--
-- PostgreSQL database dump
--

-- Dumped from database version 13.1 (Ubuntu 13.1-1.pgdg20.10+1)
-- Dumped by pg_dump version 13.1 (Ubuntu 13.1-1.pgdg20.10+1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- Name: common_date_reported; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.common_date_reported (
    type character varying(50) NOT NULL,
    id integer NOT NULL,
    date_reported character varying(255) NOT NULL,
    year_week character varying(255) NOT NULL,
    datum date NOT NULL,
    year integer NOT NULL,
    month integer NOT NULL,
    day_of_month integer NOT NULL,
    day_of_week integer NOT NULL,
    week_of_year integer NOT NULL
);


ALTER TABLE public.common_date_reported OWNER TO covid19data;

--
-- Name: common_date_reported_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.common_date_reported_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.common_date_reported_id_seq OWNER TO covid19data;

--
-- Name: common_date_reported_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.common_date_reported_id_seq OWNED BY public.common_date_reported.id;


--
-- Name: common_region; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.common_region (
    type character varying(50),
    id integer NOT NULL,
    region character varying(255) NOT NULL
);


ALTER TABLE public.common_region OWNER TO covid19data;

--
-- Name: common_region_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.common_region_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.common_region_id_seq OWNER TO covid19data;

--
-- Name: common_region_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.common_region_id_seq OWNED BY public.common_region.id;


--
-- Name: europe_country; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.europe_country (
    id integer NOT NULL,
    countries_and_territories character varying(255) NOT NULL,
    pop_data_2019 character varying(255) NOT NULL,
    geo_id character varying(255) NOT NULL,
    country_territory_code character varying(255) NOT NULL,
    continent_id integer NOT NULL
);


ALTER TABLE public.europe_country OWNER TO covid19data;

--
-- Name: europe_country_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.europe_country_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.europe_country_id_seq OWNER TO covid19data;

--
-- Name: europe_country_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.europe_country_id_seq OWNED BY public.europe_country.id;


--
-- Name: europe_data; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.europe_data (
    id integer NOT NULL,
    deaths_weekly integer NOT NULL,
    cases_weekly integer NOT NULL,
    notification_rate_per_100000_population_14days double precision NOT NULL,
    europe_country_id integer NOT NULL,
    europe_date_reported_id integer NOT NULL
);


ALTER TABLE public.europe_data OWNER TO covid19data;

--
-- Name: europe_data_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.europe_data_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.europe_data_id_seq OWNER TO covid19data;

--
-- Name: europe_data_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.europe_data_id_seq OWNED BY public.europe_data.id;


--
-- Name: europe_data_import; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.europe_data_import (
    id integer NOT NULL,
    date_rep character varying(255) NOT NULL,
    year_week character varying(255) NOT NULL,
    cases_weekly character varying(255) NOT NULL,
    deaths_weekly character varying(255) NOT NULL,
    pop_data_2019 character varying(255) NOT NULL,
    countries_and_territories character varying(255) NOT NULL,
    geo_id character varying(255) NOT NULL,
    country_territory_code character varying(255) NOT NULL,
    continent_exp character varying(255) NOT NULL,
    notification_rate_per_100000_population_14days character varying(255) NOT NULL
);


ALTER TABLE public.europe_data_import OWNER TO covid19data;

--
-- Name: europe_data_import_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.europe_data_import_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.europe_data_import_id_seq OWNER TO covid19data;

--
-- Name: europe_data_import_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.europe_data_import_id_seq OWNED BY public.europe_data_import.id;


--
-- Name: rki_country; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.rki_country (
    id integer NOT NULL,
    country_code character varying(255) NOT NULL,
    country character varying(255) NOT NULL,
    region_id integer NOT NULL
);


ALTER TABLE public.rki_country OWNER TO covid19data;

--
-- Name: rki_country_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.rki_country_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.rki_country_id_seq OWNER TO covid19data;

--
-- Name: rki_country_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.rki_country_id_seq OWNED BY public.rki_country.id;


--
-- Name: rki_global_data; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.rki_global_data (
    id integer NOT NULL,
    cases_new integer NOT NULL,
    cases_cumulative integer NOT NULL,
    deaths_new integer NOT NULL,
    deaths_cumulative integer NOT NULL,
    date_reported_id integer NOT NULL,
    country_id integer NOT NULL
);


ALTER TABLE public.rki_global_data OWNER TO covid19data;

--
-- Name: rki_global_data_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.rki_global_data_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.rki_global_data_id_seq OWNER TO covid19data;

--
-- Name: rki_global_data_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.rki_global_data_id_seq OWNED BY public.rki_global_data.id;


--
-- Name: rki_global_data_import; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.rki_global_data_import (
    id integer NOT NULL,
    date_reported character varying(255) NOT NULL,
    country_code character varying(255) NOT NULL,
    country character varying(255) NOT NULL,
    who_region character varying(255) NOT NULL,
    new_cases character varying(255) NOT NULL,
    cumulative_cases character varying(255) NOT NULL,
    new_deaths character varying(255) NOT NULL,
    cumulative_deaths character varying(255) NOT NULL
);


ALTER TABLE public.rki_global_data_import OWNER TO covid19data;

--
-- Name: rki_global_data_import_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.rki_global_data_import_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.rki_global_data_import_id_seq OWNER TO covid19data;

--
-- Name: rki_global_data_import_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.rki_global_data_import_id_seq OWNED BY public.rki_global_data_import.id;


--
-- Name: vaccination_germany_timeline; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.vaccination_germany_timeline (
    id integer NOT NULL,
    datum character varying(255) NOT NULL,
    dosen_kumulativ integer NOT NULL,
    dosen_differenz_zum_vortag integer NOT NULL,
    dosen_biontech_kumulativ integer NOT NULL,
    dosen_moderna_kumulativ integer NOT NULL,
    personen_erst_kumulativ integer NOT NULL,
    personen_voll_kumulativ integer NOT NULL,
    impf_quote_erst double precision NOT NULL,
    impf_quote_voll double precision NOT NULL,
    indikation_alter_dosen integer NOT NULL,
    indikation_beruf_dosen integer NOT NULL,
    indikation_medizinisch_dosen integer NOT NULL,
    indikation_pflegeheim_dosen integer NOT NULL,
    indikation_alter_erst integer NOT NULL,
    indikation_beruf_erst integer NOT NULL,
    indikation_medizinisch_erst integer NOT NULL,
    indikation_pflegeheim_erst integer NOT NULL,
    indikation_alter_voll integer NOT NULL,
    indikation_beruf_voll integer NOT NULL,
    indikation_medizinisch_voll integer NOT NULL,
    indikation_pflegeheim_voll integer NOT NULL
);


ALTER TABLE public.vaccination_germany_timeline OWNER TO covid19data;

--
-- Name: vaccination_germany_timeline_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.vaccination_germany_timeline_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.vaccination_germany_timeline_id_seq OWNER TO covid19data;

--
-- Name: vaccination_germany_timeline_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.vaccination_germany_timeline_id_seq OWNED BY public.vaccination_germany_timeline.id;


--
-- Name: who_country; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.who_country (
    id integer NOT NULL,
    country_code character varying(255) NOT NULL,
    country character varying(255) NOT NULL,
    region_id integer NOT NULL
);


ALTER TABLE public.who_country OWNER TO covid19data;

--
-- Name: who_country_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.who_country_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.who_country_id_seq OWNER TO covid19data;

--
-- Name: who_country_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.who_country_id_seq OWNED BY public.who_country.id;


--
-- Name: who_global_data; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.who_global_data (
    id integer NOT NULL,
    cases_new integer NOT NULL,
    cases_cumulative integer NOT NULL,
    deaths_new integer NOT NULL,
    deaths_cumulative integer NOT NULL,
    date_reported_id integer NOT NULL,
    country_id integer NOT NULL
);


ALTER TABLE public.who_global_data OWNER TO covid19data;

--
-- Name: who_global_data_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.who_global_data_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.who_global_data_id_seq OWNER TO covid19data;

--
-- Name: who_global_data_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.who_global_data_id_seq OWNED BY public.who_global_data.id;


--
-- Name: who_global_data_import; Type: TABLE; Schema: public; Owner: covid19data
--

CREATE TABLE public.who_global_data_import (
    id integer NOT NULL,
    date_reported character varying(255) NOT NULL,
    country_code character varying(255) NOT NULL,
    country character varying(255) NOT NULL,
    who_region character varying(255) NOT NULL,
    new_cases character varying(255) NOT NULL,
    cumulative_cases character varying(255) NOT NULL,
    new_deaths character varying(255) NOT NULL,
    cumulative_deaths character varying(255) NOT NULL
);


ALTER TABLE public.who_global_data_import OWNER TO covid19data;

--
-- Name: who_global_data_import_id_seq; Type: SEQUENCE; Schema: public; Owner: covid19data
--

CREATE SEQUENCE public.who_global_data_import_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.who_global_data_import_id_seq OWNER TO covid19data;

--
-- Name: who_global_data_import_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: covid19data
--

ALTER SEQUENCE public.who_global_data_import_id_seq OWNED BY public.who_global_data_import.id;


--
-- Name: common_date_reported id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.common_date_reported ALTER COLUMN id SET DEFAULT nextval('public.common_date_reported_id_seq'::regclass);


--
-- Name: common_region id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.common_region ALTER COLUMN id SET DEFAULT nextval('public.common_region_id_seq'::regclass);


--
-- Name: europe_country id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_country ALTER COLUMN id SET DEFAULT nextval('public.europe_country_id_seq'::regclass);


--
-- Name: europe_data id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_data ALTER COLUMN id SET DEFAULT nextval('public.europe_data_id_seq'::regclass);


--
-- Name: europe_data_import id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_data_import ALTER COLUMN id SET DEFAULT nextval('public.europe_data_import_id_seq'::regclass);


--
-- Name: rki_country id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_country ALTER COLUMN id SET DEFAULT nextval('public.rki_country_id_seq'::regclass);


--
-- Name: rki_global_data id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_global_data ALTER COLUMN id SET DEFAULT nextval('public.rki_global_data_id_seq'::regclass);


--
-- Name: rki_global_data_import id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_global_data_import ALTER COLUMN id SET DEFAULT nextval('public.rki_global_data_import_id_seq'::regclass);


--
-- Name: vaccination_germany_timeline id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.vaccination_germany_timeline ALTER COLUMN id SET DEFAULT nextval('public.vaccination_germany_timeline_id_seq'::regclass);


--
-- Name: who_country id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_country ALTER COLUMN id SET DEFAULT nextval('public.who_country_id_seq'::regclass);


--
-- Name: who_global_data id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_global_data ALTER COLUMN id SET DEFAULT nextval('public.who_global_data_id_seq'::regclass);


--
-- Name: who_global_data_import id; Type: DEFAULT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_global_data_import ALTER COLUMN id SET DEFAULT nextval('public.who_global_data_import_id_seq'::regclass);


--
-- Data for Name: common_date_reported; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.common_date_reported VALUES ('who_date_reported', 1, '2021-02-05', '2021-05', '2021-02-05', 2021, 2, 5, 5, 5);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 2, '2021-02-04', '2021-05', '2021-02-04', 2021, 2, 4, 4, 5);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 3, '2021-02-03', '2021-05', '2021-02-03', 2021, 2, 3, 3, 5);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 4, '2021-02-02', '2021-05', '2021-02-02', 2021, 2, 2, 2, 5);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 5, '2021-02-01', '2021-05', '2021-02-01', 2021, 2, 1, 1, 5);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 6, '2021-01-31', '2021-04', '2021-01-31', 2021, 1, 31, 7, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 7, '2021-01-30', '2021-04', '2021-01-30', 2021, 1, 30, 6, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 8, '2021-01-29', '2021-04', '2021-01-29', 2021, 1, 29, 5, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 9, '2021-01-28', '2021-04', '2021-01-28', 2021, 1, 28, 4, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 10, '2021-01-27', '2021-04', '2021-01-27', 2021, 1, 27, 3, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 11, '2021-01-26', '2021-04', '2021-01-26', 2021, 1, 26, 2, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 12, '2021-01-25', '2021-04', '2021-01-25', 2021, 1, 25, 1, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 13, '2021-01-24', '2021-03', '2021-01-24', 2021, 1, 24, 7, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 14, '2021-01-23', '2021-03', '2021-01-23', 2021, 1, 23, 6, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 15, '2021-01-22', '2021-03', '2021-01-22', 2021, 1, 22, 5, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 16, '2021-01-21', '2021-03', '2021-01-21', 2021, 1, 21, 4, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 17, '2021-01-20', '2021-03', '2021-01-20', 2021, 1, 20, 3, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 18, '2021-01-19', '2021-03', '2021-01-19', 2021, 1, 19, 2, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 19, '2021-01-18', '2021-03', '2021-01-18', 2021, 1, 18, 1, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 20, '2021-01-17', '2021-02', '2021-01-17', 2021, 1, 17, 7, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 21, '2021-01-16', '2021-02', '2021-01-16', 2021, 1, 16, 6, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 22, '2021-01-15', '2021-02', '2021-01-15', 2021, 1, 15, 5, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 23, '2021-01-14', '2021-02', '2021-01-14', 2021, 1, 14, 4, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 24, '2021-01-13', '2021-02', '2021-01-13', 2021, 1, 13, 3, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 25, '2021-01-12', '2021-02', '2021-01-12', 2021, 1, 12, 2, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 26, '2021-01-11', '2021-02', '2021-01-11', 2021, 1, 11, 1, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 27, '2021-01-10', '2021-01', '2021-01-10', 2021, 1, 10, 7, 1);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 28, '2021-01-09', '2021-01', '2021-01-09', 2021, 1, 9, 6, 1);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 29, '2021-01-08', '2021-01', '2021-01-08', 2021, 1, 8, 5, 1);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 30, '2021-01-07', '2021-01', '2021-01-07', 2021, 1, 7, 4, 1);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 31, '2021-01-06', '2021-01', '2021-01-06', 2021, 1, 6, 3, 1);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 32, '2021-01-05', '2021-01', '2021-01-05', 2021, 1, 5, 2, 1);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 33, '2021-01-04', '2021-01', '2021-01-04', 2021, 1, 4, 1, 1);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 34, '2021-01-03', '2020-53', '2021-01-03', 2021, 1, 3, 7, 53);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 35, '2021-01-02', '2020-53', '2021-01-02', 2021, 1, 2, 6, 53);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 36, '2021-01-01', '2020-53', '2021-01-01', 2021, 1, 1, 5, 53);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 37, '2020-12-31', '2020-53', '2020-12-31', 2020, 12, 31, 4, 53);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 38, '2020-12-30', '2020-53', '2020-12-30', 2020, 12, 30, 3, 53);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 39, '2020-12-29', '2020-53', '2020-12-29', 2020, 12, 29, 2, 53);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 40, '2020-12-28', '2020-53', '2020-12-28', 2020, 12, 28, 1, 53);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 41, '2020-12-27', '2020-52', '2020-12-27', 2020, 12, 27, 7, 52);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 42, '2020-12-26', '2020-52', '2020-12-26', 2020, 12, 26, 6, 52);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 43, '2020-12-25', '2020-52', '2020-12-25', 2020, 12, 25, 5, 52);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 44, '2020-12-24', '2020-52', '2020-12-24', 2020, 12, 24, 4, 52);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 45, '2020-12-23', '2020-52', '2020-12-23', 2020, 12, 23, 3, 52);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 46, '2020-12-22', '2020-52', '2020-12-22', 2020, 12, 22, 2, 52);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 47, '2020-12-21', '2020-52', '2020-12-21', 2020, 12, 21, 1, 52);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 48, '2020-12-20', '2020-51', '2020-12-20', 2020, 12, 20, 7, 51);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 49, '2020-12-19', '2020-51', '2020-12-19', 2020, 12, 19, 6, 51);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 50, '2020-12-18', '2020-51', '2020-12-18', 2020, 12, 18, 5, 51);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 51, '2020-12-17', '2020-51', '2020-12-17', 2020, 12, 17, 4, 51);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 52, '2020-12-16', '2020-51', '2020-12-16', 2020, 12, 16, 3, 51);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 53, '2020-12-15', '2020-51', '2020-12-15', 2020, 12, 15, 2, 51);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 54, '2020-12-14', '2020-51', '2020-12-14', 2020, 12, 14, 1, 51);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 55, '2020-12-13', '2020-50', '2020-12-13', 2020, 12, 13, 7, 50);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 56, '2020-12-12', '2020-50', '2020-12-12', 2020, 12, 12, 6, 50);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 57, '2020-12-11', '2020-50', '2020-12-11', 2020, 12, 11, 5, 50);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 58, '2020-12-10', '2020-50', '2020-12-10', 2020, 12, 10, 4, 50);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 59, '2020-12-09', '2020-50', '2020-12-09', 2020, 12, 9, 3, 50);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 60, '2020-12-08', '2020-50', '2020-12-08', 2020, 12, 8, 2, 50);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 61, '2020-12-07', '2020-50', '2020-12-07', 2020, 12, 7, 1, 50);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 62, '2020-12-06', '2020-49', '2020-12-06', 2020, 12, 6, 7, 49);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 63, '2020-12-05', '2020-49', '2020-12-05', 2020, 12, 5, 6, 49);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 64, '2020-12-04', '2020-49', '2020-12-04', 2020, 12, 4, 5, 49);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 65, '2020-12-03', '2020-49', '2020-12-03', 2020, 12, 3, 4, 49);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 66, '2020-12-02', '2020-49', '2020-12-02', 2020, 12, 2, 3, 49);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 67, '2020-12-01', '2020-49', '2020-12-01', 2020, 12, 1, 2, 49);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 68, '2020-11-30', '2020-49', '2020-11-30', 2020, 11, 30, 1, 49);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 69, '2020-11-29', '2020-48', '2020-11-29', 2020, 11, 29, 7, 48);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 70, '2020-11-28', '2020-48', '2020-11-28', 2020, 11, 28, 6, 48);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 71, '2020-11-27', '2020-48', '2020-11-27', 2020, 11, 27, 5, 48);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 72, '2020-11-26', '2020-48', '2020-11-26', 2020, 11, 26, 4, 48);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 73, '2020-11-25', '2020-48', '2020-11-25', 2020, 11, 25, 3, 48);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 74, '2020-11-24', '2020-48', '2020-11-24', 2020, 11, 24, 2, 48);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 75, '2020-11-23', '2020-48', '2020-11-23', 2020, 11, 23, 1, 48);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 76, '2020-11-22', '2020-47', '2020-11-22', 2020, 11, 22, 7, 47);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 77, '2020-11-21', '2020-47', '2020-11-21', 2020, 11, 21, 6, 47);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 78, '2020-11-20', '2020-47', '2020-11-20', 2020, 11, 20, 5, 47);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 79, '2020-11-19', '2020-47', '2020-11-19', 2020, 11, 19, 4, 47);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 80, '2020-11-18', '2020-47', '2020-11-18', 2020, 11, 18, 3, 47);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 81, '2020-11-17', '2020-47', '2020-11-17', 2020, 11, 17, 2, 47);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 82, '2020-11-16', '2020-47', '2020-11-16', 2020, 11, 16, 1, 47);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 83, '2020-11-15', '2020-46', '2020-11-15', 2020, 11, 15, 7, 46);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 84, '2020-11-14', '2020-46', '2020-11-14', 2020, 11, 14, 6, 46);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 85, '2020-11-13', '2020-46', '2020-11-13', 2020, 11, 13, 5, 46);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 86, '2020-11-12', '2020-46', '2020-11-12', 2020, 11, 12, 4, 46);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 87, '2020-11-11', '2020-46', '2020-11-11', 2020, 11, 11, 3, 46);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 88, '2020-11-10', '2020-46', '2020-11-10', 2020, 11, 10, 2, 46);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 89, '2020-11-09', '2020-46', '2020-11-09', 2020, 11, 9, 1, 46);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 90, '2020-11-08', '2020-45', '2020-11-08', 2020, 11, 8, 7, 45);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 91, '2020-11-07', '2020-45', '2020-11-07', 2020, 11, 7, 6, 45);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 92, '2020-11-06', '2020-45', '2020-11-06', 2020, 11, 6, 5, 45);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 93, '2020-11-05', '2020-45', '2020-11-05', 2020, 11, 5, 4, 45);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 94, '2020-11-04', '2020-45', '2020-11-04', 2020, 11, 4, 3, 45);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 95, '2020-11-03', '2020-45', '2020-11-03', 2020, 11, 3, 2, 45);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 96, '2020-11-02', '2020-45', '2020-11-02', 2020, 11, 2, 1, 45);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 97, '2020-11-01', '2020-44', '2020-11-01', 2020, 11, 1, 7, 44);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 98, '2020-10-31', '2020-44', '2020-10-31', 2020, 10, 31, 6, 44);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 99, '2020-10-30', '2020-44', '2020-10-30', 2020, 10, 30, 5, 44);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 100, '2020-10-29', '2020-44', '2020-10-29', 2020, 10, 29, 4, 44);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 101, '2020-10-28', '2020-44', '2020-10-28', 2020, 10, 28, 3, 44);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 102, '2020-10-27', '2020-44', '2020-10-27', 2020, 10, 27, 2, 44);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 103, '2020-10-26', '2020-44', '2020-10-26', 2020, 10, 26, 1, 44);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 104, '2020-10-25', '2020-43', '2020-10-25', 2020, 10, 25, 7, 43);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 105, '2020-10-24', '2020-43', '2020-10-24', 2020, 10, 24, 6, 43);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 106, '2020-10-23', '2020-43', '2020-10-23', 2020, 10, 23, 5, 43);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 107, '2020-10-22', '2020-43', '2020-10-22', 2020, 10, 22, 4, 43);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 108, '2020-10-21', '2020-43', '2020-10-21', 2020, 10, 21, 3, 43);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 109, '2020-10-20', '2020-43', '2020-10-20', 2020, 10, 20, 2, 43);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 110, '2020-10-19', '2020-43', '2020-10-19', 2020, 10, 19, 1, 43);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 111, '2020-10-18', '2020-42', '2020-10-18', 2020, 10, 18, 7, 42);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 112, '2020-10-17', '2020-42', '2020-10-17', 2020, 10, 17, 6, 42);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 113, '2020-10-16', '2020-42', '2020-10-16', 2020, 10, 16, 5, 42);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 114, '2020-10-15', '2020-42', '2020-10-15', 2020, 10, 15, 4, 42);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 115, '2020-10-14', '2020-42', '2020-10-14', 2020, 10, 14, 3, 42);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 116, '2020-10-13', '2020-42', '2020-10-13', 2020, 10, 13, 2, 42);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 117, '2020-10-12', '2020-42', '2020-10-12', 2020, 10, 12, 1, 42);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 118, '2020-10-11', '2020-41', '2020-10-11', 2020, 10, 11, 7, 41);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 119, '2020-10-10', '2020-41', '2020-10-10', 2020, 10, 10, 6, 41);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 120, '2020-10-09', '2020-41', '2020-10-09', 2020, 10, 9, 5, 41);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 121, '2020-10-08', '2020-41', '2020-10-08', 2020, 10, 8, 4, 41);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 122, '2020-10-07', '2020-41', '2020-10-07', 2020, 10, 7, 3, 41);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 123, '2020-10-06', '2020-41', '2020-10-06', 2020, 10, 6, 2, 41);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 124, '2020-10-05', '2020-41', '2020-10-05', 2020, 10, 5, 1, 41);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 125, '2020-10-04', '2020-40', '2020-10-04', 2020, 10, 4, 7, 40);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 126, '2020-10-03', '2020-40', '2020-10-03', 2020, 10, 3, 6, 40);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 127, '2020-10-02', '2020-40', '2020-10-02', 2020, 10, 2, 5, 40);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 128, '2020-10-01', '2020-40', '2020-10-01', 2020, 10, 1, 4, 40);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 129, '2020-09-30', '2020-40', '2020-09-30', 2020, 9, 30, 3, 40);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 130, '2020-09-29', '2020-40', '2020-09-29', 2020, 9, 29, 2, 40);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 131, '2020-09-28', '2020-40', '2020-09-28', 2020, 9, 28, 1, 40);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 132, '2020-09-27', '2020-39', '2020-09-27', 2020, 9, 27, 7, 39);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 133, '2020-09-26', '2020-39', '2020-09-26', 2020, 9, 26, 6, 39);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 134, '2020-09-25', '2020-39', '2020-09-25', 2020, 9, 25, 5, 39);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 135, '2020-09-24', '2020-39', '2020-09-24', 2020, 9, 24, 4, 39);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 136, '2020-09-23', '2020-39', '2020-09-23', 2020, 9, 23, 3, 39);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 137, '2020-09-22', '2020-39', '2020-09-22', 2020, 9, 22, 2, 39);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 138, '2020-09-21', '2020-39', '2020-09-21', 2020, 9, 21, 1, 39);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 139, '2020-09-20', '2020-38', '2020-09-20', 2020, 9, 20, 7, 38);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 140, '2020-09-19', '2020-38', '2020-09-19', 2020, 9, 19, 6, 38);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 141, '2020-09-18', '2020-38', '2020-09-18', 2020, 9, 18, 5, 38);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 142, '2020-09-17', '2020-38', '2020-09-17', 2020, 9, 17, 4, 38);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 143, '2020-09-16', '2020-38', '2020-09-16', 2020, 9, 16, 3, 38);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 144, '2020-09-15', '2020-38', '2020-09-15', 2020, 9, 15, 2, 38);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 145, '2020-09-14', '2020-38', '2020-09-14', 2020, 9, 14, 1, 38);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 146, '2020-09-13', '2020-37', '2020-09-13', 2020, 9, 13, 7, 37);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 147, '2020-09-12', '2020-37', '2020-09-12', 2020, 9, 12, 6, 37);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 148, '2020-09-11', '2020-37', '2020-09-11', 2020, 9, 11, 5, 37);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 149, '2020-09-10', '2020-37', '2020-09-10', 2020, 9, 10, 4, 37);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 150, '2020-09-09', '2020-37', '2020-09-09', 2020, 9, 9, 3, 37);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 151, '2020-09-08', '2020-37', '2020-09-08', 2020, 9, 8, 2, 37);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 152, '2020-09-07', '2020-37', '2020-09-07', 2020, 9, 7, 1, 37);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 153, '2020-09-06', '2020-36', '2020-09-06', 2020, 9, 6, 7, 36);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 154, '2020-09-05', '2020-36', '2020-09-05', 2020, 9, 5, 6, 36);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 155, '2020-09-04', '2020-36', '2020-09-04', 2020, 9, 4, 5, 36);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 156, '2020-09-03', '2020-36', '2020-09-03', 2020, 9, 3, 4, 36);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 157, '2020-09-02', '2020-36', '2020-09-02', 2020, 9, 2, 3, 36);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 158, '2020-09-01', '2020-36', '2020-09-01', 2020, 9, 1, 2, 36);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 159, '2020-08-31', '2020-36', '2020-08-31', 2020, 8, 31, 1, 36);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 160, '2020-08-30', '2020-35', '2020-08-30', 2020, 8, 30, 7, 35);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 161, '2020-08-29', '2020-35', '2020-08-29', 2020, 8, 29, 6, 35);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 162, '2020-08-28', '2020-35', '2020-08-28', 2020, 8, 28, 5, 35);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 163, '2020-08-27', '2020-35', '2020-08-27', 2020, 8, 27, 4, 35);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 164, '2020-08-26', '2020-35', '2020-08-26', 2020, 8, 26, 3, 35);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 165, '2020-08-25', '2020-35', '2020-08-25', 2020, 8, 25, 2, 35);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 166, '2020-08-24', '2020-35', '2020-08-24', 2020, 8, 24, 1, 35);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 167, '2020-08-23', '2020-34', '2020-08-23', 2020, 8, 23, 7, 34);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 168, '2020-08-22', '2020-34', '2020-08-22', 2020, 8, 22, 6, 34);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 169, '2020-08-21', '2020-34', '2020-08-21', 2020, 8, 21, 5, 34);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 170, '2020-08-20', '2020-34', '2020-08-20', 2020, 8, 20, 4, 34);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 171, '2020-08-19', '2020-34', '2020-08-19', 2020, 8, 19, 3, 34);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 172, '2020-08-18', '2020-34', '2020-08-18', 2020, 8, 18, 2, 34);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 173, '2020-08-17', '2020-34', '2020-08-17', 2020, 8, 17, 1, 34);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 174, '2020-08-16', '2020-33', '2020-08-16', 2020, 8, 16, 7, 33);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 175, '2020-08-15', '2020-33', '2020-08-15', 2020, 8, 15, 6, 33);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 176, '2020-08-14', '2020-33', '2020-08-14', 2020, 8, 14, 5, 33);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 177, '2020-08-13', '2020-33', '2020-08-13', 2020, 8, 13, 4, 33);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 178, '2020-08-12', '2020-33', '2020-08-12', 2020, 8, 12, 3, 33);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 179, '2020-08-11', '2020-33', '2020-08-11', 2020, 8, 11, 2, 33);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 180, '2020-08-10', '2020-33', '2020-08-10', 2020, 8, 10, 1, 33);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 181, '2020-08-09', '2020-32', '2020-08-09', 2020, 8, 9, 7, 32);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 182, '2020-08-08', '2020-32', '2020-08-08', 2020, 8, 8, 6, 32);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 183, '2020-08-07', '2020-32', '2020-08-07', 2020, 8, 7, 5, 32);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 184, '2020-08-06', '2020-32', '2020-08-06', 2020, 8, 6, 4, 32);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 185, '2020-08-05', '2020-32', '2020-08-05', 2020, 8, 5, 3, 32);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 186, '2020-08-04', '2020-32', '2020-08-04', 2020, 8, 4, 2, 32);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 187, '2020-08-03', '2020-32', '2020-08-03', 2020, 8, 3, 1, 32);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 188, '2020-08-02', '2020-31', '2020-08-02', 2020, 8, 2, 7, 31);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 189, '2020-08-01', '2020-31', '2020-08-01', 2020, 8, 1, 6, 31);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 190, '2020-07-31', '2020-31', '2020-07-31', 2020, 7, 31, 5, 31);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 191, '2020-07-30', '2020-31', '2020-07-30', 2020, 7, 30, 4, 31);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 192, '2020-07-29', '2020-31', '2020-07-29', 2020, 7, 29, 3, 31);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 193, '2020-07-28', '2020-31', '2020-07-28', 2020, 7, 28, 2, 31);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 194, '2020-07-27', '2020-31', '2020-07-27', 2020, 7, 27, 1, 31);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 195, '2020-07-26', '2020-30', '2020-07-26', 2020, 7, 26, 7, 30);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 196, '2020-07-25', '2020-30', '2020-07-25', 2020, 7, 25, 6, 30);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 197, '2020-07-24', '2020-30', '2020-07-24', 2020, 7, 24, 5, 30);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 198, '2020-07-23', '2020-30', '2020-07-23', 2020, 7, 23, 4, 30);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 199, '2020-07-22', '2020-30', '2020-07-22', 2020, 7, 22, 3, 30);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 200, '2020-07-21', '2020-30', '2020-07-21', 2020, 7, 21, 2, 30);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 201, '2020-07-20', '2020-30', '2020-07-20', 2020, 7, 20, 1, 30);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 202, '2020-07-19', '2020-29', '2020-07-19', 2020, 7, 19, 7, 29);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 203, '2020-07-18', '2020-29', '2020-07-18', 2020, 7, 18, 6, 29);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 204, '2020-07-17', '2020-29', '2020-07-17', 2020, 7, 17, 5, 29);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 205, '2020-07-16', '2020-29', '2020-07-16', 2020, 7, 16, 4, 29);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 206, '2020-07-15', '2020-29', '2020-07-15', 2020, 7, 15, 3, 29);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 207, '2020-07-14', '2020-29', '2020-07-14', 2020, 7, 14, 2, 29);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 208, '2020-07-13', '2020-29', '2020-07-13', 2020, 7, 13, 1, 29);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 209, '2020-07-12', '2020-28', '2020-07-12', 2020, 7, 12, 7, 28);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 210, '2020-07-11', '2020-28', '2020-07-11', 2020, 7, 11, 6, 28);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 211, '2020-07-10', '2020-28', '2020-07-10', 2020, 7, 10, 5, 28);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 212, '2020-07-09', '2020-28', '2020-07-09', 2020, 7, 9, 4, 28);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 213, '2020-07-08', '2020-28', '2020-07-08', 2020, 7, 8, 3, 28);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 214, '2020-07-07', '2020-28', '2020-07-07', 2020, 7, 7, 2, 28);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 215, '2020-07-06', '2020-28', '2020-07-06', 2020, 7, 6, 1, 28);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 216, '2020-07-05', '2020-27', '2020-07-05', 2020, 7, 5, 7, 27);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 217, '2020-07-04', '2020-27', '2020-07-04', 2020, 7, 4, 6, 27);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 218, '2020-07-03', '2020-27', '2020-07-03', 2020, 7, 3, 5, 27);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 219, '2020-07-02', '2020-27', '2020-07-02', 2020, 7, 2, 4, 27);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 220, '2020-07-01', '2020-27', '2020-07-01', 2020, 7, 1, 3, 27);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 221, '2020-06-30', '2020-27', '2020-06-30', 2020, 6, 30, 2, 27);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 222, '2020-06-29', '2020-27', '2020-06-29', 2020, 6, 29, 1, 27);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 223, '2020-06-28', '2020-26', '2020-06-28', 2020, 6, 28, 7, 26);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 224, '2020-06-27', '2020-26', '2020-06-27', 2020, 6, 27, 6, 26);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 225, '2020-06-26', '2020-26', '2020-06-26', 2020, 6, 26, 5, 26);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 226, '2020-06-25', '2020-26', '2020-06-25', 2020, 6, 25, 4, 26);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 227, '2020-06-24', '2020-26', '2020-06-24', 2020, 6, 24, 3, 26);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 228, '2020-06-23', '2020-26', '2020-06-23', 2020, 6, 23, 2, 26);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 229, '2020-06-22', '2020-26', '2020-06-22', 2020, 6, 22, 1, 26);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 230, '2020-06-21', '2020-25', '2020-06-21', 2020, 6, 21, 7, 25);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 231, '2020-06-20', '2020-25', '2020-06-20', 2020, 6, 20, 6, 25);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 232, '2020-06-19', '2020-25', '2020-06-19', 2020, 6, 19, 5, 25);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 233, '2020-06-18', '2020-25', '2020-06-18', 2020, 6, 18, 4, 25);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 234, '2020-06-17', '2020-25', '2020-06-17', 2020, 6, 17, 3, 25);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 235, '2020-06-16', '2020-25', '2020-06-16', 2020, 6, 16, 2, 25);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 236, '2020-06-15', '2020-25', '2020-06-15', 2020, 6, 15, 1, 25);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 237, '2020-06-14', '2020-24', '2020-06-14', 2020, 6, 14, 7, 24);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 238, '2020-06-13', '2020-24', '2020-06-13', 2020, 6, 13, 6, 24);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 239, '2020-06-12', '2020-24', '2020-06-12', 2020, 6, 12, 5, 24);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 240, '2020-06-11', '2020-24', '2020-06-11', 2020, 6, 11, 4, 24);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 241, '2020-06-10', '2020-24', '2020-06-10', 2020, 6, 10, 3, 24);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 242, '2020-06-09', '2020-24', '2020-06-09', 2020, 6, 9, 2, 24);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 243, '2020-06-08', '2020-24', '2020-06-08', 2020, 6, 8, 1, 24);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 244, '2020-06-07', '2020-23', '2020-06-07', 2020, 6, 7, 7, 23);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 245, '2020-06-06', '2020-23', '2020-06-06', 2020, 6, 6, 6, 23);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 246, '2020-06-05', '2020-23', '2020-06-05', 2020, 6, 5, 5, 23);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 247, '2020-06-04', '2020-23', '2020-06-04', 2020, 6, 4, 4, 23);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 248, '2020-06-03', '2020-23', '2020-06-03', 2020, 6, 3, 3, 23);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 249, '2020-06-02', '2020-23', '2020-06-02', 2020, 6, 2, 2, 23);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 250, '2020-06-01', '2020-23', '2020-06-01', 2020, 6, 1, 1, 23);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 251, '2020-05-31', '2020-22', '2020-05-31', 2020, 5, 31, 7, 22);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 252, '2020-05-30', '2020-22', '2020-05-30', 2020, 5, 30, 6, 22);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 253, '2020-05-29', '2020-22', '2020-05-29', 2020, 5, 29, 5, 22);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 254, '2020-05-28', '2020-22', '2020-05-28', 2020, 5, 28, 4, 22);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 255, '2020-05-27', '2020-22', '2020-05-27', 2020, 5, 27, 3, 22);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 256, '2020-05-26', '2020-22', '2020-05-26', 2020, 5, 26, 2, 22);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 257, '2020-05-25', '2020-22', '2020-05-25', 2020, 5, 25, 1, 22);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 258, '2020-05-24', '2020-21', '2020-05-24', 2020, 5, 24, 7, 21);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 259, '2020-05-23', '2020-21', '2020-05-23', 2020, 5, 23, 6, 21);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 260, '2020-05-22', '2020-21', '2020-05-22', 2020, 5, 22, 5, 21);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 261, '2020-05-21', '2020-21', '2020-05-21', 2020, 5, 21, 4, 21);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 262, '2020-05-20', '2020-21', '2020-05-20', 2020, 5, 20, 3, 21);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 263, '2020-05-19', '2020-21', '2020-05-19', 2020, 5, 19, 2, 21);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 264, '2020-05-18', '2020-21', '2020-05-18', 2020, 5, 18, 1, 21);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 265, '2020-05-17', '2020-20', '2020-05-17', 2020, 5, 17, 7, 20);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 266, '2020-05-16', '2020-20', '2020-05-16', 2020, 5, 16, 6, 20);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 267, '2020-05-15', '2020-20', '2020-05-15', 2020, 5, 15, 5, 20);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 268, '2020-05-14', '2020-20', '2020-05-14', 2020, 5, 14, 4, 20);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 269, '2020-05-13', '2020-20', '2020-05-13', 2020, 5, 13, 3, 20);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 270, '2020-05-12', '2020-20', '2020-05-12', 2020, 5, 12, 2, 20);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 271, '2020-05-11', '2020-20', '2020-05-11', 2020, 5, 11, 1, 20);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 272, '2020-05-10', '2020-19', '2020-05-10', 2020, 5, 10, 7, 19);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 273, '2020-05-09', '2020-19', '2020-05-09', 2020, 5, 9, 6, 19);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 274, '2020-05-08', '2020-19', '2020-05-08', 2020, 5, 8, 5, 19);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 275, '2020-05-07', '2020-19', '2020-05-07', 2020, 5, 7, 4, 19);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 276, '2020-05-06', '2020-19', '2020-05-06', 2020, 5, 6, 3, 19);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 277, '2020-05-05', '2020-19', '2020-05-05', 2020, 5, 5, 2, 19);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 278, '2020-05-04', '2020-19', '2020-05-04', 2020, 5, 4, 1, 19);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 279, '2020-05-03', '2020-18', '2020-05-03', 2020, 5, 3, 7, 18);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 280, '2020-05-02', '2020-18', '2020-05-02', 2020, 5, 2, 6, 18);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 281, '2020-05-01', '2020-18', '2020-05-01', 2020, 5, 1, 5, 18);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 282, '2020-04-30', '2020-18', '2020-04-30', 2020, 4, 30, 4, 18);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 283, '2020-04-29', '2020-18', '2020-04-29', 2020, 4, 29, 3, 18);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 284, '2020-04-28', '2020-18', '2020-04-28', 2020, 4, 28, 2, 18);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 285, '2020-04-27', '2020-18', '2020-04-27', 2020, 4, 27, 1, 18);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 286, '2020-04-26', '2020-17', '2020-04-26', 2020, 4, 26, 7, 17);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 287, '2020-04-25', '2020-17', '2020-04-25', 2020, 4, 25, 6, 17);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 288, '2020-04-24', '2020-17', '2020-04-24', 2020, 4, 24, 5, 17);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 289, '2020-04-23', '2020-17', '2020-04-23', 2020, 4, 23, 4, 17);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 290, '2020-04-22', '2020-17', '2020-04-22', 2020, 4, 22, 3, 17);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 291, '2020-04-21', '2020-17', '2020-04-21', 2020, 4, 21, 2, 17);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 292, '2020-04-20', '2020-17', '2020-04-20', 2020, 4, 20, 1, 17);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 293, '2020-04-19', '2020-16', '2020-04-19', 2020, 4, 19, 7, 16);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 294, '2020-04-18', '2020-16', '2020-04-18', 2020, 4, 18, 6, 16);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 295, '2020-04-17', '2020-16', '2020-04-17', 2020, 4, 17, 5, 16);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 296, '2020-04-16', '2020-16', '2020-04-16', 2020, 4, 16, 4, 16);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 297, '2020-04-15', '2020-16', '2020-04-15', 2020, 4, 15, 3, 16);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 298, '2020-04-14', '2020-16', '2020-04-14', 2020, 4, 14, 2, 16);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 299, '2020-04-13', '2020-16', '2020-04-13', 2020, 4, 13, 1, 16);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 300, '2020-04-12', '2020-15', '2020-04-12', 2020, 4, 12, 7, 15);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 301, '2020-04-11', '2020-15', '2020-04-11', 2020, 4, 11, 6, 15);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 302, '2020-04-10', '2020-15', '2020-04-10', 2020, 4, 10, 5, 15);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 303, '2020-04-09', '2020-15', '2020-04-09', 2020, 4, 9, 4, 15);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 304, '2020-04-08', '2020-15', '2020-04-08', 2020, 4, 8, 3, 15);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 305, '2020-04-07', '2020-15', '2020-04-07', 2020, 4, 7, 2, 15);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 306, '2020-04-06', '2020-15', '2020-04-06', 2020, 4, 6, 1, 15);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 307, '2020-04-05', '2020-14', '2020-04-05', 2020, 4, 5, 7, 14);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 308, '2020-04-04', '2020-14', '2020-04-04', 2020, 4, 4, 6, 14);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 309, '2020-04-03', '2020-14', '2020-04-03', 2020, 4, 3, 5, 14);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 310, '2020-04-02', '2020-14', '2020-04-02', 2020, 4, 2, 4, 14);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 311, '2020-04-01', '2020-14', '2020-04-01', 2020, 4, 1, 3, 14);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 312, '2020-03-31', '2020-14', '2020-03-31', 2020, 3, 31, 2, 14);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 313, '2020-03-30', '2020-14', '2020-03-30', 2020, 3, 30, 1, 14);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 314, '2020-03-29', '2020-13', '2020-03-29', 2020, 3, 29, 7, 13);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 315, '2020-03-28', '2020-13', '2020-03-28', 2020, 3, 28, 6, 13);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 316, '2020-03-27', '2020-13', '2020-03-27', 2020, 3, 27, 5, 13);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 317, '2020-03-26', '2020-13', '2020-03-26', 2020, 3, 26, 4, 13);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 318, '2020-03-25', '2020-13', '2020-03-25', 2020, 3, 25, 3, 13);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 319, '2020-03-24', '2020-13', '2020-03-24', 2020, 3, 24, 2, 13);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 320, '2020-03-23', '2020-13', '2020-03-23', 2020, 3, 23, 1, 13);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 321, '2020-03-22', '2020-12', '2020-03-22', 2020, 3, 22, 7, 12);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 322, '2020-03-21', '2020-12', '2020-03-21', 2020, 3, 21, 6, 12);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 323, '2020-03-20', '2020-12', '2020-03-20', 2020, 3, 20, 5, 12);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 324, '2020-03-19', '2020-12', '2020-03-19', 2020, 3, 19, 4, 12);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 325, '2020-03-18', '2020-12', '2020-03-18', 2020, 3, 18, 3, 12);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 326, '2020-03-17', '2020-12', '2020-03-17', 2020, 3, 17, 2, 12);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 327, '2020-03-16', '2020-12', '2020-03-16', 2020, 3, 16, 1, 12);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 328, '2020-03-15', '2020-11', '2020-03-15', 2020, 3, 15, 7, 11);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 329, '2020-03-14', '2020-11', '2020-03-14', 2020, 3, 14, 6, 11);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 330, '2020-03-13', '2020-11', '2020-03-13', 2020, 3, 13, 5, 11);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 331, '2020-03-12', '2020-11', '2020-03-12', 2020, 3, 12, 4, 11);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 332, '2020-03-11', '2020-11', '2020-03-11', 2020, 3, 11, 3, 11);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 333, '2020-03-10', '2020-11', '2020-03-10', 2020, 3, 10, 2, 11);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 334, '2020-03-09', '2020-11', '2020-03-09', 2020, 3, 9, 1, 11);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 335, '2020-03-08', '2020-10', '2020-03-08', 2020, 3, 8, 7, 10);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 336, '2020-03-07', '2020-10', '2020-03-07', 2020, 3, 7, 6, 10);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 337, '2020-03-06', '2020-10', '2020-03-06', 2020, 3, 6, 5, 10);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 338, '2020-03-05', '2020-10', '2020-03-05', 2020, 3, 5, 4, 10);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 339, '2020-03-04', '2020-10', '2020-03-04', 2020, 3, 4, 3, 10);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 340, '2020-03-03', '2020-10', '2020-03-03', 2020, 3, 3, 2, 10);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 341, '2020-03-02', '2020-10', '2020-03-02', 2020, 3, 2, 1, 10);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 342, '2020-03-01', '2020-09', '2020-03-01', 2020, 3, 1, 7, 9);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 343, '2020-02-29', '2020-09', '2020-02-29', 2020, 2, 29, 6, 9);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 344, '2020-02-28', '2020-09', '2020-02-28', 2020, 2, 28, 5, 9);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 345, '2020-02-27', '2020-09', '2020-02-27', 2020, 2, 27, 4, 9);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 346, '2020-02-26', '2020-09', '2020-02-26', 2020, 2, 26, 3, 9);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 347, '2020-02-25', '2020-09', '2020-02-25', 2020, 2, 25, 2, 9);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 348, '2020-02-24', '2020-09', '2020-02-24', 2020, 2, 24, 1, 9);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 349, '2020-02-23', '2020-08', '2020-02-23', 2020, 2, 23, 7, 8);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 350, '2020-02-22', '2020-08', '2020-02-22', 2020, 2, 22, 6, 8);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 351, '2020-02-21', '2020-08', '2020-02-21', 2020, 2, 21, 5, 8);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 352, '2020-02-20', '2020-08', '2020-02-20', 2020, 2, 20, 4, 8);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 353, '2020-02-19', '2020-08', '2020-02-19', 2020, 2, 19, 3, 8);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 354, '2020-02-18', '2020-08', '2020-02-18', 2020, 2, 18, 2, 8);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 355, '2020-02-17', '2020-08', '2020-02-17', 2020, 2, 17, 1, 8);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 356, '2020-02-16', '2020-07', '2020-02-16', 2020, 2, 16, 7, 7);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 357, '2020-02-15', '2020-07', '2020-02-15', 2020, 2, 15, 6, 7);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 358, '2020-02-14', '2020-07', '2020-02-14', 2020, 2, 14, 5, 7);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 359, '2020-02-13', '2020-07', '2020-02-13', 2020, 2, 13, 4, 7);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 360, '2020-02-12', '2020-07', '2020-02-12', 2020, 2, 12, 3, 7);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 361, '2020-02-11', '2020-07', '2020-02-11', 2020, 2, 11, 2, 7);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 362, '2020-02-10', '2020-07', '2020-02-10', 2020, 2, 10, 1, 7);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 363, '2020-02-09', '2020-06', '2020-02-09', 2020, 2, 9, 7, 6);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 364, '2020-02-08', '2020-06', '2020-02-08', 2020, 2, 8, 6, 6);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 365, '2020-02-07', '2020-06', '2020-02-07', 2020, 2, 7, 5, 6);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 366, '2020-02-06', '2020-06', '2020-02-06', 2020, 2, 6, 4, 6);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 367, '2020-02-05', '2020-06', '2020-02-05', 2020, 2, 5, 3, 6);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 368, '2020-02-04', '2020-06', '2020-02-04', 2020, 2, 4, 2, 6);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 369, '2020-02-03', '2020-06', '2020-02-03', 2020, 2, 3, 1, 6);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 370, '2020-02-02', '2020-05', '2020-02-02', 2020, 2, 2, 7, 5);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 371, '2020-02-01', '2020-05', '2020-02-01', 2020, 2, 1, 6, 5);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 372, '2020-01-31', '2020-05', '2020-01-31', 2020, 1, 31, 5, 5);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 373, '2020-01-30', '2020-05', '2020-01-30', 2020, 1, 30, 4, 5);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 374, '2020-01-29', '2020-05', '2020-01-29', 2020, 1, 29, 3, 5);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 375, '2020-01-28', '2020-05', '2020-01-28', 2020, 1, 28, 2, 5);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 376, '2020-01-27', '2020-05', '2020-01-27', 2020, 1, 27, 1, 5);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 377, '2020-01-26', '2020-04', '2020-01-26', 2020, 1, 26, 7, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 378, '2020-01-25', '2020-04', '2020-01-25', 2020, 1, 25, 6, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 379, '2020-01-24', '2020-04', '2020-01-24', 2020, 1, 24, 5, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 380, '2020-01-23', '2020-04', '2020-01-23', 2020, 1, 23, 4, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 381, '2020-01-22', '2020-04', '2020-01-22', 2020, 1, 22, 3, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 382, '2020-01-21', '2020-04', '2020-01-21', 2020, 1, 21, 2, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 383, '2020-01-20', '2020-04', '2020-01-20', 2020, 1, 20, 1, 4);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 384, '2020-01-19', '2020-03', '2020-01-19', 2020, 1, 19, 7, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 385, '2020-01-18', '2020-03', '2020-01-18', 2020, 1, 18, 6, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 386, '2020-01-17', '2020-03', '2020-01-17', 2020, 1, 17, 5, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 387, '2020-01-16', '2020-03', '2020-01-16', 2020, 1, 16, 4, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 388, '2020-01-15', '2020-03', '2020-01-15', 2020, 1, 15, 3, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 389, '2020-01-14', '2020-03', '2020-01-14', 2020, 1, 14, 2, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 390, '2020-01-13', '2020-03', '2020-01-13', 2020, 1, 13, 1, 3);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 391, '2020-01-12', '2020-02', '2020-01-12', 2020, 1, 12, 7, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 392, '2020-01-11', '2020-02', '2020-01-11', 2020, 1, 11, 6, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 393, '2020-01-10', '2020-02', '2020-01-10', 2020, 1, 10, 5, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 394, '2020-01-09', '2020-02', '2020-01-09', 2020, 1, 9, 4, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 395, '2020-01-08', '2020-02', '2020-01-08', 2020, 1, 8, 3, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 396, '2020-01-07', '2020-02', '2020-01-07', 2020, 1, 7, 2, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 397, '2020-01-06', '2020-02', '2020-01-06', 2020, 1, 6, 1, 2);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 398, '2020-01-05', '2020-01', '2020-01-05', 2020, 1, 5, 7, 1);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 399, '2020-01-04', '2020-01', '2020-01-04', 2020, 1, 4, 6, 1);
INSERT INTO public.common_date_reported VALUES ('who_date_reported', 400, '2020-01-03', '2020-01', '2020-01-03', 2020, 1, 3, 5, 1);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 401, '01/02/2021', '2021-05', '2021-02-01', 2021, 2, 1, 1, 5);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 402, '25/01/2021', '2021-04', '2021-01-25', 2021, 1, 25, 1, 4);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 403, '18/01/2021', '2021-03', '2021-01-18', 2021, 1, 18, 1, 3);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 404, '11/01/2021', '2021-02', '2021-01-11', 2021, 1, 11, 1, 2);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 405, '04/01/2021', '2021-01', '2021-01-04', 2021, 1, 4, 1, 1);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 406, '28/12/2020', '2020-53', '2020-12-28', 2020, 12, 28, 1, 53);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 407, '21/12/2020', '2020-52', '2020-12-21', 2020, 12, 21, 1, 52);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 408, '14/12/2020', '2020-51', '2020-12-14', 2020, 12, 14, 1, 51);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 409, '07/12/2020', '2020-50', '2020-12-07', 2020, 12, 7, 1, 50);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 410, '30/11/2020', '2020-49', '2020-11-30', 2020, 11, 30, 1, 49);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 411, '23/11/2020', '2020-48', '2020-11-23', 2020, 11, 23, 1, 48);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 412, '16/11/2020', '2020-47', '2020-11-16', 2020, 11, 16, 1, 47);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 413, '09/11/2020', '2020-46', '2020-11-09', 2020, 11, 9, 1, 46);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 414, '02/11/2020', '2020-45', '2020-11-02', 2020, 11, 2, 1, 45);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 415, '26/10/2020', '2020-44', '2020-10-26', 2020, 10, 26, 1, 44);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 416, '19/10/2020', '2020-43', '2020-10-19', 2020, 10, 19, 1, 43);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 417, '12/10/2020', '2020-42', '2020-10-12', 2020, 10, 12, 1, 42);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 418, '05/10/2020', '2020-41', '2020-10-05', 2020, 10, 5, 1, 41);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 419, '28/09/2020', '2020-40', '2020-09-28', 2020, 9, 28, 1, 40);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 420, '21/09/2020', '2020-39', '2020-09-21', 2020, 9, 21, 1, 39);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 421, '14/09/2020', '2020-38', '2020-09-14', 2020, 9, 14, 1, 38);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 422, '07/09/2020', '2020-37', '2020-09-07', 2020, 9, 7, 1, 37);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 423, '31/08/2020', '2020-36', '2020-08-31', 2020, 8, 31, 1, 36);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 424, '24/08/2020', '2020-35', '2020-08-24', 2020, 8, 24, 1, 35);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 425, '17/08/2020', '2020-34', '2020-08-17', 2020, 8, 17, 1, 34);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 426, '10/08/2020', '2020-33', '2020-08-10', 2020, 8, 10, 1, 33);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 427, '03/08/2020', '2020-32', '2020-08-03', 2020, 8, 3, 1, 32);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 428, '27/07/2020', '2020-31', '2020-07-27', 2020, 7, 27, 1, 31);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 429, '20/07/2020', '2020-30', '2020-07-20', 2020, 7, 20, 1, 30);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 430, '13/07/2020', '2020-29', '2020-07-13', 2020, 7, 13, 1, 29);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 431, '06/07/2020', '2020-28', '2020-07-06', 2020, 7, 6, 1, 28);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 432, '29/06/2020', '2020-27', '2020-06-29', 2020, 6, 29, 1, 27);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 433, '22/06/2020', '2020-26', '2020-06-22', 2020, 6, 22, 1, 26);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 434, '15/06/2020', '2020-25', '2020-06-15', 2020, 6, 15, 1, 25);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 435, '08/06/2020', '2020-24', '2020-06-08', 2020, 6, 8, 1, 24);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 436, '01/06/2020', '2020-23', '2020-06-01', 2020, 6, 1, 1, 23);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 437, '25/05/2020', '2020-22', '2020-05-25', 2020, 5, 25, 1, 22);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 438, '18/05/2020', '2020-21', '2020-05-18', 2020, 5, 18, 1, 21);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 439, '11/05/2020', '2020-20', '2020-05-11', 2020, 5, 11, 1, 20);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 440, '04/05/2020', '2020-19', '2020-05-04', 2020, 5, 4, 1, 19);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 441, '27/04/2020', '2020-18', '2020-04-27', 2020, 4, 27, 1, 18);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 442, '20/04/2020', '2020-17', '2020-04-20', 2020, 4, 20, 1, 17);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 443, '13/04/2020', '2020-16', '2020-04-13', 2020, 4, 13, 1, 16);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 444, '06/04/2020', '2020-15', '2020-04-06', 2020, 4, 6, 1, 15);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 445, '30/03/2020', '2020-14', '2020-03-30', 2020, 3, 30, 1, 14);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 446, '23/03/2020', '2020-13', '2020-03-23', 2020, 3, 23, 1, 13);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 447, '16/03/2020', '2020-12', '2020-03-16', 2020, 3, 16, 1, 12);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 448, '09/03/2020', '2020-11', '2020-03-09', 2020, 3, 9, 1, 11);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 449, '02/03/2020', '2020-10', '2020-03-02', 2020, 3, 2, 1, 10);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 450, '24/02/2020', '2020-09', '2020-02-24', 2020, 2, 24, 1, 9);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 451, '17/02/2020', '2020-08', '2020-02-17', 2020, 2, 17, 1, 8);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 452, '10/02/2020', '2020-07', '2020-02-10', 2020, 2, 10, 1, 7);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 453, '03/02/2020', '2020-06', '2020-02-03', 2020, 2, 3, 1, 6);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 454, '27/01/2020', '2020-05', '2020-01-27', 2020, 1, 27, 1, 5);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 455, '20/01/2020', '2020-04', '2020-01-20', 2020, 1, 20, 1, 4);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 456, '13/01/2020', '2020-03', '2020-01-13', 2020, 1, 13, 1, 3);
INSERT INTO public.common_date_reported VALUES ('europe_date_reported', 457, '06/01/2020', '2020-02', '2020-01-06', 2020, 1, 6, 1, 2);


--
-- Data for Name: common_region; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.common_region VALUES ('who_region', 1, 'AFRO');
INSERT INTO public.common_region VALUES ('who_region', 2, 'AMRO');
INSERT INTO public.common_region VALUES ('who_region', 3, 'EMRO');
INSERT INTO public.common_region VALUES ('who_region', 4, 'EURO');
INSERT INTO public.common_region VALUES ('who_region', 5, 'Other');
INSERT INTO public.common_region VALUES ('who_region', 6, 'SEARO');
INSERT INTO public.common_region VALUES ('who_region', 7, 'WPRO');
INSERT INTO public.common_region VALUES ('europe_continent', 8, 'Africa');
INSERT INTO public.common_region VALUES ('europe_continent', 9, 'America');
INSERT INTO public.common_region VALUES ('europe_continent', 10, 'Asia');
INSERT INTO public.common_region VALUES ('europe_continent', 11, 'Europe');
INSERT INTO public.common_region VALUES ('europe_continent', 12, 'Oceania');
INSERT INTO public.common_region VALUES ('europe_continent', 13, 'Other');


--
-- Data for Name: europe_country; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.europe_country VALUES (1, 'Algeria', '43053054', 'DZ', 'DZA', 8);
INSERT INTO public.europe_country VALUES (2, 'Angola', '31825299', 'AO', 'AGO', 8);
INSERT INTO public.europe_country VALUES (3, 'Benin', '11801151', 'BJ', 'BEN', 8);
INSERT INTO public.europe_country VALUES (4, 'Botswana', '2303703', 'BW', 'BWA', 8);
INSERT INTO public.europe_country VALUES (5, 'Burkina_Faso', '20321383', 'BF', 'BFA', 8);
INSERT INTO public.europe_country VALUES (6, 'Burundi', '11530577', 'BI', 'BDI', 8);
INSERT INTO public.europe_country VALUES (7, 'Cameroon', '25876387', 'CM', 'CMR', 8);
INSERT INTO public.europe_country VALUES (8, 'Cape_Verde', '549936', 'CV', 'CPV', 8);
INSERT INTO public.europe_country VALUES (9, 'Central_African_Republic', '4745179', 'CF', 'CAF', 8);
INSERT INTO public.europe_country VALUES (10, 'Chad', '15946882', 'TD', 'TCD', 8);
INSERT INTO public.europe_country VALUES (11, 'Comoros', '850891', 'KM', 'COM', 8);
INSERT INTO public.europe_country VALUES (12, 'Congo', '5380504', 'CG', 'COG', 8);
INSERT INTO public.europe_country VALUES (13, 'Cote_dIvoire', '25716554', 'CI', 'CIV', 8);
INSERT INTO public.europe_country VALUES (14, 'Democratic_Republic_of_the_Congo', '86790568', 'CD', 'COD', 8);
INSERT INTO public.europe_country VALUES (15, 'Djibouti', '973557', 'DJ', 'DJI', 8);
INSERT INTO public.europe_country VALUES (16, 'Egypt', '100388076', 'EG', 'EGY', 8);
INSERT INTO public.europe_country VALUES (17, 'Equatorial_Guinea', '1355982', 'GQ', 'GNQ', 8);
INSERT INTO public.europe_country VALUES (18, 'Eritrea', '3497117', 'ER', 'ERI', 8);
INSERT INTO public.europe_country VALUES (19, 'Eswatini', '1148133', 'SZ', 'SWZ', 8);
INSERT INTO public.europe_country VALUES (20, 'Ethiopia', '112078727', 'ET', 'ETH', 8);
INSERT INTO public.europe_country VALUES (21, 'Gabon', '2172578', 'GA', 'GAB', 8);
INSERT INTO public.europe_country VALUES (22, 'Gambia', '2347696', 'GM', 'GMB', 8);
INSERT INTO public.europe_country VALUES (23, 'Ghana', '30417858', 'GH', 'GHA', 8);
INSERT INTO public.europe_country VALUES (24, 'Guinea', '12771246', 'GN', 'GIN', 8);
INSERT INTO public.europe_country VALUES (25, 'Guinea_Bissau', '1920917', 'GW', 'GNB', 8);
INSERT INTO public.europe_country VALUES (26, 'Kenya', '52573967', 'KE', 'KEN', 8);
INSERT INTO public.europe_country VALUES (27, 'Lesotho', '2125267', 'LS', 'LSO', 8);
INSERT INTO public.europe_country VALUES (28, 'Liberia', '4937374', 'LR', 'LBR', 8);
INSERT INTO public.europe_country VALUES (29, 'Libya', '6777453', 'LY', 'LBY', 8);
INSERT INTO public.europe_country VALUES (30, 'Madagascar', '26969306', 'MG', 'MDG', 8);
INSERT INTO public.europe_country VALUES (31, 'Malawi', '18628749', 'MW', 'MWI', 8);
INSERT INTO public.europe_country VALUES (32, 'Mali', '19658023', 'ML', 'MLI', 8);
INSERT INTO public.europe_country VALUES (33, 'Mauritania', '4525698', 'MR', 'MRT', 8);
INSERT INTO public.europe_country VALUES (34, 'Mauritius', '1269670', 'MU', 'MUS', 8);
INSERT INTO public.europe_country VALUES (35, 'Morocco', '36471766', 'MA', 'MAR', 8);
INSERT INTO public.europe_country VALUES (36, 'Mozambique', '30366043', 'MZ', 'MOZ', 8);
INSERT INTO public.europe_country VALUES (37, 'Namibia', '2494524', 'NA', 'NAM', 8);
INSERT INTO public.europe_country VALUES (38, 'Niger', '23310719', 'NE', 'NER', 8);
INSERT INTO public.europe_country VALUES (39, 'Nigeria', '200963603', 'NG', 'NGA', 8);
INSERT INTO public.europe_country VALUES (40, 'Rwanda', '12626938', 'RW', 'RWA', 8);
INSERT INTO public.europe_country VALUES (41, 'Sao_Tome_and_Principe', '215048', 'ST', 'STP', 8);
INSERT INTO public.europe_country VALUES (42, 'Senegal', '16296362', 'SN', 'SEN', 8);
INSERT INTO public.europe_country VALUES (43, 'Seychelles', '97741', 'SC', 'SYC', 8);
INSERT INTO public.europe_country VALUES (44, 'Sierra_Leone', '7813207', 'SL', 'SLE', 8);
INSERT INTO public.europe_country VALUES (45, 'Somalia', '15442906', 'SO', 'SOM', 8);
INSERT INTO public.europe_country VALUES (46, 'South_Africa', '58558267', 'ZA', 'ZAF', 8);
INSERT INTO public.europe_country VALUES (47, 'South_Sudan', '11062114', 'SS', 'SSD', 8);
INSERT INTO public.europe_country VALUES (48, 'Sudan', '42813237', 'SD', 'SDN', 8);
INSERT INTO public.europe_country VALUES (49, 'Togo', '8082359', 'TG', 'TGO', 8);
INSERT INTO public.europe_country VALUES (50, 'Tunisia', '11694721', 'TN', 'TUN', 8);
INSERT INTO public.europe_country VALUES (51, 'Uganda', '44269587', 'UG', 'UGA', 8);
INSERT INTO public.europe_country VALUES (52, 'United_Republic_of_Tanzania', '58005461', 'TZ', 'TZA', 8);
INSERT INTO public.europe_country VALUES (53, 'Western_Sahara', '582458', 'EH', 'ESH', 8);
INSERT INTO public.europe_country VALUES (54, 'Zambia', '17861034', 'ZM', 'ZMB', 8);
INSERT INTO public.europe_country VALUES (55, 'Zimbabwe', '14645473', 'ZW', 'ZWE', 8);
INSERT INTO public.europe_country VALUES (56, 'Anguilla', '14872', 'AI', 'AIA', 9);
INSERT INTO public.europe_country VALUES (57, 'Antigua_and_Barbuda', '97115', 'AG', 'ATG', 9);
INSERT INTO public.europe_country VALUES (58, 'Argentina', '44780675', 'AR', 'ARG', 9);
INSERT INTO public.europe_country VALUES (59, 'Aruba', '106310', 'AW', 'ABW', 9);
INSERT INTO public.europe_country VALUES (60, 'Bahamas', '389486', 'BS', 'BHS', 9);
INSERT INTO public.europe_country VALUES (61, 'Barbados', '287021', 'BB', 'BRB', 9);
INSERT INTO public.europe_country VALUES (62, 'Belize', '390351', 'BZ', 'BLZ', 9);
INSERT INTO public.europe_country VALUES (63, 'Bermuda', '62508', 'BM', 'BMU', 9);
INSERT INTO public.europe_country VALUES (64, 'Bolivia', '11513102', 'BO', 'BOL', 9);
INSERT INTO public.europe_country VALUES (65, 'Bonaire, Saint Eustatius and Saba', '25983', 'BQ', 'BES', 9);
INSERT INTO public.europe_country VALUES (66, 'Brazil', '211049519', 'BR', 'BRA', 9);
INSERT INTO public.europe_country VALUES (67, 'British_Virgin_Islands', '30033', 'VG', 'VGB', 9);
INSERT INTO public.europe_country VALUES (68, 'Canada', '37411038', 'CA', 'CAN', 9);
INSERT INTO public.europe_country VALUES (69, 'Cayman_Islands', '64948', 'KY', 'CYM', 9);
INSERT INTO public.europe_country VALUES (70, 'Chile', '18952035', 'CL', 'CHL', 9);
INSERT INTO public.europe_country VALUES (71, 'Colombia', '50339443', 'CO', 'COL', 9);
INSERT INTO public.europe_country VALUES (72, 'Costa_Rica', '5047561', 'CR', 'CRI', 9);
INSERT INTO public.europe_country VALUES (73, 'Cuba', '11333484', 'CU', 'CUB', 9);
INSERT INTO public.europe_country VALUES (74, 'Curaçao', '163423', 'CW', 'CUW', 9);
INSERT INTO public.europe_country VALUES (75, 'Dominica', '71808', 'DM', 'DMA', 9);
INSERT INTO public.europe_country VALUES (76, 'Dominican_Republic', '10738957', 'DO', 'DOM', 9);
INSERT INTO public.europe_country VALUES (77, 'Ecuador', '17373657', 'EC', 'ECU', 9);
INSERT INTO public.europe_country VALUES (78, 'El_Salvador', '6453550', 'SV', 'SLV', 9);
INSERT INTO public.europe_country VALUES (79, 'Falkland_Islands_(Malvinas)', '3372', 'FK', 'FLK', 9);
INSERT INTO public.europe_country VALUES (80, 'Greenland', '56660', 'GL', 'GRL', 9);
INSERT INTO public.europe_country VALUES (81, 'Grenada', '112002', 'GD', 'GRD', 9);
INSERT INTO public.europe_country VALUES (82, 'Guatemala', '17581476', 'GT', 'GTM', 9);
INSERT INTO public.europe_country VALUES (83, 'Guyana', '782775', 'GY', 'GUY', 9);
INSERT INTO public.europe_country VALUES (84, 'Haiti', '11263079', 'HT', 'HTI', 9);
INSERT INTO public.europe_country VALUES (85, 'Honduras', '9746115', 'HN', 'HND', 9);
INSERT INTO public.europe_country VALUES (86, 'Jamaica', '2948277', 'JM', 'JAM', 9);
INSERT INTO public.europe_country VALUES (87, 'Mexico', '127575529', 'MX', 'MEX', 9);
INSERT INTO public.europe_country VALUES (88, 'Montserrat', '4991', 'MS', 'MSF', 9);
INSERT INTO public.europe_country VALUES (89, 'Nicaragua', '6545503', 'NI', 'NIC', 9);
INSERT INTO public.europe_country VALUES (90, 'Panama', '4246440', 'PA', 'PAN', 9);
INSERT INTO public.europe_country VALUES (91, 'Paraguay', '7044639', 'PY', 'PRY', 9);
INSERT INTO public.europe_country VALUES (92, 'Peru', '32510462', 'PE', 'PER', 9);
INSERT INTO public.europe_country VALUES (93, 'Puerto_Rico', '2933404', 'PR', 'PRI', 9);
INSERT INTO public.europe_country VALUES (94, 'Saint_Kitts_and_Nevis', '52834', 'KN', 'KNA', 9);
INSERT INTO public.europe_country VALUES (95, 'Saint_Lucia', '182795', 'LC', 'LCA', 9);
INSERT INTO public.europe_country VALUES (96, 'Saint_Vincent_and_the_Grenadines', '110593', 'VC', 'VCT', 9);
INSERT INTO public.europe_country VALUES (97, 'Sint_Maarten', '42389', 'SX', 'SXM', 9);
INSERT INTO public.europe_country VALUES (98, 'Suriname', '581363', 'SR', 'SUR', 9);
INSERT INTO public.europe_country VALUES (99, 'Trinidad_and_Tobago', '1394969', 'TT', 'TTO', 9);
INSERT INTO public.europe_country VALUES (100, 'Turks_and_Caicos_islands', '38194', 'TC', 'TCA', 9);
INSERT INTO public.europe_country VALUES (101, 'United_States_of_America', '329064917', 'US', 'USA', 9);
INSERT INTO public.europe_country VALUES (102, 'United_States_Virgin_Islands', '104579', 'VI', 'VIR', 9);
INSERT INTO public.europe_country VALUES (103, 'Uruguay', '3461731', 'UY', 'URY', 9);
INSERT INTO public.europe_country VALUES (104, 'Venezuela', '28515829', 'VE', 'VEN', 9);
INSERT INTO public.europe_country VALUES (105, 'Afghanistan', '38041757', 'AF', 'AFG', 10);
INSERT INTO public.europe_country VALUES (106, 'Bahrain', '1641164', 'BH', 'BHR', 10);
INSERT INTO public.europe_country VALUES (107, 'Bangladesh', '163046173', 'BD', 'BGD', 10);
INSERT INTO public.europe_country VALUES (108, 'Bhutan', '763094', 'BT', 'BTN', 10);
INSERT INTO public.europe_country VALUES (109, 'Brunei_Darussalam', '433296', 'BN', 'BRN', 10);
INSERT INTO public.europe_country VALUES (110, 'Cambodia', '16486542', 'KH', 'KHM', 10);
INSERT INTO public.europe_country VALUES (111, 'China', '1433783692', 'CN', 'CHN', 10);
INSERT INTO public.europe_country VALUES (112, 'India', '1366417756', 'IN', 'IND', 10);
INSERT INTO public.europe_country VALUES (113, 'Indonesia', '270625567', 'ID', 'IDN', 10);
INSERT INTO public.europe_country VALUES (114, 'Iran', '82913893', 'IR', 'IRN', 10);
INSERT INTO public.europe_country VALUES (115, 'Iraq', '39309789', 'IQ', 'IRQ', 10);
INSERT INTO public.europe_country VALUES (116, 'Israel', '8519373', 'IL', 'ISR', 10);
INSERT INTO public.europe_country VALUES (117, 'Japan', '126860299', 'JP', 'JPN', 10);
INSERT INTO public.europe_country VALUES (118, 'Jordan', '10101697', 'JO', 'JOR', 10);
INSERT INTO public.europe_country VALUES (119, 'Kazakhstan', '18551428', 'KZ', 'KAZ', 10);
INSERT INTO public.europe_country VALUES (120, 'Kuwait', '4207077', 'KW', 'KWT', 10);
INSERT INTO public.europe_country VALUES (121, 'Kyrgyzstan', '6415851', 'KG', 'KGZ', 10);
INSERT INTO public.europe_country VALUES (122, 'Laos', '7169456', 'LA', 'LAO', 10);
INSERT INTO public.europe_country VALUES (123, 'Lebanon', '6855709', 'LB', 'LBN', 10);
INSERT INTO public.europe_country VALUES (124, 'Malaysia', '31949789', 'MY', 'MYS', 10);
INSERT INTO public.europe_country VALUES (125, 'Maldives', '530957', 'MV', 'MDV', 10);
INSERT INTO public.europe_country VALUES (126, 'Mongolia', '3225166', 'MN', 'MNG', 10);
INSERT INTO public.europe_country VALUES (127, 'Myanmar', '54045422', 'MM', 'MMR', 10);
INSERT INTO public.europe_country VALUES (128, 'Nepal', '28608715', 'NP', 'NPL', 10);
INSERT INTO public.europe_country VALUES (129, 'Oman', '4974992', 'OM', 'OMN', 10);
INSERT INTO public.europe_country VALUES (130, 'Pakistan', '216565317', 'PK', 'PAK', 10);
INSERT INTO public.europe_country VALUES (131, 'Palestine', '4981422', 'PS', 'PSE', 10);
INSERT INTO public.europe_country VALUES (132, 'Philippines', '108116622', 'PH', 'PHL', 10);
INSERT INTO public.europe_country VALUES (133, 'Qatar', '2832071', 'QA', 'QAT', 10);
INSERT INTO public.europe_country VALUES (134, 'Saudi_Arabia', '34268529', 'SA', 'SAU', 10);
INSERT INTO public.europe_country VALUES (135, 'Singapore', '5804343', 'SG', 'SGP', 10);
INSERT INTO public.europe_country VALUES (136, 'South_Korea', '51225321', 'KR', 'KOR', 10);
INSERT INTO public.europe_country VALUES (137, 'Sri_Lanka', '21323734', 'LK', 'LKA', 10);
INSERT INTO public.europe_country VALUES (138, 'Syria', '17070132', 'SY', 'SYR', 10);
INSERT INTO public.europe_country VALUES (139, 'Taiwan', '23773881', 'TW', 'CNG1925', 10);
INSERT INTO public.europe_country VALUES (140, 'Tajikistan', '9321023', 'TJ', 'TJK', 10);
INSERT INTO public.europe_country VALUES (141, 'Thailand', '69625581', 'TH', 'THA', 10);
INSERT INTO public.europe_country VALUES (142, 'Timor_Leste', '1293120', 'TL', 'TLS', 10);
INSERT INTO public.europe_country VALUES (143, 'United_Arab_Emirates', '9770526', 'AE', 'ARE', 10);
INSERT INTO public.europe_country VALUES (144, 'Uzbekistan', '32981715', 'UZ', 'UZB', 10);
INSERT INTO public.europe_country VALUES (145, 'Vietnam', '96462108', 'VN', 'VNM', 10);
INSERT INTO public.europe_country VALUES (146, 'Yemen', '29161922', 'YE', 'YEM', 10);
INSERT INTO public.europe_country VALUES (147, 'Albania', '2862427', 'AL', 'ALB', 11);
INSERT INTO public.europe_country VALUES (148, 'Andorra', '76177', 'AD', 'AND', 11);
INSERT INTO public.europe_country VALUES (149, 'Armenia', '2957728', 'AM', 'ARM', 11);
INSERT INTO public.europe_country VALUES (150, 'Austria', '8858775', 'AT', 'AUT', 11);
INSERT INTO public.europe_country VALUES (151, 'Azerbaijan', '10047719', 'AZ', 'AZE', 11);
INSERT INTO public.europe_country VALUES (152, 'Belarus', '9452409', 'BY', 'BLR', 11);
INSERT INTO public.europe_country VALUES (153, 'Belgium', '11455519', 'BE', 'BEL', 11);
INSERT INTO public.europe_country VALUES (154, 'Bosnia_and_Herzegovina', '3300998', 'BA', 'BIH', 11);
INSERT INTO public.europe_country VALUES (155, 'Bulgaria', '7000039', 'BG', 'BGR', 11);
INSERT INTO public.europe_country VALUES (156, 'Croatia', '4076246', 'HR', 'HRV', 11);
INSERT INTO public.europe_country VALUES (157, 'Cyprus', '875899', 'CY', 'CYP', 11);
INSERT INTO public.europe_country VALUES (158, 'Czechia', '10649800', 'CZ', 'CZE', 11);
INSERT INTO public.europe_country VALUES (159, 'Denmark', '5806081', 'DK', 'DNK', 11);
INSERT INTO public.europe_country VALUES (160, 'Estonia', '1324820', 'EE', 'EST', 11);
INSERT INTO public.europe_country VALUES (161, 'Faroe_Islands', '48677', 'FO', 'FRO', 11);
INSERT INTO public.europe_country VALUES (162, 'Finland', '5517919', 'FI', 'FIN', 11);
INSERT INTO public.europe_country VALUES (163, 'France', '67012883', 'FR', 'FRA', 11);
INSERT INTO public.europe_country VALUES (164, 'Georgia', '3996762', 'GE', 'GEO', 11);
INSERT INTO public.europe_country VALUES (165, 'Germany', '83019213', 'DE', 'DEU', 11);
INSERT INTO public.europe_country VALUES (166, 'Gibraltar', '33706', 'GI', 'GIB', 11);
INSERT INTO public.europe_country VALUES (167, 'Greece', '10724599', 'EL', 'GRC', 11);
INSERT INTO public.europe_country VALUES (168, 'Guernsey', '64468', 'GG', 'GGY', 11);
INSERT INTO public.europe_country VALUES (169, 'Holy_See', '815', 'VA', 'VAT', 11);
INSERT INTO public.europe_country VALUES (170, 'Hungary', '9772756', 'HU', 'HUN', 11);
INSERT INTO public.europe_country VALUES (171, 'Iceland', '356991', 'IS', 'ISL', 11);
INSERT INTO public.europe_country VALUES (172, 'Ireland', '4904240', 'IE', 'IRL', 11);
INSERT INTO public.europe_country VALUES (173, 'Isle_of_Man', '84589', 'IM', 'IMN', 11);
INSERT INTO public.europe_country VALUES (174, 'Italy', '60359546', 'IT', 'ITA', 11);
INSERT INTO public.europe_country VALUES (175, 'Jersey', '107796', 'JE', 'JEY', 11);
INSERT INTO public.europe_country VALUES (176, 'Kosovo', '1798506', 'XK', 'XKX', 11);
INSERT INTO public.europe_country VALUES (177, 'Latvia', '1919968', 'LV', 'LVA', 11);
INSERT INTO public.europe_country VALUES (178, 'Liechtenstein', '38378', 'LI', 'LIE', 11);
INSERT INTO public.europe_country VALUES (179, 'Lithuania', '2794184', 'LT', 'LTU', 11);
INSERT INTO public.europe_country VALUES (180, 'Luxembourg', '613894', 'LU', 'LUX', 11);
INSERT INTO public.europe_country VALUES (181, 'Malta', '493559', 'MT', 'MLT', 11);
INSERT INTO public.europe_country VALUES (182, 'Moldova', '4043258', 'MD', 'MDA', 11);
INSERT INTO public.europe_country VALUES (183, 'Monaco', '33085', 'MC', 'MCO', 11);
INSERT INTO public.europe_country VALUES (184, 'Montenegro', '622182', 'ME', 'MNE', 11);
INSERT INTO public.europe_country VALUES (185, 'Netherlands', '17282163', 'NL', 'NLD', 11);
INSERT INTO public.europe_country VALUES (186, 'North_Macedonia', '2077132', 'MK', 'MKD', 11);
INSERT INTO public.europe_country VALUES (187, 'Norway', '5328212', 'NO', 'NOR', 11);
INSERT INTO public.europe_country VALUES (188, 'Poland', '37972812', 'PL', 'POL', 11);
INSERT INTO public.europe_country VALUES (189, 'Portugal', '10276617', 'PT', 'PRT', 11);
INSERT INTO public.europe_country VALUES (190, 'Romania', '19414458', 'RO', 'ROU', 11);
INSERT INTO public.europe_country VALUES (191, 'Russia', '145872260', 'RU', 'RUS', 11);
INSERT INTO public.europe_country VALUES (192, 'San_Marino', '34453', 'SM', 'SMR', 11);
INSERT INTO public.europe_country VALUES (193, 'Serbia', '6963764', 'RS', 'SRB', 11);
INSERT INTO public.europe_country VALUES (194, 'Slovakia', '5450421', 'SK', 'SVK', 11);
INSERT INTO public.europe_country VALUES (195, 'Slovenia', '2080908', 'SI', 'SVN', 11);
INSERT INTO public.europe_country VALUES (196, 'Spain', '46937060', 'ES', 'ESP', 11);
INSERT INTO public.europe_country VALUES (197, 'Sweden', '10230185', 'SE', 'SWE', 11);
INSERT INTO public.europe_country VALUES (198, 'Switzerland', '8544527', 'CH', 'CHE', 11);
INSERT INTO public.europe_country VALUES (199, 'Turkey', '82003882', 'TR', 'TUR', 11);
INSERT INTO public.europe_country VALUES (200, 'Ukraine', '43993643', 'UA', 'UKR', 11);
INSERT INTO public.europe_country VALUES (201, 'United_Kingdom', '66647112', 'UK', 'GBR', 11);
INSERT INTO public.europe_country VALUES (202, 'Australia', '25203200', 'AU', 'AUS', 12);
INSERT INTO public.europe_country VALUES (203, 'Fiji', '889955', 'FJ', 'FJI', 12);
INSERT INTO public.europe_country VALUES (204, 'French_Polynesia', '279285', 'PF', 'PYF', 12);
INSERT INTO public.europe_country VALUES (205, 'Guam', '167295', 'GU', 'GUM', 12);
INSERT INTO public.europe_country VALUES (206, 'Marshall_Islands', '58791', 'MH', 'MHL', 12);
INSERT INTO public.europe_country VALUES (207, 'Micronesia_(Federated_States_of)', '113811', 'FM', 'FSM', 12);
INSERT INTO public.europe_country VALUES (208, 'New_Caledonia', '282757', 'NC', 'NCL', 12);
INSERT INTO public.europe_country VALUES (209, 'New_Zealand', '4783062', 'NZ', 'NZL', 12);
INSERT INTO public.europe_country VALUES (210, 'Northern_Mariana_Islands', '57213', 'MP', 'MNP', 12);
INSERT INTO public.europe_country VALUES (211, 'Papua_New_Guinea', '8776119', 'PG', 'PNG', 12);
INSERT INTO public.europe_country VALUES (212, 'Solomon_Islands', '669821', 'SB', 'SLB', 12);
INSERT INTO public.europe_country VALUES (213, 'Vanuatu', '299882', 'VU', 'VUT', 12);
INSERT INTO public.europe_country VALUES (214, 'Wallis_and_Futuna', '', 'WF', '', 12);
INSERT INTO public.europe_country VALUES (215, 'Cases_on_an_international_conveyance_Japan', '', 'JPG11668', '', 13);


--
-- Data for Name: europe_data; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.europe_data VALUES (1, 16, 267, 2.58, 105, 402);
INSERT INTO public.europe_data VALUES (2, 65, 5853, 364.62, 147, 402);
INSERT INTO public.europe_data VALUES (3, 28, 1743, 8.14, 1, 402);
INSERT INTO public.europe_data VALUES (4, 5, 388, 1121.07, 148, 402);
INSERT INTO public.europe_data VALUES (5, 7, 397, 2.89, 2, 402);
INSERT INTO public.europe_data VALUES (6, 0, 1, 13.45, 56, 402);
INSERT INTO public.europe_data VALUES (7, 0, 33, 46.34, 57, 402);
INSERT INTO public.europe_data VALUES (8, 1215, 59056, 282.36, 58, 402);
INSERT INTO public.europe_data VALUES (9, 37, 994, 81.55, 149, 402);
INSERT INTO public.europe_data VALUES (10, 2, 244, 518.3, 59, 402);
INSERT INTO public.europe_data VALUES (11, 0, 52, 0.44, 202, 402);
INSERT INTO public.europe_data VALUES (12, 291, 9451, 224.32, 150, 402);
INSERT INTO public.europe_data VALUES (13, 39, 1187, 28.15, 151, 402);
INSERT INTO public.europe_data VALUES (14, 1, 41, 27.47, 60, 402);
INSERT INTO public.europe_data VALUES (15, 8, 3601, 332.08, 106, 402);
INSERT INTO public.europe_data VALUES (16, 104, 3340, 4.6, 107, 402);
INSERT INTO public.europe_data VALUES (17, 4, 157, 161.31, 61, 402);
INSERT INTO public.europe_data VALUES (18, 69, 10725, 221.91, 152, 402);
INSERT INTO public.europe_data VALUES (19, 291, 16454, 276.37, 153, 402);
INSERT INTO public.europe_data VALUES (20, 9, 175, 111.95, 62, 402);
INSERT INTO public.europe_data VALUES (21, 4, 250, 4.07, 3, 402);
INSERT INTO public.europe_data VALUES (22, 0, 6, 14.4, 63, 402);
INSERT INTO public.europe_data VALUES (23, 0, 4, 2.23, 108, 402);
INSERT INTO public.europe_data VALUES (24, 328, 14017, 257.55, 64, 402);
INSERT INTO public.europe_data VALUES (25, 0, 10, 103.91, 65, 402);
INSERT INTO public.europe_data VALUES (26, 131, 2056, 124.69, 154, 402);
INSERT INTO public.europe_data VALUES (27, 29, 1639, 170.51, 4, 402);
INSERT INTO public.europe_data VALUES (28, 7435, 357929, 339.99, 66, 402);
INSERT INTO public.europe_data VALUES (29, 0, 4, 66.59, 67, 402);
INSERT INTO public.europe_data VALUES (30, 0, 5, 1.38, 109, 402);
INSERT INTO public.europe_data VALUES (31, 225, 3931, 99.07, 155, 402);
INSERT INTO public.europe_data VALUES (32, 4, 665, 7.78, 5, 402);
INSERT INTO public.europe_data VALUES (33, 0, 156, 3.46, 6, 402);
INSERT INTO public.europe_data VALUES (34, 0, 8, 0.15, 110, 402);
INSERT INTO public.europe_data VALUES (35, 12, 696, 8.9, 7, 402);
INSERT INTO public.europe_data VALUES (36, 898, 30578, 183.15, 68, 402);
INSERT INTO public.europe_data VALUES (37, 4, 609, 200.93, 8, 402);
INSERT INTO public.europe_data VALUES (38, 0, 15, 27.71, 69, 402);
INSERT INTO public.europe_data VALUES (39, 0, 9, 0.32, 9, 402);
INSERT INTO public.europe_data VALUES (40, 5, 224, 3.07, 10, 402);
INSERT INTO public.europe_data VALUES (41, 538, 27710, 301.49, 70, 402);
INSERT INTO public.europe_data VALUES (42, 13, 816, 0.15, 111, 402);
INSERT INTO public.europe_data VALUES (43, 2525, 76760, 360.3, 71, 402);
INSERT INTO public.europe_data VALUES (44, 27, 543, 143.26, 11, 402);
INSERT INTO public.europe_data VALUES (45, 1, 93, 3.31, 12, 402);
INSERT INTO public.europe_data VALUES (46, 76, 3824, 169.45, 72, 402);
INSERT INTO public.europe_data VALUES (47, 5, 844, 9.54, 13, 402);
INSERT INTO public.europe_data VALUES (48, 195, 3466, 181.34, 156, 402);
INSERT INTO public.europe_data VALUES (49, 19, 5764, 80.73, 73, 402);
INSERT INTO public.europe_data VALUES (50, 1, 37, 39.77, 74, 402);
INSERT INTO public.europe_data VALUES (51, 13, 859, 217.83, 157, 402);
INSERT INTO public.europe_data VALUES (52, 939, 47325, 896.51, 158, 402);
INSERT INTO public.europe_data VALUES (53, 12, 888, 2.05, 14, 402);
INSERT INTO public.europe_data VALUES (54, 135, 3664, 156.13, 159, 402);
INSERT INTO public.europe_data VALUES (55, 2, 13, 2.77, 15, 402);
INSERT INTO public.europe_data VALUES (56, 0, 4, 5.57, 75, 402);
INSERT INTO public.europe_data VALUES (57, 143, 9924, 187.36, 76, 402);
INSERT INTO public.europe_data VALUES (58, 251, 9419, 111.33, 77, 402);
INSERT INTO public.europe_data VALUES (59, 357, 4134, 9.52, 16, 402);
INSERT INTO public.europe_data VALUES (60, 49, 1716, 58.23, 78, 402);
INSERT INTO public.europe_data VALUES (61, 0, 80, 12.46, 17, 402);
INSERT INTO public.europe_data VALUES (62, 0, 185, 7.38, 18, 402);
INSERT INTO public.europe_data VALUES (63, 43, 3492, 518.11, 160, 402);
INSERT INTO public.europe_data VALUES (64, 198, 2860, 249.1, 19, 402);
INSERT INTO public.europe_data VALUES (65, 37, 4617, 6.41, 20, 402);
INSERT INTO public.europe_data VALUES (66, 0, 3, 237.25, 79, 402);
INSERT INTO public.europe_data VALUES (67, 0, 2, 10.27, 161, 402);
INSERT INTO public.europe_data VALUES (68, 0, 0, 0, 203, 402);
INSERT INTO public.europe_data VALUES (69, 22, 2902, 93.24, 162, 402);
INSERT INTO public.europe_data VALUES (70, 3008, 143497, 426.97, 163, 402);
INSERT INTO public.europe_data VALUES (71, 5, 425, 152.17, 204, 402);
INSERT INTO public.europe_data VALUES (72, 1, 542, 48.51, 21, 402);
INSERT INTO public.europe_data VALUES (73, 3, 131, 9.75, 22, 402);
INSERT INTO public.europe_data VALUES (74, 123, 4535, 261.11, 164, 402);
INSERT INTO public.europe_data VALUES (75, 5033, 80306, 218.4, 165, 402);
INSERT INTO public.europe_data VALUES (76, 44, 4875, 30.56, 23, 402);
INSERT INTO public.europe_data VALUES (77, 14, 148, 1317.27, 166, 402);
INSERT INTO public.europe_data VALUES (78, 150, 4977, 77.86, 167, 402);
INSERT INTO public.europe_data VALUES (79, 0, 0, 0, 80, 402);
INSERT INTO public.europe_data VALUES (80, 0, 0, 8.04, 81, 402);
INSERT INTO public.europe_data VALUES (81, 0, 54, 73.52, 205, 402);
INSERT INTO public.europe_data VALUES (82, 204, 5202, 59.64, 82, 402);
INSERT INTO public.europe_data VALUES (83, 0, 218, 356.77, 168, 402);
INSERT INTO public.europe_data VALUES (84, 1, 176, 3, 24, 402);
INSERT INTO public.europe_data VALUES (85, 0, 103, 6.56, 25, 402);
INSERT INTO public.europe_data VALUES (86, 4, 324, 93.64, 83, 402);
INSERT INTO public.europe_data VALUES (87, 2, 304, 6.06, 84, 402);
INSERT INTO public.europe_data VALUES (88, 0, 0, 0, 169, 402);
INSERT INTO public.europe_data VALUES (89, 148, 5859, 140.9, 85, 402);
INSERT INTO public.europe_data VALUES (90, 554, 8292, 163.79, 170, 402);
INSERT INTO public.europe_data VALUES (91, 0, 19, 10.92, 171, 402);
INSERT INTO public.europe_data VALUES (92, 922, 89874, 13.6, 112, 402);
INSERT INTO public.europe_data VALUES (93, 2163, 89052, 62.96, 113, 402);
INSERT INTO public.europe_data VALUES (94, 576, 45022, 105.64, 114, 402);
INSERT INTO public.europe_data VALUES (95, 54, 5873, 29.01, 115, 402);
INSERT INTO public.europe_data VALUES (96, 337, 8993, 485.72, 172, 402);
INSERT INTO public.europe_data VALUES (97, 0, 2, 7.09, 173, 402);
INSERT INTO public.europe_data VALUES (98, 359, 45208, 1110.27, 116, 402);
INSERT INTO public.europe_data VALUES (99, 3055, 86219, 284.55, 174, 402);
INSERT INTO public.europe_data VALUES (100, 14, 766, 51.01, 86, 402);
INSERT INTO public.europe_data VALUES (101, 703, 28857, 48.26, 117, 402);
INSERT INTO public.europe_data VALUES (102, 3, 30, 90.91, 175, 402);
INSERT INTO public.europe_data VALUES (103, 102, 7609, 123.92, 118, 402);
INSERT INTO public.europe_data VALUES (104, 88, 9953, 101.77, 119, 402);
INSERT INTO public.europe_data VALUES (105, 22, 804, 3.22, 26, 402);
INSERT INTO public.europe_data VALUES (106, 42, 2130, 242.81, 176, 402);
INSERT INTO public.europe_data VALUES (107, 7, 3972, 177.8, 120, 402);
INSERT INTO public.europe_data VALUES (108, 11, 617, 21.98, 121, 402);
INSERT INTO public.europe_data VALUES (109, 0, 0, 0.04, 122, 402);
INSERT INTO public.europe_data VALUES (110, 84, 5233, 550.89, 177, 402);
INSERT INTO public.europe_data VALUES (111, 762, 21455, 703.65, 123, 402);
INSERT INTO public.europe_data VALUES (112, 37, 622, 89.73, 27, 402);
INSERT INTO public.europe_data VALUES (113, 0, 25, 1.05, 28, 402);
INSERT INTO public.europe_data VALUES (114, 94, 4103, 140.66, 29, 402);
INSERT INTO public.europe_data VALUES (115, 0, 43, 265.78, 178, 402);
INSERT INTO public.europe_data VALUES (116, 161, 5727, 533.29, 179, 402);
INSERT INTO public.europe_data VALUES (117, 16, 965, 295.98, 180, 402);
INSERT INTO public.europe_data VALUES (118, 2, 322, 2.83, 30, 402);
INSERT INTO public.europe_data VALUES (119, 194, 4378, 63.85, 31, 402);
INSERT INTO public.europe_data VALUES (120, 82, 31158, 176.92, 124, 402);
INSERT INTO public.europe_data VALUES (121, 1, 848, 250.11, 125, 402);
INSERT INTO public.europe_data VALUES (122, 8, 117, 1.33, 32, 402);
INSERT INTO public.europe_data VALUES (123, 22, 1177, 465.19, 181, 402);
INSERT INTO public.europe_data VALUES (124, 0, 0, 0, 206, 402);
INSERT INTO public.europe_data VALUES (125, 5, 146, 11.14, 33, 402);
INSERT INTO public.europe_data VALUES (126, 0, 1, 1.73, 34, 402);
INSERT INTO public.europe_data VALUES (127, 8827, 97968, 172.61, 87, 402);
INSERT INTO public.europe_data VALUES (128, 0, 0, 0, 207, 402);
INSERT INTO public.europe_data VALUES (129, 77, 3602, 171.89, 182, 402);
INSERT INTO public.europe_data VALUES (130, 5, 132, 858.4, 183, 402);
INSERT INTO public.europe_data VALUES (131, 2, 171, 8.93, 126, 402);
INSERT INTO public.europe_data VALUES (132, 37, 3343, 991.03, 184, 402);
INSERT INTO public.europe_data VALUES (133, 0, 0, 0, 88, 402);
INSERT INTO public.europe_data VALUES (134, 125, 4868, 31.49, 35, 402);
INSERT INTO public.europe_data VALUES (135, 23, 6679, 42.51, 36, 402);
INSERT INTO public.europe_data VALUES (136, 69, 2571, 10.78, 127, 402);
INSERT INTO public.europe_data VALUES (137, 34, 1743, 152.53, 37, 402);
INSERT INTO public.europe_data VALUES (138, 28, 1509, 12.71, 128, 402);
INSERT INTO public.europe_data VALUES (139, 445, 28671, 371.83, 185, 402);
INSERT INTO public.europe_data VALUES (140, 0, 3, 1.06, 208, 402);
INSERT INTO public.europe_data VALUES (141, 0, 15, 0.86, 209, 402);
INSERT INTO public.europe_data VALUES (142, 1, 49, 1.54, 89, 402);
INSERT INTO public.europe_data VALUES (143, 10, 184, 1.63, 38, 402);
INSERT INTO public.europe_data VALUES (144, 100, 8922, 10.71, 39, 402);
INSERT INTO public.europe_data VALUES (145, 70, 2039, 180.78, 186, 402);
INSERT INTO public.europe_data VALUES (146, 0, 3, 6.99, 210, 402);
INSERT INTO public.europe_data VALUES (147, 19, 1884, 80.98, 187, 402);
INSERT INTO public.europe_data VALUES (148, 11, 1480, 54.95, 129, 402);
INSERT INTO public.europe_data VALUES (149, 365, 12387, 11.64, 130, 402);
INSERT INTO public.europe_data VALUES (150, 50, 3973, 154.65, 131, 402);
INSERT INTO public.europe_data VALUES (151, 172, 8221, 526.56, 90, 402);
INSERT INTO public.europe_data VALUES (152, 0, 18, 0.38, 211, 402);
INSERT INTO public.europe_data VALUES (153, 86, 4861, 157.1, 91, 402);
INSERT INTO public.europe_data VALUES (154, 1404, 43703, 227.35, 92, 402);
INSERT INTO public.europe_data VALUES (155, 507, 11999, 23.16, 132, 402);
INSERT INTO public.europe_data VALUES (156, 1779, 35266, 196.12, 188, 402);
INSERT INTO public.europe_data VALUES (157, 2036, 83208, 1652.47, 189, 402);
INSERT INTO public.europe_data VALUES (158, 58, 5521, 448.32, 93, 402);
INSERT INTO public.europe_data VALUES (159, 0, 2316, 135.27, 133, 402);
INSERT INTO public.europe_data VALUES (160, 561, 17495, 179.78, 190, 402);
INSERT INTO public.europe_data VALUES (161, 3701, 129397, 189.91, 191, 402);
INSERT INTO public.europe_data VALUES (162, 24, 2484, 35.06, 40, 402);
INSERT INTO public.europe_data VALUES (163, 0, 3, 5.68, 94, 402);
INSERT INTO public.europe_data VALUES (164, 2, 490, 437.65, 95, 402);
INSERT INTO public.europe_data VALUES (165, 0, 205, 413.23, 96, 402);
INSERT INTO public.europe_data VALUES (166, 2, 151, 690.8, 192, 402);
INSERT INTO public.europe_data VALUES (167, 0, 58, 48.83, 41, 402);
INSERT INTO public.europe_data VALUES (168, 23, 1703, 9.18, 134, 402);
INSERT INTO public.europe_data VALUES (169, 56, 1934, 22.72, 42, 402);
INSERT INTO public.europe_data VALUES (170, 134, 11660, 326.4, 193, 402);
INSERT INTO public.europe_data VALUES (171, 2, 154, 529.97, 43, 402);
INSERT INTO public.europe_data VALUES (172, 2, 461, 8.04, 44, 402);
INSERT INTO public.europe_data VALUES (173, 0, 228, 7.29, 135, 402);
INSERT INTO public.europe_data VALUES (174, 0, 112, 504.85, 97, 402);
INSERT INTO public.europe_data VALUES (175, 574, 12886, 468.37, 194, 402);
INSERT INTO public.europe_data VALUES (176, 171, 8334, 818.83, 195, 402);
INSERT INTO public.europe_data VALUES (177, 0, 0, 0, 212, 402);
INSERT INTO public.europe_data VALUES (178, 0, 30, 0.26, 45, 402);
INSERT INTO public.europe_data VALUES (179, 3525, 43323, 202.16, 46, 402);
INSERT INTO public.europe_data VALUES (180, 65, 2987, 11.28, 136, 402);
INSERT INTO public.europe_data VALUES (181, 0, 249, 3.32, 47, 402);
INSERT INTO public.europe_data VALUES (182, 2873, 229423, 1036.18, 196, 402);
INSERT INTO public.europe_data VALUES (183, 33, 5727, 52.03, 137, 402);
INSERT INTO public.europe_data VALUES (184, 85, 927, 14.33, 48, 402);
INSERT INTO public.europe_data VALUES (185, 7, 337, 141.91, 98, 402);
INSERT INTO public.europe_data VALUES (186, 89, 20683, 429.49, 197, 402);
INSERT INTO public.europe_data VALUES (187, 295, 11451, 293.24, 198, 402);
INSERT INTO public.europe_data VALUES (188, 36, 420, 5.93, 138, 402);
INSERT INTO public.europe_data VALUES (189, 1, 23, 0.21, 139, 402);
INSERT INTO public.europe_data VALUES (190, 0, 0, 0, 140, 402);
INSERT INTO public.europe_data VALUES (191, 2, 5931, 10.33, 141, 402);
INSERT INTO public.europe_data VALUES (192, 0, 3, 1.39, 142, 402);
INSERT INTO public.europe_data VALUES (193, 3, 430, 9.77, 49, 402);
INSERT INTO public.europe_data VALUES (194, 0, 74, 12.26, 99, 402);
INSERT INTO public.europe_data VALUES (195, 515, 11409, 240.79, 50, 402);
INSERT INTO public.europe_data VALUES (196, 920, 47858, 110.19, 199, 402);
INSERT INTO public.europe_data VALUES (197, 2, 217, 1044.67, 100, 402);
INSERT INTO public.europe_data VALUES (198, 7, 418, 3.44, 51, 402);
INSERT INTO public.europe_data VALUES (199, 1010, 29551, 136.75, 200, 402);
INSERT INTO public.europe_data VALUES (200, 58, 25654, 515.3, 143, 402);
INSERT INTO public.europe_data VALUES (201, 8219, 169713, 632.01, 201, 402);
INSERT INTO public.europe_data VALUES (202, 0, 0, 0, 52, 402);
INSERT INTO public.europe_data VALUES (203, 22226, 1024054, 724.12, 101, 402);
INSERT INTO public.europe_data VALUES (204, 0, 71, 153.95, 102, 402);
INSERT INTO public.europe_data VALUES (205, 54, 4087, 267.64, 103, 402);
INSERT INTO public.europe_data VALUES (206, 0, 326, 2.18, 144, 402);
INSERT INTO public.europe_data VALUES (207, 0, 0, 0, 213, 402);
INSERT INTO public.europe_data VALUES (208, 41, 3218, 22.73, 104, 402);
INSERT INTO public.europe_data VALUES (209, 0, 271, 0.29, 145, 402);
INSERT INTO public.europe_data VALUES (210, 0, 1, 0, 214, 402);
INSERT INTO public.europe_data VALUES (211, 0, 0, 0, 53, 402);
INSERT INTO public.europe_data VALUES (212, 0, 3, 0.03, 146, 402);
INSERT INTO public.europe_data VALUES (213, 120, 8896, 94.26, 54, 402);
INSERT INTO public.europe_data VALUES (214, 229, 2228, 43.32, 55, 402);
INSERT INTO public.europe_data VALUES (215, 43, 713, 3.34, 105, 403);
INSERT INTO public.europe_data VALUES (216, 38, 4584, 303.2, 147, 403);
INSERT INTO public.europe_data VALUES (217, 27, 1763, 8.02, 1, 403);
INSERT INTO public.europe_data VALUES (218, 5, 466, 1138.14, 148, 403);
INSERT INTO public.europe_data VALUES (219, 23, 524, 3.79, 2, 403);
INSERT INTO public.europe_data VALUES (220, 0, 1, 6.72, 56, 403);
INSERT INTO public.europe_data VALUES (221, 0, 12, 25.74, 57, 403);
INSERT INTO public.europe_data VALUES (222, 1202, 67388, 321.29, 58, 403);
INSERT INTO public.europe_data VALUES (223, 49, 1418, 128.68, 149, 403);
INSERT INTO public.europe_data VALUES (224, 5, 307, 633.99, 59, 403);
INSERT INTO public.europe_data VALUES (225, 0, 58, 0.6, 202, 403);
INSERT INTO public.europe_data VALUES (226, 348, 10421, 246.39, 150, 403);
INSERT INTO public.europe_data VALUES (227, 71, 1641, 41.85, 151, 403);
INSERT INTO public.europe_data VALUES (228, 0, 66, 33.12, 60, 403);
INSERT INTO public.europe_data VALUES (229, 7, 1849, 237.51, 106, 403);
INSERT INTO public.europe_data VALUES (230, 117, 4167, 5.73, 107, 403);
INSERT INTO public.europe_data VALUES (231, 3, 306, 180.13, 61, 403);
INSERT INTO public.europe_data VALUES (232, 58, 10251, 249.86, 152, 403);
INSERT INTO public.europe_data VALUES (233, 373, 15206, 253.6, 153, 403);
INSERT INTO public.europe_data VALUES (234, 12, 262, 119.64, 62, 403);
INSERT INTO public.europe_data VALUES (235, 2, 230, 2.87, 3, 403);
INSERT INTO public.europe_data VALUES (236, 0, 3, 47.99, 63, 403);
INSERT INTO public.europe_data VALUES (237, 0, 13, 5.5, 108, 403);
INSERT INTO public.europe_data VALUES (238, 415, 15635, 251.21, 64, 403);
INSERT INTO public.europe_data VALUES (239, 0, 17, 184.74, 65, 403);
INSERT INTO public.europe_data VALUES (240, 107, 2060, 132.84, 154, 403);
INSERT INTO public.europe_data VALUES (241, 34, 2289, 156.44, 4, 403);
INSERT INTO public.europe_data VALUES (242, 7365, 359623, 350.52, 66, 403);
INSERT INTO public.europe_data VALUES (243, 0, 16, 133.19, 67, 403);
INSERT INTO public.europe_data VALUES (244, 0, 1, 0.46, 109, 403);
INSERT INTO public.europe_data VALUES (245, 337, 3004, 90.09, 155, 403);
INSERT INTO public.europe_data VALUES (246, 15, 915, 9, 5, 403);
INSERT INTO public.europe_data VALUES (247, 0, 243, 3.99, 6, 403);
INSERT INTO public.europe_data VALUES (248, 0, 17, 0.41, 110, 403);
INSERT INTO public.europe_data VALUES (249, 7, 1607, 10.7, 7, 403);
INSERT INTO public.europe_data VALUES (250, 1118, 37939, 226.75, 68, 403);
INSERT INTO public.europe_data VALUES (251, 11, 496, 192.02, 8, 403);
INSERT INTO public.europe_data VALUES (252, 0, 3, 32.33, 69, 403);
INSERT INTO public.europe_data VALUES (253, 0, 6, 0.15, 9, 403);
INSERT INTO public.europe_data VALUES (254, 5, 266, 3.91, 10, 403);
INSERT INTO public.europe_data VALUES (255, 452, 29428, 302.27, 70, 403);
INSERT INTO public.europe_data VALUES (256, 7, 1308, 0.17, 111, 403);
INSERT INTO public.europe_data VALUES (257, 2743, 104614, 448.64, 71, 403);
INSERT INTO public.europe_data VALUES (258, 26, 676, 130.22, 11, 403);
INSERT INTO public.europe_data VALUES (259, 3, 85, 10.72, 12, 403);
INSERT INTO public.europe_data VALUES (260, 100, 4729, 211.67, 72, 403);
INSERT INTO public.europe_data VALUES (261, 5, 1609, 12.05, 13, 403);
INSERT INTO public.europe_data VALUES (262, 204, 3926, 216.65, 156, 403);
INSERT INTO public.europe_data VALUES (263, 24, 3385, 60.18, 73, 403);
INSERT INTO public.europe_data VALUES (264, 1, 28, 51.4, 74, 403);
INSERT INTO public.europe_data VALUES (265, 16, 1049, 304.49, 157, 403);
INSERT INTO public.europe_data VALUES (266, 1004, 48152, 981.71, 158, 403);
INSERT INTO public.europe_data VALUES (267, 28, 895, 2.83, 14, 403);
INSERT INTO public.europe_data VALUES (268, 205, 5401, 216.51, 159, 403);
INSERT INTO public.europe_data VALUES (269, 0, 14, 4.93, 15, 403);
INSERT INTO public.europe_data VALUES (270, 0, 0, 5.57, 75, 403);
INSERT INTO public.europe_data VALUES (271, 97, 10196, 203.74, 76, 403);
INSERT INTO public.europe_data VALUES (272, 317, 9923, 115.47, 77, 403);
INSERT INTO public.europe_data VALUES (273, 376, 5420, 11.98, 16, 403);
INSERT INTO public.europe_data VALUES (274, 85, 2042, 70.88, 78, 403);
INSERT INTO public.europe_data VALUES (275, 0, 89, 11.65, 17, 403);
INSERT INTO public.europe_data VALUES (276, 1, 73, 11.27, 18, 403);
INSERT INTO public.europe_data VALUES (277, 43, 3372, 521.66, 160, 403);
INSERT INTO public.europe_data VALUES (278, 0, 0, 107.39, 19, 403);
INSERT INTO public.europe_data VALUES (279, 36, 2572, 4.6, 20, 403);
INSERT INTO public.europe_data VALUES (280, 0, 5, 237.25, 79, 403);
INSERT INTO public.europe_data VALUES (281, 0, 3, 12.33, 161, 403);
INSERT INTO public.europe_data VALUES (282, 0, 0, 0.22, 203, 403);
INSERT INTO public.europe_data VALUES (283, 34, 2243, 72.31, 162, 403);
INSERT INTO public.europe_data VALUES (284, 2766, 142628, 403.45, 163, 403);
INSERT INTO public.europe_data VALUES (285, 0, 0, 141.07, 204, 403);
INSERT INTO public.europe_data VALUES (286, 1, 512, 30.88, 21, 403);
INSERT INTO public.europe_data VALUES (287, 1, 98, 5.62, 22, 403);
INSERT INTO public.europe_data VALUES (288, 113, 5901, 351.18, 164, 403);
INSERT INTO public.europe_data VALUES (289, 5454, 101006, 265.77, 165, 403);
INSERT INTO public.europe_data VALUES (290, 26, 4421, 19.41, 23, 403);
INSERT INTO public.europe_data VALUES (291, 20, 296, 2361.6, 166, 403);
INSERT INTO public.europe_data VALUES (292, 177, 3373, 67.53, 167, 403);
INSERT INTO public.europe_data VALUES (293, 0, 0, 5.29, 80, 403);
INSERT INTO public.europe_data VALUES (294, 0, 9, 11.61, 81, 403);
INSERT INTO public.europe_data VALUES (295, 1, 69, 78.3, 205, 403);
INSERT INTO public.europe_data VALUES (296, 191, 5284, 64.03, 82, 403);
INSERT INTO public.europe_data VALUES (297, 0, 12, 24.82, 168, 403);
INSERT INTO public.europe_data VALUES (298, 1, 207, 3.05, 24, 403);
INSERT INTO public.europe_data VALUES (299, 0, 23, 2.81, 25, 403);
INSERT INTO public.europe_data VALUES (300, 2, 409, 71.92, 83, 403);
INSERT INTO public.europe_data VALUES (301, 3, 379, 9, 84, 403);
INSERT INTO public.europe_data VALUES (302, 0, 0, 0, 169, 403);
INSERT INTO public.europe_data VALUES (303, 108, 7873, 144.05, 85, 403);
INSERT INTO public.europe_data VALUES (304, 615, 7715, 171.52, 170, 403);
INSERT INTO public.europe_data VALUES (305, 0, 20, 25.77, 171, 403);
INSERT INTO public.europe_data VALUES (306, 1051, 95963, 14.72, 112, 403);
INSERT INTO public.europe_data VALUES (307, 1848, 81333, 59.58, 113, 403);
INSERT INTO public.europe_data VALUES (308, 580, 42566, 104.41, 114, 403);
INSERT INTO public.europe_data VALUES (309, 49, 5531, 39.16, 115, 403);
INSERT INTO public.europe_data VALUES (310, 362, 14828, 814.42, 172, 403);
INSERT INTO public.europe_data VALUES (311, 0, 4, 42.56, 173, 403);
INSERT INTO public.europe_data VALUES (312, 432, 49380, 1244.29, 116, 403);
INSERT INTO public.europe_data VALUES (313, 3284, 85536, 315.31, 174, 403);
INSERT INTO public.europe_data VALUES (314, 12, 738, 46.64, 86, 403);
INSERT INTO public.europe_data VALUES (315, 518, 32367, 58.26, 117, 403);
INSERT INTO public.europe_data VALUES (316, 1, 68, 139.15, 175, 403);
INSERT INTO public.europe_data VALUES (317, 71, 4909, 116.64, 118, 403);
INSERT INTO public.europe_data VALUES (318, 67, 8927, 85.2, 119, 403);
INSERT INTO public.europe_data VALUES (319, 13, 890, 3.39, 26, 403);
INSERT INTO public.europe_data VALUES (320, 46, 2237, 239.75, 176, 403);
INSERT INTO public.europe_data VALUES (321, 5, 3508, 165.7, 120, 403);
INSERT INTO public.europe_data VALUES (322, 14, 793, 24.8, 121, 403);
INSERT INTO public.europe_data VALUES (323, 0, 3, 0.04, 122, 403);
INSERT INTO public.europe_data VALUES (324, 133, 5344, 595.84, 177, 403);
INSERT INTO public.europe_data VALUES (325, 455, 26785, 879.57, 123, 403);
INSERT INTO public.europe_data VALUES (326, 30, 1285, 80.88, 27, 403);
INSERT INTO public.europe_data VALUES (327, 0, 27, 2.31, 28, 403);
INSERT INTO public.europe_data VALUES (328, 91, 5430, 146.38, 29, 403);
INSERT INTO public.europe_data VALUES (329, 2, 59, 281.41, 178, 403);
INSERT INTO public.europe_data VALUES (330, 195, 9174, 598.39, 179, 403);
INSERT INTO public.europe_data VALUES (331, 12, 852, 280.18, 180, 403);
INSERT INTO public.europe_data VALUES (332, 6, 442, 2.75, 30, 403);
INSERT INTO public.europe_data VALUES (333, 204, 7517, 61.26, 31, 403);
INSERT INTO public.europe_data VALUES (334, 77, 25367, 149.64, 124, 403);
INSERT INTO public.europe_data VALUES (335, 2, 480, 166.49, 125, 403);
INSERT INTO public.europe_data VALUES (336, 11, 144, 1.95, 32, 403);
INSERT INTO public.europe_data VALUES (337, 12, 1119, 472.49, 181, 403);
INSERT INTO public.europe_data VALUES (338, 0, 0, 0, 206, 403);
INSERT INTO public.europe_data VALUES (339, 11, 358, 19.55, 33, 403);
INSERT INTO public.europe_data VALUES (340, 0, 21, 1.81, 34, 403);
INSERT INTO public.europe_data VALUES (341, 9025, 122238, 180.37, 87, 403);
INSERT INTO public.europe_data VALUES (342, 0, 0, 0, 207, 403);
INSERT INTO public.europe_data VALUES (343, 111, 3348, 168.45, 182, 403);
INSERT INTO public.europe_data VALUES (344, 0, 152, 906.76, 183, 403);
INSERT INTO public.europe_data VALUES (345, 0, 117, 6.23, 126, 403);
INSERT INTO public.europe_data VALUES (346, 23, 2823, 945.86, 184, 403);
INSERT INTO public.europe_data VALUES (347, 0, 0, 0, 88, 403);
INSERT INTO public.europe_data VALUES (348, 208, 6618, 37.72, 35, 403);
INSERT INTO public.europe_data VALUES (349, 122, 6230, 34.4, 36, 403);
INSERT INTO public.europe_data VALUES (350, 107, 3256, 12.9, 127, 403);
INSERT INTO public.europe_data VALUES (351, 34, 2062, 153.26, 37, 403);
INSERT INTO public.europe_data VALUES (352, 42, 2128, 16.32, 128, 403);
INSERT INTO public.europe_data VALUES (353, 522, 35590, 431.41, 185, 403);
INSERT INTO public.europe_data VALUES (354, 0, 0, 1.41, 208, 403);
INSERT INTO public.europe_data VALUES (355, 0, 26, 1.38, 209, 403);
INSERT INTO public.europe_data VALUES (356, 1, 52, 1.63, 89, 403);
INSERT INTO public.europe_data VALUES (357, 11, 197, 2.04, 38, 403);
INSERT INTO public.europe_data VALUES (358, 72, 12609, 11.4, 39, 403);
INSERT INTO public.europe_data VALUES (359, 83, 1716, 200.28, 186, 403);
INSERT INTO public.europe_data VALUES (360, 0, 1, 6.99, 210, 403);
INSERT INTO public.europe_data VALUES (361, 27, 2431, 105.27, 187, 403);
INSERT INTO public.europe_data VALUES (362, 9, 1254, 45.51, 129, 403);
INSERT INTO public.europe_data VALUES (363, 321, 12830, 13.74, 130, 403);
INSERT INTO public.europe_data VALUES (364, 90, 3731, 180.61, 131, 403);
INSERT INTO public.europe_data VALUES (365, 311, 14139, 776.23, 90, 403);
INSERT INTO public.europe_data VALUES (366, 0, 15, 0.43, 211, 403);
INSERT INTO public.europe_data VALUES (367, 127, 6206, 179.33, 91, 403);
INSERT INTO public.europe_data VALUES (368, 846, 30211, 189.67, 92, 403);
INSERT INTO public.europe_data VALUES (369, 347, 13042, 23.98, 132, 403);
INSERT INTO public.europe_data VALUES (370, 1994, 39205, 231.04, 188, 403);
INSERT INTO public.europe_data VALUES (371, 1693, 86610, 1496.8, 189, 403);
INSERT INTO public.europe_data VALUES (372, 75, 7630, 532.08, 93, 403);
INSERT INTO public.europe_data VALUES (373, 0, 1515, 104.2, 133, 403);
INSERT INTO public.europe_data VALUES (374, 570, 17408, 202.37, 190, 403);
INSERT INTO public.europe_data VALUES (375, 3881, 147624, 214.86, 191, 403);
INSERT INTO public.europe_data VALUES (376, 32, 1943, 26.49, 40, 403);
INSERT INTO public.europe_data VALUES (377, 0, 0, 1.89, 94, 403);
INSERT INTO public.europe_data VALUES (378, 5, 310, 264.23, 95, 403);
INSERT INTO public.europe_data VALUES (379, 1, 252, 449.4, 96, 403);
INSERT INTO public.europe_data VALUES (380, 0, 87, 600.82, 192, 403);
INSERT INTO public.europe_data VALUES (381, 0, 47, 57.2, 41, 403);
INSERT INTO public.europe_data VALUES (382, 29, 1442, 7.48, 134, 403);
INSERT INTO public.europe_data VALUES (383, 56, 1769, 21.23, 42, 403);
INSERT INTO public.europe_data VALUES (384, 136, 11070, 343.41, 193, 403);
INSERT INTO public.europe_data VALUES (385, 1, 364, 550.43, 43, 403);
INSERT INTO public.europe_data VALUES (386, 0, 167, 4.19, 44, 403);
INSERT INTO public.europe_data VALUES (387, 0, 195, 6.91, 135, 403);
INSERT INTO public.europe_data VALUES (388, 0, 102, 431.72, 97, 403);
INSERT INTO public.europe_data VALUES (389, 542, 12642, 512.95, 194, 403);
INSERT INTO public.europe_data VALUES (390, 210, 8705, 885.48, 195, 403);
INSERT INTO public.europe_data VALUES (391, 0, 0, 0, 212, 403);
INSERT INTO public.europe_data VALUES (392, 0, 10, 0.18, 45, 403);
INSERT INTO public.europe_data VALUES (393, 3769, 75060, 309.76, 46, 403);
INSERT INTO public.europe_data VALUES (394, 96, 2792, 12.51, 136, 403);
INSERT INTO public.europe_data VALUES (395, 1, 118, 1.14, 47, 403);
INSERT INTO public.europe_data VALUES (396, 2439, 256931, 1026.05, 196, 403);
INSERT INTO public.europe_data VALUES (397, 19, 5368, 47.13, 137, 403);
INSERT INTO public.europe_data VALUES (398, 254, 5206, 12.16, 48, 403);
INSERT INTO public.europe_data VALUES (399, 4, 488, 180.27, 98, 403);
INSERT INTO public.europe_data VALUES (400, 400, 23255, 510.37, 197, 403);
INSERT INTO public.europe_data VALUES (401, 337, 13605, 339.2, 198, 403);
INSERT INTO public.europe_data VALUES (402, 53, 592, 7.4, 138, 403);
INSERT INTO public.europe_data VALUES (403, 0, 27, 0.23, 139, 403);
INSERT INTO public.europe_data VALUES (404, 0, 0, 0, 140, 403);
INSERT INTO public.europe_data VALUES (405, 5, 1264, 4.51, 141, 403);
INSERT INTO public.europe_data VALUES (406, 0, 15, 1.39, 142, 403);
INSERT INTO public.europe_data VALUES (407, 3, 360, 8.72, 49, 403);
INSERT INTO public.europe_data VALUES (408, 2, 97, 16.13, 99, 403);
INSERT INTO public.europe_data VALUES (409, 537, 16751, 310.28, 50, 403);
INSERT INTO public.europe_data VALUES (410, 1076, 42504, 126.03, 199, 403);
INSERT INTO public.europe_data VALUES (411, 0, 182, 767.14, 100, 403);
INSERT INTO public.europe_data VALUES (412, 14, 1103, 3.12, 51, 403);
INSERT INTO public.europe_data VALUES (413, 1055, 30612, 170.51, 200, 403);
INSERT INTO public.europe_data VALUES (414, 47, 24694, 460.29, 143, 403);
INSERT INTO public.europe_data VALUES (415, 8678, 251504, 862.92, 201, 403);
INSERT INTO public.europe_data VALUES (416, 0, 0, 0, 52, 403);
INSERT INTO public.europe_data VALUES (417, 23518, 1358783, 873.4, 101, 403);
INSERT INTO public.europe_data VALUES (418, 0, 90, 175.94, 102, 403);
INSERT INTO public.europe_data VALUES (419, 71, 5178, 321.8, 103, 403);
INSERT INTO public.europe_data VALUES (420, 2, 393, 2.48, 144, 403);
INSERT INTO public.europe_data VALUES (421, 0, 0, 0, 213, 403);
INSERT INTO public.europe_data VALUES (422, 36, 3265, 23.59, 104, 403);
INSERT INTO public.europe_data VALUES (423, 0, 9, 0.04, 145, 403);
INSERT INTO public.europe_data VALUES (424, 0, 0, 0, 214, 403);
INSERT INTO public.europe_data VALUES (425, 0, 0, 0, 53, 403);
INSERT INTO public.europe_data VALUES (426, 3, 6, 0.05, 146, 403);
INSERT INTO public.europe_data VALUES (427, 101, 7939, 98.26, 54, 403);
INSERT INTO public.europe_data VALUES (428, 292, 4117, 67.21, 55, 403);
INSERT INTO public.europe_data VALUES (429, 45, 557, 3.24, 105, 404);
INSERT INTO public.europe_data VALUES (430, 36, 4095, 288.29, 147, 404);
INSERT INTO public.europe_data VALUES (431, 29, 1689, 7.96, 1, 404);
INSERT INTO public.europe_data VALUES (432, 5, 401, 1169.64, 148, 404);
INSERT INTO public.europe_data VALUES (433, 20, 682, 3.87, 2, 404);
INSERT INTO public.europe_data VALUES (434, 0, 0, 0, 56, 404);
INSERT INTO public.europe_data VALUES (435, 0, 13, 29.86, 57, 404);
INSERT INTO public.europe_data VALUES (436, 1178, 76488, 372.24, 58, 404);
INSERT INTO public.europe_data VALUES (437, 67, 2388, 150.66, 149, 404);
INSERT INTO public.europe_data VALUES (438, 0, 367, 819.3, 59, 404);
INSERT INTO public.europe_data VALUES (439, 0, 94, 0.81, 202, 404);
INSERT INTO public.europe_data VALUES (440, 383, 11406, 299.58, 150, 404);
INSERT INTO public.europe_data VALUES (441, 96, 2564, 70.92, 151, 404);
INSERT INTO public.europe_data VALUES (442, 0, 63, 36.72, 60, 404);
INSERT INTO public.europe_data VALUES (443, 4, 2049, 251.59, 106, 404);
INSERT INTO public.europe_data VALUES (444, 125, 5179, 7.12, 107, 404);
INSERT INTO public.europe_data VALUES (445, 0, 211, 170.37, 61, 404);
INSERT INTO public.europe_data VALUES (446, 65, 13367, 289.85, 152, 404);
INSERT INTO public.europe_data VALUES (447, 344, 13845, 249.23, 153, 404);
INSERT INTO public.europe_data VALUES (448, 7, 205, 155.5, 62, 404);
INSERT INTO public.europe_data VALUES (449, 2, 109, 1.37, 3, 404);
INSERT INTO public.europe_data VALUES (450, 0, 27, 97.59, 63, 404);
INSERT INTO public.europe_data VALUES (451, 0, 29, 16.51, 108, 404);
INSERT INTO public.europe_data VALUES (452, 260, 13287, 212.99, 64, 404);
INSERT INTO public.europe_data VALUES (453, 0, 31, 477.24, 65, 404);
INSERT INTO public.europe_data VALUES (454, 128, 2325, 164.74, 154, 404);
INSERT INTO public.europe_data VALUES (455, 23, 1315, 112.86, 4, 404);
INSERT INTO public.europe_data VALUES (456, 6719, 380158, 368.65, 66, 404);
INSERT INTO public.europe_data VALUES (457, 0, 24, 79.91, 67, 404);
INSERT INTO public.europe_data VALUES (458, 0, 1, 0.46, 109, 404);
INSERT INTO public.europe_data VALUES (459, 357, 3302, 125.17, 155, 404);
INSERT INTO public.europe_data VALUES (460, 13, 913, 10.52, 5, 404);
INSERT INTO public.europe_data VALUES (461, 0, 217, 3.5, 6, 404);
INSERT INTO public.europe_data VALUES (462, 0, 50, 0.36, 110, 404);
INSERT INTO public.europe_data VALUES (463, 7, 1162, 4.49, 7, 404);
INSERT INTO public.europe_data VALUES (464, 1034, 46891, 303.14, 68, 404);
INSERT INTO public.europe_data VALUES (465, 4, 560, 195.11, 8, 404);
INSERT INTO public.europe_data VALUES (466, 0, 18, 50.81, 69, 404);
INSERT INTO public.europe_data VALUES (467, 0, 1, 0.23, 9, 404);
INSERT INTO public.europe_data VALUES (468, 4, 358, 4.28, 10, 404);
INSERT INTO public.europe_data VALUES (469, 385, 27858, 293.16, 70, 404);
INSERT INTO public.europe_data VALUES (470, 10, 1115, 0.12, 111, 404);
INSERT INTO public.europe_data VALUES (471, 2553, 121229, 491.29, 71, 404);
INSERT INTO public.europe_data VALUES (472, 27, 432, 85.56, 11, 404);
INSERT INTO public.europe_data VALUES (473, 6, 492, 11.19, 12, 404);
INSERT INTO public.europe_data VALUES (474, 105, 5955, 269.04, 72, 404);
INSERT INTO public.europe_data VALUES (475, 2, 1491, 10.08, 13, 404);
INSERT INTO public.europe_data VALUES (476, 252, 4905, 298.56, 156, 404);
INSERT INTO public.europe_data VALUES (477, 20, 3436, 50.32, 73, 404);
INSERT INTO public.europe_data VALUES (478, 0, 56, 124.22, 74, 404);
INSERT INTO public.europe_data VALUES (479, 22, 1618, 570.16, 157, 404);
INSERT INTO public.europe_data VALUES (480, 1177, 56398, 1362.82, 158, 404);
INSERT INTO public.europe_data VALUES (481, 15, 1564, 3.35, 14, 404);
INSERT INTO public.europe_data VALUES (482, 208, 7170, 364.86, 159, 404);
INSERT INTO public.europe_data VALUES (483, 0, 34, 6.47, 15, 404);
INSERT INTO public.europe_data VALUES (484, 0, 4, 23.67, 75, 404);
INSERT INTO public.europe_data VALUES (485, 21, 11684, 201.46, 76, 404);
INSERT INTO public.europe_data VALUES (486, 138, 10138, 98.02, 77, 404);
INSERT INTO public.europe_data VALUES (487, 386, 6605, 14.16, 16, 404);
INSERT INTO public.europe_data VALUES (488, 70, 2532, 67.4, 78, 404);
INSERT INTO public.europe_data VALUES (489, 0, 69, 6.34, 17, 404);
INSERT INTO public.europe_data VALUES (490, 0, 321, 14.7, 18, 404);
INSERT INTO public.europe_data VALUES (491, 46, 3539, 590.5, 160, 404);
INSERT INTO public.europe_data VALUES (492, 78, 1233, 261.38, 19, 404);
INSERT INTO public.europe_data VALUES (493, 27, 2579, 4.97, 20, 404);
INSERT INTO public.europe_data VALUES (494, 0, 3, 88.97, 79, 404);
INSERT INTO public.europe_data VALUES (495, 0, 3, 59.58, 161, 404);
INSERT INTO public.europe_data VALUES (496, 0, 2, 0.67, 203, 404);
INSERT INTO public.europe_data VALUES (497, 24, 1747, 61.94, 162, 404);
INSERT INTO public.europe_data VALUES (498, 2533, 127733, 380.91, 163, 404);
INSERT INTO public.europe_data VALUES (499, 4, 394, 253.86, 204, 404);
INSERT INTO public.europe_data VALUES (500, 0, 159, 13.53, 21, 404);
INSERT INTO public.europe_data VALUES (501, 2, 34, 4.43, 22, 404);
INSERT INTO public.europe_data VALUES (502, 162, 8135, 454.17, 164, 404);
INSERT INTO public.europe_data VALUES (503, 5947, 119635, 319.38, 165, 404);
INSERT INTO public.europe_data VALUES (504, 8, 1484, 8.37, 23, 404);
INSERT INTO public.europe_data VALUES (505, 27, 500, 3750.07, 166, 404);
INSERT INTO public.europe_data VALUES (506, 206, 3869, 79.33, 167, 404);
INSERT INTO public.europe_data VALUES (507, 0, 3, 5.29, 80, 404);
INSERT INTO public.europe_data VALUES (508, 0, 4, 4.46, 81, 404);
INSERT INTO public.europe_data VALUES (509, 4, 62, 94.44, 205, 404);
INSERT INTO public.europe_data VALUES (510, 228, 5973, 59.67, 82, 404);
INSERT INTO public.europe_data VALUES (511, 0, 4, 13.96, 168, 404);
INSERT INTO public.europe_data VALUES (512, 0, 183, 2.92, 24, 404);
INSERT INTO public.europe_data VALUES (513, 0, 31, 3.23, 25, 404);
INSERT INTO public.europe_data VALUES (514, 1, 154, 70.26, 83, 404);
INSERT INTO public.europe_data VALUES (515, 2, 635, 6.93, 84, 404);
INSERT INTO public.europe_data VALUES (516, 0, 0, 0, 169, 404);
INSERT INTO public.europe_data VALUES (517, 81, 6166, 110.22, 85, 404);
INSERT INTO public.europe_data VALUES (518, 684, 9047, 244.07, 170, 404);
INSERT INTO public.europe_data VALUES (519, 0, 72, 60.51, 171, 404);
INSERT INTO public.europe_data VALUES (520, 1259, 105178, 16.93, 112, 404);
INSERT INTO public.europe_data VALUES (521, 1858, 79903, 55.23, 113, 404);
INSERT INTO public.europe_data VALUES (522, 632, 44005, 104.9, 114, 404);
INSERT INTO public.europe_data VALUES (523, 100, 9863, 25.09, 115, 404);
INSERT INTO public.europe_data VALUES (524, 264, 25113, 1444.44, 172, 404);
INSERT INTO public.europe_data VALUES (525, 0, 32, 56.74, 173, 404);
INSERT INTO public.europe_data VALUES (526, 316, 56626, 1285.33, 116, 404);
INSERT INTO public.europe_data VALUES (527, 3422, 104786, 374.14, 174, 404);
INSERT INTO public.europe_data VALUES (528, 13, 637, 41.55, 86, 404);
INSERT INTO public.europe_data VALUES (529, 457, 41542, 66.57, 117, 404);
INSERT INTO public.europe_data VALUES (530, 5, 82, 216.15, 175, 404);
INSERT INTO public.europe_data VALUES (531, 110, 6874, 171.61, 118, 404);
INSERT INTO public.europe_data VALUES (532, 16, 6878, 53.34, 119, 404);
INSERT INTO public.europe_data VALUES (533, 18, 891, 4.49, 26, 404);
INSERT INTO public.europe_data VALUES (534, 33, 2075, 216.07, 176, 404);
INSERT INTO public.europe_data VALUES (535, 4, 3463, 152.93, 120, 404);
INSERT INTO public.europe_data VALUES (536, 16, 798, 27.9, 121, 404);
INSERT INTO public.europe_data VALUES (537, 0, 0, 0, 122, 404);
INSERT INTO public.europe_data VALUES (538, 129, 6096, 685.79, 177, 404);
INSERT INTO public.europe_data VALUES (539, 259, 33516, 926.73, 123, 404);
INSERT INTO public.europe_data VALUES (540, 8, 434, 148.92, 27, 404);
INSERT INTO public.europe_data VALUES (541, 1, 87, 1.76, 28, 404);
INSERT INTO public.europe_data VALUES (542, 109, 4491, 116.47, 29, 404);
INSERT INTO public.europe_data VALUES (543, 1, 49, 450.78, 178, 404);
INSERT INTO public.europe_data VALUES (544, 237, 7546, 715.95, 179, 404);
INSERT INTO public.europe_data VALUES (545, 19, 868, 314.88, 180, 404);
INSERT INTO public.europe_data VALUES (546, 6, 300, 1.98, 30, 404);
INSERT INTO public.europe_data VALUES (547, 89, 3895, 30.2, 31, 404);
INSERT INTO public.europe_data VALUES (548, 50, 22442, 117.73, 124, 404);
INSERT INTO public.europe_data VALUES (549, 0, 404, 121.67, 125, 404);
INSERT INTO public.europe_data VALUES (550, 13, 239, 2.98, 32, 404);
INSERT INTO public.europe_data VALUES (551, 7, 1213, 508.96, 181, 404);
INSERT INTO public.europe_data VALUES (552, 0, 0, 0, 206, 404);
INSERT INTO public.europe_data VALUES (553, 21, 527, 27.51, 33, 404);
INSERT INTO public.europe_data VALUES (554, 0, 2, 1.26, 34, 404);
INSERT INTO public.europe_data VALUES (555, 6880, 107869, 157.36, 87, 404);
INSERT INTO public.europe_data VALUES (556, 0, 0, 0, 207, 404);
INSERT INTO public.europe_data VALUES (557, 111, 3463, 172.66, 182, 404);
INSERT INTO public.europe_data VALUES (558, 5, 148, 900.71, 183, 404);
INSERT INTO public.europe_data VALUES (559, 0, 84, 7.44, 126, 404);
INSERT INTO public.europe_data VALUES (560, 20, 3062, 1012.24, 184, 404);
INSERT INTO public.europe_data VALUES (561, 0, 0, 0, 88, 404);
INSERT INTO public.europe_data VALUES (562, 199, 7139, 45.31, 35, 404);
INSERT INTO public.europe_data VALUES (563, 44, 4217, 23.85, 36, 404);
INSERT INTO public.europe_data VALUES (564, 109, 3714, 14.75, 127, 404);
INSERT INTO public.europe_data VALUES (565, 24, 1761, 199.52, 37, 404);
INSERT INTO public.europe_data VALUES (566, 42, 2542, 19.1, 128, 404);
INSERT INTO public.europe_data VALUES (567, 645, 38967, 555.45, 185, 404);
INSERT INTO public.europe_data VALUES (568, 0, 4, 1.41, 208, 404);
INSERT INTO public.europe_data VALUES (569, 0, 40, 1.69, 209, 404);
INSERT INTO public.europe_data VALUES (570, 1, 55, 1.62, 89, 404);
INSERT INTO public.europe_data VALUES (571, 14, 279, 2.96, 38, 404);
INSERT INTO public.europe_data VALUES (572, 77, 10300, 10.1, 39, 404);
INSERT INTO public.europe_data VALUES (573, 80, 2444, 236.58, 186, 404);
INSERT INTO public.europe_data VALUES (574, 0, 3, 10.49, 210, 404);
INSERT INTO public.europe_data VALUES (575, 43, 3178, 148.94, 187, 404);
INSERT INTO public.europe_data VALUES (576, 4, 1010, 44.34, 129, 404);
INSERT INTO public.europe_data VALUES (577, 321, 16918, 15.09, 130, 404);
INSERT INTO public.europe_data VALUES (578, 125, 5266, 224.27, 131, 404);
INSERT INTO public.europe_data VALUES (579, 332, 18823, 1042.83, 90, 404);
INSERT INTO public.europe_data VALUES (580, 0, 23, 0.4, 211, 404);
INSERT INTO public.europe_data VALUES (581, 100, 6427, 185.77, 91, 404);
INSERT INTO public.europe_data VALUES (582, 596, 31452, 146.86, 92, 404);
INSERT INTO public.europe_data VALUES (583, 490, 12887, 21.06, 132, 404);
INSERT INTO public.europe_data VALUES (584, 2143, 48529, 305.39, 188, 404);
INSERT INTO public.europe_data VALUES (585, 1103, 67210, 1215.19, 189, 404);
INSERT INTO public.europe_data VALUES (586, 61, 7978, 469.69, 93, 404);
INSERT INTO public.europe_data VALUES (587, 2, 1436, 100.99, 133, 404);
INSERT INTO public.europe_data VALUES (588, 546, 21882, 281.87, 190, 404);
INSERT INTO public.europe_data VALUES (589, 3764, 165797, 226.86, 191, 404);
INSERT INTO public.europe_data VALUES (590, 22, 1402, 18.66, 40, 404);
INSERT INTO public.europe_data VALUES (591, 0, 1, 3.79, 94, 404);
INSERT INTO public.europe_data VALUES (592, 3, 173, 141.14, 95, 404);
INSERT INTO public.europe_data VALUES (593, 1, 245, 334.56, 96, 404);
INSERT INTO public.europe_data VALUES (594, 1, 120, 853.34, 192, 404);
INSERT INTO public.europe_data VALUES (595, 0, 76, 54.87, 41, 404);
INSERT INTO public.europe_data VALUES (596, 32, 1120, 5.18, 134, 404);
INSERT INTO public.europe_data VALUES (597, 57, 1691, 20.99, 42, 404);
INSERT INTO public.europe_data VALUES (598, 168, 12844, 411.6, 193, 404);
INSERT INTO public.europe_data VALUES (599, 0, 174, 417.43, 43, 404);
INSERT INTO public.europe_data VALUES (600, 0, 160, 4.26, 44, 404);
INSERT INTO public.europe_data VALUES (601, 0, 206, 7.17, 135, 404);
INSERT INTO public.europe_data VALUES (602, 0, 81, 457.67, 97, 404);
INSERT INTO public.europe_data VALUES (603, 519, 15316, 665.75, 194, 404);
INSERT INTO public.europe_data VALUES (604, 224, 9721, 1132.97, 195, 404);
INSERT INTO public.europe_data VALUES (605, 0, 0, 0, 212, 404);
INSERT INTO public.europe_data VALUES (606, 0, 18, 0.19, 45, 404);
INSERT INTO public.europe_data VALUES (607, 3942, 106329, 405.03, 46, 404);
INSERT INTO public.europe_data VALUES (608, 124, 3615, 16.53, 136, 404);
INSERT INTO public.europe_data VALUES (609, 0, 8, 0.73, 47, 404);
INSERT INTO public.europe_data VALUES (610, 1494, 224669, 804.5, 196, 404);
INSERT INTO public.europe_data VALUES (611, 32, 4682, 38.87, 137, 404);
INSERT INTO public.europe_data VALUES (612, 0, 0, 0, 48, 404);
INSERT INTO public.europe_data VALUES (613, 7, 560, 211.74, 98, 404);
INSERT INTO public.europe_data VALUES (614, 569, 28957, 668.84, 197, 404);
INSERT INTO public.europe_data VALUES (615, 392, 15378, 442.53, 198, 404);
INSERT INTO public.europe_data VALUES (616, 58, 672, 7.77, 138, 404);
INSERT INTO public.europe_data VALUES (617, 0, 28, 0.2, 139, 404);
INSERT INTO public.europe_data VALUES (618, 0, 0, 0.09, 140, 404);
INSERT INTO public.europe_data VALUES (619, 3, 1876, 5.72, 141, 404);
INSERT INTO public.europe_data VALUES (620, 0, 3, 0.62, 142, 404);
INSERT INTO public.europe_data VALUES (621, 1, 345, 7.42, 49, 404);
INSERT INTO public.europe_data VALUES (622, 4, 128, 16.13, 99, 404);
INSERT INTO public.europe_data VALUES (623, 466, 19535, 327.85, 50, 404);
INSERT INTO public.europe_data VALUES (624, 1190, 60845, 177.05, 199, 404);
INSERT INTO public.europe_data VALUES (625, 1, 111, 510.55, 100, 404);
INSERT INTO public.europe_data VALUES (626, 2, 277, 4.6, 51, 404);
INSERT INTO public.europe_data VALUES (627, 1034, 44402, 203.72, 200, 404);
INSERT INTO public.europe_data VALUES (628, 34, 20279, 394.34, 143, 404);
INSERT INTO public.europe_data VALUES (629, 7830, 323610, 1112.1, 201, 404);
INSERT INTO public.europe_data VALUES (630, 0, 0, 0, 52, 404);
INSERT INTO public.europe_data VALUES (631, 23169, 1515282, 1002.26, 101, 404);
INSERT INTO public.europe_data VALUES (632, 0, 94, 196.02, 102, 404);
INSERT INTO public.europe_data VALUES (633, 57, 5962, 347.8, 103, 404);
INSERT INTO public.europe_data VALUES (634, 2, 425, 2.36, 144, 404);
INSERT INTO public.europe_data VALUES (635, 0, 0, 0, 213, 404);
INSERT INTO public.europe_data VALUES (636, 39, 3461, 21.17, 104, 404);
INSERT INTO public.europe_data VALUES (637, 0, 25, 0.04, 145, 404);
INSERT INTO public.europe_data VALUES (638, 0, 0, 0, 214, 404);
INSERT INTO public.europe_data VALUES (639, 0, 0, 0, 53, 404);
INSERT INTO public.europe_data VALUES (640, 1, 8, 0.04, 146, 404);
INSERT INTO public.europe_data VALUES (641, 88, 9611, 90.78, 54, 404);
INSERT INTO public.europe_data VALUES (642, 206, 5726, 81.51, 55, 404);
INSERT INTO public.europe_data VALUES (643, 71, 675, 4.15, 105, 405);
INSERT INTO public.europe_data VALUES (644, 48, 4157, 245.35, 147, 405);
INSERT INTO public.europe_data VALUES (645, 35, 1736, 8.16, 1, 405);
INSERT INTO public.europe_data VALUES (646, 2, 490, 1437.44, 148, 405);
INSERT INTO public.europe_data VALUES (647, 8, 551, 2.82, 2, 405);
INSERT INTO public.europe_data VALUES (648, 0, 0, 13.45, 56, 405);
INSERT INTO public.europe_data VALUES (649, 0, 16, 18.53, 57, 405);
INSERT INTO public.europe_data VALUES (650, 1172, 90203, 313.58, 58, 405);
INSERT INTO public.europe_data VALUES (651, 67, 2068, 146.73, 149, 405);
INSERT INTO public.europe_data VALUES (652, 3, 504, 700.78, 59, 405);
INSERT INTO public.europe_data VALUES (653, 0, 110, 1.2, 202, 405);
INSERT INTO public.europe_data VALUES (654, 378, 15133, 319.69, 150, 405);
INSERT INTO public.europe_data VALUES (655, 193, 4562, 93, 151, 405);
INSERT INTO public.europe_data VALUES (656, 0, 80, 43.65, 60, 405);
INSERT INTO public.europe_data VALUES (657, 4, 2080, 233.07, 106, 405);
INSERT INTO public.europe_data VALUES (658, 155, 6434, 8.16, 107, 405);
INSERT INTO public.europe_data VALUES (659, 0, 278, 181.87, 61, 405);
INSERT INTO public.europe_data VALUES (660, 75, 14031, 268.77, 152, 405);
INSERT INTO public.europe_data VALUES (661, 384, 14706, 227.74, 153, 405);
INSERT INTO public.europe_data VALUES (662, 24, 402, 190.09, 62, 405);
INSERT INTO public.europe_data VALUES (663, 0, 53, 0.84, 3, 405);
INSERT INTO public.europe_data VALUES (664, 2, 34, 119.98, 63, 405);
INSERT INTO public.europe_data VALUES (665, 1, 97, 24.9, 108, 405);
INSERT INTO public.europe_data VALUES (666, 175, 11235, 165.49, 64, 405);
INSERT INTO public.europe_data VALUES (667, 0, 93, 581.15, 65, 405);
INSERT INTO public.europe_data VALUES (668, 227, 3113, 183.79, 154, 405);
INSERT INTO public.europe_data VALUES (669, 3, 1285, 87.9, 4, 405);
INSERT INTO public.europe_data VALUES (670, 7562, 397866, 306.72, 66, 405);
INSERT INTO public.europe_data VALUES (671, 0, 0, 13.32, 67, 405);
INSERT INTO public.europe_data VALUES (672, 0, 1, 4.85, 109, 405);
INSERT INTO public.europe_data VALUES (673, 448, 5460, 154.21, 155, 405);
INSERT INTO public.europe_data VALUES (674, 3, 1224, 9.5, 5, 405);
INSERT INTO public.europe_data VALUES (675, 0, 186, 1.82, 6, 405);
INSERT INTO public.europe_data VALUES (676, 0, 9, 0.16, 110, 405);
INSERT INTO public.europe_data VALUES (677, 0, 0, 2.21, 7, 405);
INSERT INTO public.europe_data VALUES (678, 1221, 66518, 310.5, 68, 405);
INSERT INTO public.europe_data VALUES (679, 2, 513, 129.11, 8, 405);
INSERT INTO public.europe_data VALUES (680, 0, 15, 67.75, 69, 405);
INSERT INTO public.europe_data VALUES (681, 0, 10, 0.25, 9, 405);
INSERT INTO public.europe_data VALUES (682, 3, 324, 3.27, 10, 405);
INSERT INTO public.europe_data VALUES (683, 395, 27701, 231.45, 70, 405);
INSERT INTO public.europe_data VALUES (684, 2, 611, 0.11, 111, 405);
INSERT INTO public.europe_data VALUES (685, 2486, 126083, 393.52, 71, 405);
INSERT INTO public.europe_data VALUES (686, 5, 296, 50.42, 11, 405);
INSERT INTO public.europe_data VALUES (687, 0, 110, 12.01, 12, 405);
INSERT INTO public.europe_data VALUES (688, 124, 7625, 283.29, 72, 405);
INSERT INTO public.europe_data VALUES (689, 1, 1102, 6.12, 13, 405);
INSERT INTO public.europe_data VALUES (690, 331, 7265, 367.42, 156, 405);
INSERT INTO public.europe_data VALUES (691, 6, 2267, 31.53, 73, 405);
INSERT INTO public.europe_data VALUES (692, 3, 147, 191.53, 74, 405);
INSERT INTO public.europe_data VALUES (693, 17, 3376, 878.3, 157, 405);
INSERT INTO public.europe_data VALUES (694, 1202, 88740, 1512.84, 158, 405);
INSERT INTO public.europe_data VALUES (695, 20, 1343, 2.97, 14, 405);
INSERT INTO public.europe_data VALUES (696, 223, 14014, 505.95, 159, 405);
INSERT INTO public.europe_data VALUES (697, 0, 29, 5.96, 15, 405);
INSERT INTO public.europe_data VALUES (698, 0, 13, 23.67, 75, 405);
INSERT INTO public.europe_data VALUES (699, 9, 9951, 147.84, 76, 405);
INSERT INTO public.europe_data VALUES (700, 125, 6892, 67.62, 77, 405);
INSERT INTO public.europe_data VALUES (701, 392, 7605, 17.18, 16, 405);
INSERT INTO public.europe_data VALUES (702, 64, 1818, 66.41, 78, 405);
INSERT INTO public.europe_data VALUES (703, 0, 17, 3.54, 17, 405);
INSERT INTO public.europe_data VALUES (704, 3, 193, 14.78, 18, 405);
INSERT INTO public.europe_data VALUES (705, 36, 4284, 603.63, 160, 405);
INSERT INTO public.europe_data VALUES (706, 67, 1768, 263.38, 19, 405);
INSERT INTO public.europe_data VALUES (707, 55, 2994, 4.88, 20, 405);
INSERT INTO public.europe_data VALUES (708, 0, 0, 29.66, 79, 405);
INSERT INTO public.europe_data VALUES (709, 1, 26, 131.48, 161, 405);
INSERT INTO public.europe_data VALUES (710, 0, 4, 0.79, 203, 405);
INSERT INTO public.europe_data VALUES (711, 32, 1671, 62.58, 162, 405);
INSERT INTO public.europe_data VALUES (712, 2713, 127528, 329.21, 163, 405);
INSERT INTO public.europe_data VALUES (713, 8, 315, 247.42, 204, 405);
INSERT INTO public.europe_data VALUES (714, 0, 135, 10.59, 21, 405);
INSERT INTO public.europe_data VALUES (715, 0, 70, 3.37, 22, 405);
INSERT INTO public.europe_data VALUES (716, 168, 10017, 441.28, 164, 405);
INSERT INTO public.europe_data VALUES (717, 6112, 145511, 324.25, 165, 405);
INSERT INTO public.europe_data VALUES (718, 3, 1062, 5.68, 23, 405);
INSERT INTO public.europe_data VALUES (719, 8, 764, 4343.44, 166, 405);
INSERT INTO public.europe_data VALUES (720, 306, 4639, 82.12, 167, 405);
INSERT INTO public.europe_data VALUES (721, 0, 0, 1.76, 80, 405);
INSERT INTO public.europe_data VALUES (722, 1, 1, 16.96, 81, 405);
INSERT INTO public.europe_data VALUES (723, 1, 96, 91.46, 205, 405);
INSERT INTO public.europe_data VALUES (724, 215, 4517, 43.98, 82, 405);
INSERT INTO public.europe_data VALUES (725, 0, 5, 12.41, 168, 405);
INSERT INTO public.europe_data VALUES (726, 0, 190, 2.36, 24, 405);
INSERT INTO public.europe_data VALUES (727, 1, 31, 1.61, 25, 405);
INSERT INTO public.europe_data VALUES (728, 5, 396, 58.89, 83, 405);
INSERT INTO public.europe_data VALUES (729, 2, 145, 2.42, 84, 405);
INSERT INTO public.europe_data VALUES (730, 0, 0, 0, 169, 405);
INSERT INTO public.europe_data VALUES (731, 93, 4576, 80.46, 85, 405);
INSERT INTO public.europe_data VALUES (732, 748, 14805, 276.15, 170, 405);
INSERT INTO public.europe_data VALUES (733, 0, 144, 48.18, 171, 405);
INSERT INTO public.europe_data VALUES (734, 1511, 126126, 18.93, 112, 405);
INSERT INTO public.europe_data VALUES (735, 1574, 69553, 42.37, 113, 405);
INSERT INTO public.europe_data VALUES (736, 631, 42972, 103.65, 114, 405);
INSERT INTO public.europe_data VALUES (737, 0, 0, 17.23, 115, 405);
INSERT INTO public.europe_data VALUES (738, 85, 45726, 1253.69, 172, 405);
INSERT INTO public.europe_data VALUES (739, 0, 16, 26.01, 173, 405);
INSERT INTO public.europe_data VALUES (740, 256, 52876, 1069.06, 116, 405);
INSERT INTO public.europe_data VALUES (741, 3423, 121045, 379.05, 174, 405);
INSERT INTO public.europe_data VALUES (742, 9, 588, 30.7, 86, 405);
INSERT INTO public.europe_data VALUES (743, 445, 42905, 52.43, 117, 405);
INSERT INTO public.europe_data VALUES (744, 13, 151, 286.65, 175, 405);
INSERT INTO public.europe_data VALUES (745, 140, 10462, 205.15, 118, 405);
INSERT INTO public.europe_data VALUES (746, 100, 3018, 61.6, 119, 405);
INSERT INTO public.europe_data VALUES (747, 28, 1469, 4.33, 26, 405);
INSERT INTO public.europe_data VALUES (748, 33, 1811, 165.42, 176, 405);
INSERT INTO public.europe_data VALUES (749, 6, 2971, 110.79, 120, 405);
INSERT INTO public.europe_data VALUES (750, 11, 992, 28.76, 121, 405);
INSERT INTO public.europe_data VALUES (751, 0, 0, 0, 122, 405);
INSERT INTO public.europe_data VALUES (752, 169, 7071, 689.49, 177, 405);
INSERT INTO public.europe_data VALUES (753, 107, 30018, 701.17, 123, 405);
INSERT INTO public.europe_data VALUES (754, 20, 2731, 140.26, 27, 405);
INSERT INTO public.europe_data VALUES (755, 0, 0, 0, 28, 405);
INSERT INTO public.europe_data VALUES (756, 63, 3403, 103.24, 29, 405);
INSERT INTO public.europe_data VALUES (757, 14, 124, 661.84, 178, 405);
INSERT INTO public.europe_data VALUES (758, 282, 12459, 1004.84, 179, 405);
INSERT INTO public.europe_data VALUES (759, 27, 1065, 347.78, 180, 405);
INSERT INTO public.europe_data VALUES (760, 5, 234, 1.06, 30, 405);
INSERT INTO public.europe_data VALUES (761, 30, 1731, 11.8, 31, 405);
INSERT INTO public.europe_data VALUES (762, 50, 15174, 96.7, 124, 405);
INSERT INTO public.europe_data VALUES (763, 1, 242, 87.58, 125, 405);
INSERT INTO public.europe_data VALUES (764, 20, 347, 4.56, 32, 405);
INSERT INTO public.europe_data VALUES (765, 11, 1299, 426.09, 181, 405);
INSERT INTO public.europe_data VALUES (766, 0, 0, 0, 206, 405);
INSERT INTO public.europe_data VALUES (767, 26, 718, 38.31, 33, 405);
INSERT INTO public.europe_data VALUES (768, 0, 14, 1.42, 34, 405);
INSERT INTO public.europe_data VALUES (769, 7155, 92878, 119.3, 87, 405);
INSERT INTO public.europe_data VALUES (770, 0, 0, 0, 207, 405);
INSERT INTO public.europe_data VALUES (771, 102, 3518, 198.75, 182, 405);
INSERT INTO public.europe_data VALUES (772, 0, 150, 767.72, 183, 405);
INSERT INTO public.europe_data VALUES (773, 0, 156, 9.46, 126, 405);
INSERT INTO public.europe_data VALUES (774, 36, 3236, 922.08, 184, 405);
INSERT INTO public.europe_data VALUES (775, 0, 0, 0, 88, 405);
INSERT INTO public.europe_data VALUES (776, 258, 9386, 56.08, 35, 405);
INSERT INTO public.europe_data VALUES (777, 28, 3025, 13.25, 36, 405);
INSERT INTO public.europe_data VALUES (778, 118, 4259, 16.13, 127, 405);
INSERT INTO public.europe_data VALUES (779, 43, 3216, 253.15, 37, 405);
INSERT INTO public.europe_data VALUES (780, 39, 2921, 23.07, 128, 405);
INSERT INTO public.europe_data VALUES (781, 799, 57026, 623.33, 185, 405);
INSERT INTO public.europe_data VALUES (782, 0, 0, 0.71, 208, 405);
INSERT INTO public.europe_data VALUES (783, 0, 41, 1.63, 209, 405);
INSERT INTO public.europe_data VALUES (784, 1, 51, 1.62, 89, 405);
INSERT INTO public.europe_data VALUES (785, 16, 412, 3.08, 38, 405);
INSERT INTO public.europe_data VALUES (786, 47, 10007, 7.6, 39, 405);
INSERT INTO public.europe_data VALUES (787, 92, 2470, 225.79, 186, 405);
INSERT INTO public.europe_data VALUES (788, 0, 3, 5.24, 210, 405);
INSERT INTO public.europe_data VALUES (789, 29, 4758, 157.95, 187, 405);
INSERT INTO public.europe_data VALUES (790, 6, 1196, 46.39, 129, 405);
INSERT INTO public.europe_data VALUES (791, 326, 15764, 14.31, 130, 405);
INSERT INTO public.europe_data VALUES (792, 124, 5906, 312.88, 131, 405);
INSERT INTO public.europe_data VALUES (793, 315, 25460, 1071.27, 90, 405);
INSERT INTO public.europe_data VALUES (794, 0, 12, 0.35, 211, 405);
INSERT INTO public.europe_data VALUES (795, 113, 6660, 147.05, 91, 405);
INSERT INTO public.europe_data VALUES (796, 462, 16292, 87.49, 92, 405);
INSERT INTO public.europe_data VALUES (797, 148, 9883, 16.47, 132, 405);
INSERT INTO public.europe_data VALUES (798, 2103, 67438, 340.7, 188, 405);
INSERT INTO public.europe_data VALUES (799, 729, 57670, 901.34, 189, 405);
INSERT INTO public.europe_data VALUES (800, 80, 5800, 464.85, 93, 405);
INSERT INTO public.europe_data VALUES (801, 1, 1424, 106.14, 133, 405);
INSERT INTO public.europe_data VALUES (802, 746, 32842, 282.48, 190, 405);
INSERT INTO public.europe_data VALUES (803, 3285, 165131, 238.04, 191, 405);
INSERT INTO public.europe_data VALUES (804, 19, 954, 12.74, 40, 405);
INSERT INTO public.europe_data VALUES (805, 0, 1, 3.79, 94, 405);
INSERT INTO public.europe_data VALUES (806, 0, 85, 72.76, 95, 405);
INSERT INTO public.europe_data VALUES (807, 0, 125, 126.59, 96, 405);
INSERT INTO public.europe_data VALUES (808, 2, 174, 1137.78, 192, 405);
INSERT INTO public.europe_data VALUES (809, 0, 42, 24.18, 41, 405);
INSERT INTO public.europe_data VALUES (810, 35, 654, 4.64, 134, 405);
INSERT INTO public.europe_data VALUES (811, 45, 1730, 17.21, 42, 405);
INSERT INTO public.europe_data VALUES (812, 257, 15819, 446.17, 193, 405);
INSERT INTO public.europe_data VALUES (813, 2, 234, 321.26, 43, 405);
INSERT INTO public.europe_data VALUES (814, 1, 173, 3.66, 44, 405);
INSERT INTO public.europe_data VALUES (815, 0, 210, 6.6, 135, 405);
INSERT INTO public.europe_data VALUES (816, 0, 113, 386.89, 97, 405);
INSERT INTO public.europe_data VALUES (817, 486, 20970, 751.81, 194, 405);
INSERT INTO public.europe_data VALUES (818, 256, 13855, 1171.89, 195, 405);
INSERT INTO public.europe_data VALUES (819, 0, 0, 0, 212, 405);
INSERT INTO public.europe_data VALUES (820, 0, 12, 0.23, 45, 405);
INSERT INTO public.europe_data VALUES (821, 3586, 130849, 375.23, 46, 405);
INSERT INTO public.europe_data VALUES (822, 159, 4850, 22.32, 136, 405);
INSERT INTO public.europe_data VALUES (823, 0, 73, 1.55, 47, 405);
INSERT INTO public.europe_data VALUES (824, 1197, 152938, 495.07, 196, 405);
INSERT INTO public.europe_data VALUES (825, 19, 3606, 34.36, 137, 405);
INSERT INTO public.europe_data VALUES (826, 0, 0, 0, 48, 405);
INSERT INTO public.europe_data VALUES (827, 15, 671, 180.78, 98, 405);
INSERT INTO public.europe_data VALUES (828, 637, 39467, 789.85, 197, 405);
INSERT INTO public.europe_data VALUES (829, 417, 22434, 536.58, 198, 405);
INSERT INTO public.europe_data VALUES (830, 45, 654, 7.8, 138, 405);
INSERT INTO public.europe_data VALUES (831, 0, 19, 0.17, 139, 405);
INSERT INTO public.europe_data VALUES (832, 0, 8, 0.76, 140, 405);
INSERT INTO public.europe_data VALUES (833, 2, 2108, 6.12, 141, 405);
INSERT INTO public.europe_data VALUES (834, 0, 5, 0.62, 142, 405);
INSERT INTO public.europe_data VALUES (835, 4, 255, 4.71, 49, 405);
INSERT INTO public.europe_data VALUES (836, 1, 97, 10.75, 99, 405);
INSERT INTO public.europe_data VALUES (837, 484, 18806, 263.01, 50, 405);
INSERT INTO public.europe_data VALUES (838, 1319, 84344, 217.89, 199, 405);
INSERT INTO public.europe_data VALUES (839, 0, 84, 379.64, 100, 405);
INSERT INTO public.europe_data VALUES (840, 28, 1758, 8.66, 51, 405);
INSERT INTO public.europe_data VALUES (841, 981, 45221, 202.17, 200, 405);
INSERT INTO public.europe_data VALUES (842, 29, 18250, 318.78, 143, 405);
INSERT INTO public.europe_data VALUES (843, 6407, 417570, 1114.26, 201, 405);
INSERT INTO public.europe_data VALUES (844, 0, 0, 0, 52, 405);
INSERT INTO public.europe_data VALUES (845, 22852, 1782792, 994.14, 101, 405);
INSERT INTO public.europe_data VALUES (846, 0, 111, 154.91, 102, 405);
INSERT INTO public.europe_data VALUES (847, 58, 6078, 277.17, 103, 405);
INSERT INTO public.europe_data VALUES (848, 3, 353, 2.36, 144, 405);
INSERT INTO public.europe_data VALUES (849, 0, 0, 0, 213, 405);
INSERT INTO public.europe_data VALUES (850, 35, 2576, 16.37, 104, 405);
INSERT INTO public.europe_data VALUES (851, 0, 17, 0.08, 145, 405);
INSERT INTO public.europe_data VALUES (852, 0, 0, 0, 214, 405);
INSERT INTO public.europe_data VALUES (853, 0, 0, 0, 53, 405);
INSERT INTO public.europe_data VALUES (854, 1, 3, 0.03, 146, 405);
INSERT INTO public.europe_data VALUES (855, 73, 6603, 48.45, 54, 405);
INSERT INTO public.europe_data VALUES (856, 127, 6212, 56.87, 55, 405);
INSERT INTO public.europe_data VALUES (857, 60, 902, 7.61, 105, 406);
INSERT INTO public.europe_data VALUES (858, 29, 2866, 224.81, 147, 406);
INSERT INTO public.europe_data VALUES (859, 35, 1777, 12.09, 1, 406);
INSERT INTO public.europe_data VALUES (860, 2, 605, 807.33, 148, 406);
INSERT INTO public.europe_data VALUES (861, 5, 346, 3.14, 2, 406);
INSERT INTO public.europe_data VALUES (862, 0, 2, 33.62, 56, 406);
INSERT INTO public.europe_data VALUES (863, 0, 2, 7.21, 57, 406);
INSERT INTO public.europe_data VALUES (864, 614, 50220, 209, 58, 406);
INSERT INTO public.europe_data VALUES (865, 89, 2272, 208.1, 149, 406);
INSERT INTO public.europe_data VALUES (866, 0, 241, 364.97, 59, 406);
INSERT INTO public.europe_data VALUES (867, 1, 192, 1.21, 202, 406);
INSERT INTO public.europe_data VALUES (868, 381, 13188, 320.04, 150, 406);
INSERT INTO public.europe_data VALUES (869, 195, 4782, 180.91, 151, 406);
INSERT INTO public.europe_data VALUES (870, 5, 90, 40.82, 60, 406);
INSERT INTO public.europe_data VALUES (871, 1, 1745, 194.74, 106, 406);
INSERT INTO public.europe_data VALUES (872, 174, 6871, 9.39, 107, 406);
INSERT INTO public.europe_data VALUES (873, 0, 244, 98.95, 61, 406);
INSERT INTO public.europe_data VALUES (874, 57, 11374, 279.71, 152, 406);
INSERT INTO public.europe_data VALUES (875, 455, 11383, 209.22, 153, 406);
INSERT INTO public.europe_data VALUES (876, 17, 340, 193.67, 62, 406);
INSERT INTO public.europe_data VALUES (877, 0, 46, 0.71, 3, 406);
INSERT INTO public.europe_data VALUES (878, 0, 41, 151.98, 63, 406);
INSERT INTO public.europe_data VALUES (879, 0, 93, 32.63, 108, 406);
INSERT INTO public.europe_data VALUES (880, 103, 7818, 106.63, 64, 406);
INSERT INTO public.europe_data VALUES (881, 0, 58, 238.62, 65, 406);
INSERT INTO public.europe_data VALUES (882, 178, 2954, 215.72, 154, 406);
INSERT INTO public.europe_data VALUES (883, 5, 740, 76.01, 4, 406);
INSERT INTO public.europe_data VALUES (884, 4879, 249461, 222.76, 66, 406);
INSERT INTO public.europe_data VALUES (885, 0, 4, 36.63, 67, 406);
INSERT INTO public.europe_data VALUES (886, 0, 20, 4.62, 109, 406);
INSERT INTO public.europe_data VALUES (887, 514, 5335, 169.37, 155, 406);
INSERT INTO public.europe_data VALUES (888, 8, 707, 9.31, 5, 406);
INSERT INTO public.europe_data VALUES (889, 0, 24, 0.62, 6, 406);
INSERT INTO public.europe_data VALUES (890, 0, 18, 0.12, 110, 406);
INSERT INTO public.europe_data VALUES (891, 0, 571, 3.86, 7, 406);
INSERT INTO public.europe_data VALUES (892, 901, 49643, 230.81, 68, 406);
INSERT INTO public.europe_data VALUES (893, 1, 197, 62.01, 8, 406);
INSERT INTO public.europe_data VALUES (894, 0, 29, 47.73, 69, 406);
INSERT INTO public.europe_data VALUES (895, 0, 2, 0.53, 9, 406);
INSERT INTO public.europe_data VALUES (896, 0, 198, 2.03, 10, 406);
INSERT INTO public.europe_data VALUES (897, 324, 16163, 162, 70, 406);
INSERT INTO public.europe_data VALUES (898, 14, 918, 0.08, 111, 406);
INSERT INTO public.europe_data VALUES (899, 1591, 72013, 313.38, 71, 406);
INSERT INTO public.europe_data VALUES (900, 6, 133, 23.27, 11, 406);
INSERT INTO public.europe_data VALUES (901, 8, 536, 16.86, 12, 406);
INSERT INTO public.europe_data VALUES (902, 85, 6674, 248.5, 72, 406);
INSERT INTO public.europe_data VALUES (903, 1, 472, 2.84, 13, 406);
INSERT INTO public.europe_data VALUES (904, 333, 7712, 422.69, 156, 406);
INSERT INTO public.europe_data VALUES (905, 4, 1306, 22.04, 73, 406);
INSERT INTO public.europe_data VALUES (906, 2, 166, 209.88, 74, 406);
INSERT INTO public.europe_data VALUES (907, 19, 4317, 717.66, 157, 406);
INSERT INTO public.europe_data VALUES (908, 918, 72374, 1119.19, 158, 406);
INSERT INTO public.europe_data VALUES (909, 20, 1236, 2.7, 14, 406);
INSERT INTO public.europe_data VALUES (910, 170, 15362, 590.36, 159, 406);
INSERT INTO public.europe_data VALUES (911, 0, 29, 6.27, 15, 406);
INSERT INTO public.europe_data VALUES (912, 0, 4, 5.57, 75, 406);
INSERT INTO public.europe_data VALUES (913, 14, 5926, 114.34, 76, 406);
INSERT INTO public.europe_data VALUES (914, 65, 4856, 47.69, 77, 406);
INSERT INTO public.europe_data VALUES (915, 400, 9646, 16.57, 16, 406);
INSERT INTO public.europe_data VALUES (916, 51, 2468, 51.37, 78, 406);
INSERT INTO public.europe_data VALUES (917, 0, 31, 3.54, 17, 406);
INSERT INTO public.europe_data VALUES (918, 2, 324, 15.9, 18, 406);
INSERT INTO public.europe_data VALUES (919, 38, 3713, 583.25, 160, 406);
INSERT INTO public.europe_data VALUES (920, 64, 1256, 219.14, 19, 406);
INSERT INTO public.europe_data VALUES (921, 36, 2477, 5.06, 20, 406);
INSERT INTO public.europe_data VALUES (922, 0, 1, 177.94, 79, 406);
INSERT INTO public.europe_data VALUES (923, 0, 38, 152.02, 161, 406);
INSERT INTO public.europe_data VALUES (924, 0, 3, 0.34, 203, 406);
INSERT INTO public.europe_data VALUES (925, 19, 1782, 68.09, 162, 406);
INSERT INTO public.europe_data VALUES (926, 1928, 93082, 272.15, 163, 406);
INSERT INTO public.europe_data VALUES (927, 6, 376, 266.39, 204, 406);
INSERT INTO public.europe_data VALUES (928, 2, 95, 8.52, 21, 406);
INSERT INTO public.europe_data VALUES (929, 2, 9, 0.72, 22, 406);
INSERT INTO public.europe_data VALUES (930, 210, 7620, 507.94, 164, 406);
INSERT INTO public.europe_data VALUES (931, 4448, 123679, 319.04, 165, 406);
INSERT INTO public.europe_data VALUES (932, 2, 665, 4.98, 23, 406);
INSERT INTO public.europe_data VALUES (933, 2, 700, 3447.46, 166, 406);
INSERT INTO public.europe_data VALUES (934, 285, 4168, 84.17, 167, 406);
INSERT INTO public.europe_data VALUES (935, 0, 1, 14.12, 80, 406);
INSERT INTO public.europe_data VALUES (936, 0, 18, 24.11, 81, 406);
INSERT INTO public.europe_data VALUES (937, 2, 57, 69.34, 205, 406);
INSERT INTO public.europe_data VALUES (938, 62, 3215, 28.75, 82, 406);
INSERT INTO public.europe_data VALUES (939, 0, 3, 10.86, 168, 406);
INSERT INTO public.europe_data VALUES (940, 1, 111, 1.95, 24, 406);
INSERT INTO public.europe_data VALUES (941, 0, 0, 0, 25, 406);
INSERT INTO public.europe_data VALUES (942, 0, 65, 23.89, 83, 406);
INSERT INTO public.europe_data VALUES (943, 0, 128, 3.16, 84, 406);
INSERT INTO public.europe_data VALUES (944, 0, 0, 0, 169, 406);
INSERT INTO public.europe_data VALUES (945, 92, 3266, 65.12, 85, 406);
INSERT INTO public.europe_data VALUES (946, 816, 12182, 242.73, 170, 406);
INSERT INTO public.europe_data VALUES (947, 1, 28, 31.37, 171, 406);
INSERT INTO public.europe_data VALUES (948, 1748, 132598, 20.85, 112, 406);
INSERT INTO public.europe_data VALUES (949, 1318, 45108, 34.57, 113, 406);
INSERT INTO public.europe_data VALUES (950, 847, 42969, 110.19, 114, 406);
INSERT INTO public.europe_data VALUES (951, 64, 6772, 36.18, 115, 406);
INSERT INTO public.europe_data VALUES (952, 55, 15758, 455.63, 172, 406);
INSERT INTO public.europe_data VALUES (953, 0, 6, 8.28, 173, 406);
INSERT INTO public.europe_data VALUES (954, 193, 38201, 772.69, 116, 406);
INSERT INTO public.europe_data VALUES (955, 3407, 107750, 335.09, 174, 406);
INSERT INTO public.europe_data VALUES (956, 6, 317, 25.78, 86, 406);
INSERT INTO public.europe_data VALUES (957, 347, 23611, 35.73, 117, 406);
INSERT INTO public.europe_data VALUES (958, 3, 158, 449.92, 175, 406);
INSERT INTO public.europe_data VALUES (959, 145, 10262, 205.51, 118, 406);
INSERT INTO public.europe_data VALUES (960, 86, 8409, 83.11, 119, 406);
INSERT INTO public.europe_data VALUES (961, 21, 810, 4.38, 26, 406);
INSERT INTO public.europe_data VALUES (962, 27, 1164, 155.46, 176, 406);
INSERT INTO public.europe_data VALUES (963, 6, 1690, 79.96, 120, 406);
INSERT INTO public.europe_data VALUES (964, 11, 853, 33.26, 121, 406);
INSERT INTO public.europe_data VALUES (965, 0, 0, 0, 122, 406);
INSERT INTO public.europe_data VALUES (966, 121, 6167, 601.94, 177, 406);
INSERT INTO public.europe_data VALUES (967, 105, 18052, 454.72, 123, 406);
INSERT INTO public.europe_data VALUES (968, 14, 250, 31.05, 27, 406);
INSERT INTO public.europe_data VALUES (969, 0, 0, 0.24, 28, 406);
INSERT INTO public.europe_data VALUES (970, 90, 3594, 99.96, 29, 406);
INSERT INTO public.europe_data VALUES (971, 8, 130, 1024.02, 178, 406);
INSERT INTO public.europe_data VALUES (972, 681, 15618, 1198.92, 179, 406);
INSERT INTO public.europe_data VALUES (973, 19, 1070, 464.58, 180, 406);
INSERT INTO public.europe_data VALUES (974, 1, 53, 0.5, 30, 406);
INSERT INTO public.europe_data VALUES (975, 7, 467, 3.67, 31, 406);
INSERT INTO public.europe_data VALUES (976, 49, 15722, 86.1, 124, 406);
INSERT INTO public.europe_data VALUES (977, 0, 223, 70.44, 125, 406);
INSERT INTO public.europe_data VALUES (978, 22, 550, 5.4, 32, 406);
INSERT INTO public.europe_data VALUES (979, 6, 804, 289.33, 181, 406);
INSERT INTO public.europe_data VALUES (980, 0, 0, 0, 206, 406);
INSERT INTO public.europe_data VALUES (981, 28, 1016, 52.5, 33, 406);
INSERT INTO public.europe_data VALUES (982, 0, 4, 0.39, 34, 406);
INSERT INTO public.europe_data VALUES (983, 4358, 59325, 96.29, 87, 406);
INSERT INTO public.europe_data VALUES (984, 146, 4518, 263.8, 182, 406);
INSERT INTO public.europe_data VALUES (985, 1, 104, 541.03, 183, 406);
INSERT INTO public.europe_data VALUES (986, 0, 149, 9.08, 126, 406);
INSERT INTO public.europe_data VALUES (987, 23, 2501, 842.2, 184, 406);
INSERT INTO public.europe_data VALUES (988, 0, 0, 0, 88, 406);
INSERT INTO public.europe_data VALUES (989, 245, 11067, 71.35, 35, 406);
INSERT INTO public.europe_data VALUES (990, 7, 999, 5.73, 36, 406);
INSERT INTO public.europe_data VALUES (991, 127, 4459, 18.89, 127, 406);
INSERT INTO public.europe_data VALUES (992, 25, 3099, 267.47, 37, 406);
INSERT INTO public.europe_data VALUES (993, 53, 3678, 28.27, 128, 406);
INSERT INTO public.europe_data VALUES (994, 570, 50699, 759.7, 185, 406);
INSERT INTO public.europe_data VALUES (995, 0, 2, 1.06, 208, 406);
INSERT INTO public.europe_data VALUES (996, 0, 37, 1.25, 209, 406);
INSERT INTO public.europe_data VALUES (997, 1, 55, 1.65, 89, 406);
INSERT INTO public.europe_data VALUES (998, 11, 306, 3.46, 38, 406);
INSERT INTO public.europe_data VALUES (999, 47, 5269, 5.8, 39, 406);
INSERT INTO public.europe_data VALUES (1000, 74, 2220, 275.33, 186, 406);
INSERT INTO public.europe_data VALUES (1001, 0, 0, 10.49, 210, 406);
INSERT INTO public.europe_data VALUES (1002, 20, 3658, 149.02, 187, 406);
INSERT INTO public.europe_data VALUES (1003, 7, 1112, 38.53, 129, 406);
INSERT INTO public.europe_data VALUES (1004, 421, 15220, 13.65, 130, 406);
INSERT INTO public.europe_data VALUES (1005, 189, 9680, 401.41, 131, 406);
INSERT INTO public.europe_data VALUES (1006, 248, 20031, 934.85, 90, 406);
INSERT INTO public.europe_data VALUES (1007, 0, 19, 0.43, 211, 406);
INSERT INTO public.europe_data VALUES (1008, 90, 3699, 120.11, 91, 406);
INSERT INTO public.europe_data VALUES (1009, 348, 12150, 69.46, 92, 406);
INSERT INTO public.europe_data VALUES (1010, 148, 7921, 16.67, 132, 406);
INSERT INTO public.europe_data VALUES (1011, 2014, 61937, 316.67, 188, 406);
INSERT INTO public.europe_data VALUES (1012, 519, 34957, 559.54, 189, 406);
INSERT INTO public.europe_data VALUES (1013, 106, 7836, 721.11, 93, 406);
INSERT INTO public.europe_data VALUES (1014, 1, 1582, 93.32, 133, 406);
INSERT INTO public.europe_data VALUES (1015, 645, 22000, 253.08, 190, 406);
INSERT INTO public.europe_data VALUES (1016, 3723, 182103, 341.03, 191, 406);
INSERT INTO public.europe_data VALUES (1017, 26, 655, 10.95, 40, 406);
INSERT INTO public.europe_data VALUES (1018, 0, 1, 5.68, 94, 406);
INSERT INTO public.europe_data VALUES (1019, 0, 48, 36.11, 95, 406);
INSERT INTO public.europe_data VALUES (1020, 0, 15, 18.08, 96, 406);
INSERT INTO public.europe_data VALUES (1021, 5, 218, 1120.37, 192, 406);
INSERT INTO public.europe_data VALUES (1022, 0, 10, 5.58, 41, 406);
INSERT INTO public.europe_data VALUES (1023, 71, 935, 6.26, 134, 406);
INSERT INTO public.europe_data VALUES (1024, 34, 1075, 12.55, 42, 406);
INSERT INTO public.europe_data VALUES (1025, 252, 15251, 576.17, 193, 406);
INSERT INTO public.europe_data VALUES (1026, 0, 80, 94.13, 43, 406);
INSERT INTO public.europe_data VALUES (1027, 0, 113, 2.1, 44, 406);
INSERT INTO public.europe_data VALUES (1028, 0, 173, 4.74, 135, 406);
INSERT INTO public.europe_data VALUES (1029, 0, 51, 292.53, 97, 406);
INSERT INTO public.europe_data VALUES (1030, 642, 20007, 674.5, 194, 406);
INSERT INTO public.europe_data VALUES (1031, 307, 10531, 959.15, 195, 406);
INSERT INTO public.europe_data VALUES (1032, 0, 0, 0, 212, 406);
INSERT INTO public.europe_data VALUES (1033, 3, 24, 0.34, 45, 406);
INSERT INTO public.europe_data VALUES (1034, 2506, 88877, 305.38, 46, 406);
INSERT INTO public.europe_data VALUES (1035, 162, 6584, 26.69, 136, 406);
INSERT INTO public.europe_data VALUES (1036, 1, 98, 3.26, 47, 406);
INSERT INTO public.europe_data VALUES (1037, 956, 79431, 297.41, 196, 406);
INSERT INTO public.europe_data VALUES (1038, 22, 3720, 35.23, 137, 406);
INSERT INTO public.europe_data VALUES (1039, 0, 0, 1.15, 48, 406);
INSERT INTO public.europe_data VALUES (1040, 3, 380, 139.33, 98, 406);
INSERT INTO public.europe_data VALUES (1041, 657, 41336, 767.08, 197, 406);
INSERT INTO public.europe_data VALUES (1042, 495, 23414, 555.89, 198, 406);
INSERT INTO public.europe_data VALUES (1043, 51, 677, 8.88, 138, 406);
INSERT INTO public.europe_data VALUES (1044, 0, 22, 0.21, 139, 406);
INSERT INTO public.europe_data VALUES (1045, 0, 63, 3.65, 140, 406);
INSERT INTO public.europe_data VALUES (1046, 5, 2154, 5.07, 141, 406);
INSERT INTO public.europe_data VALUES (1047, 0, 3, 1.01, 142, 406);
INSERT INTO public.europe_data VALUES (1048, 0, 126, 3.54, 49, 406);
INSERT INTO public.europe_data VALUES (1049, 2, 53, 11.18, 99, 406);
INSERT INTO public.europe_data VALUES (1050, 334, 11952, 186.63, 50, 406);
INSERT INTO public.europe_data VALUES (1051, 1610, 94334, 265, 199, 406);
INSERT INTO public.europe_data VALUES (1052, 0, 61, 293.24, 100, 406);
INSERT INTO public.europe_data VALUES (1053, 26, 2077, 10.98, 51, 406);
INSERT INTO public.europe_data VALUES (1054, 1005, 43719, 234.35, 200, 406);
INSERT INTO public.europe_data VALUES (1055, 25, 12896, 216.54, 143, 406);
INSERT INTO public.europe_data VALUES (1056, 3915, 325049, 922.22, 201, 406);
INSERT INTO public.europe_data VALUES (1057, 0, 0, 0, 52, 406);
INSERT INTO public.europe_data VALUES (1058, 18264, 1488563, 849.49, 101, 406);
INSERT INTO public.europe_data VALUES (1059, 1, 51, 128.13, 102, 406);
INSERT INTO public.europe_data VALUES (1060, 44, 3517, 212.21, 103, 406);
INSERT INTO public.europe_data VALUES (1061, 1, 426, 3.67, 144, 406);
INSERT INTO public.europe_data VALUES (1062, 0, 0, 0, 213, 406);
INSERT INTO public.europe_data VALUES (1063, 24, 2091, 15.19, 104, 406);
INSERT INTO public.europe_data VALUES (1064, 0, 56, 0.09, 145, 406);
INSERT INTO public.europe_data VALUES (1065, 0, 0, 0, 214, 406);
INSERT INTO public.europe_data VALUES (1066, 0, 0, 0, 53, 406);
INSERT INTO public.europe_data VALUES (1067, 3, 7, 0.05, 146, 406);
INSERT INTO public.europe_data VALUES (1068, 14, 2050, 18.35, 54, 406);
INSERT INTO public.europe_data VALUES (1069, 26, 2117, 19.88, 55, 406);
INSERT INTO public.europe_data VALUES (1070, 88, 1994, 7.19, 105, 407);
INSERT INTO public.europe_data VALUES (1071, 76, 3569, 280.95, 147, 407);
INSERT INTO public.europe_data VALUES (1072, 71, 3428, 15.17, 1, 407);
INSERT INTO public.europe_data VALUES (1073, 1, 10, 326.87, 148, 407);
INSERT INTO public.europe_data VALUES (1074, 16, 652, 3.48, 2, 407);
INSERT INTO public.europe_data VALUES (1075, 0, 3, 20.17, 56, 407);
INSERT INTO public.europe_data VALUES (1076, 0, 5, 10.3, 57, 407);
INSERT INTO public.europe_data VALUES (1077, 871, 43370, 206.17, 58, 407);
INSERT INTO public.europe_data VALUES (1078, 119, 3883, 313.28, 149, 407);
INSERT INTO public.europe_data VALUES (1079, 2, 147, 257.74, 59, 407);
INSERT INTO public.europe_data VALUES (1080, 0, 114, 1.11, 202, 407);
INSERT INTO public.europe_data VALUES (1081, 656, 15164, 353.89, 150, 407);
INSERT INTO public.europe_data VALUES (1082, 328, 13395, 394.21, 151, 407);
INSERT INTO public.europe_data VALUES (1083, 6, 69, 41.08, 60, 407);
INSERT INTO public.europe_data VALUES (1084, 2, 1451, 157.81, 106, 407);
INSERT INTO public.europe_data VALUES (1085, 172, 8435, 11.42, 107, 407);
INSERT INTO public.europe_data VALUES (1086, 0, 40, 22.99, 61, 407);
INSERT INTO public.europe_data VALUES (1087, 70, 15065, 299.32, 152, 407);
INSERT INTO public.europe_data VALUES (1088, 534, 12584, 264.21, 153, 407);
INSERT INTO public.europe_data VALUES (1089, 9, 416, 324.32, 62, 407);
INSERT INTO public.europe_data VALUES (1090, 0, 38, 0.97, 3, 407);
INSERT INTO public.europe_data VALUES (1091, 1, 54, 239.97, 63, 407);
INSERT INTO public.europe_data VALUES (1092, 0, 156, 24.24, 108, 407);
INSERT INTO public.europe_data VALUES (1093, 55, 4458, 66.82, 64, 407);
INSERT INTO public.europe_data VALUES (1094, 0, 4, 38.49, 65, 407);
INSERT INTO public.europe_data VALUES (1095, 328, 4167, 259.74, 154, 407);
INSERT INTO public.europe_data VALUES (1096, 2, 1011, 50.01, 4, 407);
INSERT INTO public.europe_data VALUES (1097, 3848, 220666, 275.92, 66, 407);
INSERT INTO public.europe_data VALUES (1098, 0, 7, 43.29, 67, 407);
INSERT INTO public.europe_data VALUES (1099, 0, 0, 0, 109, 407);
INSERT INTO public.europe_data VALUES (1100, 555, 6521, 260.96, 155, 407);
INSERT INTO public.europe_data VALUES (1101, 2, 1184, 11.39, 5, 407);
INSERT INTO public.europe_data VALUES (1102, 0, 48, 0.69, 6, 407);
INSERT INTO public.europe_data VALUES (1103, 0, 1, 0.03, 110, 407);
INSERT INTO public.europe_data VALUES (1104, 0, 428, 3.55, 7, 407);
INSERT INTO public.europe_data VALUES (1105, 632, 36706, 243.98, 68, 407);
INSERT INTO public.europe_data VALUES (1106, 1, 144, 66.55, 8, 407);
INSERT INTO public.europe_data VALUES (1107, 0, 2, 30.79, 69, 407);
INSERT INTO public.europe_data VALUES (1108, 0, 23, 0.53, 9, 407);
INSERT INTO public.europe_data VALUES (1109, 2, 125, 1.54, 10, 407);
INSERT INTO public.europe_data VALUES (1110, 246, 14540, 158.87, 70, 407);
INSERT INTO public.europe_data VALUES (1111, 7, 245, 0.23, 111, 407);
INSERT INTO public.europe_data VALUES (1112, 1694, 85740, 353.67, 71, 407);
INSERT INTO public.europe_data VALUES (1113, 0, 65, 12.1, 11, 407);
INSERT INTO public.europe_data VALUES (1114, 0, 371, 6.9, 12, 407);
INSERT INTO public.europe_data VALUES (1115, 107, 5869, 249.49, 72, 407);
INSERT INTO public.europe_data VALUES (1116, 4, 258, 1.93, 13, 407);
INSERT INTO public.europe_data VALUES (1117, 482, 9518, 720.27, 156, 407);
INSERT INTO public.europe_data VALUES (1118, 6, 1192, 17.74, 73, 407);
INSERT INTO public.europe_data VALUES (1119, 3, 177, 322.48, 74, 407);
INSERT INTO public.europe_data VALUES (1120, 21, 1969, 520.15, 157, 407);
INSERT INTO public.europe_data VALUES (1121, 741, 46817, 875.71, 158, 407);
INSERT INTO public.europe_data VALUES (1122, 13, 1107, 2.77, 14, 407);
INSERT INTO public.europe_data VALUES (1123, 169, 18915, 750.78, 159, 407);
INSERT INTO public.europe_data VALUES (1124, 0, 32, 8.73, 15, 407);
INSERT INTO public.europe_data VALUES (1125, 0, 0, 5.57, 75, 407);
INSERT INTO public.europe_data VALUES (1126, 19, 6353, 118.38, 76, 407);
INSERT INTO public.europe_data VALUES (1127, 45, 3429, 44.02, 77, 407);
INSERT INTO public.europe_data VALUES (1128, 307, 6986, 10.92, 16, 407);
INSERT INTO public.europe_data VALUES (1129, 56, 847, 42.44, 78, 407);
INSERT INTO public.europe_data VALUES (1130, 1, 17, 3.91, 17, 407);
INSERT INTO public.europe_data VALUES (1131, 1, 232, 9.38, 18, 407);
INSERT INTO public.europe_data VALUES (1132, 39, 4014, 585.21, 160, 407);
INSERT INTO public.europe_data VALUES (1133, 27, 1260, 167.14, 19, 407);
INSERT INTO public.europe_data VALUES (1134, 59, 3194, 5.69, 20, 407);
INSERT INTO public.europe_data VALUES (1135, 0, 5, 266.9, 79, 407);
INSERT INTO public.europe_data VALUES (1136, 0, 36, 110.94, 161, 407);
INSERT INTO public.europe_data VALUES (1137, 0, 0, 0, 203, 407);
INSERT INTO public.europe_data VALUES (1138, 57, 1975, 78.42, 162, 407);
INSERT INTO public.europe_data VALUES (1139, 2560, 89292, 277.25, 163, 407);
INSERT INTO public.europe_data VALUES (1140, 5, 368, 287.52, 204, 407);
INSERT INTO public.europe_data VALUES (1141, 0, 90, 7.32, 21, 407);
INSERT INTO public.europe_data VALUES (1142, 0, 8, 0.64, 22, 407);
INSERT INTO public.europe_data VALUES (1143, 278, 12681, 777.63, 164, 407);
INSERT INTO public.europe_data VALUES (1144, 3851, 141182, 379.14, 165, 407);
INSERT INTO public.europe_data VALUES (1145, 2, 850, 4.9, 23, 407);
INSERT INTO public.europe_data VALUES (1146, 0, 462, 1872.07, 166, 407);
INSERT INTO public.europe_data VALUES (1147, 500, 4859, 106.27, 167, 407);
INSERT INTO public.europe_data VALUES (1148, 0, 7, 12.35, 80, 407);
INSERT INTO public.europe_data VALUES (1149, 0, 9, 41.96, 81, 407);
INSERT INTO public.europe_data VALUES (1150, 1, 59, 98.03, 205, 407);
INSERT INTO public.europe_data VALUES (1151, 55, 1840, 35.03, 82, 407);
INSERT INTO public.europe_data VALUES (1152, 0, 4, 12.41, 168, 407);
INSERT INTO public.europe_data VALUES (1153, 0, 138, 1.81, 24, 407);
INSERT INTO public.europe_data VALUES (1154, 0, 0, 0, 25, 407);
INSERT INTO public.europe_data VALUES (1155, 5, 122, 47.65, 83, 407);
INSERT INTO public.europe_data VALUES (1156, 1, 228, 3.85, 84, 407);
INSERT INTO public.europe_data VALUES (1157, 0, 0, 0, 169, 407);
INSERT INTO public.europe_data VALUES (1158, 61, 3081, 58.94, 85, 407);
INSERT INTO public.europe_data VALUES (1159, 879, 11539, 335.62, 170, 407);
INSERT INTO public.europe_data VALUES (1160, 0, 84, 47.34, 171, 407);
INSERT INTO public.europe_data VALUES (1161, 2091, 152311, 23.69, 112, 407);
INSERT INTO public.europe_data VALUES (1162, 1357, 48435, 35.31, 113, 407);
INSERT INTO public.europe_data VALUES (1163, 1245, 48393, 111.19, 114, 407);
INSERT INTO public.europe_data VALUES (1164, 83, 7452, 43.15, 115, 407);
INSERT INTO public.europe_data VALUES (1165, 46, 6587, 202.76, 172, 407);
INSERT INTO public.europe_data VALUES (1166, 0, 1, 1.18, 173, 407);
INSERT INTO public.europe_data VALUES (1167, 139, 27627, 541.44, 116, 407);
INSERT INTO public.europe_data VALUES (1168, 3126, 94511, 337.95, 174, 407);
INSERT INTO public.europe_data VALUES (1169, 12, 443, 34.66, 86, 407);
INSERT INTO public.europe_data VALUES (1170, 352, 21713, 31.99, 117, 407);
INSERT INTO public.europe_data VALUES (1171, 5, 327, 820.07, 175, 407);
INSERT INTO public.europe_data VALUES (1172, 154, 10498, 280.47, 118, 407);
INSERT INTO public.europe_data VALUES (1173, 67, 7009, 66.74, 119, 407);
INSERT INTO public.europe_data VALUES (1174, 25, 1492, 7.8, 26, 407);
INSERT INTO public.europe_data VALUES (1175, 55, 1632, 234.69, 176, 407);
INSERT INTO public.europe_data VALUES (1176, 10, 1674, 81.65, 120, 407);
INSERT INTO public.europe_data VALUES (1177, 18, 1281, 44.59, 121, 407);
INSERT INTO public.europe_data VALUES (1178, 0, 0, 0, 122, 407);
INSERT INTO public.europe_data VALUES (1179, 120, 5390, 554.96, 177, 407);
INSERT INTO public.europe_data VALUES (1180, 113, 13122, 360.37, 123, 407);
INSERT INTO public.europe_data VALUES (1181, 3, 410, 31.57, 27, 407);
INSERT INTO public.europe_data VALUES (1182, 0, 12, 0.59, 28, 407);
INSERT INTO public.europe_data VALUES (1183, 67, 3181, 112.17, 29, 407);
INSERT INTO public.europe_data VALUES (1184, 3, 263, 1506.07, 178, 407);
INSERT INTO public.europe_data VALUES (1185, 230, 17882, 1336.63, 179, 407);
INSERT INTO public.europe_data VALUES (1186, 47, 1782, 745.57, 180, 407);
INSERT INTO public.europe_data VALUES (1187, 1, 81, 0.3, 30, 407);
INSERT INTO public.europe_data VALUES (1188, 1, 216, 1.67, 31, 407);
INSERT INTO public.europe_data VALUES (1189, 15, 11787, 67.67, 124, 407);
INSERT INTO public.europe_data VALUES (1190, 0, 151, 51.98, 125, 407);
INSERT INTO public.europe_data VALUES (1191, 34, 512, 4.52, 32, 407);
INSERT INTO public.europe_data VALUES (1192, 20, 624, 237.46, 181, 407);
INSERT INTO public.europe_data VALUES (1193, 0, 0, 0, 206, 407);
INSERT INTO public.europe_data VALUES (1194, 49, 1360, 62.02, 33, 407);
INSERT INTO public.europe_data VALUES (1195, 0, 1, 0.32, 34, 407);
INSERT INTO public.europe_data VALUES (1196, 4257, 63515, 109.26, 87, 407);
INSERT INTO public.europe_data VALUES (1197, 139, 6148, 366.96, 182, 407);
INSERT INTO public.europe_data VALUES (1198, 0, 75, 408.04, 183, 407);
INSERT INTO public.europe_data VALUES (1199, 0, 144, 6.98, 126, 407);
INSERT INTO public.europe_data VALUES (1200, 40, 2739, 846.7, 184, 407);
INSERT INTO public.europe_data VALUES (1201, 0, 0, 0, 88, 407);
INSERT INTO public.europe_data VALUES (1202, 283, 14954, 89.03, 35, 407);
INSERT INTO public.europe_data VALUES (1203, 14, 742, 4.47, 36, 407);
INSERT INTO public.europe_data VALUES (1204, 158, 5752, 25.06, 127, 407);
INSERT INTO public.europe_data VALUES (1205, 16, 3573, 230.54, 37, 407);
INSERT INTO public.europe_data VALUES (1206, 37, 4409, 34.11, 128, 407);
INSERT INTO public.europe_data VALUES (1207, 551, 80594, 906.99, 185, 407);
INSERT INTO public.europe_data VALUES (1208, 0, 1, 0.71, 208, 407);
INSERT INTO public.europe_data VALUES (1209, 0, 23, 1, 209, 407);
INSERT INTO public.europe_data VALUES (1210, 1, 53, 1.59, 89, 407);
INSERT INTO public.europe_data VALUES (1211, 12, 500, 3.87, 38, 407);
INSERT INTO public.europe_data VALUES (1212, 43, 6377, 5.79, 39, 407);
INSERT INTO public.europe_data VALUES (1213, 164, 3499, 393.14, 186, 407);
INSERT INTO public.europe_data VALUES (1214, 0, 6, 15.73, 210, 407);
INSERT INTO public.europe_data VALUES (1215, 25, 4282, 113.62, 187, 407);
INSERT INTO public.europe_data VALUES (1216, 7, 805, 44.86, 129, 407);
INSERT INTO public.europe_data VALUES (1217, 537, 14341, 15.02, 130, 407);
INSERT INTO public.europe_data VALUES (1218, 147, 10316, 516.04, 131, 407);
INSERT INTO public.europe_data VALUES (1219, 295, 19667, 958.4, 90, 407);
INSERT INTO public.europe_data VALUES (1220, 0, 19, 0.63, 211, 407);
INSERT INTO public.europe_data VALUES (1221, 99, 4762, 167.39, 91, 407);
INSERT INTO public.europe_data VALUES (1222, 352, 10433, 73.62, 92, 407);
INSERT INTO public.europe_data VALUES (1223, 162, 10097, 18.95, 132, 407);
INSERT INTO public.europe_data VALUES (1224, 1750, 58310, 330.06, 188, 407);
INSERT INTO public.europe_data VALUES (1225, 543, 22545, 466.32, 189, 407);
INSERT INTO public.europe_data VALUES (1226, 74, 13317, 734.51, 93, 407);
INSERT INTO public.europe_data VALUES (1227, 1, 1061, 68.54, 133, 407);
INSERT INTO public.europe_data VALUES (1228, 940, 27135, 319.83, 190, 407);
INSERT INTO public.europe_data VALUES (1229, 6114, 315367, 290.74, 191, 407);
INSERT INTO public.europe_data VALUES (1230, 12, 728, 10.79, 40, 407);
INSERT INTO public.europe_data VALUES (1231, 0, 2, 7.57, 94, 407);
INSERT INTO public.europe_data VALUES (1232, 0, 18, 16.41, 95, 407);
INSERT INTO public.europe_data VALUES (1233, 0, 5, 9.95, 96, 407);
INSERT INTO public.europe_data VALUES (1234, 2, 168, 952.02, 192, 407);
INSERT INTO public.europe_data VALUES (1235, 0, 2, 2.33, 41, 407);
INSERT INTO public.europe_data VALUES (1236, 63, 1210, 6.81, 134, 407);
INSERT INTO public.europe_data VALUES (1237, 25, 970, 10.14, 42, 407);
INSERT INTO public.europe_data VALUES (1238, 340, 24872, 893.01, 193, 407);
INSERT INTO public.europe_data VALUES (1239, 0, 12, 15.35, 43, 407);
INSERT INTO public.europe_data VALUES (1240, 1, 51, 1.47, 44, 407);
INSERT INTO public.europe_data VALUES (1241, 0, 102, 3.51, 135, 407);
INSERT INTO public.europe_data VALUES (1242, 1, 73, 382.17, 97, 407);
INSERT INTO public.europe_data VALUES (1243, 324, 16756, 644.13, 194, 407);
INSERT INTO public.europe_data VALUES (1244, 216, 9428, 913.69, 195, 407);
INSERT INTO public.europe_data VALUES (1245, 0, 0, 0, 212, 407);
INSERT INTO public.europe_data VALUES (1246, 3, 28, 0.72, 45, 407);
INSERT INTO public.europe_data VALUES (1247, 2380, 89949, 257.7, 46, 407);
INSERT INTO public.europe_data VALUES (1248, 121, 7089, 27.71, 136, 407);
INSERT INTO public.europe_data VALUES (1249, 0, 263, 2.42, 47, 407);
INSERT INTO public.europe_data VALUES (1250, 862, 60164, 271.7, 196, 407);
INSERT INTO public.europe_data VALUES (1251, 15, 3793, 38.75, 137, 407);
INSERT INTO public.europe_data VALUES (1252, 34, 493, 4.51, 48, 407);
INSERT INTO public.europe_data VALUES (1253, 2, 430, 113.53, 98, 407);
INSERT INTO public.europe_data VALUES (1254, 638, 37138, 814.44, 197, 407);
INSERT INTO public.europe_data VALUES (1255, 563, 24084, 748.05, 198, 407);
INSERT INTO public.europe_data VALUES (1256, 68, 838, 10.94, 138, 407);
INSERT INTO public.europe_data VALUES (1257, 0, 27, 0.22, 139, 407);
INSERT INTO public.europe_data VALUES (1258, 1, 277, 5.72, 140, 407);
INSERT INTO public.europe_data VALUES (1259, 0, 1378, 2.94, 141, 407);
INSERT INTO public.europe_data VALUES (1260, 0, 10, 0.77, 142, 407);
INSERT INTO public.europe_data VALUES (1261, 2, 160, 4.02, 49, 407);
INSERT INTO public.europe_data VALUES (1262, 0, 103, 16.92, 99, 407);
INSERT INTO public.europe_data VALUES (1263, 267, 9874, 172.99, 50, 407);
INSERT INTO public.europe_data VALUES (1264, 1781, 122977, 379.07, 199, 407);
INSERT INTO public.europe_data VALUES (1265, 0, 51, 209.46, 100, 407);
INSERT INTO public.europe_data VALUES (1266, 17, 2786, 14.55, 51, 407);
INSERT INTO public.europe_data VALUES (1267, 1184, 59381, 294.83, 200, 407);
INSERT INTO public.europe_data VALUES (1268, 20, 8261, 172.84, 143, 407);
INSERT INTO public.europe_data VALUES (1269, 3708, 289583, 720.7, 201, 407);
INSERT INTO public.europe_data VALUES (1270, 0, 0, 0, 52, 407);
INSERT INTO public.europe_data VALUES (1271, 15656, 1306812, 879.73, 101, 407);
INSERT INTO public.europe_data VALUES (1272, 0, 83, 168.29, 102, 407);
INSERT INTO public.europe_data VALUES (1273, 41, 3829, 219.49, 103, 407);
INSERT INTO public.europe_data VALUES (1274, 1, 784, 5.27, 144, 407);
INSERT INTO public.europe_data VALUES (1275, 0, 0, 0, 213, 407);
INSERT INTO public.europe_data VALUES (1276, 26, 2241, 18.02, 104, 407);
INSERT INTO public.europe_data VALUES (1277, 0, 28, 0.05, 145, 407);
INSERT INTO public.europe_data VALUES (1278, 0, 0, 0, 214, 407);
INSERT INTO public.europe_data VALUES (1279, 0, 0, 0, 53, 407);
INSERT INTO public.europe_data VALUES (1280, 1, 9, 0.05, 146, 407);
INSERT INTO public.europe_data VALUES (1281, 11, 1227, 9.34, 54, 407);
INSERT INTO public.europe_data VALUES (1282, 34, 795, 12.99, 55, 407);
INSERT INTO public.europe_data VALUES (1283, 111, 740, 6.56, 105, 408);
INSERT INTO public.europe_data VALUES (1284, 85, 4473, 349.88, 147, 408);
INSERT INTO public.europe_data VALUES (1285, 70, 3101, 16.15, 1, 408);
INSERT INTO public.europe_data VALUES (1286, 2, 239, 691.81, 148, 408);
INSERT INTO public.europe_data VALUES (1287, 16, 456, 3.48, 2, 408);
INSERT INTO public.europe_data VALUES (1288, 0, 0, 6.72, 56, 408);
INSERT INTO public.europe_data VALUES (1289, 0, 5, 7.21, 57, 408);
INSERT INTO public.europe_data VALUES (1290, 1231, 48955, 187.63, 58, 408);
INSERT INTO public.europe_data VALUES (1291, 153, 5383, 396.28, 149, 408);
INSERT INTO public.europe_data VALUES (1292, 1, 127, 198.48, 59, 408);
INSERT INTO public.europe_data VALUES (1293, 0, 167, 0.92, 202, 408);
INSERT INTO public.europe_data VALUES (1294, 816, 16186, 397.87, 150, 408);
INSERT INTO public.europe_data VALUES (1295, 288, 26214, 551.46, 151, 408);
INSERT INTO public.europe_data VALUES (1296, 1, 91, 47.76, 60, 408);
INSERT INTO public.europe_data VALUES (1297, 1, 1139, 143.31, 106, 408);
INSERT INTO public.europe_data VALUES (1298, 228, 10180, 14.21, 107, 408);
INSERT INTO public.europe_data VALUES (1299, 0, 26, 12.19, 61, 408);
INSERT INTO public.europe_data VALUES (1300, 61, 13228, 278.93, 152, 408);
INSERT INTO public.europe_data VALUES (1301, 654, 17683, 300.96, 153, 408);
INSERT INTO public.europe_data VALUES (1302, 29, 850, 608.68, 62, 408);
INSERT INTO public.europe_data VALUES (1303, 0, 77, 0.95, 3, 408);
INSERT INTO public.europe_data VALUES (1304, 0, 96, 382.35, 63, 408);
INSERT INTO public.europe_data VALUES (1305, 0, 29, 4.85, 108, 408);
INSERT INTO public.europe_data VALUES (1306, 25, 3235, 41.91, 64, 408);
INSERT INTO public.europe_data VALUES (1307, 0, 6, 57.73, 65, 408);
INSERT INTO public.europe_data VALUES (1308, 289, 4407, 333.75, 154, 408);
INSERT INTO public.europe_data VALUES (1309, 0, 141, 64.37, 4, 408);
INSERT INTO public.europe_data VALUES (1310, 5889, 361667, 312.76, 66, 408);
INSERT INTO public.europe_data VALUES (1311, 0, 6, 43.29, 67, 408);
INSERT INTO public.europe_data VALUES (1312, 0, 0, 0.23, 109, 408);
INSERT INTO public.europe_data VALUES (1313, 921, 11746, 425.34, 155, 408);
INSERT INTO public.europe_data VALUES (1314, 5, 1130, 9.59, 5, 408);
INSERT INTO public.europe_data VALUES (1315, 1, 32, 0.58, 6, 408);
INSERT INTO public.europe_data VALUES (1316, 0, 4, 0.09, 110, 408);
INSERT INTO public.europe_data VALUES (1317, 3, 490, 4.24, 7, 408);
INSERT INTO public.europe_data VALUES (1318, 901, 54571, 267.65, 68, 408);
INSERT INTO public.europe_data VALUES (1319, 1, 222, 93.83, 8, 408);
INSERT INTO public.europe_data VALUES (1320, 0, 18, 43.11, 69, 408);
INSERT INTO public.europe_data VALUES (1321, 0, 2, 0.34, 9, 408);
INSERT INTO public.europe_data VALUES (1322, 0, 120, 1.03, 10, 408);
INSERT INTO public.europe_data VALUES (1323, 311, 15569, 143.02, 70, 408);
INSERT INTO public.europe_data VALUES (1324, 25, 3029, 0.22, 111, 408);
INSERT INTO public.europe_data VALUES (1325, 1627, 92293, 291.95, 71, 408);
INSERT INTO public.europe_data VALUES (1326, 0, 38, 5.88, 11, 408);
INSERT INTO public.europe_data VALUES (1327, 0, 0, 7.92, 12, 408);
INSERT INTO public.europe_data VALUES (1328, 101, 6724, 321.11, 72, 408);
INSERT INTO public.europe_data VALUES (1329, 0, 238, 1.68, 13, 408);
INSERT INTO public.europe_data VALUES (1330, 617, 19842, 1113.16, 156, 408);
INSERT INTO public.europe_data VALUES (1331, 0, 819, 12.88, 73, 408);
INSERT INTO public.europe_data VALUES (1332, 0, 350, 512.78, 74, 408);
INSERT INTO public.europe_data VALUES (1333, 13, 2587, 597.9, 157, 408);
INSERT INTO public.europe_data VALUES (1334, 802, 46444, 757.67, 158, 408);
INSERT INTO public.europe_data VALUES (1335, 210, 1297, 2.55, 14, 408);
INSERT INTO public.europe_data VALUES (1336, 94, 24676, 754.92, 159, 408);
INSERT INTO public.europe_data VALUES (1337, 0, 53, 8.22, 15, 408);
INSERT INTO public.europe_data VALUES (1338, 0, 4, 9.75, 75, 408);
INSERT INTO public.europe_data VALUES (1339, 24, 6360, 117.32, 76, 408);
INSERT INTO public.europe_data VALUES (1340, 74, 4219, 47.95, 77, 408);
INSERT INTO public.europe_data VALUES (1341, 178, 3980, 7.1, 16, 408);
INSERT INTO public.europe_data VALUES (1342, 52, 1892, 53.1, 78, 408);
INSERT INTO public.europe_data VALUES (1343, 0, 36, 4.79, 17, 408);
INSERT INTO public.europe_data VALUES (1344, 0, 96, 5, 18, 408);
INSERT INTO public.europe_data VALUES (1345, 25, 3739, 514.48, 160, 408);
INSERT INTO public.europe_data VALUES (1346, 13, 659, 80.65, 19, 408);
INSERT INTO public.europe_data VALUES (1347, 47, 3182, 5.94, 20, 408);
INSERT INTO public.europe_data VALUES (1348, 0, 4, 177.94, 79, 408);
INSERT INTO public.europe_data VALUES (1349, 0, 18, 73.96, 161, 408);
INSERT INTO public.europe_data VALUES (1350, 0, 0, 0.22, 203, 408);
INSERT INTO public.europe_data VALUES (1351, 28, 2352, 100.24, 162, 408);
INSERT INTO public.europe_data VALUES (1352, 2638, 96502, 269.88, 163, 408);
INSERT INTO public.europe_data VALUES (1353, 7, 435, 384.91, 204, 408);
INSERT INTO public.europe_data VALUES (1354, 1, 69, 7.64, 21, 408);
INSERT INTO public.europe_data VALUES (1355, 0, 7, 0.81, 22, 408);
INSERT INTO public.europe_data VALUES (1356, 301, 18399, 1113.05, 164, 408);
INSERT INTO public.europe_data VALUES (1357, 4300, 173574, 393.88, 165, 408);
INSERT INTO public.europe_data VALUES (1358, 4, 639, 4.53, 23, 408);
INSERT INTO public.europe_data VALUES (1359, 1, 169, 566.66, 166, 408);
INSERT INTO public.europe_data VALUES (1360, 547, 6538, 145.47, 167, 408);
INSERT INTO public.europe_data VALUES (1361, 0, 0, 1.76, 80, 408);
INSERT INTO public.europe_data VALUES (1362, 0, 38, 58.93, 81, 408);
INSERT INTO public.europe_data VALUES (1363, 2, 105, 123.73, 205, 408);
INSERT INTO public.europe_data VALUES (1364, 295, 4319, 45.79, 82, 408);
INSERT INTO public.europe_data VALUES (1365, 0, 4, 7.76, 168, 408);
INSERT INTO public.europe_data VALUES (1366, 0, 93, 2.48, 24, 408);
INSERT INTO public.europe_data VALUES (1367, 0, 0, 0.26, 25, 408);
INSERT INTO public.europe_data VALUES (1368, 4, 251, 64.64, 83, 408);
INSERT INTO public.europe_data VALUES (1369, 1, 206, 3.56, 84, 408);
INSERT INTO public.europe_data VALUES (1370, 0, 0, 0, 169, 408);
INSERT INTO public.europe_data VALUES (1371, 52, 2663, 61.55, 85, 408);
INSERT INTO public.europe_data VALUES (1372, 1152, 21260, 521.67, 170, 408);
INSERT INTO public.europe_data VALUES (1373, 0, 85, 44.82, 171, 408);
INSERT INTO public.europe_data VALUES (1374, 2455, 171460, 27.69, 112, 408);
INSERT INTO public.europe_data VALUES (1375, 1061, 47110, 32.94, 113, 408);
INSERT INTO public.europe_data VALUES (1376, 1252, 43803, 134.51, 114, 408);
INSERT INTO public.europe_data VALUES (1377, 118, 9511, 50.74, 115, 408);
INSERT INTO public.europe_data VALUES (1378, 34, 3357, 107.99, 172, 408);
INSERT INTO public.europe_data VALUES (1379, 0, 0, 3.55, 173, 408);
INSERT INTO public.europe_data VALUES (1380, 102, 18500, 365.73, 116, 408);
INSERT INTO public.europe_data VALUES (1381, 4279, 109473, 371.62, 174, 408);
INSERT INTO public.europe_data VALUES (1382, 13, 579, 39.65, 86, 408);
INSERT INTO public.europe_data VALUES (1383, 315, 18870, 28.74, 117, 408);
INSERT INTO public.europe_data VALUES (1384, 4, 557, 908.2, 175, 408);
INSERT INTO public.europe_data VALUES (1385, 239, 17834, 369.83, 118, 408);
INSERT INTO public.europe_data VALUES (1386, 70, 5373, 62.32, 119, 408);
INSERT INTO public.europe_data VALUES (1387, 52, 2608, 11.64, 26, 408);
INSERT INTO public.europe_data VALUES (1388, 64, 2589, 353.85, 176, 408);
INSERT INTO public.europe_data VALUES (1389, 10, 1761, 85.81, 120, 408);
INSERT INTO public.europe_data VALUES (1390, 19, 1580, 60.15, 121, 408);
INSERT INTO public.europe_data VALUES (1391, 0, 0, 0, 122, 408);
INSERT INTO public.europe_data VALUES (1392, 90, 5265, 501.41, 177, 408);
INSERT INTO public.europe_data VALUES (1393, 81, 11584, 305.6, 123, 408);
INSERT INTO public.europe_data VALUES (1394, 4, 261, 18.63, 27, 408);
INSERT INTO public.europe_data VALUES (1395, 0, 17, 2.27, 28, 408);
INSERT INTO public.europe_data VALUES (1396, 70, 4421, 127.19, 29, 408);
INSERT INTO public.europe_data VALUES (1397, 6, 315, 1128.25, 178, 408);
INSERT INTO public.europe_data VALUES (1398, 214, 19466, 1376.11, 179, 408);
INSERT INTO public.europe_data VALUES (1399, 44, 2795, 1039.76, 180, 408);
INSERT INTO public.europe_data VALUES (1400, 2, 0, 0.44, 30, 408);
INSERT INTO public.europe_data VALUES (1401, 0, 95, 0.59, 31, 408);
INSERT INTO public.europe_data VALUES (1402, 22, 9834, 64.52, 124, 408);
INSERT INTO public.europe_data VALUES (1403, 0, 125, 55.56, 125, 408);
INSERT INTO public.europe_data VALUES (1404, 28, 377, 5.37, 32, 408);
INSERT INTO public.europe_data VALUES (1405, 20, 548, 231.58, 181, 408);
INSERT INTO public.europe_data VALUES (1406, 0, 0, 0, 206, 408);
INSERT INTO public.europe_data VALUES (1407, 56, 1447, 81.93, 33, 408);
INSERT INTO public.europe_data VALUES (1408, 0, 3, 1.65, 34, 408);
INSERT INTO public.europe_data VALUES (1409, 4645, 75871, 117.63, 87, 408);
INSERT INTO public.europe_data VALUES (1410, 180, 8689, 459.33, 182, 408);
INSERT INTO public.europe_data VALUES (1411, 0, 60, 272.03, 183, 408);
INSERT INTO public.europe_data VALUES (1412, 0, 81, 3.29, 126, 408);
INSERT INTO public.europe_data VALUES (1413, 44, 2529, 917.58, 184, 408);
INSERT INTO public.europe_data VALUES (1414, 0, 0, 0, 88, 408);
INSERT INTO public.europe_data VALUES (1415, 333, 17516, 102.73, 35, 408);
INSERT INTO public.europe_data VALUES (1416, 6, 614, 4.36, 36, 408);
INSERT INTO public.europe_data VALUES (1417, 175, 7792, 31.42, 127, 408);
INSERT INTO public.europe_data VALUES (1418, 17, 2178, 145.76, 37, 408);
INSERT INTO public.europe_data VALUES (1419, 90, 5349, 44.71, 128, 408);
INSERT INTO public.europe_data VALUES (1420, 443, 76154, 765.8, 185, 408);
INSERT INTO public.europe_data VALUES (1421, 0, 1, 0.71, 208, 408);
INSERT INTO public.europe_data VALUES (1422, 0, 25, 0.88, 209, 408);
INSERT INTO public.europe_data VALUES (1423, 1, 51, 1.53, 89, 408);
INSERT INTO public.europe_data VALUES (1424, 7, 401, 3.44, 38, 408);
INSERT INTO public.europe_data VALUES (1425, 24, 5259, 4.57, 39, 408);
INSERT INTO public.europe_data VALUES (1426, 171, 4667, 497.66, 186, 408);
INSERT INTO public.europe_data VALUES (1427, 0, 3, 12.23, 210, 408);
INSERT INTO public.europe_data VALUES (1428, 11, 1772, 101.42, 187, 408);
INSERT INTO public.europe_data VALUES (1429, 17, 1427, 55.9, 129, 408);
INSERT INTO public.europe_data VALUES (1430, 560, 18181, 17.86, 130, 408);
INSERT INTO public.europe_data VALUES (1431, 208, 15390, 562.33, 131, 408);
INSERT INTO public.europe_data VALUES (1432, 241, 21031, 855.28, 90, 408);
INSERT INTO public.europe_data VALUES (1433, 1, 36, 1.03, 211, 408);
INSERT INTO public.europe_data VALUES (1434, 150, 7030, 180.17, 91, 408);
INSERT INTO public.europe_data VALUES (1435, 496, 13502, 75.55, 92, 408);
INSERT INTO public.europe_data VALUES (1436, 214, 10389, 18.46, 132, 408);
INSERT INTO public.europe_data VALUES (1437, 2533, 67024, 366.71, 188, 408);
INSERT INTO public.europe_data VALUES (1438, 575, 25377, 502.57, 189, 408);
INSERT INTO public.europe_data VALUES (1439, 110, 8229, 589.18, 93, 408);
INSERT INTO public.europe_data VALUES (1440, 2, 880, 73.9, 133, 408);
INSERT INTO public.europe_data VALUES (1441, 1009, 34959, 400.31, 190, 408);
INSERT INTO public.europe_data VALUES (1442, 2210, 108740, 206.96, 191, 408);
INSERT INTO public.europe_data VALUES (1443, 7, 634, 9.22, 40, 408);
INSERT INTO public.europe_data VALUES (1444, 0, 2, 9.46, 94, 408);
INSERT INTO public.europe_data VALUES (1445, 1, 12, 12.04, 95, 408);
INSERT INTO public.europe_data VALUES (1446, 0, 6, 15.37, 96, 408);
INSERT INTO public.europe_data VALUES (1447, 4, 160, 923, 192, 408);
INSERT INTO public.europe_data VALUES (1448, 0, 3, 6.05, 41, 408);
INSERT INTO public.europe_data VALUES (1449, 74, 1122, 6.7, 134, 408);
INSERT INTO public.europe_data VALUES (1450, 16, 683, 7.86, 42, 408);
INSERT INTO public.europe_data VALUES (1451, 402, 37315, 1207.61, 193, 408);
INSERT INTO public.europe_data VALUES (1452, 0, 3, 21.49, 43, 408);
INSERT INTO public.europe_data VALUES (1453, 0, 64, 1.06, 44, 408);
INSERT INTO public.europe_data VALUES (1454, 0, 102, 2.79, 135, 408);
INSERT INTO public.europe_data VALUES (1455, 0, 89, 464.74, 97, 408);
INSERT INTO public.europe_data VALUES (1456, 380, 18352, 634.91, 194, 408);
INSERT INTO public.europe_data VALUES (1457, 156, 9585, 965.64, 195, 408);
INSERT INTO public.europe_data VALUES (1458, 0, 0, 0, 212, 408);
INSERT INTO public.europe_data VALUES (1459, 3, 83, 0.89, 45, 408);
INSERT INTO public.europe_data VALUES (1460, 1415, 60958, 183.33, 46, 408);
INSERT INTO public.europe_data VALUES (1461, 111, 7107, 24.27, 136, 408);
INSERT INTO public.europe_data VALUES (1462, 0, 5, 0.42, 47, 408);
INSERT INTO public.europe_data VALUES (1463, 1247, 67365, 249.1, 196, 408);
INSERT INTO public.europe_data VALUES (1464, 24, 4471, 44.01, 137, 408);
INSERT INTO public.europe_data VALUES (1465, 87, 1437, 7.84, 48, 408);
INSERT INTO public.europe_data VALUES (1466, 1, 230, 44.55, 98, 408);
INSERT INTO public.europe_data VALUES (1467, 645, 46181, 877.91, 197, 408);
INSERT INTO public.europe_data VALUES (1468, 802, 39833, 808.25, 198, 408);
INSERT INTO public.europe_data VALUES (1469, 92, 1029, 10.5, 138, 408);
INSERT INTO public.europe_data VALUES (1470, 0, 26, 0.21, 139, 408);
INSERT INTO public.europe_data VALUES (1471, 1, 256, 5.71, 140, 408);
INSERT INTO public.europe_data VALUES (1472, 0, 670, 1.15, 141, 408);
INSERT INTO public.europe_data VALUES (1473, 0, 0, 0, 142, 408);
INSERT INTO public.europe_data VALUES (1474, 0, 165, 3.97, 49, 408);
INSERT INTO public.europe_data VALUES (1475, 3, 133, 17.56, 99, 408);
INSERT INTO public.europe_data VALUES (1476, 305, 10357, 151.49, 50, 408);
INSERT INTO public.europe_data VALUES (1477, 1680, 187873, 492.06, 199, 408);
INSERT INTO public.europe_data VALUES (1478, 0, 29, 109.96, 100, 408);
INSERT INTO public.europe_data VALUES (1479, 10, 3655, 19.63, 51, 408);
INSERT INTO public.europe_data VALUES (1480, 1418, 70327, 358.43, 200, 408);
INSERT INTO public.europe_data VALUES (1481, 20, 8626, 175.49, 143, 408);
INSERT INTO public.europe_data VALUES (1482, 3231, 190744, 475.5, 201, 408);
INSERT INTO public.europe_data VALUES (1483, 0, 0, 0, 52, 408);
INSERT INTO public.europe_data VALUES (1484, 18493, 1588085, 938.37, 101, 408);
INSERT INTO public.europe_data VALUES (1485, 0, 93, 260.09, 102, 408);
INSERT INTO public.europe_data VALUES (1486, 27, 3769, 178.35, 103, 408);
INSERT INTO public.europe_data VALUES (1487, 0, 954, 6.05, 144, 408);
INSERT INTO public.europe_data VALUES (1488, 0, 0, 0, 213, 408);
INSERT INTO public.europe_data VALUES (1489, 39, 2898, 19.75, 104, 408);
INSERT INTO public.europe_data VALUES (1490, 0, 16, 0.05, 145, 408);
INSERT INTO public.europe_data VALUES (1491, 0, 1, 0, 214, 408);
INSERT INTO public.europe_data VALUES (1492, 0, 0, 0, 53, 408);
INSERT INTO public.europe_data VALUES (1493, 1, 6, 0.04, 146, 408);
INSERT INTO public.europe_data VALUES (1494, 6, 442, 4.48, 54, 408);
INSERT INTO public.europe_data VALUES (1495, 13, 1107, 11.16, 55, 408);
INSERT INTO public.europe_data VALUES (1496, 71, 1757, 9.01, 105, 409);
INSERT INTO public.europe_data VALUES (1497, 98, 5542, 380.97, 147, 409);
INSERT INTO public.europe_data VALUES (1498, 80, 3850, 22.95, 1, 409);
INSERT INTO public.europe_data VALUES (1499, 1, 288, 821.77, 148, 409);
INSERT INTO public.europe_data VALUES (1500, 17, 652, 3.41, 2, 409);
INSERT INTO public.europe_data VALUES (1501, 0, 1, 40.34, 56, 409);
INSERT INTO public.europe_data VALUES (1502, 1, 2, 7.21, 57, 409);
INSERT INTO public.europe_data VALUES (1503, 996, 35067, 177.23, 58, 409);
INSERT INTO public.europe_data VALUES (1504, 159, 6338, 458.39, 149, 409);
INSERT INTO public.europe_data VALUES (1505, 1, 84, 198.48, 59, 409);
INSERT INTO public.europe_data VALUES (1506, 0, 66, 0.55, 202, 409);
INSERT INTO public.europe_data VALUES (1507, 668, 19060, 472.46, 150, 409);
INSERT INTO public.europe_data VALUES (1508, 290, 29195, 574.05, 151, 409);
INSERT INTO public.europe_data VALUES (1509, 0, 95, 45.7, 60, 409);
INSERT INTO public.europe_data VALUES (1510, 7, 1213, 143.56, 106, 409);
INSERT INTO public.europe_data VALUES (1511, 214, 12988, 17.25, 107, 409);
INSERT INTO public.europe_data VALUES (1512, 0, 9, 7.32, 61, 409);
INSERT INTO public.europe_data VALUES (1513, 56, 13138, 267.52, 152, 409);
INSERT INTO public.europe_data VALUES (1514, 666, 16793, 279.93, 153, 409);
INSERT INTO public.europe_data VALUES (1515, 22, 1526, 909.95, 62, 409);
INSERT INTO public.europe_data VALUES (1516, 0, 35, 0.98, 3, 409);
INSERT INTO public.europe_data VALUES (1517, 0, 143, 287.96, 63, 409);
INSERT INTO public.europe_data VALUES (1518, 0, 8, 5.5, 108, 409);
INSERT INTO public.europe_data VALUES (1519, 23, 1590, 21.96, 64, 409);
INSERT INTO public.europe_data VALUES (1520, 0, 9, 46.18, 65, 409);
INSERT INTO public.europe_data VALUES (1521, 384, 6610, 416.33, 154, 409);
INSERT INTO public.europe_data VALUES (1522, 4, 1342, 125.06, 4, 409);
INSERT INTO public.europe_data VALUES (1523, 4461, 298412, 278.23, 66, 409);
INSERT INTO public.europe_data VALUES (1524, 0, 7, 23.31, 67, 409);
INSERT INTO public.europe_data VALUES (1525, 0, 1, 0.46, 109, 409);
INSERT INTO public.europe_data VALUES (1526, 891, 18028, 528.04, 155, 409);
INSERT INTO public.europe_data VALUES (1527, 3, 818, 5.78, 5, 409);
INSERT INTO public.europe_data VALUES (1528, 0, 35, 0.42, 6, 409);
INSERT INTO public.europe_data VALUES (1529, 0, 11, 0.22, 110, 409);
INSERT INTO public.europe_data VALUES (1530, 2, 607, 4.8, 7, 409);
INSERT INTO public.europe_data VALUES (1531, 766, 45561, 241.81, 68, 409);
INSERT INTO public.europe_data VALUES (1532, 1, 294, 151.11, 8, 409);
INSERT INTO public.europe_data VALUES (1533, 0, 10, 36.95, 69, 409);
INSERT INTO public.europe_data VALUES (1534, 0, 14, 0.48, 9, 409);
INSERT INTO public.europe_data VALUES (1535, 0, 45, 0.55, 10, 409);
INSERT INTO public.europe_data VALUES (1536, 258, 11537, 113.39, 70, 409);
INSERT INTO public.europe_data VALUES (1537, 0, 103, 0.01, 111, 409);
INSERT INTO public.europe_data VALUES (1538, 1245, 54671, 233.21, 71, 409);
INSERT INTO public.europe_data VALUES (1539, 0, 12, 2, 11, 409);
INSERT INTO public.europe_data VALUES (1540, 6, 426, 7.92, 12, 409);
INSERT INTO public.europe_data VALUES (1541, 163, 9484, 318.49, 72, 409);
INSERT INTO public.europe_data VALUES (1542, 1, 195, 1.44, 13, 409);
INSERT INTO public.europe_data VALUES (1543, 466, 25533, 1208.81, 156, 409);
INSERT INTO public.europe_data VALUES (1544, 1, 641, 10.5, 73, 409);
INSERT INTO public.europe_data VALUES (1545, 4, 488, 771.01, 74, 409);
INSERT INTO public.europe_data VALUES (1546, 17, 2650, 538.65, 157, 409);
INSERT INTO public.europe_data VALUES (1547, 707, 34246, 576.12, 158, 409);
INSERT INTO public.europe_data VALUES (1548, 12, 918, 2.09, 14, 409);
INSERT INTO public.europe_data VALUES (1549, 56, 19155, 523.69, 159, 409);
INSERT INTO public.europe_data VALUES (1550, 0, 27, 5.24, 15, 409);
INSERT INTO public.europe_data VALUES (1551, 0, 3, 4.18, 75, 409);
INSERT INTO public.europe_data VALUES (1552, 16, 6239, 104.47, 76, 409);
INSERT INTO public.europe_data VALUES (1553, 97, 4112, 57.52, 77, 409);
INSERT INTO public.europe_data VALUES (1554, 149, 3143, 6.01, 16, 409);
INSERT INTO public.europe_data VALUES (1555, 41, 1535, 53.85, 78, 409);
INSERT INTO public.europe_data VALUES (1556, 0, 29, 3.1, 17, 409);
INSERT INTO public.europe_data VALUES (1557, 0, 79, 3.83, 18, 409);
INSERT INTO public.europe_data VALUES (1558, 18, 3077, 453.12, 160, 409);
INSERT INTO public.europe_data VALUES (1559, 5, 267, 31.18, 19, 409);
INSERT INTO public.europe_data VALUES (1560, 59, 3474, 6.46, 20, 409);
INSERT INTO public.europe_data VALUES (1561, 0, 2, 59.31, 79, 409);
INSERT INTO public.europe_data VALUES (1562, 0, 18, 53.41, 161, 409);
INSERT INTO public.europe_data VALUES (1563, 0, 2, 0.45, 203, 409);
INSERT INTO public.europe_data VALUES (1564, 46, 3179, 112.02, 162, 409);
INSERT INTO public.europe_data VALUES (1565, 2756, 84355, 236.33, 163, 409);
INSERT INTO public.europe_data VALUES (1566, 17, 640, 591.15, 204, 409);
INSERT INTO public.europe_data VALUES (1567, 3, 97, 7.36, 21, 409);
INSERT INTO public.europe_data VALUES (1568, 0, 12, 2.04, 22, 409);
INSERT INTO public.europe_data VALUES (1569, 299, 26087, 1388.1, 164, 409);
INSERT INTO public.europe_data VALUES (1570, 3056, 153424, 341.14, 165, 409);
INSERT INTO public.europe_data VALUES (1571, 2, 740, 4.75, 23, 409);
INSERT INTO public.europe_data VALUES (1572, 0, 22, 180.98, 166, 409);
INSERT INTO public.europe_data VALUES (1573, 622, 9063, 189.35, 167, 409);
INSERT INTO public.europe_data VALUES (1574, 0, 1, 1.76, 80, 409);
INSERT INTO public.europe_data VALUES (1575, 0, 28, 25, 81, 409);
INSERT INTO public.europe_data VALUES (1576, 5, 102, 172.15, 205, 409);
INSERT INTO public.europe_data VALUES (1577, 173, 3732, 41.58, 82, 409);
INSERT INTO public.europe_data VALUES (1578, 0, 1, 4.65, 168, 409);
INSERT INTO public.europe_data VALUES (1579, 4, 224, 3.27, 24, 409);
INSERT INTO public.europe_data VALUES (1580, 0, 5, 1.3, 25, 409);
INSERT INTO public.europe_data VALUES (1581, 2, 255, 69.5, 83, 409);
INSERT INTO public.europe_data VALUES (1582, 1, 195, 2.67, 84, 409);
INSERT INTO public.europe_data VALUES (1583, 0, 0, 0, 169, 409);
INSERT INTO public.europe_data VALUES (1584, 29, 3336, 66.4, 85, 409);
INSERT INTO public.europe_data VALUES (1585, 1146, 29722, 683, 170, 409);
INSERT INTO public.europe_data VALUES (1586, 1, 75, 49.3, 171, 409);
INSERT INTO public.europe_data VALUES (1587, 2782, 206897, 33.11, 112, 409);
INSERT INTO public.europe_data VALUES (1588, 1079, 42024, 30.87, 113, 409);
INSERT INTO public.europe_data VALUES (1589, 1886, 67722, 192.39, 114, 409);
INSERT INTO public.europe_data VALUES (1590, 147, 10434, 61.56, 115, 409);
INSERT INTO public.europe_data VALUES (1591, 27, 1939, 80.42, 172, 409);
INSERT INTO public.europe_data VALUES (1592, 0, 3, 4.73, 173, 409);
INSERT INTO public.europe_data VALUES (1593, 82, 12658, 256.81, 116, 409);
INSERT INTO public.europe_data VALUES (1594, 4442, 114834, 428.32, 174, 409);
INSERT INTO public.europe_data VALUES (1595, 8, 590, 33.95, 86, 409);
INSERT INTO public.europe_data VALUES (1596, 250, 17586, 25.93, 117, 409);
INSERT INTO public.europe_data VALUES (1597, 0, 422, 789.45, 175, 409);
INSERT INTO public.europe_data VALUES (1598, 309, 19525, 448.51, 118, 409);
INSERT INTO public.europe_data VALUES (1599, 64, 6188, 67.22, 119, 409);
INSERT INTO public.europe_data VALUES (1600, 61, 3512, 16.31, 26, 409);
INSERT INTO public.europe_data VALUES (1601, 92, 3775, 418.29, 176, 409);
INSERT INTO public.europe_data VALUES (1602, 20, 1849, 90.13, 120, 409);
INSERT INTO public.europe_data VALUES (1603, 15, 2279, 75.86, 121, 409);
INSERT INTO public.europe_data VALUES (1604, 0, 0, 0.03, 122, 409);
INSERT INTO public.europe_data VALUES (1605, 87, 4362, 453.13, 177, 409);
INSERT INTO public.europe_data VALUES (1606, 101, 9367, 285.54, 123, 409);
INSERT INTO public.europe_data VALUES (1607, 0, 135, 8.28, 27, 409);
INSERT INTO public.europe_data VALUES (1608, 0, 95, 3.56, 28, 409);
INSERT INTO public.europe_data VALUES (1609, 68, 4199, 123.19, 29, 409);
INSERT INTO public.europe_data VALUES (1610, 2, 118, 627.96, 178, 409);
INSERT INTO public.europe_data VALUES (1611, 188, 18985, 1205.93, 179, 409);
INSERT INTO public.europe_data VALUES (1612, 46, 3588, 1188.97, 180, 409);
INSERT INTO public.europe_data VALUES (1613, 3, 120, 1.08, 30, 409);
INSERT INTO public.europe_data VALUES (1614, 2, 15, 0.22, 31, 409);
INSERT INTO public.europe_data VALUES (1615, 33, 10781, 59.44, 124, 409);
INSERT INTO public.europe_data VALUES (1616, 1, 170, 70.44, 125, 409);
INSERT INTO public.europe_data VALUES (1617, 30, 679, 5.88, 32, 409);
INSERT INTO public.europe_data VALUES (1618, 21, 595, 279.8, 181, 409);
INSERT INTO public.europe_data VALUES (1619, 0, 0, 0, 206, 409);
INSERT INTO public.europe_data VALUES (1620, 48, 2261, 53.52, 33, 409);
INSERT INTO public.europe_data VALUES (1621, 0, 18, 1.73, 34, 409);
INSERT INTO public.europe_data VALUES (1622, 4236, 74194, 112.07, 87, 409);
INSERT INTO public.europe_data VALUES (1623, 153, 9883, 482.31, 182, 409);
INSERT INTO public.europe_data VALUES (1624, 0, 30, 181.35, 183, 409);
INSERT INTO public.europe_data VALUES (1625, 0, 25, 3.75, 126, 409);
INSERT INTO public.europe_data VALUES (1626, 49, 3180, 1051.94, 184, 409);
INSERT INTO public.europe_data VALUES (1627, 0, 0, 0, 88, 409);
INSERT INTO public.europe_data VALUES (1628, 379, 19952, 125.59, 35, 409);
INSERT INTO public.europe_data VALUES (1629, 9, 710, 4.42, 36, 409);
INSERT INTO public.europe_data VALUES (1630, 158, 9187, 34.89, 127, 409);
INSERT INTO public.europe_data VALUES (1631, 8, 1458, 87.83, 37, 409);
INSERT INTO public.europe_data VALUES (1632, 104, 7442, 57.48, 128, 409);
INSERT INTO public.europe_data VALUES (1633, 360, 56193, 546.65, 185, 409);
INSERT INTO public.europe_data VALUES (1634, 0, 1, 1.41, 208, 409);
INSERT INTO public.europe_data VALUES (1635, 0, 17, 0.84, 209, 409);
INSERT INTO public.europe_data VALUES (1636, 1, 49, 1.57, 89, 409);
INSERT INTO public.europe_data VALUES (1637, 3, 402, 3.18, 38, 409);
INSERT INTO public.europe_data VALUES (1638, 17, 3920, 2.87, 39, 409);
INSERT INTO public.europe_data VALUES (1639, 197, 5670, 582.29, 186, 409);
INSERT INTO public.europe_data VALUES (1640, 0, 4, 12.23, 210, 409);
INSERT INTO public.europe_data VALUES (1641, 39, 3632, 117.41, 187, 409);
INSERT INTO public.europe_data VALUES (1642, 27, 1354, 55.4, 129, 409);
INSERT INTO public.europe_data VALUES (1643, 434, 20493, 19.75, 130, 409);
INSERT INTO public.europe_data VALUES (1644, 157, 12622, 559.46, 131, 409);
INSERT INTO public.europe_data VALUES (1645, 163, 15288, 665.92, 90, 409);
INSERT INTO public.europe_data VALUES (1646, 1, 54, 0.8, 211, 409);
INSERT INTO public.europe_data VALUES (1647, 100, 5662, 165.74, 91, 409);
INSERT INTO public.europe_data VALUES (1648, 403, 11061, 69.03, 92, 409);
INSERT INTO public.europe_data VALUES (1649, 179, 9566, 18.07, 132, 409);
INSERT INTO public.europe_data VALUES (1650, 2775, 72227, 396.6, 188, 409);
INSERT INTO public.europe_data VALUES (1651, 596, 26270, 524.93, 189, 409);
INSERT INTO public.europe_data VALUES (1652, 80, 9054, 564.63, 93, 409);
INSERT INTO public.europe_data VALUES (1653, 2, 1213, 87.32, 133, 409);
INSERT INTO public.europe_data VALUES (1654, 1065, 42759, 436.78, 190, 409);
INSERT INTO public.europe_data VALUES (1655, 3800, 193158, 263.66, 191, 409);
INSERT INTO public.europe_data VALUES (1656, 5, 530, 5.86, 40, 409);
INSERT INTO public.europe_data VALUES (1657, 0, 3, 11.36, 94, 409);
INSERT INTO public.europe_data VALUES (1658, 2, 10, 9.85, 95, 409);
INSERT INTO public.europe_data VALUES (1659, 0, 11, 11.75, 96, 409);
INSERT INTO public.europe_data VALUES (1660, 3, 158, 1047.8, 192, 409);
INSERT INTO public.europe_data VALUES (1661, 0, 10, 9.3, 41, 409);
INSERT INTO public.europe_data VALUES (1662, 83, 1175, 8.05, 134, 409);
INSERT INTO public.europe_data VALUES (1663, 11, 598, 6.14, 42, 409);
INSERT INTO public.europe_data VALUES (1664, 382, 46780, 1396.06, 193, 409);
INSERT INTO public.europe_data VALUES (1665, 0, 18, 29.67, 43, 409);
INSERT INTO public.europe_data VALUES (1666, 1, 19, 0.44, 44, 409);
INSERT INTO public.europe_data VALUES (1667, 0, 60, 1.84, 135, 409);
INSERT INTO public.europe_data VALUES (1668, 0, 108, 431.72, 97, 409);
INSERT INTO public.europe_data VALUES (1669, 179, 16253, 499.98, 194, 409);
INSERT INTO public.europe_data VALUES (1670, 954, 10509, 1005.96, 195, 409);
INSERT INTO public.europe_data VALUES (1671, 0, 0, 0, 212, 409);
INSERT INTO public.europe_data VALUES (1672, 0, 54, 0.87, 45, 409);
INSERT INTO public.europe_data VALUES (1673, 1070, 46399, 125.11, 46, 409);
INSERT INTO public.europe_data VALUES (1674, 38, 5323, 18.12, 136, 409);
INSERT INTO public.europe_data VALUES (1675, 0, 42, 1.03, 47, 409);
INSERT INTO public.europe_data VALUES (1676, 1367, 49556, 220.93, 196, 409);
INSERT INTO public.europe_data VALUES (1677, 12, 4913, 43.64, 137, 409);
INSERT INTO public.europe_data VALUES (1678, 52, 1918, 8.78, 48, 409);
INSERT INTO public.europe_data VALUES (1679, 0, 29, 7.05, 98, 409);
INSERT INTO public.europe_data VALUES (1680, 499, 43631, 786.61, 197, 409);
INSERT INTO public.europe_data VALUES (1681, 546, 29228, 647.34, 198, 409);
INSERT INTO public.europe_data VALUES (1682, 71, 763, 8.02, 138, 409);
INSERT INTO public.europe_data VALUES (1683, 0, 24, 0.27, 139, 409);
INSERT INTO public.europe_data VALUES (1684, 1, 276, 5.89, 140, 409);
INSERT INTO public.europe_data VALUES (1685, 0, 130, 0.37, 141, 409);
INSERT INTO public.europe_data VALUES (1686, 0, 0, 0.08, 142, 409);
INSERT INTO public.europe_data VALUES (1687, 1, 156, 3.58, 49, 409);
INSERT INTO public.europe_data VALUES (1688, 0, 112, 15.7, 99, 409);
INSERT INTO public.europe_data VALUES (1689, 333, 7359, 129.2, 50, 409);
INSERT INTO public.europe_data VALUES (1690, 1517, 215632, 532.05, 199, 409);
INSERT INTO public.europe_data VALUES (1691, 0, 13, 54.98, 100, 409);
INSERT INTO public.europe_data VALUES (1692, 15, 5033, 16.69, 51, 409);
INSERT INTO public.europe_data VALUES (1693, 1659, 87360, 404.57, 200, 409);
INSERT INTO public.europe_data VALUES (1694, 25, 8520, 176, 143, 409);
INSERT INTO public.europe_data VALUES (1695, 2925, 126161, 348.22, 201, 409);
INSERT INTO public.europe_data VALUES (1696, 0, 0, 0, 52, 409);
INSERT INTO public.europe_data VALUES (1697, 16867, 1499756, 873.21, 101, 409);
INSERT INTO public.europe_data VALUES (1698, 0, 179, 271.57, 102, 409);
INSERT INTO public.europe_data VALUES (1699, 10, 2405, 115.32, 103, 409);
INSERT INTO public.europe_data VALUES (1700, 1, 1041, 6.74, 144, 409);
INSERT INTO public.europe_data VALUES (1701, 0, 0, 0, 213, 409);
INSERT INTO public.europe_data VALUES (1702, 30, 2735, 18.01, 104, 409);
INSERT INTO public.europe_data VALUES (1703, 0, 31, 0.06, 145, 409);
INSERT INTO public.europe_data VALUES (1704, 0, 0, 0, 214, 409);
INSERT INTO public.europe_data VALUES (1705, 0, 0, 0, 53, 409);
INSERT INTO public.europe_data VALUES (1706, 0, 6, 0.02, 146, 409);
INSERT INTO public.europe_data VALUES (1707, 3, 358, 3.73, 54, 409);
INSERT INTO public.europe_data VALUES (1708, 16, 528, 8.85, 55, 409);
INSERT INTO public.europe_data VALUES (1709, 137, 1672, 7.22, 105, 410);
INSERT INTO public.europe_data VALUES (1710, 107, 5363, 357.28, 147, 410);
INSERT INTO public.europe_data VALUES (1711, 106, 6031, 31.1, 1, 410);
INSERT INTO public.europe_data VALUES (1712, 2, 338, 1042.31, 148, 410);
INSERT INTO public.europe_data VALUES (1713, 8, 433, 3.28, 2, 410);
INSERT INTO public.europe_data VALUES (1714, 0, 5, 33.62, 56, 410);
INSERT INTO public.europe_data VALUES (1715, 0, 5, 7.21, 57, 410);
INSERT INTO public.europe_data VALUES (1716, 1297, 44299, 207.1, 58, 410);
INSERT INTO public.europe_data VALUES (1717, 180, 7220, 528.62, 149, 410);
INSERT INTO public.europe_data VALUES (1718, 0, 127, 220.11, 59, 410);
INSERT INTO public.europe_data VALUES (1719, 1, 72, 0.57, 202, 410);
INSERT INTO public.europe_data VALUES (1720, 828, 22794, 619.18, 150, 410);
INSERT INTO public.europe_data VALUES (1721, 271, 28484, 533.31, 151, 410);
INSERT INTO public.europe_data VALUES (1722, 0, 83, 42.62, 60, 410);
INSERT INTO public.europe_data VALUES (1723, 0, 1143, 135.57, 106, 410);
INSERT INTO public.europe_data VALUES (1724, 229, 15138, 18.52, 107, 410);
INSERT INTO public.europe_data VALUES (1725, 0, 12, 9.76, 61, 410);
INSERT INTO public.europe_data VALUES (1726, 56, 12149, 245, 152, 410);
INSERT INTO public.europe_data VALUES (1727, 699, 15275, 275.22, 153, 410);
INSERT INTO public.europe_data VALUES (1728, 26, 2026, 662.48, 62, 410);
INSERT INTO public.europe_data VALUES (1729, 1, 81, 1.18, 3, 410);
INSERT INTO public.europe_data VALUES (1730, 0, 37, 97.59, 63, 410);
INSERT INTO public.europe_data VALUES (1731, 0, 34, 6.29, 108, 410);
INSERT INTO public.europe_data VALUES (1732, 43, 938, 14.23, 64, 410);
INSERT INTO public.europe_data VALUES (1733, 0, 3, 11.55, 65, 410);
INSERT INTO public.europe_data VALUES (1734, 332, 7133, 439.26, 154, 410);
INSERT INTO public.europe_data VALUES (1735, 3, 1539, 84.08, 4, 410);
INSERT INTO public.europe_data VALUES (1736, 4108, 288800, 252.14, 66, 410);
INSERT INTO public.europe_data VALUES (1737, 0, 0, 3.33, 67, 410);
INSERT INTO public.europe_data VALUES (1738, 0, 1, 0.69, 109, 410);
INSERT INTO public.europe_data VALUES (1739, 983, 18935, 565.73, 155, 410);
INSERT INTO public.europe_data VALUES (1740, 0, 356, 2.35, 5, 410);
INSERT INTO public.europe_data VALUES (1741, 0, 13, 0.28, 6, 410);
INSERT INTO public.europe_data VALUES (1742, 0, 25, 0.25, 110, 410);
INSERT INTO public.europe_data VALUES (1743, 6, 635, 4.73, 7, 410);
INSERT INTO public.europe_data VALUES (1744, 633, 44904, 226.35, 68, 410);
INSERT INTO public.europe_data VALUES (1745, 5, 537, 143.11, 8, 410);
INSERT INTO public.europe_data VALUES (1746, 0, 14, 41.57, 69, 410);
INSERT INTO public.europe_data VALUES (1747, 0, 9, 0.23, 9, 410);
INSERT INTO public.europe_data VALUES (1748, 1, 43, 0.52, 10, 410);
INSERT INTO public.europe_data VALUES (1749, 272, 9952, 104.17, 70, 410);
INSERT INTO public.europe_data VALUES (1750, 0, 104, 0.01, 111, 410);
INSERT INTO public.europe_data VALUES (1751, 1224, 62727, 243.72, 71, 410);
INSERT INTO public.europe_data VALUES (1752, 0, 5, 2.35, 11, 410);
INSERT INTO public.europe_data VALUES (1753, 0, 0, 2.64, 12, 410);
INSERT INTO public.europe_data VALUES (1754, 83, 6592, 282.65, 72, 410);
INSERT INTO public.europe_data VALUES (1755, 1, 175, 1.35, 13, 410);
INSERT INTO public.europe_data VALUES (1756, 462, 23741, 1144.07, 156, 410);
INSERT INTO public.europe_data VALUES (1757, 2, 549, 8.26, 73, 410);
INSERT INTO public.europe_data VALUES (1758, 3, 772, 848.72, 74, 410);
INSERT INTO public.europe_data VALUES (1759, 13, 2068, 434.75, 157, 410);
INSERT INTO public.europe_data VALUES (1760, 764, 27110, 512.4, 158, 410);
INSERT INTO public.europe_data VALUES (1761, 11, 893, 1.56, 14, 410);
INSERT INTO public.europe_data VALUES (1762, 56, 11251, 346.5, 159, 410);
INSERT INTO public.europe_data VALUES (1763, 0, 24, 3.39, 15, 410);
INSERT INTO public.europe_data VALUES (1764, 0, 0, 11.14, 75, 410);
INSERT INTO public.europe_data VALUES (1765, 15, 4980, 93.52, 76, 410);
INSERT INTO public.europe_data VALUES (1766, 355, 5881, 71.11, 77, 410);
INSERT INTO public.europe_data VALUES (1767, 135, 2891, 5.38, 16, 410);
INSERT INTO public.europe_data VALUES (1768, 50, 1940, 43.12, 78, 410);
INSERT INTO public.europe_data VALUES (1769, 0, 13, 2.65, 17, 410);
INSERT INTO public.europe_data VALUES (1770, 0, 55, 2.32, 18, 410);
INSERT INTO public.europe_data VALUES (1771, 19, 2926, 396.58, 160, 410);
INSERT INTO public.europe_data VALUES (1772, 1, 91, 24.56, 19, 410);
INSERT INTO public.europe_data VALUES (1773, 47, 3761, 6.7, 20, 410);
INSERT INTO public.europe_data VALUES (1774, 0, 0, 29.66, 79, 410);
INSERT INTO public.europe_data VALUES (1775, 0, 8, 20.54, 161, 410);
INSERT INTO public.europe_data VALUES (1776, 0, 2, 1.01, 203, 410);
INSERT INTO public.europe_data VALUES (1777, 22, 3002, 108.59, 162, 410);
INSERT INTO public.europe_data VALUES (1778, 2830, 74014, 227.25, 163, 410);
INSERT INTO public.europe_data VALUES (1779, 6, 1011, 762.3, 204, 410);
INSERT INTO public.europe_data VALUES (1780, 1, 63, 5.66, 21, 410);
INSERT INTO public.europe_data VALUES (1781, 0, 36, 1.87, 22, 410);
INSERT INTO public.europe_data VALUES (1782, 273, 29392, 1408.29, 164, 410);
INSERT INTO public.europe_data VALUES (1783, 2671, 129785, 306.58, 165, 410);
INSERT INTO public.europe_data VALUES (1784, 2, 705, 4.6, 23, 410);
INSERT INTO public.europe_data VALUES (1785, 0, 39, 281.85, 166, 410);
INSERT INTO public.europe_data VALUES (1786, 682, 11244, 222.4, 167, 410);
INSERT INTO public.europe_data VALUES (1787, 0, 0, 0, 80, 410);
INSERT INTO public.europe_data VALUES (1788, 0, 0, 0, 81, 410);
INSERT INTO public.europe_data VALUES (1789, 1, 186, 271.97, 205, 410);
INSERT INTO public.europe_data VALUES (1790, 84, 3579, 39.37, 82, 410);
INSERT INTO public.europe_data VALUES (1791, 0, 2, 7.76, 168, 410);
INSERT INTO public.europe_data VALUES (1792, 0, 194, 3.19, 24, 410);
INSERT INTO public.europe_data VALUES (1793, 1, 20, 1.09, 25, 410);
INSERT INTO public.europe_data VALUES (1794, 3, 289, 67.96, 83, 410);
INSERT INTO public.europe_data VALUES (1795, 1, 106, 1.39, 84, 410);
INSERT INTO public.europe_data VALUES (1796, 0, 0, 0, 169, 410);
INSERT INTO public.europe_data VALUES (1797, 37, 3135, 67.6, 85, 410);
INSERT INTO public.europe_data VALUES (1798, 1161, 37026, 779.68, 170, 410);
INSERT INTO public.europe_data VALUES (1799, 1, 101, 57.42, 171, 410);
INSERT INTO public.europe_data VALUES (1800, 3434, 245512, 39.32, 112, 410);
INSERT INTO public.europe_data VALUES (1801, 925, 41530, 28.87, 113, 410);
INSERT INTO public.europe_data VALUES (1802, 2435, 91798, 224.55, 114, 410);
INSERT INTO public.europe_data VALUES (1803, 208, 13765, 73.47, 115, 410);
INSERT INTO public.europe_data VALUES (1804, 45, 2005, 77.18, 172, 410);
INSERT INTO public.europe_data VALUES (1805, 0, 1, 2.36, 173, 410);
INSERT INTO public.europe_data VALUES (1806, 53, 9221, 185.44, 116, 410);
INSERT INTO public.europe_data VALUES (1807, 5174, 143700, 530.17, 174, 410);
INSERT INTO public.europe_data VALUES (1808, 9, 411, 28.36, 86, 410);
INSERT INTO public.europe_data VALUES (1809, 216, 15307, 24.55, 117, 410);
INSERT INTO public.europe_data VALUES (1810, 0, 429, 506.51, 175, 410);
INSERT INTO public.europe_data VALUES (1811, 362, 25782, 560.9, 118, 410);
INSERT INTO public.europe_data VALUES (1812, 55, 6283, 68.48, 119, 410);
INSERT INTO public.europe_data VALUES (1813, 74, 5064, 20.94, 26, 410);
INSERT INTO public.europe_data VALUES (1814, 101, 3748, 473.17, 176, 410);
INSERT INTO public.europe_data VALUES (1815, 13, 1943, 102.52, 120, 410);
INSERT INTO public.europe_data VALUES (1816, 26, 2588, 85.88, 121, 410);
INSERT INTO public.europe_data VALUES (1817, 0, 2, 0.24, 122, 410);
INSERT INTO public.europe_data VALUES (1818, 65, 4338, 426.73, 177, 410);
INSERT INTO public.europe_data VALUES (1819, 95, 10209, 301.6, 123, 410);
INSERT INTO public.europe_data VALUES (1820, 0, 41, 3.06, 27, 410);
INSERT INTO public.europe_data VALUES (1821, 0, 81, 2.53, 28, 410);
INSERT INTO public.europe_data VALUES (1822, 65, 4150, 129.21, 29, 410);
INSERT INTO public.europe_data VALUES (1823, 1, 123, 740.01, 178, 410);
INSERT INTO public.europe_data VALUES (1824, 131, 14711, 1037.48, 179, 410);
INSERT INTO public.europe_data VALUES (1825, 44, 3711, 1197.44, 180, 410);
INSERT INTO public.europe_data VALUES (1826, 4, 172, 0.64, 30, 410);
INSERT INTO public.europe_data VALUES (1827, 0, 26, 0.26, 31, 410);
INSERT INTO public.europe_data VALUES (1828, 25, 8209, 56.08, 124, 410);
INSERT INTO public.europe_data VALUES (1829, 1, 204, 111.12, 125, 410);
INSERT INTO public.europe_data VALUES (1830, 15, 476, 4.73, 32, 410);
INSERT INTO public.europe_data VALUES (1831, 15, 786, 335.32, 181, 410);
INSERT INTO public.europe_data VALUES (1832, 0, 0, 0, 206, 410);
INSERT INTO public.europe_data VALUES (1833, 2, 161, 13.57, 33, 410);
INSERT INTO public.europe_data VALUES (1834, 0, 4, 0.87, 34, 410);
INSERT INTO public.europe_data VALUES (1835, 4062, 68779, 105.02, 87, 410);
INSERT INTO public.europe_data VALUES (1836, 129, 9618, 462.35, 182, 410);
INSERT INTO public.europe_data VALUES (1837, 0, 30, 169.26, 183, 410);
INSERT INTO public.europe_data VALUES (1838, 0, 96, 7.66, 126, 410);
INSERT INTO public.europe_data VALUES (1839, 46, 3365, 1154.65, 184, 410);
INSERT INTO public.europe_data VALUES (1840, 0, 0, 0, 88, 410);
INSERT INTO public.europe_data VALUES (1841, 456, 25854, 160.93, 35, 410);
INSERT INTO public.europe_data VALUES (1842, 3, 631, 3.97, 36, 410);
INSERT INTO public.europe_data VALUES (1843, 192, 9669, 36.84, 127, 410);
INSERT INTO public.europe_data VALUES (1844, 1, 733, 48.63, 37, 410);
INSERT INTO public.europe_data VALUES (1845, 115, 9003, 72.26, 128, 410);
INSERT INTO public.europe_data VALUES (1846, 338, 38280, 419.47, 185, 410);
INSERT INTO public.europe_data VALUES (1847, 0, 3, 1.06, 208, 410);
INSERT INTO public.europe_data VALUES (1848, 0, 23, 1.02, 209, 410);
INSERT INTO public.europe_data VALUES (1849, 1, 54, 1.73, 89, 410);
INSERT INTO public.europe_data VALUES (1850, 7, 340, 2.09, 38, 410);
INSERT INTO public.europe_data VALUES (1851, 7, 1843, 1.43, 39, 410);
INSERT INTO public.europe_data VALUES (1852, 193, 6425, 636.7, 186, 410);
INSERT INTO public.europe_data VALUES (1853, 0, 3, 8.74, 210, 410);
INSERT INTO public.europe_data VALUES (1854, 26, 2624, 111.35, 187, 410);
INSERT INTO public.europe_data VALUES (1855, 26, 1402, 56.38, 129, 410);
INSERT INTO public.europe_data VALUES (1856, 373, 22270, 20.02, 130, 410);
INSERT INTO public.europe_data VALUES (1857, 115, 15247, 555.97, 131, 410);
INSERT INTO public.europe_data VALUES (1858, 133, 12990, 540.12, 90, 410);
INSERT INTO public.europe_data VALUES (1859, 0, 16, 0.76, 211, 410);
INSERT INTO public.europe_data VALUES (1860, 110, 6014, 162.45, 91, 410);
INSERT INTO public.europe_data VALUES (1861, 351, 11382, 74.57, 92, 410);
INSERT INTO public.europe_data VALUES (1862, 181, 9970, 19.44, 132, 410);
INSERT INTO public.europe_data VALUES (1863, 3060, 78374, 532.27, 188, 410);
INSERT INTO public.europe_data VALUES (1864, 536, 27675, 600.55, 189, 410);
INSERT INTO public.europe_data VALUES (1865, 98, 7509, 449.31, 93, 410);
INSERT INTO public.europe_data VALUES (1866, 2, 1260, 94.6, 133, 410);
INSERT INTO public.europe_data VALUES (1867, 1127, 42040, 488.97, 190, 410);
INSERT INTO public.europe_data VALUES (1868, 3614, 191454, 254.63, 191, 410);
INSERT INTO public.europe_data VALUES (1869, 3, 210, 3.67, 40, 410);
INSERT INTO public.europe_data VALUES (1870, 0, 3, 9.46, 94, 410);
INSERT INTO public.europe_data VALUES (1871, 0, 8, 24.62, 95, 410);
INSERT INTO public.europe_data VALUES (1872, 0, 2, 2.71, 96, 410);
INSERT INTO public.europe_data VALUES (1873, 3, 203, 1143.59, 192, 410);
INSERT INTO public.europe_data VALUES (1874, 0, 10, 9.3, 41, 410);
INSERT INTO public.europe_data VALUES (1875, 81, 1585, 10.08, 134, 410);
INSERT INTO public.europe_data VALUES (1876, 5, 402, 3.65, 42, 410);
INSERT INTO public.europe_data VALUES (1877, 400, 50438, 1414.92, 193, 410);
INSERT INTO public.europe_data VALUES (1878, 0, 11, 18.42, 43, 410);
INSERT INTO public.europe_data VALUES (1879, 0, 15, 0.27, 44, 410);
INSERT INTO public.europe_data VALUES (1880, 0, 47, 1.72, 135, 410);
INSERT INTO public.europe_data VALUES (1881, 1, 75, 316.12, 97, 410);
INSERT INTO public.europe_data VALUES (1882, 180, 10998, 375.93, 194, 410);
INSERT INTO public.europe_data VALUES (1883, 331, 10424, 985, 195, 410);
INSERT INTO public.europe_data VALUES (1884, 0, 0, 0.15, 212, 410);
INSERT INTO public.europe_data VALUES (1885, 8, 80, 0.52, 45, 410);
INSERT INTO public.europe_data VALUES (1886, 729, 26863, 80.07, 46, 410);
INSERT INTO public.europe_data VALUES (1887, 23, 3960, 13.97, 136, 410);
INSERT INTO public.europe_data VALUES (1888, 1, 72, 1.21, 47, 410);
INSERT INTO public.europe_data VALUES (1889, 1577, 54141, 255.05, 196, 410);
INSERT INTO public.europe_data VALUES (1890, 24, 4393, 36.14, 137, 410);
INSERT INTO public.europe_data VALUES (1891, 54, 1841, 8.48, 48, 410);
INSERT INTO public.europe_data VALUES (1892, 0, 12, 4.82, 98, 410);
INSERT INTO public.europe_data VALUES (1893, 476, 36841, 707.71, 197, 410);
INSERT INTO public.europe_data VALUES (1894, 596, 26084, 627.51, 198, 410);
INSERT INTO public.europe_data VALUES (1895, 34, 606, 6.9, 138, 410);
INSERT INTO public.europe_data VALUES (1896, 0, 41, 0.41, 139, 410);
INSERT INTO public.europe_data VALUES (1897, 1, 273, 5.73, 140, 410);
INSERT INTO public.europe_data VALUES (1898, 0, 130, 0.28, 141, 410);
INSERT INTO public.europe_data VALUES (1899, 0, 1, 0.08, 142, 410);
INSERT INTO public.europe_data VALUES (1900, 1, 133, 3.12, 49, 410);
INSERT INTO public.europe_data VALUES (1901, 2, 107, 22.72, 99, 410);
INSERT INTO public.europe_data VALUES (1902, 342, 7751, 130.75, 50, 410);
INSERT INTO public.europe_data VALUES (1903, 1342, 220667, 463.55, 199, 410);
INSERT INTO public.europe_data VALUES (1904, 0, 8, 26.18, 100, 410);
INSERT INTO public.europe_data VALUES (1905, 5, 2354, 10.24, 51, 410);
INSERT INTO public.europe_data VALUES (1906, 1375, 90627, 456.07, 200, 410);
INSERT INTO public.europe_data VALUES (1907, 22, 8676, 178.49, 143, 410);
INSERT INTO public.europe_data VALUES (1908, 3000, 105915, 316.89, 201, 410);
INSERT INTO public.europe_data VALUES (1909, 0, 0, 0, 52, 410);
INSERT INTO public.europe_data VALUES (1910, 15437, 1373677, 762.79, 101, 410);
INSERT INTO public.europe_data VALUES (1911, 0, 105, 138.65, 102, 410);
INSERT INTO public.europe_data VALUES (1912, 6, 1587, 75.22, 103, 410);
INSERT INTO public.europe_data VALUES (1913, 3, 1183, 7.39, 144, 410);
INSERT INTO public.europe_data VALUES (1914, 0, 0, 0, 213, 410);
INSERT INTO public.europe_data VALUES (1915, 25, 2402, 16.16, 104, 410);
INSERT INTO public.europe_data VALUES (1916, 0, 23, 0.06, 145, 410);
INSERT INTO public.europe_data VALUES (1917, 0, 0, 0, 214, 410);
INSERT INTO public.europe_data VALUES (1918, 0, 0, 0, 53, 410);
INSERT INTO public.europe_data VALUES (1919, 1, 0, 0.03, 146, 410);
INSERT INTO public.europe_data VALUES (1920, 7, 308, 2.75, 54, 410);
INSERT INTO public.europe_data VALUES (1921, 15, 768, 10.23, 55, 410);
INSERT INTO public.europe_data VALUES (1922, 68, 1073, 6.42, 105, 411);
INSERT INTO public.europe_data VALUES (1923, 99, 4864, 342.19, 147, 411);
INSERT INTO public.europe_data VALUES (1924, 135, 7359, 33.78, 1, 411);
INSERT INTO public.europe_data VALUES (1925, 0, 456, 1102.7, 148, 411);
INSERT INTO public.europe_data VALUES (1926, 9, 610, 5.43, 2, 411);
INSERT INTO public.europe_data VALUES (1927, 0, 0, 6.72, 56, 411);
INSERT INTO public.europe_data VALUES (1928, 0, 2, 7.21, 57, 411);
INSERT INTO public.europe_data VALUES (1929, 1471, 48444, 241.89, 58, 411);
INSERT INTO public.europe_data VALUES (1930, 188, 8415, 582.81, 149, 411);
INSERT INTO public.europe_data VALUES (1931, 0, 107, 165.55, 59, 411);
INSERT INTO public.europe_data VALUES (1932, 0, 72, 0.67, 202, 411);
INSERT INTO public.europe_data VALUES (1933, 705, 32058, 843.1, 150, 411);
INSERT INTO public.europe_data VALUES (1934, 230, 25101, 423.05, 151, 411);
INSERT INTO public.europe_data VALUES (1935, 0, 83, 79.59, 60, 411);
INSERT INTO public.europe_data VALUES (1936, 3, 1082, 126.98, 106, 411);
INSERT INTO public.europe_data VALUES (1937, 221, 15066, 18.45, 107, 411);
INSERT INTO public.europe_data VALUES (1938, 0, 16, 8.71, 61, 411);
INSERT INTO public.europe_data VALUES (1939, 55, 11009, 220.29, 152, 411);
INSERT INTO public.europe_data VALUES (1940, 874, 16253, 336.6, 153, 411);
INSERT INTO public.europe_data VALUES (1941, 31, 560, 225.95, 62, 411);
INSERT INTO public.europe_data VALUES (1942, 0, 58, 1.1, 3, 411);
INSERT INTO public.europe_data VALUES (1943, 0, 24, 46.39, 63, 411);
INSERT INTO public.europe_data VALUES (1944, 0, 14, 2.75, 108, 411);
INSERT INTO public.europe_data VALUES (1945, 48, 700, 11.95, 64, 411);
INSERT INTO public.europe_data VALUES (1946, 0, 0, 23.09, 65, 411);
INSERT INTO public.europe_data VALUES (1947, 344, 7367, 499.06, 154, 411);
INSERT INTO public.europe_data VALUES (1948, 0, 398, 76.7, 4, 411);
INSERT INTO public.europe_data VALUES (1949, 3650, 243339, 214, 66, 411);
INSERT INTO public.europe_data VALUES (1950, 0, 1, 3.33, 67, 411);
INSERT INTO public.europe_data VALUES (1951, 0, 2, 0.46, 109, 411);
INSERT INTO public.europe_data VALUES (1952, 934, 20666, 631.93, 155, 411);
INSERT INTO public.europe_data VALUES (1953, 0, 121, 1.06, 5, 411);
INSERT INTO public.europe_data VALUES (1954, 0, 19, 0.46, 6, 411);
INSERT INTO public.europe_data VALUES (1955, 0, 17, 0.13, 110, 411);
INSERT INTO public.europe_data VALUES (1956, 2, 589, 5.51, 7, 411);
INSERT INTO public.europe_data VALUES (1957, 577, 39775, 198.34, 68, 411);
INSERT INTO public.europe_data VALUES (1958, 0, 250, 128.01, 8, 411);
INSERT INTO public.europe_data VALUES (1959, 0, 13, 30.79, 69, 411);
INSERT INTO public.europe_data VALUES (1960, 0, 2, 0.27, 9, 411);
INSERT INTO public.europe_data VALUES (1961, 0, 40, 0.53, 10, 411);
INSERT INTO public.europe_data VALUES (1962, 287, 9790, 101.08, 70, 411);
INSERT INTO public.europe_data VALUES (1963, 0, 83, 0.01, 111, 411);
INSERT INTO public.europe_data VALUES (1964, 1297, 59959, 217.78, 71, 411);
INSERT INTO public.europe_data VALUES (1965, 0, 15, 3.76, 11, 411);
INSERT INTO public.europe_data VALUES (1966, 2, 142, 7.34, 12, 411);
INSERT INTO public.europe_data VALUES (1967, 82, 7675, 274.79, 72, 411);
INSERT INTO public.europe_data VALUES (1968, 0, 172, 1.3, 13, 411);
INSERT INTO public.europe_data VALUES (1969, 359, 22894, 1040.32, 156, 411);
INSERT INTO public.europe_data VALUES (1970, 2, 387, 5.67, 73, 411);
INSERT INTO public.europe_data VALUES (1971, 1, 615, 626.59, 74, 411);
INSERT INTO public.europe_data VALUES (1972, 4, 1740, 365.91, 157, 411);
INSERT INTO public.europe_data VALUES (1973, 942, 27460, 559.7, 158, 411);
INSERT INTO public.europe_data VALUES (1974, 5, 462, 1.05, 14, 411);
INSERT INTO public.europe_data VALUES (1975, 45, 8867, 296.52, 159, 411);
INSERT INTO public.europe_data VALUES (1976, 0, 9, 2.88, 15, 411);
INSERT INTO public.europe_data VALUES (1977, 0, 8, 23.67, 75, 411);
INSERT INTO public.europe_data VALUES (1978, 20, 5063, 90.78, 76, 411);
INSERT INTO public.europe_data VALUES (1979, 222, 6474, 68.05, 77, 411);
INSERT INTO public.europe_data VALUES (1980, 88, 2514, 4.76, 16, 411);
INSERT INTO public.europe_data VALUES (1981, 33, 843, 31.72, 78, 411);
INSERT INTO public.europe_data VALUES (1982, 0, 23, 3.61, 17, 411);
INSERT INTO public.europe_data VALUES (1983, 0, 26, 2.4, 18, 411);
INSERT INTO public.europe_data VALUES (1984, 24, 2328, 333.25, 160, 411);
INSERT INTO public.europe_data VALUES (1985, 1, 191, 27.44, 19, 411);
INSERT INTO public.europe_data VALUES (1986, 53, 3749, 6.08, 20, 411);
INSERT INTO public.europe_data VALUES (1987, 0, 1, 59.31, 79, 411);
INSERT INTO public.europe_data VALUES (1988, 0, 2, 8.22, 161, 411);
INSERT INTO public.europe_data VALUES (1989, 0, 7, 0.79, 203, 411);
INSERT INTO public.europe_data VALUES (1990, 18, 2990, 96.3, 162, 411);
INSERT INTO public.europe_data VALUES (1991, 3593, 78275, 353.15, 163, 411);
INSERT INTO public.europe_data VALUES (1992, 10, 1118, 855.76, 204, 411);
INSERT INTO public.europe_data VALUES (1993, 0, 60, 5.94, 21, 411);
INSERT INTO public.europe_data VALUES (1994, 0, 8, 1.36, 22, 411);
INSERT INTO public.europe_data VALUES (1995, 255, 26894, 1319.79, 164, 411);
INSERT INTO public.europe_data VALUES (1996, 2136, 124736, 304.2, 165, 411);
INSERT INTO public.europe_data VALUES (1997, 0, 695, 4.75, 23, 411);
INSERT INTO public.europe_data VALUES (1998, 1, 56, 332.29, 166, 411);
INSERT INTO public.europe_data VALUES (1999, 691, 12608, 279.94, 167, 411);
INSERT INTO public.europe_data VALUES (2000, 0, 0, 1.76, 80, 411);
INSERT INTO public.europe_data VALUES (2001, 0, 0, 8.04, 81, 411);
INSERT INTO public.europe_data VALUES (2002, 6, 269, 416.63, 205, 411);
INSERT INTO public.europe_data VALUES (2003, 90, 3342, 40.3, 82, 411);
INSERT INTO public.europe_data VALUES (2004, 0, 3, 6.2, 168, 411);
INSERT INTO public.europe_data VALUES (2005, 1, 213, 3.35, 24, 411);
INSERT INTO public.europe_data VALUES (2006, 0, 1, 0.16, 25, 411);
INSERT INTO public.europe_data VALUES (2007, 7, 243, 70.65, 83, 411);
INSERT INTO public.europe_data VALUES (2008, 0, 50, 0.75, 84, 411);
INSERT INTO public.europe_data VALUES (2009, 0, 0, 0, 169, 411);
INSERT INTO public.europe_data VALUES (2010, 52, 3453, 49.11, 85, 411);
INSERT INTO public.europe_data VALUES (2011, 932, 39170, 712.86, 170, 411);
INSERT INTO public.europe_data VALUES (2012, 0, 104, 53.78, 171, 411);
INSERT INTO public.europe_data VALUES (2013, 3401, 291826, 42.93, 112, 411);
INSERT INTO public.europe_data VALUES (2014, 931, 36598, 24.81, 113, 411);
INSERT INTO public.europe_data VALUES (2015, 3073, 94388, 225.15, 114, 411);
INSERT INTO public.europe_data VALUES (2016, 266, 15114, 79.58, 115, 411);
INSERT INTO public.europe_data VALUES (2017, 30, 1780, 88.45, 172, 411);
INSERT INTO public.europe_data VALUES (2018, 0, 1, 7.09, 173, 411);
INSERT INTO public.europe_data VALUES (2019, 58, 6577, 139.04, 116, 411);
INSERT INTO public.europe_data VALUES (2020, 5081, 176310, 673.71, 174, 411);
INSERT INTO public.europe_data VALUES (2021, 18, 425, 27.98, 86, 411);
INSERT INTO public.europe_data VALUES (2022, 139, 15843, 23.71, 117, 411);
INSERT INTO public.europe_data VALUES (2023, 0, 117, 181.82, 175, 411);
INSERT INTO public.europe_data VALUES (2024, 458, 30878, 699.18, 118, 411);
INSERT INTO public.europe_data VALUES (2025, 61, 6421, 67.69, 119, 411);
INSERT INTO public.europe_data VALUES (2026, 72, 5944, 24.86, 26, 411);
INSERT INTO public.europe_data VALUES (2027, 91, 4762, 552.68, 176, 411);
INSERT INTO public.europe_data VALUES (2028, 12, 2370, 132.78, 120, 411);
INSERT INTO public.europe_data VALUES (2029, 34, 2922, 90.78, 121, 411);
INSERT INTO public.europe_data VALUES (2030, 0, 15, 0.21, 122, 411);
INSERT INTO public.europe_data VALUES (2031, 44, 3855, 334.8, 177, 411);
INSERT INTO public.europe_data VALUES (2032, 104, 10468, 313.81, 123, 411);
INSERT INTO public.europe_data VALUES (2033, 0, 24, 3.2, 27, 411);
INSERT INTO public.europe_data VALUES (2034, 1, 44, 1.78, 28, 411);
INSERT INTO public.europe_data VALUES (2035, 77, 4607, 130.26, 29, 411);
INSERT INTO public.europe_data VALUES (2036, 7, 161, 750.43, 178, 411);
INSERT INTO public.europe_data VALUES (2037, 120, 14278, 950.8, 179, 411);
INSERT INTO public.europe_data VALUES (2038, 44, 3640, 1210.14, 180, 411);
INSERT INTO public.europe_data VALUES (2039, 0, 0, 0.4, 30, 411);
INSERT INTO public.europe_data VALUES (2040, 0, 22, 0.32, 31, 411);
INSERT INTO public.europe_data VALUES (2041, 22, 9710, 53.42, 124, 411);
INSERT INTO public.europe_data VALUES (2042, 0, 386, 148.79, 125, 411);
INSERT INTO public.europe_data VALUES (2043, 6, 453, 4.02, 32, 411);
INSERT INTO public.europe_data VALUES (2044, 25, 869, 351.73, 181, 411);
INSERT INTO public.europe_data VALUES (2045, 0, 0, 5.1, 206, 411);
INSERT INTO public.europe_data VALUES (2046, 6, 453, 14.67, 33, 411);
INSERT INTO public.europe_data VALUES (2047, 0, 7, 1.81, 34, 411);
INSERT INTO public.europe_data VALUES (2048, 3979, 65196, 78.82, 87, 411);
INSERT INTO public.europe_data VALUES (2049, 141, 9076, 438.71, 182, 411);
INSERT INTO public.europe_data VALUES (2050, 0, 26, 181.35, 183, 411);
INSERT INTO public.europe_data VALUES (2051, 0, 151, 11.16, 126, 411);
INSERT INTO public.europe_data VALUES (2052, 48, 3819, 1238.22, 184, 411);
INSERT INTO public.europe_data VALUES (2053, 0, 0, 0, 88, 411);
INSERT INTO public.europe_data VALUES (2054, 533, 32841, 166.23, 35, 411);
INSERT INTO public.europe_data VALUES (2055, 6, 576, 3.84, 36, 411);
INSERT INTO public.europe_data VALUES (2056, 179, 10240, 37.92, 127, 411);
INSERT INTO public.europe_data VALUES (2057, 6, 480, 33.55, 37, 411);
INSERT INTO public.europe_data VALUES (2058, 158, 11670, 77.61, 128, 411);
INSERT INTO public.europe_data VALUES (2059, 457, 34213, 410.47, 185, 411);
INSERT INTO public.europe_data VALUES (2060, 0, 0, 0.71, 208, 411);
INSERT INTO public.europe_data VALUES (2061, 0, 26, 1.15, 209, 411);
INSERT INTO public.europe_data VALUES (2062, 1, 59, 1.88, 89, 411);
INSERT INTO public.europe_data VALUES (2063, 0, 148, 0.9, 38, 411);
INSERT INTO public.europe_data VALUES (2064, 6, 1029, 1.13, 39, 411);
INSERT INTO public.europe_data VALUES (2065, 220, 6800, 697.74, 186, 411);
INSERT INTO public.europe_data VALUES (2066, 0, 2, 6.99, 210, 411);
INSERT INTO public.europe_data VALUES (2067, 22, 3309, 141.15, 187, 411);
INSERT INTO public.europe_data VALUES (2068, 38, 1403, 62.21, 129, 411);
INSERT INTO public.europe_data VALUES (2069, 329, 21095, 18, 130, 411);
INSERT INTO public.europe_data VALUES (2070, 93, 12448, 430.84, 131, 411);
INSERT INTO public.europe_data VALUES (2071, 103, 9946, 425.67, 90, 411);
INSERT INTO public.europe_data VALUES (2072, 0, 51, 0.63, 211, 411);
INSERT INTO public.europe_data VALUES (2073, 86, 5430, 146.66, 91, 411);
INSERT INTO public.europe_data VALUES (2074, 328, 12860, 78.49, 92, 411);
INSERT INTO public.europe_data VALUES (2075, 250, 11046, 20.37, 132, 411);
INSERT INTO public.europe_data VALUES (2076, 3411, 123744, 716.57, 188, 411);
INSERT INTO public.europe_data VALUES (2077, 530, 34041, 754.12, 189, 411);
INSERT INTO public.europe_data VALUES (2078, 77, 5671, 428.55, 93, 411);
INSERT INTO public.europe_data VALUES (2079, 1, 1419, 101.09, 133, 411);
INSERT INTO public.europe_data VALUES (2080, 1146, 52891, 573.05, 190, 411);
INSERT INTO public.europe_data VALUES (2081, 3348, 179987, 235.47, 191, 411);
INSERT INTO public.europe_data VALUES (2082, 1, 254, 3.67, 40, 411);
INSERT INTO public.europe_data VALUES (2083, 0, 2, 5.68, 94, 411);
INSERT INTO public.europe_data VALUES (2084, 0, 37, 47.05, 95, 411);
INSERT INTO public.europe_data VALUES (2085, 0, 1, 6.33, 96, 411);
INSERT INTO public.europe_data VALUES (2086, 2, 191, 966.53, 192, 411);
INSERT INTO public.europe_data VALUES (2087, 0, 10, 11.16, 41, 411);
INSERT INTO public.europe_data VALUES (2088, 104, 1870, 11.3, 134, 411);
INSERT INTO public.europe_data VALUES (2089, 3, 193, 1.73, 42, 411);
INSERT INTO public.europe_data VALUES (2090, 350, 48094, 1215.52, 193, 411);
INSERT INTO public.europe_data VALUES (2091, 0, 7, 15.35, 43, 411);
INSERT INTO public.europe_data VALUES (2092, 0, 6, 0.26, 44, 411);
INSERT INTO public.europe_data VALUES (2093, 1, 53, 1.62, 135, 411);
INSERT INTO public.europe_data VALUES (2094, 0, 59, 313.76, 97, 411);
INSERT INTO public.europe_data VALUES (2095, 145, 9492, 347.97, 194, 411);
INSERT INTO public.europe_data VALUES (2096, 264, 10073, 977.41, 195, 411);
INSERT INTO public.europe_data VALUES (2097, 0, 1, 0.15, 212, 411);
INSERT INTO public.europe_data VALUES (2098, 0, 0, 0.93, 45, 411);
INSERT INTO public.europe_data VALUES (2099, 574, 20023, 62.64, 46, 411);
INSERT INTO public.europe_data VALUES (2100, 17, 3197, 10.6, 136, 411);
INSERT INTO public.europe_data VALUES (2101, 1, 62, 0.96, 47, 411);
INSERT INTO public.europe_data VALUES (2102, 1938, 65571, 322.4, 196, 411);
INSERT INTO public.europe_data VALUES (2103, 29, 3313, 29.06, 137, 411);
INSERT INTO public.europe_data VALUES (2104, 48, 1788, 7.01, 48, 411);
INSERT INTO public.europe_data VALUES (2105, 1, 16, 6.54, 98, 411);
INSERT INTO public.europe_data VALUES (2106, 418, 35559, 659.85, 197, 411);
INSERT INTO public.europe_data VALUES (2107, 669, 27534, 711.93, 198, 411);
INSERT INTO public.europe_data VALUES (2108, 37, 572, 6.52, 138, 411);
INSERT INTO public.europe_data VALUES (2109, 0, 57, 0.3, 139, 411);
INSERT INTO public.europe_data VALUES (2110, 0, 261, 5.85, 140, 411);
INSERT INTO public.europe_data VALUES (2111, 0, 64, 0.15, 141, 411);
INSERT INTO public.europe_data VALUES (2112, 0, 0, 0, 142, 411);
INSERT INTO public.europe_data VALUES (2113, 0, 119, 3.55, 49, 411);
INSERT INTO public.europe_data VALUES (2114, 5, 210, 41.58, 99, 411);
INSERT INTO public.europe_data VALUES (2115, 398, 7540, 135.51, 50, 411);
INSERT INTO public.europe_data VALUES (2116, 1200, 159462, 291.6, 199, 411);
INSERT INTO public.europe_data VALUES (2117, 0, 2, 73.31, 100, 411);
INSERT INTO public.europe_data VALUES (2118, 29, 2177, 9.32, 51, 411);
INSERT INTO public.europe_data VALUES (2119, 1400, 110014, 424.66, 200, 411);
INSERT INTO public.europe_data VALUES (2120, 18, 8763, 178.17, 143, 411);
INSERT INTO public.europe_data VALUES (2121, 3494, 105282, 372.12, 201, 411);
INSERT INTO public.europe_data VALUES (2122, 0, 0, 0, 52, 411);
INSERT INTO public.europe_data VALUES (2123, 10091, 1136412, 713.01, 101, 411);
INSERT INTO public.europe_data VALUES (2124, 0, 40, 105.18, 102, 411);
INSERT INTO public.europe_data VALUES (2125, 5, 1017, 48.7, 103, 411);
INSERT INTO public.europe_data VALUES (2126, 5, 1253, 7.97, 144, 411);
INSERT INTO public.europe_data VALUES (2127, 0, 0, 0, 213, 411);
INSERT INTO public.europe_data VALUES (2128, 23, 2205, 16.44, 104, 411);
INSERT INTO public.europe_data VALUES (2129, 0, 37, 0.06, 145, 411);
INSERT INTO public.europe_data VALUES (2130, 0, 1, 0, 214, 411);
INSERT INTO public.europe_data VALUES (2131, 0, 0, 0, 53, 411);
INSERT INTO public.europe_data VALUES (2132, 1, 8, 0.03, 146, 411);
INSERT INTO public.europe_data VALUES (2133, 0, 184, 2.72, 54, 411);
INSERT INTO public.europe_data VALUES (2134, 8, 730, 7.95, 55, 411);
INSERT INTO public.europe_data VALUES (2135, 69, 1368, 6.66, 105, 412);
INSERT INTO public.europe_data VALUES (2136, 76, 4931, 298.87, 147, 412);
INSERT INTO public.europe_data VALUES (2137, 121, 7183, 29.76, 1, 412);
INSERT INTO public.europe_data VALUES (2138, 0, 384, 1146.02, 148, 412);
INSERT INTO public.europe_data VALUES (2139, 15, 1119, 6.78, 2, 412);
INSERT INTO public.europe_data VALUES (2140, 0, 1, 6.72, 56, 412);
INSERT INTO public.europe_data VALUES (2141, 0, 5, 8.24, 57, 412);
INSERT INTO public.europe_data VALUES (2142, 1566, 59874, 286.24, 58, 412);
INSERT INTO public.europe_data VALUES (2143, 188, 8823, 650.6, 149, 412);
INSERT INTO public.europe_data VALUES (2144, 1, 69, 123.22, 59, 412);
INSERT INTO public.europe_data VALUES (2145, 0, 96, 0.65, 202, 412);
INSERT INTO public.europe_data VALUES (2146, 520, 42630, 1056.76, 150, 412);
INSERT INTO public.europe_data VALUES (2147, 164, 17406, 275.52, 151, 412);
INSERT INTO public.europe_data VALUES (2148, 7, 227, 119.64, 60, 412);
INSERT INTO public.europe_data VALUES (2149, 3, 1002, 137.04, 106, 412);
INSERT INTO public.europe_data VALUES (2150, 194, 15008, 16.62, 107, 412);
INSERT INTO public.europe_data VALUES (2151, 0, 9, 5.92, 61, 412);
INSERT INTO public.europe_data VALUES (2152, 50, 9814, 187.47, 152, 412);
INSERT INTO public.europe_data VALUES (2153, 1123, 22306, 491.19, 153, 412);
INSERT INTO public.europe_data VALUES (2154, 26, 322, 257.97, 62, 412);
INSERT INTO public.europe_data VALUES (2155, 0, 72, 1.45, 3, 412);
INSERT INTO public.europe_data VALUES (2156, 0, 5, 28.8, 63, 412);
INSERT INTO public.europe_data VALUES (2157, 0, 7, 3.01, 108, 412);
INSERT INTO public.europe_data VALUES (2158, 55, 676, 12.57, 64, 412);
INSERT INTO public.europe_data VALUES (2159, 0, 6, 26.94, 65, 412);
INSERT INTO public.europe_data VALUES (2160, 419, 9107, 532.69, 154, 412);
INSERT INTO public.europe_data VALUES (2161, 4, 1369, 76.36, 4, 412);
INSERT INTO public.europe_data VALUES (2162, 3385, 208308, 192.98, 66, 412);
INSERT INTO public.europe_data VALUES (2163, 0, 0, 0, 67, 412);
INSERT INTO public.europe_data VALUES (2164, 0, 0, 0, 109, 412);
INSERT INTO public.europe_data VALUES (2165, 750, 23569, 666.57, 155, 412);
INSERT INTO public.europe_data VALUES (2166, 0, 94, 0.82, 5, 412);
INSERT INTO public.europe_data VALUES (2167, 0, 34, 0.42, 6, 412);
INSERT INTO public.europe_data VALUES (2168, 0, 4, 0.05, 110, 412);
INSERT INTO public.europe_data VALUES (2169, 2, 836, 4.28, 7, 412);
INSERT INTO public.europe_data VALUES (2170, 502, 34426, 177.46, 68, 412);
INSERT INTO public.europe_data VALUES (2171, 1, 454, 164.93, 8, 412);
INSERT INTO public.europe_data VALUES (2172, 1, 7, 16.94, 69, 412);
INSERT INTO public.europe_data VALUES (2173, 0, 11, 0.67, 9, 412);
INSERT INTO public.europe_data VALUES (2174, 0, 45, 0.6, 10, 412);
INSERT INTO public.europe_data VALUES (2175, 250, 9367, 100.69, 70, 412);
INSERT INTO public.europe_data VALUES (2176, 0, 95, 0.01, 111, 412);
INSERT INTO public.europe_data VALUES (2177, 1256, 49671, 207.65, 71, 412);
INSERT INTO public.europe_data VALUES (2178, 0, 17, 3.88, 11, 412);
INSERT INTO public.europe_data VALUES (2179, 0, 253, 4.7, 12, 412);
INSERT INTO public.europe_data VALUES (2180, 62, 6195, 258.64, 72, 412);
INSERT INTO public.europe_data VALUES (2181, 3, 162, 1.19, 13, 412);
INSERT INTO public.europe_data VALUES (2182, 304, 19512, 894.72, 156, 412);
INSERT INTO public.europe_data VALUES (2183, 1, 256, 4.84, 73, 412);
INSERT INTO public.europe_data VALUES (2184, 1, 409, 398.96, 74, 412);
INSERT INTO public.europe_data VALUES (2185, 4, 1465, 303.23, 157, 412);
INSERT INTO public.europe_data VALUES (2186, 988, 32147, 727.1, 158, 412);
INSERT INTO public.europe_data VALUES (2187, 8, 450, 0.73, 14, 412);
INSERT INTO public.europe_data VALUES (2188, 24, 8349, 264.62, 159, 412);
INSERT INTO public.europe_data VALUES (2189, 0, 19, 6.16, 15, 412);
INSERT INTO public.europe_data VALUES (2190, 0, 9, 48.74, 75, 412);
INSERT INTO public.europe_data VALUES (2191, 25, 4686, 76.62, 76, 412);
INSERT INTO public.europe_data VALUES (2192, 193, 5348, 61.79, 77, 412);
INSERT INTO public.europe_data VALUES (2193, 95, 2260, 3.81, 16, 412);
INSERT INTO public.europe_data VALUES (2194, 34, 1204, 37.45, 78, 412);
INSERT INTO public.europe_data VALUES (2195, 0, 26, 2.8, 17, 412);
INSERT INTO public.europe_data VALUES (2196, 0, 58, 1.72, 18, 412);
INSERT INTO public.europe_data VALUES (2197, 7, 2087, 271.66, 160, 412);
INSERT INTO public.europe_data VALUES (2198, 1, 124, 18.81, 19, 412);
INSERT INTO public.europe_data VALUES (2199, 78, 3065, 5.45, 20, 412);
INSERT INTO public.europe_data VALUES (2200, 0, 1, 88.97, 79, 412);
INSERT INTO public.europe_data VALUES (2201, 0, 2, 6.16, 161, 412);
INSERT INTO public.europe_data VALUES (2202, 0, 0, 0.11, 203, 412);
INSERT INTO public.europe_data VALUES (2203, 6, 2324, 69.63, 162, 412);
INSERT INTO public.europe_data VALUES (2204, 4184, 158381, 526.59, 163, 412);
INSERT INTO public.europe_data VALUES (2205, 10, 1272, 1068.08, 204, 412);
INSERT INTO public.europe_data VALUES (2206, 1, 69, 5.02, 21, 412);
INSERT INTO public.europe_data VALUES (2207, 1, 24, 1.79, 22, 412);
INSERT INTO public.europe_data VALUES (2208, 279, 25855, 1201.22, 164, 412);
INSERT INTO public.europe_data VALUES (2209, 1565, 127806, 309.89, 165, 412);
INSERT INTO public.europe_data VALUES (2210, 1, 751, 5.5, 23, 412);
INSERT INTO public.europe_data VALUES (2211, 3, 56, 489.53, 166, 412);
INSERT INTO public.europe_data VALUES (2212, 524, 17414, 325.62, 167, 412);
INSERT INTO public.europe_data VALUES (2213, 0, 1, 1.76, 80, 412);
INSERT INTO public.europe_data VALUES (2214, 0, 9, 8.04, 81, 412);
INSERT INTO public.europe_data VALUES (2215, 8, 428, 786.63, 205, 412);
INSERT INTO public.europe_data VALUES (2216, 144, 3744, 41.9, 82, 412);
INSERT INTO public.europe_data VALUES (2217, 0, 1, 6.2, 168, 412);
INSERT INTO public.europe_data VALUES (2218, 0, 215, 3.13, 24, 412);
INSERT INTO public.europe_data VALUES (2219, 0, 2, 0.42, 25, 412);
INSERT INTO public.europe_data VALUES (2220, 4, 310, 79.08, 83, 412);
INSERT INTO public.europe_data VALUES (2221, 0, 35, 0.77, 84, 412);
INSERT INTO public.europe_data VALUES (2222, 0, 0, 0, 169, 412);
INSERT INTO public.europe_data VALUES (2223, 34, 1333, 40.29, 85, 412);
INSERT INTO public.europe_data VALUES (2224, 701, 30496, 646.43, 170, 412);
INSERT INTO public.europe_data VALUES (2225, 1, 88, 55.74, 171, 412);
INSERT INTO public.europe_data VALUES (2226, 3668, 294738, 42.9, 112, 412);
INSERT INTO public.europe_data VALUES (2227, 673, 30555, 22.15, 113, 412);
INSERT INTO public.europe_data VALUES (2228, 3309, 92293, 207.29, 114, 412);
INSERT INTO public.europe_data VALUES (2229, 288, 16169, 93.54, 115, 412);
INSERT INTO public.europe_data VALUES (2230, 43, 2558, 103.32, 172, 412);
INSERT INTO public.europe_data VALUES (2231, 0, 5, 13, 173, 412);
INSERT INTO public.europe_data VALUES (2232, 74, 5268, 115.51, 116, 412);
INSERT INTO public.europe_data VALUES (2233, 4594, 230339, 784.9, 174, 412);
INSERT INTO public.europe_data VALUES (2234, 7, 400, 26.39, 86, 412);
INSERT INTO public.europe_data VALUES (2235, 97, 14240, 18, 117, 412);
INSERT INTO public.europe_data VALUES (2236, 0, 79, 155.85, 175, 412);
INSERT INTO public.europe_data VALUES (2237, 464, 39751, 733.62, 118, 412);
INSERT INTO public.europe_data VALUES (2238, 53, 6137, 62.04, 119, 412);
INSERT INTO public.europe_data VALUES (2239, 111, 7127, 28.31, 26, 412);
INSERT INTO public.europe_data VALUES (2240, 92, 5178, 563.8, 176, 412);
INSERT INTO public.europe_data VALUES (2241, 28, 3216, 197.6, 120, 412);
INSERT INTO public.europe_data VALUES (2242, 34, 2902, 101.23, 121, 412);
INSERT INTO public.europe_data VALUES (2243, 0, 0, 0, 122, 412);
INSERT INTO public.europe_data VALUES (2244, 30, 2573, 261.72, 177, 412);
INSERT INTO public.europe_data VALUES (2245, 83, 11046, 324.4, 123, 412);
INSERT INTO public.europe_data VALUES (2246, 0, 44, 5.55, 27, 412);
INSERT INTO public.europe_data VALUES (2247, 0, 44, 2.21, 28, 412);
INSERT INTO public.europe_data VALUES (2248, 72, 4221, 143.21, 29, 412);
INSERT INTO public.europe_data VALUES (2249, 4, 127, 844.23, 178, 412);
INSERT INTO public.europe_data VALUES (2250, 109, 12289, 799.8, 179, 412);
INSERT INTO public.europe_data VALUES (2251, 40, 3789, 1279.05, 180, 412);
INSERT INTO public.europe_data VALUES (2252, 2, 108, 0.44, 30, 412);
INSERT INTO public.europe_data VALUES (2253, 0, 38, 0.28, 31, 412);
INSERT INTO public.europe_data VALUES (2254, 26, 7358, 45.59, 124, 412);
INSERT INTO public.europe_data VALUES (2255, 3, 404, 117.15, 125, 412);
INSERT INTO public.europe_data VALUES (2256, 4, 338, 2.7, 32, 412);
INSERT INTO public.europe_data VALUES (2257, 15, 867, 356.8, 181, 412);
INSERT INTO public.europe_data VALUES (2258, 0, 3, 5.1, 206, 412);
INSERT INTO public.europe_data VALUES (2259, 4, 211, 6.41, 33, 412);
INSERT INTO public.europe_data VALUES (2260, 0, 16, 3.31, 34, 412);
INSERT INTO public.europe_data VALUES (2261, 3134, 35353, 58.04, 87, 412);
INSERT INTO public.europe_data VALUES (2262, 130, 8662, 385.7, 182, 412);
INSERT INTO public.europe_data VALUES (2263, 1, 34, 290.16, 183, 412);
INSERT INTO public.europe_data VALUES (2264, 0, 209, 8.43, 126, 412);
INSERT INTO public.europe_data VALUES (2265, 48, 3885, 1327.1, 184, 412);
INSERT INTO public.europe_data VALUES (2266, 0, 0, 0, 88, 412);
INSERT INTO public.europe_data VALUES (2267, 477, 27785, 175.97, 35, 412);
INSERT INTO public.europe_data VALUES (2268, 11, 589, 4.18, 36, 412);
INSERT INTO public.europe_data VALUES (2269, 162, 10252, 33.06, 127, 412);
INSERT INTO public.europe_data VALUES (2270, 7, 357, 26.22, 37, 412);
INSERT INTO public.europe_data VALUES (2271, 100, 10532, 90.37, 128, 412);
INSERT INTO public.europe_data VALUES (2272, 404, 36725, 431.01, 185, 412);
INSERT INTO public.europe_data VALUES (2273, 0, 2, 1.06, 208, 412);
INSERT INTO public.europe_data VALUES (2274, 0, 29, 0.92, 209, 412);
INSERT INTO public.europe_data VALUES (2275, 1, 64, 2.05, 89, 412);
INSERT INTO public.europe_data VALUES (2276, 0, 61, 0.54, 38, 412);
INSERT INTO public.europe_data VALUES (2277, 4, 1235, 1.14, 39, 412);
INSERT INTO public.europe_data VALUES (2278, 206, 7693, 721.33, 186, 412);
INSERT INTO public.europe_data VALUES (2279, 0, 2, 6.99, 210, 412);
INSERT INTO public.europe_data VALUES (2280, 12, 4212, 154.14, 187, 412);
INSERT INTO public.europe_data VALUES (2281, 42, 1692, 79.22, 129, 412);
INSERT INTO public.europe_data VALUES (2282, 536, 17897, 14.82, 130, 412);
INSERT INTO public.europe_data VALUES (2283, 74, 9014, 284.64, 131, 412);
INSERT INTO public.europe_data VALUES (2284, 84, 8130, 359.27, 90, 412);
INSERT INTO public.europe_data VALUES (2285, 0, 4, 0.08, 211, 412);
INSERT INTO public.europe_data VALUES (2286, 70, 4902, 126.15, 91, 412);
INSERT INTO public.europe_data VALUES (2287, 364, 12659, 84.09, 92, 412);
INSERT INTO public.europe_data VALUES (2288, 291, 10980, 20.74, 132, 412);
INSERT INTO public.europe_data VALUES (2289, 3270, 148359, 829.29, 188, 412);
INSERT INTO public.europe_data VALUES (2290, 516, 43457, 792.42, 189, 412);
INSERT INTO public.europe_data VALUES (2291, 82, 6900, 438.36, 93, 412);
INSERT INTO public.europe_data VALUES (2292, 2, 1444, 106.85, 133, 412);
INSERT INTO public.europe_data VALUES (2293, 1121, 58364, 591.8, 190, 412);
INSERT INTO public.europe_data VALUES (2294, 2993, 163504, 215.94, 191, 412);
INSERT INTO public.europe_data VALUES (2295, 2, 210, 3.51, 40, 412);
INSERT INTO public.europe_data VALUES (2296, 0, 1, 1.89, 94, 412);
INSERT INTO public.europe_data VALUES (2297, 0, 49, 48.69, 95, 412);
INSERT INTO public.europe_data VALUES (2298, 0, 6, 7.23, 96, 412);
INSERT INTO public.europe_data VALUES (2299, 1, 142, 1021.68, 192, 412);
INSERT INTO public.europe_data VALUES (2300, 1, 14, 7.91, 41, 412);
INSERT INTO public.europe_data VALUES (2301, 123, 2003, 13.62, 134, 412);
INSERT INTO public.europe_data VALUES (2302, 2, 89, 1.07, 42, 412);
INSERT INTO public.europe_data VALUES (2303, 190, 36552, 838.24, 193, 412);
INSERT INTO public.europe_data VALUES (2304, 0, 8, 8.18, 43, 412);
INSERT INTO public.europe_data VALUES (2305, 0, 14, 0.31, 44, 412);
INSERT INTO public.europe_data VALUES (2306, 0, 41, 1.79, 135, 412);
INSERT INTO public.europe_data VALUES (2307, 1, 74, 261.86, 97, 412);
INSERT INTO public.europe_data VALUES (2308, 161, 9474, 380.63, 194, 412);
INSERT INTO public.europe_data VALUES (2309, 152, 10266, 968.18, 195, 412);
INSERT INTO public.europe_data VALUES (2310, 0, 0, 0.45, 212, 412);
INSERT INTO public.europe_data VALUES (2311, 6, 144, 1.4, 45, 412);
INSERT INTO public.europe_data VALUES (2312, 662, 16655, 51.92, 46, 412);
INSERT INTO public.europe_data VALUES (2313, 15, 2235, 6.74, 136, 412);
INSERT INTO public.europe_data VALUES (2314, 1, 44, 0.83, 47, 412);
INSERT INTO public.europe_data VALUES (2315, 1878, 85752, 429.08, 196, 412);
INSERT INTO public.europe_data VALUES (2316, 29, 2884, 29.27, 137, 412);
INSERT INTO public.europe_data VALUES (2317, 77, 1213, 4.09, 48, 412);
INSERT INTO public.europe_data VALUES (2318, 2, 22, 9.8, 98, 412);
INSERT INTO public.europe_data VALUES (2319, 332, 31945, 618.42, 197, 412);
INSERT INTO public.europe_data VALUES (2320, 611, 33297, 916.65, 198, 412);
INSERT INTO public.europe_data VALUES (2321, 31, 541, 5.92, 138, 412);
INSERT INTO public.europe_data VALUES (2322, 0, 15, 0.17, 139, 412);
INSERT INTO public.europe_data VALUES (2323, 1, 284, 5.99, 140, 412);
INSERT INTO public.europe_data VALUES (2324, 0, 38, 0.1, 141, 412);
INSERT INTO public.europe_data VALUES (2325, 0, 0, 0, 142, 412);
INSERT INTO public.europe_data VALUES (2326, 3, 168, 4.05, 49, 412);
INSERT INTO public.europe_data VALUES (2327, 3, 370, 43.08, 99, 412);
INSERT INTO public.europe_data VALUES (2328, 476, 8307, 150.43, 50, 412);
INSERT INTO public.europe_data VALUES (2329, 851, 79659, 179.01, 199, 412);
INSERT INTO public.europe_data VALUES (2330, 0, 26, 102.11, 100, 412);
INSERT INTO public.europe_data VALUES (2331, 27, 1948, 8.05, 51, 412);
INSERT INTO public.europe_data VALUES (2332, 1210, 76808, 346.26, 200, 412);
INSERT INTO public.europe_data VALUES (2333, 22, 8645, 172.43, 143, 412);
INSERT INTO public.europe_data VALUES (2334, 2817, 142727, 480.19, 201, 412);
INSERT INTO public.europe_data VALUES (2335, 0, 0, 0, 52, 412);
INSERT INTO public.europe_data VALUES (2336, 10568, 1209848, 691.43, 101, 412);
INSERT INTO public.europe_data VALUES (2337, 0, 70, 94.67, 102, 412);
INSERT INTO public.europe_data VALUES (2338, 6, 669, 34.23, 103, 412);
INSERT INTO public.europe_data VALUES (2339, 5, 1374, 8.58, 144, 412);
INSERT INTO public.europe_data VALUES (2340, 0, 0, 0.33, 213, 412);
INSERT INTO public.europe_data VALUES (2341, 20, 2483, 17.37, 104, 412);
INSERT INTO public.europe_data VALUES (2342, 0, 25, 0.1, 145, 412);
INSERT INTO public.europe_data VALUES (2343, 0, 1, 0, 214, 412);
INSERT INTO public.europe_data VALUES (2344, 0, 0, 0, 53, 412);
INSERT INTO public.europe_data VALUES (2345, 2, 1, 0.02, 146, 412);
INSERT INTO public.europe_data VALUES (2346, 4, 301, 2.63, 54, 412);
INSERT INTO public.europe_data VALUES (2347, 11, 434, 4.7, 55, 412);
INSERT INTO public.europe_data VALUES (2348, 61, 1164, 4.65, 105, 413);
INSERT INTO public.europe_data VALUES (2349, 64, 3624, 231.55, 147, 413);
INSERT INTO public.europe_data VALUES (2350, 106, 5628, 21.85, 1, 413);
INSERT INTO public.europe_data VALUES (2351, 1, 489, 1374.43, 148, 413);
INSERT INTO public.europe_data VALUES (2352, 19, 1039, 8.07, 2, 413);
INSERT INTO public.europe_data VALUES (2353, 0, 0, 0, 56, 413);
INSERT INTO public.europe_data VALUES (2354, 1, 3, 6.18, 57, 413);
INSERT INTO public.europe_data VALUES (2355, 1876, 68307, 305.84, 58, 413);
INSERT INTO public.europe_data VALUES (2356, 208, 10420, 826.24, 149, 413);
INSERT INTO public.europe_data VALUES (2357, 4, 62, 134.51, 59, 413);
INSERT INTO public.europe_data VALUES (2358, 0, 67, 0.52, 202, 413);
INSERT INTO public.europe_data VALUES (2359, 344, 50986, 1042.85, 150, 413);
INSERT INTO public.europe_data VALUES (2360, 127, 10277, 191.53, 151, 413);
INSERT INTO public.europe_data VALUES (2361, 4, 239, 121.19, 60, 413);
INSERT INTO public.europe_data VALUES (2362, 6, 1247, 169.39, 106, 413);
INSERT INTO public.europe_data VALUES (2363, 127, 12095, 14.16, 107, 413);
INSERT INTO public.europe_data VALUES (2364, 0, 8, 4.53, 61, 413);
INSERT INTO public.europe_data VALUES (2365, 39, 7906, 155.79, 152, 413);
INSERT INTO public.europe_data VALUES (2366, 1328, 33962, 767.8, 153, 413);
INSERT INTO public.europe_data VALUES (2367, 20, 685, 358.4, 62, 413);
INSERT INTO public.europe_data VALUES (2368, 0, 99, 1.7, 3, 413);
INSERT INTO public.europe_data VALUES (2369, 0, 13, 36.8, 63, 413);
INSERT INTO public.europe_data VALUES (2370, 0, 16, 2.75, 108, 413);
INSERT INTO public.europe_data VALUES (2371, 54, 771, 12.27, 64, 413);
INSERT INTO public.europe_data VALUES (2372, 0, 1, 7.7, 65, 413);
INSERT INTO public.europe_data VALUES (2373, 347, 8477, 587.55, 154, 413);
INSERT INTO public.europe_data VALUES (2374, 0, 390, 68.72, 4, 413);
INSERT INTO public.europe_data VALUES (2375, 3401, 198978, 150.39, 66, 413);
INSERT INTO public.europe_data VALUES (2376, 0, 0, 0, 67, 413);
INSERT INTO public.europe_data VALUES (2377, 0, 0, 0, 109, 413);
INSERT INTO public.europe_data VALUES (2378, 465, 23091, 631.17, 155, 413);
INSERT INTO public.europe_data VALUES (2379, 1, 72, 0.69, 5, 413);
INSERT INTO public.europe_data VALUES (2380, 0, 14, 0.34, 6, 413);
INSERT INTO public.europe_data VALUES (2381, 0, 5, 0.07, 110, 413);
INSERT INTO public.europe_data VALUES (2382, 0, 271, 3.47, 7, 413);
INSERT INTO public.europe_data VALUES (2383, 431, 31964, 158.34, 68, 413);
INSERT INTO public.europe_data VALUES (2384, 3, 453, 177.11, 8, 413);
INSERT INTO public.europe_data VALUES (2385, 0, 4, 21.56, 69, 413);
INSERT INTO public.europe_data VALUES (2386, 1, 21, 0.72, 9, 413);
INSERT INTO public.europe_data VALUES (2387, 2, 50, 0.62, 10, 413);
INSERT INTO public.europe_data VALUES (2388, 276, 9715, 102.41, 70, 413);
INSERT INTO public.europe_data VALUES (2389, 0, 76, 0.02, 111, 413);
INSERT INTO public.europe_data VALUES (2390, 1240, 54859, 229.29, 71, 413);
INSERT INTO public.europe_data VALUES (2391, 0, 16, 4, 11, 413);
INSERT INTO public.europe_data VALUES (2392, 0, 0, 1.65, 12, 413);
INSERT INTO public.europe_data VALUES (2393, 82, 6860, 262.54, 72, 413);
INSERT INTO public.europe_data VALUES (2394, 2, 144, 1.01, 13, 413);
INSERT INTO public.europe_data VALUES (2395, 255, 16959, 802.48, 156, 413);
INSERT INTO public.europe_data VALUES (2396, 1, 293, 5.78, 73, 413);
INSERT INTO public.europe_data VALUES (2397, 0, 243, 216, 74, 413);
INSERT INTO public.europe_data VALUES (2398, 13, 1191, 298.55, 157, 413);
INSERT INTO public.europe_data VALUES (2399, 1350, 45288, 1112.43, 158, 413);
INSERT INTO public.europe_data VALUES (2400, 4, 182, 0.48, 14, 413);
INSERT INTO public.europe_data VALUES (2401, 17, 7015, 255.54, 159, 413);
INSERT INTO public.europe_data VALUES (2402, 0, 41, 8.83, 15, 413);
INSERT INTO public.europe_data VALUES (2403, 0, 26, 36.21, 75, 413);
INSERT INTO public.europe_data VALUES (2404, 20, 3542, 59.52, 76, 413);
INSERT INTO public.europe_data VALUES (2405, 178, 5388, 63.9, 77, 413);
INSERT INTO public.europe_data VALUES (2406, 85, 1566, 3.02, 16, 413);
INSERT INTO public.europe_data VALUES (2407, 33, 1213, 36.31, 78, 413);
INSERT INTO public.europe_data VALUES (2408, 0, 12, 1.11, 17, 413);
INSERT INTO public.europe_data VALUES (2409, 0, 2, 0.86, 18, 413);
INSERT INTO public.europe_data VALUES (2410, 6, 1512, 200.18, 160, 413);
INSERT INTO public.europe_data VALUES (2411, 2, 92, 14.81, 19, 413);
INSERT INTO public.europe_data VALUES (2412, 46, 3045, 5.48, 20, 413);
INSERT INTO public.europe_data VALUES (2413, 0, 2, 59.31, 79, 413);
INSERT INTO public.europe_data VALUES (2414, 0, 1, 6.16, 161, 413);
INSERT INTO public.europe_data VALUES (2415, 0, 1, 0.11, 203, 413);
INSERT INTO public.europe_data VALUES (2416, 7, 1518, 54.8, 162, 413);
INSERT INTO public.europe_data VALUES (2417, 4109, 194503, 847.47, 163, 413);
INSERT INTO public.europe_data VALUES (2418, 14, 1711, 1591.21, 204, 413);
INSERT INTO public.europe_data VALUES (2419, 3, 40, 4.33, 21, 413);
INSERT INTO public.europe_data VALUES (2420, 1, 18, 1.28, 22, 413);
INSERT INTO public.europe_data VALUES (2421, 234, 22155, 1007.22, 164, 413);
INSERT INTO public.europe_data VALUES (2422, 1195, 129459, 308.72, 165, 413);
INSERT INTO public.europe_data VALUES (2423, 2, 921, 6.57, 23, 413);
INSERT INTO public.europe_data VALUES (2424, 1, 109, 590.4, 166, 413);
INSERT INTO public.europe_data VALUES (2425, 322, 17507, 310.28, 167, 413);
INSERT INTO public.europe_data VALUES (2426, 0, 0, 0, 80, 413);
INSERT INTO public.europe_data VALUES (2427, 0, 0, 3.57, 81, 413);
INSERT INTO public.europe_data VALUES (2428, 9, 888, 853.58, 205, 413);
INSERT INTO public.europe_data VALUES (2429, 111, 3623, 38.57, 82, 413);
INSERT INTO public.europe_data VALUES (2430, 0, 3, 18.61, 168, 413);
INSERT INTO public.europe_data VALUES (2431, 1, 185, 3.26, 24, 413);
INSERT INTO public.europe_data VALUES (2432, 2, 6, 0.31, 25, 413);
INSERT INTO public.europe_data VALUES (2433, 5, 309, 78.57, 83, 413);
INSERT INTO public.europe_data VALUES (2434, 0, 52, 1.11, 84, 413);
INSERT INTO public.europe_data VALUES (2435, 0, 0, 0, 169, 413);
INSERT INTO public.europe_data VALUES (2436, 72, 2594, 50.17, 85, 413);
INSERT INTO public.europe_data VALUES (2437, 697, 32678, 661.8, 170, 413);
INSERT INTO public.europe_data VALUES (2438, 5, 111, 83.76, 171, 413);
INSERT INTO public.europe_data VALUES (2439, 3459, 291470, 45.07, 112, 413);
INSERT INTO public.europe_data VALUES (2440, 597, 29397, 20.08, 113, 413);
INSERT INTO public.europe_data VALUES (2441, 3202, 79582, 170.75, 114, 413);
INSERT INTO public.europe_data VALUES (2442, 343, 20603, 111.59, 115, 413);
INSERT INTO public.europe_data VALUES (2443, 32, 2509, 120.32, 172, 413);
INSERT INTO public.europe_data VALUES (2444, 0, 6, 11.82, 173, 413);
INSERT INTO public.europe_data VALUES (2445, 58, 4573, 105.69, 116, 413);
INSERT INTO public.europe_data VALUES (2446, 3835, 243425, 777.33, 174, 413);
INSERT INTO public.europe_data VALUES (2447, 10, 378, 25.54, 86, 413);
INSERT INTO public.europe_data VALUES (2448, 65, 8593, 11.72, 117, 413);
INSERT INTO public.europe_data VALUES (2449, 0, 89, 146.57, 175, 413);
INSERT INTO public.europe_data VALUES (2450, 539, 34357, 671.29, 118, 413);
INSERT INTO public.europe_data VALUES (2451, 53, 5372, 55.98, 119, 413);
INSERT INTO public.europe_data VALUES (2452, 158, 7757, 27.33, 26, 413);
INSERT INTO public.europe_data VALUES (2453, 67, 4962, 496.97, 176, 413);
INSERT INTO public.europe_data VALUES (2454, 27, 5097, 244.97, 120, 413);
INSERT INTO public.europe_data VALUES (2455, 21, 3593, 110.73, 121, 413);
INSERT INTO public.europe_data VALUES (2456, 0, 0, 0, 122, 413);
INSERT INTO public.europe_data VALUES (2457, 24, 2452, 229.74, 177, 413);
INSERT INTO public.europe_data VALUES (2458, 94, 11194, 332.76, 123, 413);
INSERT INTO public.europe_data VALUES (2459, 0, 74, 4.42, 27, 413);
INSERT INTO public.europe_data VALUES (2460, 0, 65, 1.64, 28, 413);
INSERT INTO public.europe_data VALUES (2461, 88, 5485, 170.52, 29, 413);
INSERT INTO public.europe_data VALUES (2462, 1, 197, 1130.86, 178, 413);
INSERT INTO public.europe_data VALUES (2463, 70, 10059, 681.38, 179, 413);
INSERT INTO public.europe_data VALUES (2464, 37, 4063, 1264.39, 180, 413);
INSERT INTO public.europe_data VALUES (2465, 0, 10, 0.45, 30, 413);
INSERT INTO public.europe_data VALUES (2466, 1, 14, 0.18, 31, 413);
INSERT INTO public.europe_data VALUES (2467, 23, 7208, 46.67, 124, 413);
INSERT INTO public.europe_data VALUES (2468, 3, 218, 94.73, 125, 413);
INSERT INTO public.europe_data VALUES (2469, 2, 192, 1.64, 32, 413);
INSERT INTO public.europe_data VALUES (2470, 20, 894, 351.73, 181, 413);
INSERT INTO public.europe_data VALUES (2471, 0, 0, 0, 206, 413);
INSERT INTO public.europe_data VALUES (2472, 0, 79, 3.71, 33, 413);
INSERT INTO public.europe_data VALUES (2473, 0, 26, 2.52, 34, 413);
INSERT INTO public.europe_data VALUES (2474, 3515, 38697, 60.46, 87, 413);
INSERT INTO public.europe_data VALUES (2475, 126, 6933, 314.03, 182, 413);
INSERT INTO public.europe_data VALUES (2476, 0, 62, 550.1, 183, 413);
INSERT INTO public.europe_data VALUES (2477, 0, 63, 2.54, 126, 413);
INSERT INTO public.europe_data VALUES (2478, 54, 4372, 1360.21, 184, 413);
INSERT INTO public.europe_data VALUES (2479, 0, 0, 0, 88, 413);
INSERT INTO public.europe_data VALUES (2480, 507, 36396, 193.66, 35, 413);
INSERT INTO public.europe_data VALUES (2481, 14, 680, 4.81, 36, 413);
INSERT INTO public.europe_data VALUES (2482, 157, 7617, 28.84, 127, 413);
INSERT INTO public.europe_data VALUES (2483, 4, 297, 20.85, 37, 413);
INSERT INTO public.europe_data VALUES (2484, 113, 15323, 126.57, 128, 413);
INSERT INTO public.europe_data VALUES (2485, 481, 37762, 508.61, 185, 413);
INSERT INTO public.europe_data VALUES (2486, 0, 1, 0.71, 208, 413);
INSERT INTO public.europe_data VALUES (2487, 0, 15, 0.79, 209, 413);
INSERT INTO public.europe_data VALUES (2488, 1, 70, 2.25, 89, 413);
INSERT INTO public.europe_data VALUES (2489, 1, 64, 0.37, 38, 413);
INSERT INTO public.europe_data VALUES (2490, 9, 1058, 1.09, 39, 413);
INSERT INTO public.europe_data VALUES (2491, 169, 7290, 703.57, 186, 413);
INSERT INTO public.europe_data VALUES (2492, 0, 2, 10.49, 210, 413);
INSERT INTO public.europe_data VALUES (2493, 9, 4001, 143.82, 187, 413);
INSERT INTO public.europe_data VALUES (2494, 37, 2249, 93.57, 129, 413);
INSERT INTO public.europe_data VALUES (2495, 183, 14193, 11.05, 130, 413);
INSERT INTO public.europe_data VALUES (2496, 53, 5165, 191.19, 131, 413);
INSERT INTO public.europe_data VALUES (2497, 75, 7126, 290.05, 90, 413);
INSERT INTO public.europe_data VALUES (2498, 0, 3, 0.11, 211, 413);
INSERT INTO public.europe_data VALUES (2499, 97, 3985, 111.33, 91, 413);
INSERT INTO public.europe_data VALUES (2500, 352, 14678, 98.74, 92, 413);
INSERT INTO public.europe_data VALUES (2501, 293, 11443, 22.87, 132, 413);
INSERT INTO public.europe_data VALUES (2502, 2476, 166547, 877.13, 188, 413);
INSERT INTO public.europe_data VALUES (2503, 485, 37977, 709.96, 189, 413);
INSERT INTO public.europe_data VALUES (2504, 63, 5959, 387.37, 93, 413);
INSERT INTO public.europe_data VALUES (2505, 2, 1582, 108.22, 133, 413);
INSERT INTO public.europe_data VALUES (2506, 1047, 56530, 585.22, 190, 413);
INSERT INTO public.europe_data VALUES (2507, 2649, 151491, 198.15, 191, 413);
INSERT INTO public.europe_data VALUES (2508, 9, 233, 2.45, 40, 413);
INSERT INTO public.europe_data VALUES (2509, 0, 0, 0, 94, 413);
INSERT INTO public.europe_data VALUES (2510, 2, 40, 47.59, 95, 413);
INSERT INTO public.europe_data VALUES (2511, 0, 2, 2.71, 96, 413);
INSERT INTO public.europe_data VALUES (2512, 0, 210, 943.31, 192, 413);
INSERT INTO public.europe_data VALUES (2513, 0, 3, 7.44, 41, 413);
INSERT INTO public.europe_data VALUES (2514, 117, 2663, 16.34, 134, 413);
INSERT INTO public.europe_data VALUES (2515, 2, 85, 1, 42, 413);
INSERT INTO public.europe_data VALUES (2516, 119, 21821, 519.33, 193, 413);
INSERT INTO public.europe_data VALUES (2517, 0, 0, 5.12, 43, 413);
INSERT INTO public.europe_data VALUES (2518, 0, 10, 0.32, 44, 413);
INSERT INTO public.europe_data VALUES (2519, 0, 63, 1.72, 135, 413);
INSERT INTO public.europe_data VALUES (2520, 1, 37, 240.63, 97, 413);
INSERT INTO public.europe_data VALUES (2521, 159, 11272, 492.09, 194, 413);
INSERT INTO public.europe_data VALUES (2522, 129, 9881, 931.95, 195, 413);
INSERT INTO public.europe_data VALUES (2523, 0, 3, 1.19, 212, 413);
INSERT INTO public.europe_data VALUES (2524, 0, 72, 2.33, 45, 413);
INSERT INTO public.europe_data VALUES (2525, 432, 13746, 41.33, 46, 413);
INSERT INTO public.europe_data VALUES (2526, 14, 1216, 3.98, 136, 413);
INSERT INTO public.europe_data VALUES (2527, 0, 48, 0.7, 47, 413);
INSERT INTO public.europe_data VALUES (2528, 1908, 115646, 545.77, 196, 413);
INSERT INTO public.europe_data VALUES (2529, 23, 3358, 29.2, 137, 413);
INSERT INTO public.europe_data VALUES (2530, 1, 536, 1.88, 48, 413);
INSERT INTO public.europe_data VALUES (2531, 1, 35, 11.01, 98, 413);
INSERT INTO public.europe_data VALUES (2532, 235, 31320, 554.49, 197, 413);
INSERT INTO public.europe_data VALUES (2533, 552, 45026, 1199.11, 198, 413);
INSERT INTO public.europe_data VALUES (2534, 28, 469, 5.24, 138, 413);
INSERT INTO public.europe_data VALUES (2535, 0, 25, 0.17, 139, 413);
INSERT INTO public.europe_data VALUES (2536, 2, 274, 5.97, 140, 413);
INSERT INTO public.europe_data VALUES (2537, 0, 35, 0.13, 141, 413);
INSERT INTO public.europe_data VALUES (2538, 0, 0, 0, 142, 413);
INSERT INTO public.europe_data VALUES (2539, 4, 159, 3.93, 49, 413);
INSERT INTO public.europe_data VALUES (2540, 1, 231, 29.53, 99, 413);
INSERT INTO public.europe_data VALUES (2541, 472, 9285, 158.17, 50, 413);
INSERT INTO public.europe_data VALUES (2542, 620, 67133, 159.78, 199, 413);
INSERT INTO public.europe_data VALUES (2543, 0, 13, 41.89, 100, 413);
INSERT INTO public.europe_data VALUES (2544, 13, 1617, 7.4, 51, 413);
INSERT INTO public.europe_data VALUES (2545, 1153, 75526, 319.18, 200, 413);
INSERT INTO public.europe_data VALUES (2546, 16, 8202, 168.24, 143, 413);
INSERT INTO public.europe_data VALUES (2547, 2890, 177305, 501.75, 201, 413);
INSERT INTO public.europe_data VALUES (2548, 0, 0, 0, 52, 413);
INSERT INTO public.europe_data VALUES (2549, 8642, 1065410, 556.03, 101, 413);
INSERT INTO public.europe_data VALUES (2550, 0, 29, 55.46, 102, 413);
INSERT INTO public.europe_data VALUES (2551, 3, 516, 25.45, 103, 413);
INSERT INTO public.europe_data VALUES (2552, 13, 1455, 9.36, 144, 413);
INSERT INTO public.europe_data VALUES (2553, 0, 1, 0, 213, 413);
INSERT INTO public.europe_data VALUES (2554, 25, 2469, 17.63, 104, 413);
INSERT INTO public.europe_data VALUES (2555, 0, 68, 0.1, 145, 413);
INSERT INTO public.europe_data VALUES (2556, 0, 0, 0, 214, 413);
INSERT INTO public.europe_data VALUES (2557, 0, 0, 0, 53, 413);
INSERT INTO public.europe_data VALUES (2558, 0, 5, 0.02, 146, 413);
INSERT INTO public.europe_data VALUES (2559, 4, 169, 3.6, 54, 413);
INSERT INTO public.europe_data VALUES (2560, 4, 255, 2.81, 55, 413);
INSERT INTO public.europe_data VALUES (2561, 24, 606, 3.7, 105, 414);
INSERT INTO public.europe_data VALUES (2562, 41, 3004, 176.39, 147, 414);
INSERT INTO public.europe_data VALUES (2563, 75, 3779, 13.72, 1, 414);
INSERT INTO public.europe_data VALUES (2564, 0, 558, 1765.62, 148, 414);
INSERT INTO public.europe_data VALUES (2565, 19, 1530, 10.4, 2, 414);
INSERT INTO public.europe_data VALUES (2566, 0, 0, 0, 56, 414);
INSERT INTO public.europe_data VALUES (2567, 0, 3, 7.21, 57, 414);
INSERT INTO public.europe_data VALUES (2568, 2420, 68649, 338.52, 58, 414);
INSERT INTO public.europe_data VALUES (2569, 189, 14018, 968.85, 149, 414);
INSERT INTO public.europe_data VALUES (2570, 2, 81, 169.32, 59, 414);
INSERT INTO public.europe_data VALUES (2571, 0, 63, 0.55, 202, 414);
INSERT INTO public.europe_data VALUES (2572, 221, 41398, 789.86, 150, 414);
INSERT INTO public.europe_data VALUES (2573, 100, 8967, 153.79, 151, 414);
INSERT INTO public.europe_data VALUES (2574, 8, 233, 137.87, 60, 414);
INSERT INTO public.europe_data VALUES (2575, 8, 1533, 195.04, 106, 414);
INSERT INTO public.europe_data VALUES (2576, 126, 10986, 13.14, 107, 414);
INSERT INTO public.europe_data VALUES (2577, 0, 5, 5.23, 61, 414);
INSERT INTO public.europe_data VALUES (2578, 22, 6820, 142.36, 152, 414);
INSERT INTO public.europe_data VALUES (2579, 1411, 53994, 1340.3, 153, 414);
INSERT INTO public.europe_data VALUES (2580, 12, 714, 264.12, 62, 414);
INSERT INTO public.europe_data VALUES (2581, 2, 102, 1.59, 3, 414);
INSERT INTO public.europe_data VALUES (2582, 0, 10, 28.8, 63, 414);
INSERT INTO public.europe_data VALUES (2583, 0, 5, 2.23, 108, 414);
INSERT INTO public.europe_data VALUES (2584, 64, 642, 14.09, 64, 414);
INSERT INTO public.europe_data VALUES (2585, 0, 1, 15.39, 65, 414);
INSERT INTO public.europe_data VALUES (2586, 262, 10918, 652.2, 154, 414);
INSERT INTO public.europe_data VALUES (2587, 3, 1193, 83, 4, 414);
INSERT INTO public.europe_data VALUES (2588, 2323, 118410, 127.93, 66, 414);
INSERT INTO public.europe_data VALUES (2589, 0, 0, 0, 67, 414);
INSERT INTO public.europe_data VALUES (2590, 0, 0, 0, 109, 414);
INSERT INTO public.europe_data VALUES (2591, 367, 21091, 532.44, 155, 414);
INSERT INTO public.europe_data VALUES (2592, 0, 69, 0.58, 5, 414);
INSERT INTO public.europe_data VALUES (2593, 0, 25, 0.5, 6, 414);
INSERT INTO public.europe_data VALUES (2594, 0, 6, 0.06, 110, 414);
INSERT INTO public.europe_data VALUES (2595, 7, 628, 3.29, 7, 414);
INSERT INTO public.europe_data VALUES (2596, 343, 27272, 128.33, 68, 414);
INSERT INTO public.europe_data VALUES (2597, 5, 521, 176.93, 8, 414);
INSERT INTO public.europe_data VALUES (2598, 0, 10, 16.94, 69, 414);
INSERT INTO public.europe_data VALUES (2599, 0, 13, 0.36, 9, 414);
INSERT INTO public.europe_data VALUES (2600, 1, 49, 0.69, 10, 414);
INSERT INTO public.europe_data VALUES (2601, 296, 9694, 102.86, 70, 414);
INSERT INTO public.europe_data VALUES (2602, 0, 213, 0.03, 111, 414);
INSERT INTO public.europe_data VALUES (2603, 1276, 60566, 254.28, 71, 414);
INSERT INTO public.europe_data VALUES (2604, 0, 18, 5.41, 11, 414);
INSERT INTO public.europe_data VALUES (2605, 0, 89, 2.34, 12, 414);
INSERT INTO public.europe_data VALUES (2606, 79, 6392, 263, 72, 414);
INSERT INTO public.europe_data VALUES (2607, 0, 116, 1.41, 13, 414);
INSERT INTO public.europe_data VALUES (2608, 232, 15752, 757.24, 156, 414);
INSERT INTO public.europe_data VALUES (2609, 2, 362, 6.45, 73, 414);
INSERT INTO public.europe_data VALUES (2610, 1, 110, 146.25, 74, 414);
INSERT INTO public.europe_data VALUES (2611, 1, 1424, 278.8, 157, 414);
INSERT INTO public.europe_data VALUES (2612, 1429, 73184, 1471.68, 158, 414);
INSERT INTO public.europe_data VALUES (2613, 8, 236, 0.54, 14, 414);
INSERT INTO public.europe_data VALUES (2614, 20, 7822, 254.3, 159, 414);
INSERT INTO public.europe_data VALUES (2615, 0, 45, 7.4, 15, 414);
INSERT INTO public.europe_data VALUES (2616, 0, 0, 5.57, 75, 414);
INSERT INTO public.europe_data VALUES (2617, 16, 2850, 52.66, 76, 414);
INSERT INTO public.europe_data VALUES (2618, 146, 5713, 76.39, 77, 414);
INSERT INTO public.europe_data VALUES (2619, 90, 1465, 2.65, 16, 414);
INSERT INTO public.europe_data VALUES (2620, 31, 1130, 39.67, 78, 414);
INSERT INTO public.europe_data VALUES (2621, 2, 3, 0.96, 17, 414);
INSERT INTO public.europe_data VALUES (2622, 0, 28, 0.86, 18, 414);
INSERT INTO public.europe_data VALUES (2623, 2, 1140, 129.38, 160, 414);
INSERT INTO public.europe_data VALUES (2624, 0, 78, 12.98, 19, 414);
INSERT INTO public.europe_data VALUES (2625, 45, 3092, 5.65, 20, 414);
INSERT INTO public.europe_data VALUES (2626, 0, 0, 0, 79, 414);
INSERT INTO public.europe_data VALUES (2627, 0, 2, 14.38, 161, 414);
INSERT INTO public.europe_data VALUES (2628, 0, 0, 0.11, 203, 414);
INSERT INTO public.europe_data VALUES (2629, 4, 1506, 53.44, 162, 414);
INSERT INTO public.europe_data VALUES (2630, 3420, 373409, 968.2, 163, 414);
INSERT INTO public.europe_data VALUES (2631, 10, 2733, 1503.12, 204, 414);
INSERT INTO public.europe_data VALUES (2632, 0, 54, 4.74, 21, 414);
INSERT INTO public.europe_data VALUES (2633, 2, 12, 1.02, 22, 414);
INSERT INTO public.europe_data VALUES (2634, 157, 18101, 760.04, 164, 414);
INSERT INTO public.europe_data VALUES (2635, 822, 126841, 281.86, 165, 414);
INSERT INTO public.europe_data VALUES (2636, 0, 1078, 4.97, 23, 414);
INSERT INTO public.europe_data VALUES (2637, 0, 90, 373.82, 166, 414);
INSERT INTO public.europe_data VALUES (2638, 149, 15769, 241.65, 167, 414);
INSERT INTO public.europe_data VALUES (2639, 0, 0, 0, 80, 414);
INSERT INTO public.europe_data VALUES (2640, 0, 4, 3.57, 81, 414);
INSERT INTO public.europe_data VALUES (2641, 10, 540, 607.91, 205, 414);
INSERT INTO public.europe_data VALUES (2642, 83, 3158, 36.83, 82, 414);
INSERT INTO public.europe_data VALUES (2643, 0, 9, 21.72, 168, 414);
INSERT INTO public.europe_data VALUES (2644, 1, 231, 5.93, 24, 414);
INSERT INTO public.europe_data VALUES (2645, 0, 0, 0.52, 25, 414);
INSERT INTO public.europe_data VALUES (2646, 8, 306, 62.73, 83, 414);
INSERT INTO public.europe_data VALUES (2647, 0, 73, 0.9, 84, 414);
INSERT INTO public.europe_data VALUES (2648, 0, 0, 0, 169, 414);
INSERT INTO public.europe_data VALUES (2649, 76, 2296, 74.84, 85, 414);
INSERT INTO public.europe_data VALUES (2650, 604, 31998, 544.52, 170, 414);
INSERT INTO public.europe_data VALUES (2651, 8, 188, 176.48, 171, 414);
INSERT INTO public.europe_data VALUES (2652, 4004, 324344, 47.11, 112, 414);
INSERT INTO public.europe_data VALUES (2653, 671, 24932, 17.74, 113, 414);
INSERT INTO public.europe_data VALUES (2654, 2993, 61995, 137, 114, 414);
INSERT INTO public.europe_data VALUES (2655, 361, 23261, 119.16, 115, 414);
INSERT INTO public.europe_data VALUES (2656, 32, 3392, 168.55, 172, 414);
INSERT INTO public.europe_data VALUES (2657, 1, 4, 10.64, 173, 414);
INSERT INTO public.europe_data VALUES (2658, 120, 4431, 110.5, 116, 414);
INSERT INTO public.europe_data VALUES (2659, 2568, 225769, 678.14, 174, 414);
INSERT INTO public.europe_data VALUES (2660, 12, 375, 26.86, 86, 414);
INSERT INTO public.europe_data VALUES (2661, 44, 6271, 8.68, 117, 414);
INSERT INTO public.europe_data VALUES (2662, 0, 69, 104.83, 175, 414);
INSERT INTO public.europe_data VALUES (2663, 367, 33455, 556.68, 118, 414);
INSERT INTO public.europe_data VALUES (2664, 39, 5013, 45.35, 119, 414);
INSERT INTO public.europe_data VALUES (2665, 98, 6611, 24.28, 26, 414);
INSERT INTO public.europe_data VALUES (2666, 67, 3976, 345.4, 176, 414);
INSERT INTO public.europe_data VALUES (2667, 29, 5209, 240.26, 120, 414);
INSERT INTO public.europe_data VALUES (2668, 27, 3511, 112.53, 121, 414);
INSERT INTO public.europe_data VALUES (2669, 0, 0, 0, 122, 414);
INSERT INTO public.europe_data VALUES (2670, 25, 1959, 177.97, 177, 414);
INSERT INTO public.europe_data VALUES (2671, 80, 11619, 333.24, 123, 414);
INSERT INTO public.europe_data VALUES (2672, 1, 20, 1.27, 27, 414);
INSERT INTO public.europe_data VALUES (2673, 0, 16, 0.99, 28, 414);
INSERT INTO public.europe_data VALUES (2674, 58, 6072, 178.59, 29, 414);
INSERT INTO public.europe_data VALUES (2675, 0, 237, 1102.19, 178, 414);
INSERT INTO public.europe_data VALUES (2676, 41, 8980, 519.47, 179, 414);
INSERT INTO public.europe_data VALUES (2677, 25, 3699, 1348.28, 180, 414);
INSERT INTO public.europe_data VALUES (2678, 5, 112, 0.95, 30, 414);
INSERT INTO public.europe_data VALUES (2679, 0, 19, 0.33, 31, 414);
INSERT INTO public.europe_data VALUES (2680, 37, 7704, 42.7, 124, 414);
INSERT INTO public.europe_data VALUES (2681, 2, 285, 90.59, 125, 414);
INSERT INTO public.europe_data VALUES (2682, 1, 131, 0.95, 32, 414);
INSERT INTO public.europe_data VALUES (2683, 14, 842, 337.35, 181, 414);
INSERT INTO public.europe_data VALUES (2684, 0, 0, 1.7, 206, 414);
INSERT INTO public.europe_data VALUES (2685, 2, 89, 3.18, 33, 414);
INSERT INTO public.europe_data VALUES (2686, 0, 6, 1.34, 34, 414);
INSERT INTO public.europe_data VALUES (2687, 3132, 38433, 60.09, 87, 414);
INSERT INTO public.europe_data VALUES (2688, 93, 5764, 268.17, 182, 414);
INSERT INTO public.europe_data VALUES (2689, 0, 120, 544.05, 183, 414);
INSERT INTO public.europe_data VALUES (2690, 0, 19, 0.9, 126, 414);
INSERT INTO public.europe_data VALUES (2691, 24, 4091, 965.63, 184, 414);
INSERT INTO public.europe_data VALUES (2692, 0, 0, 0, 88, 414);
INSERT INTO public.europe_data VALUES (2693, 510, 34237, 162.59, 35, 414);
INSERT INTO public.europe_data VALUES (2694, 6, 780, 5.87, 36, 414);
INSERT INTO public.europe_data VALUES (2695, 162, 7972, 30.72, 127, 414);
INSERT INTO public.europe_data VALUES (2696, 1, 223, 22.09, 37, 414);
INSERT INTO public.europe_data VALUES (2697, 148, 20886, 127.11, 128, 414);
INSERT INTO public.europe_data VALUES (2698, 570, 50136, 686.53, 185, 414);
INSERT INTO public.europe_data VALUES (2699, 0, 1, 0.71, 208, 414);
INSERT INTO public.europe_data VALUES (2700, 0, 23, 0.96, 209, 414);
INSERT INTO public.europe_data VALUES (2701, 1, 77, 2.4, 89, 414);
INSERT INTO public.europe_data VALUES (2702, 0, 22, 0.12, 38, 414);
INSERT INTO public.europe_data VALUES (2703, 8, 1126, 1.04, 39, 414);
INSERT INTO public.europe_data VALUES (2704, 132, 7324, 616.52, 186, 414);
INSERT INTO public.europe_data VALUES (2705, 0, 4, 13.98, 210, 414);
INSERT INTO public.europe_data VALUES (2706, 3, 3662, 112.48, 187, 414);
INSERT INTO public.europe_data VALUES (2707, 55, 2406, 104.68, 129, 414);
INSERT INTO public.europe_data VALUES (2708, 142, 9746, 7.5, 130, 414);
INSERT INTO public.europe_data VALUES (2709, 26, 4359, 162.91, 131, 414);
INSERT INTO public.europe_data VALUES (2710, 92, 5191, 243.19, 90, 414);
INSERT INTO public.europe_data VALUES (2711, 0, 7, 0.1, 211, 414);
INSERT INTO public.europe_data VALUES (2712, 72, 3858, 113.49, 91, 414);
INSERT INTO public.europe_data VALUES (2713, 350, 17422, 103.41, 92, 414);
INSERT INTO public.europe_data VALUES (2714, 301, 13282, 24.39, 132, 414);
INSERT INTO public.europe_data VALUES (2715, 2089, 166523, 770.91, 188, 414);
INSERT INTO public.europe_data VALUES (2716, 352, 34983, 590.06, 189, 414);
INSERT INTO public.europe_data VALUES (2717, 40, 5404, 325.97, 93, 414);
INSERT INTO public.europe_data VALUES (2718, 0, 1483, 107.09, 133, 414);
INSERT INTO public.europe_data VALUES (2719, 812, 57088, 484.71, 190, 414);
INSERT INTO public.europe_data VALUES (2720, 2302, 137553, 178.55, 191, 414);
INSERT INTO public.europe_data VALUES (2721, 1, 76, 1.24, 40, 414);
INSERT INTO public.europe_data VALUES (2722, 0, 0, 0, 94, 414);
INSERT INTO public.europe_data VALUES (2723, 0, 47, 42.12, 95, 414);
INSERT INTO public.europe_data VALUES (2724, 0, 1, 2.71, 96, 414);
INSERT INTO public.europe_data VALUES (2725, 0, 115, 650.16, 192, 414);
INSERT INTO public.europe_data VALUES (2726, 0, 13, 10.23, 41, 414);
INSERT INTO public.europe_data VALUES (2727, 138, 2936, 16.68, 134, 414);
INSERT INTO public.europe_data VALUES (2728, 1, 78, 0.96, 42, 414);
INSERT INTO public.europe_data VALUES (2729, 64, 14344, 334.03, 193, 414);
INSERT INTO public.europe_data VALUES (2730, 0, 5, 5.12, 43, 414);
INSERT INTO public.europe_data VALUES (2731, 0, 15, 0.45, 44, 414);
INSERT INTO public.europe_data VALUES (2732, 0, 37, 1.48, 135, 414);
INSERT INTO public.europe_data VALUES (2733, 1, 65, 264.22, 97, 414);
INSERT INTO public.europe_data VALUES (2734, 132, 15549, 580.73, 194, 414);
INSERT INTO public.europe_data VALUES (2735, 146, 9512, 1067.37, 195, 414);
INSERT INTO public.europe_data VALUES (2736, 0, 5, 1.34, 212, 414);
INSERT INTO public.europe_data VALUES (2737, 3, 288, 1.86, 45, 414);
INSERT INTO public.europe_data VALUES (2738, 398, 10455, 36.56, 46, 414);
INSERT INTO public.europe_data VALUES (2739, 12, 821, 3.12, 136, 414);
INSERT INTO public.europe_data VALUES (2740, 0, 29, 0.65, 47, 414);
INSERT INTO public.europe_data VALUES (2741, 3088, 140521, 602.72, 196, 414);
INSERT INTO public.europe_data VALUES (2742, 14, 2869, 28.4, 137, 414);
INSERT INTO public.europe_data VALUES (2743, 278, 271, 0.81, 48, 414);
INSERT INTO public.europe_data VALUES (2744, 2, 29, 11.87, 98, 414);
INSERT INTO public.europe_data VALUES (2745, 157, 25405, 428.93, 197, 414);
INSERT INTO public.europe_data VALUES (2746, 369, 57432, 1262.06, 198, 414);
INSERT INTO public.europe_data VALUES (2747, 25, 426, 4.73, 138, 414);
INSERT INTO public.europe_data VALUES (2748, 0, 15, 0.12, 139, 414);
INSERT INTO public.europe_data VALUES (2749, 1, 282, 6.01, 140, 414);
INSERT INTO public.europe_data VALUES (2750, 1, 53, 0.14, 141, 414);
INSERT INTO public.europe_data VALUES (2751, 0, 0, 0.08, 142, 414);
INSERT INTO public.europe_data VALUES (2752, 0, 159, 3.91, 49, 414);
INSERT INTO public.europe_data VALUES (2753, 4, 181, 24.23, 99, 414);
INSERT INTO public.europe_data VALUES (2754, 492, 9213, 190.86, 50, 414);
INSERT INTO public.europe_data VALUES (2755, 561, 63892, 154.47, 199, 414);
INSERT INTO public.europe_data VALUES (2756, 0, 3, 15.71, 100, 414);
INSERT INTO public.europe_data VALUES (2757, 20, 1660, 6.69, 51, 414);
INSERT INTO public.europe_data VALUES (2758, 1144, 64891, 265.59, 200, 414);
INSERT INTO public.europe_data VALUES (2759, 18, 8236, 174.2, 143, 414);
INSERT INTO public.europe_data VALUES (2760, 2327, 157099, 477.46, 201, 414);
INSERT INTO public.europe_data VALUES (2761, 0, 0, 0, 52, 414);
INSERT INTO public.europe_data VALUES (2762, 6576, 764289, 405.84, 101, 414);
INSERT INTO public.europe_data VALUES (2763, 2, 29, 54.5, 102, 414);
INSERT INTO public.europe_data VALUES (2764, 3, 365, 19.15, 103, 414);
INSERT INTO public.europe_data VALUES (2765, 15, 1632, 10.03, 144, 414);
INSERT INTO public.europe_data VALUES (2766, 25, 2558, 18.65, 104, 414);
INSERT INTO public.europe_data VALUES (2767, 0, 33, 0.05, 145, 414);
INSERT INTO public.europe_data VALUES (2768, 0, 0, 0, 214, 414);
INSERT INTO public.europe_data VALUES (2769, 0, 0, 0, 53, 414);
INSERT INTO public.europe_data VALUES (2770, 2, 0, 0, 146, 414);
INSERT INTO public.europe_data VALUES (2771, 0, 474, 4.69, 54, 414);
INSERT INTO public.europe_data VALUES (2772, 10, 157, 1.74, 55, 414);
INSERT INTO public.europe_data VALUES (2773, 27, 800, 3.77, 105, 415);
INSERT INTO public.europe_data VALUES (2774, 41, 2045, 144.88, 147, 415);
INSERT INTO public.europe_data VALUES (2775, 59, 2129, 8.99, 1, 415);
INSERT INTO public.europe_data VALUES (2776, 6, 787, 1900.84, 148, 415);
INSERT INTO public.europe_data VALUES (2777, 17, 1779, 10.5, 2, 415);
INSERT INTO public.europe_data VALUES (2778, 0, 0, 0, 56, 415);
INSERT INTO public.europe_data VALUES (2779, 0, 4, 9.27, 57, 415);
INSERT INTO public.europe_data VALUES (2780, 2244, 82944, 410.56, 58, 415);
INSERT INTO public.europe_data VALUES (2781, 195, 14638, 972.17, 149, 415);
INSERT INTO public.europe_data VALUES (2782, 2, 99, 185.31, 59, 415);
INSERT INTO public.europe_data VALUES (2783, 2, 75, 0.81, 202, 415);
INSERT INTO public.europe_data VALUES (2784, 130, 28574, 514.21, 150, 415);
INSERT INTO public.europe_data VALUES (2785, 69, 6485, 114.25, 151, 415);
INSERT INTO public.europe_data VALUES (2786, 12, 304, 259.57, 60, 415);
INSERT INTO public.europe_data VALUES (2787, 9, 1668, 245.01, 106, 415);
INSERT INTO public.europe_data VALUES (2788, 138, 10437, 12.69, 107, 415);
INSERT INTO public.europe_data VALUES (2789, 0, 10, 5.23, 61, 415);
INSERT INTO public.europe_data VALUES (2790, 28, 6636, 124.42, 152, 415);
INSERT INTO public.europe_data VALUES (2791, 1056, 99544, 1788.42, 153, 415);
INSERT INTO public.europe_data VALUES (2792, 8, 317, 166.26, 62, 415);
INSERT INTO public.europe_data VALUES (2793, 0, 86, 1.25, 3, 415);
INSERT INTO public.europe_data VALUES (2794, 0, 8, 22.4, 63, 415);
INSERT INTO public.europe_data VALUES (2795, 0, 12, 3.54, 108, 415);
INSERT INTO public.europe_data VALUES (2796, 86, 980, 17.91, 64, 415);
INSERT INTO public.europe_data VALUES (2797, 0, 3, 11.55, 65, 415);
INSERT INTO public.europe_data VALUES (2798, 162, 10611, 526.66, 154, 415);
INSERT INTO public.europe_data VALUES (2799, 3, 719, 60.77, 4, 415);
INSERT INTO public.europe_data VALUES (2800, 2940, 151577, 147.06, 66, 415);
INSERT INTO public.europe_data VALUES (2801, 0, 0, 3.33, 67, 415);
INSERT INTO public.europe_data VALUES (2802, 0, 0, 0.23, 109, 415);
INSERT INTO public.europe_data VALUES (2803, 204, 16180, 350.94, 155, 415);
INSERT INTO public.europe_data VALUES (2804, 2, 49, 0.59, 5, 415);
INSERT INTO public.europe_data VALUES (2805, 0, 33, 0.41, 6, 415);
INSERT INTO public.europe_data VALUES (2806, 0, 4, 0.05, 110, 415);
INSERT INTO public.europe_data VALUES (2807, 1, 223, 1.36, 7, 415);
INSERT INTO public.europe_data VALUES (2808, 233, 20737, 103.43, 68, 415);
INSERT INTO public.europe_data VALUES (2809, 1, 452, 199.3, 8, 415);
INSERT INTO public.europe_data VALUES (2810, 0, 1, 10.78, 69, 415);
INSERT INTO public.europe_data VALUES (2811, 0, 4, 0.23, 9, 415);
INSERT INTO public.europe_data VALUES (2812, 2, 61, 0.75, 10, 415);
INSERT INTO public.europe_data VALUES (2813, 303, 9801, 106.08, 70, 415);
INSERT INTO public.europe_data VALUES (2814, 0, 196, 0.03, 111, 415);
INSERT INTO public.europe_data VALUES (2815, 1361, 67436, 245.83, 71, 415);
INSERT INTO public.europe_data VALUES (2816, 0, 28, 5.05, 11, 415);
INSERT INTO public.europe_data VALUES (2817, 0, 37, 2.49, 12, 415);
INSERT INTO public.europe_data VALUES (2818, 103, 6883, 286.42, 72, 415);
INSERT INTO public.europe_data VALUES (2819, 4, 246, 1.53, 13, 415);
INSERT INTO public.europe_data VALUES (2820, 125, 15115, 635.76, 156, 415);
INSERT INTO public.europe_data VALUES (2821, 0, 369, 6.31, 73, 415);
INSERT INTO public.europe_data VALUES (2822, 0, 129, 148.69, 74, 415);
INSERT INTO public.europe_data VALUES (2823, 1, 1018, 219.09, 157, 415);
INSERT INTO public.europe_data VALUES (2824, 1228, 83547, 1575.23, 158, 415);
INSERT INTO public.europe_data VALUES (2825, 3, 229, 0.37, 14, 415);
INSERT INTO public.europe_data VALUES (2826, 21, 6943, 205.08, 159, 415);
INSERT INTO public.europe_data VALUES (2827, 0, 27, 10.68, 15, 415);
INSERT INTO public.europe_data VALUES (2828, 0, 4, 12.53, 75, 415);
INSERT INTO public.europe_data VALUES (2829, 26, 2805, 55.73, 76, 415);
INSERT INTO public.europe_data VALUES (2830, 131, 7559, 91.55, 77, 415);
INSERT INTO public.europe_data VALUES (2831, 79, 1196, 2.3, 16, 415);
INSERT INTO public.europe_data VALUES (2832, 30, 1430, 36.4, 78, 415);
INSERT INTO public.europe_data VALUES (2833, 0, 10, 1.4, 17, 415);
INSERT INTO public.europe_data VALUES (2834, 0, 2, 1.09, 18, 415);
INSERT INTO public.europe_data VALUES (2835, 0, 574, 68.46, 160, 415);
INSERT INTO public.europe_data VALUES (2836, 1, 71, 12.63, 19, 415);
INSERT INTO public.europe_data VALUES (2837, 52, 3240, 6.64, 20, 415);
INSERT INTO public.europe_data VALUES (2838, 0, 0, 0, 79, 415);
INSERT INTO public.europe_data VALUES (2839, 0, 5, 20.54, 161, 415);
INSERT INTO public.europe_data VALUES (2840, 0, 1, 0.22, 203, 415);
INSERT INTO public.europe_data VALUES (2841, 5, 1443, 51.96, 162, 415);
INSERT INTO public.europe_data VALUES (2842, 2258, 275408, 771.32, 163, 415);
INSERT INTO public.europe_data VALUES (2843, 9, 1465, 1240.67, 204, 415);
INSERT INTO public.europe_data VALUES (2844, 1, 49, 4, 21, 415);
INSERT INTO public.europe_data VALUES (2845, 0, 12, 0.98, 22, 415);
INSERT INTO public.europe_data VALUES (2846, 127, 12276, 628.06, 164, 415);
INSERT INTO public.europe_data VALUES (2847, 474, 107161, 215.29, 165, 415);
INSERT INTO public.europe_data VALUES (2848, 4, 434, 2.68, 23, 415);
INSERT INTO public.europe_data VALUES (2849, 0, 36, 391.62, 166, 415);
INSERT INTO public.europe_data VALUES (2850, 61, 10147, 145.08, 167, 415);
INSERT INTO public.europe_data VALUES (2851, 0, 0, 1.76, 80, 415);
INSERT INTO public.europe_data VALUES (2852, 0, 0, 0.89, 81, 415);
INSERT INTO public.europe_data VALUES (2853, 7, 477, 608.51, 205, 415);
INSERT INTO public.europe_data VALUES (2854, 94, 3317, 38.36, 82, 415);
INSERT INTO public.europe_data VALUES (2855, 0, 5, 18.61, 168, 415);
INSERT INTO public.europe_data VALUES (2856, 2, 526, 5.3, 24, 415);
INSERT INTO public.europe_data VALUES (2857, 0, 10, 1.25, 25, 415);
INSERT INTO public.europe_data VALUES (2858, 7, 185, 60.55, 83, 415);
INSERT INTO public.europe_data VALUES (2859, 0, 28, 1.15, 84, 415);
INSERT INTO public.europe_data VALUES (2860, 0, 0, 0, 169, 415);
INSERT INTO public.europe_data VALUES (2861, 52, 4998, 100.42, 85, 415);
INSERT INTO public.europe_data VALUES (2862, 417, 21217, 358.26, 170, 415);
INSERT INTO public.europe_data VALUES (2863, 1, 442, 233.9, 171, 415);
INSERT INTO public.europe_data VALUES (2864, 3593, 319354, 49.69, 112, 415);
INSERT INTO public.europe_data VALUES (2865, 644, 23072, 18.81, 113, 415);
INSERT INTO public.europe_data VALUES (2866, 2682, 51595, 108.68, 114, 415);
INSERT INTO public.europe_data VALUES (2867, 343, 23581, 123.77, 115, 415);
INSERT INTO public.europe_data VALUES (2868, 33, 4874, 245.5, 172, 415);
INSERT INTO public.europe_data VALUES (2869, 0, 5, 5.91, 173, 415);
INSERT INTO public.europe_data VALUES (2870, 157, 4983, 132.46, 116, 415);
INSERT INTO public.europe_data VALUES (2871, 1488, 183553, 488.89, 174, 415);
INSERT INTO public.europe_data VALUES (2872, 21, 417, 29.07, 86, 415);
INSERT INTO public.europe_data VALUES (2873, 56, 4739, 6.85, 117, 415);
INSERT INTO public.europe_data VALUES (2874, 0, 44, 77.92, 175, 415);
INSERT INTO public.europe_data VALUES (2875, 287, 22779, 379.07, 118, 415);
INSERT INTO public.europe_data VALUES (2876, 37, 3400, 29.05, 119, 415);
INSERT INTO public.europe_data VALUES (2877, 111, 6156, 20.92, 26, 415);
INSERT INTO public.europe_data VALUES (2878, 25, 2236, 182.82, 176, 415);
INSERT INTO public.europe_data VALUES (2879, 36, 4899, 246.92, 120, 415);
INSERT INTO public.europe_data VALUES (2880, 21, 3709, 114.61, 121, 415);
INSERT INTO public.europe_data VALUES (2881, 0, 0, 0.01, 122, 415);
INSERT INTO public.europe_data VALUES (2882, 18, 1458, 139.9, 177, 415);
INSERT INTO public.europe_data VALUES (2883, 78, 11227, 296.56, 123, 415);
INSERT INTO public.europe_data VALUES (2884, 0, 7, 5.36, 27, 415);
INSERT INTO public.europe_data VALUES (2885, 0, 33, 0.99, 28, 415);
INSERT INTO public.europe_data VALUES (2886, 76, 6032, 195.57, 29, 415);
INSERT INTO public.europe_data VALUES (2887, 2, 186, 852.05, 178, 415);
INSERT INTO public.europe_data VALUES (2888, 32, 5535, 293.4, 179, 415);
INSERT INTO public.europe_data VALUES (2889, 15, 4578, 1325.31, 180, 415);
INSERT INTO public.europe_data VALUES (2890, 0, 143, 1.12, 30, 415);
INSERT INTO public.europe_data VALUES (2891, 1, 42, 0.4, 31, 415);
INSERT INTO public.europe_data VALUES (2892, 20, 5940, 37.58, 124, 415);
INSERT INTO public.europe_data VALUES (2893, 1, 196, 92.47, 125, 415);
INSERT INTO public.europe_data VALUES (2894, 3, 55, 0.84, 32, 415);
INSERT INTO public.europe_data VALUES (2895, 8, 823, 336.54, 181, 415);
INSERT INTO public.europe_data VALUES (2896, 0, 1, 0, 206, 415);
INSERT INTO public.europe_data VALUES (2897, 0, 55, 2.52, 33, 415);
INSERT INTO public.europe_data VALUES (2898, 0, 11, 3.07, 34, 415);
INSERT INTO public.europe_data VALUES (2899, 2971, 38232, 61.27, 87, 415);
INSERT INTO public.europe_data VALUES (2900, 115, 5079, 235.75, 182, 415);
INSERT INTO public.europe_data VALUES (2901, 0, 60, 305.27, 183, 415);
INSERT INTO public.europe_data VALUES (2902, 0, 10, 0.78, 126, 415);
INSERT INTO public.europe_data VALUES (2903, 47, 1917, 498.09, 184, 415);
INSERT INTO public.europe_data VALUES (2904, 0, 0, 0, 88, 415);
INSERT INTO public.europe_data VALUES (2905, 461, 25063, 134.11, 35, 415);
INSERT INTO public.europe_data VALUES (2906, 7, 1002, 6.99, 36, 415);
INSERT INTO public.europe_data VALUES (2907, 163, 8631, 32.16, 127, 415);
INSERT INTO public.europe_data VALUES (2908, 0, 328, 27.86, 37, 415);
INSERT INTO public.europe_data VALUES (2909, 113, 15478, 144.44, 128, 415);
INSERT INTO public.europe_data VALUES (2910, 388, 68512, 759.18, 185, 415);
INSERT INTO public.europe_data VALUES (2911, 0, 1, 0.35, 208, 415);
INSERT INTO public.europe_data VALUES (2912, 0, 23, 1.61, 209, 415);
INSERT INTO public.europe_data VALUES (2913, 1, 80, 2.46, 89, 415);
INSERT INTO public.europe_data VALUES (2914, 0, 6, 0.05, 38, 415);
INSERT INTO public.europe_data VALUES (2915, 16, 972, 0.76, 39, 415);
INSERT INTO public.europe_data VALUES (2916, 85, 5482, 424.05, 186, 415);
INSERT INTO public.europe_data VALUES (2917, 0, 4, 17.48, 210, 415);
INSERT INTO public.europe_data VALUES (2918, 3, 2331, 64.32, 187, 415);
INSERT INTO public.europe_data VALUES (2919, 72, 2802, 116.2, 129, 415);
INSERT INTO public.europe_data VALUES (2920, 96, 6491, 5.38, 130, 415);
INSERT INTO public.europe_data VALUES (2921, 43, 3756, 145.8, 131, 415);
INSERT INTO public.europe_data VALUES (2922, 73, 5136, 225.86, 90, 415);
INSERT INTO public.europe_data VALUES (2923, 0, 2, 0.1, 211, 415);
INSERT INTO public.europe_data VALUES (2924, 109, 4137, 127.86, 91, 415);
INSERT INTO public.europe_data VALUES (2925, 380, 16196, 111.46, 92, 415);
INSERT INTO public.europe_data VALUES (2926, 261, 13085, 24.51, 132, 415);
INSERT INTO public.europe_data VALUES (2927, 1345, 126214, 537.58, 188, 415);
INSERT INTO public.europe_data VALUES (2928, 228, 25655, 432.34, 189, 415);
INSERT INTO public.europe_data VALUES (2929, 31, 4158, 319.36, 93, 415);
INSERT INTO public.europe_data VALUES (2930, 2, 1550, 116.13, 133, 415);
INSERT INTO public.europe_data VALUES (2931, 676, 37015, 341.37, 190, 415);
INSERT INTO public.europe_data VALUES (2932, 2185, 122904, 162.78, 191, 415);
INSERT INTO public.europe_data VALUES (2933, 1, 80, 1.36, 40, 415);
INSERT INTO public.europe_data VALUES (2934, 0, 0, 0, 94, 415);
INSERT INTO public.europe_data VALUES (2935, 0, 30, 27.9, 95, 415);
INSERT INTO public.europe_data VALUES (2936, 0, 2, 7.23, 96, 415);
INSERT INTO public.europe_data VALUES (2937, 0, 109, 490.52, 192, 415);
INSERT INTO public.europe_data VALUES (2938, 1, 9, 7.44, 41, 415);
INSERT INTO public.europe_data VALUES (2939, 106, 2781, 15.92, 134, 415);
INSERT INTO public.europe_data VALUES (2940, 4, 79, 1.3, 42, 415);
INSERT INTO public.europe_data VALUES (2941, 34, 8917, 175.81, 193, 415);
INSERT INTO public.europe_data VALUES (2942, 0, 0, 4.09, 43, 415);
INSERT INTO public.europe_data VALUES (2943, 0, 20, 0.46, 44, 415);
INSERT INTO public.europe_data VALUES (2944, 0, 49, 1.86, 135, 415);
INSERT INTO public.europe_data VALUES (2945, 0, 47, 184.01, 97, 415);
INSERT INTO public.europe_data VALUES (2946, 60, 16103, 552.45, 194, 415);
INSERT INTO public.europe_data VALUES (2947, 53, 12699, 1081.5, 195, 415);
INSERT INTO public.europe_data VALUES (2948, 0, 4, 0.75, 212, 415);
INSERT INTO public.europe_data VALUES (2949, 0, 0, 0.5, 45, 415);
INSERT INTO public.europe_data VALUES (2950, 443, 10955, 39.33, 46, 415);
INSERT INTO public.europe_data VALUES (2951, 11, 777, 2.84, 136, 415);
INSERT INTO public.europe_data VALUES (2952, 3, 43, 0.76, 47, 415);
INSERT INTO public.europe_data VALUES (2953, 1226, 142377, 567.24, 196, 415);
INSERT INTO public.europe_data VALUES (2954, 6, 3188, 25.9, 137, 415);
INSERT INTO public.europe_data VALUES (2955, 0, 77, 0.3, 48, 415);
INSERT INTO public.europe_data VALUES (2956, 2, 40, 13.76, 98, 415);
INSERT INTO public.europe_data VALUES (2957, 82, 18475, 270.09, 197, 415);
INSERT INTO public.europe_data VALUES (2958, 159, 50405, 928.15, 198, 415);
INSERT INTO public.europe_data VALUES (2959, 23, 381, 4.17, 138, 415);
INSERT INTO public.europe_data VALUES (2960, 0, 13, 0.1, 139, 415);
INSERT INTO public.europe_data VALUES (2961, 1, 278, 6.02, 140, 415);
INSERT INTO public.europe_data VALUES (2962, 0, 44, 0.14, 141, 415);
INSERT INTO public.europe_data VALUES (2963, 0, 1, 0.08, 142, 415);
INSERT INTO public.europe_data VALUES (2964, 5, 157, 3.71, 49, 415);
INSERT INTO public.europe_data VALUES (2965, 2, 157, 26.6, 99, 415);
INSERT INTO public.europe_data VALUES (2966, 562, 13107, 182.68, 50, 415);
INSERT INTO public.europe_data VALUES (2967, 527, 62782, 151.46, 199, 415);
INSERT INTO public.europe_data VALUES (2968, 0, 3, 15.71, 100, 415);
INSERT INTO public.europe_data VALUES (2969, 11, 1300, 4.86, 51, 415);
INSERT INTO public.europe_data VALUES (2970, 915, 51951, 208.67, 200, 415);
INSERT INTO public.europe_data VALUES (2971, 19, 8784, 187.35, 143, 415);
INSERT INTO public.europe_data VALUES (2972, 1821, 161114, 468.9, 201, 415);
INSERT INTO public.europe_data VALUES (2973, 0, 0, 0, 52, 415);
INSERT INTO public.europe_data VALUES (2974, 5766, 571197, 319.93, 101, 415);
INSERT INTO public.europe_data VALUES (2975, 0, 28, 39.2, 102, 415);
INSERT INTO public.europe_data VALUES (2976, 6, 298, 17.85, 103, 415);
INSERT INTO public.europe_data VALUES (2977, 20, 1676, 11.3, 144, 415);
INSERT INTO public.europe_data VALUES (2978, 28, 2760, 19.95, 104, 415);
INSERT INTO public.europe_data VALUES (2979, 0, 12, 0.05, 145, 415);
INSERT INTO public.europe_data VALUES (2980, 0, 0, 0, 214, 415);
INSERT INTO public.europe_data VALUES (2981, 0, 0, 0, 53, 415);
INSERT INTO public.europe_data VALUES (2982, 1, 0, 0.01, 146, 415);
INSERT INTO public.europe_data VALUES (2983, 1, 363, 3.51, 54, 415);
INSERT INTO public.europe_data VALUES (2984, 6, 98, 1.55, 55, 415);
INSERT INTO public.europe_data VALUES (2985, 22, 633, 2.72, 105, 416);
INSERT INTO public.europe_data VALUES (2986, 26, 2102, 131.29, 147, 416);
INSERT INTO public.europe_data VALUES (2987, 58, 1741, 7.13, 1, 416);
INSERT INTO public.europe_data VALUES (2988, 10, 661, 1761.69, 148, 416);
INSERT INTO public.europe_data VALUES (2989, 26, 1564, 8.74, 2, 416);
INSERT INTO public.europe_data VALUES (2990, 0, 0, 0, 56, 416);
INSERT INTO public.europe_data VALUES (2991, 0, 5, 13.39, 57, 416);
INSERT INTO public.europe_data VALUES (2992, 2629, 100909, 438.54, 58, 416);
INSERT INTO public.europe_data VALUES (2993, 115, 14116, 755.95, 149, 416);
INSERT INTO public.europe_data VALUES (2994, 2, 98, 212.59, 59, 416);
INSERT INTO public.europe_data VALUES (2995, 1, 130, 1.02, 202, 416);
INSERT INTO public.europe_data VALUES (2996, 74, 16979, 299.74, 150, 416);
INSERT INTO public.europe_data VALUES (2997, 45, 4995, 79.39, 151, 416);
INSERT INTO public.europe_data VALUES (2998, 10, 707, 341.99, 60, 416);
INSERT INTO public.europe_data VALUES (2999, 12, 2353, 302.71, 106, 416);
INSERT INTO public.europe_data VALUES (3000, 143, 10246, 12.6, 107, 416);
INSERT INTO public.europe_data VALUES (3001, 0, 5, 6.62, 61, 416);
INSERT INTO public.europe_data VALUES (3002, 28, 5125, 98.27, 152, 416);
INSERT INTO public.europe_data VALUES (3003, 502, 105329, 1549.69, 153, 416);
INSERT INTO public.europe_data VALUES (3004, 6, 332, 183.94, 62, 416);
INSERT INTO public.europe_data VALUES (3005, 0, 61, 1.24, 3, 416);
INSERT INTO public.europe_data VALUES (3006, 0, 6, 11.2, 63, 416);
INSERT INTO public.europe_data VALUES (3007, 0, 15, 4.32, 108, 416);
INSERT INTO public.europe_data VALUES (3008, 164, 1082, 19.79, 64, 416);
INSERT INTO public.europe_data VALUES (3009, 1, 0, 7.7, 65, 416);
INSERT INTO public.europe_data VALUES (3010, 102, 6774, 310.48, 154, 416);
INSERT INTO public.europe_data VALUES (3011, 1, 681, 60.9, 4, 416);
INSERT INTO public.europe_data VALUES (3012, 3229, 158784, 141.74, 66, 416);
INSERT INTO public.europe_data VALUES (3013, 0, 1, 3.33, 67, 416);
INSERT INTO public.europe_data VALUES (3014, 0, 1, 0.46, 109, 416);
INSERT INTO public.europe_data VALUES (3015, 108, 8386, 192.67, 155, 416);
INSERT INTO public.europe_data VALUES (3016, 0, 70, 0.84, 5, 416);
INSERT INTO public.europe_data VALUES (3017, 0, 14, 0.28, 6, 416);
INSERT INTO public.europe_data VALUES (3018, 0, 4, 0.02, 110, 416);
INSERT INTO public.europe_data VALUES (3019, 2, 129, 1.42, 7, 416);
INSERT INTO public.europe_data VALUES (3020, 186, 17956, 101.54, 68, 416);
INSERT INTO public.europe_data VALUES (3021, 8, 644, 240.76, 8, 416);
INSERT INTO public.europe_data VALUES (3022, 0, 6, 27.71, 69, 416);
INSERT INTO public.europe_data VALUES (3023, 0, 7, 0.17, 9, 416);
INSERT INTO public.europe_data VALUES (3024, 3, 58, 0.83, 10, 416);
INSERT INTO public.europe_data VALUES (3025, 309, 10303, 109.18, 70, 416);
INSERT INTO public.europe_data VALUES (3026, 0, 179, 0.02, 111, 416);
INSERT INTO public.europe_data VALUES (3027, 1184, 56313, 207.73, 71, 416);
INSERT INTO public.europe_data VALUES (3028, 0, 15, 2.59, 11, 416);
INSERT INTO public.europe_data VALUES (3029, 0, 97, 2.51, 12, 416);
INSERT INTO public.europe_data VALUES (3030, 99, 7574, 310.03, 72, 416);
INSERT INTO public.europe_data VALUES (3031, 1, 147, 1.23, 13, 416);
INSERT INTO public.europe_data VALUES (3032, 74, 10800, 391.05, 156, 416);
INSERT INTO public.europe_data VALUES (3033, 3, 346, 5.19, 73, 416);
INSERT INTO public.europe_data VALUES (3034, 0, 114, 168.27, 74, 416);
INSERT INTO public.europe_data VALUES (3035, 0, 901, 177.99, 157, 416);
INSERT INTO public.europe_data VALUES (3036, 779, 84212, 1323.85, 158, 416);
INSERT INTO public.europe_data VALUES (3037, 2, 91, 0.34, 14, 416);
INSERT INTO public.europe_data VALUES (3038, 22, 4964, 136.65, 159, 416);
INSERT INTO public.europe_data VALUES (3039, 0, 77, 11.61, 15, 416);
INSERT INTO public.europe_data VALUES (3040, 0, 5, 8.36, 75, 416);
INSERT INTO public.europe_data VALUES (3041, 24, 3180, 56.34, 76, 416);
INSERT INTO public.europe_data VALUES (3042, 166, 8346, 84.05, 77, 416);
INSERT INTO public.europe_data VALUES (3043, 79, 1116, 2.14, 16, 416);
INSERT INTO public.europe_data VALUES (3044, 31, 919, 37.02, 78, 416);
INSERT INTO public.europe_data VALUES (3045, 0, 9, 1.18, 17, 416);
INSERT INTO public.europe_data VALUES (3046, 0, 36, 1.34, 18, 416);
INSERT INTO public.europe_data VALUES (3047, 5, 333, 41.21, 160, 416);
INSERT INTO public.europe_data VALUES (3048, 0, 74, 16.11, 19, 416);
INSERT INTO public.europe_data VALUES (3049, 74, 4206, 8.07, 20, 416);
INSERT INTO public.europe_data VALUES (3050, 0, 0, 0, 79, 416);
INSERT INTO public.europe_data VALUES (3051, 0, 5, 26.71, 161, 416);
INSERT INTO public.europe_data VALUES (3052, 0, 1, 0.11, 203, 416);
INSERT INTO public.europe_data VALUES (3053, 2, 1424, 51.65, 162, 416);
INSERT INTO public.europe_data VALUES (3054, 1284, 241473, 602.17, 163, 416);
INSERT INTO public.europe_data VALUES (3055, 6, 2000, 1111.77, 204, 416);
INSERT INTO public.europe_data VALUES (3056, 0, 38, 3.87, 21, 416);
INSERT INTO public.europe_data VALUES (3057, 1, 11, 1.19, 22, 416);
INSERT INTO public.europe_data VALUES (3058, 79, 12826, 463.1, 164, 416);
INSERT INTO public.europe_data VALUES (3059, 267, 71567, 135.55, 165, 416);
INSERT INTO public.europe_data VALUES (3060, 6, 380, 2.25, 23, 416);
INSERT INTO public.europe_data VALUES (3061, 0, 96, 539.96, 166, 416);
INSERT INTO public.europe_data VALUES (3062, 65, 5412, 78.55, 167, 416);
INSERT INTO public.europe_data VALUES (3063, 0, 1, 1.76, 80, 416);
INSERT INTO public.europe_data VALUES (3064, 0, 1, 3.57, 81, 416);
INSERT INTO public.europe_data VALUES (3065, 6, 541, 680.24, 205, 416);
INSERT INTO public.europe_data VALUES (3066, 114, 3427, 40.22, 82, 416);
INSERT INTO public.europe_data VALUES (3067, 0, 7, 10.86, 168, 416);
INSERT INTO public.europe_data VALUES (3068, 1, 151, 5.07, 24, 416);
INSERT INTO public.europe_data VALUES (3069, 0, 14, 0.94, 25, 416);
INSERT INTO public.europe_data VALUES (3070, 10, 289, 70.77, 83, 416);
INSERT INTO public.europe_data VALUES (3071, 1, 101, 1.28, 84, 416);
INSERT INTO public.europe_data VALUES (3072, 0, 0, 1717.79, 169, 416);
INSERT INTO public.europe_data VALUES (3073, 55, 4789, 93.71, 85, 416);
INSERT INTO public.europe_data VALUES (3074, 299, 13795, 235.2, 170, 416);
INSERT INTO public.europe_data VALUES (3075, 0, 393, 258.27, 171, 416);
INSERT INTO public.europe_data VALUES (3076, 4404, 359686, 57.77, 112, 416);
INSERT INTO public.europe_data VALUES (3077, 788, 27845, 20.79, 113, 416);
INSERT INTO public.europe_data VALUES (3078, 2241, 38516, 83, 114, 416);
INSERT INTO public.europe_data VALUES (3079, 369, 25073, 125.61, 115, 416);
INSERT INTO public.europe_data VALUES (3080, 30, 7166, 297.7, 172, 416);
INSERT INTO public.europe_data VALUES (3081, 0, 0, 2.36, 173, 416);
INSERT INTO public.europe_data VALUES (3082, 188, 6302, 215.04, 116, 416);
INSERT INTO public.europe_data VALUES (3083, 795, 111541, 283.02, 174, 416);
INSERT INTO public.europe_data VALUES (3084, 17, 440, 33.78, 86, 416);
INSERT INTO public.europe_data VALUES (3085, 44, 3947, 6.09, 117, 416);
INSERT INTO public.europe_data VALUES (3086, 0, 40, 75.14, 175, 416);
INSERT INTO public.europe_data VALUES (3087, 234, 15514, 278.77, 118, 416);
INSERT INTO public.europe_data VALUES (3088, 40, 1990, 20.07, 119, 416);
INSERT INTO public.europe_data VALUES (3089, 70, 4840, 15.55, 26, 416);
INSERT INTO public.europe_data VALUES (3090, 10, 1052, 98.08, 176, 416);
INSERT INTO public.europe_data VALUES (3091, 45, 5489, 250.03, 120, 416);
INSERT INTO public.europe_data VALUES (3092, 23, 3644, 108.17, 121, 416);
INSERT INTO public.europe_data VALUES (3093, 0, 1, 0.01, 122, 416);
INSERT INTO public.europe_data VALUES (3094, 14, 1228, 104.59, 177, 416);
INSERT INTO public.europe_data VALUES (3095, 45, 9104, 274.69, 123, 416);
INSERT INTO public.europe_data VALUES (3096, 1, 107, 6.35, 27, 416);
INSERT INTO public.europe_data VALUES (3097, 0, 16, 0.61, 28, 416);
INSERT INTO public.europe_data VALUES (3098, 70, 7223, 196.25, 29, 416);
INSERT INTO public.europe_data VALUES (3099, 0, 141, 591.48, 178, 416);
INSERT INTO public.europe_data VALUES (3100, 21, 2663, 145.37, 179, 416);
INSERT INTO public.europe_data VALUES (3101, 12, 3558, 789.06, 180, 416);
INSERT INTO public.europe_data VALUES (3102, 6, 158, 0.93, 30, 416);
INSERT INTO public.europe_data VALUES (3103, 2, 33, 0.37, 31, 416);
INSERT INTO public.europe_data VALUES (3104, 42, 6067, 34.14, 124, 416);
INSERT INTO public.europe_data VALUES (3105, 0, 295, 115.08, 125, 416);
INSERT INTO public.europe_data VALUES (3106, 1, 111, 1.04, 32, 416);
INSERT INTO public.europe_data VALUES (3107, 8, 838, 350.92, 181, 416);
INSERT INTO public.europe_data VALUES (3108, 0, 59, 2.47, 33, 416);
INSERT INTO public.europe_data VALUES (3109, 0, 28, 3.15, 34, 416);
INSERT INTO public.europe_data VALUES (3110, 2757, 39933, 45.79, 87, 416);
INSERT INTO public.europe_data VALUES (3111, 101, 4453, 231.3, 182, 416);
INSERT INTO public.europe_data VALUES (3112, 0, 41, 217.62, 183, 416);
INSERT INTO public.europe_data VALUES (3113, 0, 15, 0.65, 126, 416);
INSERT INTO public.europe_data VALUES (3114, 30, 1182, 470.6, 184, 416);
INSERT INTO public.europe_data VALUES (3115, 0, 0, 0, 88, 416);
INSERT INTO public.europe_data VALUES (3116, 373, 23849, 123.59, 35, 416);
INSERT INTO public.europe_data VALUES (3117, 11, 1120, 6.54, 36, 416);
INSERT INTO public.europe_data VALUES (3118, 215, 8749, 31.08, 127, 416);
INSERT INTO public.europe_data VALUES (3119, 2, 367, 29.02, 37, 416);
INSERT INTO public.europe_data VALUES (3120, 108, 25843, 175.94, 128, 416);
INSERT INTO public.europe_data VALUES (3121, 285, 62691, 673.96, 185, 416);
INSERT INTO public.europe_data VALUES (3122, 0, 0, 0, 208, 416);
INSERT INTO public.europe_data VALUES (3123, 0, 54, 1.44, 209, 416);
INSERT INTO public.europe_data VALUES (3124, 1, 81, 2.6, 89, 416);
INSERT INTO public.europe_data VALUES (3125, 0, 5, 0.06, 38, 416);
INSERT INTO public.europe_data VALUES (3126, 5, 552, 0.86, 39, 416);
INSERT INTO public.europe_data VALUES (3127, 85, 3326, 289.68, 186, 416);
INSERT INTO public.europe_data VALUES (3128, 0, 6, 26.22, 210, 416);
INSERT INTO public.europe_data VALUES (3129, 1, 1096, 37.74, 187, 416);
INSERT INTO public.europe_data VALUES (3130, 73, 2979, 141.55, 129, 416);
INSERT INTO public.europe_data VALUES (3131, 80, 5150, 4.47, 130, 416);
INSERT INTO public.europe_data VALUES (3132, 39, 3507, 130.28, 131, 416);
INSERT INTO public.europe_data VALUES (3133, 69, 4455, 209.28, 90, 416);
INSERT INTO public.europe_data VALUES (3134, 0, 7, 0.39, 211, 416);
INSERT INTO public.europe_data VALUES (3135, 121, 4870, 140.8, 91, 416);
INSERT INTO public.europe_data VALUES (3136, 390, 20040, 121.02, 92, 416);
INSERT INTO public.europe_data VALUES (3137, 325, 13410, 28.38, 132, 416);
INSERT INTO public.europe_data VALUES (3138, 865, 77922, 336.75, 188, 416);
INSERT INTO public.europe_data VALUES (3139, 135, 18775, 311.6, 189, 416);
INSERT INTO public.europe_data VALUES (3140, 35, 5210, 301.08, 93, 416);
INSERT INTO public.europe_data VALUES (3141, 6, 1739, 112.46, 133, 416);
INSERT INTO public.europe_data VALUES (3142, 519, 29260, 280.02, 190, 416);
INSERT INTO public.europe_data VALUES (3143, 1863, 114543, 147.5, 191, 416);
INSERT INTO public.europe_data VALUES (3144, 0, 92, 1.35, 40, 416);
INSERT INTO public.europe_data VALUES (3145, 0, 0, 0, 94, 416);
INSERT INTO public.europe_data VALUES (3146, 0, 21, 13.68, 95, 416);
INSERT INTO public.europe_data VALUES (3147, 0, 6, 8.14, 96, 416);
INSERT INTO public.europe_data VALUES (3148, 0, 60, 194.47, 192, 416);
INSERT INTO public.europe_data VALUES (3149, 0, 7, 5.12, 41, 416);
INSERT INTO public.europe_data VALUES (3150, 111, 2673, 16.36, 134, 416);
INSERT INTO public.europe_data VALUES (3151, 4, 133, 1.74, 42, 416);
INSERT INTO public.europe_data VALUES (3152, 16, 3326, 67.48, 193, 416);
INSERT INTO public.europe_data VALUES (3153, 0, 4, 5.12, 43, 416);
INSERT INTO public.europe_data VALUES (3154, 1, 16, 0.51, 44, 416);
INSERT INTO public.europe_data VALUES (3155, 0, 59, 1.62, 135, 416);
INSERT INTO public.europe_data VALUES (3156, 0, 31, 174.57, 97, 416);
INSERT INTO public.europe_data VALUES (3157, 71, 14008, 440.19, 194, 416);
INSERT INTO public.europe_data VALUES (3158, 22, 9806, 686.48, 195, 416);
INSERT INTO public.europe_data VALUES (3159, 0, 1, 0.6, 212, 416);
INSERT INTO public.europe_data VALUES (3160, 5, 77, 0.5, 45, 416);
INSERT INTO public.europe_data VALUES (3161, 497, 12075, 39.96, 46, 416);
INSERT INTO public.europe_data VALUES (3162, 13, 680, 2.44, 136, 416);
INSERT INTO public.europe_data VALUES (3163, 1, 41, 0.96, 47, 416);
INSERT INTO public.europe_data VALUES (3164, 1039, 123871, 446.03, 196, 416);
INSERT INTO public.europe_data VALUES (3165, 2, 2334, 14.63, 137, 416);
INSERT INTO public.europe_data VALUES (3166, 1, 51, 0.17, 48, 416);
INSERT INTO public.europe_data VALUES (3167, 0, 40, 20.47, 98, 416);
INSERT INTO public.europe_data VALUES (3168, 43, 9156, 144.44, 197, 416);
INSERT INTO public.europe_data VALUES (3169, 53, 28901, 504.33, 198, 416);
INSERT INTO public.europe_data VALUES (3170, 21, 331, 4.31, 138, 416);
INSERT INTO public.europe_data VALUES (3171, 0, 10, 0.1, 139, 416);
INSERT INTO public.europe_data VALUES (3172, 1, 283, 5.94, 140, 416);
INSERT INTO public.europe_data VALUES (3173, 0, 52, 0.15, 141, 416);
INSERT INTO public.europe_data VALUES (3174, 0, 0, 0.08, 142, 416);
INSERT INTO public.europe_data VALUES (3175, 1, 143, 3.22, 49, 416);
INSERT INTO public.europe_data VALUES (3176, 9, 214, 29.39, 99, 416);
INSERT INTO public.europe_data VALUES (3177, 193, 8257, 149.98, 50, 416);
INSERT INTO public.europe_data VALUES (3178, 503, 61418, 146.93, 199, 416);
INSERT INTO public.europe_data VALUES (3179, 0, 3, 15.71, 100, 416);
INSERT INTO public.europe_data VALUES (3180, 4, 853, 3.71, 51, 416);
INSERT INTO public.europe_data VALUES (3181, 718, 39851, 187.42, 200, 416);
INSERT INTO public.europe_data VALUES (3182, 14, 9521, 193.38, 143, 416);
INSERT INTO public.europe_data VALUES (3183, 1250, 151391, 405.24, 201, 416);
INSERT INTO public.europe_data VALUES (3184, 0, 0, 0, 52, 416);
INSERT INTO public.europe_data VALUES (3185, 5556, 481570, 265.49, 101, 416);
INSERT INTO public.europe_data VALUES (3186, 0, 13, 21.99, 102, 416);
INSERT INTO public.europe_data VALUES (3187, 2, 320, 16.09, 103, 416);
INSERT INTO public.europe_data VALUES (3188, 21, 2050, 13.29, 144, 416);
INSERT INTO public.europe_data VALUES (3189, 37, 2929, 22.54, 104, 416);
INSERT INTO public.europe_data VALUES (3190, 0, 34, 0.06, 145, 416);
INSERT INTO public.europe_data VALUES (3191, 0, 0, 0, 214, 416);
INSERT INTO public.europe_data VALUES (3192, 0, 0, 0, 53, 416);
INSERT INTO public.europe_data VALUES (3193, 2, 4, 0.03, 146, 416);
INSERT INTO public.europe_data VALUES (3194, 2, 264, 3.69, 54, 416);
INSERT INTO public.europe_data VALUES (3195, 6, 129, 1.81, 55, 416);
INSERT INTO public.europe_data VALUES (3196, 15, 401, 2.26, 105, 417);
INSERT INTO public.europe_data VALUES (3197, 31, 1656, 97.43, 147, 417);
INSERT INTO public.europe_data VALUES (3198, 55, 1330, 5.26, 1, 417);
INSERT INTO public.europe_data VALUES (3199, 4, 681, 1663.23, 148, 417);
INSERT INTO public.europe_data VALUES (3200, 23, 1216, 6.57, 2, 417);
INSERT INTO public.europe_data VALUES (3201, 0, 0, 0, 56, 417);
INSERT INTO public.europe_data VALUES (3202, 0, 8, 12.36, 57, 417);
INSERT INTO public.europe_data VALUES (3203, 2399, 95474, 426.96, 58, 417);
INSERT INTO public.europe_data VALUES (3204, 61, 8243, 412.41, 149, 417);
INSERT INTO public.europe_data VALUES (3205, 2, 128, 228.58, 59, 417);
INSERT INTO public.europe_data VALUES (3206, 6, 126, 1.01, 202, 417);
INSERT INTO public.europe_data VALUES (3207, 46, 9574, 191.21, 150, 417);
INSERT INTO public.europe_data VALUES (3208, 17, 2982, 42.53, 151, 417);
INSERT INTO public.europe_data VALUES (3209, 15, 625, 332.23, 60, 417);
INSERT INTO public.europe_data VALUES (3210, 27, 2615, 319.29, 106, 417);
INSERT INTO public.europe_data VALUES (3211, 136, 10303, 12.19, 107, 417);
INSERT INTO public.europe_data VALUES (3212, 0, 14, 8.01, 61, 417);
INSERT INTO public.europe_data VALUES (3213, 33, 4164, 78.32, 152, 417);
INSERT INTO public.europe_data VALUES (3214, 236, 72196, 969.19, 153, 417);
INSERT INTO public.europe_data VALUES (3215, 9, 386, 158.06, 62, 417);
INSERT INTO public.europe_data VALUES (3216, 0, 85, 1.18, 3, 417);
INSERT INTO public.europe_data VALUES (3217, 0, 1, 6.4, 63, 417);
INSERT INTO public.europe_data VALUES (3218, 0, 18, 3.8, 108, 417);
INSERT INTO public.europe_data VALUES (3219, 173, 1197, 25.21, 64, 417);
INSERT INTO public.europe_data VALUES (3220, 0, 2, 100.07, 65, 417);
INSERT INTO public.europe_data VALUES (3221, 63, 3475, 186.16, 154, 417);
INSERT INTO public.europe_data VALUES (3222, 2, 722, 89.86, 4, 417);
INSERT INTO public.europe_data VALUES (3223, 3417, 140362, 151.65, 66, 417);
INSERT INTO public.europe_data VALUES (3224, 0, 0, 0, 67, 417);
INSERT INTO public.europe_data VALUES (3225, 0, 1, 0.23, 109, 417);
INSERT INTO public.europe_data VALUES (3226, 94, 5101, 113.09, 155, 417);
INSERT INTO public.europe_data VALUES (3227, 2, 101, 1.05, 5, 417);
INSERT INTO public.europe_data VALUES (3228, 0, 18, 0.25, 6, 417);
INSERT INTO public.europe_data VALUES (3229, 0, 0, 0.02, 110, 417);
INSERT INTO public.europe_data VALUES (3230, 0, 238, 2, 7, 417);
INSERT INTO public.europe_data VALUES (3231, 175, 20031, 85.51, 68, 417);
INSERT INTO public.europe_data VALUES (3232, 11, 680, 253.12, 8, 417);
INSERT INTO public.europe_data VALUES (3233, 0, 12, 30.79, 69, 417);
INSERT INTO public.europe_data VALUES (3234, 0, 1, 0.21, 9, 417);
INSERT INTO public.europe_data VALUES (3235, 1, 75, 1.02, 10, 417);
INSERT INTO public.europe_data VALUES (3236, 317, 10389, 113.87, 70, 417);
INSERT INTO public.europe_data VALUES (3237, 0, 160, 0.02, 111, 417);
INSERT INTO public.europe_data VALUES (3238, 1136, 48256, 207.63, 71, 417);
INSERT INTO public.europe_data VALUES (3239, 0, 7, 1.76, 11, 417);
INSERT INTO public.europe_data VALUES (3240, 2, 38, 1.25, 12, 417);
INSERT INTO public.europe_data VALUES (3241, 107, 8075, 323.56, 72, 417);
INSERT INTO public.europe_data VALUES (3242, 1, 169, 1.71, 13, 417);
INSERT INTO public.europe_data VALUES (3243, 39, 5140, 194.32, 156, 417);
INSERT INTO public.europe_data VALUES (3244, 2, 242, 3.63, 73, 417);
INSERT INTO public.europe_data VALUES (3245, 0, 161, 178.68, 74, 417);
INSERT INTO public.europe_data VALUES (3246, 0, 658, 93.62, 157, 417);
INSERT INTO public.europe_data VALUES (3247, 388, 56775, 858.6, 158, 417);
INSERT INTO public.europe_data VALUES (3248, 27, 201, 0.34, 14, 417);
INSERT INTO public.europe_data VALUES (3249, 11, 2970, 98.38, 159, 417);
INSERT INTO public.europe_data VALUES (3250, 0, 36, 4.11, 15, 417);
INSERT INTO public.europe_data VALUES (3251, 0, 1, 2.79, 75, 417);
INSERT INTO public.europe_data VALUES (3252, 26, 2870, 63.94, 76, 417);
INSERT INTO public.europe_data VALUES (3253, 196, 6256, 70.54, 77, 417);
INSERT INTO public.europe_data VALUES (3254, 80, 1037, 1.73, 16, 417);
INSERT INTO public.europe_data VALUES (3255, 28, 1470, 34.34, 78, 417);
INSERT INTO public.europe_data VALUES (3256, 0, 7, 1.84, 17, 417);
INSERT INTO public.europe_data VALUES (3257, 0, 11, 0.77, 18, 417);
INSERT INTO public.europe_data VALUES (3258, 0, 213, 35.55, 160, 417);
INSERT INTO public.europe_data VALUES (3259, 3, 111, 18.38, 19, 417);
INSERT INTO public.europe_data VALUES (3260, 65, 4842, 9.21, 20, 417);
INSERT INTO public.europe_data VALUES (3261, 0, 0, 0, 79, 417);
INSERT INTO public.europe_data VALUES (3262, 0, 8, 22.6, 161, 417);
INSERT INTO public.europe_data VALUES (3263, 0, 0, 0, 203, 417);
INSERT INTO public.europe_data VALUES (3264, 5, 1426, 52.3, 162, 417);
INSERT INTO public.europe_data VALUES (3265, 747, 162060, 414.64, 163, 417);
INSERT INTO public.europe_data VALUES (3266, 4, 1105, 656.32, 204, 417);
INSERT INTO public.europe_data VALUES (3267, 0, 46, 3.87, 21, 417);
INSERT INTO public.europe_data VALUES (3268, 1, 17, 2.34, 22, 417);
INSERT INTO public.europe_data VALUES (3269, 51, 5683, 234.16, 164, 417);
INSERT INTO public.europe_data VALUES (3270, 168, 40968, 79.11, 165, 417);
INSERT INTO public.europe_data VALUES (3271, 4, 305, 1.58, 23, 417);
INSERT INTO public.europe_data VALUES (3272, 0, 86, 412.39, 166, 417);
INSERT INTO public.europe_data VALUES (3273, 60, 3012, 51.55, 167, 417);
INSERT INTO public.europe_data VALUES (3274, 0, 0, 3.53, 80, 417);
INSERT INTO public.europe_data VALUES (3275, 0, 3, 2.68, 81, 417);
INSERT INTO public.europe_data VALUES (3276, 6, 597, 583.4, 205, 417);
INSERT INTO public.europe_data VALUES (3277, 146, 3645, 42.07, 82, 417);
INSERT INTO public.europe_data VALUES (3278, 0, 0, 1.55, 168, 417);
INSERT INTO public.europe_data VALUES (3279, 1, 496, 5.98, 24, 417);
INSERT INTO public.europe_data VALUES (3280, 1, 4, 1.41, 25, 417);
INSERT INTO public.europe_data VALUES (3281, 6, 265, 81.89, 83, 417);
INSERT INTO public.europe_data VALUES (3282, 1, 43, 0.94, 84, 417);
INSERT INTO public.europe_data VALUES (3283, 0, 14, 1717.79, 169, 417);
INSERT INTO public.europe_data VALUES (3284, 56, 4344, 90.25, 85, 417);
INSERT INTO public.europe_data VALUES (3285, 205, 9191, 166.67, 170, 417);
INSERT INTO public.europe_data VALUES (3286, 1, 529, 317.66, 171, 417);
INSERT INTO public.europe_data VALUES (3287, 5460, 429735, 67.8, 112, 417);
INSERT INTO public.europe_data VALUES (3288, 667, 28418, 21.57, 113, 417);
INSERT INTO public.europe_data VALUES (3289, 1831, 30305, 70.69, 114, 417);
INSERT INTO public.europe_data VALUES (3290, 402, 24304, 120.82, 115, 417);
INSERT INTO public.europe_data VALUES (3291, 26, 7434, 243.26, 172, 417);
INSERT INTO public.europe_data VALUES (3292, 0, 2, 7.09, 173, 417);
INSERT INTO public.europe_data VALUES (3293, 226, 12018, 418.7, 116, 417);
INSERT INTO public.europe_data VALUES (3294, 377, 59291, 147.3, 174, 417);
INSERT INTO public.europe_data VALUES (3295, 32, 556, 46.77, 86, 417);
INSERT INTO public.europe_data VALUES (3296, 45, 3780, 5.82, 117, 417);
INSERT INTO public.europe_data VALUES (3297, 0, 41, 64.01, 175, 417);
INSERT INTO public.europe_data VALUES (3298, 154, 12647, 217.12, 118, 417);
INSERT INTO public.europe_data VALUES (3299, 36, 1733, 19.56, 119, 417);
INSERT INTO public.europe_data VALUES (3300, 66, 3335, 10.37, 26, 417);
INSERT INTO public.europe_data VALUES (3301, 6, 712, 59.88, 176, 417);
INSERT INTO public.europe_data VALUES (3302, 43, 5030, 216.8, 120, 417);
INSERT INTO public.europe_data VALUES (3303, 26, 3296, 76.23, 121, 417);
INSERT INTO public.europe_data VALUES (3304, 0, 0, 0, 122, 417);
INSERT INTO public.europe_data VALUES (3305, 2, 780, 71.04, 177, 417);
INSERT INTO public.europe_data VALUES (3306, 65, 9728, 259.7, 123, 417);
INSERT INTO public.europe_data VALUES (3307, 0, 28, 7.2, 27, 417);
INSERT INTO public.europe_data VALUES (3308, 0, 14, 0.59, 28, 417);
INSERT INTO public.europe_data VALUES (3309, 94, 6078, 176.78, 29, 417);
INSERT INTO public.europe_data VALUES (3310, 0, 86, 255.35, 178, 417);
INSERT INTO public.europe_data VALUES (3311, 10, 1399, 83.6, 179, 417);
INSERT INTO public.europe_data VALUES (3312, 3, 1286, 315.53, 180, 417);
INSERT INTO public.europe_data VALUES (3313, 1, 92, 0.93, 30, 417);
INSERT INTO public.europe_data VALUES (3314, 1, 36, 0.38, 31, 417);
INSERT INTO public.europe_data VALUES (3315, 30, 4841, 25.41, 124, 417);
INSERT INTO public.europe_data VALUES (3316, 2, 316, 128.07, 125, 417);
INSERT INTO public.europe_data VALUES (3317, 0, 93, 0.99, 32, 417);
INSERT INTO public.europe_data VALUES (3318, 2, 894, 285.88, 181, 417);
INSERT INTO public.europe_data VALUES (3319, 0, 53, 1.83, 33, 417);
INSERT INTO public.europe_data VALUES (3320, 0, 12, 2.05, 34, 417);
INSERT INTO public.europe_data VALUES (3321, 2525, 18484, 37.97, 87, 417);
INSERT INTO public.europe_data VALUES (3322, 123, 4899, 258.97, 182, 417);
INSERT INTO public.europe_data VALUES (3323, 0, 31, 129.97, 183, 417);
INSERT INTO public.europe_data VALUES (3324, 0, 6, 0.31, 126, 417);
INSERT INTO public.europe_data VALUES (3325, 34, 1746, 560.61, 184, 417);
INSERT INTO public.europe_data VALUES (3326, 0, 0, 0, 88, 417);
INSERT INTO public.europe_data VALUES (3327, 323, 21228, 110.66, 35, 417);
INSERT INTO public.europe_data VALUES (3328, 4, 865, 5.5, 36, 417);
INSERT INTO public.europe_data VALUES (3329, 234, 8051, 33.73, 127, 417);
INSERT INTO public.europe_data VALUES (3330, 3, 357, 26.74, 37, 417);
INSERT INTO public.europe_data VALUES (3331, 103, 24491, 158.77, 128, 417);
INSERT INTO public.europe_data VALUES (3332, 176, 53784, 535.15, 185, 417);
INSERT INTO public.europe_data VALUES (3333, 0, 0, 0, 208, 417);
INSERT INTO public.europe_data VALUES (3334, 0, 15, 0.65, 209, 417);
INSERT INTO public.europe_data VALUES (3335, 1, 89, 2.8, 89, 417);
INSERT INTO public.europe_data VALUES (3336, 0, 9, 0.04, 38, 417);
INSERT INTO public.europe_data VALUES (3337, 10, 1174, 1.04, 39, 417);
INSERT INTO public.europe_data VALUES (3338, 42, 2691, 241.97, 186, 417);
INSERT INTO public.europe_data VALUES (3339, 0, 9, 22.72, 210, 417);
INSERT INTO public.europe_data VALUES (3340, 3, 915, 37.29, 187, 417);
INSERT INTO public.europe_data VALUES (3341, 63, 4063, 174.53, 129, 417);
INSERT INTO public.europe_data VALUES (3342, 89, 4520, 4.08, 130, 417);
INSERT INTO public.europe_data VALUES (3343, 34, 2983, 122.58, 131, 417);
INSERT INTO public.europe_data VALUES (3344, 73, 4432, 222.75, 90, 417);
INSERT INTO public.europe_data VALUES (3345, 0, 27, 0.47, 211, 417);
INSERT INTO public.europe_data VALUES (3346, 111, 5049, 149.65, 91, 417);
INSERT INTO public.europe_data VALUES (3347, 454, 19304, 124.59, 92, 417);
INSERT INTO public.europe_data VALUES (3348, 331, 17277, 31.56, 132, 417);
INSERT INTO public.europe_data VALUES (3349, 569, 49950, 204.43, 188, 417);
INSERT INTO public.europe_data VALUES (3350, 101, 13247, 210.81, 189, 417);
INSERT INTO public.europe_data VALUES (3351, 36, 3622, 225.61, 93, 417);
INSERT INTO public.europe_data VALUES (3352, 4, 1446, 103.56, 133, 417);
INSERT INTO public.europe_data VALUES (3353, 461, 25105, 238.6, 190, 417);
INSERT INTO public.europe_data VALUES (3354, 1590, 100616, 126.37, 191, 417);
INSERT INTO public.europe_data VALUES (3355, 3, 78, 0.86, 40, 417);
INSERT INTO public.europe_data VALUES (3356, 0, 0, 0, 94, 417);
INSERT INTO public.europe_data VALUES (3357, 0, 4, 3.28, 95, 417);
INSERT INTO public.europe_data VALUES (3358, 0, 3, 2.71, 96, 417);
INSERT INTO public.europe_data VALUES (3359, 0, 7, 78.37, 192, 417);
INSERT INTO public.europe_data VALUES (3360, 0, 4, 9.3, 41, 417);
INSERT INTO public.europe_data VALUES (3361, 142, 2935, 16.97, 134, 417);
INSERT INTO public.europe_data VALUES (3362, 3, 150, 1.99, 42, 417);
INSERT INTO public.europe_data VALUES (3363, 13, 1373, 32.44, 193, 417);
INSERT INTO public.europe_data VALUES (3364, 0, 1, 4.09, 43, 417);
INSERT INTO public.europe_data VALUES (3365, 1, 24, 0.78, 44, 417);
INSERT INTO public.europe_data VALUES (3366, 1, 35, 1.71, 135, 417);
INSERT INTO public.europe_data VALUES (3367, 0, 43, 174.57, 97, 417);
INSERT INTO public.europe_data VALUES (3368, 27, 9984, 306.32, 194, 417);
INSERT INTO public.europe_data VALUES (3369, 19, 4479, 319.38, 195, 417);
INSERT INTO public.europe_data VALUES (3370, 0, 3, 0, 212, 417);
INSERT INTO public.europe_data VALUES (3371, 0, 0, 0.77, 45, 417);
INSERT INTO public.europe_data VALUES (3372, 691, 11322, 38.43, 46, 417);
INSERT INTO public.europe_data VALUES (3373, 11, 572, 2.17, 136, 417);
INSERT INTO public.europe_data VALUES (3374, 0, 65, 1.05, 47, 417);
INSERT INTO public.europe_data VALUES (3375, 868, 85481, 343.09, 196, 417);
INSERT INTO public.europe_data VALUES (3376, 0, 786, 10.02, 137, 417);
INSERT INTO public.europe_data VALUES (3377, 0, 21, 0.09, 48, 417);
INSERT INTO public.europe_data VALUES (3378, 2, 79, 32.51, 98, 417);
INSERT INTO public.europe_data VALUES (3379, 16, 5620, 96.75, 197, 417);
INSERT INTO public.europe_data VALUES (3380, 30, 14192, 235.93, 198, 417);
INSERT INTO public.europe_data VALUES (3381, 27, 404, 4.17, 138, 417);
INSERT INTO public.europe_data VALUES (3382, 0, 13, 0.1, 139, 417);
INSERT INTO public.europe_data VALUES (3383, 1, 271, 5.99, 140, 417);
INSERT INTO public.europe_data VALUES (3384, 0, 50, 0.15, 141, 417);
INSERT INTO public.europe_data VALUES (3385, 0, 1, 0.08, 142, 417);
INSERT INTO public.europe_data VALUES (3386, 2, 117, 2.51, 49, 417);
INSERT INTO public.europe_data VALUES (3387, 6, 196, 38.28, 99, 417);
INSERT INTO public.europe_data VALUES (3388, 170, 9283, 146.13, 50, 417);
INSERT INTO public.europe_data VALUES (3389, 459, 59070, 143.01, 199, 417);
INSERT INTO public.europe_data VALUES (3390, 0, 3, 7.85, 100, 417);
INSERT INTO public.europe_data VALUES (3391, 4, 789, 4.03, 51, 417);
INSERT INTO public.europe_data VALUES (3392, 701, 42604, 175.43, 200, 417);
INSERT INTO public.europe_data VALUES (3393, 18, 9373, 171.96, 143, 417);
INSERT INTO public.europe_data VALUES (3394, 821, 118693, 329.24, 201, 417);
INSERT INTO public.europe_data VALUES (3395, 0, 0, 0, 52, 417);
INSERT INTO public.europe_data VALUES (3396, 4903, 392051, 223.89, 101, 417);
INSERT INTO public.europe_data VALUES (3397, 1, 10, 13.39, 102, 417);
INSERT INTO public.europe_data VALUES (3398, 1, 237, 11.15, 103, 417);
INSERT INTO public.europe_data VALUES (3399, 24, 2332, 13.86, 144, 417);
INSERT INTO public.europe_data VALUES (3400, 39, 3499, 28.76, 104, 417);
INSERT INTO public.europe_data VALUES (3401, 0, 25, 0.04, 145, 417);
INSERT INTO public.europe_data VALUES (3402, 0, 1, 0, 214, 417);
INSERT INTO public.europe_data VALUES (3403, 0, 0, 0, 53, 417);
INSERT INTO public.europe_data VALUES (3404, 1, 4, 0.05, 146, 417);
INSERT INTO public.europe_data VALUES (3405, 10, 395, 4.48, 54, 417);
INSERT INTO public.europe_data VALUES (3406, 1, 136, 1.79, 55, 417);
INSERT INTO public.europe_data VALUES (3407, 15, 458, 1.5, 105, 418);
INSERT INTO public.europe_data VALUES (3408, 24, 1133, 74.76, 147, 418);
INSERT INTO public.europe_data VALUES (3409, 41, 936, 4.66, 1, 418);
INSERT INTO public.europe_data VALUES (3410, 2, 586, 1128.95, 148, 418);
INSERT INTO public.europe_data VALUES (3411, 25, 876, 4.95, 2, 418);
INSERT INTO public.europe_data VALUES (3412, 0, 0, 0, 56, 418);
INSERT INTO public.europe_data VALUES (3413, 0, 4, 10.3, 57, 418);
INSERT INTO public.europe_data VALUES (3414, 2850, 95720, 408.39, 58, 418);
INSERT INTO public.europe_data VALUES (3415, 43, 3955, 238.39, 149, 418);
INSERT INTO public.europe_data VALUES (3416, 2, 115, 329.23, 59, 418);
INSERT INTO public.europe_data VALUES (3417, 4, 128, 0.89, 202, 418);
INSERT INTO public.europe_data VALUES (3418, 51, 7365, 141.29, 150, 418);
INSERT INTO public.europe_data VALUES (3419, 13, 1291, 19.5, 151, 418);
INSERT INTO public.europe_data VALUES (3420, 11, 669, 330.69, 60, 418);
INSERT INTO public.europe_data VALUES (3421, 13, 2625, 396.79, 106, 418);
INSERT INTO public.europe_data VALUES (3422, 176, 9576, 11.73, 107, 418);
INSERT INTO public.europe_data VALUES (3423, 0, 9, 6.27, 61, 418);
INSERT INTO public.europe_data VALUES (3424, 39, 3239, 62.68, 152, 418);
INSERT INTO public.europe_data VALUES (3425, 139, 38830, 503.81, 153, 418);
INSERT INTO public.europe_data VALUES (3426, 5, 231, 146.79, 62, 418);
INSERT INTO public.europe_data VALUES (3427, 0, 54, 0.6, 3, 418);
INSERT INTO public.europe_data VALUES (3428, 0, 3, 4.8, 63, 418);
INSERT INTO public.europe_data VALUES (3429, 0, 11, 4.72, 108, 418);
INSERT INTO public.europe_data VALUES (3430, 207, 1706, 40.59, 64, 418);
INSERT INTO public.europe_data VALUES (3431, 1, 24, 242.47, 65, 418);
INSERT INTO public.europe_data VALUES (3432, 50, 2670, 112.94, 154, 418);
INSERT INTO public.europe_data VALUES (3433, 2, 1348, 69.41, 4, 418);
INSERT INTO public.europe_data VALUES (3434, 4136, 179693, 171.84, 66, 418);
INSERT INTO public.europe_data VALUES (3435, 0, 0, 0, 67, 418);
INSERT INTO public.europe_data VALUES (3436, 0, 0, 0, 109, 418);
INSERT INTO public.europe_data VALUES (3437, 48, 2815, 62.1, 155, 418);
INSERT INTO public.europe_data VALUES (3438, 4, 113, 1.34, 5, 418);
INSERT INTO public.europe_data VALUES (3439, 0, 11, 0.34, 6, 418);
INSERT INTO public.europe_data VALUES (3440, 0, 3, 0.04, 110, 418);
INSERT INTO public.europe_data VALUES (3441, 3, 279, 1.81, 7, 418);
INSERT INTO public.europe_data VALUES (3442, 104, 11961, 66.8, 68, 418);
INSERT INTO public.europe_data VALUES (3443, 10, 712, 236.57, 8, 418);
INSERT INTO public.europe_data VALUES (3444, 0, 8, 16.94, 69, 418);
INSERT INTO public.europe_data VALUES (3445, 0, 9, 1.01, 9, 418);
INSERT INTO public.europe_data VALUES (3446, 6, 87, 0.79, 10, 418);
INSERT INTO public.europe_data VALUES (3447, 339, 11192, 123.84, 70, 418);
INSERT INTO public.europe_data VALUES (3448, 0, 183, 0.02, 111, 418);
INSERT INTO public.europe_data VALUES (3449, 1122, 56264, 195.19, 71, 418);
INSERT INTO public.europe_data VALUES (3450, 0, 8, 2, 11, 418);
INSERT INTO public.europe_data VALUES (3451, 1, 29, 2.04, 12, 418);
INSERT INTO public.europe_data VALUES (3452, 126, 8257, 304.9, 72, 418);
INSERT INTO public.europe_data VALUES (3453, 0, 272, 2.04, 13, 418);
INSERT INTO public.europe_data VALUES (3454, 26, 2781, 104.09, 156, 418);
INSERT INTO public.europe_data VALUES (3455, 1, 169, 4.6, 73, 418);
INSERT INTO public.europe_data VALUES (3456, 0, 131, 136.46, 74, 418);
INSERT INTO public.europe_data VALUES (3457, 3, 162, 33.11, 157, 418);
INSERT INTO public.europe_data VALUES (3458, 307, 34664, 493.09, 158, 418);
INSERT INTO public.europe_data VALUES (3459, 2, 91, 0.28, 14, 418);
INSERT INTO public.europe_data VALUES (3460, 11, 2742, 99.64, 159, 418);
INSERT INTO public.europe_data VALUES (3461, 0, 4, 1.44, 15, 418);
INSERT INTO public.europe_data VALUES (3462, 0, 1, 11.14, 75, 418);
INSERT INTO public.europe_data VALUES (3463, 39, 3997, 66.03, 76, 418);
INSERT INTO public.europe_data VALUES (3464, 544, 5999, 70.72, 77, 418);
INSERT INTO public.europe_data VALUES (3465, 59, 704, 1.54, 16, 418);
INSERT INTO public.europe_data VALUES (3466, 31, 746, 24.27, 78, 418);
INSERT INTO public.europe_data VALUES (3467, 0, 18, 2.58, 17, 418);
INSERT INTO public.europe_data VALUES (3468, 0, 16, 1.12, 18, 418);
INSERT INTO public.europe_data VALUES (3469, 1, 258, 50.2, 160, 418);
INSERT INTO public.europe_data VALUES (3470, 2, 100, 20.73, 19, 418);
INSERT INTO public.europe_data VALUES (3471, 65, 5476, 9.78, 20, 418);
INSERT INTO public.europe_data VALUES (3472, 0, 0, 0, 79, 418);
INSERT INTO public.europe_data VALUES (3473, 0, 3, 34.92, 161, 418);
INSERT INTO public.europe_data VALUES (3474, 0, 0, 0, 203, 418);
INSERT INTO public.europe_data VALUES (3475, 1, 1460, 41.97, 162, 418);
INSERT INTO public.europe_data VALUES (3476, 500, 115804, 293.09, 163, 418);
INSERT INTO public.europe_data VALUES (3477, 2, 728, 486.96, 204, 418);
INSERT INTO public.europe_data VALUES (3478, 0, 38, 4.93, 21, 418);
INSERT INTO public.europe_data VALUES (3479, 2, 38, 2.68, 22, 418);
INSERT INTO public.europe_data VALUES (3480, 35, 3676, 156.18, 164, 418);
INSERT INTO public.europe_data VALUES (3481, 87, 24712, 48.18, 165, 418);
INSERT INTO public.europe_data VALUES (3482, 3, 176, 2.03, 23, 418);
INSERT INTO public.europe_data VALUES (3483, 0, 53, 314.48, 166, 418);
INSERT INTO public.europe_data VALUES (3484, 40, 2516, 45.82, 167, 418);
INSERT INTO public.europe_data VALUES (3485, 0, 2, 3.53, 80, 418);
INSERT INTO public.europe_data VALUES (3486, 0, 0, 0, 81, 418);
INSERT INTO public.europe_data VALUES (3487, 8, 379, 432.77, 205, 418);
INSERT INTO public.europe_data VALUES (3488, 91, 3752, 43.36, 82, 418);
INSERT INTO public.europe_data VALUES (3489, 0, 1, 3.1, 168, 418);
INSERT INTO public.europe_data VALUES (3490, 3, 268, 3.46, 24, 418);
INSERT INTO public.europe_data VALUES (3491, 1, 23, 3.18, 25, 418);
INSERT INTO public.europe_data VALUES (3492, 16, 376, 89.04, 83, 418);
INSERT INTO public.europe_data VALUES (3493, 1, 63, 1.41, 84, 418);
INSERT INTO public.europe_data VALUES (3494, 0, 0, 0, 169, 418);
INSERT INTO public.europe_data VALUES (3495, 90, 4452, 92.06, 85, 418);
INSERT INTO public.europe_data VALUES (3496, 135, 7097, 141.83, 170, 418);
INSERT INTO public.europe_data VALUES (3497, 0, 605, 252.95, 171, 418);
INSERT INTO public.europe_data VALUES (3498, 6465, 496723, 76.54, 112, 418);
INSERT INTO public.europe_data VALUES (3499, 693, 29951, 21.52, 113, 418);
INSERT INTO public.europe_data VALUES (3500, 1587, 28303, 64.68, 114, 418);
INSERT INTO public.europe_data VALUES (3501, 453, 23189, 134.52, 115, 418);
INSERT INTO public.europe_data VALUES (3502, 16, 4496, 153.7, 172, 418);
INSERT INTO public.europe_data VALUES (3503, 0, 4, 7.09, 173, 418);
INSERT INTO public.europe_data VALUES (3504, 264, 23653, 713.69, 116, 418);
INSERT INTO public.europe_data VALUES (3505, 180, 29621, 74.69, 174, 418);
INSERT INTO public.europe_data VALUES (3506, 19, 823, 58.51, 86, 418);
INSERT INTO public.europe_data VALUES (3507, 30, 3608, 5.69, 117, 418);
INSERT INTO public.europe_data VALUES (3508, 0, 28, 45.46, 175, 418);
INSERT INTO public.europe_data VALUES (3509, 90, 9286, 162.69, 118, 418);
INSERT INTO public.europe_data VALUES (3510, 29, 1896, 18.73, 119, 418);
INSERT INTO public.europe_data VALUES (3511, 35, 2119, 6.53, 26, 418);
INSERT INTO public.europe_data VALUES (3512, 17, 365, 39.31, 176, 418);
INSERT INTO public.europe_data VALUES (3513, 34, 4091, 179.98, 120, 418);
INSERT INTO public.europe_data VALUES (3514, 19, 1595, 44.81, 121, 418);
INSERT INTO public.europe_data VALUES (3515, 0, 0, 0, 122, 418);
INSERT INTO public.europe_data VALUES (3516, 2, 584, 51.77, 177, 418);
INSERT INTO public.europe_data VALUES (3517, 49, 8076, 237.82, 123, 418);
INSERT INTO public.europe_data VALUES (3518, 3, 125, 11.62, 27, 418);
INSERT INTO public.europe_data VALUES (3519, 0, 15, 0.49, 28, 418);
INSERT INTO public.europe_data VALUES (3520, 39, 5903, 152.68, 29, 418);
INSERT INTO public.europe_data VALUES (3521, 0, 12, 54.72, 178, 418);
INSERT INTO public.europe_data VALUES (3522, 9, 937, 62.16, 179, 418);
INSERT INTO public.europe_data VALUES (3523, 5, 651, 163.38, 180, 418);
INSERT INTO public.europe_data VALUES (3524, 5, 160, 1.61, 30, 418);
INSERT INTO public.europe_data VALUES (3525, 1, 35, 0.28, 31, 418);
INSERT INTO public.europe_data VALUES (3526, 20, 3276, 14.83, 124, 418);
INSERT INTO public.europe_data VALUES (3527, 1, 364, 149.92, 125, 418);
INSERT INTO public.europe_data VALUES (3528, 1, 102, 1.02, 32, 418);
INSERT INTO public.europe_data VALUES (3529, 4, 517, 167.76, 181, 418);
INSERT INTO public.europe_data VALUES (3530, 2, 30, 1.94, 33, 418);
INSERT INTO public.europe_data VALUES (3531, 0, 14, 2.21, 34, 418);
INSERT INTO public.europe_data VALUES (3532, 4554, 29957, 47.31, 87, 418);
INSERT INTO public.europe_data VALUES (3533, 95, 5572, 278.88, 182, 418);
INSERT INTO public.europe_data VALUES (3534, 0, 12, 72.54, 183, 418);
INSERT INTO public.europe_data VALUES (3535, 0, 4, 0.16, 126, 418);
INSERT INTO public.europe_data VALUES (3536, 23, 1742, 571.54, 184, 418);
INSERT INTO public.europe_data VALUES (3537, 0, 0, 0, 88, 418);
INSERT INTO public.europe_data VALUES (3538, 275, 19132, 95.19, 35, 418);
INSERT INTO public.europe_data VALUES (3539, 5, 805, 6.65, 36, 418);
INSERT INTO public.europe_data VALUES (3540, 234, 10180, 31.9, 127, 418);
INSERT INTO public.europe_data VALUES (3541, 5, 310, 36.2, 37, 418);
INSERT INTO public.europe_data VALUES (3542, 101, 20932, 120.11, 128, 418);
INSERT INTO public.europe_data VALUES (3543, 130, 38701, 364.19, 185, 418);
INSERT INTO public.europe_data VALUES (3544, 0, 0, 0, 208, 418);
INSERT INTO public.europe_data VALUES (3545, 0, 16, 0.79, 209, 418);
INSERT INTO public.europe_data VALUES (3546, 2, 94, 2.92, 89, 418);
INSERT INTO public.europe_data VALUES (3547, 0, 1, 0.02, 38, 418);
INSERT INTO public.europe_data VALUES (3548, 2, 921, 0.97, 39, 418);
INSERT INTO public.europe_data VALUES (3549, 39, 2335, 159.26, 186, 418);
INSERT INTO public.europe_data VALUES (3550, 0, 4, 12.23, 210, 418);
INSERT INTO public.europe_data VALUES (3551, 0, 1072, 34.06, 187, 418);
INSERT INTO public.europe_data VALUES (3552, 61, 4620, 169.65, 129, 418);
INSERT INTO public.europe_data VALUES (3553, 57, 4316, 3.74, 130, 418);
INSERT INTO public.europe_data VALUES (3554, 54, 3123, 127.73, 131, 418);
INSERT INTO public.europe_data VALUES (3555, 68, 5027, 229.79, 90, 418);
INSERT INTO public.europe_data VALUES (3556, 0, 14, 0.25, 211, 418);
INSERT INTO public.europe_data VALUES (3557, 148, 5493, 156.02, 91, 418);
INSERT INTO public.europe_data VALUES (3558, 563, 21202, 135.55, 92, 418);
INSERT INTO public.europe_data VALUES (3559, 545, 16844, 32.48, 132, 418);
INSERT INTO public.europe_data VALUES (3560, 400, 27676, 101.35, 188, 418);
INSERT INTO public.europe_data VALUES (3561, 85, 8417, 127.08, 189, 418);
INSERT INTO public.europe_data VALUES (3562, 44, 2996, 251.14, 93, 418);
INSERT INTO public.europe_data VALUES (3563, 4, 1487, 102.43, 133, 418);
INSERT INTO public.europe_data VALUES (3564, 464, 21218, 167.97, 190, 418);
INSERT INTO public.europe_data VALUES (3565, 1239, 83717, 100.97, 191, 418);
INSERT INTO public.europe_data VALUES (3566, 2, 30, 0.6, 40, 418);
INSERT INTO public.europe_data VALUES (3567, 0, 0, 0, 94, 418);
INSERT INTO public.europe_data VALUES (3568, 0, 2, 1.09, 95, 418);
INSERT INTO public.europe_data VALUES (3569, 0, 0, 0, 96, 418);
INSERT INTO public.europe_data VALUES (3570, 0, 20, 72.56, 192, 418);
INSERT INTO public.europe_data VALUES (3571, 0, 16, 8.37, 41, 418);
INSERT INTO public.europe_data VALUES (3572, 168, 2880, 17.72, 134, 418);
INSERT INTO public.europe_data VALUES (3573, 2, 174, 2.2, 42, 418);
INSERT INTO public.europe_data VALUES (3574, 9, 886, 20.15, 193, 418);
INSERT INTO public.europe_data VALUES (3575, 0, 3, 5.12, 43, 418);
INSERT INTO public.europe_data VALUES (3576, 0, 37, 1.16, 44, 418);
INSERT INTO public.europe_data VALUES (3577, 0, 64, 3.03, 135, 418);
INSERT INTO public.europe_data VALUES (3578, 0, 31, 155.7, 97, 418);
INSERT INTO public.europe_data VALUES (3579, 6, 6712, 197.65, 194, 418);
INSERT INTO public.europe_data VALUES (3580, 2, 2167, 159.31, 195, 418);
INSERT INTO public.europe_data VALUES (3581, 0, 119, 1.79, 45, 418);
INSERT INTO public.europe_data VALUES (3582, 804, 11182, 37.07, 46, 418);
INSERT INTO public.europe_data VALUES (3583, 11, 539, 2.03, 136, 418);
INSERT INTO public.europe_data VALUES (3584, 5, 51, 0.82, 47, 418);
INSERT INTO public.europe_data VALUES (3585, 899, 75556, 299.77, 196, 418);
INSERT INTO public.europe_data VALUES (3586, 0, 1350, 6.53, 137, 418);
INSERT INTO public.europe_data VALUES (3587, 0, 17, 0.15, 48, 418);
INSERT INTO public.europe_data VALUES (3588, 1, 110, 37.15, 98, 418);
INSERT INTO public.europe_data VALUES (3589, 22, 4278, 77.42, 197, 418);
INSERT INTO public.europe_data VALUES (3590, 10, 5967, 97.91, 198, 418);
INSERT INTO public.europe_data VALUES (3591, 16, 307, 3.52, 138, 418);
INSERT INTO public.europe_data VALUES (3592, 0, 10, 0.07, 139, 418);
INSERT INTO public.europe_data VALUES (3593, 1, 287, 6.18, 140, 418);
INSERT INTO public.europe_data VALUES (3594, 0, 51, 0.14, 141, 418);
INSERT INTO public.europe_data VALUES (3595, 0, 0, 0.08, 142, 418);
INSERT INTO public.europe_data VALUES (3596, 1, 86, 2.44, 49, 418);
INSERT INTO public.europe_data VALUES (3597, 9, 338, 52.98, 99, 418);
INSERT INTO public.europe_data VALUES (3598, 135, 7806, 129.5, 50, 418);
INSERT INTO public.europe_data VALUES (3599, 396, 58200, 140.63, 199, 418);
INSERT INTO public.europe_data VALUES (3600, 0, 0, 34.04, 100, 418);
INSERT INTO public.europe_data VALUES (3601, 12, 993, 5.13, 51, 418);
INSERT INTO public.europe_data VALUES (3602, 575, 34572, 141.84, 200, 418);
INSERT INTO public.europe_data VALUES (3603, 19, 7428, 151.07, 143, 418);
INSERT INTO public.europe_data VALUES (3604, 475, 100738, 253.19, 201, 418);
INSERT INTO public.europe_data VALUES (3605, 0, 0, 0, 52, 418);
INSERT INTO public.europe_data VALUES (3606, 4977, 344699, 196.77, 101, 418);
INSERT INTO public.europe_data VALUES (3607, 0, 4, 7.65, 102, 418);
INSERT INTO public.europe_data VALUES (3608, 2, 149, 8.26, 103, 418);
INSERT INTO public.europe_data VALUES (3609, 22, 2239, 16.69, 144, 418);
INSERT INTO public.europe_data VALUES (3610, 44, 4703, 36.63, 104, 418);
INSERT INTO public.europe_data VALUES (3611, 0, 13, 0.04, 145, 418);
INSERT INTO public.europe_data VALUES (3612, 0, 0, 0, 53, 418);
INSERT INTO public.europe_data VALUES (3613, 5, 10, 0.07, 146, 418);
INSERT INTO public.europe_data VALUES (3614, 3, 406, 4.57, 54, 418);
INSERT INTO public.europe_data VALUES (3615, 2, 126, 1.36, 55, 418);
INSERT INTO public.europe_data VALUES (3616, 9, 114, 0.78, 105, 419);
INSERT INTO public.europe_data VALUES (3617, 19, 1007, 65.71, 147, 419);
INSERT INTO public.europe_data VALUES (3618, 46, 1069, 5.37, 1, 419);
INSERT INTO public.europe_data VALUES (3619, 0, 274, 716.75, 148, 419);
INSERT INTO public.europe_data VALUES (3620, 22, 698, 4.33, 2, 419);
INSERT INTO public.europe_data VALUES (3621, 0, 0, 0, 56, 419);
INSERT INTO public.europe_data VALUES (3622, 0, 6, 11.33, 57, 419);
INSERT INTO public.europe_data VALUES (3623, 26, 3096, 171.25, 149, 419);
INSERT INTO public.europe_data VALUES (3624, 5269, 87161, 392.03, 58, 419);
INSERT INTO public.europe_data VALUES (3625, 5, 235, 496.66, 59, 419);
INSERT INTO public.europe_data VALUES (3626, 22, 96, 0.94, 202, 419);
INSERT INTO public.europe_data VALUES (3627, 26, 5152, 113.57, 150, 419);
INSERT INTO public.europe_data VALUES (3628, 10, 668, 14.96, 151, 419);
INSERT INTO public.europe_data VALUES (3629, 9, 619, 266.76, 60, 419);
INSERT INTO public.europe_data VALUES (3630, 18, 3887, 497.39, 106, 419);
INSERT INTO public.europe_data VALUES (3631, 187, 9542, 12.13, 107, 419);
INSERT INTO public.europe_data VALUES (3632, 0, 9, 3.48, 61, 419);
INSERT INTO public.europe_data VALUES (3633, 39, 2686, 48.89, 152, 419);
INSERT INTO public.europe_data VALUES (3634, 84, 18884, 263.26, 153, 419);
INSERT INTO public.europe_data VALUES (3635, 6, 342, 145.77, 62, 419);
INSERT INTO public.europe_data VALUES (3636, 1, 17, 0.65, 3, 419);
INSERT INTO public.europe_data VALUES (3637, 0, 0, 1.6, 63, 419);
INSERT INTO public.europe_data VALUES (3638, 0, 25, 4.85, 108, 419);
INSERT INTO public.europe_data VALUES (3639, 243, 2967, 53.78, 64, 419);
INSERT INTO public.europe_data VALUES (3640, 0, 39, 338.68, 65, 419);
INSERT INTO public.europe_data VALUES (3641, 61, 1058, 77.28, 154, 419);
INSERT INTO public.europe_data VALUES (3642, 0, 251, 26.26, 4, 419);
INSERT INTO public.europe_data VALUES (3643, 4611, 182980, 175.63, 66, 419);
INSERT INTO public.europe_data VALUES (3644, 0, 0, 0, 67, 419);
INSERT INTO public.europe_data VALUES (3645, 0, 0, 0.23, 109, 419);
INSERT INTO public.europe_data VALUES (3646, 48, 1532, 38.91, 155, 419);
INSERT INTO public.europe_data VALUES (3647, 3, 159, 1.58, 5, 419);
INSERT INTO public.europe_data VALUES (3648, 0, 28, 0.35, 6, 419);
INSERT INTO public.europe_data VALUES (3649, 0, 4, 0.03, 110, 419);
INSERT INTO public.europe_data VALUES (3650, 2, 189, 1.91, 7, 419);
INSERT INTO public.europe_data VALUES (3651, 213, 13031, 60.16, 68, 419);
INSERT INTO public.europe_data VALUES (3652, 8, 589, 200.57, 8, 419);
INSERT INTO public.europe_data VALUES (3653, 0, 3, 6.16, 69, 419);
INSERT INTO public.europe_data VALUES (3654, 0, 39, 1.1, 9, 419);
INSERT INTO public.europe_data VALUES (3655, 2, 39, 0.41, 10, 419);
INSERT INTO public.europe_data VALUES (3656, 338, 12278, 126.13, 70, 419);
INSERT INTO public.europe_data VALUES (3657, 0, 146, 0.02, 111, 419);
INSERT INTO public.europe_data VALUES (3658, 1224, 41996, 178.74, 71, 419);
INSERT INTO public.europe_data VALUES (3659, 0, 9, 2, 11, 419);
INSERT INTO public.europe_data VALUES (3660, 0, 81, 1.91, 12, 419);
INSERT INTO public.europe_data VALUES (3661, 122, 7133, 306.48, 72, 419);
INSERT INTO public.europe_data VALUES (3662, 0, 253, 2.19, 13, 419);
INSERT INTO public.europe_data VALUES (3663, 26, 1462, 67.15, 156, 419);
INSERT INTO public.europe_data VALUES (3664, 0, 352, 6.34, 73, 419);
INSERT INTO public.europe_data VALUES (3665, 0, 92, 112.59, 74, 419);
INSERT INTO public.europe_data VALUES (3666, 0, 128, 25.57, 157, 419);
INSERT INTO public.europe_data VALUES (3667, 121, 17849, 311.8, 158, 419);
INSERT INTO public.europe_data VALUES (3668, 3, 148, 0.28, 14, 419);
INSERT INTO public.europe_data VALUES (3669, 9, 3043, 134.91, 159, 419);
INSERT INTO public.europe_data VALUES (3670, 0, 10, 1.64, 15, 419);
INSERT INTO public.europe_data VALUES (3671, 0, 7, 9.75, 75, 419);
INSERT INTO public.europe_data VALUES (3672, 39, 3094, 57.65, 76, 419);
INSERT INTO public.europe_data VALUES (3673, 368, 6287, 84.12, 77, 419);
INSERT INTO public.europe_data VALUES (3674, 98, 843, 1.66, 16, 419);
INSERT INTO public.europe_data VALUES (3675, 37, 820, 29.39, 78, 419);
INSERT INTO public.europe_data VALUES (3676, 0, 17, 3.17, 17, 419);
INSERT INTO public.europe_data VALUES (3677, 0, 23, 0.97, 18, 419);
INSERT INTO public.europe_data VALUES (3678, 3, 407, 51.55, 160, 419);
INSERT INTO public.europe_data VALUES (3679, 3, 138, 26.13, 19, 419);
INSERT INTO public.europe_data VALUES (3680, 52, 5487, 8.92, 20, 419);
INSERT INTO public.europe_data VALUES (3681, 0, 0, 0, 79, 419);
INSERT INTO public.europe_data VALUES (3682, 0, 14, 82.17, 161, 419);
INSERT INTO public.europe_data VALUES (3683, 0, 0, 0, 203, 419);
INSERT INTO public.europe_data VALUES (3684, 2, 856, 28.24, 162, 419);
INSERT INTO public.europe_data VALUES (3685, 503, 80601, 246.83, 163, 419);
INSERT INTO public.europe_data VALUES (3686, 3, 632, 231.3, 204, 419);
INSERT INTO public.europe_data VALUES (3687, 0, 69, 4.65, 21, 419);
INSERT INTO public.europe_data VALUES (3688, 4, 25, 2.9, 22, 419);
INSERT INTO public.europe_data VALUES (3689, 22, 2566, 110.66, 164, 419);
INSERT INTO public.europe_data VALUES (3690, 74, 15287, 34.07, 165, 419);
INSERT INTO public.europe_data VALUES (3691, 4, 442, 2.71, 23, 419);
INSERT INTO public.europe_data VALUES (3692, 0, 53, 243.28, 166, 419);
INSERT INTO public.europe_data VALUES (3693, 30, 2398, 43.82, 167, 419);
INSERT INTO public.europe_data VALUES (3694, 0, 0, 0, 80, 419);
INSERT INTO public.europe_data VALUES (3695, 0, 0, 0, 81, 419);
INSERT INTO public.europe_data VALUES (3696, 10, 345, 347.89, 205, 419);
INSERT INTO public.europe_data VALUES (3697, 64, 3871, 48.45, 82, 419);
INSERT INTO public.europe_data VALUES (3698, 0, 1, 3.1, 168, 419);
INSERT INTO public.europe_data VALUES (3699, 0, 174, 3.36, 24, 419);
INSERT INTO public.europe_data VALUES (3700, 0, 38, 3.07, 25, 419);
INSERT INTO public.europe_data VALUES (3701, 11, 321, 105.27, 83, 419);
INSERT INTO public.europe_data VALUES (3702, 2, 96, 1.78, 84, 419);
INSERT INTO public.europe_data VALUES (3703, 0, 0, 0, 169, 419);
INSERT INTO public.europe_data VALUES (3704, 133, 4520, 82.22, 85, 419);
INSERT INTO public.europe_data VALUES (3705, 84, 6764, 129.07, 170, 419);
INSERT INTO public.europe_data VALUES (3706, 0, 298, 161.07, 171, 419);
INSERT INTO public.europe_data VALUES (3707, 7143, 549113, 83.15, 112, 419);
INSERT INTO public.europe_data VALUES (3708, 765, 28285, 21.74, 113, 419);
INSERT INTO public.europe_data VALUES (3709, 1368, 25324, 59.86, 114, 419);
INSERT INTO public.europe_data VALUES (3710, 409, 29691, 152.9, 115, 419);
INSERT INTO public.europe_data VALUES (3711, 8, 3042, 103.97, 172, 419);
INSERT INTO public.europe_data VALUES (3712, 0, 2, 3.55, 173, 419);
INSERT INTO public.europe_data VALUES (3713, 253, 37149, 936.08, 116, 419);
INSERT INTO public.europe_data VALUES (3714, 151, 15459, 45.02, 174, 419);
INSERT INTO public.europe_data VALUES (3715, 31, 902, 64.68, 86, 419);
INSERT INTO public.europe_data VALUES (3716, 51, 3608, 5.58, 117, 419);
INSERT INTO public.europe_data VALUES (3717, 0, 21, 25.97, 175, 419);
INSERT INTO public.europe_data VALUES (3718, 56, 7148, 107.52, 118, 419);
INSERT INTO public.europe_data VALUES (3719, 36, 1579, 18.27, 119, 419);
INSERT INTO public.europe_data VALUES (3720, 40, 1312, 4.65, 26, 419);
INSERT INTO public.europe_data VALUES (3721, 8, 342, 41.76, 176, 419);
INSERT INTO public.europe_data VALUES (3722, 23, 3481, 180.43, 120, 419);
INSERT INTO public.europe_data VALUES (3723, 2, 1280, 33.73, 121, 419);
INSERT INTO public.europe_data VALUES (3724, 0, 0, 0, 122, 419);
INSERT INTO public.europe_data VALUES (3725, 2, 410, 29.22, 177, 419);
INSERT INTO public.europe_data VALUES (3726, 59, 8228, 221.41, 123, 419);
INSERT INTO public.europe_data VALUES (3727, 4, 122, 12.05, 27, 419);
INSERT INTO public.europe_data VALUES (3728, 0, 9, 0.26, 28, 419);
INSERT INTO public.europe_data VALUES (3729, 72, 4445, 130.73, 29, 419);
INSERT INTO public.europe_data VALUES (3730, 0, 9, 36.48, 178, 419);
INSERT INTO public.europe_data VALUES (3731, 3, 800, 51.57, 179, 419);
INSERT INTO public.europe_data VALUES (3732, 1, 352, 147.42, 180, 419);
INSERT INTO public.europe_data VALUES (3733, 3, 273, 1.87, 30, 419);
INSERT INTO public.europe_data VALUES (3734, 0, 18, 0.3, 31, 419);
INSERT INTO public.europe_data VALUES (3735, 3, 1462, 6.77, 124, 419);
INSERT INTO public.europe_data VALUES (3736, 0, 432, 151.8, 125, 419);
INSERT INTO public.europe_data VALUES (3737, 1, 98, 0.87, 32, 419);
INSERT INTO public.europe_data VALUES (3738, 7, 311, 109.61, 181, 419);
INSERT INTO public.europe_data VALUES (3739, 0, 58, 3.36, 33, 419);
INSERT INTO public.europe_data VALUES (3740, 0, 14, 1.1, 34, 419);
INSERT INTO public.europe_data VALUES (3741, 2658, 30405, 48.87, 87, 419);
INSERT INTO public.europe_data VALUES (3742, 79, 5704, 246.9, 182, 419);
INSERT INTO public.europe_data VALUES (3743, 0, 12, 87.65, 183, 419);
INSERT INTO public.europe_data VALUES (3744, 0, 1, 0.06, 126, 419);
INSERT INTO public.europe_data VALUES (3745, 21, 1814, 564.95, 184, 419);
INSERT INTO public.europe_data VALUES (3746, 0, 0, 0, 88, 419);
INSERT INTO public.europe_data VALUES (3747, 261, 15587, 86.45, 35, 419);
INSERT INTO public.europe_data VALUES (3748, 8, 1213, 7.99, 36, 419);
INSERT INTO public.europe_data VALUES (3749, 186, 7060, 22.18, 127, 419);
INSERT INTO public.europe_data VALUES (3750, 4, 593, 50.07, 37, 419);
INSERT INTO public.europe_data VALUES (3751, 58, 13429, 79.35, 128, 419);
INSERT INTO public.europe_data VALUES (3752, 80, 24239, 243.4, 185, 419);
INSERT INTO public.europe_data VALUES (3753, 0, 0, 0.35, 208, 419);
INSERT INTO public.europe_data VALUES (3754, 0, 22, 0.73, 209, 419);
INSERT INTO public.europe_data VALUES (3755, 2, 97, 3.19, 89, 419);
INSERT INTO public.europe_data VALUES (3756, 0, 4, 0.05, 38, 419);
INSERT INTO public.europe_data VALUES (3757, 5, 1021, 1.05, 39, 419);
INSERT INTO public.europe_data VALUES (3758, 28, 973, 89.88, 186, 419);
INSERT INTO public.europe_data VALUES (3759, 0, 3, 6.99, 210, 419);
INSERT INTO public.europe_data VALUES (3760, 5, 743, 28.23, 187, 419);
INSERT INTO public.europe_data VALUES (3761, 68, 3820, 156.68, 129, 419);
INSERT INTO public.europe_data VALUES (3762, 47, 3775, 3.84, 130, 419);
INSERT INTO public.europe_data VALUES (3763, 48, 3240, 140.26, 131, 419);
INSERT INTO public.europe_data VALUES (3764, 83, 4731, 213.9, 90, 419);
INSERT INTO public.europe_data VALUES (3765, 0, 8, 0.26, 211, 419);
INSERT INTO public.europe_data VALUES (3766, 126, 5498, 151.35, 91, 419);
INSERT INTO public.europe_data VALUES (3767, 480, 22867, 182.32, 92, 419);
INSERT INTO public.europe_data VALUES (3768, 432, 18271, 33.07, 132, 419);
INSERT INTO public.europe_data VALUES (3769, 172, 10810, 49.77, 188, 419);
INSERT INTO public.europe_data VALUES (3770, 42, 4643, 94.1, 189, 419);
INSERT INTO public.europe_data VALUES (3771, 42, 4371, 301.25, 93, 419);
INSERT INTO public.europe_data VALUES (3772, 2, 1414, 110.24, 133, 419);
INSERT INTO public.europe_data VALUES (3773, 229, 11392, 109.63, 190, 419);
INSERT INTO public.europe_data VALUES (3774, 1034, 63563, 76.51, 191, 419);
INSERT INTO public.europe_data VALUES (3775, 0, 46, 1.23, 40, 419);
INSERT INTO public.europe_data VALUES (3776, 0, 0, 3.79, 94, 419);
INSERT INTO public.europe_data VALUES (3777, 0, 0, 0, 95, 419);
INSERT INTO public.europe_data VALUES (3778, 0, 0, 0, 96, 419);
INSERT INTO public.europe_data VALUES (3779, 0, 5, 26.12, 192, 419);
INSERT INTO public.europe_data VALUES (3780, 0, 2, 2.33, 41, 419);
INSERT INTO public.europe_data VALUES (3781, 192, 3194, 19.36, 134, 419);
INSERT INTO public.europe_data VALUES (3782, 4, 185, 2.33, 42, 419);
INSERT INTO public.europe_data VALUES (3783, 7, 517, 14.26, 193, 419);
INSERT INTO public.europe_data VALUES (3784, 0, 2, 4.09, 43, 419);
INSERT INTO public.europe_data VALUES (3785, 0, 54, 1.29, 44, 419);
INSERT INTO public.europe_data VALUES (3786, 0, 112, 4.07, 135, 419);
INSERT INTO public.europe_data VALUES (3787, 0, 35, 224.11, 97, 419);
INSERT INTO public.europe_data VALUES (3788, 11, 4061, 118.56, 194, 419);
INSERT INTO public.europe_data VALUES (3789, 4, 1148, 99.86, 195, 419);
INSERT INTO public.europe_data VALUES (3790, 0, 157, 1.96, 45, 419);
INSERT INTO public.europe_data VALUES (3791, 578, 10523, 34.29, 46, 419);
INSERT INTO public.europe_data VALUES (3792, 16, 503, 2.18, 136, 419);
INSERT INTO public.europe_data VALUES (3793, 1, 40, 0.76, 47, 419);
INSERT INTO public.europe_data VALUES (3794, 814, 65146, 302.41, 196, 419);
INSERT INTO public.europe_data VALUES (3795, 0, 42, 0.54, 137, 419);
INSERT INTO public.europe_data VALUES (3796, 0, 47, 0.23, 48, 419);
INSERT INTO public.europe_data VALUES (3797, 4, 106, 37.5, 98, 419);
INSERT INTO public.europe_data VALUES (3798, 17, 3642, 64.13, 197, 419);
INSERT INTO public.europe_data VALUES (3799, 5, 2399, 59.59, 198, 419);
INSERT INTO public.europe_data VALUES (3800, 13, 294, 3.32, 138, 419);
INSERT INTO public.europe_data VALUES (3801, 0, 7, 0.03, 139, 419);
INSERT INTO public.europe_data VALUES (3802, 3, 289, 6.32, 140, 419);
INSERT INTO public.europe_data VALUES (3803, 0, 45, 0.12, 141, 419);
INSERT INTO public.europe_data VALUES (3804, 0, 1, 0.08, 142, 419);
INSERT INTO public.europe_data VALUES (3805, 2, 111, 2.33, 49, 419);
INSERT INTO public.europe_data VALUES (3806, 10, 401, 61.79, 99, 419);
INSERT INTO public.europe_data VALUES (3807, 107, 7339, 108.78, 50, 419);
INSERT INTO public.europe_data VALUES (3808, 444, 57120, 141.21, 199, 419);
INSERT INTO public.europe_data VALUES (3809, 1, 13, 70.69, 100, 419);
INSERT INTO public.europe_data VALUES (3810, 8, 1278, 5.69, 51, 419);
INSERT INTO public.europe_data VALUES (3811, 438, 27828, 115.43, 200, 419);
INSERT INTO public.europe_data VALUES (3812, 14, 7332, 142.11, 143, 419);
INSERT INTO public.europe_data VALUES (3813, 362, 68009, 163.13, 201, 419);
INSERT INTO public.europe_data VALUES (3814, 0, 0, 0, 52, 419);
INSERT INTO public.europe_data VALUES (3815, 5038, 302799, 186.29, 101, 419);
INSERT INTO public.europe_data VALUES (3816, 1, 4, 49.72, 102, 419);
INSERT INTO public.europe_data VALUES (3817, 1, 137, 6.59, 103, 419);
INSERT INTO public.europe_data VALUES (3818, 23, 3266, 21.44, 144, 419);
INSERT INTO public.europe_data VALUES (3819, 47, 5743, 41.3, 104, 419);
INSERT INTO public.europe_data VALUES (3820, 0, 22, 0.03, 145, 419);
INSERT INTO public.europe_data VALUES (3821, 0, 0, 0, 53, 419);
INSERT INTO public.europe_data VALUES (3822, 3, 11, 0.05, 146, 419);
INSERT INTO public.europe_data VALUES (3823, 1, 411, 5.16, 54, 419);
INSERT INTO public.europe_data VALUES (3824, 1, 73, 1.38, 55, 419);
INSERT INTO public.europe_data VALUES (3825, 12, 183, 1.34, 105, 420);
INSERT INTO public.europe_data VALUES (3826, 15, 874, 66.59, 147, 420);
INSERT INTO public.europe_data VALUES (3827, 42, 1241, 6.53, 1, 420);
INSERT INTO public.europe_data VALUES (3828, 0, 272, 645.86, 148, 420);
INSERT INTO public.europe_data VALUES (3829, 19, 681, 4.2, 2, 420);
INSERT INTO public.europe_data VALUES (3830, 0, 0, 0, 56, 420);
INSERT INTO public.europe_data VALUES (3831, 0, 5, 6.18, 57, 420);
INSERT INTO public.europe_data VALUES (3832, 2840, 88391, 368.11, 58, 420);
INSERT INTO public.europe_data VALUES (3833, 21, 1969, 119.62, 149, 420);
INSERT INTO public.europe_data VALUES (3834, 2, 293, 750.63, 59, 420);
INSERT INTO public.europe_data VALUES (3835, 23, 142, 1.54, 202, 420);
INSERT INTO public.europe_data VALUES (3836, 21, 4909, 114.36, 150, 420);
INSERT INTO public.europe_data VALUES (3837, 11, 835, 16.88, 151, 420);
INSERT INTO public.europe_data VALUES (3838, 13, 420, 221.32, 60, 420);
INSERT INTO public.europe_data VALUES (3839, 21, 4276, 559.91, 106, 420);
INSERT INTO public.europe_data VALUES (3840, 222, 10232, 13.26, 107, 420);
INSERT INTO public.europe_data VALUES (3841, 0, 1, 3.14, 61, 420);
INSERT INTO public.europe_data VALUES (3842, 38, 1935, 36.35, 152, 420);
INSERT INTO public.europe_data VALUES (3843, 39, 11274, 186.65, 153, 420);
INSERT INTO public.europe_data VALUES (3844, 3, 227, 95.81, 62, 420);
INSERT INTO public.europe_data VALUES (3845, 0, 60, 0.62, 3, 420);
INSERT INTO public.europe_data VALUES (3846, 0, 1, 6.4, 63, 420);
INSERT INTO public.europe_data VALUES (3847, 0, 12, 3.67, 108, 420);
INSERT INTO public.europe_data VALUES (3848, 241, 3225, 61.76, 64, 420);
INSERT INTO public.europe_data VALUES (3849, 0, 49, 227.07, 65, 420);
INSERT INTO public.europe_data VALUES (3850, 53, 1493, 104.67, 154, 420);
INSERT INTO public.europe_data VALUES (3851, 3, 354, 29.04, 4, 420);
INSERT INTO public.europe_data VALUES (3852, 4846, 187680, 190.41, 66, 420);
INSERT INTO public.europe_data VALUES (3853, 0, 0, 16.65, 67, 420);
INSERT INTO public.europe_data VALUES (3854, 0, 1, 0.23, 109, 420);
INSERT INTO public.europe_data VALUES (3855, 35, 1192, 30.53, 155, 420);
INSERT INTO public.europe_data VALUES (3856, 0, 162, 1.48, 5, 420);
INSERT INTO public.europe_data VALUES (3857, 0, 12, 0.11, 6, 420);
INSERT INTO public.europe_data VALUES (3858, 0, 1, 0.01, 110, 420);
INSERT INTO public.europe_data VALUES (3859, 2, 304, 2.2, 7, 420);
INSERT INTO public.europe_data VALUES (3860, 51, 9476, 44.01, 68, 420);
INSERT INTO public.europe_data VALUES (3861, 6, 514, 174.2, 8, 420);
INSERT INTO public.europe_data VALUES (3862, 0, 1, 3.08, 69, 420);
INSERT INTO public.europe_data VALUES (3863, 0, 13, 1.2, 9, 420);
INSERT INTO public.europe_data VALUES (3864, 3, 27, 0.59, 10, 420);
INSERT INTO public.europe_data VALUES (3865, 355, 11627, 122.17, 70, 420);
INSERT INTO public.europe_data VALUES (3866, 2, 114, 0.02, 111, 420);
INSERT INTO public.europe_data VALUES (3867, 1280, 47980, 192.17, 71, 420);
INSERT INTO public.europe_data VALUES (3868, 0, 8, 2.59, 11, 420);
INSERT INTO public.europe_data VALUES (3869, 0, 22, 1.38, 12, 420);
INSERT INTO public.europe_data VALUES (3870, 122, 8337, 328.77, 72, 420);
INSERT INTO public.europe_data VALUES (3871, 0, 309, 2.4, 13, 420);
INSERT INTO public.europe_data VALUES (3872, 24, 1275, 65.35, 156, 420);
INSERT INTO public.europe_data VALUES (3873, 7, 366, 6.82, 73, 420);
INSERT INTO public.europe_data VALUES (3874, 0, 92, 124.22, 74, 420);
INSERT INTO public.europe_data VALUES (3875, 0, 96, 19.41, 157, 420);
INSERT INTO public.europe_data VALUES (3876, 103, 15357, 266.76, 158, 420);
INSERT INTO public.europe_data VALUES (3877, 0, 97, 0.26, 14, 420);
INSERT INTO public.europe_data VALUES (3878, 14, 4790, 127.81, 159, 420);
INSERT INTO public.europe_data VALUES (3879, 0, 6, 1.44, 15, 420);
INSERT INTO public.europe_data VALUES (3880, 0, 0, 0, 75, 420);
INSERT INTO public.europe_data VALUES (3881, 48, 3097, 71.94, 76, 420);
INSERT INTO public.europe_data VALUES (3882, 189, 8328, 92.97, 77, 420);
INSERT INTO public.europe_data VALUES (3883, 113, 825, 1.82, 16, 420);
INSERT INTO public.europe_data VALUES (3884, 14, 1077, 25.12, 78, 420);
INSERT INTO public.europe_data VALUES (3885, 0, 26, 2.36, 17, 420);
INSERT INTO public.europe_data VALUES (3886, 0, 11, 0.4, 18, 420);
INSERT INTO public.europe_data VALUES (3887, 0, 276, 39.55, 160, 420);
INSERT INTO public.europe_data VALUES (3888, 4, 162, 31.01, 19, 420);
INSERT INTO public.europe_data VALUES (3889, 74, 4512, 8.06, 20, 420);
INSERT INTO public.europe_data VALUES (3890, 0, 0, 0, 79, 420);
INSERT INTO public.europe_data VALUES (3891, 0, 26, 76.01, 161, 420);
INSERT INTO public.europe_data VALUES (3892, 0, 0, 0, 203, 420);
INSERT INTO public.europe_data VALUES (3893, 4, 702, 19.97, 162, 420);
INSERT INTO public.europe_data VALUES (3894, 442, 84806, 234.99, 163, 420);
INSERT INTO public.europe_data VALUES (3895, 3, 14, 157.9, 204, 420);
INSERT INTO public.europe_data VALUES (3896, 1, 32, 3.91, 21, 420);
INSERT INTO public.europe_data VALUES (3897, 3, 43, 6.99, 22, 420);
INSERT INTO public.europe_data VALUES (3898, 8, 1857, 79.06, 164, 420);
INSERT INTO public.europe_data VALUES (3899, 74, 12995, 30.09, 165, 420);
INSERT INTO public.europe_data VALUES (3900, 2, 383, 3.13, 23, 420);
INSERT INTO public.europe_data VALUES (3901, 0, 29, 145.37, 166, 420);
INSERT INTO public.europe_data VALUES (3902, 41, 2302, 39.2, 167, 420);
INSERT INTO public.europe_data VALUES (3903, 0, 0, 0, 80, 420);
INSERT INTO public.europe_data VALUES (3904, 0, 0, 0, 81, 420);
INSERT INTO public.europe_data VALUES (3905, 8, 237, 276.76, 205, 420);
INSERT INTO public.europe_data VALUES (3906, 110, 4648, 46.54, 82, 420);
INSERT INTO public.europe_data VALUES (3907, 0, 1, 4.65, 168, 420);
INSERT INTO public.europe_data VALUES (3908, 2, 255, 4.38, 24, 420);
INSERT INTO public.europe_data VALUES (3909, 0, 21, 2.55, 25, 420);
INSERT INTO public.europe_data VALUES (3910, 12, 503, 117.4, 83, 420);
INSERT INTO public.europe_data VALUES (3911, 6, 104, 2.04, 84, 420);
INSERT INTO public.europe_data VALUES (3912, 0, 0, 0, 169, 420);
INSERT INTO public.europe_data VALUES (3913, 105, 3493, 75.11, 85, 420);
INSERT INTO public.europe_data VALUES (3914, 63, 5850, 126.95, 170, 420);
INSERT INTO public.europe_data VALUES (3915, 0, 277, 128.29, 171, 420);
INSERT INTO public.europe_data VALUES (3916, 7660, 587122, 89.89, 112, 420);
INSERT INTO public.europe_data VALUES (3917, 833, 30537, 21, 113, 420);
INSERT INTO public.europe_data VALUES (3918, 1288, 24308, 53.57, 114, 420);
INSERT INTO public.europe_data VALUES (3919, 435, 30415, 150.45, 115, 420);
INSERT INTO public.europe_data VALUES (3920, 10, 2057, 81.66, 172, 420);
INSERT INTO public.europe_data VALUES (3921, 0, 1, 3.55, 173, 420);
INSERT INTO public.europe_data VALUES (3922, 210, 42599, 873.66, 116, 420);
INSERT INTO public.europe_data VALUES (3923, 128, 11714, 36.64, 174, 420);
INSERT INTO public.europe_data VALUES (3924, 22, 1005, 75.37, 86, 420);
INSERT INTO public.europe_data VALUES (3925, 48, 3474, 5.1, 117, 420);
INSERT INTO public.europe_data VALUES (3926, 0, 7, 18.55, 175, 420);
INSERT INTO public.europe_data VALUES (3927, 15, 3713, 51.26, 118, 420);
INSERT INTO public.europe_data VALUES (3928, 34, 1810, 20.22, 119, 420);
INSERT INTO public.europe_data VALUES (3929, 43, 1134, 3.72, 26, 420);
INSERT INTO public.europe_data VALUES (3930, 9, 409, 46.43, 176, 420);
INSERT INTO public.europe_data VALUES (3931, 17, 4110, 208.7, 120, 420);
INSERT INTO public.europe_data VALUES (3932, 1, 884, 22.24, 121, 420);
INSERT INTO public.europe_data VALUES (3933, 0, 0, 0, 122, 420);
INSERT INTO public.europe_data VALUES (3934, 0, 151, 10.52, 177, 420);
INSERT INTO public.europe_data VALUES (3935, 50, 6951, 174.22, 123, 420);
INSERT INTO public.europe_data VALUES (3936, 2, 134, 14.73, 27, 420);
INSERT INTO public.europe_data VALUES (3937, 0, 4, 0.41, 28, 420);
INSERT INTO public.europe_data VALUES (3938, 82, 4415, 141.4, 29, 420);
INSERT INTO public.europe_data VALUES (3939, 0, 5, 15.63, 178, 420);
INSERT INTO public.europe_data VALUES (3940, 4, 641, 37.58, 179, 420);
INSERT INTO public.europe_data VALUES (3941, 0, 553, 189.45, 180, 420);
INSERT INTO public.europe_data VALUES (3942, 6, 232, 1.96, 30, 420);
INSERT INTO public.europe_data VALUES (3943, 0, 37, 0.42, 31, 420);
INSERT INTO public.europe_data VALUES (3944, 4, 700, 3.14, 124, 420);
INSERT INTO public.europe_data VALUES (3945, 1, 374, 174.21, 125, 420);
INSERT INTO public.europe_data VALUES (3946, 2, 73, 0.82, 32, 420);
INSERT INTO public.europe_data VALUES (3947, 11, 230, 121.77, 181, 420);
INSERT INTO public.europe_data VALUES (3948, 0, 94, 4.11, 33, 420);
INSERT INTO public.europe_data VALUES (3949, 0, 0, 0.47, 34, 420);
INSERT INTO public.europe_data VALUES (3950, 2937, 31936, 47.04, 87, 420);
INSERT INTO public.europe_data VALUES (3951, 84, 4279, 195.31, 182, 420);
INSERT INTO public.europe_data VALUES (3952, 0, 17, 117.88, 183, 420);
INSERT INTO public.europe_data VALUES (3953, 0, 1, 0.06, 126, 420);
INSERT INTO public.europe_data VALUES (3954, 22, 1701, 578.77, 184, 420);
INSERT INTO public.europe_data VALUES (3955, 0, 0, 0, 88, 420);
INSERT INTO public.europe_data VALUES (3956, 239, 15942, 84.99, 35, 420);
INSERT INTO public.europe_data VALUES (3957, 15, 1212, 8.94, 36, 420);
INSERT INTO public.europe_data VALUES (3958, 132, 4929, 14.28, 127, 420);
INSERT INTO public.europe_data VALUES (3959, 7, 656, 52.68, 37, 420);
INSERT INTO public.europe_data VALUES (3960, 66, 9272, 67.23, 128, 420);
INSERT INTO public.europe_data VALUES (3961, 95, 17826, 170.62, 185, 420);
INSERT INTO public.europe_data VALUES (3962, 0, 1, 0.35, 208, 420);
INSERT INTO public.europe_data VALUES (3963, 0, 13, 0.63, 209, 420);
INSERT INTO public.europe_data VALUES (3964, 2, 112, 3.9, 89, 420);
INSERT INTO public.europe_data VALUES (3965, 0, 8, 0.07, 38, 420);
INSERT INTO public.europe_data VALUES (3966, 10, 1082, 1.03, 39, 420);
INSERT INTO public.europe_data VALUES (3967, 32, 894, 93.16, 186, 420);
INSERT INTO public.europe_data VALUES (3968, 0, 1, 17.48, 210, 420);
INSERT INTO public.europe_data VALUES (3969, 3, 761, 28.9, 187, 420);
INSERT INTO public.europe_data VALUES (3970, 63, 3975, 154.85, 129, 420);
INSERT INTO public.europe_data VALUES (3971, 46, 4537, 4.07, 130, 420);
INSERT INTO public.europe_data VALUES (3972, 43, 3747, 194.38, 131, 420);
INSERT INTO public.europe_data VALUES (3973, 83, 4352, 207.47, 90, 420);
INSERT INTO public.europe_data VALUES (3974, 0, 15, 0.24, 211, 420);
INSERT INTO public.europe_data VALUES (3975, 144, 5164, 154.26, 91, 420);
INSERT INTO public.europe_data VALUES (3976, 893, 36407, 232.8, 92, 420);
INSERT INTO public.europe_data VALUES (3977, 360, 17483, 39.78, 132, 420);
INSERT INTO public.europe_data VALUES (3978, 139, 8090, 34.7, 188, 420);
INSERT INTO public.europe_data VALUES (3979, 41, 5027, 93.62, 189, 420);
INSERT INTO public.europe_data VALUES (3980, 36, 4466, 304.22, 93, 420);
INSERT INTO public.europe_data VALUES (3981, 4, 1708, 118.08, 133, 420);
INSERT INTO public.europe_data VALUES (3982, 283, 9892, 98.78, 190, 420);
INSERT INTO public.europe_data VALUES (3983, 906, 48039, 60.76, 191, 420);
INSERT INTO public.europe_data VALUES (3984, 3, 109, 1.81, 40, 420);
INSERT INTO public.europe_data VALUES (3985, 0, 2, 3.79, 94, 420);
INSERT INTO public.europe_data VALUES (3986, 0, 0, 0, 95, 420);
INSERT INTO public.europe_data VALUES (3987, 0, 0, 0, 96, 420);
INSERT INTO public.europe_data VALUES (3988, 0, 4, 14.51, 192, 420);
INSERT INTO public.europe_data VALUES (3989, 0, 3, 2.33, 41, 420);
INSERT INTO public.europe_data VALUES (3990, 198, 3439, 22.01, 134, 420);
INSERT INTO public.europe_data VALUES (3991, 6, 195, 3.86, 42, 420);
INSERT INTO public.europe_data VALUES (3992, 6, 476, 14.02, 193, 420);
INSERT INTO public.europe_data VALUES (3993, 0, 2, 4.09, 43, 420);
INSERT INTO public.europe_data VALUES (3994, 0, 47, 1.36, 44, 420);
INSERT INTO public.europe_data VALUES (3995, 0, 124, 5.07, 135, 420);
INSERT INTO public.europe_data VALUES (3996, 2, 60, 224.11, 97, 420);
INSERT INTO public.europe_data VALUES (3997, 5, 2401, 65.06, 194, 420);
INSERT INTO public.europe_data VALUES (3998, 3, 930, 79.2, 195, 420);
INSERT INTO public.europe_data VALUES (3999, 1, 146, 1.29, 45, 420);
INSERT INTO public.europe_data VALUES (4000, 445, 9555, 35.82, 46, 420);
INSERT INTO public.europe_data VALUES (4001, 21, 616, 2.69, 136, 420);
INSERT INTO public.europe_data VALUES (4002, 0, 44, 0.98, 47, 420);
INSERT INTO public.europe_data VALUES (4003, 748, 76798, 329.24, 196, 420);
INSERT INTO public.europe_data VALUES (4004, 0, 73, 0.59, 137, 420);
INSERT INTO public.europe_data VALUES (4005, 0, 51, 0.32, 48, 420);
INSERT INTO public.europe_data VALUES (4006, 5, 112, 43.52, 98, 420);
INSERT INTO public.europe_data VALUES (4007, 11, 2919, 48.87, 197, 420);
INSERT INTO public.europe_data VALUES (4008, 14, 2693, 56.13, 198, 420);
INSERT INTO public.europe_data VALUES (4009, 20, 272, 3.12, 138, 420);
INSERT INTO public.europe_data VALUES (4010, 0, 1, 0.05, 139, 420);
INSERT INTO public.europe_data VALUES (4011, 2, 300, 6.4, 140, 420);
INSERT INTO public.europe_data VALUES (4012, 0, 39, 0.1, 141, 420);
INSERT INTO public.europe_data VALUES (4013, 0, 0, 0, 142, 420);
INSERT INTO public.europe_data VALUES (4014, 5, 77, 2.12, 49, 420);
INSERT INTO public.europe_data VALUES (4015, 6, 461, 94.63, 99, 420);
INSERT INTO public.europe_data VALUES (4016, 55, 5382, 81.05, 50, 420);
INSERT INTO public.europe_data VALUES (4017, 491, 58676, 143.27, 199, 420);
INSERT INTO public.europe_data VALUES (4018, 0, 14, 94.26, 100, 420);
INSERT INTO public.europe_data VALUES (4019, 10, 1243, 6.17, 51, 420);
INSERT INTO public.europe_data VALUES (4020, 402, 22956, 100.69, 200, 420);
INSERT INTO public.europe_data VALUES (4021, 8, 6553, 122.61, 143, 420);
INSERT INTO public.europe_data VALUES (4022, 211, 40712, 99.73, 201, 420);
INSERT INTO public.europe_data VALUES (4023, 0, 0, 0, 52, 420);
INSERT INTO public.europe_data VALUES (4024, 5247, 310232, 180.84, 101, 420);
INSERT INTO public.europe_data VALUES (4025, 0, 48, 92.75, 102, 420);
INSERT INTO public.europe_data VALUES (4026, 1, 91, 5.78, 103, 420);
INSERT INTO public.europe_data VALUES (4027, 25, 3804, 24.17, 144, 420);
INSERT INTO public.europe_data VALUES (4028, 59, 6035, 42.61, 104, 420);
INSERT INTO public.europe_data VALUES (4029, 0, 6, 0.01, 145, 420);
INSERT INTO public.europe_data VALUES (4030, 0, 0, 0, 53, 420);
INSERT INTO public.europe_data VALUES (4031, 2, 4, 0.07, 146, 420);
INSERT INTO public.europe_data VALUES (4032, 2, 510, 6.17, 54, 420);
INSERT INTO public.europe_data VALUES (4033, 2, 129, 1.95, 55, 420);
INSERT INTO public.europe_data VALUES (4034, 21, 328, 1.7, 105, 421);
INSERT INTO public.europe_data VALUES (4035, 28, 1032, 74.41, 147, 421);
INSERT INTO public.europe_data VALUES (4036, 60, 1572, 8.04, 1, 421);
INSERT INTO public.europe_data VALUES (4037, 0, 220, 458.14, 148, 421);
INSERT INTO public.europe_data VALUES (4038, 20, 656, 3.32, 2, 421);
INSERT INTO public.europe_data VALUES (4039, 0, 0, 0, 56, 421);
INSERT INTO public.europe_data VALUES (4040, 0, 1, 1.03, 57, 421);
INSERT INTO public.europe_data VALUES (4041, 1602, 76453, 337.48, 58, 421);
INSERT INTO public.europe_data VALUES (4042, 14, 1569, 89.53, 149, 421);
INSERT INTO public.europe_data VALUES (4043, 5, 505, 1036.59, 59, 421);
INSERT INTO public.europe_data VALUES (4044, 39, 247, 2.46, 202, 421);
INSERT INTO public.europe_data VALUES (4045, 10, 5222, 105.69, 150, 421);
INSERT INTO public.europe_data VALUES (4046, 13, 861, 18.5, 151, 421);
INSERT INTO public.europe_data VALUES (4047, 7, 442, 211.56, 60, 421);
INSERT INTO public.europe_data VALUES (4048, 9, 4913, 592.75, 106, 421);
INSERT INTO public.europe_data VALUES (4049, 206, 11396, 14.57, 107, 421);
INSERT INTO public.europe_data VALUES (4050, 0, 8, 3.48, 61, 421);
INSERT INTO public.europe_data VALUES (4051, 30, 1501, 29.78, 152, 421);
INSERT INTO public.europe_data VALUES (4052, 27, 10108, 141.99, 153, 421);
INSERT INTO public.europe_data VALUES (4053, 2, 147, 93.76, 62, 421);
INSERT INTO public.europe_data VALUES (4054, 0, 13, 0.57, 3, 421);
INSERT INTO public.europe_data VALUES (4055, 0, 3, 8, 63, 421);
INSERT INTO public.europe_data VALUES (4056, 0, 16, 4.06, 108, 421);
INSERT INTO public.europe_data VALUES (4057, 273, 3885, 86.05, 64, 421);
INSERT INTO public.europe_data VALUES (4058, 1, 10, 69.28, 65, 421);
INSERT INTO public.europe_data VALUES (4059, 68, 1962, 129.72, 154, 421);
INSERT INTO public.europe_data VALUES (4060, 3, 315, 24.53, 4, 421);
INSERT INTO public.europe_data VALUES (4061, 5270, 214174, 192.9, 66, 421);
INSERT INTO public.europe_data VALUES (4062, 0, 5, 26.64, 67, 421);
INSERT INTO public.europe_data VALUES (4063, 0, 0, 0, 109, 421);
INSERT INTO public.europe_data VALUES (4064, 41, 945, 25.9, 155, 421);
INSERT INTO public.europe_data VALUES (4065, 0, 139, 1.94, 5, 421);
INSERT INTO public.europe_data VALUES (4066, 0, 1, 0.1, 6, 421);
INSERT INTO public.europe_data VALUES (4067, 0, 0, 0.01, 110, 421);
INSERT INTO public.europe_data VALUES (4068, 1, 264, 3.2, 7, 421);
INSERT INTO public.europe_data VALUES (4069, 46, 6990, 31.42, 68, 421);
INSERT INTO public.europe_data VALUES (4070, 7, 444, 168.57, 8, 421);
INSERT INTO public.europe_data VALUES (4071, 0, 1, 6.16, 69, 421);
INSERT INTO public.europe_data VALUES (4072, 0, 44, 1.35, 9, 421);
INSERT INTO public.europe_data VALUES (4073, 1, 67, 0.7, 10, 421);
INSERT INTO public.europe_data VALUES (4074, 337, 11526, 125.39, 70, 421);
INSERT INTO public.europe_data VALUES (4075, 3, 172, 0.02, 111, 421);
INSERT INTO public.europe_data VALUES (4076, 1284, 48757, 195.78, 71, 421);
INSERT INTO public.europe_data VALUES (4077, 0, 14, 2.12, 11, 421);
INSERT INTO public.europe_data VALUES (4078, 1, 52, 6.65, 12, 421);
INSERT INTO public.europe_data VALUES (4079, 116, 8258, 332.68, 72, 421);
INSERT INTO public.europe_data VALUES (4080, 0, 307, 2.85, 13, 421);
INSERT INTO public.europe_data VALUES (4081, 24, 1389, 72.57, 156, 421);
INSERT INTO public.europe_data VALUES (4082, 7, 407, 6.9, 73, 421);
INSERT INTO public.europe_data VALUES (4083, 0, 111, 107.7, 74, 421);
INSERT INTO public.europe_data VALUES (4084, 1, 74, 10.39, 157, 421);
INSERT INTO public.europe_data VALUES (4085, 47, 13052, 197.98, 158, 421);
INSERT INTO public.europe_data VALUES (4086, 6, 125, 0.35, 14, 421);
INSERT INTO public.europe_data VALUES (4087, 6, 2631, 74.06, 159, 421);
INSERT INTO public.europe_data VALUES (4088, 0, 8, 1.54, 15, 421);
INSERT INTO public.europe_data VALUES (4089, 0, 0, 5.57, 75, 421);
INSERT INTO public.europe_data VALUES (4090, 79, 4629, 83.4, 76, 421);
INSERT INTO public.europe_data VALUES (4091, 187, 7825, 95.75, 77, 421);
INSERT INTO public.europe_data VALUES (4092, 122, 1006, 2.14, 16, 421);
INSERT INTO public.europe_data VALUES (4093, 24, 544, 19.29, 78, 421);
INSERT INTO public.europe_data VALUES (4094, 0, 6, 2.21, 17, 421);
INSERT INTO public.europe_data VALUES (4095, 0, 3, 0.97, 18, 421);
INSERT INTO public.europe_data VALUES (4096, 0, 248, 30.87, 160, 421);
INSERT INTO public.europe_data VALUES (4097, 6, 194, 36.23, 19, 421);
INSERT INTO public.europe_data VALUES (4098, 83, 4519, 9.05, 20, 421);
INSERT INTO public.europe_data VALUES (4099, 0, 0, 0, 79, 421);
INSERT INTO public.europe_data VALUES (4100, 0, 11, 43.14, 161, 421);
INSERT INTO public.europe_data VALUES (4101, 0, 0, 0.11, 203, 421);
INSERT INTO public.europe_data VALUES (4102, 2, 400, 12.49, 162, 421);
INSERT INTO public.europe_data VALUES (4103, 369, 72669, 192.48, 163, 421);
INSERT INTO public.europe_data VALUES (4104, 0, 427, 223.43, 204, 421);
INSERT INTO public.europe_data VALUES (4105, 0, 53, 4.37, 21, 421);
INSERT INTO public.europe_data VALUES (4106, 5, 121, 14.01, 22, 421);
INSERT INTO public.europe_data VALUES (4107, 1, 1303, 51.42, 164, 421);
INSERT INTO public.europe_data VALUES (4108, 36, 11982, 25.94, 165, 421);
INSERT INTO public.europe_data VALUES (4109, 11, 570, 4.03, 23, 421);
INSERT INTO public.europe_data VALUES (4110, 0, 20, 103.84, 166, 421);
INSERT INTO public.europe_data VALUES (4111, 33, 1902, 33.74, 167, 421);
INSERT INTO public.europe_data VALUES (4112, 0, 0, 0, 80, 421);
INSERT INTO public.europe_data VALUES (4113, 0, 0, 0, 81, 421);
INSERT INTO public.europe_data VALUES (4114, 9, 226, 297.68, 205, 421);
INSERT INTO public.europe_data VALUES (4115, 162, 3535, 44.14, 82, 421);
INSERT INTO public.europe_data VALUES (4116, 0, 2, 4.65, 168, 421);
INSERT INTO public.europe_data VALUES (4117, 1, 305, 4.72, 24, 421);
INSERT INTO public.europe_data VALUES (4118, 0, 28, 3.02, 25, 421);
INSERT INTO public.europe_data VALUES (4119, 8, 416, 102.33, 83, 421);
INSERT INTO public.europe_data VALUES (4120, 2, 126, 2.3, 84, 421);
INSERT INTO public.europe_data VALUES (4121, 0, 0, 0, 169, 421);
INSERT INTO public.europe_data VALUES (4122, 105, 3827, 70.3, 85, 421);
INSERT INTO public.europe_data VALUES (4123, 49, 6557, 107.23, 170, 421);
INSERT INTO public.europe_data VALUES (4124, 0, 181, 57.42, 171, 421);
INSERT INTO public.europe_data VALUES (4125, 8160, 641153, 93.89, 112, 421);
INSERT INTO public.europe_data VALUES (4126, 830, 26294, 18.69, 113, 421);
INSERT INTO public.europe_data VALUES (4127, 1144, 20111, 42.79, 114, 421);
INSERT INTO public.europe_data VALUES (4128, 541, 28726, 149.24, 115, 421);
INSERT INTO public.europe_data VALUES (4129, 8, 1948, 66.49, 172, 421);
INSERT INTO public.europe_data VALUES (4130, 0, 2, 2.36, 173, 421);
INSERT INTO public.europe_data VALUES (4131, 137, 31831, 678.25, 116, 421);
INSERT INTO public.europe_data VALUES (4132, 97, 10403, 34, 174, 421);
INSERT INTO public.europe_data VALUES (4133, 25, 1217, 63.94, 86, 421);
INSERT INTO public.europe_data VALUES (4134, 58, 3000, 5.36, 117, 421);
INSERT INTO public.europe_data VALUES (4135, 0, 13, 8.35, 175, 421);
INSERT INTO public.europe_data VALUES (4136, 6, 1465, 23.44, 118, 421);
INSERT INTO public.europe_data VALUES (4137, 53, 1942, 23.35, 119, 421);
INSERT INTO public.europe_data VALUES (4138, 26, 824, 3.57, 26, 421);
INSERT INTO public.europe_data VALUES (4139, 17, 426, 52.49, 176, 421);
INSERT INTO public.europe_data VALUES (4140, 24, 4670, 234.18, 120, 421);
INSERT INTO public.europe_data VALUES (4141, 0, 543, 15.9, 121, 421);
INSERT INTO public.europe_data VALUES (4142, 0, 0, 0.01, 122, 421);
INSERT INTO public.europe_data VALUES (4143, 1, 51, 5.05, 177, 421);
INSERT INTO public.europe_data VALUES (4144, 56, 4993, 129.48, 123, 421);
INSERT INTO public.europe_data VALUES (4145, 0, 179, 12.99, 27, 421);
INSERT INTO public.europe_data VALUES (4146, 0, 16, 0.57, 28, 421);
INSERT INTO public.europe_data VALUES (4147, 76, 5168, 150.5, 29, 421);
INSERT INTO public.europe_data VALUES (4148, 0, 1, 10.42, 178, 421);
INSERT INTO public.europe_data VALUES (4149, 0, 409, 23.66, 179, 421);
INSERT INTO public.europe_data VALUES (4150, 0, 610, 147.91, 180, 421);
INSERT INTO public.europe_data VALUES (4151, 12, 296, 2.72, 30, 421);
INSERT INTO public.europe_data VALUES (4152, 2, 41, 0.63, 31, 421);
INSERT INTO public.europe_data VALUES (4153, 2, 304, 2.57, 124, 421);
INSERT INTO public.europe_data VALUES (4154, 1, 551, 214.71, 125, 421);
INSERT INTO public.europe_data VALUES (4155, 0, 89, 0.87, 32, 421);
INSERT INTO public.europe_data VALUES (4156, 6, 371, 141.83, 181, 421);
INSERT INTO public.europe_data VALUES (4157, 0, 92, 5.17, 33, 421);
INSERT INTO public.europe_data VALUES (4158, 0, 6, 0.87, 34, 421);
INSERT INTO public.europe_data VALUES (4159, 2672, 28075, 48.45, 87, 421);
INSERT INTO public.europe_data VALUES (4160, 80, 3618, 168.16, 182, 421);
INSERT INTO public.europe_data VALUES (4161, 0, 22, 136.01, 183, 421);
INSERT INTO public.europe_data VALUES (4162, 0, 1, 0.06, 126, 421);
INSERT INTO public.europe_data VALUES (4163, 16, 1900, 491.66, 184, 421);
INSERT INTO public.europe_data VALUES (4164, 0, 0, 0, 88, 421);
INSERT INTO public.europe_data VALUES (4165, 252, 15057, 80.47, 35, 421);
INSERT INTO public.europe_data VALUES (4166, 8, 1502, 7.66, 36, 421);
INSERT INTO public.europe_data VALUES (4167, 70, 2790, 8.03, 127, 421);
INSERT INTO public.europe_data VALUES (4168, 11, 658, 67.83, 37, 421);
INSERT INTO public.europe_data VALUES (4169, 66, 9963, 62.45, 128, 421);
INSERT INTO public.europe_data VALUES (4170, 25, 11661, 109.76, 185, 421);
INSERT INTO public.europe_data VALUES (4171, 0, 0, 0, 208, 421);
INSERT INTO public.europe_data VALUES (4172, 1, 17, 0.82, 209, 421);
INSERT INTO public.europe_data VALUES (4173, 3, 143, 4.48, 89, 421);
INSERT INTO public.europe_data VALUES (4174, 0, 8, 0.05, 38, 421);
INSERT INTO public.europe_data VALUES (4175, 16, 986, 1.11, 39, 421);
INSERT INTO public.europe_data VALUES (4176, 47, 1041, 94.99, 186, 421);
INSERT INTO public.europe_data VALUES (4177, 0, 9, 19.23, 210, 421);
INSERT INTO public.europe_data VALUES (4178, 2, 779, 28.62, 187, 421);
INSERT INTO public.europe_data VALUES (4179, 66, 3729, 128.7, 129, 421);
INSERT INTO public.europe_data VALUES (4180, 37, 4284, 3.42, 130, 421);
INSERT INTO public.europe_data VALUES (4181, 50, 5936, 229.53, 131, 421);
INSERT INTO public.europe_data VALUES (4182, 91, 4458, 215.71, 90, 421);
INSERT INTO public.europe_data VALUES (4183, 1, 6, 0.23, 211, 421);
INSERT INTO public.europe_data VALUES (4184, 134, 5703, 156.63, 91, 421);
INSERT INTO public.europe_data VALUES (4185, 659, 39276, 242.75, 92, 421);
INSERT INTO public.europe_data VALUES (4186, 613, 25527, 45.67, 132, 421);
INSERT INTO public.europe_data VALUES (4187, 105, 5088, 22.16, 188, 421);
INSERT INTO public.europe_data VALUES (4188, 45, 4594, 80.95, 189, 421);
INSERT INTO public.europe_data VALUES (4189, 69, 4458, 249.03, 93, 421);
INSERT INTO public.europe_data VALUES (4190, 5, 1636, 115.85, 133, 421);
INSERT INTO public.europe_data VALUES (4191, 272, 9286, 91.51, 190, 421);
INSERT INTO public.europe_data VALUES (4192, 840, 40588, 53.4, 191, 421);
INSERT INTO public.europe_data VALUES (4193, 4, 120, 2.67, 40, 421);
INSERT INTO public.europe_data VALUES (4194, 0, 0, 0, 94, 421);
INSERT INTO public.europe_data VALUES (4195, 0, 0, 0.55, 95, 421);
INSERT INTO public.europe_data VALUES (4196, 0, 0, 2.71, 96, 421);
INSERT INTO public.europe_data VALUES (4197, 0, 1, 20.32, 192, 421);
INSERT INTO public.europe_data VALUES (4198, 0, 2, 4.65, 41, 421);
INSERT INTO public.europe_data VALUES (4199, 217, 4103, 26.05, 134, 421);
INSERT INTO public.europe_data VALUES (4200, 5, 434, 4.46, 42, 421);
INSERT INTO public.europe_data VALUES (4201, 8, 500, 14.4, 193, 421);
INSERT INTO public.europe_data VALUES (4202, 0, 2, 4.09, 43, 421);
INSERT INTO public.europe_data VALUES (4203, 0, 59, 1.46, 44, 421);
INSERT INTO public.europe_data VALUES (4204, 0, 170, 9.54, 135, 421);
INSERT INTO public.europe_data VALUES (4205, 1, 35, 172.21, 97, 421);
INSERT INTO public.europe_data VALUES (4206, 1, 1145, 37.85, 194, 421);
INSERT INTO public.europe_data VALUES (4207, 2, 718, 59.88, 195, 421);
INSERT INTO public.europe_data VALUES (4208, 0, 53, 0.52, 45, 421);
INSERT INTO public.europe_data VALUES (4209, 506, 11418, 38.75, 46, 421);
INSERT INTO public.europe_data VALUES (4210, 22, 760, 3.41, 136, 421);
INSERT INTO public.europe_data VALUES (4211, 0, 64, 0.89, 47, 421);
INSERT INTO public.europe_data VALUES (4212, 815, 77738, 310.88, 196, 421);
INSERT INTO public.europe_data VALUES (4213, 1, 53, 0.77, 137, 421);
INSERT INTO public.europe_data VALUES (4214, 2, 85, 0.35, 48, 421);
INSERT INTO public.europe_data VALUES (4215, 4, 141, 64.85, 98, 421);
INSERT INTO public.europe_data VALUES (4216, 12, 2080, 35.89, 197, 421);
INSERT INTO public.europe_data VALUES (4217, 18, 2103, 57.09, 198, 421);
INSERT INTO public.europe_data VALUES (4218, 17, 260, 3.68, 138, 421);
INSERT INTO public.europe_data VALUES (4219, 0, 11, 0.07, 139, 421);
INSERT INTO public.europe_data VALUES (4220, 1, 297, 5.94, 140, 421);
INSERT INTO public.europe_data VALUES (4221, 1, 31, 0.09, 141, 421);
INSERT INTO public.europe_data VALUES (4222, 0, 0, 0, 142, 421);
INSERT INTO public.europe_data VALUES (4223, 4, 94, 2.2, 49, 421);
INSERT INTO public.europe_data VALUES (4224, 12, 859, 118.35, 99, 421);
INSERT INTO public.europe_data VALUES (4225, 52, 4097, 50.93, 50, 421);
INSERT INTO public.europe_data VALUES (4226, 450, 58815, 143.02, 199, 421);
INSERT INTO public.europe_data VALUES (4227, 0, 22, 183.27, 100, 421);
INSERT INTO public.europe_data VALUES (4228, 8, 1488, 5.92, 51, 421);
INSERT INTO public.europe_data VALUES (4229, 379, 21343, 90.43, 200, 421);
INSERT INTO public.europe_data VALUES (4230, 5, 5427, 111.89, 143, 421);
INSERT INTO public.europe_data VALUES (4231, 149, 25753, 70.68, 201, 421);
INSERT INTO public.europe_data VALUES (4232, 0, 0, 0, 52, 421);
INSERT INTO public.europe_data VALUES (4233, 5430, 284835, 160.57, 101, 421);
INSERT INTO public.europe_data VALUES (4234, 0, 49, 84.15, 102, 421);
INSERT INTO public.europe_data VALUES (4235, 1, 109, 6.88, 103, 421);
INSERT INTO public.europe_data VALUES (4236, 41, 4169, 24.3, 144, 421);
INSERT INTO public.europe_data VALUES (4237, 62, 6116, 46.88, 104, 421);
INSERT INTO public.europe_data VALUES (4238, 0, 5, 0.02, 145, 421);
INSERT INTO public.europe_data VALUES (4239, 0, 0, 0, 53, 421);
INSERT INTO public.europe_data VALUES (4240, 3, 17, 0.15, 146, 421);
INSERT INTO public.europe_data VALUES (4241, 18, 592, 7.59, 54, 421);
INSERT INTO public.europe_data VALUES (4242, 1, 157, 4.82, 55, 421);
INSERT INTO public.europe_data VALUES (4243, 8, 318, 1.46, 105, 422);
INSERT INTO public.europe_data VALUES (4244, 18, 1098, 68.93, 147, 422);
INSERT INTO public.europe_data VALUES (4245, 56, 1890, 9.54, 1, 422);
INSERT INTO public.europe_data VALUES (4246, 0, 129, 288.8, 148, 422);
INSERT INTO public.europe_data VALUES (4247, 15, 400, 2.23, 2, 422);
INSERT INTO public.europe_data VALUES (4248, 0, 0, 0, 56, 422);
INSERT INTO public.europe_data VALUES (4249, 0, 0, 1.03, 57, 422);
INSERT INTO public.europe_data VALUES (4250, 1500, 74675, 324.34, 58, 422);
INSERT INTO public.europe_data VALUES (4251, 19, 1079, 71.41, 149, 422);
INSERT INTO public.europe_data VALUES (4252, 4, 597, 986.74, 59, 422);
INSERT INTO public.europe_data VALUES (4253, 57, 372, 3.89, 202, 422);
INSERT INTO public.europe_data VALUES (4254, 20, 4141, 69.05, 150, 422);
INSERT INTO public.europe_data VALUES (4255, 14, 998, 20.08, 151, 422);
INSERT INTO public.europe_data VALUES (4256, 9, 382, 195.39, 60, 422);
INSERT INTO public.europe_data VALUES (4257, 14, 4815, 488.19, 106, 422);
INSERT INTO public.europe_data VALUES (4258, 284, 12363, 16.37, 107, 422);
INSERT INTO public.europe_data VALUES (4259, 0, 2, 2.79, 61, 422);
INSERT INTO public.europe_data VALUES (4260, 39, 1314, 26.3, 152, 422);
INSERT INTO public.europe_data VALUES (4261, 19, 6158, 85.66, 153, 422);
INSERT INTO public.europe_data VALUES (4262, 4, 219, 124.5, 62, 422);
INSERT INTO public.europe_data VALUES (4263, 0, 54, 1.03, 3, 422);
INSERT INTO public.europe_data VALUES (4264, 0, 2, 12.8, 63, 422);
INSERT INTO public.europe_data VALUES (4265, 0, 15, 2.75, 108, 422);
INSERT INTO public.europe_data VALUES (4266, 336, 6022, 94.01, 64, 422);
INSERT INTO public.europe_data VALUES (4267, 0, 8, 42.34, 65, 422);
INSERT INTO public.europe_data VALUES (4268, 50, 2320, 111.27, 154, 422);
INSERT INTO public.europe_data VALUES (4269, 2, 250, 26.87, 4, 422);
INSERT INTO public.europe_data VALUES (4270, 4975, 192934, 221.82, 66, 422);
INSERT INTO public.europe_data VALUES (4271, 0, 3, 96.56, 67, 422);
INSERT INTO public.europe_data VALUES (4272, 0, 0, 0.23, 109, 422);
INSERT INTO public.europe_data VALUES (4273, 49, 868, 24.69, 155, 422);
INSERT INTO public.europe_data VALUES (4274, 1, 255, 1.67, 5, 422);
INSERT INTO public.europe_data VALUES (4275, 0, 10, 0.23, 6, 422);
INSERT INTO public.europe_data VALUES (4276, 0, 1, 0.01, 110, 422);
INSERT INTO public.europe_data VALUES (4277, 1, 563, 3.96, 7, 422);
INSERT INTO public.europe_data VALUES (4278, 26, 4764, 23.31, 68, 422);
INSERT INTO public.europe_data VALUES (4279, 2, 483, 174.75, 8, 422);
INSERT INTO public.europe_data VALUES (4280, 0, 3, 4.62, 69, 422);
INSERT INTO public.europe_data VALUES (4281, 0, 20, 1.03, 9, 422);
INSERT INTO public.europe_data VALUES (4282, 1, 45, 0.45, 10, 422);
INSERT INTO public.europe_data VALUES (4283, 357, 12238, 130.72, 70, 422);
INSERT INTO public.europe_data VALUES (4284, 4, 139, 0.02, 111, 422);
INSERT INTO public.europe_data VALUES (4285, 1512, 49798, 215.3, 71, 422);
INSERT INTO public.europe_data VALUES (4286, 0, 4, 3.88, 11, 422);
INSERT INTO public.europe_data VALUES (4287, 6, 306, 17.75, 12, 422);
INSERT INTO public.europe_data VALUES (4288, 112, 8534, 312.13, 72, 422);
INSERT INTO public.europe_data VALUES (4289, 1, 425, 4.14, 13, 422);
INSERT INTO public.europe_data VALUES (4290, 26, 1569, 83.66, 156, 422);
INSERT INTO public.europe_data VALUES (4291, 7, 375, 6.27, 73, 422);
INSERT INTO public.europe_data VALUES (4292, 0, 65, 61.19, 74, 422);
INSERT INTO public.europe_data VALUES (4293, 0, 17, 4.45, 157, 422);
INSERT INTO public.europe_data VALUES (4294, 20, 8032, 111, 158, 422);
INSERT INTO public.europe_data VALUES (4295, 5, 180, 0.4, 14, 422);
INSERT INTO public.europe_data VALUES (4296, 2, 1669, 43.33, 159, 422);
INSERT INTO public.europe_data VALUES (4297, 0, 7, 1.03, 15, 422);
INSERT INTO public.europe_data VALUES (4298, 0, 4, 5.57, 75, 422);
INSERT INTO public.europe_data VALUES (4299, 123, 4327, 87.71, 76, 422);
INSERT INTO public.europe_data VALUES (4300, 379, 8810, 28.47, 77, 422);
INSERT INTO public.europe_data VALUES (4301, 118, 1146, 2.27, 16, 422);
INSERT INTO public.europe_data VALUES (4302, 24, 701, 19.83, 78, 422);
INSERT INTO public.europe_data VALUES (4303, 0, 24, 4.06, 17, 422);
INSERT INTO public.europe_data VALUES (4304, 0, 31, 1.23, 18, 422);
INSERT INTO public.europe_data VALUES (4305, 0, 161, 22.87, 160, 422);
INSERT INTO public.europe_data VALUES (4306, 4, 222, 44.77, 19, 422);
INSERT INTO public.europe_data VALUES (4307, 95, 5629, 11.76, 20, 422);
INSERT INTO public.europe_data VALUES (4308, 0, 0, 0, 79, 422);
INSERT INTO public.europe_data VALUES (4309, 0, 10, 24.65, 161, 422);
INSERT INTO public.europe_data VALUES (4310, 0, 1, 0.45, 203, 422);
INSERT INTO public.europe_data VALUES (4311, 1, 289, 9.12, 162, 422);
INSERT INTO public.europe_data VALUES (4312, 215, 56317, 153.93, 163, 422);
INSERT INTO public.europe_data VALUES (4313, 2, 197, 168.64, 204, 422);
INSERT INTO public.europe_data VALUES (4314, 0, 42, 6.35, 21, 422);
INSERT INTO public.europe_data VALUES (4315, 4, 208, 18.83, 22, 422);
INSERT INTO public.europe_data VALUES (4316, 0, 752, 22.64, 164, 422);
INSERT INTO public.europe_data VALUES (4317, 25, 9556, 21.65, 165, 422);
INSERT INTO public.europe_data VALUES (4318, 3, 657, 4.04, 23, 422);
INSERT INTO public.europe_data VALUES (4319, 0, 15, 133.51, 166, 422);
INSERT INTO public.europe_data VALUES (4320, 21, 1716, 28.96, 167, 422);
INSERT INTO public.europe_data VALUES (4321, 0, 0, 0, 80, 422);
INSERT INTO public.europe_data VALUES (4322, 0, 0, 0, 81, 422);
INSERT INTO public.europe_data VALUES (4323, 11, 272, 325.17, 205, 422);
INSERT INTO public.europe_data VALUES (4324, 105, 4226, 45.49, 82, 422);
INSERT INTO public.europe_data VALUES (4325, 0, 1, 1.55, 168, 422);
INSERT INTO public.europe_data VALUES (4326, 2, 298, 5.08, 24, 422);
INSERT INTO public.europe_data VALUES (4327, 1, 30, 3.64, 25, 422);
INSERT INTO public.europe_data VALUES (4328, 10, 385, 79.08, 83, 422);
INSERT INTO public.europe_data VALUES (4329, 5, 133, 2.52, 84, 422);
INSERT INTO public.europe_data VALUES (4330, 0, 0, 0, 169, 422);
INSERT INTO public.europe_data VALUES (4331, 72, 3025, 78.13, 85, 422);
INSERT INTO public.europe_data VALUES (4332, 13, 3922, 64.96, 170, 422);
INSERT INTO public.europe_data VALUES (4333, 0, 24, 16.81, 171, 422);
INSERT INTO public.europe_data VALUES (4334, 8080, 641814, 89.66, 112, 422);
INSERT INTO public.europe_data VALUES (4335, 698, 24273, 17.12, 113, 422);
INSERT INTO public.europe_data VALUES (4336, 864, 15371, 34.32, 114, 422);
INSERT INTO public.europe_data VALUES (4337, 502, 29939, 150.43, 115, 422);
INSERT INTO public.europe_data VALUES (4338, 7, 1313, 45.37, 172, 422);
INSERT INTO public.europe_data VALUES (4339, 0, 0, 1.18, 173, 422);
INSERT INTO public.europe_data VALUES (4340, 100, 25952, 499.76, 116, 422);
INSERT INTO public.europe_data VALUES (4341, 69, 10119, 32.36, 174, 422);
INSERT INTO public.europe_data VALUES (4342, 9, 668, 47.96, 86, 422);
INSERT INTO public.europe_data VALUES (4343, 79, 3801, 6.14, 117, 422);
INSERT INTO public.europe_data VALUES (4344, 0, -4, 5.57, 175, 422);
INSERT INTO public.europe_data VALUES (4345, 8, 903, 13.34, 118, 422);
INSERT INTO public.europe_data VALUES (4346, 60, 2390, 31.48, 119, 422);
INSERT INTO public.europe_data VALUES (4347, 25, 1054, 3.99, 26, 422);
INSERT INTO public.europe_data VALUES (4348, 33, 518, 72.45, 176, 422);
INSERT INTO public.europe_data VALUES (4349, 16, 5182, 240.74, 120, 422);
INSERT INTO public.europe_data VALUES (4350, 3, 477, 16.05, 121, 422);
INSERT INTO public.europe_data VALUES (4351, 0, 1, 0.01, 122, 422);
INSERT INTO public.europe_data VALUES (4352, 0, 46, 4.22, 177, 422);
INSERT INTO public.europe_data VALUES (4353, 50, 3884, 108.52, 123, 422);
INSERT INTO public.europe_data VALUES (4354, 2, 97, 8.42, 27, 422);
INSERT INTO public.europe_data VALUES (4355, 0, 12, 0.3, 28, 422);
INSERT INTO public.europe_data VALUES (4356, 77, 5032, 138.08, 29, 422);
INSERT INTO public.europe_data VALUES (4357, 0, 3, 7.82, 178, 422);
INSERT INTO public.europe_data VALUES (4358, 1, 252, 16.5, 179, 422);
INSERT INTO public.europe_data VALUES (4359, 0, 298, 92.69, 180, 422);
INSERT INTO public.europe_data VALUES (4360, 11, 438, 3.39, 30, 422);
INSERT INTO public.europe_data VALUES (4361, 2, 76, 0.83, 31, 422);
INSERT INTO public.europe_data VALUES (4362, 0, 518, 1.82, 124, 422);
INSERT INTO public.europe_data VALUES (4363, 3, 589, 283.64, 125, 422);
INSERT INTO public.europe_data VALUES (4364, 1, 82, 0.77, 32, 422);
INSERT INTO public.europe_data VALUES (4365, 1, 329, 105.56, 181, 422);
INSERT INTO public.europe_data VALUES (4366, 1, 142, 5.61, 33, 422);
INSERT INTO public.europe_data VALUES (4367, 0, 5, 1.18, 34, 422);
INSERT INTO public.europe_data VALUES (4368, 3263, 33735, 55.6, 87, 422);
INSERT INTO public.europe_data VALUES (4369, 60, 3181, 155.27, 182, 422);
INSERT INTO public.europe_data VALUES (4370, 0, 23, 120.9, 183, 422);
INSERT INTO public.europe_data VALUES (4371, 0, 1, 0.31, 126, 422);
INSERT INTO public.europe_data VALUES (4372, 12, 1159, 308.91, 184, 422);
INSERT INTO public.europe_data VALUES (4373, 0, 0, 0, 88, 422);
INSERT INTO public.europe_data VALUES (4374, 217, 14292, 69.33, 35, 422);
INSERT INTO public.europe_data VALUES (4375, 8, 825, 4.77, 36, 422);
INSERT INTO public.europe_data VALUES (4376, 16, 1551, 4.12, 127, 422);
INSERT INTO public.europe_data VALUES (4377, 12, 1034, 94.37, 37, 422);
INSERT INTO public.europe_data VALUES (4378, 56, 7902, 54.52, 128, 422);
INSERT INTO public.europe_data VALUES (4379, 11, 7308, 69.16, 185, 422);
INSERT INTO public.europe_data VALUES (4380, 0, 0, 1.06, 208, 422);
INSERT INTO public.europe_data VALUES (4381, 0, 22, 1.25, 209, 422);
INSERT INTO public.europe_data VALUES (4382, 3, 150, 4.95, 89, 422);
INSERT INTO public.europe_data VALUES (4383, 0, 3, 0.02, 38, 422);
INSERT INTO public.europe_data VALUES (4384, 25, 1251, 1.19, 39, 422);
INSERT INTO public.europe_data VALUES (4385, 40, 932, 85.07, 186, 422);
INSERT INTO public.europe_data VALUES (4386, 0, 2, 6.99, 210, 422);
INSERT INTO public.europe_data VALUES (4387, 1, 746, 24.83, 187, 422);
INSERT INTO public.europe_data VALUES (4388, 52, 2674, 84.46, 129, 422);
INSERT INTO public.europe_data VALUES (4389, 38, 3117, 2.85, 130, 422);
INSERT INTO public.europe_data VALUES (4390, 47, 5498, 209.72, 131, 422);
INSERT INTO public.europe_data VALUES (4391, 80, 4702, 227.96, 90, 422);
INSERT INTO public.europe_data VALUES (4392, 1, 14, 0.59, 211, 422);
INSERT INTO public.europe_data VALUES (4393, 90, 5331, 150.78, 91, 422);
INSERT INTO public.europe_data VALUES (4394, 872, 39642, 253.62, 92, 422);
INSERT INTO public.europe_data VALUES (4395, 496, 23851, 40.53, 132, 422);
INSERT INTO public.europe_data VALUES (4396, 68, 3328, 19.18, 188, 422);
INSERT INTO public.europe_data VALUES (4397, 27, 3725, 60.48, 189, 422);
INSERT INTO public.europe_data VALUES (4398, 62, 2847, 154.5, 93, 422);
INSERT INTO public.europe_data VALUES (4399, 2, 1645, 111.76, 133, 422);
INSERT INTO public.europe_data VALUES (4400, 270, 8481, 86.07, 190, 422);
INSERT INTO public.europe_data VALUES (4401, 758, 37306, 49.69, 191, 422);
INSERT INTO public.europe_data VALUES (4402, 3, 217, 4.52, 40, 422);
INSERT INTO public.europe_data VALUES (4403, 0, 0, 0, 94, 422);
INSERT INTO public.europe_data VALUES (4404, 0, 1, 0.55, 95, 422);
INSERT INTO public.europe_data VALUES (4405, 0, 3, 3.62, 96, 422);
INSERT INTO public.europe_data VALUES (4406, 0, 6, 34.83, 192, 422);
INSERT INTO public.europe_data VALUES (4407, 0, 8, 4.65, 41, 422);
INSERT INTO public.europe_data VALUES (4408, 187, 4824, 31.6, 134, 422);
INSERT INTO public.europe_data VALUES (4409, 7, 293, 4.44, 42, 422);
INSERT INTO public.europe_data VALUES (4410, 9, 503, 14.98, 193, 422);
INSERT INTO public.europe_data VALUES (4411, 0, 2, 3.07, 43, 422);
INSERT INTO public.europe_data VALUES (4412, 1, 55, 1.11, 44, 422);
INSERT INTO public.europe_data VALUES (4413, 0, 384, 10.94, 135, 422);
INSERT INTO public.europe_data VALUES (4414, 0, 38, 202.88, 97, 422);
INSERT INTO public.europe_data VALUES (4415, 1, 918, 30.38, 194, 422);
INSERT INTO public.europe_data VALUES (4416, 1, 528, 40.22, 195, 422);
INSERT INTO public.europe_data VALUES (4417, 1, 27, 0.51, 45, 422);
INSERT INTO public.europe_data VALUES (4418, 558, 11276, 42.24, 46, 422);
INSERT INTO public.europe_data VALUES (4419, 27, 989, 4.56, 136, 422);
INSERT INTO public.europe_data VALUES (4420, 1, 34, 0.53, 47, 422);
INSERT INTO public.europe_data VALUES (4421, 332, 68181, 278.82, 196, 422);
INSERT INTO public.europe_data VALUES (4422, 0, 111, 1.04, 137, 422);
INSERT INTO public.europe_data VALUES (4423, 2, 63, 0.66, 48, 422);
INSERT INTO public.europe_data VALUES (4424, 8, 236, 98.56, 98, 422);
INSERT INTO public.europe_data VALUES (4425, 13, 1592, 28.58, 197, 422);
INSERT INTO public.europe_data VALUES (4426, 14, 2775, 60.41, 198, 422);
INSERT INTO public.europe_data VALUES (4427, 21, 369, 4.9, 138, 422);
INSERT INTO public.europe_data VALUES (4428, 0, 5, 0.04, 139, 422);
INSERT INTO public.europe_data VALUES (4429, 2, 257, 5.35, 140, 422);
INSERT INTO public.europe_data VALUES (4430, 0, 30, 0.09, 141, 422);
INSERT INTO public.europe_data VALUES (4431, 0, 0, 0, 142, 422);
INSERT INTO public.europe_data VALUES (4432, 5, 84, 2.18, 49, 422);
INSERT INTO public.europe_data VALUES (4433, 19, 792, 97.42, 99, 422);
INSERT INTO public.europe_data VALUES (4434, 14, 1859, 25.23, 50, 422);
INSERT INTO public.europe_data VALUES (4435, 383, 58466, 142.48, 199, 422);
INSERT INTO public.europe_data VALUES (4436, 0, 48, 363.93, 100, 422);
INSERT INTO public.europe_data VALUES (4437, 14, 1132, 4.23, 51, 422);
INSERT INTO public.europe_data VALUES (4438, 367, 18441, 80.15, 200, 422);
INSERT INTO public.europe_data VALUES (4439, 11, 5505, 100.29, 143, 422);
INSERT INTO public.europe_data VALUES (4440, 77, 21352, 51.07, 201, 422);
INSERT INTO public.europe_data VALUES (4441, 0, 0, 0, 52, 422);
INSERT INTO public.europe_data VALUES (4442, 5138, 243558, 158.88, 101, 422);
INSERT INTO public.europe_data VALUES (4443, 2, 39, 82.23, 102, 422);
INSERT INTO public.europe_data VALUES (4444, 0, 129, 6.44, 103, 422);
INSERT INTO public.europe_data VALUES (4445, 44, 3845, 18.1, 144, 422);
INSERT INTO public.europe_data VALUES (4446, 57, 7251, 51.45, 104, 422);
INSERT INTO public.europe_data VALUES (4447, 0, 14, 0.02, 145, 422);
INSERT INTO public.europe_data VALUES (4448, 0, 0, 0, 53, 422);
INSERT INTO public.europe_data VALUES (4449, 11, 26, 0.21, 146, 422);
INSERT INTO public.europe_data VALUES (4450, 17, 763, 8.48, 54, 422);
INSERT INTO public.europe_data VALUES (4451, 17, 549, 7.61, 55, 422);
INSERT INTO public.europe_data VALUES (4452, 10, 236, 1.05, 105, 423);
INSERT INTO public.europe_data VALUES (4453, 36, 875, 63.86, 147, 423);
INSERT INTO public.europe_data VALUES (4454, 55, 2218, 11.39, 1, 423);
INSERT INTO public.europe_data VALUES (4455, 0, 91, 223.16, 148, 423);
INSERT INTO public.europe_data VALUES (4456, 10, 311, 2.4, 2, 423);
INSERT INTO public.europe_data VALUES (4457, 0, 0, 0, 56, 423);
INSERT INTO public.europe_data VALUES (4458, 0, 1, 1.03, 57, 423);
INSERT INTO public.europe_data VALUES (4459, 1406, 70567, 301.48, 58, 423);
INSERT INTO public.europe_data VALUES (4460, 20, 1033, 67.32, 149, 423);
INSERT INTO public.europe_data VALUES (4461, 4, 452, 828.71, 59, 423);
INSERT INTO public.europe_data VALUES (4462, 142, 609, 5.82, 202, 423);
INSERT INTO public.europe_data VALUES (4463, 3, 1976, 44.64, 150, 423);
INSERT INTO public.europe_data VALUES (4464, 17, 1020, 20.45, 151, 423);
INSERT INTO public.europe_data VALUES (4465, 15, 379, 200.52, 60, 423);
INSERT INTO public.europe_data VALUES (4466, 9, 3197, 349.33, 106, 423);
INSERT INTO public.europe_data VALUES (4467, 201, 14335, 18.74, 107, 423);
INSERT INTO public.europe_data VALUES (4468, 0, 6, 6.27, 61, 423);
INSERT INTO public.europe_data VALUES (4469, 35, 1172, 25.3, 152, 423);
INSERT INTO public.europe_data VALUES (4470, 17, 3655, 59.15, 153, 423);
INSERT INTO public.europe_data VALUES (4471, 2, 267, 147.3, 62, 423);
INSERT INTO public.europe_data VALUES (4472, 0, 68, 0.83, 3, 423);
INSERT INTO public.europe_data VALUES (4473, 0, 6, 12.8, 63, 423);
INSERT INTO public.europe_data VALUES (4474, 0, 6, 9.83, 108, 423);
INSERT INTO public.europe_data VALUES (4475, 2042, 4801, 100.93, 64, 423);
INSERT INTO public.europe_data VALUES (4476, 0, 3, 19.24, 65, 423);
INSERT INTO public.europe_data VALUES (4477, 47, 1353, 98.21, 154, 423);
INSERT INTO public.europe_data VALUES (4478, 2, 369, 30.13, 4, 423);
INSERT INTO public.europe_data VALUES (4479, 5822, 275210, 251.95, 66, 423);
INSERT INTO public.europe_data VALUES (4480, 0, 26, 139.85, 67, 423);
INSERT INTO public.europe_data VALUES (4481, 0, 1, 0.46, 109, 423);
INSERT INTO public.europe_data VALUES (4482, 58, 860, 25.19, 155, 423);
INSERT INTO public.europe_data VALUES (4483, 0, 84, 0.61, 5, 423);
INSERT INTO public.europe_data VALUES (4484, 0, 17, 0.29, 6, 423);
INSERT INTO public.europe_data VALUES (4485, 0, 0, 0.01, 110, 423);
INSERT INTO public.europe_data VALUES (4486, 3, 462, 3.25, 7, 423);
INSERT INTO public.europe_data VALUES (4487, 28, 3955, 18.71, 68, 423);
INSERT INTO public.europe_data VALUES (4488, 2, 478, 149.29, 8, 423);
INSERT INTO public.europe_data VALUES (4489, 0, 0, 0, 69, 423);
INSERT INTO public.europe_data VALUES (4490, 1, 29, 1.05, 9, 423);
INSERT INTO public.europe_data VALUES (4491, 2, 27, 0.33, 10, 423);
INSERT INTO public.europe_data VALUES (4492, 348, 12536, 131.09, 70, 423);
INSERT INTO public.europe_data VALUES (4493, 8, 163, 0.03, 111, 423);
INSERT INTO public.europe_data VALUES (4494, 2048, 58583, 249.06, 71, 423);
INSERT INTO public.europe_data VALUES (4495, 0, 29, 4.11, 11, 423);
INSERT INTO public.europe_data VALUES (4496, 4, 649, 14.46, 12, 423);
INSERT INTO public.europe_data VALUES (4497, 60, 7221, 259.53, 72, 423);
INSERT INTO public.europe_data VALUES (4498, 4, 640, 4.34, 13, 423);
INSERT INTO public.europe_data VALUES (4499, 14, 1841, 92.95, 156, 423);
INSERT INTO public.europe_data VALUES (4500, 7, 336, 5.53, 73, 423);
INSERT INTO public.europe_data VALUES (4501, 0, 35, 29.98, 74, 423);
INSERT INTO public.europe_data VALUES (4502, 0, 22, 10.05, 157, 423);
INSERT INTO public.europe_data VALUES (4503, 13, 3789, 58.53, 158, 423);
INSERT INTO public.europe_data VALUES (4504, 2, 165, 0.44, 14, 423);
INSERT INTO public.europe_data VALUES (4505, 3, 847, 24.46, 159, 423);
INSERT INTO public.europe_data VALUES (4506, 1, 3, 0.62, 15, 423);
INSERT INTO public.europe_data VALUES (4507, 0, 0, 1.39, 75, 423);
INSERT INTO public.europe_data VALUES (4508, 164, 5092, 76.1, 76, 423);
INSERT INTO public.europe_data VALUES (4509, 3969, -3864, 11.6, 77, 423);
INSERT INTO public.europe_data VALUES (4510, 131, 1136, 2.62, 16, 423);
INSERT INTO public.europe_data VALUES (4511, 47, 579, 26.13, 78, 423);
INSERT INTO public.europe_data VALUES (4512, 0, 31, 3.39, 17, 423);
INSERT INTO public.europe_data VALUES (4513, 0, 12, 0.69, 18, 423);
INSERT INTO public.europe_data VALUES (4514, 0, 142, 18.34, 160, 423);
INSERT INTO public.europe_data VALUES (4515, 3, 292, 54.7, 19, 423);
INSERT INTO public.europe_data VALUES (4516, 125, 7550, 16.06, 20, 423);
INSERT INTO public.europe_data VALUES (4517, 0, 0, 0, 79, 423);
INSERT INTO public.europe_data VALUES (4518, 0, 2, 59.58, 161, 423);
INSERT INTO public.europe_data VALUES (4519, 0, 3, 0.34, 203, 423);
INSERT INTO public.europe_data VALUES (4520, 1, 214, 6.72, 162, 423);
INSERT INTO public.europe_data VALUES (4521, 95, 46834, 122.18, 163, 423);
INSERT INTO public.europe_data VALUES (4522, 0, 274, 163.99, 204, 423);
INSERT INTO public.europe_data VALUES (4523, 0, 96, 9.8, 21, 423);
INSERT INTO public.europe_data VALUES (4524, 3, 234, 32.37, 22, 423);
INSERT INTO public.europe_data VALUES (4525, 0, 153, 5.73, 164, 423);
INSERT INTO public.europe_data VALUES (4526, 27, 8418, 20.75, 165, 423);
INSERT INTO public.europe_data VALUES (4527, 7, 572, 4.18, 23, 423);
INSERT INTO public.europe_data VALUES (4528, 0, 30, 255.15, 166, 423);
INSERT INTO public.europe_data VALUES (4529, 22, 1390, 26.67, 167, 423);
INSERT INTO public.europe_data VALUES (4530, 0, 0, 0, 80, 423);
INSERT INTO public.europe_data VALUES (4531, 0, 0, 0, 81, 423);
INSERT INTO public.europe_data VALUES (4532, 4, 272, 477.6, 205, 423);
INSERT INTO public.europe_data VALUES (4533, 112, 3771, 54.01, 82, 423);
INSERT INTO public.europe_data VALUES (4534, 0, 0, 0, 168, 423);
INSERT INTO public.europe_data VALUES (4535, 2, 351, 5.91, 24, 423);
INSERT INTO public.europe_data VALUES (4536, 4, 40, 5, 25, 423);
INSERT INTO public.europe_data VALUES (4537, 9, 234, 65.54, 83, 423);
INSERT INTO public.europe_data VALUES (4538, 13, 151, 2.47, 84, 423);
INSERT INTO public.europe_data VALUES (4539, 0, 0, 0, 169, 423);
INSERT INTO public.europe_data VALUES (4540, 149, 4590, 105.2, 85, 423);
INSERT INTO public.europe_data VALUES (4541, 10, 2426, 33.07, 170, 423);
INSERT INTO public.europe_data VALUES (4542, 0, 36, 21.57, 171, 423);
INSERT INTO public.europe_data VALUES (4543, 7173, 583368, 80.38, 112, 423);
INSERT INTO public.europe_data VALUES (4544, 682, 22056, 14.99, 113, 423);
INSERT INTO public.europe_data VALUES (4545, 831, 13088, 33.47, 114, 423);
INSERT INTO public.europe_data VALUES (4546, 553, 29193, 142.53, 115, 423);
INSERT INTO public.europe_data VALUES (4547, 0, 912, 34.73, 172, 423);
INSERT INTO public.europe_data VALUES (4548, 0, 1, 1.18, 173, 423);
INSERT INTO public.europe_data VALUES (4549, 100, 16624, 322.71, 116, 423);
INSERT INTO public.europe_data VALUES (4550, 64, 9416, 30.3, 174, 423);
INSERT INTO public.europe_data VALUES (4551, 12, 746, 53.39, 86, 423);
INSERT INTO public.europe_data VALUES (4552, 84, 3991, 7.96, 117, 423);
INSERT INTO public.europe_data VALUES (4553, 0, 10, 19.48, 175, 423);
INSERT INTO public.europe_data VALUES (4554, 1, 445, 7.94, 118, 423);
INSERT INTO public.europe_data VALUES (4555, 121, 3450, 35.91, 119, 423);
INSERT INTO public.europe_data VALUES (4556, 23, 1046, 5.21, 26, 423);
INSERT INTO public.europe_data VALUES (4557, 47, 785, 92.91, 176, 423);
INSERT INTO public.europe_data VALUES (4558, 14, 4946, 215.21, 120, 423);
INSERT INTO public.europe_data VALUES (4559, 2, 553, 20.65, 121, 423);
INSERT INTO public.europe_data VALUES (4560, 0, 0, 0, 122, 423);
INSERT INTO public.europe_data VALUES (4561, 1, 35, 4.74, 177, 423);
INSERT INTO public.europe_data VALUES (4562, 31, 3556, 120.12, 123, 423);
INSERT INTO public.europe_data VALUES (4563, 0, 82, 6.26, 27, 423);
INSERT INTO public.europe_data VALUES (4564, 0, 3, 0.43, 28, 423);
INSERT INTO public.europe_data VALUES (4565, 53, 4326, 107.89, 29, 423);
INSERT INTO public.europe_data VALUES (4566, 0, 0, 18.24, 178, 423);
INSERT INTO public.europe_data VALUES (4567, 0, 209, 16.03, 179, 423);
INSERT INTO public.europe_data VALUES (4568, 0, 271, -131.62, 180, 423);
INSERT INTO public.europe_data VALUES (4569, 9, 476, 3.68, 30, 423);
INSERT INTO public.europe_data VALUES (4570, 1, 78, 1.57, 31, 423);
INSERT INTO public.europe_data VALUES (4571, 2, 63, 0.41, 124, 423);
INSERT INTO public.europe_data VALUES (4572, 1, 917, 339.95, 125, 423);
INSERT INTO public.europe_data VALUES (4573, 1, 69, 0.7, 32, 423);
INSERT INTO public.europe_data VALUES (4574, 2, 192, 82.87, 181, 423);
INSERT INTO public.europe_data VALUES (4575, 1, 112, 5.5, 33, 423);
INSERT INTO public.europe_data VALUES (4576, 0, 10, 0.79, 34, 423);
INSERT INTO public.europe_data VALUES (4577, 3400, 37193, 58.71, 87, 423);
INSERT INTO public.europe_data VALUES (4578, 71, 3097, 156.28, 182, 423);
INSERT INTO public.europe_data VALUES (4579, 0, 17, 111.83, 183, 423);
INSERT INTO public.europe_data VALUES (4580, 0, 9, 0.37, 126, 423);
INSERT INTO public.europe_data VALUES (4581, 10, 763, 194.48, 184, 423);
INSERT INTO public.europe_data VALUES (4582, 0, 0, 0, 88, 423);
INSERT INTO public.europe_data VALUES (4583, 250, 10995, 54.96, 35, 423);
INSERT INTO public.europe_data VALUES (4584, 4, 623, 3.45, 36, 423);
INSERT INTO public.europe_data VALUES (4585, 2, 677, 1.85, 127, 423);
INSERT INTO public.europe_data VALUES (4586, 17, 1320, 113.49, 37, 423);
INSERT INTO public.europe_data VALUES (4587, 68, 7696, 50.06, 128, 423);
INSERT INTO public.europe_data VALUES (4588, 19, 4644, 47.59, 185, 423);
INSERT INTO public.europe_data VALUES (4589, 0, 3, 1.06, 208, 423);
INSERT INTO public.europe_data VALUES (4590, 2, 38, 1.94, 209, 423);
INSERT INTO public.europe_data VALUES (4591, 4, 174, 5.45, 89, 423);
INSERT INTO public.europe_data VALUES (4592, 0, 1, 0.02, 38, 423);
INSERT INTO public.europe_data VALUES (4593, 44, 1140, 1.38, 39, 423);
INSERT INTO public.europe_data VALUES (4594, 22, 835, 60.08, 186, 423);
INSERT INTO public.europe_data VALUES (4595, 0, 2, 6.99, 210, 423);
INSERT INTO public.europe_data VALUES (4596, 0, 577, 17.32, 187, 423);
INSERT INTO public.europe_data VALUES (4597, 51, 1528, 66.39, 129, 423);
INSERT INTO public.europe_data VALUES (4598, 51, 3054, 2.83, 130, 423);
INSERT INTO public.europe_data VALUES (4599, 37, 4949, 180.43, 131, 423);
INSERT INTO public.europe_data VALUES (4600, 91, 4978, 238.86, 90, 423);
INSERT INTO public.europe_data VALUES (4601, 0, 38, 1.09, 211, 423);
INSERT INTO public.europe_data VALUES (4602, 127, 5291, 131.35, 91, 423);
INSERT INTO public.europe_data VALUES (4603, 1050, 42811, 294.22, 92, 423);
INSERT INTO public.europe_data VALUES (4604, 355, 19969, 44.18, 132, 423);
INSERT INTO public.europe_data VALUES (4605, 87, 3954, 23.86, 188, 423);
INSERT INTO public.europe_data VALUES (4606, 21, 2490, 45.36, 189, 423);
INSERT INTO public.europe_data VALUES (4607, 43, 1685, 158.08, 93, 423);
INSERT INTO public.europe_data VALUES (4608, 6, 1520, 109, 133, 423);
INSERT INTO public.europe_data VALUES (4609, 315, 8229, 84.93, 190, 423);
INSERT INTO public.europe_data VALUES (4610, 727, 35179, 47.13, 191, 423);
INSERT INTO public.europe_data VALUES (4611, 3, 354, 10.18, 40, 423);
INSERT INTO public.europe_data VALUES (4612, 0, 0, 0, 94, 423);
INSERT INTO public.europe_data VALUES (4613, 0, 0, 0, 95, 423);
INSERT INTO public.europe_data VALUES (4614, 0, 1, 2.71, 96, 423);
INSERT INTO public.europe_data VALUES (4615, 0, 6, 17.42, 192, 423);
INSERT INTO public.europe_data VALUES (4616, 0, 2, 2.79, 41, 423);
INSERT INTO public.europe_data VALUES (4617, 211, 6006, 38.95, 134, 423);
INSERT INTO public.europe_data VALUES (4618, 6, 431, 6.37, 42, 423);
INSERT INTO public.europe_data VALUES (4619, 13, 540, 17.92, 193, 423);
INSERT INTO public.europe_data VALUES (4620, 0, 1, 5.12, 43, 423);
INSERT INTO public.europe_data VALUES (4621, 1, 32, 0.79, 44, 423);
INSERT INTO public.europe_data VALUES (4622, 0, 251, 11.53, 135, 423);
INSERT INTO public.europe_data VALUES (4623, 2, 48, 271.3, 97, 423);
INSERT INTO public.europe_data VALUES (4624, 4, 738, 23.08, 194, 423);
INSERT INTO public.europe_data VALUES (4625, 2, 309, 25.13, 195, 423);
INSERT INTO public.europe_data VALUES (4626, 0, 52, 0.6, 45, 423);
INSERT INTO public.europe_data VALUES (4627, 861, 13461, 49.09, 46, 423);
INSERT INTO public.europe_data VALUES (4628, 12, 1349, 7.09, 136, 423);
INSERT INTO public.europe_data VALUES (4629, 1, 25, 0.41, 47, 423);
INSERT INTO public.europe_data VALUES (4630, 422, 62691, 255.9, 196, 423);
INSERT INTO public.europe_data VALUES (4631, 0, 111, 0.8, 137, 423);
INSERT INTO public.europe_data VALUES (4632, 9, 218, 1.33, 48, 423);
INSERT INTO public.europe_data VALUES (4633, 18, 337, 127.12, 98, 423);
INSERT INTO public.europe_data VALUES (4634, 12, 1332, 24.75, 197, 423);
INSERT INTO public.europe_data VALUES (4635, 8, 2387, 52.56, 198, 423);
INSERT INTO public.europe_data VALUES (4636, 25, 468, 6.02, 138, 423);
INSERT INTO public.europe_data VALUES (4637, 0, 5, 0.03, 139, 423);
INSERT INTO public.europe_data VALUES (4638, 2, 242, 5.16, 140, 423);
INSERT INTO public.europe_data VALUES (4639, 0, 33, 0.07, 141, 423);
INSERT INTO public.europe_data VALUES (4640, 0, 0, 0.08, 142, 423);
INSERT INTO public.europe_data VALUES (4641, 5, 92, 2.61, 49, 423);
INSERT INTO public.europe_data VALUES (4642, 13, 567, 89.11, 99, 423);
INSERT INTO public.europe_data VALUES (4643, 17, 1091, 17.43, 50, 423);
INSERT INTO public.europe_data VALUES (4644, 347, 58370, 141.18, 199, 423);
INSERT INTO public.europe_data VALUES (4645, 2, 91, 562.92, 100, 423);
INSERT INTO public.europe_data VALUES (4646, 11, 739, 3.17, 51, 423);
INSERT INTO public.europe_data VALUES (4647, 284, 16820, 70.32, 200, 423);
INSERT INTO public.europe_data VALUES (4648, 6, 4294, 71.41, 143, 423);
INSERT INTO public.europe_data VALUES (4649, 52, 12685, 32.27, 201, 423);
INSERT INTO public.europe_data VALUES (4650, 0, 0, 0, 52, 423);
INSERT INTO public.europe_data VALUES (4651, 5872, 279258, 174.38, 101, 423);
INSERT INTO public.europe_data VALUES (4652, 3, 47, 188.37, 102, 423);
INSERT INTO public.europe_data VALUES (4653, 1, 94, 4.39, 103, 423);
INSERT INTO public.europe_data VALUES (4654, 33, 2124, 14.64, 144, 423);
INSERT INTO public.europe_data VALUES (4655, 47, 7421, 48.13, 104, 423);
INSERT INTO public.europe_data VALUES (4656, 3, 9, 0.03, 145, 423);
INSERT INTO public.europe_data VALUES (4657, 0, 0, 0, 53, 423);
INSERT INTO public.europe_data VALUES (4658, 8, 34, 0.26, 146, 423);
INSERT INTO public.europe_data VALUES (4659, 8, 751, 9.48, 54, 423);
INSERT INTO public.europe_data VALUES (4660, 11, 565, 7.15, 55, 423);
INSERT INTO public.europe_data VALUES (4661, 15, 163, 1.49, 105, 424);
INSERT INTO public.europe_data VALUES (4662, 30, 953, 69.87, 147, 424);
INSERT INTO public.europe_data VALUES (4663, 66, 2686, 12.92, 1, 424);
INSERT INTO public.europe_data VALUES (4664, 0, 79, 177.22, 148, 424);
INSERT INTO public.europe_data VALUES (4665, 11, 453, 2.34, 2, 424);
INSERT INTO public.europe_data VALUES (4666, 0, 0, 0, 56, 424);
INSERT INTO public.europe_data VALUES (4667, 0, 0, 1.03, 57, 424);
INSERT INTO public.europe_data VALUES (4668, 1553, 64437, 250.42, 58, 424);
INSERT INTO public.europe_data VALUES (4669, 25, 958, 70.56, 149, 424);
INSERT INTO public.europe_data VALUES (4670, 3, 429, 841.88, 59, 424);
INSERT INTO public.europe_data VALUES (4671, 109, 858, 9.45, 202, 424);
INSERT INTO public.europe_data VALUES (4672, 1, 1979, 43.4, 150, 424);
INSERT INTO public.europe_data VALUES (4673, 13, 1035, 20.8, 151, 424);
INSERT INTO public.europe_data VALUES (4674, 14, 402, 218.75, 60, 424);
INSERT INTO public.europe_data VALUES (4675, 5, 2536, 313.44, 106, 424);
INSERT INTO public.europe_data VALUES (4676, 307, 16224, 21.02, 107, 424);
INSERT INTO public.europe_data VALUES (4677, 0, 12, 7.66, 61, 424);
INSERT INTO public.europe_data VALUES (4678, 34, 1219, 22.97, 152, 424);
INSERT INTO public.europe_data VALUES (4679, 28, 3121, 57.39, 153, 424);
INSERT INTO public.europe_data VALUES (4680, 7, 308, 138.85, 62, 424);
INSERT INTO public.europe_data VALUES (4681, 1, 30, 0.69, 3, 424);
INSERT INTO public.europe_data VALUES (4682, 0, 2, 11.2, 63, 424);
INSERT INTO public.europe_data VALUES (4683, 0, 69, 10.88, 108, 424);
INSERT INTO public.europe_data VALUES (4684, 457, 6819, 135.71, 64, 424);
INSERT INTO public.europe_data VALUES (4685, 0, 2, 7.7, 65, 424);
INSERT INTO public.europe_data VALUES (4686, 63, 1889, 128.87, 154, 424);
INSERT INTO public.europe_data VALUES (4687, 3, 325, 18.19, 4, 424);
INSERT INTO public.europe_data VALUES (4688, 6084, 256528, 247.39, 66, 424);
INSERT INTO public.europe_data VALUES (4689, 0, 16, 93.23, 67, 424);
INSERT INTO public.europe_data VALUES (4690, 0, 1, 0.46, 109, 424);
INSERT INTO public.europe_data VALUES (4691, 68, 903, 26.07, 155, 424);
INSERT INTO public.europe_data VALUES (4692, 0, 40, 0.5, 5, 424);
INSERT INTO public.europe_data VALUES (4693, 0, 16, 0.28, 6, 424);
INSERT INTO public.europe_data VALUES (4694, 0, 1, 0.01, 110, 424);
INSERT INTO public.europe_data VALUES (4695, 3, 380, 2.6, 7, 424);
INSERT INTO public.europe_data VALUES (4696, 44, 3044, 15.65, 68, 424);
INSERT INTO public.europe_data VALUES (4697, 3, 343, 122.38, 8, 424);
INSERT INTO public.europe_data VALUES (4698, 0, 0, 3.08, 69, 424);
INSERT INTO public.europe_data VALUES (4699, 0, 21, 1.01, 9, 424);
INSERT INTO public.europe_data VALUES (4700, 1, 26, 0.35, 10, 424);
INSERT INTO public.europe_data VALUES (4701, 392, 12309, 126.78, 70, 424);
INSERT INTO public.europe_data VALUES (4702, 11, 200, 0.04, 111, 424);
INSERT INTO public.europe_data VALUES (4703, 2048, 66791, 277.33, 71, 424);
INSERT INTO public.europe_data VALUES (4704, 0, 6, 2.12, 11, 424);
INSERT INTO public.europe_data VALUES (4705, 1, 129, 2.68, 12, 424);
INSERT INTO public.europe_data VALUES (4706, 63, 5879, 222.56, 72, 424);
INSERT INTO public.europe_data VALUES (4707, 2, 477, 3.59, 13, 424);
INSERT INTO public.europe_data VALUES (4708, 13, 1948, 87.14, 156, 424);
INSERT INTO public.europe_data VALUES (4709, 3, 291, 5.8, 73, 424);
INSERT INTO public.europe_data VALUES (4710, 0, 14, 14.07, 74, 424);
INSERT INTO public.europe_data VALUES (4711, 0, 66, 17.7, 157, 424);
INSERT INTO public.europe_data VALUES (4712, 11, 2444, 40.89, 158, 424);
INSERT INTO public.europe_data VALUES (4713, 7, 215, 0.43, 14, 424);
INSERT INTO public.europe_data VALUES (4714, 3, 573, 18.65, 159, 424);
INSERT INTO public.europe_data VALUES (4715, 0, 3, 1.64, 15, 424);
INSERT INTO public.europe_data VALUES (4716, 0, 1, 2.79, 75, 424);
INSERT INTO public.europe_data VALUES (4717, 114, 3080, 73.86, 76, 424);
INSERT INTO public.europe_data VALUES (4718, 245, 5879, 69.68, 77, 424);
INSERT INTO public.europe_data VALUES (4719, 156, 1490, 2.24, 16, 424);
INSERT INTO public.europe_data VALUES (4720, 48, 1107, 43.65, 78, 424);
INSERT INTO public.europe_data VALUES (4721, 0, 15, 8.85, 17, 424);
INSERT INTO public.europe_data VALUES (4722, 0, 12, 0.94, 18, 424);
INSERT INTO public.europe_data VALUES (4723, 1, 101, 13.81, 160, 424);
INSERT INTO public.europe_data VALUES (4724, 6, 336, 62.88, 19, 424);
INSERT INTO public.europe_data VALUES (4725, 115, 10451, 18.96, 20, 424);
INSERT INTO public.europe_data VALUES (4726, 0, 0, 0, 79, 424);
INSERT INTO public.europe_data VALUES (4727, 0, 27, 80.12, 161, 424);
INSERT INTO public.europe_data VALUES (4728, 1, 0, 0, 203, 424);
INSERT INTO public.europe_data VALUES (4729, 1, 157, 6.27, 162, 424);
INSERT INTO public.europe_data VALUES (4730, 93, 35044, 88.65, 163, 424);
INSERT INTO public.europe_data VALUES (4731, 0, 184, 81.64, 204, 424);
INSERT INTO public.europe_data VALUES (4732, 0, 117, 12.89, 21, 424);
INSERT INTO public.europe_data VALUES (4733, 12, 526, 46.47, 22, 424);
INSERT INTO public.europe_data VALUES (4734, 2, 76, 3.65, 164, 424);
INSERT INTO public.europe_data VALUES (4735, 26, 8806, 22.12, 165, 424);
INSERT INTO public.europe_data VALUES (4736, 15, 700, 5.5, 23, 424);
INSERT INTO public.europe_data VALUES (4737, 0, 56, 207.68, 166, 424);
INSERT INTO public.europe_data VALUES (4738, 20, 1470, 28.52, 167, 424);
INSERT INTO public.europe_data VALUES (4739, 0, 0, 0, 80, 424);
INSERT INTO public.europe_data VALUES (4740, 0, 0, 0, 81, 424);
INSERT INTO public.europe_data VALUES (4741, 3, 527, 471.62, 205, 424);
INSERT INTO public.europe_data VALUES (4742, 146, 5724, 64.56, 82, 424);
INSERT INTO public.europe_data VALUES (4743, 0, 0, 0, 168, 424);
INSERT INTO public.europe_data VALUES (4744, 6, 404, 6.96, 24, 424);
INSERT INTO public.europe_data VALUES (4745, 1, 56, 4.58, 25, 424);
INSERT INTO public.europe_data VALUES (4746, 6, 279, 67.07, 83, 424);
INSERT INTO public.europe_data VALUES (4747, 5, 127, 2.93, 84, 424);
INSERT INTO public.europe_data VALUES (4748, 0, 0, 0, 169, 424);
INSERT INTO public.europe_data VALUES (4749, 204, 5663, 99.24, 85, 424);
INSERT INTO public.europe_data VALUES (4750, 1, 806, 10.69, 170, 424);
INSERT INTO public.europe_data VALUES (4751, 0, 41, 26.33, 171, 424);
INSERT INTO public.europe_data VALUES (4752, 6927, 514897, 71.25, 112, 424);
INSERT INTO public.europe_data VALUES (4753, 663, 18518, 12.01, 113, 424);
INSERT INTO public.europe_data VALUES (4754, 819, 14665, 36.62, 114, 424);
INSERT INTO public.europe_data VALUES (4755, 531, 26836, 138, 115, 424);
INSERT INTO public.europe_data VALUES (4756, 0, 791, 30.65, 172, 424);
INSERT INTO public.europe_data VALUES (4757, 0, 0, 0, 173, 424);
INSERT INTO public.europe_data VALUES (4758, 85, 10869, 250.49, 116, 424);
INSERT INTO public.europe_data VALUES (4759, 40, 8873, 23.7, 174, 424);
INSERT INTO public.europe_data VALUES (4760, 5, 828, 42.19, 86, 424);
INSERT INTO public.europe_data VALUES (4761, 99, 6111, 10.18, 117, 424);
INSERT INTO public.europe_data VALUES (4762, 0, 11, 17.63, 175, 424);
INSERT INTO public.europe_data VALUES (4763, 3, 357, 5.82, 118, 424);
INSERT INTO public.europe_data VALUES (4764, 108, 3211, 48.7, 119, 424);
INSERT INTO public.europe_data VALUES (4765, 26, 1693, 7.49, 26, 424);
INSERT INTO public.europe_data VALUES (4766, 49, 886, 106.64, 176, 424);
INSERT INTO public.europe_data VALUES (4767, 15, 4108, 200.4, 120, 424);
INSERT INTO public.europe_data VALUES (4768, 1, 772, 29.72, 121, 424);
INSERT INTO public.europe_data VALUES (4769, 0, 0, 0.03, 122, 424);
INSERT INTO public.europe_data VALUES (4770, 1, 56, 3.7, 177, 424);
INSERT INTO public.europe_data VALUES (4771, 39, 4679, 116.53, 123, 424);
INSERT INTO public.europe_data VALUES (4772, 1, 51, 5.65, 27, 424);
INSERT INTO public.europe_data VALUES (4773, 0, 18, 0.95, 28, 424);
INSERT INTO public.europe_data VALUES (4774, 44, 2986, 83.88, 29, 424);
INSERT INTO public.europe_data VALUES (4775, 0, 7, 39.08, 178, 424);
INSERT INTO public.europe_data VALUES (4776, 2, 239, 16.39, 179, 424);
INSERT INTO public.europe_data VALUES (4777, 0, -1079, -132.6, 180, 424);
INSERT INTO public.europe_data VALUES (4778, 13, 516, 3.77, 30, 424);
INSERT INTO public.europe_data VALUES (4779, 8, 214, 2.49, 31, 424);
INSERT INTO public.europe_data VALUES (4780, 1, 67, 0.42, 124, 424);
INSERT INTO public.europe_data VALUES (4781, 2, 888, 354.45, 125, 424);
INSERT INTO public.europe_data VALUES (4782, 1, 68, 0.81, 32, 424);
INSERT INTO public.europe_data VALUES (4783, 2, 217, 103.74, 181, 424);
INSERT INTO public.europe_data VALUES (4784, 1, 137, 7.09, 33, 424);
INSERT INTO public.europe_data VALUES (4785, 0, 0, 0, 34, 424);
INSERT INTO public.europe_data VALUES (4786, 3678, 37703, 58.3, 87, 424);
INSERT INTO public.europe_data VALUES (4787, 52, 3222, 161.18, 182, 424);
INSERT INTO public.europe_data VALUES (4788, 0, 20, 96.72, 183, 424);
INSERT INTO public.europe_data VALUES (4789, 0, 3, 0.09, 126, 424);
INSERT INTO public.europe_data VALUES (4790, 14, 447, 121.35, 184, 424);
INSERT INTO public.europe_data VALUES (4791, 0, 0, 0, 88, 424);
INSERT INTO public.europe_data VALUES (4792, 223, 9050, 51.85, 35, 424);
INSERT INTO public.europe_data VALUES (4793, 3, 426, 3.18, 36, 424);
INSERT INTO public.europe_data VALUES (4794, 0, 324, 0.76, 127, 424);
INSERT INTO public.europe_data VALUES (4795, 20, 1511, 128.72, 37, 424);
INSERT INTO public.europe_data VALUES (4796, 72, 6626, 41.6, 128, 424);
INSERT INTO public.europe_data VALUES (4797, 24, 3581, 41.24, 185, 424);
INSERT INTO public.europe_data VALUES (4798, 0, 0, 0, 208, 424);
INSERT INTO public.europe_data VALUES (4799, 0, 55, 2.24, 209, 424);
INSERT INTO public.europe_data VALUES (4800, 4, 183, 5.79, 89, 424);
INSERT INTO public.europe_data VALUES (4801, 0, 4, 0.04, 38, 424);
INSERT INTO public.europe_data VALUES (4802, 11, 1638, 2.39, 39, 424);
INSERT INTO public.europe_data VALUES (4803, 21, 413, 57.19, 186, 424);
INSERT INTO public.europe_data VALUES (4804, 0, 2, 10.49, 210, 424);
INSERT INTO public.europe_data VALUES (4805, 0, 346, 13.01, 187, 424);
INSERT INTO public.europe_data VALUES (4806, 68, 1775, 49.41, 129, 424);
INSERT INTO public.europe_data VALUES (4807, 59, 3084, 3.06, 130, 424);
INSERT INTO public.europe_data VALUES (4808, 23, 4039, 143.09, 131, 424);
INSERT INTO public.europe_data VALUES (4809, 103, 5165, 238.44, 90, 424);
INSERT INTO public.europe_data VALUES (4810, 1, 58, 1.55, 211, 424);
INSERT INTO public.europe_data VALUES (4811, 103, 3962, 105.1, 91, 424);
INSERT INTO public.europe_data VALUES (4812, 1125, 52840, 342.11, 92, 424);
INSERT INTO public.europe_data VALUES (4813, 522, 27795, 51.93, 132, 424);
INSERT INTO public.europe_data VALUES (4814, 78, 5108, 26.82, 188, 424);
INSERT INTO public.europe_data VALUES (4815, 23, 2171, 35.67, 189, 424);
INSERT INTO public.europe_data VALUES (4816, 44, 2952, 233.24, 93, 424);
INSERT INTO public.europe_data VALUES (4817, 4, 1567, 123.41, 133, 424);
INSERT INTO public.europe_data VALUES (4818, 306, 8260, 84.08, 190, 424);
INSERT INTO public.europe_data VALUES (4819, 710, 33577, 46.25, 191, 424);
INSERT INTO public.europe_data VALUES (4820, 4, 931, 12.41, 40, 424);
INSERT INTO public.europe_data VALUES (4821, 0, 0, 0, 94, 424);
INSERT INTO public.europe_data VALUES (4822, 0, 0, 0.55, 95, 424);
INSERT INTO public.europe_data VALUES (4823, 0, 2, 2.71, 96, 424);
INSERT INTO public.europe_data VALUES (4824, 0, 0, 0, 192, 424);
INSERT INTO public.europe_data VALUES (4825, 0, 4, 5.12, 41, 424);
INSERT INTO public.europe_data VALUES (4826, 221, 7342, 47.5, 134, 424);
INSERT INTO public.europe_data VALUES (4827, 15, 607, 8.55, 42, 424);
INSERT INTO public.europe_data VALUES (4828, 13, 708, 24.17, 193, 424);
INSERT INTO public.europe_data VALUES (4829, 0, 4, 9.21, 43, 424);
INSERT INTO public.europe_data VALUES (4830, 1, 30, 0.84, 44, 424);
INSERT INTO public.europe_data VALUES (4831, 0, 418, 17.64, 135, 424);
INSERT INTO public.europe_data VALUES (4832, 0, 67, 344.43, 97, 424);
INSERT INTO public.europe_data VALUES (4833, 0, 520, 17.87, 194, 424);
INSERT INTO public.europe_data VALUES (4834, 1, 214, 21.58, 195, 424);
INSERT INTO public.europe_data VALUES (4835, 4, 41, 0.35, 45, 424);
INSERT INTO public.europe_data VALUES (4836, 969, 15283, 64.4, 46, 424);
INSERT INTO public.europe_data VALUES (4837, 15, 2282, 8.65, 136, 424);
INSERT INTO public.europe_data VALUES (4838, 0, 20, 0.27, 47, 424);
INSERT INTO public.europe_data VALUES (4839, 222, 57422, 221.1, 196, 424);
INSERT INTO public.europe_data VALUES (4840, 0, 59, 0.56, 137, 424);
INSERT INTO public.europe_data VALUES (4841, 8, 353, 1.82, 48, 424);
INSERT INTO public.europe_data VALUES (4842, 9, 402, 170.81, 98, 424);
INSERT INTO public.europe_data VALUES (4843, 10, 1200, 28.22, 197, 424);
INSERT INTO public.europe_data VALUES (4844, 5, 2104, 45.35, 198, 424);
INSERT INTO public.europe_data VALUES (4845, 24, 560, 6.01, 138, 424);
INSERT INTO public.europe_data VALUES (4846, 0, 1, 0.01, 139, 424);
INSERT INTO public.europe_data VALUES (4847, 2, 239, 5.2, 140, 424);
INSERT INTO public.europe_data VALUES (4848, 0, 15, 0.05, 141, 424);
INSERT INTO public.europe_data VALUES (4849, 0, 1, 0.15, 142, 424);
INSERT INTO public.europe_data VALUES (4850, 0, 119, 3.08, 49, 424);
INSERT INTO public.europe_data VALUES (4851, 7, 676, 81.08, 99, 424);
INSERT INTO public.europe_data VALUES (4852, 8, 947, 13.49, 50, 424);
INSERT INTO public.europe_data VALUES (4853, 205, 57407, 138.36, 199, 424);
INSERT INTO public.europe_data VALUES (4854, 1, 124, 547.21, 100, 424);
INSERT INTO public.europe_data VALUES (4855, 11, 665, 3.23, 51, 424);
INSERT INTO public.europe_data VALUES (4856, 256, 14116, 59.68, 200, 424);
INSERT INTO public.europe_data VALUES (4857, 7, 2683, 55.04, 143, 424);
INSERT INTO public.europe_data VALUES (4858, 70, 8825, 23.98, 201, 424);
INSERT INTO public.europe_data VALUES (4859, 0, 0, 0, 52, 424);
INSERT INTO public.europe_data VALUES (4860, 6263, 294552, 180.48, 101, 424);
INSERT INTO public.europe_data VALUES (4861, 3, 150, 375.79, 102, 424);
INSERT INTO public.europe_data VALUES (4862, 2, 58, 4.19, 103, 424);
INSERT INTO public.europe_data VALUES (4863, 44, 2705, 20.34, 144, 424);
INSERT INTO public.europe_data VALUES (4864, 52, 6304, 42.48, 104, 424);
INSERT INTO public.europe_data VALUES (4865, 5, 24, 0.08, 145, 424);
INSERT INTO public.europe_data VALUES (4866, 0, 0, 0, 53, 424);
INSERT INTO public.europe_data VALUES (4867, 17, 42, 0.29, 146, 424);
INSERT INTO public.europe_data VALUES (4868, 7, 943, 15.02, 54, 424);
INSERT INTO public.europe_data VALUES (4869, 41, 482, 7.86, 55, 424);
INSERT INTO public.europe_data VALUES (4870, 12, 403, 2.48, 105, 425);
INSERT INTO public.europe_data VALUES (4871, 22, 1047, 70.43, 147, 425);
INSERT INTO public.europe_data VALUES (4872, 65, 2877, 14.51, 1, 425);
INSERT INTO public.europe_data VALUES (4873, 0, 56, 116.83, 148, 425);
INSERT INTO public.europe_data VALUES (4874, 10, 292, 1.88, 2, 425);
INSERT INTO public.europe_data VALUES (4875, 0, 0, 0, 56, 425);
INSERT INTO public.europe_data VALUES (4876, 0, 1, 2.06, 57, 425);
INSERT INTO public.europe_data VALUES (4877, 1191, 47702, 212.12, 58, 425);
INSERT INTO public.europe_data VALUES (4878, 34, 1129, 80.53, 149, 425);
INSERT INTO public.europe_data VALUES (4879, 3, 466, 945.35, 59, 425);
INSERT INTO public.europe_data VALUES (4880, 106, 1524, 14.79, 202, 425);
INSERT INTO public.europe_data VALUES (4881, 4, 1866, 36.44, 150, 425);
INSERT INTO public.europe_data VALUES (4882, 12, 1055, 16.98, 151, 425);
INSERT INTO public.europe_data VALUES (4883, 11, 450, 222.6, 60, 425);
INSERT INTO public.europe_data VALUES (4884, 14, 2608, 306.31, 106, 425);
INSERT INTO public.europe_data VALUES (4885, 284, 18049, 22.69, 107, 425);
INSERT INTO public.europe_data VALUES (4886, 0, 10, 6.62, 61, 425);
INSERT INTO public.europe_data VALUES (4887, 32, 952, 17.12, 152, 425);
INSERT INTO public.europe_data VALUES (4888, 42, 3453, 62.89, 153, 425);
INSERT INTO public.europe_data VALUES (4889, 3, 234, 136.29, 62, 425);
INSERT INTO public.europe_data VALUES (4890, 0, 52, 1.52, 3, 425);
INSERT INTO public.europe_data VALUES (4891, 0, 5, 14.4, 63, 425);
INSERT INTO public.europe_data VALUES (4892, 0, 14, 5.9, 108, 425);
INSERT INTO public.europe_data VALUES (4893, 461, 8805, 166.33, 64, 425);
INSERT INTO public.europe_data VALUES (4894, 0, 0, 0, 65, 425);
INSERT INTO public.europe_data VALUES (4895, 60, 2365, 108.3, 154, 425);
INSERT INTO public.europe_data VALUES (4896, 0, 94, 17.32, 4, 425);
INSERT INTO public.europe_data VALUES (4897, 6892, 265586, 270.25, 66, 425);
INSERT INTO public.europe_data VALUES (4898, 0, 12, 39.96, 67, 425);
INSERT INTO public.europe_data VALUES (4899, 0, 1, 0.23, 109, 425);
INSERT INTO public.europe_data VALUES (4900, 47, 922, 27.01, 155, 425);
INSERT INTO public.europe_data VALUES (4901, 0, 61, 0.61, 5, 425);
INSERT INTO public.europe_data VALUES (4902, 0, 16, 0.18, 6, 425);
INSERT INTO public.europe_data VALUES (4903, 0, 0, 0.13, 110, 425);
INSERT INTO public.europe_data VALUES (4904, 7, 293, 2.78, 7, 425);
INSERT INTO public.europe_data VALUES (4905, 47, 2809, 14.55, 68, 425);
INSERT INTO public.europe_data VALUES (4906, 2, 330, 118.38, 8, 425);
INSERT INTO public.europe_data VALUES (4907, 0, 2, 3.08, 69, 425);
INSERT INTO public.europe_data VALUES (4908, 0, 27, 0.8, 9, 425);
INSERT INTO public.europe_data VALUES (4909, 0, 30, 0.26, 10, 425);
INSERT INTO public.europe_data VALUES (4910, 400, 11719, 129.85, 70, 425);
INSERT INTO public.europe_data VALUES (4911, 8, 320, 0.06, 111, 425);
INSERT INTO public.europe_data VALUES (4912, 2219, 72815, 305.26, 71, 425);
INSERT INTO public.europe_data VALUES (4913, 0, 12, 2.12, 11, 425);
INSERT INTO public.europe_data VALUES (4914, 1, 15, 3.46, 12, 425);
INSERT INTO public.europe_data VALUES (4915, 61, 5355, 208.69, 72, 425);
INSERT INTO public.europe_data VALUES (4916, 3, 445, 2.94, 13, 425);
INSERT INTO public.europe_data VALUES (4917, 5, 1604, 63.07, 156, 425);
INSERT INTO public.europe_data VALUES (4918, 3, 366, 6.43, 73, 425);
INSERT INTO public.europe_data VALUES (4919, 0, 9, 7.34, 74, 425);
INSERT INTO public.europe_data VALUES (4920, 1, 89, 20.44, 157, 425);
INSERT INTO public.europe_data VALUES (4921, 15, 1911, 33.5, 158, 425);
INSERT INTO public.europe_data VALUES (4922, 11, 154, 0.43, 14, 425);
INSERT INTO public.europe_data VALUES (4923, 0, 510, 29.02, 159, 425);
INSERT INTO public.europe_data VALUES (4924, 1, 13, 3.9, 15, 425);
INSERT INTO public.europe_data VALUES (4925, 0, 1, 1.39, 75, 425);
INSERT INTO public.europe_data VALUES (4926, 114, 4852, 106.43, 76, 425);
INSERT INTO public.europe_data VALUES (4927, 240, 6227, 76.61, 77, 425);
INSERT INTO public.europe_data VALUES (4928, 83, 762, 1.74, 16, 425);
INSERT INTO public.europe_data VALUES (4929, 51, 1710, 65.06, 78, 425);
INSERT INTO public.europe_data VALUES (4930, 0, 105, 7.74, 17, 425);
INSERT INTO public.europe_data VALUES (4931, 0, 21, 0.6, 18, 425);
INSERT INTO public.europe_data VALUES (4932, 0, 82, 9.06, 160, 425);
INSERT INTO public.europe_data VALUES (4933, 15, 386, 86.14, 19, 425);
INSERT INTO public.europe_data VALUES (4934, 150, 10795, 15.93, 20, 425);
INSERT INTO public.europe_data VALUES (4935, 0, 0, 0, 79, 425);
INSERT INTO public.europe_data VALUES (4936, 0, 12, 191.06, 161, 425);
INSERT INTO public.europe_data VALUES (4937, 0, 0, 0.11, 203, 425);
INSERT INTO public.europe_data VALUES (4938, 1, 189, 6.09, 162, 425);
INSERT INTO public.europe_data VALUES (4939, 103, 24363, 67.12, 163, 425);
INSERT INTO public.europe_data VALUES (4940, 0, 44, 62.3, 204, 425);
INSERT INTO public.europe_data VALUES (4941, 2, 163, 21.4, 21, 425);
INSERT INTO public.europe_data VALUES (4942, 21, 565, 51.2, 22, 425);
INSERT INTO public.europe_data VALUES (4943, 0, 70, 4.03, 164, 425);
INSERT INTO public.europe_data VALUES (4944, 40, 9561, 20.78, 165, 425);
INSERT INTO public.europe_data VALUES (4945, 30, 973, 8.23, 23, 425);
INSERT INTO public.europe_data VALUES (4946, 0, 14, 94.94, 166, 425);
INSERT INTO public.europe_data VALUES (4947, 14, 1589, 28.36, 167, 425);
INSERT INTO public.europe_data VALUES (4948, 0, 0, 0, 80, 425);
INSERT INTO public.europe_data VALUES (4949, 0, 0, 0, 81, 425);
INSERT INTO public.europe_data VALUES (4950, 2, 262, 240.29, 205, 425);
INSERT INTO public.europe_data VALUES (4951, 215, 5626, 65.88, 82, 425);
INSERT INTO public.europe_data VALUES (4952, 0, 0, 0, 168, 425);
INSERT INTO public.europe_data VALUES (4953, 2, 485, 8.12, 24, 425);
INSERT INTO public.europe_data VALUES (4954, 0, 32, 5.05, 25, 425);
INSERT INTO public.europe_data VALUES (4955, 8, 246, 49.44, 83, 425);
INSERT INTO public.europe_data VALUES (4956, 0, 203, 3.98, 84, 425);
INSERT INTO public.europe_data VALUES (4957, 0, 0, 0, 169, 425);
INSERT INTO public.europe_data VALUES (4958, 79, 4009, 72.41, 85, 425);
INSERT INTO public.europe_data VALUES (4959, 5, 239, 4.7, 170, 425);
INSERT INTO public.europe_data VALUES (4960, 0, 53, 29.69, 171, 425);
INSERT INTO public.europe_data VALUES (4961, 6621, 458685, 65.23, 112, 425);
INSERT INTO public.europe_data VALUES (4962, 530, 13986, 10.4, 113, 425);
INSERT INTO public.europe_data VALUES (4963, 1004, 15702, 38.83, 114, 425);
INSERT INTO public.europe_data VALUES (4964, 568, 27410, 137.95, 115, 425);
INSERT INTO public.europe_data VALUES (4965, 3, 712, 25.63, 172, 425);
INSERT INTO public.europe_data VALUES (4966, 0, 0, 0, 173, 425);
INSERT INTO public.europe_data VALUES (4967, 149, 10471, 236.51, 116, 425);
INSERT INTO public.europe_data VALUES (4968, 41, 5430, 14.54, 174, 425);
INSERT INTO public.europe_data VALUES (4969, 2, 416, 17.16, 86, 425);
INSERT INTO public.europe_data VALUES (4970, 82, 6802, 10.85, 117, 425);
INSERT INTO public.europe_data VALUES (4971, 1, 8, 16.7, 175, 425);
INSERT INTO public.europe_data VALUES (4972, 1, 231, 3.53, 118, 425);
INSERT INTO public.europe_data VALUES (4973, 186, 5823, 79.45, 119, 425);
INSERT INTO public.europe_data VALUES (4974, 74, 2244, 11.28, 26, 425);
INSERT INTO public.europe_data VALUES (4975, 66, 1032, 122.38, 176, 425);
INSERT INTO public.europe_data VALUES (4976, 14, 4323, 209.53, 120, 425);
INSERT INTO public.europe_data VALUES (4977, -439, 1135, 45.96, 121, 425);
INSERT INTO public.europe_data VALUES (4978, 0, 2, 0.03, 122, 425);
INSERT INTO public.europe_data VALUES (4979, 1, 15, 2.45, 177, 425);
INSERT INTO public.europe_data VALUES (4980, 18, 3310, 82.76, 123, 425);
INSERT INTO public.europe_data VALUES (4981, 0, 69, 12.85, 27, 425);
INSERT INTO public.europe_data VALUES (4982, 0, 29, 0.99, 28, 425);
INSERT INTO public.europe_data VALUES (4983, 43, 2699, 76.8, 29, 425);
INSERT INTO public.europe_data VALUES (4984, 0, 8, 31.27, 178, 425);
INSERT INTO public.europe_data VALUES (4985, 3, 219, 13.71, 179, 425);
INSERT INTO public.europe_data VALUES (4986, 1, 265, 96.27, 180, 425);
INSERT INTO public.europe_data VALUES (4987, 8, 500, 4.6, 30, 425);
INSERT INTO public.europe_data VALUES (4988, 5, 250, 3.56, 31, 425);
INSERT INTO public.europe_data VALUES (4989, 0, 67, 0.58, 124, 425);
INSERT INTO public.europe_data VALUES (4990, 4, 994, 327.33, 125, 425);
INSERT INTO public.europe_data VALUES (4991, 0, 91, 0.7, 32, 425);
INSERT INTO public.europe_data VALUES (4992, 1, 295, 134.13, 181, 425);
INSERT INTO public.europe_data VALUES (4993, 1, 184, 8.55, 33, 425);
INSERT INTO public.europe_data VALUES (4994, 0, 0, 0.16, 34, 425);
INSERT INTO public.europe_data VALUES (4995, 3723, 36673, 58.44, 87, 425);
INSERT INTO public.europe_data VALUES (4996, 44, 3295, 143.89, 182, 425);
INSERT INTO public.europe_data VALUES (4997, 0, 12, 51.38, 183, 425);
INSERT INTO public.europe_data VALUES (4998, 0, 0, 0.16, 126, 425);
INSERT INTO public.europe_data VALUES (4999, 7, 308, 116.53, 184, 425);
INSERT INTO public.europe_data VALUES (5000, 0, 0, 0, 88, 425);
INSERT INTO public.europe_data VALUES (5001, 230, 9860, 52.4, 35, 425);
INSERT INTO public.europe_data VALUES (5002, 1, 540, 3.71, 36, 425);
INSERT INTO public.europe_data VALUES (5003, 0, 88, 0.19, 127, 425);
INSERT INTO public.europe_data VALUES (5004, 17, 1700, 116.46, 37, 425);
INSERT INTO public.europe_data VALUES (5005, 45, 5275, 31.33, 128, 425);
INSERT INTO public.europe_data VALUES (5006, 28, 3547, 45.86, 185, 425);
INSERT INTO public.europe_data VALUES (5007, 0, 0, 0, 208, 425);
INSERT INTO public.europe_data VALUES (5008, 0, 52, 2.36, 209, 425);
INSERT INTO public.europe_data VALUES (5009, 5, 196, 6.25, 89, 425);
INSERT INTO public.europe_data VALUES (5010, 0, 5, 0.06, 38, 425);
INSERT INTO public.europe_data VALUES (5011, 27, 3159, 2.81, 39, 425);
INSERT INTO public.europe_data VALUES (5012, 19, 775, 79.82, 186, 425);
INSERT INTO public.europe_data VALUES (5013, 0, 4, 10.49, 210, 425);
INSERT INTO public.europe_data VALUES (5014, 3, 347, 13.68, 187, 425);
INSERT INTO public.europe_data VALUES (5015, 37, 683, 44, 129, 425);
INSERT INTO public.europe_data VALUES (5016, 60, 3550, 3.74, 130, 425);
INSERT INTO public.europe_data VALUES (5017, 22, 3089, 127.94, 131, 425);
INSERT INTO public.europe_data VALUES (5018, 125, 4960, 292.2, 90, 425);
INSERT INTO public.europe_data VALUES (5019, 1, 78, 2.13, 211, 425);
INSERT INTO public.europe_data VALUES (5020, 67, 3442, 89.8, 91, 425);
INSERT INTO public.europe_data VALUES (5021, 1382, 58380, 357.74, 92, 425);
INSERT INTO public.europe_data VALUES (5022, 333, 28348, 55.21, 132, 425);
INSERT INTO public.europe_data VALUES (5023, 78, 5078, 26.26, 188, 425);
INSERT INTO public.europe_data VALUES (5024, 18, 1495, 28.5, 189, 425);
INSERT INTO public.europe_data VALUES (5025, 55, 3890, 265.05, 93, 425);
INSERT INTO public.europe_data VALUES (5026, 0, 1928, 143.39, 133, 425);
INSERT INTO public.europe_data VALUES (5027, 281, 8064, 86.31, 190, 425);
INSERT INTO public.europe_data VALUES (5028, 698, 33896, 47.45, 191, 425);
INSERT INTO public.europe_data VALUES (5029, 4, 636, 7.52, 40, 425);
INSERT INTO public.europe_data VALUES (5030, 0, 0, 0, 94, 425);
INSERT INTO public.europe_data VALUES (5031, 0, 1, 0.55, 95, 425);
INSERT INTO public.europe_data VALUES (5032, 0, 1, 0.9, 96, 425);
INSERT INTO public.europe_data VALUES (5033, 0, 0, 0, 192, 425);
INSERT INTO public.europe_data VALUES (5034, 0, 7, 6.51, 41, 425);
INSERT INTO public.europe_data VALUES (5035, 241, 8937, 54.83, 134, 425);
INSERT INTO public.europe_data VALUES (5036, 16, 787, 10.89, 42, 425);
INSERT INTO public.europe_data VALUES (5037, 24, 975, 36.73, 193, 425);
INSERT INTO public.europe_data VALUES (5038, 0, 5, 6.14, 43, 425);
INSERT INTO public.europe_data VALUES (5039, 0, 36, 0.97, 44, 425);
INSERT INTO public.europe_data VALUES (5040, 0, 606, 21.52, 135, 425);
INSERT INTO public.europe_data VALUES (5041, 0, 79, 488.33, 97, 425);
INSERT INTO public.europe_data VALUES (5042, 2, 454, 13.94, 194, 425);
INSERT INTO public.europe_data VALUES (5043, 3, 235, 19.32, 195, 425);
INSERT INTO public.europe_data VALUES (5044, 0, 13, 0.27, 45, 425);
INSERT INTO public.europe_data VALUES (5045, 1220, 22428, 85.24, 46, 425);
INSERT INTO public.europe_data VALUES (5046, 4, 2150, 5.93, 136, 425);
INSERT INTO public.europe_data VALUES (5047, 0, 10, 0.26, 47, 425);
INSERT INTO public.europe_data VALUES (5048, 226, 46354, 175.67, 196, 425);
INSERT INTO public.europe_data VALUES (5049, 1, 60, 0.51, 137, 425);
INSERT INTO public.europe_data VALUES (5050, 12, 426, 2.2, 48, 425);
INSERT INTO public.europe_data VALUES (5051, 11, 591, 209.16, 98, 425);
INSERT INTO public.europe_data VALUES (5052, 19, 1687, 36.55, 197, 425);
INSERT INTO public.europe_data VALUES (5053, 4, 1771, 38.48, 198, 425);
INSERT INTO public.europe_data VALUES (5054, 21, 466, 5.59, 138, 425);
INSERT INTO public.europe_data VALUES (5055, 0, 2, 0.03, 139, 425);
INSERT INTO public.europe_data VALUES (5056, 2, 246, 6.07, 140, 425);
INSERT INTO public.europe_data VALUES (5057, 0, 19, 0.07, 141, 425);
INSERT INTO public.europe_data VALUES (5058, 0, 1, 0.08, 142, 425);
INSERT INTO public.europe_data VALUES (5059, 0, 130, 2.68, 49, 425);
INSERT INTO public.europe_data VALUES (5060, 3, 455, 52.19, 99, 425);
INSERT INTO public.europe_data VALUES (5061, 14, 631, 8.9, 50, 425);
INSERT INTO public.europe_data VALUES (5062, 147, 56050, 136.17, 199, 425);
INSERT INTO public.europe_data VALUES (5063, 0, 85, 437.24, 100, 425);
INSERT INTO public.europe_data VALUES (5064, 6, 763, 2.21, 51, 425);
INSERT INTO public.europe_data VALUES (5065, 182, 12138, 52.28, 200, 425);
INSERT INTO public.europe_data VALUES (5066, 11, 2695, 45.87, 143, 425);
INSERT INTO public.europe_data VALUES (5067, 63, 7158, 22.23, 201, 425);
INSERT INTO public.europe_data VALUES (5068, 0, 0, 0, 52, 425);
INSERT INTO public.europe_data VALUES (5069, 6754, 299342, 199.88, 101, 425);
INSERT INTO public.europe_data VALUES (5070, 2, 243, 417.87, 102, 425);
INSERT INTO public.europe_data VALUES (5071, 4, 87, 5.03, 103, 425);
INSERT INTO public.europe_data VALUES (5072, 45, 4002, 24.64, 144, 425);
INSERT INTO public.europe_data VALUES (5073, 48, 5809, 48.25, 104, 425);
INSERT INTO public.europe_data VALUES (5074, 3, 52, 0.18, 145, 425);
INSERT INTO public.europe_data VALUES (5075, 0, 0, 0, 53, 425);
INSERT INTO public.europe_data VALUES (5076, 17, 42, 0.37, 146, 425);
INSERT INTO public.europe_data VALUES (5077, 20, 1739, 16.78, 54, 425);
INSERT INTO public.europe_data VALUES (5078, 23, 669, 8.75, 55, 425);
INSERT INTO public.europe_data VALUES (5079, 63, 542, 2.33, 105, 426);
INSERT INTO public.europe_data VALUES (5080, 29, 969, 65.01, 147, 426);
INSERT INTO public.europe_data VALUES (5081, 68, 3369, 16.53, 1, 426);
INSERT INTO public.europe_data VALUES (5082, 1, 33, 84.01, 148, 426);
INSERT INTO public.europe_data VALUES (5083, 16, 307, 2.3, 2, 426);
INSERT INTO public.europe_data VALUES (5084, 0, 0, 0, 56, 426);
INSERT INTO public.europe_data VALUES (5085, 0, 1, 2.06, 57, 426);
INSERT INTO public.europe_data VALUES (5086, 1101, 47289, 206.69, 58, 426);
INSERT INTO public.europe_data VALUES (5087, 27, 1253, 86.59, 149, 426);
INSERT INTO public.europe_data VALUES (5088, 1, 539, 921.83, 59, 426);
INSERT INTO public.europe_data VALUES (5089, 101, 2204, 21.29, 202, 426);
INSERT INTO public.europe_data VALUES (5090, 7, 1362, 23.3, 150, 426);
INSERT INTO public.europe_data VALUES (5091, 16, 651, 17.68, 151, 426);
INSERT INTO public.europe_data VALUES (5092, 3, 417, 171.25, 60, 426);
INSERT INTO public.europe_data VALUES (5093, 8, 2419, 298.2, 106, 426);
INSERT INTO public.europe_data VALUES (5094, 258, 18949, 21.96, 107, 426);
INSERT INTO public.europe_data VALUES (5095, 0, 9, 6.62, 61, 426);
INSERT INTO public.europe_data VALUES (5096, 23, 666, 15.33, 152, 426);
INSERT INTO public.europe_data VALUES (5097, 75, 3751, 70.63, 153, 426);
INSERT INTO public.europe_data VALUES (5098, 1, 298, 101.19, 62, 426);
INSERT INTO public.europe_data VALUES (5099, 1, 127, 2.19, 3, 426);
INSERT INTO public.europe_data VALUES (5100, 0, 4, 9.6, 63, 426);
INSERT INTO public.europe_data VALUES (5101, 0, 31, 4.98, 108, 426);
INSERT INTO public.europe_data VALUES (5102, 408, 10345, 175.37, 64, 426);
INSERT INTO public.europe_data VALUES (5103, 0, 0, 7.7, 65, 426);
INSERT INTO public.europe_data VALUES (5104, 67, 1210, 103.82, 154, 426);
INSERT INTO public.europe_data VALUES (5105, 1, 305, 17.8, 4, 426);
INSERT INTO public.europe_data VALUES (5106, 6803, 304775, 287.38, 66, 426);
INSERT INTO public.europe_data VALUES (5107, 0, 0, 0, 67, 426);
INSERT INTO public.europe_data VALUES (5108, 0, 0, 0.23, 109, 426);
INSERT INTO public.europe_data VALUES (5109, 51, 969, 34.43, 155, 426);
INSERT INTO public.europe_data VALUES (5110, 1, 63, 0.58, 5, 426);
INSERT INTO public.europe_data VALUES (5111, 0, 5, 0.16, 6, 426);
INSERT INTO public.europe_data VALUES (5112, 0, 22, 0.2, 110, 426);
INSERT INTO public.europe_data VALUES (5113, 6, 427, 4.69, 7, 426);
INSERT INTO public.europe_data VALUES (5114, 45, 2636, 13.95, 68, 426);
INSERT INTO public.europe_data VALUES (5115, 3, 321, 114.92, 8, 426);
INSERT INTO public.europe_data VALUES (5116, 0, 0, 0, 69, 426);
INSERT INTO public.europe_data VALUES (5117, 1, 11, 0.8, 9, 426);
INSERT INTO public.europe_data VALUES (5118, 0, 12, 0.13, 10, 426);
INSERT INTO public.europe_data VALUES (5119, 375, 12890, 138.32, 70, 426);
INSERT INTO public.europe_data VALUES (5120, 17, 582, 0.1, 111, 426);
INSERT INTO public.europe_data VALUES (5121, 2255, 80851, 299.33, 71, 426);
INSERT INTO public.europe_data VALUES (5122, 0, 6, 2.23, 11, 426);
INSERT INTO public.europe_data VALUES (5123, 18, 171, 8.33, 12, 426);
INSERT INTO public.europe_data VALUES (5124, 59, 5179, 188.01, 72, 426);
INSERT INTO public.europe_data VALUES (5125, 5, 311, 3.28, 13, 426);
INSERT INTO public.europe_data VALUES (5126, 9, 967, 32.16, 156, 426);
INSERT INTO public.europe_data VALUES (5127, 0, 363, 5.91, 73, 426);
INSERT INTO public.europe_data VALUES (5128, 0, 3, 3.06, 74, 426);
INSERT INTO public.europe_data VALUES (5129, 1, 90, 20.78, 157, 426);
INSERT INTO public.europe_data VALUES (5130, 8, 1657, 30.16, 158, 426);
INSERT INTO public.europe_data VALUES (5131, 16, 222, 0.65, 14, 426);
INSERT INTO public.europe_data VALUES (5132, 4, 1175, 31.48, 159, 426);
INSERT INTO public.europe_data VALUES (5133, 0, 25, 21.36, 15, 426);
INSERT INTO public.europe_data VALUES (5134, 0, 0, 0, 75, 426);
INSERT INTO public.europe_data VALUES (5135, 144, 6577, 130.98, 76, 426);
INSERT INTO public.europe_data VALUES (5136, 148, 7083, 86.44, 77, 426);
INSERT INTO public.europe_data VALUES (5137, 151, 983, 1.98, 16, 426);
INSERT INTO public.europe_data VALUES (5138, 55, 2489, 84.67, 78, 426);
INSERT INTO public.europe_data VALUES (5139, 0, 0, 0, 17, 426);
INSERT INTO public.europe_data VALUES (5140, 0, 0, 0.17, 18, 426);
INSERT INTO public.europe_data VALUES (5141, 0, 38, 8.38, 160, 426);
INSERT INTO public.europe_data VALUES (5142, 12, 603, 92.67, 19, 426);
INSERT INTO public.europe_data VALUES (5143, 121, 7058, 10.6, 20, 426);
INSERT INTO public.europe_data VALUES (5144, 0, 0, 0, 79, 426);
INSERT INTO public.europe_data VALUES (5145, 0, 81, 301.99, 161, 426);
INSERT INTO public.europe_data VALUES (5146, 0, 1, 0.11, 203, 426);
INSERT INTO public.europe_data VALUES (5147, 2, 147, 5.04, 162, 426);
INSERT INTO public.europe_data VALUES (5148, 86, 20615, 45.69, 163, 426);
INSERT INTO public.europe_data VALUES (5149, 0, 130, 46.55, 204, 426);
INSERT INTO public.europe_data VALUES (5150, 0, 302, 31.94, 21, 426);
INSERT INTO public.europe_data VALUES (5151, 40, 637, 58.53, 22, 426);
INSERT INTO public.europe_data VALUES (5152, 0, 91, 4.1, 164, 426);
INSERT INTO public.europe_data VALUES (5153, 35, 7687, 16.4, 165, 426);
INSERT INTO public.europe_data VALUES (5154, 16, 1529, 18.14, 23, 426);
INSERT INTO public.europe_data VALUES (5155, 0, 18, 80.1, 166, 426);
INSERT INTO public.europe_data VALUES (5156, 16, 1452, 22.5, 167, 426);
INSERT INTO public.europe_data VALUES (5157, 0, 0, 0, 80, 426);
INSERT INTO public.europe_data VALUES (5158, 0, 0, 0, 81, 426);
INSERT INTO public.europe_data VALUES (5159, 0, 140, 113.57, 205, 426);
INSERT INTO public.europe_data VALUES (5160, 168, 5957, 64.02, 82, 426);
INSERT INTO public.europe_data VALUES (5161, 0, 0, 0, 168, 426);
INSERT INTO public.europe_data VALUES (5162, 1, 552, 8.75, 24, 426);
INSERT INTO public.europe_data VALUES (5163, 4, 65, 7.08, 25, 426);
INSERT INTO public.europe_data VALUES (5164, 1, 141, 30.02, 83, 426);
INSERT INTO public.europe_data VALUES (5165, 13, 245, 3.58, 84, 426);
INSERT INTO public.europe_data VALUES (5166, 0, 0, 0, 169, 426);
INSERT INTO public.europe_data VALUES (5167, 80, 3048, 74.95, 85, 426);
INSERT INTO public.europe_data VALUES (5168, 6, 220, 3.9, 170, 426);
INSERT INTO public.europe_data VALUES (5169, 0, 53, 29.13, 171, 426);
INSERT INTO public.europe_data VALUES (5170, 6535, 432589, 61.77, 112, 426);
INSERT INTO public.europe_data VALUES (5171, 427, 14153, 10.38, 113, 426);
INSERT INTO public.europe_data VALUES (5172, 1212, 16491, 40.72, 114, 426);
INSERT INTO public.europe_data VALUES (5173, 468, 26816, 121.55, 115, 426);
INSERT INTO public.europe_data VALUES (5174, 2, 545, 22.33, 172, 426);
INSERT INTO public.europe_data VALUES (5175, 0, 0, 0, 173, 426);
INSERT INTO public.europe_data VALUES (5176, 85, 9678, 230.71, 116, 426);
INSERT INTO public.europe_data VALUES (5177, 191, 3349, 9.68, 174, 426);
INSERT INTO public.europe_data VALUES (5178, 0, 90, 7.43, 86, 426);
INSERT INTO public.europe_data VALUES (5179, 51, 6962, 13.31, 117, 426);
INSERT INTO public.europe_data VALUES (5180, 0, 10, 18.55, 175, 426);
INSERT INTO public.europe_data VALUES (5181, 0, 126, 1.63, 118, 426);
INSERT INTO public.europe_data VALUES (5182, 54, 8917, 123.97, 119, 426);
INSERT INTO public.europe_data VALUES (5183, 54, 3684, 15.34, 26, 426);
INSERT INTO public.europe_data VALUES (5184, 74, 1169, 145.51, 176, 426);
INSERT INTO public.europe_data VALUES (5185, 23, 4492, 197.14, 120, 426);
INSERT INTO public.europe_data VALUES (5186, 22, 1814, 75.78, 121, 426);
INSERT INTO public.europe_data VALUES (5187, 0, 0, 0, 122, 426);
INSERT INTO public.europe_data VALUES (5188, 0, 32, 4.11, 177, 426);
INSERT INTO public.europe_data VALUES (5189, 27, 2364, 58.29, 123, 426);
INSERT INTO public.europe_data VALUES (5190, 7, 204, 10.73, 27, 426);
INSERT INTO public.europe_data VALUES (5191, 3, 20, 1.01, 28, 426);
INSERT INTO public.europe_data VALUES (5192, 32, 2506, 59.71, 29, 426);
INSERT INTO public.europe_data VALUES (5193, 0, 4, 10.42, 178, 426);
INSERT INTO public.europe_data VALUES (5194, 0, 164, 10.95, 179, 426);
INSERT INTO public.europe_data VALUES (5195, 4, 326, 121.19, 180, 426);
INSERT INTO public.europe_data VALUES (5196, 22, 741, 8.52, 30, 426);
INSERT INTO public.europe_data VALUES (5197, 15, 414, 4.51, 31, 426);
INSERT INTO public.europe_data VALUES (5198, 0, 117, 0.63, 124, 426);
INSERT INTO public.europe_data VALUES (5199, 3, 744, 305.3, 125, 426);
INSERT INTO public.europe_data VALUES (5200, 0, 47, 0.37, 32, 426);
INSERT INTO public.europe_data VALUES (5201, 0, 367, 119.54, 181, 426);
INSERT INTO public.europe_data VALUES (5202, 0, 203, 8.64, 33, 426);
INSERT INTO public.europe_data VALUES (5203, 0, 2, 0.16, 34, 426);
INSERT INTO public.europe_data VALUES (5204, 4459, 37880, 61.78, 87, 426);
INSERT INTO public.europe_data VALUES (5205, 51, 2523, 119.24, 182, 426);
INSERT INTO public.europe_data VALUES (5206, 0, 5, 45.34, 183, 426);
INSERT INTO public.europe_data VALUES (5207, 0, 5, 0.16, 126, 426);
INSERT INTO public.europe_data VALUES (5208, 13, 417, 124.88, 184, 426);
INSERT INTO public.europe_data VALUES (5209, 0, 0, 0, 88, 426);
INSERT INTO public.europe_data VALUES (5210, 160, 9252, 46.48, 35, 426);
INSERT INTO public.europe_data VALUES (5211, 3, 586, 2.99, 36, 426);
INSERT INTO public.europe_data VALUES (5212, 0, 15, 0.04, 127, 426);
INSERT INTO public.europe_data VALUES (5213, 16, 1205, 74.56, 37, 426);
INSERT INTO public.europe_data VALUES (5214, 29, 3688, 22.12, 128, 426);
INSERT INTO public.europe_data VALUES (5215, 15, 4379, 45.71, 185, 426);
INSERT INTO public.europe_data VALUES (5216, 0, 0, 0.35, 208, 426);
INSERT INTO public.europe_data VALUES (5217, 0, 61, 1.32, 209, 426);
INSERT INTO public.europe_data VALUES (5218, 5, 213, 6.77, 89, 426);
INSERT INTO public.europe_data VALUES (5219, 0, 9, 0.09, 38, 426);
INSERT INTO public.europe_data VALUES (5220, 30, 2491, 2.6, 39, 426);
INSERT INTO public.europe_data VALUES (5221, 17, 883, 81.12, 186, 426);
INSERT INTO public.europe_data VALUES (5222, 0, 2, 6.99, 210, 426);
INSERT INTO public.europe_data VALUES (5223, 5, 382, 12.05, 187, 426);
INSERT INTO public.europe_data VALUES (5224, 59, 1506, 78.93, 129, 426);
INSERT INTO public.europe_data VALUES (5225, 78, 4555, 4.24, 130, 426);
INSERT INTO public.europe_data VALUES (5226, 18, 3284, 123.56, 131, 426);
INSERT INTO public.europe_data VALUES (5227, 128, 7448, 341.16, 90, 426);
INSERT INTO public.europe_data VALUES (5228, 0, 109, 2.43, 211, 426);
INSERT INTO public.europe_data VALUES (5229, 63, 2884, 58.87, 91, 426);
INSERT INTO public.europe_data VALUES (5230, 5209, 57922, 329.42, 92, 426);
INSERT INTO public.europe_data VALUES (5231, 395, 31340, 53.71, 132, 426);
INSERT INTO public.europe_data VALUES (5232, 70, 4893, 25.78, 188, 426);
INSERT INTO public.europe_data VALUES (5233, 22, 1434, 25.68, 189, 426);
INSERT INTO public.europe_data VALUES (5234, 56, 3885, 258.91, 93, 426);
INSERT INTO public.europe_data VALUES (5235, 9, 2133, 140.29, 133, 426);
INSERT INTO public.europe_data VALUES (5236, 291, 8693, 88.98, 190, 426);
INSERT INTO public.europe_data VALUES (5237, 754, 35317, 49.35, 191, 426);
INSERT INTO public.europe_data VALUES (5238, 1, 313, 3.1, 40, 426);
INSERT INTO public.europe_data VALUES (5239, 0, 0, 0, 94, 426);
INSERT INTO public.europe_data VALUES (5240, 0, 0, 0, 95, 426);
INSERT INTO public.europe_data VALUES (5241, 0, 0, 1.81, 96, 426);
INSERT INTO public.europe_data VALUES (5242, 0, 0, 31.93, 192, 426);
INSERT INTO public.europe_data VALUES (5243, 0, 7, 5.12, 41, 426);
INSERT INTO public.europe_data VALUES (5244, 241, 9852, 57.51, 134, 426);
INSERT INTO public.europe_data VALUES (5245, 21, 987, 11.16, 42, 426);
INSERT INTO public.europe_data VALUES (5246, 33, 1583, 50.1, 193, 426);
INSERT INTO public.europe_data VALUES (5247, 0, 1, 13.3, 43, 426);
INSERT INTO public.europe_data VALUES (5248, 1, 40, 1.45, 44, 426);
INSERT INTO public.europe_data VALUES (5249, 0, 643, 50.34, 135, 426);
INSERT INTO public.europe_data VALUES (5250, 0, 128, 403.41, 97, 426);
INSERT INTO public.europe_data VALUES (5251, 0, 306, 10.24, 194, 426);
INSERT INTO public.europe_data VALUES (5252, 4, 167, 11.34, 195, 426);
INSERT INTO public.europe_data VALUES (5253, 0, 29, 0.28, 45, 426);
INSERT INTO public.europe_data VALUES (5254, 1431, 27487, 129.55, 46, 426);
INSERT INTO public.europe_data VALUES (5255, 0, 889, 2.2, 136, 426);
INSERT INTO public.europe_data VALUES (5256, 0, 19, 0.54, 47, 426);
INSERT INTO public.europe_data VALUES (5257, 70, 36102, 132.15, 196, 426);
INSERT INTO public.europe_data VALUES (5258, 0, 49, 0.33, 137, 426);
INSERT INTO public.europe_data VALUES (5259, 30, 516, 1.57, 48, 426);
INSERT INTO public.europe_data VALUES (5260, 18, 625, 200.74, 98, 426);
INSERT INTO public.europe_data VALUES (5261, 16, 2052, 39.75, 197, 426);
INSERT INTO public.europe_data VALUES (5262, 4, 1517, 30.08, 198, 426);
INSERT INTO public.europe_data VALUES (5263, 12, 489, 5.08, 138, 426);
INSERT INTO public.europe_data VALUES (5264, 0, 5, 0.04, 139, 426);
INSERT INTO public.europe_data VALUES (5265, 2, 320, 6.12, 140, 426);
INSERT INTO public.europe_data VALUES (5266, 0, 27, 0.08, 141, 426);
INSERT INTO public.europe_data VALUES (5267, 0, 0, 0.08, 142, 426);
INSERT INTO public.europe_data VALUES (5268, 4, 87, 2.3, 49, 426);
INSERT INTO public.europe_data VALUES (5269, 3, 273, 26.52, 99, 426);
INSERT INTO public.europe_data VALUES (5270, 3, 410, 4.67, 50, 426);
INSERT INTO public.europe_data VALUES (5271, 130, 55615, 134.96, 199, 426);
INSERT INTO public.europe_data VALUES (5272, 0, 82, 476.51, 100, 426);
INSERT INTO public.europe_data VALUES (5273, 6, 217, 0.72, 51, 426);
INSERT INTO public.europe_data VALUES (5274, 167, 10863, 46.94, 200, 426);
INSERT INTO public.europe_data VALUES (5275, 7, 1787, 33.91, 143, 426);
INSERT INTO public.europe_data VALUES (5276, 88, 7659, 20.69, 201, 426);
INSERT INTO public.europe_data VALUES (5277, 0, 0, 0, 52, 426);
INSERT INTO public.europe_data VALUES (5278, 7114, 358405, 223.46, 101, 426);
INSERT INTO public.europe_data VALUES (5279, 0, 194, 305.99, 102, 426);
INSERT INTO public.europe_data VALUES (5280, 1, 87, 4.45, 103, 426);
INSERT INTO public.europe_data VALUES (5281, 32, 4124, 27.64, 144, 426);
INSERT INTO public.europe_data VALUES (5282, 58, 7950, 47.51, 104, 426);
INSERT INTO public.europe_data VALUES (5283, 11, 123, 0.36, 145, 426);
INSERT INTO public.europe_data VALUES (5284, 0, 0, 0, 53, 426);
INSERT INTO public.europe_data VALUES (5285, 15, 65, 0.46, 146, 426);
INSERT INTO public.europe_data VALUES (5286, 25, 1258, 16.77, 54, 426);
INSERT INTO public.europe_data VALUES (5287, 28, 612, 9.15, 55, 426);
INSERT INTO public.europe_data VALUES (5288, 28, 344, 2.08, 105, 427);
INSERT INTO public.europe_data VALUES (5289, 33, 892, 57.57, 147, 427);
INSERT INTO public.europe_data VALUES (5290, 71, 3749, 18.25, 1, 427);
INSERT INTO public.europe_data VALUES (5291, 0, 31, 77.45, 148, 427);
INSERT INTO public.europe_data VALUES (5292, 18, 424, 2.02, 2, 427);
INSERT INTO public.europe_data VALUES (5293, 0, 0, 0, 56, 427);
INSERT INTO public.europe_data VALUES (5294, 0, 1, 10.3, 57, 427);
INSERT INTO public.europe_data VALUES (5295, 944, 45268, 177.05, 58, 427);
INSERT INTO public.europe_data VALUES (5296, 29, 1308, 102.11, 149, 427);
INSERT INTO public.europe_data VALUES (5297, 0, 441, 417.65, 59, 427);
INSERT INTO public.europe_data VALUES (5298, 87, 3161, 26.51, 202, 427);
INSERT INTO public.europe_data VALUES (5299, 3, 702, 17.21, 150, 427);
INSERT INTO public.europe_data VALUES (5300, 28, 1125, 35.01, 151, 427);
INSERT INTO public.europe_data VALUES (5301, 1, 250, 142.75, 60, 427);
INSERT INTO public.europe_data VALUES (5302, 15, 2475, 297.35, 106, 427);
INSERT INTO public.europe_data VALUES (5303, 245, 16854, 20.94, 107, 427);
INSERT INTO public.europe_data VALUES (5304, 0, 10, 11.15, 61, 427);
INSERT INTO public.europe_data VALUES (5305, 20, 783, 18.18, 152, 427);
INSERT INTO public.europe_data VALUES (5306, 30, 4340, 70.7, 153, 427);
INSERT INTO public.europe_data VALUES (5307, 0, 97, 27.16, 62, 427);
INSERT INTO public.europe_data VALUES (5308, 2, 131, 1.41, 3, 427);
INSERT INTO public.europe_data VALUES (5309, 0, 2, 6.4, 63, 427);
INSERT INTO public.europe_data VALUES (5310, 0, 7, 1.97, 108, 427);
INSERT INTO public.europe_data VALUES (5311, 487, 9846, 178.67, 64, 427);
INSERT INTO public.europe_data VALUES (5312, 0, 2, 7.7, 65, 427);
INSERT INTO public.europe_data VALUES (5313, 59, 2217, 128.93, 154, 427);
INSERT INTO public.europe_data VALUES (5314, 0, 105, 9.68, 4, 427);
INSERT INTO public.europe_data VALUES (5315, 6945, 301745, 292.03, 66, 427);
INSERT INTO public.europe_data VALUES (5316, 0, 0, 3.33, 67, 427);
INSERT INTO public.europe_data VALUES (5317, 0, 1, 0.23, 109, 427);
INSERT INTO public.europe_data VALUES (5318, 59, 1441, 42.41, 155, 427);
INSERT INTO public.europe_data VALUES (5319, 1, 54, 0.51, 5, 427);
INSERT INTO public.europe_data VALUES (5320, 0, 13, 0.41, 6, 427);
INSERT INTO public.europe_data VALUES (5321, 0, 11, 0.16, 110, 427);
INSERT INTO public.europe_data VALUES (5322, 8, 787, 5.16, 7, 427);
INSERT INTO public.europe_data VALUES (5323, 36, 2581, 14.84, 68, 427);
INSERT INTO public.europe_data VALUES (5324, 8, 311, 100.19, 8, 427);
INSERT INTO public.europe_data VALUES (5325, 0, 0, 0, 69, 427);
INSERT INTO public.europe_data VALUES (5326, 1, 27, 0.89, 9, 427);
INSERT INTO public.europe_data VALUES (5327, 1, 8, 0.18, 10, 427);
INSERT INTO public.europe_data VALUES (5328, 469, 13325, 143.87, 70, 427);
INSERT INTO public.europe_data VALUES (5329, 17, 808, 0.16, 111, 427);
INSERT INTO public.europe_data VALUES (5330, 2192, 69830, 275.14, 71, 427);
INSERT INTO public.europe_data VALUES (5331, 0, 13, 6.93, 11, 427);
INSERT INTO public.europe_data VALUES (5332, 2, 277, 11.63, 12, 427);
INSERT INTO public.europe_data VALUES (5333, 73, 4311, 159.62, 72, 427);
INSERT INTO public.europe_data VALUES (5334, 3, 533, 4.35, 13, 427);
INSERT INTO public.europe_data VALUES (5335, 8, 344, 18.33, 156, 427);
INSERT INTO public.europe_data VALUES (5336, 1, 307, 4.04, 73, 427);
INSERT INTO public.europe_data VALUES (5337, 0, 2, 1.22, 74, 427);
INSERT INTO public.europe_data VALUES (5338, 0, 92, 21.12, 157, 427);
INSERT INTO public.europe_data VALUES (5339, 6, 1555, 28.46, 158, 427);
INSERT INTO public.europe_data VALUES (5340, 9, 339, 0.72, 14, 427);
INSERT INTO public.europe_data VALUES (5341, 2, 653, 17.29, 159, 427);
INSERT INTO public.europe_data VALUES (5342, 0, 183, 30.2, 15, 427);
INSERT INTO public.europe_data VALUES (5343, 0, 0, 0, 75, 427);
INSERT INTO public.europe_data VALUES (5344, 131, 7489, 156.66, 76, 427);
INSERT INTO public.europe_data VALUES (5345, 172, 7935, 79.23, 77, 427);
INSERT INTO public.europe_data VALUES (5346, 144, 1009, 3.42, 16, 427);
INSERT INTO public.europe_data VALUES (5347, 96, 2975, 89.76, 78, 427);
INSERT INTO public.europe_data VALUES (5348, 0, 0, 129.06, 17, 427);
INSERT INTO public.europe_data VALUES (5349, 0, 6, 0.63, 18, 427);
INSERT INTO public.europe_data VALUES (5350, 0, 73, 8.91, 160, 427);
INSERT INTO public.europe_data VALUES (5351, 15, 461, 89.62, 19, 427);
INSERT INTO public.europe_data VALUES (5352, 123, 4819, 7.9, 20, 427);
INSERT INTO public.europe_data VALUES (5353, 0, 0, 0, 79, 427);
INSERT INTO public.europe_data VALUES (5354, 0, 66, 205.44, 161, 427);
INSERT INTO public.europe_data VALUES (5355, 0, 0, 0, 203, 427);
INSERT INTO public.europe_data VALUES (5356, 2, 131, 3.46, 162, 427);
INSERT INTO public.europe_data VALUES (5357, 59, 10002, 25.95, 163, 427);
INSERT INTO public.europe_data VALUES (5358, 0, 0, 0, 204, 427);
INSERT INTO public.europe_data VALUES (5359, 1, 392, 43.22, 21, 427);
INSERT INTO public.europe_data VALUES (5360, 14, 737, 40.81, 22, 427);
INSERT INTO public.europe_data VALUES (5361, 0, 73, 2.83, 164, 427);
INSERT INTO public.europe_data VALUES (5362, 49, 5925, 12.91, 165, 427);
INSERT INTO public.europe_data VALUES (5363, 33, 3989, 26.41, 23, 427);
INSERT INTO public.europe_data VALUES (5364, 0, 9, 35.6, 166, 427);
INSERT INTO public.europe_data VALUES (5365, 4, 961, 13.33, 167, 427);
INSERT INTO public.europe_data VALUES (5366, 0, 0, 1.76, 80, 427);
INSERT INTO public.europe_data VALUES (5367, 0, 0, 0.89, 81, 427);
INSERT INTO public.europe_data VALUES (5368, 0, 50, 43.04, 205, 427);
INSERT INTO public.europe_data VALUES (5369, 216, 5299, 65.71, 82, 427);
INSERT INTO public.europe_data VALUES (5370, 0, 0, 0, 168, 427);
INSERT INTO public.europe_data VALUES (5371, 4, 566, 7.22, 24, 427);
INSERT INTO public.europe_data VALUES (5372, 3, 71, 5.1, 25, 427);
INSERT INTO public.europe_data VALUES (5373, 1, 94, 25.29, 83, 427);
INSERT INTO public.europe_data VALUES (5374, 18, 158, 2.83, 84, 427);
INSERT INTO public.europe_data VALUES (5375, 0, 0, 0, 169, 427);
INSERT INTO public.europe_data VALUES (5376, 118, 4257, 83.91, 85, 427);
INSERT INTO public.europe_data VALUES (5377, 5, 161, 2.54, 170, 427);
INSERT INTO public.europe_data VALUES (5378, 0, 51, 31.09, 171, 427);
INSERT INTO public.europe_data VALUES (5379, 6251, 411379, 57.06, 112, 427);
INSERT INTO public.europe_data VALUES (5380, 487, 13941, 9.84, 113, 427);
INSERT INTO public.europe_data VALUES (5381, 1237, 17275, 42.86, 114, 427);
INSERT INTO public.europe_data VALUES (5382, 524, 20964, 101.97, 115, 427);
INSERT INTO public.europe_data VALUES (5383, 9, 550, 16.94, 172, 427);
INSERT INTO public.europe_data VALUES (5384, 0, 0, 0, 173, 427);
INSERT INTO public.europe_data VALUES (5385, 64, 9977, 247.04, 116, 427);
INSERT INTO public.europe_data VALUES (5386, 51, 2496, 7.37, 174, 427);
INSERT INTO public.europe_data VALUES (5387, 2, 129, 6.14, 86, 427);
INSERT INTO public.europe_data VALUES (5388, 36, 9918, 14.19, 117, 427);
INSERT INTO public.europe_data VALUES (5389, 0, 10, 12.06, 175, 427);
INSERT INTO public.europe_data VALUES (5390, 0, 39, 0.83, 118, 427);
INSERT INTO public.europe_data VALUES (5391, 324, 14081, 159.56, 119, 427);
INSERT INTO public.europe_data VALUES (5392, 51, 4383, 16.8, 26, 427);
INSERT INTO public.europe_data VALUES (5393, 78, 1448, 185.15, 176, 427);
INSERT INTO public.europe_data VALUES (5394, 21, 3802, 188.73, 120, 427);
INSERT INTO public.europe_data VALUES (5395, 54, 3048, 107.25, 121, 427);
INSERT INTO public.europe_data VALUES (5396, 0, 0, 0, 122, 427);
INSERT INTO public.europe_data VALUES (5397, 0, 47, 3.7, 177, 427);
INSERT INTO public.europe_data VALUES (5398, 14, 1632, 40.36, 123, 427);
INSERT INTO public.europe_data VALUES (5399, 4, 24, 13.93, 27, 427);
INSERT INTO public.europe_data VALUES (5400, 2, 30, 1.52, 28, 427);
INSERT INTO public.europe_data VALUES (5401, 33, 1541, 39.62, 29, 427);
INSERT INTO public.europe_data VALUES (5402, 0, 0, 5.21, 178, 427);
INSERT INTO public.europe_data VALUES (5403, 1, 142, 8.73, 179, 427);
INSERT INTO public.europe_data VALUES (5404, 2, 418, 136.99, 180, 427);
INSERT INTO public.europe_data VALUES (5405, 34, 1558, 14.06, 30, 427);
INSERT INTO public.europe_data VALUES (5406, 23, 427, 5.46, 31, 427);
INSERT INTO public.europe_data VALUES (5407, 0, 84, 0.58, 124, 427);
INSERT INTO public.europe_data VALUES (5408, 2, 877, 327.52, 125, 427);
INSERT INTO public.europe_data VALUES (5409, 1, 26, 0.29, 32, 427);
INSERT INTO public.europe_data VALUES (5410, 0, 223, 62.2, 181, 427);
INSERT INTO public.europe_data VALUES (5411, 0, 188, 7.23, 33, 427);
INSERT INTO public.europe_data VALUES (5412, 0, 0, 0, 34, 427);
INSERT INTO public.europe_data VALUES (5413, 4552, 40936, 66.98, 87, 427);
INSERT INTO public.europe_data VALUES (5414, 54, 2298, 114.41, 182, 427);
INSERT INTO public.europe_data VALUES (5415, 0, 10, 39.29, 183, 427);
INSERT INTO public.europe_data VALUES (5416, 0, 0, 0.16, 126, 427);
INSERT INTO public.europe_data VALUES (5417, 13, 360, 168.6, 184, 427);
INSERT INTO public.europe_data VALUES (5418, 0, 0, 0, 88, 427);
INSERT INTO public.europe_data VALUES (5419, 116, 7700, 35.53, 35, 427);
INSERT INTO public.europe_data VALUES (5420, 3, 323, 1.98, 36, 427);
INSERT INTO public.europe_data VALUES (5421, 0, 7, 0.02, 127, 427);
INSERT INTO public.europe_data VALUES (5422, 8, 655, 47.06, 37, 427);
INSERT INTO public.europe_data VALUES (5423, 18, 2640, 15.24, 128, 427);
INSERT INTO public.europe_data VALUES (5424, 8, 3521, 32.51, 185, 427);
INSERT INTO public.europe_data VALUES (5425, 0, 1, 0.35, 208, 427);
INSERT INTO public.europe_data VALUES (5426, 0, 2, 0.27, 209, 427);
INSERT INTO public.europe_data VALUES (5427, 7, 230, 7.07, 89, 427);
INSERT INTO public.europe_data VALUES (5428, 0, 11, 0.11, 38, 427);
INSERT INTO public.europe_data VALUES (5429, 57, 2736, 3.01, 39, 427);
INSERT INTO public.europe_data VALUES (5430, 30, 802, 85.21, 186, 427);
INSERT INTO public.europe_data VALUES (5431, 0, 2, 13.98, 210, 427);
INSERT INTO public.europe_data VALUES (5432, 1, 260, 7.19, 187, 427);
INSERT INTO public.europe_data VALUES (5433, 92, 2421, 112.06, 129, 427);
INSERT INTO public.europe_data VALUES (5434, 113, 4631, 4.79, 130, 427);
INSERT INTO public.europe_data VALUES (5435, 16, 2871, 110.85, 131, 427);
INSERT INTO public.europe_data VALUES (5436, 168, 7039, 334.3, 90, 427);
INSERT INTO public.europe_data VALUES (5437, 1, 104, 1.73, 211, 427);
INSERT INTO public.europe_data VALUES (5438, 23, 1263, 34.96, 91, 427);
INSERT INTO public.europe_data VALUES (5439, 1458, 49174, 286.76, 92, 427);
INSERT INTO public.europe_data VALUES (5440, 211, 26728, 45.75, 132, 427);
INSERT INTO public.europe_data VALUES (5441, 76, 4897, 22.98, 188, 427);
INSERT INTO public.europe_data VALUES (5442, 18, 1205, 24.37, 189, 427);
INSERT INTO public.europe_data VALUES (5443, 49, 3710, 237.88, 93, 427);
INSERT INTO public.europe_data VALUES (5444, 7, 1840, 128.6, 133, 427);
INSERT INTO public.europe_data VALUES (5445, 287, 8582, 87.41, 190, 427);
INSERT INTO public.europe_data VALUES (5446, 803, 36666, 51.45, 191, 427);
INSERT INTO public.europe_data VALUES (5447, 2, 78, 2.53, 40, 427);
INSERT INTO public.europe_data VALUES (5448, 0, 0, 0, 94, 427);
INSERT INTO public.europe_data VALUES (5449, 0, 0, 0.55, 95, 427);
INSERT INTO public.europe_data VALUES (5450, 0, 2, 4.52, 96, 427);
INSERT INTO public.europe_data VALUES (5451, 0, 11, 31.93, 192, 427);
INSERT INTO public.europe_data VALUES (5452, 0, 4, 6.98, 41, 427);
INSERT INTO public.europe_data VALUES (5453, 250, 9855, 63.47, 134, 427);
INSERT INTO public.europe_data VALUES (5454, 23, 831, 9.17, 42, 427);
INSERT INTO public.europe_data VALUES (5455, 51, 1906, 62.74, 193, 427);
INSERT INTO public.europe_data VALUES (5456, 0, 12, 12.28, 43, 427);
INSERT INTO public.europe_data VALUES (5457, 1, 73, 1.7, 44, 427);
INSERT INTO public.europe_data VALUES (5458, 0, 2279, 81.58, 135, 427);
INSERT INTO public.europe_data VALUES (5459, 1, 43, 224.11, 97, 427);
INSERT INTO public.europe_data VALUES (5460, 2, 252, 7.65, 194, 427);
INSERT INTO public.europe_data VALUES (5461, 3, 69, 8.03, 195, 427);
INSERT INTO public.europe_data VALUES (5462, 0, 15, 0.32, 45, 427);
INSERT INTO public.europe_data VALUES (5463, 2042, 48373, 195.4, 46, 427);
INSERT INTO public.europe_data VALUES (5464, 4, 237, 0.88, 136, 427);
INSERT INTO public.europe_data VALUES (5465, 1, 41, 1.88, 47, 427);
INSERT INTO public.europe_data VALUES (5466, 104, 25926, 94.16, 196, 427);
INSERT INTO public.europe_data VALUES (5467, 0, 21, 0.29, 137, 427);
INSERT INTO public.europe_data VALUES (5468, 21, 156, 1.19, 48, 427);
INSERT INTO public.europe_data VALUES (5469, 2, 542, 163.75, 98, 427);
INSERT INTO public.europe_data VALUES (5470, 18, 2014, 34.9, 197, 427);
INSERT INTO public.europe_data VALUES (5471, 6, 1053, 25.62, 198, 427);
INSERT INTO public.europe_data VALUES (5472, 8, 379, 3.15, 138, 427);
INSERT INTO public.europe_data VALUES (5473, 0, 5, 0.08, 139, 427);
INSERT INTO public.europe_data VALUES (5474, 1, 250, 5.93, 140, 427);
INSERT INTO public.europe_data VALUES (5475, 0, 31, 0.08, 141, 427);
INSERT INTO public.europe_data VALUES (5476, 0, 1, 0.08, 142, 427);
INSERT INTO public.europe_data VALUES (5477, 4, 99, 2.38, 49, 427);
INSERT INTO public.europe_data VALUES (5478, 0, 97, 9.46, 99, 427);
INSERT INTO public.europe_data VALUES (5479, 0, 136, 2.09, 50, 427);
INSERT INTO public.europe_data VALUES (5480, 116, 55058, 124.62, 199, 427);
INSERT INTO public.europe_data VALUES (5481, 0, 100, 306.33, 100, 427);
INSERT INTO public.europe_data VALUES (5482, 3, 101, 0.38, 51, 427);
INSERT INTO public.europe_data VALUES (5483, 197, 9789, 38.89, 200, 427);
INSERT INTO public.europe_data VALUES (5484, 6, 1526, 36.97, 143, 427);
INSERT INTO public.europe_data VALUES (5485, 71, 6130, 15.87, 201, 427);
INSERT INTO public.europe_data VALUES (5486, 0, 0, 0, 52, 427);
INSERT INTO public.europe_data VALUES (5487, 8078, 376909, 246.41, 101, 427);
INSERT INTO public.europe_data VALUES (5488, 1, 126, 177.86, 102, 427);
INSERT INTO public.europe_data VALUES (5489, 1, 67, 4.65, 103, 427);
INSERT INTO public.europe_data VALUES (5490, 41, 4992, 30.32, 144, 427);
INSERT INTO public.europe_data VALUES (5491, 49, 5599, 36.27, 104, 427);
INSERT INTO public.europe_data VALUES (5492, 7, 220, 0.44, 145, 427);
INSERT INTO public.europe_data VALUES (5493, 0, 0, 0, 53, 427);
INSERT INTO public.europe_data VALUES (5494, 18, 70, 0.42, 146, 427);
INSERT INTO public.europe_data VALUES (5495, 65, 1738, 20.18, 54, 427);
INSERT INTO public.europe_data VALUES (5496, 34, 728, 14.59, 55, 427);
INSERT INTO public.europe_data VALUES (5497, 15, 447, 3.25, 105, 428);
INSERT INTO public.europe_data VALUES (5498, 28, 756, 49.92, 147, 428);
INSERT INTO public.europe_data VALUES (5499, 76, 4108, 19.47, 1, 428);
INSERT INTO public.europe_data VALUES (5500, 0, 28, 59.07, 148, 428);
INSERT INTO public.europe_data VALUES (5501, 12, 218, 1.39, 2, 428);
INSERT INTO public.europe_data VALUES (5502, 0, 0, 0, 56, 428);
INSERT INTO public.europe_data VALUES (5503, 0, 9, 15.45, 57, 428);
INSERT INTO public.europe_data VALUES (5504, 673, 34017, 165.29, 58, 428);
INSERT INTO public.europe_data VALUES (5505, 51, 1712, 139.33, 149, 428);
INSERT INTO public.europe_data VALUES (5506, 0, 3, 8.47, 59, 428);
INSERT INTO public.europe_data VALUES (5507, 53, 3520, 24.29, 202, 428);
INSERT INTO public.europe_data VALUES (5508, 6, 823, 19.62, 150, 428);
INSERT INTO public.europe_data VALUES (5509, 45, 2393, 48.99, 151, 428);
INSERT INTO public.europe_data VALUES (5510, 3, 306, 127.09, 60, 428);
INSERT INTO public.europe_data VALUES (5511, 7, 2405, 311.61, 106, 428);
INSERT INTO public.europe_data VALUES (5512, 226, 17293, 22.22, 107, 428);
INSERT INTO public.europe_data VALUES (5513, 0, 22, 9.41, 61, 428);
INSERT INTO public.europe_data VALUES (5514, 33, 935, 20.86, 152, 428);
INSERT INTO public.europe_data VALUES (5515, 20, 3759, 54.54, 153, 428);
INSERT INTO public.europe_data VALUES (5516, 0, 9, 4.36, 62, 428);
INSERT INTO public.europe_data VALUES (5517, 1, 35, 1.72, 3, 428);
INSERT INTO public.europe_data VALUES (5518, 0, 2, 4.8, 63, 428);
INSERT INTO public.europe_data VALUES (5519, 0, 8, 1.83, 108, 428);
INSERT INTO public.europe_data VALUES (5520, 570, 10724, 178.67, 64, 428);
INSERT INTO public.europe_data VALUES (5521, 0, 0, 3.85, 65, 428);
INSERT INTO public.europe_data VALUES (5522, 60, 2039, 110.75, 154, 428);
INSERT INTO public.europe_data VALUES (5523, 1, 118, 12.24, 4, 428);
INSERT INTO public.europe_data VALUES (5524, 7100, 314586, 301.01, 66, 428);
INSERT INTO public.europe_data VALUES (5525, 0, 1, 3.33, 67, 428);
INSERT INTO public.europe_data VALUES (5526, 0, 0, 0, 109, 428);
INSERT INTO public.europe_data VALUES (5527, 48, 1528, 46.03, 155, 428);
INSERT INTO public.europe_data VALUES (5528, 0, 50, 0.42, 5, 428);
INSERT INTO public.europe_data VALUES (5529, 0, 34, 0.74, 6, 428);
INSERT INTO public.europe_data VALUES (5530, 0, 15, 0.42, 110, 428);
INSERT INTO public.europe_data VALUES (5531, 2, 547, 4.24, 7, 428);
INSERT INTO public.europe_data VALUES (5532, 55, 2972, 17.46, 68, 428);
INSERT INTO public.europe_data VALUES (5533, 2, 240, 91.65, 8, 428);
INSERT INTO public.europe_data VALUES (5534, 0, 0, 0, 69, 428);
INSERT INTO public.europe_data VALUES (5535, 0, 15, 2.72, 9, 428);
INSERT INTO public.europe_data VALUES (5536, 0, 21, 0.29, 10, 428);
INSERT INTO public.europe_data VALUES (5537, 496, 13941, 151.97, 70, 428);
INSERT INTO public.europe_data VALUES (5538, 17, 1415, 0.17, 111, 428);
INSERT INTO public.europe_data VALUES (5539, 2125, 68675, 239.12, 71, 428);
INSERT INTO public.europe_data VALUES (5540, 0, 46, 6.11, 11, 428);
INSERT INTO public.europe_data VALUES (5541, 5, 349, 14.01, 12, 428);
INSERT INTO public.europe_data VALUES (5542, 58, 3746, 155.74, 72, 428);
INSERT INTO public.europe_data VALUES (5543, 6, 586, 8.02, 13, 428);
INSERT INTO public.europe_data VALUES (5544, 13, 403, 22.23, 156, 428);
INSERT INTO public.europe_data VALUES (5545, 0, 151, 1.76, 73, 428);
INSERT INTO public.europe_data VALUES (5546, 0, 0, 0.61, 74, 428);
INSERT INTO public.europe_data VALUES (5547, 0, 93, 12.79, 157, 428);
INSERT INTO public.europe_data VALUES (5548, 12, 1476, 26.81, 158, 428);
INSERT INTO public.europe_data VALUES (5549, 10, 283, 0.82, 14, 428);
INSERT INTO public.europe_data VALUES (5550, 2, 351, 10.61, 159, 428);
INSERT INTO public.europe_data VALUES (5551, 1, 111, 15.41, 15, 428);
INSERT INTO public.europe_data VALUES (5552, 0, 0, 0, 75, 428);
INSERT INTO public.europe_data VALUES (5553, 115, 9335, 180.54, 76, 428);
INSERT INTO public.europe_data VALUES (5554, 235, 5830, 72.01, 77, 428);
INSERT INTO public.europe_data VALUES (5555, 259, 2421, 6.68, 16, 428);
INSERT INTO public.europe_data VALUES (5556, 59, 2818, 86.8, 78, 428);
INSERT INTO public.europe_data VALUES (5557, 32, 1750, 129.06, 17, 428);
INSERT INTO public.europe_data VALUES (5558, 0, 16, 0.8, 18, 428);
INSERT INTO public.europe_data VALUES (5559, 0, 45, 4.38, 160, 428);
INSERT INTO public.europe_data VALUES (5560, 11, 568, 85.53, 19, 428);
INSERT INTO public.europe_data VALUES (5561, 61, 4031, 7.58, 20, 428);
INSERT INTO public.europe_data VALUES (5562, 0, 0, 0, 79, 428);
INSERT INTO public.europe_data VALUES (5563, 0, 34, 69.85, 161, 428);
INSERT INTO public.europe_data VALUES (5564, 1, 0, 0.11, 203, 428);
INSERT INTO public.europe_data VALUES (5565, 0, 60, 2.08, 162, 428);
INSERT INTO public.europe_data VALUES (5566, 73, 7391, 19.76, 163, 428);
INSERT INTO public.europe_data VALUES (5567, 0, 0, 0, 204, 428);
INSERT INTO public.europe_data VALUES (5568, 1, 547, 55.97, 21, 428);
INSERT INTO public.europe_data VALUES (5569, 3, 221, 17.25, 22, 428);
INSERT INTO public.europe_data VALUES (5570, 1, 40, 3.73, 164, 428);
INSERT INTO public.europe_data VALUES (5571, 30, 4793, 10.33, 165, 428);
INSERT INTO public.europe_data VALUES (5572, 14, 4045, 30.73, 23, 428);
INSERT INTO public.europe_data VALUES (5573, 0, 3, 23.73, 166, 428);
INSERT INTO public.europe_data VALUES (5574, 6, 469, 6.11, 167, 428);
INSERT INTO public.europe_data VALUES (5575, 0, 1, 1.76, 80, 428);
INSERT INTO public.europe_data VALUES (5576, 0, 1, 0.89, 81, 428);
INSERT INTO public.europe_data VALUES (5577, 0, 22, 29.29, 205, 428);
INSERT INTO public.europe_data VALUES (5578, 261, 6253, 71.83, 82, 428);
INSERT INTO public.europe_data VALUES (5579, 0, 0, 0, 168, 428);
INSERT INTO public.europe_data VALUES (5580, 3, 356, 6.42, 24, 428);
INSERT INTO public.europe_data VALUES (5581, 0, 27, 2.81, 25, 428);
INSERT INTO public.europe_data VALUES (5582, 1, 104, 17.63, 83, 428);
INSERT INTO public.europe_data VALUES (5583, 8, 161, 3.76, 84, 428);
INSERT INTO public.europe_data VALUES (5584, 0, 0, 0, 169, 428);
INSERT INTO public.europe_data VALUES (5585, 261, 3921, 96.06, 85, 428);
INSERT INTO public.europe_data VALUES (5586, 1, 87, 2.07, 170, 428);
INSERT INTO public.europe_data VALUES (5587, 0, 60, 19.05, 171, 428);
INSERT INTO public.europe_data VALUES (5588, 5364, 368242, 50.18, 112, 428);
INSERT INTO public.europe_data VALUES (5589, 455, 12677, 9.21, 113, 428);
INSERT INTO public.europe_data VALUES (5590, 1490, 18265, 43, 114, 428);
INSERT INTO public.europe_data VALUES (5591, 506, 19119, 93.16, 115, 428);
INSERT INTO public.europe_data VALUES (5592, 0, 281, 8.2, 172, 428);
INSERT INTO public.europe_data VALUES (5593, 0, 0, 0, 173, 428);
INSERT INTO public.europe_data VALUES (5594, 66, 11069, 266.87, 116, 428);
INSERT INTO public.europe_data VALUES (5595, 47, 1952, 6.02, 174, 428);
INSERT INTO public.europe_data VALUES (5596, 2, 52, 3.53, 86, 428);
INSERT INTO public.europe_data VALUES (5597, 15, 8083, 10.23, 117, 428);
INSERT INTO public.europe_data VALUES (5598, 0, 3, 3.71, 175, 428);
INSERT INTO public.europe_data VALUES (5599, 0, 45, -0.05, 118, 428);
INSERT INTO public.europe_data VALUES (5600, 524, 15519, 144.48, 119, 428);
INSERT INTO public.europe_data VALUES (5601, 89, 4450, 16.55, 26, 428);
INSERT INTO public.europe_data VALUES (5602, 80, 1882, 170.36, 176, 428);
INSERT INTO public.europe_data VALUES (5603, 24, 4138, 206.96, 120, 428);
INSERT INTO public.europe_data VALUES (5604, 119, 3833, 155.65, 121, 428);
INSERT INTO public.europe_data VALUES (5605, 0, 0, 0.01, 122, 428);
INSERT INTO public.europe_data VALUES (5606, 1, 24, 2.66, 177, 428);
INSERT INTO public.europe_data VALUES (5607, 11, 1135, 29.55, 123, 428);
INSERT INTO public.europe_data VALUES (5608, 8, 272, 16.89, 27, 428);
INSERT INTO public.europe_data VALUES (5609, 5, 45, 2.35, 28, 428);
INSERT INTO public.europe_data VALUES (5610, 22, 1144, 26.93, 29, 428);
INSERT INTO public.europe_data VALUES (5611, 0, 2, 5.21, 178, 428);
INSERT INTO public.europe_data VALUES (5612, 0, 102, 6.37, 179, 428);
INSERT INTO public.europe_data VALUES (5613, 5, 423, 197.43, 180, 428);
INSERT INTO public.europe_data VALUES (5614, 29, 2233, 16.61, 30, 428);
INSERT INTO public.europe_data VALUES (5615, 24, 591, 6.65, 31, 428);
INSERT INTO public.europe_data VALUES (5616, 1, 102, 0.69, 124, 428);
INSERT INTO public.europe_data VALUES (5617, 2, 862, 225.63, 125, 428);
INSERT INTO public.europe_data VALUES (5618, 1, 31, 0.34, 32, 428);
INSERT INTO public.europe_data VALUES (5619, 0, 84, 21.88, 181, 428);
INSERT INTO public.europe_data VALUES (5620, 1, 139, 9.66, 33, 428);
INSERT INTO public.europe_data VALUES (5621, 0, 0, 0.08, 34, 428);
INSERT INTO public.europe_data VALUES (5622, 4066, 44519, 73.26, 87, 428);
INSERT INTO public.europe_data VALUES (5623, 56, 2328, 108.38, 182, 428);
INSERT INTO public.europe_data VALUES (5624, 0, 3, 24.18, 183, 428);
INSERT INTO public.europe_data VALUES (5625, 0, 5, 0.19, 126, 428);
INSERT INTO public.europe_data VALUES (5626, 11, 689, 239, 184, 428);
INSERT INTO public.europe_data VALUES (5627, 0, 0, 20.04, 88, 428);
INSERT INTO public.europe_data VALUES (5628, 69, 5259, 22.76, 35, 428);
INSERT INTO public.europe_data VALUES (5629, 2, 277, 1.5, 36, 428);
INSERT INTO public.europe_data VALUES (5630, 0, 3, 0.02, 127, 428);
INSERT INTO public.europe_data VALUES (5631, 3, 519, 41.97, 37, 428);
INSERT INTO public.europe_data VALUES (5632, 12, 1719, 9.35, 128, 428);
INSERT INTO public.europe_data VALUES (5633, 0, 2097, 19.2, 185, 428);
INSERT INTO public.europe_data VALUES (5634, 0, 0, 0, 208, 428);
INSERT INTO public.europe_data VALUES (5635, 0, 11, 0.27, 209, 428);
INSERT INTO public.europe_data VALUES (5636, 8, 233, 8.02, 89, 428);
INSERT INTO public.europe_data VALUES (5637, 0, 15, 0.18, 38, 428);
INSERT INTO public.europe_data VALUES (5638, 30, 3309, 3.57, 39, 428);
INSERT INTO public.europe_data VALUES (5639, 37, 968, 92.53, 186, 428);
INSERT INTO public.europe_data VALUES (5640, 0, 6, 15.73, 210, 428);
INSERT INTO public.europe_data VALUES (5641, 0, 123, 3.62, 187, 428);
INSERT INTO public.europe_data VALUES (5642, 37, 3154, 251.22, 129, 428);
INSERT INTO public.europe_data VALUES (5643, 142, 5740, 6.9, 130, 428);
INSERT INTO public.europe_data VALUES (5644, 9, 2651, 114.99, 131, 428);
INSERT INTO public.europe_data VALUES (5645, 177, 7157, 329.33, 90, 428);
INSERT INTO public.europe_data VALUES (5646, 2, 48, 1.06, 211, 428);
INSERT INTO public.europe_data VALUES (5647, 11, 1200, 27.3, 91, 428);
INSERT INTO public.europe_data VALUES (5648, 1385, 44053, 231.49, 92, 428);
INSERT INTO public.europe_data VALUES (5649, 127, 22737, 33.05, 132, 428);
INSERT INTO public.europe_data VALUES (5650, 60, 3829, 17.88, 188, 428);
INSERT INTO public.europe_data VALUES (5651, 21, 1299, 27.51, 189, 428);
INSERT INTO public.europe_data VALUES (5652, 29, 3268, 216.4, 93, 428);
INSERT INTO public.europe_data VALUES (5653, 12, 1802, 157.45, 133, 428);
INSERT INTO public.europe_data VALUES (5654, 226, 8388, 81.01, 190, 428);
INSERT INTO public.europe_data VALUES (5655, 859, 38385, 54.38, 191, 428);
INSERT INTO public.europe_data VALUES (5656, 0, 241, 3.8, 40, 428);
INSERT INTO public.europe_data VALUES (5657, 0, 0, 0, 94, 428);
INSERT INTO public.europe_data VALUES (5658, 0, 1, 1.09, 95, 428);
INSERT INTO public.europe_data VALUES (5659, 0, 3, 4.52, 96, 428);
INSERT INTO public.europe_data VALUES (5660, 0, 0, 0, 192, 428);
INSERT INTO public.europe_data VALUES (5661, 1, 11, 59.52, 41, 428);
INSERT INTO public.europe_data VALUES (5662, 184, 11894, 81.46, 134, 428);
INSERT INTO public.europe_data VALUES (5663, 18, 663, 9.41, 42, 428);
INSERT INTO public.europe_data VALUES (5664, 56, 2463, 76.09, 193, 428);
INSERT INTO public.europe_data VALUES (5665, 0, 0, 14.32, 43, 428);
INSERT INTO public.europe_data VALUES (5666, 1, 60, 1.69, 44, 428);
INSERT INTO public.europe_data VALUES (5667, 0, 2456, 84.64, 135, 428);
INSERT INTO public.europe_data VALUES (5668, 1, 52, 158.06, 97, 428);
INSERT INTO public.europe_data VALUES (5669, 1, 165, 6.7, 194, 428);
INSERT INTO public.europe_data VALUES (5670, 2, 98, 11.25, 195, 428);
INSERT INTO public.europe_data VALUES (5671, 0, 34, 0.6, 45, 428);
INSERT INTO public.europe_data VALUES (5672, 1597, 66052, 251.3, 46, 428);
INSERT INTO public.europe_data VALUES (5673, 2, 214, 1.21, 136, 428);
INSERT INTO public.europe_data VALUES (5674, 1, 167, 2.07, 47, 428);
INSERT INTO public.europe_data VALUES (5675, 38, 18272, 68.64, 196, 428);
INSERT INTO public.europe_data VALUES (5676, 0, 41, 0.46, 137, 428);
INSERT INTO public.europe_data VALUES (5677, 35, 353, 2.28, 48, 428);
INSERT INTO public.europe_data VALUES (5678, 4, 410, 141.05, 98, 428);
INSERT INTO public.europe_data VALUES (5679, 18, 1556, 28.07, 197, 428);
INSERT INTO public.europe_data VALUES (5680, 5, 1136, 22.9, 198, 428);
INSERT INTO public.europe_data VALUES (5681, 6, 159, 1.83, 138, 428);
INSERT INTO public.europe_data VALUES (5682, 0, 13, 0.08, 139, 428);
INSERT INTO public.europe_data VALUES (5683, 2, 303, 6.62, 140, 428);
INSERT INTO public.europe_data VALUES (5684, 0, 25, 0.1, 141, 428);
INSERT INTO public.europe_data VALUES (5685, 0, 0, 0, 142, 428);
INSERT INTO public.europe_data VALUES (5686, 1, 93, 2.31, 49, 428);
INSERT INTO public.europe_data VALUES (5687, 0, 35, 3.23, 99, 428);
INSERT INTO public.europe_data VALUES (5688, 1, 109, 1.6, 50, 428);
INSERT INTO public.europe_data VALUES (5689, 115, 47136, 65.36, 199, 428);
INSERT INTO public.europe_data VALUES (5690, 0, 17, 91.64, 100, 428);
INSERT INTO public.europe_data VALUES (5691, 2, 67, 0.26, 51, 428);
INSERT INTO public.europe_data VALUES (5692, 120, 7319, 30.29, 200, 428);
INSERT INTO public.europe_data VALUES (5693, 7, 2086, 41.73, 143, 428);
INSERT INTO public.europe_data VALUES (5694, 96, 4444, 13.49, 201, 428);
INSERT INTO public.europe_data VALUES (5695, 0, 0, 0, 52, 428);
INSERT INTO public.europe_data VALUES (5696, 7925, 433935, 271.89, 101, 428);
INSERT INTO public.europe_data VALUES (5697, 1, 60, 118.57, 102, 428);
INSERT INTO public.europe_data VALUES (5698, 2, 94, 6.7, 103, 428);
INSERT INTO public.europe_data VALUES (5699, 38, 5008, 26.87, 144, 428);
INSERT INTO public.europe_data VALUES (5700, 32, 4743, 29.16, 104, 428);
INSERT INTO public.europe_data VALUES (5701, 6, 201, 0.26, 145, 428);
INSERT INTO public.europe_data VALUES (5702, 0, 0, 0, 53, 428);
INSERT INTO public.europe_data VALUES (5703, 18, 53, 0.44, 146, 428);
INSERT INTO public.europe_data VALUES (5704, 31, 1866, 18.85, 54, 428);
INSERT INTO public.europe_data VALUES (5705, 36, 1409, 15.77, 55, 428);
INSERT INTO public.europe_data VALUES (5706, 88, 788, 4.76, 105, 429);
INSERT INTO public.europe_data VALUES (5707, 26, 673, 45.73, 147, 429);
INSERT INTO public.europe_data VALUES (5708, 77, 4273, 18.96, 1, 429);
INSERT INTO public.europe_data VALUES (5709, 0, 17, 55.13, 148, 429);
INSERT INTO public.europe_data VALUES (5710, 11, 225, 1.33, 2, 429);
INSERT INTO public.europe_data VALUES (5711, 0, 0, 0, 56, 429);
INSERT INTO public.europe_data VALUES (5712, 0, 6, 8.24, 57, 429);
INSERT INTO public.europe_data VALUES (5713, 693, 40002, 145.19, 58, 429);
INSERT INTO public.europe_data VALUES (5714, 61, 2409, 177.13, 149, 429);
INSERT INTO public.europe_data VALUES (5715, 0, 6, 13.17, 59, 429);
INSERT INTO public.europe_data VALUES (5716, 33, 2601, 18.28, 202, 429);
INSERT INTO public.europe_data VALUES (5717, 2, 915, 18.5, 150, 429);
INSERT INTO public.europe_data VALUES (5718, 63, 2529, 59.8, 151, 429);
INSERT INTO public.europe_data VALUES (5719, 0, 189, 59.31, 60, 429);
INSERT INTO public.europe_data VALUES (5720, 14, 2709, 377.17, 106, 429);
INSERT INTO public.europe_data VALUES (5721, 310, 18928, 24.32, 107, 429);
INSERT INTO public.europe_data VALUES (5722, 0, 5, 2.44, 61, 429);
INSERT INTO public.europe_data VALUES (5723, 35, 1037, 23.27, 152, 429);
INSERT INTO public.europe_data VALUES (5724, 15, 2489, 33.82, 153, 429);
INSERT INTO public.europe_data VALUES (5725, 0, 8, 2.82, 62, 429);
INSERT INTO public.europe_data VALUES (5726, 4, 168, 3.32, 3, 429);
INSERT INTO public.europe_data VALUES (5727, 0, 1, 6.4, 63, 429);
INSERT INTO public.europe_data VALUES (5728, 0, 6, 1.44, 108, 429);
INSERT INTO public.europe_data VALUES (5729, 432, 9847, 184.5, 64, 429);
INSERT INTO public.europe_data VALUES (5730, 0, 1, 15.39, 65, 429);
INSERT INTO public.europe_data VALUES (5731, 33, 1617, 96.49, 154, 429);
INSERT INTO public.europe_data VALUES (5732, 0, 164, 12.46, 4, 429);
INSERT INTO public.europe_data VALUES (5733, 7516, 320702, 262.69, 66, 429);
INSERT INTO public.europe_data VALUES (5734, 0, 0, 0, 67, 429);
INSERT INTO public.europe_data VALUES (5735, 0, 0, 0, 109, 429);
INSERT INTO public.europe_data VALUES (5736, 40, 1694, 45.36, 155, 429);
INSERT INTO public.europe_data VALUES (5737, 0, 35, 0.31, 5, 429);
INSERT INTO public.europe_data VALUES (5738, 0, 51, 0.96, 6, 429);
INSERT INTO public.europe_data VALUES (5739, 0, 54, 0.42, 110, 429);
INSERT INTO public.europe_data VALUES (5740, 12, 551, 5.93, 7, 429);
INSERT INTO public.europe_data VALUES (5741, 38, 3560, 16.89, 68, 429);
INSERT INTO public.europe_data VALUES (5742, 1, 264, 110.74, 8, 429);
INSERT INTO public.europe_data VALUES (5743, 0, 0, 3.08, 69, 429);
INSERT INTO public.europe_data VALUES (5744, 4, 114, 6.55, 9, 429);
INSERT INTO public.europe_data VALUES (5745, 0, 26, 0.22, 10, 429);
INSERT INTO public.europe_data VALUES (5746, 609, 14860, 162.25, 70, 429);
INSERT INTO public.europe_data VALUES (5747, 6, 957, 0.1, 111, 429);
INSERT INTO public.europe_data VALUES (5748, 1789, 51698, 195.73, 71, 429);
INSERT INTO public.europe_data VALUES (5749, 0, 6, 2.7, 11, 429);
INSERT INTO public.europe_data VALUES (5750, 2, 405, 17.38, 12, 429);
INSERT INTO public.europe_data VALUES (5751, 42, 4115, 151.22, 72, 429);
INSERT INTO public.europe_data VALUES (5752, 4, 1477, 11, 13, 429);
INSERT INTO public.europe_data VALUES (5753, 16, 503, 27.84, 156, 429);
INSERT INTO public.europe_data VALUES (5754, 0, 49, 0.61, 73, 429);
INSERT INTO public.europe_data VALUES (5755, 0, 1, 2.45, 74, 429);
INSERT INTO public.europe_data VALUES (5756, 0, 19, 4.11, 157, 429);
INSERT INTO public.europe_data VALUES (5757, 12, 1379, 20.19, 158, 429);
INSERT INTO public.europe_data VALUES (5758, 11, 429, 0.92, 14, 429);
INSERT INTO public.europe_data VALUES (5759, 2, 265, 8.47, 159, 429);
INSERT INTO public.europe_data VALUES (5760, 2, 39, 8.01, 15, 429);
INSERT INTO public.europe_data VALUES (5761, 0, 0, 0, 75, 429);
INSERT INTO public.europe_data VALUES (5762, 82, 10053, 171.12, 76, 429);
INSERT INTO public.europe_data VALUES (5763, 202, 6681, 73.81, 77, 429);
INSERT INTO public.europe_data VALUES (5764, 304, 4287, 9.95, 16, 429);
INSERT INTO public.europe_data VALUES (5765, 64, 2784, 76.79, 78, 429);
INSERT INTO public.europe_data VALUES (5766, 0, 0, 0, 17, 429);
INSERT INTO public.europe_data VALUES (5767, 0, 12, 0.89, 18, 429);
INSERT INTO public.europe_data VALUES (5768, 0, 13, 1.51, 160, 429);
INSERT INTO public.europe_data VALUES (5769, 11, 414, 74.56, 19, 429);
INSERT INTO public.europe_data VALUES (5770, 56, 4465, 5.72, 20, 429);
INSERT INTO public.europe_data VALUES (5771, 0, 0, 0, 79, 429);
INSERT INTO public.europe_data VALUES (5772, 0, 0, 6.16, 161, 429);
INSERT INTO public.europe_data VALUES (5773, 0, 1, 0.11, 203, 429);
INSERT INTO public.europe_data VALUES (5774, 1, 55, 1.83, 162, 429);
INSERT INTO public.europe_data VALUES (5775, 40, 5854, 14.59, 163, 429);
INSERT INTO public.europe_data VALUES (5776, 0, 0, 0, 204, 429);
INSERT INTO public.europe_data VALUES (5777, 3, 669, 47.96, 21, 429);
INSERT INTO public.europe_data VALUES (5778, 2, 184, 9.07, 22, 429);
INSERT INTO public.europe_data VALUES (5779, 1, 109, 3.55, 164, 429);
INSERT INTO public.europe_data VALUES (5780, 32, 3786, 8.01, 165, 429);
INSERT INTO public.europe_data VALUES (5781, 20, 5302, 27.78, 23, 429);
INSERT INTO public.europe_data VALUES (5782, 0, 5, 14.83, 166, 429);
INSERT INTO public.europe_data VALUES (5783, 8, 186, 3.64, 167, 429);
INSERT INTO public.europe_data VALUES (5784, 0, 0, 0, 80, 429);
INSERT INTO public.europe_data VALUES (5785, 0, 0, 0, 81, 429);
INSERT INTO public.europe_data VALUES (5786, 0, 27, 20.32, 205, 429);
INSERT INTO public.europe_data VALUES (5787, 249, 6376, 89.29, 82, 429);
INSERT INTO public.europe_data VALUES (5788, 0, 0, 0, 168, 429);
INSERT INTO public.europe_data VALUES (5789, 4, 464, 6.79, 24, 429);
INSERT INTO public.europe_data VALUES (5790, 0, 27, 5.83, 25, 429);
INSERT INTO public.europe_data VALUES (5791, 1, 34, 9.33, 83, 429);
INSERT INTO public.europe_data VALUES (5792, 11, 262, 5.22, 84, 429);
INSERT INTO public.europe_data VALUES (5793, 0, 0, 0, 169, 429);
INSERT INTO public.europe_data VALUES (5794, 216, 5441, 114.77, 85, 429);
INSERT INTO public.europe_data VALUES (5795, 0, 115, 2.19, 170, 429);
INSERT INTO public.europe_data VALUES (5796, 0, 8, 3.92, 171, 429);
INSERT INTO public.europe_data VALUES (5797, 5274, 317410, 40.78, 112, 429);
INSERT INTO public.europe_data VALUES (5798, 638, 12257, 8.53, 113, 429);
INSERT INTO public.europe_data VALUES (5799, 1512, 17384, 40.85, 114, 429);
INSERT INTO public.europe_data VALUES (5800, 581, 17502, 82.74, 115, 429);
INSERT INTO public.europe_data VALUES (5801, 10, 121, 5.16, 172, 429);
INSERT INTO public.europe_data VALUES (5802, 0, 0, 0, 173, 429);
INSERT INTO public.europe_data VALUES (5803, 61, 11667, 273.33, 116, 429);
INSERT INTO public.europe_data VALUES (5804, 62, 1684, 5.06, 174, 429);
INSERT INTO public.europe_data VALUES (5805, 0, 52, 2.85, 86, 429);
INSERT INTO public.europe_data VALUES (5806, 11, 4893, 6.4, 117, 429);
INSERT INTO public.europe_data VALUES (5807, 0, 1, 6.49, 175, 429);
INSERT INTO public.europe_data VALUES (5808, 0, -50, -0.11, 118, 429);
INSERT INTO public.europe_data VALUES (5809, 210, 11284, 125.24, 119, 429);
INSERT INTO public.europe_data VALUES (5810, 46, 4250, 14.26, 26, 429);
INSERT INTO public.europe_data VALUES (5811, 34, 1182, 110.42, 176, 429);
INSERT INTO public.europe_data VALUES (5812, 25, 4569, 211.05, 120, 429);
INSERT INTO public.europe_data VALUES (5813, 264, 6153, 345.69, 121, 429);
INSERT INTO public.europe_data VALUES (5814, 0, 1, 0.01, 122, 429);
INSERT INTO public.europe_data VALUES (5815, 0, 27, 2.4, 177, 429);
INSERT INTO public.europe_data VALUES (5816, 11, 891, 20.65, 123, 429);
INSERT INTO public.europe_data VALUES (5817, 5, 87, 10.02, 27, 429);
INSERT INTO public.europe_data VALUES (5818, 2, 71, 3.08, 28, 429);
INSERT INTO public.europe_data VALUES (5819, 10, 681, 16.44, 29, 429);
INSERT INTO public.europe_data VALUES (5820, 0, 0, 5.21, 178, 429);
INSERT INTO public.europe_data VALUES (5821, 0, 76, 4.97, 179, 429);
INSERT INTO public.europe_data VALUES (5822, 1, 789, 219.42, 180, 429);
INSERT INTO public.europe_data VALUES (5823, 26, 2246, 16.42, 30, 429);
INSERT INTO public.europe_data VALUES (5824, 37, 648, 6.85, 31, 429);
INSERT INTO public.europe_data VALUES (5825, 1, 118, 0.56, 124, 429);
INSERT INTO public.europe_data VALUES (5826, 0, 336, 107.54, 125, 429);
INSERT INTO public.europe_data VALUES (5827, 2, 35, 0.5, 32, 429);
INSERT INTO public.europe_data VALUES (5828, 0, 24, 5.27, 181, 429);
INSERT INTO public.europe_data VALUES (5829, 1, 298, 23.09, 33, 429);
INSERT INTO public.europe_data VALUES (5830, 0, 1, 0.16, 34, 429);
INSERT INTO public.europe_data VALUES (5831, 4496, 48945, 77.36, 87, 429);
INSERT INTO public.europe_data VALUES (5832, 51, 2054, 90.32, 182, 429);
INSERT INTO public.europe_data VALUES (5833, 0, 5, 15.11, 183, 429);
INSERT INTO public.europe_data VALUES (5834, 0, 1, 1.8, 126, 429);
INSERT INTO public.europe_data VALUES (5835, 10, 798, 216.66, 184, 429);
INSERT INTO public.europe_data VALUES (5836, 0, 1, 20.04, 88, 429);
INSERT INTO public.europe_data VALUES (5837, 40, 3042, 12.43, 35, 429);
INSERT INTO public.europe_data VALUES (5838, 1, 178, 1.69, 36, 429);
INSERT INTO public.europe_data VALUES (5839, 0, 9, 0.04, 127, 429);
INSERT INTO public.europe_data VALUES (5840, 5, 528, 39.69, 37, 429);
INSERT INTO public.europe_data VALUES (5841, 5, 955, 6.33, 128, 429);
INSERT INTO public.europe_data VALUES (5842, 4, 1221, 11.13, 185, 429);
INSERT INTO public.europe_data VALUES (5843, 0, 0, 0.35, 208, 429);
INSERT INTO public.europe_data VALUES (5844, 0, 2, 0.25, 209, 429);
INSERT INTO public.europe_data VALUES (5845, 9, 292, 9.06, 89, 429);
INSERT INTO public.europe_data VALUES (5846, 0, 28, 0.14, 38, 429);
INSERT INTO public.europe_data VALUES (5847, 69, 3869, 3.97, 39, 429);
INSERT INTO public.europe_data VALUES (5848, 38, 954, 95.08, 186, 429);
INSERT INTO public.europe_data VALUES (5849, 0, 3, 12.23, 210, 429);
INSERT INTO public.europe_data VALUES (5850, 0, 70, 2.25, 187, 429);
INSERT INTO public.europe_data VALUES (5851, 66, 9344, 401.81, 129, 429);
INSERT INTO public.europe_data VALUES (5852, 243, 9206, 10.47, 130, 429);
INSERT INTO public.europe_data VALUES (5853, 16, 3077, 122.27, 131, 429);
INSERT INTO public.europe_data VALUES (5854, 198, 6828, 345.3, 90, 429);
INSERT INTO public.europe_data VALUES (5855, 0, 45, 0.58, 211, 429);
INSERT INTO public.europe_data VALUES (5856, 10, 723, 21.24, 91, 429);
INSERT INTO public.europe_data VALUES (5857, 5042, 31207, 179.85, 92, 429);
INSERT INTO public.europe_data VALUES (5858, 101, 12992, 22.37, 132, 429);
INSERT INTO public.europe_data VALUES (5859, 47, 2961, 13.63, 188, 429);
INSERT INTO public.europe_data VALUES (5860, 28, 1528, 35.54, 189, 429);
INSERT INTO public.europe_data VALUES (5861, 23, 3080, 181.43, 93, 429);
INSERT INTO public.europe_data VALUES (5862, 8, 2657, 201.51, 133, 429);
INSERT INTO public.europe_data VALUES (5863, 161, 7340, 63.16, 190, 429);
INSERT INTO public.europe_data VALUES (5864, 927, 40939, 58.49, 191, 429);
INSERT INTO public.europe_data VALUES (5865, 0, 239, 3.83, 40, 429);
INSERT INTO public.europe_data VALUES (5866, 0, 0, 0, 94, 429);
INSERT INTO public.europe_data VALUES (5867, 0, 1, 1.09, 95, 429);
INSERT INTO public.europe_data VALUES (5868, 0, 2, 15.37, 96, 429);
INSERT INTO public.europe_data VALUES (5869, 0, 0, 0, 192, 429);
INSERT INTO public.europe_data VALUES (5870, 0, 117, 62.31, 41, 429);
INSERT INTO public.europe_data VALUES (5871, 247, 16021, 101.21, 134, 429);
INSERT INTO public.europe_data VALUES (5872, 24, 871, 9.49, 42, 429);
INSERT INTO public.europe_data VALUES (5873, 62, 2836, 77.11, 193, 429);
INSERT INTO public.europe_data VALUES (5874, 0, 14, 14.32, 43, 429);
INSERT INTO public.europe_data VALUES (5875, 1, 72, 1.89, 44, 429);
INSERT INTO public.europe_data VALUES (5876, 0, 2457, 75.94, 135, 429);
INSERT INTO public.europe_data VALUES (5877, 0, 15, 37.75, 97, 429);
INSERT INTO public.europe_data VALUES (5878, 0, 200, 5.1, 194, 429);
INSERT INTO public.europe_data VALUES (5879, 4, 136, 11.58, 195, 429);
INSERT INTO public.europe_data VALUES (5880, 0, 59, 0.77, 45, 429);
INSERT INTO public.europe_data VALUES (5881, 1736, 81105, 288.93, 46, 429);
INSERT INTO public.europe_data VALUES (5882, 3, 404, 1.36, 136, 429);
INSERT INTO public.europe_data VALUES (5883, 2, 62, 1.11, 47, 429);
INSERT INTO public.europe_data VALUES (5884, 12, 13946, 48.64, 196, 429);
INSERT INTO public.europe_data VALUES (5885, 0, 58, 0.77, 137, 429);
INSERT INTO public.europe_data VALUES (5886, 37, 623, 2.65, 48, 429);
INSERT INTO public.europe_data VALUES (5887, 2, 410, 120.06, 98, 429);
INSERT INTO public.europe_data VALUES (5888, 30, 1316, 28.72, 197, 429);
INSERT INTO public.europe_data VALUES (5889, 13, 821, 17.87, 198, 429);
INSERT INTO public.europe_data VALUES (5890, 13, 154, 1.5, 138, 429);
INSERT INTO public.europe_data VALUES (5891, 0, 7, 0.05, 139, 429);
INSERT INTO public.europe_data VALUES (5892, 2, 314, 6.87, 140, 429);
INSERT INTO public.europe_data VALUES (5893, 0, 45, 0.11, 141, 429);
INSERT INTO public.europe_data VALUES (5894, 0, 0, 0, 142, 429);
INSERT INTO public.europe_data VALUES (5895, 3, 94, 1.83, 49, 429);
INSERT INTO public.europe_data VALUES (5896, 0, 10, 1, 99, 429);
INSERT INTO public.europe_data VALUES (5897, 0, 78, 1.62, 50, 429);
INSERT INTO public.europe_data VALUES (5898, 122, 6459, 15.98, 199, 429);
INSERT INTO public.europe_data VALUES (5899, 0, 18, 70.69, 100, 429);
INSERT INTO public.europe_data VALUES (5900, 2, 50, 0.2, 51, 429);
INSERT INTO public.europe_data VALUES (5901, 120, 6007, 25.75, 200, 429);
INSERT INTO public.europe_data VALUES (5902, 5, 1991, 41.54, 143, 429);
INSERT INTO public.europe_data VALUES (5903, 116, 4549, 13.29, 201, 429);
INSERT INTO public.europe_data VALUES (5904, 0, 0, 0, 52, 429);
INSERT INTO public.europe_data VALUES (5905, 6401, 460760, 282.34, 101, 429);
INSERT INTO public.europe_data VALUES (5906, 1, 64, 172.12, 102, 429);
INSERT INTO public.europe_data VALUES (5907, 1, 138, 5.92, 103, 429);
INSERT INTO public.europe_data VALUES (5908, 29, 3854, 23.12, 144, 429);
INSERT INTO public.europe_data VALUES (5909, 30, 3572, 21.03, 104, 429);
INSERT INTO public.europe_data VALUES (5910, 0, 47, 0.05, 145, 429);
INSERT INTO public.europe_data VALUES (5911, 0, 0, 42.41, 53, 429);
INSERT INTO public.europe_data VALUES (5912, 34, 75, 0.74, 146, 429);
INSERT INTO public.europe_data VALUES (5913, 30, 1501, 14.48, 54, 429);
INSERT INTO public.europe_data VALUES (5914, 9, 901, 10.43, 55, 429);
INSERT INTO public.europe_data VALUES (5915, 171, 1024, 6.63, 105, 430);
INSERT INTO public.europe_data VALUES (5916, 19, 636, 41.82, 147, 430);
INSERT INTO public.europe_data VALUES (5917, 67, 3889, 16.59, 1, 430);
INSERT INTO public.europe_data VALUES (5918, 0, 25, 32.82, 148, 430);
INSERT INTO public.europe_data VALUES (5919, 3, 199, 1.13, 2, 430);
INSERT INTO public.europe_data VALUES (5920, 0, 0, 0, 56, 430);
INSERT INTO public.europe_data VALUES (5921, 0, 2, 8.24, 57, 430);
INSERT INTO public.europe_data VALUES (5922, 428, 25015, 105.29, 58, 430);
INSERT INTO public.europe_data VALUES (5923, 77, 2830, 204.38, 149, 430);
INSERT INTO public.europe_data VALUES (5924, 0, 8, 7.53, 59, 430);
INSERT INTO public.europe_data VALUES (5925, 14, 2005, 13.3, 202, 430);
INSERT INTO public.europe_data VALUES (5926, 2, 724, 14.7, 150, 430);
INSERT INTO public.europe_data VALUES (5927, 48, 3480, 71.63, 151, 430);
INSERT INTO public.europe_data VALUES (5928, 0, 42, 12.58, 60, 430);
INSERT INTO public.europe_data VALUES (5929, 17, 3481, 429.88, 106, 430);
INSERT INTO public.europe_data VALUES (5930, 266, 20730, 25.83, 107, 430);
INSERT INTO public.europe_data VALUES (5931, 0, 2, 2.44, 61, 430);
INSERT INTO public.europe_data VALUES (5932, 35, 1163, 26.88, 152, 430);
INSERT INTO public.europe_data VALUES (5933, 19, 1385, 18.24, 153, 430);
INSERT INTO public.europe_data VALUES (5934, 0, 3, 2.56, 62, 430);
INSERT INTO public.europe_data VALUES (5935, 5, 224, 3.41, 3, 430);
INSERT INTO public.europe_data VALUES (5936, 0, 3, 11.2, 63, 430);
INSERT INTO public.europe_data VALUES (5937, 0, 5, 1.18, 108, 430);
INSERT INTO public.europe_data VALUES (5938, 344, 11395, 176.19, 64, 430);
INSERT INTO public.europe_data VALUES (5939, 0, 3, 11.55, 65, 430);
INSERT INTO public.europe_data VALUES (5940, 30, 1568, 92.67, 154, 430);
INSERT INTO public.europe_data VALUES (5941, 0, 123, 10.72, 4, 430);
INSERT INTO public.europe_data VALUES (5942, 7388, 233708, 234.7, 66, 430);
INSERT INTO public.europe_data VALUES (5943, 0, 0, 0, 67, 430);
INSERT INTO public.europe_data VALUES (5944, 0, 0, 0, 109, 430);
INSERT INTO public.europe_data VALUES (5945, 32, 1481, 42.76, 155, 430);
INSERT INTO public.europe_data VALUES (5946, 0, 29, 0.38, 5, 430);
INSERT INTO public.europe_data VALUES (5947, 0, 60, 1.03, 6, 430);
INSERT INTO public.europe_data VALUES (5948, 0, 15, 0.18, 110, 430);
INSERT INTO public.europe_data VALUES (5949, 14, 984, 9.45, 7, 430);
INSERT INTO public.europe_data VALUES (5950, 69, 2759, 12.87, 68, 430);
INSERT INTO public.europe_data VALUES (5951, 2, 345, 107.65, 8, 430);
INSERT INTO public.europe_data VALUES (5952, 0, 2, 3.08, 69, 430);
INSERT INTO public.europe_data VALUES (5953, 2, 197, 10.87, 9, 430);
INSERT INTO public.europe_data VALUES (5954, 0, 9, 0.11, 10, 430);
INSERT INTO public.europe_data VALUES (5955, 1524, 15889, 186.78, 70, 430);
INSERT INTO public.europe_data VALUES (5956, 5, 496, 0.05, 111, 430);
INSERT INTO public.europe_data VALUES (5957, 1429, 46833, 159.25, 71, 430);
INSERT INTO public.europe_data VALUES (5958, 0, 17, 2.7, 11, 430);
INSERT INTO public.europe_data VALUES (5959, 2, 530, 20, 12, 430);
INSERT INTO public.europe_data VALUES (5960, 32, 3518, 121.21, 72, 430);
INSERT INTO public.europe_data VALUES (5961, 8, 1353, 13.01, 13, 430);
INSERT INTO public.europe_data VALUES (5962, 1, 632, 29.51, 156, 430);
INSERT INTO public.europe_data VALUES (5963, 0, 20, 0.65, 73, 430);
INSERT INTO public.europe_data VALUES (5964, 0, 3, 1.84, 74, 430);
INSERT INTO public.europe_data VALUES (5965, 0, 17, 4, 157, 430);
INSERT INTO public.europe_data VALUES (5966, 7, 771, 13.43, 158, 430);
INSERT INTO public.europe_data VALUES (5967, 5, 370, 1.14, 14, 430);
INSERT INTO public.europe_data VALUES (5968, 2, 227, 5.87, 159, 430);
INSERT INTO public.europe_data VALUES (5969, 0, 39, 22.49, 15, 430);
INSERT INTO public.europe_data VALUES (5970, 0, 0, 0, 75, 430);
INSERT INTO public.europe_data VALUES (5971, 84, 8323, 143.68, 76, 430);
INSERT INTO public.europe_data VALUES (5972, 266, 6143, 69.39, 77, 430);
INSERT INTO public.europe_data VALUES (5973, 444, 5705, 12.47, 16, 430);
INSERT INTO public.europe_data VALUES (5974, 77, 2172, 63.05, 78, 430);
INSERT INTO public.europe_data VALUES (5975, 0, 0, 0, 17, 430);
INSERT INTO public.europe_data VALUES (5976, 0, 19, 1.03, 18, 430);
INSERT INTO public.europe_data VALUES (5977, 0, 7, 2.11, 160, 430);
INSERT INTO public.europe_data VALUES (5978, 1, 442, 70.11, 19, 430);
INSERT INTO public.europe_data VALUES (5979, 40, 1943, 3.26, 20, 430);
INSERT INTO public.europe_data VALUES (5980, 0, 0, 0, 79, 430);
INSERT INTO public.europe_data VALUES (5981, 0, 3, 8.22, 161, 430);
INSERT INTO public.europe_data VALUES (5982, 0, 0, 0.9, 203, 430);
INSERT INTO public.europe_data VALUES (5983, 0, 46, 1.2, 162, 430);
INSERT INTO public.europe_data VALUES (5984, 148, 3922, 11.51, 163, 430);
INSERT INTO public.europe_data VALUES (5985, 0, 0, 0, 204, 430);
INSERT INTO public.europe_data VALUES (5986, 0, 373, 31.99, 21, 430);
INSERT INTO public.europe_data VALUES (5987, 1, 29, 1.53, 22, 430);
INSERT INTO public.europe_data VALUES (5988, 0, 33, 1.88, 164, 430);
INSERT INTO public.europe_data VALUES (5989, 22, 2860, 6.35, 165, 430);
INSERT INTO public.europe_data VALUES (5990, 9, 3149, 24.93, 23, 430);
INSERT INTO public.europe_data VALUES (5991, 0, 0, 5.93, 166, 430);
INSERT INTO public.europe_data VALUES (5992, 1, 204, 4.55, 167, 430);
INSERT INTO public.europe_data VALUES (5993, 0, 0, 0, 80, 430);
INSERT INTO public.europe_data VALUES (5994, 0, 0, 0, 81, 430);
INSERT INTO public.europe_data VALUES (5995, 0, 7, 10.76, 205, 430);
INSERT INTO public.europe_data VALUES (5996, 266, 9322, 87.76, 82, 430);
INSERT INTO public.europe_data VALUES (5997, 0, 0, 0, 168, 430);
INSERT INTO public.europe_data VALUES (5998, 2, 403, 7.31, 24, 430);
INSERT INTO public.europe_data VALUES (5999, 1, 85, 8.43, 25, 430);
INSERT INTO public.europe_data VALUES (6000, 2, 39, 8.05, 83, 430);
INSERT INTO public.europe_data VALUES (6001, 7, 326, 6.39, 84, 430);
INSERT INTO public.europe_data VALUES (6002, 0, 0, 0, 169, 430);
INSERT INTO public.europe_data VALUES (6003, 126, 5745, 101.5, 85, 430);
INSERT INTO public.europe_data VALUES (6004, 1, 99, 1.53, 170, 430);
INSERT INTO public.europe_data VALUES (6005, 0, 6, 2.52, 171, 430);
INSERT INTO public.europe_data VALUES (6006, 4323, 239789, 30.78, 112, 430);
INSERT INTO public.europe_data VALUES (6007, 537, 10822, 8.41, 113, 430);
INSERT INTO public.europe_data VALUES (6008, 1359, 16485, 40.22, 114, 430);
INSERT INTO public.europe_data VALUES (6009, 631, 15024, 81.53, 115, 430);
INSERT INTO public.europe_data VALUES (6010, 7, 132, 4.75, 172, 430);
INSERT INTO public.europe_data VALUES (6011, 0, 0, 0, 173, 430);
INSERT INTO public.europe_data VALUES (6012, 47, 11619, 238.64, 116, 430);
INSERT INTO public.europe_data VALUES (6013, 91, 1373, 4.68, 174, 430);
INSERT INTO public.europe_data VALUES (6014, 0, 32, 1.97, 86, 430);
INSERT INTO public.europe_data VALUES (6015, 3, 3228, 4.19, 117, 430);
INSERT INTO public.europe_data VALUES (6016, 0, 6, 10.2, 175, 430);
INSERT INTO public.europe_data VALUES (6017, 1, 39, 0.53, 118, 430);
INSERT INTO public.europe_data VALUES (6018, 0, 11949, 125.4, 119, 430);
INSERT INTO public.europe_data VALUES (6019, 49, 3248, 10.4, 26, 430);
INSERT INTO public.europe_data VALUES (6020, 33, 804, 132.28, 176, 430);
INSERT INTO public.europe_data VALUES (6021, 18, 4310, 220.18, 120, 430);
INSERT INTO public.europe_data VALUES (6022, 890, 16026, 303.19, 121, 430);
INSERT INTO public.europe_data VALUES (6023, 0, 0, 0, 122, 430);
INSERT INTO public.europe_data VALUES (6024, 1, 19, 3.54, 177, 430);
INSERT INTO public.europe_data VALUES (6025, 4, 525, 14.38, 123, 430);
INSERT INTO public.europe_data VALUES (6026, 4, 126, 13.17, 27, 430);
INSERT INTO public.europe_data VALUES (6027, 19, 81, 4.4, 28, 430);
INSERT INTO public.europe_data VALUES (6028, 9, 433, 12.94, 29, 430);
INSERT INTO public.europe_data VALUES (6029, 0, 2, 7.82, 178, 430);
INSERT INTO public.europe_data VALUES (6030, 1, 63, 3.44, 179, 430);
INSERT INTO public.europe_data VALUES (6031, 0, 558, 156.54, 180, 430);
INSERT INTO public.europe_data VALUES (6032, 24, 2182, 16.02, 30, 430);
INSERT INTO public.europe_data VALUES (6033, 24, 628, 6.71, 31, 430);
INSERT INTO public.europe_data VALUES (6034, 1, 61, 0.38, 124, 430);
INSERT INTO public.europe_data VALUES (6035, 2, 235, 93.79, 125, 430);
INSERT INTO public.europe_data VALUES (6036, 0, 64, 0.74, 32, 430);
INSERT INTO public.europe_data VALUES (6037, 0, 2, 0.81, 181, 430);
INSERT INTO public.europe_data VALUES (6038, 11, 747, 21.96, 33, 430);
INSERT INTO public.europe_data VALUES (6039, 0, 1, 0.16, 34, 430);
INSERT INTO public.europe_data VALUES (6040, 4178, 49745, 73.68, 87, 430);
INSERT INTO public.europe_data VALUES (6041, 42, 1598, 78.3, 182, 430);
INSERT INTO public.europe_data VALUES (6042, 0, 0, 3.02, 183, 430);
INSERT INTO public.europe_data VALUES (6043, 0, 57, 2.08, 126, 430);
INSERT INTO public.europe_data VALUES (6044, 7, 550, 159.12, 184, 430);
INSERT INTO public.europe_data VALUES (6045, 0, 0, 20.04, 88, 430);
INSERT INTO public.europe_data VALUES (6046, 23, 1491, 8.28, 35, 430);
INSERT INTO public.europe_data VALUES (6047, 1, 334, 1.66, 36, 430);
INSERT INTO public.europe_data VALUES (6048, 0, 10, 0.05, 127, 430);
INSERT INTO public.europe_data VALUES (6049, 2, 462, 33.47, 37, 430);
INSERT INTO public.europe_data VALUES (6050, 2, 857, 6.55, 128, 430);
INSERT INTO public.europe_data VALUES (6051, 1, 703, 6.39, 185, 430);
INSERT INTO public.europe_data VALUES (6052, 0, 1, 0.35, 208, 430);
INSERT INTO public.europe_data VALUES (6053, 0, 10, 0.44, 209, 430);
INSERT INTO public.europe_data VALUES (6054, 8, 301, 9.59, 89, 430);
INSERT INTO public.europe_data VALUES (6055, 1, 5, 0.05, 38, 430);
INSERT INTO public.europe_data VALUES (6056, 49, 4105, 3.96, 39, 430);
INSERT INTO public.europe_data VALUES (6057, 40, 1021, 100.43, 186, 430);
INSERT INTO public.europe_data VALUES (6058, 0, 4, 10.49, 210, 430);
INSERT INTO public.europe_data VALUES (6059, 3, 50, 2.25, 187, 430);
INSERT INTO public.europe_data VALUES (6060, 61, 10646, 411.72, 129, 430);
INSERT INTO public.europe_data VALUES (6061, 333, 13458, 15.36, 130, 430);
INSERT INTO public.europe_data VALUES (6062, 25, 3014, 112.3, 131, 430);
INSERT INTO public.europe_data VALUES (6063, 187, 7835, 360.75, 90, 430);
INSERT INTO public.europe_data VALUES (6064, 0, 6, 0.07, 211, 430);
INSERT INTO public.europe_data VALUES (6065, 9, 773, 18.37, 91, 430);
INSERT INTO public.europe_data VALUES (6066, 1317, 27264, 156.48, 92, 430);
INSERT INTO public.europe_data VALUES (6067, 297, 11197, 23.7, 132, 430);
INSERT INTO public.europe_data VALUES (6068, 53, 2213, 10.94, 188, 430);
INSERT INTO public.europe_data VALUES (6069, 29, 2124, 46.11, 189, 430);
INSERT INTO public.europe_data VALUES (6070, 11, 2242, 141.37, 93, 430);
INSERT INTO public.europe_data VALUES (6071, 10, 3050, 241.84, 133, 430);
INSERT INTO public.europe_data VALUES (6072, 142, 4923, 43.7, 190, 430);
INSERT INTO public.europe_data VALUES (6073, 1007, 44384, 61.9, 191, 430);
INSERT INTO public.europe_data VALUES (6074, 1, 245, 3.78, 40, 430);
INSERT INTO public.europe_data VALUES (6075, 0, 0, 1.89, 94, 430);
INSERT INTO public.europe_data VALUES (6076, 0, 1, 0.55, 95, 430);
INSERT INTO public.europe_data VALUES (6077, 0, 15, 18.99, 96, 430);
INSERT INTO public.europe_data VALUES (6078, 0, 0, 2.9, 192, 430);
INSERT INTO public.europe_data VALUES (6079, 0, 17, 12.09, 41, 430);
INSERT INTO public.europe_data VALUES (6080, 263, 18661, 120.84, 134, 430);
INSERT INTO public.europe_data VALUES (6081, 19, 675, 8.65, 42, 430);
INSERT INTO public.europe_data VALUES (6082, 79, 2534, 68.4, 193, 430);
INSERT INTO public.europe_data VALUES (6083, 0, 0, 91.06, 43, 430);
INSERT INTO public.europe_data VALUES (6084, 2, 76, 2.16, 44, 430);
INSERT INTO public.europe_data VALUES (6085, 1, 1951, 55.96, 135, 430);
INSERT INTO public.europe_data VALUES (6086, 0, 1, 2.36, 97, 430);
INSERT INTO public.europe_data VALUES (6087, 0, 78, 3.94, 194, 430);
INSERT INTO public.europe_data VALUES (6088, 0, 105, 11.82, 195, 430);
INSERT INTO public.europe_data VALUES (6089, 0, 60, 0.79, 45, 430);
INSERT INTO public.europe_data VALUES (6090, 954, 88086, 286.17, 46, 430);
INSERT INTO public.europe_data VALUES (6091, 7, 292, 1.33, 136, 430);
INSERT INTO public.europe_data VALUES (6092, 2, 61, 1.48, 47, 430);
INSERT INTO public.europe_data VALUES (6093, 16, 8883, 27.8, 196, 430);
INSERT INTO public.europe_data VALUES (6094, 0, 107, 3.04, 137, 430);
INSERT INTO public.europe_data VALUES (6095, 30, 512, 2.32, 48, 430);
INSERT INTO public.europe_data VALUES (6096, 3, 288, 74.82, 98, 430);
INSERT INTO public.europe_data VALUES (6097, 57, 1622, 37.15, 197, 430);
INSERT INTO public.europe_data VALUES (6098, 2, 706, 15.45, 198, 430);
INSERT INTO public.europe_data VALUES (6099, 9, 102, 0.81, 138, 430);
INSERT INTO public.europe_data VALUES (6100, 0, 4, 0.03, 139, 430);
INSERT INTO public.europe_data VALUES (6101, 2, 326, 7.13, 140, 430);
INSERT INTO public.europe_data VALUES (6102, 0, 30, 0.08, 141, 430);
INSERT INTO public.europe_data VALUES (6103, 0, 0, 0, 142, 430);
INSERT INTO public.europe_data VALUES (6104, 0, 54, 1.16, 49, 430);
INSERT INTO public.europe_data VALUES (6105, 0, 4, 0.29, 99, 430);
INSERT INTO public.europe_data VALUES (6106, 0, 111, 1.59, 50, 430);
INSERT INTO public.europe_data VALUES (6107, 128, 6648, 16.93, 199, 430);
INSERT INTO public.europe_data VALUES (6108, 0, 9, 89.02, 100, 430);
INSERT INTO public.europe_data VALUES (6109, 0, 40, 0.28, 51, 430);
INSERT INTO public.europe_data VALUES (6110, 102, 5321, 23.51, 200, 430);
INSERT INTO public.europe_data VALUES (6111, 6, 2068, 55.08, 143, 430);
INSERT INTO public.europe_data VALUES (6112, 150, 4310, 12.88, 201, 430);
INSERT INTO public.europe_data VALUES (6113, 0, 0, 0, 52, 430);
INSERT INTO public.europe_data VALUES (6114, 5329, 468318, 268.83, 101, 430);
INSERT INTO public.europe_data VALUES (6115, 0, 116, 176.9, 102, 430);
INSERT INTO public.europe_data VALUES (6116, 2, 67, 2.83, 103, 430);
INSERT INTO public.europe_data VALUES (6117, 27, 3773, 20.69, 144, 430);
INSERT INTO public.europe_data VALUES (6118, 23, 2426, 16.56, 104, 430);
INSERT INTO public.europe_data VALUES (6119, 0, 1, 0.02, 145, 430);
INSERT INTO public.europe_data VALUES (6120, 0, 247, 42.41, 53, 430);
INSERT INTO public.europe_data VALUES (6121, 28, 141, 1.17, 146, 430);
INSERT INTO public.europe_data VALUES (6122, 67, 1085, 7.55, 54, 430);
INSERT INTO public.europe_data VALUES (6123, 7, 626, 6.11, 55, 430);
INSERT INTO public.europe_data VALUES (6124, 146, 1500, 9.16, 105, 431);
INSERT INTO public.europe_data VALUES (6125, 17, 561, 36.75, 147, 431);
INSERT INTO public.europe_data VALUES (6126, 59, 3254, 13.76, 1, 431);
INSERT INTO public.europe_data VALUES (6127, 0, 0, 0, 148, 431);
INSERT INTO public.europe_data VALUES (6128, 7, 160, 0.75, 2, 431);
INSERT INTO public.europe_data VALUES (6129, 0, 0, 0, 56, 431);
INSERT INTO public.europe_data VALUES (6130, 0, 6, 9.27, 57, 431);
INSERT INTO public.europe_data VALUES (6131, 328, 22133, 88.8, 58, 431);
INSERT INTO public.europe_data VALUES (6132, 82, 3215, 237.48, 149, 431);
INSERT INTO public.europe_data VALUES (6133, 0, 0, 3.76, 59, 431);
INSERT INTO public.europe_data VALUES (6134, 4, 1348, 8.38, 202, 431);
INSERT INTO public.europe_data VALUES (6135, 2, 578, 13.79, 150, 431);
INSERT INTO public.europe_data VALUES (6136, 56, 3717, 75.81, 151, 431);
INSERT INTO public.europe_data VALUES (6137, 0, 7, 1.8, 60, 431);
INSERT INTO public.europe_data VALUES (6138, 12, 3574, 440.91, 106, 431);
INSERT INTO public.europe_data VALUES (6139, 300, 21378, 28.22, 107, 431);
INSERT INTO public.europe_data VALUES (6140, 0, 5, 2.09, 61, 431);
INSERT INTO public.europe_data VALUES (6141, 41, 1378, 36.57, 152, 431);
INSERT INTO public.europe_data VALUES (6142, 13, 704, 11.71, 153, 431);
INSERT INTO public.europe_data VALUES (6143, 0, 7, 3.33, 62, 431);
INSERT INTO public.europe_data VALUES (6144, 5, 179, 1.94, 3, 431);
INSERT INTO public.europe_data VALUES (6145, 0, 4, 6.4, 63, 431);
INSERT INTO public.europe_data VALUES (6146, 0, 4, 1.05, 108, 431);
INSERT INTO public.europe_data VALUES (6147, 373, 8890, 144.73, 64, 431);
INSERT INTO public.europe_data VALUES (6148, 0, 0, 0, 65, 431);
INSERT INTO public.europe_data VALUES (6149, 27, 1491, 80.85, 154, 431);
INSERT INTO public.europe_data VALUES (6150, 0, 124, 11.89, 4, 431);
INSERT INTO public.europe_data VALUES (6151, 7233, 261626, 246.64, 66, 431);
INSERT INTO public.europe_data VALUES (6152, 0, 0, 0, 67, 431);
INSERT INTO public.europe_data VALUES (6153, 0, 0, 0, 109, 431);
INSERT INTO public.europe_data VALUES (6154, 22, 1512, 36.59, 155, 431);
INSERT INTO public.europe_data VALUES (6155, 0, 49, 0.38, 5, 431);
INSERT INTO public.europe_data VALUES (6156, 0, 59, 0.69, 6, 431);
INSERT INTO public.europe_data VALUES (6157, 0, 15, 0.09, 110, 431);
INSERT INTO public.europe_data VALUES (6158, 31, 1462, 9.97, 7, 431);
INSERT INTO public.europe_data VALUES (6159, 99, 2055, 11.6, 68, 431);
INSERT INTO public.europe_data VALUES (6160, 2, 247, 98.74, 8, 431);
INSERT INTO public.europe_data VALUES (6161, 0, 0, 7.7, 69, 431);
INSERT INTO public.europe_data VALUES (6162, 5, 319, 18.1, 9, 431);
INSERT INTO public.europe_data VALUES (6163, 1, 8, 0.09, 10, 431);
INSERT INTO public.europe_data VALUES (6164, 671, 19509, 227.2, 70, 431);
INSERT INTO public.europe_data VALUES (6165, 0, 246, 0.03, 111, 431);
INSERT INTO public.europe_data VALUES (6166, 1243, 33335, 116.56, 71, 431);
INSERT INTO public.europe_data VALUES (6167, 0, 6, 5.29, 11, 431);
INSERT INTO public.europe_data VALUES (6168, 3, 546, 15.95, 12, 431);
INSERT INTO public.europe_data VALUES (6169, 11, 2600, 88.48, 72, 431);
INSERT INTO public.europe_data VALUES (6170, 10, 1994, 14.86, 13, 431);
INSERT INTO public.europe_data VALUES (6171, 6, 571, 25.29, 156, 431);
INSERT INTO public.europe_data VALUES (6172, 1, 54, 0.83, 73, 431);
INSERT INTO public.europe_data VALUES (6173, 0, 0, 0.61, 74, 431);
INSERT INTO public.europe_data VALUES (6174, 0, 18, 3.08, 157, 431);
INSERT INTO public.europe_data VALUES (6175, 4, 659, 14.75, 158, 431);
INSERT INTO public.europe_data VALUES (6176, 7, 622, 1.39, 14, 431);
INSERT INTO public.europe_data VALUES (6177, 3, 114, 4.67, 159, 431);
INSERT INTO public.europe_data VALUES (6178, 1, 180, 33.79, 15, 431);
INSERT INTO public.europe_data VALUES (6179, 0, 0, 0, 75, 431);
INSERT INTO public.europe_data VALUES (6180, 103, 7107, 122.54, 76, 431);
INSERT INTO public.europe_data VALUES (6181, 266, 5912, 72.61, 77, 431);
INSERT INTO public.europe_data VALUES (6182, 515, 6817, 16.82, 16, 431);
INSERT INTO public.europe_data VALUES (6183, 50, 1897, 57.95, 78, 431);
INSERT INTO public.europe_data VALUES (6184, 0, 0, 78.91, 17, 431);
INSERT INTO public.europe_data VALUES (6185, 0, 17, 1.17, 18, 431);
INSERT INTO public.europe_data VALUES (6186, 0, 21, 2.04, 160, 431);
INSERT INTO public.europe_data VALUES (6187, 7, 363, 49.65, 19, 431);
INSERT INTO public.europe_data VALUES (6188, 24, 1714, 1.67, 20, 431);
INSERT INTO public.europe_data VALUES (6189, 0, 0, 0, 79, 431);
INSERT INTO public.europe_data VALUES (6190, 0, 1, 2.05, 161, 431);
INSERT INTO public.europe_data VALUES (6191, 0, 8, 0.9, 203, 431);
INSERT INTO public.europe_data VALUES (6192, 0, 20, 1.83, 162, 431);
INSERT INTO public.europe_data VALUES (6193, 111, 3792, 11.66, 163, 431);
INSERT INTO public.europe_data VALUES (6194, 0, 0, 0, 204, 431);
INSERT INTO public.europe_data VALUES (6195, 2, 322, 33.74, 21, 431);
INSERT INTO public.europe_data VALUES (6196, 1, 7, 0.81, 22, 431);
INSERT INTO public.europe_data VALUES (6197, 0, 42, 1.73, 164, 431);
INSERT INTO public.europe_data VALUES (6198, 48, 2409, 6.27, 165, 431);
INSERT INTO public.europe_data VALUES (6199, 17, 4433, 23.56, 23, 431);
INSERT INTO public.europe_data VALUES (6200, 0, 2, 8.9, 166, 431);
INSERT INTO public.europe_data VALUES (6201, 1, 284, 3.98, 167, 431);
INSERT INTO public.europe_data VALUES (6202, 0, 0, 0, 80, 431);
INSERT INTO public.europe_data VALUES (6203, 0, 0, 0, 81, 431);
INSERT INTO public.europe_data VALUES (6204, 0, 11, 35.27, 205, 431);
INSERT INTO public.europe_data VALUES (6205, 272, 6107, 70.67, 82, 431);
INSERT INTO public.europe_data VALUES (6206, 0, 0, 0, 168, 431);
INSERT INTO public.europe_data VALUES (6207, 3, 531, 6.26, 24, 431);
INSERT INTO public.europe_data VALUES (6208, 0, 77, 11.87, 25, 431);
INSERT INTO public.europe_data VALUES (6209, 2, 24, 8.56, 83, 431);
INSERT INTO public.europe_data VALUES (6210, 26, 394, 7.81, 84, 431);
INSERT INTO public.europe_data VALUES (6211, 0, 0, 0, 169, 431);
INSERT INTO public.europe_data VALUES (6212, 135, 4147, 102.69, 85, 431);
INSERT INTO public.europe_data VALUES (6213, 6, 51, 0.94, 170, 431);
INSERT INTO public.europe_data VALUES (6214, 0, 3, 3.36, 171, 431);
INSERT INTO public.europe_data VALUES (6215, 3481, 180841, 24.15, 112, 431);
INSERT INTO public.europe_data VALUES (6216, 435, 11950, 8.01, 113, 431);
INSERT INTO public.europe_data VALUES (6217, 1258, 16865, 41.77, 114, 431);
INSERT INTO public.europe_data VALUES (6218, 677, 17027, 81.67, 115, 431);
INSERT INTO public.europe_data VALUES (6219, 5, 101, 3.85, 172, 431);
INSERT INTO public.europe_data VALUES (6220, 0, 0, 0, 173, 431);
INSERT INTO public.europe_data VALUES (6221, 31, 8712, 175.07, 116, 431);
INSERT INTO public.europe_data VALUES (6222, 93, 1450, 4.56, 174, 431);
INSERT INTO public.europe_data VALUES (6223, 0, 26, 2.1, 86, 431);
INSERT INTO public.europe_data VALUES (6224, 5, 2093, 2.67, 117, 431);
INSERT INTO public.europe_data VALUES (6225, 0, 5, 5.57, 175, 431);
INSERT INTO public.europe_data VALUES (6226, 0, 15, 0.57, 118, 431);
INSERT INTO public.europe_data VALUES (6227, 187, 11315, 207.87, 119, 431);
INSERT INTO public.europe_data VALUES (6228, 25, 2219, 7.67, 26, 431);
INSERT INTO public.europe_data VALUES (6229, 36, 1575, 125.33, 176, 431);
INSERT INTO public.europe_data VALUES (6230, 22, 4953, 236.55, 120, 431);
INSERT INTO public.europe_data VALUES (6231, 55, 3426, 95.08, 121, 431);
INSERT INTO public.europe_data VALUES (6232, 0, 0, 0, 122, 431);
INSERT INTO public.europe_data VALUES (6233, 0, 49, 2.97, 177, 431);
INSERT INTO public.europe_data VALUES (6234, 0, 461, 8.66, 123, 431);
INSERT INTO public.europe_data VALUES (6235, 2, 154, 9.69, 27, 431);
INSERT INTO public.europe_data VALUES (6236, 14, 136, 4.9, 28, 431);
INSERT INTO public.europe_data VALUES (6237, 12, 444, 9.9, 29, 431);
INSERT INTO public.europe_data VALUES (6238, 0, 1, 5.21, 178, 431);
INSERT INTO public.europe_data VALUES (6239, 0, 33, 1.9, 179, 431);
INSERT INTO public.europe_data VALUES (6240, 1, 403, 111.26, 180, 431);
INSERT INTO public.europe_data VALUES (6241, 6, 2139, 10.34, 30, 431);
INSERT INTO public.europe_data VALUES (6242, 19, 622, 6.54, 31, 431);
INSERT INTO public.europe_data VALUES (6243, 1, 60, 0.26, 124, 431);
INSERT INTO public.europe_data VALUES (6244, 2, 263, 76.84, 125, 431);
INSERT INTO public.europe_data VALUES (6245, 2, 81, 1.34, 32, 431);
INSERT INTO public.europe_data VALUES (6246, 0, 2, 0.81, 181, 431);
INSERT INTO public.europe_data VALUES (6247, 14, 247, 26.94, 33, 431);
INSERT INTO public.europe_data VALUES (6248, 0, 1, 0.08, 34, 431);
INSERT INTO public.europe_data VALUES (6249, 4367, 44253, 68.19, 87, 431);
INSERT INTO public.europe_data VALUES (6250, 57, 1568, 77.46, 182, 431);
INSERT INTO public.europe_data VALUES (6251, 0, 1, 18.14, 183, 431);
INSERT INTO public.europe_data VALUES (6252, 0, 10, 0.31, 126, 431);
INSERT INTO public.europe_data VALUES (6253, 9, 440, 118.94, 184, 431);
INSERT INTO public.europe_data VALUES (6254, 0, 1, 20.04, 88, 431);
INSERT INTO public.europe_data VALUES (6255, 15, 1530, 10.13, 35, 431);
INSERT INTO public.europe_data VALUES (6256, 1, 170, 0.98, 36, 431);
INSERT INTO public.europe_data VALUES (6257, 0, 18, 0.06, 127, 431);
INSERT INTO public.europe_data VALUES (6258, 1, 373, 24.13, 37, 431);
INSERT INTO public.europe_data VALUES (6259, 4, 1017, 14.08, 128, 431);
INSERT INTO public.europe_data VALUES (6260, 8, 401, 5.06, 185, 431);
INSERT INTO public.europe_data VALUES (6261, 0, 0, 0, 208, 431);
INSERT INTO public.europe_data VALUES (6262, 0, 11, 0.33, 209, 431);
INSERT INTO public.europe_data VALUES (6263, 8, 327, 10.33, 89, 431);
INSERT INTO public.europe_data VALUES (6264, 0, 6, 0.11, 38, 431);
INSERT INTO public.europe_data VALUES (6265, 95, 3847, 3.98, 39, 431);
INSERT INTO public.europe_data VALUES (6266, 41, 1065, 97.2, 186, 431);
INSERT INTO public.europe_data VALUES (6267, 0, 2, 5.24, 210, 431);
INSERT INTO public.europe_data VALUES (6268, 1, 70, 2.82, 187, 431);
INSERT INTO public.europe_data VALUES (6269, 44, 9837, 359.1, 129, 431);
INSERT INTO public.europe_data VALUES (6270, 504, 19807, 20.83, 130, 431);
INSERT INTO public.europe_data VALUES (6271, 17, 2580, 96.16, 131, 431);
INSERT INTO public.europe_data VALUES (6272, 162, 7484, 328.44, 90, 431);
INSERT INTO public.europe_data VALUES (6273, 0, 0, 0, 211, 431);
INSERT INTO public.europe_data VALUES (6274, 2, 521, 11.65, 91, 431);
INSERT INTO public.europe_data VALUES (6275, 1281, 23608, 144.28, 92, 431);
INSERT INTO public.europe_data VALUES (6276, 244, 14429, 19.24, 132, 431);
INSERT INTO public.europe_data VALUES (6277, 54, 1941, 10.49, 188, 431);
INSERT INTO public.europe_data VALUES (6278, 46, 2615, 47.35, 189, 431);
INSERT INTO public.europe_data VALUES (6279, 12, 1905, 89.73, 93, 431);
INSERT INTO public.europe_data VALUES (6280, 19, 3799, 324.32, 133, 431);
INSERT INTO public.europe_data VALUES (6281, 134, 3562, 32.05, 190, 431);
INSERT INTO public.europe_data VALUES (6282, 1174, 45911, 63.57, 191, 431);
INSERT INTO public.europe_data VALUES (6283, 1, 232, 3.46, 40, 431);
INSERT INTO public.europe_data VALUES (6284, 0, 1, 3.79, 94, 431);
INSERT INTO public.europe_data VALUES (6285, 0, 0, 1.64, 95, 431);
INSERT INTO public.europe_data VALUES (6286, 0, 6, 5.43, 96, 431);
INSERT INTO public.europe_data VALUES (6287, 0, 1, 2.9, 192, 431);
INSERT INTO public.europe_data VALUES (6288, 1, 9, 7.44, 41, 431);
INSERT INTO public.europe_data VALUES (6289, 307, 22750, 145.22, 134, 431);
INSERT INTO public.europe_data VALUES (6290, 15, 735, 9.51, 42, 431);
INSERT INTO public.europe_data VALUES (6291, 82, 2229, 61.95, 193, 431);
INSERT INTO public.europe_data VALUES (6292, 0, 89, 91.06, 43, 431);
INSERT INTO public.europe_data VALUES (6293, 1, 93, 2.66, 44, 431);
INSERT INTO public.europe_data VALUES (6294, 0, 1297, 43.11, 135, 431);
INSERT INTO public.europe_data VALUES (6295, 0, 0, 2.36, 97, 431);
INSERT INTO public.europe_data VALUES (6296, 0, 137, 4.35, 194, 431);
INSERT INTO public.europe_data VALUES (6297, 0, 141, 12.49, 195, 431);
INSERT INTO public.europe_data VALUES (6298, 1, 62, 1.07, 45, 431);
INSERT INTO public.europe_data VALUES (6299, 880, 79492, 235.85, 46, 431);
INSERT INTO public.europe_data VALUES (6300, 6, 388, 1.41, 136, 431);
INSERT INTO public.europe_data VALUES (6301, 3, 103, 1.36, 47, 431);
INSERT INTO public.europe_data VALUES (6302, 18, 4164, 14.88, 196, 431);
INSERT INTO public.europe_data VALUES (6303, 0, 541, 2.72, 137, 431);
INSERT INTO public.europe_data VALUES (6304, 42, 483, 2.32, 48, 431);
INSERT INTO public.europe_data VALUES (6305, 4, 147, 43.17, 98, 431);
INSERT INTO public.europe_data VALUES (6306, 84, 2179, 63.1, 197, 431);
INSERT INTO public.europe_data VALUES (6307, 0, 614, 14.79, 198, 431);
INSERT INTO public.europe_data VALUES (6308, 3, 36, 0.81, 138, 431);
INSERT INTO public.europe_data VALUES (6309, 0, 2, 0.02, 139, 431);
INSERT INTO public.europe_data VALUES (6310, 2, 339, 7.54, 140, 431);
INSERT INTO public.europe_data VALUES (6311, 0, 25, 0.08, 141, 431);
INSERT INTO public.europe_data VALUES (6312, 0, 0, 0, 142, 431);
INSERT INTO public.europe_data VALUES (6313, 0, 40, 0.97, 49, 431);
INSERT INTO public.europe_data VALUES (6314, 0, 0, 0.5, 99, 431);
INSERT INTO public.europe_data VALUES (6315, 0, 75, 0.8, 50, 431);
INSERT INTO public.europe_data VALUES (6316, 138, 7235, 19.21, 199, 431);
INSERT INTO public.europe_data VALUES (6317, 0, 25, 115.2, 100, 431);
INSERT INTO public.europe_data VALUES (6318, 0, 86, 0.37, 51, 431);
INSERT INTO public.europe_data VALUES (6319, 134, 5021, 23.96, 200, 431);
INSERT INTO public.europe_data VALUES (6320, 10, 3314, 72.23, 143, 431);
INSERT INTO public.europe_data VALUES (6321, 213, 4271, 12.45, 201, 431);
INSERT INTO public.europe_data VALUES (6322, 0, 0, 0, 52, 431);
INSERT INTO public.europe_data VALUES (6323, 5258, 416307, 229.73, 101, 431);
INSERT INTO public.europe_data VALUES (6324, 0, 69, 95.62, 102, 431);
INSERT INTO public.europe_data VALUES (6325, 3, 31, 1.68, 103, 431);
INSERT INTO public.europe_data VALUES (6326, 26, 3050, 15.65, 144, 431);
INSERT INTO public.europe_data VALUES (6327, 25, 2296, 14.62, 104, 431);
INSERT INTO public.europe_data VALUES (6328, 0, 17, 0.02, 145, 431);
INSERT INTO public.europe_data VALUES (6329, 0, 0, 53.39, 53, 431);
INSERT INTO public.europe_data VALUES (6330, 79, 200, 1.19, 146, 431);
INSERT INTO public.europe_data VALUES (6331, 12, 263, 1.89, 54, 431);
INSERT INTO public.europe_data VALUES (6332, 10, 269, 2.85, 55, 431);
INSERT INTO public.europe_data VALUES (6333, 143, 1984, 10.82, 105, 432);
INSERT INTO public.europe_data VALUES (6334, 21, 491, 33.75, 147, 432);
INSERT INTO public.europe_data VALUES (6335, 55, 2668, 9.69, 1, 432);
INSERT INTO public.europe_data VALUES (6336, 0, 0, 0, 148, 432);
INSERT INTO public.europe_data VALUES (6337, 8, 79, 0.53, 2, 432);
INSERT INTO public.europe_data VALUES (6338, 0, 0, 0, 56, 432);
INSERT INTO public.europe_data VALUES (6339, 0, 3, 43.25, 57, 432);
INSERT INTO public.europe_data VALUES (6340, 273, 17632, 72.78, 58, 432);
INSERT INTO public.europe_data VALUES (6341, 58, 3809, 282.24, 149, 432);
INSERT INTO public.europe_data VALUES (6342, 0, 4, 3.76, 59, 432);
INSERT INTO public.europe_data VALUES (6343, 0, 763, 3.92, 202, 432);
INSERT INTO public.europe_data VALUES (6344, 4, 644, 11.11, 150, 432);
INSERT INTO public.europe_data VALUES (6345, 52, 3900, 75.59, 151, 432);
INSERT INTO public.europe_data VALUES (6346, 0, 0, 0, 60, 432);
INSERT INTO public.europe_data VALUES (6347, 14, 3662, 463.27, 106, 432);
INSERT INTO public.europe_data VALUES (6348, 314, 24630, 30.73, 107, 432);
INSERT INTO public.europe_data VALUES (6349, 0, 1, 0.35, 61, 432);
INSERT INTO public.europe_data VALUES (6350, 40, 2079, 53.41, 152, 432);
INSERT INTO public.europe_data VALUES (6351, 25, 637, 10.86, 153, 432);
INSERT INTO public.europe_data VALUES (6352, 0, 6, 2.05, 62, 432);
INSERT INTO public.europe_data VALUES (6353, 5, 50, 3.68, 3, 432);
INSERT INTO public.europe_data VALUES (6354, 0, 0, 0, 63, 432);
INSERT INTO public.europe_data VALUES (6355, 0, 4, 1.57, 108, 432);
INSERT INTO public.europe_data VALUES (6356, 420, 7773, 129.5, 64, 432);
INSERT INTO public.europe_data VALUES (6357, 0, 0, 0, 65, 432);
INSERT INTO public.europe_data VALUES (6358, 11, 1178, 59.44, 154, 432);
INSERT INTO public.europe_data VALUES (6359, 0, 150, 8.07, 4, 432);
INSERT INTO public.europe_data VALUES (6360, 7245, 258912, 245.45, 66, 432);
INSERT INTO public.europe_data VALUES (6361, 0, 0, 0, 67, 432);
INSERT INTO public.europe_data VALUES (6362, 0, 0, 0, 109, 432);
INSERT INTO public.europe_data VALUES (6363, 27, 1049, 26.21, 155, 432);
INSERT INTO public.europe_data VALUES (6364, 0, 28, 0.41, 5, 432);
INSERT INTO public.europe_data VALUES (6365, 0, 21, 0.41, 6, 432);
INSERT INTO public.europe_data VALUES (6366, 0, 0, 0.07, 110, 432);
INSERT INTO public.europe_data VALUES (6367, 15, 1119, 8.12, 7, 432);
INSERT INTO public.europe_data VALUES (6368, 162, 2285, 11.22, 68, 432);
INSERT INTO public.europe_data VALUES (6369, 5, 296, 102.01, 8, 432);
INSERT INTO public.europe_data VALUES (6370, 0, 5, 9.24, 69, 432);
INSERT INTO public.europe_data VALUES (6371, 3, 540, 24.47, 9, 432);
INSERT INTO public.europe_data VALUES (6372, 0, 6, 0.09, 10, 432);
INSERT INTO public.europe_data VALUES (6373, 799, 23550, 280.59, 70, 432);
INSERT INTO public.europe_data VALUES (6374, 0, 114, 0.02, 111, 432);
INSERT INTO public.europe_data VALUES (6375, 958, 25341, 96.26, 71, 432);
INSERT INTO public.europe_data VALUES (6376, 0, 39, 7.52, 11, 432);
INSERT INTO public.europe_data VALUES (6377, 4, 312, 10.11, 12, 432);
INSERT INTO public.europe_data VALUES (6378, 4, 1866, 55.14, 72, 432);
INSERT INTO public.europe_data VALUES (6379, 8, 1828, 12.75, 13, 432);
INSERT INTO public.europe_data VALUES (6380, 6, 460, 20.46, 156, 432);
INSERT INTO public.europe_data VALUES (6381, 0, 40, 0.53, 73, 432);
INSERT INTO public.europe_data VALUES (6382, 0, 1, 1.22, 74, 432);
INSERT INTO public.europe_data VALUES (6383, 0, 9, 1.94, 157, 432);
INSERT INTO public.europe_data VALUES (6384, 0, 912, 18.94, 158, 432);
INSERT INTO public.europe_data VALUES (6385, 24, 584, 1.83, 14, 432);
INSERT INTO public.europe_data VALUES (6386, 2, 157, 7.6, 159, 432);
INSERT INTO public.europe_data VALUES (6387, 3, 149, 21.57, 15, 432);
INSERT INTO public.europe_data VALUES (6388, 0, 0, 0, 75, 432);
INSERT INTO public.europe_data VALUES (6389, 68, 6052, 100.08, 76, 432);
INSERT INTO public.europe_data VALUES (6390, 352, 6703, 65.14, 77, 432);
INSERT INTO public.europe_data VALUES (6391, 554, 10065, 19.94, 16, 432);
INSERT INTO public.europe_data VALUES (6392, 53, 1843, 48.83, 78, 432);
INSERT INTO public.europe_data VALUES (6393, 19, 1070, 103.76, 17, 432);
INSERT INTO public.europe_data VALUES (6394, 0, 24, 2.06, 18, 432);
INSERT INTO public.europe_data VALUES (6395, 0, 6, 0.91, 160, 432);
INSERT INTO public.europe_data VALUES (6396, 2, 207, 30.75, 19, 432);
INSERT INTO public.europe_data VALUES (6397, 5, 157, 1.17, 20, 432);
INSERT INTO public.europe_data VALUES (6398, 0, 0, 0, 79, 432);
INSERT INTO public.europe_data VALUES (6399, 0, 0, 0, 161, 432);
INSERT INTO public.europe_data VALUES (6400, 0, 0, 0, 203, 432);
INSERT INTO public.europe_data VALUES (6401, 0, 81, 2.34, 162, 432);
INSERT INTO public.europe_data VALUES (6402, 115, 4024, 9.82, 163, 432);
INSERT INTO public.europe_data VALUES (6403, 0, 0, 0.72, 204, 432);
INSERT INTO public.europe_data VALUES (6404, 4, 411, 54.87, 21, 432);
INSERT INTO public.europe_data VALUES (6405, 0, 12, 0.85, 22, 432);
INSERT INTO public.europe_data VALUES (6406, 0, 27, 1.13, 164, 432);
INSERT INTO public.europe_data VALUES (6407, 55, 2793, 7.46, 165, 432);
INSERT INTO public.europe_data VALUES (6408, 10, 2734, 19.5, 23, 432);
INSERT INTO public.europe_data VALUES (6409, 0, 1, 5.93, 166, 432);
INSERT INTO public.europe_data VALUES (6410, 1, 143, 2.36, 167, 432);
INSERT INTO public.europe_data VALUES (6411, 0, 0, 0, 80, 432);
INSERT INTO public.europe_data VALUES (6412, 0, 0, 0, 81, 432);
INSERT INTO public.europe_data VALUES (6413, 0, 48, 47.22, 205, 432);
INSERT INTO public.europe_data VALUES (6414, 220, 6318, 57.46, 82, 432);
INSERT INTO public.europe_data VALUES (6415, 0, 0, 0, 168, 432);
INSERT INTO public.europe_data VALUES (6416, 3, 268, 4.87, 24, 432);
INSERT INTO public.europe_data VALUES (6417, 4, 151, 11.66, 25, 432);
INSERT INTO public.europe_data VALUES (6418, 3, 43, 11.37, 83, 432);
INSERT INTO public.europe_data VALUES (6419, 9, 486, 9.96, 84, 432);
INSERT INTO public.europe_data VALUES (6420, 0, 0, 0, 169, 432);
INSERT INTO public.europe_data VALUES (6421, 160, 5861, 114.65, 85, 432);
INSERT INTO public.europe_data VALUES (6422, 8, 41, 0.83, 170, 432);
INSERT INTO public.europe_data VALUES (6423, 0, 9, 4.2, 171, 432);
INSERT INTO public.europe_data VALUES (6424, 3218, 149095, 19.92, 112, 432);
INSERT INTO public.europe_data VALUES (6425, 417, 9739, 6.6, 113, 432);
INSERT INTO public.europe_data VALUES (6426, 1063, 17769, 42.8, 114, 432);
INSERT INTO public.europe_data VALUES (6427, 717, 15077, 75.33, 115, 432);
INSERT INTO public.europe_data VALUES (6428, 6, 88, 3.02, 172, 432);
INSERT INTO public.europe_data VALUES (6429, 0, 0, 0, 173, 432);
INSERT INTO public.europe_data VALUES (6430, 13, 6203, 107.75, 116, 432);
INSERT INTO public.europe_data VALUES (6431, 123, 1301, 5.16, 174, 432);
INSERT INTO public.europe_data VALUES (6432, 0, 36, 2.48, 86, 432);
INSERT INTO public.europe_data VALUES (6433, 5, 1299, 1.47, 117, 432);
INSERT INTO public.europe_data VALUES (6434, 0, 1, 1.86, 175, 432);
INSERT INTO public.europe_data VALUES (6435, 1, 43, 1.3, 118, 432);
INSERT INTO public.europe_data VALUES (6436, 5, 27247, 166.25, 119, 432);
INSERT INTO public.europe_data VALUES (6437, 17, 1816, 5.99, 26, 432);
INSERT INTO public.europe_data VALUES (6438, 17, 679, 66, 176, 432);
INSERT INTO public.europe_data VALUES (6439, 20, 4999, 244.61, 120, 432);
INSERT INTO public.europe_data VALUES (6440, 42, 2674, 67.57, 121, 432);
INSERT INTO public.europe_data VALUES (6441, 0, 0, 0, 122, 432);
INSERT INTO public.europe_data VALUES (6442, 0, 8, 0.68, 177, 432);
INSERT INTO public.europe_data VALUES (6443, 2, 133, 4.17, 123, 432);
INSERT INTO public.europe_data VALUES (6444, 0, 52, 3.53, 27, 432);
INSERT INTO public.europe_data VALUES (6445, 3, 106, 5.02, 28, 432);
INSERT INTO public.europe_data VALUES (6446, 6, 227, 6.57, 29, 432);
INSERT INTO public.europe_data VALUES (6447, 0, 1, 2.61, 178, 432);
INSERT INTO public.europe_data VALUES (6448, 1, 20, 1.36, 179, 432);
INSERT INTO public.europe_data VALUES (6449, 0, 280, 65.48, 180, 432);
INSERT INTO public.europe_data VALUES (6450, 11, 650, 4.2, 30, 432);
INSERT INTO public.europe_data VALUES (6451, 6, 596, 5.43, 31, 432);
INSERT INTO public.europe_data VALUES (6452, 0, 24, 0.27, 124, 432);
INSERT INTO public.europe_data VALUES (6453, 3, 145, 49.91, 125, 432);
INSERT INTO public.europe_data VALUES (6454, 5, 183, 1.88, 32, 432);
INSERT INTO public.europe_data VALUES (6455, 0, 2, 1.42, 181, 432);
INSERT INTO public.europe_data VALUES (6456, 10, 972, 45.65, 33, 432);
INSERT INTO public.europe_data VALUES (6457, 0, 0, 0.32, 34, 432);
INSERT INTO public.europe_data VALUES (6458, 3991, 42740, 64.01, 87, 432);
INSERT INTO public.europe_data VALUES (6459, 55, 1564, 89.38, 182, 432);
INSERT INTO public.europe_data VALUES (6460, 0, 5, 21.16, 183, 432);
INSERT INTO public.europe_data VALUES (6461, 0, 0, 0.22, 126, 432);
INSERT INTO public.europe_data VALUES (6462, 3, 300, 67.34, 184, 432);
INSERT INTO public.europe_data VALUES (6463, 0, 0, 0, 88, 432);
INSERT INTO public.europe_data VALUES (6464, 14, 2163, 11.62, 35, 432);
INSERT INTO public.europe_data VALUES (6465, 3, 128, 0.84, 36, 432);
INSERT INTO public.europe_data VALUES (6466, 0, 14, 0.04, 127, 432);
INSERT INTO public.europe_data VALUES (6467, 0, 229, 14.31, 37, 432);
INSERT INTO public.europe_data VALUES (6468, 6, 3012, 23.62, 128, 432);
INSERT INTO public.europe_data VALUES (6469, 22, 474, 5.95, 185, 432);
INSERT INTO public.europe_data VALUES (6470, 0, 0, 0, 208, 432);
INSERT INTO public.europe_data VALUES (6471, 0, 5, 0.42, 209, 432);
INSERT INTO public.europe_data VALUES (6472, 9, 349, 7.72, 89, 432);
INSERT INTO public.europe_data VALUES (6473, 1, 19, 0.24, 38, 432);
INSERT INTO public.europe_data VALUES (6474, 80, 4144, 4.21, 39, 432);
INSERT INTO public.europe_data VALUES (6475, 55, 954, 93.4, 186, 432);
INSERT INTO public.europe_data VALUES (6476, 0, 1, 1.75, 210, 432);
INSERT INTO public.europe_data VALUES (6477, 2, 80, 3.51, 187, 432);
INSERT INTO public.europe_data VALUES (6478, 50, 8028, 335.82, 129, 432);
INSERT INTO public.europe_data VALUES (6479, 595, 25306, 23.42, 130, 432);
INSERT INTO public.europe_data VALUES (6480, 13, 2210, 68.98, 131, 432);
INSERT INTO public.europe_data VALUES (6481, 143, 6463, 285.39, 90, 432);
INSERT INTO public.europe_data VALUES (6482, 0, 0, 0.02, 211, 432);
INSERT INTO public.europe_data VALUES (6483, 5, 300, 14.88, 91, 432);
INSERT INTO public.europe_data VALUES (6484, 1272, 23299, 146.97, 92, 432);
INSERT INTO public.europe_data VALUES (6485, 46, 6375, 10.89, 132, 432);
INSERT INTO public.europe_data VALUES (6486, 79, 2043, 10.58, 188, 432);
INSERT INTO public.europe_data VALUES (6487, 50, 2251, 46.36, 189, 432);
INSERT INTO public.europe_data VALUES (6488, 2, 727, 47.42, 93, 432);
INSERT INTO public.europe_data VALUES (6489, 18, 5386, 438.9, 133, 432);
INSERT INTO public.europe_data VALUES (6490, 138, 2660, 25.38, 190, 432);
INSERT INTO public.europe_data VALUES (6491, 1088, 46814, 66.2, 191, 432);
INSERT INTO public.europe_data VALUES (6492, 1, 205, 2.99, 40, 432);
INSERT INTO public.europe_data VALUES (6493, 0, 1, 1.89, 94, 432);
INSERT INTO public.europe_data VALUES (6494, 0, 3, 1.64, 95, 432);
INSERT INTO public.europe_data VALUES (6495, 0, 0, 0, 96, 432);
INSERT INTO public.europe_data VALUES (6496, 0, 0, 5.81, 192, 432);
INSERT INTO public.europe_data VALUES (6497, 0, 7, 10.23, 41, 432);
INSERT INTO public.europe_data VALUES (6498, 365, 27016, 151.44, 134, 432);
INSERT INTO public.europe_data VALUES (6499, 28, 814, 9.28, 42, 432);
INSERT INTO public.europe_data VALUES (6500, 41, 2085, 46.48, 193, 432);
INSERT INTO public.europe_data VALUES (6501, 0, 0, 0, 43, 432);
INSERT INTO public.europe_data VALUES (6502, 2, 115, 2.75, 44, 432);
INSERT INTO public.europe_data VALUES (6503, 0, 1205, 44.26, 135, 432);
INSERT INTO public.europe_data VALUES (6504, 0, 1, 2.36, 97, 432);
INSERT INTO public.europe_data VALUES (6505, 0, 100, 3.25, 194, 432);
INSERT INTO public.europe_data VALUES (6506, 0, 119, 8.65, 195, 432);
INSERT INTO public.europe_data VALUES (6507, 2, 103, 1.41, 45, 432);
INSERT INTO public.europe_data VALUES (6508, 743, 58616, 169.83, 46, 432);
INSERT INTO public.europe_data VALUES (6509, 1, 334, 1.27, 136, 432);
INSERT INTO public.europe_data VALUES (6510, 2, 47, 1.39, 47, 432);
INSERT INTO public.europe_data VALUES (6511, 42, 2819, 11.26, 196, 432);
INSERT INTO public.europe_data VALUES (6512, 0, 39, 0.59, 137, 432);
INSERT INTO public.europe_data VALUES (6513, 36, 509, 2.77, 48, 432);
INSERT INTO public.europe_data VALUES (6514, 3, 104, 48.16, 98, 432);
INSERT INTO public.europe_data VALUES (6515, 98, 4276, 114.71, 197, 432);
INSERT INTO public.europe_data VALUES (6516, 4, 650, 11.41, 198, 432);
INSERT INTO public.europe_data VALUES (6517, 4, 102, 0.9, 138, 432);
INSERT INTO public.europe_data VALUES (6518, 0, 2, 0.01, 139, 432);
INSERT INTO public.europe_data VALUES (6519, 1, 364, 8.11, 140, 432);
INSERT INTO public.europe_data VALUES (6520, 0, 33, 0.07, 141, 432);
INSERT INTO public.europe_data VALUES (6521, 0, 0, 0, 142, 432);
INSERT INTO public.europe_data VALUES (6522, 1, 38, 1.37, 49, 432);
INSERT INTO public.europe_data VALUES (6523, 0, 7, 0.72, 99, 432);
INSERT INTO public.europe_data VALUES (6524, 0, 19, 0.27, 50, 432);
INSERT INTO public.europe_data VALUES (6525, 128, 8519, 22.04, 199, 432);
INSERT INTO public.europe_data VALUES (6526, 1, 19, 86.4, 100, 432);
INSERT INTO public.europe_data VALUES (6527, 0, 80, 0.38, 51, 432);
INSERT INTO public.europe_data VALUES (6528, 120, 5518, 27.14, 200, 432);
INSERT INTO public.europe_data VALUES (6529, 10, 3743, 67.7, 143, 432);
INSERT INTO public.europe_data VALUES (6530, 312, 4026, 13.9, 201, 432);
INSERT INTO public.europe_data VALUES (6531, 0, 0, 0, 52, 432);
INSERT INTO public.europe_data VALUES (6532, 4143, 339639, 184.68, 101, 432);
INSERT INTO public.europe_data VALUES (6533, 0, 31, 34.42, 102, 432);
INSERT INTO public.europe_data VALUES (6534, 1, 27, 2.31, 103, 432);
INSERT INTO public.europe_data VALUES (6535, 13, 2112, 11.48, 144, 432);
INSERT INTO public.europe_data VALUES (6536, 20, 1872, 11.4, 104, 432);
INSERT INTO public.europe_data VALUES (6537, 0, 0, 0.01, 145, 432);
INSERT INTO public.europe_data VALUES (6538, 0, 311, 84.81, 53, 432);
INSERT INTO public.europe_data VALUES (6539, 36, 147, 1.11, 146, 432);
INSERT INTO public.europe_data VALUES (6540, 8, 75, 1.13, 54, 432);
INSERT INTO public.europe_data VALUES (6541, 2, 149, 1.55, 55, 432);
INSERT INTO public.europe_data VALUES (6542, 140, 2134, 16.3, 105, 433);
INSERT INTO public.europe_data VALUES (6543, 11, 475, 30.78, 147, 433);
INSERT INTO public.europe_data VALUES (6544, 52, 1502, 5.47, 1, 433);
INSERT INTO public.europe_data VALUES (6545, 0, 0, 2.63, 148, 433);
INSERT INTO public.europe_data VALUES (6546, 2, 91, 0.4, 2, 433);
INSERT INTO public.europe_data VALUES (6547, 0, 0, 0, 56, 433);
INSERT INTO public.europe_data VALUES (6548, 0, 39, 40.16, 57, 433);
INSERT INTO public.europe_data VALUES (6549, 206, 14959, 58.43, 58, 433);
INSERT INTO public.europe_data VALUES (6550, 73, 4539, 272.61, 149, 433);
INSERT INTO public.europe_data VALUES (6551, 0, 0, 0, 59, 433);
INSERT INTO public.europe_data VALUES (6552, 2, 225, 1.45, 202, 433);
INSERT INTO public.europe_data VALUES (6553, 12, 340, 6.63, 150, 433);
INSERT INTO public.europe_data VALUES (6554, 44, 3695, 64.36, 151, 433);
INSERT INTO public.europe_data VALUES (6555, 0, 0, 0.26, 60, 433);
INSERT INTO public.europe_data VALUES (6556, 20, 3941, 436.34, 106, 433);
INSERT INTO public.europe_data VALUES (6557, 274, 25481, 30.83, 107, 433);
INSERT INTO public.europe_data VALUES (6558, 0, 0, 0.35, 61, 433);
INSERT INTO public.europe_data VALUES (6559, 37, 2970, 79.37, 152, 433);
INSERT INTO public.europe_data VALUES (6560, 39, 607, 11.13, 153, 433);
INSERT INTO public.europe_data VALUES (6561, 0, 2, 0.77, 62, 433);
INSERT INTO public.europe_data VALUES (6562, 3, 384, 5.75, 3, 433);
INSERT INTO public.europe_data VALUES (6563, 0, 0, 3.2, 63, 433);
INSERT INTO public.europe_data VALUES (6564, 0, 8, 1.31, 108, 433);
INSERT INTO public.europe_data VALUES (6565, 241, 7136, 113.48, 64, 433);
INSERT INTO public.europe_data VALUES (6566, 0, 0, 0, 65, 433);
INSERT INTO public.europe_data VALUES (6567, 13, 784, 36.78, 154, 433);
INSERT INTO public.europe_data VALUES (6568, 0, 36, 2.82, 4, 433);
INSERT INTO public.europe_data VALUES (6569, 7005, 259105, 225.79, 66, 433);
INSERT INTO public.europe_data VALUES (6570, 0, 0, 0, 67, 433);
INSERT INTO public.europe_data VALUES (6571, 0, 0, 0, 109, 433);
INSERT INTO public.europe_data VALUES (6572, 20, 786, 20.01, 155, 433);
INSERT INTO public.europe_data VALUES (6573, 0, 56, 0.32, 5, 433);
INSERT INTO public.europe_data VALUES (6574, 0, 26, 0.66, 6, 433);
INSERT INTO public.europe_data VALUES (6575, 0, 12, 0.08, 110, 433);
INSERT INTO public.europe_data VALUES (6576, 12, 982, 10.54, 7, 433);
INSERT INTO public.europe_data VALUES (6577, 92, 1913, 11.93, 68, 433);
INSERT INTO public.europe_data VALUES (6578, 4, 265, 73.64, 8, 433);
INSERT INTO public.europe_data VALUES (6579, 0, 1, 13.86, 69, 433);
INSERT INTO public.europe_data VALUES (6580, 22, 621, 25.44, 9, 433);
INSERT INTO public.europe_data VALUES (6581, 0, 8, 0.1, 10, 433);
INSERT INTO public.europe_data VALUES (6582, 1030, 29627, 515.45, 70, 433);
INSERT INTO public.europe_data VALUES (6583, 2, 185, 0.03, 111, 433);
INSERT INTO public.europe_data VALUES (6584, 869, 23117, 81.11, 71, 433);
INSERT INTO public.europe_data VALUES (6585, 2, 25, 11.28, 11, 433);
INSERT INTO public.europe_data VALUES (6586, 12, 232, 8.66, 12, 433);
INSERT INTO public.europe_data VALUES (6587, 3, 917, 28.03, 72, 433);
INSERT INTO public.europe_data VALUES (6588, 15, 1452, 15.01, 13, 433);
INSERT INTO public.europe_data VALUES (6589, 0, 374, 10.77, 156, 433);
INSERT INTO public.europe_data VALUES (6590, 1, 20, 0.74, 73, 433);
INSERT INTO public.europe_data VALUES (6591, 0, 1, 1.22, 74, 433);
INSERT INTO public.europe_data VALUES (6592, 0, 8, 1.26, 157, 433);
INSERT INTO public.europe_data VALUES (6593, 12, 1105, 14.83, 158, 433);
INSERT INTO public.europe_data VALUES (6594, 27, 1000, 2.36, 14, 433);
INSERT INTO public.europe_data VALUES (6595, 4, 284, 8.3, 159, 433);
INSERT INTO public.europe_data VALUES (6596, 7, 61, 18.28, 15, 433);
INSERT INTO public.europe_data VALUES (6597, 0, 0, 0, 75, 433);
INSERT INTO public.europe_data VALUES (6598, 64, 4696, 78.32, 76, 433);
INSERT INTO public.europe_data VALUES (6599, 206, 4615, 48.95, 77, 433);
INSERT INTO public.europe_data VALUES (6600, 596, 9955, 20.51, 16, 433);
INSERT INTO public.europe_data VALUES (6601, 57, 1308, 34.31, 78, 433);
INSERT INTO public.europe_data VALUES (6602, 0, 337, 51.25, 17, 433);
INSERT INTO public.europe_data VALUES (6603, 0, 48, 2.72, 18, 433);
INSERT INTO public.europe_data VALUES (6604, 0, 6, 1.06, 160, 433);
INSERT INTO public.europe_data VALUES (6605, 6, 146, 25.35, 19, 433);
INSERT INTO public.europe_data VALUES (6606, 24, 1157, 2.09, 20, 433);
INSERT INTO public.europe_data VALUES (6607, 0, 0, 0, 79, 433);
INSERT INTO public.europe_data VALUES (6608, 0, 0, 0, 161, 433);
INSERT INTO public.europe_data VALUES (6609, 0, 0, 0, 203, 433);
INSERT INTO public.europe_data VALUES (6610, 2, 48, 1.58, 162, 433);
INSERT INTO public.europe_data VALUES (6611, 138, 2559, 8.53, 163, 433);
INSERT INTO public.europe_data VALUES (6612, 0, 2, 0.72, 204, 433);
INSERT INTO public.europe_data VALUES (6613, 6, 781, 80.37, 21, 433);
INSERT INTO public.europe_data VALUES (6614, 0, 8, 0.72, 22, 433);
INSERT INTO public.europe_data VALUES (6615, 1, 18, 1.18, 164, 433);
INSERT INTO public.europe_data VALUES (6616, 76, 3402, 8.79, 165, 433);
INSERT INTO public.europe_data VALUES (6617, 27, 3197, 17.71, 23, 433);
INSERT INTO public.europe_data VALUES (6618, 0, 1, 2.97, 166, 433);
INSERT INTO public.europe_data VALUES (6619, 1, 110, 2.38, 167, 433);
INSERT INTO public.europe_data VALUES (6620, 0, 0, 0, 80, 433);
INSERT INTO public.europe_data VALUES (6621, 0, 0, 0, 81, 433);
INSERT INTO public.europe_data VALUES (6622, 0, 31, 40.65, 205, 433);
INSERT INTO public.europe_data VALUES (6623, 196, 3785, 40.3, 82, 433);
INSERT INTO public.europe_data VALUES (6624, 0, 0, 0, 168, 433);
INSERT INTO public.europe_data VALUES (6625, 4, 354, 6.34, 24, 433);
INSERT INTO public.europe_data VALUES (6626, 4, 73, 8.02, 25, 433);
INSERT INTO public.europe_data VALUES (6627, 0, 46, 9.07, 83, 433);
INSERT INTO public.europe_data VALUES (6628, 16, 636, 13.66, 84, 433);
INSERT INTO public.europe_data VALUES (6629, 0, 0, 0, 169, 433);
INSERT INTO public.europe_data VALUES (6630, 116, 5313, 94.64, 85, 433);
INSERT INTO public.europe_data VALUES (6631, 9, 40, 0.68, 170, 433);
INSERT INTO public.europe_data VALUES (6632, 0, 6, 3.08, 171, 433);
INSERT INTO public.europe_data VALUES (6633, 2776, 123036, 15.8, 112, 433);
INSERT INTO public.europe_data VALUES (6634, 289, 8119, 5.81, 113, 433);
INSERT INTO public.europe_data VALUES (6635, 885, 17717, 42.5, 114, 433);
INSERT INTO public.europe_data VALUES (6636, 656, 14534, 64.09, 115, 433);
INSERT INTO public.europe_data VALUES (6637, 20, 60, 2.77, 172, 433);
INSERT INTO public.europe_data VALUES (6638, 0, 0, 0, 173, 433);
INSERT INTO public.europe_data VALUES (6639, 12, 2977, 54.39, 116, 433);
INSERT INTO public.europe_data VALUES (6640, 104, 1811, 5.5, 174, 433);
INSERT INTO public.europe_data VALUES (6641, 0, 37, 2.68, 86, 433);
INSERT INTO public.europe_data VALUES (6642, 19, 560, 0.77, 117, 433);
INSERT INTO public.europe_data VALUES (6643, 0, 1, 5.57, 175, 433);
INSERT INTO public.europe_data VALUES (6644, 0, 88, 1.58, 118, 433);
INSERT INTO public.europe_data VALUES (6645, 63, 3595, 35.13, 119, 433);
INSERT INTO public.europe_data VALUES (6646, 20, 1332, 4.71, 26, 433);
INSERT INTO public.europe_data VALUES (6647, 13, 508, 66.22, 176, 433);
INSERT INTO public.europe_data VALUES (6648, 22, 5292, 214.45, 120, 433);
INSERT INTO public.europe_data VALUES (6649, 10, 1661, 41.23, 121, 433);
INSERT INTO public.europe_data VALUES (6650, 0, 0, 0, 122, 433);
INSERT INTO public.europe_data VALUES (6651, 0, 5, 0.99, 177, 433);
INSERT INTO public.europe_data VALUES (6652, 2, 153, 4.29, 123, 433);
INSERT INTO public.europe_data VALUES (6653, 0, 23, 1.08, 27, 433);
INSERT INTO public.europe_data VALUES (6654, 0, 142, 6.28, 28, 433);
INSERT INTO public.europe_data VALUES (6655, 11, 218, 5.08, 29, 433);
INSERT INTO public.europe_data VALUES (6656, 0, 0, 0, 178, 433);
INSERT INTO public.europe_data VALUES (6657, 2, 18, 1.72, 179, 433);
INSERT INTO public.europe_data VALUES (6658, 0, 122, 28.02, 180, 433);
INSERT INTO public.europe_data VALUES (6659, 4, 482, 2.99, 30, 433);
INSERT INTO public.europe_data VALUES (6660, 2, 416, 3.22, 31, 433);
INSERT INTO public.europe_data VALUES (6661, 0, 62, 0.57, 124, 433);
INSERT INTO public.europe_data VALUES (6662, 0, 120, 54.24, 125, 433);
INSERT INTO public.europe_data VALUES (6663, 3, 186, 1.72, 32, 433);
INSERT INTO public.europe_data VALUES (6664, 0, 5, 4.05, 181, 433);
INSERT INTO public.europe_data VALUES (6665, 12, 1094, 46.93, 33, 433);
INSERT INTO public.europe_data VALUES (6666, 0, 4, 0.32, 34, 433);
INSERT INTO public.europe_data VALUES (6667, 4823, 38916, 59.55, 87, 433);
INSERT INTO public.europe_data VALUES (6668, 57, 2050, 111.54, 182, 433);
INSERT INTO public.europe_data VALUES (6669, 0, 2, 9.07, 183, 433);
INSERT INTO public.europe_data VALUES (6670, 0, 7, 0.71, 126, 433);
INSERT INTO public.europe_data VALUES (6671, 2, 119, 25.07, 184, 433);
INSERT INTO public.europe_data VALUES (6672, 0, 0, 0, 88, 433);
INSERT INTO public.europe_data VALUES (6673, 7, 2075, 9.1, 35, 433);
INSERT INTO public.europe_data VALUES (6674, 0, 126, 0.91, 36, 433);
INSERT INTO public.europe_data VALUES (6675, 0, 9, 0.07, 127, 433);
INSERT INTO public.europe_data VALUES (6676, 0, 128, 6.05, 37, 433);
INSERT INTO public.europe_data VALUES (6677, 5, 3746, 24.51, 128, 433);
INSERT INTO public.europe_data VALUES (6678, 15, 554, 7.89, 185, 433);
INSERT INTO public.europe_data VALUES (6679, 0, 0, 0, 208, 433);
INSERT INTO public.europe_data VALUES (6680, 0, 15, 0.5, 209, 433);
INSERT INTO public.europe_data VALUES (6681, 10, 156, 7.87, 89, 433);
INSERT INTO public.europe_data VALUES (6682, 0, 38, 0.4, 38, 433);
INSERT INTO public.europe_data VALUES (6683, 47, 4323, 4.22, 39, 433);
INSERT INTO public.europe_data VALUES (6684, 48, 986, 97.97, 186, 433);
INSERT INTO public.europe_data VALUES (6685, 0, 0, 0, 210, 433);
INSERT INTO public.europe_data VALUES (6686, 5, 107, 3.92, 187, 433);
INSERT INTO public.europe_data VALUES (6687, 32, 8679, 294.85, 129, 433);
INSERT INTO public.europe_data VALUES (6688, 577, 25424, 28.64, 130, 433);
INSERT INTO public.europe_data VALUES (6689, 2, 1226, 31.62, 131, 433);
INSERT INTO public.europe_data VALUES (6690, 103, 5656, 259.04, 90, 433);
INSERT INTO public.europe_data VALUES (6691, 0, 2, 0.03, 211, 433);
INSERT INTO public.europe_data VALUES (6692, 2, 748, 11.9, 91, 433);
INSERT INTO public.europe_data VALUES (6693, 1272, 24483, 152.82, 92, 433);
INSERT INTO public.europe_data VALUES (6694, 75, 5403, 8.81, 132, 433);
INSERT INTO public.europe_data VALUES (6695, 82, 1976, 11.89, 188, 433);
INSERT INTO public.europe_data VALUES (6696, 34, 2513, 48.23, 189, 433);
INSERT INTO public.europe_data VALUES (6697, 4, 664, 46.98, 93, 433);
INSERT INTO public.europe_data VALUES (6698, 12, 7044, 522.97, 133, 433);
INSERT INTO public.europe_data VALUES (6699, 100, 2268, 22.22, 190, 433);
INSERT INTO public.europe_data VALUES (6700, 962, 49757, 72.31, 191, 433);
INSERT INTO public.europe_data VALUES (6701, 0, 172, 2.52, 40, 433);
INSERT INTO public.europe_data VALUES (6702, 0, 0, 0, 94, 433);
INSERT INTO public.europe_data VALUES (6703, 0, 0, 0, 95, 433);
INSERT INTO public.europe_data VALUES (6704, 0, 0, 1.81, 96, 433);
INSERT INTO public.europe_data VALUES (6705, 0, 2, 11.61, 192, 433);
INSERT INTO public.europe_data VALUES (6706, 1, 15, 24.18, 41, 433);
INSERT INTO public.europe_data VALUES (6707, 284, 24881, 160.36, 134, 433);
INSERT INTO public.europe_data VALUES (6708, 21, 698, 9.18, 42, 433);
INSERT INTO public.europe_data VALUES (6709, 9, 1152, 24.93, 193, 433);
INSERT INTO public.europe_data VALUES (6710, 0, 0, 0, 43, 433);
INSERT INTO public.europe_data VALUES (6711, 5, 100, 3.3, 44, 433);
INSERT INTO public.europe_data VALUES (6712, 0, 1364, 49.19, 135, 433);
INSERT INTO public.europe_data VALUES (6713, 0, 0, 0, 97, 433);
INSERT INTO public.europe_data VALUES (6714, 0, 77, 2.13, 194, 433);
INSERT INTO public.europe_data VALUES (6715, 2, 61, 4.13, 195, 433);
INSERT INTO public.europe_data VALUES (6716, 0, 115, 1.88, 45, 433);
INSERT INTO public.europe_data VALUES (6717, 526, 40832, 116.29, 46, 433);
INSERT INTO public.europe_data VALUES (6718, 2, 319, 1.24, 136, 433);
INSERT INTO public.europe_data VALUES (6719, 2, 107, 2.68, 47, 433);
INSERT INTO public.europe_data VALUES (6720, 22, 2466, 10.36, 196, 433);
INSERT INTO public.europe_data VALUES (6721, 0, 87, 0.69, 137, 433);
INSERT INTO public.europe_data VALUES (6722, 51, 678, 4.76, 48, 433);
INSERT INTO public.europe_data VALUES (6723, 3, 176, 48.51, 98, 433);
INSERT INTO public.europe_data VALUES (6724, 138, 7459, 142.05, 197, 433);
INSERT INTO public.europe_data VALUES (6725, 2, 325, 5.85, 198, 433);
INSERT INTO public.europe_data VALUES (6726, 2, 52, 0.46, 138, 433);
INSERT INTO public.europe_data VALUES (6727, 0, 1, 0.02, 139, 433);
INSERT INTO public.europe_data VALUES (6728, 0, 392, 8.73, 140, 433);
INSERT INTO public.europe_data VALUES (6729, 0, 14, 0.04, 141, 433);
INSERT INTO public.europe_data VALUES (6730, 0, 0, 0, 142, 433);
INSERT INTO public.europe_data VALUES (6731, 1, 73, 1.37, 49, 433);
INSERT INTO public.europe_data VALUES (6732, 0, 3, 0.22, 99, 433);
INSERT INTO public.europe_data VALUES (6733, 0, 12, 0.62, 50, 433);
INSERT INTO public.europe_data VALUES (6734, 147, 9554, 23.17, 199, 433);
INSERT INTO public.europe_data VALUES (6735, 0, 14, 41.89, 100, 433);
INSERT INTO public.europe_data VALUES (6736, 0, 89, 0.37, 51, 433);
INSERT INTO public.europe_data VALUES (6737, 127, 6422, 26.89, 200, 433);
INSERT INTO public.europe_data VALUES (6738, 11, 2872, 56.32, 143, 433);
INSERT INTO public.europe_data VALUES (6739, 442, 5240, 17.89, 201, 433);
INSERT INTO public.europe_data VALUES (6740, 0, 0, 0, 52, 433);
INSERT INTO public.europe_data VALUES (6741, 5829, 268084, 138.25, 101, 433);
INSERT INTO public.europe_data VALUES (6742, 0, 5, 7.65, 102, 433);
INSERT INTO public.europe_data VALUES (6743, 2, 53, 2.34, 103, 433);
INSERT INTO public.europe_data VALUES (6744, 3, 1673, 8.88, 144, 433);
INSERT INTO public.europe_data VALUES (6745, 11, 1379, 8.13, 104, 433);
INSERT INTO public.europe_data VALUES (6746, 0, 6, 0.02, 145, 433);
INSERT INTO public.europe_data VALUES (6747, 0, 183, 31.76, 53, 433);
INSERT INTO public.europe_data VALUES (6748, 46, 177, 1.34, 146, 433);
INSERT INTO public.europe_data VALUES (6749, 11, 127, 1.11, 54, 433);
INSERT INTO public.europe_data VALUES (6750, 0, 78, 1.26, 55, 433);
INSERT INTO public.europe_data VALUES (6751, 110, 4067, 22.32, 105, 434);
INSERT INTO public.europe_data VALUES (6752, 8, 406, 23.79, 147, 434);
INSERT INTO public.europe_data VALUES (6753, 78, 852, 3.76, 1, 434);
INSERT INTO public.europe_data VALUES (6754, 1, 2, 3.94, 148, 434);
INSERT INTO public.europe_data VALUES (6755, 3, 36, 0.27, 2, 434);
INSERT INTO public.europe_data VALUES (6756, 0, 0, 0, 56, 434);
INSERT INTO public.europe_data VALUES (6757, 0, 0, 0, 57, 434);
INSERT INTO public.europe_data VALUES (6758, 178, 11208, 44.64, 58, 434);
INSERT INTO public.europe_data VALUES (6759, 75, 3524, 245.56, 149, 434);
INSERT INTO public.europe_data VALUES (6760, 0, 0, 0, 59, 434);
INSERT INTO public.europe_data VALUES (6761, 0, 141, 0.8, 202, 434);
INSERT INTO public.europe_data VALUES (6762, 13, 247, 4.71, 150, 434);
INSERT INTO public.europe_data VALUES (6763, 35, 2772, 51.51, 151, 434);
INSERT INTO public.europe_data VALUES (6764, 0, 1, 0.26, 60, 434);
INSERT INTO public.europe_data VALUES (6765, 20, 3220, 426.59, 106, 434);
INSERT INTO public.europe_data VALUES (6766, 293, 24786, 28.54, 107, 434);
INSERT INTO public.europe_data VALUES (6767, 0, 1, 1.74, 61, 434);
INSERT INTO public.europe_data VALUES (6768, 38, 4532, 104.47, 152, 434);
INSERT INTO public.europe_data VALUES (6769, 43, 668, 11.69, 153, 434);
INSERT INTO public.europe_data VALUES (6770, 0, 1, 1.02, 62, 434);
INSERT INTO public.europe_data VALUES (6771, 6, 295, 4.21, 3, 434);
INSERT INTO public.europe_data VALUES (6772, 0, 2, 8, 63, 434);
INSERT INTO public.europe_data VALUES (6773, 0, 2, 1.18, 108, 434);
INSERT INTO public.europe_data VALUES (6774, 162, 5929, 93.33, 64, 434);
INSERT INTO public.europe_data VALUES (6775, 0, 0, 0, 65, 434);
INSERT INTO public.europe_data VALUES (6776, 6, 430, 22.96, 154, 434);
INSERT INTO public.europe_data VALUES (6777, 0, 29, 2.13, 4, 434);
INSERT INTO public.europe_data VALUES (6778, 7285, 217414, 186.34, 66, 434);
INSERT INTO public.europe_data VALUES (6779, 0, 0, 0, 67, 434);
INSERT INTO public.europe_data VALUES (6780, 1, 0, 0, 109, 434);
INSERT INTO public.europe_data VALUES (6781, 25, 615, 16.83, 155, 434);
INSERT INTO public.europe_data VALUES (6782, 0, 9, 0.07, 5, 434);
INSERT INTO public.europe_data VALUES (6783, 0, 50, 0.53, 6, 434);
INSERT INTO public.europe_data VALUES (6784, 0, 1, 0.02, 110, 434);
INSERT INTO public.europe_data VALUES (6785, 25, 1746, 14.31, 7, 434);
INSERT INTO public.europe_data VALUES (6786, 284, 2550, 15.07, 68, 434);
INSERT INTO public.europe_data VALUES (6787, 2, 140, 61.1, 8, 434);
INSERT INTO public.europe_data VALUES (6788, 0, 8, 47.73, 69, 434);
INSERT INTO public.europe_data VALUES (6789, 16, 586, 24.74, 9, 434);
INSERT INTO public.europe_data VALUES (6790, 1, 8, 0.13, 10, 434);
INSERT INTO public.europe_data VALUES (6791, 1156, 68062, 570.94, 70, 434);
INSERT INTO public.europe_data VALUES (6792, 1, 237, 0.03, 111, 434);
INSERT INTO public.europe_data VALUES (6793, 570, 17713, 58.44, 71, 434);
INSERT INTO public.europe_data VALUES (6794, 3, 71, 12.46, 11, 434);
INSERT INTO public.europe_data VALUES (6795, 3, 234, 6.13, 12, 434);
INSERT INTO public.europe_data VALUES (6796, 0, 498, 17.73, 72, 434);
INSERT INTO public.europe_data VALUES (6797, 6, 2408, 14.59, 13, 434);
INSERT INTO public.europe_data VALUES (6798, 0, 65, 1.72, 156, 434);
INSERT INTO public.europe_data VALUES (6799, 1, 64, 1.07, 73, 434);
INSERT INTO public.europe_data VALUES (6800, 0, 1, 1.22, 74, 434);
INSERT INTO public.europe_data VALUES (6801, 1, 3, 2.51, 157, 434);
INSERT INTO public.europe_data VALUES (6802, 7, 474, 8.17, 158, 434);
INSERT INTO public.europe_data VALUES (6803, 24, 1049, 2.09, 14, 434);
INSERT INTO public.europe_data VALUES (6804, 3, 198, 7.63, 159, 434);
INSERT INTO public.europe_data VALUES (6805, 2, 117, 38.52, 15, 434);
INSERT INTO public.europe_data VALUES (6806, 0, 0, 0, 75, 434);
INSERT INTO public.europe_data VALUES (6807, 70, 3715, 65.9, 76, 434);
INSERT INTO public.europe_data VALUES (6808, 327, 3889, 43.28, 77, 434);
INSERT INTO public.europe_data VALUES (6809, 618, 10635, 21.07, 16, 434);
INSERT INTO public.europe_data VALUES (6810, 33, 906, 24.96, 78, 434);
INSERT INTO public.europe_data VALUES (6811, 20, 358, 26.4, 17, 434);
INSERT INTO public.europe_data VALUES (6812, 0, 47, 2.92, 18, 434);
INSERT INTO public.europe_data VALUES (6813, 0, 8, 3.17, 160, 434);
INSERT INTO public.europe_data VALUES (6814, 1, 145, 26.3, 19, 434);
INSERT INTO public.europe_data VALUES (6815, 17, 1187, 2.24, 20, 434);
INSERT INTO public.europe_data VALUES (6816, 0, 0, 0, 79, 434);
INSERT INTO public.europe_data VALUES (6817, 0, 0, 0, 161, 434);
INSERT INTO public.europe_data VALUES (6818, 0, 0, 0, 203, 434);
INSERT INTO public.europe_data VALUES (6819, 0, 39, 2.94, 162, 434);
INSERT INTO public.europe_data VALUES (6820, 233, 3157, 9.55, 163, 434);
INSERT INTO public.europe_data VALUES (6821, 0, 0, 0, 204, 434);
INSERT INTO public.europe_data VALUES (6822, 11, 965, 61.08, 21, 434);
INSERT INTO public.europe_data VALUES (6823, 1, 9, 0.47, 22, 434);
INSERT INTO public.europe_data VALUES (6824, 0, 29, 2.5, 164, 434);
INSERT INTO public.europe_data VALUES (6825, 94, 3898, 7.43, 165, 434);
INSERT INTO public.europe_data VALUES (6826, 31, 2190, 14.85, 23, 434);
INSERT INTO public.europe_data VALUES (6827, 0, 0, 2.97, 166, 434);
INSERT INTO public.europe_data VALUES (6828, 7, 145, 2.51, 167, 434);
INSERT INTO public.europe_data VALUES (6829, 0, 0, 0, 80, 434);
INSERT INTO public.europe_data VALUES (6830, 0, 0, 0, 81, 434);
INSERT INTO public.europe_data VALUES (6831, 0, 37, 25.7, 205, 434);
INSERT INTO public.europe_data VALUES (6832, 147, 3300, 34.64, 82, 434);
INSERT INTO public.europe_data VALUES (6833, 0, 0, 0, 168, 434);
INSERT INTO public.europe_data VALUES (6834, 2, 456, 6.44, 24, 434);
INSERT INTO public.europe_data VALUES (6835, 2, 81, 9.01, 25, 434);
INSERT INTO public.europe_data VALUES (6836, 0, 25, 3.83, 83, 434);
INSERT INTO public.europe_data VALUES (6837, 15, 902, 16.67, 84, 434);
INSERT INTO public.europe_data VALUES (6838, 0, 0, 0, 169, 434);
INSERT INTO public.europe_data VALUES (6839, 51, 3911, 66.1, 85, 434);
INSERT INTO public.europe_data VALUES (6840, 9, 26, 1.35, 170, 434);
INSERT INTO public.europe_data VALUES (6841, 0, 5, 2.24, 171, 434);
INSERT INTO public.europe_data VALUES (6842, 4179, 92858, 12.34, 112, 434);
INSERT INTO public.europe_data VALUES (6843, 331, 7614, 5.43, 113, 434);
INSERT INTO public.europe_data VALUES (6844, 786, 17525, 40, 114, 434);
INSERT INTO public.europe_data VALUES (6845, 493, 10659, 47.07, 115, 434);
INSERT INTO public.europe_data VALUES (6846, 9, 76, 3.63, 172, 434);
INSERT INTO public.europe_data VALUES (6847, 0, 0, 0, 173, 434);
INSERT INTO public.europe_data VALUES (6848, 4, 1657, 33.61, 116, 434);
INSERT INTO public.europe_data VALUES (6849, 289, 1510, 5.8, 174, 434);
INSERT INTO public.europe_data VALUES (6850, 0, 42, 2.07, 86, 434);
INSERT INTO public.europe_data VALUES (6851, 28, 414, 0.58, 117, 434);
INSERT INTO public.europe_data VALUES (6852, 1, 5, 6.49, 175, 434);
INSERT INTO public.europe_data VALUES (6853, 0, 72, 2.23, 118, 434);
INSERT INTO public.europe_data VALUES (6854, 43, 2923, 26.27, 119, 434);
INSERT INTO public.europe_data VALUES (6855, 20, 1144, 3.75, 26, 434);
INSERT INTO public.europe_data VALUES (6856, 3, 683, 51.99, 176, 434);
INSERT INTO public.europe_data VALUES (6857, 30, 3730, 185.45, 120, 434);
INSERT INTO public.europe_data VALUES (6858, 13, 984, 20.64, 121, 434);
INSERT INTO public.europe_data VALUES (6859, 0, 0, 0, 122, 434);
INSERT INTO public.europe_data VALUES (6860, 2, 14, 1.2, 177, 434);
INSERT INTO public.europe_data VALUES (6861, 0, 141, 3.73, 123, 434);
INSERT INTO public.europe_data VALUES (6862, 0, 0, 0, 27, 434);
INSERT INTO public.europe_data VALUES (6863, 2, 168, 5.41, 28, 434);
INSERT INTO public.europe_data VALUES (6864, 2, 126, 4.25, 29, 434);
INSERT INTO public.europe_data VALUES (6865, 0, 0, 0, 178, 434);
INSERT INTO public.europe_data VALUES (6866, 1, 30, 3.01, 179, 434);
INSERT INTO public.europe_data VALUES (6867, 0, 50, 13.19, 180, 434);
INSERT INTO public.europe_data VALUES (6868, 4, 324, 2.02, 30, 434);
INSERT INTO public.europe_data VALUES (6869, 5, 183, 1.57, 31, 434);
INSERT INTO public.europe_data VALUES (6870, 0, 119, 0.78, 124, 434);
INSERT INTO public.europe_data VALUES (6871, 0, 168, 56.5, 125, 434);
INSERT INTO public.europe_data VALUES (6872, 7, 152, 2.18, 32, 434);
INSERT INTO public.europe_data VALUES (6873, 0, 15, 7.09, 181, 434);
INSERT INTO public.europe_data VALUES (6874, 21, 1030, 41.23, 33, 434);
INSERT INTO public.europe_data VALUES (6875, 0, 0, 0, 34, 434);
INSERT INTO public.europe_data VALUES (6876, 4684, 37054, 55.79, 87, 434);
INSERT INTO public.europe_data VALUES (6877, 67, 2460, 111.3, 182, 434);
INSERT INTO public.europe_data VALUES (6878, 0, 1, 3.02, 183, 434);
INSERT INTO public.europe_data VALUES (6879, 0, 16, 0.59, 126, 434);
INSERT INTO public.europe_data VALUES (6880, 0, 37, 6.11, 184, 434);
INSERT INTO public.europe_data VALUES (6881, 0, 0, 0, 88, 434);
INSERT INTO public.europe_data VALUES (6882, 2, 1243, 4.81, 35, 434);
INSERT INTO public.europe_data VALUES (6883, 2, 150, 1.01, 36, 434);
INSERT INTO public.europe_data VALUES (6884, 0, 28, 0.09, 127, 434);
INSERT INTO public.europe_data VALUES (6885, 0, 23, 1.04, 37, 434);
INSERT INTO public.europe_data VALUES (6886, 4, 3266, 19.5, 128, 434);
INSERT INTO public.europe_data VALUES (6887, 31, 810, 11.68, 185, 434);
INSERT INTO public.europe_data VALUES (6888, 0, 0, 0.35, 208, 434);
INSERT INTO public.europe_data VALUES (6889, 0, 9, 0.19, 209, 434);
INSERT INTO public.europe_data VALUES (6890, 9, 359, 10.77, 89, 434);
INSERT INTO public.europe_data VALUES (6891, 1, 56, 0.27, 38, 434);
INSERT INTO public.europe_data VALUES (6892, 98, 4159, 3.86, 39, 434);
INSERT INTO public.europe_data VALUES (6893, 50, 1049, 100.04, 186, 434);
INSERT INTO public.europe_data VALUES (6894, 0, 0, 5.24, 210, 434);
INSERT INTO public.europe_data VALUES (6895, 2, 102, 3.83, 187, 434);
INSERT INTO public.europe_data VALUES (6896, 27, 5990, 253.05, 129, 434);
INSERT INTO public.europe_data VALUES (6897, 861, 36610, 35.75, 130, 434);
INSERT INTO public.europe_data VALUES (6898, 0, 349, 7.45, 131, 434);
INSERT INTO public.europe_data VALUES (6899, 64, 5344, 226.19, 90, 434);
INSERT INTO public.europe_data VALUES (6900, 0, 1, 0.01, 211, 434);
INSERT INTO public.europe_data VALUES (6901, 2, 90, 3.46, 91, 434);
INSERT INTO public.europe_data VALUES (6902, 1357, 25200, 179.7, 92, 434);
INSERT INTO public.europe_data VALUES (6903, 81, 4122, 7.54, 132, 434);
INSERT INTO public.europe_data VALUES (6904, 109, 2539, 14.14, 188, 434);
INSERT INTO public.europe_data VALUES (6905, 13, 2443, 45.15, 189, 434);
INSERT INTO public.europe_data VALUES (6906, 2, 714, 52.5, 93, 434);
INSERT INTO public.europe_data VALUES (6907, 25, 7767, 656.02, 133, 434);
INSERT INTO public.europe_data VALUES (6908, 102, 2046, 18.37, 190, 434);
INSERT INTO public.europe_data VALUES (6909, 1163, 55716, 80.21, 191, 434);
INSERT INTO public.europe_data VALUES (6910, 0, 146, 2.29, 40, 434);
INSERT INTO public.europe_data VALUES (6911, 0, 0, 0, 94, 434);
INSERT INTO public.europe_data VALUES (6912, 0, 0, 0, 95, 434);
INSERT INTO public.europe_data VALUES (6913, 0, 2, 2.71, 96, 434);
INSERT INTO public.europe_data VALUES (6914, 0, 2, 26.12, 192, 434);
INSERT INTO public.europe_data VALUES (6915, 0, 37, 85.56, 41, 434);
INSERT INTO public.europe_data VALUES (6916, 295, 30071, 162.53, 134, 434);
INSERT INTO public.europe_data VALUES (6917, 24, 798, 9.57, 42, 434);
INSERT INTO public.europe_data VALUES (6918, 7, 584, 15.38, 193, 434);
INSERT INTO public.europe_data VALUES (6919, 0, 0, 0, 43, 434);
INSERT INTO public.europe_data VALUES (6920, 4, 158, 4.58, 44, 434);
INSERT INTO public.europe_data VALUES (6921, 0, 1491, 72.1, 135, 434);
INSERT INTO public.europe_data VALUES (6922, 0, 0, 0, 97, 434);
INSERT INTO public.europe_data VALUES (6923, 0, 39, 1.08, 194, 434);
INSERT INTO public.europe_data VALUES (6924, 0, 25, 1.68, 195, 434);
INSERT INTO public.europe_data VALUES (6925, 2, 176, 2.88, 45, 434);
INSERT INTO public.europe_data VALUES (6926, 450, 27264, 83.71, 46, 434);
INSERT INTO public.europe_data VALUES (6927, 3, 317, 1.22, 136, 434);
INSERT INTO public.europe_data VALUES (6928, 7, 189, 5.11, 47, 434);
INSERT INTO public.europe_data VALUES (6929, 1188, 2395, 10.2, 196, 434);
INSERT INTO public.europe_data VALUES (6930, 0, 61, 0.54, 137, 434);
INSERT INTO public.europe_data VALUES (6931, 62, 1360, 5.83, 48, 434);
INSERT INTO public.europe_data VALUES (6932, 5, 106, 33.03, 98, 434);
INSERT INTO public.europe_data VALUES (6933, 200, 7073, 138.77, 197, 434);
INSERT INTO public.europe_data VALUES (6934, 3, 175, 3.83, 198, 434);
INSERT INTO public.europe_data VALUES (6935, 1, 27, 0.37, 138, 434);
INSERT INTO public.europe_data VALUES (6936, 0, 3, 0.01, 139, 434);
INSERT INTO public.europe_data VALUES (6937, 2, 422, 9.96, 140, 434);
INSERT INTO public.europe_data VALUES (6938, 0, 13, 0.04, 141, 434);
INSERT INTO public.europe_data VALUES (6939, 0, 0, 0, 142, 434);
INSERT INTO public.europe_data VALUES (6940, 0, 38, 0.92, 49, 434);
INSERT INTO public.europe_data VALUES (6941, 0, 0, 0.43, 99, 434);
INSERT INTO public.europe_data VALUES (6942, 1, 61, 0.6, 50, 434);
INSERT INTO public.europe_data VALUES (6943, 143, 9446, 21.41, 199, 434);
INSERT INTO public.europe_data VALUES (6944, 0, 2, 5.24, 100, 434);
INSERT INTO public.europe_data VALUES (6945, 0, 74, 0.35, 51, 434);
INSERT INTO public.europe_data VALUES (6946, 113, 5406, 21.73, 200, 434);
INSERT INTO public.europe_data VALUES (6947, 13, 2631, 62.61, 143, 434);
INSERT INTO public.europe_data VALUES (6948, 512, 6680, 20.73, 201, 434);
INSERT INTO public.europe_data VALUES (6949, 0, 0, 0, 52, 434);
INSERT INTO public.europe_data VALUES (6950, 4243, 186843, 102.88, 101, 434);
INSERT INTO public.europe_data VALUES (6951, 0, 3, 4.78, 102, 434);
INSERT INTO public.europe_data VALUES (6952, 2, 28, 0.9, 103, 434);
INSERT INTO public.europe_data VALUES (6953, 0, 1255, 6.08, 144, 434);
INSERT INTO public.europe_data VALUES (6954, 8, 940, 5.4, 104, 434);
INSERT INTO public.europe_data VALUES (6955, 0, 15, 0.02, 145, 434);
INSERT INTO public.europe_data VALUES (6956, 0, 2, 0.34, 53, 434);
INSERT INTO public.europe_data VALUES (6957, 92, 213, 1.56, 146, 434);
INSERT INTO public.europe_data VALUES (6958, 0, 72, 1.55, 54, 434);
INSERT INTO public.europe_data VALUES (6959, 2, 106, 1.41, 55, 434);
INSERT INTO public.europe_data VALUES (6960, 114, 4424, 25.13, 105, 435);
INSERT INTO public.europe_data VALUES (6961, 2, 275, 13.42, 147, 435);
INSERT INTO public.europe_data VALUES (6962, 60, 765, 3.54, 1, 435);
INSERT INTO public.europe_data VALUES (6963, 0, 1, 116.83, 148, 435);
INSERT INTO public.europe_data VALUES (6964, 2, 49, 0.17, 2, 435);
INSERT INTO public.europe_data VALUES (6965, 0, 0, 0, 56, 435);
INSERT INTO public.europe_data VALUES (6966, 0, 0, 1.03, 57, 435);
INSERT INTO public.europe_data VALUES (6967, 169, 8783, 32.88, 58, 435);
INSERT INTO public.europe_data VALUES (6968, 74, 3739, 256.01, 149, 435);
INSERT INTO public.europe_data VALUES (6969, 0, 0, 0, 59, 435);
INSERT INTO public.europe_data VALUES (6970, 0, 60, 0.5, 202, 435);
INSERT INTO public.europe_data VALUES (6971, 5, 170, 4.47, 150, 435);
INSERT INTO public.europe_data VALUES (6972, 31, 2404, 44.42, 151, 435);
INSERT INTO public.europe_data VALUES (6973, 0, 0, 0.26, 60, 435);
INSERT INTO public.europe_data VALUES (6974, 17, 3781, 435.42, 106, 435);
INSERT INTO public.europe_data VALUES (6975, 283, 21751, 24.76, 107, 435);
INSERT INTO public.europe_data VALUES (6976, 0, 4, 1.39, 61, 435);
INSERT INTO public.europe_data VALUES (6977, 39, 5343, 120.78, 152, 435);
INSERT INTO public.europe_data VALUES (6978, 58, 671, 13.25, 153, 435);
INSERT INTO public.europe_data VALUES (6979, 0, 3, 0.77, 62, 435);
INSERT INTO public.europe_data VALUES (6980, 3, 202, 2.02, 3, 435);
INSERT INTO public.europe_data VALUES (6981, 0, 3, 6.4, 63, 435);
INSERT INTO public.europe_data VALUES (6982, 0, 7, 3.01, 108, 435);
INSERT INTO public.europe_data VALUES (6983, 146, 4816, 73.63, 64, 435);
INSERT INTO public.europe_data VALUES (6984, 0, 0, 0, 65, 435);
INSERT INTO public.europe_data VALUES (6985, 4, 328, 14.9, 154, 435);
INSERT INTO public.europe_data VALUES (6986, 0, 20, 0.95, 4, 435);
INSERT INTO public.europe_data VALUES (6987, 6877, 175866, 167.15, 66, 435);
INSERT INTO public.europe_data VALUES (6988, 0, 0, 0, 67, 435);
INSERT INTO public.europe_data VALUES (6989, 0, 0, 0, 109, 435);
INSERT INTO public.europe_data VALUES (6990, 14, 563, 11.1, 155, 435);
INSERT INTO public.europe_data VALUES (6991, 0, 5, 0.06, 5, 435);
INSERT INTO public.europe_data VALUES (6992, 0, 11, 0.27, 6, 435);
INSERT INTO public.europe_data VALUES (6993, 0, 2, 0.02, 110, 435);
INSERT INTO public.europe_data VALUES (6994, 73, 1956, 15.3, 7, 435);
INSERT INTO public.europe_data VALUES (6995, 346, 3088, 20.96, 68, 435);
INSERT INTO public.europe_data VALUES (6996, 1, 196, 57.28, 8, 435);
INSERT INTO public.europe_data VALUES (6997, 0, 23, 70.83, 69, 435);
INSERT INTO public.europe_data VALUES (6998, 2, 588, 25.52, 9, 435);
INSERT INTO public.europe_data VALUES (6999, 4, 13, 0.45, 10, 435);
INSERT INTO public.europe_data VALUES (7000, 1133, 40143, 393.65, 70, 435);
INSERT INTO public.europe_data VALUES (7001, 0, 144, 0.01, 111, 435);
INSERT INTO public.europe_data VALUES (7002, 408, 11703, 42.82, 71, 435);
INSERT INTO public.europe_data VALUES (7003, 0, 35, 8.23, 11, 435);
INSERT INTO public.europe_data VALUES (7004, 3, 96, 3.12, 12, 435);
INSERT INTO public.europe_data VALUES (7005, 2, 397, 13.06, 72, 435);
INSERT INTO public.europe_data VALUES (7006, 9, 1345, 8.75, 13, 435);
INSERT INTO public.europe_data VALUES (7007, 3, 5, 0.15, 156, 435);
INSERT INTO public.europe_data VALUES (7008, 1, 57, 1.79, 73, 435);
INSERT INTO public.europe_data VALUES (7009, 0, 1, 1.84, 74, 435);
INSERT INTO public.europe_data VALUES (7010, 0, 19, 4.45, 157, 435);
INSERT INTO public.europe_data VALUES (7011, 2, 396, 7.05, 158, 435);
INSERT INTO public.europe_data VALUES (7012, 21, 761, 1.99, 14, 435);
INSERT INTO public.europe_data VALUES (7013, 8, 245, 9.03, 159, 435);
INSERT INTO public.europe_data VALUES (7014, 15, 258, 114.12, 15, 435);
INSERT INTO public.europe_data VALUES (7015, 0, 0, 2.79, 75, 435);
INSERT INTO public.europe_data VALUES (7016, 54, 3362, 52.86, 76, 435);
INSERT INTO public.europe_data VALUES (7017, 275, 3631, 44.05, 77, 435);
INSERT INTO public.europe_data VALUES (7018, 338, 10519, 19.54, 16, 435);
INSERT INTO public.europe_data VALUES (7019, 19, 705, 18.64, 78, 435);
INSERT INTO public.europe_data VALUES (7020, 0, 0, 0, 17, 435);
INSERT INTO public.europe_data VALUES (7021, 0, 55, 1.63, 18, 435);
INSERT INTO public.europe_data VALUES (7022, 0, 34, 7.85, 160, 435);
INSERT INTO public.europe_data VALUES (7023, 1, 157, 17.86, 19, 435);
INSERT INTO public.europe_data VALUES (7024, 30, 1325, 1.94, 20, 435);
INSERT INTO public.europe_data VALUES (7025, 0, 0, 0, 79, 435);
INSERT INTO public.europe_data VALUES (7026, 0, 0, 0, 161, 435);
INSERT INTO public.europe_data VALUES (7027, 0, 0, 0, 203, 435);
INSERT INTO public.europe_data VALUES (7028, 3, 123, 4.44, 162, 435);
INSERT INTO public.europe_data VALUES (7029, 252, 3243, 8.16, 163, 435);
INSERT INTO public.europe_data VALUES (7030, 0, 0, 0, 204, 435);
INSERT INTO public.europe_data VALUES (7031, 2, 362, 37.19, 21, 435);
INSERT INTO public.europe_data VALUES (7032, 0, 2, 0.13, 22, 435);
INSERT INTO public.europe_data VALUES (7033, 1, 71, 2.4, 164, 435);
INSERT INTO public.europe_data VALUES (7034, 117, 2268, 5.6, 165, 435);
INSERT INTO public.europe_data VALUES (7035, 10, 2326, 12.8, 23, 435);
INSERT INTO public.europe_data VALUES (7036, 0, 1, 20.77, 166, 435);
INSERT INTO public.europe_data VALUES (7037, 3, 124, 1.9, 167, 435);
INSERT INTO public.europe_data VALUES (7038, 0, 0, 0, 80, 435);
INSERT INTO public.europe_data VALUES (7039, 0, 0, 0, 81, 435);
INSERT INTO public.europe_data VALUES (7040, 0, 6, 5.98, 205, 435);
INSERT INTO public.europe_data VALUES (7041, 132, 2790, 27.06, 82, 435);
INSERT INTO public.europe_data VALUES (7042, 0, 0, 0, 168, 435);
INSERT INTO public.europe_data VALUES (7043, 2, 367, 5.96, 24, 435);
INSERT INTO public.europe_data VALUES (7044, 3, 92, 7.18, 25, 435);
INSERT INTO public.europe_data VALUES (7045, 0, 5, 0.77, 83, 435);
INSERT INTO public.europe_data VALUES (7046, 22, 975, 19.4, 84, 435);
INSERT INTO public.europe_data VALUES (7047, 0, 0, 0, 169, 435);
INSERT INTO public.europe_data VALUES (7048, 54, 2531, 37.51, 85, 435);
INSERT INTO public.europe_data VALUES (7049, 21, 106, 2.05, 170, 435);
INSERT INTO public.europe_data VALUES (7050, 0, 3, 1.12, 171, 435);
INSERT INTO public.europe_data VALUES (7051, 2385, 75813, 10.38, 112, 435);
INSERT INTO public.europe_data VALUES (7052, 283, 7091, 4.36, 113, 435);
INSERT INTO public.europe_data VALUES (7053, 556, 15638, 43.37, 114, 435);
INSERT INTO public.europe_data VALUES (7054, 261, 7843, 35.03, 115, 435);
INSERT INTO public.europe_data VALUES (7055, 27, 102, 6.38, 172, 435);
INSERT INTO public.europe_data VALUES (7056, 0, 0, 0, 173, 435);
INSERT INTO public.europe_data VALUES (7057, 4, 1206, 24.06, 116, 435);
INSERT INTO public.europe_data VALUES (7058, 446, 1991, 6.58, 174, 435);
INSERT INTO public.europe_data VALUES (7059, 0, 19, 1.05, 86, 435);
INSERT INTO public.europe_data VALUES (7060, 9, 328, 0.49, 117, 435);
INSERT INTO public.europe_data VALUES (7061, 0, 2, 4.64, 175, 435);
INSERT INTO public.europe_data VALUES (7062, 0, 153, 2.2, 118, 435);
INSERT INTO public.europe_data VALUES (7063, 21, 1950, 18.87, 119, 435);
INSERT INTO public.europe_data VALUES (7064, 19, 827, 3.1, 26, 435);
INSERT INTO public.europe_data VALUES (7065, 2, 252, 22.41, 176, 435);
INSERT INTO public.europe_data VALUES (7066, 32, 4072, 211, 120, 435);
INSERT INTO public.europe_data VALUES (7067, 4, 340, 8.65, 121, 435);
INSERT INTO public.europe_data VALUES (7068, 0, 0, 0, 122, 435);
INSERT INTO public.europe_data VALUES (7069, 3, 9, 1.61, 177, 435);
INSERT INTO public.europe_data VALUES (7070, 2, 115, 3.3, 123, 435);
INSERT INTO public.europe_data VALUES (7071, 0, 0, 0.09, 27, 435);
INSERT INTO public.europe_data VALUES (7072, 2, 99, 3.44, 28, 435);
INSERT INTO public.europe_data VALUES (7073, 3, 162, 3.87, 29, 435);
INSERT INTO public.europe_data VALUES (7074, 0, 0, 0, 178, 435);
INSERT INTO public.europe_data VALUES (7075, 4, 54, 3.33, 179, 435);
INSERT INTO public.europe_data VALUES (7076, 0, 31, 8.47, 180, 435);
INSERT INTO public.europe_data VALUES (7077, 1, 220, 1.86, 30, 435);
INSERT INTO public.europe_data VALUES (7078, 2, 109, 1.41, 31, 435);
INSERT INTO public.europe_data VALUES (7079, 4, 131, 1.98, 124, 435);
INSERT INTO public.europe_data VALUES (7080, 0, 132, 49.34, 125, 435);
INSERT INTO public.europe_data VALUES (7081, 12, 276, 2.77, 32, 435);
INSERT INTO public.europe_data VALUES (7082, 0, 20, 6.28, 181, 435);
INSERT INTO public.europe_data VALUES (7083, 44, 836, 27.69, 33, 435);
INSERT INTO public.europe_data VALUES (7084, 0, 0, 0.16, 34, 435);
INSERT INTO public.europe_data VALUES (7085, 3442, 34118, 50.31, 87, 435);
INSERT INTO public.europe_data VALUES (7086, 65, 2040, 86.29, 182, 435);
INSERT INTO public.europe_data VALUES (7087, 0, 0, 0, 183, 435);
INSERT INTO public.europe_data VALUES (7088, 0, 3, 0.37, 126, 435);
INSERT INTO public.europe_data VALUES (7089, 0, 1, 0.16, 184, 435);
INSERT INTO public.europe_data VALUES (7090, 0, 0, 0, 88, 435);
INSERT INTO public.europe_data VALUES (7091, 4, 510, 2.54, 35, 435);
INSERT INTO public.europe_data VALUES (7092, 1, 157, 1.08, 36, 435);
INSERT INTO public.europe_data VALUES (7093, 0, 19, 0.06, 127, 435);
INSERT INTO public.europe_data VALUES (7094, 0, 3, 0.32, 37, 435);
INSERT INTO public.europe_data VALUES (7095, 6, 2312, 14.64, 128, 435);
INSERT INTO public.europe_data VALUES (7096, 46, 1209, 13.55, 185, 435);
INSERT INTO public.europe_data VALUES (7097, 0, 1, 0.71, 208, 435);
INSERT INTO public.europe_data VALUES (7098, 0, 0, 0, 209, 435);
INSERT INTO public.europe_data VALUES (7099, 9, 346, 13.69, 89, 435);
INSERT INTO public.europe_data VALUES (7100, 1, 7, 0.09, 38, 435);
INSERT INTO public.europe_data VALUES (7101, 66, 3599, 2.95, 39, 435);
INSERT INTO public.europe_data VALUES (7102, 35, 1029, 88.15, 186, 435);
INSERT INTO public.europe_data VALUES (7103, 0, 3, 13.98, 210, 435);
INSERT INTO public.europe_data VALUES (7104, 4, 102, 3.66, 187, 435);
INSERT INTO public.europe_data VALUES (7105, 29, 6599, 242.09, 129, 435);
INSERT INTO public.europe_data VALUES (7106, 662, 40807, 33.25, 130, 435);
INSERT INTO public.europe_data VALUES (7107, 0, 22, 0.92, 131, 435);
INSERT INTO public.europe_data VALUES (7108, 44, 4261, 170.1, 90, 435);
INSERT INTO public.europe_data VALUES (7109, 0, 0, 0, 211, 435);
INSERT INTO public.europe_data VALUES (7110, 0, 154, 4.3, 91, 435);
INSERT INTO public.europe_data VALUES (7111, 1223, 33221, 200.74, 92, 435);
INSERT INTO public.europe_data VALUES (7112, 85, 4035, 7.26, 132, 435);
INSERT INTO public.europe_data VALUES (7113, 90, 2831, 14.76, 188, 435);
INSERT INTO public.europe_data VALUES (7114, 38, 2197, 40.77, 189, 435);
INSERT INTO public.europe_data VALUES (7115, 5, 826, 69.37, 93, 435);
INSERT INTO public.europe_data VALUES (7116, 19, 10812, 801.25, 133, 435);
INSERT INTO public.europe_data VALUES (7117, 84, 1520, 14.12, 190, 435);
INSERT INTO public.europe_data VALUES (7118, 1089, 61291, 84.4, 191, 435);
INSERT INTO public.europe_data VALUES (7119, 0, 143, 1.68, 40, 435);
INSERT INTO public.europe_data VALUES (7120, 0, 0, 0, 94, 435);
INSERT INTO public.europe_data VALUES (7121, 0, 0, 0.55, 95, 435);
INSERT INTO public.europe_data VALUES (7122, 0, 1, 0.9, 96, 435);
INSERT INTO public.europe_data VALUES (7123, 0, 7, 66.76, 192, 435);
INSERT INTO public.europe_data VALUES (7124, 0, 147, 82.77, 41, 435);
INSERT INTO public.europe_data VALUES (7125, 260, 25627, 123.38, 134, 435);
INSERT INTO public.europe_data VALUES (7126, 11, 762, 8.87, 42, 435);
INSERT INTO public.europe_data VALUES (7127, 5, 487, 12.9, 193, 435);
INSERT INTO public.europe_data VALUES (7128, 0, 0, 0, 43, 435);
INSERT INTO public.europe_data VALUES (7129, 3, 200, 3.94, 44, 435);
INSERT INTO public.europe_data VALUES (7130, 1, 2694, 98.55, 135, 435);
INSERT INTO public.europe_data VALUES (7131, 0, 0, 0, 97, 435);
INSERT INTO public.europe_data VALUES (7132, 0, 20, 0.48, 194, 435);
INSERT INTO public.europe_data VALUES (7133, 1, 10, 1.06, 195, 435);
INSERT INTO public.europe_data VALUES (7134, 5, 269, 4.06, 45, 435);
INSERT INTO public.europe_data VALUES (7135, 482, 21753, 63.79, 46, 435);
INSERT INTO public.europe_data VALUES (7136, 4, 307, 1.21, 136, 435);
INSERT INTO public.europe_data VALUES (7137, 13, 376, 6.32, 47, 435);
INSERT INTO public.europe_data VALUES (7138, 0, 2392, 9.53, 196, 435);
INSERT INTO public.europe_data VALUES (7139, 0, 54, 1.2, 137, 435);
INSERT INTO public.europe_data VALUES (7140, 100, 1137, 5.12, 48, 435);
INSERT INTO public.europe_data VALUES (7141, 2, 86, 31.82, 98, 435);
INSERT INTO public.europe_data VALUES (7142, 234, 7123, 128.48, 197, 435);
INSERT INTO public.europe_data VALUES (7143, 16, 152, 2.98, 198, 435);
INSERT INTO public.europe_data VALUES (7144, 0, 36, 0.32, 138, 435);
INSERT INTO public.europe_data VALUES (7145, 0, 0, 0, 139, 435);
INSERT INTO public.europe_data VALUES (7146, 2, 506, 13.17, 140, 435);
INSERT INTO public.europe_data VALUES (7147, 0, 16, 0.08, 141, 435);
INSERT INTO public.europe_data VALUES (7148, 0, 0, 0, 142, 435);
INSERT INTO public.europe_data VALUES (7149, 0, 36, 1.1, 49, 435);
INSERT INTO public.europe_data VALUES (7150, 0, 6, 0.43, 99, 435);
INSERT INTO public.europe_data VALUES (7151, 0, 9, 0.16, 50, 435);
INSERT INTO public.europe_data VALUES (7152, 115, 8107, 17.43, 199, 435);
INSERT INTO public.europe_data VALUES (7153, 0, 0, 0, 100, 435);
INSERT INTO public.europe_data VALUES (7154, 0, 80, 0.54, 51, 435);
INSERT INTO public.europe_data VALUES (7155, 101, 4155, 17.01, 200, 435);
INSERT INTO public.europe_data VALUES (7156, 13, 3486, 79.19, 143, 435);
INSERT INTO public.europe_data VALUES (7157, 747, 7136, 23.5, 201, 435);
INSERT INTO public.europe_data VALUES (7158, 0, 0, 0, 52, 435);
INSERT INTO public.europe_data VALUES (7159, 5218, 151706, 92.35, 101, 435);
INSERT INTO public.europe_data VALUES (7160, 0, 2, 3.82, 102, 435);
INSERT INTO public.europe_data VALUES (7161, 0, 3, 0.72, 103, 435);
INSERT INTO public.europe_data VALUES (7162, 2, 751, 4.37, 144, 435);
INSERT INTO public.europe_data VALUES (7163, 3, 601, 5.15, 104, 435);
INSERT INTO public.europe_data VALUES (7164, 0, 3, 0.01, 145, 435);
INSERT INTO public.europe_data VALUES (7165, 0, 0, 0, 53, 435);
INSERT INTO public.europe_data VALUES (7166, 52, 242, 1.39, 146, 435);
INSERT INTO public.europe_data VALUES (7167, 4, 204, 1.69, 54, 435);
INSERT INTO public.europe_data VALUES (7168, 0, 101, 1.4, 55, 435);
INSERT INTO public.europe_data VALUES (7169, 100, 5137, 25.66, 105, 436);
INSERT INTO public.europe_data VALUES (7170, 1, 109, 8.66, 147, 436);
INSERT INTO public.europe_data VALUES (7171, 54, 760, 4.29, 1, 436);
INSERT INTO public.europe_data VALUES (7172, 0, 88, 116.83, 148, 436);
INSERT INTO public.europe_data VALUES (7173, 0, 5, 0.07, 2, 436);
INSERT INTO public.europe_data VALUES (7174, 0, 0, 0, 56, 436);
INSERT INTO public.europe_data VALUES (7175, 0, 1, 1.03, 57, 436);
INSERT INTO public.europe_data VALUES (7176, 125, 5943, 23.93, 58, 436);
INSERT INTO public.europe_data VALUES (7177, 72, 3833, 210.03, 149, 436);
INSERT INTO public.europe_data VALUES (7178, 0, 0, 0, 59, 436);
INSERT INTO public.europe_data VALUES (7179, 0, 65, 0.6, 202, 436);
INSERT INTO public.europe_data VALUES (7180, 4, 226, 4.84, 150, 436);
INSERT INTO public.europe_data VALUES (7181, 25, 2059, 34.15, 151, 436);
INSERT INTO public.europe_data VALUES (7182, 0, 1, 0.77, 60, 436);
INSERT INTO public.europe_data VALUES (7183, 7, 3365, 342.74, 106, 436);
INSERT INTO public.europe_data VALUES (7184, 238, 18616, 19.72, 107, 436);
INSERT INTO public.europe_data VALUES (7185, 0, 0, 0, 61, 436);
INSERT INTO public.europe_data VALUES (7186, 34, 6074, 131.52, 152, 436);
INSERT INTO public.europe_data VALUES (7187, 113, 847, 17.38, 153, 436);
INSERT INTO public.europe_data VALUES (7188, 0, 0, 0, 62, 436);
INSERT INTO public.europe_data VALUES (7189, 1, 36, 0.65, 3, 436);
INSERT INTO public.europe_data VALUES (7190, 0, 1, 12.8, 63, 436);
INSERT INTO public.europe_data VALUES (7191, 0, 16, 4.19, 108, 436);
INSERT INTO public.europe_data VALUES (7192, 152, 3661, 64.1, 64, 436);
INSERT INTO public.europe_data VALUES (7193, 0, 0, 0, 65, 436);
INSERT INTO public.europe_data VALUES (7194, 7, 164, 8.27, 154, 436);
INSERT INTO public.europe_data VALUES (7195, 0, 2, 0.22, 4, 436);
INSERT INTO public.europe_data VALUES (7196, 7141, 176909, 155.67, 66, 436);
INSERT INTO public.europe_data VALUES (7197, 0, 0, 0, 67, 436);
INSERT INTO public.europe_data VALUES (7198, 0, 0, 0, 109, 436);
INSERT INTO public.europe_data VALUES (7199, 20, 214, 4.2, 155, 436);
INSERT INTO public.europe_data VALUES (7200, 0, 8, 0.28, 5, 436);
INSERT INTO public.europe_data VALUES (7201, 0, 20, 0.36, 6, 436);
INSERT INTO public.europe_data VALUES (7202, 0, 1, 0.01, 110, 436);
INSERT INTO public.europe_data VALUES (7203, 12, 2004, 11.66, 7, 436);
INSERT INTO public.europe_data VALUES (7204, 505, 4752, 29.4, 68, 436);
INSERT INTO public.europe_data VALUES (7205, 1, 119, 31.64, 8, 436);
INSERT INTO public.europe_data VALUES (7206, 0, 23, 53.89, 69, 436);
INSERT INTO public.europe_data VALUES (7207, 3, 623, 21.71, 9, 436);
INSERT INTO public.europe_data VALUES (7208, 4, 59, 1.02, 10, 436);
INSERT INTO public.europe_data VALUES (7209, 1136, 34462, 343.22, 70, 436);
INSERT INTO public.europe_data VALUES (7210, 0, 44, 0.01, 111, 436);
INSERT INTO public.europe_data VALUES (7211, 320, 9853, 35.88, 71, 436);
INSERT INTO public.europe_data VALUES (7212, 0, 35, 6.35, 11, 436);
INSERT INTO public.europe_data VALUES (7213, 2, 72, 3.64, 12, 436);
INSERT INTO public.europe_data VALUES (7214, 0, 262, 7.69, 72, 436);
INSERT INTO public.europe_data VALUES (7215, 3, 906, 5.3, 13, 436);
INSERT INTO public.europe_data VALUES (7216, 1, 1, 0.07, 156, 436);
INSERT INTO public.europe_data VALUES (7217, 0, 146, 2.21, 73, 436);
INSERT INTO public.europe_data VALUES (7218, 0, 2, 2.45, 74, 436);
INSERT INTO public.europe_data VALUES (7219, 1, 20, 3.31, 157, 436);
INSERT INTO public.europe_data VALUES (7220, 7, 355, 6.3, 158, 436);
INSERT INTO public.europe_data VALUES (7221, 14, 967, 1.98, 14, 436);
INSERT INTO public.europe_data VALUES (7222, 15, 279, 10.13, 159, 436);
INSERT INTO public.europe_data VALUES (7223, 4, 853, 198.96, 15, 436);
INSERT INTO public.europe_data VALUES (7224, 0, 2, 2.79, 75, 436);
INSERT INTO public.europe_data VALUES (7225, 36, 2315, 48.22, 76, 436);
INSERT INTO public.europe_data VALUES (7226, 263, 4022, 36.63, 77, 436);
INSERT INTO public.europe_data VALUES (7227, 278, 9094, 16.75, 16, 436);
INSERT INTO public.europe_data VALUES (7228, 9, 498, 17.04, 78, 436);
INSERT INTO public.europe_data VALUES (7229, 0, 0, 19.4, 17, 436);
INSERT INTO public.europe_data VALUES (7230, 0, 2, 0.06, 18, 436);
INSERT INTO public.europe_data VALUES (7231, 0, 70, 8.76, 160, 436);
INSERT INTO public.europe_data VALUES (7232, 1, 48, 7.23, 19, 436);
INSERT INTO public.europe_data VALUES (7233, 16, 848, 1.28, 20, 436);
INSERT INTO public.europe_data VALUES (7234, 0, 0, 0, 79, 436);
INSERT INTO public.europe_data VALUES (7235, 0, 0, 0, 161, 436);
INSERT INTO public.europe_data VALUES (7236, 0, 0, 0, 203, 436);
INSERT INTO public.europe_data VALUES (7237, 3, 122, 7.29, 162, 436);
INSERT INTO public.europe_data VALUES (7238, 353, 2224, 13.51, 163, 436);
INSERT INTO public.europe_data VALUES (7239, 0, 0, 0, 204, 436);
INSERT INTO public.europe_data VALUES (7240, 4, 446, 53.71, 21, 436);
INSERT INTO public.europe_data VALUES (7241, 0, 1, 0.04, 22, 436);
INSERT INTO public.europe_data VALUES (7242, 1, 25, 1.95, 164, 436);
INSERT INTO public.europe_data VALUES (7243, 163, 2378, 6.77, 165, 436);
INSERT INTO public.europe_data VALUES (7244, 8, 1568, 9.71, 23, 436);
INSERT INTO public.europe_data VALUES (7245, 0, 6, 71.2, 166, 436);
INSERT INTO public.europe_data VALUES (7246, 5, 80, 1.11, 167, 436);
INSERT INTO public.europe_data VALUES (7247, 0, 0, 3.53, 80, 436);
INSERT INTO public.europe_data VALUES (7248, 0, 0, 0.89, 81, 436);
INSERT INTO public.europe_data VALUES (7249, 0, 4, 7.77, 205, 436);
INSERT INTO public.europe_data VALUES (7250, 144, 1968, 20.65, 82, 436);
INSERT INTO public.europe_data VALUES (7251, 0, 0, 0, 168, 436);
INSERT INTO public.europe_data VALUES (7252, 0, 394, 6.97, 24, 436);
INSERT INTO public.europe_data VALUES (7253, 4, 46, 10.15, 25, 436);
INSERT INTO public.europe_data VALUES (7254, 0, 1, 2.43, 83, 436);
INSERT INTO public.europe_data VALUES (7255, 7, 1210, 21.1, 84, 436);
INSERT INTO public.europe_data VALUES (7256, 0, 0, 0, 169, 436);
INSERT INTO public.europe_data VALUES (7257, 46, 1125, 24.39, 85, 436);
INSERT INTO public.europe_data VALUES (7258, 16, 94, 2.19, 170, 436);
INSERT INTO public.europe_data VALUES (7259, 0, 1, 0.84, 171, 436);
INSERT INTO public.europe_data VALUES (7260, 1741, 66076, 8.62, 112, 436);
INSERT INTO public.europe_data VALUES (7261, 238, 4713, 3.29, 113, 436);
INSERT INTO public.europe_data VALUES (7262, 484, 20323, 43.52, 114, 436);
INSERT INTO public.europe_data VALUES (7263, 141, 5927, 20.09, 115, 436);
INSERT INTO public.europe_data VALUES (7264, 29, 211, 11.46, 172, 436);
INSERT INTO public.europe_data VALUES (7265, 0, 0, 0, 173, 436);
INSERT INTO public.europe_data VALUES (7266, 13, 844, 14.03, 116, 436);
INSERT INTO public.europe_data VALUES (7267, 484, 1979, 8.52, 174, 436);
INSERT INTO public.europe_data VALUES (7268, 1, 12, 1.56, 86, 436);
INSERT INTO public.europe_data VALUES (7269, 24, 290, 0.47, 117, 436);
INSERT INTO public.europe_data VALUES (7270, 1, 3, 4.64, 175, 436);
INSERT INTO public.europe_data VALUES (7271, 0, 69, 0.99, 118, 436);
INSERT INTO public.europe_data VALUES (7272, 15, 1551, 23.33, 119, 436);
INSERT INTO public.europe_data VALUES (7273, 20, 805, 2.95, 26, 436);
INSERT INTO public.europe_data VALUES (7274, 1, 151, 11.23, 176, 436);
INSERT INTO public.europe_data VALUES (7275, 52, 4805, 250.67, 120, 436);
INSERT INTO public.europe_data VALUES (7276, 7, 215, 9.34, 121, 436);
INSERT INTO public.europe_data VALUES (7277, 0, 0, 0, 122, 436);
INSERT INTO public.europe_data VALUES (7278, 1, 22, 2.14, 177, 436);
INSERT INTO public.europe_data VALUES (7279, 3, 111, 3.17, 123, 436);
INSERT INTO public.europe_data VALUES (7280, 0, 2, 0.09, 27, 436);
INSERT INTO public.europe_data VALUES (7281, 3, 71, 1.9, 28, 436);
INSERT INTO public.europe_data VALUES (7282, 0, 100, 2.67, 29, 436);
INSERT INTO public.europe_data VALUES (7283, 0, 0, 0, 178, 436);
INSERT INTO public.europe_data VALUES (7284, 1, 39, 3.26, 179, 436);
INSERT INTO public.europe_data VALUES (7285, 0, 21, 7.66, 180, 436);
INSERT INTO public.europe_data VALUES (7286, 3, 281, 1.95, 30, 436);
INSERT INTO public.europe_data VALUES (7287, 0, 154, 1.91, 31, 436);
INSERT INTO public.europe_data VALUES (7288, 2, 503, 3.37, 124, 436);
INSERT INTO public.europe_data VALUES (7289, 3, 130, 100.2, 125, 436);
INSERT INTO public.europe_data VALUES (7290, 15, 268, 2.56, 32, 436);
INSERT INTO public.europe_data VALUES (7291, 0, 11, 3.85, 181, 436);
INSERT INTO public.europe_data VALUES (7292, 20, 417, 15.69, 33, 436);
INSERT INTO public.europe_data VALUES (7293, 0, 2, 0.24, 34, 436);
INSERT INTO public.europe_data VALUES (7294, 3769, 30070, 44.49, 87, 436);
INSERT INTO public.europe_data VALUES (7295, 46, 1449, 64.48, 182, 436);
INSERT INTO public.europe_data VALUES (7296, 0, 0, 0, 183, 436);
INSERT INTO public.europe_data VALUES (7297, 0, 9, 1.64, 126, 436);
INSERT INTO public.europe_data VALUES (7298, 0, 0, 0, 184, 436);
INSERT INTO public.europe_data VALUES (7299, 0, 0, 0, 88, 436);
INSERT INTO public.europe_data VALUES (7300, 3, 417, 2.17, 35, 436);
INSERT INTO public.europe_data VALUES (7301, 0, 172, 0.76, 36, 436);
INSERT INTO public.europe_data VALUES (7302, 0, 15, 0.08, 127, 436);
INSERT INTO public.europe_data VALUES (7303, 0, 5, 0.32, 37, 436);
INSERT INTO public.europe_data VALUES (7304, 5, 1876, 9.94, 128, 436);
INSERT INTO public.europe_data VALUES (7305, 57, 1132, 13.53, 185, 436);
INSERT INTO public.europe_data VALUES (7306, 0, 1, 0.71, 208, 436);
INSERT INTO public.europe_data VALUES (7307, 0, 0, 0, 209, 436);
INSERT INTO public.europe_data VALUES (7308, 11, 550, 15.74, 89, 436);
INSERT INTO public.europe_data VALUES (7309, 1, 15, 0.12, 38, 436);
INSERT INTO public.europe_data VALUES (7310, 67, 2324, 2.31, 39, 436);
INSERT INTO public.europe_data VALUES (7311, 20, 802, 50.55, 186, 436);
INSERT INTO public.europe_data VALUES (7312, 0, 5, 8.74, 210, 436);
INSERT INTO public.europe_data VALUES (7313, 2, 93, 3.66, 187, 436);
INSERT INTO public.europe_data VALUES (7314, 28, 5445, 183.16, 129, 436);
INSERT INTO public.europe_data VALUES (7315, 524, 31211, 21.85, 130, 436);
INSERT INTO public.europe_data VALUES (7316, 0, 24, 0.98, 131, 436);
INSERT INTO public.europe_data VALUES (7317, 57, 2962, 129.5, 90, 436);
INSERT INTO public.europe_data VALUES (7318, 0, 0, 0, 211, 436);
INSERT INTO public.europe_data VALUES (7319, 0, 149, 3.88, 91, 436);
INSERT INTO public.europe_data VALUES (7320, 959, 32039, 235.48, 92, 436);
INSERT INTO public.europe_data VALUES (7321, 46, 3809, 7.27, 132, 436);
INSERT INTO public.europe_data VALUES (7322, 93, 2775, 13.79, 188, 436);
INSERT INTO public.europe_data VALUES (7323, 69, 1993, 37.66, 189, 436);
INSERT INTO public.europe_data VALUES (7324, 6, 1209, 61.23, 93, 436);
INSERT INTO public.europe_data VALUES (7325, 16, 11880, 885.43, 133, 436);
INSERT INTO public.europe_data VALUES (7326, 64, 1222, 12.41, 190, 436);
INSERT INTO public.europe_data VALUES (7327, 1166, 61830, 84.45, 191, 436);
INSERT INTO public.europe_data VALUES (7328, 1, 69, 0.89, 40, 436);
INSERT INTO public.europe_data VALUES (7329, 0, 0, 0, 94, 436);
INSERT INTO public.europe_data VALUES (7330, 0, 1, 0.55, 95, 436);
INSERT INTO public.europe_data VALUES (7331, 0, 0, 7.23, 96, 436);
INSERT INTO public.europe_data VALUES (7332, 0, 16, 63.86, 192, 436);
INSERT INTO public.europe_data VALUES (7333, 0, 31, 99.98, 41, 436);
INSERT INTO public.europe_data VALUES (7334, 209, 16653, 85.66, 134, 436);
INSERT INTO public.europe_data VALUES (7335, 7, 683, 7.86, 42, 436);
INSERT INTO public.europe_data VALUES (7336, 6, 411, 9.54, 193, 436);
INSERT INTO public.europe_data VALUES (7337, 0, 0, 0, 43, 436);
INSERT INTO public.europe_data VALUES (7338, 2, 108, 3.35, 44, 436);
INSERT INTO public.europe_data VALUES (7339, 2, 3026, 108.44, 135, 436);
INSERT INTO public.europe_data VALUES (7340, 0, 0, 0, 97, 436);
INSERT INTO public.europe_data VALUES (7341, 0, 6, 0.35, 194, 436);
INSERT INTO public.europe_data VALUES (7342, 0, 12, 0.77, 195, 436);
INSERT INTO public.europe_data VALUES (7343, 5, 358, 4.79, 45, 436);
INSERT INTO public.europe_data VALUES (7344, 315, 15602, 43.89, 46, 436);
INSERT INTO public.europe_data VALUES (7345, 2, 311, 1.19, 136, 436);
INSERT INTO public.europe_data VALUES (7346, 4, 323, 6.82, 47, 436);
INSERT INTO public.europe_data VALUES (7347, 9, 2079, 13.46, 196, 436);
INSERT INTO public.europe_data VALUES (7348, 1, 202, 3.25, 137, 436);
INSERT INTO public.europe_data VALUES (7349, 73, 1057, 5.72, 48, 436);
INSERT INTO public.europe_data VALUES (7350, 0, 99, 19.09, 98, 436);
INSERT INTO public.europe_data VALUES (7351, 245, 6021, 100.7, 197, 436);
INSERT INTO public.europe_data VALUES (7352, 4, 103, 2.68, 198, 436);
INSERT INTO public.europe_data VALUES (7353, 2, 19, 0.32, 138, 436);
INSERT INTO public.europe_data VALUES (7354, 0, 1, 0.01, 139, 436);
INSERT INTO public.europe_data VALUES (7355, 1, 722, 19.21, 140, 436);
INSERT INTO public.europe_data VALUES (7356, 1, 38, 0.11, 141, 436);
INSERT INTO public.europe_data VALUES (7357, 0, 0, 0, 142, 436);
INSERT INTO public.europe_data VALUES (7358, 0, 53, 1.41, 49, 436);
INSERT INTO public.europe_data VALUES (7359, 0, 0, 0.07, 99, 436);
INSERT INTO public.europe_data VALUES (7360, 1, 10, 0.31, 50, 436);
INSERT INTO public.europe_data VALUES (7361, 152, 6190, 16.22, 199, 436);
INSERT INTO public.europe_data VALUES (7362, 0, 0, 0, 100, 436);
INSERT INTO public.europe_data VALUES (7363, 0, 158, 0.91, 51, 436);
INSERT INTO public.europe_data VALUES (7364, 80, 3327, 13.67, 200, 436);
INSERT INTO public.europe_data VALUES (7365, 12, 4251, 95.42, 143, 436);
INSERT INTO public.europe_data VALUES (7366, 1174, 8524, 29.16, 201, 436);
INSERT INTO public.europe_data VALUES (7367, 0, 0, 0, 52, 436);
INSERT INTO public.europe_data VALUES (7368, 6131, 152172, 90.9, 101, 436);
INSERT INTO public.europe_data VALUES (7369, 0, 2, 1.91, 102, 436);
INSERT INTO public.europe_data VALUES (7370, 1, 22, 2.2, 103, 436);
INSERT INTO public.europe_data VALUES (7371, 2, 690, 3.6, 144, 436);
INSERT INTO public.europe_data VALUES (7372, 8, 867, 4.4, 104, 436);
INSERT INTO public.europe_data VALUES (7373, 0, 3, 0.01, 145, 436);
INSERT INTO public.europe_data VALUES (7374, 0, 0, 2.92, 53, 436);
INSERT INTO public.europe_data VALUES (7375, 32, 163, 0.91, 146, 436);
INSERT INTO public.europe_data VALUES (7376, 0, 97, 1.31, 54, 436);
INSERT INTO public.europe_data VALUES (7377, 0, 104, 1.54, 55, 436);
INSERT INTO public.europe_data VALUES (7378, 39, 4623, 22.45, 105, 437);
INSERT INTO public.europe_data VALUES (7379, 1, 139, 6.67, 147, 437);
INSERT INTO public.europe_data VALUES (7380, 53, 1088, 5.52, 1, 437);
INSERT INTO public.europe_data VALUES (7381, 0, 1, 3.94, 148, 437);
INSERT INTO public.europe_data VALUES (7382, 0, 17, 0.12, 2, 437);
INSERT INTO public.europe_data VALUES (7383, 0, 0, 0, 56, 437);
INSERT INTO public.europe_data VALUES (7384, 0, 0, 0, 57, 437);
INSERT INTO public.europe_data VALUES (7385, 87, 4775, 20.2, 58, 437);
INSERT INTO public.europe_data VALUES (7386, 52, 2379, 157.86, 149, 437);
INSERT INTO public.europe_data VALUES (7387, 0, 0, 0, 59, 437);
INSERT INTO public.europe_data VALUES (7388, 0, 86, 0.6, 202, 437);
INSERT INTO public.europe_data VALUES (7389, 28, 203, 5.51, 150, 437);
INSERT INTO public.europe_data VALUES (7390, 14, 1372, 22.09, 151, 437);
INSERT INTO public.europe_data VALUES (7391, 0, 2, 1.54, 60, 437);
INSERT INTO public.europe_data VALUES (7392, 5, 2260, 270.66, 106, 437);
INSERT INTO public.europe_data VALUES (7393, 170, 13543, 15.26, 107, 437);
INSERT INTO public.europe_data VALUES (7394, 0, 0, 1.39, 61, 437);
INSERT INTO public.europe_data VALUES (7395, 36, 6358, 136.54, 152, 437);
INSERT INTO public.europe_data VALUES (7396, 160, 1144, 23.17, 153, 437);
INSERT INTO public.europe_data VALUES (7397, 0, 0, 0, 62, 437);
INSERT INTO public.europe_data VALUES (7398, 0, 41, -0.91, 3, 437);
INSERT INTO public.europe_data VALUES (7399, 0, 7, 27.2, 63, 437);
INSERT INTO public.europe_data VALUES (7400, 0, 16, 2.88, 108, 437);
INSERT INTO public.europe_data VALUES (7401, 63, 3719, 51.19, 64, 437);
INSERT INTO public.europe_data VALUES (7402, 0, 0, 3.85, 65, 437);
INSERT INTO public.europe_data VALUES (7403, 9, 109, 6.66, 154, 437);
INSERT INTO public.europe_data VALUES (7404, 0, 3, 0.56, 4, 437);
INSERT INTO public.europe_data VALUES (7405, 6648, 151638, 129.72, 66, 437);
INSERT INTO public.europe_data VALUES (7406, 0, 0, 0, 67, 437);
INSERT INTO public.europe_data VALUES (7407, 1, 0, 0, 109, 437);
INSERT INTO public.europe_data VALUES (7408, 10, 80, 3.97, 155, 437);
INSERT INTO public.europe_data VALUES (7409, 1, 49, 0.42, 5, 437);
INSERT INTO public.europe_data VALUES (7410, 0, 21, 0.18, 6, 437);
INSERT INTO public.europe_data VALUES (7411, 0, 1, 0.02, 110, 437);
INSERT INTO public.europe_data VALUES (7412, 26, 1014, 10.09, 7, 437);
INSERT INTO public.europe_data VALUES (7413, 871, 6248, 37.28, 68, 437);
INSERT INTO public.europe_data VALUES (7414, 1, 55, 19.46, 8, 437);
INSERT INTO public.europe_data VALUES (7415, 0, 12, 72.37, 69, 437);
INSERT INTO public.europe_data VALUES (7416, 1, 407, 14.41, 9, 437);
INSERT INTO public.europe_data VALUES (7417, 5, 103, 1.72, 10, 437);
INSERT INTO public.europe_data VALUES (7418, 336, 30586, 294.99, 70, 437);
INSERT INTO public.europe_data VALUES (7419, 0, 52, 0.01, 111, 437);
INSERT INTO public.europe_data VALUES (7420, 212, 8208, 27.43, 71, 437);
INSERT INTO public.europe_data VALUES (7421, 1, 19, 11.16, 11, 437);
INSERT INTO public.europe_data VALUES (7422, 4, 124, 3.7, 12, 437);
INSERT INTO public.europe_data VALUES (7423, 0, 126, 3.82, 72, 437);
INSERT INTO public.europe_data VALUES (7424, 3, 457, 2.82, 13, 437);
INSERT INTO public.europe_data VALUES (7425, 4, 2, 0.49, 156, 437);
INSERT INTO public.europe_data VALUES (7426, 1, 104, 1.53, 73, 437);
INSERT INTO public.europe_data VALUES (7427, 0, 2, 1.84, 74, 437);
INSERT INTO public.europe_data VALUES (7428, 0, 9, 3.2, 157, 437);
INSERT INTO public.europe_data VALUES (7429, 5, 316, 7.49, 158, 437);
INSERT INTO public.europe_data VALUES (7430, 4, 752, 1.84, 14, 437);
INSERT INTO public.europe_data VALUES (7431, 12, 309, 12.78, 159, 437);
INSERT INTO public.europe_data VALUES (7432, 14, 1084, 200.6, 15, 437);
INSERT INTO public.europe_data VALUES (7433, 0, 0, 0, 75, 437);
INSERT INTO public.europe_data VALUES (7434, 44, 2863, 46.29, 76, 437);
INSERT INTO public.europe_data VALUES (7435, 250, 2342, 34.05, 77, 437);
INSERT INTO public.europe_data VALUES (7436, 195, 7720, 12.71, 16, 437);
INSERT INTO public.europe_data VALUES (7437, 11, 602, 18.27, 78, 437);
INSERT INTO public.europe_data VALUES (7438, 0, 263, 52.51, 17, 437);
INSERT INTO public.europe_data VALUES (7439, 0, 0, 0, 18, 437);
INSERT INTO public.europe_data VALUES (7440, 0, 46, 7.17, 160, 437);
INSERT INTO public.europe_data VALUES (7441, 0, 35, 7.14, 19, 437);
INSERT INTO public.europe_data VALUES (7442, 6, 590, 0.76, 20, 437);
INSERT INTO public.europe_data VALUES (7443, 0, 0, 0, 79, 437);
INSERT INTO public.europe_data VALUES (7444, 0, 0, 0, 161, 437);
INSERT INTO public.europe_data VALUES (7445, 0, 0, 0, 203, 437);
INSERT INTO public.europe_data VALUES (7446, 13, 280, 9.28, 162, 437);
INSERT INTO public.europe_data VALUES (7447, 435, 6832, 13.94, 163, 437);
INSERT INTO public.europe_data VALUES (7448, 0, 0, 0, 204, 437);
INSERT INTO public.europe_data VALUES (7449, 5, 721, 61.45, 21, 437);
INSERT INTO public.europe_data VALUES (7450, 0, 0, 0.09, 22, 437);
INSERT INTO public.europe_data VALUES (7451, 0, 53, 2.05, 164, 437);
INSERT INTO public.europe_data VALUES (7452, 254, 3245, 8.57, 165, 437);
INSERT INTO public.europe_data VALUES (7453, 4, 1387, 7.68, 23, 437);
INSERT INTO public.europe_data VALUES (7454, 0, 18, 65.27, 166, 437);
INSERT INTO public.europe_data VALUES (7455, 4, 39, 0.77, 167, 437);
INSERT INTO public.europe_data VALUES (7456, 0, 2, 3.53, 80, 437);
INSERT INTO public.europe_data VALUES (7457, 0, 1, 0.89, 81, 437);
INSERT INTO public.europe_data VALUES (7458, 0, 9, 12.55, 205, 437);
INSERT INTO public.europe_data VALUES (7459, 50, 1663, 18.06, 82, 437);
INSERT INTO public.europe_data VALUES (7460, 0, 0, 0, 168, 437);
INSERT INTO public.europe_data VALUES (7461, 3, 496, 8.71, 24, 437);
INSERT INTO public.europe_data VALUES (7462, 2, 149, 17.28, 25, 437);
INSERT INTO public.europe_data VALUES (7463, 2, 18, 4.6, 83, 437);
INSERT INTO public.europe_data VALUES (7464, 17, 1166, 14.81, 84, 437);
INSERT INTO public.europe_data VALUES (7465, 0, 0, 0, 169, 437);
INSERT INTO public.europe_data VALUES (7466, 32, 1252, 26.23, 85, 437);
INSERT INTO public.europe_data VALUES (7467, 35, 120, 3.49, 170, 437);
INSERT INTO public.europe_data VALUES (7468, 0, 2, 1.12, 171, 437);
INSERT INTO public.europe_data VALUES (7469, 1373, 51690, 6.91, 112, 437);
INSERT INTO public.europe_data VALUES (7470, 241, 4202, 3.31, 113, 437);
INSERT INTO public.europe_data VALUES (7471, 380, 15765, 37.71, 114, 437);
INSERT INTO public.europe_data VALUES (7472, 45, 1970, 7.72, 115, 437);
INSERT INTO public.europe_data VALUES (7473, 44, 351, 17.9, 172, 437);
INSERT INTO public.europe_data VALUES (7474, 0, 0, 1.18, 173, 437);
INSERT INTO public.europe_data VALUES (7475, 5, 351, 5.33, 116, 437);
INSERT INTO public.europe_data VALUES (7476, 630, 3161, 12.56, 174, 437);
INSERT INTO public.europe_data VALUES (7477, 0, 34, 2.24, 86, 437);
INSERT INTO public.europe_data VALUES (7478, 62, 303, 0.46, 117, 437);
INSERT INTO public.europe_data VALUES (7479, 0, 2, 5.57, 175, 437);
INSERT INTO public.europe_data VALUES (7480, 0, 31, 1.25, 118, 437);
INSERT INTO public.europe_data VALUES (7481, 6, 2777, 26.24, 119, 437);
INSERT INTO public.europe_data VALUES (7482, 13, 748, 2.04, 26, 437);
INSERT INTO public.europe_data VALUES (7483, 1, 51, 5.45, 176, 437);
INSERT INTO public.europe_data VALUES (7484, 56, 5741, 289.82, 120, 437);
INSERT INTO public.europe_data VALUES (7485, 0, 384, 9.37, 121, 437);
INSERT INTO public.europe_data VALUES (7486, 0, 0, 0, 122, 437);
INSERT INTO public.europe_data VALUES (7487, 2, 19, 3.02, 177, 437);
INSERT INTO public.europe_data VALUES (7488, 1, 106, 4.51, 123, 437);
INSERT INTO public.europe_data VALUES (7489, 0, 0, 0.05, 27, 437);
INSERT INTO public.europe_data VALUES (7490, 1, 23, 1.26, 28, 437);
INSERT INTO public.europe_data VALUES (7491, 2, 81, 1.34, 29, 437);
INSERT INTO public.europe_data VALUES (7492, 0, 0, 0, 178, 437);
INSERT INTO public.europe_data VALUES (7493, 7, 52, 4.8, 179, 437);
INSERT INTO public.europe_data VALUES (7494, 0, 26, 11.89, 180, 437);
INSERT INTO public.europe_data VALUES (7495, 4, 244, 1.73, 30, 437);
INSERT INTO public.europe_data VALUES (7496, 0, 201, 1.15, 31, 437);
INSERT INTO public.europe_data VALUES (7497, 0, 574, 2.9, 124, 437);
INSERT INTO public.europe_data VALUES (7498, 1, 402, 127.88, 125, 437);
INSERT INTO public.europe_data VALUES (7499, 12, 235, 2.06, 32, 437);
INSERT INTO public.europe_data VALUES (7500, 3, 8, 12.36, 181, 437);
INSERT INTO public.europe_data VALUES (7501, 17, 293, 10.34, 33, 437);
INSERT INTO public.europe_data VALUES (7502, 0, 1, 0.24, 34, 437);
INSERT INTO public.europe_data VALUES (7503, 2536, 26685, 39.34, 87, 437);
INSERT INTO public.europe_data VALUES (7504, 45, 1158, 54.19, 182, 437);
INSERT INTO public.europe_data VALUES (7505, 0, 0, 3.02, 183, 437);
INSERT INTO public.europe_data VALUES (7506, 0, 44, 1.4, 126, 437);
INSERT INTO public.europe_data VALUES (7507, 0, 0, 0, 184, 437);
INSERT INTO public.europe_data VALUES (7508, 0, 0, 0, 88, 437);
INSERT INTO public.europe_data VALUES (7509, 6, 374, 2.57, 35, 437);
INSERT INTO public.europe_data VALUES (7510, 2, 60, 0.39, 36, 437);
INSERT INTO public.europe_data VALUES (7511, 0, 27, 0.08, 127, 437);
INSERT INTO public.europe_data VALUES (7512, 0, 3, 0.32, 37, 437);
INSERT INTO public.europe_data VALUES (7513, 5, 969, 4.43, 128, 437);
INSERT INTO public.europe_data VALUES (7514, 134, 1206, 14.16, 185, 437);
INSERT INTO public.europe_data VALUES (7515, 0, 1, 0.35, 208, 437);
INSERT INTO public.europe_data VALUES (7516, 1, 0, 0.1, 209, 437);
INSERT INTO public.europe_data VALUES (7517, 18, 480, 11.21, 89, 437);
INSERT INTO public.europe_data VALUES (7518, 3, 13, 0.23, 38, 437);
INSERT INTO public.europe_data VALUES (7519, 61, 2323, 2.09, 39, 437);
INSERT INTO public.europe_data VALUES (7520, 20, 248, 20.89, 186, 437);
INSERT INTO public.europe_data VALUES (7521, 0, 0, 1.75, 210, 437);
INSERT INTO public.europe_data VALUES (7522, 1, 102, 4.02, 187, 437);
INSERT INTO public.europe_data VALUES (7523, 10, 3667, 125.65, 129, 437);
INSERT INTO public.europe_data VALUES (7524, 376, 16111, 14.01, 130, 437);
INSERT INTO public.europe_data VALUES (7525, 0, 25, 1.34, 131, 437);
INSERT INTO public.europe_data VALUES (7526, 30, 2537, 90.83, 90, 437);
INSERT INTO public.europe_data VALUES (7527, 0, 0, 0, 211, 437);
INSERT INTO public.europe_data VALUES (7528, 0, 124, 2.84, 91, 437);
INSERT INTO public.europe_data VALUES (7529, 1050, 44517, 222.09, 92, 437);
INSERT INTO public.europe_data VALUES (7530, 89, 4051, 5.15, 132, 437);
INSERT INTO public.europe_data VALUES (7531, 68, 2460, 13.84, 188, 437);
INSERT INTO public.europe_data VALUES (7532, 94, 1877, 33.71, 189, 437);
INSERT INTO public.europe_data VALUES (7533, 9, 587, 38.52, 93, 437);
INSERT INTO public.europe_data VALUES (7534, 15, 13196, 858.24, 133, 437);
INSERT INTO public.europe_data VALUES (7535, 83, 1187, 12.29, 190, 437);
INSERT INTO public.europe_data VALUES (7536, 1152, 61362, 85.07, 191, 437);
INSERT INTO public.europe_data VALUES (7537, 1, 43, 0.62, 40, 437);
INSERT INTO public.europe_data VALUES (7538, 0, 0, 0, 94, 437);
INSERT INTO public.europe_data VALUES (7539, 0, 0, 0, 95, 437);
INSERT INTO public.europe_data VALUES (7540, 0, 8, 8.14, 96, 437);
INSERT INTO public.europe_data VALUES (7541, 0, 6, 49.34, 192, 437);
INSERT INTO public.europe_data VALUES (7542, 3, 184, 115.32, 41, 437);
INSERT INTO public.europe_data VALUES (7543, 113, 12701, 89.03, 134, 437);
INSERT INTO public.europe_data VALUES (7544, 7, 598, 7.15, 42, 437);
INSERT INTO public.europe_data VALUES (7545, 5, 253, 11.52, 193, 437);
INSERT INTO public.europe_data VALUES (7546, 0, 0, 0, 43, 437);
INSERT INTO public.europe_data VALUES (7547, 6, 154, 4.56, 44, 437);
INSERT INTO public.europe_data VALUES (7548, 0, 3268, 117.95, 135, 437);
INSERT INTO public.europe_data VALUES (7549, 0, 0, 0, 97, 437);
INSERT INTO public.europe_data VALUES (7550, 0, 13, 0.51, 194, 437);
INSERT INTO public.europe_data VALUES (7551, 2, 4, 0.34, 195, 437);
INSERT INTO public.europe_data VALUES (7552, 17, 382, 3.59, 45, 437);
INSERT INTO public.europe_data VALUES (7553, 254, 10100, 29.32, 46, 437);
INSERT INTO public.europe_data VALUES (7554, 4, 297, 0.86, 136, 437);
INSERT INTO public.europe_data VALUES (7555, 4, 431, 6.44, 47, 437);
INSERT INTO public.europe_data VALUES (7556, 293, 4238, 17.11, 196, 437);
INSERT INTO public.europe_data VALUES (7557, 1, 492, 3.06, 137, 437);
INSERT INTO public.europe_data VALUES (7558, 140, 1392, 6.39, 48, 437);
INSERT INTO public.europe_data VALUES (7559, 0, 12, 2.24, 98, 437);
INSERT INTO public.europe_data VALUES (7560, 274, 4281, 77.61, 197, 437);
INSERT INTO public.europe_data VALUES (7561, 15, 126, 3.22, 198, 437);
INSERT INTO public.europe_data VALUES (7562, 0, 36, 0.37, 138, 437);
INSERT INTO public.europe_data VALUES (7563, 0, 1, 0.01, 139, 437);
INSERT INTO public.europe_data VALUES (7564, 3, 1069, 24.49, 140, 437);
INSERT INTO public.europe_data VALUES (7565, 0, 39, 0.08, 141, 437);
INSERT INTO public.europe_data VALUES (7566, 0, 0, 0, 142, 437);
INSERT INTO public.europe_data VALUES (7567, 1, 61, 1.74, 49, 437);
INSERT INTO public.europe_data VALUES (7568, 0, 1, 0.07, 99, 437);
INSERT INTO public.europe_data VALUES (7569, 0, 26, 0.34, 50, 437);
INSERT INTO public.europe_data VALUES (7570, 200, 7115, 17.69, 199, 437);
INSERT INTO public.europe_data VALUES (7571, 0, 0, 0, 100, 437);
INSERT INTO public.europe_data VALUES (7572, 0, 246, 0.52, 51, 437);
INSERT INTO public.europe_data VALUES (7573, 91, 2686, 12.23, 200, 437);
INSERT INTO public.europe_data VALUES (7574, 19, 5072, 114.62, 143, 437);
INSERT INTO public.europe_data VALUES (7575, 1488, 10907, 40.91, 201, 437);
INSERT INTO public.europe_data VALUES (7576, 0, 0, 0, 52, 437);
INSERT INTO public.europe_data VALUES (7577, 6663, 146953, 92.21, 101, 437);
INSERT INTO public.europe_data VALUES (7578, 0, 0, 0, 102, 437);
INSERT INTO public.europe_data VALUES (7579, 0, 54, 2.57, 103, 437);
INSERT INTO public.europe_data VALUES (7580, 2, 498, 2.76, 144, 437);
INSERT INTO public.europe_data VALUES (7581, 4, 389, 3.4, 104, 437);
INSERT INTO public.europe_data VALUES (7582, 0, 3, 0.01, 145, 437);
INSERT INTO public.europe_data VALUES (7583, 1, 17, 2.92, 53, 437);
INSERT INTO public.europe_data VALUES (7584, 38, 101, 0.67, 146, 437);
INSERT INTO public.europe_data VALUES (7585, 0, 137, 1.7, 54, 437);
INSERT INTO public.europe_data VALUES (7586, 0, 122, 0.9, 55, 437);
INSERT INTO public.europe_data VALUES (7587, 49, 3918, 16.25, 105, 438);
INSERT INTO public.europe_data VALUES (7588, 1, 52, 4.54, 147, 438);
INSERT INTO public.europe_data VALUES (7589, 52, 1287, 6, 1, 438);
INSERT INTO public.europe_data VALUES (7590, 0, 2, 10.5, 148, 438);
INSERT INTO public.europe_data VALUES (7591, 2, 21, 0.08, 2, 438);
INSERT INTO public.europe_data VALUES (7592, 0, 0, 0, 56, 438);
INSERT INTO public.europe_data VALUES (7593, 0, 0, 0, 57, 438);
INSERT INTO public.europe_data VALUES (7594, 86, 4271, 14.04, 58, 438);
INSERT INTO public.europe_data VALUES (7595, 26, 2290, 125.81, 149, 438);
INSERT INTO public.europe_data VALUES (7596, 0, 0, 0, 59, 438);
INSERT INTO public.europe_data VALUES (7597, 4, 64, 0.67, 202, 438);
INSERT INTO public.europe_data VALUES (7598, 11, 285, 7.36, 150, 438);
INSERT INTO public.europe_data VALUES (7599, 10, 848, 15.95, 151, 438);
INSERT INTO public.europe_data VALUES (7600, 0, 4, 2.05, 60, 438);
INSERT INTO public.europe_data VALUES (7601, 2, 2182, 255.73, 106, 438);
INSERT INTO public.europe_data VALUES (7602, 152, 11342, 11.62, 107, 438);
INSERT INTO public.europe_data VALUES (7603, 0, 4, 2.79, 61, 438);
INSERT INTO public.europe_data VALUES (7604, 34, 6548, 139.91, 152, 438);
INSERT INTO public.europe_data VALUES (7605, 230, 1510, 31.26, 153, 438);
INSERT INTO public.europe_data VALUES (7606, 0, 0, 0, 62, 438);
INSERT INTO public.europe_data VALUES (7607, 1, -148, -1.08, 3, 438);
INSERT INTO public.europe_data VALUES (7608, 0, 10, 24, 63, 438);
INSERT INTO public.europe_data VALUES (7609, 0, 6, 2.36, 108, 438);
INSERT INTO public.europe_data VALUES (7610, 81, 2175, 32.2, 64, 438);
INSERT INTO public.europe_data VALUES (7611, 0, 1, 3.85, 65, 438);
INSERT INTO public.europe_data VALUES (7612, 11, 111, 8.57, 154, 438);
INSERT INTO public.europe_data VALUES (7613, 0, 10, 0.52, 4, 438);
INSERT INTO public.europe_data VALUES (7614, 6548, 122131, 95.01, 66, 438);
INSERT INTO public.europe_data VALUES (7615, 0, 0, 3.33, 67, 438);
INSERT INTO public.europe_data VALUES (7616, 0, 0, 0, 109, 438);
INSERT INTO public.europe_data VALUES (7617, 20, 198, 6.69, 155, 438);
INSERT INTO public.europe_data VALUES (7618, 1, 36, 0.4, 5, 438);
INSERT INTO public.europe_data VALUES (7619, 0, 0, 0.2, 6, 438);
INSERT INTO public.europe_data VALUES (7620, 0, 2, 0.01, 110, 438);
INSERT INTO public.europe_data VALUES (7621, 25, 1598, 8.93, 7, 438);
INSERT INTO public.europe_data VALUES (7622, 642, 7697, 42.34, 68, 438);
INSERT INTO public.europe_data VALUES (7623, 0, 52, 24.37, 8, 438);
INSERT INTO public.europe_data VALUES (7624, 0, 35, 73.91, 69, 438);
INSERT INTO public.europe_data VALUES (7625, 1, 277, 8.96, 9, 438);
INSERT INTO public.europe_data VALUES (7626, 7, 172, 2.21, 10, 438);
INSERT INTO public.europe_data VALUES (7627, 268, 25321, 212.3, 70, 438);
INSERT INTO public.europe_data VALUES (7628, 0, 41, 0.01, 111, 438);
INSERT INTO public.europe_data VALUES (7629, 153, 5601, 20.09, 71, 438);
INSERT INTO public.europe_data VALUES (7630, 0, 76, 8.93, 11, 438);
INSERT INTO public.europe_data VALUES (7631, 1, 75, 3.72, 12, 438);
INSERT INTO public.europe_data VALUES (7632, 0, 67, 2.73, 72, 438);
INSERT INTO public.europe_data VALUES (7633, 3, 267, 2.63, 13, 438);
INSERT INTO public.europe_data VALUES (7634, 4, 18, 1.4, 156, 438);
INSERT INTO public.europe_data VALUES (7635, 3, 69, 1.54, 73, 438);
INSERT INTO public.europe_data VALUES (7636, 0, 1, 0.61, 74, 438);
INSERT INTO public.europe_data VALUES (7637, 0, 19, 4.22, 157, 438);
INSERT INTO public.europe_data VALUES (7638, 18, 482, 7.83, 158, 438);
INSERT INTO public.europe_data VALUES (7639, 7, 843, 1.47, 14, 438);
INSERT INTO public.europe_data VALUES (7640, 15, 433, 16.03, 159, 438);
INSERT INTO public.europe_data VALUES (7641, 6, 869, 108.88, 15, 438);
INSERT INTO public.europe_data VALUES (7642, 0, 0, 0, 75, 438);
INSERT INTO public.europe_data VALUES (7643, 30, 2108, 37.95, 76, 438);
INSERT INTO public.europe_data VALUES (7644, 372, 3574, 41.42, 77, 438);
INSERT INTO public.europe_data VALUES (7645, 134, 5036, 7.83, 16, 438);
INSERT INTO public.europe_data VALUES (7646, 5, 577, 14.83, 78, 438);
INSERT INTO public.europe_data VALUES (7647, 5, 449, 44.54, 17, 438);
INSERT INTO public.europe_data VALUES (7648, 0, 0, 0, 18, 438);
INSERT INTO public.europe_data VALUES (7649, 0, 49, 6.34, 160, 438);
INSERT INTO public.europe_data VALUES (7650, 0, 47, 6.79, 19, 438);
INSERT INTO public.europe_data VALUES (7651, 0, 265, 0.31, 20, 438);
INSERT INTO public.europe_data VALUES (7652, 0, 0, 0, 79, 438);
INSERT INTO public.europe_data VALUES (7653, 0, 0, 0, 161, 438);
INSERT INTO public.europe_data VALUES (7654, 0, 0, 0, 203, 438);
INSERT INTO public.europe_data VALUES (7655, 9, 232, 11.18, 162, 438);
INSERT INTO public.europe_data VALUES (7656, 656, 2510, 8.74, 163, 438);
INSERT INTO public.europe_data VALUES (7657, 0, 0, 0, 204, 438);
INSERT INTO public.europe_data VALUES (7658, 1, 614, 58.59, 21, 438);
INSERT INTO public.europe_data VALUES (7659, 0, 2, 0.21, 22, 438);
INSERT INTO public.europe_data VALUES (7660, 0, 29, 2.38, 164, 438);
INSERT INTO public.europe_data VALUES (7661, 322, 3873, 10.83, 165, 438);
INSERT INTO public.europe_data VALUES (7662, 3, 948, 7.96, 23, 438);
INSERT INTO public.europe_data VALUES (7663, 0, 4, 14.83, 166, 438);
INSERT INTO public.europe_data VALUES (7664, 8, 44, 1.51, 167, 438);
INSERT INTO public.europe_data VALUES (7665, 0, 0, 0, 80, 438);
INSERT INTO public.europe_data VALUES (7666, 0, 0, 0.89, 81, 438);
INSERT INTO public.europe_data VALUES (7667, 0, 12, 8.97, 205, 438);
INSERT INTO public.europe_data VALUES (7668, 23, 1512, 13.49, 82, 438);
INSERT INTO public.europe_data VALUES (7669, 0, 0, 0, 168, 438);
INSERT INTO public.europe_data VALUES (7670, 4, 617, 8.84, 24, 438);
INSERT INTO public.europe_data VALUES (7671, 2, 183, 23.27, 25, 438);
INSERT INTO public.europe_data VALUES (7672, 0, 18, 3.96, 83, 438);
INSERT INTO public.europe_data VALUES (7673, 7, 502, 6.89, 84, 438);
INSERT INTO public.europe_data VALUES (7674, 0, 0, 0, 169, 438);
INSERT INTO public.europe_data VALUES (7675, 38, 1304, 20.3, 85, 438);
INSERT INTO public.europe_data VALUES (7676, 29, 221, 4.83, 170, 438);
INSERT INTO public.europe_data VALUES (7677, 0, 2, 0.84, 171, 438);
INSERT INTO public.europe_data VALUES (7678, 992, 42676, 5.25, 112, 438);
INSERT INTO public.europe_data VALUES (7679, 224, 4757, 3.04, 113, 438);
INSERT INTO public.europe_data VALUES (7680, 429, 15503, 33.89, 114, 438);
INSERT INTO public.europe_data VALUES (7681, 37, 1065, 4.33, 115, 438);
INSERT INTO public.europe_data VALUES (7682, 63, 527, 33.5, 172, 438);
INSERT INTO public.europe_data VALUES (7683, 0, 1, 7.09, 173, 438);
INSERT INTO public.europe_data VALUES (7684, 8, 103, 2.85, 116, 438);
INSERT INTO public.europe_data VALUES (7685, 877, 4423, 17.87, 174, 438);
INSERT INTO public.europe_data VALUES (7686, 0, 32, 1.7, 86, 438);
INSERT INTO public.europe_data VALUES (7687, 81, 276, 0.62, 117, 438);
INSERT INTO public.europe_data VALUES (7688, 2, 4, 11.13, 175, 438);
INSERT INTO public.europe_data VALUES (7689, 0, 95, 1.66, 118, 438);
INSERT INTO public.europe_data VALUES (7690, 1, 2091, 18.35, 119, 438);
INSERT INTO public.europe_data VALUES (7691, 1, 327, 1.03, 26, 438);
INSERT INTO public.europe_data VALUES (7692, 0, 47, 8.23, 176, 438);
INSERT INTO public.europe_data VALUES (7693, 44, 6452, 299.83, 120, 438);
INSERT INTO public.europe_data VALUES (7694, 2, 217, 6.5, 121, 438);
INSERT INTO public.europe_data VALUES (7695, 0, 0, 0, 122, 438);
INSERT INTO public.europe_data VALUES (7696, 3, 39, 5.63, 177, 438);
INSERT INTO public.europe_data VALUES (7697, 0, 203, 3.92, 123, 438);
INSERT INTO public.europe_data VALUES (7698, 0, 1, 0.09, 27, 438);
INSERT INTO public.europe_data VALUES (7699, 5, 39, 1.34, 28, 438);
INSERT INTO public.europe_data VALUES (7700, 0, 10, 0.16, 29, 438);
INSERT INTO public.europe_data VALUES (7701, 0, 0, 0, 178, 438);
INSERT INTO public.europe_data VALUES (7702, 7, 82, 5.15, 179, 438);
INSERT INTO public.europe_data VALUES (7703, 3, 47, 17.27, 180, 438);
INSERT INTO public.europe_data VALUES (7704, 1, 223, 1.32, 30, 438);
INSERT INTO public.europe_data VALUES (7705, 1, 13, 0.14, 31, 438);
INSERT INTO public.europe_data VALUES (7706, 2, 351, 1.84, 124, 438);
INSERT INTO public.europe_data VALUES (7707, 0, 277, 100.95, 125, 438);
INSERT INTO public.europe_data VALUES (7708, 13, 170, 1.66, 32, 438);
INSERT INTO public.europe_data VALUES (7709, 0, 53, 21.88, 181, 438);
INSERT INTO public.europe_data VALUES (7710, 2, 175, 5.06, 33, 438);
INSERT INTO public.europe_data VALUES (7711, 0, 2, 0.16, 34, 438);
INSERT INTO public.europe_data VALUES (7712, 2217, 23497, 33.48, 87, 438);
INSERT INTO public.europe_data VALUES (7713, 39, 1033, 53.57, 182, 438);
INSERT INTO public.europe_data VALUES (7714, 0, 1, 3.02, 183, 438);
INSERT INTO public.europe_data VALUES (7715, 0, 1, 3.07, 126, 438);
INSERT INTO public.europe_data VALUES (7716, 0, 0, 0, 184, 438);
INSERT INTO public.europe_data VALUES (7717, 0, 0, 0, 88, 438);
INSERT INTO public.europe_data VALUES (7718, 7, 563, 3.76, 35, 438);
INSERT INTO public.europe_data VALUES (7719, 0, 57, 0.34, 36, 438);
INSERT INTO public.europe_data VALUES (7720, 0, 14, 0.04, 127, 438);
INSERT INTO public.europe_data VALUES (7721, 0, 5, 0.2, 37, 438);
INSERT INTO public.europe_data VALUES (7722, 1, 299, 1.69, 128, 438);
INSERT INTO public.europe_data VALUES (7723, 142, 1241, 15.1, 185, 438);
INSERT INTO public.europe_data VALUES (7724, 0, 0, 0, 208, 438);
INSERT INTO public.europe_data VALUES (7725, 0, 5, 0.15, 209, 438);
INSERT INTO public.europe_data VALUES (7726, 9, 254, 4.02, 89, 438);
INSERT INTO public.europe_data VALUES (7727, 7, 41, 0.53, 38, 438);
INSERT INTO public.europe_data VALUES (7728, 44, 1880, 1.71, 39, 438);
INSERT INTO public.europe_data VALUES (7729, 12, 186, 16.18, 186, 438);
INSERT INTO public.europe_data VALUES (7730, 0, 1, 10.49, 210, 438);
INSERT INTO public.europe_data VALUES (7731, 3, 112, 3.94, 187, 438);
INSERT INTO public.europe_data VALUES (7732, 15, 2584, 87.86, 129, 438);
INSERT INTO public.europe_data VALUES (7733, 264, 14224, 11.73, 130, 438);
INSERT INTO public.europe_data VALUES (7734, 1, 42, 1.1, 131, 438);
INSERT INTO public.europe_data VALUES (7735, 31, 1320, 58.35, 90, 438);
INSERT INTO public.europe_data VALUES (7736, 0, 0, 0, 211, 438);
INSERT INTO public.europe_data VALUES (7737, 0, 76, 2.12, 91, 438);
INSERT INTO public.europe_data VALUES (7738, 808, 27686, 161.95, 92, 438);
INSERT INTO public.europe_data VALUES (7739, 44, 1522, 3, 132, 438);
INSERT INTO public.europe_data VALUES (7740, 71, 2797, 14.04, 188, 438);
INSERT INTO public.europe_data VALUES (7741, 98, 1587, 29.6, 189, 438);
INSERT INTO public.europe_data VALUES (7742, 4, 543, 33.78, 93, 438);
INSERT INTO public.europe_data VALUES (7743, 8, 11110, 748.36, 133, 438);
INSERT INTO public.europe_data VALUES (7744, 82, 1199, 13.95, 190, 438);
INSERT INTO public.europe_data VALUES (7745, 910, 62729, 92.4, 191, 438);
INSERT INTO public.europe_data VALUES (7746, 0, 35, 0.34, 40, 438);
INSERT INTO public.europe_data VALUES (7747, 0, 0, 0, 94, 438);
INSERT INTO public.europe_data VALUES (7748, 0, 0, 0, 95, 438);
INSERT INTO public.europe_data VALUES (7749, 0, 1, 0.9, 96, 438);
INSERT INTO public.europe_data VALUES (7750, 1, 11, 107.39, 192, 438);
INSERT INTO public.europe_data VALUES (7751, 2, 64, 42.32, 41, 438);
INSERT INTO public.europe_data VALUES (7752, 78, 17808, 97.79, 134, 438);
INSERT INTO public.europe_data VALUES (7753, 9, 567, 8.21, 42, 438);
INSERT INTO public.europe_data VALUES (7754, 8, 549, 15.01, 193, 438);
INSERT INTO public.europe_data VALUES (7755, 0, 0, 0, 43, 438);
INSERT INTO public.europe_data VALUES (7756, 8, 202, 5.12, 44, 438);
INSERT INTO public.europe_data VALUES (7757, 1, 3578, 142.65, 135, 438);
INSERT INTO public.europe_data VALUES (7758, 0, 0, 2.36, 97, 438);
INSERT INTO public.europe_data VALUES (7759, 0, 15, 0.95, 194, 438);
INSERT INTO public.europe_data VALUES (7760, 2, 3, 0.43, 195, 438);
INSERT INTO public.europe_data VALUES (7761, 5, 173, 3.5, 45, 438);
INSERT INTO public.europe_data VALUES (7762, 165, 7068, 21.46, 46, 438);
INSERT INTO public.europe_data VALUES (7763, 4, 141, 0.58, 136, 438);
INSERT INTO public.europe_data VALUES (7764, 2, 281, 3.68, 47, 438);
INSERT INTO public.europe_data VALUES (7765, -875, 3794, 16.26, 196, 438);
INSERT INTO public.europe_data VALUES (7766, 0, 160, 1.3, 137, 438);
INSERT INTO public.europe_data VALUES (7767, 49, 1345, 5.3, 48, 438);
INSERT INTO public.europe_data VALUES (7768, 0, 1, 0.17, 98, 438);
INSERT INTO public.europe_data VALUES (7769, 360, 3659, 73.59, 197, 438);
INSERT INTO public.europe_data VALUES (7770, 39, 149, 5.04, 198, 438);
INSERT INTO public.europe_data VALUES (7771, 1, 28, 0.23, 138, 438);
INSERT INTO public.europe_data VALUES (7772, 0, 1, 0, 139, 438);
INSERT INTO public.europe_data VALUES (7773, 5, 1214, 22.81, 140, 438);
INSERT INTO public.europe_data VALUES (7774, 1, 14, 0.04, 141, 438);
INSERT INTO public.europe_data VALUES (7775, 0, 0, 0, 142, 438);
INSERT INTO public.europe_data VALUES (7776, 1, 80, 2.56, 49, 438);
INSERT INTO public.europe_data VALUES (7777, 0, 0, 0, 99, 438);
INSERT INTO public.europe_data VALUES (7778, 3, 14, 0.16, 50, 438);
INSERT INTO public.europe_data VALUES (7779, 200, 7392, 22.16, 199, 438);
INSERT INTO public.europe_data VALUES (7780, 0, 0, 0, 100, 438);
INSERT INTO public.europe_data VALUES (7781, 0, -15, 0.21, 51, 438);
INSERT INTO public.europe_data VALUES (7782, 103, 2695, 13.08, 200, 438);
INSERT INTO public.europe_data VALUES (7783, 25, 6127, 115.52, 143, 438);
INSERT INTO public.europe_data VALUES (7784, 2137, 16360, 54.34, 201, 438);
INSERT INTO public.europe_data VALUES (7785, 0, 0, 0, 52, 438);
INSERT INTO public.europe_data VALUES (7786, 8158, 156481, 95.25, 101, 438);
INSERT INTO public.europe_data VALUES (7787, 0, 0, 0, 102, 438);
INSERT INTO public.europe_data VALUES (7788, 2, 35, 1.79, 103, 438);
INSERT INTO public.europe_data VALUES (7789, 1, 411, 2.26, 144, 438);
INSERT INTO public.europe_data VALUES (7790, 0, 580, 2.48, 104, 438);
INSERT INTO public.europe_data VALUES (7791, 0, 5, 0.04, 145, 438);
INSERT INTO public.europe_data VALUES (7792, 0, 0, 0, 53, 438);
INSERT INTO public.europe_data VALUES (7793, 22, 94, 0.59, 146, 438);
INSERT INTO public.europe_data VALUES (7794, 0, 167, 3.66, 54, 438);
INSERT INTO public.europe_data VALUES (7795, 0, 10, 0.14, 55, 438);
INSERT INTO public.europe_data VALUES (7796, 49, 2262, 10.41, 105, 439);
INSERT INTO public.europe_data VALUES (7797, 0, 78, 5.28, 147, 439);
INSERT INTO public.europe_data VALUES (7798, 46, 1296, 5.91, 1, 439);
INSERT INTO public.europe_data VALUES (7799, 3, 6, 17.07, 148, 439);
INSERT INTO public.europe_data VALUES (7800, 0, 3, 0.04, 2, 439);
INSERT INTO public.europe_data VALUES (7801, 0, 0, 0, 56, 439);
INSERT INTO public.europe_data VALUES (7802, 0, 0, 0, 57, 439);
INSERT INTO public.europe_data VALUES (7803, 66, 2016, 6.75, 58, 439);
INSERT INTO public.europe_data VALUES (7804, 15, 1431, 78.3, 149, 439);
INSERT INTO public.europe_data VALUES (7805, 0, 0, 0.94, 59, 439);
INSERT INTO public.europe_data VALUES (7806, 1, 104, 0.97, 202, 439);
INSERT INTO public.europe_data VALUES (7807, 11, 367, 6.95, 150, 439);
INSERT INTO public.europe_data VALUES (7808, 7, 755, 13.36, 151, 439);
INSERT INTO public.europe_data VALUES (7809, 0, 4, 3.34, 60, 439);
INSERT INTO public.europe_data VALUES (7810, 4, 2015, 217.71, 106, 439);
INSERT INTO public.europe_data VALUES (7811, 100, 7611, 7.86, 107, 439);
INSERT INTO public.europe_data VALUES (7812, 0, 4, 2.09, 61, 439);
INSERT INTO public.europe_data VALUES (7813, 34, 6677, 136.95, 152, 439);
INSERT INTO public.europe_data VALUES (7814, 314, 2071, 44.71, 153, 439);
INSERT INTO public.europe_data VALUES (7815, 0, 0, 0, 62, 439);
INSERT INTO public.europe_data VALUES (7816, 0, 20, 2.11, 3, 439);
INSERT INTO public.europe_data VALUES (7817, 2, 5, 12.8, 63, 439);
INSERT INTO public.europe_data VALUES (7818, 0, 12, 1.83, 108, 439);
INSERT INTO public.europe_data VALUES (7819, 51, 1532, 21.66, 64, 439);
INSERT INTO public.europe_data VALUES (7820, 0, 0, 0, 65, 439);
INSERT INTO public.europe_data VALUES (7821, 25, 172, 13.09, 154, 439);
INSERT INTO public.europe_data VALUES (7822, 0, 2, 0.09, 4, 439);
INSERT INTO public.europe_data VALUES (7823, 4995, 78381, 66.3, 66, 439);
INSERT INTO public.europe_data VALUES (7824, 0, 1, 6.66, 67, 439);
INSERT INTO public.europe_data VALUES (7825, 0, 0, 0.69, 109, 439);
INSERT INTO public.europe_data VALUES (7826, 19, 270, 8.81, 155, 439);
INSERT INTO public.europe_data VALUES (7827, 2, 45, 0.66, 5, 439);
INSERT INTO public.europe_data VALUES (7828, 0, 23, 0.2, 6, 439);
INSERT INTO public.europe_data VALUES (7829, 0, 0, 0, 110, 439);
INSERT INTO public.europe_data VALUES (7830, 26, 713, 4.7, 7, 439);
INSERT INTO public.europe_data VALUES (7831, 911, 8143, 46.82, 68, 439);
INSERT INTO public.europe_data VALUES (7832, 1, 82, 29.64, 8, 439);
INSERT INTO public.europe_data VALUES (7833, 0, 13, 30.79, 69, 439);
INSERT INTO public.europe_data VALUES (7834, 0, 148, 5.37, 9, 439);
INSERT INTO public.europe_data VALUES (7835, 22, 181, 2.42, 10, 439);
INSERT INTO public.europe_data VALUES (7836, 138, 14915, 127.26, 70, 439);
INSERT INTO public.europe_data VALUES (7837, 1, 44, 0.01, 111, 439);
INSERT INTO public.europe_data VALUES (7838, 111, 4511, 15.71, 71, 439);
INSERT INTO public.europe_data VALUES (7839, 0, 0, 0.94, 11, 439);
INSERT INTO public.europe_data VALUES (7840, 5, 125, 3.4, 12, 439);
INSERT INTO public.europe_data VALUES (7841, 4, 71, 2.46, 72, 439);
INSERT INTO public.europe_data VALUES (7842, 6, 409, 2.76, 13, 439);
INSERT INTO public.europe_data VALUES (7843, 5, 39, 3.19, 156, 439);
INSERT INTO public.europe_data VALUES (7844, 2, 106, 1.97, 73, 439);
INSERT INTO public.europe_data VALUES (7845, 0, 0, 0, 74, 439);
INSERT INTO public.europe_data VALUES (7846, 1, 18, 5.02, 157, 439);
INSERT INTO public.europe_data VALUES (7847, 17, 352, 6.52, 158, 439);
INSERT INTO public.europe_data VALUES (7848, 19, 430, 0.89, 14, 439);
INSERT INTO public.europe_data VALUES (7849, 28, 498, 24.18, 159, 439);
INSERT INTO public.europe_data VALUES (7850, 1, 191, 29.68, 15, 439);
INSERT INTO public.europe_data VALUES (7851, 0, 0, 0, 75, 439);
INSERT INTO public.europe_data VALUES (7852, 40, 1967, 40.6, 76, 439);
INSERT INTO public.europe_data VALUES (7853, 609, 3623, 20.97, 77, 439);
INSERT INTO public.europe_data VALUES (7854, 105, 2829, 5.74, 16, 439);
INSERT INTO public.europe_data VALUES (7855, 13, 380, 12.13, 78, 439);
INSERT INTO public.europe_data VALUES (7856, 3, 155, 20.58, 17, 439);
INSERT INTO public.europe_data VALUES (7857, 0, 0, 0, 18, 439);
INSERT INTO public.europe_data VALUES (7858, 3, 35, 5.59, 160, 439);
INSERT INTO public.europe_data VALUES (7859, 0, 31, 7.93, 19, 439);
INSERT INTO public.europe_data VALUES (7860, 0, 78, 0.16, 20, 439);
INSERT INTO public.europe_data VALUES (7861, 0, 0, 0, 79, 439);
INSERT INTO public.europe_data VALUES (7862, 0, 0, 0, 161, 439);
INSERT INTO public.europe_data VALUES (7863, 0, 0, 0, 203, 439);
INSERT INTO public.europe_data VALUES (7864, 31, 385, 19.81, 162, 439);
INSERT INTO public.europe_data VALUES (7865, 1331, 3348, 16.6, 163, 439);
INSERT INTO public.europe_data VALUES (7866, 0, 0, 0.72, 204, 439);
INSERT INTO public.europe_data VALUES (7867, 3, 659, 45.34, 21, 439);
INSERT INTO public.europe_data VALUES (7868, 0, 3, 0.26, 22, 439);
INSERT INTO public.europe_data VALUES (7869, 2, 66, 2.8, 164, 439);
INSERT INTO public.europe_data VALUES (7870, 518, 5122, 13.88, 165, 439);
INSERT INTO public.europe_data VALUES (7871, 7, 1472, 11.72, 23, 439);
INSERT INTO public.europe_data VALUES (7872, 0, 1, 8.9, 166, 439);
INSERT INTO public.europe_data VALUES (7873, 12, 118, 1.94, 167, 439);
INSERT INTO public.europe_data VALUES (7874, 0, 0, 0, 80, 439);
INSERT INTO public.europe_data VALUES (7875, 0, 1, 0.89, 81, 439);
INSERT INTO public.europe_data VALUES (7876, 0, 3, 2.99, 205, 439);
INSERT INTO public.europe_data VALUES (7877, 9, 860, 6.88, 82, 439);
INSERT INTO public.europe_data VALUES (7878, 0, 0, 0, 168, 439);
INSERT INTO public.europe_data VALUES (7879, 5, 512, 8.39, 24, 439);
INSERT INTO public.europe_data VALUES (7880, 1, 264, 36.34, 25, 439);
INSERT INTO public.europe_data VALUES (7881, 0, 13, 4.47, 83, 439);
INSERT INTO public.europe_data VALUES (7882, 5, 274, 3.29, 84, 439);
INSERT INTO public.europe_data VALUES (7883, 0, 0, 122.7, 169, 439);
INSERT INTO public.europe_data VALUES (7884, 34, 674, 16.32, 85, 439);
INSERT INTO public.europe_data VALUES (7885, 41, 251, 5.12, 170, 439);
INSERT INTO public.europe_data VALUES (7886, 0, 1, 0.84, 171, 439);
INSERT INTO public.europe_data VALUES (7887, 823, 29017, 3.93, 112, 439);
INSERT INTO public.europe_data VALUES (7888, 175, 3482, 2.34, 113, 439);
INSERT INTO public.europe_data VALUES (7889, 348, 12595, 27.47, 114, 439);
INSERT INTO public.europe_data VALUES (7890, 14, 637, 2.82, 115, 439);
INSERT INTO public.europe_data VALUES (7891, 85, 1116, 53.14, 172, 439);
INSERT INTO public.europe_data VALUES (7892, 1, 5, 16.55, 173, 439);
INSERT INTO public.europe_data VALUES (7893, 20, 140, 4.8, 116, 439);
INSERT INTO public.europe_data VALUES (7894, 1348, 6365, 24.38, 174, 439);
INSERT INTO public.europe_data VALUES (7895, 0, 18, 1.73, 86, 439);
INSERT INTO public.europe_data VALUES (7896, 128, 507, 0.98, 117, 439);
INSERT INTO public.europe_data VALUES (7897, 2, 8, 9.28, 175, 439);
INSERT INTO public.europe_data VALUES (7898, 0, 73, 1.5, 118, 439);
INSERT INTO public.europe_data VALUES (7899, 3, 1314, 13.35, 119, 439);
INSERT INTO public.europe_data VALUES (7900, 18, 215, 0.8, 26, 439);
INSERT INTO public.europe_data VALUES (7901, 1, 101, 7.45, 176, 439);
INSERT INTO public.europe_data VALUES (7902, 54, 6162, 234.53, 120, 439);
INSERT INTO public.europe_data VALUES (7903, 2, 200, 6.02, 121, 439);
INSERT INTO public.europe_data VALUES (7904, 0, 0, 0, 122, 439);
INSERT INTO public.europe_data VALUES (7905, 1, 69, 6.72, 177, 439);
INSERT INTO public.europe_data VALUES (7906, 0, 66, 2.54, 123, 439);
INSERT INTO public.europe_data VALUES (7907, 0, 1, 0, 27, 439);
INSERT INTO public.europe_data VALUES (7908, 1, 27, 1.38, 28, 439);
INSERT INTO public.europe_data VALUES (7909, 0, 1, 0.03, 29, 439);
INSERT INTO public.europe_data VALUES (7910, 0, 0, 0, 178, 439);
INSERT INTO public.europe_data VALUES (7911, 6, 62, 4.69, 179, 439);
INSERT INTO public.europe_data VALUES (7912, 6, 59, 19.71, 180, 439);
INSERT INTO public.europe_data VALUES (7913, 1, 133, 0.57, 30, 439);
INSERT INTO public.europe_data VALUES (7914, 0, 14, 0.17, 31, 439);
INSERT INTO public.europe_data VALUES (7915, 5, 238, 1.87, 124, 439);
INSERT INTO public.europe_data VALUES (7916, 1, 259, 106.79, 125, 439);
INSERT INTO public.europe_data VALUES (7917, 14, 156, 1.51, 32, 439);
INSERT INTO public.europe_data VALUES (7918, 1, 55, 15.8, 181, 439);
INSERT INTO public.europe_data VALUES (7919, 3, 54, 1.19, 33, 439);
INSERT INTO public.europe_data VALUES (7920, 0, 0, 0, 34, 439);
INSERT INTO public.europe_data VALUES (7921, 1712, 19213, 26.45, 87, 439);
INSERT INTO public.europe_data VALUES (7922, 42, 1133, 47.96, 182, 439);
INSERT INTO public.europe_data VALUES (7923, 0, 0, 0, 183, 439);
INSERT INTO public.europe_data VALUES (7924, 0, 98, 3.1, 126, 439);
INSERT INTO public.europe_data VALUES (7925, 0, 0, 0.32, 184, 439);
INSERT INTO public.europe_data VALUES (7926, 0, 0, 0, 88, 439);
INSERT INTO public.europe_data VALUES (7927, 4, 807, 5.39, 35, 439);
INSERT INTO public.europe_data VALUES (7928, 0, 46, 0.19, 36, 439);
INSERT INTO public.europe_data VALUES (7929, 0, 7, 0.06, 127, 439);
INSERT INTO public.europe_data VALUES (7930, 0, 0, 0, 37, 439);
INSERT INTO public.europe_data VALUES (7931, 2, 184, 0.8, 128, 439);
INSERT INTO public.europe_data VALUES (7932, 240, 1368, 19.81, 185, 439);
INSERT INTO public.europe_data VALUES (7933, 0, 0, 0, 208, 439);
INSERT INTO public.europe_data VALUES (7934, 0, 2, 0.25, 209, 439);
INSERT INTO public.europe_data VALUES (7935, 3, 9, 0.17, 89, 439);
INSERT INTO public.europe_data VALUES (7936, 8, 83, 0.66, 38, 439);
INSERT INTO public.europe_data VALUES (7937, 39, 1560, 1.69, 39, 439);
INSERT INTO public.europe_data VALUES (7938, 10, 150, 13.53, 186, 439);
INSERT INTO public.europe_data VALUES (7939, 0, 5, 12.23, 210, 439);
INSERT INTO public.europe_data VALUES (7940, 15, 98, 7.28, 187, 439);
INSERT INTO public.europe_data VALUES (7941, 5, 1787, 52.62, 129, 439);
INSERT INTO public.europe_data VALUES (7942, 236, 11184, 10.13, 130, 439);
INSERT INTO public.europe_data VALUES (7943, 0, 13, 0.76, 131, 439);
INSERT INTO public.europe_data VALUES (7944, 31, 1158, 56.73, 90, 439);
INSERT INTO public.europe_data VALUES (7945, 0, 0, 0, 211, 439);
INSERT INTO public.europe_data VALUES (7946, 1, 73, 5.54, 91, 439);
INSERT INTO public.europe_data VALUES (7947, 759, 24966, 142.55, 92, 439);
INSERT INTO public.europe_data VALUES (7948, 105, 1719, 3.04, 132, 439);
INSERT INTO public.europe_data VALUES (7949, 125, 2533, 12.74, 188, 439);
INSERT INTO public.europe_data VALUES (7950, 83, 1455, 34.17, 189, 439);
INSERT INTO public.europe_data VALUES (7951, 12, 448, 28.57, 93, 439);
INSERT INTO public.europe_data VALUES (7952, 1, 10084, 602.14, 133, 439);
INSERT INTO public.europe_data VALUES (7953, 145, 1509, 19.1, 190, 439);
INSERT INTO public.europe_data VALUES (7954, 716, 72064, 100.82, 191, 439);
INSERT INTO public.europe_data VALUES (7955, 0, 8, 0.26, 40, 439);
INSERT INTO public.europe_data VALUES (7956, 0, 0, 0, 94, 439);
INSERT INTO public.europe_data VALUES (7957, 0, 0, 0, 95, 439);
INSERT INTO public.europe_data VALUES (7958, 0, 0, 0, 96, 439);
INSERT INTO public.europe_data VALUES (7959, 0, 26, 208.98, 192, 439);
INSERT INTO public.europe_data VALUES (7960, 2, 27, 100.91, 41, 439);
INSERT INTO public.europe_data VALUES (7961, 66, 15704, 80.95, 134, 439);
INSERT INTO public.europe_data VALUES (7962, 7, 771, 7.96, 42, 439);
INSERT INTO public.europe_data VALUES (7963, 15, 496, 16.46, 193, 439);
INSERT INTO public.europe_data VALUES (7964, 0, 0, 0, 43, 439);
INSERT INTO public.europe_data VALUES (7965, 14, 198, 4.45, 44, 439);
INSERT INTO public.europe_data VALUES (7966, 2, 4702, 169.41, 135, 439);
INSERT INTO public.europe_data VALUES (7967, 0, 1, 2.36, 97, 439);
INSERT INTO public.europe_data VALUES (7968, 2, 37, 1.58, 194, 439);
INSERT INTO public.europe_data VALUES (7969, 2, 6, 1.3, 195, 439);
INSERT INTO public.europe_data VALUES (7970, 5, 367, 4.53, 45, 439);
INSERT INTO public.europe_data VALUES (7971, 70, 5500, 14.91, 46, 439);
INSERT INTO public.europe_data VALUES (7972, 7, 156, 0.52, 136, 439);
INSERT INTO public.europe_data VALUES (7973, 4, 126, 2.13, 47, 439);
INSERT INTO public.europe_data VALUES (7974, 965, 3836, 26.42, 196, 439);
INSERT INTO public.europe_data VALUES (7975, 0, 118, 1.23, 137, 439);
INSERT INTO public.europe_data VALUES (7976, 27, 926, 3.76, 48, 439);
INSERT INTO public.europe_data VALUES (7977, 0, 0, 0, 98, 439);
INSERT INTO public.europe_data VALUES (7978, 380, 3869, 78.42, 197, 439);
INSERT INTO public.europe_data VALUES (7979, 65, 282, 7.98, 198, 439);
INSERT INTO public.europe_data VALUES (7980, 0, 11, 0.08, 138, 439);
INSERT INTO public.europe_data VALUES (7981, 1, 0, 0.02, 139, 439);
INSERT INTO public.europe_data VALUES (7982, 19, 912, 15.53, 140, 439);
INSERT INTO public.europe_data VALUES (7983, 0, 13, 0.08, 141, 439);
INSERT INTO public.europe_data VALUES (7984, 0, 0, 0, 142, 439);
INSERT INTO public.europe_data VALUES (7985, 0, 127, 2.19, 49, 439);
INSERT INTO public.europe_data VALUES (7986, 0, 0, 0, 99, 439);
INSERT INTO public.europe_data VALUES (7987, 0, 5, 0.21, 50, 439);
INSERT INTO public.europe_data VALUES (7988, 354, 10778, 28.52, 199, 439);
INSERT INTO public.europe_data VALUES (7989, 0, 0, 0, 100, 439);
INSERT INTO public.europe_data VALUES (7990, 0, 106, 0.31, 51, 439);
INSERT INTO public.europe_data VALUES (7991, 123, 3059, 14.5, 200, 439);
INSERT INTO public.europe_data VALUES (7992, 22, 5160, 94.11, 143, 439);
INSERT INTO public.europe_data VALUES (7993, 2428, 19857, 64.1, 201, 439);
INSERT INTO public.europe_data VALUES (7994, 0, 0, 0.05, 52, 439);
INSERT INTO public.europe_data VALUES (7995, 10034, 156958, 99.89, 101, 439);
INSERT INTO public.europe_data VALUES (7996, 2, 0, 2.87, 102, 439);
INSERT INTO public.europe_data VALUES (7997, 1, 27, 2.28, 103, 439);
INSERT INTO public.europe_data VALUES (7998, 2, 335, 1.83, 144, 439);
INSERT INTO public.europe_data VALUES (7999, 0, 127, 0.65, 104, 439);
INSERT INTO public.europe_data VALUES (8000, 0, 32, 0.05, 145, 439);
INSERT INTO public.europe_data VALUES (8001, 0, 0, 0, 53, 439);
INSERT INTO public.europe_data VALUES (8002, 12, 77, 0.4, 146, 439);
INSERT INTO public.europe_data VALUES (8003, 0, 486, 3.52, 54, 439);
INSERT INTO public.europe_data VALUES (8004, 0, 10, 0.08, 55, 439);
INSERT INTO public.europe_data VALUES (8005, 35, 1698, 7.55, 105, 440);
INSERT INTO public.europe_data VALUES (8006, 0, 73, 4.96, 147, 440);
INSERT INTO public.europe_data VALUES (8007, 39, 1249, 5.44, 1, 440);
INSERT INTO public.europe_data VALUES (8008, 3, 7, 19.69, 148, 440);
INSERT INTO public.europe_data VALUES (8009, 0, 10, 0.06, 2, 440);
INSERT INTO public.europe_data VALUES (8010, 0, 0, 0, 56, 440);
INSERT INTO public.europe_data VALUES (8011, 0, 0, 1.03, 57, 440);
INSERT INTO public.europe_data VALUES (8012, 54, 1006, 4.49, 58, 440);
INSERT INTO public.europe_data VALUES (8013, 7, 885, 53.55, 149, 440);
INSERT INTO public.europe_data VALUES (8014, 1, 1, 0.94, 59, 440);
INSERT INTO public.europe_data VALUES (8015, 2, 140, 0.9, 202, 440);
INSERT INTO public.europe_data VALUES (8016, 20, 249, 6.75, 150, 440);
INSERT INTO public.europe_data VALUES (8017, 7, 587, 8.7, 151, 440);
INSERT INTO public.europe_data VALUES (8018, 0, 9, 3.08, 60, 440);
INSERT INTO public.europe_data VALUES (8019, 0, 1558, 139.78, 106, 440);
INSERT INTO public.europe_data VALUES (8020, 51, 5202, 5.67, 107, 440);
INSERT INTO public.europe_data VALUES (8021, 0, 2, 1.74, 61, 440);
INSERT INTO public.europe_data VALUES (8022, 32, 6268, 132.35, 152, 440);
INSERT INTO public.europe_data VALUES (8023, 535, 3051, 53.65, 153, 440);
INSERT INTO public.europe_data VALUES (8024, 0, 0, 0, 62, 440);
INSERT INTO public.europe_data VALUES (8025, 0, 229, 2.16, 3, 440);
INSERT INTO public.europe_data VALUES (8026, 0, 3, 14.4, 63, 440);
INSERT INTO public.europe_data VALUES (8027, 0, 2, 0.26, 108, 440);
INSERT INTO public.europe_data VALUES (8028, 42, 962, 13.95, 64, 440);
INSERT INTO public.europe_data VALUES (8029, 0, 0, 0, 65, 440);
INSERT INTO public.europe_data VALUES (8030, 31, 260, 18.21, 154, 440);
INSERT INTO public.europe_data VALUES (8031, 0, 0, 0.04, 4, 440);
INSERT INTO public.europe_data VALUES (8032, 4098, 61552, 47.77, 66, 440);
INSERT INTO public.europe_data VALUES (8033, 0, 1, 3.33, 67, 440);
INSERT INTO public.europe_data VALUES (8034, 0, 3, 0.69, 109, 440);
INSERT INTO public.europe_data VALUES (8035, 18, 347, 9.5, 155, 440);
INSERT INTO public.europe_data VALUES (8036, 4, 89, 0.59, 5, 440);
INSERT INTO public.europe_data VALUES (8037, 0, 0, 0.03, 6, 440);
INSERT INTO public.europe_data VALUES (8038, 0, 0, 0, 110, 440);
INSERT INTO public.europe_data VALUES (8039, 50, 502, 3.7, 7, 440);
INSERT INTO public.europe_data VALUES (8040, 1189, 9374, 58.71, 68, 440);
INSERT INTO public.europe_data VALUES (8041, 0, 81, 25.46, 8, 440);
INSERT INTO public.europe_data VALUES (8042, 0, 7, 16.94, 69, 440);
INSERT INTO public.europe_data VALUES (8043, 0, 107, 3.37, 9, 440);
INSERT INTO public.europe_data VALUES (8044, 21, 205, 1.73, 10, 440);
INSERT INTO public.europe_data VALUES (8045, 52, 9203, 81.97, 70, 440);
INSERT INTO public.europe_data VALUES (8046, 0, 46, 0.01, 111, 440);
INSERT INTO public.europe_data VALUES (8047, 123, 3395, 11.29, 71, 440);
INSERT INTO public.europe_data VALUES (8048, 1, 8, 1.29, 11, 440);
INSERT INTO public.europe_data VALUES (8049, 0, 58, 1.62, 12, 440);
INSERT INTO public.europe_data VALUES (8050, 0, 53, 1.92, 72, 440);
INSERT INTO public.europe_data VALUES (8051, 4, 302, 2.14, 13, 440);
INSERT INTO public.europe_data VALUES (8052, 11, 91, 3.85, 156, 440);
INSERT INTO public.europe_data VALUES (8053, 10, 117, 3.5, 73, 440);
INSERT INTO public.europe_data VALUES (8054, 0, 0, 0, 74, 440);
INSERT INTO public.europe_data VALUES (8055, 1, 26, 9.25, 157, 440);
INSERT INTO public.europe_data VALUES (8056, 32, 342, 6.75, 158, 440);
INSERT INTO public.europe_data VALUES (8057, 7, 340, 0.65, 14, 440);
INSERT INTO public.europe_data VALUES (8058, 38, 906, 31.93, 159, 440);
INSERT INTO public.europe_data VALUES (8059, 1, 98, 19.21, 15, 440);
INSERT INTO public.europe_data VALUES (8060, 0, 0, 0, 75, 440);
INSERT INTO public.europe_data VALUES (8061, 55, 2393, 39.22, 76, 440);
INSERT INTO public.europe_data VALUES (8062, 563, 21, 39.37, 77, 440);
INSERT INTO public.europe_data VALUES (8063, 96, 2935, 5.06, 16, 440);
INSERT INTO public.europe_data VALUES (8064, 5, 403, 10.23, 78, 440);
INSERT INTO public.europe_data VALUES (8065, 3, 124, 13.35, 17, 440);
INSERT INTO public.europe_data VALUES (8066, 0, 0, 0, 18, 440);
INSERT INTO public.europe_data VALUES (8067, 5, 39, 7.25, 160, 440);
INSERT INTO public.europe_data VALUES (8068, 1, 60, 9.84, 19, 440);
INSERT INTO public.europe_data VALUES (8069, 2, 104, 0.1, 20, 440);
INSERT INTO public.europe_data VALUES (8070, 0, 0, 0, 79, 440);
INSERT INTO public.europe_data VALUES (8071, 0, 0, 0, 161, 440);
INSERT INTO public.europe_data VALUES (8072, 0, 0, 0, 203, 440);
INSERT INTO public.europe_data VALUES (8073, 37, 708, 25.12, 162, 440);
INSERT INTO public.europe_data VALUES (8074, 1485, 7776, 21.62, 163, 440);
INSERT INTO public.europe_data VALUES (8075, 0, 2, 1.07, 204, 440);
INSERT INTO public.europe_data VALUES (8076, 3, 326, 22.32, 21, 440);
INSERT INTO public.europe_data VALUES (8077, 0, 3, 0.43, 22, 440);
INSERT INTO public.europe_data VALUES (8078, 1, 46, 3.73, 164, 440);
INSERT INTO public.europe_data VALUES (8079, 725, 6400, 17.32, 165, 440);
INSERT INTO public.europe_data VALUES (8080, 4, 2094, 8.92, 23, 440);
INSERT INTO public.europe_data VALUES (8081, 0, 2, 14.83, 166, 440);
INSERT INTO public.europe_data VALUES (8082, 7, 90, 1.96, 167, 440);
INSERT INTO public.europe_data VALUES (8083, 0, 0, 0, 80, 440);
INSERT INTO public.europe_data VALUES (8084, 0, 0, 2.68, 81, 440);
INSERT INTO public.europe_data VALUES (8085, 0, 2, 5.38, 205, 440);
INSERT INTO public.europe_data VALUES (8086, 9, 349, 3.14, 82, 440);
INSERT INTO public.europe_data VALUES (8087, 0, 0, 7.76, 168, 440);
INSERT INTO public.europe_data VALUES (8088, 4, 560, 8.24, 24, 440);
INSERT INTO public.europe_data VALUES (8089, 1, 434, 35.04, 25, 440);
INSERT INTO public.europe_data VALUES (8090, 1, 22, 3.83, 83, 440);
INSERT INTO public.europe_data VALUES (8091, 7, 97, 0.98, 84, 440);
INSERT INTO public.europe_data VALUES (8092, 0, 1, 368.1, 169, 440);
INSERT INTO public.europe_data VALUES (8093, 26, 917, 13.45, 85, 440);
INSERT INTO public.europe_data VALUES (8094, 70, 249, 7.17, 170, 440);
INSERT INTO public.europe_data VALUES (8095, 0, 2, 2.52, 171, 440);
INSERT INTO public.europe_data VALUES (8096, 833, 24619, 2.87, 112, 440);
INSERT INTO public.europe_data VALUES (8097, 128, 2840, 1.9, 113, 440);
INSERT INTO public.europe_data VALUES (8098, 437, 10179, 20.65, 114, 440);
INSERT INTO public.europe_data VALUES (8099, 12, 471, 2.41, 115, 440);
INSERT INTO public.europe_data VALUES (8100, 155, 1490, 76.14, 172, 440);
INSERT INTO public.europe_data VALUES (8101, 1, 9, 26.01, 173, 440);
INSERT INTO public.europe_data VALUES (8102, 20, 269, 12.67, 116, 440);
INSERT INTO public.europe_data VALUES (8103, 1676, 8353, 35.45, 174, 440);
INSERT INTO public.europe_data VALUES (8104, 0, 33, 5.16, 86, 440);
INSERT INTO public.europe_data VALUES (8105, 111, 741, 1.9, 117, 440);
INSERT INTO public.europe_data VALUES (8106, 1, 2, 12.06, 175, 440);
INSERT INTO public.europe_data VALUES (8107, 0, 79, 0.92, 118, 440);
INSERT INTO public.europe_data VALUES (8108, 4, 1162, 12.99, 119, 440);
INSERT INTO public.europe_data VALUES (8109, 8, 207, 0.6, 26, 440);
INSERT INTO public.europe_data VALUES (8110, 3, 33, 6.67, 176, 440);
INSERT INTO public.europe_data VALUES (8111, 20, 3705, 133.42, 120, 440);
INSERT INTO public.europe_data VALUES (8112, 2, 186, 5, 121, 440);
INSERT INTO public.europe_data VALUES (8113, 0, 0, 0, 122, 440);
INSERT INTO public.europe_data VALUES (8114, 2, 60, 6.61, 177, 440);
INSERT INTO public.europe_data VALUES (8115, 1, 108, 2.01, 123, 440);
INSERT INTO public.europe_data VALUES (8116, 2, 41, 1.52, 28, 440);
INSERT INTO public.europe_data VALUES (8117, 0, 1, 0.04, 29, 440);
INSERT INTO public.europe_data VALUES (8118, 0, 0, 0, 178, 440);
INSERT INTO public.europe_data VALUES (8119, 4, 69, 1.47, 179, 440);
INSERT INTO public.europe_data VALUES (8120, 5, 62, 26.55, 180, 440);
INSERT INTO public.europe_data VALUES (8121, 0, 22, 0.17, 30, 440);
INSERT INTO public.europe_data VALUES (8122, 0, 17, 0.12, 31, 440);
INSERT INTO public.europe_data VALUES (8123, 3, 358, 2.74, 124, 440);
INSERT INTO public.europe_data VALUES (8124, 2, 308, 116.96, 125, 440);
INSERT INTO public.europe_data VALUES (8125, 11, 141, 1.6, 32, 440);
INSERT INTO public.europe_data VALUES (8126, 1, 23, 10.74, 181, 440);
INSERT INTO public.europe_data VALUES (8127, 0, 0, 0.02, 33, 440);
INSERT INTO public.europe_data VALUES (8128, 0, 0, 0, 34, 440);
INSERT INTO public.europe_data VALUES (8129, 1311, 14536, 20.09, 87, 440);
INSERT INTO public.europe_data VALUES (8130, 44, 806, 37.57, 182, 440);
INSERT INTO public.europe_data VALUES (8131, 0, 0, 3.02, 183, 440);
INSERT INTO public.europe_data VALUES (8132, 0, 2, 0.12, 126, 440);
INSERT INTO public.europe_data VALUES (8133, 1, 2, 0.48, 184, 440);
INSERT INTO public.europe_data VALUES (8134, 0, 0, 0, 88, 440);
INSERT INTO public.europe_data VALUES (8135, 14, 1160, 5.48, 35, 440);
INSERT INTO public.europe_data VALUES (8136, 0, 11, 0.05, 36, 440);
INSERT INTO public.europe_data VALUES (8137, 0, 25, 0.06, 127, 440);
INSERT INTO public.europe_data VALUES (8138, 0, 0, 0, 37, 440);
INSERT INTO public.europe_data VALUES (8139, 0, 45, 0.24, 128, 440);
INSERT INTO public.europe_data VALUES (8140, 384, 2056, 27.67, 185, 440);
INSERT INTO public.europe_data VALUES (8141, 0, 0, 0, 208, 440);
INSERT INTO public.europe_data VALUES (8142, 1, 10, 0.52, 209, 440);
INSERT INTO public.europe_data VALUES (8143, 0, 2, 0.05, 89, 440);
INSERT INTO public.europe_data VALUES (8144, 10, 71, 0.54, 38, 440);
INSERT INTO public.europe_data VALUES (8145, 56, 1841, 1.56, 39, 440);
INSERT INTO public.europe_data VALUES (8146, 7, 131, 12.32, 186, 440);
INSERT INTO public.europe_data VALUES (8147, 0, 2, 3.5, 210, 440);
INSERT INTO public.europe_data VALUES (8148, 9, 290, 11.15, 187, 440);
INSERT INTO public.europe_data VALUES (8149, 5, 831, 28.16, 129, 440);
INSERT INTO public.europe_data VALUES (8150, 205, 10755, 8.13, 130, 440);
INSERT INTO public.europe_data VALUES (8151, 0, 25, 1.04, 131, 440);
INSERT INTO public.europe_data VALUES (8152, 44, 1251, 62.85, 90, 440);
INSERT INTO public.europe_data VALUES (8153, 0, 0, 0, 211, 440);
INSERT INTO public.europe_data VALUES (8154, 0, 317, 6.88, 91, 440);
INSERT INTO public.europe_data VALUES (8155, 603, 21379, 122.39, 92, 440);
INSERT INTO public.europe_data VALUES (8156, 112, 1571, 2.97, 132, 440);
INSERT INTO public.europe_data VALUES (8157, 122, 2303, 11.53, 188, 440);
INSERT INTO public.europe_data VALUES (8158, 72, 2057, 36.34, 189, 440);
INSERT INTO public.europe_data VALUES (8159, 14, 390, 28.19, 93, 440);
INSERT INTO public.europe_data VALUES (8160, 2, 6969, 431.95, 133, 440);
INSERT INTO public.europe_data VALUES (8161, 172, 2199, 22.28, 190, 440);
INSERT INTO public.europe_data VALUES (8162, 635, 75001, 88.25, 191, 440);
INSERT INTO public.europe_data VALUES (8163, 0, 25, 0.74, 40, 440);
INSERT INTO public.europe_data VALUES (8164, 0, 0, 0, 94, 440);
INSERT INTO public.europe_data VALUES (8165, 0, 0, 1.64, 95, 440);
INSERT INTO public.europe_data VALUES (8166, 0, 0, 2.71, 96, 440);
INSERT INTO public.europe_data VALUES (8167, 0, 46, 261.23, 192, 440);
INSERT INTO public.europe_data VALUES (8168, 4, 190, 93, 41, 440);
INSERT INTO public.europe_data VALUES (8169, 62, 12037, 62.82, 134, 440);
INSERT INTO public.europe_data VALUES (8170, 10, 527, 6.37, 42, 440);
INSERT INTO public.europe_data VALUES (8171, 22, 650, 29.75, 193, 440);
INSERT INTO public.europe_data VALUES (8172, 0, 0, 0, 43, 440);
INSERT INTO public.europe_data VALUES (8173, 10, 150, 2.74, 44, 440);
INSERT INTO public.europe_data VALUES (8174, 2, 5131, 167.32, 135, 440);
INSERT INTO public.europe_data VALUES (8175, 2, 0, 4.72, 97, 440);
INSERT INTO public.europe_data VALUES (8176, 2, 49, 1.43, 194, 440);
INSERT INTO public.europe_data VALUES (8177, 6, 21, 2.55, 195, 440);
INSERT INTO public.europe_data VALUES (8178, 19, 332, 4, 45, 440);
INSERT INTO public.europe_data VALUES (8179, 63, 3232, 9.34, 46, 440);
INSERT INTO public.europe_data VALUES (8180, 4, 108, 0.33, 136, 440);
INSERT INTO public.europe_data VALUES (8181, 0, 110, 1.36, 47, 440);
INSERT INTO public.europe_data VALUES (8182, 1316, 8565, 34.51, 196, 440);
INSERT INTO public.europe_data VALUES (8183, 2, 145, 1.59, 137, 440);
INSERT INTO public.europe_data VALUES (8184, 29, 685, 2.63, 48, 440);
INSERT INTO public.europe_data VALUES (8185, 0, 0, 0, 98, 440);
INSERT INTO public.europe_data VALUES (8186, 510, 4153, 78.05, 197, 440);
INSERT INTO public.europe_data VALUES (8187, 65, 400, 14.56, 198, 440);
INSERT INTO public.europe_data VALUES (8188, 0, 3, 0.02, 138, 440);
INSERT INTO public.europe_data VALUES (8189, 0, 4, 0.05, 139, 440);
INSERT INTO public.europe_data VALUES (8190, 18, 536, 6.57, 140, 440);
INSERT INTO public.europe_data VALUES (8191, 2, 46, 0.13, 141, 440);
INSERT INTO public.europe_data VALUES (8192, 0, 0, 0, 142, 440);
INSERT INTO public.europe_data VALUES (8193, 2, 50, 0.94, 49, 440);
INSERT INTO public.europe_data VALUES (8194, 0, 0, 0, 99, 440);
INSERT INTO public.europe_data VALUES (8195, 3, 19, 0.71, 50, 440);
INSERT INTO public.europe_data VALUES (8196, 389, 12612, 34.79, 199, 440);
INSERT INTO public.europe_data VALUES (8197, 0, 0, 2.62, 100, 440);
INSERT INTO public.europe_data VALUES (8198, 0, 32, 0.09, 51, 440);
INSERT INTO public.europe_data VALUES (8199, 103, 3319, 15.04, 200, 440);
INSERT INTO public.europe_data VALUES (8200, 72, 4035, 80.33, 143, 440);
INSERT INTO public.europe_data VALUES (8201, 3174, 22867, 81.25, 201, 440);
INSERT INTO public.europe_data VALUES (8202, 5, 29, 0.36, 52, 440);
INSERT INTO public.europe_data VALUES (8203, 11846, 171758, 110.58, 101, 440);
INSERT INTO public.europe_data VALUES (8204, 0, 3, 13.39, 102, 440);
INSERT INTO public.europe_data VALUES (8205, 2, 52, 2.92, 103, 440);
INSERT INTO public.europe_data VALUES (8206, 0, 269, 1.61, 144, 440);
INSERT INTO public.europe_data VALUES (8207, 0, 57, 0.31, 104, 440);
INSERT INTO public.europe_data VALUES (8208, 0, 17, 0.02, 145, 440);
INSERT INTO public.europe_data VALUES (8209, 0, 0, 0, 53, 440);
INSERT INTO public.europe_data VALUES (8210, 6, 41, 0.17, 146, 440);
INSERT INTO public.europe_data VALUES (8211, 4, 143, 1, 54, 440);
INSERT INTO public.europe_data VALUES (8212, 0, 2, 0.03, 55, 440);
INSERT INTO public.europe_data VALUES (8213, 28, 1173, 4.49, 105, 441);
INSERT INTO public.europe_data VALUES (8214, 3, 69, 8.14, 147, 441);
INSERT INTO public.europe_data VALUES (8215, 38, 1092, 4.29, 1, 441);
INSERT INTO public.europe_data VALUES (8216, 5, 8, 45.95, 148, 441);
INSERT INTO public.europe_data VALUES (8217, 0, 9, 0.03, 2, 441);
INSERT INTO public.europe_data VALUES (8218, 0, 0, 0, 56, 441);
INSERT INTO public.europe_data VALUES (8219, 0, 1, 2.06, 57, 441);
INSERT INTO public.europe_data VALUES (8220, 60, 1003, 4.11, 58, 441);
INSERT INTO public.europe_data VALUES (8221, 10, 699, 39.49, 149, 441);
INSERT INTO public.europe_data VALUES (8222, 0, 0, 2.82, 59, 441);
INSERT INTO public.europe_data VALUES (8223, 12, 88, 0.75, 202, 441);
INSERT INTO public.europe_data VALUES (8224, 56, 349, 9.35, 150, 441);
INSERT INTO public.europe_data VALUES (8225, 4, 287, 5.31, 151, 441);
INSERT INTO public.europe_data VALUES (8226, 0, 3, 5.91, 60, 441);
INSERT INTO public.europe_data VALUES (8227, 0, 736, 92.01, 106, 441);
INSERT INTO public.europe_data VALUES (8228, 32, 4039, 4.29, 107, 441);
INSERT INTO public.europe_data VALUES (8229, 1, 3, 2.44, 61, 441);
INSERT INTO public.europe_data VALUES (8230, 27, 6242, 115.29, 152, 441);
INSERT INTO public.europe_data VALUES (8231, 698, 3095, 76.8, 153, 441);
INSERT INTO public.europe_data VALUES (8232, 0, 0, 0, 62, 441);
INSERT INTO public.europe_data VALUES (8233, 1, 26, 0.45, 3, 441);
INSERT INTO public.europe_data VALUES (8234, 2, 6, 46.39, 63, 441);
INSERT INTO public.europe_data VALUES (8235, 0, 0, 0.26, 108, 441);
INSERT INTO public.europe_data VALUES (8236, 26, 644, 8.95, 64, 441);
INSERT INTO public.europe_data VALUES (8237, 0, 0, 3.85, 65, 441);
INSERT INTO public.europe_data VALUES (8238, 18, 341, 17.81, 154, 441);
INSERT INTO public.europe_data VALUES (8239, 0, 1, 0.13, 4, 441);
INSERT INTO public.europe_data VALUES (8240, 2820, 39259, 29.61, 66, 441);
INSERT INTO public.europe_data VALUES (8241, 0, 0, 6.66, 67, 441);
INSERT INTO public.europe_data VALUES (8242, 0, 0, 0, 109, 441);
INSERT INTO public.europe_data VALUES (8243, 17, 318, 10.04, 155, 441);
INSERT INTO public.europe_data VALUES (8244, 3, 30, 0.42, 5, 441);
INSERT INTO public.europe_data VALUES (8245, 0, 4, 0.11, 6, 441);
INSERT INTO public.europe_data VALUES (8246, 0, 0, 0, 110, 441);
INSERT INTO public.europe_data VALUES (8247, 8, 456, 4.1, 7, 441);
INSERT INTO public.europe_data VALUES (8248, 1122, 12590, 66.02, 68, 441);
INSERT INTO public.europe_data VALUES (8249, 1, 59, 18.91, 8, 441);
INSERT INTO public.europe_data VALUES (8250, 0, 4, 20.02, 69, 441);
INSERT INTO public.europe_data VALUES (8251, 0, 53, 1.26, 9, 441);
INSERT INTO public.europe_data VALUES (8252, 10, 71, 0.53, 10, 441);
INSERT INTO public.europe_data VALUES (8253, 71, 6332, 50.52, 70, 441);
INSERT INTO public.europe_data VALUES (8254, 0, 52, 0.01, 111, 441);
INSERT INTO public.europe_data VALUES (8255, 97, 2289, 7.7, 71, 441);
INSERT INTO public.europe_data VALUES (8256, 0, 3, 0, 11, 441);
INSERT INTO public.europe_data VALUES (8257, 2, 29, 1.28, 12, 441);
INSERT INTO public.europe_data VALUES (8258, 0, 44, 1.57, 72, 441);
INSERT INTO public.europe_data VALUES (8259, 3, 248, 2.14, 13, 441);
INSERT INTO public.europe_data VALUES (8260, 24, 66, 5.52, 156, 441);
INSERT INTO public.europe_data VALUES (8261, 13, 280, 5.42, 73, 441);
INSERT INTO public.europe_data VALUES (8262, 0, 0, 1.22, 74, 441);
INSERT INTO public.europe_data VALUES (8263, 1, 55, 11.99, 157, 441);
INSERT INTO public.europe_data VALUES (8264, 27, 377, 9.33, 158, 441);
INSERT INTO public.europe_data VALUES (8265, 6, 225, 0.41, 14, 441);
INSERT INTO public.europe_data VALUES (8266, 59, 948, 36.84, 159, 441);
INSERT INTO public.europe_data VALUES (8267, 0, 89, 27.32, 15, 441);
INSERT INTO public.europe_data VALUES (8268, 0, 0, 0, 75, 441);
INSERT INTO public.europe_data VALUES (8269, 55, 1819, 30.49, 76, 441);
INSERT INTO public.europe_data VALUES (8270, 988, 6819, 115.52, 77, 441);
INSERT INTO public.europe_data VALUES (8271, 122, 2146, 3.31, 16, 441);
INSERT INTO public.europe_data VALUES (8272, 4, 257, 5.49, 78, 441);
INSERT INTO public.europe_data VALUES (8273, 0, 57, 17.4, 17, 441);
INSERT INTO public.europe_data VALUES (8274, 0, 0, 0, 18, 441);
INSERT INTO public.europe_data VALUES (8275, 6, 57, 12.98, 160, 441);
INSERT INTO public.europe_data VALUES (8276, 0, 53, 7.84, 19, 441);
INSERT INTO public.europe_data VALUES (8277, 0, 12, 0.02, 20, 441);
INSERT INTO public.europe_data VALUES (8278, 0, 0, 59.31, 79, 441);
INSERT INTO public.europe_data VALUES (8279, 0, 0, 4.11, 161, 441);
INSERT INTO public.europe_data VALUES (8280, 0, 0, 0.11, 203, 441);
INSERT INTO public.europe_data VALUES (8281, 40, 678, 26.66, 162, 441);
INSERT INTO public.europe_data VALUES (8282, 2039, 6712, 27.88, 163, 441);
INSERT INTO public.europe_data VALUES (8283, 0, 1, 1.07, 204, 441);
INSERT INTO public.europe_data VALUES (8284, 2, 159, 10.4, 21, 441);
INSERT INTO public.europe_data VALUES (8285, 0, 7, 0.3, 22, 441);
INSERT INTO public.europe_data VALUES (8286, 3, 103, 4.88, 164, 441);
INSERT INTO public.europe_data VALUES (8287, 942, 7982, 25.9, 165, 441);
INSERT INTO public.europe_data VALUES (8288, 7, 619, 3.71, 23, 441);
INSERT INTO public.europe_data VALUES (8289, 0, 3, 32.64, 166, 441);
INSERT INTO public.europe_data VALUES (8290, 14, 120, 3.65, 167, 441);
INSERT INTO public.europe_data VALUES (8291, 0, 0, 0, 80, 441);
INSERT INTO public.europe_data VALUES (8292, 0, 3, 6.25, 81, 441);
INSERT INTO public.europe_data VALUES (8293, 0, 7, 7.77, 205, 441);
INSERT INTO public.europe_data VALUES (8294, 2, 203, 2.35, 82, 441);
INSERT INTO public.europe_data VALUES (8295, 0, 5, 20.17, 168, 441);
INSERT INTO public.europe_data VALUES (8296, 0, 492, 7.88, 24, 441);
INSERT INTO public.europe_data VALUES (8297, 1, 239, 12.6, 25, 441);
INSERT INTO public.europe_data VALUES (8298, 1, 8, 2.17, 83, 441);
INSERT INTO public.europe_data VALUES (8299, 2, 13, 0.34, 84, 441);
INSERT INTO public.europe_data VALUES (8300, 0, 2, 368.1, 169, 441);
INSERT INTO public.europe_data VALUES (8301, 21, 394, 5.93, 85, 441);
INSERT INTO public.europe_data VALUES (8302, 71, 452, 10.75, 170, 441);
INSERT INTO public.europe_data VALUES (8303, 0, 7, 7.84, 171, 441);
INSERT INTO public.europe_data VALUES (8304, 501, 14641, 1.85, 112, 441);
INSERT INTO public.europe_data VALUES (8305, 102, 2310, 1.71, 113, 441);
INSERT INTO public.europe_data VALUES (8306, 493, 6943, 18.35, 114, 441);
INSERT INTO public.europe_data VALUES (8307, 10, 476, 1.93, 115, 441);
INSERT INTO public.europe_data VALUES (8308, 216, 2244, 127.54, 172, 441);
INSERT INTO public.europe_data VALUES (8309, 4, 13, 27.19, 173, 441);
INSERT INTO public.europe_data VALUES (8310, 33, 810, 31.89, 116, 441);
INSERT INTO public.europe_data VALUES (8311, 2240, 13042, 52.59, 174, 441);
INSERT INTO public.europe_data VALUES (8312, 2, 119, 9.26, 86, 441);
INSERT INTO public.europe_data VALUES (8313, 159, 1672, 3.39, 117, 441);
INSERT INTO public.europe_data VALUES (8314, 5, 11, 39.89, 175, 441);
INSERT INTO public.europe_data VALUES (8315, 2, 14, 0.44, 118, 441);
INSERT INTO public.europe_data VALUES (8316, 2, 1247, 12.02, 119, 441);
INSERT INTO public.europe_data VALUES (8317, 10, 110, 0.37, 26, 441);
INSERT INTO public.europe_data VALUES (8318, 5, 87, 16.12, 176, 441);
INSERT INTO public.europe_data VALUES (8319, 18, 1908, 72.92, 120, 441);
INSERT INTO public.europe_data VALUES (8320, 2, 135, 4.08, 121, 441);
INSERT INTO public.europe_data VALUES (8321, 0, 0, 0, 122, 441);
INSERT INTO public.europe_data VALUES (8322, 4, 67, 7.92, 177, 441);
INSERT INTO public.europe_data VALUES (8323, 1, 30, 0.93, 123, 441);
INSERT INTO public.europe_data VALUES (8324, 6, 34, 1.36, 28, 441);
INSERT INTO public.europe_data VALUES (8325, 1, 2, 0.21, 29, 441);
INSERT INTO public.europe_data VALUES (8326, 0, 0, 2.61, 178, 441);
INSERT INTO public.europe_data VALUES (8327, 5, -28, 3.01, 179, 441);
INSERT INTO public.europe_data VALUES (8328, 8, 101, 44.63, 180, 441);
INSERT INTO public.europe_data VALUES (8329, 0, 25, 0.1, 30, 441);
INSERT INTO public.europe_data VALUES (8330, 0, 5, 0.12, 31, 441);
INSERT INTO public.europe_data VALUES (8331, 7, 518, 2.85, 124, 441);
INSERT INTO public.europe_data VALUES (8332, 1, 313, 89.46, 125, 441);
INSERT INTO public.europe_data VALUES (8333, 4, 174, 1.72, 32, 441);
INSERT INTO public.europe_data VALUES (8334, 0, 30, 9.73, 181, 441);
INSERT INTO public.europe_data VALUES (8335, 0, 1, 0.02, 33, 441);
INSERT INTO public.europe_data VALUES (8336, 1, 0, 0.32, 34, 441);
INSERT INTO public.europe_data VALUES (8337, 803, 11094, 15.86, 87, 441);
INSERT INTO public.europe_data VALUES (8338, 29, 713, 40.78, 182, 441);
INSERT INTO public.europe_data VALUES (8339, 0, 1, 3.02, 183, 441);
INSERT INTO public.europe_data VALUES (8340, 0, 2, 0.25, 126, 441);
INSERT INTO public.europe_data VALUES (8341, 1, 1, 2.25, 184, 441);
INSERT INTO public.europe_data VALUES (8342, 0, 0, 0, 88, 441);
INSERT INTO public.europe_data VALUES (8343, 13, 838, 5.62, 35, 441);
INSERT INTO public.europe_data VALUES (8344, 0, 4, 0.14, 36, 441);
INSERT INTO public.europe_data VALUES (8345, 1, 9, 0.08, 127, 441);
INSERT INTO public.europe_data VALUES (8346, 0, 0, 0, 37, 441);
INSERT INTO public.europe_data VALUES (8347, 0, 23, 0.15, 128, 441);
INSERT INTO public.europe_data VALUES (8348, 581, 2726, 45.8, 185, 441);
INSERT INTO public.europe_data VALUES (8349, 0, 0, 0, 208, 441);
INSERT INTO public.europe_data VALUES (8350, 1, 15, 0.67, 209, 441);
INSERT INTO public.europe_data VALUES (8351, 2, 1, 0.08, 89, 441);
INSERT INTO public.europe_data VALUES (8352, 7, 54, 0.44, 38, 441);
INSERT INTO public.europe_data VALUES (8353, 47, 1285, 0.96, 39, 441);
INSERT INTO public.europe_data VALUES (8354, 23, 125, 14.64, 186, 441);
INSERT INTO public.europe_data VALUES (8355, 0, 0, 0, 210, 441);
INSERT INTO public.europe_data VALUES (8356, 15, 304, 13.91, 187, 441);
INSERT INTO public.europe_data VALUES (8357, 2, 570, 26.17, 129, 441);
INSERT INTO public.europe_data VALUES (8358, 181, 6858, 5.43, 130, 441);
INSERT INTO public.europe_data VALUES (8359, 2, 27, 4.01, 131, 441);
INSERT INTO public.europe_data VALUES (8360, 35, 1418, 64.29, 90, 441);
INSERT INTO public.europe_data VALUES (8361, 0, 0, 0.01, 211, 441);
INSERT INTO public.europe_data VALUES (8362, 1, 168, 2.7, 91, 441);
INSERT INTO public.europe_data VALUES (8363, 558, 18411, 93.2, 92, 441);
INSERT INTO public.europe_data VALUES (8364, 106, 1644, 2.74, 132, 441);
INSERT INTO public.europe_data VALUES (8365, 143, 2076, 11.6, 188, 441);
INSERT INTO public.europe_data VALUES (8366, 135, 1678, 51.75, 189, 441);
INSERT INTO public.europe_data VALUES (8367, 13, 437, 20.28, 93, 441);
INSERT INTO public.europe_data VALUES (8368, 2, 5264, 356.74, 133, 441);
INSERT INTO public.europe_data VALUES (8369, 172, 2127, 22.75, 190, 441);
INSERT INTO public.europe_data VALUES (8370, 533, 53738, 62.96, 191, 441);
INSERT INTO public.europe_data VALUES (8371, 0, 68, 0.89, 40, 441);
INSERT INTO public.europe_data VALUES (8372, 0, 0, 0, 94, 441);
INSERT INTO public.europe_data VALUES (8373, 0, 3, 1.64, 95, 441);
INSERT INTO public.europe_data VALUES (8374, 0, 3, 4.52, 96, 441);
INSERT INTO public.europe_data VALUES (8375, 0, 44, 351.2, 192, 441);
INSERT INTO public.europe_data VALUES (8376, 1, 10, 6.51, 41, 441);
INSERT INTO public.europe_data VALUES (8377, 45, 9489, 51.5, 134, 441);
INSERT INTO public.europe_data VALUES (8378, 0, 511, 5, 42, 441);
INSERT INTO public.europe_data VALUES (8379, 37, 1422, 45.18, 193, 441);
INSERT INTO public.europe_data VALUES (8380, 0, 0, 0, 43, 441);
INSERT INTO public.europe_data VALUES (8381, 4, 64, 1.56, 44, 441);
INSERT INTO public.europe_data VALUES (8382, 6, 4581, 200.14, 135, 441);
INSERT INTO public.europe_data VALUES (8383, 0, 2, 21.23, 97, 441);
INSERT INTO public.europe_data VALUES (8384, 6, 29, 4.53, 194, 441);
INSERT INTO public.europe_data VALUES (8385, 14, 32, 5.24, 195, 441);
INSERT INTO public.europe_data VALUES (8386, 9, 286, 3.61, 45, 441);
INSERT INTO public.europe_data VALUES (8387, 44, 2237, 6.19, 46, 441);
INSERT INTO public.europe_data VALUES (8388, 9, 63, 0.25, 136, 441);
INSERT INTO public.europe_data VALUES (8389, 0, 40, 0.38, 47, 441);
INSERT INTO public.europe_data VALUES (8390, 2238, 7635, 50.57, 196, 441);
INSERT INTO public.europe_data VALUES (8391, 0, 195, 1.98, 137, 441);
INSERT INTO public.europe_data VALUES (8392, 20, 441, 1.43, 48, 441);
INSERT INTO public.europe_data VALUES (8393, 0, 0, 0, 98, 441);
INSERT INTO public.europe_data VALUES (8394, 544, 3832, 78.52, 197, 441);
INSERT INTO public.europe_data VALUES (8395, 136, 844, 25.33, 198, 441);
INSERT INTO public.europe_data VALUES (8396, 0, 1, 0.03, 138, 441);
INSERT INTO public.europe_data VALUES (8397, 0, 7, 0.07, 139, 441);
INSERT INTO public.europe_data VALUES (8398, 2, 76, 0, 140, 441);
INSERT INTO public.europe_data VALUES (8399, 3, 47, 0.29, 141, 441);
INSERT INTO public.europe_data VALUES (8400, 0, 0, 0.39, 142, 441);
INSERT INTO public.europe_data VALUES (8401, 3, 26, 0.49, 49, 441);
INSERT INTO public.europe_data VALUES (8402, 0, 0, 0.14, 99, 441);
INSERT INTO public.europe_data VALUES (8403, 4, 64, 1.15, 50, 441);
INSERT INTO public.europe_data VALUES (8404, 592, 15915, 48.46, 199, 441);
INSERT INTO public.europe_data VALUES (8405, 0, 1, 2.62, 100, 441);
INSERT INTO public.europe_data VALUES (8406, 0, 10, 0.08, 51, 441);
INSERT INTO public.europe_data VALUES (8407, 79, 3296, 14.69, 200, 441);
INSERT INTO public.europe_data VALUES (8408, 50, 3814, 73.9, 143, 441);
INSERT INTO public.europe_data VALUES (8409, 4227, 31282, 96.2, 201, 441);
INSERT INTO public.europe_data VALUES (8410, 6, 180, 0.53, 52, 441);
INSERT INTO public.europe_data VALUES (8411, 12806, 192131, 121.06, 101, 441);
INSERT INTO public.europe_data VALUES (8412, 1, 11, 12.43, 102, 441);
INSERT INTO public.europe_data VALUES (8413, 2, 49, 3.67, 103, 441);
INSERT INTO public.europe_data VALUES (8414, 2, 262, 1.77, 144, 441);
INSERT INTO public.europe_data VALUES (8415, 0, 32, 0.35, 104, 441);
INSERT INTO public.europe_data VALUES (8416, 0, 1, 0, 145, 441);
INSERT INTO public.europe_data VALUES (8417, 0, 0, 1.03, 53, 441);
INSERT INTO public.europe_data VALUES (8418, 2, 9, 0.03, 146, 441);
INSERT INTO public.europe_data VALUES (8419, 0, 36, 0.35, 54, 441);
INSERT INTO public.europe_data VALUES (8420, 0, 3, 0.06, 55, 441);
INSERT INTO public.europe_data VALUES (8421, 24, 535, 2.43, 105, 442);
INSERT INTO public.europe_data VALUES (8422, 2, 164, 9.78, 147, 442);
INSERT INTO public.europe_data VALUES (8423, 50, 753, 3.41, 1, 442);
INSERT INTO public.europe_data VALUES (8424, 4, 27, 133.9, 148, 442);
INSERT INTO public.europe_data VALUES (8425, 0, 2, 0.02, 2, 442);
INSERT INTO public.europe_data VALUES (8426, 0, 0, 0, 56, 442);
INSERT INTO public.europe_data VALUES (8427, 1, 1, 3.09, 57, 442);
INSERT INTO public.europe_data VALUES (8428, 52, 837, 3.49, 58, 442);
INSERT INTO public.europe_data VALUES (8429, 7, 469, 26, 149, 442);
INSERT INTO public.europe_data VALUES (8430, 0, 3, 7.53, 59, 442);
INSERT INTO public.europe_data VALUES (8431, 13, 101, 1.55, 202, 442);
INSERT INTO public.europe_data VALUES (8432, 90, 479, 14.13, 150, 442);
INSERT INTO public.europe_data VALUES (8433, 2, 247, 5.44, 151, 442);
INSERT INTO public.europe_data VALUES (8434, 2, 20, 8.47, 60, 442);
INSERT INTO public.europe_data VALUES (8435, 1, 774, 92.07, 106, 442);
INSERT INTO public.europe_data VALUES (8436, 54, 2960, 2.94, 107, 442);
INSERT INTO public.europe_data VALUES (8437, 1, 4, 2.79, 61, 442);
INSERT INTO public.europe_data VALUES (8438, 25, 4656, 83.42, 152, 442);
INSERT INTO public.europe_data VALUES (8439, 1195, 5703, 119.3, 153, 442);
INSERT INTO public.europe_data VALUES (8440, 0, 0, 1.02, 62, 442);
INSERT INTO public.europe_data VALUES (8441, 0, 27, 0.25, 3, 442);
INSERT INTO public.europe_data VALUES (8442, 0, 23, 83.19, 63, 442);
INSERT INTO public.europe_data VALUES (8443, 0, 2, 0.26, 108, 442);
INSERT INTO public.europe_data VALUES (8444, 17, 386, 5.39, 64, 442);
INSERT INTO public.europe_data VALUES (8445, 0, 1, 11.55, 65, 442);
INSERT INTO public.europe_data VALUES (8446, 12, 247, 15.42, 154, 442);
INSERT INTO public.europe_data VALUES (8447, 0, 2, 0.39, 4, 442);
INSERT INTO public.europe_data VALUES (8448, 1743, 23234, 18.82, 66, 442);
INSERT INTO public.europe_data VALUES (8449, 0, 2, 9.99, 67, 442);
INSERT INTO public.europe_data VALUES (8450, 0, 0, 0.46, 109, 442);
INSERT INTO public.europe_data VALUES (8451, 13, 385, 8.93, 155, 442);
INSERT INTO public.europe_data VALUES (8452, 6, 56, 0.66, 5, 442);
INSERT INTO public.europe_data VALUES (8453, 0, 9, 0.09, 6, 442);
INSERT INTO public.europe_data VALUES (8454, 0, 0, 0, 110, 442);
INSERT INTO public.europe_data VALUES (8455, 14, 605, 3.1, 7, 442);
INSERT INTO public.europe_data VALUES (8456, 980, 12107, 60.19, 68, 442);
INSERT INTO public.europe_data VALUES (8457, 0, 45, 17.46, 8, 442);
INSERT INTO public.europe_data VALUES (8458, 0, 9, 26.17, 69, 442);
INSERT INTO public.europe_data VALUES (8459, 0, 7, 0.17, 9, 442);
INSERT INTO public.europe_data VALUES (8460, 0, 13, 0.19, 10, 442);
INSERT INTO public.europe_data VALUES (8461, 56, 3243, 32.28, 70, 442);
INSERT INTO public.europe_data VALUES (8462, 1, 95, 0.05, 111, 442);
INSERT INTO public.europe_data VALUES (8463, 64, 1587, 5.17, 71, 442);
INSERT INTO public.europe_data VALUES (8464, 2, 40, 2.42, 12, 442);
INSERT INTO public.europe_data VALUES (8465, 2, 35, 1.98, 72, 442);
INSERT INTO public.europe_data VALUES (8466, 5, 303, 2.24, 13, 442);
INSERT INTO public.europe_data VALUES (8467, 8, 159, 10.55, 156, 442);
INSERT INTO public.europe_data VALUES (8468, 20, 334, 6.18, 73, 442);
INSERT INTO public.europe_data VALUES (8469, 0, 2, 1.22, 74, 442);
INSERT INTO public.europe_data VALUES (8470, 2, 50, 21.01, 157, 442);
INSERT INTO public.europe_data VALUES (8471, 33, 617, 13.27, 158, 442);
INSERT INTO public.europe_data VALUES (8472, 3, 127, 0.26, 14, 442);
INSERT INTO public.europe_data VALUES (8473, 67, 1191, 41.35, 159, 442);
INSERT INTO public.europe_data VALUES (8474, 0, 177, 83.1, 15, 442);
INSERT INTO public.europe_data VALUES (8475, 0, 0, 0, 75, 442);
INSERT INTO public.europe_data VALUES (8476, 52, 1455, 29.5, 76, 442);
INSERT INTO public.europe_data VALUES (8477, 102, 13251, 87.79, 77, 442);
INSERT INTO public.europe_data VALUES (8478, 68, 1175, 2.25, 16, 442);
INSERT INTO public.europe_data VALUES (8479, 1, 97, 2.68, 78, 442);
INSERT INTO public.europe_data VALUES (8480, 1, 179, 17.48, 17, 442);
INSERT INTO public.europe_data VALUES (8481, 0, 0, 0.14, 18, 442);
INSERT INTO public.europe_data VALUES (8482, 9, 115, 25.21, 160, 442);
INSERT INTO public.europe_data VALUES (8483, 0, 37, 3.92, 19, 442);
INSERT INTO public.europe_data VALUES (8484, 0, 15, 0.05, 20, 442);
INSERT INTO public.europe_data VALUES (8485, 0, 2, 237.25, 79, 442);
INSERT INTO public.europe_data VALUES (8486, 0, 2, 6.16, 161, 442);
INSERT INTO public.europe_data VALUES (8487, 0, 1, 0.22, 203, 442);
INSERT INTO public.europe_data VALUES (8488, 96, 793, 29.03, 162, 442);
INSERT INTO public.europe_data VALUES (8489, 3138, 11969, 43.53, 163, 442);
INSERT INTO public.europe_data VALUES (8490, 0, 2, 1.43, 204, 442);
INSERT INTO public.europe_data VALUES (8491, 2, 67, 5.48, 21, 442);
INSERT INTO public.europe_data VALUES (8492, 0, 0, 0.04, 22, 442);
INSERT INTO public.europe_data VALUES (8493, 2, 92, 5.73, 164, 442);
INSERT INTO public.europe_data VALUES (8494, 1346, 13521, 38.76, 165, 442);
INSERT INTO public.europe_data VALUES (8495, 2, 508, 3.23, 23, 442);
INSERT INTO public.europe_data VALUES (8496, 0, 8, 35.6, 166, 442);
INSERT INTO public.europe_data VALUES (8497, 20, 271, 3.66, 167, 442);
INSERT INTO public.europe_data VALUES (8498, 0, 0, 0, 80, 442);
INSERT INTO public.europe_data VALUES (8499, 0, 4, 3.57, 81, 442);
INSERT INTO public.europe_data VALUES (8500, 0, 6, 5.38, 205, 442);
INSERT INTO public.europe_data VALUES (8501, 8, 211, 1.96, 82, 442);
INSERT INTO public.europe_data VALUES (8502, 4, 8, 44.98, 168, 442);
INSERT INTO public.europe_data VALUES (8503, 2, 515, 6.61, 24, 442);
INSERT INTO public.europe_data VALUES (8504, 1, 3, 0.73, 25, 442);
INSERT INTO public.europe_data VALUES (8505, 1, 9, 3.7, 83, 442);
INSERT INTO public.europe_data VALUES (8506, 3, 25, 0.35, 84, 442);
INSERT INTO public.europe_data VALUES (8507, 0, 1, 122.7, 169, 442);
INSERT INTO public.europe_data VALUES (8508, 15, 184, 2.71, 85, 442);
INSERT INTO public.europe_data VALUES (8509, 81, 599, 11.51, 170, 442);
INSERT INTO public.europe_data VALUES (8510, 1, 21, 25.49, 171, 442);
INSERT INTO public.europe_data VALUES (8511, 329, 10627, 1.37, 112, 442);
INSERT INTO public.europe_data VALUES (8512, 161, 2307, 1.71, 113, 442);
INSERT INTO public.europe_data VALUES (8513, 592, 8270, 22.67, 114, 442);
INSERT INTO public.europe_data VALUES (8514, 5, 281, 1.19, 115, 442);
INSERT INTO public.europe_data VALUES (8515, 477, 4011, 195.89, 172, 442);
INSERT INTO public.europe_data VALUES (8516, 12, 10, 94.57, 173, 442);
INSERT INTO public.europe_data VALUES (8517, 27, 1907, 49.92, 116, 442);
INSERT INTO public.europe_data VALUES (8518, 2984, 18703, 68.44, 174, 442);
INSERT INTO public.europe_data VALUES (8519, 2, 154, 9.43, 86, 442);
INSERT INTO public.europe_data VALUES (8520, 180, 2634, 4.83, 117, 442);
INSERT INTO public.europe_data VALUES (8521, 7, 32, 63.08, 175, 442);
INSERT INTO public.europe_data VALUES (8522, 0, 30, 0.57, 118, 442);
INSERT INTO public.europe_data VALUES (8523, 6, 982, 9.47, 119, 442);
INSERT INTO public.europe_data VALUES (8524, 0, 85, 0.3, 26, 442);
INSERT INTO public.europe_data VALUES (8525, 6, 203, 22.35, 176, 442);
INSERT INTO public.europe_data VALUES (8526, 13, 1160, 43.76, 120, 442);
INSERT INTO public.europe_data VALUES (8527, 1, 127, 4.3, 121, 442);
INSERT INTO public.europe_data VALUES (8528, 0, 0, 0, 122, 442);
INSERT INTO public.europe_data VALUES (8529, 7, 85, 8.39, 177, 442);
INSERT INTO public.europe_data VALUES (8530, 3, 34, 1.12, 123, 442);
INSERT INTO public.europe_data VALUES (8531, 4, 33, 1.5, 28, 442);
INSERT INTO public.europe_data VALUES (8532, 1, 12, 0.53, 29, 442);
INSERT INTO public.europe_data VALUES (8533, 0, 1, 7.82, 178, 442);
INSERT INTO public.europe_data VALUES (8534, 5, 112, 13.46, 179, 442);
INSERT INTO public.europe_data VALUES (8535, 15, 173, 72, 180, 442);
INSERT INTO public.europe_data VALUES (8536, 0, 3, 0.07, 30, 442);
INSERT INTO public.europe_data VALUES (8537, 1, 17, 0.11, 31, 442);
INSERT INTO public.europe_data VALUES (8538, 9, 391, 3.43, 124, 442);
INSERT INTO public.europe_data VALUES (8539, 0, 162, 36.54, 125, 442);
INSERT INTO public.europe_data VALUES (8540, 9, 165, 1.39, 32, 442);
INSERT INTO public.europe_data VALUES (8541, 1, 18, 13.17, 181, 442);
INSERT INTO public.europe_data VALUES (8542, 0, 0, 0, 33, 442);
INSERT INTO public.europe_data VALUES (8543, 0, 4, 0.63, 34, 442);
INSERT INTO public.europe_data VALUES (8544, 665, 9135, 11.97, 87, 442);
INSERT INTO public.europe_data VALUES (8545, 29, 936, 43.18, 182, 442);
INSERT INTO public.europe_data VALUES (8546, 0, 0, 3.02, 183, 442);
INSERT INTO public.europe_data VALUES (8547, 0, 6, 0.68, 126, 442);
INSERT INTO public.europe_data VALUES (8548, 2, 13, 7.88, 184, 442);
INSERT INTO public.europe_data VALUES (8549, 1, 0, 0, 88, 442);
INSERT INTO public.europe_data VALUES (8550, 20, 1210, 6.59, 35, 442);
INSERT INTO public.europe_data VALUES (8551, 0, 37, 0.18, 36, 442);
INSERT INTO public.europe_data VALUES (8552, 0, 35, 0.19, 127, 442);
INSERT INTO public.europe_data VALUES (8553, 0, 0, 0, 37, 442);
INSERT INTO public.europe_data VALUES (8554, 0, 21, 0.14, 128, 442);
INSERT INTO public.europe_data VALUES (8555, 791, 5190, 70.93, 185, 442);
INSERT INTO public.europe_data VALUES (8556, 0, 0, 0, 208, 442);
INSERT INTO public.europe_data VALUES (8557, 7, 17, 1.21, 209, 442);
INSERT INTO public.europe_data VALUES (8558, 2, 4, 0.06, 89, 442);
INSERT INTO public.europe_data VALUES (8559, 9, 48, 0.72, 38, 442);
INSERT INTO public.europe_data VALUES (8560, 19, 646, 0.47, 39, 442);
INSERT INTO public.europe_data VALUES (8561, 10, 179, 26.86, 186, 442);
INSERT INTO public.europe_data VALUES (8562, 0, 0, 5.24, 210, 442);
INSERT INTO public.europe_data VALUES (8563, 39, 437, 20.46, 187, 442);
INSERT INTO public.europe_data VALUES (8564, 3, 732, 28.12, 129, 442);
INSERT INTO public.europe_data VALUES (8565, 105, 4910, 3.67, 130, 442);
INSERT INTO public.europe_data VALUES (8566, 0, 173, 4.56, 131, 442);
INSERT INTO public.europe_data VALUES (8567, 39, 1312, 56.02, 90, 442);
INSERT INTO public.europe_data VALUES (8568, 0, 1, 0.07, 211, 442);
INSERT INTO public.europe_data VALUES (8569, 1, 22, 1.15, 91, 442);
INSERT INTO public.europe_data VALUES (8570, 328, 11889, 61.51, 92, 442);
INSERT INTO public.europe_data VALUES (8571, 92, 1320, 2.71, 132, 442);
INSERT INTO public.europe_data VALUES (8572, 175, 2330, 13.02, 188, 442);
INSERT INTO public.europe_data VALUES (8573, 214, 3640, 70.66, 189, 442);
INSERT INTO public.europe_data VALUES (8574, 22, 158, 16.16, 93, 442);
INSERT INTO public.europe_data VALUES (8575, 2, 4839, 258.04, 133, 442);
INSERT INTO public.europe_data VALUES (8576, 174, 2290, 24.39, 190, 442);
INSERT INTO public.europe_data VALUES (8577, 386, 38096, 44.68, 191, 442);
INSERT INTO public.europe_data VALUES (8578, 0, 44, 0.51, 40, 442);
INSERT INTO public.europe_data VALUES (8579, 0, 0, 5.68, 94, 442);
INSERT INTO public.europe_data VALUES (8580, 0, 0, 0, 95, 442);
INSERT INTO public.europe_data VALUES (8581, 0, 2, 1.81, 96, 442);
INSERT INTO public.europe_data VALUES (8582, 2, 77, 528.26, 192, 442);
INSERT INTO public.europe_data VALUES (8583, 0, 4, 1.86, 41, 442);
INSERT INTO public.europe_data VALUES (8584, 42, 8160, 38.11, 134, 442);
INSERT INTO public.europe_data VALUES (8585, 5, 304, 2.4, 42, 442);
INSERT INTO public.europe_data VALUES (8586, 34, 1724, 63.36, 193, 442);
INSERT INTO public.europe_data VALUES (8587, 0, 0, 1.02, 43, 442);
INSERT INTO public.europe_data VALUES (8588, 4, 58, 1.06, 44, 442);
INSERT INTO public.europe_data VALUES (8589, 1, 7036, 191.1, 135, 442);
INSERT INTO public.europe_data VALUES (8590, 3, 7, 56.62, 97, 442);
INSERT INTO public.europe_data VALUES (8591, 6, 218, 11.69, 194, 442);
INSERT INTO public.europe_data VALUES (8592, 8, 77, 9.71, 195, 442);
INSERT INTO public.europe_data VALUES (8593, 16, 272, 2.66, 45, 442);
INSERT INTO public.europe_data VALUES (8594, 33, 1388, 4.05, 46, 442);
INSERT INTO public.europe_data VALUES (8595, 7, 64, 0.39, 136, 442);
INSERT INTO public.europe_data VALUES (8596, 0, 2, 0.02, 47, 442);
INSERT INTO public.europe_data VALUES (8597, 2338, 16100, 78.02, 196, 442);
INSERT INTO public.europe_data VALUES (8598, 0, 228, 1.47, 137, 442);
INSERT INTO public.europe_data VALUES (8599, 11, 171, 0.51, 48, 442);
INSERT INTO public.europe_data VALUES (8600, 0, 0, 0, 98, 442);
INSERT INTO public.europe_data VALUES (8601, 546, 4201, 77.73, 197, 442);
INSERT INTO public.europe_data VALUES (8602, 202, 1320, 43.98, 198, 442);
INSERT INTO public.europe_data VALUES (8603, 0, 4, 0.11, 138, 442);
INSERT INTO public.europe_data VALUES (8604, 0, 9, 0.17, 139, 442);
INSERT INTO public.europe_data VALUES (8605, 4, 157, 0.49, 141, 442);
INSERT INTO public.europe_data VALUES (8606, 0, 5, 1.7, 142, 442);
INSERT INTO public.europe_data VALUES (8607, 1, 14, 0.27, 49, 442);
INSERT INTO public.europe_data VALUES (8608, 0, 2, 0.22, 99, 442);
INSERT INTO public.europe_data VALUES (8609, 0, 70, 2.07, 50, 442);
INSERT INTO public.europe_data VALUES (8610, 788, 23824, 64.84, 199, 442);
INSERT INTO public.europe_data VALUES (8611, 0, 0, 5.24, 100, 442);
INSERT INTO public.europe_data VALUES (8612, 0, 24, 0.06, 51, 442);
INSERT INTO public.europe_data VALUES (8613, 68, 3168, 13.27, 200, 442);
INSERT INTO public.europe_data VALUES (8614, 35, 3406, 65.17, 143, 442);
INSERT INTO public.europe_data VALUES (8615, 5512, 32830, 97.31, 201, 442);
INSERT INTO public.europe_data VALUES (8616, 5, 130, 0.46, 52, 442);
INSERT INTO public.europe_data VALUES (8617, 14194, 206223, 124.09, 101, 442);
INSERT INTO public.europe_data VALUES (8618, 0, 2, 3.82, 102, 442);
INSERT INTO public.europe_data VALUES (8619, 5, 78, 4.07, 103, 442);
INSERT INTO public.europe_data VALUES (8620, 3, 322, 3.1, 144, 442);
INSERT INTO public.europe_data VALUES (8621, 1, 69, 0.5, 104, 442);
INSERT INTO public.europe_data VALUES (8622, 0, 2, 0.01, 145, 442);
INSERT INTO public.europe_data VALUES (8623, 0, 6, 0, 53, 442);
INSERT INTO public.europe_data VALUES (8624, 0, 0, 0, 146, 442);
INSERT INTO public.europe_data VALUES (8625, 0, 27, 0.25, 54, 442);
INSERT INTO public.europe_data VALUES (8626, 1, 6, 0.12, 55, 442);
INSERT INTO public.europe_data VALUES (8627, 15, 389, 1.83, 105, 443);
INSERT INTO public.europe_data VALUES (8628, 3, 116, 7.02, 147, 443);
INSERT INTO public.europe_data VALUES (8629, 82, 715, 3.04, 1, 443);
INSERT INTO public.europe_data VALUES (8630, 7, 75, 278.3, 148, 443);
INSERT INTO public.europe_data VALUES (8631, 0, 5, 0.03, 2, 443);
INSERT INTO public.europe_data VALUES (8632, 0, 0, 0, 56, 443);
INSERT INTO public.europe_data VALUES (8633, 0, 2, 8.24, 57, 443);
INSERT INTO public.europe_data VALUES (8634, 39, 727, 3.07, 58, 443);
INSERT INTO public.europe_data VALUES (8635, 8, 300, 17.11, 149, 443);
INSERT INTO public.europe_data VALUES (8636, 2, 5, 31.04, 59, 443);
INSERT INTO public.europe_data VALUES (8637, 9, 290, 3.44, 202, 443);
INSERT INTO public.europe_data VALUES (8638, 102, 773, 30.78, 150, 443);
INSERT INTO public.europe_data VALUES (8639, 8, 300, 8.1, 151, 443);
INSERT INTO public.europe_data VALUES (8640, 1, 13, 7.96, 60, 443);
INSERT INTO public.europe_data VALUES (8641, 1, 737, 71.47, 106, 443);
INSERT INTO public.europe_data VALUES (8642, 57, 1835, 1.45, 107, 443);
INSERT INTO public.europe_data VALUES (8643, 1, 4, 6.62, 61, 443);
INSERT INTO public.europe_data VALUES (8644, 21, 3229, 55.47, 152, 443);
INSERT INTO public.europe_data VALUES (8645, 1667, 7963, 167.06, 153, 443);
INSERT INTO public.europe_data VALUES (8646, 0, 4, 3.33, 62, 443);
INSERT INTO public.europe_data VALUES (8647, 0, 2, 0.13, 3, 443);
INSERT INTO public.europe_data VALUES (8648, 1, 29, 78.39, 63, 443);
INSERT INTO public.europe_data VALUES (8649, 0, 0, 0, 108, 443);
INSERT INTO public.europe_data VALUES (8650, 6, 234, 3.31, 64, 443);
INSERT INTO public.europe_data VALUES (8651, 0, 2, 11.55, 65, 443);
INSERT INTO public.europe_data VALUES (8652, 8, 262, 18.36, 154, 443);
INSERT INTO public.europe_data VALUES (8653, 0, 7, 0.61, 4, 443);
INSERT INTO public.europe_data VALUES (8654, 1239, 16485, 13.04, 66, 443);
INSERT INTO public.europe_data VALUES (8655, 1, 1, 3.33, 67, 443);
INSERT INTO public.europe_data VALUES (8656, 0, 2, 0.69, 109, 443);
INSERT INTO public.europe_data VALUES (8657, 14, 240, 5.49, 155, 443);
INSERT INTO public.europe_data VALUES (8658, 9, 79, 1.14, 5, 443);
INSERT INTO public.europe_data VALUES (8659, 1, 1, 0.03, 6, 443);
INSERT INTO public.europe_data VALUES (8660, 0, 0, 0.05, 110, 443);
INSERT INTO public.europe_data VALUES (8661, 30, 196, 1.41, 7, 443);
INSERT INTO public.europe_data VALUES (8662, 863, 10412, 51.54, 68, 443);
INSERT INTO public.europe_data VALUES (8663, 0, 51, 9.82, 8, 443);
INSERT INTO public.europe_data VALUES (8664, 0, 8, 33.87, 69, 443);
INSERT INTO public.europe_data VALUES (8665, 0, 1, 0.06, 9, 443);
INSERT INTO public.europe_data VALUES (8666, 0, 18, 0.15, 10, 443);
INSERT INTO public.europe_data VALUES (8667, 53, 2875, 29.64, 70, 443);
INSERT INTO public.europe_data VALUES (8668, 1291, 608, 0.08, 111, 443);
INSERT INTO public.europe_data VALUES (8669, 70, 1016, 4.58, 71, 443);
INSERT INTO public.europe_data VALUES (8670, 1, 90, 2.14, 12, 443);
INSERT INTO public.europe_data VALUES (8671, 1, 65, 4.08, 72, 443);
INSERT INTO public.europe_data VALUES (8672, 4, 273, 2.28, 13, 443);
INSERT INTO public.europe_data VALUES (8673, 24, 271, 16.9, 156, 443);
INSERT INTO public.europe_data VALUES (8674, 16, 366, 6.31, 73, 443);
INSERT INTO public.europe_data VALUES (8675, 0, 0, 1.84, 74, 443);
INSERT INTO public.europe_data VALUES (8676, 1, 134, 36.65, 157, 443);
INSERT INTO public.europe_data VALUES (8677, 50, 796, 20.66, 158, 443);
INSERT INTO public.europe_data VALUES (8678, 5, 98, 0.21, 14, 443);
INSERT INTO public.europe_data VALUES (8679, 82, 1210, 51.93, 159, 443);
INSERT INTO public.europe_data VALUES (8680, 0, 632, 80.84, 15, 443);
INSERT INTO public.europe_data VALUES (8681, 0, 0, 2.79, 75, 443);
INSERT INTO public.europe_data VALUES (8682, 53, 1713, 27.33, 76, 443);
INSERT INTO public.europe_data VALUES (8683, 141, 2002, 33.51, 77, 443);
INSERT INTO public.europe_data VALUES (8684, 80, 1079, 2.07, 16, 443);
INSERT INTO public.europe_data VALUES (8685, 1, 76, 2.05, 78, 443);
INSERT INTO public.europe_data VALUES (8686, 0, 58, 4.65, 17, 443);
INSERT INTO public.europe_data VALUES (8687, 0, 5, 0.29, 18, 443);
INSERT INTO public.europe_data VALUES (8688, 15, 219, 32.53, 160, 443);
INSERT INTO public.europe_data VALUES (8689, 1, 8, 1.13, 19, 443);
INSERT INTO public.europe_data VALUES (8690, 0, 37, 0.06, 20, 443);
INSERT INTO public.europe_data VALUES (8691, 0, 6, 266.9, 79, 443);
INSERT INTO public.europe_data VALUES (8692, 0, 1, 8.22, 161, 443);
INSERT INTO public.europe_data VALUES (8693, 0, 1, 0.34, 203, 443);
INSERT INTO public.europe_data VALUES (8694, 38, 809, 33.64, 162, 443);
INSERT INTO public.europe_data VALUES (8695, 5325, 17203, 62.87, 163, 443);
INSERT INTO public.europe_data VALUES (8696, 0, 2, 5.01, 204, 443);
INSERT INTO public.europe_data VALUES (8697, 0, 52, 4.05, 21, 443);
INSERT INTO public.europe_data VALUES (8698, 0, 1, 0.26, 22, 443);
INSERT INTO public.europe_data VALUES (8699, 1, 137, 5.5, 164, 443);
INSERT INTO public.europe_data VALUES (8700, 1605, 18656, 55.75, 165, 443);
INSERT INTO public.europe_data VALUES (8701, 1, 476, 2.72, 23, 443);
INSERT INTO public.europe_data VALUES (8702, 0, 4, 89, 166, 443);
INSERT INTO public.europe_data VALUES (8703, 12, 121, 4.66, 167, 443);
INSERT INTO public.europe_data VALUES (8704, 0, 0, 0, 80, 443);
INSERT INTO public.europe_data VALUES (8705, 0, 0, 1.79, 81, 443);
INSERT INTO public.europe_data VALUES (8706, 0, 3, 15.54, 205, 443);
INSERT INTO public.europe_data VALUES (8707, 2, 133, 1.25, 82, 443);
INSERT INTO public.europe_data VALUES (8708, 3, 21, 131.85, 168, 443);
INSERT INTO public.europe_data VALUES (8709, 5, 329, 3.59, 24, 443);
INSERT INTO public.europe_data VALUES (8710, 0, 11, 1.67, 25, 443);
INSERT INTO public.europe_data VALUES (8711, 1, 20, 4.6, 83, 443);
INSERT INTO public.europe_data VALUES (8712, 0, 14, 0.23, 84, 443);
INSERT INTO public.europe_data VALUES (8713, 0, 0, 122.7, 169, 443);
INSERT INTO public.europe_data VALUES (8714, 21, 80, 1.84, 85, 443);
INSERT INTO public.europe_data VALUES (8715, 90, 526, 12.69, 170, 443);
INSERT INTO public.europe_data VALUES (8716, 1, 70, 79.83, 171, 443);
INSERT INTO public.europe_data VALUES (8717, 235, 8113, 0.97, 112, 443);
INSERT INTO public.europe_data VALUES (8718, 209, 2334, 1.59, 113, 443);
INSERT INTO public.europe_data VALUES (8719, 644, 10525, 28.93, 114, 443);
INSERT INTO public.europe_data VALUES (8720, 6, 187, 1.47, 115, 443);
INSERT INTO public.europe_data VALUES (8721, 276, 5596, 206.76, 172, 443);
INSERT INTO public.europe_data VALUES (8722, 4, 70, 202.15, 173, 443);
INSERT INTO public.europe_data VALUES (8723, 69, 2346, 59.41, 116, 443);
INSERT INTO public.europe_data VALUES (8724, 3759, 22609, 82.88, 174, 443);
INSERT INTO public.europe_data VALUES (8725, 1, 124, 4.68, 86, 443);
INSERT INTO public.europe_data VALUES (8726, 69, 3496, 5.59, 117, 443);
INSERT INTO public.europe_data VALUES (8727, 8, 36, 87.2, 175, 443);
INSERT INTO public.europe_data VALUES (8728, 0, 28, 0.71, 118, 443);
INSERT INTO public.europe_data VALUES (8729, 9, 774, 6.49, 119, 443);
INSERT INTO public.europe_data VALUES (8730, 6, 73, 0.24, 26, 443);
INSERT INTO public.europe_data VALUES (8731, 7, 199, 22.02, 176, 443);
INSERT INTO public.europe_data VALUES (8732, 6, 681, 32.3, 120, 443);
INSERT INTO public.europe_data VALUES (8733, 2, 149, 5.49, 121, 443);
INSERT INTO public.europe_data VALUES (8734, 0, 0, 0.11, 122, 443);
INSERT INTO public.europe_data VALUES (8735, 0, 76, 10.1, 177, 443);
INSERT INTO public.europe_data VALUES (8736, 1, 43, 2.13, 123, 443);
INSERT INTO public.europe_data VALUES (8737, 3, 41, 1.58, 28, 443);
INSERT INTO public.europe_data VALUES (8738, 0, 24, 0.46, 29, 443);
INSERT INTO public.europe_data VALUES (8739, 0, 2, 10.42, 178, 443);
INSERT INTO public.europe_data VALUES (8740, 12, 264, 18.43, 179, 443);
INSERT INTO public.europe_data VALUES (8741, 7, 269, 121.52, 180, 443);
INSERT INTO public.europe_data VALUES (8742, 0, 15, 0.18, 30, 443);
INSERT INTO public.europe_data VALUES (8743, 0, 4, 0.07, 31, 443);
INSERT INTO public.europe_data VALUES (8744, 13, 706, 5.41, 124, 443);
INSERT INTO public.europe_data VALUES (8745, 0, 32, 6.22, 125, 443);
INSERT INTO public.europe_data VALUES (8746, 5, 108, 0.91, 32, 443);
INSERT INTO public.europe_data VALUES (8747, 0, 47, 38.5, 181, 443);
INSERT INTO public.europe_data VALUES (8748, 0, 0, 0.02, 33, 443);
INSERT INTO public.europe_data VALUES (8749, 0, 4, 7.95, 34, 443);
INSERT INTO public.europe_data VALUES (8750, 390, 6141, 7.47, 87, 443);
INSERT INTO public.europe_data VALUES (8751, 35, 810, 39.77, 182, 443);
INSERT INTO public.europe_data VALUES (8752, 0, 1, 42.32, 183, 443);
INSERT INTO public.europe_data VALUES (8753, 0, 16, 0.56, 126, 443);
INSERT INTO public.europe_data VALUES (8754, 2, 36, 15.11, 184, 443);
INSERT INTO public.europe_data VALUES (8755, 0, 0, 100.18, 88, 443);
INSERT INTO public.europe_data VALUES (8756, 23, 1194, 5.03, 35, 443);
INSERT INTO public.europe_data VALUES (8757, 0, 18, 0.1, 36, 443);
INSERT INTO public.europe_data VALUES (8758, 1, 70, 0.17, 127, 443);
INSERT INTO public.europe_data VALUES (8759, 0, 0, 0, 37, 443);
INSERT INTO public.europe_data VALUES (8760, 0, 19, 0.08, 128, 443);
INSERT INTO public.europe_data VALUES (8761, 947, 7068, 85.66, 185, 443);
INSERT INTO public.europe_data VALUES (8762, 0, 0, 0, 208, 443);
INSERT INTO public.europe_data VALUES (8763, 7, 41, 4.06, 209, 443);
INSERT INTO public.europe_data VALUES (8764, 0, 0, 0.06, 89, 443);
INSERT INTO public.europe_data VALUES (8765, 8, 119, 1.99, 38, 443);
INSERT INTO public.europe_data VALUES (8766, 11, 304, 0.2, 39, 443);
INSERT INTO public.europe_data VALUES (8767, 17, 379, 34.86, 186, 443);
INSERT INTO public.europe_data VALUES (8768, 0, 3, 10.49, 210, 443);
INSERT INTO public.europe_data VALUES (8769, 51, 653, 26.8, 187, 443);
INSERT INTO public.europe_data VALUES (8770, 3, 667, 19.46, 129, 443);
INSERT INTO public.europe_data VALUES (8771, 83, 3044, 2.37, 130, 443);
INSERT INTO public.europe_data VALUES (8772, 0, 54, 2.11, 131, 443);
INSERT INTO public.europe_data VALUES (8773, 39, 1067, 58.38, 90, 443);
INSERT INTO public.europe_data VALUES (8774, 0, 5, 0.07, 211, 443);
INSERT INTO public.europe_data VALUES (8775, 2, 59, 1.32, 91, 443);
INSERT INTO public.europe_data VALUES (8776, 207, 8109, 41.05, 92, 443);
INSERT INTO public.europe_data VALUES (8777, 112, 1611, 2.79, 132, 443);
INSERT INTO public.europe_data VALUES (8778, 128, 2613, 13.65, 188, 443);
INSERT INTO public.europe_data VALUES (8779, 210, 3621, 86.88, 189, 443);
INSERT INTO public.europe_data VALUES (8780, 18, 316, 25.16, 93, 443);
INSERT INTO public.europe_data VALUES (8781, 1, 2469, 135.73, 133, 443);
INSERT INTO public.europe_data VALUES (8782, 128, 2446, 25.15, 190, 443);
INSERT INTO public.europe_data VALUES (8783, 231, 27083, 25.68, 191, 443);
INSERT INTO public.europe_data VALUES (8784, 0, 21, 0.34, 40, 443);
INSERT INTO public.europe_data VALUES (8785, 0, 3, 9.46, 94, 443);
INSERT INTO public.europe_data VALUES (8786, 0, 0, 0.55, 95, 443);
INSERT INTO public.europe_data VALUES (8787, 0, 0, 4.52, 96, 443);
INSERT INTO public.europe_data VALUES (8788, 4, 105, 565.99, 192, 443);
INSERT INTO public.europe_data VALUES (8789, 0, 0, 1.86, 41, 443);
INSERT INTO public.europe_data VALUES (8790, 38, 4900, 20.36, 134, 443);
INSERT INTO public.europe_data VALUES (8791, 2, 87, 0.89, 42, 443);
INSERT INTO public.europe_data VALUES (8792, 42, 2688, 63.33, 193, 443);
INSERT INTO public.europe_data VALUES (8793, 0, 1, 1.02, 43, 443);
INSERT INTO public.europe_data VALUES (8794, 0, 25, 0.37, 44, 443);
INSERT INTO public.europe_data VALUES (8795, 3, 4056, 90.95, 135, 443);
INSERT INTO public.europe_data VALUES (8796, 1, 17, 99.08, 97, 443);
INSERT INTO public.europe_data VALUES (8797, 10, 419, 12.4, 194, 443);
INSERT INTO public.europe_data VALUES (8798, 21, 125, 16, 195, 443);
INSERT INTO public.europe_data VALUES (8799, 5, 139, 1.02, 45, 443);
INSERT INTO public.europe_data VALUES (8800, 29, 985, 2.57, 46, 443);
INSERT INTO public.europe_data VALUES (8801, 19, 137, 0.76, 136, 443);
INSERT INTO public.europe_data VALUES (8802, 0, 0, 0.03, 47, 443);
INSERT INTO public.europe_data VALUES (8803, 3880, 20519, 113.07, 196, 443);
INSERT INTO public.europe_data VALUES (8804, 0, 85, 0.6, 137, 443);
INSERT INTO public.europe_data VALUES (8805, 8, 47, 0.13, 48, 443);
INSERT INTO public.europe_data VALUES (8806, 0, 0, 0, 98, 443);
INSERT INTO public.europe_data VALUES (8807, 658, 3751, 73.21, 197, 443);
INSERT INTO public.europe_data VALUES (8808, 276, 2438, 77.66, 198, 443);
INSERT INTO public.europe_data VALUES (8809, 1, 14, 0.12, 138, 443);
INSERT INTO public.europe_data VALUES (8810, 0, 32, 0.24, 139, 443);
INSERT INTO public.europe_data VALUES (8811, 7, 186, 0.78, 141, 443);
INSERT INTO public.europe_data VALUES (8812, 0, 17, 1.39, 142, 443);
INSERT INTO public.europe_data VALUES (8813, 2, 8, 0.49, 49, 443);
INSERT INTO public.europe_data VALUES (8814, 0, 1, 0.72, 99, 443);
INSERT INTO public.europe_data VALUES (8815, 7, 172, 2.79, 50, 443);
INSERT INTO public.europe_data VALUES (8816, 819, 29350, 72.24, 199, 443);
INSERT INTO public.europe_data VALUES (8817, 0, 2, 15.71, 100, 443);
INSERT INTO public.europe_data VALUES (8818, 0, 1, 0.01, 51, 443);
INSERT INTO public.europe_data VALUES (8819, 58, 2672, 9.41, 200, 443);
INSERT INTO public.europe_data VALUES (8820, 19, 2961, 52.81, 143, 443);
INSERT INTO public.europe_data VALUES (8821, 6166, 32027, 96.38, 201, 443);
INSERT INTO public.europe_data VALUES (8822, 2, 138, 0.26, 52, 443);
INSERT INTO public.europe_data VALUES (8823, 18574, 202116, 128.26, 101, 443);
INSERT INTO public.europe_data VALUES (8824, 2, 2, 10.52, 102, 443);
INSERT INTO public.europe_data VALUES (8825, 2, 63, 3.5, 103, 443);
INSERT INTO public.europe_data VALUES (8826, 1, 700, 3.71, 144, 443);
INSERT INTO public.europe_data VALUES (8827, 0, 75, 0.38, 104, 443);
INSERT INTO public.europe_data VALUES (8828, 0, 4, 0.02, 145, 443);
INSERT INTO public.europe_data VALUES (8829, 0, 0, 0, 146, 443);
INSERT INTO public.europe_data VALUES (8830, 1, 18, 0.12, 54, 443);
INSERT INTO public.europe_data VALUES (8831, 0, 11, 0.11, 55, 443);
INSERT INTO public.europe_data VALUES (8832, 11, 308, 1.3, 105, 444);
INSERT INTO public.europe_data VALUES (8833, 2, 85, 8.17, 147, 444);
INSERT INTO public.europe_data VALUES (8834, 141, 594, 3.26, 1, 444);
INSERT INTO public.europe_data VALUES (8835, 11, 137, 399.07, 148, 444);
INSERT INTO public.europe_data VALUES (8836, 0, 5, 0.04, 2, 444);
INSERT INTO public.europe_data VALUES (8837, 0, 0, 6.72, 56, 444);
INSERT INTO public.europe_data VALUES (8838, 2, 6, 14.42, 57, 444);
INSERT INTO public.europe_data VALUES (8839, 49, 649, 3.09, 58, 444);
INSERT INTO public.europe_data VALUES (8840, 6, 206, 18.83, 149, 444);
INSERT INTO public.europe_data VALUES (8841, 0, 28, 39.51, 59, 444);
INSERT INTO public.europe_data VALUES (8842, 25, 578, 8.84, 202, 444);
INSERT INTO public.europe_data VALUES (8843, 146, 1954, 57.84, 150, 444);
INSERT INTO public.europe_data VALUES (8844, 4, 514, 8.85, 151, 444);
INSERT INTO public.europe_data VALUES (8845, 3, 18, 8.47, 60, 444);
INSERT INTO public.europe_data VALUES (8846, 2, 436, 38.75, 106, 444);
INSERT INTO public.europe_data VALUES (8847, 25, 533, 0.35, 107, 444);
INSERT INTO public.europe_data VALUES (8848, 3, 15, 13.24, 61, 444);
INSERT INTO public.europe_data VALUES (8849, 18, 2014, 26.28, 152, 444);
INSERT INTO public.europe_data VALUES (8850, 1979, 11175, 182.17, 153, 444);
INSERT INTO public.europe_data VALUES (8851, 1, 9, 3.07, 62, 444);
INSERT INTO public.europe_data VALUES (8852, 1, 13, 0.25, 3, 444);
INSERT INTO public.europe_data VALUES (8853, 4, 20, 55.99, 63, 444);
INSERT INTO public.europe_data VALUES (8854, 0, 0, 0.13, 108, 444);
INSERT INTO public.europe_data VALUES (8855, 16, 147, 2.03, 64, 444);
INSERT INTO public.europe_data VALUES (8856, 0, 1, 11.55, 65, 444);
INSERT INTO public.europe_data VALUES (8857, 14, 344, 20.72, 154, 444);
INSERT INTO public.europe_data VALUES (8858, 0, 7, 0.56, 4, 444);
INSERT INTO public.europe_data VALUES (8859, 737, 11039, 8.49, 66, 444);
INSERT INTO public.europe_data VALUES (8860, 0, 0, 3.33, 67, 444);
INSERT INTO public.europe_data VALUES (8861, 0, 1, 2.31, 109, 444);
INSERT INTO public.europe_data VALUES (8862, 9, 144, 4.7, 155, 444);
INSERT INTO public.europe_data VALUES (8863, 10, 152, 1.56, 5, 444);
INSERT INTO public.europe_data VALUES (8864, 0, 2, 0.04, 6, 444);
INSERT INTO public.europe_data VALUES (8865, 0, 8, 0.09, 110, 444);
INSERT INTO public.europe_data VALUES (8866, 3, 170, 2.79, 7, 444);
INSERT INTO public.europe_data VALUES (8867, 437, 8869, 48.41, 68, 444);
INSERT INTO public.europe_data VALUES (8868, 0, 3, 0.91, 8, 444);
INSERT INTO public.europe_data VALUES (8869, 0, 14, 69.29, 69, 444);
INSERT INTO public.europe_data VALUES (8870, 0, 2, 0.11, 9, 444);
INSERT INTO public.europe_data VALUES (8871, 0, 6, 0.06, 10, 444);
INSERT INTO public.europe_data VALUES (8872, 46, 2742, 26.77, 70, 444);
INSERT INTO public.europe_data VALUES (8873, 10, 567, 0.07, 111, 444);
INSERT INTO public.europe_data VALUES (8874, 74, 1291, 4.12, 71, 444);
INSERT INTO public.europe_data VALUES (8875, 0, 25, 0.95, 12, 444);
INSERT INTO public.europe_data VALUES (8876, 1, 141, 5.57, 72, 444);
INSERT INTO public.europe_data VALUES (8877, 2, 313, 1.59, 13, 444);
INSERT INTO public.europe_data VALUES (8878, 8, 418, 21.76, 156, 444);
INSERT INTO public.europe_data VALUES (8879, 10, 349, 4.68, 73, 444);
INSERT INTO public.europe_data VALUES (8880, 0, 3, 3.06, 74, 444);
INSERT INTO public.europe_data VALUES (8881, 2, 187, 47.84, 157, 444);
INSERT INTO public.europe_data VALUES (8882, 71, 1404, 29.69, 158, 444);
INSERT INTO public.europe_data VALUES (8883, 2, 80, 0.18, 14, 444);
INSERT INTO public.europe_data VALUES (8884, 94, 1805, 65.09, 159, 444);
INSERT INTO public.europe_data VALUES (8885, 2, 155, 20.03, 15, 444);
INSERT INTO public.europe_data VALUES (8886, 0, 2, 6.96, 75, 444);
INSERT INTO public.europe_data VALUES (8887, 91, 1222, 19.63, 76, 444);
INSERT INTO public.europe_data VALUES (8888, 153, 3820, 32.09, 77, 444);
INSERT INTO public.europe_data VALUES (8889, 88, 995, 1.48, 16, 444);
INSERT INTO public.europe_data VALUES (8890, 3, 56, 1.47, 78, 444);
INSERT INTO public.europe_data VALUES (8891, 0, 5, 0.52, 17, 444);
INSERT INTO public.europe_data VALUES (8892, 0, 5, 0.63, 18, 444);
INSERT INTO public.europe_data VALUES (8893, 10, 212, 47.55, 160, 444);
INSERT INTO public.europe_data VALUES (8894, 0, 5, 0.44, 19, 444);
INSERT INTO public.europe_data VALUES (8895, 1, 28, 0.05, 20, 444);
INSERT INTO public.europe_data VALUES (8896, 0, 3, 148.28, 79, 444);
INSERT INTO public.europe_data VALUES (8897, 0, 3, 51.36, 161, 444);
INSERT INTO public.europe_data VALUES (8898, 0, 2, 1.24, 203, 444);
INSERT INTO public.europe_data VALUES (8899, 29, 1047, 31.82, 162, 444);
INSERT INTO public.europe_data VALUES (8900, 6315, 24925, 82.42, 163, 444);
INSERT INTO public.europe_data VALUES (8901, 0, 12, 6.45, 204, 444);
INSERT INTO public.europe_data VALUES (8902, 0, 36, 2.3, 21, 444);
INSERT INTO public.europe_data VALUES (8903, 0, 5, 0.26, 22, 444);
INSERT INTO public.europe_data VALUES (8904, 1, 83, 4.18, 164, 444);
INSERT INTO public.europe_data VALUES (8905, 1365, 27625, 79.16, 165, 444);
INSERT INTO public.europe_data VALUES (8906, 3, 352, 1.36, 23, 444);
INSERT INTO public.europe_data VALUES (8907, 0, 26, 189.88, 166, 444);
INSERT INTO public.europe_data VALUES (8908, 25, 379, 8.93, 167, 444);
INSERT INTO public.europe_data VALUES (8909, 0, 0, 1.76, 80, 444);
INSERT INTO public.europe_data VALUES (8910, 0, 2, 4.46, 81, 444);
INSERT INTO public.europe_data VALUES (8911, 1, 23, 46.03, 205, 444);
INSERT INTO public.europe_data VALUES (8912, 2, 86, 0.68, 82, 444);
INSERT INTO public.europe_data VALUES (8913, 3, 64, 268.35, 168, 444);
INSERT INTO public.europe_data VALUES (8914, 0, 129, 1.89, 24, 444);
INSERT INTO public.europe_data VALUES (8915, 0, 21, 1.93, 25, 444);
INSERT INTO public.europe_data VALUES (8916, 2, 16, 4.73, 83, 444);
INSERT INTO public.europe_data VALUES (8917, 3, 12, 0.16, 84, 444);
INSERT INTO public.europe_data VALUES (8918, 0, 1, 245.4, 169, 444);
INSERT INTO public.europe_data VALUES (8919, 3, 99, 2.65, 85, 444);
INSERT INTO public.europe_data VALUES (8920, 71, 714, 10.35, 170, 444);
INSERT INTO public.europe_data VALUES (8921, 4, 215, 190.76, 171, 444);
INSERT INTO public.europe_data VALUES (8922, 199, 5085, 0.59, 112, 444);
INSERT INTO public.europe_data VALUES (8923, 175, 1968, 1.09, 113, 444);
INSERT INTO public.europe_data VALUES (8924, 871, 13460, 40.26, 114, 444);
INSERT INTO public.europe_data VALUES (8925, 15, 391, 2.05, 115, 444);
INSERT INTO public.europe_data VALUES (8926, 176, 4544, 143.55, 172, 444);
INSERT INTO public.europe_data VALUES (8927, 1, 101, 219.89, 173, 444);
INSERT INTO public.europe_data VALUES (8928, 54, 2715, 80.97, 116, 444);
INSERT INTO public.europe_data VALUES (8929, 4012, 27415, 97.21, 174, 444);
INSERT INTO public.europe_data VALUES (8930, 1, 14, 1.29, 86, 444);
INSERT INTO public.europe_data VALUES (8931, 29, 3601, 4.25, 117, 444);
INSERT INTO public.europe_data VALUES (8932, 1, 58, 139.15, 175, 444);
INSERT INTO public.europe_data VALUES (8933, 2, 44, 1.29, 118, 444);
INSERT INTO public.europe_data VALUES (8934, 5, 430, 3.65, 119, 444);
INSERT INTO public.europe_data VALUES (8935, 4, 55, 0.29, 26, 444);
INSERT INTO public.europe_data VALUES (8936, 6, 197, 14.68, 176, 444);
INSERT INTO public.europe_data VALUES (8937, 0, 678, 23.27, 120, 444);
INSERT INTO public.europe_data VALUES (8938, 1, 203, 5.22, 121, 444);
INSERT INTO public.europe_data VALUES (8939, 0, 8, 0.18, 122, 444);
INSERT INTO public.europe_data VALUES (8940, 4, 118, 14.32, 177, 444);
INSERT INTO public.europe_data VALUES (8941, 2, 103, 2.8, 123, 444);
INSERT INTO public.europe_data VALUES (8942, 2, 37, 0.95, 28, 444);
INSERT INTO public.europe_data VALUES (8943, 0, 7, 0.25, 29, 444);
INSERT INTO public.europe_data VALUES (8944, 0, 2, 46.9, 178, 444);
INSERT INTO public.europe_data VALUES (8945, 11, 251, 20.69, 179, 444);
INSERT INTO public.europe_data VALUES (8946, 30, 477, 216.81, 180, 444);
INSERT INTO public.europe_data VALUES (8947, 0, 34, 0.26, 30, 444);
INSERT INTO public.europe_data VALUES (8948, 2, 9, 0.07, 31, 444);
INSERT INTO public.europe_data VALUES (8949, 15, 1021, 6.93, 124, 444);
INSERT INTO public.europe_data VALUES (8950, 0, 1, 0.57, 125, 444);
INSERT INTO public.europe_data VALUES (8951, 4, 71, 0.5, 32, 444);
INSERT INTO public.europe_data VALUES (8952, 3, 143, 46.2, 181, 444);
INSERT INTO public.europe_data VALUES (8953, 0, 1, 0.04, 33, 444);
INSERT INTO public.europe_data VALUES (8954, 2, 97, 16.85, 34, 444);
INSERT INTO public.europe_data VALUES (8955, 202, 3386, 4.29, 87, 444);
INSERT INTO public.europe_data VALUES (8956, 17, 798, 34.6, 182, 444);
INSERT INTO public.europe_data VALUES (8957, 1, 13, 87.65, 183, 444);
INSERT INTO public.europe_data VALUES (8958, 0, 2, 0.12, 126, 444);
INSERT INTO public.europe_data VALUES (8959, 1, 58, 30.06, 184, 444);
INSERT INTO public.europe_data VALUES (8960, 0, 5, 120.22, 88, 444);
INSERT INTO public.europe_data VALUES (8961, 48, 640, 3.24, 35, 444);
INSERT INTO public.europe_data VALUES (8962, 0, 11, 0.04, 36, 444);
INSERT INTO public.europe_data VALUES (8963, 3, 20, 0.06, 127, 444);
INSERT INTO public.europe_data VALUES (8964, 0, 0, 0.2, 37, 444);
INSERT INTO public.europe_data VALUES (8965, 0, 3, 0.02, 128, 444);
INSERT INTO public.europe_data VALUES (8966, 971, 7736, 85.18, 185, 444);
INSERT INTO public.europe_data VALUES (8967, 0, 0, 1.06, 208, 444);
INSERT INTO public.europe_data VALUES (8968, 4, 153, 10.7, 209, 444);
INSERT INTO public.europe_data VALUES (8969, 0, 4, 0.08, 89, 444);
INSERT INTO public.europe_data VALUES (8970, 2, 345, 2.23, 38, 444);
INSERT INTO public.europe_data VALUES (8971, 5, 91, 0.11, 39, 444);
INSERT INTO public.europe_data VALUES (8972, 17, 345, 27.39, 186, 444);
INSERT INTO public.europe_data VALUES (8973, 1, 3, 19.23, 210, 444);
INSERT INTO public.europe_data VALUES (8974, 45, 775, 43.41, 187, 444);
INSERT INTO public.europe_data VALUES (8975, 2, 301, 8.68, 129, 444);
INSERT INTO public.europe_data VALUES (8976, 43, 2097, 1.78, 130, 444);
INSERT INTO public.europe_data VALUES (8977, 1, 51, 3.25, 131, 444);
INSERT INTO public.europe_data VALUES (8978, 33, 1412, 56.78, 90, 444);
INSERT INTO public.europe_data VALUES (8979, 0, 1, 0.01, 211, 444);
INSERT INTO public.europe_data VALUES (8980, 1, 34, 1.18, 91, 444);
INSERT INTO public.europe_data VALUES (8981, 110, 5238, 20.51, 92, 444);
INSERT INTO public.europe_data VALUES (8982, 145, 1402, 2.99, 132, 444);
INSERT INTO public.europe_data VALUES (8983, 138, 2572, 12.67, 188, 444);
INSERT INTO public.europe_data VALUES (8984, 209, 5307, 103.37, 189, 444);
INSERT INTO public.europe_data VALUES (8985, 24, 422, 26.25, 93, 444);
INSERT INTO public.europe_data VALUES (8986, 3, 1375, 82.8, 133, 444);
INSERT INTO public.europe_data VALUES (8987, 158, 2436, 23.38, 190, 444);
INSERT INTO public.europe_data VALUES (8988, 85, 10381, 9.76, 191, 444);
INSERT INTO public.europe_data VALUES (8989, 0, 22, 0.44, 40, 444);
INSERT INTO public.europe_data VALUES (8990, 0, 2, 9.46, 94, 444);
INSERT INTO public.europe_data VALUES (8991, 0, 1, 3.28, 95, 444);
INSERT INTO public.europe_data VALUES (8992, 0, 5, 9.95, 96, 444);
INSERT INTO public.europe_data VALUES (8993, 3, 90, 368.62, 192, 444);
INSERT INTO public.europe_data VALUES (8994, 0, 4, 0, 41, 444);
INSERT INTO public.europe_data VALUES (8995, 25, 2077, 9.43, 134, 444);
INSERT INTO public.europe_data VALUES (8996, 0, 58, 0.85, 42, 444);
INSERT INTO public.europe_data VALUES (8997, 29, 1722, 41.49, 193, 444);
INSERT INTO public.europe_data VALUES (8998, 0, 0, 2.05, 43, 444);
INSERT INTO public.europe_data VALUES (8999, 0, 4, 0.13, 44, 444);
INSERT INTO public.europe_data VALUES (9000, 2, 1223, 29.08, 135, 444);
INSERT INTO public.europe_data VALUES (9001, 5, 25, 110.88, 97, 444);
INSERT INTO public.europe_data VALUES (9002, 2, 257, 7.45, 194, 444);
INSERT INTO public.europe_data VALUES (9003, 25, 208, 22.83, 195, 444);
INSERT INTO public.europe_data VALUES (9004, 2, 18, 0.14, 45, 444);
INSERT INTO public.europe_data VALUES (9005, 14, 518, 1.52, 46, 444);
INSERT INTO public.europe_data VALUES (9006, 31, 253, 1.71, 136, 444);
INSERT INTO public.europe_data VALUES (9007, 0, 3, 0.04, 47, 444);
INSERT INTO public.europe_data VALUES (9008, 4554, 32553, 167.95, 196, 444);
INSERT INTO public.europe_data VALUES (9009, 2, 44, 0.42, 137, 444);
INSERT INTO public.europe_data VALUES (9010, 0, 7, 0.03, 48, 444);
INSERT INTO public.europe_data VALUES (9011, 0, 0, 0.34, 98, 444);
INSERT INTO public.europe_data VALUES (9012, 664, 3739, 68.1, 197, 444);
INSERT INTO public.europe_data VALUES (9013, 299, 4198, 128.11, 198, 444);
INSERT INTO public.europe_data VALUES (9014, 0, 6, 0.09, 138, 444);
INSERT INTO public.europe_data VALUES (9015, 1, 25, 0.34, 139, 444);
INSERT INTO public.europe_data VALUES (9016, 14, 359, 1.71, 141, 444);
INSERT INTO public.europe_data VALUES (9017, 0, 1, 0.08, 142, 444);
INSERT INTO public.europe_data VALUES (9018, 0, 32, 0.57, 49, 444);
INSERT INTO public.europe_data VALUES (9019, 1, 9, 2.51, 99, 444);
INSERT INTO public.europe_data VALUES (9020, 12, 154, 3.67, 50, 444);
INSERT INTO public.europe_data VALUES (9021, 624, 29887, 58.15, 199, 444);
INSERT INTO public.europe_data VALUES (9022, 0, 4, 10.47, 100, 444);
INSERT INTO public.europe_data VALUES (9023, 0, 2, 0.05, 51, 444);
INSERT INTO public.europe_data VALUES (9024, 46, 1469, 5.36, 200, 444);
INSERT INTO public.europe_data VALUES (9025, 12, 2199, 34.92, 143, 444);
INSERT INTO public.europe_data VALUES (9026, 6440, 32205, 93.87, 201, 444);
INSERT INTO public.europe_data VALUES (9027, 2, 10, 0.03, 52, 444);
INSERT INTO public.europe_data VALUES (9028, 12461, 219936, 125.98, 101, 444);
INSERT INTO public.europe_data VALUES (9029, 0, 9, 20.08, 102, 444);
INSERT INTO public.europe_data VALUES (9030, 2, 58, 4.91, 103, 444);
INSERT INTO public.europe_data VALUES (9031, 2, 523, 2.18, 144, 444);
INSERT INTO public.europe_data VALUES (9032, 4, 33, 0.22, 104, 444);
INSERT INTO public.europe_data VALUES (9033, 0, 19, 0.06, 145, 444);
INSERT INTO public.europe_data VALUES (9034, 0, 1, 0, 146, 444);
INSERT INTO public.europe_data VALUES (9035, 1, 4, 0.08, 54, 444);
INSERT INTO public.europe_data VALUES (9036, 2, 5, 0.05, 55, 444);
INSERT INTO public.europe_data VALUES (9037, 3, 185, 0.7, 105, 445);
INSERT INTO public.europe_data VALUES (9038, 11, 149, 9.5, 147, 445);
INSERT INTO public.europe_data VALUES (9039, 121, 809, 2.6, 1, 445);
INSERT INTO public.europe_data VALUES (9040, 12, 167, 509.34, 148, 445);
INSERT INTO public.europe_data VALUES (9041, 0, 7, 0.04, 2, 445);
INSERT INTO public.europe_data VALUES (9042, 0, 1, 20.17, 56, 445);
INSERT INTO public.europe_data VALUES (9043, 0, 8, 14.42, 57, 445);
INSERT INTO public.europe_data VALUES (9044, 26, 734, 2.88, 58, 445);
INSERT INTO public.europe_data VALUES (9045, 5, 351, 21.6, 149, 445);
INSERT INTO public.europe_data VALUES (9046, 0, 14, 60.2, 59, 445);
INSERT INTO public.europe_data VALUES (9047, 20, 1651, 16.01, 202, 445);
INSERT INTO public.europe_data VALUES (9048, 118, 3170, 94.28, 150, 445);
INSERT INTO public.europe_data VALUES (9049, 3, 375, 5.17, 151, 445);
INSERT INTO public.europe_data VALUES (9050, 5, 15, 6.42, 60, 445);
INSERT INTO public.europe_data VALUES (9051, 0, 200, 22.3, 106, 445);
INSERT INTO public.europe_data VALUES (9052, 4, 39, 0.04, 107, 445);
INSERT INTO public.europe_data VALUES (9053, 1, 23, 13.59, 61, 445);
INSERT INTO public.europe_data VALUES (9054, 8, 470, 5.16, 152, 445);
INSERT INTO public.europe_data VALUES (9055, 1584, 9694, 155.59, 153, 445);
INSERT INTO public.europe_data VALUES (9056, 1, 3, 1.28, 62, 445);
INSERT INTO public.europe_data VALUES (9057, 0, 16, 0.17, 3, 445);
INSERT INTO public.europe_data VALUES (9058, 0, 15, 49.59, 63, 445);
INSERT INTO public.europe_data VALUES (9059, 0, 1, 0.39, 108, 445);
INSERT INTO public.europe_data VALUES (9060, 8, 87, 1.35, 64, 445);
INSERT INTO public.europe_data VALUES (9061, 0, 2, 0, 65, 445);
INSERT INTO public.europe_data VALUES (9062, 18, 340, 16.3, 154, 445);
INSERT INTO public.europe_data VALUES (9063, 1, 6, 0, 4, 445);
INSERT INTO public.europe_data VALUES (9064, 350, 6874, 4.54, 66, 445);
INSERT INTO public.europe_data VALUES (9065, 0, 1, 9.99, 67, 445);
INSERT INTO public.europe_data VALUES (9066, 0, 9, 10.85, 109, 445);
INSERT INTO public.europe_data VALUES (9067, 12, 185, 4.94, 155, 445);
INSERT INTO public.europe_data VALUES (9068, 8, 165, 1.38, 5, 445);
INSERT INTO public.europe_data VALUES (9069, 0, 3, 0, 6, 445);
INSERT INTO public.europe_data VALUES (9070, 0, 7, 0.17, 110, 445);
INSERT INTO public.europe_data VALUES (9071, 7, 551, 2.41, 7, 445);
INSERT INTO public.europe_data VALUES (9072, 219, 9241, 37.6, 68, 445);
INSERT INTO public.europe_data VALUES (9073, 0, 2, 0.73, 8, 445);
INSERT INTO public.europe_data VALUES (9074, 0, 31, 55.43, 69, 445);
INSERT INTO public.europe_data VALUES (9075, 0, 3, 0.11, 9, 445);
INSERT INTO public.europe_data VALUES (9076, 0, 4, 0.04, 10, 445);
INSERT INTO public.europe_data VALUES (9077, 27, 2332, 20.26, 70, 445);
INSERT INTO public.europe_data VALUES (9078, 29, 485, 0.08, 111, 445);
INSERT INTO public.europe_data VALUES (9079, 25, 783, 2.48, 71, 445);
INSERT INTO public.europe_data VALUES (9080, 5, 26, 0.76, 12, 445);
INSERT INTO public.europe_data VALUES (9081, 0, 140, 6.34, 72, 445);
INSERT INTO public.europe_data VALUES (9082, 2, 96, 0.92, 13, 445);
INSERT INTO public.europe_data VALUES (9083, 9, 469, 23.23, 156, 445);
INSERT INTO public.europe_data VALUES (9084, 5, 181, 2.51, 73, 445);
INSERT INTO public.europe_data VALUES (9085, 0, 2, 6.73, 74, 445);
INSERT INTO public.europe_data VALUES (9086, 3, 232, 40.07, 157, 445);
INSERT INTO public.europe_data VALUES (9087, 51, 1758, 32.13, 158, 445);
INSERT INTO public.europe_data VALUES (9088, 10, 73, 0.15, 14, 445);
INSERT INTO public.europe_data VALUES (9089, 107, 1974, 51.22, 159, 445);
INSERT INTO public.europe_data VALUES (9090, 0, 40, 5.96, 15, 445);
INSERT INTO public.europe_data VALUES (9091, 0, 3, 18.1, 75, 445);
INSERT INTO public.europe_data VALUES (9092, 43, 886, 14.37, 76, 445);
INSERT INTO public.europe_data VALUES (9093, 122, 1756, 16.44, 77, 445);
INSERT INTO public.europe_data VALUES (9094, 35, 494, 0.77, 16, 445);
INSERT INTO public.europe_data VALUES (9095, 3, 39, 1.02, 78, 445);
INSERT INTO public.europe_data VALUES (9096, 0, 2, 0.74, 17, 445);
INSERT INTO public.europe_data VALUES (9097, 0, 17, 0.8, 18, 445);
INSERT INTO public.europe_data VALUES (9098, 12, 418, 58.2, 160, 445);
INSERT INTO public.europe_data VALUES (9099, 0, 0, 0.44, 19, 445);
INSERT INTO public.europe_data VALUES (9100, 2, 27, 0.03, 20, 445);
INSERT INTO public.europe_data VALUES (9101, 0, 2, 0, 79, 445);
INSERT INTO public.europe_data VALUES (9102, 0, 22, 135.59, 161, 445);
INSERT INTO public.europe_data VALUES (9103, 0, 9, 1.24, 203, 445);
INSERT INTO public.europe_data VALUES (9104, 16, 709, 23.58, 162, 445);
INSERT INTO public.europe_data VALUES (9105, 5472, 30304, 81.27, 163, 445);
INSERT INTO public.europe_data VALUES (9106, 0, 6, 8.24, 204, 445);
INSERT INTO public.europe_data VALUES (9107, 0, 14, 0.69, 21, 445);
INSERT INTO public.europe_data VALUES (9108, 0, 1, 0.13, 22, 445);
INSERT INTO public.europe_data VALUES (9109, 2, 84, 3, 164, 445);
INSERT INTO public.europe_data VALUES (9110, 979, 38093, 85.06, 165, 445);
INSERT INTO public.europe_data VALUES (9111, 0, 62, 0.62, 23, 445);
INSERT INTO public.europe_data VALUES (9112, 0, 38, 261.08, 166, 445);
INSERT INTO public.europe_data VALUES (9113, 35, 579, 10.36, 167, 445);
INSERT INTO public.europe_data VALUES (9114, 0, 1, 15.88, 80, 445);
INSERT INTO public.europe_data VALUES (9115, 0, 3, 9.82, 81, 445);
INSERT INTO public.europe_data VALUES (9116, 3, 54, 49.61, 205, 445);
INSERT INTO public.europe_data VALUES (9117, 2, 34, 0.29, 82, 445);
INSERT INTO public.europe_data VALUES (9118, 3, 109, 212.51, 168, 445);
INSERT INTO public.europe_data VALUES (9119, 0, 113, 0.93, 24, 445);
INSERT INTO public.europe_data VALUES (9120, 0, 16, 0.94, 25, 445);
INSERT INTO public.europe_data VALUES (9121, 3, 21, 3.07, 83, 445);
INSERT INTO public.europe_data VALUES (9122, 0, 6, 0.17, 84, 445);
INSERT INTO public.europe_data VALUES (9123, 0, 1, 736.2, 169, 445);
INSERT INTO public.europe_data VALUES (9124, 19, 159, 2.78, 85, 445);
INSERT INTO public.europe_data VALUES (9125, 23, 297, 5.9, 170, 445);
INSERT INTO public.europe_data VALUES (9126, 2, 466, 257.15, 171, 445);
INSERT INTO public.europe_data VALUES (9127, 80, 2996, 0.27, 112, 445);
INSERT INTO public.europe_data VALUES (9128, 84, 988, 0.65, 113, 445);
INSERT INTO public.europe_data VALUES (9129, 963, 19917, 44.13, 114, 445);
INSERT INTO public.europe_data VALUES (9130, 19, 414, 1.85, 115, 445);
INSERT INTO public.europe_data VALUES (9131, 112, 2496, 85.74, 172, 445);
INSERT INTO public.europe_data VALUES (9132, 1, 85, 147.77, 173, 445);
INSERT INTO public.europe_data VALUES (9133, 34, 4183, 86.38, 116, 445);
INSERT INTO public.europe_data VALUES (9134, 5108, 31259, 115.66, 174, 445);
INSERT INTO public.europe_data VALUES (9135, 2, 24, 1.32, 86, 445);
INSERT INTO public.europe_data VALUES (9136, 19, 1788, 2.02, 117, 445);
INSERT INTO public.europe_data VALUES (9137, 1, 92, 129.87, 175, 445);
INSERT INTO public.europe_data VALUES (9138, 4, 86, 2.44, 118, 445);
INSERT INTO public.europe_data VALUES (9139, 4, 247, 2.54, 119, 445);
INSERT INTO public.europe_data VALUES (9140, 3, 100, 0.24, 26, 445);
INSERT INTO public.europe_data VALUES (9141, 0, 67, 7.34, 176, 445);
INSERT INTO public.europe_data VALUES (9142, 1, 301, 8.75, 120, 445);
INSERT INTO public.europe_data VALUES (9143, 4, 132, 3.15, 121, 445);
INSERT INTO public.europe_data VALUES (9144, 0, 5, 0.15, 122, 445);
INSERT INTO public.europe_data VALUES (9145, 1, 157, 20.52, 177, 445);
INSERT INTO public.europe_data VALUES (9146, 8, 89, 4.07, 123, 445);
INSERT INTO public.europe_data VALUES (9147, 3, 10, 0.2, 28, 445);
INSERT INTO public.europe_data VALUES (9148, 1, 10, 0.27, 29, 445);
INSERT INTO public.europe_data VALUES (9149, 1, 16, 83.38, 178, 445);
INSERT INTO public.europe_data VALUES (9150, 6, 327, 23.91, 179, 445);
INSERT INTO public.europe_data VALUES (9151, 15, 854, 326.77, 180, 445);
INSERT INTO public.europe_data VALUES (9152, 0, 35, 0.26, 30, 445);
INSERT INTO public.europe_data VALUES (9153, 0, 4, 0, 31, 445);
INSERT INTO public.europe_data VALUES (9154, 27, 1192, 7.37, 124, 445);
INSERT INTO public.europe_data VALUES (9155, 0, 2, 1.13, 125, 445);
INSERT INTO public.europe_data VALUES (9156, 5, 27, 0.23, 32, 445);
INSERT INTO public.europe_data VALUES (9157, 0, 85, 27.15, 181, 445);
INSERT INTO public.europe_data VALUES (9158, 1, 1, 0.09, 33, 445);
INSERT INTO public.europe_data VALUES (9159, 4, 117, 15.67, 34, 445);
INSERT INTO public.europe_data VALUES (9160, 74, 2083, 2.59, 87, 445);
INSERT INTO public.europe_data VALUES (9161, 13, 601, 19.04, 182, 445);
INSERT INTO public.europe_data VALUES (9162, 0, 16, 93.7, 183, 445);
INSERT INTO public.europe_data VALUES (9163, 0, 2, 0.12, 126, 445);
INSERT INTO public.europe_data VALUES (9164, 1, 129, 31.02, 184, 445);
INSERT INTO public.europe_data VALUES (9165, 0, 1, 100.18, 88, 445);
INSERT INTO public.europe_data VALUES (9166, 44, 542, 2.48, 35, 445);
INSERT INTO public.europe_data VALUES (9167, 0, 2, 0.03, 36, 445);
INSERT INTO public.europe_data VALUES (9168, 1, 13, 0.04, 127, 445);
INSERT INTO public.europe_data VALUES (9169, 0, 5, 0.52, 37, 445);
INSERT INTO public.europe_data VALUES (9170, 0, 4, 0.03, 128, 445);
INSERT INTO public.europe_data VALUES (9171, 995, 6985, 78.97, 185, 445);
INSERT INTO public.europe_data VALUES (9172, 0, 3, 4.6, 208, 445);
INSERT INTO public.europe_data VALUES (9173, 0, 359, 16.91, 209, 445);
INSERT INTO public.europe_data VALUES (9174, 0, 1, 0.05, 89, 445);
INSERT INTO public.europe_data VALUES (9175, 9, 174, 0.79, 38, 445);
INSERT INTO public.europe_data VALUES (9176, 4, 135, 0.1, 39, 445);
INSERT INTO public.europe_data VALUES (9177, 11, 224, 17.76, 186, 445);
INSERT INTO public.europe_data VALUES (9178, 1, 8, 0, 210, 445);
INSERT INTO public.europe_data VALUES (9179, 36, 1538, 65.84, 187, 445);
INSERT INTO public.europe_data VALUES (9180, 2, 131, 4.88, 129, 445);
INSERT INTO public.europe_data VALUES (9181, 37, 1751, 1.15, 130, 445);
INSERT INTO public.europe_data VALUES (9182, 0, 111, 3.17, 131, 445);
INSERT INTO public.europe_data VALUES (9183, 30, 999, 39.44, 90, 445);
INSERT INTO public.europe_data VALUES (9184, 0, 0, 0, 211, 445);
INSERT INTO public.europe_data VALUES (9185, 2, 49, 1.29, 91, 445);
INSERT INTO public.europe_data VALUES (9186, 65, 1429, 5.9, 92, 445);
INSERT INTO public.europe_data VALUES (9187, 81, 1828, 2.65, 132, 445);
INSERT INTO public.europe_data VALUES (9188, 72, 2240, 9.13, 188, 445);
INSERT INTO public.europe_data VALUES (9189, 176, 5316, 94.17, 189, 445);
INSERT INTO public.europe_data VALUES (9190, 15, 348, 16.19, 93, 445);
INSERT INTO public.europe_data VALUES (9191, 3, 970, 39.19, 133, 445);
INSERT INTO public.europe_data VALUES (9192, 108, 2104, 17.67, 190, 445);
INSERT INTO public.europe_data VALUES (9193, 37, 3855, 3.44, 191, 445);
INSERT INTO public.europe_data VALUES (9194, 0, 34, 0.67, 40, 445);
INSERT INTO public.europe_data VALUES (9195, 0, 3, 18.93, 94, 445);
INSERT INTO public.europe_data VALUES (9196, 0, 5, 6.56, 95, 445);
INSERT INTO public.europe_data VALUES (9197, 0, 6, 6.33, 96, 445);
INSERT INTO public.europe_data VALUES (9198, 8, 37, 333.79, 192, 445);
INSERT INTO public.europe_data VALUES (9199, 26, 1156, 5.47, 134, 445);
INSERT INTO public.europe_data VALUES (9200, 2, 80, 0.95, 42, 445);
INSERT INTO public.europe_data VALUES (9201, 38, 1167, 24.7, 193, 445);
INSERT INTO public.europe_data VALUES (9202, 0, 2, 3.07, 43, 445);
INSERT INTO public.europe_data VALUES (9203, 0, 6, 0, 44, 445);
INSERT INTO public.europe_data VALUES (9204, 3, 465, 14.71, 135, 445);
INSERT INTO public.europe_data VALUES (9205, 4, 22, 58.98, 97, 445);
INSERT INTO public.europe_data VALUES (9206, 0, 149, 5.5, 194, 445);
INSERT INTO public.europe_data VALUES (9207, 17, 267, 28.02, 195, 445);
INSERT INTO public.europe_data VALUES (9208, 0, 4, 0.04, 45, 445);
INSERT INTO public.europe_data VALUES (9209, 9, 375, 2.36, 46, 445);
INSERT INTO public.europe_data VALUES (9210, 28, 623, 2.58, 136, 445);
INSERT INTO public.europe_data VALUES (9211, 0, 1, 0, 47, 445);
INSERT INTO public.europe_data VALUES (9212, 5890, 46276, 215.47, 196, 445);
INSERT INTO public.europe_data VALUES (9213, 4, 46, 0.37, 137, 445);
INSERT INTO public.europe_data VALUES (9214, 1, 7, 0.02, 48, 445);
INSERT INTO public.europe_data VALUES (9215, 1, 2, 0.86, 98, 445);
INSERT INTO public.europe_data VALUES (9216, 451, 3228, 50.68, 197, 445);
INSERT INTO public.europe_data VALUES (9217, 302, 6748, 164.44, 198, 445);
INSERT INTO public.europe_data VALUES (9218, 1, 10, 0.11, 138, 445);
INSERT INTO public.europe_data VALUES (9219, 0, 57, 0.83, 139, 445);
INSERT INTO public.europe_data VALUES (9220, 19, 832, 2.15, 141, 445);
INSERT INTO public.europe_data VALUES (9221, 0, 0, 0, 142, 445);
INSERT INTO public.europe_data VALUES (9222, 2, 14, 0.36, 49, 445);
INSERT INTO public.europe_data VALUES (9223, 4, 26, 3.87, 99, 445);
INSERT INTO public.europe_data VALUES (9224, 11, 275, 4.09, 50, 445);
INSERT INTO public.europe_data VALUES (9225, 443, 17798, 31.5, 199, 445);
INSERT INTO public.europe_data VALUES (9226, 1, 0, 13.09, 100, 445);
INSERT INTO public.europe_data VALUES (9227, 0, 19, 0.12, 51, 445);
INSERT INTO public.europe_data VALUES (9228, 28, 890, 2.87, 200, 445);
INSERT INTO public.europe_data VALUES (9229, 7, 1213, 16.68, 143, 445);
INSERT INTO public.europe_data VALUES (9230, 4197, 30357, 72.39, 201, 445);
INSERT INTO public.europe_data VALUES (9231, 0, 8, 0.02, 52, 445);
INSERT INTO public.europe_data VALUES (9232, 7138, 194610, 91.91, 101, 445);
INSERT INTO public.europe_data VALUES (9233, 1, 12, 40.16, 102, 445);
INSERT INTO public.europe_data VALUES (9234, 5, 112, 7.19, 103, 445);
INSERT INTO public.europe_data VALUES (9235, 1, 197, 0.9, 144, 445);
INSERT INTO public.europe_data VALUES (9236, 4, 29, 0.39, 104, 445);
INSERT INTO public.europe_data VALUES (9237, 0, 42, 0.13, 145, 445);
INSERT INTO public.europe_data VALUES (9238, 1, 10, 0.2, 54, 445);
INSERT INTO public.europe_data VALUES (9239, 0, 2, 0.05, 55, 445);
INSERT INTO public.europe_data VALUES (9240, 4, 80, 0.26, 105, 446);
INSERT INTO public.europe_data VALUES (9241, 8, 123, 5.94, 147, 446);
INSERT INTO public.europe_data VALUES (9242, 14, 310, 1.08, 1, 446);
INSERT INTO public.europe_data VALUES (9243, 6, 221, 431.89, 148, 446);
INSERT INTO public.europe_data VALUES (9244, 2, 5, 0.02, 2, 446);
INSERT INTO public.europe_data VALUES (9245, 0, 2, 0, 56, 446);
INSERT INTO public.europe_data VALUES (9246, 0, 6, 7.21, 57, 446);
INSERT INTO public.europe_data VALUES (9247, 16, 554, 1.71, 58, 446);
INSERT INTO public.europe_data VALUES (9248, 3, 288, 15.35, 149, 446);
INSERT INTO public.europe_data VALUES (9249, 0, 50, 0, 59, 446);
INSERT INTO public.europe_data VALUES (9250, 9, 2384, 15.06, 202, 446);
INSERT INTO public.europe_data VALUES (9251, 70, 5182, 89.78, 150, 446);
INSERT INTO public.europe_data VALUES (9252, 3, 144, 1.89, 151, 446);
INSERT INTO public.europe_data VALUES (9253, 0, 10, 3.34, 60, 446);
INSERT INTO public.europe_data VALUES (9254, 2, 166, 17.43, 106, 446);
INSERT INTO public.europe_data VALUES (9255, 2, 22, 0.03, 107, 446);
INSERT INTO public.europe_data VALUES (9256, 0, 16, 11.5, 61, 446);
INSERT INTO public.europe_data VALUES (9257, 0, 18, 0.71, 152, 446);
INSERT INTO public.europe_data VALUES (9258, 782, 8130, 103.03, 153, 446);
INSERT INTO public.europe_data VALUES (9259, 0, 2, 0, 62, 446);
INSERT INTO public.europe_data VALUES (9260, 0, 4, 0.05, 3, 446);
INSERT INTO public.europe_data VALUES (9261, 0, 16, 35.2, 63, 446);
INSERT INTO public.europe_data VALUES (9262, 0, 2, 0.52, 108, 446);
INSERT INTO public.europe_data VALUES (9263, 3, 69, 0.83, 64, 446);
INSERT INTO public.europe_data VALUES (9264, 5, 198, 9.24, 154, 446);
INSERT INTO public.europe_data VALUES (9265, 111, 2710, 1.92, 66, 446);
INSERT INTO public.europe_data VALUES (9266, 0, 2, 0, 67, 446);
INSERT INTO public.europe_data VALUES (9267, 1, 38, 17.54, 109, 446);
INSERT INTO public.europe_data VALUES (9268, 5, 161, 4.21, 155, 446);
INSERT INTO public.europe_data VALUES (9269, 6, 116, 0.87, 5, 446);
INSERT INTO public.europe_data VALUES (9270, 0, 21, 0.58, 110, 446);
INSERT INTO public.europe_data VALUES (9271, 2, 72, 0.37, 7, 446);
INSERT INTO public.europe_data VALUES (9272, 41, 4825, 15.91, 68, 446);
INSERT INTO public.europe_data VALUES (9273, 1, 2, 0.91, 8, 446);
INSERT INTO public.europe_data VALUES (9274, 0, 5, 12.32, 69, 446);
INSERT INTO public.europe_data VALUES (9275, 0, 2, 0.11, 9, 446);
INSERT INTO public.europe_data VALUES (9276, 0, 3, 0.03, 10, 446);
INSERT INTO public.europe_data VALUES (9277, 6, 1507, 10.89, 70, 446);
INSERT INTO public.europe_data VALUES (9278, 32, 673, 0.08, 111, 446);
INSERT INTO public.europe_data VALUES (9279, 8, 467, 1.31, 71, 446);
INSERT INTO public.europe_data VALUES (9280, 0, 15, 0.33, 12, 446);
INSERT INTO public.europe_data VALUES (9281, 0, 180, 5.53, 72, 446);
INSERT INTO public.europe_data VALUES (9282, 1, 140, 0.63, 13, 446);
INSERT INTO public.europe_data VALUES (9283, 6, 478, 16.31, 156, 446);
INSERT INTO public.europe_data VALUES (9284, 2, 104, 1.23, 73, 446);
INSERT INTO public.europe_data VALUES (9285, 1, 9, 0, 74, 446);
INSERT INTO public.europe_data VALUES (9286, 6, 119, 21.01, 157, 446);
INSERT INTO public.europe_data VALUES (9287, 15, 1664, 23.77, 158, 446);
INSERT INTO public.europe_data VALUES (9288, 6, 55, 0.09, 14, 446);
INSERT INTO public.europe_data VALUES (9289, 59, 1000, 26.18, 159, 446);
INSERT INTO public.europe_data VALUES (9290, 0, 18, 1.95, 15, 446);
INSERT INTO public.europe_data VALUES (9291, 0, 10, 15.32, 75, 446);
INSERT INTO public.europe_data VALUES (9292, 36, 657, 7.9, 76, 446);
INSERT INTO public.europe_data VALUES (9293, 44, 1101, 10.67, 77, 446);
INSERT INTO public.europe_data VALUES (9294, 26, 282, 0.46, 16, 446);
INSERT INTO public.europe_data VALUES (9295, 0, 27, 0.46, 78, 446);
INSERT INTO public.europe_data VALUES (9296, 0, 8, 0.96, 17, 446);
INSERT INTO public.europe_data VALUES (9297, 0, 11, 0.34, 18, 446);
INSERT INTO public.europe_data VALUES (9298, 3, 353, 38.34, 160, 446);
INSERT INTO public.europe_data VALUES (9299, 0, 5, 0.7, 19, 446);
INSERT INTO public.europe_data VALUES (9300, 0, 5, 0.01, 20, 446);
INSERT INTO public.europe_data VALUES (9301, 0, 44, 308.15, 161, 446);
INSERT INTO public.europe_data VALUES (9302, 0, 2, 0.56, 203, 446);
INSERT INTO public.europe_data VALUES (9303, 10, 592, 17.23, 162, 446);
INSERT INTO public.europe_data VALUES (9304, 1932, 24156, 51.86, 163, 446);
INSERT INTO public.europe_data VALUES (9305, 0, 17, 12.53, 204, 446);
INSERT INTO public.europe_data VALUES (9306, 0, 1, 0.28, 21, 446);
INSERT INTO public.europe_data VALUES (9307, 1, 2, 0.13, 22, 446);
INSERT INTO public.europe_data VALUES (9308, 0, 36, 1.5, 164, 446);
INSERT INTO public.europe_data VALUES (9309, 361, 32524, 63.19, 165, 446);
INSERT INTO public.europe_data VALUES (9310, 4, 128, 0.49, 23, 446);
INSERT INTO public.europe_data VALUES (9311, 0, 50, 192.84, 166, 446);
INSERT INTO public.europe_data VALUES (9312, 23, 532, 7.69, 167, 446);
INSERT INTO public.europe_data VALUES (9313, 0, 8, 17.65, 80, 446);
INSERT INTO public.europe_data VALUES (9314, 0, 8, 8.04, 81, 446);
INSERT INTO public.europe_data VALUES (9315, 0, 29, 33.47, 205, 446);
INSERT INTO public.europe_data VALUES (9316, 0, 17, 0.2, 82, 446);
INSERT INTO public.europe_data VALUES (9317, 0, 28, 69.8, 168, 446);
INSERT INTO public.europe_data VALUES (9318, 0, 6, 0.06, 24, 446);
INSERT INTO public.europe_data VALUES (9319, 0, 2, 0, 25, 446);
INSERT INTO public.europe_data VALUES (9320, 0, 3, 0.51, 83, 446);
INSERT INTO public.europe_data VALUES (9321, 0, 13, 0.13, 84, 446);
INSERT INTO public.europe_data VALUES (9322, 0, 5, 613.5, 169, 446);
INSERT INTO public.europe_data VALUES (9323, 3, 112, 1.36, 85, 446);
INSERT INTO public.europe_data VALUES (9324, 8, 280, 4.17, 170, 446);
INSERT INTO public.europe_data VALUES (9325, 1, 452, 235.86, 171, 446);
INSERT INTO public.europe_data VALUES (9326, 22, 632, 0.07, 112, 446);
INSERT INTO public.europe_data VALUES (9327, 66, 771, 0.43, 113, 446);
INSERT INTO public.europe_data VALUES (9328, 955, 16671, 29.39, 114, 446);
INSERT INTO public.europe_data VALUES (9329, 22, 314, 1.08, 115, 446);
INSERT INTO public.europe_data VALUES (9330, 42, 1709, 49.88, 172, 446);
INSERT INTO public.europe_data VALUES (9331, 0, 40, 49.65, 173, 446);
INSERT INTO public.europe_data VALUES (9332, 14, 3176, 46.92, 116, 446);
INSERT INTO public.europe_data VALUES (9333, 5305, 38551, 122.12, 174, 446);
INSERT INTO public.europe_data VALUES (9334, 1, 15, 0.81, 86, 446);
INSERT INTO public.europe_data VALUES (9335, 13, 777, 0.83, 117, 446);
INSERT INTO public.europe_data VALUES (9336, 2, 48, 58.44, 175, 446);
INSERT INTO public.europe_data VALUES (9337, 1, 160, 2.42, 118, 446);
INSERT INTO public.europe_data VALUES (9338, 1, 224, 1.48, 119, 446);
INSERT INTO public.europe_data VALUES (9339, 1, 27, 0.07, 26, 446);
INSERT INTO public.europe_data VALUES (9340, 0, 65, 4.73, 176, 446);
INSERT INTO public.europe_data VALUES (9341, 0, 67, 3.4, 120, 446);
INSERT INTO public.europe_data VALUES (9342, 0, 70, 1.31, 121, 446);
INSERT INTO public.europe_data VALUES (9343, 0, 6, 0, 122, 446);
INSERT INTO public.europe_data VALUES (9344, 0, 237, 17.97, 177, 446);
INSERT INTO public.europe_data VALUES (9345, 6, 190, 4.94, 123, 446);
INSERT INTO public.europe_data VALUES (9346, 0, 0, 0.06, 28, 446);
INSERT INTO public.europe_data VALUES (9347, 0, 8, 0, 29, 446);
INSERT INTO public.europe_data VALUES (9348, 0, 16, 143.31, 178, 446);
INSERT INTO public.europe_data VALUES (9349, 6, 341, 16.82, 179, 446);
INSERT INTO public.europe_data VALUES (9350, 13, 1152, 305.1, 180, 446);
INSERT INTO public.europe_data VALUES (9351, 0, 34, 0.14, 30, 446);
INSERT INTO public.europe_data VALUES (9352, 24, 1164, 6.39, 124, 446);
INSERT INTO public.europe_data VALUES (9353, 0, 4, 0.75, 125, 446);
INSERT INTO public.europe_data VALUES (9354, 0, 18, 0, 32, 446);
INSERT INTO public.europe_data VALUES (9355, 0, 49, 25.53, 181, 446);
INSERT INTO public.europe_data VALUES (9356, 0, 3, 0.09, 33, 446);
INSERT INTO public.europe_data VALUES (9357, 1, 82, 8.66, 34, 446);
INSERT INTO public.europe_data VALUES (9358, 18, 1221, 1.47, 87, 446);
INSERT INTO public.europe_data VALUES (9359, 1, 169, 5.94, 182, 446);
INSERT INTO public.europe_data VALUES (9360, 0, 15, 78.59, 183, 446);
INSERT INTO public.europe_data VALUES (9361, 0, 2, 0.37, 126, 446);
INSERT INTO public.europe_data VALUES (9362, 1, 64, 13.66, 184, 446);
INSERT INTO public.europe_data VALUES (9363, 0, 4, 100.18, 88, 446);
INSERT INTO public.europe_data VALUES (9364, 22, 364, 1.24, 35, 446);
INSERT INTO public.europe_data VALUES (9365, 0, 7, 0.03, 36, 446);
INSERT INTO public.europe_data VALUES (9366, 0, 8, 0, 127, 446);
INSERT INTO public.europe_data VALUES (9367, 0, 8, 0.36, 37, 446);
INSERT INTO public.europe_data VALUES (9368, 0, 4, 0.01, 128, 446);
INSERT INTO public.europe_data VALUES (9369, 592, 6662, 56.31, 185, 446);
INSERT INTO public.europe_data VALUES (9370, 0, 10, 5.3, 208, 446);
INSERT INTO public.europe_data VALUES (9371, 1, 450, 11.37, 209, 446);
INSERT INTO public.europe_data VALUES (9372, 1, 2, 0.06, 89, 446);
INSERT INTO public.europe_data VALUES (9373, 1, 9, 0.04, 38, 446);
INSERT INTO public.europe_data VALUES (9374, 1, 67, 0.05, 39, 446);
INSERT INTO public.europe_data VALUES (9375, 5, 145, 11.84, 186, 446);
INSERT INTO public.europe_data VALUES (9376, 15, 1970, 56.77, 187, 446);
INSERT INTO public.europe_data VALUES (9377, 0, 112, 2.91, 129, 446);
INSERT INTO public.europe_data VALUES (9378, 8, 742, 0.69, 130, 446);
INSERT INTO public.europe_data VALUES (9379, 1, 47, 1.37, 131, 446);
INSERT INTO public.europe_data VALUES (9380, 21, 676, 22.28, 90, 446);
INSERT INTO public.europe_data VALUES (9381, 0, 0, 0.01, 211, 446);
INSERT INTO public.europe_data VALUES (9382, 2, 42, 0.79, 91, 446);
INSERT INTO public.europe_data VALUES (9383, 13, 489, 2.4, 92, 446);
INSERT INTO public.europe_data VALUES (9384, 46, 1038, 1.18, 132, 446);
INSERT INTO public.europe_data VALUES (9385, 15, 1228, 4.57, 188, 446);
INSERT INTO public.europe_data VALUES (9386, 105, 4362, 55.63, 189, 446);
INSERT INTO public.europe_data VALUES (9387, 5, 127, 0, 93, 446);
INSERT INTO public.europe_data VALUES (9388, 1, 140, 8.23, 133, 446);
INSERT INTO public.europe_data VALUES (9389, 38, 1327, 8.35, 190, 446);
INSERT INTO public.europe_data VALUES (9390, 8, 1167, 1.01, 191, 446);
INSERT INTO public.europe_data VALUES (9391, 0, 51, 0.51, 40, 446);
INSERT INTO public.europe_data VALUES (9392, 0, 7, 0, 94, 446);
INSERT INTO public.europe_data VALUES (9393, 0, 7, 3.83, 95, 446);
INSERT INTO public.europe_data VALUES (9394, 0, 1, 0, 96, 446);
INSERT INTO public.europe_data VALUES (9395, 4, 78, 380.23, 192, 446);
INSERT INTO public.europe_data VALUES (9396, 8, 718, 3.24, 134, 446);
INSERT INTO public.europe_data VALUES (9397, 0, 75, 0.71, 42, 446);
INSERT INTO public.europe_data VALUES (9398, 12, 553, 9.85, 193, 446);
INSERT INTO public.europe_data VALUES (9399, 0, 1, 5.12, 43, 446);
INSERT INTO public.europe_data VALUES (9400, 1, 389, 10.65, 135, 446);
INSERT INTO public.europe_data VALUES (9401, 0, 3, 0, 97, 446);
INSERT INTO public.europe_data VALUES (9402, 0, 151, 5.05, 194, 446);
INSERT INTO public.europe_data VALUES (9403, 10, 316, 24.56, 195, 446);
INSERT INTO public.europe_data VALUES (9404, 0, 2, 0.02, 45, 446);
INSERT INTO public.europe_data VALUES (9405, 2, 1006, 2.1, 46, 446);
INSERT INTO public.europe_data VALUES (9406, 45, 700, 2.78, 136, 446);
INSERT INTO public.europe_data VALUES (9407, 4808, 54860, 180.31, 196, 446);
INSERT INTO public.europe_data VALUES (9408, 1, 33, 0.47, 137, 446);
INSERT INTO public.europe_data VALUES (9409, 0, 3, 0.01, 48, 446);
INSERT INTO public.europe_data VALUES (9410, 0, 3, 1.38, 98, 446);
INSERT INTO public.europe_data VALUES (9411, 190, 1957, 28.16, 197, 446);
INSERT INTO public.europe_data VALUES (9412, 197, 7303, 141.31, 198, 446);
INSERT INTO public.europe_data VALUES (9413, 1, 8, 0.05, 138, 446);
INSERT INTO public.europe_data VALUES (9414, 3, 141, 1.04, 139, 446);
INSERT INTO public.europe_data VALUES (9415, 6, 667, 1.83, 141, 446);
INSERT INTO public.europe_data VALUES (9416, 0, 0, 0.08, 142, 446);
INSERT INTO public.europe_data VALUES (9417, 1, 15, 0.36, 49, 446);
INSERT INTO public.europe_data VALUES (9418, 3, 28, 5.3, 99, 446);
INSERT INTO public.europe_data VALUES (9419, 5, 203, 2.22, 50, 446);
INSERT INTO public.europe_data VALUES (9420, 101, 8035, 11.28, 199, 446);
INSERT INTO public.europe_data VALUES (9421, 0, 5, 0, 100, 446);
INSERT INTO public.europe_data VALUES (9422, 0, 32, 0.07, 51, 446);
INSERT INTO public.europe_data VALUES (9423, 6, 371, 0.94, 200, 446);
INSERT INTO public.europe_data VALUES (9424, 1, 417, 4.83, 143, 446);
INSERT INTO public.europe_data VALUES (9425, 1388, 17889, 36.34, 201, 446);
INSERT INTO public.europe_data VALUES (9426, 1, 2, 0.02, 52, 446);
INSERT INTO public.europe_data VALUES (9427, 2038, 107819, 42.32, 101, 446);
INSERT INTO public.europe_data VALUES (9428, 0, 30, 0, 102, 446);
INSERT INTO public.europe_data VALUES (9429, 1, 137, 8.29, 103, 446);
INSERT INTO public.europe_data VALUES (9430, 1, 99, 0.42, 144, 446);
INSERT INTO public.europe_data VALUES (9431, 1, 83, 0.36, 104, 446);
INSERT INTO public.europe_data VALUES (9432, 0, 82, 0.15, 145, 446);
INSERT INTO public.europe_data VALUES (9433, 0, 26, 0.16, 54, 446);
INSERT INTO public.europe_data VALUES (9434, 1, 5, 0.05, 55, 446);
INSERT INTO public.europe_data VALUES (9435, 0, 18, 0.08, 105, 447);
INSERT INTO public.europe_data VALUES (9436, 1, 47, 3.04, 147, 447);
INSERT INTO public.europe_data VALUES (9437, 13, 153, 0.42, 1, 447);
INSERT INTO public.europe_data VALUES (9438, 0, 108, 148.34, 148, 447);
INSERT INTO public.europe_data VALUES (9439, 0, 2, 0, 2, 447);
INSERT INTO public.europe_data VALUES (9440, 0, 1, 0, 57, 447);
INSERT INTO public.europe_data VALUES (9441, 2, 210, 0.57, 58, 447);
INSERT INTO public.europe_data VALUES (9442, 0, 166, 6.53, 149, 447);
INSERT INTO public.europe_data VALUES (9443, 2, 1411, 6.46, 202, 447);
INSERT INTO public.europe_data VALUES (9444, 15, 2771, 39.84, 150, 447);
INSERT INTO public.europe_data VALUES (9445, 1, 46, 0.56, 151, 447);
INSERT INTO public.europe_data VALUES (9446, 0, 3, 1.03, 60, 447);
INSERT INTO public.europe_data VALUES (9447, 2, 120, 15.54, 106, 447);
INSERT INTO public.europe_data VALUES (9448, 3, 24, 0.01, 107, 447);
INSERT INTO public.europe_data VALUES (9449, 0, 17, 0, 61, 447);
INSERT INTO public.europe_data VALUES (9450, 0, 49, 0.74, 152, 447);
INSERT INTO public.europe_data VALUES (9451, 198, 3673, 43.83, 153, 447);
INSERT INTO public.europe_data VALUES (9452, 0, 2, 0, 3, 447);
INSERT INTO public.europe_data VALUES (9453, 0, 6, 0, 63, 447);
INSERT INTO public.europe_data VALUES (9454, 0, 2, 0, 108, 447);
INSERT INTO public.europe_data VALUES (9455, 0, 27, 0, 64, 447);
INSERT INTO public.europe_data VALUES (9456, 1, 107, 3.79, 154, 447);
INSERT INTO public.europe_data VALUES (9457, 25, 1346, 0.72, 66, 447);
INSERT INTO public.europe_data VALUES (9458, 0, 38, 20.31, 109, 447);
INSERT INTO public.europe_data VALUES (9459, 1, 134, 2.59, 155, 447);
INSERT INTO public.europe_data VALUES (9460, 3, 61, 0.31, 5, 447);
INSERT INTO public.europe_data VALUES (9461, 0, 74, 0.51, 110, 447);
INSERT INTO public.europe_data VALUES (9462, 0, 23, 0.1, 7, 447);
INSERT INTO public.europe_data VALUES (9463, 19, 1126, 3.66, 68, 447);
INSERT INTO public.europe_data VALUES (9464, 0, 3, 0, 8, 447);
INSERT INTO public.europe_data VALUES (9465, 1, 3, 0, 69, 447);
INSERT INTO public.europe_data VALUES (9466, 0, 3, 0.08, 9, 447);
INSERT INTO public.europe_data VALUES (9467, 0, 2, 0, 10, 447);
INSERT INTO public.europe_data VALUES (9468, 1, 557, 3.28, 70, 447);
INSERT INTO public.europe_data VALUES (9469, 58, 464, 0.04, 111, 447);
INSERT INTO public.europe_data VALUES (9470, 2, 190, 0.47, 71, 447);
INSERT INTO public.europe_data VALUES (9471, 0, 3, 0.07, 12, 447);
INSERT INTO public.europe_data VALUES (9472, 2, 99, 2.56, 72, 447);
INSERT INTO public.europe_data VALUES (9473, 0, 21, 0.1, 13, 447);
INSERT INTO public.europe_data VALUES (9474, 0, 187, 5.47, 156, 447);
INSERT INTO public.europe_data VALUES (9475, 1, 35, 0, 73, 447);
INSERT INTO public.europe_data VALUES (9476, 0, 65, 10.85, 157, 447);
INSERT INTO public.europe_data VALUES (9477, 1, 867, 10.64, 158, 447);
INSERT INTO public.europe_data VALUES (9478, 2, 24, 0.03, 14, 447);
INSERT INTO public.europe_data VALUES (9479, 12, 520, 23.37, 159, 447);
INSERT INTO public.europe_data VALUES (9480, 0, 1, 0, 15, 447);
INSERT INTO public.europe_data VALUES (9481, 0, 1, 0, 75, 447);
INSERT INTO public.europe_data VALUES (9482, 3, 191, 1.86, 76, 447);
INSERT INTO public.europe_data VALUES (9483, 12, 752, 4.46, 77, 447);
INSERT INTO public.europe_data VALUES (9484, 8, 184, 0.24, 16, 447);
INSERT INTO public.europe_data VALUES (9485, 0, 3, 0, 78, 447);
INSERT INTO public.europe_data VALUES (9486, 0, 5, 0.44, 17, 447);
INSERT INTO public.europe_data VALUES (9487, 0, 1, 0, 18, 447);
INSERT INTO public.europe_data VALUES (9488, 0, 155, 23.85, 160, 447);
INSERT INTO public.europe_data VALUES (9489, 0, 3, 0.35, 19, 447);
INSERT INTO public.europe_data VALUES (9490, 0, 7, 0.01, 20, 447);
INSERT INTO public.europe_data VALUES (9491, 0, 106, 230.09, 161, 447);
INSERT INTO public.europe_data VALUES (9492, 0, 3, 0, 203, 447);
INSERT INTO public.europe_data VALUES (9493, 1, 359, 10.8, 162, 447);
INSERT INTO public.europe_data VALUES (9494, 547, 10595, 22.22, 163, 447);
INSERT INTO public.europe_data VALUES (9495, 0, 18, 0, 204, 447);
INSERT INTO public.europe_data VALUES (9496, 1, 5, 0.28, 21, 447);
INSERT INTO public.europe_data VALUES (9497, 0, 1, 0, 22, 447);
INSERT INTO public.europe_data VALUES (9498, 0, 24, 1.03, 164, 447);
INSERT INTO public.europe_data VALUES (9499, 82, 19936, 28.75, 165, 447);
INSERT INTO public.europe_data VALUES (9500, 1, 22, 0.08, 23, 447);
INSERT INTO public.europe_data VALUES (9501, 0, 15, 0, 166, 447);
INSERT INTO public.europe_data VALUES (9502, 11, 293, 5.14, 167, 447);
INSERT INTO public.europe_data VALUES (9503, 0, 2, 0, 80, 447);
INSERT INTO public.europe_data VALUES (9504, 0, 1, 0, 81, 447);
INSERT INTO public.europe_data VALUES (9505, 1, 27, 0, 205, 447);
INSERT INTO public.europe_data VALUES (9506, 0, 18, 0.11, 82, 447);
INSERT INTO public.europe_data VALUES (9507, 0, 17, 0, 168, 447);
INSERT INTO public.europe_data VALUES (9508, 0, 2, 0, 24, 447);
INSERT INTO public.europe_data VALUES (9509, 0, 1, 0.64, 83, 447);
INSERT INTO public.europe_data VALUES (9510, 0, 2, 0, 84, 447);
INSERT INTO public.europe_data VALUES (9511, 0, 0, 122.7, 169, 447);
INSERT INTO public.europe_data VALUES (9512, 0, 21, 0.28, 85, 447);
INSERT INTO public.europe_data VALUES (9513, 6, 128, 1.63, 170, 447);
INSERT INTO public.europe_data VALUES (9514, 1, 390, 143.7, 171, 447);
INSERT INTO public.europe_data VALUES (9515, 5, 346, 0.03, 112, 447);
INSERT INTO public.europe_data VALUES (9516, 43, 397, 0.19, 113, 447);
INSERT INTO public.europe_data VALUES (9517, 961, 7700, 18.18, 114, 447);
INSERT INTO public.europe_data VALUES (9518, 11, 109, 0.44, 115, 447);
INSERT INTO public.europe_data VALUES (9519, 2, 737, 18.05, 172, 447);
INSERT INTO public.europe_data VALUES (9520, 0, 2, 0, 173, 447);
INSERT INTO public.europe_data VALUES (9521, 1, 821, 12.11, 116, 447);
INSERT INTO public.europe_data VALUES (9522, 3665, 35158, 85.76, 174, 447);
INSERT INTO public.europe_data VALUES (9523, 0, 9, 0.64, 86, 447);
INSERT INTO public.europe_data VALUES (9524, 17, 275, 0.47, 117, 447);
INSERT INTO public.europe_data VALUES (9525, 0, 15, 0, 175, 447);
INSERT INTO public.europe_data VALUES (9526, 0, 84, 0.98, 118, 447);
INSERT INTO public.europe_data VALUES (9527, 0, 51, 0.32, 119, 447);
INSERT INTO public.europe_data VALUES (9528, 0, 12, 0.03, 26, 447);
INSERT INTO public.europe_data VALUES (9529, 1, 20, 1.83, 176, 447);
INSERT INTO public.europe_data VALUES (9530, 0, 76, 2.95, 120, 447);
INSERT INTO public.europe_data VALUES (9531, 0, 14, 0, 121, 447);
INSERT INTO public.europe_data VALUES (9532, 0, 108, 7.08, 177, 447);
INSERT INTO public.europe_data VALUES (9533, 1, 149, 3.15, 123, 447);
INSERT INTO public.europe_data VALUES (9534, 0, 3, 0, 28, 447);
INSERT INTO public.europe_data VALUES (9535, 0, 39, 119.86, 178, 447);
INSERT INTO public.europe_data VALUES (9536, 1, 129, 5.08, 179, 447);
INSERT INTO public.europe_data VALUES (9537, 7, 721, 129.18, 180, 447);
INSERT INTO public.europe_data VALUES (9538, 0, 3, 0, 30, 447);
INSERT INTO public.europe_data VALUES (9539, 10, 878, 3.78, 124, 447);
INSERT INTO public.europe_data VALUES (9540, 0, 0, 1.7, 125, 447);
INSERT INTO public.europe_data VALUES (9541, 0, 77, 21.07, 181, 447);
INSERT INTO public.europe_data VALUES (9542, 0, 1, 0.04, 33, 447);
INSERT INTO public.europe_data VALUES (9543, 2, 28, 0, 34, 447);
INSERT INTO public.europe_data VALUES (9544, 2, 654, 0.68, 87, 447);
INSERT INTO public.europe_data VALUES (9545, 1, 71, 2.32, 182, 447);
INSERT INTO public.europe_data VALUES (9546, 0, 11, 57.43, 183, 447);
INSERT INTO public.europe_data VALUES (9547, 0, 10, 0, 126, 447);
INSERT INTO public.europe_data VALUES (9548, 0, 21, 0, 184, 447);
INSERT INTO public.europe_data VALUES (9549, 0, 1, 0, 88, 447);
INSERT INTO public.europe_data VALUES (9550, 3, 87, 0.32, 35, 447);
INSERT INTO public.europe_data VALUES (9551, 0, 1, 0, 36, 447);
INSERT INTO public.europe_data VALUES (9552, 0, 1, 0.12, 37, 447);
INSERT INTO public.europe_data VALUES (9553, 0, 0, 0, 128, 447);
INSERT INTO public.europe_data VALUES (9554, 159, 3069, 22.79, 185, 447);
INSERT INTO public.europe_data VALUES (9555, 0, 5, 0, 208, 447);
INSERT INTO public.europe_data VALUES (9556, 0, 94, 2.03, 209, 447);
INSERT INTO public.europe_data VALUES (9557, 0, 2, 0, 89, 447);
INSERT INTO public.europe_data VALUES (9558, 0, 1, 0, 38, 447);
INSERT INTO public.europe_data VALUES (9559, 0, 28, 0.01, 39, 447);
INSERT INTO public.europe_data VALUES (9560, 1, 101, 5.34, 186, 447);
INSERT INTO public.europe_data VALUES (9561, 6, 1055, 36.84, 187, 447);
INSERT INTO public.europe_data VALUES (9562, 0, 33, 0.78, 129, 447);
INSERT INTO public.europe_data VALUES (9563, 5, 753, 0.36, 130, 447);
INSERT INTO public.europe_data VALUES (9564, 0, 21, 1.18, 131, 447);
INSERT INTO public.europe_data VALUES (9565, 2, 270, 7.37, 90, 447);
INSERT INTO public.europe_data VALUES (9566, 0, 1, 0, 211, 447);
INSERT INTO public.europe_data VALUES (9567, 1, 14, 0.31, 91, 447);
INSERT INTO public.europe_data VALUES (9568, 5, 292, 1.1, 92, 447);
INSERT INTO public.europe_data VALUES (9569, 13, 240, 0.34, 132, 447);
INSERT INTO public.europe_data VALUES (9570, 4, 509, 1.64, 188, 447);
INSERT INTO public.europe_data VALUES (9571, 14, 1355, 15.28, 189, 447);
INSERT INTO public.europe_data VALUES (9572, 0, 93, 16.91, 133, 447);
INSERT INTO public.europe_data VALUES (9573, 2, 294, 2.15, 190, 447);
INSERT INTO public.europe_data VALUES (9574, 0, 304, 0.24, 191, 447);
INSERT INTO public.europe_data VALUES (9575, 0, 14, 0.15, 40, 447);
INSERT INTO public.europe_data VALUES (9576, 0, 0, 1.09, 95, 447);
INSERT INTO public.europe_data VALUES (9577, 13, 53, 330.89, 192, 447);
INSERT INTO public.europe_data VALUES (9578, 0, 393, 1.46, 134, 447);
INSERT INTO public.europe_data VALUES (9579, 0, 41, 0.41, 42, 447);
INSERT INTO public.europe_data VALUES (9580, 1, 133, 2.7, 193, 447);
INSERT INTO public.europe_data VALUES (9581, 0, 4, 7.16, 43, 447);
INSERT INTO public.europe_data VALUES (9582, 2, 229, 5.25, 135, 447);
INSERT INTO public.europe_data VALUES (9583, 0, 124, 3.3, 194, 447);
INSERT INTO public.europe_data VALUES (9584, 1, 195, 19.13, 195, 447);
INSERT INTO public.europe_data VALUES (9585, 0, 1, 0, 45, 447);
INSERT INTO public.europe_data VALUES (9586, 0, 223, 0.46, 46, 447);
INSERT INTO public.europe_data VALUES (9587, 38, 725, 3.08, 136, 447);
INSERT INTO public.europe_data VALUES (9588, 1432, 29771, 84.66, 196, 447);
INSERT INTO public.europe_data VALUES (9589, 0, 68, 0.4, 137, 447);
INSERT INTO public.europe_data VALUES (9590, 0, 1, 0, 48, 447);
INSERT INTO public.europe_data VALUES (9591, 0, 5, 0, 98, 447);
INSERT INTO public.europe_data VALUES (9592, 44, 924, 17.22, 197, 447);
INSERT INTO public.europe_data VALUES (9593, 47, 4771, 77.7, 198, 447);
INSERT INTO public.europe_data VALUES (9594, 0, 1, 0, 138, 447);
INSERT INTO public.europe_data VALUES (9595, 1, 106, 0.5, 139, 447);
INSERT INTO public.europe_data VALUES (9596, 0, 607, 0.96, 141, 447);
INSERT INTO public.europe_data VALUES (9597, 0, 1, 0, 142, 447);
INSERT INTO public.europe_data VALUES (9598, 0, 14, 0.19, 49, 447);
INSERT INTO public.europe_data VALUES (9599, 0, 46, 3.58, 99, 447);
INSERT INTO public.europe_data VALUES (9600, 3, 57, 0.64, 50, 447);
INSERT INTO public.europe_data VALUES (9601, 30, 1218, 1.51, 199, 447);
INSERT INTO public.europe_data VALUES (9602, 0, 1, 0, 51, 447);
INSERT INTO public.europe_data VALUES (9603, 3, 44, 0.11, 200, 447);
INSERT INTO public.europe_data VALUES (9604, 2, 55, 1.11, 143, 447);
INSERT INTO public.europe_data VALUES (9605, 245, 6329, 12.79, 201, 447);
INSERT INTO public.europe_data VALUES (9606, 0, 12, 0, 52, 447);
INSERT INTO public.europe_data VALUES (9607, 402, 31432, 10.53, 101, 447);
INSERT INTO public.europe_data VALUES (9608, 0, 150, 4.56, 103, 447);
INSERT INTO public.europe_data VALUES (9609, 0, 40, 0.14, 144, 447);
INSERT INTO public.europe_data VALUES (9610, 0, 21, 0.13, 104, 447);
INSERT INTO public.europe_data VALUES (9611, 0, 64, 0.09, 145, 447);
INSERT INTO public.europe_data VALUES (9612, 0, 3, 0, 54, 447);
INSERT INTO public.europe_data VALUES (9613, 0, 2, 0, 55, 447);
INSERT INTO public.europe_data VALUES (9614, 0, 12, 0.04, 105, 448);
INSERT INTO public.europe_data VALUES (9615, 1, 40, 1.47, 147, 448);
INSERT INTO public.europe_data VALUES (9616, 4, 28, 0.1, 1, 448);
INSERT INTO public.europe_data VALUES (9617, 0, 5, 0, 148, 448);
INSERT INTO public.europe_data VALUES (9618, 1, 44, 0.13, 58, 448);
INSERT INTO public.europe_data VALUES (9619, 0, 27, 0.91, 149, 448);
INSERT INTO public.europe_data VALUES (9620, 2, 218, 1.07, 202, 448);
INSERT INTO public.europe_data VALUES (9621, 1, 758, 9.55, 150, 448);
INSERT INTO public.europe_data VALUES (9622, 0, 10, 0.16, 151, 448);
INSERT INTO public.europe_data VALUES (9623, 0, 1, 0, 60, 448);
INSERT INTO public.europe_data VALUES (9624, 0, 135, 10.18, 106, 448);
INSERT INTO public.europe_data VALUES (9625, 0, 0, 0, 107, 448);
INSERT INTO public.europe_data VALUES (9626, 0, 21, 0.28, 152, 448);
INSERT INTO public.europe_data VALUES (9627, 18, 1348, 15.15, 153, 448);
INSERT INTO public.europe_data VALUES (9628, 0, 18, 0, 154, 448);
INSERT INTO public.europe_data VALUES (9629, 0, 175, 0.09, 66, 448);
INSERT INTO public.europe_data VALUES (9630, 0, 50, 0, 109, 448);
INSERT INTO public.europe_data VALUES (9631, 2, 47, 0.73, 155, 448);
INSERT INTO public.europe_data VALUES (9632, 0, 3, 0, 5, 448);
INSERT INTO public.europe_data VALUES (9633, 0, 10, 0.07, 110, 448);
INSERT INTO public.europe_data VALUES (9634, 0, 2, 0.02, 7, 448);
INSERT INTO public.europe_data VALUES (9635, 1, 242, 0.75, 68, 448);
INSERT INTO public.europe_data VALUES (9636, 0, 1, 0, 9, 448);
INSERT INTO public.europe_data VALUES (9637, 0, 65, 0.4, 70, 448);
INSERT INTO public.europe_data VALUES (9638, 94, 161, 0.06, 111, 448);
INSERT INTO public.europe_data VALUES (9639, 0, 45, 0, 71, 448);
INSERT INTO public.europe_data VALUES (9640, 0, 1, 0, 12, 448);
INSERT INTO public.europe_data VALUES (9641, 0, 30, 0.69, 72, 448);
INSERT INTO public.europe_data VALUES (9642, 0, 4, 0, 13, 448);
INSERT INTO public.europe_data VALUES (9643, 0, 36, 1.01, 156, 448);
INSERT INTO public.europe_data VALUES (9644, 0, 30, 0, 157, 448);
INSERT INTO public.europe_data VALUES (9645, 0, 266, 2.77, 158, 448);
INSERT INTO public.europe_data VALUES (9646, 0, 2, 0, 14, 448);
INSERT INTO public.europe_data VALUES (9647, 1, 837, 15, 159, 448);
INSERT INTO public.europe_data VALUES (9648, 0, 9, 0.09, 76, 448);
INSERT INTO public.europe_data VALUES (9649, 2, 23, 0.18, 77, 448);
INSERT INTO public.europe_data VALUES (9650, 1, 61, 0.11, 16, 448);
INSERT INTO public.europe_data VALUES (9651, 0, 1, 0, 17, 448);
INSERT INTO public.europe_data VALUES (9652, 0, 161, 12.83, 160, 448);
INSERT INTO public.europe_data VALUES (9653, 0, 1, 0, 19, 448);
INSERT INTO public.europe_data VALUES (9654, 0, 4, 0, 20, 448);
INSERT INTO public.europe_data VALUES (9655, 0, 6, 18.49, 161, 448);
INSERT INTO public.europe_data VALUES (9656, 0, 237, 4.73, 162, 448);
INSERT INTO public.europe_data VALUES (9657, 108, 4297, 7.9, 163, 448);
INSERT INTO public.europe_data VALUES (9658, 0, 1, 0, 21, 448);
INSERT INTO public.europe_data VALUES (9659, 0, 17, 0.68, 164, 448);
INSERT INTO public.europe_data VALUES (9660, 12, 3936, 5.67, 165, 448);
INSERT INTO public.europe_data VALUES (9661, 0, 2, 0, 23, 448);
INSERT INTO public.europe_data VALUES (9662, 4, 258, 3.02, 167, 448);
INSERT INTO public.europe_data VALUES (9663, 1, 1, 0, 82, 448);
INSERT INTO public.europe_data VALUES (9664, 1, 4, 0, 83, 448);
INSERT INTO public.europe_data VALUES (9665, 0, 1, 0, 169, 448);
INSERT INTO public.europe_data VALUES (9666, 0, 6, 0, 85, 448);
INSERT INTO public.europe_data VALUES (9667, 1, 31, 0.4, 170, 448);
INSERT INTO public.europe_data VALUES (9668, 0, 123, 49.02, 171, 448);
INSERT INTO public.europe_data VALUES (9669, 2, 59, 0.01, 112, 448);
INSERT INTO public.europe_data VALUES (9670, 5, 111, 0.04, 113, 448);
INSERT INTO public.europe_data VALUES (9671, 530, 7372, 15.63, 114, 448);
INSERT INTO public.europe_data VALUES (9672, 3, 63, 0.27, 115, 448);
INSERT INTO public.europe_data VALUES (9673, 2, 148, 3.43, 172, 448);
INSERT INTO public.europe_data VALUES (9674, 0, 211, 2.82, 116, 448);
INSERT INTO public.europe_data VALUES (9675, 1445, 16605, 36.93, 174, 448);
INSERT INTO public.europe_data VALUES (9676, 0, 10, 0, 86, 448);
INSERT INTO public.europe_data VALUES (9677, 17, 326, 0.44, 117, 448);
INSERT INTO public.europe_data VALUES (9678, 0, 15, 0, 118, 448);
INSERT INTO public.europe_data VALUES (9679, 0, 9, 0, 119, 448);
INSERT INTO public.europe_data VALUES (9680, 0, 3, 0, 26, 448);
INSERT INTO public.europe_data VALUES (9681, 0, 13, 0, 176, 448);
INSERT INTO public.europe_data VALUES (9682, 0, 48, 1.57, 120, 448);
INSERT INTO public.europe_data VALUES (9683, 0, 28, 1.61, 177, 448);
INSERT INTO public.europe_data VALUES (9684, 3, 67, 1.3, 123, 448);
INSERT INTO public.europe_data VALUES (9685, 0, 7, 0, 178, 448);
INSERT INTO public.europe_data VALUES (9686, 0, 13, 0.47, 179, 448);
INSERT INTO public.europe_data VALUES (9687, 1, 72, 12.38, 180, 448);
INSERT INTO public.europe_data VALUES (9688, 0, 329, 1.25, 124, 448);
INSERT INTO public.europe_data VALUES (9689, 0, 9, 2.45, 125, 448);
INSERT INTO public.europe_data VALUES (9690, 0, 27, 6.08, 181, 448);
INSERT INTO public.europe_data VALUES (9691, 0, 1, 0, 33, 448);
INSERT INTO public.europe_data VALUES (9692, 0, 216, 0.18, 87, 448);
INSERT INTO public.europe_data VALUES (9693, 0, 23, 0, 182, 448);
INSERT INTO public.europe_data VALUES (9694, 0, 8, 24.18, 183, 448);
INSERT INTO public.europe_data VALUES (9695, 1, 28, 0, 35, 448);
INSERT INTO public.europe_data VALUES (9696, 0, 2, 0, 37, 448);
INSERT INTO public.europe_data VALUES (9697, 0, 0, 0, 128, 448);
INSERT INTO public.europe_data VALUES (9698, 17, 870, 6.49, 185, 448);
INSERT INTO public.europe_data VALUES (9699, 0, 3, 0.15, 209, 448);
INSERT INTO public.europe_data VALUES (9700, 0, 1, 0, 39, 448);
INSERT INTO public.europe_data VALUES (9701, 0, 10, 0.58, 186, 448);
INSERT INTO public.europe_data VALUES (9702, 1, 908, 19.86, 187, 448);
INSERT INTO public.europe_data VALUES (9703, 0, 6, 0.32, 129, 448);
INSERT INTO public.europe_data VALUES (9704, 0, 25, 0.01, 130, 448);
INSERT INTO public.europe_data VALUES (9705, 0, 38, 0, 131, 448);
INSERT INTO public.europe_data VALUES (9706, 1, 43, 0, 90, 448);
INSERT INTO public.europe_data VALUES (9707, 0, 8, 0, 91, 448);
INSERT INTO public.europe_data VALUES (9708, 0, 64, 0.22, 92, 448);
INSERT INTO public.europe_data VALUES (9709, 11, 130, 0.13, 132, 448);
INSERT INTO public.europe_data VALUES (9710, 3, 114, 0.33, 188, 448);
INSERT INTO public.europe_data VALUES (9711, 0, 215, 2.38, 189, 448);
INSERT INTO public.europe_data VALUES (9712, 0, 386, 14.05, 133, 448);
INSERT INTO public.europe_data VALUES (9713, 0, 124, 0.7, 190, 448);
INSERT INTO public.europe_data VALUES (9714, 0, 53, 0.04, 191, 448);
INSERT INTO public.europe_data VALUES (9715, 0, 5, 0, 40, 448);
INSERT INTO public.europe_data VALUES (9716, 0, 2, 0, 95, 448);
INSERT INTO public.europe_data VALUES (9717, 6, 61, 261.23, 192, 448);
INSERT INTO public.europe_data VALUES (9718, 0, 107, 0.34, 134, 448);
INSERT INTO public.europe_data VALUES (9719, 0, 26, 0, 42, 448);
INSERT INTO public.europe_data VALUES (9720, 0, 55, 0, 193, 448);
INSERT INTO public.europe_data VALUES (9721, 0, 3, 0, 43, 448);
INSERT INTO public.europe_data VALUES (9722, 0, 76, 2.07, 135, 448);
INSERT INTO public.europe_data VALUES (9723, 0, 56, 1.12, 194, 448);
INSERT INTO public.europe_data VALUES (9724, 0, 203, 10.52, 195, 448);
INSERT INTO public.europe_data VALUES (9725, 0, 48, 0.09, 46, 448);
INSERT INTO public.europe_data VALUES (9726, 24, 854, 7.86, 136, 448);
INSERT INTO public.europe_data VALUES (9727, 283, 9964, 24.19, 196, 448);
INSERT INTO public.europe_data VALUES (9728, 0, 18, 0.08, 137, 448);
INSERT INTO public.europe_data VALUES (9729, 1, 1, 0, 48, 448);
INSERT INTO public.europe_data VALUES (9730, 5, 838, 10.25, 197, 448);
INSERT INTO public.europe_data VALUES (9731, 11, 1868, 25.47, 198, 448);
INSERT INTO public.europe_data VALUES (9732, 0, 14, 0.08, 139, 448);
INSERT INTO public.europe_data VALUES (9733, 0, 64, 0.1, 141, 448);
INSERT INTO public.europe_data VALUES (9734, 0, 1, 0, 49, 448);
INSERT INTO public.europe_data VALUES (9735, 0, 4, 0, 99, 448);
INSERT INTO public.europe_data VALUES (9736, 0, 18, 0, 50, 448);
INSERT INTO public.europe_data VALUES (9737, 0, 18, 0, 199, 448);
INSERT INTO public.europe_data VALUES (9738, 0, 3, 0, 200, 448);
INSERT INTO public.europe_data VALUES (9739, 0, 53, 0.79, 143, 448);
INSERT INTO public.europe_data VALUES (9740, 41, 2193, 3.84, 201, 448);
INSERT INTO public.europe_data VALUES (9741, 48, 3220, 1.12, 101, 448);
INSERT INTO public.europe_data VALUES (9742, 0, 8, 0, 103, 448);
INSERT INTO public.europe_data VALUES (9743, 0, 6, 0, 144, 448);
INSERT INTO public.europe_data VALUES (9744, 0, 15, 0, 104, 448);
INSERT INTO public.europe_data VALUES (9745, 0, 27, 0.04, 145, 448);
INSERT INTO public.europe_data VALUES (9746, 0, 3, 0.01, 105, 449);
INSERT INTO public.europe_data VALUES (9747, 0, 2, 0, 147, 449);
INSERT INTO public.europe_data VALUES (9748, 0, 17, 0.05, 1, 449);
INSERT INTO public.europe_data VALUES (9749, 1, 12, 0, 58, 449);
INSERT INTO public.europe_data VALUES (9750, 0, 0, 0.03, 149, 449);
INSERT INTO public.europe_data VALUES (9751, 2, 51, 0.23, 202, 449);
INSERT INTO public.europe_data VALUES (9752, 0, 88, 1.15, 150, 449);
INSERT INTO public.europe_data VALUES (9753, 0, 6, 0.09, 151, 449);
INSERT INTO public.europe_data VALUES (9754, 0, 32, 4.75, 106, 449);
INSERT INTO public.europe_data VALUES (9755, 0, 3, 0, 107, 449);
INSERT INTO public.europe_data VALUES (9756, 0, 5, 0.06, 152, 449);
INSERT INTO public.europe_data VALUES (9757, 0, 388, 0.56, 153, 449);
INSERT INTO public.europe_data VALUES (9758, 0, 23, 0.01, 66, 449);
INSERT INTO public.europe_data VALUES (9759, 0, 4, 0, 155, 449);
INSERT INTO public.europe_data VALUES (9760, 0, 1, 0.01, 110, 449);
INSERT INTO public.europe_data VALUES (9761, 0, 2, 0, 7, 449);
INSERT INTO public.europe_data VALUES (9762, 0, 38, 0.14, 68, 449);
INSERT INTO public.europe_data VALUES (9763, 0, 10, 0, 70, 449);
INSERT INTO public.europe_data VALUES (9764, 208, 725, 0.25, 111, 449);
INSERT INTO public.europe_data VALUES (9765, 0, 5, 0, 72, 449);
INSERT INTO public.europe_data VALUES (9766, 0, 5, 0.29, 156, 449);
INSERT INTO public.europe_data VALUES (9767, 0, 29, 0.3, 158, 449);
INSERT INTO public.europe_data VALUES (9768, 0, 34, 0.65, 159, 449);
INSERT INTO public.europe_data VALUES (9769, 0, 1, 0.02, 76, 449);
INSERT INTO public.europe_data VALUES (9770, 0, 8, 0.08, 77, 449);
INSERT INTO public.europe_data VALUES (9771, 1, 47, 0.05, 16, 449);
INSERT INTO public.europe_data VALUES (9772, 0, 9, 0.75, 160, 449);
INSERT INTO public.europe_data VALUES (9773, 0, 3, 0, 161, 449);
INSERT INTO public.europe_data VALUES (9774, 0, 24, 0.53, 162, 449);
INSERT INTO public.europe_data VALUES (9775, 17, 996, 1.66, 163, 449);
INSERT INTO public.europe_data VALUES (9776, 0, 10, 0.33, 164, 449);
INSERT INTO public.europe_data VALUES (9777, 0, 773, 1.07, 165, 449);
INSERT INTO public.europe_data VALUES (9778, 0, 66, 0.68, 167, 449);
INSERT INTO public.europe_data VALUES (9779, 0, 8, 0, 170, 449);
INSERT INTO public.europe_data VALUES (9780, 0, 52, 15.41, 171, 449);
INSERT INTO public.europe_data VALUES (9781, 0, 31, 0, 112, 449);
INSERT INTO public.europe_data VALUES (9782, 0, 4, 0, 113, 449);
INSERT INTO public.europe_data VALUES (9783, 140, 5588, 7.87, 114, 449);
INSERT INTO public.europe_data VALUES (9784, 6, 42, 0.16, 115, 449);
INSERT INTO public.europe_data VALUES (9785, 0, 20, 0.43, 172, 449);
INSERT INTO public.europe_data VALUES (9786, 0, 29, 0.43, 116, 449);
INSERT INTO public.europe_data VALUES (9787, 331, 5686, 12, 174, 449);
INSERT INTO public.europe_data VALUES (9788, 1, 234, 0.27, 117, 449);
INSERT INTO public.europe_data VALUES (9789, 0, 18, 1.45, 120, 449);
INSERT INTO public.europe_data VALUES (9790, 0, 3, 0, 177, 449);
INSERT INTO public.europe_data VALUES (9791, 0, 22, 0.45, 123, 449);
INSERT INTO public.europe_data VALUES (9792, 0, 0, 0.04, 179, 449);
INSERT INTO public.europe_data VALUES (9793, 0, 4, 0.81, 180, 449);
INSERT INTO public.europe_data VALUES (9794, 0, 70, 0.24, 124, 449);
INSERT INTO public.europe_data VALUES (9795, 0, 4, 0, 125, 449);
INSERT INTO public.europe_data VALUES (9796, 0, 3, 0, 181, 449);
INSERT INTO public.europe_data VALUES (9797, 0, 14, 0.02, 87, 449);
INSERT INTO public.europe_data VALUES (9798, 0, 0, 3.02, 183, 449);
INSERT INTO public.europe_data VALUES (9799, 0, 0, 0, 128, 449);
INSERT INTO public.europe_data VALUES (9800, 3, 252, 1.53, 185, 449);
INSERT INTO public.europe_data VALUES (9801, 0, 4, 0.1, 209, 449);
INSERT INTO public.europe_data VALUES (9802, 0, 0, 0, 39, 449);
INSERT INTO public.europe_data VALUES (9803, 0, 2, 0.14, 186, 449);
INSERT INTO public.europe_data VALUES (9804, 0, 150, 3.17, 187, 449);
INSERT INTO public.europe_data VALUES (9805, 0, 10, 0.32, 129, 449);
INSERT INTO public.europe_data VALUES (9806, 0, 2, 0, 130, 449);
INSERT INTO public.europe_data VALUES (9807, 0, 7, 0, 92, 449);
INSERT INTO public.europe_data VALUES (9808, 0, 7, 0.01, 132, 449);
INSERT INTO public.europe_data VALUES (9809, 0, 11, 0, 188, 449);
INSERT INTO public.europe_data VALUES (9810, 0, 30, 0, 189, 449);
INSERT INTO public.europe_data VALUES (9811, 0, 12, 0.53, 133, 449);
INSERT INTO public.europe_data VALUES (9812, 0, 12, 0.08, 190, 449);
INSERT INTO public.europe_data VALUES (9813, 0, 8, 0.01, 191, 449);
INSERT INTO public.europe_data VALUES (9814, 0, 29, 107.39, 192, 449);
INSERT INTO public.europe_data VALUES (9815, 0, 11, 0, 134, 449);
INSERT INTO public.europe_data VALUES (9816, 0, 44, 1.05, 135, 449);
INSERT INTO public.europe_data VALUES (9817, 0, 5, 0, 194, 449);
INSERT INTO public.europe_data VALUES (9818, 0, 16, 0, 195, 449);
INSERT INTO public.europe_data VALUES (9819, 0, 3, 0, 46, 449);
INSERT INTO public.europe_data VALUES (9820, 29, 3170, 12.92, 136, 449);
INSERT INTO public.europe_data VALUES (9821, 5, 1391, 3.25, 196, 449);
INSERT INTO public.europe_data VALUES (9822, 0, 0, 0, 137, 449);
INSERT INTO public.europe_data VALUES (9823, 0, 211, 2.19, 197, 449);
INSERT INTO public.europe_data VALUES (9824, 2, 308, 3.89, 198, 449);
INSERT INTO public.europe_data VALUES (9825, 0, 5, 0.07, 139, 449);
INSERT INTO public.europe_data VALUES (9826, 0, 7, 0.02, 141, 449);
INSERT INTO public.europe_data VALUES (9827, 0, 24, 0.33, 143, 449);
INSERT INTO public.europe_data VALUES (9828, 2, 365, 0.6, 201, 449);
INSERT INTO public.europe_data VALUES (9829, 19, 465, 0.16, 101, 449);
INSERT INTO public.europe_data VALUES (9830, 0, 14, 0.01, 145, 449);
INSERT INTO public.europe_data VALUES (9831, 0, 1, 0, 105, 450);
INSERT INTO public.europe_data VALUES (9832, 0, 3, 0.01, 1, 450);
INSERT INTO public.europe_data VALUES (9833, 0, 1, 0.03, 149, 450);
INSERT INTO public.europe_data VALUES (9834, 1, 7, 0.06, 202, 450);
INSERT INTO public.europe_data VALUES (9835, 0, 14, 0.16, 150, 450);
INSERT INTO public.europe_data VALUES (9836, 0, 3, 0.03, 151, 450);
INSERT INTO public.europe_data VALUES (9837, 0, 46, 2.86, 106, 450);
INSERT INTO public.europe_data VALUES (9838, 0, 1, 0.01, 152, 450);
INSERT INTO public.europe_data VALUES (9839, 0, -324, 0.17, 153, 450);
INSERT INTO public.europe_data VALUES (9840, 0, 2, 0, 66, 450);
INSERT INTO public.europe_data VALUES (9841, 0, 0, 0, 110, 450);
INSERT INTO public.europe_data VALUES (9842, 0, 15, 0.04, 68, 450);
INSERT INTO public.europe_data VALUES (9843, 3, 14, 0, 215, 450);
INSERT INTO public.europe_data VALUES (9844, 319, 2900, 0.66, 111, 450);
INSERT INTO public.europe_data VALUES (9845, 0, 7, 0.17, 156, 450);
INSERT INTO public.europe_data VALUES (9846, 0, 3, 0.03, 158, 450);
INSERT INTO public.europe_data VALUES (9847, 0, 4, 0.07, 159, 450);
INSERT INTO public.europe_data VALUES (9848, 0, 1, 0.01, 76, 450);
INSERT INTO public.europe_data VALUES (9849, 0, 6, 0.03, 77, 450);
INSERT INTO public.europe_data VALUES (9850, 0, 1, 0, 16, 450);
INSERT INTO public.europe_data VALUES (9851, 0, 1, 0.08, 160, 450);
INSERT INTO public.europe_data VALUES (9852, 0, 5, 0.09, 162, 450);
INSERT INTO public.europe_data VALUES (9853, 1, 118, 0.18, 163, 450);
INSERT INTO public.europe_data VALUES (9854, 0, 3, 0.08, 164, 450);
INSERT INTO public.europe_data VALUES (9855, 0, 114, 0.14, 165, 450);
INSERT INTO public.europe_data VALUES (9856, 0, 7, 0.07, 167, 450);
INSERT INTO public.europe_data VALUES (9857, 0, 3, 0.84, 171, 450);
INSERT INTO public.europe_data VALUES (9858, 0, 0, 0, 112, 450);
INSERT INTO public.europe_data VALUES (9859, 0, 2, 0, 113, 450);
INSERT INTO public.europe_data VALUES (9860, 46, 935, 1.18, 114, 450);
INSERT INTO public.europe_data VALUES (9861, 0, 19, 0.05, 115, 450);
INSERT INTO public.europe_data VALUES (9862, 0, 1, 0.02, 172, 450);
INSERT INTO public.europe_data VALUES (9863, 0, 8, 0.12, 116, 450);
INSERT INTO public.europe_data VALUES (9864, 33, 1557, 2.79, 174, 450);
INSERT INTO public.europe_data VALUES (9865, 5, 110, 0.15, 117, 450);
INSERT INTO public.europe_data VALUES (9866, 0, 43, 1.09, 120, 450);
INSERT INTO public.europe_data VALUES (9867, 0, 9, 0.15, 123, 450);
INSERT INTO public.europe_data VALUES (9868, 0, 1, 0.04, 179, 450);
INSERT INTO public.europe_data VALUES (9869, 0, 1, 0.16, 180, 450);
INSERT INTO public.europe_data VALUES (9870, 0, 7, 0.02, 124, 450);
INSERT INTO public.europe_data VALUES (9871, 0, 11, 0.01, 87, 450);
INSERT INTO public.europe_data VALUES (9872, 0, 1, 3.02, 183, 450);
INSERT INTO public.europe_data VALUES (9873, 0, 0, 0, 128, 450);
INSERT INTO public.europe_data VALUES (9874, 0, 13, 0.08, 185, 450);
INSERT INTO public.europe_data VALUES (9875, 0, 1, 0.02, 209, 450);
INSERT INTO public.europe_data VALUES (9876, 0, 1, 0, 39, 450);
INSERT INTO public.europe_data VALUES (9877, 0, 1, 0.05, 186, 450);
INSERT INTO public.europe_data VALUES (9878, 0, 19, 0.36, 187, 450);
INSERT INTO public.europe_data VALUES (9879, 0, 6, 0.12, 129, 450);
INSERT INTO public.europe_data VALUES (9880, 0, 4, 0, 130, 450);
INSERT INTO public.europe_data VALUES (9881, 0, 0, 0, 132, 450);
INSERT INTO public.europe_data VALUES (9882, 0, 3, 0.11, 133, 450);
INSERT INTO public.europe_data VALUES (9883, 0, 3, 0.02, 190, 450);
INSERT INTO public.europe_data VALUES (9884, 0, 0, 0, 191, 450);
INSERT INTO public.europe_data VALUES (9885, 1, 8, 23.22, 192, 450);
INSERT INTO public.europe_data VALUES (9886, 0, 17, 0.53, 135, 450);
INSERT INTO public.europe_data VALUES (9887, 15, 3450, 8.16, 136, 450);
INSERT INTO public.europe_data VALUES (9888, 0, 134, 0.29, 196, 450);
INSERT INTO public.europe_data VALUES (9889, 0, 0, 0, 137, 450);
INSERT INTO public.europe_data VALUES (9890, 0, 13, 0.13, 197, 450);
INSERT INTO public.europe_data VALUES (9891, 0, 24, 0.28, 198, 450);
INSERT INTO public.europe_data VALUES (9892, 0, 12, 0.08, 139, 450);
INSERT INTO public.europe_data VALUES (9893, 1, 8, 0.01, 141, 450);
INSERT INTO public.europe_data VALUES (9894, 0, 8, 0.12, 143, 450);
INSERT INTO public.europe_data VALUES (9895, 0, 36, 0.06, 201, 450);
INSERT INTO public.europe_data VALUES (9896, 2, 54, 0.02, 101, 450);
INSERT INTO public.europe_data VALUES (9897, 0, 0, 0, 145, 450);
INSERT INTO public.europe_data VALUES (9898, 0, 0, 0, 105, 451);
INSERT INTO public.europe_data VALUES (9899, 0, 0, 0, 1, 451);
INSERT INTO public.europe_data VALUES (9900, 0, 0, 0, 149, 451);
INSERT INTO public.europe_data VALUES (9901, 0, 7, 0.03, 202, 451);
INSERT INTO public.europe_data VALUES (9902, 0, 0, 0, 150, 451);
INSERT INTO public.europe_data VALUES (9903, 0, 0, 0, 151, 451);
INSERT INTO public.europe_data VALUES (9904, 0, 1, 0.06, 106, 451);
INSERT INTO public.europe_data VALUES (9905, 0, 0, 0, 152, 451);
INSERT INTO public.europe_data VALUES (9906, 0, 343, 2.99, 153, 451);
INSERT INTO public.europe_data VALUES (9907, 0, 0, 0, 66, 451);
INSERT INTO public.europe_data VALUES (9908, 0, 0, 0, 110, 451);
INSERT INTO public.europe_data VALUES (9909, 0, 1, 0.01, 68, 451);
INSERT INTO public.europe_data VALUES (9910, 3, 336, 0, 215, 451);
INSERT INTO public.europe_data VALUES (9911, 824, 6616, 2.58, 111, 451);
INSERT INTO public.europe_data VALUES (9912, 0, 0, 0, 156, 451);
INSERT INTO public.europe_data VALUES (9913, 0, 0, 0, 158, 451);
INSERT INTO public.europe_data VALUES (9914, 0, 0, 0, 159, 451);
INSERT INTO public.europe_data VALUES (9915, 0, 0, 0, 76, 451);
INSERT INTO public.europe_data VALUES (9916, 0, 0, 0, 77, 451);
INSERT INTO public.europe_data VALUES (9917, 0, 0, 0, 16, 451);
INSERT INTO public.europe_data VALUES (9918, 0, 0, 0, 160, 451);
INSERT INTO public.europe_data VALUES (9919, 0, 0, 0, 162, 451);
INSERT INTO public.europe_data VALUES (9920, 0, 0, 0, 163, 451);
INSERT INTO public.europe_data VALUES (9921, 0, 0, 0, 164, 451);
INSERT INTO public.europe_data VALUES (9922, 0, 0, 0, 165, 451);
INSERT INTO public.europe_data VALUES (9923, 0, 0, 0, 167, 451);
INSERT INTO public.europe_data VALUES (9924, 0, 0, 0, 171, 451);
INSERT INTO public.europe_data VALUES (9925, 0, 0, 0, 112, 451);
INSERT INTO public.europe_data VALUES (9926, 0, 0, 0, 113, 451);
INSERT INTO public.europe_data VALUES (9927, 8, 43, 0.05, 114, 451);
INSERT INTO public.europe_data VALUES (9928, 0, 0, 0, 115, 451);
INSERT INTO public.europe_data VALUES (9929, 0, 0, 0, 172, 451);
INSERT INTO public.europe_data VALUES (9930, 0, 2, 0.02, 116, 451);
INSERT INTO public.europe_data VALUES (9931, 2, 129, 0.21, 174, 451);
INSERT INTO public.europe_data VALUES (9932, 0, 85, 0.09, 117, 451);
INSERT INTO public.europe_data VALUES (9933, 0, 3, 0.07, 120, 451);
INSERT INTO public.europe_data VALUES (9934, 0, 1, 0.01, 123, 451);
INSERT INTO public.europe_data VALUES (9935, 0, 0, 0, 179, 451);
INSERT INTO public.europe_data VALUES (9936, 0, 0, 0, 180, 451);
INSERT INTO public.europe_data VALUES (9937, 0, 0, 0.01, 124, 451);
INSERT INTO public.europe_data VALUES (9938, 0, 1, 0, 87, 451);
INSERT INTO public.europe_data VALUES (9939, 0, 0, 0, 183, 451);
INSERT INTO public.europe_data VALUES (9940, 0, 0, 0, 128, 451);
INSERT INTO public.europe_data VALUES (9941, 0, 0, 0, 185, 451);
INSERT INTO public.europe_data VALUES (9942, 0, 0, 0, 209, 451);
INSERT INTO public.europe_data VALUES (9943, 0, 0, 0, 39, 451);
INSERT INTO public.europe_data VALUES (9944, 0, 0, 0, 186, 451);
INSERT INTO public.europe_data VALUES (9945, 0, 0, 0, 187, 451);
INSERT INTO public.europe_data VALUES (9946, 0, 0, 0, 129, 451);
INSERT INTO public.europe_data VALUES (9947, 0, 0, 0, 130, 451);
INSERT INTO public.europe_data VALUES (9948, 0, 0, 0, 132, 451);
INSERT INTO public.europe_data VALUES (9949, 0, 0, 0, 133, 451);
INSERT INTO public.europe_data VALUES (9950, 0, 0, 0, 190, 451);
INSERT INTO public.europe_data VALUES (9951, 0, 0, 0, 191, 451);
INSERT INTO public.europe_data VALUES (9952, 0, 0, 0, 192, 451);
INSERT INTO public.europe_data VALUES (9953, 0, 14, 0.79, 135, 451);
INSERT INTO public.europe_data VALUES (9954, 7, 732, 1.43, 136, 451);
INSERT INTO public.europe_data VALUES (9955, 0, 0, 0, 196, 451);
INSERT INTO public.europe_data VALUES (9956, 0, 0, 0, 137, 451);
INSERT INTO public.europe_data VALUES (9957, 0, 0, 0, 197, 451);
INSERT INTO public.europe_data VALUES (9958, 0, 0, 0, 198, 451);
INSERT INTO public.europe_data VALUES (9959, 0, 8, 0.04, 139, 451);
INSERT INTO public.europe_data VALUES (9960, 0, 1, 0, 141, 451);
INSERT INTO public.europe_data VALUES (9961, 0, 4, 0.06, 143, 451);
INSERT INTO public.europe_data VALUES (9962, 0, 1, 0, 201, 451);
INSERT INTO public.europe_data VALUES (9963, 0, 20, 0.01, 101, 451);
INSERT INTO public.europe_data VALUES (9964, 0, 0, 0, 145, 451);
INSERT INTO public.europe_data VALUES (9965, 0, 0, 0, 105, 452);
INSERT INTO public.europe_data VALUES (9966, 0, 0, 0, 1, 452);
INSERT INTO public.europe_data VALUES (9967, 0, 0, 0, 149, 452);
INSERT INTO public.europe_data VALUES (9968, 0, 1, 0.02, 202, 452);
INSERT INTO public.europe_data VALUES (9969, 0, 0, 0, 150, 452);
INSERT INTO public.europe_data VALUES (9970, 0, 0, 0, 151, 452);
INSERT INTO public.europe_data VALUES (9971, 0, 0, 0, 106, 452);
INSERT INTO public.europe_data VALUES (9972, 0, 0, 0, 152, 452);
INSERT INTO public.europe_data VALUES (9973, 0, 0, 0, 153, 452);
INSERT INTO public.europe_data VALUES (9974, 0, 0, 0, 66, 452);
INSERT INTO public.europe_data VALUES (9975, 0, 0, 0, 110, 452);
INSERT INTO public.europe_data VALUES (9976, 0, 1, 0.01, 68, 452);
INSERT INTO public.europe_data VALUES (9977, 0, 285, 0, 215, 452);
INSERT INTO public.europe_data VALUES (9978, 862, 30412, 3.72, 111, 452);
INSERT INTO public.europe_data VALUES (9979, 0, 0, 0, 156, 452);
INSERT INTO public.europe_data VALUES (9980, 0, 0, 0, 158, 452);
INSERT INTO public.europe_data VALUES (9981, 0, 0, 0, 159, 452);
INSERT INTO public.europe_data VALUES (9982, 0, 0, 0, 76, 452);
INSERT INTO public.europe_data VALUES (9983, 0, 0, 0, 77, 452);
INSERT INTO public.europe_data VALUES (9984, 0, 1, 0, 16, 452);
INSERT INTO public.europe_data VALUES (9985, 0, 0, 0, 160, 452);
INSERT INTO public.europe_data VALUES (9986, 0, 0, 0, 162, 452);
INSERT INTO public.europe_data VALUES (9987, 1, 1, 0.01, 163, 452);
INSERT INTO public.europe_data VALUES (9988, 0, 0, 0, 164, 452);
INSERT INTO public.europe_data VALUES (9989, 0, 2, 0.01, 165, 452);
INSERT INTO public.europe_data VALUES (9990, 0, 0, 0, 167, 452);
INSERT INTO public.europe_data VALUES (9991, 0, 0, 0, 171, 452);
INSERT INTO public.europe_data VALUES (9992, 0, 0, 0, 112, 452);
INSERT INTO public.europe_data VALUES (9993, 0, 0, 0, 113, 452);
INSERT INTO public.europe_data VALUES (9994, 0, 0, 0, 114, 452);
INSERT INTO public.europe_data VALUES (9995, 0, 0, 0, 115, 452);
INSERT INTO public.europe_data VALUES (9996, 0, 0, 0, 172, 452);
INSERT INTO public.europe_data VALUES (9997, 0, 0, 0, 116, 452);
INSERT INTO public.europe_data VALUES (9998, 0, 0, 0, 174, 452);
INSERT INTO public.europe_data VALUES (9999, 1, 34, 0.03, 117, 452);
INSERT INTO public.europe_data VALUES (10000, 0, 0, 0, 120, 452);
INSERT INTO public.europe_data VALUES (10001, 0, 0, 0, 123, 452);
INSERT INTO public.europe_data VALUES (10002, 0, 0, 0, 179, 452);
INSERT INTO public.europe_data VALUES (10003, 0, 0, 0, 180, 452);
INSERT INTO public.europe_data VALUES (10004, 0, 4, 0.04, 124, 452);
INSERT INTO public.europe_data VALUES (10005, 0, 1, 0, 87, 452);
INSERT INTO public.europe_data VALUES (10006, 0, 0, 0, 183, 452);
INSERT INTO public.europe_data VALUES (10007, 0, 0, 0, 128, 452);
INSERT INTO public.europe_data VALUES (10008, 0, 0, 0, 185, 452);
INSERT INTO public.europe_data VALUES (10009, 0, 0, 0, 209, 452);
INSERT INTO public.europe_data VALUES (10010, 0, 0, 0, 39, 452);
INSERT INTO public.europe_data VALUES (10011, 0, 0, 0, 186, 452);
INSERT INTO public.europe_data VALUES (10012, 0, 0, 0, 187, 452);
INSERT INTO public.europe_data VALUES (10013, 0, 0, 0, 129, 452);
INSERT INTO public.europe_data VALUES (10014, 0, 0, 0, 130, 452);
INSERT INTO public.europe_data VALUES (10015, 0, 0, 0, 132, 452);
INSERT INTO public.europe_data VALUES (10016, 0, 0, 0, 133, 452);
INSERT INTO public.europe_data VALUES (10017, 0, 0, 0, 190, 452);
INSERT INTO public.europe_data VALUES (10018, 0, 0, 0, 191, 452);
INSERT INTO public.europe_data VALUES (10019, 0, 0, 0, 192, 452);
INSERT INTO public.europe_data VALUES (10020, 0, 32, 0.98, 135, 452);
INSERT INTO public.europe_data VALUES (10021, 0, 3, 0.03, 136, 452);
INSERT INTO public.europe_data VALUES (10022, 0, 0, 0, 196, 452);
INSERT INTO public.europe_data VALUES (10023, 0, 0, 0, 137, 452);
INSERT INTO public.europe_data VALUES (10024, 0, 0, 0.01, 197, 452);
INSERT INTO public.europe_data VALUES (10025, 0, 0, 0, 198, 452);
INSERT INTO public.europe_data VALUES (10026, 1, 2, 0.04, 139, 452);
INSERT INTO public.europe_data VALUES (10027, 0, 2, 0.02, 141, 452);
INSERT INTO public.europe_data VALUES (10028, 0, 2, 0.04, 143, 452);
INSERT INTO public.europe_data VALUES (10029, 0, 2, 0.01, 201, 452);
INSERT INTO public.europe_data VALUES (10030, 0, 3, 0, 101, 452);
INSERT INTO public.europe_data VALUES (10031, 0, 2, 0.01, 145, 452);
INSERT INTO public.europe_data VALUES (10032, 0, 0, 0, 105, 453);
INSERT INTO public.europe_data VALUES (10033, 0, 0, 0, 1, 453);
INSERT INTO public.europe_data VALUES (10034, 0, 0, 0, 149, 453);
INSERT INTO public.europe_data VALUES (10035, 0, 3, 0.04, 202, 453);
INSERT INTO public.europe_data VALUES (10036, 0, 0, 0, 150, 453);
INSERT INTO public.europe_data VALUES (10037, 0, 0, 0, 151, 453);
INSERT INTO public.europe_data VALUES (10038, 0, 0, 0, 106, 453);
INSERT INTO public.europe_data VALUES (10039, 0, 0, 0, 152, 453);
INSERT INTO public.europe_data VALUES (10040, 0, 0, 0, 153, 453);
INSERT INTO public.europe_data VALUES (10041, 0, 0, 0, 66, 453);
INSERT INTO public.europe_data VALUES (10042, 0, 0, 0.01, 110, 453);
INSERT INTO public.europe_data VALUES (10043, 0, 3, 0.02, 68, 453);
INSERT INTO public.europe_data VALUES (10044, 0, 70, 0, 215, 453);
INSERT INTO public.europe_data VALUES (10045, 548, 22995, 2.61, 111, 453);
INSERT INTO public.europe_data VALUES (10046, 0, 0, 0, 156, 453);
INSERT INTO public.europe_data VALUES (10047, 0, 0, 0, 158, 453);
INSERT INTO public.europe_data VALUES (10048, 0, 0, 0, 159, 453);
INSERT INTO public.europe_data VALUES (10049, 0, 0, 0, 76, 453);
INSERT INTO public.europe_data VALUES (10050, 0, 0, 0, 77, 453);
INSERT INTO public.europe_data VALUES (10051, 0, 0, 0, 16, 453);
INSERT INTO public.europe_data VALUES (10052, 0, 0, 0, 160, 453);
INSERT INTO public.europe_data VALUES (10053, 0, 0, 0.02, 162, 453);
INSERT INTO public.europe_data VALUES (10054, 0, 5, 0.01, 163, 453);
INSERT INTO public.europe_data VALUES (10055, 0, 0, 0, 164, 453);
INSERT INTO public.europe_data VALUES (10056, 0, 4, 0.02, 165, 453);
INSERT INTO public.europe_data VALUES (10057, 0, 0, 0, 167, 453);
INSERT INTO public.europe_data VALUES (10058, 0, 0, 0, 171, 453);
INSERT INTO public.europe_data VALUES (10059, 0, 1, 0, 112, 453);
INSERT INTO public.europe_data VALUES (10060, 0, 0, 0, 113, 453);
INSERT INTO public.europe_data VALUES (10061, 0, 0, 0, 114, 453);
INSERT INTO public.europe_data VALUES (10062, 0, 0, 0, 115, 453);
INSERT INTO public.europe_data VALUES (10063, 0, 0, 0, 172, 453);
INSERT INTO public.europe_data VALUES (10064, 0, 0, 0, 116, 453);
INSERT INTO public.europe_data VALUES (10065, 0, 0, 0, 174, 453);
INSERT INTO public.europe_data VALUES (10066, 0, 5, 0.02, 117, 453);
INSERT INTO public.europe_data VALUES (10067, 0, 0, 0, 120, 453);
INSERT INTO public.europe_data VALUES (10068, 0, 0, 0, 123, 453);
INSERT INTO public.europe_data VALUES (10069, 0, 0, 0, 179, 453);
INSERT INTO public.europe_data VALUES (10070, 0, 0, 0, 180, 453);
INSERT INTO public.europe_data VALUES (10071, 0, 10, 0.04, 124, 453);
INSERT INTO public.europe_data VALUES (10072, 0, 0, 0, 87, 453);
INSERT INTO public.europe_data VALUES (10073, 0, 0, 0, 183, 453);
INSERT INTO public.europe_data VALUES (10074, 0, 0, 0, 128, 453);
INSERT INTO public.europe_data VALUES (10075, 0, 0, 0, 185, 453);
INSERT INTO public.europe_data VALUES (10076, 0, 0, 0, 209, 453);
INSERT INTO public.europe_data VALUES (10077, 0, 0, 0, 39, 453);
INSERT INTO public.europe_data VALUES (10078, 0, 0, 0, 186, 453);
INSERT INTO public.europe_data VALUES (10079, 0, 0, 0, 187, 453);
INSERT INTO public.europe_data VALUES (10080, 0, 0, 0, 129, 453);
INSERT INTO public.europe_data VALUES (10081, 0, 0, 0, 130, 453);
INSERT INTO public.europe_data VALUES (10082, 0, 1, 0, 132, 453);
INSERT INTO public.europe_data VALUES (10083, 0, 0, 0, 133, 453);
INSERT INTO public.europe_data VALUES (10084, 0, 0, 0, 190, 453);
INSERT INTO public.europe_data VALUES (10085, 0, 0, 0, 191, 453);
INSERT INTO public.europe_data VALUES (10086, 0, 0, 0, 192, 453);
INSERT INTO public.europe_data VALUES (10087, 0, 25, 0.67, 135, 453);
INSERT INTO public.europe_data VALUES (10088, 0, 12, 0.04, 136, 453);
INSERT INTO public.europe_data VALUES (10089, 0, 1, 0, 196, 453);
INSERT INTO public.europe_data VALUES (10090, 0, 0, 0, 137, 453);
INSERT INTO public.europe_data VALUES (10091, 0, 1, 0.01, 197, 453);
INSERT INTO public.europe_data VALUES (10092, 0, 0, 0, 198, 453);
INSERT INTO public.europe_data VALUES (10093, 0, 8, 0.05, 139, 453);
INSERT INTO public.europe_data VALUES (10094, 0, 13, 0.03, 141, 453);
INSERT INTO public.europe_data VALUES (10095, 0, 2, 0.06, 143, 453);
INSERT INTO public.europe_data VALUES (10096, 0, 6, 0.01, 201, 453);
INSERT INTO public.europe_data VALUES (10097, 0, 1, 0, 101, 453);
INSERT INTO public.europe_data VALUES (10098, 0, 6, 0.01, 145, 453);
INSERT INTO public.europe_data VALUES (10099, 0, 0, 0, 105, 454);
INSERT INTO public.europe_data VALUES (10100, 0, 0, 0, 1, 454);
INSERT INTO public.europe_data VALUES (10101, 0, 0, 0, 149, 454);
INSERT INTO public.europe_data VALUES (10102, 0, 7, 0.04, 202, 454);
INSERT INTO public.europe_data VALUES (10103, 0, 0, 0, 150, 454);
INSERT INTO public.europe_data VALUES (10104, 0, 0, 0, 151, 454);
INSERT INTO public.europe_data VALUES (10105, 0, 0, 0, 106, 454);
INSERT INTO public.europe_data VALUES (10106, 0, 0, 0, 152, 454);
INSERT INTO public.europe_data VALUES (10107, 0, 0, 0, 153, 454);
INSERT INTO public.europe_data VALUES (10108, 0, 0, 0, 66, 454);
INSERT INTO public.europe_data VALUES (10109, 0, 1, 0.01, 110, 454);
INSERT INTO public.europe_data VALUES (10110, 0, 3, 0.01, 68, 454);
INSERT INTO public.europe_data VALUES (10111, 0, 0, 0, 215, 454);
INSERT INTO public.europe_data VALUES (10112, 280, 14436, 1.18, 111, 454);
INSERT INTO public.europe_data VALUES (10113, 0, 0, 0, 156, 454);
INSERT INTO public.europe_data VALUES (10114, 0, 0, 0, 158, 454);
INSERT INTO public.europe_data VALUES (10115, 0, 0, 0, 159, 454);
INSERT INTO public.europe_data VALUES (10116, 0, 0, 0, 76, 454);
INSERT INTO public.europe_data VALUES (10117, 0, 0, 0, 77, 454);
INSERT INTO public.europe_data VALUES (10118, 0, 0, 0, 16, 454);
INSERT INTO public.europe_data VALUES (10119, 0, 0, 0, 160, 454);
INSERT INTO public.europe_data VALUES (10120, 0, 1, 0.02, 162, 454);
INSERT INTO public.europe_data VALUES (10121, 0, 3, 0.01, 163, 454);
INSERT INTO public.europe_data VALUES (10122, 0, 0, 0, 164, 454);
INSERT INTO public.europe_data VALUES (10123, 0, 9, 0.01, 165, 454);
INSERT INTO public.europe_data VALUES (10124, 0, 0, 0, 167, 454);
INSERT INTO public.europe_data VALUES (10125, 0, 0, 0, 171, 454);
INSERT INTO public.europe_data VALUES (10126, 0, 2, 0, 112, 454);
INSERT INTO public.europe_data VALUES (10127, 0, 0, 0, 113, 454);
INSERT INTO public.europe_data VALUES (10128, 0, 0, 0, 114, 454);
INSERT INTO public.europe_data VALUES (10129, 0, 0, 0, 115, 454);
INSERT INTO public.europe_data VALUES (10130, 0, 0, 0, 172, 454);
INSERT INTO public.europe_data VALUES (10131, 0, 0, 0, 116, 454);
INSERT INTO public.europe_data VALUES (10132, 0, 3, 0, 174, 454);
INSERT INTO public.europe_data VALUES (10133, 0, 17, 0.01, 117, 454);
INSERT INTO public.europe_data VALUES (10134, 0, 0, 0, 120, 454);
INSERT INTO public.europe_data VALUES (10135, 0, 0, 0, 123, 454);
INSERT INTO public.europe_data VALUES (10136, 0, 0, 0, 179, 454);
INSERT INTO public.europe_data VALUES (10137, 0, 0, 0, 180, 454);
INSERT INTO public.europe_data VALUES (10138, 0, 4, 0.03, 124, 454);
INSERT INTO public.europe_data VALUES (10139, 0, 1, 0, 87, 454);
INSERT INTO public.europe_data VALUES (10140, 0, 0, 0, 183, 454);
INSERT INTO public.europe_data VALUES (10141, 0, 0, 0, 128, 454);
INSERT INTO public.europe_data VALUES (10142, 0, 0, 0, 185, 454);
INSERT INTO public.europe_data VALUES (10143, 0, 0, 0, 209, 454);
INSERT INTO public.europe_data VALUES (10144, 0, 0, 0, 39, 454);
INSERT INTO public.europe_data VALUES (10145, 0, 0, 0, 186, 454);
INSERT INTO public.europe_data VALUES (10146, 0, 0, 0, 187, 454);
INSERT INTO public.europe_data VALUES (10147, 0, 0, 0, 129, 454);
INSERT INTO public.europe_data VALUES (10148, 0, 0, 0, 130, 454);
INSERT INTO public.europe_data VALUES (10149, 1, 2, 0, 132, 454);
INSERT INTO public.europe_data VALUES (10150, 0, 0, 0, 133, 454);
INSERT INTO public.europe_data VALUES (10151, 0, 0, 0, 190, 454);
INSERT INTO public.europe_data VALUES (10152, 0, 2, 0, 191, 454);
INSERT INTO public.europe_data VALUES (10153, 0, 0, 0, 192, 454);
INSERT INTO public.europe_data VALUES (10154, 0, 14, 0.31, 135, 454);
INSERT INTO public.europe_data VALUES (10155, 0, 11, 0.03, 136, 454);
INSERT INTO public.europe_data VALUES (10156, 0, 1, 0, 196, 454);
INSERT INTO public.europe_data VALUES (10157, 0, 1, 0, 137, 454);
INSERT INTO public.europe_data VALUES (10158, 0, 0, 0, 197, 454);
INSERT INTO public.europe_data VALUES (10159, 0, 0, 0, 198, 454);
INSERT INTO public.europe_data VALUES (10160, 0, 5, 0.04, 139, 454);
INSERT INTO public.europe_data VALUES (10161, 0, 11, 0.02, 141, 454);
INSERT INTO public.europe_data VALUES (10162, 0, 4, 0.05, 143, 454);
INSERT INTO public.europe_data VALUES (10163, 0, 2, 0, 201, 454);
INSERT INTO public.europe_data VALUES (10164, 0, 6, 0, 101, 454);
INSERT INTO public.europe_data VALUES (10165, 0, 6, 0.01, 145, 454);
INSERT INTO public.europe_data VALUES (10166, 0, 0, 0, 105, 455);
INSERT INTO public.europe_data VALUES (10167, 0, 0, 0, 1, 455);
INSERT INTO public.europe_data VALUES (10168, 0, 0, 0, 149, 455);
INSERT INTO public.europe_data VALUES (10169, 0, 4, 0.02, 202, 455);
INSERT INTO public.europe_data VALUES (10170, 0, 0, 0, 150, 455);
INSERT INTO public.europe_data VALUES (10171, 0, 0, 0, 151, 455);
INSERT INTO public.europe_data VALUES (10172, 0, 0, 0, 106, 455);
INSERT INTO public.europe_data VALUES (10173, 0, 0, 0, 152, 455);
INSERT INTO public.europe_data VALUES (10174, 0, 0, 0, 153, 455);
INSERT INTO public.europe_data VALUES (10175, 0, 0, 0, 66, 455);
INSERT INTO public.europe_data VALUES (10176, 0, 0, 0, 110, 455);
INSERT INTO public.europe_data VALUES (10177, 0, 1, 0, 68, 455);
INSERT INTO public.europe_data VALUES (10178, 0, 0, 0, 215, 455);
INSERT INTO public.europe_data VALUES (10179, 78, 2540, 0.19, 111, 455);
INSERT INTO public.europe_data VALUES (10180, 0, 0, 0, 156, 455);
INSERT INTO public.europe_data VALUES (10181, 0, 0, 0, 158, 455);
INSERT INTO public.europe_data VALUES (10182, 0, 0, 0, 159, 455);
INSERT INTO public.europe_data VALUES (10183, 0, 0, 0, 76, 455);
INSERT INTO public.europe_data VALUES (10184, 0, 0, 0, 77, 455);
INSERT INTO public.europe_data VALUES (10185, 0, 0, 0, 16, 455);
INSERT INTO public.europe_data VALUES (10186, 0, 0, 0, 160, 455);
INSERT INTO public.europe_data VALUES (10187, 0, 0, 0, 162, 455);
INSERT INTO public.europe_data VALUES (10188, 0, 3, 0, 163, 455);
INSERT INTO public.europe_data VALUES (10189, 0, 0, 0, 164, 455);
INSERT INTO public.europe_data VALUES (10190, 0, 0, 0, 165, 455);
INSERT INTO public.europe_data VALUES (10191, 0, 0, 0, 167, 455);
INSERT INTO public.europe_data VALUES (10192, 0, 0, 0, 171, 455);
INSERT INTO public.europe_data VALUES (10193, 0, 0, 0, 112, 455);
INSERT INTO public.europe_data VALUES (10194, 0, 0, 0, 113, 455);
INSERT INTO public.europe_data VALUES (10195, 0, 0, 0, 114, 455);
INSERT INTO public.europe_data VALUES (10196, 0, 0, 0, 115, 455);
INSERT INTO public.europe_data VALUES (10197, 0, 0, 0, 172, 455);
INSERT INTO public.europe_data VALUES (10198, 0, 0, 0, 116, 455);
INSERT INTO public.europe_data VALUES (10199, 0, 0, 0, 174, 455);
INSERT INTO public.europe_data VALUES (10200, 0, 2, 0, 117, 455);
INSERT INTO public.europe_data VALUES (10201, 0, 0, 0, 120, 455);
INSERT INTO public.europe_data VALUES (10202, 0, 0, 0, 123, 455);
INSERT INTO public.europe_data VALUES (10203, 0, 0, 0, 179, 455);
INSERT INTO public.europe_data VALUES (10204, 0, 0, 0, 180, 455);
INSERT INTO public.europe_data VALUES (10205, 0, 4, 0.01, 124, 455);
INSERT INTO public.europe_data VALUES (10206, 0, 0, 0, 87, 455);
INSERT INTO public.europe_data VALUES (10207, 0, 0, 0, 183, 455);
INSERT INTO public.europe_data VALUES (10208, 0, 1, 0, 128, 455);
INSERT INTO public.europe_data VALUES (10209, 0, 0, 0, 185, 455);
INSERT INTO public.europe_data VALUES (10210, 0, 0, 0, 209, 455);
INSERT INTO public.europe_data VALUES (10211, 0, 0, 0, 39, 455);
INSERT INTO public.europe_data VALUES (10212, 0, 0, 0, 186, 455);
INSERT INTO public.europe_data VALUES (10213, 0, 0, 0, 187, 455);
INSERT INTO public.europe_data VALUES (10214, 0, 0, 0, 129, 455);
INSERT INTO public.europe_data VALUES (10215, 0, 0, 0, 130, 455);
INSERT INTO public.europe_data VALUES (10216, 0, 0, 0, 132, 455);
INSERT INTO public.europe_data VALUES (10217, 0, 0, 0, 133, 455);
INSERT INTO public.europe_data VALUES (10218, 0, 0, 0, 190, 455);
INSERT INTO public.europe_data VALUES (10219, 0, 0, 0, 191, 455);
INSERT INTO public.europe_data VALUES (10220, 0, 0, 0, 192, 455);
INSERT INTO public.europe_data VALUES (10221, 0, 4, 0.07, 135, 455);
INSERT INTO public.europe_data VALUES (10222, 0, 3, 0.01, 136, 455);
INSERT INTO public.europe_data VALUES (10223, 0, 0, 0, 196, 455);
INSERT INTO public.europe_data VALUES (10224, 0, 0, 0, 137, 455);
INSERT INTO public.europe_data VALUES (10225, 0, 0, 0, 197, 455);
INSERT INTO public.europe_data VALUES (10226, 0, 0, 0, 198, 455);
INSERT INTO public.europe_data VALUES (10227, 0, 5, 0.02, 139, 455);
INSERT INTO public.europe_data VALUES (10228, 0, 6, 0.01, 141, 455);
INSERT INTO public.europe_data VALUES (10229, 0, 1, 0.01, 143, 455);
INSERT INTO public.europe_data VALUES (10230, 0, 0, 0, 201, 455);
INSERT INTO public.europe_data VALUES (10231, 0, 5, 0, 101, 455);
INSERT INTO public.europe_data VALUES (10232, 0, 2, 0, 145, 455);
INSERT INTO public.europe_data VALUES (10233, 0, 0, 0, 105, 456);
INSERT INTO public.europe_data VALUES (10234, 0, 0, 0, 1, 456);
INSERT INTO public.europe_data VALUES (10235, 0, 0, 0, 149, 456);
INSERT INTO public.europe_data VALUES (10236, 0, 0, 0, 202, 456);
INSERT INTO public.europe_data VALUES (10237, 0, 0, 0, 150, 456);
INSERT INTO public.europe_data VALUES (10238, 0, 0, 0, 151, 456);
INSERT INTO public.europe_data VALUES (10239, 0, 0, 0, 106, 456);
INSERT INTO public.europe_data VALUES (10240, 0, 0, 0, 152, 456);
INSERT INTO public.europe_data VALUES (10241, 0, 0, 0, 153, 456);
INSERT INTO public.europe_data VALUES (10242, 0, 0, 0, 66, 456);
INSERT INTO public.europe_data VALUES (10243, 0, 0, 0, 110, 456);
INSERT INTO public.europe_data VALUES (10244, 0, 0, 0, 68, 456);
INSERT INTO public.europe_data VALUES (10245, 0, 0, 0, 215, 456);
INSERT INTO public.europe_data VALUES (10246, 2, 176, 0.01, 111, 456);
INSERT INTO public.europe_data VALUES (10247, 0, 0, 0, 156, 456);
INSERT INTO public.europe_data VALUES (10248, 0, 0, 0, 158, 456);
INSERT INTO public.europe_data VALUES (10249, 0, 0, 0, 159, 456);
INSERT INTO public.europe_data VALUES (10250, 0, 0, 0, 76, 456);
INSERT INTO public.europe_data VALUES (10251, 0, 0, 0, 77, 456);
INSERT INTO public.europe_data VALUES (10252, 0, 0, 0, 16, 456);
INSERT INTO public.europe_data VALUES (10253, 0, 0, 0, 160, 456);
INSERT INTO public.europe_data VALUES (10254, 0, 0, 0, 162, 456);
INSERT INTO public.europe_data VALUES (10255, 0, 0, 0, 163, 456);
INSERT INTO public.europe_data VALUES (10256, 0, 0, 0, 164, 456);
INSERT INTO public.europe_data VALUES (10257, 0, 0, 0, 165, 456);
INSERT INTO public.europe_data VALUES (10258, 0, 0, 0, 167, 456);
INSERT INTO public.europe_data VALUES (10259, 0, 0, 0, 171, 456);
INSERT INTO public.europe_data VALUES (10260, 0, 0, 0, 112, 456);
INSERT INTO public.europe_data VALUES (10261, 0, 0, 0, 113, 456);
INSERT INTO public.europe_data VALUES (10262, 0, 0, 0, 114, 456);
INSERT INTO public.europe_data VALUES (10263, 0, 0, 0, 115, 456);
INSERT INTO public.europe_data VALUES (10264, 0, 0, 0, 172, 456);
INSERT INTO public.europe_data VALUES (10265, 0, 0, 0, 116, 456);
INSERT INTO public.europe_data VALUES (10266, 0, 0, 0, 174, 456);
INSERT INTO public.europe_data VALUES (10267, 0, 1, 0, 117, 456);
INSERT INTO public.europe_data VALUES (10268, 0, 0, 0, 120, 456);
INSERT INTO public.europe_data VALUES (10269, 0, 0, 0, 123, 456);
INSERT INTO public.europe_data VALUES (10270, 0, 0, 0, 179, 456);
INSERT INTO public.europe_data VALUES (10271, 0, 0, 0, 180, 456);
INSERT INTO public.europe_data VALUES (10272, 0, 0, 0, 124, 456);
INSERT INTO public.europe_data VALUES (10273, 0, 1, 0, 87, 456);
INSERT INTO public.europe_data VALUES (10274, 0, 0, 0, 183, 456);
INSERT INTO public.europe_data VALUES (10275, 0, 0, 0, 128, 456);
INSERT INTO public.europe_data VALUES (10276, 0, 0, 0, 185, 456);
INSERT INTO public.europe_data VALUES (10277, 0, 0, 0, 209, 456);
INSERT INTO public.europe_data VALUES (10278, 0, 0, 0, 39, 456);
INSERT INTO public.europe_data VALUES (10279, 0, 0, 0, 186, 456);
INSERT INTO public.europe_data VALUES (10280, 0, 0, 0, 187, 456);
INSERT INTO public.europe_data VALUES (10281, 0, 0, 0, 129, 456);
INSERT INTO public.europe_data VALUES (10282, 0, 0, 0, 130, 456);
INSERT INTO public.europe_data VALUES (10283, 0, 0, 0, 132, 456);
INSERT INTO public.europe_data VALUES (10284, 0, 0, 0, 133, 456);
INSERT INTO public.europe_data VALUES (10285, 0, 0, 0, 190, 456);
INSERT INTO public.europe_data VALUES (10286, 0, 0, 0, 191, 456);
INSERT INTO public.europe_data VALUES (10287, 0, 0, 0, 192, 456);
INSERT INTO public.europe_data VALUES (10288, 0, 0, 0, 135, 456);
INSERT INTO public.europe_data VALUES (10289, 0, 1, 0, 136, 456);
INSERT INTO public.europe_data VALUES (10290, 0, 0, 0, 196, 456);
INSERT INTO public.europe_data VALUES (10291, 0, 0, 0, 137, 456);
INSERT INTO public.europe_data VALUES (10292, 0, 0, 0, 197, 456);
INSERT INTO public.europe_data VALUES (10293, 0, 0, 0, 198, 456);
INSERT INTO public.europe_data VALUES (10294, 0, 0, 0, 139, 456);
INSERT INTO public.europe_data VALUES (10295, 0, 1, 0, 141, 456);
INSERT INTO public.europe_data VALUES (10296, 0, 0, 0, 143, 456);
INSERT INTO public.europe_data VALUES (10297, 0, 0, 0, 201, 456);
INSERT INTO public.europe_data VALUES (10298, 0, 0, 0, 101, 456);
INSERT INTO public.europe_data VALUES (10299, 0, 0, 0, 145, 456);
INSERT INTO public.europe_data VALUES (10300, 0, 0, 0, 105, 457);
INSERT INTO public.europe_data VALUES (10301, 0, 0, 0, 1, 457);
INSERT INTO public.europe_data VALUES (10302, 0, 0, 0, 149, 457);
INSERT INTO public.europe_data VALUES (10303, 0, 0, 0, 202, 457);
INSERT INTO public.europe_data VALUES (10304, 0, 0, 0, 150, 457);
INSERT INTO public.europe_data VALUES (10305, 0, 0, 0, 151, 457);
INSERT INTO public.europe_data VALUES (10306, 0, 0, 0, 106, 457);
INSERT INTO public.europe_data VALUES (10307, 0, 0, 0, 152, 457);
INSERT INTO public.europe_data VALUES (10308, 0, 0, 0, 153, 457);
INSERT INTO public.europe_data VALUES (10309, 0, 0, 0, 66, 457);
INSERT INTO public.europe_data VALUES (10310, 0, 0, 0, 110, 457);
INSERT INTO public.europe_data VALUES (10311, 0, 0, 0, 68, 457);
INSERT INTO public.europe_data VALUES (10312, 0, 0, 0, 215, 457);
INSERT INTO public.europe_data VALUES (10313, 1, 0, 0, 111, 457);
INSERT INTO public.europe_data VALUES (10314, 0, 0, 0, 156, 457);
INSERT INTO public.europe_data VALUES (10315, 0, 0, 0, 158, 457);
INSERT INTO public.europe_data VALUES (10316, 0, 0, 0, 159, 457);
INSERT INTO public.europe_data VALUES (10317, 0, 0, 0, 76, 457);
INSERT INTO public.europe_data VALUES (10318, 0, 0, 0, 77, 457);
INSERT INTO public.europe_data VALUES (10319, 0, 0, 0, 16, 457);
INSERT INTO public.europe_data VALUES (10320, 0, 0, 0, 160, 457);
INSERT INTO public.europe_data VALUES (10321, 0, 0, 0, 162, 457);
INSERT INTO public.europe_data VALUES (10322, 0, 0, 0, 163, 457);
INSERT INTO public.europe_data VALUES (10323, 0, 0, 0, 164, 457);
INSERT INTO public.europe_data VALUES (10324, 0, 0, 0, 165, 457);
INSERT INTO public.europe_data VALUES (10325, 0, 0, 0, 167, 457);
INSERT INTO public.europe_data VALUES (10326, 0, 0, 0, 171, 457);
INSERT INTO public.europe_data VALUES (10327, 0, 0, 0, 112, 457);
INSERT INTO public.europe_data VALUES (10328, 0, 0, 0, 113, 457);
INSERT INTO public.europe_data VALUES (10329, 0, 0, 0, 114, 457);
INSERT INTO public.europe_data VALUES (10330, 0, 0, 0, 115, 457);
INSERT INTO public.europe_data VALUES (10331, 0, 0, 0, 172, 457);
INSERT INTO public.europe_data VALUES (10332, 0, 0, 0, 116, 457);
INSERT INTO public.europe_data VALUES (10333, 0, 0, 0, 174, 457);
INSERT INTO public.europe_data VALUES (10334, 0, 0, 0, 117, 457);
INSERT INTO public.europe_data VALUES (10335, 0, 0, 0, 120, 457);
INSERT INTO public.europe_data VALUES (10336, 0, 0, 0, 123, 457);
INSERT INTO public.europe_data VALUES (10337, 0, 0, 0, 179, 457);
INSERT INTO public.europe_data VALUES (10338, 0, 0, 0, 180, 457);
INSERT INTO public.europe_data VALUES (10339, 0, 0, 0, 124, 457);
INSERT INTO public.europe_data VALUES (10340, 0, 0, 0, 87, 457);
INSERT INTO public.europe_data VALUES (10341, 0, 0, 0, 183, 457);
INSERT INTO public.europe_data VALUES (10342, 0, 0, 0, 128, 457);
INSERT INTO public.europe_data VALUES (10343, 0, 0, 0, 185, 457);
INSERT INTO public.europe_data VALUES (10344, 0, 0, 0, 209, 457);
INSERT INTO public.europe_data VALUES (10345, 0, 0, 0, 39, 457);
INSERT INTO public.europe_data VALUES (10346, 0, 0, 0, 186, 457);
INSERT INTO public.europe_data VALUES (10347, 0, 0, 0, 187, 457);
INSERT INTO public.europe_data VALUES (10348, 0, 0, 0, 129, 457);
INSERT INTO public.europe_data VALUES (10349, 0, 0, 0, 130, 457);
INSERT INTO public.europe_data VALUES (10350, 0, 0, 0, 132, 457);
INSERT INTO public.europe_data VALUES (10351, 0, 0, 0, 133, 457);
INSERT INTO public.europe_data VALUES (10352, 0, 0, 0, 190, 457);
INSERT INTO public.europe_data VALUES (10353, 0, 0, 0, 191, 457);
INSERT INTO public.europe_data VALUES (10354, 0, 0, 0, 192, 457);
INSERT INTO public.europe_data VALUES (10355, 0, 0, 0, 135, 457);
INSERT INTO public.europe_data VALUES (10356, 0, 0, 0, 136, 457);
INSERT INTO public.europe_data VALUES (10357, 0, 0, 0, 196, 457);
INSERT INTO public.europe_data VALUES (10358, 0, 0, 0, 137, 457);
INSERT INTO public.europe_data VALUES (10359, 0, 0, 0, 197, 457);
INSERT INTO public.europe_data VALUES (10360, 0, 0, 0, 198, 457);
INSERT INTO public.europe_data VALUES (10361, 0, 0, 0, 139, 457);
INSERT INTO public.europe_data VALUES (10362, 0, 1, 0, 141, 457);
INSERT INTO public.europe_data VALUES (10363, 0, 0, 0, 143, 457);
INSERT INTO public.europe_data VALUES (10364, 0, 0, 0, 201, 457);
INSERT INTO public.europe_data VALUES (10365, 0, 0, 0, 101, 457);
INSERT INTO public.europe_data VALUES (10366, 0, 0, 0, 145, 457);


--
-- Data for Name: europe_data_import; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.europe_data_import VALUES (1, '01/02/2021', '2021-04', '267', '16', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.58');
INSERT INTO public.europe_data_import VALUES (2, '25/01/2021', '2021-03', '713', '43', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '3.34');
INSERT INTO public.europe_data_import VALUES (3, '18/01/2021', '2021-02', '557', '45', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '3.24');
INSERT INTO public.europe_data_import VALUES (4, '11/01/2021', '2021-01', '675', '71', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '4.15');
INSERT INTO public.europe_data_import VALUES (5, '04/01/2021', '2020-53', '902', '60', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '7.61');
INSERT INTO public.europe_data_import VALUES (6, '28/12/2020', '2020-52', '1994', '88', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '7.19');
INSERT INTO public.europe_data_import VALUES (7, '21/12/2020', '2020-51', '740', '111', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '6.56');
INSERT INTO public.europe_data_import VALUES (8, '14/12/2020', '2020-50', '1757', '71', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '9.01');
INSERT INTO public.europe_data_import VALUES (9, '07/12/2020', '2020-49', '1672', '137', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '7.22');
INSERT INTO public.europe_data_import VALUES (10, '30/11/2020', '2020-48', '1073', '68', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '6.42');
INSERT INTO public.europe_data_import VALUES (11, '23/11/2020', '2020-47', '1368', '69', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '6.66');
INSERT INTO public.europe_data_import VALUES (12, '16/11/2020', '2020-46', '1164', '61', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '4.65');
INSERT INTO public.europe_data_import VALUES (13, '09/11/2020', '2020-45', '606', '24', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '3.7');
INSERT INTO public.europe_data_import VALUES (14, '02/11/2020', '2020-44', '800', '27', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '3.77');
INSERT INTO public.europe_data_import VALUES (15, '26/10/2020', '2020-43', '633', '22', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.72');
INSERT INTO public.europe_data_import VALUES (16, '19/10/2020', '2020-42', '401', '15', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.26');
INSERT INTO public.europe_data_import VALUES (17, '12/10/2020', '2020-41', '458', '15', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.5');
INSERT INTO public.europe_data_import VALUES (18, '05/10/2020', '2020-40', '114', '9', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.78');
INSERT INTO public.europe_data_import VALUES (19, '28/09/2020', '2020-39', '183', '12', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.34');
INSERT INTO public.europe_data_import VALUES (20, '21/09/2020', '2020-38', '328', '21', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.7');
INSERT INTO public.europe_data_import VALUES (21, '14/09/2020', '2020-37', '318', '8', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.46');
INSERT INTO public.europe_data_import VALUES (22, '07/09/2020', '2020-36', '236', '10', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.05');
INSERT INTO public.europe_data_import VALUES (23, '31/08/2020', '2020-35', '163', '15', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.49');
INSERT INTO public.europe_data_import VALUES (24, '24/08/2020', '2020-34', '403', '12', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.48');
INSERT INTO public.europe_data_import VALUES (25, '17/08/2020', '2020-33', '542', '63', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.33');
INSERT INTO public.europe_data_import VALUES (26, '10/08/2020', '2020-32', '344', '28', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.08');
INSERT INTO public.europe_data_import VALUES (27, '03/08/2020', '2020-31', '447', '15', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '3.25');
INSERT INTO public.europe_data_import VALUES (28, '27/07/2020', '2020-30', '788', '88', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '4.76');
INSERT INTO public.europe_data_import VALUES (29, '20/07/2020', '2020-29', '1024', '171', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '6.63');
INSERT INTO public.europe_data_import VALUES (30, '13/07/2020', '2020-28', '1500', '146', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '9.16');
INSERT INTO public.europe_data_import VALUES (31, '06/07/2020', '2020-27', '1984', '143', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '10.82');
INSERT INTO public.europe_data_import VALUES (32, '29/06/2020', '2020-26', '2134', '140', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '16.3');
INSERT INTO public.europe_data_import VALUES (33, '22/06/2020', '2020-25', '4067', '110', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '22.32');
INSERT INTO public.europe_data_import VALUES (34, '15/06/2020', '2020-24', '4424', '114', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '25.13');
INSERT INTO public.europe_data_import VALUES (35, '08/06/2020', '2020-23', '5137', '100', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '25.66');
INSERT INTO public.europe_data_import VALUES (36, '01/06/2020', '2020-22', '4623', '39', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '22.45');
INSERT INTO public.europe_data_import VALUES (37, '25/05/2020', '2020-21', '3918', '49', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '16.25');
INSERT INTO public.europe_data_import VALUES (38, '18/05/2020', '2020-20', '2262', '49', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '10.41');
INSERT INTO public.europe_data_import VALUES (39, '11/05/2020', '2020-19', '1698', '35', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '7.55');
INSERT INTO public.europe_data_import VALUES (40, '04/05/2020', '2020-18', '1173', '28', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '4.49');
INSERT INTO public.europe_data_import VALUES (41, '27/04/2020', '2020-17', '535', '24', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '2.43');
INSERT INTO public.europe_data_import VALUES (42, '20/04/2020', '2020-16', '389', '15', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.83');
INSERT INTO public.europe_data_import VALUES (43, '13/04/2020', '2020-15', '308', '11', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '1.3');
INSERT INTO public.europe_data_import VALUES (44, '06/04/2020', '2020-14', '185', '3', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.7');
INSERT INTO public.europe_data_import VALUES (45, '30/03/2020', '2020-13', '80', '4', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (46, '23/03/2020', '2020-12', '18', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (47, '16/03/2020', '2020-11', '12', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (48, '09/03/2020', '2020-10', '3', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (49, '02/03/2020', '2020-09', '1', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (50, '24/02/2020', '2020-08', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (51, '17/02/2020', '2020-07', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (52, '10/02/2020', '2020-06', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (53, '03/02/2020', '2020-05', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (54, '27/01/2020', '2020-04', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (55, '20/01/2020', '2020-03', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (56, '13/01/2020', '2020-02', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (57, '06/01/2020', '2020-01', '0', '0', '38041757', 'Afghanistan', 'AF', 'AFG', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (58, '01/02/2021', '2021-04', '5853', '65', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '364.62');
INSERT INTO public.europe_data_import VALUES (59, '25/01/2021', '2021-03', '4584', '38', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '303.2');
INSERT INTO public.europe_data_import VALUES (60, '18/01/2021', '2021-02', '4095', '36', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '288.29');
INSERT INTO public.europe_data_import VALUES (61, '11/01/2021', '2021-01', '4157', '48', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '245.35');
INSERT INTO public.europe_data_import VALUES (62, '04/01/2021', '2020-53', '2866', '29', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '224.81');
INSERT INTO public.europe_data_import VALUES (63, '28/12/2020', '2020-52', '3569', '76', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '280.95');
INSERT INTO public.europe_data_import VALUES (64, '21/12/2020', '2020-51', '4473', '85', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '349.88');
INSERT INTO public.europe_data_import VALUES (65, '14/12/2020', '2020-50', '5542', '98', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '380.97');
INSERT INTO public.europe_data_import VALUES (66, '07/12/2020', '2020-49', '5363', '107', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '357.28');
INSERT INTO public.europe_data_import VALUES (67, '30/11/2020', '2020-48', '4864', '99', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '342.19');
INSERT INTO public.europe_data_import VALUES (68, '23/11/2020', '2020-47', '4931', '76', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '298.87');
INSERT INTO public.europe_data_import VALUES (69, '16/11/2020', '2020-46', '3624', '64', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '231.55');
INSERT INTO public.europe_data_import VALUES (70, '09/11/2020', '2020-45', '3004', '41', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '176.39');
INSERT INTO public.europe_data_import VALUES (71, '02/11/2020', '2020-44', '2045', '41', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '144.88');
INSERT INTO public.europe_data_import VALUES (72, '26/10/2020', '2020-43', '2102', '26', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '131.29');
INSERT INTO public.europe_data_import VALUES (73, '19/10/2020', '2020-42', '1656', '31', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '97.43');
INSERT INTO public.europe_data_import VALUES (74, '12/10/2020', '2020-41', '1133', '24', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '74.76');
INSERT INTO public.europe_data_import VALUES (75, '05/10/2020', '2020-40', '1007', '19', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '65.71');
INSERT INTO public.europe_data_import VALUES (76, '28/09/2020', '2020-39', '874', '15', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '66.59');
INSERT INTO public.europe_data_import VALUES (77, '21/09/2020', '2020-38', '1032', '28', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '74.41');
INSERT INTO public.europe_data_import VALUES (78, '14/09/2020', '2020-37', '1098', '18', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '68.93');
INSERT INTO public.europe_data_import VALUES (79, '07/09/2020', '2020-36', '875', '36', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '63.86');
INSERT INTO public.europe_data_import VALUES (80, '31/08/2020', '2020-35', '953', '30', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '69.87');
INSERT INTO public.europe_data_import VALUES (81, '24/08/2020', '2020-34', '1047', '22', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '70.43');
INSERT INTO public.europe_data_import VALUES (82, '17/08/2020', '2020-33', '969', '29', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '65.01');
INSERT INTO public.europe_data_import VALUES (83, '10/08/2020', '2020-32', '892', '33', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '57.57');
INSERT INTO public.europe_data_import VALUES (84, '03/08/2020', '2020-31', '756', '28', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '49.92');
INSERT INTO public.europe_data_import VALUES (85, '27/07/2020', '2020-30', '673', '26', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '45.73');
INSERT INTO public.europe_data_import VALUES (86, '20/07/2020', '2020-29', '636', '19', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '41.82');
INSERT INTO public.europe_data_import VALUES (87, '13/07/2020', '2020-28', '561', '17', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '36.75');
INSERT INTO public.europe_data_import VALUES (88, '06/07/2020', '2020-27', '491', '21', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '33.75');
INSERT INTO public.europe_data_import VALUES (89, '29/06/2020', '2020-26', '475', '11', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '30.78');
INSERT INTO public.europe_data_import VALUES (90, '22/06/2020', '2020-25', '406', '8', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '23.79');
INSERT INTO public.europe_data_import VALUES (91, '15/06/2020', '2020-24', '275', '2', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '13.42');
INSERT INTO public.europe_data_import VALUES (92, '08/06/2020', '2020-23', '109', '1', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '8.66');
INSERT INTO public.europe_data_import VALUES (93, '01/06/2020', '2020-22', '139', '1', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '6.67');
INSERT INTO public.europe_data_import VALUES (94, '25/05/2020', '2020-21', '52', '1', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '4.54');
INSERT INTO public.europe_data_import VALUES (95, '18/05/2020', '2020-20', '78', '0', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '5.28');
INSERT INTO public.europe_data_import VALUES (96, '11/05/2020', '2020-19', '73', '0', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '4.96');
INSERT INTO public.europe_data_import VALUES (97, '04/05/2020', '2020-18', '69', '3', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '8.14');
INSERT INTO public.europe_data_import VALUES (98, '27/04/2020', '2020-17', '164', '2', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '9.78');
INSERT INTO public.europe_data_import VALUES (99, '20/04/2020', '2020-16', '116', '3', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '7.02');
INSERT INTO public.europe_data_import VALUES (100, '13/04/2020', '2020-15', '85', '2', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '8.17');
INSERT INTO public.europe_data_import VALUES (101, '06/04/2020', '2020-14', '149', '11', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '9.5');
INSERT INTO public.europe_data_import VALUES (102, '30/03/2020', '2020-13', '123', '8', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '5.94');
INSERT INTO public.europe_data_import VALUES (103, '23/03/2020', '2020-12', '47', '1', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '3.04');
INSERT INTO public.europe_data_import VALUES (104, '16/03/2020', '2020-11', '40', '1', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '1.47');
INSERT INTO public.europe_data_import VALUES (105, '09/03/2020', '2020-10', '2', '0', '2862427', 'Albania', 'AL', 'ALB', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (106, '01/02/2021', '2021-04', '1743', '28', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '8.14');
INSERT INTO public.europe_data_import VALUES (107, '25/01/2021', '2021-03', '1763', '27', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '8.02');
INSERT INTO public.europe_data_import VALUES (108, '18/01/2021', '2021-02', '1689', '29', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '7.96');
INSERT INTO public.europe_data_import VALUES (109, '11/01/2021', '2021-01', '1736', '35', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '8.16');
INSERT INTO public.europe_data_import VALUES (110, '04/01/2021', '2020-53', '1777', '35', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '12.09');
INSERT INTO public.europe_data_import VALUES (111, '28/12/2020', '2020-52', '3428', '71', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '15.17');
INSERT INTO public.europe_data_import VALUES (112, '21/12/2020', '2020-51', '3101', '70', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '16.15');
INSERT INTO public.europe_data_import VALUES (113, '14/12/2020', '2020-50', '3850', '80', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '22.95');
INSERT INTO public.europe_data_import VALUES (114, '07/12/2020', '2020-49', '6031', '106', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '31.1');
INSERT INTO public.europe_data_import VALUES (115, '30/11/2020', '2020-48', '7359', '135', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '33.78');
INSERT INTO public.europe_data_import VALUES (116, '23/11/2020', '2020-47', '7183', '121', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '29.76');
INSERT INTO public.europe_data_import VALUES (117, '16/11/2020', '2020-46', '5628', '106', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '21.85');
INSERT INTO public.europe_data_import VALUES (118, '09/11/2020', '2020-45', '3779', '75', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '13.72');
INSERT INTO public.europe_data_import VALUES (119, '02/11/2020', '2020-44', '2129', '59', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '8.99');
INSERT INTO public.europe_data_import VALUES (120, '26/10/2020', '2020-43', '1741', '58', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '7.13');
INSERT INTO public.europe_data_import VALUES (121, '19/10/2020', '2020-42', '1330', '55', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '5.26');
INSERT INTO public.europe_data_import VALUES (122, '12/10/2020', '2020-41', '936', '41', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '4.66');
INSERT INTO public.europe_data_import VALUES (123, '05/10/2020', '2020-40', '1069', '46', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '5.37');
INSERT INTO public.europe_data_import VALUES (124, '28/09/2020', '2020-39', '1241', '42', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '6.53');
INSERT INTO public.europe_data_import VALUES (125, '21/09/2020', '2020-38', '1572', '60', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '8.04');
INSERT INTO public.europe_data_import VALUES (126, '14/09/2020', '2020-37', '1890', '56', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '9.54');
INSERT INTO public.europe_data_import VALUES (127, '07/09/2020', '2020-36', '2218', '55', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '11.39');
INSERT INTO public.europe_data_import VALUES (128, '31/08/2020', '2020-35', '2686', '66', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '12.92');
INSERT INTO public.europe_data_import VALUES (129, '24/08/2020', '2020-34', '2877', '65', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '14.51');
INSERT INTO public.europe_data_import VALUES (130, '17/08/2020', '2020-33', '3369', '68', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '16.53');
INSERT INTO public.europe_data_import VALUES (131, '10/08/2020', '2020-32', '3749', '71', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '18.25');
INSERT INTO public.europe_data_import VALUES (132, '03/08/2020', '2020-31', '4108', '76', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '19.47');
INSERT INTO public.europe_data_import VALUES (133, '27/07/2020', '2020-30', '4273', '77', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '18.96');
INSERT INTO public.europe_data_import VALUES (134, '20/07/2020', '2020-29', '3889', '67', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '16.59');
INSERT INTO public.europe_data_import VALUES (135, '13/07/2020', '2020-28', '3254', '59', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '13.76');
INSERT INTO public.europe_data_import VALUES (136, '06/07/2020', '2020-27', '2668', '55', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '9.69');
INSERT INTO public.europe_data_import VALUES (137, '29/06/2020', '2020-26', '1502', '52', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '5.47');
INSERT INTO public.europe_data_import VALUES (138, '22/06/2020', '2020-25', '852', '78', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '3.76');
INSERT INTO public.europe_data_import VALUES (139, '15/06/2020', '2020-24', '765', '60', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '3.54');
INSERT INTO public.europe_data_import VALUES (140, '08/06/2020', '2020-23', '760', '54', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '4.29');
INSERT INTO public.europe_data_import VALUES (141, '01/06/2020', '2020-22', '1088', '53', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '5.52');
INSERT INTO public.europe_data_import VALUES (142, '25/05/2020', '2020-21', '1287', '52', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '6.0');
INSERT INTO public.europe_data_import VALUES (143, '18/05/2020', '2020-20', '1296', '46', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '5.91');
INSERT INTO public.europe_data_import VALUES (144, '11/05/2020', '2020-19', '1249', '39', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '5.44');
INSERT INTO public.europe_data_import VALUES (145, '04/05/2020', '2020-18', '1092', '38', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '4.29');
INSERT INTO public.europe_data_import VALUES (146, '27/04/2020', '2020-17', '753', '50', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '3.41');
INSERT INTO public.europe_data_import VALUES (147, '20/04/2020', '2020-16', '715', '82', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '3.04');
INSERT INTO public.europe_data_import VALUES (148, '13/04/2020', '2020-15', '594', '141', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '3.26');
INSERT INTO public.europe_data_import VALUES (149, '06/04/2020', '2020-14', '809', '121', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '2.6');
INSERT INTO public.europe_data_import VALUES (150, '30/03/2020', '2020-13', '310', '14', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '1.08');
INSERT INTO public.europe_data_import VALUES (151, '23/03/2020', '2020-12', '153', '13', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (152, '16/03/2020', '2020-11', '28', '4', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (153, '09/03/2020', '2020-10', '17', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (154, '02/03/2020', '2020-09', '3', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0.01');
INSERT INTO public.europe_data_import VALUES (155, '24/02/2020', '2020-08', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (156, '17/02/2020', '2020-07', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (157, '10/02/2020', '2020-06', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (158, '03/02/2020', '2020-05', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (159, '27/01/2020', '2020-04', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (160, '20/01/2020', '2020-03', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (161, '13/01/2020', '2020-02', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (162, '06/01/2020', '2020-01', '0', '0', '43053054', 'Algeria', 'DZ', 'DZA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (163, '01/02/2021', '2021-04', '388', '5', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1121.07');
INSERT INTO public.europe_data_import VALUES (164, '25/01/2021', '2021-03', '466', '5', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1138.14');
INSERT INTO public.europe_data_import VALUES (165, '18/01/2021', '2021-02', '401', '5', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1169.64');
INSERT INTO public.europe_data_import VALUES (166, '11/01/2021', '2021-01', '490', '2', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1437.44');
INSERT INTO public.europe_data_import VALUES (167, '04/01/2021', '2020-53', '605', '2', '76177', 'Andorra', 'AD', 'AND', 'Europe', '807.33');
INSERT INTO public.europe_data_import VALUES (168, '28/12/2020', '2020-52', '10', '1', '76177', 'Andorra', 'AD', 'AND', 'Europe', '326.87');
INSERT INTO public.europe_data_import VALUES (169, '21/12/2020', '2020-51', '239', '2', '76177', 'Andorra', 'AD', 'AND', 'Europe', '691.81');
INSERT INTO public.europe_data_import VALUES (170, '14/12/2020', '2020-50', '288', '1', '76177', 'Andorra', 'AD', 'AND', 'Europe', '821.77');
INSERT INTO public.europe_data_import VALUES (171, '07/12/2020', '2020-49', '338', '2', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1042.31');
INSERT INTO public.europe_data_import VALUES (172, '30/11/2020', '2020-48', '456', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1102.7');
INSERT INTO public.europe_data_import VALUES (173, '23/11/2020', '2020-47', '384', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1146.02');
INSERT INTO public.europe_data_import VALUES (174, '16/11/2020', '2020-46', '489', '1', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1374.43');
INSERT INTO public.europe_data_import VALUES (175, '09/11/2020', '2020-45', '558', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1765.62');
INSERT INTO public.europe_data_import VALUES (176, '02/11/2020', '2020-44', '787', '6', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1900.84');
INSERT INTO public.europe_data_import VALUES (177, '26/10/2020', '2020-43', '661', '10', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1761.69');
INSERT INTO public.europe_data_import VALUES (178, '19/10/2020', '2020-42', '681', '4', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1663.23');
INSERT INTO public.europe_data_import VALUES (179, '12/10/2020', '2020-41', '586', '2', '76177', 'Andorra', 'AD', 'AND', 'Europe', '1128.95');
INSERT INTO public.europe_data_import VALUES (180, '05/10/2020', '2020-40', '274', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '716.75');
INSERT INTO public.europe_data_import VALUES (181, '28/09/2020', '2020-39', '272', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '645.86');
INSERT INTO public.europe_data_import VALUES (182, '21/09/2020', '2020-38', '220', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '458.14');
INSERT INTO public.europe_data_import VALUES (183, '14/09/2020', '2020-37', '129', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '288.8');
INSERT INTO public.europe_data_import VALUES (184, '07/09/2020', '2020-36', '91', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '223.16');
INSERT INTO public.europe_data_import VALUES (185, '31/08/2020', '2020-35', '79', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '177.22');
INSERT INTO public.europe_data_import VALUES (186, '24/08/2020', '2020-34', '56', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '116.83');
INSERT INTO public.europe_data_import VALUES (187, '17/08/2020', '2020-33', '33', '1', '76177', 'Andorra', 'AD', 'AND', 'Europe', '84.01');
INSERT INTO public.europe_data_import VALUES (188, '10/08/2020', '2020-32', '31', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '77.45');
INSERT INTO public.europe_data_import VALUES (189, '03/08/2020', '2020-31', '28', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '59.07');
INSERT INTO public.europe_data_import VALUES (190, '27/07/2020', '2020-30', '17', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '55.13');
INSERT INTO public.europe_data_import VALUES (191, '20/07/2020', '2020-29', '25', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '32.82');
INSERT INTO public.europe_data_import VALUES (192, '13/07/2020', '2020-28', '0', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (193, '06/07/2020', '2020-27', '0', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (194, '29/06/2020', '2020-26', '0', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '2.63');
INSERT INTO public.europe_data_import VALUES (195, '22/06/2020', '2020-25', '2', '1', '76177', 'Andorra', 'AD', 'AND', 'Europe', '3.94');
INSERT INTO public.europe_data_import VALUES (196, '15/06/2020', '2020-24', '1', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '116.83');
INSERT INTO public.europe_data_import VALUES (197, '08/06/2020', '2020-23', '88', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '116.83');
INSERT INTO public.europe_data_import VALUES (198, '01/06/2020', '2020-22', '1', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '3.94');
INSERT INTO public.europe_data_import VALUES (199, '25/05/2020', '2020-21', '2', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '10.5');
INSERT INTO public.europe_data_import VALUES (200, '18/05/2020', '2020-20', '6', '3', '76177', 'Andorra', 'AD', 'AND', 'Europe', '17.07');
INSERT INTO public.europe_data_import VALUES (201, '11/05/2020', '2020-19', '7', '3', '76177', 'Andorra', 'AD', 'AND', 'Europe', '19.69');
INSERT INTO public.europe_data_import VALUES (202, '04/05/2020', '2020-18', '8', '5', '76177', 'Andorra', 'AD', 'AND', 'Europe', '45.95');
INSERT INTO public.europe_data_import VALUES (203, '27/04/2020', '2020-17', '27', '4', '76177', 'Andorra', 'AD', 'AND', 'Europe', '133.9');
INSERT INTO public.europe_data_import VALUES (204, '20/04/2020', '2020-16', '75', '7', '76177', 'Andorra', 'AD', 'AND', 'Europe', '278.3');
INSERT INTO public.europe_data_import VALUES (205, '13/04/2020', '2020-15', '137', '11', '76177', 'Andorra', 'AD', 'AND', 'Europe', '399.07');
INSERT INTO public.europe_data_import VALUES (206, '06/04/2020', '2020-14', '167', '12', '76177', 'Andorra', 'AD', 'AND', 'Europe', '509.34');
INSERT INTO public.europe_data_import VALUES (207, '30/03/2020', '2020-13', '221', '6', '76177', 'Andorra', 'AD', 'AND', 'Europe', '431.89');
INSERT INTO public.europe_data_import VALUES (208, '23/03/2020', '2020-12', '108', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '148.34');
INSERT INTO public.europe_data_import VALUES (209, '16/03/2020', '2020-11', '5', '0', '76177', 'Andorra', 'AD', 'AND', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (210, '01/02/2021', '2021-04', '397', '7', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.89');
INSERT INTO public.europe_data_import VALUES (211, '25/01/2021', '2021-03', '524', '23', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.79');
INSERT INTO public.europe_data_import VALUES (212, '18/01/2021', '2021-02', '682', '20', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.87');
INSERT INTO public.europe_data_import VALUES (213, '11/01/2021', '2021-01', '551', '8', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.82');
INSERT INTO public.europe_data_import VALUES (214, '04/01/2021', '2020-53', '346', '5', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.14');
INSERT INTO public.europe_data_import VALUES (215, '28/12/2020', '2020-52', '652', '16', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.48');
INSERT INTO public.europe_data_import VALUES (216, '21/12/2020', '2020-51', '456', '16', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.48');
INSERT INTO public.europe_data_import VALUES (217, '14/12/2020', '2020-50', '652', '17', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.41');
INSERT INTO public.europe_data_import VALUES (218, '07/12/2020', '2020-49', '433', '8', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.28');
INSERT INTO public.europe_data_import VALUES (219, '30/11/2020', '2020-48', '610', '9', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '5.43');
INSERT INTO public.europe_data_import VALUES (220, '23/11/2020', '2020-47', '1119', '15', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '6.78');
INSERT INTO public.europe_data_import VALUES (221, '16/11/2020', '2020-46', '1039', '19', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '8.07');
INSERT INTO public.europe_data_import VALUES (222, '09/11/2020', '2020-45', '1530', '19', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '10.4');
INSERT INTO public.europe_data_import VALUES (223, '02/11/2020', '2020-44', '1779', '17', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '10.5');
INSERT INTO public.europe_data_import VALUES (224, '26/10/2020', '2020-43', '1564', '26', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '8.74');
INSERT INTO public.europe_data_import VALUES (225, '19/10/2020', '2020-42', '1216', '23', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '6.57');
INSERT INTO public.europe_data_import VALUES (226, '12/10/2020', '2020-41', '876', '25', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '4.95');
INSERT INTO public.europe_data_import VALUES (227, '05/10/2020', '2020-40', '698', '22', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '4.33');
INSERT INTO public.europe_data_import VALUES (228, '28/09/2020', '2020-39', '681', '19', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '4.2');
INSERT INTO public.europe_data_import VALUES (229, '21/09/2020', '2020-38', '656', '20', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '3.32');
INSERT INTO public.europe_data_import VALUES (230, '14/09/2020', '2020-37', '400', '15', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.23');
INSERT INTO public.europe_data_import VALUES (231, '07/09/2020', '2020-36', '311', '10', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.4');
INSERT INTO public.europe_data_import VALUES (232, '31/08/2020', '2020-35', '453', '11', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.34');
INSERT INTO public.europe_data_import VALUES (233, '24/08/2020', '2020-34', '292', '10', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '1.88');
INSERT INTO public.europe_data_import VALUES (234, '17/08/2020', '2020-33', '307', '16', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.3');
INSERT INTO public.europe_data_import VALUES (235, '10/08/2020', '2020-32', '424', '18', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '2.02');
INSERT INTO public.europe_data_import VALUES (236, '03/08/2020', '2020-31', '218', '12', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '1.39');
INSERT INTO public.europe_data_import VALUES (237, '27/07/2020', '2020-30', '225', '11', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '1.33');
INSERT INTO public.europe_data_import VALUES (238, '20/07/2020', '2020-29', '199', '3', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '1.13');
INSERT INTO public.europe_data_import VALUES (239, '13/07/2020', '2020-28', '160', '7', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.75');
INSERT INTO public.europe_data_import VALUES (240, '06/07/2020', '2020-27', '79', '8', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (241, '29/06/2020', '2020-26', '91', '2', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (242, '22/06/2020', '2020-25', '36', '3', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (243, '15/06/2020', '2020-24', '49', '2', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (244, '08/06/2020', '2020-23', '5', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (245, '01/06/2020', '2020-22', '17', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (246, '25/05/2020', '2020-21', '21', '2', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (247, '18/05/2020', '2020-20', '3', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (248, '11/05/2020', '2020-19', '10', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (249, '04/05/2020', '2020-18', '9', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (250, '27/04/2020', '2020-17', '2', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (251, '20/04/2020', '2020-16', '5', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (252, '13/04/2020', '2020-15', '5', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (253, '06/04/2020', '2020-14', '7', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (254, '30/03/2020', '2020-13', '5', '2', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (255, '23/03/2020', '2020-12', '2', '0', '31825299', 'Angola', 'AO', 'AGO', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (256, '01/02/2021', '2021-04', '1', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '13.45');
INSERT INTO public.europe_data_import VALUES (257, '25/01/2021', '2021-03', '1', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '6.72');
INSERT INTO public.europe_data_import VALUES (258, '18/01/2021', '2021-02', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (259, '11/01/2021', '2021-01', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '13.45');
INSERT INTO public.europe_data_import VALUES (260, '04/01/2021', '2020-53', '2', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '33.62');
INSERT INTO public.europe_data_import VALUES (261, '28/12/2020', '2020-52', '3', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '20.17');
INSERT INTO public.europe_data_import VALUES (262, '21/12/2020', '2020-51', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '6.72');
INSERT INTO public.europe_data_import VALUES (263, '14/12/2020', '2020-50', '1', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '40.34');
INSERT INTO public.europe_data_import VALUES (264, '07/12/2020', '2020-49', '5', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '33.62');
INSERT INTO public.europe_data_import VALUES (265, '30/11/2020', '2020-48', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '6.72');
INSERT INTO public.europe_data_import VALUES (266, '23/11/2020', '2020-47', '1', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '6.72');
INSERT INTO public.europe_data_import VALUES (267, '16/11/2020', '2020-46', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (268, '09/11/2020', '2020-45', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (269, '02/11/2020', '2020-44', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (270, '26/10/2020', '2020-43', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (271, '19/10/2020', '2020-42', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (272, '12/10/2020', '2020-41', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (273, '05/10/2020', '2020-40', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (274, '28/09/2020', '2020-39', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (275, '21/09/2020', '2020-38', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (276, '14/09/2020', '2020-37', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (277, '07/09/2020', '2020-36', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (278, '31/08/2020', '2020-35', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (279, '24/08/2020', '2020-34', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (280, '17/08/2020', '2020-33', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (281, '10/08/2020', '2020-32', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (282, '03/08/2020', '2020-31', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (283, '27/07/2020', '2020-30', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (284, '20/07/2020', '2020-29', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (285, '13/07/2020', '2020-28', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (286, '06/07/2020', '2020-27', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (287, '29/06/2020', '2020-26', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (288, '22/06/2020', '2020-25', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (289, '15/06/2020', '2020-24', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (290, '08/06/2020', '2020-23', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (291, '01/06/2020', '2020-22', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (292, '25/05/2020', '2020-21', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (293, '18/05/2020', '2020-20', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (294, '11/05/2020', '2020-19', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (295, '04/05/2020', '2020-18', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (296, '27/04/2020', '2020-17', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (297, '20/04/2020', '2020-16', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (298, '13/04/2020', '2020-15', '0', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '6.72');
INSERT INTO public.europe_data_import VALUES (299, '06/04/2020', '2020-14', '1', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '20.17');
INSERT INTO public.europe_data_import VALUES (300, '30/03/2020', '2020-13', '2', '0', '14872', 'Anguilla', 'AI', 'AIA', 'America', '');
INSERT INTO public.europe_data_import VALUES (301, '01/02/2021', '2021-04', '33', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '46.34');
INSERT INTO public.europe_data_import VALUES (302, '25/01/2021', '2021-03', '12', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '25.74');
INSERT INTO public.europe_data_import VALUES (303, '18/01/2021', '2021-02', '13', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '29.86');
INSERT INTO public.europe_data_import VALUES (304, '11/01/2021', '2021-01', '16', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '18.53');
INSERT INTO public.europe_data_import VALUES (305, '04/01/2021', '2020-53', '2', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (306, '28/12/2020', '2020-52', '5', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '10.3');
INSERT INTO public.europe_data_import VALUES (307, '21/12/2020', '2020-51', '5', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (308, '14/12/2020', '2020-50', '2', '1', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (309, '07/12/2020', '2020-49', '5', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (310, '30/11/2020', '2020-48', '2', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (311, '23/11/2020', '2020-47', '5', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '8.24');
INSERT INTO public.europe_data_import VALUES (312, '16/11/2020', '2020-46', '3', '1', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '6.18');
INSERT INTO public.europe_data_import VALUES (313, '09/11/2020', '2020-45', '3', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (314, '02/11/2020', '2020-44', '4', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '9.27');
INSERT INTO public.europe_data_import VALUES (315, '26/10/2020', '2020-43', '5', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '13.39');
INSERT INTO public.europe_data_import VALUES (316, '19/10/2020', '2020-42', '8', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '12.36');
INSERT INTO public.europe_data_import VALUES (317, '12/10/2020', '2020-41', '4', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '10.3');
INSERT INTO public.europe_data_import VALUES (318, '05/10/2020', '2020-40', '6', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '11.33');
INSERT INTO public.europe_data_import VALUES (319, '28/09/2020', '2020-39', '5', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '6.18');
INSERT INTO public.europe_data_import VALUES (320, '21/09/2020', '2020-38', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (321, '14/09/2020', '2020-37', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (322, '07/09/2020', '2020-36', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (323, '31/08/2020', '2020-35', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (324, '24/08/2020', '2020-34', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '2.06');
INSERT INTO public.europe_data_import VALUES (325, '17/08/2020', '2020-33', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '2.06');
INSERT INTO public.europe_data_import VALUES (326, '10/08/2020', '2020-32', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '10.3');
INSERT INTO public.europe_data_import VALUES (327, '03/08/2020', '2020-31', '9', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '15.45');
INSERT INTO public.europe_data_import VALUES (328, '27/07/2020', '2020-30', '6', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '8.24');
INSERT INTO public.europe_data_import VALUES (329, '20/07/2020', '2020-29', '2', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '8.24');
INSERT INTO public.europe_data_import VALUES (330, '13/07/2020', '2020-28', '6', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '9.27');
INSERT INTO public.europe_data_import VALUES (331, '06/07/2020', '2020-27', '3', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '43.25');
INSERT INTO public.europe_data_import VALUES (332, '29/06/2020', '2020-26', '39', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '40.16');
INSERT INTO public.europe_data_import VALUES (333, '22/06/2020', '2020-25', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '0');
INSERT INTO public.europe_data_import VALUES (412, '05/10/2020', '2020-40', '3096', '26', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '171.25');
INSERT INTO public.europe_data_import VALUES (334, '15/06/2020', '2020-24', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (335, '08/06/2020', '2020-23', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (336, '01/06/2020', '2020-22', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '0');
INSERT INTO public.europe_data_import VALUES (337, '25/05/2020', '2020-21', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '0');
INSERT INTO public.europe_data_import VALUES (338, '18/05/2020', '2020-20', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '0');
INSERT INTO public.europe_data_import VALUES (339, '11/05/2020', '2020-19', '0', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (340, '04/05/2020', '2020-18', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '2.06');
INSERT INTO public.europe_data_import VALUES (341, '27/04/2020', '2020-17', '1', '1', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '3.09');
INSERT INTO public.europe_data_import VALUES (342, '20/04/2020', '2020-16', '2', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '8.24');
INSERT INTO public.europe_data_import VALUES (343, '13/04/2020', '2020-15', '6', '2', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '14.42');
INSERT INTO public.europe_data_import VALUES (344, '06/04/2020', '2020-14', '8', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '14.42');
INSERT INTO public.europe_data_import VALUES (345, '30/03/2020', '2020-13', '6', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '7.21');
INSERT INTO public.europe_data_import VALUES (346, '23/03/2020', '2020-12', '1', '0', '97115', 'Antigua_and_Barbuda', 'AG', 'ATG', 'America', '');
INSERT INTO public.europe_data_import VALUES (347, '01/02/2021', '2021-04', '59056', '1215', '44780675', 'Argentina', 'AR', 'ARG', 'America', '282.36');
INSERT INTO public.europe_data_import VALUES (348, '25/01/2021', '2021-03', '67388', '1202', '44780675', 'Argentina', 'AR', 'ARG', 'America', '321.29');
INSERT INTO public.europe_data_import VALUES (349, '18/01/2021', '2021-02', '76488', '1178', '44780675', 'Argentina', 'AR', 'ARG', 'America', '372.24');
INSERT INTO public.europe_data_import VALUES (350, '11/01/2021', '2021-01', '90203', '1172', '44780675', 'Argentina', 'AR', 'ARG', 'America', '313.58');
INSERT INTO public.europe_data_import VALUES (351, '04/01/2021', '2020-53', '50220', '614', '44780675', 'Argentina', 'AR', 'ARG', 'America', '209.0');
INSERT INTO public.europe_data_import VALUES (352, '28/12/2020', '2020-52', '43370', '871', '44780675', 'Argentina', 'AR', 'ARG', 'America', '206.17');
INSERT INTO public.europe_data_import VALUES (353, '21/12/2020', '2020-51', '48955', '1231', '44780675', 'Argentina', 'AR', 'ARG', 'America', '187.63');
INSERT INTO public.europe_data_import VALUES (354, '14/12/2020', '2020-50', '35067', '996', '44780675', 'Argentina', 'AR', 'ARG', 'America', '177.23');
INSERT INTO public.europe_data_import VALUES (355, '07/12/2020', '2020-49', '44299', '1297', '44780675', 'Argentina', 'AR', 'ARG', 'America', '207.1');
INSERT INTO public.europe_data_import VALUES (356, '30/11/2020', '2020-48', '48444', '1471', '44780675', 'Argentina', 'AR', 'ARG', 'America', '241.89');
INSERT INTO public.europe_data_import VALUES (357, '23/11/2020', '2020-47', '59874', '1566', '44780675', 'Argentina', 'AR', 'ARG', 'America', '286.24');
INSERT INTO public.europe_data_import VALUES (358, '16/11/2020', '2020-46', '68307', '1876', '44780675', 'Argentina', 'AR', 'ARG', 'America', '305.84');
INSERT INTO public.europe_data_import VALUES (359, '09/11/2020', '2020-45', '68649', '2420', '44780675', 'Argentina', 'AR', 'ARG', 'America', '338.52');
INSERT INTO public.europe_data_import VALUES (360, '02/11/2020', '2020-44', '82944', '2244', '44780675', 'Argentina', 'AR', 'ARG', 'America', '410.56');
INSERT INTO public.europe_data_import VALUES (361, '26/10/2020', '2020-43', '100909', '2629', '44780675', 'Argentina', 'AR', 'ARG', 'America', '438.54');
INSERT INTO public.europe_data_import VALUES (362, '19/10/2020', '2020-42', '95474', '2399', '44780675', 'Argentina', 'AR', 'ARG', 'America', '426.96');
INSERT INTO public.europe_data_import VALUES (363, '12/10/2020', '2020-41', '95720', '2850', '44780675', 'Argentina', 'AR', 'ARG', 'America', '408.39');
INSERT INTO public.europe_data_import VALUES (364, '05/10/2020', '2020-40', '87161', '5269', '44780675', 'Argentina', 'AR', 'ARG', 'America', '392.03');
INSERT INTO public.europe_data_import VALUES (365, '28/09/2020', '2020-39', '88391', '2840', '44780675', 'Argentina', 'AR', 'ARG', 'America', '368.11');
INSERT INTO public.europe_data_import VALUES (366, '21/09/2020', '2020-38', '76453', '1602', '44780675', 'Argentina', 'AR', 'ARG', 'America', '337.48');
INSERT INTO public.europe_data_import VALUES (367, '14/09/2020', '2020-37', '74675', '1500', '44780675', 'Argentina', 'AR', 'ARG', 'America', '324.34');
INSERT INTO public.europe_data_import VALUES (368, '07/09/2020', '2020-36', '70567', '1406', '44780675', 'Argentina', 'AR', 'ARG', 'America', '301.48');
INSERT INTO public.europe_data_import VALUES (369, '31/08/2020', '2020-35', '64437', '1553', '44780675', 'Argentina', 'AR', 'ARG', 'America', '250.42');
INSERT INTO public.europe_data_import VALUES (370, '24/08/2020', '2020-34', '47702', '1191', '44780675', 'Argentina', 'AR', 'ARG', 'America', '212.12');
INSERT INTO public.europe_data_import VALUES (371, '17/08/2020', '2020-33', '47289', '1101', '44780675', 'Argentina', 'AR', 'ARG', 'America', '206.69');
INSERT INTO public.europe_data_import VALUES (372, '10/08/2020', '2020-32', '45268', '944', '44780675', 'Argentina', 'AR', 'ARG', 'America', '177.05');
INSERT INTO public.europe_data_import VALUES (373, '03/08/2020', '2020-31', '34017', '673', '44780675', 'Argentina', 'AR', 'ARG', 'America', '165.29');
INSERT INTO public.europe_data_import VALUES (374, '27/07/2020', '2020-30', '40002', '693', '44780675', 'Argentina', 'AR', 'ARG', 'America', '145.19');
INSERT INTO public.europe_data_import VALUES (375, '20/07/2020', '2020-29', '25015', '428', '44780675', 'Argentina', 'AR', 'ARG', 'America', '105.29');
INSERT INTO public.europe_data_import VALUES (376, '13/07/2020', '2020-28', '22133', '328', '44780675', 'Argentina', 'AR', 'ARG', 'America', '88.8');
INSERT INTO public.europe_data_import VALUES (377, '06/07/2020', '2020-27', '17632', '273', '44780675', 'Argentina', 'AR', 'ARG', 'America', '72.78');
INSERT INTO public.europe_data_import VALUES (378, '29/06/2020', '2020-26', '14959', '206', '44780675', 'Argentina', 'AR', 'ARG', 'America', '58.43');
INSERT INTO public.europe_data_import VALUES (379, '22/06/2020', '2020-25', '11208', '178', '44780675', 'Argentina', 'AR', 'ARG', 'America', '44.64');
INSERT INTO public.europe_data_import VALUES (380, '15/06/2020', '2020-24', '8783', '169', '44780675', 'Argentina', 'AR', 'ARG', 'America', '32.88');
INSERT INTO public.europe_data_import VALUES (381, '08/06/2020', '2020-23', '5943', '125', '44780675', 'Argentina', 'AR', 'ARG', 'America', '23.93');
INSERT INTO public.europe_data_import VALUES (382, '01/06/2020', '2020-22', '4775', '87', '44780675', 'Argentina', 'AR', 'ARG', 'America', '20.2');
INSERT INTO public.europe_data_import VALUES (383, '25/05/2020', '2020-21', '4271', '86', '44780675', 'Argentina', 'AR', 'ARG', 'America', '14.04');
INSERT INTO public.europe_data_import VALUES (384, '18/05/2020', '2020-20', '2016', '66', '44780675', 'Argentina', 'AR', 'ARG', 'America', '6.75');
INSERT INTO public.europe_data_import VALUES (385, '11/05/2020', '2020-19', '1006', '54', '44780675', 'Argentina', 'AR', 'ARG', 'America', '4.49');
INSERT INTO public.europe_data_import VALUES (386, '04/05/2020', '2020-18', '1003', '60', '44780675', 'Argentina', 'AR', 'ARG', 'America', '4.11');
INSERT INTO public.europe_data_import VALUES (387, '27/04/2020', '2020-17', '837', '52', '44780675', 'Argentina', 'AR', 'ARG', 'America', '3.49');
INSERT INTO public.europe_data_import VALUES (388, '20/04/2020', '2020-16', '727', '39', '44780675', 'Argentina', 'AR', 'ARG', 'America', '3.07');
INSERT INTO public.europe_data_import VALUES (389, '13/04/2020', '2020-15', '649', '49', '44780675', 'Argentina', 'AR', 'ARG', 'America', '3.09');
INSERT INTO public.europe_data_import VALUES (390, '06/04/2020', '2020-14', '734', '26', '44780675', 'Argentina', 'AR', 'ARG', 'America', '2.88');
INSERT INTO public.europe_data_import VALUES (391, '30/03/2020', '2020-13', '554', '16', '44780675', 'Argentina', 'AR', 'ARG', 'America', '1.71');
INSERT INTO public.europe_data_import VALUES (392, '23/03/2020', '2020-12', '210', '2', '44780675', 'Argentina', 'AR', 'ARG', 'America', '0.57');
INSERT INTO public.europe_data_import VALUES (393, '16/03/2020', '2020-11', '44', '1', '44780675', 'Argentina', 'AR', 'ARG', 'America', '0.13');
INSERT INTO public.europe_data_import VALUES (394, '09/03/2020', '2020-10', '12', '1', '44780675', 'Argentina', 'AR', 'ARG', 'America', '');
INSERT INTO public.europe_data_import VALUES (395, '01/02/2021', '2021-04', '994', '37', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '81.55');
INSERT INTO public.europe_data_import VALUES (396, '25/01/2021', '2021-03', '1418', '49', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '128.68');
INSERT INTO public.europe_data_import VALUES (397, '18/01/2021', '2021-02', '2388', '67', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '150.66');
INSERT INTO public.europe_data_import VALUES (398, '11/01/2021', '2021-01', '2068', '67', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '146.73');
INSERT INTO public.europe_data_import VALUES (399, '04/01/2021', '2020-53', '2272', '89', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '208.1');
INSERT INTO public.europe_data_import VALUES (400, '28/12/2020', '2020-52', '3883', '119', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '313.28');
INSERT INTO public.europe_data_import VALUES (401, '21/12/2020', '2020-51', '5383', '153', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '396.28');
INSERT INTO public.europe_data_import VALUES (402, '14/12/2020', '2020-50', '6338', '159', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '458.39');
INSERT INTO public.europe_data_import VALUES (403, '07/12/2020', '2020-49', '7220', '180', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '528.62');
INSERT INTO public.europe_data_import VALUES (404, '30/11/2020', '2020-48', '8415', '188', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '582.81');
INSERT INTO public.europe_data_import VALUES (405, '23/11/2020', '2020-47', '8823', '188', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '650.6');
INSERT INTO public.europe_data_import VALUES (406, '16/11/2020', '2020-46', '10420', '208', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '826.24');
INSERT INTO public.europe_data_import VALUES (407, '09/11/2020', '2020-45', '14018', '189', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '968.85');
INSERT INTO public.europe_data_import VALUES (408, '02/11/2020', '2020-44', '14638', '195', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '972.17');
INSERT INTO public.europe_data_import VALUES (409, '26/10/2020', '2020-43', '14116', '115', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '755.95');
INSERT INTO public.europe_data_import VALUES (410, '19/10/2020', '2020-42', '8243', '61', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '412.41');
INSERT INTO public.europe_data_import VALUES (411, '12/10/2020', '2020-41', '3955', '43', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '238.39');
INSERT INTO public.europe_data_import VALUES (413, '28/09/2020', '2020-39', '1969', '21', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '119.62');
INSERT INTO public.europe_data_import VALUES (414, '21/09/2020', '2020-38', '1569', '14', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '89.53');
INSERT INTO public.europe_data_import VALUES (415, '14/09/2020', '2020-37', '1079', '19', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '71.41');
INSERT INTO public.europe_data_import VALUES (416, '07/09/2020', '2020-36', '1033', '20', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '67.32');
INSERT INTO public.europe_data_import VALUES (417, '31/08/2020', '2020-35', '958', '25', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '70.56');
INSERT INTO public.europe_data_import VALUES (418, '24/08/2020', '2020-34', '1129', '34', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '80.53');
INSERT INTO public.europe_data_import VALUES (419, '17/08/2020', '2020-33', '1253', '27', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '86.59');
INSERT INTO public.europe_data_import VALUES (420, '10/08/2020', '2020-32', '1308', '29', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '102.11');
INSERT INTO public.europe_data_import VALUES (421, '03/08/2020', '2020-31', '1712', '51', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '139.33');
INSERT INTO public.europe_data_import VALUES (422, '27/07/2020', '2020-30', '2409', '61', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '177.13');
INSERT INTO public.europe_data_import VALUES (423, '20/07/2020', '2020-29', '2830', '77', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '204.38');
INSERT INTO public.europe_data_import VALUES (424, '13/07/2020', '2020-28', '3215', '82', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '237.48');
INSERT INTO public.europe_data_import VALUES (425, '06/07/2020', '2020-27', '3809', '58', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '282.24');
INSERT INTO public.europe_data_import VALUES (426, '29/06/2020', '2020-26', '4539', '73', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '272.61');
INSERT INTO public.europe_data_import VALUES (427, '22/06/2020', '2020-25', '3524', '75', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '245.56');
INSERT INTO public.europe_data_import VALUES (428, '15/06/2020', '2020-24', '3739', '74', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '256.01');
INSERT INTO public.europe_data_import VALUES (429, '08/06/2020', '2020-23', '3833', '72', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '210.03');
INSERT INTO public.europe_data_import VALUES (430, '01/06/2020', '2020-22', '2379', '52', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '157.86');
INSERT INTO public.europe_data_import VALUES (431, '25/05/2020', '2020-21', '2290', '26', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '125.81');
INSERT INTO public.europe_data_import VALUES (432, '18/05/2020', '2020-20', '1431', '15', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '78.3');
INSERT INTO public.europe_data_import VALUES (433, '11/05/2020', '2020-19', '885', '7', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '53.55');
INSERT INTO public.europe_data_import VALUES (434, '04/05/2020', '2020-18', '699', '10', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '39.49');
INSERT INTO public.europe_data_import VALUES (435, '27/04/2020', '2020-17', '469', '7', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '26.0');
INSERT INTO public.europe_data_import VALUES (436, '20/04/2020', '2020-16', '300', '8', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '17.11');
INSERT INTO public.europe_data_import VALUES (437, '13/04/2020', '2020-15', '206', '6', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '18.83');
INSERT INTO public.europe_data_import VALUES (438, '06/04/2020', '2020-14', '351', '5', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '21.6');
INSERT INTO public.europe_data_import VALUES (439, '30/03/2020', '2020-13', '288', '3', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '15.35');
INSERT INTO public.europe_data_import VALUES (440, '23/03/2020', '2020-12', '166', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '6.53');
INSERT INTO public.europe_data_import VALUES (441, '16/03/2020', '2020-11', '27', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0.91');
INSERT INTO public.europe_data_import VALUES (442, '09/03/2020', '2020-10', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0.03');
INSERT INTO public.europe_data_import VALUES (443, '02/03/2020', '2020-09', '1', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0.03');
INSERT INTO public.europe_data_import VALUES (444, '24/02/2020', '2020-08', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (445, '17/02/2020', '2020-07', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (446, '10/02/2020', '2020-06', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (447, '03/02/2020', '2020-05', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (448, '27/01/2020', '2020-04', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (449, '20/01/2020', '2020-03', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (450, '13/01/2020', '2020-02', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (451, '06/01/2020', '2020-01', '0', '0', '2957728', 'Armenia', 'AM', 'ARM', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (452, '01/02/2021', '2021-04', '244', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '518.3');
INSERT INTO public.europe_data_import VALUES (453, '25/01/2021', '2021-03', '307', '5', '106310', 'Aruba', 'AW', 'ABW', 'America', '633.99');
INSERT INTO public.europe_data_import VALUES (454, '18/01/2021', '2021-02', '367', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '819.3');
INSERT INTO public.europe_data_import VALUES (455, '11/01/2021', '2021-01', '504', '3', '106310', 'Aruba', 'AW', 'ABW', 'America', '700.78');
INSERT INTO public.europe_data_import VALUES (456, '04/01/2021', '2020-53', '241', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '364.97');
INSERT INTO public.europe_data_import VALUES (457, '28/12/2020', '2020-52', '147', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '257.74');
INSERT INTO public.europe_data_import VALUES (458, '21/12/2020', '2020-51', '127', '1', '106310', 'Aruba', 'AW', 'ABW', 'America', '198.48');
INSERT INTO public.europe_data_import VALUES (459, '14/12/2020', '2020-50', '84', '1', '106310', 'Aruba', 'AW', 'ABW', 'America', '198.48');
INSERT INTO public.europe_data_import VALUES (460, '07/12/2020', '2020-49', '127', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '220.11');
INSERT INTO public.europe_data_import VALUES (461, '30/11/2020', '2020-48', '107', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '165.55');
INSERT INTO public.europe_data_import VALUES (462, '23/11/2020', '2020-47', '69', '1', '106310', 'Aruba', 'AW', 'ABW', 'America', '123.22');
INSERT INTO public.europe_data_import VALUES (463, '16/11/2020', '2020-46', '62', '4', '106310', 'Aruba', 'AW', 'ABW', 'America', '134.51');
INSERT INTO public.europe_data_import VALUES (464, '09/11/2020', '2020-45', '81', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '169.32');
INSERT INTO public.europe_data_import VALUES (465, '02/11/2020', '2020-44', '99', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '185.31');
INSERT INTO public.europe_data_import VALUES (466, '26/10/2020', '2020-43', '98', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '212.59');
INSERT INTO public.europe_data_import VALUES (467, '19/10/2020', '2020-42', '128', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '228.58');
INSERT INTO public.europe_data_import VALUES (468, '12/10/2020', '2020-41', '115', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '329.23');
INSERT INTO public.europe_data_import VALUES (469, '05/10/2020', '2020-40', '235', '5', '106310', 'Aruba', 'AW', 'ABW', 'America', '496.66');
INSERT INTO public.europe_data_import VALUES (470, '28/09/2020', '2020-39', '293', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '750.63');
INSERT INTO public.europe_data_import VALUES (471, '21/09/2020', '2020-38', '505', '5', '106310', 'Aruba', 'AW', 'ABW', 'America', '1036.59');
INSERT INTO public.europe_data_import VALUES (472, '14/09/2020', '2020-37', '597', '4', '106310', 'Aruba', 'AW', 'ABW', 'America', '986.74');
INSERT INTO public.europe_data_import VALUES (473, '07/09/2020', '2020-36', '452', '4', '106310', 'Aruba', 'AW', 'ABW', 'America', '828.71');
INSERT INTO public.europe_data_import VALUES (474, '31/08/2020', '2020-35', '429', '3', '106310', 'Aruba', 'AW', 'ABW', 'America', '841.88');
INSERT INTO public.europe_data_import VALUES (475, '24/08/2020', '2020-34', '466', '3', '106310', 'Aruba', 'AW', 'ABW', 'America', '945.35');
INSERT INTO public.europe_data_import VALUES (476, '17/08/2020', '2020-33', '539', '1', '106310', 'Aruba', 'AW', 'ABW', 'America', '921.83');
INSERT INTO public.europe_data_import VALUES (477, '10/08/2020', '2020-32', '441', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '417.65');
INSERT INTO public.europe_data_import VALUES (478, '03/08/2020', '2020-31', '3', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '8.47');
INSERT INTO public.europe_data_import VALUES (479, '27/07/2020', '2020-30', '6', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '13.17');
INSERT INTO public.europe_data_import VALUES (480, '20/07/2020', '2020-29', '8', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '7.53');
INSERT INTO public.europe_data_import VALUES (481, '13/07/2020', '2020-28', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '3.76');
INSERT INTO public.europe_data_import VALUES (482, '06/07/2020', '2020-27', '4', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '3.76');
INSERT INTO public.europe_data_import VALUES (483, '29/06/2020', '2020-26', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (484, '22/06/2020', '2020-25', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (485, '15/06/2020', '2020-24', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (486, '08/06/2020', '2020-23', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (487, '01/06/2020', '2020-22', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (488, '25/05/2020', '2020-21', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (489, '18/05/2020', '2020-20', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '0.94');
INSERT INTO public.europe_data_import VALUES (490, '11/05/2020', '2020-19', '1', '1', '106310', 'Aruba', 'AW', 'ABW', 'America', '0.94');
INSERT INTO public.europe_data_import VALUES (491, '04/05/2020', '2020-18', '0', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '2.82');
INSERT INTO public.europe_data_import VALUES (492, '27/04/2020', '2020-17', '3', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '7.53');
INSERT INTO public.europe_data_import VALUES (493, '20/04/2020', '2020-16', '5', '2', '106310', 'Aruba', 'AW', 'ABW', 'America', '31.04');
INSERT INTO public.europe_data_import VALUES (494, '13/04/2020', '2020-15', '28', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '39.51');
INSERT INTO public.europe_data_import VALUES (495, '06/04/2020', '2020-14', '14', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '60.2');
INSERT INTO public.europe_data_import VALUES (496, '30/03/2020', '2020-13', '50', '0', '106310', 'Aruba', 'AW', 'ABW', 'America', '');
INSERT INTO public.europe_data_import VALUES (497, '01/02/2021', '2021-04', '52', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.44');
INSERT INTO public.europe_data_import VALUES (498, '25/01/2021', '2021-03', '58', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.6');
INSERT INTO public.europe_data_import VALUES (499, '18/01/2021', '2021-02', '94', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.81');
INSERT INTO public.europe_data_import VALUES (500, '11/01/2021', '2021-01', '110', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.2');
INSERT INTO public.europe_data_import VALUES (501, '04/01/2021', '2020-53', '192', '1', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.21');
INSERT INTO public.europe_data_import VALUES (502, '28/12/2020', '2020-52', '114', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.11');
INSERT INTO public.europe_data_import VALUES (503, '21/12/2020', '2020-51', '167', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.92');
INSERT INTO public.europe_data_import VALUES (504, '14/12/2020', '2020-50', '66', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.55');
INSERT INTO public.europe_data_import VALUES (505, '07/12/2020', '2020-49', '72', '1', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.57');
INSERT INTO public.europe_data_import VALUES (506, '30/11/2020', '2020-48', '72', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.67');
INSERT INTO public.europe_data_import VALUES (507, '23/11/2020', '2020-47', '96', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.65');
INSERT INTO public.europe_data_import VALUES (508, '16/11/2020', '2020-46', '67', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.52');
INSERT INTO public.europe_data_import VALUES (509, '09/11/2020', '2020-45', '63', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.55');
INSERT INTO public.europe_data_import VALUES (510, '02/11/2020', '2020-44', '75', '2', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.81');
INSERT INTO public.europe_data_import VALUES (511, '26/10/2020', '2020-43', '130', '1', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.02');
INSERT INTO public.europe_data_import VALUES (512, '19/10/2020', '2020-42', '126', '6', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.01');
INSERT INTO public.europe_data_import VALUES (513, '12/10/2020', '2020-41', '128', '4', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.89');
INSERT INTO public.europe_data_import VALUES (514, '05/10/2020', '2020-40', '96', '22', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.94');
INSERT INTO public.europe_data_import VALUES (515, '28/09/2020', '2020-39', '142', '23', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.54');
INSERT INTO public.europe_data_import VALUES (516, '21/09/2020', '2020-38', '247', '39', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '2.46');
INSERT INTO public.europe_data_import VALUES (517, '14/09/2020', '2020-37', '372', '57', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '3.89');
INSERT INTO public.europe_data_import VALUES (518, '07/09/2020', '2020-36', '609', '142', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '5.82');
INSERT INTO public.europe_data_import VALUES (519, '31/08/2020', '2020-35', '858', '109', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '9.45');
INSERT INTO public.europe_data_import VALUES (520, '24/08/2020', '2020-34', '1524', '106', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '14.79');
INSERT INTO public.europe_data_import VALUES (521, '17/08/2020', '2020-33', '2204', '101', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '21.29');
INSERT INTO public.europe_data_import VALUES (522, '10/08/2020', '2020-32', '3161', '87', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '26.51');
INSERT INTO public.europe_data_import VALUES (523, '03/08/2020', '2020-31', '3520', '53', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '24.29');
INSERT INTO public.europe_data_import VALUES (524, '27/07/2020', '2020-30', '2601', '33', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '18.28');
INSERT INTO public.europe_data_import VALUES (525, '20/07/2020', '2020-29', '2005', '14', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '13.3');
INSERT INTO public.europe_data_import VALUES (526, '13/07/2020', '2020-28', '1348', '4', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '8.38');
INSERT INTO public.europe_data_import VALUES (527, '06/07/2020', '2020-27', '763', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '3.92');
INSERT INTO public.europe_data_import VALUES (528, '29/06/2020', '2020-26', '225', '2', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.45');
INSERT INTO public.europe_data_import VALUES (529, '22/06/2020', '2020-25', '141', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.8');
INSERT INTO public.europe_data_import VALUES (530, '15/06/2020', '2020-24', '60', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.5');
INSERT INTO public.europe_data_import VALUES (531, '08/06/2020', '2020-23', '65', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.6');
INSERT INTO public.europe_data_import VALUES (532, '01/06/2020', '2020-22', '86', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.6');
INSERT INTO public.europe_data_import VALUES (533, '25/05/2020', '2020-21', '64', '4', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.67');
INSERT INTO public.europe_data_import VALUES (534, '18/05/2020', '2020-20', '104', '1', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.97');
INSERT INTO public.europe_data_import VALUES (535, '11/05/2020', '2020-19', '140', '2', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.9');
INSERT INTO public.europe_data_import VALUES (536, '04/05/2020', '2020-18', '88', '12', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.75');
INSERT INTO public.europe_data_import VALUES (537, '27/04/2020', '2020-17', '101', '13', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.55');
INSERT INTO public.europe_data_import VALUES (538, '20/04/2020', '2020-16', '290', '9', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '3.44');
INSERT INTO public.europe_data_import VALUES (539, '13/04/2020', '2020-15', '578', '25', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '8.84');
INSERT INTO public.europe_data_import VALUES (540, '06/04/2020', '2020-14', '1651', '20', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '16.01');
INSERT INTO public.europe_data_import VALUES (541, '30/03/2020', '2020-13', '2384', '9', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '15.06');
INSERT INTO public.europe_data_import VALUES (542, '23/03/2020', '2020-12', '1411', '2', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '6.46');
INSERT INTO public.europe_data_import VALUES (543, '16/03/2020', '2020-11', '218', '2', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '1.07');
INSERT INTO public.europe_data_import VALUES (544, '09/03/2020', '2020-10', '51', '2', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.23');
INSERT INTO public.europe_data_import VALUES (545, '02/03/2020', '2020-09', '7', '1', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.06');
INSERT INTO public.europe_data_import VALUES (546, '24/02/2020', '2020-08', '7', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.03');
INSERT INTO public.europe_data_import VALUES (547, '17/02/2020', '2020-07', '1', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.02');
INSERT INTO public.europe_data_import VALUES (548, '10/02/2020', '2020-06', '3', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.04');
INSERT INTO public.europe_data_import VALUES (549, '03/02/2020', '2020-05', '7', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.04');
INSERT INTO public.europe_data_import VALUES (550, '27/01/2020', '2020-04', '4', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0.02');
INSERT INTO public.europe_data_import VALUES (551, '20/01/2020', '2020-03', '0', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (552, '13/01/2020', '2020-02', '0', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (553, '06/01/2020', '2020-01', '0', '0', '25203200', 'Australia', 'AU', 'AUS', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (554, '01/02/2021', '2021-04', '9451', '291', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '224.32');
INSERT INTO public.europe_data_import VALUES (555, '25/01/2021', '2021-03', '10421', '348', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '246.39');
INSERT INTO public.europe_data_import VALUES (556, '18/01/2021', '2021-02', '11406', '383', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '299.58');
INSERT INTO public.europe_data_import VALUES (557, '11/01/2021', '2021-01', '15133', '378', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '319.69');
INSERT INTO public.europe_data_import VALUES (558, '04/01/2021', '2020-53', '13188', '381', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '320.04');
INSERT INTO public.europe_data_import VALUES (559, '28/12/2020', '2020-52', '15164', '656', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '353.89');
INSERT INTO public.europe_data_import VALUES (560, '21/12/2020', '2020-51', '16186', '816', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '397.87');
INSERT INTO public.europe_data_import VALUES (561, '14/12/2020', '2020-50', '19060', '668', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '472.46');
INSERT INTO public.europe_data_import VALUES (562, '07/12/2020', '2020-49', '22794', '828', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '619.18');
INSERT INTO public.europe_data_import VALUES (563, '30/11/2020', '2020-48', '32058', '705', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '843.1');
INSERT INTO public.europe_data_import VALUES (564, '23/11/2020', '2020-47', '42630', '520', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '1056.76');
INSERT INTO public.europe_data_import VALUES (565, '16/11/2020', '2020-46', '50986', '344', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '1042.85');
INSERT INTO public.europe_data_import VALUES (566, '09/11/2020', '2020-45', '41398', '221', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '789.86');
INSERT INTO public.europe_data_import VALUES (567, '02/11/2020', '2020-44', '28574', '130', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '514.21');
INSERT INTO public.europe_data_import VALUES (568, '26/10/2020', '2020-43', '16979', '74', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '299.74');
INSERT INTO public.europe_data_import VALUES (569, '19/10/2020', '2020-42', '9574', '46', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '191.21');
INSERT INTO public.europe_data_import VALUES (570, '12/10/2020', '2020-41', '7365', '51', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '141.29');
INSERT INTO public.europe_data_import VALUES (571, '05/10/2020', '2020-40', '5152', '26', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '113.57');
INSERT INTO public.europe_data_import VALUES (572, '28/09/2020', '2020-39', '4909', '21', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '114.36');
INSERT INTO public.europe_data_import VALUES (573, '21/09/2020', '2020-38', '5222', '10', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '105.69');
INSERT INTO public.europe_data_import VALUES (574, '14/09/2020', '2020-37', '4141', '20', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '69.05');
INSERT INTO public.europe_data_import VALUES (575, '07/09/2020', '2020-36', '1976', '3', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '44.64');
INSERT INTO public.europe_data_import VALUES (576, '31/08/2020', '2020-35', '1979', '1', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '43.4');
INSERT INTO public.europe_data_import VALUES (577, '24/08/2020', '2020-34', '1866', '4', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '36.44');
INSERT INTO public.europe_data_import VALUES (578, '17/08/2020', '2020-33', '1362', '7', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '23.3');
INSERT INTO public.europe_data_import VALUES (579, '10/08/2020', '2020-32', '702', '3', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '17.21');
INSERT INTO public.europe_data_import VALUES (580, '03/08/2020', '2020-31', '823', '6', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '19.62');
INSERT INTO public.europe_data_import VALUES (581, '27/07/2020', '2020-30', '915', '2', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '18.5');
INSERT INTO public.europe_data_import VALUES (582, '20/07/2020', '2020-29', '724', '2', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '14.7');
INSERT INTO public.europe_data_import VALUES (583, '13/07/2020', '2020-28', '578', '2', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '13.79');
INSERT INTO public.europe_data_import VALUES (584, '06/07/2020', '2020-27', '644', '4', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '11.11');
INSERT INTO public.europe_data_import VALUES (585, '29/06/2020', '2020-26', '340', '12', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '6.63');
INSERT INTO public.europe_data_import VALUES (586, '22/06/2020', '2020-25', '247', '13', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '4.71');
INSERT INTO public.europe_data_import VALUES (587, '15/06/2020', '2020-24', '170', '5', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '4.47');
INSERT INTO public.europe_data_import VALUES (588, '08/06/2020', '2020-23', '226', '4', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '4.84');
INSERT INTO public.europe_data_import VALUES (589, '01/06/2020', '2020-22', '203', '28', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '5.51');
INSERT INTO public.europe_data_import VALUES (590, '25/05/2020', '2020-21', '285', '11', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '7.36');
INSERT INTO public.europe_data_import VALUES (591, '18/05/2020', '2020-20', '367', '11', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '6.95');
INSERT INTO public.europe_data_import VALUES (592, '11/05/2020', '2020-19', '249', '20', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '6.75');
INSERT INTO public.europe_data_import VALUES (593, '04/05/2020', '2020-18', '349', '56', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '9.35');
INSERT INTO public.europe_data_import VALUES (594, '27/04/2020', '2020-17', '479', '90', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '14.13');
INSERT INTO public.europe_data_import VALUES (595, '20/04/2020', '2020-16', '773', '102', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '30.78');
INSERT INTO public.europe_data_import VALUES (596, '13/04/2020', '2020-15', '1954', '146', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '57.84');
INSERT INTO public.europe_data_import VALUES (597, '06/04/2020', '2020-14', '3170', '118', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '94.28');
INSERT INTO public.europe_data_import VALUES (598, '30/03/2020', '2020-13', '5182', '70', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '89.78');
INSERT INTO public.europe_data_import VALUES (599, '23/03/2020', '2020-12', '2771', '15', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '39.84');
INSERT INTO public.europe_data_import VALUES (600, '16/03/2020', '2020-11', '758', '1', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '9.55');
INSERT INTO public.europe_data_import VALUES (601, '09/03/2020', '2020-10', '88', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '1.15');
INSERT INTO public.europe_data_import VALUES (602, '02/03/2020', '2020-09', '14', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0.16');
INSERT INTO public.europe_data_import VALUES (603, '24/02/2020', '2020-08', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (604, '17/02/2020', '2020-07', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (605, '10/02/2020', '2020-06', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (606, '03/02/2020', '2020-05', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (607, '27/01/2020', '2020-04', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (608, '20/01/2020', '2020-03', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (609, '13/01/2020', '2020-02', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (610, '06/01/2020', '2020-01', '0', '0', '8858775', 'Austria', 'AT', 'AUT', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (611, '01/02/2021', '2021-04', '1187', '39', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '28.15');
INSERT INTO public.europe_data_import VALUES (612, '25/01/2021', '2021-03', '1641', '71', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '41.85');
INSERT INTO public.europe_data_import VALUES (613, '18/01/2021', '2021-02', '2564', '96', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '70.92');
INSERT INTO public.europe_data_import VALUES (614, '11/01/2021', '2021-01', '4562', '193', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '93.0');
INSERT INTO public.europe_data_import VALUES (615, '04/01/2021', '2020-53', '4782', '195', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '180.91');
INSERT INTO public.europe_data_import VALUES (616, '28/12/2020', '2020-52', '13395', '328', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '394.21');
INSERT INTO public.europe_data_import VALUES (617, '21/12/2020', '2020-51', '26214', '288', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '551.46');
INSERT INTO public.europe_data_import VALUES (618, '14/12/2020', '2020-50', '29195', '290', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '574.05');
INSERT INTO public.europe_data_import VALUES (619, '07/12/2020', '2020-49', '28484', '271', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '533.31');
INSERT INTO public.europe_data_import VALUES (620, '30/11/2020', '2020-48', '25101', '230', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '423.05');
INSERT INTO public.europe_data_import VALUES (621, '23/11/2020', '2020-47', '17406', '164', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '275.52');
INSERT INTO public.europe_data_import VALUES (622, '16/11/2020', '2020-46', '10277', '127', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '191.53');
INSERT INTO public.europe_data_import VALUES (623, '09/11/2020', '2020-45', '8967', '100', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '153.79');
INSERT INTO public.europe_data_import VALUES (624, '02/11/2020', '2020-44', '6485', '69', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '114.25');
INSERT INTO public.europe_data_import VALUES (625, '26/10/2020', '2020-43', '4995', '45', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '79.39');
INSERT INTO public.europe_data_import VALUES (626, '19/10/2020', '2020-42', '2982', '17', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '42.53');
INSERT INTO public.europe_data_import VALUES (627, '12/10/2020', '2020-41', '1291', '13', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '19.5');
INSERT INTO public.europe_data_import VALUES (628, '05/10/2020', '2020-40', '668', '10', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '14.96');
INSERT INTO public.europe_data_import VALUES (629, '28/09/2020', '2020-39', '835', '11', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '16.88');
INSERT INTO public.europe_data_import VALUES (630, '21/09/2020', '2020-38', '861', '13', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '18.5');
INSERT INTO public.europe_data_import VALUES (631, '14/09/2020', '2020-37', '998', '14', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '20.08');
INSERT INTO public.europe_data_import VALUES (632, '07/09/2020', '2020-36', '1020', '17', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '20.45');
INSERT INTO public.europe_data_import VALUES (633, '31/08/2020', '2020-35', '1035', '13', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '20.8');
INSERT INTO public.europe_data_import VALUES (634, '24/08/2020', '2020-34', '1055', '12', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '16.98');
INSERT INTO public.europe_data_import VALUES (635, '17/08/2020', '2020-33', '651', '16', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '17.68');
INSERT INTO public.europe_data_import VALUES (636, '10/08/2020', '2020-32', '1125', '28', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '35.01');
INSERT INTO public.europe_data_import VALUES (637, '03/08/2020', '2020-31', '2393', '45', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '48.99');
INSERT INTO public.europe_data_import VALUES (638, '27/07/2020', '2020-30', '2529', '63', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '59.8');
INSERT INTO public.europe_data_import VALUES (639, '20/07/2020', '2020-29', '3480', '48', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '71.63');
INSERT INTO public.europe_data_import VALUES (640, '13/07/2020', '2020-28', '3717', '56', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '75.81');
INSERT INTO public.europe_data_import VALUES (641, '06/07/2020', '2020-27', '3900', '52', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '75.59');
INSERT INTO public.europe_data_import VALUES (642, '29/06/2020', '2020-26', '3695', '44', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '64.36');
INSERT INTO public.europe_data_import VALUES (643, '22/06/2020', '2020-25', '2772', '35', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '51.51');
INSERT INTO public.europe_data_import VALUES (644, '15/06/2020', '2020-24', '2404', '31', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '44.42');
INSERT INTO public.europe_data_import VALUES (645, '08/06/2020', '2020-23', '2059', '25', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '34.15');
INSERT INTO public.europe_data_import VALUES (646, '01/06/2020', '2020-22', '1372', '14', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '22.09');
INSERT INTO public.europe_data_import VALUES (647, '25/05/2020', '2020-21', '848', '10', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '15.95');
INSERT INTO public.europe_data_import VALUES (648, '18/05/2020', '2020-20', '755', '7', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '13.36');
INSERT INTO public.europe_data_import VALUES (649, '11/05/2020', '2020-19', '587', '7', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '8.7');
INSERT INTO public.europe_data_import VALUES (650, '04/05/2020', '2020-18', '287', '4', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '5.31');
INSERT INTO public.europe_data_import VALUES (651, '27/04/2020', '2020-17', '247', '2', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '5.44');
INSERT INTO public.europe_data_import VALUES (652, '20/04/2020', '2020-16', '300', '8', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '8.1');
INSERT INTO public.europe_data_import VALUES (653, '13/04/2020', '2020-15', '514', '4', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '8.85');
INSERT INTO public.europe_data_import VALUES (654, '06/04/2020', '2020-14', '375', '3', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '5.17');
INSERT INTO public.europe_data_import VALUES (655, '30/03/2020', '2020-13', '144', '3', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '1.89');
INSERT INTO public.europe_data_import VALUES (656, '23/03/2020', '2020-12', '46', '1', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0.56');
INSERT INTO public.europe_data_import VALUES (657, '16/03/2020', '2020-11', '10', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0.16');
INSERT INTO public.europe_data_import VALUES (658, '09/03/2020', '2020-10', '6', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0.09');
INSERT INTO public.europe_data_import VALUES (659, '02/03/2020', '2020-09', '3', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0.03');
INSERT INTO public.europe_data_import VALUES (660, '24/02/2020', '2020-08', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (661, '17/02/2020', '2020-07', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (662, '10/02/2020', '2020-06', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (663, '03/02/2020', '2020-05', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (664, '27/01/2020', '2020-04', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (665, '20/01/2020', '2020-03', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (666, '13/01/2020', '2020-02', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (667, '06/01/2020', '2020-01', '0', '0', '10047719', 'Azerbaijan', 'AZ', 'AZE', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (668, '01/02/2021', '2021-04', '41', '1', '389486', 'Bahamas', 'BS', 'BHS', 'America', '27.47');
INSERT INTO public.europe_data_import VALUES (669, '25/01/2021', '2021-03', '66', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '33.12');
INSERT INTO public.europe_data_import VALUES (670, '18/01/2021', '2021-02', '63', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '36.72');
INSERT INTO public.europe_data_import VALUES (671, '11/01/2021', '2021-01', '80', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '43.65');
INSERT INTO public.europe_data_import VALUES (672, '04/01/2021', '2020-53', '90', '5', '389486', 'Bahamas', 'BS', 'BHS', 'America', '40.82');
INSERT INTO public.europe_data_import VALUES (673, '28/12/2020', '2020-52', '69', '6', '389486', 'Bahamas', 'BS', 'BHS', 'America', '41.08');
INSERT INTO public.europe_data_import VALUES (674, '21/12/2020', '2020-51', '91', '1', '389486', 'Bahamas', 'BS', 'BHS', 'America', '47.76');
INSERT INTO public.europe_data_import VALUES (675, '14/12/2020', '2020-50', '95', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '45.7');
INSERT INTO public.europe_data_import VALUES (676, '07/12/2020', '2020-49', '83', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '42.62');
INSERT INTO public.europe_data_import VALUES (677, '30/11/2020', '2020-48', '83', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '79.59');
INSERT INTO public.europe_data_import VALUES (678, '23/11/2020', '2020-47', '227', '7', '389486', 'Bahamas', 'BS', 'BHS', 'America', '119.64');
INSERT INTO public.europe_data_import VALUES (679, '16/11/2020', '2020-46', '239', '4', '389486', 'Bahamas', 'BS', 'BHS', 'America', '121.19');
INSERT INTO public.europe_data_import VALUES (680, '09/11/2020', '2020-45', '233', '8', '389486', 'Bahamas', 'BS', 'BHS', 'America', '137.87');
INSERT INTO public.europe_data_import VALUES (681, '02/11/2020', '2020-44', '304', '12', '389486', 'Bahamas', 'BS', 'BHS', 'America', '259.57');
INSERT INTO public.europe_data_import VALUES (682, '26/10/2020', '2020-43', '707', '10', '389486', 'Bahamas', 'BS', 'BHS', 'America', '341.99');
INSERT INTO public.europe_data_import VALUES (683, '19/10/2020', '2020-42', '625', '15', '389486', 'Bahamas', 'BS', 'BHS', 'America', '332.23');
INSERT INTO public.europe_data_import VALUES (684, '12/10/2020', '2020-41', '669', '11', '389486', 'Bahamas', 'BS', 'BHS', 'America', '330.69');
INSERT INTO public.europe_data_import VALUES (685, '05/10/2020', '2020-40', '619', '9', '389486', 'Bahamas', 'BS', 'BHS', 'America', '266.76');
INSERT INTO public.europe_data_import VALUES (686, '28/09/2020', '2020-39', '420', '13', '389486', 'Bahamas', 'BS', 'BHS', 'America', '221.32');
INSERT INTO public.europe_data_import VALUES (687, '21/09/2020', '2020-38', '442', '7', '389486', 'Bahamas', 'BS', 'BHS', 'America', '211.56');
INSERT INTO public.europe_data_import VALUES (688, '14/09/2020', '2020-37', '382', '9', '389486', 'Bahamas', 'BS', 'BHS', 'America', '195.39');
INSERT INTO public.europe_data_import VALUES (689, '07/09/2020', '2020-36', '379', '15', '389486', 'Bahamas', 'BS', 'BHS', 'America', '200.52');
INSERT INTO public.europe_data_import VALUES (690, '31/08/2020', '2020-35', '402', '14', '389486', 'Bahamas', 'BS', 'BHS', 'America', '218.75');
INSERT INTO public.europe_data_import VALUES (691, '24/08/2020', '2020-34', '450', '11', '389486', 'Bahamas', 'BS', 'BHS', 'America', '222.6');
INSERT INTO public.europe_data_import VALUES (692, '17/08/2020', '2020-33', '417', '3', '389486', 'Bahamas', 'BS', 'BHS', 'America', '171.25');
INSERT INTO public.europe_data_import VALUES (693, '10/08/2020', '2020-32', '250', '1', '389486', 'Bahamas', 'BS', 'BHS', 'America', '142.75');
INSERT INTO public.europe_data_import VALUES (694, '03/08/2020', '2020-31', '306', '3', '389486', 'Bahamas', 'BS', 'BHS', 'America', '127.09');
INSERT INTO public.europe_data_import VALUES (695, '27/07/2020', '2020-30', '189', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '59.31');
INSERT INTO public.europe_data_import VALUES (696, '20/07/2020', '2020-29', '42', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '12.58');
INSERT INTO public.europe_data_import VALUES (697, '13/07/2020', '2020-28', '7', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '1.8');
INSERT INTO public.europe_data_import VALUES (698, '06/07/2020', '2020-27', '0', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '0');
INSERT INTO public.europe_data_import VALUES (699, '29/06/2020', '2020-26', '0', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '0.26');
INSERT INTO public.europe_data_import VALUES (700, '22/06/2020', '2020-25', '1', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '0.26');
INSERT INTO public.europe_data_import VALUES (701, '15/06/2020', '2020-24', '0', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '0.26');
INSERT INTO public.europe_data_import VALUES (702, '08/06/2020', '2020-23', '1', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '0.77');
INSERT INTO public.europe_data_import VALUES (703, '01/06/2020', '2020-22', '2', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '1.54');
INSERT INTO public.europe_data_import VALUES (704, '25/05/2020', '2020-21', '4', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '2.05');
INSERT INTO public.europe_data_import VALUES (705, '18/05/2020', '2020-20', '4', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '3.34');
INSERT INTO public.europe_data_import VALUES (706, '11/05/2020', '2020-19', '9', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '3.08');
INSERT INTO public.europe_data_import VALUES (707, '04/05/2020', '2020-18', '3', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '5.91');
INSERT INTO public.europe_data_import VALUES (708, '27/04/2020', '2020-17', '20', '2', '389486', 'Bahamas', 'BS', 'BHS', 'America', '8.47');
INSERT INTO public.europe_data_import VALUES (709, '20/04/2020', '2020-16', '13', '1', '389486', 'Bahamas', 'BS', 'BHS', 'America', '7.96');
INSERT INTO public.europe_data_import VALUES (710, '13/04/2020', '2020-15', '18', '3', '389486', 'Bahamas', 'BS', 'BHS', 'America', '8.47');
INSERT INTO public.europe_data_import VALUES (711, '06/04/2020', '2020-14', '15', '5', '389486', 'Bahamas', 'BS', 'BHS', 'America', '6.42');
INSERT INTO public.europe_data_import VALUES (712, '30/03/2020', '2020-13', '10', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '3.34');
INSERT INTO public.europe_data_import VALUES (713, '23/03/2020', '2020-12', '3', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '1.03');
INSERT INTO public.europe_data_import VALUES (714, '16/03/2020', '2020-11', '1', '0', '389486', 'Bahamas', 'BS', 'BHS', 'America', '');
INSERT INTO public.europe_data_import VALUES (715, '01/02/2021', '2021-04', '3601', '8', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '332.08');
INSERT INTO public.europe_data_import VALUES (716, '25/01/2021', '2021-03', '1849', '7', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '237.51');
INSERT INTO public.europe_data_import VALUES (717, '18/01/2021', '2021-02', '2049', '4', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '251.59');
INSERT INTO public.europe_data_import VALUES (718, '11/01/2021', '2021-01', '2080', '4', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '233.07');
INSERT INTO public.europe_data_import VALUES (719, '04/01/2021', '2020-53', '1745', '1', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '194.74');
INSERT INTO public.europe_data_import VALUES (720, '28/12/2020', '2020-52', '1451', '2', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '157.81');
INSERT INTO public.europe_data_import VALUES (721, '21/12/2020', '2020-51', '1139', '1', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '143.31');
INSERT INTO public.europe_data_import VALUES (722, '14/12/2020', '2020-50', '1213', '7', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '143.56');
INSERT INTO public.europe_data_import VALUES (723, '07/12/2020', '2020-49', '1143', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '135.57');
INSERT INTO public.europe_data_import VALUES (724, '30/11/2020', '2020-48', '1082', '3', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '126.98');
INSERT INTO public.europe_data_import VALUES (725, '23/11/2020', '2020-47', '1002', '3', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '137.04');
INSERT INTO public.europe_data_import VALUES (726, '16/11/2020', '2020-46', '1247', '6', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '169.39');
INSERT INTO public.europe_data_import VALUES (727, '09/11/2020', '2020-45', '1533', '8', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '195.04');
INSERT INTO public.europe_data_import VALUES (728, '02/11/2020', '2020-44', '1668', '9', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '245.01');
INSERT INTO public.europe_data_import VALUES (729, '26/10/2020', '2020-43', '2353', '12', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '302.71');
INSERT INTO public.europe_data_import VALUES (730, '19/10/2020', '2020-42', '2615', '27', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '319.29');
INSERT INTO public.europe_data_import VALUES (731, '12/10/2020', '2020-41', '2625', '13', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '396.79');
INSERT INTO public.europe_data_import VALUES (732, '05/10/2020', '2020-40', '3887', '18', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '497.39');
INSERT INTO public.europe_data_import VALUES (733, '28/09/2020', '2020-39', '4276', '21', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '559.91');
INSERT INTO public.europe_data_import VALUES (734, '21/09/2020', '2020-38', '4913', '9', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '592.75');
INSERT INTO public.europe_data_import VALUES (735, '14/09/2020', '2020-37', '4815', '14', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '488.19');
INSERT INTO public.europe_data_import VALUES (736, '07/09/2020', '2020-36', '3197', '9', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '349.33');
INSERT INTO public.europe_data_import VALUES (737, '31/08/2020', '2020-35', '2536', '5', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '313.44');
INSERT INTO public.europe_data_import VALUES (738, '24/08/2020', '2020-34', '2608', '14', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '306.31');
INSERT INTO public.europe_data_import VALUES (739, '17/08/2020', '2020-33', '2419', '8', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '298.2');
INSERT INTO public.europe_data_import VALUES (740, '10/08/2020', '2020-32', '2475', '15', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '297.35');
INSERT INTO public.europe_data_import VALUES (741, '03/08/2020', '2020-31', '2405', '7', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '311.61');
INSERT INTO public.europe_data_import VALUES (742, '27/07/2020', '2020-30', '2709', '14', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '377.17');
INSERT INTO public.europe_data_import VALUES (743, '20/07/2020', '2020-29', '3481', '17', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '429.88');
INSERT INTO public.europe_data_import VALUES (744, '13/07/2020', '2020-28', '3574', '12', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '440.91');
INSERT INTO public.europe_data_import VALUES (745, '06/07/2020', '2020-27', '3662', '14', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '463.27');
INSERT INTO public.europe_data_import VALUES (746, '29/06/2020', '2020-26', '3941', '20', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '436.34');
INSERT INTO public.europe_data_import VALUES (747, '22/06/2020', '2020-25', '3220', '20', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '426.59');
INSERT INTO public.europe_data_import VALUES (748, '15/06/2020', '2020-24', '3781', '17', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '435.42');
INSERT INTO public.europe_data_import VALUES (749, '08/06/2020', '2020-23', '3365', '7', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '342.74');
INSERT INTO public.europe_data_import VALUES (750, '01/06/2020', '2020-22', '2260', '5', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '270.66');
INSERT INTO public.europe_data_import VALUES (751, '25/05/2020', '2020-21', '2182', '2', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '255.73');
INSERT INTO public.europe_data_import VALUES (752, '18/05/2020', '2020-20', '2015', '4', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '217.71');
INSERT INTO public.europe_data_import VALUES (753, '11/05/2020', '2020-19', '1558', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '139.78');
INSERT INTO public.europe_data_import VALUES (754, '04/05/2020', '2020-18', '736', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '92.01');
INSERT INTO public.europe_data_import VALUES (755, '27/04/2020', '2020-17', '774', '1', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '92.07');
INSERT INTO public.europe_data_import VALUES (756, '20/04/2020', '2020-16', '737', '1', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '71.47');
INSERT INTO public.europe_data_import VALUES (757, '13/04/2020', '2020-15', '436', '2', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '38.75');
INSERT INTO public.europe_data_import VALUES (758, '06/04/2020', '2020-14', '200', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '22.3');
INSERT INTO public.europe_data_import VALUES (759, '30/03/2020', '2020-13', '166', '2', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '17.43');
INSERT INTO public.europe_data_import VALUES (760, '23/03/2020', '2020-12', '120', '2', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '15.54');
INSERT INTO public.europe_data_import VALUES (761, '16/03/2020', '2020-11', '135', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '10.18');
INSERT INTO public.europe_data_import VALUES (762, '09/03/2020', '2020-10', '32', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '4.75');
INSERT INTO public.europe_data_import VALUES (763, '02/03/2020', '2020-09', '46', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '2.86');
INSERT INTO public.europe_data_import VALUES (764, '24/02/2020', '2020-08', '1', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (765, '17/02/2020', '2020-07', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (766, '10/02/2020', '2020-06', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (767, '03/02/2020', '2020-05', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (768, '27/01/2020', '2020-04', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (769, '20/01/2020', '2020-03', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (770, '13/01/2020', '2020-02', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (771, '06/01/2020', '2020-01', '0', '0', '1641164', 'Bahrain', 'BH', 'BHR', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (772, '01/02/2021', '2021-04', '3340', '104', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '4.6');
INSERT INTO public.europe_data_import VALUES (773, '25/01/2021', '2021-03', '4167', '117', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '5.73');
INSERT INTO public.europe_data_import VALUES (774, '18/01/2021', '2021-02', '5179', '125', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '7.12');
INSERT INTO public.europe_data_import VALUES (775, '11/01/2021', '2021-01', '6434', '155', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '8.16');
INSERT INTO public.europe_data_import VALUES (776, '04/01/2021', '2020-53', '6871', '174', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '9.39');
INSERT INTO public.europe_data_import VALUES (777, '28/12/2020', '2020-52', '8435', '172', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '11.42');
INSERT INTO public.europe_data_import VALUES (778, '21/12/2020', '2020-51', '10180', '228', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '14.21');
INSERT INTO public.europe_data_import VALUES (779, '14/12/2020', '2020-50', '12988', '214', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '17.25');
INSERT INTO public.europe_data_import VALUES (780, '07/12/2020', '2020-49', '15138', '229', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '18.52');
INSERT INTO public.europe_data_import VALUES (781, '30/11/2020', '2020-48', '15066', '221', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '18.45');
INSERT INTO public.europe_data_import VALUES (782, '23/11/2020', '2020-47', '15008', '194', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '16.62');
INSERT INTO public.europe_data_import VALUES (783, '16/11/2020', '2020-46', '12095', '127', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '14.16');
INSERT INTO public.europe_data_import VALUES (784, '09/11/2020', '2020-45', '10986', '126', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '13.14');
INSERT INTO public.europe_data_import VALUES (785, '02/11/2020', '2020-44', '10437', '138', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '12.69');
INSERT INTO public.europe_data_import VALUES (786, '26/10/2020', '2020-43', '10246', '143', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '12.6');
INSERT INTO public.europe_data_import VALUES (787, '19/10/2020', '2020-42', '10303', '136', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '12.19');
INSERT INTO public.europe_data_import VALUES (788, '12/10/2020', '2020-41', '9576', '176', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '11.73');
INSERT INTO public.europe_data_import VALUES (789, '05/10/2020', '2020-40', '9542', '187', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '12.13');
INSERT INTO public.europe_data_import VALUES (790, '28/09/2020', '2020-39', '10232', '222', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '13.26');
INSERT INTO public.europe_data_import VALUES (791, '21/09/2020', '2020-38', '11396', '206', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '14.57');
INSERT INTO public.europe_data_import VALUES (792, '14/09/2020', '2020-37', '12363', '284', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '16.37');
INSERT INTO public.europe_data_import VALUES (793, '07/09/2020', '2020-36', '14335', '201', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '18.74');
INSERT INTO public.europe_data_import VALUES (794, '31/08/2020', '2020-35', '16224', '307', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '21.02');
INSERT INTO public.europe_data_import VALUES (795, '24/08/2020', '2020-34', '18049', '284', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '22.69');
INSERT INTO public.europe_data_import VALUES (796, '17/08/2020', '2020-33', '18949', '258', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '21.96');
INSERT INTO public.europe_data_import VALUES (797, '10/08/2020', '2020-32', '16854', '245', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '20.94');
INSERT INTO public.europe_data_import VALUES (798, '03/08/2020', '2020-31', '17293', '226', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '22.22');
INSERT INTO public.europe_data_import VALUES (799, '27/07/2020', '2020-30', '18928', '310', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '24.32');
INSERT INTO public.europe_data_import VALUES (800, '20/07/2020', '2020-29', '20730', '266', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '25.83');
INSERT INTO public.europe_data_import VALUES (801, '13/07/2020', '2020-28', '21378', '300', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '28.22');
INSERT INTO public.europe_data_import VALUES (802, '06/07/2020', '2020-27', '24630', '314', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '30.73');
INSERT INTO public.europe_data_import VALUES (803, '29/06/2020', '2020-26', '25481', '274', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '30.83');
INSERT INTO public.europe_data_import VALUES (804, '22/06/2020', '2020-25', '24786', '293', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '28.54');
INSERT INTO public.europe_data_import VALUES (805, '15/06/2020', '2020-24', '21751', '283', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '24.76');
INSERT INTO public.europe_data_import VALUES (806, '08/06/2020', '2020-23', '18616', '238', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '19.72');
INSERT INTO public.europe_data_import VALUES (807, '01/06/2020', '2020-22', '13543', '170', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '15.26');
INSERT INTO public.europe_data_import VALUES (808, '25/05/2020', '2020-21', '11342', '152', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '11.62');
INSERT INTO public.europe_data_import VALUES (809, '18/05/2020', '2020-20', '7611', '100', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '7.86');
INSERT INTO public.europe_data_import VALUES (810, '11/05/2020', '2020-19', '5202', '51', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '5.67');
INSERT INTO public.europe_data_import VALUES (811, '04/05/2020', '2020-18', '4039', '32', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '4.29');
INSERT INTO public.europe_data_import VALUES (812, '27/04/2020', '2020-17', '2960', '54', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '2.94');
INSERT INTO public.europe_data_import VALUES (813, '20/04/2020', '2020-16', '1835', '57', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '1.45');
INSERT INTO public.europe_data_import VALUES (814, '13/04/2020', '2020-15', '533', '25', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '0.35');
INSERT INTO public.europe_data_import VALUES (815, '06/04/2020', '2020-14', '39', '4', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (816, '30/03/2020', '2020-13', '22', '2', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (817, '23/03/2020', '2020-12', '24', '3', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (818, '16/03/2020', '2020-11', '0', '0', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (819, '09/03/2020', '2020-10', '3', '0', '163046173', 'Bangladesh', 'BD', 'BGD', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (820, '01/02/2021', '2021-04', '157', '4', '287021', 'Barbados', 'BB', 'BRB', 'America', '161.31');
INSERT INTO public.europe_data_import VALUES (821, '25/01/2021', '2021-03', '306', '3', '287021', 'Barbados', 'BB', 'BRB', 'America', '180.13');
INSERT INTO public.europe_data_import VALUES (822, '18/01/2021', '2021-02', '211', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '170.37');
INSERT INTO public.europe_data_import VALUES (823, '11/01/2021', '2021-01', '278', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '181.87');
INSERT INTO public.europe_data_import VALUES (824, '04/01/2021', '2020-53', '244', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '98.95');
INSERT INTO public.europe_data_import VALUES (825, '28/12/2020', '2020-52', '40', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '22.99');
INSERT INTO public.europe_data_import VALUES (826, '21/12/2020', '2020-51', '26', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '12.19');
INSERT INTO public.europe_data_import VALUES (827, '14/12/2020', '2020-50', '9', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '7.32');
INSERT INTO public.europe_data_import VALUES (828, '07/12/2020', '2020-49', '12', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '9.76');
INSERT INTO public.europe_data_import VALUES (829, '30/11/2020', '2020-48', '16', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '8.71');
INSERT INTO public.europe_data_import VALUES (830, '23/11/2020', '2020-47', '9', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '5.92');
INSERT INTO public.europe_data_import VALUES (831, '16/11/2020', '2020-46', '8', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '4.53');
INSERT INTO public.europe_data_import VALUES (832, '09/11/2020', '2020-45', '5', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '5.23');
INSERT INTO public.europe_data_import VALUES (833, '02/11/2020', '2020-44', '10', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '5.23');
INSERT INTO public.europe_data_import VALUES (834, '26/10/2020', '2020-43', '5', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '6.62');
INSERT INTO public.europe_data_import VALUES (835, '19/10/2020', '2020-42', '14', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '8.01');
INSERT INTO public.europe_data_import VALUES (836, '12/10/2020', '2020-41', '9', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '6.27');
INSERT INTO public.europe_data_import VALUES (837, '05/10/2020', '2020-40', '9', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '3.48');
INSERT INTO public.europe_data_import VALUES (838, '28/09/2020', '2020-39', '1', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '3.14');
INSERT INTO public.europe_data_import VALUES (839, '21/09/2020', '2020-38', '8', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '3.48');
INSERT INTO public.europe_data_import VALUES (840, '14/09/2020', '2020-37', '2', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (841, '07/09/2020', '2020-36', '6', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '6.27');
INSERT INTO public.europe_data_import VALUES (842, '31/08/2020', '2020-35', '12', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '7.66');
INSERT INTO public.europe_data_import VALUES (843, '24/08/2020', '2020-34', '10', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '6.62');
INSERT INTO public.europe_data_import VALUES (844, '17/08/2020', '2020-33', '9', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '6.62');
INSERT INTO public.europe_data_import VALUES (845, '10/08/2020', '2020-32', '10', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '11.15');
INSERT INTO public.europe_data_import VALUES (846, '03/08/2020', '2020-31', '22', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '9.41');
INSERT INTO public.europe_data_import VALUES (847, '27/07/2020', '2020-30', '5', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.44');
INSERT INTO public.europe_data_import VALUES (848, '20/07/2020', '2020-29', '2', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.44');
INSERT INTO public.europe_data_import VALUES (849, '13/07/2020', '2020-28', '5', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.09');
INSERT INTO public.europe_data_import VALUES (850, '06/07/2020', '2020-27', '1', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '0.35');
INSERT INTO public.europe_data_import VALUES (851, '29/06/2020', '2020-26', '0', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '0.35');
INSERT INTO public.europe_data_import VALUES (852, '22/06/2020', '2020-25', '1', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '1.74');
INSERT INTO public.europe_data_import VALUES (853, '15/06/2020', '2020-24', '4', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '1.39');
INSERT INTO public.europe_data_import VALUES (854, '08/06/2020', '2020-23', '0', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (855, '01/06/2020', '2020-22', '0', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '1.39');
INSERT INTO public.europe_data_import VALUES (856, '25/05/2020', '2020-21', '4', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (857, '18/05/2020', '2020-20', '4', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.09');
INSERT INTO public.europe_data_import VALUES (858, '11/05/2020', '2020-19', '2', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '1.74');
INSERT INTO public.europe_data_import VALUES (859, '04/05/2020', '2020-18', '3', '1', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.44');
INSERT INTO public.europe_data_import VALUES (860, '27/04/2020', '2020-17', '4', '1', '287021', 'Barbados', 'BB', 'BRB', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (861, '20/04/2020', '2020-16', '4', '1', '287021', 'Barbados', 'BB', 'BRB', 'America', '6.62');
INSERT INTO public.europe_data_import VALUES (862, '13/04/2020', '2020-15', '15', '3', '287021', 'Barbados', 'BB', 'BRB', 'America', '13.24');
INSERT INTO public.europe_data_import VALUES (863, '06/04/2020', '2020-14', '23', '1', '287021', 'Barbados', 'BB', 'BRB', 'America', '13.59');
INSERT INTO public.europe_data_import VALUES (864, '30/03/2020', '2020-13', '16', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '11.5');
INSERT INTO public.europe_data_import VALUES (865, '23/03/2020', '2020-12', '17', '0', '287021', 'Barbados', 'BB', 'BRB', 'America', '');
INSERT INTO public.europe_data_import VALUES (866, '01/02/2021', '2021-04', '10725', '69', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '221.91');
INSERT INTO public.europe_data_import VALUES (867, '25/01/2021', '2021-03', '10251', '58', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '249.86');
INSERT INTO public.europe_data_import VALUES (868, '18/01/2021', '2021-02', '13367', '65', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '289.85');
INSERT INTO public.europe_data_import VALUES (869, '11/01/2021', '2021-01', '14031', '75', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '268.77');
INSERT INTO public.europe_data_import VALUES (870, '04/01/2021', '2020-53', '11374', '57', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '279.71');
INSERT INTO public.europe_data_import VALUES (871, '28/12/2020', '2020-52', '15065', '70', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '299.32');
INSERT INTO public.europe_data_import VALUES (872, '21/12/2020', '2020-51', '13228', '61', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '278.93');
INSERT INTO public.europe_data_import VALUES (873, '14/12/2020', '2020-50', '13138', '56', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '267.52');
INSERT INTO public.europe_data_import VALUES (874, '07/12/2020', '2020-49', '12149', '56', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '245.0');
INSERT INTO public.europe_data_import VALUES (875, '30/11/2020', '2020-48', '11009', '55', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '220.29');
INSERT INTO public.europe_data_import VALUES (876, '23/11/2020', '2020-47', '9814', '50', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '187.47');
INSERT INTO public.europe_data_import VALUES (877, '16/11/2020', '2020-46', '7906', '39', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '155.79');
INSERT INTO public.europe_data_import VALUES (878, '09/11/2020', '2020-45', '6820', '22', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '142.36');
INSERT INTO public.europe_data_import VALUES (879, '02/11/2020', '2020-44', '6636', '28', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '124.42');
INSERT INTO public.europe_data_import VALUES (880, '26/10/2020', '2020-43', '5125', '28', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '98.27');
INSERT INTO public.europe_data_import VALUES (881, '19/10/2020', '2020-42', '4164', '33', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '78.32');
INSERT INTO public.europe_data_import VALUES (882, '12/10/2020', '2020-41', '3239', '39', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '62.68');
INSERT INTO public.europe_data_import VALUES (883, '05/10/2020', '2020-40', '2686', '39', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '48.89');
INSERT INTO public.europe_data_import VALUES (884, '28/09/2020', '2020-39', '1935', '38', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '36.35');
INSERT INTO public.europe_data_import VALUES (885, '21/09/2020', '2020-38', '1501', '30', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '29.78');
INSERT INTO public.europe_data_import VALUES (886, '14/09/2020', '2020-37', '1314', '39', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '26.3');
INSERT INTO public.europe_data_import VALUES (887, '07/09/2020', '2020-36', '1172', '35', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '25.3');
INSERT INTO public.europe_data_import VALUES (888, '31/08/2020', '2020-35', '1219', '34', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '22.97');
INSERT INTO public.europe_data_import VALUES (889, '24/08/2020', '2020-34', '952', '32', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '17.12');
INSERT INTO public.europe_data_import VALUES (890, '17/08/2020', '2020-33', '666', '23', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '15.33');
INSERT INTO public.europe_data_import VALUES (891, '10/08/2020', '2020-32', '783', '20', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '18.18');
INSERT INTO public.europe_data_import VALUES (892, '03/08/2020', '2020-31', '935', '33', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '20.86');
INSERT INTO public.europe_data_import VALUES (893, '27/07/2020', '2020-30', '1037', '35', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '23.27');
INSERT INTO public.europe_data_import VALUES (894, '20/07/2020', '2020-29', '1163', '35', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '26.88');
INSERT INTO public.europe_data_import VALUES (895, '13/07/2020', '2020-28', '1378', '41', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '36.57');
INSERT INTO public.europe_data_import VALUES (896, '06/07/2020', '2020-27', '2079', '40', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '53.41');
INSERT INTO public.europe_data_import VALUES (897, '29/06/2020', '2020-26', '2970', '37', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '79.37');
INSERT INTO public.europe_data_import VALUES (898, '22/06/2020', '2020-25', '4532', '38', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '104.47');
INSERT INTO public.europe_data_import VALUES (899, '15/06/2020', '2020-24', '5343', '39', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '120.78');
INSERT INTO public.europe_data_import VALUES (900, '08/06/2020', '2020-23', '6074', '34', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '131.52');
INSERT INTO public.europe_data_import VALUES (901, '01/06/2020', '2020-22', '6358', '36', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '136.54');
INSERT INTO public.europe_data_import VALUES (902, '25/05/2020', '2020-21', '6548', '34', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '139.91');
INSERT INTO public.europe_data_import VALUES (903, '18/05/2020', '2020-20', '6677', '34', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '136.95');
INSERT INTO public.europe_data_import VALUES (904, '11/05/2020', '2020-19', '6268', '32', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '132.35');
INSERT INTO public.europe_data_import VALUES (905, '04/05/2020', '2020-18', '6242', '27', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '115.29');
INSERT INTO public.europe_data_import VALUES (906, '27/04/2020', '2020-17', '4656', '25', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '83.42');
INSERT INTO public.europe_data_import VALUES (907, '20/04/2020', '2020-16', '3229', '21', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '55.47');
INSERT INTO public.europe_data_import VALUES (908, '13/04/2020', '2020-15', '2014', '18', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '26.28');
INSERT INTO public.europe_data_import VALUES (909, '06/04/2020', '2020-14', '470', '8', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '5.16');
INSERT INTO public.europe_data_import VALUES (910, '30/03/2020', '2020-13', '18', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0.71');
INSERT INTO public.europe_data_import VALUES (911, '23/03/2020', '2020-12', '49', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0.74');
INSERT INTO public.europe_data_import VALUES (912, '16/03/2020', '2020-11', '21', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0.28');
INSERT INTO public.europe_data_import VALUES (913, '09/03/2020', '2020-10', '5', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0.06');
INSERT INTO public.europe_data_import VALUES (914, '02/03/2020', '2020-09', '1', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (915, '24/02/2020', '2020-08', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (916, '17/02/2020', '2020-07', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (917, '10/02/2020', '2020-06', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (918, '03/02/2020', '2020-05', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (919, '27/01/2020', '2020-04', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (920, '20/01/2020', '2020-03', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (921, '13/01/2020', '2020-02', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (922, '06/01/2020', '2020-01', '0', '0', '9452409', 'Belarus', 'BY', 'BLR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (923, '01/02/2021', '2021-04', '16454', '291', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '276.37');
INSERT INTO public.europe_data_import VALUES (924, '25/01/2021', '2021-03', '15206', '373', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '253.6');
INSERT INTO public.europe_data_import VALUES (925, '18/01/2021', '2021-02', '13845', '344', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '249.23');
INSERT INTO public.europe_data_import VALUES (926, '11/01/2021', '2021-01', '14706', '384', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '227.74');
INSERT INTO public.europe_data_import VALUES (927, '04/01/2021', '2020-53', '11383', '455', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '209.22');
INSERT INTO public.europe_data_import VALUES (928, '28/12/2020', '2020-52', '12584', '534', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '264.21');
INSERT INTO public.europe_data_import VALUES (929, '21/12/2020', '2020-51', '17683', '654', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '300.96');
INSERT INTO public.europe_data_import VALUES (930, '14/12/2020', '2020-50', '16793', '666', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '279.93');
INSERT INTO public.europe_data_import VALUES (931, '07/12/2020', '2020-49', '15275', '699', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '275.22');
INSERT INTO public.europe_data_import VALUES (932, '30/11/2020', '2020-48', '16253', '874', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '336.6');
INSERT INTO public.europe_data_import VALUES (933, '23/11/2020', '2020-47', '22306', '1123', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '491.19');
INSERT INTO public.europe_data_import VALUES (934, '16/11/2020', '2020-46', '33962', '1328', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '767.8');
INSERT INTO public.europe_data_import VALUES (935, '09/11/2020', '2020-45', '53994', '1411', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '1340.3');
INSERT INTO public.europe_data_import VALUES (936, '02/11/2020', '2020-44', '99544', '1056', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '1788.42');
INSERT INTO public.europe_data_import VALUES (937, '26/10/2020', '2020-43', '105329', '502', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '1549.69');
INSERT INTO public.europe_data_import VALUES (938, '19/10/2020', '2020-42', '72196', '236', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '969.19');
INSERT INTO public.europe_data_import VALUES (939, '12/10/2020', '2020-41', '38830', '139', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '503.81');
INSERT INTO public.europe_data_import VALUES (940, '05/10/2020', '2020-40', '18884', '84', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '263.26');
INSERT INTO public.europe_data_import VALUES (941, '28/09/2020', '2020-39', '11274', '39', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '186.65');
INSERT INTO public.europe_data_import VALUES (942, '21/09/2020', '2020-38', '10108', '27', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '141.99');
INSERT INTO public.europe_data_import VALUES (943, '14/09/2020', '2020-37', '6158', '19', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '85.66');
INSERT INTO public.europe_data_import VALUES (944, '07/09/2020', '2020-36', '3655', '17', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '59.15');
INSERT INTO public.europe_data_import VALUES (945, '31/08/2020', '2020-35', '3121', '28', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '57.39');
INSERT INTO public.europe_data_import VALUES (946, '24/08/2020', '2020-34', '3453', '42', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '62.89');
INSERT INTO public.europe_data_import VALUES (947, '17/08/2020', '2020-33', '3751', '75', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '70.63');
INSERT INTO public.europe_data_import VALUES (948, '10/08/2020', '2020-32', '4340', '30', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '70.7');
INSERT INTO public.europe_data_import VALUES (949, '03/08/2020', '2020-31', '3759', '20', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '54.54');
INSERT INTO public.europe_data_import VALUES (950, '27/07/2020', '2020-30', '2489', '15', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '33.82');
INSERT INTO public.europe_data_import VALUES (951, '20/07/2020', '2020-29', '1385', '19', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '18.24');
INSERT INTO public.europe_data_import VALUES (952, '13/07/2020', '2020-28', '704', '13', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '11.71');
INSERT INTO public.europe_data_import VALUES (953, '06/07/2020', '2020-27', '637', '25', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '10.86');
INSERT INTO public.europe_data_import VALUES (954, '29/06/2020', '2020-26', '607', '39', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '11.13');
INSERT INTO public.europe_data_import VALUES (955, '22/06/2020', '2020-25', '668', '43', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '11.69');
INSERT INTO public.europe_data_import VALUES (956, '15/06/2020', '2020-24', '671', '58', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '13.25');
INSERT INTO public.europe_data_import VALUES (957, '08/06/2020', '2020-23', '847', '113', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '17.38');
INSERT INTO public.europe_data_import VALUES (958, '01/06/2020', '2020-22', '1144', '160', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '23.17');
INSERT INTO public.europe_data_import VALUES (959, '25/05/2020', '2020-21', '1510', '230', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '31.26');
INSERT INTO public.europe_data_import VALUES (960, '18/05/2020', '2020-20', '2071', '314', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '44.71');
INSERT INTO public.europe_data_import VALUES (961, '11/05/2020', '2020-19', '3051', '535', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '53.65');
INSERT INTO public.europe_data_import VALUES (962, '04/05/2020', '2020-18', '3095', '698', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '76.8');
INSERT INTO public.europe_data_import VALUES (963, '27/04/2020', '2020-17', '5703', '1195', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '119.3');
INSERT INTO public.europe_data_import VALUES (964, '20/04/2020', '2020-16', '7963', '1667', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '167.06');
INSERT INTO public.europe_data_import VALUES (965, '13/04/2020', '2020-15', '11175', '1979', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '182.17');
INSERT INTO public.europe_data_import VALUES (966, '06/04/2020', '2020-14', '9694', '1584', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '155.59');
INSERT INTO public.europe_data_import VALUES (967, '30/03/2020', '2020-13', '8130', '782', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '103.03');
INSERT INTO public.europe_data_import VALUES (968, '23/03/2020', '2020-12', '3673', '198', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '43.83');
INSERT INTO public.europe_data_import VALUES (969, '16/03/2020', '2020-11', '1348', '18', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '15.15');
INSERT INTO public.europe_data_import VALUES (970, '09/03/2020', '2020-10', '388', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0.56');
INSERT INTO public.europe_data_import VALUES (971, '02/03/2020', '2020-09', '-324', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0.17');
INSERT INTO public.europe_data_import VALUES (972, '24/02/2020', '2020-08', '343', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '2.99');
INSERT INTO public.europe_data_import VALUES (973, '17/02/2020', '2020-07', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (974, '10/02/2020', '2020-06', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (975, '03/02/2020', '2020-05', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (976, '27/01/2020', '2020-04', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (977, '20/01/2020', '2020-03', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (978, '13/01/2020', '2020-02', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (979, '06/01/2020', '2020-01', '0', '0', '11455519', 'Belgium', 'BE', 'BEL', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (980, '01/02/2021', '2021-04', '175', '9', '390351', 'Belize', 'BZ', 'BLZ', 'America', '111.95');
INSERT INTO public.europe_data_import VALUES (981, '25/01/2021', '2021-03', '262', '12', '390351', 'Belize', 'BZ', 'BLZ', 'America', '119.64');
INSERT INTO public.europe_data_import VALUES (982, '18/01/2021', '2021-02', '205', '7', '390351', 'Belize', 'BZ', 'BLZ', 'America', '155.5');
INSERT INTO public.europe_data_import VALUES (983, '11/01/2021', '2021-01', '402', '24', '390351', 'Belize', 'BZ', 'BLZ', 'America', '190.09');
INSERT INTO public.europe_data_import VALUES (984, '04/01/2021', '2020-53', '340', '17', '390351', 'Belize', 'BZ', 'BLZ', 'America', '193.67');
INSERT INTO public.europe_data_import VALUES (985, '28/12/2020', '2020-52', '416', '9', '390351', 'Belize', 'BZ', 'BLZ', 'America', '324.32');
INSERT INTO public.europe_data_import VALUES (986, '21/12/2020', '2020-51', '850', '29', '390351', 'Belize', 'BZ', 'BLZ', 'America', '608.68');
INSERT INTO public.europe_data_import VALUES (987, '14/12/2020', '2020-50', '1526', '22', '390351', 'Belize', 'BZ', 'BLZ', 'America', '909.95');
INSERT INTO public.europe_data_import VALUES (988, '07/12/2020', '2020-49', '2026', '26', '390351', 'Belize', 'BZ', 'BLZ', 'America', '662.48');
INSERT INTO public.europe_data_import VALUES (989, '30/11/2020', '2020-48', '560', '31', '390351', 'Belize', 'BZ', 'BLZ', 'America', '225.95');
INSERT INTO public.europe_data_import VALUES (990, '23/11/2020', '2020-47', '322', '26', '390351', 'Belize', 'BZ', 'BLZ', 'America', '257.97');
INSERT INTO public.europe_data_import VALUES (991, '16/11/2020', '2020-46', '685', '20', '390351', 'Belize', 'BZ', 'BLZ', 'America', '358.4');
INSERT INTO public.europe_data_import VALUES (992, '09/11/2020', '2020-45', '714', '12', '390351', 'Belize', 'BZ', 'BLZ', 'America', '264.12');
INSERT INTO public.europe_data_import VALUES (993, '02/11/2020', '2020-44', '317', '8', '390351', 'Belize', 'BZ', 'BLZ', 'America', '166.26');
INSERT INTO public.europe_data_import VALUES (994, '26/10/2020', '2020-43', '332', '6', '390351', 'Belize', 'BZ', 'BLZ', 'America', '183.94');
INSERT INTO public.europe_data_import VALUES (995, '19/10/2020', '2020-42', '386', '9', '390351', 'Belize', 'BZ', 'BLZ', 'America', '158.06');
INSERT INTO public.europe_data_import VALUES (996, '12/10/2020', '2020-41', '231', '5', '390351', 'Belize', 'BZ', 'BLZ', 'America', '146.79');
INSERT INTO public.europe_data_import VALUES (997, '05/10/2020', '2020-40', '342', '6', '390351', 'Belize', 'BZ', 'BLZ', 'America', '145.77');
INSERT INTO public.europe_data_import VALUES (998, '28/09/2020', '2020-39', '227', '3', '390351', 'Belize', 'BZ', 'BLZ', 'America', '95.81');
INSERT INTO public.europe_data_import VALUES (999, '21/09/2020', '2020-38', '147', '2', '390351', 'Belize', 'BZ', 'BLZ', 'America', '93.76');
INSERT INTO public.europe_data_import VALUES (1000, '14/09/2020', '2020-37', '219', '4', '390351', 'Belize', 'BZ', 'BLZ', 'America', '124.5');
INSERT INTO public.europe_data_import VALUES (1001, '07/09/2020', '2020-36', '267', '2', '390351', 'Belize', 'BZ', 'BLZ', 'America', '147.3');
INSERT INTO public.europe_data_import VALUES (1002, '31/08/2020', '2020-35', '308', '7', '390351', 'Belize', 'BZ', 'BLZ', 'America', '138.85');
INSERT INTO public.europe_data_import VALUES (1003, '24/08/2020', '2020-34', '234', '3', '390351', 'Belize', 'BZ', 'BLZ', 'America', '136.29');
INSERT INTO public.europe_data_import VALUES (1004, '17/08/2020', '2020-33', '298', '1', '390351', 'Belize', 'BZ', 'BLZ', 'America', '101.19');
INSERT INTO public.europe_data_import VALUES (1005, '10/08/2020', '2020-32', '97', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '27.16');
INSERT INTO public.europe_data_import VALUES (1006, '03/08/2020', '2020-31', '9', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '4.36');
INSERT INTO public.europe_data_import VALUES (1007, '27/07/2020', '2020-30', '8', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '2.82');
INSERT INTO public.europe_data_import VALUES (1008, '20/07/2020', '2020-29', '3', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '2.56');
INSERT INTO public.europe_data_import VALUES (1009, '13/07/2020', '2020-28', '7', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1010, '06/07/2020', '2020-27', '6', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '2.05');
INSERT INTO public.europe_data_import VALUES (1011, '29/06/2020', '2020-26', '2', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0.77');
INSERT INTO public.europe_data_import VALUES (1012, '22/06/2020', '2020-25', '1', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '1.02');
INSERT INTO public.europe_data_import VALUES (1013, '15/06/2020', '2020-24', '3', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0.77');
INSERT INTO public.europe_data_import VALUES (1014, '08/06/2020', '2020-23', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1015, '01/06/2020', '2020-22', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1016, '25/05/2020', '2020-21', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1017, '18/05/2020', '2020-20', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1018, '11/05/2020', '2020-19', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1019, '04/05/2020', '2020-18', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1020, '27/04/2020', '2020-17', '0', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '1.02');
INSERT INTO public.europe_data_import VALUES (1021, '20/04/2020', '2020-16', '4', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1022, '13/04/2020', '2020-15', '9', '1', '390351', 'Belize', 'BZ', 'BLZ', 'America', '3.07');
INSERT INTO public.europe_data_import VALUES (1023, '06/04/2020', '2020-14', '3', '1', '390351', 'Belize', 'BZ', 'BLZ', 'America', '1.28');
INSERT INTO public.europe_data_import VALUES (1024, '30/03/2020', '2020-13', '2', '0', '390351', 'Belize', 'BZ', 'BLZ', 'America', '');
INSERT INTO public.europe_data_import VALUES (1025, '01/02/2021', '2021-04', '250', '4', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '4.07');
INSERT INTO public.europe_data_import VALUES (1026, '25/01/2021', '2021-03', '230', '2', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '2.87');
INSERT INTO public.europe_data_import VALUES (1027, '18/01/2021', '2021-02', '109', '2', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.37');
INSERT INTO public.europe_data_import VALUES (1028, '11/01/2021', '2021-01', '53', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.84');
INSERT INTO public.europe_data_import VALUES (1029, '04/01/2021', '2020-53', '46', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.71');
INSERT INTO public.europe_data_import VALUES (1030, '28/12/2020', '2020-52', '38', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.97');
INSERT INTO public.europe_data_import VALUES (1031, '21/12/2020', '2020-51', '77', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (1032, '14/12/2020', '2020-50', '35', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.98');
INSERT INTO public.europe_data_import VALUES (1033, '07/12/2020', '2020-49', '81', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.18');
INSERT INTO public.europe_data_import VALUES (1034, '30/11/2020', '2020-48', '58', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.1');
INSERT INTO public.europe_data_import VALUES (1035, '23/11/2020', '2020-47', '72', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.45');
INSERT INTO public.europe_data_import VALUES (1036, '16/11/2020', '2020-46', '99', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.7');
INSERT INTO public.europe_data_import VALUES (1037, '09/11/2020', '2020-45', '102', '2', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.59');
INSERT INTO public.europe_data_import VALUES (1038, '02/11/2020', '2020-44', '86', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.25');
INSERT INTO public.europe_data_import VALUES (1039, '26/10/2020', '2020-43', '61', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.24');
INSERT INTO public.europe_data_import VALUES (1040, '19/10/2020', '2020-42', '85', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.18');
INSERT INTO public.europe_data_import VALUES (1041, '12/10/2020', '2020-41', '54', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (1042, '05/10/2020', '2020-40', '17', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.65');
INSERT INTO public.europe_data_import VALUES (1043, '28/09/2020', '2020-39', '60', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (1044, '21/09/2020', '2020-38', '13', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.57');
INSERT INTO public.europe_data_import VALUES (1045, '14/09/2020', '2020-37', '54', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (1046, '07/09/2020', '2020-36', '68', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.83');
INSERT INTO public.europe_data_import VALUES (1047, '31/08/2020', '2020-35', '30', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (1048, '24/08/2020', '2020-34', '52', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.52');
INSERT INTO public.europe_data_import VALUES (1049, '17/08/2020', '2020-33', '127', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '2.19');
INSERT INTO public.europe_data_import VALUES (1050, '10/08/2020', '2020-32', '131', '2', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (1051, '03/08/2020', '2020-31', '35', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.72');
INSERT INTO public.europe_data_import VALUES (1052, '27/07/2020', '2020-30', '168', '4', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '3.32');
INSERT INTO public.europe_data_import VALUES (1053, '20/07/2020', '2020-29', '224', '5', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '3.41');
INSERT INTO public.europe_data_import VALUES (1054, '13/07/2020', '2020-28', '179', '5', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '1.94');
INSERT INTO public.europe_data_import VALUES (1055, '06/07/2020', '2020-27', '50', '5', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '3.68');
INSERT INTO public.europe_data_import VALUES (1056, '29/06/2020', '2020-26', '384', '3', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '5.75');
INSERT INTO public.europe_data_import VALUES (1057, '22/06/2020', '2020-25', '295', '6', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '4.21');
INSERT INTO public.europe_data_import VALUES (1058, '15/06/2020', '2020-24', '202', '3', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '2.02');
INSERT INTO public.europe_data_import VALUES (1059, '08/06/2020', '2020-23', '36', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.65');
INSERT INTO public.europe_data_import VALUES (1060, '01/06/2020', '2020-22', '41', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '-0.91');
INSERT INTO public.europe_data_import VALUES (1061, '25/05/2020', '2020-21', '-148', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '-1.08');
INSERT INTO public.europe_data_import VALUES (1062, '18/05/2020', '2020-20', '20', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '2.11');
INSERT INTO public.europe_data_import VALUES (1063, '11/05/2020', '2020-19', '229', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '2.16');
INSERT INTO public.europe_data_import VALUES (1064, '04/05/2020', '2020-18', '26', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.45');
INSERT INTO public.europe_data_import VALUES (1065, '27/04/2020', '2020-17', '27', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.25');
INSERT INTO public.europe_data_import VALUES (1066, '20/04/2020', '2020-16', '2', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (1067, '13/04/2020', '2020-15', '13', '1', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.25');
INSERT INTO public.europe_data_import VALUES (1068, '06/04/2020', '2020-14', '16', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (1069, '30/03/2020', '2020-13', '4', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (1070, '23/03/2020', '2020-12', '2', '0', '11801151', 'Benin', 'BJ', 'BEN', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1071, '01/02/2021', '2021-04', '6', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '14.4');
INSERT INTO public.europe_data_import VALUES (1072, '25/01/2021', '2021-03', '3', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '47.99');
INSERT INTO public.europe_data_import VALUES (1073, '18/01/2021', '2021-02', '27', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '97.59');
INSERT INTO public.europe_data_import VALUES (1074, '11/01/2021', '2021-01', '34', '2', '62508', 'Bermuda', 'BM', 'BMU', 'America', '119.98');
INSERT INTO public.europe_data_import VALUES (1075, '04/01/2021', '2020-53', '41', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '151.98');
INSERT INTO public.europe_data_import VALUES (1076, '28/12/2020', '2020-52', '54', '1', '62508', 'Bermuda', 'BM', 'BMU', 'America', '239.97');
INSERT INTO public.europe_data_import VALUES (1077, '21/12/2020', '2020-51', '96', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '382.35');
INSERT INTO public.europe_data_import VALUES (1078, '14/12/2020', '2020-50', '143', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '287.96');
INSERT INTO public.europe_data_import VALUES (1079, '07/12/2020', '2020-49', '37', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '97.59');
INSERT INTO public.europe_data_import VALUES (1080, '30/11/2020', '2020-48', '24', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '46.39');
INSERT INTO public.europe_data_import VALUES (1081, '23/11/2020', '2020-47', '5', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '28.8');
INSERT INTO public.europe_data_import VALUES (1082, '16/11/2020', '2020-46', '13', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '36.8');
INSERT INTO public.europe_data_import VALUES (1083, '09/11/2020', '2020-45', '10', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '28.8');
INSERT INTO public.europe_data_import VALUES (1084, '02/11/2020', '2020-44', '8', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '22.4');
INSERT INTO public.europe_data_import VALUES (1085, '26/10/2020', '2020-43', '6', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '11.2');
INSERT INTO public.europe_data_import VALUES (1086, '19/10/2020', '2020-42', '1', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '6.4');
INSERT INTO public.europe_data_import VALUES (1087, '12/10/2020', '2020-41', '3', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '4.8');
INSERT INTO public.europe_data_import VALUES (1088, '05/10/2020', '2020-40', '0', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '1.6');
INSERT INTO public.europe_data_import VALUES (1089, '28/09/2020', '2020-39', '1', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '6.4');
INSERT INTO public.europe_data_import VALUES (1090, '21/09/2020', '2020-38', '3', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '8.0');
INSERT INTO public.europe_data_import VALUES (1091, '14/09/2020', '2020-37', '2', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '12.8');
INSERT INTO public.europe_data_import VALUES (1092, '07/09/2020', '2020-36', '6', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '12.8');
INSERT INTO public.europe_data_import VALUES (1093, '31/08/2020', '2020-35', '2', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '11.2');
INSERT INTO public.europe_data_import VALUES (1094, '24/08/2020', '2020-34', '5', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '14.4');
INSERT INTO public.europe_data_import VALUES (1095, '17/08/2020', '2020-33', '4', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '9.6');
INSERT INTO public.europe_data_import VALUES (1096, '10/08/2020', '2020-32', '2', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '6.4');
INSERT INTO public.europe_data_import VALUES (1097, '03/08/2020', '2020-31', '2', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '4.8');
INSERT INTO public.europe_data_import VALUES (1098, '27/07/2020', '2020-30', '1', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '6.4');
INSERT INTO public.europe_data_import VALUES (1099, '20/07/2020', '2020-29', '3', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '11.2');
INSERT INTO public.europe_data_import VALUES (1100, '13/07/2020', '2020-28', '4', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '6.4');
INSERT INTO public.europe_data_import VALUES (1101, '06/07/2020', '2020-27', '0', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1102, '29/06/2020', '2020-26', '0', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '3.2');
INSERT INTO public.europe_data_import VALUES (1103, '22/06/2020', '2020-25', '2', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '8.0');
INSERT INTO public.europe_data_import VALUES (1104, '15/06/2020', '2020-24', '3', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '6.4');
INSERT INTO public.europe_data_import VALUES (1105, '08/06/2020', '2020-23', '1', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '12.8');
INSERT INTO public.europe_data_import VALUES (1106, '01/06/2020', '2020-22', '7', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '27.2');
INSERT INTO public.europe_data_import VALUES (1107, '25/05/2020', '2020-21', '10', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '24.0');
INSERT INTO public.europe_data_import VALUES (1108, '18/05/2020', '2020-20', '5', '2', '62508', 'Bermuda', 'BM', 'BMU', 'America', '12.8');
INSERT INTO public.europe_data_import VALUES (1109, '11/05/2020', '2020-19', '3', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '14.4');
INSERT INTO public.europe_data_import VALUES (1110, '04/05/2020', '2020-18', '6', '2', '62508', 'Bermuda', 'BM', 'BMU', 'America', '46.39');
INSERT INTO public.europe_data_import VALUES (1111, '27/04/2020', '2020-17', '23', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '83.19');
INSERT INTO public.europe_data_import VALUES (1112, '20/04/2020', '2020-16', '29', '1', '62508', 'Bermuda', 'BM', 'BMU', 'America', '78.39');
INSERT INTO public.europe_data_import VALUES (1113, '13/04/2020', '2020-15', '20', '4', '62508', 'Bermuda', 'BM', 'BMU', 'America', '55.99');
INSERT INTO public.europe_data_import VALUES (1114, '06/04/2020', '2020-14', '15', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '49.59');
INSERT INTO public.europe_data_import VALUES (1115, '30/03/2020', '2020-13', '16', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '35.2');
INSERT INTO public.europe_data_import VALUES (1116, '23/03/2020', '2020-12', '6', '0', '62508', 'Bermuda', 'BM', 'BMU', 'America', '');
INSERT INTO public.europe_data_import VALUES (1117, '01/02/2021', '2021-04', '4', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.23');
INSERT INTO public.europe_data_import VALUES (1118, '25/01/2021', '2021-03', '13', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '5.5');
INSERT INTO public.europe_data_import VALUES (1119, '18/01/2021', '2021-02', '29', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '16.51');
INSERT INTO public.europe_data_import VALUES (1120, '11/01/2021', '2021-01', '97', '1', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '24.9');
INSERT INTO public.europe_data_import VALUES (1121, '04/01/2021', '2020-53', '93', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '32.63');
INSERT INTO public.europe_data_import VALUES (1122, '28/12/2020', '2020-52', '156', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '24.24');
INSERT INTO public.europe_data_import VALUES (1123, '21/12/2020', '2020-51', '29', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.85');
INSERT INTO public.europe_data_import VALUES (1124, '14/12/2020', '2020-50', '8', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '5.5');
INSERT INTO public.europe_data_import VALUES (1125, '07/12/2020', '2020-49', '34', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '6.29');
INSERT INTO public.europe_data_import VALUES (1126, '30/11/2020', '2020-48', '14', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.75');
INSERT INTO public.europe_data_import VALUES (1127, '23/11/2020', '2020-47', '7', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '3.01');
INSERT INTO public.europe_data_import VALUES (1128, '16/11/2020', '2020-46', '16', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.75');
INSERT INTO public.europe_data_import VALUES (1129, '09/11/2020', '2020-45', '5', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.23');
INSERT INTO public.europe_data_import VALUES (1130, '02/11/2020', '2020-44', '12', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '3.54');
INSERT INTO public.europe_data_import VALUES (1131, '26/10/2020', '2020-43', '15', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.32');
INSERT INTO public.europe_data_import VALUES (1132, '19/10/2020', '2020-42', '18', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '3.8');
INSERT INTO public.europe_data_import VALUES (1133, '12/10/2020', '2020-41', '11', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.72');
INSERT INTO public.europe_data_import VALUES (1134, '05/10/2020', '2020-40', '25', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.85');
INSERT INTO public.europe_data_import VALUES (1135, '28/09/2020', '2020-39', '12', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '3.67');
INSERT INTO public.europe_data_import VALUES (1136, '21/09/2020', '2020-38', '16', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.06');
INSERT INTO public.europe_data_import VALUES (1137, '14/09/2020', '2020-37', '15', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.75');
INSERT INTO public.europe_data_import VALUES (1138, '07/09/2020', '2020-36', '6', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '9.83');
INSERT INTO public.europe_data_import VALUES (1139, '31/08/2020', '2020-35', '69', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '10.88');
INSERT INTO public.europe_data_import VALUES (1140, '24/08/2020', '2020-34', '14', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '5.9');
INSERT INTO public.europe_data_import VALUES (1141, '17/08/2020', '2020-33', '31', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.98');
INSERT INTO public.europe_data_import VALUES (1142, '10/08/2020', '2020-32', '7', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.97');
INSERT INTO public.europe_data_import VALUES (1143, '03/08/2020', '2020-31', '8', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.83');
INSERT INTO public.europe_data_import VALUES (1144, '27/07/2020', '2020-30', '6', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.44');
INSERT INTO public.europe_data_import VALUES (1145, '20/07/2020', '2020-29', '5', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.18');
INSERT INTO public.europe_data_import VALUES (1146, '13/07/2020', '2020-28', '4', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.05');
INSERT INTO public.europe_data_import VALUES (1147, '06/07/2020', '2020-27', '4', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.57');
INSERT INTO public.europe_data_import VALUES (1148, '29/06/2020', '2020-26', '8', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.31');
INSERT INTO public.europe_data_import VALUES (1149, '22/06/2020', '2020-25', '2', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.18');
INSERT INTO public.europe_data_import VALUES (1150, '15/06/2020', '2020-24', '7', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '3.01');
INSERT INTO public.europe_data_import VALUES (1151, '08/06/2020', '2020-23', '16', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '4.19');
INSERT INTO public.europe_data_import VALUES (1152, '01/06/2020', '2020-22', '16', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.88');
INSERT INTO public.europe_data_import VALUES (1153, '25/05/2020', '2020-21', '6', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '2.36');
INSERT INTO public.europe_data_import VALUES (1154, '18/05/2020', '2020-20', '12', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '1.83');
INSERT INTO public.europe_data_import VALUES (1155, '11/05/2020', '2020-19', '2', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (1156, '04/05/2020', '2020-18', '0', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (1157, '27/04/2020', '2020-17', '2', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (1158, '20/04/2020', '2020-16', '0', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1159, '13/04/2020', '2020-15', '0', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (1160, '06/04/2020', '2020-14', '1', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0.39');
INSERT INTO public.europe_data_import VALUES (1161, '30/03/2020', '2020-13', '2', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '0.52');
INSERT INTO public.europe_data_import VALUES (1162, '23/03/2020', '2020-12', '2', '0', '763094', 'Bhutan', 'BT', 'BTN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (1163, '01/02/2021', '2021-04', '14017', '328', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '257.55');
INSERT INTO public.europe_data_import VALUES (1164, '25/01/2021', '2021-03', '15635', '415', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '251.21');
INSERT INTO public.europe_data_import VALUES (1165, '18/01/2021', '2021-02', '13287', '260', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '212.99');
INSERT INTO public.europe_data_import VALUES (1166, '11/01/2021', '2021-01', '11235', '175', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '165.49');
INSERT INTO public.europe_data_import VALUES (1167, '04/01/2021', '2020-53', '7818', '103', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '106.63');
INSERT INTO public.europe_data_import VALUES (1168, '28/12/2020', '2020-52', '4458', '55', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '66.82');
INSERT INTO public.europe_data_import VALUES (1169, '21/12/2020', '2020-51', '3235', '25', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '41.91');
INSERT INTO public.europe_data_import VALUES (1170, '14/12/2020', '2020-50', '1590', '23', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '21.96');
INSERT INTO public.europe_data_import VALUES (1171, '07/12/2020', '2020-49', '938', '43', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '14.23');
INSERT INTO public.europe_data_import VALUES (1172, '30/11/2020', '2020-48', '700', '48', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '11.95');
INSERT INTO public.europe_data_import VALUES (1173, '23/11/2020', '2020-47', '676', '55', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '12.57');
INSERT INTO public.europe_data_import VALUES (1174, '16/11/2020', '2020-46', '771', '54', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '12.27');
INSERT INTO public.europe_data_import VALUES (1175, '09/11/2020', '2020-45', '642', '64', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '14.09');
INSERT INTO public.europe_data_import VALUES (1176, '02/11/2020', '2020-44', '980', '86', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '17.91');
INSERT INTO public.europe_data_import VALUES (1177, '26/10/2020', '2020-43', '1082', '164', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '19.79');
INSERT INTO public.europe_data_import VALUES (1178, '19/10/2020', '2020-42', '1197', '173', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '25.21');
INSERT INTO public.europe_data_import VALUES (1179, '12/10/2020', '2020-41', '1706', '207', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '40.59');
INSERT INTO public.europe_data_import VALUES (1180, '05/10/2020', '2020-40', '2967', '243', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '53.78');
INSERT INTO public.europe_data_import VALUES (1181, '28/09/2020', '2020-39', '3225', '241', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '61.76');
INSERT INTO public.europe_data_import VALUES (1182, '21/09/2020', '2020-38', '3885', '273', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '86.05');
INSERT INTO public.europe_data_import VALUES (1183, '14/09/2020', '2020-37', '6022', '336', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '94.01');
INSERT INTO public.europe_data_import VALUES (1184, '07/09/2020', '2020-36', '4801', '2042', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '100.93');
INSERT INTO public.europe_data_import VALUES (1185, '31/08/2020', '2020-35', '6819', '457', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '135.71');
INSERT INTO public.europe_data_import VALUES (1186, '24/08/2020', '2020-34', '8805', '461', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '166.33');
INSERT INTO public.europe_data_import VALUES (1187, '17/08/2020', '2020-33', '10345', '408', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '175.37');
INSERT INTO public.europe_data_import VALUES (1188, '10/08/2020', '2020-32', '9846', '487', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '178.67');
INSERT INTO public.europe_data_import VALUES (1189, '03/08/2020', '2020-31', '10724', '570', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '178.67');
INSERT INTO public.europe_data_import VALUES (1190, '27/07/2020', '2020-30', '9847', '432', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '184.5');
INSERT INTO public.europe_data_import VALUES (1191, '20/07/2020', '2020-29', '11395', '344', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '176.19');
INSERT INTO public.europe_data_import VALUES (1192, '13/07/2020', '2020-28', '8890', '373', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '144.73');
INSERT INTO public.europe_data_import VALUES (1193, '06/07/2020', '2020-27', '7773', '420', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '129.5');
INSERT INTO public.europe_data_import VALUES (1194, '29/06/2020', '2020-26', '7136', '241', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '113.48');
INSERT INTO public.europe_data_import VALUES (1195, '22/06/2020', '2020-25', '5929', '162', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '93.33');
INSERT INTO public.europe_data_import VALUES (1196, '15/06/2020', '2020-24', '4816', '146', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '73.63');
INSERT INTO public.europe_data_import VALUES (1197, '08/06/2020', '2020-23', '3661', '152', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '64.1');
INSERT INTO public.europe_data_import VALUES (1198, '01/06/2020', '2020-22', '3719', '63', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '51.19');
INSERT INTO public.europe_data_import VALUES (1199, '25/05/2020', '2020-21', '2175', '81', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '32.2');
INSERT INTO public.europe_data_import VALUES (1200, '18/05/2020', '2020-20', '1532', '51', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '21.66');
INSERT INTO public.europe_data_import VALUES (1201, '11/05/2020', '2020-19', '962', '42', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '13.95');
INSERT INTO public.europe_data_import VALUES (1202, '04/05/2020', '2020-18', '644', '26', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '8.95');
INSERT INTO public.europe_data_import VALUES (1203, '27/04/2020', '2020-17', '386', '17', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '5.39');
INSERT INTO public.europe_data_import VALUES (1204, '20/04/2020', '2020-16', '234', '6', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '3.31');
INSERT INTO public.europe_data_import VALUES (1205, '13/04/2020', '2020-15', '147', '16', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '2.03');
INSERT INTO public.europe_data_import VALUES (1206, '06/04/2020', '2020-14', '87', '8', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '1.35');
INSERT INTO public.europe_data_import VALUES (1207, '30/03/2020', '2020-13', '69', '3', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '0.83');
INSERT INTO public.europe_data_import VALUES (1208, '23/03/2020', '2020-12', '27', '0', '11513102', 'Bolivia', 'BO', 'BOL', 'America', '');
INSERT INTO public.europe_data_import VALUES (1209, '01/02/2021', '2021-04', '10', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '103.91');
INSERT INTO public.europe_data_import VALUES (1210, '25/01/2021', '2021-03', '17', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '184.74');
INSERT INTO public.europe_data_import VALUES (1211, '18/01/2021', '2021-02', '31', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '477.24');
INSERT INTO public.europe_data_import VALUES (1212, '11/01/2021', '2021-01', '93', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '581.15');
INSERT INTO public.europe_data_import VALUES (1213, '04/01/2021', '2020-53', '58', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '238.62');
INSERT INTO public.europe_data_import VALUES (1214, '28/12/2020', '2020-52', '4', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '38.49');
INSERT INTO public.europe_data_import VALUES (1215, '21/12/2020', '2020-51', '6', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '57.73');
INSERT INTO public.europe_data_import VALUES (1216, '14/12/2020', '2020-50', '9', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '46.18');
INSERT INTO public.europe_data_import VALUES (1217, '07/12/2020', '2020-49', '3', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '11.55');
INSERT INTO public.europe_data_import VALUES (1218, '30/11/2020', '2020-48', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '23.09');
INSERT INTO public.europe_data_import VALUES (1219, '23/11/2020', '2020-47', '6', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '26.94');
INSERT INTO public.europe_data_import VALUES (1220, '16/11/2020', '2020-46', '1', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (1221, '09/11/2020', '2020-45', '1', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '15.39');
INSERT INTO public.europe_data_import VALUES (1222, '02/11/2020', '2020-44', '3', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '11.55');
INSERT INTO public.europe_data_import VALUES (1223, '26/10/2020', '2020-43', '0', '1', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (1224, '19/10/2020', '2020-42', '2', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '100.07');
INSERT INTO public.europe_data_import VALUES (1225, '12/10/2020', '2020-41', '24', '1', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '242.47');
INSERT INTO public.europe_data_import VALUES (1226, '05/10/2020', '2020-40', '39', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '338.68');
INSERT INTO public.europe_data_import VALUES (1227, '28/09/2020', '2020-39', '49', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '227.07');
INSERT INTO public.europe_data_import VALUES (1228, '21/09/2020', '2020-38', '10', '1', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '69.28');
INSERT INTO public.europe_data_import VALUES (1229, '14/09/2020', '2020-37', '8', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '42.34');
INSERT INTO public.europe_data_import VALUES (1230, '07/09/2020', '2020-36', '3', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '19.24');
INSERT INTO public.europe_data_import VALUES (1231, '31/08/2020', '2020-35', '2', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (1232, '24/08/2020', '2020-34', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1233, '17/08/2020', '2020-33', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (1234, '10/08/2020', '2020-32', '2', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (1235, '03/08/2020', '2020-31', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '3.85');
INSERT INTO public.europe_data_import VALUES (1236, '27/07/2020', '2020-30', '1', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '15.39');
INSERT INTO public.europe_data_import VALUES (1237, '20/07/2020', '2020-29', '3', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '11.55');
INSERT INTO public.europe_data_import VALUES (1238, '13/07/2020', '2020-28', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1239, '06/07/2020', '2020-27', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1240, '29/06/2020', '2020-26', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1241, '22/06/2020', '2020-25', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1242, '15/06/2020', '2020-24', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1243, '08/06/2020', '2020-23', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1244, '01/06/2020', '2020-22', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '3.85');
INSERT INTO public.europe_data_import VALUES (1245, '25/05/2020', '2020-21', '1', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '3.85');
INSERT INTO public.europe_data_import VALUES (1246, '18/05/2020', '2020-20', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1247, '11/05/2020', '2020-19', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1248, '04/05/2020', '2020-18', '0', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '3.85');
INSERT INTO public.europe_data_import VALUES (1249, '27/04/2020', '2020-17', '1', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '11.55');
INSERT INTO public.europe_data_import VALUES (1250, '20/04/2020', '2020-16', '2', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '11.55');
INSERT INTO public.europe_data_import VALUES (1251, '13/04/2020', '2020-15', '1', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '11.55');
INSERT INTO public.europe_data_import VALUES (1252, '06/04/2020', '2020-14', '2', '0', '25983', 'Bonaire, Saint Eustatius and Saba', 'BQ', 'BES', 'America', '');
INSERT INTO public.europe_data_import VALUES (1253, '01/02/2021', '2021-04', '2056', '131', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '124.69');
INSERT INTO public.europe_data_import VALUES (1254, '25/01/2021', '2021-03', '2060', '107', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '132.84');
INSERT INTO public.europe_data_import VALUES (1255, '18/01/2021', '2021-02', '2325', '128', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '164.74');
INSERT INTO public.europe_data_import VALUES (1256, '11/01/2021', '2021-01', '3113', '227', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '183.79');
INSERT INTO public.europe_data_import VALUES (1257, '04/01/2021', '2020-53', '2954', '178', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '215.72');
INSERT INTO public.europe_data_import VALUES (1258, '28/12/2020', '2020-52', '4167', '328', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '259.74');
INSERT INTO public.europe_data_import VALUES (1259, '21/12/2020', '2020-51', '4407', '289', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '333.75');
INSERT INTO public.europe_data_import VALUES (1260, '14/12/2020', '2020-50', '6610', '384', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '416.33');
INSERT INTO public.europe_data_import VALUES (1261, '07/12/2020', '2020-49', '7133', '332', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '439.26');
INSERT INTO public.europe_data_import VALUES (1262, '30/11/2020', '2020-48', '7367', '344', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '499.06');
INSERT INTO public.europe_data_import VALUES (1263, '23/11/2020', '2020-47', '9107', '419', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '532.69');
INSERT INTO public.europe_data_import VALUES (1264, '16/11/2020', '2020-46', '8477', '347', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '587.55');
INSERT INTO public.europe_data_import VALUES (1265, '09/11/2020', '2020-45', '10918', '262', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '652.2');
INSERT INTO public.europe_data_import VALUES (1266, '02/11/2020', '2020-44', '10611', '162', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '526.66');
INSERT INTO public.europe_data_import VALUES (1267, '26/10/2020', '2020-43', '6774', '102', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '310.48');
INSERT INTO public.europe_data_import VALUES (1268, '19/10/2020', '2020-42', '3475', '63', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '186.16');
INSERT INTO public.europe_data_import VALUES (1269, '12/10/2020', '2020-41', '2670', '50', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '112.94');
INSERT INTO public.europe_data_import VALUES (1270, '05/10/2020', '2020-40', '1058', '61', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '77.28');
INSERT INTO public.europe_data_import VALUES (1271, '28/09/2020', '2020-39', '1493', '53', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '104.67');
INSERT INTO public.europe_data_import VALUES (1272, '21/09/2020', '2020-38', '1962', '68', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '129.72');
INSERT INTO public.europe_data_import VALUES (1273, '14/09/2020', '2020-37', '2320', '50', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '111.27');
INSERT INTO public.europe_data_import VALUES (1274, '07/09/2020', '2020-36', '1353', '47', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '98.21');
INSERT INTO public.europe_data_import VALUES (1275, '31/08/2020', '2020-35', '1889', '63', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '128.87');
INSERT INTO public.europe_data_import VALUES (1276, '24/08/2020', '2020-34', '2365', '60', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '108.3');
INSERT INTO public.europe_data_import VALUES (1277, '17/08/2020', '2020-33', '1210', '67', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '103.82');
INSERT INTO public.europe_data_import VALUES (1278, '10/08/2020', '2020-32', '2217', '59', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '128.93');
INSERT INTO public.europe_data_import VALUES (1279, '03/08/2020', '2020-31', '2039', '60', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '110.75');
INSERT INTO public.europe_data_import VALUES (1280, '27/07/2020', '2020-30', '1617', '33', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '96.49');
INSERT INTO public.europe_data_import VALUES (1281, '20/07/2020', '2020-29', '1568', '30', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '92.67');
INSERT INTO public.europe_data_import VALUES (1282, '13/07/2020', '2020-28', '1491', '27', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '80.85');
INSERT INTO public.europe_data_import VALUES (1283, '06/07/2020', '2020-27', '1178', '11', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '59.44');
INSERT INTO public.europe_data_import VALUES (1284, '29/06/2020', '2020-26', '784', '13', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '36.78');
INSERT INTO public.europe_data_import VALUES (1285, '22/06/2020', '2020-25', '430', '6', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '22.96');
INSERT INTO public.europe_data_import VALUES (1286, '15/06/2020', '2020-24', '328', '4', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '14.9');
INSERT INTO public.europe_data_import VALUES (1287, '08/06/2020', '2020-23', '164', '7', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '8.27');
INSERT INTO public.europe_data_import VALUES (1288, '01/06/2020', '2020-22', '109', '9', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '6.66');
INSERT INTO public.europe_data_import VALUES (1289, '25/05/2020', '2020-21', '111', '11', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '8.57');
INSERT INTO public.europe_data_import VALUES (1290, '18/05/2020', '2020-20', '172', '25', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '13.09');
INSERT INTO public.europe_data_import VALUES (1291, '11/05/2020', '2020-19', '260', '31', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '18.21');
INSERT INTO public.europe_data_import VALUES (1292, '04/05/2020', '2020-18', '341', '18', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '17.81');
INSERT INTO public.europe_data_import VALUES (1293, '27/04/2020', '2020-17', '247', '12', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '15.42');
INSERT INTO public.europe_data_import VALUES (1294, '20/04/2020', '2020-16', '262', '8', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '18.36');
INSERT INTO public.europe_data_import VALUES (1295, '13/04/2020', '2020-15', '344', '14', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '20.72');
INSERT INTO public.europe_data_import VALUES (1296, '06/04/2020', '2020-14', '340', '18', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '16.3');
INSERT INTO public.europe_data_import VALUES (1297, '30/03/2020', '2020-13', '198', '5', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '9.24');
INSERT INTO public.europe_data_import VALUES (1298, '23/03/2020', '2020-12', '107', '1', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '3.79');
INSERT INTO public.europe_data_import VALUES (1299, '16/03/2020', '2020-11', '18', '0', '3300998', 'Bosnia_and_Herzegovina', 'BA', 'BIH', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (1300, '01/02/2021', '2021-04', '1639', '29', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '170.51');
INSERT INTO public.europe_data_import VALUES (1301, '25/01/2021', '2021-03', '2289', '34', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '156.44');
INSERT INTO public.europe_data_import VALUES (1302, '18/01/2021', '2021-02', '1315', '23', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '112.86');
INSERT INTO public.europe_data_import VALUES (1303, '11/01/2021', '2021-01', '1285', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '87.9');
INSERT INTO public.europe_data_import VALUES (1304, '04/01/2021', '2020-53', '740', '5', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '76.01');
INSERT INTO public.europe_data_import VALUES (1305, '28/12/2020', '2020-52', '1011', '2', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '50.01');
INSERT INTO public.europe_data_import VALUES (1306, '21/12/2020', '2020-51', '141', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '64.37');
INSERT INTO public.europe_data_import VALUES (1307, '14/12/2020', '2020-50', '1342', '4', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '125.06');
INSERT INTO public.europe_data_import VALUES (1308, '07/12/2020', '2020-49', '1539', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '84.08');
INSERT INTO public.europe_data_import VALUES (1309, '30/11/2020', '2020-48', '398', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '76.7');
INSERT INTO public.europe_data_import VALUES (1310, '23/11/2020', '2020-47', '1369', '4', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '76.36');
INSERT INTO public.europe_data_import VALUES (1311, '16/11/2020', '2020-46', '390', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '68.72');
INSERT INTO public.europe_data_import VALUES (1312, '09/11/2020', '2020-45', '1193', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '83.0');
INSERT INTO public.europe_data_import VALUES (1313, '02/11/2020', '2020-44', '719', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '60.77');
INSERT INTO public.europe_data_import VALUES (1314, '26/10/2020', '2020-43', '681', '1', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '60.9');
INSERT INTO public.europe_data_import VALUES (1315, '19/10/2020', '2020-42', '722', '2', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '89.86');
INSERT INTO public.europe_data_import VALUES (1316, '12/10/2020', '2020-41', '1348', '2', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '69.41');
INSERT INTO public.europe_data_import VALUES (1317, '05/10/2020', '2020-40', '251', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '26.26');
INSERT INTO public.europe_data_import VALUES (1318, '28/09/2020', '2020-39', '354', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '29.04');
INSERT INTO public.europe_data_import VALUES (1319, '21/09/2020', '2020-38', '315', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '24.53');
INSERT INTO public.europe_data_import VALUES (1320, '14/09/2020', '2020-37', '250', '2', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '26.87');
INSERT INTO public.europe_data_import VALUES (1321, '07/09/2020', '2020-36', '369', '2', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '30.13');
INSERT INTO public.europe_data_import VALUES (1322, '31/08/2020', '2020-35', '325', '3', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '18.19');
INSERT INTO public.europe_data_import VALUES (1323, '24/08/2020', '2020-34', '94', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '17.32');
INSERT INTO public.europe_data_import VALUES (1324, '17/08/2020', '2020-33', '305', '1', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '17.8');
INSERT INTO public.europe_data_import VALUES (1325, '10/08/2020', '2020-32', '105', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '9.68');
INSERT INTO public.europe_data_import VALUES (1326, '03/08/2020', '2020-31', '118', '1', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '12.24');
INSERT INTO public.europe_data_import VALUES (1327, '27/07/2020', '2020-30', '164', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '12.46');
INSERT INTO public.europe_data_import VALUES (1328, '20/07/2020', '2020-29', '123', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '10.72');
INSERT INTO public.europe_data_import VALUES (1329, '13/07/2020', '2020-28', '124', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '11.89');
INSERT INTO public.europe_data_import VALUES (1330, '06/07/2020', '2020-27', '150', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '8.07');
INSERT INTO public.europe_data_import VALUES (1331, '29/06/2020', '2020-26', '36', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '2.82');
INSERT INTO public.europe_data_import VALUES (1332, '22/06/2020', '2020-25', '29', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '2.13');
INSERT INTO public.europe_data_import VALUES (1333, '15/06/2020', '2020-24', '20', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (1334, '08/06/2020', '2020-23', '2', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.22');
INSERT INTO public.europe_data_import VALUES (1335, '01/06/2020', '2020-22', '3', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.56');
INSERT INTO public.europe_data_import VALUES (1336, '25/05/2020', '2020-21', '10', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (1337, '18/05/2020', '2020-20', '2', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (1338, '11/05/2020', '2020-19', '0', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (1339, '04/05/2020', '2020-18', '1', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (1340, '27/04/2020', '2020-17', '2', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.39');
INSERT INTO public.europe_data_import VALUES (1341, '20/04/2020', '2020-16', '7', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.61');
INSERT INTO public.europe_data_import VALUES (1342, '13/04/2020', '2020-15', '7', '0', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '0.56');
INSERT INTO public.europe_data_import VALUES (1343, '06/04/2020', '2020-14', '6', '1', '2303703', 'Botswana', 'BW', 'BWA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1344, '01/02/2021', '2021-04', '357929', '7435', '211049519', 'Brazil', 'BR', 'BRA', 'America', '339.99');
INSERT INTO public.europe_data_import VALUES (1345, '25/01/2021', '2021-03', '359623', '7365', '211049519', 'Brazil', 'BR', 'BRA', 'America', '350.52');
INSERT INTO public.europe_data_import VALUES (1346, '18/01/2021', '2021-02', '380158', '6719', '211049519', 'Brazil', 'BR', 'BRA', 'America', '368.65');
INSERT INTO public.europe_data_import VALUES (1347, '11/01/2021', '2021-01', '397866', '7562', '211049519', 'Brazil', 'BR', 'BRA', 'America', '306.72');
INSERT INTO public.europe_data_import VALUES (1348, '04/01/2021', '2020-53', '249461', '4879', '211049519', 'Brazil', 'BR', 'BRA', 'America', '222.76');
INSERT INTO public.europe_data_import VALUES (1349, '28/12/2020', '2020-52', '220666', '3848', '211049519', 'Brazil', 'BR', 'BRA', 'America', '275.92');
INSERT INTO public.europe_data_import VALUES (1350, '21/12/2020', '2020-51', '361667', '5889', '211049519', 'Brazil', 'BR', 'BRA', 'America', '312.76');
INSERT INTO public.europe_data_import VALUES (1351, '14/12/2020', '2020-50', '298412', '4461', '211049519', 'Brazil', 'BR', 'BRA', 'America', '278.23');
INSERT INTO public.europe_data_import VALUES (1352, '07/12/2020', '2020-49', '288800', '4108', '211049519', 'Brazil', 'BR', 'BRA', 'America', '252.14');
INSERT INTO public.europe_data_import VALUES (1353, '30/11/2020', '2020-48', '243339', '3650', '211049519', 'Brazil', 'BR', 'BRA', 'America', '214.0');
INSERT INTO public.europe_data_import VALUES (1354, '23/11/2020', '2020-47', '208308', '3385', '211049519', 'Brazil', 'BR', 'BRA', 'America', '192.98');
INSERT INTO public.europe_data_import VALUES (1355, '16/11/2020', '2020-46', '198978', '3401', '211049519', 'Brazil', 'BR', 'BRA', 'America', '150.39');
INSERT INTO public.europe_data_import VALUES (1356, '09/11/2020', '2020-45', '118410', '2323', '211049519', 'Brazil', 'BR', 'BRA', 'America', '127.93');
INSERT INTO public.europe_data_import VALUES (1357, '02/11/2020', '2020-44', '151577', '2940', '211049519', 'Brazil', 'BR', 'BRA', 'America', '147.06');
INSERT INTO public.europe_data_import VALUES (1358, '26/10/2020', '2020-43', '158784', '3229', '211049519', 'Brazil', 'BR', 'BRA', 'America', '141.74');
INSERT INTO public.europe_data_import VALUES (1359, '19/10/2020', '2020-42', '140362', '3417', '211049519', 'Brazil', 'BR', 'BRA', 'America', '151.65');
INSERT INTO public.europe_data_import VALUES (1360, '12/10/2020', '2020-41', '179693', '4136', '211049519', 'Brazil', 'BR', 'BRA', 'America', '171.84');
INSERT INTO public.europe_data_import VALUES (1361, '05/10/2020', '2020-40', '182980', '4611', '211049519', 'Brazil', 'BR', 'BRA', 'America', '175.63');
INSERT INTO public.europe_data_import VALUES (1362, '28/09/2020', '2020-39', '187680', '4846', '211049519', 'Brazil', 'BR', 'BRA', 'America', '190.41');
INSERT INTO public.europe_data_import VALUES (1363, '21/09/2020', '2020-38', '214174', '5270', '211049519', 'Brazil', 'BR', 'BRA', 'America', '192.9');
INSERT INTO public.europe_data_import VALUES (1364, '14/09/2020', '2020-37', '192934', '4975', '211049519', 'Brazil', 'BR', 'BRA', 'America', '221.82');
INSERT INTO public.europe_data_import VALUES (1365, '07/09/2020', '2020-36', '275210', '5822', '211049519', 'Brazil', 'BR', 'BRA', 'America', '251.95');
INSERT INTO public.europe_data_import VALUES (1366, '31/08/2020', '2020-35', '256528', '6084', '211049519', 'Brazil', 'BR', 'BRA', 'America', '247.39');
INSERT INTO public.europe_data_import VALUES (1367, '24/08/2020', '2020-34', '265586', '6892', '211049519', 'Brazil', 'BR', 'BRA', 'America', '270.25');
INSERT INTO public.europe_data_import VALUES (1368, '17/08/2020', '2020-33', '304775', '6803', '211049519', 'Brazil', 'BR', 'BRA', 'America', '287.38');
INSERT INTO public.europe_data_import VALUES (1369, '10/08/2020', '2020-32', '301745', '6945', '211049519', 'Brazil', 'BR', 'BRA', 'America', '292.03');
INSERT INTO public.europe_data_import VALUES (1370, '03/08/2020', '2020-31', '314586', '7100', '211049519', 'Brazil', 'BR', 'BRA', 'America', '301.01');
INSERT INTO public.europe_data_import VALUES (1371, '27/07/2020', '2020-30', '320702', '7516', '211049519', 'Brazil', 'BR', 'BRA', 'America', '262.69');
INSERT INTO public.europe_data_import VALUES (1372, '20/07/2020', '2020-29', '233708', '7388', '211049519', 'Brazil', 'BR', 'BRA', 'America', '234.7');
INSERT INTO public.europe_data_import VALUES (1373, '13/07/2020', '2020-28', '261626', '7233', '211049519', 'Brazil', 'BR', 'BRA', 'America', '246.64');
INSERT INTO public.europe_data_import VALUES (1374, '06/07/2020', '2020-27', '258912', '7245', '211049519', 'Brazil', 'BR', 'BRA', 'America', '245.45');
INSERT INTO public.europe_data_import VALUES (1375, '29/06/2020', '2020-26', '259105', '7005', '211049519', 'Brazil', 'BR', 'BRA', 'America', '225.79');
INSERT INTO public.europe_data_import VALUES (1376, '22/06/2020', '2020-25', '217414', '7285', '211049519', 'Brazil', 'BR', 'BRA', 'America', '186.34');
INSERT INTO public.europe_data_import VALUES (1377, '15/06/2020', '2020-24', '175866', '6877', '211049519', 'Brazil', 'BR', 'BRA', 'America', '167.15');
INSERT INTO public.europe_data_import VALUES (1378, '08/06/2020', '2020-23', '176909', '7141', '211049519', 'Brazil', 'BR', 'BRA', 'America', '155.67');
INSERT INTO public.europe_data_import VALUES (1379, '01/06/2020', '2020-22', '151638', '6648', '211049519', 'Brazil', 'BR', 'BRA', 'America', '129.72');
INSERT INTO public.europe_data_import VALUES (1380, '25/05/2020', '2020-21', '122131', '6548', '211049519', 'Brazil', 'BR', 'BRA', 'America', '95.01');
INSERT INTO public.europe_data_import VALUES (1381, '18/05/2020', '2020-20', '78381', '4995', '211049519', 'Brazil', 'BR', 'BRA', 'America', '66.3');
INSERT INTO public.europe_data_import VALUES (1382, '11/05/2020', '2020-19', '61552', '4098', '211049519', 'Brazil', 'BR', 'BRA', 'America', '47.77');
INSERT INTO public.europe_data_import VALUES (1383, '04/05/2020', '2020-18', '39259', '2820', '211049519', 'Brazil', 'BR', 'BRA', 'America', '29.61');
INSERT INTO public.europe_data_import VALUES (1384, '27/04/2020', '2020-17', '23234', '1743', '211049519', 'Brazil', 'BR', 'BRA', 'America', '18.82');
INSERT INTO public.europe_data_import VALUES (1385, '20/04/2020', '2020-16', '16485', '1239', '211049519', 'Brazil', 'BR', 'BRA', 'America', '13.04');
INSERT INTO public.europe_data_import VALUES (1386, '13/04/2020', '2020-15', '11039', '737', '211049519', 'Brazil', 'BR', 'BRA', 'America', '8.49');
INSERT INTO public.europe_data_import VALUES (1387, '06/04/2020', '2020-14', '6874', '350', '211049519', 'Brazil', 'BR', 'BRA', 'America', '4.54');
INSERT INTO public.europe_data_import VALUES (1388, '30/03/2020', '2020-13', '2710', '111', '211049519', 'Brazil', 'BR', 'BRA', 'America', '1.92');
INSERT INTO public.europe_data_import VALUES (1389, '23/03/2020', '2020-12', '1346', '25', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0.72');
INSERT INTO public.europe_data_import VALUES (1390, '16/03/2020', '2020-11', '175', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0.09');
INSERT INTO public.europe_data_import VALUES (1391, '09/03/2020', '2020-10', '23', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (1392, '02/03/2020', '2020-09', '2', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (1393, '24/02/2020', '2020-08', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1394, '17/02/2020', '2020-07', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1395, '10/02/2020', '2020-06', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1396, '03/02/2020', '2020-05', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1397, '27/01/2020', '2020-04', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1398, '20/01/2020', '2020-03', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1399, '13/01/2020', '2020-02', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1400, '06/01/2020', '2020-01', '0', '0', '211049519', 'Brazil', 'BR', 'BRA', 'America', '');
INSERT INTO public.europe_data_import VALUES (1401, '01/02/2021', '2021-04', '4', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '66.59');
INSERT INTO public.europe_data_import VALUES (1402, '25/01/2021', '2021-03', '16', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '133.19');
INSERT INTO public.europe_data_import VALUES (1403, '18/01/2021', '2021-02', '24', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '79.91');
INSERT INTO public.europe_data_import VALUES (1404, '11/01/2021', '2021-01', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '13.32');
INSERT INTO public.europe_data_import VALUES (1405, '04/01/2021', '2020-53', '4', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '36.63');
INSERT INTO public.europe_data_import VALUES (1406, '28/12/2020', '2020-52', '7', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '43.29');
INSERT INTO public.europe_data_import VALUES (1407, '21/12/2020', '2020-51', '6', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '43.29');
INSERT INTO public.europe_data_import VALUES (1408, '14/12/2020', '2020-50', '7', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '23.31');
INSERT INTO public.europe_data_import VALUES (1409, '07/12/2020', '2020-49', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1410, '30/11/2020', '2020-48', '1', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1411, '23/11/2020', '2020-47', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1412, '16/11/2020', '2020-46', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1413, '09/11/2020', '2020-45', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1414, '02/11/2020', '2020-44', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1415, '26/10/2020', '2020-43', '1', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1416, '19/10/2020', '2020-42', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1417, '12/10/2020', '2020-41', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1418, '05/10/2020', '2020-40', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1419, '28/09/2020', '2020-39', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '16.65');
INSERT INTO public.europe_data_import VALUES (1420, '21/09/2020', '2020-38', '5', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '26.64');
INSERT INTO public.europe_data_import VALUES (1421, '14/09/2020', '2020-37', '3', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '96.56');
INSERT INTO public.europe_data_import VALUES (1422, '07/09/2020', '2020-36', '26', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '139.85');
INSERT INTO public.europe_data_import VALUES (1423, '31/08/2020', '2020-35', '16', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '93.23');
INSERT INTO public.europe_data_import VALUES (1424, '24/08/2020', '2020-34', '12', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '39.96');
INSERT INTO public.europe_data_import VALUES (1425, '17/08/2020', '2020-33', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1426, '10/08/2020', '2020-32', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1427, '03/08/2020', '2020-31', '1', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1428, '27/07/2020', '2020-30', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1429, '20/07/2020', '2020-29', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1430, '13/07/2020', '2020-28', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1431, '06/07/2020', '2020-27', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1432, '29/06/2020', '2020-26', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1433, '22/06/2020', '2020-25', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1434, '15/06/2020', '2020-24', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1435, '08/06/2020', '2020-23', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1436, '01/06/2020', '2020-22', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1437, '25/05/2020', '2020-21', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1438, '18/05/2020', '2020-20', '1', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '6.66');
INSERT INTO public.europe_data_import VALUES (1439, '11/05/2020', '2020-19', '1', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1440, '04/05/2020', '2020-18', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '6.66');
INSERT INTO public.europe_data_import VALUES (1441, '27/04/2020', '2020-17', '2', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '9.99');
INSERT INTO public.europe_data_import VALUES (1442, '20/04/2020', '2020-16', '1', '1', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1443, '13/04/2020', '2020-15', '0', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '3.33');
INSERT INTO public.europe_data_import VALUES (1444, '06/04/2020', '2020-14', '1', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '9.99');
INSERT INTO public.europe_data_import VALUES (1445, '30/03/2020', '2020-13', '2', '0', '30033', 'British_Virgin_Islands', 'VG', 'VGB', 'America', '');
INSERT INTO public.europe_data_import VALUES (1446, '01/02/2021', '2021-04', '5', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '1.38');
INSERT INTO public.europe_data_import VALUES (1447, '25/01/2021', '2021-03', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1448, '18/01/2021', '2021-02', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1449, '11/01/2021', '2021-01', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '4.85');
INSERT INTO public.europe_data_import VALUES (1450, '04/01/2021', '2020-53', '20', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '4.62');
INSERT INTO public.europe_data_import VALUES (1451, '28/12/2020', '2020-52', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1452, '21/12/2020', '2020-51', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1453, '14/12/2020', '2020-50', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1454, '07/12/2020', '2020-49', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (1455, '30/11/2020', '2020-48', '2', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1456, '23/11/2020', '2020-47', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1457, '16/11/2020', '2020-46', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1458, '09/11/2020', '2020-45', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1459, '02/11/2020', '2020-44', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1460, '26/10/2020', '2020-43', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1461, '19/10/2020', '2020-42', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1462, '12/10/2020', '2020-41', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1463, '05/10/2020', '2020-40', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1464, '28/09/2020', '2020-39', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1465, '21/09/2020', '2020-38', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1466, '14/09/2020', '2020-37', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1467, '07/09/2020', '2020-36', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1468, '31/08/2020', '2020-35', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1469, '24/08/2020', '2020-34', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1470, '17/08/2020', '2020-33', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1471, '10/08/2020', '2020-32', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (1472, '03/08/2020', '2020-31', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1473, '27/07/2020', '2020-30', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1474, '20/07/2020', '2020-29', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1475, '13/07/2020', '2020-28', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1476, '06/07/2020', '2020-27', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1477, '29/06/2020', '2020-26', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1478, '22/06/2020', '2020-25', '0', '1', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1479, '15/06/2020', '2020-24', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1480, '08/06/2020', '2020-23', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1481, '01/06/2020', '2020-22', '0', '1', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1482, '25/05/2020', '2020-21', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1483, '18/05/2020', '2020-20', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (1484, '11/05/2020', '2020-19', '3', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (1485, '04/05/2020', '2020-18', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1486, '27/04/2020', '2020-17', '0', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (1487, '20/04/2020', '2020-16', '2', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (1488, '13/04/2020', '2020-15', '1', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '2.31');
INSERT INTO public.europe_data_import VALUES (1489, '06/04/2020', '2020-14', '9', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '10.85');
INSERT INTO public.europe_data_import VALUES (1490, '30/03/2020', '2020-13', '38', '1', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '17.54');
INSERT INTO public.europe_data_import VALUES (1491, '23/03/2020', '2020-12', '38', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '20.31');
INSERT INTO public.europe_data_import VALUES (1492, '16/03/2020', '2020-11', '50', '0', '433296', 'Brunei_Darussalam', 'BN', 'BRN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (1493, '01/02/2021', '2021-04', '3931', '225', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '99.07');
INSERT INTO public.europe_data_import VALUES (1494, '25/01/2021', '2021-03', '3004', '337', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '90.09');
INSERT INTO public.europe_data_import VALUES (1495, '18/01/2021', '2021-02', '3302', '357', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '125.17');
INSERT INTO public.europe_data_import VALUES (1496, '11/01/2021', '2021-01', '5460', '448', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '154.21');
INSERT INTO public.europe_data_import VALUES (1497, '04/01/2021', '2020-53', '5335', '514', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '169.37');
INSERT INTO public.europe_data_import VALUES (1498, '28/12/2020', '2020-52', '6521', '555', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '260.96');
INSERT INTO public.europe_data_import VALUES (1499, '21/12/2020', '2020-51', '11746', '921', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '425.34');
INSERT INTO public.europe_data_import VALUES (1500, '14/12/2020', '2020-50', '18028', '891', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '528.04');
INSERT INTO public.europe_data_import VALUES (1501, '07/12/2020', '2020-49', '18935', '983', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '565.73');
INSERT INTO public.europe_data_import VALUES (1502, '30/11/2020', '2020-48', '20666', '934', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '631.93');
INSERT INTO public.europe_data_import VALUES (1503, '23/11/2020', '2020-47', '23569', '750', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '666.57');
INSERT INTO public.europe_data_import VALUES (1504, '16/11/2020', '2020-46', '23091', '465', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '631.17');
INSERT INTO public.europe_data_import VALUES (1505, '09/11/2020', '2020-45', '21091', '367', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '532.44');
INSERT INTO public.europe_data_import VALUES (1506, '02/11/2020', '2020-44', '16180', '204', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '350.94');
INSERT INTO public.europe_data_import VALUES (1507, '26/10/2020', '2020-43', '8386', '108', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '192.67');
INSERT INTO public.europe_data_import VALUES (1508, '19/10/2020', '2020-42', '5101', '94', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '113.09');
INSERT INTO public.europe_data_import VALUES (1509, '12/10/2020', '2020-41', '2815', '48', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '62.1');
INSERT INTO public.europe_data_import VALUES (1510, '05/10/2020', '2020-40', '1532', '48', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '38.91');
INSERT INTO public.europe_data_import VALUES (1511, '28/09/2020', '2020-39', '1192', '35', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '30.53');
INSERT INTO public.europe_data_import VALUES (1512, '21/09/2020', '2020-38', '945', '41', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '25.9');
INSERT INTO public.europe_data_import VALUES (1513, '14/09/2020', '2020-37', '868', '49', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '24.69');
INSERT INTO public.europe_data_import VALUES (1514, '07/09/2020', '2020-36', '860', '58', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '25.19');
INSERT INTO public.europe_data_import VALUES (1515, '31/08/2020', '2020-35', '903', '68', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '26.07');
INSERT INTO public.europe_data_import VALUES (1516, '24/08/2020', '2020-34', '922', '47', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '27.01');
INSERT INTO public.europe_data_import VALUES (1517, '17/08/2020', '2020-33', '969', '51', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '34.43');
INSERT INTO public.europe_data_import VALUES (1518, '10/08/2020', '2020-32', '1441', '59', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '42.41');
INSERT INTO public.europe_data_import VALUES (1519, '03/08/2020', '2020-31', '1528', '48', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '46.03');
INSERT INTO public.europe_data_import VALUES (1520, '27/07/2020', '2020-30', '1694', '40', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '45.36');
INSERT INTO public.europe_data_import VALUES (1521, '20/07/2020', '2020-29', '1481', '32', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '42.76');
INSERT INTO public.europe_data_import VALUES (1522, '13/07/2020', '2020-28', '1512', '22', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '36.59');
INSERT INTO public.europe_data_import VALUES (1523, '06/07/2020', '2020-27', '1049', '27', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '26.21');
INSERT INTO public.europe_data_import VALUES (1524, '29/06/2020', '2020-26', '786', '20', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '20.01');
INSERT INTO public.europe_data_import VALUES (1525, '22/06/2020', '2020-25', '615', '25', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '16.83');
INSERT INTO public.europe_data_import VALUES (1526, '15/06/2020', '2020-24', '563', '14', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '11.1');
INSERT INTO public.europe_data_import VALUES (1527, '08/06/2020', '2020-23', '214', '20', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '4.2');
INSERT INTO public.europe_data_import VALUES (1528, '01/06/2020', '2020-22', '80', '10', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '3.97');
INSERT INTO public.europe_data_import VALUES (1529, '25/05/2020', '2020-21', '198', '20', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '6.69');
INSERT INTO public.europe_data_import VALUES (1530, '18/05/2020', '2020-20', '270', '19', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '8.81');
INSERT INTO public.europe_data_import VALUES (1531, '11/05/2020', '2020-19', '347', '18', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '9.5');
INSERT INTO public.europe_data_import VALUES (1532, '04/05/2020', '2020-18', '318', '17', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '10.04');
INSERT INTO public.europe_data_import VALUES (1533, '27/04/2020', '2020-17', '385', '13', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '8.93');
INSERT INTO public.europe_data_import VALUES (1534, '20/04/2020', '2020-16', '240', '14', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '5.49');
INSERT INTO public.europe_data_import VALUES (1535, '13/04/2020', '2020-15', '144', '9', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '4.7');
INSERT INTO public.europe_data_import VALUES (1536, '06/04/2020', '2020-14', '185', '12', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '4.94');
INSERT INTO public.europe_data_import VALUES (1537, '30/03/2020', '2020-13', '161', '5', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '4.21');
INSERT INTO public.europe_data_import VALUES (1538, '23/03/2020', '2020-12', '134', '1', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '2.59');
INSERT INTO public.europe_data_import VALUES (1539, '16/03/2020', '2020-11', '47', '2', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '0.73');
INSERT INTO public.europe_data_import VALUES (1540, '09/03/2020', '2020-10', '4', '0', '7000039', 'Bulgaria', 'BG', 'BGR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (1541, '01/02/2021', '2021-04', '665', '4', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '7.78');
INSERT INTO public.europe_data_import VALUES (1542, '25/01/2021', '2021-03', '915', '15', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '9.0');
INSERT INTO public.europe_data_import VALUES (1543, '18/01/2021', '2021-02', '913', '13', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '10.52');
INSERT INTO public.europe_data_import VALUES (1544, '11/01/2021', '2021-01', '1224', '3', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '9.5');
INSERT INTO public.europe_data_import VALUES (1545, '04/01/2021', '2020-53', '707', '8', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '9.31');
INSERT INTO public.europe_data_import VALUES (1546, '28/12/2020', '2020-52', '1184', '2', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '11.39');
INSERT INTO public.europe_data_import VALUES (1547, '21/12/2020', '2020-51', '1130', '5', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '9.59');
INSERT INTO public.europe_data_import VALUES (1548, '14/12/2020', '2020-50', '818', '3', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '5.78');
INSERT INTO public.europe_data_import VALUES (1549, '07/12/2020', '2020-49', '356', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '2.35');
INSERT INTO public.europe_data_import VALUES (1550, '30/11/2020', '2020-48', '121', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.06');
INSERT INTO public.europe_data_import VALUES (1551, '23/11/2020', '2020-47', '94', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.82');
INSERT INTO public.europe_data_import VALUES (1552, '16/11/2020', '2020-46', '72', '1', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (1553, '09/11/2020', '2020-45', '69', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.58');
INSERT INTO public.europe_data_import VALUES (1554, '02/11/2020', '2020-44', '49', '2', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.59');
INSERT INTO public.europe_data_import VALUES (1555, '26/10/2020', '2020-43', '70', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.84');
INSERT INTO public.europe_data_import VALUES (1556, '19/10/2020', '2020-42', '101', '2', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.05');
INSERT INTO public.europe_data_import VALUES (1557, '12/10/2020', '2020-41', '113', '4', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.34');
INSERT INTO public.europe_data_import VALUES (1558, '05/10/2020', '2020-40', '159', '3', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.58');
INSERT INTO public.europe_data_import VALUES (1559, '28/09/2020', '2020-39', '162', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.48');
INSERT INTO public.europe_data_import VALUES (1560, '21/09/2020', '2020-38', '139', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.94');
INSERT INTO public.europe_data_import VALUES (1561, '14/09/2020', '2020-37', '255', '1', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.67');
INSERT INTO public.europe_data_import VALUES (1562, '07/09/2020', '2020-36', '84', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.61');
INSERT INTO public.europe_data_import VALUES (1563, '31/08/2020', '2020-35', '40', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (1564, '24/08/2020', '2020-34', '61', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.61');
INSERT INTO public.europe_data_import VALUES (1565, '17/08/2020', '2020-33', '63', '1', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.58');
INSERT INTO public.europe_data_import VALUES (1566, '10/08/2020', '2020-32', '54', '1', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.51');
INSERT INTO public.europe_data_import VALUES (1567, '03/08/2020', '2020-31', '50', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (1568, '27/07/2020', '2020-30', '35', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (1569, '20/07/2020', '2020-29', '29', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.38');
INSERT INTO public.europe_data_import VALUES (1570, '13/07/2020', '2020-28', '49', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.38');
INSERT INTO public.europe_data_import VALUES (1571, '06/07/2020', '2020-27', '28', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (1572, '29/06/2020', '2020-26', '56', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (1573, '22/06/2020', '2020-25', '9', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (1574, '15/06/2020', '2020-24', '5', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (1575, '08/06/2020', '2020-23', '8', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (1576, '01/06/2020', '2020-22', '49', '1', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (1577, '25/05/2020', '2020-21', '36', '1', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (1578, '18/05/2020', '2020-20', '45', '2', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.66');
INSERT INTO public.europe_data_import VALUES (1579, '11/05/2020', '2020-19', '89', '4', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.59');
INSERT INTO public.europe_data_import VALUES (1580, '04/05/2020', '2020-18', '30', '3', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (1581, '27/04/2020', '2020-17', '56', '6', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.66');
INSERT INTO public.europe_data_import VALUES (1582, '20/04/2020', '2020-16', '79', '9', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.14');
INSERT INTO public.europe_data_import VALUES (1583, '13/04/2020', '2020-15', '152', '10', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.56');
INSERT INTO public.europe_data_import VALUES (1584, '06/04/2020', '2020-14', '165', '8', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '1.38');
INSERT INTO public.europe_data_import VALUES (1585, '30/03/2020', '2020-13', '116', '6', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.87');
INSERT INTO public.europe_data_import VALUES (1586, '23/03/2020', '2020-12', '61', '3', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (1587, '16/03/2020', '2020-11', '3', '0', '20321383', 'Burkina_Faso', 'BF', 'BFA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1588, '01/02/2021', '2021-04', '156', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '3.46');
INSERT INTO public.europe_data_import VALUES (1589, '25/01/2021', '2021-03', '243', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '3.99');
INSERT INTO public.europe_data_import VALUES (1590, '18/01/2021', '2021-02', '217', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '3.5');
INSERT INTO public.europe_data_import VALUES (1591, '11/01/2021', '2021-01', '186', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '1.82');
INSERT INTO public.europe_data_import VALUES (1592, '04/01/2021', '2020-53', '24', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (1593, '28/12/2020', '2020-52', '48', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (1594, '21/12/2020', '2020-51', '32', '1', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.58');
INSERT INTO public.europe_data_import VALUES (1595, '14/12/2020', '2020-50', '35', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (1596, '07/12/2020', '2020-49', '13', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (1597, '30/11/2020', '2020-48', '19', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.46');
INSERT INTO public.europe_data_import VALUES (1598, '23/11/2020', '2020-47', '34', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (1599, '16/11/2020', '2020-46', '14', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (1600, '09/11/2020', '2020-45', '25', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (1601, '02/11/2020', '2020-44', '33', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (1602, '26/10/2020', '2020-43', '14', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (1603, '19/10/2020', '2020-42', '18', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.25');
INSERT INTO public.europe_data_import VALUES (1604, '12/10/2020', '2020-41', '11', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (1605, '05/10/2020', '2020-40', '28', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (1606, '28/09/2020', '2020-39', '12', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (1607, '21/09/2020', '2020-38', '1', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (1608, '14/09/2020', '2020-37', '10', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (1609, '07/09/2020', '2020-36', '17', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.29');
INSERT INTO public.europe_data_import VALUES (1610, '31/08/2020', '2020-35', '16', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (1611, '24/08/2020', '2020-34', '16', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (1612, '17/08/2020', '2020-33', '5', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (1613, '10/08/2020', '2020-32', '13', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (1614, '03/08/2020', '2020-31', '34', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.74');
INSERT INTO public.europe_data_import VALUES (1615, '27/07/2020', '2020-30', '51', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (1616, '20/07/2020', '2020-29', '60', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (1617, '13/07/2020', '2020-28', '59', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (1618, '06/07/2020', '2020-27', '21', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (1619, '29/06/2020', '2020-26', '26', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.66');
INSERT INTO public.europe_data_import VALUES (1620, '22/06/2020', '2020-25', '50', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (1621, '15/06/2020', '2020-24', '11', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (1622, '08/06/2020', '2020-23', '20', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.36');
INSERT INTO public.europe_data_import VALUES (1623, '01/06/2020', '2020-22', '21', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (1624, '25/05/2020', '2020-21', '0', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (1625, '18/05/2020', '2020-20', '23', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (1626, '11/05/2020', '2020-19', '0', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (1627, '04/05/2020', '2020-18', '4', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (1628, '27/04/2020', '2020-17', '9', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (1629, '20/04/2020', '2020-16', '1', '1', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (1630, '13/04/2020', '2020-15', '2', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (1631, '06/04/2020', '2020-14', '3', '0', '11530577', 'Burundi', 'BI', 'BDI', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1632, '01/02/2021', '2021-04', '8', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (1633, '25/01/2021', '2021-03', '17', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.41');
INSERT INTO public.europe_data_import VALUES (1634, '18/01/2021', '2021-02', '50', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.36');
INSERT INTO public.europe_data_import VALUES (1635, '11/01/2021', '2021-01', '9', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (1636, '04/01/2021', '2020-53', '18', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (1637, '28/12/2020', '2020-52', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (1638, '21/12/2020', '2020-51', '4', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (1639, '14/12/2020', '2020-50', '11', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.22');
INSERT INTO public.europe_data_import VALUES (1640, '07/12/2020', '2020-49', '25', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.25');
INSERT INTO public.europe_data_import VALUES (1641, '30/11/2020', '2020-48', '17', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (1642, '23/11/2020', '2020-47', '4', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (1643, '16/11/2020', '2020-46', '5', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (1644, '09/11/2020', '2020-45', '6', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (1645, '02/11/2020', '2020-44', '4', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (1646, '26/10/2020', '2020-43', '4', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (1647, '19/10/2020', '2020-42', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (1648, '12/10/2020', '2020-41', '3', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (1649, '05/10/2020', '2020-40', '4', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (1650, '28/09/2020', '2020-39', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1651, '21/09/2020', '2020-38', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1652, '14/09/2020', '2020-37', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1653, '07/09/2020', '2020-36', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1654, '31/08/2020', '2020-35', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1655, '24/08/2020', '2020-34', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (1656, '17/08/2020', '2020-33', '22', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.2');
INSERT INTO public.europe_data_import VALUES (1657, '10/08/2020', '2020-32', '11', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (1658, '03/08/2020', '2020-31', '15', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.42');
INSERT INTO public.europe_data_import VALUES (1659, '27/07/2020', '2020-30', '54', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.42');
INSERT INTO public.europe_data_import VALUES (1660, '20/07/2020', '2020-29', '15', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.18');
INSERT INTO public.europe_data_import VALUES (1661, '13/07/2020', '2020-28', '15', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (1662, '06/07/2020', '2020-27', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (1663, '29/06/2020', '2020-26', '12', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (1664, '22/06/2020', '2020-25', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (1665, '15/06/2020', '2020-24', '2', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (1666, '08/06/2020', '2020-23', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1667, '01/06/2020', '2020-22', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (1668, '25/05/2020', '2020-21', '2', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1669, '18/05/2020', '2020-20', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1670, '11/05/2020', '2020-19', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1671, '04/05/2020', '2020-18', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1672, '27/04/2020', '2020-17', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1673, '20/04/2020', '2020-16', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (1674, '13/04/2020', '2020-15', '8', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (1675, '06/04/2020', '2020-14', '7', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (1676, '30/03/2020', '2020-13', '21', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.58');
INSERT INTO public.europe_data_import VALUES (1677, '23/03/2020', '2020-12', '74', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.51');
INSERT INTO public.europe_data_import VALUES (1678, '16/03/2020', '2020-11', '10', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (1679, '09/03/2020', '2020-10', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1680, '02/03/2020', '2020-09', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1681, '24/02/2020', '2020-08', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1682, '17/02/2020', '2020-07', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1683, '10/02/2020', '2020-06', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1684, '03/02/2020', '2020-05', '1', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (1685, '27/01/2020', '2020-04', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1686, '20/01/2020', '2020-03', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1687, '13/01/2020', '2020-02', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (1688, '06/01/2020', '2020-01', '0', '0', '16486542', 'Cambodia', 'KH', 'KHM', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (1689, '01/02/2021', '2021-04', '696', '12', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '8.9');
INSERT INTO public.europe_data_import VALUES (1690, '25/01/2021', '2021-03', '1607', '7', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '10.7');
INSERT INTO public.europe_data_import VALUES (1691, '18/01/2021', '2021-02', '1162', '7', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.49');
INSERT INTO public.europe_data_import VALUES (1692, '11/01/2021', '2021-01', '0', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.21');
INSERT INTO public.europe_data_import VALUES (1693, '04/01/2021', '2020-53', '571', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.86');
INSERT INTO public.europe_data_import VALUES (1694, '28/12/2020', '2020-52', '428', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.55');
INSERT INTO public.europe_data_import VALUES (1695, '21/12/2020', '2020-51', '490', '3', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.24');
INSERT INTO public.europe_data_import VALUES (1696, '14/12/2020', '2020-50', '607', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.8');
INSERT INTO public.europe_data_import VALUES (1697, '07/12/2020', '2020-49', '635', '6', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.73');
INSERT INTO public.europe_data_import VALUES (1698, '30/11/2020', '2020-48', '589', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '5.51');
INSERT INTO public.europe_data_import VALUES (1699, '23/11/2020', '2020-47', '836', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.28');
INSERT INTO public.europe_data_import VALUES (1700, '16/11/2020', '2020-46', '271', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.47');
INSERT INTO public.europe_data_import VALUES (1701, '09/11/2020', '2020-45', '628', '7', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.29');
INSERT INTO public.europe_data_import VALUES (1702, '02/11/2020', '2020-44', '223', '1', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (1703, '26/10/2020', '2020-43', '129', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '1.42');
INSERT INTO public.europe_data_import VALUES (1704, '19/10/2020', '2020-42', '238', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.0');
INSERT INTO public.europe_data_import VALUES (1705, '12/10/2020', '2020-41', '279', '3', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '1.81');
INSERT INTO public.europe_data_import VALUES (1706, '05/10/2020', '2020-40', '189', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '1.91');
INSERT INTO public.europe_data_import VALUES (1707, '28/09/2020', '2020-39', '304', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.2');
INSERT INTO public.europe_data_import VALUES (1708, '21/09/2020', '2020-38', '264', '1', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.2');
INSERT INTO public.europe_data_import VALUES (1709, '14/09/2020', '2020-37', '563', '1', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.96');
INSERT INTO public.europe_data_import VALUES (1710, '07/09/2020', '2020-36', '462', '3', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.25');
INSERT INTO public.europe_data_import VALUES (1711, '31/08/2020', '2020-35', '380', '3', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.6');
INSERT INTO public.europe_data_import VALUES (1712, '24/08/2020', '2020-34', '293', '7', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.78');
INSERT INTO public.europe_data_import VALUES (1713, '17/08/2020', '2020-33', '427', '6', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.69');
INSERT INTO public.europe_data_import VALUES (1714, '10/08/2020', '2020-32', '787', '8', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '5.16');
INSERT INTO public.europe_data_import VALUES (1715, '03/08/2020', '2020-31', '547', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.24');
INSERT INTO public.europe_data_import VALUES (1716, '27/07/2020', '2020-30', '551', '12', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '5.93');
INSERT INTO public.europe_data_import VALUES (1717, '20/07/2020', '2020-29', '984', '14', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '9.45');
INSERT INTO public.europe_data_import VALUES (1718, '13/07/2020', '2020-28', '1462', '31', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '9.97');
INSERT INTO public.europe_data_import VALUES (1719, '06/07/2020', '2020-27', '1119', '15', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '8.12');
INSERT INTO public.europe_data_import VALUES (1720, '29/06/2020', '2020-26', '982', '12', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '10.54');
INSERT INTO public.europe_data_import VALUES (1721, '22/06/2020', '2020-25', '1746', '25', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '14.31');
INSERT INTO public.europe_data_import VALUES (1722, '15/06/2020', '2020-24', '1956', '73', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '15.3');
INSERT INTO public.europe_data_import VALUES (1723, '08/06/2020', '2020-23', '2004', '12', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '11.66');
INSERT INTO public.europe_data_import VALUES (1724, '01/06/2020', '2020-22', '1014', '26', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '10.09');
INSERT INTO public.europe_data_import VALUES (1725, '25/05/2020', '2020-21', '1598', '25', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '8.93');
INSERT INTO public.europe_data_import VALUES (1726, '18/05/2020', '2020-20', '713', '26', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.7');
INSERT INTO public.europe_data_import VALUES (1727, '11/05/2020', '2020-19', '502', '50', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.7');
INSERT INTO public.europe_data_import VALUES (1728, '04/05/2020', '2020-18', '456', '8', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '4.1');
INSERT INTO public.europe_data_import VALUES (1729, '27/04/2020', '2020-17', '605', '14', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '3.1');
INSERT INTO public.europe_data_import VALUES (1730, '20/04/2020', '2020-16', '196', '30', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (1731, '13/04/2020', '2020-15', '170', '3', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.79');
INSERT INTO public.europe_data_import VALUES (1732, '06/04/2020', '2020-14', '551', '7', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '2.41');
INSERT INTO public.europe_data_import VALUES (1733, '30/03/2020', '2020-13', '72', '2', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (1734, '23/03/2020', '2020-12', '23', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (1735, '16/03/2020', '2020-11', '2', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (1736, '09/03/2020', '2020-10', '2', '0', '25876387', 'Cameroon', 'CM', 'CMR', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1737, '01/02/2021', '2021-04', '30578', '898', '37411038', 'Canada', 'CA', 'CAN', 'America', '183.15');
INSERT INTO public.europe_data_import VALUES (1738, '25/01/2021', '2021-03', '37939', '1118', '37411038', 'Canada', 'CA', 'CAN', 'America', '226.75');
INSERT INTO public.europe_data_import VALUES (1739, '18/01/2021', '2021-02', '46891', '1034', '37411038', 'Canada', 'CA', 'CAN', 'America', '303.14');
INSERT INTO public.europe_data_import VALUES (1740, '11/01/2021', '2021-01', '66518', '1221', '37411038', 'Canada', 'CA', 'CAN', 'America', '310.5');
INSERT INTO public.europe_data_import VALUES (1741, '04/01/2021', '2020-53', '49643', '901', '37411038', 'Canada', 'CA', 'CAN', 'America', '230.81');
INSERT INTO public.europe_data_import VALUES (1742, '28/12/2020', '2020-52', '36706', '632', '37411038', 'Canada', 'CA', 'CAN', 'America', '243.98');
INSERT INTO public.europe_data_import VALUES (1743, '21/12/2020', '2020-51', '54571', '901', '37411038', 'Canada', 'CA', 'CAN', 'America', '267.65');
INSERT INTO public.europe_data_import VALUES (1744, '14/12/2020', '2020-50', '45561', '766', '37411038', 'Canada', 'CA', 'CAN', 'America', '241.81');
INSERT INTO public.europe_data_import VALUES (1745, '07/12/2020', '2020-49', '44904', '633', '37411038', 'Canada', 'CA', 'CAN', 'America', '226.35');
INSERT INTO public.europe_data_import VALUES (1746, '30/11/2020', '2020-48', '39775', '577', '37411038', 'Canada', 'CA', 'CAN', 'America', '198.34');
INSERT INTO public.europe_data_import VALUES (1747, '23/11/2020', '2020-47', '34426', '502', '37411038', 'Canada', 'CA', 'CAN', 'America', '177.46');
INSERT INTO public.europe_data_import VALUES (1748, '16/11/2020', '2020-46', '31964', '431', '37411038', 'Canada', 'CA', 'CAN', 'America', '158.34');
INSERT INTO public.europe_data_import VALUES (1749, '09/11/2020', '2020-45', '27272', '343', '37411038', 'Canada', 'CA', 'CAN', 'America', '128.33');
INSERT INTO public.europe_data_import VALUES (1750, '02/11/2020', '2020-44', '20737', '233', '37411038', 'Canada', 'CA', 'CAN', 'America', '103.43');
INSERT INTO public.europe_data_import VALUES (1751, '26/10/2020', '2020-43', '17956', '186', '37411038', 'Canada', 'CA', 'CAN', 'America', '101.54');
INSERT INTO public.europe_data_import VALUES (1752, '19/10/2020', '2020-42', '20031', '175', '37411038', 'Canada', 'CA', 'CAN', 'America', '85.51');
INSERT INTO public.europe_data_import VALUES (1753, '12/10/2020', '2020-41', '11961', '104', '37411038', 'Canada', 'CA', 'CAN', 'America', '66.8');
INSERT INTO public.europe_data_import VALUES (1754, '05/10/2020', '2020-40', '13031', '213', '37411038', 'Canada', 'CA', 'CAN', 'America', '60.16');
INSERT INTO public.europe_data_import VALUES (1755, '28/09/2020', '2020-39', '9476', '51', '37411038', 'Canada', 'CA', 'CAN', 'America', '44.01');
INSERT INTO public.europe_data_import VALUES (1756, '21/09/2020', '2020-38', '6990', '46', '37411038', 'Canada', 'CA', 'CAN', 'America', '31.42');
INSERT INTO public.europe_data_import VALUES (1757, '14/09/2020', '2020-37', '4764', '26', '37411038', 'Canada', 'CA', 'CAN', 'America', '23.31');
INSERT INTO public.europe_data_import VALUES (1758, '07/09/2020', '2020-36', '3955', '28', '37411038', 'Canada', 'CA', 'CAN', 'America', '18.71');
INSERT INTO public.europe_data_import VALUES (1759, '31/08/2020', '2020-35', '3044', '44', '37411038', 'Canada', 'CA', 'CAN', 'America', '15.65');
INSERT INTO public.europe_data_import VALUES (1760, '24/08/2020', '2020-34', '2809', '47', '37411038', 'Canada', 'CA', 'CAN', 'America', '14.55');
INSERT INTO public.europe_data_import VALUES (1761, '17/08/2020', '2020-33', '2636', '45', '37411038', 'Canada', 'CA', 'CAN', 'America', '13.95');
INSERT INTO public.europe_data_import VALUES (1762, '10/08/2020', '2020-32', '2581', '36', '37411038', 'Canada', 'CA', 'CAN', 'America', '14.84');
INSERT INTO public.europe_data_import VALUES (1763, '03/08/2020', '2020-31', '2972', '55', '37411038', 'Canada', 'CA', 'CAN', 'America', '17.46');
INSERT INTO public.europe_data_import VALUES (1764, '27/07/2020', '2020-30', '3560', '38', '37411038', 'Canada', 'CA', 'CAN', 'America', '16.89');
INSERT INTO public.europe_data_import VALUES (1765, '20/07/2020', '2020-29', '2759', '69', '37411038', 'Canada', 'CA', 'CAN', 'America', '12.87');
INSERT INTO public.europe_data_import VALUES (1766, '13/07/2020', '2020-28', '2055', '99', '37411038', 'Canada', 'CA', 'CAN', 'America', '11.6');
INSERT INTO public.europe_data_import VALUES (1767, '06/07/2020', '2020-27', '2285', '162', '37411038', 'Canada', 'CA', 'CAN', 'America', '11.22');
INSERT INTO public.europe_data_import VALUES (1768, '29/06/2020', '2020-26', '1913', '92', '37411038', 'Canada', 'CA', 'CAN', 'America', '11.93');
INSERT INTO public.europe_data_import VALUES (1769, '22/06/2020', '2020-25', '2550', '284', '37411038', 'Canada', 'CA', 'CAN', 'America', '15.07');
INSERT INTO public.europe_data_import VALUES (1770, '15/06/2020', '2020-24', '3088', '346', '37411038', 'Canada', 'CA', 'CAN', 'America', '20.96');
INSERT INTO public.europe_data_import VALUES (1771, '08/06/2020', '2020-23', '4752', '505', '37411038', 'Canada', 'CA', 'CAN', 'America', '29.4');
INSERT INTO public.europe_data_import VALUES (1772, '01/06/2020', '2020-22', '6248', '871', '37411038', 'Canada', 'CA', 'CAN', 'America', '37.28');
INSERT INTO public.europe_data_import VALUES (1773, '25/05/2020', '2020-21', '7697', '642', '37411038', 'Canada', 'CA', 'CAN', 'America', '42.34');
INSERT INTO public.europe_data_import VALUES (1774, '18/05/2020', '2020-20', '8143', '911', '37411038', 'Canada', 'CA', 'CAN', 'America', '46.82');
INSERT INTO public.europe_data_import VALUES (1775, '11/05/2020', '2020-19', '9374', '1189', '37411038', 'Canada', 'CA', 'CAN', 'America', '58.71');
INSERT INTO public.europe_data_import VALUES (1776, '04/05/2020', '2020-18', '12590', '1122', '37411038', 'Canada', 'CA', 'CAN', 'America', '66.02');
INSERT INTO public.europe_data_import VALUES (1777, '27/04/2020', '2020-17', '12107', '980', '37411038', 'Canada', 'CA', 'CAN', 'America', '60.19');
INSERT INTO public.europe_data_import VALUES (1778, '20/04/2020', '2020-16', '10412', '863', '37411038', 'Canada', 'CA', 'CAN', 'America', '51.54');
INSERT INTO public.europe_data_import VALUES (1779, '13/04/2020', '2020-15', '8869', '437', '37411038', 'Canada', 'CA', 'CAN', 'America', '48.41');
INSERT INTO public.europe_data_import VALUES (1780, '06/04/2020', '2020-14', '9241', '219', '37411038', 'Canada', 'CA', 'CAN', 'America', '37.6');
INSERT INTO public.europe_data_import VALUES (1781, '30/03/2020', '2020-13', '4825', '41', '37411038', 'Canada', 'CA', 'CAN', 'America', '15.91');
INSERT INTO public.europe_data_import VALUES (1782, '23/03/2020', '2020-12', '1126', '19', '37411038', 'Canada', 'CA', 'CAN', 'America', '3.66');
INSERT INTO public.europe_data_import VALUES (1783, '16/03/2020', '2020-11', '242', '1', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.75');
INSERT INTO public.europe_data_import VALUES (1784, '09/03/2020', '2020-10', '38', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.14');
INSERT INTO public.europe_data_import VALUES (1785, '02/03/2020', '2020-09', '15', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.04');
INSERT INTO public.europe_data_import VALUES (1786, '24/02/2020', '2020-08', '1', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (1787, '17/02/2020', '2020-07', '1', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (1788, '10/02/2020', '2020-06', '3', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.02');
INSERT INTO public.europe_data_import VALUES (1789, '03/02/2020', '2020-05', '3', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (1790, '27/01/2020', '2020-04', '1', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (1791, '20/01/2020', '2020-03', '0', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1792, '13/01/2020', '2020-02', '0', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1793, '06/01/2020', '2020-01', '0', '0', '37411038', 'Canada', 'CA', 'CAN', 'America', '');
INSERT INTO public.europe_data_import VALUES (1794, '01/02/2021', '2021-04', '609', '4', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '200.93');
INSERT INTO public.europe_data_import VALUES (1795, '25/01/2021', '2021-03', '496', '11', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '192.02');
INSERT INTO public.europe_data_import VALUES (1796, '18/01/2021', '2021-02', '560', '4', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '195.11');
INSERT INTO public.europe_data_import VALUES (1797, '11/01/2021', '2021-01', '513', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '129.11');
INSERT INTO public.europe_data_import VALUES (1798, '04/01/2021', '2020-53', '197', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '62.01');
INSERT INTO public.europe_data_import VALUES (1799, '28/12/2020', '2020-52', '144', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '66.55');
INSERT INTO public.europe_data_import VALUES (1800, '21/12/2020', '2020-51', '222', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '93.83');
INSERT INTO public.europe_data_import VALUES (1801, '14/12/2020', '2020-50', '294', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '151.11');
INSERT INTO public.europe_data_import VALUES (1802, '07/12/2020', '2020-49', '537', '5', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '143.11');
INSERT INTO public.europe_data_import VALUES (1803, '30/11/2020', '2020-48', '250', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '128.01');
INSERT INTO public.europe_data_import VALUES (1804, '23/11/2020', '2020-47', '454', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '164.93');
INSERT INTO public.europe_data_import VALUES (1805, '16/11/2020', '2020-46', '453', '3', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '177.11');
INSERT INTO public.europe_data_import VALUES (1806, '09/11/2020', '2020-45', '521', '5', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '176.93');
INSERT INTO public.europe_data_import VALUES (1807, '02/11/2020', '2020-44', '452', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '199.3');
INSERT INTO public.europe_data_import VALUES (1808, '26/10/2020', '2020-43', '644', '8', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '240.76');
INSERT INTO public.europe_data_import VALUES (1809, '19/10/2020', '2020-42', '680', '11', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '253.12');
INSERT INTO public.europe_data_import VALUES (1810, '12/10/2020', '2020-41', '712', '10', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '236.57');
INSERT INTO public.europe_data_import VALUES (1811, '05/10/2020', '2020-40', '589', '8', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '200.57');
INSERT INTO public.europe_data_import VALUES (1812, '28/09/2020', '2020-39', '514', '6', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '174.2');
INSERT INTO public.europe_data_import VALUES (1813, '21/09/2020', '2020-38', '444', '7', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '168.57');
INSERT INTO public.europe_data_import VALUES (1814, '14/09/2020', '2020-37', '483', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '174.75');
INSERT INTO public.europe_data_import VALUES (1815, '07/09/2020', '2020-36', '478', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '149.29');
INSERT INTO public.europe_data_import VALUES (1816, '31/08/2020', '2020-35', '343', '3', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '122.38');
INSERT INTO public.europe_data_import VALUES (1817, '24/08/2020', '2020-34', '330', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '118.38');
INSERT INTO public.europe_data_import VALUES (1818, '17/08/2020', '2020-33', '321', '3', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '114.92');
INSERT INTO public.europe_data_import VALUES (1819, '10/08/2020', '2020-32', '311', '8', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '100.19');
INSERT INTO public.europe_data_import VALUES (1820, '03/08/2020', '2020-31', '240', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '91.65');
INSERT INTO public.europe_data_import VALUES (1821, '27/07/2020', '2020-30', '264', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '110.74');
INSERT INTO public.europe_data_import VALUES (1822, '20/07/2020', '2020-29', '345', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '107.65');
INSERT INTO public.europe_data_import VALUES (1823, '13/07/2020', '2020-28', '247', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '98.74');
INSERT INTO public.europe_data_import VALUES (1824, '06/07/2020', '2020-27', '296', '5', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '102.01');
INSERT INTO public.europe_data_import VALUES (1825, '29/06/2020', '2020-26', '265', '4', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '73.64');
INSERT INTO public.europe_data_import VALUES (1826, '22/06/2020', '2020-25', '140', '2', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '61.1');
INSERT INTO public.europe_data_import VALUES (1827, '15/06/2020', '2020-24', '196', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '57.28');
INSERT INTO public.europe_data_import VALUES (1828, '08/06/2020', '2020-23', '119', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '31.64');
INSERT INTO public.europe_data_import VALUES (1829, '01/06/2020', '2020-22', '55', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '19.46');
INSERT INTO public.europe_data_import VALUES (1830, '25/05/2020', '2020-21', '52', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '24.37');
INSERT INTO public.europe_data_import VALUES (1831, '18/05/2020', '2020-20', '82', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '29.64');
INSERT INTO public.europe_data_import VALUES (1832, '11/05/2020', '2020-19', '81', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '25.46');
INSERT INTO public.europe_data_import VALUES (1833, '04/05/2020', '2020-18', '59', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '18.91');
INSERT INTO public.europe_data_import VALUES (1834, '27/04/2020', '2020-17', '45', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '17.46');
INSERT INTO public.europe_data_import VALUES (1835, '20/04/2020', '2020-16', '51', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '9.82');
INSERT INTO public.europe_data_import VALUES (1836, '13/04/2020', '2020-15', '3', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '0.91');
INSERT INTO public.europe_data_import VALUES (1837, '06/04/2020', '2020-14', '2', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '0.73');
INSERT INTO public.europe_data_import VALUES (1838, '30/03/2020', '2020-13', '2', '1', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '0.91');
INSERT INTO public.europe_data_import VALUES (1839, '23/03/2020', '2020-12', '3', '0', '549936', 'Cape_Verde', 'CV', 'CPV', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1840, '02/03/2020', '2020-09', '14', '3', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1841, '24/02/2020', '2020-08', '336', '3', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1842, '17/02/2020', '2020-07', '285', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1843, '10/02/2020', '2020-06', '70', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1844, '03/02/2020', '2020-05', '0', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1845, '27/01/2020', '2020-04', '0', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1846, '20/01/2020', '2020-03', '0', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1847, '13/01/2020', '2020-02', '0', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1848, '06/01/2020', '2020-01', '0', '0', '', 'Cases_on_an_international_conveyance_Japan', 'JPG11668', '', 'Other', '');
INSERT INTO public.europe_data_import VALUES (1849, '01/02/2021', '2021-04', '15', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '27.71');
INSERT INTO public.europe_data_import VALUES (1850, '25/01/2021', '2021-03', '3', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '32.33');
INSERT INTO public.europe_data_import VALUES (1851, '18/01/2021', '2021-02', '18', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '50.81');
INSERT INTO public.europe_data_import VALUES (1852, '11/01/2021', '2021-01', '15', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '67.75');
INSERT INTO public.europe_data_import VALUES (1853, '04/01/2021', '2020-53', '29', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '47.73');
INSERT INTO public.europe_data_import VALUES (1854, '28/12/2020', '2020-52', '2', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '30.79');
INSERT INTO public.europe_data_import VALUES (1855, '21/12/2020', '2020-51', '18', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '43.11');
INSERT INTO public.europe_data_import VALUES (1856, '14/12/2020', '2020-50', '10', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '36.95');
INSERT INTO public.europe_data_import VALUES (1857, '07/12/2020', '2020-49', '14', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '41.57');
INSERT INTO public.europe_data_import VALUES (1858, '30/11/2020', '2020-48', '13', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '30.79');
INSERT INTO public.europe_data_import VALUES (1859, '23/11/2020', '2020-47', '7', '1', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '16.94');
INSERT INTO public.europe_data_import VALUES (1860, '16/11/2020', '2020-46', '4', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '21.56');
INSERT INTO public.europe_data_import VALUES (1861, '09/11/2020', '2020-45', '10', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '16.94');
INSERT INTO public.europe_data_import VALUES (1862, '02/11/2020', '2020-44', '1', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '10.78');
INSERT INTO public.europe_data_import VALUES (1863, '26/10/2020', '2020-43', '6', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '27.71');
INSERT INTO public.europe_data_import VALUES (1864, '19/10/2020', '2020-42', '12', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '30.79');
INSERT INTO public.europe_data_import VALUES (1865, '12/10/2020', '2020-41', '8', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '16.94');
INSERT INTO public.europe_data_import VALUES (1866, '05/10/2020', '2020-40', '3', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '6.16');
INSERT INTO public.europe_data_import VALUES (1867, '28/09/2020', '2020-39', '1', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '3.08');
INSERT INTO public.europe_data_import VALUES (1868, '21/09/2020', '2020-38', '1', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '6.16');
INSERT INTO public.europe_data_import VALUES (1869, '14/09/2020', '2020-37', '3', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '4.62');
INSERT INTO public.europe_data_import VALUES (1870, '07/09/2020', '2020-36', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1871, '31/08/2020', '2020-35', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '3.08');
INSERT INTO public.europe_data_import VALUES (1872, '24/08/2020', '2020-34', '2', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '3.08');
INSERT INTO public.europe_data_import VALUES (1873, '17/08/2020', '2020-33', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1874, '10/08/2020', '2020-32', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1875, '03/08/2020', '2020-31', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (1876, '27/07/2020', '2020-30', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '3.08');
INSERT INTO public.europe_data_import VALUES (1877, '20/07/2020', '2020-29', '2', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '3.08');
INSERT INTO public.europe_data_import VALUES (1878, '13/07/2020', '2020-28', '0', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (1879, '06/07/2020', '2020-27', '5', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '9.24');
INSERT INTO public.europe_data_import VALUES (1880, '29/06/2020', '2020-26', '1', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '13.86');
INSERT INTO public.europe_data_import VALUES (1881, '22/06/2020', '2020-25', '8', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '47.73');
INSERT INTO public.europe_data_import VALUES (1882, '15/06/2020', '2020-24', '23', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '70.83');
INSERT INTO public.europe_data_import VALUES (1883, '08/06/2020', '2020-23', '23', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '53.89');
INSERT INTO public.europe_data_import VALUES (1884, '01/06/2020', '2020-22', '12', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '72.37');
INSERT INTO public.europe_data_import VALUES (1885, '25/05/2020', '2020-21', '35', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '73.91');
INSERT INTO public.europe_data_import VALUES (1886, '18/05/2020', '2020-20', '13', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '30.79');
INSERT INTO public.europe_data_import VALUES (1887, '11/05/2020', '2020-19', '7', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '16.94');
INSERT INTO public.europe_data_import VALUES (1888, '04/05/2020', '2020-18', '4', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '20.02');
INSERT INTO public.europe_data_import VALUES (1889, '27/04/2020', '2020-17', '9', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '26.17');
INSERT INTO public.europe_data_import VALUES (1890, '20/04/2020', '2020-16', '8', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '33.87');
INSERT INTO public.europe_data_import VALUES (1891, '13/04/2020', '2020-15', '14', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '69.29');
INSERT INTO public.europe_data_import VALUES (1892, '06/04/2020', '2020-14', '31', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '55.43');
INSERT INTO public.europe_data_import VALUES (1893, '30/03/2020', '2020-13', '5', '0', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '12.32');
INSERT INTO public.europe_data_import VALUES (1894, '23/03/2020', '2020-12', '3', '1', '64948', 'Cayman_Islands', 'KY', 'CYM', 'America', '');
INSERT INTO public.europe_data_import VALUES (1895, '01/02/2021', '2021-04', '9', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (1896, '25/01/2021', '2021-03', '6', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.15');
INSERT INTO public.europe_data_import VALUES (1897, '18/01/2021', '2021-02', '1', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (1898, '11/01/2021', '2021-01', '10', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.25');
INSERT INTO public.europe_data_import VALUES (1899, '04/01/2021', '2020-53', '2', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (1900, '28/12/2020', '2020-52', '23', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (1901, '21/12/2020', '2020-51', '2', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (1902, '14/12/2020', '2020-50', '14', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.48');
INSERT INTO public.europe_data_import VALUES (1903, '07/12/2020', '2020-49', '9', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (1904, '30/11/2020', '2020-48', '2', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (1905, '23/11/2020', '2020-47', '11', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.67');
INSERT INTO public.europe_data_import VALUES (1906, '16/11/2020', '2020-46', '21', '1', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (1907, '09/11/2020', '2020-45', '13', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.36');
INSERT INTO public.europe_data_import VALUES (1908, '02/11/2020', '2020-44', '4', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (1909, '26/10/2020', '2020-43', '7', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (1910, '19/10/2020', '2020-42', '1', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.21');
INSERT INTO public.europe_data_import VALUES (1911, '12/10/2020', '2020-41', '9', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.01');
INSERT INTO public.europe_data_import VALUES (1912, '05/10/2020', '2020-40', '39', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.1');
INSERT INTO public.europe_data_import VALUES (1913, '28/09/2020', '2020-39', '13', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.2');
INSERT INTO public.europe_data_import VALUES (1914, '21/09/2020', '2020-38', '44', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.35');
INSERT INTO public.europe_data_import VALUES (1915, '14/09/2020', '2020-37', '20', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (1916, '07/09/2020', '2020-36', '29', '1', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.05');
INSERT INTO public.europe_data_import VALUES (1917, '31/08/2020', '2020-35', '21', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.01');
INSERT INTO public.europe_data_import VALUES (1918, '24/08/2020', '2020-34', '27', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.8');
INSERT INTO public.europe_data_import VALUES (1919, '17/08/2020', '2020-33', '11', '1', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.8');
INSERT INTO public.europe_data_import VALUES (1920, '10/08/2020', '2020-32', '27', '1', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (1921, '03/08/2020', '2020-31', '15', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '2.72');
INSERT INTO public.europe_data_import VALUES (1922, '27/07/2020', '2020-30', '114', '4', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '6.55');
INSERT INTO public.europe_data_import VALUES (1923, '20/07/2020', '2020-29', '197', '2', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '10.87');
INSERT INTO public.europe_data_import VALUES (1924, '13/07/2020', '2020-28', '319', '5', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '18.1');
INSERT INTO public.europe_data_import VALUES (1925, '06/07/2020', '2020-27', '540', '3', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '24.47');
INSERT INTO public.europe_data_import VALUES (1926, '29/06/2020', '2020-26', '621', '22', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '25.44');
INSERT INTO public.europe_data_import VALUES (1927, '22/06/2020', '2020-25', '586', '16', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '24.74');
INSERT INTO public.europe_data_import VALUES (1928, '15/06/2020', '2020-24', '588', '2', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '25.52');
INSERT INTO public.europe_data_import VALUES (1929, '08/06/2020', '2020-23', '623', '3', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '21.71');
INSERT INTO public.europe_data_import VALUES (1930, '01/06/2020', '2020-22', '407', '1', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '14.41');
INSERT INTO public.europe_data_import VALUES (1931, '25/05/2020', '2020-21', '277', '1', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '8.96');
INSERT INTO public.europe_data_import VALUES (1932, '18/05/2020', '2020-20', '148', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '5.37');
INSERT INTO public.europe_data_import VALUES (1933, '11/05/2020', '2020-19', '107', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '3.37');
INSERT INTO public.europe_data_import VALUES (1934, '04/05/2020', '2020-18', '53', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '1.26');
INSERT INTO public.europe_data_import VALUES (1935, '27/04/2020', '2020-17', '7', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (1936, '20/04/2020', '2020-16', '1', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (1937, '13/04/2020', '2020-15', '2', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (1938, '06/04/2020', '2020-14', '3', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (1939, '30/03/2020', '2020-13', '2', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (1940, '23/03/2020', '2020-12', '3', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (1941, '16/03/2020', '2020-11', '1', '0', '4745179', 'Central_African_Republic', 'CF', 'CAF', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1942, '01/02/2021', '2021-04', '224', '5', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '3.07');
INSERT INTO public.europe_data_import VALUES (1943, '25/01/2021', '2021-03', '266', '5', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '3.91');
INSERT INTO public.europe_data_import VALUES (1944, '18/01/2021', '2021-02', '358', '4', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '4.28');
INSERT INTO public.europe_data_import VALUES (1945, '11/01/2021', '2021-01', '324', '3', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '3.27');
INSERT INTO public.europe_data_import VALUES (1946, '04/01/2021', '2020-53', '198', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '2.03');
INSERT INTO public.europe_data_import VALUES (1947, '28/12/2020', '2020-52', '125', '2', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '1.54');
INSERT INTO public.europe_data_import VALUES (1948, '21/12/2020', '2020-51', '120', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (1949, '14/12/2020', '2020-50', '45', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.55');
INSERT INTO public.europe_data_import VALUES (1950, '07/12/2020', '2020-49', '43', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (1951, '30/11/2020', '2020-48', '40', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (1952, '23/11/2020', '2020-47', '45', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (1953, '16/11/2020', '2020-46', '50', '2', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (1954, '09/11/2020', '2020-45', '49', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (1955, '02/11/2020', '2020-44', '61', '2', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.75');
INSERT INTO public.europe_data_import VALUES (1956, '26/10/2020', '2020-43', '58', '3', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.83');
INSERT INTO public.europe_data_import VALUES (1957, '19/10/2020', '2020-42', '75', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (1958, '12/10/2020', '2020-41', '87', '6', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.79');
INSERT INTO public.europe_data_import VALUES (1959, '05/10/2020', '2020-40', '39', '2', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (1960, '28/09/2020', '2020-39', '27', '3', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.59');
INSERT INTO public.europe_data_import VALUES (1961, '21/09/2020', '2020-38', '67', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.7');
INSERT INTO public.europe_data_import VALUES (1962, '14/09/2020', '2020-37', '45', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.45');
INSERT INTO public.europe_data_import VALUES (1963, '07/09/2020', '2020-36', '27', '2', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.33');
INSERT INTO public.europe_data_import VALUES (1964, '31/08/2020', '2020-35', '26', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (1965, '24/08/2020', '2020-34', '30', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (1966, '17/08/2020', '2020-33', '12', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (1967, '10/08/2020', '2020-32', '8', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (1968, '03/08/2020', '2020-31', '21', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.29');
INSERT INTO public.europe_data_import VALUES (1969, '27/07/2020', '2020-30', '26', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.22');
INSERT INTO public.europe_data_import VALUES (1970, '20/07/2020', '2020-29', '9', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (1971, '13/07/2020', '2020-28', '8', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (1972, '06/07/2020', '2020-27', '6', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (1973, '29/06/2020', '2020-26', '8', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (1974, '22/06/2020', '2020-25', '8', '1', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (1975, '15/06/2020', '2020-24', '13', '4', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.45');
INSERT INTO public.europe_data_import VALUES (1976, '08/06/2020', '2020-23', '59', '4', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (1977, '01/06/2020', '2020-22', '103', '5', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '1.72');
INSERT INTO public.europe_data_import VALUES (1978, '25/05/2020', '2020-21', '172', '7', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '2.21');
INSERT INTO public.europe_data_import VALUES (1979, '18/05/2020', '2020-20', '181', '22', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '2.42');
INSERT INTO public.europe_data_import VALUES (1980, '11/05/2020', '2020-19', '205', '21', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '1.73');
INSERT INTO public.europe_data_import VALUES (1981, '04/05/2020', '2020-18', '71', '10', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (1982, '27/04/2020', '2020-17', '13', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.19');
INSERT INTO public.europe_data_import VALUES (1983, '20/04/2020', '2020-16', '18', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.15');
INSERT INTO public.europe_data_import VALUES (1984, '13/04/2020', '2020-15', '6', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (1985, '06/04/2020', '2020-14', '4', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (1986, '30/03/2020', '2020-13', '3', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (1987, '23/03/2020', '2020-12', '2', '0', '15946882', 'Chad', 'TD', 'TCD', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (1988, '01/02/2021', '2021-04', '27710', '538', '18952035', 'Chile', 'CL', 'CHL', 'America', '301.49');
INSERT INTO public.europe_data_import VALUES (1989, '25/01/2021', '2021-03', '29428', '452', '18952035', 'Chile', 'CL', 'CHL', 'America', '302.27');
INSERT INTO public.europe_data_import VALUES (1990, '18/01/2021', '2021-02', '27858', '385', '18952035', 'Chile', 'CL', 'CHL', 'America', '293.16');
INSERT INTO public.europe_data_import VALUES (1991, '11/01/2021', '2021-01', '27701', '395', '18952035', 'Chile', 'CL', 'CHL', 'America', '231.45');
INSERT INTO public.europe_data_import VALUES (1992, '04/01/2021', '2020-53', '16163', '324', '18952035', 'Chile', 'CL', 'CHL', 'America', '162.0');
INSERT INTO public.europe_data_import VALUES (1993, '28/12/2020', '2020-52', '14540', '246', '18952035', 'Chile', 'CL', 'CHL', 'America', '158.87');
INSERT INTO public.europe_data_import VALUES (1994, '21/12/2020', '2020-51', '15569', '311', '18952035', 'Chile', 'CL', 'CHL', 'America', '143.02');
INSERT INTO public.europe_data_import VALUES (1995, '14/12/2020', '2020-50', '11537', '258', '18952035', 'Chile', 'CL', 'CHL', 'America', '113.39');
INSERT INTO public.europe_data_import VALUES (1996, '07/12/2020', '2020-49', '9952', '272', '18952035', 'Chile', 'CL', 'CHL', 'America', '104.17');
INSERT INTO public.europe_data_import VALUES (1997, '30/11/2020', '2020-48', '9790', '287', '18952035', 'Chile', 'CL', 'CHL', 'America', '101.08');
INSERT INTO public.europe_data_import VALUES (1998, '23/11/2020', '2020-47', '9367', '250', '18952035', 'Chile', 'CL', 'CHL', 'America', '100.69');
INSERT INTO public.europe_data_import VALUES (1999, '16/11/2020', '2020-46', '9715', '276', '18952035', 'Chile', 'CL', 'CHL', 'America', '102.41');
INSERT INTO public.europe_data_import VALUES (2000, '09/11/2020', '2020-45', '9694', '296', '18952035', 'Chile', 'CL', 'CHL', 'America', '102.86');
INSERT INTO public.europe_data_import VALUES (2001, '02/11/2020', '2020-44', '9801', '303', '18952035', 'Chile', 'CL', 'CHL', 'America', '106.08');
INSERT INTO public.europe_data_import VALUES (2002, '26/10/2020', '2020-43', '10303', '309', '18952035', 'Chile', 'CL', 'CHL', 'America', '109.18');
INSERT INTO public.europe_data_import VALUES (2003, '19/10/2020', '2020-42', '10389', '317', '18952035', 'Chile', 'CL', 'CHL', 'America', '113.87');
INSERT INTO public.europe_data_import VALUES (2004, '12/10/2020', '2020-41', '11192', '339', '18952035', 'Chile', 'CL', 'CHL', 'America', '123.84');
INSERT INTO public.europe_data_import VALUES (2005, '05/10/2020', '2020-40', '12278', '338', '18952035', 'Chile', 'CL', 'CHL', 'America', '126.13');
INSERT INTO public.europe_data_import VALUES (2006, '28/09/2020', '2020-39', '11627', '355', '18952035', 'Chile', 'CL', 'CHL', 'America', '122.17');
INSERT INTO public.europe_data_import VALUES (2007, '21/09/2020', '2020-38', '11526', '337', '18952035', 'Chile', 'CL', 'CHL', 'America', '125.39');
INSERT INTO public.europe_data_import VALUES (2008, '14/09/2020', '2020-37', '12238', '357', '18952035', 'Chile', 'CL', 'CHL', 'America', '130.72');
INSERT INTO public.europe_data_import VALUES (2009, '07/09/2020', '2020-36', '12536', '348', '18952035', 'Chile', 'CL', 'CHL', 'America', '131.09');
INSERT INTO public.europe_data_import VALUES (2010, '31/08/2020', '2020-35', '12309', '392', '18952035', 'Chile', 'CL', 'CHL', 'America', '126.78');
INSERT INTO public.europe_data_import VALUES (2011, '24/08/2020', '2020-34', '11719', '400', '18952035', 'Chile', 'CL', 'CHL', 'America', '129.85');
INSERT INTO public.europe_data_import VALUES (2012, '17/08/2020', '2020-33', '12890', '375', '18952035', 'Chile', 'CL', 'CHL', 'America', '138.32');
INSERT INTO public.europe_data_import VALUES (2013, '10/08/2020', '2020-32', '13325', '469', '18952035', 'Chile', 'CL', 'CHL', 'America', '143.87');
INSERT INTO public.europe_data_import VALUES (2014, '03/08/2020', '2020-31', '13941', '496', '18952035', 'Chile', 'CL', 'CHL', 'America', '151.97');
INSERT INTO public.europe_data_import VALUES (2015, '27/07/2020', '2020-30', '14860', '609', '18952035', 'Chile', 'CL', 'CHL', 'America', '162.25');
INSERT INTO public.europe_data_import VALUES (2016, '20/07/2020', '2020-29', '15889', '1524', '18952035', 'Chile', 'CL', 'CHL', 'America', '186.78');
INSERT INTO public.europe_data_import VALUES (2017, '13/07/2020', '2020-28', '19509', '671', '18952035', 'Chile', 'CL', 'CHL', 'America', '227.2');
INSERT INTO public.europe_data_import VALUES (2018, '06/07/2020', '2020-27', '23550', '799', '18952035', 'Chile', 'CL', 'CHL', 'America', '280.59');
INSERT INTO public.europe_data_import VALUES (2019, '29/06/2020', '2020-26', '29627', '1030', '18952035', 'Chile', 'CL', 'CHL', 'America', '515.45');
INSERT INTO public.europe_data_import VALUES (2020, '22/06/2020', '2020-25', '68062', '1156', '18952035', 'Chile', 'CL', 'CHL', 'America', '570.94');
INSERT INTO public.europe_data_import VALUES (2021, '15/06/2020', '2020-24', '40143', '1133', '18952035', 'Chile', 'CL', 'CHL', 'America', '393.65');
INSERT INTO public.europe_data_import VALUES (2022, '08/06/2020', '2020-23', '34462', '1136', '18952035', 'Chile', 'CL', 'CHL', 'America', '343.22');
INSERT INTO public.europe_data_import VALUES (2023, '01/06/2020', '2020-22', '30586', '336', '18952035', 'Chile', 'CL', 'CHL', 'America', '294.99');
INSERT INTO public.europe_data_import VALUES (2024, '25/05/2020', '2020-21', '25321', '268', '18952035', 'Chile', 'CL', 'CHL', 'America', '212.3');
INSERT INTO public.europe_data_import VALUES (2025, '18/05/2020', '2020-20', '14915', '138', '18952035', 'Chile', 'CL', 'CHL', 'America', '127.26');
INSERT INTO public.europe_data_import VALUES (2026, '11/05/2020', '2020-19', '9203', '52', '18952035', 'Chile', 'CL', 'CHL', 'America', '81.97');
INSERT INTO public.europe_data_import VALUES (2027, '04/05/2020', '2020-18', '6332', '71', '18952035', 'Chile', 'CL', 'CHL', 'America', '50.52');
INSERT INTO public.europe_data_import VALUES (2028, '27/04/2020', '2020-17', '3243', '56', '18952035', 'Chile', 'CL', 'CHL', 'America', '32.28');
INSERT INTO public.europe_data_import VALUES (2029, '20/04/2020', '2020-16', '2875', '53', '18952035', 'Chile', 'CL', 'CHL', 'America', '29.64');
INSERT INTO public.europe_data_import VALUES (2030, '13/04/2020', '2020-15', '2742', '46', '18952035', 'Chile', 'CL', 'CHL', 'America', '26.77');
INSERT INTO public.europe_data_import VALUES (2031, '06/04/2020', '2020-14', '2332', '27', '18952035', 'Chile', 'CL', 'CHL', 'America', '20.26');
INSERT INTO public.europe_data_import VALUES (2032, '30/03/2020', '2020-13', '1507', '6', '18952035', 'Chile', 'CL', 'CHL', 'America', '10.89');
INSERT INTO public.europe_data_import VALUES (2033, '23/03/2020', '2020-12', '557', '1', '18952035', 'Chile', 'CL', 'CHL', 'America', '3.28');
INSERT INTO public.europe_data_import VALUES (2034, '16/03/2020', '2020-11', '65', '0', '18952035', 'Chile', 'CL', 'CHL', 'America', '0.4');
INSERT INTO public.europe_data_import VALUES (2035, '09/03/2020', '2020-10', '10', '0', '18952035', 'Chile', 'CL', 'CHL', 'America', '');
INSERT INTO public.europe_data_import VALUES (2036, '01/02/2021', '2021-04', '816', '13', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (2037, '25/01/2021', '2021-03', '1308', '7', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (2038, '18/01/2021', '2021-02', '1115', '10', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (2039, '11/01/2021', '2021-01', '611', '2', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (2040, '04/01/2021', '2020-53', '918', '14', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (2041, '28/12/2020', '2020-52', '245', '7', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (2042, '21/12/2020', '2020-51', '3029', '25', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.22');
INSERT INTO public.europe_data_import VALUES (2043, '14/12/2020', '2020-50', '103', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2044, '07/12/2020', '2020-49', '104', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2045, '30/11/2020', '2020-48', '83', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2046, '23/11/2020', '2020-47', '95', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2047, '16/11/2020', '2020-46', '76', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2048, '09/11/2020', '2020-45', '213', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (2049, '02/11/2020', '2020-44', '196', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (2050, '26/10/2020', '2020-43', '179', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2051, '19/10/2020', '2020-42', '160', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2052, '12/10/2020', '2020-41', '183', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2053, '05/10/2020', '2020-40', '146', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2054, '28/09/2020', '2020-39', '114', '2', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2055, '21/09/2020', '2020-38', '172', '3', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2056, '14/09/2020', '2020-37', '139', '4', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2057, '07/09/2020', '2020-36', '163', '8', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (2058, '31/08/2020', '2020-35', '200', '11', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (2059, '24/08/2020', '2020-34', '320', '8', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (2060, '17/08/2020', '2020-33', '582', '17', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (2061, '10/08/2020', '2020-32', '808', '17', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (2062, '03/08/2020', '2020-31', '1415', '17', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (2063, '27/07/2020', '2020-30', '957', '6', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (2064, '20/07/2020', '2020-29', '496', '5', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (2065, '13/07/2020', '2020-28', '246', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (2066, '06/07/2020', '2020-27', '114', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (2067, '29/06/2020', '2020-26', '185', '2', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (2068, '22/06/2020', '2020-25', '237', '1', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (2069, '15/06/2020', '2020-24', '144', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2070, '08/06/2020', '2020-23', '44', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2071, '01/06/2020', '2020-22', '52', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2072, '25/05/2020', '2020-21', '41', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2073, '18/05/2020', '2020-20', '44', '1', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2074, '11/05/2020', '2020-19', '46', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2075, '04/05/2020', '2020-18', '52', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2076, '27/04/2020', '2020-17', '95', '1', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (2077, '20/04/2020', '2020-16', '608', '1291', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (2078, '13/04/2020', '2020-15', '567', '10', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (2079, '06/04/2020', '2020-14', '485', '29', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (2080, '30/03/2020', '2020-13', '673', '32', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (2081, '23/03/2020', '2020-12', '464', '58', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (2082, '16/03/2020', '2020-11', '161', '94', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (2083, '09/03/2020', '2020-10', '725', '208', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.25');
INSERT INTO public.europe_data_import VALUES (2084, '02/03/2020', '2020-09', '2900', '319', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.66');
INSERT INTO public.europe_data_import VALUES (2085, '24/02/2020', '2020-08', '6616', '824', '1433783692', 'China', 'CN', 'CHN', 'Asia', '2.58');
INSERT INTO public.europe_data_import VALUES (2086, '17/02/2020', '2020-07', '30412', '862', '1433783692', 'China', 'CN', 'CHN', 'Asia', '3.72');
INSERT INTO public.europe_data_import VALUES (2087, '10/02/2020', '2020-06', '22995', '548', '1433783692', 'China', 'CN', 'CHN', 'Asia', '2.61');
INSERT INTO public.europe_data_import VALUES (2088, '03/02/2020', '2020-05', '14436', '280', '1433783692', 'China', 'CN', 'CHN', 'Asia', '1.18');
INSERT INTO public.europe_data_import VALUES (2089, '27/01/2020', '2020-04', '2540', '78', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.19');
INSERT INTO public.europe_data_import VALUES (2090, '20/01/2020', '2020-03', '176', '2', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (2091, '13/01/2020', '2020-02', '0', '1', '1433783692', 'China', 'CN', 'CHN', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (2092, '06/01/2020', '2020-01', '59', '0', '1433783692', 'China', 'CN', 'CHN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (2093, '01/02/2021', '2021-04', '76760', '2525', '50339443', 'Colombia', 'CO', 'COL', 'America', '360.3');
INSERT INTO public.europe_data_import VALUES (2094, '25/01/2021', '2021-03', '104614', '2743', '50339443', 'Colombia', 'CO', 'COL', 'America', '448.64');
INSERT INTO public.europe_data_import VALUES (2095, '18/01/2021', '2021-02', '121229', '2553', '50339443', 'Colombia', 'CO', 'COL', 'America', '491.29');
INSERT INTO public.europe_data_import VALUES (2096, '11/01/2021', '2021-01', '126083', '2486', '50339443', 'Colombia', 'CO', 'COL', 'America', '393.52');
INSERT INTO public.europe_data_import VALUES (2097, '04/01/2021', '2020-53', '72013', '1591', '50339443', 'Colombia', 'CO', 'COL', 'America', '313.38');
INSERT INTO public.europe_data_import VALUES (2098, '28/12/2020', '2020-52', '85740', '1694', '50339443', 'Colombia', 'CO', 'COL', 'America', '353.67');
INSERT INTO public.europe_data_import VALUES (2099, '21/12/2020', '2020-51', '92293', '1627', '50339443', 'Colombia', 'CO', 'COL', 'America', '291.95');
INSERT INTO public.europe_data_import VALUES (2100, '14/12/2020', '2020-50', '54671', '1245', '50339443', 'Colombia', 'CO', 'COL', 'America', '233.21');
INSERT INTO public.europe_data_import VALUES (2101, '07/12/2020', '2020-49', '62727', '1224', '50339443', 'Colombia', 'CO', 'COL', 'America', '243.72');
INSERT INTO public.europe_data_import VALUES (2102, '30/11/2020', '2020-48', '59959', '1297', '50339443', 'Colombia', 'CO', 'COL', 'America', '217.78');
INSERT INTO public.europe_data_import VALUES (2103, '23/11/2020', '2020-47', '49671', '1256', '50339443', 'Colombia', 'CO', 'COL', 'America', '207.65');
INSERT INTO public.europe_data_import VALUES (2104, '16/11/2020', '2020-46', '54859', '1240', '50339443', 'Colombia', 'CO', 'COL', 'America', '229.29');
INSERT INTO public.europe_data_import VALUES (2105, '09/11/2020', '2020-45', '60566', '1276', '50339443', 'Colombia', 'CO', 'COL', 'America', '254.28');
INSERT INTO public.europe_data_import VALUES (2106, '02/11/2020', '2020-44', '67436', '1361', '50339443', 'Colombia', 'CO', 'COL', 'America', '245.83');
INSERT INTO public.europe_data_import VALUES (2107, '26/10/2020', '2020-43', '56313', '1184', '50339443', 'Colombia', 'CO', 'COL', 'America', '207.73');
INSERT INTO public.europe_data_import VALUES (2108, '19/10/2020', '2020-42', '48256', '1136', '50339443', 'Colombia', 'CO', 'COL', 'America', '207.63');
INSERT INTO public.europe_data_import VALUES (2109, '12/10/2020', '2020-41', '56264', '1122', '50339443', 'Colombia', 'CO', 'COL', 'America', '195.19');
INSERT INTO public.europe_data_import VALUES (2110, '05/10/2020', '2020-40', '41996', '1224', '50339443', 'Colombia', 'CO', 'COL', 'America', '178.74');
INSERT INTO public.europe_data_import VALUES (2111, '28/09/2020', '2020-39', '47980', '1280', '50339443', 'Colombia', 'CO', 'COL', 'America', '192.17');
INSERT INTO public.europe_data_import VALUES (2112, '21/09/2020', '2020-38', '48757', '1284', '50339443', 'Colombia', 'CO', 'COL', 'America', '195.78');
INSERT INTO public.europe_data_import VALUES (2113, '14/09/2020', '2020-37', '49798', '1512', '50339443', 'Colombia', 'CO', 'COL', 'America', '215.3');
INSERT INTO public.europe_data_import VALUES (2114, '07/09/2020', '2020-36', '58583', '2048', '50339443', 'Colombia', 'CO', 'COL', 'America', '249.06');
INSERT INTO public.europe_data_import VALUES (2115, '31/08/2020', '2020-35', '66791', '2048', '50339443', 'Colombia', 'CO', 'COL', 'America', '277.33');
INSERT INTO public.europe_data_import VALUES (2116, '24/08/2020', '2020-34', '72815', '2219', '50339443', 'Colombia', 'CO', 'COL', 'America', '305.26');
INSERT INTO public.europe_data_import VALUES (2117, '17/08/2020', '2020-33', '80851', '2255', '50339443', 'Colombia', 'CO', 'COL', 'America', '299.33');
INSERT INTO public.europe_data_import VALUES (2118, '10/08/2020', '2020-32', '69830', '2192', '50339443', 'Colombia', 'CO', 'COL', 'America', '275.14');
INSERT INTO public.europe_data_import VALUES (2119, '03/08/2020', '2020-31', '68675', '2125', '50339443', 'Colombia', 'CO', 'COL', 'America', '239.12');
INSERT INTO public.europe_data_import VALUES (2120, '27/07/2020', '2020-30', '51698', '1789', '50339443', 'Colombia', 'CO', 'COL', 'America', '195.73');
INSERT INTO public.europe_data_import VALUES (2121, '20/07/2020', '2020-29', '46833', '1429', '50339443', 'Colombia', 'CO', 'COL', 'America', '159.25');
INSERT INTO public.europe_data_import VALUES (2122, '13/07/2020', '2020-28', '33335', '1243', '50339443', 'Colombia', 'CO', 'COL', 'America', '116.56');
INSERT INTO public.europe_data_import VALUES (2123, '06/07/2020', '2020-27', '25341', '958', '50339443', 'Colombia', 'CO', 'COL', 'America', '96.26');
INSERT INTO public.europe_data_import VALUES (2124, '29/06/2020', '2020-26', '23117', '869', '50339443', 'Colombia', 'CO', 'COL', 'America', '81.11');
INSERT INTO public.europe_data_import VALUES (2125, '22/06/2020', '2020-25', '17713', '570', '50339443', 'Colombia', 'CO', 'COL', 'America', '58.44');
INSERT INTO public.europe_data_import VALUES (2126, '15/06/2020', '2020-24', '11703', '408', '50339443', 'Colombia', 'CO', 'COL', 'America', '42.82');
INSERT INTO public.europe_data_import VALUES (2127, '08/06/2020', '2020-23', '9853', '320', '50339443', 'Colombia', 'CO', 'COL', 'America', '35.88');
INSERT INTO public.europe_data_import VALUES (2128, '01/06/2020', '2020-22', '8208', '212', '50339443', 'Colombia', 'CO', 'COL', 'America', '27.43');
INSERT INTO public.europe_data_import VALUES (2129, '25/05/2020', '2020-21', '5601', '153', '50339443', 'Colombia', 'CO', 'COL', 'America', '20.09');
INSERT INTO public.europe_data_import VALUES (2130, '18/05/2020', '2020-20', '4511', '111', '50339443', 'Colombia', 'CO', 'COL', 'America', '15.71');
INSERT INTO public.europe_data_import VALUES (2131, '11/05/2020', '2020-19', '3395', '123', '50339443', 'Colombia', 'CO', 'COL', 'America', '11.29');
INSERT INTO public.europe_data_import VALUES (2132, '04/05/2020', '2020-18', '2289', '97', '50339443', 'Colombia', 'CO', 'COL', 'America', '7.7');
INSERT INTO public.europe_data_import VALUES (2133, '27/04/2020', '2020-17', '1587', '64', '50339443', 'Colombia', 'CO', 'COL', 'America', '5.17');
INSERT INTO public.europe_data_import VALUES (2134, '20/04/2020', '2020-16', '1016', '70', '50339443', 'Colombia', 'CO', 'COL', 'America', '4.58');
INSERT INTO public.europe_data_import VALUES (2135, '13/04/2020', '2020-15', '1291', '74', '50339443', 'Colombia', 'CO', 'COL', 'America', '4.12');
INSERT INTO public.europe_data_import VALUES (2136, '06/04/2020', '2020-14', '783', '25', '50339443', 'Colombia', 'CO', 'COL', 'America', '2.48');
INSERT INTO public.europe_data_import VALUES (2137, '30/03/2020', '2020-13', '467', '8', '50339443', 'Colombia', 'CO', 'COL', 'America', '1.31');
INSERT INTO public.europe_data_import VALUES (2138, '23/03/2020', '2020-12', '190', '2', '50339443', 'Colombia', 'CO', 'COL', 'America', '0.47');
INSERT INTO public.europe_data_import VALUES (2139, '16/03/2020', '2020-11', '45', '0', '50339443', 'Colombia', 'CO', 'COL', 'America', '');
INSERT INTO public.europe_data_import VALUES (2140, '01/02/2021', '2021-04', '543', '27', '850891', 'Comoros', 'KM', 'COM', 'Africa', '143.26');
INSERT INTO public.europe_data_import VALUES (2141, '25/01/2021', '2021-03', '676', '26', '850891', 'Comoros', 'KM', 'COM', 'Africa', '130.22');
INSERT INTO public.europe_data_import VALUES (2142, '18/01/2021', '2021-02', '432', '27', '850891', 'Comoros', 'KM', 'COM', 'Africa', '85.56');
INSERT INTO public.europe_data_import VALUES (2143, '11/01/2021', '2021-01', '296', '5', '850891', 'Comoros', 'KM', 'COM', 'Africa', '50.42');
INSERT INTO public.europe_data_import VALUES (2144, '04/01/2021', '2020-53', '133', '6', '850891', 'Comoros', 'KM', 'COM', 'Africa', '23.27');
INSERT INTO public.europe_data_import VALUES (2145, '28/12/2020', '2020-52', '65', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '12.1');
INSERT INTO public.europe_data_import VALUES (2146, '21/12/2020', '2020-51', '38', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '5.88');
INSERT INTO public.europe_data_import VALUES (2147, '14/12/2020', '2020-50', '12', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.0');
INSERT INTO public.europe_data_import VALUES (2148, '07/12/2020', '2020-49', '5', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.35');
INSERT INTO public.europe_data_import VALUES (2149, '30/11/2020', '2020-48', '15', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '3.76');
INSERT INTO public.europe_data_import VALUES (2150, '23/11/2020', '2020-47', '17', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '3.88');
INSERT INTO public.europe_data_import VALUES (2151, '16/11/2020', '2020-46', '16', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '4.0');
INSERT INTO public.europe_data_import VALUES (2152, '09/11/2020', '2020-45', '18', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '5.41');
INSERT INTO public.europe_data_import VALUES (2153, '02/11/2020', '2020-44', '28', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '5.05');
INSERT INTO public.europe_data_import VALUES (2154, '26/10/2020', '2020-43', '15', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.59');
INSERT INTO public.europe_data_import VALUES (2155, '19/10/2020', '2020-42', '7', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '1.76');
INSERT INTO public.europe_data_import VALUES (2156, '12/10/2020', '2020-41', '8', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.0');
INSERT INTO public.europe_data_import VALUES (2157, '05/10/2020', '2020-40', '9', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.0');
INSERT INTO public.europe_data_import VALUES (2158, '28/09/2020', '2020-39', '8', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.59');
INSERT INTO public.europe_data_import VALUES (2159, '21/09/2020', '2020-38', '14', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.12');
INSERT INTO public.europe_data_import VALUES (2160, '14/09/2020', '2020-37', '4', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '3.88');
INSERT INTO public.europe_data_import VALUES (2161, '07/09/2020', '2020-36', '29', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '4.11');
INSERT INTO public.europe_data_import VALUES (2162, '31/08/2020', '2020-35', '6', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.12');
INSERT INTO public.europe_data_import VALUES (2163, '24/08/2020', '2020-34', '12', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.12');
INSERT INTO public.europe_data_import VALUES (2164, '17/08/2020', '2020-33', '6', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.23');
INSERT INTO public.europe_data_import VALUES (2165, '10/08/2020', '2020-32', '13', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '6.93');
INSERT INTO public.europe_data_import VALUES (2166, '03/08/2020', '2020-31', '46', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '6.11');
INSERT INTO public.europe_data_import VALUES (2167, '27/07/2020', '2020-30', '6', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.7');
INSERT INTO public.europe_data_import VALUES (2168, '20/07/2020', '2020-29', '17', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '2.7');
INSERT INTO public.europe_data_import VALUES (2169, '13/07/2020', '2020-28', '6', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '5.29');
INSERT INTO public.europe_data_import VALUES (2170, '06/07/2020', '2020-27', '39', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '7.52');
INSERT INTO public.europe_data_import VALUES (2171, '29/06/2020', '2020-26', '25', '2', '850891', 'Comoros', 'KM', 'COM', 'Africa', '11.28');
INSERT INTO public.europe_data_import VALUES (2172, '22/06/2020', '2020-25', '71', '3', '850891', 'Comoros', 'KM', 'COM', 'Africa', '12.46');
INSERT INTO public.europe_data_import VALUES (2173, '15/06/2020', '2020-24', '35', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '8.23');
INSERT INTO public.europe_data_import VALUES (2174, '08/06/2020', '2020-23', '35', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '6.35');
INSERT INTO public.europe_data_import VALUES (2175, '01/06/2020', '2020-22', '19', '1', '850891', 'Comoros', 'KM', 'COM', 'Africa', '11.16');
INSERT INTO public.europe_data_import VALUES (2176, '25/05/2020', '2020-21', '76', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '8.93');
INSERT INTO public.europe_data_import VALUES (2177, '18/05/2020', '2020-20', '0', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '0.94');
INSERT INTO public.europe_data_import VALUES (2178, '11/05/2020', '2020-19', '8', '1', '850891', 'Comoros', 'KM', 'COM', 'Africa', '1.29');
INSERT INTO public.europe_data_import VALUES (2179, '04/05/2020', '2020-18', '3', '0', '850891', 'Comoros', 'KM', 'COM', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (2180, '01/02/2021', '2021-04', '93', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.31');
INSERT INTO public.europe_data_import VALUES (2181, '25/01/2021', '2021-03', '85', '3', '5380504', 'Congo', 'CG', 'COG', 'Africa', '10.72');
INSERT INTO public.europe_data_import VALUES (2182, '18/01/2021', '2021-02', '492', '6', '5380504', 'Congo', 'CG', 'COG', 'Africa', '11.19');
INSERT INTO public.europe_data_import VALUES (2183, '11/01/2021', '2021-01', '110', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '12.01');
INSERT INTO public.europe_data_import VALUES (2184, '04/01/2021', '2020-53', '536', '8', '5380504', 'Congo', 'CG', 'COG', 'Africa', '16.86');
INSERT INTO public.europe_data_import VALUES (2185, '28/12/2020', '2020-52', '371', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '6.9');
INSERT INTO public.europe_data_import VALUES (2186, '21/12/2020', '2020-51', '0', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '7.92');
INSERT INTO public.europe_data_import VALUES (2187, '14/12/2020', '2020-50', '426', '6', '5380504', 'Congo', 'CG', 'COG', 'Africa', '7.92');
INSERT INTO public.europe_data_import VALUES (2188, '07/12/2020', '2020-49', '0', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.64');
INSERT INTO public.europe_data_import VALUES (2189, '30/11/2020', '2020-48', '142', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '7.34');
INSERT INTO public.europe_data_import VALUES (2190, '23/11/2020', '2020-47', '253', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '4.7');
INSERT INTO public.europe_data_import VALUES (2191, '16/11/2020', '2020-46', '0', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '1.65');
INSERT INTO public.europe_data_import VALUES (2192, '09/11/2020', '2020-45', '89', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.34');
INSERT INTO public.europe_data_import VALUES (2193, '02/11/2020', '2020-44', '37', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.49');
INSERT INTO public.europe_data_import VALUES (2194, '26/10/2020', '2020-43', '97', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.51');
INSERT INTO public.europe_data_import VALUES (2195, '19/10/2020', '2020-42', '38', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '1.25');
INSERT INTO public.europe_data_import VALUES (2196, '12/10/2020', '2020-41', '29', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.04');
INSERT INTO public.europe_data_import VALUES (2197, '05/10/2020', '2020-40', '81', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '1.91');
INSERT INTO public.europe_data_import VALUES (2198, '28/09/2020', '2020-39', '22', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '1.38');
INSERT INTO public.europe_data_import VALUES (2199, '21/09/2020', '2020-38', '52', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '6.65');
INSERT INTO public.europe_data_import VALUES (2200, '14/09/2020', '2020-37', '306', '6', '5380504', 'Congo', 'CG', 'COG', 'Africa', '17.75');
INSERT INTO public.europe_data_import VALUES (2201, '07/09/2020', '2020-36', '649', '4', '5380504', 'Congo', 'CG', 'COG', 'Africa', '14.46');
INSERT INTO public.europe_data_import VALUES (2202, '31/08/2020', '2020-35', '129', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.68');
INSERT INTO public.europe_data_import VALUES (2203, '24/08/2020', '2020-34', '15', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.46');
INSERT INTO public.europe_data_import VALUES (2204, '17/08/2020', '2020-33', '171', '18', '5380504', 'Congo', 'CG', 'COG', 'Africa', '8.33');
INSERT INTO public.europe_data_import VALUES (2205, '10/08/2020', '2020-32', '277', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '11.63');
INSERT INTO public.europe_data_import VALUES (2206, '03/08/2020', '2020-31', '349', '5', '5380504', 'Congo', 'CG', 'COG', 'Africa', '14.01');
INSERT INTO public.europe_data_import VALUES (2207, '27/07/2020', '2020-30', '405', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '17.38');
INSERT INTO public.europe_data_import VALUES (2208, '20/07/2020', '2020-29', '530', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '20.0');
INSERT INTO public.europe_data_import VALUES (2209, '13/07/2020', '2020-28', '546', '3', '5380504', 'Congo', 'CG', 'COG', 'Africa', '15.95');
INSERT INTO public.europe_data_import VALUES (2210, '06/07/2020', '2020-27', '312', '4', '5380504', 'Congo', 'CG', 'COG', 'Africa', '10.11');
INSERT INTO public.europe_data_import VALUES (2211, '29/06/2020', '2020-26', '232', '12', '5380504', 'Congo', 'CG', 'COG', 'Africa', '8.66');
INSERT INTO public.europe_data_import VALUES (2212, '22/06/2020', '2020-25', '234', '3', '5380504', 'Congo', 'CG', 'COG', 'Africa', '6.13');
INSERT INTO public.europe_data_import VALUES (2213, '15/06/2020', '2020-24', '96', '3', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.12');
INSERT INTO public.europe_data_import VALUES (2214, '08/06/2020', '2020-23', '72', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.64');
INSERT INTO public.europe_data_import VALUES (2215, '01/06/2020', '2020-22', '124', '4', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.7');
INSERT INTO public.europe_data_import VALUES (2216, '25/05/2020', '2020-21', '75', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.72');
INSERT INTO public.europe_data_import VALUES (2217, '18/05/2020', '2020-20', '125', '5', '5380504', 'Congo', 'CG', 'COG', 'Africa', '3.4');
INSERT INTO public.europe_data_import VALUES (2218, '11/05/2020', '2020-19', '58', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '1.62');
INSERT INTO public.europe_data_import VALUES (2219, '04/05/2020', '2020-18', '29', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '1.28');
INSERT INTO public.europe_data_import VALUES (2220, '27/04/2020', '2020-17', '40', '2', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.42');
INSERT INTO public.europe_data_import VALUES (2221, '20/04/2020', '2020-16', '90', '1', '5380504', 'Congo', 'CG', 'COG', 'Africa', '2.14');
INSERT INTO public.europe_data_import VALUES (2222, '13/04/2020', '2020-15', '25', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (2223, '06/04/2020', '2020-14', '26', '5', '5380504', 'Congo', 'CG', 'COG', 'Africa', '0.76');
INSERT INTO public.europe_data_import VALUES (2224, '30/03/2020', '2020-13', '15', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '0.33');
INSERT INTO public.europe_data_import VALUES (2225, '23/03/2020', '2020-12', '3', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (2226, '16/03/2020', '2020-11', '1', '0', '5380504', 'Congo', 'CG', 'COG', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (2227, '01/02/2021', '2021-04', '3824', '76', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '169.45');
INSERT INTO public.europe_data_import VALUES (2228, '25/01/2021', '2021-03', '4729', '100', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '211.67');
INSERT INTO public.europe_data_import VALUES (2229, '18/01/2021', '2021-02', '5955', '105', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '269.04');
INSERT INTO public.europe_data_import VALUES (2230, '11/01/2021', '2021-01', '7625', '124', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '283.29');
INSERT INTO public.europe_data_import VALUES (2231, '04/01/2021', '2020-53', '6674', '85', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '248.5');
INSERT INTO public.europe_data_import VALUES (2232, '28/12/2020', '2020-52', '5869', '107', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '249.49');
INSERT INTO public.europe_data_import VALUES (2233, '21/12/2020', '2020-51', '6724', '101', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '321.11');
INSERT INTO public.europe_data_import VALUES (2234, '14/12/2020', '2020-50', '9484', '163', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '318.49');
INSERT INTO public.europe_data_import VALUES (2235, '07/12/2020', '2020-49', '6592', '83', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '282.65');
INSERT INTO public.europe_data_import VALUES (2236, '30/11/2020', '2020-48', '7675', '82', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '274.79');
INSERT INTO public.europe_data_import VALUES (2237, '23/11/2020', '2020-47', '6195', '62', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '258.64');
INSERT INTO public.europe_data_import VALUES (2238, '16/11/2020', '2020-46', '6860', '82', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '262.54');
INSERT INTO public.europe_data_import VALUES (2239, '09/11/2020', '2020-45', '6392', '79', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '263.0');
INSERT INTO public.europe_data_import VALUES (2240, '02/11/2020', '2020-44', '6883', '103', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '286.42');
INSERT INTO public.europe_data_import VALUES (2241, '26/10/2020', '2020-43', '7574', '99', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '310.03');
INSERT INTO public.europe_data_import VALUES (2242, '19/10/2020', '2020-42', '8075', '107', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '323.56');
INSERT INTO public.europe_data_import VALUES (2243, '12/10/2020', '2020-41', '8257', '126', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '304.9');
INSERT INTO public.europe_data_import VALUES (2244, '05/10/2020', '2020-40', '7133', '122', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '306.48');
INSERT INTO public.europe_data_import VALUES (2245, '28/09/2020', '2020-39', '8337', '122', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '328.77');
INSERT INTO public.europe_data_import VALUES (2246, '21/09/2020', '2020-38', '8258', '116', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '332.68');
INSERT INTO public.europe_data_import VALUES (2247, '14/09/2020', '2020-37', '8534', '112', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '312.13');
INSERT INTO public.europe_data_import VALUES (2248, '07/09/2020', '2020-36', '7221', '60', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '259.53');
INSERT INTO public.europe_data_import VALUES (2249, '31/08/2020', '2020-35', '5879', '63', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '222.56');
INSERT INTO public.europe_data_import VALUES (2250, '24/08/2020', '2020-34', '5355', '61', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '208.69');
INSERT INTO public.europe_data_import VALUES (2251, '17/08/2020', '2020-33', '5179', '59', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '188.01');
INSERT INTO public.europe_data_import VALUES (2252, '10/08/2020', '2020-32', '4311', '73', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '159.62');
INSERT INTO public.europe_data_import VALUES (2253, '03/08/2020', '2020-31', '3746', '58', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '155.74');
INSERT INTO public.europe_data_import VALUES (2254, '27/07/2020', '2020-30', '4115', '42', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '151.22');
INSERT INTO public.europe_data_import VALUES (2255, '20/07/2020', '2020-29', '3518', '32', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '121.21');
INSERT INTO public.europe_data_import VALUES (2256, '13/07/2020', '2020-28', '2600', '11', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '88.48');
INSERT INTO public.europe_data_import VALUES (2257, '06/07/2020', '2020-27', '1866', '4', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '55.14');
INSERT INTO public.europe_data_import VALUES (2258, '29/06/2020', '2020-26', '917', '3', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '28.03');
INSERT INTO public.europe_data_import VALUES (2259, '22/06/2020', '2020-25', '498', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '17.73');
INSERT INTO public.europe_data_import VALUES (2260, '15/06/2020', '2020-24', '397', '2', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '13.06');
INSERT INTO public.europe_data_import VALUES (2261, '08/06/2020', '2020-23', '262', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '7.69');
INSERT INTO public.europe_data_import VALUES (2262, '01/06/2020', '2020-22', '126', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '3.82');
INSERT INTO public.europe_data_import VALUES (2263, '25/05/2020', '2020-21', '67', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '2.73');
INSERT INTO public.europe_data_import VALUES (2264, '18/05/2020', '2020-20', '71', '4', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '2.46');
INSERT INTO public.europe_data_import VALUES (2265, '11/05/2020', '2020-19', '53', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '1.92');
INSERT INTO public.europe_data_import VALUES (2266, '04/05/2020', '2020-18', '44', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '1.57');
INSERT INTO public.europe_data_import VALUES (2267, '27/04/2020', '2020-17', '35', '2', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '1.98');
INSERT INTO public.europe_data_import VALUES (2268, '20/04/2020', '2020-16', '65', '1', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '4.08');
INSERT INTO public.europe_data_import VALUES (2269, '13/04/2020', '2020-15', '141', '1', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2270, '06/04/2020', '2020-14', '140', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '6.34');
INSERT INTO public.europe_data_import VALUES (2271, '30/03/2020', '2020-13', '180', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '5.53');
INSERT INTO public.europe_data_import VALUES (2272, '23/03/2020', '2020-12', '99', '2', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '2.56');
INSERT INTO public.europe_data_import VALUES (2273, '16/03/2020', '2020-11', '30', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '0.69');
INSERT INTO public.europe_data_import VALUES (2274, '09/03/2020', '2020-10', '5', '0', '5047561', 'Costa_Rica', 'CR', 'CRI', 'America', '');
INSERT INTO public.europe_data_import VALUES (2275, '01/02/2021', '2021-04', '844', '5', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '9.54');
INSERT INTO public.europe_data_import VALUES (2276, '25/01/2021', '2021-03', '1609', '5', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '12.05');
INSERT INTO public.europe_data_import VALUES (2277, '18/01/2021', '2021-02', '1491', '2', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '10.08');
INSERT INTO public.europe_data_import VALUES (2278, '11/01/2021', '2021-01', '1102', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '6.12');
INSERT INTO public.europe_data_import VALUES (2279, '04/01/2021', '2020-53', '472', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.84');
INSERT INTO public.europe_data_import VALUES (2280, '28/12/2020', '2020-52', '258', '4', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.93');
INSERT INTO public.europe_data_import VALUES (2281, '21/12/2020', '2020-51', '238', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.68');
INSERT INTO public.europe_data_import VALUES (2282, '14/12/2020', '2020-50', '195', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.44');
INSERT INTO public.europe_data_import VALUES (2283, '07/12/2020', '2020-49', '175', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.35');
INSERT INTO public.europe_data_import VALUES (2284, '30/11/2020', '2020-48', '172', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.3');
INSERT INTO public.europe_data_import VALUES (2285, '23/11/2020', '2020-47', '162', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.19');
INSERT INTO public.europe_data_import VALUES (2286, '16/11/2020', '2020-46', '144', '2', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.01');
INSERT INTO public.europe_data_import VALUES (2287, '09/11/2020', '2020-45', '116', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (2288, '02/11/2020', '2020-44', '246', '4', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.53');
INSERT INTO public.europe_data_import VALUES (2289, '26/10/2020', '2020-43', '147', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.23');
INSERT INTO public.europe_data_import VALUES (2290, '19/10/2020', '2020-42', '169', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.71');
INSERT INTO public.europe_data_import VALUES (2291, '12/10/2020', '2020-41', '272', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.04');
INSERT INTO public.europe_data_import VALUES (2292, '05/10/2020', '2020-40', '253', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.19');
INSERT INTO public.europe_data_import VALUES (2293, '28/09/2020', '2020-39', '309', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.4');
INSERT INTO public.europe_data_import VALUES (2294, '21/09/2020', '2020-38', '307', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.85');
INSERT INTO public.europe_data_import VALUES (2295, '14/09/2020', '2020-37', '425', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '4.14');
INSERT INTO public.europe_data_import VALUES (2296, '07/09/2020', '2020-36', '640', '4', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '4.34');
INSERT INTO public.europe_data_import VALUES (2297, '31/08/2020', '2020-35', '477', '2', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '3.59');
INSERT INTO public.europe_data_import VALUES (2298, '24/08/2020', '2020-34', '445', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.94');
INSERT INTO public.europe_data_import VALUES (2299, '17/08/2020', '2020-33', '311', '5', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '3.28');
INSERT INTO public.europe_data_import VALUES (2300, '10/08/2020', '2020-32', '533', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '4.35');
INSERT INTO public.europe_data_import VALUES (2301, '03/08/2020', '2020-31', '586', '6', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '8.02');
INSERT INTO public.europe_data_import VALUES (2302, '27/07/2020', '2020-30', '1477', '4', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '11.0');
INSERT INTO public.europe_data_import VALUES (2303, '20/07/2020', '2020-29', '1353', '8', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '13.01');
INSERT INTO public.europe_data_import VALUES (2304, '13/07/2020', '2020-28', '1994', '10', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '14.86');
INSERT INTO public.europe_data_import VALUES (2305, '06/07/2020', '2020-27', '1828', '8', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '12.75');
INSERT INTO public.europe_data_import VALUES (2306, '29/06/2020', '2020-26', '1452', '15', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '15.01');
INSERT INTO public.europe_data_import VALUES (2307, '22/06/2020', '2020-25', '2408', '6', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '14.59');
INSERT INTO public.europe_data_import VALUES (2308, '15/06/2020', '2020-24', '1345', '9', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '8.75');
INSERT INTO public.europe_data_import VALUES (2309, '08/06/2020', '2020-23', '906', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '5.3');
INSERT INTO public.europe_data_import VALUES (2310, '01/06/2020', '2020-22', '457', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.82');
INSERT INTO public.europe_data_import VALUES (2311, '25/05/2020', '2020-21', '267', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.63');
INSERT INTO public.europe_data_import VALUES (2312, '18/05/2020', '2020-20', '409', '6', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.76');
INSERT INTO public.europe_data_import VALUES (2313, '11/05/2020', '2020-19', '302', '4', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.14');
INSERT INTO public.europe_data_import VALUES (2314, '04/05/2020', '2020-18', '248', '3', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.14');
INSERT INTO public.europe_data_import VALUES (2315, '27/04/2020', '2020-17', '303', '5', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.24');
INSERT INTO public.europe_data_import VALUES (2316, '20/04/2020', '2020-16', '273', '4', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '2.28');
INSERT INTO public.europe_data_import VALUES (2317, '13/04/2020', '2020-15', '313', '2', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '1.59');
INSERT INTO public.europe_data_import VALUES (2318, '06/04/2020', '2020-14', '96', '2', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '0.92');
INSERT INTO public.europe_data_import VALUES (2319, '30/03/2020', '2020-13', '140', '1', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '0.63');
INSERT INTO public.europe_data_import VALUES (2320, '23/03/2020', '2020-12', '21', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (2321, '16/03/2020', '2020-11', '4', '0', '25716554', 'Cote_dIvoire', 'CI', 'CIV', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (2322, '01/02/2021', '2021-04', '3466', '195', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '181.34');
INSERT INTO public.europe_data_import VALUES (2323, '25/01/2021', '2021-03', '3926', '204', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '216.65');
INSERT INTO public.europe_data_import VALUES (2324, '18/01/2021', '2021-02', '4905', '252', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '298.56');
INSERT INTO public.europe_data_import VALUES (2325, '11/01/2021', '2021-01', '7265', '331', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '367.42');
INSERT INTO public.europe_data_import VALUES (2326, '04/01/2021', '2020-53', '7712', '333', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '422.69');
INSERT INTO public.europe_data_import VALUES (2327, '28/12/2020', '2020-52', '9518', '482', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '720.27');
INSERT INTO public.europe_data_import VALUES (2328, '21/12/2020', '2020-51', '19842', '617', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1113.16');
INSERT INTO public.europe_data_import VALUES (2329, '14/12/2020', '2020-50', '25533', '466', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1208.81');
INSERT INTO public.europe_data_import VALUES (2330, '07/12/2020', '2020-49', '23741', '462', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1144.07');
INSERT INTO public.europe_data_import VALUES (2331, '30/11/2020', '2020-48', '22894', '359', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1040.32');
INSERT INTO public.europe_data_import VALUES (2332, '23/11/2020', '2020-47', '19512', '304', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '894.72');
INSERT INTO public.europe_data_import VALUES (2333, '16/11/2020', '2020-46', '16959', '255', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '802.48');
INSERT INTO public.europe_data_import VALUES (2334, '09/11/2020', '2020-45', '15752', '232', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '757.24');
INSERT INTO public.europe_data_import VALUES (2335, '02/11/2020', '2020-44', '15115', '125', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '635.76');
INSERT INTO public.europe_data_import VALUES (2336, '26/10/2020', '2020-43', '10800', '74', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '391.05');
INSERT INTO public.europe_data_import VALUES (2337, '19/10/2020', '2020-42', '5140', '39', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '194.32');
INSERT INTO public.europe_data_import VALUES (2338, '12/10/2020', '2020-41', '2781', '26', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '104.09');
INSERT INTO public.europe_data_import VALUES (2339, '05/10/2020', '2020-40', '1462', '26', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '67.15');
INSERT INTO public.europe_data_import VALUES (2340, '28/09/2020', '2020-39', '1275', '24', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '65.35');
INSERT INTO public.europe_data_import VALUES (2341, '21/09/2020', '2020-38', '1389', '24', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '72.57');
INSERT INTO public.europe_data_import VALUES (2342, '14/09/2020', '2020-37', '1569', '26', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '83.66');
INSERT INTO public.europe_data_import VALUES (2343, '07/09/2020', '2020-36', '1841', '14', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '92.95');
INSERT INTO public.europe_data_import VALUES (2344, '31/08/2020', '2020-35', '1948', '13', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '87.14');
INSERT INTO public.europe_data_import VALUES (2345, '24/08/2020', '2020-34', '1604', '5', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '63.07');
INSERT INTO public.europe_data_import VALUES (2346, '17/08/2020', '2020-33', '967', '9', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '32.16');
INSERT INTO public.europe_data_import VALUES (2347, '10/08/2020', '2020-32', '344', '8', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '18.33');
INSERT INTO public.europe_data_import VALUES (2348, '03/08/2020', '2020-31', '403', '13', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '22.23');
INSERT INTO public.europe_data_import VALUES (2349, '27/07/2020', '2020-30', '503', '16', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '27.84');
INSERT INTO public.europe_data_import VALUES (2350, '20/07/2020', '2020-29', '632', '1', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '29.51');
INSERT INTO public.europe_data_import VALUES (2351, '13/07/2020', '2020-28', '571', '6', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '25.29');
INSERT INTO public.europe_data_import VALUES (2352, '06/07/2020', '2020-27', '460', '6', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '20.46');
INSERT INTO public.europe_data_import VALUES (2353, '29/06/2020', '2020-26', '374', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '10.77');
INSERT INTO public.europe_data_import VALUES (2354, '22/06/2020', '2020-25', '65', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1.72');
INSERT INTO public.europe_data_import VALUES (2355, '15/06/2020', '2020-24', '5', '3', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0.15');
INSERT INTO public.europe_data_import VALUES (2356, '08/06/2020', '2020-23', '1', '1', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0.07');
INSERT INTO public.europe_data_import VALUES (2357, '01/06/2020', '2020-22', '2', '4', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0.49');
INSERT INTO public.europe_data_import VALUES (2358, '25/05/2020', '2020-21', '18', '4', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1.4');
INSERT INTO public.europe_data_import VALUES (2359, '18/05/2020', '2020-20', '39', '5', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '3.19');
INSERT INTO public.europe_data_import VALUES (2360, '11/05/2020', '2020-19', '91', '11', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '3.85');
INSERT INTO public.europe_data_import VALUES (2361, '04/05/2020', '2020-18', '66', '24', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '5.52');
INSERT INTO public.europe_data_import VALUES (2362, '27/04/2020', '2020-17', '159', '8', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '10.55');
INSERT INTO public.europe_data_import VALUES (2363, '20/04/2020', '2020-16', '271', '24', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '16.9');
INSERT INTO public.europe_data_import VALUES (2364, '13/04/2020', '2020-15', '418', '8', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '21.76');
INSERT INTO public.europe_data_import VALUES (2365, '06/04/2020', '2020-14', '469', '9', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '23.23');
INSERT INTO public.europe_data_import VALUES (2366, '30/03/2020', '2020-13', '478', '6', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '16.31');
INSERT INTO public.europe_data_import VALUES (2367, '23/03/2020', '2020-12', '187', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '5.47');
INSERT INTO public.europe_data_import VALUES (2368, '16/03/2020', '2020-11', '36', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '1.01');
INSERT INTO public.europe_data_import VALUES (2369, '09/03/2020', '2020-10', '5', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0.29');
INSERT INTO public.europe_data_import VALUES (2370, '02/03/2020', '2020-09', '7', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0.17');
INSERT INTO public.europe_data_import VALUES (2371, '24/02/2020', '2020-08', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2372, '17/02/2020', '2020-07', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2373, '10/02/2020', '2020-06', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2374, '03/02/2020', '2020-05', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2375, '27/01/2020', '2020-04', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2376, '20/01/2020', '2020-03', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2377, '13/01/2020', '2020-02', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2378, '06/01/2020', '2020-01', '0', '0', '4076246', 'Croatia', 'HR', 'HRV', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (2379, '01/02/2021', '2021-04', '5764', '19', '11333484', 'Cuba', 'CU', 'CUB', 'America', '80.73');
INSERT INTO public.europe_data_import VALUES (2380, '25/01/2021', '2021-03', '3385', '24', '11333484', 'Cuba', 'CU', 'CUB', 'America', '60.18');
INSERT INTO public.europe_data_import VALUES (2381, '18/01/2021', '2021-02', '3436', '20', '11333484', 'Cuba', 'CU', 'CUB', 'America', '50.32');
INSERT INTO public.europe_data_import VALUES (2382, '11/01/2021', '2021-01', '2267', '6', '11333484', 'Cuba', 'CU', 'CUB', 'America', '31.53');
INSERT INTO public.europe_data_import VALUES (2383, '04/01/2021', '2020-53', '1306', '4', '11333484', 'Cuba', 'CU', 'CUB', 'America', '22.04');
INSERT INTO public.europe_data_import VALUES (2384, '28/12/2020', '2020-52', '1192', '6', '11333484', 'Cuba', 'CU', 'CUB', 'America', '17.74');
INSERT INTO public.europe_data_import VALUES (2385, '21/12/2020', '2020-51', '819', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '12.88');
INSERT INTO public.europe_data_import VALUES (2386, '14/12/2020', '2020-50', '641', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '10.5');
INSERT INTO public.europe_data_import VALUES (2387, '07/12/2020', '2020-49', '549', '2', '11333484', 'Cuba', 'CU', 'CUB', 'America', '8.26');
INSERT INTO public.europe_data_import VALUES (2388, '30/11/2020', '2020-48', '387', '2', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.67');
INSERT INTO public.europe_data_import VALUES (2389, '23/11/2020', '2020-47', '256', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '4.84');
INSERT INTO public.europe_data_import VALUES (2390, '16/11/2020', '2020-46', '293', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.78');
INSERT INTO public.europe_data_import VALUES (2391, '09/11/2020', '2020-45', '362', '2', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.45');
INSERT INTO public.europe_data_import VALUES (2392, '02/11/2020', '2020-44', '369', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.31');
INSERT INTO public.europe_data_import VALUES (2393, '26/10/2020', '2020-43', '346', '3', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.19');
INSERT INTO public.europe_data_import VALUES (2394, '19/10/2020', '2020-42', '242', '2', '11333484', 'Cuba', 'CU', 'CUB', 'America', '3.63');
INSERT INTO public.europe_data_import VALUES (2395, '12/10/2020', '2020-41', '169', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '4.6');
INSERT INTO public.europe_data_import VALUES (2396, '05/10/2020', '2020-40', '352', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.34');
INSERT INTO public.europe_data_import VALUES (2397, '28/09/2020', '2020-39', '366', '7', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.82');
INSERT INTO public.europe_data_import VALUES (2398, '21/09/2020', '2020-38', '407', '7', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.9');
INSERT INTO public.europe_data_import VALUES (2399, '14/09/2020', '2020-37', '375', '7', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.27');
INSERT INTO public.europe_data_import VALUES (2400, '07/09/2020', '2020-36', '336', '7', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.53');
INSERT INTO public.europe_data_import VALUES (2401, '31/08/2020', '2020-35', '291', '3', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.8');
INSERT INTO public.europe_data_import VALUES (2402, '24/08/2020', '2020-34', '366', '3', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.43');
INSERT INTO public.europe_data_import VALUES (2403, '17/08/2020', '2020-33', '363', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.91');
INSERT INTO public.europe_data_import VALUES (2404, '10/08/2020', '2020-32', '307', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '4.04');
INSERT INTO public.europe_data_import VALUES (2405, '03/08/2020', '2020-31', '151', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (2406, '27/07/2020', '2020-30', '49', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '0.61');
INSERT INTO public.europe_data_import VALUES (2407, '20/07/2020', '2020-29', '20', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '0.65');
INSERT INTO public.europe_data_import VALUES (2408, '13/07/2020', '2020-28', '54', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '0.83');
INSERT INTO public.europe_data_import VALUES (2409, '06/07/2020', '2020-27', '40', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '0.53');
INSERT INTO public.europe_data_import VALUES (2410, '29/06/2020', '2020-26', '20', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '0.74');
INSERT INTO public.europe_data_import VALUES (2411, '22/06/2020', '2020-25', '64', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.07');
INSERT INTO public.europe_data_import VALUES (2412, '15/06/2020', '2020-24', '57', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.79');
INSERT INTO public.europe_data_import VALUES (2413, '08/06/2020', '2020-23', '146', '0', '11333484', 'Cuba', 'CU', 'CUB', 'America', '2.21');
INSERT INTO public.europe_data_import VALUES (2414, '01/06/2020', '2020-22', '104', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.53');
INSERT INTO public.europe_data_import VALUES (2415, '25/05/2020', '2020-21', '69', '3', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.54');
INSERT INTO public.europe_data_import VALUES (2416, '18/05/2020', '2020-20', '106', '2', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.97');
INSERT INTO public.europe_data_import VALUES (2417, '11/05/2020', '2020-19', '117', '10', '11333484', 'Cuba', 'CU', 'CUB', 'America', '3.5');
INSERT INTO public.europe_data_import VALUES (2418, '04/05/2020', '2020-18', '280', '13', '11333484', 'Cuba', 'CU', 'CUB', 'America', '5.42');
INSERT INTO public.europe_data_import VALUES (2419, '27/04/2020', '2020-17', '334', '20', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.18');
INSERT INTO public.europe_data_import VALUES (2420, '20/04/2020', '2020-16', '366', '16', '11333484', 'Cuba', 'CU', 'CUB', 'America', '6.31');
INSERT INTO public.europe_data_import VALUES (2421, '13/04/2020', '2020-15', '349', '10', '11333484', 'Cuba', 'CU', 'CUB', 'America', '4.68');
INSERT INTO public.europe_data_import VALUES (2422, '06/04/2020', '2020-14', '181', '5', '11333484', 'Cuba', 'CU', 'CUB', 'America', '2.51');
INSERT INTO public.europe_data_import VALUES (2423, '30/03/2020', '2020-13', '104', '2', '11333484', 'Cuba', 'CU', 'CUB', 'America', '1.23');
INSERT INTO public.europe_data_import VALUES (2424, '23/03/2020', '2020-12', '35', '1', '11333484', 'Cuba', 'CU', 'CUB', 'America', '');
INSERT INTO public.europe_data_import VALUES (2425, '01/02/2021', '2021-04', '37', '1', '163423', 'Curaçao', 'CW', 'CUW', 'America', '39.77');
INSERT INTO public.europe_data_import VALUES (2426, '25/01/2021', '2021-03', '28', '1', '163423', 'Curaçao', 'CW', 'CUW', 'America', '51.4');
INSERT INTO public.europe_data_import VALUES (2427, '18/01/2021', '2021-02', '56', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '124.22');
INSERT INTO public.europe_data_import VALUES (2428, '11/01/2021', '2021-01', '147', '3', '163423', 'Curaçao', 'CW', 'CUW', 'America', '191.53');
INSERT INTO public.europe_data_import VALUES (2429, '04/01/2021', '2020-53', '166', '2', '163423', 'Curaçao', 'CW', 'CUW', 'America', '209.88');
INSERT INTO public.europe_data_import VALUES (2430, '28/12/2020', '2020-52', '177', '3', '163423', 'Curaçao', 'CW', 'CUW', 'America', '322.48');
INSERT INTO public.europe_data_import VALUES (2431, '21/12/2020', '2020-51', '350', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '512.78');
INSERT INTO public.europe_data_import VALUES (2432, '14/12/2020', '2020-50', '488', '4', '163423', 'Curaçao', 'CW', 'CUW', 'America', '771.01');
INSERT INTO public.europe_data_import VALUES (2433, '07/12/2020', '2020-49', '772', '3', '163423', 'Curaçao', 'CW', 'CUW', 'America', '848.72');
INSERT INTO public.europe_data_import VALUES (2434, '30/11/2020', '2020-48', '615', '1', '163423', 'Curaçao', 'CW', 'CUW', 'America', '626.59');
INSERT INTO public.europe_data_import VALUES (2435, '23/11/2020', '2020-47', '409', '1', '163423', 'Curaçao', 'CW', 'CUW', 'America', '398.96');
INSERT INTO public.europe_data_import VALUES (2436, '16/11/2020', '2020-46', '243', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '216.0');
INSERT INTO public.europe_data_import VALUES (2437, '09/11/2020', '2020-45', '110', '1', '163423', 'Curaçao', 'CW', 'CUW', 'America', '146.25');
INSERT INTO public.europe_data_import VALUES (2438, '02/11/2020', '2020-44', '129', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '148.69');
INSERT INTO public.europe_data_import VALUES (2439, '26/10/2020', '2020-43', '114', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '168.27');
INSERT INTO public.europe_data_import VALUES (2440, '19/10/2020', '2020-42', '161', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '178.68');
INSERT INTO public.europe_data_import VALUES (2441, '12/10/2020', '2020-41', '131', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '136.46');
INSERT INTO public.europe_data_import VALUES (2442, '05/10/2020', '2020-40', '92', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '112.59');
INSERT INTO public.europe_data_import VALUES (2443, '28/09/2020', '2020-39', '92', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '124.22');
INSERT INTO public.europe_data_import VALUES (2444, '21/09/2020', '2020-38', '111', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '107.7');
INSERT INTO public.europe_data_import VALUES (2445, '14/09/2020', '2020-37', '65', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '61.19');
INSERT INTO public.europe_data_import VALUES (2446, '07/09/2020', '2020-36', '35', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '29.98');
INSERT INTO public.europe_data_import VALUES (2447, '31/08/2020', '2020-35', '14', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '14.07');
INSERT INTO public.europe_data_import VALUES (2448, '24/08/2020', '2020-34', '9', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '7.34');
INSERT INTO public.europe_data_import VALUES (2449, '17/08/2020', '2020-33', '3', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '3.06');
INSERT INTO public.europe_data_import VALUES (2450, '10/08/2020', '2020-32', '2', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.22');
INSERT INTO public.europe_data_import VALUES (2451, '03/08/2020', '2020-31', '0', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '0.61');
INSERT INTO public.europe_data_import VALUES (2452, '27/07/2020', '2020-30', '1', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '2.45');
INSERT INTO public.europe_data_import VALUES (2453, '20/07/2020', '2020-29', '3', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.84');
INSERT INTO public.europe_data_import VALUES (2454, '13/07/2020', '2020-28', '0', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '0.61');
INSERT INTO public.europe_data_import VALUES (2455, '06/07/2020', '2020-27', '1', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.22');
INSERT INTO public.europe_data_import VALUES (2456, '29/06/2020', '2020-26', '1', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.22');
INSERT INTO public.europe_data_import VALUES (2457, '22/06/2020', '2020-25', '1', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.22');
INSERT INTO public.europe_data_import VALUES (2458, '15/06/2020', '2020-24', '1', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.84');
INSERT INTO public.europe_data_import VALUES (2459, '08/06/2020', '2020-23', '2', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '2.45');
INSERT INTO public.europe_data_import VALUES (2460, '01/06/2020', '2020-22', '2', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.84');
INSERT INTO public.europe_data_import VALUES (2461, '25/05/2020', '2020-21', '1', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '0.61');
INSERT INTO public.europe_data_import VALUES (2462, '18/05/2020', '2020-20', '0', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2463, '11/05/2020', '2020-19', '0', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2464, '04/05/2020', '2020-18', '0', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.22');
INSERT INTO public.europe_data_import VALUES (2465, '27/04/2020', '2020-17', '2', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.22');
INSERT INTO public.europe_data_import VALUES (2466, '20/04/2020', '2020-16', '0', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '1.84');
INSERT INTO public.europe_data_import VALUES (2467, '13/04/2020', '2020-15', '3', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '3.06');
INSERT INTO public.europe_data_import VALUES (2468, '06/04/2020', '2020-14', '2', '0', '163423', 'Curaçao', 'CW', 'CUW', 'America', '6.73');
INSERT INTO public.europe_data_import VALUES (2469, '30/03/2020', '2020-13', '9', '1', '163423', 'Curaçao', 'CW', 'CUW', 'America', '');
INSERT INTO public.europe_data_import VALUES (2470, '01/02/2021', '2021-04', '859', '13', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '217.83');
INSERT INTO public.europe_data_import VALUES (2471, '25/01/2021', '2021-03', '1049', '16', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '304.49');
INSERT INTO public.europe_data_import VALUES (2472, '18/01/2021', '2021-02', '1618', '22', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '570.16');
INSERT INTO public.europe_data_import VALUES (2473, '11/01/2021', '2021-01', '3376', '17', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '878.3');
INSERT INTO public.europe_data_import VALUES (2474, '04/01/2021', '2020-53', '4317', '19', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '717.66');
INSERT INTO public.europe_data_import VALUES (2475, '28/12/2020', '2020-52', '1969', '21', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '520.15');
INSERT INTO public.europe_data_import VALUES (2476, '21/12/2020', '2020-51', '2587', '13', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '597.9');
INSERT INTO public.europe_data_import VALUES (2477, '14/12/2020', '2020-50', '2650', '17', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '538.65');
INSERT INTO public.europe_data_import VALUES (2478, '07/12/2020', '2020-49', '2068', '13', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '434.75');
INSERT INTO public.europe_data_import VALUES (2479, '30/11/2020', '2020-48', '1740', '4', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '365.91');
INSERT INTO public.europe_data_import VALUES (2480, '23/11/2020', '2020-47', '1465', '4', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '303.23');
INSERT INTO public.europe_data_import VALUES (2481, '16/11/2020', '2020-46', '1191', '13', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '298.55');
INSERT INTO public.europe_data_import VALUES (2482, '09/11/2020', '2020-45', '1424', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '278.8');
INSERT INTO public.europe_data_import VALUES (2483, '02/11/2020', '2020-44', '1018', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '219.09');
INSERT INTO public.europe_data_import VALUES (2484, '26/10/2020', '2020-43', '901', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '177.99');
INSERT INTO public.europe_data_import VALUES (2485, '19/10/2020', '2020-42', '658', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '93.62');
INSERT INTO public.europe_data_import VALUES (2486, '12/10/2020', '2020-41', '162', '3', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '33.11');
INSERT INTO public.europe_data_import VALUES (2487, '05/10/2020', '2020-40', '128', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '25.57');
INSERT INTO public.europe_data_import VALUES (2488, '28/09/2020', '2020-39', '96', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '19.41');
INSERT INTO public.europe_data_import VALUES (2489, '21/09/2020', '2020-38', '74', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '10.39');
INSERT INTO public.europe_data_import VALUES (2490, '14/09/2020', '2020-37', '17', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '4.45');
INSERT INTO public.europe_data_import VALUES (2491, '07/09/2020', '2020-36', '22', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '10.05');
INSERT INTO public.europe_data_import VALUES (2492, '31/08/2020', '2020-35', '66', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '17.7');
INSERT INTO public.europe_data_import VALUES (2493, '24/08/2020', '2020-34', '89', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '20.44');
INSERT INTO public.europe_data_import VALUES (2494, '17/08/2020', '2020-33', '90', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '20.78');
INSERT INTO public.europe_data_import VALUES (2495, '10/08/2020', '2020-32', '92', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '21.12');
INSERT INTO public.europe_data_import VALUES (2496, '03/08/2020', '2020-31', '93', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '12.79');
INSERT INTO public.europe_data_import VALUES (2497, '27/07/2020', '2020-30', '19', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '4.11');
INSERT INTO public.europe_data_import VALUES (2498, '20/07/2020', '2020-29', '17', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '4.0');
INSERT INTO public.europe_data_import VALUES (2499, '13/07/2020', '2020-28', '18', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '3.08');
INSERT INTO public.europe_data_import VALUES (2500, '06/07/2020', '2020-27', '9', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '1.94');
INSERT INTO public.europe_data_import VALUES (2501, '29/06/2020', '2020-26', '8', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '1.26');
INSERT INTO public.europe_data_import VALUES (2502, '22/06/2020', '2020-25', '3', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '2.51');
INSERT INTO public.europe_data_import VALUES (2503, '15/06/2020', '2020-24', '19', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '4.45');
INSERT INTO public.europe_data_import VALUES (2504, '08/06/2020', '2020-23', '20', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '3.31');
INSERT INTO public.europe_data_import VALUES (2505, '01/06/2020', '2020-22', '9', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '3.2');
INSERT INTO public.europe_data_import VALUES (2506, '25/05/2020', '2020-21', '19', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '4.22');
INSERT INTO public.europe_data_import VALUES (2507, '18/05/2020', '2020-20', '18', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '5.02');
INSERT INTO public.europe_data_import VALUES (2508, '11/05/2020', '2020-19', '26', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '9.25');
INSERT INTO public.europe_data_import VALUES (2509, '04/05/2020', '2020-18', '55', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '11.99');
INSERT INTO public.europe_data_import VALUES (2510, '27/04/2020', '2020-17', '50', '2', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '21.01');
INSERT INTO public.europe_data_import VALUES (2511, '20/04/2020', '2020-16', '134', '1', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '36.65');
INSERT INTO public.europe_data_import VALUES (2512, '13/04/2020', '2020-15', '187', '2', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '47.84');
INSERT INTO public.europe_data_import VALUES (2513, '06/04/2020', '2020-14', '232', '3', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '40.07');
INSERT INTO public.europe_data_import VALUES (2514, '30/03/2020', '2020-13', '119', '6', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '21.01');
INSERT INTO public.europe_data_import VALUES (2515, '23/03/2020', '2020-12', '65', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '10.85');
INSERT INTO public.europe_data_import VALUES (2516, '16/03/2020', '2020-11', '30', '0', '875899', 'Cyprus', 'CY', 'CYP', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (2517, '01/02/2021', '2021-04', '47325', '939', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '896.51');
INSERT INTO public.europe_data_import VALUES (2518, '25/01/2021', '2021-03', '48152', '1004', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '981.71');
INSERT INTO public.europe_data_import VALUES (2519, '18/01/2021', '2021-02', '56398', '1177', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1362.82');
INSERT INTO public.europe_data_import VALUES (2520, '11/01/2021', '2021-01', '88740', '1202', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1512.84');
INSERT INTO public.europe_data_import VALUES (2521, '04/01/2021', '2020-53', '72374', '918', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1119.19');
INSERT INTO public.europe_data_import VALUES (2522, '28/12/2020', '2020-52', '46817', '741', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '875.71');
INSERT INTO public.europe_data_import VALUES (2523, '21/12/2020', '2020-51', '46444', '802', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '757.67');
INSERT INTO public.europe_data_import VALUES (2524, '14/12/2020', '2020-50', '34246', '707', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '576.12');
INSERT INTO public.europe_data_import VALUES (2525, '07/12/2020', '2020-49', '27110', '764', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '512.4');
INSERT INTO public.europe_data_import VALUES (2526, '30/11/2020', '2020-48', '27460', '942', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '559.7');
INSERT INTO public.europe_data_import VALUES (2527, '23/11/2020', '2020-47', '32147', '988', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '727.1');
INSERT INTO public.europe_data_import VALUES (2528, '16/11/2020', '2020-46', '45288', '1350', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1112.43');
INSERT INTO public.europe_data_import VALUES (2529, '09/11/2020', '2020-45', '73184', '1429', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1471.68');
INSERT INTO public.europe_data_import VALUES (2530, '02/11/2020', '2020-44', '83547', '1228', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1575.23');
INSERT INTO public.europe_data_import VALUES (2531, '26/10/2020', '2020-43', '84212', '779', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '1323.85');
INSERT INTO public.europe_data_import VALUES (2532, '19/10/2020', '2020-42', '56775', '388', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '858.6');
INSERT INTO public.europe_data_import VALUES (2533, '12/10/2020', '2020-41', '34664', '307', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '493.09');
INSERT INTO public.europe_data_import VALUES (2534, '05/10/2020', '2020-40', '17849', '121', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '311.8');
INSERT INTO public.europe_data_import VALUES (2535, '28/09/2020', '2020-39', '15357', '103', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '266.76');
INSERT INTO public.europe_data_import VALUES (2536, '21/09/2020', '2020-38', '13052', '47', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '197.98');
INSERT INTO public.europe_data_import VALUES (2537, '14/09/2020', '2020-37', '8032', '20', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '111.0');
INSERT INTO public.europe_data_import VALUES (2538, '07/09/2020', '2020-36', '3789', '13', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '58.53');
INSERT INTO public.europe_data_import VALUES (2539, '31/08/2020', '2020-35', '2444', '11', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '40.89');
INSERT INTO public.europe_data_import VALUES (2540, '24/08/2020', '2020-34', '1911', '15', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '33.5');
INSERT INTO public.europe_data_import VALUES (2541, '17/08/2020', '2020-33', '1657', '8', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '30.16');
INSERT INTO public.europe_data_import VALUES (2542, '10/08/2020', '2020-32', '1555', '6', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '28.46');
INSERT INTO public.europe_data_import VALUES (2543, '03/08/2020', '2020-31', '1476', '12', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '26.81');
INSERT INTO public.europe_data_import VALUES (2544, '27/07/2020', '2020-30', '1379', '12', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '20.19');
INSERT INTO public.europe_data_import VALUES (2545, '20/07/2020', '2020-29', '771', '7', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '13.43');
INSERT INTO public.europe_data_import VALUES (2546, '13/07/2020', '2020-28', '659', '4', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '14.75');
INSERT INTO public.europe_data_import VALUES (2547, '06/07/2020', '2020-27', '912', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '18.94');
INSERT INTO public.europe_data_import VALUES (2548, '29/06/2020', '2020-26', '1105', '12', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '14.83');
INSERT INTO public.europe_data_import VALUES (2549, '22/06/2020', '2020-25', '474', '7', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '8.17');
INSERT INTO public.europe_data_import VALUES (2550, '15/06/2020', '2020-24', '396', '2', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '7.05');
INSERT INTO public.europe_data_import VALUES (2551, '08/06/2020', '2020-23', '355', '7', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '6.3');
INSERT INTO public.europe_data_import VALUES (2552, '01/06/2020', '2020-22', '316', '5', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '7.49');
INSERT INTO public.europe_data_import VALUES (2553, '25/05/2020', '2020-21', '482', '18', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '7.83');
INSERT INTO public.europe_data_import VALUES (2554, '18/05/2020', '2020-20', '352', '17', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '6.52');
INSERT INTO public.europe_data_import VALUES (2555, '11/05/2020', '2020-19', '342', '32', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '6.75');
INSERT INTO public.europe_data_import VALUES (2556, '04/05/2020', '2020-18', '377', '27', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '9.33');
INSERT INTO public.europe_data_import VALUES (2557, '27/04/2020', '2020-17', '617', '33', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '13.27');
INSERT INTO public.europe_data_import VALUES (2558, '20/04/2020', '2020-16', '796', '50', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '20.66');
INSERT INTO public.europe_data_import VALUES (2559, '13/04/2020', '2020-15', '1404', '71', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '29.69');
INSERT INTO public.europe_data_import VALUES (2560, '06/04/2020', '2020-14', '1758', '51', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '32.13');
INSERT INTO public.europe_data_import VALUES (2561, '30/03/2020', '2020-13', '1664', '15', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '23.77');
INSERT INTO public.europe_data_import VALUES (2562, '23/03/2020', '2020-12', '867', '1', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '10.64');
INSERT INTO public.europe_data_import VALUES (2563, '16/03/2020', '2020-11', '266', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '2.77');
INSERT INTO public.europe_data_import VALUES (2564, '09/03/2020', '2020-10', '29', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0.3');
INSERT INTO public.europe_data_import VALUES (2565, '02/03/2020', '2020-09', '3', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0.03');
INSERT INTO public.europe_data_import VALUES (2566, '24/02/2020', '2020-08', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2567, '17/02/2020', '2020-07', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2568, '10/02/2020', '2020-06', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2569, '03/02/2020', '2020-05', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2570, '27/01/2020', '2020-04', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2571, '20/01/2020', '2020-03', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2572, '13/01/2020', '2020-02', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2573, '06/01/2020', '2020-01', '0', '0', '10649800', 'Czechia', 'CZ', 'CZE', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (2574, '01/02/2021', '2021-04', '888', '12', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.05');
INSERT INTO public.europe_data_import VALUES (2575, '25/01/2021', '2021-03', '895', '28', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.83');
INSERT INTO public.europe_data_import VALUES (2576, '18/01/2021', '2021-02', '1564', '15', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '3.35');
INSERT INTO public.europe_data_import VALUES (2577, '11/01/2021', '2021-01', '1343', '20', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.97');
INSERT INTO public.europe_data_import VALUES (2578, '04/01/2021', '2020-53', '1236', '20', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.7');
INSERT INTO public.europe_data_import VALUES (2579, '28/12/2020', '2020-52', '1107', '13', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.77');
INSERT INTO public.europe_data_import VALUES (2580, '21/12/2020', '2020-51', '1297', '210', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.55');
INSERT INTO public.europe_data_import VALUES (2581, '14/12/2020', '2020-50', '918', '12', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.09');
INSERT INTO public.europe_data_import VALUES (2582, '07/12/2020', '2020-49', '893', '11', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.56');
INSERT INTO public.europe_data_import VALUES (2583, '30/11/2020', '2020-48', '462', '5', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.05');
INSERT INTO public.europe_data_import VALUES (2584, '23/11/2020', '2020-47', '450', '8', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.73');
INSERT INTO public.europe_data_import VALUES (2585, '16/11/2020', '2020-46', '182', '4', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.48');
INSERT INTO public.europe_data_import VALUES (2586, '09/11/2020', '2020-45', '236', '8', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.54');
INSERT INTO public.europe_data_import VALUES (2587, '02/11/2020', '2020-44', '229', '3', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (2588, '26/10/2020', '2020-43', '91', '2', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (2589, '19/10/2020', '2020-42', '201', '27', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (2590, '12/10/2020', '2020-41', '91', '2', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (2591, '05/10/2020', '2020-40', '148', '3', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (2592, '28/09/2020', '2020-39', '97', '0', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (2593, '21/09/2020', '2020-38', '125', '6', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (2594, '14/09/2020', '2020-37', '180', '5', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (2595, '07/09/2020', '2020-36', '165', '2', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (2596, '31/08/2020', '2020-35', '215', '7', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.43');
INSERT INTO public.europe_data_import VALUES (2597, '24/08/2020', '2020-34', '154', '11', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.43');
INSERT INTO public.europe_data_import VALUES (2598, '17/08/2020', '2020-33', '222', '16', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.65');
INSERT INTO public.europe_data_import VALUES (2599, '10/08/2020', '2020-32', '339', '9', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (2600, '03/08/2020', '2020-31', '283', '10', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.82');
INSERT INTO public.europe_data_import VALUES (2601, '27/07/2020', '2020-30', '429', '11', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.92');
INSERT INTO public.europe_data_import VALUES (2602, '20/07/2020', '2020-29', '370', '5', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.14');
INSERT INTO public.europe_data_import VALUES (2603, '13/07/2020', '2020-28', '622', '7', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.39');
INSERT INTO public.europe_data_import VALUES (2604, '06/07/2020', '2020-27', '584', '24', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.83');
INSERT INTO public.europe_data_import VALUES (2605, '29/06/2020', '2020-26', '1000', '27', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.36');
INSERT INTO public.europe_data_import VALUES (2606, '22/06/2020', '2020-25', '1049', '24', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '2.09');
INSERT INTO public.europe_data_import VALUES (2607, '15/06/2020', '2020-24', '761', '21', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.99');
INSERT INTO public.europe_data_import VALUES (2608, '08/06/2020', '2020-23', '967', '14', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.98');
INSERT INTO public.europe_data_import VALUES (2609, '01/06/2020', '2020-22', '752', '4', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.84');
INSERT INTO public.europe_data_import VALUES (2610, '25/05/2020', '2020-21', '843', '7', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '1.47');
INSERT INTO public.europe_data_import VALUES (2611, '18/05/2020', '2020-20', '430', '19', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (2612, '11/05/2020', '2020-19', '340', '7', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.65');
INSERT INTO public.europe_data_import VALUES (2613, '04/05/2020', '2020-18', '225', '6', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (2614, '27/04/2020', '2020-17', '127', '3', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (2615, '20/04/2020', '2020-16', '98', '5', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.21');
INSERT INTO public.europe_data_import VALUES (2616, '13/04/2020', '2020-15', '80', '2', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (2617, '06/04/2020', '2020-14', '73', '10', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.15');
INSERT INTO public.europe_data_import VALUES (2618, '30/03/2020', '2020-13', '55', '6', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (2619, '23/03/2020', '2020-12', '24', '2', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (2620, '16/03/2020', '2020-11', '2', '0', '86790568', 'Democratic_Republic_of_the_Congo', 'CD', 'COD', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (2621, '01/02/2021', '2021-04', '3664', '135', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '156.13');
INSERT INTO public.europe_data_import VALUES (2622, '25/01/2021', '2021-03', '5401', '205', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '216.51');
INSERT INTO public.europe_data_import VALUES (2623, '18/01/2021', '2021-02', '7170', '208', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '364.86');
INSERT INTO public.europe_data_import VALUES (2624, '11/01/2021', '2021-01', '14014', '223', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '505.95');
INSERT INTO public.europe_data_import VALUES (2625, '04/01/2021', '2020-53', '15362', '170', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '590.36');
INSERT INTO public.europe_data_import VALUES (2626, '28/12/2020', '2020-52', '18915', '169', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '750.78');
INSERT INTO public.europe_data_import VALUES (2627, '21/12/2020', '2020-51', '24676', '94', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '754.92');
INSERT INTO public.europe_data_import VALUES (2628, '14/12/2020', '2020-50', '19155', '56', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '523.69');
INSERT INTO public.europe_data_import VALUES (2629, '07/12/2020', '2020-49', '11251', '56', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '346.5');
INSERT INTO public.europe_data_import VALUES (2630, '30/11/2020', '2020-48', '8867', '45', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '296.52');
INSERT INTO public.europe_data_import VALUES (2631, '23/11/2020', '2020-47', '8349', '24', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '264.62');
INSERT INTO public.europe_data_import VALUES (2632, '16/11/2020', '2020-46', '7015', '17', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '255.54');
INSERT INTO public.europe_data_import VALUES (2633, '09/11/2020', '2020-45', '7822', '20', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '254.3');
INSERT INTO public.europe_data_import VALUES (2634, '02/11/2020', '2020-44', '6943', '21', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '205.08');
INSERT INTO public.europe_data_import VALUES (2635, '26/10/2020', '2020-43', '4964', '22', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '136.65');
INSERT INTO public.europe_data_import VALUES (2636, '19/10/2020', '2020-42', '2970', '11', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '98.38');
INSERT INTO public.europe_data_import VALUES (2637, '12/10/2020', '2020-41', '2742', '11', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '99.64');
INSERT INTO public.europe_data_import VALUES (2638, '05/10/2020', '2020-40', '3043', '9', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '134.91');
INSERT INTO public.europe_data_import VALUES (2639, '28/09/2020', '2020-39', '4790', '14', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '127.81');
INSERT INTO public.europe_data_import VALUES (2640, '21/09/2020', '2020-38', '2631', '6', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '74.06');
INSERT INTO public.europe_data_import VALUES (2641, '14/09/2020', '2020-37', '1669', '2', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '43.33');
INSERT INTO public.europe_data_import VALUES (2642, '07/09/2020', '2020-36', '847', '3', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '24.46');
INSERT INTO public.europe_data_import VALUES (2643, '31/08/2020', '2020-35', '573', '3', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '18.65');
INSERT INTO public.europe_data_import VALUES (2644, '24/08/2020', '2020-34', '510', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '29.02');
INSERT INTO public.europe_data_import VALUES (2645, '17/08/2020', '2020-33', '1175', '4', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '31.48');
INSERT INTO public.europe_data_import VALUES (2646, '10/08/2020', '2020-32', '653', '2', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '17.29');
INSERT INTO public.europe_data_import VALUES (2647, '03/08/2020', '2020-31', '351', '2', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '10.61');
INSERT INTO public.europe_data_import VALUES (2648, '27/07/2020', '2020-30', '265', '2', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '8.47');
INSERT INTO public.europe_data_import VALUES (2649, '20/07/2020', '2020-29', '227', '2', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '5.87');
INSERT INTO public.europe_data_import VALUES (2650, '13/07/2020', '2020-28', '114', '3', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '4.67');
INSERT INTO public.europe_data_import VALUES (2651, '06/07/2020', '2020-27', '157', '2', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '7.6');
INSERT INTO public.europe_data_import VALUES (2652, '29/06/2020', '2020-26', '284', '4', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '8.3');
INSERT INTO public.europe_data_import VALUES (2653, '22/06/2020', '2020-25', '198', '3', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '7.63');
INSERT INTO public.europe_data_import VALUES (2654, '15/06/2020', '2020-24', '245', '8', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '9.03');
INSERT INTO public.europe_data_import VALUES (2655, '08/06/2020', '2020-23', '279', '15', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '10.13');
INSERT INTO public.europe_data_import VALUES (2656, '01/06/2020', '2020-22', '309', '12', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '12.78');
INSERT INTO public.europe_data_import VALUES (2657, '25/05/2020', '2020-21', '433', '15', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '16.03');
INSERT INTO public.europe_data_import VALUES (2658, '18/05/2020', '2020-20', '498', '28', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '24.18');
INSERT INTO public.europe_data_import VALUES (2659, '11/05/2020', '2020-19', '906', '38', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '31.93');
INSERT INTO public.europe_data_import VALUES (2660, '04/05/2020', '2020-18', '948', '59', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '36.84');
INSERT INTO public.europe_data_import VALUES (2661, '27/04/2020', '2020-17', '1191', '67', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '41.35');
INSERT INTO public.europe_data_import VALUES (2662, '20/04/2020', '2020-16', '1210', '82', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '51.93');
INSERT INTO public.europe_data_import VALUES (2663, '13/04/2020', '2020-15', '1805', '94', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '65.09');
INSERT INTO public.europe_data_import VALUES (2664, '06/04/2020', '2020-14', '1974', '107', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '51.22');
INSERT INTO public.europe_data_import VALUES (2665, '30/03/2020', '2020-13', '1000', '59', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '26.18');
INSERT INTO public.europe_data_import VALUES (2666, '23/03/2020', '2020-12', '520', '12', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '23.37');
INSERT INTO public.europe_data_import VALUES (2667, '16/03/2020', '2020-11', '837', '1', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '15.0');
INSERT INTO public.europe_data_import VALUES (2668, '09/03/2020', '2020-10', '34', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0.65');
INSERT INTO public.europe_data_import VALUES (2669, '02/03/2020', '2020-09', '4', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0.07');
INSERT INTO public.europe_data_import VALUES (2670, '24/02/2020', '2020-08', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2671, '17/02/2020', '2020-07', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2672, '10/02/2020', '2020-06', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2673, '03/02/2020', '2020-05', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2674, '27/01/2020', '2020-04', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2675, '20/01/2020', '2020-03', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2676, '13/01/2020', '2020-02', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (2677, '06/01/2020', '2020-01', '0', '0', '5806081', 'Denmark', 'DK', 'DNK', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (2678, '01/02/2021', '2021-04', '13', '2', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '2.77');
INSERT INTO public.europe_data_import VALUES (2679, '25/01/2021', '2021-03', '14', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '4.93');
INSERT INTO public.europe_data_import VALUES (2680, '18/01/2021', '2021-02', '34', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '6.47');
INSERT INTO public.europe_data_import VALUES (2681, '11/01/2021', '2021-01', '29', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '5.96');
INSERT INTO public.europe_data_import VALUES (2682, '04/01/2021', '2020-53', '29', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '6.27');
INSERT INTO public.europe_data_import VALUES (2683, '28/12/2020', '2020-52', '32', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '8.73');
INSERT INTO public.europe_data_import VALUES (2684, '21/12/2020', '2020-51', '53', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '8.22');
INSERT INTO public.europe_data_import VALUES (2685, '14/12/2020', '2020-50', '27', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '5.24');
INSERT INTO public.europe_data_import VALUES (2686, '07/12/2020', '2020-49', '24', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '3.39');
INSERT INTO public.europe_data_import VALUES (2687, '30/11/2020', '2020-48', '9', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '2.88');
INSERT INTO public.europe_data_import VALUES (2688, '23/11/2020', '2020-47', '19', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '6.16');
INSERT INTO public.europe_data_import VALUES (2689, '16/11/2020', '2020-46', '41', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '8.83');
INSERT INTO public.europe_data_import VALUES (2690, '09/11/2020', '2020-45', '45', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '7.4');
INSERT INTO public.europe_data_import VALUES (2691, '02/11/2020', '2020-44', '27', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '10.68');
INSERT INTO public.europe_data_import VALUES (2692, '26/10/2020', '2020-43', '77', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '11.61');
INSERT INTO public.europe_data_import VALUES (2693, '19/10/2020', '2020-42', '36', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '4.11');
INSERT INTO public.europe_data_import VALUES (2694, '12/10/2020', '2020-41', '4', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.44');
INSERT INTO public.europe_data_import VALUES (2695, '05/10/2020', '2020-40', '10', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.64');
INSERT INTO public.europe_data_import VALUES (2696, '28/09/2020', '2020-39', '6', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.44');
INSERT INTO public.europe_data_import VALUES (2697, '21/09/2020', '2020-38', '8', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.54');
INSERT INTO public.europe_data_import VALUES (2698, '14/09/2020', '2020-37', '7', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (2699, '07/09/2020', '2020-36', '3', '1', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (2700, '31/08/2020', '2020-35', '3', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.64');
INSERT INTO public.europe_data_import VALUES (2701, '24/08/2020', '2020-34', '13', '1', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '3.9');
INSERT INTO public.europe_data_import VALUES (2702, '17/08/2020', '2020-33', '25', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '21.36');
INSERT INTO public.europe_data_import VALUES (2703, '10/08/2020', '2020-32', '183', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '30.2');
INSERT INTO public.europe_data_import VALUES (2704, '03/08/2020', '2020-31', '111', '1', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '15.41');
INSERT INTO public.europe_data_import VALUES (2705, '27/07/2020', '2020-30', '39', '2', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '8.01');
INSERT INTO public.europe_data_import VALUES (2706, '20/07/2020', '2020-29', '39', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '22.49');
INSERT INTO public.europe_data_import VALUES (2707, '13/07/2020', '2020-28', '180', '1', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '33.79');
INSERT INTO public.europe_data_import VALUES (2708, '06/07/2020', '2020-27', '149', '3', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '21.57');
INSERT INTO public.europe_data_import VALUES (2709, '29/06/2020', '2020-26', '61', '7', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '18.28');
INSERT INTO public.europe_data_import VALUES (2710, '22/06/2020', '2020-25', '117', '2', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '38.52');
INSERT INTO public.europe_data_import VALUES (2711, '15/06/2020', '2020-24', '258', '15', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '114.12');
INSERT INTO public.europe_data_import VALUES (2712, '08/06/2020', '2020-23', '853', '4', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '198.96');
INSERT INTO public.europe_data_import VALUES (2713, '01/06/2020', '2020-22', '1084', '14', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '200.6');
INSERT INTO public.europe_data_import VALUES (2714, '25/05/2020', '2020-21', '869', '6', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '108.88');
INSERT INTO public.europe_data_import VALUES (2715, '18/05/2020', '2020-20', '191', '1', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '29.68');
INSERT INTO public.europe_data_import VALUES (2716, '11/05/2020', '2020-19', '98', '1', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '19.21');
INSERT INTO public.europe_data_import VALUES (2717, '04/05/2020', '2020-18', '89', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '27.32');
INSERT INTO public.europe_data_import VALUES (2718, '27/04/2020', '2020-17', '177', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '83.1');
INSERT INTO public.europe_data_import VALUES (2719, '20/04/2020', '2020-16', '632', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '80.84');
INSERT INTO public.europe_data_import VALUES (2720, '13/04/2020', '2020-15', '155', '2', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '20.03');
INSERT INTO public.europe_data_import VALUES (2721, '06/04/2020', '2020-14', '40', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '5.96');
INSERT INTO public.europe_data_import VALUES (2722, '30/03/2020', '2020-13', '18', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '1.95');
INSERT INTO public.europe_data_import VALUES (2723, '23/03/2020', '2020-12', '1', '0', '973557', 'Djibouti', 'DJ', 'DJI', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (2724, '01/02/2021', '2021-04', '4', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2725, '25/01/2021', '2021-03', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2726, '18/01/2021', '2021-02', '4', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '23.67');
INSERT INTO public.europe_data_import VALUES (2727, '11/01/2021', '2021-01', '13', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '23.67');
INSERT INTO public.europe_data_import VALUES (2728, '04/01/2021', '2020-53', '4', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2729, '28/12/2020', '2020-52', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2730, '21/12/2020', '2020-51', '4', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '9.75');
INSERT INTO public.europe_data_import VALUES (2731, '14/12/2020', '2020-50', '3', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '4.18');
INSERT INTO public.europe_data_import VALUES (2732, '07/12/2020', '2020-49', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '11.14');
INSERT INTO public.europe_data_import VALUES (2733, '30/11/2020', '2020-48', '8', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '23.67');
INSERT INTO public.europe_data_import VALUES (2734, '23/11/2020', '2020-47', '9', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '48.74');
INSERT INTO public.europe_data_import VALUES (2735, '16/11/2020', '2020-46', '26', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '36.21');
INSERT INTO public.europe_data_import VALUES (2736, '09/11/2020', '2020-45', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2737, '02/11/2020', '2020-44', '4', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '12.53');
INSERT INTO public.europe_data_import VALUES (2738, '26/10/2020', '2020-43', '5', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '8.36');
INSERT INTO public.europe_data_import VALUES (2739, '19/10/2020', '2020-42', '1', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (2740, '12/10/2020', '2020-41', '1', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '11.14');
INSERT INTO public.europe_data_import VALUES (2741, '05/10/2020', '2020-40', '7', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '9.75');
INSERT INTO public.europe_data_import VALUES (2742, '28/09/2020', '2020-39', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2743, '21/09/2020', '2020-38', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2744, '14/09/2020', '2020-37', '4', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '5.57');
INSERT INTO public.europe_data_import VALUES (2745, '07/09/2020', '2020-36', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '1.39');
INSERT INTO public.europe_data_import VALUES (2746, '31/08/2020', '2020-35', '1', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (2747, '24/08/2020', '2020-34', '1', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '1.39');
INSERT INTO public.europe_data_import VALUES (2748, '17/08/2020', '2020-33', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2749, '10/08/2020', '2020-32', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2750, '03/08/2020', '2020-31', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2751, '27/07/2020', '2020-30', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2752, '20/07/2020', '2020-29', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2753, '13/07/2020', '2020-28', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2754, '06/07/2020', '2020-27', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2755, '29/06/2020', '2020-26', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2756, '22/06/2020', '2020-25', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2757, '15/06/2020', '2020-24', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (2758, '08/06/2020', '2020-23', '2', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (2759, '01/06/2020', '2020-22', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2760, '25/05/2020', '2020-21', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2761, '18/05/2020', '2020-20', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2762, '11/05/2020', '2020-19', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2763, '04/05/2020', '2020-18', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2764, '27/04/2020', '2020-17', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2765, '20/04/2020', '2020-16', '0', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '2.79');
INSERT INTO public.europe_data_import VALUES (2766, '13/04/2020', '2020-15', '2', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '6.96');
INSERT INTO public.europe_data_import VALUES (2767, '06/04/2020', '2020-14', '3', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '18.1');
INSERT INTO public.europe_data_import VALUES (2768, '30/03/2020', '2020-13', '10', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '15.32');
INSERT INTO public.europe_data_import VALUES (2769, '23/03/2020', '2020-12', '1', '0', '71808', 'Dominica', 'DM', 'DMA', 'America', '');
INSERT INTO public.europe_data_import VALUES (2770, '01/02/2021', '2021-04', '9924', '143', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '187.36');
INSERT INTO public.europe_data_import VALUES (2771, '25/01/2021', '2021-03', '10196', '97', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '203.74');
INSERT INTO public.europe_data_import VALUES (2772, '18/01/2021', '2021-02', '11684', '21', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '201.46');
INSERT INTO public.europe_data_import VALUES (2773, '11/01/2021', '2021-01', '9951', '9', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '147.84');
INSERT INTO public.europe_data_import VALUES (2774, '04/01/2021', '2020-53', '5926', '14', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '114.34');
INSERT INTO public.europe_data_import VALUES (2775, '28/12/2020', '2020-52', '6353', '19', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '118.38');
INSERT INTO public.europe_data_import VALUES (2776, '21/12/2020', '2020-51', '6360', '24', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '117.32');
INSERT INTO public.europe_data_import VALUES (2777, '14/12/2020', '2020-50', '6239', '16', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '104.47');
INSERT INTO public.europe_data_import VALUES (2778, '07/12/2020', '2020-49', '4980', '15', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '93.52');
INSERT INTO public.europe_data_import VALUES (2779, '30/11/2020', '2020-48', '5063', '20', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '90.78');
INSERT INTO public.europe_data_import VALUES (2780, '23/11/2020', '2020-47', '4686', '25', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '76.62');
INSERT INTO public.europe_data_import VALUES (2781, '16/11/2020', '2020-46', '3542', '20', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '59.52');
INSERT INTO public.europe_data_import VALUES (2782, '09/11/2020', '2020-45', '2850', '16', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '52.66');
INSERT INTO public.europe_data_import VALUES (2783, '02/11/2020', '2020-44', '2805', '26', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '55.73');
INSERT INTO public.europe_data_import VALUES (2784, '26/10/2020', '2020-43', '3180', '24', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '56.34');
INSERT INTO public.europe_data_import VALUES (2785, '19/10/2020', '2020-42', '2870', '26', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '63.94');
INSERT INTO public.europe_data_import VALUES (2786, '12/10/2020', '2020-41', '3997', '39', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '66.03');
INSERT INTO public.europe_data_import VALUES (2787, '05/10/2020', '2020-40', '3094', '39', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '57.65');
INSERT INTO public.europe_data_import VALUES (2788, '28/09/2020', '2020-39', '3097', '48', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '71.94');
INSERT INTO public.europe_data_import VALUES (2789, '21/09/2020', '2020-38', '4629', '79', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '83.4');
INSERT INTO public.europe_data_import VALUES (2790, '14/09/2020', '2020-37', '4327', '123', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '87.71');
INSERT INTO public.europe_data_import VALUES (2791, '07/09/2020', '2020-36', '5092', '164', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '76.1');
INSERT INTO public.europe_data_import VALUES (2792, '31/08/2020', '2020-35', '3080', '114', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '73.86');
INSERT INTO public.europe_data_import VALUES (2793, '24/08/2020', '2020-34', '4852', '114', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '106.43');
INSERT INTO public.europe_data_import VALUES (2794, '17/08/2020', '2020-33', '6577', '144', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '130.98');
INSERT INTO public.europe_data_import VALUES (2795, '10/08/2020', '2020-32', '7489', '131', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '156.66');
INSERT INTO public.europe_data_import VALUES (2796, '03/08/2020', '2020-31', '9335', '115', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '180.54');
INSERT INTO public.europe_data_import VALUES (2797, '27/07/2020', '2020-30', '10053', '82', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '171.12');
INSERT INTO public.europe_data_import VALUES (2798, '20/07/2020', '2020-29', '8323', '84', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '143.68');
INSERT INTO public.europe_data_import VALUES (2799, '13/07/2020', '2020-28', '7107', '103', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '122.54');
INSERT INTO public.europe_data_import VALUES (2800, '06/07/2020', '2020-27', '6052', '68', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '100.08');
INSERT INTO public.europe_data_import VALUES (2801, '29/06/2020', '2020-26', '4696', '64', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '78.32');
INSERT INTO public.europe_data_import VALUES (2802, '22/06/2020', '2020-25', '3715', '70', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '65.9');
INSERT INTO public.europe_data_import VALUES (2803, '15/06/2020', '2020-24', '3362', '54', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '52.86');
INSERT INTO public.europe_data_import VALUES (2804, '08/06/2020', '2020-23', '2315', '36', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '48.22');
INSERT INTO public.europe_data_import VALUES (2805, '01/06/2020', '2020-22', '2863', '44', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '46.29');
INSERT INTO public.europe_data_import VALUES (2806, '25/05/2020', '2020-21', '2108', '30', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '37.95');
INSERT INTO public.europe_data_import VALUES (2807, '18/05/2020', '2020-20', '1967', '40', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '40.6');
INSERT INTO public.europe_data_import VALUES (2808, '11/05/2020', '2020-19', '2393', '55', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '39.22');
INSERT INTO public.europe_data_import VALUES (2809, '04/05/2020', '2020-18', '1819', '55', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '30.49');
INSERT INTO public.europe_data_import VALUES (2810, '27/04/2020', '2020-17', '1455', '52', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '29.5');
INSERT INTO public.europe_data_import VALUES (2811, '20/04/2020', '2020-16', '1713', '53', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '27.33');
INSERT INTO public.europe_data_import VALUES (2812, '13/04/2020', '2020-15', '1222', '91', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '19.63');
INSERT INTO public.europe_data_import VALUES (2813, '06/04/2020', '2020-14', '886', '43', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '14.37');
INSERT INTO public.europe_data_import VALUES (2814, '30/03/2020', '2020-13', '657', '36', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '7.9');
INSERT INTO public.europe_data_import VALUES (2815, '23/03/2020', '2020-12', '191', '3', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '1.86');
INSERT INTO public.europe_data_import VALUES (2816, '16/03/2020', '2020-11', '9', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0.09');
INSERT INTO public.europe_data_import VALUES (2817, '09/03/2020', '2020-10', '1', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0.02');
INSERT INTO public.europe_data_import VALUES (2818, '02/03/2020', '2020-09', '1', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (2819, '24/02/2020', '2020-08', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2820, '17/02/2020', '2020-07', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2821, '10/02/2020', '2020-06', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2822, '03/02/2020', '2020-05', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2823, '27/01/2020', '2020-04', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2824, '20/01/2020', '2020-03', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2825, '13/01/2020', '2020-02', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2826, '06/01/2020', '2020-01', '0', '0', '10738957', 'Dominican_Republic', 'DO', 'DOM', 'America', '');
INSERT INTO public.europe_data_import VALUES (2827, '01/02/2021', '2021-04', '9419', '251', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '111.33');
INSERT INTO public.europe_data_import VALUES (2828, '25/01/2021', '2021-03', '9923', '317', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '115.47');
INSERT INTO public.europe_data_import VALUES (2829, '18/01/2021', '2021-02', '10138', '138', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '98.02');
INSERT INTO public.europe_data_import VALUES (2830, '11/01/2021', '2021-01', '6892', '125', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '67.62');
INSERT INTO public.europe_data_import VALUES (2831, '04/01/2021', '2020-53', '4856', '65', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '47.69');
INSERT INTO public.europe_data_import VALUES (2832, '28/12/2020', '2020-52', '3429', '45', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '44.02');
INSERT INTO public.europe_data_import VALUES (2833, '21/12/2020', '2020-51', '4219', '74', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '47.95');
INSERT INTO public.europe_data_import VALUES (2834, '14/12/2020', '2020-50', '4112', '97', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '57.52');
INSERT INTO public.europe_data_import VALUES (2835, '07/12/2020', '2020-49', '5881', '355', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '71.11');
INSERT INTO public.europe_data_import VALUES (2836, '30/11/2020', '2020-48', '6474', '222', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '68.05');
INSERT INTO public.europe_data_import VALUES (2837, '23/11/2020', '2020-47', '5348', '193', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '61.79');
INSERT INTO public.europe_data_import VALUES (2838, '16/11/2020', '2020-46', '5388', '178', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '63.9');
INSERT INTO public.europe_data_import VALUES (2839, '09/11/2020', '2020-45', '5713', '146', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '76.39');
INSERT INTO public.europe_data_import VALUES (2840, '02/11/2020', '2020-44', '7559', '131', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '91.55');
INSERT INTO public.europe_data_import VALUES (2841, '26/10/2020', '2020-43', '8346', '166', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '84.05');
INSERT INTO public.europe_data_import VALUES (2842, '19/10/2020', '2020-42', '6256', '196', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '70.54');
INSERT INTO public.europe_data_import VALUES (2843, '12/10/2020', '2020-41', '5999', '544', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '70.72');
INSERT INTO public.europe_data_import VALUES (2844, '05/10/2020', '2020-40', '6287', '368', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '84.12');
INSERT INTO public.europe_data_import VALUES (2845, '28/09/2020', '2020-39', '8328', '189', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '92.97');
INSERT INTO public.europe_data_import VALUES (2846, '21/09/2020', '2020-38', '7825', '187', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '95.75');
INSERT INTO public.europe_data_import VALUES (2847, '14/09/2020', '2020-37', '8810', '379', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '28.47');
INSERT INTO public.europe_data_import VALUES (2848, '07/09/2020', '2020-36', '-3864', '3969', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '11.6');
INSERT INTO public.europe_data_import VALUES (2849, '31/08/2020', '2020-35', '5879', '245', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '69.68');
INSERT INTO public.europe_data_import VALUES (2850, '24/08/2020', '2020-34', '6227', '240', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '76.61');
INSERT INTO public.europe_data_import VALUES (2851, '17/08/2020', '2020-33', '7083', '148', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '86.44');
INSERT INTO public.europe_data_import VALUES (2852, '10/08/2020', '2020-32', '7935', '172', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '79.23');
INSERT INTO public.europe_data_import VALUES (2853, '03/08/2020', '2020-31', '5830', '235', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '72.01');
INSERT INTO public.europe_data_import VALUES (2854, '27/07/2020', '2020-30', '6681', '202', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '73.81');
INSERT INTO public.europe_data_import VALUES (2855, '20/07/2020', '2020-29', '6143', '266', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '69.39');
INSERT INTO public.europe_data_import VALUES (2856, '13/07/2020', '2020-28', '5912', '266', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '72.61');
INSERT INTO public.europe_data_import VALUES (2857, '06/07/2020', '2020-27', '6703', '352', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '65.14');
INSERT INTO public.europe_data_import VALUES (2858, '29/06/2020', '2020-26', '4615', '206', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '48.95');
INSERT INTO public.europe_data_import VALUES (2859, '22/06/2020', '2020-25', '3889', '327', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '43.28');
INSERT INTO public.europe_data_import VALUES (2860, '15/06/2020', '2020-24', '3631', '275', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '44.05');
INSERT INTO public.europe_data_import VALUES (2861, '08/06/2020', '2020-23', '4022', '263', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '36.63');
INSERT INTO public.europe_data_import VALUES (2862, '01/06/2020', '2020-22', '2342', '250', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '34.05');
INSERT INTO public.europe_data_import VALUES (2863, '25/05/2020', '2020-21', '3574', '372', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '41.42');
INSERT INTO public.europe_data_import VALUES (2864, '18/05/2020', '2020-20', '3623', '609', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '20.97');
INSERT INTO public.europe_data_import VALUES (2865, '11/05/2020', '2020-19', '21', '563', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '39.37');
INSERT INTO public.europe_data_import VALUES (2866, '04/05/2020', '2020-18', '6819', '988', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '115.52');
INSERT INTO public.europe_data_import VALUES (2867, '27/04/2020', '2020-17', '13251', '102', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '87.79');
INSERT INTO public.europe_data_import VALUES (2868, '20/04/2020', '2020-16', '2002', '141', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '33.51');
INSERT INTO public.europe_data_import VALUES (2869, '13/04/2020', '2020-15', '3820', '153', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '32.09');
INSERT INTO public.europe_data_import VALUES (2870, '06/04/2020', '2020-14', '1756', '122', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '16.44');
INSERT INTO public.europe_data_import VALUES (2871, '30/03/2020', '2020-13', '1101', '44', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '10.67');
INSERT INTO public.europe_data_import VALUES (2872, '23/03/2020', '2020-12', '752', '12', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '4.46');
INSERT INTO public.europe_data_import VALUES (2873, '16/03/2020', '2020-11', '23', '2', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0.18');
INSERT INTO public.europe_data_import VALUES (2874, '09/03/2020', '2020-10', '8', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0.08');
INSERT INTO public.europe_data_import VALUES (2875, '02/03/2020', '2020-09', '6', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0.03');
INSERT INTO public.europe_data_import VALUES (2876, '24/02/2020', '2020-08', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2877, '17/02/2020', '2020-07', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2878, '10/02/2020', '2020-06', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2879, '03/02/2020', '2020-05', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2880, '27/01/2020', '2020-04', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2881, '20/01/2020', '2020-03', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2882, '13/01/2020', '2020-02', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '0');
INSERT INTO public.europe_data_import VALUES (2883, '06/01/2020', '2020-01', '0', '0', '17373657', 'Ecuador', 'EC', 'ECU', 'America', '');
INSERT INTO public.europe_data_import VALUES (2884, '01/02/2021', '2021-04', '4134', '357', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '9.52');
INSERT INTO public.europe_data_import VALUES (2885, '25/01/2021', '2021-03', '5420', '376', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '11.98');
INSERT INTO public.europe_data_import VALUES (2886, '18/01/2021', '2021-02', '6605', '386', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '14.16');
INSERT INTO public.europe_data_import VALUES (2887, '11/01/2021', '2021-01', '7605', '392', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '17.18');
INSERT INTO public.europe_data_import VALUES (2888, '04/01/2021', '2020-53', '9646', '400', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '16.57');
INSERT INTO public.europe_data_import VALUES (2889, '28/12/2020', '2020-52', '6986', '307', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '10.92');
INSERT INTO public.europe_data_import VALUES (2890, '21/12/2020', '2020-51', '3980', '178', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '7.1');
INSERT INTO public.europe_data_import VALUES (2891, '14/12/2020', '2020-50', '3143', '149', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '6.01');
INSERT INTO public.europe_data_import VALUES (2892, '07/12/2020', '2020-49', '2891', '135', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '5.38');
INSERT INTO public.europe_data_import VALUES (2893, '30/11/2020', '2020-48', '2514', '88', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '4.76');
INSERT INTO public.europe_data_import VALUES (2894, '23/11/2020', '2020-47', '2260', '95', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '3.81');
INSERT INTO public.europe_data_import VALUES (2895, '16/11/2020', '2020-46', '1566', '85', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '3.02');
INSERT INTO public.europe_data_import VALUES (2896, '09/11/2020', '2020-45', '1465', '90', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.65');
INSERT INTO public.europe_data_import VALUES (2897, '02/11/2020', '2020-44', '1196', '79', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.3');
INSERT INTO public.europe_data_import VALUES (2898, '26/10/2020', '2020-43', '1116', '79', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.14');
INSERT INTO public.europe_data_import VALUES (2899, '19/10/2020', '2020-42', '1037', '80', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.73');
INSERT INTO public.europe_data_import VALUES (2900, '12/10/2020', '2020-41', '704', '59', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.54');
INSERT INTO public.europe_data_import VALUES (2901, '05/10/2020', '2020-40', '843', '98', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.66');
INSERT INTO public.europe_data_import VALUES (2902, '28/09/2020', '2020-39', '825', '113', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.82');
INSERT INTO public.europe_data_import VALUES (2903, '21/09/2020', '2020-38', '1006', '122', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.14');
INSERT INTO public.europe_data_import VALUES (2904, '14/09/2020', '2020-37', '1146', '118', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.27');
INSERT INTO public.europe_data_import VALUES (2905, '07/09/2020', '2020-36', '1136', '131', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.62');
INSERT INTO public.europe_data_import VALUES (2906, '31/08/2020', '2020-35', '1490', '156', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.24');
INSERT INTO public.europe_data_import VALUES (2907, '24/08/2020', '2020-34', '762', '83', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.74');
INSERT INTO public.europe_data_import VALUES (2908, '17/08/2020', '2020-33', '983', '151', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.98');
INSERT INTO public.europe_data_import VALUES (2909, '10/08/2020', '2020-32', '1009', '144', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '3.42');
INSERT INTO public.europe_data_import VALUES (2910, '03/08/2020', '2020-31', '2421', '259', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '6.68');
INSERT INTO public.europe_data_import VALUES (2911, '27/07/2020', '2020-30', '4287', '304', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '9.95');
INSERT INTO public.europe_data_import VALUES (2912, '20/07/2020', '2020-29', '5705', '444', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '12.47');
INSERT INTO public.europe_data_import VALUES (2913, '13/07/2020', '2020-28', '6817', '515', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '16.82');
INSERT INTO public.europe_data_import VALUES (2914, '06/07/2020', '2020-27', '10065', '554', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '19.94');
INSERT INTO public.europe_data_import VALUES (2915, '29/06/2020', '2020-26', '9955', '596', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '20.51');
INSERT INTO public.europe_data_import VALUES (2916, '22/06/2020', '2020-25', '10635', '618', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '21.07');
INSERT INTO public.europe_data_import VALUES (2917, '15/06/2020', '2020-24', '10519', '338', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '19.54');
INSERT INTO public.europe_data_import VALUES (2918, '08/06/2020', '2020-23', '9094', '278', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '16.75');
INSERT INTO public.europe_data_import VALUES (2919, '01/06/2020', '2020-22', '7720', '195', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '12.71');
INSERT INTO public.europe_data_import VALUES (2920, '25/05/2020', '2020-21', '5036', '134', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '7.83');
INSERT INTO public.europe_data_import VALUES (2921, '18/05/2020', '2020-20', '2829', '105', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '5.74');
INSERT INTO public.europe_data_import VALUES (2922, '11/05/2020', '2020-19', '2935', '96', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '5.06');
INSERT INTO public.europe_data_import VALUES (2923, '04/05/2020', '2020-18', '2146', '122', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '3.31');
INSERT INTO public.europe_data_import VALUES (2924, '27/04/2020', '2020-17', '1175', '68', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.25');
INSERT INTO public.europe_data_import VALUES (2925, '20/04/2020', '2020-16', '1079', '80', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '2.07');
INSERT INTO public.europe_data_import VALUES (2926, '13/04/2020', '2020-15', '995', '88', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '1.48');
INSERT INTO public.europe_data_import VALUES (2927, '06/04/2020', '2020-14', '494', '35', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.77');
INSERT INTO public.europe_data_import VALUES (2928, '30/03/2020', '2020-13', '282', '26', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.46');
INSERT INTO public.europe_data_import VALUES (2929, '23/03/2020', '2020-12', '184', '8', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (2930, '16/03/2020', '2020-11', '61', '1', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (2931, '09/03/2020', '2020-10', '47', '1', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (2932, '02/03/2020', '2020-09', '1', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (2933, '24/02/2020', '2020-08', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (2934, '17/02/2020', '2020-07', '1', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (2935, '10/02/2020', '2020-06', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (2936, '03/02/2020', '2020-05', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (2937, '27/01/2020', '2020-04', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (2938, '20/01/2020', '2020-03', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (2939, '13/01/2020', '2020-02', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (2940, '06/01/2020', '2020-01', '0', '0', '100388076', 'Egypt', 'EG', 'EGY', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (2941, '01/02/2021', '2021-04', '1716', '49', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '58.23');
INSERT INTO public.europe_data_import VALUES (2942, '25/01/2021', '2021-03', '2042', '85', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '70.88');
INSERT INTO public.europe_data_import VALUES (2943, '18/01/2021', '2021-02', '2532', '70', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '67.4');
INSERT INTO public.europe_data_import VALUES (2944, '11/01/2021', '2021-01', '1818', '64', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '66.41');
INSERT INTO public.europe_data_import VALUES (2945, '04/01/2021', '2020-53', '2468', '51', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '51.37');
INSERT INTO public.europe_data_import VALUES (2946, '28/12/2020', '2020-52', '847', '56', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '42.44');
INSERT INTO public.europe_data_import VALUES (2947, '21/12/2020', '2020-51', '1892', '52', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '53.1');
INSERT INTO public.europe_data_import VALUES (2948, '14/12/2020', '2020-50', '1535', '41', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '53.85');
INSERT INTO public.europe_data_import VALUES (2949, '07/12/2020', '2020-49', '1940', '50', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '43.12');
INSERT INTO public.europe_data_import VALUES (2950, '30/11/2020', '2020-48', '843', '33', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '31.72');
INSERT INTO public.europe_data_import VALUES (2951, '23/11/2020', '2020-47', '1204', '34', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '37.45');
INSERT INTO public.europe_data_import VALUES (2952, '16/11/2020', '2020-46', '1213', '33', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '36.31');
INSERT INTO public.europe_data_import VALUES (2953, '09/11/2020', '2020-45', '1130', '31', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '39.67');
INSERT INTO public.europe_data_import VALUES (2954, '02/11/2020', '2020-44', '1430', '30', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '36.4');
INSERT INTO public.europe_data_import VALUES (2955, '26/10/2020', '2020-43', '919', '31', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '37.02');
INSERT INTO public.europe_data_import VALUES (2956, '19/10/2020', '2020-42', '1470', '28', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '34.34');
INSERT INTO public.europe_data_import VALUES (2957, '12/10/2020', '2020-41', '746', '31', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '24.27');
INSERT INTO public.europe_data_import VALUES (2958, '05/10/2020', '2020-40', '820', '37', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '29.39');
INSERT INTO public.europe_data_import VALUES (2959, '28/09/2020', '2020-39', '1077', '14', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '25.12');
INSERT INTO public.europe_data_import VALUES (2960, '21/09/2020', '2020-38', '544', '24', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '19.29');
INSERT INTO public.europe_data_import VALUES (2961, '14/09/2020', '2020-37', '701', '24', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '19.83');
INSERT INTO public.europe_data_import VALUES (2962, '07/09/2020', '2020-36', '579', '47', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '26.13');
INSERT INTO public.europe_data_import VALUES (2963, '31/08/2020', '2020-35', '1107', '48', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '43.65');
INSERT INTO public.europe_data_import VALUES (2964, '24/08/2020', '2020-34', '1710', '51', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '65.06');
INSERT INTO public.europe_data_import VALUES (2965, '17/08/2020', '2020-33', '2489', '55', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '84.67');
INSERT INTO public.europe_data_import VALUES (2966, '10/08/2020', '2020-32', '2975', '96', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '89.76');
INSERT INTO public.europe_data_import VALUES (2967, '03/08/2020', '2020-31', '2818', '59', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '86.8');
INSERT INTO public.europe_data_import VALUES (2968, '27/07/2020', '2020-30', '2784', '64', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '76.79');
INSERT INTO public.europe_data_import VALUES (2969, '20/07/2020', '2020-29', '2172', '77', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '63.05');
INSERT INTO public.europe_data_import VALUES (2970, '13/07/2020', '2020-28', '1897', '50', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '57.95');
INSERT INTO public.europe_data_import VALUES (2971, '06/07/2020', '2020-27', '1843', '53', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '48.83');
INSERT INTO public.europe_data_import VALUES (2972, '29/06/2020', '2020-26', '1308', '57', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '34.31');
INSERT INTO public.europe_data_import VALUES (2973, '22/06/2020', '2020-25', '906', '33', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '24.96');
INSERT INTO public.europe_data_import VALUES (2974, '15/06/2020', '2020-24', '705', '19', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '18.64');
INSERT INTO public.europe_data_import VALUES (2975, '08/06/2020', '2020-23', '498', '9', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '17.04');
INSERT INTO public.europe_data_import VALUES (2976, '01/06/2020', '2020-22', '602', '11', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '18.27');
INSERT INTO public.europe_data_import VALUES (2977, '25/05/2020', '2020-21', '577', '5', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '14.83');
INSERT INTO public.europe_data_import VALUES (2978, '18/05/2020', '2020-20', '380', '13', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '12.13');
INSERT INTO public.europe_data_import VALUES (2979, '11/05/2020', '2020-19', '403', '5', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '10.23');
INSERT INTO public.europe_data_import VALUES (2980, '04/05/2020', '2020-18', '257', '4', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '5.49');
INSERT INTO public.europe_data_import VALUES (2981, '27/04/2020', '2020-17', '97', '1', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '2.68');
INSERT INTO public.europe_data_import VALUES (2982, '20/04/2020', '2020-16', '76', '1', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '2.05');
INSERT INTO public.europe_data_import VALUES (2983, '13/04/2020', '2020-15', '56', '3', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '1.47');
INSERT INTO public.europe_data_import VALUES (2984, '06/04/2020', '2020-14', '39', '3', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '1.02');
INSERT INTO public.europe_data_import VALUES (2985, '30/03/2020', '2020-13', '27', '0', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '0.46');
INSERT INTO public.europe_data_import VALUES (2986, '23/03/2020', '2020-12', '3', '0', '6453550', 'El_Salvador', 'SV', 'SLV', 'America', '');
INSERT INTO public.europe_data_import VALUES (2987, '01/02/2021', '2021-04', '80', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '12.46');
INSERT INTO public.europe_data_import VALUES (2988, '25/01/2021', '2021-03', '89', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '11.65');
INSERT INTO public.europe_data_import VALUES (2989, '18/01/2021', '2021-02', '69', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '6.34');
INSERT INTO public.europe_data_import VALUES (2990, '11/01/2021', '2021-01', '17', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.54');
INSERT INTO public.europe_data_import VALUES (2991, '04/01/2021', '2020-53', '31', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.54');
INSERT INTO public.europe_data_import VALUES (2992, '28/12/2020', '2020-52', '17', '1', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.91');
INSERT INTO public.europe_data_import VALUES (2993, '21/12/2020', '2020-51', '36', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '4.79');
INSERT INTO public.europe_data_import VALUES (2994, '14/12/2020', '2020-50', '29', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.1');
INSERT INTO public.europe_data_import VALUES (2995, '07/12/2020', '2020-49', '13', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '2.65');
INSERT INTO public.europe_data_import VALUES (2996, '30/11/2020', '2020-48', '23', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.61');
INSERT INTO public.europe_data_import VALUES (2997, '23/11/2020', '2020-47', '26', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '2.8');
INSERT INTO public.europe_data_import VALUES (2998, '16/11/2020', '2020-46', '12', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '1.11');
INSERT INTO public.europe_data_import VALUES (2999, '09/11/2020', '2020-45', '3', '2', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (3000, '02/11/2020', '2020-44', '10', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '1.4');
INSERT INTO public.europe_data_import VALUES (3001, '26/10/2020', '2020-43', '9', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '1.18');
INSERT INTO public.europe_data_import VALUES (3002, '19/10/2020', '2020-42', '7', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '1.84');
INSERT INTO public.europe_data_import VALUES (3003, '12/10/2020', '2020-41', '18', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '2.58');
INSERT INTO public.europe_data_import VALUES (3004, '05/10/2020', '2020-40', '17', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.17');
INSERT INTO public.europe_data_import VALUES (3005, '28/09/2020', '2020-39', '26', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '2.36');
INSERT INTO public.europe_data_import VALUES (3006, '21/09/2020', '2020-38', '6', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '2.21');
INSERT INTO public.europe_data_import VALUES (3007, '14/09/2020', '2020-37', '24', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '4.06');
INSERT INTO public.europe_data_import VALUES (3008, '07/09/2020', '2020-36', '31', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '3.39');
INSERT INTO public.europe_data_import VALUES (3009, '31/08/2020', '2020-35', '15', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '8.85');
INSERT INTO public.europe_data_import VALUES (3010, '24/08/2020', '2020-34', '105', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '7.74');
INSERT INTO public.europe_data_import VALUES (3011, '17/08/2020', '2020-33', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3012, '10/08/2020', '2020-32', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '129.06');
INSERT INTO public.europe_data_import VALUES (3013, '03/08/2020', '2020-31', '1750', '32', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '129.06');
INSERT INTO public.europe_data_import VALUES (3014, '27/07/2020', '2020-30', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3015, '20/07/2020', '2020-29', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3016, '13/07/2020', '2020-28', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '78.91');
INSERT INTO public.europe_data_import VALUES (3017, '06/07/2020', '2020-27', '1070', '19', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '103.76');
INSERT INTO public.europe_data_import VALUES (3018, '29/06/2020', '2020-26', '337', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '51.25');
INSERT INTO public.europe_data_import VALUES (3019, '22/06/2020', '2020-25', '358', '20', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '26.4');
INSERT INTO public.europe_data_import VALUES (3020, '15/06/2020', '2020-24', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3021, '08/06/2020', '2020-23', '0', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '19.4');
INSERT INTO public.europe_data_import VALUES (3022, '01/06/2020', '2020-22', '263', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '52.51');
INSERT INTO public.europe_data_import VALUES (3023, '25/05/2020', '2020-21', '449', '5', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '44.54');
INSERT INTO public.europe_data_import VALUES (3024, '18/05/2020', '2020-20', '155', '3', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '20.58');
INSERT INTO public.europe_data_import VALUES (3025, '11/05/2020', '2020-19', '124', '3', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '13.35');
INSERT INTO public.europe_data_import VALUES (3026, '04/05/2020', '2020-18', '57', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '17.4');
INSERT INTO public.europe_data_import VALUES (3027, '27/04/2020', '2020-17', '179', '1', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '17.48');
INSERT INTO public.europe_data_import VALUES (3028, '20/04/2020', '2020-16', '58', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '4.65');
INSERT INTO public.europe_data_import VALUES (3029, '13/04/2020', '2020-15', '5', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (3030, '06/04/2020', '2020-14', '2', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0.74');
INSERT INTO public.europe_data_import VALUES (3031, '30/03/2020', '2020-13', '8', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (3032, '23/03/2020', '2020-12', '5', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (3033, '16/03/2020', '2020-11', '1', '0', '1355982', 'Equatorial_Guinea', 'GQ', 'GNQ', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3034, '01/02/2021', '2021-04', '185', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '7.38');
INSERT INTO public.europe_data_import VALUES (3035, '25/01/2021', '2021-03', '73', '1', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '11.27');
INSERT INTO public.europe_data_import VALUES (3036, '18/01/2021', '2021-02', '321', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '14.7');
INSERT INTO public.europe_data_import VALUES (3037, '11/01/2021', '2021-01', '193', '3', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '14.78');
INSERT INTO public.europe_data_import VALUES (3038, '04/01/2021', '2020-53', '324', '2', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '15.9');
INSERT INTO public.europe_data_import VALUES (3039, '28/12/2020', '2020-52', '232', '1', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '9.38');
INSERT INTO public.europe_data_import VALUES (3040, '21/12/2020', '2020-51', '96', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '5.0');
INSERT INTO public.europe_data_import VALUES (3041, '14/12/2020', '2020-50', '79', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '3.83');
INSERT INTO public.europe_data_import VALUES (3042, '07/12/2020', '2020-49', '55', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '2.32');
INSERT INTO public.europe_data_import VALUES (3043, '30/11/2020', '2020-48', '26', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '2.4');
INSERT INTO public.europe_data_import VALUES (3044, '23/11/2020', '2020-47', '58', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.72');
INSERT INTO public.europe_data_import VALUES (3045, '16/11/2020', '2020-46', '2', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.86');
INSERT INTO public.europe_data_import VALUES (3046, '09/11/2020', '2020-45', '28', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.86');
INSERT INTO public.europe_data_import VALUES (3047, '02/11/2020', '2020-44', '2', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.09');
INSERT INTO public.europe_data_import VALUES (3048, '26/10/2020', '2020-43', '36', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.34');
INSERT INTO public.europe_data_import VALUES (3049, '19/10/2020', '2020-42', '11', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.77');
INSERT INTO public.europe_data_import VALUES (3050, '12/10/2020', '2020-41', '16', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.12');
INSERT INTO public.europe_data_import VALUES (3051, '05/10/2020', '2020-40', '23', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.97');
INSERT INTO public.europe_data_import VALUES (3052, '28/09/2020', '2020-39', '11', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (3053, '21/09/2020', '2020-38', '3', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.97');
INSERT INTO public.europe_data_import VALUES (3054, '14/09/2020', '2020-37', '31', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.23');
INSERT INTO public.europe_data_import VALUES (3055, '07/09/2020', '2020-36', '12', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (3056, '31/08/2020', '2020-35', '12', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.94');
INSERT INTO public.europe_data_import VALUES (3057, '24/08/2020', '2020-34', '21', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (3058, '17/08/2020', '2020-33', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (3059, '10/08/2020', '2020-32', '6', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.63');
INSERT INTO public.europe_data_import VALUES (3060, '03/08/2020', '2020-31', '16', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.8');
INSERT INTO public.europe_data_import VALUES (3061, '27/07/2020', '2020-30', '12', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (3062, '20/07/2020', '2020-29', '19', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (3063, '13/07/2020', '2020-28', '17', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.17');
INSERT INTO public.europe_data_import VALUES (3064, '06/07/2020', '2020-27', '24', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '2.06');
INSERT INTO public.europe_data_import VALUES (3065, '29/06/2020', '2020-26', '48', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '2.72');
INSERT INTO public.europe_data_import VALUES (3066, '22/06/2020', '2020-25', '47', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '2.92');
INSERT INTO public.europe_data_import VALUES (3067, '15/06/2020', '2020-24', '55', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '1.63');
INSERT INTO public.europe_data_import VALUES (3068, '08/06/2020', '2020-23', '2', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (3069, '01/06/2020', '2020-22', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3070, '25/05/2020', '2020-21', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3071, '18/05/2020', '2020-20', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3072, '11/05/2020', '2020-19', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3073, '04/05/2020', '2020-18', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (3074, '27/04/2020', '2020-17', '0', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (3075, '20/04/2020', '2020-16', '5', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.29');
INSERT INTO public.europe_data_import VALUES (3076, '13/04/2020', '2020-15', '5', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.63');
INSERT INTO public.europe_data_import VALUES (3077, '06/04/2020', '2020-14', '17', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.8');
INSERT INTO public.europe_data_import VALUES (3078, '30/03/2020', '2020-13', '11', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (3079, '23/03/2020', '2020-12', '1', '0', '3497117', 'Eritrea', 'ER', 'ERI', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3080, '01/02/2021', '2021-04', '3492', '43', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '518.11');
INSERT INTO public.europe_data_import VALUES (3081, '25/01/2021', '2021-03', '3372', '43', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '521.66');
INSERT INTO public.europe_data_import VALUES (3082, '18/01/2021', '2021-02', '3539', '46', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '590.5');
INSERT INTO public.europe_data_import VALUES (3083, '11/01/2021', '2021-01', '4284', '36', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '603.63');
INSERT INTO public.europe_data_import VALUES (3084, '04/01/2021', '2020-53', '3713', '38', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '583.25');
INSERT INTO public.europe_data_import VALUES (3085, '28/12/2020', '2020-52', '4014', '39', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '585.21');
INSERT INTO public.europe_data_import VALUES (3086, '21/12/2020', '2020-51', '3739', '25', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '514.48');
INSERT INTO public.europe_data_import VALUES (3087, '14/12/2020', '2020-50', '3077', '18', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '453.12');
INSERT INTO public.europe_data_import VALUES (3088, '07/12/2020', '2020-49', '2926', '19', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '396.58');
INSERT INTO public.europe_data_import VALUES (3089, '30/11/2020', '2020-48', '2328', '24', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '333.25');
INSERT INTO public.europe_data_import VALUES (3090, '23/11/2020', '2020-47', '2087', '7', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '271.66');
INSERT INTO public.europe_data_import VALUES (3091, '16/11/2020', '2020-46', '1512', '6', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '200.18');
INSERT INTO public.europe_data_import VALUES (3092, '09/11/2020', '2020-45', '1140', '2', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '129.38');
INSERT INTO public.europe_data_import VALUES (3093, '02/11/2020', '2020-44', '574', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '68.46');
INSERT INTO public.europe_data_import VALUES (3094, '26/10/2020', '2020-43', '333', '5', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '41.21');
INSERT INTO public.europe_data_import VALUES (3095, '19/10/2020', '2020-42', '213', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '35.55');
INSERT INTO public.europe_data_import VALUES (3096, '12/10/2020', '2020-41', '258', '1', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '50.2');
INSERT INTO public.europe_data_import VALUES (3097, '05/10/2020', '2020-40', '407', '3', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '51.55');
INSERT INTO public.europe_data_import VALUES (3098, '28/09/2020', '2020-39', '276', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '39.55');
INSERT INTO public.europe_data_import VALUES (3099, '21/09/2020', '2020-38', '248', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '30.87');
INSERT INTO public.europe_data_import VALUES (3100, '14/09/2020', '2020-37', '161', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '22.87');
INSERT INTO public.europe_data_import VALUES (3101, '07/09/2020', '2020-36', '142', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '18.34');
INSERT INTO public.europe_data_import VALUES (3102, '31/08/2020', '2020-35', '101', '1', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '13.81');
INSERT INTO public.europe_data_import VALUES (3103, '24/08/2020', '2020-34', '82', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '9.06');
INSERT INTO public.europe_data_import VALUES (3104, '17/08/2020', '2020-33', '38', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '8.38');
INSERT INTO public.europe_data_import VALUES (3105, '10/08/2020', '2020-32', '73', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '8.91');
INSERT INTO public.europe_data_import VALUES (3106, '03/08/2020', '2020-31', '45', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '4.38');
INSERT INTO public.europe_data_import VALUES (3107, '27/07/2020', '2020-30', '13', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '1.51');
INSERT INTO public.europe_data_import VALUES (3108, '20/07/2020', '2020-29', '7', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '2.11');
INSERT INTO public.europe_data_import VALUES (3109, '13/07/2020', '2020-28', '21', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '2.04');
INSERT INTO public.europe_data_import VALUES (3110, '06/07/2020', '2020-27', '6', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0.91');
INSERT INTO public.europe_data_import VALUES (3111, '29/06/2020', '2020-26', '6', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '1.06');
INSERT INTO public.europe_data_import VALUES (3112, '22/06/2020', '2020-25', '8', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '3.17');
INSERT INTO public.europe_data_import VALUES (3113, '15/06/2020', '2020-24', '34', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '7.85');
INSERT INTO public.europe_data_import VALUES (3114, '08/06/2020', '2020-23', '70', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '8.76');
INSERT INTO public.europe_data_import VALUES (3115, '01/06/2020', '2020-22', '46', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '7.17');
INSERT INTO public.europe_data_import VALUES (3116, '25/05/2020', '2020-21', '49', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '6.34');
INSERT INTO public.europe_data_import VALUES (3117, '18/05/2020', '2020-20', '35', '3', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '5.59');
INSERT INTO public.europe_data_import VALUES (3118, '11/05/2020', '2020-19', '39', '5', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '7.25');
INSERT INTO public.europe_data_import VALUES (3119, '04/05/2020', '2020-18', '57', '6', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '12.98');
INSERT INTO public.europe_data_import VALUES (3120, '27/04/2020', '2020-17', '115', '9', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '25.21');
INSERT INTO public.europe_data_import VALUES (3121, '20/04/2020', '2020-16', '219', '15', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '32.53');
INSERT INTO public.europe_data_import VALUES (3122, '13/04/2020', '2020-15', '212', '10', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '47.55');
INSERT INTO public.europe_data_import VALUES (3123, '06/04/2020', '2020-14', '418', '12', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '58.2');
INSERT INTO public.europe_data_import VALUES (3124, '30/03/2020', '2020-13', '353', '3', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '38.34');
INSERT INTO public.europe_data_import VALUES (3125, '23/03/2020', '2020-12', '155', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '23.85');
INSERT INTO public.europe_data_import VALUES (3126, '16/03/2020', '2020-11', '161', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '12.83');
INSERT INTO public.europe_data_import VALUES (3127, '09/03/2020', '2020-10', '9', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0.75');
INSERT INTO public.europe_data_import VALUES (3128, '02/03/2020', '2020-09', '1', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0.08');
INSERT INTO public.europe_data_import VALUES (3129, '24/02/2020', '2020-08', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3130, '17/02/2020', '2020-07', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3131, '10/02/2020', '2020-06', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3132, '03/02/2020', '2020-05', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3133, '27/01/2020', '2020-04', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3134, '20/01/2020', '2020-03', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3135, '13/01/2020', '2020-02', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3136, '06/01/2020', '2020-01', '0', '0', '1324820', 'Estonia', 'EE', 'EST', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3137, '01/02/2021', '2021-04', '2860', '198', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '249.1');
INSERT INTO public.europe_data_import VALUES (3138, '25/01/2021', '2021-03', '0', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '107.39');
INSERT INTO public.europe_data_import VALUES (3139, '18/01/2021', '2021-02', '1233', '78', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '261.38');
INSERT INTO public.europe_data_import VALUES (3140, '11/01/2021', '2021-01', '1768', '67', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '263.38');
INSERT INTO public.europe_data_import VALUES (3141, '04/01/2021', '2020-53', '1256', '64', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '219.14');
INSERT INTO public.europe_data_import VALUES (3142, '28/12/2020', '2020-52', '1260', '27', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '167.14');
INSERT INTO public.europe_data_import VALUES (3143, '21/12/2020', '2020-51', '659', '13', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '80.65');
INSERT INTO public.europe_data_import VALUES (3144, '14/12/2020', '2020-50', '267', '5', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '31.18');
INSERT INTO public.europe_data_import VALUES (3145, '07/12/2020', '2020-49', '91', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '24.56');
INSERT INTO public.europe_data_import VALUES (3146, '30/11/2020', '2020-48', '191', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '27.44');
INSERT INTO public.europe_data_import VALUES (3147, '23/11/2020', '2020-47', '124', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '18.81');
INSERT INTO public.europe_data_import VALUES (3148, '16/11/2020', '2020-46', '92', '2', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '14.81');
INSERT INTO public.europe_data_import VALUES (3149, '09/11/2020', '2020-45', '78', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '12.98');
INSERT INTO public.europe_data_import VALUES (3150, '02/11/2020', '2020-44', '71', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '12.63');
INSERT INTO public.europe_data_import VALUES (3151, '26/10/2020', '2020-43', '74', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '16.11');
INSERT INTO public.europe_data_import VALUES (3152, '19/10/2020', '2020-42', '111', '3', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '18.38');
INSERT INTO public.europe_data_import VALUES (3153, '12/10/2020', '2020-41', '100', '2', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '20.73');
INSERT INTO public.europe_data_import VALUES (3154, '05/10/2020', '2020-40', '138', '3', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '26.13');
INSERT INTO public.europe_data_import VALUES (3155, '28/09/2020', '2020-39', '162', '4', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '31.01');
INSERT INTO public.europe_data_import VALUES (3156, '21/09/2020', '2020-38', '194', '6', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '36.23');
INSERT INTO public.europe_data_import VALUES (3157, '14/09/2020', '2020-37', '222', '4', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '44.77');
INSERT INTO public.europe_data_import VALUES (3158, '07/09/2020', '2020-36', '292', '3', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '54.7');
INSERT INTO public.europe_data_import VALUES (3159, '31/08/2020', '2020-35', '336', '6', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '62.88');
INSERT INTO public.europe_data_import VALUES (3160, '24/08/2020', '2020-34', '386', '15', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '86.14');
INSERT INTO public.europe_data_import VALUES (3161, '17/08/2020', '2020-33', '603', '12', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '92.67');
INSERT INTO public.europe_data_import VALUES (3162, '10/08/2020', '2020-32', '461', '15', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '89.62');
INSERT INTO public.europe_data_import VALUES (3163, '03/08/2020', '2020-31', '568', '11', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '85.53');
INSERT INTO public.europe_data_import VALUES (3164, '27/07/2020', '2020-30', '414', '11', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '74.56');
INSERT INTO public.europe_data_import VALUES (3165, '20/07/2020', '2020-29', '442', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '70.11');
INSERT INTO public.europe_data_import VALUES (3166, '13/07/2020', '2020-28', '363', '7', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '49.65');
INSERT INTO public.europe_data_import VALUES (3167, '06/07/2020', '2020-27', '207', '2', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '30.75');
INSERT INTO public.europe_data_import VALUES (3168, '29/06/2020', '2020-26', '146', '6', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '25.35');
INSERT INTO public.europe_data_import VALUES (3169, '22/06/2020', '2020-25', '145', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '26.3');
INSERT INTO public.europe_data_import VALUES (3170, '15/06/2020', '2020-24', '157', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '17.86');
INSERT INTO public.europe_data_import VALUES (3171, '08/06/2020', '2020-23', '48', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '7.23');
INSERT INTO public.europe_data_import VALUES (3172, '01/06/2020', '2020-22', '35', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '7.14');
INSERT INTO public.europe_data_import VALUES (3173, '25/05/2020', '2020-21', '47', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '6.79');
INSERT INTO public.europe_data_import VALUES (3174, '18/05/2020', '2020-20', '31', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '7.93');
INSERT INTO public.europe_data_import VALUES (3175, '11/05/2020', '2020-19', '60', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '9.84');
INSERT INTO public.europe_data_import VALUES (3176, '04/05/2020', '2020-18', '53', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '7.84');
INSERT INTO public.europe_data_import VALUES (3177, '27/04/2020', '2020-17', '37', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '3.92');
INSERT INTO public.europe_data_import VALUES (3178, '20/04/2020', '2020-16', '8', '1', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '1.13');
INSERT INTO public.europe_data_import VALUES (3179, '13/04/2020', '2020-15', '5', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (3180, '06/04/2020', '2020-14', '0', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (3181, '30/03/2020', '2020-13', '5', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '0.7');
INSERT INTO public.europe_data_import VALUES (3182, '23/03/2020', '2020-12', '3', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (3183, '16/03/2020', '2020-11', '1', '0', '1148133', 'Eswatini', 'SZ', 'SWZ', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3184, '01/02/2021', '2021-04', '4617', '37', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '6.41');
INSERT INTO public.europe_data_import VALUES (3185, '25/01/2021', '2021-03', '2572', '36', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '4.6');
INSERT INTO public.europe_data_import VALUES (3186, '18/01/2021', '2021-02', '2579', '27', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '4.97');
INSERT INTO public.europe_data_import VALUES (3187, '11/01/2021', '2021-01', '2994', '55', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '4.88');
INSERT INTO public.europe_data_import VALUES (3188, '04/01/2021', '2020-53', '2477', '36', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.06');
INSERT INTO public.europe_data_import VALUES (3189, '28/12/2020', '2020-52', '3194', '59', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.69');
INSERT INTO public.europe_data_import VALUES (3190, '21/12/2020', '2020-51', '3182', '47', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.94');
INSERT INTO public.europe_data_import VALUES (3191, '14/12/2020', '2020-50', '3474', '59', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '6.46');
INSERT INTO public.europe_data_import VALUES (3192, '07/12/2020', '2020-49', '3761', '47', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '6.7');
INSERT INTO public.europe_data_import VALUES (3193, '30/11/2020', '2020-48', '3749', '53', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '6.08');
INSERT INTO public.europe_data_import VALUES (3194, '23/11/2020', '2020-47', '3065', '78', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.45');
INSERT INTO public.europe_data_import VALUES (3195, '16/11/2020', '2020-46', '3045', '46', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.48');
INSERT INTO public.europe_data_import VALUES (3196, '09/11/2020', '2020-45', '3092', '45', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.65');
INSERT INTO public.europe_data_import VALUES (3197, '02/11/2020', '2020-44', '3240', '52', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '6.64');
INSERT INTO public.europe_data_import VALUES (3198, '26/10/2020', '2020-43', '4206', '74', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '8.07');
INSERT INTO public.europe_data_import VALUES (3199, '19/10/2020', '2020-42', '4842', '65', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '9.21');
INSERT INTO public.europe_data_import VALUES (3200, '12/10/2020', '2020-41', '5476', '65', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '9.78');
INSERT INTO public.europe_data_import VALUES (3201, '05/10/2020', '2020-40', '5487', '52', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '8.92');
INSERT INTO public.europe_data_import VALUES (3202, '28/09/2020', '2020-39', '4512', '74', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '8.06');
INSERT INTO public.europe_data_import VALUES (3203, '21/09/2020', '2020-38', '4519', '83', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '9.05');
INSERT INTO public.europe_data_import VALUES (3204, '14/09/2020', '2020-37', '5629', '95', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '11.76');
INSERT INTO public.europe_data_import VALUES (3205, '07/09/2020', '2020-36', '7550', '125', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '16.06');
INSERT INTO public.europe_data_import VALUES (3206, '31/08/2020', '2020-35', '10451', '115', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '18.96');
INSERT INTO public.europe_data_import VALUES (3207, '24/08/2020', '2020-34', '10795', '150', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '15.93');
INSERT INTO public.europe_data_import VALUES (3208, '17/08/2020', '2020-33', '7058', '121', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '10.6');
INSERT INTO public.europe_data_import VALUES (3209, '10/08/2020', '2020-32', '4819', '123', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '7.9');
INSERT INTO public.europe_data_import VALUES (3210, '03/08/2020', '2020-31', '4031', '61', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '7.58');
INSERT INTO public.europe_data_import VALUES (3211, '27/07/2020', '2020-30', '4465', '56', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '5.72');
INSERT INTO public.europe_data_import VALUES (3212, '20/07/2020', '2020-29', '1943', '40', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '3.26');
INSERT INTO public.europe_data_import VALUES (3213, '13/07/2020', '2020-28', '1714', '24', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '1.67');
INSERT INTO public.europe_data_import VALUES (3214, '06/07/2020', '2020-27', '157', '5', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '1.17');
INSERT INTO public.europe_data_import VALUES (3215, '29/06/2020', '2020-26', '1157', '24', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '2.09');
INSERT INTO public.europe_data_import VALUES (3216, '22/06/2020', '2020-25', '1187', '17', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '2.24');
INSERT INTO public.europe_data_import VALUES (3217, '15/06/2020', '2020-24', '1325', '30', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '1.94');
INSERT INTO public.europe_data_import VALUES (3218, '08/06/2020', '2020-23', '848', '16', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '1.28');
INSERT INTO public.europe_data_import VALUES (3219, '01/06/2020', '2020-22', '590', '6', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.76');
INSERT INTO public.europe_data_import VALUES (3220, '25/05/2020', '2020-21', '265', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (3221, '18/05/2020', '2020-20', '78', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (3222, '11/05/2020', '2020-19', '104', '2', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (3223, '04/05/2020', '2020-18', '12', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (3224, '27/04/2020', '2020-17', '15', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (3225, '20/04/2020', '2020-16', '37', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (3226, '13/04/2020', '2020-15', '28', '1', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (3227, '06/04/2020', '2020-14', '27', '2', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (3228, '30/03/2020', '2020-13', '5', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.01');
INSERT INTO public.europe_data_import VALUES (3229, '23/03/2020', '2020-12', '7', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '0.01');
INSERT INTO public.europe_data_import VALUES (3230, '16/03/2020', '2020-11', '4', '0', '112078727', 'Ethiopia', 'ET', 'ETH', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3231, '01/02/2021', '2021-04', '3', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '237.25');
INSERT INTO public.europe_data_import VALUES (3232, '25/01/2021', '2021-03', '5', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '237.25');
INSERT INTO public.europe_data_import VALUES (3233, '18/01/2021', '2021-02', '3', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '88.97');
INSERT INTO public.europe_data_import VALUES (3234, '11/01/2021', '2021-01', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '29.66');
INSERT INTO public.europe_data_import VALUES (3235, '04/01/2021', '2020-53', '1', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '177.94');
INSERT INTO public.europe_data_import VALUES (3236, '28/12/2020', '2020-52', '5', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '266.9');
INSERT INTO public.europe_data_import VALUES (3237, '21/12/2020', '2020-51', '4', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '177.94');
INSERT INTO public.europe_data_import VALUES (3238, '14/12/2020', '2020-50', '2', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '59.31');
INSERT INTO public.europe_data_import VALUES (3239, '07/12/2020', '2020-49', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '29.66');
INSERT INTO public.europe_data_import VALUES (3240, '30/11/2020', '2020-48', '1', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '59.31');
INSERT INTO public.europe_data_import VALUES (3241, '23/11/2020', '2020-47', '1', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '88.97');
INSERT INTO public.europe_data_import VALUES (3242, '16/11/2020', '2020-46', '2', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '59.31');
INSERT INTO public.europe_data_import VALUES (3243, '09/11/2020', '2020-45', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3244, '02/11/2020', '2020-44', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3245, '26/10/2020', '2020-43', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3246, '19/10/2020', '2020-42', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3247, '12/10/2020', '2020-41', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3248, '05/10/2020', '2020-40', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3249, '28/09/2020', '2020-39', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3250, '21/09/2020', '2020-38', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3251, '14/09/2020', '2020-37', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3252, '07/09/2020', '2020-36', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3253, '31/08/2020', '2020-35', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3254, '24/08/2020', '2020-34', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3255, '17/08/2020', '2020-33', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3256, '10/08/2020', '2020-32', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3257, '03/08/2020', '2020-31', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3258, '27/07/2020', '2020-30', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3259, '20/07/2020', '2020-29', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3260, '13/07/2020', '2020-28', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3261, '06/07/2020', '2020-27', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3262, '29/06/2020', '2020-26', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3263, '22/06/2020', '2020-25', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3264, '15/06/2020', '2020-24', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3265, '08/06/2020', '2020-23', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3266, '01/06/2020', '2020-22', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3267, '25/05/2020', '2020-21', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3268, '18/05/2020', '2020-20', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3269, '11/05/2020', '2020-19', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3270, '04/05/2020', '2020-18', '0', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '59.31');
INSERT INTO public.europe_data_import VALUES (3271, '27/04/2020', '2020-17', '2', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '237.25');
INSERT INTO public.europe_data_import VALUES (3272, '20/04/2020', '2020-16', '6', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '266.9');
INSERT INTO public.europe_data_import VALUES (3273, '13/04/2020', '2020-15', '3', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '148.28');
INSERT INTO public.europe_data_import VALUES (3274, '06/04/2020', '2020-14', '2', '0', '3372', 'Falkland_Islands_(Malvinas)', 'FK', 'FLK', 'America', '');
INSERT INTO public.europe_data_import VALUES (3275, '01/02/2021', '2021-04', '2', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '10.27');
INSERT INTO public.europe_data_import VALUES (3276, '25/01/2021', '2021-03', '3', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '12.33');
INSERT INTO public.europe_data_import VALUES (3277, '18/01/2021', '2021-02', '3', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '59.58');
INSERT INTO public.europe_data_import VALUES (3278, '11/01/2021', '2021-01', '26', '1', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '131.48');
INSERT INTO public.europe_data_import VALUES (3279, '04/01/2021', '2020-53', '38', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '152.02');
INSERT INTO public.europe_data_import VALUES (3280, '28/12/2020', '2020-52', '36', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '110.94');
INSERT INTO public.europe_data_import VALUES (3281, '21/12/2020', '2020-51', '18', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '73.96');
INSERT INTO public.europe_data_import VALUES (3282, '14/12/2020', '2020-50', '18', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '53.41');
INSERT INTO public.europe_data_import VALUES (3283, '07/12/2020', '2020-49', '8', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '20.54');
INSERT INTO public.europe_data_import VALUES (3284, '30/11/2020', '2020-48', '2', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '8.22');
INSERT INTO public.europe_data_import VALUES (3285, '23/11/2020', '2020-47', '2', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '6.16');
INSERT INTO public.europe_data_import VALUES (3286, '16/11/2020', '2020-46', '1', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '6.16');
INSERT INTO public.europe_data_import VALUES (3287, '09/11/2020', '2020-45', '2', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '14.38');
INSERT INTO public.europe_data_import VALUES (3288, '02/11/2020', '2020-44', '5', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '20.54');
INSERT INTO public.europe_data_import VALUES (3289, '26/10/2020', '2020-43', '5', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '26.71');
INSERT INTO public.europe_data_import VALUES (3290, '19/10/2020', '2020-42', '8', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '22.6');
INSERT INTO public.europe_data_import VALUES (3291, '12/10/2020', '2020-41', '3', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '34.92');
INSERT INTO public.europe_data_import VALUES (3292, '05/10/2020', '2020-40', '14', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '82.17');
INSERT INTO public.europe_data_import VALUES (3293, '28/09/2020', '2020-39', '26', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '76.01');
INSERT INTO public.europe_data_import VALUES (3294, '21/09/2020', '2020-38', '11', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '43.14');
INSERT INTO public.europe_data_import VALUES (3295, '14/09/2020', '2020-37', '10', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '24.65');
INSERT INTO public.europe_data_import VALUES (3296, '07/09/2020', '2020-36', '2', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '59.58');
INSERT INTO public.europe_data_import VALUES (3297, '31/08/2020', '2020-35', '27', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '80.12');
INSERT INTO public.europe_data_import VALUES (3298, '24/08/2020', '2020-34', '12', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '191.06');
INSERT INTO public.europe_data_import VALUES (3299, '17/08/2020', '2020-33', '81', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '301.99');
INSERT INTO public.europe_data_import VALUES (3300, '10/08/2020', '2020-32', '66', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '205.44');
INSERT INTO public.europe_data_import VALUES (3301, '03/08/2020', '2020-31', '34', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '69.85');
INSERT INTO public.europe_data_import VALUES (3302, '27/07/2020', '2020-30', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '6.16');
INSERT INTO public.europe_data_import VALUES (3303, '20/07/2020', '2020-29', '3', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '8.22');
INSERT INTO public.europe_data_import VALUES (3304, '13/07/2020', '2020-28', '1', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '2.05');
INSERT INTO public.europe_data_import VALUES (3305, '06/07/2020', '2020-27', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3306, '29/06/2020', '2020-26', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3307, '22/06/2020', '2020-25', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3308, '15/06/2020', '2020-24', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3309, '08/06/2020', '2020-23', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3310, '01/06/2020', '2020-22', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3311, '25/05/2020', '2020-21', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3312, '18/05/2020', '2020-20', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3313, '11/05/2020', '2020-19', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3314, '04/05/2020', '2020-18', '0', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '4.11');
INSERT INTO public.europe_data_import VALUES (3315, '27/04/2020', '2020-17', '2', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '6.16');
INSERT INTO public.europe_data_import VALUES (3316, '20/04/2020', '2020-16', '1', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '8.22');
INSERT INTO public.europe_data_import VALUES (3317, '13/04/2020', '2020-15', '3', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '51.36');
INSERT INTO public.europe_data_import VALUES (3318, '06/04/2020', '2020-14', '22', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '135.59');
INSERT INTO public.europe_data_import VALUES (3319, '30/03/2020', '2020-13', '44', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '308.15');
INSERT INTO public.europe_data_import VALUES (3320, '23/03/2020', '2020-12', '106', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '230.09');
INSERT INTO public.europe_data_import VALUES (3321, '16/03/2020', '2020-11', '6', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '18.49');
INSERT INTO public.europe_data_import VALUES (3322, '09/03/2020', '2020-10', '3', '0', '48677', 'Faroe_Islands', 'FO', 'FRO', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3323, '01/02/2021', '2021-04', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3324, '25/01/2021', '2021-03', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.22');
INSERT INTO public.europe_data_import VALUES (3325, '18/01/2021', '2021-02', '2', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.67');
INSERT INTO public.europe_data_import VALUES (3326, '11/01/2021', '2021-01', '4', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.79');
INSERT INTO public.europe_data_import VALUES (3327, '04/01/2021', '2020-53', '3', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.34');
INSERT INTO public.europe_data_import VALUES (3328, '28/12/2020', '2020-52', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3329, '21/12/2020', '2020-51', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.22');
INSERT INTO public.europe_data_import VALUES (3330, '14/12/2020', '2020-50', '2', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.45');
INSERT INTO public.europe_data_import VALUES (3331, '07/12/2020', '2020-49', '2', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '1.01');
INSERT INTO public.europe_data_import VALUES (3332, '30/11/2020', '2020-48', '7', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.79');
INSERT INTO public.europe_data_import VALUES (3333, '23/11/2020', '2020-47', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3334, '16/11/2020', '2020-46', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3335, '09/11/2020', '2020-45', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3336, '02/11/2020', '2020-44', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.22');
INSERT INTO public.europe_data_import VALUES (3337, '26/10/2020', '2020-43', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3338, '19/10/2020', '2020-42', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3339, '12/10/2020', '2020-41', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3340, '05/10/2020', '2020-40', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3341, '28/09/2020', '2020-39', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3342, '21/09/2020', '2020-38', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3343, '14/09/2020', '2020-37', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.45');
INSERT INTO public.europe_data_import VALUES (3344, '07/09/2020', '2020-36', '3', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.34');
INSERT INTO public.europe_data_import VALUES (3345, '31/08/2020', '2020-35', '0', '1', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3346, '24/08/2020', '2020-34', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3347, '17/08/2020', '2020-33', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3348, '10/08/2020', '2020-32', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3349, '03/08/2020', '2020-31', '0', '1', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3350, '27/07/2020', '2020-30', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3351, '20/07/2020', '2020-29', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.9');
INSERT INTO public.europe_data_import VALUES (3352, '13/07/2020', '2020-28', '8', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.9');
INSERT INTO public.europe_data_import VALUES (3353, '06/07/2020', '2020-27', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3354, '29/06/2020', '2020-26', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3355, '22/06/2020', '2020-25', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3356, '15/06/2020', '2020-24', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3357, '08/06/2020', '2020-23', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3358, '01/06/2020', '2020-22', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3359, '25/05/2020', '2020-21', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3360, '18/05/2020', '2020-20', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3361, '11/05/2020', '2020-19', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3362, '04/05/2020', '2020-18', '0', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (3363, '27/04/2020', '2020-17', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.22');
INSERT INTO public.europe_data_import VALUES (3364, '20/04/2020', '2020-16', '1', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.34');
INSERT INTO public.europe_data_import VALUES (3365, '13/04/2020', '2020-15', '2', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '1.24');
INSERT INTO public.europe_data_import VALUES (3366, '06/04/2020', '2020-14', '9', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '1.24');
INSERT INTO public.europe_data_import VALUES (3367, '30/03/2020', '2020-13', '2', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '0.56');
INSERT INTO public.europe_data_import VALUES (3368, '23/03/2020', '2020-12', '3', '0', '889955', 'Fiji', 'FJ', 'FJI', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (3369, '01/02/2021', '2021-04', '2902', '22', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '93.24');
INSERT INTO public.europe_data_import VALUES (3370, '25/01/2021', '2021-03', '2243', '34', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '72.31');
INSERT INTO public.europe_data_import VALUES (3371, '18/01/2021', '2021-02', '1747', '24', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '61.94');
INSERT INTO public.europe_data_import VALUES (3372, '11/01/2021', '2021-01', '1671', '32', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '62.58');
INSERT INTO public.europe_data_import VALUES (3373, '04/01/2021', '2020-53', '1782', '19', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '68.09');
INSERT INTO public.europe_data_import VALUES (3374, '28/12/2020', '2020-52', '1975', '57', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '78.42');
INSERT INTO public.europe_data_import VALUES (3375, '21/12/2020', '2020-51', '2352', '28', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '100.24');
INSERT INTO public.europe_data_import VALUES (3376, '14/12/2020', '2020-50', '3179', '46', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '112.02');
INSERT INTO public.europe_data_import VALUES (3377, '07/12/2020', '2020-49', '3002', '22', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '108.59');
INSERT INTO public.europe_data_import VALUES (3378, '30/11/2020', '2020-48', '2990', '18', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '96.3');
INSERT INTO public.europe_data_import VALUES (3379, '23/11/2020', '2020-47', '2324', '6', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '69.63');
INSERT INTO public.europe_data_import VALUES (3380, '16/11/2020', '2020-46', '1518', '7', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '54.8');
INSERT INTO public.europe_data_import VALUES (3381, '09/11/2020', '2020-45', '1506', '4', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '53.44');
INSERT INTO public.europe_data_import VALUES (3382, '02/11/2020', '2020-44', '1443', '5', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '51.96');
INSERT INTO public.europe_data_import VALUES (3383, '26/10/2020', '2020-43', '1424', '2', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '51.65');
INSERT INTO public.europe_data_import VALUES (3384, '19/10/2020', '2020-42', '1426', '5', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '52.3');
INSERT INTO public.europe_data_import VALUES (3385, '12/10/2020', '2020-41', '1460', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '41.97');
INSERT INTO public.europe_data_import VALUES (3386, '05/10/2020', '2020-40', '856', '2', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '28.24');
INSERT INTO public.europe_data_import VALUES (3387, '28/09/2020', '2020-39', '702', '4', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '19.97');
INSERT INTO public.europe_data_import VALUES (3388, '21/09/2020', '2020-38', '400', '2', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '12.49');
INSERT INTO public.europe_data_import VALUES (3389, '14/09/2020', '2020-37', '289', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '9.12');
INSERT INTO public.europe_data_import VALUES (3390, '07/09/2020', '2020-36', '214', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '6.72');
INSERT INTO public.europe_data_import VALUES (3391, '31/08/2020', '2020-35', '157', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '6.27');
INSERT INTO public.europe_data_import VALUES (3392, '24/08/2020', '2020-34', '189', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '6.09');
INSERT INTO public.europe_data_import VALUES (3393, '17/08/2020', '2020-33', '147', '2', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '5.04');
INSERT INTO public.europe_data_import VALUES (3394, '10/08/2020', '2020-32', '131', '2', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '3.46');
INSERT INTO public.europe_data_import VALUES (3395, '03/08/2020', '2020-31', '60', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '2.08');
INSERT INTO public.europe_data_import VALUES (3396, '27/07/2020', '2020-30', '55', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '1.83');
INSERT INTO public.europe_data_import VALUES (3397, '20/07/2020', '2020-29', '46', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '1.2');
INSERT INTO public.europe_data_import VALUES (3398, '13/07/2020', '2020-28', '20', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '1.83');
INSERT INTO public.europe_data_import VALUES (3399, '06/07/2020', '2020-27', '81', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '2.34');
INSERT INTO public.europe_data_import VALUES (3400, '29/06/2020', '2020-26', '48', '2', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '1.58');
INSERT INTO public.europe_data_import VALUES (3401, '22/06/2020', '2020-25', '39', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '2.94');
INSERT INTO public.europe_data_import VALUES (3402, '15/06/2020', '2020-24', '123', '3', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '4.44');
INSERT INTO public.europe_data_import VALUES (3403, '08/06/2020', '2020-23', '122', '3', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '7.29');
INSERT INTO public.europe_data_import VALUES (3404, '01/06/2020', '2020-22', '280', '13', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '9.28');
INSERT INTO public.europe_data_import VALUES (3405, '25/05/2020', '2020-21', '232', '9', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '11.18');
INSERT INTO public.europe_data_import VALUES (3406, '18/05/2020', '2020-20', '385', '31', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '19.81');
INSERT INTO public.europe_data_import VALUES (3407, '11/05/2020', '2020-19', '708', '37', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '25.12');
INSERT INTO public.europe_data_import VALUES (3408, '04/05/2020', '2020-18', '678', '40', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '26.66');
INSERT INTO public.europe_data_import VALUES (3409, '27/04/2020', '2020-17', '793', '96', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '29.03');
INSERT INTO public.europe_data_import VALUES (3410, '20/04/2020', '2020-16', '809', '38', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '33.64');
INSERT INTO public.europe_data_import VALUES (3411, '13/04/2020', '2020-15', '1047', '29', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '31.82');
INSERT INTO public.europe_data_import VALUES (3412, '06/04/2020', '2020-14', '709', '16', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '23.58');
INSERT INTO public.europe_data_import VALUES (3413, '30/03/2020', '2020-13', '592', '10', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '17.23');
INSERT INTO public.europe_data_import VALUES (3414, '23/03/2020', '2020-12', '359', '1', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '10.8');
INSERT INTO public.europe_data_import VALUES (3415, '16/03/2020', '2020-11', '237', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '4.73');
INSERT INTO public.europe_data_import VALUES (3416, '09/03/2020', '2020-10', '24', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0.53');
INSERT INTO public.europe_data_import VALUES (3417, '02/03/2020', '2020-09', '5', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0.09');
INSERT INTO public.europe_data_import VALUES (3418, '24/02/2020', '2020-08', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3419, '17/02/2020', '2020-07', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3420, '10/02/2020', '2020-06', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0.02');
INSERT INTO public.europe_data_import VALUES (3421, '03/02/2020', '2020-05', '1', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0.02');
INSERT INTO public.europe_data_import VALUES (3422, '27/01/2020', '2020-04', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3423, '20/01/2020', '2020-03', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3424, '13/01/2020', '2020-02', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3425, '06/01/2020', '2020-01', '0', '0', '5517919', 'Finland', 'FI', 'FIN', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3426, '01/02/2021', '2021-04', '143497', '3008', '67012883', 'France', 'FR', 'FRA', 'Europe', '426.97');
INSERT INTO public.europe_data_import VALUES (3427, '25/01/2021', '2021-03', '142628', '2766', '67012883', 'France', 'FR', 'FRA', 'Europe', '403.45');
INSERT INTO public.europe_data_import VALUES (3428, '18/01/2021', '2021-02', '127733', '2533', '67012883', 'France', 'FR', 'FRA', 'Europe', '380.91');
INSERT INTO public.europe_data_import VALUES (3429, '11/01/2021', '2021-01', '127528', '2713', '67012883', 'France', 'FR', 'FRA', 'Europe', '329.21');
INSERT INTO public.europe_data_import VALUES (3430, '04/01/2021', '2020-53', '93082', '1928', '67012883', 'France', 'FR', 'FRA', 'Europe', '272.15');
INSERT INTO public.europe_data_import VALUES (3431, '28/12/2020', '2020-52', '89292', '2560', '67012883', 'France', 'FR', 'FRA', 'Europe', '277.25');
INSERT INTO public.europe_data_import VALUES (3432, '21/12/2020', '2020-51', '96502', '2638', '67012883', 'France', 'FR', 'FRA', 'Europe', '269.88');
INSERT INTO public.europe_data_import VALUES (3433, '14/12/2020', '2020-50', '84355', '2756', '67012883', 'France', 'FR', 'FRA', 'Europe', '236.33');
INSERT INTO public.europe_data_import VALUES (3434, '07/12/2020', '2020-49', '74014', '2830', '67012883', 'France', 'FR', 'FRA', 'Europe', '227.25');
INSERT INTO public.europe_data_import VALUES (3435, '30/11/2020', '2020-48', '78275', '3593', '67012883', 'France', 'FR', 'FRA', 'Europe', '353.15');
INSERT INTO public.europe_data_import VALUES (3436, '23/11/2020', '2020-47', '158381', '4184', '67012883', 'France', 'FR', 'FRA', 'Europe', '526.59');
INSERT INTO public.europe_data_import VALUES (3437, '16/11/2020', '2020-46', '194503', '4109', '67012883', 'France', 'FR', 'FRA', 'Europe', '847.47');
INSERT INTO public.europe_data_import VALUES (3438, '09/11/2020', '2020-45', '373409', '3420', '67012883', 'France', 'FR', 'FRA', 'Europe', '968.2');
INSERT INTO public.europe_data_import VALUES (3439, '02/11/2020', '2020-44', '275408', '2258', '67012883', 'France', 'FR', 'FRA', 'Europe', '771.32');
INSERT INTO public.europe_data_import VALUES (3440, '26/10/2020', '2020-43', '241473', '1284', '67012883', 'France', 'FR', 'FRA', 'Europe', '602.17');
INSERT INTO public.europe_data_import VALUES (3441, '19/10/2020', '2020-42', '162060', '747', '67012883', 'France', 'FR', 'FRA', 'Europe', '414.64');
INSERT INTO public.europe_data_import VALUES (3442, '12/10/2020', '2020-41', '115804', '500', '67012883', 'France', 'FR', 'FRA', 'Europe', '293.09');
INSERT INTO public.europe_data_import VALUES (3443, '05/10/2020', '2020-40', '80601', '503', '67012883', 'France', 'FR', 'FRA', 'Europe', '246.83');
INSERT INTO public.europe_data_import VALUES (3444, '28/09/2020', '2020-39', '84806', '442', '67012883', 'France', 'FR', 'FRA', 'Europe', '234.99');
INSERT INTO public.europe_data_import VALUES (3445, '21/09/2020', '2020-38', '72669', '369', '67012883', 'France', 'FR', 'FRA', 'Europe', '192.48');
INSERT INTO public.europe_data_import VALUES (3446, '14/09/2020', '2020-37', '56317', '215', '67012883', 'France', 'FR', 'FRA', 'Europe', '153.93');
INSERT INTO public.europe_data_import VALUES (3447, '07/09/2020', '2020-36', '46834', '95', '67012883', 'France', 'FR', 'FRA', 'Europe', '122.18');
INSERT INTO public.europe_data_import VALUES (3448, '31/08/2020', '2020-35', '35044', '93', '67012883', 'France', 'FR', 'FRA', 'Europe', '88.65');
INSERT INTO public.europe_data_import VALUES (3449, '24/08/2020', '2020-34', '24363', '103', '67012883', 'France', 'FR', 'FRA', 'Europe', '67.12');
INSERT INTO public.europe_data_import VALUES (3450, '17/08/2020', '2020-33', '20615', '86', '67012883', 'France', 'FR', 'FRA', 'Europe', '45.69');
INSERT INTO public.europe_data_import VALUES (3451, '10/08/2020', '2020-32', '10002', '59', '67012883', 'France', 'FR', 'FRA', 'Europe', '25.95');
INSERT INTO public.europe_data_import VALUES (3452, '03/08/2020', '2020-31', '7391', '73', '67012883', 'France', 'FR', 'FRA', 'Europe', '19.76');
INSERT INTO public.europe_data_import VALUES (3453, '27/07/2020', '2020-30', '5854', '40', '67012883', 'France', 'FR', 'FRA', 'Europe', '14.59');
INSERT INTO public.europe_data_import VALUES (3454, '20/07/2020', '2020-29', '3922', '148', '67012883', 'France', 'FR', 'FRA', 'Europe', '11.51');
INSERT INTO public.europe_data_import VALUES (3455, '13/07/2020', '2020-28', '3792', '111', '67012883', 'France', 'FR', 'FRA', 'Europe', '11.66');
INSERT INTO public.europe_data_import VALUES (3456, '06/07/2020', '2020-27', '4024', '115', '67012883', 'France', 'FR', 'FRA', 'Europe', '9.82');
INSERT INTO public.europe_data_import VALUES (3457, '29/06/2020', '2020-26', '2559', '138', '67012883', 'France', 'FR', 'FRA', 'Europe', '8.53');
INSERT INTO public.europe_data_import VALUES (3458, '22/06/2020', '2020-25', '3157', '233', '67012883', 'France', 'FR', 'FRA', 'Europe', '9.55');
INSERT INTO public.europe_data_import VALUES (3459, '15/06/2020', '2020-24', '3243', '252', '67012883', 'France', 'FR', 'FRA', 'Europe', '8.16');
INSERT INTO public.europe_data_import VALUES (3460, '08/06/2020', '2020-23', '2224', '353', '67012883', 'France', 'FR', 'FRA', 'Europe', '13.51');
INSERT INTO public.europe_data_import VALUES (3461, '01/06/2020', '2020-22', '6832', '435', '67012883', 'France', 'FR', 'FRA', 'Europe', '13.94');
INSERT INTO public.europe_data_import VALUES (3462, '25/05/2020', '2020-21', '2510', '656', '67012883', 'France', 'FR', 'FRA', 'Europe', '8.74');
INSERT INTO public.europe_data_import VALUES (3463, '18/05/2020', '2020-20', '3348', '1331', '67012883', 'France', 'FR', 'FRA', 'Europe', '16.6');
INSERT INTO public.europe_data_import VALUES (3464, '11/05/2020', '2020-19', '7776', '1485', '67012883', 'France', 'FR', 'FRA', 'Europe', '21.62');
INSERT INTO public.europe_data_import VALUES (3465, '04/05/2020', '2020-18', '6712', '2039', '67012883', 'France', 'FR', 'FRA', 'Europe', '27.88');
INSERT INTO public.europe_data_import VALUES (3466, '27/04/2020', '2020-17', '11969', '3138', '67012883', 'France', 'FR', 'FRA', 'Europe', '43.53');
INSERT INTO public.europe_data_import VALUES (3467, '20/04/2020', '2020-16', '17203', '5325', '67012883', 'France', 'FR', 'FRA', 'Europe', '62.87');
INSERT INTO public.europe_data_import VALUES (3468, '13/04/2020', '2020-15', '24925', '6315', '67012883', 'France', 'FR', 'FRA', 'Europe', '82.42');
INSERT INTO public.europe_data_import VALUES (3469, '06/04/2020', '2020-14', '30304', '5472', '67012883', 'France', 'FR', 'FRA', 'Europe', '81.27');
INSERT INTO public.europe_data_import VALUES (3470, '30/03/2020', '2020-13', '24156', '1932', '67012883', 'France', 'FR', 'FRA', 'Europe', '51.86');
INSERT INTO public.europe_data_import VALUES (3471, '23/03/2020', '2020-12', '10595', '547', '67012883', 'France', 'FR', 'FRA', 'Europe', '22.22');
INSERT INTO public.europe_data_import VALUES (3472, '16/03/2020', '2020-11', '4297', '108', '67012883', 'France', 'FR', 'FRA', 'Europe', '7.9');
INSERT INTO public.europe_data_import VALUES (3473, '09/03/2020', '2020-10', '996', '17', '67012883', 'France', 'FR', 'FRA', 'Europe', '1.66');
INSERT INTO public.europe_data_import VALUES (3474, '02/03/2020', '2020-09', '118', '1', '67012883', 'France', 'FR', 'FRA', 'Europe', '0.18');
INSERT INTO public.europe_data_import VALUES (3475, '24/02/2020', '2020-08', '0', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (3476, '17/02/2020', '2020-07', '1', '1', '67012883', 'France', 'FR', 'FRA', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (3477, '10/02/2020', '2020-06', '5', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (3478, '03/02/2020', '2020-05', '3', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (3479, '27/01/2020', '2020-04', '3', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (3480, '20/01/2020', '2020-03', '0', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3481, '13/01/2020', '2020-02', '0', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3482, '06/01/2020', '2020-01', '0', '0', '67012883', 'France', 'FR', 'FRA', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3483, '01/02/2021', '2021-04', '425', '5', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '152.17');
INSERT INTO public.europe_data_import VALUES (3484, '25/01/2021', '2021-03', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '141.07');
INSERT INTO public.europe_data_import VALUES (3485, '18/01/2021', '2021-02', '394', '4', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '253.86');
INSERT INTO public.europe_data_import VALUES (3486, '11/01/2021', '2021-01', '315', '8', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '247.42');
INSERT INTO public.europe_data_import VALUES (3487, '04/01/2021', '2020-53', '376', '6', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '266.39');
INSERT INTO public.europe_data_import VALUES (3488, '28/12/2020', '2020-52', '368', '5', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '287.52');
INSERT INTO public.europe_data_import VALUES (3489, '21/12/2020', '2020-51', '435', '7', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '384.91');
INSERT INTO public.europe_data_import VALUES (3490, '14/12/2020', '2020-50', '640', '17', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '591.15');
INSERT INTO public.europe_data_import VALUES (3491, '07/12/2020', '2020-49', '1011', '6', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '762.3');
INSERT INTO public.europe_data_import VALUES (3492, '30/11/2020', '2020-48', '1118', '10', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '855.76');
INSERT INTO public.europe_data_import VALUES (3493, '23/11/2020', '2020-47', '1272', '10', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1068.08');
INSERT INTO public.europe_data_import VALUES (3494, '16/11/2020', '2020-46', '1711', '14', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1591.21');
INSERT INTO public.europe_data_import VALUES (3495, '09/11/2020', '2020-45', '2733', '10', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1503.12');
INSERT INTO public.europe_data_import VALUES (3496, '02/11/2020', '2020-44', '1465', '9', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1240.67');
INSERT INTO public.europe_data_import VALUES (3497, '26/10/2020', '2020-43', '2000', '6', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1111.77');
INSERT INTO public.europe_data_import VALUES (3498, '19/10/2020', '2020-42', '1105', '4', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '656.32');
INSERT INTO public.europe_data_import VALUES (3499, '12/10/2020', '2020-41', '728', '2', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '486.96');
INSERT INTO public.europe_data_import VALUES (3500, '05/10/2020', '2020-40', '632', '3', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '231.3');
INSERT INTO public.europe_data_import VALUES (3501, '28/09/2020', '2020-39', '14', '3', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '157.9');
INSERT INTO public.europe_data_import VALUES (3502, '21/09/2020', '2020-38', '427', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '223.43');
INSERT INTO public.europe_data_import VALUES (3503, '14/09/2020', '2020-37', '197', '2', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '168.64');
INSERT INTO public.europe_data_import VALUES (3504, '07/09/2020', '2020-36', '274', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '163.99');
INSERT INTO public.europe_data_import VALUES (3505, '31/08/2020', '2020-35', '184', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '81.64');
INSERT INTO public.europe_data_import VALUES (3506, '24/08/2020', '2020-34', '44', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '62.3');
INSERT INTO public.europe_data_import VALUES (3507, '17/08/2020', '2020-33', '130', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '46.55');
INSERT INTO public.europe_data_import VALUES (3508, '10/08/2020', '2020-32', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3509, '03/08/2020', '2020-31', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3510, '27/07/2020', '2020-30', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3511, '20/07/2020', '2020-29', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3512, '13/07/2020', '2020-28', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3513, '06/07/2020', '2020-27', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0.72');
INSERT INTO public.europe_data_import VALUES (3514, '29/06/2020', '2020-26', '2', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0.72');
INSERT INTO public.europe_data_import VALUES (3515, '22/06/2020', '2020-25', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3516, '15/06/2020', '2020-24', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3517, '08/06/2020', '2020-23', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3518, '01/06/2020', '2020-22', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3519, '25/05/2020', '2020-21', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (3520, '18/05/2020', '2020-20', '0', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '0.72');
INSERT INTO public.europe_data_import VALUES (3521, '11/05/2020', '2020-19', '2', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1.07');
INSERT INTO public.europe_data_import VALUES (3522, '04/05/2020', '2020-18', '1', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1.07');
INSERT INTO public.europe_data_import VALUES (3523, '27/04/2020', '2020-17', '2', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '1.43');
INSERT INTO public.europe_data_import VALUES (3524, '20/04/2020', '2020-16', '2', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '5.01');
INSERT INTO public.europe_data_import VALUES (3525, '13/04/2020', '2020-15', '12', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '6.45');
INSERT INTO public.europe_data_import VALUES (3526, '06/04/2020', '2020-14', '6', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '8.24');
INSERT INTO public.europe_data_import VALUES (3527, '30/03/2020', '2020-13', '17', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '12.53');
INSERT INTO public.europe_data_import VALUES (3528, '23/03/2020', '2020-12', '18', '0', '279285', 'French_Polynesia', 'PF', 'PYF', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (3529, '01/02/2021', '2021-04', '542', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '48.51');
INSERT INTO public.europe_data_import VALUES (3530, '25/01/2021', '2021-03', '512', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '30.88');
INSERT INTO public.europe_data_import VALUES (3531, '18/01/2021', '2021-02', '159', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '13.53');
INSERT INTO public.europe_data_import VALUES (3532, '11/01/2021', '2021-01', '135', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '10.59');
INSERT INTO public.europe_data_import VALUES (3533, '04/01/2021', '2020-53', '95', '2', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '8.52');
INSERT INTO public.europe_data_import VALUES (3534, '28/12/2020', '2020-52', '90', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '7.32');
INSERT INTO public.europe_data_import VALUES (3535, '21/12/2020', '2020-51', '69', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '7.64');
INSERT INTO public.europe_data_import VALUES (3536, '14/12/2020', '2020-50', '97', '3', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '7.36');
INSERT INTO public.europe_data_import VALUES (3537, '07/12/2020', '2020-49', '63', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '5.66');
INSERT INTO public.europe_data_import VALUES (3538, '30/11/2020', '2020-48', '60', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '5.94');
INSERT INTO public.europe_data_import VALUES (3539, '23/11/2020', '2020-47', '69', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '5.02');
INSERT INTO public.europe_data_import VALUES (3540, '16/11/2020', '2020-46', '40', '3', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.33');
INSERT INTO public.europe_data_import VALUES (3541, '09/11/2020', '2020-45', '54', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.74');
INSERT INTO public.europe_data_import VALUES (3542, '02/11/2020', '2020-44', '49', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.0');
INSERT INTO public.europe_data_import VALUES (3543, '26/10/2020', '2020-43', '38', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '3.87');
INSERT INTO public.europe_data_import VALUES (3544, '19/10/2020', '2020-42', '46', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '3.87');
INSERT INTO public.europe_data_import VALUES (3545, '12/10/2020', '2020-41', '38', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.93');
INSERT INTO public.europe_data_import VALUES (3546, '05/10/2020', '2020-40', '69', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.65');
INSERT INTO public.europe_data_import VALUES (3547, '28/09/2020', '2020-39', '32', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '3.91');
INSERT INTO public.europe_data_import VALUES (3548, '21/09/2020', '2020-38', '53', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.37');
INSERT INTO public.europe_data_import VALUES (3549, '14/09/2020', '2020-37', '42', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '6.35');
INSERT INTO public.europe_data_import VALUES (3550, '07/09/2020', '2020-36', '96', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '9.8');
INSERT INTO public.europe_data_import VALUES (3551, '31/08/2020', '2020-35', '117', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '12.89');
INSERT INTO public.europe_data_import VALUES (3552, '24/08/2020', '2020-34', '163', '2', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '21.4');
INSERT INTO public.europe_data_import VALUES (3553, '17/08/2020', '2020-33', '302', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '31.94');
INSERT INTO public.europe_data_import VALUES (3554, '10/08/2020', '2020-32', '392', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '43.22');
INSERT INTO public.europe_data_import VALUES (3555, '03/08/2020', '2020-31', '547', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '55.97');
INSERT INTO public.europe_data_import VALUES (3556, '27/07/2020', '2020-30', '669', '3', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '47.96');
INSERT INTO public.europe_data_import VALUES (3557, '20/07/2020', '2020-29', '373', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '31.99');
INSERT INTO public.europe_data_import VALUES (3558, '13/07/2020', '2020-28', '322', '2', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '33.74');
INSERT INTO public.europe_data_import VALUES (3559, '06/07/2020', '2020-27', '411', '4', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '54.87');
INSERT INTO public.europe_data_import VALUES (3560, '29/06/2020', '2020-26', '781', '6', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '80.37');
INSERT INTO public.europe_data_import VALUES (3561, '22/06/2020', '2020-25', '965', '11', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '61.08');
INSERT INTO public.europe_data_import VALUES (3562, '15/06/2020', '2020-24', '362', '2', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '37.19');
INSERT INTO public.europe_data_import VALUES (3563, '08/06/2020', '2020-23', '446', '4', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '53.71');
INSERT INTO public.europe_data_import VALUES (3564, '01/06/2020', '2020-22', '721', '5', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '61.45');
INSERT INTO public.europe_data_import VALUES (3565, '25/05/2020', '2020-21', '614', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '58.59');
INSERT INTO public.europe_data_import VALUES (3566, '18/05/2020', '2020-20', '659', '3', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '45.34');
INSERT INTO public.europe_data_import VALUES (3567, '11/05/2020', '2020-19', '326', '3', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '22.32');
INSERT INTO public.europe_data_import VALUES (3568, '04/05/2020', '2020-18', '159', '2', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '10.4');
INSERT INTO public.europe_data_import VALUES (3569, '27/04/2020', '2020-17', '67', '2', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '5.48');
INSERT INTO public.europe_data_import VALUES (3570, '20/04/2020', '2020-16', '52', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '4.05');
INSERT INTO public.europe_data_import VALUES (3571, '13/04/2020', '2020-15', '36', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '2.3');
INSERT INTO public.europe_data_import VALUES (3572, '06/04/2020', '2020-14', '14', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '0.69');
INSERT INTO public.europe_data_import VALUES (3573, '30/03/2020', '2020-13', '1', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (3574, '23/03/2020', '2020-12', '5', '1', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (3575, '16/03/2020', '2020-11', '1', '0', '2172578', 'Gabon', 'GA', 'GAB', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3576, '01/02/2021', '2021-04', '131', '3', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '9.75');
INSERT INTO public.europe_data_import VALUES (3577, '25/01/2021', '2021-03', '98', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '5.62');
INSERT INTO public.europe_data_import VALUES (3578, '18/01/2021', '2021-02', '34', '2', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '4.43');
INSERT INTO public.europe_data_import VALUES (3579, '11/01/2021', '2021-01', '70', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '3.37');
INSERT INTO public.europe_data_import VALUES (3580, '04/01/2021', '2020-53', '9', '2', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (3581, '28/12/2020', '2020-52', '8', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.64');
INSERT INTO public.europe_data_import VALUES (3582, '21/12/2020', '2020-51', '7', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.81');
INSERT INTO public.europe_data_import VALUES (3583, '14/12/2020', '2020-50', '12', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '2.04');
INSERT INTO public.europe_data_import VALUES (3584, '07/12/2020', '2020-49', '36', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.87');
INSERT INTO public.europe_data_import VALUES (3585, '30/11/2020', '2020-48', '8', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (3586, '23/11/2020', '2020-47', '24', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.79');
INSERT INTO public.europe_data_import VALUES (3587, '16/11/2020', '2020-46', '18', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.28');
INSERT INTO public.europe_data_import VALUES (3588, '09/11/2020', '2020-45', '12', '2', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (3589, '02/11/2020', '2020-44', '12', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.98');
INSERT INTO public.europe_data_import VALUES (3590, '26/10/2020', '2020-43', '11', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.19');
INSERT INTO public.europe_data_import VALUES (3591, '19/10/2020', '2020-42', '17', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '2.34');
INSERT INTO public.europe_data_import VALUES (3592, '12/10/2020', '2020-41', '38', '2', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '2.68');
INSERT INTO public.europe_data_import VALUES (3593, '05/10/2020', '2020-40', '25', '4', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '2.9');
INSERT INTO public.europe_data_import VALUES (3594, '28/09/2020', '2020-39', '43', '3', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '6.99');
INSERT INTO public.europe_data_import VALUES (3595, '21/09/2020', '2020-38', '121', '5', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '14.01');
INSERT INTO public.europe_data_import VALUES (3596, '14/09/2020', '2020-37', '208', '4', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '18.83');
INSERT INTO public.europe_data_import VALUES (3597, '07/09/2020', '2020-36', '234', '3', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '32.37');
INSERT INTO public.europe_data_import VALUES (3598, '31/08/2020', '2020-35', '526', '12', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '46.47');
INSERT INTO public.europe_data_import VALUES (3599, '24/08/2020', '2020-34', '565', '21', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '51.2');
INSERT INTO public.europe_data_import VALUES (3600, '17/08/2020', '2020-33', '637', '40', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '58.53');
INSERT INTO public.europe_data_import VALUES (3601, '10/08/2020', '2020-32', '737', '14', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '40.81');
INSERT INTO public.europe_data_import VALUES (3602, '03/08/2020', '2020-31', '221', '3', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '17.25');
INSERT INTO public.europe_data_import VALUES (3603, '27/07/2020', '2020-30', '184', '2', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '9.07');
INSERT INTO public.europe_data_import VALUES (3604, '20/07/2020', '2020-29', '29', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '1.53');
INSERT INTO public.europe_data_import VALUES (3605, '13/07/2020', '2020-28', '7', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.81');
INSERT INTO public.europe_data_import VALUES (3606, '06/07/2020', '2020-27', '12', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.85');
INSERT INTO public.europe_data_import VALUES (3607, '29/06/2020', '2020-26', '8', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (3608, '22/06/2020', '2020-25', '9', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.47');
INSERT INTO public.europe_data_import VALUES (3609, '15/06/2020', '2020-24', '2', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (3610, '08/06/2020', '2020-23', '1', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (3611, '01/06/2020', '2020-22', '0', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (3612, '25/05/2020', '2020-21', '2', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.21');
INSERT INTO public.europe_data_import VALUES (3613, '18/05/2020', '2020-20', '3', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (3614, '11/05/2020', '2020-19', '3', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.43');
INSERT INTO public.europe_data_import VALUES (3615, '04/05/2020', '2020-18', '7', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.3');
INSERT INTO public.europe_data_import VALUES (3616, '27/04/2020', '2020-17', '0', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (3617, '20/04/2020', '2020-16', '1', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (3618, '13/04/2020', '2020-15', '5', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (3619, '06/04/2020', '2020-14', '1', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (3620, '30/03/2020', '2020-13', '2', '1', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (3621, '23/03/2020', '2020-12', '1', '0', '2347696', 'Gambia', 'GM', 'GMB', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3622, '01/02/2021', '2021-04', '4535', '123', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '261.11');
INSERT INTO public.europe_data_import VALUES (3623, '25/01/2021', '2021-03', '5901', '113', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '351.18');
INSERT INTO public.europe_data_import VALUES (3624, '18/01/2021', '2021-02', '8135', '162', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '454.17');
INSERT INTO public.europe_data_import VALUES (3625, '11/01/2021', '2021-01', '10017', '168', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '441.28');
INSERT INTO public.europe_data_import VALUES (3626, '04/01/2021', '2020-53', '7620', '210', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '507.94');
INSERT INTO public.europe_data_import VALUES (3627, '28/12/2020', '2020-52', '12681', '278', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '777.63');
INSERT INTO public.europe_data_import VALUES (3628, '21/12/2020', '2020-51', '18399', '301', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1113.05');
INSERT INTO public.europe_data_import VALUES (3629, '14/12/2020', '2020-50', '26087', '299', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1388.1');
INSERT INTO public.europe_data_import VALUES (3630, '07/12/2020', '2020-49', '29392', '273', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1408.29');
INSERT INTO public.europe_data_import VALUES (3631, '30/11/2020', '2020-48', '26894', '255', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1319.79');
INSERT INTO public.europe_data_import VALUES (3632, '23/11/2020', '2020-47', '25855', '279', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1201.22');
INSERT INTO public.europe_data_import VALUES (3633, '16/11/2020', '2020-46', '22155', '234', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1007.22');
INSERT INTO public.europe_data_import VALUES (3634, '09/11/2020', '2020-45', '18101', '157', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '760.04');
INSERT INTO public.europe_data_import VALUES (3635, '02/11/2020', '2020-44', '12276', '127', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '628.06');
INSERT INTO public.europe_data_import VALUES (3636, '26/10/2020', '2020-43', '12826', '79', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '463.1');
INSERT INTO public.europe_data_import VALUES (3637, '19/10/2020', '2020-42', '5683', '51', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '234.16');
INSERT INTO public.europe_data_import VALUES (3638, '12/10/2020', '2020-41', '3676', '35', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '156.18');
INSERT INTO public.europe_data_import VALUES (3639, '05/10/2020', '2020-40', '2566', '22', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '110.66');
INSERT INTO public.europe_data_import VALUES (3640, '28/09/2020', '2020-39', '1857', '8', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '79.06');
INSERT INTO public.europe_data_import VALUES (3641, '21/09/2020', '2020-38', '1303', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '51.42');
INSERT INTO public.europe_data_import VALUES (3642, '14/09/2020', '2020-37', '752', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '22.64');
INSERT INTO public.europe_data_import VALUES (3643, '07/09/2020', '2020-36', '153', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '5.73');
INSERT INTO public.europe_data_import VALUES (3644, '31/08/2020', '2020-35', '76', '2', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '3.65');
INSERT INTO public.europe_data_import VALUES (3645, '24/08/2020', '2020-34', '70', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '4.03');
INSERT INTO public.europe_data_import VALUES (3646, '17/08/2020', '2020-33', '91', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '4.1');
INSERT INTO public.europe_data_import VALUES (3647, '10/08/2020', '2020-32', '73', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '2.83');
INSERT INTO public.europe_data_import VALUES (3648, '03/08/2020', '2020-31', '40', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '3.73');
INSERT INTO public.europe_data_import VALUES (3649, '27/07/2020', '2020-30', '109', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '3.55');
INSERT INTO public.europe_data_import VALUES (3650, '20/07/2020', '2020-29', '33', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.88');
INSERT INTO public.europe_data_import VALUES (3651, '13/07/2020', '2020-28', '42', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.73');
INSERT INTO public.europe_data_import VALUES (3652, '06/07/2020', '2020-27', '27', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.13');
INSERT INTO public.europe_data_import VALUES (3653, '29/06/2020', '2020-26', '18', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.18');
INSERT INTO public.europe_data_import VALUES (3654, '22/06/2020', '2020-25', '29', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '2.5');
INSERT INTO public.europe_data_import VALUES (3655, '15/06/2020', '2020-24', '71', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '2.4');
INSERT INTO public.europe_data_import VALUES (3656, '08/06/2020', '2020-23', '25', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.95');
INSERT INTO public.europe_data_import VALUES (3657, '01/06/2020', '2020-22', '53', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '2.05');
INSERT INTO public.europe_data_import VALUES (3658, '25/05/2020', '2020-21', '29', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '2.38');
INSERT INTO public.europe_data_import VALUES (3659, '18/05/2020', '2020-20', '66', '2', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '2.8');
INSERT INTO public.europe_data_import VALUES (3660, '11/05/2020', '2020-19', '46', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '3.73');
INSERT INTO public.europe_data_import VALUES (3661, '04/05/2020', '2020-18', '103', '3', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '4.88');
INSERT INTO public.europe_data_import VALUES (3662, '27/04/2020', '2020-17', '92', '2', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '5.73');
INSERT INTO public.europe_data_import VALUES (3663, '20/04/2020', '2020-16', '137', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '5.5');
INSERT INTO public.europe_data_import VALUES (3664, '13/04/2020', '2020-15', '83', '1', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '4.18');
INSERT INTO public.europe_data_import VALUES (3665, '06/04/2020', '2020-14', '84', '2', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '3.0');
INSERT INTO public.europe_data_import VALUES (3666, '30/03/2020', '2020-13', '36', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.5');
INSERT INTO public.europe_data_import VALUES (3667, '23/03/2020', '2020-12', '24', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '1.03');
INSERT INTO public.europe_data_import VALUES (3668, '16/03/2020', '2020-11', '17', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0.68');
INSERT INTO public.europe_data_import VALUES (3669, '09/03/2020', '2020-10', '10', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0.33');
INSERT INTO public.europe_data_import VALUES (3670, '02/03/2020', '2020-09', '3', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0.08');
INSERT INTO public.europe_data_import VALUES (3671, '24/02/2020', '2020-08', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3672, '17/02/2020', '2020-07', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3673, '10/02/2020', '2020-06', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3674, '03/02/2020', '2020-05', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3675, '27/01/2020', '2020-04', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3676, '20/01/2020', '2020-03', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3677, '13/01/2020', '2020-02', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3678, '06/01/2020', '2020-01', '0', '0', '3996762', 'Georgia', 'GE', 'GEO', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3679, '01/02/2021', '2021-04', '80306', '5033', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '218.4');
INSERT INTO public.europe_data_import VALUES (3680, '25/01/2021', '2021-03', '101006', '5454', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '265.77');
INSERT INTO public.europe_data_import VALUES (3681, '18/01/2021', '2021-02', '119635', '5947', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '319.38');
INSERT INTO public.europe_data_import VALUES (3682, '11/01/2021', '2021-01', '145511', '6112', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '324.25');
INSERT INTO public.europe_data_import VALUES (3683, '04/01/2021', '2020-53', '123679', '4448', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '319.04');
INSERT INTO public.europe_data_import VALUES (3684, '28/12/2020', '2020-52', '141182', '3851', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '379.14');
INSERT INTO public.europe_data_import VALUES (3685, '21/12/2020', '2020-51', '173574', '4300', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '393.88');
INSERT INTO public.europe_data_import VALUES (3686, '14/12/2020', '2020-50', '153424', '3056', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '341.14');
INSERT INTO public.europe_data_import VALUES (3687, '07/12/2020', '2020-49', '129785', '2671', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '306.58');
INSERT INTO public.europe_data_import VALUES (3688, '30/11/2020', '2020-48', '124736', '2136', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '304.2');
INSERT INTO public.europe_data_import VALUES (3689, '23/11/2020', '2020-47', '127806', '1565', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '309.89');
INSERT INTO public.europe_data_import VALUES (3690, '16/11/2020', '2020-46', '129459', '1195', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '308.72');
INSERT INTO public.europe_data_import VALUES (3691, '09/11/2020', '2020-45', '126841', '822', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '281.86');
INSERT INTO public.europe_data_import VALUES (3692, '02/11/2020', '2020-44', '107161', '474', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '215.29');
INSERT INTO public.europe_data_import VALUES (3693, '26/10/2020', '2020-43', '71567', '267', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '135.55');
INSERT INTO public.europe_data_import VALUES (3694, '19/10/2020', '2020-42', '40968', '168', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '79.11');
INSERT INTO public.europe_data_import VALUES (3695, '12/10/2020', '2020-41', '24712', '87', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '48.18');
INSERT INTO public.europe_data_import VALUES (3696, '05/10/2020', '2020-40', '15287', '74', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '34.07');
INSERT INTO public.europe_data_import VALUES (3697, '28/09/2020', '2020-39', '12995', '74', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '30.09');
INSERT INTO public.europe_data_import VALUES (3698, '21/09/2020', '2020-38', '11982', '36', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '25.94');
INSERT INTO public.europe_data_import VALUES (3699, '14/09/2020', '2020-37', '9556', '25', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '21.65');
INSERT INTO public.europe_data_import VALUES (3700, '07/09/2020', '2020-36', '8418', '27', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '20.75');
INSERT INTO public.europe_data_import VALUES (3701, '31/08/2020', '2020-35', '8806', '26', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '22.12');
INSERT INTO public.europe_data_import VALUES (3702, '24/08/2020', '2020-34', '9561', '40', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '20.78');
INSERT INTO public.europe_data_import VALUES (3703, '17/08/2020', '2020-33', '7687', '35', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '16.4');
INSERT INTO public.europe_data_import VALUES (3704, '10/08/2020', '2020-32', '5925', '49', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '12.91');
INSERT INTO public.europe_data_import VALUES (3705, '03/08/2020', '2020-31', '4793', '30', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '10.33');
INSERT INTO public.europe_data_import VALUES (3706, '27/07/2020', '2020-30', '3786', '32', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '8.01');
INSERT INTO public.europe_data_import VALUES (3707, '20/07/2020', '2020-29', '2860', '22', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '6.35');
INSERT INTO public.europe_data_import VALUES (3708, '13/07/2020', '2020-28', '2409', '48', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '6.27');
INSERT INTO public.europe_data_import VALUES (3709, '06/07/2020', '2020-27', '2793', '55', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '7.46');
INSERT INTO public.europe_data_import VALUES (3710, '29/06/2020', '2020-26', '3402', '76', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '8.79');
INSERT INTO public.europe_data_import VALUES (3711, '22/06/2020', '2020-25', '3898', '94', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '7.43');
INSERT INTO public.europe_data_import VALUES (3712, '15/06/2020', '2020-24', '2268', '117', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '5.6');
INSERT INTO public.europe_data_import VALUES (3713, '08/06/2020', '2020-23', '2378', '163', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '6.77');
INSERT INTO public.europe_data_import VALUES (3714, '01/06/2020', '2020-22', '3245', '254', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '8.57');
INSERT INTO public.europe_data_import VALUES (3715, '25/05/2020', '2020-21', '3873', '322', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '10.83');
INSERT INTO public.europe_data_import VALUES (3716, '18/05/2020', '2020-20', '5122', '518', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '13.88');
INSERT INTO public.europe_data_import VALUES (3717, '11/05/2020', '2020-19', '6400', '725', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '17.32');
INSERT INTO public.europe_data_import VALUES (3718, '04/05/2020', '2020-18', '7982', '942', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '25.9');
INSERT INTO public.europe_data_import VALUES (3719, '27/04/2020', '2020-17', '13521', '1346', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '38.76');
INSERT INTO public.europe_data_import VALUES (3720, '20/04/2020', '2020-16', '18656', '1605', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '55.75');
INSERT INTO public.europe_data_import VALUES (3721, '13/04/2020', '2020-15', '27625', '1365', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '79.16');
INSERT INTO public.europe_data_import VALUES (3722, '06/04/2020', '2020-14', '38093', '979', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '85.06');
INSERT INTO public.europe_data_import VALUES (3723, '30/03/2020', '2020-13', '32524', '361', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '63.19');
INSERT INTO public.europe_data_import VALUES (3724, '23/03/2020', '2020-12', '19936', '82', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '28.75');
INSERT INTO public.europe_data_import VALUES (3725, '16/03/2020', '2020-11', '3936', '12', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '5.67');
INSERT INTO public.europe_data_import VALUES (3726, '09/03/2020', '2020-10', '773', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '1.07');
INSERT INTO public.europe_data_import VALUES (3727, '02/03/2020', '2020-09', '114', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0.14');
INSERT INTO public.europe_data_import VALUES (3728, '24/02/2020', '2020-08', '0', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (3729, '17/02/2020', '2020-07', '2', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (3730, '10/02/2020', '2020-06', '4', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0.02');
INSERT INTO public.europe_data_import VALUES (3731, '03/02/2020', '2020-05', '9', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (3732, '27/01/2020', '2020-04', '0', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3733, '20/01/2020', '2020-03', '0', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3734, '13/01/2020', '2020-02', '0', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3735, '06/01/2020', '2020-01', '0', '0', '83019213', 'Germany', 'DE', 'DEU', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3736, '01/02/2021', '2021-04', '4875', '44', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '30.56');
INSERT INTO public.europe_data_import VALUES (3737, '25/01/2021', '2021-03', '4421', '26', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '19.41');
INSERT INTO public.europe_data_import VALUES (3738, '18/01/2021', '2021-02', '1484', '8', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '8.37');
INSERT INTO public.europe_data_import VALUES (3739, '11/01/2021', '2021-01', '1062', '3', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '5.68');
INSERT INTO public.europe_data_import VALUES (3740, '04/01/2021', '2020-53', '665', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.98');
INSERT INTO public.europe_data_import VALUES (3741, '28/12/2020', '2020-52', '850', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.9');
INSERT INTO public.europe_data_import VALUES (3742, '21/12/2020', '2020-51', '639', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.53');
INSERT INTO public.europe_data_import VALUES (3743, '14/12/2020', '2020-50', '740', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.75');
INSERT INTO public.europe_data_import VALUES (3744, '07/12/2020', '2020-49', '705', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.6');
INSERT INTO public.europe_data_import VALUES (3745, '30/11/2020', '2020-48', '695', '0', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.75');
INSERT INTO public.europe_data_import VALUES (3746, '23/11/2020', '2020-47', '751', '1', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '5.5');
INSERT INTO public.europe_data_import VALUES (3747, '16/11/2020', '2020-46', '921', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '6.57');
INSERT INTO public.europe_data_import VALUES (3748, '09/11/2020', '2020-45', '1078', '0', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.97');
INSERT INTO public.europe_data_import VALUES (3749, '02/11/2020', '2020-44', '434', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '2.68');
INSERT INTO public.europe_data_import VALUES (3750, '26/10/2020', '2020-43', '380', '6', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '2.25');
INSERT INTO public.europe_data_import VALUES (3751, '19/10/2020', '2020-42', '305', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '1.58');
INSERT INTO public.europe_data_import VALUES (3752, '12/10/2020', '2020-41', '176', '3', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '2.03');
INSERT INTO public.europe_data_import VALUES (3753, '05/10/2020', '2020-40', '442', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '2.71');
INSERT INTO public.europe_data_import VALUES (3754, '28/09/2020', '2020-39', '383', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '3.13');
INSERT INTO public.europe_data_import VALUES (3755, '21/09/2020', '2020-38', '570', '11', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.03');
INSERT INTO public.europe_data_import VALUES (3756, '14/09/2020', '2020-37', '657', '3', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.04');
INSERT INTO public.europe_data_import VALUES (3757, '07/09/2020', '2020-36', '572', '7', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '4.18');
INSERT INTO public.europe_data_import VALUES (3758, '31/08/2020', '2020-35', '700', '15', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '5.5');
INSERT INTO public.europe_data_import VALUES (3759, '24/08/2020', '2020-34', '973', '30', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '8.23');
INSERT INTO public.europe_data_import VALUES (3760, '17/08/2020', '2020-33', '1529', '16', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '18.14');
INSERT INTO public.europe_data_import VALUES (3761, '10/08/2020', '2020-32', '3989', '33', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '26.41');
INSERT INTO public.europe_data_import VALUES (3762, '03/08/2020', '2020-31', '4045', '14', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '30.73');
INSERT INTO public.europe_data_import VALUES (3763, '27/07/2020', '2020-30', '5302', '20', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '27.78');
INSERT INTO public.europe_data_import VALUES (3764, '20/07/2020', '2020-29', '3149', '9', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '24.93');
INSERT INTO public.europe_data_import VALUES (3765, '13/07/2020', '2020-28', '4433', '17', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '23.56');
INSERT INTO public.europe_data_import VALUES (3766, '06/07/2020', '2020-27', '2734', '10', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '19.5');
INSERT INTO public.europe_data_import VALUES (3767, '29/06/2020', '2020-26', '3197', '27', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '17.71');
INSERT INTO public.europe_data_import VALUES (3768, '22/06/2020', '2020-25', '2190', '31', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '14.85');
INSERT INTO public.europe_data_import VALUES (3769, '15/06/2020', '2020-24', '2326', '10', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '12.8');
INSERT INTO public.europe_data_import VALUES (3770, '08/06/2020', '2020-23', '1568', '8', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '9.71');
INSERT INTO public.europe_data_import VALUES (3771, '01/06/2020', '2020-22', '1387', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '7.68');
INSERT INTO public.europe_data_import VALUES (3772, '25/05/2020', '2020-21', '948', '3', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '7.96');
INSERT INTO public.europe_data_import VALUES (3773, '18/05/2020', '2020-20', '1472', '7', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '11.72');
INSERT INTO public.europe_data_import VALUES (3774, '11/05/2020', '2020-19', '2094', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '8.92');
INSERT INTO public.europe_data_import VALUES (3775, '04/05/2020', '2020-18', '619', '7', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '3.71');
INSERT INTO public.europe_data_import VALUES (3776, '27/04/2020', '2020-17', '508', '2', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '3.23');
INSERT INTO public.europe_data_import VALUES (3777, '20/04/2020', '2020-16', '476', '1', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '2.72');
INSERT INTO public.europe_data_import VALUES (3778, '13/04/2020', '2020-15', '352', '3', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (3779, '06/04/2020', '2020-14', '62', '0', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (3780, '30/03/2020', '2020-13', '128', '4', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '0.49');
INSERT INTO public.europe_data_import VALUES (3781, '23/03/2020', '2020-12', '22', '1', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (3782, '16/03/2020', '2020-11', '2', '0', '30417858', 'Ghana', 'GH', 'GHA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (3783, '01/02/2021', '2021-04', '148', '14', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '1317.27');
INSERT INTO public.europe_data_import VALUES (3784, '25/01/2021', '2021-03', '296', '20', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '2361.6');
INSERT INTO public.europe_data_import VALUES (3785, '18/01/2021', '2021-02', '500', '27', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '3750.07');
INSERT INTO public.europe_data_import VALUES (3786, '11/01/2021', '2021-01', '764', '8', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '4343.44');
INSERT INTO public.europe_data_import VALUES (3787, '04/01/2021', '2020-53', '700', '2', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '3447.46');
INSERT INTO public.europe_data_import VALUES (3788, '28/12/2020', '2020-52', '462', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '1872.07');
INSERT INTO public.europe_data_import VALUES (3789, '21/12/2020', '2020-51', '169', '1', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '566.66');
INSERT INTO public.europe_data_import VALUES (3790, '14/12/2020', '2020-50', '22', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '180.98');
INSERT INTO public.europe_data_import VALUES (3791, '07/12/2020', '2020-49', '39', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '281.85');
INSERT INTO public.europe_data_import VALUES (3792, '30/11/2020', '2020-48', '56', '1', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '332.29');
INSERT INTO public.europe_data_import VALUES (3793, '23/11/2020', '2020-47', '56', '3', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '489.53');
INSERT INTO public.europe_data_import VALUES (3794, '16/11/2020', '2020-46', '109', '1', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '590.4');
INSERT INTO public.europe_data_import VALUES (3795, '09/11/2020', '2020-45', '90', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '373.82');
INSERT INTO public.europe_data_import VALUES (3796, '02/11/2020', '2020-44', '36', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '391.62');
INSERT INTO public.europe_data_import VALUES (3797, '26/10/2020', '2020-43', '96', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '539.96');
INSERT INTO public.europe_data_import VALUES (3798, '19/10/2020', '2020-42', '86', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '412.39');
INSERT INTO public.europe_data_import VALUES (3799, '12/10/2020', '2020-41', '53', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '314.48');
INSERT INTO public.europe_data_import VALUES (3800, '05/10/2020', '2020-40', '53', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '243.28');
INSERT INTO public.europe_data_import VALUES (3801, '28/09/2020', '2020-39', '29', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '145.37');
INSERT INTO public.europe_data_import VALUES (3802, '21/09/2020', '2020-38', '20', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '103.84');
INSERT INTO public.europe_data_import VALUES (3803, '14/09/2020', '2020-37', '15', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '133.51');
INSERT INTO public.europe_data_import VALUES (3804, '07/09/2020', '2020-36', '30', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '255.15');
INSERT INTO public.europe_data_import VALUES (3805, '31/08/2020', '2020-35', '56', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '207.68');
INSERT INTO public.europe_data_import VALUES (3806, '24/08/2020', '2020-34', '14', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '94.94');
INSERT INTO public.europe_data_import VALUES (3807, '17/08/2020', '2020-33', '18', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '80.1');
INSERT INTO public.europe_data_import VALUES (3808, '10/08/2020', '2020-32', '9', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '35.6');
INSERT INTO public.europe_data_import VALUES (3809, '03/08/2020', '2020-31', '3', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '23.73');
INSERT INTO public.europe_data_import VALUES (3810, '27/07/2020', '2020-30', '5', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '14.83');
INSERT INTO public.europe_data_import VALUES (3811, '20/07/2020', '2020-29', '0', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '5.93');
INSERT INTO public.europe_data_import VALUES (3812, '13/07/2020', '2020-28', '2', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '8.9');
INSERT INTO public.europe_data_import VALUES (3813, '06/07/2020', '2020-27', '1', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '5.93');
INSERT INTO public.europe_data_import VALUES (3814, '29/06/2020', '2020-26', '1', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '2.97');
INSERT INTO public.europe_data_import VALUES (3815, '22/06/2020', '2020-25', '0', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '2.97');
INSERT INTO public.europe_data_import VALUES (3816, '15/06/2020', '2020-24', '1', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '20.77');
INSERT INTO public.europe_data_import VALUES (3817, '08/06/2020', '2020-23', '6', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '71.2');
INSERT INTO public.europe_data_import VALUES (3818, '01/06/2020', '2020-22', '18', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '65.27');
INSERT INTO public.europe_data_import VALUES (3819, '25/05/2020', '2020-21', '4', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '14.83');
INSERT INTO public.europe_data_import VALUES (3820, '18/05/2020', '2020-20', '1', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '8.9');
INSERT INTO public.europe_data_import VALUES (3821, '11/05/2020', '2020-19', '2', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '14.83');
INSERT INTO public.europe_data_import VALUES (3822, '04/05/2020', '2020-18', '3', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '32.64');
INSERT INTO public.europe_data_import VALUES (3823, '27/04/2020', '2020-17', '8', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '35.6');
INSERT INTO public.europe_data_import VALUES (3824, '20/04/2020', '2020-16', '4', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '89.0');
INSERT INTO public.europe_data_import VALUES (3825, '13/04/2020', '2020-15', '26', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '189.88');
INSERT INTO public.europe_data_import VALUES (3826, '06/04/2020', '2020-14', '38', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '261.08');
INSERT INTO public.europe_data_import VALUES (3827, '30/03/2020', '2020-13', '50', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '192.84');
INSERT INTO public.europe_data_import VALUES (3828, '23/03/2020', '2020-12', '15', '0', '33706', 'Gibraltar', 'GI', 'GIB', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3829, '01/02/2021', '2021-04', '4977', '150', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '77.86');
INSERT INTO public.europe_data_import VALUES (3830, '25/01/2021', '2021-03', '3373', '177', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '67.53');
INSERT INTO public.europe_data_import VALUES (3831, '18/01/2021', '2021-02', '3869', '206', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '79.33');
INSERT INTO public.europe_data_import VALUES (3832, '11/01/2021', '2021-01', '4639', '306', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '82.12');
INSERT INTO public.europe_data_import VALUES (3833, '04/01/2021', '2020-53', '4168', '285', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '84.17');
INSERT INTO public.europe_data_import VALUES (3834, '28/12/2020', '2020-52', '4859', '500', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '106.27');
INSERT INTO public.europe_data_import VALUES (3835, '21/12/2020', '2020-51', '6538', '547', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '145.47');
INSERT INTO public.europe_data_import VALUES (3836, '14/12/2020', '2020-50', '9063', '622', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '189.35');
INSERT INTO public.europe_data_import VALUES (3837, '07/12/2020', '2020-49', '11244', '682', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '222.4');
INSERT INTO public.europe_data_import VALUES (3838, '30/11/2020', '2020-48', '12608', '691', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '279.94');
INSERT INTO public.europe_data_import VALUES (3839, '23/11/2020', '2020-47', '17414', '524', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '325.62');
INSERT INTO public.europe_data_import VALUES (3840, '16/11/2020', '2020-46', '17507', '322', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '310.28');
INSERT INTO public.europe_data_import VALUES (3841, '09/11/2020', '2020-45', '15769', '149', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '241.65');
INSERT INTO public.europe_data_import VALUES (3842, '02/11/2020', '2020-44', '10147', '61', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '145.08');
INSERT INTO public.europe_data_import VALUES (3843, '26/10/2020', '2020-43', '5412', '65', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '78.55');
INSERT INTO public.europe_data_import VALUES (3844, '19/10/2020', '2020-42', '3012', '60', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '51.55');
INSERT INTO public.europe_data_import VALUES (3845, '12/10/2020', '2020-41', '2516', '40', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '45.82');
INSERT INTO public.europe_data_import VALUES (3846, '05/10/2020', '2020-40', '2398', '30', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '43.82');
INSERT INTO public.europe_data_import VALUES (3847, '28/09/2020', '2020-39', '2302', '41', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '39.2');
INSERT INTO public.europe_data_import VALUES (3848, '21/09/2020', '2020-38', '1902', '33', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '33.74');
INSERT INTO public.europe_data_import VALUES (3849, '14/09/2020', '2020-37', '1716', '21', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '28.96');
INSERT INTO public.europe_data_import VALUES (3850, '07/09/2020', '2020-36', '1390', '22', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '26.67');
INSERT INTO public.europe_data_import VALUES (3851, '31/08/2020', '2020-35', '1470', '20', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '28.52');
INSERT INTO public.europe_data_import VALUES (3852, '24/08/2020', '2020-34', '1589', '14', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '28.36');
INSERT INTO public.europe_data_import VALUES (3853, '17/08/2020', '2020-33', '1452', '16', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '22.5');
INSERT INTO public.europe_data_import VALUES (3854, '10/08/2020', '2020-32', '961', '4', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '13.33');
INSERT INTO public.europe_data_import VALUES (3855, '03/08/2020', '2020-31', '469', '6', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '6.11');
INSERT INTO public.europe_data_import VALUES (3856, '27/07/2020', '2020-30', '186', '8', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '3.64');
INSERT INTO public.europe_data_import VALUES (3857, '20/07/2020', '2020-29', '204', '1', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '4.55');
INSERT INTO public.europe_data_import VALUES (3858, '13/07/2020', '2020-28', '284', '1', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '3.98');
INSERT INTO public.europe_data_import VALUES (3859, '06/07/2020', '2020-27', '143', '1', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '2.36');
INSERT INTO public.europe_data_import VALUES (3860, '29/06/2020', '2020-26', '110', '1', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '2.38');
INSERT INTO public.europe_data_import VALUES (3861, '22/06/2020', '2020-25', '145', '7', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '2.51');
INSERT INTO public.europe_data_import VALUES (3862, '15/06/2020', '2020-24', '124', '3', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '1.9');
INSERT INTO public.europe_data_import VALUES (3863, '08/06/2020', '2020-23', '80', '5', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '1.11');
INSERT INTO public.europe_data_import VALUES (3864, '01/06/2020', '2020-22', '39', '4', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0.77');
INSERT INTO public.europe_data_import VALUES (3865, '25/05/2020', '2020-21', '44', '8', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '1.51');
INSERT INTO public.europe_data_import VALUES (3866, '18/05/2020', '2020-20', '118', '12', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '1.94');
INSERT INTO public.europe_data_import VALUES (3867, '11/05/2020', '2020-19', '90', '7', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '1.96');
INSERT INTO public.europe_data_import VALUES (3868, '04/05/2020', '2020-18', '120', '14', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '3.65');
INSERT INTO public.europe_data_import VALUES (3869, '27/04/2020', '2020-17', '271', '20', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '3.66');
INSERT INTO public.europe_data_import VALUES (3870, '20/04/2020', '2020-16', '121', '12', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '4.66');
INSERT INTO public.europe_data_import VALUES (3871, '13/04/2020', '2020-15', '379', '25', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '8.93');
INSERT INTO public.europe_data_import VALUES (3872, '06/04/2020', '2020-14', '579', '35', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '10.36');
INSERT INTO public.europe_data_import VALUES (3873, '30/03/2020', '2020-13', '532', '23', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '7.69');
INSERT INTO public.europe_data_import VALUES (3874, '23/03/2020', '2020-12', '293', '11', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '5.14');
INSERT INTO public.europe_data_import VALUES (3875, '16/03/2020', '2020-11', '258', '4', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (3876, '09/03/2020', '2020-10', '66', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0.68');
INSERT INTO public.europe_data_import VALUES (3877, '02/03/2020', '2020-09', '7', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0.07');
INSERT INTO public.europe_data_import VALUES (3878, '24/02/2020', '2020-08', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3879, '17/02/2020', '2020-07', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3880, '10/02/2020', '2020-06', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3881, '03/02/2020', '2020-05', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3882, '27/01/2020', '2020-04', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3883, '20/01/2020', '2020-03', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3884, '13/01/2020', '2020-02', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (3885, '06/01/2020', '2020-01', '0', '0', '10724599', 'Greece', 'EL', 'GRC', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (3886, '01/02/2021', '2021-04', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3887, '25/01/2021', '2021-03', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '5.29');
INSERT INTO public.europe_data_import VALUES (3888, '18/01/2021', '2021-02', '3', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '5.29');
INSERT INTO public.europe_data_import VALUES (3889, '11/01/2021', '2021-01', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3890, '04/01/2021', '2020-53', '1', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '14.12');
INSERT INTO public.europe_data_import VALUES (3891, '28/12/2020', '2020-52', '7', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '12.35');
INSERT INTO public.europe_data_import VALUES (3892, '21/12/2020', '2020-51', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3893, '14/12/2020', '2020-50', '1', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3894, '07/12/2020', '2020-49', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3895, '30/11/2020', '2020-48', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3896, '23/11/2020', '2020-47', '1', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3897, '16/11/2020', '2020-46', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3898, '09/11/2020', '2020-45', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3899, '02/11/2020', '2020-44', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3900, '26/10/2020', '2020-43', '1', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3901, '19/10/2020', '2020-42', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '3.53');
INSERT INTO public.europe_data_import VALUES (3902, '12/10/2020', '2020-41', '2', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '3.53');
INSERT INTO public.europe_data_import VALUES (3903, '05/10/2020', '2020-40', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3904, '28/09/2020', '2020-39', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3905, '21/09/2020', '2020-38', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3906, '14/09/2020', '2020-37', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3907, '07/09/2020', '2020-36', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3908, '31/08/2020', '2020-35', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3909, '24/08/2020', '2020-34', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3910, '17/08/2020', '2020-33', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3911, '10/08/2020', '2020-32', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3912, '03/08/2020', '2020-31', '1', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3913, '27/07/2020', '2020-30', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3914, '20/07/2020', '2020-29', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3915, '13/07/2020', '2020-28', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3916, '06/07/2020', '2020-27', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3917, '29/06/2020', '2020-26', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3918, '22/06/2020', '2020-25', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3919, '15/06/2020', '2020-24', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3920, '08/06/2020', '2020-23', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '3.53');
INSERT INTO public.europe_data_import VALUES (3921, '01/06/2020', '2020-22', '2', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '3.53');
INSERT INTO public.europe_data_import VALUES (3922, '25/05/2020', '2020-21', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3923, '18/05/2020', '2020-20', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3924, '11/05/2020', '2020-19', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3925, '04/05/2020', '2020-18', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3926, '27/04/2020', '2020-17', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3927, '20/04/2020', '2020-16', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3928, '13/04/2020', '2020-15', '0', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '1.76');
INSERT INTO public.europe_data_import VALUES (3929, '06/04/2020', '2020-14', '1', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '15.88');
INSERT INTO public.europe_data_import VALUES (3930, '30/03/2020', '2020-13', '8', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '17.65');
INSERT INTO public.europe_data_import VALUES (3931, '23/03/2020', '2020-12', '2', '0', '56660', 'Greenland', 'GL', 'GRL', 'America', '');
INSERT INTO public.europe_data_import VALUES (3932, '01/02/2021', '2021-04', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '8.04');
INSERT INTO public.europe_data_import VALUES (3933, '25/01/2021', '2021-03', '9', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '11.61');
INSERT INTO public.europe_data_import VALUES (3934, '18/01/2021', '2021-02', '4', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '4.46');
INSERT INTO public.europe_data_import VALUES (3935, '11/01/2021', '2021-01', '1', '1', '112002', 'Grenada', 'GD', 'GRD', 'America', '16.96');
INSERT INTO public.europe_data_import VALUES (3936, '04/01/2021', '2020-53', '18', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '24.11');
INSERT INTO public.europe_data_import VALUES (3937, '28/12/2020', '2020-52', '9', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '41.96');
INSERT INTO public.europe_data_import VALUES (3938, '21/12/2020', '2020-51', '38', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '58.93');
INSERT INTO public.europe_data_import VALUES (3939, '14/12/2020', '2020-50', '28', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '25.0');
INSERT INTO public.europe_data_import VALUES (3940, '07/12/2020', '2020-49', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3941, '30/11/2020', '2020-48', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '8.04');
INSERT INTO public.europe_data_import VALUES (3942, '23/11/2020', '2020-47', '9', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '8.04');
INSERT INTO public.europe_data_import VALUES (3943, '16/11/2020', '2020-46', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '3.57');
INSERT INTO public.europe_data_import VALUES (3944, '09/11/2020', '2020-45', '4', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '3.57');
INSERT INTO public.europe_data_import VALUES (3945, '02/11/2020', '2020-44', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3946, '26/10/2020', '2020-43', '1', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '3.57');
INSERT INTO public.europe_data_import VALUES (3947, '19/10/2020', '2020-42', '3', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '2.68');
INSERT INTO public.europe_data_import VALUES (3948, '12/10/2020', '2020-41', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3949, '05/10/2020', '2020-40', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3950, '28/09/2020', '2020-39', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3951, '21/09/2020', '2020-38', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3952, '14/09/2020', '2020-37', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3953, '07/09/2020', '2020-36', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3954, '31/08/2020', '2020-35', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3955, '24/08/2020', '2020-34', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3956, '17/08/2020', '2020-33', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3957, '10/08/2020', '2020-32', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3958, '03/08/2020', '2020-31', '1', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3959, '27/07/2020', '2020-30', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3960, '20/07/2020', '2020-29', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3961, '13/07/2020', '2020-28', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3962, '06/07/2020', '2020-27', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3963, '29/06/2020', '2020-26', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3964, '22/06/2020', '2020-25', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3965, '15/06/2020', '2020-24', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0');
INSERT INTO public.europe_data_import VALUES (3966, '08/06/2020', '2020-23', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3967, '01/06/2020', '2020-22', '1', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3968, '25/05/2020', '2020-21', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3969, '18/05/2020', '2020-20', '1', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '0.89');
INSERT INTO public.europe_data_import VALUES (3970, '11/05/2020', '2020-19', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '2.68');
INSERT INTO public.europe_data_import VALUES (3971, '04/05/2020', '2020-18', '3', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '6.25');
INSERT INTO public.europe_data_import VALUES (3972, '27/04/2020', '2020-17', '4', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '3.57');
INSERT INTO public.europe_data_import VALUES (3973, '20/04/2020', '2020-16', '0', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '1.79');
INSERT INTO public.europe_data_import VALUES (3974, '13/04/2020', '2020-15', '2', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '4.46');
INSERT INTO public.europe_data_import VALUES (3975, '06/04/2020', '2020-14', '3', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '9.82');
INSERT INTO public.europe_data_import VALUES (3976, '30/03/2020', '2020-13', '8', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '8.04');
INSERT INTO public.europe_data_import VALUES (3977, '23/03/2020', '2020-12', '1', '0', '112002', 'Grenada', 'GD', 'GRD', 'America', '');
INSERT INTO public.europe_data_import VALUES (3978, '01/02/2021', '2021-04', '54', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '73.52');
INSERT INTO public.europe_data_import VALUES (3979, '25/01/2021', '2021-03', '69', '1', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '78.3');
INSERT INTO public.europe_data_import VALUES (3980, '18/01/2021', '2021-02', '62', '4', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '94.44');
INSERT INTO public.europe_data_import VALUES (3981, '11/01/2021', '2021-01', '96', '1', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '91.46');
INSERT INTO public.europe_data_import VALUES (3982, '04/01/2021', '2020-53', '57', '2', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '69.34');
INSERT INTO public.europe_data_import VALUES (3983, '28/12/2020', '2020-52', '59', '1', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '98.03');
INSERT INTO public.europe_data_import VALUES (3984, '21/12/2020', '2020-51', '105', '2', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '123.73');
INSERT INTO public.europe_data_import VALUES (3985, '14/12/2020', '2020-50', '102', '5', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '172.15');
INSERT INTO public.europe_data_import VALUES (3986, '07/12/2020', '2020-49', '186', '1', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '271.97');
INSERT INTO public.europe_data_import VALUES (3987, '30/11/2020', '2020-48', '269', '6', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '416.63');
INSERT INTO public.europe_data_import VALUES (3988, '23/11/2020', '2020-47', '428', '8', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '786.63');
INSERT INTO public.europe_data_import VALUES (3989, '16/11/2020', '2020-46', '888', '9', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '853.58');
INSERT INTO public.europe_data_import VALUES (3990, '09/11/2020', '2020-45', '540', '10', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '607.91');
INSERT INTO public.europe_data_import VALUES (3991, '02/11/2020', '2020-44', '477', '7', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '608.51');
INSERT INTO public.europe_data_import VALUES (3992, '26/10/2020', '2020-43', '541', '6', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '680.24');
INSERT INTO public.europe_data_import VALUES (3993, '19/10/2020', '2020-42', '597', '6', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '583.4');
INSERT INTO public.europe_data_import VALUES (3994, '12/10/2020', '2020-41', '379', '8', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '432.77');
INSERT INTO public.europe_data_import VALUES (3995, '05/10/2020', '2020-40', '345', '10', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '347.89');
INSERT INTO public.europe_data_import VALUES (3996, '28/09/2020', '2020-39', '237', '8', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '276.76');
INSERT INTO public.europe_data_import VALUES (3997, '21/09/2020', '2020-38', '226', '9', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '297.68');
INSERT INTO public.europe_data_import VALUES (3998, '14/09/2020', '2020-37', '272', '11', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '325.17');
INSERT INTO public.europe_data_import VALUES (3999, '07/09/2020', '2020-36', '272', '4', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '477.6');
INSERT INTO public.europe_data_import VALUES (4000, '31/08/2020', '2020-35', '527', '3', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '471.62');
INSERT INTO public.europe_data_import VALUES (4001, '24/08/2020', '2020-34', '262', '2', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '240.29');
INSERT INTO public.europe_data_import VALUES (4002, '17/08/2020', '2020-33', '140', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '113.57');
INSERT INTO public.europe_data_import VALUES (4003, '10/08/2020', '2020-32', '50', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '43.04');
INSERT INTO public.europe_data_import VALUES (4004, '03/08/2020', '2020-31', '22', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '29.29');
INSERT INTO public.europe_data_import VALUES (4005, '27/07/2020', '2020-30', '27', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '20.32');
INSERT INTO public.europe_data_import VALUES (4006, '20/07/2020', '2020-29', '7', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '10.76');
INSERT INTO public.europe_data_import VALUES (4007, '13/07/2020', '2020-28', '11', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '35.27');
INSERT INTO public.europe_data_import VALUES (4008, '06/07/2020', '2020-27', '48', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '47.22');
INSERT INTO public.europe_data_import VALUES (4009, '29/06/2020', '2020-26', '31', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '40.65');
INSERT INTO public.europe_data_import VALUES (4010, '22/06/2020', '2020-25', '37', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '25.7');
INSERT INTO public.europe_data_import VALUES (4011, '15/06/2020', '2020-24', '6', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '5.98');
INSERT INTO public.europe_data_import VALUES (4012, '08/06/2020', '2020-23', '4', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '7.77');
INSERT INTO public.europe_data_import VALUES (4013, '01/06/2020', '2020-22', '9', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '12.55');
INSERT INTO public.europe_data_import VALUES (4014, '25/05/2020', '2020-21', '12', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '8.97');
INSERT INTO public.europe_data_import VALUES (4015, '18/05/2020', '2020-20', '3', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '2.99');
INSERT INTO public.europe_data_import VALUES (4016, '11/05/2020', '2020-19', '2', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '5.38');
INSERT INTO public.europe_data_import VALUES (4017, '04/05/2020', '2020-18', '7', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '7.77');
INSERT INTO public.europe_data_import VALUES (4018, '27/04/2020', '2020-17', '6', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '5.38');
INSERT INTO public.europe_data_import VALUES (4019, '20/04/2020', '2020-16', '3', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '15.54');
INSERT INTO public.europe_data_import VALUES (4020, '13/04/2020', '2020-15', '23', '1', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '46.03');
INSERT INTO public.europe_data_import VALUES (4021, '06/04/2020', '2020-14', '54', '3', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '49.61');
INSERT INTO public.europe_data_import VALUES (4022, '30/03/2020', '2020-13', '29', '0', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '33.47');
INSERT INTO public.europe_data_import VALUES (4023, '23/03/2020', '2020-12', '27', '1', '167295', 'Guam', 'GU', 'GUM', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (4024, '01/02/2021', '2021-04', '5202', '204', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '59.64');
INSERT INTO public.europe_data_import VALUES (4025, '25/01/2021', '2021-03', '5284', '191', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '64.03');
INSERT INTO public.europe_data_import VALUES (4026, '18/01/2021', '2021-02', '5973', '228', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '59.67');
INSERT INTO public.europe_data_import VALUES (4027, '11/01/2021', '2021-01', '4517', '215', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '43.98');
INSERT INTO public.europe_data_import VALUES (4028, '04/01/2021', '2020-53', '3215', '62', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '28.75');
INSERT INTO public.europe_data_import VALUES (4029, '28/12/2020', '2020-52', '1840', '55', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '35.03');
INSERT INTO public.europe_data_import VALUES (4030, '21/12/2020', '2020-51', '4319', '295', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '45.79');
INSERT INTO public.europe_data_import VALUES (4031, '14/12/2020', '2020-50', '3732', '173', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '41.58');
INSERT INTO public.europe_data_import VALUES (4032, '07/12/2020', '2020-49', '3579', '84', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '39.37');
INSERT INTO public.europe_data_import VALUES (4033, '30/11/2020', '2020-48', '3342', '90', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '40.3');
INSERT INTO public.europe_data_import VALUES (4034, '23/11/2020', '2020-47', '3744', '144', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '41.9');
INSERT INTO public.europe_data_import VALUES (4035, '16/11/2020', '2020-46', '3623', '111', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '38.57');
INSERT INTO public.europe_data_import VALUES (4036, '09/11/2020', '2020-45', '3158', '83', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '36.83');
INSERT INTO public.europe_data_import VALUES (4037, '02/11/2020', '2020-44', '3317', '94', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '38.36');
INSERT INTO public.europe_data_import VALUES (4038, '26/10/2020', '2020-43', '3427', '114', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '40.22');
INSERT INTO public.europe_data_import VALUES (4039, '19/10/2020', '2020-42', '3645', '146', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '42.07');
INSERT INTO public.europe_data_import VALUES (4040, '12/10/2020', '2020-41', '3752', '91', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '43.36');
INSERT INTO public.europe_data_import VALUES (4041, '05/10/2020', '2020-40', '3871', '64', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '48.45');
INSERT INTO public.europe_data_import VALUES (4042, '28/09/2020', '2020-39', '4648', '110', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '46.54');
INSERT INTO public.europe_data_import VALUES (4043, '21/09/2020', '2020-38', '3535', '162', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '44.14');
INSERT INTO public.europe_data_import VALUES (4044, '14/09/2020', '2020-37', '4226', '105', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '45.49');
INSERT INTO public.europe_data_import VALUES (4045, '07/09/2020', '2020-36', '3771', '112', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '54.01');
INSERT INTO public.europe_data_import VALUES (4046, '31/08/2020', '2020-35', '5724', '146', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '64.56');
INSERT INTO public.europe_data_import VALUES (4047, '24/08/2020', '2020-34', '5626', '215', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '65.88');
INSERT INTO public.europe_data_import VALUES (4048, '17/08/2020', '2020-33', '5957', '168', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '64.02');
INSERT INTO public.europe_data_import VALUES (4049, '10/08/2020', '2020-32', '5299', '216', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '65.71');
INSERT INTO public.europe_data_import VALUES (4050, '03/08/2020', '2020-31', '6253', '261', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '71.83');
INSERT INTO public.europe_data_import VALUES (4051, '27/07/2020', '2020-30', '6376', '249', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '89.29');
INSERT INTO public.europe_data_import VALUES (4052, '20/07/2020', '2020-29', '9322', '266', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '87.76');
INSERT INTO public.europe_data_import VALUES (4053, '13/07/2020', '2020-28', '6107', '272', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '70.67');
INSERT INTO public.europe_data_import VALUES (4054, '06/07/2020', '2020-27', '6318', '220', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '57.46');
INSERT INTO public.europe_data_import VALUES (4055, '29/06/2020', '2020-26', '3785', '196', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '40.3');
INSERT INTO public.europe_data_import VALUES (4056, '22/06/2020', '2020-25', '3300', '147', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '34.64');
INSERT INTO public.europe_data_import VALUES (4057, '15/06/2020', '2020-24', '2790', '132', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '27.06');
INSERT INTO public.europe_data_import VALUES (4058, '08/06/2020', '2020-23', '1968', '144', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '20.65');
INSERT INTO public.europe_data_import VALUES (4059, '01/06/2020', '2020-22', '1663', '50', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '18.06');
INSERT INTO public.europe_data_import VALUES (4060, '25/05/2020', '2020-21', '1512', '23', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '13.49');
INSERT INTO public.europe_data_import VALUES (4061, '18/05/2020', '2020-20', '860', '9', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '6.88');
INSERT INTO public.europe_data_import VALUES (4062, '11/05/2020', '2020-19', '349', '9', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '3.14');
INSERT INTO public.europe_data_import VALUES (4063, '04/05/2020', '2020-18', '203', '2', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '2.35');
INSERT INTO public.europe_data_import VALUES (4064, '27/04/2020', '2020-17', '211', '8', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '1.96');
INSERT INTO public.europe_data_import VALUES (4065, '20/04/2020', '2020-16', '133', '2', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '1.25');
INSERT INTO public.europe_data_import VALUES (4066, '13/04/2020', '2020-15', '86', '2', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '0.68');
INSERT INTO public.europe_data_import VALUES (4067, '06/04/2020', '2020-14', '34', '2', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '0.29');
INSERT INTO public.europe_data_import VALUES (4068, '30/03/2020', '2020-13', '17', '0', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '0.2');
INSERT INTO public.europe_data_import VALUES (4069, '23/03/2020', '2020-12', '18', '0', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '0.11');
INSERT INTO public.europe_data_import VALUES (4070, '16/03/2020', '2020-11', '1', '1', '17581476', 'Guatemala', 'GT', 'GTM', 'America', '');
INSERT INTO public.europe_data_import VALUES (4071, '01/02/2021', '2021-04', '218', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '356.77');
INSERT INTO public.europe_data_import VALUES (4072, '25/01/2021', '2021-03', '12', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '24.82');
INSERT INTO public.europe_data_import VALUES (4073, '18/01/2021', '2021-02', '4', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '13.96');
INSERT INTO public.europe_data_import VALUES (4074, '11/01/2021', '2021-01', '5', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '12.41');
INSERT INTO public.europe_data_import VALUES (4075, '04/01/2021', '2020-53', '3', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '10.86');
INSERT INTO public.europe_data_import VALUES (4076, '28/12/2020', '2020-52', '4', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '12.41');
INSERT INTO public.europe_data_import VALUES (4077, '21/12/2020', '2020-51', '4', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '7.76');
INSERT INTO public.europe_data_import VALUES (4078, '14/12/2020', '2020-50', '1', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '4.65');
INSERT INTO public.europe_data_import VALUES (4079, '07/12/2020', '2020-49', '2', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '7.76');
INSERT INTO public.europe_data_import VALUES (4080, '30/11/2020', '2020-48', '3', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '6.2');
INSERT INTO public.europe_data_import VALUES (4081, '23/11/2020', '2020-47', '1', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '6.2');
INSERT INTO public.europe_data_import VALUES (4082, '16/11/2020', '2020-46', '3', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '18.61');
INSERT INTO public.europe_data_import VALUES (4083, '09/11/2020', '2020-45', '9', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '21.72');
INSERT INTO public.europe_data_import VALUES (4084, '02/11/2020', '2020-44', '5', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '18.61');
INSERT INTO public.europe_data_import VALUES (4085, '26/10/2020', '2020-43', '7', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '10.86');
INSERT INTO public.europe_data_import VALUES (4086, '19/10/2020', '2020-42', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '1.55');
INSERT INTO public.europe_data_import VALUES (4087, '12/10/2020', '2020-41', '1', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '3.1');
INSERT INTO public.europe_data_import VALUES (4088, '05/10/2020', '2020-40', '1', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '3.1');
INSERT INTO public.europe_data_import VALUES (4089, '28/09/2020', '2020-39', '1', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '4.65');
INSERT INTO public.europe_data_import VALUES (4090, '21/09/2020', '2020-38', '2', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '4.65');
INSERT INTO public.europe_data_import VALUES (4091, '14/09/2020', '2020-37', '1', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '1.55');
INSERT INTO public.europe_data_import VALUES (4092, '07/09/2020', '2020-36', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4093, '31/08/2020', '2020-35', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4094, '24/08/2020', '2020-34', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4095, '17/08/2020', '2020-33', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4096, '10/08/2020', '2020-32', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4097, '03/08/2020', '2020-31', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4098, '27/07/2020', '2020-30', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4099, '20/07/2020', '2020-29', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4100, '13/07/2020', '2020-28', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4101, '06/07/2020', '2020-27', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4102, '29/06/2020', '2020-26', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4103, '22/06/2020', '2020-25', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4104, '15/06/2020', '2020-24', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4105, '08/06/2020', '2020-23', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4106, '01/06/2020', '2020-22', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4107, '25/05/2020', '2020-21', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4108, '18/05/2020', '2020-20', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4109, '11/05/2020', '2020-19', '0', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '7.76');
INSERT INTO public.europe_data_import VALUES (4110, '04/05/2020', '2020-18', '5', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '20.17');
INSERT INTO public.europe_data_import VALUES (4111, '27/04/2020', '2020-17', '8', '4', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '44.98');
INSERT INTO public.europe_data_import VALUES (4112, '20/04/2020', '2020-16', '21', '3', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '131.85');
INSERT INTO public.europe_data_import VALUES (4113, '13/04/2020', '2020-15', '64', '3', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '268.35');
INSERT INTO public.europe_data_import VALUES (4114, '06/04/2020', '2020-14', '109', '3', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '212.51');
INSERT INTO public.europe_data_import VALUES (4115, '30/03/2020', '2020-13', '28', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '69.8');
INSERT INTO public.europe_data_import VALUES (4116, '23/03/2020', '2020-12', '17', '0', '64468', 'Guernsey', 'GG', 'GGY', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4117, '01/02/2021', '2021-04', '176', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.0');
INSERT INTO public.europe_data_import VALUES (4118, '25/01/2021', '2021-03', '207', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.05');
INSERT INTO public.europe_data_import VALUES (4119, '18/01/2021', '2021-02', '183', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '2.92');
INSERT INTO public.europe_data_import VALUES (4120, '11/01/2021', '2021-01', '190', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '2.36');
INSERT INTO public.europe_data_import VALUES (4121, '04/01/2021', '2020-53', '111', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '1.95');
INSERT INTO public.europe_data_import VALUES (4122, '28/12/2020', '2020-52', '138', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '1.81');
INSERT INTO public.europe_data_import VALUES (4123, '21/12/2020', '2020-51', '93', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '2.48');
INSERT INTO public.europe_data_import VALUES (4124, '14/12/2020', '2020-50', '224', '4', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.27');
INSERT INTO public.europe_data_import VALUES (4125, '07/12/2020', '2020-49', '194', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.19');
INSERT INTO public.europe_data_import VALUES (4126, '30/11/2020', '2020-48', '213', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.35');
INSERT INTO public.europe_data_import VALUES (4127, '23/11/2020', '2020-47', '215', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.13');
INSERT INTO public.europe_data_import VALUES (4128, '16/11/2020', '2020-46', '185', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.26');
INSERT INTO public.europe_data_import VALUES (4129, '09/11/2020', '2020-45', '231', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.93');
INSERT INTO public.europe_data_import VALUES (4130, '02/11/2020', '2020-44', '526', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.3');
INSERT INTO public.europe_data_import VALUES (4131, '26/10/2020', '2020-43', '151', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.07');
INSERT INTO public.europe_data_import VALUES (4132, '19/10/2020', '2020-42', '496', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.98');
INSERT INTO public.europe_data_import VALUES (4133, '12/10/2020', '2020-41', '268', '3', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.46');
INSERT INTO public.europe_data_import VALUES (4134, '05/10/2020', '2020-40', '174', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.36');
INSERT INTO public.europe_data_import VALUES (4135, '28/09/2020', '2020-39', '255', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '4.38');
INSERT INTO public.europe_data_import VALUES (4136, '21/09/2020', '2020-38', '305', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '4.72');
INSERT INTO public.europe_data_import VALUES (4137, '14/09/2020', '2020-37', '298', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.08');
INSERT INTO public.europe_data_import VALUES (4138, '07/09/2020', '2020-36', '351', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.91');
INSERT INTO public.europe_data_import VALUES (4139, '31/08/2020', '2020-35', '404', '6', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.96');
INSERT INTO public.europe_data_import VALUES (4140, '24/08/2020', '2020-34', '485', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '8.12');
INSERT INTO public.europe_data_import VALUES (4141, '17/08/2020', '2020-33', '552', '1', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '8.75');
INSERT INTO public.europe_data_import VALUES (4142, '10/08/2020', '2020-32', '566', '4', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '7.22');
INSERT INTO public.europe_data_import VALUES (4143, '03/08/2020', '2020-31', '356', '3', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.42');
INSERT INTO public.europe_data_import VALUES (4144, '27/07/2020', '2020-30', '464', '4', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.79');
INSERT INTO public.europe_data_import VALUES (4145, '20/07/2020', '2020-29', '403', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '7.31');
INSERT INTO public.europe_data_import VALUES (4146, '13/07/2020', '2020-28', '531', '3', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.26');
INSERT INTO public.europe_data_import VALUES (4147, '06/07/2020', '2020-27', '268', '3', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '4.87');
INSERT INTO public.europe_data_import VALUES (4148, '29/06/2020', '2020-26', '354', '4', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.34');
INSERT INTO public.europe_data_import VALUES (4149, '22/06/2020', '2020-25', '456', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.44');
INSERT INTO public.europe_data_import VALUES (4150, '15/06/2020', '2020-24', '367', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '5.96');
INSERT INTO public.europe_data_import VALUES (4151, '08/06/2020', '2020-23', '394', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.97');
INSERT INTO public.europe_data_import VALUES (4152, '01/06/2020', '2020-22', '496', '3', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '8.71');
INSERT INTO public.europe_data_import VALUES (4153, '25/05/2020', '2020-21', '617', '4', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '8.84');
INSERT INTO public.europe_data_import VALUES (4154, '18/05/2020', '2020-20', '512', '5', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '8.39');
INSERT INTO public.europe_data_import VALUES (4155, '11/05/2020', '2020-19', '560', '4', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '8.24');
INSERT INTO public.europe_data_import VALUES (4156, '04/05/2020', '2020-18', '492', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '7.88');
INSERT INTO public.europe_data_import VALUES (4157, '27/04/2020', '2020-17', '515', '2', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '6.61');
INSERT INTO public.europe_data_import VALUES (4158, '20/04/2020', '2020-16', '329', '5', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '3.59');
INSERT INTO public.europe_data_import VALUES (4159, '13/04/2020', '2020-15', '129', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '1.89');
INSERT INTO public.europe_data_import VALUES (4160, '06/04/2020', '2020-14', '113', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '0.93');
INSERT INTO public.europe_data_import VALUES (4161, '30/03/2020', '2020-13', '6', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (4162, '23/03/2020', '2020-12', '2', '0', '12771246', 'Guinea', 'GN', 'GIN', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (4163, '01/02/2021', '2021-04', '103', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '6.56');
INSERT INTO public.europe_data_import VALUES (4164, '25/01/2021', '2021-03', '23', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '2.81');
INSERT INTO public.europe_data_import VALUES (4165, '18/01/2021', '2021-02', '31', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '3.23');
INSERT INTO public.europe_data_import VALUES (4166, '11/01/2021', '2021-01', '31', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.61');
INSERT INTO public.europe_data_import VALUES (4167, '04/01/2021', '2020-53', '0', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (4168, '28/12/2020', '2020-52', '0', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (4169, '21/12/2020', '2020-51', '0', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (4170, '14/12/2020', '2020-50', '5', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.3');
INSERT INTO public.europe_data_import VALUES (4171, '07/12/2020', '2020-49', '20', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.09');
INSERT INTO public.europe_data_import VALUES (4172, '30/11/2020', '2020-48', '1', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (4173, '23/11/2020', '2020-47', '2', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (4174, '16/11/2020', '2020-46', '6', '2', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (4175, '09/11/2020', '2020-45', '0', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (4176, '02/11/2020', '2020-44', '10', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.25');
INSERT INTO public.europe_data_import VALUES (4177, '26/10/2020', '2020-43', '14', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.94');
INSERT INTO public.europe_data_import VALUES (4178, '19/10/2020', '2020-42', '4', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (4179, '12/10/2020', '2020-41', '23', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '3.18');
INSERT INTO public.europe_data_import VALUES (4180, '05/10/2020', '2020-40', '38', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '3.07');
INSERT INTO public.europe_data_import VALUES (4181, '28/09/2020', '2020-39', '21', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '2.55');
INSERT INTO public.europe_data_import VALUES (4182, '21/09/2020', '2020-38', '28', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '3.02');
INSERT INTO public.europe_data_import VALUES (4183, '14/09/2020', '2020-37', '30', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '3.64');
INSERT INTO public.europe_data_import VALUES (4184, '07/09/2020', '2020-36', '40', '4', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '5.0');
INSERT INTO public.europe_data_import VALUES (4185, '31/08/2020', '2020-35', '56', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '4.58');
INSERT INTO public.europe_data_import VALUES (4186, '24/08/2020', '2020-34', '32', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '5.05');
INSERT INTO public.europe_data_import VALUES (4187, '17/08/2020', '2020-33', '65', '4', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '7.08');
INSERT INTO public.europe_data_import VALUES (4188, '10/08/2020', '2020-32', '71', '3', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '5.1');
INSERT INTO public.europe_data_import VALUES (4189, '03/08/2020', '2020-31', '27', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '2.81');
INSERT INTO public.europe_data_import VALUES (4190, '27/07/2020', '2020-30', '27', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '5.83');
INSERT INTO public.europe_data_import VALUES (4191, '20/07/2020', '2020-29', '85', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '8.43');
INSERT INTO public.europe_data_import VALUES (4192, '13/07/2020', '2020-28', '77', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '11.87');
INSERT INTO public.europe_data_import VALUES (4193, '06/07/2020', '2020-27', '151', '4', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '11.66');
INSERT INTO public.europe_data_import VALUES (4194, '29/06/2020', '2020-26', '73', '4', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '8.02');
INSERT INTO public.europe_data_import VALUES (4195, '22/06/2020', '2020-25', '81', '2', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '9.01');
INSERT INTO public.europe_data_import VALUES (4196, '15/06/2020', '2020-24', '92', '3', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '7.18');
INSERT INTO public.europe_data_import VALUES (4197, '08/06/2020', '2020-23', '46', '4', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '10.15');
INSERT INTO public.europe_data_import VALUES (4198, '01/06/2020', '2020-22', '149', '2', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '17.28');
INSERT INTO public.europe_data_import VALUES (4199, '25/05/2020', '2020-21', '183', '2', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '23.27');
INSERT INTO public.europe_data_import VALUES (4200, '18/05/2020', '2020-20', '264', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '36.34');
INSERT INTO public.europe_data_import VALUES (4201, '11/05/2020', '2020-19', '434', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '35.04');
INSERT INTO public.europe_data_import VALUES (4202, '04/05/2020', '2020-18', '239', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '12.6');
INSERT INTO public.europe_data_import VALUES (4203, '27/04/2020', '2020-17', '3', '1', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.73');
INSERT INTO public.europe_data_import VALUES (4204, '20/04/2020', '2020-16', '11', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.67');
INSERT INTO public.europe_data_import VALUES (4205, '13/04/2020', '2020-15', '21', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '1.93');
INSERT INTO public.europe_data_import VALUES (4206, '06/04/2020', '2020-14', '16', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '0.94');
INSERT INTO public.europe_data_import VALUES (4207, '30/03/2020', '2020-13', '2', '0', '1920917', 'Guinea_Bissau', 'GW', 'GNB', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (4208, '01/02/2021', '2021-04', '324', '4', '782775', 'Guyana', 'GY', 'GUY', 'America', '93.64');
INSERT INTO public.europe_data_import VALUES (4209, '25/01/2021', '2021-03', '409', '2', '782775', 'Guyana', 'GY', 'GUY', 'America', '71.92');
INSERT INTO public.europe_data_import VALUES (4210, '18/01/2021', '2021-02', '154', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '70.26');
INSERT INTO public.europe_data_import VALUES (4211, '11/01/2021', '2021-01', '396', '5', '782775', 'Guyana', 'GY', 'GUY', 'America', '58.89');
INSERT INTO public.europe_data_import VALUES (4212, '04/01/2021', '2020-53', '65', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '23.89');
INSERT INTO public.europe_data_import VALUES (4213, '28/12/2020', '2020-52', '122', '5', '782775', 'Guyana', 'GY', 'GUY', 'America', '47.65');
INSERT INTO public.europe_data_import VALUES (4214, '21/12/2020', '2020-51', '251', '4', '782775', 'Guyana', 'GY', 'GUY', 'America', '64.64');
INSERT INTO public.europe_data_import VALUES (4215, '14/12/2020', '2020-50', '255', '2', '782775', 'Guyana', 'GY', 'GUY', 'America', '69.5');
INSERT INTO public.europe_data_import VALUES (4216, '07/12/2020', '2020-49', '289', '3', '782775', 'Guyana', 'GY', 'GUY', 'America', '67.96');
INSERT INTO public.europe_data_import VALUES (4217, '30/11/2020', '2020-48', '243', '7', '782775', 'Guyana', 'GY', 'GUY', 'America', '70.65');
INSERT INTO public.europe_data_import VALUES (4218, '23/11/2020', '2020-47', '310', '4', '782775', 'Guyana', 'GY', 'GUY', 'America', '79.08');
INSERT INTO public.europe_data_import VALUES (4219, '16/11/2020', '2020-46', '309', '5', '782775', 'Guyana', 'GY', 'GUY', 'America', '78.57');
INSERT INTO public.europe_data_import VALUES (4220, '09/11/2020', '2020-45', '306', '8', '782775', 'Guyana', 'GY', 'GUY', 'America', '62.73');
INSERT INTO public.europe_data_import VALUES (4221, '02/11/2020', '2020-44', '185', '7', '782775', 'Guyana', 'GY', 'GUY', 'America', '60.55');
INSERT INTO public.europe_data_import VALUES (4222, '26/10/2020', '2020-43', '289', '10', '782775', 'Guyana', 'GY', 'GUY', 'America', '70.77');
INSERT INTO public.europe_data_import VALUES (4223, '19/10/2020', '2020-42', '265', '6', '782775', 'Guyana', 'GY', 'GUY', 'America', '81.89');
INSERT INTO public.europe_data_import VALUES (4224, '12/10/2020', '2020-41', '376', '16', '782775', 'Guyana', 'GY', 'GUY', 'America', '89.04');
INSERT INTO public.europe_data_import VALUES (4225, '05/10/2020', '2020-40', '321', '11', '782775', 'Guyana', 'GY', 'GUY', 'America', '105.27');
INSERT INTO public.europe_data_import VALUES (4226, '28/09/2020', '2020-39', '503', '12', '782775', 'Guyana', 'GY', 'GUY', 'America', '117.4');
INSERT INTO public.europe_data_import VALUES (4227, '21/09/2020', '2020-38', '416', '8', '782775', 'Guyana', 'GY', 'GUY', 'America', '102.33');
INSERT INTO public.europe_data_import VALUES (4228, '14/09/2020', '2020-37', '385', '10', '782775', 'Guyana', 'GY', 'GUY', 'America', '79.08');
INSERT INTO public.europe_data_import VALUES (4229, '07/09/2020', '2020-36', '234', '9', '782775', 'Guyana', 'GY', 'GUY', 'America', '65.54');
INSERT INTO public.europe_data_import VALUES (4230, '31/08/2020', '2020-35', '279', '6', '782775', 'Guyana', 'GY', 'GUY', 'America', '67.07');
INSERT INTO public.europe_data_import VALUES (4231, '24/08/2020', '2020-34', '246', '8', '782775', 'Guyana', 'GY', 'GUY', 'America', '49.44');
INSERT INTO public.europe_data_import VALUES (4232, '17/08/2020', '2020-33', '141', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '30.02');
INSERT INTO public.europe_data_import VALUES (4233, '10/08/2020', '2020-32', '94', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '25.29');
INSERT INTO public.europe_data_import VALUES (4234, '03/08/2020', '2020-31', '104', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '17.63');
INSERT INTO public.europe_data_import VALUES (4235, '27/07/2020', '2020-30', '34', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '9.33');
INSERT INTO public.europe_data_import VALUES (4236, '20/07/2020', '2020-29', '39', '2', '782775', 'Guyana', 'GY', 'GUY', 'America', '8.05');
INSERT INTO public.europe_data_import VALUES (4237, '13/07/2020', '2020-28', '24', '2', '782775', 'Guyana', 'GY', 'GUY', 'America', '8.56');
INSERT INTO public.europe_data_import VALUES (4238, '06/07/2020', '2020-27', '43', '3', '782775', 'Guyana', 'GY', 'GUY', 'America', '11.37');
INSERT INTO public.europe_data_import VALUES (4239, '29/06/2020', '2020-26', '46', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '9.07');
INSERT INTO public.europe_data_import VALUES (4240, '22/06/2020', '2020-25', '25', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '3.83');
INSERT INTO public.europe_data_import VALUES (4241, '15/06/2020', '2020-24', '5', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '0.77');
INSERT INTO public.europe_data_import VALUES (4242, '08/06/2020', '2020-23', '1', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '2.43');
INSERT INTO public.europe_data_import VALUES (4243, '01/06/2020', '2020-22', '18', '2', '782775', 'Guyana', 'GY', 'GUY', 'America', '4.6');
INSERT INTO public.europe_data_import VALUES (4244, '25/05/2020', '2020-21', '18', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '3.96');
INSERT INTO public.europe_data_import VALUES (4245, '18/05/2020', '2020-20', '13', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '4.47');
INSERT INTO public.europe_data_import VALUES (4246, '11/05/2020', '2020-19', '22', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '3.83');
INSERT INTO public.europe_data_import VALUES (4247, '04/05/2020', '2020-18', '8', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '2.17');
INSERT INTO public.europe_data_import VALUES (4248, '27/04/2020', '2020-17', '9', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '3.7');
INSERT INTO public.europe_data_import VALUES (4249, '20/04/2020', '2020-16', '20', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '4.6');
INSERT INTO public.europe_data_import VALUES (4250, '13/04/2020', '2020-15', '16', '2', '782775', 'Guyana', 'GY', 'GUY', 'America', '4.73');
INSERT INTO public.europe_data_import VALUES (4251, '06/04/2020', '2020-14', '21', '3', '782775', 'Guyana', 'GY', 'GUY', 'America', '3.07');
INSERT INTO public.europe_data_import VALUES (4252, '30/03/2020', '2020-13', '3', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '0.51');
INSERT INTO public.europe_data_import VALUES (4253, '23/03/2020', '2020-12', '1', '0', '782775', 'Guyana', 'GY', 'GUY', 'America', '0.64');
INSERT INTO public.europe_data_import VALUES (4254, '16/03/2020', '2020-11', '4', '1', '782775', 'Guyana', 'GY', 'GUY', 'America', '');
INSERT INTO public.europe_data_import VALUES (4255, '01/02/2021', '2021-04', '304', '2', '11263079', 'Haiti', 'HT', 'HTI', 'America', '6.06');
INSERT INTO public.europe_data_import VALUES (4256, '25/01/2021', '2021-03', '379', '3', '11263079', 'Haiti', 'HT', 'HTI', 'America', '9.0');
INSERT INTO public.europe_data_import VALUES (4257, '18/01/2021', '2021-02', '635', '2', '11263079', 'Haiti', 'HT', 'HTI', 'America', '6.93');
INSERT INTO public.europe_data_import VALUES (4258, '11/01/2021', '2021-01', '145', '2', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.42');
INSERT INTO public.europe_data_import VALUES (4259, '04/01/2021', '2020-53', '128', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.16');
INSERT INTO public.europe_data_import VALUES (4260, '28/12/2020', '2020-52', '228', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.85');
INSERT INTO public.europe_data_import VALUES (4261, '21/12/2020', '2020-51', '206', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.56');
INSERT INTO public.europe_data_import VALUES (4262, '14/12/2020', '2020-50', '195', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.67');
INSERT INTO public.europe_data_import VALUES (4263, '07/12/2020', '2020-49', '106', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '1.39');
INSERT INTO public.europe_data_import VALUES (4264, '30/11/2020', '2020-48', '50', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.75');
INSERT INTO public.europe_data_import VALUES (4265, '23/11/2020', '2020-47', '35', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.77');
INSERT INTO public.europe_data_import VALUES (4266, '16/11/2020', '2020-46', '52', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '1.11');
INSERT INTO public.europe_data_import VALUES (4267, '09/11/2020', '2020-45', '73', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.9');
INSERT INTO public.europe_data_import VALUES (4268, '02/11/2020', '2020-44', '28', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '1.15');
INSERT INTO public.europe_data_import VALUES (4269, '26/10/2020', '2020-43', '101', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '1.28');
INSERT INTO public.europe_data_import VALUES (4270, '19/10/2020', '2020-42', '43', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.94');
INSERT INTO public.europe_data_import VALUES (4271, '12/10/2020', '2020-41', '63', '1', '11263079', 'Haiti', 'HT', 'HTI', 'America', '1.41');
INSERT INTO public.europe_data_import VALUES (4272, '05/10/2020', '2020-40', '96', '2', '11263079', 'Haiti', 'HT', 'HTI', 'America', '1.78');
INSERT INTO public.europe_data_import VALUES (4273, '28/09/2020', '2020-39', '104', '6', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.04');
INSERT INTO public.europe_data_import VALUES (4274, '21/09/2020', '2020-38', '126', '2', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.3');
INSERT INTO public.europe_data_import VALUES (4275, '14/09/2020', '2020-37', '133', '5', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.52');
INSERT INTO public.europe_data_import VALUES (4276, '07/09/2020', '2020-36', '151', '13', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.47');
INSERT INTO public.europe_data_import VALUES (4277, '31/08/2020', '2020-35', '127', '5', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.93');
INSERT INTO public.europe_data_import VALUES (4278, '24/08/2020', '2020-34', '203', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.98');
INSERT INTO public.europe_data_import VALUES (4279, '17/08/2020', '2020-33', '245', '13', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.58');
INSERT INTO public.europe_data_import VALUES (4280, '10/08/2020', '2020-32', '158', '18', '11263079', 'Haiti', 'HT', 'HTI', 'America', '2.83');
INSERT INTO public.europe_data_import VALUES (4281, '03/08/2020', '2020-31', '161', '8', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.76');
INSERT INTO public.europe_data_import VALUES (4282, '27/07/2020', '2020-30', '262', '11', '11263079', 'Haiti', 'HT', 'HTI', 'America', '5.22');
INSERT INTO public.europe_data_import VALUES (4283, '20/07/2020', '2020-29', '326', '7', '11263079', 'Haiti', 'HT', 'HTI', 'America', '6.39');
INSERT INTO public.europe_data_import VALUES (4284, '13/07/2020', '2020-28', '394', '26', '11263079', 'Haiti', 'HT', 'HTI', 'America', '7.81');
INSERT INTO public.europe_data_import VALUES (4285, '06/07/2020', '2020-27', '486', '9', '11263079', 'Haiti', 'HT', 'HTI', 'America', '9.96');
INSERT INTO public.europe_data_import VALUES (4286, '29/06/2020', '2020-26', '636', '16', '11263079', 'Haiti', 'HT', 'HTI', 'America', '13.66');
INSERT INTO public.europe_data_import VALUES (4287, '22/06/2020', '2020-25', '902', '15', '11263079', 'Haiti', 'HT', 'HTI', 'America', '16.67');
INSERT INTO public.europe_data_import VALUES (4288, '15/06/2020', '2020-24', '975', '22', '11263079', 'Haiti', 'HT', 'HTI', 'America', '19.4');
INSERT INTO public.europe_data_import VALUES (4289, '08/06/2020', '2020-23', '1210', '7', '11263079', 'Haiti', 'HT', 'HTI', 'America', '21.1');
INSERT INTO public.europe_data_import VALUES (4290, '01/06/2020', '2020-22', '1166', '17', '11263079', 'Haiti', 'HT', 'HTI', 'America', '14.81');
INSERT INTO public.europe_data_import VALUES (4291, '25/05/2020', '2020-21', '502', '7', '11263079', 'Haiti', 'HT', 'HTI', 'America', '6.89');
INSERT INTO public.europe_data_import VALUES (4292, '18/05/2020', '2020-20', '274', '5', '11263079', 'Haiti', 'HT', 'HTI', 'America', '3.29');
INSERT INTO public.europe_data_import VALUES (4293, '11/05/2020', '2020-19', '97', '7', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.98');
INSERT INTO public.europe_data_import VALUES (4294, '04/05/2020', '2020-18', '13', '2', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.34');
INSERT INTO public.europe_data_import VALUES (4295, '27/04/2020', '2020-17', '25', '3', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.35');
INSERT INTO public.europe_data_import VALUES (4296, '20/04/2020', '2020-16', '14', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.23');
INSERT INTO public.europe_data_import VALUES (4297, '13/04/2020', '2020-15', '12', '3', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.16');
INSERT INTO public.europe_data_import VALUES (4298, '06/04/2020', '2020-14', '6', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.17');
INSERT INTO public.europe_data_import VALUES (4299, '30/03/2020', '2020-13', '13', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '0.13');
INSERT INTO public.europe_data_import VALUES (4300, '23/03/2020', '2020-12', '2', '0', '11263079', 'Haiti', 'HT', 'HTI', 'America', '');
INSERT INTO public.europe_data_import VALUES (4301, '01/02/2021', '2021-04', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4302, '25/01/2021', '2021-03', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4303, '18/01/2021', '2021-02', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4304, '11/01/2021', '2021-01', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4305, '04/01/2021', '2020-53', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4306, '28/12/2020', '2020-52', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4307, '21/12/2020', '2020-51', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4308, '14/12/2020', '2020-50', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4309, '07/12/2020', '2020-49', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4310, '30/11/2020', '2020-48', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4311, '23/11/2020', '2020-47', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4312, '16/11/2020', '2020-46', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4313, '09/11/2020', '2020-45', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4314, '02/11/2020', '2020-44', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4315, '26/10/2020', '2020-43', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '1717.79');
INSERT INTO public.europe_data_import VALUES (4316, '19/10/2020', '2020-42', '14', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '1717.79');
INSERT INTO public.europe_data_import VALUES (4317, '12/10/2020', '2020-41', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4318, '05/10/2020', '2020-40', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4319, '28/09/2020', '2020-39', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4320, '21/09/2020', '2020-38', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4321, '14/09/2020', '2020-37', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4322, '07/09/2020', '2020-36', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4323, '31/08/2020', '2020-35', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4324, '24/08/2020', '2020-34', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4325, '17/08/2020', '2020-33', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4326, '10/08/2020', '2020-32', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4327, '03/08/2020', '2020-31', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4328, '27/07/2020', '2020-30', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4329, '20/07/2020', '2020-29', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4330, '13/07/2020', '2020-28', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4331, '06/07/2020', '2020-27', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4332, '29/06/2020', '2020-26', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4333, '22/06/2020', '2020-25', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4334, '15/06/2020', '2020-24', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4335, '08/06/2020', '2020-23', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4336, '01/06/2020', '2020-22', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4337, '25/05/2020', '2020-21', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4338, '18/05/2020', '2020-20', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '122.7');
INSERT INTO public.europe_data_import VALUES (4339, '11/05/2020', '2020-19', '1', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '368.1');
INSERT INTO public.europe_data_import VALUES (4340, '04/05/2020', '2020-18', '2', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '368.1');
INSERT INTO public.europe_data_import VALUES (4341, '27/04/2020', '2020-17', '1', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '122.7');
INSERT INTO public.europe_data_import VALUES (4342, '20/04/2020', '2020-16', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '122.7');
INSERT INTO public.europe_data_import VALUES (4343, '13/04/2020', '2020-15', '1', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '245.4');
INSERT INTO public.europe_data_import VALUES (4344, '06/04/2020', '2020-14', '1', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '736.2');
INSERT INTO public.europe_data_import VALUES (4345, '30/03/2020', '2020-13', '5', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '613.5');
INSERT INTO public.europe_data_import VALUES (4346, '23/03/2020', '2020-12', '0', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '122.7');
INSERT INTO public.europe_data_import VALUES (4347, '16/03/2020', '2020-11', '1', '0', '815', 'Holy_See', 'VA', 'VAT', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4348, '01/02/2021', '2021-04', '5859', '148', '9746115', 'Honduras', 'HN', 'HND', 'America', '140.9');
INSERT INTO public.europe_data_import VALUES (4349, '25/01/2021', '2021-03', '7873', '108', '9746115', 'Honduras', 'HN', 'HND', 'America', '144.05');
INSERT INTO public.europe_data_import VALUES (4350, '18/01/2021', '2021-02', '6166', '81', '9746115', 'Honduras', 'HN', 'HND', 'America', '110.22');
INSERT INTO public.europe_data_import VALUES (4351, '11/01/2021', '2021-01', '4576', '93', '9746115', 'Honduras', 'HN', 'HND', 'America', '80.46');
INSERT INTO public.europe_data_import VALUES (4352, '04/01/2021', '2020-53', '3266', '92', '9746115', 'Honduras', 'HN', 'HND', 'America', '65.12');
INSERT INTO public.europe_data_import VALUES (4353, '28/12/2020', '2020-52', '3081', '61', '9746115', 'Honduras', 'HN', 'HND', 'America', '58.94');
INSERT INTO public.europe_data_import VALUES (4354, '21/12/2020', '2020-51', '2663', '52', '9746115', 'Honduras', 'HN', 'HND', 'America', '61.55');
INSERT INTO public.europe_data_import VALUES (4355, '14/12/2020', '2020-50', '3336', '29', '9746115', 'Honduras', 'HN', 'HND', 'America', '66.4');
INSERT INTO public.europe_data_import VALUES (4356, '07/12/2020', '2020-49', '3135', '37', '9746115', 'Honduras', 'HN', 'HND', 'America', '67.6');
INSERT INTO public.europe_data_import VALUES (4357, '30/11/2020', '2020-48', '3453', '52', '9746115', 'Honduras', 'HN', 'HND', 'America', '49.11');
INSERT INTO public.europe_data_import VALUES (4358, '23/11/2020', '2020-47', '1333', '34', '9746115', 'Honduras', 'HN', 'HND', 'America', '40.29');
INSERT INTO public.europe_data_import VALUES (4359, '16/11/2020', '2020-46', '2594', '72', '9746115', 'Honduras', 'HN', 'HND', 'America', '50.17');
INSERT INTO public.europe_data_import VALUES (4360, '09/11/2020', '2020-45', '2296', '76', '9746115', 'Honduras', 'HN', 'HND', 'America', '74.84');
INSERT INTO public.europe_data_import VALUES (4361, '02/11/2020', '2020-44', '4998', '52', '9746115', 'Honduras', 'HN', 'HND', 'America', '100.42');
INSERT INTO public.europe_data_import VALUES (4362, '26/10/2020', '2020-43', '4789', '55', '9746115', 'Honduras', 'HN', 'HND', 'America', '93.71');
INSERT INTO public.europe_data_import VALUES (4363, '19/10/2020', '2020-42', '4344', '56', '9746115', 'Honduras', 'HN', 'HND', 'America', '90.25');
INSERT INTO public.europe_data_import VALUES (4364, '12/10/2020', '2020-41', '4452', '90', '9746115', 'Honduras', 'HN', 'HND', 'America', '92.06');
INSERT INTO public.europe_data_import VALUES (4365, '05/10/2020', '2020-40', '4520', '133', '9746115', 'Honduras', 'HN', 'HND', 'America', '82.22');
INSERT INTO public.europe_data_import VALUES (4366, '28/09/2020', '2020-39', '3493', '105', '9746115', 'Honduras', 'HN', 'HND', 'America', '75.11');
INSERT INTO public.europe_data_import VALUES (4367, '21/09/2020', '2020-38', '3827', '105', '9746115', 'Honduras', 'HN', 'HND', 'America', '70.3');
INSERT INTO public.europe_data_import VALUES (4368, '14/09/2020', '2020-37', '3025', '72', '9746115', 'Honduras', 'HN', 'HND', 'America', '78.13');
INSERT INTO public.europe_data_import VALUES (4369, '07/09/2020', '2020-36', '4590', '149', '9746115', 'Honduras', 'HN', 'HND', 'America', '105.2');
INSERT INTO public.europe_data_import VALUES (4370, '31/08/2020', '2020-35', '5663', '204', '9746115', 'Honduras', 'HN', 'HND', 'America', '99.24');
INSERT INTO public.europe_data_import VALUES (4371, '24/08/2020', '2020-34', '4009', '79', '9746115', 'Honduras', 'HN', 'HND', 'America', '72.41');
INSERT INTO public.europe_data_import VALUES (4372, '17/08/2020', '2020-33', '3048', '80', '9746115', 'Honduras', 'HN', 'HND', 'America', '74.95');
INSERT INTO public.europe_data_import VALUES (4373, '10/08/2020', '2020-32', '4257', '118', '9746115', 'Honduras', 'HN', 'HND', 'America', '83.91');
INSERT INTO public.europe_data_import VALUES (4374, '03/08/2020', '2020-31', '3921', '261', '9746115', 'Honduras', 'HN', 'HND', 'America', '96.06');
INSERT INTO public.europe_data_import VALUES (4375, '27/07/2020', '2020-30', '5441', '216', '9746115', 'Honduras', 'HN', 'HND', 'America', '114.77');
INSERT INTO public.europe_data_import VALUES (4376, '20/07/2020', '2020-29', '5745', '126', '9746115', 'Honduras', 'HN', 'HND', 'America', '101.5');
INSERT INTO public.europe_data_import VALUES (4377, '13/07/2020', '2020-28', '4147', '135', '9746115', 'Honduras', 'HN', 'HND', 'America', '102.69');
INSERT INTO public.europe_data_import VALUES (4378, '06/07/2020', '2020-27', '5861', '160', '9746115', 'Honduras', 'HN', 'HND', 'America', '114.65');
INSERT INTO public.europe_data_import VALUES (4379, '29/06/2020', '2020-26', '5313', '116', '9746115', 'Honduras', 'HN', 'HND', 'America', '94.64');
INSERT INTO public.europe_data_import VALUES (4380, '22/06/2020', '2020-25', '3911', '51', '9746115', 'Honduras', 'HN', 'HND', 'America', '66.1');
INSERT INTO public.europe_data_import VALUES (4381, '15/06/2020', '2020-24', '2531', '54', '9746115', 'Honduras', 'HN', 'HND', 'America', '37.51');
INSERT INTO public.europe_data_import VALUES (4382, '08/06/2020', '2020-23', '1125', '46', '9746115', 'Honduras', 'HN', 'HND', 'America', '24.39');
INSERT INTO public.europe_data_import VALUES (4383, '01/06/2020', '2020-22', '1252', '32', '9746115', 'Honduras', 'HN', 'HND', 'America', '26.23');
INSERT INTO public.europe_data_import VALUES (4384, '25/05/2020', '2020-21', '1304', '38', '9746115', 'Honduras', 'HN', 'HND', 'America', '20.3');
INSERT INTO public.europe_data_import VALUES (4385, '18/05/2020', '2020-20', '674', '34', '9746115', 'Honduras', 'HN', 'HND', 'America', '16.32');
INSERT INTO public.europe_data_import VALUES (4386, '11/05/2020', '2020-19', '917', '26', '9746115', 'Honduras', 'HN', 'HND', 'America', '13.45');
INSERT INTO public.europe_data_import VALUES (4387, '04/05/2020', '2020-18', '394', '21', '9746115', 'Honduras', 'HN', 'HND', 'America', '5.93');
INSERT INTO public.europe_data_import VALUES (4388, '27/04/2020', '2020-17', '184', '15', '9746115', 'Honduras', 'HN', 'HND', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (4389, '20/04/2020', '2020-16', '80', '21', '9746115', 'Honduras', 'HN', 'HND', 'America', '1.84');
INSERT INTO public.europe_data_import VALUES (4390, '13/04/2020', '2020-15', '99', '3', '9746115', 'Honduras', 'HN', 'HND', 'America', '2.65');
INSERT INTO public.europe_data_import VALUES (4391, '06/04/2020', '2020-14', '159', '19', '9746115', 'Honduras', 'HN', 'HND', 'America', '2.78');
INSERT INTO public.europe_data_import VALUES (4392, '30/03/2020', '2020-13', '112', '3', '9746115', 'Honduras', 'HN', 'HND', 'America', '1.36');
INSERT INTO public.europe_data_import VALUES (4393, '23/03/2020', '2020-12', '21', '0', '9746115', 'Honduras', 'HN', 'HND', 'America', '0.28');
INSERT INTO public.europe_data_import VALUES (4394, '16/03/2020', '2020-11', '6', '0', '9746115', 'Honduras', 'HN', 'HND', 'America', '');
INSERT INTO public.europe_data_import VALUES (4395, '01/02/2021', '2021-04', '8292', '554', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '163.79');
INSERT INTO public.europe_data_import VALUES (4396, '25/01/2021', '2021-03', '7715', '615', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '171.52');
INSERT INTO public.europe_data_import VALUES (4397, '18/01/2021', '2021-02', '9047', '684', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '244.07');
INSERT INTO public.europe_data_import VALUES (4398, '11/01/2021', '2021-01', '14805', '748', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '276.15');
INSERT INTO public.europe_data_import VALUES (4399, '04/01/2021', '2020-53', '12182', '816', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '242.73');
INSERT INTO public.europe_data_import VALUES (4400, '28/12/2020', '2020-52', '11539', '879', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '335.62');
INSERT INTO public.europe_data_import VALUES (4401, '21/12/2020', '2020-51', '21260', '1152', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '521.67');
INSERT INTO public.europe_data_import VALUES (4402, '14/12/2020', '2020-50', '29722', '1146', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '683.0');
INSERT INTO public.europe_data_import VALUES (4403, '07/12/2020', '2020-49', '37026', '1161', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '779.68');
INSERT INTO public.europe_data_import VALUES (4404, '30/11/2020', '2020-48', '39170', '932', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '712.86');
INSERT INTO public.europe_data_import VALUES (4405, '23/11/2020', '2020-47', '30496', '701', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '646.43');
INSERT INTO public.europe_data_import VALUES (4406, '16/11/2020', '2020-46', '32678', '697', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '661.8');
INSERT INTO public.europe_data_import VALUES (4407, '09/11/2020', '2020-45', '31998', '604', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '544.52');
INSERT INTO public.europe_data_import VALUES (4408, '02/11/2020', '2020-44', '21217', '417', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '358.26');
INSERT INTO public.europe_data_import VALUES (4409, '26/10/2020', '2020-43', '13795', '299', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '235.2');
INSERT INTO public.europe_data_import VALUES (4410, '19/10/2020', '2020-42', '9191', '205', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '166.67');
INSERT INTO public.europe_data_import VALUES (4411, '12/10/2020', '2020-41', '7097', '135', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '141.83');
INSERT INTO public.europe_data_import VALUES (4412, '05/10/2020', '2020-40', '6764', '84', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '129.07');
INSERT INTO public.europe_data_import VALUES (4413, '28/09/2020', '2020-39', '5850', '63', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '126.95');
INSERT INTO public.europe_data_import VALUES (4414, '21/09/2020', '2020-38', '6557', '49', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '107.23');
INSERT INTO public.europe_data_import VALUES (4415, '14/09/2020', '2020-37', '3922', '13', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '64.96');
INSERT INTO public.europe_data_import VALUES (4416, '07/09/2020', '2020-36', '2426', '10', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '33.07');
INSERT INTO public.europe_data_import VALUES (4417, '31/08/2020', '2020-35', '806', '1', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '10.69');
INSERT INTO public.europe_data_import VALUES (4418, '24/08/2020', '2020-34', '239', '5', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '4.7');
INSERT INTO public.europe_data_import VALUES (4419, '17/08/2020', '2020-33', '220', '6', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '3.9');
INSERT INTO public.europe_data_import VALUES (4420, '10/08/2020', '2020-32', '161', '5', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '2.54');
INSERT INTO public.europe_data_import VALUES (4421, '03/08/2020', '2020-31', '87', '1', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '2.07');
INSERT INTO public.europe_data_import VALUES (4422, '27/07/2020', '2020-30', '115', '0', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '2.19');
INSERT INTO public.europe_data_import VALUES (4423, '20/07/2020', '2020-29', '99', '1', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '1.53');
INSERT INTO public.europe_data_import VALUES (4424, '13/07/2020', '2020-28', '51', '6', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '0.94');
INSERT INTO public.europe_data_import VALUES (4425, '06/07/2020', '2020-27', '41', '8', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '0.83');
INSERT INTO public.europe_data_import VALUES (4426, '29/06/2020', '2020-26', '40', '9', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '0.68');
INSERT INTO public.europe_data_import VALUES (4427, '22/06/2020', '2020-25', '26', '9', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '1.35');
INSERT INTO public.europe_data_import VALUES (4428, '15/06/2020', '2020-24', '106', '21', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '2.05');
INSERT INTO public.europe_data_import VALUES (4429, '08/06/2020', '2020-23', '94', '16', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '2.19');
INSERT INTO public.europe_data_import VALUES (4430, '01/06/2020', '2020-22', '120', '35', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '3.49');
INSERT INTO public.europe_data_import VALUES (4431, '25/05/2020', '2020-21', '221', '29', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '4.83');
INSERT INTO public.europe_data_import VALUES (4432, '18/05/2020', '2020-20', '251', '41', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '5.12');
INSERT INTO public.europe_data_import VALUES (4433, '11/05/2020', '2020-19', '249', '70', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '7.17');
INSERT INTO public.europe_data_import VALUES (4434, '04/05/2020', '2020-18', '452', '71', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '10.75');
INSERT INTO public.europe_data_import VALUES (4435, '27/04/2020', '2020-17', '599', '81', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '11.51');
INSERT INTO public.europe_data_import VALUES (4436, '20/04/2020', '2020-16', '526', '90', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '12.69');
INSERT INTO public.europe_data_import VALUES (4437, '13/04/2020', '2020-15', '714', '71', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '10.35');
INSERT INTO public.europe_data_import VALUES (4438, '06/04/2020', '2020-14', '297', '23', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '5.9');
INSERT INTO public.europe_data_import VALUES (4439, '30/03/2020', '2020-13', '280', '8', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '4.17');
INSERT INTO public.europe_data_import VALUES (4440, '23/03/2020', '2020-12', '128', '6', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '1.63');
INSERT INTO public.europe_data_import VALUES (4441, '16/03/2020', '2020-11', '31', '1', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '0.4');
INSERT INTO public.europe_data_import VALUES (4442, '09/03/2020', '2020-10', '8', '0', '9772756', 'Hungary', 'HU', 'HUN', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4443, '01/02/2021', '2021-04', '19', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '10.92');
INSERT INTO public.europe_data_import VALUES (4444, '25/01/2021', '2021-03', '20', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '25.77');
INSERT INTO public.europe_data_import VALUES (4445, '18/01/2021', '2021-02', '72', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '60.51');
INSERT INTO public.europe_data_import VALUES (4446, '11/01/2021', '2021-01', '144', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '48.18');
INSERT INTO public.europe_data_import VALUES (4447, '04/01/2021', '2020-53', '28', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '31.37');
INSERT INTO public.europe_data_import VALUES (4448, '28/12/2020', '2020-52', '84', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '47.34');
INSERT INTO public.europe_data_import VALUES (4449, '21/12/2020', '2020-51', '85', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '44.82');
INSERT INTO public.europe_data_import VALUES (4450, '14/12/2020', '2020-50', '75', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '49.3');
INSERT INTO public.europe_data_import VALUES (4451, '07/12/2020', '2020-49', '101', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '57.42');
INSERT INTO public.europe_data_import VALUES (4452, '30/11/2020', '2020-48', '104', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '53.78');
INSERT INTO public.europe_data_import VALUES (4453, '23/11/2020', '2020-47', '88', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '55.74');
INSERT INTO public.europe_data_import VALUES (4454, '16/11/2020', '2020-46', '111', '5', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '83.76');
INSERT INTO public.europe_data_import VALUES (4455, '09/11/2020', '2020-45', '188', '8', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '176.48');
INSERT INTO public.europe_data_import VALUES (4456, '02/11/2020', '2020-44', '442', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '233.9');
INSERT INTO public.europe_data_import VALUES (4457, '26/10/2020', '2020-43', '393', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '258.27');
INSERT INTO public.europe_data_import VALUES (4458, '19/10/2020', '2020-42', '529', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '317.66');
INSERT INTO public.europe_data_import VALUES (4459, '12/10/2020', '2020-41', '605', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '252.95');
INSERT INTO public.europe_data_import VALUES (4460, '05/10/2020', '2020-40', '298', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '161.07');
INSERT INTO public.europe_data_import VALUES (4461, '28/09/2020', '2020-39', '277', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '128.29');
INSERT INTO public.europe_data_import VALUES (4462, '21/09/2020', '2020-38', '181', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '57.42');
INSERT INTO public.europe_data_import VALUES (4463, '14/09/2020', '2020-37', '24', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '16.81');
INSERT INTO public.europe_data_import VALUES (4464, '07/09/2020', '2020-36', '36', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '21.57');
INSERT INTO public.europe_data_import VALUES (4465, '31/08/2020', '2020-35', '41', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '26.33');
INSERT INTO public.europe_data_import VALUES (4466, '24/08/2020', '2020-34', '53', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '29.69');
INSERT INTO public.europe_data_import VALUES (4467, '17/08/2020', '2020-33', '53', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '29.13');
INSERT INTO public.europe_data_import VALUES (4468, '10/08/2020', '2020-32', '51', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '31.09');
INSERT INTO public.europe_data_import VALUES (4469, '03/08/2020', '2020-31', '60', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '19.05');
INSERT INTO public.europe_data_import VALUES (4470, '27/07/2020', '2020-30', '8', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '3.92');
INSERT INTO public.europe_data_import VALUES (4471, '20/07/2020', '2020-29', '6', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '2.52');
INSERT INTO public.europe_data_import VALUES (4472, '13/07/2020', '2020-28', '3', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '3.36');
INSERT INTO public.europe_data_import VALUES (4473, '06/07/2020', '2020-27', '9', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '4.2');
INSERT INTO public.europe_data_import VALUES (4474, '29/06/2020', '2020-26', '6', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '3.08');
INSERT INTO public.europe_data_import VALUES (4475, '22/06/2020', '2020-25', '5', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '2.24');
INSERT INTO public.europe_data_import VALUES (4476, '15/06/2020', '2020-24', '3', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '1.12');
INSERT INTO public.europe_data_import VALUES (4477, '08/06/2020', '2020-23', '1', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0.84');
INSERT INTO public.europe_data_import VALUES (4478, '01/06/2020', '2020-22', '2', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '1.12');
INSERT INTO public.europe_data_import VALUES (4479, '25/05/2020', '2020-21', '2', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0.84');
INSERT INTO public.europe_data_import VALUES (4480, '18/05/2020', '2020-20', '1', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0.84');
INSERT INTO public.europe_data_import VALUES (4481, '11/05/2020', '2020-19', '2', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '2.52');
INSERT INTO public.europe_data_import VALUES (4482, '04/05/2020', '2020-18', '7', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '7.84');
INSERT INTO public.europe_data_import VALUES (4483, '27/04/2020', '2020-17', '21', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '25.49');
INSERT INTO public.europe_data_import VALUES (4484, '20/04/2020', '2020-16', '70', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '79.83');
INSERT INTO public.europe_data_import VALUES (4485, '13/04/2020', '2020-15', '215', '4', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '190.76');
INSERT INTO public.europe_data_import VALUES (4486, '06/04/2020', '2020-14', '466', '2', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '257.15');
INSERT INTO public.europe_data_import VALUES (4487, '30/03/2020', '2020-13', '452', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '235.86');
INSERT INTO public.europe_data_import VALUES (4488, '23/03/2020', '2020-12', '390', '1', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '143.7');
INSERT INTO public.europe_data_import VALUES (4489, '16/03/2020', '2020-11', '123', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '49.02');
INSERT INTO public.europe_data_import VALUES (4490, '09/03/2020', '2020-10', '52', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '15.41');
INSERT INTO public.europe_data_import VALUES (4491, '02/03/2020', '2020-09', '3', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0.84');
INSERT INTO public.europe_data_import VALUES (4492, '24/02/2020', '2020-08', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4493, '17/02/2020', '2020-07', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4494, '10/02/2020', '2020-06', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4495, '03/02/2020', '2020-05', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4496, '27/01/2020', '2020-04', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4497, '20/01/2020', '2020-03', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4498, '13/01/2020', '2020-02', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4499, '06/01/2020', '2020-01', '0', '0', '356991', 'Iceland', 'IS', 'ISL', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4500, '01/02/2021', '2021-04', '89874', '922', '1366417756', 'India', 'IN', 'IND', 'Asia', '13.6');
INSERT INTO public.europe_data_import VALUES (4501, '25/01/2021', '2021-03', '95963', '1051', '1366417756', 'India', 'IN', 'IND', 'Asia', '14.72');
INSERT INTO public.europe_data_import VALUES (4502, '18/01/2021', '2021-02', '105178', '1259', '1366417756', 'India', 'IN', 'IND', 'Asia', '16.93');
INSERT INTO public.europe_data_import VALUES (4503, '11/01/2021', '2021-01', '126126', '1511', '1366417756', 'India', 'IN', 'IND', 'Asia', '18.93');
INSERT INTO public.europe_data_import VALUES (4504, '04/01/2021', '2020-53', '132598', '1748', '1366417756', 'India', 'IN', 'IND', 'Asia', '20.85');
INSERT INTO public.europe_data_import VALUES (4505, '28/12/2020', '2020-52', '152311', '2091', '1366417756', 'India', 'IN', 'IND', 'Asia', '23.69');
INSERT INTO public.europe_data_import VALUES (4506, '21/12/2020', '2020-51', '171460', '2455', '1366417756', 'India', 'IN', 'IND', 'Asia', '27.69');
INSERT INTO public.europe_data_import VALUES (4507, '14/12/2020', '2020-50', '206897', '2782', '1366417756', 'India', 'IN', 'IND', 'Asia', '33.11');
INSERT INTO public.europe_data_import VALUES (4508, '07/12/2020', '2020-49', '245512', '3434', '1366417756', 'India', 'IN', 'IND', 'Asia', '39.32');
INSERT INTO public.europe_data_import VALUES (4509, '30/11/2020', '2020-48', '291826', '3401', '1366417756', 'India', 'IN', 'IND', 'Asia', '42.93');
INSERT INTO public.europe_data_import VALUES (4510, '23/11/2020', '2020-47', '294738', '3668', '1366417756', 'India', 'IN', 'IND', 'Asia', '42.9');
INSERT INTO public.europe_data_import VALUES (4511, '16/11/2020', '2020-46', '291470', '3459', '1366417756', 'India', 'IN', 'IND', 'Asia', '45.07');
INSERT INTO public.europe_data_import VALUES (4512, '09/11/2020', '2020-45', '324344', '4004', '1366417756', 'India', 'IN', 'IND', 'Asia', '47.11');
INSERT INTO public.europe_data_import VALUES (4513, '02/11/2020', '2020-44', '319354', '3593', '1366417756', 'India', 'IN', 'IND', 'Asia', '49.69');
INSERT INTO public.europe_data_import VALUES (4514, '26/10/2020', '2020-43', '359686', '4404', '1366417756', 'India', 'IN', 'IND', 'Asia', '57.77');
INSERT INTO public.europe_data_import VALUES (4515, '19/10/2020', '2020-42', '429735', '5460', '1366417756', 'India', 'IN', 'IND', 'Asia', '67.8');
INSERT INTO public.europe_data_import VALUES (4516, '12/10/2020', '2020-41', '496723', '6465', '1366417756', 'India', 'IN', 'IND', 'Asia', '76.54');
INSERT INTO public.europe_data_import VALUES (4517, '05/10/2020', '2020-40', '549113', '7143', '1366417756', 'India', 'IN', 'IND', 'Asia', '83.15');
INSERT INTO public.europe_data_import VALUES (4518, '28/09/2020', '2020-39', '587122', '7660', '1366417756', 'India', 'IN', 'IND', 'Asia', '89.89');
INSERT INTO public.europe_data_import VALUES (4519, '21/09/2020', '2020-38', '641153', '8160', '1366417756', 'India', 'IN', 'IND', 'Asia', '93.89');
INSERT INTO public.europe_data_import VALUES (4520, '14/09/2020', '2020-37', '641814', '8080', '1366417756', 'India', 'IN', 'IND', 'Asia', '89.66');
INSERT INTO public.europe_data_import VALUES (4521, '07/09/2020', '2020-36', '583368', '7173', '1366417756', 'India', 'IN', 'IND', 'Asia', '80.38');
INSERT INTO public.europe_data_import VALUES (4522, '31/08/2020', '2020-35', '514897', '6927', '1366417756', 'India', 'IN', 'IND', 'Asia', '71.25');
INSERT INTO public.europe_data_import VALUES (4523, '24/08/2020', '2020-34', '458685', '6621', '1366417756', 'India', 'IN', 'IND', 'Asia', '65.23');
INSERT INTO public.europe_data_import VALUES (4524, '17/08/2020', '2020-33', '432589', '6535', '1366417756', 'India', 'IN', 'IND', 'Asia', '61.77');
INSERT INTO public.europe_data_import VALUES (4525, '10/08/2020', '2020-32', '411379', '6251', '1366417756', 'India', 'IN', 'IND', 'Asia', '57.06');
INSERT INTO public.europe_data_import VALUES (4526, '03/08/2020', '2020-31', '368242', '5364', '1366417756', 'India', 'IN', 'IND', 'Asia', '50.18');
INSERT INTO public.europe_data_import VALUES (4527, '27/07/2020', '2020-30', '317410', '5274', '1366417756', 'India', 'IN', 'IND', 'Asia', '40.78');
INSERT INTO public.europe_data_import VALUES (4528, '20/07/2020', '2020-29', '239789', '4323', '1366417756', 'India', 'IN', 'IND', 'Asia', '30.78');
INSERT INTO public.europe_data_import VALUES (4529, '13/07/2020', '2020-28', '180841', '3481', '1366417756', 'India', 'IN', 'IND', 'Asia', '24.15');
INSERT INTO public.europe_data_import VALUES (4530, '06/07/2020', '2020-27', '149095', '3218', '1366417756', 'India', 'IN', 'IND', 'Asia', '19.92');
INSERT INTO public.europe_data_import VALUES (4531, '29/06/2020', '2020-26', '123036', '2776', '1366417756', 'India', 'IN', 'IND', 'Asia', '15.8');
INSERT INTO public.europe_data_import VALUES (4532, '22/06/2020', '2020-25', '92858', '4179', '1366417756', 'India', 'IN', 'IND', 'Asia', '12.34');
INSERT INTO public.europe_data_import VALUES (4533, '15/06/2020', '2020-24', '75813', '2385', '1366417756', 'India', 'IN', 'IND', 'Asia', '10.38');
INSERT INTO public.europe_data_import VALUES (4534, '08/06/2020', '2020-23', '66076', '1741', '1366417756', 'India', 'IN', 'IND', 'Asia', '8.62');
INSERT INTO public.europe_data_import VALUES (4535, '01/06/2020', '2020-22', '51690', '1373', '1366417756', 'India', 'IN', 'IND', 'Asia', '6.91');
INSERT INTO public.europe_data_import VALUES (4536, '25/05/2020', '2020-21', '42676', '992', '1366417756', 'India', 'IN', 'IND', 'Asia', '5.25');
INSERT INTO public.europe_data_import VALUES (4537, '18/05/2020', '2020-20', '29017', '823', '1366417756', 'India', 'IN', 'IND', 'Asia', '3.93');
INSERT INTO public.europe_data_import VALUES (4538, '11/05/2020', '2020-19', '24619', '833', '1366417756', 'India', 'IN', 'IND', 'Asia', '2.87');
INSERT INTO public.europe_data_import VALUES (4539, '04/05/2020', '2020-18', '14641', '501', '1366417756', 'India', 'IN', 'IND', 'Asia', '1.85');
INSERT INTO public.europe_data_import VALUES (4540, '27/04/2020', '2020-17', '10627', '329', '1366417756', 'India', 'IN', 'IND', 'Asia', '1.37');
INSERT INTO public.europe_data_import VALUES (4541, '20/04/2020', '2020-16', '8113', '235', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.97');
INSERT INTO public.europe_data_import VALUES (4542, '13/04/2020', '2020-15', '5085', '199', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.59');
INSERT INTO public.europe_data_import VALUES (4543, '06/04/2020', '2020-14', '2996', '80', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.27');
INSERT INTO public.europe_data_import VALUES (4544, '30/03/2020', '2020-13', '632', '22', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (4545, '23/03/2020', '2020-12', '346', '5', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (4546, '16/03/2020', '2020-11', '59', '2', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (4547, '09/03/2020', '2020-10', '31', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (4548, '02/03/2020', '2020-09', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4549, '24/02/2020', '2020-08', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4550, '17/02/2020', '2020-07', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (4551, '10/02/2020', '2020-06', '1', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (4552, '03/02/2020', '2020-05', '2', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (4553, '27/01/2020', '2020-04', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4554, '20/01/2020', '2020-03', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4555, '13/01/2020', '2020-02', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4556, '06/01/2020', '2020-01', '0', '0', '1366417756', 'India', 'IN', 'IND', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (4557, '01/02/2021', '2021-04', '89052', '2163', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '62.96');
INSERT INTO public.europe_data_import VALUES (4558, '25/01/2021', '2021-03', '81333', '1848', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '59.58');
INSERT INTO public.europe_data_import VALUES (4559, '18/01/2021', '2021-02', '79903', '1858', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '55.23');
INSERT INTO public.europe_data_import VALUES (4560, '11/01/2021', '2021-01', '69553', '1574', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '42.37');
INSERT INTO public.europe_data_import VALUES (4561, '04/01/2021', '2020-53', '45108', '1318', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '34.57');
INSERT INTO public.europe_data_import VALUES (4562, '28/12/2020', '2020-52', '48435', '1357', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '35.31');
INSERT INTO public.europe_data_import VALUES (4563, '21/12/2020', '2020-51', '47110', '1061', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '32.94');
INSERT INTO public.europe_data_import VALUES (4564, '14/12/2020', '2020-50', '42024', '1079', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '30.87');
INSERT INTO public.europe_data_import VALUES (4565, '07/12/2020', '2020-49', '41530', '925', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '28.87');
INSERT INTO public.europe_data_import VALUES (4566, '30/11/2020', '2020-48', '36598', '931', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '24.81');
INSERT INTO public.europe_data_import VALUES (4567, '23/11/2020', '2020-47', '30555', '673', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '22.15');
INSERT INTO public.europe_data_import VALUES (4568, '16/11/2020', '2020-46', '29397', '597', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '20.08');
INSERT INTO public.europe_data_import VALUES (4569, '09/11/2020', '2020-45', '24932', '671', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '17.74');
INSERT INTO public.europe_data_import VALUES (4570, '02/11/2020', '2020-44', '23072', '644', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '18.81');
INSERT INTO public.europe_data_import VALUES (4571, '26/10/2020', '2020-43', '27845', '788', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '20.79');
INSERT INTO public.europe_data_import VALUES (4572, '19/10/2020', '2020-42', '28418', '667', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '21.57');
INSERT INTO public.europe_data_import VALUES (4573, '12/10/2020', '2020-41', '29951', '693', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '21.52');
INSERT INTO public.europe_data_import VALUES (4574, '05/10/2020', '2020-40', '28285', '765', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '21.74');
INSERT INTO public.europe_data_import VALUES (4575, '28/09/2020', '2020-39', '30537', '833', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '21.0');
INSERT INTO public.europe_data_import VALUES (4576, '21/09/2020', '2020-38', '26294', '830', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '18.69');
INSERT INTO public.europe_data_import VALUES (4577, '14/09/2020', '2020-37', '24273', '698', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '17.12');
INSERT INTO public.europe_data_import VALUES (4578, '07/09/2020', '2020-36', '22056', '682', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '14.99');
INSERT INTO public.europe_data_import VALUES (4579, '31/08/2020', '2020-35', '18518', '663', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '12.01');
INSERT INTO public.europe_data_import VALUES (4580, '24/08/2020', '2020-34', '13986', '530', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '10.4');
INSERT INTO public.europe_data_import VALUES (4581, '17/08/2020', '2020-33', '14153', '427', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '10.38');
INSERT INTO public.europe_data_import VALUES (4582, '10/08/2020', '2020-32', '13941', '487', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '9.84');
INSERT INTO public.europe_data_import VALUES (4583, '03/08/2020', '2020-31', '12677', '455', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '9.21');
INSERT INTO public.europe_data_import VALUES (4584, '27/07/2020', '2020-30', '12257', '638', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '8.53');
INSERT INTO public.europe_data_import VALUES (4585, '20/07/2020', '2020-29', '10822', '537', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '8.41');
INSERT INTO public.europe_data_import VALUES (4586, '13/07/2020', '2020-28', '11950', '435', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '8.01');
INSERT INTO public.europe_data_import VALUES (4587, '06/07/2020', '2020-27', '9739', '417', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '6.6');
INSERT INTO public.europe_data_import VALUES (4588, '29/06/2020', '2020-26', '8119', '289', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '5.81');
INSERT INTO public.europe_data_import VALUES (4589, '22/06/2020', '2020-25', '7614', '331', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '5.43');
INSERT INTO public.europe_data_import VALUES (4590, '15/06/2020', '2020-24', '7091', '283', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '4.36');
INSERT INTO public.europe_data_import VALUES (4591, '08/06/2020', '2020-23', '4713', '238', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '3.29');
INSERT INTO public.europe_data_import VALUES (4592, '01/06/2020', '2020-22', '4202', '241', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '3.31');
INSERT INTO public.europe_data_import VALUES (4593, '25/05/2020', '2020-21', '4757', '224', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '3.04');
INSERT INTO public.europe_data_import VALUES (4594, '18/05/2020', '2020-20', '3482', '175', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '2.34');
INSERT INTO public.europe_data_import VALUES (4595, '11/05/2020', '2020-19', '2840', '128', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '1.9');
INSERT INTO public.europe_data_import VALUES (4596, '04/05/2020', '2020-18', '2310', '102', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '1.71');
INSERT INTO public.europe_data_import VALUES (4597, '27/04/2020', '2020-17', '2307', '161', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '1.71');
INSERT INTO public.europe_data_import VALUES (4598, '20/04/2020', '2020-16', '2334', '209', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '1.59');
INSERT INTO public.europe_data_import VALUES (4599, '13/04/2020', '2020-15', '1968', '175', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '1.09');
INSERT INTO public.europe_data_import VALUES (4600, '06/04/2020', '2020-14', '988', '84', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0.65');
INSERT INTO public.europe_data_import VALUES (4601, '30/03/2020', '2020-13', '771', '66', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0.43');
INSERT INTO public.europe_data_import VALUES (4602, '23/03/2020', '2020-12', '397', '43', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0.19');
INSERT INTO public.europe_data_import VALUES (4603, '16/03/2020', '2020-11', '111', '5', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (4604, '09/03/2020', '2020-10', '4', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (4605, '02/03/2020', '2020-09', '2', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (4606, '24/02/2020', '2020-08', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4607, '17/02/2020', '2020-07', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4608, '10/02/2020', '2020-06', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4609, '03/02/2020', '2020-05', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4610, '27/01/2020', '2020-04', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4611, '20/01/2020', '2020-03', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4612, '13/01/2020', '2020-02', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4613, '06/01/2020', '2020-01', '0', '0', '270625567', 'Indonesia', 'ID', 'IDN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (4614, '01/02/2021', '2021-04', '45022', '576', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '105.64');
INSERT INTO public.europe_data_import VALUES (4615, '25/01/2021', '2021-03', '42566', '580', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '104.41');
INSERT INTO public.europe_data_import VALUES (4616, '18/01/2021', '2021-02', '44005', '632', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '104.9');
INSERT INTO public.europe_data_import VALUES (4617, '11/01/2021', '2021-01', '42972', '631', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '103.65');
INSERT INTO public.europe_data_import VALUES (4618, '04/01/2021', '2020-53', '42969', '847', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '110.19');
INSERT INTO public.europe_data_import VALUES (4619, '28/12/2020', '2020-52', '48393', '1245', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '111.19');
INSERT INTO public.europe_data_import VALUES (4620, '21/12/2020', '2020-51', '43803', '1252', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '134.51');
INSERT INTO public.europe_data_import VALUES (4621, '14/12/2020', '2020-50', '67722', '1886', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '192.39');
INSERT INTO public.europe_data_import VALUES (4622, '07/12/2020', '2020-49', '91798', '2435', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '224.55');
INSERT INTO public.europe_data_import VALUES (4623, '30/11/2020', '2020-48', '94388', '3073', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '225.15');
INSERT INTO public.europe_data_import VALUES (4624, '23/11/2020', '2020-47', '92293', '3309', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '207.29');
INSERT INTO public.europe_data_import VALUES (4625, '16/11/2020', '2020-46', '79582', '3202', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '170.75');
INSERT INTO public.europe_data_import VALUES (4626, '09/11/2020', '2020-45', '61995', '2993', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '137.0');
INSERT INTO public.europe_data_import VALUES (4627, '02/11/2020', '2020-44', '51595', '2682', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '108.68');
INSERT INTO public.europe_data_import VALUES (4628, '26/10/2020', '2020-43', '38516', '2241', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '83.0');
INSERT INTO public.europe_data_import VALUES (4629, '19/10/2020', '2020-42', '30305', '1831', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '70.69');
INSERT INTO public.europe_data_import VALUES (4630, '12/10/2020', '2020-41', '28303', '1587', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '64.68');
INSERT INTO public.europe_data_import VALUES (4631, '05/10/2020', '2020-40', '25324', '1368', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '59.86');
INSERT INTO public.europe_data_import VALUES (4632, '28/09/2020', '2020-39', '24308', '1288', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '53.57');
INSERT INTO public.europe_data_import VALUES (4633, '21/09/2020', '2020-38', '20111', '1144', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '42.79');
INSERT INTO public.europe_data_import VALUES (4634, '14/09/2020', '2020-37', '15371', '864', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '34.32');
INSERT INTO public.europe_data_import VALUES (4635, '07/09/2020', '2020-36', '13088', '831', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '33.47');
INSERT INTO public.europe_data_import VALUES (4636, '31/08/2020', '2020-35', '14665', '819', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '36.62');
INSERT INTO public.europe_data_import VALUES (4637, '24/08/2020', '2020-34', '15702', '1004', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '38.83');
INSERT INTO public.europe_data_import VALUES (4638, '17/08/2020', '2020-33', '16491', '1212', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '40.72');
INSERT INTO public.europe_data_import VALUES (4639, '10/08/2020', '2020-32', '17275', '1237', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '42.86');
INSERT INTO public.europe_data_import VALUES (4640, '03/08/2020', '2020-31', '18265', '1490', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '43.0');
INSERT INTO public.europe_data_import VALUES (4641, '27/07/2020', '2020-30', '17384', '1512', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '40.85');
INSERT INTO public.europe_data_import VALUES (4642, '20/07/2020', '2020-29', '16485', '1359', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '40.22');
INSERT INTO public.europe_data_import VALUES (4643, '13/07/2020', '2020-28', '16865', '1258', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '41.77');
INSERT INTO public.europe_data_import VALUES (4644, '06/07/2020', '2020-27', '17769', '1063', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '42.8');
INSERT INTO public.europe_data_import VALUES (4645, '29/06/2020', '2020-26', '17717', '885', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '42.5');
INSERT INTO public.europe_data_import VALUES (4646, '22/06/2020', '2020-25', '17525', '786', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '40.0');
INSERT INTO public.europe_data_import VALUES (4647, '15/06/2020', '2020-24', '15638', '556', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '43.37');
INSERT INTO public.europe_data_import VALUES (4648, '08/06/2020', '2020-23', '20323', '484', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '43.52');
INSERT INTO public.europe_data_import VALUES (4649, '01/06/2020', '2020-22', '15765', '380', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '37.71');
INSERT INTO public.europe_data_import VALUES (4650, '25/05/2020', '2020-21', '15503', '429', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '33.89');
INSERT INTO public.europe_data_import VALUES (4651, '18/05/2020', '2020-20', '12595', '348', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '27.47');
INSERT INTO public.europe_data_import VALUES (4652, '11/05/2020', '2020-19', '10179', '437', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '20.65');
INSERT INTO public.europe_data_import VALUES (4653, '04/05/2020', '2020-18', '6943', '493', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '18.35');
INSERT INTO public.europe_data_import VALUES (4654, '27/04/2020', '2020-17', '8270', '592', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '22.67');
INSERT INTO public.europe_data_import VALUES (4655, '20/04/2020', '2020-16', '10525', '644', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '28.93');
INSERT INTO public.europe_data_import VALUES (4656, '13/04/2020', '2020-15', '13460', '871', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '40.26');
INSERT INTO public.europe_data_import VALUES (4657, '06/04/2020', '2020-14', '19917', '963', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '44.13');
INSERT INTO public.europe_data_import VALUES (4658, '30/03/2020', '2020-13', '16671', '955', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '29.39');
INSERT INTO public.europe_data_import VALUES (4659, '23/03/2020', '2020-12', '7700', '961', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '18.18');
INSERT INTO public.europe_data_import VALUES (4660, '16/03/2020', '2020-11', '7372', '530', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '15.63');
INSERT INTO public.europe_data_import VALUES (4661, '09/03/2020', '2020-10', '5588', '140', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '7.87');
INSERT INTO public.europe_data_import VALUES (4662, '02/03/2020', '2020-09', '935', '46', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '1.18');
INSERT INTO public.europe_data_import VALUES (4663, '24/02/2020', '2020-08', '43', '8', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (4664, '17/02/2020', '2020-07', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4665, '10/02/2020', '2020-06', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4666, '03/02/2020', '2020-05', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4667, '27/01/2020', '2020-04', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4668, '20/01/2020', '2020-03', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4669, '13/01/2020', '2020-02', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4670, '06/01/2020', '2020-01', '0', '0', '82913893', 'Iran', 'IR', 'IRN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (4671, '01/02/2021', '2021-04', '5873', '54', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '29.01');
INSERT INTO public.europe_data_import VALUES (4672, '25/01/2021', '2021-03', '5531', '49', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '39.16');
INSERT INTO public.europe_data_import VALUES (4673, '18/01/2021', '2021-02', '9863', '100', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '25.09');
INSERT INTO public.europe_data_import VALUES (4674, '11/01/2021', '2021-01', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '17.23');
INSERT INTO public.europe_data_import VALUES (4675, '04/01/2021', '2020-53', '6772', '64', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '36.18');
INSERT INTO public.europe_data_import VALUES (4676, '28/12/2020', '2020-52', '7452', '83', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '43.15');
INSERT INTO public.europe_data_import VALUES (4677, '21/12/2020', '2020-51', '9511', '118', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '50.74');
INSERT INTO public.europe_data_import VALUES (4678, '14/12/2020', '2020-50', '10434', '147', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '61.56');
INSERT INTO public.europe_data_import VALUES (4679, '07/12/2020', '2020-49', '13765', '208', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '73.47');
INSERT INTO public.europe_data_import VALUES (4680, '30/11/2020', '2020-48', '15114', '266', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '79.58');
INSERT INTO public.europe_data_import VALUES (4681, '23/11/2020', '2020-47', '16169', '288', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '93.54');
INSERT INTO public.europe_data_import VALUES (4682, '16/11/2020', '2020-46', '20603', '343', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '111.59');
INSERT INTO public.europe_data_import VALUES (4683, '09/11/2020', '2020-45', '23261', '361', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '119.16');
INSERT INTO public.europe_data_import VALUES (4684, '02/11/2020', '2020-44', '23581', '343', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '123.77');
INSERT INTO public.europe_data_import VALUES (4685, '26/10/2020', '2020-43', '25073', '369', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '125.61');
INSERT INTO public.europe_data_import VALUES (4686, '19/10/2020', '2020-42', '24304', '402', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '120.82');
INSERT INTO public.europe_data_import VALUES (4687, '12/10/2020', '2020-41', '23189', '453', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '134.52');
INSERT INTO public.europe_data_import VALUES (4688, '05/10/2020', '2020-40', '29691', '409', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '152.9');
INSERT INTO public.europe_data_import VALUES (4689, '28/09/2020', '2020-39', '30415', '435', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '150.45');
INSERT INTO public.europe_data_import VALUES (4690, '21/09/2020', '2020-38', '28726', '541', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '149.24');
INSERT INTO public.europe_data_import VALUES (4691, '14/09/2020', '2020-37', '29939', '502', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '150.43');
INSERT INTO public.europe_data_import VALUES (4692, '07/09/2020', '2020-36', '29193', '553', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '142.53');
INSERT INTO public.europe_data_import VALUES (4693, '31/08/2020', '2020-35', '26836', '531', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '138.0');
INSERT INTO public.europe_data_import VALUES (4694, '24/08/2020', '2020-34', '27410', '568', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '137.95');
INSERT INTO public.europe_data_import VALUES (4695, '17/08/2020', '2020-33', '26816', '468', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '121.55');
INSERT INTO public.europe_data_import VALUES (4696, '10/08/2020', '2020-32', '20964', '524', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '101.97');
INSERT INTO public.europe_data_import VALUES (4697, '03/08/2020', '2020-31', '19119', '506', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '93.16');
INSERT INTO public.europe_data_import VALUES (4698, '27/07/2020', '2020-30', '17502', '581', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '82.74');
INSERT INTO public.europe_data_import VALUES (4699, '20/07/2020', '2020-29', '15024', '631', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '81.53');
INSERT INTO public.europe_data_import VALUES (4700, '13/07/2020', '2020-28', '17027', '677', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '81.67');
INSERT INTO public.europe_data_import VALUES (4701, '06/07/2020', '2020-27', '15077', '717', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '75.33');
INSERT INTO public.europe_data_import VALUES (4702, '29/06/2020', '2020-26', '14534', '656', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '64.09');
INSERT INTO public.europe_data_import VALUES (4703, '22/06/2020', '2020-25', '10659', '493', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '47.07');
INSERT INTO public.europe_data_import VALUES (4704, '15/06/2020', '2020-24', '7843', '261', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '35.03');
INSERT INTO public.europe_data_import VALUES (4705, '08/06/2020', '2020-23', '5927', '141', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '20.09');
INSERT INTO public.europe_data_import VALUES (4706, '01/06/2020', '2020-22', '1970', '45', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '7.72');
INSERT INTO public.europe_data_import VALUES (4707, '25/05/2020', '2020-21', '1065', '37', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '4.33');
INSERT INTO public.europe_data_import VALUES (4708, '18/05/2020', '2020-20', '637', '14', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '2.82');
INSERT INTO public.europe_data_import VALUES (4709, '11/05/2020', '2020-19', '471', '12', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '2.41');
INSERT INTO public.europe_data_import VALUES (4710, '04/05/2020', '2020-18', '476', '10', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '1.93');
INSERT INTO public.europe_data_import VALUES (4711, '27/04/2020', '2020-17', '281', '5', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '1.19');
INSERT INTO public.europe_data_import VALUES (4712, '20/04/2020', '2020-16', '187', '6', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '1.47');
INSERT INTO public.europe_data_import VALUES (4713, '13/04/2020', '2020-15', '391', '15', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '2.05');
INSERT INTO public.europe_data_import VALUES (4714, '06/04/2020', '2020-14', '414', '19', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '1.85');
INSERT INTO public.europe_data_import VALUES (4715, '30/03/2020', '2020-13', '314', '22', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '1.08');
INSERT INTO public.europe_data_import VALUES (4716, '23/03/2020', '2020-12', '109', '11', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0.44');
INSERT INTO public.europe_data_import VALUES (4717, '16/03/2020', '2020-11', '63', '3', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0.27');
INSERT INTO public.europe_data_import VALUES (4718, '09/03/2020', '2020-10', '42', '6', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (4719, '02/03/2020', '2020-09', '19', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (4720, '24/02/2020', '2020-08', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4721, '17/02/2020', '2020-07', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4722, '10/02/2020', '2020-06', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4723, '03/02/2020', '2020-05', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4724, '27/01/2020', '2020-04', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4725, '20/01/2020', '2020-03', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4726, '13/01/2020', '2020-02', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4727, '06/01/2020', '2020-01', '0', '0', '39309789', 'Iraq', 'IQ', 'IRQ', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (4728, '01/02/2021', '2021-04', '8993', '337', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '485.72');
INSERT INTO public.europe_data_import VALUES (4729, '25/01/2021', '2021-03', '14828', '362', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '814.42');
INSERT INTO public.europe_data_import VALUES (4730, '18/01/2021', '2021-02', '25113', '264', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '1444.44');
INSERT INTO public.europe_data_import VALUES (4731, '11/01/2021', '2021-01', '45726', '85', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '1253.69');
INSERT INTO public.europe_data_import VALUES (4732, '04/01/2021', '2020-53', '15758', '55', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '455.63');
INSERT INTO public.europe_data_import VALUES (4733, '28/12/2020', '2020-52', '6587', '46', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '202.76');
INSERT INTO public.europe_data_import VALUES (4734, '21/12/2020', '2020-51', '3357', '34', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '107.99');
INSERT INTO public.europe_data_import VALUES (4735, '14/12/2020', '2020-50', '1939', '27', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '80.42');
INSERT INTO public.europe_data_import VALUES (4736, '07/12/2020', '2020-49', '2005', '45', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '77.18');
INSERT INTO public.europe_data_import VALUES (4737, '30/11/2020', '2020-48', '1780', '30', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '88.45');
INSERT INTO public.europe_data_import VALUES (4738, '23/11/2020', '2020-47', '2558', '43', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '103.32');
INSERT INTO public.europe_data_import VALUES (4739, '16/11/2020', '2020-46', '2509', '32', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '120.32');
INSERT INTO public.europe_data_import VALUES (4740, '09/11/2020', '2020-45', '3392', '32', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '168.55');
INSERT INTO public.europe_data_import VALUES (4741, '02/11/2020', '2020-44', '4874', '33', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '245.5');
INSERT INTO public.europe_data_import VALUES (4742, '26/10/2020', '2020-43', '7166', '30', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '297.7');
INSERT INTO public.europe_data_import VALUES (4743, '19/10/2020', '2020-42', '7434', '26', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '243.26');
INSERT INTO public.europe_data_import VALUES (4744, '12/10/2020', '2020-41', '4496', '16', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '153.7');
INSERT INTO public.europe_data_import VALUES (4745, '05/10/2020', '2020-40', '3042', '8', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '103.97');
INSERT INTO public.europe_data_import VALUES (4746, '28/09/2020', '2020-39', '2057', '10', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '81.66');
INSERT INTO public.europe_data_import VALUES (4747, '21/09/2020', '2020-38', '1948', '8', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '66.49');
INSERT INTO public.europe_data_import VALUES (4748, '14/09/2020', '2020-37', '1313', '7', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '45.37');
INSERT INTO public.europe_data_import VALUES (4749, '07/09/2020', '2020-36', '912', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '34.73');
INSERT INTO public.europe_data_import VALUES (4750, '31/08/2020', '2020-35', '791', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '30.65');
INSERT INTO public.europe_data_import VALUES (4751, '24/08/2020', '2020-34', '712', '3', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '25.63');
INSERT INTO public.europe_data_import VALUES (4752, '17/08/2020', '2020-33', '545', '2', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '22.33');
INSERT INTO public.europe_data_import VALUES (4753, '10/08/2020', '2020-32', '550', '9', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '16.94');
INSERT INTO public.europe_data_import VALUES (4754, '03/08/2020', '2020-31', '281', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '8.2');
INSERT INTO public.europe_data_import VALUES (4755, '27/07/2020', '2020-30', '121', '10', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '5.16');
INSERT INTO public.europe_data_import VALUES (4756, '20/07/2020', '2020-29', '132', '7', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '4.75');
INSERT INTO public.europe_data_import VALUES (4757, '13/07/2020', '2020-28', '101', '5', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '3.85');
INSERT INTO public.europe_data_import VALUES (4758, '06/07/2020', '2020-27', '88', '6', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (4759, '29/06/2020', '2020-26', '60', '20', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '2.77');
INSERT INTO public.europe_data_import VALUES (4760, '22/06/2020', '2020-25', '76', '9', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '3.63');
INSERT INTO public.europe_data_import VALUES (4761, '15/06/2020', '2020-24', '102', '27', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '6.38');
INSERT INTO public.europe_data_import VALUES (4762, '08/06/2020', '2020-23', '211', '29', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '11.46');
INSERT INTO public.europe_data_import VALUES (4763, '01/06/2020', '2020-22', '351', '44', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '17.9');
INSERT INTO public.europe_data_import VALUES (4764, '25/05/2020', '2020-21', '527', '63', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '33.5');
INSERT INTO public.europe_data_import VALUES (4765, '18/05/2020', '2020-20', '1116', '85', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '53.14');
INSERT INTO public.europe_data_import VALUES (4766, '11/05/2020', '2020-19', '1490', '155', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '76.14');
INSERT INTO public.europe_data_import VALUES (4767, '04/05/2020', '2020-18', '2244', '216', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '127.54');
INSERT INTO public.europe_data_import VALUES (4768, '27/04/2020', '2020-17', '4011', '477', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '195.89');
INSERT INTO public.europe_data_import VALUES (4769, '20/04/2020', '2020-16', '5596', '276', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '206.76');
INSERT INTO public.europe_data_import VALUES (4770, '13/04/2020', '2020-15', '4544', '176', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '143.55');
INSERT INTO public.europe_data_import VALUES (4771, '06/04/2020', '2020-14', '2496', '112', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '85.74');
INSERT INTO public.europe_data_import VALUES (4772, '30/03/2020', '2020-13', '1709', '42', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '49.88');
INSERT INTO public.europe_data_import VALUES (4773, '23/03/2020', '2020-12', '737', '2', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '18.05');
INSERT INTO public.europe_data_import VALUES (4774, '16/03/2020', '2020-11', '148', '2', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '3.43');
INSERT INTO public.europe_data_import VALUES (4775, '09/03/2020', '2020-10', '20', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0.43');
INSERT INTO public.europe_data_import VALUES (4776, '02/03/2020', '2020-09', '1', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0.02');
INSERT INTO public.europe_data_import VALUES (4777, '24/02/2020', '2020-08', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4778, '17/02/2020', '2020-07', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4779, '10/02/2020', '2020-06', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4780, '03/02/2020', '2020-05', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4781, '27/01/2020', '2020-04', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4782, '20/01/2020', '2020-03', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4783, '13/01/2020', '2020-02', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4784, '06/01/2020', '2020-01', '0', '0', '4904240', 'Ireland', 'IE', 'IRL', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4785, '01/02/2021', '2021-04', '2', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '7.09');
INSERT INTO public.europe_data_import VALUES (4786, '25/01/2021', '2021-03', '4', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '42.56');
INSERT INTO public.europe_data_import VALUES (4787, '18/01/2021', '2021-02', '32', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '56.74');
INSERT INTO public.europe_data_import VALUES (4788, '11/01/2021', '2021-01', '16', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '26.01');
INSERT INTO public.europe_data_import VALUES (4789, '04/01/2021', '2020-53', '6', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '8.28');
INSERT INTO public.europe_data_import VALUES (4790, '28/12/2020', '2020-52', '1', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '1.18');
INSERT INTO public.europe_data_import VALUES (4791, '21/12/2020', '2020-51', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '3.55');
INSERT INTO public.europe_data_import VALUES (4792, '14/12/2020', '2020-50', '3', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '4.73');
INSERT INTO public.europe_data_import VALUES (4793, '07/12/2020', '2020-49', '1', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '2.36');
INSERT INTO public.europe_data_import VALUES (4794, '30/11/2020', '2020-48', '1', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '7.09');
INSERT INTO public.europe_data_import VALUES (4795, '23/11/2020', '2020-47', '5', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '13.0');
INSERT INTO public.europe_data_import VALUES (4796, '16/11/2020', '2020-46', '6', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '11.82');
INSERT INTO public.europe_data_import VALUES (4797, '09/11/2020', '2020-45', '4', '1', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '10.64');
INSERT INTO public.europe_data_import VALUES (4798, '02/11/2020', '2020-44', '5', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '5.91');
INSERT INTO public.europe_data_import VALUES (4799, '26/10/2020', '2020-43', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '2.36');
INSERT INTO public.europe_data_import VALUES (4800, '19/10/2020', '2020-42', '2', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '7.09');
INSERT INTO public.europe_data_import VALUES (4801, '12/10/2020', '2020-41', '4', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '7.09');
INSERT INTO public.europe_data_import VALUES (4802, '05/10/2020', '2020-40', '2', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '3.55');
INSERT INTO public.europe_data_import VALUES (4803, '28/09/2020', '2020-39', '1', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '3.55');
INSERT INTO public.europe_data_import VALUES (4804, '21/09/2020', '2020-38', '2', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '2.36');
INSERT INTO public.europe_data_import VALUES (4805, '14/09/2020', '2020-37', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '1.18');
INSERT INTO public.europe_data_import VALUES (4806, '07/09/2020', '2020-36', '1', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '1.18');
INSERT INTO public.europe_data_import VALUES (4807, '31/08/2020', '2020-35', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4808, '24/08/2020', '2020-34', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4809, '17/08/2020', '2020-33', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4810, '10/08/2020', '2020-32', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4811, '03/08/2020', '2020-31', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4812, '27/07/2020', '2020-30', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4813, '20/07/2020', '2020-29', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4814, '13/07/2020', '2020-28', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4815, '06/07/2020', '2020-27', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4816, '29/06/2020', '2020-26', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4817, '22/06/2020', '2020-25', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4818, '15/06/2020', '2020-24', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4819, '08/06/2020', '2020-23', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4820, '01/06/2020', '2020-22', '0', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '1.18');
INSERT INTO public.europe_data_import VALUES (4821, '25/05/2020', '2020-21', '1', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '7.09');
INSERT INTO public.europe_data_import VALUES (4822, '18/05/2020', '2020-20', '5', '1', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '16.55');
INSERT INTO public.europe_data_import VALUES (4823, '11/05/2020', '2020-19', '9', '1', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '26.01');
INSERT INTO public.europe_data_import VALUES (4824, '04/05/2020', '2020-18', '13', '4', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '27.19');
INSERT INTO public.europe_data_import VALUES (4825, '27/04/2020', '2020-17', '10', '12', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '94.57');
INSERT INTO public.europe_data_import VALUES (4826, '20/04/2020', '2020-16', '70', '4', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '202.15');
INSERT INTO public.europe_data_import VALUES (4827, '13/04/2020', '2020-15', '101', '1', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '219.89');
INSERT INTO public.europe_data_import VALUES (4828, '06/04/2020', '2020-14', '85', '1', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '147.77');
INSERT INTO public.europe_data_import VALUES (4829, '30/03/2020', '2020-13', '40', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '49.65');
INSERT INTO public.europe_data_import VALUES (4830, '23/03/2020', '2020-12', '2', '0', '84589', 'Isle_of_Man', 'IM', 'IMN', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4831, '01/02/2021', '2021-04', '45208', '359', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '1110.27');
INSERT INTO public.europe_data_import VALUES (4832, '25/01/2021', '2021-03', '49380', '432', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '1244.29');
INSERT INTO public.europe_data_import VALUES (4833, '18/01/2021', '2021-02', '56626', '316', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '1285.33');
INSERT INTO public.europe_data_import VALUES (4834, '11/01/2021', '2021-01', '52876', '256', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '1069.06');
INSERT INTO public.europe_data_import VALUES (4835, '04/01/2021', '2020-53', '38201', '193', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '772.69');
INSERT INTO public.europe_data_import VALUES (4836, '28/12/2020', '2020-52', '27627', '139', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '541.44');
INSERT INTO public.europe_data_import VALUES (4837, '21/12/2020', '2020-51', '18500', '102', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '365.73');
INSERT INTO public.europe_data_import VALUES (4838, '14/12/2020', '2020-50', '12658', '82', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '256.81');
INSERT INTO public.europe_data_import VALUES (4839, '07/12/2020', '2020-49', '9221', '53', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '185.44');
INSERT INTO public.europe_data_import VALUES (4840, '30/11/2020', '2020-48', '6577', '58', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '139.04');
INSERT INTO public.europe_data_import VALUES (4841, '23/11/2020', '2020-47', '5268', '74', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '115.51');
INSERT INTO public.europe_data_import VALUES (4842, '16/11/2020', '2020-46', '4573', '58', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '105.69');
INSERT INTO public.europe_data_import VALUES (4843, '09/11/2020', '2020-45', '4431', '120', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '110.5');
INSERT INTO public.europe_data_import VALUES (4844, '02/11/2020', '2020-44', '4983', '157', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '132.46');
INSERT INTO public.europe_data_import VALUES (4845, '26/10/2020', '2020-43', '6302', '188', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '215.04');
INSERT INTO public.europe_data_import VALUES (4846, '19/10/2020', '2020-42', '12018', '226', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '418.7');
INSERT INTO public.europe_data_import VALUES (4847, '12/10/2020', '2020-41', '23653', '264', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '713.69');
INSERT INTO public.europe_data_import VALUES (4848, '05/10/2020', '2020-40', '37149', '253', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '936.08');
INSERT INTO public.europe_data_import VALUES (4849, '28/09/2020', '2020-39', '42599', '210', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '873.66');
INSERT INTO public.europe_data_import VALUES (4850, '21/09/2020', '2020-38', '31831', '137', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '678.25');
INSERT INTO public.europe_data_import VALUES (4851, '14/09/2020', '2020-37', '25952', '100', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '499.76');
INSERT INTO public.europe_data_import VALUES (4852, '07/09/2020', '2020-36', '16624', '100', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '322.71');
INSERT INTO public.europe_data_import VALUES (4853, '31/08/2020', '2020-35', '10869', '85', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '250.49');
INSERT INTO public.europe_data_import VALUES (4854, '24/08/2020', '2020-34', '10471', '149', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '236.51');
INSERT INTO public.europe_data_import VALUES (4855, '17/08/2020', '2020-33', '9678', '85', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '230.71');
INSERT INTO public.europe_data_import VALUES (4856, '10/08/2020', '2020-32', '9977', '64', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '247.04');
INSERT INTO public.europe_data_import VALUES (4857, '03/08/2020', '2020-31', '11069', '66', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '266.87');
INSERT INTO public.europe_data_import VALUES (4858, '27/07/2020', '2020-30', '11667', '61', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '273.33');
INSERT INTO public.europe_data_import VALUES (4859, '20/07/2020', '2020-29', '11619', '47', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '238.64');
INSERT INTO public.europe_data_import VALUES (4860, '13/07/2020', '2020-28', '8712', '31', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '175.07');
INSERT INTO public.europe_data_import VALUES (4861, '06/07/2020', '2020-27', '6203', '13', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '107.75');
INSERT INTO public.europe_data_import VALUES (4862, '29/06/2020', '2020-26', '2977', '12', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '54.39');
INSERT INTO public.europe_data_import VALUES (4863, '22/06/2020', '2020-25', '1657', '4', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '33.61');
INSERT INTO public.europe_data_import VALUES (4864, '15/06/2020', '2020-24', '1206', '4', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '24.06');
INSERT INTO public.europe_data_import VALUES (4865, '08/06/2020', '2020-23', '844', '13', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '14.03');
INSERT INTO public.europe_data_import VALUES (4866, '01/06/2020', '2020-22', '351', '5', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '5.33');
INSERT INTO public.europe_data_import VALUES (4867, '25/05/2020', '2020-21', '103', '8', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '2.85');
INSERT INTO public.europe_data_import VALUES (4868, '18/05/2020', '2020-20', '140', '20', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '4.8');
INSERT INTO public.europe_data_import VALUES (4869, '11/05/2020', '2020-19', '269', '20', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '12.67');
INSERT INTO public.europe_data_import VALUES (4870, '04/05/2020', '2020-18', '810', '33', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '31.89');
INSERT INTO public.europe_data_import VALUES (4871, '27/04/2020', '2020-17', '1907', '27', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '49.92');
INSERT INTO public.europe_data_import VALUES (4872, '20/04/2020', '2020-16', '2346', '69', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '59.41');
INSERT INTO public.europe_data_import VALUES (4873, '13/04/2020', '2020-15', '2715', '54', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '80.97');
INSERT INTO public.europe_data_import VALUES (4874, '06/04/2020', '2020-14', '4183', '34', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '86.38');
INSERT INTO public.europe_data_import VALUES (4875, '30/03/2020', '2020-13', '3176', '14', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '46.92');
INSERT INTO public.europe_data_import VALUES (4876, '23/03/2020', '2020-12', '821', '1', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '12.11');
INSERT INTO public.europe_data_import VALUES (4877, '16/03/2020', '2020-11', '211', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '2.82');
INSERT INTO public.europe_data_import VALUES (4878, '09/03/2020', '2020-10', '29', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0.43');
INSERT INTO public.europe_data_import VALUES (4879, '02/03/2020', '2020-09', '8', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (4880, '24/02/2020', '2020-08', '2', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (4881, '17/02/2020', '2020-07', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4882, '10/02/2020', '2020-06', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4883, '03/02/2020', '2020-05', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4884, '27/01/2020', '2020-04', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4885, '20/01/2020', '2020-03', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4886, '13/01/2020', '2020-02', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (4887, '06/01/2020', '2020-01', '0', '0', '8519373', 'Israel', 'IL', 'ISR', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (4888, '01/02/2021', '2021-04', '86219', '3055', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '284.55');
INSERT INTO public.europe_data_import VALUES (4889, '25/01/2021', '2021-03', '85536', '3284', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '315.31');
INSERT INTO public.europe_data_import VALUES (4890, '18/01/2021', '2021-02', '104786', '3422', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '374.14');
INSERT INTO public.europe_data_import VALUES (4891, '11/01/2021', '2021-01', '121045', '3423', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '379.05');
INSERT INTO public.europe_data_import VALUES (4892, '04/01/2021', '2020-53', '107750', '3407', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '335.09');
INSERT INTO public.europe_data_import VALUES (4893, '28/12/2020', '2020-52', '94511', '3126', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '337.95');
INSERT INTO public.europe_data_import VALUES (4894, '21/12/2020', '2020-51', '109473', '4279', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '371.62');
INSERT INTO public.europe_data_import VALUES (4895, '14/12/2020', '2020-50', '114834', '4442', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '428.32');
INSERT INTO public.europe_data_import VALUES (4896, '07/12/2020', '2020-49', '143700', '5174', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '530.17');
INSERT INTO public.europe_data_import VALUES (4897, '30/11/2020', '2020-48', '176310', '5081', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '673.71');
INSERT INTO public.europe_data_import VALUES (4898, '23/11/2020', '2020-47', '230339', '4594', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '784.9');
INSERT INTO public.europe_data_import VALUES (4899, '16/11/2020', '2020-46', '243425', '3835', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '777.33');
INSERT INTO public.europe_data_import VALUES (4900, '09/11/2020', '2020-45', '225769', '2568', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '678.14');
INSERT INTO public.europe_data_import VALUES (4901, '02/11/2020', '2020-44', '183553', '1488', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '488.89');
INSERT INTO public.europe_data_import VALUES (4902, '26/10/2020', '2020-43', '111541', '795', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '283.02');
INSERT INTO public.europe_data_import VALUES (4903, '19/10/2020', '2020-42', '59291', '377', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '147.3');
INSERT INTO public.europe_data_import VALUES (4904, '12/10/2020', '2020-41', '29621', '180', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '74.69');
INSERT INTO public.europe_data_import VALUES (4905, '05/10/2020', '2020-40', '15459', '151', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '45.02');
INSERT INTO public.europe_data_import VALUES (4906, '28/09/2020', '2020-39', '11714', '128', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '36.64');
INSERT INTO public.europe_data_import VALUES (4907, '21/09/2020', '2020-38', '10403', '97', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '34.0');
INSERT INTO public.europe_data_import VALUES (4908, '14/09/2020', '2020-37', '10119', '69', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '32.36');
INSERT INTO public.europe_data_import VALUES (4909, '07/09/2020', '2020-36', '9416', '64', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '30.3');
INSERT INTO public.europe_data_import VALUES (4910, '31/08/2020', '2020-35', '8873', '40', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '23.7');
INSERT INTO public.europe_data_import VALUES (4911, '24/08/2020', '2020-34', '5430', '41', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '14.54');
INSERT INTO public.europe_data_import VALUES (4912, '17/08/2020', '2020-33', '3349', '191', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '9.68');
INSERT INTO public.europe_data_import VALUES (4913, '10/08/2020', '2020-32', '2496', '51', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '7.37');
INSERT INTO public.europe_data_import VALUES (4914, '03/08/2020', '2020-31', '1952', '47', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '6.02');
INSERT INTO public.europe_data_import VALUES (4915, '27/07/2020', '2020-30', '1684', '62', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '5.06');
INSERT INTO public.europe_data_import VALUES (4916, '20/07/2020', '2020-29', '1373', '91', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '4.68');
INSERT INTO public.europe_data_import VALUES (4917, '13/07/2020', '2020-28', '1450', '93', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '4.56');
INSERT INTO public.europe_data_import VALUES (4918, '06/07/2020', '2020-27', '1301', '123', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '5.16');
INSERT INTO public.europe_data_import VALUES (4919, '29/06/2020', '2020-26', '1811', '104', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '5.5');
INSERT INTO public.europe_data_import VALUES (4920, '22/06/2020', '2020-25', '1510', '289', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '5.8');
INSERT INTO public.europe_data_import VALUES (4921, '15/06/2020', '2020-24', '1991', '446', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '6.58');
INSERT INTO public.europe_data_import VALUES (4922, '08/06/2020', '2020-23', '1979', '484', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '8.52');
INSERT INTO public.europe_data_import VALUES (4923, '01/06/2020', '2020-22', '3161', '630', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '12.56');
INSERT INTO public.europe_data_import VALUES (4924, '25/05/2020', '2020-21', '4423', '877', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '17.87');
INSERT INTO public.europe_data_import VALUES (4925, '18/05/2020', '2020-20', '6365', '1348', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '24.38');
INSERT INTO public.europe_data_import VALUES (4926, '11/05/2020', '2020-19', '8353', '1676', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '35.45');
INSERT INTO public.europe_data_import VALUES (4927, '04/05/2020', '2020-18', '13042', '2240', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '52.59');
INSERT INTO public.europe_data_import VALUES (4928, '27/04/2020', '2020-17', '18703', '2984', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '68.44');
INSERT INTO public.europe_data_import VALUES (4929, '20/04/2020', '2020-16', '22609', '3759', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '82.88');
INSERT INTO public.europe_data_import VALUES (4930, '13/04/2020', '2020-15', '27415', '4012', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '97.21');
INSERT INTO public.europe_data_import VALUES (4931, '06/04/2020', '2020-14', '31259', '5108', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '115.66');
INSERT INTO public.europe_data_import VALUES (4932, '30/03/2020', '2020-13', '38551', '5305', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '122.12');
INSERT INTO public.europe_data_import VALUES (4933, '23/03/2020', '2020-12', '35158', '3665', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '85.76');
INSERT INTO public.europe_data_import VALUES (4934, '16/03/2020', '2020-11', '16605', '1445', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '36.93');
INSERT INTO public.europe_data_import VALUES (4935, '09/03/2020', '2020-10', '5686', '331', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '12.0');
INSERT INTO public.europe_data_import VALUES (4936, '02/03/2020', '2020-09', '1557', '33', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '2.79');
INSERT INTO public.europe_data_import VALUES (4937, '24/02/2020', '2020-08', '129', '2', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0.21');
INSERT INTO public.europe_data_import VALUES (4938, '17/02/2020', '2020-07', '0', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4939, '10/02/2020', '2020-06', '0', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (4940, '03/02/2020', '2020-05', '3', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (4941, '27/01/2020', '2020-04', '0', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4942, '20/01/2020', '2020-03', '0', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4943, '13/01/2020', '2020-02', '0', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (4944, '06/01/2020', '2020-01', '0', '0', '60359546', 'Italy', 'IT', 'ITA', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (4945, '01/02/2021', '2021-04', '766', '14', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '51.01');
INSERT INTO public.europe_data_import VALUES (4946, '25/01/2021', '2021-03', '738', '12', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '46.64');
INSERT INTO public.europe_data_import VALUES (4947, '18/01/2021', '2021-02', '637', '13', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '41.55');
INSERT INTO public.europe_data_import VALUES (4948, '11/01/2021', '2021-01', '588', '9', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '30.7');
INSERT INTO public.europe_data_import VALUES (4949, '04/01/2021', '2020-53', '317', '6', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '25.78');
INSERT INTO public.europe_data_import VALUES (4950, '28/12/2020', '2020-52', '443', '12', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '34.66');
INSERT INTO public.europe_data_import VALUES (4951, '21/12/2020', '2020-51', '579', '13', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '39.65');
INSERT INTO public.europe_data_import VALUES (4952, '14/12/2020', '2020-50', '590', '8', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '33.95');
INSERT INTO public.europe_data_import VALUES (4953, '07/12/2020', '2020-49', '411', '9', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '28.36');
INSERT INTO public.europe_data_import VALUES (4954, '30/11/2020', '2020-48', '425', '18', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '27.98');
INSERT INTO public.europe_data_import VALUES (4955, '23/11/2020', '2020-47', '400', '7', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '26.39');
INSERT INTO public.europe_data_import VALUES (4956, '16/11/2020', '2020-46', '378', '10', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '25.54');
INSERT INTO public.europe_data_import VALUES (4957, '09/11/2020', '2020-45', '375', '12', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '26.86');
INSERT INTO public.europe_data_import VALUES (4958, '02/11/2020', '2020-44', '417', '21', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '29.07');
INSERT INTO public.europe_data_import VALUES (4959, '26/10/2020', '2020-43', '440', '17', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '33.78');
INSERT INTO public.europe_data_import VALUES (4960, '19/10/2020', '2020-42', '556', '32', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '46.77');
INSERT INTO public.europe_data_import VALUES (4961, '12/10/2020', '2020-41', '823', '19', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '58.51');
INSERT INTO public.europe_data_import VALUES (4962, '05/10/2020', '2020-40', '902', '31', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '64.68');
INSERT INTO public.europe_data_import VALUES (4963, '28/09/2020', '2020-39', '1005', '22', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '75.37');
INSERT INTO public.europe_data_import VALUES (4964, '21/09/2020', '2020-38', '1217', '25', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '63.94');
INSERT INTO public.europe_data_import VALUES (4965, '14/09/2020', '2020-37', '668', '9', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '47.96');
INSERT INTO public.europe_data_import VALUES (4966, '07/09/2020', '2020-36', '746', '12', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '53.39');
INSERT INTO public.europe_data_import VALUES (4967, '31/08/2020', '2020-35', '828', '5', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '42.19');
INSERT INTO public.europe_data_import VALUES (4968, '24/08/2020', '2020-34', '416', '2', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '17.16');
INSERT INTO public.europe_data_import VALUES (4969, '17/08/2020', '2020-33', '90', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '7.43');
INSERT INTO public.europe_data_import VALUES (4970, '10/08/2020', '2020-32', '129', '2', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '6.14');
INSERT INTO public.europe_data_import VALUES (4971, '03/08/2020', '2020-31', '52', '2', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '3.53');
INSERT INTO public.europe_data_import VALUES (4972, '27/07/2020', '2020-30', '52', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '2.85');
INSERT INTO public.europe_data_import VALUES (4973, '20/07/2020', '2020-29', '32', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.97');
INSERT INTO public.europe_data_import VALUES (4974, '13/07/2020', '2020-28', '26', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '2.1');
INSERT INTO public.europe_data_import VALUES (4975, '06/07/2020', '2020-27', '36', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '2.48');
INSERT INTO public.europe_data_import VALUES (4976, '29/06/2020', '2020-26', '37', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '2.68');
INSERT INTO public.europe_data_import VALUES (4977, '22/06/2020', '2020-25', '42', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '2.07');
INSERT INTO public.europe_data_import VALUES (4978, '15/06/2020', '2020-24', '19', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.05');
INSERT INTO public.europe_data_import VALUES (4979, '08/06/2020', '2020-23', '12', '1', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.56');
INSERT INTO public.europe_data_import VALUES (4980, '01/06/2020', '2020-22', '34', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '2.24');
INSERT INTO public.europe_data_import VALUES (4981, '25/05/2020', '2020-21', '32', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.7');
INSERT INTO public.europe_data_import VALUES (4982, '18/05/2020', '2020-20', '18', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.73');
INSERT INTO public.europe_data_import VALUES (4983, '11/05/2020', '2020-19', '33', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '5.16');
INSERT INTO public.europe_data_import VALUES (4984, '04/05/2020', '2020-18', '119', '2', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '9.26');
INSERT INTO public.europe_data_import VALUES (4985, '27/04/2020', '2020-17', '154', '2', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '9.43');
INSERT INTO public.europe_data_import VALUES (4986, '20/04/2020', '2020-16', '124', '1', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '4.68');
INSERT INTO public.europe_data_import VALUES (4987, '13/04/2020', '2020-15', '14', '1', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.29');
INSERT INTO public.europe_data_import VALUES (4988, '06/04/2020', '2020-14', '24', '2', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '1.32');
INSERT INTO public.europe_data_import VALUES (4989, '30/03/2020', '2020-13', '15', '1', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '0.81');
INSERT INTO public.europe_data_import VALUES (4990, '23/03/2020', '2020-12', '9', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '0.64');
INSERT INTO public.europe_data_import VALUES (4991, '16/03/2020', '2020-11', '10', '0', '2948277', 'Jamaica', 'JM', 'JAM', 'America', '');
INSERT INTO public.europe_data_import VALUES (4992, '01/02/2021', '2021-04', '28857', '703', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '48.26');
INSERT INTO public.europe_data_import VALUES (4993, '25/01/2021', '2021-03', '32367', '518', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '58.26');
INSERT INTO public.europe_data_import VALUES (4994, '18/01/2021', '2021-02', '41542', '457', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '66.57');
INSERT INTO public.europe_data_import VALUES (4995, '11/01/2021', '2021-01', '42905', '445', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '52.43');
INSERT INTO public.europe_data_import VALUES (4996, '04/01/2021', '2020-53', '23611', '347', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '35.73');
INSERT INTO public.europe_data_import VALUES (4997, '28/12/2020', '2020-52', '21713', '352', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '31.99');
INSERT INTO public.europe_data_import VALUES (4998, '21/12/2020', '2020-51', '18870', '315', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '28.74');
INSERT INTO public.europe_data_import VALUES (4999, '14/12/2020', '2020-50', '17586', '250', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '25.93');
INSERT INTO public.europe_data_import VALUES (5000, '07/12/2020', '2020-49', '15307', '216', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '24.55');
INSERT INTO public.europe_data_import VALUES (5001, '30/11/2020', '2020-48', '15843', '139', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '23.71');
INSERT INTO public.europe_data_import VALUES (5002, '23/11/2020', '2020-47', '14240', '97', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '18.0');
INSERT INTO public.europe_data_import VALUES (5003, '16/11/2020', '2020-46', '8593', '65', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '11.72');
INSERT INTO public.europe_data_import VALUES (5004, '09/11/2020', '2020-45', '6271', '44', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '8.68');
INSERT INTO public.europe_data_import VALUES (5005, '02/11/2020', '2020-44', '4739', '56', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '6.85');
INSERT INTO public.europe_data_import VALUES (5006, '26/10/2020', '2020-43', '3947', '44', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '6.09');
INSERT INTO public.europe_data_import VALUES (5007, '19/10/2020', '2020-42', '3780', '45', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '5.82');
INSERT INTO public.europe_data_import VALUES (5008, '12/10/2020', '2020-41', '3608', '30', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '5.69');
INSERT INTO public.europe_data_import VALUES (5009, '05/10/2020', '2020-40', '3608', '51', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '5.58');
INSERT INTO public.europe_data_import VALUES (5010, '28/09/2020', '2020-39', '3474', '48', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '5.1');
INSERT INTO public.europe_data_import VALUES (5011, '21/09/2020', '2020-38', '3000', '58', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '5.36');
INSERT INTO public.europe_data_import VALUES (5012, '14/09/2020', '2020-37', '3801', '79', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '6.14');
INSERT INTO public.europe_data_import VALUES (5013, '07/09/2020', '2020-36', '3991', '84', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '7.96');
INSERT INTO public.europe_data_import VALUES (5014, '31/08/2020', '2020-35', '6111', '99', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '10.18');
INSERT INTO public.europe_data_import VALUES (5015, '24/08/2020', '2020-34', '6802', '82', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '10.85');
INSERT INTO public.europe_data_import VALUES (5016, '17/08/2020', '2020-33', '6962', '51', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '13.31');
INSERT INTO public.europe_data_import VALUES (5017, '10/08/2020', '2020-32', '9918', '36', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '14.19');
INSERT INTO public.europe_data_import VALUES (5018, '03/08/2020', '2020-31', '8083', '15', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '10.23');
INSERT INTO public.europe_data_import VALUES (5019, '27/07/2020', '2020-30', '4893', '11', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '6.4');
INSERT INTO public.europe_data_import VALUES (5020, '20/07/2020', '2020-29', '3228', '3', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '4.19');
INSERT INTO public.europe_data_import VALUES (5021, '13/07/2020', '2020-28', '2093', '5', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '2.67');
INSERT INTO public.europe_data_import VALUES (5022, '06/07/2020', '2020-27', '1299', '5', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '1.47');
INSERT INTO public.europe_data_import VALUES (5023, '29/06/2020', '2020-26', '560', '19', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.77');
INSERT INTO public.europe_data_import VALUES (5024, '22/06/2020', '2020-25', '414', '28', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.58');
INSERT INTO public.europe_data_import VALUES (5025, '15/06/2020', '2020-24', '328', '9', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.49');
INSERT INTO public.europe_data_import VALUES (5026, '08/06/2020', '2020-23', '290', '24', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.47');
INSERT INTO public.europe_data_import VALUES (5027, '01/06/2020', '2020-22', '303', '62', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (5028, '25/05/2020', '2020-21', '276', '81', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.62');
INSERT INTO public.europe_data_import VALUES (5029, '18/05/2020', '2020-20', '507', '128', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.98');
INSERT INTO public.europe_data_import VALUES (5030, '11/05/2020', '2020-19', '741', '111', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '1.9');
INSERT INTO public.europe_data_import VALUES (5031, '04/05/2020', '2020-18', '1672', '159', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '3.39');
INSERT INTO public.europe_data_import VALUES (5032, '27/04/2020', '2020-17', '2634', '180', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '4.83');
INSERT INTO public.europe_data_import VALUES (5033, '20/04/2020', '2020-16', '3496', '69', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '5.59');
INSERT INTO public.europe_data_import VALUES (5034, '13/04/2020', '2020-15', '3601', '29', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '4.25');
INSERT INTO public.europe_data_import VALUES (5035, '06/04/2020', '2020-14', '1788', '19', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '2.02');
INSERT INTO public.europe_data_import VALUES (5036, '30/03/2020', '2020-13', '777', '13', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.83');
INSERT INTO public.europe_data_import VALUES (5037, '23/03/2020', '2020-12', '275', '17', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.47');
INSERT INTO public.europe_data_import VALUES (5038, '16/03/2020', '2020-11', '326', '17', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.44');
INSERT INTO public.europe_data_import VALUES (5039, '09/03/2020', '2020-10', '234', '1', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.27');
INSERT INTO public.europe_data_import VALUES (5040, '02/03/2020', '2020-09', '110', '5', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (5041, '24/02/2020', '2020-08', '85', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (5042, '17/02/2020', '2020-07', '34', '1', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (5043, '10/02/2020', '2020-06', '5', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (5044, '03/02/2020', '2020-05', '17', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5045, '27/01/2020', '2020-04', '2', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (5046, '20/01/2020', '2020-03', '1', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (5047, '13/01/2020', '2020-02', '0', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5048, '06/01/2020', '2020-01', '0', '0', '126860299', 'Japan', 'JP', 'JPN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5049, '01/02/2021', '2021-04', '30', '3', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '90.91');
INSERT INTO public.europe_data_import VALUES (5050, '25/01/2021', '2021-03', '68', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '139.15');
INSERT INTO public.europe_data_import VALUES (5051, '18/01/2021', '2021-02', '82', '5', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '216.15');
INSERT INTO public.europe_data_import VALUES (5052, '11/01/2021', '2021-01', '151', '13', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '286.65');
INSERT INTO public.europe_data_import VALUES (5053, '04/01/2021', '2020-53', '158', '3', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '449.92');
INSERT INTO public.europe_data_import VALUES (5054, '28/12/2020', '2020-52', '327', '5', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '820.07');
INSERT INTO public.europe_data_import VALUES (5055, '21/12/2020', '2020-51', '557', '4', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '908.2');
INSERT INTO public.europe_data_import VALUES (5056, '14/12/2020', '2020-50', '422', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '789.45');
INSERT INTO public.europe_data_import VALUES (5057, '07/12/2020', '2020-49', '429', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '506.51');
INSERT INTO public.europe_data_import VALUES (5058, '30/11/2020', '2020-48', '117', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '181.82');
INSERT INTO public.europe_data_import VALUES (5059, '23/11/2020', '2020-47', '79', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '155.85');
INSERT INTO public.europe_data_import VALUES (5060, '16/11/2020', '2020-46', '89', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '146.57');
INSERT INTO public.europe_data_import VALUES (5061, '09/11/2020', '2020-45', '69', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '104.83');
INSERT INTO public.europe_data_import VALUES (5062, '02/11/2020', '2020-44', '44', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '77.92');
INSERT INTO public.europe_data_import VALUES (5063, '26/10/2020', '2020-43', '40', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '75.14');
INSERT INTO public.europe_data_import VALUES (5064, '19/10/2020', '2020-42', '41', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '64.01');
INSERT INTO public.europe_data_import VALUES (5065, '12/10/2020', '2020-41', '28', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '45.46');
INSERT INTO public.europe_data_import VALUES (5066, '05/10/2020', '2020-40', '21', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '25.97');
INSERT INTO public.europe_data_import VALUES (5067, '28/09/2020', '2020-39', '7', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '18.55');
INSERT INTO public.europe_data_import VALUES (5068, '21/09/2020', '2020-38', '13', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '8.35');
INSERT INTO public.europe_data_import VALUES (5069, '14/09/2020', '2020-37', '-4', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '5.57');
INSERT INTO public.europe_data_import VALUES (5070, '07/09/2020', '2020-36', '10', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '19.48');
INSERT INTO public.europe_data_import VALUES (5071, '31/08/2020', '2020-35', '11', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '17.63');
INSERT INTO public.europe_data_import VALUES (5072, '24/08/2020', '2020-34', '8', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '16.7');
INSERT INTO public.europe_data_import VALUES (5073, '17/08/2020', '2020-33', '10', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '18.55');
INSERT INTO public.europe_data_import VALUES (5074, '10/08/2020', '2020-32', '10', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '12.06');
INSERT INTO public.europe_data_import VALUES (5075, '03/08/2020', '2020-31', '3', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '3.71');
INSERT INTO public.europe_data_import VALUES (5076, '27/07/2020', '2020-30', '1', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '6.49');
INSERT INTO public.europe_data_import VALUES (5077, '20/07/2020', '2020-29', '6', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '10.2');
INSERT INTO public.europe_data_import VALUES (5078, '13/07/2020', '2020-28', '5', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '5.57');
INSERT INTO public.europe_data_import VALUES (5079, '06/07/2020', '2020-27', '1', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '1.86');
INSERT INTO public.europe_data_import VALUES (5080, '29/06/2020', '2020-26', '1', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '5.57');
INSERT INTO public.europe_data_import VALUES (5081, '22/06/2020', '2020-25', '5', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '6.49');
INSERT INTO public.europe_data_import VALUES (5082, '15/06/2020', '2020-24', '2', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '4.64');
INSERT INTO public.europe_data_import VALUES (5083, '08/06/2020', '2020-23', '3', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '4.64');
INSERT INTO public.europe_data_import VALUES (5084, '01/06/2020', '2020-22', '2', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '5.57');
INSERT INTO public.europe_data_import VALUES (5085, '25/05/2020', '2020-21', '4', '2', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '11.13');
INSERT INTO public.europe_data_import VALUES (5086, '18/05/2020', '2020-20', '8', '2', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '9.28');
INSERT INTO public.europe_data_import VALUES (5087, '11/05/2020', '2020-19', '2', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '12.06');
INSERT INTO public.europe_data_import VALUES (5088, '04/05/2020', '2020-18', '11', '5', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '39.89');
INSERT INTO public.europe_data_import VALUES (5089, '27/04/2020', '2020-17', '32', '7', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '63.08');
INSERT INTO public.europe_data_import VALUES (5090, '20/04/2020', '2020-16', '36', '8', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '87.2');
INSERT INTO public.europe_data_import VALUES (5091, '13/04/2020', '2020-15', '58', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '139.15');
INSERT INTO public.europe_data_import VALUES (5092, '06/04/2020', '2020-14', '92', '1', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '129.87');
INSERT INTO public.europe_data_import VALUES (5093, '30/03/2020', '2020-13', '48', '2', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '58.44');
INSERT INTO public.europe_data_import VALUES (5094, '23/03/2020', '2020-12', '15', '0', '107796', 'Jersey', 'JE', 'JEY', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (5095, '01/02/2021', '2021-04', '7609', '102', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '123.92');
INSERT INTO public.europe_data_import VALUES (5096, '25/01/2021', '2021-03', '4909', '71', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '116.64');
INSERT INTO public.europe_data_import VALUES (5097, '18/01/2021', '2021-02', '6874', '110', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '171.61');
INSERT INTO public.europe_data_import VALUES (5098, '11/01/2021', '2021-01', '10462', '140', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '205.15');
INSERT INTO public.europe_data_import VALUES (5099, '04/01/2021', '2020-53', '10262', '145', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '205.51');
INSERT INTO public.europe_data_import VALUES (5100, '28/12/2020', '2020-52', '10498', '154', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '280.47');
INSERT INTO public.europe_data_import VALUES (5101, '21/12/2020', '2020-51', '17834', '239', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '369.83');
INSERT INTO public.europe_data_import VALUES (5102, '14/12/2020', '2020-50', '19525', '309', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '448.51');
INSERT INTO public.europe_data_import VALUES (5103, '07/12/2020', '2020-49', '25782', '362', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '560.9');
INSERT INTO public.europe_data_import VALUES (5104, '30/11/2020', '2020-48', '30878', '458', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '699.18');
INSERT INTO public.europe_data_import VALUES (5105, '23/11/2020', '2020-47', '39751', '464', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '733.62');
INSERT INTO public.europe_data_import VALUES (5106, '16/11/2020', '2020-46', '34357', '539', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '671.29');
INSERT INTO public.europe_data_import VALUES (5107, '09/11/2020', '2020-45', '33455', '367', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '556.68');
INSERT INTO public.europe_data_import VALUES (5108, '02/11/2020', '2020-44', '22779', '287', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '379.07');
INSERT INTO public.europe_data_import VALUES (5109, '26/10/2020', '2020-43', '15514', '234', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '278.77');
INSERT INTO public.europe_data_import VALUES (5110, '19/10/2020', '2020-42', '12647', '154', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '217.12');
INSERT INTO public.europe_data_import VALUES (5111, '12/10/2020', '2020-41', '9286', '90', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '162.69');
INSERT INTO public.europe_data_import VALUES (5112, '05/10/2020', '2020-40', '7148', '56', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '107.52');
INSERT INTO public.europe_data_import VALUES (5113, '28/09/2020', '2020-39', '3713', '15', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '51.26');
INSERT INTO public.europe_data_import VALUES (5114, '21/09/2020', '2020-38', '1465', '6', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '23.44');
INSERT INTO public.europe_data_import VALUES (5115, '14/09/2020', '2020-37', '903', '8', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '13.34');
INSERT INTO public.europe_data_import VALUES (5116, '07/09/2020', '2020-36', '445', '1', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '7.94');
INSERT INTO public.europe_data_import VALUES (5117, '31/08/2020', '2020-35', '357', '3', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '5.82');
INSERT INTO public.europe_data_import VALUES (5118, '24/08/2020', '2020-34', '231', '1', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '3.53');
INSERT INTO public.europe_data_import VALUES (5119, '17/08/2020', '2020-33', '126', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.63');
INSERT INTO public.europe_data_import VALUES (5120, '10/08/2020', '2020-32', '39', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.83');
INSERT INTO public.europe_data_import VALUES (5121, '03/08/2020', '2020-31', '45', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '-0.05');
INSERT INTO public.europe_data_import VALUES (5122, '27/07/2020', '2020-30', '-50', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '-0.11');
INSERT INTO public.europe_data_import VALUES (5123, '20/07/2020', '2020-29', '39', '1', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.53');
INSERT INTO public.europe_data_import VALUES (5124, '13/07/2020', '2020-28', '15', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.57');
INSERT INTO public.europe_data_import VALUES (5125, '06/07/2020', '2020-27', '43', '1', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.3');
INSERT INTO public.europe_data_import VALUES (5126, '29/06/2020', '2020-26', '88', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.58');
INSERT INTO public.europe_data_import VALUES (5127, '22/06/2020', '2020-25', '72', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '2.23');
INSERT INTO public.europe_data_import VALUES (5128, '15/06/2020', '2020-24', '153', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '2.2');
INSERT INTO public.europe_data_import VALUES (5129, '08/06/2020', '2020-23', '69', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.99');
INSERT INTO public.europe_data_import VALUES (5130, '01/06/2020', '2020-22', '31', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.25');
INSERT INTO public.europe_data_import VALUES (5131, '25/05/2020', '2020-21', '95', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.66');
INSERT INTO public.europe_data_import VALUES (5132, '18/05/2020', '2020-20', '73', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.5');
INSERT INTO public.europe_data_import VALUES (5133, '11/05/2020', '2020-19', '79', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.92');
INSERT INTO public.europe_data_import VALUES (5134, '04/05/2020', '2020-18', '14', '2', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.44');
INSERT INTO public.europe_data_import VALUES (5135, '27/04/2020', '2020-17', '30', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.57');
INSERT INTO public.europe_data_import VALUES (5136, '20/04/2020', '2020-16', '28', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.71');
INSERT INTO public.europe_data_import VALUES (5137, '13/04/2020', '2020-15', '44', '2', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '1.29');
INSERT INTO public.europe_data_import VALUES (5138, '06/04/2020', '2020-14', '86', '4', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '2.44');
INSERT INTO public.europe_data_import VALUES (5139, '30/03/2020', '2020-13', '160', '1', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '2.42');
INSERT INTO public.europe_data_import VALUES (5140, '23/03/2020', '2020-12', '84', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '0.98');
INSERT INTO public.europe_data_import VALUES (5141, '16/03/2020', '2020-11', '15', '0', '10101697', 'Jordan', 'JO', 'JOR', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5142, '01/02/2021', '2021-04', '9953', '88', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '101.77');
INSERT INTO public.europe_data_import VALUES (5143, '25/01/2021', '2021-03', '8927', '67', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '85.2');
INSERT INTO public.europe_data_import VALUES (5144, '18/01/2021', '2021-02', '6878', '16', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '53.34');
INSERT INTO public.europe_data_import VALUES (5145, '11/01/2021', '2021-01', '3018', '100', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '61.6');
INSERT INTO public.europe_data_import VALUES (5146, '04/01/2021', '2020-53', '8409', '86', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '83.11');
INSERT INTO public.europe_data_import VALUES (5147, '28/12/2020', '2020-52', '7009', '67', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '66.74');
INSERT INTO public.europe_data_import VALUES (5148, '21/12/2020', '2020-51', '5373', '70', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '62.32');
INSERT INTO public.europe_data_import VALUES (5149, '14/12/2020', '2020-50', '6188', '64', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '67.22');
INSERT INTO public.europe_data_import VALUES (5150, '07/12/2020', '2020-49', '6283', '55', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '68.48');
INSERT INTO public.europe_data_import VALUES (5151, '30/11/2020', '2020-48', '6421', '61', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '67.69');
INSERT INTO public.europe_data_import VALUES (5152, '23/11/2020', '2020-47', '6137', '53', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '62.04');
INSERT INTO public.europe_data_import VALUES (5153, '16/11/2020', '2020-46', '5372', '53', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '55.98');
INSERT INTO public.europe_data_import VALUES (5154, '09/11/2020', '2020-45', '5013', '39', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '45.35');
INSERT INTO public.europe_data_import VALUES (5155, '02/11/2020', '2020-44', '3400', '37', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '29.05');
INSERT INTO public.europe_data_import VALUES (5156, '26/10/2020', '2020-43', '1990', '40', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '20.07');
INSERT INTO public.europe_data_import VALUES (5157, '19/10/2020', '2020-42', '1733', '36', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '19.56');
INSERT INTO public.europe_data_import VALUES (5158, '12/10/2020', '2020-41', '1896', '29', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '18.73');
INSERT INTO public.europe_data_import VALUES (5159, '05/10/2020', '2020-40', '1579', '36', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '18.27');
INSERT INTO public.europe_data_import VALUES (5160, '28/09/2020', '2020-39', '1810', '34', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '20.22');
INSERT INTO public.europe_data_import VALUES (5161, '21/09/2020', '2020-38', '1942', '53', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '23.35');
INSERT INTO public.europe_data_import VALUES (5162, '14/09/2020', '2020-37', '2390', '60', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '31.48');
INSERT INTO public.europe_data_import VALUES (5163, '07/09/2020', '2020-36', '3450', '121', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '35.91');
INSERT INTO public.europe_data_import VALUES (5164, '31/08/2020', '2020-35', '3211', '108', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '48.7');
INSERT INTO public.europe_data_import VALUES (5165, '24/08/2020', '2020-34', '5823', '186', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '79.45');
INSERT INTO public.europe_data_import VALUES (5166, '17/08/2020', '2020-33', '8917', '54', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '123.97');
INSERT INTO public.europe_data_import VALUES (5167, '10/08/2020', '2020-32', '14081', '324', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '159.56');
INSERT INTO public.europe_data_import VALUES (5168, '03/08/2020', '2020-31', '15519', '524', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '144.48');
INSERT INTO public.europe_data_import VALUES (5169, '27/07/2020', '2020-30', '11284', '210', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '125.24');
INSERT INTO public.europe_data_import VALUES (5170, '20/07/2020', '2020-29', '11949', '0', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '125.4');
INSERT INTO public.europe_data_import VALUES (5171, '13/07/2020', '2020-28', '11315', '187', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '207.87');
INSERT INTO public.europe_data_import VALUES (5172, '06/07/2020', '2020-27', '27247', '5', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '166.25');
INSERT INTO public.europe_data_import VALUES (5173, '29/06/2020', '2020-26', '3595', '63', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '35.13');
INSERT INTO public.europe_data_import VALUES (5174, '22/06/2020', '2020-25', '2923', '43', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '26.27');
INSERT INTO public.europe_data_import VALUES (5175, '15/06/2020', '2020-24', '1950', '21', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '18.87');
INSERT INTO public.europe_data_import VALUES (5176, '08/06/2020', '2020-23', '1551', '15', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '23.33');
INSERT INTO public.europe_data_import VALUES (5177, '01/06/2020', '2020-22', '2777', '6', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '26.24');
INSERT INTO public.europe_data_import VALUES (5178, '25/05/2020', '2020-21', '2091', '1', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '18.35');
INSERT INTO public.europe_data_import VALUES (5179, '18/05/2020', '2020-20', '1314', '3', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '13.35');
INSERT INTO public.europe_data_import VALUES (5180, '11/05/2020', '2020-19', '1162', '4', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '12.99');
INSERT INTO public.europe_data_import VALUES (5181, '04/05/2020', '2020-18', '1247', '2', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '12.02');
INSERT INTO public.europe_data_import VALUES (5182, '27/04/2020', '2020-17', '982', '6', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '9.47');
INSERT INTO public.europe_data_import VALUES (5183, '20/04/2020', '2020-16', '774', '9', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '6.49');
INSERT INTO public.europe_data_import VALUES (5184, '13/04/2020', '2020-15', '430', '5', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '3.65');
INSERT INTO public.europe_data_import VALUES (5185, '06/04/2020', '2020-14', '247', '4', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '2.54');
INSERT INTO public.europe_data_import VALUES (5186, '30/03/2020', '2020-13', '224', '1', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '1.48');
INSERT INTO public.europe_data_import VALUES (5187, '23/03/2020', '2020-12', '51', '0', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '0.32');
INSERT INTO public.europe_data_import VALUES (5188, '16/03/2020', '2020-11', '9', '0', '18551428', 'Kazakhstan', 'KZ', 'KAZ', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5189, '01/02/2021', '2021-04', '804', '22', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.22');
INSERT INTO public.europe_data_import VALUES (5190, '25/01/2021', '2021-03', '890', '13', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.39');
INSERT INTO public.europe_data_import VALUES (5191, '18/01/2021', '2021-02', '891', '18', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '4.49');
INSERT INTO public.europe_data_import VALUES (5192, '11/01/2021', '2021-01', '1469', '28', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '4.33');
INSERT INTO public.europe_data_import VALUES (5193, '04/01/2021', '2020-53', '810', '21', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '4.38');
INSERT INTO public.europe_data_import VALUES (5194, '28/12/2020', '2020-52', '1492', '25', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '7.8');
INSERT INTO public.europe_data_import VALUES (5195, '21/12/2020', '2020-51', '2608', '52', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '11.64');
INSERT INTO public.europe_data_import VALUES (5196, '14/12/2020', '2020-50', '3512', '61', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '16.31');
INSERT INTO public.europe_data_import VALUES (5197, '07/12/2020', '2020-49', '5064', '74', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '20.94');
INSERT INTO public.europe_data_import VALUES (5198, '30/11/2020', '2020-48', '5944', '72', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '24.86');
INSERT INTO public.europe_data_import VALUES (5199, '23/11/2020', '2020-47', '7127', '111', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '28.31');
INSERT INTO public.europe_data_import VALUES (5200, '16/11/2020', '2020-46', '7757', '158', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '27.33');
INSERT INTO public.europe_data_import VALUES (5201, '09/11/2020', '2020-45', '6611', '98', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '24.28');
INSERT INTO public.europe_data_import VALUES (5202, '02/11/2020', '2020-44', '6156', '111', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '20.92');
INSERT INTO public.europe_data_import VALUES (5203, '26/10/2020', '2020-43', '4840', '70', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '15.55');
INSERT INTO public.europe_data_import VALUES (5204, '19/10/2020', '2020-42', '3335', '66', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '10.37');
INSERT INTO public.europe_data_import VALUES (5205, '12/10/2020', '2020-41', '2119', '35', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '6.53');
INSERT INTO public.europe_data_import VALUES (5206, '05/10/2020', '2020-40', '1312', '40', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '4.65');
INSERT INTO public.europe_data_import VALUES (5207, '28/09/2020', '2020-39', '1134', '43', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.72');
INSERT INTO public.europe_data_import VALUES (5208, '21/09/2020', '2020-38', '824', '26', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.57');
INSERT INTO public.europe_data_import VALUES (5209, '14/09/2020', '2020-37', '1054', '25', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.99');
INSERT INTO public.europe_data_import VALUES (5210, '07/09/2020', '2020-36', '1046', '23', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '5.21');
INSERT INTO public.europe_data_import VALUES (5211, '31/08/2020', '2020-35', '1693', '26', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '7.49');
INSERT INTO public.europe_data_import VALUES (5212, '24/08/2020', '2020-34', '2244', '74', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '11.28');
INSERT INTO public.europe_data_import VALUES (5213, '17/08/2020', '2020-33', '3684', '54', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '15.34');
INSERT INTO public.europe_data_import VALUES (5214, '10/08/2020', '2020-32', '4383', '51', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '16.8');
INSERT INTO public.europe_data_import VALUES (5215, '03/08/2020', '2020-31', '4450', '89', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '16.55');
INSERT INTO public.europe_data_import VALUES (5216, '27/07/2020', '2020-30', '4250', '46', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '14.26');
INSERT INTO public.europe_data_import VALUES (5217, '20/07/2020', '2020-29', '3248', '49', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '10.4');
INSERT INTO public.europe_data_import VALUES (5218, '13/07/2020', '2020-28', '2219', '25', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '7.67');
INSERT INTO public.europe_data_import VALUES (5219, '06/07/2020', '2020-27', '1816', '17', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '5.99');
INSERT INTO public.europe_data_import VALUES (5220, '29/06/2020', '2020-26', '1332', '20', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '4.71');
INSERT INTO public.europe_data_import VALUES (5221, '22/06/2020', '2020-25', '1144', '20', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.75');
INSERT INTO public.europe_data_import VALUES (5222, '15/06/2020', '2020-24', '827', '19', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '3.1');
INSERT INTO public.europe_data_import VALUES (5223, '08/06/2020', '2020-23', '805', '20', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '2.95');
INSERT INTO public.europe_data_import VALUES (5224, '01/06/2020', '2020-22', '748', '13', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '2.04');
INSERT INTO public.europe_data_import VALUES (5225, '25/05/2020', '2020-21', '327', '1', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (5226, '18/05/2020', '2020-20', '215', '18', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.8');
INSERT INTO public.europe_data_import VALUES (5227, '11/05/2020', '2020-19', '207', '8', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (5228, '04/05/2020', '2020-18', '110', '10', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (5229, '27/04/2020', '2020-17', '85', '0', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.3');
INSERT INTO public.europe_data_import VALUES (5230, '20/04/2020', '2020-16', '73', '6', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (5231, '13/04/2020', '2020-15', '55', '4', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.29');
INSERT INTO public.europe_data_import VALUES (5232, '06/04/2020', '2020-14', '100', '3', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (5233, '30/03/2020', '2020-13', '27', '1', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (5234, '23/03/2020', '2020-12', '12', '0', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (5235, '16/03/2020', '2020-11', '3', '0', '52573967', 'Kenya', 'KE', 'KEN', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (5236, '01/02/2021', '2021-04', '2130', '42', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '242.81');
INSERT INTO public.europe_data_import VALUES (5237, '25/01/2021', '2021-03', '2237', '46', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '239.75');
INSERT INTO public.europe_data_import VALUES (5238, '18/01/2021', '2021-02', '2075', '33', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '216.07');
INSERT INTO public.europe_data_import VALUES (5239, '11/01/2021', '2021-01', '1811', '33', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '165.42');
INSERT INTO public.europe_data_import VALUES (5240, '04/01/2021', '2020-53', '1164', '27', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '155.46');
INSERT INTO public.europe_data_import VALUES (5241, '28/12/2020', '2020-52', '1632', '55', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '234.69');
INSERT INTO public.europe_data_import VALUES (5242, '21/12/2020', '2020-51', '2589', '64', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '353.85');
INSERT INTO public.europe_data_import VALUES (5243, '14/12/2020', '2020-50', '3775', '92', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '418.29');
INSERT INTO public.europe_data_import VALUES (5244, '07/12/2020', '2020-49', '3748', '101', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '473.17');
INSERT INTO public.europe_data_import VALUES (5245, '30/11/2020', '2020-48', '4762', '91', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '552.68');
INSERT INTO public.europe_data_import VALUES (5246, '23/11/2020', '2020-47', '5178', '92', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '563.8');
INSERT INTO public.europe_data_import VALUES (5247, '16/11/2020', '2020-46', '4962', '67', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '496.97');
INSERT INTO public.europe_data_import VALUES (5248, '09/11/2020', '2020-45', '3976', '67', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '345.4');
INSERT INTO public.europe_data_import VALUES (5249, '02/11/2020', '2020-44', '2236', '25', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '182.82');
INSERT INTO public.europe_data_import VALUES (5250, '26/10/2020', '2020-43', '1052', '10', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '98.08');
INSERT INTO public.europe_data_import VALUES (5251, '19/10/2020', '2020-42', '712', '6', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '59.88');
INSERT INTO public.europe_data_import VALUES (5252, '12/10/2020', '2020-41', '365', '17', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '39.31');
INSERT INTO public.europe_data_import VALUES (5253, '05/10/2020', '2020-40', '342', '8', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '41.76');
INSERT INTO public.europe_data_import VALUES (5254, '28/09/2020', '2020-39', '409', '9', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '46.43');
INSERT INTO public.europe_data_import VALUES (5255, '21/09/2020', '2020-38', '426', '17', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '52.49');
INSERT INTO public.europe_data_import VALUES (5256, '14/09/2020', '2020-37', '518', '33', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '72.45');
INSERT INTO public.europe_data_import VALUES (5257, '07/09/2020', '2020-36', '785', '47', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '92.91');
INSERT INTO public.europe_data_import VALUES (5258, '31/08/2020', '2020-35', '886', '49', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '106.64');
INSERT INTO public.europe_data_import VALUES (5259, '24/08/2020', '2020-34', '1032', '66', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '122.38');
INSERT INTO public.europe_data_import VALUES (5260, '17/08/2020', '2020-33', '1169', '74', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '145.51');
INSERT INTO public.europe_data_import VALUES (5261, '10/08/2020', '2020-32', '1448', '78', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '185.15');
INSERT INTO public.europe_data_import VALUES (5262, '03/08/2020', '2020-31', '1882', '80', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '170.36');
INSERT INTO public.europe_data_import VALUES (5263, '27/07/2020', '2020-30', '1182', '34', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '110.42');
INSERT INTO public.europe_data_import VALUES (5264, '20/07/2020', '2020-29', '804', '33', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '132.28');
INSERT INTO public.europe_data_import VALUES (5265, '13/07/2020', '2020-28', '1575', '36', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '125.33');
INSERT INTO public.europe_data_import VALUES (5266, '06/07/2020', '2020-27', '679', '17', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '66.0');
INSERT INTO public.europe_data_import VALUES (5267, '29/06/2020', '2020-26', '508', '13', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '66.22');
INSERT INTO public.europe_data_import VALUES (5268, '22/06/2020', '2020-25', '683', '3', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '51.99');
INSERT INTO public.europe_data_import VALUES (5269, '15/06/2020', '2020-24', '252', '2', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '22.41');
INSERT INTO public.europe_data_import VALUES (5270, '08/06/2020', '2020-23', '151', '1', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '11.23');
INSERT INTO public.europe_data_import VALUES (5271, '01/06/2020', '2020-22', '51', '1', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '5.45');
INSERT INTO public.europe_data_import VALUES (5272, '25/05/2020', '2020-21', '47', '0', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '8.23');
INSERT INTO public.europe_data_import VALUES (5273, '18/05/2020', '2020-20', '101', '1', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '7.45');
INSERT INTO public.europe_data_import VALUES (5274, '11/05/2020', '2020-19', '33', '3', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '6.67');
INSERT INTO public.europe_data_import VALUES (5275, '04/05/2020', '2020-18', '87', '5', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '16.12');
INSERT INTO public.europe_data_import VALUES (5276, '27/04/2020', '2020-17', '203', '6', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '22.35');
INSERT INTO public.europe_data_import VALUES (5277, '20/04/2020', '2020-16', '199', '7', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '22.02');
INSERT INTO public.europe_data_import VALUES (5278, '13/04/2020', '2020-15', '197', '6', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '14.68');
INSERT INTO public.europe_data_import VALUES (5279, '06/04/2020', '2020-14', '67', '0', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '7.34');
INSERT INTO public.europe_data_import VALUES (5280, '30/03/2020', '2020-13', '65', '0', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '4.73');
INSERT INTO public.europe_data_import VALUES (5281, '23/03/2020', '2020-12', '20', '1', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '1.83');
INSERT INTO public.europe_data_import VALUES (5282, '16/03/2020', '2020-11', '13', '0', '1798506', 'Kosovo', 'XK', 'XKX', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (5283, '01/02/2021', '2021-04', '3972', '7', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '177.8');
INSERT INTO public.europe_data_import VALUES (5284, '25/01/2021', '2021-03', '3508', '5', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '165.7');
INSERT INTO public.europe_data_import VALUES (5285, '18/01/2021', '2021-02', '3463', '4', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '152.93');
INSERT INTO public.europe_data_import VALUES (5286, '11/01/2021', '2021-01', '2971', '6', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '110.79');
INSERT INTO public.europe_data_import VALUES (5287, '04/01/2021', '2020-53', '1690', '6', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '79.96');
INSERT INTO public.europe_data_import VALUES (5288, '28/12/2020', '2020-52', '1674', '10', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '81.65');
INSERT INTO public.europe_data_import VALUES (5289, '21/12/2020', '2020-51', '1761', '10', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '85.81');
INSERT INTO public.europe_data_import VALUES (5290, '14/12/2020', '2020-50', '1849', '20', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '90.13');
INSERT INTO public.europe_data_import VALUES (5291, '07/12/2020', '2020-49', '1943', '13', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '102.52');
INSERT INTO public.europe_data_import VALUES (5292, '30/11/2020', '2020-48', '2370', '12', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '132.78');
INSERT INTO public.europe_data_import VALUES (5293, '23/11/2020', '2020-47', '3216', '28', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '197.6');
INSERT INTO public.europe_data_import VALUES (5294, '16/11/2020', '2020-46', '5097', '27', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '244.97');
INSERT INTO public.europe_data_import VALUES (5295, '09/11/2020', '2020-45', '5209', '29', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '240.26');
INSERT INTO public.europe_data_import VALUES (5296, '02/11/2020', '2020-44', '4899', '36', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '246.92');
INSERT INTO public.europe_data_import VALUES (5297, '26/10/2020', '2020-43', '5489', '45', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '250.03');
INSERT INTO public.europe_data_import VALUES (5298, '19/10/2020', '2020-42', '5030', '43', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '216.8');
INSERT INTO public.europe_data_import VALUES (5299, '12/10/2020', '2020-41', '4091', '34', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '179.98');
INSERT INTO public.europe_data_import VALUES (5300, '05/10/2020', '2020-40', '3481', '23', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '180.43');
INSERT INTO public.europe_data_import VALUES (5301, '28/09/2020', '2020-39', '4110', '17', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '208.7');
INSERT INTO public.europe_data_import VALUES (5302, '21/09/2020', '2020-38', '4670', '24', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '234.18');
INSERT INTO public.europe_data_import VALUES (5303, '14/09/2020', '2020-37', '5182', '16', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '240.74');
INSERT INTO public.europe_data_import VALUES (5304, '07/09/2020', '2020-36', '4946', '14', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '215.21');
INSERT INTO public.europe_data_import VALUES (5305, '31/08/2020', '2020-35', '4108', '15', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '200.4');
INSERT INTO public.europe_data_import VALUES (5306, '24/08/2020', '2020-34', '4323', '14', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '209.53');
INSERT INTO public.europe_data_import VALUES (5307, '17/08/2020', '2020-33', '4492', '23', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '197.14');
INSERT INTO public.europe_data_import VALUES (5308, '10/08/2020', '2020-32', '3802', '21', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '188.73');
INSERT INTO public.europe_data_import VALUES (5309, '03/08/2020', '2020-31', '4138', '24', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '206.96');
INSERT INTO public.europe_data_import VALUES (5310, '27/07/2020', '2020-30', '4569', '25', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '211.05');
INSERT INTO public.europe_data_import VALUES (5311, '20/07/2020', '2020-29', '4310', '18', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '220.18');
INSERT INTO public.europe_data_import VALUES (5312, '13/07/2020', '2020-28', '4953', '22', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '236.55');
INSERT INTO public.europe_data_import VALUES (5313, '06/07/2020', '2020-27', '4999', '20', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '244.61');
INSERT INTO public.europe_data_import VALUES (5314, '29/06/2020', '2020-26', '5292', '22', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '214.45');
INSERT INTO public.europe_data_import VALUES (5315, '22/06/2020', '2020-25', '3730', '30', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '185.45');
INSERT INTO public.europe_data_import VALUES (5316, '15/06/2020', '2020-24', '4072', '32', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '211.0');
INSERT INTO public.europe_data_import VALUES (5317, '08/06/2020', '2020-23', '4805', '52', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '250.67');
INSERT INTO public.europe_data_import VALUES (5318, '01/06/2020', '2020-22', '5741', '56', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '289.82');
INSERT INTO public.europe_data_import VALUES (5319, '25/05/2020', '2020-21', '6452', '44', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '299.83');
INSERT INTO public.europe_data_import VALUES (5320, '18/05/2020', '2020-20', '6162', '54', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '234.53');
INSERT INTO public.europe_data_import VALUES (5321, '11/05/2020', '2020-19', '3705', '20', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '133.42');
INSERT INTO public.europe_data_import VALUES (5322, '04/05/2020', '2020-18', '1908', '18', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '72.92');
INSERT INTO public.europe_data_import VALUES (5323, '27/04/2020', '2020-17', '1160', '13', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '43.76');
INSERT INTO public.europe_data_import VALUES (5324, '20/04/2020', '2020-16', '681', '6', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '32.3');
INSERT INTO public.europe_data_import VALUES (5325, '13/04/2020', '2020-15', '678', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '23.27');
INSERT INTO public.europe_data_import VALUES (5326, '06/04/2020', '2020-14', '301', '1', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '8.75');
INSERT INTO public.europe_data_import VALUES (5327, '30/03/2020', '2020-13', '67', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '3.4');
INSERT INTO public.europe_data_import VALUES (5328, '23/03/2020', '2020-12', '76', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '2.95');
INSERT INTO public.europe_data_import VALUES (5329, '16/03/2020', '2020-11', '48', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '1.57');
INSERT INTO public.europe_data_import VALUES (5330, '09/03/2020', '2020-10', '18', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '1.45');
INSERT INTO public.europe_data_import VALUES (5331, '02/03/2020', '2020-09', '43', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '1.09');
INSERT INTO public.europe_data_import VALUES (5332, '24/02/2020', '2020-08', '3', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (5333, '17/02/2020', '2020-07', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5334, '10/02/2020', '2020-06', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5335, '03/02/2020', '2020-05', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5336, '27/01/2020', '2020-04', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5337, '20/01/2020', '2020-03', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5338, '13/01/2020', '2020-02', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5339, '06/01/2020', '2020-01', '0', '0', '4207077', 'Kuwait', 'KW', 'KWT', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5340, '01/02/2021', '2021-04', '617', '11', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '21.98');
INSERT INTO public.europe_data_import VALUES (5341, '25/01/2021', '2021-03', '793', '14', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '24.8');
INSERT INTO public.europe_data_import VALUES (5342, '18/01/2021', '2021-02', '798', '16', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '27.9');
INSERT INTO public.europe_data_import VALUES (5343, '11/01/2021', '2021-01', '992', '11', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '28.76');
INSERT INTO public.europe_data_import VALUES (5344, '04/01/2021', '2020-53', '853', '11', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '33.26');
INSERT INTO public.europe_data_import VALUES (5345, '28/12/2020', '2020-52', '1281', '18', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '44.59');
INSERT INTO public.europe_data_import VALUES (5346, '21/12/2020', '2020-51', '1580', '19', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '60.15');
INSERT INTO public.europe_data_import VALUES (5347, '14/12/2020', '2020-50', '2279', '15', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '75.86');
INSERT INTO public.europe_data_import VALUES (5348, '07/12/2020', '2020-49', '2588', '26', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '85.88');
INSERT INTO public.europe_data_import VALUES (5349, '30/11/2020', '2020-48', '2922', '34', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '90.78');
INSERT INTO public.europe_data_import VALUES (5350, '23/11/2020', '2020-47', '2902', '34', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '101.23');
INSERT INTO public.europe_data_import VALUES (5351, '16/11/2020', '2020-46', '3593', '21', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '110.73');
INSERT INTO public.europe_data_import VALUES (5352, '09/11/2020', '2020-45', '3511', '27', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '112.53');
INSERT INTO public.europe_data_import VALUES (5353, '02/11/2020', '2020-44', '3709', '21', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '114.61');
INSERT INTO public.europe_data_import VALUES (5354, '26/10/2020', '2020-43', '3644', '23', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '108.17');
INSERT INTO public.europe_data_import VALUES (5355, '19/10/2020', '2020-42', '3296', '26', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '76.23');
INSERT INTO public.europe_data_import VALUES (5356, '12/10/2020', '2020-41', '1595', '19', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '44.81');
INSERT INTO public.europe_data_import VALUES (5357, '05/10/2020', '2020-40', '1280', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '33.73');
INSERT INTO public.europe_data_import VALUES (5358, '28/09/2020', '2020-39', '884', '1', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '22.24');
INSERT INTO public.europe_data_import VALUES (5359, '21/09/2020', '2020-38', '543', '0', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '15.9');
INSERT INTO public.europe_data_import VALUES (5360, '14/09/2020', '2020-37', '477', '3', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '16.05');
INSERT INTO public.europe_data_import VALUES (5361, '07/09/2020', '2020-36', '553', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '20.65');
INSERT INTO public.europe_data_import VALUES (5362, '31/08/2020', '2020-35', '772', '1', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '29.72');
INSERT INTO public.europe_data_import VALUES (5363, '24/08/2020', '2020-34', '1135', '-439', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '45.96');
INSERT INTO public.europe_data_import VALUES (5364, '17/08/2020', '2020-33', '1814', '22', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '75.78');
INSERT INTO public.europe_data_import VALUES (5365, '10/08/2020', '2020-32', '3048', '54', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '107.25');
INSERT INTO public.europe_data_import VALUES (5366, '03/08/2020', '2020-31', '3833', '119', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '155.65');
INSERT INTO public.europe_data_import VALUES (5367, '27/07/2020', '2020-30', '6153', '264', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '345.69');
INSERT INTO public.europe_data_import VALUES (5368, '20/07/2020', '2020-29', '16026', '890', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '303.19');
INSERT INTO public.europe_data_import VALUES (5369, '13/07/2020', '2020-28', '3426', '55', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '95.08');
INSERT INTO public.europe_data_import VALUES (5370, '06/07/2020', '2020-27', '2674', '42', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '67.57');
INSERT INTO public.europe_data_import VALUES (5371, '29/06/2020', '2020-26', '1661', '10', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '41.23');
INSERT INTO public.europe_data_import VALUES (5372, '22/06/2020', '2020-25', '984', '13', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '20.64');
INSERT INTO public.europe_data_import VALUES (5373, '15/06/2020', '2020-24', '340', '4', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '8.65');
INSERT INTO public.europe_data_import VALUES (5374, '08/06/2020', '2020-23', '215', '7', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '9.34');
INSERT INTO public.europe_data_import VALUES (5375, '01/06/2020', '2020-22', '384', '0', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '9.37');
INSERT INTO public.europe_data_import VALUES (5376, '25/05/2020', '2020-21', '217', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '6.5');
INSERT INTO public.europe_data_import VALUES (5377, '18/05/2020', '2020-20', '200', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '6.02');
INSERT INTO public.europe_data_import VALUES (5378, '11/05/2020', '2020-19', '186', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '5.0');
INSERT INTO public.europe_data_import VALUES (5379, '04/05/2020', '2020-18', '135', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '4.08');
INSERT INTO public.europe_data_import VALUES (5380, '27/04/2020', '2020-17', '127', '1', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '4.3');
INSERT INTO public.europe_data_import VALUES (5381, '20/04/2020', '2020-16', '149', '2', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '5.49');
INSERT INTO public.europe_data_import VALUES (5382, '13/04/2020', '2020-15', '203', '1', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '5.22');
INSERT INTO public.europe_data_import VALUES (5383, '06/04/2020', '2020-14', '132', '4', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '3.15');
INSERT INTO public.europe_data_import VALUES (5384, '30/03/2020', '2020-13', '70', '0', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '1.31');
INSERT INTO public.europe_data_import VALUES (5385, '23/03/2020', '2020-12', '14', '0', '6415851', 'Kyrgyzstan', 'KG', 'KGZ', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5386, '01/02/2021', '2021-04', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (5387, '25/01/2021', '2021-03', '3', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (5388, '18/01/2021', '2021-02', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5389, '11/01/2021', '2021-01', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5390, '04/01/2021', '2020-53', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5391, '28/12/2020', '2020-52', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5392, '21/12/2020', '2020-51', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5393, '14/12/2020', '2020-50', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (5394, '07/12/2020', '2020-49', '2', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.24');
INSERT INTO public.europe_data_import VALUES (5395, '30/11/2020', '2020-48', '15', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.21');
INSERT INTO public.europe_data_import VALUES (5396, '23/11/2020', '2020-47', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5397, '16/11/2020', '2020-46', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5398, '09/11/2020', '2020-45', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5399, '02/11/2020', '2020-44', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5400, '26/10/2020', '2020-43', '1', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5401, '19/10/2020', '2020-42', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5402, '12/10/2020', '2020-41', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5403, '05/10/2020', '2020-40', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5404, '28/09/2020', '2020-39', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5405, '21/09/2020', '2020-38', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5406, '14/09/2020', '2020-37', '1', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5407, '07/09/2020', '2020-36', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5408, '31/08/2020', '2020-35', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (5409, '24/08/2020', '2020-34', '2', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (5410, '17/08/2020', '2020-33', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5411, '10/08/2020', '2020-32', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5412, '03/08/2020', '2020-31', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5413, '27/07/2020', '2020-30', '1', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5414, '20/07/2020', '2020-29', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5415, '13/07/2020', '2020-28', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5416, '06/07/2020', '2020-27', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5417, '29/06/2020', '2020-26', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5418, '22/06/2020', '2020-25', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5419, '15/06/2020', '2020-24', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5420, '08/06/2020', '2020-23', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5421, '01/06/2020', '2020-22', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5422, '25/05/2020', '2020-21', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5423, '18/05/2020', '2020-20', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5424, '11/05/2020', '2020-19', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5425, '04/05/2020', '2020-18', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5426, '27/04/2020', '2020-17', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5427, '20/04/2020', '2020-16', '0', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (5428, '13/04/2020', '2020-15', '8', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.18');
INSERT INTO public.europe_data_import VALUES (5429, '06/04/2020', '2020-14', '5', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (5430, '30/03/2020', '2020-13', '6', '0', '7169456', 'Laos', 'LA', 'LAO', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5431, '01/02/2021', '2021-04', '5233', '84', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '550.89');
INSERT INTO public.europe_data_import VALUES (5432, '25/01/2021', '2021-03', '5344', '133', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '595.84');
INSERT INTO public.europe_data_import VALUES (5433, '18/01/2021', '2021-02', '6096', '129', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '685.79');
INSERT INTO public.europe_data_import VALUES (5434, '11/01/2021', '2021-01', '7071', '169', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '689.49');
INSERT INTO public.europe_data_import VALUES (5435, '04/01/2021', '2020-53', '6167', '121', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '601.94');
INSERT INTO public.europe_data_import VALUES (5436, '28/12/2020', '2020-52', '5390', '120', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '554.96');
INSERT INTO public.europe_data_import VALUES (5437, '21/12/2020', '2020-51', '5265', '90', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '501.41');
INSERT INTO public.europe_data_import VALUES (5438, '14/12/2020', '2020-50', '4362', '87', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '453.13');
INSERT INTO public.europe_data_import VALUES (5439, '07/12/2020', '2020-49', '4338', '65', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '426.73');
INSERT INTO public.europe_data_import VALUES (5440, '30/11/2020', '2020-48', '3855', '44', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '334.8');
INSERT INTO public.europe_data_import VALUES (5441, '23/11/2020', '2020-47', '2573', '30', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '261.72');
INSERT INTO public.europe_data_import VALUES (5442, '16/11/2020', '2020-46', '2452', '24', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '229.74');
INSERT INTO public.europe_data_import VALUES (5443, '09/11/2020', '2020-45', '1959', '25', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '177.97');
INSERT INTO public.europe_data_import VALUES (5444, '02/11/2020', '2020-44', '1458', '18', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '139.9');
INSERT INTO public.europe_data_import VALUES (5445, '26/10/2020', '2020-43', '1228', '14', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '104.59');
INSERT INTO public.europe_data_import VALUES (5446, '19/10/2020', '2020-42', '780', '2', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '71.04');
INSERT INTO public.europe_data_import VALUES (5447, '12/10/2020', '2020-41', '584', '2', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '51.77');
INSERT INTO public.europe_data_import VALUES (5448, '05/10/2020', '2020-40', '410', '2', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '29.22');
INSERT INTO public.europe_data_import VALUES (5449, '28/09/2020', '2020-39', '151', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '10.52');
INSERT INTO public.europe_data_import VALUES (5450, '21/09/2020', '2020-38', '51', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '5.05');
INSERT INTO public.europe_data_import VALUES (5451, '14/09/2020', '2020-37', '46', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '4.22');
INSERT INTO public.europe_data_import VALUES (5452, '07/09/2020', '2020-36', '35', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '4.74');
INSERT INTO public.europe_data_import VALUES (5453, '31/08/2020', '2020-35', '56', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '3.7');
INSERT INTO public.europe_data_import VALUES (5454, '24/08/2020', '2020-34', '15', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '2.45');
INSERT INTO public.europe_data_import VALUES (5455, '17/08/2020', '2020-33', '32', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '4.11');
INSERT INTO public.europe_data_import VALUES (5456, '10/08/2020', '2020-32', '47', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '3.7');
INSERT INTO public.europe_data_import VALUES (5457, '03/08/2020', '2020-31', '24', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '2.66');
INSERT INTO public.europe_data_import VALUES (5458, '27/07/2020', '2020-30', '27', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '2.4');
INSERT INTO public.europe_data_import VALUES (5459, '20/07/2020', '2020-29', '19', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '3.54');
INSERT INTO public.europe_data_import VALUES (5460, '13/07/2020', '2020-28', '49', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '2.97');
INSERT INTO public.europe_data_import VALUES (5461, '06/07/2020', '2020-27', '8', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '0.68');
INSERT INTO public.europe_data_import VALUES (5462, '29/06/2020', '2020-26', '5', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '0.99');
INSERT INTO public.europe_data_import VALUES (5463, '22/06/2020', '2020-25', '14', '2', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '1.2');
INSERT INTO public.europe_data_import VALUES (5464, '15/06/2020', '2020-24', '9', '3', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '1.61');
INSERT INTO public.europe_data_import VALUES (5465, '08/06/2020', '2020-23', '22', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '2.14');
INSERT INTO public.europe_data_import VALUES (5466, '01/06/2020', '2020-22', '19', '2', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (5467, '25/05/2020', '2020-21', '39', '3', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '5.63');
INSERT INTO public.europe_data_import VALUES (5468, '18/05/2020', '2020-20', '69', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '6.72');
INSERT INTO public.europe_data_import VALUES (5469, '11/05/2020', '2020-19', '60', '2', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '6.61');
INSERT INTO public.europe_data_import VALUES (5470, '04/05/2020', '2020-18', '67', '4', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '7.92');
INSERT INTO public.europe_data_import VALUES (5471, '27/04/2020', '2020-17', '85', '7', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '8.39');
INSERT INTO public.europe_data_import VALUES (5472, '20/04/2020', '2020-16', '76', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '10.1');
INSERT INTO public.europe_data_import VALUES (5473, '13/04/2020', '2020-15', '118', '4', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '14.32');
INSERT INTO public.europe_data_import VALUES (5474, '06/04/2020', '2020-14', '157', '1', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '20.52');
INSERT INTO public.europe_data_import VALUES (5475, '30/03/2020', '2020-13', '237', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '17.97');
INSERT INTO public.europe_data_import VALUES (5476, '23/03/2020', '2020-12', '108', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '7.08');
INSERT INTO public.europe_data_import VALUES (5477, '16/03/2020', '2020-11', '28', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '1.61');
INSERT INTO public.europe_data_import VALUES (5478, '09/03/2020', '2020-10', '3', '0', '1919968', 'Latvia', 'LV', 'LVA', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (5479, '01/02/2021', '2021-04', '21455', '762', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '703.65');
INSERT INTO public.europe_data_import VALUES (5480, '25/01/2021', '2021-03', '26785', '455', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '879.57');
INSERT INTO public.europe_data_import VALUES (5481, '18/01/2021', '2021-02', '33516', '259', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '926.73');
INSERT INTO public.europe_data_import VALUES (5482, '11/01/2021', '2021-01', '30018', '107', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '701.17');
INSERT INTO public.europe_data_import VALUES (5483, '04/01/2021', '2020-53', '18052', '105', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '454.72');
INSERT INTO public.europe_data_import VALUES (5484, '28/12/2020', '2020-52', '13122', '113', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '360.37');
INSERT INTO public.europe_data_import VALUES (5485, '21/12/2020', '2020-51', '11584', '81', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '305.6');
INSERT INTO public.europe_data_import VALUES (5486, '14/12/2020', '2020-50', '9367', '101', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '285.54');
INSERT INTO public.europe_data_import VALUES (5487, '07/12/2020', '2020-49', '10209', '95', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '301.6');
INSERT INTO public.europe_data_import VALUES (5488, '30/11/2020', '2020-48', '10468', '104', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '313.81');
INSERT INTO public.europe_data_import VALUES (5489, '23/11/2020', '2020-47', '11046', '83', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '324.4');
INSERT INTO public.europe_data_import VALUES (5490, '16/11/2020', '2020-46', '11194', '94', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '332.76');
INSERT INTO public.europe_data_import VALUES (5491, '09/11/2020', '2020-45', '11619', '80', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '333.24');
INSERT INTO public.europe_data_import VALUES (5492, '02/11/2020', '2020-44', '11227', '78', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '296.56');
INSERT INTO public.europe_data_import VALUES (5493, '26/10/2020', '2020-43', '9104', '45', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '274.69');
INSERT INTO public.europe_data_import VALUES (5494, '19/10/2020', '2020-42', '9728', '65', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '259.7');
INSERT INTO public.europe_data_import VALUES (5495, '12/10/2020', '2020-41', '8076', '49', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '237.82');
INSERT INTO public.europe_data_import VALUES (5496, '05/10/2020', '2020-40', '8228', '59', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '221.41');
INSERT INTO public.europe_data_import VALUES (5497, '28/09/2020', '2020-39', '6951', '50', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '174.22');
INSERT INTO public.europe_data_import VALUES (5498, '21/09/2020', '2020-38', '4993', '56', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '129.48');
INSERT INTO public.europe_data_import VALUES (5499, '14/09/2020', '2020-37', '3884', '50', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '108.52');
INSERT INTO public.europe_data_import VALUES (5500, '07/09/2020', '2020-36', '3556', '31', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '120.12');
INSERT INTO public.europe_data_import VALUES (5501, '31/08/2020', '2020-35', '4679', '39', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '116.53');
INSERT INTO public.europe_data_import VALUES (5502, '24/08/2020', '2020-34', '3310', '18', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '82.76');
INSERT INTO public.europe_data_import VALUES (5503, '17/08/2020', '2020-33', '2364', '27', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '58.29');
INSERT INTO public.europe_data_import VALUES (5504, '10/08/2020', '2020-32', '1632', '14', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '40.36');
INSERT INTO public.europe_data_import VALUES (5505, '03/08/2020', '2020-31', '1135', '11', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '29.55');
INSERT INTO public.europe_data_import VALUES (5506, '27/07/2020', '2020-30', '891', '11', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '20.65');
INSERT INTO public.europe_data_import VALUES (5507, '20/07/2020', '2020-29', '525', '4', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '14.38');
INSERT INTO public.europe_data_import VALUES (5508, '13/07/2020', '2020-28', '461', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '8.66');
INSERT INTO public.europe_data_import VALUES (5509, '06/07/2020', '2020-27', '133', '2', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '4.17');
INSERT INTO public.europe_data_import VALUES (5510, '29/06/2020', '2020-26', '153', '2', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '4.29');
INSERT INTO public.europe_data_import VALUES (5511, '22/06/2020', '2020-25', '141', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '3.73');
INSERT INTO public.europe_data_import VALUES (5512, '15/06/2020', '2020-24', '115', '2', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '3.3');
INSERT INTO public.europe_data_import VALUES (5513, '08/06/2020', '2020-23', '111', '3', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '3.17');
INSERT INTO public.europe_data_import VALUES (5514, '01/06/2020', '2020-22', '106', '1', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '4.51');
INSERT INTO public.europe_data_import VALUES (5515, '25/05/2020', '2020-21', '203', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '3.92');
INSERT INTO public.europe_data_import VALUES (5516, '18/05/2020', '2020-20', '66', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '2.54');
INSERT INTO public.europe_data_import VALUES (5517, '11/05/2020', '2020-19', '108', '1', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '2.01');
INSERT INTO public.europe_data_import VALUES (5518, '04/05/2020', '2020-18', '30', '1', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0.93');
INSERT INTO public.europe_data_import VALUES (5519, '27/04/2020', '2020-17', '34', '3', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '1.12');
INSERT INTO public.europe_data_import VALUES (5520, '20/04/2020', '2020-16', '43', '1', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '2.13');
INSERT INTO public.europe_data_import VALUES (5521, '13/04/2020', '2020-15', '103', '2', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '2.8');
INSERT INTO public.europe_data_import VALUES (5522, '06/04/2020', '2020-14', '89', '8', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '4.07');
INSERT INTO public.europe_data_import VALUES (5523, '30/03/2020', '2020-13', '190', '6', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '4.94');
INSERT INTO public.europe_data_import VALUES (5524, '23/03/2020', '2020-12', '149', '1', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '3.15');
INSERT INTO public.europe_data_import VALUES (5525, '16/03/2020', '2020-11', '67', '3', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '1.3');
INSERT INTO public.europe_data_import VALUES (5526, '09/03/2020', '2020-10', '22', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0.45');
INSERT INTO public.europe_data_import VALUES (5527, '02/03/2020', '2020-09', '9', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (5528, '24/02/2020', '2020-08', '1', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5529, '17/02/2020', '2020-07', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5530, '10/02/2020', '2020-06', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5531, '03/02/2020', '2020-05', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5532, '27/01/2020', '2020-04', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5533, '20/01/2020', '2020-03', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5534, '13/01/2020', '2020-02', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5535, '06/01/2020', '2020-01', '0', '0', '6855709', 'Lebanon', 'LB', 'LBN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5536, '01/02/2021', '2021-04', '622', '37', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '89.73');
INSERT INTO public.europe_data_import VALUES (5537, '25/01/2021', '2021-03', '1285', '30', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '80.88');
INSERT INTO public.europe_data_import VALUES (5538, '18/01/2021', '2021-02', '434', '8', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '148.92');
INSERT INTO public.europe_data_import VALUES (5539, '11/01/2021', '2021-01', '2731', '20', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '140.26');
INSERT INTO public.europe_data_import VALUES (5540, '04/01/2021', '2020-53', '250', '14', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '31.05');
INSERT INTO public.europe_data_import VALUES (5541, '28/12/2020', '2020-52', '410', '3', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '31.57');
INSERT INTO public.europe_data_import VALUES (5542, '21/12/2020', '2020-51', '261', '4', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '18.63');
INSERT INTO public.europe_data_import VALUES (5543, '14/12/2020', '2020-50', '135', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '8.28');
INSERT INTO public.europe_data_import VALUES (5544, '07/12/2020', '2020-49', '41', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '3.06');
INSERT INTO public.europe_data_import VALUES (5545, '30/11/2020', '2020-48', '24', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '3.2');
INSERT INTO public.europe_data_import VALUES (5546, '23/11/2020', '2020-47', '44', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '5.55');
INSERT INTO public.europe_data_import VALUES (5547, '16/11/2020', '2020-46', '74', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '4.42');
INSERT INTO public.europe_data_import VALUES (5548, '09/11/2020', '2020-45', '20', '1', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '1.27');
INSERT INTO public.europe_data_import VALUES (5549, '02/11/2020', '2020-44', '7', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '5.36');
INSERT INTO public.europe_data_import VALUES (5550, '26/10/2020', '2020-43', '107', '1', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '6.35');
INSERT INTO public.europe_data_import VALUES (5551, '19/10/2020', '2020-42', '28', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '7.2');
INSERT INTO public.europe_data_import VALUES (5552, '12/10/2020', '2020-41', '125', '3', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '11.62');
INSERT INTO public.europe_data_import VALUES (5553, '05/10/2020', '2020-40', '122', '4', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '12.05');
INSERT INTO public.europe_data_import VALUES (5554, '28/09/2020', '2020-39', '134', '2', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '14.73');
INSERT INTO public.europe_data_import VALUES (5555, '21/09/2020', '2020-38', '179', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '12.99');
INSERT INTO public.europe_data_import VALUES (5556, '14/09/2020', '2020-37', '97', '2', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '8.42');
INSERT INTO public.europe_data_import VALUES (5557, '07/09/2020', '2020-36', '82', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '6.26');
INSERT INTO public.europe_data_import VALUES (5558, '31/08/2020', '2020-35', '51', '1', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '5.65');
INSERT INTO public.europe_data_import VALUES (5559, '24/08/2020', '2020-34', '69', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '12.85');
INSERT INTO public.europe_data_import VALUES (5560, '17/08/2020', '2020-33', '204', '7', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '10.73');
INSERT INTO public.europe_data_import VALUES (5561, '10/08/2020', '2020-32', '24', '4', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '13.93');
INSERT INTO public.europe_data_import VALUES (5562, '03/08/2020', '2020-31', '272', '8', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '16.89');
INSERT INTO public.europe_data_import VALUES (5563, '27/07/2020', '2020-30', '87', '5', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '10.02');
INSERT INTO public.europe_data_import VALUES (5564, '20/07/2020', '2020-29', '126', '4', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '13.17');
INSERT INTO public.europe_data_import VALUES (5565, '13/07/2020', '2020-28', '154', '2', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '9.69');
INSERT INTO public.europe_data_import VALUES (5566, '06/07/2020', '2020-27', '52', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '3.53');
INSERT INTO public.europe_data_import VALUES (5567, '29/06/2020', '2020-26', '23', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '1.08');
INSERT INTO public.europe_data_import VALUES (5568, '22/06/2020', '2020-25', '0', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (5569, '15/06/2020', '2020-24', '0', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (5570, '08/06/2020', '2020-23', '2', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (5571, '01/06/2020', '2020-22', '0', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (5572, '25/05/2020', '2020-21', '1', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (5573, '18/05/2020', '2020-20', '1', '0', '2125267', 'Lesotho', 'LS', 'LSO', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (5574, '01/02/2021', '2021-04', '25', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.05');
INSERT INTO public.europe_data_import VALUES (5575, '25/01/2021', '2021-03', '27', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '2.31');
INSERT INTO public.europe_data_import VALUES (5576, '18/01/2021', '2021-02', '87', '1', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.76');
INSERT INTO public.europe_data_import VALUES (5577, '11/01/2021', '2021-01', '0', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (5578, '04/01/2021', '2020-53', '0', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (5579, '28/12/2020', '2020-52', '12', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.59');
INSERT INTO public.europe_data_import VALUES (5580, '21/12/2020', '2020-51', '17', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '2.27');
INSERT INTO public.europe_data_import VALUES (5581, '14/12/2020', '2020-50', '95', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '3.56');
INSERT INTO public.europe_data_import VALUES (5582, '07/12/2020', '2020-49', '81', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '2.53');
INSERT INTO public.europe_data_import VALUES (5583, '30/11/2020', '2020-48', '44', '1', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.78');
INSERT INTO public.europe_data_import VALUES (5584, '23/11/2020', '2020-47', '44', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '2.21');
INSERT INTO public.europe_data_import VALUES (5585, '16/11/2020', '2020-46', '65', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.64');
INSERT INTO public.europe_data_import VALUES (5586, '09/11/2020', '2020-45', '16', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.99');
INSERT INTO public.europe_data_import VALUES (5587, '02/11/2020', '2020-44', '33', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.99');
INSERT INTO public.europe_data_import VALUES (5588, '26/10/2020', '2020-43', '16', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.61');
INSERT INTO public.europe_data_import VALUES (5589, '19/10/2020', '2020-42', '14', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.59');
INSERT INTO public.europe_data_import VALUES (5590, '12/10/2020', '2020-41', '15', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.49');
INSERT INTO public.europe_data_import VALUES (5591, '05/10/2020', '2020-40', '9', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (5592, '28/09/2020', '2020-39', '4', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (5593, '21/09/2020', '2020-38', '16', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.57');
INSERT INTO public.europe_data_import VALUES (5594, '14/09/2020', '2020-37', '12', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.3');
INSERT INTO public.europe_data_import VALUES (5595, '07/09/2020', '2020-36', '3', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.43');
INSERT INTO public.europe_data_import VALUES (5596, '31/08/2020', '2020-35', '18', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (5597, '24/08/2020', '2020-34', '29', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.99');
INSERT INTO public.europe_data_import VALUES (5598, '17/08/2020', '2020-33', '20', '3', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.01');
INSERT INTO public.europe_data_import VALUES (5599, '10/08/2020', '2020-32', '30', '2', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.52');
INSERT INTO public.europe_data_import VALUES (5600, '03/08/2020', '2020-31', '45', '5', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '2.35');
INSERT INTO public.europe_data_import VALUES (5601, '27/07/2020', '2020-30', '71', '2', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '3.08');
INSERT INTO public.europe_data_import VALUES (5602, '20/07/2020', '2020-29', '81', '19', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '4.4');
INSERT INTO public.europe_data_import VALUES (5603, '13/07/2020', '2020-28', '136', '14', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '4.9');
INSERT INTO public.europe_data_import VALUES (5604, '06/07/2020', '2020-27', '106', '3', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '5.02');
INSERT INTO public.europe_data_import VALUES (5605, '29/06/2020', '2020-26', '142', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '6.28');
INSERT INTO public.europe_data_import VALUES (5606, '22/06/2020', '2020-25', '168', '2', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '5.41');
INSERT INTO public.europe_data_import VALUES (5607, '15/06/2020', '2020-24', '99', '2', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '3.44');
INSERT INTO public.europe_data_import VALUES (5608, '08/06/2020', '2020-23', '71', '3', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.9');
INSERT INTO public.europe_data_import VALUES (5609, '01/06/2020', '2020-22', '23', '1', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.26');
INSERT INTO public.europe_data_import VALUES (5610, '25/05/2020', '2020-21', '39', '5', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.34');
INSERT INTO public.europe_data_import VALUES (5611, '18/05/2020', '2020-20', '27', '1', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.38');
INSERT INTO public.europe_data_import VALUES (5612, '11/05/2020', '2020-19', '41', '2', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.52');
INSERT INTO public.europe_data_import VALUES (5613, '04/05/2020', '2020-18', '34', '6', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (5614, '27/04/2020', '2020-17', '33', '4', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.5');
INSERT INTO public.europe_data_import VALUES (5615, '20/04/2020', '2020-16', '41', '3', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '1.58');
INSERT INTO public.europe_data_import VALUES (5616, '13/04/2020', '2020-15', '37', '2', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (5617, '06/04/2020', '2020-14', '10', '3', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (5618, '30/03/2020', '2020-13', '0', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (5619, '23/03/2020', '2020-12', '3', '0', '4937374', 'Liberia', 'LR', 'LBR', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (5620, '01/02/2021', '2021-04', '4103', '94', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '140.66');
INSERT INTO public.europe_data_import VALUES (5621, '25/01/2021', '2021-03', '5430', '91', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '146.38');
INSERT INTO public.europe_data_import VALUES (5622, '18/01/2021', '2021-02', '4491', '109', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '116.47');
INSERT INTO public.europe_data_import VALUES (5623, '11/01/2021', '2021-01', '3403', '63', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '103.24');
INSERT INTO public.europe_data_import VALUES (5624, '04/01/2021', '2020-53', '3594', '90', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '99.96');
INSERT INTO public.europe_data_import VALUES (5625, '28/12/2020', '2020-52', '3181', '67', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '112.17');
INSERT INTO public.europe_data_import VALUES (5626, '21/12/2020', '2020-51', '4421', '70', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '127.19');
INSERT INTO public.europe_data_import VALUES (5627, '14/12/2020', '2020-50', '4199', '68', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '123.19');
INSERT INTO public.europe_data_import VALUES (5628, '07/12/2020', '2020-49', '4150', '65', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '129.21');
INSERT INTO public.europe_data_import VALUES (5629, '30/11/2020', '2020-48', '4607', '77', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '130.26');
INSERT INTO public.europe_data_import VALUES (5630, '23/11/2020', '2020-47', '4221', '72', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '143.21');
INSERT INTO public.europe_data_import VALUES (5631, '16/11/2020', '2020-46', '5485', '88', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '170.52');
INSERT INTO public.europe_data_import VALUES (5632, '09/11/2020', '2020-45', '6072', '58', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '178.59');
INSERT INTO public.europe_data_import VALUES (5633, '02/11/2020', '2020-44', '6032', '76', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '195.57');
INSERT INTO public.europe_data_import VALUES (5634, '26/10/2020', '2020-43', '7223', '70', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '196.25');
INSERT INTO public.europe_data_import VALUES (5635, '19/10/2020', '2020-42', '6078', '94', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '176.78');
INSERT INTO public.europe_data_import VALUES (5636, '12/10/2020', '2020-41', '5903', '39', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '152.68');
INSERT INTO public.europe_data_import VALUES (5637, '05/10/2020', '2020-40', '4445', '72', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '130.73');
INSERT INTO public.europe_data_import VALUES (5638, '28/09/2020', '2020-39', '4415', '82', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '141.4');
INSERT INTO public.europe_data_import VALUES (5639, '21/09/2020', '2020-38', '5168', '76', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '150.5');
INSERT INTO public.europe_data_import VALUES (5640, '14/09/2020', '2020-37', '5032', '77', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '138.08');
INSERT INTO public.europe_data_import VALUES (5641, '07/09/2020', '2020-36', '4326', '53', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '107.89');
INSERT INTO public.europe_data_import VALUES (5642, '31/08/2020', '2020-35', '2986', '44', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '83.88');
INSERT INTO public.europe_data_import VALUES (5643, '24/08/2020', '2020-34', '2699', '43', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '76.8');
INSERT INTO public.europe_data_import VALUES (5644, '17/08/2020', '2020-33', '2506', '32', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '59.71');
INSERT INTO public.europe_data_import VALUES (5645, '10/08/2020', '2020-32', '1541', '33', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '39.62');
INSERT INTO public.europe_data_import VALUES (5646, '03/08/2020', '2020-31', '1144', '22', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '26.93');
INSERT INTO public.europe_data_import VALUES (5647, '27/07/2020', '2020-30', '681', '10', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '16.44');
INSERT INTO public.europe_data_import VALUES (5648, '20/07/2020', '2020-29', '433', '9', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '12.94');
INSERT INTO public.europe_data_import VALUES (5649, '13/07/2020', '2020-28', '444', '12', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '9.9');
INSERT INTO public.europe_data_import VALUES (5650, '06/07/2020', '2020-27', '227', '6', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '6.57');
INSERT INTO public.europe_data_import VALUES (5651, '29/06/2020', '2020-26', '218', '11', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '5.08');
INSERT INTO public.europe_data_import VALUES (5652, '22/06/2020', '2020-25', '126', '2', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '4.25');
INSERT INTO public.europe_data_import VALUES (5653, '15/06/2020', '2020-24', '162', '3', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '3.87');
INSERT INTO public.europe_data_import VALUES (5654, '08/06/2020', '2020-23', '100', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '2.67');
INSERT INTO public.europe_data_import VALUES (5655, '01/06/2020', '2020-22', '81', '2', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '1.34');
INSERT INTO public.europe_data_import VALUES (5656, '25/05/2020', '2020-21', '10', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (5657, '18/05/2020', '2020-20', '1', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (5658, '11/05/2020', '2020-19', '1', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (5659, '04/05/2020', '2020-18', '2', '1', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.21');
INSERT INTO public.europe_data_import VALUES (5660, '27/04/2020', '2020-17', '12', '1', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (5661, '20/04/2020', '2020-16', '24', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.46');
INSERT INTO public.europe_data_import VALUES (5662, '13/04/2020', '2020-15', '7', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.25');
INSERT INTO public.europe_data_import VALUES (5663, '06/04/2020', '2020-14', '10', '1', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (5664, '30/03/2020', '2020-13', '8', '0', '6777453', 'Libya', 'LY', 'LBY', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (5665, '01/02/2021', '2021-04', '43', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '265.78');
INSERT INTO public.europe_data_import VALUES (5666, '25/01/2021', '2021-03', '59', '2', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '281.41');
INSERT INTO public.europe_data_import VALUES (5667, '18/01/2021', '2021-02', '49', '1', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '450.78');
INSERT INTO public.europe_data_import VALUES (5668, '11/01/2021', '2021-01', '124', '14', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '661.84');
INSERT INTO public.europe_data_import VALUES (5669, '04/01/2021', '2020-53', '130', '8', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '1024.02');
INSERT INTO public.europe_data_import VALUES (5670, '28/12/2020', '2020-52', '263', '3', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '1506.07');
INSERT INTO public.europe_data_import VALUES (5671, '21/12/2020', '2020-51', '315', '6', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '1128.25');
INSERT INTO public.europe_data_import VALUES (5672, '14/12/2020', '2020-50', '118', '2', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '627.96');
INSERT INTO public.europe_data_import VALUES (5673, '07/12/2020', '2020-49', '123', '1', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '740.01');
INSERT INTO public.europe_data_import VALUES (5674, '30/11/2020', '2020-48', '161', '7', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '750.43');
INSERT INTO public.europe_data_import VALUES (5675, '23/11/2020', '2020-47', '127', '4', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '844.23');
INSERT INTO public.europe_data_import VALUES (5676, '16/11/2020', '2020-46', '197', '1', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '1130.86');
INSERT INTO public.europe_data_import VALUES (5677, '09/11/2020', '2020-45', '237', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '1102.19');
INSERT INTO public.europe_data_import VALUES (5678, '02/11/2020', '2020-44', '186', '2', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '852.05');
INSERT INTO public.europe_data_import VALUES (5679, '26/10/2020', '2020-43', '141', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '591.48');
INSERT INTO public.europe_data_import VALUES (5680, '19/10/2020', '2020-42', '86', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '255.35');
INSERT INTO public.europe_data_import VALUES (5681, '12/10/2020', '2020-41', '12', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '54.72');
INSERT INTO public.europe_data_import VALUES (5682, '05/10/2020', '2020-40', '9', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '36.48');
INSERT INTO public.europe_data_import VALUES (5683, '28/09/2020', '2020-39', '5', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '15.63');
INSERT INTO public.europe_data_import VALUES (5684, '21/09/2020', '2020-38', '1', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '10.42');
INSERT INTO public.europe_data_import VALUES (5685, '14/09/2020', '2020-37', '3', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '7.82');
INSERT INTO public.europe_data_import VALUES (5686, '07/09/2020', '2020-36', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '18.24');
INSERT INTO public.europe_data_import VALUES (5687, '31/08/2020', '2020-35', '7', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '39.08');
INSERT INTO public.europe_data_import VALUES (5688, '24/08/2020', '2020-34', '8', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '31.27');
INSERT INTO public.europe_data_import VALUES (5689, '17/08/2020', '2020-33', '4', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '10.42');
INSERT INTO public.europe_data_import VALUES (5690, '10/08/2020', '2020-32', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '5.21');
INSERT INTO public.europe_data_import VALUES (5691, '03/08/2020', '2020-31', '2', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '5.21');
INSERT INTO public.europe_data_import VALUES (5692, '27/07/2020', '2020-30', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '5.21');
INSERT INTO public.europe_data_import VALUES (5693, '20/07/2020', '2020-29', '2', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '7.82');
INSERT INTO public.europe_data_import VALUES (5694, '13/07/2020', '2020-28', '1', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '5.21');
INSERT INTO public.europe_data_import VALUES (5695, '06/07/2020', '2020-27', '1', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '2.61');
INSERT INTO public.europe_data_import VALUES (5696, '29/06/2020', '2020-26', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5697, '22/06/2020', '2020-25', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5698, '15/06/2020', '2020-24', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5699, '08/06/2020', '2020-23', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5700, '01/06/2020', '2020-22', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5701, '25/05/2020', '2020-21', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5702, '18/05/2020', '2020-20', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5703, '11/05/2020', '2020-19', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5704, '04/05/2020', '2020-18', '0', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '2.61');
INSERT INTO public.europe_data_import VALUES (5705, '27/04/2020', '2020-17', '1', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '7.82');
INSERT INTO public.europe_data_import VALUES (5706, '20/04/2020', '2020-16', '2', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '10.42');
INSERT INTO public.europe_data_import VALUES (5707, '13/04/2020', '2020-15', '2', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '46.9');
INSERT INTO public.europe_data_import VALUES (5708, '06/04/2020', '2020-14', '16', '1', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '83.38');
INSERT INTO public.europe_data_import VALUES (5709, '30/03/2020', '2020-13', '16', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '143.31');
INSERT INTO public.europe_data_import VALUES (5710, '23/03/2020', '2020-12', '39', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '119.86');
INSERT INTO public.europe_data_import VALUES (5711, '16/03/2020', '2020-11', '7', '0', '38378', 'Liechtenstein', 'LI', 'LIE', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (5712, '01/02/2021', '2021-04', '5727', '161', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '533.29');
INSERT INTO public.europe_data_import VALUES (5713, '25/01/2021', '2021-03', '9174', '195', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '598.39');
INSERT INTO public.europe_data_import VALUES (5714, '18/01/2021', '2021-02', '7546', '237', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '715.95');
INSERT INTO public.europe_data_import VALUES (5715, '11/01/2021', '2021-01', '12459', '282', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1004.84');
INSERT INTO public.europe_data_import VALUES (5716, '04/01/2021', '2020-53', '15618', '681', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1198.92');
INSERT INTO public.europe_data_import VALUES (5717, '28/12/2020', '2020-52', '17882', '230', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1336.63');
INSERT INTO public.europe_data_import VALUES (5718, '21/12/2020', '2020-51', '19466', '214', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1376.11');
INSERT INTO public.europe_data_import VALUES (5719, '14/12/2020', '2020-50', '18985', '188', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1205.93');
INSERT INTO public.europe_data_import VALUES (5720, '07/12/2020', '2020-49', '14711', '131', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1037.48');
INSERT INTO public.europe_data_import VALUES (5721, '30/11/2020', '2020-48', '14278', '120', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '950.8');
INSERT INTO public.europe_data_import VALUES (5722, '23/11/2020', '2020-47', '12289', '109', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '799.8');
INSERT INTO public.europe_data_import VALUES (5723, '16/11/2020', '2020-46', '10059', '70', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '681.38');
INSERT INTO public.europe_data_import VALUES (5724, '09/11/2020', '2020-45', '8980', '41', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '519.47');
INSERT INTO public.europe_data_import VALUES (5725, '02/11/2020', '2020-44', '5535', '32', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '293.4');
INSERT INTO public.europe_data_import VALUES (5726, '26/10/2020', '2020-43', '2663', '21', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '145.37');
INSERT INTO public.europe_data_import VALUES (5727, '19/10/2020', '2020-42', '1399', '10', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '83.6');
INSERT INTO public.europe_data_import VALUES (5728, '12/10/2020', '2020-41', '937', '9', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '62.16');
INSERT INTO public.europe_data_import VALUES (5729, '05/10/2020', '2020-40', '800', '3', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '51.57');
INSERT INTO public.europe_data_import VALUES (5730, '28/09/2020', '2020-39', '641', '4', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '37.58');
INSERT INTO public.europe_data_import VALUES (5731, '21/09/2020', '2020-38', '409', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '23.66');
INSERT INTO public.europe_data_import VALUES (5732, '14/09/2020', '2020-37', '252', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '16.5');
INSERT INTO public.europe_data_import VALUES (5733, '07/09/2020', '2020-36', '209', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '16.03');
INSERT INTO public.europe_data_import VALUES (5734, '31/08/2020', '2020-35', '239', '2', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '16.39');
INSERT INTO public.europe_data_import VALUES (5735, '24/08/2020', '2020-34', '219', '3', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '13.71');
INSERT INTO public.europe_data_import VALUES (5736, '17/08/2020', '2020-33', '164', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '10.95');
INSERT INTO public.europe_data_import VALUES (5737, '10/08/2020', '2020-32', '142', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '8.73');
INSERT INTO public.europe_data_import VALUES (5738, '03/08/2020', '2020-31', '102', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '6.37');
INSERT INTO public.europe_data_import VALUES (5739, '27/07/2020', '2020-30', '76', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '4.97');
INSERT INTO public.europe_data_import VALUES (5740, '20/07/2020', '2020-29', '63', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '3.44');
INSERT INTO public.europe_data_import VALUES (5741, '13/07/2020', '2020-28', '33', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1.9');
INSERT INTO public.europe_data_import VALUES (5742, '06/07/2020', '2020-27', '20', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1.36');
INSERT INTO public.europe_data_import VALUES (5743, '29/06/2020', '2020-26', '18', '2', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1.72');
INSERT INTO public.europe_data_import VALUES (5744, '22/06/2020', '2020-25', '30', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '3.01');
INSERT INTO public.europe_data_import VALUES (5745, '15/06/2020', '2020-24', '54', '4', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '3.33');
INSERT INTO public.europe_data_import VALUES (5746, '08/06/2020', '2020-23', '39', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '3.26');
INSERT INTO public.europe_data_import VALUES (5747, '01/06/2020', '2020-22', '52', '7', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '4.8');
INSERT INTO public.europe_data_import VALUES (5748, '25/05/2020', '2020-21', '82', '7', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '5.15');
INSERT INTO public.europe_data_import VALUES (5749, '18/05/2020', '2020-20', '62', '6', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '4.69');
INSERT INTO public.europe_data_import VALUES (5750, '11/05/2020', '2020-19', '69', '4', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '1.47');
INSERT INTO public.europe_data_import VALUES (5751, '04/05/2020', '2020-18', '-28', '5', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '3.01');
INSERT INTO public.europe_data_import VALUES (5752, '27/04/2020', '2020-17', '112', '5', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '13.46');
INSERT INTO public.europe_data_import VALUES (5753, '20/04/2020', '2020-16', '264', '12', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '18.43');
INSERT INTO public.europe_data_import VALUES (5754, '13/04/2020', '2020-15', '251', '11', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '20.69');
INSERT INTO public.europe_data_import VALUES (5755, '06/04/2020', '2020-14', '327', '6', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '23.91');
INSERT INTO public.europe_data_import VALUES (5756, '30/03/2020', '2020-13', '341', '6', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '16.82');
INSERT INTO public.europe_data_import VALUES (5757, '23/03/2020', '2020-12', '129', '1', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '5.08');
INSERT INTO public.europe_data_import VALUES (5758, '16/03/2020', '2020-11', '13', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0.47');
INSERT INTO public.europe_data_import VALUES (5759, '09/03/2020', '2020-10', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0.04');
INSERT INTO public.europe_data_import VALUES (5760, '02/03/2020', '2020-09', '1', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0.04');
INSERT INTO public.europe_data_import VALUES (5761, '24/02/2020', '2020-08', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5762, '17/02/2020', '2020-07', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5763, '10/02/2020', '2020-06', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5764, '03/02/2020', '2020-05', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5765, '27/01/2020', '2020-04', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5766, '20/01/2020', '2020-03', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5767, '13/01/2020', '2020-02', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5768, '06/01/2020', '2020-01', '0', '0', '2794184', 'Lithuania', 'LT', 'LTU', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (5769, '01/02/2021', '2021-04', '965', '16', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '295.98');
INSERT INTO public.europe_data_import VALUES (5770, '25/01/2021', '2021-03', '852', '12', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '280.18');
INSERT INTO public.europe_data_import VALUES (5771, '18/01/2021', '2021-02', '868', '19', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '314.88');
INSERT INTO public.europe_data_import VALUES (5772, '11/01/2021', '2021-01', '1065', '27', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '347.78');
INSERT INTO public.europe_data_import VALUES (5773, '04/01/2021', '2020-53', '1070', '19', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '464.58');
INSERT INTO public.europe_data_import VALUES (5774, '28/12/2020', '2020-52', '1782', '47', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '745.57');
INSERT INTO public.europe_data_import VALUES (5775, '21/12/2020', '2020-51', '2795', '44', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1039.76');
INSERT INTO public.europe_data_import VALUES (5776, '14/12/2020', '2020-50', '3588', '46', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1188.97');
INSERT INTO public.europe_data_import VALUES (5777, '07/12/2020', '2020-49', '3711', '44', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1197.44');
INSERT INTO public.europe_data_import VALUES (5778, '30/11/2020', '2020-48', '3640', '44', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1210.14');
INSERT INTO public.europe_data_import VALUES (5779, '23/11/2020', '2020-47', '3789', '40', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1279.05');
INSERT INTO public.europe_data_import VALUES (5780, '16/11/2020', '2020-46', '4063', '37', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1264.39');
INSERT INTO public.europe_data_import VALUES (5781, '09/11/2020', '2020-45', '3699', '25', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1348.28');
INSERT INTO public.europe_data_import VALUES (5782, '02/11/2020', '2020-44', '4578', '15', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '1325.31');
INSERT INTO public.europe_data_import VALUES (5783, '26/10/2020', '2020-43', '3558', '12', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '789.06');
INSERT INTO public.europe_data_import VALUES (5784, '19/10/2020', '2020-42', '1286', '3', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '315.53');
INSERT INTO public.europe_data_import VALUES (5785, '12/10/2020', '2020-41', '651', '5', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '163.38');
INSERT INTO public.europe_data_import VALUES (5786, '05/10/2020', '2020-40', '352', '1', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '147.42');
INSERT INTO public.europe_data_import VALUES (5787, '28/09/2020', '2020-39', '553', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '189.45');
INSERT INTO public.europe_data_import VALUES (5788, '21/09/2020', '2020-38', '610', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '147.91');
INSERT INTO public.europe_data_import VALUES (5789, '14/09/2020', '2020-37', '298', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '92.69');
INSERT INTO public.europe_data_import VALUES (5790, '07/09/2020', '2020-36', '271', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '-131.62');
INSERT INTO public.europe_data_import VALUES (5791, '31/08/2020', '2020-35', '-1079', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '-132.6');
INSERT INTO public.europe_data_import VALUES (5792, '24/08/2020', '2020-34', '265', '1', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '96.27');
INSERT INTO public.europe_data_import VALUES (5793, '17/08/2020', '2020-33', '326', '4', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '121.19');
INSERT INTO public.europe_data_import VALUES (5794, '10/08/2020', '2020-32', '418', '2', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '136.99');
INSERT INTO public.europe_data_import VALUES (5795, '03/08/2020', '2020-31', '423', '5', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '197.43');
INSERT INTO public.europe_data_import VALUES (5796, '27/07/2020', '2020-30', '789', '1', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '219.42');
INSERT INTO public.europe_data_import VALUES (5797, '20/07/2020', '2020-29', '558', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '156.54');
INSERT INTO public.europe_data_import VALUES (5798, '13/07/2020', '2020-28', '403', '1', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '111.26');
INSERT INTO public.europe_data_import VALUES (5799, '06/07/2020', '2020-27', '280', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '65.48');
INSERT INTO public.europe_data_import VALUES (5800, '29/06/2020', '2020-26', '122', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '28.02');
INSERT INTO public.europe_data_import VALUES (5801, '22/06/2020', '2020-25', '50', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '13.19');
INSERT INTO public.europe_data_import VALUES (5802, '15/06/2020', '2020-24', '31', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '8.47');
INSERT INTO public.europe_data_import VALUES (5803, '08/06/2020', '2020-23', '21', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '7.66');
INSERT INTO public.europe_data_import VALUES (5804, '01/06/2020', '2020-22', '26', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '11.89');
INSERT INTO public.europe_data_import VALUES (5805, '25/05/2020', '2020-21', '47', '3', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '17.27');
INSERT INTO public.europe_data_import VALUES (5806, '18/05/2020', '2020-20', '59', '6', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '19.71');
INSERT INTO public.europe_data_import VALUES (5807, '11/05/2020', '2020-19', '62', '5', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '26.55');
INSERT INTO public.europe_data_import VALUES (5808, '04/05/2020', '2020-18', '101', '8', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '44.63');
INSERT INTO public.europe_data_import VALUES (5809, '27/04/2020', '2020-17', '173', '15', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '72.0');
INSERT INTO public.europe_data_import VALUES (5810, '20/04/2020', '2020-16', '269', '7', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '121.52');
INSERT INTO public.europe_data_import VALUES (5811, '13/04/2020', '2020-15', '477', '30', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '216.81');
INSERT INTO public.europe_data_import VALUES (5812, '06/04/2020', '2020-14', '854', '15', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '326.77');
INSERT INTO public.europe_data_import VALUES (5813, '30/03/2020', '2020-13', '1152', '13', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '305.1');
INSERT INTO public.europe_data_import VALUES (5814, '23/03/2020', '2020-12', '721', '7', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '129.18');
INSERT INTO public.europe_data_import VALUES (5815, '16/03/2020', '2020-11', '72', '1', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '12.38');
INSERT INTO public.europe_data_import VALUES (5816, '09/03/2020', '2020-10', '4', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0.81');
INSERT INTO public.europe_data_import VALUES (5817, '02/03/2020', '2020-09', '1', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0.16');
INSERT INTO public.europe_data_import VALUES (5818, '24/02/2020', '2020-08', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5819, '17/02/2020', '2020-07', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5820, '10/02/2020', '2020-06', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5821, '03/02/2020', '2020-05', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5822, '27/01/2020', '2020-04', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5823, '20/01/2020', '2020-03', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5824, '13/01/2020', '2020-02', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (5825, '06/01/2020', '2020-01', '0', '0', '613894', 'Luxembourg', 'LU', 'LUX', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (5826, '01/02/2021', '2021-04', '322', '2', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '2.83');
INSERT INTO public.europe_data_import VALUES (5827, '25/01/2021', '2021-03', '442', '6', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '2.75');
INSERT INTO public.europe_data_import VALUES (5828, '18/01/2021', '2021-02', '300', '6', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.98');
INSERT INTO public.europe_data_import VALUES (5829, '11/01/2021', '2021-01', '234', '5', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.06');
INSERT INTO public.europe_data_import VALUES (5830, '04/01/2021', '2020-53', '53', '1', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (5831, '28/12/2020', '2020-52', '81', '1', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.3');
INSERT INTO public.europe_data_import VALUES (5832, '21/12/2020', '2020-51', '0', '2', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (5833, '14/12/2020', '2020-50', '120', '3', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.08');
INSERT INTO public.europe_data_import VALUES (5834, '07/12/2020', '2020-49', '172', '4', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.64');
INSERT INTO public.europe_data_import VALUES (5835, '30/11/2020', '2020-48', '0', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (5836, '23/11/2020', '2020-47', '108', '2', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (5837, '16/11/2020', '2020-46', '10', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.45');
INSERT INTO public.europe_data_import VALUES (5838, '09/11/2020', '2020-45', '112', '5', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (5839, '02/11/2020', '2020-44', '143', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.12');
INSERT INTO public.europe_data_import VALUES (5840, '26/10/2020', '2020-43', '158', '6', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.93');
INSERT INTO public.europe_data_import VALUES (5841, '19/10/2020', '2020-42', '92', '1', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.93');
INSERT INTO public.europe_data_import VALUES (5842, '12/10/2020', '2020-41', '160', '5', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.61');
INSERT INTO public.europe_data_import VALUES (5843, '05/10/2020', '2020-40', '273', '3', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.87');
INSERT INTO public.europe_data_import VALUES (5844, '28/09/2020', '2020-39', '232', '6', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.96');
INSERT INTO public.europe_data_import VALUES (5845, '21/09/2020', '2020-38', '296', '12', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '2.72');
INSERT INTO public.europe_data_import VALUES (5846, '14/09/2020', '2020-37', '438', '11', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '3.39');
INSERT INTO public.europe_data_import VALUES (5847, '07/09/2020', '2020-36', '476', '9', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '3.68');
INSERT INTO public.europe_data_import VALUES (5848, '31/08/2020', '2020-35', '516', '13', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '3.77');
INSERT INTO public.europe_data_import VALUES (5849, '24/08/2020', '2020-34', '500', '8', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '4.6');
INSERT INTO public.europe_data_import VALUES (5850, '17/08/2020', '2020-33', '741', '22', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '8.52');
INSERT INTO public.europe_data_import VALUES (5851, '10/08/2020', '2020-32', '1558', '34', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '14.06');
INSERT INTO public.europe_data_import VALUES (5852, '03/08/2020', '2020-31', '2233', '29', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '16.61');
INSERT INTO public.europe_data_import VALUES (5853, '27/07/2020', '2020-30', '2246', '26', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '16.42');
INSERT INTO public.europe_data_import VALUES (5854, '20/07/2020', '2020-29', '2182', '24', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '16.02');
INSERT INTO public.europe_data_import VALUES (5855, '13/07/2020', '2020-28', '2139', '6', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '10.34');
INSERT INTO public.europe_data_import VALUES (5856, '06/07/2020', '2020-27', '650', '11', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '4.2');
INSERT INTO public.europe_data_import VALUES (5857, '29/06/2020', '2020-26', '482', '4', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '2.99');
INSERT INTO public.europe_data_import VALUES (5858, '22/06/2020', '2020-25', '324', '4', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '2.02');
INSERT INTO public.europe_data_import VALUES (5859, '15/06/2020', '2020-24', '220', '1', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.86');
INSERT INTO public.europe_data_import VALUES (5860, '08/06/2020', '2020-23', '281', '3', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.95');
INSERT INTO public.europe_data_import VALUES (5861, '01/06/2020', '2020-22', '244', '4', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.73');
INSERT INTO public.europe_data_import VALUES (5862, '25/05/2020', '2020-21', '223', '1', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '1.32');
INSERT INTO public.europe_data_import VALUES (5863, '18/05/2020', '2020-20', '133', '1', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.57');
INSERT INTO public.europe_data_import VALUES (5864, '11/05/2020', '2020-19', '22', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (5865, '04/05/2020', '2020-18', '25', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (5866, '27/04/2020', '2020-17', '3', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (5867, '20/04/2020', '2020-16', '15', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (5868, '13/04/2020', '2020-15', '34', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (5869, '06/04/2020', '2020-14', '35', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (5870, '30/03/2020', '2020-13', '34', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (5871, '23/03/2020', '2020-12', '3', '0', '26969306', 'Madagascar', 'MG', 'MDG', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (5872, '01/02/2021', '2021-04', '4378', '194', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '63.85');
INSERT INTO public.europe_data_import VALUES (5873, '25/01/2021', '2021-03', '7517', '204', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '61.26');
INSERT INTO public.europe_data_import VALUES (5874, '18/01/2021', '2021-02', '3895', '89', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '30.2');
INSERT INTO public.europe_data_import VALUES (5875, '11/01/2021', '2021-01', '1731', '30', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '11.8');
INSERT INTO public.europe_data_import VALUES (5876, '04/01/2021', '2020-53', '467', '7', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '3.67');
INSERT INTO public.europe_data_import VALUES (5877, '28/12/2020', '2020-52', '216', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '1.67');
INSERT INTO public.europe_data_import VALUES (5878, '21/12/2020', '2020-51', '95', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.59');
INSERT INTO public.europe_data_import VALUES (5879, '14/12/2020', '2020-50', '15', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.22');
INSERT INTO public.europe_data_import VALUES (5880, '07/12/2020', '2020-49', '26', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (5881, '30/11/2020', '2020-48', '22', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (5882, '23/11/2020', '2020-47', '38', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (5883, '16/11/2020', '2020-46', '14', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (5884, '09/11/2020', '2020-45', '19', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.33');
INSERT INTO public.europe_data_import VALUES (5885, '02/11/2020', '2020-44', '42', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (5886, '26/10/2020', '2020-43', '33', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (5887, '19/10/2020', '2020-42', '36', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.38');
INSERT INTO public.europe_data_import VALUES (5888, '12/10/2020', '2020-41', '35', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (5889, '05/10/2020', '2020-40', '18', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.3');
INSERT INTO public.europe_data_import VALUES (5890, '28/09/2020', '2020-39', '37', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (5891, '21/09/2020', '2020-38', '41', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.63');
INSERT INTO public.europe_data_import VALUES (5892, '14/09/2020', '2020-37', '76', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.83');
INSERT INTO public.europe_data_import VALUES (5893, '07/09/2020', '2020-36', '78', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '1.57');
INSERT INTO public.europe_data_import VALUES (5894, '31/08/2020', '2020-35', '214', '8', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '2.49');
INSERT INTO public.europe_data_import VALUES (5895, '24/08/2020', '2020-34', '250', '5', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '3.56');
INSERT INTO public.europe_data_import VALUES (5896, '17/08/2020', '2020-33', '414', '15', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '4.51');
INSERT INTO public.europe_data_import VALUES (5897, '10/08/2020', '2020-32', '427', '23', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '5.46');
INSERT INTO public.europe_data_import VALUES (5898, '03/08/2020', '2020-31', '591', '24', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '6.65');
INSERT INTO public.europe_data_import VALUES (5899, '27/07/2020', '2020-30', '648', '37', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '6.85');
INSERT INTO public.europe_data_import VALUES (5900, '20/07/2020', '2020-29', '628', '24', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '6.71');
INSERT INTO public.europe_data_import VALUES (5901, '13/07/2020', '2020-28', '622', '19', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '6.54');
INSERT INTO public.europe_data_import VALUES (5902, '06/07/2020', '2020-27', '596', '6', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '5.43');
INSERT INTO public.europe_data_import VALUES (5903, '29/06/2020', '2020-26', '416', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '3.22');
INSERT INTO public.europe_data_import VALUES (5904, '22/06/2020', '2020-25', '183', '5', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '1.57');
INSERT INTO public.europe_data_import VALUES (5905, '15/06/2020', '2020-24', '109', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (5906, '08/06/2020', '2020-23', '154', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '1.91');
INSERT INTO public.europe_data_import VALUES (5907, '01/06/2020', '2020-22', '201', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '1.15');
INSERT INTO public.europe_data_import VALUES (5908, '25/05/2020', '2020-21', '13', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (5909, '18/05/2020', '2020-20', '14', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (5910, '11/05/2020', '2020-19', '17', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (5911, '04/05/2020', '2020-18', '5', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (5912, '27/04/2020', '2020-17', '17', '1', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (5913, '20/04/2020', '2020-16', '4', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (5914, '13/04/2020', '2020-15', '9', '2', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (5915, '06/04/2020', '2020-14', '4', '0', '18628749', 'Malawi', 'MW', 'MWI', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (5916, '01/02/2021', '2021-04', '31158', '82', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '176.92');
INSERT INTO public.europe_data_import VALUES (5917, '25/01/2021', '2021-03', '25367', '77', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '149.64');
INSERT INTO public.europe_data_import VALUES (5918, '18/01/2021', '2021-02', '22442', '50', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '117.73');
INSERT INTO public.europe_data_import VALUES (5919, '11/01/2021', '2021-01', '15174', '50', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '96.7');
INSERT INTO public.europe_data_import VALUES (5920, '04/01/2021', '2020-53', '15722', '49', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '86.1');
INSERT INTO public.europe_data_import VALUES (5921, '28/12/2020', '2020-52', '11787', '15', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '67.67');
INSERT INTO public.europe_data_import VALUES (5922, '21/12/2020', '2020-51', '9834', '22', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '64.52');
INSERT INTO public.europe_data_import VALUES (5923, '14/12/2020', '2020-50', '10781', '33', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '59.44');
INSERT INTO public.europe_data_import VALUES (5924, '07/12/2020', '2020-49', '8209', '25', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '56.08');
INSERT INTO public.europe_data_import VALUES (5925, '30/11/2020', '2020-48', '9710', '22', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '53.42');
INSERT INTO public.europe_data_import VALUES (5926, '23/11/2020', '2020-47', '7358', '26', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '45.59');
INSERT INTO public.europe_data_import VALUES (5927, '16/11/2020', '2020-46', '7208', '23', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '46.67');
INSERT INTO public.europe_data_import VALUES (5928, '09/11/2020', '2020-45', '7704', '37', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '42.7');
INSERT INTO public.europe_data_import VALUES (5929, '02/11/2020', '2020-44', '5940', '20', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '37.58');
INSERT INTO public.europe_data_import VALUES (5930, '26/10/2020', '2020-43', '6067', '42', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '34.14');
INSERT INTO public.europe_data_import VALUES (5931, '19/10/2020', '2020-42', '4841', '30', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '25.41');
INSERT INTO public.europe_data_import VALUES (5932, '12/10/2020', '2020-41', '3276', '20', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '14.83');
INSERT INTO public.europe_data_import VALUES (5933, '05/10/2020', '2020-40', '1462', '3', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '6.77');
INSERT INTO public.europe_data_import VALUES (5934, '28/09/2020', '2020-39', '700', '4', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '3.14');
INSERT INTO public.europe_data_import VALUES (5935, '21/09/2020', '2020-38', '304', '2', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '2.57');
INSERT INTO public.europe_data_import VALUES (5936, '14/09/2020', '2020-37', '518', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '1.82');
INSERT INTO public.europe_data_import VALUES (5937, '07/09/2020', '2020-36', '63', '2', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.41');
INSERT INTO public.europe_data_import VALUES (5938, '31/08/2020', '2020-35', '67', '1', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.42');
INSERT INTO public.europe_data_import VALUES (5939, '24/08/2020', '2020-34', '67', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.58');
INSERT INTO public.europe_data_import VALUES (5940, '17/08/2020', '2020-33', '117', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.63');
INSERT INTO public.europe_data_import VALUES (5941, '10/08/2020', '2020-32', '84', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.58');
INSERT INTO public.europe_data_import VALUES (5942, '03/08/2020', '2020-31', '102', '1', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (5943, '27/07/2020', '2020-30', '118', '1', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.56');
INSERT INTO public.europe_data_import VALUES (5944, '20/07/2020', '2020-29', '61', '1', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.38');
INSERT INTO public.europe_data_import VALUES (5945, '13/07/2020', '2020-28', '60', '1', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (5946, '06/07/2020', '2020-27', '24', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.27');
INSERT INTO public.europe_data_import VALUES (5947, '29/06/2020', '2020-26', '62', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.57');
INSERT INTO public.europe_data_import VALUES (5948, '22/06/2020', '2020-25', '119', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.78');
INSERT INTO public.europe_data_import VALUES (5949, '15/06/2020', '2020-24', '131', '4', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '1.98');
INSERT INTO public.europe_data_import VALUES (5950, '08/06/2020', '2020-23', '503', '2', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '3.37');
INSERT INTO public.europe_data_import VALUES (5951, '01/06/2020', '2020-22', '574', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '2.9');
INSERT INTO public.europe_data_import VALUES (5952, '25/05/2020', '2020-21', '351', '2', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '1.84');
INSERT INTO public.europe_data_import VALUES (5953, '18/05/2020', '2020-20', '238', '5', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '1.87');
INSERT INTO public.europe_data_import VALUES (5954, '11/05/2020', '2020-19', '358', '3', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '2.74');
INSERT INTO public.europe_data_import VALUES (5955, '04/05/2020', '2020-18', '518', '7', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '2.85');
INSERT INTO public.europe_data_import VALUES (5956, '27/04/2020', '2020-17', '391', '9', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '3.43');
INSERT INTO public.europe_data_import VALUES (5957, '20/04/2020', '2020-16', '706', '13', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '5.41');
INSERT INTO public.europe_data_import VALUES (5958, '13/04/2020', '2020-15', '1021', '15', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '6.93');
INSERT INTO public.europe_data_import VALUES (5959, '06/04/2020', '2020-14', '1192', '27', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '7.37');
INSERT INTO public.europe_data_import VALUES (5960, '30/03/2020', '2020-13', '1164', '24', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '6.39');
INSERT INTO public.europe_data_import VALUES (5961, '23/03/2020', '2020-12', '878', '10', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '3.78');
INSERT INTO public.europe_data_import VALUES (5962, '16/03/2020', '2020-11', '329', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '1.25');
INSERT INTO public.europe_data_import VALUES (5963, '09/03/2020', '2020-10', '70', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.24');
INSERT INTO public.europe_data_import VALUES (5964, '02/03/2020', '2020-09', '7', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (5965, '24/02/2020', '2020-08', '0', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5966, '17/02/2020', '2020-07', '4', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (5967, '10/02/2020', '2020-06', '10', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (5968, '03/02/2020', '2020-05', '4', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (5969, '27/01/2020', '2020-04', '4', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (5970, '20/01/2020', '2020-03', '0', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5971, '13/01/2020', '2020-02', '0', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (5972, '06/01/2020', '2020-01', '0', '0', '31949789', 'Malaysia', 'MY', 'MYS', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (5973, '01/02/2021', '2021-04', '848', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '250.11');
INSERT INTO public.europe_data_import VALUES (5974, '25/01/2021', '2021-03', '480', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '166.49');
INSERT INTO public.europe_data_import VALUES (5975, '18/01/2021', '2021-02', '404', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '121.67');
INSERT INTO public.europe_data_import VALUES (5976, '11/01/2021', '2021-01', '242', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '87.58');
INSERT INTO public.europe_data_import VALUES (5977, '04/01/2021', '2020-53', '223', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '70.44');
INSERT INTO public.europe_data_import VALUES (5978, '28/12/2020', '2020-52', '151', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '51.98');
INSERT INTO public.europe_data_import VALUES (5979, '21/12/2020', '2020-51', '125', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '55.56');
INSERT INTO public.europe_data_import VALUES (5980, '14/12/2020', '2020-50', '170', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '70.44');
INSERT INTO public.europe_data_import VALUES (5981, '07/12/2020', '2020-49', '204', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '111.12');
INSERT INTO public.europe_data_import VALUES (5982, '30/11/2020', '2020-48', '386', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '148.79');
INSERT INTO public.europe_data_import VALUES (5983, '23/11/2020', '2020-47', '404', '3', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '117.15');
INSERT INTO public.europe_data_import VALUES (5984, '16/11/2020', '2020-46', '218', '3', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '94.73');
INSERT INTO public.europe_data_import VALUES (5985, '09/11/2020', '2020-45', '285', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '90.59');
INSERT INTO public.europe_data_import VALUES (5986, '02/11/2020', '2020-44', '196', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '92.47');
INSERT INTO public.europe_data_import VALUES (5987, '26/10/2020', '2020-43', '295', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '115.08');
INSERT INTO public.europe_data_import VALUES (5988, '19/10/2020', '2020-42', '316', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '128.07');
INSERT INTO public.europe_data_import VALUES (5989, '12/10/2020', '2020-41', '364', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '149.92');
INSERT INTO public.europe_data_import VALUES (5990, '05/10/2020', '2020-40', '432', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '151.8');
INSERT INTO public.europe_data_import VALUES (5991, '28/09/2020', '2020-39', '374', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '174.21');
INSERT INTO public.europe_data_import VALUES (5992, '21/09/2020', '2020-38', '551', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '214.71');
INSERT INTO public.europe_data_import VALUES (5993, '14/09/2020', '2020-37', '589', '3', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '283.64');
INSERT INTO public.europe_data_import VALUES (5994, '07/09/2020', '2020-36', '917', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '339.95');
INSERT INTO public.europe_data_import VALUES (5995, '31/08/2020', '2020-35', '888', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '354.45');
INSERT INTO public.europe_data_import VALUES (5996, '24/08/2020', '2020-34', '994', '4', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '327.33');
INSERT INTO public.europe_data_import VALUES (5997, '17/08/2020', '2020-33', '744', '3', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '305.3');
INSERT INTO public.europe_data_import VALUES (5998, '10/08/2020', '2020-32', '877', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '327.52');
INSERT INTO public.europe_data_import VALUES (5999, '03/08/2020', '2020-31', '862', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '225.63');
INSERT INTO public.europe_data_import VALUES (6000, '27/07/2020', '2020-30', '336', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '107.54');
INSERT INTO public.europe_data_import VALUES (6001, '20/07/2020', '2020-29', '235', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '93.79');
INSERT INTO public.europe_data_import VALUES (6002, '13/07/2020', '2020-28', '263', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '76.84');
INSERT INTO public.europe_data_import VALUES (6003, '06/07/2020', '2020-27', '145', '3', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '49.91');
INSERT INTO public.europe_data_import VALUES (6004, '29/06/2020', '2020-26', '120', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '54.24');
INSERT INTO public.europe_data_import VALUES (6005, '22/06/2020', '2020-25', '168', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '56.5');
INSERT INTO public.europe_data_import VALUES (6006, '15/06/2020', '2020-24', '132', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '49.34');
INSERT INTO public.europe_data_import VALUES (6007, '08/06/2020', '2020-23', '130', '3', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '100.2');
INSERT INTO public.europe_data_import VALUES (6008, '01/06/2020', '2020-22', '402', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '127.88');
INSERT INTO public.europe_data_import VALUES (6009, '25/05/2020', '2020-21', '277', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '100.95');
INSERT INTO public.europe_data_import VALUES (6010, '18/05/2020', '2020-20', '259', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '106.79');
INSERT INTO public.europe_data_import VALUES (6011, '11/05/2020', '2020-19', '308', '2', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '116.96');
INSERT INTO public.europe_data_import VALUES (6012, '04/05/2020', '2020-18', '313', '1', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '89.46');
INSERT INTO public.europe_data_import VALUES (6013, '27/04/2020', '2020-17', '162', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '36.54');
INSERT INTO public.europe_data_import VALUES (6014, '20/04/2020', '2020-16', '32', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '6.22');
INSERT INTO public.europe_data_import VALUES (6015, '13/04/2020', '2020-15', '1', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '0.57');
INSERT INTO public.europe_data_import VALUES (6016, '06/04/2020', '2020-14', '2', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '1.13');
INSERT INTO public.europe_data_import VALUES (6017, '30/03/2020', '2020-13', '4', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '0.75');
INSERT INTO public.europe_data_import VALUES (6018, '23/03/2020', '2020-12', '0', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '1.7');
INSERT INTO public.europe_data_import VALUES (6019, '16/03/2020', '2020-11', '9', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '2.45');
INSERT INTO public.europe_data_import VALUES (6020, '09/03/2020', '2020-10', '4', '0', '530957', 'Maldives', 'MV', 'MDV', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (6021, '01/02/2021', '2021-04', '117', '8', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.33');
INSERT INTO public.europe_data_import VALUES (6022, '25/01/2021', '2021-03', '144', '11', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.95');
INSERT INTO public.europe_data_import VALUES (6023, '18/01/2021', '2021-02', '239', '13', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '2.98');
INSERT INTO public.europe_data_import VALUES (6024, '11/01/2021', '2021-01', '347', '20', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '4.56');
INSERT INTO public.europe_data_import VALUES (6025, '04/01/2021', '2020-53', '550', '22', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '5.4');
INSERT INTO public.europe_data_import VALUES (6026, '28/12/2020', '2020-52', '512', '34', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '4.52');
INSERT INTO public.europe_data_import VALUES (6027, '21/12/2020', '2020-51', '377', '28', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '5.37');
INSERT INTO public.europe_data_import VALUES (6028, '14/12/2020', '2020-50', '679', '30', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '5.88');
INSERT INTO public.europe_data_import VALUES (6029, '07/12/2020', '2020-49', '476', '15', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '4.73');
INSERT INTO public.europe_data_import VALUES (6030, '30/11/2020', '2020-48', '453', '6', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '4.02');
INSERT INTO public.europe_data_import VALUES (6031, '23/11/2020', '2020-47', '338', '4', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '2.7');
INSERT INTO public.europe_data_import VALUES (6032, '16/11/2020', '2020-46', '192', '2', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.64');
INSERT INTO public.europe_data_import VALUES (6033, '09/11/2020', '2020-45', '131', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (6034, '02/11/2020', '2020-44', '55', '3', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.84');
INSERT INTO public.europe_data_import VALUES (6035, '26/10/2020', '2020-43', '111', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.04');
INSERT INTO public.europe_data_import VALUES (6036, '19/10/2020', '2020-42', '93', '0', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.99');
INSERT INTO public.europe_data_import VALUES (6037, '12/10/2020', '2020-41', '102', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (6038, '05/10/2020', '2020-40', '98', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.87');
INSERT INTO public.europe_data_import VALUES (6039, '28/09/2020', '2020-39', '73', '2', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.82');
INSERT INTO public.europe_data_import VALUES (6040, '21/09/2020', '2020-38', '89', '0', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.87');
INSERT INTO public.europe_data_import VALUES (6041, '14/09/2020', '2020-37', '82', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.77');
INSERT INTO public.europe_data_import VALUES (6042, '07/09/2020', '2020-36', '69', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.7');
INSERT INTO public.europe_data_import VALUES (6043, '31/08/2020', '2020-35', '68', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.81');
INSERT INTO public.europe_data_import VALUES (6044, '24/08/2020', '2020-34', '91', '0', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.7');
INSERT INTO public.europe_data_import VALUES (6045, '17/08/2020', '2020-33', '47', '0', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (6046, '10/08/2020', '2020-32', '26', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.29');
INSERT INTO public.europe_data_import VALUES (6047, '03/08/2020', '2020-31', '31', '1', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (6048, '27/07/2020', '2020-30', '35', '2', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (6049, '20/07/2020', '2020-29', '64', '0', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.74');
INSERT INTO public.europe_data_import VALUES (6050, '13/07/2020', '2020-28', '81', '2', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.34');
INSERT INTO public.europe_data_import VALUES (6051, '06/07/2020', '2020-27', '183', '5', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.88');
INSERT INTO public.europe_data_import VALUES (6052, '29/06/2020', '2020-26', '186', '3', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.72');
INSERT INTO public.europe_data_import VALUES (6053, '22/06/2020', '2020-25', '152', '7', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '2.18');
INSERT INTO public.europe_data_import VALUES (6054, '15/06/2020', '2020-24', '276', '12', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '2.77');
INSERT INTO public.europe_data_import VALUES (6055, '08/06/2020', '2020-23', '268', '15', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '2.56');
INSERT INTO public.europe_data_import VALUES (6056, '01/06/2020', '2020-22', '235', '12', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '2.06');
INSERT INTO public.europe_data_import VALUES (6057, '25/05/2020', '2020-21', '170', '13', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.66');
INSERT INTO public.europe_data_import VALUES (6058, '18/05/2020', '2020-20', '156', '14', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.51');
INSERT INTO public.europe_data_import VALUES (6059, '11/05/2020', '2020-19', '141', '11', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.6');
INSERT INTO public.europe_data_import VALUES (6060, '04/05/2020', '2020-18', '174', '4', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.72');
INSERT INTO public.europe_data_import VALUES (6061, '27/04/2020', '2020-17', '165', '9', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '1.39');
INSERT INTO public.europe_data_import VALUES (6062, '20/04/2020', '2020-16', '108', '5', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.91');
INSERT INTO public.europe_data_import VALUES (6063, '13/04/2020', '2020-15', '71', '4', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (6064, '06/04/2020', '2020-14', '27', '5', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (6065, '30/03/2020', '2020-13', '18', '0', '19658023', 'Mali', 'ML', 'MLI', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (6066, '01/02/2021', '2021-04', '1177', '22', '493559', 'Malta', 'MT', 'MLT', 'Europe', '465.19');
INSERT INTO public.europe_data_import VALUES (6067, '25/01/2021', '2021-03', '1119', '12', '493559', 'Malta', 'MT', 'MLT', 'Europe', '472.49');
INSERT INTO public.europe_data_import VALUES (6068, '18/01/2021', '2021-02', '1213', '7', '493559', 'Malta', 'MT', 'MLT', 'Europe', '508.96');
INSERT INTO public.europe_data_import VALUES (6069, '11/01/2021', '2021-01', '1299', '11', '493559', 'Malta', 'MT', 'MLT', 'Europe', '426.09');
INSERT INTO public.europe_data_import VALUES (6070, '04/01/2021', '2020-53', '804', '6', '493559', 'Malta', 'MT', 'MLT', 'Europe', '289.33');
INSERT INTO public.europe_data_import VALUES (6071, '28/12/2020', '2020-52', '624', '20', '493559', 'Malta', 'MT', 'MLT', 'Europe', '237.46');
INSERT INTO public.europe_data_import VALUES (6072, '21/12/2020', '2020-51', '548', '20', '493559', 'Malta', 'MT', 'MLT', 'Europe', '231.58');
INSERT INTO public.europe_data_import VALUES (6073, '14/12/2020', '2020-50', '595', '21', '493559', 'Malta', 'MT', 'MLT', 'Europe', '279.8');
INSERT INTO public.europe_data_import VALUES (6074, '07/12/2020', '2020-49', '786', '15', '493559', 'Malta', 'MT', 'MLT', 'Europe', '335.32');
INSERT INTO public.europe_data_import VALUES (6075, '30/11/2020', '2020-48', '869', '25', '493559', 'Malta', 'MT', 'MLT', 'Europe', '351.73');
INSERT INTO public.europe_data_import VALUES (6076, '23/11/2020', '2020-47', '867', '15', '493559', 'Malta', 'MT', 'MLT', 'Europe', '356.8');
INSERT INTO public.europe_data_import VALUES (6077, '16/11/2020', '2020-46', '894', '20', '493559', 'Malta', 'MT', 'MLT', 'Europe', '351.73');
INSERT INTO public.europe_data_import VALUES (6078, '09/11/2020', '2020-45', '842', '14', '493559', 'Malta', 'MT', 'MLT', 'Europe', '337.35');
INSERT INTO public.europe_data_import VALUES (6079, '02/11/2020', '2020-44', '823', '8', '493559', 'Malta', 'MT', 'MLT', 'Europe', '336.54');
INSERT INTO public.europe_data_import VALUES (6080, '26/10/2020', '2020-43', '838', '8', '493559', 'Malta', 'MT', 'MLT', 'Europe', '350.92');
INSERT INTO public.europe_data_import VALUES (6081, '19/10/2020', '2020-42', '894', '2', '493559', 'Malta', 'MT', 'MLT', 'Europe', '285.88');
INSERT INTO public.europe_data_import VALUES (6082, '12/10/2020', '2020-41', '517', '4', '493559', 'Malta', 'MT', 'MLT', 'Europe', '167.76');
INSERT INTO public.europe_data_import VALUES (6083, '05/10/2020', '2020-40', '311', '7', '493559', 'Malta', 'MT', 'MLT', 'Europe', '109.61');
INSERT INTO public.europe_data_import VALUES (6084, '28/09/2020', '2020-39', '230', '11', '493559', 'Malta', 'MT', 'MLT', 'Europe', '121.77');
INSERT INTO public.europe_data_import VALUES (6085, '21/09/2020', '2020-38', '371', '6', '493559', 'Malta', 'MT', 'MLT', 'Europe', '141.83');
INSERT INTO public.europe_data_import VALUES (6086, '14/09/2020', '2020-37', '329', '1', '493559', 'Malta', 'MT', 'MLT', 'Europe', '105.56');
INSERT INTO public.europe_data_import VALUES (6087, '07/09/2020', '2020-36', '192', '2', '493559', 'Malta', 'MT', 'MLT', 'Europe', '82.87');
INSERT INTO public.europe_data_import VALUES (6088, '31/08/2020', '2020-35', '217', '2', '493559', 'Malta', 'MT', 'MLT', 'Europe', '103.74');
INSERT INTO public.europe_data_import VALUES (6089, '24/08/2020', '2020-34', '295', '1', '493559', 'Malta', 'MT', 'MLT', 'Europe', '134.13');
INSERT INTO public.europe_data_import VALUES (6090, '17/08/2020', '2020-33', '367', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '119.54');
INSERT INTO public.europe_data_import VALUES (6091, '10/08/2020', '2020-32', '223', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '62.2');
INSERT INTO public.europe_data_import VALUES (6092, '03/08/2020', '2020-31', '84', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '21.88');
INSERT INTO public.europe_data_import VALUES (6093, '27/07/2020', '2020-30', '24', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '5.27');
INSERT INTO public.europe_data_import VALUES (6094, '20/07/2020', '2020-29', '2', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '0.81');
INSERT INTO public.europe_data_import VALUES (6095, '13/07/2020', '2020-28', '2', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '0.81');
INSERT INTO public.europe_data_import VALUES (6096, '06/07/2020', '2020-27', '2', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '1.42');
INSERT INTO public.europe_data_import VALUES (6097, '29/06/2020', '2020-26', '5', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '4.05');
INSERT INTO public.europe_data_import VALUES (6098, '22/06/2020', '2020-25', '15', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '7.09');
INSERT INTO public.europe_data_import VALUES (6099, '15/06/2020', '2020-24', '20', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '6.28');
INSERT INTO public.europe_data_import VALUES (6100, '08/06/2020', '2020-23', '11', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '3.85');
INSERT INTO public.europe_data_import VALUES (6101, '01/06/2020', '2020-22', '8', '3', '493559', 'Malta', 'MT', 'MLT', 'Europe', '12.36');
INSERT INTO public.europe_data_import VALUES (6102, '25/05/2020', '2020-21', '53', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '21.88');
INSERT INTO public.europe_data_import VALUES (6103, '18/05/2020', '2020-20', '55', '1', '493559', 'Malta', 'MT', 'MLT', 'Europe', '15.8');
INSERT INTO public.europe_data_import VALUES (6104, '11/05/2020', '2020-19', '23', '1', '493559', 'Malta', 'MT', 'MLT', 'Europe', '10.74');
INSERT INTO public.europe_data_import VALUES (6105, '04/05/2020', '2020-18', '30', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '9.73');
INSERT INTO public.europe_data_import VALUES (6106, '27/04/2020', '2020-17', '18', '1', '493559', 'Malta', 'MT', 'MLT', 'Europe', '13.17');
INSERT INTO public.europe_data_import VALUES (6107, '20/04/2020', '2020-16', '47', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '38.5');
INSERT INTO public.europe_data_import VALUES (6108, '13/04/2020', '2020-15', '143', '3', '493559', 'Malta', 'MT', 'MLT', 'Europe', '46.2');
INSERT INTO public.europe_data_import VALUES (6109, '06/04/2020', '2020-14', '85', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '27.15');
INSERT INTO public.europe_data_import VALUES (6110, '30/03/2020', '2020-13', '49', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '25.53');
INSERT INTO public.europe_data_import VALUES (6111, '23/03/2020', '2020-12', '77', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '21.07');
INSERT INTO public.europe_data_import VALUES (6112, '16/03/2020', '2020-11', '27', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '6.08');
INSERT INTO public.europe_data_import VALUES (6113, '09/03/2020', '2020-10', '3', '0', '493559', 'Malta', 'MT', 'MLT', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (6114, '01/02/2021', '2021-04', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6115, '25/01/2021', '2021-03', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6116, '18/01/2021', '2021-02', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6117, '11/01/2021', '2021-01', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6118, '04/01/2021', '2020-53', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6119, '28/12/2020', '2020-52', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6120, '21/12/2020', '2020-51', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6121, '14/12/2020', '2020-50', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6122, '07/12/2020', '2020-49', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6123, '30/11/2020', '2020-48', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '5.1');
INSERT INTO public.europe_data_import VALUES (6124, '23/11/2020', '2020-47', '3', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '5.1');
INSERT INTO public.europe_data_import VALUES (6125, '16/11/2020', '2020-46', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6126, '09/11/2020', '2020-45', '0', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '1.7');
INSERT INTO public.europe_data_import VALUES (6127, '02/11/2020', '2020-44', '1', '0', '58791', 'Marshall_Islands', 'MH', 'MHL', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (6128, '01/02/2021', '2021-04', '146', '5', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '11.14');
INSERT INTO public.europe_data_import VALUES (6129, '25/01/2021', '2021-03', '358', '11', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '19.55');
INSERT INTO public.europe_data_import VALUES (6130, '18/01/2021', '2021-02', '527', '21', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '27.51');
INSERT INTO public.europe_data_import VALUES (6131, '11/01/2021', '2021-01', '718', '26', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '38.31');
INSERT INTO public.europe_data_import VALUES (6132, '04/01/2021', '2020-53', '1016', '28', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '52.5');
INSERT INTO public.europe_data_import VALUES (6133, '28/12/2020', '2020-52', '1360', '49', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '62.02');
INSERT INTO public.europe_data_import VALUES (6134, '21/12/2020', '2020-51', '1447', '56', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '81.93');
INSERT INTO public.europe_data_import VALUES (6135, '14/12/2020', '2020-50', '2261', '48', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '53.52');
INSERT INTO public.europe_data_import VALUES (6136, '07/12/2020', '2020-49', '161', '2', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '13.57');
INSERT INTO public.europe_data_import VALUES (6137, '30/11/2020', '2020-48', '453', '6', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '14.67');
INSERT INTO public.europe_data_import VALUES (6138, '23/11/2020', '2020-47', '211', '4', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '6.41');
INSERT INTO public.europe_data_import VALUES (6139, '16/11/2020', '2020-46', '79', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '3.71');
INSERT INTO public.europe_data_import VALUES (6140, '09/11/2020', '2020-45', '89', '2', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '3.18');
INSERT INTO public.europe_data_import VALUES (6141, '02/11/2020', '2020-44', '55', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '2.52');
INSERT INTO public.europe_data_import VALUES (6142, '26/10/2020', '2020-43', '59', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '2.47');
INSERT INTO public.europe_data_import VALUES (6143, '19/10/2020', '2020-42', '53', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '1.83');
INSERT INTO public.europe_data_import VALUES (6144, '12/10/2020', '2020-41', '30', '2', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '1.94');
INSERT INTO public.europe_data_import VALUES (6145, '05/10/2020', '2020-40', '58', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '3.36');
INSERT INTO public.europe_data_import VALUES (6146, '28/09/2020', '2020-39', '94', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '4.11');
INSERT INTO public.europe_data_import VALUES (6147, '21/09/2020', '2020-38', '92', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '5.17');
INSERT INTO public.europe_data_import VALUES (6148, '14/09/2020', '2020-37', '142', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '5.61');
INSERT INTO public.europe_data_import VALUES (6149, '07/09/2020', '2020-36', '112', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '5.5');
INSERT INTO public.europe_data_import VALUES (6150, '31/08/2020', '2020-35', '137', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '7.09');
INSERT INTO public.europe_data_import VALUES (6151, '24/08/2020', '2020-34', '184', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '8.55');
INSERT INTO public.europe_data_import VALUES (6152, '17/08/2020', '2020-33', '203', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '8.64');
INSERT INTO public.europe_data_import VALUES (6153, '10/08/2020', '2020-32', '188', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '7.23');
INSERT INTO public.europe_data_import VALUES (6154, '03/08/2020', '2020-31', '139', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '9.66');
INSERT INTO public.europe_data_import VALUES (6155, '27/07/2020', '2020-30', '298', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '23.09');
INSERT INTO public.europe_data_import VALUES (6156, '20/07/2020', '2020-29', '747', '11', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '21.96');
INSERT INTO public.europe_data_import VALUES (6157, '13/07/2020', '2020-28', '247', '14', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '26.94');
INSERT INTO public.europe_data_import VALUES (6158, '06/07/2020', '2020-27', '972', '10', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '45.65');
INSERT INTO public.europe_data_import VALUES (6159, '29/06/2020', '2020-26', '1094', '12', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '46.93');
INSERT INTO public.europe_data_import VALUES (6160, '22/06/2020', '2020-25', '1030', '21', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '41.23');
INSERT INTO public.europe_data_import VALUES (6161, '15/06/2020', '2020-24', '836', '44', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '27.69');
INSERT INTO public.europe_data_import VALUES (6162, '08/06/2020', '2020-23', '417', '20', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '15.69');
INSERT INTO public.europe_data_import VALUES (6163, '01/06/2020', '2020-22', '293', '17', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '10.34');
INSERT INTO public.europe_data_import VALUES (6164, '25/05/2020', '2020-21', '175', '2', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '5.06');
INSERT INTO public.europe_data_import VALUES (6165, '18/05/2020', '2020-20', '54', '3', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '1.19');
INSERT INTO public.europe_data_import VALUES (6166, '11/05/2020', '2020-19', '0', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (6167, '04/05/2020', '2020-18', '1', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (6168, '27/04/2020', '2020-17', '0', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6169, '20/04/2020', '2020-16', '0', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (6170, '13/04/2020', '2020-15', '1', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (6171, '06/04/2020', '2020-14', '1', '1', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (6172, '30/03/2020', '2020-13', '3', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (6173, '23/03/2020', '2020-12', '1', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (6174, '16/03/2020', '2020-11', '1', '0', '4525698', 'Mauritania', 'MR', 'MRT', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (6175, '01/02/2021', '2021-04', '1', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.73');
INSERT INTO public.europe_data_import VALUES (6176, '25/01/2021', '2021-03', '21', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.81');
INSERT INTO public.europe_data_import VALUES (6177, '18/01/2021', '2021-02', '2', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.26');
INSERT INTO public.europe_data_import VALUES (6178, '11/01/2021', '2021-01', '14', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.42');
INSERT INTO public.europe_data_import VALUES (6179, '04/01/2021', '2020-53', '4', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.39');
INSERT INTO public.europe_data_import VALUES (6180, '28/12/2020', '2020-52', '1', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6181, '21/12/2020', '2020-51', '3', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.65');
INSERT INTO public.europe_data_import VALUES (6182, '14/12/2020', '2020-50', '18', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.73');
INSERT INTO public.europe_data_import VALUES (6183, '07/12/2020', '2020-49', '4', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.87');
INSERT INTO public.europe_data_import VALUES (6184, '30/11/2020', '2020-48', '7', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.81');
INSERT INTO public.europe_data_import VALUES (6185, '23/11/2020', '2020-47', '16', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '3.31');
INSERT INTO public.europe_data_import VALUES (6186, '16/11/2020', '2020-46', '26', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '2.52');
INSERT INTO public.europe_data_import VALUES (6187, '09/11/2020', '2020-45', '6', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.34');
INSERT INTO public.europe_data_import VALUES (6188, '02/11/2020', '2020-44', '11', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '3.07');
INSERT INTO public.europe_data_import VALUES (6189, '26/10/2020', '2020-43', '28', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '3.15');
INSERT INTO public.europe_data_import VALUES (6190, '19/10/2020', '2020-42', '12', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '2.05');
INSERT INTO public.europe_data_import VALUES (6191, '12/10/2020', '2020-41', '14', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '2.21');
INSERT INTO public.europe_data_import VALUES (6192, '05/10/2020', '2020-40', '14', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.1');
INSERT INTO public.europe_data_import VALUES (6193, '28/09/2020', '2020-39', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.47');
INSERT INTO public.europe_data_import VALUES (6194, '21/09/2020', '2020-38', '6', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.87');
INSERT INTO public.europe_data_import VALUES (6195, '14/09/2020', '2020-37', '5', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '1.18');
INSERT INTO public.europe_data_import VALUES (6196, '07/09/2020', '2020-36', '10', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.79');
INSERT INTO public.europe_data_import VALUES (6197, '31/08/2020', '2020-35', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6198, '24/08/2020', '2020-34', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (6199, '17/08/2020', '2020-33', '2', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (6200, '10/08/2020', '2020-32', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6201, '03/08/2020', '2020-31', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (6202, '27/07/2020', '2020-30', '1', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (6203, '20/07/2020', '2020-29', '1', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (6204, '13/07/2020', '2020-28', '1', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (6205, '06/07/2020', '2020-27', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6206, '29/06/2020', '2020-26', '4', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6207, '22/06/2020', '2020-25', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6208, '15/06/2020', '2020-24', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (6209, '08/06/2020', '2020-23', '2', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (6210, '01/06/2020', '2020-22', '1', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (6211, '25/05/2020', '2020-21', '2', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (6212, '18/05/2020', '2020-20', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6213, '11/05/2020', '2020-19', '0', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6214, '04/05/2020', '2020-18', '0', '1', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6215, '27/04/2020', '2020-17', '4', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '0.63');
INSERT INTO public.europe_data_import VALUES (6216, '20/04/2020', '2020-16', '4', '0', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '7.95');
INSERT INTO public.europe_data_import VALUES (6217, '13/04/2020', '2020-15', '97', '2', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '16.85');
INSERT INTO public.europe_data_import VALUES (6218, '06/04/2020', '2020-14', '117', '4', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '15.67');
INSERT INTO public.europe_data_import VALUES (6219, '30/03/2020', '2020-13', '82', '1', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '8.66');
INSERT INTO public.europe_data_import VALUES (6220, '23/03/2020', '2020-12', '28', '2', '1269670', 'Mauritius', 'MU', 'MUS', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (6221, '01/02/2021', '2021-04', '97968', '8827', '127575529', 'Mexico', 'MX', 'MEX', 'America', '172.61');
INSERT INTO public.europe_data_import VALUES (6222, '25/01/2021', '2021-03', '122238', '9025', '127575529', 'Mexico', 'MX', 'MEX', 'America', '180.37');
INSERT INTO public.europe_data_import VALUES (6223, '18/01/2021', '2021-02', '107869', '6880', '127575529', 'Mexico', 'MX', 'MEX', 'America', '157.36');
INSERT INTO public.europe_data_import VALUES (6224, '11/01/2021', '2021-01', '92878', '7155', '127575529', 'Mexico', 'MX', 'MEX', 'America', '119.3');
INSERT INTO public.europe_data_import VALUES (6225, '04/01/2021', '2020-53', '59325', '4358', '127575529', 'Mexico', 'MX', 'MEX', 'America', '96.29');
INSERT INTO public.europe_data_import VALUES (6226, '28/12/2020', '2020-52', '63515', '4257', '127575529', 'Mexico', 'MX', 'MEX', 'America', '109.26');
INSERT INTO public.europe_data_import VALUES (6227, '21/12/2020', '2020-51', '75871', '4645', '127575529', 'Mexico', 'MX', 'MEX', 'America', '117.63');
INSERT INTO public.europe_data_import VALUES (6228, '14/12/2020', '2020-50', '74194', '4236', '127575529', 'Mexico', 'MX', 'MEX', 'America', '112.07');
INSERT INTO public.europe_data_import VALUES (6229, '07/12/2020', '2020-49', '68779', '4062', '127575529', 'Mexico', 'MX', 'MEX', 'America', '105.02');
INSERT INTO public.europe_data_import VALUES (6230, '30/11/2020', '2020-48', '65196', '3979', '127575529', 'Mexico', 'MX', 'MEX', 'America', '78.82');
INSERT INTO public.europe_data_import VALUES (6231, '23/11/2020', '2020-47', '35353', '3134', '127575529', 'Mexico', 'MX', 'MEX', 'America', '58.04');
INSERT INTO public.europe_data_import VALUES (6232, '16/11/2020', '2020-46', '38697', '3515', '127575529', 'Mexico', 'MX', 'MEX', 'America', '60.46');
INSERT INTO public.europe_data_import VALUES (6233, '09/11/2020', '2020-45', '38433', '3132', '127575529', 'Mexico', 'MX', 'MEX', 'America', '60.09');
INSERT INTO public.europe_data_import VALUES (6234, '02/11/2020', '2020-44', '38232', '2971', '127575529', 'Mexico', 'MX', 'MEX', 'America', '61.27');
INSERT INTO public.europe_data_import VALUES (6235, '26/10/2020', '2020-43', '39933', '2757', '127575529', 'Mexico', 'MX', 'MEX', 'America', '45.79');
INSERT INTO public.europe_data_import VALUES (6236, '19/10/2020', '2020-42', '18484', '2525', '127575529', 'Mexico', 'MX', 'MEX', 'America', '37.97');
INSERT INTO public.europe_data_import VALUES (6237, '12/10/2020', '2020-41', '29957', '4554', '127575529', 'Mexico', 'MX', 'MEX', 'America', '47.31');
INSERT INTO public.europe_data_import VALUES (6238, '05/10/2020', '2020-40', '30405', '2658', '127575529', 'Mexico', 'MX', 'MEX', 'America', '48.87');
INSERT INTO public.europe_data_import VALUES (6239, '28/09/2020', '2020-39', '31936', '2937', '127575529', 'Mexico', 'MX', 'MEX', 'America', '47.04');
INSERT INTO public.europe_data_import VALUES (6240, '21/09/2020', '2020-38', '28075', '2672', '127575529', 'Mexico', 'MX', 'MEX', 'America', '48.45');
INSERT INTO public.europe_data_import VALUES (6241, '14/09/2020', '2020-37', '33735', '3263', '127575529', 'Mexico', 'MX', 'MEX', 'America', '55.6');
INSERT INTO public.europe_data_import VALUES (6242, '07/09/2020', '2020-36', '37193', '3400', '127575529', 'Mexico', 'MX', 'MEX', 'America', '58.71');
INSERT INTO public.europe_data_import VALUES (6243, '31/08/2020', '2020-35', '37703', '3678', '127575529', 'Mexico', 'MX', 'MEX', 'America', '58.3');
INSERT INTO public.europe_data_import VALUES (6244, '24/08/2020', '2020-34', '36673', '3723', '127575529', 'Mexico', 'MX', 'MEX', 'America', '58.44');
INSERT INTO public.europe_data_import VALUES (6245, '17/08/2020', '2020-33', '37880', '4459', '127575529', 'Mexico', 'MX', 'MEX', 'America', '61.78');
INSERT INTO public.europe_data_import VALUES (6246, '10/08/2020', '2020-32', '40936', '4552', '127575529', 'Mexico', 'MX', 'MEX', 'America', '66.98');
INSERT INTO public.europe_data_import VALUES (6247, '03/08/2020', '2020-31', '44519', '4066', '127575529', 'Mexico', 'MX', 'MEX', 'America', '73.26');
INSERT INTO public.europe_data_import VALUES (6248, '27/07/2020', '2020-30', '48945', '4496', '127575529', 'Mexico', 'MX', 'MEX', 'America', '77.36');
INSERT INTO public.europe_data_import VALUES (6249, '20/07/2020', '2020-29', '49745', '4178', '127575529', 'Mexico', 'MX', 'MEX', 'America', '73.68');
INSERT INTO public.europe_data_import VALUES (6250, '13/07/2020', '2020-28', '44253', '4367', '127575529', 'Mexico', 'MX', 'MEX', 'America', '68.19');
INSERT INTO public.europe_data_import VALUES (6251, '06/07/2020', '2020-27', '42740', '3991', '127575529', 'Mexico', 'MX', 'MEX', 'America', '64.01');
INSERT INTO public.europe_data_import VALUES (6252, '29/06/2020', '2020-26', '38916', '4823', '127575529', 'Mexico', 'MX', 'MEX', 'America', '59.55');
INSERT INTO public.europe_data_import VALUES (6253, '22/06/2020', '2020-25', '37054', '4684', '127575529', 'Mexico', 'MX', 'MEX', 'America', '55.79');
INSERT INTO public.europe_data_import VALUES (6254, '15/06/2020', '2020-24', '34118', '3442', '127575529', 'Mexico', 'MX', 'MEX', 'America', '50.31');
INSERT INTO public.europe_data_import VALUES (6255, '08/06/2020', '2020-23', '30070', '3769', '127575529', 'Mexico', 'MX', 'MEX', 'America', '44.49');
INSERT INTO public.europe_data_import VALUES (6256, '01/06/2020', '2020-22', '26685', '2536', '127575529', 'Mexico', 'MX', 'MEX', 'America', '39.34');
INSERT INTO public.europe_data_import VALUES (6257, '25/05/2020', '2020-21', '23497', '2217', '127575529', 'Mexico', 'MX', 'MEX', 'America', '33.48');
INSERT INTO public.europe_data_import VALUES (6258, '18/05/2020', '2020-20', '19213', '1712', '127575529', 'Mexico', 'MX', 'MEX', 'America', '26.45');
INSERT INTO public.europe_data_import VALUES (6259, '11/05/2020', '2020-19', '14536', '1311', '127575529', 'Mexico', 'MX', 'MEX', 'America', '20.09');
INSERT INTO public.europe_data_import VALUES (6260, '04/05/2020', '2020-18', '11094', '803', '127575529', 'Mexico', 'MX', 'MEX', 'America', '15.86');
INSERT INTO public.europe_data_import VALUES (6261, '27/04/2020', '2020-17', '9135', '665', '127575529', 'Mexico', 'MX', 'MEX', 'America', '11.97');
INSERT INTO public.europe_data_import VALUES (6262, '20/04/2020', '2020-16', '6141', '390', '127575529', 'Mexico', 'MX', 'MEX', 'America', '7.47');
INSERT INTO public.europe_data_import VALUES (6263, '13/04/2020', '2020-15', '3386', '202', '127575529', 'Mexico', 'MX', 'MEX', 'America', '4.29');
INSERT INTO public.europe_data_import VALUES (6264, '06/04/2020', '2020-14', '2083', '74', '127575529', 'Mexico', 'MX', 'MEX', 'America', '2.59');
INSERT INTO public.europe_data_import VALUES (6265, '30/03/2020', '2020-13', '1221', '18', '127575529', 'Mexico', 'MX', 'MEX', 'America', '1.47');
INSERT INTO public.europe_data_import VALUES (6266, '23/03/2020', '2020-12', '654', '2', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.68');
INSERT INTO public.europe_data_import VALUES (6267, '16/03/2020', '2020-11', '216', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.18');
INSERT INTO public.europe_data_import VALUES (6268, '09/03/2020', '2020-10', '14', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.02');
INSERT INTO public.europe_data_import VALUES (6269, '02/03/2020', '2020-09', '11', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (6270, '24/02/2020', '2020-08', '1', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (6271, '17/02/2020', '2020-07', '1', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (6272, '10/02/2020', '2020-06', '0', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (6273, '03/02/2020', '2020-05', '1', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (6274, '27/01/2020', '2020-04', '0', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (6275, '20/01/2020', '2020-03', '1', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (6276, '13/01/2020', '2020-02', '0', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6277, '06/01/2020', '2020-01', '0', '0', '127575529', 'Mexico', 'MX', 'MEX', 'America', '');
INSERT INTO public.europe_data_import VALUES (6278, '01/02/2021', '2021-04', '0', '0', '113811', 'Micronesia_(Federated_States_of)', 'FM', 'FSM', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6279, '25/01/2021', '2021-03', '0', '0', '113811', 'Micronesia_(Federated_States_of)', 'FM', 'FSM', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6280, '18/01/2021', '2021-02', '0', '0', '113811', 'Micronesia_(Federated_States_of)', 'FM', 'FSM', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6281, '11/01/2021', '2021-01', '0', '0', '113811', 'Micronesia_(Federated_States_of)', 'FM', 'FSM', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (6282, '01/02/2021', '2021-04', '3602', '77', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '171.89');
INSERT INTO public.europe_data_import VALUES (6283, '25/01/2021', '2021-03', '3348', '111', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '168.45');
INSERT INTO public.europe_data_import VALUES (6284, '18/01/2021', '2021-02', '3463', '111', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '172.66');
INSERT INTO public.europe_data_import VALUES (6285, '11/01/2021', '2021-01', '3518', '102', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '198.75');
INSERT INTO public.europe_data_import VALUES (6286, '04/01/2021', '2020-53', '4518', '146', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '263.8');
INSERT INTO public.europe_data_import VALUES (6287, '28/12/2020', '2020-52', '6148', '139', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '366.96');
INSERT INTO public.europe_data_import VALUES (6288, '21/12/2020', '2020-51', '8689', '180', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '459.33');
INSERT INTO public.europe_data_import VALUES (6289, '14/12/2020', '2020-50', '9883', '153', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '482.31');
INSERT INTO public.europe_data_import VALUES (6290, '07/12/2020', '2020-49', '9618', '129', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '462.35');
INSERT INTO public.europe_data_import VALUES (6291, '30/11/2020', '2020-48', '9076', '141', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '438.71');
INSERT INTO public.europe_data_import VALUES (6292, '23/11/2020', '2020-47', '8662', '130', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '385.7');
INSERT INTO public.europe_data_import VALUES (6293, '16/11/2020', '2020-46', '6933', '126', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '314.03');
INSERT INTO public.europe_data_import VALUES (6294, '09/11/2020', '2020-45', '5764', '93', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '268.17');
INSERT INTO public.europe_data_import VALUES (6295, '02/11/2020', '2020-44', '5079', '115', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '235.75');
INSERT INTO public.europe_data_import VALUES (6296, '26/10/2020', '2020-43', '4453', '101', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '231.3');
INSERT INTO public.europe_data_import VALUES (6297, '19/10/2020', '2020-42', '4899', '123', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '258.97');
INSERT INTO public.europe_data_import VALUES (6298, '12/10/2020', '2020-41', '5572', '95', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '278.88');
INSERT INTO public.europe_data_import VALUES (6299, '05/10/2020', '2020-40', '5704', '79', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '246.9');
INSERT INTO public.europe_data_import VALUES (6300, '28/09/2020', '2020-39', '4279', '84', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '195.31');
INSERT INTO public.europe_data_import VALUES (6301, '21/09/2020', '2020-38', '3618', '80', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '168.16');
INSERT INTO public.europe_data_import VALUES (6302, '14/09/2020', '2020-37', '3181', '60', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '155.27');
INSERT INTO public.europe_data_import VALUES (6303, '07/09/2020', '2020-36', '3097', '71', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '156.28');
INSERT INTO public.europe_data_import VALUES (6304, '31/08/2020', '2020-35', '3222', '52', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '161.18');
INSERT INTO public.europe_data_import VALUES (6305, '24/08/2020', '2020-34', '3295', '44', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '143.89');
INSERT INTO public.europe_data_import VALUES (6306, '17/08/2020', '2020-33', '2523', '51', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '119.24');
INSERT INTO public.europe_data_import VALUES (6307, '10/08/2020', '2020-32', '2298', '54', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '114.41');
INSERT INTO public.europe_data_import VALUES (6308, '03/08/2020', '2020-31', '2328', '56', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '108.38');
INSERT INTO public.europe_data_import VALUES (6309, '27/07/2020', '2020-30', '2054', '51', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '90.32');
INSERT INTO public.europe_data_import VALUES (6310, '20/07/2020', '2020-29', '1598', '42', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '78.3');
INSERT INTO public.europe_data_import VALUES (6311, '13/07/2020', '2020-28', '1568', '57', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '77.46');
INSERT INTO public.europe_data_import VALUES (6312, '06/07/2020', '2020-27', '1564', '55', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '89.38');
INSERT INTO public.europe_data_import VALUES (6313, '29/06/2020', '2020-26', '2050', '57', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '111.54');
INSERT INTO public.europe_data_import VALUES (6314, '22/06/2020', '2020-25', '2460', '67', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '111.3');
INSERT INTO public.europe_data_import VALUES (6315, '15/06/2020', '2020-24', '2040', '65', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '86.29');
INSERT INTO public.europe_data_import VALUES (6316, '08/06/2020', '2020-23', '1449', '46', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '64.48');
INSERT INTO public.europe_data_import VALUES (6317, '01/06/2020', '2020-22', '1158', '45', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '54.19');
INSERT INTO public.europe_data_import VALUES (6318, '25/05/2020', '2020-21', '1033', '39', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '53.57');
INSERT INTO public.europe_data_import VALUES (6319, '18/05/2020', '2020-20', '1133', '42', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '47.96');
INSERT INTO public.europe_data_import VALUES (6320, '11/05/2020', '2020-19', '806', '44', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '37.57');
INSERT INTO public.europe_data_import VALUES (6321, '04/05/2020', '2020-18', '713', '29', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '40.78');
INSERT INTO public.europe_data_import VALUES (6322, '27/04/2020', '2020-17', '936', '29', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '43.18');
INSERT INTO public.europe_data_import VALUES (6323, '20/04/2020', '2020-16', '810', '35', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '39.77');
INSERT INTO public.europe_data_import VALUES (6324, '13/04/2020', '2020-15', '798', '17', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '34.6');
INSERT INTO public.europe_data_import VALUES (6325, '06/04/2020', '2020-14', '601', '13', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '19.04');
INSERT INTO public.europe_data_import VALUES (6326, '30/03/2020', '2020-13', '169', '1', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '5.94');
INSERT INTO public.europe_data_import VALUES (6327, '23/03/2020', '2020-12', '71', '1', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '2.32');
INSERT INTO public.europe_data_import VALUES (6328, '16/03/2020', '2020-11', '23', '0', '4043258', 'Moldova', 'MD', 'MDA', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (6329, '01/02/2021', '2021-04', '132', '5', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '858.4');
INSERT INTO public.europe_data_import VALUES (6330, '25/01/2021', '2021-03', '152', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '906.76');
INSERT INTO public.europe_data_import VALUES (6331, '18/01/2021', '2021-02', '148', '5', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '900.71');
INSERT INTO public.europe_data_import VALUES (6332, '11/01/2021', '2021-01', '150', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '767.72');
INSERT INTO public.europe_data_import VALUES (6333, '04/01/2021', '2020-53', '104', '1', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '541.03');
INSERT INTO public.europe_data_import VALUES (6334, '28/12/2020', '2020-52', '75', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '408.04');
INSERT INTO public.europe_data_import VALUES (6335, '21/12/2020', '2020-51', '60', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '272.03');
INSERT INTO public.europe_data_import VALUES (6336, '14/12/2020', '2020-50', '30', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '181.35');
INSERT INTO public.europe_data_import VALUES (6337, '07/12/2020', '2020-49', '30', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '169.26');
INSERT INTO public.europe_data_import VALUES (6338, '30/11/2020', '2020-48', '26', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '181.35');
INSERT INTO public.europe_data_import VALUES (6339, '23/11/2020', '2020-47', '34', '1', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '290.16');
INSERT INTO public.europe_data_import VALUES (6340, '16/11/2020', '2020-46', '62', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '550.1');
INSERT INTO public.europe_data_import VALUES (6341, '09/11/2020', '2020-45', '120', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '544.05');
INSERT INTO public.europe_data_import VALUES (6342, '02/11/2020', '2020-44', '60', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '305.27');
INSERT INTO public.europe_data_import VALUES (6343, '26/10/2020', '2020-43', '41', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '217.62');
INSERT INTO public.europe_data_import VALUES (6344, '19/10/2020', '2020-42', '31', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '129.97');
INSERT INTO public.europe_data_import VALUES (6345, '12/10/2020', '2020-41', '12', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '72.54');
INSERT INTO public.europe_data_import VALUES (6346, '05/10/2020', '2020-40', '12', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '87.65');
INSERT INTO public.europe_data_import VALUES (6347, '28/09/2020', '2020-39', '17', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '117.88');
INSERT INTO public.europe_data_import VALUES (6348, '21/09/2020', '2020-38', '22', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '136.01');
INSERT INTO public.europe_data_import VALUES (6349, '14/09/2020', '2020-37', '23', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '120.9');
INSERT INTO public.europe_data_import VALUES (6350, '07/09/2020', '2020-36', '17', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '111.83');
INSERT INTO public.europe_data_import VALUES (6351, '31/08/2020', '2020-35', '20', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '96.72');
INSERT INTO public.europe_data_import VALUES (6352, '24/08/2020', '2020-34', '12', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '51.38');
INSERT INTO public.europe_data_import VALUES (6353, '17/08/2020', '2020-33', '5', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '45.34');
INSERT INTO public.europe_data_import VALUES (6354, '10/08/2020', '2020-32', '10', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '39.29');
INSERT INTO public.europe_data_import VALUES (6355, '03/08/2020', '2020-31', '3', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '24.18');
INSERT INTO public.europe_data_import VALUES (6356, '27/07/2020', '2020-30', '5', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '15.11');
INSERT INTO public.europe_data_import VALUES (6357, '20/07/2020', '2020-29', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6358, '13/07/2020', '2020-28', '1', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '18.14');
INSERT INTO public.europe_data_import VALUES (6359, '06/07/2020', '2020-27', '5', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '21.16');
INSERT INTO public.europe_data_import VALUES (6360, '29/06/2020', '2020-26', '2', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '9.07');
INSERT INTO public.europe_data_import VALUES (6361, '22/06/2020', '2020-25', '1', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6362, '15/06/2020', '2020-24', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6363, '08/06/2020', '2020-23', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6364, '01/06/2020', '2020-22', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6365, '25/05/2020', '2020-21', '1', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6366, '18/05/2020', '2020-20', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6367, '11/05/2020', '2020-19', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6368, '04/05/2020', '2020-18', '1', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6369, '27/04/2020', '2020-17', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6370, '20/04/2020', '2020-16', '1', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '42.32');
INSERT INTO public.europe_data_import VALUES (6371, '13/04/2020', '2020-15', '13', '1', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '87.65');
INSERT INTO public.europe_data_import VALUES (6372, '06/04/2020', '2020-14', '16', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '93.7');
INSERT INTO public.europe_data_import VALUES (6373, '30/03/2020', '2020-13', '15', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '78.59');
INSERT INTO public.europe_data_import VALUES (6374, '23/03/2020', '2020-12', '11', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '57.43');
INSERT INTO public.europe_data_import VALUES (6375, '16/03/2020', '2020-11', '8', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '24.18');
INSERT INTO public.europe_data_import VALUES (6376, '09/03/2020', '2020-10', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6377, '02/03/2020', '2020-09', '1', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '3.02');
INSERT INTO public.europe_data_import VALUES (6378, '24/02/2020', '2020-08', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6379, '17/02/2020', '2020-07', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6380, '10/02/2020', '2020-06', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6381, '03/02/2020', '2020-05', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6382, '27/01/2020', '2020-04', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6383, '20/01/2020', '2020-03', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6384, '13/01/2020', '2020-02', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6385, '06/01/2020', '2020-01', '0', '0', '33085', 'Monaco', 'MC', 'MCO', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (6386, '01/02/2021', '2021-04', '171', '2', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '8.93');
INSERT INTO public.europe_data_import VALUES (6387, '25/01/2021', '2021-03', '117', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '6.23');
INSERT INTO public.europe_data_import VALUES (6388, '18/01/2021', '2021-02', '84', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '7.44');
INSERT INTO public.europe_data_import VALUES (6389, '11/01/2021', '2021-01', '156', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '9.46');
INSERT INTO public.europe_data_import VALUES (6390, '04/01/2021', '2020-53', '149', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '9.08');
INSERT INTO public.europe_data_import VALUES (6391, '28/12/2020', '2020-52', '144', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '6.98');
INSERT INTO public.europe_data_import VALUES (6392, '21/12/2020', '2020-51', '81', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '3.29');
INSERT INTO public.europe_data_import VALUES (6393, '14/12/2020', '2020-50', '25', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '3.75');
INSERT INTO public.europe_data_import VALUES (6394, '07/12/2020', '2020-49', '96', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '7.66');
INSERT INTO public.europe_data_import VALUES (6395, '30/11/2020', '2020-48', '151', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '11.16');
INSERT INTO public.europe_data_import VALUES (6396, '23/11/2020', '2020-47', '209', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '8.43');
INSERT INTO public.europe_data_import VALUES (6397, '16/11/2020', '2020-46', '63', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '2.54');
INSERT INTO public.europe_data_import VALUES (6398, '09/11/2020', '2020-45', '19', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.9');
INSERT INTO public.europe_data_import VALUES (6399, '02/11/2020', '2020-44', '10', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.78');
INSERT INTO public.europe_data_import VALUES (6400, '26/10/2020', '2020-43', '15', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.65');
INSERT INTO public.europe_data_import VALUES (6401, '19/10/2020', '2020-42', '6', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.31');
INSERT INTO public.europe_data_import VALUES (6402, '12/10/2020', '2020-41', '4', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (6403, '05/10/2020', '2020-40', '1', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6404, '28/09/2020', '2020-39', '1', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6405, '21/09/2020', '2020-38', '1', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6406, '14/09/2020', '2020-37', '1', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.31');
INSERT INTO public.europe_data_import VALUES (6407, '07/09/2020', '2020-36', '9', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (6408, '31/08/2020', '2020-35', '3', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (6409, '24/08/2020', '2020-34', '0', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (6410, '17/08/2020', '2020-33', '5', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (6411, '10/08/2020', '2020-32', '0', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.16');
INSERT INTO public.europe_data_import VALUES (6412, '03/08/2020', '2020-31', '5', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.19');
INSERT INTO public.europe_data_import VALUES (6413, '27/07/2020', '2020-30', '1', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '1.8');
INSERT INTO public.europe_data_import VALUES (6414, '20/07/2020', '2020-29', '57', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '2.08');
INSERT INTO public.europe_data_import VALUES (6415, '13/07/2020', '2020-28', '10', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.31');
INSERT INTO public.europe_data_import VALUES (6416, '06/07/2020', '2020-27', '0', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.22');
INSERT INTO public.europe_data_import VALUES (6417, '29/06/2020', '2020-26', '7', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.71');
INSERT INTO public.europe_data_import VALUES (6418, '22/06/2020', '2020-25', '16', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.59');
INSERT INTO public.europe_data_import VALUES (6419, '15/06/2020', '2020-24', '3', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (6420, '08/06/2020', '2020-23', '9', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '1.64');
INSERT INTO public.europe_data_import VALUES (6421, '01/06/2020', '2020-22', '44', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '1.4');
INSERT INTO public.europe_data_import VALUES (6422, '25/05/2020', '2020-21', '1', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '3.07');
INSERT INTO public.europe_data_import VALUES (6423, '18/05/2020', '2020-20', '98', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '3.1');
INSERT INTO public.europe_data_import VALUES (6424, '11/05/2020', '2020-19', '2', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (6425, '04/05/2020', '2020-18', '2', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.25');
INSERT INTO public.europe_data_import VALUES (6426, '27/04/2020', '2020-17', '6', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.68');
INSERT INTO public.europe_data_import VALUES (6427, '20/04/2020', '2020-16', '16', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.56');
INSERT INTO public.europe_data_import VALUES (6428, '13/04/2020', '2020-15', '2', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (6429, '06/04/2020', '2020-14', '2', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (6430, '30/03/2020', '2020-13', '2', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (6431, '23/03/2020', '2020-12', '10', '0', '3225166', 'Mongolia', 'MN', 'MNG', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (6432, '01/02/2021', '2021-04', '3343', '37', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '991.03');
INSERT INTO public.europe_data_import VALUES (6433, '25/01/2021', '2021-03', '2823', '23', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '945.86');
INSERT INTO public.europe_data_import VALUES (6434, '18/01/2021', '2021-02', '3062', '20', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '1012.24');
INSERT INTO public.europe_data_import VALUES (6435, '11/01/2021', '2021-01', '3236', '36', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '922.08');
INSERT INTO public.europe_data_import VALUES (6436, '04/01/2021', '2020-53', '2501', '23', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '842.2');
INSERT INTO public.europe_data_import VALUES (6437, '28/12/2020', '2020-52', '2739', '40', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '846.7');
INSERT INTO public.europe_data_import VALUES (6438, '21/12/2020', '2020-51', '2529', '44', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '917.58');
INSERT INTO public.europe_data_import VALUES (6439, '14/12/2020', '2020-50', '3180', '49', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '1051.94');
INSERT INTO public.europe_data_import VALUES (6440, '07/12/2020', '2020-49', '3365', '46', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '1154.65');
INSERT INTO public.europe_data_import VALUES (6441, '30/11/2020', '2020-48', '3819', '48', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '1238.22');
INSERT INTO public.europe_data_import VALUES (6442, '23/11/2020', '2020-47', '3885', '48', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '1327.1');
INSERT INTO public.europe_data_import VALUES (6443, '16/11/2020', '2020-46', '4372', '54', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '1360.21');
INSERT INTO public.europe_data_import VALUES (6444, '09/11/2020', '2020-45', '4091', '24', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '965.63');
INSERT INTO public.europe_data_import VALUES (6445, '02/11/2020', '2020-44', '1917', '47', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '498.09');
INSERT INTO public.europe_data_import VALUES (6446, '26/10/2020', '2020-43', '1182', '30', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '470.6');
INSERT INTO public.europe_data_import VALUES (6447, '19/10/2020', '2020-42', '1746', '34', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '560.61');
INSERT INTO public.europe_data_import VALUES (6448, '12/10/2020', '2020-41', '1742', '23', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '571.54');
INSERT INTO public.europe_data_import VALUES (6449, '05/10/2020', '2020-40', '1814', '21', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '564.95');
INSERT INTO public.europe_data_import VALUES (6450, '28/09/2020', '2020-39', '1701', '22', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '578.77');
INSERT INTO public.europe_data_import VALUES (6451, '21/09/2020', '2020-38', '1900', '16', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '491.66');
INSERT INTO public.europe_data_import VALUES (6452, '14/09/2020', '2020-37', '1159', '12', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '308.91');
INSERT INTO public.europe_data_import VALUES (6453, '07/09/2020', '2020-36', '763', '10', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '194.48');
INSERT INTO public.europe_data_import VALUES (6454, '31/08/2020', '2020-35', '447', '14', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '121.35');
INSERT INTO public.europe_data_import VALUES (6455, '24/08/2020', '2020-34', '308', '7', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '116.53');
INSERT INTO public.europe_data_import VALUES (6456, '17/08/2020', '2020-33', '417', '13', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '124.88');
INSERT INTO public.europe_data_import VALUES (6457, '10/08/2020', '2020-32', '360', '13', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '168.6');
INSERT INTO public.europe_data_import VALUES (6458, '03/08/2020', '2020-31', '689', '11', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '239.0');
INSERT INTO public.europe_data_import VALUES (6459, '27/07/2020', '2020-30', '798', '10', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '216.66');
INSERT INTO public.europe_data_import VALUES (6460, '20/07/2020', '2020-29', '550', '7', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '159.12');
INSERT INTO public.europe_data_import VALUES (6461, '13/07/2020', '2020-28', '440', '9', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '118.94');
INSERT INTO public.europe_data_import VALUES (6462, '06/07/2020', '2020-27', '300', '3', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '67.34');
INSERT INTO public.europe_data_import VALUES (6463, '29/06/2020', '2020-26', '119', '2', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '25.07');
INSERT INTO public.europe_data_import VALUES (6464, '22/06/2020', '2020-25', '37', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '6.11');
INSERT INTO public.europe_data_import VALUES (6465, '15/06/2020', '2020-24', '1', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '0.16');
INSERT INTO public.europe_data_import VALUES (6466, '08/06/2020', '2020-23', '0', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6467, '01/06/2020', '2020-22', '0', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6468, '25/05/2020', '2020-21', '0', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6469, '18/05/2020', '2020-20', '0', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '0.32');
INSERT INTO public.europe_data_import VALUES (6470, '11/05/2020', '2020-19', '2', '1', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '0.48');
INSERT INTO public.europe_data_import VALUES (6471, '04/05/2020', '2020-18', '1', '1', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '2.25');
INSERT INTO public.europe_data_import VALUES (6472, '27/04/2020', '2020-17', '13', '2', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '7.88');
INSERT INTO public.europe_data_import VALUES (6473, '20/04/2020', '2020-16', '36', '2', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '15.11');
INSERT INTO public.europe_data_import VALUES (6474, '13/04/2020', '2020-15', '58', '1', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '30.06');
INSERT INTO public.europe_data_import VALUES (6475, '06/04/2020', '2020-14', '129', '1', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '31.02');
INSERT INTO public.europe_data_import VALUES (6476, '30/03/2020', '2020-13', '64', '1', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '13.66');
INSERT INTO public.europe_data_import VALUES (6477, '23/03/2020', '2020-12', '21', '0', '622182', 'Montenegro', 'ME', 'MNE', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (6478, '01/02/2021', '2021-04', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6479, '25/01/2021', '2021-03', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6480, '18/01/2021', '2021-02', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6481, '11/01/2021', '2021-01', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6482, '04/01/2021', '2020-53', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6483, '28/12/2020', '2020-52', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6484, '21/12/2020', '2020-51', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6485, '14/12/2020', '2020-50', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6486, '07/12/2020', '2020-49', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6487, '30/11/2020', '2020-48', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6488, '23/11/2020', '2020-47', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6489, '16/11/2020', '2020-46', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6490, '09/11/2020', '2020-45', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6491, '02/11/2020', '2020-44', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6492, '26/10/2020', '2020-43', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6493, '19/10/2020', '2020-42', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6494, '12/10/2020', '2020-41', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6495, '05/10/2020', '2020-40', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6496, '28/09/2020', '2020-39', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6497, '21/09/2020', '2020-38', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6498, '14/09/2020', '2020-37', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6499, '07/09/2020', '2020-36', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6500, '31/08/2020', '2020-35', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6501, '24/08/2020', '2020-34', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6502, '17/08/2020', '2020-33', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6503, '10/08/2020', '2020-32', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6504, '03/08/2020', '2020-31', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '20.04');
INSERT INTO public.europe_data_import VALUES (6505, '27/07/2020', '2020-30', '1', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '20.04');
INSERT INTO public.europe_data_import VALUES (6506, '20/07/2020', '2020-29', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '20.04');
INSERT INTO public.europe_data_import VALUES (6507, '13/07/2020', '2020-28', '1', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '20.04');
INSERT INTO public.europe_data_import VALUES (6508, '06/07/2020', '2020-27', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6509, '29/06/2020', '2020-26', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6510, '22/06/2020', '2020-25', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6511, '15/06/2020', '2020-24', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6512, '08/06/2020', '2020-23', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6513, '01/06/2020', '2020-22', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6514, '25/05/2020', '2020-21', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6515, '18/05/2020', '2020-20', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6516, '11/05/2020', '2020-19', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6517, '04/05/2020', '2020-18', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6518, '27/04/2020', '2020-17', '0', '1', '4991', 'Montserrat', 'MS', 'MSF', 'America', '0');
INSERT INTO public.europe_data_import VALUES (6519, '20/04/2020', '2020-16', '0', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '100.18');
INSERT INTO public.europe_data_import VALUES (6520, '13/04/2020', '2020-15', '5', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '120.22');
INSERT INTO public.europe_data_import VALUES (6521, '06/04/2020', '2020-14', '1', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '100.18');
INSERT INTO public.europe_data_import VALUES (6522, '30/03/2020', '2020-13', '4', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '100.18');
INSERT INTO public.europe_data_import VALUES (6523, '23/03/2020', '2020-12', '1', '0', '4991', 'Montserrat', 'MS', 'MSF', 'America', '');
INSERT INTO public.europe_data_import VALUES (6524, '01/02/2021', '2021-04', '4868', '125', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '31.49');
INSERT INTO public.europe_data_import VALUES (6525, '25/01/2021', '2021-03', '6618', '208', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '37.72');
INSERT INTO public.europe_data_import VALUES (6526, '18/01/2021', '2021-02', '7139', '199', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '45.31');
INSERT INTO public.europe_data_import VALUES (6527, '11/01/2021', '2021-01', '9386', '258', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '56.08');
INSERT INTO public.europe_data_import VALUES (6528, '04/01/2021', '2020-53', '11067', '245', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '71.35');
INSERT INTO public.europe_data_import VALUES (6529, '28/12/2020', '2020-52', '14954', '283', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '89.03');
INSERT INTO public.europe_data_import VALUES (6530, '21/12/2020', '2020-51', '17516', '333', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '102.73');
INSERT INTO public.europe_data_import VALUES (6531, '14/12/2020', '2020-50', '19952', '379', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '125.59');
INSERT INTO public.europe_data_import VALUES (6532, '07/12/2020', '2020-49', '25854', '456', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '160.93');
INSERT INTO public.europe_data_import VALUES (6533, '30/11/2020', '2020-48', '32841', '533', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '166.23');
INSERT INTO public.europe_data_import VALUES (6534, '23/11/2020', '2020-47', '27785', '477', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '175.97');
INSERT INTO public.europe_data_import VALUES (6535, '16/11/2020', '2020-46', '36396', '507', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '193.66');
INSERT INTO public.europe_data_import VALUES (6536, '09/11/2020', '2020-45', '34237', '510', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '162.59');
INSERT INTO public.europe_data_import VALUES (6537, '02/11/2020', '2020-44', '25063', '461', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '134.11');
INSERT INTO public.europe_data_import VALUES (6538, '26/10/2020', '2020-43', '23849', '373', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '123.59');
INSERT INTO public.europe_data_import VALUES (6539, '19/10/2020', '2020-42', '21228', '323', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '110.66');
INSERT INTO public.europe_data_import VALUES (6540, '12/10/2020', '2020-41', '19132', '275', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '95.19');
INSERT INTO public.europe_data_import VALUES (6541, '05/10/2020', '2020-40', '15587', '261', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '86.45');
INSERT INTO public.europe_data_import VALUES (6542, '28/09/2020', '2020-39', '15942', '239', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '84.99');
INSERT INTO public.europe_data_import VALUES (6543, '21/09/2020', '2020-38', '15057', '252', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '80.47');
INSERT INTO public.europe_data_import VALUES (6544, '14/09/2020', '2020-37', '14292', '217', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '69.33');
INSERT INTO public.europe_data_import VALUES (6545, '07/09/2020', '2020-36', '10995', '250', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '54.96');
INSERT INTO public.europe_data_import VALUES (6546, '31/08/2020', '2020-35', '9050', '223', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '51.85');
INSERT INTO public.europe_data_import VALUES (6547, '24/08/2020', '2020-34', '9860', '230', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '52.4');
INSERT INTO public.europe_data_import VALUES (6548, '17/08/2020', '2020-33', '9252', '160', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '46.48');
INSERT INTO public.europe_data_import VALUES (6549, '10/08/2020', '2020-32', '7700', '116', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '35.53');
INSERT INTO public.europe_data_import VALUES (6550, '03/08/2020', '2020-31', '5259', '69', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '22.76');
INSERT INTO public.europe_data_import VALUES (6551, '27/07/2020', '2020-30', '3042', '40', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '12.43');
INSERT INTO public.europe_data_import VALUES (6552, '20/07/2020', '2020-29', '1491', '23', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '8.28');
INSERT INTO public.europe_data_import VALUES (6553, '13/07/2020', '2020-28', '1530', '15', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '10.13');
INSERT INTO public.europe_data_import VALUES (6554, '06/07/2020', '2020-27', '2163', '14', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '11.62');
INSERT INTO public.europe_data_import VALUES (6555, '29/06/2020', '2020-26', '2075', '7', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '9.1');
INSERT INTO public.europe_data_import VALUES (6556, '22/06/2020', '2020-25', '1243', '2', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '4.81');
INSERT INTO public.europe_data_import VALUES (6557, '15/06/2020', '2020-24', '510', '4', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '2.54');
INSERT INTO public.europe_data_import VALUES (6558, '08/06/2020', '2020-23', '417', '3', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '2.17');
INSERT INTO public.europe_data_import VALUES (6559, '01/06/2020', '2020-22', '374', '6', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '2.57');
INSERT INTO public.europe_data_import VALUES (6560, '25/05/2020', '2020-21', '563', '7', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '3.76');
INSERT INTO public.europe_data_import VALUES (6561, '18/05/2020', '2020-20', '807', '4', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '5.39');
INSERT INTO public.europe_data_import VALUES (6562, '11/05/2020', '2020-19', '1160', '14', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '5.48');
INSERT INTO public.europe_data_import VALUES (6563, '04/05/2020', '2020-18', '838', '13', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '5.62');
INSERT INTO public.europe_data_import VALUES (6564, '27/04/2020', '2020-17', '1210', '20', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '6.59');
INSERT INTO public.europe_data_import VALUES (6565, '20/04/2020', '2020-16', '1194', '23', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '5.03');
INSERT INTO public.europe_data_import VALUES (6566, '13/04/2020', '2020-15', '640', '48', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '3.24');
INSERT INTO public.europe_data_import VALUES (6567, '06/04/2020', '2020-14', '542', '44', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '2.48');
INSERT INTO public.europe_data_import VALUES (6568, '30/03/2020', '2020-13', '364', '22', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '1.24');
INSERT INTO public.europe_data_import VALUES (6569, '23/03/2020', '2020-12', '87', '3', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6570, '16/03/2020', '2020-11', '28', '1', '36471766', 'Morocco', 'MA', 'MAR', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (6571, '01/02/2021', '2021-04', '6679', '23', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '42.51');
INSERT INTO public.europe_data_import VALUES (6572, '25/01/2021', '2021-03', '6230', '122', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '34.4');
INSERT INTO public.europe_data_import VALUES (6573, '18/01/2021', '2021-02', '4217', '44', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '23.85');
INSERT INTO public.europe_data_import VALUES (6574, '11/01/2021', '2021-01', '3025', '28', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '13.25');
INSERT INTO public.europe_data_import VALUES (6575, '04/01/2021', '2020-53', '999', '7', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '5.73');
INSERT INTO public.europe_data_import VALUES (6576, '28/12/2020', '2020-52', '742', '14', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '4.47');
INSERT INTO public.europe_data_import VALUES (6577, '21/12/2020', '2020-51', '614', '6', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '4.36');
INSERT INTO public.europe_data_import VALUES (6578, '14/12/2020', '2020-50', '710', '9', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '4.42');
INSERT INTO public.europe_data_import VALUES (6579, '07/12/2020', '2020-49', '631', '3', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '3.97');
INSERT INTO public.europe_data_import VALUES (6580, '30/11/2020', '2020-48', '576', '6', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '3.84');
INSERT INTO public.europe_data_import VALUES (6581, '23/11/2020', '2020-47', '589', '11', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '4.18');
INSERT INTO public.europe_data_import VALUES (6582, '16/11/2020', '2020-46', '680', '14', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '4.81');
INSERT INTO public.europe_data_import VALUES (6583, '09/11/2020', '2020-45', '780', '6', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '5.87');
INSERT INTO public.europe_data_import VALUES (6584, '02/11/2020', '2020-44', '1002', '7', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '6.99');
INSERT INTO public.europe_data_import VALUES (6585, '26/10/2020', '2020-43', '1120', '11', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '6.54');
INSERT INTO public.europe_data_import VALUES (6586, '19/10/2020', '2020-42', '865', '4', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '5.5');
INSERT INTO public.europe_data_import VALUES (6587, '12/10/2020', '2020-41', '805', '5', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '6.65');
INSERT INTO public.europe_data_import VALUES (6588, '05/10/2020', '2020-40', '1213', '8', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '7.99');
INSERT INTO public.europe_data_import VALUES (6589, '28/09/2020', '2020-39', '1212', '15', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '8.94');
INSERT INTO public.europe_data_import VALUES (6590, '21/09/2020', '2020-38', '1502', '8', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '7.66');
INSERT INTO public.europe_data_import VALUES (6591, '14/09/2020', '2020-37', '825', '8', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '4.77');
INSERT INTO public.europe_data_import VALUES (6592, '07/09/2020', '2020-36', '623', '4', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '3.45');
INSERT INTO public.europe_data_import VALUES (6593, '31/08/2020', '2020-35', '426', '3', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '3.18');
INSERT INTO public.europe_data_import VALUES (6594, '24/08/2020', '2020-34', '540', '1', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '3.71');
INSERT INTO public.europe_data_import VALUES (6595, '17/08/2020', '2020-33', '586', '3', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '2.99');
INSERT INTO public.europe_data_import VALUES (6596, '10/08/2020', '2020-32', '323', '3', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '1.98');
INSERT INTO public.europe_data_import VALUES (6597, '03/08/2020', '2020-31', '277', '2', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '1.5');
INSERT INTO public.europe_data_import VALUES (6598, '27/07/2020', '2020-30', '178', '1', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '1.69');
INSERT INTO public.europe_data_import VALUES (6599, '20/07/2020', '2020-29', '334', '1', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '1.66');
INSERT INTO public.europe_data_import VALUES (6600, '13/07/2020', '2020-28', '170', '1', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.98');
INSERT INTO public.europe_data_import VALUES (6601, '06/07/2020', '2020-27', '128', '3', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.84');
INSERT INTO public.europe_data_import VALUES (6602, '29/06/2020', '2020-26', '126', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.91');
INSERT INTO public.europe_data_import VALUES (6603, '22/06/2020', '2020-25', '150', '2', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '1.01');
INSERT INTO public.europe_data_import VALUES (6604, '15/06/2020', '2020-24', '157', '1', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '1.08');
INSERT INTO public.europe_data_import VALUES (6605, '08/06/2020', '2020-23', '172', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.76');
INSERT INTO public.europe_data_import VALUES (6606, '01/06/2020', '2020-22', '60', '2', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.39');
INSERT INTO public.europe_data_import VALUES (6607, '25/05/2020', '2020-21', '57', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (6608, '18/05/2020', '2020-20', '46', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.19');
INSERT INTO public.europe_data_import VALUES (6609, '11/05/2020', '2020-19', '11', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (6610, '04/05/2020', '2020-18', '4', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (6611, '27/04/2020', '2020-17', '37', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (6612, '20/04/2020', '2020-16', '18', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (6613, '13/04/2020', '2020-15', '11', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (6614, '06/04/2020', '2020-14', '2', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (6615, '30/03/2020', '2020-13', '7', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (6616, '23/03/2020', '2020-12', '1', '0', '30366043', 'Mozambique', 'MZ', 'MOZ', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (6617, '01/02/2021', '2021-04', '2571', '69', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '10.78');
INSERT INTO public.europe_data_import VALUES (6618, '25/01/2021', '2021-03', '3256', '107', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '12.9');
INSERT INTO public.europe_data_import VALUES (6619, '18/01/2021', '2021-02', '3714', '109', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '14.75');
INSERT INTO public.europe_data_import VALUES (6620, '11/01/2021', '2021-01', '4259', '118', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '16.13');
INSERT INTO public.europe_data_import VALUES (6621, '04/01/2021', '2020-53', '4459', '127', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '18.89');
INSERT INTO public.europe_data_import VALUES (6622, '28/12/2020', '2020-52', '5752', '158', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '25.06');
INSERT INTO public.europe_data_import VALUES (6623, '21/12/2020', '2020-51', '7792', '175', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '31.42');
INSERT INTO public.europe_data_import VALUES (6624, '14/12/2020', '2020-50', '9187', '158', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '34.89');
INSERT INTO public.europe_data_import VALUES (6625, '07/12/2020', '2020-49', '9669', '192', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '36.84');
INSERT INTO public.europe_data_import VALUES (6626, '30/11/2020', '2020-48', '10240', '179', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '37.92');
INSERT INTO public.europe_data_import VALUES (6627, '23/11/2020', '2020-47', '10252', '162', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '33.06');
INSERT INTO public.europe_data_import VALUES (6628, '16/11/2020', '2020-46', '7617', '157', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '28.84');
INSERT INTO public.europe_data_import VALUES (6629, '09/11/2020', '2020-45', '7972', '162', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '30.72');
INSERT INTO public.europe_data_import VALUES (6630, '02/11/2020', '2020-44', '8631', '163', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '32.16');
INSERT INTO public.europe_data_import VALUES (6631, '26/10/2020', '2020-43', '8749', '215', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '31.08');
INSERT INTO public.europe_data_import VALUES (6632, '19/10/2020', '2020-42', '8051', '234', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '33.73');
INSERT INTO public.europe_data_import VALUES (6633, '12/10/2020', '2020-41', '10180', '234', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '31.9');
INSERT INTO public.europe_data_import VALUES (6634, '05/10/2020', '2020-40', '7060', '186', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '22.18');
INSERT INTO public.europe_data_import VALUES (6635, '28/09/2020', '2020-39', '4929', '132', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '14.28');
INSERT INTO public.europe_data_import VALUES (6636, '21/09/2020', '2020-38', '2790', '70', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '8.03');
INSERT INTO public.europe_data_import VALUES (6637, '14/09/2020', '2020-37', '1551', '16', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '4.12');
INSERT INTO public.europe_data_import VALUES (6638, '07/09/2020', '2020-36', '677', '2', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '1.85');
INSERT INTO public.europe_data_import VALUES (6639, '31/08/2020', '2020-35', '324', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.76');
INSERT INTO public.europe_data_import VALUES (6640, '24/08/2020', '2020-34', '88', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.19');
INSERT INTO public.europe_data_import VALUES (6641, '17/08/2020', '2020-33', '15', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (6642, '10/08/2020', '2020-32', '7', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (6643, '03/08/2020', '2020-31', '3', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (6644, '27/07/2020', '2020-30', '9', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (6645, '20/07/2020', '2020-29', '10', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (6646, '13/07/2020', '2020-28', '18', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6647, '06/07/2020', '2020-27', '14', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (6648, '29/06/2020', '2020-26', '9', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (6649, '22/06/2020', '2020-25', '28', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (6650, '15/06/2020', '2020-24', '19', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6651, '08/06/2020', '2020-23', '15', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (6652, '01/06/2020', '2020-22', '27', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (6653, '25/05/2020', '2020-21', '14', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (6654, '18/05/2020', '2020-20', '7', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6655, '11/05/2020', '2020-19', '25', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6656, '04/05/2020', '2020-18', '9', '1', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (6657, '27/04/2020', '2020-17', '35', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.19');
INSERT INTO public.europe_data_import VALUES (6658, '20/04/2020', '2020-16', '70', '1', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (6659, '13/04/2020', '2020-15', '20', '3', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (6660, '06/04/2020', '2020-14', '13', '1', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (6661, '30/03/2020', '2020-13', '8', '0', '54045422', 'Myanmar', 'MM', 'MMR', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (6662, '01/02/2021', '2021-04', '1743', '34', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '152.53');
INSERT INTO public.europe_data_import VALUES (6663, '25/01/2021', '2021-03', '2062', '34', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '153.26');
INSERT INTO public.europe_data_import VALUES (6664, '18/01/2021', '2021-02', '1761', '24', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '199.52');
INSERT INTO public.europe_data_import VALUES (6665, '11/01/2021', '2021-01', '3216', '43', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '253.15');
INSERT INTO public.europe_data_import VALUES (6666, '04/01/2021', '2020-53', '3099', '25', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '267.47');
INSERT INTO public.europe_data_import VALUES (6667, '28/12/2020', '2020-52', '3573', '16', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '230.54');
INSERT INTO public.europe_data_import VALUES (6668, '21/12/2020', '2020-51', '2178', '17', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '145.76');
INSERT INTO public.europe_data_import VALUES (6669, '14/12/2020', '2020-50', '1458', '8', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '87.83');
INSERT INTO public.europe_data_import VALUES (6670, '07/12/2020', '2020-49', '733', '1', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '48.63');
INSERT INTO public.europe_data_import VALUES (6671, '30/11/2020', '2020-48', '480', '6', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '33.55');
INSERT INTO public.europe_data_import VALUES (6672, '23/11/2020', '2020-47', '357', '7', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '26.22');
INSERT INTO public.europe_data_import VALUES (6673, '16/11/2020', '2020-46', '297', '4', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '20.85');
INSERT INTO public.europe_data_import VALUES (6674, '09/11/2020', '2020-45', '223', '1', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '22.09');
INSERT INTO public.europe_data_import VALUES (6675, '02/11/2020', '2020-44', '328', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '27.86');
INSERT INTO public.europe_data_import VALUES (6676, '26/10/2020', '2020-43', '367', '2', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '29.02');
INSERT INTO public.europe_data_import VALUES (6677, '19/10/2020', '2020-42', '357', '3', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '26.74');
INSERT INTO public.europe_data_import VALUES (6678, '12/10/2020', '2020-41', '310', '5', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '36.2');
INSERT INTO public.europe_data_import VALUES (6679, '05/10/2020', '2020-40', '593', '4', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '50.07');
INSERT INTO public.europe_data_import VALUES (6680, '28/09/2020', '2020-39', '656', '7', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '52.68');
INSERT INTO public.europe_data_import VALUES (6681, '21/09/2020', '2020-38', '658', '11', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '67.83');
INSERT INTO public.europe_data_import VALUES (6682, '14/09/2020', '2020-37', '1034', '12', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '94.37');
INSERT INTO public.europe_data_import VALUES (6683, '07/09/2020', '2020-36', '1320', '17', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '113.49');
INSERT INTO public.europe_data_import VALUES (6684, '31/08/2020', '2020-35', '1511', '20', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '128.72');
INSERT INTO public.europe_data_import VALUES (6685, '24/08/2020', '2020-34', '1700', '17', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '116.46');
INSERT INTO public.europe_data_import VALUES (6686, '17/08/2020', '2020-33', '1205', '16', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '74.56');
INSERT INTO public.europe_data_import VALUES (6687, '10/08/2020', '2020-32', '655', '8', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '47.06');
INSERT INTO public.europe_data_import VALUES (6688, '03/08/2020', '2020-31', '519', '3', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '41.97');
INSERT INTO public.europe_data_import VALUES (6689, '27/07/2020', '2020-30', '528', '5', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '39.69');
INSERT INTO public.europe_data_import VALUES (6690, '20/07/2020', '2020-29', '462', '2', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '33.47');
INSERT INTO public.europe_data_import VALUES (6691, '13/07/2020', '2020-28', '373', '1', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '24.13');
INSERT INTO public.europe_data_import VALUES (6692, '06/07/2020', '2020-27', '229', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '14.31');
INSERT INTO public.europe_data_import VALUES (6693, '29/06/2020', '2020-26', '128', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '6.05');
INSERT INTO public.europe_data_import VALUES (6694, '22/06/2020', '2020-25', '23', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '1.04');
INSERT INTO public.europe_data_import VALUES (6695, '15/06/2020', '2020-24', '3', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6696, '08/06/2020', '2020-23', '5', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6697, '01/06/2020', '2020-22', '3', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (6698, '25/05/2020', '2020-21', '5', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (6699, '18/05/2020', '2020-20', '0', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6700, '11/05/2020', '2020-19', '0', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6701, '04/05/2020', '2020-18', '0', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6702, '27/04/2020', '2020-17', '0', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6703, '20/04/2020', '2020-16', '0', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (6704, '13/04/2020', '2020-15', '0', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (6705, '06/04/2020', '2020-14', '5', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (6706, '30/03/2020', '2020-13', '8', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.36');
INSERT INTO public.europe_data_import VALUES (6707, '23/03/2020', '2020-12', '1', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (6708, '16/03/2020', '2020-11', '2', '0', '2494524', 'Namibia', 'NA', 'NAM', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (6709, '01/02/2021', '2021-04', '1509', '28', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '12.71');
INSERT INTO public.europe_data_import VALUES (6710, '25/01/2021', '2021-03', '2128', '42', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '16.32');
INSERT INTO public.europe_data_import VALUES (6711, '18/01/2021', '2021-02', '2542', '42', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '19.1');
INSERT INTO public.europe_data_import VALUES (6712, '11/01/2021', '2021-01', '2921', '39', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '23.07');
INSERT INTO public.europe_data_import VALUES (6713, '04/01/2021', '2020-53', '3678', '53', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '28.27');
INSERT INTO public.europe_data_import VALUES (6714, '28/12/2020', '2020-52', '4409', '37', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '34.11');
INSERT INTO public.europe_data_import VALUES (6715, '21/12/2020', '2020-51', '5349', '90', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '44.71');
INSERT INTO public.europe_data_import VALUES (6716, '14/12/2020', '2020-50', '7442', '104', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '57.48');
INSERT INTO public.europe_data_import VALUES (6717, '07/12/2020', '2020-49', '9003', '115', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '72.26');
INSERT INTO public.europe_data_import VALUES (6718, '30/11/2020', '2020-48', '11670', '158', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '77.61');
INSERT INTO public.europe_data_import VALUES (6719, '23/11/2020', '2020-47', '10532', '100', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '90.37');
INSERT INTO public.europe_data_import VALUES (6720, '16/11/2020', '2020-46', '15323', '113', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '126.57');
INSERT INTO public.europe_data_import VALUES (6721, '09/11/2020', '2020-45', '20886', '148', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '127.11');
INSERT INTO public.europe_data_import VALUES (6722, '02/11/2020', '2020-44', '15478', '113', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '144.44');
INSERT INTO public.europe_data_import VALUES (6723, '26/10/2020', '2020-43', '25843', '108', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '175.94');
INSERT INTO public.europe_data_import VALUES (6724, '19/10/2020', '2020-42', '24491', '103', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '158.77');
INSERT INTO public.europe_data_import VALUES (6725, '12/10/2020', '2020-41', '20932', '101', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '120.11');
INSERT INTO public.europe_data_import VALUES (6726, '05/10/2020', '2020-40', '13429', '58', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '79.35');
INSERT INTO public.europe_data_import VALUES (6727, '28/09/2020', '2020-39', '9272', '66', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '67.23');
INSERT INTO public.europe_data_import VALUES (6728, '21/09/2020', '2020-38', '9963', '66', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '62.45');
INSERT INTO public.europe_data_import VALUES (6729, '14/09/2020', '2020-37', '7902', '56', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '54.52');
INSERT INTO public.europe_data_import VALUES (6730, '07/09/2020', '2020-36', '7696', '68', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '50.06');
INSERT INTO public.europe_data_import VALUES (6731, '31/08/2020', '2020-35', '6626', '72', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '41.6');
INSERT INTO public.europe_data_import VALUES (6732, '24/08/2020', '2020-34', '5275', '45', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '31.33');
INSERT INTO public.europe_data_import VALUES (6733, '17/08/2020', '2020-33', '3688', '29', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '22.12');
INSERT INTO public.europe_data_import VALUES (6734, '10/08/2020', '2020-32', '2640', '18', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '15.24');
INSERT INTO public.europe_data_import VALUES (6735, '03/08/2020', '2020-31', '1719', '12', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '9.35');
INSERT INTO public.europe_data_import VALUES (6736, '27/07/2020', '2020-30', '955', '5', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '6.33');
INSERT INTO public.europe_data_import VALUES (6737, '20/07/2020', '2020-29', '857', '2', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '6.55');
INSERT INTO public.europe_data_import VALUES (6738, '13/07/2020', '2020-28', '1017', '4', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '14.08');
INSERT INTO public.europe_data_import VALUES (6739, '06/07/2020', '2020-27', '3012', '6', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '23.62');
INSERT INTO public.europe_data_import VALUES (6740, '29/06/2020', '2020-26', '3746', '5', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '24.51');
INSERT INTO public.europe_data_import VALUES (6741, '22/06/2020', '2020-25', '3266', '4', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '19.5');
INSERT INTO public.europe_data_import VALUES (6742, '15/06/2020', '2020-24', '2312', '6', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '14.64');
INSERT INTO public.europe_data_import VALUES (6743, '08/06/2020', '2020-23', '1876', '5', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '9.94');
INSERT INTO public.europe_data_import VALUES (6744, '01/06/2020', '2020-22', '969', '5', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '4.43');
INSERT INTO public.europe_data_import VALUES (6745, '25/05/2020', '2020-21', '299', '1', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '1.69');
INSERT INTO public.europe_data_import VALUES (6746, '18/05/2020', '2020-20', '184', '2', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.8');
INSERT INTO public.europe_data_import VALUES (6747, '11/05/2020', '2020-19', '45', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.24');
INSERT INTO public.europe_data_import VALUES (6748, '04/05/2020', '2020-18', '23', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (6749, '27/04/2020', '2020-17', '21', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.14');
INSERT INTO public.europe_data_import VALUES (6750, '20/04/2020', '2020-16', '19', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (6751, '13/04/2020', '2020-15', '3', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (6752, '06/04/2020', '2020-14', '4', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (6753, '30/03/2020', '2020-13', '4', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (6754, '23/03/2020', '2020-12', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6755, '16/03/2020', '2020-11', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6756, '09/03/2020', '2020-10', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6757, '02/03/2020', '2020-09', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6758, '24/02/2020', '2020-08', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6759, '17/02/2020', '2020-07', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6760, '10/02/2020', '2020-06', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6761, '03/02/2020', '2020-05', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (6762, '27/01/2020', '2020-04', '1', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (6763, '20/01/2020', '2020-03', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6764, '13/01/2020', '2020-02', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (6765, '06/01/2020', '2020-01', '0', '0', '28608715', 'Nepal', 'NP', 'NPL', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (6766, '01/02/2021', '2021-04', '28671', '445', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '371.83');
INSERT INTO public.europe_data_import VALUES (6767, '25/01/2021', '2021-03', '35590', '522', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '431.41');
INSERT INTO public.europe_data_import VALUES (6768, '18/01/2021', '2021-02', '38967', '645', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '555.45');
INSERT INTO public.europe_data_import VALUES (6769, '11/01/2021', '2021-01', '57026', '799', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '623.33');
INSERT INTO public.europe_data_import VALUES (6770, '04/01/2021', '2020-53', '50699', '570', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '759.7');
INSERT INTO public.europe_data_import VALUES (6771, '28/12/2020', '2020-52', '80594', '551', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '906.99');
INSERT INTO public.europe_data_import VALUES (6772, '21/12/2020', '2020-51', '76154', '443', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '765.8');
INSERT INTO public.europe_data_import VALUES (6773, '14/12/2020', '2020-50', '56193', '360', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '546.65');
INSERT INTO public.europe_data_import VALUES (6774, '07/12/2020', '2020-49', '38280', '338', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '419.47');
INSERT INTO public.europe_data_import VALUES (6775, '30/11/2020', '2020-48', '34213', '457', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '410.47');
INSERT INTO public.europe_data_import VALUES (6776, '23/11/2020', '2020-47', '36725', '404', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '431.01');
INSERT INTO public.europe_data_import VALUES (6777, '16/11/2020', '2020-46', '37762', '481', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '508.61');
INSERT INTO public.europe_data_import VALUES (6778, '09/11/2020', '2020-45', '50136', '570', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '686.53');
INSERT INTO public.europe_data_import VALUES (6779, '02/11/2020', '2020-44', '68512', '388', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '759.18');
INSERT INTO public.europe_data_import VALUES (6780, '26/10/2020', '2020-43', '62691', '285', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '673.96');
INSERT INTO public.europe_data_import VALUES (6781, '19/10/2020', '2020-42', '53784', '176', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '535.15');
INSERT INTO public.europe_data_import VALUES (6782, '12/10/2020', '2020-41', '38701', '130', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '364.19');
INSERT INTO public.europe_data_import VALUES (6783, '05/10/2020', '2020-40', '24239', '80', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '243.4');
INSERT INTO public.europe_data_import VALUES (6784, '28/09/2020', '2020-39', '17826', '95', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '170.62');
INSERT INTO public.europe_data_import VALUES (6785, '21/09/2020', '2020-38', '11661', '25', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '109.76');
INSERT INTO public.europe_data_import VALUES (6786, '14/09/2020', '2020-37', '7308', '11', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '69.16');
INSERT INTO public.europe_data_import VALUES (6787, '07/09/2020', '2020-36', '4644', '19', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '47.59');
INSERT INTO public.europe_data_import VALUES (6788, '31/08/2020', '2020-35', '3581', '24', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '41.24');
INSERT INTO public.europe_data_import VALUES (6789, '24/08/2020', '2020-34', '3547', '28', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '45.86');
INSERT INTO public.europe_data_import VALUES (6790, '17/08/2020', '2020-33', '4379', '15', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '45.71');
INSERT INTO public.europe_data_import VALUES (6791, '10/08/2020', '2020-32', '3521', '8', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '32.51');
INSERT INTO public.europe_data_import VALUES (6792, '03/08/2020', '2020-31', '2097', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '19.2');
INSERT INTO public.europe_data_import VALUES (6793, '27/07/2020', '2020-30', '1221', '4', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '11.13');
INSERT INTO public.europe_data_import VALUES (6794, '20/07/2020', '2020-29', '703', '1', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '6.39');
INSERT INTO public.europe_data_import VALUES (6795, '13/07/2020', '2020-28', '401', '8', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '5.06');
INSERT INTO public.europe_data_import VALUES (6796, '06/07/2020', '2020-27', '474', '22', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '5.95');
INSERT INTO public.europe_data_import VALUES (6797, '29/06/2020', '2020-26', '554', '15', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '7.89');
INSERT INTO public.europe_data_import VALUES (6798, '22/06/2020', '2020-25', '810', '31', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '11.68');
INSERT INTO public.europe_data_import VALUES (6799, '15/06/2020', '2020-24', '1209', '46', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '13.55');
INSERT INTO public.europe_data_import VALUES (6800, '08/06/2020', '2020-23', '1132', '57', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '13.53');
INSERT INTO public.europe_data_import VALUES (6801, '01/06/2020', '2020-22', '1206', '134', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '14.16');
INSERT INTO public.europe_data_import VALUES (6802, '25/05/2020', '2020-21', '1241', '142', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '15.1');
INSERT INTO public.europe_data_import VALUES (6803, '18/05/2020', '2020-20', '1368', '240', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '19.81');
INSERT INTO public.europe_data_import VALUES (6804, '11/05/2020', '2020-19', '2056', '384', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '27.67');
INSERT INTO public.europe_data_import VALUES (6805, '04/05/2020', '2020-18', '2726', '581', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '45.8');
INSERT INTO public.europe_data_import VALUES (6806, '27/04/2020', '2020-17', '5190', '791', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '70.93');
INSERT INTO public.europe_data_import VALUES (6807, '20/04/2020', '2020-16', '7068', '947', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '85.66');
INSERT INTO public.europe_data_import VALUES (6808, '13/04/2020', '2020-15', '7736', '971', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '85.18');
INSERT INTO public.europe_data_import VALUES (6809, '06/04/2020', '2020-14', '6985', '995', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '78.97');
INSERT INTO public.europe_data_import VALUES (6810, '30/03/2020', '2020-13', '6662', '592', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '56.31');
INSERT INTO public.europe_data_import VALUES (6811, '23/03/2020', '2020-12', '3069', '159', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '22.79');
INSERT INTO public.europe_data_import VALUES (6812, '16/03/2020', '2020-11', '870', '17', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '6.49');
INSERT INTO public.europe_data_import VALUES (6813, '09/03/2020', '2020-10', '252', '3', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '1.53');
INSERT INTO public.europe_data_import VALUES (6814, '02/03/2020', '2020-09', '13', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0.08');
INSERT INTO public.europe_data_import VALUES (6815, '24/02/2020', '2020-08', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6816, '17/02/2020', '2020-07', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6817, '10/02/2020', '2020-06', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6818, '03/02/2020', '2020-05', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6819, '27/01/2020', '2020-04', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6820, '20/01/2020', '2020-03', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6821, '13/01/2020', '2020-02', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (6822, '06/01/2020', '2020-01', '0', '0', '17282163', 'Netherlands', 'NL', 'NLD', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (6823, '01/02/2021', '2021-04', '3', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6824, '25/01/2021', '2021-03', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.41');
INSERT INTO public.europe_data_import VALUES (6825, '18/01/2021', '2021-02', '4', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.41');
INSERT INTO public.europe_data_import VALUES (6826, '11/01/2021', '2021-01', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6827, '04/01/2021', '2020-53', '2', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6828, '28/12/2020', '2020-52', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6829, '21/12/2020', '2020-51', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6830, '14/12/2020', '2020-50', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.41');
INSERT INTO public.europe_data_import VALUES (6831, '07/12/2020', '2020-49', '3', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6832, '30/11/2020', '2020-48', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6833, '23/11/2020', '2020-47', '2', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6834, '16/11/2020', '2020-46', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6835, '09/11/2020', '2020-45', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6836, '02/11/2020', '2020-44', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6837, '26/10/2020', '2020-43', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6838, '19/10/2020', '2020-42', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6839, '12/10/2020', '2020-41', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6840, '05/10/2020', '2020-40', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6841, '28/09/2020', '2020-39', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6842, '21/09/2020', '2020-38', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6843, '14/09/2020', '2020-37', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6844, '07/09/2020', '2020-36', '3', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6845, '31/08/2020', '2020-35', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6846, '24/08/2020', '2020-34', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6847, '17/08/2020', '2020-33', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6848, '10/08/2020', '2020-32', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6849, '03/08/2020', '2020-31', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6850, '27/07/2020', '2020-30', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6851, '20/07/2020', '2020-29', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6852, '13/07/2020', '2020-28', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6853, '06/07/2020', '2020-27', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6854, '29/06/2020', '2020-26', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6855, '22/06/2020', '2020-25', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6856, '15/06/2020', '2020-24', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6857, '08/06/2020', '2020-23', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.71');
INSERT INTO public.europe_data_import VALUES (6858, '01/06/2020', '2020-22', '1', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (6859, '25/05/2020', '2020-21', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6860, '18/05/2020', '2020-20', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6861, '11/05/2020', '2020-19', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6862, '04/05/2020', '2020-18', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6863, '27/04/2020', '2020-17', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6864, '20/04/2020', '2020-16', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6865, '13/04/2020', '2020-15', '0', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (6866, '06/04/2020', '2020-14', '3', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '4.6');
INSERT INTO public.europe_data_import VALUES (6867, '30/03/2020', '2020-13', '10', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '5.3');
INSERT INTO public.europe_data_import VALUES (6868, '23/03/2020', '2020-12', '5', '0', '282757', 'New_Caledonia', 'NC', 'NCL', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (6869, '01/02/2021', '2021-04', '15', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.86');
INSERT INTO public.europe_data_import VALUES (6870, '25/01/2021', '2021-03', '26', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.38');
INSERT INTO public.europe_data_import VALUES (6871, '18/01/2021', '2021-02', '40', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.69');
INSERT INTO public.europe_data_import VALUES (6872, '11/01/2021', '2021-01', '41', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.63');
INSERT INTO public.europe_data_import VALUES (6873, '04/01/2021', '2020-53', '37', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.25');
INSERT INTO public.europe_data_import VALUES (6874, '28/12/2020', '2020-52', '23', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.0');
INSERT INTO public.europe_data_import VALUES (6875, '21/12/2020', '2020-51', '25', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.88');
INSERT INTO public.europe_data_import VALUES (6876, '14/12/2020', '2020-50', '17', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.84');
INSERT INTO public.europe_data_import VALUES (6877, '07/12/2020', '2020-49', '23', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.02');
INSERT INTO public.europe_data_import VALUES (6878, '30/11/2020', '2020-48', '26', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.15');
INSERT INTO public.europe_data_import VALUES (6879, '23/11/2020', '2020-47', '29', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.92');
INSERT INTO public.europe_data_import VALUES (6880, '16/11/2020', '2020-46', '15', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.79');
INSERT INTO public.europe_data_import VALUES (6881, '09/11/2020', '2020-45', '23', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.96');
INSERT INTO public.europe_data_import VALUES (6882, '02/11/2020', '2020-44', '23', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.61');
INSERT INTO public.europe_data_import VALUES (6883, '26/10/2020', '2020-43', '54', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.44');
INSERT INTO public.europe_data_import VALUES (6884, '19/10/2020', '2020-42', '15', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.65');
INSERT INTO public.europe_data_import VALUES (6885, '12/10/2020', '2020-41', '16', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.79');
INSERT INTO public.europe_data_import VALUES (6886, '05/10/2020', '2020-40', '22', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.73');
INSERT INTO public.europe_data_import VALUES (6887, '28/09/2020', '2020-39', '13', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.63');
INSERT INTO public.europe_data_import VALUES (6888, '21/09/2020', '2020-38', '17', '1', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.82');
INSERT INTO public.europe_data_import VALUES (6889, '14/09/2020', '2020-37', '22', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.25');
INSERT INTO public.europe_data_import VALUES (6890, '07/09/2020', '2020-36', '38', '2', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.94');
INSERT INTO public.europe_data_import VALUES (6891, '31/08/2020', '2020-35', '55', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '2.24');
INSERT INTO public.europe_data_import VALUES (6892, '24/08/2020', '2020-34', '52', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '2.36');
INSERT INTO public.europe_data_import VALUES (6893, '17/08/2020', '2020-33', '61', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.32');
INSERT INTO public.europe_data_import VALUES (6894, '10/08/2020', '2020-32', '2', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.27');
INSERT INTO public.europe_data_import VALUES (6895, '03/08/2020', '2020-31', '11', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.27');
INSERT INTO public.europe_data_import VALUES (6896, '27/07/2020', '2020-30', '2', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.25');
INSERT INTO public.europe_data_import VALUES (6897, '20/07/2020', '2020-29', '10', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.44');
INSERT INTO public.europe_data_import VALUES (6898, '13/07/2020', '2020-28', '11', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.33');
INSERT INTO public.europe_data_import VALUES (6899, '06/07/2020', '2020-27', '5', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.42');
INSERT INTO public.europe_data_import VALUES (6900, '29/06/2020', '2020-26', '15', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.5');
INSERT INTO public.europe_data_import VALUES (6901, '22/06/2020', '2020-25', '9', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.19');
INSERT INTO public.europe_data_import VALUES (6902, '15/06/2020', '2020-24', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6903, '08/06/2020', '2020-23', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6904, '01/06/2020', '2020-22', '0', '1', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.1');
INSERT INTO public.europe_data_import VALUES (6905, '25/05/2020', '2020-21', '5', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.15');
INSERT INTO public.europe_data_import VALUES (6906, '18/05/2020', '2020-20', '2', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.25');
INSERT INTO public.europe_data_import VALUES (6907, '11/05/2020', '2020-19', '10', '1', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.52');
INSERT INTO public.europe_data_import VALUES (6908, '04/05/2020', '2020-18', '15', '1', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.67');
INSERT INTO public.europe_data_import VALUES (6909, '27/04/2020', '2020-17', '17', '7', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '1.21');
INSERT INTO public.europe_data_import VALUES (6910, '20/04/2020', '2020-16', '41', '7', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '4.06');
INSERT INTO public.europe_data_import VALUES (6911, '13/04/2020', '2020-15', '153', '4', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '10.7');
INSERT INTO public.europe_data_import VALUES (6912, '06/04/2020', '2020-14', '359', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '16.91');
INSERT INTO public.europe_data_import VALUES (6913, '30/03/2020', '2020-13', '450', '1', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '11.37');
INSERT INTO public.europe_data_import VALUES (6914, '23/03/2020', '2020-12', '94', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '2.03');
INSERT INTO public.europe_data_import VALUES (6915, '16/03/2020', '2020-11', '3', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.15');
INSERT INTO public.europe_data_import VALUES (6916, '09/03/2020', '2020-10', '4', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.1');
INSERT INTO public.europe_data_import VALUES (6917, '02/03/2020', '2020-09', '1', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0.02');
INSERT INTO public.europe_data_import VALUES (6918, '24/02/2020', '2020-08', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6919, '17/02/2020', '2020-07', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6920, '10/02/2020', '2020-06', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6921, '03/02/2020', '2020-05', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6922, '27/01/2020', '2020-04', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6923, '20/01/2020', '2020-03', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6924, '13/01/2020', '2020-02', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (6925, '06/01/2020', '2020-01', '0', '0', '4783062', 'New_Zealand', 'NZ', 'NZL', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (6926, '01/02/2021', '2021-04', '49', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.54');
INSERT INTO public.europe_data_import VALUES (6927, '25/01/2021', '2021-03', '52', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.63');
INSERT INTO public.europe_data_import VALUES (6928, '18/01/2021', '2021-02', '55', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.62');
INSERT INTO public.europe_data_import VALUES (6929, '11/01/2021', '2021-01', '51', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.62');
INSERT INTO public.europe_data_import VALUES (6930, '04/01/2021', '2020-53', '55', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.65');
INSERT INTO public.europe_data_import VALUES (6931, '28/12/2020', '2020-52', '53', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.59');
INSERT INTO public.europe_data_import VALUES (6932, '21/12/2020', '2020-51', '51', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.53');
INSERT INTO public.europe_data_import VALUES (6933, '14/12/2020', '2020-50', '49', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.57');
INSERT INTO public.europe_data_import VALUES (6934, '07/12/2020', '2020-49', '54', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.73');
INSERT INTO public.europe_data_import VALUES (6935, '30/11/2020', '2020-48', '59', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '1.88');
INSERT INTO public.europe_data_import VALUES (6936, '23/11/2020', '2020-47', '64', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.05');
INSERT INTO public.europe_data_import VALUES (6937, '16/11/2020', '2020-46', '70', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.25');
INSERT INTO public.europe_data_import VALUES (6938, '09/11/2020', '2020-45', '77', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.4');
INSERT INTO public.europe_data_import VALUES (6939, '02/11/2020', '2020-44', '80', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.46');
INSERT INTO public.europe_data_import VALUES (6940, '26/10/2020', '2020-43', '81', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.6');
INSERT INTO public.europe_data_import VALUES (6941, '19/10/2020', '2020-42', '89', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.8');
INSERT INTO public.europe_data_import VALUES (6942, '12/10/2020', '2020-41', '94', '2', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '2.92');
INSERT INTO public.europe_data_import VALUES (6943, '05/10/2020', '2020-40', '97', '2', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '3.19');
INSERT INTO public.europe_data_import VALUES (6944, '28/09/2020', '2020-39', '112', '2', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '3.9');
INSERT INTO public.europe_data_import VALUES (6945, '21/09/2020', '2020-38', '143', '3', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '4.48');
INSERT INTO public.europe_data_import VALUES (6946, '14/09/2020', '2020-37', '150', '3', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '4.95');
INSERT INTO public.europe_data_import VALUES (6947, '07/09/2020', '2020-36', '174', '4', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '5.45');
INSERT INTO public.europe_data_import VALUES (6948, '31/08/2020', '2020-35', '183', '4', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '5.79');
INSERT INTO public.europe_data_import VALUES (6949, '24/08/2020', '2020-34', '196', '5', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '6.25');
INSERT INTO public.europe_data_import VALUES (6950, '17/08/2020', '2020-33', '213', '5', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '6.77');
INSERT INTO public.europe_data_import VALUES (6951, '10/08/2020', '2020-32', '230', '7', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '7.07');
INSERT INTO public.europe_data_import VALUES (6952, '03/08/2020', '2020-31', '233', '8', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '8.02');
INSERT INTO public.europe_data_import VALUES (6953, '27/07/2020', '2020-30', '292', '9', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '9.06');
INSERT INTO public.europe_data_import VALUES (6954, '20/07/2020', '2020-29', '301', '8', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '9.59');
INSERT INTO public.europe_data_import VALUES (6955, '13/07/2020', '2020-28', '327', '8', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '10.33');
INSERT INTO public.europe_data_import VALUES (6956, '06/07/2020', '2020-27', '349', '9', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '7.72');
INSERT INTO public.europe_data_import VALUES (6957, '29/06/2020', '2020-26', '156', '10', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '7.87');
INSERT INTO public.europe_data_import VALUES (6958, '22/06/2020', '2020-25', '359', '9', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '10.77');
INSERT INTO public.europe_data_import VALUES (6959, '15/06/2020', '2020-24', '346', '9', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '13.69');
INSERT INTO public.europe_data_import VALUES (6960, '08/06/2020', '2020-23', '550', '11', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '15.74');
INSERT INTO public.europe_data_import VALUES (6961, '01/06/2020', '2020-22', '480', '18', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '11.21');
INSERT INTO public.europe_data_import VALUES (6962, '25/05/2020', '2020-21', '254', '9', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '4.02');
INSERT INTO public.europe_data_import VALUES (6963, '18/05/2020', '2020-20', '9', '3', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.17');
INSERT INTO public.europe_data_import VALUES (6964, '11/05/2020', '2020-19', '2', '0', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.05');
INSERT INTO public.europe_data_import VALUES (6965, '04/05/2020', '2020-18', '1', '2', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.08');
INSERT INTO public.europe_data_import VALUES (6966, '27/04/2020', '2020-17', '4', '2', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.06');
INSERT INTO public.europe_data_import VALUES (6967, '20/04/2020', '2020-16', '0', '0', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.06');
INSERT INTO public.europe_data_import VALUES (6968, '13/04/2020', '2020-15', '4', '0', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.08');
INSERT INTO public.europe_data_import VALUES (6969, '06/04/2020', '2020-14', '1', '0', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.05');
INSERT INTO public.europe_data_import VALUES (6970, '30/03/2020', '2020-13', '2', '1', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '0.06');
INSERT INTO public.europe_data_import VALUES (6971, '23/03/2020', '2020-12', '2', '0', '6545503', 'Nicaragua', 'NI', 'NIC', 'America', '');
INSERT INTO public.europe_data_import VALUES (6972, '01/02/2021', '2021-04', '184', '10', '23310719', 'Niger', 'NE', 'NER', 'Africa', '1.63');
INSERT INTO public.europe_data_import VALUES (6973, '25/01/2021', '2021-03', '197', '11', '23310719', 'Niger', 'NE', 'NER', 'Africa', '2.04');
INSERT INTO public.europe_data_import VALUES (6974, '18/01/2021', '2021-02', '279', '14', '23310719', 'Niger', 'NE', 'NER', 'Africa', '2.96');
INSERT INTO public.europe_data_import VALUES (6975, '11/01/2021', '2021-01', '412', '16', '23310719', 'Niger', 'NE', 'NER', 'Africa', '3.08');
INSERT INTO public.europe_data_import VALUES (6976, '04/01/2021', '2020-53', '306', '11', '23310719', 'Niger', 'NE', 'NER', 'Africa', '3.46');
INSERT INTO public.europe_data_import VALUES (6977, '28/12/2020', '2020-52', '500', '12', '23310719', 'Niger', 'NE', 'NER', 'Africa', '3.87');
INSERT INTO public.europe_data_import VALUES (6978, '21/12/2020', '2020-51', '401', '7', '23310719', 'Niger', 'NE', 'NER', 'Africa', '3.44');
INSERT INTO public.europe_data_import VALUES (6979, '14/12/2020', '2020-50', '402', '3', '23310719', 'Niger', 'NE', 'NER', 'Africa', '3.18');
INSERT INTO public.europe_data_import VALUES (6980, '07/12/2020', '2020-49', '340', '7', '23310719', 'Niger', 'NE', 'NER', 'Africa', '2.09');
INSERT INTO public.europe_data_import VALUES (6981, '30/11/2020', '2020-48', '148', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.9');
INSERT INTO public.europe_data_import VALUES (6982, '23/11/2020', '2020-47', '61', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.54');
INSERT INTO public.europe_data_import VALUES (6983, '16/11/2020', '2020-46', '64', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (6984, '09/11/2020', '2020-45', '22', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (6985, '02/11/2020', '2020-44', '6', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (6986, '26/10/2020', '2020-43', '5', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (6987, '19/10/2020', '2020-42', '9', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (6988, '12/10/2020', '2020-41', '1', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (6989, '05/10/2020', '2020-40', '4', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (6990, '28/09/2020', '2020-39', '8', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (6991, '21/09/2020', '2020-38', '8', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (6992, '14/09/2020', '2020-37', '3', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (6993, '07/09/2020', '2020-36', '1', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (6994, '31/08/2020', '2020-35', '4', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (6995, '24/08/2020', '2020-34', '5', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (6996, '17/08/2020', '2020-33', '9', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (6997, '10/08/2020', '2020-32', '11', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (6998, '03/08/2020', '2020-31', '15', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (6999, '27/07/2020', '2020-30', '28', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (7000, '20/07/2020', '2020-29', '5', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (7001, '13/07/2020', '2020-28', '6', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (7002, '06/07/2020', '2020-27', '19', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.24');
INSERT INTO public.europe_data_import VALUES (7003, '29/06/2020', '2020-26', '38', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.4');
INSERT INTO public.europe_data_import VALUES (7004, '22/06/2020', '2020-25', '56', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (7005, '15/06/2020', '2020-24', '7', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (7006, '08/06/2020', '2020-23', '15', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (7007, '01/06/2020', '2020-22', '13', '3', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (7008, '25/05/2020', '2020-21', '41', '7', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (7009, '18/05/2020', '2020-20', '83', '8', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.66');
INSERT INTO public.europe_data_import VALUES (7010, '11/05/2020', '2020-19', '71', '10', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.54');
INSERT INTO public.europe_data_import VALUES (7011, '04/05/2020', '2020-18', '54', '7', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (7012, '27/04/2020', '2020-17', '48', '9', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (7013, '20/04/2020', '2020-16', '119', '8', '23310719', 'Niger', 'NE', 'NER', 'Africa', '1.99');
INSERT INTO public.europe_data_import VALUES (7014, '13/04/2020', '2020-15', '345', '2', '23310719', 'Niger', 'NE', 'NER', 'Africa', '2.23');
INSERT INTO public.europe_data_import VALUES (7015, '06/04/2020', '2020-14', '174', '9', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.79');
INSERT INTO public.europe_data_import VALUES (7016, '30/03/2020', '2020-13', '9', '1', '23310719', 'Niger', 'NE', 'NER', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (7017, '23/03/2020', '2020-12', '1', '0', '23310719', 'Niger', 'NE', 'NER', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (7018, '01/02/2021', '2021-04', '8922', '100', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '10.71');
INSERT INTO public.europe_data_import VALUES (7019, '25/01/2021', '2021-03', '12609', '72', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '11.4');
INSERT INTO public.europe_data_import VALUES (7020, '18/01/2021', '2021-02', '10300', '77', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '10.1');
INSERT INTO public.europe_data_import VALUES (7021, '11/01/2021', '2021-01', '10007', '47', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '7.6');
INSERT INTO public.europe_data_import VALUES (7022, '04/01/2021', '2020-53', '5269', '47', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '5.8');
INSERT INTO public.europe_data_import VALUES (7023, '28/12/2020', '2020-52', '6377', '43', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '5.79');
INSERT INTO public.europe_data_import VALUES (7024, '21/12/2020', '2020-51', '5259', '24', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '4.57');
INSERT INTO public.europe_data_import VALUES (7025, '14/12/2020', '2020-50', '3920', '17', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.87');
INSERT INTO public.europe_data_import VALUES (7026, '07/12/2020', '2020-49', '1843', '7', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.43');
INSERT INTO public.europe_data_import VALUES (7027, '30/11/2020', '2020-48', '1029', '6', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.13');
INSERT INTO public.europe_data_import VALUES (7028, '23/11/2020', '2020-47', '1235', '4', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.14');
INSERT INTO public.europe_data_import VALUES (7029, '16/11/2020', '2020-46', '1058', '9', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.09');
INSERT INTO public.europe_data_import VALUES (7030, '09/11/2020', '2020-45', '1126', '8', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.04');
INSERT INTO public.europe_data_import VALUES (7031, '02/11/2020', '2020-44', '972', '16', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.76');
INSERT INTO public.europe_data_import VALUES (7032, '26/10/2020', '2020-43', '552', '5', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.86');
INSERT INTO public.europe_data_import VALUES (7033, '19/10/2020', '2020-42', '1174', '10', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.04');
INSERT INTO public.europe_data_import VALUES (7034, '12/10/2020', '2020-41', '921', '2', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.97');
INSERT INTO public.europe_data_import VALUES (7035, '05/10/2020', '2020-40', '1021', '5', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.05');
INSERT INTO public.europe_data_import VALUES (7036, '28/09/2020', '2020-39', '1082', '10', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (7037, '21/09/2020', '2020-38', '986', '16', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.11');
INSERT INTO public.europe_data_import VALUES (7038, '14/09/2020', '2020-37', '1251', '25', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.19');
INSERT INTO public.europe_data_import VALUES (7039, '07/09/2020', '2020-36', '1140', '44', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.38');
INSERT INTO public.europe_data_import VALUES (7040, '31/08/2020', '2020-35', '1638', '11', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.39');
INSERT INTO public.europe_data_import VALUES (7041, '24/08/2020', '2020-34', '3159', '27', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.81');
INSERT INTO public.europe_data_import VALUES (7042, '17/08/2020', '2020-33', '2491', '30', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.6');
INSERT INTO public.europe_data_import VALUES (7043, '10/08/2020', '2020-32', '2736', '57', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '3.01');
INSERT INTO public.europe_data_import VALUES (7044, '03/08/2020', '2020-31', '3309', '30', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '3.57');
INSERT INTO public.europe_data_import VALUES (7045, '27/07/2020', '2020-30', '3869', '69', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '3.97');
INSERT INTO public.europe_data_import VALUES (7046, '20/07/2020', '2020-29', '4105', '49', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '3.96');
INSERT INTO public.europe_data_import VALUES (7047, '13/07/2020', '2020-28', '3847', '95', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '3.98');
INSERT INTO public.europe_data_import VALUES (7048, '06/07/2020', '2020-27', '4144', '80', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '4.21');
INSERT INTO public.europe_data_import VALUES (7049, '29/06/2020', '2020-26', '4323', '47', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '4.22');
INSERT INTO public.europe_data_import VALUES (7050, '22/06/2020', '2020-25', '4159', '98', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '3.86');
INSERT INTO public.europe_data_import VALUES (7051, '15/06/2020', '2020-24', '3599', '66', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.95');
INSERT INTO public.europe_data_import VALUES (7052, '08/06/2020', '2020-23', '2324', '67', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.31');
INSERT INTO public.europe_data_import VALUES (7053, '01/06/2020', '2020-22', '2323', '61', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '2.09');
INSERT INTO public.europe_data_import VALUES (7054, '25/05/2020', '2020-21', '1880', '44', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.71');
INSERT INTO public.europe_data_import VALUES (7055, '18/05/2020', '2020-20', '1560', '39', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.69');
INSERT INTO public.europe_data_import VALUES (7056, '11/05/2020', '2020-19', '1841', '56', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '1.56');
INSERT INTO public.europe_data_import VALUES (7057, '04/05/2020', '2020-18', '1285', '47', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (7058, '27/04/2020', '2020-17', '646', '19', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.47');
INSERT INTO public.europe_data_import VALUES (7059, '20/04/2020', '2020-16', '304', '11', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (7060, '13/04/2020', '2020-15', '91', '5', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (7061, '06/04/2020', '2020-14', '135', '4', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.1');
INSERT INTO public.europe_data_import VALUES (7062, '30/03/2020', '2020-13', '67', '1', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (7063, '23/03/2020', '2020-12', '28', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.01');
INSERT INTO public.europe_data_import VALUES (7064, '16/03/2020', '2020-11', '1', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (7065, '09/03/2020', '2020-10', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (7066, '02/03/2020', '2020-09', '1', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (7067, '24/02/2020', '2020-08', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7068, '17/02/2020', '2020-07', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7069, '10/02/2020', '2020-06', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7070, '03/02/2020', '2020-05', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7071, '27/01/2020', '2020-04', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7072, '20/01/2020', '2020-03', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7073, '13/01/2020', '2020-02', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (7074, '06/01/2020', '2020-01', '0', '0', '200963603', 'Nigeria', 'NG', 'NGA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (7075, '01/02/2021', '2021-04', '2039', '70', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '180.78');
INSERT INTO public.europe_data_import VALUES (7076, '25/01/2021', '2021-03', '1716', '83', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '200.28');
INSERT INTO public.europe_data_import VALUES (7077, '18/01/2021', '2021-02', '2444', '80', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '236.58');
INSERT INTO public.europe_data_import VALUES (7078, '11/01/2021', '2021-01', '2470', '92', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '225.79');
INSERT INTO public.europe_data_import VALUES (7079, '04/01/2021', '2020-53', '2220', '74', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '275.33');
INSERT INTO public.europe_data_import VALUES (7080, '28/12/2020', '2020-52', '3499', '164', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '393.14');
INSERT INTO public.europe_data_import VALUES (7081, '21/12/2020', '2020-51', '4667', '171', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '497.66');
INSERT INTO public.europe_data_import VALUES (7082, '14/12/2020', '2020-50', '5670', '197', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '582.29');
INSERT INTO public.europe_data_import VALUES (7083, '07/12/2020', '2020-49', '6425', '193', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '636.7');
INSERT INTO public.europe_data_import VALUES (7084, '30/11/2020', '2020-48', '6800', '220', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '697.74');
INSERT INTO public.europe_data_import VALUES (7085, '23/11/2020', '2020-47', '7693', '206', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '721.33');
INSERT INTO public.europe_data_import VALUES (7086, '16/11/2020', '2020-46', '7290', '169', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '703.57');
INSERT INTO public.europe_data_import VALUES (7087, '09/11/2020', '2020-45', '7324', '132', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '616.52');
INSERT INTO public.europe_data_import VALUES (7088, '02/11/2020', '2020-44', '5482', '85', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '424.05');
INSERT INTO public.europe_data_import VALUES (7089, '26/10/2020', '2020-43', '3326', '85', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '289.68');
INSERT INTO public.europe_data_import VALUES (7090, '19/10/2020', '2020-42', '2691', '42', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '241.97');
INSERT INTO public.europe_data_import VALUES (7091, '12/10/2020', '2020-41', '2335', '39', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '159.26');
INSERT INTO public.europe_data_import VALUES (7092, '05/10/2020', '2020-40', '973', '28', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '89.88');
INSERT INTO public.europe_data_import VALUES (7093, '28/09/2020', '2020-39', '894', '32', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '93.16');
INSERT INTO public.europe_data_import VALUES (7094, '21/09/2020', '2020-38', '1041', '47', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '94.99');
INSERT INTO public.europe_data_import VALUES (7095, '14/09/2020', '2020-37', '932', '40', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '85.07');
INSERT INTO public.europe_data_import VALUES (7096, '07/09/2020', '2020-36', '835', '22', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '60.08');
INSERT INTO public.europe_data_import VALUES (7097, '31/08/2020', '2020-35', '413', '21', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '57.19');
INSERT INTO public.europe_data_import VALUES (7098, '24/08/2020', '2020-34', '775', '19', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '79.82');
INSERT INTO public.europe_data_import VALUES (7099, '17/08/2020', '2020-33', '883', '17', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '81.12');
INSERT INTO public.europe_data_import VALUES (7100, '10/08/2020', '2020-32', '802', '30', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '85.21');
INSERT INTO public.europe_data_import VALUES (7101, '03/08/2020', '2020-31', '968', '37', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '92.53');
INSERT INTO public.europe_data_import VALUES (7102, '27/07/2020', '2020-30', '954', '38', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '95.08');
INSERT INTO public.europe_data_import VALUES (7103, '20/07/2020', '2020-29', '1021', '40', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '100.43');
INSERT INTO public.europe_data_import VALUES (7104, '13/07/2020', '2020-28', '1065', '41', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '97.2');
INSERT INTO public.europe_data_import VALUES (7105, '06/07/2020', '2020-27', '954', '55', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '93.4');
INSERT INTO public.europe_data_import VALUES (7106, '29/06/2020', '2020-26', '986', '48', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '97.97');
INSERT INTO public.europe_data_import VALUES (7107, '22/06/2020', '2020-25', '1049', '50', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '100.04');
INSERT INTO public.europe_data_import VALUES (7108, '15/06/2020', '2020-24', '1029', '35', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '88.15');
INSERT INTO public.europe_data_import VALUES (7109, '08/06/2020', '2020-23', '802', '20', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '50.55');
INSERT INTO public.europe_data_import VALUES (7110, '01/06/2020', '2020-22', '248', '20', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '20.89');
INSERT INTO public.europe_data_import VALUES (7111, '25/05/2020', '2020-21', '186', '12', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '16.18');
INSERT INTO public.europe_data_import VALUES (7112, '18/05/2020', '2020-20', '150', '10', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '13.53');
INSERT INTO public.europe_data_import VALUES (7113, '11/05/2020', '2020-19', '131', '7', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '12.32');
INSERT INTO public.europe_data_import VALUES (7114, '04/05/2020', '2020-18', '125', '23', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '14.64');
INSERT INTO public.europe_data_import VALUES (7115, '27/04/2020', '2020-17', '179', '10', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '26.86');
INSERT INTO public.europe_data_import VALUES (7116, '20/04/2020', '2020-16', '379', '17', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '34.86');
INSERT INTO public.europe_data_import VALUES (7117, '13/04/2020', '2020-15', '345', '17', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '27.39');
INSERT INTO public.europe_data_import VALUES (7118, '06/04/2020', '2020-14', '224', '11', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '17.76');
INSERT INTO public.europe_data_import VALUES (7119, '30/03/2020', '2020-13', '145', '5', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '11.84');
INSERT INTO public.europe_data_import VALUES (7120, '23/03/2020', '2020-12', '101', '1', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '5.34');
INSERT INTO public.europe_data_import VALUES (7121, '16/03/2020', '2020-11', '10', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0.58');
INSERT INTO public.europe_data_import VALUES (7122, '09/03/2020', '2020-10', '2', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0.14');
INSERT INTO public.europe_data_import VALUES (7123, '02/03/2020', '2020-09', '1', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0.05');
INSERT INTO public.europe_data_import VALUES (7124, '24/02/2020', '2020-08', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7125, '17/02/2020', '2020-07', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7126, '10/02/2020', '2020-06', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7127, '03/02/2020', '2020-05', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7128, '27/01/2020', '2020-04', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7129, '20/01/2020', '2020-03', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7130, '13/01/2020', '2020-02', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7131, '06/01/2020', '2020-01', '0', '0', '2077132', 'North_Macedonia', 'MK', 'MKD', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (7132, '01/02/2021', '2021-04', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7133, '25/01/2021', '2021-03', '1', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7134, '18/01/2021', '2021-02', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7135, '11/01/2021', '2021-01', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '5.24');
INSERT INTO public.europe_data_import VALUES (7136, '04/01/2021', '2020-53', '0', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7137, '28/12/2020', '2020-52', '6', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '15.73');
INSERT INTO public.europe_data_import VALUES (7138, '21/12/2020', '2020-51', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '12.23');
INSERT INTO public.europe_data_import VALUES (7139, '14/12/2020', '2020-50', '4', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '12.23');
INSERT INTO public.europe_data_import VALUES (7140, '07/12/2020', '2020-49', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '8.74');
INSERT INTO public.europe_data_import VALUES (7141, '30/11/2020', '2020-48', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7142, '23/11/2020', '2020-47', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7143, '16/11/2020', '2020-46', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7144, '09/11/2020', '2020-45', '4', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '13.98');
INSERT INTO public.europe_data_import VALUES (7145, '02/11/2020', '2020-44', '4', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '17.48');
INSERT INTO public.europe_data_import VALUES (7146, '26/10/2020', '2020-43', '6', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '26.22');
INSERT INTO public.europe_data_import VALUES (7147, '19/10/2020', '2020-42', '9', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '22.72');
INSERT INTO public.europe_data_import VALUES (7148, '12/10/2020', '2020-41', '4', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '12.23');
INSERT INTO public.europe_data_import VALUES (7149, '05/10/2020', '2020-40', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7150, '28/09/2020', '2020-39', '1', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '17.48');
INSERT INTO public.europe_data_import VALUES (7151, '21/09/2020', '2020-38', '9', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '19.23');
INSERT INTO public.europe_data_import VALUES (7152, '14/09/2020', '2020-37', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7153, '07/09/2020', '2020-36', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7154, '31/08/2020', '2020-35', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7155, '24/08/2020', '2020-34', '4', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7156, '17/08/2020', '2020-33', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '6.99');
INSERT INTO public.europe_data_import VALUES (7157, '10/08/2020', '2020-32', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '13.98');
INSERT INTO public.europe_data_import VALUES (7158, '03/08/2020', '2020-31', '6', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '15.73');
INSERT INTO public.europe_data_import VALUES (7159, '27/07/2020', '2020-30', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '12.23');
INSERT INTO public.europe_data_import VALUES (7160, '20/07/2020', '2020-29', '4', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7161, '13/07/2020', '2020-28', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '5.24');
INSERT INTO public.europe_data_import VALUES (7162, '06/07/2020', '2020-27', '1', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '1.75');
INSERT INTO public.europe_data_import VALUES (7163, '29/06/2020', '2020-26', '0', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7164, '22/06/2020', '2020-25', '0', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '5.24');
INSERT INTO public.europe_data_import VALUES (7165, '15/06/2020', '2020-24', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '13.98');
INSERT INTO public.europe_data_import VALUES (7166, '08/06/2020', '2020-23', '5', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '8.74');
INSERT INTO public.europe_data_import VALUES (7167, '01/06/2020', '2020-22', '0', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '1.75');
INSERT INTO public.europe_data_import VALUES (7168, '25/05/2020', '2020-21', '1', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7169, '18/05/2020', '2020-20', '5', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '12.23');
INSERT INTO public.europe_data_import VALUES (7170, '11/05/2020', '2020-19', '2', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '3.5');
INSERT INTO public.europe_data_import VALUES (7171, '04/05/2020', '2020-18', '0', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7172, '27/04/2020', '2020-17', '0', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '5.24');
INSERT INTO public.europe_data_import VALUES (7173, '20/04/2020', '2020-16', '3', '0', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '10.49');
INSERT INTO public.europe_data_import VALUES (7174, '13/04/2020', '2020-15', '3', '1', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '19.23');
INSERT INTO public.europe_data_import VALUES (7175, '06/04/2020', '2020-14', '8', '1', '57213', 'Northern_Mariana_Islands', 'MP', 'MNP', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (7176, '01/02/2021', '2021-04', '1884', '19', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '80.98');
INSERT INTO public.europe_data_import VALUES (7177, '25/01/2021', '2021-03', '2431', '27', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '105.27');
INSERT INTO public.europe_data_import VALUES (7178, '18/01/2021', '2021-02', '3178', '43', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '148.94');
INSERT INTO public.europe_data_import VALUES (7179, '11/01/2021', '2021-01', '4758', '29', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '157.95');
INSERT INTO public.europe_data_import VALUES (7180, '04/01/2021', '2020-53', '3658', '20', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '149.02');
INSERT INTO public.europe_data_import VALUES (7181, '28/12/2020', '2020-52', '4282', '25', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '113.62');
INSERT INTO public.europe_data_import VALUES (7182, '21/12/2020', '2020-51', '1772', '11', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '101.42');
INSERT INTO public.europe_data_import VALUES (7183, '14/12/2020', '2020-50', '3632', '39', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '117.41');
INSERT INTO public.europe_data_import VALUES (7184, '07/12/2020', '2020-49', '2624', '26', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '111.35');
INSERT INTO public.europe_data_import VALUES (7185, '30/11/2020', '2020-48', '3309', '22', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '141.15');
INSERT INTO public.europe_data_import VALUES (7186, '23/11/2020', '2020-47', '4212', '12', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '154.14');
INSERT INTO public.europe_data_import VALUES (7187, '16/11/2020', '2020-46', '4001', '9', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '143.82');
INSERT INTO public.europe_data_import VALUES (7188, '09/11/2020', '2020-45', '3662', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '112.48');
INSERT INTO public.europe_data_import VALUES (7189, '02/11/2020', '2020-44', '2331', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '64.32');
INSERT INTO public.europe_data_import VALUES (7190, '26/10/2020', '2020-43', '1096', '1', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '37.74');
INSERT INTO public.europe_data_import VALUES (7191, '19/10/2020', '2020-42', '915', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '37.29');
INSERT INTO public.europe_data_import VALUES (7192, '12/10/2020', '2020-41', '1072', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '34.06');
INSERT INTO public.europe_data_import VALUES (7193, '05/10/2020', '2020-40', '743', '5', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '28.23');
INSERT INTO public.europe_data_import VALUES (7194, '28/09/2020', '2020-39', '761', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '28.9');
INSERT INTO public.europe_data_import VALUES (7195, '21/09/2020', '2020-38', '779', '2', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '28.62');
INSERT INTO public.europe_data_import VALUES (7196, '14/09/2020', '2020-37', '746', '1', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '24.83');
INSERT INTO public.europe_data_import VALUES (7197, '07/09/2020', '2020-36', '577', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '17.32');
INSERT INTO public.europe_data_import VALUES (7198, '31/08/2020', '2020-35', '346', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '13.01');
INSERT INTO public.europe_data_import VALUES (7199, '24/08/2020', '2020-34', '347', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '13.68');
INSERT INTO public.europe_data_import VALUES (7200, '17/08/2020', '2020-33', '382', '5', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '12.05');
INSERT INTO public.europe_data_import VALUES (7201, '10/08/2020', '2020-32', '260', '1', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '7.19');
INSERT INTO public.europe_data_import VALUES (7202, '03/08/2020', '2020-31', '123', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.62');
INSERT INTO public.europe_data_import VALUES (7203, '27/07/2020', '2020-30', '70', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '2.25');
INSERT INTO public.europe_data_import VALUES (7204, '20/07/2020', '2020-29', '50', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '2.25');
INSERT INTO public.europe_data_import VALUES (7205, '13/07/2020', '2020-28', '70', '1', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '2.82');
INSERT INTO public.europe_data_import VALUES (7206, '06/07/2020', '2020-27', '80', '2', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.51');
INSERT INTO public.europe_data_import VALUES (7207, '29/06/2020', '2020-26', '107', '5', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.92');
INSERT INTO public.europe_data_import VALUES (7208, '22/06/2020', '2020-25', '102', '2', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.83');
INSERT INTO public.europe_data_import VALUES (7209, '15/06/2020', '2020-24', '102', '4', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.66');
INSERT INTO public.europe_data_import VALUES (7210, '08/06/2020', '2020-23', '93', '2', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.66');
INSERT INTO public.europe_data_import VALUES (7211, '01/06/2020', '2020-22', '102', '1', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '4.02');
INSERT INTO public.europe_data_import VALUES (7212, '25/05/2020', '2020-21', '112', '3', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.94');
INSERT INTO public.europe_data_import VALUES (7213, '18/05/2020', '2020-20', '98', '15', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '7.28');
INSERT INTO public.europe_data_import VALUES (7214, '11/05/2020', '2020-19', '290', '9', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '11.15');
INSERT INTO public.europe_data_import VALUES (7215, '04/05/2020', '2020-18', '304', '15', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '13.91');
INSERT INTO public.europe_data_import VALUES (7216, '27/04/2020', '2020-17', '437', '39', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '20.46');
INSERT INTO public.europe_data_import VALUES (7217, '20/04/2020', '2020-16', '653', '51', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '26.8');
INSERT INTO public.europe_data_import VALUES (7218, '13/04/2020', '2020-15', '775', '45', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '43.41');
INSERT INTO public.europe_data_import VALUES (7219, '06/04/2020', '2020-14', '1538', '36', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '65.84');
INSERT INTO public.europe_data_import VALUES (7220, '30/03/2020', '2020-13', '1970', '15', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '56.77');
INSERT INTO public.europe_data_import VALUES (7221, '23/03/2020', '2020-12', '1055', '6', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '36.84');
INSERT INTO public.europe_data_import VALUES (7222, '16/03/2020', '2020-11', '908', '1', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '19.86');
INSERT INTO public.europe_data_import VALUES (7223, '09/03/2020', '2020-10', '150', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '3.17');
INSERT INTO public.europe_data_import VALUES (7224, '02/03/2020', '2020-09', '19', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0.36');
INSERT INTO public.europe_data_import VALUES (7225, '24/02/2020', '2020-08', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7226, '17/02/2020', '2020-07', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7227, '10/02/2020', '2020-06', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7228, '03/02/2020', '2020-05', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7229, '27/01/2020', '2020-04', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7230, '20/01/2020', '2020-03', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7231, '13/01/2020', '2020-02', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7232, '06/01/2020', '2020-01', '0', '0', '5328212', 'Norway', 'NO', 'NOR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (7233, '01/02/2021', '2021-04', '1480', '11', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '54.95');
INSERT INTO public.europe_data_import VALUES (7234, '25/01/2021', '2021-03', '1254', '9', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '45.51');
INSERT INTO public.europe_data_import VALUES (7235, '18/01/2021', '2021-02', '1010', '4', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '44.34');
INSERT INTO public.europe_data_import VALUES (7236, '11/01/2021', '2021-01', '1196', '6', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '46.39');
INSERT INTO public.europe_data_import VALUES (7237, '04/01/2021', '2020-53', '1112', '7', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '38.53');
INSERT INTO public.europe_data_import VALUES (7238, '28/12/2020', '2020-52', '805', '7', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '44.86');
INSERT INTO public.europe_data_import VALUES (7239, '21/12/2020', '2020-51', '1427', '17', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '55.9');
INSERT INTO public.europe_data_import VALUES (7240, '14/12/2020', '2020-50', '1354', '27', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '55.4');
INSERT INTO public.europe_data_import VALUES (7241, '07/12/2020', '2020-49', '1402', '26', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '56.38');
INSERT INTO public.europe_data_import VALUES (7242, '30/11/2020', '2020-48', '1403', '38', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '62.21');
INSERT INTO public.europe_data_import VALUES (7243, '23/11/2020', '2020-47', '1692', '42', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '79.22');
INSERT INTO public.europe_data_import VALUES (7244, '16/11/2020', '2020-46', '2249', '37', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '93.57');
INSERT INTO public.europe_data_import VALUES (7245, '09/11/2020', '2020-45', '2406', '55', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '104.68');
INSERT INTO public.europe_data_import VALUES (7246, '02/11/2020', '2020-44', '2802', '72', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '116.2');
INSERT INTO public.europe_data_import VALUES (7247, '26/10/2020', '2020-43', '2979', '73', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '141.55');
INSERT INTO public.europe_data_import VALUES (7248, '19/10/2020', '2020-42', '4063', '63', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '174.53');
INSERT INTO public.europe_data_import VALUES (7249, '12/10/2020', '2020-41', '4620', '61', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '169.65');
INSERT INTO public.europe_data_import VALUES (7250, '05/10/2020', '2020-40', '3820', '68', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '156.68');
INSERT INTO public.europe_data_import VALUES (7251, '28/09/2020', '2020-39', '3975', '63', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '154.85');
INSERT INTO public.europe_data_import VALUES (7252, '21/09/2020', '2020-38', '3729', '66', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '128.7');
INSERT INTO public.europe_data_import VALUES (7253, '14/09/2020', '2020-37', '2674', '52', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '84.46');
INSERT INTO public.europe_data_import VALUES (7254, '07/09/2020', '2020-36', '1528', '51', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '66.39');
INSERT INTO public.europe_data_import VALUES (7255, '31/08/2020', '2020-35', '1775', '68', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '49.41');
INSERT INTO public.europe_data_import VALUES (7256, '24/08/2020', '2020-34', '683', '37', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '44.0');
INSERT INTO public.europe_data_import VALUES (7257, '17/08/2020', '2020-33', '1506', '59', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '78.93');
INSERT INTO public.europe_data_import VALUES (7258, '10/08/2020', '2020-32', '2421', '92', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '112.06');
INSERT INTO public.europe_data_import VALUES (7259, '03/08/2020', '2020-31', '3154', '37', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '251.22');
INSERT INTO public.europe_data_import VALUES (7260, '27/07/2020', '2020-30', '9344', '66', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '401.81');
INSERT INTO public.europe_data_import VALUES (7261, '20/07/2020', '2020-29', '10646', '61', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '411.72');
INSERT INTO public.europe_data_import VALUES (7262, '13/07/2020', '2020-28', '9837', '44', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '359.1');
INSERT INTO public.europe_data_import VALUES (7263, '06/07/2020', '2020-27', '8028', '50', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '335.82');
INSERT INTO public.europe_data_import VALUES (7264, '29/06/2020', '2020-26', '8679', '32', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '294.85');
INSERT INTO public.europe_data_import VALUES (7265, '22/06/2020', '2020-25', '5990', '27', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '253.05');
INSERT INTO public.europe_data_import VALUES (7266, '15/06/2020', '2020-24', '6599', '29', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '242.09');
INSERT INTO public.europe_data_import VALUES (7267, '08/06/2020', '2020-23', '5445', '28', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '183.16');
INSERT INTO public.europe_data_import VALUES (7268, '01/06/2020', '2020-22', '3667', '10', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '125.65');
INSERT INTO public.europe_data_import VALUES (7269, '25/05/2020', '2020-21', '2584', '15', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '87.86');
INSERT INTO public.europe_data_import VALUES (7270, '18/05/2020', '2020-20', '1787', '5', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '52.62');
INSERT INTO public.europe_data_import VALUES (7271, '11/05/2020', '2020-19', '831', '5', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '28.16');
INSERT INTO public.europe_data_import VALUES (7272, '04/05/2020', '2020-18', '570', '2', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '26.17');
INSERT INTO public.europe_data_import VALUES (7273, '27/04/2020', '2020-17', '732', '3', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '28.12');
INSERT INTO public.europe_data_import VALUES (7274, '20/04/2020', '2020-16', '667', '3', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '19.46');
INSERT INTO public.europe_data_import VALUES (7275, '13/04/2020', '2020-15', '301', '2', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '8.68');
INSERT INTO public.europe_data_import VALUES (7276, '06/04/2020', '2020-14', '131', '2', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '4.88');
INSERT INTO public.europe_data_import VALUES (7277, '30/03/2020', '2020-13', '112', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '2.91');
INSERT INTO public.europe_data_import VALUES (7278, '23/03/2020', '2020-12', '33', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0.78');
INSERT INTO public.europe_data_import VALUES (7279, '16/03/2020', '2020-11', '6', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0.32');
INSERT INTO public.europe_data_import VALUES (7280, '09/03/2020', '2020-10', '10', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0.32');
INSERT INTO public.europe_data_import VALUES (7281, '02/03/2020', '2020-09', '6', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (7282, '24/02/2020', '2020-08', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7283, '17/02/2020', '2020-07', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7284, '10/02/2020', '2020-06', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7285, '03/02/2020', '2020-05', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7286, '27/01/2020', '2020-04', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7287, '20/01/2020', '2020-03', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7288, '13/01/2020', '2020-02', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7289, '06/01/2020', '2020-01', '0', '0', '4974992', 'Oman', 'OM', 'OMN', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (7290, '01/02/2021', '2021-04', '12387', '365', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '11.64');
INSERT INTO public.europe_data_import VALUES (7291, '25/01/2021', '2021-03', '12830', '321', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '13.74');
INSERT INTO public.europe_data_import VALUES (7292, '18/01/2021', '2021-02', '16918', '321', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '15.09');
INSERT INTO public.europe_data_import VALUES (7293, '11/01/2021', '2021-01', '15764', '326', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '14.31');
INSERT INTO public.europe_data_import VALUES (7294, '04/01/2021', '2020-53', '15220', '421', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '13.65');
INSERT INTO public.europe_data_import VALUES (7295, '28/12/2020', '2020-52', '14341', '537', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '15.02');
INSERT INTO public.europe_data_import VALUES (7296, '21/12/2020', '2020-51', '18181', '560', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '17.86');
INSERT INTO public.europe_data_import VALUES (7297, '14/12/2020', '2020-50', '20493', '434', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '19.75');
INSERT INTO public.europe_data_import VALUES (7298, '07/12/2020', '2020-49', '22270', '373', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '20.02');
INSERT INTO public.europe_data_import VALUES (7299, '30/11/2020', '2020-48', '21095', '329', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '18.0');
INSERT INTO public.europe_data_import VALUES (7300, '23/11/2020', '2020-47', '17897', '536', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '14.82');
INSERT INTO public.europe_data_import VALUES (7301, '16/11/2020', '2020-46', '14193', '183', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '11.05');
INSERT INTO public.europe_data_import VALUES (7302, '09/11/2020', '2020-45', '9746', '142', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '7.5');
INSERT INTO public.europe_data_import VALUES (7303, '02/11/2020', '2020-44', '6491', '96', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '5.38');
INSERT INTO public.europe_data_import VALUES (7304, '26/10/2020', '2020-43', '5150', '80', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '4.47');
INSERT INTO public.europe_data_import VALUES (7305, '19/10/2020', '2020-42', '4520', '89', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '4.08');
INSERT INTO public.europe_data_import VALUES (7306, '12/10/2020', '2020-41', '4316', '57', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '3.74');
INSERT INTO public.europe_data_import VALUES (7307, '05/10/2020', '2020-40', '3775', '47', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '3.84');
INSERT INTO public.europe_data_import VALUES (7308, '28/09/2020', '2020-39', '4537', '46', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '4.07');
INSERT INTO public.europe_data_import VALUES (7309, '21/09/2020', '2020-38', '4284', '37', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '3.42');
INSERT INTO public.europe_data_import VALUES (7310, '14/09/2020', '2020-37', '3117', '38', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '2.85');
INSERT INTO public.europe_data_import VALUES (7311, '07/09/2020', '2020-36', '3054', '51', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '2.83');
INSERT INTO public.europe_data_import VALUES (7312, '31/08/2020', '2020-35', '3084', '59', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '3.06');
INSERT INTO public.europe_data_import VALUES (7313, '24/08/2020', '2020-34', '3550', '60', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '3.74');
INSERT INTO public.europe_data_import VALUES (7314, '17/08/2020', '2020-33', '4555', '78', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '4.24');
INSERT INTO public.europe_data_import VALUES (7315, '10/08/2020', '2020-32', '4631', '113', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '4.79');
INSERT INTO public.europe_data_import VALUES (7316, '03/08/2020', '2020-31', '5740', '142', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '6.9');
INSERT INTO public.europe_data_import VALUES (7317, '27/07/2020', '2020-30', '9206', '243', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '10.47');
INSERT INTO public.europe_data_import VALUES (7318, '20/07/2020', '2020-29', '13458', '333', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '15.36');
INSERT INTO public.europe_data_import VALUES (7319, '13/07/2020', '2020-28', '19807', '504', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '20.83');
INSERT INTO public.europe_data_import VALUES (7320, '06/07/2020', '2020-27', '25306', '595', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '23.42');
INSERT INTO public.europe_data_import VALUES (7321, '29/06/2020', '2020-26', '25424', '577', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '28.64');
INSERT INTO public.europe_data_import VALUES (7322, '22/06/2020', '2020-25', '36610', '861', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '35.75');
INSERT INTO public.europe_data_import VALUES (7323, '15/06/2020', '2020-24', '40807', '662', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '33.25');
INSERT INTO public.europe_data_import VALUES (7324, '08/06/2020', '2020-23', '31211', '524', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '21.85');
INSERT INTO public.europe_data_import VALUES (7325, '01/06/2020', '2020-22', '16111', '376', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '14.01');
INSERT INTO public.europe_data_import VALUES (7326, '25/05/2020', '2020-21', '14224', '264', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '11.73');
INSERT INTO public.europe_data_import VALUES (7327, '18/05/2020', '2020-20', '11184', '236', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '10.13');
INSERT INTO public.europe_data_import VALUES (7328, '11/05/2020', '2020-19', '10755', '205', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '8.13');
INSERT INTO public.europe_data_import VALUES (7329, '04/05/2020', '2020-18', '6858', '181', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '5.43');
INSERT INTO public.europe_data_import VALUES (7330, '27/04/2020', '2020-17', '4910', '105', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '3.67');
INSERT INTO public.europe_data_import VALUES (7331, '20/04/2020', '2020-16', '3044', '83', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '2.37');
INSERT INTO public.europe_data_import VALUES (7332, '13/04/2020', '2020-15', '2097', '43', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '1.78');
INSERT INTO public.europe_data_import VALUES (7333, '06/04/2020', '2020-14', '1751', '37', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '1.15');
INSERT INTO public.europe_data_import VALUES (7334, '30/03/2020', '2020-13', '742', '8', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (7335, '23/03/2020', '2020-12', '753', '5', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0.36');
INSERT INTO public.europe_data_import VALUES (7336, '16/03/2020', '2020-11', '25', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (7337, '09/03/2020', '2020-10', '2', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (7338, '02/03/2020', '2020-09', '4', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (7339, '24/02/2020', '2020-08', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7340, '17/02/2020', '2020-07', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7341, '10/02/2020', '2020-06', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7342, '03/02/2020', '2020-05', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7343, '27/01/2020', '2020-04', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7344, '20/01/2020', '2020-03', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7345, '13/01/2020', '2020-02', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7346, '06/01/2020', '2020-01', '0', '0', '216565317', 'Pakistan', 'PK', 'PAK', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (7347, '01/02/2021', '2021-04', '3973', '50', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '154.65');
INSERT INTO public.europe_data_import VALUES (7348, '25/01/2021', '2021-03', '3731', '90', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '180.61');
INSERT INTO public.europe_data_import VALUES (7349, '18/01/2021', '2021-02', '5266', '125', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '224.27');
INSERT INTO public.europe_data_import VALUES (7350, '11/01/2021', '2021-01', '5906', '124', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '312.88');
INSERT INTO public.europe_data_import VALUES (7351, '04/01/2021', '2020-53', '9680', '189', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '401.41');
INSERT INTO public.europe_data_import VALUES (7352, '28/12/2020', '2020-52', '10316', '147', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '516.04');
INSERT INTO public.europe_data_import VALUES (7353, '21/12/2020', '2020-51', '15390', '208', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '562.33');
INSERT INTO public.europe_data_import VALUES (7354, '14/12/2020', '2020-50', '12622', '157', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '559.46');
INSERT INTO public.europe_data_import VALUES (7355, '07/12/2020', '2020-49', '15247', '115', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '555.97');
INSERT INTO public.europe_data_import VALUES (7356, '30/11/2020', '2020-48', '12448', '93', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '430.84');
INSERT INTO public.europe_data_import VALUES (7357, '23/11/2020', '2020-47', '9014', '74', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '284.64');
INSERT INTO public.europe_data_import VALUES (7358, '16/11/2020', '2020-46', '5165', '53', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '191.19');
INSERT INTO public.europe_data_import VALUES (7359, '09/11/2020', '2020-45', '4359', '26', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '162.91');
INSERT INTO public.europe_data_import VALUES (7360, '02/11/2020', '2020-44', '3756', '43', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '145.8');
INSERT INTO public.europe_data_import VALUES (7361, '26/10/2020', '2020-43', '3507', '39', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '130.28');
INSERT INTO public.europe_data_import VALUES (7362, '19/10/2020', '2020-42', '2983', '34', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '122.58');
INSERT INTO public.europe_data_import VALUES (7363, '12/10/2020', '2020-41', '3123', '54', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '127.73');
INSERT INTO public.europe_data_import VALUES (7364, '05/10/2020', '2020-40', '3240', '48', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '140.26');
INSERT INTO public.europe_data_import VALUES (7365, '28/09/2020', '2020-39', '3747', '43', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '194.38');
INSERT INTO public.europe_data_import VALUES (7366, '21/09/2020', '2020-38', '5936', '50', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '229.53');
INSERT INTO public.europe_data_import VALUES (7367, '14/09/2020', '2020-37', '5498', '47', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '209.72');
INSERT INTO public.europe_data_import VALUES (7368, '07/09/2020', '2020-36', '4949', '37', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '180.43');
INSERT INTO public.europe_data_import VALUES (7369, '31/08/2020', '2020-35', '4039', '23', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '143.09');
INSERT INTO public.europe_data_import VALUES (7370, '24/08/2020', '2020-34', '3089', '22', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '127.94');
INSERT INTO public.europe_data_import VALUES (7371, '17/08/2020', '2020-33', '3284', '18', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '123.56');
INSERT INTO public.europe_data_import VALUES (7372, '10/08/2020', '2020-32', '2871', '16', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '110.85');
INSERT INTO public.europe_data_import VALUES (7373, '03/08/2020', '2020-31', '2651', '9', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '114.99');
INSERT INTO public.europe_data_import VALUES (7374, '27/07/2020', '2020-30', '3077', '16', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '122.27');
INSERT INTO public.europe_data_import VALUES (7375, '20/07/2020', '2020-29', '3014', '25', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '112.3');
INSERT INTO public.europe_data_import VALUES (7376, '13/07/2020', '2020-28', '2580', '17', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '96.16');
INSERT INTO public.europe_data_import VALUES (7377, '06/07/2020', '2020-27', '2210', '13', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '68.98');
INSERT INTO public.europe_data_import VALUES (7378, '29/06/2020', '2020-26', '1226', '2', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '31.62');
INSERT INTO public.europe_data_import VALUES (7379, '22/06/2020', '2020-25', '349', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '7.45');
INSERT INTO public.europe_data_import VALUES (7380, '15/06/2020', '2020-24', '22', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '0.92');
INSERT INTO public.europe_data_import VALUES (7381, '08/06/2020', '2020-23', '24', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '0.98');
INSERT INTO public.europe_data_import VALUES (7382, '01/06/2020', '2020-22', '25', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '1.34');
INSERT INTO public.europe_data_import VALUES (7383, '25/05/2020', '2020-21', '42', '1', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '1.1');
INSERT INTO public.europe_data_import VALUES (7384, '18/05/2020', '2020-20', '13', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '0.76');
INSERT INTO public.europe_data_import VALUES (7385, '11/05/2020', '2020-19', '25', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '1.04');
INSERT INTO public.europe_data_import VALUES (7386, '04/05/2020', '2020-18', '27', '2', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '4.01');
INSERT INTO public.europe_data_import VALUES (7387, '27/04/2020', '2020-17', '173', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '4.56');
INSERT INTO public.europe_data_import VALUES (7388, '20/04/2020', '2020-16', '54', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '2.11');
INSERT INTO public.europe_data_import VALUES (7389, '13/04/2020', '2020-15', '51', '1', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '3.25');
INSERT INTO public.europe_data_import VALUES (7390, '06/04/2020', '2020-14', '111', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '3.17');
INSERT INTO public.europe_data_import VALUES (7391, '30/03/2020', '2020-13', '47', '1', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '1.37');
INSERT INTO public.europe_data_import VALUES (7392, '23/03/2020', '2020-12', '21', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '1.18');
INSERT INTO public.europe_data_import VALUES (7393, '16/03/2020', '2020-11', '38', '0', '4981422', 'Palestine', 'PS', 'PSE', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (7394, '01/02/2021', '2021-04', '8221', '172', '4246440', 'Panama', 'PA', 'PAN', 'America', '526.56');
INSERT INTO public.europe_data_import VALUES (7395, '25/01/2021', '2021-03', '14139', '311', '4246440', 'Panama', 'PA', 'PAN', 'America', '776.23');
INSERT INTO public.europe_data_import VALUES (7396, '18/01/2021', '2021-02', '18823', '332', '4246440', 'Panama', 'PA', 'PAN', 'America', '1042.83');
INSERT INTO public.europe_data_import VALUES (7397, '11/01/2021', '2021-01', '25460', '315', '4246440', 'Panama', 'PA', 'PAN', 'America', '1071.27');
INSERT INTO public.europe_data_import VALUES (7398, '04/01/2021', '2020-53', '20031', '248', '4246440', 'Panama', 'PA', 'PAN', 'America', '934.85');
INSERT INTO public.europe_data_import VALUES (7399, '28/12/2020', '2020-52', '19667', '295', '4246440', 'Panama', 'PA', 'PAN', 'America', '958.4');
INSERT INTO public.europe_data_import VALUES (7400, '21/12/2020', '2020-51', '21031', '241', '4246440', 'Panama', 'PA', 'PAN', 'America', '855.28');
INSERT INTO public.europe_data_import VALUES (7401, '14/12/2020', '2020-50', '15288', '163', '4246440', 'Panama', 'PA', 'PAN', 'America', '665.92');
INSERT INTO public.europe_data_import VALUES (7402, '07/12/2020', '2020-49', '12990', '133', '4246440', 'Panama', 'PA', 'PAN', 'America', '540.12');
INSERT INTO public.europe_data_import VALUES (7403, '30/11/2020', '2020-48', '9946', '103', '4246440', 'Panama', 'PA', 'PAN', 'America', '425.67');
INSERT INTO public.europe_data_import VALUES (7404, '23/11/2020', '2020-47', '8130', '84', '4246440', 'Panama', 'PA', 'PAN', 'America', '359.27');
INSERT INTO public.europe_data_import VALUES (7405, '16/11/2020', '2020-46', '7126', '75', '4246440', 'Panama', 'PA', 'PAN', 'America', '290.05');
INSERT INTO public.europe_data_import VALUES (7406, '09/11/2020', '2020-45', '5191', '92', '4246440', 'Panama', 'PA', 'PAN', 'America', '243.19');
INSERT INTO public.europe_data_import VALUES (7407, '02/11/2020', '2020-44', '5136', '73', '4246440', 'Panama', 'PA', 'PAN', 'America', '225.86');
INSERT INTO public.europe_data_import VALUES (7408, '26/10/2020', '2020-43', '4455', '69', '4246440', 'Panama', 'PA', 'PAN', 'America', '209.28');
INSERT INTO public.europe_data_import VALUES (7409, '19/10/2020', '2020-42', '4432', '73', '4246440', 'Panama', 'PA', 'PAN', 'America', '222.75');
INSERT INTO public.europe_data_import VALUES (7410, '12/10/2020', '2020-41', '5027', '68', '4246440', 'Panama', 'PA', 'PAN', 'America', '229.79');
INSERT INTO public.europe_data_import VALUES (7411, '05/10/2020', '2020-40', '4731', '83', '4246440', 'Panama', 'PA', 'PAN', 'America', '213.9');
INSERT INTO public.europe_data_import VALUES (7412, '28/09/2020', '2020-39', '4352', '83', '4246440', 'Panama', 'PA', 'PAN', 'America', '207.47');
INSERT INTO public.europe_data_import VALUES (7413, '21/09/2020', '2020-38', '4458', '91', '4246440', 'Panama', 'PA', 'PAN', 'America', '215.71');
INSERT INTO public.europe_data_import VALUES (7414, '14/09/2020', '2020-37', '4702', '80', '4246440', 'Panama', 'PA', 'PAN', 'America', '227.96');
INSERT INTO public.europe_data_import VALUES (7415, '07/09/2020', '2020-36', '4978', '91', '4246440', 'Panama', 'PA', 'PAN', 'America', '238.86');
INSERT INTO public.europe_data_import VALUES (7416, '31/08/2020', '2020-35', '5165', '103', '4246440', 'Panama', 'PA', 'PAN', 'America', '238.44');
INSERT INTO public.europe_data_import VALUES (7417, '24/08/2020', '2020-34', '4960', '125', '4246440', 'Panama', 'PA', 'PAN', 'America', '292.2');
INSERT INTO public.europe_data_import VALUES (7418, '17/08/2020', '2020-33', '7448', '128', '4246440', 'Panama', 'PA', 'PAN', 'America', '341.16');
INSERT INTO public.europe_data_import VALUES (7419, '10/08/2020', '2020-32', '7039', '168', '4246440', 'Panama', 'PA', 'PAN', 'America', '334.3');
INSERT INTO public.europe_data_import VALUES (7420, '03/08/2020', '2020-31', '7157', '177', '4246440', 'Panama', 'PA', 'PAN', 'America', '329.33');
INSERT INTO public.europe_data_import VALUES (7421, '27/07/2020', '2020-30', '6828', '198', '4246440', 'Panama', 'PA', 'PAN', 'America', '345.3');
INSERT INTO public.europe_data_import VALUES (7422, '20/07/2020', '2020-29', '7835', '187', '4246440', 'Panama', 'PA', 'PAN', 'America', '360.75');
INSERT INTO public.europe_data_import VALUES (7423, '13/07/2020', '2020-28', '7484', '162', '4246440', 'Panama', 'PA', 'PAN', 'America', '328.44');
INSERT INTO public.europe_data_import VALUES (7424, '06/07/2020', '2020-27', '6463', '143', '4246440', 'Panama', 'PA', 'PAN', 'America', '285.39');
INSERT INTO public.europe_data_import VALUES (7425, '29/06/2020', '2020-26', '5656', '103', '4246440', 'Panama', 'PA', 'PAN', 'America', '259.04');
INSERT INTO public.europe_data_import VALUES (7426, '22/06/2020', '2020-25', '5344', '64', '4246440', 'Panama', 'PA', 'PAN', 'America', '226.19');
INSERT INTO public.europe_data_import VALUES (7427, '15/06/2020', '2020-24', '4261', '44', '4246440', 'Panama', 'PA', 'PAN', 'America', '170.1');
INSERT INTO public.europe_data_import VALUES (7428, '08/06/2020', '2020-23', '2962', '57', '4246440', 'Panama', 'PA', 'PAN', 'America', '129.5');
INSERT INTO public.europe_data_import VALUES (7429, '01/06/2020', '2020-22', '2537', '30', '4246440', 'Panama', 'PA', 'PAN', 'America', '90.83');
INSERT INTO public.europe_data_import VALUES (7430, '25/05/2020', '2020-21', '1320', '31', '4246440', 'Panama', 'PA', 'PAN', 'America', '58.35');
INSERT INTO public.europe_data_import VALUES (7431, '18/05/2020', '2020-20', '1158', '31', '4246440', 'Panama', 'PA', 'PAN', 'America', '56.73');
INSERT INTO public.europe_data_import VALUES (7432, '11/05/2020', '2020-19', '1251', '44', '4246440', 'Panama', 'PA', 'PAN', 'America', '62.85');
INSERT INTO public.europe_data_import VALUES (7433, '04/05/2020', '2020-18', '1418', '35', '4246440', 'Panama', 'PA', 'PAN', 'America', '64.29');
INSERT INTO public.europe_data_import VALUES (7434, '27/04/2020', '2020-17', '1312', '39', '4246440', 'Panama', 'PA', 'PAN', 'America', '56.02');
INSERT INTO public.europe_data_import VALUES (7435, '20/04/2020', '2020-16', '1067', '39', '4246440', 'Panama', 'PA', 'PAN', 'America', '58.38');
INSERT INTO public.europe_data_import VALUES (7436, '13/04/2020', '2020-15', '1412', '33', '4246440', 'Panama', 'PA', 'PAN', 'America', '56.78');
INSERT INTO public.europe_data_import VALUES (7437, '06/04/2020', '2020-14', '999', '30', '4246440', 'Panama', 'PA', 'PAN', 'America', '39.44');
INSERT INTO public.europe_data_import VALUES (7438, '30/03/2020', '2020-13', '676', '21', '4246440', 'Panama', 'PA', 'PAN', 'America', '22.28');
INSERT INTO public.europe_data_import VALUES (7439, '23/03/2020', '2020-12', '270', '2', '4246440', 'Panama', 'PA', 'PAN', 'America', '7.37');
INSERT INTO public.europe_data_import VALUES (7440, '16/03/2020', '2020-11', '43', '1', '4246440', 'Panama', 'PA', 'PAN', 'America', '');
INSERT INTO public.europe_data_import VALUES (7441, '01/02/2021', '2021-04', '18', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.38');
INSERT INTO public.europe_data_import VALUES (7442, '25/01/2021', '2021-03', '15', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.43');
INSERT INTO public.europe_data_import VALUES (7443, '18/01/2021', '2021-02', '23', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.4');
INSERT INTO public.europe_data_import VALUES (7444, '11/01/2021', '2021-01', '12', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.35');
INSERT INTO public.europe_data_import VALUES (7445, '04/01/2021', '2020-53', '19', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.43');
INSERT INTO public.europe_data_import VALUES (7446, '28/12/2020', '2020-52', '19', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.63');
INSERT INTO public.europe_data_import VALUES (7447, '21/12/2020', '2020-51', '36', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '1.03');
INSERT INTO public.europe_data_import VALUES (7448, '14/12/2020', '2020-50', '54', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.8');
INSERT INTO public.europe_data_import VALUES (7449, '07/12/2020', '2020-49', '16', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.76');
INSERT INTO public.europe_data_import VALUES (7450, '30/11/2020', '2020-48', '51', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.63');
INSERT INTO public.europe_data_import VALUES (7451, '23/11/2020', '2020-47', '4', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.08');
INSERT INTO public.europe_data_import VALUES (7452, '16/11/2020', '2020-46', '3', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.11');
INSERT INTO public.europe_data_import VALUES (7453, '09/11/2020', '2020-45', '7', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.1');
INSERT INTO public.europe_data_import VALUES (7454, '02/11/2020', '2020-44', '2', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.1');
INSERT INTO public.europe_data_import VALUES (7455, '26/10/2020', '2020-43', '7', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.39');
INSERT INTO public.europe_data_import VALUES (7456, '19/10/2020', '2020-42', '27', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.47');
INSERT INTO public.europe_data_import VALUES (7457, '12/10/2020', '2020-41', '14', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.25');
INSERT INTO public.europe_data_import VALUES (7458, '05/10/2020', '2020-40', '8', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.26');
INSERT INTO public.europe_data_import VALUES (7459, '28/09/2020', '2020-39', '15', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.24');
INSERT INTO public.europe_data_import VALUES (7460, '21/09/2020', '2020-38', '6', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.23');
INSERT INTO public.europe_data_import VALUES (7461, '14/09/2020', '2020-37', '14', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.59');
INSERT INTO public.europe_data_import VALUES (7462, '07/09/2020', '2020-36', '38', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '1.09');
INSERT INTO public.europe_data_import VALUES (7463, '31/08/2020', '2020-35', '58', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '1.55');
INSERT INTO public.europe_data_import VALUES (7464, '24/08/2020', '2020-34', '78', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '2.13');
INSERT INTO public.europe_data_import VALUES (7465, '17/08/2020', '2020-33', '109', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '2.43');
INSERT INTO public.europe_data_import VALUES (7466, '10/08/2020', '2020-32', '104', '1', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '1.73');
INSERT INTO public.europe_data_import VALUES (7467, '03/08/2020', '2020-31', '48', '2', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '1.06');
INSERT INTO public.europe_data_import VALUES (7468, '27/07/2020', '2020-30', '45', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.58');
INSERT INTO public.europe_data_import VALUES (7469, '20/07/2020', '2020-29', '6', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.07');
INSERT INTO public.europe_data_import VALUES (7470, '13/07/2020', '2020-28', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7471, '06/07/2020', '2020-27', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.02');
INSERT INTO public.europe_data_import VALUES (7472, '29/06/2020', '2020-26', '2', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.03');
INSERT INTO public.europe_data_import VALUES (7473, '22/06/2020', '2020-25', '1', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.01');
INSERT INTO public.europe_data_import VALUES (7474, '15/06/2020', '2020-24', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7475, '08/06/2020', '2020-23', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7476, '01/06/2020', '2020-22', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7477, '25/05/2020', '2020-21', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7478, '18/05/2020', '2020-20', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7479, '11/05/2020', '2020-19', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7480, '04/05/2020', '2020-18', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.01');
INSERT INTO public.europe_data_import VALUES (7481, '27/04/2020', '2020-17', '1', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.07');
INSERT INTO public.europe_data_import VALUES (7482, '20/04/2020', '2020-16', '5', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.07');
INSERT INTO public.europe_data_import VALUES (7483, '13/04/2020', '2020-15', '1', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.01');
INSERT INTO public.europe_data_import VALUES (7484, '06/04/2020', '2020-14', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (7485, '30/03/2020', '2020-13', '0', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '0.01');
INSERT INTO public.europe_data_import VALUES (7486, '23/03/2020', '2020-12', '1', '0', '8776119', 'Papua_New_Guinea', 'PG', 'PNG', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (7487, '01/02/2021', '2021-04', '4861', '86', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '157.1');
INSERT INTO public.europe_data_import VALUES (7488, '25/01/2021', '2021-03', '6206', '127', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '179.33');
INSERT INTO public.europe_data_import VALUES (7489, '18/01/2021', '2021-02', '6427', '100', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '185.77');
INSERT INTO public.europe_data_import VALUES (7490, '11/01/2021', '2021-01', '6660', '113', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '147.05');
INSERT INTO public.europe_data_import VALUES (7491, '04/01/2021', '2020-53', '3699', '90', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '120.11');
INSERT INTO public.europe_data_import VALUES (7492, '28/12/2020', '2020-52', '4762', '99', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '167.39');
INSERT INTO public.europe_data_import VALUES (7493, '21/12/2020', '2020-51', '7030', '150', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '180.17');
INSERT INTO public.europe_data_import VALUES (7494, '14/12/2020', '2020-50', '5662', '100', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '165.74');
INSERT INTO public.europe_data_import VALUES (7495, '07/12/2020', '2020-49', '6014', '110', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '162.45');
INSERT INTO public.europe_data_import VALUES (7496, '30/11/2020', '2020-48', '5430', '86', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '146.66');
INSERT INTO public.europe_data_import VALUES (7497, '23/11/2020', '2020-47', '4902', '70', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '126.15');
INSERT INTO public.europe_data_import VALUES (7498, '16/11/2020', '2020-46', '3985', '97', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '111.33');
INSERT INTO public.europe_data_import VALUES (7499, '09/11/2020', '2020-45', '3858', '72', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '113.49');
INSERT INTO public.europe_data_import VALUES (7500, '02/11/2020', '2020-44', '4137', '109', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '127.86');
INSERT INTO public.europe_data_import VALUES (7501, '26/10/2020', '2020-43', '4870', '121', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '140.8');
INSERT INTO public.europe_data_import VALUES (7502, '19/10/2020', '2020-42', '5049', '111', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '149.65');
INSERT INTO public.europe_data_import VALUES (7503, '12/10/2020', '2020-41', '5493', '148', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '156.02');
INSERT INTO public.europe_data_import VALUES (7504, '05/10/2020', '2020-40', '5498', '126', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '151.35');
INSERT INTO public.europe_data_import VALUES (7505, '28/09/2020', '2020-39', '5164', '144', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '154.26');
INSERT INTO public.europe_data_import VALUES (7506, '21/09/2020', '2020-38', '5703', '134', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '156.63');
INSERT INTO public.europe_data_import VALUES (7507, '14/09/2020', '2020-37', '5331', '90', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '150.78');
INSERT INTO public.europe_data_import VALUES (7508, '07/09/2020', '2020-36', '5291', '127', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '131.35');
INSERT INTO public.europe_data_import VALUES (7509, '31/08/2020', '2020-35', '3962', '103', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '105.1');
INSERT INTO public.europe_data_import VALUES (7510, '24/08/2020', '2020-34', '3442', '67', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '89.8');
INSERT INTO public.europe_data_import VALUES (7511, '17/08/2020', '2020-33', '2884', '63', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '58.87');
INSERT INTO public.europe_data_import VALUES (7512, '10/08/2020', '2020-32', '1263', '23', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '34.96');
INSERT INTO public.europe_data_import VALUES (7513, '03/08/2020', '2020-31', '1200', '11', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '27.3');
INSERT INTO public.europe_data_import VALUES (7514, '27/07/2020', '2020-30', '723', '10', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '21.24');
INSERT INTO public.europe_data_import VALUES (7515, '20/07/2020', '2020-29', '773', '9', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '18.37');
INSERT INTO public.europe_data_import VALUES (7516, '13/07/2020', '2020-28', '521', '2', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '11.65');
INSERT INTO public.europe_data_import VALUES (7517, '06/07/2020', '2020-27', '300', '5', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '14.88');
INSERT INTO public.europe_data_import VALUES (7518, '29/06/2020', '2020-26', '748', '2', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '11.9');
INSERT INTO public.europe_data_import VALUES (7519, '22/06/2020', '2020-25', '90', '2', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '3.46');
INSERT INTO public.europe_data_import VALUES (7520, '15/06/2020', '2020-24', '154', '0', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '4.3');
INSERT INTO public.europe_data_import VALUES (7521, '08/06/2020', '2020-23', '149', '0', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '3.88');
INSERT INTO public.europe_data_import VALUES (7522, '01/06/2020', '2020-22', '124', '0', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '2.84');
INSERT INTO public.europe_data_import VALUES (7523, '25/05/2020', '2020-21', '76', '0', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '2.12');
INSERT INTO public.europe_data_import VALUES (7524, '18/05/2020', '2020-20', '73', '1', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '5.54');
INSERT INTO public.europe_data_import VALUES (7525, '11/05/2020', '2020-19', '317', '0', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '6.88');
INSERT INTO public.europe_data_import VALUES (7526, '04/05/2020', '2020-18', '168', '1', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '2.7');
INSERT INTO public.europe_data_import VALUES (7527, '27/04/2020', '2020-17', '22', '1', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '1.15');
INSERT INTO public.europe_data_import VALUES (7528, '20/04/2020', '2020-16', '59', '2', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '1.32');
INSERT INTO public.europe_data_import VALUES (7529, '13/04/2020', '2020-15', '34', '1', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '1.18');
INSERT INTO public.europe_data_import VALUES (7530, '06/04/2020', '2020-14', '49', '2', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '1.29');
INSERT INTO public.europe_data_import VALUES (7531, '30/03/2020', '2020-13', '42', '2', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '0.79');
INSERT INTO public.europe_data_import VALUES (7532, '23/03/2020', '2020-12', '14', '1', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '0.31');
INSERT INTO public.europe_data_import VALUES (7533, '16/03/2020', '2020-11', '8', '0', '7044639', 'Paraguay', 'PY', 'PRY', 'America', '');
INSERT INTO public.europe_data_import VALUES (7534, '01/02/2021', '2021-04', '43703', '1404', '32510462', 'Peru', 'PE', 'PER', 'America', '227.35');
INSERT INTO public.europe_data_import VALUES (7535, '25/01/2021', '2021-03', '30211', '846', '32510462', 'Peru', 'PE', 'PER', 'America', '189.67');
INSERT INTO public.europe_data_import VALUES (7536, '18/01/2021', '2021-02', '31452', '596', '32510462', 'Peru', 'PE', 'PER', 'America', '146.86');
INSERT INTO public.europe_data_import VALUES (7537, '11/01/2021', '2021-01', '16292', '462', '32510462', 'Peru', 'PE', 'PER', 'America', '87.49');
INSERT INTO public.europe_data_import VALUES (7538, '04/01/2021', '2020-53', '12150', '348', '32510462', 'Peru', 'PE', 'PER', 'America', '69.46');
INSERT INTO public.europe_data_import VALUES (7539, '28/12/2020', '2020-52', '10433', '352', '32510462', 'Peru', 'PE', 'PER', 'America', '73.62');
INSERT INTO public.europe_data_import VALUES (7540, '21/12/2020', '2020-51', '13502', '496', '32510462', 'Peru', 'PE', 'PER', 'America', '75.55');
INSERT INTO public.europe_data_import VALUES (7541, '14/12/2020', '2020-50', '11061', '403', '32510462', 'Peru', 'PE', 'PER', 'America', '69.03');
INSERT INTO public.europe_data_import VALUES (7542, '07/12/2020', '2020-49', '11382', '351', '32510462', 'Peru', 'PE', 'PER', 'America', '74.57');
INSERT INTO public.europe_data_import VALUES (7543, '30/11/2020', '2020-48', '12860', '328', '32510462', 'Peru', 'PE', 'PER', 'America', '78.49');
INSERT INTO public.europe_data_import VALUES (7544, '23/11/2020', '2020-47', '12659', '364', '32510462', 'Peru', 'PE', 'PER', 'America', '84.09');
INSERT INTO public.europe_data_import VALUES (7545, '16/11/2020', '2020-46', '14678', '352', '32510462', 'Peru', 'PE', 'PER', 'America', '98.74');
INSERT INTO public.europe_data_import VALUES (7546, '09/11/2020', '2020-45', '17422', '350', '32510462', 'Peru', 'PE', 'PER', 'America', '103.41');
INSERT INTO public.europe_data_import VALUES (7547, '02/11/2020', '2020-44', '16196', '380', '32510462', 'Peru', 'PE', 'PER', 'America', '111.46');
INSERT INTO public.europe_data_import VALUES (7548, '26/10/2020', '2020-43', '20040', '390', '32510462', 'Peru', 'PE', 'PER', 'America', '121.02');
INSERT INTO public.europe_data_import VALUES (7549, '19/10/2020', '2020-42', '19304', '454', '32510462', 'Peru', 'PE', 'PER', 'America', '124.59');
INSERT INTO public.europe_data_import VALUES (7550, '12/10/2020', '2020-41', '21202', '563', '32510462', 'Peru', 'PE', 'PER', 'America', '135.55');
INSERT INTO public.europe_data_import VALUES (7551, '05/10/2020', '2020-40', '22867', '480', '32510462', 'Peru', 'PE', 'PER', 'America', '182.32');
INSERT INTO public.europe_data_import VALUES (7552, '28/09/2020', '2020-39', '36407', '893', '32510462', 'Peru', 'PE', 'PER', 'America', '232.8');
INSERT INTO public.europe_data_import VALUES (7553, '21/09/2020', '2020-38', '39276', '659', '32510462', 'Peru', 'PE', 'PER', 'America', '242.75');
INSERT INTO public.europe_data_import VALUES (7554, '14/09/2020', '2020-37', '39642', '872', '32510462', 'Peru', 'PE', 'PER', 'America', '253.62');
INSERT INTO public.europe_data_import VALUES (7555, '07/09/2020', '2020-36', '42811', '1050', '32510462', 'Peru', 'PE', 'PER', 'America', '294.22');
INSERT INTO public.europe_data_import VALUES (7556, '31/08/2020', '2020-35', '52840', '1125', '32510462', 'Peru', 'PE', 'PER', 'America', '342.11');
INSERT INTO public.europe_data_import VALUES (7557, '24/08/2020', '2020-34', '58380', '1382', '32510462', 'Peru', 'PE', 'PER', 'America', '357.74');
INSERT INTO public.europe_data_import VALUES (7558, '17/08/2020', '2020-33', '57922', '5209', '32510462', 'Peru', 'PE', 'PER', 'America', '329.42');
INSERT INTO public.europe_data_import VALUES (7559, '10/08/2020', '2020-32', '49174', '1458', '32510462', 'Peru', 'PE', 'PER', 'America', '286.76');
INSERT INTO public.europe_data_import VALUES (7560, '03/08/2020', '2020-31', '44053', '1385', '32510462', 'Peru', 'PE', 'PER', 'America', '231.49');
INSERT INTO public.europe_data_import VALUES (7561, '27/07/2020', '2020-30', '31207', '5042', '32510462', 'Peru', 'PE', 'PER', 'America', '179.85');
INSERT INTO public.europe_data_import VALUES (7562, '20/07/2020', '2020-29', '27264', '1317', '32510462', 'Peru', 'PE', 'PER', 'America', '156.48');
INSERT INTO public.europe_data_import VALUES (7563, '13/07/2020', '2020-28', '23608', '1281', '32510462', 'Peru', 'PE', 'PER', 'America', '144.28');
INSERT INTO public.europe_data_import VALUES (7564, '06/07/2020', '2020-27', '23299', '1272', '32510462', 'Peru', 'PE', 'PER', 'America', '146.97');
INSERT INTO public.europe_data_import VALUES (7565, '29/06/2020', '2020-26', '24483', '1272', '32510462', 'Peru', 'PE', 'PER', 'America', '152.82');
INSERT INTO public.europe_data_import VALUES (7566, '22/06/2020', '2020-25', '25200', '1357', '32510462', 'Peru', 'PE', 'PER', 'America', '179.7');
INSERT INTO public.europe_data_import VALUES (7567, '15/06/2020', '2020-24', '33221', '1223', '32510462', 'Peru', 'PE', 'PER', 'America', '200.74');
INSERT INTO public.europe_data_import VALUES (7568, '08/06/2020', '2020-23', '32039', '959', '32510462', 'Peru', 'PE', 'PER', 'America', '235.48');
INSERT INTO public.europe_data_import VALUES (7569, '01/06/2020', '2020-22', '44517', '1050', '32510462', 'Peru', 'PE', 'PER', 'America', '222.09');
INSERT INTO public.europe_data_import VALUES (7570, '25/05/2020', '2020-21', '27686', '808', '32510462', 'Peru', 'PE', 'PER', 'America', '161.95');
INSERT INTO public.europe_data_import VALUES (7571, '18/05/2020', '2020-20', '24966', '759', '32510462', 'Peru', 'PE', 'PER', 'America', '142.55');
INSERT INTO public.europe_data_import VALUES (7572, '11/05/2020', '2020-19', '21379', '603', '32510462', 'Peru', 'PE', 'PER', 'America', '122.39');
INSERT INTO public.europe_data_import VALUES (7573, '04/05/2020', '2020-18', '18411', '558', '32510462', 'Peru', 'PE', 'PER', 'America', '93.2');
INSERT INTO public.europe_data_import VALUES (7574, '27/04/2020', '2020-17', '11889', '328', '32510462', 'Peru', 'PE', 'PER', 'America', '61.51');
INSERT INTO public.europe_data_import VALUES (7575, '20/04/2020', '2020-16', '8109', '207', '32510462', 'Peru', 'PE', 'PER', 'America', '41.05');
INSERT INTO public.europe_data_import VALUES (7576, '13/04/2020', '2020-15', '5238', '110', '32510462', 'Peru', 'PE', 'PER', 'America', '20.51');
INSERT INTO public.europe_data_import VALUES (7577, '06/04/2020', '2020-14', '1429', '65', '32510462', 'Peru', 'PE', 'PER', 'America', '5.9');
INSERT INTO public.europe_data_import VALUES (7578, '30/03/2020', '2020-13', '489', '13', '32510462', 'Peru', 'PE', 'PER', 'America', '2.4');
INSERT INTO public.europe_data_import VALUES (7579, '23/03/2020', '2020-12', '292', '5', '32510462', 'Peru', 'PE', 'PER', 'America', '1.1');
INSERT INTO public.europe_data_import VALUES (7580, '16/03/2020', '2020-11', '64', '0', '32510462', 'Peru', 'PE', 'PER', 'America', '0.22');
INSERT INTO public.europe_data_import VALUES (7581, '09/03/2020', '2020-10', '7', '0', '32510462', 'Peru', 'PE', 'PER', 'America', '');
INSERT INTO public.europe_data_import VALUES (7582, '01/02/2021', '2021-04', '11999', '507', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '23.16');
INSERT INTO public.europe_data_import VALUES (7583, '25/01/2021', '2021-03', '13042', '347', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '23.98');
INSERT INTO public.europe_data_import VALUES (7584, '18/01/2021', '2021-02', '12887', '490', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '21.06');
INSERT INTO public.europe_data_import VALUES (7585, '11/01/2021', '2021-01', '9883', '148', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '16.47');
INSERT INTO public.europe_data_import VALUES (7586, '04/01/2021', '2020-53', '7921', '148', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '16.67');
INSERT INTO public.europe_data_import VALUES (7587, '28/12/2020', '2020-52', '10097', '162', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '18.95');
INSERT INTO public.europe_data_import VALUES (7588, '21/12/2020', '2020-51', '10389', '214', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '18.46');
INSERT INTO public.europe_data_import VALUES (7589, '14/12/2020', '2020-50', '9566', '179', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '18.07');
INSERT INTO public.europe_data_import VALUES (7590, '07/12/2020', '2020-49', '9970', '181', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '19.44');
INSERT INTO public.europe_data_import VALUES (7591, '30/11/2020', '2020-48', '11046', '250', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '20.37');
INSERT INTO public.europe_data_import VALUES (7592, '23/11/2020', '2020-47', '10980', '291', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '20.74');
INSERT INTO public.europe_data_import VALUES (7593, '16/11/2020', '2020-46', '11443', '293', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '22.87');
INSERT INTO public.europe_data_import VALUES (7594, '09/11/2020', '2020-45', '13282', '301', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '24.39');
INSERT INTO public.europe_data_import VALUES (7595, '02/11/2020', '2020-44', '13085', '261', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '24.51');
INSERT INTO public.europe_data_import VALUES (7596, '26/10/2020', '2020-43', '13410', '325', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '28.38');
INSERT INTO public.europe_data_import VALUES (7597, '19/10/2020', '2020-42', '17277', '331', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '31.56');
INSERT INTO public.europe_data_import VALUES (7598, '12/10/2020', '2020-41', '16844', '545', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '32.48');
INSERT INTO public.europe_data_import VALUES (7599, '05/10/2020', '2020-40', '18271', '432', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '33.07');
INSERT INTO public.europe_data_import VALUES (7600, '28/09/2020', '2020-39', '17483', '360', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '39.78');
INSERT INTO public.europe_data_import VALUES (7601, '21/09/2020', '2020-38', '25527', '613', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '45.67');
INSERT INTO public.europe_data_import VALUES (7602, '14/09/2020', '2020-37', '23851', '496', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '40.53');
INSERT INTO public.europe_data_import VALUES (7603, '07/09/2020', '2020-36', '19969', '355', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '44.18');
INSERT INTO public.europe_data_import VALUES (7604, '31/08/2020', '2020-35', '27795', '522', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '51.93');
INSERT INTO public.europe_data_import VALUES (7605, '24/08/2020', '2020-34', '28348', '333', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '55.21');
INSERT INTO public.europe_data_import VALUES (7606, '17/08/2020', '2020-33', '31340', '395', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '53.71');
INSERT INTO public.europe_data_import VALUES (7607, '10/08/2020', '2020-32', '26728', '211', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '45.75');
INSERT INTO public.europe_data_import VALUES (7608, '03/08/2020', '2020-31', '22737', '127', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '33.05');
INSERT INTO public.europe_data_import VALUES (7609, '27/07/2020', '2020-30', '12992', '101', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '22.37');
INSERT INTO public.europe_data_import VALUES (7610, '20/07/2020', '2020-29', '11197', '297', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '23.7');
INSERT INTO public.europe_data_import VALUES (7611, '13/07/2020', '2020-28', '14429', '244', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '19.24');
INSERT INTO public.europe_data_import VALUES (7612, '06/07/2020', '2020-27', '6375', '46', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '10.89');
INSERT INTO public.europe_data_import VALUES (7613, '29/06/2020', '2020-26', '5403', '75', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '8.81');
INSERT INTO public.europe_data_import VALUES (7614, '22/06/2020', '2020-25', '4122', '81', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '7.54');
INSERT INTO public.europe_data_import VALUES (7615, '15/06/2020', '2020-24', '4035', '85', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '7.26');
INSERT INTO public.europe_data_import VALUES (7616, '08/06/2020', '2020-23', '3809', '46', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '7.27');
INSERT INTO public.europe_data_import VALUES (7617, '01/06/2020', '2020-22', '4051', '89', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '5.15');
INSERT INTO public.europe_data_import VALUES (7618, '25/05/2020', '2020-21', '1522', '44', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '3.0');
INSERT INTO public.europe_data_import VALUES (7619, '18/05/2020', '2020-20', '1719', '105', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '3.04');
INSERT INTO public.europe_data_import VALUES (7620, '11/05/2020', '2020-19', '1571', '112', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '2.97');
INSERT INTO public.europe_data_import VALUES (7621, '04/05/2020', '2020-18', '1644', '106', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '2.74');
INSERT INTO public.europe_data_import VALUES (7622, '27/04/2020', '2020-17', '1320', '92', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '2.71');
INSERT INTO public.europe_data_import VALUES (7623, '20/04/2020', '2020-16', '1611', '112', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '2.79');
INSERT INTO public.europe_data_import VALUES (7624, '13/04/2020', '2020-15', '1402', '145', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '2.99');
INSERT INTO public.europe_data_import VALUES (7625, '06/04/2020', '2020-14', '1828', '81', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '2.65');
INSERT INTO public.europe_data_import VALUES (7626, '30/03/2020', '2020-13', '1038', '46', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '1.18');
INSERT INTO public.europe_data_import VALUES (7627, '23/03/2020', '2020-12', '240', '13', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0.34');
INSERT INTO public.europe_data_import VALUES (7628, '16/03/2020', '2020-11', '130', '11', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (7629, '09/03/2020', '2020-10', '7', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (7630, '02/03/2020', '2020-09', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7631, '24/02/2020', '2020-08', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7632, '17/02/2020', '2020-07', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (7633, '10/02/2020', '2020-06', '1', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (7634, '03/02/2020', '2020-05', '2', '1', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (7635, '27/01/2020', '2020-04', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7636, '20/01/2020', '2020-03', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7637, '13/01/2020', '2020-02', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7638, '06/01/2020', '2020-01', '0', '0', '108116622', 'Philippines', 'PH', 'PHL', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (7639, '01/02/2021', '2021-04', '35266', '1779', '37972812', 'Poland', 'PL', 'POL', 'Europe', '196.12');
INSERT INTO public.europe_data_import VALUES (7640, '25/01/2021', '2021-03', '39205', '1994', '37972812', 'Poland', 'PL', 'POL', 'Europe', '231.04');
INSERT INTO public.europe_data_import VALUES (7641, '18/01/2021', '2021-02', '48529', '2143', '37972812', 'Poland', 'PL', 'POL', 'Europe', '305.39');
INSERT INTO public.europe_data_import VALUES (7642, '11/01/2021', '2021-01', '67438', '2103', '37972812', 'Poland', 'PL', 'POL', 'Europe', '340.7');
INSERT INTO public.europe_data_import VALUES (7643, '04/01/2021', '2020-53', '61937', '2014', '37972812', 'Poland', 'PL', 'POL', 'Europe', '316.67');
INSERT INTO public.europe_data_import VALUES (7644, '28/12/2020', '2020-52', '58310', '1750', '37972812', 'Poland', 'PL', 'POL', 'Europe', '330.06');
INSERT INTO public.europe_data_import VALUES (7645, '21/12/2020', '2020-51', '67024', '2533', '37972812', 'Poland', 'PL', 'POL', 'Europe', '366.71');
INSERT INTO public.europe_data_import VALUES (7646, '14/12/2020', '2020-50', '72227', '2775', '37972812', 'Poland', 'PL', 'POL', 'Europe', '396.6');
INSERT INTO public.europe_data_import VALUES (7647, '07/12/2020', '2020-49', '78374', '3060', '37972812', 'Poland', 'PL', 'POL', 'Europe', '532.27');
INSERT INTO public.europe_data_import VALUES (7648, '30/11/2020', '2020-48', '123744', '3411', '37972812', 'Poland', 'PL', 'POL', 'Europe', '716.57');
INSERT INTO public.europe_data_import VALUES (7649, '23/11/2020', '2020-47', '148359', '3270', '37972812', 'Poland', 'PL', 'POL', 'Europe', '829.29');
INSERT INTO public.europe_data_import VALUES (7650, '16/11/2020', '2020-46', '166547', '2476', '37972812', 'Poland', 'PL', 'POL', 'Europe', '877.13');
INSERT INTO public.europe_data_import VALUES (7651, '09/11/2020', '2020-45', '166523', '2089', '37972812', 'Poland', 'PL', 'POL', 'Europe', '770.91');
INSERT INTO public.europe_data_import VALUES (7652, '02/11/2020', '2020-44', '126214', '1345', '37972812', 'Poland', 'PL', 'POL', 'Europe', '537.58');
INSERT INTO public.europe_data_import VALUES (7653, '26/10/2020', '2020-43', '77922', '865', '37972812', 'Poland', 'PL', 'POL', 'Europe', '336.75');
INSERT INTO public.europe_data_import VALUES (7654, '19/10/2020', '2020-42', '49950', '569', '37972812', 'Poland', 'PL', 'POL', 'Europe', '204.43');
INSERT INTO public.europe_data_import VALUES (7655, '12/10/2020', '2020-41', '27676', '400', '37972812', 'Poland', 'PL', 'POL', 'Europe', '101.35');
INSERT INTO public.europe_data_import VALUES (7656, '05/10/2020', '2020-40', '10810', '172', '37972812', 'Poland', 'PL', 'POL', 'Europe', '49.77');
INSERT INTO public.europe_data_import VALUES (7657, '28/09/2020', '2020-39', '8090', '139', '37972812', 'Poland', 'PL', 'POL', 'Europe', '34.7');
INSERT INTO public.europe_data_import VALUES (7658, '21/09/2020', '2020-38', '5088', '105', '37972812', 'Poland', 'PL', 'POL', 'Europe', '22.16');
INSERT INTO public.europe_data_import VALUES (7659, '14/09/2020', '2020-37', '3328', '68', '37972812', 'Poland', 'PL', 'POL', 'Europe', '19.18');
INSERT INTO public.europe_data_import VALUES (7660, '07/09/2020', '2020-36', '3954', '87', '37972812', 'Poland', 'PL', 'POL', 'Europe', '23.86');
INSERT INTO public.europe_data_import VALUES (7661, '31/08/2020', '2020-35', '5108', '78', '37972812', 'Poland', 'PL', 'POL', 'Europe', '26.82');
INSERT INTO public.europe_data_import VALUES (7662, '24/08/2020', '2020-34', '5078', '78', '37972812', 'Poland', 'PL', 'POL', 'Europe', '26.26');
INSERT INTO public.europe_data_import VALUES (7663, '17/08/2020', '2020-33', '4893', '70', '37972812', 'Poland', 'PL', 'POL', 'Europe', '25.78');
INSERT INTO public.europe_data_import VALUES (7664, '10/08/2020', '2020-32', '4897', '76', '37972812', 'Poland', 'PL', 'POL', 'Europe', '22.98');
INSERT INTO public.europe_data_import VALUES (7665, '03/08/2020', '2020-31', '3829', '60', '37972812', 'Poland', 'PL', 'POL', 'Europe', '17.88');
INSERT INTO public.europe_data_import VALUES (7666, '27/07/2020', '2020-30', '2961', '47', '37972812', 'Poland', 'PL', 'POL', 'Europe', '13.63');
INSERT INTO public.europe_data_import VALUES (7667, '20/07/2020', '2020-29', '2213', '53', '37972812', 'Poland', 'PL', 'POL', 'Europe', '10.94');
INSERT INTO public.europe_data_import VALUES (7668, '13/07/2020', '2020-28', '1941', '54', '37972812', 'Poland', 'PL', 'POL', 'Europe', '10.49');
INSERT INTO public.europe_data_import VALUES (7669, '06/07/2020', '2020-27', '2043', '79', '37972812', 'Poland', 'PL', 'POL', 'Europe', '10.58');
INSERT INTO public.europe_data_import VALUES (7670, '29/06/2020', '2020-26', '1976', '82', '37972812', 'Poland', 'PL', 'POL', 'Europe', '11.89');
INSERT INTO public.europe_data_import VALUES (7671, '22/06/2020', '2020-25', '2539', '109', '37972812', 'Poland', 'PL', 'POL', 'Europe', '14.14');
INSERT INTO public.europe_data_import VALUES (7672, '15/06/2020', '2020-24', '2831', '90', '37972812', 'Poland', 'PL', 'POL', 'Europe', '14.76');
INSERT INTO public.europe_data_import VALUES (7673, '08/06/2020', '2020-23', '2775', '93', '37972812', 'Poland', 'PL', 'POL', 'Europe', '13.79');
INSERT INTO public.europe_data_import VALUES (7674, '01/06/2020', '2020-22', '2460', '68', '37972812', 'Poland', 'PL', 'POL', 'Europe', '13.84');
INSERT INTO public.europe_data_import VALUES (7675, '25/05/2020', '2020-21', '2797', '71', '37972812', 'Poland', 'PL', 'POL', 'Europe', '14.04');
INSERT INTO public.europe_data_import VALUES (7676, '18/05/2020', '2020-20', '2533', '125', '37972812', 'Poland', 'PL', 'POL', 'Europe', '12.74');
INSERT INTO public.europe_data_import VALUES (7677, '11/05/2020', '2020-19', '2303', '122', '37972812', 'Poland', 'PL', 'POL', 'Europe', '11.53');
INSERT INTO public.europe_data_import VALUES (7678, '04/05/2020', '2020-18', '2076', '143', '37972812', 'Poland', 'PL', 'POL', 'Europe', '11.6');
INSERT INTO public.europe_data_import VALUES (7679, '27/04/2020', '2020-17', '2330', '175', '37972812', 'Poland', 'PL', 'POL', 'Europe', '13.02');
INSERT INTO public.europe_data_import VALUES (7680, '20/04/2020', '2020-16', '2613', '128', '37972812', 'Poland', 'PL', 'POL', 'Europe', '13.65');
INSERT INTO public.europe_data_import VALUES (7681, '13/04/2020', '2020-15', '2572', '138', '37972812', 'Poland', 'PL', 'POL', 'Europe', '12.67');
INSERT INTO public.europe_data_import VALUES (7682, '06/04/2020', '2020-14', '2240', '72', '37972812', 'Poland', 'PL', 'POL', 'Europe', '9.13');
INSERT INTO public.europe_data_import VALUES (7683, '30/03/2020', '2020-13', '1228', '15', '37972812', 'Poland', 'PL', 'POL', 'Europe', '4.57');
INSERT INTO public.europe_data_import VALUES (7684, '23/03/2020', '2020-12', '509', '4', '37972812', 'Poland', 'PL', 'POL', 'Europe', '1.64');
INSERT INTO public.europe_data_import VALUES (7685, '16/03/2020', '2020-11', '114', '3', '37972812', 'Poland', 'PL', 'POL', 'Europe', '0.33');
INSERT INTO public.europe_data_import VALUES (7686, '09/03/2020', '2020-10', '11', '0', '37972812', 'Poland', 'PL', 'POL', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (7687, '01/02/2021', '2021-04', '83208', '2036', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '1652.47');
INSERT INTO public.europe_data_import VALUES (7688, '25/01/2021', '2021-03', '86610', '1693', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '1496.8');
INSERT INTO public.europe_data_import VALUES (7689, '18/01/2021', '2021-02', '67210', '1103', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '1215.19');
INSERT INTO public.europe_data_import VALUES (7690, '11/01/2021', '2021-01', '57670', '729', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '901.34');
INSERT INTO public.europe_data_import VALUES (7691, '04/01/2021', '2020-53', '34957', '519', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '559.54');
INSERT INTO public.europe_data_import VALUES (7692, '28/12/2020', '2020-52', '22545', '543', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '466.32');
INSERT INTO public.europe_data_import VALUES (7693, '21/12/2020', '2020-51', '25377', '575', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '502.57');
INSERT INTO public.europe_data_import VALUES (7694, '14/12/2020', '2020-50', '26270', '596', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '524.93');
INSERT INTO public.europe_data_import VALUES (7695, '07/12/2020', '2020-49', '27675', '536', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '600.55');
INSERT INTO public.europe_data_import VALUES (7696, '30/11/2020', '2020-48', '34041', '530', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '754.12');
INSERT INTO public.europe_data_import VALUES (7697, '23/11/2020', '2020-47', '43457', '516', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '792.42');
INSERT INTO public.europe_data_import VALUES (7698, '16/11/2020', '2020-46', '37977', '485', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '709.96');
INSERT INTO public.europe_data_import VALUES (7699, '09/11/2020', '2020-45', '34983', '352', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '590.06');
INSERT INTO public.europe_data_import VALUES (7700, '02/11/2020', '2020-44', '25655', '228', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '432.34');
INSERT INTO public.europe_data_import VALUES (7701, '26/10/2020', '2020-43', '18775', '135', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '311.6');
INSERT INTO public.europe_data_import VALUES (7702, '19/10/2020', '2020-42', '13247', '101', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '210.81');
INSERT INTO public.europe_data_import VALUES (7703, '12/10/2020', '2020-41', '8417', '85', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '127.08');
INSERT INTO public.europe_data_import VALUES (7704, '05/10/2020', '2020-40', '4643', '42', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '94.1');
INSERT INTO public.europe_data_import VALUES (7705, '28/09/2020', '2020-39', '5027', '41', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '93.62');
INSERT INTO public.europe_data_import VALUES (7706, '21/09/2020', '2020-38', '4594', '45', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '80.95');
INSERT INTO public.europe_data_import VALUES (7707, '14/09/2020', '2020-37', '3725', '27', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '60.48');
INSERT INTO public.europe_data_import VALUES (7708, '07/09/2020', '2020-36', '2490', '21', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '45.36');
INSERT INTO public.europe_data_import VALUES (7709, '31/08/2020', '2020-35', '2171', '23', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '35.67');
INSERT INTO public.europe_data_import VALUES (7710, '24/08/2020', '2020-34', '1495', '18', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '28.5');
INSERT INTO public.europe_data_import VALUES (7711, '17/08/2020', '2020-33', '1434', '22', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '25.68');
INSERT INTO public.europe_data_import VALUES (7712, '10/08/2020', '2020-32', '1205', '18', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '24.37');
INSERT INTO public.europe_data_import VALUES (7713, '03/08/2020', '2020-31', '1299', '21', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '27.51');
INSERT INTO public.europe_data_import VALUES (7714, '27/07/2020', '2020-30', '1528', '28', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '35.54');
INSERT INTO public.europe_data_import VALUES (7715, '20/07/2020', '2020-29', '2124', '29', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '46.11');
INSERT INTO public.europe_data_import VALUES (7716, '13/07/2020', '2020-28', '2615', '46', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '47.35');
INSERT INTO public.europe_data_import VALUES (7717, '06/07/2020', '2020-27', '2251', '50', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '46.36');
INSERT INTO public.europe_data_import VALUES (7718, '29/06/2020', '2020-26', '2513', '34', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '48.23');
INSERT INTO public.europe_data_import VALUES (7719, '22/06/2020', '2020-25', '2443', '13', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '45.15');
INSERT INTO public.europe_data_import VALUES (7720, '15/06/2020', '2020-24', '2197', '38', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '40.77');
INSERT INTO public.europe_data_import VALUES (7721, '08/06/2020', '2020-23', '1993', '69', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '37.66');
INSERT INTO public.europe_data_import VALUES (7722, '01/06/2020', '2020-22', '1877', '94', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '33.71');
INSERT INTO public.europe_data_import VALUES (7723, '25/05/2020', '2020-21', '1587', '98', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '29.6');
INSERT INTO public.europe_data_import VALUES (7724, '18/05/2020', '2020-20', '1455', '83', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '34.17');
INSERT INTO public.europe_data_import VALUES (7725, '11/05/2020', '2020-19', '2057', '72', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '36.34');
INSERT INTO public.europe_data_import VALUES (7726, '04/05/2020', '2020-18', '1678', '135', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '51.75');
INSERT INTO public.europe_data_import VALUES (7727, '27/04/2020', '2020-17', '3640', '214', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '70.66');
INSERT INTO public.europe_data_import VALUES (7728, '20/04/2020', '2020-16', '3621', '210', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '86.88');
INSERT INTO public.europe_data_import VALUES (7729, '13/04/2020', '2020-15', '5307', '209', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '103.37');
INSERT INTO public.europe_data_import VALUES (7730, '06/04/2020', '2020-14', '5316', '176', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '94.17');
INSERT INTO public.europe_data_import VALUES (7731, '30/03/2020', '2020-13', '4362', '105', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '55.63');
INSERT INTO public.europe_data_import VALUES (7732, '23/03/2020', '2020-12', '1355', '14', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '15.28');
INSERT INTO public.europe_data_import VALUES (7733, '16/03/2020', '2020-11', '215', '0', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '2.38');
INSERT INTO public.europe_data_import VALUES (7734, '09/03/2020', '2020-10', '30', '0', '10276617', 'Portugal', 'PT', 'PRT', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (7735, '01/02/2021', '2021-04', '5521', '58', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '448.32');
INSERT INTO public.europe_data_import VALUES (7736, '25/01/2021', '2021-03', '7630', '75', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '532.08');
INSERT INTO public.europe_data_import VALUES (7737, '18/01/2021', '2021-02', '7978', '61', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '469.69');
INSERT INTO public.europe_data_import VALUES (7738, '11/01/2021', '2021-01', '5800', '80', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '464.85');
INSERT INTO public.europe_data_import VALUES (7739, '04/01/2021', '2020-53', '7836', '106', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '721.11');
INSERT INTO public.europe_data_import VALUES (7740, '28/12/2020', '2020-52', '13317', '74', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '734.51');
INSERT INTO public.europe_data_import VALUES (7741, '21/12/2020', '2020-51', '8229', '110', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '589.18');
INSERT INTO public.europe_data_import VALUES (7742, '14/12/2020', '2020-50', '9054', '80', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '564.63');
INSERT INTO public.europe_data_import VALUES (7743, '07/12/2020', '2020-49', '7509', '98', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '449.31');
INSERT INTO public.europe_data_import VALUES (7744, '30/11/2020', '2020-48', '5671', '77', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '428.55');
INSERT INTO public.europe_data_import VALUES (7745, '23/11/2020', '2020-47', '6900', '82', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '438.36');
INSERT INTO public.europe_data_import VALUES (7746, '16/11/2020', '2020-46', '5959', '63', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '387.37');
INSERT INTO public.europe_data_import VALUES (7747, '09/11/2020', '2020-45', '5404', '40', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '325.97');
INSERT INTO public.europe_data_import VALUES (7748, '02/11/2020', '2020-44', '4158', '31', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '319.36');
INSERT INTO public.europe_data_import VALUES (7749, '26/10/2020', '2020-43', '5210', '35', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '301.08');
INSERT INTO public.europe_data_import VALUES (7750, '19/10/2020', '2020-42', '3622', '36', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '225.61');
INSERT INTO public.europe_data_import VALUES (7751, '12/10/2020', '2020-41', '2996', '44', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '251.14');
INSERT INTO public.europe_data_import VALUES (7752, '05/10/2020', '2020-40', '4371', '42', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '301.25');
INSERT INTO public.europe_data_import VALUES (7753, '28/09/2020', '2020-39', '4466', '36', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '304.22');
INSERT INTO public.europe_data_import VALUES (7754, '21/09/2020', '2020-38', '4458', '69', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '249.03');
INSERT INTO public.europe_data_import VALUES (7755, '14/09/2020', '2020-37', '2847', '62', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '154.5');
INSERT INTO public.europe_data_import VALUES (7756, '07/09/2020', '2020-36', '1685', '43', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '158.08');
INSERT INTO public.europe_data_import VALUES (7757, '31/08/2020', '2020-35', '2952', '44', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '233.24');
INSERT INTO public.europe_data_import VALUES (7758, '24/08/2020', '2020-34', '3890', '55', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '265.05');
INSERT INTO public.europe_data_import VALUES (7759, '17/08/2020', '2020-33', '3885', '56', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '258.91');
INSERT INTO public.europe_data_import VALUES (7760, '10/08/2020', '2020-32', '3710', '49', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '237.88');
INSERT INTO public.europe_data_import VALUES (7761, '03/08/2020', '2020-31', '3268', '29', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '216.4');
INSERT INTO public.europe_data_import VALUES (7762, '27/07/2020', '2020-30', '3080', '23', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '181.43');
INSERT INTO public.europe_data_import VALUES (7763, '20/07/2020', '2020-29', '2242', '11', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '141.37');
INSERT INTO public.europe_data_import VALUES (7764, '13/07/2020', '2020-28', '1905', '12', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '89.73');
INSERT INTO public.europe_data_import VALUES (7765, '06/07/2020', '2020-27', '727', '2', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '47.42');
INSERT INTO public.europe_data_import VALUES (7766, '29/06/2020', '2020-26', '664', '4', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '46.98');
INSERT INTO public.europe_data_import VALUES (7767, '22/06/2020', '2020-25', '714', '2', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '52.5');
INSERT INTO public.europe_data_import VALUES (7768, '15/06/2020', '2020-24', '826', '5', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '69.37');
INSERT INTO public.europe_data_import VALUES (7769, '08/06/2020', '2020-23', '1209', '6', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '61.23');
INSERT INTO public.europe_data_import VALUES (7770, '01/06/2020', '2020-22', '587', '9', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '38.52');
INSERT INTO public.europe_data_import VALUES (7771, '25/05/2020', '2020-21', '543', '4', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '33.78');
INSERT INTO public.europe_data_import VALUES (7772, '18/05/2020', '2020-20', '448', '12', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '28.57');
INSERT INTO public.europe_data_import VALUES (7773, '11/05/2020', '2020-19', '390', '14', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '28.19');
INSERT INTO public.europe_data_import VALUES (7774, '04/05/2020', '2020-18', '437', '13', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '20.28');
INSERT INTO public.europe_data_import VALUES (7775, '27/04/2020', '2020-17', '158', '22', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '16.16');
INSERT INTO public.europe_data_import VALUES (7776, '20/04/2020', '2020-16', '316', '18', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '25.16');
INSERT INTO public.europe_data_import VALUES (7777, '13/04/2020', '2020-15', '422', '24', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '26.25');
INSERT INTO public.europe_data_import VALUES (7778, '06/04/2020', '2020-14', '348', '15', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '16.19');
INSERT INTO public.europe_data_import VALUES (7779, '30/03/2020', '2020-13', '127', '5', '2933404', 'Puerto_Rico', 'PR', 'PRI', 'America', '');
INSERT INTO public.europe_data_import VALUES (7780, '01/02/2021', '2021-04', '2316', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '135.27');
INSERT INTO public.europe_data_import VALUES (7781, '25/01/2021', '2021-03', '1515', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '104.2');
INSERT INTO public.europe_data_import VALUES (7782, '18/01/2021', '2021-02', '1436', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '100.99');
INSERT INTO public.europe_data_import VALUES (7783, '11/01/2021', '2021-01', '1424', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '106.14');
INSERT INTO public.europe_data_import VALUES (7784, '04/01/2021', '2020-53', '1582', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '93.32');
INSERT INTO public.europe_data_import VALUES (7785, '28/12/2020', '2020-52', '1061', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '68.54');
INSERT INTO public.europe_data_import VALUES (7786, '21/12/2020', '2020-51', '880', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '73.9');
INSERT INTO public.europe_data_import VALUES (7787, '14/12/2020', '2020-50', '1213', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '87.32');
INSERT INTO public.europe_data_import VALUES (7788, '07/12/2020', '2020-49', '1260', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '94.6');
INSERT INTO public.europe_data_import VALUES (7789, '30/11/2020', '2020-48', '1419', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '101.09');
INSERT INTO public.europe_data_import VALUES (7790, '23/11/2020', '2020-47', '1444', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '106.85');
INSERT INTO public.europe_data_import VALUES (7791, '16/11/2020', '2020-46', '1582', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '108.22');
INSERT INTO public.europe_data_import VALUES (7792, '09/11/2020', '2020-45', '1483', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '107.09');
INSERT INTO public.europe_data_import VALUES (7793, '02/11/2020', '2020-44', '1550', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '116.13');
INSERT INTO public.europe_data_import VALUES (7794, '26/10/2020', '2020-43', '1739', '6', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '112.46');
INSERT INTO public.europe_data_import VALUES (7795, '19/10/2020', '2020-42', '1446', '4', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '103.56');
INSERT INTO public.europe_data_import VALUES (7796, '12/10/2020', '2020-41', '1487', '4', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '102.43');
INSERT INTO public.europe_data_import VALUES (7797, '05/10/2020', '2020-40', '1414', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '110.24');
INSERT INTO public.europe_data_import VALUES (7798, '28/09/2020', '2020-39', '1708', '4', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '118.08');
INSERT INTO public.europe_data_import VALUES (7799, '21/09/2020', '2020-38', '1636', '5', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '115.85');
INSERT INTO public.europe_data_import VALUES (7800, '14/09/2020', '2020-37', '1645', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '111.76');
INSERT INTO public.europe_data_import VALUES (7801, '07/09/2020', '2020-36', '1520', '6', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '109.0');
INSERT INTO public.europe_data_import VALUES (7802, '31/08/2020', '2020-35', '1567', '4', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '123.41');
INSERT INTO public.europe_data_import VALUES (7803, '24/08/2020', '2020-34', '1928', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '143.39');
INSERT INTO public.europe_data_import VALUES (7804, '17/08/2020', '2020-33', '2133', '9', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '140.29');
INSERT INTO public.europe_data_import VALUES (7805, '10/08/2020', '2020-32', '1840', '7', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '128.6');
INSERT INTO public.europe_data_import VALUES (7806, '03/08/2020', '2020-31', '1802', '12', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '157.45');
INSERT INTO public.europe_data_import VALUES (7807, '27/07/2020', '2020-30', '2657', '8', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '201.51');
INSERT INTO public.europe_data_import VALUES (7808, '20/07/2020', '2020-29', '3050', '10', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '241.84');
INSERT INTO public.europe_data_import VALUES (7809, '13/07/2020', '2020-28', '3799', '19', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '324.32');
INSERT INTO public.europe_data_import VALUES (7810, '06/07/2020', '2020-27', '5386', '18', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '438.9');
INSERT INTO public.europe_data_import VALUES (7811, '29/06/2020', '2020-26', '7044', '12', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '522.97');
INSERT INTO public.europe_data_import VALUES (7812, '22/06/2020', '2020-25', '7767', '25', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '656.02');
INSERT INTO public.europe_data_import VALUES (7813, '15/06/2020', '2020-24', '10812', '19', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '801.25');
INSERT INTO public.europe_data_import VALUES (7814, '08/06/2020', '2020-23', '11880', '16', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '885.43');
INSERT INTO public.europe_data_import VALUES (7815, '01/06/2020', '2020-22', '13196', '15', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '858.24');
INSERT INTO public.europe_data_import VALUES (7816, '25/05/2020', '2020-21', '11110', '8', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '748.36');
INSERT INTO public.europe_data_import VALUES (7817, '18/05/2020', '2020-20', '10084', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '602.14');
INSERT INTO public.europe_data_import VALUES (7818, '11/05/2020', '2020-19', '6969', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '431.95');
INSERT INTO public.europe_data_import VALUES (7819, '04/05/2020', '2020-18', '5264', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '356.74');
INSERT INTO public.europe_data_import VALUES (7820, '27/04/2020', '2020-17', '4839', '2', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '258.04');
INSERT INTO public.europe_data_import VALUES (7821, '20/04/2020', '2020-16', '2469', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '135.73');
INSERT INTO public.europe_data_import VALUES (7822, '13/04/2020', '2020-15', '1375', '3', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '82.8');
INSERT INTO public.europe_data_import VALUES (7823, '06/04/2020', '2020-14', '970', '3', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '39.19');
INSERT INTO public.europe_data_import VALUES (7824, '30/03/2020', '2020-13', '140', '1', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '8.23');
INSERT INTO public.europe_data_import VALUES (7825, '23/03/2020', '2020-12', '93', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '16.91');
INSERT INTO public.europe_data_import VALUES (7826, '16/03/2020', '2020-11', '386', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '14.05');
INSERT INTO public.europe_data_import VALUES (7827, '09/03/2020', '2020-10', '12', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0.53');
INSERT INTO public.europe_data_import VALUES (7828, '02/03/2020', '2020-09', '3', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (7829, '24/02/2020', '2020-08', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7830, '17/02/2020', '2020-07', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7831, '10/02/2020', '2020-06', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7832, '03/02/2020', '2020-05', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7833, '27/01/2020', '2020-04', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7834, '20/01/2020', '2020-03', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7835, '13/01/2020', '2020-02', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (7836, '06/01/2020', '2020-01', '0', '0', '2832071', 'Qatar', 'QA', 'QAT', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (7837, '01/02/2021', '2021-04', '17495', '561', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '179.78');
INSERT INTO public.europe_data_import VALUES (7838, '25/01/2021', '2021-03', '17408', '570', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '202.37');
INSERT INTO public.europe_data_import VALUES (7839, '18/01/2021', '2021-02', '21882', '546', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '281.87');
INSERT INTO public.europe_data_import VALUES (7840, '11/01/2021', '2021-01', '32842', '746', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '282.48');
INSERT INTO public.europe_data_import VALUES (7841, '04/01/2021', '2020-53', '22000', '645', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '253.08');
INSERT INTO public.europe_data_import VALUES (7842, '28/12/2020', '2020-52', '27135', '940', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '319.83');
INSERT INTO public.europe_data_import VALUES (7843, '21/12/2020', '2020-51', '34959', '1009', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '400.31');
INSERT INTO public.europe_data_import VALUES (7844, '14/12/2020', '2020-50', '42759', '1065', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '436.78');
INSERT INTO public.europe_data_import VALUES (7845, '07/12/2020', '2020-49', '42040', '1127', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '488.97');
INSERT INTO public.europe_data_import VALUES (7846, '30/11/2020', '2020-48', '52891', '1146', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '573.05');
INSERT INTO public.europe_data_import VALUES (7847, '23/11/2020', '2020-47', '58364', '1121', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '591.8');
INSERT INTO public.europe_data_import VALUES (7848, '16/11/2020', '2020-46', '56530', '1047', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '585.22');
INSERT INTO public.europe_data_import VALUES (7849, '09/11/2020', '2020-45', '57088', '812', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '484.71');
INSERT INTO public.europe_data_import VALUES (7850, '02/11/2020', '2020-44', '37015', '676', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '341.37');
INSERT INTO public.europe_data_import VALUES (7851, '26/10/2020', '2020-43', '29260', '519', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '280.02');
INSERT INTO public.europe_data_import VALUES (7852, '19/10/2020', '2020-42', '25105', '461', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '238.6');
INSERT INTO public.europe_data_import VALUES (7853, '12/10/2020', '2020-41', '21218', '464', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '167.97');
INSERT INTO public.europe_data_import VALUES (7854, '05/10/2020', '2020-40', '11392', '229', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '109.63');
INSERT INTO public.europe_data_import VALUES (7855, '28/09/2020', '2020-39', '9892', '283', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '98.78');
INSERT INTO public.europe_data_import VALUES (7856, '21/09/2020', '2020-38', '9286', '272', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '91.51');
INSERT INTO public.europe_data_import VALUES (7857, '14/09/2020', '2020-37', '8481', '270', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '86.07');
INSERT INTO public.europe_data_import VALUES (7858, '07/09/2020', '2020-36', '8229', '315', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '84.93');
INSERT INTO public.europe_data_import VALUES (7859, '31/08/2020', '2020-35', '8260', '306', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '84.08');
INSERT INTO public.europe_data_import VALUES (7860, '24/08/2020', '2020-34', '8064', '281', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '86.31');
INSERT INTO public.europe_data_import VALUES (7861, '17/08/2020', '2020-33', '8693', '291', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '88.98');
INSERT INTO public.europe_data_import VALUES (7862, '10/08/2020', '2020-32', '8582', '287', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '87.41');
INSERT INTO public.europe_data_import VALUES (7863, '03/08/2020', '2020-31', '8388', '226', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '81.01');
INSERT INTO public.europe_data_import VALUES (7864, '27/07/2020', '2020-30', '7340', '161', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '63.16');
INSERT INTO public.europe_data_import VALUES (7865, '20/07/2020', '2020-29', '4923', '142', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '43.7');
INSERT INTO public.europe_data_import VALUES (7866, '13/07/2020', '2020-28', '3562', '134', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '32.05');
INSERT INTO public.europe_data_import VALUES (7867, '06/07/2020', '2020-27', '2660', '138', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '25.38');
INSERT INTO public.europe_data_import VALUES (7868, '29/06/2020', '2020-26', '2268', '100', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '22.22');
INSERT INTO public.europe_data_import VALUES (7869, '22/06/2020', '2020-25', '2046', '102', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '18.37');
INSERT INTO public.europe_data_import VALUES (7870, '15/06/2020', '2020-24', '1520', '84', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '14.12');
INSERT INTO public.europe_data_import VALUES (7871, '08/06/2020', '2020-23', '1222', '64', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '12.41');
INSERT INTO public.europe_data_import VALUES (7872, '01/06/2020', '2020-22', '1187', '83', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '12.29');
INSERT INTO public.europe_data_import VALUES (7873, '25/05/2020', '2020-21', '1199', '82', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '13.95');
INSERT INTO public.europe_data_import VALUES (7874, '18/05/2020', '2020-20', '1509', '145', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '19.1');
INSERT INTO public.europe_data_import VALUES (7875, '11/05/2020', '2020-19', '2199', '172', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '22.28');
INSERT INTO public.europe_data_import VALUES (7876, '04/05/2020', '2020-18', '2127', '172', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '22.75');
INSERT INTO public.europe_data_import VALUES (7877, '27/04/2020', '2020-17', '2290', '174', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '24.39');
INSERT INTO public.europe_data_import VALUES (7878, '20/04/2020', '2020-16', '2446', '128', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '25.15');
INSERT INTO public.europe_data_import VALUES (7879, '13/04/2020', '2020-15', '2436', '158', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '23.38');
INSERT INTO public.europe_data_import VALUES (7880, '06/04/2020', '2020-14', '2104', '108', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '17.67');
INSERT INTO public.europe_data_import VALUES (7881, '30/03/2020', '2020-13', '1327', '38', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '8.35');
INSERT INTO public.europe_data_import VALUES (7882, '23/03/2020', '2020-12', '294', '2', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '2.15');
INSERT INTO public.europe_data_import VALUES (7883, '16/03/2020', '2020-11', '124', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0.7');
INSERT INTO public.europe_data_import VALUES (7884, '09/03/2020', '2020-10', '12', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0.08');
INSERT INTO public.europe_data_import VALUES (7885, '02/03/2020', '2020-09', '3', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0.02');
INSERT INTO public.europe_data_import VALUES (7886, '24/02/2020', '2020-08', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7887, '17/02/2020', '2020-07', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7888, '10/02/2020', '2020-06', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7889, '03/02/2020', '2020-05', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7890, '27/01/2020', '2020-04', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7891, '20/01/2020', '2020-03', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7892, '13/01/2020', '2020-02', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7893, '06/01/2020', '2020-01', '0', '0', '19414458', 'Romania', 'RO', 'ROU', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (7894, '01/02/2021', '2021-04', '129397', '3701', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '189.91');
INSERT INTO public.europe_data_import VALUES (7895, '25/01/2021', '2021-03', '147624', '3881', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '214.86');
INSERT INTO public.europe_data_import VALUES (7896, '18/01/2021', '2021-02', '165797', '3764', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '226.86');
INSERT INTO public.europe_data_import VALUES (7897, '11/01/2021', '2021-01', '165131', '3285', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '238.04');
INSERT INTO public.europe_data_import VALUES (7898, '04/01/2021', '2020-53', '182103', '3723', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '341.03');
INSERT INTO public.europe_data_import VALUES (7899, '28/12/2020', '2020-52', '315367', '6114', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '290.74');
INSERT INTO public.europe_data_import VALUES (7900, '21/12/2020', '2020-51', '108740', '2210', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '206.96');
INSERT INTO public.europe_data_import VALUES (7901, '14/12/2020', '2020-50', '193158', '3800', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '263.66');
INSERT INTO public.europe_data_import VALUES (7902, '07/12/2020', '2020-49', '191454', '3614', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '254.63');
INSERT INTO public.europe_data_import VALUES (7903, '30/11/2020', '2020-48', '179987', '3348', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '235.47');
INSERT INTO public.europe_data_import VALUES (7904, '23/11/2020', '2020-47', '163504', '2993', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '215.94');
INSERT INTO public.europe_data_import VALUES (7905, '16/11/2020', '2020-46', '151491', '2649', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '198.15');
INSERT INTO public.europe_data_import VALUES (7906, '09/11/2020', '2020-45', '137553', '2302', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '178.55');
INSERT INTO public.europe_data_import VALUES (7907, '02/11/2020', '2020-44', '122904', '2185', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '162.78');
INSERT INTO public.europe_data_import VALUES (7908, '26/10/2020', '2020-43', '114543', '1863', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '147.5');
INSERT INTO public.europe_data_import VALUES (7909, '19/10/2020', '2020-42', '100616', '1590', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '126.37');
INSERT INTO public.europe_data_import VALUES (7910, '12/10/2020', '2020-41', '83717', '1239', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '100.97');
INSERT INTO public.europe_data_import VALUES (7911, '05/10/2020', '2020-40', '63563', '1034', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '76.51');
INSERT INTO public.europe_data_import VALUES (7912, '28/09/2020', '2020-39', '48039', '906', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '60.76');
INSERT INTO public.europe_data_import VALUES (7913, '21/09/2020', '2020-38', '40588', '840', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '53.4');
INSERT INTO public.europe_data_import VALUES (7914, '14/09/2020', '2020-37', '37306', '758', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '49.69');
INSERT INTO public.europe_data_import VALUES (7915, '07/09/2020', '2020-36', '35179', '727', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '47.13');
INSERT INTO public.europe_data_import VALUES (7916, '31/08/2020', '2020-35', '33577', '710', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '46.25');
INSERT INTO public.europe_data_import VALUES (7917, '24/08/2020', '2020-34', '33896', '698', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '47.45');
INSERT INTO public.europe_data_import VALUES (7918, '17/08/2020', '2020-33', '35317', '754', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '49.35');
INSERT INTO public.europe_data_import VALUES (7919, '10/08/2020', '2020-32', '36666', '803', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '51.45');
INSERT INTO public.europe_data_import VALUES (7920, '03/08/2020', '2020-31', '38385', '859', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '54.38');
INSERT INTO public.europe_data_import VALUES (7921, '27/07/2020', '2020-30', '40939', '927', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '58.49');
INSERT INTO public.europe_data_import VALUES (7922, '20/07/2020', '2020-29', '44384', '1007', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '61.9');
INSERT INTO public.europe_data_import VALUES (7923, '13/07/2020', '2020-28', '45911', '1174', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '63.57');
INSERT INTO public.europe_data_import VALUES (7924, '06/07/2020', '2020-27', '46814', '1088', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '66.2');
INSERT INTO public.europe_data_import VALUES (7925, '29/06/2020', '2020-26', '49757', '962', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '72.31');
INSERT INTO public.europe_data_import VALUES (7926, '22/06/2020', '2020-25', '55716', '1163', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '80.21');
INSERT INTO public.europe_data_import VALUES (7927, '15/06/2020', '2020-24', '61291', '1089', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '84.4');
INSERT INTO public.europe_data_import VALUES (7928, '08/06/2020', '2020-23', '61830', '1166', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '84.45');
INSERT INTO public.europe_data_import VALUES (7929, '01/06/2020', '2020-22', '61362', '1152', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '85.07');
INSERT INTO public.europe_data_import VALUES (7930, '25/05/2020', '2020-21', '62729', '910', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '92.4');
INSERT INTO public.europe_data_import VALUES (7931, '18/05/2020', '2020-20', '72064', '716', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '100.82');
INSERT INTO public.europe_data_import VALUES (7932, '11/05/2020', '2020-19', '75001', '635', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '88.25');
INSERT INTO public.europe_data_import VALUES (7933, '04/05/2020', '2020-18', '53738', '533', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '62.96');
INSERT INTO public.europe_data_import VALUES (7934, '27/04/2020', '2020-17', '38096', '386', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '44.68');
INSERT INTO public.europe_data_import VALUES (7935, '20/04/2020', '2020-16', '27083', '231', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '25.68');
INSERT INTO public.europe_data_import VALUES (7936, '13/04/2020', '2020-15', '10381', '85', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '9.76');
INSERT INTO public.europe_data_import VALUES (7937, '06/04/2020', '2020-14', '3855', '37', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '3.44');
INSERT INTO public.europe_data_import VALUES (7938, '30/03/2020', '2020-13', '1167', '8', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '1.01');
INSERT INTO public.europe_data_import VALUES (7939, '23/03/2020', '2020-12', '304', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0.24');
INSERT INTO public.europe_data_import VALUES (7940, '16/03/2020', '2020-11', '53', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0.04');
INSERT INTO public.europe_data_import VALUES (7941, '09/03/2020', '2020-10', '8', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (7942, '02/03/2020', '2020-09', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7943, '24/02/2020', '2020-08', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7944, '17/02/2020', '2020-07', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7945, '10/02/2020', '2020-06', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (7946, '03/02/2020', '2020-05', '2', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (7947, '27/01/2020', '2020-04', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7948, '20/01/2020', '2020-03', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7949, '13/01/2020', '2020-02', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (7950, '06/01/2020', '2020-01', '0', '0', '145872260', 'Russia', 'RU', 'RUS', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (7951, '01/02/2021', '2021-04', '2484', '24', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '35.06');
INSERT INTO public.europe_data_import VALUES (7952, '25/01/2021', '2021-03', '1943', '32', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '26.49');
INSERT INTO public.europe_data_import VALUES (7953, '18/01/2021', '2021-02', '1402', '22', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '18.66');
INSERT INTO public.europe_data_import VALUES (7954, '11/01/2021', '2021-01', '954', '19', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '12.74');
INSERT INTO public.europe_data_import VALUES (7955, '04/01/2021', '2020-53', '655', '26', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '10.95');
INSERT INTO public.europe_data_import VALUES (7956, '28/12/2020', '2020-52', '728', '12', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '10.79');
INSERT INTO public.europe_data_import VALUES (7957, '21/12/2020', '2020-51', '634', '7', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '9.22');
INSERT INTO public.europe_data_import VALUES (7958, '14/12/2020', '2020-50', '530', '5', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '5.86');
INSERT INTO public.europe_data_import VALUES (7959, '07/12/2020', '2020-49', '210', '3', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.67');
INSERT INTO public.europe_data_import VALUES (7960, '30/11/2020', '2020-48', '254', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.67');
INSERT INTO public.europe_data_import VALUES (7961, '23/11/2020', '2020-47', '210', '2', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.51');
INSERT INTO public.europe_data_import VALUES (7962, '16/11/2020', '2020-46', '233', '9', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '2.45');
INSERT INTO public.europe_data_import VALUES (7963, '09/11/2020', '2020-45', '76', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '1.24');
INSERT INTO public.europe_data_import VALUES (7964, '02/11/2020', '2020-44', '80', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (7965, '26/10/2020', '2020-43', '92', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '1.35');
INSERT INTO public.europe_data_import VALUES (7966, '19/10/2020', '2020-42', '78', '3', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.86');
INSERT INTO public.europe_data_import VALUES (7967, '12/10/2020', '2020-41', '30', '2', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (7968, '05/10/2020', '2020-40', '46', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '1.23');
INSERT INTO public.europe_data_import VALUES (7969, '28/09/2020', '2020-39', '109', '3', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '1.81');
INSERT INTO public.europe_data_import VALUES (7970, '21/09/2020', '2020-38', '120', '4', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '2.67');
INSERT INTO public.europe_data_import VALUES (7971, '14/09/2020', '2020-37', '217', '3', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '4.52');
INSERT INTO public.europe_data_import VALUES (7972, '07/09/2020', '2020-36', '354', '3', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '10.18');
INSERT INTO public.europe_data_import VALUES (7973, '31/08/2020', '2020-35', '931', '4', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '12.41');
INSERT INTO public.europe_data_import VALUES (7974, '24/08/2020', '2020-34', '636', '4', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '7.52');
INSERT INTO public.europe_data_import VALUES (7975, '17/08/2020', '2020-33', '313', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.1');
INSERT INTO public.europe_data_import VALUES (7976, '10/08/2020', '2020-32', '78', '2', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '2.53');
INSERT INTO public.europe_data_import VALUES (7977, '03/08/2020', '2020-31', '241', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.8');
INSERT INTO public.europe_data_import VALUES (7978, '27/07/2020', '2020-30', '239', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.83');
INSERT INTO public.europe_data_import VALUES (7979, '20/07/2020', '2020-29', '245', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.78');
INSERT INTO public.europe_data_import VALUES (7980, '13/07/2020', '2020-28', '232', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '3.46');
INSERT INTO public.europe_data_import VALUES (7981, '06/07/2020', '2020-27', '205', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '2.99');
INSERT INTO public.europe_data_import VALUES (7982, '29/06/2020', '2020-26', '172', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '2.52');
INSERT INTO public.europe_data_import VALUES (7983, '22/06/2020', '2020-25', '146', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '2.29');
INSERT INTO public.europe_data_import VALUES (7984, '15/06/2020', '2020-24', '143', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '1.68');
INSERT INTO public.europe_data_import VALUES (7985, '08/06/2020', '2020-23', '69', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (7986, '01/06/2020', '2020-22', '43', '1', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (7987, '25/05/2020', '2020-21', '35', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (7988, '18/05/2020', '2020-20', '8', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (7989, '11/05/2020', '2020-19', '25', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.74');
INSERT INTO public.europe_data_import VALUES (7990, '04/05/2020', '2020-18', '68', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (7991, '27/04/2020', '2020-17', '44', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.51');
INSERT INTO public.europe_data_import VALUES (7992, '20/04/2020', '2020-16', '21', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (7993, '13/04/2020', '2020-15', '22', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (7994, '06/04/2020', '2020-14', '34', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.67');
INSERT INTO public.europe_data_import VALUES (7995, '30/03/2020', '2020-13', '51', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.51');
INSERT INTO public.europe_data_import VALUES (7996, '23/03/2020', '2020-12', '14', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '0.15');
INSERT INTO public.europe_data_import VALUES (7997, '16/03/2020', '2020-11', '5', '0', '12626938', 'Rwanda', 'RW', 'RWA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (7998, '01/02/2021', '2021-04', '3', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '5.68');
INSERT INTO public.europe_data_import VALUES (7999, '25/01/2021', '2021-03', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '1.89');
INSERT INTO public.europe_data_import VALUES (8000, '18/01/2021', '2021-02', '1', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '3.79');
INSERT INTO public.europe_data_import VALUES (8001, '11/01/2021', '2021-01', '1', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '3.79');
INSERT INTO public.europe_data_import VALUES (8002, '04/01/2021', '2020-53', '1', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '5.68');
INSERT INTO public.europe_data_import VALUES (8003, '28/12/2020', '2020-52', '2', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '7.57');
INSERT INTO public.europe_data_import VALUES (8004, '21/12/2020', '2020-51', '2', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '9.46');
INSERT INTO public.europe_data_import VALUES (8005, '14/12/2020', '2020-50', '3', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '11.36');
INSERT INTO public.europe_data_import VALUES (8006, '07/12/2020', '2020-49', '3', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '9.46');
INSERT INTO public.europe_data_import VALUES (8007, '30/11/2020', '2020-48', '2', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '5.68');
INSERT INTO public.europe_data_import VALUES (8008, '23/11/2020', '2020-47', '1', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '1.89');
INSERT INTO public.europe_data_import VALUES (8009, '16/11/2020', '2020-46', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8010, '09/11/2020', '2020-45', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8011, '02/11/2020', '2020-44', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8012, '26/10/2020', '2020-43', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8013, '19/10/2020', '2020-42', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8014, '12/10/2020', '2020-41', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8015, '05/10/2020', '2020-40', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '3.79');
INSERT INTO public.europe_data_import VALUES (8016, '28/09/2020', '2020-39', '2', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '3.79');
INSERT INTO public.europe_data_import VALUES (8017, '21/09/2020', '2020-38', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8018, '14/09/2020', '2020-37', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8019, '07/09/2020', '2020-36', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8020, '31/08/2020', '2020-35', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8021, '24/08/2020', '2020-34', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8022, '17/08/2020', '2020-33', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8023, '10/08/2020', '2020-32', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8024, '03/08/2020', '2020-31', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8025, '27/07/2020', '2020-30', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8026, '20/07/2020', '2020-29', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '1.89');
INSERT INTO public.europe_data_import VALUES (8027, '13/07/2020', '2020-28', '1', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '3.79');
INSERT INTO public.europe_data_import VALUES (8028, '06/07/2020', '2020-27', '1', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '1.89');
INSERT INTO public.europe_data_import VALUES (8029, '29/06/2020', '2020-26', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8030, '22/06/2020', '2020-25', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8031, '15/06/2020', '2020-24', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8032, '08/06/2020', '2020-23', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8033, '01/06/2020', '2020-22', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8034, '25/05/2020', '2020-21', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8035, '18/05/2020', '2020-20', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8036, '11/05/2020', '2020-19', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8037, '04/05/2020', '2020-18', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8038, '27/04/2020', '2020-17', '0', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '5.68');
INSERT INTO public.europe_data_import VALUES (8039, '20/04/2020', '2020-16', '3', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '9.46');
INSERT INTO public.europe_data_import VALUES (8040, '13/04/2020', '2020-15', '2', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '9.46');
INSERT INTO public.europe_data_import VALUES (8041, '06/04/2020', '2020-14', '3', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '18.93');
INSERT INTO public.europe_data_import VALUES (8042, '30/03/2020', '2020-13', '7', '0', '52834', 'Saint_Kitts_and_Nevis', 'KN', 'KNA', 'America', '');
INSERT INTO public.europe_data_import VALUES (8043, '01/02/2021', '2021-04', '490', '2', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '437.65');
INSERT INTO public.europe_data_import VALUES (8044, '25/01/2021', '2021-03', '310', '5', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '264.23');
INSERT INTO public.europe_data_import VALUES (8045, '18/01/2021', '2021-02', '173', '3', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '141.14');
INSERT INTO public.europe_data_import VALUES (8046, '11/01/2021', '2021-01', '85', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '72.76');
INSERT INTO public.europe_data_import VALUES (8047, '04/01/2021', '2020-53', '48', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '36.11');
INSERT INTO public.europe_data_import VALUES (8048, '28/12/2020', '2020-52', '18', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '16.41');
INSERT INTO public.europe_data_import VALUES (8049, '21/12/2020', '2020-51', '12', '1', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '12.04');
INSERT INTO public.europe_data_import VALUES (8050, '14/12/2020', '2020-50', '10', '2', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '9.85');
INSERT INTO public.europe_data_import VALUES (8051, '07/12/2020', '2020-49', '8', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '24.62');
INSERT INTO public.europe_data_import VALUES (8052, '30/11/2020', '2020-48', '37', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '47.05');
INSERT INTO public.europe_data_import VALUES (8053, '23/11/2020', '2020-47', '49', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '48.69');
INSERT INTO public.europe_data_import VALUES (8054, '16/11/2020', '2020-46', '40', '2', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '47.59');
INSERT INTO public.europe_data_import VALUES (8055, '09/11/2020', '2020-45', '47', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '42.12');
INSERT INTO public.europe_data_import VALUES (8056, '02/11/2020', '2020-44', '30', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '27.9');
INSERT INTO public.europe_data_import VALUES (8057, '26/10/2020', '2020-43', '21', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '13.68');
INSERT INTO public.europe_data_import VALUES (8058, '19/10/2020', '2020-42', '4', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '3.28');
INSERT INTO public.europe_data_import VALUES (8059, '12/10/2020', '2020-41', '2', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.09');
INSERT INTO public.europe_data_import VALUES (8060, '05/10/2020', '2020-40', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8061, '28/09/2020', '2020-39', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8062, '21/09/2020', '2020-38', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8063, '14/09/2020', '2020-37', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8064, '07/09/2020', '2020-36', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8065, '31/08/2020', '2020-35', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8066, '24/08/2020', '2020-34', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8067, '17/08/2020', '2020-33', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8068, '10/08/2020', '2020-32', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8069, '03/08/2020', '2020-31', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.09');
INSERT INTO public.europe_data_import VALUES (8070, '27/07/2020', '2020-30', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.09');
INSERT INTO public.europe_data_import VALUES (8071, '20/07/2020', '2020-29', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8072, '13/07/2020', '2020-28', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.64');
INSERT INTO public.europe_data_import VALUES (8073, '06/07/2020', '2020-27', '3', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.64');
INSERT INTO public.europe_data_import VALUES (8074, '29/06/2020', '2020-26', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8075, '22/06/2020', '2020-25', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8076, '15/06/2020', '2020-24', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8077, '08/06/2020', '2020-23', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8078, '01/06/2020', '2020-22', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8079, '25/05/2020', '2020-21', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8080, '18/05/2020', '2020-20', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8081, '11/05/2020', '2020-19', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.64');
INSERT INTO public.europe_data_import VALUES (8082, '04/05/2020', '2020-18', '3', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.64');
INSERT INTO public.europe_data_import VALUES (8083, '27/04/2020', '2020-17', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8084, '20/04/2020', '2020-16', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '0.55');
INSERT INTO public.europe_data_import VALUES (8085, '13/04/2020', '2020-15', '1', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '3.28');
INSERT INTO public.europe_data_import VALUES (8086, '06/04/2020', '2020-14', '5', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '6.56');
INSERT INTO public.europe_data_import VALUES (8087, '30/03/2020', '2020-13', '7', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '3.83');
INSERT INTO public.europe_data_import VALUES (8088, '23/03/2020', '2020-12', '0', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '1.09');
INSERT INTO public.europe_data_import VALUES (8089, '16/03/2020', '2020-11', '2', '0', '182795', 'Saint_Lucia', 'LC', 'LCA', 'America', '');
INSERT INTO public.europe_data_import VALUES (8090, '01/02/2021', '2021-04', '205', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '413.23');
INSERT INTO public.europe_data_import VALUES (8091, '25/01/2021', '2021-03', '252', '1', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '449.4');
INSERT INTO public.europe_data_import VALUES (8092, '18/01/2021', '2021-02', '245', '1', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '334.56');
INSERT INTO public.europe_data_import VALUES (8093, '11/01/2021', '2021-01', '125', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '126.59');
INSERT INTO public.europe_data_import VALUES (8094, '04/01/2021', '2020-53', '15', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '18.08');
INSERT INTO public.europe_data_import VALUES (8095, '28/12/2020', '2020-52', '5', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '9.95');
INSERT INTO public.europe_data_import VALUES (8096, '21/12/2020', '2020-51', '6', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '15.37');
INSERT INTO public.europe_data_import VALUES (8097, '14/12/2020', '2020-50', '11', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '11.75');
INSERT INTO public.europe_data_import VALUES (8098, '07/12/2020', '2020-49', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8099, '30/11/2020', '2020-48', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '6.33');
INSERT INTO public.europe_data_import VALUES (8100, '23/11/2020', '2020-47', '6', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '7.23');
INSERT INTO public.europe_data_import VALUES (8101, '16/11/2020', '2020-46', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8102, '09/11/2020', '2020-45', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8103, '02/11/2020', '2020-44', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '7.23');
INSERT INTO public.europe_data_import VALUES (8104, '26/10/2020', '2020-43', '6', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '8.14');
INSERT INTO public.europe_data_import VALUES (8105, '19/10/2020', '2020-42', '3', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8106, '12/10/2020', '2020-41', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8107, '05/10/2020', '2020-40', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8108, '28/09/2020', '2020-39', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8109, '21/09/2020', '2020-38', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8110, '14/09/2020', '2020-37', '3', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '3.62');
INSERT INTO public.europe_data_import VALUES (8111, '07/09/2020', '2020-36', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8112, '31/08/2020', '2020-35', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8113, '24/08/2020', '2020-34', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0.9');
INSERT INTO public.europe_data_import VALUES (8114, '17/08/2020', '2020-33', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '1.81');
INSERT INTO public.europe_data_import VALUES (8115, '10/08/2020', '2020-32', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '4.52');
INSERT INTO public.europe_data_import VALUES (8116, '03/08/2020', '2020-31', '3', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '4.52');
INSERT INTO public.europe_data_import VALUES (8117, '27/07/2020', '2020-30', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '15.37');
INSERT INTO public.europe_data_import VALUES (8118, '20/07/2020', '2020-29', '15', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '18.99');
INSERT INTO public.europe_data_import VALUES (8119, '13/07/2020', '2020-28', '6', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '5.43');
INSERT INTO public.europe_data_import VALUES (8120, '06/07/2020', '2020-27', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8121, '29/06/2020', '2020-26', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '1.81');
INSERT INTO public.europe_data_import VALUES (8122, '22/06/2020', '2020-25', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8123, '15/06/2020', '2020-24', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0.9');
INSERT INTO public.europe_data_import VALUES (8124, '08/06/2020', '2020-23', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '7.23');
INSERT INTO public.europe_data_import VALUES (8125, '01/06/2020', '2020-22', '8', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '8.14');
INSERT INTO public.europe_data_import VALUES (8126, '25/05/2020', '2020-21', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0.9');
INSERT INTO public.europe_data_import VALUES (8127, '18/05/2020', '2020-20', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8128, '11/05/2020', '2020-19', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '2.71');
INSERT INTO public.europe_data_import VALUES (8129, '04/05/2020', '2020-18', '3', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '4.52');
INSERT INTO public.europe_data_import VALUES (8130, '27/04/2020', '2020-17', '2', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '1.81');
INSERT INTO public.europe_data_import VALUES (8131, '20/04/2020', '2020-16', '0', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '4.52');
INSERT INTO public.europe_data_import VALUES (8132, '13/04/2020', '2020-15', '5', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '9.95');
INSERT INTO public.europe_data_import VALUES (8133, '06/04/2020', '2020-14', '6', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '6.33');
INSERT INTO public.europe_data_import VALUES (8134, '30/03/2020', '2020-13', '1', '0', '110593', 'Saint_Vincent_and_the_Grenadines', 'VC', 'VCT', 'America', '');
INSERT INTO public.europe_data_import VALUES (8135, '01/02/2021', '2021-04', '151', '2', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '690.8');
INSERT INTO public.europe_data_import VALUES (8136, '25/01/2021', '2021-03', '87', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '600.82');
INSERT INTO public.europe_data_import VALUES (8137, '18/01/2021', '2021-02', '120', '1', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '853.34');
INSERT INTO public.europe_data_import VALUES (8138, '11/01/2021', '2021-01', '174', '2', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '1137.78');
INSERT INTO public.europe_data_import VALUES (8139, '04/01/2021', '2020-53', '218', '5', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '1120.37');
INSERT INTO public.europe_data_import VALUES (8140, '28/12/2020', '2020-52', '168', '2', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '952.02');
INSERT INTO public.europe_data_import VALUES (8141, '21/12/2020', '2020-51', '160', '4', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '923.0');
INSERT INTO public.europe_data_import VALUES (8142, '14/12/2020', '2020-50', '158', '3', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '1047.8');
INSERT INTO public.europe_data_import VALUES (8143, '07/12/2020', '2020-49', '203', '3', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '1143.59');
INSERT INTO public.europe_data_import VALUES (8144, '30/11/2020', '2020-48', '191', '2', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '966.53');
INSERT INTO public.europe_data_import VALUES (8145, '23/11/2020', '2020-47', '142', '1', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '1021.68');
INSERT INTO public.europe_data_import VALUES (8146, '16/11/2020', '2020-46', '210', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '943.31');
INSERT INTO public.europe_data_import VALUES (8147, '09/11/2020', '2020-45', '115', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '650.16');
INSERT INTO public.europe_data_import VALUES (8148, '02/11/2020', '2020-44', '109', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '490.52');
INSERT INTO public.europe_data_import VALUES (8149, '26/10/2020', '2020-43', '60', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '194.47');
INSERT INTO public.europe_data_import VALUES (8150, '19/10/2020', '2020-42', '7', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '78.37');
INSERT INTO public.europe_data_import VALUES (8151, '12/10/2020', '2020-41', '20', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '72.56');
INSERT INTO public.europe_data_import VALUES (8152, '05/10/2020', '2020-40', '5', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '26.12');
INSERT INTO public.europe_data_import VALUES (8153, '28/09/2020', '2020-39', '4', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '14.51');
INSERT INTO public.europe_data_import VALUES (8154, '21/09/2020', '2020-38', '1', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '20.32');
INSERT INTO public.europe_data_import VALUES (8155, '14/09/2020', '2020-37', '6', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '34.83');
INSERT INTO public.europe_data_import VALUES (8156, '07/09/2020', '2020-36', '6', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '17.42');
INSERT INTO public.europe_data_import VALUES (8157, '31/08/2020', '2020-35', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8158, '24/08/2020', '2020-34', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8159, '17/08/2020', '2020-33', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '31.93');
INSERT INTO public.europe_data_import VALUES (8160, '10/08/2020', '2020-32', '11', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '31.93');
INSERT INTO public.europe_data_import VALUES (8161, '03/08/2020', '2020-31', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8162, '27/07/2020', '2020-30', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8163, '20/07/2020', '2020-29', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '2.9');
INSERT INTO public.europe_data_import VALUES (8164, '13/07/2020', '2020-28', '1', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '2.9');
INSERT INTO public.europe_data_import VALUES (8165, '06/07/2020', '2020-27', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '5.81');
INSERT INTO public.europe_data_import VALUES (8166, '29/06/2020', '2020-26', '2', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '11.61');
INSERT INTO public.europe_data_import VALUES (8167, '22/06/2020', '2020-25', '2', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '26.12');
INSERT INTO public.europe_data_import VALUES (8168, '15/06/2020', '2020-24', '7', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '66.76');
INSERT INTO public.europe_data_import VALUES (8169, '08/06/2020', '2020-23', '16', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '63.86');
INSERT INTO public.europe_data_import VALUES (8170, '01/06/2020', '2020-22', '6', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '49.34');
INSERT INTO public.europe_data_import VALUES (8171, '25/05/2020', '2020-21', '11', '1', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '107.39');
INSERT INTO public.europe_data_import VALUES (8172, '18/05/2020', '2020-20', '26', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '208.98');
INSERT INTO public.europe_data_import VALUES (8173, '11/05/2020', '2020-19', '46', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '261.23');
INSERT INTO public.europe_data_import VALUES (8174, '04/05/2020', '2020-18', '44', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '351.2');
INSERT INTO public.europe_data_import VALUES (8175, '27/04/2020', '2020-17', '77', '2', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '528.26');
INSERT INTO public.europe_data_import VALUES (8176, '20/04/2020', '2020-16', '105', '4', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '565.99');
INSERT INTO public.europe_data_import VALUES (8177, '13/04/2020', '2020-15', '90', '3', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '368.62');
INSERT INTO public.europe_data_import VALUES (8178, '06/04/2020', '2020-14', '37', '8', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '333.79');
INSERT INTO public.europe_data_import VALUES (8179, '30/03/2020', '2020-13', '78', '4', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '380.23');
INSERT INTO public.europe_data_import VALUES (8180, '23/03/2020', '2020-12', '53', '13', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '330.89');
INSERT INTO public.europe_data_import VALUES (8181, '16/03/2020', '2020-11', '61', '6', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '261.23');
INSERT INTO public.europe_data_import VALUES (8182, '09/03/2020', '2020-10', '29', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '107.39');
INSERT INTO public.europe_data_import VALUES (8183, '02/03/2020', '2020-09', '8', '1', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '23.22');
INSERT INTO public.europe_data_import VALUES (8184, '24/02/2020', '2020-08', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8185, '17/02/2020', '2020-07', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8186, '10/02/2020', '2020-06', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8187, '03/02/2020', '2020-05', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8188, '27/01/2020', '2020-04', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8189, '20/01/2020', '2020-03', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8190, '13/01/2020', '2020-02', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8191, '06/01/2020', '2020-01', '0', '0', '34453', 'San_Marino', 'SM', 'SMR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (8192, '01/02/2021', '2021-04', '58', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '48.83');
INSERT INTO public.europe_data_import VALUES (8193, '25/01/2021', '2021-03', '47', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '57.2');
INSERT INTO public.europe_data_import VALUES (8194, '18/01/2021', '2021-02', '76', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '54.87');
INSERT INTO public.europe_data_import VALUES (8195, '11/01/2021', '2021-01', '42', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '24.18');
INSERT INTO public.europe_data_import VALUES (8196, '04/01/2021', '2020-53', '10', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '5.58');
INSERT INTO public.europe_data_import VALUES (8197, '28/12/2020', '2020-52', '2', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '2.33');
INSERT INTO public.europe_data_import VALUES (8198, '21/12/2020', '2020-51', '3', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '6.05');
INSERT INTO public.europe_data_import VALUES (8199, '14/12/2020', '2020-50', '10', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '9.3');
INSERT INTO public.europe_data_import VALUES (8200, '07/12/2020', '2020-49', '10', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '9.3');
INSERT INTO public.europe_data_import VALUES (8201, '30/11/2020', '2020-48', '10', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '11.16');
INSERT INTO public.europe_data_import VALUES (8202, '23/11/2020', '2020-47', '14', '1', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '7.91');
INSERT INTO public.europe_data_import VALUES (8203, '16/11/2020', '2020-46', '3', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '7.44');
INSERT INTO public.europe_data_import VALUES (8204, '09/11/2020', '2020-45', '13', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '10.23');
INSERT INTO public.europe_data_import VALUES (8205, '02/11/2020', '2020-44', '9', '1', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '7.44');
INSERT INTO public.europe_data_import VALUES (8206, '26/10/2020', '2020-43', '7', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8207, '19/10/2020', '2020-42', '4', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '9.3');
INSERT INTO public.europe_data_import VALUES (8208, '12/10/2020', '2020-41', '16', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '8.37');
INSERT INTO public.europe_data_import VALUES (8209, '05/10/2020', '2020-40', '2', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '2.33');
INSERT INTO public.europe_data_import VALUES (8210, '28/09/2020', '2020-39', '3', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '2.33');
INSERT INTO public.europe_data_import VALUES (8211, '21/09/2020', '2020-38', '2', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '4.65');
INSERT INTO public.europe_data_import VALUES (8212, '14/09/2020', '2020-37', '8', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '4.65');
INSERT INTO public.europe_data_import VALUES (8213, '07/09/2020', '2020-36', '2', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '2.79');
INSERT INTO public.europe_data_import VALUES (8214, '31/08/2020', '2020-35', '4', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8215, '24/08/2020', '2020-34', '7', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '6.51');
INSERT INTO public.europe_data_import VALUES (8216, '17/08/2020', '2020-33', '7', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8217, '10/08/2020', '2020-32', '4', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '6.98');
INSERT INTO public.europe_data_import VALUES (8218, '03/08/2020', '2020-31', '11', '1', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '59.52');
INSERT INTO public.europe_data_import VALUES (8219, '27/07/2020', '2020-30', '117', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '62.31');
INSERT INTO public.europe_data_import VALUES (8220, '20/07/2020', '2020-29', '17', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '12.09');
INSERT INTO public.europe_data_import VALUES (8221, '13/07/2020', '2020-28', '9', '1', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '7.44');
INSERT INTO public.europe_data_import VALUES (8222, '06/07/2020', '2020-27', '7', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '10.23');
INSERT INTO public.europe_data_import VALUES (8223, '29/06/2020', '2020-26', '15', '1', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '24.18');
INSERT INTO public.europe_data_import VALUES (8224, '22/06/2020', '2020-25', '37', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '85.56');
INSERT INTO public.europe_data_import VALUES (8225, '15/06/2020', '2020-24', '147', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '82.77');
INSERT INTO public.europe_data_import VALUES (8226, '08/06/2020', '2020-23', '31', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '99.98');
INSERT INTO public.europe_data_import VALUES (8227, '01/06/2020', '2020-22', '184', '3', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '115.32');
INSERT INTO public.europe_data_import VALUES (8228, '25/05/2020', '2020-21', '64', '2', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '42.32');
INSERT INTO public.europe_data_import VALUES (8229, '18/05/2020', '2020-20', '27', '2', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '100.91');
INSERT INTO public.europe_data_import VALUES (8230, '11/05/2020', '2020-19', '190', '4', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '93.0');
INSERT INTO public.europe_data_import VALUES (8231, '04/05/2020', '2020-18', '10', '1', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '6.51');
INSERT INTO public.europe_data_import VALUES (8232, '27/04/2020', '2020-17', '4', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '1.86');
INSERT INTO public.europe_data_import VALUES (8233, '20/04/2020', '2020-16', '0', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '1.86');
INSERT INTO public.europe_data_import VALUES (8234, '13/04/2020', '2020-15', '4', '0', '215048', 'Sao_Tome_and_Principe', 'ST', 'STP', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8235, '01/02/2021', '2021-04', '1703', '23', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '9.18');
INSERT INTO public.europe_data_import VALUES (8236, '25/01/2021', '2021-03', '1442', '29', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '7.48');
INSERT INTO public.europe_data_import VALUES (8237, '18/01/2021', '2021-02', '1120', '32', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '5.18');
INSERT INTO public.europe_data_import VALUES (8238, '11/01/2021', '2021-01', '654', '35', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '4.64');
INSERT INTO public.europe_data_import VALUES (8239, '04/01/2021', '2020-53', '935', '71', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '6.26');
INSERT INTO public.europe_data_import VALUES (8240, '28/12/2020', '2020-52', '1210', '63', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '6.81');
INSERT INTO public.europe_data_import VALUES (8241, '21/12/2020', '2020-51', '1122', '74', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '6.7');
INSERT INTO public.europe_data_import VALUES (8242, '14/12/2020', '2020-50', '1175', '83', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '8.05');
INSERT INTO public.europe_data_import VALUES (8243, '07/12/2020', '2020-49', '1585', '81', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '10.08');
INSERT INTO public.europe_data_import VALUES (8244, '30/11/2020', '2020-48', '1870', '104', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '11.3');
INSERT INTO public.europe_data_import VALUES (8245, '23/11/2020', '2020-47', '2003', '123', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '13.62');
INSERT INTO public.europe_data_import VALUES (8246, '16/11/2020', '2020-46', '2663', '117', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '16.34');
INSERT INTO public.europe_data_import VALUES (8247, '09/11/2020', '2020-45', '2936', '138', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '16.68');
INSERT INTO public.europe_data_import VALUES (8248, '02/11/2020', '2020-44', '2781', '106', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '15.92');
INSERT INTO public.europe_data_import VALUES (8249, '26/10/2020', '2020-43', '2673', '111', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '16.36');
INSERT INTO public.europe_data_import VALUES (8250, '19/10/2020', '2020-42', '2935', '142', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '16.97');
INSERT INTO public.europe_data_import VALUES (8251, '12/10/2020', '2020-41', '2880', '168', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '17.72');
INSERT INTO public.europe_data_import VALUES (8252, '05/10/2020', '2020-40', '3194', '192', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '19.36');
INSERT INTO public.europe_data_import VALUES (8253, '28/09/2020', '2020-39', '3439', '198', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '22.01');
INSERT INTO public.europe_data_import VALUES (8254, '21/09/2020', '2020-38', '4103', '217', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '26.05');
INSERT INTO public.europe_data_import VALUES (8255, '14/09/2020', '2020-37', '4824', '187', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '31.6');
INSERT INTO public.europe_data_import VALUES (8256, '07/09/2020', '2020-36', '6006', '211', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '38.95');
INSERT INTO public.europe_data_import VALUES (8257, '31/08/2020', '2020-35', '7342', '221', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '47.5');
INSERT INTO public.europe_data_import VALUES (8258, '24/08/2020', '2020-34', '8937', '241', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '54.83');
INSERT INTO public.europe_data_import VALUES (8259, '17/08/2020', '2020-33', '9852', '241', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '57.51');
INSERT INTO public.europe_data_import VALUES (8260, '10/08/2020', '2020-32', '9855', '250', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '63.47');
INSERT INTO public.europe_data_import VALUES (8261, '03/08/2020', '2020-31', '11894', '184', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '81.46');
INSERT INTO public.europe_data_import VALUES (8262, '27/07/2020', '2020-30', '16021', '247', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '101.21');
INSERT INTO public.europe_data_import VALUES (8263, '20/07/2020', '2020-29', '18661', '263', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '120.84');
INSERT INTO public.europe_data_import VALUES (8264, '13/07/2020', '2020-28', '22750', '307', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '145.22');
INSERT INTO public.europe_data_import VALUES (8265, '06/07/2020', '2020-27', '27016', '365', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '151.44');
INSERT INTO public.europe_data_import VALUES (8266, '29/06/2020', '2020-26', '24881', '284', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '160.36');
INSERT INTO public.europe_data_import VALUES (8267, '22/06/2020', '2020-25', '30071', '295', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '162.53');
INSERT INTO public.europe_data_import VALUES (8268, '15/06/2020', '2020-24', '25627', '260', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '123.38');
INSERT INTO public.europe_data_import VALUES (8269, '08/06/2020', '2020-23', '16653', '209', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '85.66');
INSERT INTO public.europe_data_import VALUES (8270, '01/06/2020', '2020-22', '12701', '113', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '89.03');
INSERT INTO public.europe_data_import VALUES (8271, '25/05/2020', '2020-21', '17808', '78', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '97.79');
INSERT INTO public.europe_data_import VALUES (8272, '18/05/2020', '2020-20', '15704', '66', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '80.95');
INSERT INTO public.europe_data_import VALUES (8273, '11/05/2020', '2020-19', '12037', '62', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '62.82');
INSERT INTO public.europe_data_import VALUES (8274, '04/05/2020', '2020-18', '9489', '45', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '51.5');
INSERT INTO public.europe_data_import VALUES (8275, '27/04/2020', '2020-17', '8160', '42', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '38.11');
INSERT INTO public.europe_data_import VALUES (8276, '20/04/2020', '2020-16', '4900', '38', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '20.36');
INSERT INTO public.europe_data_import VALUES (8277, '13/04/2020', '2020-15', '2077', '25', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '9.43');
INSERT INTO public.europe_data_import VALUES (8278, '06/04/2020', '2020-14', '1156', '26', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '5.47');
INSERT INTO public.europe_data_import VALUES (8279, '30/03/2020', '2020-13', '718', '8', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '3.24');
INSERT INTO public.europe_data_import VALUES (8280, '23/03/2020', '2020-12', '393', '0', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '1.46');
INSERT INTO public.europe_data_import VALUES (8281, '16/03/2020', '2020-11', '107', '0', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '0.34');
INSERT INTO public.europe_data_import VALUES (8282, '09/03/2020', '2020-10', '11', '0', '34268529', 'Saudi_Arabia', 'SA', 'SAU', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (8283, '01/02/2021', '2021-04', '1934', '56', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '22.72');
INSERT INTO public.europe_data_import VALUES (8284, '25/01/2021', '2021-03', '1769', '56', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '21.23');
INSERT INTO public.europe_data_import VALUES (8285, '18/01/2021', '2021-02', '1691', '57', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '20.99');
INSERT INTO public.europe_data_import VALUES (8286, '11/01/2021', '2021-01', '1730', '45', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '17.21');
INSERT INTO public.europe_data_import VALUES (8287, '04/01/2021', '2020-53', '1075', '34', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '12.55');
INSERT INTO public.europe_data_import VALUES (8288, '28/12/2020', '2020-52', '970', '25', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '10.14');
INSERT INTO public.europe_data_import VALUES (8289, '21/12/2020', '2020-51', '683', '16', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '7.86');
INSERT INTO public.europe_data_import VALUES (8290, '14/12/2020', '2020-50', '598', '11', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '6.14');
INSERT INTO public.europe_data_import VALUES (8291, '07/12/2020', '2020-49', '402', '5', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '3.65');
INSERT INTO public.europe_data_import VALUES (8292, '30/11/2020', '2020-48', '193', '3', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '1.73');
INSERT INTO public.europe_data_import VALUES (8293, '23/11/2020', '2020-47', '89', '2', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '1.07');
INSERT INTO public.europe_data_import VALUES (8294, '16/11/2020', '2020-46', '85', '2', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '1.0');
INSERT INTO public.europe_data_import VALUES (8295, '09/11/2020', '2020-45', '78', '1', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (8296, '02/11/2020', '2020-44', '79', '4', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '1.3');
INSERT INTO public.europe_data_import VALUES (8297, '26/10/2020', '2020-43', '133', '4', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '1.74');
INSERT INTO public.europe_data_import VALUES (8298, '19/10/2020', '2020-42', '150', '3', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '1.99');
INSERT INTO public.europe_data_import VALUES (8299, '12/10/2020', '2020-41', '174', '2', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '2.2');
INSERT INTO public.europe_data_import VALUES (8300, '05/10/2020', '2020-40', '185', '4', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '2.33');
INSERT INTO public.europe_data_import VALUES (8301, '28/09/2020', '2020-39', '195', '6', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '3.86');
INSERT INTO public.europe_data_import VALUES (8302, '21/09/2020', '2020-38', '434', '5', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '4.46');
INSERT INTO public.europe_data_import VALUES (8303, '14/09/2020', '2020-37', '293', '7', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '4.44');
INSERT INTO public.europe_data_import VALUES (8304, '07/09/2020', '2020-36', '431', '6', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '6.37');
INSERT INTO public.europe_data_import VALUES (8305, '31/08/2020', '2020-35', '607', '15', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '8.55');
INSERT INTO public.europe_data_import VALUES (8306, '24/08/2020', '2020-34', '787', '16', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '10.89');
INSERT INTO public.europe_data_import VALUES (8307, '17/08/2020', '2020-33', '987', '21', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '11.16');
INSERT INTO public.europe_data_import VALUES (8308, '10/08/2020', '2020-32', '831', '23', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.17');
INSERT INTO public.europe_data_import VALUES (8309, '03/08/2020', '2020-31', '663', '18', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.41');
INSERT INTO public.europe_data_import VALUES (8310, '27/07/2020', '2020-30', '871', '24', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.49');
INSERT INTO public.europe_data_import VALUES (8311, '20/07/2020', '2020-29', '675', '19', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '8.65');
INSERT INTO public.europe_data_import VALUES (8312, '13/07/2020', '2020-28', '735', '15', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.51');
INSERT INTO public.europe_data_import VALUES (8313, '06/07/2020', '2020-27', '814', '28', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.28');
INSERT INTO public.europe_data_import VALUES (8314, '29/06/2020', '2020-26', '698', '21', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.18');
INSERT INTO public.europe_data_import VALUES (8315, '22/06/2020', '2020-25', '798', '24', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '9.57');
INSERT INTO public.europe_data_import VALUES (8316, '15/06/2020', '2020-24', '762', '11', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '8.87');
INSERT INTO public.europe_data_import VALUES (8317, '08/06/2020', '2020-23', '683', '7', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '7.86');
INSERT INTO public.europe_data_import VALUES (8318, '01/06/2020', '2020-22', '598', '7', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '7.15');
INSERT INTO public.europe_data_import VALUES (8319, '25/05/2020', '2020-21', '567', '9', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '8.21');
INSERT INTO public.europe_data_import VALUES (8320, '18/05/2020', '2020-20', '771', '7', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '7.96');
INSERT INTO public.europe_data_import VALUES (8321, '11/05/2020', '2020-19', '527', '10', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '6.37');
INSERT INTO public.europe_data_import VALUES (8322, '04/05/2020', '2020-18', '511', '0', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '5.0');
INSERT INTO public.europe_data_import VALUES (8323, '27/04/2020', '2020-17', '304', '5', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '2.4');
INSERT INTO public.europe_data_import VALUES (8324, '20/04/2020', '2020-16', '87', '2', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (8325, '13/04/2020', '2020-15', '58', '0', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '0.85');
INSERT INTO public.europe_data_import VALUES (8326, '06/04/2020', '2020-14', '80', '2', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '0.95');
INSERT INTO public.europe_data_import VALUES (8327, '30/03/2020', '2020-13', '75', '0', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '0.71');
INSERT INTO public.europe_data_import VALUES (8328, '23/03/2020', '2020-12', '41', '0', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (8329, '16/03/2020', '2020-11', '26', '0', '16296362', 'Senegal', 'SN', 'SEN', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8330, '01/02/2021', '2021-04', '11660', '134', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '326.4');
INSERT INTO public.europe_data_import VALUES (8331, '25/01/2021', '2021-03', '11070', '136', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '343.41');
INSERT INTO public.europe_data_import VALUES (8332, '18/01/2021', '2021-02', '12844', '168', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '411.6');
INSERT INTO public.europe_data_import VALUES (8333, '11/01/2021', '2021-01', '15819', '257', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '446.17');
INSERT INTO public.europe_data_import VALUES (8334, '04/01/2021', '2020-53', '15251', '252', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '576.17');
INSERT INTO public.europe_data_import VALUES (8335, '28/12/2020', '2020-52', '24872', '340', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '893.01');
INSERT INTO public.europe_data_import VALUES (8336, '21/12/2020', '2020-51', '37315', '402', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '1207.61');
INSERT INTO public.europe_data_import VALUES (8337, '14/12/2020', '2020-50', '46780', '382', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '1396.06');
INSERT INTO public.europe_data_import VALUES (8338, '07/12/2020', '2020-49', '50438', '400', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '1414.92');
INSERT INTO public.europe_data_import VALUES (8339, '30/11/2020', '2020-48', '48094', '350', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '1215.52');
INSERT INTO public.europe_data_import VALUES (8340, '23/11/2020', '2020-47', '36552', '190', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '838.24');
INSERT INTO public.europe_data_import VALUES (8341, '16/11/2020', '2020-46', '21821', '119', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '519.33');
INSERT INTO public.europe_data_import VALUES (8342, '09/11/2020', '2020-45', '14344', '64', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '334.03');
INSERT INTO public.europe_data_import VALUES (8343, '02/11/2020', '2020-44', '8917', '34', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '175.81');
INSERT INTO public.europe_data_import VALUES (8344, '26/10/2020', '2020-43', '3326', '16', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '67.48');
INSERT INTO public.europe_data_import VALUES (8345, '19/10/2020', '2020-42', '1373', '13', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '32.44');
INSERT INTO public.europe_data_import VALUES (8346, '12/10/2020', '2020-41', '886', '9', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '20.15');
INSERT INTO public.europe_data_import VALUES (8347, '05/10/2020', '2020-40', '517', '7', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '14.26');
INSERT INTO public.europe_data_import VALUES (8348, '28/09/2020', '2020-39', '476', '6', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '14.02');
INSERT INTO public.europe_data_import VALUES (8349, '21/09/2020', '2020-38', '500', '8', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '14.4');
INSERT INTO public.europe_data_import VALUES (8350, '14/09/2020', '2020-37', '503', '9', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '14.98');
INSERT INTO public.europe_data_import VALUES (8351, '07/09/2020', '2020-36', '540', '13', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '17.92');
INSERT INTO public.europe_data_import VALUES (8352, '31/08/2020', '2020-35', '708', '13', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '24.17');
INSERT INTO public.europe_data_import VALUES (8353, '24/08/2020', '2020-34', '975', '24', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '36.73');
INSERT INTO public.europe_data_import VALUES (8354, '17/08/2020', '2020-33', '1583', '33', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '50.1');
INSERT INTO public.europe_data_import VALUES (8355, '10/08/2020', '2020-32', '1906', '51', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '62.74');
INSERT INTO public.europe_data_import VALUES (8356, '03/08/2020', '2020-31', '2463', '56', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '76.09');
INSERT INTO public.europe_data_import VALUES (8357, '27/07/2020', '2020-30', '2836', '62', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '77.11');
INSERT INTO public.europe_data_import VALUES (8358, '20/07/2020', '2020-29', '2534', '79', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '68.4');
INSERT INTO public.europe_data_import VALUES (8359, '13/07/2020', '2020-28', '2229', '82', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '61.95');
INSERT INTO public.europe_data_import VALUES (8360, '06/07/2020', '2020-27', '2085', '41', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '46.48');
INSERT INTO public.europe_data_import VALUES (8361, '29/06/2020', '2020-26', '1152', '9', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '24.93');
INSERT INTO public.europe_data_import VALUES (8362, '22/06/2020', '2020-25', '584', '7', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '15.38');
INSERT INTO public.europe_data_import VALUES (8363, '15/06/2020', '2020-24', '487', '5', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '12.9');
INSERT INTO public.europe_data_import VALUES (8364, '08/06/2020', '2020-23', '411', '6', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '9.54');
INSERT INTO public.europe_data_import VALUES (8365, '01/06/2020', '2020-22', '253', '5', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '11.52');
INSERT INTO public.europe_data_import VALUES (8366, '25/05/2020', '2020-21', '549', '8', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '15.01');
INSERT INTO public.europe_data_import VALUES (8367, '18/05/2020', '2020-20', '496', '15', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '16.46');
INSERT INTO public.europe_data_import VALUES (8368, '11/05/2020', '2020-19', '650', '22', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '29.75');
INSERT INTO public.europe_data_import VALUES (8369, '04/05/2020', '2020-18', '1422', '37', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '45.18');
INSERT INTO public.europe_data_import VALUES (8370, '27/04/2020', '2020-17', '1724', '34', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '63.36');
INSERT INTO public.europe_data_import VALUES (8371, '20/04/2020', '2020-16', '2688', '42', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '63.33');
INSERT INTO public.europe_data_import VALUES (8372, '13/04/2020', '2020-15', '1722', '29', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '41.49');
INSERT INTO public.europe_data_import VALUES (8373, '06/04/2020', '2020-14', '1167', '38', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '24.7');
INSERT INTO public.europe_data_import VALUES (8374, '30/03/2020', '2020-13', '553', '12', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '9.85');
INSERT INTO public.europe_data_import VALUES (8375, '23/03/2020', '2020-12', '133', '1', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '2.7');
INSERT INTO public.europe_data_import VALUES (8376, '16/03/2020', '2020-11', '55', '0', '6963764', 'Serbia', 'RS', 'SRB', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (8377, '01/02/2021', '2021-04', '154', '2', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '529.97');
INSERT INTO public.europe_data_import VALUES (8378, '25/01/2021', '2021-03', '364', '1', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '550.43');
INSERT INTO public.europe_data_import VALUES (8379, '18/01/2021', '2021-02', '174', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '417.43');
INSERT INTO public.europe_data_import VALUES (8380, '11/01/2021', '2021-01', '234', '2', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '321.26');
INSERT INTO public.europe_data_import VALUES (8381, '04/01/2021', '2020-53', '80', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '94.13');
INSERT INTO public.europe_data_import VALUES (8382, '28/12/2020', '2020-52', '12', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '15.35');
INSERT INTO public.europe_data_import VALUES (8383, '21/12/2020', '2020-51', '3', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '21.49');
INSERT INTO public.europe_data_import VALUES (8384, '14/12/2020', '2020-50', '18', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '29.67');
INSERT INTO public.europe_data_import VALUES (8385, '07/12/2020', '2020-49', '11', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '18.42');
INSERT INTO public.europe_data_import VALUES (8386, '30/11/2020', '2020-48', '7', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '15.35');
INSERT INTO public.europe_data_import VALUES (8387, '23/11/2020', '2020-47', '8', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '8.18');
INSERT INTO public.europe_data_import VALUES (8388, '16/11/2020', '2020-46', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8389, '09/11/2020', '2020-45', '5', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8390, '02/11/2020', '2020-44', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (8391, '26/10/2020', '2020-43', '4', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8392, '19/10/2020', '2020-42', '1', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (8393, '12/10/2020', '2020-41', '3', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8394, '05/10/2020', '2020-40', '2', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (8395, '28/09/2020', '2020-39', '2', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (8396, '21/09/2020', '2020-38', '2', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (8397, '14/09/2020', '2020-37', '2', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '3.07');
INSERT INTO public.europe_data_import VALUES (8398, '07/09/2020', '2020-36', '1', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8399, '31/08/2020', '2020-35', '4', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '9.21');
INSERT INTO public.europe_data_import VALUES (8400, '24/08/2020', '2020-34', '5', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '6.14');
INSERT INTO public.europe_data_import VALUES (8401, '17/08/2020', '2020-33', '1', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '13.3');
INSERT INTO public.europe_data_import VALUES (8402, '10/08/2020', '2020-32', '12', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '12.28');
INSERT INTO public.europe_data_import VALUES (8403, '03/08/2020', '2020-31', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '14.32');
INSERT INTO public.europe_data_import VALUES (8404, '27/07/2020', '2020-30', '14', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '14.32');
INSERT INTO public.europe_data_import VALUES (8405, '20/07/2020', '2020-29', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '91.06');
INSERT INTO public.europe_data_import VALUES (8406, '13/07/2020', '2020-28', '89', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '91.06');
INSERT INTO public.europe_data_import VALUES (8407, '06/07/2020', '2020-27', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8408, '29/06/2020', '2020-26', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8409, '22/06/2020', '2020-25', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8410, '15/06/2020', '2020-24', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8411, '08/06/2020', '2020-23', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8412, '01/06/2020', '2020-22', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8413, '25/05/2020', '2020-21', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8414, '18/05/2020', '2020-20', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8415, '11/05/2020', '2020-19', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8416, '04/05/2020', '2020-18', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8417, '27/04/2020', '2020-17', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (8418, '20/04/2020', '2020-16', '1', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (8419, '13/04/2020', '2020-15', '0', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '2.05');
INSERT INTO public.europe_data_import VALUES (8420, '06/04/2020', '2020-14', '2', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '3.07');
INSERT INTO public.europe_data_import VALUES (8421, '30/03/2020', '2020-13', '1', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8422, '23/03/2020', '2020-12', '4', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '7.16');
INSERT INTO public.europe_data_import VALUES (8423, '16/03/2020', '2020-11', '3', '0', '97741', 'Seychelles', 'SC', 'SYC', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8424, '01/02/2021', '2021-04', '461', '2', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '8.04');
INSERT INTO public.europe_data_import VALUES (8425, '25/01/2021', '2021-03', '167', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '4.19');
INSERT INTO public.europe_data_import VALUES (8426, '18/01/2021', '2021-02', '160', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '4.26');
INSERT INTO public.europe_data_import VALUES (8427, '11/01/2021', '2021-01', '173', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '3.66');
INSERT INTO public.europe_data_import VALUES (8428, '04/01/2021', '2020-53', '113', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '2.1');
INSERT INTO public.europe_data_import VALUES (8429, '28/12/2020', '2020-52', '51', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.47');
INSERT INTO public.europe_data_import VALUES (8430, '21/12/2020', '2020-51', '64', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.06');
INSERT INTO public.europe_data_import VALUES (8431, '14/12/2020', '2020-50', '19', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.44');
INSERT INTO public.europe_data_import VALUES (8432, '07/12/2020', '2020-49', '15', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (8433, '30/11/2020', '2020-48', '6', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (8434, '23/11/2020', '2020-47', '14', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (8435, '16/11/2020', '2020-46', '10', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (8436, '09/11/2020', '2020-45', '15', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.45');
INSERT INTO public.europe_data_import VALUES (8437, '02/11/2020', '2020-44', '20', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.46');
INSERT INTO public.europe_data_import VALUES (8438, '26/10/2020', '2020-43', '16', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.51');
INSERT INTO public.europe_data_import VALUES (8439, '19/10/2020', '2020-42', '24', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.78');
INSERT INTO public.europe_data_import VALUES (8440, '12/10/2020', '2020-41', '37', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.16');
INSERT INTO public.europe_data_import VALUES (8441, '05/10/2020', '2020-40', '54', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.29');
INSERT INTO public.europe_data_import VALUES (8442, '28/09/2020', '2020-39', '47', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (8443, '21/09/2020', '2020-38', '59', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.46');
INSERT INTO public.europe_data_import VALUES (8444, '14/09/2020', '2020-37', '55', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.11');
INSERT INTO public.europe_data_import VALUES (8445, '07/09/2020', '2020-36', '32', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.79');
INSERT INTO public.europe_data_import VALUES (8446, '31/08/2020', '2020-35', '30', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.84');
INSERT INTO public.europe_data_import VALUES (8447, '24/08/2020', '2020-34', '36', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.97');
INSERT INTO public.europe_data_import VALUES (8448, '17/08/2020', '2020-33', '40', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.45');
INSERT INTO public.europe_data_import VALUES (8449, '10/08/2020', '2020-32', '73', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.7');
INSERT INTO public.europe_data_import VALUES (8450, '03/08/2020', '2020-31', '60', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.69');
INSERT INTO public.europe_data_import VALUES (8451, '27/07/2020', '2020-30', '72', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.89');
INSERT INTO public.europe_data_import VALUES (8452, '20/07/2020', '2020-29', '76', '2', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '2.16');
INSERT INTO public.europe_data_import VALUES (8453, '13/07/2020', '2020-28', '93', '1', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '2.66');
INSERT INTO public.europe_data_import VALUES (8454, '06/07/2020', '2020-27', '115', '2', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '2.75');
INSERT INTO public.europe_data_import VALUES (8455, '29/06/2020', '2020-26', '100', '5', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '3.3');
INSERT INTO public.europe_data_import VALUES (8456, '22/06/2020', '2020-25', '158', '4', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '4.58');
INSERT INTO public.europe_data_import VALUES (8457, '15/06/2020', '2020-24', '200', '3', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '3.94');
INSERT INTO public.europe_data_import VALUES (8458, '08/06/2020', '2020-23', '108', '2', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '3.35');
INSERT INTO public.europe_data_import VALUES (8459, '01/06/2020', '2020-22', '154', '6', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '4.56');
INSERT INTO public.europe_data_import VALUES (8460, '25/05/2020', '2020-21', '202', '8', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (8461, '18/05/2020', '2020-20', '198', '14', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '4.45');
INSERT INTO public.europe_data_import VALUES (8462, '11/05/2020', '2020-19', '150', '10', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '2.74');
INSERT INTO public.europe_data_import VALUES (8463, '04/05/2020', '2020-18', '64', '4', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.56');
INSERT INTO public.europe_data_import VALUES (8464, '27/04/2020', '2020-17', '58', '4', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '1.06');
INSERT INTO public.europe_data_import VALUES (8465, '20/04/2020', '2020-16', '25', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (8466, '13/04/2020', '2020-15', '4', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (8467, '06/04/2020', '2020-14', '6', '0', '7813207', 'Sierra_Leone', 'SL', 'SLE', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8468, '01/02/2021', '2021-04', '228', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '7.29');
INSERT INTO public.europe_data_import VALUES (8469, '25/01/2021', '2021-03', '195', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '6.91');
INSERT INTO public.europe_data_import VALUES (8470, '18/01/2021', '2021-02', '206', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '7.17');
INSERT INTO public.europe_data_import VALUES (8471, '11/01/2021', '2021-01', '210', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '6.6');
INSERT INTO public.europe_data_import VALUES (8472, '04/01/2021', '2020-53', '173', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '4.74');
INSERT INTO public.europe_data_import VALUES (8473, '28/12/2020', '2020-52', '102', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '3.51');
INSERT INTO public.europe_data_import VALUES (8474, '21/12/2020', '2020-51', '102', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '2.79');
INSERT INTO public.europe_data_import VALUES (8475, '14/12/2020', '2020-50', '60', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.84');
INSERT INTO public.europe_data_import VALUES (8476, '07/12/2020', '2020-49', '47', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.72');
INSERT INTO public.europe_data_import VALUES (8477, '30/11/2020', '2020-48', '53', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.62');
INSERT INTO public.europe_data_import VALUES (8478, '23/11/2020', '2020-47', '41', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.79');
INSERT INTO public.europe_data_import VALUES (8479, '16/11/2020', '2020-46', '63', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.72');
INSERT INTO public.europe_data_import VALUES (8480, '09/11/2020', '2020-45', '37', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.48');
INSERT INTO public.europe_data_import VALUES (8481, '02/11/2020', '2020-44', '49', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.86');
INSERT INTO public.europe_data_import VALUES (8482, '26/10/2020', '2020-43', '59', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.62');
INSERT INTO public.europe_data_import VALUES (8483, '19/10/2020', '2020-42', '35', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.71');
INSERT INTO public.europe_data_import VALUES (8484, '12/10/2020', '2020-41', '64', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '3.03');
INSERT INTO public.europe_data_import VALUES (8485, '05/10/2020', '2020-40', '112', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '4.07');
INSERT INTO public.europe_data_import VALUES (8486, '28/09/2020', '2020-39', '124', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '5.07');
INSERT INTO public.europe_data_import VALUES (8487, '21/09/2020', '2020-38', '170', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '9.54');
INSERT INTO public.europe_data_import VALUES (8488, '14/09/2020', '2020-37', '384', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '10.94');
INSERT INTO public.europe_data_import VALUES (8489, '07/09/2020', '2020-36', '251', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '11.53');
INSERT INTO public.europe_data_import VALUES (8490, '31/08/2020', '2020-35', '418', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '17.64');
INSERT INTO public.europe_data_import VALUES (8491, '24/08/2020', '2020-34', '606', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '21.52');
INSERT INTO public.europe_data_import VALUES (8492, '17/08/2020', '2020-33', '643', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '50.34');
INSERT INTO public.europe_data_import VALUES (8493, '10/08/2020', '2020-32', '2279', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '81.58');
INSERT INTO public.europe_data_import VALUES (8494, '03/08/2020', '2020-31', '2456', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '84.64');
INSERT INTO public.europe_data_import VALUES (8495, '27/07/2020', '2020-30', '2457', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '75.94');
INSERT INTO public.europe_data_import VALUES (8496, '20/07/2020', '2020-29', '1951', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '55.96');
INSERT INTO public.europe_data_import VALUES (8497, '13/07/2020', '2020-28', '1297', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '43.11');
INSERT INTO public.europe_data_import VALUES (8498, '06/07/2020', '2020-27', '1205', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '44.26');
INSERT INTO public.europe_data_import VALUES (8499, '29/06/2020', '2020-26', '1364', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '49.19');
INSERT INTO public.europe_data_import VALUES (8500, '22/06/2020', '2020-25', '1491', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '72.1');
INSERT INTO public.europe_data_import VALUES (8501, '15/06/2020', '2020-24', '2694', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '98.55');
INSERT INTO public.europe_data_import VALUES (8502, '08/06/2020', '2020-23', '3026', '2', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '108.44');
INSERT INTO public.europe_data_import VALUES (8503, '01/06/2020', '2020-22', '3268', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '117.95');
INSERT INTO public.europe_data_import VALUES (8504, '25/05/2020', '2020-21', '3578', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '142.65');
INSERT INTO public.europe_data_import VALUES (8505, '18/05/2020', '2020-20', '4702', '2', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '169.41');
INSERT INTO public.europe_data_import VALUES (8506, '11/05/2020', '2020-19', '5131', '2', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '167.32');
INSERT INTO public.europe_data_import VALUES (8507, '04/05/2020', '2020-18', '4581', '6', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '200.14');
INSERT INTO public.europe_data_import VALUES (8508, '27/04/2020', '2020-17', '7036', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '191.1');
INSERT INTO public.europe_data_import VALUES (8509, '20/04/2020', '2020-16', '4056', '3', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '90.95');
INSERT INTO public.europe_data_import VALUES (8510, '13/04/2020', '2020-15', '1223', '2', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '29.08');
INSERT INTO public.europe_data_import VALUES (8511, '06/04/2020', '2020-14', '465', '3', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '14.71');
INSERT INTO public.europe_data_import VALUES (8512, '30/03/2020', '2020-13', '389', '1', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '10.65');
INSERT INTO public.europe_data_import VALUES (8513, '23/03/2020', '2020-12', '229', '2', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '5.25');
INSERT INTO public.europe_data_import VALUES (8514, '16/03/2020', '2020-11', '76', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '2.07');
INSERT INTO public.europe_data_import VALUES (8515, '09/03/2020', '2020-10', '44', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '1.05');
INSERT INTO public.europe_data_import VALUES (8516, '02/03/2020', '2020-09', '17', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0.53');
INSERT INTO public.europe_data_import VALUES (8517, '24/02/2020', '2020-08', '14', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0.79');
INSERT INTO public.europe_data_import VALUES (8518, '17/02/2020', '2020-07', '32', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0.98');
INSERT INTO public.europe_data_import VALUES (8519, '10/02/2020', '2020-06', '25', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0.67');
INSERT INTO public.europe_data_import VALUES (8520, '03/02/2020', '2020-05', '14', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0.31');
INSERT INTO public.europe_data_import VALUES (8521, '27/01/2020', '2020-04', '4', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (8522, '20/01/2020', '2020-03', '0', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8523, '13/01/2020', '2020-02', '0', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8524, '06/01/2020', '2020-01', '0', '0', '5804343', 'Singapore', 'SG', 'SGP', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (8525, '01/02/2021', '2021-04', '112', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '504.85');
INSERT INTO public.europe_data_import VALUES (8526, '25/01/2021', '2021-03', '102', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '431.72');
INSERT INTO public.europe_data_import VALUES (8527, '18/01/2021', '2021-02', '81', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '457.67');
INSERT INTO public.europe_data_import VALUES (8528, '11/01/2021', '2021-01', '113', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '386.89');
INSERT INTO public.europe_data_import VALUES (8529, '04/01/2021', '2020-53', '51', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '292.53');
INSERT INTO public.europe_data_import VALUES (8530, '28/12/2020', '2020-52', '73', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '382.17');
INSERT INTO public.europe_data_import VALUES (8531, '21/12/2020', '2020-51', '89', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '464.74');
INSERT INTO public.europe_data_import VALUES (8532, '14/12/2020', '2020-50', '108', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '431.72');
INSERT INTO public.europe_data_import VALUES (8533, '07/12/2020', '2020-49', '75', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '316.12');
INSERT INTO public.europe_data_import VALUES (8534, '30/11/2020', '2020-48', '59', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '313.76');
INSERT INTO public.europe_data_import VALUES (8535, '23/11/2020', '2020-47', '74', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '261.86');
INSERT INTO public.europe_data_import VALUES (8536, '16/11/2020', '2020-46', '37', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '240.63');
INSERT INTO public.europe_data_import VALUES (8537, '09/11/2020', '2020-45', '65', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '264.22');
INSERT INTO public.europe_data_import VALUES (8538, '02/11/2020', '2020-44', '47', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '184.01');
INSERT INTO public.europe_data_import VALUES (8539, '26/10/2020', '2020-43', '31', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '174.57');
INSERT INTO public.europe_data_import VALUES (8540, '19/10/2020', '2020-42', '43', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '174.57');
INSERT INTO public.europe_data_import VALUES (8541, '12/10/2020', '2020-41', '31', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '155.7');
INSERT INTO public.europe_data_import VALUES (8542, '05/10/2020', '2020-40', '35', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '224.11');
INSERT INTO public.europe_data_import VALUES (8543, '28/09/2020', '2020-39', '60', '2', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '224.11');
INSERT INTO public.europe_data_import VALUES (8544, '21/09/2020', '2020-38', '35', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '172.21');
INSERT INTO public.europe_data_import VALUES (8545, '14/09/2020', '2020-37', '38', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '202.88');
INSERT INTO public.europe_data_import VALUES (8546, '07/09/2020', '2020-36', '48', '2', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '271.3');
INSERT INTO public.europe_data_import VALUES (8547, '31/08/2020', '2020-35', '67', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '344.43');
INSERT INTO public.europe_data_import VALUES (8548, '24/08/2020', '2020-34', '79', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '488.33');
INSERT INTO public.europe_data_import VALUES (8549, '17/08/2020', '2020-33', '128', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '403.41');
INSERT INTO public.europe_data_import VALUES (8550, '10/08/2020', '2020-32', '43', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '224.11');
INSERT INTO public.europe_data_import VALUES (8551, '03/08/2020', '2020-31', '52', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '158.06');
INSERT INTO public.europe_data_import VALUES (8552, '27/07/2020', '2020-30', '15', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '37.75');
INSERT INTO public.europe_data_import VALUES (8553, '20/07/2020', '2020-29', '1', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '2.36');
INSERT INTO public.europe_data_import VALUES (8554, '13/07/2020', '2020-28', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '2.36');
INSERT INTO public.europe_data_import VALUES (8555, '06/07/2020', '2020-27', '1', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '2.36');
INSERT INTO public.europe_data_import VALUES (8556, '29/06/2020', '2020-26', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8557, '22/06/2020', '2020-25', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8558, '15/06/2020', '2020-24', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8559, '08/06/2020', '2020-23', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8560, '01/06/2020', '2020-22', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '0');
INSERT INTO public.europe_data_import VALUES (8561, '25/05/2020', '2020-21', '0', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '2.36');
INSERT INTO public.europe_data_import VALUES (8562, '18/05/2020', '2020-20', '1', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '2.36');
INSERT INTO public.europe_data_import VALUES (8563, '11/05/2020', '2020-19', '0', '2', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '4.72');
INSERT INTO public.europe_data_import VALUES (8564, '04/05/2020', '2020-18', '2', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '21.23');
INSERT INTO public.europe_data_import VALUES (8565, '27/04/2020', '2020-17', '7', '3', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '56.62');
INSERT INTO public.europe_data_import VALUES (8566, '20/04/2020', '2020-16', '17', '1', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '99.08');
INSERT INTO public.europe_data_import VALUES (8567, '13/04/2020', '2020-15', '25', '5', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '110.88');
INSERT INTO public.europe_data_import VALUES (8568, '06/04/2020', '2020-14', '22', '4', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '58.98');
INSERT INTO public.europe_data_import VALUES (8569, '30/03/2020', '2020-13', '3', '0', '42389', 'Sint_Maarten', 'SX', 'SXM', 'America', '');
INSERT INTO public.europe_data_import VALUES (8570, '01/02/2021', '2021-04', '12886', '574', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '468.37');
INSERT INTO public.europe_data_import VALUES (8571, '25/01/2021', '2021-03', '12642', '542', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '512.95');
INSERT INTO public.europe_data_import VALUES (8572, '18/01/2021', '2021-02', '15316', '519', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '665.75');
INSERT INTO public.europe_data_import VALUES (8573, '11/01/2021', '2021-01', '20970', '486', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '751.81');
INSERT INTO public.europe_data_import VALUES (8574, '04/01/2021', '2020-53', '20007', '642', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '674.5');
INSERT INTO public.europe_data_import VALUES (8575, '28/12/2020', '2020-52', '16756', '324', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '644.13');
INSERT INTO public.europe_data_import VALUES (8576, '21/12/2020', '2020-51', '18352', '380', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '634.91');
INSERT INTO public.europe_data_import VALUES (8577, '14/12/2020', '2020-50', '16253', '179', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '499.98');
INSERT INTO public.europe_data_import VALUES (8578, '07/12/2020', '2020-49', '10998', '180', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '375.93');
INSERT INTO public.europe_data_import VALUES (8579, '30/11/2020', '2020-48', '9492', '145', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '347.97');
INSERT INTO public.europe_data_import VALUES (8580, '23/11/2020', '2020-47', '9474', '161', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '380.63');
INSERT INTO public.europe_data_import VALUES (8581, '16/11/2020', '2020-46', '11272', '159', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '492.09');
INSERT INTO public.europe_data_import VALUES (8582, '09/11/2020', '2020-45', '15549', '132', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '580.73');
INSERT INTO public.europe_data_import VALUES (8583, '02/11/2020', '2020-44', '16103', '60', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '552.45');
INSERT INTO public.europe_data_import VALUES (8584, '26/10/2020', '2020-43', '14008', '71', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '440.19');
INSERT INTO public.europe_data_import VALUES (8585, '19/10/2020', '2020-42', '9984', '27', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '306.32');
INSERT INTO public.europe_data_import VALUES (8586, '12/10/2020', '2020-41', '6712', '6', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '197.65');
INSERT INTO public.europe_data_import VALUES (8587, '05/10/2020', '2020-40', '4061', '11', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '118.56');
INSERT INTO public.europe_data_import VALUES (8588, '28/09/2020', '2020-39', '2401', '5', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '65.06');
INSERT INTO public.europe_data_import VALUES (8589, '21/09/2020', '2020-38', '1145', '1', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '37.85');
INSERT INTO public.europe_data_import VALUES (8590, '14/09/2020', '2020-37', '918', '1', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '30.38');
INSERT INTO public.europe_data_import VALUES (8591, '07/09/2020', '2020-36', '738', '4', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '23.08');
INSERT INTO public.europe_data_import VALUES (8592, '31/08/2020', '2020-35', '520', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '17.87');
INSERT INTO public.europe_data_import VALUES (8593, '24/08/2020', '2020-34', '454', '2', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '13.94');
INSERT INTO public.europe_data_import VALUES (8594, '17/08/2020', '2020-33', '306', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '10.24');
INSERT INTO public.europe_data_import VALUES (8595, '10/08/2020', '2020-32', '252', '2', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '7.65');
INSERT INTO public.europe_data_import VALUES (8596, '03/08/2020', '2020-31', '165', '1', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '6.7');
INSERT INTO public.europe_data_import VALUES (8597, '27/07/2020', '2020-30', '200', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '5.1');
INSERT INTO public.europe_data_import VALUES (8598, '20/07/2020', '2020-29', '78', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '3.94');
INSERT INTO public.europe_data_import VALUES (8599, '13/07/2020', '2020-28', '137', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '4.35');
INSERT INTO public.europe_data_import VALUES (8600, '06/07/2020', '2020-27', '100', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '3.25');
INSERT INTO public.europe_data_import VALUES (8601, '29/06/2020', '2020-26', '77', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '2.13');
INSERT INTO public.europe_data_import VALUES (8602, '22/06/2020', '2020-25', '39', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '1.08');
INSERT INTO public.europe_data_import VALUES (8603, '15/06/2020', '2020-24', '20', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '0.48');
INSERT INTO public.europe_data_import VALUES (8604, '08/06/2020', '2020-23', '6', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '0.35');
INSERT INTO public.europe_data_import VALUES (8605, '01/06/2020', '2020-22', '13', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '0.51');
INSERT INTO public.europe_data_import VALUES (8606, '25/05/2020', '2020-21', '15', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '0.95');
INSERT INTO public.europe_data_import VALUES (8607, '18/05/2020', '2020-20', '37', '2', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '1.58');
INSERT INTO public.europe_data_import VALUES (8608, '11/05/2020', '2020-19', '49', '2', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '1.43');
INSERT INTO public.europe_data_import VALUES (8609, '04/05/2020', '2020-18', '29', '6', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '4.53');
INSERT INTO public.europe_data_import VALUES (8610, '27/04/2020', '2020-17', '218', '6', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '11.69');
INSERT INTO public.europe_data_import VALUES (8611, '20/04/2020', '2020-16', '419', '10', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '12.4');
INSERT INTO public.europe_data_import VALUES (8612, '13/04/2020', '2020-15', '257', '2', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '7.45');
INSERT INTO public.europe_data_import VALUES (8613, '06/04/2020', '2020-14', '149', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '5.5');
INSERT INTO public.europe_data_import VALUES (8614, '30/03/2020', '2020-13', '151', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '5.05');
INSERT INTO public.europe_data_import VALUES (8615, '23/03/2020', '2020-12', '124', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '3.3');
INSERT INTO public.europe_data_import VALUES (8616, '16/03/2020', '2020-11', '56', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '1.12');
INSERT INTO public.europe_data_import VALUES (8617, '09/03/2020', '2020-10', '5', '0', '5450421', 'Slovakia', 'SK', 'SVK', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (8618, '01/02/2021', '2021-04', '8334', '171', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '818.83');
INSERT INTO public.europe_data_import VALUES (8619, '25/01/2021', '2021-03', '8705', '210', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '885.48');
INSERT INTO public.europe_data_import VALUES (8620, '18/01/2021', '2021-02', '9721', '224', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1132.97');
INSERT INTO public.europe_data_import VALUES (8621, '11/01/2021', '2021-01', '13855', '256', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1171.89');
INSERT INTO public.europe_data_import VALUES (8622, '04/01/2021', '2020-53', '10531', '307', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '959.15');
INSERT INTO public.europe_data_import VALUES (8623, '28/12/2020', '2020-52', '9428', '216', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '913.69');
INSERT INTO public.europe_data_import VALUES (8624, '21/12/2020', '2020-51', '9585', '156', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '965.64');
INSERT INTO public.europe_data_import VALUES (8625, '14/12/2020', '2020-50', '10509', '954', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1005.96');
INSERT INTO public.europe_data_import VALUES (8626, '07/12/2020', '2020-49', '10424', '331', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '985.0');
INSERT INTO public.europe_data_import VALUES (8627, '30/11/2020', '2020-48', '10073', '264', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '977.41');
INSERT INTO public.europe_data_import VALUES (8628, '23/11/2020', '2020-47', '10266', '152', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '968.18');
INSERT INTO public.europe_data_import VALUES (8629, '16/11/2020', '2020-46', '9881', '129', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '931.95');
INSERT INTO public.europe_data_import VALUES (8630, '09/11/2020', '2020-45', '9512', '146', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1067.37');
INSERT INTO public.europe_data_import VALUES (8631, '02/11/2020', '2020-44', '12699', '53', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1081.5');
INSERT INTO public.europe_data_import VALUES (8632, '26/10/2020', '2020-43', '9806', '22', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '686.48');
INSERT INTO public.europe_data_import VALUES (8633, '19/10/2020', '2020-42', '4479', '19', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '319.38');
INSERT INTO public.europe_data_import VALUES (8634, '12/10/2020', '2020-41', '2167', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '159.31');
INSERT INTO public.europe_data_import VALUES (8635, '05/10/2020', '2020-40', '1148', '4', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '99.86');
INSERT INTO public.europe_data_import VALUES (8636, '28/09/2020', '2020-39', '930', '3', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '79.2');
INSERT INTO public.europe_data_import VALUES (8637, '21/09/2020', '2020-38', '718', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '59.88');
INSERT INTO public.europe_data_import VALUES (8638, '14/09/2020', '2020-37', '528', '1', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '40.22');
INSERT INTO public.europe_data_import VALUES (8639, '07/09/2020', '2020-36', '309', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '25.13');
INSERT INTO public.europe_data_import VALUES (8640, '31/08/2020', '2020-35', '214', '1', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '21.58');
INSERT INTO public.europe_data_import VALUES (8641, '24/08/2020', '2020-34', '235', '3', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '19.32');
INSERT INTO public.europe_data_import VALUES (8642, '17/08/2020', '2020-33', '167', '4', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '11.34');
INSERT INTO public.europe_data_import VALUES (8643, '10/08/2020', '2020-32', '69', '3', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '8.03');
INSERT INTO public.europe_data_import VALUES (8644, '03/08/2020', '2020-31', '98', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '11.25');
INSERT INTO public.europe_data_import VALUES (8645, '27/07/2020', '2020-30', '136', '4', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '11.58');
INSERT INTO public.europe_data_import VALUES (8646, '20/07/2020', '2020-29', '105', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '11.82');
INSERT INTO public.europe_data_import VALUES (8647, '13/07/2020', '2020-28', '141', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '12.49');
INSERT INTO public.europe_data_import VALUES (8648, '06/07/2020', '2020-27', '119', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '8.65');
INSERT INTO public.europe_data_import VALUES (8649, '29/06/2020', '2020-26', '61', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '4.13');
INSERT INTO public.europe_data_import VALUES (8650, '22/06/2020', '2020-25', '25', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1.68');
INSERT INTO public.europe_data_import VALUES (8651, '15/06/2020', '2020-24', '10', '1', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1.06');
INSERT INTO public.europe_data_import VALUES (8652, '08/06/2020', '2020-23', '12', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '0.77');
INSERT INTO public.europe_data_import VALUES (8653, '01/06/2020', '2020-22', '4', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '0.34');
INSERT INTO public.europe_data_import VALUES (8654, '25/05/2020', '2020-21', '3', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '0.43');
INSERT INTO public.europe_data_import VALUES (8655, '18/05/2020', '2020-20', '6', '2', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '1.3');
INSERT INTO public.europe_data_import VALUES (8656, '11/05/2020', '2020-19', '21', '6', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '2.55');
INSERT INTO public.europe_data_import VALUES (8657, '04/05/2020', '2020-18', '32', '14', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '5.24');
INSERT INTO public.europe_data_import VALUES (8658, '27/04/2020', '2020-17', '77', '8', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '9.71');
INSERT INTO public.europe_data_import VALUES (8659, '20/04/2020', '2020-16', '125', '21', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '16.0');
INSERT INTO public.europe_data_import VALUES (8660, '13/04/2020', '2020-15', '208', '25', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '22.83');
INSERT INTO public.europe_data_import VALUES (8661, '06/04/2020', '2020-14', '267', '17', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '28.02');
INSERT INTO public.europe_data_import VALUES (8662, '30/03/2020', '2020-13', '316', '10', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '24.56');
INSERT INTO public.europe_data_import VALUES (8663, '23/03/2020', '2020-12', '195', '1', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '19.13');
INSERT INTO public.europe_data_import VALUES (8664, '16/03/2020', '2020-11', '203', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '10.52');
INSERT INTO public.europe_data_import VALUES (8665, '09/03/2020', '2020-10', '16', '0', '2080908', 'Slovenia', 'SI', 'SVN', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (8666, '01/02/2021', '2021-04', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8667, '25/01/2021', '2021-03', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8668, '18/01/2021', '2021-02', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8669, '11/01/2021', '2021-01', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8670, '04/01/2021', '2020-53', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8671, '28/12/2020', '2020-52', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8672, '21/12/2020', '2020-51', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8673, '14/12/2020', '2020-50', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (8674, '07/12/2020', '2020-49', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0.15');
INSERT INTO public.europe_data_import VALUES (8675, '30/11/2020', '2020-48', '1', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0.15');
INSERT INTO public.europe_data_import VALUES (8676, '23/11/2020', '2020-47', '0', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0.45');
INSERT INTO public.europe_data_import VALUES (8677, '16/11/2020', '2020-46', '3', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '1.19');
INSERT INTO public.europe_data_import VALUES (8678, '09/11/2020', '2020-45', '5', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '1.34');
INSERT INTO public.europe_data_import VALUES (8679, '02/11/2020', '2020-44', '4', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0.75');
INSERT INTO public.europe_data_import VALUES (8680, '26/10/2020', '2020-43', '1', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '0.6');
INSERT INTO public.europe_data_import VALUES (8681, '19/10/2020', '2020-42', '3', '0', '669821', 'Solomon_Islands', 'SB', 'SLB', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (8682, '01/02/2021', '2021-04', '30', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (8683, '25/01/2021', '2021-03', '10', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.18');
INSERT INTO public.europe_data_import VALUES (8684, '18/01/2021', '2021-02', '18', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.19');
INSERT INTO public.europe_data_import VALUES (8685, '11/01/2021', '2021-01', '12', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (8686, '04/01/2021', '2020-53', '24', '3', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (8687, '28/12/2020', '2020-52', '28', '3', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (8688, '21/12/2020', '2020-51', '83', '3', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (8689, '14/12/2020', '2020-50', '54', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.87');
INSERT INTO public.europe_data_import VALUES (8690, '07/12/2020', '2020-49', '80', '8', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (8691, '30/11/2020', '2020-48', '0', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.93');
INSERT INTO public.europe_data_import VALUES (8692, '23/11/2020', '2020-47', '144', '6', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.4');
INSERT INTO public.europe_data_import VALUES (8693, '16/11/2020', '2020-46', '72', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '2.33');
INSERT INTO public.europe_data_import VALUES (8694, '09/11/2020', '2020-45', '288', '3', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.86');
INSERT INTO public.europe_data_import VALUES (8695, '02/11/2020', '2020-44', '0', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (8696, '26/10/2020', '2020-43', '77', '5', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.5');
INSERT INTO public.europe_data_import VALUES (8697, '19/10/2020', '2020-42', '0', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.77');
INSERT INTO public.europe_data_import VALUES (8698, '12/10/2020', '2020-41', '119', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.79');
INSERT INTO public.europe_data_import VALUES (8699, '05/10/2020', '2020-40', '157', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.96');
INSERT INTO public.europe_data_import VALUES (8700, '28/09/2020', '2020-39', '146', '1', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.29');
INSERT INTO public.europe_data_import VALUES (8701, '21/09/2020', '2020-38', '53', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (8702, '14/09/2020', '2020-37', '27', '1', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.51');
INSERT INTO public.europe_data_import VALUES (8703, '07/09/2020', '2020-36', '52', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (8704, '31/08/2020', '2020-35', '41', '4', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (8705, '24/08/2020', '2020-34', '13', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (8706, '17/08/2020', '2020-33', '29', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (8707, '10/08/2020', '2020-32', '15', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (8708, '03/08/2020', '2020-31', '34', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (8709, '27/07/2020', '2020-30', '59', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.77');
INSERT INTO public.europe_data_import VALUES (8710, '20/07/2020', '2020-29', '60', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.79');
INSERT INTO public.europe_data_import VALUES (8711, '13/07/2020', '2020-28', '62', '1', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.07');
INSERT INTO public.europe_data_import VALUES (8712, '06/07/2020', '2020-27', '103', '2', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (8713, '29/06/2020', '2020-26', '115', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.88');
INSERT INTO public.europe_data_import VALUES (8714, '22/06/2020', '2020-25', '176', '2', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '2.88');
INSERT INTO public.europe_data_import VALUES (8715, '15/06/2020', '2020-24', '269', '5', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '4.06');
INSERT INTO public.europe_data_import VALUES (8716, '08/06/2020', '2020-23', '358', '5', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '4.79');
INSERT INTO public.europe_data_import VALUES (8717, '01/06/2020', '2020-22', '382', '17', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '3.59');
INSERT INTO public.europe_data_import VALUES (8718, '25/05/2020', '2020-21', '173', '5', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '3.5');
INSERT INTO public.europe_data_import VALUES (8719, '18/05/2020', '2020-20', '367', '5', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '4.53');
INSERT INTO public.europe_data_import VALUES (8720, '11/05/2020', '2020-19', '332', '19', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '4.0');
INSERT INTO public.europe_data_import VALUES (8721, '04/05/2020', '2020-18', '286', '9', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '3.61');
INSERT INTO public.europe_data_import VALUES (8722, '27/04/2020', '2020-17', '272', '16', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '2.66');
INSERT INTO public.europe_data_import VALUES (8723, '20/04/2020', '2020-16', '139', '5', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '1.02');
INSERT INTO public.europe_data_import VALUES (8724, '13/04/2020', '2020-15', '18', '2', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (8725, '06/04/2020', '2020-14', '4', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (8726, '30/03/2020', '2020-13', '2', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (8727, '23/03/2020', '2020-12', '1', '0', '15442906', 'Somalia', 'SO', 'SOM', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8728, '01/02/2021', '2021-04', '43323', '3525', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '202.16');
INSERT INTO public.europe_data_import VALUES (8729, '25/01/2021', '2021-03', '75060', '3769', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '309.76');
INSERT INTO public.europe_data_import VALUES (8730, '18/01/2021', '2021-02', '106329', '3942', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '405.03');
INSERT INTO public.europe_data_import VALUES (8731, '11/01/2021', '2021-01', '130849', '3586', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '375.23');
INSERT INTO public.europe_data_import VALUES (8732, '04/01/2021', '2020-53', '88877', '2506', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '305.38');
INSERT INTO public.europe_data_import VALUES (8733, '28/12/2020', '2020-52', '89949', '2380', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '257.7');
INSERT INTO public.europe_data_import VALUES (8734, '21/12/2020', '2020-51', '60958', '1415', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '183.33');
INSERT INTO public.europe_data_import VALUES (8735, '14/12/2020', '2020-50', '46399', '1070', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '125.11');
INSERT INTO public.europe_data_import VALUES (8736, '07/12/2020', '2020-49', '26863', '729', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '80.07');
INSERT INTO public.europe_data_import VALUES (8737, '30/11/2020', '2020-48', '20023', '574', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '62.64');
INSERT INTO public.europe_data_import VALUES (8738, '23/11/2020', '2020-47', '16655', '662', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '51.92');
INSERT INTO public.europe_data_import VALUES (8739, '16/11/2020', '2020-46', '13746', '432', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '41.33');
INSERT INTO public.europe_data_import VALUES (8740, '09/11/2020', '2020-45', '10455', '398', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '36.56');
INSERT INTO public.europe_data_import VALUES (8741, '02/11/2020', '2020-44', '10955', '443', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '39.33');
INSERT INTO public.europe_data_import VALUES (8742, '26/10/2020', '2020-43', '12075', '497', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '39.96');
INSERT INTO public.europe_data_import VALUES (8743, '19/10/2020', '2020-42', '11322', '691', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '38.43');
INSERT INTO public.europe_data_import VALUES (8744, '12/10/2020', '2020-41', '11182', '804', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '37.07');
INSERT INTO public.europe_data_import VALUES (8745, '05/10/2020', '2020-40', '10523', '578', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '34.29');
INSERT INTO public.europe_data_import VALUES (8746, '28/09/2020', '2020-39', '9555', '445', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '35.82');
INSERT INTO public.europe_data_import VALUES (8747, '21/09/2020', '2020-38', '11418', '506', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '38.75');
INSERT INTO public.europe_data_import VALUES (8748, '14/09/2020', '2020-37', '11276', '558', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '42.24');
INSERT INTO public.europe_data_import VALUES (8749, '07/09/2020', '2020-36', '13461', '861', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '49.09');
INSERT INTO public.europe_data_import VALUES (8750, '31/08/2020', '2020-35', '15283', '969', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '64.4');
INSERT INTO public.europe_data_import VALUES (8751, '24/08/2020', '2020-34', '22428', '1220', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '85.24');
INSERT INTO public.europe_data_import VALUES (8752, '17/08/2020', '2020-33', '27487', '1431', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '129.55');
INSERT INTO public.europe_data_import VALUES (8753, '10/08/2020', '2020-32', '48373', '2042', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '195.4');
INSERT INTO public.europe_data_import VALUES (8754, '03/08/2020', '2020-31', '66052', '1597', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '251.3');
INSERT INTO public.europe_data_import VALUES (8755, '27/07/2020', '2020-30', '81105', '1736', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '288.93');
INSERT INTO public.europe_data_import VALUES (8756, '20/07/2020', '2020-29', '88086', '954', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '286.17');
INSERT INTO public.europe_data_import VALUES (8757, '13/07/2020', '2020-28', '79492', '880', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '235.85');
INSERT INTO public.europe_data_import VALUES (8758, '06/07/2020', '2020-27', '58616', '743', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '169.83');
INSERT INTO public.europe_data_import VALUES (8759, '29/06/2020', '2020-26', '40832', '526', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '116.29');
INSERT INTO public.europe_data_import VALUES (8760, '22/06/2020', '2020-25', '27264', '450', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '83.71');
INSERT INTO public.europe_data_import VALUES (8761, '15/06/2020', '2020-24', '21753', '482', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '63.79');
INSERT INTO public.europe_data_import VALUES (8762, '08/06/2020', '2020-23', '15602', '315', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '43.89');
INSERT INTO public.europe_data_import VALUES (8763, '01/06/2020', '2020-22', '10100', '254', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '29.32');
INSERT INTO public.europe_data_import VALUES (8764, '25/05/2020', '2020-21', '7068', '165', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '21.46');
INSERT INTO public.europe_data_import VALUES (8765, '18/05/2020', '2020-20', '5500', '70', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '14.91');
INSERT INTO public.europe_data_import VALUES (8766, '11/05/2020', '2020-19', '3232', '63', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '9.34');
INSERT INTO public.europe_data_import VALUES (8767, '04/05/2020', '2020-18', '2237', '44', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '6.19');
INSERT INTO public.europe_data_import VALUES (8768, '27/04/2020', '2020-17', '1388', '33', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '4.05');
INSERT INTO public.europe_data_import VALUES (8769, '20/04/2020', '2020-16', '985', '29', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '2.57');
INSERT INTO public.europe_data_import VALUES (8770, '13/04/2020', '2020-15', '518', '14', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '1.52');
INSERT INTO public.europe_data_import VALUES (8771, '06/04/2020', '2020-14', '375', '9', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '2.36');
INSERT INTO public.europe_data_import VALUES (8772, '30/03/2020', '2020-13', '1006', '2', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '2.1');
INSERT INTO public.europe_data_import VALUES (8773, '23/03/2020', '2020-12', '223', '0', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '0.46');
INSERT INTO public.europe_data_import VALUES (8774, '16/03/2020', '2020-11', '48', '0', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (8775, '09/03/2020', '2020-10', '3', '0', '58558267', 'South_Africa', 'ZA', 'ZAF', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8776, '01/02/2021', '2021-04', '2987', '65', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '11.28');
INSERT INTO public.europe_data_import VALUES (8777, '25/01/2021', '2021-03', '2792', '96', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '12.51');
INSERT INTO public.europe_data_import VALUES (8778, '18/01/2021', '2021-02', '3615', '124', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '16.53');
INSERT INTO public.europe_data_import VALUES (8779, '11/01/2021', '2021-01', '4850', '159', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '22.32');
INSERT INTO public.europe_data_import VALUES (8780, '04/01/2021', '2020-53', '6584', '162', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '26.69');
INSERT INTO public.europe_data_import VALUES (8781, '28/12/2020', '2020-52', '7089', '121', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '27.71');
INSERT INTO public.europe_data_import VALUES (8782, '21/12/2020', '2020-51', '7107', '111', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '24.27');
INSERT INTO public.europe_data_import VALUES (8783, '14/12/2020', '2020-50', '5323', '38', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '18.12');
INSERT INTO public.europe_data_import VALUES (8784, '07/12/2020', '2020-49', '3960', '23', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '13.97');
INSERT INTO public.europe_data_import VALUES (8785, '30/11/2020', '2020-48', '3197', '17', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '10.6');
INSERT INTO public.europe_data_import VALUES (8786, '23/11/2020', '2020-47', '2235', '15', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '6.74');
INSERT INTO public.europe_data_import VALUES (8787, '16/11/2020', '2020-46', '1216', '14', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '3.98');
INSERT INTO public.europe_data_import VALUES (8788, '09/11/2020', '2020-45', '821', '12', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '3.12');
INSERT INTO public.europe_data_import VALUES (8789, '02/11/2020', '2020-44', '777', '11', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.84');
INSERT INTO public.europe_data_import VALUES (8790, '26/10/2020', '2020-43', '680', '13', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.44');
INSERT INTO public.europe_data_import VALUES (8791, '19/10/2020', '2020-42', '572', '11', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.17');
INSERT INTO public.europe_data_import VALUES (8792, '12/10/2020', '2020-41', '539', '11', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.03');
INSERT INTO public.europe_data_import VALUES (8793, '05/10/2020', '2020-40', '503', '16', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.18');
INSERT INTO public.europe_data_import VALUES (8794, '28/09/2020', '2020-39', '616', '21', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.69');
INSERT INTO public.europe_data_import VALUES (8795, '21/09/2020', '2020-38', '760', '22', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '3.41');
INSERT INTO public.europe_data_import VALUES (8796, '14/09/2020', '2020-37', '989', '27', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '4.56');
INSERT INTO public.europe_data_import VALUES (8797, '07/09/2020', '2020-36', '1349', '12', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '7.09');
INSERT INTO public.europe_data_import VALUES (8798, '31/08/2020', '2020-35', '2282', '15', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '8.65');
INSERT INTO public.europe_data_import VALUES (8799, '24/08/2020', '2020-34', '2150', '4', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '5.93');
INSERT INTO public.europe_data_import VALUES (8800, '17/08/2020', '2020-33', '889', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.2');
INSERT INTO public.europe_data_import VALUES (8801, '10/08/2020', '2020-32', '237', '4', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.88');
INSERT INTO public.europe_data_import VALUES (8802, '03/08/2020', '2020-31', '214', '2', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.21');
INSERT INTO public.europe_data_import VALUES (8803, '27/07/2020', '2020-30', '404', '3', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.36');
INSERT INTO public.europe_data_import VALUES (8804, '20/07/2020', '2020-29', '292', '7', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.33');
INSERT INTO public.europe_data_import VALUES (8805, '13/07/2020', '2020-28', '388', '6', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.41');
INSERT INTO public.europe_data_import VALUES (8806, '06/07/2020', '2020-27', '334', '1', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.27');
INSERT INTO public.europe_data_import VALUES (8807, '29/06/2020', '2020-26', '319', '2', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.24');
INSERT INTO public.europe_data_import VALUES (8808, '22/06/2020', '2020-25', '317', '3', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.22');
INSERT INTO public.europe_data_import VALUES (8809, '15/06/2020', '2020-24', '307', '4', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.21');
INSERT INTO public.europe_data_import VALUES (8810, '08/06/2020', '2020-23', '311', '2', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.19');
INSERT INTO public.europe_data_import VALUES (8811, '01/06/2020', '2020-22', '297', '4', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.86');
INSERT INTO public.europe_data_import VALUES (8812, '25/05/2020', '2020-21', '141', '4', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.58');
INSERT INTO public.europe_data_import VALUES (8813, '18/05/2020', '2020-20', '156', '7', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.52');
INSERT INTO public.europe_data_import VALUES (8814, '11/05/2020', '2020-19', '108', '4', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.33');
INSERT INTO public.europe_data_import VALUES (8815, '04/05/2020', '2020-18', '63', '9', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.25');
INSERT INTO public.europe_data_import VALUES (8816, '27/04/2020', '2020-17', '64', '7', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.39');
INSERT INTO public.europe_data_import VALUES (8817, '20/04/2020', '2020-16', '137', '19', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.76');
INSERT INTO public.europe_data_import VALUES (8818, '13/04/2020', '2020-15', '253', '31', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.71');
INSERT INTO public.europe_data_import VALUES (8819, '06/04/2020', '2020-14', '623', '28', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.58');
INSERT INTO public.europe_data_import VALUES (8820, '30/03/2020', '2020-13', '700', '45', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '2.78');
INSERT INTO public.europe_data_import VALUES (8821, '23/03/2020', '2020-12', '725', '38', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '3.08');
INSERT INTO public.europe_data_import VALUES (8822, '16/03/2020', '2020-11', '854', '24', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '7.86');
INSERT INTO public.europe_data_import VALUES (8823, '09/03/2020', '2020-10', '3170', '29', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '12.92');
INSERT INTO public.europe_data_import VALUES (8824, '02/03/2020', '2020-09', '3450', '15', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '8.16');
INSERT INTO public.europe_data_import VALUES (8825, '24/02/2020', '2020-08', '732', '7', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '1.43');
INSERT INTO public.europe_data_import VALUES (8826, '17/02/2020', '2020-07', '3', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (8827, '10/02/2020', '2020-06', '12', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (8828, '03/02/2020', '2020-05', '11', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (8829, '27/01/2020', '2020-04', '3', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (8830, '20/01/2020', '2020-03', '1', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (8831, '13/01/2020', '2020-02', '0', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8832, '06/01/2020', '2020-01', '0', '0', '51225321', 'South_Korea', 'KR', 'KOR', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (8833, '01/02/2021', '2021-04', '249', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '3.32');
INSERT INTO public.europe_data_import VALUES (8834, '25/01/2021', '2021-03', '118', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.14');
INSERT INTO public.europe_data_import VALUES (8835, '18/01/2021', '2021-02', '8', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.73');
INSERT INTO public.europe_data_import VALUES (8836, '11/01/2021', '2021-01', '73', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.55');
INSERT INTO public.europe_data_import VALUES (8837, '04/01/2021', '2020-53', '98', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '3.26');
INSERT INTO public.europe_data_import VALUES (8838, '28/12/2020', '2020-52', '263', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '2.42');
INSERT INTO public.europe_data_import VALUES (8839, '21/12/2020', '2020-51', '5', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.42');
INSERT INTO public.europe_data_import VALUES (8840, '14/12/2020', '2020-50', '42', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (8841, '07/12/2020', '2020-49', '72', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.21');
INSERT INTO public.europe_data_import VALUES (8842, '30/11/2020', '2020-48', '62', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (8843, '23/11/2020', '2020-47', '44', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.83');
INSERT INTO public.europe_data_import VALUES (8844, '16/11/2020', '2020-46', '48', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.7');
INSERT INTO public.europe_data_import VALUES (8845, '09/11/2020', '2020-45', '29', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.65');
INSERT INTO public.europe_data_import VALUES (8846, '02/11/2020', '2020-44', '43', '3', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.76');
INSERT INTO public.europe_data_import VALUES (8847, '26/10/2020', '2020-43', '41', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.96');
INSERT INTO public.europe_data_import VALUES (8848, '19/10/2020', '2020-42', '65', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.05');
INSERT INTO public.europe_data_import VALUES (8849, '12/10/2020', '2020-41', '51', '5', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.82');
INSERT INTO public.europe_data_import VALUES (8850, '05/10/2020', '2020-40', '40', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.76');
INSERT INTO public.europe_data_import VALUES (8851, '28/09/2020', '2020-39', '44', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.98');
INSERT INTO public.europe_data_import VALUES (8852, '21/09/2020', '2020-38', '64', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.89');
INSERT INTO public.europe_data_import VALUES (8853, '14/09/2020', '2020-37', '34', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (8854, '07/09/2020', '2020-36', '25', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.41');
INSERT INTO public.europe_data_import VALUES (8855, '31/08/2020', '2020-35', '20', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (8856, '24/08/2020', '2020-34', '10', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (8857, '17/08/2020', '2020-33', '19', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.54');
INSERT INTO public.europe_data_import VALUES (8858, '10/08/2020', '2020-32', '41', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.88');
INSERT INTO public.europe_data_import VALUES (8859, '03/08/2020', '2020-31', '167', '1', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '2.07');
INSERT INTO public.europe_data_import VALUES (8860, '27/07/2020', '2020-30', '62', '2', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.11');
INSERT INTO public.europe_data_import VALUES (8861, '20/07/2020', '2020-29', '61', '2', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.48');
INSERT INTO public.europe_data_import VALUES (8862, '13/07/2020', '2020-28', '103', '3', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (8863, '06/07/2020', '2020-27', '47', '2', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.39');
INSERT INTO public.europe_data_import VALUES (8864, '29/06/2020', '2020-26', '107', '2', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '2.68');
INSERT INTO public.europe_data_import VALUES (8865, '22/06/2020', '2020-25', '189', '7', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '5.11');
INSERT INTO public.europe_data_import VALUES (8866, '15/06/2020', '2020-24', '376', '13', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '6.32');
INSERT INTO public.europe_data_import VALUES (8867, '08/06/2020', '2020-23', '323', '4', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '6.82');
INSERT INTO public.europe_data_import VALUES (8868, '01/06/2020', '2020-22', '431', '4', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '6.44');
INSERT INTO public.europe_data_import VALUES (8869, '25/05/2020', '2020-21', '281', '2', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '3.68');
INSERT INTO public.europe_data_import VALUES (8870, '18/05/2020', '2020-20', '126', '4', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '2.13');
INSERT INTO public.europe_data_import VALUES (8871, '11/05/2020', '2020-19', '110', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (8872, '04/05/2020', '2020-18', '40', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.38');
INSERT INTO public.europe_data_import VALUES (8873, '27/04/2020', '2020-17', '2', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (8874, '20/04/2020', '2020-16', '0', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (8875, '13/04/2020', '2020-15', '3', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '0.04');
INSERT INTO public.europe_data_import VALUES (8876, '06/04/2020', '2020-14', '1', '0', '11062114', 'South_Sudan', 'SS', 'SSD', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (8877, '01/02/2021', '2021-04', '229423', '2873', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '1036.18');
INSERT INTO public.europe_data_import VALUES (8878, '25/01/2021', '2021-03', '256931', '2439', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '1026.05');
INSERT INTO public.europe_data_import VALUES (8879, '18/01/2021', '2021-02', '224669', '1494', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '804.5');
INSERT INTO public.europe_data_import VALUES (8880, '11/01/2021', '2021-01', '152938', '1197', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '495.07');
INSERT INTO public.europe_data_import VALUES (8881, '04/01/2021', '2020-53', '79431', '956', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '297.41');
INSERT INTO public.europe_data_import VALUES (8882, '28/12/2020', '2020-52', '60164', '862', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '271.7');
INSERT INTO public.europe_data_import VALUES (8883, '21/12/2020', '2020-51', '67365', '1247', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '249.1');
INSERT INTO public.europe_data_import VALUES (8884, '14/12/2020', '2020-50', '49556', '1367', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '220.93');
INSERT INTO public.europe_data_import VALUES (8885, '07/12/2020', '2020-49', '54141', '1577', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '255.05');
INSERT INTO public.europe_data_import VALUES (8886, '30/11/2020', '2020-48', '65571', '1938', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '322.4');
INSERT INTO public.europe_data_import VALUES (8887, '23/11/2020', '2020-47', '85752', '1878', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '429.08');
INSERT INTO public.europe_data_import VALUES (8888, '16/11/2020', '2020-46', '115646', '1908', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '545.77');
INSERT INTO public.europe_data_import VALUES (8889, '09/11/2020', '2020-45', '140521', '3088', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '602.72');
INSERT INTO public.europe_data_import VALUES (8890, '02/11/2020', '2020-44', '142377', '1226', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '567.24');
INSERT INTO public.europe_data_import VALUES (8891, '26/10/2020', '2020-43', '123871', '1039', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '446.03');
INSERT INTO public.europe_data_import VALUES (8892, '19/10/2020', '2020-42', '85481', '868', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '343.09');
INSERT INTO public.europe_data_import VALUES (8893, '12/10/2020', '2020-41', '75556', '899', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '299.77');
INSERT INTO public.europe_data_import VALUES (8894, '05/10/2020', '2020-40', '65146', '814', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '302.41');
INSERT INTO public.europe_data_import VALUES (8895, '28/09/2020', '2020-39', '76798', '748', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '329.24');
INSERT INTO public.europe_data_import VALUES (8896, '21/09/2020', '2020-38', '77738', '815', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '310.88');
INSERT INTO public.europe_data_import VALUES (8897, '14/09/2020', '2020-37', '68181', '332', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '278.82');
INSERT INTO public.europe_data_import VALUES (8898, '07/09/2020', '2020-36', '62691', '422', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '255.9');
INSERT INTO public.europe_data_import VALUES (8899, '31/08/2020', '2020-35', '57422', '222', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '221.1');
INSERT INTO public.europe_data_import VALUES (8900, '24/08/2020', '2020-34', '46354', '226', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '175.67');
INSERT INTO public.europe_data_import VALUES (8901, '17/08/2020', '2020-33', '36102', '70', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '132.15');
INSERT INTO public.europe_data_import VALUES (8902, '10/08/2020', '2020-32', '25926', '104', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '94.16');
INSERT INTO public.europe_data_import VALUES (8903, '03/08/2020', '2020-31', '18272', '38', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '68.64');
INSERT INTO public.europe_data_import VALUES (8904, '27/07/2020', '2020-30', '13946', '12', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '48.64');
INSERT INTO public.europe_data_import VALUES (8905, '20/07/2020', '2020-29', '8883', '16', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '27.8');
INSERT INTO public.europe_data_import VALUES (8906, '13/07/2020', '2020-28', '4164', '18', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '14.88');
INSERT INTO public.europe_data_import VALUES (8907, '06/07/2020', '2020-27', '2819', '42', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '11.26');
INSERT INTO public.europe_data_import VALUES (8908, '29/06/2020', '2020-26', '2466', '22', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '10.36');
INSERT INTO public.europe_data_import VALUES (8909, '22/06/2020', '2020-25', '2395', '1188', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '10.2');
INSERT INTO public.europe_data_import VALUES (8910, '15/06/2020', '2020-24', '2392', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '9.53');
INSERT INTO public.europe_data_import VALUES (8911, '08/06/2020', '2020-23', '2079', '9', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '13.46');
INSERT INTO public.europe_data_import VALUES (8912, '01/06/2020', '2020-22', '4238', '293', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '17.11');
INSERT INTO public.europe_data_import VALUES (8913, '25/05/2020', '2020-21', '3794', '-875', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '16.26');
INSERT INTO public.europe_data_import VALUES (8914, '18/05/2020', '2020-20', '3836', '965', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '26.42');
INSERT INTO public.europe_data_import VALUES (8915, '11/05/2020', '2020-19', '8565', '1316', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '34.51');
INSERT INTO public.europe_data_import VALUES (8916, '04/05/2020', '2020-18', '7635', '2238', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '50.57');
INSERT INTO public.europe_data_import VALUES (8917, '27/04/2020', '2020-17', '16100', '2338', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '78.02');
INSERT INTO public.europe_data_import VALUES (8918, '20/04/2020', '2020-16', '20519', '3880', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '113.07');
INSERT INTO public.europe_data_import VALUES (8919, '13/04/2020', '2020-15', '32553', '4554', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '167.95');
INSERT INTO public.europe_data_import VALUES (8920, '06/04/2020', '2020-14', '46276', '5890', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '215.47');
INSERT INTO public.europe_data_import VALUES (8921, '30/03/2020', '2020-13', '54860', '4808', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '180.31');
INSERT INTO public.europe_data_import VALUES (8922, '23/03/2020', '2020-12', '29771', '1432', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '84.66');
INSERT INTO public.europe_data_import VALUES (8923, '16/03/2020', '2020-11', '9964', '283', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '24.19');
INSERT INTO public.europe_data_import VALUES (8924, '09/03/2020', '2020-10', '1391', '5', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '3.25');
INSERT INTO public.europe_data_import VALUES (8925, '02/03/2020', '2020-09', '134', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0.29');
INSERT INTO public.europe_data_import VALUES (8926, '24/02/2020', '2020-08', '0', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8927, '17/02/2020', '2020-07', '0', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (8928, '10/02/2020', '2020-06', '1', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (8929, '03/02/2020', '2020-05', '1', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (8930, '27/01/2020', '2020-04', '0', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8931, '20/01/2020', '2020-03', '0', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8932, '13/01/2020', '2020-02', '0', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (8933, '06/01/2020', '2020-01', '0', '0', '46937060', 'Spain', 'ES', 'ESP', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (8934, '01/02/2021', '2021-04', '5727', '33', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '52.03');
INSERT INTO public.europe_data_import VALUES (8935, '25/01/2021', '2021-03', '5368', '19', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '47.13');
INSERT INTO public.europe_data_import VALUES (8936, '18/01/2021', '2021-02', '4682', '32', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '38.87');
INSERT INTO public.europe_data_import VALUES (8937, '11/01/2021', '2021-01', '3606', '19', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '34.36');
INSERT INTO public.europe_data_import VALUES (8938, '04/01/2021', '2020-53', '3720', '22', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '35.23');
INSERT INTO public.europe_data_import VALUES (8939, '28/12/2020', '2020-52', '3793', '15', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '38.75');
INSERT INTO public.europe_data_import VALUES (8940, '21/12/2020', '2020-51', '4471', '24', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '44.01');
INSERT INTO public.europe_data_import VALUES (8941, '14/12/2020', '2020-50', '4913', '12', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '43.64');
INSERT INTO public.europe_data_import VALUES (8942, '07/12/2020', '2020-49', '4393', '24', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '36.14');
INSERT INTO public.europe_data_import VALUES (8943, '30/11/2020', '2020-48', '3313', '29', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '29.06');
INSERT INTO public.europe_data_import VALUES (8944, '23/11/2020', '2020-47', '2884', '29', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '29.27');
INSERT INTO public.europe_data_import VALUES (8945, '16/11/2020', '2020-46', '3358', '23', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '29.2');
INSERT INTO public.europe_data_import VALUES (8946, '09/11/2020', '2020-45', '2869', '14', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '28.4');
INSERT INTO public.europe_data_import VALUES (8947, '02/11/2020', '2020-44', '3188', '6', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '25.9');
INSERT INTO public.europe_data_import VALUES (8948, '26/10/2020', '2020-43', '2334', '2', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '14.63');
INSERT INTO public.europe_data_import VALUES (8949, '19/10/2020', '2020-42', '786', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '10.02');
INSERT INTO public.europe_data_import VALUES (8950, '12/10/2020', '2020-41', '1350', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '6.53');
INSERT INTO public.europe_data_import VALUES (8951, '05/10/2020', '2020-40', '42', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.54');
INSERT INTO public.europe_data_import VALUES (8952, '28/09/2020', '2020-39', '73', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.59');
INSERT INTO public.europe_data_import VALUES (8953, '21/09/2020', '2020-38', '53', '1', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.77');
INSERT INTO public.europe_data_import VALUES (8954, '14/09/2020', '2020-37', '111', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.04');
INSERT INTO public.europe_data_import VALUES (8955, '07/09/2020', '2020-36', '111', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.8');
INSERT INTO public.europe_data_import VALUES (8956, '31/08/2020', '2020-35', '59', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.56');
INSERT INTO public.europe_data_import VALUES (8957, '24/08/2020', '2020-34', '60', '1', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.51');
INSERT INTO public.europe_data_import VALUES (8958, '17/08/2020', '2020-33', '49', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.33');
INSERT INTO public.europe_data_import VALUES (8959, '10/08/2020', '2020-32', '21', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.29');
INSERT INTO public.europe_data_import VALUES (8960, '03/08/2020', '2020-31', '41', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (8961, '27/07/2020', '2020-30', '58', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.77');
INSERT INTO public.europe_data_import VALUES (8962, '20/07/2020', '2020-29', '107', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '3.04');
INSERT INTO public.europe_data_import VALUES (8963, '13/07/2020', '2020-28', '541', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '2.72');
INSERT INTO public.europe_data_import VALUES (8964, '06/07/2020', '2020-27', '39', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.59');
INSERT INTO public.europe_data_import VALUES (8965, '29/06/2020', '2020-26', '87', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.69');
INSERT INTO public.europe_data_import VALUES (8966, '22/06/2020', '2020-25', '61', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.54');
INSERT INTO public.europe_data_import VALUES (8967, '15/06/2020', '2020-24', '54', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.2');
INSERT INTO public.europe_data_import VALUES (8968, '08/06/2020', '2020-23', '202', '1', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '3.25');
INSERT INTO public.europe_data_import VALUES (8969, '01/06/2020', '2020-22', '492', '1', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '3.06');
INSERT INTO public.europe_data_import VALUES (8970, '25/05/2020', '2020-21', '160', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.3');
INSERT INTO public.europe_data_import VALUES (8971, '18/05/2020', '2020-20', '118', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.23');
INSERT INTO public.europe_data_import VALUES (8972, '11/05/2020', '2020-19', '145', '2', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.59');
INSERT INTO public.europe_data_import VALUES (8973, '04/05/2020', '2020-18', '195', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.98');
INSERT INTO public.europe_data_import VALUES (8974, '27/04/2020', '2020-17', '228', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '1.47');
INSERT INTO public.europe_data_import VALUES (8975, '20/04/2020', '2020-16', '85', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.6');
INSERT INTO public.europe_data_import VALUES (8976, '13/04/2020', '2020-15', '44', '2', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.42');
INSERT INTO public.europe_data_import VALUES (8977, '06/04/2020', '2020-14', '46', '4', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (8978, '30/03/2020', '2020-13', '33', '1', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.47');
INSERT INTO public.europe_data_import VALUES (8979, '23/03/2020', '2020-12', '68', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.4');
INSERT INTO public.europe_data_import VALUES (8980, '16/03/2020', '2020-11', '18', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (8981, '09/03/2020', '2020-10', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8982, '02/03/2020', '2020-09', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8983, '24/02/2020', '2020-08', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8984, '17/02/2020', '2020-07', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8985, '10/02/2020', '2020-06', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (8986, '03/02/2020', '2020-05', '1', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (8987, '27/01/2020', '2020-04', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8988, '20/01/2020', '2020-03', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8989, '13/01/2020', '2020-02', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (8990, '06/01/2020', '2020-01', '0', '0', '21323734', 'Sri_Lanka', 'LK', 'LKA', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (8991, '01/02/2021', '2021-04', '927', '85', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '14.33');
INSERT INTO public.europe_data_import VALUES (8992, '25/01/2021', '2021-03', '5206', '254', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '12.16');
INSERT INTO public.europe_data_import VALUES (8993, '18/01/2021', '2021-02', '0', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8994, '11/01/2021', '2021-01', '0', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (8995, '04/01/2021', '2020-53', '0', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.15');
INSERT INTO public.europe_data_import VALUES (8996, '28/12/2020', '2020-52', '493', '34', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '4.51');
INSERT INTO public.europe_data_import VALUES (8997, '21/12/2020', '2020-51', '1437', '87', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '7.84');
INSERT INTO public.europe_data_import VALUES (8998, '14/12/2020', '2020-50', '1918', '52', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '8.78');
INSERT INTO public.europe_data_import VALUES (8999, '07/12/2020', '2020-49', '1841', '54', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '8.48');
INSERT INTO public.europe_data_import VALUES (9000, '30/11/2020', '2020-48', '1788', '48', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '7.01');
INSERT INTO public.europe_data_import VALUES (9001, '23/11/2020', '2020-47', '1213', '77', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (9002, '16/11/2020', '2020-46', '536', '1', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.88');
INSERT INTO public.europe_data_import VALUES (9003, '09/11/2020', '2020-45', '271', '278', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.81');
INSERT INTO public.europe_data_import VALUES (9004, '02/11/2020', '2020-44', '77', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.3');
INSERT INTO public.europe_data_import VALUES (9005, '26/10/2020', '2020-43', '51', '1', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.17');
INSERT INTO public.europe_data_import VALUES (9006, '19/10/2020', '2020-42', '21', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (9007, '12/10/2020', '2020-41', '17', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.15');
INSERT INTO public.europe_data_import VALUES (9008, '05/10/2020', '2020-40', '47', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.23');
INSERT INTO public.europe_data_import VALUES (9009, '28/09/2020', '2020-39', '51', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.32');
INSERT INTO public.europe_data_import VALUES (9010, '21/09/2020', '2020-38', '85', '2', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (9011, '14/09/2020', '2020-37', '63', '2', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.66');
INSERT INTO public.europe_data_import VALUES (9012, '07/09/2020', '2020-36', '218', '9', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.33');
INSERT INTO public.europe_data_import VALUES (9013, '31/08/2020', '2020-35', '353', '8', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.82');
INSERT INTO public.europe_data_import VALUES (9014, '24/08/2020', '2020-34', '426', '12', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.2');
INSERT INTO public.europe_data_import VALUES (9015, '17/08/2020', '2020-33', '516', '30', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.57');
INSERT INTO public.europe_data_import VALUES (9016, '10/08/2020', '2020-32', '156', '21', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.19');
INSERT INTO public.europe_data_import VALUES (9017, '03/08/2020', '2020-31', '353', '35', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.28');
INSERT INTO public.europe_data_import VALUES (9018, '27/07/2020', '2020-30', '623', '37', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.65');
INSERT INTO public.europe_data_import VALUES (9019, '20/07/2020', '2020-29', '512', '30', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.32');
INSERT INTO public.europe_data_import VALUES (9020, '13/07/2020', '2020-28', '483', '42', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.32');
INSERT INTO public.europe_data_import VALUES (9021, '06/07/2020', '2020-27', '509', '36', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.77');
INSERT INTO public.europe_data_import VALUES (9022, '29/06/2020', '2020-26', '678', '51', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '4.76');
INSERT INTO public.europe_data_import VALUES (9023, '22/06/2020', '2020-25', '1360', '62', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '5.83');
INSERT INTO public.europe_data_import VALUES (9024, '15/06/2020', '2020-24', '1137', '100', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '5.12');
INSERT INTO public.europe_data_import VALUES (9025, '08/06/2020', '2020-23', '1057', '73', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '5.72');
INSERT INTO public.europe_data_import VALUES (9026, '01/06/2020', '2020-22', '1392', '140', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '6.39');
INSERT INTO public.europe_data_import VALUES (9027, '25/05/2020', '2020-21', '1345', '49', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '5.3');
INSERT INTO public.europe_data_import VALUES (9028, '18/05/2020', '2020-20', '926', '27', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '3.76');
INSERT INTO public.europe_data_import VALUES (9029, '11/05/2020', '2020-19', '685', '29', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '2.63');
INSERT INTO public.europe_data_import VALUES (9030, '04/05/2020', '2020-18', '441', '20', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '1.43');
INSERT INTO public.europe_data_import VALUES (9031, '27/04/2020', '2020-17', '171', '11', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.51');
INSERT INTO public.europe_data_import VALUES (9032, '20/04/2020', '2020-16', '47', '8', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.13');
INSERT INTO public.europe_data_import VALUES (9033, '13/04/2020', '2020-15', '7', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (9034, '06/04/2020', '2020-14', '7', '1', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (9035, '30/03/2020', '2020-13', '3', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.01');
INSERT INTO public.europe_data_import VALUES (9036, '23/03/2020', '2020-12', '1', '0', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '0.0');
INSERT INTO public.europe_data_import VALUES (9037, '16/03/2020', '2020-11', '1', '1', '42813237', 'Sudan', 'SD', 'SDN', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (9038, '01/02/2021', '2021-04', '337', '7', '581363', 'Suriname', 'SR', 'SUR', 'America', '141.91');
INSERT INTO public.europe_data_import VALUES (9039, '25/01/2021', '2021-03', '488', '4', '581363', 'Suriname', 'SR', 'SUR', 'America', '180.27');
INSERT INTO public.europe_data_import VALUES (9040, '18/01/2021', '2021-02', '560', '7', '581363', 'Suriname', 'SR', 'SUR', 'America', '211.74');
INSERT INTO public.europe_data_import VALUES (9041, '11/01/2021', '2021-01', '671', '15', '581363', 'Suriname', 'SR', 'SUR', 'America', '180.78');
INSERT INTO public.europe_data_import VALUES (9042, '04/01/2021', '2020-53', '380', '3', '581363', 'Suriname', 'SR', 'SUR', 'America', '139.33');
INSERT INTO public.europe_data_import VALUES (9043, '28/12/2020', '2020-52', '430', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '113.53');
INSERT INTO public.europe_data_import VALUES (9044, '21/12/2020', '2020-51', '230', '1', '581363', 'Suriname', 'SR', 'SUR', 'America', '44.55');
INSERT INTO public.europe_data_import VALUES (9045, '14/12/2020', '2020-50', '29', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '7.05');
INSERT INTO public.europe_data_import VALUES (9046, '07/12/2020', '2020-49', '12', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '4.82');
INSERT INTO public.europe_data_import VALUES (9047, '30/11/2020', '2020-48', '16', '1', '581363', 'Suriname', 'SR', 'SUR', 'America', '6.54');
INSERT INTO public.europe_data_import VALUES (9048, '23/11/2020', '2020-47', '22', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '9.8');
INSERT INTO public.europe_data_import VALUES (9049, '16/11/2020', '2020-46', '35', '1', '581363', 'Suriname', 'SR', 'SUR', 'America', '11.01');
INSERT INTO public.europe_data_import VALUES (9050, '09/11/2020', '2020-45', '29', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '11.87');
INSERT INTO public.europe_data_import VALUES (9051, '02/11/2020', '2020-44', '40', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '13.76');
INSERT INTO public.europe_data_import VALUES (9052, '26/10/2020', '2020-43', '40', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '20.47');
INSERT INTO public.europe_data_import VALUES (9053, '19/10/2020', '2020-42', '79', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '32.51');
INSERT INTO public.europe_data_import VALUES (9054, '12/10/2020', '2020-41', '110', '1', '581363', 'Suriname', 'SR', 'SUR', 'America', '37.15');
INSERT INTO public.europe_data_import VALUES (9055, '05/10/2020', '2020-40', '106', '4', '581363', 'Suriname', 'SR', 'SUR', 'America', '37.5');
INSERT INTO public.europe_data_import VALUES (9056, '28/09/2020', '2020-39', '112', '5', '581363', 'Suriname', 'SR', 'SUR', 'America', '43.52');
INSERT INTO public.europe_data_import VALUES (9057, '21/09/2020', '2020-38', '141', '4', '581363', 'Suriname', 'SR', 'SUR', 'America', '64.85');
INSERT INTO public.europe_data_import VALUES (9058, '14/09/2020', '2020-37', '236', '8', '581363', 'Suriname', 'SR', 'SUR', 'America', '98.56');
INSERT INTO public.europe_data_import VALUES (9059, '07/09/2020', '2020-36', '337', '18', '581363', 'Suriname', 'SR', 'SUR', 'America', '127.12');
INSERT INTO public.europe_data_import VALUES (9060, '31/08/2020', '2020-35', '402', '9', '581363', 'Suriname', 'SR', 'SUR', 'America', '170.81');
INSERT INTO public.europe_data_import VALUES (9061, '24/08/2020', '2020-34', '591', '11', '581363', 'Suriname', 'SR', 'SUR', 'America', '209.16');
INSERT INTO public.europe_data_import VALUES (9062, '17/08/2020', '2020-33', '625', '18', '581363', 'Suriname', 'SR', 'SUR', 'America', '200.74');
INSERT INTO public.europe_data_import VALUES (9063, '10/08/2020', '2020-32', '542', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '163.75');
INSERT INTO public.europe_data_import VALUES (9064, '03/08/2020', '2020-31', '410', '4', '581363', 'Suriname', 'SR', 'SUR', 'America', '141.05');
INSERT INTO public.europe_data_import VALUES (9065, '27/07/2020', '2020-30', '410', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '120.06');
INSERT INTO public.europe_data_import VALUES (9066, '20/07/2020', '2020-29', '288', '3', '581363', 'Suriname', 'SR', 'SUR', 'America', '74.82');
INSERT INTO public.europe_data_import VALUES (9067, '13/07/2020', '2020-28', '147', '4', '581363', 'Suriname', 'SR', 'SUR', 'America', '43.17');
INSERT INTO public.europe_data_import VALUES (9068, '06/07/2020', '2020-27', '104', '3', '581363', 'Suriname', 'SR', 'SUR', 'America', '48.16');
INSERT INTO public.europe_data_import VALUES (9069, '29/06/2020', '2020-26', '176', '3', '581363', 'Suriname', 'SR', 'SUR', 'America', '48.51');
INSERT INTO public.europe_data_import VALUES (9070, '22/06/2020', '2020-25', '106', '5', '581363', 'Suriname', 'SR', 'SUR', 'America', '33.03');
INSERT INTO public.europe_data_import VALUES (9071, '15/06/2020', '2020-24', '86', '2', '581363', 'Suriname', 'SR', 'SUR', 'America', '31.82');
INSERT INTO public.europe_data_import VALUES (9072, '08/06/2020', '2020-23', '99', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '19.09');
INSERT INTO public.europe_data_import VALUES (9073, '01/06/2020', '2020-22', '12', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '2.24');
INSERT INTO public.europe_data_import VALUES (9074, '25/05/2020', '2020-21', '1', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0.17');
INSERT INTO public.europe_data_import VALUES (9075, '18/05/2020', '2020-20', '0', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9076, '11/05/2020', '2020-19', '0', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9077, '04/05/2020', '2020-18', '0', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9078, '27/04/2020', '2020-17', '0', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9079, '20/04/2020', '2020-16', '0', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9080, '13/04/2020', '2020-15', '0', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '0.34');
INSERT INTO public.europe_data_import VALUES (9081, '06/04/2020', '2020-14', '2', '1', '581363', 'Suriname', 'SR', 'SUR', 'America', '0.86');
INSERT INTO public.europe_data_import VALUES (9082, '30/03/2020', '2020-13', '3', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '1.38');
INSERT INTO public.europe_data_import VALUES (9083, '23/03/2020', '2020-12', '5', '0', '581363', 'Suriname', 'SR', 'SUR', 'America', '');
INSERT INTO public.europe_data_import VALUES (9084, '01/02/2021', '2021-04', '20683', '89', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '429.49');
INSERT INTO public.europe_data_import VALUES (9085, '25/01/2021', '2021-03', '23255', '400', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '510.37');
INSERT INTO public.europe_data_import VALUES (9086, '18/01/2021', '2021-02', '28957', '569', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '668.84');
INSERT INTO public.europe_data_import VALUES (9087, '11/01/2021', '2021-01', '39467', '637', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '789.85');
INSERT INTO public.europe_data_import VALUES (9088, '04/01/2021', '2020-53', '41336', '657', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '767.08');
INSERT INTO public.europe_data_import VALUES (9089, '28/12/2020', '2020-52', '37138', '638', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '814.44');
INSERT INTO public.europe_data_import VALUES (9090, '21/12/2020', '2020-51', '46181', '645', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '877.91');
INSERT INTO public.europe_data_import VALUES (9091, '14/12/2020', '2020-50', '43631', '499', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '786.61');
INSERT INTO public.europe_data_import VALUES (9092, '07/12/2020', '2020-49', '36841', '476', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '707.71');
INSERT INTO public.europe_data_import VALUES (9093, '30/11/2020', '2020-48', '35559', '418', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '659.85');
INSERT INTO public.europe_data_import VALUES (9094, '23/11/2020', '2020-47', '31945', '332', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '618.42');
INSERT INTO public.europe_data_import VALUES (9095, '16/11/2020', '2020-46', '31320', '235', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '554.49');
INSERT INTO public.europe_data_import VALUES (9096, '09/11/2020', '2020-45', '25405', '157', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '428.93');
INSERT INTO public.europe_data_import VALUES (9097, '02/11/2020', '2020-44', '18475', '82', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '270.09');
INSERT INTO public.europe_data_import VALUES (9098, '26/10/2020', '2020-43', '9156', '43', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '144.44');
INSERT INTO public.europe_data_import VALUES (9099, '19/10/2020', '2020-42', '5620', '16', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '96.75');
INSERT INTO public.europe_data_import VALUES (9100, '12/10/2020', '2020-41', '4278', '22', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '77.42');
INSERT INTO public.europe_data_import VALUES (9101, '05/10/2020', '2020-40', '3642', '17', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '64.13');
INSERT INTO public.europe_data_import VALUES (9102, '28/09/2020', '2020-39', '2919', '11', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '48.87');
INSERT INTO public.europe_data_import VALUES (9103, '21/09/2020', '2020-38', '2080', '12', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '35.89');
INSERT INTO public.europe_data_import VALUES (9104, '14/09/2020', '2020-37', '1592', '13', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '28.58');
INSERT INTO public.europe_data_import VALUES (9105, '07/09/2020', '2020-36', '1332', '12', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '24.75');
INSERT INTO public.europe_data_import VALUES (9106, '31/08/2020', '2020-35', '1200', '10', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '28.22');
INSERT INTO public.europe_data_import VALUES (9107, '24/08/2020', '2020-34', '1687', '19', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '36.55');
INSERT INTO public.europe_data_import VALUES (9108, '17/08/2020', '2020-33', '2052', '16', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '39.75');
INSERT INTO public.europe_data_import VALUES (9109, '10/08/2020', '2020-32', '2014', '18', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '34.9');
INSERT INTO public.europe_data_import VALUES (9110, '03/08/2020', '2020-31', '1556', '18', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '28.07');
INSERT INTO public.europe_data_import VALUES (9111, '27/07/2020', '2020-30', '1316', '30', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '28.72');
INSERT INTO public.europe_data_import VALUES (9112, '20/07/2020', '2020-29', '1622', '57', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '37.15');
INSERT INTO public.europe_data_import VALUES (9113, '13/07/2020', '2020-28', '2179', '84', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '63.1');
INSERT INTO public.europe_data_import VALUES (9114, '06/07/2020', '2020-27', '4276', '98', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '114.71');
INSERT INTO public.europe_data_import VALUES (9115, '29/06/2020', '2020-26', '7459', '138', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '142.05');
INSERT INTO public.europe_data_import VALUES (9116, '22/06/2020', '2020-25', '7073', '200', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '138.77');
INSERT INTO public.europe_data_import VALUES (9117, '15/06/2020', '2020-24', '7123', '234', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '128.48');
INSERT INTO public.europe_data_import VALUES (9118, '08/06/2020', '2020-23', '6021', '245', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '100.7');
INSERT INTO public.europe_data_import VALUES (9119, '01/06/2020', '2020-22', '4281', '274', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '77.61');
INSERT INTO public.europe_data_import VALUES (9120, '25/05/2020', '2020-21', '3659', '360', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '73.59');
INSERT INTO public.europe_data_import VALUES (9121, '18/05/2020', '2020-20', '3869', '380', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '78.42');
INSERT INTO public.europe_data_import VALUES (9122, '11/05/2020', '2020-19', '4153', '510', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '78.05');
INSERT INTO public.europe_data_import VALUES (9123, '04/05/2020', '2020-18', '3832', '544', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '78.52');
INSERT INTO public.europe_data_import VALUES (9124, '27/04/2020', '2020-17', '4201', '546', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '77.73');
INSERT INTO public.europe_data_import VALUES (9125, '20/04/2020', '2020-16', '3751', '658', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '73.21');
INSERT INTO public.europe_data_import VALUES (9126, '13/04/2020', '2020-15', '3739', '664', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '68.1');
INSERT INTO public.europe_data_import VALUES (9127, '06/04/2020', '2020-14', '3228', '451', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '50.68');
INSERT INTO public.europe_data_import VALUES (9128, '30/03/2020', '2020-13', '1957', '190', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '28.16');
INSERT INTO public.europe_data_import VALUES (9129, '23/03/2020', '2020-12', '924', '44', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '17.22');
INSERT INTO public.europe_data_import VALUES (9130, '16/03/2020', '2020-11', '838', '5', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '10.25');
INSERT INTO public.europe_data_import VALUES (9131, '09/03/2020', '2020-10', '211', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '2.19');
INSERT INTO public.europe_data_import VALUES (9132, '02/03/2020', '2020-09', '13', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0.13');
INSERT INTO public.europe_data_import VALUES (9133, '24/02/2020', '2020-08', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9134, '17/02/2020', '2020-07', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (9135, '10/02/2020', '2020-06', '1', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (9136, '03/02/2020', '2020-05', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9137, '27/01/2020', '2020-04', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9138, '20/01/2020', '2020-03', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9139, '13/01/2020', '2020-02', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9140, '06/01/2020', '2020-01', '0', '0', '10230185', 'Sweden', 'SE', 'SWE', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (9141, '01/02/2021', '2021-04', '11451', '295', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '293.24');
INSERT INTO public.europe_data_import VALUES (9142, '25/01/2021', '2021-03', '13605', '337', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '339.2');
INSERT INTO public.europe_data_import VALUES (9143, '18/01/2021', '2021-02', '15378', '392', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '442.53');
INSERT INTO public.europe_data_import VALUES (9144, '11/01/2021', '2021-01', '22434', '417', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '536.58');
INSERT INTO public.europe_data_import VALUES (9145, '04/01/2021', '2020-53', '23414', '495', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '555.89');
INSERT INTO public.europe_data_import VALUES (9146, '28/12/2020', '2020-52', '24084', '563', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '748.05');
INSERT INTO public.europe_data_import VALUES (9147, '21/12/2020', '2020-51', '39833', '802', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '808.25');
INSERT INTO public.europe_data_import VALUES (9148, '14/12/2020', '2020-50', '29228', '546', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '647.34');
INSERT INTO public.europe_data_import VALUES (9149, '07/12/2020', '2020-49', '26084', '596', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '627.51');
INSERT INTO public.europe_data_import VALUES (9150, '30/11/2020', '2020-48', '27534', '669', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '711.93');
INSERT INTO public.europe_data_import VALUES (9151, '23/11/2020', '2020-47', '33297', '611', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '916.65');
INSERT INTO public.europe_data_import VALUES (9152, '16/11/2020', '2020-46', '45026', '552', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '1199.11');
INSERT INTO public.europe_data_import VALUES (9153, '09/11/2020', '2020-45', '57432', '369', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '1262.06');
INSERT INTO public.europe_data_import VALUES (9154, '02/11/2020', '2020-44', '50405', '159', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '928.15');
INSERT INTO public.europe_data_import VALUES (9155, '26/10/2020', '2020-43', '28901', '53', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '504.33');
INSERT INTO public.europe_data_import VALUES (9156, '19/10/2020', '2020-42', '14192', '30', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '235.93');
INSERT INTO public.europe_data_import VALUES (9157, '12/10/2020', '2020-41', '5967', '10', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '97.91');
INSERT INTO public.europe_data_import VALUES (9158, '05/10/2020', '2020-40', '2399', '5', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '59.59');
INSERT INTO public.europe_data_import VALUES (9159, '28/09/2020', '2020-39', '2693', '14', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '56.13');
INSERT INTO public.europe_data_import VALUES (9160, '21/09/2020', '2020-38', '2103', '18', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '57.09');
INSERT INTO public.europe_data_import VALUES (9161, '14/09/2020', '2020-37', '2775', '14', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '60.41');
INSERT INTO public.europe_data_import VALUES (9162, '07/09/2020', '2020-36', '2387', '8', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '52.56');
INSERT INTO public.europe_data_import VALUES (9163, '31/08/2020', '2020-35', '2104', '5', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '45.35');
INSERT INTO public.europe_data_import VALUES (9164, '24/08/2020', '2020-34', '1771', '4', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '38.48');
INSERT INTO public.europe_data_import VALUES (9165, '17/08/2020', '2020-33', '1517', '4', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '30.08');
INSERT INTO public.europe_data_import VALUES (9166, '10/08/2020', '2020-32', '1053', '6', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '25.62');
INSERT INTO public.europe_data_import VALUES (9167, '03/08/2020', '2020-31', '1136', '5', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '22.9');
INSERT INTO public.europe_data_import VALUES (9168, '27/07/2020', '2020-30', '821', '13', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '17.87');
INSERT INTO public.europe_data_import VALUES (9169, '20/07/2020', '2020-29', '706', '2', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '15.45');
INSERT INTO public.europe_data_import VALUES (9170, '13/07/2020', '2020-28', '614', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '14.79');
INSERT INTO public.europe_data_import VALUES (9171, '06/07/2020', '2020-27', '650', '4', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '11.41');
INSERT INTO public.europe_data_import VALUES (9172, '29/06/2020', '2020-26', '325', '2', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '5.85');
INSERT INTO public.europe_data_import VALUES (9173, '22/06/2020', '2020-25', '175', '3', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '3.83');
INSERT INTO public.europe_data_import VALUES (9174, '15/06/2020', '2020-24', '152', '16', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '2.98');
INSERT INTO public.europe_data_import VALUES (9175, '08/06/2020', '2020-23', '103', '4', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '2.68');
INSERT INTO public.europe_data_import VALUES (9176, '01/06/2020', '2020-22', '126', '15', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '3.22');
INSERT INTO public.europe_data_import VALUES (9177, '25/05/2020', '2020-21', '149', '39', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '5.04');
INSERT INTO public.europe_data_import VALUES (9178, '18/05/2020', '2020-20', '282', '65', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '7.98');
INSERT INTO public.europe_data_import VALUES (9179, '11/05/2020', '2020-19', '400', '65', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '14.56');
INSERT INTO public.europe_data_import VALUES (9180, '04/05/2020', '2020-18', '844', '136', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '25.33');
INSERT INTO public.europe_data_import VALUES (9181, '27/04/2020', '2020-17', '1320', '202', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '43.98');
INSERT INTO public.europe_data_import VALUES (9182, '20/04/2020', '2020-16', '2438', '276', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '77.66');
INSERT INTO public.europe_data_import VALUES (9183, '13/04/2020', '2020-15', '4198', '299', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '128.11');
INSERT INTO public.europe_data_import VALUES (9184, '06/04/2020', '2020-14', '6748', '302', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '164.44');
INSERT INTO public.europe_data_import VALUES (9185, '30/03/2020', '2020-13', '7303', '197', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '141.31');
INSERT INTO public.europe_data_import VALUES (9186, '23/03/2020', '2020-12', '4771', '47', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '77.7');
INSERT INTO public.europe_data_import VALUES (9187, '16/03/2020', '2020-11', '1868', '11', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '25.47');
INSERT INTO public.europe_data_import VALUES (9188, '09/03/2020', '2020-10', '308', '2', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '3.89');
INSERT INTO public.europe_data_import VALUES (9189, '02/03/2020', '2020-09', '24', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0.28');
INSERT INTO public.europe_data_import VALUES (9190, '24/02/2020', '2020-08', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9191, '17/02/2020', '2020-07', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9192, '10/02/2020', '2020-06', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9193, '03/02/2020', '2020-05', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9194, '27/01/2020', '2020-04', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9195, '20/01/2020', '2020-03', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9196, '13/01/2020', '2020-02', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9197, '06/01/2020', '2020-01', '0', '0', '8544527', 'Switzerland', 'CH', 'CHE', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (9198, '01/02/2021', '2021-04', '420', '36', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '5.93');
INSERT INTO public.europe_data_import VALUES (9199, '25/01/2021', '2021-03', '592', '53', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '7.4');
INSERT INTO public.europe_data_import VALUES (9200, '18/01/2021', '2021-02', '672', '58', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '7.77');
INSERT INTO public.europe_data_import VALUES (9201, '11/01/2021', '2021-01', '654', '45', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '7.8');
INSERT INTO public.europe_data_import VALUES (9202, '04/01/2021', '2020-53', '677', '51', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '8.88');
INSERT INTO public.europe_data_import VALUES (9203, '28/12/2020', '2020-52', '838', '68', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '10.94');
INSERT INTO public.europe_data_import VALUES (9204, '21/12/2020', '2020-51', '1029', '92', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '10.5');
INSERT INTO public.europe_data_import VALUES (9205, '14/12/2020', '2020-50', '763', '71', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '8.02');
INSERT INTO public.europe_data_import VALUES (9206, '07/12/2020', '2020-49', '606', '34', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '6.9');
INSERT INTO public.europe_data_import VALUES (9207, '30/11/2020', '2020-48', '572', '37', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '6.52');
INSERT INTO public.europe_data_import VALUES (9208, '23/11/2020', '2020-47', '541', '31', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '5.92');
INSERT INTO public.europe_data_import VALUES (9209, '16/11/2020', '2020-46', '469', '28', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '5.24');
INSERT INTO public.europe_data_import VALUES (9210, '09/11/2020', '2020-45', '426', '25', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '4.73');
INSERT INTO public.europe_data_import VALUES (9211, '02/11/2020', '2020-44', '381', '23', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '4.17');
INSERT INTO public.europe_data_import VALUES (9212, '26/10/2020', '2020-43', '331', '21', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '4.31');
INSERT INTO public.europe_data_import VALUES (9213, '19/10/2020', '2020-42', '404', '27', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '4.17');
INSERT INTO public.europe_data_import VALUES (9214, '12/10/2020', '2020-41', '307', '16', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '3.52');
INSERT INTO public.europe_data_import VALUES (9215, '05/10/2020', '2020-40', '294', '13', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '3.32');
INSERT INTO public.europe_data_import VALUES (9216, '28/09/2020', '2020-39', '272', '20', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '3.12');
INSERT INTO public.europe_data_import VALUES (9217, '21/09/2020', '2020-38', '260', '17', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '3.68');
INSERT INTO public.europe_data_import VALUES (9218, '14/09/2020', '2020-37', '369', '21', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '4.9');
INSERT INTO public.europe_data_import VALUES (9219, '07/09/2020', '2020-36', '468', '25', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '6.02');
INSERT INTO public.europe_data_import VALUES (9220, '31/08/2020', '2020-35', '560', '24', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '6.01');
INSERT INTO public.europe_data_import VALUES (9221, '24/08/2020', '2020-34', '466', '21', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '5.59');
INSERT INTO public.europe_data_import VALUES (9222, '17/08/2020', '2020-33', '489', '12', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '5.08');
INSERT INTO public.europe_data_import VALUES (9223, '10/08/2020', '2020-32', '379', '8', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '3.15');
INSERT INTO public.europe_data_import VALUES (9224, '03/08/2020', '2020-31', '159', '6', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '1.83');
INSERT INTO public.europe_data_import VALUES (9225, '27/07/2020', '2020-30', '154', '13', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '1.5');
INSERT INTO public.europe_data_import VALUES (9226, '20/07/2020', '2020-29', '102', '9', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.81');
INSERT INTO public.europe_data_import VALUES (9227, '13/07/2020', '2020-28', '36', '3', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.81');
INSERT INTO public.europe_data_import VALUES (9228, '06/07/2020', '2020-27', '102', '4', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.9');
INSERT INTO public.europe_data_import VALUES (9229, '29/06/2020', '2020-26', '52', '2', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (9230, '22/06/2020', '2020-25', '27', '1', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (9231, '15/06/2020', '2020-24', '36', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.32');
INSERT INTO public.europe_data_import VALUES (9232, '08/06/2020', '2020-23', '19', '2', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.32');
INSERT INTO public.europe_data_import VALUES (9233, '01/06/2020', '2020-22', '36', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (9234, '25/05/2020', '2020-21', '28', '1', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (9235, '18/05/2020', '2020-20', '11', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9236, '11/05/2020', '2020-19', '3', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9237, '04/05/2020', '2020-18', '1', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (9238, '27/04/2020', '2020-17', '4', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (9239, '20/04/2020', '2020-16', '14', '1', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (9240, '13/04/2020', '2020-15', '6', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (9241, '06/04/2020', '2020-14', '10', '1', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (9242, '30/03/2020', '2020-13', '8', '1', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9243, '23/03/2020', '2020-12', '1', '0', '17070132', 'Syria', 'SY', 'SYR', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (9244, '01/02/2021', '2021-04', '23', '1', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.21');
INSERT INTO public.europe_data_import VALUES (9245, '25/01/2021', '2021-03', '27', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.23');
INSERT INTO public.europe_data_import VALUES (9246, '18/01/2021', '2021-02', '28', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.2');
INSERT INTO public.europe_data_import VALUES (9247, '11/01/2021', '2021-01', '19', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (9248, '04/01/2021', '2020-53', '22', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.21');
INSERT INTO public.europe_data_import VALUES (9249, '28/12/2020', '2020-52', '27', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.22');
INSERT INTO public.europe_data_import VALUES (9250, '21/12/2020', '2020-51', '26', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.21');
INSERT INTO public.europe_data_import VALUES (9251, '14/12/2020', '2020-50', '24', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.27');
INSERT INTO public.europe_data_import VALUES (9252, '07/12/2020', '2020-49', '41', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.41');
INSERT INTO public.europe_data_import VALUES (9253, '30/11/2020', '2020-48', '57', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.3');
INSERT INTO public.europe_data_import VALUES (9254, '23/11/2020', '2020-47', '15', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (9255, '16/11/2020', '2020-46', '25', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (9256, '09/11/2020', '2020-45', '15', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (9257, '02/11/2020', '2020-44', '13', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9258, '26/10/2020', '2020-43', '10', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9259, '19/10/2020', '2020-42', '13', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9260, '12/10/2020', '2020-41', '10', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9261, '05/10/2020', '2020-40', '7', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (9262, '28/09/2020', '2020-39', '1', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9263, '21/09/2020', '2020-38', '11', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9264, '14/09/2020', '2020-37', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9265, '07/09/2020', '2020-36', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (9266, '31/08/2020', '2020-35', '1', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9267, '24/08/2020', '2020-34', '2', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (9268, '17/08/2020', '2020-33', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9269, '10/08/2020', '2020-32', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9270, '03/08/2020', '2020-31', '13', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9271, '27/07/2020', '2020-30', '7', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9272, '20/07/2020', '2020-29', '4', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (9273, '13/07/2020', '2020-28', '2', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9274, '06/07/2020', '2020-27', '2', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9275, '29/06/2020', '2020-26', '1', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9276, '22/06/2020', '2020-25', '3', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9277, '15/06/2020', '2020-24', '0', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (9278, '08/06/2020', '2020-23', '1', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9279, '01/06/2020', '2020-22', '1', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9280, '25/05/2020', '2020-21', '1', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (9281, '18/05/2020', '2020-20', '0', '1', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9282, '11/05/2020', '2020-19', '4', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9283, '04/05/2020', '2020-18', '7', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9284, '27/04/2020', '2020-17', '9', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (9285, '20/04/2020', '2020-16', '32', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.24');
INSERT INTO public.europe_data_import VALUES (9286, '13/04/2020', '2020-15', '25', '1', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.34');
INSERT INTO public.europe_data_import VALUES (9287, '06/04/2020', '2020-14', '57', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.83');
INSERT INTO public.europe_data_import VALUES (9288, '30/03/2020', '2020-13', '141', '3', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '1.04');
INSERT INTO public.europe_data_import VALUES (9289, '23/03/2020', '2020-12', '106', '1', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.5');
INSERT INTO public.europe_data_import VALUES (9290, '16/03/2020', '2020-11', '14', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9291, '09/03/2020', '2020-10', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9292, '02/03/2020', '2020-09', '12', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9293, '24/02/2020', '2020-08', '8', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9294, '17/02/2020', '2020-07', '2', '1', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9295, '10/02/2020', '2020-06', '8', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9296, '03/02/2020', '2020-05', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9297, '27/01/2020', '2020-04', '5', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9298, '20/01/2020', '2020-03', '0', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9299, '13/01/2020', '2020-02', '0', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9300, '06/01/2020', '2020-01', '0', '0', '23773881', 'Taiwan', 'TW', 'CNG1925', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (9301, '01/02/2021', '2021-04', '0', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9302, '25/01/2021', '2021-03', '0', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9303, '18/01/2021', '2021-02', '0', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (9304, '11/01/2021', '2021-01', '8', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '0.76');
INSERT INTO public.europe_data_import VALUES (9305, '04/01/2021', '2020-53', '63', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '3.65');
INSERT INTO public.europe_data_import VALUES (9306, '28/12/2020', '2020-52', '277', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.72');
INSERT INTO public.europe_data_import VALUES (9307, '21/12/2020', '2020-51', '256', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.71');
INSERT INTO public.europe_data_import VALUES (9308, '14/12/2020', '2020-50', '276', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.89');
INSERT INTO public.europe_data_import VALUES (9309, '07/12/2020', '2020-49', '273', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.73');
INSERT INTO public.europe_data_import VALUES (9310, '30/11/2020', '2020-48', '261', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.85');
INSERT INTO public.europe_data_import VALUES (9311, '23/11/2020', '2020-47', '284', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.99');
INSERT INTO public.europe_data_import VALUES (9312, '16/11/2020', '2020-46', '274', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.97');
INSERT INTO public.europe_data_import VALUES (9313, '09/11/2020', '2020-45', '282', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.01');
INSERT INTO public.europe_data_import VALUES (9314, '02/11/2020', '2020-44', '278', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.02');
INSERT INTO public.europe_data_import VALUES (9315, '26/10/2020', '2020-43', '283', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.94');
INSERT INTO public.europe_data_import VALUES (9316, '19/10/2020', '2020-42', '271', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.99');
INSERT INTO public.europe_data_import VALUES (9317, '12/10/2020', '2020-41', '287', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.18');
INSERT INTO public.europe_data_import VALUES (9318, '05/10/2020', '2020-40', '289', '3', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.32');
INSERT INTO public.europe_data_import VALUES (9319, '28/09/2020', '2020-39', '300', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.4');
INSERT INTO public.europe_data_import VALUES (9320, '21/09/2020', '2020-38', '297', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.94');
INSERT INTO public.europe_data_import VALUES (9321, '14/09/2020', '2020-37', '257', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.35');
INSERT INTO public.europe_data_import VALUES (9322, '07/09/2020', '2020-36', '242', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.16');
INSERT INTO public.europe_data_import VALUES (9323, '31/08/2020', '2020-35', '239', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.2');
INSERT INTO public.europe_data_import VALUES (9324, '24/08/2020', '2020-34', '246', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.07');
INSERT INTO public.europe_data_import VALUES (9325, '17/08/2020', '2020-33', '320', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.12');
INSERT INTO public.europe_data_import VALUES (9326, '10/08/2020', '2020-32', '250', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '5.93');
INSERT INTO public.europe_data_import VALUES (9327, '03/08/2020', '2020-31', '303', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.62');
INSERT INTO public.europe_data_import VALUES (9328, '27/07/2020', '2020-30', '314', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.87');
INSERT INTO public.europe_data_import VALUES (9329, '20/07/2020', '2020-29', '326', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '7.13');
INSERT INTO public.europe_data_import VALUES (9330, '13/07/2020', '2020-28', '339', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '7.54');
INSERT INTO public.europe_data_import VALUES (9331, '06/07/2020', '2020-27', '364', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '8.11');
INSERT INTO public.europe_data_import VALUES (9332, '29/06/2020', '2020-26', '392', '0', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '8.73');
INSERT INTO public.europe_data_import VALUES (9333, '22/06/2020', '2020-25', '422', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '9.96');
INSERT INTO public.europe_data_import VALUES (9334, '15/06/2020', '2020-24', '506', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '13.17');
INSERT INTO public.europe_data_import VALUES (9335, '08/06/2020', '2020-23', '722', '1', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '19.21');
INSERT INTO public.europe_data_import VALUES (9336, '01/06/2020', '2020-22', '1069', '3', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '24.49');
INSERT INTO public.europe_data_import VALUES (9337, '25/05/2020', '2020-21', '1214', '5', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '22.81');
INSERT INTO public.europe_data_import VALUES (9338, '18/05/2020', '2020-20', '912', '19', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '15.53');
INSERT INTO public.europe_data_import VALUES (9339, '11/05/2020', '2020-19', '536', '18', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '6.57');
INSERT INTO public.europe_data_import VALUES (9340, '04/05/2020', '2020-18', '76', '2', '9321023', 'Tajikistan', 'TJ', 'TJK', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (9341, '01/02/2021', '2021-04', '5931', '2', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '10.33');
INSERT INTO public.europe_data_import VALUES (9342, '25/01/2021', '2021-03', '1264', '5', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '4.51');
INSERT INTO public.europe_data_import VALUES (9343, '18/01/2021', '2021-02', '1876', '3', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '5.72');
INSERT INTO public.europe_data_import VALUES (9344, '11/01/2021', '2021-01', '2108', '2', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '6.12');
INSERT INTO public.europe_data_import VALUES (9345, '04/01/2021', '2020-53', '2154', '5', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '5.07');
INSERT INTO public.europe_data_import VALUES (9346, '28/12/2020', '2020-52', '1378', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '2.94');
INSERT INTO public.europe_data_import VALUES (9347, '21/12/2020', '2020-51', '670', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '1.15');
INSERT INTO public.europe_data_import VALUES (9348, '14/12/2020', '2020-50', '130', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (9349, '07/12/2020', '2020-49', '130', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.28');
INSERT INTO public.europe_data_import VALUES (9350, '30/11/2020', '2020-48', '64', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (9351, '23/11/2020', '2020-47', '38', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9352, '16/11/2020', '2020-46', '35', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (9353, '09/11/2020', '2020-45', '53', '1', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.14');
INSERT INTO public.europe_data_import VALUES (9354, '02/11/2020', '2020-44', '44', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.14');
INSERT INTO public.europe_data_import VALUES (9355, '26/10/2020', '2020-43', '52', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (9356, '19/10/2020', '2020-42', '50', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (9357, '12/10/2020', '2020-41', '51', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.14');
INSERT INTO public.europe_data_import VALUES (9358, '05/10/2020', '2020-40', '45', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (9359, '28/09/2020', '2020-39', '39', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9360, '21/09/2020', '2020-38', '31', '1', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (9361, '14/09/2020', '2020-37', '30', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (9362, '07/09/2020', '2020-36', '33', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9363, '31/08/2020', '2020-35', '15', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9364, '24/08/2020', '2020-34', '19', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9365, '17/08/2020', '2020-33', '27', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9366, '10/08/2020', '2020-32', '31', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9367, '03/08/2020', '2020-31', '25', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9368, '27/07/2020', '2020-30', '45', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (9369, '20/07/2020', '2020-29', '30', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9370, '13/07/2020', '2020-28', '25', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9371, '06/07/2020', '2020-27', '33', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (9372, '29/06/2020', '2020-26', '14', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9373, '22/06/2020', '2020-25', '13', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9374, '15/06/2020', '2020-24', '16', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9375, '08/06/2020', '2020-23', '38', '1', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.11');
INSERT INTO public.europe_data_import VALUES (9376, '01/06/2020', '2020-22', '39', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9377, '25/05/2020', '2020-21', '14', '1', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9378, '18/05/2020', '2020-20', '13', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9379, '11/05/2020', '2020-19', '46', '2', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (9380, '04/05/2020', '2020-18', '47', '3', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.29');
INSERT INTO public.europe_data_import VALUES (9381, '27/04/2020', '2020-17', '157', '4', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.49');
INSERT INTO public.europe_data_import VALUES (9382, '20/04/2020', '2020-16', '186', '7', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.78');
INSERT INTO public.europe_data_import VALUES (9383, '13/04/2020', '2020-15', '359', '14', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '1.71');
INSERT INTO public.europe_data_import VALUES (9384, '06/04/2020', '2020-14', '832', '19', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '2.15');
INSERT INTO public.europe_data_import VALUES (9385, '30/03/2020', '2020-13', '667', '6', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '1.83');
INSERT INTO public.europe_data_import VALUES (9386, '23/03/2020', '2020-12', '607', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.96');
INSERT INTO public.europe_data_import VALUES (9387, '16/03/2020', '2020-11', '64', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (9388, '09/03/2020', '2020-10', '7', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9389, '02/03/2020', '2020-09', '8', '1', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9390, '24/02/2020', '2020-08', '1', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (9391, '17/02/2020', '2020-07', '2', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9392, '10/02/2020', '2020-06', '13', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (9393, '03/02/2020', '2020-05', '11', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (9394, '27/01/2020', '2020-04', '6', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9395, '20/01/2020', '2020-03', '1', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (9396, '13/01/2020', '2020-02', '1', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (9397, '06/01/2020', '2020-01', '0', '0', '69625581', 'Thailand', 'TH', 'THA', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (9398, '01/02/2021', '2021-04', '3', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '1.39');
INSERT INTO public.europe_data_import VALUES (9399, '25/01/2021', '2021-03', '15', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '1.39');
INSERT INTO public.europe_data_import VALUES (9400, '18/01/2021', '2021-02', '3', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.62');
INSERT INTO public.europe_data_import VALUES (9401, '11/01/2021', '2021-01', '5', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.62');
INSERT INTO public.europe_data_import VALUES (9402, '04/01/2021', '2020-53', '3', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '1.01');
INSERT INTO public.europe_data_import VALUES (9403, '28/12/2020', '2020-52', '10', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.77');
INSERT INTO public.europe_data_import VALUES (9404, '21/12/2020', '2020-51', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9405, '14/12/2020', '2020-50', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9406, '07/12/2020', '2020-49', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9407, '30/11/2020', '2020-48', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9408, '23/11/2020', '2020-47', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9409, '16/11/2020', '2020-46', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9410, '09/11/2020', '2020-45', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9411, '02/11/2020', '2020-44', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9412, '26/10/2020', '2020-43', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9413, '19/10/2020', '2020-42', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9414, '12/10/2020', '2020-41', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9415, '05/10/2020', '2020-40', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9416, '28/09/2020', '2020-39', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9417, '21/09/2020', '2020-38', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9418, '14/09/2020', '2020-37', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9419, '07/09/2020', '2020-36', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9420, '31/08/2020', '2020-35', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (9421, '24/08/2020', '2020-34', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9422, '17/08/2020', '2020-33', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9423, '10/08/2020', '2020-32', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9424, '03/08/2020', '2020-31', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9425, '27/07/2020', '2020-30', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9426, '20/07/2020', '2020-29', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9427, '13/07/2020', '2020-28', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9428, '06/07/2020', '2020-27', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9429, '29/06/2020', '2020-26', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9430, '22/06/2020', '2020-25', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9431, '15/06/2020', '2020-24', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9432, '08/06/2020', '2020-23', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9433, '01/06/2020', '2020-22', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9434, '25/05/2020', '2020-21', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9435, '18/05/2020', '2020-20', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9436, '11/05/2020', '2020-19', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9437, '04/05/2020', '2020-18', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.39');
INSERT INTO public.europe_data_import VALUES (9438, '27/04/2020', '2020-17', '5', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '1.7');
INSERT INTO public.europe_data_import VALUES (9439, '20/04/2020', '2020-16', '17', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '1.39');
INSERT INTO public.europe_data_import VALUES (9440, '13/04/2020', '2020-15', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9441, '06/04/2020', '2020-14', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9442, '30/03/2020', '2020-13', '0', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (9443, '23/03/2020', '2020-12', '1', '0', '1293120', 'Timor_Leste', 'TL', 'TLS', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (9444, '01/02/2021', '2021-04', '430', '3', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '9.77');
INSERT INTO public.europe_data_import VALUES (9445, '25/01/2021', '2021-03', '360', '3', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '8.72');
INSERT INTO public.europe_data_import VALUES (9446, '18/01/2021', '2021-02', '345', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '7.42');
INSERT INTO public.europe_data_import VALUES (9447, '11/01/2021', '2021-01', '255', '4', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '4.71');
INSERT INTO public.europe_data_import VALUES (9448, '04/01/2021', '2020-53', '126', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.54');
INSERT INTO public.europe_data_import VALUES (9449, '28/12/2020', '2020-52', '160', '2', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '4.02');
INSERT INTO public.europe_data_import VALUES (9450, '21/12/2020', '2020-51', '165', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.97');
INSERT INTO public.europe_data_import VALUES (9451, '14/12/2020', '2020-50', '156', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.58');
INSERT INTO public.europe_data_import VALUES (9452, '07/12/2020', '2020-49', '133', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.12');
INSERT INTO public.europe_data_import VALUES (9453, '30/11/2020', '2020-48', '119', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.55');
INSERT INTO public.europe_data_import VALUES (9454, '23/11/2020', '2020-47', '168', '3', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '4.05');
INSERT INTO public.europe_data_import VALUES (9455, '16/11/2020', '2020-46', '159', '4', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.93');
INSERT INTO public.europe_data_import VALUES (9456, '09/11/2020', '2020-45', '159', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.91');
INSERT INTO public.europe_data_import VALUES (9457, '02/11/2020', '2020-44', '157', '5', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.71');
INSERT INTO public.europe_data_import VALUES (9458, '26/10/2020', '2020-43', '143', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.22');
INSERT INTO public.europe_data_import VALUES (9459, '19/10/2020', '2020-42', '117', '2', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.51');
INSERT INTO public.europe_data_import VALUES (9460, '12/10/2020', '2020-41', '86', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.44');
INSERT INTO public.europe_data_import VALUES (9461, '05/10/2020', '2020-40', '111', '2', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.33');
INSERT INTO public.europe_data_import VALUES (9462, '28/09/2020', '2020-39', '77', '5', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.12');
INSERT INTO public.europe_data_import VALUES (9463, '21/09/2020', '2020-38', '94', '4', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.2');
INSERT INTO public.europe_data_import VALUES (9464, '14/09/2020', '2020-37', '84', '5', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.18');
INSERT INTO public.europe_data_import VALUES (9465, '07/09/2020', '2020-36', '92', '5', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.61');
INSERT INTO public.europe_data_import VALUES (9466, '31/08/2020', '2020-35', '119', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '3.08');
INSERT INTO public.europe_data_import VALUES (9467, '24/08/2020', '2020-34', '130', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.68');
INSERT INTO public.europe_data_import VALUES (9468, '17/08/2020', '2020-33', '87', '4', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.3');
INSERT INTO public.europe_data_import VALUES (9469, '10/08/2020', '2020-32', '99', '4', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.38');
INSERT INTO public.europe_data_import VALUES (9470, '03/08/2020', '2020-31', '93', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.31');
INSERT INTO public.europe_data_import VALUES (9471, '27/07/2020', '2020-30', '94', '3', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.83');
INSERT INTO public.europe_data_import VALUES (9472, '20/07/2020', '2020-29', '54', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.16');
INSERT INTO public.europe_data_import VALUES (9473, '13/07/2020', '2020-28', '40', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.97');
INSERT INTO public.europe_data_import VALUES (9474, '06/07/2020', '2020-27', '38', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.37');
INSERT INTO public.europe_data_import VALUES (9475, '29/06/2020', '2020-26', '73', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.37');
INSERT INTO public.europe_data_import VALUES (9476, '22/06/2020', '2020-25', '38', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.92');
INSERT INTO public.europe_data_import VALUES (9477, '15/06/2020', '2020-24', '36', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.1');
INSERT INTO public.europe_data_import VALUES (9478, '08/06/2020', '2020-23', '53', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (9479, '01/06/2020', '2020-22', '61', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '1.74');
INSERT INTO public.europe_data_import VALUES (9480, '25/05/2020', '2020-21', '80', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.56');
INSERT INTO public.europe_data_import VALUES (9481, '18/05/2020', '2020-20', '127', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '2.19');
INSERT INTO public.europe_data_import VALUES (9482, '11/05/2020', '2020-19', '50', '2', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.94');
INSERT INTO public.europe_data_import VALUES (9483, '04/05/2020', '2020-18', '26', '3', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.49');
INSERT INTO public.europe_data_import VALUES (9484, '27/04/2020', '2020-17', '14', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (9485, '20/04/2020', '2020-16', '8', '2', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.49');
INSERT INTO public.europe_data_import VALUES (9486, '13/04/2020', '2020-15', '32', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.57');
INSERT INTO public.europe_data_import VALUES (9487, '06/04/2020', '2020-14', '14', '2', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.36');
INSERT INTO public.europe_data_import VALUES (9488, '30/03/2020', '2020-13', '15', '1', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.36');
INSERT INTO public.europe_data_import VALUES (9489, '23/03/2020', '2020-12', '14', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '0.19');
INSERT INTO public.europe_data_import VALUES (9490, '16/03/2020', '2020-11', '1', '0', '8082359', 'Togo', 'TG', 'TGO', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (9491, '01/02/2021', '2021-04', '74', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '12.26');
INSERT INTO public.europe_data_import VALUES (9492, '25/01/2021', '2021-03', '97', '2', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '16.13');
INSERT INTO public.europe_data_import VALUES (9493, '18/01/2021', '2021-02', '128', '4', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '16.13');
INSERT INTO public.europe_data_import VALUES (9494, '11/01/2021', '2021-01', '97', '1', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '10.75');
INSERT INTO public.europe_data_import VALUES (9495, '04/01/2021', '2020-53', '53', '2', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '11.18');
INSERT INTO public.europe_data_import VALUES (9496, '28/12/2020', '2020-52', '103', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '16.92');
INSERT INTO public.europe_data_import VALUES (9497, '21/12/2020', '2020-51', '133', '3', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '17.56');
INSERT INTO public.europe_data_import VALUES (9498, '14/12/2020', '2020-50', '112', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '15.7');
INSERT INTO public.europe_data_import VALUES (9499, '07/12/2020', '2020-49', '107', '2', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '22.72');
INSERT INTO public.europe_data_import VALUES (9500, '30/11/2020', '2020-48', '210', '5', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '41.58');
INSERT INTO public.europe_data_import VALUES (9501, '23/11/2020', '2020-47', '370', '3', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '43.08');
INSERT INTO public.europe_data_import VALUES (9502, '16/11/2020', '2020-46', '231', '1', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '29.53');
INSERT INTO public.europe_data_import VALUES (9503, '09/11/2020', '2020-45', '181', '4', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '24.23');
INSERT INTO public.europe_data_import VALUES (9504, '02/11/2020', '2020-44', '157', '2', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '26.6');
INSERT INTO public.europe_data_import VALUES (9505, '26/10/2020', '2020-43', '214', '9', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '29.39');
INSERT INTO public.europe_data_import VALUES (9506, '19/10/2020', '2020-42', '196', '6', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '38.28');
INSERT INTO public.europe_data_import VALUES (9507, '12/10/2020', '2020-41', '338', '9', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '52.98');
INSERT INTO public.europe_data_import VALUES (9508, '05/10/2020', '2020-40', '401', '10', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '61.79');
INSERT INTO public.europe_data_import VALUES (9509, '28/09/2020', '2020-39', '461', '6', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '94.63');
INSERT INTO public.europe_data_import VALUES (9510, '21/09/2020', '2020-38', '859', '12', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '118.35');
INSERT INTO public.europe_data_import VALUES (9511, '14/09/2020', '2020-37', '792', '19', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '97.42');
INSERT INTO public.europe_data_import VALUES (9512, '07/09/2020', '2020-36', '567', '13', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '89.11');
INSERT INTO public.europe_data_import VALUES (9513, '31/08/2020', '2020-35', '676', '7', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '81.08');
INSERT INTO public.europe_data_import VALUES (9514, '24/08/2020', '2020-34', '455', '3', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '52.19');
INSERT INTO public.europe_data_import VALUES (9515, '17/08/2020', '2020-33', '273', '3', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '26.52');
INSERT INTO public.europe_data_import VALUES (9516, '10/08/2020', '2020-32', '97', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '9.46');
INSERT INTO public.europe_data_import VALUES (9517, '03/08/2020', '2020-31', '35', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '3.23');
INSERT INTO public.europe_data_import VALUES (9518, '27/07/2020', '2020-30', '10', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '1.0');
INSERT INTO public.europe_data_import VALUES (9519, '20/07/2020', '2020-29', '4', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.29');
INSERT INTO public.europe_data_import VALUES (9520, '13/07/2020', '2020-28', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.5');
INSERT INTO public.europe_data_import VALUES (9521, '06/07/2020', '2020-27', '7', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.72');
INSERT INTO public.europe_data_import VALUES (9522, '29/06/2020', '2020-26', '3', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.22');
INSERT INTO public.europe_data_import VALUES (9523, '22/06/2020', '2020-25', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.43');
INSERT INTO public.europe_data_import VALUES (9524, '15/06/2020', '2020-24', '6', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.43');
INSERT INTO public.europe_data_import VALUES (9525, '08/06/2020', '2020-23', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.07');
INSERT INTO public.europe_data_import VALUES (9526, '01/06/2020', '2020-22', '1', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.07');
INSERT INTO public.europe_data_import VALUES (9527, '25/05/2020', '2020-21', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9528, '18/05/2020', '2020-20', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9529, '11/05/2020', '2020-19', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9530, '04/05/2020', '2020-18', '0', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.14');
INSERT INTO public.europe_data_import VALUES (9531, '27/04/2020', '2020-17', '2', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.22');
INSERT INTO public.europe_data_import VALUES (9532, '20/04/2020', '2020-16', '1', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '0.72');
INSERT INTO public.europe_data_import VALUES (9533, '13/04/2020', '2020-15', '9', '1', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '2.51');
INSERT INTO public.europe_data_import VALUES (9534, '06/04/2020', '2020-14', '26', '4', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '3.87');
INSERT INTO public.europe_data_import VALUES (9535, '30/03/2020', '2020-13', '28', '3', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '5.3');
INSERT INTO public.europe_data_import VALUES (9536, '23/03/2020', '2020-12', '46', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '3.58');
INSERT INTO public.europe_data_import VALUES (9537, '16/03/2020', '2020-11', '4', '0', '1394969', 'Trinidad_and_Tobago', 'TT', 'TTO', 'America', '');
INSERT INTO public.europe_data_import VALUES (9538, '01/02/2021', '2021-04', '11409', '515', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '240.79');
INSERT INTO public.europe_data_import VALUES (9539, '25/01/2021', '2021-03', '16751', '537', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '310.28');
INSERT INTO public.europe_data_import VALUES (9540, '18/01/2021', '2021-02', '19535', '466', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '327.85');
INSERT INTO public.europe_data_import VALUES (9541, '11/01/2021', '2021-01', '18806', '484', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '263.01');
INSERT INTO public.europe_data_import VALUES (9542, '04/01/2021', '2020-53', '11952', '334', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '186.63');
INSERT INTO public.europe_data_import VALUES (9543, '28/12/2020', '2020-52', '9874', '267', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '172.99');
INSERT INTO public.europe_data_import VALUES (9544, '21/12/2020', '2020-51', '10357', '305', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '151.49');
INSERT INTO public.europe_data_import VALUES (9545, '14/12/2020', '2020-50', '7359', '333', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '129.2');
INSERT INTO public.europe_data_import VALUES (9546, '07/12/2020', '2020-49', '7751', '342', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '130.75');
INSERT INTO public.europe_data_import VALUES (9547, '30/11/2020', '2020-48', '7540', '398', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '135.51');
INSERT INTO public.europe_data_import VALUES (9548, '23/11/2020', '2020-47', '8307', '476', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '150.43');
INSERT INTO public.europe_data_import VALUES (9549, '16/11/2020', '2020-46', '9285', '472', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '158.17');
INSERT INTO public.europe_data_import VALUES (9550, '09/11/2020', '2020-45', '9213', '492', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '190.86');
INSERT INTO public.europe_data_import VALUES (9551, '02/11/2020', '2020-44', '13107', '562', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '182.68');
INSERT INTO public.europe_data_import VALUES (9552, '26/10/2020', '2020-43', '8257', '193', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '149.98');
INSERT INTO public.europe_data_import VALUES (9553, '19/10/2020', '2020-42', '9283', '170', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '146.13');
INSERT INTO public.europe_data_import VALUES (9554, '12/10/2020', '2020-41', '7806', '135', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '129.5');
INSERT INTO public.europe_data_import VALUES (9555, '05/10/2020', '2020-40', '7339', '107', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '108.78');
INSERT INTO public.europe_data_import VALUES (9556, '28/09/2020', '2020-39', '5382', '55', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '81.05');
INSERT INTO public.europe_data_import VALUES (9557, '21/09/2020', '2020-38', '4097', '52', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '50.93');
INSERT INTO public.europe_data_import VALUES (9558, '14/09/2020', '2020-37', '1859', '14', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '25.23');
INSERT INTO public.europe_data_import VALUES (9559, '07/09/2020', '2020-36', '1091', '17', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '17.43');
INSERT INTO public.europe_data_import VALUES (9560, '31/08/2020', '2020-35', '947', '8', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '13.49');
INSERT INTO public.europe_data_import VALUES (9561, '24/08/2020', '2020-34', '631', '14', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '8.9');
INSERT INTO public.europe_data_import VALUES (9562, '17/08/2020', '2020-33', '410', '3', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '4.67');
INSERT INTO public.europe_data_import VALUES (9563, '10/08/2020', '2020-32', '136', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '2.09');
INSERT INTO public.europe_data_import VALUES (9564, '03/08/2020', '2020-31', '109', '1', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '1.6');
INSERT INTO public.europe_data_import VALUES (9565, '27/07/2020', '2020-30', '78', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '1.62');
INSERT INTO public.europe_data_import VALUES (9566, '20/07/2020', '2020-29', '111', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '1.59');
INSERT INTO public.europe_data_import VALUES (9567, '13/07/2020', '2020-28', '75', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.8');
INSERT INTO public.europe_data_import VALUES (9568, '06/07/2020', '2020-27', '19', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.27');
INSERT INTO public.europe_data_import VALUES (9569, '29/06/2020', '2020-26', '12', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.62');
INSERT INTO public.europe_data_import VALUES (9570, '22/06/2020', '2020-25', '61', '1', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.6');
INSERT INTO public.europe_data_import VALUES (9571, '15/06/2020', '2020-24', '9', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (9572, '08/06/2020', '2020-23', '10', '1', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (9573, '01/06/2020', '2020-22', '26', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (9574, '25/05/2020', '2020-21', '14', '3', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (9575, '18/05/2020', '2020-20', '5', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.21');
INSERT INTO public.europe_data_import VALUES (9576, '11/05/2020', '2020-19', '19', '3', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.71');
INSERT INTO public.europe_data_import VALUES (9577, '04/05/2020', '2020-18', '64', '4', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '1.15');
INSERT INTO public.europe_data_import VALUES (9578, '27/04/2020', '2020-17', '70', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '2.07');
INSERT INTO public.europe_data_import VALUES (9579, '20/04/2020', '2020-16', '172', '7', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '2.79');
INSERT INTO public.europe_data_import VALUES (9580, '13/04/2020', '2020-15', '154', '12', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '3.67');
INSERT INTO public.europe_data_import VALUES (9581, '06/04/2020', '2020-14', '275', '11', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '4.09');
INSERT INTO public.europe_data_import VALUES (9582, '30/03/2020', '2020-13', '203', '5', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '2.22');
INSERT INTO public.europe_data_import VALUES (9583, '23/03/2020', '2020-12', '57', '3', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '0.64');
INSERT INTO public.europe_data_import VALUES (9584, '16/03/2020', '2020-11', '18', '0', '11694721', 'Tunisia', 'TN', 'TUN', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (9585, '01/02/2021', '2021-04', '47858', '920', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '110.19');
INSERT INTO public.europe_data_import VALUES (9586, '25/01/2021', '2021-03', '42504', '1076', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '126.03');
INSERT INTO public.europe_data_import VALUES (9587, '18/01/2021', '2021-02', '60845', '1190', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '177.05');
INSERT INTO public.europe_data_import VALUES (9588, '11/01/2021', '2021-01', '84344', '1319', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '217.89');
INSERT INTO public.europe_data_import VALUES (9589, '04/01/2021', '2020-53', '94334', '1610', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '265.0');
INSERT INTO public.europe_data_import VALUES (9590, '28/12/2020', '2020-52', '122977', '1781', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '379.07');
INSERT INTO public.europe_data_import VALUES (9591, '21/12/2020', '2020-51', '187873', '1680', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '492.06');
INSERT INTO public.europe_data_import VALUES (9592, '14/12/2020', '2020-50', '215632', '1517', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '532.05');
INSERT INTO public.europe_data_import VALUES (9593, '07/12/2020', '2020-49', '220667', '1342', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '463.55');
INSERT INTO public.europe_data_import VALUES (9594, '30/11/2020', '2020-48', '159462', '1200', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '291.6');
INSERT INTO public.europe_data_import VALUES (9595, '23/11/2020', '2020-47', '79659', '851', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '179.01');
INSERT INTO public.europe_data_import VALUES (9596, '16/11/2020', '2020-46', '67133', '620', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '159.78');
INSERT INTO public.europe_data_import VALUES (9597, '09/11/2020', '2020-45', '63892', '561', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '154.47');
INSERT INTO public.europe_data_import VALUES (9598, '02/11/2020', '2020-44', '62782', '527', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '151.46');
INSERT INTO public.europe_data_import VALUES (9599, '26/10/2020', '2020-43', '61418', '503', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '146.93');
INSERT INTO public.europe_data_import VALUES (9600, '19/10/2020', '2020-42', '59070', '459', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '143.01');
INSERT INTO public.europe_data_import VALUES (9601, '12/10/2020', '2020-41', '58200', '396', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '140.63');
INSERT INTO public.europe_data_import VALUES (9602, '05/10/2020', '2020-40', '57120', '444', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '141.21');
INSERT INTO public.europe_data_import VALUES (9603, '28/09/2020', '2020-39', '58676', '491', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '143.27');
INSERT INTO public.europe_data_import VALUES (9604, '21/09/2020', '2020-38', '58815', '450', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '143.02');
INSERT INTO public.europe_data_import VALUES (9605, '14/09/2020', '2020-37', '58466', '383', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '142.48');
INSERT INTO public.europe_data_import VALUES (9606, '07/09/2020', '2020-36', '58370', '347', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '141.18');
INSERT INTO public.europe_data_import VALUES (9607, '31/08/2020', '2020-35', '57407', '205', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '138.36');
INSERT INTO public.europe_data_import VALUES (9608, '24/08/2020', '2020-34', '56050', '147', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '136.17');
INSERT INTO public.europe_data_import VALUES (9609, '17/08/2020', '2020-33', '55615', '130', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '134.96');
INSERT INTO public.europe_data_import VALUES (9610, '10/08/2020', '2020-32', '55058', '116', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '124.62');
INSERT INTO public.europe_data_import VALUES (9611, '03/08/2020', '2020-31', '47136', '115', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '65.36');
INSERT INTO public.europe_data_import VALUES (9612, '27/07/2020', '2020-30', '6459', '122', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '15.98');
INSERT INTO public.europe_data_import VALUES (9613, '20/07/2020', '2020-29', '6648', '128', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '16.93');
INSERT INTO public.europe_data_import VALUES (9614, '13/07/2020', '2020-28', '7235', '138', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '19.21');
INSERT INTO public.europe_data_import VALUES (9615, '06/07/2020', '2020-27', '8519', '128', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '22.04');
INSERT INTO public.europe_data_import VALUES (9616, '29/06/2020', '2020-26', '9554', '147', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '23.17');
INSERT INTO public.europe_data_import VALUES (9617, '22/06/2020', '2020-25', '9446', '143', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '21.41');
INSERT INTO public.europe_data_import VALUES (9618, '15/06/2020', '2020-24', '8107', '115', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '17.43');
INSERT INTO public.europe_data_import VALUES (9619, '08/06/2020', '2020-23', '6190', '152', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '16.22');
INSERT INTO public.europe_data_import VALUES (9620, '01/06/2020', '2020-22', '7115', '200', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '17.69');
INSERT INTO public.europe_data_import VALUES (9621, '25/05/2020', '2020-21', '7392', '200', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '22.16');
INSERT INTO public.europe_data_import VALUES (9622, '18/05/2020', '2020-20', '10778', '354', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '28.52');
INSERT INTO public.europe_data_import VALUES (9623, '11/05/2020', '2020-19', '12612', '389', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '34.79');
INSERT INTO public.europe_data_import VALUES (9624, '04/05/2020', '2020-18', '15915', '592', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '48.46');
INSERT INTO public.europe_data_import VALUES (9625, '27/04/2020', '2020-17', '23824', '788', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '64.84');
INSERT INTO public.europe_data_import VALUES (9626, '20/04/2020', '2020-16', '29350', '819', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '72.24');
INSERT INTO public.europe_data_import VALUES (9627, '13/04/2020', '2020-15', '29887', '624', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '58.15');
INSERT INTO public.europe_data_import VALUES (9628, '06/04/2020', '2020-14', '17798', '443', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '31.5');
INSERT INTO public.europe_data_import VALUES (9629, '30/03/2020', '2020-13', '8035', '101', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '11.28');
INSERT INTO public.europe_data_import VALUES (9630, '23/03/2020', '2020-12', '1218', '30', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '1.51');
INSERT INTO public.europe_data_import VALUES (9631, '16/03/2020', '2020-11', '18', '0', '82003882', 'Turkey', 'TR', 'TUR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (9632, '01/02/2021', '2021-04', '217', '2', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '1044.67');
INSERT INTO public.europe_data_import VALUES (9633, '25/01/2021', '2021-03', '182', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '767.14');
INSERT INTO public.europe_data_import VALUES (9634, '18/01/2021', '2021-02', '111', '1', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '510.55');
INSERT INTO public.europe_data_import VALUES (9635, '11/01/2021', '2021-01', '84', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '379.64');
INSERT INTO public.europe_data_import VALUES (9636, '04/01/2021', '2020-53', '61', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '293.24');
INSERT INTO public.europe_data_import VALUES (9637, '28/12/2020', '2020-52', '51', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '209.46');
INSERT INTO public.europe_data_import VALUES (9638, '21/12/2020', '2020-51', '29', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '109.96');
INSERT INTO public.europe_data_import VALUES (9639, '14/12/2020', '2020-50', '13', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '54.98');
INSERT INTO public.europe_data_import VALUES (9640, '07/12/2020', '2020-49', '8', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '26.18');
INSERT INTO public.europe_data_import VALUES (9641, '30/11/2020', '2020-48', '2', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '73.31');
INSERT INTO public.europe_data_import VALUES (9642, '23/11/2020', '2020-47', '26', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '102.11');
INSERT INTO public.europe_data_import VALUES (9643, '16/11/2020', '2020-46', '13', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '41.89');
INSERT INTO public.europe_data_import VALUES (9644, '09/11/2020', '2020-45', '3', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '15.71');
INSERT INTO public.europe_data_import VALUES (9645, '02/11/2020', '2020-44', '3', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '15.71');
INSERT INTO public.europe_data_import VALUES (9646, '26/10/2020', '2020-43', '3', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '15.71');
INSERT INTO public.europe_data_import VALUES (9647, '19/10/2020', '2020-42', '3', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '7.85');
INSERT INTO public.europe_data_import VALUES (9648, '12/10/2020', '2020-41', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '34.04');
INSERT INTO public.europe_data_import VALUES (9649, '05/10/2020', '2020-40', '13', '1', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '70.69');
INSERT INTO public.europe_data_import VALUES (9650, '28/09/2020', '2020-39', '14', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '94.26');
INSERT INTO public.europe_data_import VALUES (9651, '21/09/2020', '2020-38', '22', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '183.27');
INSERT INTO public.europe_data_import VALUES (9652, '14/09/2020', '2020-37', '48', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '363.93');
INSERT INTO public.europe_data_import VALUES (9653, '07/09/2020', '2020-36', '91', '2', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '562.92');
INSERT INTO public.europe_data_import VALUES (9654, '31/08/2020', '2020-35', '124', '1', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '547.21');
INSERT INTO public.europe_data_import VALUES (9655, '24/08/2020', '2020-34', '85', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '437.24');
INSERT INTO public.europe_data_import VALUES (9656, '17/08/2020', '2020-33', '82', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '476.51');
INSERT INTO public.europe_data_import VALUES (9657, '10/08/2020', '2020-32', '100', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '306.33');
INSERT INTO public.europe_data_import VALUES (9658, '03/08/2020', '2020-31', '17', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '91.64');
INSERT INTO public.europe_data_import VALUES (9659, '27/07/2020', '2020-30', '18', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '70.69');
INSERT INTO public.europe_data_import VALUES (9660, '20/07/2020', '2020-29', '9', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '89.02');
INSERT INTO public.europe_data_import VALUES (9661, '13/07/2020', '2020-28', '25', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '115.2');
INSERT INTO public.europe_data_import VALUES (9662, '06/07/2020', '2020-27', '19', '1', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '86.4');
INSERT INTO public.europe_data_import VALUES (9663, '29/06/2020', '2020-26', '14', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '41.89');
INSERT INTO public.europe_data_import VALUES (9664, '22/06/2020', '2020-25', '2', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '5.24');
INSERT INTO public.europe_data_import VALUES (9665, '15/06/2020', '2020-24', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9666, '08/06/2020', '2020-23', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9667, '01/06/2020', '2020-22', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9668, '25/05/2020', '2020-21', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9669, '18/05/2020', '2020-20', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9670, '11/05/2020', '2020-19', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '2.62');
INSERT INTO public.europe_data_import VALUES (9671, '04/05/2020', '2020-18', '1', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '2.62');
INSERT INTO public.europe_data_import VALUES (9672, '27/04/2020', '2020-17', '0', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '5.24');
INSERT INTO public.europe_data_import VALUES (9673, '20/04/2020', '2020-16', '2', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '15.71');
INSERT INTO public.europe_data_import VALUES (9674, '13/04/2020', '2020-15', '4', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '10.47');
INSERT INTO public.europe_data_import VALUES (9675, '06/04/2020', '2020-14', '0', '1', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '13.09');
INSERT INTO public.europe_data_import VALUES (9676, '30/03/2020', '2020-13', '5', '0', '38194', 'Turks_and_Caicos_islands', 'TC', 'TCA', 'America', '');
INSERT INTO public.europe_data_import VALUES (9677, '01/02/2021', '2021-04', '418', '7', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '3.44');
INSERT INTO public.europe_data_import VALUES (9678, '25/01/2021', '2021-03', '1103', '14', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '3.12');
INSERT INTO public.europe_data_import VALUES (9679, '18/01/2021', '2021-02', '277', '2', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '4.6');
INSERT INTO public.europe_data_import VALUES (9680, '11/01/2021', '2021-01', '1758', '28', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '8.66');
INSERT INTO public.europe_data_import VALUES (9681, '04/01/2021', '2020-53', '2077', '26', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '10.98');
INSERT INTO public.europe_data_import VALUES (9682, '28/12/2020', '2020-52', '2786', '17', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '14.55');
INSERT INTO public.europe_data_import VALUES (9683, '21/12/2020', '2020-51', '3655', '10', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '19.63');
INSERT INTO public.europe_data_import VALUES (9684, '14/12/2020', '2020-50', '5033', '15', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '16.69');
INSERT INTO public.europe_data_import VALUES (9685, '07/12/2020', '2020-49', '2354', '5', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '10.24');
INSERT INTO public.europe_data_import VALUES (9686, '30/11/2020', '2020-48', '2177', '29', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '9.32');
INSERT INTO public.europe_data_import VALUES (9687, '23/11/2020', '2020-47', '1948', '27', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '8.05');
INSERT INTO public.europe_data_import VALUES (9688, '16/11/2020', '2020-46', '1617', '13', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '7.4');
INSERT INTO public.europe_data_import VALUES (9689, '09/11/2020', '2020-45', '1660', '20', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '6.69');
INSERT INTO public.europe_data_import VALUES (9690, '02/11/2020', '2020-44', '1300', '11', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '4.86');
INSERT INTO public.europe_data_import VALUES (9691, '26/10/2020', '2020-43', '853', '4', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '3.71');
INSERT INTO public.europe_data_import VALUES (9692, '19/10/2020', '2020-42', '789', '4', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '4.03');
INSERT INTO public.europe_data_import VALUES (9693, '12/10/2020', '2020-41', '993', '12', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '5.13');
INSERT INTO public.europe_data_import VALUES (9694, '05/10/2020', '2020-40', '1278', '8', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '5.69');
INSERT INTO public.europe_data_import VALUES (9695, '28/09/2020', '2020-39', '1243', '10', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '6.17');
INSERT INTO public.europe_data_import VALUES (9696, '21/09/2020', '2020-38', '1488', '8', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '5.92');
INSERT INTO public.europe_data_import VALUES (9697, '14/09/2020', '2020-37', '1132', '14', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '4.23');
INSERT INTO public.europe_data_import VALUES (9698, '07/09/2020', '2020-36', '739', '11', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '3.17');
INSERT INTO public.europe_data_import VALUES (9699, '31/08/2020', '2020-35', '665', '11', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '3.23');
INSERT INTO public.europe_data_import VALUES (9700, '24/08/2020', '2020-34', '763', '6', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '2.21');
INSERT INTO public.europe_data_import VALUES (9701, '17/08/2020', '2020-33', '217', '6', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.72');
INSERT INTO public.europe_data_import VALUES (9702, '10/08/2020', '2020-32', '101', '3', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.38');
INSERT INTO public.europe_data_import VALUES (9703, '03/08/2020', '2020-31', '67', '2', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (9704, '27/07/2020', '2020-30', '50', '2', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (9705, '20/07/2020', '2020-29', '40', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.28');
INSERT INTO public.europe_data_import VALUES (9706, '13/07/2020', '2020-28', '86', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (9707, '06/07/2020', '2020-27', '80', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.38');
INSERT INTO public.europe_data_import VALUES (9708, '29/06/2020', '2020-26', '89', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.37');
INSERT INTO public.europe_data_import VALUES (9709, '22/06/2020', '2020-25', '74', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (9710, '15/06/2020', '2020-24', '80', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.54');
INSERT INTO public.europe_data_import VALUES (9711, '08/06/2020', '2020-23', '158', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.91');
INSERT INTO public.europe_data_import VALUES (9712, '01/06/2020', '2020-22', '246', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.52');
INSERT INTO public.europe_data_import VALUES (9713, '25/05/2020', '2020-21', '-15', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.21');
INSERT INTO public.europe_data_import VALUES (9714, '18/05/2020', '2020-20', '106', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.31');
INSERT INTO public.europe_data_import VALUES (9715, '11/05/2020', '2020-19', '32', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.09');
INSERT INTO public.europe_data_import VALUES (9716, '04/05/2020', '2020-18', '10', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (9717, '27/04/2020', '2020-17', '24', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (9718, '20/04/2020', '2020-16', '1', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.01');
INSERT INTO public.europe_data_import VALUES (9719, '13/04/2020', '2020-15', '2', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (9720, '06/04/2020', '2020-14', '19', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (9721, '30/03/2020', '2020-13', '32', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '0.07');
INSERT INTO public.europe_data_import VALUES (9722, '23/03/2020', '2020-12', '1', '0', '44269587', 'Uganda', 'UG', 'UGA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (9723, '01/02/2021', '2021-04', '29551', '1010', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '136.75');
INSERT INTO public.europe_data_import VALUES (9724, '25/01/2021', '2021-03', '30612', '1055', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '170.51');
INSERT INTO public.europe_data_import VALUES (9725, '18/01/2021', '2021-02', '44402', '1034', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '203.72');
INSERT INTO public.europe_data_import VALUES (9726, '11/01/2021', '2021-01', '45221', '981', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '202.17');
INSERT INTO public.europe_data_import VALUES (9727, '04/01/2021', '2020-53', '43719', '1005', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '234.35');
INSERT INTO public.europe_data_import VALUES (9728, '28/12/2020', '2020-52', '59381', '1184', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '294.83');
INSERT INTO public.europe_data_import VALUES (9729, '21/12/2020', '2020-51', '70327', '1418', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '358.43');
INSERT INTO public.europe_data_import VALUES (9730, '14/12/2020', '2020-50', '87360', '1659', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '404.57');
INSERT INTO public.europe_data_import VALUES (9731, '07/12/2020', '2020-49', '90627', '1375', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '456.07');
INSERT INTO public.europe_data_import VALUES (9732, '30/11/2020', '2020-48', '110014', '1400', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '424.66');
INSERT INTO public.europe_data_import VALUES (9733, '23/11/2020', '2020-47', '76808', '1210', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '346.26');
INSERT INTO public.europe_data_import VALUES (9734, '16/11/2020', '2020-46', '75526', '1153', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '319.18');
INSERT INTO public.europe_data_import VALUES (9735, '09/11/2020', '2020-45', '64891', '1144', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '265.59');
INSERT INTO public.europe_data_import VALUES (9736, '02/11/2020', '2020-44', '51951', '915', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '208.67');
INSERT INTO public.europe_data_import VALUES (9737, '26/10/2020', '2020-43', '39851', '718', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '187.42');
INSERT INTO public.europe_data_import VALUES (9738, '19/10/2020', '2020-42', '42604', '701', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '175.43');
INSERT INTO public.europe_data_import VALUES (9739, '12/10/2020', '2020-41', '34572', '575', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '141.84');
INSERT INTO public.europe_data_import VALUES (9740, '05/10/2020', '2020-40', '27828', '438', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '115.43');
INSERT INTO public.europe_data_import VALUES (9741, '28/09/2020', '2020-39', '22956', '402', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '100.69');
INSERT INTO public.europe_data_import VALUES (9742, '21/09/2020', '2020-38', '21343', '379', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '90.43');
INSERT INTO public.europe_data_import VALUES (9743, '14/09/2020', '2020-37', '18441', '367', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '80.15');
INSERT INTO public.europe_data_import VALUES (9744, '07/09/2020', '2020-36', '16820', '284', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '70.32');
INSERT INTO public.europe_data_import VALUES (9745, '31/08/2020', '2020-35', '14116', '256', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '59.68');
INSERT INTO public.europe_data_import VALUES (9746, '24/08/2020', '2020-34', '12138', '182', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '52.28');
INSERT INTO public.europe_data_import VALUES (9747, '17/08/2020', '2020-33', '10863', '167', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '46.94');
INSERT INTO public.europe_data_import VALUES (9748, '10/08/2020', '2020-32', '9789', '197', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '38.89');
INSERT INTO public.europe_data_import VALUES (9749, '03/08/2020', '2020-31', '7319', '120', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '30.29');
INSERT INTO public.europe_data_import VALUES (9750, '27/07/2020', '2020-30', '6007', '120', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '25.75');
INSERT INTO public.europe_data_import VALUES (9751, '20/07/2020', '2020-29', '5321', '102', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '23.51');
INSERT INTO public.europe_data_import VALUES (9752, '13/07/2020', '2020-28', '5021', '134', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '23.96');
INSERT INTO public.europe_data_import VALUES (9753, '06/07/2020', '2020-27', '5518', '120', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '27.14');
INSERT INTO public.europe_data_import VALUES (9754, '29/06/2020', '2020-26', '6422', '127', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '26.89');
INSERT INTO public.europe_data_import VALUES (9755, '22/06/2020', '2020-25', '5406', '113', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '21.73');
INSERT INTO public.europe_data_import VALUES (9756, '15/06/2020', '2020-24', '4155', '101', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '17.01');
INSERT INTO public.europe_data_import VALUES (9757, '08/06/2020', '2020-23', '3327', '80', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '13.67');
INSERT INTO public.europe_data_import VALUES (9758, '01/06/2020', '2020-22', '2686', '91', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '12.23');
INSERT INTO public.europe_data_import VALUES (9759, '25/05/2020', '2020-21', '2695', '103', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '13.08');
INSERT INTO public.europe_data_import VALUES (9760, '18/05/2020', '2020-20', '3059', '123', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '14.5');
INSERT INTO public.europe_data_import VALUES (9761, '11/05/2020', '2020-19', '3319', '103', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '15.04');
INSERT INTO public.europe_data_import VALUES (9762, '04/05/2020', '2020-18', '3296', '79', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '14.69');
INSERT INTO public.europe_data_import VALUES (9763, '27/04/2020', '2020-17', '3168', '68', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '13.27');
INSERT INTO public.europe_data_import VALUES (9764, '20/04/2020', '2020-16', '2672', '58', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '9.41');
INSERT INTO public.europe_data_import VALUES (9765, '13/04/2020', '2020-15', '1469', '46', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '5.36');
INSERT INTO public.europe_data_import VALUES (9766, '06/04/2020', '2020-14', '890', '28', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '2.87');
INSERT INTO public.europe_data_import VALUES (9767, '30/03/2020', '2020-13', '371', '6', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '0.94');
INSERT INTO public.europe_data_import VALUES (9768, '23/03/2020', '2020-12', '44', '3', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '0.11');
INSERT INTO public.europe_data_import VALUES (9769, '16/03/2020', '2020-11', '3', '0', '43993643', 'Ukraine', 'UA', 'UKR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (9770, '01/02/2021', '2021-04', '25654', '58', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '515.3');
INSERT INTO public.europe_data_import VALUES (9771, '25/01/2021', '2021-03', '24694', '47', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '460.29');
INSERT INTO public.europe_data_import VALUES (9772, '18/01/2021', '2021-02', '20279', '34', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '394.34');
INSERT INTO public.europe_data_import VALUES (9773, '11/01/2021', '2021-01', '18250', '29', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '318.78');
INSERT INTO public.europe_data_import VALUES (9774, '04/01/2021', '2020-53', '12896', '25', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '216.54');
INSERT INTO public.europe_data_import VALUES (9775, '28/12/2020', '2020-52', '8261', '20', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '172.84');
INSERT INTO public.europe_data_import VALUES (9776, '21/12/2020', '2020-51', '8626', '20', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '175.49');
INSERT INTO public.europe_data_import VALUES (9777, '14/12/2020', '2020-50', '8520', '25', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '176.0');
INSERT INTO public.europe_data_import VALUES (9778, '07/12/2020', '2020-49', '8676', '22', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '178.49');
INSERT INTO public.europe_data_import VALUES (9779, '30/11/2020', '2020-48', '8763', '18', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '178.17');
INSERT INTO public.europe_data_import VALUES (9780, '23/11/2020', '2020-47', '8645', '22', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '172.43');
INSERT INTO public.europe_data_import VALUES (9781, '16/11/2020', '2020-46', '8202', '16', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '168.24');
INSERT INTO public.europe_data_import VALUES (9782, '09/11/2020', '2020-45', '8236', '18', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '174.2');
INSERT INTO public.europe_data_import VALUES (9783, '02/11/2020', '2020-44', '8784', '19', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '187.35');
INSERT INTO public.europe_data_import VALUES (9784, '26/10/2020', '2020-43', '9521', '14', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '193.38');
INSERT INTO public.europe_data_import VALUES (9785, '19/10/2020', '2020-42', '9373', '18', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '171.96');
INSERT INTO public.europe_data_import VALUES (9786, '12/10/2020', '2020-41', '7428', '19', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '151.07');
INSERT INTO public.europe_data_import VALUES (9787, '05/10/2020', '2020-40', '7332', '14', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '142.11');
INSERT INTO public.europe_data_import VALUES (9788, '28/09/2020', '2020-39', '6553', '8', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '122.61');
INSERT INTO public.europe_data_import VALUES (9789, '21/09/2020', '2020-38', '5427', '5', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '111.89');
INSERT INTO public.europe_data_import VALUES (9790, '14/09/2020', '2020-37', '5505', '11', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '100.29');
INSERT INTO public.europe_data_import VALUES (9791, '07/09/2020', '2020-36', '4294', '6', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '71.41');
INSERT INTO public.europe_data_import VALUES (9792, '31/08/2020', '2020-35', '2683', '7', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '55.04');
INSERT INTO public.europe_data_import VALUES (9793, '24/08/2020', '2020-34', '2695', '11', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '45.87');
INSERT INTO public.europe_data_import VALUES (9794, '17/08/2020', '2020-33', '1787', '7', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '33.91');
INSERT INTO public.europe_data_import VALUES (9795, '10/08/2020', '2020-32', '1526', '6', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '36.97');
INSERT INTO public.europe_data_import VALUES (9796, '03/08/2020', '2020-31', '2086', '7', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '41.73');
INSERT INTO public.europe_data_import VALUES (9797, '27/07/2020', '2020-30', '1991', '5', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '41.54');
INSERT INTO public.europe_data_import VALUES (9798, '20/07/2020', '2020-29', '2068', '6', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '55.08');
INSERT INTO public.europe_data_import VALUES (9799, '13/07/2020', '2020-28', '3314', '10', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '72.23');
INSERT INTO public.europe_data_import VALUES (9800, '06/07/2020', '2020-27', '3743', '10', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '67.7');
INSERT INTO public.europe_data_import VALUES (9801, '29/06/2020', '2020-26', '2872', '11', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '56.32');
INSERT INTO public.europe_data_import VALUES (9802, '22/06/2020', '2020-25', '2631', '13', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '62.61');
INSERT INTO public.europe_data_import VALUES (9803, '15/06/2020', '2020-24', '3486', '13', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '79.19');
INSERT INTO public.europe_data_import VALUES (9804, '08/06/2020', '2020-23', '4251', '12', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '95.42');
INSERT INTO public.europe_data_import VALUES (9805, '01/06/2020', '2020-22', '5072', '19', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '114.62');
INSERT INTO public.europe_data_import VALUES (9806, '25/05/2020', '2020-21', '6127', '25', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '115.52');
INSERT INTO public.europe_data_import VALUES (9807, '18/05/2020', '2020-20', '5160', '22', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '94.11');
INSERT INTO public.europe_data_import VALUES (9808, '11/05/2020', '2020-19', '4035', '72', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '80.33');
INSERT INTO public.europe_data_import VALUES (9809, '04/05/2020', '2020-18', '3814', '50', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '73.9');
INSERT INTO public.europe_data_import VALUES (9810, '27/04/2020', '2020-17', '3406', '35', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '65.17');
INSERT INTO public.europe_data_import VALUES (9811, '20/04/2020', '2020-16', '2961', '19', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '52.81');
INSERT INTO public.europe_data_import VALUES (9812, '13/04/2020', '2020-15', '2199', '12', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '34.92');
INSERT INTO public.europe_data_import VALUES (9813, '06/04/2020', '2020-14', '1213', '7', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '16.68');
INSERT INTO public.europe_data_import VALUES (9814, '30/03/2020', '2020-13', '417', '1', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '4.83');
INSERT INTO public.europe_data_import VALUES (9815, '23/03/2020', '2020-12', '55', '2', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '1.11');
INSERT INTO public.europe_data_import VALUES (9816, '16/03/2020', '2020-11', '53', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.79');
INSERT INTO public.europe_data_import VALUES (9817, '09/03/2020', '2020-10', '24', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.33');
INSERT INTO public.europe_data_import VALUES (9818, '02/03/2020', '2020-09', '8', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.12');
INSERT INTO public.europe_data_import VALUES (9819, '24/02/2020', '2020-08', '4', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (9820, '17/02/2020', '2020-07', '2', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (9821, '10/02/2020', '2020-06', '2', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (9822, '03/02/2020', '2020-05', '4', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (9823, '27/01/2020', '2020-04', '1', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (9824, '20/01/2020', '2020-03', '0', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9825, '13/01/2020', '2020-02', '0', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (9826, '06/01/2020', '2020-01', '0', '0', '9770526', 'United_Arab_Emirates', 'AE', 'ARE', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (9827, '01/02/2021', '2021-04', '169713', '8219', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '632.01');
INSERT INTO public.europe_data_import VALUES (9828, '25/01/2021', '2021-03', '251504', '8678', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '862.92');
INSERT INTO public.europe_data_import VALUES (9829, '18/01/2021', '2021-02', '323610', '7830', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '1112.1');
INSERT INTO public.europe_data_import VALUES (9830, '11/01/2021', '2021-01', '417570', '6407', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '1114.26');
INSERT INTO public.europe_data_import VALUES (9831, '04/01/2021', '2020-53', '325049', '3915', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '922.22');
INSERT INTO public.europe_data_import VALUES (9832, '28/12/2020', '2020-52', '289583', '3708', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '720.7');
INSERT INTO public.europe_data_import VALUES (9833, '21/12/2020', '2020-51', '190744', '3231', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '475.5');
INSERT INTO public.europe_data_import VALUES (9834, '14/12/2020', '2020-50', '126161', '2925', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '348.22');
INSERT INTO public.europe_data_import VALUES (9835, '07/12/2020', '2020-49', '105915', '3000', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '316.89');
INSERT INTO public.europe_data_import VALUES (9836, '30/11/2020', '2020-48', '105282', '3494', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '372.12');
INSERT INTO public.europe_data_import VALUES (9837, '23/11/2020', '2020-47', '142727', '2817', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '480.19');
INSERT INTO public.europe_data_import VALUES (9838, '16/11/2020', '2020-46', '177305', '2890', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '501.75');
INSERT INTO public.europe_data_import VALUES (9839, '09/11/2020', '2020-45', '157099', '2327', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '477.46');
INSERT INTO public.europe_data_import VALUES (9840, '02/11/2020', '2020-44', '161114', '1821', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '468.9');
INSERT INTO public.europe_data_import VALUES (9841, '26/10/2020', '2020-43', '151391', '1250', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '405.24');
INSERT INTO public.europe_data_import VALUES (9842, '19/10/2020', '2020-42', '118693', '821', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '329.24');
INSERT INTO public.europe_data_import VALUES (9843, '12/10/2020', '2020-41', '100738', '475', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '253.19');
INSERT INTO public.europe_data_import VALUES (9844, '05/10/2020', '2020-40', '68009', '362', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '163.13');
INSERT INTO public.europe_data_import VALUES (9845, '28/09/2020', '2020-39', '40712', '211', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '99.73');
INSERT INTO public.europe_data_import VALUES (9846, '21/09/2020', '2020-38', '25753', '149', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '70.68');
INSERT INTO public.europe_data_import VALUES (9847, '14/09/2020', '2020-37', '21352', '77', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '51.07');
INSERT INTO public.europe_data_import VALUES (9848, '07/09/2020', '2020-36', '12685', '52', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '32.27');
INSERT INTO public.europe_data_import VALUES (9849, '31/08/2020', '2020-35', '8825', '70', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '23.98');
INSERT INTO public.europe_data_import VALUES (9850, '24/08/2020', '2020-34', '7158', '63', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '22.23');
INSERT INTO public.europe_data_import VALUES (9851, '17/08/2020', '2020-33', '7659', '88', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '20.69');
INSERT INTO public.europe_data_import VALUES (9852, '10/08/2020', '2020-32', '6130', '71', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '15.87');
INSERT INTO public.europe_data_import VALUES (9853, '03/08/2020', '2020-31', '4444', '96', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '13.49');
INSERT INTO public.europe_data_import VALUES (9854, '27/07/2020', '2020-30', '4549', '116', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '13.29');
INSERT INTO public.europe_data_import VALUES (9855, '20/07/2020', '2020-29', '4310', '150', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '12.88');
INSERT INTO public.europe_data_import VALUES (9856, '13/07/2020', '2020-28', '4271', '213', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '12.45');
INSERT INTO public.europe_data_import VALUES (9857, '06/07/2020', '2020-27', '4026', '312', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '13.9');
INSERT INTO public.europe_data_import VALUES (9858, '29/06/2020', '2020-26', '5240', '442', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '17.89');
INSERT INTO public.europe_data_import VALUES (9859, '22/06/2020', '2020-25', '6680', '512', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '20.73');
INSERT INTO public.europe_data_import VALUES (9860, '15/06/2020', '2020-24', '7136', '747', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '23.5');
INSERT INTO public.europe_data_import VALUES (9861, '08/06/2020', '2020-23', '8524', '1174', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '29.16');
INSERT INTO public.europe_data_import VALUES (9862, '01/06/2020', '2020-22', '10907', '1488', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '40.91');
INSERT INTO public.europe_data_import VALUES (9863, '25/05/2020', '2020-21', '16360', '2137', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '54.34');
INSERT INTO public.europe_data_import VALUES (9864, '18/05/2020', '2020-20', '19857', '2428', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '64.1');
INSERT INTO public.europe_data_import VALUES (9865, '11/05/2020', '2020-19', '22867', '3174', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '81.25');
INSERT INTO public.europe_data_import VALUES (9866, '04/05/2020', '2020-18', '31282', '4227', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '96.2');
INSERT INTO public.europe_data_import VALUES (9867, '27/04/2020', '2020-17', '32830', '5512', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '97.31');
INSERT INTO public.europe_data_import VALUES (9868, '20/04/2020', '2020-16', '32027', '6166', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '96.38');
INSERT INTO public.europe_data_import VALUES (9869, '13/04/2020', '2020-15', '32205', '6440', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '93.87');
INSERT INTO public.europe_data_import VALUES (9870, '06/04/2020', '2020-14', '30357', '4197', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '72.39');
INSERT INTO public.europe_data_import VALUES (9871, '30/03/2020', '2020-13', '17889', '1388', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '36.34');
INSERT INTO public.europe_data_import VALUES (9872, '23/03/2020', '2020-12', '6329', '245', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '12.79');
INSERT INTO public.europe_data_import VALUES (9873, '16/03/2020', '2020-11', '2193', '41', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '3.84');
INSERT INTO public.europe_data_import VALUES (9874, '09/03/2020', '2020-10', '365', '2', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0.6');
INSERT INTO public.europe_data_import VALUES (9875, '02/03/2020', '2020-09', '36', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0.06');
INSERT INTO public.europe_data_import VALUES (9876, '24/02/2020', '2020-08', '1', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (9877, '17/02/2020', '2020-07', '2', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (9878, '10/02/2020', '2020-06', '6', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0.01');
INSERT INTO public.europe_data_import VALUES (9879, '03/02/2020', '2020-05', '2', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0.0');
INSERT INTO public.europe_data_import VALUES (9880, '27/01/2020', '2020-04', '0', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9881, '20/01/2020', '2020-03', '0', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9882, '13/01/2020', '2020-02', '0', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '0');
INSERT INTO public.europe_data_import VALUES (9883, '06/01/2020', '2020-01', '0', '0', '66647112', 'United_Kingdom', 'UK', 'GBR', 'Europe', '');
INSERT INTO public.europe_data_import VALUES (9884, '01/02/2021', '2021-04', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9885, '25/01/2021', '2021-03', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9886, '18/01/2021', '2021-02', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9887, '11/01/2021', '2021-01', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9888, '04/01/2021', '2020-53', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9889, '28/12/2020', '2020-52', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9890, '21/12/2020', '2020-51', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9891, '14/12/2020', '2020-50', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9892, '07/12/2020', '2020-49', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9893, '30/11/2020', '2020-48', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9894, '23/11/2020', '2020-47', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9895, '16/11/2020', '2020-46', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9896, '09/11/2020', '2020-45', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9897, '02/11/2020', '2020-44', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9898, '26/10/2020', '2020-43', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9899, '19/10/2020', '2020-42', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9900, '12/10/2020', '2020-41', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9901, '05/10/2020', '2020-40', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9902, '28/09/2020', '2020-39', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9903, '21/09/2020', '2020-38', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9904, '14/09/2020', '2020-37', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9905, '07/09/2020', '2020-36', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9906, '31/08/2020', '2020-35', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9907, '24/08/2020', '2020-34', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9908, '17/08/2020', '2020-33', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9909, '10/08/2020', '2020-32', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9910, '03/08/2020', '2020-31', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9911, '27/07/2020', '2020-30', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9912, '20/07/2020', '2020-29', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9913, '13/07/2020', '2020-28', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9914, '06/07/2020', '2020-27', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9915, '29/06/2020', '2020-26', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9916, '22/06/2020', '2020-25', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9917, '15/06/2020', '2020-24', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9918, '08/06/2020', '2020-23', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9919, '01/06/2020', '2020-22', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9920, '25/05/2020', '2020-21', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (9921, '18/05/2020', '2020-20', '0', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (9922, '11/05/2020', '2020-19', '29', '5', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.36');
INSERT INTO public.europe_data_import VALUES (9923, '04/05/2020', '2020-18', '180', '6', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.53');
INSERT INTO public.europe_data_import VALUES (9924, '27/04/2020', '2020-17', '130', '5', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.46');
INSERT INTO public.europe_data_import VALUES (9925, '20/04/2020', '2020-16', '138', '2', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.26');
INSERT INTO public.europe_data_import VALUES (9926, '13/04/2020', '2020-15', '10', '2', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (9927, '06/04/2020', '2020-14', '8', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (9928, '30/03/2020', '2020-13', '2', '1', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '0.02');
INSERT INTO public.europe_data_import VALUES (9929, '23/03/2020', '2020-12', '12', '0', '58005461', 'United_Republic_of_Tanzania', 'TZ', 'TZA', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (9930, '01/02/2021', '2021-04', '1024054', '22226', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '724.12');
INSERT INTO public.europe_data_import VALUES (9931, '25/01/2021', '2021-03', '1358783', '23518', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '873.4');
INSERT INTO public.europe_data_import VALUES (9932, '18/01/2021', '2021-02', '1515282', '23169', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '1002.26');
INSERT INTO public.europe_data_import VALUES (9933, '11/01/2021', '2021-01', '1782792', '22852', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '994.14');
INSERT INTO public.europe_data_import VALUES (9934, '04/01/2021', '2020-53', '1488563', '18264', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '849.49');
INSERT INTO public.europe_data_import VALUES (9935, '28/12/2020', '2020-52', '1306812', '15656', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '879.73');
INSERT INTO public.europe_data_import VALUES (9936, '21/12/2020', '2020-51', '1588085', '18493', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '938.37');
INSERT INTO public.europe_data_import VALUES (9937, '14/12/2020', '2020-50', '1499756', '16867', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '873.21');
INSERT INTO public.europe_data_import VALUES (9938, '07/12/2020', '2020-49', '1373677', '15437', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '762.79');
INSERT INTO public.europe_data_import VALUES (9939, '30/11/2020', '2020-48', '1136412', '10091', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '713.01');
INSERT INTO public.europe_data_import VALUES (9940, '23/11/2020', '2020-47', '1209848', '10568', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '691.43');
INSERT INTO public.europe_data_import VALUES (9941, '16/11/2020', '2020-46', '1065410', '8642', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '556.03');
INSERT INTO public.europe_data_import VALUES (9942, '09/11/2020', '2020-45', '764289', '6576', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '405.84');
INSERT INTO public.europe_data_import VALUES (9943, '02/11/2020', '2020-44', '571197', '5766', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '319.93');
INSERT INTO public.europe_data_import VALUES (9944, '26/10/2020', '2020-43', '481570', '5556', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '265.49');
INSERT INTO public.europe_data_import VALUES (9945, '19/10/2020', '2020-42', '392051', '4903', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '223.89');
INSERT INTO public.europe_data_import VALUES (9946, '12/10/2020', '2020-41', '344699', '4977', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '196.77');
INSERT INTO public.europe_data_import VALUES (9947, '05/10/2020', '2020-40', '302799', '5038', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '186.29');
INSERT INTO public.europe_data_import VALUES (9948, '28/09/2020', '2020-39', '310232', '5247', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '180.84');
INSERT INTO public.europe_data_import VALUES (9949, '21/09/2020', '2020-38', '284835', '5430', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '160.57');
INSERT INTO public.europe_data_import VALUES (9950, '14/09/2020', '2020-37', '243558', '5138', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '158.88');
INSERT INTO public.europe_data_import VALUES (9951, '07/09/2020', '2020-36', '279258', '5872', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '174.38');
INSERT INTO public.europe_data_import VALUES (9952, '31/08/2020', '2020-35', '294552', '6263', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '180.48');
INSERT INTO public.europe_data_import VALUES (9953, '24/08/2020', '2020-34', '299342', '6754', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '199.88');
INSERT INTO public.europe_data_import VALUES (9954, '17/08/2020', '2020-33', '358405', '7114', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '223.46');
INSERT INTO public.europe_data_import VALUES (9955, '10/08/2020', '2020-32', '376909', '8078', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '246.41');
INSERT INTO public.europe_data_import VALUES (9956, '03/08/2020', '2020-31', '433935', '7925', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '271.89');
INSERT INTO public.europe_data_import VALUES (9957, '27/07/2020', '2020-30', '460760', '6401', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '282.34');
INSERT INTO public.europe_data_import VALUES (9958, '20/07/2020', '2020-29', '468318', '5329', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '268.83');
INSERT INTO public.europe_data_import VALUES (9959, '13/07/2020', '2020-28', '416307', '5258', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '229.73');
INSERT INTO public.europe_data_import VALUES (9960, '06/07/2020', '2020-27', '339639', '4143', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '184.68');
INSERT INTO public.europe_data_import VALUES (9961, '29/06/2020', '2020-26', '268084', '5829', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '138.25');
INSERT INTO public.europe_data_import VALUES (9962, '22/06/2020', '2020-25', '186843', '4243', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '102.88');
INSERT INTO public.europe_data_import VALUES (9963, '15/06/2020', '2020-24', '151706', '5218', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '92.35');
INSERT INTO public.europe_data_import VALUES (9964, '08/06/2020', '2020-23', '152172', '6131', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '90.9');
INSERT INTO public.europe_data_import VALUES (9965, '01/06/2020', '2020-22', '146953', '6663', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '92.21');
INSERT INTO public.europe_data_import VALUES (9966, '25/05/2020', '2020-21', '156481', '8158', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '95.25');
INSERT INTO public.europe_data_import VALUES (9967, '18/05/2020', '2020-20', '156958', '10034', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '99.89');
INSERT INTO public.europe_data_import VALUES (9968, '11/05/2020', '2020-19', '171758', '11846', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '110.58');
INSERT INTO public.europe_data_import VALUES (9969, '04/05/2020', '2020-18', '192131', '12806', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '121.06');
INSERT INTO public.europe_data_import VALUES (9970, '27/04/2020', '2020-17', '206223', '14194', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '124.09');
INSERT INTO public.europe_data_import VALUES (9971, '20/04/2020', '2020-16', '202116', '18574', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '128.26');
INSERT INTO public.europe_data_import VALUES (9972, '13/04/2020', '2020-15', '219936', '12461', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '125.98');
INSERT INTO public.europe_data_import VALUES (9973, '06/04/2020', '2020-14', '194610', '7138', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '91.91');
INSERT INTO public.europe_data_import VALUES (9974, '30/03/2020', '2020-13', '107819', '2038', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '42.32');
INSERT INTO public.europe_data_import VALUES (9975, '23/03/2020', '2020-12', '31432', '402', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '10.53');
INSERT INTO public.europe_data_import VALUES (9976, '16/03/2020', '2020-11', '3220', '48', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '1.12');
INSERT INTO public.europe_data_import VALUES (9977, '09/03/2020', '2020-10', '465', '19', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.16');
INSERT INTO public.europe_data_import VALUES (9978, '02/03/2020', '2020-09', '54', '2', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.02');
INSERT INTO public.europe_data_import VALUES (9979, '24/02/2020', '2020-08', '20', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.01');
INSERT INTO public.europe_data_import VALUES (9980, '17/02/2020', '2020-07', '3', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (9981, '10/02/2020', '2020-06', '1', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (9982, '03/02/2020', '2020-05', '6', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (9983, '27/01/2020', '2020-04', '5', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0.0');
INSERT INTO public.europe_data_import VALUES (9984, '20/01/2020', '2020-03', '0', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9985, '13/01/2020', '2020-02', '0', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '0');
INSERT INTO public.europe_data_import VALUES (9986, '06/01/2020', '2020-01', '0', '0', '329064917', 'United_States_of_America', 'US', 'USA', 'America', '');
INSERT INTO public.europe_data_import VALUES (9987, '01/02/2021', '2021-04', '71', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '153.95');
INSERT INTO public.europe_data_import VALUES (9988, '25/01/2021', '2021-03', '90', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '175.94');
INSERT INTO public.europe_data_import VALUES (9989, '18/01/2021', '2021-02', '94', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '196.02');
INSERT INTO public.europe_data_import VALUES (9990, '11/01/2021', '2021-01', '111', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '154.91');
INSERT INTO public.europe_data_import VALUES (9991, '04/01/2021', '2020-53', '51', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '128.13');
INSERT INTO public.europe_data_import VALUES (9992, '28/12/2020', '2020-52', '83', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '168.29');
INSERT INTO public.europe_data_import VALUES (9993, '21/12/2020', '2020-51', '93', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '260.09');
INSERT INTO public.europe_data_import VALUES (9994, '14/12/2020', '2020-50', '179', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '271.57');
INSERT INTO public.europe_data_import VALUES (9995, '07/12/2020', '2020-49', '105', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '138.65');
INSERT INTO public.europe_data_import VALUES (9996, '30/11/2020', '2020-48', '40', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '105.18');
INSERT INTO public.europe_data_import VALUES (9997, '23/11/2020', '2020-47', '70', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '94.67');
INSERT INTO public.europe_data_import VALUES (9998, '16/11/2020', '2020-46', '29', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '55.46');
INSERT INTO public.europe_data_import VALUES (9999, '09/11/2020', '2020-45', '29', '2', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '54.5');
INSERT INTO public.europe_data_import VALUES (10000, '02/11/2020', '2020-44', '28', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '39.2');
INSERT INTO public.europe_data_import VALUES (10001, '26/10/2020', '2020-43', '13', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '21.99');
INSERT INTO public.europe_data_import VALUES (10002, '19/10/2020', '2020-42', '10', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '13.39');
INSERT INTO public.europe_data_import VALUES (10003, '12/10/2020', '2020-41', '4', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '7.65');
INSERT INTO public.europe_data_import VALUES (10004, '05/10/2020', '2020-40', '4', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '49.72');
INSERT INTO public.europe_data_import VALUES (10005, '28/09/2020', '2020-39', '48', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '92.75');
INSERT INTO public.europe_data_import VALUES (10006, '21/09/2020', '2020-38', '49', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '84.15');
INSERT INTO public.europe_data_import VALUES (10007, '14/09/2020', '2020-37', '39', '2', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '82.23');
INSERT INTO public.europe_data_import VALUES (10008, '07/09/2020', '2020-36', '47', '3', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '188.37');
INSERT INTO public.europe_data_import VALUES (10009, '31/08/2020', '2020-35', '150', '3', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '375.79');
INSERT INTO public.europe_data_import VALUES (10010, '24/08/2020', '2020-34', '243', '2', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '417.87');
INSERT INTO public.europe_data_import VALUES (10011, '17/08/2020', '2020-33', '194', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '305.99');
INSERT INTO public.europe_data_import VALUES (10012, '10/08/2020', '2020-32', '126', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '177.86');
INSERT INTO public.europe_data_import VALUES (10013, '03/08/2020', '2020-31', '60', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '118.57');
INSERT INTO public.europe_data_import VALUES (10014, '27/07/2020', '2020-30', '64', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '172.12');
INSERT INTO public.europe_data_import VALUES (10015, '20/07/2020', '2020-29', '116', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '176.9');
INSERT INTO public.europe_data_import VALUES (10016, '13/07/2020', '2020-28', '69', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '95.62');
INSERT INTO public.europe_data_import VALUES (10017, '06/07/2020', '2020-27', '31', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '34.42');
INSERT INTO public.europe_data_import VALUES (10018, '29/06/2020', '2020-26', '5', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '7.65');
INSERT INTO public.europe_data_import VALUES (10019, '22/06/2020', '2020-25', '3', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '4.78');
INSERT INTO public.europe_data_import VALUES (10020, '15/06/2020', '2020-24', '2', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '3.82');
INSERT INTO public.europe_data_import VALUES (10021, '08/06/2020', '2020-23', '2', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '1.91');
INSERT INTO public.europe_data_import VALUES (10022, '01/06/2020', '2020-22', '0', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (10023, '25/05/2020', '2020-21', '0', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '0');
INSERT INTO public.europe_data_import VALUES (10024, '18/05/2020', '2020-20', '0', '2', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '2.87');
INSERT INTO public.europe_data_import VALUES (10025, '11/05/2020', '2020-19', '3', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '13.39');
INSERT INTO public.europe_data_import VALUES (10026, '04/05/2020', '2020-18', '11', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '12.43');
INSERT INTO public.europe_data_import VALUES (10027, '27/04/2020', '2020-17', '2', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '3.82');
INSERT INTO public.europe_data_import VALUES (10028, '20/04/2020', '2020-16', '2', '2', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '10.52');
INSERT INTO public.europe_data_import VALUES (10029, '13/04/2020', '2020-15', '9', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '20.08');
INSERT INTO public.europe_data_import VALUES (10030, '06/04/2020', '2020-14', '12', '1', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '40.16');
INSERT INTO public.europe_data_import VALUES (10031, '30/03/2020', '2020-13', '30', '0', '104579', 'United_States_Virgin_Islands', 'VI', 'VIR', 'America', '');
INSERT INTO public.europe_data_import VALUES (10032, '01/02/2021', '2021-04', '4087', '54', '3461731', 'Uruguay', 'UY', 'URY', 'America', '267.64');
INSERT INTO public.europe_data_import VALUES (10033, '25/01/2021', '2021-03', '5178', '71', '3461731', 'Uruguay', 'UY', 'URY', 'America', '321.8');
INSERT INTO public.europe_data_import VALUES (10034, '18/01/2021', '2021-02', '5962', '57', '3461731', 'Uruguay', 'UY', 'URY', 'America', '347.8');
INSERT INTO public.europe_data_import VALUES (10035, '11/01/2021', '2021-01', '6078', '58', '3461731', 'Uruguay', 'UY', 'URY', 'America', '277.17');
INSERT INTO public.europe_data_import VALUES (10036, '04/01/2021', '2020-53', '3517', '44', '3461731', 'Uruguay', 'UY', 'URY', 'America', '212.21');
INSERT INTO public.europe_data_import VALUES (10037, '28/12/2020', '2020-52', '3829', '41', '3461731', 'Uruguay', 'UY', 'URY', 'America', '219.49');
INSERT INTO public.europe_data_import VALUES (10038, '21/12/2020', '2020-51', '3769', '27', '3461731', 'Uruguay', 'UY', 'URY', 'America', '178.35');
INSERT INTO public.europe_data_import VALUES (10039, '14/12/2020', '2020-50', '2405', '10', '3461731', 'Uruguay', 'UY', 'URY', 'America', '115.32');
INSERT INTO public.europe_data_import VALUES (10040, '07/12/2020', '2020-49', '1587', '6', '3461731', 'Uruguay', 'UY', 'URY', 'America', '75.22');
INSERT INTO public.europe_data_import VALUES (10041, '30/11/2020', '2020-48', '1017', '5', '3461731', 'Uruguay', 'UY', 'URY', 'America', '48.7');
INSERT INTO public.europe_data_import VALUES (10042, '23/11/2020', '2020-47', '669', '6', '3461731', 'Uruguay', 'UY', 'URY', 'America', '34.23');
INSERT INTO public.europe_data_import VALUES (10043, '16/11/2020', '2020-46', '516', '3', '3461731', 'Uruguay', 'UY', 'URY', 'America', '25.45');
INSERT INTO public.europe_data_import VALUES (10044, '09/11/2020', '2020-45', '365', '3', '3461731', 'Uruguay', 'UY', 'URY', 'America', '19.15');
INSERT INTO public.europe_data_import VALUES (10045, '02/11/2020', '2020-44', '298', '6', '3461731', 'Uruguay', 'UY', 'URY', 'America', '17.85');
INSERT INTO public.europe_data_import VALUES (10046, '26/10/2020', '2020-43', '320', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '16.09');
INSERT INTO public.europe_data_import VALUES (10047, '19/10/2020', '2020-42', '237', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '11.15');
INSERT INTO public.europe_data_import VALUES (10048, '12/10/2020', '2020-41', '149', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '8.26');
INSERT INTO public.europe_data_import VALUES (10049, '05/10/2020', '2020-40', '137', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '6.59');
INSERT INTO public.europe_data_import VALUES (10050, '28/09/2020', '2020-39', '91', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '5.78');
INSERT INTO public.europe_data_import VALUES (10051, '21/09/2020', '2020-38', '109', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '6.88');
INSERT INTO public.europe_data_import VALUES (10052, '14/09/2020', '2020-37', '129', '0', '3461731', 'Uruguay', 'UY', 'URY', 'America', '6.44');
INSERT INTO public.europe_data_import VALUES (10053, '07/09/2020', '2020-36', '94', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.39');
INSERT INTO public.europe_data_import VALUES (10054, '31/08/2020', '2020-35', '58', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.19');
INSERT INTO public.europe_data_import VALUES (10055, '24/08/2020', '2020-34', '87', '4', '3461731', 'Uruguay', 'UY', 'URY', 'America', '5.03');
INSERT INTO public.europe_data_import VALUES (10056, '17/08/2020', '2020-33', '87', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.45');
INSERT INTO public.europe_data_import VALUES (10057, '10/08/2020', '2020-32', '67', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.65');
INSERT INTO public.europe_data_import VALUES (10058, '03/08/2020', '2020-31', '94', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '6.7');
INSERT INTO public.europe_data_import VALUES (10059, '27/07/2020', '2020-30', '138', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '5.92');
INSERT INTO public.europe_data_import VALUES (10060, '20/07/2020', '2020-29', '67', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.83');
INSERT INTO public.europe_data_import VALUES (10061, '13/07/2020', '2020-28', '31', '3', '3461731', 'Uruguay', 'UY', 'URY', 'America', '1.68');
INSERT INTO public.europe_data_import VALUES (10062, '06/07/2020', '2020-27', '27', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.31');
INSERT INTO public.europe_data_import VALUES (10063, '29/06/2020', '2020-26', '53', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.34');
INSERT INTO public.europe_data_import VALUES (10064, '22/06/2020', '2020-25', '28', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '0.9');
INSERT INTO public.europe_data_import VALUES (10065, '15/06/2020', '2020-24', '3', '0', '3461731', 'Uruguay', 'UY', 'URY', 'America', '0.72');
INSERT INTO public.europe_data_import VALUES (10066, '08/06/2020', '2020-23', '22', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.2');
INSERT INTO public.europe_data_import VALUES (10067, '01/06/2020', '2020-22', '54', '0', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.57');
INSERT INTO public.europe_data_import VALUES (10068, '25/05/2020', '2020-21', '35', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '1.79');
INSERT INTO public.europe_data_import VALUES (10069, '18/05/2020', '2020-20', '27', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.28');
INSERT INTO public.europe_data_import VALUES (10070, '11/05/2020', '2020-19', '52', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '2.92');
INSERT INTO public.europe_data_import VALUES (10071, '04/05/2020', '2020-18', '49', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '3.67');
INSERT INTO public.europe_data_import VALUES (10072, '27/04/2020', '2020-17', '78', '5', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.07');
INSERT INTO public.europe_data_import VALUES (10073, '20/04/2020', '2020-16', '63', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '3.5');
INSERT INTO public.europe_data_import VALUES (10074, '13/04/2020', '2020-15', '58', '2', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.91');
INSERT INTO public.europe_data_import VALUES (10075, '06/04/2020', '2020-14', '112', '5', '3461731', 'Uruguay', 'UY', 'URY', 'America', '7.19');
INSERT INTO public.europe_data_import VALUES (10076, '30/03/2020', '2020-13', '137', '1', '3461731', 'Uruguay', 'UY', 'URY', 'America', '8.29');
INSERT INTO public.europe_data_import VALUES (10077, '23/03/2020', '2020-12', '150', '0', '3461731', 'Uruguay', 'UY', 'URY', 'America', '4.56');
INSERT INTO public.europe_data_import VALUES (10078, '16/03/2020', '2020-11', '8', '0', '3461731', 'Uruguay', 'UY', 'URY', 'America', '');
INSERT INTO public.europe_data_import VALUES (10079, '01/02/2021', '2021-04', '326', '0', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.18');
INSERT INTO public.europe_data_import VALUES (10080, '25/01/2021', '2021-03', '393', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.48');
INSERT INTO public.europe_data_import VALUES (10081, '18/01/2021', '2021-02', '425', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.36');
INSERT INTO public.europe_data_import VALUES (10082, '11/01/2021', '2021-01', '353', '3', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.36');
INSERT INTO public.europe_data_import VALUES (10083, '04/01/2021', '2020-53', '426', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '3.67');
INSERT INTO public.europe_data_import VALUES (10084, '28/12/2020', '2020-52', '784', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '5.27');
INSERT INTO public.europe_data_import VALUES (10085, '21/12/2020', '2020-51', '954', '0', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '6.05');
INSERT INTO public.europe_data_import VALUES (10086, '14/12/2020', '2020-50', '1041', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '6.74');
INSERT INTO public.europe_data_import VALUES (10087, '07/12/2020', '2020-49', '1183', '3', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '7.39');
INSERT INTO public.europe_data_import VALUES (10088, '30/11/2020', '2020-48', '1253', '5', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '7.97');
INSERT INTO public.europe_data_import VALUES (10089, '23/11/2020', '2020-47', '1374', '5', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '8.58');
INSERT INTO public.europe_data_import VALUES (10090, '16/11/2020', '2020-46', '1455', '13', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '9.36');
INSERT INTO public.europe_data_import VALUES (10091, '09/11/2020', '2020-45', '1632', '15', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '10.03');
INSERT INTO public.europe_data_import VALUES (10092, '02/11/2020', '2020-44', '1676', '20', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '11.3');
INSERT INTO public.europe_data_import VALUES (10093, '26/10/2020', '2020-43', '2050', '21', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '13.29');
INSERT INTO public.europe_data_import VALUES (10094, '19/10/2020', '2020-42', '2332', '24', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '13.86');
INSERT INTO public.europe_data_import VALUES (10095, '12/10/2020', '2020-41', '2239', '22', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '16.69');
INSERT INTO public.europe_data_import VALUES (10096, '05/10/2020', '2020-40', '3266', '23', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '21.44');
INSERT INTO public.europe_data_import VALUES (10097, '28/09/2020', '2020-39', '3804', '25', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '24.17');
INSERT INTO public.europe_data_import VALUES (10098, '21/09/2020', '2020-38', '4169', '41', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '24.3');
INSERT INTO public.europe_data_import VALUES (10099, '14/09/2020', '2020-37', '3845', '44', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '18.1');
INSERT INTO public.europe_data_import VALUES (10100, '07/09/2020', '2020-36', '2124', '33', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '14.64');
INSERT INTO public.europe_data_import VALUES (10101, '31/08/2020', '2020-35', '2705', '44', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '20.34');
INSERT INTO public.europe_data_import VALUES (10102, '24/08/2020', '2020-34', '4002', '45', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '24.64');
INSERT INTO public.europe_data_import VALUES (10103, '17/08/2020', '2020-33', '4124', '32', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '27.64');
INSERT INTO public.europe_data_import VALUES (10104, '10/08/2020', '2020-32', '4992', '41', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '30.32');
INSERT INTO public.europe_data_import VALUES (10105, '03/08/2020', '2020-31', '5008', '38', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '26.87');
INSERT INTO public.europe_data_import VALUES (10106, '27/07/2020', '2020-30', '3854', '29', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '23.12');
INSERT INTO public.europe_data_import VALUES (10107, '20/07/2020', '2020-29', '3773', '27', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '20.69');
INSERT INTO public.europe_data_import VALUES (10108, '13/07/2020', '2020-28', '3050', '26', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '15.65');
INSERT INTO public.europe_data_import VALUES (10109, '06/07/2020', '2020-27', '2112', '13', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '11.48');
INSERT INTO public.europe_data_import VALUES (10110, '29/06/2020', '2020-26', '1673', '3', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '8.88');
INSERT INTO public.europe_data_import VALUES (10111, '22/06/2020', '2020-25', '1255', '0', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '6.08');
INSERT INTO public.europe_data_import VALUES (10112, '15/06/2020', '2020-24', '751', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '4.37');
INSERT INTO public.europe_data_import VALUES (10113, '08/06/2020', '2020-23', '690', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '3.6');
INSERT INTO public.europe_data_import VALUES (10114, '01/06/2020', '2020-22', '498', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.76');
INSERT INTO public.europe_data_import VALUES (10115, '25/05/2020', '2020-21', '411', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.26');
INSERT INTO public.europe_data_import VALUES (10116, '18/05/2020', '2020-20', '335', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '1.83');
INSERT INTO public.europe_data_import VALUES (10117, '11/05/2020', '2020-19', '269', '0', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '1.61');
INSERT INTO public.europe_data_import VALUES (10118, '04/05/2020', '2020-18', '262', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '1.77');
INSERT INTO public.europe_data_import VALUES (10119, '27/04/2020', '2020-17', '322', '3', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '3.1');
INSERT INTO public.europe_data_import VALUES (10120, '20/04/2020', '2020-16', '700', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '3.71');
INSERT INTO public.europe_data_import VALUES (10121, '13/04/2020', '2020-15', '523', '2', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '2.18');
INSERT INTO public.europe_data_import VALUES (10122, '06/04/2020', '2020-14', '197', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '0.9');
INSERT INTO public.europe_data_import VALUES (10123, '30/03/2020', '2020-13', '99', '1', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '0.42');
INSERT INTO public.europe_data_import VALUES (10124, '23/03/2020', '2020-12', '40', '0', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '0.14');
INSERT INTO public.europe_data_import VALUES (10125, '16/03/2020', '2020-11', '6', '0', '32981715', 'Uzbekistan', 'UZ', 'UZB', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (10126, '01/02/2021', '2021-04', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10127, '25/01/2021', '2021-03', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10128, '18/01/2021', '2021-02', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10129, '11/01/2021', '2021-01', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10130, '04/01/2021', '2020-53', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10131, '28/12/2020', '2020-52', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10132, '21/12/2020', '2020-51', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10133, '14/12/2020', '2020-50', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10134, '07/12/2020', '2020-49', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10135, '30/11/2020', '2020-48', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0');
INSERT INTO public.europe_data_import VALUES (10136, '23/11/2020', '2020-47', '0', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '0.33');
INSERT INTO public.europe_data_import VALUES (10137, '16/11/2020', '2020-46', '1', '0', '299882', 'Vanuatu', 'VU', 'VUT', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10138, '01/02/2021', '2021-04', '3218', '41', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '22.73');
INSERT INTO public.europe_data_import VALUES (10139, '25/01/2021', '2021-03', '3265', '36', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '23.59');
INSERT INTO public.europe_data_import VALUES (10140, '18/01/2021', '2021-02', '3461', '39', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '21.17');
INSERT INTO public.europe_data_import VALUES (10141, '11/01/2021', '2021-01', '2576', '35', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '16.37');
INSERT INTO public.europe_data_import VALUES (10142, '04/01/2021', '2020-53', '2091', '24', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '15.19');
INSERT INTO public.europe_data_import VALUES (10143, '28/12/2020', '2020-52', '2241', '26', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '18.02');
INSERT INTO public.europe_data_import VALUES (10144, '21/12/2020', '2020-51', '2898', '39', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '19.75');
INSERT INTO public.europe_data_import VALUES (10145, '14/12/2020', '2020-50', '2735', '30', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '18.01');
INSERT INTO public.europe_data_import VALUES (10146, '07/12/2020', '2020-49', '2402', '25', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '16.16');
INSERT INTO public.europe_data_import VALUES (10147, '30/11/2020', '2020-48', '2205', '23', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '16.44');
INSERT INTO public.europe_data_import VALUES (10148, '23/11/2020', '2020-47', '2483', '20', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '17.37');
INSERT INTO public.europe_data_import VALUES (10149, '16/11/2020', '2020-46', '2469', '25', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '17.63');
INSERT INTO public.europe_data_import VALUES (10150, '09/11/2020', '2020-45', '2558', '25', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '18.65');
INSERT INTO public.europe_data_import VALUES (10151, '02/11/2020', '2020-44', '2760', '28', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '19.95');
INSERT INTO public.europe_data_import VALUES (10152, '26/10/2020', '2020-43', '2929', '37', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '22.54');
INSERT INTO public.europe_data_import VALUES (10153, '19/10/2020', '2020-42', '3499', '39', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '28.76');
INSERT INTO public.europe_data_import VALUES (10154, '12/10/2020', '2020-41', '4703', '44', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '36.63');
INSERT INTO public.europe_data_import VALUES (10155, '05/10/2020', '2020-40', '5743', '47', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '41.3');
INSERT INTO public.europe_data_import VALUES (10156, '28/09/2020', '2020-39', '6035', '59', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '42.61');
INSERT INTO public.europe_data_import VALUES (10157, '21/09/2020', '2020-38', '6116', '62', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '46.88');
INSERT INTO public.europe_data_import VALUES (10158, '14/09/2020', '2020-37', '7251', '57', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '51.45');
INSERT INTO public.europe_data_import VALUES (10159, '07/09/2020', '2020-36', '7421', '47', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '48.13');
INSERT INTO public.europe_data_import VALUES (10160, '31/08/2020', '2020-35', '6304', '52', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '42.48');
INSERT INTO public.europe_data_import VALUES (10161, '24/08/2020', '2020-34', '5809', '48', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '48.25');
INSERT INTO public.europe_data_import VALUES (10162, '17/08/2020', '2020-33', '7950', '58', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '47.51');
INSERT INTO public.europe_data_import VALUES (10163, '10/08/2020', '2020-32', '5599', '49', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '36.27');
INSERT INTO public.europe_data_import VALUES (10164, '03/08/2020', '2020-31', '4743', '32', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '29.16');
INSERT INTO public.europe_data_import VALUES (10165, '27/07/2020', '2020-30', '3572', '30', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '21.03');
INSERT INTO public.europe_data_import VALUES (10166, '20/07/2020', '2020-29', '2426', '23', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '16.56');
INSERT INTO public.europe_data_import VALUES (10167, '13/07/2020', '2020-28', '2296', '25', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '14.62');
INSERT INTO public.europe_data_import VALUES (10168, '06/07/2020', '2020-27', '1872', '20', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '11.4');
INSERT INTO public.europe_data_import VALUES (10169, '29/06/2020', '2020-26', '1379', '11', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '8.13');
INSERT INTO public.europe_data_import VALUES (10170, '22/06/2020', '2020-25', '940', '8', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '5.4');
INSERT INTO public.europe_data_import VALUES (10171, '15/06/2020', '2020-24', '601', '3', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '5.15');
INSERT INTO public.europe_data_import VALUES (10172, '08/06/2020', '2020-23', '867', '8', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '4.4');
INSERT INTO public.europe_data_import VALUES (10173, '01/06/2020', '2020-22', '389', '4', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '3.4');
INSERT INTO public.europe_data_import VALUES (10174, '25/05/2020', '2020-21', '580', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '2.48');
INSERT INTO public.europe_data_import VALUES (10175, '18/05/2020', '2020-20', '127', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.65');
INSERT INTO public.europe_data_import VALUES (10176, '11/05/2020', '2020-19', '57', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.31');
INSERT INTO public.europe_data_import VALUES (10177, '04/05/2020', '2020-18', '32', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.35');
INSERT INTO public.europe_data_import VALUES (10178, '27/04/2020', '2020-17', '69', '1', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.5');
INSERT INTO public.europe_data_import VALUES (10179, '20/04/2020', '2020-16', '75', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.38');
INSERT INTO public.europe_data_import VALUES (10180, '13/04/2020', '2020-15', '33', '4', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.22');
INSERT INTO public.europe_data_import VALUES (10181, '06/04/2020', '2020-14', '29', '4', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.39');
INSERT INTO public.europe_data_import VALUES (10182, '30/03/2020', '2020-13', '83', '1', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.36');
INSERT INTO public.europe_data_import VALUES (10183, '23/03/2020', '2020-12', '21', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '0.13');
INSERT INTO public.europe_data_import VALUES (10184, '16/03/2020', '2020-11', '15', '0', '28515829', 'Venezuela', 'VE', 'VEN', 'America', '');
INSERT INTO public.europe_data_import VALUES (10185, '01/02/2021', '2021-04', '271', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.29');
INSERT INTO public.europe_data_import VALUES (10186, '25/01/2021', '2021-03', '9', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10187, '18/01/2021', '2021-02', '25', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10188, '11/01/2021', '2021-01', '17', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (10189, '04/01/2021', '2020-53', '56', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (10190, '28/12/2020', '2020-52', '28', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10191, '21/12/2020', '2020-51', '16', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10192, '14/12/2020', '2020-50', '31', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (10193, '07/12/2020', '2020-49', '23', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (10194, '30/11/2020', '2020-48', '37', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (10195, '23/11/2020', '2020-47', '25', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (10196, '16/11/2020', '2020-46', '68', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.1');
INSERT INTO public.europe_data_import VALUES (10197, '09/11/2020', '2020-45', '33', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10198, '02/11/2020', '2020-44', '12', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10199, '26/10/2020', '2020-43', '34', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (10200, '19/10/2020', '2020-42', '25', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10201, '12/10/2020', '2020-41', '13', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10202, '05/10/2020', '2020-40', '22', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10203, '28/09/2020', '2020-39', '6', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10204, '21/09/2020', '2020-38', '5', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10205, '14/09/2020', '2020-37', '14', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10206, '07/09/2020', '2020-36', '9', '3', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10207, '31/08/2020', '2020-35', '24', '5', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.08');
INSERT INTO public.europe_data_import VALUES (10208, '24/08/2020', '2020-34', '52', '3', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.18');
INSERT INTO public.europe_data_import VALUES (10209, '17/08/2020', '2020-33', '123', '11', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.36');
INSERT INTO public.europe_data_import VALUES (10210, '10/08/2020', '2020-32', '220', '7', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.44');
INSERT INTO public.europe_data_import VALUES (10211, '03/08/2020', '2020-31', '201', '6', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (10212, '27/07/2020', '2020-30', '47', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10213, '20/07/2020', '2020-29', '1', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10214, '13/07/2020', '2020-28', '17', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10215, '06/07/2020', '2020-27', '0', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10216, '29/06/2020', '2020-26', '6', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10217, '22/06/2020', '2020-25', '15', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10218, '15/06/2020', '2020-24', '3', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10219, '08/06/2020', '2020-23', '3', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10220, '01/06/2020', '2020-22', '3', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10221, '25/05/2020', '2020-21', '5', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10222, '18/05/2020', '2020-20', '32', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10223, '11/05/2020', '2020-19', '17', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10224, '04/05/2020', '2020-18', '1', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (10225, '27/04/2020', '2020-17', '2', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10226, '20/04/2020', '2020-16', '4', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10227, '13/04/2020', '2020-15', '19', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.06');
INSERT INTO public.europe_data_import VALUES (10228, '06/04/2020', '2020-14', '42', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.13');
INSERT INTO public.europe_data_import VALUES (10229, '30/03/2020', '2020-13', '82', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (10230, '23/03/2020', '2020-12', '64', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.09');
INSERT INTO public.europe_data_import VALUES (10231, '16/03/2020', '2020-11', '27', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10232, '09/03/2020', '2020-10', '14', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10233, '02/03/2020', '2020-09', '0', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (10234, '24/02/2020', '2020-08', '0', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (10235, '17/02/2020', '2020-07', '2', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10236, '10/02/2020', '2020-06', '6', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10237, '03/02/2020', '2020-05', '6', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10238, '27/01/2020', '2020-04', '2', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (10239, '20/01/2020', '2020-03', '0', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (10240, '13/01/2020', '2020-02', '0', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (10241, '06/01/2020', '2020-01', '0', '0', '96462108', 'Vietnam', 'VN', 'VNM', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (10242, '01/02/2021', '2021-04', '1', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10243, '25/01/2021', '2021-03', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10244, '18/01/2021', '2021-02', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10245, '11/01/2021', '2021-01', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10246, '04/01/2021', '2020-53', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10247, '28/12/2020', '2020-52', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10248, '21/12/2020', '2020-51', '1', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10249, '14/12/2020', '2020-50', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10250, '07/12/2020', '2020-49', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10251, '30/11/2020', '2020-48', '1', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10252, '23/11/2020', '2020-47', '1', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10253, '16/11/2020', '2020-46', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10254, '09/11/2020', '2020-45', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10255, '02/11/2020', '2020-44', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10256, '26/10/2020', '2020-43', '0', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10257, '19/10/2020', '2020-42', '1', '0', '', 'Wallis_and_Futuna', 'WF', '', 'Oceania', '');
INSERT INTO public.europe_data_import VALUES (10258, '01/02/2021', '2021-04', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10259, '25/01/2021', '2021-03', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10260, '18/01/2021', '2021-02', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10261, '11/01/2021', '2021-01', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10262, '04/01/2021', '2020-53', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10263, '28/12/2020', '2020-52', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10264, '21/12/2020', '2020-51', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10265, '14/12/2020', '2020-50', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10266, '07/12/2020', '2020-49', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10267, '30/11/2020', '2020-48', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10268, '23/11/2020', '2020-47', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10269, '16/11/2020', '2020-46', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10270, '09/11/2020', '2020-45', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10271, '02/11/2020', '2020-44', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10272, '26/10/2020', '2020-43', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10273, '19/10/2020', '2020-42', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10274, '12/10/2020', '2020-41', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10275, '05/10/2020', '2020-40', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10276, '28/09/2020', '2020-39', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10277, '21/09/2020', '2020-38', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10278, '14/09/2020', '2020-37', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10279, '07/09/2020', '2020-36', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10280, '31/08/2020', '2020-35', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10281, '24/08/2020', '2020-34', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10282, '17/08/2020', '2020-33', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10283, '10/08/2020', '2020-32', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10284, '03/08/2020', '2020-31', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10285, '27/07/2020', '2020-30', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '42.41');
INSERT INTO public.europe_data_import VALUES (10286, '20/07/2020', '2020-29', '247', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '42.41');
INSERT INTO public.europe_data_import VALUES (10287, '13/07/2020', '2020-28', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '53.39');
INSERT INTO public.europe_data_import VALUES (10288, '06/07/2020', '2020-27', '311', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '84.81');
INSERT INTO public.europe_data_import VALUES (10289, '29/06/2020', '2020-26', '183', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '31.76');
INSERT INTO public.europe_data_import VALUES (10290, '22/06/2020', '2020-25', '2', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0.34');
INSERT INTO public.europe_data_import VALUES (10291, '15/06/2020', '2020-24', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10292, '08/06/2020', '2020-23', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '2.92');
INSERT INTO public.europe_data_import VALUES (10293, '01/06/2020', '2020-22', '17', '1', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '2.92');
INSERT INTO public.europe_data_import VALUES (10294, '25/05/2020', '2020-21', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10295, '18/05/2020', '2020-20', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10296, '11/05/2020', '2020-19', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '0');
INSERT INTO public.europe_data_import VALUES (10297, '04/05/2020', '2020-18', '0', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '1.03');
INSERT INTO public.europe_data_import VALUES (10298, '27/04/2020', '2020-17', '6', '0', '582458', 'Western_Sahara', 'EH', 'ESH', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (10299, '01/02/2021', '2021-04', '3', '0', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10300, '25/01/2021', '2021-03', '6', '3', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10301, '18/01/2021', '2021-02', '8', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10302, '11/01/2021', '2021-01', '3', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10303, '04/01/2021', '2020-53', '7', '3', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10304, '28/12/2020', '2020-52', '9', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10305, '21/12/2020', '2020-51', '6', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.04');
INSERT INTO public.europe_data_import VALUES (10306, '14/12/2020', '2020-50', '6', '0', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10307, '07/12/2020', '2020-49', '0', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10308, '30/11/2020', '2020-48', '8', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10309, '23/11/2020', '2020-47', '1', '2', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10310, '16/11/2020', '2020-46', '5', '0', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.02');
INSERT INTO public.europe_data_import VALUES (10311, '09/11/2020', '2020-45', '0', '2', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (10312, '02/11/2020', '2020-44', '0', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.01');
INSERT INTO public.europe_data_import VALUES (10313, '26/10/2020', '2020-43', '4', '2', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10314, '19/10/2020', '2020-42', '4', '1', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10315, '12/10/2020', '2020-41', '10', '5', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (10316, '05/10/2020', '2020-40', '11', '3', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.05');
INSERT INTO public.europe_data_import VALUES (10317, '28/09/2020', '2020-39', '4', '2', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.07');
INSERT INTO public.europe_data_import VALUES (10318, '21/09/2020', '2020-38', '17', '3', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.15');
INSERT INTO public.europe_data_import VALUES (10319, '14/09/2020', '2020-37', '26', '11', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.21');
INSERT INTO public.europe_data_import VALUES (10320, '07/09/2020', '2020-36', '34', '8', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.26');
INSERT INTO public.europe_data_import VALUES (10321, '31/08/2020', '2020-35', '42', '17', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.29');
INSERT INTO public.europe_data_import VALUES (10322, '24/08/2020', '2020-34', '42', '17', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.37');
INSERT INTO public.europe_data_import VALUES (10323, '17/08/2020', '2020-33', '65', '15', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.46');
INSERT INTO public.europe_data_import VALUES (10324, '10/08/2020', '2020-32', '70', '18', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.42');
INSERT INTO public.europe_data_import VALUES (10325, '03/08/2020', '2020-31', '53', '18', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.44');
INSERT INTO public.europe_data_import VALUES (10326, '27/07/2020', '2020-30', '75', '34', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.74');
INSERT INTO public.europe_data_import VALUES (10327, '20/07/2020', '2020-29', '141', '28', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '1.17');
INSERT INTO public.europe_data_import VALUES (10328, '13/07/2020', '2020-28', '200', '79', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '1.19');
INSERT INTO public.europe_data_import VALUES (10329, '06/07/2020', '2020-27', '147', '36', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '1.11');
INSERT INTO public.europe_data_import VALUES (10330, '29/06/2020', '2020-26', '177', '46', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '1.34');
INSERT INTO public.europe_data_import VALUES (10331, '22/06/2020', '2020-25', '213', '92', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '1.56');
INSERT INTO public.europe_data_import VALUES (10332, '15/06/2020', '2020-24', '242', '52', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '1.39');
INSERT INTO public.europe_data_import VALUES (10333, '08/06/2020', '2020-23', '163', '32', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.91');
INSERT INTO public.europe_data_import VALUES (10334, '01/06/2020', '2020-22', '101', '38', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.67');
INSERT INTO public.europe_data_import VALUES (10335, '25/05/2020', '2020-21', '94', '22', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.59');
INSERT INTO public.europe_data_import VALUES (10336, '18/05/2020', '2020-20', '77', '12', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.4');
INSERT INTO public.europe_data_import VALUES (10337, '11/05/2020', '2020-19', '41', '6', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.17');
INSERT INTO public.europe_data_import VALUES (10338, '04/05/2020', '2020-18', '9', '2', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.03');
INSERT INTO public.europe_data_import VALUES (10339, '27/04/2020', '2020-17', '0', '0', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0');
INSERT INTO public.europe_data_import VALUES (10340, '20/04/2020', '2020-16', '0', '0', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '0.0');
INSERT INTO public.europe_data_import VALUES (10341, '13/04/2020', '2020-15', '1', '0', '29161922', 'Yemen', 'YE', 'YEM', 'Asia', '');
INSERT INTO public.europe_data_import VALUES (10342, '01/02/2021', '2021-04', '8896', '120', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '94.26');
INSERT INTO public.europe_data_import VALUES (10343, '25/01/2021', '2021-03', '7939', '101', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '98.26');
INSERT INTO public.europe_data_import VALUES (10344, '18/01/2021', '2021-02', '9611', '88', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '90.78');
INSERT INTO public.europe_data_import VALUES (10345, '11/01/2021', '2021-01', '6603', '73', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '48.45');
INSERT INTO public.europe_data_import VALUES (10346, '04/01/2021', '2020-53', '2050', '14', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '18.35');
INSERT INTO public.europe_data_import VALUES (10347, '28/12/2020', '2020-52', '1227', '11', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '9.34');
INSERT INTO public.europe_data_import VALUES (10348, '21/12/2020', '2020-51', '442', '6', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '4.48');
INSERT INTO public.europe_data_import VALUES (10349, '14/12/2020', '2020-50', '358', '3', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '3.73');
INSERT INTO public.europe_data_import VALUES (10350, '07/12/2020', '2020-49', '308', '7', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '2.75');
INSERT INTO public.europe_data_import VALUES (10351, '30/11/2020', '2020-48', '184', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '2.72');
INSERT INTO public.europe_data_import VALUES (10352, '23/11/2020', '2020-47', '301', '4', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '2.63');
INSERT INTO public.europe_data_import VALUES (10353, '16/11/2020', '2020-46', '169', '4', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '3.6');
INSERT INTO public.europe_data_import VALUES (10354, '09/11/2020', '2020-45', '474', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '4.69');
INSERT INTO public.europe_data_import VALUES (10355, '02/11/2020', '2020-44', '363', '1', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '3.51');
INSERT INTO public.europe_data_import VALUES (10356, '26/10/2020', '2020-43', '264', '2', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '3.69');
INSERT INTO public.europe_data_import VALUES (10357, '19/10/2020', '2020-42', '395', '10', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '4.48');
INSERT INTO public.europe_data_import VALUES (10358, '12/10/2020', '2020-41', '406', '3', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '4.57');
INSERT INTO public.europe_data_import VALUES (10359, '05/10/2020', '2020-40', '411', '1', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '5.16');
INSERT INTO public.europe_data_import VALUES (10360, '28/09/2020', '2020-39', '510', '2', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '6.17');
INSERT INTO public.europe_data_import VALUES (10361, '21/09/2020', '2020-38', '592', '18', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '7.59');
INSERT INTO public.europe_data_import VALUES (10362, '14/09/2020', '2020-37', '763', '17', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '8.48');
INSERT INTO public.europe_data_import VALUES (10363, '07/09/2020', '2020-36', '751', '8', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '9.48');
INSERT INTO public.europe_data_import VALUES (10364, '31/08/2020', '2020-35', '943', '7', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '15.02');
INSERT INTO public.europe_data_import VALUES (10365, '24/08/2020', '2020-34', '1739', '20', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '16.78');
INSERT INTO public.europe_data_import VALUES (10366, '17/08/2020', '2020-33', '1258', '25', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '16.77');
INSERT INTO public.europe_data_import VALUES (10367, '10/08/2020', '2020-32', '1738', '65', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '20.18');
INSERT INTO public.europe_data_import VALUES (10368, '03/08/2020', '2020-31', '1866', '31', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '18.85');
INSERT INTO public.europe_data_import VALUES (10369, '27/07/2020', '2020-30', '1501', '30', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '14.48');
INSERT INTO public.europe_data_import VALUES (10370, '20/07/2020', '2020-29', '1085', '67', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '7.55');
INSERT INTO public.europe_data_import VALUES (10371, '13/07/2020', '2020-28', '263', '12', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.89');
INSERT INTO public.europe_data_import VALUES (10372, '06/07/2020', '2020-27', '75', '8', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.13');
INSERT INTO public.europe_data_import VALUES (10373, '29/06/2020', '2020-26', '127', '11', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.11');
INSERT INTO public.europe_data_import VALUES (10374, '22/06/2020', '2020-25', '72', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.55');
INSERT INTO public.europe_data_import VALUES (10375, '15/06/2020', '2020-24', '204', '4', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.69');
INSERT INTO public.europe_data_import VALUES (10376, '08/06/2020', '2020-23', '97', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.31');
INSERT INTO public.europe_data_import VALUES (10377, '01/06/2020', '2020-22', '137', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.7');
INSERT INTO public.europe_data_import VALUES (10378, '25/05/2020', '2020-21', '167', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '3.66');
INSERT INTO public.europe_data_import VALUES (10379, '18/05/2020', '2020-20', '486', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '3.52');
INSERT INTO public.europe_data_import VALUES (10380, '11/05/2020', '2020-19', '143', '4', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '1.0');
INSERT INTO public.europe_data_import VALUES (10381, '04/05/2020', '2020-18', '36', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '0.35');
INSERT INTO public.europe_data_import VALUES (10382, '27/04/2020', '2020-17', '27', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '0.25');
INSERT INTO public.europe_data_import VALUES (10383, '20/04/2020', '2020-16', '18', '1', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (10384, '13/04/2020', '2020-15', '4', '1', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (10385, '06/04/2020', '2020-14', '10', '1', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '0.2');
INSERT INTO public.europe_data_import VALUES (10386, '30/03/2020', '2020-13', '26', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '0.16');
INSERT INTO public.europe_data_import VALUES (10387, '23/03/2020', '2020-12', '3', '0', '17861034', 'Zambia', 'ZM', 'ZMB', 'Africa', '');
INSERT INTO public.europe_data_import VALUES (10388, '01/02/2021', '2021-04', '2228', '229', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '43.32');
INSERT INTO public.europe_data_import VALUES (10389, '25/01/2021', '2021-03', '4117', '292', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '67.21');
INSERT INTO public.europe_data_import VALUES (10390, '18/01/2021', '2021-02', '5726', '206', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '81.51');
INSERT INTO public.europe_data_import VALUES (10391, '11/01/2021', '2021-01', '6212', '127', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '56.87');
INSERT INTO public.europe_data_import VALUES (10392, '04/01/2021', '2020-53', '2117', '26', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '19.88');
INSERT INTO public.europe_data_import VALUES (10393, '28/12/2020', '2020-52', '795', '34', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '12.99');
INSERT INTO public.europe_data_import VALUES (10394, '21/12/2020', '2020-51', '1107', '13', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '11.16');
INSERT INTO public.europe_data_import VALUES (10395, '14/12/2020', '2020-50', '528', '16', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '8.85');
INSERT INTO public.europe_data_import VALUES (10396, '07/12/2020', '2020-49', '768', '15', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '10.23');
INSERT INTO public.europe_data_import VALUES (10397, '30/11/2020', '2020-48', '730', '8', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '7.95');
INSERT INTO public.europe_data_import VALUES (10398, '23/11/2020', '2020-47', '434', '11', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '4.7');
INSERT INTO public.europe_data_import VALUES (10399, '16/11/2020', '2020-46', '255', '4', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '2.81');
INSERT INTO public.europe_data_import VALUES (10400, '09/11/2020', '2020-45', '157', '10', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.74');
INSERT INTO public.europe_data_import VALUES (10401, '02/11/2020', '2020-44', '98', '6', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.55');
INSERT INTO public.europe_data_import VALUES (10402, '26/10/2020', '2020-43', '129', '6', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.81');
INSERT INTO public.europe_data_import VALUES (10403, '19/10/2020', '2020-42', '136', '1', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.79');
INSERT INTO public.europe_data_import VALUES (10404, '12/10/2020', '2020-41', '126', '2', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.36');
INSERT INTO public.europe_data_import VALUES (10405, '05/10/2020', '2020-40', '73', '1', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.38');
INSERT INTO public.europe_data_import VALUES (10406, '28/09/2020', '2020-39', '129', '2', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.95');
INSERT INTO public.europe_data_import VALUES (10407, '21/09/2020', '2020-38', '157', '1', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '4.82');
INSERT INTO public.europe_data_import VALUES (10408, '14/09/2020', '2020-37', '549', '17', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '7.61');
INSERT INTO public.europe_data_import VALUES (10409, '07/09/2020', '2020-36', '565', '11', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '7.15');
INSERT INTO public.europe_data_import VALUES (10410, '31/08/2020', '2020-35', '482', '41', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '7.86');
INSERT INTO public.europe_data_import VALUES (10411, '24/08/2020', '2020-34', '669', '23', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '8.75');
INSERT INTO public.europe_data_import VALUES (10412, '17/08/2020', '2020-33', '612', '28', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '9.15');
INSERT INTO public.europe_data_import VALUES (10413, '10/08/2020', '2020-32', '728', '34', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '14.59');
INSERT INTO public.europe_data_import VALUES (10414, '03/08/2020', '2020-31', '1409', '36', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '15.77');
INSERT INTO public.europe_data_import VALUES (10415, '27/07/2020', '2020-30', '901', '9', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '10.43');
INSERT INTO public.europe_data_import VALUES (10416, '20/07/2020', '2020-29', '626', '7', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '6.11');
INSERT INTO public.europe_data_import VALUES (10417, '13/07/2020', '2020-28', '269', '10', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '2.85');
INSERT INTO public.europe_data_import VALUES (10418, '06/07/2020', '2020-27', '149', '2', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.55');
INSERT INTO public.europe_data_import VALUES (10419, '29/06/2020', '2020-26', '78', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.26');
INSERT INTO public.europe_data_import VALUES (10420, '22/06/2020', '2020-25', '106', '2', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.41');
INSERT INTO public.europe_data_import VALUES (10421, '15/06/2020', '2020-24', '101', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.4');
INSERT INTO public.europe_data_import VALUES (10422, '08/06/2020', '2020-23', '104', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '1.54');
INSERT INTO public.europe_data_import VALUES (10423, '01/06/2020', '2020-22', '122', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.9');
INSERT INTO public.europe_data_import VALUES (10424, '25/05/2020', '2020-21', '10', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.14');
INSERT INTO public.europe_data_import VALUES (10425, '18/05/2020', '2020-20', '10', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.08');
INSERT INTO public.europe_data_import VALUES (10426, '11/05/2020', '2020-19', '2', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.03');
INSERT INTO public.europe_data_import VALUES (10427, '04/05/2020', '2020-18', '3', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.06');
INSERT INTO public.europe_data_import VALUES (10428, '27/04/2020', '2020-17', '6', '1', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.12');
INSERT INTO public.europe_data_import VALUES (10429, '20/04/2020', '2020-16', '11', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.11');
INSERT INTO public.europe_data_import VALUES (10430, '13/04/2020', '2020-15', '5', '2', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (10431, '06/04/2020', '2020-14', '2', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (10432, '30/03/2020', '2020-13', '5', '1', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '0.05');
INSERT INTO public.europe_data_import VALUES (10433, '23/03/2020', '2020-12', '2', '0', '14645473', 'Zimbabwe', 'ZW', 'ZWE', 'Africa', '');


--
-- Data for Name: rki_country; Type: TABLE DATA; Schema: public; Owner: covid19data
--



--
-- Data for Name: rki_global_data; Type: TABLE DATA; Schema: public; Owner: covid19data
--



--
-- Data for Name: rki_global_data_import; Type: TABLE DATA; Schema: public; Owner: covid19data
--



--
-- Data for Name: vaccination_germany_timeline; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.vaccination_germany_timeline VALUES (1, '2020-12-27', 23898, 23898, 23898, 0, 23898, 0, 0.00029, 0, 8507, 7859, 1280, 13362, 8507, 7859, 1280, 13362, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (2, '2020-12-28', 43734, 19836, 43734, 0, 43734, 0, 0.00053, 0, 16289, 15316, 2010, 23187, 16289, 15316, 2010, 23187, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (3, '2020-12-29', 87151, 43417, 87151, 0, 87151, 0, 0.00105, 0, 28460, 37021, 3089, 40433, 28460, 37021, 3089, 40433, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (4, '2020-12-30', 144907, 57756, 144907, 0, 144907, 0, 0.00174, 0, 45710, 68226, 4688, 61371, 45710, 68226, 4688, 61371, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (5, '2020-12-31', 182965, 38058, 182965, 0, 182965, 0, 0.0022, 0, 58583, 86625, 6500, 76501, 58583, 86625, 6500, 76501, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (6, '2021-01-01', 207458, 24493, 207458, 0, 207458, 0, 0.00249, 0, 66265, 96401, 7591, 89068, 66265, 96401, 7591, 89068, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (7, '2021-01-02', 258228, 50770, 258228, 0, 258228, 0, 0.0031, 0, 85186, 119346, 10036, 109820, 85186, 119346, 10036, 109820, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (8, '2021-01-03', 283387, 25159, 283387, 0, 283387, 0, 0.00341, 0, 94982, 130409, 10965, 120516, 94982, 130409, 10965, 120516, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (9, '2021-01-04', 332275, 48888, 332275, 0, 332275, 0, 0.004, 0, 109225, 155338, 13614, 136520, 109225, 155338, 13614, 136520, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (10, '2021-01-05', 384411, 52136, 384411, 0, 384411, 0, 0.00462, 0, 124509, 182250, 16015, 154814, 124509, 182250, 16015, 154814, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (11, '2021-01-06', 442822, 58411, 442822, 0, 442822, 0, 0.00532, 0, 141004, 212591, 19389, 175519, 141004, 212591, 19389, 175519, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (12, '2021-01-07', 501307, 58485, 501307, 0, 501307, 0, 0.00603, 0, 157689, 242549, 22372, 193485, 157689, 242549, 22372, 193485, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (13, '2021-01-08', 561257, 59950, 561257, 0, 561257, 0, 0.00675, 0, 176146, 273399, 25662, 213252, 176146, 273399, 25662, 213252, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (14, '2021-01-09', 617747, 56490, 617747, 0, 617747, 0, 0.00743, 0, 197403, 297268, 27937, 236171, 197403, 297268, 27937, 236171, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (15, '2021-01-10', 650983, 33236, 650983, 0, 650983, 0, 0.00783, 0, 210615, 311320, 29262, 248200, 210615, 311320, 29262, 248200, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (16, '2021-01-11', 716627, 65644, 716627, 0, 716627, 0, 0.00862, 0, 233212, 342497, 32133, 268364, 233212, 342497, 32133, 268364, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (17, '2021-01-12', 798485, 81858, 798485, 0, 798485, 0, 0.0096, 0, 258621, 384743, 35336, 292606, 258621, 384743, 35336, 292606, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (18, '2021-01-13', 896659, 98174, 895865, 794, 896659, 0, 0.01078, 0, 289427, 435711, 38227, 319990, 289427, 435711, 38227, 319990, 0, 0, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (19, '2021-01-14', 997037, 100378, 992117, 4920, 996904, 133, 0.01199, 0, 314508, 485613, 39905, 350499, 314438, 485610, 39905, 350499, 70, 3, 0, 0);
INSERT INTO public.vaccination_germany_timeline VALUES (20, '2021-01-15', 1089844, 92807, 1080038, 9806, 1089267, 577, 0.0131, 1e-05, 343260, 531533, 43061, 376746, 343054, 531500, 43060, 376710, 206, 33, 1, 36);
INSERT INTO public.vaccination_germany_timeline VALUES (21, '2021-01-16', 1146650, 56806, 1134993, 11657, 1145651, 999, 0.01378, 1e-05, 362973, 555655, 44759, 395028, 362553, 555528, 44697, 394804, 420, 127, 62, 224);
INSERT INTO public.vaccination_germany_timeline VALUES (22, '2021-01-17', 1191479, 44829, 1178407, 13072, 1176871, 14608, 0.01415, 0.00018, 378894, 574554, 46302, 411555, 372134, 569559, 45645, 403406, 6760, 4995, 657, 8149);
INSERT INTO public.vaccination_germany_timeline VALUES (23, '2021-01-18', 1265619, 74140, 1250534, 15085, 1234551, 31068, 0.01484, 0.00037, 405269, 609302, 47964, 430573, 393093, 597382, 47109, 415498, 12176, 11920, 855, 15075);
INSERT INTO public.vaccination_germany_timeline VALUES (24, '2021-01-19', 1359519, 93900, 1342859, 16660, 1301232, 58287, 0.01565, 0.0007, 436622, 656353, 50791, 455836, 415391, 631482, 49354, 430525, 21231, 24871, 1437, 25311);
INSERT INTO public.vaccination_germany_timeline VALUES (25, '2021-01-20', 1487398, 127879, 1469409, 17989, 1378723, 108675, 0.01658, 0.00131, 477544, 717792, 54531, 496661, 441611, 667751, 52241, 451592, 35933, 50041, 2290, 45069);
INSERT INTO public.vaccination_germany_timeline VALUES (26, '2021-01-21', 1581563, 94165, 1562477, 19086, 1438566, 142997, 0.0173, 0.00172, 513636, 758639, 59998, 525658, 465209, 693669, 55301, 467705, 48427, 64970, 4697, 57953);
INSERT INTO public.vaccination_germany_timeline VALUES (27, '2021-01-22', 1695376, 113813, 1674861, 20515, 1521871, 173505, 0.0183, 0.00209, 553710, 809265, 63241, 566093, 493096, 730314, 57774, 493831, 60614, 78951, 5467, 72262);
INSERT INTO public.vaccination_germany_timeline VALUES (28, '2021-01-23', 1786215, 90839, 1765317, 20898, 1570058, 216157, 0.01888, 0.0026, 587407, 848846, 66391, 596602, 511361, 749796, 58941, 507292, 76046, 99050, 7450, 89310);
INSERT INTO public.vaccination_germany_timeline VALUES (29, '2021-01-24', 1851790, 65575, 1830648, 21142, 1607953, 243837, 0.01933, 0.00293, 609612, 875489, 67180, 620334, 524666, 764637, 59266, 519062, 84946, 110852, 7914, 101272);
INSERT INTO public.vaccination_germany_timeline VALUES (30, '2021-01-25', 1948061, 96271, 1925399, 22662, 1665182, 282879, 0.02002, 0.0034, 648965, 917415, 70436, 645373, 552165, 786363, 60801, 531347, 96800, 131052, 9635, 114026);
INSERT INTO public.vaccination_germany_timeline VALUES (31, '2021-01-26', 2049404, 101343, 2025154, 24250, 1718227, 331177, 0.02066, 0.00398, 686841, 964274, 74058, 672360, 576916, 806668, 62098, 543136, 109925, 157606, 11960, 129224);
INSERT INTO public.vaccination_germany_timeline VALUES (32, '2021-01-27', 2159706, 110302, 2133549, 26157, 1771865, 387841, 0.0213, 0.00466, 726220, 1017254, 78993, 702581, 600015, 828773, 63877, 554960, 126205, 188481, 15116, 147621);
INSERT INTO public.vaccination_germany_timeline VALUES (33, '2021-01-28', 2258631, 98925, 2225994, 32637, 1823278, 435353, 0.02192, 0.00523, 762446, 1065060, 82998, 728067, 621607, 851661, 65396, 566560, 140839, 213399, 17602, 161507);
INSERT INTO public.vaccination_germany_timeline VALUES (34, '2021-01-29', 2366458, 107827, 2332418, 34040, 1879594, 486864, 0.0226, 0.00585, 802401, 1115195, 88205, 754999, 643920, 875638, 67664, 577092, 158481, 239557, 20541, 177907);
INSERT INTO public.vaccination_germany_timeline VALUES (35, '2021-01-30', 2449931, 83473, 2415086, 34845, 1917353, 532578, 0.02305, 0.0064, 834053, 1153908, 91818, 778940, 659115, 893272, 69047, 584532, 174938, 260636, 22771, 194408);
INSERT INTO public.vaccination_germany_timeline VALUES (36, '2021-01-31', 2512113, 62182, 2476925, 35188, 1948477, 563636, 0.02343, 0.00678, 857382, 1182048, 93847, 794470, 672576, 907461, 70205, 590227, 184806, 274587, 23642, 204243);
INSERT INTO public.vaccination_germany_timeline VALUES (37, '2021-02-01', 2624051, 111938, 2587286, 36765, 1995805, 628246, 0.024, 0.00755, 897089, 1236881, 97281, 822444, 691852, 930021, 71940, 599708, 205237, 306860, 25341, 222736);
INSERT INTO public.vaccination_germany_timeline VALUES (38, '2021-02-02', 2745944, 121893, 2707153, 38791, 2050436, 695508, 0.02465, 0.00836, 937012, 1299527, 102046, 853304, 709933, 960261, 74343, 609038, 227079, 339266, 27703, 244266);
INSERT INTO public.vaccination_germany_timeline VALUES (39, '2021-02-03', 2870810, 124866, 2826880, 43930, 2101482, 769328, 0.02527, 0.00925, 984900, 1357244, 106378, 885121, 731115, 983150, 76190, 618548, 253785, 374094, 30188, 266573);
INSERT INTO public.vaccination_germany_timeline VALUES (40, '2021-02-04', 2987398, 116588, 2940357, 47041, 2153000, 834398, 0.02589, 0.01003, 1027594, 1412509, 110467, 913990, 751469, 1008877, 78284, 626939, 276125, 403632, 32183, 287051);


--
-- Data for Name: who_country; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.who_country VALUES (1, 'CI', 'Côte d’Ivoire', 1);
INSERT INTO public.who_country VALUES (2, 'BF', 'Burkina Faso', 1);
INSERT INTO public.who_country VALUES (3, 'GM', 'Gambia', 1);
INSERT INTO public.who_country VALUES (4, 'MC', 'Monaco', 4);
INSERT INTO public.who_country VALUES (5, 'OM', 'Oman', 3);
INSERT INTO public.who_country VALUES (6, 'LC', 'Saint Lucia', 2);
INSERT INTO public.who_country VALUES (7, 'FJ', 'Fiji', 7);
INSERT INTO public.who_country VALUES (8, 'VN', 'Viet Nam', 7);
INSERT INTO public.who_country VALUES (9, 'IS', 'Iceland', 4);
INSERT INTO public.who_country VALUES (10, 'LI', 'Liechtenstein', 4);
INSERT INTO public.who_country VALUES (11, 'GE', 'Georgia', 4);
INSERT INTO public.who_country VALUES (12, 'IE', 'Ireland', 4);
INSERT INTO public.who_country VALUES (13, 'VU', 'Vanuatu', 7);
INSERT INTO public.who_country VALUES (14, 'ZW', 'Zimbabwe', 1);
INSERT INTO public.who_country VALUES (15, 'TL', 'Timor-Leste', 6);
INSERT INTO public.who_country VALUES (16, 'LY', 'Libya', 3);
INSERT INTO public.who_country VALUES (17, 'NU', 'Niue', 7);
INSERT INTO public.who_country VALUES (18, 'TJ', 'Tajikistan', 4);
INSERT INTO public.who_country VALUES (19, 'US', 'United States of America', 2);
INSERT INTO public.who_country VALUES (20, 'CL', 'Chile', 2);
INSERT INTO public.who_country VALUES (21, 'CY', 'Cyprus', 4);
INSERT INTO public.who_country VALUES (22, 'MA', 'Morocco', 3);
INSERT INTO public.who_country VALUES (23, 'GW', 'Guinea-Bissau', 1);
INSERT INTO public.who_country VALUES (24, 'GH', 'Ghana', 1);
INSERT INTO public.who_country VALUES (25, 'TG', 'Togo', 1);
INSERT INTO public.who_country VALUES (26, 'RO', 'Romania', 4);
INSERT INTO public.who_country VALUES (27, 'KW', 'Kuwait', 3);
INSERT INTO public.who_country VALUES (28, 'FR', 'France', 4);
INSERT INTO public.who_country VALUES (29, 'GD', 'Grenada', 2);
INSERT INTO public.who_country VALUES (30, 'ZA', 'South Africa', 1);
INSERT INTO public.who_country VALUES (31, 'ME', 'Montenegro', 4);
INSERT INTO public.who_country VALUES (32, 'SB', 'Solomon Islands', 7);
INSERT INTO public.who_country VALUES (33, 'BJ', 'Benin', 1);
INSERT INTO public.who_country VALUES (34, 'TO', 'Tonga', 7);
INSERT INTO public.who_country VALUES (35, 'SC', 'Seychelles', 1);
INSERT INTO public.who_country VALUES (36, 'TC', 'Turks and Caicos Islands', 2);
INSERT INTO public.who_country VALUES (37, 'AZ', 'Azerbaijan', 4);
INSERT INTO public.who_country VALUES (38, 'BW', 'Botswana', 1);
INSERT INTO public.who_country VALUES (39, 'BG', 'Bulgaria', 4);
INSERT INTO public.who_country VALUES (40, 'GP', 'Guadeloupe', 2);
INSERT INTO public.who_country VALUES (41, 'EE', 'Estonia', 4);
INSERT INTO public.who_country VALUES (42, 'NC', 'New Caledonia', 7);
INSERT INTO public.who_country VALUES (43, 'CK', 'Cook Islands', 7);
INSERT INTO public.who_country VALUES (44, 'GB', 'The United Kingdom', 4);
INSERT INTO public.who_country VALUES (45, 'LK', 'Sri Lanka', 6);
INSERT INTO public.who_country VALUES (46, 'NP', 'Nepal', 6);
INSERT INTO public.who_country VALUES (47, 'GL', 'Greenland', 4);
INSERT INTO public.who_country VALUES (48, 'HR', 'Croatia', 4);
INSERT INTO public.who_country VALUES (49, 'CR', 'Costa Rica', 2);
INSERT INTO public.who_country VALUES (50, 'BZ', 'Belize', 2);
INSERT INTO public.who_country VALUES (51, 'SE', 'Sweden', 4);
INSERT INTO public.who_country VALUES (52, 'AO', 'Angola', 1);
INSERT INTO public.who_country VALUES (53, 'KY', 'Cayman Islands', 2);
INSERT INTO public.who_country VALUES (54, 'KG', 'Kyrgyzstan', 4);
INSERT INTO public.who_country VALUES (55, 'XB', 'Sint Eustatius', 2);
INSERT INTO public.who_country VALUES (56, 'LB', 'Lebanon', 3);
INSERT INTO public.who_country VALUES (57, 'BA', 'Bosnia and Herzegovina', 4);
INSERT INTO public.who_country VALUES (58, 'AU', 'Australia', 7);
INSERT INTO public.who_country VALUES (59, 'GQ', 'Equatorial Guinea', 1);
INSERT INTO public.who_country VALUES (60, 'GA', 'Gabon', 1);
INSERT INTO public.who_country VALUES (61, 'FO', 'Faroe Islands', 4);
INSERT INTO public.who_country VALUES (62, 'BY', 'Belarus', 4);
INSERT INTO public.who_country VALUES (63, 'NG', 'Nigeria', 1);
INSERT INTO public.who_country VALUES (64, 'BL', 'Saint Barthélemy', 2);
INSERT INTO public.who_country VALUES (65, 'YT', 'Mayotte', 1);
INSERT INTO public.who_country VALUES (66, 'AW', 'Aruba', 2);
INSERT INTO public.who_country VALUES (67, 'XA', 'Bonaire', 2);
INSERT INTO public.who_country VALUES (68, 'PM', 'Saint Pierre and Miquelon', 2);
INSERT INTO public.who_country VALUES (69, 'HT', 'Haiti', 2);
INSERT INTO public.who_country VALUES (70, 'NR', 'Nauru', 7);
INSERT INTO public.who_country VALUES (71, 'KM', 'Comoros', 1);
INSERT INTO public.who_country VALUES (72, 'TH', 'Thailand', 6);
INSERT INTO public.who_country VALUES (73, 'WF', 'Wallis and Futuna', 7);
INSERT INTO public.who_country VALUES (74, 'IN', 'India', 6);
INSERT INTO public.who_country VALUES (75, 'XK', 'Kosovo[1]', 4);
INSERT INTO public.who_country VALUES (76, 'PY', 'Paraguay', 2);
INSERT INTO public.who_country VALUES (77, 'HU', 'Hungary', 4);
INSERT INTO public.who_country VALUES (78, 'SA', 'Saudi Arabia', 3);
INSERT INTO public.who_country VALUES (79, 'LV', 'Latvia', 4);
INSERT INTO public.who_country VALUES (80, 'NZ', 'New Zealand', 7);
INSERT INTO public.who_country VALUES (81, 'KR', 'Republic of Korea', 7);
INSERT INTO public.who_country VALUES (82, 'WS', 'Samoa', 7);
INSERT INTO public.who_country VALUES (83, 'BH', 'Bahrain', 3);
INSERT INTO public.who_country VALUES (84, 'JP', 'Japan', 7);
INSERT INTO public.who_country VALUES (85, 'GF', 'French Guiana', 2);
INSERT INTO public.who_country VALUES (86, 'UZ', 'Uzbekistan', 4);
INSERT INTO public.who_country VALUES (87, 'ML', 'Mali', 1);
INSERT INTO public.who_country VALUES (88, 'SR', 'Suriname', 2);
INSERT INTO public.who_country VALUES (89, 'DE', 'Germany', 4);
INSERT INTO public.who_country VALUES (90, 'NA', 'Namibia', 1);
INSERT INTO public.who_country VALUES (91, 'IT', 'Italy', 4);
INSERT INTO public.who_country VALUES (92, 'BT', 'Bhutan', 6);
INSERT INTO public.who_country VALUES (93, 'PS', 'occupied Palestinian territory, including east Jerusalem', 3);
INSERT INTO public.who_country VALUES (94, 'AM', 'Armenia', 4);
INSERT INTO public.who_country VALUES (95, 'KP', 'Democratic People''s Republic of Korea', 6);
INSERT INTO public.who_country VALUES (96, 'ER', 'Eritrea', 1);
INSERT INTO public.who_country VALUES (97, 'TM', 'Turkmenistan', 4);
INSERT INTO public.who_country VALUES (98, 'PH', 'Philippines', 7);
INSERT INTO public.who_country VALUES (99, 'MY', 'Malaysia', 7);
INSERT INTO public.who_country VALUES (100, 'GR', 'Greece', 4);
INSERT INTO public.who_country VALUES (101, 'YE', 'Yemen', 3);
INSERT INTO public.who_country VALUES (102, 'MX', 'Mexico', 2);
INSERT INTO public.who_country VALUES (103, 'PN', 'Pitcairn Islands', 7);
INSERT INTO public.who_country VALUES (104, 'IM', 'Isle of Man', 4);
INSERT INTO public.who_country VALUES (105, 'KZ', 'Kazakhstan', 4);
INSERT INTO public.who_country VALUES (106, 'MM', 'Myanmar', 6);
INSERT INTO public.who_country VALUES (107, 'CV', 'Cabo Verde', 1);
INSERT INTO public.who_country VALUES (108, 'BN', 'Brunei Darussalam', 7);
INSERT INTO public.who_country VALUES (109, 'MK', 'North Macedonia', 4);
INSERT INTO public.who_country VALUES (110, 'SD', 'Sudan', 3);
INSERT INTO public.who_country VALUES (111, 'CO', 'Colombia', 2);
INSERT INTO public.who_country VALUES (112, 'CN', 'China', 7);
INSERT INTO public.who_country VALUES (113, 'AL', 'Albania', 4);
INSERT INTO public.who_country VALUES (114, 'SL', 'Sierra Leone', 1);
INSERT INTO public.who_country VALUES (115, 'MZ', 'Mozambique', 1);
INSERT INTO public.who_country VALUES (116, 'SH', 'Saint Helena', 1);
INSERT INTO public.who_country VALUES (117, 'LS', 'Lesotho', 1);
INSERT INTO public.who_country VALUES (118, 'MR', 'Mauritania', 1);
INSERT INTO public.who_country VALUES (119, 'MG', 'Madagascar', 1);
INSERT INTO public.who_country VALUES (120, 'DJ', 'Djibouti', 3);
INSERT INTO public.who_country VALUES (121, 'SV', 'El Salvador', 2);
INSERT INTO public.who_country VALUES (122, 'KE', 'Kenya', 1);
INSERT INTO public.who_country VALUES (123, 'MT', 'Malta', 4);
INSERT INTO public.who_country VALUES (124, 'UG', 'Uganda', 1);
INSERT INTO public.who_country VALUES (125, 'TV', 'Tuvalu', 7);
INSERT INTO public.who_country VALUES (126, 'TR', 'Turkey', 4);
INSERT INTO public.who_country VALUES (127, 'MS', 'Montserrat', 2);
INSERT INTO public.who_country VALUES (128, 'KN', 'Saint Kitts and Nevis', 2);
INSERT INTO public.who_country VALUES (129, 'EG', 'Egypt', 3);
INSERT INTO public.who_country VALUES (130, 'GG', 'Guernsey', 4);
INSERT INTO public.who_country VALUES (131, 'PT', 'Portugal', 4);
INSERT INTO public.who_country VALUES (132, 'GT', 'Guatemala', 2);
INSERT INTO public.who_country VALUES (133, 'RS', 'Serbia', 4);
INSERT INTO public.who_country VALUES (134, 'MU', 'Mauritius', 1);
INSERT INTO public.who_country VALUES (135, 'DM', 'Dominica', 2);
INSERT INTO public.who_country VALUES (136, 'NE', 'Niger', 1);
INSERT INTO public.who_country VALUES (137, 'QA', 'Qatar', 3);
INSERT INTO public.who_country VALUES (138, 'PE', 'Peru', 2);
INSERT INTO public.who_country VALUES (139, 'NL', 'Netherlands', 4);
INSERT INTO public.who_country VALUES (140, 'TD', 'Chad', 1);
INSERT INTO public.who_country VALUES (141, 'BR', 'Brazil', 2);
INSERT INTO public.who_country VALUES (142, 'BS', 'Bahamas', 2);
INSERT INTO public.who_country VALUES (143, 'DZ', 'Algeria', 1);
INSERT INTO public.who_country VALUES (144, 'TZ', 'United Republic of Tanzania', 1);
INSERT INTO public.who_country VALUES (145, 'RE', 'Réunion', 1);
INSERT INTO public.who_country VALUES (146, 'MN', 'Mongolia', 7);
INSERT INTO public.who_country VALUES (147, 'SS', 'South Sudan', 1);
INSERT INTO public.who_country VALUES (148, 'UY', 'Uruguay', 2);
INSERT INTO public.who_country VALUES (149, 'SM', 'San Marino', 4);
INSERT INTO public.who_country VALUES (150, 'FK', 'Falkland Islands (Malvinas)', 2);
INSERT INTO public.who_country VALUES (151, 'MH', 'Marshall Islands', 7);
INSERT INTO public.who_country VALUES (152, 'LR', 'Liberia', 1);
INSERT INTO public.who_country VALUES (153, 'IL', 'Israel', 4);
INSERT INTO public.who_country VALUES (154, 'AR', 'Argentina', 2);
INSERT INTO public.who_country VALUES (155, 'SI', 'Slovenia', 4);
INSERT INTO public.who_country VALUES (156, 'CZ', 'Czechia', 4);
INSERT INTO public.who_country VALUES (157, 'VE', 'Venezuela (Bolivarian Republic of)', 2);
INSERT INTO public.who_country VALUES (158, 'BO', 'Bolivia (Plurinational State of)', 2);
INSERT INTO public.who_country VALUES (159, 'KI', 'Kiribati', 7);
INSERT INTO public.who_country VALUES (160, 'BE', 'Belgium', 4);
INSERT INTO public.who_country VALUES (161, 'KH', 'Cambodia', 7);
INSERT INTO public.who_country VALUES (162, 'GI', 'Gibraltar', 4);
INSERT INTO public.who_country VALUES (163, 'AT', 'Austria', 4);
INSERT INTO public.who_country VALUES (164, 'CF', 'Central African Republic', 1);
INSERT INTO public.who_country VALUES (165, 'ZM', 'Zambia', 1);
INSERT INTO public.who_country VALUES (166, 'TN', 'Tunisia', 3);
INSERT INTO public.who_country VALUES (167, 'AG', 'Antigua and Barbuda', 2);
INSERT INTO public.who_country VALUES (168, 'MW', 'Malawi', 1);
INSERT INTO public.who_country VALUES (169, 'FI', 'Finland', 4);
INSERT INTO public.who_country VALUES (170, 'RU', 'Russian Federation', 4);
INSERT INTO public.who_country VALUES (171, 'MV', 'Maldives', 6);
INSERT INTO public.who_country VALUES (172, 'MP', 'Northern Mariana Islands (Commonwealth of the)', 7);
INSERT INTO public.who_country VALUES (173, 'PA', 'Panama', 2);
INSERT INTO public.who_country VALUES (174, 'LU', 'Luxembourg', 4);
INSERT INTO public.who_country VALUES (175, 'CW', 'Curaçao', 2);
INSERT INTO public.who_country VALUES (176, 'SX', 'Sint Maarten', 2);
INSERT INTO public.who_country VALUES (177, 'CD', 'Democratic Republic of the Congo', 1);
INSERT INTO public.who_country VALUES (178, 'VG', 'British Virgin Islands', 2);
INSERT INTO public.who_country VALUES (179, 'TK', 'Tokelau', 7);
INSERT INTO public.who_country VALUES (180, 'AI', 'Anguilla', 2);
INSERT INTO public.who_country VALUES (181, 'CA', 'Canada', 2);
INSERT INTO public.who_country VALUES (182, 'MD', 'Republic of Moldova', 4);
INSERT INTO public.who_country VALUES (183, 'BM', 'Bermuda', 2);
INSERT INTO public.who_country VALUES (184, 'VC', 'Saint Vincent and the Grenadines', 2);
INSERT INTO public.who_country VALUES (185, 'UA', 'Ukraine', 4);
INSERT INTO public.who_country VALUES (186, 'AD', 'Andorra', 4);
INSERT INTO public.who_country VALUES (187, 'VA', 'Holy See', 4);
INSERT INTO public.who_country VALUES (188, 'BB', 'Barbados', 2);
INSERT INTO public.who_country VALUES (189, 'EC', 'Ecuador', 2);
INSERT INTO public.who_country VALUES (190, 'IQ', 'Iraq', 3);
INSERT INTO public.who_country VALUES (191, 'RW', 'Rwanda', 1);
INSERT INTO public.who_country VALUES (192, 'GY', 'Guyana', 2);
INSERT INTO public.who_country VALUES (193, 'AF', 'Afghanistan', 3);
INSERT INTO public.who_country VALUES (194, 'AE', 'United Arab Emirates', 3);
INSERT INTO public.who_country VALUES (195, 'BI', 'Burundi', 1);
INSERT INTO public.who_country VALUES (196, 'JO', 'Jordan', 3);
INSERT INTO public.who_country VALUES (197, 'ST', 'Sao Tome and Principe', 1);
INSERT INTO public.who_country VALUES (198, 'PW', 'Palau', 7);
INSERT INTO public.who_country VALUES (199, 'IR', 'Iran (Islamic Republic of)', 3);
INSERT INTO public.who_country VALUES (200, 'NO', 'Norway', 4);
INSERT INTO public.who_country VALUES (201, 'LT', 'Lithuania', 4);
INSERT INTO public.who_country VALUES (202, 'SK', 'Slovakia', 4);
INSERT INTO public.who_country VALUES (203, 'NI', 'Nicaragua', 2);
INSERT INTO public.who_country VALUES (204, 'PK', 'Pakistan', 3);
INSERT INTO public.who_country VALUES (205, 'SY', 'Syrian Arab Republic', 3);
INSERT INTO public.who_country VALUES (206, 'DO', 'Dominican Republic', 2);
INSERT INTO public.who_country VALUES (207, 'TT', 'Trinidad and Tobago', 2);
INSERT INTO public.who_country VALUES (208, 'ES', 'Spain', 4);
INSERT INTO public.who_country VALUES (209, 'CH', 'Switzerland', 4);
INSERT INTO public.who_country VALUES (210, 'DK', 'Denmark', 4);
INSERT INTO public.who_country VALUES (211, 'PF', 'French Polynesia', 7);
INSERT INTO public.who_country VALUES (212, 'CM', 'Cameroon', 1);
INSERT INTO public.who_country VALUES (213, 'MQ', 'Martinique', 2);
INSERT INTO public.who_country VALUES (214, ' ', 'Other', 5);
INSERT INTO public.who_country VALUES (215, 'JM', 'Jamaica', 2);
INSERT INTO public.who_country VALUES (216, 'SZ', 'Eswatini', 1);
INSERT INTO public.who_country VALUES (217, 'VI', 'United States Virgin Islands', 2);
INSERT INTO public.who_country VALUES (218, 'CG', 'Congo', 1);
INSERT INTO public.who_country VALUES (219, 'AS', 'American Samoa', 7);
INSERT INTO public.who_country VALUES (220, 'SO', 'Somalia', 3);
INSERT INTO public.who_country VALUES (221, 'XC', 'Saba', 2);
INSERT INTO public.who_country VALUES (222, 'GU', 'Guam', 7);
INSERT INTO public.who_country VALUES (223, 'FM', 'Micronesia (Federated States of)', 7);
INSERT INTO public.who_country VALUES (224, 'ID', 'Indonesia', 6);
INSERT INTO public.who_country VALUES (225, 'PL', 'Poland', 4);
INSERT INTO public.who_country VALUES (226, 'LA', 'Lao People''s Democratic Republic', 7);
INSERT INTO public.who_country VALUES (227, 'MF', 'Saint Martin', 2);
INSERT INTO public.who_country VALUES (228, 'BD', 'Bangladesh', 6);
INSERT INTO public.who_country VALUES (229, 'PG', 'Papua New Guinea', 7);
INSERT INTO public.who_country VALUES (230, 'HN', 'Honduras', 2);
INSERT INTO public.who_country VALUES (231, 'JE', 'Jersey', 4);
INSERT INTO public.who_country VALUES (232, 'CU', 'Cuba', 2);
INSERT INTO public.who_country VALUES (233, 'SN', 'Senegal', 1);
INSERT INTO public.who_country VALUES (234, 'GN', 'Guinea', 1);
INSERT INTO public.who_country VALUES (235, 'PR', 'Puerto Rico', 2);
INSERT INTO public.who_country VALUES (236, 'ET', 'Ethiopia', 1);
INSERT INTO public.who_country VALUES (237, 'SG', 'Singapore', 7);


--
-- Data for Name: who_global_data; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.who_global_data VALUES (1, 34, 55265, 0, 2407, 1, 193);
INSERT INTO public.who_global_data VALUES (2, 1052, 81993, 14, 1418, 1, 113);
INSERT INTO public.who_global_data VALUES (3, 265, 108381, 4, 2904, 1, 143);
INSERT INTO public.who_global_data VALUES (4, 0, 0, 0, 0, 1, 219);
INSERT INTO public.who_global_data VALUES (5, 67, 10137, 0, 103, 1, 186);
INSERT INTO public.who_global_data VALUES (6, 59, 19996, 3, 473, 1, 52);
INSERT INTO public.who_global_data VALUES (7, 0, 17, 0, 0, 1, 180);
INSERT INTO public.who_global_data VALUES (8, 19, 268, 0, 7, 1, 167);
INSERT INTO public.who_global_data VALUES (9, 9196, 1952744, 113, 48539, 1, 154);
INSERT INTO public.who_global_data VALUES (10, 158, 167726, 2, 3109, 1, 94);
INSERT INTO public.who_global_data VALUES (11, 55, 7083, 2, 61, 1, 66);
INSERT INTO public.who_global_data VALUES (12, 9, 28838, 0, 909, 1, 58);
INSERT INTO public.who_global_data VALUES (13, 1444, 416369, 28, 7828, 1, 163);
INSERT INTO public.who_global_data VALUES (14, 152, 230769, 3, 3148, 1, 37);
INSERT INTO public.who_global_data VALUES (15, 16, 8247, 0, 176, 1, 142);
INSERT INTO public.who_global_data VALUES (16, 704, 105496, 1, 377, 1, 83);
INSERT INTO public.who_global_data VALUES (17, 485, 537030, 13, 8175, 1, 228);
INSERT INTO public.who_global_data VALUES (18, 25, 1611, 1, 15, 1, 188);
INSERT INTO public.who_global_data VALUES (19, 1708, 253413, 9, 1755, 1, 62);
INSERT INTO public.who_global_data VALUES (20, 0, 718847, 0, 21260, 1, 160);
INSERT INTO public.who_global_data VALUES (21, 21, 11978, 3, 306, 1, 50);
INSERT INTO public.who_global_data VALUES (22, 0, 4119, 0, 54, 1, 33);
INSERT INTO public.who_global_data VALUES (23, 0, 692, 0, 12, 1, 183);
INSERT INTO public.who_global_data VALUES (24, 0, 859, 0, 1, 1, 92);
INSERT INTO public.who_global_data VALUES (25, 2021, 222447, 58, 10571, 1, 158);
INSERT INTO public.who_global_data VALUES (26, 0, 366, 0, 3, 1, 67);
INSERT INTO public.who_global_data VALUES (27, 314, 123142, 16, 4761, 1, 57);
INSERT INTO public.who_global_data VALUES (28, 0, 22738, 0, 148, 1, 38);
INSERT INTO public.who_global_data VALUES (29, 56002, 9339420, 1254, 227563, 1, 141);
INSERT INTO public.who_global_data VALUES (30, 0, 141, 0, 1, 1, 178);
INSERT INTO public.who_global_data VALUES (31, 0, 180, 0, 3, 1, 108);
INSERT INTO public.who_global_data VALUES (32, 883, 222149, 54, 9272, 1, 39);
INSERT INTO public.who_global_data VALUES (33, 95, 11053, 5, 132, 1, 2);
INSERT INTO public.who_global_data VALUES (34, 12, 1698, 1, 3, 1, 195);
INSERT INTO public.who_global_data VALUES (35, 138, 14290, 1, 135, 1, 107);
INSERT INTO public.who_global_data VALUES (36, 3, 470, 0, 0, 1, 161);
INSERT INTO public.who_global_data VALUES (37, 0, 30313, 0, 474, 1, 212);
INSERT INTO public.who_global_data VALUES (38, 3234, 789651, 142, 20355, 1, 181);
INSERT INTO public.who_global_data VALUES (39, 0, 400, 0, 2, 1, 53);
INSERT INTO public.who_global_data VALUES (40, 0, 4989, 0, 63, 1, 164);
INSERT INTO public.who_global_data VALUES (41, 14, 3433, 0, 121, 1, 140);
INSERT INTO public.who_global_data VALUES (42, 3592, 740237, 155, 18731, 1, 20);
INSERT INTO public.who_global_data VALUES (43, 44, 101187, 2, 4831, 1, 112);
INSERT INTO public.who_global_data VALUES (44, 11025, 2125622, 301, 54877, 1, 111);
INSERT INTO public.who_global_data VALUES (45, 83, 2975, 1, 105, 1, 71);
INSERT INTO public.who_global_data VALUES (46, 0, 8060, 0, 122, 1, 218);
INSERT INTO public.who_global_data VALUES (47, 0, 0, 0, 0, 1, 43);
INSERT INTO public.who_global_data VALUES (48, 528, 195537, 9, 2650, 1, 49);
INSERT INTO public.who_global_data VALUES (49, 363, 29102, 0, 158, 1, 1);
INSERT INTO public.who_global_data VALUES (50, 549, 234702, 16, 5122, 1, 48);
INSERT INTO public.who_global_data VALUES (51, 816, 30345, 5, 225, 1, 232);
INSERT INTO public.who_global_data VALUES (52, 4, 4595, 0, 21, 1, 175);
INSERT INTO public.who_global_data VALUES (53, 116, 31379, 5, 208, 1, 21);
INSERT INTO public.who_global_data VALUES (54, 8125, 1021477, 150, 16976, 1, 156);
INSERT INTO public.who_global_data VALUES (55, 0, 0, 0, 0, 1, 95);
INSERT INTO public.who_global_data VALUES (56, 30, 23211, 3, 677, 1, 177);
INSERT INTO public.who_global_data VALUES (57, 553, 200335, 14, 2184, 1, 210);
INSERT INTO public.who_global_data VALUES (58, 0, 5936, 0, 63, 1, 120);
INSERT INTO public.who_global_data VALUES (59, 0, 121, 0, 0, 1, 135);
INSERT INTO public.who_global_data VALUES (60, 1671, 218948, 28, 2747, 1, 206);
INSERT INTO public.who_global_data VALUES (61, 949, 253339, 19, 14968, 1, 189);
INSERT INTO public.who_global_data VALUES (62, 532, 168057, 52, 9512, 1, 129);
INSERT INTO public.who_global_data VALUES (63, 198, 55821, 7, 1653, 1, 121);
INSERT INTO public.who_global_data VALUES (64, 0, 5534, 0, 86, 1, 59);
INSERT INTO public.who_global_data VALUES (65, 0, 2309, 0, 7, 1, 96);
INSERT INTO public.who_global_data VALUES (66, 591, 46925, 4, 447, 1, 41);
INSERT INTO public.who_global_data VALUES (67, 71, 16045, 6, 591, 1, 216);
INSERT INTO public.who_global_data VALUES (68, 749, 140157, 4, 2126, 1, 236);
INSERT INTO public.who_global_data VALUES (69, 0, 41, 0, 0, 1, 150);
INSERT INTO public.who_global_data VALUES (70, 1, 655, 0, 1, 1, 61);
INSERT INTO public.who_global_data VALUES (71, 0, 56, 0, 2, 1, 7);
INSERT INTO public.who_global_data VALUES (72, 444, 46493, 3, 688, 1, 169);
INSERT INTO public.who_global_data VALUES (73, 23148, 3221178, 355, 77548, 1, 28);
INSERT INTO public.who_global_data VALUES (74, 46, 16264, 1, 79, 1, 85);
INSERT INTO public.who_global_data VALUES (75, 20, 18165, 0, 133, 1, 211);
INSERT INTO public.who_global_data VALUES (76, 0, 11129, 0, 70, 1, 60);
INSERT INTO public.who_global_data VALUES (77, 0, 4184, 0, 132, 1, 3);
INSERT INTO public.who_global_data VALUES (78, 538, 261018, 18, 3258, 1, 11);
INSERT INTO public.who_global_data VALUES (79, 12908, 2264909, 855, 60597, 1, 89);
INSERT INTO public.who_global_data VALUES (80, 777, 68559, 9, 433, 1, 24);
INSERT INTO public.who_global_data VALUES (81, 13, 4156, 0, 79, 1, 162);
INSERT INTO public.who_global_data VALUES (82, 1069, 160935, 25, 5903, 1, 100);
INSERT INTO public.who_global_data VALUES (83, 0, 30, 0, 0, 1, 47);
INSERT INTO public.who_global_data VALUES (84, 0, 148, 0, 1, 1, 29);
INSERT INTO public.who_global_data VALUES (85, 0, 9156, 0, 158, 1, 40);
INSERT INTO public.who_global_data VALUES (86, 4, 7415, 0, 129, 1, 222);
INSERT INTO public.who_global_data VALUES (87, 699, 161665, 49, 5785, 1, 132);
INSERT INTO public.who_global_data VALUES (88, 36, 651, 0, 13, 1, 130);
INSERT INTO public.who_global_data VALUES (89, 61, 14629, 1, 84, 1, 234);
INSERT INTO public.who_global_data VALUES (90, 31, 2693, 1, 46, 1, 23);
INSERT INTO public.who_global_data VALUES (91, 36, 7714, 0, 177, 1, 192);
INSERT INTO public.who_global_data VALUES (92, 0, 11692, 0, 245, 1, 69);
INSERT INTO public.who_global_data VALUES (93, 0, 26, 0, 0, 1, 187);
INSERT INTO public.who_global_data VALUES (94, 1312, 151103, 24, 3662, 1, 230);
INSERT INTO public.who_global_data VALUES (95, 1576, 373564, 98, 12930, 1, 77);
INSERT INTO public.who_global_data VALUES (96, 3, 6016, 0, 29, 1, 9);
INSERT INTO public.who_global_data VALUES (97, 12408, 10802591, 120, 154823, 1, 74);
INSERT INTO public.who_global_data VALUES (98, 11434, 1123105, 231, 31001, 1, 224);
INSERT INTO public.who_global_data VALUES (99, 7040, 1445326, 67, 58256, 1, 199);
INSERT INTO public.who_global_data VALUES (100, 1150, 624222, 12, 13091, 1, 190);
INSERT INTO public.who_global_data VALUES (101, 1314, 200744, 74, 3586, 1, 12);
INSERT INTO public.who_global_data VALUES (102, 0, 434, 0, 25, 1, 104);
INSERT INTO public.who_global_data VALUES (103, 0, 645590, 0, 4806, 1, 153);
INSERT INTO public.who_global_data VALUES (104, 13656, 2597446, 421, 90241, 1, 91);
INSERT INTO public.who_global_data VALUES (105, 177, 16250, 0, 355, 1, 215);
INSERT INTO public.who_global_data VALUES (106, 2619, 399048, 115, 6135, 1, 84);
INSERT INTO public.who_global_data VALUES (107, 4, 3165, 0, 67, 1, 231);
INSERT INTO public.who_global_data VALUES (108, 1294, 331768, 10, 4354, 1, 196);
INSERT INTO public.who_global_data VALUES (109, 0, 240983, 0, 3126, 1, 105);
INSERT INTO public.who_global_data VALUES (110, 180, 101339, 4, 1773, 1, 122);
INSERT INTO public.who_global_data VALUES (111, 0, 0, 0, 0, 1, 159);
INSERT INTO public.who_global_data VALUES (112, 318, 61337, 5, 1504, 1, 75);
INSERT INTO public.who_global_data VALUES (113, 840, 168250, 1, 962, 1, 27);
INSERT INTO public.who_global_data VALUES (114, 88, 84920, 2, 1420, 1, 54);
INSERT INTO public.who_global_data VALUES (115, 0, 45, 0, 0, 1, 226);
INSERT INTO public.who_global_data VALUES (116, 742, 69400, 31, 1281, 1, 79);
INSERT INTO public.who_global_data VALUES (117, 3107, 312269, 82, 3397, 1, 56);
INSERT INTO public.who_global_data VALUES (118, 0, 8969, 0, 178, 1, 117);
INSERT INTO public.who_global_data VALUES (119, 0, 1945, 0, 84, 1, 152);
INSERT INTO public.who_global_data VALUES (120, 770, 122013, 5, 1919, 1, 16);
INSERT INTO public.who_global_data VALUES (121, 6, 2586, 0, 46, 1, 10);
INSERT INTO public.who_global_data VALUES (122, 653, 185601, 23, 2908, 1, 201);
INSERT INTO public.who_global_data VALUES (123, 202, 51330, 1, 588, 1, 174);
INSERT INTO public.who_global_data VALUES (124, 0, 19065, 0, 281, 1, 119);
INSERT INTO public.who_global_data VALUES (125, 435, 25884, 18, 779, 1, 168);
INSERT INTO public.who_global_data VALUES (126, 4571, 231483, 17, 826, 1, 99);
INSERT INTO public.who_global_data VALUES (127, 134, 16410, 1, 54, 1, 171);
INSERT INTO public.who_global_data VALUES (128, 11, 8130, 0, 333, 1, 87);
INSERT INTO public.who_global_data VALUES (129, 57, 18442, 4, 277, 1, 123);
INSERT INTO public.who_global_data VALUES (130, 0, 4, 0, 0, 1, 151);
INSERT INTO public.who_global_data VALUES (131, 0, 6442, 0, 45, 1, 213);
INSERT INTO public.who_global_data VALUES (132, 0, 16662, 0, 422, 1, 118);
INSERT INTO public.who_global_data VALUES (133, 0, 584, 0, 10, 1, 134);
INSERT INTO public.who_global_data VALUES (134, 254, 9546, 1, 63, 1, 65);
INSERT INTO public.who_global_data VALUES (135, 12153, 1886245, 1707, 161240, 1, 102);
INSERT INTO public.who_global_data VALUES (136, 0, 0, 0, 0, 1, 223);
INSERT INTO public.who_global_data VALUES (137, 24, 1596, 0, 18, 1, 4);
INSERT INTO public.who_global_data VALUES (138, 31, 1890, 0, 2, 1, 146);
INSERT INTO public.who_global_data VALUES (139, 0, 64007, 0, 826, 1, 31);
INSERT INTO public.who_global_data VALUES (140, 0, 13, 0, 1, 1, 127);
INSERT INTO public.who_global_data VALUES (141, 620, 473667, 28, 8351, 1, 22);
INSERT INTO public.who_global_data VALUES (142, 1055, 42488, 12, 427, 1, 115);
INSERT INTO public.who_global_data VALUES (143, 177, 141104, 3, 3163, 1, 106);
INSERT INTO public.who_global_data VALUES (144, 147, 34519, 5, 364, 1, 90);
INSERT INTO public.who_global_data VALUES (145, 0, 0, 0, 0, 1, 70);
INSERT INTO public.who_global_data VALUES (146, 171, 271602, 2, 2033, 1, 46);
INSERT INTO public.who_global_data VALUES (147, 4246, 993430, 67, 14234, 1, 139);
INSERT INTO public.who_global_data VALUES (148, 0, 47, 0, 0, 1, 42);
INSERT INTO public.who_global_data VALUES (149, 2, 1959, 0, 25, 1, 80);
INSERT INTO public.who_global_data VALUES (150, 0, 5027, 0, 170, 1, 203);
INSERT INTO public.who_global_data VALUES (151, 10, 4575, 1, 164, 1, 136);
INSERT INTO public.who_global_data VALUES (152, 1340, 136030, 14, 1632, 1, 63);
INSERT INTO public.who_global_data VALUES (153, 0, 0, 0, 0, 1, 17);
INSERT INTO public.who_global_data VALUES (154, 0, 133, 0, 2, 1, 172);
INSERT INTO public.who_global_data VALUES (155, 372, 93882, 7, 2900, 1, 109);
INSERT INTO public.who_global_data VALUES (156, 284, 63837, 8, 582, 1, 200);
INSERT INTO public.who_global_data VALUES (157, 661, 181349, 8, 2050, 1, 93);
INSERT INTO public.who_global_data VALUES (158, 185, 135041, 0, 1532, 1, 5);
INSERT INTO public.who_global_data VALUES (159, 0, 745, 0, 13, 1, 214);
INSERT INTO public.who_global_data VALUES (160, 1508, 550540, 31, 11833, 1, 204);
INSERT INTO public.who_global_data VALUES (161, 0, 0, 0, 0, 1, 198);
INSERT INTO public.who_global_data VALUES (162, 1181, 323382, 27, 5366, 1, 173);
INSERT INTO public.who_global_data VALUES (163, 24, 891, 0, 9, 1, 229);
INSERT INTO public.who_global_data VALUES (164, 747, 135229, 15, 2765, 1, 76);
INSERT INTO public.who_global_data VALUES (165, 8573, 1158337, 184, 41538, 1, 138);
INSERT INTO public.who_global_data VALUES (166, 1581, 531699, 55, 10997, 1, 98);
INSERT INTO public.who_global_data VALUES (167, 0, 0, 0, 0, 1, 103);
INSERT INTO public.who_global_data VALUES (168, 6053, 1539564, 368, 38712, 1, 225);
INSERT INTO public.who_global_data VALUES (169, 7914, 748858, 225, 13482, 1, 131);
INSERT INTO public.who_global_data VALUES (170, 322, 94984, 8, 1861, 1, 235);
INSERT INTO public.who_global_data VALUES (171, 407, 152898, 0, 249, 1, 137);
INSERT INTO public.who_global_data VALUES (172, 370, 80131, 11, 1459, 1, 81);
INSERT INTO public.who_global_data VALUES (173, 982, 162624, 17, 3497, 1, 182);
INSERT INTO public.who_global_data VALUES (174, 0, 10330, 0, 47, 1, 145);
INSERT INTO public.who_global_data VALUES (175, 2668, 738152, 75, 18675, 1, 26);
INSERT INTO public.who_global_data VALUES (176, 16688, 3934606, 527, 75732, 1, 170);
INSERT INTO public.who_global_data VALUES (177, 154, 15988, 2, 210, 1, 191);
INSERT INTO public.who_global_data VALUES (178, 0, 6, 0, 0, 1, 221);
INSERT INTO public.who_global_data VALUES (179, 0, 379, 0, 0, 1, 64);
INSERT INTO public.who_global_data VALUES (180, 0, 0, 0, 0, 1, 116);
INSERT INTO public.who_global_data VALUES (181, 0, 39, 0, 0, 1, 128);
INSERT INTO public.who_global_data VALUES (182, 77, 1556, 2, 18, 1, 6);
INSERT INTO public.who_global_data VALUES (183, 0, 1289, 0, 12, 1, 227);
INSERT INTO public.who_global_data VALUES (184, 0, 24, 0, 0, 1, 68);
INSERT INTO public.who_global_data VALUES (185, 8, 1067, 1, 3, 1, 184);
INSERT INTO public.who_global_data VALUES (186, 0, 3, 0, 0, 1, 82);
INSERT INTO public.who_global_data VALUES (187, 14, 3125, 0, 68, 1, 149);
INSERT INTO public.who_global_data VALUES (188, 0, 1275, 0, 17, 1, 197);
INSERT INTO public.who_global_data VALUES (189, 303, 369248, 3, 6389, 1, 78);
INSERT INTO public.who_global_data VALUES (190, 368, 27733, 11, 659, 1, 233);
INSERT INTO public.who_global_data VALUES (191, 1863, 402700, 14, 4085, 1, 133);
INSERT INTO public.who_global_data VALUES (192, 36, 1279, 0, 5, 1, 35);
INSERT INTO public.who_global_data VALUES (193, 29, 3728, 0, 79, 1, 114);
INSERT INTO public.who_global_data VALUES (194, 22, 59624, 0, 29, 1, 237);
INSERT INTO public.who_global_data VALUES (195, 0, 20, 0, 0, 1, 55);
INSERT INTO public.who_global_data VALUES (196, 14, 1899, 0, 27, 1, 176);
INSERT INTO public.who_global_data VALUES (197, 2630, 259533, 74, 5050, 1, 202);
INSERT INTO public.who_global_data VALUES (198, 869, 172209, 24, 3857, 1, 155);
INSERT INTO public.who_global_data VALUES (199, 0, 17, 0, 0, 1, 32);
INSERT INTO public.who_global_data VALUES (200, 0, 4814, 0, 132, 1, 220);
INSERT INTO public.who_global_data VALUES (201, 3751, 1466767, 261, 45605, 1, 30);
INSERT INTO public.who_global_data VALUES (202, 0, 4106, 0, 65, 1, 147);
INSERT INTO public.who_global_data VALUES (203, 11388, 2913425, 85, 60802, 1, 208);
INSERT INTO public.who_global_data VALUES (204, 706, 67115, 7, 339, 1, 45);
INSERT INTO public.who_global_data VALUES (205, 57, 29634, 1, 1831, 1, 110);
INSERT INTO public.who_global_data VALUES (206, 59, 8556, 0, 156, 1, 88);
INSERT INTO public.who_global_data VALUES (207, 3745, 584674, 2, 12028, 1, 51);
INSERT INTO public.who_global_data VALUES (208, 1759, 527703, 23, 8790, 1, 209);
INSERT INTO public.who_global_data VALUES (209, 65, 14267, 5, 938, 1, 205);
INSERT INTO public.who_global_data VALUES (210, 0, 13714, 0, 91, 1, 18);
INSERT INTO public.who_global_data VALUES (211, 586, 22644, 0, 79, 1, 72);
INSERT INTO public.who_global_data VALUES (212, 20634, 3892463, 915, 110250, 1, 44);
INSERT INTO public.who_global_data VALUES (213, 0, 80, 0, 0, 1, 15);
INSERT INTO public.who_global_data VALUES (214, 66, 5290, 0, 79, 1, 25);
INSERT INTO public.who_global_data VALUES (215, 0, 0, 0, 0, 1, 179);
INSERT INTO public.who_global_data VALUES (216, 0, 0, 0, 0, 1, 34);
INSERT INTO public.who_global_data VALUES (217, 8, 7586, 1, 135, 1, 207);
INSERT INTO public.who_global_data VALUES (218, 1270, 213949, 68, 7048, 1, 166);
INSERT INTO public.who_global_data VALUES (219, 7909, 2508988, 113, 26467, 1, 126);
INSERT INTO public.who_global_data VALUES (220, 0, 0, 0, 0, 1, 97);
INSERT INTO public.who_global_data VALUES (221, 49, 1553, 0, 9, 1, 36);
INSERT INTO public.who_global_data VALUES (222, 0, 0, 0, 0, 1, 125);
INSERT INTO public.who_global_data VALUES (223, 50, 39735, 0, 327, 1, 124);
INSERT INTO public.who_global_data VALUES (224, 4923, 1237169, 158, 23387, 1, 185);
INSERT INTO public.who_global_data VALUES (225, 3249, 316875, 10, 888, 1, 194);
INSERT INTO public.who_global_data VALUES (226, 0, 509, 0, 21, 1, 144);
INSERT INTO public.who_global_data VALUES (227, 0, 26172274, 0, 443256, 1, 19);
INSERT INTO public.who_global_data VALUES (228, 10, 2440, 0, 24, 1, 217);
INSERT INTO public.who_global_data VALUES (229, 548, 43215, 11, 464, 1, 148);
INSERT INTO public.who_global_data VALUES (230, 73, 78989, 0, 621, 1, 86);
INSERT INTO public.who_global_data VALUES (231, 0, 1, 0, 0, 1, 13);
INSERT INTO public.who_global_data VALUES (232, 563, 128315, 7, 1209, 1, 157);
INSERT INTO public.who_global_data VALUES (233, 9, 1957, 0, 35, 1, 8);
INSERT INTO public.who_global_data VALUES (234, 0, 5, 0, 0, 1, 73);
INSERT INTO public.who_global_data VALUES (235, 0, 2126, 0, 616, 1, 101);
INSERT INTO public.who_global_data VALUES (236, 1514, 59003, 8, 812, 1, 165);
INSERT INTO public.who_global_data VALUES (237, 207, 34171, 19, 1288, 1, 14);
INSERT INTO public.who_global_data VALUES (238, 57, 55231, 1, 2407, 2, 193);
INSERT INTO public.who_global_data VALUES (239, 1007, 80941, 6, 1404, 2, 113);
INSERT INTO public.who_global_data VALUES (240, 275, 108116, 2, 2900, 2, 143);
INSERT INTO public.who_global_data VALUES (241, 0, 0, 0, 0, 2, 219);
INSERT INTO public.who_global_data VALUES (242, 53, 10070, 1, 103, 2, 186);
INSERT INTO public.who_global_data VALUES (243, 37, 19937, 2, 470, 2, 52);
INSERT INTO public.who_global_data VALUES (244, 0, 17, 0, 0, 2, 180);
INSERT INTO public.who_global_data VALUES (245, 15, 249, 0, 7, 2, 167);
INSERT INTO public.who_global_data VALUES (246, 9695, 1943548, 177, 48426, 2, 154);
INSERT INTO public.who_global_data VALUES (247, 147, 167568, 11, 3107, 2, 94);
INSERT INTO public.who_global_data VALUES (248, 42, 7028, 0, 59, 2, 66);
INSERT INTO public.who_global_data VALUES (249, 5, 28829, 0, 909, 2, 58);
INSERT INTO public.who_global_data VALUES (250, 1686, 414925, 51, 7800, 2, 163);
INSERT INTO public.who_global_data VALUES (251, 162, 230617, 4, 3145, 2, 37);
INSERT INTO public.who_global_data VALUES (252, 6, 8231, 0, 176, 2, 142);
INSERT INTO public.who_global_data VALUES (253, 553, 104792, 0, 376, 2, 83);
INSERT INTO public.who_global_data VALUES (254, 438, 536545, 13, 8162, 2, 228);
INSERT INTO public.who_global_data VALUES (255, 28, 1586, 0, 14, 2, 188);
INSERT INTO public.who_global_data VALUES (256, 1711, 251705, 9, 1746, 2, 62);
INSERT INTO public.who_global_data VALUES (257, 1052, 718847, 32, 21260, 2, 160);
INSERT INTO public.who_global_data VALUES (258, 12, 11957, 1, 303, 2, 50);
INSERT INTO public.who_global_data VALUES (259, 0, 4119, 0, 54, 2, 33);
INSERT INTO public.who_global_data VALUES (260, 0, 692, 0, 12, 2, 183);
INSERT INTO public.who_global_data VALUES (261, 0, 859, 0, 1, 2, 92);
INSERT INTO public.who_global_data VALUES (262, 2127, 220426, 74, 10513, 2, 158);
INSERT INTO public.who_global_data VALUES (263, 0, 366, 0, 3, 2, 67);
INSERT INTO public.who_global_data VALUES (264, 367, 122828, 8, 4745, 2, 57);
INSERT INTO public.who_global_data VALUES (265, 1445, 22738, 0, 148, 2, 38);
INSERT INTO public.who_global_data VALUES (266, 54096, 9283418, 1210, 226309, 2, 141);
INSERT INTO public.who_global_data VALUES (267, 0, 141, 0, 1, 2, 178);
INSERT INTO public.who_global_data VALUES (268, 0, 180, 0, 3, 2, 108);
INSERT INTO public.who_global_data VALUES (269, 719, 221266, 40, 9218, 2, 39);
INSERT INTO public.who_global_data VALUES (270, 54, 10958, 1, 127, 2, 2);
INSERT INTO public.who_global_data VALUES (271, 22, 1686, 0, 2, 2, 195);
INSERT INTO public.who_global_data VALUES (272, 0, 14152, 0, 134, 2, 107);
INSERT INTO public.who_global_data VALUES (273, 1, 467, 0, 0, 2, 161);
INSERT INTO public.who_global_data VALUES (274, 0, 30313, 0, 474, 2, 212);
INSERT INTO public.who_global_data VALUES (275, 2828, 786417, 77, 20213, 2, 181);
INSERT INTO public.who_global_data VALUES (276, 2, 400, 0, 2, 2, 53);
INSERT INTO public.who_global_data VALUES (277, 0, 4989, 0, 63, 2, 164);
INSERT INTO public.who_global_data VALUES (278, 15, 3419, 0, 121, 2, 140);
INSERT INTO public.who_global_data VALUES (279, 2610, 736645, 17, 18576, 2, 20);
INSERT INTO public.who_global_data VALUES (280, 51, 101143, 1, 4829, 2, 112);
INSERT INTO public.who_global_data VALUES (281, 10091, 2114597, 304, 54576, 2, 111);
INSERT INTO public.who_global_data VALUES (282, 44, 2892, 4, 104, 2, 71);
INSERT INTO public.who_global_data VALUES (283, 173, 8060, 5, 122, 2, 218);
INSERT INTO public.who_global_data VALUES (284, 0, 0, 0, 0, 2, 43);
INSERT INTO public.who_global_data VALUES (285, 440, 195009, 7, 2641, 2, 49);
INSERT INTO public.who_global_data VALUES (286, 132, 28739, 0, 158, 2, 1);
INSERT INTO public.who_global_data VALUES (287, 516, 234153, 18, 5106, 2, 48);
INSERT INTO public.who_global_data VALUES (288, 893, 29529, 2, 220, 2, 232);
INSERT INTO public.who_global_data VALUES (289, 6, 4591, 0, 21, 2, 175);
INSERT INTO public.who_global_data VALUES (290, 139, 31263, 1, 203, 2, 21);
INSERT INTO public.who_global_data VALUES (291, 9695, 1013352, 143, 16826, 2, 156);
INSERT INTO public.who_global_data VALUES (292, 0, 0, 0, 0, 2, 95);
INSERT INTO public.who_global_data VALUES (293, 139, 23181, 0, 674, 2, 177);
INSERT INTO public.who_global_data VALUES (294, 425, 199782, 10, 2170, 2, 210);
INSERT INTO public.who_global_data VALUES (295, 1, 5936, 0, 63, 2, 120);
INSERT INTO public.who_global_data VALUES (296, 0, 121, 0, 0, 2, 135);
INSERT INTO public.who_global_data VALUES (297, 1357, 217277, 15, 2719, 2, 206);
INSERT INTO public.who_global_data VALUES (298, 1111, 252390, 34, 14949, 2, 189);
INSERT INTO public.who_global_data VALUES (299, 512, 167525, 53, 9460, 2, 129);
INSERT INTO public.who_global_data VALUES (300, 428, 55623, 8, 1646, 2, 121);
INSERT INTO public.who_global_data VALUES (301, 0, 5534, 0, 86, 2, 59);
INSERT INTO public.who_global_data VALUES (302, 42, 2309, 0, 7, 2, 96);
INSERT INTO public.who_global_data VALUES (303, 671, 46334, 10, 443, 2, 41);
INSERT INTO public.who_global_data VALUES (304, 96, 15974, 2, 585, 2, 216);
INSERT INTO public.who_global_data VALUES (305, 547, 139408, 6, 2122, 2, 236);
INSERT INTO public.who_global_data VALUES (306, 0, 41, 0, 0, 2, 150);
INSERT INTO public.who_global_data VALUES (307, 0, 654, 0, 1, 2, 61);
INSERT INTO public.who_global_data VALUES (308, 1, 56, 0, 2, 2, 7);
INSERT INTO public.who_global_data VALUES (309, 265, 46049, 1, 685, 2, 169);
INSERT INTO public.who_global_data VALUES (310, 25904, 3198030, 353, 77193, 2, 28);
INSERT INTO public.who_global_data VALUES (311, 33, 16218, 2, 78, 2, 85);
INSERT INTO public.who_global_data VALUES (312, 24, 18145, 0, 133, 2, 211);
INSERT INTO public.who_global_data VALUES (313, 177, 11129, 2, 70, 2, 60);
INSERT INTO public.who_global_data VALUES (314, 45, 4184, 1, 132, 2, 3);
INSERT INTO public.who_global_data VALUES (315, 583, 260480, 19, 3240, 2, 11);
INSERT INTO public.who_global_data VALUES (316, 14211, 2252001, 786, 59742, 2, 89);
INSERT INTO public.who_global_data VALUES (317, 0, 67782, 0, 424, 2, 24);
INSERT INTO public.who_global_data VALUES (318, 15, 4143, 1, 79, 2, 162);
INSERT INTO public.who_global_data VALUES (319, 1150, 159866, 27, 5878, 2, 100);
INSERT INTO public.who_global_data VALUES (320, 0, 30, 0, 0, 2, 47);
INSERT INTO public.who_global_data VALUES (321, 0, 148, 0, 1, 2, 29);
INSERT INTO public.who_global_data VALUES (322, 0, 9156, 0, 158, 2, 40);
INSERT INTO public.who_global_data VALUES (323, 8, 7411, 0, 129, 2, 222);
INSERT INTO public.who_global_data VALUES (324, 667, 160966, 27, 5736, 2, 132);
INSERT INTO public.who_global_data VALUES (325, 30, 615, 0, 13, 2, 130);
INSERT INTO public.who_global_data VALUES (326, 13, 14568, 0, 83, 2, 234);
INSERT INTO public.who_global_data VALUES (327, 7, 2662, 0, 45, 2, 23);
INSERT INTO public.who_global_data VALUES (328, 24, 7678, 0, 177, 2, 192);
INSERT INTO public.who_global_data VALUES (329, 20, 11692, 0, 245, 2, 69);
INSERT INTO public.who_global_data VALUES (330, 0, 26, 0, 0, 2, 187);
INSERT INTO public.who_global_data VALUES (331, 840, 149791, 24, 3638, 2, 230);
INSERT INTO public.who_global_data VALUES (332, 1652, 371988, 93, 12832, 2, 77);
INSERT INTO public.who_global_data VALUES (333, 2, 6013, 0, 29, 2, 9);
INSERT INTO public.who_global_data VALUES (334, 12899, 10790183, 107, 154703, 2, 74);
INSERT INTO public.who_global_data VALUES (335, 11984, 1111671, 189, 30770, 2, 224);
INSERT INTO public.who_global_data VALUES (336, 6870, 1438286, 79, 58189, 2, 199);
INSERT INTO public.who_global_data VALUES (337, 1317, 623072, 11, 13079, 2, 190);
INSERT INTO public.who_global_data VALUES (338, 1006, 199430, 94, 3512, 2, 12);
INSERT INTO public.who_global_data VALUES (339, 0, 434, 0, 25, 2, 104);
INSERT INTO public.who_global_data VALUES (340, 0, 645590, 0, 4806, 2, 153);
INSERT INTO public.who_global_data VALUES (341, 13182, 2583790, 476, 89820, 2, 91);
INSERT INTO public.who_global_data VALUES (342, 100, 16073, 2, 355, 2, 215);
INSERT INTO public.who_global_data VALUES (343, 2593, 396429, 108, 6020, 2, 84);
INSERT INTO public.who_global_data VALUES (344, 7, 3161, 1, 67, 2, 231);
INSERT INTO public.who_global_data VALUES (345, 1280, 330474, 10, 4344, 2, 196);
INSERT INTO public.who_global_data VALUES (346, 1257, 240983, 0, 3126, 2, 105);
INSERT INTO public.who_global_data VALUES (347, 150, 101159, 3, 1769, 2, 122);
INSERT INTO public.who_global_data VALUES (348, 0, 0, 0, 0, 2, 159);
INSERT INTO public.who_global_data VALUES (349, 314, 61019, 3, 1499, 2, 75);
INSERT INTO public.who_global_data VALUES (350, 756, 167410, 2, 961, 2, 27);
INSERT INTO public.who_global_data VALUES (351, 70, 84832, 3, 1418, 2, 54);
INSERT INTO public.who_global_data VALUES (352, 1, 45, 0, 0, 2, 226);
INSERT INTO public.who_global_data VALUES (353, 1231, 68658, 31, 1250, 2, 79);
INSERT INTO public.who_global_data VALUES (354, 3320, 309162, 89, 3315, 2, 56);
INSERT INTO public.who_global_data VALUES (355, 69, 8969, 6, 178, 2, 117);
INSERT INTO public.who_global_data VALUES (356, 1, 1945, 0, 84, 2, 152);
INSERT INTO public.who_global_data VALUES (357, 809, 121243, 18, 1914, 2, 16);
INSERT INTO public.who_global_data VALUES (358, 1, 2580, 0, 46, 2, 10);
INSERT INTO public.who_global_data VALUES (359, 740, 184948, 18, 2885, 2, 201);
INSERT INTO public.who_global_data VALUES (360, 205, 51128, 1, 587, 2, 174);
INSERT INTO public.who_global_data VALUES (361, 0, 19065, 0, 281, 2, 119);
INSERT INTO public.who_global_data VALUES (362, 546, 25449, 35, 761, 2, 168);
INSERT INTO public.who_global_data VALUES (363, 4284, 226912, 18, 809, 2, 99);
INSERT INTO public.who_global_data VALUES (364, 121, 16276, 1, 53, 2, 171);
INSERT INTO public.who_global_data VALUES (365, 8, 8119, 0, 333, 2, 87);
INSERT INTO public.who_global_data VALUES (366, 79, 18385, 0, 273, 2, 123);
INSERT INTO public.who_global_data VALUES (367, 0, 4, 0, 0, 2, 151);
INSERT INTO public.who_global_data VALUES (368, 0, 6442, 0, 45, 2, 213);
INSERT INTO public.who_global_data VALUES (369, 202, 16662, 4, 422, 2, 118);
INSERT INTO public.who_global_data VALUES (370, 1, 584, 0, 10, 2, 134);
INSERT INTO public.who_global_data VALUES (371, 289, 9292, 1, 62, 2, 65);
INSERT INTO public.who_global_data VALUES (372, 4384, 1874092, 433, 159533, 2, 102);
INSERT INTO public.who_global_data VALUES (373, 0, 0, 0, 0, 2, 223);
INSERT INTO public.who_global_data VALUES (374, 29, 1572, 1, 18, 2, 4);
INSERT INTO public.who_global_data VALUES (375, 27, 1859, 0, 2, 2, 146);
INSERT INTO public.who_global_data VALUES (376, 383, 64007, 1, 826, 2, 31);
INSERT INTO public.who_global_data VALUES (377, 0, 13, 0, 1, 2, 127);
INSERT INTO public.who_global_data VALUES (378, 774, 473047, 14, 8323, 2, 22);
INSERT INTO public.who_global_data VALUES (379, 1173, 41433, 12, 415, 2, 115);
INSERT INTO public.who_global_data VALUES (380, 263, 140927, 14, 3160, 2, 106);
INSERT INTO public.who_global_data VALUES (381, 102, 34372, 4, 359, 2, 90);
INSERT INTO public.who_global_data VALUES (382, 0, 0, 0, 0, 2, 70);
INSERT INTO public.who_global_data VALUES (383, 142, 271431, 1, 2031, 2, 46);
INSERT INTO public.who_global_data VALUES (384, 4038, 989184, 62, 14167, 2, 139);
INSERT INTO public.who_global_data VALUES (385, 0, 47, 0, 0, 2, 42);
INSERT INTO public.who_global_data VALUES (386, 6, 1957, 0, 25, 2, 80);
INSERT INTO public.who_global_data VALUES (387, 0, 5027, 0, 170, 2, 203);
INSERT INTO public.who_global_data VALUES (388, 17, 4565, 1, 163, 2, 136);
INSERT INTO public.who_global_data VALUES (389, 1138, 134690, 5, 1618, 2, 63);
INSERT INTO public.who_global_data VALUES (390, 0, 0, 0, 0, 2, 17);
INSERT INTO public.who_global_data VALUES (391, 0, 133, 0, 2, 2, 172);
INSERT INTO public.who_global_data VALUES (392, 350, 93510, 20, 2893, 2, 109);
INSERT INTO public.who_global_data VALUES (393, 293, 63553, 6, 574, 2, 200);
INSERT INTO public.who_global_data VALUES (394, 670, 180688, 10, 2042, 2, 93);
INSERT INTO public.who_global_data VALUES (395, 171, 134856, 0, 1532, 2, 5);
INSERT INTO public.who_global_data VALUES (396, 0, 745, 0, 13, 2, 214);
INSERT INTO public.who_global_data VALUES (397, 1384, 549032, 56, 11802, 2, 204);
INSERT INTO public.who_global_data VALUES (398, 0, 0, 0, 0, 2, 198);
INSERT INTO public.who_global_data VALUES (399, 1098, 322201, 43, 5339, 2, 173);
INSERT INTO public.who_global_data VALUES (400, 0, 867, 0, 9, 2, 229);
INSERT INTO public.who_global_data VALUES (401, 701, 134482, 17, 2750, 2, 76);
INSERT INTO public.who_global_data VALUES (402, 7048, 1149764, 173, 41354, 2, 138);
INSERT INTO public.who_global_data VALUES (403, 1265, 530118, 68, 10942, 2, 98);
INSERT INTO public.who_global_data VALUES (404, 0, 0, 0, 0, 2, 103);
INSERT INTO public.who_global_data VALUES (405, 6495, 1533511, 447, 38344, 2, 225);
INSERT INTO public.who_global_data VALUES (406, 9083, 740944, 240, 13257, 2, 131);
INSERT INTO public.who_global_data VALUES (407, 136, 94662, 7, 1853, 2, 235);
INSERT INTO public.who_global_data VALUES (408, 396, 152491, 0, 249, 2, 137);
INSERT INTO public.who_global_data VALUES (409, 451, 79761, 7, 1448, 2, 81);
INSERT INTO public.who_global_data VALUES (410, 917, 161642, 18, 3480, 2, 182);
INSERT INTO public.who_global_data VALUES (411, 136, 10330, 1, 47, 2, 145);
INSERT INTO public.who_global_data VALUES (412, 2752, 735484, 87, 18600, 2, 26);
INSERT INTO public.who_global_data VALUES (413, 16714, 3917918, 521, 75205, 2, 170);
INSERT INTO public.who_global_data VALUES (414, 146, 15834, 3, 208, 2, 191);
INSERT INTO public.who_global_data VALUES (415, 0, 6, 0, 0, 2, 221);
INSERT INTO public.who_global_data VALUES (416, 0, 379, 0, 0, 2, 64);
INSERT INTO public.who_global_data VALUES (417, 0, 0, 0, 0, 2, 116);
INSERT INTO public.who_global_data VALUES (418, 0, 39, 0, 0, 2, 128);
INSERT INTO public.who_global_data VALUES (419, 68, 1479, 1, 16, 2, 6);
INSERT INTO public.who_global_data VALUES (420, 0, 1289, 0, 12, 2, 227);
INSERT INTO public.who_global_data VALUES (421, 0, 24, 0, 0, 2, 68);
INSERT INTO public.who_global_data VALUES (422, 51, 1059, 0, 2, 2, 184);
INSERT INTO public.who_global_data VALUES (423, 0, 3, 0, 0, 2, 82);
INSERT INTO public.who_global_data VALUES (424, 17, 3111, 0, 68, 2, 149);
INSERT INTO public.who_global_data VALUES (425, 4, 1275, 0, 17, 2, 197);
INSERT INTO public.who_global_data VALUES (426, 306, 368945, 3, 6386, 2, 78);
INSERT INTO public.who_global_data VALUES (427, 285, 27365, 7, 648, 2, 233);
INSERT INTO public.who_global_data VALUES (428, 1932, 400837, 15, 4071, 2, 133);
INSERT INTO public.who_global_data VALUES (429, 0, 1243, 0, 5, 2, 35);
INSERT INTO public.who_global_data VALUES (430, 39, 3699, 0, 79, 2, 114);
INSERT INTO public.who_global_data VALUES (431, 18, 59602, 0, 29, 2, 237);
INSERT INTO public.who_global_data VALUES (432, 0, 20, 0, 0, 2, 55);
INSERT INTO public.who_global_data VALUES (433, 15, 1885, 0, 27, 2, 176);
INSERT INTO public.who_global_data VALUES (434, 2077, 256903, 87, 4976, 2, 202);
INSERT INTO public.who_global_data VALUES (435, 1239, 171340, 22, 3833, 2, 155);
INSERT INTO public.who_global_data VALUES (436, 0, 17, 0, 0, 2, 32);
INSERT INTO public.who_global_data VALUES (437, 30, 4814, 2, 132, 2, 220);
INSERT INTO public.who_global_data VALUES (438, 4058, 1463016, 398, 45344, 2, 30);
INSERT INTO public.who_global_data VALUES (439, 69, 4106, 1, 65, 2, 147);
INSERT INTO public.who_global_data VALUES (440, 21755, 2902037, 196, 60717, 2, 208);
INSERT INTO public.who_global_data VALUES (441, 711, 66409, 2, 332, 2, 45);
INSERT INTO public.who_global_data VALUES (442, 41, 29577, 1, 1830, 2, 110);
INSERT INTO public.who_global_data VALUES (443, 48, 8497, 0, 156, 2, 88);
INSERT INTO public.who_global_data VALUES (444, 4325, 580929, 3, 12026, 2, 51);
INSERT INTO public.who_global_data VALUES (445, 7, 525944, 0, 8767, 2, 209);
INSERT INTO public.who_global_data VALUES (446, 60, 14202, 4, 933, 2, 205);
INSERT INTO public.who_global_data VALUES (447, 0, 13714, 0, 91, 2, 18);
INSERT INTO public.who_global_data VALUES (448, 809, 22058, 0, 79, 2, 72);
INSERT INTO public.who_global_data VALUES (449, 19202, 3871829, 1322, 109335, 2, 44);
INSERT INTO public.who_global_data VALUES (450, 3, 80, 0, 0, 2, 15);
INSERT INTO public.who_global_data VALUES (451, 58, 5224, 0, 79, 2, 25);
INSERT INTO public.who_global_data VALUES (452, 0, 0, 0, 0, 2, 179);
INSERT INTO public.who_global_data VALUES (453, 0, 0, 0, 0, 2, 34);
INSERT INTO public.who_global_data VALUES (454, 12, 7578, 0, 134, 2, 207);
INSERT INTO public.who_global_data VALUES (455, 1267, 212679, 87, 6980, 2, 166);
INSERT INTO public.who_global_data VALUES (456, 8102, 2501079, 117, 26354, 2, 126);
INSERT INTO public.who_global_data VALUES (457, 0, 0, 0, 0, 2, 97);
INSERT INTO public.who_global_data VALUES (458, 0, 1504, 0, 9, 2, 36);
INSERT INTO public.who_global_data VALUES (459, 0, 0, 0, 0, 2, 125);
INSERT INTO public.who_global_data VALUES (460, 34, 39685, 2, 327, 2, 124);
INSERT INTO public.who_global_data VALUES (461, 5082, 1232246, 140, 23229, 2, 185);
INSERT INTO public.who_global_data VALUES (462, 3977, 313626, 12, 878, 2, 194);
INSERT INTO public.who_global_data VALUES (463, 0, 509, 0, 21, 2, 144);
INSERT INTO public.who_global_data VALUES (464, 116762, 26172274, 3426, 443256, 2, 19);
INSERT INTO public.who_global_data VALUES (465, 4, 2430, 0, 24, 2, 217);
INSERT INTO public.who_global_data VALUES (466, 539, 42667, 9, 453, 2, 148);
INSERT INTO public.who_global_data VALUES (467, 57, 78916, 0, 621, 2, 86);
INSERT INTO public.who_global_data VALUES (468, 0, 1, 0, 0, 2, 13);
INSERT INTO public.who_global_data VALUES (469, 406, 127752, 6, 1202, 2, 157);
INSERT INTO public.who_global_data VALUES (470, 57, 1948, 0, 35, 2, 8);
INSERT INTO public.who_global_data VALUES (471, 0, 5, 0, 0, 2, 73);
INSERT INTO public.who_global_data VALUES (472, 0, 2126, 0, 616, 2, 101);
INSERT INTO public.who_global_data VALUES (473, 1256, 57489, 10, 804, 2, 165);
INSERT INTO public.who_global_data VALUES (474, 150, 33964, 15, 1269, 2, 14);
INSERT INTO public.who_global_data VALUES (475, 53, 55174, 1, 2406, 3, 193);
INSERT INTO public.who_global_data VALUES (476, 942, 79934, 5, 1398, 3, 113);
INSERT INTO public.who_global_data VALUES (477, 263, 107841, 4, 2898, 3, 143);
INSERT INTO public.who_global_data VALUES (478, 0, 0, 0, 0, 3, 219);
INSERT INTO public.who_global_data VALUES (479, 45, 10017, 1, 102, 3, 186);
INSERT INTO public.who_global_data VALUES (480, 71, 19900, 2, 468, 3, 52);
INSERT INTO public.who_global_data VALUES (481, 0, 17, 0, 0, 3, 180);
INSERT INTO public.who_global_data VALUES (482, 0, 234, 0, 7, 3, 167);
INSERT INTO public.who_global_data VALUES (483, 6614, 1933853, 275, 48249, 3, 154);
INSERT INTO public.who_global_data VALUES (484, 190, 167421, 7, 3096, 3, 94);
INSERT INTO public.who_global_data VALUES (485, 20, 6986, 0, 59, 3, 66);
INSERT INTO public.who_global_data VALUES (486, 6, 28824, 0, 909, 3, 58);
INSERT INTO public.who_global_data VALUES (487, 1318, 413239, 39, 7749, 3, 163);
INSERT INTO public.who_global_data VALUES (488, 159, 230455, 5, 3141, 3, 37);
INSERT INTO public.who_global_data VALUES (489, 18, 8225, 0, 176, 3, 142);
INSERT INTO public.who_global_data VALUES (490, 657, 104239, 0, 376, 3, 83);
INSERT INTO public.who_global_data VALUES (491, 525, 536107, 12, 8149, 3, 228);
INSERT INTO public.who_global_data VALUES (492, 13, 1558, 0, 14, 3, 188);
INSERT INTO public.who_global_data VALUES (493, 699, 249994, 9, 1737, 3, 62);
INSERT INTO public.who_global_data VALUES (494, 2439, 717795, 50, 21228, 3, 160);
INSERT INTO public.who_global_data VALUES (495, 37, 11945, 1, 302, 3, 50);
INSERT INTO public.who_global_data VALUES (496, 226, 4119, 2, 54, 3, 33);
INSERT INTO public.who_global_data VALUES (497, 1, 692, 0, 12, 3, 183);
INSERT INTO public.who_global_data VALUES (498, 0, 859, 0, 1, 3, 92);
INSERT INTO public.who_global_data VALUES (499, 1464, 218299, 60, 10439, 3, 158);
INSERT INTO public.who_global_data VALUES (500, 0, 366, 0, 3, 3, 67);
INSERT INTO public.who_global_data VALUES (501, 262, 122461, 13, 4737, 3, 57);
INSERT INTO public.who_global_data VALUES (502, 0, 21293, 14, 148, 3, 38);
INSERT INTO public.who_global_data VALUES (503, 24591, 9229322, 595, 225099, 3, 141);
INSERT INTO public.who_global_data VALUES (504, 0, 141, 0, 1, 3, 178);
INSERT INTO public.who_global_data VALUES (505, 0, 180, 0, 3, 3, 108);
INSERT INTO public.who_global_data VALUES (506, 967, 220547, 36, 9178, 3, 39);
INSERT INTO public.who_global_data VALUES (507, 136, 10904, 5, 126, 3, 2);
INSERT INTO public.who_global_data VALUES (508, 23, 1664, 0, 2, 3, 195);
INSERT INTO public.who_global_data VALUES (509, 54, 14152, 0, 134, 3, 107);
INSERT INTO public.who_global_data VALUES (510, 0, 466, 0, 0, 3, 161);
INSERT INTO public.who_global_data VALUES (511, 0, 30313, 0, 474, 3, 212);
INSERT INTO public.who_global_data VALUES (512, 4617, 783589, 104, 20136, 3, 181);
INSERT INTO public.who_global_data VALUES (513, 8, 398, 0, 2, 3, 53);
INSERT INTO public.who_global_data VALUES (514, 0, 4989, 0, 63, 3, 164);
INSERT INTO public.who_global_data VALUES (515, 19, 3404, 0, 121, 3, 140);
INSERT INTO public.who_global_data VALUES (516, 3147, 734035, 22, 18559, 3, 20);
INSERT INTO public.who_global_data VALUES (517, 53, 101092, 2, 4828, 3, 112);
INSERT INTO public.who_global_data VALUES (518, 9622, 2104506, 289, 54272, 3, 111);
INSERT INTO public.who_global_data VALUES (519, 37, 2848, 2, 100, 3, 71);
INSERT INTO public.who_global_data VALUES (520, 0, 7887, 0, 117, 3, 218);
INSERT INTO public.who_global_data VALUES (521, 0, 0, 0, 0, 3, 43);
INSERT INTO public.who_global_data VALUES (522, 289, 194569, 7, 2634, 3, 49);
INSERT INTO public.who_global_data VALUES (523, 132, 28607, 2, 158, 3, 1);
INSERT INTO public.who_global_data VALUES (524, 730, 233637, 17, 5088, 3, 48);
INSERT INTO public.who_global_data VALUES (525, 1044, 28636, 2, 218, 3, 232);
INSERT INTO public.who_global_data VALUES (526, 0, 4585, 0, 21, 3, 175);
INSERT INTO public.who_global_data VALUES (527, 128, 31124, 0, 202, 3, 21);
INSERT INTO public.who_global_data VALUES (528, 9143, 1003657, 138, 16683, 3, 156);
INSERT INTO public.who_global_data VALUES (529, 0, 0, 0, 0, 3, 95);
INSERT INTO public.who_global_data VALUES (530, 201, 23042, 1, 674, 3, 177);
INSERT INTO public.who_global_data VALUES (531, 397, 199357, 15, 2160, 3, 210);
INSERT INTO public.who_global_data VALUES (532, 2, 5935, 0, 63, 3, 120);
INSERT INTO public.who_global_data VALUES (533, 4, 121, 0, 0, 3, 135);
INSERT INTO public.who_global_data VALUES (534, 834, 215920, 16, 2704, 3, 206);
INSERT INTO public.who_global_data VALUES (535, 293, 251279, 25, 14915, 3, 189);
INSERT INTO public.who_global_data VALUES (536, 521, 167013, 47, 9407, 3, 129);
INSERT INTO public.who_global_data VALUES (537, 0, 55195, 6, 1638, 3, 121);
INSERT INTO public.who_global_data VALUES (538, 0, 5534, 0, 86, 3, 59);
INSERT INTO public.who_global_data VALUES (539, 132, 2267, 0, 7, 3, 96);
INSERT INTO public.who_global_data VALUES (540, 685, 45663, 9, 433, 3, 41);
INSERT INTO public.who_global_data VALUES (541, 74, 15878, 9, 583, 3, 216);
INSERT INTO public.who_global_data VALUES (542, 477, 138861, 13, 2116, 3, 236);
INSERT INTO public.who_global_data VALUES (543, 1, 41, 0, 0, 3, 150);
INSERT INTO public.who_global_data VALUES (544, 0, 654, 0, 1, 3, 61);
INSERT INTO public.who_global_data VALUES (545, 0, 55, 0, 2, 3, 7);
INSERT INTO public.who_global_data VALUES (546, 302, 45784, 7, 684, 3, 169);
INSERT INTO public.who_global_data VALUES (547, 22871, 3172126, 726, 76840, 3, 28);
INSERT INTO public.who_global_data VALUES (548, 51, 16185, 0, 76, 3, 85);
INSERT INTO public.who_global_data VALUES (549, 20, 18121, 1, 133, 3, 211);
INSERT INTO public.who_global_data VALUES (550, 0, 10952, 0, 68, 3, 60);
INSERT INTO public.who_global_data VALUES (551, 0, 4139, 0, 131, 3, 3);
INSERT INTO public.who_global_data VALUES (552, 688, 259897, 13, 3221, 3, 11);
INSERT INTO public.who_global_data VALUES (553, 9705, 2237790, 975, 58956, 3, 89);
INSERT INTO public.who_global_data VALUES (554, 772, 67782, 8, 424, 3, 24);
INSERT INTO public.who_global_data VALUES (555, 14, 4128, 1, 78, 3, 162);
INSERT INTO public.who_global_data VALUES (556, 1221, 158716, 22, 5851, 3, 100);
INSERT INTO public.who_global_data VALUES (557, 0, 30, 0, 0, 3, 47);
INSERT INTO public.who_global_data VALUES (558, 0, 148, 0, 1, 3, 29);
INSERT INTO public.who_global_data VALUES (559, 0, 9156, 0, 158, 3, 40);
INSERT INTO public.who_global_data VALUES (560, 2, 7403, 0, 129, 3, 222);
INSERT INTO public.who_global_data VALUES (561, 667, 160299, 36, 5709, 3, 132);
INSERT INTO public.who_global_data VALUES (562, 46, 585, 0, 13, 3, 130);
INSERT INTO public.who_global_data VALUES (563, 9, 14555, 1, 83, 3, 234);
INSERT INTO public.who_global_data VALUES (564, 20, 2655, 0, 45, 3, 23);
INSERT INTO public.who_global_data VALUES (565, 13, 7654, 1, 177, 3, 192);
INSERT INTO public.who_global_data VALUES (566, 82, 11672, 0, 245, 3, 69);
INSERT INTO public.who_global_data VALUES (567, 0, 26, 0, 0, 3, 187);
INSERT INTO public.who_global_data VALUES (568, 1108, 148951, 4, 3614, 3, 230);
INSERT INTO public.who_global_data VALUES (569, 1048, 370336, 83, 12739, 3, 77);
INSERT INTO public.who_global_data VALUES (570, 2, 6011, 0, 29, 3, 9);
INSERT INTO public.who_global_data VALUES (571, 11039, 10777284, 110, 154596, 3, 74);
INSERT INTO public.who_global_data VALUES (572, 10379, 1099687, 304, 30581, 3, 224);
INSERT INTO public.who_global_data VALUES (573, 6820, 1431416, 72, 58110, 3, 199);
INSERT INTO public.who_global_data VALUES (574, 1135, 621755, 11, 13068, 3, 190);
INSERT INTO public.who_global_data VALUES (575, 871, 198424, 101, 3418, 3, 12);
INSERT INTO public.who_global_data VALUES (576, 0, 434, 0, 25, 3, 104);
INSERT INTO public.who_global_data VALUES (577, 0, 645590, 0, 4806, 3, 153);
INSERT INTO public.who_global_data VALUES (578, 9651, 2570608, 499, 89344, 3, 91);
INSERT INTO public.who_global_data VALUES (579, 195, 15973, 1, 353, 3, 215);
INSERT INTO public.who_global_data VALUES (580, 2210, 393836, 118, 5912, 3, 84);
INSERT INTO public.who_global_data VALUES (581, 2, 3154, 0, 66, 3, 231);
INSERT INTO public.who_global_data VALUES (582, 1132, 329194, 8, 4334, 3, 196);
INSERT INTO public.who_global_data VALUES (583, 1362, 239726, 0, 3126, 3, 105);
INSERT INTO public.who_global_data VALUES (584, 153, 101009, 0, 1766, 3, 122);
INSERT INTO public.who_global_data VALUES (585, 0, 0, 0, 0, 3, 159);
INSERT INTO public.who_global_data VALUES (586, 245, 60705, 3, 1496, 3, 75);
INSERT INTO public.who_global_data VALUES (587, 811, 166654, 0, 959, 3, 27);
INSERT INTO public.who_global_data VALUES (588, 116, 84762, 1, 1415, 3, 54);
INSERT INTO public.who_global_data VALUES (589, 0, 44, 0, 0, 3, 226);
INSERT INTO public.who_global_data VALUES (590, 775, 67427, 17, 1219, 3, 79);
INSERT INTO public.who_global_data VALUES (591, 2770, 305842, 81, 3226, 3, 56);
INSERT INTO public.who_global_data VALUES (592, 0, 8900, 0, 172, 3, 117);
INSERT INTO public.who_global_data VALUES (593, 0, 1944, 0, 84, 3, 152);
INSERT INTO public.who_global_data VALUES (594, 1032, 120434, 13, 1896, 3, 16);
INSERT INTO public.who_global_data VALUES (595, 0, 2579, 0, 46, 3, 10);
INSERT INTO public.who_global_data VALUES (596, 764, 184208, 20, 2867, 3, 201);
INSERT INTO public.who_global_data VALUES (597, 190, 50923, 2, 586, 3, 174);
INSERT INTO public.who_global_data VALUES (598, 0, 19065, 0, 281, 3, 119);
INSERT INTO public.who_global_data VALUES (599, 538, 24903, 14, 726, 3, 168);
INSERT INTO public.who_global_data VALUES (600, 3455, 222628, 21, 791, 3, 99);
INSERT INTO public.who_global_data VALUES (601, 99, 16155, 0, 52, 3, 171);
INSERT INTO public.who_global_data VALUES (602, 11, 8111, 3, 333, 3, 87);
INSERT INTO public.who_global_data VALUES (603, 138, 18306, 3, 273, 3, 123);
INSERT INTO public.who_global_data VALUES (604, 0, 4, 0, 0, 3, 151);
INSERT INTO public.who_global_data VALUES (605, 0, 6442, 0, 45, 3, 213);
INSERT INTO public.who_global_data VALUES (606, 0, 16460, 0, 418, 3, 118);
INSERT INTO public.who_global_data VALUES (607, 15, 583, 0, 10, 3, 134);
INSERT INTO public.who_global_data VALUES (608, 415, 9003, 0, 61, 3, 65);
INSERT INTO public.who_global_data VALUES (609, 5448, 1869708, 564, 159100, 3, 102);
INSERT INTO public.who_global_data VALUES (610, 0, 0, 0, 0, 3, 223);
INSERT INTO public.who_global_data VALUES (611, 44, 1543, 3, 17, 3, 4);
INSERT INTO public.who_global_data VALUES (612, 18, 1832, 0, 2, 3, 146);
INSERT INTO public.who_global_data VALUES (613, 510, 63624, 7, 825, 3, 31);
INSERT INTO public.who_global_data VALUES (614, 0, 13, 0, 1, 3, 127);
INSERT INTO public.who_global_data VALUES (615, 835, 472273, 22, 8309, 3, 22);
INSERT INTO public.who_global_data VALUES (616, 800, 40260, 17, 403, 3, 115);
INSERT INTO public.who_global_data VALUES (617, 310, 140664, 8, 3146, 3, 106);
INSERT INTO public.who_global_data VALUES (618, 102, 34270, 2, 355, 3, 90);
INSERT INTO public.who_global_data VALUES (619, 0, 0, 0, 0, 3, 70);
INSERT INTO public.who_global_data VALUES (620, 171, 271289, 1, 2030, 3, 46);
INSERT INTO public.who_global_data VALUES (621, 3570, 985146, 83, 14105, 3, 139);
INSERT INTO public.who_global_data VALUES (622, 0, 47, 0, 0, 3, 42);
INSERT INTO public.who_global_data VALUES (623, 2, 1951, 0, 25, 3, 80);
INSERT INTO public.who_global_data VALUES (624, 35, 5027, 1, 170, 3, 203);
INSERT INTO public.who_global_data VALUES (625, 11, 4548, 1, 162, 3, 136);
INSERT INTO public.who_global_data VALUES (626, 1634, 133552, 6, 1613, 3, 63);
INSERT INTO public.who_global_data VALUES (627, 0, 0, 0, 0, 3, 17);
INSERT INTO public.who_global_data VALUES (628, 0, 133, 0, 2, 3, 172);
INSERT INTO public.who_global_data VALUES (629, 407, 93160, 7, 2873, 3, 109);
INSERT INTO public.who_global_data VALUES (630, 294, 63260, 1, 568, 3, 200);
INSERT INTO public.who_global_data VALUES (631, 513, 180018, 9, 2032, 3, 93);
INSERT INTO public.who_global_data VALUES (632, 161, 134685, 0, 1532, 3, 5);
INSERT INTO public.who_global_data VALUES (633, 0, 745, 0, 13, 3, 214);
INSERT INTO public.who_global_data VALUES (634, 1220, 547648, 63, 11746, 3, 204);
INSERT INTO public.who_global_data VALUES (635, 0, 0, 0, 0, 3, 198);
INSERT INTO public.who_global_data VALUES (636, 724, 321103, 26, 5296, 3, 173);
INSERT INTO public.who_global_data VALUES (637, 0, 867, 0, 9, 3, 229);
INSERT INTO public.who_global_data VALUES (638, 554, 133781, 14, 2733, 3, 76);
INSERT INTO public.who_global_data VALUES (639, 4477, 1142716, 155, 41181, 3, 138);
INSERT INTO public.who_global_data VALUES (640, 1581, 528853, 67, 10874, 3, 98);
INSERT INTO public.who_global_data VALUES (641, 0, 0, 0, 0, 3, 103);
INSERT INTO public.who_global_data VALUES (642, 6801, 1527016, 421, 37897, 3, 225);
INSERT INTO public.who_global_data VALUES (643, 5540, 731861, 260, 13017, 3, 131);
INSERT INTO public.who_global_data VALUES (644, 288, 94526, 10, 1846, 3, 235);
INSERT INTO public.who_global_data VALUES (645, 375, 152095, 0, 249, 3, 137);
INSERT INTO public.who_global_data VALUES (646, 467, 79310, 6, 1441, 3, 81);
INSERT INTO public.who_global_data VALUES (647, 639, 160725, 16, 3462, 3, 182);
INSERT INTO public.who_global_data VALUES (648, 0, 10194, 0, 46, 3, 145);
INSERT INTO public.who_global_data VALUES (649, 2676, 732732, 111, 18513, 3, 26);
INSERT INTO public.who_global_data VALUES (650, 16474, 3901204, 526, 74684, 3, 170);
INSERT INTO public.who_global_data VALUES (651, 229, 15688, 7, 205, 3, 191);
INSERT INTO public.who_global_data VALUES (652, 0, 6, 0, 0, 3, 221);
INSERT INTO public.who_global_data VALUES (653, 0, 379, 0, 0, 3, 64);
INSERT INTO public.who_global_data VALUES (654, 0, 0, 0, 0, 3, 116);
INSERT INTO public.who_global_data VALUES (655, 1, 39, 0, 0, 3, 128);
INSERT INTO public.who_global_data VALUES (656, 0, 1411, 0, 15, 3, 6);
INSERT INTO public.who_global_data VALUES (657, 0, 1289, 0, 12, 3, 227);
INSERT INTO public.who_global_data VALUES (658, 0, 24, 0, 0, 3, 68);
INSERT INTO public.who_global_data VALUES (659, 57, 1008, 0, 2, 3, 184);
INSERT INTO public.who_global_data VALUES (660, 0, 3, 0, 0, 3, 82);
INSERT INTO public.who_global_data VALUES (661, 28, 3094, 1, 68, 3, 149);
INSERT INTO public.who_global_data VALUES (662, 12, 1271, 0, 17, 3, 197);
INSERT INTO public.who_global_data VALUES (663, 310, 368639, 4, 6383, 3, 78);
INSERT INTO public.who_global_data VALUES (664, 153, 27080, 3, 641, 3, 233);
INSERT INTO public.who_global_data VALUES (665, 1903, 398905, 18, 4056, 3, 133);
INSERT INTO public.who_global_data VALUES (666, 38, 1243, 1, 5, 3, 35);
INSERT INTO public.who_global_data VALUES (667, 26, 3660, 0, 79, 3, 114);
INSERT INTO public.who_global_data VALUES (668, 19, 59584, 0, 29, 3, 237);
INSERT INTO public.who_global_data VALUES (669, 0, 20, 0, 0, 3, 55);
INSERT INTO public.who_global_data VALUES (670, 8, 1870, 0, 27, 3, 176);
INSERT INTO public.who_global_data VALUES (671, 2732, 254826, 105, 4889, 3, 202);
INSERT INTO public.who_global_data VALUES (672, 1615, 170101, 32, 3811, 3, 155);
INSERT INTO public.who_global_data VALUES (673, 0, 17, 0, 0, 3, 32);
INSERT INTO public.who_global_data VALUES (674, 0, 4784, 0, 130, 3, 220);
INSERT INTO public.who_global_data VALUES (675, 2649, 1458958, 547, 44946, 3, 30);
INSERT INTO public.who_global_data VALUES (676, 0, 4037, 0, 64, 3, 147);
INSERT INTO public.who_global_data VALUES (677, 20626, 2880282, 330, 60521, 3, 208);
INSERT INTO public.who_global_data VALUES (678, 715, 65698, 7, 330, 3, 45);
INSERT INTO public.who_global_data VALUES (679, 0, 29536, 0, 1829, 3, 110);
INSERT INTO public.who_global_data VALUES (680, 11, 8449, 2, 156, 3, 88);
INSERT INTO public.who_global_data VALUES (681, 1560, 576604, 14, 12023, 3, 51);
INSERT INTO public.who_global_data VALUES (682, 1036, 525937, 5, 8767, 3, 209);
INSERT INTO public.who_global_data VALUES (683, 46, 14142, 3, 929, 3, 205);
INSERT INTO public.who_global_data VALUES (684, 0, 13714, 0, 91, 3, 18);
INSERT INTO public.who_global_data VALUES (685, 795, 21249, 0, 79, 3, 72);
INSERT INTO public.who_global_data VALUES (686, 16840, 3852627, 1449, 108013, 3, 44);
INSERT INTO public.who_global_data VALUES (687, 2, 77, 0, 0, 3, 15);
INSERT INTO public.who_global_data VALUES (688, 74, 5166, 0, 79, 3, 25);
INSERT INTO public.who_global_data VALUES (689, 0, 0, 0, 0, 3, 179);
INSERT INTO public.who_global_data VALUES (690, 0, 0, 0, 0, 3, 34);
INSERT INTO public.who_global_data VALUES (691, 2, 7566, 0, 134, 3, 207);
INSERT INTO public.who_global_data VALUES (692, 1367, 211412, 91, 6893, 3, 166);
INSERT INTO public.who_global_data VALUES (693, 7795, 2492977, 120, 26237, 3, 126);
INSERT INTO public.who_global_data VALUES (694, 0, 0, 0, 0, 3, 97);
INSERT INTO public.who_global_data VALUES (695, 0, 1504, 0, 9, 3, 36);
INSERT INTO public.who_global_data VALUES (696, 0, 0, 0, 0, 3, 125);
INSERT INTO public.who_global_data VALUES (697, 45, 39651, 0, 325, 3, 124);
INSERT INTO public.who_global_data VALUES (698, 3285, 1227164, 165, 23089, 3, 185);
INSERT INTO public.who_global_data VALUES (699, 3310, 309649, 7, 866, 3, 194);
INSERT INTO public.who_global_data VALUES (700, 0, 509, 0, 21, 3, 144);
INSERT INTO public.who_global_data VALUES (701, 125444, 26055512, 1866, 439830, 3, 19);
INSERT INTO public.who_global_data VALUES (702, 5, 2426, 0, 24, 3, 217);
INSERT INTO public.who_global_data VALUES (703, 390, 42128, 8, 444, 3, 148);
INSERT INTO public.who_global_data VALUES (704, 58, 78859, 0, 621, 3, 86);
INSERT INTO public.who_global_data VALUES (705, 0, 1, 0, 0, 3, 13);
INSERT INTO public.who_global_data VALUES (706, 419, 127346, 7, 1196, 3, 157);
INSERT INTO public.who_global_data VALUES (707, 40, 1891, 0, 35, 3, 8);
INSERT INTO public.who_global_data VALUES (708, 0, 5, 0, 0, 3, 73);
INSERT INTO public.who_global_data VALUES (709, 0, 2126, 0, 616, 3, 101);
INSERT INTO public.who_global_data VALUES (710, 1191, 56233, 14, 794, 3, 165);
INSERT INTO public.who_global_data VALUES (711, 266, 33814, 20, 1254, 3, 14);
INSERT INTO public.who_global_data VALUES (712, 62, 55121, 1, 2405, 4, 193);
INSERT INTO public.who_global_data VALUES (713, 865, 78992, 13, 1393, 4, 113);
INSERT INTO public.who_global_data VALUES (714, 239, 107578, 3, 2894, 4, 143);
INSERT INTO public.who_global_data VALUES (715, 0, 0, 0, 0, 4, 219);
INSERT INTO public.who_global_data VALUES (716, 35, 9972, 0, 101, 4, 186);
INSERT INTO public.who_global_data VALUES (717, 33, 19829, 0, 466, 4, 52);
INSERT INTO public.who_global_data VALUES (718, 0, 17, 0, 0, 4, 180);
INSERT INTO public.who_global_data VALUES (719, 14, 234, 0, 7, 4, 167);
INSERT INTO public.who_global_data VALUES (720, 4975, 1927239, 43, 47974, 4, 154);
INSERT INTO public.who_global_data VALUES (721, 143, 167231, 5, 3089, 4, 94);
INSERT INTO public.who_global_data VALUES (722, 108, 6966, 1, 59, 4, 66);
INSERT INTO public.who_global_data VALUES (723, 7, 28818, 0, 909, 4, 58);
INSERT INTO public.who_global_data VALUES (724, 936, 411921, 57, 7710, 4, 163);
INSERT INTO public.who_global_data VALUES (725, 77, 230296, 4, 3136, 4, 37);
INSERT INTO public.who_global_data VALUES (726, 24, 8207, 0, 176, 4, 142);
INSERT INTO public.who_global_data VALUES (727, 525, 103582, 1, 376, 4, 83);
INSERT INTO public.who_global_data VALUES (728, 443, 535582, 10, 8137, 4, 228);
INSERT INTO public.who_global_data VALUES (729, 0, 1545, 2, 14, 4, 188);
INSERT INTO public.who_global_data VALUES (730, 959, 249295, 10, 1728, 4, 62);
INSERT INTO public.who_global_data VALUES (731, 3308, 715356, 35, 21178, 4, 160);
INSERT INTO public.who_global_data VALUES (732, 0, 11908, 0, 301, 4, 50);
INSERT INTO public.who_global_data VALUES (733, 0, 3893, 0, 52, 4, 33);
INSERT INTO public.who_global_data VALUES (734, 0, 691, 0, 12, 4, 183);
INSERT INTO public.who_global_data VALUES (735, 0, 859, 0, 1, 4, 92);
INSERT INTO public.who_global_data VALUES (736, 1438, 216835, 49, 10379, 4, 158);
INSERT INTO public.who_global_data VALUES (737, 4, 366, 0, 3, 4, 67);
INSERT INTO public.who_global_data VALUES (738, 113, 122199, 19, 4724, 4, 57);
INSERT INTO public.who_global_data VALUES (739, 0, 21293, 0, 134, 4, 38);
INSERT INTO public.who_global_data VALUES (740, 27756, 9204731, 559, 224504, 4, 141);
INSERT INTO public.who_global_data VALUES (741, 0, 141, 0, 1, 4, 178);
INSERT INTO public.who_global_data VALUES (742, 0, 180, 0, 3, 4, 108);
INSERT INTO public.who_global_data VALUES (743, 832, 219580, 97, 9142, 4, 39);
INSERT INTO public.who_global_data VALUES (744, 86, 10768, 1, 121, 4, 2);
INSERT INTO public.who_global_data VALUES (745, 6, 1641, 0, 2, 4, 195);
INSERT INTO public.who_global_data VALUES (746, 28, 14098, 0, 134, 4, 107);
INSERT INTO public.who_global_data VALUES (747, 0, 466, 0, 0, 4, 161);
INSERT INTO public.who_global_data VALUES (748, 696, 30313, 12, 474, 4, 212);
INSERT INTO public.who_global_data VALUES (749, 3924, 778972, 90, 20032, 4, 181);
INSERT INTO public.who_global_data VALUES (750, 0, 390, 0, 2, 4, 53);
INSERT INTO public.who_global_data VALUES (751, 0, 4989, 0, 63, 4, 164);
INSERT INTO public.who_global_data VALUES (752, 9, 3385, 3, 121, 4, 140);
INSERT INTO public.who_global_data VALUES (753, 3779, 730888, 85, 18537, 4, 20);
INSERT INTO public.who_global_data VALUES (754, 65, 101039, 1, 4826, 4, 112);
INSERT INTO public.who_global_data VALUES (755, 8078, 2094884, 333, 53983, 4, 111);
INSERT INTO public.who_global_data VALUES (756, 85, 2811, 5, 98, 4, 71);
INSERT INTO public.who_global_data VALUES (757, 0, 7887, 0, 117, 4, 218);
INSERT INTO public.who_global_data VALUES (758, 0, 0, 0, 0, 4, 43);
INSERT INTO public.who_global_data VALUES (759, 436, 194280, 15, 2627, 4, 49);
INSERT INTO public.who_global_data VALUES (760, 76, 28475, 2, 156, 4, 1);
INSERT INTO public.who_global_data VALUES (761, 387, 232907, 17, 5071, 4, 48);
INSERT INTO public.who_global_data VALUES (762, 906, 27592, 2, 216, 4, 232);
INSERT INTO public.who_global_data VALUES (763, 11, 4585, 1, 21, 4, 175);
INSERT INTO public.who_global_data VALUES (764, 120, 30996, 3, 202, 4, 21);
INSERT INTO public.who_global_data VALUES (765, 7185, 994514, 153, 16545, 4, 156);
INSERT INTO public.who_global_data VALUES (766, 0, 0, 0, 0, 4, 95);
INSERT INTO public.who_global_data VALUES (767, 71, 22841, 2, 673, 4, 177);
INSERT INTO public.who_global_data VALUES (768, 488, 198960, 20, 2145, 4, 210);
INSERT INTO public.who_global_data VALUES (769, 1, 5933, 0, 63, 4, 120);
INSERT INTO public.who_global_data VALUES (770, 0, 117, 0, 0, 4, 135);
INSERT INTO public.who_global_data VALUES (771, 1026, 215086, 22, 2688, 4, 206);
INSERT INTO public.who_global_data VALUES (772, 158, 250986, 31, 14890, 4, 189);
INSERT INTO public.who_global_data VALUES (773, 541, 166492, 44, 9360, 4, 129);
INSERT INTO public.who_global_data VALUES (774, 229, 55195, 9, 1632, 4, 121);
INSERT INTO public.who_global_data VALUES (775, 18, 5534, 0, 86, 4, 59);
INSERT INTO public.who_global_data VALUES (776, 0, 2135, 0, 7, 4, 96);
INSERT INTO public.who_global_data VALUES (777, 403, 44978, 2, 424, 4, 41);
INSERT INTO public.who_global_data VALUES (778, 93, 15804, 9, 574, 4, 216);
INSERT INTO public.who_global_data VALUES (779, 734, 138384, 10, 2103, 4, 236);
INSERT INTO public.who_global_data VALUES (780, 0, 40, 0, 0, 4, 150);
INSERT INTO public.who_global_data VALUES (781, 0, 654, 0, 1, 4, 61);
INSERT INTO public.who_global_data VALUES (782, 0, 55, 0, 2, 4, 7);
INSERT INTO public.who_global_data VALUES (783, 244, 45482, 6, 677, 4, 169);
INSERT INTO public.who_global_data VALUES (784, 3669, 3149255, 453, 76114, 4, 28);
INSERT INTO public.who_global_data VALUES (785, 51, 16134, 0, 76, 4, 85);
INSERT INTO public.who_global_data VALUES (786, 41, 18101, 1, 132, 4, 211);
INSERT INTO public.who_global_data VALUES (787, 204, 10952, 0, 68, 4, 60);
INSERT INTO public.who_global_data VALUES (788, 49, 4139, 3, 131, 4, 3);
INSERT INTO public.who_global_data VALUES (789, 858, 259209, 14, 3208, 4, 11);
INSERT INTO public.who_global_data VALUES (790, 6114, 2228085, 861, 57981, 4, 89);
INSERT INTO public.who_global_data VALUES (791, 0, 67010, 0, 416, 4, 24);
INSERT INTO public.who_global_data VALUES (792, 6, 4114, 2, 77, 4, 162);
INSERT INTO public.who_global_data VALUES (793, 538, 157495, 33, 5829, 4, 100);
INSERT INTO public.who_global_data VALUES (794, 0, 30, 0, 0, 4, 47);
INSERT INTO public.who_global_data VALUES (795, 0, 148, 0, 1, 4, 29);
INSERT INTO public.who_global_data VALUES (796, 0, 9156, 1, 158, 4, 40);
INSERT INTO public.who_global_data VALUES (797, 21, 7401, 0, 129, 4, 222);
INSERT INTO public.who_global_data VALUES (798, 128, 159632, 30, 5673, 4, 132);
INSERT INTO public.who_global_data VALUES (799, 46, 539, 0, 13, 4, 130);
INSERT INTO public.who_global_data VALUES (800, 14, 14546, 0, 82, 4, 234);
INSERT INTO public.who_global_data VALUES (801, 0, 2635, 0, 45, 4, 23);
INSERT INTO public.who_global_data VALUES (802, 60, 7641, 0, 176, 4, 192);
INSERT INTO public.who_global_data VALUES (803, 57, 11590, 0, 245, 4, 69);
INSERT INTO public.who_global_data VALUES (804, 0, 26, 0, 0, 4, 187);
INSERT INTO public.who_global_data VALUES (805, 743, 147843, 18, 3610, 4, 230);
INSERT INTO public.who_global_data VALUES (806, 578, 369288, 78, 12656, 4, 77);
INSERT INTO public.who_global_data VALUES (807, 0, 6009, 0, 29, 4, 9);
INSERT INTO public.who_global_data VALUES (808, 8635, 10766245, 94, 154486, 4, 74);
INSERT INTO public.who_global_data VALUES (809, 10994, 1089308, 279, 30277, 4, 224);
INSERT INTO public.who_global_data VALUES (810, 6597, 1424596, 79, 58038, 4, 199);
INSERT INTO public.who_global_data VALUES (811, 984, 620620, 10, 13057, 4, 190);
INSERT INTO public.who_global_data VALUES (812, 1006, 197553, 10, 3317, 4, 12);
INSERT INTO public.who_global_data VALUES (813, 0, 434, 0, 25, 4, 104);
INSERT INTO public.who_global_data VALUES (814, 5171, 645590, 41, 4806, 4, 153);
INSERT INTO public.who_global_data VALUES (815, 7925, 2560957, 329, 88845, 4, 91);
INSERT INTO public.who_global_data VALUES (816, 125, 15778, 2, 352, 4, 215);
INSERT INTO public.who_global_data VALUES (817, 2108, 391626, 72, 5794, 4, 84);
INSERT INTO public.who_global_data VALUES (818, 6, 3152, 0, 66, 4, 231);
INSERT INTO public.who_global_data VALUES (819, 1207, 328062, 10, 4326, 4, 196);
INSERT INTO public.who_global_data VALUES (820, 1335, 238364, 0, 3126, 4, 105);
INSERT INTO public.who_global_data VALUES (821, 83, 100856, 3, 1766, 4, 122);
INSERT INTO public.who_global_data VALUES (822, 0, 0, 0, 0, 4, 159);
INSERT INTO public.who_global_data VALUES (823, 282, 60460, 5, 1493, 4, 75);
INSERT INTO public.who_global_data VALUES (824, 586, 165843, 0, 959, 4, 27);
INSERT INTO public.who_global_data VALUES (825, 58, 84646, 2, 1414, 4, 54);
INSERT INTO public.who_global_data VALUES (826, 0, 44, 0, 0, 4, 226);
INSERT INTO public.who_global_data VALUES (827, 411, 66652, 7, 1202, 4, 79);
INSERT INTO public.who_global_data VALUES (828, 2020, 303072, 63, 3145, 4, 56);
INSERT INTO public.who_global_data VALUES (829, 622, 8900, 12, 172, 4, 117);
INSERT INTO public.who_global_data VALUES (830, 5, 1944, 0, 84, 4, 152);
INSERT INTO public.who_global_data VALUES (831, 771, 119402, 6, 1883, 4, 16);
INSERT INTO public.who_global_data VALUES (832, 12, 2579, 0, 46, 4, 10);
INSERT INTO public.who_global_data VALUES (833, 551, 183444, 22, 2847, 4, 201);
INSERT INTO public.who_global_data VALUES (834, 34, 50733, 4, 584, 4, 174);
INSERT INTO public.who_global_data VALUES (835, 0, 19065, 0, 281, 4, 119);
INSERT INTO public.who_global_data VALUES (836, 402, 24365, 10, 712, 4, 168);
INSERT INTO public.who_global_data VALUES (837, 4214, 219173, 10, 770, 4, 99);
INSERT INTO public.who_global_data VALUES (838, 215, 16056, 0, 52, 4, 171);
INSERT INTO public.who_global_data VALUES (839, 9, 8100, 0, 330, 4, 87);
INSERT INTO public.who_global_data VALUES (840, 141, 18168, 1, 270, 4, 123);
INSERT INTO public.who_global_data VALUES (841, 0, 4, 0, 0, 4, 151);
INSERT INTO public.who_global_data VALUES (842, 72, 6442, 1, 45, 4, 213);
INSERT INTO public.who_global_data VALUES (843, 0, 16460, 0, 418, 4, 118);
INSERT INTO public.who_global_data VALUES (844, 0, 568, 0, 10, 4, 134);
INSERT INTO public.who_global_data VALUES (845, 357, 8588, 0, 61, 4, 65);
INSERT INTO public.who_global_data VALUES (846, 7030, 1864260, 462, 158536, 4, 102);
INSERT INTO public.who_global_data VALUES (847, 0, 0, 0, 0, 4, 223);
INSERT INTO public.who_global_data VALUES (848, 10, 1499, 2, 14, 4, 4);
INSERT INTO public.who_global_data VALUES (849, 35, 1814, 0, 2, 4, 146);
INSERT INTO public.who_global_data VALUES (850, 601, 63114, 7, 818, 4, 31);
INSERT INTO public.who_global_data VALUES (851, 0, 13, 0, 1, 4, 127);
INSERT INTO public.who_global_data VALUES (852, 281, 471438, 12, 8287, 4, 22);
INSERT INTO public.who_global_data VALUES (853, 806, 39460, 19, 386, 4, 115);
INSERT INTO public.who_global_data VALUES (854, 209, 140354, 7, 3138, 4, 106);
INSERT INTO public.who_global_data VALUES (855, 228, 34168, 1, 353, 4, 90);
INSERT INTO public.who_global_data VALUES (856, 0, 0, 0, 0, 4, 70);
INSERT INTO public.who_global_data VALUES (857, 159, 271118, 0, 2029, 4, 46);
INSERT INTO public.who_global_data VALUES (858, 3258, 981576, 27, 14022, 4, 139);
INSERT INTO public.who_global_data VALUES (859, 0, 47, 0, 0, 4, 42);
INSERT INTO public.who_global_data VALUES (860, 2, 1949, 0, 25, 4, 80);
INSERT INTO public.who_global_data VALUES (861, 0, 4992, 0, 169, 4, 203);
INSERT INTO public.who_global_data VALUES (862, 20, 4537, 2, 161, 4, 136);
INSERT INTO public.who_global_data VALUES (863, 676, 131918, 21, 1607, 4, 63);
INSERT INTO public.who_global_data VALUES (864, 0, 0, 0, 0, 4, 17);
INSERT INTO public.who_global_data VALUES (865, 1, 133, 0, 2, 4, 172);
INSERT INTO public.who_global_data VALUES (866, 60, 92753, 11, 2866, 4, 109);
INSERT INTO public.who_global_data VALUES (867, 173, 62966, 4, 567, 4, 200);
INSERT INTO public.who_global_data VALUES (868, 586, 179505, 11, 2023, 4, 93);
INSERT INTO public.who_global_data VALUES (869, 198, 134524, 3, 1532, 4, 5);
INSERT INTO public.who_global_data VALUES (870, 0, 745, 0, 13, 4, 214);
INSERT INTO public.who_global_data VALUES (871, 1615, 546428, 26, 11683, 4, 204);
INSERT INTO public.who_global_data VALUES (872, 0, 0, 0, 0, 4, 198);
INSERT INTO public.who_global_data VALUES (873, 926, 320379, 26, 5270, 4, 173);
INSERT INTO public.who_global_data VALUES (874, 0, 867, 0, 9, 4, 229);
INSERT INTO public.who_global_data VALUES (875, 679, 133227, 15, 2719, 4, 76);
INSERT INTO public.who_global_data VALUES (876, 5217, 1138239, 169, 41026, 4, 138);
INSERT INTO public.who_global_data VALUES (877, 1654, 527272, 58, 10807, 4, 98);
INSERT INTO public.who_global_data VALUES (878, 0, 0, 0, 0, 4, 103);
INSERT INTO public.who_global_data VALUES (879, 4326, 1520215, 254, 37476, 4, 225);
INSERT INTO public.who_global_data VALUES (880, 5805, 726321, 275, 12757, 4, 131);
INSERT INTO public.who_global_data VALUES (881, 614, 94238, 7, 1836, 4, 235);
INSERT INTO public.who_global_data VALUES (882, 385, 151720, 1, 249, 4, 137);
INSERT INTO public.who_global_data VALUES (883, 336, 78843, 10, 1435, 4, 81);
INSERT INTO public.who_global_data VALUES (884, 282, 160086, 8, 3446, 4, 182);
INSERT INTO public.who_global_data VALUES (885, 198, 10194, 0, 46, 4, 145);
INSERT INTO public.who_global_data VALUES (886, 1313, 730056, 67, 18402, 4, 26);
INSERT INTO public.who_global_data VALUES (887, 16643, 3884730, 539, 74158, 4, 170);
INSERT INTO public.who_global_data VALUES (888, 155, 15459, 2, 198, 4, 191);
INSERT INTO public.who_global_data VALUES (889, 0, 6, 0, 0, 4, 221);
INSERT INTO public.who_global_data VALUES (890, 0, 379, 0, 0, 4, 64);
INSERT INTO public.who_global_data VALUES (891, 0, 0, 0, 0, 4, 116);
INSERT INTO public.who_global_data VALUES (892, 1, 38, 0, 0, 4, 128);
INSERT INTO public.who_global_data VALUES (893, 216, 1411, 2, 15, 4, 6);
INSERT INTO public.who_global_data VALUES (894, 0, 1289, 0, 12, 4, 227);
INSERT INTO public.who_global_data VALUES (895, 0, 24, 0, 0, 4, 68);
INSERT INTO public.who_global_data VALUES (896, 50, 951, 0, 2, 4, 184);
INSERT INTO public.who_global_data VALUES (897, 0, 3, 0, 0, 4, 82);
INSERT INTO public.who_global_data VALUES (898, 41, 3066, 0, 67, 4, 149);
INSERT INTO public.who_global_data VALUES (899, 3, 1259, 0, 17, 4, 197);
INSERT INTO public.who_global_data VALUES (900, 255, 368329, 4, 6379, 4, 78);
INSERT INTO public.who_global_data VALUES (901, 404, 26927, 10, 638, 4, 233);
INSERT INTO public.who_global_data VALUES (902, 1739, 397002, 18, 4038, 4, 133);
INSERT INTO public.who_global_data VALUES (903, 4, 1205, 0, 4, 4, 35);
INSERT INTO public.who_global_data VALUES (904, 41, 3634, 0, 79, 4, 114);
INSERT INTO public.who_global_data VALUES (905, 29, 59565, 0, 29, 4, 237);
INSERT INTO public.who_global_data VALUES (906, 0, 20, 0, 0, 4, 55);
INSERT INTO public.who_global_data VALUES (907, 40, 1862, 0, 27, 4, 176);
INSERT INTO public.who_global_data VALUES (908, 1737, 252094, 73, 4784, 4, 202);
INSERT INTO public.who_global_data VALUES (909, 1650, 168486, 20, 3779, 4, 155);
INSERT INTO public.who_global_data VALUES (910, 0, 17, 0, 0, 4, 32);
INSERT INTO public.who_global_data VALUES (911, 0, 4784, 0, 130, 4, 220);
INSERT INTO public.who_global_data VALUES (912, 2548, 1456309, 235, 44399, 4, 30);
INSERT INTO public.who_global_data VALUES (913, 76, 4037, 0, 64, 4, 147);
INSERT INTO public.who_global_data VALUES (914, 11024, 2859656, 273, 60191, 4, 208);
INSERT INTO public.who_global_data VALUES (915, 826, 64983, 7, 323, 4, 45);
INSERT INTO public.who_global_data VALUES (916, 48, 29536, 17, 1829, 4, 110);
INSERT INTO public.who_global_data VALUES (917, 35, 8438, 0, 154, 4, 88);
INSERT INTO public.who_global_data VALUES (918, 1165, 575044, 11, 12009, 4, 51);
INSERT INTO public.who_global_data VALUES (919, 2046, 524901, 26, 8762, 4, 209);
INSERT INTO public.who_global_data VALUES (920, 48, 14096, 5, 926, 4, 205);
INSERT INTO public.who_global_data VALUES (921, 0, 13714, 0, 91, 4, 18);
INSERT INTO public.who_global_data VALUES (922, 836, 20454, 2, 79, 4, 72);
INSERT INTO public.who_global_data VALUES (923, 18607, 3835787, 406, 106564, 4, 44);
INSERT INTO public.who_global_data VALUES (924, 5, 75, 0, 0, 4, 15);
INSERT INTO public.who_global_data VALUES (925, 18, 5092, 2, 79, 4, 25);
INSERT INTO public.who_global_data VALUES (926, 0, 0, 0, 0, 4, 179);
INSERT INTO public.who_global_data VALUES (927, 0, 0, 0, 0, 4, 34);
INSERT INTO public.who_global_data VALUES (928, 22, 7564, 0, 134, 4, 207);
INSERT INTO public.who_global_data VALUES (929, 1160, 210045, 48, 6802, 4, 166);
INSERT INTO public.who_global_data VALUES (930, 7719, 2485182, 124, 26117, 4, 126);
INSERT INTO public.who_global_data VALUES (931, 0, 0, 0, 0, 4, 97);
INSERT INTO public.who_global_data VALUES (932, 1, 1504, 0, 9, 4, 36);
INSERT INTO public.who_global_data VALUES (933, 0, 0, 0, 0, 4, 125);
INSERT INTO public.who_global_data VALUES (934, 27, 39606, 1, 325, 4, 124);
INSERT INTO public.who_global_data VALUES (935, 2394, 1223879, 156, 22924, 4, 185);
INSERT INTO public.who_global_data VALUES (936, 2730, 306339, 9, 859, 4, 194);
INSERT INTO public.who_global_data VALUES (937, 0, 509, 0, 21, 4, 144);
INSERT INTO public.who_global_data VALUES (938, 112129, 25930068, 1913, 437964, 4, 19);
INSERT INTO public.who_global_data VALUES (939, 0, 2421, 0, 24, 4, 217);
INSERT INTO public.who_global_data VALUES (940, 557, 41738, 5, 436, 4, 148);
INSERT INTO public.who_global_data VALUES (941, 46, 78801, 0, 621, 4, 86);
INSERT INTO public.who_global_data VALUES (942, 0, 1, 0, 0, 4, 13);
INSERT INTO public.who_global_data VALUES (943, 604, 126927, 6, 1189, 4, 157);
INSERT INTO public.who_global_data VALUES (944, 32, 1851, 0, 35, 4, 8);
INSERT INTO public.who_global_data VALUES (945, 0, 5, 0, 0, 4, 73);
INSERT INTO public.who_global_data VALUES (946, 1, 2126, 0, 616, 4, 101);
INSERT INTO public.who_global_data VALUES (947, 825, 55042, 17, 780, 4, 165);
INSERT INTO public.who_global_data VALUES (948, 160, 33548, 17, 1234, 4, 14);
INSERT INTO public.who_global_data VALUES (949, 36, 55059, 4, 2404, 5, 193);
INSERT INTO public.who_global_data VALUES (950, 876, 78127, 11, 1380, 5, 113);
INSERT INTO public.who_global_data VALUES (951, 217, 107339, 3, 2891, 5, 143);
INSERT INTO public.who_global_data VALUES (952, 0, 0, 0, 0, 5, 219);
INSERT INTO public.who_global_data VALUES (953, 52, 9937, 0, 101, 5, 186);
INSERT INTO public.who_global_data VALUES (954, 14, 19796, 2, 466, 5, 52);
INSERT INTO public.who_global_data VALUES (955, 0, 17, 0, 0, 5, 180);
INSERT INTO public.who_global_data VALUES (956, 2, 220, 0, 7, 5, 167);
INSERT INTO public.who_global_data VALUES (957, 6902, 1922264, 156, 47931, 5, 154);
INSERT INTO public.who_global_data VALUES (958, 62, 167088, 4, 3084, 5, 94);
INSERT INTO public.who_global_data VALUES (959, 0, 6858, 0, 58, 5, 66);
INSERT INTO public.who_global_data VALUES (960, 5, 28811, 0, 909, 5, 58);
INSERT INTO public.who_global_data VALUES (961, 1093, 410985, 17, 7653, 5, 163);
INSERT INTO public.who_global_data VALUES (962, 153, 230219, 6, 3132, 5, 37);
INSERT INTO public.who_global_data VALUES (963, 9, 8183, 0, 176, 5, 142);
INSERT INTO public.who_global_data VALUES (964, 431, 103057, 3, 375, 5, 83);
INSERT INTO public.who_global_data VALUES (965, 369, 535139, 16, 8127, 5, 228);
INSERT INTO public.who_global_data VALUES (966, 47, 1545, 0, 12, 5, 188);
INSERT INTO public.who_global_data VALUES (967, 1766, 248336, 10, 1718, 5, 62);
INSERT INTO public.who_global_data VALUES (968, 855, 712048, 32, 21143, 5, 160);
INSERT INTO public.who_global_data VALUES (969, 31, 11908, 0, 301, 5, 50);
INSERT INTO public.who_global_data VALUES (970, 107, 3893, 4, 52, 5, 33);
INSERT INTO public.who_global_data VALUES (971, 0, 691, 0, 12, 5, 183);
INSERT INTO public.who_global_data VALUES (972, 1, 859, 0, 1, 5, 92);
INSERT INTO public.who_global_data VALUES (973, 2005, 215397, 104, 10330, 5, 158);
INSERT INTO public.who_global_data VALUES (974, 0, 362, 0, 3, 5, 67);
INSERT INTO public.who_global_data VALUES (975, 195, 122086, 9, 4705, 5, 57);
INSERT INTO public.who_global_data VALUES (976, 0, 21293, 0, 134, 5, 38);
INSERT INTO public.who_global_data VALUES (977, 58462, 9176975, 1279, 223945, 5, 141);
INSERT INTO public.who_global_data VALUES (978, 0, 141, 0, 1, 5, 178);
INSERT INTO public.who_global_data VALUES (979, 0, 180, 0, 3, 5, 108);
INSERT INTO public.who_global_data VALUES (980, 130, 218748, 17, 9045, 5, 39);
INSERT INTO public.who_global_data VALUES (981, 102, 10682, 0, 120, 5, 2);
INSERT INTO public.who_global_data VALUES (982, 3, 1635, 0, 2, 5, 195);
INSERT INTO public.who_global_data VALUES (983, 89, 14070, 1, 134, 5, 107);
INSERT INTO public.who_global_data VALUES (984, 1, 466, 0, 0, 5, 161);
INSERT INTO public.who_global_data VALUES (985, 0, 29617, 0, 462, 5, 212);
INSERT INTO public.who_global_data VALUES (986, 4255, 775048, 141, 19942, 5, 181);
INSERT INTO public.who_global_data VALUES (987, 0, 390, 0, 2, 5, 53);
INSERT INTO public.who_global_data VALUES (988, 8, 4989, 0, 63, 5, 164);
INSERT INTO public.who_global_data VALUES (989, 29, 3376, 0, 118, 5, 140);
INSERT INTO public.who_global_data VALUES (990, 4209, 727109, 113, 18452, 5, 20);
INSERT INTO public.who_global_data VALUES (991, 97, 100974, 2, 4825, 5, 112);
INSERT INTO public.who_global_data VALUES (992, 9173, 2086806, 366, 53650, 5, 111);
INSERT INTO public.who_global_data VALUES (993, 8, 2726, 3, 93, 5, 71);
INSERT INTO public.who_global_data VALUES (994, 0, 7887, 0, 117, 5, 218);
INSERT INTO public.who_global_data VALUES (995, 0, 0, 0, 0, 5, 43);
INSERT INTO public.who_global_data VALUES (996, 568, 193844, 8, 2612, 5, 49);
INSERT INTO public.who_global_data VALUES (997, 221, 28399, 2, 154, 5, 1);
INSERT INTO public.who_global_data VALUES (998, 94, 232520, 27, 5054, 5, 48);
INSERT INTO public.who_global_data VALUES (999, 1012, 26686, 1, 214, 5, 232);
INSERT INTO public.who_global_data VALUES (1000, 0, 4574, 0, 20, 5, 175);
INSERT INTO public.who_global_data VALUES (1001, 106, 30876, 2, 199, 5, 21);
INSERT INTO public.who_global_data VALUES (1002, 2555, 987329, 84, 16392, 5, 156);
INSERT INTO public.who_global_data VALUES (1003, 0, 0, 0, 0, 5, 95);
INSERT INTO public.who_global_data VALUES (1004, 167, 22770, 0, 671, 5, 177);
INSERT INTO public.who_global_data VALUES (1005, 377, 198472, 19, 2125, 5, 210);
INSERT INTO public.who_global_data VALUES (1006, 1, 5932, 1, 63, 5, 120);
INSERT INTO public.who_global_data VALUES (1007, 0, 117, 0, 0, 5, 135);
INSERT INTO public.who_global_data VALUES (1008, 1507, 214060, 20, 2666, 5, 206);
INSERT INTO public.who_global_data VALUES (1009, 1049, 250828, 8, 14859, 5, 189);
INSERT INTO public.who_global_data VALUES (1010, 533, 165951, 53, 9316, 5, 129);
INSERT INTO public.who_global_data VALUES (1011, 977, 54966, 9, 1623, 5, 121);
INSERT INTO public.who_global_data VALUES (1012, 0, 5516, 0, 86, 5, 59);
INSERT INTO public.who_global_data VALUES (1013, 0, 2135, 0, 7, 5, 96);
INSERT INTO public.who_global_data VALUES (1014, 367, 44575, 3, 422, 5, 41);
INSERT INTO public.who_global_data VALUES (1015, 45, 15711, 3, 565, 5, 216);
INSERT INTO public.who_global_data VALUES (1016, 629, 137650, 2, 2093, 5, 236);
INSERT INTO public.who_global_data VALUES (1017, 0, 40, 0, 0, 5, 150);
INSERT INTO public.who_global_data VALUES (1018, 0, 654, 0, 1, 5, 61);
INSERT INTO public.who_global_data VALUES (1019, 0, 55, 0, 2, 5, 7);
INSERT INTO public.who_global_data VALUES (1020, 367, 45238, 0, 671, 5, 169);
INSERT INTO public.who_global_data VALUES (1021, 19235, 3145586, 195, 75661, 5, 28);
INSERT INTO public.who_global_data VALUES (1022, 0, 16083, 0, 76, 5, 85);
INSERT INTO public.who_global_data VALUES (1023, 0, 18060, 0, 131, 5, 211);
INSERT INTO public.who_global_data VALUES (1024, 0, 10748, 0, 68, 5, 60);
INSERT INTO public.who_global_data VALUES (1025, 0, 4090, 0, 128, 5, 3);
INSERT INTO public.who_global_data VALUES (1026, 240, 258351, 16, 3194, 5, 11);
INSERT INTO public.who_global_data VALUES (1027, 5608, 2221971, 175, 57120, 5, 89);
INSERT INTO public.who_global_data VALUES (1028, 1583, 67010, 11, 416, 5, 24);
INSERT INTO public.who_global_data VALUES (1029, 12, 4108, 2, 75, 5, 162);
INSERT INTO public.who_global_data VALUES (1030, 484, 156957, 17, 5796, 5, 100);
INSERT INTO public.who_global_data VALUES (1031, 0, 30, 0, 0, 5, 47);
INSERT INTO public.who_global_data VALUES (1032, 0, 148, 0, 1, 5, 29);
INSERT INTO public.who_global_data VALUES (1033, 0, 9156, 0, 157, 5, 40);
INSERT INTO public.who_global_data VALUES (1034, 1, 7380, 0, 129, 5, 222);
INSERT INTO public.who_global_data VALUES (1035, 386, 159504, 25, 5643, 5, 132);
INSERT INTO public.who_global_data VALUES (1036, 44, 493, 0, 13, 5, 130);
INSERT INTO public.who_global_data VALUES (1037, 57, 14532, 0, 82, 5, 234);
INSERT INTO public.who_global_data VALUES (1038, 12, 2635, 0, 45, 5, 23);
INSERT INTO public.who_global_data VALUES (1039, 53, 7581, 1, 176, 5, 192);
INSERT INTO public.who_global_data VALUES (1040, 0, 11533, 0, 245, 5, 69);
INSERT INTO public.who_global_data VALUES (1041, 0, 26, 0, 0, 5, 187);
INSERT INTO public.who_global_data VALUES (1042, 990, 147100, 17, 3592, 5, 230);
INSERT INTO public.who_global_data VALUES (1043, 1124, 368710, 54, 12578, 5, 77);
INSERT INTO public.who_global_data VALUES (1044, 7, 6009, 0, 29, 5, 9);
INSERT INTO public.who_global_data VALUES (1045, 11427, 10757610, 118, 154392, 5, 74);
INSERT INTO public.who_global_data VALUES (1046, 12001, 1078314, 270, 29998, 5, 224);
INSERT INTO public.who_global_data VALUES (1047, 6268, 1417999, 70, 57959, 5, 199);
INSERT INTO public.who_global_data VALUES (1048, 714, 619636, 6, 13047, 5, 190);
INSERT INTO public.who_global_data VALUES (1049, 1244, 196547, 15, 3307, 5, 12);
INSERT INTO public.who_global_data VALUES (1050, 0, 434, 0, 25, 5, 104);
INSERT INTO public.who_global_data VALUES (1051, 3177, 640419, 43, 4765, 5, 153);
INSERT INTO public.who_global_data VALUES (1052, 11249, 2553032, 237, 88516, 5, 91);
INSERT INTO public.who_global_data VALUES (1053, 126, 15653, 2, 350, 5, 215);
INSERT INTO public.who_global_data VALUES (1054, 2776, 389518, 68, 5722, 5, 84);
INSERT INTO public.who_global_data VALUES (1055, 3, 3146, 0, 66, 5, 231);
INSERT INTO public.who_global_data VALUES (1056, 1181, 326855, 12, 4316, 5, 196);
INSERT INTO public.who_global_data VALUES (1057, 1185, 237029, 0, 3126, 5, 105);
INSERT INTO public.who_global_data VALUES (1058, 98, 100773, 8, 1763, 5, 122);
INSERT INTO public.who_global_data VALUES (1059, 0, 0, 0, 0, 5, 159);
INSERT INTO public.who_global_data VALUES (1060, 287, 60178, 6, 1488, 5, 75);
INSERT INTO public.who_global_data VALUES (1061, 635, 165257, 0, 959, 5, 27);
INSERT INTO public.who_global_data VALUES (1062, 59, 84588, 0, 1412, 5, 54);
INSERT INTO public.who_global_data VALUES (1063, 0, 44, 0, 0, 5, 226);
INSERT INTO public.who_global_data VALUES (1064, 533, 66241, 15, 1195, 5, 79);
INSERT INTO public.who_global_data VALUES (1065, 2139, 301052, 51, 3082, 5, 56);
INSERT INTO public.who_global_data VALUES (1066, 0, 8278, 0, 160, 5, 117);
INSERT INTO public.who_global_data VALUES (1067, 0, 1939, 0, 84, 5, 152);
INSERT INTO public.who_global_data VALUES (1068, 981, 118631, 35, 1877, 5, 16);
INSERT INTO public.who_global_data VALUES (1069, 2, 2567, 0, 46, 5, 10);
INSERT INTO public.who_global_data VALUES (1070, 354, 182893, 22, 2825, 5, 201);
INSERT INTO public.who_global_data VALUES (1071, 152, 50699, 1, 580, 5, 174);
INSERT INTO public.who_global_data VALUES (1072, 322, 19065, 2, 281, 5, 119);
INSERT INTO public.who_global_data VALUES (1073, 466, 23963, 15, 702, 5, 168);
INSERT INTO public.who_global_data VALUES (1074, 5298, 214959, 14, 760, 5, 99);
INSERT INTO public.who_global_data VALUES (1075, 105, 15841, 1, 52, 5, 171);
INSERT INTO public.who_global_data VALUES (1076, 22, 8091, 0, 330, 5, 87);
INSERT INTO public.who_global_data VALUES (1077, 124, 18027, 2, 269, 5, 123);
INSERT INTO public.who_global_data VALUES (1078, 0, 4, 0, 0, 5, 151);
INSERT INTO public.who_global_data VALUES (1079, 0, 6370, 0, 44, 5, 213);
INSERT INTO public.who_global_data VALUES (1080, 0, 16460, 0, 418, 5, 118);
INSERT INTO public.who_global_data VALUES (1081, 0, 568, 0, 10, 5, 134);
INSERT INTO public.who_global_data VALUES (1082, 0, 8231, 0, 61, 5, 65);
INSERT INTO public.who_global_data VALUES (1083, 15337, 1857230, 1495, 158074, 5, 102);
INSERT INTO public.who_global_data VALUES (1084, 0, 0, 0, 0, 5, 223);
INSERT INTO public.who_global_data VALUES (1085, 14, 1489, 0, 12, 5, 4);
INSERT INTO public.who_global_data VALUES (1086, 37, 1779, 0, 2, 5, 146);
INSERT INTO public.who_global_data VALUES (1087, 523, 62513, 6, 811, 5, 31);
INSERT INTO public.who_global_data VALUES (1088, 0, 13, 0, 1, 5, 127);
INSERT INTO public.who_global_data VALUES (1089, 466, 471157, 16, 8275, 5, 22);
INSERT INTO public.who_global_data VALUES (1090, 949, 38654, 4, 367, 5, 115);
INSERT INTO public.who_global_data VALUES (1091, 281, 140145, 6, 3131, 5, 106);
INSERT INTO public.who_global_data VALUES (1092, 112, 33940, 2, 352, 5, 90);
INSERT INTO public.who_global_data VALUES (1093, 0, 0, 0, 0, 5, 70);
INSERT INTO public.who_global_data VALUES (1094, 105, 270959, 2, 2029, 5, 46);
INSERT INTO public.who_global_data VALUES (1095, 3692, 978318, 40, 13995, 5, 139);
INSERT INTO public.who_global_data VALUES (1096, 0, 47, 0, 0, 5, 42);
INSERT INTO public.who_global_data VALUES (1097, 0, 1947, 0, 25, 5, 80);
INSERT INTO public.who_global_data VALUES (1098, 0, 4992, 0, 169, 5, 203);
INSERT INTO public.who_global_data VALUES (1099, 1, 4517, 0, 159, 5, 136);
INSERT INTO public.who_global_data VALUES (1100, 685, 131242, 8, 1586, 5, 63);
INSERT INTO public.who_global_data VALUES (1101, 0, 0, 0, 0, 5, 17);
INSERT INTO public.who_global_data VALUES (1102, 0, 132, 0, 2, 5, 172);
INSERT INTO public.who_global_data VALUES (1103, 175, 92693, 7, 2855, 5, 109);
INSERT INTO public.who_global_data VALUES (1104, 218, 62793, 0, 563, 5, 200);
INSERT INTO public.who_global_data VALUES (1105, 403, 178919, 2, 2012, 5, 93);
INSERT INTO public.who_global_data VALUES (1106, 598, 134326, 2, 1529, 5, 5);
INSERT INTO public.who_global_data VALUES (1107, 0, 745, 0, 13, 5, 214);
INSERT INTO public.who_global_data VALUES (1108, 1599, 544813, 34, 11657, 5, 204);
INSERT INTO public.who_global_data VALUES (1109, 0, 0, 0, 0, 5, 198);
INSERT INTO public.who_global_data VALUES (1110, 1200, 319453, 23, 5244, 5, 173);
INSERT INTO public.who_global_data VALUES (1111, 16, 867, 0, 9, 5, 229);
INSERT INTO public.who_global_data VALUES (1112, 662, 132548, 11, 2704, 5, 76);
INSERT INTO public.who_global_data VALUES (1113, 7147, 1133022, 171, 40857, 5, 138);
INSERT INTO public.who_global_data VALUES (1114, 2102, 525618, 80, 10749, 5, 98);
INSERT INTO public.who_global_data VALUES (1115, 0, 0, 0, 0, 5, 103);
INSERT INTO public.who_global_data VALUES (1116, 2504, 1515889, 42, 37222, 5, 225);
INSERT INTO public.who_global_data VALUES (1117, 9498, 720516, 303, 12482, 5, 131);
INSERT INTO public.who_global_data VALUES (1118, 218, 93624, 6, 1829, 5, 235);
INSERT INTO public.who_global_data VALUES (1119, 351, 151335, 0, 248, 5, 137);
INSERT INTO public.who_global_data VALUES (1120, 305, 78507, 5, 1425, 5, 81);
INSERT INTO public.who_global_data VALUES (1121, 291, 159804, 4, 3438, 5, 182);
INSERT INTO public.who_global_data VALUES (1122, 0, 9996, 0, 46, 5, 145);
INSERT INTO public.who_global_data VALUES (1123, 1825, 728743, 71, 18335, 5, 26);
INSERT INTO public.who_global_data VALUES (1124, 17648, 3868087, 437, 73619, 5, 170);
INSERT INTO public.who_global_data VALUES (1125, 186, 15304, 3, 196, 5, 191);
INSERT INTO public.who_global_data VALUES (1126, 0, 6, 0, 0, 5, 221);
INSERT INTO public.who_global_data VALUES (1127, 0, 379, 0, 0, 5, 64);
INSERT INTO public.who_global_data VALUES (1128, 0, 0, 0, 0, 5, 116);
INSERT INTO public.who_global_data VALUES (1129, 0, 37, 0, 0, 5, 128);
INSERT INTO public.who_global_data VALUES (1130, 0, 1195, 0, 13, 5, 6);
INSERT INTO public.who_global_data VALUES (1131, 0, 1289, 0, 12, 5, 227);
INSERT INTO public.who_global_data VALUES (1132, 0, 24, 0, 0, 5, 68);
INSERT INTO public.who_global_data VALUES (1133, 5, 901, 0, 2, 5, 184);
INSERT INTO public.who_global_data VALUES (1134, 0, 3, 0, 0, 5, 82);
INSERT INTO public.who_global_data VALUES (1135, 0, 3025, 0, 67, 5, 149);
INSERT INTO public.who_global_data VALUES (1136, 0, 1256, 0, 17, 5, 197);
INSERT INTO public.who_global_data VALUES (1137, 261, 368074, 3, 6375, 5, 78);
INSERT INTO public.who_global_data VALUES (1138, 310, 26523, 7, 628, 5, 233);
INSERT INTO public.who_global_data VALUES (1139, 1366, 395263, 20, 4020, 5, 133);
INSERT INTO public.who_global_data VALUES (1140, 15, 1201, 1, 4, 5, 35);
INSERT INTO public.who_global_data VALUES (1141, 65, 3593, 0, 79, 5, 114);
INSERT INTO public.who_global_data VALUES (1142, 29, 59536, 0, 29, 5, 237);
INSERT INTO public.who_global_data VALUES (1143, 0, 20, 0, 0, 5, 55);
INSERT INTO public.who_global_data VALUES (1144, 0, 1822, 0, 27, 5, 176);
INSERT INTO public.who_global_data VALUES (1145, 444, 250357, 69, 4711, 5, 202);
INSERT INTO public.who_global_data VALUES (1146, 363, 166836, 7, 3759, 5, 155);
INSERT INTO public.who_global_data VALUES (1147, 0, 17, 0, 0, 5, 32);
INSERT INTO public.who_global_data VALUES (1148, 0, 4784, 0, 130, 5, 220);
INSERT INTO public.who_global_data VALUES (1149, 4525, 1453761, 213, 44164, 5, 30);
INSERT INTO public.who_global_data VALUES (1150, 0, 3961, 0, 64, 5, 147);
INSERT INTO public.who_global_data VALUES (1151, 17399, 2848632, 318, 59918, 5, 208);
INSERT INTO public.who_global_data VALUES (1152, 864, 64157, 3, 316, 5, 45);
INSERT INTO public.who_global_data VALUES (1153, 39, 29488, 5, 1812, 5, 110);
INSERT INTO public.who_global_data VALUES (1154, 39, 8403, 0, 154, 5, 88);
INSERT INTO public.who_global_data VALUES (1155, 2695, 573879, 15, 11998, 5, 51);
INSERT INTO public.who_global_data VALUES (1156, 721, 522855, 24, 8736, 5, 209);
INSERT INTO public.who_global_data VALUES (1157, 50, 14048, 5, 921, 5, 205);
INSERT INTO public.who_global_data VALUES (1158, 0, 13714, 0, 91, 5, 18);
INSERT INTO public.who_global_data VALUES (1159, 836, 19618, 0, 77, 5, 72);
INSERT INTO public.who_global_data VALUES (1160, 21088, 3817180, 587, 106158, 5, 44);
INSERT INTO public.who_global_data VALUES (1161, 0, 70, 0, 0, 5, 15);
INSERT INTO public.who_global_data VALUES (1162, 33, 5074, 0, 77, 5, 25);
INSERT INTO public.who_global_data VALUES (1163, 0, 0, 0, 0, 5, 179);
INSERT INTO public.who_global_data VALUES (1164, 0, 0, 0, 0, 5, 34);
INSERT INTO public.who_global_data VALUES (1165, 9, 7542, 0, 134, 5, 207);
INSERT INTO public.who_global_data VALUES (1166, 1417, 208885, 74, 6754, 5, 166);
INSERT INTO public.who_global_data VALUES (1167, 6562, 2477463, 128, 25993, 5, 126);
INSERT INTO public.who_global_data VALUES (1168, 0, 0, 0, 0, 5, 97);
INSERT INTO public.who_global_data VALUES (1169, 44, 1503, 1, 9, 5, 36);
INSERT INTO public.who_global_data VALUES (1170, 0, 0, 0, 0, 5, 125);
INSERT INTO public.who_global_data VALUES (1171, 46, 39579, 0, 324, 5, 124);
INSERT INTO public.who_global_data VALUES (1172, 2030, 1221485, 61, 22768, 5, 185);
INSERT INTO public.who_global_data VALUES (1173, 2948, 303609, 12, 850, 5, 194);
INSERT INTO public.who_global_data VALUES (1174, 0, 509, 0, 21, 5, 144);
INSERT INTO public.who_global_data VALUES (1175, 141327, 25817939, 2878, 436051, 5, 19);
INSERT INTO public.who_global_data VALUES (1176, 23, 2421, 0, 24, 5, 217);
INSERT INTO public.who_global_data VALUES (1177, 652, 41181, 6, 431, 5, 148);
INSERT INTO public.who_global_data VALUES (1178, 44, 78755, 0, 621, 5, 86);
INSERT INTO public.who_global_data VALUES (1179, 0, 1, 0, 0, 5, 13);
INSERT INTO public.who_global_data VALUES (1180, 547, 126323, 6, 1183, 5, 157);
INSERT INTO public.who_global_data VALUES (1181, 38, 1819, 0, 35, 5, 8);
INSERT INTO public.who_global_data VALUES (1182, 0, 5, 0, 0, 5, 73);
INSERT INTO public.who_global_data VALUES (1183, 1, 2125, 0, 616, 5, 101);
INSERT INTO public.who_global_data VALUES (1184, 865, 54217, 18, 763, 5, 165);
INSERT INTO public.who_global_data VALUES (1185, 117, 33388, 24, 1217, 5, 14);
INSERT INTO public.who_global_data VALUES (1186, 15, 55023, 0, 2400, 6, 193);
INSERT INTO public.who_global_data VALUES (1187, 901, 77251, 11, 1369, 6, 113);
INSERT INTO public.who_global_data VALUES (1188, 235, 107122, 4, 2888, 6, 143);
INSERT INTO public.who_global_data VALUES (1189, 0, 0, 0, 0, 6, 219);
INSERT INTO public.who_global_data VALUES (1190, 48, 9885, 1, 101, 6, 186);
INSERT INTO public.who_global_data VALUES (1191, 59, 19782, 0, 464, 6, 52);
INSERT INTO public.who_global_data VALUES (1192, 1, 17, 0, 0, 6, 180);
INSERT INTO public.who_global_data VALUES (1193, 0, 218, 1, 7, 6, 167);
INSERT INTO public.who_global_data VALUES (1194, 9838, 1915362, 174, 47775, 6, 154);
INSERT INTO public.who_global_data VALUES (1195, 125, 167026, 9, 3080, 6, 94);
INSERT INTO public.who_global_data VALUES (1196, 0, 6858, 0, 58, 6, 66);
INSERT INTO public.who_global_data VALUES (1197, 6, 28806, 0, 909, 6, 58);
INSERT INTO public.who_global_data VALUES (1198, 1519, 409892, 31, 7636, 6, 163);
INSERT INTO public.who_global_data VALUES (1199, 131, 230066, 7, 3126, 6, 37);
INSERT INTO public.who_global_data VALUES (1200, 7, 8174, 1, 176, 6, 142);
INSERT INTO public.who_global_data VALUES (1201, 655, 102626, 0, 372, 6, 83);
INSERT INTO public.who_global_data VALUES (1202, 363, 534770, 17, 8111, 6, 228);
INSERT INTO public.who_global_data VALUES (1203, 51, 1498, 1, 12, 6, 188);
INSERT INTO public.who_global_data VALUES (1204, 1852, 246570, 10, 1708, 6, 62);
INSERT INTO public.who_global_data VALUES (1205, 1568, 711193, 28, 21111, 6, 160);
INSERT INTO public.who_global_data VALUES (1206, 32, 11877, 3, 301, 6, 50);
INSERT INTO public.who_global_data VALUES (1207, 0, 3786, 0, 48, 6, 33);
INSERT INTO public.who_global_data VALUES (1208, 1, 691, 0, 12, 6, 183);
INSERT INTO public.who_global_data VALUES (1209, 0, 858, 0, 1, 6, 92);
INSERT INTO public.who_global_data VALUES (1210, 2666, 213392, 0, 10226, 6, 158);
INSERT INTO public.who_global_data VALUES (1211, 0, 362, 0, 3, 6, 67);
INSERT INTO public.who_global_data VALUES (1212, 394, 121891, 17, 4696, 6, 57);
INSERT INTO public.who_global_data VALUES (1213, 0, 21293, 0, 134, 6, 38);
INSERT INTO public.who_global_data VALUES (1214, 59826, 9118513, 1119, 222666, 6, 141);
INSERT INTO public.who_global_data VALUES (1215, 0, 141, 0, 1, 6, 178);
INSERT INTO public.who_global_data VALUES (1216, 0, 180, 0, 3, 6, 108);
INSERT INTO public.who_global_data VALUES (1217, 349, 218618, 20, 9028, 6, 39);
INSERT INTO public.who_global_data VALUES (1218, 157, 10580, 0, 120, 6, 2);
INSERT INTO public.who_global_data VALUES (1219, 19, 1632, 0, 2, 6, 195);
INSERT INTO public.who_global_data VALUES (1220, 84, 13981, 2, 133, 6, 107);
INSERT INTO public.who_global_data VALUES (1221, 1, 465, 0, 0, 6, 161);
INSERT INTO public.who_global_data VALUES (1222, 0, 29617, 0, 462, 6, 212);
INSERT INTO public.who_global_data VALUES (1223, 4690, 770793, 137, 19801, 6, 181);
INSERT INTO public.who_global_data VALUES (1224, 3, 390, 0, 2, 6, 53);
INSERT INTO public.who_global_data VALUES (1225, 0, 4981, 0, 63, 6, 164);
INSERT INTO public.who_global_data VALUES (1226, 26, 3347, 0, 118, 6, 140);
INSERT INTO public.who_global_data VALUES (1227, 4151, 722900, 82, 18339, 6, 20);
INSERT INTO public.who_global_data VALUES (1228, 130, 100877, 2, 4823, 6, 112);
INSERT INTO public.who_global_data VALUES (1229, 10058, 2077633, 371, 53284, 6, 111);
INSERT INTO public.who_global_data VALUES (1230, 72, 2718, 1, 90, 6, 71);
INSERT INTO public.who_global_data VALUES (1231, 0, 7887, 0, 117, 6, 218);
INSERT INTO public.who_global_data VALUES (1232, 0, 0, 0, 0, 6, 43);
INSERT INTO public.who_global_data VALUES (1233, 639, 193276, 5, 2604, 6, 49);
INSERT INTO public.who_global_data VALUES (1234, 243, 28178, 0, 152, 6, 1);
INSERT INTO public.who_global_data VALUES (1235, 336, 232426, 29, 5027, 6, 48);
INSERT INTO public.who_global_data VALUES (1236, 910, 25674, 3, 213, 6, 232);
INSERT INTO public.who_global_data VALUES (1237, 0, 4574, 0, 20, 6, 175);
INSERT INTO public.who_global_data VALUES (1238, 113, 30770, 0, 197, 6, 21);
INSERT INTO public.who_global_data VALUES (1239, 4060, 984774, 97, 16308, 6, 156);
INSERT INTO public.who_global_data VALUES (1240, 0, 0, 0, 0, 6, 95);
INSERT INTO public.who_global_data VALUES (1241, 149, 22603, 6, 671, 6, 177);
INSERT INTO public.who_global_data VALUES (1242, 431, 198095, 22, 2106, 6, 210);
INSERT INTO public.who_global_data VALUES (1243, 1, 5931, 0, 62, 6, 120);
INSERT INTO public.who_global_data VALUES (1244, 0, 117, 0, 0, 6, 135);
INSERT INTO public.who_global_data VALUES (1245, 2141, 212553, 20, 2646, 6, 206);
INSERT INTO public.who_global_data VALUES (1246, 3779, 249779, 85, 14851, 6, 189);
INSERT INTO public.who_global_data VALUES (1247, 547, 165418, 46, 9263, 6, 129);
INSERT INTO public.who_global_data VALUES (1248, 0, 53989, 10, 1614, 6, 121);
INSERT INTO public.who_global_data VALUES (1249, 0, 5516, 0, 86, 6, 59);
INSERT INTO public.who_global_data VALUES (1250, 0, 2135, 0, 7, 6, 96);
INSERT INTO public.who_global_data VALUES (1251, 461, 44208, 8, 419, 6, 41);
INSERT INTO public.who_global_data VALUES (1252, 195, 15666, 11, 562, 6, 216);
INSERT INTO public.who_global_data VALUES (1253, 656, 137021, 4, 2091, 6, 236);
INSERT INTO public.who_global_data VALUES (1254, 2, 40, 0, 0, 6, 150);
INSERT INTO public.who_global_data VALUES (1255, 0, 654, 0, 1, 6, 61);
INSERT INTO public.who_global_data VALUES (1256, 0, 55, 0, 2, 6, 7);
INSERT INTO public.who_global_data VALUES (1257, 469, 44871, 0, 671, 6, 169);
INSERT INTO public.who_global_data VALUES (1258, 24136, 3126351, 242, 75466, 6, 28);
INSERT INTO public.who_global_data VALUES (1259, 55, 16083, 0, 76, 6, 85);
INSERT INTO public.who_global_data VALUES (1260, 0, 18060, 0, 131, 6, 211);
INSERT INTO public.who_global_data VALUES (1261, 0, 10748, 0, 68, 6, 60);
INSERT INTO public.who_global_data VALUES (1262, 0, 4090, 0, 128, 6, 3);
INSERT INTO public.who_global_data VALUES (1263, 479, 258111, 19, 3178, 6, 11);
INSERT INTO public.who_global_data VALUES (1264, 11192, 2216363, 399, 56945, 6, 89);
INSERT INTO public.who_global_data VALUES (1265, 1544, 65427, 15, 405, 6, 24);
INSERT INTO public.who_global_data VALUES (1266, 14, 4096, 3, 73, 6, 162);
INSERT INTO public.who_global_data VALUES (1267, 795, 156473, 15, 5779, 6, 100);
INSERT INTO public.who_global_data VALUES (1268, 0, 30, 0, 0, 6, 47);
INSERT INTO public.who_global_data VALUES (1269, 0, 148, 0, 1, 6, 29);
INSERT INTO public.who_global_data VALUES (1270, 100, 9156, 0, 157, 6, 40);
INSERT INTO public.who_global_data VALUES (1271, 7, 7379, 0, 129, 6, 222);
INSERT INTO public.who_global_data VALUES (1272, 782, 159118, 36, 5618, 6, 132);
INSERT INTO public.who_global_data VALUES (1273, 35, 449, 0, 13, 6, 130);
INSERT INTO public.who_global_data VALUES (1274, 24, 14475, 0, 82, 6, 234);
INSERT INTO public.who_global_data VALUES (1275, 9, 2623, 0, 45, 6, 23);
INSERT INTO public.who_global_data VALUES (1276, 58, 7528, 0, 175, 6, 192);
INSERT INTO public.who_global_data VALUES (1277, 73, 11533, 0, 245, 6, 69);
INSERT INTO public.who_global_data VALUES (1278, 0, 26, 0, 0, 6, 187);
INSERT INTO public.who_global_data VALUES (1279, 1118, 146110, 26, 3575, 6, 230);
INSERT INTO public.who_global_data VALUES (1280, 1307, 367586, 61, 12524, 6, 77);
INSERT INTO public.who_global_data VALUES (1281, 0, 6002, 0, 29, 6, 9);
INSERT INTO public.who_global_data VALUES (1282, 13052, 10746183, 127, 154274, 6, 74);
INSERT INTO public.who_global_data VALUES (1283, 14518, 1066313, 210, 29728, 6, 224);
INSERT INTO public.who_global_data VALUES (1284, 6317, 1411731, 82, 57889, 6, 199);
INSERT INTO public.who_global_data VALUES (1285, 775, 618922, 5, 13041, 6, 190);
INSERT INTO public.who_global_data VALUES (1286, 1411, 195303, 78, 3292, 6, 12);
INSERT INTO public.who_global_data VALUES (1287, 2, 434, 0, 25, 6, 104);
INSERT INTO public.who_global_data VALUES (1288, 7100, 637242, 41, 4722, 6, 153);
INSERT INTO public.who_global_data VALUES (1289, 12713, 2541783, 421, 88279, 6, 91);
INSERT INTO public.who_global_data VALUES (1290, 65, 15527, 3, 348, 6, 215);
INSERT INTO public.who_global_data VALUES (1291, 3659, 386742, 108, 5654, 6, 84);
INSERT INTO public.who_global_data VALUES (1292, 3, 3143, 1, 66, 6, 231);
INSERT INTO public.who_global_data VALUES (1293, 641, 325674, 23, 4304, 6, 196);
INSERT INTO public.who_global_data VALUES (1294, 1275, 235844, 91, 3126, 6, 105);
INSERT INTO public.who_global_data VALUES (1295, 112, 100675, 2, 1755, 6, 122);
INSERT INTO public.who_global_data VALUES (1296, 0, 0, 0, 0, 6, 159);
INSERT INTO public.who_global_data VALUES (1297, 285, 59891, 5, 1482, 6, 75);
INSERT INTO public.who_global_data VALUES (1298, 514, 164622, 1, 959, 6, 27);
INSERT INTO public.who_global_data VALUES (1299, 76, 84529, 1, 1412, 6, 54);
INSERT INTO public.who_global_data VALUES (1300, 0, 44, 0, 0, 6, 226);
INSERT INTO public.who_global_data VALUES (1301, 785, 65708, 14, 1180, 6, 79);
INSERT INTO public.who_global_data VALUES (1302, 2631, 298913, 351, 3031, 6, 56);
INSERT INTO public.who_global_data VALUES (1303, 0, 8278, 0, 160, 6, 117);
INSERT INTO public.who_global_data VALUES (1304, 0, 1939, 0, 84, 6, 152);
INSERT INTO public.who_global_data VALUES (1305, 0, 117650, 0, 1842, 6, 16);
INSERT INTO public.who_global_data VALUES (1306, 2, 2565, 0, 46, 6, 10);
INSERT INTO public.who_global_data VALUES (1307, 805, 182539, 16, 2803, 6, 201);
INSERT INTO public.who_global_data VALUES (1308, 159, 50547, 2, 579, 6, 174);
INSERT INTO public.who_global_data VALUES (1309, 0, 18743, 0, 279, 6, 119);
INSERT INTO public.who_global_data VALUES (1310, 477, 23497, 44, 687, 6, 168);
INSERT INTO public.who_global_data VALUES (1311, 5728, 209661, 13, 746, 6, 99);
INSERT INTO public.who_global_data VALUES (1312, 122, 15736, 0, 51, 6, 171);
INSERT INTO public.who_global_data VALUES (1313, 6, 8069, 1, 330, 6, 87);
INSERT INTO public.who_global_data VALUES (1314, 182, 17903, 2, 267, 6, 123);
INSERT INTO public.who_global_data VALUES (1315, 0, 4, 0, 0, 6, 151);
INSERT INTO public.who_global_data VALUES (1316, 0, 6370, 0, 44, 6, 213);
INSERT INTO public.who_global_data VALUES (1317, 0, 16460, 0, 418, 6, 118);
INSERT INTO public.who_global_data VALUES (1318, 0, 568, 0, 10, 6, 134);
INSERT INTO public.who_global_data VALUES (1319, 0, 8231, 0, 61, 6, 65);
INSERT INTO public.who_global_data VALUES (1320, 16374, 1841893, 1434, 156579, 6, 102);
INSERT INTO public.who_global_data VALUES (1321, 0, 0, 0, 0, 6, 223);
INSERT INTO public.who_global_data VALUES (1322, 18, 1475, 0, 12, 6, 4);
INSERT INTO public.who_global_data VALUES (1323, 32, 1742, 0, 2, 6, 146);
INSERT INTO public.who_global_data VALUES (1324, 365, 61990, 3, 805, 6, 31);
INSERT INTO public.who_global_data VALUES (1325, 0, 13, 0, 1, 6, 127);
INSERT INTO public.who_global_data VALUES (1326, 701, 470691, 13, 8259, 6, 22);
INSERT INTO public.who_global_data VALUES (1327, 597, 37705, 7, 363, 6, 115);
INSERT INTO public.who_global_data VALUES (1328, 349, 139864, 10, 3125, 6, 106);
INSERT INTO public.who_global_data VALUES (1329, 136, 33828, 8, 350, 6, 90);
INSERT INTO public.who_global_data VALUES (1330, 0, 0, 0, 0, 6, 70);
INSERT INTO public.who_global_data VALUES (1331, 109, 270854, 2, 2027, 6, 46);
INSERT INTO public.who_global_data VALUES (1332, 4187, 974626, 88, 13955, 6, 139);
INSERT INTO public.who_global_data VALUES (1333, 0, 47, 0, 0, 6, 42);
INSERT INTO public.who_global_data VALUES (1334, 0, 1947, 0, 25, 6, 80);
INSERT INTO public.who_global_data VALUES (1335, 0, 4992, 0, 169, 6, 203);
INSERT INTO public.who_global_data VALUES (1336, 27, 4516, 0, 159, 6, 136);
INSERT INTO public.who_global_data VALUES (1337, 1883, 130557, 1, 1578, 6, 63);
INSERT INTO public.who_global_data VALUES (1338, 0, 0, 0, 0, 6, 17);
INSERT INTO public.who_global_data VALUES (1339, 0, 132, 0, 2, 6, 172);
INSERT INTO public.who_global_data VALUES (1340, 325, 92518, 7, 2848, 6, 109);
INSERT INTO public.who_global_data VALUES (1341, 299, 62575, 0, 563, 6, 200);
INSERT INTO public.who_global_data VALUES (1342, 515, 178516, 9, 2010, 6, 93);
INSERT INTO public.who_global_data VALUES (1343, 0, 133728, 0, 1527, 6, 5);
INSERT INTO public.who_global_data VALUES (1344, 0, 745, 0, 13, 6, 214);
INSERT INTO public.who_global_data VALUES (1345, 2183, 543214, 63, 11623, 6, 204);
INSERT INTO public.who_global_data VALUES (1346, 0, 0, 0, 0, 6, 198);
INSERT INTO public.who_global_data VALUES (1347, 1445, 318253, 25, 5221, 6, 173);
INSERT INTO public.who_global_data VALUES (1348, 0, 851, 0, 9, 6, 229);
INSERT INTO public.who_global_data VALUES (1349, 969, 131886, 12, 2693, 6, 76);
INSERT INTO public.who_global_data VALUES (1350, 6190, 1125875, 202, 40686, 6, 138);
INSERT INTO public.who_global_data VALUES (1351, 2103, 523516, 69, 10669, 6, 98);
INSERT INTO public.who_global_data VALUES (1352, 0, 0, 0, 0, 6, 103);
INSERT INTO public.who_global_data VALUES (1353, 4711, 1513385, 98, 37180, 6, 225);
INSERT INTO public.who_global_data VALUES (1354, 12435, 711018, 293, 12179, 6, 131);
INSERT INTO public.who_global_data VALUES (1355, 438, 93406, 11, 1823, 6, 235);
INSERT INTO public.who_global_data VALUES (1356, 363, 150984, 0, 248, 6, 137);
INSERT INTO public.who_global_data VALUES (1357, 354, 78202, 6, 1420, 6, 81);
INSERT INTO public.who_global_data VALUES (1358, 653, 159513, 10, 3434, 6, 182);
INSERT INTO public.who_global_data VALUES (1359, 0, 9996, 0, 46, 6, 145);
INSERT INTO public.who_global_data VALUES (1360, 2668, 726918, 68, 18264, 6, 26);
INSERT INTO public.who_global_data VALUES (1361, 18359, 3850439, 485, 73182, 6, 170);
INSERT INTO public.who_global_data VALUES (1362, 334, 15118, 5, 193, 6, 191);
INSERT INTO public.who_global_data VALUES (1363, 0, 6, 0, 0, 6, 221);
INSERT INTO public.who_global_data VALUES (1364, 3, 379, 0, 0, 6, 64);
INSERT INTO public.who_global_data VALUES (1365, 0, 0, 0, 0, 6, 116);
INSERT INTO public.who_global_data VALUES (1366, 0, 37, 0, 0, 6, 128);
INSERT INTO public.who_global_data VALUES (1367, 89, 1195, 0, 13, 6, 6);
INSERT INTO public.who_global_data VALUES (1368, 98, 1289, 0, 12, 6, 227);
INSERT INTO public.who_global_data VALUES (1369, 0, 24, 0, 0, 6, 68);
INSERT INTO public.who_global_data VALUES (1370, 31, 896, 0, 2, 6, 184);
INSERT INTO public.who_global_data VALUES (1371, 0, 3, 0, 0, 6, 82);
INSERT INTO public.who_global_data VALUES (1372, 29, 3025, 2, 67, 6, 149);
INSERT INTO public.who_global_data VALUES (1373, 11, 1256, 0, 17, 6, 197);
INSERT INTO public.who_global_data VALUES (1374, 270, 367813, 4, 6372, 6, 78);
INSERT INTO public.who_global_data VALUES (1375, 318, 26213, 4, 621, 6, 233);
INSERT INTO public.who_global_data VALUES (1376, 1543, 393897, 17, 4000, 6, 133);
INSERT INTO public.who_global_data VALUES (1377, 29, 1186, 0, 3, 6, 35);
INSERT INTO public.who_global_data VALUES (1378, 146, 3528, 0, 79, 6, 114);
INSERT INTO public.who_global_data VALUES (1379, 58, 59507, 0, 29, 6, 237);
INSERT INTO public.who_global_data VALUES (1380, 0, 20, 0, 0, 6, 55);
INSERT INTO public.who_global_data VALUES (1381, 0, 1822, 0, 27, 6, 176);
INSERT INTO public.who_global_data VALUES (1382, 2914, 249913, 77, 4642, 6, 202);
INSERT INTO public.who_global_data VALUES (1383, 586, 166473, 20, 3752, 6, 155);
INSERT INTO public.who_global_data VALUES (1384, 0, 17, 0, 0, 6, 32);
INSERT INTO public.who_global_data VALUES (1385, 0, 4784, 0, 130, 6, 220);
INSERT INTO public.who_global_data VALUES (1386, 5297, 1449236, 318, 43951, 6, 30);
INSERT INTO public.who_global_data VALUES (1387, 0, 3961, 0, 64, 6, 147);
INSERT INTO public.who_global_data VALUES (1388, 30669, 2831233, 337, 59600, 6, 208);
INSERT INTO public.who_global_data VALUES (1389, 848, 63293, 8, 313, 6, 45);
INSERT INTO public.who_global_data VALUES (1390, 69, 29449, 3, 1807, 6, 110);
INSERT INTO public.who_global_data VALUES (1391, 71, 8364, 0, 154, 6, 88);
INSERT INTO public.who_global_data VALUES (1392, 4262, 571184, 28, 11983, 6, 51);
INSERT INTO public.who_global_data VALUES (1393, 1017, 522134, 25, 8712, 6, 209);
INSERT INTO public.who_global_data VALUES (1394, 54, 13998, 5, 916, 6, 205);
INSERT INTO public.who_global_data VALUES (1395, 0, 13714, 0, 91, 6, 18);
INSERT INTO public.who_global_data VALUES (1396, 829, 18782, 0, 77, 6, 72);
INSERT INTO public.who_global_data VALUES (1397, 23275, 3796092, 1222, 105571, 6, 44);
INSERT INTO public.who_global_data VALUES (1398, 0, 70, 0, 0, 6, 15);
INSERT INTO public.who_global_data VALUES (1399, 119, 5041, 1, 77, 6, 25);
INSERT INTO public.who_global_data VALUES (1400, 0, 0, 0, 0, 6, 179);
INSERT INTO public.who_global_data VALUES (1401, 0, 0, 0, 0, 6, 34);
INSERT INTO public.who_global_data VALUES (1402, 13, 7533, 0, 134, 6, 207);
INSERT INTO public.who_global_data VALUES (1403, 1438, 207468, 81, 6680, 6, 166);
INSERT INTO public.who_global_data VALUES (1404, 6871, 2470901, 129, 25865, 6, 126);
INSERT INTO public.who_global_data VALUES (1405, 0, 0, 0, 0, 6, 97);
INSERT INTO public.who_global_data VALUES (1406, 24, 1459, 0, 8, 6, 36);
INSERT INTO public.who_global_data VALUES (1407, 0, 0, 0, 0, 6, 125);
INSERT INTO public.who_global_data VALUES (1408, 43, 39533, 0, 324, 6, 124);
INSERT INTO public.who_global_data VALUES (1409, 3177, 1219455, 79, 22707, 6, 185);
INSERT INTO public.who_global_data VALUES (1410, 3647, 300661, 12, 838, 6, 194);
INSERT INTO public.who_global_data VALUES (1411, 0, 509, 0, 21, 6, 144);
INSERT INTO public.who_global_data VALUES (1412, 164415, 25676612, 3521, 433173, 6, 19);
INSERT INTO public.who_global_data VALUES (1413, 0, 2398, 0, 24, 6, 217);
INSERT INTO public.who_global_data VALUES (1414, 642, 40529, 10, 425, 6, 148);
INSERT INTO public.who_global_data VALUES (1415, 39, 78711, 0, 621, 6, 86);
INSERT INTO public.who_global_data VALUES (1416, 0, 1, 0, 0, 6, 13);
INSERT INTO public.who_global_data VALUES (1417, 412, 125776, 6, 1177, 6, 157);
INSERT INTO public.who_global_data VALUES (1418, 42, 1781, 0, 35, 6, 8);
INSERT INTO public.who_global_data VALUES (1419, 0, 5, 0, 0, 6, 73);
INSERT INTO public.who_global_data VALUES (1420, 0, 2124, 0, 616, 6, 101);
INSERT INTO public.who_global_data VALUES (1421, 1728, 53352, 17, 745, 6, 165);
INSERT INTO public.who_global_data VALUES (1422, 319, 33271, 15, 1193, 6, 14);
INSERT INTO public.who_global_data VALUES (1423, 69, 55008, 1, 2400, 7, 193);
INSERT INTO public.who_global_data VALUES (1424, 896, 76350, 8, 1358, 7, 113);
INSERT INTO public.who_global_data VALUES (1425, 277, 106887, 3, 2884, 7, 143);
INSERT INTO public.who_global_data VALUES (1426, 0, 0, 0, 0, 7, 219);
INSERT INTO public.who_global_data VALUES (1427, 58, 9837, 0, 100, 7, 186);
INSERT INTO public.who_global_data VALUES (1428, 51, 19723, 0, 464, 7, 52);
INSERT INTO public.who_global_data VALUES (1429, 0, 16, 0, 0, 7, 180);
INSERT INTO public.who_global_data VALUES (1430, 3, 218, 0, 6, 7, 167);
INSERT INTO public.who_global_data VALUES (1431, 9471, 1905524, 166, 47601, 7, 154);
INSERT INTO public.who_global_data VALUES (1432, 173, 166901, 2, 3071, 7, 94);
INSERT INTO public.who_global_data VALUES (1433, 49, 6858, 0, 58, 7, 66);
INSERT INTO public.who_global_data VALUES (1434, 6, 28800, 0, 909, 7, 58);
INSERT INTO public.who_global_data VALUES (1435, 1606, 408373, 47, 7605, 7, 163);
INSERT INTO public.who_global_data VALUES (1436, 142, 229935, 6, 3119, 7, 37);
INSERT INTO public.who_global_data VALUES (1437, 0, 8167, 0, 175, 7, 142);
INSERT INTO public.who_global_data VALUES (1438, 468, 101971, 0, 372, 7, 83);
INSERT INTO public.who_global_data VALUES (1439, 454, 534407, 7, 8094, 7, 228);
INSERT INTO public.who_global_data VALUES (1440, 4, 1447, 0, 11, 7, 188);
INSERT INTO public.who_global_data VALUES (1441, 1867, 244718, 10, 1698, 7, 62);
INSERT INTO public.who_global_data VALUES (1442, 3026, 709625, 43, 21083, 7, 160);
INSERT INTO public.who_global_data VALUES (1443, 29, 11845, 4, 298, 7, 50);
INSERT INTO public.who_global_data VALUES (1444, 0, 3786, 0, 48, 7, 33);
INSERT INTO public.who_global_data VALUES (1445, 1, 690, 0, 12, 7, 183);
INSERT INTO public.who_global_data VALUES (1446, 1, 858, 0, 1, 7, 92);
INSERT INTO public.who_global_data VALUES (1447, 2652, 210726, 59, 10226, 7, 158);
INSERT INTO public.who_global_data VALUES (1448, 0, 362, 0, 3, 7, 67);
INSERT INTO public.who_global_data VALUES (1449, 303, 121497, 20, 4679, 7, 57);
INSERT INTO public.who_global_data VALUES (1450, 635, 21293, 10, 134, 7, 38);
INSERT INTO public.who_global_data VALUES (1451, 61811, 9058687, 1386, 221547, 7, 141);
INSERT INTO public.who_global_data VALUES (1452, 4, 141, 0, 1, 7, 178);
INSERT INTO public.who_global_data VALUES (1453, 0, 180, 0, 3, 7, 108);
INSERT INTO public.who_global_data VALUES (1454, 695, 218269, 35, 9008, 7, 39);
INSERT INTO public.who_global_data VALUES (1455, 46, 10423, 0, 120, 7, 2);
INSERT INTO public.who_global_data VALUES (1456, 9, 1613, 0, 2, 7, 195);
INSERT INTO public.who_global_data VALUES (1457, 113, 13897, 0, 131, 7, 107);
INSERT INTO public.who_global_data VALUES (1458, 1, 464, 0, 0, 7, 161);
INSERT INTO public.who_global_data VALUES (1459, 0, 29617, 0, 462, 7, 212);
INSERT INTO public.who_global_data VALUES (1460, 4877, 766103, 131, 19664, 7, 181);
INSERT INTO public.who_global_data VALUES (1461, 2, 387, 0, 2, 7, 53);
INSERT INTO public.who_global_data VALUES (1462, 0, 4981, 0, 63, 7, 164);
INSERT INTO public.who_global_data VALUES (1463, 25, 3321, 0, 118, 7, 140);
INSERT INTO public.who_global_data VALUES (1464, 4606, 718749, 83, 18257, 7, 20);
INSERT INTO public.who_global_data VALUES (1465, 106, 100747, 1, 4821, 7, 112);
INSERT INTO public.who_global_data VALUES (1466, 12270, 2067575, 390, 52913, 7, 111);
INSERT INTO public.who_global_data VALUES (1467, 48, 2646, 4, 89, 7, 71);
INSERT INTO public.who_global_data VALUES (1468, 0, 7887, 0, 117, 7, 218);
INSERT INTO public.who_global_data VALUES (1469, 0, 0, 0, 0, 7, 43);
INSERT INTO public.who_global_data VALUES (1470, 571, 192637, 15, 2599, 7, 49);
INSERT INTO public.who_global_data VALUES (1471, 240, 27935, 1, 152, 7, 1);
INSERT INTO public.who_global_data VALUES (1472, 551, 232090, 26, 4998, 7, 48);
INSERT INTO public.who_global_data VALUES (1473, 659, 24764, 2, 210, 7, 232);
INSERT INTO public.who_global_data VALUES (1474, 7, 4574, 0, 20, 7, 175);
INSERT INTO public.who_global_data VALUES (1475, 119, 30657, 0, 197, 7, 21);
INSERT INTO public.who_global_data VALUES (1476, 8072, 980714, 139, 16211, 7, 156);
INSERT INTO public.who_global_data VALUES (1477, 0, 0, 0, 0, 7, 95);
INSERT INTO public.who_global_data VALUES (1478, 133, 22454, 0, 665, 7, 177);
INSERT INTO public.who_global_data VALUES (1479, 456, 197664, 13, 2084, 7, 210);
INSERT INTO public.who_global_data VALUES (1480, 1, 5930, 0, 62, 7, 120);
INSERT INTO public.who_global_data VALUES (1481, 0, 117, 0, 0, 7, 135);
INSERT INTO public.who_global_data VALUES (1482, 1802, 210412, 23, 2626, 7, 206);
INSERT INTO public.who_global_data VALUES (1483, 0, 246000, 0, 14766, 7, 189);
INSERT INTO public.who_global_data VALUES (1484, 589, 164871, 48, 9217, 7, 129);
INSERT INTO public.who_global_data VALUES (1485, 0, 53989, 5, 1604, 7, 121);
INSERT INTO public.who_global_data VALUES (1486, 24, 5516, 0, 86, 7, 59);
INSERT INTO public.who_global_data VALUES (1487, 50, 2135, 0, 7, 7, 96);
INSERT INTO public.who_global_data VALUES (1488, 404, 43747, 2, 411, 7, 41);
INSERT INTO public.who_global_data VALUES (1489, 188, 15471, 13, 551, 7, 216);
INSERT INTO public.who_global_data VALUES (1490, 771, 136365, 2, 2087, 7, 236);
INSERT INTO public.who_global_data VALUES (1491, 0, 38, 0, 0, 7, 150);
INSERT INTO public.who_global_data VALUES (1492, 0, 654, 0, 1, 7, 61);
INSERT INTO public.who_global_data VALUES (1493, 0, 55, 0, 2, 7, 7);
INSERT INTO public.who_global_data VALUES (1494, 363, 44402, 7, 671, 7, 169);
INSERT INTO public.who_global_data VALUES (1495, 22670, 3102215, 819, 75224, 7, 28);
INSERT INTO public.who_global_data VALUES (1496, 96, 16028, 0, 76, 7, 85);
INSERT INTO public.who_global_data VALUES (1497, 27, 18060, 0, 131, 7, 211);
INSERT INTO public.who_global_data VALUES (1498, 212, 10748, 0, 68, 7, 60);
INSERT INTO public.who_global_data VALUES (1499, 71, 4090, 0, 128, 7, 3);
INSERT INTO public.who_global_data VALUES (1500, 676, 257632, 11, 3159, 7, 11);
INSERT INTO public.who_global_data VALUES (1501, 12321, 2205171, 794, 56546, 7, 89);
INSERT INTO public.who_global_data VALUES (1502, 0, 63883, 0, 390, 7, 24);
INSERT INTO public.who_global_data VALUES (1503, 25, 4082, 0, 70, 7, 162);
INSERT INTO public.who_global_data VALUES (1504, 882, 155678, 22, 5764, 7, 100);
INSERT INTO public.who_global_data VALUES (1505, 0, 30, 0, 0, 7, 47);
INSERT INTO public.who_global_data VALUES (1506, 0, 148, 0, 1, 7, 29);
INSERT INTO public.who_global_data VALUES (1507, 0, 9056, 0, 157, 7, 40);
INSERT INTO public.who_global_data VALUES (1508, 7, 7372, 0, 129, 7, 222);
INSERT INTO public.who_global_data VALUES (1509, 741, 158336, 39, 5582, 7, 132);
INSERT INTO public.who_global_data VALUES (1510, 23, 414, 0, 13, 7, 130);
INSERT INTO public.who_global_data VALUES (1511, 16, 14451, 0, 82, 7, 234);
INSERT INTO public.who_global_data VALUES (1512, 9, 2614, 0, 45, 7, 23);
INSERT INTO public.who_global_data VALUES (1513, 90, 7470, 1, 175, 7, 192);
INSERT INTO public.who_global_data VALUES (1514, 58, 11460, 1, 245, 7, 69);
INSERT INTO public.who_global_data VALUES (1515, 0, 26, 0, 0, 7, 187);
INSERT INTO public.who_global_data VALUES (1516, 985, 144992, 37, 3549, 7, 230);
INSERT INTO public.who_global_data VALUES (1517, 1370, 366279, 89, 12463, 7, 77);
INSERT INTO public.who_global_data VALUES (1518, 1, 6002, 0, 29, 7, 9);
INSERT INTO public.who_global_data VALUES (1519, 13083, 10733131, 137, 154147, 7, 74);
INSERT INTO public.who_global_data VALUES (1520, 13802, 1051795, 187, 29518, 7, 224);
INSERT INTO public.who_global_data VALUES (1521, 6573, 1405414, 71, 57807, 7, 199);
INSERT INTO public.who_global_data VALUES (1522, 945, 618147, 12, 13036, 7, 190);
INSERT INTO public.who_global_data VALUES (1523, 247, 193892, 47, 3214, 7, 12);
INSERT INTO public.who_global_data VALUES (1524, 0, 432, 0, 25, 7, 104);
INSERT INTO public.who_global_data VALUES (1525, 7726, 630142, 47, 4681, 7, 153);
INSERT INTO public.who_global_data VALUES (1526, 13563, 2529070, 477, 87858, 7, 91);
INSERT INTO public.who_global_data VALUES (1527, 27, 15462, 1, 345, 7, 215);
INSERT INTO public.who_global_data VALUES (1528, 3567, 383083, 94, 5546, 7, 84);
INSERT INTO public.who_global_data VALUES (1529, 6, 3140, 1, 65, 7, 231);
INSERT INTO public.who_global_data VALUES (1530, 864, 325033, 12, 4281, 7, 196);
INSERT INTO public.who_global_data VALUES (1531, 1413, 234569, 0, 3035, 7, 105);
INSERT INTO public.who_global_data VALUES (1532, 141, 100563, 0, 1753, 7, 122);
INSERT INTO public.who_global_data VALUES (1533, 0, 0, 0, 0, 7, 159);
INSERT INTO public.who_global_data VALUES (1534, 342, 59606, 5, 1477, 7, 75);
INSERT INTO public.who_global_data VALUES (1535, 658, 164108, 0, 958, 7, 27);
INSERT INTO public.who_global_data VALUES (1536, 76, 84453, 2, 1411, 7, 54);
INSERT INTO public.who_global_data VALUES (1537, 0, 44, 0, 0, 7, 226);
INSERT INTO public.who_global_data VALUES (1538, 931, 64923, 18, 1166, 7, 79);
INSERT INTO public.who_global_data VALUES (1539, 3125, 296282, 59, 2680, 7, 56);
INSERT INTO public.who_global_data VALUES (1540, 136, 8278, 0, 160, 7, 117);
INSERT INTO public.who_global_data VALUES (1541, 3, 1939, 0, 84, 7, 152);
INSERT INTO public.who_global_data VALUES (1542, 871, 117650, 10, 1842, 7, 16);
INSERT INTO public.who_global_data VALUES (1543, 13, 2563, 0, 46, 7, 10);
INSERT INTO public.who_global_data VALUES (1544, 706, 181734, 25, 2787, 7, 201);
INSERT INTO public.who_global_data VALUES (1545, 160, 50388, 3, 577, 7, 174);
INSERT INTO public.who_global_data VALUES (1546, 0, 18743, 0, 279, 7, 119);
INSERT INTO public.who_global_data VALUES (1547, 716, 23020, 15, 643, 7, 168);
INSERT INTO public.who_global_data VALUES (1548, 5725, 203933, 16, 733, 7, 99);
INSERT INTO public.who_global_data VALUES (1549, 118, 15614, 0, 51, 7, 171);
INSERT INTO public.who_global_data VALUES (1550, 7, 8063, 0, 329, 7, 87);
INSERT INTO public.who_global_data VALUES (1551, 136, 17721, 1, 265, 7, 123);
INSERT INTO public.who_global_data VALUES (1552, 0, 4, 0, 0, 7, 151);
INSERT INTO public.who_global_data VALUES (1553, 0, 6370, 0, 44, 7, 213);
INSERT INTO public.who_global_data VALUES (1554, 0, 16460, 0, 418, 7, 118);
INSERT INTO public.who_global_data VALUES (1555, 0, 568, 0, 10, 7, 134);
INSERT INTO public.who_global_data VALUES (1556, 0, 8231, 0, 61, 7, 65);
INSERT INTO public.who_global_data VALUES (1557, 18670, 1825519, 1506, 155145, 7, 102);
INSERT INTO public.who_global_data VALUES (1558, 0, 0, 0, 0, 7, 223);
INSERT INTO public.who_global_data VALUES (1559, 27, 1457, 1, 12, 7, 4);
INSERT INTO public.who_global_data VALUES (1560, 18, 1710, 0, 2, 7, 146);
INSERT INTO public.who_global_data VALUES (1561, 450, 61625, 2, 802, 7, 31);
INSERT INTO public.who_global_data VALUES (1562, 0, 13, 0, 1, 7, 127);
INSERT INTO public.who_global_data VALUES (1563, 851, 469990, 22, 8246, 7, 22);
INSERT INTO public.who_global_data VALUES (1564, 1275, 37108, 9, 356, 7, 115);
INSERT INTO public.who_global_data VALUES (1565, 363, 139515, 12, 3115, 7, 106);
INSERT INTO public.who_global_data VALUES (1566, 243, 33692, 10, 342, 7, 90);
INSERT INTO public.who_global_data VALUES (1567, 0, 0, 0, 0, 7, 70);
INSERT INTO public.who_global_data VALUES (1568, 157, 270745, 5, 2025, 7, 46);
INSERT INTO public.who_global_data VALUES (1569, 4421, 970439, 57, 13867, 7, 139);
INSERT INTO public.who_global_data VALUES (1570, 3, 47, 0, 0, 7, 42);
INSERT INTO public.who_global_data VALUES (1571, 1, 1947, 0, 25, 7, 80);
INSERT INTO public.who_global_data VALUES (1572, 0, 4992, 0, 169, 7, 203);
INSERT INTO public.who_global_data VALUES (1573, 15, 4489, 2, 159, 7, 136);
INSERT INTO public.who_global_data VALUES (1574, 1650, 128674, 30, 1577, 7, 63);
INSERT INTO public.who_global_data VALUES (1575, 0, 0, 0, 0, 7, 17);
INSERT INTO public.who_global_data VALUES (1576, 0, 132, 0, 2, 7, 172);
INSERT INTO public.who_global_data VALUES (1577, 302, 92193, 10, 2841, 7, 109);
INSERT INTO public.who_global_data VALUES (1578, 316, 62276, 6, 563, 7, 200);
INSERT INTO public.who_global_data VALUES (1579, 575, 178001, 11, 2001, 7, 93);
INSERT INTO public.who_global_data VALUES (1580, 0, 133728, 0, 1527, 7, 5);
INSERT INTO public.who_global_data VALUES (1581, 0, 745, 0, 13, 7, 214);
INSERT INTO public.who_global_data VALUES (1582, 1644, 541031, 46, 11560, 7, 204);
INSERT INTO public.who_global_data VALUES (1583, 0, 0, 0, 0, 7, 198);
INSERT INTO public.who_global_data VALUES (1584, 1408, 316808, 20, 5196, 7, 173);
INSERT INTO public.who_global_data VALUES (1585, 0, 851, 0, 9, 7, 229);
INSERT INTO public.who_global_data VALUES (1586, 754, 130917, 13, 2681, 7, 76);
INSERT INTO public.who_global_data VALUES (1587, 5715, 1119685, 212, 40484, 7, 138);
INSERT INTO public.who_global_data VALUES (1588, 1838, 521413, 48, 10600, 7, 98);
INSERT INTO public.who_global_data VALUES (1589, 0, 0, 0, 0, 7, 103);
INSERT INTO public.who_global_data VALUES (1590, 5864, 1508674, 302, 37082, 7, 225);
INSERT INTO public.who_global_data VALUES (1591, 13200, 698583, 278, 11886, 7, 131);
INSERT INTO public.who_global_data VALUES (1592, 427, 92968, 11, 1812, 7, 235);
INSERT INTO public.who_global_data VALUES (1593, 341, 150621, 0, 248, 7, 137);
INSERT INTO public.who_global_data VALUES (1594, 456, 77848, 15, 1414, 7, 81);
INSERT INTO public.who_global_data VALUES (1595, 551, 158860, 11, 3424, 7, 182);
INSERT INTO public.who_global_data VALUES (1596, 92, 9996, 1, 46, 7, 145);
INSERT INTO public.who_global_data VALUES (1597, 2737, 724250, 91, 18196, 7, 26);
INSERT INTO public.who_global_data VALUES (1598, 19032, 3832080, 512, 72697, 7, 170);
INSERT INTO public.who_global_data VALUES (1599, 255, 14784, 5, 188, 7, 191);
INSERT INTO public.who_global_data VALUES (1600, 0, 6, 0, 0, 7, 221);
INSERT INTO public.who_global_data VALUES (1601, 0, 376, 0, 0, 7, 64);
INSERT INTO public.who_global_data VALUES (1602, 0, 0, 0, 0, 7, 116);
INSERT INTO public.who_global_data VALUES (1603, 0, 37, 0, 0, 7, 128);
INSERT INTO public.who_global_data VALUES (1604, 77, 1106, 0, 13, 7, 6);
INSERT INTO public.who_global_data VALUES (1605, 0, 1191, 0, 12, 7, 227);
INSERT INTO public.who_global_data VALUES (1606, 0, 24, 0, 0, 7, 68);
INSERT INTO public.who_global_data VALUES (1607, 38, 865, 0, 2, 7, 184);
INSERT INTO public.who_global_data VALUES (1608, 0, 3, 0, 0, 7, 82);
INSERT INTO public.who_global_data VALUES (1609, 27, 2996, 0, 65, 7, 149);
INSERT INTO public.who_global_data VALUES (1610, 13, 1245, 0, 17, 7, 197);
INSERT INTO public.who_global_data VALUES (1611, 267, 367543, 2, 6368, 7, 78);
INSERT INTO public.who_global_data VALUES (1612, 184, 25895, 3, 617, 7, 233);
INSERT INTO public.who_global_data VALUES (1613, 1717, 392354, 18, 3983, 7, 133);
INSERT INTO public.who_global_data VALUES (1614, 27, 1157, 0, 3, 7, 35);
INSERT INTO public.who_global_data VALUES (1615, 100, 3382, 2, 79, 7, 114);
INSERT INTO public.who_global_data VALUES (1616, 24, 59449, 0, 29, 7, 237);
INSERT INTO public.who_global_data VALUES (1617, 0, 20, 0, 0, 7, 55);
INSERT INTO public.who_global_data VALUES (1618, 15, 1822, 0, 27, 7, 176);
INSERT INTO public.who_global_data VALUES (1619, 991, 246999, 70, 4565, 7, 202);
INSERT INTO public.who_global_data VALUES (1620, 1304, 165887, 23, 3732, 7, 155);
INSERT INTO public.who_global_data VALUES (1621, 0, 17, 0, 0, 7, 32);
INSERT INTO public.who_global_data VALUES (1622, 0, 4784, 0, 130, 7, 220);
INSERT INTO public.who_global_data VALUES (1623, 6141, 1443939, 528, 43633, 7, 30);
INSERT INTO public.who_global_data VALUES (1624, 32, 3961, 0, 64, 7, 147);
INSERT INTO public.who_global_data VALUES (1625, 32003, 2800564, 344, 59263, 7, 208);
INSERT INTO public.who_global_data VALUES (1626, 859, 62445, 8, 305, 7, 45);
INSERT INTO public.who_global_data VALUES (1627, 40, 29380, 3, 1804, 7, 110);
INSERT INTO public.who_global_data VALUES (1628, 50, 8293, 2, 154, 7, 88);
INSERT INTO public.who_global_data VALUES (1629, 2376, 566922, 22, 11955, 7, 51);
INSERT INTO public.who_global_data VALUES (1630, 1766, 521117, 27, 8687, 7, 209);
INSERT INTO public.who_global_data VALUES (1631, 59, 13944, 5, 911, 7, 205);
INSERT INTO public.who_global_data VALUES (1632, 0, 13714, 0, 91, 7, 18);
INSERT INTO public.who_global_data VALUES (1633, 930, 17953, 1, 77, 7, 72);
INSERT INTO public.who_global_data VALUES (1634, 29079, 3772817, 1223, 104349, 7, 44);
INSERT INTO public.who_global_data VALUES (1635, 1, 70, 0, 0, 7, 15);
INSERT INTO public.who_global_data VALUES (1636, 0, 4922, 0, 76, 7, 25);
INSERT INTO public.who_global_data VALUES (1637, 0, 0, 0, 0, 7, 179);
INSERT INTO public.who_global_data VALUES (1638, 0, 0, 0, 0, 7, 34);
INSERT INTO public.who_global_data VALUES (1639, 11, 7520, 0, 134, 7, 207);
INSERT INTO public.who_global_data VALUES (1640, 1679, 206030, 91, 6599, 7, 166);
INSERT INTO public.who_global_data VALUES (1641, 6912, 2464030, 131, 25736, 7, 126);
INSERT INTO public.who_global_data VALUES (1642, 0, 0, 0, 0, 7, 97);
INSERT INTO public.who_global_data VALUES (1643, 48, 1435, 0, 8, 7, 36);
INSERT INTO public.who_global_data VALUES (1644, 0, 0, 0, 0, 7, 125);
INSERT INTO public.who_global_data VALUES (1645, 66, 39490, 6, 324, 7, 124);
INSERT INTO public.who_global_data VALUES (1646, 4685, 1216278, 149, 22628, 7, 185);
INSERT INTO public.who_global_data VALUES (1647, 3962, 297014, 7, 826, 7, 194);
INSERT INTO public.who_global_data VALUES (1648, 0, 509, 0, 21, 7, 144);
INSERT INTO public.who_global_data VALUES (1649, 158153, 25512197, 3982, 429652, 7, 19);
INSERT INTO public.who_global_data VALUES (1650, 14, 2398, 0, 24, 7, 217);
INSERT INTO public.who_global_data VALUES (1651, 559, 39887, 8, 415, 7, 148);
INSERT INTO public.who_global_data VALUES (1652, 70, 78672, 0, 621, 7, 86);
INSERT INTO public.who_global_data VALUES (1653, 0, 1, 0, 0, 7, 13);
INSERT INTO public.who_global_data VALUES (1654, 406, 125364, 6, 1171, 7, 157);
INSERT INTO public.who_global_data VALUES (1655, 88, 1739, 0, 35, 7, 8);
INSERT INTO public.who_global_data VALUES (1656, 0, 5, 0, 0, 7, 73);
INSERT INTO public.who_global_data VALUES (1657, 0, 2124, 0, 616, 7, 101);
INSERT INTO public.who_global_data VALUES (1658, 1305, 51624, 23, 728, 7, 165);
INSERT INTO public.who_global_data VALUES (1659, 306, 32952, 18, 1178, 7, 14);
INSERT INTO public.who_global_data VALUES (1660, 48, 54939, 2, 2399, 8, 193);
INSERT INTO public.who_global_data VALUES (1661, 887, 75454, 11, 1350, 8, 113);
INSERT INTO public.who_global_data VALUES (1662, 251, 106610, 4, 2881, 8, 143);
INSERT INTO public.who_global_data VALUES (1663, 0, 0, 0, 0, 8, 219);
INSERT INTO public.who_global_data VALUES (1664, 63, 9779, 2, 100, 8, 186);
INSERT INTO public.who_global_data VALUES (1665, 92, 19672, 2, 464, 8, 52);
INSERT INTO public.who_global_data VALUES (1666, 0, 16, 0, 0, 8, 180);
INSERT INTO public.who_global_data VALUES (1667, 14, 215, 0, 6, 8, 167);
INSERT INTO public.who_global_data VALUES (1668, 10843, 1896053, 182, 47435, 8, 154);
INSERT INTO public.who_global_data VALUES (1669, 59, 166728, 2, 3069, 8, 94);
INSERT INTO public.who_global_data VALUES (1670, 41, 6809, 1, 58, 8, 66);
INSERT INTO public.who_global_data VALUES (1671, 8, 28794, 0, 909, 8, 58);
INSERT INTO public.who_global_data VALUES (1672, 1238, 406767, 43, 7558, 8, 163);
INSERT INTO public.who_global_data VALUES (1673, 209, 229793, 8, 3113, 8, 37);
INSERT INTO public.who_global_data VALUES (1674, 6, 8167, 0, 175, 8, 142);
INSERT INTO public.who_global_data VALUES (1675, 387, 101503, 1, 372, 8, 83);
INSERT INTO public.who_global_data VALUES (1676, 509, 533953, 15, 8087, 8, 228);
INSERT INTO public.who_global_data VALUES (1677, 16, 1443, 1, 11, 8, 188);
INSERT INTO public.who_global_data VALUES (1678, 1718, 242851, 10, 1688, 8, 62);
INSERT INTO public.who_global_data VALUES (1679, 2498, 706599, 54, 21040, 8, 160);
INSERT INTO public.who_global_data VALUES (1680, 28, 11816, 1, 294, 8, 50);
INSERT INTO public.who_global_data VALUES (1681, 0, 3786, 0, 48, 8, 33);
INSERT INTO public.who_global_data VALUES (1682, 1, 689, 0, 12, 8, 183);
INSERT INTO public.who_global_data VALUES (1683, 1, 857, 0, 1, 8, 92);
INSERT INTO public.who_global_data VALUES (1684, 2866, 208074, 62, 10167, 8, 158);
INSERT INTO public.who_global_data VALUES (1685, 2, 362, 0, 3, 8, 67);
INSERT INTO public.who_global_data VALUES (1686, 330, 121194, 16, 4659, 8, 57);
INSERT INTO public.who_global_data VALUES (1687, 0, 20658, 0, 124, 8, 38);
INSERT INTO public.who_global_data VALUES (1688, 63520, 8996876, 1283, 220161, 8, 141);
INSERT INTO public.who_global_data VALUES (1689, 0, 137, 0, 1, 8, 178);
INSERT INTO public.who_global_data VALUES (1690, 4, 180, 0, 3, 8, 108);
INSERT INTO public.who_global_data VALUES (1691, 560, 217574, 29, 8973, 8, 39);
INSERT INTO public.who_global_data VALUES (1692, 160, 10377, 0, 120, 8, 2);
INSERT INTO public.who_global_data VALUES (1693, 20, 1604, 0, 2, 8, 195);
INSERT INTO public.who_global_data VALUES (1694, 62, 13784, 2, 131, 8, 107);
INSERT INTO public.who_global_data VALUES (1695, 2, 463, 0, 0, 8, 161);
INSERT INTO public.who_global_data VALUES (1696, 0, 29617, 0, 462, 8, 212);
INSERT INTO public.who_global_data VALUES (1697, 4204, 761226, 130, 19533, 8, 181);
INSERT INTO public.who_global_data VALUES (1698, 1, 385, 0, 2, 8, 53);
INSERT INTO public.who_global_data VALUES (1699, 0, 4981, 0, 63, 8, 164);
INSERT INTO public.who_global_data VALUES (1700, 27, 3296, 1, 118, 8, 140);
INSERT INTO public.who_global_data VALUES (1701, 4255, 714143, 134, 18174, 8, 20);
INSERT INTO public.who_global_data VALUES (1702, 93, 100641, 2, 4820, 8, 112);
INSERT INTO public.who_global_data VALUES (1703, 13953, 2055305, 395, 52523, 8, 111);
INSERT INTO public.who_global_data VALUES (1704, 106, 2598, 4, 85, 8, 71);
INSERT INTO public.who_global_data VALUES (1705, 0, 7887, 0, 117, 8, 218);
INSERT INTO public.who_global_data VALUES (1706, 0, 0, 0, 0, 8, 43);
INSERT INTO public.who_global_data VALUES (1707, 721, 192066, 17, 2584, 8, 49);
INSERT INTO public.who_global_data VALUES (1708, 239, 27695, 0, 151, 8, 1);
INSERT INTO public.who_global_data VALUES (1709, 561, 231539, 29, 4972, 8, 48);
INSERT INTO public.who_global_data VALUES (1710, 666, 24105, 4, 208, 8, 232);
INSERT INTO public.who_global_data VALUES (1711, 9, 4567, 0, 20, 8, 175);
INSERT INTO public.who_global_data VALUES (1712, 158, 30538, 4, 197, 8, 21);
INSERT INTO public.who_global_data VALUES (1713, 7982, 972642, 128, 16072, 8, 156);
INSERT INTO public.who_global_data VALUES (1714, 0, 0, 0, 0, 8, 95);
INSERT INTO public.who_global_data VALUES (1715, 144, 22321, 4, 665, 8, 177);
INSERT INTO public.who_global_data VALUES (1716, 668, 197208, 21, 2071, 8, 210);
INSERT INTO public.who_global_data VALUES (1717, 3, 5929, 0, 62, 8, 120);
INSERT INTO public.who_global_data VALUES (1718, 4, 117, 0, 0, 8, 135);
INSERT INTO public.who_global_data VALUES (1719, 1155, 208610, 24, 2603, 8, 206);
INSERT INTO public.who_global_data VALUES (1720, 2465, 246000, 62, 14766, 8, 189);
INSERT INTO public.who_global_data VALUES (1721, 521, 164282, 54, 9169, 8, 129);
INSERT INTO public.who_global_data VALUES (1722, 0, 53989, 10, 1599, 8, 121);
INSERT INTO public.who_global_data VALUES (1723, 0, 5492, 0, 86, 8, 59);
INSERT INTO public.who_global_data VALUES (1724, 0, 2085, 0, 7, 8, 96);
INSERT INTO public.who_global_data VALUES (1725, 687, 43343, 3, 409, 8, 41);
INSERT INTO public.who_global_data VALUES (1726, 232, 15283, 16, 538, 8, 216);
INSERT INTO public.who_global_data VALUES (1727, 549, 135594, 2, 2085, 8, 236);
INSERT INTO public.who_global_data VALUES (1728, 0, 38, 0, 0, 8, 150);
INSERT INTO public.who_global_data VALUES (1729, 0, 654, 0, 1, 8, 61);
INSERT INTO public.who_global_data VALUES (1730, 0, 55, 0, 2, 8, 7);
INSERT INTO public.who_global_data VALUES (1731, 423, 44039, 4, 664, 8, 169);
INSERT INTO public.who_global_data VALUES (1732, 23347, 3079545, 343, 74405, 8, 28);
INSERT INTO public.who_global_data VALUES (1733, 75, 15932, 0, 76, 8, 85);
INSERT INTO public.who_global_data VALUES (1734, 37, 18033, 0, 131, 8, 211);
INSERT INTO public.who_global_data VALUES (1735, 0, 10536, 0, 68, 8, 60);
INSERT INTO public.who_global_data VALUES (1736, 0, 4019, 0, 128, 8, 3);
INSERT INTO public.who_global_data VALUES (1737, 669, 256956, 21, 3148, 8, 11);
INSERT INTO public.who_global_data VALUES (1738, 14022, 2192850, 839, 55752, 8, 89);
INSERT INTO public.who_global_data VALUES (1739, 1132, 63883, 13, 390, 8, 24);
INSERT INTO public.who_global_data VALUES (1740, 33, 4057, 1, 70, 8, 162);
INSERT INTO public.who_global_data VALUES (1741, 713, 154796, 18, 5742, 8, 100);
INSERT INTO public.who_global_data VALUES (1742, 0, 30, 0, 0, 8, 47);
INSERT INTO public.who_global_data VALUES (1743, 0, 148, 0, 1, 8, 29);
INSERT INTO public.who_global_data VALUES (1744, 0, 9056, 0, 157, 8, 40);
INSERT INTO public.who_global_data VALUES (1745, 4, 7365, 0, 129, 8, 222);
INSERT INTO public.who_global_data VALUES (1746, 1098, 157595, 30, 5543, 8, 132);
INSERT INTO public.who_global_data VALUES (1747, 22, 391, 0, 13, 8, 130);
INSERT INTO public.who_global_data VALUES (1748, 18, 14435, 0, 82, 8, 234);
INSERT INTO public.who_global_data VALUES (1749, 61, 2605, 0, 45, 8, 23);
INSERT INTO public.who_global_data VALUES (1750, 34, 7380, 2, 174, 8, 192);
INSERT INTO public.who_global_data VALUES (1751, 116, 11402, 1, 244, 8, 69);
INSERT INTO public.who_global_data VALUES (1752, 0, 26, 0, 0, 8, 187);
INSERT INTO public.who_global_data VALUES (1753, 1127, 144007, 26, 3512, 8, 230);
INSERT INTO public.who_global_data VALUES (1754, 1459, 364909, 83, 12374, 8, 77);
INSERT INTO public.who_global_data VALUES (1755, 1, 6001, 0, 29, 8, 9);
INSERT INTO public.who_global_data VALUES (1756, 18855, 10720048, 163, 154010, 8, 74);
INSERT INTO public.who_global_data VALUES (1757, 13695, 1037993, 476, 29331, 8, 224);
INSERT INTO public.who_global_data VALUES (1758, 6527, 1398841, 85, 57736, 8, 199);
INSERT INTO public.who_global_data VALUES (1759, 943, 617202, 6, 13024, 8, 190);
INSERT INTO public.who_global_data VALUES (1760, 2463, 193645, 47, 3167, 8, 12);
INSERT INTO public.who_global_data VALUES (1761, 0, 432, 0, 25, 8, 104);
INSERT INTO public.who_global_data VALUES (1762, 6488, 622416, 72, 4634, 8, 153);
INSERT INTO public.who_global_data VALUES (1763, 14360, 2515507, 492, 87381, 8, 91);
INSERT INTO public.who_global_data VALUES (1764, 194, 15435, 2, 344, 8, 215);
INSERT INTO public.who_global_data VALUES (1765, 3909, 379516, 91, 5452, 8, 84);
INSERT INTO public.who_global_data VALUES (1766, 4, 3134, 1, 64, 8, 231);
INSERT INTO public.who_global_data VALUES (1767, 1058, 324169, 7, 4269, 8, 196);
INSERT INTO public.who_global_data VALUES (1768, 1440, 233156, 0, 3035, 8, 105);
INSERT INTO public.who_global_data VALUES (1769, 99, 100422, 2, 1753, 8, 122);
INSERT INTO public.who_global_data VALUES (1770, 0, 0, 0, 0, 8, 159);
INSERT INTO public.who_global_data VALUES (1771, 316, 59264, 3, 1472, 8, 75);
INSERT INTO public.who_global_data VALUES (1772, 588, 163450, 1, 958, 8, 27);
INSERT INTO public.who_global_data VALUES (1773, 74, 84377, 1, 1409, 8, 54);
INSERT INTO public.who_global_data VALUES (1774, 0, 44, 0, 0, 8, 226);
INSERT INTO public.who_global_data VALUES (1775, 965, 63992, 10, 1148, 8, 79);
INSERT INTO public.who_global_data VALUES (1776, 3497, 293157, 68, 2621, 8, 56);
INSERT INTO public.who_global_data VALUES (1777, 0, 8142, 0, 160, 8, 117);
INSERT INTO public.who_global_data VALUES (1778, 0, 1936, 0, 84, 8, 152);
INSERT INTO public.who_global_data VALUES (1779, 715, 116779, 30, 1832, 8, 16);
INSERT INTO public.who_global_data VALUES (1780, 0, 2550, 0, 46, 8, 10);
INSERT INTO public.who_global_data VALUES (1781, 858, 181028, 16, 2762, 8, 201);
INSERT INTO public.who_global_data VALUES (1782, 139, 50228, 3, 574, 8, 174);
INSERT INTO public.who_global_data VALUES (1783, 0, 18743, 0, 279, 8, 119);
INSERT INTO public.who_global_data VALUES (1784, 644, 22304, 73, 628, 8, 168);
INSERT INTO public.who_global_data VALUES (1785, 4094, 198208, 10, 717, 8, 99);
INSERT INTO public.who_global_data VALUES (1786, 106, 15496, 0, 51, 8, 171);
INSERT INTO public.who_global_data VALUES (1787, 19, 8056, 2, 329, 8, 87);
INSERT INTO public.who_global_data VALUES (1788, 185, 17585, 3, 264, 8, 123);
INSERT INTO public.who_global_data VALUES (1789, 0, 4, 0, 0, 8, 151);
INSERT INTO public.who_global_data VALUES (1790, 0, 6370, 0, 44, 8, 213);
INSERT INTO public.who_global_data VALUES (1791, 238, 16460, 8, 418, 8, 118);
INSERT INTO public.who_global_data VALUES (1792, 0, 568, 0, 10, 8, 134);
INSERT INTO public.who_global_data VALUES (1793, 347, 8231, 1, 61, 8, 65);
INSERT INTO public.who_global_data VALUES (1794, 17944, 1806849, 1623, 153639, 8, 102);
INSERT INTO public.who_global_data VALUES (1795, 0, 0, 0, 0, 8, 223);
INSERT INTO public.who_global_data VALUES (1796, 17, 1430, 1, 11, 8, 4);
INSERT INTO public.who_global_data VALUES (1797, 25, 1692, 0, 2, 8, 146);
INSERT INTO public.who_global_data VALUES (1798, 459, 61175, 10, 800, 8, 31);
INSERT INTO public.who_global_data VALUES (1799, 0, 13, 0, 1, 8, 127);
INSERT INTO public.who_global_data VALUES (1800, 756, 469139, 17, 8224, 8, 22);
INSERT INTO public.who_global_data VALUES (1801, 907, 35833, 11, 347, 8, 115);
INSERT INTO public.who_global_data VALUES (1802, 350, 139152, 14, 3103, 8, 106);
INSERT INTO public.who_global_data VALUES (1803, 194, 33449, 0, 332, 8, 90);
INSERT INTO public.who_global_data VALUES (1804, 0, 0, 0, 0, 8, 70);
INSERT INTO public.who_global_data VALUES (1805, 213, 270588, 0, 2020, 8, 46);
INSERT INTO public.who_global_data VALUES (1806, 4711, 966018, 84, 13810, 8, 139);
INSERT INTO public.who_global_data VALUES (1807, 0, 44, 0, 0, 8, 42);
INSERT INTO public.who_global_data VALUES (1808, 3, 1946, 0, 25, 8, 80);
INSERT INTO public.who_global_data VALUES (1809, 0, 4992, 0, 169, 8, 203);
INSERT INTO public.who_global_data VALUES (1810, 41, 4474, 4, 157, 8, 136);
INSERT INTO public.who_global_data VALUES (1811, 864, 127024, 4, 1547, 8, 63);
INSERT INTO public.who_global_data VALUES (1812, 0, 0, 0, 0, 8, 17);
INSERT INTO public.who_global_data VALUES (1813, 0, 132, 0, 2, 8, 172);
INSERT INTO public.who_global_data VALUES (1814, 336, 91891, 10, 2831, 8, 109);
INSERT INTO public.who_global_data VALUES (1815, 366, 61960, 1, 557, 8, 200);
INSERT INTO public.who_global_data VALUES (1816, 747, 177426, 8, 1990, 8, 93);
INSERT INTO public.who_global_data VALUES (1817, 154, 133728, 2, 1527, 8, 5);
INSERT INTO public.who_global_data VALUES (1818, 0, 745, 0, 13, 8, 214);
INSERT INTO public.who_global_data VALUES (1819, 1910, 539387, 64, 11514, 8, 204);
INSERT INTO public.who_global_data VALUES (1820, 0, 0, 0, 0, 8, 198);
INSERT INTO public.who_global_data VALUES (1821, 1566, 315400, 39, 5176, 8, 173);
INSERT INTO public.who_global_data VALUES (1822, 0, 851, 0, 9, 8, 229);
INSERT INTO public.who_global_data VALUES (1823, 769, 130163, 17, 2668, 8, 76);
INSERT INTO public.who_global_data VALUES (1824, 6731, 1113970, 165, 40272, 8, 138);
INSERT INTO public.who_global_data VALUES (1825, 1168, 519575, 71, 10552, 8, 98);
INSERT INTO public.who_global_data VALUES (1826, 0, 0, 0, 0, 8, 103);
INSERT INTO public.who_global_data VALUES (1827, 6145, 1502810, 337, 36780, 8, 225);
INSERT INTO public.who_global_data VALUES (1828, 16432, 685383, 303, 11608, 8, 131);
INSERT INTO public.who_global_data VALUES (1829, 297, 92541, 7, 1801, 8, 235);
INSERT INTO public.who_global_data VALUES (1830, 347, 150280, 0, 248, 8, 137);
INSERT INTO public.who_global_data VALUES (1831, 469, 77392, 13, 1399, 8, 81);
INSERT INTO public.who_global_data VALUES (1832, 683, 158309, 17, 3413, 8, 182);
INSERT INTO public.who_global_data VALUES (1833, 0, 9904, 0, 45, 8, 145);
INSERT INTO public.who_global_data VALUES (1834, 2901, 721513, 90, 18105, 8, 26);
INSERT INTO public.who_global_data VALUES (1835, 19238, 3813048, 534, 72185, 8, 170);
INSERT INTO public.who_global_data VALUES (1836, 363, 14529, 0, 183, 8, 191);
INSERT INTO public.who_global_data VALUES (1837, 0, 6, 0, 0, 8, 221);
INSERT INTO public.who_global_data VALUES (1838, 0, 376, 0, 0, 8, 64);
INSERT INTO public.who_global_data VALUES (1839, 0, 0, 0, 0, 8, 116);
INSERT INTO public.who_global_data VALUES (1840, 0, 37, 0, 0, 8, 128);
INSERT INTO public.who_global_data VALUES (1841, 60, 1029, 0, 13, 8, 6);
INSERT INTO public.who_global_data VALUES (1842, 0, 1191, 0, 12, 8, 227);
INSERT INTO public.who_global_data VALUES (1843, 1, 24, 0, 0, 8, 68);
INSERT INTO public.who_global_data VALUES (1844, 29, 827, 0, 2, 8, 184);
INSERT INTO public.who_global_data VALUES (1845, 0, 3, 0, 0, 8, 82);
INSERT INTO public.who_global_data VALUES (1846, 28, 2969, 0, 65, 8, 149);
INSERT INTO public.who_global_data VALUES (1847, 11, 1232, 0, 17, 8, 197);
INSERT INTO public.who_global_data VALUES (1848, 253, 367276, 3, 6366, 8, 78);
INSERT INTO public.who_global_data VALUES (1849, 304, 25711, 13, 614, 8, 233);
INSERT INTO public.who_global_data VALUES (1850, 1592, 390637, 21, 3965, 8, 133);
INSERT INTO public.who_global_data VALUES (1851, 0, 1130, 0, 3, 8, 35);
INSERT INTO public.who_global_data VALUES (1852, 46, 3282, 0, 77, 8, 114);
INSERT INTO public.who_global_data VALUES (1853, 34, 59425, 0, 29, 8, 237);
INSERT INTO public.who_global_data VALUES (1854, 0, 20, 0, 0, 8, 55);
INSERT INTO public.who_global_data VALUES (1855, 40, 1807, 0, 27, 8, 176);
INSERT INTO public.who_global_data VALUES (1856, 2581, 246008, 84, 4495, 8, 202);
INSERT INTO public.who_global_data VALUES (1857, 1348, 164583, 44, 3709, 8, 155);
INSERT INTO public.who_global_data VALUES (1858, 0, 17, 0, 0, 8, 32);
INSERT INTO public.who_global_data VALUES (1859, 0, 4784, 0, 130, 8, 220);
INSERT INTO public.who_global_data VALUES (1860, 7150, 1437798, 555, 43105, 8, 30);
INSERT INTO public.who_global_data VALUES (1861, 47, 3929, 0, 64, 8, 147);
INSERT INTO public.who_global_data VALUES (1862, 34570, 2768561, 384, 58919, 8, 208);
INSERT INTO public.who_global_data VALUES (1863, 892, 61586, 7, 297, 8, 45);
INSERT INTO public.who_global_data VALUES (1864, 49, 29340, 3, 1801, 8, 110);
INSERT INTO public.who_global_data VALUES (1865, 69, 8243, 2, 152, 8, 88);
INSERT INTO public.who_global_data VALUES (1866, 4109, 564546, 22, 11933, 8, 51);
INSERT INTO public.who_global_data VALUES (1867, 1767, 519351, 32, 8660, 8, 209);
INSERT INTO public.who_global_data VALUES (1868, 62, 13885, 6, 906, 8, 205);
INSERT INTO public.who_global_data VALUES (1869, 0, 13714, 0, 91, 8, 18);
INSERT INTO public.who_global_data VALUES (1870, 802, 17023, 0, 76, 8, 72);
INSERT INTO public.who_global_data VALUES (1871, 28680, 3743738, 1239, 103126, 8, 44);
INSERT INTO public.who_global_data VALUES (1872, 1, 69, 0, 0, 8, 15);
INSERT INTO public.who_global_data VALUES (1873, 52, 4922, 0, 76, 8, 25);
INSERT INTO public.who_global_data VALUES (1874, 0, 0, 0, 0, 8, 179);
INSERT INTO public.who_global_data VALUES (1875, 0, 0, 0, 0, 8, 34);
INSERT INTO public.who_global_data VALUES (1876, 13, 7509, 0, 134, 8, 207);
INSERT INTO public.who_global_data VALUES (1877, 2028, 204351, 62, 6508, 8, 166);
INSERT INTO public.who_global_data VALUES (1878, 7279, 2457118, 129, 25605, 8, 126);
INSERT INTO public.who_global_data VALUES (1879, 0, 0, 0, 0, 8, 97);
INSERT INTO public.who_global_data VALUES (1880, 75, 1387, 0, 8, 8, 36);
INSERT INTO public.who_global_data VALUES (1881, 0, 0, 0, 0, 8, 125);
INSERT INTO public.who_global_data VALUES (1882, 110, 39424, 0, 318, 8, 124);
INSERT INTO public.who_global_data VALUES (1883, 5181, 1211593, 128, 22479, 8, 185);
INSERT INTO public.who_global_data VALUES (1884, 3966, 293052, 8, 819, 8, 194);
INSERT INTO public.who_global_data VALUES (1885, 0, 509, 0, 21, 8, 144);
INSERT INTO public.who_global_data VALUES (1886, 155203, 25354044, 4100, 425670, 8, 19);
INSERT INTO public.who_global_data VALUES (1887, 11, 2384, 0, 24, 8, 217);
INSERT INTO public.who_global_data VALUES (1888, 648, 39328, 6, 407, 8, 148);
INSERT INTO public.who_global_data VALUES (1889, 46, 78602, 0, 621, 8, 86);
INSERT INTO public.who_global_data VALUES (1890, 0, 1, 0, 0, 8, 13);
INSERT INTO public.who_global_data VALUES (1891, 433, 124958, 6, 1165, 8, 157);
INSERT INTO public.who_global_data VALUES (1892, 98, 1651, 0, 35, 8, 8);
INSERT INTO public.who_global_data VALUES (1893, 0, 5, 0, 0, 8, 73);
INSERT INTO public.who_global_data VALUES (1894, 0, 2124, 0, 616, 8, 101);
INSERT INTO public.who_global_data VALUES (1895, 1408, 50319, 17, 705, 8, 165);
INSERT INTO public.who_global_data VALUES (1896, 342, 32646, 38, 1160, 8, 14);
INSERT INTO public.who_global_data VALUES (1897, 37, 54891, 8, 2397, 9, 193);
INSERT INTO public.who_global_data VALUES (1898, 876, 74567, 7, 1339, 9, 113);
INSERT INTO public.who_global_data VALUES (1899, 262, 106359, 6, 2877, 9, 143);
INSERT INTO public.who_global_data VALUES (1900, 0, 0, 0, 0, 9, 219);
INSERT INTO public.who_global_data VALUES (1901, 78, 9716, 1, 98, 9, 186);
INSERT INTO public.who_global_data VALUES (1902, 27, 19580, 0, 462, 9, 52);
INSERT INTO public.who_global_data VALUES (1903, 0, 16, 0, 0, 9, 180);
INSERT INTO public.who_global_data VALUES (1904, 0, 201, 0, 6, 9, 167);
INSERT INTO public.who_global_data VALUES (1905, 10409, 1885210, 219, 47253, 9, 154);
INSERT INTO public.who_global_data VALUES (1906, 242, 166669, 11, 3067, 9, 94);
INSERT INTO public.who_global_data VALUES (1907, 26, 6768, 0, 57, 9, 66);
INSERT INTO public.who_global_data VALUES (1908, 6, 28786, 0, 909, 9, 58);
INSERT INTO public.who_global_data VALUES (1909, 1606, 405529, 53, 7515, 9, 163);
INSERT INTO public.who_global_data VALUES (1910, 226, 229584, 5, 3105, 9, 37);
INSERT INTO public.who_global_data VALUES (1911, 21, 8161, 0, 175, 9, 142);
INSERT INTO public.who_global_data VALUES (1912, 427, 101116, 1, 371, 9, 83);
INSERT INTO public.who_global_data VALUES (1913, 528, 533444, 17, 8072, 9, 228);
INSERT INTO public.who_global_data VALUES (1914, 26, 1427, 0, 10, 9, 188);
INSERT INTO public.who_global_data VALUES (1915, 1651, 241133, 10, 1678, 9, 62);
INSERT INTO public.who_global_data VALUES (1916, 2466, 704101, 41, 20986, 9, 160);
INSERT INTO public.who_global_data VALUES (1917, 18, 11788, 0, 293, 9, 50);
INSERT INTO public.who_global_data VALUES (1918, 0, 3786, 0, 48, 9, 33);
INSERT INTO public.who_global_data VALUES (1919, 2, 688, 0, 12, 9, 183);
INSERT INTO public.who_global_data VALUES (1920, 0, 856, 0, 1, 9, 92);
INSERT INTO public.who_global_data VALUES (1921, 2390, 205208, 54, 10105, 9, 158);
INSERT INTO public.who_global_data VALUES (1922, 4, 360, 0, 3, 9, 67);
INSERT INTO public.who_global_data VALUES (1923, 332, 120864, 22, 4643, 9, 57);
INSERT INTO public.who_global_data VALUES (1924, 0, 20658, 0, 124, 9, 38);
INSERT INTO public.who_global_data VALUES (1925, 61963, 8933356, 1214, 218878, 9, 141);
INSERT INTO public.who_global_data VALUES (1926, 0, 137, 0, 1, 9, 178);
INSERT INTO public.who_global_data VALUES (1927, 0, 176, 0, 3, 9, 108);
INSERT INTO public.who_global_data VALUES (1928, 598, 217014, 28, 8944, 9, 39);
INSERT INTO public.who_global_data VALUES (1929, 60, 10217, 2, 120, 9, 2);
INSERT INTO public.who_global_data VALUES (1930, 42, 1584, 0, 2, 9, 195);
INSERT INTO public.who_global_data VALUES (1931, 103, 13722, 0, 129, 9, 107);
INSERT INTO public.who_global_data VALUES (1932, 1, 461, 0, 0, 9, 161);
INSERT INTO public.who_global_data VALUES (1933, 0, 29617, 0, 462, 9, 212);
INSERT INTO public.who_global_data VALUES (1934, 4011, 757022, 165, 19403, 9, 181);
INSERT INTO public.who_global_data VALUES (1935, 1, 384, 0, 2, 9, 53);
INSERT INTO public.who_global_data VALUES (1936, 0, 4981, 0, 63, 9, 164);
INSERT INTO public.who_global_data VALUES (1937, 44, 3269, 1, 117, 9, 140);
INSERT INTO public.who_global_data VALUES (1938, 3388, 709888, 17, 18040, 9, 20);
INSERT INTO public.who_global_data VALUES (1939, 117, 100548, 2, 4818, 9, 112);
INSERT INTO public.who_global_data VALUES (1940, 13606, 2041352, 381, 52128, 9, 111);
INSERT INTO public.who_global_data VALUES (1941, 67, 2492, 4, 81, 9, 71);
INSERT INTO public.who_global_data VALUES (1942, 0, 7887, 0, 117, 9, 218);
INSERT INTO public.who_global_data VALUES (1943, 0, 0, 0, 0, 9, 43);
INSERT INTO public.who_global_data VALUES (1944, 600, 191345, 9, 2567, 9, 49);
INSERT INTO public.who_global_data VALUES (1945, 219, 27456, 4, 151, 9, 1);
INSERT INTO public.who_global_data VALUES (1946, 619, 230978, 30, 4943, 9, 48);
INSERT INTO public.who_global_data VALUES (1947, 825, 23439, 4, 204, 9, 232);
INSERT INTO public.who_global_data VALUES (1948, 10, 4558, 0, 20, 9, 175);
INSERT INTO public.who_global_data VALUES (1949, 128, 30380, 3, 193, 9, 21);
INSERT INTO public.who_global_data VALUES (1950, 8505, 964660, 153, 15944, 9, 156);
INSERT INTO public.who_global_data VALUES (1951, 0, 0, 0, 0, 9, 95);
INSERT INTO public.who_global_data VALUES (1952, 130, 22177, 0, 661, 9, 177);
INSERT INTO public.who_global_data VALUES (1953, 592, 196540, 20, 2050, 9, 210);
INSERT INTO public.who_global_data VALUES (1954, 3, 5926, 0, 62, 9, 120);
INSERT INTO public.who_global_data VALUES (1955, 0, 113, 0, 0, 9, 135);
INSERT INTO public.who_global_data VALUES (1956, 1150, 207455, 15, 2579, 9, 206);
INSERT INTO public.who_global_data VALUES (1957, 1389, 243535, 36, 14704, 9, 189);
INSERT INTO public.who_global_data VALUES (1958, 632, 163761, 48, 9115, 9, 129);
INSERT INTO public.who_global_data VALUES (1959, 510, 53989, 6, 1589, 9, 121);
INSERT INTO public.who_global_data VALUES (1960, 38, 5492, 0, 86, 9, 59);
INSERT INTO public.who_global_data VALUES (1961, 115, 2085, 0, 7, 9, 96);
INSERT INTO public.who_global_data VALUES (1962, 690, 42656, 8, 406, 9, 41);
INSERT INTO public.who_global_data VALUES (1963, 220, 15051, 5, 522, 9, 216);
INSERT INTO public.who_global_data VALUES (1964, 476, 135045, 8, 2083, 9, 236);
INSERT INTO public.who_global_data VALUES (1965, 1, 38, 0, 0, 9, 150);
INSERT INTO public.who_global_data VALUES (1966, 0, 654, 0, 1, 9, 61);
INSERT INTO public.who_global_data VALUES (1967, 0, 55, 0, 2, 9, 7);
INSERT INTO public.who_global_data VALUES (1968, 496, 43616, 5, 660, 9, 169);
INSERT INTO public.who_global_data VALUES (1969, 26406, 3056198, 349, 74062, 9, 28);
INSERT INTO public.who_global_data VALUES (1970, 78, 15857, 0, 76, 9, 85);
INSERT INTO public.who_global_data VALUES (1971, 35, 17996, 0, 131, 9, 211);
INSERT INTO public.who_global_data VALUES (1972, 125, 10536, 1, 68, 9, 60);
INSERT INTO public.who_global_data VALUES (1973, 7, 4019, 0, 128, 9, 3);
INSERT INTO public.who_global_data VALUES (1974, 723, 256287, 19, 3127, 9, 11);
INSERT INTO public.who_global_data VALUES (1975, 17549, 2178828, 941, 54913, 9, 89);
INSERT INTO public.who_global_data VALUES (1976, 616, 62751, 5, 377, 9, 24);
INSERT INTO public.who_global_data VALUES (1977, 32, 4024, 4, 69, 9, 162);
INSERT INTO public.who_global_data VALUES (1978, 857, 154083, 32, 5724, 9, 100);
INSERT INTO public.who_global_data VALUES (1979, 0, 30, 0, 0, 9, 47);
INSERT INTO public.who_global_data VALUES (1980, 0, 148, 0, 1, 9, 29);
INSERT INTO public.who_global_data VALUES (1981, 0, 9056, 0, 157, 9, 40);
INSERT INTO public.who_global_data VALUES (1982, 2, 7361, 0, 129, 9, 222);
INSERT INTO public.who_global_data VALUES (1983, 1038, 156497, 27, 5513, 9, 132);
INSERT INTO public.who_global_data VALUES (1984, 10, 369, 0, 13, 9, 130);
INSERT INTO public.who_global_data VALUES (1985, 38, 14417, 0, 82, 9, 234);
INSERT INTO public.who_global_data VALUES (1986, 2, 2544, 0, 45, 9, 23);
INSERT INTO public.who_global_data VALUES (1987, 29, 7346, 0, 172, 9, 192);
INSERT INTO public.who_global_data VALUES (1988, 0, 11286, 0, 243, 9, 69);
INSERT INTO public.who_global_data VALUES (1989, 0, 26, 0, 0, 9, 187);
INSERT INTO public.who_global_data VALUES (1990, 896, 142880, 24, 3486, 9, 230);
INSERT INTO public.who_global_data VALUES (1991, 1569, 363450, 93, 12291, 9, 77);
INSERT INTO public.who_global_data VALUES (1992, 8, 6000, 0, 29, 9, 9);
INSERT INTO public.who_global_data VALUES (1993, 11666, 10701193, 123, 153847, 9, 74);
INSERT INTO public.who_global_data VALUES (1994, 11948, 1024298, 387, 28855, 9, 224);
INSERT INTO public.who_global_data VALUES (1995, 6608, 1392314, 91, 57651, 9, 199);
INSERT INTO public.who_global_data VALUES (1996, 879, 616259, 8, 13018, 9, 190);
INSERT INTO public.who_global_data VALUES (1997, 1331, 191182, 54, 3120, 9, 12);
INSERT INTO public.who_global_data VALUES (1998, 0, 432, 0, 25, 9, 104);
INSERT INTO public.who_global_data VALUES (1999, 7824, 615928, 75, 4562, 9, 153);
INSERT INTO public.who_global_data VALUES (2000, 15191, 2501147, 467, 86889, 9, 91);
INSERT INTO public.who_global_data VALUES (2001, 88, 15241, 3, 342, 9, 215);
INSERT INTO public.who_global_data VALUES (2002, 3927, 375607, 109, 5361, 9, 84);
INSERT INTO public.who_global_data VALUES (2003, 3, 3130, 0, 63, 9, 231);
INSERT INTO public.who_global_data VALUES (2004, 870, 323111, 14, 4262, 9, 196);
INSERT INTO public.who_global_data VALUES (2005, 1528, 231716, 0, 3035, 9, 105);
INSERT INTO public.who_global_data VALUES (2006, 130, 100323, 1, 1751, 9, 122);
INSERT INTO public.who_global_data VALUES (2007, 0, 0, 0, 0, 9, 159);
INSERT INTO public.who_global_data VALUES (2008, 301, 58948, 8, 1469, 9, 75);
INSERT INTO public.who_global_data VALUES (2009, 580, 162862, 0, 957, 9, 27);
INSERT INTO public.who_global_data VALUES (2010, 128, 84303, 3, 1408, 9, 54);
INSERT INTO public.who_global_data VALUES (2011, 0, 44, 0, 0, 9, 226);
INSERT INTO public.who_global_data VALUES (2012, 1103, 63027, 12, 1138, 9, 79);
INSERT INTO public.who_global_data VALUES (2013, 3906, 289660, 76, 2553, 9, 56);
INSERT INTO public.who_global_data VALUES (2014, 95, 8142, 14, 160, 9, 117);
INSERT INTO public.who_global_data VALUES (2015, 4, 1936, 0, 84, 9, 152);
INSERT INTO public.who_global_data VALUES (2016, 765, 116064, 13, 1802, 9, 16);
INSERT INTO public.who_global_data VALUES (2017, 7, 2550, 0, 46, 9, 10);
INSERT INTO public.who_global_data VALUES (2018, 958, 180170, 30, 2746, 9, 201);
INSERT INTO public.who_global_data VALUES (2019, 237, 50089, 1, 571, 9, 174);
INSERT INTO public.who_global_data VALUES (2020, 0, 18743, 0, 279, 9, 119);
INSERT INTO public.who_global_data VALUES (2021, 830, 21660, 15, 555, 9, 168);
INSERT INTO public.who_global_data VALUES (2022, 3680, 194114, 7, 707, 9, 99);
INSERT INTO public.who_global_data VALUES (2023, 143, 15390, 0, 51, 9, 171);
INSERT INTO public.who_global_data VALUES (2024, 31, 8037, 0, 327, 9, 87);
INSERT INTO public.who_global_data VALUES (2025, 208, 17400, 3, 261, 9, 123);
INSERT INTO public.who_global_data VALUES (2026, 0, 4, 0, 0, 9, 151);
INSERT INTO public.who_global_data VALUES (2027, 0, 6370, 0, 44, 9, 213);
INSERT INTO public.who_global_data VALUES (2028, 0, 16222, 0, 410, 9, 118);
INSERT INTO public.who_global_data VALUES (2029, 0, 568, 0, 10, 9, 134);
INSERT INTO public.who_global_data VALUES (2030, 294, 7884, 1, 60, 9, 65);
INSERT INTO public.who_global_data VALUES (2031, 17165, 1788905, 1743, 152016, 9, 102);
INSERT INTO public.who_global_data VALUES (2032, 0, 0, 0, 0, 9, 223);
INSERT INTO public.who_global_data VALUES (2033, 14, 1413, 2, 10, 9, 4);
INSERT INTO public.who_global_data VALUES (2034, 11, 1667, 0, 2, 9, 146);
INSERT INTO public.who_global_data VALUES (2035, 460, 60716, 7, 790, 9, 31);
INSERT INTO public.who_global_data VALUES (2036, 0, 13, 0, 1, 9, 127);
INSERT INTO public.who_global_data VALUES (2037, 890, 468383, 20, 8207, 9, 22);
INSERT INTO public.who_global_data VALUES (2038, 871, 34926, 7, 336, 9, 115);
INSERT INTO public.who_global_data VALUES (2039, 434, 138802, 7, 3089, 9, 106);
INSERT INTO public.who_global_data VALUES (2040, 298, 33255, 4, 332, 9, 90);
INSERT INTO public.who_global_data VALUES (2041, 0, 0, 0, 0, 9, 70);
INSERT INTO public.who_global_data VALUES (2042, 283, 270375, 3, 2020, 9, 46);
INSERT INTO public.who_global_data VALUES (2043, 4738, 961307, 69, 13726, 9, 139);
INSERT INTO public.who_global_data VALUES (2044, 0, 44, 0, 0, 9, 42);
INSERT INTO public.who_global_data VALUES (2045, 5, 1943, 0, 25, 9, 80);
INSERT INTO public.who_global_data VALUES (2046, 0, 4992, 0, 169, 9, 203);
INSERT INTO public.who_global_data VALUES (2047, 59, 4433, 2, 153, 9, 136);
INSERT INTO public.who_global_data VALUES (2048, 1861, 126160, 21, 1543, 9, 63);
INSERT INTO public.who_global_data VALUES (2049, 0, 0, 0, 0, 9, 17);
INSERT INTO public.who_global_data VALUES (2050, 0, 132, 0, 2, 9, 172);
INSERT INTO public.who_global_data VALUES (2051, 394, 91555, 9, 2821, 9, 109);
INSERT INTO public.who_global_data VALUES (2052, 280, 61594, 6, 556, 9, 200);
INSERT INTO public.who_global_data VALUES (2053, 603, 176679, 5, 1982, 9, 93);
INSERT INTO public.who_global_data VALUES (2054, 167, 133574, 1, 1525, 9, 5);
INSERT INTO public.who_global_data VALUES (2055, 0, 745, 0, 13, 9, 214);
INSERT INTO public.who_global_data VALUES (2056, 1563, 537477, 74, 11450, 9, 204);
INSERT INTO public.who_global_data VALUES (2057, 0, 0, 0, 0, 9, 198);
INSERT INTO public.who_global_data VALUES (2058, 1676, 313834, 39, 5137, 9, 173);
INSERT INTO public.who_global_data VALUES (2059, 1, 851, 0, 9, 9, 229);
INSERT INTO public.who_global_data VALUES (2060, 1028, 129394, 19, 2651, 9, 76);
INSERT INTO public.who_global_data VALUES (2061, 4444, 1107239, 220, 40107, 9, 138);
INSERT INTO public.who_global_data VALUES (2062, 2241, 518407, 95, 10481, 9, 98);
INSERT INTO public.who_global_data VALUES (2063, 0, 0, 0, 0, 9, 103);
INSERT INTO public.who_global_data VALUES (2064, 7153, 1496665, 389, 36443, 9, 225);
INSERT INTO public.who_global_data VALUES (2065, 15073, 668951, 293, 11305, 9, 131);
INSERT INTO public.who_global_data VALUES (2066, 175, 92244, 11, 1794, 9, 235);
INSERT INTO public.who_global_data VALUES (2067, 338, 149933, 0, 248, 9, 137);
INSERT INTO public.who_global_data VALUES (2068, 497, 76923, 8, 1386, 9, 81);
INSERT INTO public.who_global_data VALUES (2069, 654, 157626, 15, 3396, 9, 182);
INSERT INTO public.who_global_data VALUES (2070, 61, 9904, 0, 45, 9, 145);
INSERT INTO public.who_global_data VALUES (2071, 3174, 718612, 77, 18015, 9, 26);
INSERT INTO public.who_global_data VALUES (2072, 19138, 3793810, 575, 71651, 9, 170);
INSERT INTO public.who_global_data VALUES (2073, 281, 14166, 2, 183, 9, 191);
INSERT INTO public.who_global_data VALUES (2074, 0, 6, 0, 0, 9, 221);
INSERT INTO public.who_global_data VALUES (2075, 0, 376, 0, 0, 9, 64);
INSERT INTO public.who_global_data VALUES (2076, 0, 0, 0, 0, 9, 116);
INSERT INTO public.who_global_data VALUES (2077, 2, 37, 0, 0, 9, 128);
INSERT INTO public.who_global_data VALUES (2078, 48, 969, 0, 13, 9, 6);
INSERT INTO public.who_global_data VALUES (2079, 0, 1191, 0, 12, 9, 227);
INSERT INTO public.who_global_data VALUES (2080, 0, 23, 0, 0, 9, 68);
INSERT INTO public.who_global_data VALUES (2081, 35, 798, 0, 2, 9, 184);
INSERT INTO public.who_global_data VALUES (2082, 1, 3, 0, 0, 9, 82);
INSERT INTO public.who_global_data VALUES (2083, 26, 2941, 0, 65, 9, 149);
INSERT INTO public.who_global_data VALUES (2084, 11, 1221, 0, 17, 9, 197);
INSERT INTO public.who_global_data VALUES (2085, 216, 367023, 4, 6363, 9, 78);
INSERT INTO public.who_global_data VALUES (2086, 281, 25407, 9, 601, 9, 233);
INSERT INTO public.who_global_data VALUES (2087, 1839, 389045, 20, 3944, 9, 133);
INSERT INTO public.who_global_data VALUES (2088, 14, 1130, 0, 3, 9, 35);
INSERT INTO public.who_global_data VALUES (2089, 42, 3236, 0, 77, 9, 114);
INSERT INTO public.who_global_data VALUES (2090, 25, 59391, 0, 29, 9, 237);
INSERT INTO public.who_global_data VALUES (2091, 0, 20, 0, 0, 9, 55);
INSERT INTO public.who_global_data VALUES (2092, 9, 1767, 0, 27, 9, 176);
INSERT INTO public.who_global_data VALUES (2093, 2035, 243427, 50, 4411, 9, 202);
INSERT INTO public.who_global_data VALUES (2094, 1516, 163235, 7, 3665, 9, 155);
INSERT INTO public.who_global_data VALUES (2095, 0, 17, 0, 0, 9, 32);
INSERT INTO public.who_global_data VALUES (2096, 0, 4784, 0, 130, 9, 220);
INSERT INTO public.who_global_data VALUES (2097, 7070, 1430648, 753, 42550, 9, 30);
INSERT INTO public.who_global_data VALUES (2098, 0, 3882, 0, 64, 9, 147);
INSERT INTO public.who_global_data VALUES (2099, 36370, 2733991, 339, 58535, 9, 208);
INSERT INTO public.who_global_data VALUES (2100, 772, 60694, 2, 290, 9, 45);
INSERT INTO public.who_global_data VALUES (2101, 225, 29291, 38, 1798, 9, 110);
INSERT INTO public.who_global_data VALUES (2102, 62, 8174, 1, 150, 9, 88);
INSERT INTO public.who_global_data VALUES (2103, 4190, 560437, 37, 11911, 9, 51);
INSERT INTO public.who_global_data VALUES (2104, 1870, 517584, 30, 8628, 9, 209);
INSERT INTO public.who_global_data VALUES (2105, 61, 13823, 5, 900, 9, 205);
INSERT INTO public.who_global_data VALUES (2106, 0, 13714, 0, 91, 9, 18);
INSERT INTO public.who_global_data VALUES (2107, 756, 16221, 0, 76, 9, 72);
INSERT INTO public.who_global_data VALUES (2108, 25308, 3715058, 1725, 101887, 9, 44);
INSERT INTO public.who_global_data VALUES (2109, 0, 68, 0, 0, 9, 15);
INSERT INTO public.who_global_data VALUES (2110, 188, 4870, 0, 76, 9, 25);
INSERT INTO public.who_global_data VALUES (2111, 0, 0, 0, 0, 9, 179);
INSERT INTO public.who_global_data VALUES (2112, 0, 0, 0, 0, 9, 34);
INSERT INTO public.who_global_data VALUES (2113, 6, 7496, 0, 134, 9, 207);
INSERT INTO public.who_global_data VALUES (2114, 1661, 202323, 76, 6446, 9, 166);
INSERT INTO public.who_global_data VALUES (2115, 7489, 2449839, 132, 25476, 9, 126);
INSERT INTO public.who_global_data VALUES (2116, 0, 0, 0, 0, 9, 97);
INSERT INTO public.who_global_data VALUES (2117, 25, 1312, 0, 8, 9, 36);
INSERT INTO public.who_global_data VALUES (2118, 0, 0, 0, 0, 9, 125);
INSERT INTO public.who_global_data VALUES (2119, 53, 39314, 0, 318, 9, 124);
INSERT INTO public.who_global_data VALUES (2120, 5529, 1206412, 149, 22351, 9, 185);
INSERT INTO public.who_global_data VALUES (2121, 3939, 289086, 6, 811, 9, 194);
INSERT INTO public.who_global_data VALUES (2122, 0, 509, 0, 21, 9, 144);
INSERT INTO public.who_global_data VALUES (2123, 148533, 25198841, 3681, 421570, 9, 19);
INSERT INTO public.who_global_data VALUES (2124, 23, 2373, 0, 24, 9, 217);
INSERT INTO public.who_global_data VALUES (2125, 639, 38680, 11, 401, 9, 148);
INSERT INTO public.who_global_data VALUES (2126, 46, 78556, 0, 621, 9, 86);
INSERT INTO public.who_global_data VALUES (2127, 0, 1, 0, 0, 9, 13);
INSERT INTO public.who_global_data VALUES (2128, 413, 124525, 5, 1159, 9, 157);
INSERT INTO public.who_global_data VALUES (2129, 2, 1553, 0, 35, 9, 8);
INSERT INTO public.who_global_data VALUES (2130, 0, 5, 0, 0, 9, 73);
INSERT INTO public.who_global_data VALUES (2131, 1, 2124, 0, 616, 9, 101);
INSERT INTO public.who_global_data VALUES (2132, 1289, 48911, 16, 688, 9, 165);
INSERT INTO public.who_global_data VALUES (2133, 300, 32304, 19, 1122, 9, 14);
INSERT INTO public.who_global_data VALUES (2134, 104, 54854, 0, 2389, 10, 193);
INSERT INTO public.who_global_data VALUES (2135, 879, 73691, 8, 1332, 10, 113);
INSERT INTO public.who_global_data VALUES (2136, 243, 106097, 5, 2871, 10, 143);
INSERT INTO public.who_global_data VALUES (2137, 0, 0, 0, 0, 10, 219);
INSERT INTO public.who_global_data VALUES (2138, 42, 9638, 0, 97, 10, 186);
INSERT INTO public.who_global_data VALUES (2139, 77, 19553, 1, 462, 10, 52);
INSERT INTO public.who_global_data VALUES (2140, 0, 16, 0, 0, 10, 180);
INSERT INTO public.who_global_data VALUES (2141, 0, 201, 0, 6, 10, 167);
INSERT INTO public.who_global_data VALUES (2142, 7578, 1874801, 207, 47034, 10, 154);
INSERT INTO public.who_global_data VALUES (2143, 195, 166427, 4, 3056, 10, 94);
INSERT INTO public.who_global_data VALUES (2144, 19, 6742, 1, 57, 10, 66);
INSERT INTO public.who_global_data VALUES (2145, 3, 28780, 0, 909, 10, 58);
INSERT INTO public.who_global_data VALUES (2146, 1445, 403923, 46, 7462, 10, 163);
INSERT INTO public.who_global_data VALUES (2147, 326, 229358, 7, 3100, 10, 37);
INSERT INTO public.who_global_data VALUES (2148, 7, 8140, 0, 175, 10, 142);
INSERT INTO public.who_global_data VALUES (2149, 459, 100689, 1, 370, 10, 83);
INSERT INTO public.who_global_data VALUES (2150, 515, 532916, 14, 8055, 10, 228);
INSERT INTO public.who_global_data VALUES (2151, 14, 1401, 0, 10, 10, 188);
INSERT INTO public.who_global_data VALUES (2152, 847, 239482, 10, 1668, 10, 62);
INSERT INTO public.who_global_data VALUES (2153, 2723, 701635, 52, 20945, 10, 160);
INSERT INTO public.who_global_data VALUES (2154, 20, 11770, 3, 293, 10, 50);
INSERT INTO public.who_global_data VALUES (2155, 143, 3786, 0, 48, 10, 33);
INSERT INTO public.who_global_data VALUES (2156, 0, 686, 0, 12, 10, 183);
INSERT INTO public.who_global_data VALUES (2157, 0, 856, 0, 1, 10, 92);
INSERT INTO public.who_global_data VALUES (2158, 1781, 202818, 66, 10051, 10, 158);
INSERT INTO public.who_global_data VALUES (2159, 2, 356, 0, 3, 10, 67);
INSERT INTO public.who_global_data VALUES (2160, 389, 120532, 28, 4621, 10, 57);
INSERT INTO public.who_global_data VALUES (2161, 1004, 20658, 19, 124, 10, 38);
INSERT INTO public.who_global_data VALUES (2162, 26816, 8871393, 627, 217664, 10, 141);
INSERT INTO public.who_global_data VALUES (2163, 0, 137, 0, 1, 10, 178);
INSERT INTO public.who_global_data VALUES (2164, 1, 176, 0, 3, 10, 108);
INSERT INTO public.who_global_data VALUES (2165, 827, 216416, 36, 8916, 10, 39);
INSERT INTO public.who_global_data VALUES (2166, 54, 10157, 1, 118, 10, 2);
INSERT INTO public.who_global_data VALUES (2167, 61, 1542, 0, 2, 10, 195);
INSERT INTO public.who_global_data VALUES (2168, 62, 13619, 2, 129, 10, 107);
INSERT INTO public.who_global_data VALUES (2169, 0, 460, 0, 0, 10, 161);
INSERT INTO public.who_global_data VALUES (2170, 0, 29617, 0, 462, 10, 212);
INSERT INTO public.who_global_data VALUES (2171, 5628, 753011, 144, 19238, 10, 181);
INSERT INTO public.who_global_data VALUES (2172, 0, 383, 0, 2, 10, 53);
INSERT INTO public.who_global_data VALUES (2173, 1, 4981, 0, 63, 10, 164);
INSERT INTO public.who_global_data VALUES (2174, 43, 3225, 0, 116, 10, 140);
INSERT INTO public.who_global_data VALUES (2175, 3322, 706500, 24, 18023, 10, 20);
INSERT INTO public.who_global_data VALUES (2176, 140, 100431, 2, 4816, 10, 112);
INSERT INTO public.who_global_data VALUES (2177, 12261, 2027746, 373, 51747, 10, 111);
INSERT INTO public.who_global_data VALUES (2178, 75, 2425, 1, 77, 10, 71);
INSERT INTO public.who_global_data VALUES (2179, 0, 7887, 0, 117, 10, 218);
INSERT INTO public.who_global_data VALUES (2180, 0, 0, 0, 0, 10, 43);
INSERT INTO public.who_global_data VALUES (2181, 355, 190745, 15, 2558, 10, 49);
INSERT INTO public.who_global_data VALUES (2182, 387, 27237, 1, 147, 10, 1);
INSERT INTO public.who_global_data VALUES (2183, 857, 230359, 31, 4913, 10, 48);
INSERT INTO public.who_global_data VALUES (2184, 786, 22614, 3, 200, 10, 232);
INSERT INTO public.who_global_data VALUES (2185, 0, 4548, 0, 20, 10, 175);
INSERT INTO public.who_global_data VALUES (2186, 109, 30252, 2, 190, 10, 21);
INSERT INTO public.who_global_data VALUES (2187, 9209, 956155, 173, 15791, 10, 156);
INSERT INTO public.who_global_data VALUES (2188, 0, 0, 0, 0, 10, 95);
INSERT INTO public.who_global_data VALUES (2189, 0, 22047, 0, 661, 10, 177);
INSERT INTO public.who_global_data VALUES (2190, 652, 195948, 20, 2030, 10, 210);
INSERT INTO public.who_global_data VALUES (2191, 3, 5923, 1, 62, 10, 120);
INSERT INTO public.who_global_data VALUES (2192, 0, 113, 0, 0, 10, 135);
INSERT INTO public.who_global_data VALUES (2193, 1143, 206305, 19, 2564, 10, 206);
INSERT INTO public.who_global_data VALUES (2194, 579, 242146, 29, 14668, 10, 189);
INSERT INTO public.who_global_data VALUES (2195, 643, 163129, 55, 9067, 10, 129);
INSERT INTO public.who_global_data VALUES (2196, 0, 53479, 11, 1583, 10, 121);
INSERT INTO public.who_global_data VALUES (2197, 0, 5454, 0, 86, 10, 59);
INSERT INTO public.who_global_data VALUES (2198, 30, 1970, 0, 7, 10, 96);
INSERT INTO public.who_global_data VALUES (2199, 636, 41966, 6, 398, 10, 41);
INSERT INTO public.who_global_data VALUES (2200, 347, 14831, 24, 517, 10, 216);
INSERT INTO public.who_global_data VALUES (2201, 437, 134569, 4, 2075, 10, 236);
INSERT INTO public.who_global_data VALUES (2202, 0, 37, 0, 0, 10, 150);
INSERT INTO public.who_global_data VALUES (2203, 2, 654, 0, 1, 10, 61);
INSERT INTO public.who_global_data VALUES (2204, 0, 55, 0, 2, 10, 7);
INSERT INTO public.who_global_data VALUES (2205, 348, 43120, 0, 655, 10, 169);
INSERT INTO public.who_global_data VALUES (2206, 22086, 3029792, 612, 73713, 10, 28);
INSERT INTO public.who_global_data VALUES (2207, 77, 15779, 0, 76, 10, 85);
INSERT INTO public.who_global_data VALUES (2208, 49, 17961, 2, 131, 10, 211);
INSERT INTO public.who_global_data VALUES (2209, 0, 10411, 0, 67, 10, 60);
INSERT INTO public.who_global_data VALUES (2210, 4, 4012, 0, 128, 10, 3);
INSERT INTO public.who_global_data VALUES (2211, 742, 255564, 12, 3108, 10, 11);
INSERT INTO public.who_global_data VALUES (2212, 13202, 2161279, 982, 53972, 10, 89);
INSERT INTO public.who_global_data VALUES (2213, 0, 62135, 0, 372, 10, 24);
INSERT INTO public.who_global_data VALUES (2214, 26, 3992, 2, 65, 10, 162);
INSERT INTO public.who_global_data VALUES (2215, 814, 153226, 21, 5692, 10, 100);
INSERT INTO public.who_global_data VALUES (2216, 0, 30, 0, 0, 10, 47);
INSERT INTO public.who_global_data VALUES (2217, 0, 148, 0, 1, 10, 29);
INSERT INTO public.who_global_data VALUES (2218, 0, 9056, 0, 157, 10, 40);
INSERT INTO public.who_global_data VALUES (2219, 12, 7359, 0, 129, 10, 222);
INSERT INTO public.who_global_data VALUES (2220, 1029, 155459, 17, 5486, 10, 132);
INSERT INTO public.who_global_data VALUES (2221, 38, 359, 0, 13, 10, 130);
INSERT INTO public.who_global_data VALUES (2222, 4, 14379, 1, 82, 10, 234);
INSERT INTO public.who_global_data VALUES (2223, 9, 2542, 0, 45, 10, 23);
INSERT INTO public.who_global_data VALUES (2224, 19, 7317, 0, 172, 10, 192);
INSERT INTO public.who_global_data VALUES (2225, 0, 11286, 0, 243, 10, 69);
INSERT INTO public.who_global_data VALUES (2226, 0, 26, 0, 0, 10, 187);
INSERT INTO public.who_global_data VALUES (2227, 1055, 141984, 15, 3462, 10, 230);
INSERT INTO public.who_global_data VALUES (2228, 1004, 361881, 85, 12198, 10, 77);
INSERT INTO public.who_global_data VALUES (2229, 2, 5992, 0, 29, 10, 9);
INSERT INTO public.who_global_data VALUES (2230, 12689, 10689527, 137, 153724, 10, 74);
INSERT INTO public.who_global_data VALUES (2231, 13094, 1012350, 336, 28468, 10, 224);
INSERT INTO public.who_global_data VALUES (2232, 6420, 1385706, 79, 57560, 10, 199);
INSERT INTO public.who_global_data VALUES (2233, 804, 615380, 10, 13010, 10, 190);
INSERT INTO public.who_global_data VALUES (2234, 928, 189851, 89, 3066, 10, 12);
INSERT INTO public.who_global_data VALUES (2235, 0, 432, 0, 25, 10, 104);
INSERT INTO public.who_global_data VALUES (2236, 8714, 608104, 55, 4487, 10, 153);
INSERT INTO public.who_global_data VALUES (2237, 10584, 2485956, 541, 86422, 10, 91);
INSERT INTO public.who_global_data VALUES (2238, 141, 15153, 1, 339, 10, 215);
INSERT INTO public.who_global_data VALUES (2239, 3537, 371680, 94, 5252, 10, 84);
INSERT INTO public.who_global_data VALUES (2240, 5, 3127, 0, 63, 10, 231);
INSERT INTO public.who_global_data VALUES (2241, 943, 322241, 9, 4248, 10, 196);
INSERT INTO public.who_global_data VALUES (2242, 1496, 230188, 0, 3035, 10, 105);
INSERT INTO public.who_global_data VALUES (2243, 141, 100193, 6, 1750, 10, 122);
INSERT INTO public.who_global_data VALUES (2244, 0, 0, 0, 0, 10, 159);
INSERT INTO public.who_global_data VALUES (2245, 288, 58647, 5, 1461, 10, 75);
INSERT INTO public.who_global_data VALUES (2246, 505, 162282, 3, 957, 10, 27);
INSERT INTO public.who_global_data VALUES (2247, 107, 84175, 3, 1405, 10, 54);
INSERT INTO public.who_global_data VALUES (2248, 0, 44, 0, 0, 10, 226);
INSERT INTO public.who_global_data VALUES (2249, 693, 61924, 12, 1126, 10, 79);
INSERT INTO public.who_global_data VALUES (2250, 3505, 285754, 83, 2477, 10, 56);
INSERT INTO public.who_global_data VALUES (2251, 3, 8047, 12, 146, 10, 117);
INSERT INTO public.who_global_data VALUES (2252, 5, 1932, 0, 84, 10, 152);
INSERT INTO public.who_global_data VALUES (2253, 869, 115299, 7, 1789, 10, 16);
INSERT INTO public.who_global_data VALUES (2254, 17, 2543, 0, 46, 10, 10);
INSERT INTO public.who_global_data VALUES (2255, 1278, 179212, 28, 2716, 10, 201);
INSERT INTO public.who_global_data VALUES (2256, 119, 49852, 4, 570, 10, 174);
INSERT INTO public.who_global_data VALUES (2257, 0, 18743, 0, 279, 10, 119);
INSERT INTO public.who_global_data VALUES (2258, 843, 20830, 22, 540, 10, 168);
INSERT INTO public.who_global_data VALUES (2259, 3585, 190434, 11, 700, 10, 99);
INSERT INTO public.who_global_data VALUES (2260, 145, 15247, 0, 51, 10, 171);
INSERT INTO public.who_global_data VALUES (2261, 23, 8006, 4, 327, 10, 87);
INSERT INTO public.who_global_data VALUES (2262, 193, 17192, 3, 258, 10, 123);
INSERT INTO public.who_global_data VALUES (2263, 0, 4, 0, 0, 10, 151);
INSERT INTO public.who_global_data VALUES (2264, 0, 6370, 0, 44, 10, 213);
INSERT INTO public.who_global_data VALUES (2265, 0, 16222, 0, 410, 10, 118);
INSERT INTO public.who_global_data VALUES (2266, 0, 568, 0, 10, 10, 134);
INSERT INTO public.who_global_data VALUES (2267, 0, 7590, 0, 59, 10, 65);
INSERT INTO public.who_global_data VALUES (2268, 8521, 1771740, 659, 150273, 10, 102);
INSERT INTO public.who_global_data VALUES (2269, 0, 0, 0, 0, 10, 223);
INSERT INTO public.who_global_data VALUES (2270, 31, 1399, 0, 8, 10, 4);
INSERT INTO public.who_global_data VALUES (2271, 13, 1656, 0, 2, 10, 146);
INSERT INTO public.who_global_data VALUES (2272, 498, 60256, 6, 783, 10, 31);
INSERT INTO public.who_global_data VALUES (2273, 0, 13, 0, 1, 10, 127);
INSERT INTO public.who_global_data VALUES (2274, 867, 467493, 15, 8187, 10, 22);
INSERT INTO public.who_global_data VALUES (2275, 1274, 34055, 10, 329, 10, 115);
INSERT INTO public.who_global_data VALUES (2276, 411, 138368, 13, 3082, 10, 106);
INSERT INTO public.who_global_data VALUES (2277, 307, 32957, 9, 328, 10, 90);
INSERT INTO public.who_global_data VALUES (2278, 0, 0, 0, 0, 10, 70);
INSERT INTO public.who_global_data VALUES (2279, 303, 270092, 6, 2017, 10, 46);
INSERT INTO public.who_global_data VALUES (2280, 3964, 956569, 87, 13657, 10, 139);
INSERT INTO public.who_global_data VALUES (2281, 0, 44, 0, 0, 10, 42);
INSERT INTO public.who_global_data VALUES (2282, 5, 1938, 0, 25, 10, 80);
INSERT INTO public.who_global_data VALUES (2283, 39, 4992, 1, 169, 10, 203);
INSERT INTO public.who_global_data VALUES (2284, 0, 4374, 0, 151, 10, 136);
INSERT INTO public.who_global_data VALUES (2285, 1303, 124299, 15, 1522, 10, 63);
INSERT INTO public.who_global_data VALUES (2286, 0, 0, 0, 0, 10, 17);
INSERT INTO public.who_global_data VALUES (2287, 0, 132, 0, 2, 10, 172);
INSERT INTO public.who_global_data VALUES (2288, 444, 91161, 21, 2812, 10, 109);
INSERT INTO public.who_global_data VALUES (2289, 232, 61314, 2, 550, 10, 200);
INSERT INTO public.who_global_data VALUES (2290, 660, 176076, 10, 1977, 10, 93);
INSERT INTO public.who_global_data VALUES (2291, 154, 133407, 2, 1524, 10, 5);
INSERT INTO public.who_global_data VALUES (2292, 0, 745, 0, 13, 10, 214);
INSERT INTO public.who_global_data VALUES (2293, 1873, 535914, 58, 11376, 10, 204);
INSERT INTO public.who_global_data VALUES (2294, 0, 0, 0, 0, 10, 198);
INSERT INTO public.who_global_data VALUES (2295, 914, 312158, 35, 5098, 10, 173);
INSERT INTO public.who_global_data VALUES (2296, 1, 850, 0, 9, 10, 229);
INSERT INTO public.who_global_data VALUES (2297, 714, 128366, 15, 2632, 10, 76);
INSERT INTO public.who_global_data VALUES (2298, 3782, 1102795, 110, 39887, 10, 138);
INSERT INTO public.who_global_data VALUES (2299, 1170, 516166, 94, 10386, 10, 98);
INSERT INTO public.who_global_data VALUES (2300, 0, 0, 0, 0, 10, 103);
INSERT INTO public.who_global_data VALUES (2301, 6790, 1489512, 389, 36054, 10, 225);
INSERT INTO public.who_global_data VALUES (2302, 10765, 653878, 291, 11012, 10, 131);
INSERT INTO public.who_global_data VALUES (2303, 473, 92069, 5, 1783, 10, 235);
INSERT INTO public.who_global_data VALUES (2304, 299, 149595, 0, 248, 10, 137);
INSERT INTO public.who_global_data VALUES (2305, 559, 76426, 7, 1378, 10, 81);
INSERT INTO public.who_global_data VALUES (2306, 546, 156972, 13, 3381, 10, 182);
INSERT INTO public.who_global_data VALUES (2307, 0, 9843, 0, 45, 10, 145);
INSERT INTO public.who_global_data VALUES (2308, 2877, 715438, 97, 17938, 10, 26);
INSERT INTO public.who_global_data VALUES (2309, 17741, 3774672, 594, 71076, 10, 170);
INSERT INTO public.who_global_data VALUES (2310, 574, 13885, 4, 181, 10, 191);
INSERT INTO public.who_global_data VALUES (2311, 0, 6, 0, 0, 10, 221);
INSERT INTO public.who_global_data VALUES (2312, 0, 376, 0, 0, 10, 64);
INSERT INTO public.who_global_data VALUES (2313, 0, 0, 0, 0, 10, 116);
INSERT INTO public.who_global_data VALUES (2314, 0, 35, 0, 0, 10, 128);
INSERT INTO public.who_global_data VALUES (2315, 35, 921, 2, 13, 10, 6);
INSERT INTO public.who_global_data VALUES (2316, 0, 1191, 0, 12, 10, 227);
INSERT INTO public.who_global_data VALUES (2317, 0, 23, 0, 0, 10, 68);
INSERT INTO public.who_global_data VALUES (2318, 17, 763, 0, 2, 10, 184);
INSERT INTO public.who_global_data VALUES (2319, 0, 2, 0, 0, 10, 82);
INSERT INTO public.who_global_data VALUES (2320, 26, 2915, 0, 65, 10, 149);
INSERT INTO public.who_global_data VALUES (2321, 21, 1210, 0, 17, 10, 197);
INSERT INTO public.who_global_data VALUES (2322, 223, 366807, 4, 6359, 10, 78);
INSERT INTO public.who_global_data VALUES (2323, 133, 25126, 10, 592, 10, 233);
INSERT INTO public.who_global_data VALUES (2324, 2080, 387206, 19, 3924, 10, 133);
INSERT INTO public.who_global_data VALUES (2325, 47, 1116, 0, 3, 10, 35);
INSERT INTO public.who_global_data VALUES (2326, 21, 3194, 0, 77, 10, 114);
INSERT INTO public.who_global_data VALUES (2327, 14, 59366, 0, 29, 10, 237);
INSERT INTO public.who_global_data VALUES (2328, 0, 20, 0, 0, 10, 55);
INSERT INTO public.who_global_data VALUES (2329, 9, 1758, 0, 27, 10, 176);
INSERT INTO public.who_global_data VALUES (2330, 2775, 241392, 101, 4361, 10, 202);
INSERT INTO public.who_global_data VALUES (2331, 1864, 161719, 11, 3658, 10, 155);
INSERT INTO public.who_global_data VALUES (2332, 0, 17, 0, 0, 10, 32);
INSERT INTO public.who_global_data VALUES (2333, 30, 4784, 0, 130, 10, 220);
INSERT INTO public.who_global_data VALUES (2334, 6041, 1423578, 680, 41797, 10, 30);
INSERT INTO public.who_global_data VALUES (2335, 17, 3882, 0, 64, 10, 147);
INSERT INTO public.who_global_data VALUES (2336, 31515, 2697621, 319, 58196, 10, 208);
INSERT INTO public.who_global_data VALUES (2337, 755, 59922, 5, 288, 10, 45);
INSERT INTO public.who_global_data VALUES (2338, 72, 29066, 10, 1760, 10, 110);
INSERT INTO public.who_global_data VALUES (2339, 55, 8112, 0, 149, 10, 88);
INSERT INTO public.who_global_data VALUES (2340, 1889, 556247, 42, 11874, 10, 51);
INSERT INTO public.who_global_data VALUES (2341, 1835, 515714, 33, 8598, 10, 209);
INSERT INTO public.who_global_data VALUES (2342, 65, 13762, 5, 895, 10, 205);
INSERT INTO public.who_global_data VALUES (2343, 0, 13714, 0, 91, 10, 18);
INSERT INTO public.who_global_data VALUES (2344, 819, 15465, 1, 76, 10, 72);
INSERT INTO public.who_global_data VALUES (2345, 20088, 3689750, 1631, 100162, 10, 44);
INSERT INTO public.who_global_data VALUES (2346, 1, 68, 0, 0, 10, 15);
INSERT INTO public.who_global_data VALUES (2347, 20, 4682, 1, 76, 10, 25);
INSERT INTO public.who_global_data VALUES (2348, 0, 0, 0, 0, 10, 179);
INSERT INTO public.who_global_data VALUES (2349, 0, 0, 0, 0, 10, 34);
INSERT INTO public.who_global_data VALUES (2350, 17, 7490, 0, 134, 10, 207);
INSERT INTO public.who_global_data VALUES (2351, 2026, 200662, 83, 6370, 10, 166);
INSERT INTO public.who_global_data VALUES (2352, 7103, 2442350, 134, 25344, 10, 126);
INSERT INTO public.who_global_data VALUES (2353, 0, 0, 0, 0, 10, 97);
INSERT INTO public.who_global_data VALUES (2354, 0, 1287, 1, 8, 10, 36);
INSERT INTO public.who_global_data VALUES (2355, 0, 0, 0, 0, 10, 125);
INSERT INTO public.who_global_data VALUES (2356, 73, 39261, 0, 318, 10, 124);
INSERT INTO public.who_global_data VALUES (2357, 3776, 1200883, 145, 22202, 10, 185);
INSERT INTO public.who_global_data VALUES (2358, 3601, 285147, 7, 805, 10, 194);
INSERT INTO public.who_global_data VALUES (2359, 0, 509, 0, 21, 10, 144);
INSERT INTO public.who_global_data VALUES (2360, 133409, 25050308, 1885, 417889, 10, 19);
INSERT INTO public.who_global_data VALUES (2361, 9, 2350, 0, 24, 10, 217);
INSERT INTO public.who_global_data VALUES (2362, 408, 38041, 14, 390, 10, 148);
INSERT INTO public.who_global_data VALUES (2363, 39, 78510, 0, 621, 10, 86);
INSERT INTO public.who_global_data VALUES (2364, 0, 1, 0, 0, 10, 13);
INSERT INTO public.who_global_data VALUES (2365, 403, 124112, 6, 1154, 10, 157);
INSERT INTO public.who_global_data VALUES (2366, 2, 1551, 0, 35, 10, 8);
INSERT INTO public.who_global_data VALUES (2367, 0, 5, 0, 0, 10, 73);
INSERT INTO public.who_global_data VALUES (2368, 1, 2123, 0, 616, 10, 101);
INSERT INTO public.who_global_data VALUES (2369, 1476, 47622, 12, 672, 10, 165);
INSERT INTO public.who_global_data VALUES (2370, 358, 32004, 28, 1103, 10, 14);
INSERT INTO public.who_global_data VALUES (2371, 78, 54750, 4, 2389, 11, 193);
INSERT INTO public.who_global_data VALUES (2372, 538, 72812, 9, 1324, 11, 113);
INSERT INTO public.who_global_data VALUES (2373, 258, 105854, 3, 2866, 11, 143);
INSERT INTO public.who_global_data VALUES (2374, 0, 0, 0, 0, 11, 219);
INSERT INTO public.who_global_data VALUES (2375, 47, 9596, 1, 97, 11, 186);
INSERT INTO public.who_global_data VALUES (2376, 77, 19476, 2, 461, 11, 52);
INSERT INTO public.who_global_data VALUES (2377, 1, 16, 0, 0, 11, 180);
INSERT INTO public.who_global_data VALUES (2378, 6, 201, 0, 6, 11, 167);
INSERT INTO public.who_global_data VALUES (2379, 5031, 1867223, 90, 46827, 11, 154);
INSERT INTO public.who_global_data VALUES (2380, 138, 166232, 5, 3052, 11, 94);
INSERT INTO public.who_global_data VALUES (2381, 100, 6723, 4, 56, 11, 66);
INSERT INTO public.who_global_data VALUES (2382, 11, 28777, 0, 909, 11, 58);
INSERT INTO public.who_global_data VALUES (2383, 944, 402478, 54, 7416, 11, 163);
INSERT INTO public.who_global_data VALUES (2384, 57, 229032, 11, 3093, 11, 37);
INSERT INTO public.who_global_data VALUES (2385, 6, 8133, 0, 175, 11, 142);
INSERT INTO public.who_global_data VALUES (2386, 413, 100230, 2, 369, 11, 83);
INSERT INTO public.who_global_data VALUES (2387, 602, 532401, 18, 8041, 11, 228);
INSERT INTO public.who_global_data VALUES (2388, 46, 1387, 1, 10, 11, 188);
INSERT INTO public.who_global_data VALUES (2389, 1024, 238635, 9, 1658, 11, 62);
INSERT INTO public.who_global_data VALUES (2390, 3419, 698912, 44, 20893, 11, 160);
INSERT INTO public.who_global_data VALUES (2391, 28, 11750, 0, 290, 11, 50);
INSERT INTO public.who_global_data VALUES (2392, 0, 3643, 0, 48, 11, 33);
INSERT INTO public.who_global_data VALUES (2393, 0, 686, 0, 12, 11, 183);
INSERT INTO public.who_global_data VALUES (2394, 1, 856, 0, 1, 11, 92);
INSERT INTO public.who_global_data VALUES (2395, 1048, 201037, 58, 9985, 11, 158);
INSERT INTO public.who_global_data VALUES (2396, 4, 354, 0, 3, 11, 67);
INSERT INTO public.who_global_data VALUES (2397, 100, 120143, 19, 4593, 11, 57);
INSERT INTO public.who_global_data VALUES (2398, 1024, 19654, 17, 105, 11, 38);
INSERT INTO public.who_global_data VALUES (2399, 28323, 8844577, 592, 217037, 11, 141);
INSERT INTO public.who_global_data VALUES (2400, 0, 137, 0, 1, 11, 178);
INSERT INTO public.who_global_data VALUES (2401, 0, 175, 0, 3, 11, 108);
INSERT INTO public.who_global_data VALUES (2402, 772, 215589, 60, 8880, 11, 39);
INSERT INTO public.who_global_data VALUES (2403, 65, 10103, 5, 117, 11, 2);
INSERT INTO public.who_global_data VALUES (2404, 2, 1481, 0, 2, 11, 195);
INSERT INTO public.who_global_data VALUES (2405, 68, 13557, 0, 127, 11, 107);
INSERT INTO public.who_global_data VALUES (2406, 2, 460, 0, 0, 11, 161);
INSERT INTO public.who_global_data VALUES (2407, 0, 29617, 0, 462, 11, 212);
INSERT INTO public.who_global_data VALUES (2408, 4852, 747383, 120, 19094, 11, 181);
INSERT INTO public.who_global_data VALUES (2409, 0, 383, 0, 2, 11, 53);
INSERT INTO public.who_global_data VALUES (2410, 0, 4980, 0, 63, 11, 164);
INSERT INTO public.who_global_data VALUES (2411, 21, 3182, 0, 116, 11, 140);
INSERT INTO public.who_global_data VALUES (2412, 4068, 703178, 66, 17999, 11, 20);
INSERT INTO public.who_global_data VALUES (2413, 155, 100291, 3, 4814, 11, 112);
INSERT INTO public.who_global_data VALUES (2414, 12516, 2015485, 392, 51374, 11, 111);
INSERT INTO public.who_global_data VALUES (2415, 82, 2350, 5, 76, 11, 71);
INSERT INTO public.who_global_data VALUES (2416, 0, 7887, 0, 117, 11, 218);
INSERT INTO public.who_global_data VALUES (2417, 0, 0, 0, 0, 11, 43);
INSERT INTO public.who_global_data VALUES (2418, 431, 190390, 11, 2543, 11, 49);
INSERT INTO public.who_global_data VALUES (2419, 0, 26850, 0, 146, 11, 1);
INSERT INTO public.who_global_data VALUES (2420, 448, 229502, 23, 4882, 11, 48);
INSERT INTO public.who_global_data VALUES (2421, 567, 21828, 3, 197, 11, 232);
INSERT INTO public.who_global_data VALUES (2422, 11, 4548, 0, 20, 11, 175);
INSERT INTO public.who_global_data VALUES (2423, 126, 30143, 2, 188, 11, 21);
INSERT INTO public.who_global_data VALUES (2424, 6942, 946946, 165, 15618, 11, 156);
INSERT INTO public.who_global_data VALUES (2425, 0, 0, 0, 0, 11, 95);
INSERT INTO public.who_global_data VALUES (2426, 179, 22047, 1, 661, 11, 177);
INSERT INTO public.who_global_data VALUES (2427, 625, 195296, 27, 2010, 11, 210);
INSERT INTO public.who_global_data VALUES (2428, 1, 5920, 0, 61, 11, 120);
INSERT INTO public.who_global_data VALUES (2429, 0, 113, 0, 0, 11, 135);
INSERT INTO public.who_global_data VALUES (2430, 1216, 205162, 32, 2545, 11, 206);
INSERT INTO public.who_global_data VALUES (2431, 275, 241567, 16, 14639, 11, 189);
INSERT INTO public.who_global_data VALUES (2432, 669, 162486, 53, 9012, 11, 129);
INSERT INTO public.who_global_data VALUES (2433, 261, 53479, 11, 1572, 11, 121);
INSERT INTO public.who_global_data VALUES (2434, 53, 5454, 0, 86, 11, 59);
INSERT INTO public.who_global_data VALUES (2435, 0, 1940, 1, 7, 11, 96);
INSERT INTO public.who_global_data VALUES (2436, 355, 41330, 9, 392, 11, 41);
INSERT INTO public.who_global_data VALUES (2437, 0, 14484, 14, 493, 11, 216);
INSERT INTO public.who_global_data VALUES (2438, 365, 134132, 5, 2071, 11, 236);
INSERT INTO public.who_global_data VALUES (2439, 0, 37, 0, 0, 11, 150);
INSERT INTO public.who_global_data VALUES (2440, 0, 652, 0, 1, 11, 61);
INSERT INTO public.who_global_data VALUES (2441, 0, 55, 0, 2, 11, 7);
INSERT INTO public.who_global_data VALUES (2442, 192, 42772, 3, 655, 11, 169);
INSERT INTO public.who_global_data VALUES (2443, 4012, 3007706, 445, 73101, 11, 28);
INSERT INTO public.who_global_data VALUES (2444, 38, 15702, 0, 76, 11, 85);
INSERT INTO public.who_global_data VALUES (2445, 60, 17912, 1, 129, 11, 211);
INSERT INTO public.who_global_data VALUES (2446, 133, 10411, 0, 67, 11, 60);
INSERT INTO public.who_global_data VALUES (2447, 50, 4008, 0, 128, 11, 3);
INSERT INTO public.who_global_data VALUES (2448, 1006, 254822, 25, 3096, 11, 11);
INSERT INTO public.who_global_data VALUES (2449, 6412, 2148077, 903, 52990, 11, 89);
INSERT INTO public.who_global_data VALUES (2450, 1341, 62135, 5, 372, 11, 24);
INSERT INTO public.who_global_data VALUES (2451, 31, 3966, 1, 63, 11, 162);
INSERT INTO public.who_global_data VALUES (2452, 432, 152412, 25, 5671, 11, 100);
INSERT INTO public.who_global_data VALUES (2453, 0, 30, 0, 0, 11, 47);
INSERT INTO public.who_global_data VALUES (2454, 0, 148, 0, 1, 11, 29);
INSERT INTO public.who_global_data VALUES (2455, 0, 9056, 0, 157, 11, 40);
INSERT INTO public.who_global_data VALUES (2456, 7, 7347, 1, 129, 11, 222);
INSERT INTO public.who_global_data VALUES (2457, 218, 154430, 4, 5469, 11, 132);
INSERT INTO public.who_global_data VALUES (2458, 7, 321, 0, 13, 11, 130);
INSERT INTO public.who_global_data VALUES (2459, 56, 14375, 0, 81, 11, 234);
INSERT INTO public.who_global_data VALUES (2460, 0, 2533, 0, 45, 11, 23);
INSERT INTO public.who_global_data VALUES (2461, 76, 7298, 2, 172, 11, 192);
INSERT INTO public.who_global_data VALUES (2462, 105, 11286, 0, 243, 11, 69);
INSERT INTO public.who_global_data VALUES (2463, 0, 26, 0, 0, 11, 187);
INSERT INTO public.who_global_data VALUES (2464, 691, 140929, 6, 3447, 11, 230);
INSERT INTO public.who_global_data VALUES (2465, 459, 360877, 89, 12113, 11, 77);
INSERT INTO public.who_global_data VALUES (2466, 0, 5990, 0, 29, 11, 9);
INSERT INTO public.who_global_data VALUES (2467, 9102, 10676838, 117, 153587, 11, 74);
INSERT INTO public.who_global_data VALUES (2468, 9994, 999256, 297, 28132, 11, 224);
INSERT INTO public.who_global_data VALUES (2469, 6309, 1379286, 98, 57481, 11, 199);
INSERT INTO public.who_global_data VALUES (2470, 813, 614576, 7, 13000, 11, 190);
INSERT INTO public.who_global_data VALUES (2471, 1369, 188923, 7, 2977, 11, 12);
INSERT INTO public.who_global_data VALUES (2472, 0, 432, 0, 25, 11, 104);
INSERT INTO public.who_global_data VALUES (2473, 4924, 599390, 69, 4432, 11, 153);
INSERT INTO public.who_global_data VALUES (2474, 8559, 2475372, 420, 85881, 11, 91);
INSERT INTO public.who_global_data VALUES (2475, 133, 15012, 2, 338, 11, 215);
INSERT INTO public.who_global_data VALUES (2476, 3330, 368143, 74, 5158, 11, 84);
INSERT INTO public.who_global_data VALUES (2477, 6, 3122, 0, 63, 11, 231);
INSERT INTO public.who_global_data VALUES (2478, 845, 321298, 15, 4239, 11, 196);
INSERT INTO public.who_global_data VALUES (2479, 1527, 228692, 0, 3035, 11, 105);
INSERT INTO public.who_global_data VALUES (2480, 69, 100052, 0, 1744, 11, 122);
INSERT INTO public.who_global_data VALUES (2481, 0, 0, 0, 0, 11, 159);
INSERT INTO public.who_global_data VALUES (2482, 311, 58359, 10, 1456, 11, 75);
INSERT INTO public.who_global_data VALUES (2483, 492, 161777, 2, 954, 11, 27);
INSERT INTO public.who_global_data VALUES (2484, 97, 84068, 1, 1402, 11, 54);
INSERT INTO public.who_global_data VALUES (2485, 1, 44, 0, 0, 11, 226);
INSERT INTO public.who_global_data VALUES (2486, 223, 61231, 3, 1114, 11, 79);
INSERT INTO public.who_global_data VALUES (2487, 2652, 282249, 54, 2394, 11, 56);
INSERT INTO public.who_global_data VALUES (2488, 388, 8044, 11, 134, 11, 117);
INSERT INTO public.who_global_data VALUES (2489, 13, 1927, 0, 84, 11, 152);
INSERT INTO public.who_global_data VALUES (2490, 742, 114430, 19, 1782, 11, 16);
INSERT INTO public.who_global_data VALUES (2491, 4, 2526, 0, 46, 11, 10);
INSERT INTO public.who_global_data VALUES (2492, 768, 177934, 24, 2688, 11, 201);
INSERT INTO public.who_global_data VALUES (2493, 29, 49733, 2, 566, 11, 174);
INSERT INTO public.who_global_data VALUES (2494, 0, 18743, 0, 279, 11, 119);
INSERT INTO public.who_global_data VALUES (2495, 592, 19987, 10, 518, 11, 168);
INSERT INTO public.who_global_data VALUES (2496, 3048, 186849, 11, 689, 11, 99);
INSERT INTO public.who_global_data VALUES (2497, 109, 15102, 0, 51, 11, 171);
INSERT INTO public.who_global_data VALUES (2498, 0, 7983, 0, 323, 11, 87);
INSERT INTO public.who_global_data VALUES (2499, 138, 16999, 2, 255, 11, 123);
INSERT INTO public.who_global_data VALUES (2500, 0, 4, 0, 0, 11, 151);
INSERT INTO public.who_global_data VALUES (2501, 0, 6370, 0, 44, 11, 213);
INSERT INTO public.who_global_data VALUES (2502, 0, 16222, 0, 410, 11, 118);
INSERT INTO public.who_global_data VALUES (2503, 12, 568, 0, 10, 11, 134);
INSERT INTO public.who_global_data VALUES (2504, 46, 7590, 0, 59, 11, 65);
INSERT INTO public.who_global_data VALUES (2505, 10872, 1763219, 530, 149614, 11, 102);
INSERT INTO public.who_global_data VALUES (2506, 0, 0, 0, 0, 11, 223);
INSERT INTO public.who_global_data VALUES (2507, 11, 1368, 0, 8, 11, 4);
INSERT INTO public.who_global_data VALUES (2508, 16, 1643, 0, 2, 11, 146);
INSERT INTO public.who_global_data VALUES (2509, 507, 59758, 7, 777, 11, 31);
INSERT INTO public.who_global_data VALUES (2510, 0, 13, 0, 1, 11, 127);
INSERT INTO public.who_global_data VALUES (2511, 337, 466626, 22, 8172, 11, 22);
INSERT INTO public.who_global_data VALUES (2512, 363, 32781, 14, 319, 11, 115);
INSERT INTO public.who_global_data VALUES (2513, 383, 137957, 7, 3069, 11, 106);
INSERT INTO public.who_global_data VALUES (2514, 225, 32650, 0, 319, 11, 90);
INSERT INTO public.who_global_data VALUES (2515, 0, 0, 0, 0, 11, 70);
INSERT INTO public.who_global_data VALUES (2516, 339, 269789, 10, 2011, 11, 46);
INSERT INTO public.who_global_data VALUES (2517, 4103, 952605, 40, 13570, 11, 139);
INSERT INTO public.who_global_data VALUES (2518, 0, 44, 0, 0, 11, 42);
INSERT INTO public.who_global_data VALUES (2519, 1, 1933, 0, 25, 11, 80);
INSERT INTO public.who_global_data VALUES (2520, 0, 4953, 0, 168, 11, 203);
INSERT INTO public.who_global_data VALUES (2521, 21, 4374, 0, 151, 11, 136);
INSERT INTO public.who_global_data VALUES (2522, 1430, 122996, 10, 1507, 11, 63);
INSERT INTO public.who_global_data VALUES (2523, 0, 0, 0, 0, 11, 17);
INSERT INTO public.who_global_data VALUES (2524, 0, 132, 0, 2, 11, 172);
INSERT INTO public.who_global_data VALUES (2525, 63, 90717, 6, 2791, 11, 109);
INSERT INTO public.who_global_data VALUES (2526, 279, 61082, 4, 548, 11, 200);
INSERT INTO public.who_global_data VALUES (2527, 470, 175416, 5, 1967, 11, 93);
INSERT INTO public.who_global_data VALUES (2528, 209, 133253, 1, 1522, 11, 5);
INSERT INTO public.who_global_data VALUES (2529, 0, 745, 0, 13, 11, 214);
INSERT INTO public.who_global_data VALUES (2530, 1629, 534041, 23, 11318, 11, 204);
INSERT INTO public.who_global_data VALUES (2531, 0, 0, 0, 0, 11, 198);
INSERT INTO public.who_global_data VALUES (2532, 1393, 311244, 29, 5063, 11, 173);
INSERT INTO public.who_global_data VALUES (2533, 0, 849, 0, 9, 11, 229);
INSERT INTO public.who_global_data VALUES (2534, 571, 127652, 10, 2617, 11, 76);
INSERT INTO public.who_global_data VALUES (2535, 5075, 1099013, 169, 39777, 11, 138);
INSERT INTO public.who_global_data VALUES (2536, 1377, 514996, 50, 10292, 11, 98);
INSERT INTO public.who_global_data VALUES (2537, 0, 0, 0, 0, 11, 103);
INSERT INTO public.who_global_data VALUES (2538, 4603, 1482722, 264, 35665, 11, 225);
INSERT INTO public.who_global_data VALUES (2539, 6923, 643113, 252, 10721, 11, 131);
INSERT INTO public.who_global_data VALUES (2540, 568, 91596, 5, 1778, 11, 235);
INSERT INTO public.who_global_data VALUES (2541, 277, 149296, 0, 248, 11, 137);
INSERT INTO public.who_global_data VALUES (2542, 349, 75867, 11, 1371, 11, 81);
INSERT INTO public.who_global_data VALUES (2543, 224, 156426, 7, 3368, 11, 182);
INSERT INTO public.who_global_data VALUES (2544, 142, 9843, 0, 45, 11, 145);
INSERT INTO public.who_global_data VALUES (2545, 1551, 712561, 65, 17841, 11, 26);
INSERT INTO public.who_global_data VALUES (2546, 18241, 3756931, 564, 70482, 11, 170);
INSERT INTO public.who_global_data VALUES (2547, 336, 13311, 3, 177, 11, 191);
INSERT INTO public.who_global_data VALUES (2548, 0, 6, 0, 0, 11, 221);
INSERT INTO public.who_global_data VALUES (2549, 0, 376, 0, 0, 11, 64);
INSERT INTO public.who_global_data VALUES (2550, 0, 0, 0, 0, 11, 116);
INSERT INTO public.who_global_data VALUES (2551, 0, 35, 0, 0, 11, 128);
INSERT INTO public.who_global_data VALUES (2552, 76, 886, 0, 11, 11, 6);
INSERT INTO public.who_global_data VALUES (2553, 0, 1191, 0, 12, 11, 227);
INSERT INTO public.who_global_data VALUES (2554, 2, 23, 0, 0, 11, 68);
INSERT INTO public.who_global_data VALUES (2555, 8, 746, 0, 2, 11, 184);
INSERT INTO public.who_global_data VALUES (2556, 0, 2, 0, 0, 11, 82);
INSERT INTO public.who_global_data VALUES (2557, 15, 2889, 0, 65, 11, 149);
INSERT INTO public.who_global_data VALUES (2558, 1, 1189, 0, 17, 11, 197);
INSERT INTO public.who_global_data VALUES (2559, 213, 366584, 3, 6355, 11, 78);
INSERT INTO public.who_global_data VALUES (2560, 265, 24993, 7, 582, 11, 233);
INSERT INTO public.who_global_data VALUES (2561, 1523, 385126, 19, 3905, 11, 133);
INSERT INTO public.who_global_data VALUES (2562, 36, 1069, 0, 3, 11, 35);
INSERT INTO public.who_global_data VALUES (2563, 34, 3173, 0, 77, 11, 114);
INSERT INTO public.who_global_data VALUES (2564, 44, 59352, 0, 29, 11, 237);
INSERT INTO public.who_global_data VALUES (2565, 0, 20, 0, 0, 11, 55);
INSERT INTO public.who_global_data VALUES (2566, 41, 1749, 0, 27, 11, 176);
INSERT INTO public.who_global_data VALUES (2567, 1590, 238617, 192, 4260, 11, 202);
INSERT INTO public.who_global_data VALUES (2568, 1680, 159855, 10, 3647, 11, 155);
INSERT INTO public.who_global_data VALUES (2569, 0, 17, 0, 0, 11, 32);
INSERT INTO public.who_global_data VALUES (2570, 0, 4754, 0, 130, 11, 220);
INSERT INTO public.who_global_data VALUES (2571, 4551, 1417537, 243, 41117, 11, 30);
INSERT INTO public.who_global_data VALUES (2572, 0, 3865, 0, 64, 11, 147);
INSERT INTO public.who_global_data VALUES (2573, 16838, 2666106, 358, 57877, 11, 208);
INSERT INTO public.who_global_data VALUES (2574, 737, 59167, 0, 283, 11, 45);
INSERT INTO public.who_global_data VALUES (2575, 70, 28994, 12, 1750, 11, 110);
INSERT INTO public.who_global_data VALUES (2576, 57, 8057, 1, 149, 11, 88);
INSERT INTO public.who_global_data VALUES (2577, 1148, 554358, 49, 11832, 11, 51);
INSERT INTO public.who_global_data VALUES (2578, 2491, 513879, 30, 8565, 11, 209);
INSERT INTO public.who_global_data VALUES (2579, 69, 13697, 5, 890, 11, 205);
INSERT INTO public.who_global_data VALUES (2580, 0, 13714, 0, 91, 11, 18);
INSERT INTO public.who_global_data VALUES (2581, 959, 14646, 0, 75, 11, 72);
INSERT INTO public.who_global_data VALUES (2582, 22195, 3669662, 592, 98531, 11, 44);
INSERT INTO public.who_global_data VALUES (2583, 0, 67, 0, 0, 11, 15);
INSERT INTO public.who_global_data VALUES (2584, 0, 4662, 0, 75, 11, 25);
INSERT INTO public.who_global_data VALUES (2585, 0, 0, 0, 0, 11, 179);
INSERT INTO public.who_global_data VALUES (2586, 0, 0, 0, 0, 11, 34);
INSERT INTO public.who_global_data VALUES (2587, 11, 7473, 0, 134, 11, 207);
INSERT INTO public.who_global_data VALUES (2588, 1263, 198636, 53, 6287, 11, 166);
INSERT INTO public.who_global_data VALUES (2589, 5642, 2435247, 137, 25210, 11, 126);
INSERT INTO public.who_global_data VALUES (2590, 0, 0, 0, 0, 11, 97);
INSERT INTO public.who_global_data VALUES (2591, 0, 1287, 0, 7, 11, 36);
INSERT INTO public.who_global_data VALUES (2592, 0, 0, 0, 0, 11, 125);
INSERT INTO public.who_global_data VALUES (2593, 39, 39188, 1, 318, 11, 124);
INSERT INTO public.who_global_data VALUES (2594, 2779, 1197107, 133, 22057, 11, 185);
INSERT INTO public.who_global_data VALUES (2595, 3591, 281546, 6, 798, 11, 194);
INSERT INTO public.who_global_data VALUES (2596, 0, 509, 0, 21, 11, 144);
INSERT INTO public.who_global_data VALUES (2597, 141691, 24916899, 1921, 416004, 11, 19);
INSERT INTO public.who_global_data VALUES (2598, 0, 2341, 0, 24, 11, 217);
INSERT INTO public.who_global_data VALUES (2599, 666, 37633, 9, 376, 11, 148);
INSERT INTO public.who_global_data VALUES (2600, 42, 78471, 0, 621, 11, 86);
INSERT INTO public.who_global_data VALUES (2601, 0, 1, 0, 0, 11, 13);
INSERT INTO public.who_global_data VALUES (2602, 464, 123709, 6, 1148, 11, 157);
INSERT INTO public.who_global_data VALUES (2603, 1, 1549, 0, 35, 11, 8);
INSERT INTO public.who_global_data VALUES (2604, 0, 5, 0, 0, 11, 73);
INSERT INTO public.who_global_data VALUES (2605, 0, 2122, 0, 616, 11, 101);
INSERT INTO public.who_global_data VALUES (2606, 809, 46146, 21, 660, 11, 165);
INSERT INTO public.who_global_data VALUES (2607, 326, 31646, 70, 1075, 11, 14);
INSERT INTO public.who_global_data VALUES (2608, 77, 54672, 7, 2385, 12, 193);
INSERT INTO public.who_global_data VALUES (2609, 833, 72274, 5, 1315, 12, 113);
INSERT INTO public.who_global_data VALUES (2610, 227, 105596, 2, 2863, 12, 143);
INSERT INTO public.who_global_data VALUES (2611, 0, 0, 0, 0, 12, 219);
INSERT INTO public.who_global_data VALUES (2612, 50, 9549, 0, 96, 12, 186);
INSERT INTO public.who_global_data VALUES (2613, 32, 19399, 2, 459, 12, 52);
INSERT INTO public.who_global_data VALUES (2614, 0, 15, 0, 0, 12, 180);
INSERT INTO public.who_global_data VALUES (2615, 0, 195, 0, 6, 12, 167);
INSERT INTO public.who_global_data VALUES (2616, 8362, 1862192, 162, 46737, 12, 154);
INSERT INTO public.who_global_data VALUES (2617, 58, 166094, 8, 3047, 12, 94);
INSERT INTO public.who_global_data VALUES (2618, 0, 6623, 0, 52, 12, 66);
INSERT INTO public.who_global_data VALUES (2619, 5, 28766, 0, 909, 12, 58);
INSERT INTO public.who_global_data VALUES (2620, 1347, 401534, 44, 7362, 12, 163);
INSERT INTO public.who_global_data VALUES (2621, 287, 228975, 10, 3082, 12, 37);
INSERT INTO public.who_global_data VALUES (2622, 17, 8127, 0, 175, 12, 142);
INSERT INTO public.who_global_data VALUES (2623, 361, 99817, 0, 367, 12, 83);
INSERT INTO public.who_global_data VALUES (2624, 473, 531799, 20, 8023, 12, 228);
INSERT INTO public.who_global_data VALUES (2625, 98, 1341, 0, 9, 12, 188);
INSERT INTO public.who_global_data VALUES (2626, 1752, 237611, 10, 1649, 12, 62);
INSERT INTO public.who_global_data VALUES (2627, 817, 695493, 39, 20849, 12, 160);
INSERT INTO public.who_global_data VALUES (2628, 22, 11722, 0, 290, 12, 50);
INSERT INTO public.who_global_data VALUES (2629, 0, 3643, 0, 48, 12, 33);
INSERT INTO public.who_global_data VALUES (2630, 0, 686, 0, 12, 12, 183);
INSERT INTO public.who_global_data VALUES (2631, 1, 855, 0, 1, 12, 92);
INSERT INTO public.who_global_data VALUES (2632, 1732, 199989, 56, 9927, 12, 158);
INSERT INTO public.who_global_data VALUES (2633, 0, 350, 0, 3, 12, 67);
INSERT INTO public.who_global_data VALUES (2634, 203, 120043, 5, 4574, 12, 57);
INSERT INTO public.who_global_data VALUES (2635, 0, 18630, 0, 88, 12, 38);
INSERT INTO public.who_global_data VALUES (2636, 62334, 8816254, 1202, 216445, 12, 141);
INSERT INTO public.who_global_data VALUES (2637, 0, 137, 0, 1, 12, 178);
INSERT INTO public.who_global_data VALUES (2638, 0, 175, 0, 3, 12, 108);
INSERT INTO public.who_global_data VALUES (2639, 121, 214817, 9, 8820, 12, 39);
INSERT INTO public.who_global_data VALUES (2640, 71, 10038, 3, 112, 12, 2);
INSERT INTO public.who_global_data VALUES (2641, 7, 1479, 0, 2, 12, 195);
INSERT INTO public.who_global_data VALUES (2642, 75, 13489, 3, 127, 12, 107);
INSERT INTO public.who_global_data VALUES (2643, 0, 458, 0, 0, 12, 161);
INSERT INTO public.who_global_data VALUES (2644, 0, 29617, 0, 462, 12, 212);
INSERT INTO public.who_global_data VALUES (2645, 5124, 742531, 146, 18974, 12, 181);
INSERT INTO public.who_global_data VALUES (2646, 0, 383, 0, 2, 12, 53);
INSERT INTO public.who_global_data VALUES (2647, 0, 4980, 0, 63, 12, 164);
INSERT INTO public.who_global_data VALUES (2648, 24, 3161, 1, 116, 12, 140);
INSERT INTO public.who_global_data VALUES (2649, 4463, 699110, 79, 17933, 12, 20);
INSERT INTO public.who_global_data VALUES (2650, 205, 100136, 1, 4811, 12, 112);
INSERT INTO public.who_global_data VALUES (2651, 15551, 2002969, 396, 50982, 12, 111);
INSERT INTO public.who_global_data VALUES (2652, 8, 2268, 1, 71, 12, 71);
INSERT INTO public.who_global_data VALUES (2653, 93, 7887, 0, 117, 12, 218);
INSERT INTO public.who_global_data VALUES (2654, 0, 0, 0, 0, 12, 43);
INSERT INTO public.who_global_data VALUES (2655, 651, 189959, 14, 2532, 12, 49);
INSERT INTO public.who_global_data VALUES (2656, 238, 26850, 1, 146, 12, 1);
INSERT INTO public.who_global_data VALUES (2657, 134, 229054, 32, 4859, 12, 48);
INSERT INTO public.who_global_data VALUES (2658, 634, 21261, 3, 194, 12, 232);
INSERT INTO public.who_global_data VALUES (2659, 0, 4537, 0, 20, 12, 175);
INSERT INTO public.who_global_data VALUES (2660, 130, 30017, 3, 186, 12, 21);
INSERT INTO public.who_global_data VALUES (2661, 2387, 940004, 84, 15453, 12, 156);
INSERT INTO public.who_global_data VALUES (2662, 0, 0, 0, 0, 12, 95);
INSERT INTO public.who_global_data VALUES (2663, 0, 21868, 0, 660, 12, 177);
INSERT INTO public.who_global_data VALUES (2664, 754, 194671, 14, 1983, 12, 210);
INSERT INTO public.who_global_data VALUES (2665, 1, 5919, 0, 61, 12, 120);
INSERT INTO public.who_global_data VALUES (2666, 0, 113, 0, 0, 12, 135);
INSERT INTO public.who_global_data VALUES (2667, 1439, 203946, 0, 2513, 12, 206);
INSERT INTO public.who_global_data VALUES (2668, 3060, 241292, 27, 14623, 12, 189);
INSERT INTO public.who_global_data VALUES (2669, 674, 161817, 57, 8959, 12, 129);
INSERT INTO public.who_global_data VALUES (2670, 546, 53218, 10, 1561, 12, 121);
INSERT INTO public.who_global_data VALUES (2671, 0, 5401, 0, 86, 12, 59);
INSERT INTO public.who_global_data VALUES (2672, 0, 1940, 0, 6, 12, 96);
INSERT INTO public.who_global_data VALUES (2673, 259, 40975, 7, 383, 12, 41);
INSERT INTO public.who_global_data VALUES (2674, 154, 14484, 21, 479, 12, 216);
INSERT INTO public.who_global_data VALUES (2675, 469, 133767, 3, 2066, 12, 236);
INSERT INTO public.who_global_data VALUES (2676, 0, 37, 0, 0, 12, 150);
INSERT INTO public.who_global_data VALUES (2677, 0, 652, 0, 1, 12, 61);
INSERT INTO public.who_global_data VALUES (2678, 0, 55, 0, 2, 12, 7);
INSERT INTO public.who_global_data VALUES (2679, 246, 42580, 4, 652, 12, 169);
INSERT INTO public.who_global_data VALUES (2680, 18435, 3003694, 172, 72656, 12, 28);
INSERT INTO public.who_global_data VALUES (2681, 0, 15664, 0, 76, 12, 85);
INSERT INTO public.who_global_data VALUES (2682, 0, 17852, 0, 128, 12, 211);
INSERT INTO public.who_global_data VALUES (2683, 0, 10278, 0, 67, 12, 60);
INSERT INTO public.who_global_data VALUES (2684, 0, 3958, 0, 128, 12, 3);
INSERT INTO public.who_global_data VALUES (2685, 298, 253816, 16, 3071, 12, 11);
INSERT INTO public.who_global_data VALUES (2686, 6729, 2141665, 217, 52087, 12, 89);
INSERT INTO public.who_global_data VALUES (2687, 679, 60794, 6, 367, 12, 24);
INSERT INTO public.who_global_data VALUES (2688, 30, 3935, 3, 62, 12, 162);
INSERT INTO public.who_global_data VALUES (2689, 334, 151980, 24, 5646, 12, 100);
INSERT INTO public.who_global_data VALUES (2690, 0, 30, 0, 0, 12, 47);
INSERT INTO public.who_global_data VALUES (2691, 1, 148, 0, 1, 12, 29);
INSERT INTO public.who_global_data VALUES (2692, 0, 9056, 0, 157, 12, 40);
INSERT INTO public.who_global_data VALUES (2693, 0, 7340, 0, 128, 12, 222);
INSERT INTO public.who_global_data VALUES (2694, 322, 154212, 9, 5465, 12, 132);
INSERT INTO public.who_global_data VALUES (2695, 4, 314, 0, 13, 12, 130);
INSERT INTO public.who_global_data VALUES (2696, 19, 14319, 0, 81, 12, 234);
INSERT INTO public.who_global_data VALUES (2697, 2, 2533, 0, 45, 12, 23);
INSERT INTO public.who_global_data VALUES (2698, 79, 7222, 0, 170, 12, 192);
INSERT INTO public.who_global_data VALUES (2699, 82, 11181, 0, 243, 12, 69);
INSERT INTO public.who_global_data VALUES (2700, 0, 26, 0, 0, 12, 187);
INSERT INTO public.who_global_data VALUES (2701, 1056, 140238, 2, 3441, 12, 230);
INSERT INTO public.who_global_data VALUES (2702, 844, 360418, 56, 12024, 12, 77);
INSERT INTO public.who_global_data VALUES (2703, 9, 5990, 0, 29, 12, 9);
INSERT INTO public.who_global_data VALUES (2704, 13203, 10667736, 131, 153470, 12, 74);
INSERT INTO public.who_global_data VALUES (2705, 11788, 989262, 171, 27835, 12, 224);
INSERT INTO public.who_global_data VALUES (2706, 5945, 1372977, 89, 57383, 12, 199);
INSERT INTO public.who_global_data VALUES (2707, 893, 613763, 5, 12993, 12, 190);
INSERT INTO public.who_global_data VALUES (2708, 1370, 187554, 23, 2970, 12, 12);
INSERT INTO public.who_global_data VALUES (2709, 0, 432, 0, 25, 12, 104);
INSERT INTO public.who_global_data VALUES (2710, 2418, 594466, 47, 4363, 12, 153);
INSERT INTO public.who_global_data VALUES (2711, 11628, 2466813, 299, 85461, 12, 91);
INSERT INTO public.who_global_data VALUES (2712, 107, 14879, 0, 336, 12, 215);
INSERT INTO public.who_global_data VALUES (2713, 4152, 364813, 65, 5084, 12, 84);
INSERT INTO public.who_global_data VALUES (2714, 12, 3116, 0, 63, 12, 231);
INSERT INTO public.who_global_data VALUES (2715, 934, 320453, 7, 4224, 12, 196);
INSERT INTO public.who_global_data VALUES (2716, 1274, 227165, 0, 3035, 12, 105);
INSERT INTO public.who_global_data VALUES (2717, 85, 99983, 4, 1744, 12, 122);
INSERT INTO public.who_global_data VALUES (2718, 0, 0, 0, 0, 12, 159);
INSERT INTO public.who_global_data VALUES (2719, 392, 58048, 6, 1446, 12, 75);
INSERT INTO public.who_global_data VALUES (2720, 384, 161285, 0, 952, 12, 27);
INSERT INTO public.who_global_data VALUES (2721, 71, 83971, 1, 1401, 12, 54);
INSERT INTO public.who_global_data VALUES (2722, 0, 43, 0, 0, 12, 226);
INSERT INTO public.who_global_data VALUES (2723, 512, 61008, 14, 1111, 12, 79);
INSERT INTO public.who_global_data VALUES (2724, 3010, 279597, 60, 2340, 12, 56);
INSERT INTO public.who_global_data VALUES (2725, 0, 7656, 0, 123, 12, 117);
INSERT INTO public.who_global_data VALUES (2726, 0, 1914, 0, 84, 12, 152);
INSERT INTO public.who_global_data VALUES (2727, 1148, 113688, 26, 1763, 12, 16);
INSERT INTO public.who_global_data VALUES (2728, 11, 2522, 0, 46, 12, 10);
INSERT INTO public.who_global_data VALUES (2729, 542, 177166, 15, 2664, 12, 201);
INSERT INTO public.who_global_data VALUES (2730, 123, 49704, 0, 564, 12, 174);
INSERT INTO public.who_global_data VALUES (2731, 442, 18743, 6, 279, 12, 119);
INSERT INTO public.who_global_data VALUES (2732, 956, 19395, 38, 508, 12, 168);
INSERT INTO public.who_global_data VALUES (2733, 3346, 183801, 11, 678, 12, 99);
INSERT INTO public.who_global_data VALUES (2734, 108, 14993, 1, 51, 12, 171);
INSERT INTO public.who_global_data VALUES (2735, 18, 7983, 0, 323, 12, 87);
INSERT INTO public.who_global_data VALUES (2736, 203, 16861, 2, 253, 12, 123);
INSERT INTO public.who_global_data VALUES (2737, 0, 4, 0, 0, 12, 151);
INSERT INTO public.who_global_data VALUES (2738, 0, 6370, 0, 44, 12, 213);
INSERT INTO public.who_global_data VALUES (2739, 0, 16222, 0, 410, 12, 118);
INSERT INTO public.who_global_data VALUES (2740, 0, 556, 0, 10, 12, 134);
INSERT INTO public.who_global_data VALUES (2741, 0, 7544, 0, 59, 12, 65);
INSERT INTO public.who_global_data VALUES (2742, 20057, 1752347, 1470, 149084, 12, 102);
INSERT INTO public.who_global_data VALUES (2743, 0, 0, 0, 0, 12, 223);
INSERT INTO public.who_global_data VALUES (2744, 12, 1357, 0, 8, 12, 4);
INSERT INTO public.who_global_data VALUES (2745, 16, 1627, 0, 2, 12, 146);
INSERT INTO public.who_global_data VALUES (2746, 566, 59251, 2, 770, 12, 31);
INSERT INTO public.who_global_data VALUES (2747, 0, 13, 0, 1, 12, 127);
INSERT INTO public.who_global_data VALUES (2748, 520, 466289, 22, 8150, 12, 22);
INSERT INTO public.who_global_data VALUES (2749, 790, 32418, 8, 305, 12, 115);
INSERT INTO public.who_global_data VALUES (2750, 476, 137574, 17, 3062, 12, 106);
INSERT INTO public.who_global_data VALUES (2751, 212, 32425, 2, 319, 12, 90);
INSERT INTO public.who_global_data VALUES (2752, 0, 0, 0, 0, 12, 70);
INSERT INTO public.who_global_data VALUES (2753, 270, 269450, 7, 2001, 12, 46);
INSERT INTO public.who_global_data VALUES (2754, 4893, 948502, 30, 13530, 12, 139);
INSERT INTO public.who_global_data VALUES (2755, 0, 44, 0, 0, 12, 42);
INSERT INTO public.who_global_data VALUES (2756, 6, 1932, 0, 25, 12, 80);
INSERT INTO public.who_global_data VALUES (2757, 0, 4953, 0, 168, 12, 203);
INSERT INTO public.who_global_data VALUES (2758, 32, 4353, 0, 151, 12, 136);
INSERT INTO public.who_global_data VALUES (2759, 964, 121566, 2, 1497, 12, 63);
INSERT INTO public.who_global_data VALUES (2760, 0, 0, 0, 0, 12, 17);
INSERT INTO public.who_global_data VALUES (2761, 0, 132, 0, 2, 12, 172);
INSERT INTO public.who_global_data VALUES (2762, 183, 90654, 6, 2785, 12, 109);
INSERT INTO public.who_global_data VALUES (2763, 238, 60803, 0, 544, 12, 200);
INSERT INTO public.who_global_data VALUES (2764, 533, 174946, 11, 1962, 12, 93);
INSERT INTO public.who_global_data VALUES (2765, 558, 133044, 4, 1521, 12, 5);
INSERT INTO public.who_global_data VALUES (2766, 0, 745, 0, 13, 12, 214);
INSERT INTO public.who_global_data VALUES (2767, 1594, 532412, 48, 11295, 12, 204);
INSERT INTO public.who_global_data VALUES (2768, 0, 0, 0, 0, 12, 198);
INSERT INTO public.who_global_data VALUES (2769, 2058, 309851, 54, 5034, 12, 173);
INSERT INTO public.who_global_data VALUES (2770, 0, 849, 0, 9, 12, 229);
INSERT INTO public.who_global_data VALUES (2771, 711, 127081, 22, 2607, 12, 76);
INSERT INTO public.who_global_data VALUES (2772, 5842, 1093938, 181, 39608, 12, 138);
INSERT INTO public.who_global_data VALUES (2773, 1940, 513619, 52, 10242, 12, 98);
INSERT INTO public.who_global_data VALUES (2774, 0, 0, 0, 0, 12, 103);
INSERT INTO public.who_global_data VALUES (2775, 2674, 1478119, 38, 35401, 12, 225);
INSERT INTO public.who_global_data VALUES (2776, 11721, 636190, 275, 10469, 12, 131);
INSERT INTO public.who_global_data VALUES (2777, 955, 91028, 2, 1773, 12, 235);
INSERT INTO public.who_global_data VALUES (2778, 247, 149019, 0, 248, 12, 137);
INSERT INTO public.who_global_data VALUES (2779, 437, 75518, 11, 1360, 12, 81);
INSERT INTO public.who_global_data VALUES (2780, 265, 156202, 14, 3361, 12, 182);
INSERT INTO public.who_global_data VALUES (2781, 0, 9701, 0, 45, 12, 145);
INSERT INTO public.who_global_data VALUES (2782, 1816, 711010, 54, 17776, 12, 26);
INSERT INTO public.who_global_data VALUES (2783, 19290, 3738690, 456, 69918, 12, 170);
INSERT INTO public.who_global_data VALUES (2784, 328, 12975, 2, 174, 12, 191);
INSERT INTO public.who_global_data VALUES (2785, 0, 6, 0, 0, 12, 221);
INSERT INTO public.who_global_data VALUES (2786, 0, 376, 0, 0, 12, 64);
INSERT INTO public.who_global_data VALUES (2787, 0, 0, 0, 0, 12, 116);
INSERT INTO public.who_global_data VALUES (2788, 0, 35, 0, 0, 12, 128);
INSERT INTO public.who_global_data VALUES (2789, 40, 810, 1, 11, 12, 6);
INSERT INTO public.who_global_data VALUES (2790, 0, 1191, 0, 12, 12, 227);
INSERT INTO public.who_global_data VALUES (2791, 1, 21, 0, 0, 12, 68);
INSERT INTO public.who_global_data VALUES (2792, 18, 738, 0, 2, 12, 184);
INSERT INTO public.who_global_data VALUES (2793, 0, 2, 0, 0, 12, 82);
INSERT INTO public.who_global_data VALUES (2794, 0, 2874, 0, 65, 12, 149);
INSERT INTO public.who_global_data VALUES (2795, 6, 1188, 0, 17, 12, 197);
INSERT INTO public.who_global_data VALUES (2796, 186, 366371, 2, 6352, 12, 78);
INSERT INTO public.who_global_data VALUES (2797, 268, 24728, 6, 575, 12, 233);
INSERT INTO public.who_global_data VALUES (2798, 1318, 383603, 18, 3886, 12, 133);
INSERT INTO public.who_global_data VALUES (2799, 0, 1033, 0, 3, 12, 35);
INSERT INTO public.who_global_data VALUES (2800, 19, 3139, 0, 77, 12, 114);
INSERT INTO public.who_global_data VALUES (2801, 48, 59308, 0, 29, 12, 237);
INSERT INTO public.who_global_data VALUES (2802, 0, 20, 0, 0, 12, 55);
INSERT INTO public.who_global_data VALUES (2803, 0, 1708, 0, 27, 12, 176);
INSERT INTO public.who_global_data VALUES (2804, 551, 237027, 0, 4068, 12, 202);
INSERT INTO public.who_global_data VALUES (2805, 295, 158175, 9, 3637, 12, 155);
INSERT INTO public.who_global_data VALUES (2806, 0, 17, 0, 0, 12, 32);
INSERT INTO public.who_global_data VALUES (2807, 0, 4754, 0, 130, 12, 220);
INSERT INTO public.who_global_data VALUES (2808, 8147, 1412986, 300, 40874, 12, 30);
INSERT INTO public.who_global_data VALUES (2809, 92, 3865, 0, 64, 12, 147);
INSERT INTO public.who_global_data VALUES (2810, 23318, 2649268, 343, 57519, 12, 208);
INSERT INTO public.who_global_data VALUES (2811, 843, 58430, 3, 283, 12, 45);
INSERT INTO public.who_global_data VALUES (2812, 54, 28924, 0, 1738, 12, 110);
INSERT INTO public.who_global_data VALUES (2813, 55, 8000, 0, 148, 12, 88);
INSERT INTO public.who_global_data VALUES (2814, 2369, 553210, 57, 11783, 12, 51);
INSERT INTO public.who_global_data VALUES (2815, 732, 511388, 45, 8535, 12, 209);
INSERT INTO public.who_global_data VALUES (2816, 71, 13628, 6, 885, 12, 205);
INSERT INTO public.who_global_data VALUES (2817, 0, 13714, 0, 91, 12, 18);
INSERT INTO public.who_global_data VALUES (2818, 187, 13687, 2, 75, 12, 72);
INSERT INTO public.who_global_data VALUES (2819, 30004, 3647467, 610, 97939, 12, 44);
INSERT INTO public.who_global_data VALUES (2820, 0, 67, 0, 0, 12, 15);
INSERT INTO public.who_global_data VALUES (2821, 26, 4662, 1, 75, 12, 25);
INSERT INTO public.who_global_data VALUES (2822, 0, 0, 0, 0, 12, 179);
INSERT INTO public.who_global_data VALUES (2823, 0, 0, 0, 0, 12, 34);
INSERT INTO public.who_global_data VALUES (2824, 6, 7462, 1, 134, 12, 207);
INSERT INTO public.who_global_data VALUES (2825, 2059, 197373, 80, 6234, 12, 166);
INSERT INTO public.who_global_data VALUES (2826, 5277, 2429605, 140, 25073, 12, 126);
INSERT INTO public.who_global_data VALUES (2827, 0, 0, 0, 0, 12, 97);
INSERT INTO public.who_global_data VALUES (2828, 43, 1287, 0, 7, 12, 36);
INSERT INTO public.who_global_data VALUES (2829, 0, 0, 0, 0, 12, 125);
INSERT INTO public.who_global_data VALUES (2830, 105, 39149, 0, 317, 12, 124);
INSERT INTO public.who_global_data VALUES (2831, 2516, 1194328, 63, 21924, 12, 185);
INSERT INTO public.who_global_data VALUES (2832, 3579, 277955, 9, 792, 12, 194);
INSERT INTO public.who_global_data VALUES (2833, 0, 509, 0, 21, 12, 144);
INSERT INTO public.who_global_data VALUES (2834, 170883, 24775208, 3416, 414083, 12, 19);
INSERT INTO public.who_global_data VALUES (2835, 6, 2341, 0, 24, 12, 217);
INSERT INTO public.who_global_data VALUES (2836, 797, 36967, 3, 367, 12, 148);
INSERT INTO public.who_global_data VALUES (2837, 54, 78429, 0, 621, 12, 86);
INSERT INTO public.who_global_data VALUES (2838, 0, 1, 0, 0, 12, 13);
INSERT INTO public.who_global_data VALUES (2839, 450, 123245, 6, 1142, 12, 157);
INSERT INTO public.who_global_data VALUES (2840, 0, 1548, 0, 35, 12, 8);
INSERT INTO public.who_global_data VALUES (2841, 1, 5, 0, 0, 12, 73);
INSERT INTO public.who_global_data VALUES (2842, 0, 2122, 0, 616, 12, 101);
INSERT INTO public.who_global_data VALUES (2843, 745, 45337, 12, 639, 12, 165);
INSERT INTO public.who_global_data VALUES (2844, 313, 31320, 31, 1005, 12, 14);
INSERT INTO public.who_global_data VALUES (2845, 36, 54595, 5, 2378, 13, 193);
INSERT INTO public.who_global_data VALUES (2846, 786, 71441, 7, 1310, 13, 113);
INSERT INTO public.who_global_data VALUES (2847, 245, 105369, 5, 2861, 13, 143);
INSERT INTO public.who_global_data VALUES (2848, 0, 0, 0, 0, 13, 219);
INSERT INTO public.who_global_data VALUES (2849, 83, 9499, 3, 96, 13, 186);
INSERT INTO public.who_global_data VALUES (2850, 98, 19367, 5, 457, 13, 52);
INSERT INTO public.who_global_data VALUES (2851, 0, 15, 0, 0, 13, 180);
INSERT INTO public.who_global_data VALUES (2852, 3, 195, 0, 6, 13, 167);
INSERT INTO public.who_global_data VALUES (2853, 10753, 1853830, 220, 46575, 13, 154);
INSERT INTO public.who_global_data VALUES (2854, 127, 166036, 5, 3039, 13, 94);
INSERT INTO public.who_global_data VALUES (2855, 0, 6623, 0, 52, 13, 66);
INSERT INTO public.who_global_data VALUES (2856, 6, 28761, 0, 909, 13, 58);
INSERT INTO public.who_global_data VALUES (2857, 1551, 400187, 30, 7318, 13, 163);
INSERT INTO public.who_global_data VALUES (2858, 162, 228688, 8, 3072, 13, 37);
INSERT INTO public.who_global_data VALUES (2859, 9, 8110, 0, 175, 13, 142);
INSERT INTO public.who_global_data VALUES (2860, 246, 99456, 1, 367, 13, 83);
INSERT INTO public.who_global_data VALUES (2861, 436, 531326, 22, 8003, 13, 228);
INSERT INTO public.who_global_data VALUES (2862, 87, 1243, 0, 9, 13, 188);
INSERT INTO public.who_global_data VALUES (2863, 1748, 235859, 11, 1639, 13, 62);
INSERT INTO public.who_global_data VALUES (2864, 1395, 694676, 67, 20810, 13, 160);
INSERT INTO public.who_global_data VALUES (2865, 24, 11700, 1, 290, 13, 50);
INSERT INTO public.who_global_data VALUES (2866, 0, 3643, 0, 48, 13, 33);
INSERT INTO public.who_global_data VALUES (2867, 0, 686, 0, 12, 13, 183);
INSERT INTO public.who_global_data VALUES (2868, 3, 854, 0, 1, 13, 92);
INSERT INTO public.who_global_data VALUES (2869, 1864, 198257, 53, 9871, 13, 158);
INSERT INTO public.who_global_data VALUES (2870, 0, 350, 0, 3, 13, 67);
INSERT INTO public.who_global_data VALUES (2871, 420, 119840, 14, 4569, 13, 57);
INSERT INTO public.who_global_data VALUES (2872, 0, 18630, 0, 88, 13, 38);
INSERT INTO public.who_global_data VALUES (2873, 56552, 8753920, 1096, 215243, 13, 141);
INSERT INTO public.who_global_data VALUES (2874, 16, 137, 0, 1, 13, 178);
INSERT INTO public.who_global_data VALUES (2875, 0, 175, 0, 3, 13, 108);
INSERT INTO public.who_global_data VALUES (2876, 266, 214696, 12, 8811, 13, 39);
INSERT INTO public.who_global_data VALUES (2877, 110, 9967, 2, 109, 13, 2);
INSERT INTO public.who_global_data VALUES (2878, 34, 1472, 0, 2, 13, 195);
INSERT INTO public.who_global_data VALUES (2879, 33, 13414, 2, 124, 13, 107);
INSERT INTO public.who_global_data VALUES (2880, 2, 458, 0, 0, 13, 161);
INSERT INTO public.who_global_data VALUES (2881, 1607, 29617, 7, 462, 13, 212);
INSERT INTO public.who_global_data VALUES (2882, 5957, 737407, 206, 18828, 13, 181);
INSERT INTO public.who_global_data VALUES (2883, 1, 383, 0, 2, 13, 53);
INSERT INTO public.who_global_data VALUES (2884, 6, 4980, 0, 63, 13, 164);
INSERT INTO public.who_global_data VALUES (2885, 33, 3137, 0, 115, 13, 140);
INSERT INTO public.who_global_data VALUES (2886, 4581, 694647, 68, 17854, 13, 20);
INSERT INTO public.who_global_data VALUES (2887, 164, 99931, 0, 4810, 13, 112);
INSERT INTO public.who_global_data VALUES (2888, 15073, 1987418, 399, 50586, 13, 111);
INSERT INTO public.who_global_data VALUES (2889, 100, 2260, 7, 70, 13, 71);
INSERT INTO public.who_global_data VALUES (2890, 0, 7794, 0, 117, 13, 218);
INSERT INTO public.who_global_data VALUES (2891, 0, 0, 0, 0, 13, 43);
INSERT INTO public.who_global_data VALUES (2892, 831, 189308, 12, 2518, 13, 49);
INSERT INTO public.who_global_data VALUES (2893, 297, 26612, 2, 145, 13, 1);
INSERT INTO public.who_global_data VALUES (2894, 352, 228920, 28, 4827, 13, 48);
INSERT INTO public.who_global_data VALUES (2895, 567, 20627, 3, 191, 13, 232);
INSERT INTO public.who_global_data VALUES (2896, 0, 4537, 0, 20, 13, 175);
INSERT INTO public.who_global_data VALUES (2897, 129, 29887, 4, 183, 13, 21);
INSERT INTO public.who_global_data VALUES (2898, 4256, 937617, 99, 15369, 13, 156);
INSERT INTO public.who_global_data VALUES (2899, 0, 0, 0, 0, 13, 95);
INSERT INTO public.who_global_data VALUES (2900, 273, 21868, 14, 660, 13, 177);
INSERT INTO public.who_global_data VALUES (2901, 879, 193917, 28, 1969, 13, 210);
INSERT INTO public.who_global_data VALUES (2902, 1, 5918, 0, 61, 13, 120);
INSERT INTO public.who_global_data VALUES (2903, 0, 113, 0, 0, 13, 135);
INSERT INTO public.who_global_data VALUES (2904, 1362, 202507, 17, 2513, 13, 206);
INSERT INTO public.who_global_data VALUES (2905, 1074, 238232, 34, 14596, 13, 189);
INSERT INTO public.who_global_data VALUES (2906, 680, 161143, 49, 8902, 13, 129);
INSERT INTO public.who_global_data VALUES (2907, 0, 52672, 11, 1551, 13, 121);
INSERT INTO public.who_global_data VALUES (2908, 0, 5401, 0, 86, 13, 59);
INSERT INTO public.who_global_data VALUES (2909, 0, 1940, 0, 6, 13, 96);
INSERT INTO public.who_global_data VALUES (2910, 532, 40716, 8, 376, 13, 41);
INSERT INTO public.who_global_data VALUES (2911, 111, 14330, 0, 458, 13, 216);
INSERT INTO public.who_global_data VALUES (2912, 417, 133298, 3, 2063, 13, 236);
INSERT INTO public.who_global_data VALUES (2913, 3, 37, 0, 0, 13, 150);
INSERT INTO public.who_global_data VALUES (2914, 0, 652, 0, 1, 13, 61);
INSERT INTO public.who_global_data VALUES (2915, 0, 55, 0, 2, 13, 7);
INSERT INTO public.who_global_data VALUES (2916, 419, 42334, 4, 648, 13, 169);
INSERT INTO public.who_global_data VALUES (2917, 23522, 2985259, 229, 72484, 13, 28);
INSERT INTO public.who_global_data VALUES (2918, 104, 15664, 0, 76, 13, 85);
INSERT INTO public.who_global_data VALUES (2919, 0, 17852, 0, 128, 13, 211);
INSERT INTO public.who_global_data VALUES (2920, 0, 10278, 0, 67, 13, 60);
INSERT INTO public.who_global_data VALUES (2921, 8, 3958, 0, 128, 13, 3);
INSERT INTO public.who_global_data VALUES (2922, 546, 253518, 17, 3055, 13, 11);
INSERT INTO public.who_global_data VALUES (2923, 12257, 2134936, 349, 51870, 13, 89);
INSERT INTO public.who_global_data VALUES (2924, 635, 60115, 0, 361, 13, 24);
INSERT INTO public.who_global_data VALUES (2925, 24, 3905, 0, 59, 13, 162);
INSERT INTO public.who_global_data VALUES (2926, 605, 151646, 24, 5622, 13, 100);
INSERT INTO public.who_global_data VALUES (2927, 0, 30, 0, 0, 13, 47);
INSERT INTO public.who_global_data VALUES (2928, 0, 147, 0, 1, 13, 29);
INSERT INTO public.who_global_data VALUES (2929, 0, 9056, 0, 157, 13, 40);
INSERT INTO public.who_global_data VALUES (2930, 0, 7340, 0, 128, 13, 222);
INSERT INTO public.who_global_data VALUES (2931, 934, 153890, 36, 5456, 13, 132);
INSERT INTO public.who_global_data VALUES (2932, 0, 310, 0, 13, 13, 130);
INSERT INTO public.who_global_data VALUES (2933, 38, 14300, 0, 81, 13, 234);
INSERT INTO public.who_global_data VALUES (2934, 6, 2531, 0, 45, 13, 23);
INSERT INTO public.who_global_data VALUES (2935, 76, 7143, 0, 170, 13, 192);
INSERT INTO public.who_global_data VALUES (2936, 64, 11099, 0, 243, 13, 69);
INSERT INTO public.who_global_data VALUES (2937, 0, 26, 0, 0, 13, 187);
INSERT INTO public.who_global_data VALUES (2938, 1138, 139182, 17, 3439, 13, 230);
INSERT INTO public.who_global_data VALUES (2939, 1257, 359574, 64, 11968, 13, 77);
INSERT INTO public.who_global_data VALUES (2940, 0, 5981, 0, 29, 13, 9);
INSERT INTO public.who_global_data VALUES (2941, 14849, 10654533, 155, 153339, 13, 74);
INSERT INTO public.who_global_data VALUES (2942, 12191, 977474, 211, 27664, 13, 224);
INSERT INTO public.who_global_data VALUES (2943, 6207, 1367032, 69, 57294, 13, 199);
INSERT INTO public.who_global_data VALUES (2944, 778, 612870, 4, 12988, 13, 190);
INSERT INTO public.who_global_data VALUES (2945, 1905, 186184, 77, 2947, 13, 12);
INSERT INTO public.who_global_data VALUES (2946, 0, 432, 0, 25, 13, 104);
INSERT INTO public.who_global_data VALUES (2947, 7381, 592048, 56, 4316, 13, 153);
INSERT INTO public.who_global_data VALUES (2948, 13331, 2455185, 488, 85162, 13, 91);
INSERT INTO public.who_global_data VALUES (2949, 114, 14772, 4, 336, 13, 215);
INSERT INTO public.who_global_data VALUES (2950, 4587, 360661, 84, 5019, 13, 84);
INSERT INTO public.who_global_data VALUES (2951, 7, 3104, 1, 63, 13, 231);
INSERT INTO public.who_global_data VALUES (2952, 608, 319519, 10, 4217, 13, 196);
INSERT INTO public.who_global_data VALUES (2953, 1496, 225891, 79, 3035, 13, 105);
INSERT INTO public.who_global_data VALUES (2954, 129, 99898, 0, 1740, 13, 122);
INSERT INTO public.who_global_data VALUES (2955, 0, 0, 0, 0, 13, 159);
INSERT INTO public.who_global_data VALUES (2956, 379, 57656, 3, 1440, 13, 75);
INSERT INTO public.who_global_data VALUES (2957, 534, 160901, 0, 952, 13, 27);
INSERT INTO public.who_global_data VALUES (2958, 104, 83900, 2, 1400, 13, 54);
INSERT INTO public.who_global_data VALUES (2959, 0, 43, 0, 0, 13, 226);
INSERT INTO public.who_global_data VALUES (2960, 910, 60496, 21, 1097, 13, 79);
INSERT INTO public.who_global_data VALUES (2961, 4176, 276587, 62, 2280, 13, 56);
INSERT INTO public.who_global_data VALUES (2962, 101, 7656, 10, 123, 13, 117);
INSERT INTO public.who_global_data VALUES (2963, 0, 1914, 0, 84, 13, 152);
INSERT INTO public.who_global_data VALUES (2964, 0, 112540, 0, 1737, 13, 16);
INSERT INTO public.who_global_data VALUES (2965, 5, 2511, 0, 46, 13, 10);
INSERT INTO public.who_global_data VALUES (2966, 773, 176624, 21, 2649, 13, 201);
INSERT INTO public.who_global_data VALUES (2967, 143, 49581, 2, 564, 13, 174);
INSERT INTO public.who_global_data VALUES (2968, 0, 18301, 0, 273, 13, 119);
INSERT INTO public.who_global_data VALUES (2969, 1076, 18439, 25, 470, 13, 168);
INSERT INTO public.who_global_data VALUES (2970, 4275, 180455, 7, 667, 13, 99);
INSERT INTO public.who_global_data VALUES (2971, 55, 14885, 0, 50, 13, 171);
INSERT INTO public.who_global_data VALUES (2972, 28, 7965, 2, 323, 13, 87);
INSERT INTO public.who_global_data VALUES (2973, 116, 16658, 1, 251, 13, 123);
INSERT INTO public.who_global_data VALUES (2974, 0, 4, 0, 0, 13, 151);
INSERT INTO public.who_global_data VALUES (2975, 0, 6370, 0, 44, 13, 213);
INSERT INTO public.who_global_data VALUES (2976, 0, 16222, 0, 410, 13, 118);
INSERT INTO public.who_global_data VALUES (2977, 0, 556, 0, 10, 13, 134);
INSERT INTO public.who_global_data VALUES (2978, 294, 7544, 1, 59, 13, 65);
INSERT INTO public.who_global_data VALUES (2979, 21007, 1732290, 1440, 147614, 13, 102);
INSERT INTO public.who_global_data VALUES (2980, 0, 0, 0, 0, 13, 223);
INSERT INTO public.who_global_data VALUES (2981, 34, 1345, 0, 8, 13, 4);
INSERT INTO public.who_global_data VALUES (2982, 19, 1611, 1, 2, 13, 146);
INSERT INTO public.who_global_data VALUES (2983, 384, 58685, 2, 768, 13, 31);
INSERT INTO public.who_global_data VALUES (2984, 0, 13, 0, 1, 13, 127);
INSERT INTO public.who_global_data VALUES (2985, 925, 465769, 23, 8128, 13, 22);
INSERT INTO public.who_global_data VALUES (2986, 780, 31628, 7, 297, 13, 115);
INSERT INTO public.who_global_data VALUES (2987, 507, 137098, 14, 3045, 13, 106);
INSERT INTO public.who_global_data VALUES (2988, 365, 32213, 6, 317, 13, 90);
INSERT INTO public.who_global_data VALUES (2989, 0, 0, 0, 0, 13, 70);
INSERT INTO public.who_global_data VALUES (2990, 232, 269180, 8, 1994, 13, 46);
INSERT INTO public.who_global_data VALUES (2991, 5459, 943609, 88, 13500, 13, 139);
INSERT INTO public.who_global_data VALUES (2992, 0, 44, 0, 0, 13, 42);
INSERT INTO public.who_global_data VALUES (2993, 7, 1926, 0, 25, 13, 80);
INSERT INTO public.who_global_data VALUES (2994, 0, 4953, 0, 168, 13, 203);
INSERT INTO public.who_global_data VALUES (2995, 54, 4321, 4, 151, 13, 136);
INSERT INTO public.who_global_data VALUES (2996, 2464, 120602, 5, 1495, 13, 63);
INSERT INTO public.who_global_data VALUES (2997, 0, 0, 0, 0, 13, 17);
INSERT INTO public.who_global_data VALUES (2998, 3, 132, 0, 2, 13, 172);
INSERT INTO public.who_global_data VALUES (2999, 347, 90471, 11, 2779, 13, 109);
INSERT INTO public.who_global_data VALUES (3000, 306, 60565, 0, 544, 13, 200);
INSERT INTO public.who_global_data VALUES (3001, 449, 174413, 14, 1951, 13, 93);
INSERT INTO public.who_global_data VALUES (3002, 0, 132486, 0, 1517, 13, 5);
INSERT INTO public.who_global_data VALUES (3003, 0, 745, 0, 13, 13, 214);
INSERT INTO public.who_global_data VALUES (3004, 1927, 530818, 43, 11247, 13, 204);
INSERT INTO public.who_global_data VALUES (3005, 0, 0, 0, 0, 13, 198);
INSERT INTO public.who_global_data VALUES (3006, 2041, 307793, 36, 4980, 13, 173);
INSERT INTO public.who_global_data VALUES (3007, 0, 849, 0, 9, 13, 229);
INSERT INTO public.who_global_data VALUES (3008, 852, 126370, 15, 2585, 13, 76);
INSERT INTO public.who_global_data VALUES (3009, 5189, 1088096, 153, 39427, 13, 138);
INSERT INTO public.who_global_data VALUES (3010, 1792, 511679, 54, 10190, 13, 98);
INSERT INTO public.who_global_data VALUES (3011, 0, 0, 0, 0, 13, 103);
INSERT INTO public.who_global_data VALUES (3012, 4566, 1475445, 110, 35363, 13, 225);
INSERT INTO public.who_global_data VALUES (3013, 15333, 624469, 274, 10194, 13, 131);
INSERT INTO public.who_global_data VALUES (3014, 791, 90073, 10, 1771, 13, 235);
INSERT INTO public.who_global_data VALUES (3015, 251, 148772, 0, 248, 13, 137);
INSERT INTO public.who_global_data VALUES (3016, 392, 75081, 12, 1349, 13, 81);
INSERT INTO public.who_global_data VALUES (3017, 635, 155937, 15, 3347, 13, 182);
INSERT INTO public.who_global_data VALUES (3018, 0, 9701, 0, 45, 13, 145);
INSERT INTO public.who_global_data VALUES (3019, 2719, 709194, 94, 17722, 13, 26);
INSERT INTO public.who_global_data VALUES (3020, 21127, 3719400, 491, 69462, 13, 170);
INSERT INTO public.who_global_data VALUES (3021, 204, 12647, 7, 172, 13, 191);
INSERT INTO public.who_global_data VALUES (3022, 0, 6, 0, 0, 13, 221);
INSERT INTO public.who_global_data VALUES (3023, 0, 376, 0, 0, 13, 64);
INSERT INTO public.who_global_data VALUES (3024, 0, 0, 0, 0, 13, 116);
INSERT INTO public.who_global_data VALUES (3025, 0, 35, 0, 0, 13, 128);
INSERT INTO public.who_global_data VALUES (3026, 15, 770, 2, 10, 13, 6);
INSERT INTO public.who_global_data VALUES (3027, 0, 1191, 0, 12, 13, 227);
INSERT INTO public.who_global_data VALUES (3028, 4, 20, 0, 0, 13, 68);
INSERT INTO public.who_global_data VALUES (3029, 30, 720, 0, 2, 13, 184);
INSERT INTO public.who_global_data VALUES (3030, 0, 2, 0, 0, 13, 82);
INSERT INTO public.who_global_data VALUES (3031, 13, 2874, 0, 65, 13, 149);
INSERT INTO public.who_global_data VALUES (3032, 0, 1182, 0, 17, 13, 197);
INSERT INTO public.who_global_data VALUES (3033, 197, 366185, 4, 6350, 13, 78);
INSERT INTO public.who_global_data VALUES (3034, 250, 24460, 8, 569, 13, 233);
INSERT INTO public.who_global_data VALUES (3035, 1483, 382285, 19, 3868, 13, 133);
INSERT INTO public.who_global_data VALUES (3036, 61, 1033, 0, 3, 13, 35);
INSERT INTO public.who_global_data VALUES (3037, 27, 3120, 0, 77, 13, 114);
INSERT INTO public.who_global_data VALUES (3038, 10, 59260, 0, 29, 13, 237);
INSERT INTO public.who_global_data VALUES (3039, 0, 20, 0, 0, 13, 55);
INSERT INTO public.who_global_data VALUES (3040, 0, 1708, 0, 27, 13, 176);
INSERT INTO public.who_global_data VALUES (3041, 1905, 236476, 103, 4068, 13, 202);
INSERT INTO public.who_global_data VALUES (3042, 540, 157880, 14, 3628, 13, 155);
INSERT INTO public.who_global_data VALUES (3043, 0, 17, 0, 0, 13, 32);
INSERT INTO public.who_global_data VALUES (3044, 10, 4754, 0, 130, 13, 220);
INSERT INTO public.who_global_data VALUES (3045, 12271, 1404839, 498, 40574, 13, 30);
INSERT INTO public.who_global_data VALUES (3046, 0, 3773, 0, 64, 13, 147);
INSERT INTO public.who_global_data VALUES (3047, 41230, 2625950, 415, 57176, 13, 208);
INSERT INTO public.who_global_data VALUES (3048, 724, 57587, 2, 280, 13, 45);
INSERT INTO public.who_global_data VALUES (3049, 82, 28870, 0, 1738, 13, 110);
INSERT INTO public.who_global_data VALUES (3050, 65, 7945, 2, 148, 13, 88);
INSERT INTO public.who_global_data VALUES (3051, 3724, 550841, 57, 11726, 13, 51);
INSERT INTO public.who_global_data VALUES (3052, 1097, 510656, 44, 8490, 13, 209);
INSERT INTO public.who_global_data VALUES (3053, 78, 13557, 6, 879, 13, 205);
INSERT INTO public.who_global_data VALUES (3054, 0, 13714, 0, 91, 13, 18);
INSERT INTO public.who_global_data VALUES (3055, 198, 13500, 1, 73, 13, 72);
INSERT INTO public.who_global_data VALUES (3056, 33552, 3617463, 1348, 97329, 13, 44);
INSERT INTO public.who_global_data VALUES (3057, 3, 67, 0, 0, 13, 15);
INSERT INTO public.who_global_data VALUES (3058, 131, 4636, 0, 74, 13, 25);
INSERT INTO public.who_global_data VALUES (3059, 0, 0, 0, 0, 13, 179);
INSERT INTO public.who_global_data VALUES (3060, 0, 0, 0, 0, 13, 34);
INSERT INTO public.who_global_data VALUES (3061, 6, 7456, 0, 133, 13, 207);
INSERT INTO public.who_global_data VALUES (3062, 2041, 195314, 62, 6154, 13, 166);
INSERT INTO public.who_global_data VALUES (3063, 5856, 2424328, 144, 24933, 13, 126);
INSERT INTO public.who_global_data VALUES (3064, 0, 0, 0, 0, 13, 97);
INSERT INTO public.who_global_data VALUES (3065, 51, 1244, 0, 7, 13, 36);
INSERT INTO public.who_global_data VALUES (3066, 0, 0, 0, 0, 13, 125);
INSERT INTO public.who_global_data VALUES (3067, 109, 39044, 0, 317, 13, 124);
INSERT INTO public.who_global_data VALUES (3068, 3915, 1191812, 83, 21861, 13, 185);
INSERT INTO public.who_global_data VALUES (3069, 3566, 274376, 7, 783, 13, 194);
INSERT INTO public.who_global_data VALUES (3070, 0, 509, 0, 21, 13, 144);
INSERT INTO public.who_global_data VALUES (3071, 190994, 24604325, 3885, 410667, 13, 19);
INSERT INTO public.who_global_data VALUES (3072, 14, 2335, 0, 24, 13, 217);
INSERT INTO public.who_global_data VALUES (3073, 1178, 36170, 17, 364, 13, 148);
INSERT INTO public.who_global_data VALUES (3074, 58, 78375, 0, 621, 13, 86);
INSERT INTO public.who_global_data VALUES (3075, 0, 1, 0, 0, 13, 13);
INSERT INTO public.who_global_data VALUES (3076, 535, 122795, 7, 1136, 13, 157);
INSERT INTO public.who_global_data VALUES (3077, 0, 1548, 0, 35, 13, 8);
INSERT INTO public.who_global_data VALUES (3078, 0, 4, 0, 0, 13, 73);
INSERT INTO public.who_global_data VALUES (3079, 0, 2122, 1, 616, 13, 101);
INSERT INTO public.who_global_data VALUES (3080, 1259, 44592, 17, 627, 13, 165);
INSERT INTO public.who_global_data VALUES (3081, 484, 31007, 12, 974, 13, 14);
INSERT INTO public.who_global_data VALUES (3082, 76, 54559, 3, 2373, 14, 193);
INSERT INTO public.who_global_data VALUES (3083, 739, 70655, 7, 1303, 14, 113);
INSERT INTO public.who_global_data VALUES (3084, 272, 105124, 2, 2856, 14, 143);
INSERT INTO public.who_global_data VALUES (3085, 0, 0, 0, 0, 14, 219);
INSERT INTO public.who_global_data VALUES (3086, 37, 9416, 0, 93, 14, 186);
INSERT INTO public.who_global_data VALUES (3087, 92, 19269, 4, 452, 14, 52);
INSERT INTO public.who_global_data VALUES (3088, 0, 15, 0, 0, 14, 180);
INSERT INTO public.who_global_data VALUES (3089, 2, 192, 0, 6, 14, 167);
INSERT INTO public.who_global_data VALUES (3090, 11396, 1843077, 139, 46355, 14, 154);
INSERT INTO public.who_global_data VALUES (3091, 198, 165909, 4, 3034, 14, 94);
INSERT INTO public.who_global_data VALUES (3092, 61, 6623, 0, 52, 14, 66);
INSERT INTO public.who_global_data VALUES (3093, 5, 28755, 0, 909, 14, 58);
INSERT INTO public.who_global_data VALUES (3094, 1779, 398636, 66, 7288, 14, 163);
INSERT INTO public.who_global_data VALUES (3095, 280, 228526, 11, 3064, 14, 37);
INSERT INTO public.who_global_data VALUES (3096, 13, 8101, 0, 175, 14, 142);
INSERT INTO public.who_global_data VALUES (3097, 332, 99210, 0, 366, 14, 83);
INSERT INTO public.who_global_data VALUES (3098, 619, 530890, 15, 7981, 14, 228);
INSERT INTO public.who_global_data VALUES (3099, 0, 1156, 0, 9, 14, 188);
INSERT INTO public.who_global_data VALUES (3100, 1813, 234111, 9, 1628, 14, 62);
INSERT INTO public.who_global_data VALUES (3101, 2575, 693281, 50, 20743, 14, 160);
INSERT INTO public.who_global_data VALUES (3102, 34, 11676, 3, 289, 14, 50);
INSERT INTO public.who_global_data VALUES (3103, 61, 3643, 0, 48, 14, 33);
INSERT INTO public.who_global_data VALUES (3104, 2, 686, 0, 12, 14, 183);
INSERT INTO public.who_global_data VALUES (3105, 0, 851, 0, 1, 14, 92);
INSERT INTO public.who_global_data VALUES (3106, 2648, 196393, 54, 9818, 14, 158);
INSERT INTO public.who_global_data VALUES (3107, 1, 350, 0, 3, 14, 67);
INSERT INTO public.who_global_data VALUES (3108, 214, 119420, 19, 4555, 14, 57);
INSERT INTO public.who_global_data VALUES (3109, 0, 18630, 0, 88, 14, 38);
INSERT INTO public.who_global_data VALUES (3110, 59119, 8697368, 1316, 214147, 14, 141);
INSERT INTO public.who_global_data VALUES (3111, 0, 121, 0, 1, 14, 178);
INSERT INTO public.who_global_data VALUES (3112, 1, 175, 0, 3, 14, 108);
INSERT INTO public.who_global_data VALUES (3113, 566, 214430, 58, 8799, 14, 39);
INSERT INTO public.who_global_data VALUES (3114, 138, 9857, 1, 107, 14, 2);
INSERT INTO public.who_global_data VALUES (3115, 58, 1438, 0, 2, 14, 195);
INSERT INTO public.who_global_data VALUES (3116, 74, 13381, 0, 122, 14, 107);
INSERT INTO public.who_global_data VALUES (3117, 0, 456, 0, 0, 14, 161);
INSERT INTO public.who_global_data VALUES (3118, 0, 28010, 0, 455, 14, 212);
INSERT INTO public.who_global_data VALUES (3119, 5955, 731450, 160, 18622, 14, 181);
INSERT INTO public.who_global_data VALUES (3120, 1, 382, 0, 2, 14, 53);
INSERT INTO public.who_global_data VALUES (3121, 0, 4974, 0, 63, 14, 164);
INSERT INTO public.who_global_data VALUES (3122, 39, 3104, 1, 115, 14, 140);
INSERT INTO public.who_global_data VALUES (3123, 4959, 690066, 84, 17786, 14, 20);
INSERT INTO public.who_global_data VALUES (3124, 178, 99767, 1, 4810, 14, 112);
INSERT INTO public.who_global_data VALUES (3125, 15366, 1972345, 395, 50187, 14, 111);
INSERT INTO public.who_global_data VALUES (3126, 78, 2160, 1, 63, 14, 71);
INSERT INTO public.who_global_data VALUES (3127, 0, 7794, 0, 117, 14, 218);
INSERT INTO public.who_global_data VALUES (3128, 0, 0, 0, 0, 14, 43);
INSERT INTO public.who_global_data VALUES (3129, 765, 188477, 14, 2506, 14, 49);
INSERT INTO public.who_global_data VALUES (3130, 564, 26315, 1, 143, 14, 1);
INSERT INTO public.who_global_data VALUES (3131, 599, 228568, 29, 4799, 14, 48);
INSERT INTO public.who_global_data VALUES (3132, 530, 20060, 4, 188, 14, 232);
INSERT INTO public.who_global_data VALUES (3133, 2, 4537, 0, 20, 14, 175);
INSERT INTO public.who_global_data VALUES (3134, 122, 29758, 1, 179, 14, 21);
INSERT INTO public.who_global_data VALUES (3135, 8514, 933361, 140, 15270, 14, 156);
INSERT INTO public.who_global_data VALUES (3136, 0, 0, 0, 0, 14, 95);
INSERT INTO public.who_global_data VALUES (3137, 198, 21595, 3, 646, 14, 177);
INSERT INTO public.who_global_data VALUES (3138, 773, 193038, 32, 1941, 14, 210);
INSERT INTO public.who_global_data VALUES (3139, 1, 5917, 0, 61, 14, 120);
INSERT INTO public.who_global_data VALUES (3140, 0, 113, 0, 0, 14, 135);
INSERT INTO public.who_global_data VALUES (3141, 1473, 201145, 14, 2496, 14, 206);
INSERT INTO public.who_global_data VALUES (3142, 969, 237158, 36, 14562, 14, 189);
INSERT INTO public.who_global_data VALUES (3143, 748, 160463, 52, 8853, 14, 129);
INSERT INTO public.who_global_data VALUES (3144, 284, 52672, 10, 1540, 14, 121);
INSERT INTO public.who_global_data VALUES (3145, 36, 5401, 0, 86, 14, 59);
INSERT INTO public.who_global_data VALUES (3146, 27, 1940, 0, 6, 14, 96);
INSERT INTO public.who_global_data VALUES (3147, 483, 40184, 10, 368, 14, 41);
INSERT INTO public.who_global_data VALUES (3148, 202, 14219, 17, 458, 14, 216);
INSERT INTO public.who_global_data VALUES (3149, 555, 132881, 3, 2060, 14, 236);
INSERT INTO public.who_global_data VALUES (3150, 2, 34, 0, 0, 14, 150);
INSERT INTO public.who_global_data VALUES (3151, 0, 652, 0, 1, 14, 61);
INSERT INTO public.who_global_data VALUES (3152, 0, 55, 0, 2, 14, 7);
INSERT INTO public.who_global_data VALUES (3153, 350, 41915, 6, 644, 14, 169);
INSERT INTO public.who_global_data VALUES (3154, 22609, 2961737, 648, 72255, 14, 28);
INSERT INTO public.who_global_data VALUES (3155, 129, 15560, 0, 76, 14, 85);
INSERT INTO public.who_global_data VALUES (3156, 32, 17852, 0, 128, 14, 211);
INSERT INTO public.who_global_data VALUES (3157, 158, 10278, 1, 67, 14, 60);
INSERT INTO public.who_global_data VALUES (3158, 0, 3950, 0, 128, 14, 3);
INSERT INTO public.who_global_data VALUES (3159, 998, 252972, 16, 3038, 14, 11);
INSERT INTO public.who_global_data VALUES (3160, 16417, 2122679, 879, 51521, 14, 89);
INSERT INTO public.who_global_data VALUES (3161, 0, 59480, 0, 361, 14, 24);
INSERT INTO public.who_global_data VALUES (3162, 36, 3881, 6, 59, 14, 162);
INSERT INTO public.who_global_data VALUES (3163, 562, 151041, 28, 5598, 14, 100);
INSERT INTO public.who_global_data VALUES (3164, 0, 30, 0, 0, 14, 47);
INSERT INTO public.who_global_data VALUES (3165, 8, 147, 0, 1, 14, 29);
INSERT INTO public.who_global_data VALUES (3166, 108, 9056, 1, 157, 14, 40);
INSERT INTO public.who_global_data VALUES (3167, 19, 7340, 0, 128, 14, 222);
INSERT INTO public.who_global_data VALUES (3168, 561, 152956, 31, 5420, 14, 132);
INSERT INTO public.who_global_data VALUES (3169, 0, 310, 0, 13, 14, 130);
INSERT INTO public.who_global_data VALUES (3170, 26, 14262, 0, 81, 14, 234);
INSERT INTO public.who_global_data VALUES (3171, 8, 2525, 0, 45, 14, 23);
INSERT INTO public.who_global_data VALUES (3172, 52, 7067, 0, 170, 14, 192);
INSERT INTO public.who_global_data VALUES (3173, 72, 11035, 3, 243, 14, 69);
INSERT INTO public.who_global_data VALUES (3174, 0, 26, 0, 0, 14, 187);
INSERT INTO public.who_global_data VALUES (3175, 1146, 138044, 16, 3422, 14, 230);
INSERT INTO public.who_global_data VALUES (3176, 1344, 358317, 93, 11904, 14, 77);
INSERT INTO public.who_global_data VALUES (3177, 0, 5981, 0, 29, 14, 9);
INSERT INTO public.who_global_data VALUES (3178, 14256, 10639684, 152, 153184, 14, 74);
INSERT INTO public.who_global_data VALUES (3179, 13632, 965283, 250, 27453, 14, 224);
INSERT INTO public.who_global_data VALUES (3180, 6305, 1360825, 75, 57225, 14, 199);
INSERT INTO public.who_global_data VALUES (3181, 685, 612092, 7, 12984, 14, 190);
INSERT INTO public.who_global_data VALUES (3182, 2357, 184279, 52, 2870, 14, 12);
INSERT INTO public.who_global_data VALUES (3183, 0, 432, 0, 25, 14, 104);
INSERT INTO public.who_global_data VALUES (3184, 7200, 584667, 41, 4260, 14, 153);
INSERT INTO public.who_global_data VALUES (3185, 13633, 2441854, 472, 84674, 14, 91);
INSERT INTO public.who_global_data VALUES (3186, 108, 14658, 1, 332, 14, 215);
INSERT INTO public.who_global_data VALUES (3187, 5054, 356074, 105, 4935, 14, 84);
INSERT INTO public.who_global_data VALUES (3188, 9, 3097, 0, 62, 14, 231);
INSERT INTO public.who_global_data VALUES (3189, 730, 318911, 9, 4207, 14, 196);
INSERT INTO public.who_global_data VALUES (3190, 1694, 224395, 0, 2956, 14, 105);
INSERT INTO public.who_global_data VALUES (3191, 139, 99769, 1, 1740, 14, 122);
INSERT INTO public.who_global_data VALUES (3192, 0, 0, 0, 0, 14, 159);
INSERT INTO public.who_global_data VALUES (3193, 289, 57277, 14, 1437, 14, 75);
INSERT INTO public.who_global_data VALUES (3194, 533, 160367, 1, 952, 14, 27);
INSERT INTO public.who_global_data VALUES (3195, 93, 83796, 2, 1398, 14, 54);
INSERT INTO public.who_global_data VALUES (3196, 2, 43, 0, 0, 14, 226);
INSERT INTO public.who_global_data VALUES (3197, 876, 59586, 19, 1076, 14, 79);
INSERT INTO public.who_global_data VALUES (3198, 3170, 272411, 67, 2218, 14, 56);
INSERT INTO public.who_global_data VALUES (3199, 0, 7555, 0, 113, 14, 117);
INSERT INTO public.who_global_data VALUES (3200, 13, 1914, 0, 84, 14, 152);
INSERT INTO public.who_global_data VALUES (3201, 794, 112540, 21, 1737, 14, 16);
INSERT INTO public.who_global_data VALUES (3202, 6, 2506, 0, 46, 14, 10);
INSERT INTO public.who_global_data VALUES (3203, 1005, 175851, 37, 2628, 14, 201);
INSERT INTO public.who_global_data VALUES (3204, 119, 49438, 0, 562, 14, 174);
INSERT INTO public.who_global_data VALUES (3205, 0, 18301, 0, 273, 14, 119);
INSERT INTO public.who_global_data VALUES (3206, 1315, 17363, 49, 445, 14, 168);
INSERT INTO public.who_global_data VALUES (3207, 3631, 176180, 18, 660, 14, 99);
INSERT INTO public.who_global_data VALUES (3208, 65, 14830, 0, 50, 14, 171);
INSERT INTO public.who_global_data VALUES (3209, 26, 7937, 1, 321, 14, 87);
INSERT INTO public.who_global_data VALUES (3210, 119, 16542, 2, 250, 14, 123);
INSERT INTO public.who_global_data VALUES (3211, 0, 4, 0, 0, 14, 151);
INSERT INTO public.who_global_data VALUES (3212, 68, 6370, 0, 44, 14, 213);
INSERT INTO public.who_global_data VALUES (3213, 183, 16222, 8, 410, 14, 118);
INSERT INTO public.who_global_data VALUES (3214, 0, 556, 0, 10, 14, 134);
INSERT INTO public.who_global_data VALUES (3215, 92, 7250, 0, 58, 14, 65);
INSERT INTO public.who_global_data VALUES (3216, 22339, 1711283, 1803, 146174, 14, 102);
INSERT INTO public.who_global_data VALUES (3217, 0, 0, 0, 0, 14, 223);
INSERT INTO public.who_global_data VALUES (3218, 24, 1311, 0, 8, 14, 4);
INSERT INTO public.who_global_data VALUES (3219, 8, 1592, 0, 1, 14, 146);
INSERT INTO public.who_global_data VALUES (3220, 425, 58301, 1, 766, 14, 31);
INSERT INTO public.who_global_data VALUES (3221, 0, 13, 0, 1, 14, 127);
INSERT INTO public.who_global_data VALUES (3222, 1138, 464844, 29, 8105, 14, 22);
INSERT INTO public.who_global_data VALUES (3223, 623, 30848, 7, 290, 14, 115);
INSERT INTO public.who_global_data VALUES (3224, 425, 136591, 18, 3031, 14, 106);
INSERT INTO public.who_global_data VALUES (3225, 333, 31848, 1, 311, 14, 90);
INSERT INTO public.who_global_data VALUES (3226, 0, 0, 0, 0, 14, 70);
INSERT INTO public.who_global_data VALUES (3227, 302, 268948, 7, 1986, 14, 46);
INSERT INTO public.who_global_data VALUES (3228, 5755, 938150, 89, 13412, 14, 139);
INSERT INTO public.who_global_data VALUES (3229, 0, 44, 0, 0, 14, 42);
INSERT INTO public.who_global_data VALUES (3230, 0, 1919, 0, 25, 14, 80);
INSERT INTO public.who_global_data VALUES (3231, 0, 4953, 0, 168, 14, 203);
INSERT INTO public.who_global_data VALUES (3232, 0, 4267, 0, 147, 14, 136);
INSERT INTO public.who_global_data VALUES (3233, 1485, 118138, 5, 1490, 14, 63);
INSERT INTO public.who_global_data VALUES (3234, 0, 0, 0, 0, 14, 17);
INSERT INTO public.who_global_data VALUES (3235, 0, 129, 0, 2, 14, 172);
INSERT INTO public.who_global_data VALUES (3236, 307, 90124, 14, 2768, 14, 109);
INSERT INTO public.who_global_data VALUES (3237, 372, 60259, 0, 544, 14, 200);
INSERT INTO public.who_global_data VALUES (3238, 494, 173964, 12, 1937, 14, 93);
INSERT INTO public.who_global_data VALUES (3239, 0, 132486, 0, 1517, 14, 5);
INSERT INTO public.who_global_data VALUES (3240, 0, 745, 0, 13, 14, 214);
INSERT INTO public.who_global_data VALUES (3241, 1745, 528891, 47, 11204, 14, 204);
INSERT INTO public.who_global_data VALUES (3242, 0, 0, 0, 0, 14, 198);
INSERT INTO public.who_global_data VALUES (3243, 1975, 305752, 32, 4944, 14, 173);
INSERT INTO public.who_global_data VALUES (3244, 0, 849, 0, 9, 14, 229);
INSERT INTO public.who_global_data VALUES (3245, 1071, 125518, 13, 2570, 14, 76);
INSERT INTO public.who_global_data VALUES (3246, 4232, 1082907, 117, 39274, 14, 138);
INSERT INTO public.who_global_data VALUES (3247, 2170, 509887, 20, 10136, 14, 98);
INSERT INTO public.who_global_data VALUES (3248, 0, 0, 0, 0, 14, 103);
INSERT INTO public.who_global_data VALUES (3249, 6431, 1470879, 345, 35253, 14, 225);
INSERT INTO public.who_global_data VALUES (3250, 13987, 609136, 234, 9920, 14, 131);
INSERT INTO public.who_global_data VALUES (3251, 554, 89282, 29, 1761, 14, 235);
INSERT INTO public.who_global_data VALUES (3252, 263, 148521, 0, 248, 14, 137);
INSERT INTO public.who_global_data VALUES (3253, 431, 74689, 9, 1337, 14, 81);
INSERT INTO public.who_global_data VALUES (3254, 514, 155302, 17, 3332, 14, 182);
INSERT INTO public.who_global_data VALUES (3255, 117, 9701, 0, 45, 14, 145);
INSERT INTO public.who_global_data VALUES (3256, 2699, 706475, 74, 17628, 14, 26);
INSERT INTO public.who_global_data VALUES (3257, 20921, 3698273, 559, 68971, 14, 170);
INSERT INTO public.who_global_data VALUES (3258, 273, 12443, 3, 165, 14, 191);
INSERT INTO public.who_global_data VALUES (3259, 0, 6, 0, 0, 14, 221);
INSERT INTO public.who_global_data VALUES (3260, 95, 376, 0, 0, 14, 64);
INSERT INTO public.who_global_data VALUES (3261, 0, 0, 0, 0, 14, 116);
INSERT INTO public.who_global_data VALUES (3262, 0, 35, 0, 0, 14, 128);
INSERT INTO public.who_global_data VALUES (3263, 37, 755, 0, 8, 14, 6);
INSERT INTO public.who_global_data VALUES (3264, 74, 1191, 0, 12, 14, 227);
INSERT INTO public.who_global_data VALUES (3265, 0, 16, 0, 0, 14, 68);
INSERT INTO public.who_global_data VALUES (3266, 35, 690, 0, 2, 14, 184);
INSERT INTO public.who_global_data VALUES (3267, 0, 2, 0, 0, 14, 82);
INSERT INTO public.who_global_data VALUES (3268, 28, 2861, 0, 65, 14, 149);
INSERT INTO public.who_global_data VALUES (3269, 11, 1182, 0, 17, 14, 197);
INSERT INTO public.who_global_data VALUES (3270, 213, 365988, 4, 6346, 14, 78);
INSERT INTO public.who_global_data VALUES (3271, 300, 24210, 9, 561, 14, 233);
INSERT INTO public.who_global_data VALUES (3272, 1709, 380802, 19, 3849, 14, 133);
INSERT INTO public.who_global_data VALUES (3273, 106, 972, 0, 3, 14, 35);
INSERT INTO public.who_global_data VALUES (3274, 12, 3093, 0, 77, 14, 114);
INSERT INTO public.who_global_data VALUES (3275, 15, 59250, 0, 29, 14, 237);
INSERT INTO public.who_global_data VALUES (3276, 0, 20, 0, 0, 14, 55);
INSERT INTO public.who_global_data VALUES (3277, 5, 1708, 0, 27, 14, 176);
INSERT INTO public.who_global_data VALUES (3278, 1544, 234571, 71, 3965, 14, 202);
INSERT INTO public.who_global_data VALUES (3279, 1518, 157340, 20, 3614, 14, 155);
INSERT INTO public.who_global_data VALUES (3280, 0, 17, 0, 0, 14, 32);
INSERT INTO public.who_global_data VALUES (3281, 0, 4744, 0, 130, 14, 220);
INSERT INTO public.who_global_data VALUES (3282, 11761, 1392568, 575, 40076, 14, 30);
INSERT INTO public.who_global_data VALUES (3283, 11, 3773, 0, 64, 14, 147);
INSERT INTO public.who_global_data VALUES (3284, 39629, 2584720, 380, 56761, 14, 208);
INSERT INTO public.who_global_data VALUES (3285, 787, 56863, 2, 278, 14, 45);
INSERT INTO public.who_global_data VALUES (3286, 134, 28788, 5, 1738, 14, 110);
INSERT INTO public.who_global_data VALUES (3287, 97, 7880, 0, 146, 14, 88);
INSERT INTO public.who_global_data VALUES (3288, 4204, 547117, 86, 11669, 14, 51);
INSERT INTO public.who_global_data VALUES (3289, 2035, 509559, 42, 8446, 14, 209);
INSERT INTO public.who_global_data VALUES (3290, 81, 13479, 7, 873, 14, 205);
INSERT INTO public.who_global_data VALUES (3291, 0, 13714, 0, 91, 14, 18);
INSERT INTO public.who_global_data VALUES (3292, 198, 13302, 1, 72, 14, 72);
INSERT INTO public.who_global_data VALUES (3293, 40261, 3583911, 1401, 95981, 14, 44);
INSERT INTO public.who_global_data VALUES (3294, 11, 64, 0, 0, 14, 15);
INSERT INTO public.who_global_data VALUES (3295, 0, 4505, 0, 74, 14, 25);
INSERT INTO public.who_global_data VALUES (3296, 0, 0, 0, 0, 14, 179);
INSERT INTO public.who_global_data VALUES (3297, 0, 0, 0, 0, 14, 34);
INSERT INTO public.who_global_data VALUES (3298, 20, 7450, 0, 133, 14, 207);
INSERT INTO public.who_global_data VALUES (3299, 2389, 193273, 103, 6092, 14, 166);
INSERT INTO public.who_global_data VALUES (3300, 5967, 2418472, 149, 24789, 14, 126);
INSERT INTO public.who_global_data VALUES (3301, 0, 0, 0, 0, 14, 97);
INSERT INTO public.who_global_data VALUES (3302, 29, 1193, 0, 7, 14, 36);
INSERT INTO public.who_global_data VALUES (3303, 0, 0, 0, 0, 14, 125);
INSERT INTO public.who_global_data VALUES (3304, 129, 38935, 1, 317, 14, 124);
INSERT INTO public.who_global_data VALUES (3305, 4928, 1187897, 116, 21778, 14, 185);
INSERT INTO public.who_global_data VALUES (3306, 3552, 270810, 10, 776, 14, 194);
INSERT INTO public.who_global_data VALUES (3307, 0, 509, 0, 21, 14, 144);
INSERT INTO public.who_global_data VALUES (3308, 188176, 24413331, 3979, 406782, 14, 19);
INSERT INTO public.who_global_data VALUES (3309, 16, 2321, 0, 24, 14, 217);
INSERT INTO public.who_global_data VALUES (3310, 698, 34992, 11, 347, 14, 148);
INSERT INTO public.who_global_data VALUES (3311, 45, 78317, 1, 621, 14, 86);
INSERT INTO public.who_global_data VALUES (3312, 0, 1, 0, 0, 14, 13);
INSERT INTO public.who_global_data VALUES (3313, 569, 122260, 7, 1129, 14, 157);
INSERT INTO public.who_global_data VALUES (3314, 2, 1548, 0, 35, 14, 8);
INSERT INTO public.who_global_data VALUES (3315, 0, 4, 0, 0, 14, 73);
INSERT INTO public.who_global_data VALUES (3316, 3, 2122, 0, 615, 14, 101);
INSERT INTO public.who_global_data VALUES (3317, 1120, 43333, 13, 610, 14, 165);
INSERT INTO public.who_global_data VALUES (3318, 476, 30523, 45, 962, 14, 14);
INSERT INTO public.who_global_data VALUES (3319, 80, 54483, 7, 2370, 15, 193);
INSERT INTO public.who_global_data VALUES (3320, 678, 69916, 5, 1296, 15, 113);
INSERT INTO public.who_global_data VALUES (3321, 246, 104852, 0, 2854, 15, 143);
INSERT INTO public.who_global_data VALUES (3322, 0, 0, 0, 0, 15, 219);
INSERT INTO public.who_global_data VALUES (3323, 71, 9379, 1, 93, 15, 186);
INSERT INTO public.who_global_data VALUES (3324, 84, 19177, 4, 448, 15, 52);
INSERT INTO public.who_global_data VALUES (3325, 0, 15, 0, 0, 15, 180);
INSERT INTO public.who_global_data VALUES (3326, 0, 190, 0, 6, 15, 167);
INSERT INTO public.who_global_data VALUES (3327, 12112, 1831681, 150, 46216, 15, 154);
INSERT INTO public.who_global_data VALUES (3328, 183, 165711, 9, 3030, 15, 94);
INSERT INTO public.who_global_data VALUES (3329, 39, 6562, 0, 52, 15, 66);
INSERT INTO public.who_global_data VALUES (3330, 10, 28750, 0, 909, 15, 58);
INSERT INTO public.who_global_data VALUES (3331, 1779, 396857, 57, 7222, 15, 163);
INSERT INTO public.who_global_data VALUES (3332, 218, 228246, 9, 3053, 15, 37);
INSERT INTO public.who_global_data VALUES (3333, 13, 8088, 0, 175, 15, 142);
INSERT INTO public.who_global_data VALUES (3334, 305, 98878, 0, 366, 15, 83);
INSERT INTO public.who_global_data VALUES (3335, 584, 530271, 16, 7966, 15, 228);
INSERT INTO public.who_global_data VALUES (3336, 0, 1156, 0, 9, 15, 188);
INSERT INTO public.who_global_data VALUES (3337, 1804, 232298, 9, 1619, 15, 62);
INSERT INTO public.who_global_data VALUES (3338, 2380, 690706, 51, 20693, 15, 160);
INSERT INTO public.who_global_data VALUES (3339, 27, 11642, 3, 286, 15, 50);
INSERT INTO public.who_global_data VALUES (3340, 0, 3582, 0, 48, 15, 33);
INSERT INTO public.who_global_data VALUES (3341, 0, 684, 0, 12, 15, 183);
INSERT INTO public.who_global_data VALUES (3342, 1, 851, 0, 1, 15, 92);
INSERT INTO public.who_global_data VALUES (3343, 2655, 193745, 42, 9764, 15, 158);
INSERT INTO public.who_global_data VALUES (3344, 1, 349, 0, 3, 15, 67);
INSERT INTO public.who_global_data VALUES (3345, 489, 119206, 15, 4536, 15, 57);
INSERT INTO public.who_global_data VALUES (3346, 0, 18630, 0, 88, 15, 38);
INSERT INTO public.who_global_data VALUES (3347, 64385, 8638249, 1340, 212831, 15, 141);
INSERT INTO public.who_global_data VALUES (3348, 0, 121, 0, 1, 15, 178);
INSERT INTO public.who_global_data VALUES (3349, 0, 174, 0, 3, 15, 108);
INSERT INTO public.who_global_data VALUES (3350, 455, 213864, 90, 8741, 15, 39);
INSERT INTO public.who_global_data VALUES (3351, 166, 9719, 0, 106, 15, 2);
INSERT INTO public.who_global_data VALUES (3352, 22, 1380, 0, 2, 15, 195);
INSERT INTO public.who_global_data VALUES (3353, 83, 13307, 1, 122, 15, 107);
INSERT INTO public.who_global_data VALUES (3354, 3, 456, 0, 0, 15, 161);
INSERT INTO public.who_global_data VALUES (3355, 0, 28010, 0, 455, 15, 212);
INSERT INTO public.who_global_data VALUES (3356, 5744, 725495, 196, 18462, 15, 181);
INSERT INTO public.who_global_data VALUES (3357, 0, 381, 0, 2, 15, 53);
INSERT INTO public.who_global_data VALUES (3358, 0, 4974, 0, 63, 15, 164);
INSERT INTO public.who_global_data VALUES (3359, 53, 3065, 0, 114, 15, 140);
INSERT INTO public.who_global_data VALUES (3360, 4367, 685107, 108, 17702, 15, 20);
INSERT INTO public.who_global_data VALUES (3361, 175, 99589, 1, 4809, 15, 112);
INSERT INTO public.who_global_data VALUES (3362, 17908, 1956979, 390, 49792, 15, 111);
INSERT INTO public.who_global_data VALUES (3363, 149, 2082, 8, 62, 15, 71);
INSERT INTO public.who_global_data VALUES (3364, 0, 7794, 0, 117, 15, 218);
INSERT INTO public.who_global_data VALUES (3365, 0, 0, 0, 0, 15, 43);
INSERT INTO public.who_global_data VALUES (3366, 835, 187712, 15, 2492, 15, 49);
INSERT INTO public.who_global_data VALUES (3367, 154, 25751, 0, 142, 15, 1);
INSERT INTO public.who_global_data VALUES (3368, 643, 227969, 32, 4770, 15, 48);
INSERT INTO public.who_global_data VALUES (3369, 408, 19530, 4, 184, 15, 232);
INSERT INTO public.who_global_data VALUES (3370, 8, 4535, 0, 20, 15, 175);
INSERT INTO public.who_global_data VALUES (3371, 164, 29636, 2, 178, 15, 21);
INSERT INTO public.who_global_data VALUES (3372, 7488, 924847, 157, 15130, 15, 156);
INSERT INTO public.who_global_data VALUES (3373, 0, 0, 0, 0, 15, 95);
INSERT INTO public.who_global_data VALUES (3374, 96, 21397, 3, 643, 15, 177);
INSERT INTO public.who_global_data VALUES (3375, 760, 192265, 37, 1909, 15, 210);
INSERT INTO public.who_global_data VALUES (3376, 3, 5916, 0, 61, 15, 120);
INSERT INTO public.who_global_data VALUES (3377, 0, 113, 0, 0, 15, 135);
INSERT INTO public.who_global_data VALUES (3378, 1549, 199672, 12, 2482, 15, 206);
INSERT INTO public.who_global_data VALUES (3379, 1874, 236189, 89, 14526, 15, 189);
INSERT INTO public.who_global_data VALUES (3380, 752, 159715, 54, 8801, 15, 129);
INSERT INTO public.who_global_data VALUES (3381, 951, 52388, 9, 1530, 15, 121);
INSERT INTO public.who_global_data VALUES (3382, 0, 5365, 0, 86, 15, 59);
INSERT INTO public.who_global_data VALUES (3383, 3, 1913, 0, 6, 15, 96);
INSERT INTO public.who_global_data VALUES (3384, 489, 39701, 4, 358, 15, 41);
INSERT INTO public.who_global_data VALUES (3385, 228, 14017, 14, 441, 15, 216);
INSERT INTO public.who_global_data VALUES (3386, 292, 132326, 13, 2057, 15, 236);
INSERT INTO public.who_global_data VALUES (3387, 0, 32, 0, 0, 15, 150);
INSERT INTO public.who_global_data VALUES (3388, 0, 652, 0, 1, 15, 61);
INSERT INTO public.who_global_data VALUES (3389, 0, 55, 0, 2, 15, 7);
INSERT INTO public.who_global_data VALUES (3390, 399, 41565, 5, 638, 15, 169);
INSERT INTO public.who_global_data VALUES (3391, 22551, 2939128, 346, 71607, 15, 28);
INSERT INTO public.who_global_data VALUES (3392, 120, 15431, 0, 76, 15, 85);
INSERT INTO public.who_global_data VALUES (3393, 12, 17820, 0, 128, 15, 211);
INSERT INTO public.who_global_data VALUES (3394, 0, 10120, 0, 66, 15, 60);
INSERT INTO public.who_global_data VALUES (3395, 0, 3950, 0, 128, 15, 3);
INSERT INTO public.who_global_data VALUES (3396, 903, 251974, 24, 3022, 15, 11);
INSERT INTO public.who_global_data VALUES (3397, 17862, 2106262, 859, 50642, 15, 89);
INSERT INTO public.who_global_data VALUES (3398, 658, 59480, 3, 361, 15, 24);
INSERT INTO public.who_global_data VALUES (3399, 52, 3845, 6, 53, 15, 162);
INSERT INTO public.who_global_data VALUES (3400, 506, 150479, 25, 5570, 15, 100);
INSERT INTO public.who_global_data VALUES (3401, 0, 30, 0, 0, 15, 47);
INSERT INTO public.who_global_data VALUES (3402, 0, 139, 0, 1, 15, 29);
INSERT INTO public.who_global_data VALUES (3403, 0, 8948, 0, 156, 15, 40);
INSERT INTO public.who_global_data VALUES (3404, 7, 7321, 0, 128, 15, 222);
INSERT INTO public.who_global_data VALUES (3405, 1071, 152395, 46, 5389, 15, 132);
INSERT INTO public.who_global_data VALUES (3406, 1, 310, 0, 13, 15, 130);
INSERT INTO public.who_global_data VALUES (3407, 29, 14236, 0, 81, 15, 234);
INSERT INTO public.who_global_data VALUES (3408, 7, 2517, 0, 45, 15, 23);
INSERT INTO public.who_global_data VALUES (3409, 65, 7015, 0, 170, 15, 192);
INSERT INTO public.who_global_data VALUES (3410, 0, 10963, 0, 240, 15, 69);
INSERT INTO public.who_global_data VALUES (3411, 0, 26, 0, 0, 15, 187);
INSERT INTO public.who_global_data VALUES (3412, 830, 136898, 15, 3406, 15, 230);
INSERT INTO public.who_global_data VALUES (3413, 1311, 356973, 98, 11811, 15, 77);
INSERT INTO public.who_global_data VALUES (3414, 6, 5981, 0, 29, 15, 9);
INSERT INTO public.who_global_data VALUES (3415, 14545, 10625428, 163, 153032, 15, 74);
INSERT INTO public.who_global_data VALUES (3416, 11703, 951651, 346, 27203, 15, 224);
INSERT INTO public.who_global_data VALUES (3417, 6204, 1354520, 93, 57150, 15, 199);
INSERT INTO public.who_global_data VALUES (3418, 809, 611407, 9, 12977, 15, 190);
INSERT INTO public.who_global_data VALUES (3419, 2598, 181922, 50, 2818, 15, 12);
INSERT INTO public.who_global_data VALUES (3420, 0, 432, 0, 25, 15, 104);
INSERT INTO public.who_global_data VALUES (3421, 8252, 577467, 54, 4219, 15, 153);
INSERT INTO public.who_global_data VALUES (3422, 14055, 2428221, 521, 84202, 15, 91);
INSERT INTO public.who_global_data VALUES (3423, 63, 14550, 0, 331, 15, 215);
INSERT INTO public.who_global_data VALUES (3424, 5799, 351020, 87, 4830, 15, 84);
INSERT INTO public.who_global_data VALUES (3425, 11, 3088, 0, 62, 15, 231);
INSERT INTO public.who_global_data VALUES (3426, 776, 318181, 11, 4198, 15, 196);
INSERT INTO public.who_global_data VALUES (3427, 1648, 222701, 0, 2956, 15, 105);
INSERT INTO public.who_global_data VALUES (3428, 186, 99630, 3, 1739, 15, 122);
INSERT INTO public.who_global_data VALUES (3429, 0, 0, 0, 0, 15, 159);
INSERT INTO public.who_global_data VALUES (3430, 296, 56988, 7, 1423, 15, 75);
INSERT INTO public.who_global_data VALUES (3431, 570, 159834, 0, 951, 15, 27);
INSERT INTO public.who_global_data VALUES (3432, 118, 83703, 2, 1396, 15, 54);
INSERT INTO public.who_global_data VALUES (3433, 0, 41, 0, 0, 15, 226);
INSERT INTO public.who_global_data VALUES (3434, 902, 58710, 25, 1057, 15, 79);
INSERT INTO public.who_global_data VALUES (3435, 4594, 269241, 67, 2151, 15, 56);
INSERT INTO public.who_global_data VALUES (3436, 520, 7555, 12, 113, 15, 117);
INSERT INTO public.who_global_data VALUES (3437, 0, 1901, 0, 84, 15, 152);
INSERT INTO public.who_global_data VALUES (3438, 622, 111746, 1, 1716, 15, 16);
INSERT INTO public.who_global_data VALUES (3439, 5, 2500, 0, 46, 15, 10);
INSERT INTO public.who_global_data VALUES (3440, 1027, 174846, 37, 2591, 15, 201);
INSERT INTO public.who_global_data VALUES (3441, 115, 49319, 0, 562, 15, 174);
INSERT INTO public.who_global_data VALUES (3442, 0, 18301, 0, 273, 15, 119);
INSERT INTO public.who_global_data VALUES (3443, 1197, 16048, 42, 396, 15, 168);
INSERT INTO public.who_global_data VALUES (3444, 3170, 172549, 12, 642, 15, 99);
INSERT INTO public.who_global_data VALUES (3445, 53, 14765, 1, 50, 15, 171);
INSERT INTO public.who_global_data VALUES (3446, 14, 7911, 2, 320, 15, 87);
INSERT INTO public.who_global_data VALUES (3447, 143, 16423, 3, 248, 15, 123);
INSERT INTO public.who_global_data VALUES (3448, 0, 4, 0, 0, 15, 151);
INSERT INTO public.who_global_data VALUES (3449, 0, 6302, 0, 44, 15, 213);
INSERT INTO public.who_global_data VALUES (3450, 0, 16039, 0, 402, 15, 118);
INSERT INTO public.who_global_data VALUES (3451, 0, 556, 0, 10, 15, 134);
INSERT INTO public.who_global_data VALUES (3452, 177, 7158, 0, 58, 15, 65);
INSERT INTO public.who_global_data VALUES (3453, 20548, 1688944, 1539, 144371, 15, 102);
INSERT INTO public.who_global_data VALUES (3454, 0, 0, 0, 0, 15, 223);
INSERT INTO public.who_global_data VALUES (3455, 25, 1287, 0, 8, 15, 4);
INSERT INTO public.who_global_data VALUES (3456, 16, 1584, 0, 1, 15, 146);
INSERT INTO public.who_global_data VALUES (3457, 421, 57876, 3, 765, 15, 31);
INSERT INTO public.who_global_data VALUES (3458, 0, 13, 0, 1, 15, 127);
INSERT INTO public.who_global_data VALUES (3459, 1164, 463706, 33, 8076, 15, 22);
INSERT INTO public.who_global_data VALUES (3460, 829, 30225, 12, 283, 15, 115);
INSERT INTO public.who_global_data VALUES (3461, 445, 136166, 16, 3013, 15, 106);
INSERT INTO public.who_global_data VALUES (3462, 262, 31515, 9, 310, 15, 90);
INSERT INTO public.who_global_data VALUES (3463, 0, 0, 0, 0, 15, 70);
INSERT INTO public.who_global_data VALUES (3464, 336, 268646, 4, 1979, 15, 46);
INSERT INTO public.who_global_data VALUES (3465, 5816, 932395, 91, 13323, 15, 139);
INSERT INTO public.who_global_data VALUES (3466, 0, 44, 0, 0, 15, 42);
INSERT INTO public.who_global_data VALUES (3467, 8, 1919, 0, 25, 15, 80);
INSERT INTO public.who_global_data VALUES (3468, 0, 4953, 0, 168, 15, 203);
INSERT INTO public.who_global_data VALUES (3469, 18, 4267, 0, 147, 15, 136);
INSERT INTO public.who_global_data VALUES (3470, 1962, 116653, 7, 1485, 15, 63);
INSERT INTO public.who_global_data VALUES (3471, 0, 0, 0, 0, 15, 17);
INSERT INTO public.who_global_data VALUES (3472, 0, 129, 0, 2, 15, 172);
INSERT INTO public.who_global_data VALUES (3473, 354, 89817, 15, 2754, 15, 109);
INSERT INTO public.who_global_data VALUES (3474, 431, 59887, 1, 544, 15, 200);
INSERT INTO public.who_global_data VALUES (3475, 574, 173470, 7, 1925, 15, 93);
INSERT INTO public.who_global_data VALUES (3476, 169, 132486, 1, 1517, 15, 5);
INSERT INTO public.who_global_data VALUES (3477, 0, 745, 0, 13, 15, 214);
INSERT INTO public.who_global_data VALUES (3478, 2363, 527146, 54, 11157, 15, 204);
INSERT INTO public.who_global_data VALUES (3479, 0, 0, 0, 0, 15, 198);
INSERT INTO public.who_global_data VALUES (3480, 2243, 303777, 48, 4912, 15, 173);
INSERT INTO public.who_global_data VALUES (3481, 5, 849, 0, 9, 15, 229);
INSERT INTO public.who_global_data VALUES (3482, 1088, 124447, 22, 2557, 15, 76);
INSERT INTO public.who_global_data VALUES (3483, 5461, 1078675, 113, 39157, 15, 138);
INSERT INTO public.who_global_data VALUES (3484, 1778, 507717, 74, 10116, 15, 98);
INSERT INTO public.who_global_data VALUES (3485, 0, 0, 0, 0, 15, 103);
INSERT INTO public.who_global_data VALUES (3486, 6693, 1464448, 347, 34908, 15, 225);
INSERT INTO public.who_global_data VALUES (3487, 13544, 595149, 221, 9686, 15, 131);
INSERT INTO public.who_global_data VALUES (3488, 215, 88728, 15, 1732, 15, 235);
INSERT INTO public.who_global_data VALUES (3489, 258, 148258, 0, 248, 15, 137);
INSERT INTO public.who_global_data VALUES (3490, 345, 74258, 12, 1328, 15, 81);
INSERT INTO public.who_global_data VALUES (3491, 670, 154788, 16, 3315, 15, 182);
INSERT INTO public.who_global_data VALUES (3492, 0, 9584, 0, 45, 15, 145);
INSERT INTO public.who_global_data VALUES (3493, 2878, 703776, 69, 17554, 15, 26);
INSERT INTO public.who_global_data VALUES (3494, 21513, 3677352, 580, 68412, 15, 170);
INSERT INTO public.who_global_data VALUES (3495, 310, 12170, 9, 162, 15, 191);
INSERT INTO public.who_global_data VALUES (3496, 0, 6, 0, 0, 15, 221);
INSERT INTO public.who_global_data VALUES (3497, 0, 281, 0, 0, 15, 64);
INSERT INTO public.who_global_data VALUES (3498, 0, 0, 0, 0, 15, 116);
INSERT INTO public.who_global_data VALUES (3499, 0, 35, 0, 0, 15, 128);
INSERT INTO public.who_global_data VALUES (3500, 5, 718, 0, 8, 15, 6);
INSERT INTO public.who_global_data VALUES (3501, 0, 1117, 0, 12, 15, 227);
INSERT INTO public.who_global_data VALUES (3502, 0, 16, 0, 0, 15, 68);
INSERT INTO public.who_global_data VALUES (3503, 53, 655, 0, 2, 15, 184);
INSERT INTO public.who_global_data VALUES (3504, 0, 2, 0, 0, 15, 82);
INSERT INTO public.who_global_data VALUES (3505, 18, 2833, 0, 65, 15, 149);
INSERT INTO public.who_global_data VALUES (3506, 1, 1171, 0, 17, 15, 197);
INSERT INTO public.who_global_data VALUES (3507, 212, 365775, 4, 6342, 15, 78);
INSERT INTO public.who_global_data VALUES (3508, 268, 23910, 6, 552, 15, 233);
INSERT INTO public.who_global_data VALUES (3509, 1648, 379093, 20, 3830, 15, 133);
INSERT INTO public.who_global_data VALUES (3510, 22, 866, 0, 3, 15, 35);
INSERT INTO public.who_global_data VALUES (3511, 30, 3081, 0, 77, 15, 114);
INSERT INTO public.who_global_data VALUES (3512, 38, 59235, 0, 29, 15, 237);
INSERT INTO public.who_global_data VALUES (3513, 0, 20, 0, 0, 15, 55);
INSERT INTO public.who_global_data VALUES (3514, 26, 1703, 0, 27, 15, 176);
INSERT INTO public.who_global_data VALUES (3515, 1785, 233027, 93, 3894, 15, 202);
INSERT INTO public.who_global_data VALUES (3516, 1458, 155822, 19, 3594, 15, 155);
INSERT INTO public.who_global_data VALUES (3517, 0, 17, 0, 0, 15, 32);
INSERT INTO public.who_global_data VALUES (3518, 0, 4744, 0, 130, 15, 220);
INSERT INTO public.who_global_data VALUES (3519, 11381, 1380807, 647, 39501, 15, 30);
INSERT INTO public.who_global_data VALUES (3520, 0, 3762, 1, 64, 15, 147);
INSERT INTO public.who_global_data VALUES (3521, 40980, 2545091, 346, 56381, 15, 208);
INSERT INTO public.who_global_data VALUES (3522, 887, 56076, 2, 276, 15, 45);
INSERT INTO public.who_global_data VALUES (3523, 65, 28654, 1, 1733, 15, 110);
INSERT INTO public.who_global_data VALUES (3524, 74, 7783, 0, 146, 15, 88);
INSERT INTO public.who_global_data VALUES (3525, 4950, 542913, 85, 11583, 15, 51);
INSERT INTO public.who_global_data VALUES (3526, 2051, 507524, 41, 8404, 15, 209);
INSERT INTO public.who_global_data VALUES (3527, 85, 13398, 8, 866, 15, 205);
INSERT INTO public.who_global_data VALUES (3528, 0, 13714, 0, 91, 15, 18);
INSERT INTO public.who_global_data VALUES (3529, 309, 13104, 0, 71, 15, 72);
INSERT INTO public.who_global_data VALUES (3530, 37892, 3543650, 1290, 94580, 15, 44);
INSERT INTO public.who_global_data VALUES (3531, 0, 53, 0, 0, 15, 15);
INSERT INTO public.who_global_data VALUES (3532, 46, 4505, 0, 74, 15, 25);
INSERT INTO public.who_global_data VALUES (3533, 0, 0, 0, 0, 15, 179);
INSERT INTO public.who_global_data VALUES (3534, 0, 0, 0, 0, 15, 34);
INSERT INTO public.who_global_data VALUES (3535, 15, 7430, 1, 133, 15, 207);
INSERT INTO public.who_global_data VALUES (3536, 2511, 190884, 68, 5989, 15, 166);
INSERT INTO public.who_global_data VALUES (3537, 6289, 2412505, 153, 24640, 15, 126);
INSERT INTO public.who_global_data VALUES (3538, 0, 0, 0, 0, 15, 97);
INSERT INTO public.who_global_data VALUES (3539, 39, 1164, 0, 7, 15, 36);
INSERT INTO public.who_global_data VALUES (3540, 0, 0, 0, 0, 15, 125);
INSERT INTO public.who_global_data VALUES (3541, 178, 38806, 11, 316, 15, 124);
INSERT INTO public.who_global_data VALUES (3542, 5348, 1182969, 163, 21662, 15, 185);
INSERT INTO public.who_global_data VALUES (3543, 3529, 267258, 4, 766, 15, 194);
INSERT INTO public.who_global_data VALUES (3544, 0, 509, 0, 21, 15, 144);
INSERT INTO public.who_global_data VALUES (3545, 187919, 24225155, 4368, 402803, 15, 19);
INSERT INTO public.who_global_data VALUES (3546, 22, 2305, 0, 24, 15, 217);
INSERT INTO public.who_global_data VALUES (3547, 848, 34294, 6, 336, 15, 148);
INSERT INTO public.who_global_data VALUES (3548, 53, 78272, 0, 620, 15, 86);
INSERT INTO public.who_global_data VALUES (3549, 0, 1, 0, 0, 15, 13);
INSERT INTO public.who_global_data VALUES (3550, 574, 121691, 6, 1122, 15, 157);
INSERT INTO public.who_global_data VALUES (3551, 2, 1546, 0, 35, 15, 8);
INSERT INTO public.who_global_data VALUES (3552, 0, 4, 0, 0, 15, 73);
INSERT INTO public.who_global_data VALUES (3553, 0, 2119, 2, 615, 15, 101);
INSERT INTO public.who_global_data VALUES (3554, 1264, 42213, 12, 597, 15, 165);
INSERT INTO public.who_global_data VALUES (3555, 639, 30047, 38, 917, 15, 14);
INSERT INTO public.who_global_data VALUES (3556, 125, 54403, 9, 2363, 16, 193);
INSERT INTO public.who_global_data VALUES (3557, 670, 69238, 4, 1291, 16, 113);
INSERT INTO public.who_global_data VALUES (3558, 265, 104606, 6, 2854, 16, 143);
INSERT INTO public.who_global_data VALUES (3559, 0, 0, 0, 0, 16, 219);
INSERT INTO public.who_global_data VALUES (3560, 114, 9308, 0, 92, 16, 186);
INSERT INTO public.who_global_data VALUES (3561, 82, 19093, 2, 444, 16, 52);
INSERT INTO public.who_global_data VALUES (3562, 0, 15, 0, 0, 16, 180);
INSERT INTO public.who_global_data VALUES (3563, 0, 190, 0, 6, 16, 167);
INSERT INTO public.who_global_data VALUES (3564, 12141, 1819569, 234, 46066, 16, 154);
INSERT INTO public.who_global_data VALUES (3565, 307, 165528, 5, 3021, 16, 94);
INSERT INTO public.who_global_data VALUES (3566, 72, 6523, 0, 52, 16, 66);
INSERT INTO public.who_global_data VALUES (3567, 10, 28740, 0, 909, 16, 58);
INSERT INTO public.who_global_data VALUES (3568, 1634, 395078, 38, 7165, 16, 163);
INSERT INTO public.who_global_data VALUES (3569, 332, 228028, 12, 3044, 16, 37);
INSERT INTO public.who_global_data VALUES (3570, 7, 8075, 0, 175, 16, 142);
INSERT INTO public.who_global_data VALUES (3571, 313, 98573, 4, 366, 16, 83);
INSERT INTO public.who_global_data VALUES (3572, 656, 529687, 8, 7950, 16, 228);
INSERT INTO public.who_global_data VALUES (3573, 61, 1156, 2, 9, 16, 188);
INSERT INTO public.who_global_data VALUES (3574, 1778, 230494, 9, 1610, 16, 62);
INSERT INTO public.who_global_data VALUES (3575, 2540, 688326, 49, 20642, 16, 160);
INSERT INTO public.who_global_data VALUES (3576, 23, 11615, 1, 283, 16, 50);
INSERT INTO public.who_global_data VALUES (3577, 0, 3582, 0, 48, 16, 33);
INSERT INTO public.who_global_data VALUES (3578, 1, 684, 0, 12, 16, 183);
INSERT INTO public.who_global_data VALUES (3579, 2, 850, 0, 1, 16, 92);
INSERT INTO public.who_global_data VALUES (3580, 2357, 191090, 42, 9722, 16, 158);
INSERT INTO public.who_global_data VALUES (3581, 2, 348, 0, 3, 16, 67);
INSERT INTO public.who_global_data VALUES (3582, 334, 118717, 12, 4521, 16, 57);
INSERT INTO public.who_global_data VALUES (3583, 0, 18630, 0, 88, 16, 38);
INSERT INTO public.who_global_data VALUES (3584, 62094, 8573864, 1192, 211491, 16, 141);
INSERT INTO public.who_global_data VALUES (3585, 0, 121, 0, 1, 16, 178);
INSERT INTO public.who_global_data VALUES (3586, 0, 174, 0, 3, 16, 108);
INSERT INTO public.who_global_data VALUES (3587, 482, 213409, 37, 8651, 16, 39);
INSERT INTO public.who_global_data VALUES (3588, 201, 9553, 1, 106, 16, 2);
INSERT INTO public.who_global_data VALUES (3589, 36, 1358, 0, 2, 16, 195);
INSERT INTO public.who_global_data VALUES (3590, 85, 13224, 1, 121, 16, 107);
INSERT INTO public.who_global_data VALUES (3591, 5, 453, 0, 0, 16, 161);
INSERT INTO public.who_global_data VALUES (3592, 0, 28010, 0, 455, 16, 212);
INSERT INTO public.who_global_data VALUES (3593, 4679, 719751, 146, 18266, 16, 181);
INSERT INTO public.who_global_data VALUES (3594, 1, 381, 0, 2, 16, 53);
INSERT INTO public.who_global_data VALUES (3595, 0, 4974, 0, 63, 16, 164);
INSERT INTO public.who_global_data VALUES (3596, 35, 3012, 0, 114, 16, 140);
INSERT INTO public.who_global_data VALUES (3597, 3589, 680740, 21, 17594, 16, 20);
INSERT INTO public.who_global_data VALUES (3598, 223, 99414, 1, 4808, 16, 112);
INSERT INTO public.who_global_data VALUES (3599, 15939, 1939071, 398, 49402, 16, 111);
INSERT INTO public.who_global_data VALUES (3600, 69, 1933, 3, 54, 16, 71);
INSERT INTO public.who_global_data VALUES (3601, 85, 7794, 3, 117, 16, 218);
INSERT INTO public.who_global_data VALUES (3602, 0, 0, 0, 0, 16, 43);
INSERT INTO public.who_global_data VALUES (3603, 861, 186877, 19, 2477, 16, 49);
INSERT INTO public.who_global_data VALUES (3604, 214, 25597, 0, 142, 16, 1);
INSERT INTO public.who_global_data VALUES (3605, 776, 227326, 27, 4738, 16, 48);
INSERT INTO public.who_global_data VALUES (3606, 349, 19122, 5, 180, 16, 232);
INSERT INTO public.who_global_data VALUES (3607, 4, 4527, 1, 20, 16, 175);
INSERT INTO public.who_global_data VALUES (3608, 178, 29472, 0, 176, 16, 21);
INSERT INTO public.who_global_data VALUES (3609, 8228, 917359, 153, 14973, 16, 156);
INSERT INTO public.who_global_data VALUES (3610, 0, 0, 0, 0, 16, 95);
INSERT INTO public.who_global_data VALUES (3611, 162, 21301, 0, 640, 16, 177);
INSERT INTO public.who_global_data VALUES (3612, 886, 191505, 35, 1872, 16, 210);
INSERT INTO public.who_global_data VALUES (3613, 3, 5913, 0, 61, 16, 120);
INSERT INTO public.who_global_data VALUES (3614, 3, 113, 0, 0, 16, 135);
INSERT INTO public.who_global_data VALUES (3615, 1532, 198123, 9, 2470, 16, 206);
INSERT INTO public.who_global_data VALUES (3616, 1747, 234315, 55, 14437, 16, 189);
INSERT INTO public.who_global_data VALUES (3617, 789, 158963, 51, 8747, 16, 129);
INSERT INTO public.who_global_data VALUES (3618, 0, 51437, 12, 1521, 16, 121);
INSERT INTO public.who_global_data VALUES (3619, 0, 5365, 0, 86, 16, 59);
INSERT INTO public.who_global_data VALUES (3620, 33, 1910, 0, 6, 16, 96);
INSERT INTO public.who_global_data VALUES (3621, 668, 39212, 5, 354, 16, 41);
INSERT INTO public.who_global_data VALUES (3622, 346, 13789, 24, 427, 16, 216);
INSERT INTO public.who_global_data VALUES (3623, 307, 132034, 7, 2044, 16, 236);
INSERT INTO public.who_global_data VALUES (3624, 0, 32, 0, 0, 16, 150);
INSERT INTO public.who_global_data VALUES (3625, 2, 652, 0, 1, 16, 61);
INSERT INTO public.who_global_data VALUES (3626, 0, 55, 0, 2, 16, 7);
INSERT INTO public.who_global_data VALUES (3627, 444, 41166, 0, 633, 16, 169);
INSERT INTO public.who_global_data VALUES (3628, 26565, 2916577, 310, 71261, 16, 28);
INSERT INTO public.who_global_data VALUES (3629, 124, 15311, 0, 76, 16, 85);
INSERT INTO public.who_global_data VALUES (3630, 111, 17808, 1, 128, 16, 211);
INSERT INTO public.who_global_data VALUES (3631, 101, 10120, 0, 66, 16, 60);
INSERT INTO public.who_global_data VALUES (3632, 12, 3950, 0, 128, 16, 3);
INSERT INTO public.who_global_data VALUES (3633, 1137, 251071, 11, 2998, 16, 11);
INSERT INTO public.who_global_data VALUES (3634, 20398, 2088400, 1013, 49783, 16, 89);
INSERT INTO public.who_global_data VALUES (3635, 391, 58822, 0, 358, 16, 24);
INSERT INTO public.who_global_data VALUES (3636, 81, 3793, 2, 47, 16, 162);
INSERT INTO public.who_global_data VALUES (3637, 511, 149973, 27, 5545, 16, 100);
INSERT INTO public.who_global_data VALUES (3638, 0, 30, 0, 0, 16, 47);
INSERT INTO public.who_global_data VALUES (3639, 0, 139, 0, 1, 16, 29);
INSERT INTO public.who_global_data VALUES (3640, 0, 8948, 0, 156, 16, 40);
INSERT INTO public.who_global_data VALUES (3641, 5, 7314, 0, 128, 16, 222);
INSERT INTO public.who_global_data VALUES (3642, 1047, 151324, 30, 5343, 16, 132);
INSERT INTO public.who_global_data VALUES (3643, 0, 309, 0, 13, 16, 130);
INSERT INTO public.who_global_data VALUES (3644, 35, 14207, 0, 81, 16, 234);
INSERT INTO public.who_global_data VALUES (3645, 0, 2510, 0, 45, 16, 23);
INSERT INTO public.who_global_data VALUES (3646, 19, 6950, 0, 170, 16, 192);
INSERT INTO public.who_global_data VALUES (3647, 56, 10963, 0, 240, 16, 69);
INSERT INTO public.who_global_data VALUES (3648, 0, 26, 0, 0, 16, 187);
INSERT INTO public.who_global_data VALUES (3649, 1130, 136068, 23, 3391, 16, 230);
INSERT INTO public.who_global_data VALUES (3650, 1410, 355662, 98, 11713, 16, 77);
INSERT INTO public.who_global_data VALUES (3651, 5, 5975, 0, 29, 16, 9);
INSERT INTO public.who_global_data VALUES (3652, 15223, 10610883, 151, 152869, 16, 74);
INSERT INTO public.who_global_data VALUES (3653, 12568, 939948, 267, 26857, 16, 224);
INSERT INTO public.who_global_data VALUES (3654, 6182, 1348316, 84, 57057, 16, 199);
INSERT INTO public.who_global_data VALUES (3655, 746, 610598, 6, 12968, 16, 190);
INSERT INTO public.who_global_data VALUES (3656, 2485, 179324, 60, 2768, 16, 12);
INSERT INTO public.who_global_data VALUES (3657, 0, 432, 0, 25, 16, 104);
INSERT INTO public.who_global_data VALUES (3658, 8601, 569215, 46, 4165, 16, 153);
INSERT INTO public.who_global_data VALUES (3659, 13568, 2414166, 524, 83681, 16, 91);
INSERT INTO public.who_global_data VALUES (3660, 68, 14487, 2, 331, 16, 215);
INSERT INTO public.who_global_data VALUES (3661, 5447, 345221, 96, 4743, 16, 84);
INSERT INTO public.who_global_data VALUES (3662, 16, 3077, 0, 62, 16, 231);
INSERT INTO public.who_global_data VALUES (3663, 978, 317405, 17, 4187, 16, 196);
INSERT INTO public.who_global_data VALUES (3664, 1526, 221053, 0, 2956, 16, 105);
INSERT INTO public.who_global_data VALUES (3665, 136, 99444, 2, 1736, 16, 122);
INSERT INTO public.who_global_data VALUES (3666, 0, 0, 0, 0, 16, 159);
INSERT INTO public.who_global_data VALUES (3667, 320, 56692, 6, 1416, 16, 75);
INSERT INTO public.who_global_data VALUES (3668, 442, 159264, 1, 951, 16, 27);
INSERT INTO public.who_global_data VALUES (3669, 155, 83585, 2, 1394, 16, 54);
INSERT INTO public.who_global_data VALUES (3670, 0, 41, 0, 0, 16, 226);
INSERT INTO public.who_global_data VALUES (3671, 1088, 57808, 20, 1032, 16, 79);
INSERT INTO public.who_global_data VALUES (3672, 4332, 264647, 64, 2084, 16, 56);
INSERT INTO public.who_global_data VALUES (3673, 17, 7035, 0, 101, 16, 117);
INSERT INTO public.who_global_data VALUES (3674, 3, 1901, 0, 84, 16, 152);
INSERT INTO public.who_global_data VALUES (3675, 659, 111124, 15, 1715, 16, 16);
INSERT INTO public.who_global_data VALUES (3676, 17, 2495, 0, 46, 16, 10);
INSERT INTO public.who_global_data VALUES (3677, 1759, 173819, 40, 2554, 16, 201);
INSERT INTO public.who_global_data VALUES (3678, 238, 49204, 2, 562, 16, 174);
INSERT INTO public.who_global_data VALUES (3679, 0, 18301, 0, 273, 16, 119);
INSERT INTO public.who_global_data VALUES (3680, 971, 14851, 18, 354, 16, 168);
INSERT INTO public.who_global_data VALUES (3681, 4008, 169379, 11, 630, 16, 99);
INSERT INTO public.who_global_data VALUES (3682, 79, 14712, 0, 49, 16, 171);
INSERT INTO public.who_global_data VALUES (3683, 17, 7897, 1, 318, 16, 87);
INSERT INTO public.who_global_data VALUES (3684, 151, 16280, 1, 245, 16, 123);
INSERT INTO public.who_global_data VALUES (3685, 0, 4, 0, 0, 16, 151);
INSERT INTO public.who_global_data VALUES (3686, 0, 6302, 0, 44, 16, 213);
INSERT INTO public.who_global_data VALUES (3687, 0, 16039, 0, 402, 16, 118);
INSERT INTO public.who_global_data VALUES (3688, 0, 556, 0, 10, 16, 134);
INSERT INTO public.who_global_data VALUES (3689, 63, 6981, 0, 58, 16, 65);
INSERT INTO public.who_global_data VALUES (3690, 18894, 1668396, 1584, 142832, 16, 102);
INSERT INTO public.who_global_data VALUES (3691, 0, 0, 0, 0, 16, 223);
INSERT INTO public.who_global_data VALUES (3692, 22, 1262, 0, 8, 16, 4);
INSERT INTO public.who_global_data VALUES (3693, 32, 1568, 0, 1, 16, 146);
INSERT INTO public.who_global_data VALUES (3694, 476, 57455, 4, 762, 16, 31);
INSERT INTO public.who_global_data VALUES (3695, 0, 13, 0, 1, 16, 127);
INSERT INTO public.who_global_data VALUES (3696, 1152, 462542, 32, 8043, 16, 22);
INSERT INTO public.who_global_data VALUES (3697, 1126, 29396, 18, 271, 16, 115);
INSERT INTO public.who_global_data VALUES (3698, 478, 135721, 11, 2997, 16, 106);
INSERT INTO public.who_global_data VALUES (3699, 258, 31253, 5, 301, 16, 90);
INSERT INTO public.who_global_data VALUES (3700, 0, 0, 0, 0, 16, 70);
INSERT INTO public.who_global_data VALUES (3701, 318, 268310, 6, 1975, 16, 46);
INSERT INTO public.who_global_data VALUES (3702, 5577, 926579, 86, 13232, 16, 139);
INSERT INTO public.who_global_data VALUES (3703, 0, 44, 0, 0, 16, 42);
INSERT INTO public.who_global_data VALUES (3704, 0, 1911, 0, 25, 16, 80);
INSERT INTO public.who_global_data VALUES (3705, 0, 4953, 0, 168, 16, 203);
INSERT INTO public.who_global_data VALUES (3706, 24, 4249, 1, 147, 16, 136);
INSERT INTO public.who_global_data VALUES (3707, 1386, 114691, 14, 1478, 16, 63);
INSERT INTO public.who_global_data VALUES (3708, 0, 0, 0, 0, 16, 17);
INSERT INTO public.who_global_data VALUES (3709, 0, 129, 0, 2, 16, 172);
INSERT INTO public.who_global_data VALUES (3710, 71, 89463, 13, 2739, 16, 109);
INSERT INTO public.who_global_data VALUES (3711, 423, 59456, 18, 543, 16, 200);
INSERT INTO public.who_global_data VALUES (3712, 497, 172896, 10, 1918, 16, 93);
INSERT INTO public.who_global_data VALUES (3713, 171, 132317, 0, 1516, 16, 5);
INSERT INTO public.who_global_data VALUES (3714, 0, 745, 0, 13, 16, 214);
INSERT INTO public.who_global_data VALUES (3715, 1772, 524783, 48, 11103, 16, 204);
INSERT INTO public.who_global_data VALUES (3716, 0, 0, 0, 0, 16, 198);
INSERT INTO public.who_global_data VALUES (3717, 2173, 301534, 36, 4864, 16, 173);
INSERT INTO public.who_global_data VALUES (3718, 1, 844, 0, 9, 16, 229);
INSERT INTO public.who_global_data VALUES (3719, 771, 123359, 17, 2535, 16, 76);
INSERT INTO public.who_global_data VALUES (3720, 4412, 1073214, 113, 39044, 16, 138);
INSERT INTO public.who_global_data VALUES (3721, 1855, 505939, 64, 10042, 16, 98);
INSERT INTO public.who_global_data VALUES (3722, 0, 0, 0, 0, 16, 103);
INSERT INTO public.who_global_data VALUES (3723, 7008, 1457755, 420, 34561, 16, 225);
INSERT INTO public.who_global_data VALUES (3724, 14647, 581605, 219, 9465, 16, 131);
INSERT INTO public.who_global_data VALUES (3725, 140, 88513, 14, 1717, 16, 235);
INSERT INTO public.who_global_data VALUES (3726, 271, 148000, 0, 248, 16, 137);
INSERT INTO public.who_global_data VALUES (3727, 401, 73913, 16, 1316, 16, 81);
INSERT INTO public.who_global_data VALUES (3728, 612, 154118, 17, 3299, 16, 182);
INSERT INTO public.who_global_data VALUES (3729, 32, 9584, 0, 45, 16, 145);
INSERT INTO public.who_global_data VALUES (3730, 3000, 700898, 116, 17485, 16, 26);
INSERT INTO public.who_global_data VALUES (3731, 21887, 3655839, 612, 67832, 16, 170);
INSERT INTO public.who_global_data VALUES (3732, 312, 11860, 5, 153, 16, 191);
INSERT INTO public.who_global_data VALUES (3733, 1, 6, 0, 0, 16, 221);
INSERT INTO public.who_global_data VALUES (3734, 0, 281, 0, 0, 16, 64);
INSERT INTO public.who_global_data VALUES (3735, 0, 0, 0, 0, 16, 116);
INSERT INTO public.who_global_data VALUES (3736, 0, 35, 0, 0, 16, 128);
INSERT INTO public.who_global_data VALUES (3737, 57, 713, 0, 8, 16, 6);
INSERT INTO public.who_global_data VALUES (3738, 0, 1117, 0, 12, 16, 227);
INSERT INTO public.who_global_data VALUES (3739, 0, 16, 0, 0, 16, 68);
INSERT INTO public.who_global_data VALUES (3740, 62, 602, 0, 2, 16, 184);
INSERT INTO public.who_global_data VALUES (3741, 0, 2, 0, 0, 16, 82);
INSERT INTO public.who_global_data VALUES (3742, 28, 2815, 0, 65, 16, 149);
INSERT INTO public.who_global_data VALUES (3743, 19, 1170, 0, 17, 16, 197);
INSERT INTO public.who_global_data VALUES (3744, 238, 365563, 3, 6338, 16, 78);
INSERT INTO public.who_global_data VALUES (3745, 250, 23642, 10, 546, 16, 233);
INSERT INTO public.who_global_data VALUES (3746, 1646, 377445, 19, 3810, 16, 133);
INSERT INTO public.who_global_data VALUES (3747, 82, 844, 1, 3, 16, 35);
INSERT INTO public.who_global_data VALUES (3748, 21, 3051, 0, 77, 16, 114);
INSERT INTO public.who_global_data VALUES (3749, 40, 59197, 0, 29, 16, 237);
INSERT INTO public.who_global_data VALUES (3750, 0, 20, 0, 0, 16, 55);
INSERT INTO public.who_global_data VALUES (3751, 8, 1677, 0, 27, 16, 176);
INSERT INTO public.who_global_data VALUES (3752, 2464, 231242, 64, 3801, 16, 202);
INSERT INTO public.who_global_data VALUES (3753, 1455, 154364, 26, 3575, 16, 155);
INSERT INTO public.who_global_data VALUES (3754, 0, 17, 0, 0, 16, 32);
INSERT INTO public.who_global_data VALUES (3755, 0, 4744, 0, 130, 16, 220);
INSERT INTO public.who_global_data VALUES (3756, 12710, 1369426, 566, 38854, 16, 30);
INSERT INTO public.who_global_data VALUES (3757, 0, 3762, 0, 63, 16, 147);
INSERT INTO public.who_global_data VALUES (3758, 41232, 2504111, 378, 56035, 16, 208);
INSERT INTO public.who_global_data VALUES (3759, 770, 55189, 1, 274, 16, 45);
INSERT INTO public.who_global_data VALUES (3760, 67, 28589, 10, 1732, 16, 110);
INSERT INTO public.who_global_data VALUES (3761, 85, 7709, 1, 146, 16, 88);
INSERT INTO public.who_global_data VALUES (3762, 4739, 537963, 86, 11498, 16, 51);
INSERT INTO public.who_global_data VALUES (3763, 2277, 505473, 41, 8363, 16, 209);
INSERT INTO public.who_global_data VALUES (3764, 89, 13313, 8, 858, 16, 205);
INSERT INTO public.who_global_data VALUES (3765, 0, 13714, 0, 91, 16, 18);
INSERT INTO public.who_global_data VALUES (3766, 142, 12795, 0, 71, 16, 72);
INSERT INTO public.who_global_data VALUES (3767, 38905, 3505758, 1820, 93290, 16, 44);
INSERT INTO public.who_global_data VALUES (3768, 1, 53, 0, 0, 16, 15);
INSERT INTO public.who_global_data VALUES (3769, 76, 4459, 0, 74, 16, 25);
INSERT INTO public.who_global_data VALUES (3770, 0, 0, 0, 0, 16, 179);
INSERT INTO public.who_global_data VALUES (3771, 0, 0, 0, 0, 16, 34);
INSERT INTO public.who_global_data VALUES (3772, 16, 7415, 0, 132, 16, 207);
INSERT INTO public.who_global_data VALUES (3773, 3890, 188373, 77, 5921, 16, 166);
INSERT INTO public.who_global_data VALUES (3774, 6435, 2406216, 159, 24487, 16, 126);
INSERT INTO public.who_global_data VALUES (3775, 0, 0, 0, 0, 16, 97);
INSERT INTO public.who_global_data VALUES (3776, 20, 1125, 0, 7, 16, 36);
INSERT INTO public.who_global_data VALUES (3777, 0, 0, 0, 0, 16, 125);
INSERT INTO public.who_global_data VALUES (3778, 94, 38628, 0, 305, 16, 124);
INSERT INTO public.who_global_data VALUES (3779, 5583, 1177621, 241, 21499, 16, 185);
INSERT INTO public.who_global_data VALUES (3780, 3506, 263729, 6, 762, 16, 194);
INSERT INTO public.who_global_data VALUES (3781, 0, 509, 0, 21, 16, 144);
INSERT INTO public.who_global_data VALUES (3782, 152937, 24037236, 2280, 398435, 16, 19);
INSERT INTO public.who_global_data VALUES (3783, 23, 2283, 0, 24, 16, 217);
INSERT INTO public.who_global_data VALUES (3784, 583, 33446, 11, 330, 16, 148);
INSERT INTO public.who_global_data VALUES (3785, 56, 78219, 0, 620, 16, 86);
INSERT INTO public.who_global_data VALUES (3786, 0, 1, 0, 0, 16, 13);
INSERT INTO public.who_global_data VALUES (3787, 673, 121117, 4, 1116, 16, 157);
INSERT INTO public.who_global_data VALUES (3788, 4, 1544, 0, 35, 16, 8);
INSERT INTO public.who_global_data VALUES (3789, 0, 4, 0, 0, 16, 73);
INSERT INTO public.who_global_data VALUES (3790, 0, 2119, 0, 613, 16, 101);
INSERT INTO public.who_global_data VALUES (3791, 1434, 40949, 7, 585, 16, 165);
INSERT INTO public.who_global_data VALUES (3792, 733, 29408, 54, 879, 16, 14);
INSERT INTO public.who_global_data VALUES (3793, 137, 54278, 8, 2354, 17, 193);
INSERT INTO public.who_global_data VALUES (3794, 586, 68568, 6, 1287, 17, 113);
INSERT INTO public.who_global_data VALUES (3795, 249, 104341, 3, 2848, 17, 143);
INSERT INTO public.who_global_data VALUES (3796, 0, 0, 0, 0, 17, 219);
INSERT INTO public.who_global_data VALUES (3797, 111, 9194, 1, 92, 17, 186);
INSERT INTO public.who_global_data VALUES (3798, 85, 19011, 3, 442, 17, 52);
INSERT INTO public.who_global_data VALUES (3799, 0, 15, 0, 0, 17, 180);
INSERT INTO public.who_global_data VALUES (3800, 1, 190, 0, 6, 17, 167);
INSERT INTO public.who_global_data VALUES (3801, 8185, 1807428, 425, 45832, 17, 154);
INSERT INTO public.who_global_data VALUES (3802, 309, 165221, 9, 3016, 17, 94);
INSERT INTO public.who_global_data VALUES (3803, 16, 6451, 0, 52, 17, 66);
INSERT INTO public.who_global_data VALUES (3804, 9, 28730, 0, 909, 17, 58);
INSERT INTO public.who_global_data VALUES (3805, 1463, 393444, 58, 7127, 17, 163);
INSERT INTO public.who_global_data VALUES (3806, 305, 227696, 10, 3032, 17, 37);
INSERT INTO public.who_global_data VALUES (3807, 1, 8068, 0, 175, 17, 142);
INSERT INTO public.who_global_data VALUES (3808, 320, 98260, 2, 362, 17, 83);
INSERT INTO public.who_global_data VALUES (3809, 702, 529031, 20, 7942, 17, 228);
INSERT INTO public.who_global_data VALUES (3810, 0, 1095, 0, 7, 17, 188);
INSERT INTO public.who_global_data VALUES (3811, 1356, 228716, 10, 1601, 17, 62);
INSERT INTO public.who_global_data VALUES (3812, 2485, 685786, 60, 20593, 17, 160);
INSERT INTO public.who_global_data VALUES (3813, 12, 11592, 1, 282, 17, 50);
INSERT INTO public.who_global_data VALUES (3814, 169, 3582, 2, 48, 17, 33);
INSERT INTO public.who_global_data VALUES (3815, 13, 683, 0, 12, 17, 183);
INSERT INTO public.who_global_data VALUES (3816, 5, 848, 0, 1, 17, 92);
INSERT INTO public.who_global_data VALUES (3817, 1550, 188733, 44, 9680, 17, 158);
INSERT INTO public.who_global_data VALUES (3818, 6, 346, 0, 3, 17, 67);
INSERT INTO public.who_global_data VALUES (3819, 300, 118383, 23, 4509, 17, 57);
INSERT INTO public.who_global_data VALUES (3820, 0, 18630, 0, 88, 17, 38);
INSERT INTO public.who_global_data VALUES (3821, 23671, 8511770, 452, 210299, 17, 141);
INSERT INTO public.who_global_data VALUES (3822, 0, 121, 0, 1, 17, 178);
INSERT INTO public.who_global_data VALUES (3823, 0, 174, 0, 3, 17, 108);
INSERT INTO public.who_global_data VALUES (3824, 544, 212927, 49, 8614, 17, 39);
INSERT INTO public.who_global_data VALUES (3825, 0, 9352, 0, 105, 17, 2);
INSERT INTO public.who_global_data VALUES (3826, 69, 1322, 0, 2, 17, 195);
INSERT INTO public.who_global_data VALUES (3827, 93, 13139, 0, 120, 17, 107);
INSERT INTO public.who_global_data VALUES (3828, 7, 448, 0, 0, 17, 161);
INSERT INTO public.who_global_data VALUES (3829, 0, 28010, 0, 455, 17, 212);
INSERT INTO public.who_global_data VALUES (3830, 6453, 715072, 106, 18120, 17, 181);
INSERT INTO public.who_global_data VALUES (3831, 6, 380, 0, 2, 17, 53);
INSERT INTO public.who_global_data VALUES (3832, 1, 4974, 0, 63, 17, 164);
INSERT INTO public.who_global_data VALUES (3833, 58, 2977, 1, 114, 17, 140);
INSERT INTO public.who_global_data VALUES (3834, 3401, 677151, 26, 17573, 17, 20);
INSERT INTO public.who_global_data VALUES (3835, 165, 99191, 2, 4807, 17, 112);
INSERT INTO public.who_global_data VALUES (3836, 14719, 1923132, 373, 49004, 17, 111);
INSERT INTO public.who_global_data VALUES (3837, 95, 1864, 2, 51, 17, 71);
INSERT INTO public.who_global_data VALUES (3838, 0, 7709, 0, 114, 17, 218);
INSERT INTO public.who_global_data VALUES (3839, 0, 0, 0, 0, 17, 43);
INSERT INTO public.who_global_data VALUES (3840, 363, 186016, 9, 2458, 17, 49);
INSERT INTO public.who_global_data VALUES (3841, 78, 25383, 0, 142, 17, 1);
INSERT INTO public.who_global_data VALUES (3842, 902, 226550, 27, 4711, 17, 48);
INSERT INTO public.who_global_data VALUES (3843, 330, 18773, 2, 175, 17, 232);
INSERT INTO public.who_global_data VALUES (3844, 3, 4523, 0, 19, 17, 175);
INSERT INTO public.who_global_data VALUES (3845, 164, 29294, 1, 176, 17, 21);
INSERT INTO public.who_global_data VALUES (3846, 9628, 909131, 174, 14820, 17, 156);
INSERT INTO public.who_global_data VALUES (3847, 0, 0, 0, 0, 17, 95);
INSERT INTO public.who_global_data VALUES (3848, 232, 21139, 10, 640, 17, 177);
INSERT INTO public.who_global_data VALUES (3849, 724, 190619, 32, 1837, 17, 210);
INSERT INTO public.who_global_data VALUES (3850, 4, 5910, 0, 61, 17, 120);
INSERT INTO public.who_global_data VALUES (3851, 0, 110, 0, 0, 17, 135);
INSERT INTO public.who_global_data VALUES (3852, 1625, 196591, 13, 2461, 17, 206);
INSERT INTO public.who_global_data VALUES (3853, 924, 232568, 60, 14382, 17, 189);
INSERT INTO public.who_global_data VALUES (3854, 899, 158174, 58, 8696, 17, 129);
INSERT INTO public.who_global_data VALUES (3855, 0, 51437, 11, 1509, 17, 121);
INSERT INTO public.who_global_data VALUES (3856, 0, 5365, 0, 86, 17, 59);
INSERT INTO public.who_global_data VALUES (3857, 0, 1877, 0, 6, 17, 96);
INSERT INTO public.who_global_data VALUES (3858, 603, 38544, 5, 349, 17, 41);
INSERT INTO public.who_global_data VALUES (3859, 256, 13443, 19, 403, 17, 216);
INSERT INTO public.who_global_data VALUES (3860, 181, 131727, 4, 2037, 17, 236);
INSERT INTO public.who_global_data VALUES (3861, 0, 32, 0, 0, 17, 150);
INSERT INTO public.who_global_data VALUES (3862, 1, 650, 0, 1, 17, 61);
INSERT INTO public.who_global_data VALUES (3863, 0, 55, 0, 2, 17, 7);
INSERT INTO public.who_global_data VALUES (3864, 217, 40722, 12, 633, 17, 169);
INSERT INTO public.who_global_data VALUES (3865, 23347, 2890012, 656, 70951, 17, 28);
INSERT INTO public.who_global_data VALUES (3866, 132, 15187, 0, 76, 17, 85);
INSERT INTO public.who_global_data VALUES (3867, 0, 17697, 0, 127, 17, 211);
INSERT INTO public.who_global_data VALUES (3868, 0, 10019, 0, 66, 17, 60);
INSERT INTO public.who_global_data VALUES (3869, 5, 3938, 0, 128, 17, 3);
INSERT INTO public.who_global_data VALUES (3870, 469, 249934, 14, 2987, 17, 11);
INSERT INTO public.who_global_data VALUES (3871, 15974, 2068002, 1148, 48770, 17, 89);
INSERT INTO public.who_global_data VALUES (3872, 366, 58431, 6, 358, 17, 24);
INSERT INTO public.who_global_data VALUES (3873, 42, 3712, 2, 45, 17, 162);
INSERT INTO public.who_global_data VALUES (3874, 537, 149462, 30, 5518, 17, 100);
INSERT INTO public.who_global_data VALUES (3875, 0, 30, 0, 0, 17, 47);
INSERT INTO public.who_global_data VALUES (3876, 0, 139, 0, 1, 17, 29);
INSERT INTO public.who_global_data VALUES (3877, 0, 8948, 0, 156, 17, 40);
INSERT INTO public.who_global_data VALUES (3878, 22, 7309, 0, 128, 17, 222);
INSERT INTO public.who_global_data VALUES (3879, 1131, 150277, 35, 5313, 17, 132);
INSERT INTO public.who_global_data VALUES (3880, 0, 309, 0, 13, 17, 130);
INSERT INTO public.who_global_data VALUES (3881, 7, 14172, 0, 81, 17, 234);
INSERT INTO public.who_global_data VALUES (3882, 32, 2510, 0, 45, 17, 23);
INSERT INTO public.who_global_data VALUES (3883, 23, 6931, 0, 170, 17, 192);
INSERT INTO public.who_global_data VALUES (3884, 55, 10907, 0, 240, 17, 69);
INSERT INTO public.who_global_data VALUES (3885, 0, 26, 0, 0, 17, 187);
INSERT INTO public.who_global_data VALUES (3886, 827, 134938, 14, 3368, 17, 230);
INSERT INTO public.who_global_data VALUES (3887, 976, 354252, 95, 11615, 17, 77);
INSERT INTO public.who_global_data VALUES (3888, 0, 5970, 0, 29, 17, 9);
INSERT INTO public.who_global_data VALUES (3889, 13823, 10595660, 162, 152718, 17, 74);
INSERT INTO public.who_global_data VALUES (3890, 10365, 927380, 308, 26590, 17, 224);
INSERT INTO public.who_global_data VALUES (3891, 5917, 1342134, 87, 56973, 17, 199);
INSERT INTO public.who_global_data VALUES (3892, 823, 609852, 9, 12962, 17, 190);
INSERT INTO public.who_global_data VALUES (3893, 1996, 176839, 92, 2708, 17, 12);
INSERT INTO public.who_global_data VALUES (3894, 4, 432, 0, 25, 17, 104);
INSERT INTO public.who_global_data VALUES (3895, 10116, 560614, 47, 4119, 17, 153);
INSERT INTO public.who_global_data VALUES (3896, 10496, 2400598, 603, 83157, 17, 91);
INSERT INTO public.who_global_data VALUES (3897, 145, 14419, 3, 329, 17, 215);
INSERT INTO public.who_global_data VALUES (3898, 5446, 339774, 99, 4647, 17, 84);
INSERT INTO public.who_global_data VALUES (3899, 7, 3061, 0, 62, 17, 231);
INSERT INTO public.who_global_data VALUES (3900, 883, 316427, 17, 4170, 17, 196);
INSERT INTO public.who_global_data VALUES (3901, 1311, 219527, 0, 2956, 17, 105);
INSERT INTO public.who_global_data VALUES (3902, 81, 99308, 0, 1734, 17, 122);
INSERT INTO public.who_global_data VALUES (3903, 0, 0, 0, 0, 17, 159);
INSERT INTO public.who_global_data VALUES (3904, 297, 56372, 9, 1410, 17, 75);
INSERT INTO public.who_global_data VALUES (3905, 578, 158822, 2, 950, 17, 27);
INSERT INTO public.who_global_data VALUES (3906, 162, 83430, 2, 1392, 17, 54);
INSERT INTO public.who_global_data VALUES (3907, 0, 41, 0, 0, 17, 226);
INSERT INTO public.who_global_data VALUES (3908, 812, 56720, 29, 1012, 17, 79);
INSERT INTO public.who_global_data VALUES (3909, 4359, 260315, 61, 2020, 17, 56);
INSERT INTO public.who_global_data VALUES (3910, 647, 7018, 8, 101, 17, 117);
INSERT INTO public.who_global_data VALUES (3911, 2, 1898, 0, 84, 17, 152);
INSERT INTO public.who_global_data VALUES (3912, 596, 110465, 2, 1700, 17, 16);
INSERT INTO public.who_global_data VALUES (3913, 10, 2478, 1, 46, 17, 10);
INSERT INTO public.who_global_data VALUES (3914, 3352, 172060, 20, 2514, 17, 201);
INSERT INTO public.who_global_data VALUES (3915, 85, 48966, 3, 560, 17, 174);
INSERT INTO public.who_global_data VALUES (3916, 0, 18301, 0, 273, 17, 119);
INSERT INTO public.who_global_data VALUES (3917, 853, 13880, 15, 336, 17, 168);
INSERT INTO public.who_global_data VALUES (3918, 3631, 165371, 14, 619, 17, 99);
INSERT INTO public.who_global_data VALUES (3919, 51, 14633, 0, 49, 17, 171);
INSERT INTO public.who_global_data VALUES (3920, 25, 7880, 6, 317, 17, 87);
INSERT INTO public.who_global_data VALUES (3921, 187, 16129, 2, 244, 17, 123);
INSERT INTO public.who_global_data VALUES (3922, 0, 4, 0, 0, 17, 151);
INSERT INTO public.who_global_data VALUES (3923, 0, 6302, 0, 44, 17, 213);
INSERT INTO public.who_global_data VALUES (3924, 0, 16039, 0, 402, 17, 118);
INSERT INTO public.who_global_data VALUES (3925, 9, 556, 0, 10, 17, 134);
INSERT INTO public.who_global_data VALUES (3926, 129, 6918, 0, 58, 17, 65);
INSERT INTO public.who_global_data VALUES (3927, 8074, 1649502, 544, 141248, 17, 102);
INSERT INTO public.who_global_data VALUES (3928, 0, 0, 0, 0, 17, 223);
INSERT INTO public.who_global_data VALUES (3929, 25, 1240, 0, 8, 17, 4);
INSERT INTO public.who_global_data VALUES (3930, 10, 1536, 0, 1, 17, 146);
INSERT INTO public.who_global_data VALUES (3931, 452, 56979, 9, 758, 17, 31);
INSERT INTO public.who_global_data VALUES (3932, 0, 13, 0, 1, 17, 127);
INSERT INTO public.who_global_data VALUES (3933, 1246, 461390, 34, 8011, 17, 22);
INSERT INTO public.who_global_data VALUES (3934, 824, 28270, 4, 253, 17, 115);
INSERT INTO public.who_global_data VALUES (3935, 448, 135243, 13, 2986, 17, 106);
INSERT INTO public.who_global_data VALUES (3936, 242, 30995, 3, 296, 17, 90);
INSERT INTO public.who_global_data VALUES (3937, 0, 0, 0, 0, 17, 70);
INSERT INTO public.who_global_data VALUES (3938, 348, 267992, 4, 1969, 17, 46);
INSERT INTO public.who_global_data VALUES (3939, 4304, 921002, 106, 13146, 17, 139);
INSERT INTO public.who_global_data VALUES (3940, 0, 44, 0, 0, 17, 42);
INSERT INTO public.who_global_data VALUES (3941, 6, 1911, 0, 25, 17, 80);
INSERT INTO public.who_global_data VALUES (3942, 37, 4953, 1, 168, 17, 203);
INSERT INTO public.who_global_data VALUES (3943, 21, 4225, 1, 146, 17, 136);
INSERT INTO public.who_global_data VALUES (3944, 1301, 113305, 15, 1464, 17, 63);
INSERT INTO public.who_global_data VALUES (3945, 0, 0, 0, 0, 17, 17);
INSERT INTO public.who_global_data VALUES (3946, 0, 129, 0, 2, 17, 172);
INSERT INTO public.who_global_data VALUES (3947, 400, 89392, 11, 2726, 17, 109);
INSERT INTO public.who_global_data VALUES (3948, 382, 59033, 4, 525, 17, 200);
INSERT INTO public.who_global_data VALUES (3949, 660, 172399, 19, 1908, 17, 93);
INSERT INTO public.who_global_data VALUES (3950, 135, 132146, 2, 1516, 17, 5);
INSERT INTO public.who_global_data VALUES (3951, 0, 745, 0, 13, 17, 214);
INSERT INTO public.who_global_data VALUES (3952, 1800, 523011, 58, 11055, 17, 204);
INSERT INTO public.who_global_data VALUES (3953, 0, 0, 0, 0, 17, 198);
INSERT INTO public.who_global_data VALUES (3954, 1342, 299361, 41, 4828, 17, 173);
INSERT INTO public.who_global_data VALUES (3955, 9, 843, 0, 9, 17, 229);
INSERT INTO public.who_global_data VALUES (3956, 428, 122588, 13, 2518, 17, 76);
INSERT INTO public.who_global_data VALUES (3957, 3893, 1068802, 60, 38931, 17, 138);
INSERT INTO public.who_global_data VALUES (3958, 1348, 504084, 69, 9978, 17, 98);
INSERT INTO public.who_global_data VALUES (3959, 0, 0, 0, 0, 17, 103);
INSERT INTO public.who_global_data VALUES (3960, 6943, 1450747, 443, 34141, 17, 225);
INSERT INTO public.who_global_data VALUES (3961, 10455, 566958, 218, 9246, 17, 131);
INSERT INTO public.who_global_data VALUES (3962, 434, 88373, 0, 1703, 17, 235);
INSERT INTO public.who_global_data VALUES (3963, 225, 147729, 0, 248, 17, 137);
INSERT INTO public.who_global_data VALUES (3964, 404, 73512, 17, 1300, 17, 81);
INSERT INTO public.who_global_data VALUES (3965, 394, 153506, 15, 3282, 17, 182);
INSERT INTO public.who_global_data VALUES (3966, 0, 9552, 0, 45, 17, 145);
INSERT INTO public.who_global_data VALUES (3967, 2745, 697898, 98, 17369, 17, 26);
INSERT INTO public.who_global_data VALUES (3968, 21152, 3633952, 597, 67220, 17, 170);
INSERT INTO public.who_global_data VALUES (3969, 289, 11548, 2, 148, 17, 191);
INSERT INTO public.who_global_data VALUES (3970, 0, 5, 0, 0, 17, 221);
INSERT INTO public.who_global_data VALUES (3971, 0, 281, 0, 0, 17, 64);
INSERT INTO public.who_global_data VALUES (3972, 0, 0, 0, 0, 17, 116);
INSERT INTO public.who_global_data VALUES (3973, 0, 35, 0, 0, 17, 128);
INSERT INTO public.who_global_data VALUES (3974, 35, 656, 0, 8, 17, 6);
INSERT INTO public.who_global_data VALUES (3975, 0, 1117, 0, 12, 17, 227);
INSERT INTO public.who_global_data VALUES (3976, 0, 16, 0, 0, 17, 68);
INSERT INTO public.who_global_data VALUES (3977, 46, 540, 0, 2, 17, 184);
INSERT INTO public.who_global_data VALUES (3978, 0, 2, 0, 0, 17, 82);
INSERT INTO public.who_global_data VALUES (3979, 0, 2787, 0, 65, 17, 149);
INSERT INTO public.who_global_data VALUES (3980, 9, 1151, 0, 17, 17, 197);
INSERT INTO public.who_global_data VALUES (3981, 226, 365325, 6, 6335, 17, 78);
INSERT INTO public.who_global_data VALUES (3982, 168, 23392, 10, 536, 17, 233);
INSERT INTO public.who_global_data VALUES (3983, 1688, 375799, 20, 3791, 17, 133);
INSERT INTO public.who_global_data VALUES (3984, 16, 762, 0, 2, 17, 35);
INSERT INTO public.who_global_data VALUES (3985, 16, 3030, 0, 77, 17, 114);
INSERT INTO public.who_global_data VALUES (3986, 30, 59157, 0, 29, 17, 237);
INSERT INTO public.who_global_data VALUES (3987, 0, 20, 0, 0, 17, 55);
INSERT INTO public.who_global_data VALUES (3988, 13, 1669, 0, 27, 17, 176);
INSERT INTO public.who_global_data VALUES (3989, 2484, 228778, 100, 3737, 17, 202);
INSERT INTO public.who_global_data VALUES (3990, 1713, 152909, 23, 3549, 17, 155);
INSERT INTO public.who_global_data VALUES (3991, 0, 17, 0, 0, 17, 32);
INSERT INTO public.who_global_data VALUES (3992, 0, 4744, 0, 130, 17, 220);
INSERT INTO public.who_global_data VALUES (3993, 9780, 1356716, 839, 38288, 17, 30);
INSERT INTO public.who_global_data VALUES (3994, 59, 3762, 0, 63, 17, 147);
INSERT INTO public.who_global_data VALUES (3995, 34619, 2462879, 324, 55657, 17, 208);
INSERT INTO public.who_global_data VALUES (3996, 669, 54419, 3, 273, 17, 45);
INSERT INTO public.who_global_data VALUES (3997, 72, 28522, 1, 1722, 17, 110);
INSERT INTO public.who_global_data VALUES (3998, 97, 7624, 4, 145, 17, 88);
INSERT INTO public.who_global_data VALUES (3999, 2118, 533224, 72, 11412, 17, 51);
INSERT INTO public.who_global_data VALUES (4000, 2330, 503196, 60, 8322, 17, 209);
INSERT INTO public.who_global_data VALUES (4001, 92, 13224, 9, 850, 17, 205);
INSERT INTO public.who_global_data VALUES (4002, 0, 13714, 0, 91, 17, 18);
INSERT INTO public.who_global_data VALUES (4003, 59, 12653, 1, 71, 17, 72);
INSERT INTO public.who_global_data VALUES (4004, 33355, 3466853, 1610, 91470, 17, 44);
INSERT INTO public.who_global_data VALUES (4005, 0, 52, 0, 0, 17, 15);
INSERT INTO public.who_global_data VALUES (4006, 59, 4383, 0, 74, 17, 25);
INSERT INTO public.who_global_data VALUES (4007, 0, 0, 0, 0, 17, 179);
INSERT INTO public.who_global_data VALUES (4008, 0, 0, 0, 0, 17, 34);
INSERT INTO public.who_global_data VALUES (4009, 6, 7399, 0, 132, 17, 207);
INSERT INTO public.who_global_data VALUES (4010, 2598, 184483, 94, 5844, 17, 166);
INSERT INTO public.who_global_data VALUES (4011, 6818, 2399781, 167, 24328, 17, 126);
INSERT INTO public.who_global_data VALUES (4012, 0, 0, 0, 0, 17, 97);
INSERT INTO public.who_global_data VALUES (4013, 3, 1105, 1, 7, 17, 36);
INSERT INTO public.who_global_data VALUES (4014, 0, 0, 0, 0, 17, 125);
INSERT INTO public.who_global_data VALUES (4015, 449, 38534, 1, 305, 17, 124);
INSERT INTO public.who_global_data VALUES (4016, 4383, 1172038, 212, 21258, 17, 185);
INSERT INTO public.who_global_data VALUES (4017, 3491, 260223, 5, 756, 17, 194);
INSERT INTO public.who_global_data VALUES (4018, 0, 509, 0, 21, 17, 144);
INSERT INTO public.who_global_data VALUES (4019, 142240, 23884299, 1567, 396155, 17, 19);
INSERT INTO public.who_global_data VALUES (4020, 0, 2260, 0, 24, 17, 217);
INSERT INTO public.who_global_data VALUES (4021, 485, 32863, 8, 319, 17, 148);
INSERT INTO public.who_global_data VALUES (4022, 72, 78163, 0, 620, 17, 86);
INSERT INTO public.who_global_data VALUES (4023, 0, 1, 0, 0, 17, 13);
INSERT INTO public.who_global_data VALUES (4024, 641, 120444, 6, 1112, 17, 157);
INSERT INTO public.who_global_data VALUES (4025, 1, 1540, 0, 35, 17, 8);
INSERT INTO public.who_global_data VALUES (4026, 0, 4, 0, 0, 17, 73);
INSERT INTO public.who_global_data VALUES (4027, 2, 2119, 0, 613, 17, 101);
INSERT INTO public.who_global_data VALUES (4028, 1308, 39515, 19, 578, 17, 165);
INSERT INTO public.who_global_data VALUES (4029, 783, 28675, 52, 825, 17, 14);
INSERT INTO public.who_global_data VALUES (4030, 79, 54141, 3, 2346, 18, 193);
INSERT INTO public.who_global_data VALUES (4031, 292, 67982, 4, 1281, 18, 113);
INSERT INTO public.who_global_data VALUES (4032, 259, 104092, 4, 2845, 18, 143);
INSERT INTO public.who_global_data VALUES (4033, 0, 0, 0, 0, 18, 219);
INSERT INTO public.who_global_data VALUES (4034, 45, 9083, 0, 91, 18, 186);
INSERT INTO public.who_global_data VALUES (4035, 51, 18926, 3, 439, 18, 52);
INSERT INTO public.who_global_data VALUES (4036, 0, 15, 0, 0, 18, 180);
INSERT INTO public.who_global_data VALUES (4037, 2, 189, 0, 6, 18, 167);
INSERT INTO public.who_global_data VALUES (4038, 7264, 1799243, 112, 45407, 18, 154);
INSERT INTO public.who_global_data VALUES (4039, 236, 164912, 9, 3007, 18, 94);
INSERT INTO public.who_global_data VALUES (4040, 139, 6435, 0, 52, 18, 66);
INSERT INTO public.who_global_data VALUES (4041, 13, 28721, 0, 909, 18, 58);
INSERT INTO public.who_global_data VALUES (4042, 868, 391981, 55, 7069, 18, 163);
INSERT INTO public.who_global_data VALUES (4043, 118, 227391, 13, 3022, 18, 37);
INSERT INTO public.who_global_data VALUES (4044, 35, 8067, 0, 175, 18, 142);
INSERT INTO public.who_global_data VALUES (4045, 333, 97940, 0, 360, 18, 83);
INSERT INTO public.who_global_data VALUES (4046, 697, 528329, 16, 7922, 18, 228);
INSERT INTO public.who_global_data VALUES (4047, 0, 1095, 0, 7, 18, 188);
INSERT INTO public.who_global_data VALUES (4048, 1899, 227360, 9, 1591, 18, 62);
INSERT INTO public.who_global_data VALUES (4049, 3041, 683301, 57, 20533, 18, 160);
INSERT INTO public.who_global_data VALUES (4050, 51, 11580, 0, 281, 18, 50);
INSERT INTO public.who_global_data VALUES (4051, 0, 3413, 0, 46, 18, 33);
INSERT INTO public.who_global_data VALUES (4052, 0, 670, 0, 12, 18, 183);
INSERT INTO public.who_global_data VALUES (4053, 1, 843, 0, 1, 18, 92);
INSERT INTO public.who_global_data VALUES (4054, 1503, 187183, 40, 9636, 18, 158);
INSERT INTO public.who_global_data VALUES (4055, 11, 340, 0, 3, 18, 67);
INSERT INTO public.who_global_data VALUES (4056, 110, 118083, 14, 4486, 18, 57);
INSERT INTO public.who_global_data VALUES (4057, 1982, 18630, 17, 88, 18, 38);
INSERT INTO public.who_global_data VALUES (4058, 33040, 8488099, 551, 209847, 18, 141);
INSERT INTO public.who_global_data VALUES (4059, 0, 121, 0, 1, 18, 178);
INSERT INTO public.who_global_data VALUES (4060, 0, 174, 0, 3, 18, 108);
INSERT INTO public.who_global_data VALUES (4061, 570, 212383, 82, 8565, 18, 39);
INSERT INTO public.who_global_data VALUES (4062, 164, 9352, 3, 105, 18, 2);
INSERT INTO public.who_global_data VALUES (4063, 8, 1253, 0, 2, 18, 195);
INSERT INTO public.who_global_data VALUES (4064, 53, 13046, 1, 120, 18, 107);
INSERT INTO public.who_global_data VALUES (4065, 2, 441, 0, 0, 18, 161);
INSERT INTO public.who_global_data VALUES (4066, 0, 28010, 0, 455, 18, 212);
INSERT INTO public.who_global_data VALUES (4067, 6436, 708619, 149, 18014, 18, 181);
INSERT INTO public.who_global_data VALUES (4068, 0, 374, 0, 2, 18, 53);
INSERT INTO public.who_global_data VALUES (4069, 0, 4973, 0, 63, 18, 164);
INSERT INTO public.who_global_data VALUES (4070, 24, 2919, 2, 113, 18, 140);
INSERT INTO public.who_global_data VALUES (4071, 3918, 673750, 70, 17547, 18, 20);
INSERT INTO public.who_global_data VALUES (4072, 232, 99026, 1, 4805, 18, 112);
INSERT INTO public.who_global_data VALUES (4073, 17379, 1908413, 375, 48631, 18, 111);
INSERT INTO public.who_global_data VALUES (4074, 177, 1769, 4, 49, 18, 71);
INSERT INTO public.who_global_data VALUES (4075, 0, 7709, 0, 114, 18, 218);
INSERT INTO public.who_global_data VALUES (4076, 0, 0, 0, 0, 18, 43);
INSERT INTO public.who_global_data VALUES (4077, 508, 185653, 6, 2449, 18, 49);
INSERT INTO public.who_global_data VALUES (4078, 64, 25305, 1, 142, 18, 1);
INSERT INTO public.who_global_data VALUES (4079, 520, 225648, 29, 4684, 18, 48);
INSERT INTO public.who_global_data VALUES (4080, 942, 18443, 7, 173, 18, 232);
INSERT INTO public.who_global_data VALUES (4081, 22, 4520, 0, 19, 18, 175);
INSERT INTO public.who_global_data VALUES (4082, 162, 29130, 5, 175, 18, 21);
INSERT INTO public.who_global_data VALUES (4083, 7651, 899503, 197, 14646, 18, 156);
INSERT INTO public.who_global_data VALUES (4084, 0, 0, 0, 0, 18, 95);
INSERT INTO public.who_global_data VALUES (4085, 215, 20907, 0, 630, 18, 177);
INSERT INTO public.who_global_data VALUES (4086, 807, 189895, 30, 1805, 18, 210);
INSERT INTO public.who_global_data VALUES (4087, 1, 5906, 0, 61, 18, 120);
INSERT INTO public.who_global_data VALUES (4088, 0, 110, 0, 0, 18, 135);
INSERT INTO public.who_global_data VALUES (4089, 1848, 194966, 11, 2448, 18, 206);
INSERT INTO public.who_global_data VALUES (4090, 162, 231644, 3, 14322, 18, 189);
INSERT INTO public.who_global_data VALUES (4091, 878, 157275, 55, 8638, 18, 129);
INSERT INTO public.who_global_data VALUES (4092, 653, 51437, 11, 1498, 18, 121);
INSERT INTO public.who_global_data VALUES (4093, 9, 5365, 0, 86, 18, 59);
INSERT INTO public.who_global_data VALUES (4094, 0, 1877, 0, 6, 18, 96);
INSERT INTO public.who_global_data VALUES (4095, 597, 37941, 11, 344, 18, 41);
INSERT INTO public.who_global_data VALUES (4096, 243, 13187, 8, 384, 18, 216);
INSERT INTO public.who_global_data VALUES (4097, 351, 131546, 3, 2033, 18, 236);
INSERT INTO public.who_global_data VALUES (4098, 0, 32, 0, 0, 18, 150);
INSERT INTO public.who_global_data VALUES (4099, 0, 649, 0, 1, 18, 61);
INSERT INTO public.who_global_data VALUES (4100, 0, 55, 0, 2, 18, 7);
INSERT INTO public.who_global_data VALUES (4101, 168, 40505, 3, 621, 18, 169);
INSERT INTO public.who_global_data VALUES (4102, 3052, 2866665, 401, 70295, 18, 28);
INSERT INTO public.who_global_data VALUES (4103, 80, 15055, 1, 76, 18, 85);
INSERT INTO public.who_global_data VALUES (4104, 62, 17697, 1, 127, 18, 211);
INSERT INTO public.who_global_data VALUES (4105, 120, 10019, 0, 66, 18, 60);
INSERT INTO public.who_global_data VALUES (4106, 23, 3933, 1, 128, 18, 3);
INSERT INTO public.who_global_data VALUES (4107, 1550, 249465, 15, 2973, 18, 11);
INSERT INTO public.who_global_data VALUES (4108, 11369, 2052028, 989, 47622, 18, 89);
INSERT INTO public.who_global_data VALUES (4109, 351, 58065, 6, 352, 18, 24);
INSERT INTO public.who_global_data VALUES (4110, 33, 3670, 9, 43, 18, 162);
INSERT INTO public.who_global_data VALUES (4111, 318, 148925, 19, 5488, 18, 100);
INSERT INTO public.who_global_data VALUES (4112, 0, 30, 0, 0, 18, 47);
INSERT INTO public.who_global_data VALUES (4113, 0, 139, 0, 1, 18, 29);
INSERT INTO public.who_global_data VALUES (4114, 114, 8948, 0, 156, 18, 40);
INSERT INTO public.who_global_data VALUES (4115, 1, 7287, 1, 128, 18, 222);
INSERT INTO public.who_global_data VALUES (4116, 258, 149146, 24, 5278, 18, 132);
INSERT INTO public.who_global_data VALUES (4117, 0, 309, 0, 13, 18, 130);
INSERT INTO public.who_global_data VALUES (4118, 51, 14165, 0, 81, 18, 234);
INSERT INTO public.who_global_data VALUES (4119, 0, 2478, 0, 45, 18, 23);
INSERT INTO public.who_global_data VALUES (4120, 57, 6908, 0, 170, 18, 192);
INSERT INTO public.who_global_data VALUES (4121, 71, 10852, 0, 240, 18, 69);
INSERT INTO public.who_global_data VALUES (4122, 0, 26, 0, 0, 18, 187);
INSERT INTO public.who_global_data VALUES (4123, 604, 134111, 6, 3354, 18, 230);
INSERT INTO public.who_global_data VALUES (4124, 573, 353276, 111, 11520, 18, 77);
INSERT INTO public.who_global_data VALUES (4125, 14, 5970, 0, 29, 18, 9);
INSERT INTO public.who_global_data VALUES (4126, 10064, 10581837, 137, 152556, 18, 74);
INSERT INTO public.who_global_data VALUES (4127, 9086, 917015, 295, 26282, 18, 224);
INSERT INTO public.who_global_data VALUES (4128, 5806, 1336217, 83, 56886, 18, 199);
INSERT INTO public.who_global_data VALUES (4129, 797, 609029, 9, 12953, 18, 190);
INSERT INTO public.who_global_data VALUES (4130, 2117, 174843, 8, 2616, 18, 12);
INSERT INTO public.who_global_data VALUES (4131, 9, 428, 0, 25, 18, 104);
INSERT INTO public.who_global_data VALUES (4132, 5649, 550498, 58, 4072, 18, 153);
INSERT INTO public.who_global_data VALUES (4133, 8825, 2390102, 377, 82554, 18, 91);
INSERT INTO public.who_global_data VALUES (4134, 113, 14274, 2, 326, 18, 215);
INSERT INTO public.who_global_data VALUES (4135, 6034, 334328, 47, 4548, 18, 84);
INSERT INTO public.who_global_data VALUES (4136, 7, 3054, 0, 62, 18, 231);
INSERT INTO public.who_global_data VALUES (4137, 1030, 315544, 8, 4153, 18, 196);
INSERT INTO public.who_global_data VALUES (4138, 1252, 218216, 0, 2956, 18, 105);
INSERT INTO public.who_global_data VALUES (4139, 65, 99227, 3, 1734, 18, 122);
INSERT INTO public.who_global_data VALUES (4140, 0, 0, 0, 0, 18, 159);
INSERT INTO public.who_global_data VALUES (4141, 267, 56075, 1, 1401, 18, 75);
INSERT INTO public.who_global_data VALUES (4142, 467, 158244, 1, 948, 18, 27);
INSERT INTO public.who_global_data VALUES (4143, 90, 83268, 3, 1390, 18, 54);
INSERT INTO public.who_global_data VALUES (4144, 0, 41, 0, 0, 18, 226);
INSERT INTO public.who_global_data VALUES (4145, 244, 55908, 5, 983, 18, 79);
INSERT INTO public.who_global_data VALUES (4146, 3144, 255956, 53, 1959, 18, 56);
INSERT INTO public.who_global_data VALUES (4147, 0, 6371, 0, 93, 18, 117);
INSERT INTO public.who_global_data VALUES (4148, 9, 1896, 0, 84, 18, 152);
INSERT INTO public.who_global_data VALUES (4149, 781, 109869, 33, 1698, 18, 16);
INSERT INTO public.who_global_data VALUES (4150, 10, 2468, 0, 45, 18, 10);
INSERT INTO public.who_global_data VALUES (4151, 716, 168708, 25, 2494, 18, 201);
INSERT INTO public.who_global_data VALUES (4152, 37, 48881, 5, 557, 18, 174);
INSERT INTO public.who_global_data VALUES (4153, 0, 18301, 0, 273, 18, 119);
INSERT INTO public.who_global_data VALUES (4154, 557, 13027, 7, 321, 18, 168);
INSERT INTO public.who_global_data VALUES (4155, 3306, 161740, 4, 605, 18, 99);
INSERT INTO public.who_global_data VALUES (4156, 69, 14582, 0, 49, 18, 171);
INSERT INTO public.who_global_data VALUES (4157, 16, 7855, 1, 311, 18, 87);
INSERT INTO public.who_global_data VALUES (4158, 200, 15942, 1, 242, 18, 123);
INSERT INTO public.who_global_data VALUES (4159, 0, 4, 0, 0, 18, 151);
INSERT INTO public.who_global_data VALUES (4160, 75, 6302, 1, 44, 18, 213);
INSERT INTO public.who_global_data VALUES (4161, 0, 16039, 0, 402, 18, 118);
INSERT INTO public.who_global_data VALUES (4162, 0, 547, 0, 10, 18, 134);
INSERT INTO public.who_global_data VALUES (4163, 178, 6789, 0, 58, 18, 65);
INSERT INTO public.who_global_data VALUES (4164, 11170, 1641428, 463, 140704, 18, 102);
INSERT INTO public.who_global_data VALUES (4165, 0, 0, 0, 0, 18, 223);
INSERT INTO public.who_global_data VALUES (4166, 7, 1215, 0, 8, 18, 4);
INSERT INTO public.who_global_data VALUES (4167, 9, 1526, 0, 1, 18, 146);
INSERT INTO public.who_global_data VALUES (4168, 351, 56527, 3, 749, 18, 31);
INSERT INTO public.who_global_data VALUES (4169, 0, 13, 0, 1, 18, 127);
INSERT INTO public.who_global_data VALUES (4170, 473, 460144, 35, 7977, 18, 22);
INSERT INTO public.who_global_data VALUES (4171, 895, 27446, 8, 249, 18, 115);
INSERT INTO public.who_global_data VALUES (4172, 477, 134795, 18, 2973, 18, 106);
INSERT INTO public.who_global_data VALUES (4173, 390, 30753, 8, 293, 18, 90);
INSERT INTO public.who_global_data VALUES (4174, 0, 0, 0, 0, 18, 70);
INSERT INTO public.who_global_data VALUES (4175, 322, 267644, 6, 1965, 18, 46);
INSERT INTO public.who_global_data VALUES (4176, 4796, 916698, 59, 13040, 18, 139);
INSERT INTO public.who_global_data VALUES (4177, 0, 44, 0, 0, 18, 42);
INSERT INTO public.who_global_data VALUES (4178, 0, 1905, 0, 25, 18, 80);
INSERT INTO public.who_global_data VALUES (4179, 0, 4916, 0, 167, 18, 203);
INSERT INTO public.who_global_data VALUES (4180, 48, 4204, 5, 145, 18, 136);
INSERT INTO public.who_global_data VALUES (4181, 1617, 112004, 14, 1449, 18, 63);
INSERT INTO public.who_global_data VALUES (4182, 0, 0, 0, 0, 18, 17);
INSERT INTO public.who_global_data VALUES (4183, 0, 129, 0, 2, 18, 172);
INSERT INTO public.who_global_data VALUES (4184, 54, 88992, 13, 2715, 18, 109);
INSERT INTO public.who_global_data VALUES (4185, 206, 58651, 4, 521, 18, 200);
INSERT INTO public.who_global_data VALUES (4186, 524, 171739, 8, 1889, 18, 93);
INSERT INTO public.who_global_data VALUES (4187, 221, 132011, 2, 1514, 18, 5);
INSERT INTO public.who_global_data VALUES (4188, 0, 745, 0, 13, 18, 214);
INSERT INTO public.who_global_data VALUES (4189, 1920, 521211, 46, 10997, 18, 204);
INSERT INTO public.who_global_data VALUES (4190, 0, 0, 0, 0, 18, 198);
INSERT INTO public.who_global_data VALUES (4191, 1750, 298019, 49, 4787, 18, 173);
INSERT INTO public.who_global_data VALUES (4192, 0, 834, 0, 9, 18, 229);
INSERT INTO public.who_global_data VALUES (4193, 512, 122160, 10, 2505, 18, 76);
INSERT INTO public.who_global_data VALUES (4194, 4342, 1064909, 101, 38871, 18, 138);
INSERT INTO public.who_global_data VALUES (4195, 2159, 502736, 14, 9909, 18, 98);
INSERT INTO public.who_global_data VALUES (4196, 0, 0, 0, 0, 18, 103);
INSERT INTO public.who_global_data VALUES (4197, 4890, 1443804, 291, 33698, 18, 225);
INSERT INTO public.who_global_data VALUES (4198, 6702, 556503, 167, 9028, 18, 131);
INSERT INTO public.who_global_data VALUES (4199, 567, 87939, 0, 1703, 18, 235);
INSERT INTO public.who_global_data VALUES (4200, 227, 147504, 2, 248, 18, 137);
INSERT INTO public.who_global_data VALUES (4201, 386, 73108, 19, 1283, 18, 81);
INSERT INTO public.who_global_data VALUES (4202, 258, 153112, 17, 3267, 18, 182);
INSERT INTO public.who_global_data VALUES (4203, 109, 9552, 0, 45, 18, 145);
INSERT INTO public.who_global_data VALUES (4204, 1509, 695153, 50, 17271, 18, 26);
INSERT INTO public.who_global_data VALUES (4205, 21734, 3612800, 586, 66623, 18, 170);
INSERT INTO public.who_global_data VALUES (4206, 227, 11259, 4, 146, 18, 191);
INSERT INTO public.who_global_data VALUES (4207, 0, 5, 0, 0, 18, 221);
INSERT INTO public.who_global_data VALUES (4208, 57, 281, 0, 0, 18, 64);
INSERT INTO public.who_global_data VALUES (4209, 0, 0, 0, 0, 18, 116);
INSERT INTO public.who_global_data VALUES (4210, 1, 35, 0, 0, 18, 128);
INSERT INTO public.who_global_data VALUES (4211, 10, 621, 0, 8, 18, 6);
INSERT INTO public.who_global_data VALUES (4212, 71, 1117, 0, 12, 18, 227);
INSERT INTO public.who_global_data VALUES (4213, 0, 16, 0, 0, 18, 68);
INSERT INTO public.who_global_data VALUES (4214, 16, 494, 1, 2, 18, 184);
INSERT INTO public.who_global_data VALUES (4215, 0, 2, 0, 0, 18, 82);
INSERT INTO public.who_global_data VALUES (4216, 9, 2787, 0, 65, 18, 149);
INSERT INTO public.who_global_data VALUES (4217, 0, 1142, 0, 17, 18, 197);
INSERT INTO public.who_global_data VALUES (4218, 170, 365099, 6, 6329, 18, 78);
INSERT INTO public.who_global_data VALUES (4219, 196, 23224, 11, 526, 18, 233);
INSERT INTO public.who_global_data VALUES (4220, 1578, 374111, 21, 3771, 18, 133);
INSERT INTO public.who_global_data VALUES (4221, 58, 746, 0, 2, 18, 35);
INSERT INTO public.who_global_data VALUES (4222, 8, 3014, 0, 77, 18, 114);
INSERT INTO public.who_global_data VALUES (4223, 14, 59127, 0, 29, 18, 237);
INSERT INTO public.who_global_data VALUES (4224, 1, 20, 0, 0, 18, 55);
INSERT INTO public.who_global_data VALUES (4225, 27, 1656, 0, 27, 18, 176);
INSERT INTO public.who_global_data VALUES (4226, 1909, 226294, 111, 3637, 18, 202);
INSERT INTO public.who_global_data VALUES (4227, 1702, 151196, 27, 3526, 18, 155);
INSERT INTO public.who_global_data VALUES (4228, 0, 17, 0, 0, 18, 32);
INSERT INTO public.who_global_data VALUES (4229, 0, 4744, 0, 130, 18, 220);
INSERT INTO public.who_global_data VALUES (4230, 9010, 1346936, 344, 37449, 18, 30);
INSERT INTO public.who_global_data VALUES (4231, 0, 3703, 0, 63, 18, 147);
INSERT INTO public.who_global_data VALUES (4232, 18249, 2428260, 274, 55333, 18, 208);
INSERT INTO public.who_global_data VALUES (4233, 688, 53750, 6, 270, 18, 45);
INSERT INTO public.who_global_data VALUES (4234, 133, 28450, 4, 1721, 18, 110);
INSERT INTO public.who_global_data VALUES (4235, 58, 7527, 0, 141, 18, 88);
INSERT INTO public.who_global_data VALUES (4236, 1250, 531106, 58, 11340, 18, 51);
INSERT INTO public.who_global_data VALUES (4237, 2945, 500866, 36, 8262, 18, 209);
INSERT INTO public.who_global_data VALUES (4238, 96, 13132, 9, 841, 18, 205);
INSERT INTO public.who_global_data VALUES (4239, 0, 13714, 0, 91, 18, 18);
INSERT INTO public.who_global_data VALUES (4240, 171, 12594, 0, 70, 18, 72);
INSERT INTO public.who_global_data VALUES (4241, 37535, 3433498, 599, 89860, 18, 44);
INSERT INTO public.who_global_data VALUES (4242, 0, 52, 0, 0, 18, 15);
INSERT INTO public.who_global_data VALUES (4243, 22, 4324, 1, 74, 18, 25);
INSERT INTO public.who_global_data VALUES (4244, 0, 0, 0, 0, 18, 179);
INSERT INTO public.who_global_data VALUES (4245, 0, 0, 0, 0, 18, 34);
INSERT INTO public.who_global_data VALUES (4246, 23, 7393, 1, 132, 18, 207);
INSERT INTO public.who_global_data VALUES (4247, 1795, 181885, 58, 5750, 18, 166);
INSERT INTO public.who_global_data VALUES (4248, 5862, 2392963, 164, 24161, 18, 126);
INSERT INTO public.who_global_data VALUES (4249, 0, 0, 0, 0, 18, 97);
INSERT INTO public.who_global_data VALUES (4250, 0, 1102, 0, 6, 18, 36);
INSERT INTO public.who_global_data VALUES (4251, 0, 0, 0, 0, 18, 125);
INSERT INTO public.who_global_data VALUES (4252, 0, 38085, 0, 304, 18, 124);
INSERT INTO public.who_global_data VALUES (4253, 3939, 1167655, 177, 21046, 18, 185);
INSERT INTO public.who_global_data VALUES (4254, 3471, 256732, 6, 751, 18, 194);
INSERT INTO public.who_global_data VALUES (4255, 0, 509, 0, 21, 18, 144);
INSERT INTO public.who_global_data VALUES (4256, 185383, 23742059, 1947, 394588, 18, 19);
INSERT INTO public.who_global_data VALUES (4257, 0, 2260, 0, 24, 18, 217);
INSERT INTO public.who_global_data VALUES (4258, 709, 32378, 13, 311, 18, 148);
INSERT INTO public.who_global_data VALUES (4259, 55, 78091, 1, 620, 18, 86);
INSERT INTO public.who_global_data VALUES (4260, 0, 1, 0, 0, 18, 13);
INSERT INTO public.who_global_data VALUES (4261, 497, 119803, 5, 1106, 18, 157);
INSERT INTO public.who_global_data VALUES (4262, 2, 1539, 0, 35, 18, 8);
INSERT INTO public.who_global_data VALUES (4263, 0, 4, 0, 0, 18, 73);
INSERT INTO public.who_global_data VALUES (4264, 1, 2117, 0, 613, 18, 101);
INSERT INTO public.who_global_data VALUES (4265, 602, 38207, 13, 559, 18, 165);
INSERT INTO public.who_global_data VALUES (4266, 689, 27892, 60, 773, 18, 14);
INSERT INTO public.who_global_data VALUES (4267, 78, 54062, 4, 2343, 19, 193);
INSERT INTO public.who_global_data VALUES (4268, 474, 67690, 7, 1277, 19, 113);
INSERT INTO public.who_global_data VALUES (4269, 222, 103833, 10, 2841, 19, 143);
INSERT INTO public.who_global_data VALUES (4270, 0, 0, 0, 0, 19, 219);
INSERT INTO public.who_global_data VALUES (4271, 0, 9038, 0, 91, 19, 186);
INSERT INTO public.who_global_data VALUES (4272, 110, 18875, 5, 436, 19, 52);
INSERT INTO public.who_global_data VALUES (4273, 0, 15, 0, 0, 19, 180);
INSERT INTO public.who_global_data VALUES (4274, 0, 187, 0, 6, 19, 167);
INSERT INTO public.who_global_data VALUES (4275, 8932, 1791979, 68, 45295, 19, 154);
INSERT INTO public.who_global_data VALUES (4276, 90, 164676, 6, 2998, 19, 94);
INSERT INTO public.who_global_data VALUES (4277, 0, 6296, 0, 52, 19, 66);
INSERT INTO public.who_global_data VALUES (4278, 19, 28708, 0, 909, 19, 58);
INSERT INTO public.who_global_data VALUES (4279, 1361, 391113, 50, 7014, 19, 163);
INSERT INTO public.who_global_data VALUES (4280, 322, 227273, 11, 3009, 19, 37);
INSERT INTO public.who_global_data VALUES (4281, 0, 8032, 0, 175, 19, 142);
INSERT INTO public.who_global_data VALUES (4282, 339, 97607, 2, 360, 19, 83);
INSERT INTO public.who_global_data VALUES (4283, 569, 527632, 23, 7906, 19, 228);
INSERT INTO public.who_global_data VALUES (4284, 59, 1095, 0, 7, 19, 188);
INSERT INTO public.who_global_data VALUES (4285, 1924, 225461, 9, 1582, 19, 62);
INSERT INTO public.who_global_data VALUES (4286, 721, 680260, 44, 20476, 19, 160);
INSERT INTO public.who_global_data VALUES (4287, 0, 11529, 0, 281, 19, 50);
INSERT INTO public.who_global_data VALUES (4288, 0, 3413, 0, 46, 19, 33);
INSERT INTO public.who_global_data VALUES (4289, 0, 670, 0, 12, 19, 183);
INSERT INTO public.who_global_data VALUES (4290, 0, 842, 0, 1, 19, 92);
INSERT INTO public.who_global_data VALUES (4291, 2091, 185680, 25, 9596, 19, 158);
INSERT INTO public.who_global_data VALUES (4292, 0, 329, 0, 3, 19, 67);
INSERT INTO public.who_global_data VALUES (4293, 180, 117973, 23, 4472, 19, 57);
INSERT INTO public.who_global_data VALUES (4294, 597, 16648, 23, 71, 19, 38);
INSERT INTO public.who_global_data VALUES (4295, 61567, 8455059, 1050, 209296, 19, 141);
INSERT INTO public.who_global_data VALUES (4296, 0, 121, 0, 1, 19, 178);
INSERT INTO public.who_global_data VALUES (4297, 0, 174, 0, 3, 19, 108);
INSERT INTO public.who_global_data VALUES (4298, 77, 211813, 9, 8483, 19, 39);
INSERT INTO public.who_global_data VALUES (4299, 188, 9188, 1, 102, 19, 2);
INSERT INTO public.who_global_data VALUES (4300, 9, 1245, 0, 2, 19, 195);
INSERT INTO public.who_global_data VALUES (4301, 92, 12993, 0, 119, 19, 107);
INSERT INTO public.who_global_data VALUES (4302, 0, 439, 0, 0, 19, 161);
INSERT INTO public.who_global_data VALUES (4303, 674, 28010, 4, 455, 19, 212);
INSERT INTO public.who_global_data VALUES (4304, 6476, 702183, 136, 17865, 19, 181);
INSERT INTO public.who_global_data VALUES (4305, 0, 374, 0, 2, 19, 53);
INSERT INTO public.who_global_data VALUES (4306, 0, 4973, 0, 63, 19, 164);
INSERT INTO public.who_global_data VALUES (4307, 40, 2895, 0, 111, 19, 140);
INSERT INTO public.who_global_data VALUES (4308, 4339, 669832, 42, 17477, 19, 20);
INSERT INTO public.who_global_data VALUES (4309, 169, 98794, 0, 4804, 19, 112);
INSERT INTO public.who_global_data VALUES (4310, 20855, 1891034, 388, 48256, 19, 111);
INSERT INTO public.who_global_data VALUES (4311, 15, 1592, 4, 45, 19, 71);
INSERT INTO public.who_global_data VALUES (4312, 0, 7709, 0, 114, 19, 218);
INSERT INTO public.who_global_data VALUES (4313, 0, 0, 0, 0, 19, 43);
INSERT INTO public.who_global_data VALUES (4314, 958, 185145, 27, 2443, 19, 49);
INSERT INTO public.who_global_data VALUES (4315, 385, 25241, 0, 141, 19, 1);
INSERT INTO public.who_global_data VALUES (4316, 174, 225128, 39, 4655, 19, 48);
INSERT INTO public.who_global_data VALUES (4317, 0, 17501, 0, 166, 19, 232);
INSERT INTO public.who_global_data VALUES (4318, 0, 4498, 0, 19, 19, 175);
INSERT INTO public.who_global_data VALUES (4319, 157, 28968, 3, 170, 19, 21);
INSERT INTO public.who_global_data VALUES (4320, 2693, 891852, 111, 14449, 19, 156);
INSERT INTO public.who_global_data VALUES (4321, 0, 0, 0, 0, 19, 95);
INSERT INTO public.who_global_data VALUES (4322, 67, 20692, 1, 630, 19, 177);
INSERT INTO public.who_global_data VALUES (4323, 889, 189088, 28, 1775, 19, 210);
INSERT INTO public.who_global_data VALUES (4324, 2, 5905, 0, 61, 19, 120);
INSERT INTO public.who_global_data VALUES (4325, 0, 110, 0, 0, 19, 135);
INSERT INTO public.who_global_data VALUES (4326, 1779, 193118, 5, 2437, 19, 206);
INSERT INTO public.who_global_data VALUES (4327, 674, 231482, 3, 14319, 19, 189);
INSERT INTO public.who_global_data VALUES (4328, 890, 156397, 56, 8583, 19, 129);
INSERT INTO public.who_global_data VALUES (4329, 627, 50784, 8, 1487, 19, 121);
INSERT INTO public.who_global_data VALUES (4330, 0, 5356, 0, 86, 19, 59);
INSERT INTO public.who_global_data VALUES (4331, 0, 1877, 0, 6, 19, 96);
INSERT INTO public.who_global_data VALUES (4332, 265, 37344, 8, 333, 19, 41);
INSERT INTO public.who_global_data VALUES (4333, 208, 12944, 16, 376, 19, 216);
INSERT INTO public.who_global_data VALUES (4334, 423, 131195, 1, 2030, 19, 236);
INSERT INTO public.who_global_data VALUES (4335, 0, 32, 0, 0, 19, 150);
INSERT INTO public.who_global_data VALUES (4336, 0, 649, 0, 1, 19, 61);
INSERT INTO public.who_global_data VALUES (4337, 0, 55, 0, 2, 19, 7);
INSERT INTO public.who_global_data VALUES (4338, 236, 40337, 0, 618, 19, 169);
INSERT INTO public.who_global_data VALUES (4339, 16642, 2863613, 141, 69894, 19, 28);
INSERT INTO public.who_global_data VALUES (4340, 0, 14975, 0, 75, 19, 85);
INSERT INTO public.who_global_data VALUES (4341, 0, 17635, 0, 126, 19, 211);
INSERT INTO public.who_global_data VALUES (4342, 0, 9899, 0, 66, 19, 60);
INSERT INTO public.who_global_data VALUES (4343, 13, 3910, 0, 127, 19, 3);
INSERT INTO public.who_global_data VALUES (4344, 110, 247915, 25, 2958, 19, 11);
INSERT INTO public.who_global_data VALUES (4345, 7141, 2040659, 214, 46633, 19, 89);
INSERT INTO public.who_global_data VALUES (4346, 733, 57714, 5, 346, 19, 24);
INSERT INTO public.who_global_data VALUES (4347, 62, 3637, 4, 34, 19, 162);
INSERT INTO public.who_global_data VALUES (4348, 237, 148607, 28, 5469, 19, 100);
INSERT INTO public.who_global_data VALUES (4349, 0, 30, 0, 0, 19, 47);
INSERT INTO public.who_global_data VALUES (4350, 0, 139, 0, 1, 19, 29);
INSERT INTO public.who_global_data VALUES (4351, 0, 8834, 0, 156, 19, 40);
INSERT INTO public.who_global_data VALUES (4352, 3, 7286, 1, 127, 19, 222);
INSERT INTO public.who_global_data VALUES (4353, 290, 148888, 34, 5254, 19, 132);
INSERT INTO public.who_global_data VALUES (4354, 0, 309, 0, 13, 19, 130);
INSERT INTO public.who_global_data VALUES (4355, 16, 14114, 0, 81, 19, 234);
INSERT INTO public.who_global_data VALUES (4356, 0, 2478, 0, 45, 19, 23);
INSERT INTO public.who_global_data VALUES (4357, 46, 6851, 0, 170, 19, 192);
INSERT INTO public.who_global_data VALUES (4358, 0, 10781, 0, 240, 19, 69);
INSERT INTO public.who_global_data VALUES (4359, 0, 26, 0, 0, 19, 187);
INSERT INTO public.who_global_data VALUES (4360, 1095, 133507, 4, 3348, 19, 230);
INSERT INTO public.who_global_data VALUES (4361, 875, 352703, 68, 11409, 19, 77);
INSERT INTO public.who_global_data VALUES (4362, 0, 5956, 0, 29, 19, 9);
INSERT INTO public.who_global_data VALUES (4363, 13788, 10571773, 145, 152419, 19, 74);
INSERT INTO public.who_global_data VALUES (4364, 11287, 907929, 220, 25987, 19, 224);
INSERT INTO public.who_global_data VALUES (4365, 6016, 1330411, 86, 56803, 19, 199);
INSERT INTO public.who_global_data VALUES (4366, 645, 608232, 9, 12944, 19, 190);
INSERT INTO public.who_global_data VALUES (4367, 2946, 172726, 13, 2608, 19, 12);
INSERT INTO public.who_global_data VALUES (4368, 1, 419, 0, 25, 19, 104);
INSERT INTO public.who_global_data VALUES (4369, 5086, 544849, 51, 4014, 19, 153);
INSERT INTO public.who_global_data VALUES (4370, 12544, 2381277, 377, 82177, 19, 91);
INSERT INTO public.who_global_data VALUES (4371, 65, 14161, 1, 324, 19, 215);
INSERT INTO public.who_global_data VALUES (4372, 5998, 328294, 55, 4501, 19, 84);
INSERT INTO public.who_global_data VALUES (4373, 3, 3047, 0, 62, 19, 231);
INSERT INTO public.who_global_data VALUES (4374, 957, 314514, 8, 4145, 19, 196);
INSERT INTO public.who_global_data VALUES (4375, 1017, 216964, 0, 2956, 19, 105);
INSERT INTO public.who_global_data VALUES (4376, 80, 99162, 3, 1731, 19, 122);
INSERT INTO public.who_global_data VALUES (4377, 0, 0, 0, 0, 19, 159);
INSERT INTO public.who_global_data VALUES (4378, 353, 55808, 5, 1400, 19, 75);
INSERT INTO public.who_global_data VALUES (4379, 378, 157777, 0, 947, 19, 27);
INSERT INTO public.who_global_data VALUES (4380, 69, 83178, 3, 1387, 19, 54);
INSERT INTO public.who_global_data VALUES (4381, 0, 41, 0, 0, 19, 226);
INSERT INTO public.who_global_data VALUES (4382, 567, 55664, 17, 978, 19, 79);
INSERT INTO public.who_global_data VALUES (4383, 3654, 252812, 40, 1906, 19, 56);
INSERT INTO public.who_global_data VALUES (4384, 0, 6371, -4, 93, 19, 117);
INSERT INTO public.who_global_data VALUES (4385, 0, 1887, 0, 84, 19, 152);
INSERT INTO public.who_global_data VALUES (4386, 1071, 109088, 14, 1665, 19, 16);
INSERT INTO public.who_global_data VALUES (4387, 6, 2458, 1, 45, 19, 10);
INSERT INTO public.who_global_data VALUES (4388, 476, 167992, 24, 2469, 19, 201);
INSERT INTO public.who_global_data VALUES (4389, 87, 48844, 0, 552, 19, 174);
INSERT INTO public.who_global_data VALUES (4390, 300, 18301, 6, 273, 19, 119);
INSERT INTO public.who_global_data VALUES (4391, 685, 12470, 14, 314, 19, 168);
INSERT INTO public.who_global_data VALUES (4392, 3339, 158434, 7, 601, 19, 99);
INSERT INTO public.who_global_data VALUES (4393, 51, 14513, 0, 49, 19, 171);
INSERT INTO public.who_global_data VALUES (4394, 16, 7839, 2, 310, 19, 87);
INSERT INTO public.who_global_data VALUES (4395, 154, 15742, 2, 241, 19, 123);
INSERT INTO public.who_global_data VALUES (4396, 0, 4, 0, 0, 19, 151);
INSERT INTO public.who_global_data VALUES (4397, 0, 6227, 0, 43, 19, 213);
INSERT INTO public.who_global_data VALUES (4398, 146, 16039, 6, 402, 19, 118);
INSERT INTO public.who_global_data VALUES (4399, 0, 547, 0, 10, 19, 134);
INSERT INTO public.who_global_data VALUES (4400, 0, 6611, 0, 58, 19, 65);
INSERT INTO public.who_global_data VALUES (4401, 20523, 1630258, 1219, 140241, 19, 102);
INSERT INTO public.who_global_data VALUES (4402, 0, 0, 0, 0, 19, 223);
INSERT INTO public.who_global_data VALUES (4403, 11, 1208, 0, 8, 19, 4);
INSERT INTO public.who_global_data VALUES (4404, 5, 1517, 0, 1, 19, 146);
INSERT INTO public.who_global_data VALUES (4405, 406, 56176, 1, 746, 19, 31);
INSERT INTO public.who_global_data VALUES (4406, 0, 13, 0, 1, 19, 127);
INSERT INTO public.who_global_data VALUES (4407, 806, 459671, 31, 7942, 19, 22);
INSERT INTO public.who_global_data VALUES (4408, 689, 26551, 7, 241, 19, 115);
INSERT INTO public.who_global_data VALUES (4409, 449, 134318, 13, 2955, 19, 106);
INSERT INTO public.who_global_data VALUES (4410, 165, 30363, 5, 285, 19, 90);
INSERT INTO public.who_global_data VALUES (4411, 0, 0, 0, 0, 19, 70);
INSERT INTO public.who_global_data VALUES (4412, 266, 267322, 5, 1959, 19, 46);
INSERT INTO public.who_global_data VALUES (4413, 5589, 911902, 43, 12981, 19, 139);
INSERT INTO public.who_global_data VALUES (4414, 0, 44, 0, 0, 19, 42);
INSERT INTO public.who_global_data VALUES (4415, 5, 1905, 0, 25, 19, 80);
INSERT INTO public.who_global_data VALUES (4416, 0, 4916, 0, 167, 19, 203);
INSERT INTO public.who_global_data VALUES (4417, 24, 4156, 2, 140, 19, 136);
INSERT INTO public.who_global_data VALUES (4418, 1444, 110387, 15, 1435, 19, 63);
INSERT INTO public.who_global_data VALUES (4419, 0, 0, 0, 0, 19, 17);
INSERT INTO public.who_global_data VALUES (4420, 1, 129, 0, 2, 19, 172);
INSERT INTO public.who_global_data VALUES (4421, 189, 88938, 6, 2702, 19, 109);
INSERT INTO public.who_global_data VALUES (4422, 711, 58445, 0, 517, 19, 200);
INSERT INTO public.who_global_data VALUES (4423, 578, 171215, 20, 1881, 19, 93);
INSERT INTO public.who_global_data VALUES (4424, 526, 131790, 3, 1512, 19, 5);
INSERT INTO public.who_global_data VALUES (4425, 0, 745, 0, 13, 19, 214);
INSERT INTO public.who_global_data VALUES (4426, 2521, 519291, 43, 10951, 19, 204);
INSERT INTO public.who_global_data VALUES (4427, 0, 0, 0, 0, 19, 198);
INSERT INTO public.who_global_data VALUES (4428, 2677, 296269, 49, 4738, 19, 173);
INSERT INTO public.who_global_data VALUES (4429, 0, 834, 0, 9, 19, 229);
INSERT INTO public.who_global_data VALUES (4430, 859, 121648, 16, 2495, 19, 76);
INSERT INTO public.who_global_data VALUES (4431, 4544, 1060567, 116, 38770, 19, 138);
INSERT INTO public.who_global_data VALUES (4432, 1886, 500577, 11, 9895, 19, 98);
INSERT INTO public.who_global_data VALUES (4433, 0, 0, 0, 0, 19, 103);
INSERT INTO public.who_global_data VALUES (4434, 3332, 1438914, 52, 33407, 19, 225);
INSERT INTO public.who_global_data VALUES (4435, 10385, 549801, 152, 8861, 19, 131);
INSERT INTO public.who_global_data VALUES (4436, 849, 87372, 0, 1703, 19, 235);
INSERT INTO public.who_global_data VALUES (4437, 188, 147277, 0, 246, 19, 137);
INSERT INTO public.who_global_data VALUES (4438, 389, 72722, 15, 1264, 19, 81);
INSERT INTO public.who_global_data VALUES (4439, 214, 152854, 5, 3250, 19, 182);
INSERT INTO public.who_global_data VALUES (4440, 0, 9443, 0, 45, 19, 145);
INSERT INTO public.who_global_data VALUES (4441, 2156, 693644, 57, 17221, 19, 26);
INSERT INTO public.who_global_data VALUES (4442, 22857, 3591066, 471, 66037, 19, 170);
INSERT INTO public.who_global_data VALUES (4443, 182, 11032, 2, 142, 19, 191);
INSERT INTO public.who_global_data VALUES (4444, 0, 5, 0, 0, 19, 221);
INSERT INTO public.who_global_data VALUES (4445, 0, 224, 0, 0, 19, 64);
INSERT INTO public.who_global_data VALUES (4446, 0, 0, 0, 0, 19, 116);
INSERT INTO public.who_global_data VALUES (4447, 0, 34, 0, 0, 19, 128);
INSERT INTO public.who_global_data VALUES (4448, 35, 611, 2, 8, 19, 6);
INSERT INTO public.who_global_data VALUES (4449, 0, 1046, 0, 12, 19, 227);
INSERT INTO public.who_global_data VALUES (4450, 0, 16, 0, 0, 19, 68);
INSERT INTO public.who_global_data VALUES (4451, 28, 478, 0, 1, 19, 184);
INSERT INTO public.who_global_data VALUES (4452, 0, 2, 0, 0, 19, 82);
INSERT INTO public.who_global_data VALUES (4453, 0, 2778, 0, 65, 19, 149);
INSERT INTO public.who_global_data VALUES (4454, 12, 1142, 0, 17, 19, 197);
INSERT INTO public.who_global_data VALUES (4455, 176, 364929, 5, 6323, 19, 78);
INSERT INTO public.who_global_data VALUES (4456, 290, 23028, 6, 515, 19, 233);
INSERT INTO public.who_global_data VALUES (4457, 1317, 372533, 20, 3750, 19, 133);
INSERT INTO public.who_global_data VALUES (4458, -1, 688, 1, 2, 19, 35);
INSERT INTO public.who_global_data VALUES (4459, 36, 3006, 0, 77, 19, 114);
INSERT INTO public.who_global_data VALUES (4460, 30, 59113, 0, 29, 19, 237);
INSERT INTO public.who_global_data VALUES (4461, 0, 19, 0, 0, 19, 55);
INSERT INTO public.who_global_data VALUES (4462, 0, 1629, 0, 27, 19, 176);
INSERT INTO public.who_global_data VALUES (4463, 1060, 224385, 52, 3526, 19, 202);
INSERT INTO public.who_global_data VALUES (4464, 300, 149494, 27, 3499, 19, 155);
INSERT INTO public.who_global_data VALUES (4465, 0, 17, 0, 0, 19, 32);
INSERT INTO public.who_global_data VALUES (4466, 0, 4744, 0, 130, 19, 220);
INSERT INTO public.who_global_data VALUES (4467, 12267, 1337926, 254, 37105, 19, 30);
INSERT INTO public.who_global_data VALUES (4468, 10, 3703, 0, 63, 19, 147);
INSERT INTO public.who_global_data VALUES (4469, 24336, 2410011, 281, 55059, 19, 208);
INSERT INTO public.who_global_data VALUES (4470, 749, 53062, 8, 264, 19, 45);
INSERT INTO public.who_global_data VALUES (4471, 84, 28317, 10, 1717, 19, 110);
INSERT INTO public.who_global_data VALUES (4472, 60, 7469, 2, 141, 19, 88);
INSERT INTO public.who_global_data VALUES (4473, 2162, 529856, 81, 11282, 19, 51);
INSERT INTO public.who_global_data VALUES (4474, 892, 497921, 31, 8226, 19, 209);
INSERT INTO public.who_global_data VALUES (4475, 94, 13036, 8, 832, 19, 205);
INSERT INTO public.who_global_data VALUES (4476, 0, 13714, 0, 91, 19, 18);
INSERT INTO public.who_global_data VALUES (4477, 369, 12423, 0, 70, 19, 72);
INSERT INTO public.who_global_data VALUES (4478, 38598, 3395963, 671, 89261, 19, 44);
INSERT INTO public.who_global_data VALUES (4479, 0, 52, 0, 0, 19, 15);
INSERT INTO public.who_global_data VALUES (4480, 30, 4302, 0, 73, 19, 25);
INSERT INTO public.who_global_data VALUES (4481, 0, 0, 0, 0, 19, 179);
INSERT INTO public.who_global_data VALUES (4482, 0, 0, 0, 0, 19, 34);
INSERT INTO public.who_global_data VALUES (4483, 27, 7370, 1, 131, 19, 207);
INSERT INTO public.who_global_data VALUES (4484, 2859, 180090, 76, 5692, 19, 166);
INSERT INTO public.who_global_data VALUES (4485, 6436, 2387101, 165, 23997, 19, 126);
INSERT INTO public.who_global_data VALUES (4486, 0, 0, 0, 0, 19, 97);
INSERT INTO public.who_global_data VALUES (4487, 23, 1102, 0, 6, 19, 36);
INSERT INTO public.who_global_data VALUES (4488, 0, 0, 0, 0, 19, 125);
INSERT INTO public.who_global_data VALUES (4489, 0, 38085, 0, 304, 19, 124);
INSERT INTO public.who_global_data VALUES (4490, 3034, 1163716, 67, 20869, 19, 185);
INSERT INTO public.who_global_data VALUES (4491, 3453, 253261, 5, 745, 19, 194);
INSERT INTO public.who_global_data VALUES (4492, 0, 509, 0, 21, 19, 144);
INSERT INTO public.who_global_data VALUES (4493, 212253, 23556676, 3557, 392641, 19, 19);
INSERT INTO public.who_global_data VALUES (4494, 8, 2260, 0, 24, 19, 217);
INSERT INTO public.who_global_data VALUES (4495, 723, 31669, 7, 298, 19, 148);
INSERT INTO public.who_global_data VALUES (4496, 68, 78036, 0, 619, 19, 86);
INSERT INTO public.who_global_data VALUES (4497, 0, 1, 0, 0, 19, 13);
INSERT INTO public.who_global_data VALUES (4498, 450, 119306, 6, 1101, 19, 157);
INSERT INTO public.who_global_data VALUES (4499, 0, 1537, 0, 35, 19, 8);
INSERT INTO public.who_global_data VALUES (4500, 0, 4, 0, 0, 19, 73);
INSERT INTO public.who_global_data VALUES (4501, 0, 2116, 0, 613, 19, 101);
INSERT INTO public.who_global_data VALUES (4502, 1531, 37605, 14, 546, 19, 165);
INSERT INTO public.who_global_data VALUES (4503, 322, 27203, 30, 713, 19, 14);
INSERT INTO public.who_global_data VALUES (4504, 46, 53984, 3, 2339, 20, 193);
INSERT INTO public.who_global_data VALUES (4505, 581, 67216, 5, 1270, 20, 113);
INSERT INTO public.who_global_data VALUES (4506, 751, 103611, 12, 2831, 20, 143);
INSERT INTO public.who_global_data VALUES (4507, 0, 0, 0, 0, 20, 219);
INSERT INTO public.who_global_data VALUES (4508, 92, 9038, 3, 91, 20, 186);
INSERT INTO public.who_global_data VALUES (4509, 152, 18765, 6, 431, 20, 52);
INSERT INTO public.who_global_data VALUES (4510, 0, 15, 0, 0, 20, 180);
INSERT INTO public.who_global_data VALUES (4511, 3, 187, 0, 6, 20, 167);
INSERT INTO public.who_global_data VALUES (4512, 12332, 1783047, 102, 45227, 20, 154);
INSERT INTO public.who_global_data VALUES (4513, 351, 164586, 5, 2992, 20, 94);
INSERT INTO public.who_global_data VALUES (4514, 0, 6296, 0, 52, 20, 66);
INSERT INTO public.who_global_data VALUES (4515, 20, 28689, 0, 909, 20, 58);
INSERT INTO public.who_global_data VALUES (4516, 1757, 389752, 33, 6964, 20, 163);
INSERT INTO public.who_global_data VALUES (4517, 402, 226951, 15, 2998, 20, 37);
INSERT INTO public.who_global_data VALUES (4518, 0, 8032, 0, 175, 20, 142);
INSERT INTO public.who_global_data VALUES (4519, 247, 97268, 1, 358, 20, 83);
INSERT INTO public.who_global_data VALUES (4520, 578, 527063, 21, 7883, 20, 228);
INSERT INTO public.who_global_data VALUES (4521, 0, 1036, 0, 7, 20, 188);
INSERT INTO public.who_global_data VALUES (4522, 1933, 223537, 9, 1573, 20, 62);
INSERT INTO public.who_global_data VALUES (4523, 1175, 679539, 45, 20432, 20, 160);
INSERT INTO public.who_global_data VALUES (4524, 73, 11529, 1, 281, 20, 50);
INSERT INTO public.who_global_data VALUES (4525, 0, 3413, 0, 46, 20, 33);
INSERT INTO public.who_global_data VALUES (4526, 3, 670, 0, 12, 20, 183);
INSERT INTO public.who_global_data VALUES (4527, 5, 842, 0, 1, 20, 92);
INSERT INTO public.who_global_data VALUES (4528, 2573, 183589, 41, 9571, 20, 158);
INSERT INTO public.who_global_data VALUES (4529, 0, 329, 0, 3, 20, 67);
INSERT INTO public.who_global_data VALUES (4530, 462, 117793, 20, 4449, 20, 57);
INSERT INTO public.who_global_data VALUES (4531, 0, 16051, 0, 48, 20, 38);
INSERT INTO public.who_global_data VALUES (4532, 69198, 8393492, 1151, 208246, 20, 141);
INSERT INTO public.who_global_data VALUES (4533, 0, 121, 0, 1, 20, 178);
INSERT INTO public.who_global_data VALUES (4534, 0, 174, 0, 3, 20, 108);
INSERT INTO public.who_global_data VALUES (4535, 233, 211736, 17, 8474, 20, 39);
INSERT INTO public.who_global_data VALUES (4536, 191, 9000, 4, 101, 20, 2);
INSERT INTO public.who_global_data VALUES (4537, 51, 1236, 0, 2, 20, 195);
INSERT INTO public.who_global_data VALUES (4538, 125, 12901, 1, 119, 20, 107);
INSERT INTO public.who_global_data VALUES (4539, 3, 439, 0, 0, 20, 161);
INSERT INTO public.who_global_data VALUES (4540, 0, 27336, 0, 451, 20, 212);
INSERT INTO public.who_global_data VALUES (4541, 6816, 695707, 191, 17729, 20, 181);
INSERT INTO public.who_global_data VALUES (4542, 6, 374, 0, 2, 20, 53);
INSERT INTO public.who_global_data VALUES (4543, 0, 4973, 0, 63, 20, 164);
INSERT INTO public.who_global_data VALUES (4544, 48, 2855, 0, 111, 20, 140);
INSERT INTO public.who_global_data VALUES (4545, 4313, 665493, 66, 17435, 20, 20);
INSERT INTO public.who_global_data VALUES (4546, 166, 98625, 1, 4804, 20, 112);
INSERT INTO public.who_global_data VALUES (4547, 21078, 1870179, 377, 47868, 20, 111);
INSERT INTO public.who_global_data VALUES (4548, 108, 1577, 3, 41, 20, 71);
INSERT INTO public.who_global_data VALUES (4549, 0, 7709, 0, 114, 20, 218);
INSERT INTO public.who_global_data VALUES (4550, 0, 0, 0, 0, 20, 43);
INSERT INTO public.who_global_data VALUES (4551, 945, 184187, 15, 2416, 20, 49);
INSERT INTO public.who_global_data VALUES (4552, 0, 24856, 0, 141, 20, 1);
INSERT INTO public.who_global_data VALUES (4553, 379, 224954, 28, 4616, 20, 48);
INSERT INTO public.who_global_data VALUES (4554, 405, 17501, 4, 166, 20, 232);
INSERT INTO public.who_global_data VALUES (4555, 0, 4498, 0, 19, 20, 175);
INSERT INTO public.who_global_data VALUES (4556, 202, 28811, 1, 167, 20, 21);
INSERT INTO public.who_global_data VALUES (4557, 5253, 889159, 123, 14338, 20, 156);
INSERT INTO public.who_global_data VALUES (4558, 0, 0, 0, 0, 20, 95);
INSERT INTO public.who_global_data VALUES (4559, 0, 20625, 2, 629, 20, 177);
INSERT INTO public.who_global_data VALUES (4560, 879, 188199, 27, 1747, 20, 210);
INSERT INTO public.who_global_data VALUES (4561, 0, 5903, 0, 61, 20, 120);
INSERT INTO public.who_global_data VALUES (4562, 1, 110, 0, 0, 20, 135);
INSERT INTO public.who_global_data VALUES (4563, 2370, 191339, 0, 2432, 20, 206);
INSERT INTO public.who_global_data VALUES (4564, 3942, 230808, 43, 14316, 20, 189);
INSERT INTO public.who_global_data VALUES (4565, 887, 155507, 54, 8527, 20, 129);
INSERT INTO public.who_global_data VALUES (4566, 0, 50157, 10, 1479, 20, 121);
INSERT INTO public.who_global_data VALUES (4567, 40, 5356, 0, 86, 20, 59);
INSERT INTO public.who_global_data VALUES (4568, 72, 1877, 0, 6, 20, 96);
INSERT INTO public.who_global_data VALUES (4569, 388, 37079, 5, 325, 20, 41);
INSERT INTO public.who_global_data VALUES (4570, 409, 12736, 25, 360, 20, 216);
INSERT INTO public.who_global_data VALUES (4571, 446, 130772, 6, 2029, 20, 236);
INSERT INTO public.who_global_data VALUES (4572, 0, 32, 0, 0, 20, 150);
INSERT INTO public.who_global_data VALUES (4573, 1, 649, 0, 1, 20, 61);
INSERT INTO public.who_global_data VALUES (4574, 2, 55, 0, 2, 20, 7);
INSERT INTO public.who_global_data VALUES (4575, 190, 40101, 0, 618, 20, 169);
INSERT INTO public.who_global_data VALUES (4576, 21207, 2846971, 192, 69753, 20, 28);
INSERT INTO public.who_global_data VALUES (4577, 199, 14975, 1, 75, 20, 85);
INSERT INTO public.who_global_data VALUES (4578, 0, 17635, 0, 126, 20, 211);
INSERT INTO public.who_global_data VALUES (4579, 80, 9899, 0, 66, 20, 60);
INSERT INTO public.who_global_data VALUES (4580, 0, 3897, 0, 127, 20, 3);
INSERT INTO public.who_global_data VALUES (4581, 780, 247805, 17, 2933, 20, 11);
INSERT INTO public.who_global_data VALUES (4582, 13882, 2033518, 445, 46419, 20, 89);
INSERT INTO public.who_global_data VALUES (4583, 0, 56981, 0, 341, 20, 24);
INSERT INTO public.who_global_data VALUES (4584, 66, 3575, 5, 30, 20, 162);
INSERT INTO public.who_global_data VALUES (4585, 510, 148370, 20, 5441, 20, 100);
INSERT INTO public.who_global_data VALUES (4586, 0, 30, 0, 0, 20, 47);
INSERT INTO public.who_global_data VALUES (4587, 0, 139, 0, 1, 20, 29);
INSERT INTO public.who_global_data VALUES (4588, 0, 8834, 0, 156, 20, 40);
INSERT INTO public.who_global_data VALUES (4589, 7, 7283, 1, 126, 20, 222);
INSERT INTO public.who_global_data VALUES (4590, 1038, 148598, 43, 5220, 20, 132);
INSERT INTO public.who_global_data VALUES (4591, 1, 309, 0, 13, 20, 130);
INSERT INTO public.who_global_data VALUES (4592, 33, 14098, 0, 81, 20, 234);
INSERT INTO public.who_global_data VALUES (4593, 31, 2478, 0, 45, 20, 23);
INSERT INTO public.who_global_data VALUES (4594, 60, 6805, 0, 170, 20, 192);
INSERT INTO public.who_global_data VALUES (4595, 146, 10781, 2, 240, 20, 69);
INSERT INTO public.who_global_data VALUES (4596, 0, 26, 0, 0, 20, 187);
INSERT INTO public.who_global_data VALUES (4597, 449, 132412, 9, 3344, 20, 230);
INSERT INTO public.who_global_data VALUES (4598, 1241, 351828, 77, 11341, 20, 77);
INSERT INTO public.who_global_data VALUES (4599, 0, 5956, 0, 29, 20, 9);
INSERT INTO public.who_global_data VALUES (4600, 15144, 10557985, 181, 152274, 20, 74);
INSERT INTO public.who_global_data VALUES (4601, 14224, 896642, 283, 25767, 20, 224);
INSERT INTO public.who_global_data VALUES (4602, 6100, 1324395, 96, 56717, 20, 199);
INSERT INTO public.who_global_data VALUES (4603, 596, 607587, 3, 12935, 20, 190);
INSERT INTO public.who_global_data VALUES (4604, 3232, 169780, 59, 2595, 20, 12);
INSERT INTO public.who_global_data VALUES (4605, 1, 418, 0, 25, 20, 104);
INSERT INTO public.who_global_data VALUES (4606, 8427, 539763, 45, 3963, 20, 153);
INSERT INTO public.who_global_data VALUES (4607, 16310, 2368733, 475, 81800, 20, 91);
INSERT INTO public.who_global_data VALUES (4608, 104, 14096, 0, 323, 20, 215);
INSERT INTO public.who_global_data VALUES (4609, 6386, 322296, 66, 4446, 20, 84);
INSERT INTO public.who_global_data VALUES (4610, 15, 3044, 2, 62, 20, 231);
INSERT INTO public.who_global_data VALUES (4611, 706, 313557, 16, 4137, 20, 196);
INSERT INTO public.who_global_data VALUES (4612, 1020, 215947, 71, 2956, 20, 105);
INSERT INTO public.who_global_data VALUES (4613, 223, 99082, 2, 1728, 20, 122);
INSERT INTO public.who_global_data VALUES (4614, 0, 0, 0, 0, 20, 159);
INSERT INTO public.who_global_data VALUES (4615, 363, 55455, 6, 1395, 20, 75);
INSERT INTO public.who_global_data VALUES (4616, 435, 157399, 0, 947, 20, 27);
INSERT INTO public.who_global_data VALUES (4617, 123, 83109, 2, 1384, 20, 54);
INSERT INTO public.who_global_data VALUES (4618, 0, 41, 0, 0, 20, 226);
INSERT INTO public.who_global_data VALUES (4619, 1031, 55097, 41, 961, 20, 79);
INSERT INTO public.who_global_data VALUES (4620, 5872, 249158, 41, 1866, 20, 56);
INSERT INTO public.who_global_data VALUES (4621, 0, 6371, 4, 97, 20, 117);
INSERT INTO public.who_global_data VALUES (4622, 5, 1887, 0, 84, 20, 152);
INSERT INTO public.who_global_data VALUES (4623, 0, 108017, 0, 1651, 20, 16);
INSERT INTO public.who_global_data VALUES (4624, 6, 2452, 0, 44, 20, 10);
INSERT INTO public.who_global_data VALUES (4625, 836, 167516, 31, 2445, 20, 201);
INSERT INTO public.who_global_data VALUES (4626, 135, 48757, 3, 552, 20, 174);
INSERT INTO public.who_global_data VALUES (4627, 0, 18001, 0, 267, 20, 119);
INSERT INTO public.who_global_data VALUES (4628, 1291, 11785, 15, 300, 20, 168);
INSERT INTO public.who_global_data VALUES (4629, 4029, 155095, 8, 594, 20, 99);
INSERT INTO public.who_global_data VALUES (4630, 87, 14462, 0, 49, 20, 171);
INSERT INTO public.who_global_data VALUES (4631, 23, 7823, 0, 308, 20, 87);
INSERT INTO public.who_global_data VALUES (4632, 141, 15588, 1, 239, 20, 123);
INSERT INTO public.who_global_data VALUES (4633, 0, 4, 0, 0, 20, 151);
INSERT INTO public.who_global_data VALUES (4634, 0, 6227, 0, 43, 20, 213);
INSERT INTO public.who_global_data VALUES (4635, 0, 15893, 0, 396, 20, 118);
INSERT INTO public.who_global_data VALUES (4636, 0, 547, 0, 10, 20, 134);
INSERT INTO public.who_global_data VALUES (4637, 0, 6611, 0, 58, 20, 65);
INSERT INTO public.who_global_data VALUES (4638, 21366, 1609735, 1106, 139022, 20, 102);
INSERT INTO public.who_global_data VALUES (4639, 0, 0, 0, 0, 20, 223);
INSERT INTO public.who_global_data VALUES (4640, 25, 1197, 0, 8, 20, 4);
INSERT INTO public.who_global_data VALUES (4641, 21, 1512, 0, 1, 20, 146);
INSERT INTO public.who_global_data VALUES (4642, 286, 55770, 2, 745, 20, 31);
INSERT INTO public.who_global_data VALUES (4643, 0, 13, 0, 1, 20, 127);
INSERT INTO public.who_global_data VALUES (4644, 1240, 458865, 23, 7911, 20, 22);
INSERT INTO public.who_global_data VALUES (4645, 1593, 25862, 23, 234, 20, 115);
INSERT INTO public.who_global_data VALUES (4646, 491, 133869, 16, 2942, 20, 106);
INSERT INTO public.who_global_data VALUES (4647, 628, 30198, 5, 280, 20, 90);
INSERT INTO public.who_global_data VALUES (4648, 0, 0, 0, 0, 20, 70);
INSERT INTO public.who_global_data VALUES (4649, 240, 267056, 6, 1954, 20, 46);
INSERT INTO public.who_global_data VALUES (4650, 5304, 906313, 97, 12938, 20, 139);
INSERT INTO public.who_global_data VALUES (4651, 3, 44, 0, 0, 20, 42);
INSERT INTO public.who_global_data VALUES (4652, 10, 1900, 0, 25, 20, 80);
INSERT INTO public.who_global_data VALUES (4653, 0, 4916, 0, 167, 20, 203);
INSERT INTO public.who_global_data VALUES (4654, 27, 4132, 0, 138, 20, 136);
INSERT INTO public.who_global_data VALUES (4655, 1598, 108943, 7, 1420, 20, 63);
INSERT INTO public.who_global_data VALUES (4656, 0, 0, 0, 0, 20, 17);
INSERT INTO public.who_global_data VALUES (4657, 0, 128, 0, 2, 20, 172);
INSERT INTO public.who_global_data VALUES (4658, 360, 88749, 14, 2696, 20, 109);
INSERT INTO public.who_global_data VALUES (4659, 0, 57734, 0, 517, 20, 200);
INSERT INTO public.who_global_data VALUES (4660, 427, 170637, 13, 1861, 20, 93);
INSERT INTO public.who_global_data VALUES (4661, 0, 131264, 0, 1509, 20, 5);
INSERT INTO public.who_global_data VALUES (4662, 0, 745, 0, 13, 20, 214);
INSERT INTO public.who_global_data VALUES (4663, 2432, 516770, 45, 10908, 20, 204);
INSERT INTO public.who_global_data VALUES (4664, 0, 0, 0, 0, 20, 198);
INSERT INTO public.who_global_data VALUES (4665, 2307, 293592, 38, 4689, 20, 173);
INSERT INTO public.who_global_data VALUES (4666, 0, 834, 0, 9, 20, 229);
INSERT INTO public.who_global_data VALUES (4667, 1149, 120789, 12, 2479, 20, 76);
INSERT INTO public.who_global_data VALUES (4668, 7361, 1056023, 90, 38654, 20, 138);
INSERT INTO public.who_global_data VALUES (4669, 2045, 498691, 8, 9884, 20, 98);
INSERT INTO public.who_global_data VALUES (4670, 0, 0, 0, 0, 20, 103);
INSERT INTO public.who_global_data VALUES (4671, 5970, 1435582, 142, 33355, 20, 225);
INSERT INTO public.who_global_data VALUES (4672, 10947, 539416, 166, 8709, 20, 131);
INSERT INTO public.who_global_data VALUES (4673, 569, 86523, 11, 1703, 20, 235);
INSERT INTO public.who_global_data VALUES (4674, 204, 147089, 0, 246, 20, 137);
INSERT INTO public.who_global_data VALUES (4675, 520, 72333, 13, 1249, 20, 81);
INSERT INTO public.who_global_data VALUES (4676, 377, 152640, 17, 3245, 20, 182);
INSERT INTO public.who_global_data VALUES (4677, 0, 9443, 0, 45, 20, 145);
INSERT INTO public.who_global_data VALUES (4678, 3218, 691488, 66, 17164, 20, 26);
INSERT INTO public.who_global_data VALUES (4679, 23586, 3568209, 481, 65566, 20, 170);
INSERT INTO public.who_global_data VALUES (4680, 277, 10850, 2, 140, 20, 191);
INSERT INTO public.who_global_data VALUES (4681, 0, 5, 0, 0, 20, 221);
INSERT INTO public.who_global_data VALUES (4682, 0, 224, 0, 0, 20, 64);
INSERT INTO public.who_global_data VALUES (4683, 0, 0, 0, 0, 20, 116);
INSERT INTO public.who_global_data VALUES (4684, 0, 34, 0, 0, 20, 128);
INSERT INTO public.who_global_data VALUES (4685, 33, 576, 0, 6, 20, 6);
INSERT INTO public.who_global_data VALUES (4686, 0, 1046, 0, 12, 20, 227);
INSERT INTO public.who_global_data VALUES (4687, 0, 16, 0, 0, 20, 68);
INSERT INTO public.who_global_data VALUES (4688, 62, 450, 1, 1, 20, 184);
INSERT INTO public.who_global_data VALUES (4689, 0, 2, 0, 0, 20, 82);
INSERT INTO public.who_global_data VALUES (4690, 11, 2778, 0, 65, 20, 149);
INSERT INTO public.who_global_data VALUES (4691, 5, 1130, 0, 17, 20, 197);
INSERT INTO public.who_global_data VALUES (4692, 140, 364753, 5, 6318, 20, 78);
INSERT INTO public.who_global_data VALUES (4693, 342, 22738, 3, 509, 20, 233);
INSERT INTO public.who_global_data VALUES (4694, 1393, 371216, 22, 3730, 20, 133);
INSERT INTO public.who_global_data VALUES (4695, 63, 689, 0, 1, 20, 35);
INSERT INTO public.who_global_data VALUES (4696, 11, 2970, 0, 77, 20, 114);
INSERT INTO public.who_global_data VALUES (4697, 24, 59083, 0, 29, 20, 237);
INSERT INTO public.who_global_data VALUES (4698, 0, 19, 0, 0, 20, 55);
INSERT INTO public.who_global_data VALUES (4699, 0, 1629, 0, 27, 20, 176);
INSERT INTO public.who_global_data VALUES (4700, 573, 223325, 57, 3474, 20, 202);
INSERT INTO public.who_global_data VALUES (4701, 573, 149194, 31, 3472, 20, 155);
INSERT INTO public.who_global_data VALUES (4702, 0, 17, 0, 0, 20, 32);
INSERT INTO public.who_global_data VALUES (4703, 0, 4744, 0, 130, 20, 220);
INSERT INTO public.who_global_data VALUES (4704, 13973, 1325659, 384, 36851, 20, 30);
INSERT INTO public.who_global_data VALUES (4705, 0, 3693, 0, 63, 20, 147);
INSERT INTO public.who_global_data VALUES (4706, 42029, 2385675, 306, 54778, 20, 208);
INSERT INTO public.who_global_data VALUES (4707, 719, 52313, 1, 256, 20, 45);
INSERT INTO public.who_global_data VALUES (4708, 54, 28233, 8, 1707, 20, 110);
INSERT INTO public.who_global_data VALUES (4709, 109, 7409, 0, 139, 20, 88);
INSERT INTO public.who_global_data VALUES (4710, 4209, 527694, 85, 11201, 20, 51);
INSERT INTO public.who_global_data VALUES (4711, 1334, 497029, 46, 8195, 20, 209);
INSERT INTO public.who_global_data VALUES (4712, 92, 12942, 7, 824, 20, 205);
INSERT INTO public.who_global_data VALUES (4713, 3, 13714, 0, 91, 20, 18);
INSERT INTO public.who_global_data VALUES (4714, 374, 12054, 0, 70, 20, 72);
INSERT INTO public.who_global_data VALUES (4715, 41342, 3357365, 1295, 88590, 20, 44);
INSERT INTO public.who_global_data VALUES (4716, 0, 52, 0, 0, 20, 15);
INSERT INTO public.who_global_data VALUES (4717, 52, 4272, 0, 73, 20, 25);
INSERT INTO public.who_global_data VALUES (4718, 0, 0, 0, 0, 20, 179);
INSERT INTO public.who_global_data VALUES (4719, 0, 0, 0, 0, 20, 34);
INSERT INTO public.who_global_data VALUES (4720, 23, 7343, 0, 130, 20, 207);
INSERT INTO public.who_global_data VALUES (4721, 2166, 177231, 88, 5616, 20, 166);
INSERT INTO public.who_global_data VALUES (4722, 7550, 2380665, 168, 23832, 20, 126);
INSERT INTO public.who_global_data VALUES (4723, 0, 0, 0, 0, 20, 97);
INSERT INTO public.who_global_data VALUES (4724, 17, 1079, 0, 6, 20, 36);
INSERT INTO public.who_global_data VALUES (4725, 0, 0, 0, 0, 20, 125);
INSERT INTO public.who_global_data VALUES (4726, 0, 38085, 0, 304, 20, 124);
INSERT INTO public.who_global_data VALUES (4727, 5990, 1160682, 116, 20802, 20, 185);
INSERT INTO public.who_global_data VALUES (4728, 3432, 249808, 7, 740, 20, 194);
INSERT INTO public.who_global_data VALUES (4729, 0, 509, 0, 21, 20, 144);
INSERT INTO public.who_global_data VALUES (4730, 246485, 23344423, 3671, 389084, 20, 19);
INSERT INTO public.who_global_data VALUES (4731, 34, 2252, 0, 24, 20, 217);
INSERT INTO public.who_global_data VALUES (4732, 957, 30946, 11, 291, 20, 148);
INSERT INTO public.who_global_data VALUES (4733, 64, 77968, 0, 619, 20, 86);
INSERT INTO public.who_global_data VALUES (4734, 0, 1, 0, 0, 20, 13);
INSERT INTO public.who_global_data VALUES (4735, 441, 118856, 5, 1095, 20, 157);
INSERT INTO public.who_global_data VALUES (4736, 1, 1537, 0, 35, 20, 8);
INSERT INTO public.who_global_data VALUES (4737, 0, 4, 0, 0, 20, 73);
INSERT INTO public.who_global_data VALUES (4738, 1, 2116, 0, 613, 20, 101);
INSERT INTO public.who_global_data VALUES (4739, 1796, 36074, 5, 532, 20, 165);
INSERT INTO public.who_global_data VALUES (4740, 772, 26881, 17, 683, 20, 14);
INSERT INTO public.who_global_data VALUES (4741, 107, 53938, 12, 2336, 21, 193);
INSERT INTO public.who_global_data VALUES (4742, 641, 66635, 4, 1265, 21, 113);
INSERT INTO public.who_global_data VALUES (4743, 0, 102860, 0, 2819, 21, 143);
INSERT INTO public.who_global_data VALUES (4744, 0, 0, 0, 0, 21, 219);
INSERT INTO public.who_global_data VALUES (4745, 78, 8946, 0, 88, 21, 186);
INSERT INTO public.who_global_data VALUES (4746, 0, 18613, 0, 425, 21, 52);
INSERT INTO public.who_global_data VALUES (4747, 0, 15, 0, 0, 21, 180);
INSERT INTO public.who_global_data VALUES (4748, 0, 184, 0, 6, 21, 167);
INSERT INTO public.who_global_data VALUES (4749, 13286, 1770715, 142, 45125, 21, 154);
INSERT INTO public.who_global_data VALUES (4750, 263, 164235, 13, 2987, 21, 94);
INSERT INTO public.who_global_data VALUES (4751, 68, 6296, 0, 52, 21, 66);
INSERT INTO public.who_global_data VALUES (4752, 11, 28669, 0, 909, 21, 58);
INSERT INTO public.who_global_data VALUES (4753, 1472, 387995, 51, 6931, 21, 163);
INSERT INTO public.who_global_data VALUES (4754, 349, 226549, 12, 2983, 21, 37);
INSERT INTO public.who_global_data VALUES (4755, 11, 8032, 0, 175, 21, 142);
INSERT INTO public.who_global_data VALUES (4756, 209, 97021, 1, 357, 21, 83);
INSERT INTO public.who_global_data VALUES (4757, 762, 526485, 13, 7862, 21, 228);
INSERT INTO public.who_global_data VALUES (4758, 29, 1036, 0, 7, 21, 188);
INSERT INTO public.who_global_data VALUES (4759, 1941, 221604, 10, 1564, 21, 62);
INSERT INTO public.who_global_data VALUES (4760, 2063, 678364, 48, 20387, 21, 160);
INSERT INTO public.who_global_data VALUES (4761, 37, 11456, 2, 280, 21, 50);
INSERT INTO public.who_global_data VALUES (4762, 0, 3413, 0, 46, 21, 33);
INSERT INTO public.who_global_data VALUES (4763, 3, 667, 0, 12, 21, 183);
INSERT INTO public.who_global_data VALUES (4764, 3, 837, 0, 1, 21, 92);
INSERT INTO public.who_global_data VALUES (4765, 2198, 181016, 37, 9530, 21, 158);
INSERT INTO public.who_global_data VALUES (4766, 11, 329, 0, 3, 21, 67);
INSERT INTO public.who_global_data VALUES (4767, 320, 117331, 18, 4429, 21, 57);
INSERT INTO public.who_global_data VALUES (4768, 0, 16051, 0, 48, 21, 38);
INSERT INTO public.who_global_data VALUES (4769, 67758, 8324294, 1131, 207095, 21, 141);
INSERT INTO public.who_global_data VALUES (4770, 7, 121, 0, 1, 21, 178);
INSERT INTO public.who_global_data VALUES (4771, 0, 174, 0, 3, 21, 108);
INSERT INTO public.who_global_data VALUES (4772, 552, 211503, 61, 8457, 21, 39);
INSERT INTO public.who_global_data VALUES (4773, 0, 8809, 0, 97, 21, 2);
INSERT INTO public.who_global_data VALUES (4774, 35, 1185, 0, 2, 21, 195);
INSERT INTO public.who_global_data VALUES (4775, 112, 12776, 3, 118, 21, 107);
INSERT INTO public.who_global_data VALUES (4776, 10, 436, 0, 0, 21, 161);
INSERT INTO public.who_global_data VALUES (4777, 0, 27336, 0, 451, 21, 212);
INSERT INTO public.who_global_data VALUES (4778, 7563, 688891, 155, 17538, 21, 181);
INSERT INTO public.who_global_data VALUES (4779, 1, 368, 0, 2, 21, 53);
INSERT INTO public.who_global_data VALUES (4780, 0, 4973, 0, 63, 21, 164);
INSERT INTO public.who_global_data VALUES (4781, 34, 2807, 1, 111, 21, 140);
INSERT INTO public.who_global_data VALUES (4782, 4468, 661180, 75, 17369, 21, 20);
INSERT INTO public.who_global_data VALUES (4783, 169, 98459, 0, 4803, 21, 112);
INSERT INTO public.who_global_data VALUES (4784, 17121, 1849101, 367, 47491, 21, 111);
INSERT INTO public.who_global_data VALUES (4785, 66, 1469, 0, 38, 21, 71);
INSERT INTO public.who_global_data VALUES (4786, 0, 7709, 0, 114, 21, 218);
INSERT INTO public.who_global_data VALUES (4787, 0, 0, 0, 0, 21, 43);
INSERT INTO public.who_global_data VALUES (4788, 1086, 183242, 17, 2401, 21, 49);
INSERT INTO public.who_global_data VALUES (4789, 487, 24856, 1, 141, 21, 1);
INSERT INTO public.who_global_data VALUES (4790, 763, 224575, 38, 4588, 21, 48);
INSERT INTO public.who_global_data VALUES (4791, 547, 17096, 2, 162, 21, 232);
INSERT INTO public.who_global_data VALUES (4792, 10, 4498, 0, 19, 21, 175);
INSERT INTO public.who_global_data VALUES (4793, 244, 28609, 0, 166, 21, 21);
INSERT INTO public.who_global_data VALUES (4794, 9301, 883906, 186, 14215, 21, 156);
INSERT INTO public.who_global_data VALUES (4795, 0, 0, 0, 0, 21, 95);
INSERT INTO public.who_global_data VALUES (4796, 919, 20625, 2, 627, 21, 177);
INSERT INTO public.who_global_data VALUES (4797, 659, 187320, 17, 1720, 21, 210);
INSERT INTO public.who_global_data VALUES (4798, 3, 5903, 0, 61, 21, 120);
INSERT INTO public.who_global_data VALUES (4799, 0, 109, 0, 0, 21, 135);
INSERT INTO public.who_global_data VALUES (4800, 1482, 188969, 4, 2432, 21, 206);
INSERT INTO public.who_global_data VALUES (4801, 864, 226866, 27, 14273, 21, 189);
INSERT INTO public.who_global_data VALUES (4802, 879, 154620, 52, 8473, 21, 129);
INSERT INTO public.who_global_data VALUES (4803, 0, 50157, 10, 1469, 21, 121);
INSERT INTO public.who_global_data VALUES (4804, 0, 5316, 0, 86, 21, 59);
INSERT INTO public.who_global_data VALUES (4805, 0, 1805, 0, 6, 21, 96);
INSERT INTO public.who_global_data VALUES (4806, 595, 36691, 9, 320, 21, 41);
INSERT INTO public.who_global_data VALUES (4807, 0, 12327, 0, 335, 21, 216);
INSERT INTO public.who_global_data VALUES (4808, 404, 130326, 15, 2023, 21, 236);
INSERT INTO public.who_global_data VALUES (4809, 0, 32, 0, 0, 21, 150);
INSERT INTO public.who_global_data VALUES (4810, 1, 648, 0, 1, 21, 61);
INSERT INTO public.who_global_data VALUES (4811, 0, 53, 0, 2, 21, 7);
INSERT INTO public.who_global_data VALUES (4812, 318, 39911, 2, 618, 21, 169);
INSERT INTO public.who_global_data VALUES (4813, 20984, 2825764, 633, 69561, 21, 28);
INSERT INTO public.who_global_data VALUES (4814, 122, 14776, 0, 74, 21, 85);
INSERT INTO public.who_global_data VALUES (4815, 45, 17635, 0, 126, 21, 211);
INSERT INTO public.who_global_data VALUES (4816, 0, 9819, 0, 66, 21, 60);
INSERT INTO public.who_global_data VALUES (4817, 4, 3897, 0, 127, 21, 3);
INSERT INTO public.who_global_data VALUES (4818, 1236, 247025, 23, 2916, 21, 11);
INSERT INTO public.who_global_data VALUES (4819, 18678, 2019636, 980, 45974, 21, 89);
INSERT INTO public.who_global_data VALUES (4820, 0, 56981, 0, 341, 21, 24);
INSERT INTO public.who_global_data VALUES (4821, 78, 3509, 5, 25, 21, 162);
INSERT INTO public.who_global_data VALUES (4822, 577, 147860, 34, 5421, 21, 100);
INSERT INTO public.who_global_data VALUES (4823, 0, 30, 0, 0, 21, 47);
INSERT INTO public.who_global_data VALUES (4824, 0, 139, 0, 1, 21, 29);
INSERT INTO public.who_global_data VALUES (4825, 0, 8834, 0, 156, 21, 40);
INSERT INTO public.who_global_data VALUES (4826, 13, 7276, 1, 125, 21, 222);
INSERT INTO public.who_global_data VALUES (4827, 623, 147560, 26, 5177, 21, 132);
INSERT INTO public.who_global_data VALUES (4828, 0, 308, 0, 13, 21, 130);
INSERT INTO public.who_global_data VALUES (4829, 14, 14065, 0, 81, 21, 234);
INSERT INTO public.who_global_data VALUES (4830, 0, 2447, 0, 45, 21, 23);
INSERT INTO public.who_global_data VALUES (4831, 49, 6745, 0, 170, 21, 192);
INSERT INTO public.who_global_data VALUES (4832, 66, 10635, 0, 238, 21, 69);
INSERT INTO public.who_global_data VALUES (4833, 0, 26, 0, 0, 21, 187);
INSERT INTO public.who_global_data VALUES (4834, 954, 131963, 15, 3335, 21, 230);
INSERT INTO public.who_global_data VALUES (4835, 1438, 350587, 87, 11264, 21, 77);
INSERT INTO public.who_global_data VALUES (4836, 8, 5956, 0, 29, 21, 9);
INSERT INTO public.who_global_data VALUES (4837, 15158, 10542841, 175, 152093, 21, 74);
INSERT INTO public.who_global_data VALUES (4838, 12818, 882418, 238, 25484, 21, 224);
INSERT INTO public.who_global_data VALUES (4839, 6485, 1318295, 83, 56621, 21, 199);
INSERT INTO public.who_global_data VALUES (4840, 805, 606991, 10, 12932, 21, 190);
INSERT INTO public.who_global_data VALUES (4841, 3491, 166548, 48, 2536, 21, 12);
INSERT INTO public.who_global_data VALUES (4842, 3, 417, 0, 25, 21, 104);
INSERT INTO public.who_global_data VALUES (4843, 9291, 531336, 59, 3918, 21, 153);
INSERT INTO public.who_global_data VALUES (4844, 16144, 2352423, 477, 81325, 21, 91);
INSERT INTO public.who_global_data VALUES (4845, 77, 13992, 1, 323, 21, 215);
INSERT INTO public.who_global_data VALUES (4846, 6696, 315910, 65, 4380, 21, 84);
INSERT INTO public.who_global_data VALUES (4847, 13, 3029, 0, 60, 21, 231);
INSERT INTO public.who_global_data VALUES (4848, 808, 312851, 14, 4121, 21, 196);
INSERT INTO public.who_global_data VALUES (4849, 1072, 214927, 0, 2885, 21, 105);
INSERT INTO public.who_global_data VALUES (4850, 166, 98859, 3, 1726, 21, 122);
INSERT INTO public.who_global_data VALUES (4851, 0, 0, 0, 0, 21, 159);
INSERT INTO public.who_global_data VALUES (4852, 296, 55092, 7, 1389, 21, 75);
INSERT INTO public.who_global_data VALUES (4853, 530, 156964, 1, 947, 21, 27);
INSERT INTO public.who_global_data VALUES (4854, 129, 82986, 1, 1382, 21, 54);
INSERT INTO public.who_global_data VALUES (4855, 0, 41, 0, 0, 21, 226);
INSERT INTO public.who_global_data VALUES (4856, 1084, 54066, 0, 920, 21, 79);
INSERT INTO public.who_global_data VALUES (4857, 6154, 243286, 44, 1825, 21, 56);
INSERT INTO public.who_global_data VALUES (4858, 15, 6371, 4, 93, 21, 117);
INSERT INTO public.who_global_data VALUES (4859, 5, 1882, 0, 84, 21, 152);
INSERT INTO public.who_global_data VALUES (4860, 583, 108017, 6, 1651, 21, 16);
INSERT INTO public.who_global_data VALUES (4861, 4, 2446, 0, 44, 21, 10);
INSERT INTO public.who_global_data VALUES (4862, 1120, 166680, 38, 2414, 21, 201);
INSERT INTO public.who_global_data VALUES (4863, 143, 48622, 4, 549, 21, 174);
INSERT INTO public.who_global_data VALUES (4864, 0, 18001, 0, 267, 21, 119);
INSERT INTO public.who_global_data VALUES (4865, 0, 10494, 0, 285, 21, 168);
INSERT INTO public.who_global_data VALUES (4866, 3211, 151066, 8, 586, 21, 99);
INSERT INTO public.who_global_data VALUES (4867, 50, 14375, 0, 49, 21, 171);
INSERT INTO public.who_global_data VALUES (4868, 62, 7800, 5, 308, 21, 87);
INSERT INTO public.who_global_data VALUES (4869, 175, 15447, 2, 238, 21, 123);
INSERT INTO public.who_global_data VALUES (4870, 0, 4, 0, 0, 21, 151);
INSERT INTO public.who_global_data VALUES (4871, 0, 6227, 0, 43, 21, 213);
INSERT INTO public.who_global_data VALUES (4872, 0, 15893, 0, 396, 21, 118);
INSERT INTO public.who_global_data VALUES (4873, 1, 547, 0, 10, 21, 134);
INSERT INTO public.who_global_data VALUES (4874, 0, 6611, 0, 58, 21, 65);
INSERT INTO public.who_global_data VALUES (4875, 16468, 1588369, 999, 137916, 21, 102);
INSERT INTO public.who_global_data VALUES (4876, 0, 0, 0, 0, 21, 223);
INSERT INTO public.who_global_data VALUES (4877, 24, 1172, 0, 8, 21, 4);
INSERT INTO public.who_global_data VALUES (4878, 12, 1491, 0, 1, 21, 146);
INSERT INTO public.who_global_data VALUES (4879, 403, 55484, 2, 743, 21, 31);
INSERT INTO public.who_global_data VALUES (4880, 0, 13, 0, 1, 21, 127);
INSERT INTO public.who_global_data VALUES (4881, 1291, 457625, 34, 7888, 21, 22);
INSERT INTO public.who_global_data VALUES (4882, 0, 24269, 0, 211, 21, 115);
INSERT INTO public.who_global_data VALUES (4883, 513, 133378, 14, 2926, 21, 106);
INSERT INTO public.who_global_data VALUES (4884, 0, 29570, 0, 275, 21, 90);
INSERT INTO public.who_global_data VALUES (4885, 0, 0, 0, 0, 21, 70);
INSERT INTO public.who_global_data VALUES (4886, 270, 266816, 5, 1948, 21, 46);
INSERT INTO public.who_global_data VALUES (4887, 6035, 901009, 94, 12841, 21, 139);
INSERT INTO public.who_global_data VALUES (4888, 1, 41, 0, 0, 21, 42);
INSERT INTO public.who_global_data VALUES (4889, 0, 1890, 0, 25, 21, 80);
INSERT INTO public.who_global_data VALUES (4890, 0, 4916, 0, 167, 21, 203);
INSERT INTO public.who_global_data VALUES (4891, 47, 4105, 1, 138, 21, 136);
INSERT INTO public.who_global_data VALUES (4892, 1867, 107345, 8, 1413, 21, 63);
INSERT INTO public.who_global_data VALUES (4893, 0, 0, 0, 0, 21, 17);
INSERT INTO public.who_global_data VALUES (4894, 0, 128, 0, 2, 21, 172);
INSERT INTO public.who_global_data VALUES (4895, 403, 88389, 10, 2682, 21, 109);
INSERT INTO public.who_global_data VALUES (4896, 0, 57734, 0, 517, 21, 200);
INSERT INTO public.who_global_data VALUES (4897, 822, 170210, 27, 1848, 21, 93);
INSERT INTO public.who_global_data VALUES (4898, 0, 131264, 0, 1509, 21, 5);
INSERT INTO public.who_global_data VALUES (4899, 0, 745, 0, 13, 21, 214);
INSERT INTO public.who_global_data VALUES (4900, 2417, 514338, 45, 10863, 21, 204);
INSERT INTO public.who_global_data VALUES (4901, 0, 0, 0, 0, 21, 198);
INSERT INTO public.who_global_data VALUES (4902, 2877, 291285, 57, 4651, 21, 173);
INSERT INTO public.who_global_data VALUES (4903, 0, 834, 0, 9, 21, 229);
INSERT INTO public.who_global_data VALUES (4904, 1048, 119640, 15, 2467, 21, 76);
INSERT INTO public.who_global_data VALUES (4905, 5022, 1048662, 91, 38564, 21, 138);
INSERT INTO public.who_global_data VALUES (4906, 2041, 496646, 137, 9876, 21, 98);
INSERT INTO public.who_global_data VALUES (4907, 0, 0, 0, 0, 21, 103);
INSERT INTO public.who_global_data VALUES (4908, 7292, 1429612, 369, 33213, 21, 225);
INSERT INTO public.who_global_data VALUES (4909, 10663, 528469, 159, 8543, 21, 131);
INSERT INTO public.who_global_data VALUES (4910, 1138, 85954, 13, 1692, 21, 235);
INSERT INTO public.who_global_data VALUES (4911, 196, 146885, 0, 246, 21, 137);
INSERT INTO public.who_global_data VALUES (4912, 580, 71813, 19, 1236, 21, 81);
INSERT INTO public.who_global_data VALUES (4913, 576, 152263, 17, 3228, 21, 182);
INSERT INTO public.who_global_data VALUES (4914, 37, 9443, 3, 45, 21, 145);
INSERT INTO public.who_global_data VALUES (4915, 3353, 688270, 63, 17098, 21, 26);
INSERT INTO public.who_global_data VALUES (4916, 24092, 3544623, 590, 65085, 21, 170);
INSERT INTO public.who_global_data VALUES (4917, 257, 10573, 5, 138, 21, 191);
INSERT INTO public.who_global_data VALUES (4918, 0, 5, 0, 0, 21, 221);
INSERT INTO public.who_global_data VALUES (4919, 0, 224, 0, 0, 21, 64);
INSERT INTO public.who_global_data VALUES (4920, 0, 0, 0, 0, 21, 116);
INSERT INTO public.who_global_data VALUES (4921, 0, 34, 0, 0, 21, 128);
INSERT INTO public.who_global_data VALUES (4922, 41, 543, 0, 6, 21, 6);
INSERT INTO public.who_global_data VALUES (4923, 0, 1046, 0, 12, 21, 227);
INSERT INTO public.who_global_data VALUES (4924, 0, 16, 0, 0, 21, 68);
INSERT INTO public.who_global_data VALUES (4925, 48, 388, 0, 0, 21, 184);
INSERT INTO public.who_global_data VALUES (4926, 0, 2, 0, 0, 21, 82);
INSERT INTO public.who_global_data VALUES (4927, 44, 2767, 0, 65, 21, 149);
INSERT INTO public.who_global_data VALUES (4928, 6, 1125, 0, 17, 21, 197);
INSERT INTO public.who_global_data VALUES (4929, 173, 364613, 3, 6313, 21, 78);
INSERT INTO public.who_global_data VALUES (4930, 218, 22396, 10, 506, 21, 233);
INSERT INTO public.who_global_data VALUES (4931, 1751, 369823, 21, 3708, 21, 133);
INSERT INTO public.who_global_data VALUES (4932, 0, 626, 0, 1, 21, 35);
INSERT INTO public.who_global_data VALUES (4933, 26, 2959, 0, 77, 21, 114);
INSERT INTO public.who_global_data VALUES (4934, 30, 59059, 0, 29, 21, 237);
INSERT INTO public.who_global_data VALUES (4935, 0, 19, 0, 0, 21, 55);
INSERT INTO public.who_global_data VALUES (4936, 22, 1629, 0, 27, 21, 176);
INSERT INTO public.who_global_data VALUES (4937, 2045, 222752, 55, 3417, 21, 202);
INSERT INTO public.who_global_data VALUES (4938, 1543, 148621, 28, 3441, 21, 155);
INSERT INTO public.who_global_data VALUES (4939, 0, 17, 0, 0, 21, 32);
INSERT INTO public.who_global_data VALUES (4940, 0, 4744, 0, 130, 21, 220);
INSERT INTO public.who_global_data VALUES (4941, 14880, 1311686, 615, 36467, 21, 30);
INSERT INTO public.who_global_data VALUES (4942, 23, 3693, 0, 63, 21, 147);
INSERT INTO public.who_global_data VALUES (4943, 37301, 2343646, 238, 54472, 21, 208);
INSERT INTO public.who_global_data VALUES (4944, 695, 51594, 4, 255, 21, 45);
INSERT INTO public.who_global_data VALUES (4945, 82, 28179, 4, 1699, 21, 110);
INSERT INTO public.who_global_data VALUES (4946, 53, 7300, 0, 139, 21, 88);
INSERT INTO public.who_global_data VALUES (4947, 4749, 523485, 95, 11116, 21, 51);
INSERT INTO public.who_global_data VALUES (4948, 2158, 495695, 59, 8149, 21, 209);
INSERT INTO public.who_global_data VALUES (4949, 90, 12850, 8, 817, 21, 205);
INSERT INTO public.who_global_data VALUES (4950, 0, 13711, 0, 91, 21, 18);
INSERT INTO public.who_global_data VALUES (4951, 230, 11680, 1, 70, 21, 72);
INSERT INTO public.who_global_data VALUES (4952, 55761, 3316023, 1280, 87295, 21, 44);
INSERT INTO public.who_global_data VALUES (4953, 1, 52, 0, 0, 21, 15);
INSERT INTO public.who_global_data VALUES (4954, 111, 4220, 0, 73, 21, 25);
INSERT INTO public.who_global_data VALUES (4955, 0, 0, 0, 0, 21, 179);
INSERT INTO public.who_global_data VALUES (4956, 0, 0, 0, 0, 21, 34);
INSERT INTO public.who_global_data VALUES (4957, 15, 7320, 1, 130, 21, 207);
INSERT INTO public.who_global_data VALUES (4958, 4170, 175065, 50, 5528, 21, 166);
INSERT INTO public.who_global_data VALUES (4959, 8314, 2373115, 169, 23664, 21, 126);
INSERT INTO public.who_global_data VALUES (4960, 0, 0, 0, 0, 21, 97);
INSERT INTO public.who_global_data VALUES (4961, 32, 1062, 0, 6, 21, 36);
INSERT INTO public.who_global_data VALUES (4962, 0, 0, 0, 0, 21, 125);
INSERT INTO public.who_global_data VALUES (4963, 0, 38085, 0, 304, 21, 124);
INSERT INTO public.who_global_data VALUES (4964, 7729, 1154692, 144, 20686, 21, 185);
INSERT INTO public.who_global_data VALUES (4965, 3407, 246376, 7, 733, 21, 194);
INSERT INTO public.who_global_data VALUES (4966, 0, 509, 0, 21, 21, 144);
INSERT INTO public.who_global_data VALUES (4967, 226608, 23097938, 3891, 385413, 21, 19);
INSERT INTO public.who_global_data VALUES (4968, 0, 2218, 0, 24, 21, 217);
INSERT INTO public.who_global_data VALUES (4969, 1514, 29989, 5, 280, 21, 148);
INSERT INTO public.who_global_data VALUES (4970, 59, 77904, 0, 619, 21, 86);
INSERT INTO public.who_global_data VALUES (4971, 0, 1, 0, 0, 21, 13);
INSERT INTO public.who_global_data VALUES (4972, 604, 118415, 6, 1090, 21, 157);
INSERT INTO public.who_global_data VALUES (4973, 5, 1536, 0, 35, 21, 8);
INSERT INTO public.who_global_data VALUES (4974, 0, 4, 0, 0, 21, 73);
INSERT INTO public.who_global_data VALUES (4975, 1, 2115, 0, 613, 21, 101);
INSERT INTO public.who_global_data VALUES (4976, 1478, 34278, 13, 527, 21, 165);
INSERT INTO public.who_global_data VALUES (4977, 741, 26109, 30, 666, 21, 14);
INSERT INTO public.who_global_data VALUES (4978, 56, 53831, 10, 2324, 22, 193);
INSERT INTO public.who_global_data VALUES (4979, 660, 65994, 5, 1261, 22, 113);
INSERT INTO public.who_global_data VALUES (4980, 219, 102860, 3, 2819, 22, 143);
INSERT INTO public.who_global_data VALUES (4981, 0, 0, 0, 0, 22, 219);
INSERT INTO public.who_global_data VALUES (4982, 50, 8868, 1, 88, 22, 186);
INSERT INTO public.who_global_data VALUES (4983, 188, 18613, 1, 425, 22, 52);
INSERT INTO public.who_global_data VALUES (4984, 0, 15, 0, 0, 22, 180);
INSERT INTO public.who_global_data VALUES (4985, 8, 184, 1, 6, 22, 167);
INSERT INTO public.who_global_data VALUES (4986, 12725, 1757429, 135, 44983, 22, 154);
INSERT INTO public.who_global_data VALUES (4987, 396, 163972, 11, 2974, 22, 94);
INSERT INTO public.who_global_data VALUES (4988, 74, 6228, 0, 52, 22, 66);
INSERT INTO public.who_global_data VALUES (4989, 8, 28658, 0, 909, 22, 58);
INSERT INTO public.who_global_data VALUES (4990, 1514, 386523, 54, 6880, 22, 163);
INSERT INTO public.who_global_data VALUES (4991, 380, 226200, 14, 2971, 22, 37);
INSERT INTO public.who_global_data VALUES (4992, 17, 8021, 0, 175, 22, 142);
INSERT INTO public.who_global_data VALUES (4993, 342, 96812, 0, 356, 22, 83);
INSERT INTO public.who_global_data VALUES (4994, 813, 525723, 16, 7849, 22, 228);
INSERT INTO public.who_global_data VALUES (4995, 39, 1007, 0, 7, 22, 188);
INSERT INTO public.who_global_data VALUES (4996, 1967, 219663, 10, 1554, 22, 62);
INSERT INTO public.who_global_data VALUES (4997, 2105, 676301, 61, 20339, 22, 160);
INSERT INTO public.who_global_data VALUES (4998, 53, 11419, 1, 278, 22, 50);
INSERT INTO public.who_global_data VALUES (4999, 0, 3413, 0, 46, 22, 33);
INSERT INTO public.who_global_data VALUES (5000, 3, 664, 0, 12, 22, 183);
INSERT INTO public.who_global_data VALUES (5001, 1, 834, 0, 1, 22, 92);
INSERT INTO public.who_global_data VALUES (5002, 2057, 178818, 39, 9493, 22, 158);
INSERT INTO public.who_global_data VALUES (5003, 3, 318, 0, 3, 22, 67);
INSERT INTO public.who_global_data VALUES (5004, 343, 117011, 12, 4411, 22, 57);
INSERT INTO public.who_global_data VALUES (5005, 0, 16051, 0, 48, 22, 38);
INSERT INTO public.who_global_data VALUES (5006, 60899, 8256536, 1274, 205964, 22, 141);
INSERT INTO public.who_global_data VALUES (5007, 0, 114, 0, 1, 22, 178);
INSERT INTO public.who_global_data VALUES (5008, 0, 174, 0, 3, 22, 108);
INSERT INTO public.who_global_data VALUES (5009, 535, 210951, 47, 8396, 22, 39);
INSERT INTO public.who_global_data VALUES (5010, 263, 8809, 4, 97, 22, 2);
INSERT INTO public.who_global_data VALUES (5011, 47, 1150, 0, 2, 22, 195);
INSERT INTO public.who_global_data VALUES (5012, 72, 12664, 0, 115, 22, 107);
INSERT INTO public.who_global_data VALUES (5013, 15, 426, 0, 0, 22, 161);
INSERT INTO public.who_global_data VALUES (5014, 0, 27336, 0, 451, 22, 212);
INSERT INTO public.who_global_data VALUES (5015, 6855, 681328, 150, 17383, 22, 181);
INSERT INTO public.who_global_data VALUES (5016, 5, 367, 0, 2, 22, 53);
INSERT INTO public.who_global_data VALUES (5017, 0, 4973, 0, 63, 22, 164);
INSERT INTO public.who_global_data VALUES (5018, 64, 2773, 1, 110, 22, 140);
INSERT INTO public.who_global_data VALUES (5019, 4187, 656712, 90, 17294, 22, 20);
INSERT INTO public.who_global_data VALUES (5020, 173, 98290, 0, 4803, 22, 112);
INSERT INTO public.who_global_data VALUES (5021, 15898, 1831980, 342, 47124, 22, 111);
INSERT INTO public.who_global_data VALUES (5022, 62, 1403, 5, 38, 22, 71);
INSERT INTO public.who_global_data VALUES (5023, 549, 7709, 2, 114, 22, 218);
INSERT INTO public.who_global_data VALUES (5024, 0, 0, 0, 0, 22, 43);
INSERT INTO public.who_global_data VALUES (5025, 1063, 182156, 17, 2384, 22, 49);
INSERT INTO public.who_global_data VALUES (5026, 183, 24369, 0, 140, 22, 1);
INSERT INTO public.who_global_data VALUES (5027, 715, 223812, 33, 4550, 22, 48);
INSERT INTO public.who_global_data VALUES (5028, 505, 16549, 2, 160, 22, 232);
INSERT INTO public.who_global_data VALUES (5029, 19, 4488, 0, 19, 22, 175);
INSERT INTO public.who_global_data VALUES (5030, 241, 28365, 3, 166, 22, 21);
INSERT INTO public.who_global_data VALUES (5031, 8083, 874605, 173, 14029, 22, 156);
INSERT INTO public.who_global_data VALUES (5032, 0, 0, 0, 0, 22, 95);
INSERT INTO public.who_global_data VALUES (5033, 211, 19706, 15, 625, 22, 177);
INSERT INTO public.who_global_data VALUES (5034, 1502, 186661, 43, 1703, 22, 210);
INSERT INTO public.who_global_data VALUES (5035, 9, 5900, 0, 61, 22, 120);
INSERT INTO public.who_global_data VALUES (5036, 0, 109, 0, 0, 22, 135);
INSERT INTO public.who_global_data VALUES (5037, 1104, 187487, 0, 2428, 22, 206);
INSERT INTO public.who_global_data VALUES (5038, 1687, 226002, 17, 14246, 22, 189);
INSERT INTO public.who_global_data VALUES (5039, 1022, 153741, 59, 8421, 22, 129);
INSERT INTO public.who_global_data VALUES (5040, 618, 50157, 12, 1459, 22, 121);
INSERT INTO public.who_global_data VALUES (5041, 0, 5316, 0, 86, 22, 59);
INSERT INTO public.who_global_data VALUES (5042, 209, 1805, 0, 6, 22, 96);
INSERT INTO public.who_global_data VALUES (5043, 475, 36096, 10, 311, 22, 41);
INSERT INTO public.who_global_data VALUES (5044, 203, 12327, 3, 335, 22, 216);
INSERT INTO public.who_global_data VALUES (5045, 477, 129922, 2, 2008, 22, 236);
INSERT INTO public.who_global_data VALUES (5046, 0, 32, 0, 0, 22, 150);
INSERT INTO public.who_global_data VALUES (5047, 0, 647, 0, 1, 22, 61);
INSERT INTO public.who_global_data VALUES (5048, 0, 53, 0, 2, 22, 7);
INSERT INTO public.who_global_data VALUES (5049, 258, 39593, 6, 616, 22, 169);
INSERT INTO public.who_global_data VALUES (5050, 20872, 2804780, 280, 68928, 22, 28);
INSERT INTO public.who_global_data VALUES (5051, 128, 14654, 0, 74, 22, 85);
INSERT INTO public.who_global_data VALUES (5052, 107, 17590, 2, 126, 22, 211);
INSERT INTO public.who_global_data VALUES (5053, 0, 9819, 0, 66, 22, 60);
INSERT INTO public.who_global_data VALUES (5054, 3, 3893, 1, 127, 22, 3);
INSERT INTO public.who_global_data VALUES (5055, 1177, 245789, 26, 2893, 22, 11);
INSERT INTO public.who_global_data VALUES (5056, 22368, 2000958, 1113, 44994, 22, 89);
INSERT INTO public.who_global_data VALUES (5057, 0, 56981, 0, 341, 22, 24);
INSERT INTO public.who_global_data VALUES (5058, 107, 3431, 3, 20, 22, 162);
INSERT INTO public.who_global_data VALUES (5059, 595, 147283, 33, 5387, 22, 100);
INSERT INTO public.who_global_data VALUES (5060, 1, 30, 0, 0, 22, 47);
INSERT INTO public.who_global_data VALUES (5061, 0, 139, 0, 1, 22, 29);
INSERT INTO public.who_global_data VALUES (5062, 0, 8834, 0, 156, 22, 40);
INSERT INTO public.who_global_data VALUES (5063, 13, 7263, 0, 124, 22, 222);
INSERT INTO public.who_global_data VALUES (5064, 951, 146937, 34, 5151, 22, 132);
INSERT INTO public.who_global_data VALUES (5065, 1, 308, 0, 13, 22, 130);
INSERT INTO public.who_global_data VALUES (5066, 26, 14051, 0, 81, 22, 234);
INSERT INTO public.who_global_data VALUES (5067, 0, 2447, 0, 45, 22, 23);
INSERT INTO public.who_global_data VALUES (5068, 43, 6696, 0, 170, 22, 192);
INSERT INTO public.who_global_data VALUES (5069, 154, 10569, 0, 238, 22, 69);
INSERT INTO public.who_global_data VALUES (5070, 0, 26, 0, 0, 22, 187);
INSERT INTO public.who_global_data VALUES (5071, 1204, 131009, 26, 3320, 22, 230);
INSERT INTO public.who_global_data VALUES (5072, 1513, 349149, 111, 11177, 22, 77);
INSERT INTO public.who_global_data VALUES (5073, 13, 5948, 0, 29, 22, 9);
INSERT INTO public.who_global_data VALUES (5074, 15590, 10527683, 191, 151918, 22, 74);
INSERT INTO public.who_global_data VALUES (5075, 11557, 869600, 295, 25246, 22, 224);
INSERT INTO public.who_global_data VALUES (5076, 6471, 1311810, 81, 56538, 22, 199);
INSERT INTO public.who_global_data VALUES (5077, 770, 606186, 7, 12922, 22, 190);
INSERT INTO public.who_global_data VALUES (5078, 3913, 163057, 28, 2488, 22, 12);
INSERT INTO public.who_global_data VALUES (5079, 8, 414, 0, 25, 22, 104);
INSERT INTO public.who_global_data VALUES (5080, 9467, 522045, 55, 3859, 22, 153);
INSERT INTO public.who_global_data VALUES (5081, 17243, 2336279, 522, 80848, 22, 91);
INSERT INTO public.who_global_data VALUES (5082, 63, 13915, 5, 322, 22, 215);
INSERT INTO public.who_global_data VALUES (5083, 6591, 309214, 82, 4315, 22, 84);
INSERT INTO public.who_global_data VALUES (5084, 13, 3016, 1, 60, 22, 231);
INSERT INTO public.who_global_data VALUES (5085, 1075, 312043, 16, 4107, 22, 196);
INSERT INTO public.who_global_data VALUES (5086, 1043, 213855, 0, 2885, 22, 105);
INSERT INTO public.who_global_data VALUES (5087, 138, 98693, 3, 1723, 22, 122);
INSERT INTO public.who_global_data VALUES (5088, 0, 0, 0, 0, 22, 159);
INSERT INTO public.who_global_data VALUES (5089, 279, 54796, 4, 1382, 22, 75);
INSERT INTO public.who_global_data VALUES (5090, 560, 156434, 0, 946, 22, 27);
INSERT INTO public.who_global_data VALUES (5091, 134, 82857, 3, 1381, 22, 54);
INSERT INTO public.who_global_data VALUES (5092, 0, 41, 0, 0, 22, 226);
INSERT INTO public.who_global_data VALUES (5093, 950, 52982, 11, 920, 22, 79);
INSERT INTO public.who_global_data VALUES (5094, 5196, 237132, 41, 1781, 22, 56);
INSERT INTO public.who_global_data VALUES (5095, 115, 6356, 2, 89, 22, 117);
INSERT INTO public.who_global_data VALUES (5096, 0, 1877, 0, 84, 22, 152);
INSERT INTO public.who_global_data VALUES (5097, 764, 107434, 16, 1645, 22, 16);
INSERT INTO public.who_global_data VALUES (5098, 1, 2442, 0, 44, 22, 10);
INSERT INTO public.who_global_data VALUES (5099, 1146, 165560, 30, 2376, 22, 201);
INSERT INTO public.who_global_data VALUES (5100, 114, 48479, 3, 545, 22, 174);
INSERT INTO public.who_global_data VALUES (5101, 0, 18001, 0, 267, 22, 119);
INSERT INTO public.who_global_data VALUES (5102, 503, 10494, 10, 285, 22, 168);
INSERT INTO public.who_global_data VALUES (5103, 3337, 147855, 15, 578, 22, 99);
INSERT INTO public.who_global_data VALUES (5104, 48, 14325, 0, 49, 22, 171);
INSERT INTO public.who_global_data VALUES (5105, 0, 7738, 0, 303, 22, 87);
INSERT INTO public.who_global_data VALUES (5106, 193, 15272, 1, 236, 22, 123);
INSERT INTO public.who_global_data VALUES (5107, 0, 4, 0, 0, 22, 151);
INSERT INTO public.who_global_data VALUES (5108, 0, 6227, 0, 43, 22, 213);
INSERT INTO public.who_global_data VALUES (5109, 282, 15893, 9, 396, 22, 118);
INSERT INTO public.who_global_data VALUES (5110, 0, 546, 0, 10, 22, 134);
INSERT INTO public.who_global_data VALUES (5111, 356, 6611, 2, 58, 22, 65);
INSERT INTO public.who_global_data VALUES (5112, 15873, 1571901, 1235, 136917, 22, 102);
INSERT INTO public.who_global_data VALUES (5113, 0, 0, 0, 0, 22, 223);
INSERT INTO public.who_global_data VALUES (5114, 17, 1148, 1, 8, 22, 4);
INSERT INTO public.who_global_data VALUES (5115, 10, 1479, 0, 1, 22, 146);
INSERT INTO public.who_global_data VALUES (5116, 429, 55081, 1, 741, 22, 31);
INSERT INTO public.who_global_data VALUES (5117, 0, 13, 0, 1, 22, 127);
INSERT INTO public.who_global_data VALUES (5118, 1279, 456334, 44, 7854, 22, 22);
INSERT INTO public.who_global_data VALUES (5119, 543, 24269, 6, 211, 22, 115);
INSERT INTO public.who_global_data VALUES (5120, 605, 132865, 10, 2912, 22, 106);
INSERT INTO public.who_global_data VALUES (5121, 387, 29570, 4, 275, 22, 90);
INSERT INTO public.who_global_data VALUES (5122, 0, 0, 0, 0, 22, 70);
INSERT INTO public.who_global_data VALUES (5123, 403, 266546, 6, 1943, 22, 46);
INSERT INTO public.who_global_data VALUES (5124, 6504, 894974, 86, 12747, 22, 139);
INSERT INTO public.who_global_data VALUES (5125, 0, 40, 0, 0, 22, 42);
INSERT INTO public.who_global_data VALUES (5126, 18, 1890, 0, 25, 22, 80);
INSERT INTO public.who_global_data VALUES (5127, 0, 4916, 0, 167, 22, 203);
INSERT INTO public.who_global_data VALUES (5128, 60, 4058, 1, 137, 22, 136);
INSERT INTO public.who_global_data VALUES (5129, 1479, 105478, 23, 1405, 22, 63);
INSERT INTO public.who_global_data VALUES (5130, 0, 0, 0, 0, 22, 17);
INSERT INTO public.who_global_data VALUES (5131, 0, 128, 0, 2, 22, 172);
INSERT INTO public.who_global_data VALUES (5132, 396, 87986, 15, 2672, 22, 109);
INSERT INTO public.who_global_data VALUES (5133, 455, 57734, 6, 517, 22, 200);
INSERT INTO public.who_global_data VALUES (5134, 736, 169388, 7, 1821, 22, 93);
INSERT INTO public.who_global_data VALUES (5135, 178, 131264, 1, 1509, 22, 5);
INSERT INTO public.who_global_data VALUES (5136, 0, 745, 0, 13, 22, 214);
INSERT INTO public.who_global_data VALUES (5137, 3097, 511921, 46, 10818, 22, 204);
INSERT INTO public.who_global_data VALUES (5138, 0, 0, 0, 0, 22, 198);
INSERT INTO public.who_global_data VALUES (5139, 3315, 288408, 33, 4594, 22, 173);
INSERT INTO public.who_global_data VALUES (5140, 1, 834, 0, 9, 22, 229);
INSERT INTO public.who_global_data VALUES (5141, 1002, 118592, 15, 2452, 22, 76);
INSERT INTO public.who_global_data VALUES (5142, 3409, 1043640, 134, 38473, 22, 138);
INSERT INTO public.who_global_data VALUES (5143, 1905, 494605, 40, 9739, 22, 98);
INSERT INTO public.who_global_data VALUES (5144, 0, 0, 0, 0, 22, 103);
INSERT INTO public.who_global_data VALUES (5145, 7958, 1422320, 388, 32844, 22, 225);
INSERT INTO public.who_global_data VALUES (5146, 10698, 517806, 148, 8384, 22, 131);
INSERT INTO public.who_global_data VALUES (5147, 177, 84816, 20, 1679, 22, 235);
INSERT INTO public.who_global_data VALUES (5148, 209, 146689, 0, 246, 22, 137);
INSERT INTO public.who_global_data VALUES (5149, 512, 71233, 22, 1217, 22, 81);
INSERT INTO public.who_global_data VALUES (5150, 741, 151687, 18, 3211, 22, 182);
INSERT INTO public.who_global_data VALUES (5151, 0, 9406, 0, 42, 22, 145);
INSERT INTO public.who_global_data VALUES (5152, 3525, 684917, 66, 17035, 22, 26);
INSERT INTO public.who_global_data VALUES (5153, 24715, 3520531, 555, 64495, 22, 170);
INSERT INTO public.who_global_data VALUES (5154, 194, 10316, 5, 133, 22, 191);
INSERT INTO public.who_global_data VALUES (5155, 0, 5, 0, 0, 22, 221);
INSERT INTO public.who_global_data VALUES (5156, 0, 224, 0, 0, 22, 64);
INSERT INTO public.who_global_data VALUES (5157, 0, 0, 0, 0, 22, 116);
INSERT INTO public.who_global_data VALUES (5158, 0, 34, 0, 0, 22, 128);
INSERT INTO public.who_global_data VALUES (5159, 12, 502, 1, 6, 22, 6);
INSERT INTO public.who_global_data VALUES (5160, 0, 1046, 0, 12, 22, 227);
INSERT INTO public.who_global_data VALUES (5161, 0, 16, 0, 0, 22, 68);
INSERT INTO public.who_global_data VALUES (5162, 56, 340, 0, 0, 22, 184);
INSERT INTO public.who_global_data VALUES (5163, 0, 2, 0, 0, 22, 82);
INSERT INTO public.who_global_data VALUES (5164, 0, 2723, 0, 65, 22, 149);
INSERT INTO public.who_global_data VALUES (5165, 14, 1119, 0, 17, 22, 197);
INSERT INTO public.who_global_data VALUES (5166, 169, 364440, 6, 6310, 22, 78);
INSERT INTO public.who_global_data VALUES (5167, 295, 22178, 7, 496, 22, 233);
INSERT INTO public.who_global_data VALUES (5168, 1881, 368072, 23, 3687, 22, 133);
INSERT INTO public.who_global_data VALUES (5169, 16, 626, 0, 1, 22, 35);
INSERT INTO public.who_global_data VALUES (5170, 46, 2933, 0, 77, 22, 114);
INSERT INTO public.who_global_data VALUES (5171, 45, 59029, 0, 29, 22, 237);
INSERT INTO public.who_global_data VALUES (5172, 0, 19, 0, 0, 22, 55);
INSERT INTO public.who_global_data VALUES (5173, 18, 1607, 0, 27, 22, 176);
INSERT INTO public.who_global_data VALUES (5174, 2729, 220707, 102, 3362, 22, 202);
INSERT INTO public.who_global_data VALUES (5175, 1493, 147078, 24, 3413, 22, 155);
INSERT INTO public.who_global_data VALUES (5176, 0, 17, 0, 0, 22, 32);
INSERT INTO public.who_global_data VALUES (5177, 18, 4744, 0, 130, 22, 220);
INSERT INTO public.who_global_data VALUES (5178, 18503, 1296806, 712, 35852, 22, 30);
INSERT INTO public.who_global_data VALUES (5179, 0, 3670, 0, 63, 22, 147);
INSERT INTO public.who_global_data VALUES (5180, 37995, 2306345, 231, 54234, 22, 208);
INSERT INTO public.who_global_data VALUES (5181, 670, 50899, 4, 251, 22, 45);
INSERT INTO public.who_global_data VALUES (5182, 128, 28097, 12, 1695, 22, 110);
INSERT INTO public.who_global_data VALUES (5183, 69, 7247, 1, 139, 22, 88);
INSERT INTO public.who_global_data VALUES (5184, 6597, 518736, 89, 11021, 22, 51);
INSERT INTO public.who_global_data VALUES (5185, 2241, 493537, 44, 8090, 22, 209);
INSERT INTO public.who_global_data VALUES (5186, 100, 12760, 10, 809, 22, 205);
INSERT INTO public.who_global_data VALUES (5187, 0, 13711, 0, 91, 22, 18);
INSERT INTO public.who_global_data VALUES (5188, 188, 11450, 0, 69, 22, 72);
INSERT INTO public.who_global_data VALUES (5189, 48682, 3260262, 1248, 86015, 22, 44);
INSERT INTO public.who_global_data VALUES (5190, 0, 51, 0, 0, 22, 15);
INSERT INTO public.who_global_data VALUES (5191, 0, 4109, 0, 73, 22, 25);
INSERT INTO public.who_global_data VALUES (5192, 0, 0, 0, 0, 22, 179);
INSERT INTO public.who_global_data VALUES (5193, 0, 0, 0, 0, 22, 34);
INSERT INTO public.who_global_data VALUES (5194, 19, 7305, 1, 129, 22, 207);
INSERT INTO public.who_global_data VALUES (5195, 2327, 170895, 63, 5478, 22, 166);
INSERT INTO public.who_global_data VALUES (5196, 8962, 2364801, 170, 23495, 22, 126);
INSERT INTO public.who_global_data VALUES (5197, 0, 0, 0, 0, 22, 97);
INSERT INTO public.who_global_data VALUES (5198, 19, 1030, 0, 6, 22, 36);
INSERT INTO public.who_global_data VALUES (5199, 0, 0, 0, 0, 22, 125);
INSERT INTO public.who_global_data VALUES (5200, 0, 38085, 0, 304, 22, 124);
INSERT INTO public.who_global_data VALUES (5201, 8199, 1146963, 166, 20542, 22, 185);
INSERT INTO public.who_global_data VALUES (5202, 3382, 242969, 3, 726, 22, 194);
INSERT INTO public.who_global_data VALUES (5203, 0, 509, 0, 21, 22, 144);
INSERT INTO public.who_global_data VALUES (5204, 225573, 22871330, 4076, 381522, 22, 19);
INSERT INTO public.who_global_data VALUES (5205, 38, 2218, 0, 24, 22, 217);
INSERT INTO public.who_global_data VALUES (5206, 629, 28475, 6, 275, 22, 148);
INSERT INTO public.who_global_data VALUES (5207, 68, 77845, 1, 619, 22, 86);
INSERT INTO public.who_global_data VALUES (5208, 0, 1, 0, 0, 22, 13);
INSERT INTO public.who_global_data VALUES (5209, 512, 117811, 6, 1084, 22, 157);
INSERT INTO public.who_global_data VALUES (5210, 10, 1531, 0, 35, 22, 8);
INSERT INTO public.who_global_data VALUES (5211, 0, 4, 0, 0, 22, 73);
INSERT INTO public.who_global_data VALUES (5212, 1, 2114, 0, 613, 22, 101);
INSERT INTO public.who_global_data VALUES (5213, 1700, 32800, 5, 514, 22, 165);
INSERT INTO public.who_global_data VALUES (5214, 1112, 25368, 47, 636, 22, 14);
INSERT INTO public.who_global_data VALUES (5215, 85, 53775, 6, 2314, 23, 193);
INSERT INTO public.who_global_data VALUES (5216, 707, 65334, 4, 1256, 23, 113);
INSERT INTO public.who_global_data VALUES (5217, 0, 102641, 0, 2816, 23, 143);
INSERT INTO public.who_global_data VALUES (5218, 0, 0, 0, 0, 23, 219);
INSERT INTO public.who_global_data VALUES (5219, 73, 8818, 0, 87, 23, 186);
INSERT INTO public.who_global_data VALUES (5220, 82, 18425, 2, 424, 23, 52);
INSERT INTO public.who_global_data VALUES (5221, 0, 15, 0, 0, 23, 180);
INSERT INTO public.who_global_data VALUES (5222, 0, 176, 0, 5, 23, 167);
INSERT INTO public.who_global_data VALUES (5223, 13783, 1744704, 194, 44848, 23, 154);
INSERT INTO public.who_global_data VALUES (5224, 448, 163576, 12, 2963, 23, 94);
INSERT INTO public.who_global_data VALUES (5225, 86, 6154, 0, 52, 23, 66);
INSERT INTO public.who_global_data VALUES (5226, 16, 28650, 0, 909, 23, 58);
INSERT INTO public.who_global_data VALUES (5227, 2246, 385009, 44, 6826, 23, 163);
INSERT INTO public.who_global_data VALUES (5228, 474, 225820, 16, 2957, 23, 37);
INSERT INTO public.who_global_data VALUES (5229, 0, 8004, 0, 175, 23, 142);
INSERT INTO public.who_global_data VALUES (5230, 275, 96470, 0, 356, 23, 83);
INSERT INTO public.who_global_data VALUES (5231, 890, 524910, 14, 7833, 23, 228);
INSERT INTO public.who_global_data VALUES (5232, 84, 968, 0, 7, 23, 188);
INSERT INTO public.who_global_data VALUES (5233, 1972, 217696, 9, 1544, 23, 62);
INSERT INTO public.who_global_data VALUES (5234, 2217, 674196, 42, 20278, 23, 160);
INSERT INTO public.who_global_data VALUES (5235, 34, 11366, 2, 277, 23, 50);
INSERT INTO public.who_global_data VALUES (5236, 0, 3413, 0, 46, 23, 33);
INSERT INTO public.who_global_data VALUES (5237, 5, 661, 0, 12, 23, 183);
INSERT INTO public.who_global_data VALUES (5238, 2, 833, 0, 1, 23, 92);
INSERT INTO public.who_global_data VALUES (5239, 1473, 176761, 39, 9454, 23, 158);
INSERT INTO public.who_global_data VALUES (5240, 5, 315, 0, 3, 23, 67);
INSERT INTO public.who_global_data VALUES (5241, 468, 116668, 26, 4399, 23, 57);
INSERT INTO public.who_global_data VALUES (5242, 0, 16051, 0, 48, 23, 38);
INSERT INTO public.who_global_data VALUES (5243, 64025, 8195637, 1110, 204690, 23, 141);
INSERT INTO public.who_global_data VALUES (5244, 0, 114, 0, 1, 23, 178);
INSERT INTO public.who_global_data VALUES (5245, 0, 174, 0, 3, 23, 108);
INSERT INTO public.who_global_data VALUES (5246, 535, 210416, 70, 8349, 23, 39);
INSERT INTO public.who_global_data VALUES (5247, 83, 8546, 1, 93, 23, 2);
INSERT INTO public.who_global_data VALUES (5248, 41, 1103, 0, 2, 23, 195);
INSERT INTO public.who_global_data VALUES (5249, 86, 12592, 0, 115, 23, 107);
INSERT INTO public.who_global_data VALUES (5250, 13, 411, 0, 0, 23, 161);
INSERT INTO public.who_global_data VALUES (5251, 0, 27336, 0, 451, 23, 212);
INSERT INTO public.who_global_data VALUES (5252, 6292, 674473, 147, 17233, 23, 181);
INSERT INTO public.who_global_data VALUES (5253, 0, 362, 0, 2, 23, 53);
INSERT INTO public.who_global_data VALUES (5254, 0, 4973, 0, 63, 23, 164);
INSERT INTO public.who_global_data VALUES (5255, 41, 2709, 1, 109, 23, 140);
INSERT INTO public.who_global_data VALUES (5256, 3390, 652525, 22, 17204, 23, 20);
INSERT INTO public.who_global_data VALUES (5257, 184, 98117, 2, 4803, 23, 112);
INSERT INTO public.who_global_data VALUES (5258, 14179, 1816082, 331, 46782, 23, 111);
INSERT INTO public.who_global_data VALUES (5259, 53, 1341, 3, 33, 23, 71);
INSERT INTO public.who_global_data VALUES (5260, 0, 7160, 0, 112, 23, 218);
INSERT INTO public.who_global_data VALUES (5261, 0, 0, 0, 0, 23, 43);
INSERT INTO public.who_global_data VALUES (5262, 1032, 181093, 14, 2367, 23, 49);
INSERT INTO public.who_global_data VALUES (5263, 292, 24186, 1, 140, 23, 1);
INSERT INTO public.who_global_data VALUES (5264, 980, 223097, 45, 4517, 23, 48);
INSERT INTO public.who_global_data VALUES (5265, 550, 16044, 3, 158, 23, 232);
INSERT INTO public.who_global_data VALUES (5266, 5, 4469, 0, 19, 23, 175);
INSERT INTO public.who_global_data VALUES (5267, 227, 28124, 6, 163, 23, 21);
INSERT INTO public.who_global_data VALUES (5268, 10922, 866522, 200, 13856, 23, 156);
INSERT INTO public.who_global_data VALUES (5269, 0, 0, 0, 0, 23, 95);
INSERT INTO public.who_global_data VALUES (5270, 61, 19495, 0, 610, 23, 177);
INSERT INTO public.who_global_data VALUES (5271, 1358, 185159, 37, 1660, 23, 210);
INSERT INTO public.who_global_data VALUES (5272, 12, 5891, 0, 61, 23, 120);
INSERT INTO public.who_global_data VALUES (5273, 0, 109, 0, 0, 23, 135);
INSERT INTO public.who_global_data VALUES (5274, 1595, 186383, 1, 2428, 23, 206);
INSERT INTO public.who_global_data VALUES (5275, 1748, 224315, 33, 14229, 23, 189);
INSERT INTO public.who_global_data VALUES (5276, 996, 152719, 58, 8362, 23, 129);
INSERT INTO public.who_global_data VALUES (5277, 634, 49539, 10, 1447, 23, 121);
INSERT INTO public.who_global_data VALUES (5278, 20, 5316, 0, 86, 23, 59);
INSERT INTO public.who_global_data VALUES (5279, 0, 1596, 0, 6, 23, 96);
INSERT INTO public.who_global_data VALUES (5280, 630, 35621, 9, 301, 23, 41);
INSERT INTO public.who_global_data VALUES (5281, 205, 12124, 13, 332, 23, 216);
INSERT INTO public.who_global_data VALUES (5282, 453, 129445, 2, 2006, 23, 236);
INSERT INTO public.who_global_data VALUES (5283, 0, 32, 0, 0, 23, 150);
INSERT INTO public.who_global_data VALUES (5284, 1, 647, 0, 1, 23, 61);
INSERT INTO public.who_global_data VALUES (5285, 0, 53, 0, 2, 23, 7);
INSERT INTO public.who_global_data VALUES (5286, 324, 39335, 8, 610, 23, 169);
INSERT INTO public.who_global_data VALUES (5287, 23649, 2783908, 229, 68648, 23, 28);
INSERT INTO public.who_global_data VALUES (5288, 156, 14526, 0, 74, 23, 85);
INSERT INTO public.who_global_data VALUES (5289, 80, 17483, 0, 124, 23, 211);
INSERT INTO public.who_global_data VALUES (5290, 79, 9819, 0, 66, 23, 60);
INSERT INTO public.who_global_data VALUES (5291, 5, 3890, 1, 126, 23, 3);
INSERT INTO public.who_global_data VALUES (5292, 1357, 244612, 21, 2867, 23, 11);
INSERT INTO public.who_global_data VALUES (5293, 25164, 1978590, 1244, 43881, 23, 89);
INSERT INTO public.who_global_data VALUES (5294, 560, 56981, 3, 341, 23, 24);
INSERT INTO public.who_global_data VALUES (5295, 84, 3324, 1, 17, 23, 162);
INSERT INTO public.who_global_data VALUES (5296, 668, 146688, 25, 5354, 23, 100);
INSERT INTO public.who_global_data VALUES (5297, 0, 29, 0, 0, 23, 47);
INSERT INTO public.who_global_data VALUES (5298, 0, 139, 0, 1, 23, 29);
INSERT INTO public.who_global_data VALUES (5299, 0, 8834, 0, 156, 23, 40);
INSERT INTO public.who_global_data VALUES (5300, 11, 7250, 0, 124, 23, 222);
INSERT INTO public.who_global_data VALUES (5301, 982, 145986, 0, 5117, 23, 132);
INSERT INTO public.who_global_data VALUES (5302, 1, 307, 0, 13, 23, 130);
INSERT INTO public.who_global_data VALUES (5303, 36, 14025, 0, 81, 23, 234);
INSERT INTO public.who_global_data VALUES (5304, 0, 2447, 0, 45, 23, 23);
INSERT INTO public.who_global_data VALUES (5305, 65, 6653, 0, 170, 23, 192);
INSERT INTO public.who_global_data VALUES (5306, 29, 10415, 0, 238, 23, 69);
INSERT INTO public.who_global_data VALUES (5307, 0, 26, 0, 0, 23, 187);
INSERT INTO public.who_global_data VALUES (5308, 1104, 129805, 9, 3294, 23, 230);
INSERT INTO public.who_global_data VALUES (5309, 1926, 347636, 118, 11066, 23, 77);
INSERT INTO public.who_global_data VALUES (5310, 23, 5935, 0, 29, 23, 9);
INSERT INTO public.who_global_data VALUES (5311, 16946, 10512093, 198, 151727, 23, 74);
INSERT INTO public.who_global_data VALUES (5312, 11278, 858043, 306, 24951, 23, 224);
INSERT INTO public.who_global_data VALUES (5313, 6317, 1305339, 97, 56457, 23, 199);
INSERT INTO public.who_global_data VALUES (5314, 867, 605416, 4, 12915, 23, 190);
INSERT INTO public.who_global_data VALUES (5315, 3553, 159144, 63, 2460, 23, 12);
INSERT INTO public.who_global_data VALUES (5316, 3, 406, 0, 25, 23, 104);
INSERT INTO public.who_global_data VALUES (5317, 9295, 512578, 57, 3804, 23, 153);
INSERT INTO public.who_global_data VALUES (5318, 15773, 2319036, 507, 80326, 23, 91);
INSERT INTO public.who_global_data VALUES (5319, 92, 13852, 2, 317, 23, 215);
INSERT INTO public.who_global_data VALUES (5320, 5308, 302623, 88, 4233, 23, 84);
INSERT INTO public.who_global_data VALUES (5321, 10, 3003, 0, 59, 23, 231);
INSERT INTO public.who_global_data VALUES (5322, 1122, 310968, 15, 4091, 23, 196);
INSERT INTO public.who_global_data VALUES (5323, 911, 212812, 0, 2885, 23, 105);
INSERT INTO public.who_global_data VALUES (5324, 123, 98555, 4, 1720, 23, 122);
INSERT INTO public.who_global_data VALUES (5325, 0, 0, 0, 0, 23, 159);
INSERT INTO public.who_global_data VALUES (5326, 299, 54517, 1, 1378, 23, 75);
INSERT INTO public.who_global_data VALUES (5327, 539, 155874, 0, 946, 23, 27);
INSERT INTO public.who_global_data VALUES (5328, 136, 82723, 3, 1378, 23, 54);
INSERT INTO public.who_global_data VALUES (5329, 0, 41, 0, 0, 23, 226);
INSERT INTO public.who_global_data VALUES (5330, 1255, 52032, 27, 909, 23, 79);
INSERT INTO public.who_global_data VALUES (5331, 4988, 231936, 35, 1740, 23, 56);
INSERT INTO public.who_global_data VALUES (5332, 307, 6241, 2, 87, 23, 117);
INSERT INTO public.who_global_data VALUES (5333, 1, 1877, 0, 84, 23, 152);
INSERT INTO public.who_global_data VALUES (5334, 640, 106670, 7, 1629, 23, 16);
INSERT INTO public.who_global_data VALUES (5335, 4, 2441, 0, 44, 23, 10);
INSERT INTO public.who_global_data VALUES (5336, 1372, 164414, 29, 2346, 23, 201);
INSERT INTO public.who_global_data VALUES (5337, 190, 48365, 4, 542, 23, 174);
INSERT INTO public.who_global_data VALUES (5338, 0, 18001, 0, 267, 23, 119);
INSERT INTO public.who_global_data VALUES (5339, 591, 9991, 21, 275, 23, 168);
INSERT INTO public.who_global_data VALUES (5340, 2985, 144518, 4, 563, 23, 99);
INSERT INTO public.who_global_data VALUES (5341, 59, 14277, 0, 49, 23, 171);
INSERT INTO public.who_global_data VALUES (5342, 51, 7738, 0, 303, 23, 87);
INSERT INTO public.who_global_data VALUES (5343, 121, 15079, 1, 235, 23, 123);
INSERT INTO public.who_global_data VALUES (5344, 0, 4, 0, 0, 23, 151);
INSERT INTO public.who_global_data VALUES (5345, 0, 6227, 0, 43, 23, 213);
INSERT INTO public.who_global_data VALUES (5346, 0, 15611, 0, 387, 23, 118);
INSERT INTO public.who_global_data VALUES (5347, 0, 546, 0, 10, 23, 134);
INSERT INTO public.who_global_data VALUES (5348, 0, 6255, 0, 56, 23, 65);
INSERT INTO public.who_global_data VALUES (5349, 14395, 1556028, 1314, 135682, 23, 102);
INSERT INTO public.who_global_data VALUES (5350, 0, 0, 0, 0, 23, 223);
INSERT INTO public.who_global_data VALUES (5351, 33, 1131, 0, 7, 23, 4);
INSERT INTO public.who_global_data VALUES (5352, 13, 1469, 0, 1, 23, 146);
INSERT INTO public.who_global_data VALUES (5353, 422, 54652, 3, 740, 23, 31);
INSERT INTO public.who_global_data VALUES (5354, 0, 13, 0, 1, 23, 127);
INSERT INTO public.who_global_data VALUES (5355, 1266, 455055, 26, 7810, 23, 22);
INSERT INTO public.who_global_data VALUES (5356, 730, 23726, 4, 205, 23, 115);
INSERT INTO public.who_global_data VALUES (5357, 523, 132260, 24, 2902, 23, 106);
INSERT INTO public.who_global_data VALUES (5358, 312, 29183, 7, 271, 23, 90);
INSERT INTO public.who_global_data VALUES (5359, 0, 0, 0, 0, 23, 70);
INSERT INTO public.who_global_data VALUES (5360, 445, 266143, 5, 1937, 23, 46);
INSERT INTO public.who_global_data VALUES (5361, 6102, 888470, 121, 12661, 23, 139);
INSERT INTO public.who_global_data VALUES (5362, 0, 40, 0, 0, 23, 42);
INSERT INTO public.who_global_data VALUES (5363, 0, 1872, 0, 25, 23, 80);
INSERT INTO public.who_global_data VALUES (5364, 0, 4916, 0, 167, 23, 203);
INSERT INTO public.who_global_data VALUES (5365, 29, 3998, 1, 136, 23, 136);
INSERT INTO public.who_global_data VALUES (5366, 1398, 103999, 9, 1382, 23, 63);
INSERT INTO public.who_global_data VALUES (5367, 0, 0, 0, 0, 23, 17);
INSERT INTO public.who_global_data VALUES (5368, 0, 128, 0, 2, 23, 172);
INSERT INTO public.who_global_data VALUES (5369, 473, 87590, 10, 2657, 23, 109);
INSERT INTO public.who_global_data VALUES (5370, 665, 57279, 2, 511, 23, 200);
INSERT INTO public.who_global_data VALUES (5371, 978, 168652, 30, 1814, 23, 93);
INSERT INTO public.who_global_data VALUES (5372, 142, 131086, 0, 1508, 23, 5);
INSERT INTO public.who_global_data VALUES (5373, 0, 745, 0, 13, 23, 214);
INSERT INTO public.who_global_data VALUES (5374, 2123, 508824, 55, 10772, 23, 204);
INSERT INTO public.who_global_data VALUES (5375, 0, 0, 0, 0, 23, 198);
INSERT INTO public.who_global_data VALUES (5376, 3740, 285093, 61, 4561, 23, 173);
INSERT INTO public.who_global_data VALUES (5377, 10, 833, 0, 9, 23, 229);
INSERT INTO public.who_global_data VALUES (5378, 1055, 117590, 17, 2437, 23, 76);
INSERT INTO public.who_global_data VALUES (5379, 2881, 1040231, 4, 38339, 23, 138);
INSERT INTO public.who_global_data VALUES (5380, 1442, 492700, 145, 9699, 23, 98);
INSERT INTO public.who_global_data VALUES (5381, 0, 0, 0, 0, 23, 103);
INSERT INTO public.who_global_data VALUES (5382, 9457, 1414362, 382, 32456, 23, 225);
INSERT INTO public.who_global_data VALUES (5383, 10556, 507108, 156, 8236, 23, 131);
INSERT INTO public.who_global_data VALUES (5384, 212, 84639, 14, 1659, 23, 235);
INSERT INTO public.who_global_data VALUES (5385, 201, 146480, 0, 246, 23, 137);
INSERT INTO public.who_global_data VALUES (5386, 524, 70721, 10, 1195, 23, 81);
INSERT INTO public.who_global_data VALUES (5387, 808, 150946, 17, 3193, 23, 182);
INSERT INTO public.who_global_data VALUES (5388, 47, 9406, 0, 42, 23, 145);
INSERT INTO public.who_global_data VALUES (5389, 4424, 681392, 88, 16969, 23, 26);
INSERT INTO public.who_global_data VALUES (5390, 24763, 3495816, 570, 63940, 23, 170);
INSERT INTO public.who_global_data VALUES (5391, 172, 10122, 3, 128, 23, 191);
INSERT INTO public.who_global_data VALUES (5392, 0, 5, 0, 0, 23, 221);
INSERT INTO public.who_global_data VALUES (5393, 0, 224, 0, 0, 23, 64);
INSERT INTO public.who_global_data VALUES (5394, 0, 0, 0, 0, 23, 116);
INSERT INTO public.who_global_data VALUES (5395, 0, 34, 0, 0, 23, 128);
INSERT INTO public.who_global_data VALUES (5396, 12, 490, 0, 5, 23, 6);
INSERT INTO public.who_global_data VALUES (5397, 0, 1046, 0, 12, 23, 227);
INSERT INTO public.who_global_data VALUES (5398, 0, 16, 0, 0, 23, 68);
INSERT INTO public.who_global_data VALUES (5399, 31, 284, 0, 0, 23, 184);
INSERT INTO public.who_global_data VALUES (5400, 0, 2, 0, 0, 23, 82);
INSERT INTO public.who_global_data VALUES (5401, 17, 2723, 0, 65, 23, 149);
INSERT INTO public.who_global_data VALUES (5402, 15, 1105, 0, 17, 23, 197);
INSERT INTO public.who_global_data VALUES (5403, 175, 364271, 4, 6304, 23, 78);
INSERT INTO public.who_global_data VALUES (5404, 198, 21883, 9, 489, 23, 233);
INSERT INTO public.who_global_data VALUES (5405, 2267, 366191, 25, 3664, 23, 133);
INSERT INTO public.who_global_data VALUES (5406, 33, 610, 0, 1, 23, 35);
INSERT INTO public.who_global_data VALUES (5407, 23, 2887, 0, 77, 23, 114);
INSERT INTO public.who_global_data VALUES (5408, 38, 58984, 0, 29, 23, 237);
INSERT INTO public.who_global_data VALUES (5409, 0, 19, 0, 0, 23, 55);
INSERT INTO public.who_global_data VALUES (5410, 14, 1589, 0, 27, 23, 176);
INSERT INTO public.who_global_data VALUES (5411, 2923, 217978, 97, 3260, 23, 202);
INSERT INTO public.who_global_data VALUES (5412, 1804, 145585, 18, 3389, 23, 155);
INSERT INTO public.who_global_data VALUES (5413, 0, 17, 0, 0, 23, 32);
INSERT INTO public.who_global_data VALUES (5414, 0, 4726, 0, 130, 23, 220);
INSERT INTO public.who_global_data VALUES (5415, 18555, 1278303, 806, 35140, 23, 30);
INSERT INTO public.who_global_data VALUES (5416, 0, 3670, 0, 63, 23, 147);
INSERT INTO public.who_global_data VALUES (5417, 36154, 2268350, 228, 54003, 23, 208);
INSERT INTO public.who_global_data VALUES (5418, 692, 50229, 3, 247, 23, 45);
INSERT INTO public.who_global_data VALUES (5419, 142, 27969, 6, 1683, 23, 110);
INSERT INTO public.who_global_data VALUES (5420, 114, 7178, 0, 138, 23, 88);
INSERT INTO public.who_global_data VALUES (5421, 5342, 512139, 88, 10932, 23, 51);
INSERT INTO public.who_global_data VALUES (5422, 2458, 491296, 56, 8046, 23, 209);
INSERT INTO public.who_global_data VALUES (5423, 102, 12660, 9, 799, 23, 205);
INSERT INTO public.who_global_data VALUES (5424, 1, 13711, 0, 91, 23, 18);
INSERT INTO public.who_global_data VALUES (5425, 271, 11262, 2, 69, 23, 72);
INSERT INTO public.who_global_data VALUES (5426, 47525, 3211580, 1564, 84767, 23, 44);
INSERT INTO public.who_global_data VALUES (5427, 0, 51, 0, 0, 23, 15);
INSERT INTO public.who_global_data VALUES (5428, 64, 4109, 0, 73, 23, 25);
INSERT INTO public.who_global_data VALUES (5429, 0, 0, 0, 0, 23, 179);
INSERT INTO public.who_global_data VALUES (5430, 0, 0, 0, 0, 23, 34);
INSERT INTO public.who_global_data VALUES (5431, 13, 7286, 0, 128, 23, 207);
INSERT INTO public.who_global_data VALUES (5432, 3632, 168568, 72, 5415, 23, 166);
INSERT INTO public.who_global_data VALUES (5433, 9554, 2355839, 173, 23325, 23, 126);
INSERT INTO public.who_global_data VALUES (5434, 0, 0, 0, 0, 23, 97);
INSERT INTO public.who_global_data VALUES (5435, 17, 1011, 0, 6, 23, 36);
INSERT INTO public.who_global_data VALUES (5436, 0, 0, 0, 0, 23, 125);
INSERT INTO public.who_global_data VALUES (5437, 137, 38085, 1, 304, 23, 124);
INSERT INTO public.who_global_data VALUES (5438, 7925, 1138764, 162, 20376, 23, 185);
INSERT INTO public.who_global_data VALUES (5439, 3362, 239587, 6, 723, 23, 194);
INSERT INTO public.who_global_data VALUES (5440, 0, 509, 0, 21, 23, 144);
INSERT INTO public.who_global_data VALUES (5441, 217166, 22645757, 4117, 377446, 23, 19);
INSERT INTO public.who_global_data VALUES (5442, 14, 2180, 0, 24, 23, 217);
INSERT INTO public.who_global_data VALUES (5443, 945, 27846, 7, 269, 23, 148);
INSERT INTO public.who_global_data VALUES (5444, 61, 77777, 0, 618, 23, 86);
INSERT INTO public.who_global_data VALUES (5445, 0, 1, 0, 0, 23, 13);
INSERT INTO public.who_global_data VALUES (5446, 316, 117299, 5, 1078, 23, 157);
INSERT INTO public.who_global_data VALUES (5447, 1, 1521, 0, 35, 23, 8);
INSERT INTO public.who_global_data VALUES (5448, 0, 4, 0, 0, 23, 73);
INSERT INTO public.who_global_data VALUES (5449, 2, 2113, 0, 613, 23, 101);
INSERT INTO public.who_global_data VALUES (5450, 1343, 31100, 14, 509, 23, 165);
INSERT INTO public.who_global_data VALUES (5451, 1017, 24256, 38, 589, 23, 14);
INSERT INTO public.who_global_data VALUES (5452, 106, 53690, 7, 2308, 24, 193);
INSERT INTO public.who_global_data VALUES (5453, 656, 64627, 5, 1252, 24, 113);
INSERT INTO public.who_global_data VALUES (5454, 272, 102641, 4, 2816, 24, 143);
INSERT INTO public.who_global_data VALUES (5455, 0, 0, 0, 0, 24, 219);
INSERT INTO public.who_global_data VALUES (5456, 63, 8745, 1, 87, 24, 186);
INSERT INTO public.who_global_data VALUES (5457, 89, 18343, 2, 422, 24, 52);
INSERT INTO public.who_global_data VALUES (5458, 0, 15, 0, 0, 24, 180);
INSERT INTO public.who_global_data VALUES (5459, 0, 176, 0, 5, 24, 167);
INSERT INTO public.who_global_data VALUES (5460, 8704, 1730921, 159, 44654, 24, 154);
INSERT INTO public.who_global_data VALUES (5461, 240, 163128, 20, 2951, 24, 94);
INSERT INTO public.who_global_data VALUES (5462, 26, 6068, 1, 52, 24, 66);
INSERT INTO public.who_global_data VALUES (5463, 20, 28634, 0, 909, 24, 58);
INSERT INTO public.who_global_data VALUES (5464, 1728, 382763, 80, 6782, 24, 163);
INSERT INTO public.who_global_data VALUES (5465, 519, 225346, 15, 2941, 24, 37);
INSERT INTO public.who_global_data VALUES (5466, 0, 8004, 0, 175, 24, 142);
INSERT INTO public.who_global_data VALUES (5467, 316, 96195, 0, 356, 24, 83);
INSERT INTO public.who_global_data VALUES (5468, 718, 524020, 16, 7819, 24, 228);
INSERT INTO public.who_global_data VALUES (5469, 6, 884, 0, 7, 24, 188);
INSERT INTO public.who_global_data VALUES (5470, 1731, 215724, 9, 1535, 24, 62);
INSERT INTO public.who_global_data VALUES (5471, 2485, 671979, 51, 20236, 24, 160);
INSERT INTO public.who_global_data VALUES (5472, 29, 11332, 1, 275, 24, 50);
INSERT INTO public.who_global_data VALUES (5473, 50, 3413, 0, 46, 24, 33);
INSERT INTO public.who_global_data VALUES (5474, 4, 656, 0, 12, 24, 183);
INSERT INTO public.who_global_data VALUES (5475, 6, 831, 0, 1, 24, 92);
INSERT INTO public.who_global_data VALUES (5476, 1392, 175288, 39, 9415, 24, 158);
INSERT INTO public.who_global_data VALUES (5477, 25, 310, 0, 3, 24, 67);
INSERT INTO public.who_global_data VALUES (5478, 442, 116200, 15, 4373, 24, 57);
INSERT INTO public.who_global_data VALUES (5479, 0, 16051, 0, 48, 24, 38);
INSERT INTO public.who_global_data VALUES (5480, 25822, 8131612, 480, 203580, 24, 141);
INSERT INTO public.who_global_data VALUES (5481, 0, 114, 0, 1, 24, 178);
INSERT INTO public.who_global_data VALUES (5482, 1, 174, 0, 3, 24, 108);
INSERT INTO public.who_global_data VALUES (5483, 750, 209881, 47, 8279, 24, 39);
INSERT INTO public.who_global_data VALUES (5484, 184, 8463, 3, 92, 24, 2);
INSERT INTO public.who_global_data VALUES (5485, 43, 1062, 0, 2, 24, 195);
INSERT INTO public.who_global_data VALUES (5486, 73, 12506, 0, 115, 24, 107);
INSERT INTO public.who_global_data VALUES (5487, 6, 398, 0, 0, 24, 161);
INSERT INTO public.who_global_data VALUES (5488, 0, 27336, 0, 451, 24, 212);
INSERT INTO public.who_global_data VALUES (5489, 7892, 668181, 136, 17086, 24, 181);
INSERT INTO public.who_global_data VALUES (5490, 3, 362, 0, 2, 24, 53);
INSERT INTO public.who_global_data VALUES (5491, 0, 4973, 0, 63, 24, 164);
INSERT INTO public.who_global_data VALUES (5492, 79, 2668, 1, 108, 24, 140);
INSERT INTO public.who_global_data VALUES (5493, 3243, 649135, 20, 17182, 24, 20);
INSERT INTO public.who_global_data VALUES (5494, 179, 97933, 1, 4801, 24, 112);
INSERT INTO public.who_global_data VALUES (5495, 15003, 1801903, 337, 46451, 24, 111);
INSERT INTO public.who_global_data VALUES (5496, 104, 1288, 5, 30, 24, 71);
INSERT INTO public.who_global_data VALUES (5497, 0, 7160, 0, 112, 24, 218);
INSERT INTO public.who_global_data VALUES (5498, 0, 0, 0, 0, 24, 43);
INSERT INTO public.who_global_data VALUES (5499, 656, 180061, 15, 2353, 24, 49);
INSERT INTO public.who_global_data VALUES (5500, 412, 23894, 0, 139, 24, 1);
INSERT INTO public.who_global_data VALUES (5501, 1135, 222117, 26, 4472, 24, 48);
INSERT INTO public.who_global_data VALUES (5502, 487, 15494, 2, 155, 24, 232);
INSERT INTO public.who_global_data VALUES (5503, 6, 4464, 0, 19, 24, 175);
INSERT INTO public.who_global_data VALUES (5504, 259, 27897, 4, 157, 24, 21);
INSERT INTO public.who_global_data VALUES (5505, 10801, 855600, 171, 13656, 24, 156);
INSERT INTO public.who_global_data VALUES (5506, 0, 0, 0, 0, 24, 95);
INSERT INTO public.who_global_data VALUES (5507, 0, 19434, 0, 610, 24, 177);
INSERT INTO public.who_global_data VALUES (5508, 1076, 183801, 26, 1623, 24, 210);
INSERT INTO public.who_global_data VALUES (5509, 2, 5879, 0, 61, 24, 120);
INSERT INTO public.who_global_data VALUES (5510, 3, 109, 0, 0, 24, 135);
INSERT INTO public.who_global_data VALUES (5511, 1506, 184788, 0, 2427, 24, 206);
INSERT INTO public.who_global_data VALUES (5512, 1061, 222567, 12, 14196, 24, 189);
INSERT INTO public.who_global_data VALUES (5513, 970, 151723, 55, 8304, 24, 129);
INSERT INTO public.who_global_data VALUES (5514, 0, 48905, 9, 1437, 24, 121);
INSERT INTO public.who_global_data VALUES (5515, 0, 5296, 0, 86, 24, 59);
INSERT INTO public.who_global_data VALUES (5516, 40, 1596, 0, 6, 24, 96);
INSERT INTO public.who_global_data VALUES (5517, 853, 34991, 0, 292, 24, 41);
INSERT INTO public.who_global_data VALUES (5518, 208, 11919, 21, 319, 24, 216);
INSERT INTO public.who_global_data VALUES (5519, 376, 128992, 1, 2004, 24, 236);
INSERT INTO public.who_global_data VALUES (5520, 3, 32, 0, 0, 24, 150);
INSERT INTO public.who_global_data VALUES (5521, 0, 646, 0, 1, 24, 61);
INSERT INTO public.who_global_data VALUES (5522, 0, 53, 0, 2, 24, 7);
INSERT INTO public.who_global_data VALUES (5523, 221, 39011, 5, 602, 24, 169);
INSERT INTO public.who_global_data VALUES (5524, 19603, 2760259, 362, 68419, 24, 28);
INSERT INTO public.who_global_data VALUES (5525, 149, 14370, 0, 74, 24, 85);
INSERT INTO public.who_global_data VALUES (5526, 63, 17403, 0, 124, 24, 211);
INSERT INTO public.who_global_data VALUES (5527, 0, 9740, 0, 66, 24, 60);
INSERT INTO public.who_global_data VALUES (5528, 9, 3885, 0, 125, 24, 3);
INSERT INTO public.who_global_data VALUES (5529, 1618, 243255, 26, 2846, 24, 11);
INSERT INTO public.who_global_data VALUES (5530, 19600, 1953426, 1060, 42637, 24, 89);
INSERT INTO public.who_global_data VALUES (5531, 191, 56421, 0, 338, 24, 24);
INSERT INTO public.who_global_data VALUES (5532, 70, 3240, 0, 16, 24, 162);
INSERT INTO public.who_global_data VALUES (5533, 841, 146020, 27, 5329, 24, 100);
INSERT INTO public.who_global_data VALUES (5534, 0, 29, 0, 0, 24, 47);
INSERT INTO public.who_global_data VALUES (5535, 4, 139, 0, 1, 24, 29);
INSERT INTO public.who_global_data VALUES (5536, 0, 8834, 0, 156, 24, 40);
INSERT INTO public.who_global_data VALUES (5537, 5, 7239, 0, 124, 24, 222);
INSERT INTO public.who_global_data VALUES (5538, 1044, 145004, 92, 5117, 24, 132);
INSERT INTO public.who_global_data VALUES (5539, 1, 306, 0, 13, 24, 130);
INSERT INTO public.who_global_data VALUES (5540, 22, 13989, 0, 81, 24, 234);
INSERT INTO public.who_global_data VALUES (5541, 0, 2447, 0, 45, 24, 23);
INSERT INTO public.who_global_data VALUES (5542, 14, 6588, 1, 170, 24, 192);
INSERT INTO public.who_global_data VALUES (5543, 114, 10386, 0, 238, 24, 69);
INSERT INTO public.who_global_data VALUES (5544, 0, 26, 0, 0, 24, 187);
INSERT INTO public.who_global_data VALUES (5545, 756, 128701, 12, 3285, 24, 230);
INSERT INTO public.who_global_data VALUES (5546, 1358, 345710, 95, 10948, 24, 77);
INSERT INTO public.who_global_data VALUES (5547, 14, 5912, 0, 29, 24, 9);
INSERT INTO public.who_global_data VALUES (5548, 15968, 10495147, 202, 151529, 24, 74);
INSERT INTO public.who_global_data VALUES (5549, 10047, 846765, 302, 24645, 24, 224);
INSERT INTO public.who_global_data VALUES (5550, 6408, 1299022, 98, 56360, 24, 199);
INSERT INTO public.who_global_data VALUES (5551, 810, 604549, 5, 12911, 24, 190);
INSERT INTO public.who_global_data VALUES (5552, 3052, 155591, 45, 2397, 24, 12);
INSERT INTO public.who_global_data VALUES (5553, 7, 403, 0, 25, 24, 104);
INSERT INTO public.who_global_data VALUES (5554, 9712, 503283, 30, 3747, 24, 153);
INSERT INTO public.who_global_data VALUES (5555, 14242, 2303263, 616, 79819, 24, 91);
INSERT INTO public.who_global_data VALUES (5556, 123, 13760, 2, 315, 24, 215);
INSERT INTO public.who_global_data VALUES (5557, 5103, 297315, 51, 4145, 24, 84);
INSERT INTO public.who_global_data VALUES (5558, 21, 2993, 2, 59, 24, 231);
INSERT INTO public.who_global_data VALUES (5559, 1176, 309846, 33, 4076, 24, 196);
INSERT INTO public.who_global_data VALUES (5560, 925, 211901, 0, 2885, 24, 105);
INSERT INTO public.who_global_data VALUES (5561, 98, 98432, 3, 1716, 24, 122);
INSERT INTO public.who_global_data VALUES (5562, 0, 0, 0, 0, 24, 159);
INSERT INTO public.who_global_data VALUES (5563, 279, 54218, 4, 1377, 24, 75);
INSERT INTO public.who_global_data VALUES (5564, 494, 155335, 1, 946, 24, 27);
INSERT INTO public.who_global_data VALUES (5565, 92, 82587, 1, 1375, 24, 54);
INSERT INTO public.who_global_data VALUES (5566, 0, 41, 0, 0, 24, 226);
INSERT INTO public.who_global_data VALUES (5567, 878, 50777, 18, 882, 24, 79);
INSERT INTO public.who_global_data VALUES (5568, 4557, 226948, 76, 1705, 24, 56);
INSERT INTO public.who_global_data VALUES (5569, 764, 5934, 6, 85, 24, 117);
INSERT INTO public.who_global_data VALUES (5570, 76, 1876, 1, 84, 24, 152);
INSERT INTO public.who_global_data VALUES (5571, 652, 106030, 33, 1622, 24, 16);
INSERT INTO public.who_global_data VALUES (5572, 9, 2437, 0, 44, 24, 10);
INSERT INTO public.who_global_data VALUES (5573, 1694, 163042, 45, 2317, 24, 201);
INSERT INTO public.who_global_data VALUES (5574, 153, 48175, 3, 538, 24, 174);
INSERT INTO public.who_global_data VALUES (5575, 0, 18001, 0, 267, 24, 119);
INSERT INTO public.who_global_data VALUES (5576, 373, 9400, 19, 254, 24, 168);
INSERT INTO public.who_global_data VALUES (5577, 3309, 141533, 4, 559, 24, 99);
INSERT INTO public.who_global_data VALUES (5578, 59, 14218, 0, 49, 24, 171);
INSERT INTO public.who_global_data VALUES (5579, 23, 7687, 4, 303, 24, 87);
INSERT INTO public.who_global_data VALUES (5580, 189, 14958, 0, 234, 24, 123);
INSERT INTO public.who_global_data VALUES (5581, 0, 4, 0, 0, 24, 151);
INSERT INTO public.who_global_data VALUES (5582, 0, 6227, 0, 43, 24, 213);
INSERT INTO public.who_global_data VALUES (5583, 99, 15611, 3, 387, 24, 118);
INSERT INTO public.who_global_data VALUES (5584, 1, 546, 0, 10, 24, 134);
INSERT INTO public.who_global_data VALUES (5585, 0, 6255, 0, 56, 24, 65);
INSERT INTO public.who_global_data VALUES (5586, 7594, 1541633, 662, 134368, 24, 102);
INSERT INTO public.who_global_data VALUES (5587, 0, 0, 0, 0, 24, 223);
INSERT INTO public.who_global_data VALUES (5588, 25, 1098, 1, 7, 24, 4);
INSERT INTO public.who_global_data VALUES (5589, 14, 1456, 0, 1, 24, 146);
INSERT INTO public.who_global_data VALUES (5590, 447, 54230, 7, 737, 24, 31);
INSERT INTO public.who_global_data VALUES (5591, 0, 13, 0, 1, 24, 127);
INSERT INTO public.who_global_data VALUES (5592, 801, 453789, 17, 7784, 24, 22);
INSERT INTO public.who_global_data VALUES (5593, 662, 22996, 4, 201, 24, 115);
INSERT INTO public.who_global_data VALUES (5594, 551, 131737, 20, 2878, 24, 106);
INSERT INTO public.who_global_data VALUES (5595, 269, 28871, 3, 264, 24, 90);
INSERT INTO public.who_global_data VALUES (5596, 0, 0, 0, 0, 24, 70);
INSERT INTO public.who_global_data VALUES (5597, 430, 265698, 5, 1932, 24, 46);
INSERT INTO public.who_global_data VALUES (5598, 4949, 882368, 153, 12540, 24, 139);
INSERT INTO public.who_global_data VALUES (5599, 0, 40, 0, 0, 24, 42);
INSERT INTO public.who_global_data VALUES (5600, 7, 1872, 0, 25, 24, 80);
INSERT INTO public.who_global_data VALUES (5601, 49, 4916, 1, 167, 24, 203);
INSERT INTO public.who_global_data VALUES (5602, 92, 3969, 9, 135, 24, 136);
INSERT INTO public.who_global_data VALUES (5603, 1270, 102601, 12, 1373, 24, 63);
INSERT INTO public.who_global_data VALUES (5604, 0, 0, 0, 0, 24, 17);
INSERT INTO public.who_global_data VALUES (5605, 0, 128, 0, 2, 24, 172);
INSERT INTO public.who_global_data VALUES (5606, 520, 87117, 12, 2647, 24, 109);
INSERT INTO public.who_global_data VALUES (5607, 713, 56614, 27, 509, 24, 200);
INSERT INTO public.who_global_data VALUES (5608, 797, 167674, 16, 1784, 24, 93);
INSERT INTO public.who_global_data VALUES (5609, 164, 130944, 0, 1508, 24, 5);
INSERT INTO public.who_global_data VALUES (5610, 0, 745, 0, 13, 24, 214);
INSERT INTO public.who_global_data VALUES (5611, 2408, 506701, 41, 10717, 24, 204);
INSERT INTO public.who_global_data VALUES (5612, 0, 0, 0, 0, 24, 198);
INSERT INTO public.who_global_data VALUES (5613, 2157, 281353, 45, 4500, 24, 173);
INSERT INTO public.who_global_data VALUES (5614, 4, 823, 0, 9, 24, 229);
INSERT INTO public.who_global_data VALUES (5615, 802, 116535, 15, 2420, 24, 76);
INSERT INTO public.who_global_data VALUES (5616, 2166, 1037350, 55, 38335, 24, 138);
INSERT INTO public.who_global_data VALUES (5617, 1522, 491258, 138, 9554, 24, 98);
INSERT INTO public.who_global_data VALUES (5618, 0, 0, 0, 0, 24, 103);
INSERT INTO public.who_global_data VALUES (5619, 9053, 1404905, 481, 32074, 24, 225);
INSERT INTO public.who_global_data VALUES (5620, 7259, 496552, 155, 8080, 24, 131);
INSERT INTO public.who_global_data VALUES (5621, 959, 84427, 3, 1645, 24, 235);
INSERT INTO public.who_global_data VALUES (5622, 211, 146279, 0, 246, 24, 137);
INSERT INTO public.who_global_data VALUES (5623, 561, 70197, 20, 1185, 24, 81);
INSERT INTO public.who_global_data VALUES (5624, 476, 150138, 20, 3176, 24, 182);
INSERT INTO public.who_global_data VALUES (5625, 0, 9359, 0, 42, 24, 145);
INSERT INTO public.who_global_data VALUES (5626, 3697, 676968, 156, 16881, 24, 26);
INSERT INTO public.who_global_data VALUES (5627, 22850, 3471053, 566, 63370, 24, 170);
INSERT INTO public.who_global_data VALUES (5628, 166, 9950, 1, 125, 24, 191);
INSERT INTO public.who_global_data VALUES (5629, 0, 5, 0, 0, 24, 221);
INSERT INTO public.who_global_data VALUES (5630, 0, 224, 0, 0, 24, 64);
INSERT INTO public.who_global_data VALUES (5631, 0, 0, 0, 0, 24, 116);
INSERT INTO public.who_global_data VALUES (5632, 0, 34, 0, 0, 24, 128);
INSERT INTO public.who_global_data VALUES (5633, 40, 478, 0, 5, 24, 6);
INSERT INTO public.who_global_data VALUES (5634, 0, 1046, 0, 12, 24, 227);
INSERT INTO public.who_global_data VALUES (5635, 0, 16, 0, 0, 24, 68);
INSERT INTO public.who_global_data VALUES (5636, 4, 253, 0, 0, 24, 184);
INSERT INTO public.who_global_data VALUES (5637, 0, 2, 0, 0, 24, 82);
INSERT INTO public.who_global_data VALUES (5638, 56, 2706, 1, 65, 24, 149);
INSERT INTO public.who_global_data VALUES (5639, 24, 1090, 0, 17, 24, 197);
INSERT INTO public.who_global_data VALUES (5640, 147, 364096, 5, 6300, 24, 78);
INSERT INTO public.who_global_data VALUES (5641, 152, 21685, 11, 480, 24, 233);
INSERT INTO public.who_global_data VALUES (5642, 2142, 363924, 29, 3639, 24, 133);
INSERT INTO public.who_global_data VALUES (5643, 0, 577, 0, 1, 24, 35);
INSERT INTO public.who_global_data VALUES (5644, 18, 2864, 0, 77, 24, 114);
INSERT INTO public.who_global_data VALUES (5645, 17, 58946, 0, 29, 24, 237);
INSERT INTO public.who_global_data VALUES (5646, 0, 19, 0, 0, 24, 55);
INSERT INTO public.who_global_data VALUES (5647, 20, 1575, 0, 27, 24, 176);
INSERT INTO public.who_global_data VALUES (5648, 3576, 215055, 61, 3163, 24, 202);
INSERT INTO public.who_global_data VALUES (5649, 2100, 143781, 23, 3371, 24, 155);
INSERT INTO public.who_global_data VALUES (5650, 0, 17, 0, 0, 24, 32);
INSERT INTO public.who_global_data VALUES (5651, 0, 4726, 0, 130, 24, 220);
INSERT INTO public.who_global_data VALUES (5652, 13105, 1259748, 755, 34334, 24, 30);
INSERT INTO public.who_global_data VALUES (5653, 8, 3670, 0, 63, 24, 147);
INSERT INTO public.who_global_data VALUES (5654, 31235, 2232196, 235, 53775, 24, 208);
INSERT INTO public.who_global_data VALUES (5655, 588, 49537, 12, 244, 24, 45);
INSERT INTO public.who_global_data VALUES (5656, 59, 27827, 5, 1677, 24, 110);
INSERT INTO public.who_global_data VALUES (5657, 56, 7064, 5, 138, 24, 88);
INSERT INTO public.who_global_data VALUES (5658, 4648, 506797, 88, 10844, 24, 51);
INSERT INTO public.who_global_data VALUES (5659, 2606, 488838, 51, 7990, 24, 209);
INSERT INTO public.who_global_data VALUES (5660, 96, 12558, 9, 790, 24, 205);
INSERT INTO public.who_global_data VALUES (5661, 1, 13710, 0, 91, 24, 18);
INSERT INTO public.who_global_data VALUES (5662, 157, 10991, 0, 67, 24, 72);
INSERT INTO public.who_global_data VALUES (5663, 45533, 3164055, 1243, 83203, 24, 44);
INSERT INTO public.who_global_data VALUES (5664, 2, 51, 0, 0, 24, 15);
INSERT INTO public.who_global_data VALUES (5665, 67, 4045, 0, 73, 24, 25);
INSERT INTO public.who_global_data VALUES (5666, 0, 0, 0, 0, 24, 179);
INSERT INTO public.who_global_data VALUES (5667, 0, 0, 0, 0, 24, 34);
INSERT INTO public.who_global_data VALUES (5668, 8, 7273, 0, 128, 24, 207);
INSERT INTO public.who_global_data VALUES (5669, 2586, 164936, 59, 5343, 24, 166);
INSERT INTO public.who_global_data VALUES (5670, 9809, 2346285, 171, 23152, 24, 126);
INSERT INTO public.who_global_data VALUES (5671, 0, 0, 0, 0, 24, 97);
INSERT INTO public.who_global_data VALUES (5672, 0, 994, 0, 6, 24, 36);
INSERT INTO public.who_global_data VALUES (5673, 0, 0, 0, 0, 24, 125);
INSERT INTO public.who_global_data VALUES (5674, 140, 37948, 1, 303, 24, 124);
INSERT INTO public.who_global_data VALUES (5675, 6409, 1130839, 195, 20214, 24, 185);
INSERT INTO public.who_global_data VALUES (5676, 3243, 236225, 6, 717, 24, 194);
INSERT INTO public.who_global_data VALUES (5677, 0, 509, 0, 21, 24, 144);
INSERT INTO public.who_global_data VALUES (5678, 198788, 22428591, 1954, 373329, 24, 19);
INSERT INTO public.who_global_data VALUES (5679, 23, 2166, 0, 24, 24, 217);
INSERT INTO public.who_global_data VALUES (5680, 715, 26901, 6, 262, 24, 148);
INSERT INTO public.who_global_data VALUES (5681, 53, 77716, 1, 618, 24, 86);
INSERT INTO public.who_global_data VALUES (5682, 0, 1, 0, 0, 24, 13);
INSERT INTO public.who_global_data VALUES (5683, 373, 116983, 6, 1073, 24, 157);
INSERT INTO public.who_global_data VALUES (5684, 5, 1520, 0, 35, 24, 8);
INSERT INTO public.who_global_data VALUES (5685, 0, 4, 0, 0, 24, 73);
INSERT INTO public.who_global_data VALUES (5686, 2, 2111, 0, 613, 24, 101);
INSERT INTO public.who_global_data VALUES (5687, 1161, 29757, 24, 495, 24, 165);
INSERT INTO public.who_global_data VALUES (5688, 942, 23239, 23, 551, 24, 14);
INSERT INTO public.who_global_data VALUES (5689, 46, 53584, 13, 2301, 25, 193);
INSERT INTO public.who_global_data VALUES (5690, 376, 63971, 6, 1247, 25, 113);
INSERT INTO public.who_global_data VALUES (5691, 225, 102369, 5, 2812, 25, 143);
INSERT INTO public.who_global_data VALUES (5692, 0, 0, 0, 0, 25, 219);
INSERT INTO public.who_global_data VALUES (5693, 96, 8682, 1, 86, 25, 186);
INSERT INTO public.who_global_data VALUES (5694, 61, 18254, 4, 420, 25, 52);
INSERT INTO public.who_global_data VALUES (5695, 0, 15, 0, 0, 25, 180);
INSERT INTO public.who_global_data VALUES (5696, 0, 176, 0, 5, 25, 167);
INSERT INTO public.who_global_data VALUES (5697, 7808, 1722217, 78, 44495, 25, 154);
INSERT INTO public.who_global_data VALUES (5698, 0, 162888, 0, 2931, 25, 94);
INSERT INTO public.who_global_data VALUES (5699, 159, 6042, 1, 51, 25, 66);
INSERT INTO public.who_global_data VALUES (5700, 19, 28614, 0, 909, 25, 58);
INSERT INTO public.who_global_data VALUES (5701, 1328, 381035, 71, 6702, 25, 163);
INSERT INTO public.who_global_data VALUES (5702, 176, 224827, 17, 2926, 25, 37);
INSERT INTO public.who_global_data VALUES (5703, 9, 8004, 0, 175, 25, 142);
INSERT INTO public.who_global_data VALUES (5704, 321, 95879, 0, 356, 25, 83);
INSERT INTO public.who_global_data VALUES (5705, 849, 523302, 22, 7803, 25, 228);
INSERT INTO public.who_global_data VALUES (5706, 0, 878, 0, 7, 25, 188);
INSERT INTO public.who_global_data VALUES (5707, 1792, 213993, 9, 1526, 25, 62);
INSERT INTO public.who_global_data VALUES (5708, 3081, 669494, 53, 20185, 25, 160);
INSERT INTO public.who_global_data VALUES (5709, 37, 11303, 3, 274, 25, 50);
INSERT INTO public.who_global_data VALUES (5710, 59, 3363, 2, 46, 25, 33);
INSERT INTO public.who_global_data VALUES (5711, 0, 652, 0, 12, 25, 183);
INSERT INTO public.who_global_data VALUES (5712, 12, 825, 0, 1, 25, 92);
INSERT INTO public.who_global_data VALUES (5713, 1098, 173896, 25, 9376, 25, 158);
INSERT INTO public.who_global_data VALUES (5714, 31, 285, 0, 3, 25, 67);
INSERT INTO public.who_global_data VALUES (5715, 123, 115758, 28, 4358, 25, 57);
INSERT INTO public.who_global_data VALUES (5716, 0, 16051, 0, 48, 25, 38);
INSERT INTO public.who_global_data VALUES (5717, 29792, 8105790, 469, 203100, 25, 141);
INSERT INTO public.who_global_data VALUES (5718, 0, 114, 0, 1, 25, 178);
INSERT INTO public.who_global_data VALUES (5719, 0, 173, 0, 3, 25, 108);
INSERT INTO public.who_global_data VALUES (5720, 620, 209131, 106, 8232, 25, 39);
INSERT INTO public.who_global_data VALUES (5721, 197, 8279, 0, 89, 25, 2);
INSERT INTO public.who_global_data VALUES (5722, 0, 1019, 0, 2, 25, 195);
INSERT INTO public.who_global_data VALUES (5723, 41, 12433, 1, 115, 25, 107);
INSERT INTO public.who_global_data VALUES (5724, 0, 392, 0, 0, 25, 161);
INSERT INTO public.who_global_data VALUES (5725, 488, 27336, 3, 451, 25, 212);
INSERT INTO public.who_global_data VALUES (5726, 7816, 660289, 117, 16950, 25, 181);
INSERT INTO public.who_global_data VALUES (5727, 0, 359, 0, 2, 25, 53);
INSERT INTO public.who_global_data VALUES (5728, 0, 4973, 0, 63, 25, 164);
INSERT INTO public.who_global_data VALUES (5729, 52, 2589, 0, 107, 25, 140);
INSERT INTO public.who_global_data VALUES (5730, 3969, 645892, 66, 17162, 25, 20);
INSERT INTO public.who_global_data VALUES (5731, 102, 97754, 1, 4800, 25, 112);
INSERT INTO public.who_global_data VALUES (5732, 15537, 1786900, 330, 46114, 25, 111);
INSERT INTO public.who_global_data VALUES (5733, 0, 1184, 0, 25, 25, 71);
INSERT INTO public.who_global_data VALUES (5734, 0, 7160, 12, 112, 25, 218);
INSERT INTO public.who_global_data VALUES (5735, 0, 0, 0, 0, 25, 43);
INSERT INTO public.who_global_data VALUES (5736, 756, 179405, 16, 2338, 25, 49);
INSERT INTO public.who_global_data VALUES (5737, 228, 23482, 1, 139, 25, 1);
INSERT INTO public.who_global_data VALUES (5738, 759, 220982, 43, 4446, 25, 48);
INSERT INTO public.who_global_data VALUES (5739, 431, 15007, 2, 153, 25, 232);
INSERT INTO public.who_global_data VALUES (5740, 53, 4458, 1, 19, 25, 175);
INSERT INTO public.who_global_data VALUES (5741, 288, 27638, 5, 153, 25, 21);
INSERT INTO public.who_global_data VALUES (5742, 9345, 844799, 213, 13485, 25, 156);
INSERT INTO public.who_global_data VALUES (5743, 0, 0, 0, 0, 25, 95);
INSERT INTO public.who_global_data VALUES (5744, 277, 19434, 0, 610, 25, 177);
INSERT INTO public.who_global_data VALUES (5745, 1239, 182725, 27, 1597, 25, 210);
INSERT INTO public.who_global_data VALUES (5746, 6, 5877, 0, 61, 25, 120);
INSERT INTO public.who_global_data VALUES (5747, 0, 106, 0, 0, 25, 135);
INSERT INTO public.who_global_data VALUES (5748, 1179, 183282, 0, 2427, 25, 206);
INSERT INTO public.who_global_data VALUES (5749, 436, 221506, 7, 14184, 25, 189);
INSERT INTO public.who_global_data VALUES (5750, 961, 150753, 52, 8249, 25, 129);
INSERT INTO public.who_global_data VALUES (5751, 0, 48905, 9, 1428, 25, 121);
INSERT INTO public.who_global_data VALUES (5752, 7, 5296, 0, 86, 25, 59);
INSERT INTO public.who_global_data VALUES (5753, 0, 1556, 0, 6, 25, 96);
INSERT INTO public.who_global_data VALUES (5754, 333, 34138, 5, 292, 25, 41);
INSERT INTO public.who_global_data VALUES (5755, 276, 11711, 3, 298, 25, 216);
INSERT INTO public.who_global_data VALUES (5756, 300, 128616, 9, 2003, 25, 236);
INSERT INTO public.who_global_data VALUES (5757, 0, 29, 0, 0, 25, 150);
INSERT INTO public.who_global_data VALUES (5758, 0, 646, 0, 1, 25, 61);
INSERT INTO public.who_global_data VALUES (5759, 0, 53, 0, 2, 25, 7);
INSERT INTO public.who_global_data VALUES (5760, 200, 38790, 11, 597, 25, 169);
INSERT INTO public.who_global_data VALUES (5761, 3155, 2740656, 689, 68057, 25, 28);
INSERT INTO public.who_global_data VALUES (5762, 108, 14221, 0, 74, 25, 85);
INSERT INTO public.who_global_data VALUES (5763, 99, 17340, 2, 124, 25, 211);
INSERT INTO public.who_global_data VALUES (5764, 46, 9740, 0, 66, 25, 60);
INSERT INTO public.who_global_data VALUES (5765, 19, 3876, 0, 125, 25, 3);
INSERT INTO public.who_global_data VALUES (5766, 1857, 241637, 24, 2820, 25, 11);
INSERT INTO public.who_global_data VALUES (5767, 12802, 1933826, 891, 41577, 25, 89);
INSERT INTO public.who_global_data VALUES (5768, 458, 56230, 2, 338, 25, 24);
INSERT INTO public.who_global_data VALUES (5769, 61, 3170, 4, 16, 25, 162);
INSERT INTO public.who_global_data VALUES (5770, 441, 145179, 39, 5302, 25, 100);
INSERT INTO public.who_global_data VALUES (5771, 0, 29, 0, 0, 25, 47);
INSERT INTO public.who_global_data VALUES (5772, 0, 135, 0, 1, 25, 29);
INSERT INTO public.who_global_data VALUES (5773, 132, 8834, 1, 156, 25, 40);
INSERT INTO public.who_global_data VALUES (5774, 8, 7234, 0, 124, 25, 222);
INSERT INTO public.who_global_data VALUES (5775, 717, 143960, 0, 5025, 25, 132);
INSERT INTO public.who_global_data VALUES (5776, 1, 305, 0, 13, 25, 130);
INSERT INTO public.who_global_data VALUES (5777, 25, 13967, 0, 81, 25, 234);
INSERT INTO public.who_global_data VALUES (5778, 0, 2447, 0, 45, 25, 23);
INSERT INTO public.who_global_data VALUES (5779, 33, 6574, 2, 169, 25, 192);
INSERT INTO public.who_global_data VALUES (5780, 0, 10272, 0, 238, 25, 69);
INSERT INTO public.who_global_data VALUES (5781, 0, 26, 0, 0, 25, 187);
INSERT INTO public.who_global_data VALUES (5782, 719, 127945, -2, 3273, 25, 230);
INSERT INTO public.who_global_data VALUES (5783, 696, 344352, 128, 10853, 25, 77);
INSERT INTO public.who_global_data VALUES (5784, 8, 5898, 0, 29, 25, 9);
INSERT INTO public.who_global_data VALUES (5785, 12584, 10479179, 167, 151327, 25, 74);
INSERT INTO public.who_global_data VALUES (5786, 8692, 836718, 214, 24343, 25, 224);
INSERT INTO public.who_global_data VALUES (5787, 6208, 1292614, 91, 56262, 25, 199);
INSERT INTO public.who_global_data VALUES (5788, 801, 603739, 11, 12906, 25, 190);
INSERT INTO public.who_global_data VALUES (5789, 4926, 152539, 8, 2352, 25, 12);
INSERT INTO public.who_global_data VALUES (5790, 2, 396, 0, 25, 25, 104);
INSERT INTO public.who_global_data VALUES (5791, 6937, 493571, 44, 3717, 25, 153);
INSERT INTO public.who_global_data VALUES (5792, 12530, 2289021, 448, 79203, 25, 91);
INSERT INTO public.who_global_data VALUES (5793, 89, 13637, 1, 313, 25, 215);
INSERT INTO public.who_global_data VALUES (5794, 5460, 292212, 50, 4094, 25, 84);
INSERT INTO public.who_global_data VALUES (5795, 14, 2972, 0, 57, 25, 231);
INSERT INTO public.who_global_data VALUES (5796, 1461, 308670, 19, 4043, 25, 196);
INSERT INTO public.who_global_data VALUES (5797, 890, 210976, 0, 2885, 25, 105);
INSERT INTO public.who_global_data VALUES (5798, 63, 98334, 3, 1713, 25, 122);
INSERT INTO public.who_global_data VALUES (5799, 0, 0, 0, 0, 25, 159);
INSERT INTO public.who_global_data VALUES (5800, 206, 53939, 6, 1373, 25, 75);
INSERT INTO public.who_global_data VALUES (5801, 527, 154841, 2, 945, 25, 27);
INSERT INTO public.who_global_data VALUES (5802, 115, 82495, 3, 1374, 25, 54);
INSERT INTO public.who_global_data VALUES (5803, 0, 41, 0, 0, 25, 226);
INSERT INTO public.who_global_data VALUES (5804, 331, 49899, 15, 864, 25, 79);
INSERT INTO public.who_global_data VALUES (5805, 3095, 222391, 23, 1629, 25, 56);
INSERT INTO public.who_global_data VALUES (5806, 2593, 5170, 29, 79, 25, 117);
INSERT INTO public.who_global_data VALUES (5807, 0, 1800, 0, 83, 25, 152);
INSERT INTO public.who_global_data VALUES (5808, 633, 105378, 8, 1589, 25, 16);
INSERT INTO public.who_global_data VALUES (5809, 16, 2428, 0, 44, 25, 10);
INSERT INTO public.who_global_data VALUES (5810, 902, 161348, 40, 2272, 25, 201);
INSERT INTO public.who_global_data VALUES (5811, 42, 48022, 2, 535, 25, 174);
INSERT INTO public.who_global_data VALUES (5812, 234, 18001, 5, 267, 25, 119);
INSERT INTO public.who_global_data VALUES (5813, 452, 9027, 10, 235, 25, 168);
INSERT INTO public.who_global_data VALUES (5814, 2232, 138224, 4, 555, 25, 99);
INSERT INTO public.who_global_data VALUES (5815, 50, 14159, 0, 49, 25, 171);
INSERT INTO public.who_global_data VALUES (5816, 64, 7664, 1, 299, 25, 87);
INSERT INTO public.who_global_data VALUES (5817, 240, 14769, 1, 234, 25, 123);
INSERT INTO public.who_global_data VALUES (5818, 0, 4, 0, 0, 25, 151);
INSERT INTO public.who_global_data VALUES (5819, 110, 6227, 0, 43, 25, 213);
INSERT INTO public.who_global_data VALUES (5820, 0, 15512, 0, 384, 25, 118);
INSERT INTO public.who_global_data VALUES (5821, 6, 545, 0, 10, 25, 134);
INSERT INTO public.who_global_data VALUES (5822, 0, 6255, 0, 56, 25, 65);
INSERT INTO public.who_global_data VALUES (5823, 10003, 1534039, 502, 133706, 25, 102);
INSERT INTO public.who_global_data VALUES (5824, 0, 0, 0, 0, 25, 223);
INSERT INTO public.who_global_data VALUES (5825, 13, 1073, 1, 6, 25, 4);
INSERT INTO public.who_global_data VALUES (5826, 13, 1442, 0, 1, 25, 146);
INSERT INTO public.who_global_data VALUES (5827, 524, 53783, 1, 730, 25, 31);
INSERT INTO public.who_global_data VALUES (5828, 0, 13, 0, 1, 25, 127);
INSERT INTO public.who_global_data VALUES (5829, 456, 452988, 24, 7767, 25, 22);
INSERT INTO public.who_global_data VALUES (5830, 395, 22334, 5, 197, 25, 115);
INSERT INTO public.who_global_data VALUES (5831, 582, 131186, 12, 2858, 25, 106);
INSERT INTO public.who_global_data VALUES (5832, 343, 28602, 7, 261, 25, 90);
INSERT INTO public.who_global_data VALUES (5833, 0, 0, 0, 0, 25, 70);
INSERT INTO public.who_global_data VALUES (5834, 488, 265268, 10, 1927, 25, 46);
INSERT INTO public.who_global_data VALUES (5835, 5464, 877419, 48, 12387, 25, 139);
INSERT INTO public.who_global_data VALUES (5836, 0, 40, 0, 0, 25, 42);
INSERT INTO public.who_global_data VALUES (5837, 0, 1865, 0, 25, 25, 80);
INSERT INTO public.who_global_data VALUES (5838, 0, 4867, 0, 166, 25, 203);
INSERT INTO public.who_global_data VALUES (5839, 0, 3877, 0, 126, 25, 136);
INSERT INTO public.who_global_data VALUES (5840, 1244, 101331, 3, 1361, 25, 63);
INSERT INTO public.who_global_data VALUES (5841, 0, 0, 0, 0, 25, 17);
INSERT INTO public.who_global_data VALUES (5842, 3, 128, 0, 2, 25, 172);
INSERT INTO public.who_global_data VALUES (5843, 103, 86597, 13, 2635, 25, 109);
INSERT INTO public.who_global_data VALUES (5844, 428, 55901, 4, 482, 25, 200);
INSERT INTO public.who_global_data VALUES (5845, 928, 166877, 12, 1768, 25, 93);
INSERT INTO public.who_global_data VALUES (5846, 172, 130780, 0, 1508, 25, 5);
INSERT INTO public.who_global_data VALUES (5847, 0, 745, 0, 13, 25, 214);
INSERT INTO public.who_global_data VALUES (5848, 1877, 504293, 32, 10676, 25, 204);
INSERT INTO public.who_global_data VALUES (5849, 0, 0, 0, 0, 25, 198);
INSERT INTO public.who_global_data VALUES (5850, 2424, 279196, 45, 4455, 25, 173);
INSERT INTO public.who_global_data VALUES (5851, 8, 819, 0, 9, 25, 229);
INSERT INTO public.who_global_data VALUES (5852, 707, 115733, 18, 2405, 25, 76);
INSERT INTO public.who_global_data VALUES (5853, 2909, 1035184, 67, 38280, 25, 138);
INSERT INTO public.who_global_data VALUES (5854, 2046, 489736, 11, 9416, 25, 98);
INSERT INTO public.who_global_data VALUES (5855, 0, 0, 0, 0, 25, 103);
INSERT INTO public.who_global_data VALUES (5856, 5467, 1395852, 329, 31593, 25, 225);
INSERT INTO public.who_global_data VALUES (5857, 5604, 489293, 122, 7925, 25, 131);
INSERT INTO public.who_global_data VALUES (5858, 349, 83468, 12, 1642, 25, 235);
INSERT INTO public.who_global_data VALUES (5859, 203, 146068, 0, 246, 25, 137);
INSERT INTO public.who_global_data VALUES (5860, 537, 69636, 25, 1165, 25, 81);
INSERT INTO public.who_global_data VALUES (5861, 271, 149662, 17, 3156, 25, 182);
INSERT INTO public.who_global_data VALUES (5862, 0, 9359, 0, 42, 25, 145);
INSERT INTO public.who_global_data VALUES (5863, 1987, 673271, 71, 16725, 25, 26);
INSERT INTO public.who_global_data VALUES (5864, 22934, 3448203, 531, 62804, 25, 170);
INSERT INTO public.who_global_data VALUES (5865, 154, 9784, 4, 124, 25, 191);
INSERT INTO public.who_global_data VALUES (5866, 0, 5, 0, 0, 25, 221);
INSERT INTO public.who_global_data VALUES (5867, 33, 224, 0, 0, 25, 64);
INSERT INTO public.who_global_data VALUES (5868, 0, 0, 0, 0, 25, 116);
INSERT INTO public.who_global_data VALUES (5869, 0, 34, 0, 0, 25, 128);
INSERT INTO public.who_global_data VALUES (5870, 0, 438, 0, 5, 25, 6);
INSERT INTO public.who_global_data VALUES (5871, 44, 1046, 0, 12, 25, 227);
INSERT INTO public.who_global_data VALUES (5872, 0, 16, 0, 0, 25, 68);
INSERT INTO public.who_global_data VALUES (5873, 24, 249, 0, 0, 25, 184);
INSERT INTO public.who_global_data VALUES (5874, 0, 2, 0, 0, 25, 82);
INSERT INTO public.who_global_data VALUES (5875, 0, 2650, 0, 64, 25, 149);
INSERT INTO public.who_global_data VALUES (5876, 0, 1066, 0, 17, 25, 197);
INSERT INTO public.who_global_data VALUES (5877, 140, 363949, 4, 6295, 25, 78);
INSERT INTO public.who_global_data VALUES (5878, 288, 21533, 4, 469, 25, 233);
INSERT INTO public.who_global_data VALUES (5879, 2093, 361782, 28, 3610, 25, 133);
INSERT INTO public.who_global_data VALUES (5880, 52, 577, 0, 1, 25, 35);
INSERT INTO public.who_global_data VALUES (5881, 12, 2846, 0, 77, 25, 114);
INSERT INTO public.who_global_data VALUES (5882, 22, 58929, 0, 29, 25, 237);
INSERT INTO public.who_global_data VALUES (5883, 0, 19, 0, 0, 25, 55);
INSERT INTO public.who_global_data VALUES (5884, 24, 1555, 0, 27, 25, 176);
INSERT INTO public.who_global_data VALUES (5885, 2410, 211479, 95, 3102, 25, 202);
INSERT INTO public.who_global_data VALUES (5886, 1897, 141681, 29, 3348, 25, 155);
INSERT INTO public.who_global_data VALUES (5887, 0, 17, 0, 0, 25, 32);
INSERT INTO public.who_global_data VALUES (5888, 0, 4726, 0, 130, 25, 220);
INSERT INTO public.who_global_data VALUES (5889, 15046, 1246643, 416, 33579, 25, 30);
INSERT INTO public.who_global_data VALUES (5890, 13, 3662, 0, 63, 25, 147);
INSERT INTO public.who_global_data VALUES (5891, 13443, 2200961, 166, 53540, 25, 208);
INSERT INTO public.who_global_data VALUES (5892, 569, 48949, 0, 232, 25, 45);
INSERT INTO public.who_global_data VALUES (5893, 149, 27768, 6, 1672, 25, 110);
INSERT INTO public.who_global_data VALUES (5894, 60, 7008, 1, 133, 25, 88);
INSERT INTO public.who_global_data VALUES (5895, 2318, 502149, 90, 10756, 25, 51);
INSERT INTO public.who_global_data VALUES (5896, 3458, 486232, 54, 7939, 25, 209);
INSERT INTO public.who_global_data VALUES (5897, 98, 12462, 7, 781, 25, 205);
INSERT INTO public.who_global_data VALUES (5898, 1, 13709, 0, 91, 25, 18);
INSERT INTO public.who_global_data VALUES (5899, 287, 10834, 0, 67, 25, 72);
INSERT INTO public.who_global_data VALUES (5900, 46169, 3118522, 529, 81960, 25, 44);
INSERT INTO public.who_global_data VALUES (5901, 0, 49, 0, 0, 25, 15);
INSERT INTO public.who_global_data VALUES (5902, 21, 3978, 1, 73, 25, 25);
INSERT INTO public.who_global_data VALUES (5903, 0, 0, 0, 0, 25, 179);
INSERT INTO public.who_global_data VALUES (5904, 0, 0, 0, 0, 25, 34);
INSERT INTO public.who_global_data VALUES (5905, 21, 7265, 0, 128, 25, 207);
INSERT INTO public.who_global_data VALUES (5906, 3074, 162350, 69, 5284, 25, 166);
INSERT INTO public.who_global_data VALUES (5907, 10220, 2336476, 174, 22981, 25, 126);
INSERT INTO public.who_global_data VALUES (5908, 0, 0, 0, 0, 25, 97);
INSERT INTO public.who_global_data VALUES (5909, 0, 994, 0, 6, 25, 36);
INSERT INTO public.who_global_data VALUES (5910, 0, 0, 0, 0, 25, 125);
INSERT INTO public.who_global_data VALUES (5911, 66, 37808, 1, 302, 25, 124);
INSERT INTO public.who_global_data VALUES (5912, 5116, 1124430, 184, 20019, 25, 185);
INSERT INTO public.who_global_data VALUES (5913, 2404, 232982, 3, 711, 25, 194);
INSERT INTO public.who_global_data VALUES (5914, 0, 509, 0, 21, 25, 144);
INSERT INTO public.who_global_data VALUES (5915, 220528, 22229803, 2071, 371375, 25, 19);
INSERT INTO public.who_global_data VALUES (5916, 0, 2143, 0, 24, 25, 217);
INSERT INTO public.who_global_data VALUES (5917, 1212, 26186, 8, 256, 25, 148);
INSERT INTO public.who_global_data VALUES (5918, 52, 77663, 0, 617, 25, 86);
INSERT INTO public.who_global_data VALUES (5919, 0, 1, 0, 0, 25, 13);
INSERT INTO public.who_global_data VALUES (5920, 438, 116610, 6, 1067, 25, 157);
INSERT INTO public.who_global_data VALUES (5921, 1, 1515, 0, 35, 25, 8);
INSERT INTO public.who_global_data VALUES (5922, 0, 4, 0, 0, 25, 73);
INSERT INTO public.who_global_data VALUES (5923, 1, 2109, 1, 613, 25, 101);
INSERT INTO public.who_global_data VALUES (5924, 868, 28596, 2, 471, 25, 165);
INSERT INTO public.who_global_data VALUES (5925, 820, 22297, 21, 528, 25, 14);
INSERT INTO public.who_global_data VALUES (5926, 49, 53538, 11, 2288, 26, 193);
INSERT INTO public.who_global_data VALUES (5927, 562, 63595, 8, 1241, 26, 113);
INSERT INTO public.who_global_data VALUES (5928, 231, 102144, 4, 2807, 26, 143);
INSERT INTO public.who_global_data VALUES (5929, 0, 0, 0, 0, 26, 219);
INSERT INTO public.who_global_data VALUES (5930, 0, 8586, 0, 85, 26, 186);
INSERT INTO public.who_global_data VALUES (5931, 37, 18193, 0, 416, 26, 52);
INSERT INTO public.who_global_data VALUES (5932, 0, 15, 0, 0, 26, 180);
INSERT INTO public.who_global_data VALUES (5933, 7, 176, 0, 5, 26, 167);
INSERT INTO public.who_global_data VALUES (5934, 11057, 1714409, 144, 44417, 26, 154);
INSERT INTO public.who_global_data VALUES (5935, 757, 162888, 2, 2931, 26, 94);
INSERT INTO public.who_global_data VALUES (5936, 0, 5883, 0, 50, 26, 66);
INSERT INTO public.who_global_data VALUES (5937, 13, 28595, 0, 909, 26, 58);
INSERT INTO public.who_global_data VALUES (5938, 1597, 379707, 17, 6631, 26, 163);
INSERT INTO public.who_global_data VALUES (5939, 601, 224651, 19, 2909, 26, 37);
INSERT INTO public.who_global_data VALUES (5940, 18, 7995, 0, 175, 26, 142);
INSERT INTO public.who_global_data VALUES (5941, 241, 95558, 1, 356, 26, 83);
INSERT INTO public.who_global_data VALUES (5942, 1071, 522453, 25, 7781, 26, 228);
INSERT INTO public.who_global_data VALUES (5943, 70, 878, 0, 7, 26, 188);
INSERT INTO public.who_global_data VALUES (5944, 1833, 212201, 10, 1517, 26, 62);
INSERT INTO public.who_global_data VALUES (5945, 857, 666413, 56, 20132, 26, 160);
INSERT INTO public.who_global_data VALUES (5946, 64, 11266, 0, 271, 26, 50);
INSERT INTO public.who_global_data VALUES (5947, 0, 3304, 0, 44, 26, 33);
INSERT INTO public.who_global_data VALUES (5948, 6, 652, 0, 12, 26, 183);
INSERT INTO public.who_global_data VALUES (5949, 3, 813, 0, 1, 26, 92);
INSERT INTO public.who_global_data VALUES (5950, 1644, 172798, 23, 9351, 26, 158);
INSERT INTO public.who_global_data VALUES (5951, 0, 254, 0, 3, 26, 67);
INSERT INTO public.who_global_data VALUES (5952, 256, 115635, 25, 4330, 26, 57);
INSERT INTO public.who_global_data VALUES (5953, 0, 16051, 0, 48, 26, 38);
INSERT INTO public.who_global_data VALUES (5954, 62290, 8075998, 1171, 202631, 26, 141);
INSERT INTO public.who_global_data VALUES (5955, 0, 114, 0, 1, 26, 178);
INSERT INTO public.who_global_data VALUES (5956, 0, 173, 0, 3, 26, 108);
INSERT INTO public.who_global_data VALUES (5957, 105, 208511, 29, 8126, 26, 39);
INSERT INTO public.who_global_data VALUES (5958, 216, 8082, 0, 89, 26, 2);
INSERT INTO public.who_global_data VALUES (5959, 33, 1019, 0, 2, 26, 195);
INSERT INTO public.who_global_data VALUES (5960, 155, 12392, 0, 114, 26, 107);
INSERT INTO public.who_global_data VALUES (5961, 1, 392, 0, 0, 26, 161);
INSERT INTO public.who_global_data VALUES (5962, 0, 26848, 0, 448, 26, 212);
INSERT INTO public.who_global_data VALUES (5963, 8125, 652473, 126, 16833, 26, 181);
INSERT INTO public.who_global_data VALUES (5964, 0, 359, 0, 2, 26, 53);
INSERT INTO public.who_global_data VALUES (5965, 0, 4973, 0, 63, 26, 164);
INSERT INTO public.who_global_data VALUES (5966, 27, 2537, 0, 107, 26, 140);
INSERT INTO public.who_global_data VALUES (5967, 4181, 641923, 59, 17096, 26, 20);
INSERT INTO public.who_global_data VALUES (5968, 134, 97652, 1, 4799, 26, 112);
INSERT INTO public.who_global_data VALUES (5969, 15795, 1771363, 353, 45784, 26, 111);
INSERT INTO public.who_global_data VALUES (5970, 34, 1184, 7, 25, 26, 71);
INSERT INTO public.who_global_data VALUES (5971, 0, 7160, 0, 100, 26, 218);
INSERT INTO public.who_global_data VALUES (5972, 0, 0, 0, 0, 26, 43);
INSERT INTO public.who_global_data VALUES (5973, 1035, 178649, 17, 2322, 26, 49);
INSERT INTO public.who_global_data VALUES (5974, 0, 23254, 0, 138, 26, 1);
INSERT INTO public.who_global_data VALUES (5975, 230, 220223, 35, 4403, 26, 48);
INSERT INTO public.who_global_data VALUES (5976, 388, 14576, 3, 151, 26, 232);
INSERT INTO public.who_global_data VALUES (5977, 0, 4405, 0, 18, 26, 175);
INSERT INTO public.who_global_data VALUES (5978, 339, 27350, 1, 148, 26, 21);
INSERT INTO public.who_global_data VALUES (5979, 4289, 835454, 157, 13272, 26, 156);
INSERT INTO public.who_global_data VALUES (5980, 0, 0, 0, 0, 26, 95);
INSERT INTO public.who_global_data VALUES (5981, 190, 19157, 0, 610, 26, 177);
INSERT INTO public.who_global_data VALUES (5982, 1246, 181486, 28, 1570, 26, 210);
INSERT INTO public.who_global_data VALUES (5983, 5, 5871, 0, 61, 26, 120);
INSERT INTO public.who_global_data VALUES (5984, 0, 106, 0, 0, 26, 135);
INSERT INTO public.who_global_data VALUES (5985, 1459, 182103, 3, 2427, 26, 206);
INSERT INTO public.who_global_data VALUES (5986, 721, 221070, 0, 14177, 26, 189);
INSERT INTO public.who_global_data VALUES (5987, 993, 149792, 55, 8197, 26, 129);
INSERT INTO public.who_global_data VALUES (5988, 331, 48905, 11, 1419, 26, 121);
INSERT INTO public.who_global_data VALUES (5989, 0, 5289, 0, 86, 26, 59);
INSERT INTO public.who_global_data VALUES (5990, 0, 1556, 0, 6, 26, 96);
INSERT INTO public.who_global_data VALUES (5991, 289, 33805, 4, 287, 26, 41);
INSERT INTO public.who_global_data VALUES (5992, 255, 11435, 4, 295, 26, 216);
INSERT INTO public.who_global_data VALUES (5993, 524, 128316, 9, 1994, 26, 236);
INSERT INTO public.who_global_data VALUES (5994, 0, 29, 0, 0, 26, 150);
INSERT INTO public.who_global_data VALUES (5995, 0, 646, 0, 1, 26, 61);
INSERT INTO public.who_global_data VALUES (5996, 0, 53, 0, 2, 26, 7);
INSERT INTO public.who_global_data VALUES (5997, 198, 38590, 0, 586, 26, 169);
INSERT INTO public.who_global_data VALUES (5998, 15809, 2737501, 151, 67368, 26, 28);
INSERT INTO public.who_global_data VALUES (5999, 0, 14113, 0, 74, 26, 85);
INSERT INTO public.who_global_data VALUES (6000, 0, 17241, 0, 122, 26, 211);
INSERT INTO public.who_global_data VALUES (6001, 0, 9694, 0, 66, 26, 60);
INSERT INTO public.who_global_data VALUES (6002, 0, 3857, 0, 125, 26, 3);
INSERT INTO public.who_global_data VALUES (6003, 551, 239780, 23, 2796, 26, 11);
INSERT INTO public.who_global_data VALUES (6004, 12497, 1921024, 343, 40686, 26, 89);
INSERT INTO public.who_global_data VALUES (6005, 0, 55772, 0, 336, 26, 24);
INSERT INTO public.who_global_data VALUES (6006, 88, 3109, 0, 12, 26, 162);
INSERT INTO public.who_global_data VALUES (6007, 445, 144738, 36, 5263, 26, 100);
INSERT INTO public.who_global_data VALUES (6008, 0, 29, 0, 0, 26, 47);
INSERT INTO public.who_global_data VALUES (6009, 0, 135, 0, 1, 26, 29);
INSERT INTO public.who_global_data VALUES (6010, 0, 8702, 0, 155, 26, 40);
INSERT INTO public.who_global_data VALUES (6011, 8, 7226, 0, 124, 26, 222);
INSERT INTO public.who_global_data VALUES (6012, 116, 143243, 26, 5025, 26, 132);
INSERT INTO public.who_global_data VALUES (6013, 2, 304, 0, 13, 26, 130);
INSERT INTO public.who_global_data VALUES (6014, 38, 13942, 0, 81, 26, 234);
INSERT INTO public.who_global_data VALUES (6015, 0, 2447, 0, 45, 26, 23);
INSERT INTO public.who_global_data VALUES (6016, 72, 6541, 0, 167, 26, 192);
INSERT INTO public.who_global_data VALUES (6017, 31, 10272, 1, 238, 26, 69);
INSERT INTO public.who_global_data VALUES (6018, 0, 26, 0, 0, 26, 187);
INSERT INTO public.who_global_data VALUES (6019, 830, 127226, 9, 3275, 26, 230);
INSERT INTO public.who_global_data VALUES (6020, 1419, 343656, 77, 10725, 26, 77);
INSERT INTO public.who_global_data VALUES (6021, 10, 5890, 0, 29, 26, 9);
INSERT INTO public.who_global_data VALUES (6022, 16311, 10466595, 161, 151160, 26, 74);
INSERT INTO public.who_global_data VALUES (6023, 9640, 828026, 182, 24129, 26, 224);
INSERT INTO public.who_global_data VALUES (6024, 5968, 1286406, 71, 56171, 26, 199);
INSERT INTO public.who_global_data VALUES (6025, 607, 602938, 14, 12895, 26, 190);
INSERT INTO public.who_global_data VALUES (6026, 6886, 147613, 8, 2344, 26, 12);
INSERT INTO public.who_global_data VALUES (6027, 2, 394, 0, 25, 26, 104);
INSERT INTO public.who_global_data VALUES (6028, 5156, 486634, 21, 3673, 26, 153);
INSERT INTO public.who_global_data VALUES (6029, 18625, 2276491, 361, 78755, 26, 91);
INSERT INTO public.who_global_data VALUES (6030, 93, 13548, 1, 312, 26, 215);
INSERT INTO public.who_global_data VALUES (6031, 5977, 286752, 48, 4044, 26, 84);
INSERT INTO public.who_global_data VALUES (6032, 37, 2958, 0, 57, 26, 231);
INSERT INTO public.who_global_data VALUES (6033, 1250, 307209, 15, 4024, 26, 196);
INSERT INTO public.who_global_data VALUES (6034, 717, 210086, 0, 2885, 26, 105);
INSERT INTO public.who_global_data VALUES (6035, 87, 98271, 6, 1710, 26, 122);
INSERT INTO public.who_global_data VALUES (6036, 0, 0, 0, 0, 26, 159);
INSERT INTO public.who_global_data VALUES (6037, 253, 53733, 2, 1367, 26, 75);
INSERT INTO public.who_global_data VALUES (6038, 414, 154314, 1, 943, 26, 27);
INSERT INTO public.who_global_data VALUES (6039, 107, 82380, 2, 1371, 26, 54);
INSERT INTO public.who_global_data VALUES (6040, 0, 41, 0, 0, 26, 226);
INSERT INTO public.who_global_data VALUES (6041, 616, 49568, 31, 849, 26, 79);
INSERT INTO public.who_global_data VALUES (6042, 3743, 219296, 16, 1606, 26, 56);
INSERT INTO public.who_global_data VALUES (6043, 0, 2577, 0, 50, 26, 117);
INSERT INTO public.who_global_data VALUES (6044, 0, 1800, 0, 83, 26, 152);
INSERT INTO public.who_global_data VALUES (6045, 743, 104745, 13, 1581, 26, 16);
INSERT INTO public.who_global_data VALUES (6046, 9, 2412, 0, 44, 26, 10);
INSERT INTO public.who_global_data VALUES (6047, 775, 160446, 32, 2232, 26, 201);
INSERT INTO public.who_global_data VALUES (6048, 104, 47980, 3, 533, 26, 174);
INSERT INTO public.who_global_data VALUES (6049, 0, 17767, 0, 262, 26, 119);
INSERT INTO public.who_global_data VALUES (6050, 269, 8575, 5, 225, 26, 168);
INSERT INTO public.who_global_data VALUES (6051, 2433, 135992, 9, 551, 26, 99);
INSERT INTO public.who_global_data VALUES (6052, 44, 14109, 0, 49, 26, 171);
INSERT INTO public.who_global_data VALUES (6053, 35, 7600, 3, 298, 26, 87);
INSERT INTO public.who_global_data VALUES (6054, 133, 14529, 0, 233, 26, 123);
INSERT INTO public.who_global_data VALUES (6055, 0, 4, 0, 0, 26, 151);
INSERT INTO public.who_global_data VALUES (6056, 0, 6117, 0, 43, 26, 213);
INSERT INTO public.who_global_data VALUES (6057, 298, 15512, 6, 384, 26, 118);
INSERT INTO public.who_global_data VALUES (6058, 0, 539, 0, 10, 26, 134);
INSERT INTO public.who_global_data VALUES (6059, 23, 6255, 0, 56, 26, 65);
INSERT INTO public.who_global_data VALUES (6060, 16105, 1524036, 1135, 133204, 26, 102);
INSERT INTO public.who_global_data VALUES (6061, 0, 0, 0, 0, 26, 223);
INSERT INTO public.who_global_data VALUES (6062, 4, 1060, 0, 5, 26, 4);
INSERT INTO public.who_global_data VALUES (6063, 21, 1429, 0, 1, 26, 146);
INSERT INTO public.who_global_data VALUES (6064, 515, 53259, 4, 729, 26, 31);
INSERT INTO public.who_global_data VALUES (6065, 0, 13, 0, 1, 26, 127);
INSERT INTO public.who_global_data VALUES (6066, 895, 452532, 34, 7743, 26, 22);
INSERT INTO public.who_global_data VALUES (6067, 578, 21939, 5, 192, 26, 115);
INSERT INTO public.who_global_data VALUES (6068, 555, 130604, 20, 2846, 26, 106);
INSERT INTO public.who_global_data VALUES (6069, 536, 28259, 3, 254, 26, 90);
INSERT INTO public.who_global_data VALUES (6070, 0, 0, 0, 0, 26, 70);
INSERT INTO public.who_global_data VALUES (6071, 259, 264780, 5, 1917, 26, 46);
INSERT INTO public.who_global_data VALUES (6072, 6610, 871955, 53, 12339, 26, 139);
INSERT INTO public.who_global_data VALUES (6073, 0, 40, 0, 0, 26, 42);
INSERT INTO public.who_global_data VALUES (6074, 4, 1865, 0, 25, 26, 80);
INSERT INTO public.who_global_data VALUES (6075, 0, 4867, 0, 166, 26, 203);
INSERT INTO public.who_global_data VALUES (6076, 555, 3877, 22, 126, 26, 136);
INSERT INTO public.who_global_data VALUES (6077, 2609, 100087, 16, 1358, 26, 63);
INSERT INTO public.who_global_data VALUES (6078, 0, 0, 0, 0, 26, 17);
INSERT INTO public.who_global_data VALUES (6079, 0, 125, 0, 2, 26, 172);
INSERT INTO public.who_global_data VALUES (6080, 344, 86494, 8, 2622, 26, 109);
INSERT INTO public.who_global_data VALUES (6081, 1681, 55473, 7, 478, 26, 200);
INSERT INTO public.who_global_data VALUES (6082, 699, 165949, 21, 1756, 26, 93);
INSERT INTO public.who_global_data VALUES (6083, 538, 130608, 3, 1508, 26, 5);
INSERT INTO public.who_global_data VALUES (6084, 0, 745, 0, 13, 26, 214);
INSERT INTO public.who_global_data VALUES (6085, 2899, 502416, 46, 10644, 26, 204);
INSERT INTO public.who_global_data VALUES (6086, 0, 0, 0, 0, 26, 198);
INSERT INTO public.who_global_data VALUES (6087, 3735, 276772, 47, 4410, 26, 173);
INSERT INTO public.who_global_data VALUES (6088, 0, 811, 0, 9, 26, 229);
INSERT INTO public.who_global_data VALUES (6089, 1032, 115026, 15, 2387, 26, 76);
INSERT INTO public.who_global_data VALUES (6090, 2804, 1032275, 68, 38213, 26, 138);
INSERT INTO public.who_global_data VALUES (6091, 1893, 487690, 7, 9405, 26, 98);
INSERT INTO public.who_global_data VALUES (6092, 0, 0, 0, 0, 26, 103);
INSERT INTO public.who_global_data VALUES (6093, 4863, 1390385, 75, 31264, 26, 225);
INSERT INTO public.who_global_data VALUES (6094, 7502, 483689, 102, 7803, 26, 131);
INSERT INTO public.who_global_data VALUES (6095, 489, 83119, 14, 1630, 26, 235);
INSERT INTO public.who_global_data VALUES (6096, 193, 145865, 0, 246, 26, 137);
INSERT INTO public.who_global_data VALUES (6097, 451, 69099, 15, 1140, 26, 81);
INSERT INTO public.who_global_data VALUES (6098, 298, 149391, 9, 3139, 26, 182);
INSERT INTO public.who_global_data VALUES (6099, 112, 9359, 0, 42, 26, 145);
INSERT INTO public.who_global_data VALUES (6100, 3082, 671284, 62, 16654, 26, 26);
INSERT INTO public.who_global_data VALUES (6101, 23315, 3425269, 436, 62273, 26, 170);
INSERT INTO public.who_global_data VALUES (6102, 169, 9630, 2, 120, 26, 191);
INSERT INTO public.who_global_data VALUES (6103, 0, 5, 0, 0, 26, 221);
INSERT INTO public.who_global_data VALUES (6104, 0, 191, 0, 0, 26, 64);
INSERT INTO public.who_global_data VALUES (6105, 0, 0, 0, 0, 26, 116);
INSERT INTO public.who_global_data VALUES (6106, 0, 34, 0, 0, 26, 128);
INSERT INTO public.who_global_data VALUES (6107, 43, 438, 0, 5, 26, 6);
INSERT INTO public.who_global_data VALUES (6108, 0, 1002, 0, 12, 26, 227);
INSERT INTO public.who_global_data VALUES (6109, 0, 16, 0, 0, 26, 68);
INSERT INTO public.who_global_data VALUES (6110, 21, 225, 0, 0, 26, 184);
INSERT INTO public.who_global_data VALUES (6111, 0, 2, 0, 0, 26, 82);
INSERT INTO public.who_global_data VALUES (6112, 0, 2650, 0, 64, 26, 149);
INSERT INTO public.who_global_data VALUES (6113, 12, 1066, 0, 17, 26, 197);
INSERT INTO public.who_global_data VALUES (6114, 117, 363809, 5, 6291, 26, 78);
INSERT INTO public.who_global_data VALUES (6115, 245, 21245, 6, 465, 26, 233);
INSERT INTO public.who_global_data VALUES (6116, 1795, 359689, 34, 3582, 26, 133);
INSERT INTO public.who_global_data VALUES (6117, 23, 525, 0, 1, 26, 35);
INSERT INTO public.who_global_data VALUES (6118, 31, 2834, 0, 77, 26, 114);
INSERT INTO public.who_global_data VALUES (6119, 42, 58907, 0, 29, 26, 237);
INSERT INTO public.who_global_data VALUES (6120, 0, 19, 0, 0, 26, 55);
INSERT INTO public.who_global_data VALUES (6121, 0, 1531, 0, 27, 26, 176);
INSERT INTO public.who_global_data VALUES (6122, 860, 209069, 89, 3007, 26, 202);
INSERT INTO public.who_global_data VALUES (6123, 428, 139784, 19, 3319, 26, 155);
INSERT INTO public.who_global_data VALUES (6124, 0, 17, 0, 0, 26, 32);
INSERT INTO public.who_global_data VALUES (6125, 0, 4726, 0, 130, 26, 220);
INSERT INTO public.who_global_data VALUES (6126, 17421, 1231597, 339, 33163, 26, 30);
INSERT INTO public.who_global_data VALUES (6127, 9, 3649, 0, 63, 26, 147);
INSERT INTO public.who_global_data VALUES (6128, 18564, 2187518, 169, 53374, 26, 208);
INSERT INTO public.who_global_data VALUES (6129, 540, 48380, 3, 232, 26, 45);
INSERT INTO public.who_global_data VALUES (6130, 125, 27619, 9, 1666, 26, 110);
INSERT INTO public.who_global_data VALUES (6131, 94, 6948, 1, 132, 26, 88);
INSERT INTO public.who_global_data VALUES (6132, 4737, 499831, 87, 10666, 26, 51);
INSERT INTO public.who_global_data VALUES (6133, 1293, 482774, 54, 7885, 26, 209);
INSERT INTO public.who_global_data VALUES (6134, 90, 12364, 6, 774, 26, 205);
INSERT INTO public.who_global_data VALUES (6135, 1, 13708, 0, 91, 26, 18);
INSERT INTO public.who_global_data VALUES (6136, 249, 10547, 0, 67, 26, 72);
INSERT INTO public.who_global_data VALUES (6137, 54940, 3072353, 563, 81431, 26, 44);
INSERT INTO public.who_global_data VALUES (6138, 0, 49, 0, 0, 26, 15);
INSERT INTO public.who_global_data VALUES (6139, 25, 3957, 0, 72, 26, 25);
INSERT INTO public.who_global_data VALUES (6140, 0, 0, 0, 0, 26, 179);
INSERT INTO public.who_global_data VALUES (6141, 0, 0, 0, 0, 26, 34);
INSERT INTO public.who_global_data VALUES (6142, 25, 7244, 1, 128, 26, 207);
INSERT INTO public.who_global_data VALUES (6143, 1762, 159276, 62, 5215, 26, 166);
INSERT INTO public.who_global_data VALUES (6144, 9138, 2326256, 176, 22807, 26, 126);
INSERT INTO public.who_global_data VALUES (6145, 0, 0, 0, 0, 26, 97);
INSERT INTO public.who_global_data VALUES (6146, 29, 994, 0, 6, 26, 36);
INSERT INTO public.who_global_data VALUES (6147, 0, 0, 0, 0, 26, 125);
INSERT INTO public.who_global_data VALUES (6148, 188, 37742, 0, 301, 26, 124);
INSERT INTO public.who_global_data VALUES (6149, 4288, 1119314, 68, 19835, 26, 185);
INSERT INTO public.who_global_data VALUES (6150, 2876, 230578, 6, 708, 26, 194);
INSERT INTO public.who_global_data VALUES (6151, 0, 509, 0, 21, 26, 144);
INSERT INTO public.who_global_data VALUES (6152, 248089, 22009275, 3418, 369304, 26, 19);
INSERT INTO public.who_global_data VALUES (6153, 0, 2143, 0, 24, 26, 217);
INSERT INTO public.who_global_data VALUES (6154, 635, 24974, 8, 248, 26, 148);
INSERT INTO public.who_global_data VALUES (6155, 39, 77611, 0, 617, 26, 86);
INSERT INTO public.who_global_data VALUES (6156, 0, 1, 0, 0, 26, 13);
INSERT INTO public.who_global_data VALUES (6157, 505, 116172, 5, 1061, 26, 157);
INSERT INTO public.who_global_data VALUES (6158, 1, 1514, 0, 35, 26, 8);
INSERT INTO public.who_global_data VALUES (6159, 0, 4, 0, 0, 26, 73);
INSERT INTO public.who_global_data VALUES (6160, 0, 2108, 1, 612, 26, 101);
INSERT INTO public.who_global_data VALUES (6161, 1161, 27728, 5, 469, 26, 165);
INSERT INTO public.who_global_data VALUES (6162, 978, 21477, 24, 507, 26, 14);
INSERT INTO public.who_global_data VALUES (6163, 89, 53489, 13, 2277, 27, 193);
INSERT INTO public.who_global_data VALUES (6164, 655, 63033, 3, 1233, 27, 113);
INSERT INTO public.who_global_data VALUES (6165, 256, 101913, 5, 2803, 27, 143);
INSERT INTO public.who_global_data VALUES (6166, 0, 0, 0, 0, 27, 219);
INSERT INTO public.who_global_data VALUES (6167, 97, 8586, 1, 85, 27, 186);
INSERT INTO public.who_global_data VALUES (6168, 90, 18156, 1, 416, 27, 52);
INSERT INTO public.who_global_data VALUES (6169, 0, 15, 0, 0, 27, 180);
INSERT INTO public.who_global_data VALUES (6170, 2, 169, 0, 5, 27, 167);
INSERT INTO public.who_global_data VALUES (6171, 13346, 1703352, 151, 44273, 27, 154);
INSERT INTO public.who_global_data VALUES (6172, 337, 162131, 7, 2929, 27, 94);
INSERT INTO public.who_global_data VALUES (6173, 0, 5883, 0, 50, 27, 66);
INSERT INTO public.who_global_data VALUES (6174, 11, 28582, 0, 909, 27, 58);
INSERT INTO public.who_global_data VALUES (6175, 2446, 378110, 42, 6614, 27, 163);
INSERT INTO public.who_global_data VALUES (6176, 633, 224050, 21, 2890, 27, 37);
INSERT INTO public.who_global_data VALUES (6177, 8, 7977, 0, 175, 27, 142);
INSERT INTO public.who_global_data VALUES (6178, 287, 95317, 1, 355, 27, 83);
INSERT INTO public.who_global_data VALUES (6179, 692, 521382, 22, 7756, 27, 228);
INSERT INTO public.who_global_data VALUES (6180, 28, 808, 0, 7, 27, 188);
INSERT INTO public.who_global_data VALUES (6181, 1767, 210368, 9, 1507, 27, 62);
INSERT INTO public.who_global_data VALUES (6182, 1393, 665556, 51, 20076, 27, 160);
INSERT INTO public.who_global_data VALUES (6183, 50, 11202, 4, 271, 27, 50);
INSERT INTO public.who_global_data VALUES (6184, 0, 3304, 0, 44, 27, 33);
INSERT INTO public.who_global_data VALUES (6185, 5, 646, 0, 12, 27, 183);
INSERT INTO public.who_global_data VALUES (6186, 39, 810, 0, 1, 27, 92);
INSERT INTO public.who_global_data VALUES (6187, 2263, 171154, 24, 9328, 27, 158);
INSERT INTO public.who_global_data VALUES (6188, 0, 254, 0, 3, 27, 67);
INSERT INTO public.who_global_data VALUES (6189, 459, 115379, 20, 4305, 27, 57);
INSERT INTO public.who_global_data VALUES (6190, 0, 16051, 0, 48, 27, 38);
INSERT INTO public.who_global_data VALUES (6191, 52035, 8013708, 962, 201460, 27, 141);
INSERT INTO public.who_global_data VALUES (6192, 0, 114, 0, 1, 27, 178);
INSERT INTO public.who_global_data VALUES (6193, 0, 173, 0, 3, 27, 108);
INSERT INTO public.who_global_data VALUES (6194, 394, 208406, 19, 8097, 27, 39);
INSERT INTO public.who_global_data VALUES (6195, 0, 7866, 0, 89, 27, 2);
INSERT INTO public.who_global_data VALUES (6196, 101, 986, 0, 2, 27, 195);
INSERT INTO public.who_global_data VALUES (6197, 0, 12237, 0, 114, 27, 107);
INSERT INTO public.who_global_data VALUES (6198, 4, 391, 0, 0, 27, 161);
INSERT INTO public.who_global_data VALUES (6199, 0, 26848, 0, 448, 27, 212);
INSERT INTO public.who_global_data VALUES (6200, 9214, 644348, 128, 16707, 27, 181);
INSERT INTO public.who_global_data VALUES (6201, 0, 359, 0, 2, 27, 53);
INSERT INTO public.who_global_data VALUES (6202, 4, 4973, 0, 63, 27, 164);
INSERT INTO public.who_global_data VALUES (6203, 91, 2510, 1, 107, 27, 140);
INSERT INTO public.who_global_data VALUES (6204, 4361, 637742, 63, 17037, 27, 20);
INSERT INTO public.who_global_data VALUES (6205, 131, 97518, 2, 4798, 27, 112);
INSERT INTO public.who_global_data VALUES (6206, 18221, 1755568, 364, 45431, 27, 111);
INSERT INTO public.who_global_data VALUES (6207, 286, 1150, 5, 18, 27, 71);
INSERT INTO public.who_global_data VALUES (6208, 0, 7160, 0, 100, 27, 218);
INSERT INTO public.who_global_data VALUES (6209, 0, 0, 0, 0, 27, 43);
INSERT INTO public.who_global_data VALUES (6210, 1207, 177614, 19, 2305, 27, 49);
INSERT INTO public.who_global_data VALUES (6211, 81, 23254, 0, 138, 27, 1);
INSERT INTO public.who_global_data VALUES (6212, 646, 219993, 26, 4368, 27, 48);
INSERT INTO public.who_global_data VALUES (6213, 365, 14188, 0, 148, 27, 232);
INSERT INTO public.who_global_data VALUES (6214, 0, 4405, 0, 18, 27, 175);
INSERT INTO public.who_global_data VALUES (6215, 337, 27011, 6, 147, 27, 21);
INSERT INTO public.who_global_data VALUES (6216, 8449, 831165, 137, 13115, 27, 156);
INSERT INTO public.who_global_data VALUES (6217, 0, 0, 0, 0, 27, 95);
INSERT INTO public.who_global_data VALUES (6218, 231, 18967, 0, 610, 27, 177);
INSERT INTO public.who_global_data VALUES (6219, 1743, 180240, 25, 1542, 27, 210);
INSERT INTO public.who_global_data VALUES (6220, 1, 5866, 0, 61, 27, 120);
INSERT INTO public.who_global_data VALUES (6221, 0, 106, 0, 0, 27, 135);
INSERT INTO public.who_global_data VALUES (6222, 2106, 180644, 0, 2424, 27, 206);
INSERT INTO public.who_global_data VALUES (6223, 1201, 220349, 12, 14177, 27, 189);
INSERT INTO public.who_global_data VALUES (6224, 989, 148799, 57, 8142, 27, 129);
INSERT INTO public.who_global_data VALUES (6225, 319, 48574, 10, 1408, 27, 121);
INSERT INTO public.who_global_data VALUES (6226, 0, 5289, 0, 86, 27, 59);
INSERT INTO public.who_global_data VALUES (6227, 0, 1556, 0, 6, 27, 96);
INSERT INTO public.who_global_data VALUES (6228, 427, 33516, 5, 283, 27, 41);
INSERT INTO public.who_global_data VALUES (6229, 207, 11180, 12, 291, 27, 216);
INSERT INTO public.who_global_data VALUES (6230, 220, 127792, 11, 1985, 27, 236);
INSERT INTO public.who_global_data VALUES (6231, 0, 29, 0, 0, 27, 150);
INSERT INTO public.who_global_data VALUES (6232, 2, 646, 0, 1, 27, 61);
INSERT INTO public.who_global_data VALUES (6233, 0, 53, 0, 2, 27, 7);
INSERT INTO public.who_global_data VALUES (6234, 324, 38392, 0, 586, 27, 169);
INSERT INTO public.who_global_data VALUES (6235, 20034, 2721692, 168, 67217, 27, 28);
INSERT INTO public.who_global_data VALUES (6236, 143, 14113, 0, 74, 27, 85);
INSERT INTO public.who_global_data VALUES (6237, 0, 17241, 0, 122, 27, 211);
INSERT INTO public.who_global_data VALUES (6238, 0, 9694, 0, 66, 27, 60);
INSERT INTO public.who_global_data VALUES (6239, 16, 3857, 0, 125, 27, 3);
INSERT INTO public.who_global_data VALUES (6240, 1143, 239229, 23, 2773, 27, 11);
INSERT INTO public.who_global_data VALUES (6241, 16946, 1908527, 465, 40343, 27, 89);
INSERT INTO public.who_global_data VALUES (6242, 311, 55772, 0, 336, 27, 24);
INSERT INTO public.who_global_data VALUES (6243, 93, 3021, 1, 12, 27, 162);
INSERT INTO public.who_global_data VALUES (6244, 799, 144293, 32, 5227, 27, 100);
INSERT INTO public.who_global_data VALUES (6245, 0, 29, 0, 0, 27, 47);
INSERT INTO public.who_global_data VALUES (6246, 4, 135, 0, 1, 27, 29);
INSERT INTO public.who_global_data VALUES (6247, 0, 8702, 0, 155, 27, 40);
INSERT INTO public.who_global_data VALUES (6248, 5, 7218, 0, 124, 27, 222);
INSERT INTO public.who_global_data VALUES (6249, 1063, 143127, 27, 4999, 27, 132);
INSERT INTO public.who_global_data VALUES (6250, 0, 302, 0, 13, 27, 130);
INSERT INTO public.who_global_data VALUES (6251, 0, 13904, 0, 81, 27, 234);
INSERT INTO public.who_global_data VALUES (6252, 0, 2447, 0, 45, 27, 23);
INSERT INTO public.who_global_data VALUES (6253, 0, 6469, 0, 167, 27, 192);
INSERT INTO public.who_global_data VALUES (6254, 0, 10241, 0, 237, 27, 69);
INSERT INTO public.who_global_data VALUES (6255, 0, 26, 0, 0, 27, 187);
INSERT INTO public.who_global_data VALUES (6256, 839, 126396, 22, 3266, 27, 230);
INSERT INTO public.who_global_data VALUES (6257, 1778, 342237, 94, 10648, 27, 77);
INSERT INTO public.who_global_data VALUES (6258, 13, 5880, 0, 29, 27, 9);
INSERT INTO public.who_global_data VALUES (6259, 36867, 10450284, 429, 150999, 27, 74);
INSERT INTO public.who_global_data VALUES (6260, 10046, 818386, 194, 23947, 27, 224);
INSERT INTO public.who_global_data VALUES (6261, 5924, 1280438, 82, 56100, 27, 199);
INSERT INTO public.who_global_data VALUES (6262, 907, 602331, 4, 12881, 27, 190);
INSERT INTO public.who_global_data VALUES (6263, 4843, 140727, 9, 2336, 27, 12);
INSERT INTO public.who_global_data VALUES (6264, 1, 392, 0, 25, 27, 104);
INSERT INTO public.who_global_data VALUES (6265, 8159, 481478, 48, 3652, 27, 153);
INSERT INTO public.who_global_data VALUES (6266, 19976, 2257866, 483, 78394, 27, 91);
INSERT INTO public.who_global_data VALUES (6267, 44, 13455, 4, 311, 27, 215);
INSERT INTO public.who_global_data VALUES (6268, 7621, 280775, 64, 3996, 27, 84);
INSERT INTO public.who_global_data VALUES (6269, 13, 2921, 1, 57, 27, 231);
INSERT INTO public.who_global_data VALUES (6270, 796, 305959, 20, 4009, 27, 196);
INSERT INTO public.who_global_data VALUES (6271, 773, 209369, 40, 2885, 27, 105);
INSERT INTO public.who_global_data VALUES (6272, 230, 98184, 1, 1704, 27, 122);
INSERT INTO public.who_global_data VALUES (6273, 0, 0, 0, 0, 27, 159);
INSERT INTO public.who_global_data VALUES (6274, 259, 53480, 7, 1365, 27, 75);
INSERT INTO public.who_global_data VALUES (6275, 427, 153900, 2, 942, 27, 27);
INSERT INTO public.who_global_data VALUES (6276, 135, 82273, 2, 1369, 27, 54);
INSERT INTO public.who_global_data VALUES (6277, 0, 41, 0, 0, 27, 226);
INSERT INTO public.who_global_data VALUES (6278, 1170, 48952, 17, 818, 27, 79);
INSERT INTO public.who_global_data VALUES (6279, 5414, 215553, 20, 1590, 27, 56);
INSERT INTO public.who_global_data VALUES (6280, 0, 2577, 0, 50, 27, 117);
INSERT INTO public.who_global_data VALUES (6281, 0, 1800, 0, 83, 27, 152);
INSERT INTO public.who_global_data VALUES (6282, 0, 104002, 0, 1568, 27, 16);
INSERT INTO public.who_global_data VALUES (6283, 8, 2403, 0, 44, 27, 10);
INSERT INTO public.who_global_data VALUES (6284, 1489, 159671, 27, 2200, 27, 201);
INSERT INTO public.who_global_data VALUES (6285, 136, 47876, 3, 530, 27, 174);
INSERT INTO public.who_global_data VALUES (6286, 0, 17767, 0, 262, 27, 119);
INSERT INTO public.who_global_data VALUES (6287, 381, 8306, 12, 220, 27, 168);
INSERT INTO public.who_global_data VALUES (6288, 2451, 133559, 5, 542, 27, 99);
INSERT INTO public.who_global_data VALUES (6289, 25, 14065, 0, 49, 27, 171);
INSERT INTO public.who_global_data VALUES (6290, 138, 7565, 9, 295, 27, 87);
INSERT INTO public.who_global_data VALUES (6291, 184, 14396, 1, 233, 27, 123);
INSERT INTO public.who_global_data VALUES (6292, 0, 4, 0, 0, 27, 151);
INSERT INTO public.who_global_data VALUES (6293, 0, 6117, 0, 43, 27, 213);
INSERT INTO public.who_global_data VALUES (6294, 0, 15214, 0, 378, 27, 118);
INSERT INTO public.who_global_data VALUES (6295, 0, 539, 0, 10, 27, 134);
INSERT INTO public.who_global_data VALUES (6296, 0, 6232, 0, 56, 27, 65);
INSERT INTO public.who_global_data VALUES (6297, 14362, 1507931, 1038, 132069, 27, 102);
INSERT INTO public.who_global_data VALUES (6298, 0, 0, 0, 0, 27, 223);
INSERT INTO public.who_global_data VALUES (6299, 12, 1056, 0, 5, 27, 4);
INSERT INTO public.who_global_data VALUES (6300, 13, 1408, 0, 1, 27, 146);
INSERT INTO public.who_global_data VALUES (6301, 343, 52744, 4, 725, 27, 31);
INSERT INTO public.who_global_data VALUES (6302, 0, 13, 0, 1, 27, 127);
INSERT INTO public.who_global_data VALUES (6303, 1416, 451637, 24, 7709, 27, 22);
INSERT INTO public.who_global_data VALUES (6304, 879, 21361, 6, 187, 27, 115);
INSERT INTO public.who_global_data VALUES (6305, 566, 130049, 14, 2826, 27, 106);
INSERT INTO public.who_global_data VALUES (6306, 468, 27723, 11, 251, 27, 90);
INSERT INTO public.who_global_data VALUES (6307, 0, 0, 0, 0, 27, 70);
INSERT INTO public.who_global_data VALUES (6308, 362, 264521, 3, 1912, 27, 46);
INSERT INTO public.who_global_data VALUES (6309, 7341, 865345, 138, 12286, 27, 139);
INSERT INTO public.who_global_data VALUES (6310, 0, 40, 0, 0, 27, 42);
INSERT INTO public.who_global_data VALUES (6311, 29, 1861, 0, 25, 27, 80);
INSERT INTO public.who_global_data VALUES (6312, 0, 4867, 0, 166, 27, 203);
INSERT INTO public.who_global_data VALUES (6313, 0, 3322, 0, 104, 27, 136);
INSERT INTO public.who_global_data VALUES (6314, 0, 97478, 0, 1342, 27, 63);
INSERT INTO public.who_global_data VALUES (6315, 0, 0, 0, 0, 27, 17);
INSERT INTO public.who_global_data VALUES (6316, 0, 125, 0, 2, 27, 172);
INSERT INTO public.who_global_data VALUES (6317, 556, 86150, 22, 2614, 27, 109);
INSERT INTO public.who_global_data VALUES (6318, 0, 53792, 0, 471, 27, 200);
INSERT INTO public.who_global_data VALUES (6319, 855, 165250, 28, 1735, 27, 93);
INSERT INTO public.who_global_data VALUES (6320, 0, 130070, 0, 1505, 27, 5);
INSERT INTO public.who_global_data VALUES (6321, 0, 745, 0, 13, 27, 214);
INSERT INTO public.who_global_data VALUES (6322, 2007, 499517, 40, 10598, 27, 204);
INSERT INTO public.who_global_data VALUES (6323, 0, 0, 0, 0, 27, 198);
INSERT INTO public.who_global_data VALUES (6324, 3946, 273037, 42, 4363, 27, 173);
INSERT INTO public.who_global_data VALUES (6325, 0, 811, 0, 9, 27, 229);
INSERT INTO public.who_global_data VALUES (6326, 1138, 113994, 20, 2372, 27, 76);
INSERT INTO public.who_global_data VALUES (6327, 2781, 1029471, 96, 38145, 27, 138);
INSERT INTO public.who_global_data VALUES (6328, 1945, 485797, 34, 9398, 27, 98);
INSERT INTO public.who_global_data VALUES (6329, 0, 0, 0, 0, 27, 103);
INSERT INTO public.who_global_data VALUES (6330, 9133, 1385522, 178, 31189, 27, 225);
INSERT INTO public.who_global_data VALUES (6331, 9478, 476187, 111, 7701, 27, 131);
INSERT INTO public.who_global_data VALUES (6332, 563, 82630, 24, 1616, 27, 235);
INSERT INTO public.who_global_data VALUES (6333, 206, 145672, 0, 246, 27, 137);
INSERT INTO public.who_global_data VALUES (6334, 657, 68648, 25, 1125, 27, 81);
INSERT INTO public.who_global_data VALUES (6335, 424, 149093, 8, 3130, 27, 182);
INSERT INTO public.who_global_data VALUES (6336, 0, 9247, 0, 42, 27, 145);
INSERT INTO public.who_global_data VALUES (6337, 4423, 668202, 86, 16592, 27, 26);
INSERT INTO public.who_global_data VALUES (6338, 22851, 3401954, 456, 61837, 27, 170);
INSERT INTO public.who_global_data VALUES (6339, 403, 9461, 6, 118, 27, 191);
INSERT INTO public.who_global_data VALUES (6340, 0, 5, 0, 0, 27, 221);
INSERT INTO public.who_global_data VALUES (6341, 0, 191, 0, 0, 27, 64);
INSERT INTO public.who_global_data VALUES (6342, 0, 0, 0, 0, 27, 116);
INSERT INTO public.who_global_data VALUES (6343, 0, 34, 0, 0, 27, 128);
INSERT INTO public.who_global_data VALUES (6344, 12, 395, 0, 5, 27, 6);
INSERT INTO public.who_global_data VALUES (6345, 0, 1002, 0, 12, 27, 227);
INSERT INTO public.who_global_data VALUES (6346, 0, 16, 0, 0, 27, 68);
INSERT INTO public.who_global_data VALUES (6347, 0, 204, 0, 0, 27, 184);
INSERT INTO public.who_global_data VALUES (6348, 0, 2, 0, 0, 27, 82);
INSERT INTO public.who_global_data VALUES (6349, 22, 2650, 0, 64, 27, 149);
INSERT INTO public.who_global_data VALUES (6350, 0, 1054, 0, 17, 27, 197);
INSERT INTO public.who_global_data VALUES (6351, 110, 363692, 4, 6286, 27, 78);
INSERT INTO public.who_global_data VALUES (6352, 328, 21000, 13, 459, 27, 233);
INSERT INTO public.who_global_data VALUES (6353, 1769, 357894, 35, 3548, 27, 133);
INSERT INTO public.who_global_data VALUES (6354, 54, 502, 0, 1, 27, 35);
INSERT INTO public.who_global_data VALUES (6355, 21, 2803, 0, 77, 27, 114);
INSERT INTO public.who_global_data VALUES (6356, 29, 58865, 0, 29, 27, 237);
INSERT INTO public.who_global_data VALUES (6357, 0, 19, 0, 0, 27, 55);
INSERT INTO public.who_global_data VALUES (6358, 0, 1531, 0, 27, 27, 176);
INSERT INTO public.who_global_data VALUES (6359, 2973, 208209, 82, 2918, 27, 202);
INSERT INTO public.who_global_data VALUES (6360, 762, 139356, 33, 3300, 27, 155);
INSERT INTO public.who_global_data VALUES (6361, 0, 17, 0, 0, 27, 32);
INSERT INTO public.who_global_data VALUES (6362, 0, 4726, 0, 130, 27, 220);
INSERT INTO public.who_global_data VALUES (6363, 21606, 1214176, 399, 32824, 27, 30);
INSERT INTO public.who_global_data VALUES (6364, 36, 3640, 0, 63, 27, 147);
INSERT INTO public.who_global_data VALUES (6365, 31500, 2168954, 187, 53205, 27, 208);
INSERT INTO public.who_global_data VALUES (6366, 535, 47840, 7, 229, 27, 45);
INSERT INTO public.who_global_data VALUES (6367, 1215, 27494, 54, 1657, 27, 110);
INSERT INTO public.who_global_data VALUES (6368, 104, 6854, 1, 131, 27, 88);
INSERT INTO public.who_global_data VALUES (6369, 5699, 495094, 99, 10579, 27, 51);
INSERT INTO public.who_global_data VALUES (6370, 1681, 481481, 61, 7831, 27, 209);
INSERT INTO public.who_global_data VALUES (6371, 95, 12274, 5, 768, 27, 205);
INSERT INTO public.who_global_data VALUES (6372, 1, 13707, 0, 91, 27, 18);
INSERT INTO public.who_global_data VALUES (6373, 457, 10298, 0, 67, 27, 72);
INSERT INTO public.who_global_data VALUES (6374, 59937, 3017413, 1035, 80868, 27, 44);
INSERT INTO public.who_global_data VALUES (6375, 0, 49, 0, 0, 27, 15);
INSERT INTO public.who_global_data VALUES (6376, 87, 3932, 0, 72, 27, 25);
INSERT INTO public.who_global_data VALUES (6377, 0, 0, 0, 0, 27, 179);
INSERT INTO public.who_global_data VALUES (6378, 0, 0, 0, 0, 27, 34);
INSERT INTO public.who_global_data VALUES (6379, 9, 7219, 0, 127, 27, 207);
INSERT INTO public.who_global_data VALUES (6380, 2611, 157514, 45, 5153, 27, 166);
INSERT INTO public.who_global_data VALUES (6381, 9537, 2317118, 181, 22631, 27, 126);
INSERT INTO public.who_global_data VALUES (6382, 0, 0, 0, 0, 27, 97);
INSERT INTO public.who_global_data VALUES (6383, 9, 965, 0, 6, 27, 36);
INSERT INTO public.who_global_data VALUES (6384, 0, 0, 0, 0, 27, 125);
INSERT INTO public.who_global_data VALUES (6385, 258, 37554, 1, 301, 27, 124);
INSERT INTO public.who_global_data VALUES (6386, 5011, 1115026, 99, 19767, 27, 185);
INSERT INTO public.who_global_data VALUES (6387, 2998, 227702, 5, 702, 27, 194);
INSERT INTO public.who_global_data VALUES (6388, 0, 509, 0, 21, 27, 144);
INSERT INTO public.who_global_data VALUES (6389, 313516, 21761186, 3599, 365886, 27, 19);
INSERT INTO public.who_global_data VALUES (6390, 13, 2143, 0, 24, 27, 217);
INSERT INTO public.who_global_data VALUES (6391, 532, 24339, 9, 240, 27, 148);
INSERT INTO public.who_global_data VALUES (6392, 42, 77572, 1, 617, 27, 86);
INSERT INTO public.who_global_data VALUES (6393, 0, 1, 0, 0, 27, 13);
INSERT INTO public.who_global_data VALUES (6394, 345, 115667, 4, 1056, 27, 157);
INSERT INTO public.who_global_data VALUES (6395, 1, 1513, 0, 35, 27, 8);
INSERT INTO public.who_global_data VALUES (6396, 0, 4, 0, 0, 27, 73);
INSERT INTO public.who_global_data VALUES (6397, 0, 2108, 0, 611, 27, 101);
INSERT INTO public.who_global_data VALUES (6398, 1241, 26567, 23, 464, 27, 165);
INSERT INTO public.who_global_data VALUES (6399, 839, 20499, 15, 483, 27, 14);
INSERT INTO public.who_global_data VALUES (6400, 68, 53400, 7, 2264, 28, 193);
INSERT INTO public.who_global_data VALUES (6401, 673, 62378, 7, 1230, 28, 113);
INSERT INTO public.who_global_data VALUES (6402, 537, 101657, 12, 2798, 28, 143);
INSERT INTO public.who_global_data VALUES (6403, 0, 0, 0, 0, 28, 219);
INSERT INTO public.who_global_data VALUES (6404, 141, 8489, 0, 84, 28, 186);
INSERT INTO public.who_global_data VALUES (6405, 92, 18066, 2, 415, 28, 52);
INSERT INTO public.who_global_data VALUES (6406, 0, 15, 0, 0, 28, 180);
INSERT INTO public.who_global_data VALUES (6407, 4, 167, 0, 5, 28, 167);
INSERT INTO public.who_global_data VALUES (6408, 13835, 1690006, 146, 44122, 28, 154);
INSERT INTO public.who_global_data VALUES (6409, 379, 161794, 14, 2922, 28, 94);
INSERT INTO public.who_global_data VALUES (6410, 72, 5883, 0, 50, 28, 66);
INSERT INTO public.who_global_data VALUES (6411, 24, 28571, 0, 909, 28, 58);
INSERT INTO public.who_global_data VALUES (6412, 2001, 375664, 68, 6572, 28, 163);
INSERT INTO public.who_global_data VALUES (6413, 532, 223417, 24, 2869, 28, 37);
INSERT INTO public.who_global_data VALUES (6414, 10, 7969, 0, 175, 28, 142);
INSERT INTO public.who_global_data VALUES (6415, 397, 95030, 1, 354, 28, 83);
INSERT INTO public.who_global_data VALUES (6416, 785, 520690, 16, 7734, 28, 228);
INSERT INTO public.who_global_data VALUES (6417, 37, 780, 0, 7, 28, 188);
INSERT INTO public.who_global_data VALUES (6418, 1805, 208601, 9, 1498, 28, 62);
INSERT INTO public.who_global_data VALUES (6419, 2015, 664163, 48, 20025, 28, 160);
INSERT INTO public.who_global_data VALUES (6420, 44, 11152, 7, 267, 28, 50);
INSERT INTO public.who_global_data VALUES (6421, 0, 3304, 0, 44, 28, 33);
INSERT INTO public.who_global_data VALUES (6422, 5, 641, 1, 12, 28, 183);
INSERT INTO public.who_global_data VALUES (6423, 4, 771, 1, 1, 28, 92);
INSERT INTO public.who_global_data VALUES (6424, 1910, 168891, 17, 9304, 28, 158);
INSERT INTO public.who_global_data VALUES (6425, 5, 254, 0, 3, 28, 67);
INSERT INTO public.who_global_data VALUES (6426, 518, 114920, 21, 4285, 28, 57);
INSERT INTO public.who_global_data VALUES (6427, 611, 16051, 3, 48, 28, 38);
INSERT INTO public.who_global_data VALUES (6428, 87843, 7961673, 1524, 200498, 28, 141);
INSERT INTO public.who_global_data VALUES (6429, 7, 114, 0, 1, 28, 178);
INSERT INTO public.who_global_data VALUES (6430, 0, 173, 0, 3, 28, 108);
INSERT INTO public.who_global_data VALUES (6431, 753, 208012, 61, 8078, 28, 39);
INSERT INTO public.who_global_data VALUES (6432, 153, 7866, 0, 89, 28, 2);
INSERT INTO public.who_global_data VALUES (6433, 0, 885, 0, 2, 28, 195);
INSERT INTO public.who_global_data VALUES (6434, 91, 12237, 1, 114, 28, 107);
INSERT INTO public.who_global_data VALUES (6435, 1, 387, 0, 0, 28, 161);
INSERT INTO public.who_global_data VALUES (6436, 0, 26848, 0, 448, 28, 212);
INSERT INTO public.who_global_data VALUES (6437, 8335, 635134, 210, 16579, 28, 181);
INSERT INTO public.who_global_data VALUES (6438, 3, 359, 0, 2, 28, 53);
INSERT INTO public.who_global_data VALUES (6439, 0, 4969, 0, 63, 28, 164);
INSERT INTO public.who_global_data VALUES (6440, 61, 2419, 1, 106, 28, 140);
INSERT INTO public.who_global_data VALUES (6441, 4205, 633381, 61, 16974, 28, 20);
INSERT INTO public.who_global_data VALUES (6442, 81, 97387, 1, 4796, 28, 112);
INSERT INTO public.who_global_data VALUES (6443, 17576, 1737347, 344, 45067, 28, 111);
INSERT INTO public.who_global_data VALUES (6444, 0, 864, 0, 13, 28, 71);
INSERT INTO public.who_global_data VALUES (6445, 0, 7160, 0, 100, 28, 218);
INSERT INTO public.who_global_data VALUES (6446, 0, 0, 0, 0, 28, 43);
INSERT INTO public.who_global_data VALUES (6447, 1369, 176407, 19, 2286, 28, 49);
INSERT INTO public.who_global_data VALUES (6448, 318, 23173, 0, 138, 28, 1);
INSERT INTO public.who_global_data VALUES (6449, 1401, 219347, 38, 4342, 28, 48);
INSERT INTO public.who_global_data VALUES (6450, 344, 13823, 0, 148, 28, 232);
INSERT INTO public.who_global_data VALUES (6451, 27, 4405, 1, 18, 28, 175);
INSERT INTO public.who_global_data VALUES (6452, 466, 26674, 1, 141, 28, 21);
INSERT INTO public.who_global_data VALUES (6453, 13115, 822716, 178, 12978, 28, 156);
INSERT INTO public.who_global_data VALUES (6454, 0, 0, 0, 0, 28, 95);
INSERT INTO public.who_global_data VALUES (6455, 251, 18736, 0, 610, 28, 177);
INSERT INTO public.who_global_data VALUES (6456, 1660, 178497, 30, 1517, 28, 210);
INSERT INTO public.who_global_data VALUES (6457, 8, 5865, 0, 61, 28, 120);
INSERT INTO public.who_global_data VALUES (6458, 1, 106, 0, 0, 28, 135);
INSERT INTO public.who_global_data VALUES (6459, 1045, 178538, 1, 2424, 28, 206);
INSERT INTO public.who_global_data VALUES (6460, 763, 219148, 7, 14165, 28, 189);
INSERT INTO public.who_global_data VALUES (6461, 1001, 147810, 56, 8085, 28, 129);
INSERT INTO public.who_global_data VALUES (6462, 307, 48255, 8, 1398, 28, 121);
INSERT INTO public.who_global_data VALUES (6463, 3, 5289, 0, 86, 28, 59);
INSERT INTO public.who_global_data VALUES (6464, 111, 1556, 3, 6, 28, 96);
INSERT INTO public.who_global_data VALUES (6465, 552, 33089, 8, 278, 28, 41);
INSERT INTO public.who_global_data VALUES (6466, 200, 10973, 18, 279, 28, 216);
INSERT INTO public.who_global_data VALUES (6467, 345, 127572, 8, 1974, 28, 236);
INSERT INTO public.who_global_data VALUES (6468, 0, 29, 0, 0, 28, 150);
INSERT INTO public.who_global_data VALUES (6469, 1, 644, 0, 1, 28, 61);
INSERT INTO public.who_global_data VALUES (6470, 0, 53, 0, 2, 28, 7);
INSERT INTO public.who_global_data VALUES (6471, 296, 38068, 2, 586, 28, 169);
INSERT INTO public.who_global_data VALUES (6472, 19408, 2701658, 589, 67049, 28, 28);
INSERT INTO public.who_global_data VALUES (6473, 145, 13970, 1, 74, 28, 85);
INSERT INTO public.who_global_data VALUES (6474, 46, 17241, 1, 122, 28, 211);
INSERT INTO public.who_global_data VALUES (6475, 53, 9694, 0, 66, 28, 60);
INSERT INTO public.who_global_data VALUES (6476, 3, 3841, 0, 125, 28, 3);
INSERT INTO public.who_global_data VALUES (6477, 2058, 238086, 22, 2750, 28, 11);
INSERT INTO public.who_global_data VALUES (6478, 24694, 1891581, 1083, 39878, 28, 89);
INSERT INTO public.who_global_data VALUES (6479, 0, 55461, 0, 336, 28, 24);
INSERT INTO public.who_global_data VALUES (6480, 130, 2928, 0, 11, 28, 162);
INSERT INTO public.who_global_data VALUES (6481, 717, 143494, 49, 5195, 28, 100);
INSERT INTO public.who_global_data VALUES (6482, 1, 29, 0, 0, 28, 47);
INSERT INTO public.who_global_data VALUES (6483, 1, 131, 0, 1, 28, 29);
INSERT INTO public.who_global_data VALUES (6484, 0, 8702, 0, 155, 28, 40);
INSERT INTO public.who_global_data VALUES (6485, 13, 7213, 0, 124, 28, 222);
INSERT INTO public.who_global_data VALUES (6486, 990, 142064, 44, 4972, 28, 132);
INSERT INTO public.who_global_data VALUES (6487, 0, 302, 0, 13, 28, 130);
INSERT INTO public.who_global_data VALUES (6488, 42, 13904, 0, 81, 28, 234);
INSERT INTO public.who_global_data VALUES (6489, 0, 2447, 0, 45, 28, 23);
INSERT INTO public.who_global_data VALUES (6490, 62, 6469, 1, 167, 28, 192);
INSERT INTO public.who_global_data VALUES (6491, 38, 10241, 1, 237, 28, 69);
INSERT INTO public.who_global_data VALUES (6492, 0, 26, 0, 0, 28, 187);
INSERT INTO public.who_global_data VALUES (6493, 658, 125557, 52, 3244, 28, 230);
INSERT INTO public.who_global_data VALUES (6494, 2716, 340459, 114, 10554, 28, 77);
INSERT INTO public.who_global_data VALUES (6495, 22, 5867, 0, 29, 28, 9);
INSERT INTO public.who_global_data VALUES (6496, 0, 10413417, 0, 150570, 28, 74);
INSERT INTO public.who_global_data VALUES (6497, 10617, 808340, 233, 23753, 28, 224);
INSERT INTO public.who_global_data VALUES (6498, 6251, 1274514, 85, 56018, 28, 199);
INSERT INTO public.who_global_data VALUES (6499, 669, 601424, 8, 12877, 28, 190);
INSERT INTO public.who_global_data VALUES (6500, 8227, 135884, 20, 2327, 28, 12);
INSERT INTO public.who_global_data VALUES (6501, 2, 391, 0, 25, 28, 104);
INSERT INTO public.who_global_data VALUES (6502, 7642, 473319, 45, 3604, 28, 153);
INSERT INTO public.who_global_data VALUES (6503, 17529, 2237890, 620, 77911, 28, 91);
INSERT INTO public.who_global_data VALUES (6504, 43, 13411, 1, 307, 28, 215);
INSERT INTO public.who_global_data VALUES (6505, 7855, 273154, 75, 3932, 28, 84);
INSERT INTO public.who_global_data VALUES (6506, 16, 2908, 3, 56, 28, 231);
INSERT INTO public.who_global_data VALUES (6507, 1092, 305163, 21, 3989, 28, 196);
INSERT INTO public.who_global_data VALUES (6508, 885, 208596, 0, 2845, 28, 105);
INSERT INTO public.who_global_data VALUES (6509, 221, 97954, 1, 1703, 28, 122);
INSERT INTO public.who_global_data VALUES (6510, 0, 0, 0, 0, 28, 159);
INSERT INTO public.who_global_data VALUES (6511, 321, 53221, 5, 1358, 28, 75);
INSERT INTO public.who_global_data VALUES (6512, 495, 153473, 2, 940, 28, 27);
INSERT INTO public.who_global_data VALUES (6513, 147, 82138, 2, 1367, 28, 54);
INSERT INTO public.who_global_data VALUES (6514, 0, 41, 0, 0, 28, 226);
INSERT INTO public.who_global_data VALUES (6515, 1237, 47782, 11, 801, 28, 79);
INSERT INTO public.who_global_data VALUES (6516, 5440, 210139, 17, 1570, 28, 56);
INSERT INTO public.who_global_data VALUES (6517, 0, 2577, 0, 50, 28, 117);
INSERT INTO public.who_global_data VALUES (6518, 0, 1800, 0, 83, 28, 152);
INSERT INTO public.who_global_data VALUES (6519, 487, 104002, 10, 1568, 28, 16);
INSERT INTO public.who_global_data VALUES (6520, 13, 2395, 0, 44, 28, 10);
INSERT INTO public.who_global_data VALUES (6521, 1640, 158182, 40, 2173, 28, 201);
INSERT INTO public.who_global_data VALUES (6522, 149, 47740, 6, 527, 28, 174);
INSERT INTO public.who_global_data VALUES (6523, 0, 17767, 0, 262, 28, 119);
INSERT INTO public.who_global_data VALUES (6524, 314, 7925, 5, 208, 28, 168);
INSERT INTO public.who_global_data VALUES (6525, 2643, 131108, 16, 537, 28, 99);
INSERT INTO public.who_global_data VALUES (6526, 52, 14040, 0, 49, 28, 171);
INSERT INTO public.who_global_data VALUES (6527, 32, 7427, 1, 286, 28, 87);
INSERT INTO public.who_global_data VALUES (6528, 245, 14212, 2, 232, 28, 123);
INSERT INTO public.who_global_data VALUES (6529, 0, 4, 0, 0, 28, 151);
INSERT INTO public.who_global_data VALUES (6530, 0, 6117, 0, 43, 28, 213);
INSERT INTO public.who_global_data VALUES (6531, 0, 15214, 0, 378, 28, 118);
INSERT INTO public.who_global_data VALUES (6532, 0, 539, 0, 10, 28, 134);
INSERT INTO public.who_global_data VALUES (6533, 187, 6232, 0, 56, 28, 65);
INSERT INTO public.who_global_data VALUES (6534, 13734, 1493569, 1044, 131031, 28, 102);
INSERT INTO public.who_global_data VALUES (6535, 0, 0, 0, 0, 28, 223);
INSERT INTO public.who_global_data VALUES (6536, 23, 1044, 0, 5, 28, 4);
INSERT INTO public.who_global_data VALUES (6537, 33, 1395, 0, 1, 28, 146);
INSERT INTO public.who_global_data VALUES (6538, 490, 52401, 3, 721, 28, 31);
INSERT INTO public.who_global_data VALUES (6539, 0, 13, 0, 1, 28, 127);
INSERT INTO public.who_global_data VALUES (6540, 1543, 450221, 40, 7685, 28, 22);
INSERT INTO public.who_global_data VALUES (6541, 521, 20482, 5, 181, 28, 115);
INSERT INTO public.who_global_data VALUES (6542, 711, 129483, 13, 2812, 28, 106);
INSERT INTO public.who_global_data VALUES (6543, 573, 27255, 0, 240, 28, 90);
INSERT INTO public.who_global_data VALUES (6544, 0, 0, 0, 0, 28, 70);
INSERT INTO public.who_global_data VALUES (6545, 554, 264159, 6, 1909, 28, 46);
INSERT INTO public.who_global_data VALUES (6546, 8124, 858004, 88, 12148, 28, 139);
INSERT INTO public.who_global_data VALUES (6547, 0, 40, 0, 0, 28, 42);
INSERT INTO public.who_global_data VALUES (6548, 0, 1832, 0, 25, 28, 80);
INSERT INTO public.who_global_data VALUES (6549, 0, 4867, 0, 166, 28, 203);
INSERT INTO public.who_global_data VALUES (6550, 0, 3322, 0, 104, 28, 136);
INSERT INTO public.who_global_data VALUES (6551, 1544, 97478, 12, 1342, 28, 63);
INSERT INTO public.who_global_data VALUES (6552, 0, 0, 0, 0, 28, 17);
INSERT INTO public.who_global_data VALUES (6553, 0, 125, 0, 2, 28, 172);
INSERT INTO public.who_global_data VALUES (6554, 100, 85594, 11, 2592, 28, 109);
INSERT INTO public.who_global_data VALUES (6555, 825, 53792, 4, 471, 28, 200);
INSERT INTO public.who_global_data VALUES (6556, 822, 164395, 23, 1707, 28, 93);
INSERT INTO public.who_global_data VALUES (6557, 0, 130070, 0, 1505, 28, 5);
INSERT INTO public.who_global_data VALUES (6558, 0, 745, 0, 13, 28, 214);
INSERT INTO public.who_global_data VALUES (6559, 2435, 497510, 47, 10558, 28, 204);
INSERT INTO public.who_global_data VALUES (6560, 0, 0, 0, 0, 28, 198);
INSERT INTO public.who_global_data VALUES (6561, 4135, 269091, 38, 4321, 28, 173);
INSERT INTO public.who_global_data VALUES (6562, 12, 811, 0, 9, 28, 229);
INSERT INTO public.who_global_data VALUES (6563, 1162, 112856, 15, 2352, 28, 76);
INSERT INTO public.who_global_data VALUES (6564, 2258, 1026690, 58, 38049, 28, 138);
INSERT INTO public.who_global_data VALUES (6565, 1769, 483852, 8, 9364, 28, 98);
INSERT INTO public.who_global_data VALUES (6566, 0, 0, 0, 0, 28, 103);
INSERT INTO public.who_global_data VALUES (6567, 10744, 1376389, 437, 31011, 28, 225);
INSERT INTO public.who_global_data VALUES (6568, 10176, 466709, 118, 7590, 28, 131);
INSERT INTO public.who_global_data VALUES (6569, 2169, 82067, 4, 1592, 28, 235);
INSERT INTO public.who_global_data VALUES (6570, 195, 145466, 1, 246, 28, 137);
INSERT INTO public.who_global_data VALUES (6571, 641, 67991, 19, 1100, 28, 81);
INSERT INTO public.who_global_data VALUES (6572, 375, 148669, 16, 3122, 28, 182);
INSERT INTO public.who_global_data VALUES (6573, 74, 9247, 0, 42, 28, 145);
INSERT INTO public.who_global_data VALUES (6574, 4821, 663779, 96, 16506, 28, 26);
INSERT INTO public.who_global_data VALUES (6575, 23309, 3379103, 470, 61381, 28, 170);
INSERT INTO public.who_global_data VALUES (6576, 0, 9058, 0, 112, 28, 191);
INSERT INTO public.who_global_data VALUES (6577, 0, 5, 0, 0, 28, 221);
INSERT INTO public.who_global_data VALUES (6578, 0, 191, 0, 0, 28, 64);
INSERT INTO public.who_global_data VALUES (6579, 0, 0, 0, 0, 28, 116);
INSERT INTO public.who_global_data VALUES (6580, 1, 34, 0, 0, 28, 128);
INSERT INTO public.who_global_data VALUES (6581, 1, 383, 0, 5, 28, 6);
INSERT INTO public.who_global_data VALUES (6582, 0, 1002, 0, 12, 28, 227);
INSERT INTO public.who_global_data VALUES (6583, 0, 16, 0, 0, 28, 68);
INSERT INTO public.who_global_data VALUES (6584, 55, 204, 0, 0, 28, 184);
INSERT INTO public.who_global_data VALUES (6585, 0, 2, 0, 0, 28, 82);
INSERT INTO public.who_global_data VALUES (6586, 45, 2628, 0, 64, 28, 149);
INSERT INTO public.who_global_data VALUES (6587, 19, 1054, 0, 17, 28, 197);
INSERT INTO public.who_global_data VALUES (6588, 97, 363582, 4, 6282, 28, 78);
INSERT INTO public.who_global_data VALUES (6589, 296, 20672, 8, 446, 28, 233);
INSERT INTO public.who_global_data VALUES (6590, 2218, 356125, 34, 3513, 28, 133);
INSERT INTO public.who_global_data VALUES (6591, 30, 448, 0, 1, 28, 35);
INSERT INTO public.who_global_data VALUES (6592, 25, 2782, 0, 77, 28, 114);
INSERT INTO public.who_global_data VALUES (6593, 23, 58836, 0, 29, 28, 237);
INSERT INTO public.who_global_data VALUES (6594, 0, 19, 0, 0, 28, 55);
INSERT INTO public.who_global_data VALUES (6595, 19, 1531, 0, 27, 28, 176);
INSERT INTO public.who_global_data VALUES (6596, 4072, 205236, 48, 2836, 28, 202);
INSERT INTO public.who_global_data VALUES (6597, 1854, 138594, 27, 3267, 28, 155);
INSERT INTO public.who_global_data VALUES (6598, 0, 17, 0, 0, 28, 32);
INSERT INTO public.who_global_data VALUES (6599, 0, 4726, 0, 130, 28, 220);
INSERT INTO public.who_global_data VALUES (6600, 21980, 1192570, 616, 32425, 28, 30);
INSERT INTO public.who_global_data VALUES (6601, 0, 3604, 0, 63, 28, 147);
INSERT INTO public.who_global_data VALUES (6602, 25618, 2137454, 179, 53018, 28, 208);
INSERT INTO public.who_global_data VALUES (6603, 525, 47305, 3, 222, 28, 45);
INSERT INTO public.who_global_data VALUES (6604, 0, 26279, 0, 1603, 28, 110);
INSERT INTO public.who_global_data VALUES (6605, 84, 6750, 4, 130, 28, 88);
INSERT INTO public.who_global_data VALUES (6606, 7152, 489395, 102, 10480, 28, 51);
INSERT INTO public.who_global_data VALUES (6607, 3049, 479800, 42, 7770, 28, 209);
INSERT INTO public.who_global_data VALUES (6608, 95, 12179, 8, 763, 28, 205);
INSERT INTO public.who_global_data VALUES (6609, 1, 13706, 0, 91, 28, 18);
INSERT INTO public.who_global_data VALUES (6610, 0, 9841, 0, 67, 28, 72);
INSERT INTO public.who_global_data VALUES (6611, 68053, 2957476, 1325, 79833, 28, 44);
INSERT INTO public.who_global_data VALUES (6612, 0, 49, 0, 0, 28, 15);
INSERT INTO public.who_global_data VALUES (6613, 38, 3845, 2, 72, 28, 25);
INSERT INTO public.who_global_data VALUES (6614, 0, 0, 0, 0, 28, 179);
INSERT INTO public.who_global_data VALUES (6615, 0, 0, 0, 0, 28, 34);
INSERT INTO public.who_global_data VALUES (6616, 14, 7210, 0, 127, 28, 207);
INSERT INTO public.who_global_data VALUES (6617, 2649, 154903, 56, 5108, 28, 166);
INSERT INTO public.who_global_data VALUES (6618, 11479, 2307581, 186, 22450, 28, 126);
INSERT INTO public.who_global_data VALUES (6619, 0, 0, 0, 0, 28, 97);
INSERT INTO public.who_global_data VALUES (6620, 15, 956, 0, 6, 28, 36);
INSERT INTO public.who_global_data VALUES (6621, 0, 0, 0, 0, 28, 125);
INSERT INTO public.who_global_data VALUES (6622, 222, 37296, 3, 300, 28, 124);
INSERT INTO public.who_global_data VALUES (6623, 4846, 1110015, 80, 19668, 28, 185);
INSERT INTO public.who_global_data VALUES (6624, 2950, 224704, 3, 697, 28, 194);
INSERT INTO public.who_global_data VALUES (6625, 0, 509, 0, 21, 28, 144);
INSERT INTO public.who_global_data VALUES (6626, 277195, 21447670, 4176, 362287, 28, 19);
INSERT INTO public.who_global_data VALUES (6627, 24, 2130, 0, 24, 28, 217);
INSERT INTO public.who_global_data VALUES (6628, 759, 23807, 10, 231, 28, 148);
INSERT INTO public.who_global_data VALUES (6629, 45, 77530, 0, 616, 28, 86);
INSERT INTO public.who_global_data VALUES (6630, 0, 1, 0, 0, 28, 13);
INSERT INTO public.who_global_data VALUES (6631, 414, 115322, 5, 1052, 28, 157);
INSERT INTO public.who_global_data VALUES (6632, 3, 1512, 0, 35, 28, 8);
INSERT INTO public.who_global_data VALUES (6633, 0, 4, 0, 0, 28, 73);
INSERT INTO public.who_global_data VALUES (6634, 0, 2108, 0, 611, 28, 101);
INSERT INTO public.who_global_data VALUES (6635, 1029, 25326, 18, 441, 28, 165);
INSERT INTO public.who_global_data VALUES (6636, 985, 19660, 22, 468, 28, 14);
INSERT INTO public.who_global_data VALUES (6637, 125, 53332, 4, 2257, 29, 193);
INSERT INTO public.who_global_data VALUES (6638, 697, 61705, 6, 1223, 29, 113);
INSERT INTO public.who_global_data VALUES (6639, 0, 101120, 0, 2786, 29, 143);
INSERT INTO public.who_global_data VALUES (6640, 0, 0, 0, 0, 29, 219);
INSERT INTO public.who_global_data VALUES (6641, 0, 8348, 0, 84, 29, 186);
INSERT INTO public.who_global_data VALUES (6642, 110, 17974, 0, 413, 29, 52);
INSERT INTO public.who_global_data VALUES (6643, 0, 15, 0, 0, 29, 180);
INSERT INTO public.who_global_data VALUES (6644, 3, 163, 0, 5, 29, 167);
INSERT INTO public.who_global_data VALUES (6645, 13441, 1676171, 191, 43976, 29, 154);
INSERT INTO public.who_global_data VALUES (6646, 361, 161415, 7, 2908, 29, 94);
INSERT INTO public.who_global_data VALUES (6647, 95, 5811, 0, 50, 29, 66);
INSERT INTO public.who_global_data VALUES (6648, 11, 28547, 0, 909, 29, 58);
INSERT INTO public.who_global_data VALUES (6649, 2006, 373663, 50, 6504, 29, 163);
INSERT INTO public.who_global_data VALUES (6650, 685, 222885, 27, 2845, 29, 37);
INSERT INTO public.who_global_data VALUES (6651, 14, 7959, 0, 175, 29, 142);
INSERT INTO public.who_global_data VALUES (6652, 349, 94633, 0, 353, 29, 83);
INSERT INTO public.who_global_data VALUES (6653, 1007, 519905, 31, 7718, 29, 228);
INSERT INTO public.who_global_data VALUES (6654, 51, 743, 0, 7, 29, 188);
INSERT INTO public.who_global_data VALUES (6655, 1838, 206796, 9, 1489, 29, 62);
INSERT INTO public.who_global_data VALUES (6656, 1979, 662148, 53, 19977, 29, 160);
INSERT INTO public.who_global_data VALUES (6657, 90, 11108, 2, 260, 29, 50);
INSERT INTO public.who_global_data VALUES (6658, 0, 3304, 0, 44, 29, 33);
INSERT INTO public.who_global_data VALUES (6659, 4, 636, 0, 11, 29, 183);
INSERT INTO public.who_global_data VALUES (6660, 12, 767, 0, 0, 29, 92);
INSERT INTO public.who_global_data VALUES (6661, 1713, 166981, 46, 9287, 29, 158);
INSERT INTO public.who_global_data VALUES (6662, 12, 249, 0, 3, 29, 67);
INSERT INTO public.who_global_data VALUES (6663, 250, 114402, 16, 4264, 29, 57);
INSERT INTO public.who_global_data VALUES (6664, 635, 15440, 3, 45, 29, 38);
INSERT INTO public.who_global_data VALUES (6665, 63430, 7873830, 1242, 198974, 29, 141);
INSERT INTO public.who_global_data VALUES (6666, 0, 107, 0, 1, 29, 178);
INSERT INTO public.who_global_data VALUES (6667, 1, 173, 0, 3, 29, 108);
INSERT INTO public.who_global_data VALUES (6668, 867, 207259, 56, 8017, 29, 39);
INSERT INTO public.who_global_data VALUES (6669, 150, 7713, 0, 89, 29, 2);
INSERT INTO public.who_global_data VALUES (6670, 0, 885, 0, 2, 29, 195);
INSERT INTO public.who_global_data VALUES (6671, 94, 12146, 0, 113, 29, 107);
INSERT INTO public.who_global_data VALUES (6672, 1, 386, 0, 0, 29, 161);
INSERT INTO public.who_global_data VALUES (6673, 0, 26848, 0, 448, 29, 212);
INSERT INTO public.who_global_data VALUES (6674, 8153, 626799, 136, 16369, 29, 181);
INSERT INTO public.who_global_data VALUES (6675, 6, 356, 0, 2, 29, 53);
INSERT INTO public.who_global_data VALUES (6676, 0, 4969, 0, 63, 29, 164);
INSERT INTO public.who_global_data VALUES (6677, 30, 2358, 0, 105, 29, 140);
INSERT INTO public.who_global_data VALUES (6678, 3693, 629176, 97, 16913, 29, 20);
INSERT INTO public.who_global_data VALUES (6679, 89, 97306, 0, 4795, 29, 112);
INSERT INTO public.who_global_data VALUES (6680, 16805, 1719771, 295, 44723, 29, 111);
INSERT INTO public.who_global_data VALUES (6681, 0, 864, 0, 13, 29, 71);
INSERT INTO public.who_global_data VALUES (6682, 0, 7160, 0, 100, 29, 218);
INSERT INTO public.who_global_data VALUES (6683, 0, 0, 0, 0, 29, 43);
INSERT INTO public.who_global_data VALUES (6684, 1447, 175038, 19, 2267, 29, 49);
INSERT INTO public.who_global_data VALUES (6685, 0, 22855, 0, 138, 29, 1);
INSERT INTO public.who_global_data VALUES (6686, 1098, 217946, 38, 4304, 29, 48);
INSERT INTO public.who_global_data VALUES (6687, 314, 13479, 0, 148, 29, 232);
INSERT INTO public.who_global_data VALUES (6688, 36, 4378, 1, 17, 29, 175);
INSERT INTO public.who_global_data VALUES (6689, 427, 26208, 2, 140, 29, 21);
INSERT INTO public.who_global_data VALUES (6690, 14861, 809601, 179, 12800, 29, 156);
INSERT INTO public.who_global_data VALUES (6691, 0, 0, 0, 0, 29, 95);
INSERT INTO public.who_global_data VALUES (6692, 333, 18485, 9, 610, 29, 177);
INSERT INTO public.who_global_data VALUES (6693, 1842, 176837, 37, 1487, 29, 210);
INSERT INTO public.who_global_data VALUES (6694, 2, 5857, 0, 61, 29, 120);
INSERT INTO public.who_global_data VALUES (6695, 0, 105, 0, 0, 29, 135);
INSERT INTO public.who_global_data VALUES (6696, 1115, 177493, 4, 2423, 29, 206);
INSERT INTO public.who_global_data VALUES (6697, 1008, 218385, 12, 14158, 29, 189);
INSERT INTO public.who_global_data VALUES (6698, 1219, 146809, 54, 8029, 29, 129);
INSERT INTO public.who_global_data VALUES (6699, 593, 47948, 17, 1390, 29, 121);
INSERT INTO public.who_global_data VALUES (6700, 0, 5286, 0, 86, 29, 59);
INSERT INTO public.who_global_data VALUES (6701, 0, 1445, 0, 3, 29, 96);
INSERT INTO public.who_global_data VALUES (6702, 786, 32537, 5, 270, 29, 41);
INSERT INTO public.who_global_data VALUES (6703, 234, 10773, 0, 261, 29, 216);
INSERT INTO public.who_global_data VALUES (6704, 441, 127227, 1, 1966, 29, 236);
INSERT INTO public.who_global_data VALUES (6705, 0, 29, 0, 0, 29, 150);
INSERT INTO public.who_global_data VALUES (6706, 3, 643, 0, 1, 29, 61);
INSERT INTO public.who_global_data VALUES (6707, 0, 53, 0, 2, 29, 7);
INSERT INTO public.who_global_data VALUES (6708, 223, 37772, 8, 584, 29, 169);
INSERT INTO public.who_global_data VALUES (6709, 21510, 2682250, 276, 66460, 29, 28);
INSERT INTO public.who_global_data VALUES (6710, 193, 13825, 0, 73, 29, 85);
INSERT INTO public.who_global_data VALUES (6711, 64, 17195, 0, 121, 29, 211);
INSERT INTO public.who_global_data VALUES (6712, 0, 9641, 0, 66, 29, 60);
INSERT INTO public.who_global_data VALUES (6713, 5, 3838, 0, 125, 29, 3);
INSERT INTO public.who_global_data VALUES (6714, 537, 236028, 34, 2728, 29, 11);
INSERT INTO public.who_global_data VALUES (6715, 31849, 1866887, 1188, 38795, 29, 89);
INSERT INTO public.who_global_data VALUES (6716, 293, 55461, 1, 336, 29, 24);
INSERT INTO public.who_global_data VALUES (6717, 172, 2798, 1, 11, 29, 162);
INSERT INTO public.who_global_data VALUES (6718, 510, 142777, 47, 5146, 29, 100);
INSERT INTO public.who_global_data VALUES (6719, 0, 28, 0, 0, 29, 47);
INSERT INTO public.who_global_data VALUES (6720, 0, 130, 0, 1, 29, 29);
INSERT INTO public.who_global_data VALUES (6721, 0, 8702, 0, 155, 29, 40);
INSERT INTO public.who_global_data VALUES (6722, 8, 7200, 1, 124, 29, 222);
INSERT INTO public.who_global_data VALUES (6723, 872, 141074, 29, 4928, 29, 132);
INSERT INTO public.who_global_data VALUES (6724, 1, 302, 0, 13, 29, 130);
INSERT INTO public.who_global_data VALUES (6725, 17, 13862, 0, 81, 29, 234);
INSERT INTO public.who_global_data VALUES (6726, 0, 2447, 0, 45, 29, 23);
INSERT INTO public.who_global_data VALUES (6727, 0, 6407, 0, 166, 29, 192);
INSERT INTO public.who_global_data VALUES (6728, 76, 10203, 0, 236, 29, 69);
INSERT INTO public.who_global_data VALUES (6729, 0, 26, 0, 0, 29, 187);
INSERT INTO public.who_global_data VALUES (6730, 1077, 124899, 6, 3192, 29, 230);
INSERT INTO public.who_global_data VALUES (6731, 2907, 337743, 115, 10440, 29, 77);
INSERT INTO public.who_global_data VALUES (6732, 13, 5845, 0, 29, 29, 9);
INSERT INTO public.who_global_data VALUES (6733, 18139, 10413417, 234, 150570, 29, 74);
INSERT INTO public.who_global_data VALUES (6734, 9321, 797723, 224, 23520, 29, 224);
INSERT INTO public.who_global_data VALUES (6735, 6360, 1268263, 103, 55933, 29, 199);
INSERT INTO public.who_global_data VALUES (6736, 790, 600755, 4, 12869, 29, 190);
INSERT INTO public.who_global_data VALUES (6737, 6503, 127657, 8, 2307, 29, 12);
INSERT INTO public.who_global_data VALUES (6738, 3, 389, 0, 25, 29, 104);
INSERT INTO public.who_global_data VALUES (6739, 7878, 465677, 45, 3559, 29, 153);
INSERT INTO public.who_global_data VALUES (6740, 18416, 2220361, 414, 77291, 29, 91);
INSERT INTO public.who_global_data VALUES (6741, 38, 13368, 0, 306, 29, 215);
INSERT INTO public.who_global_data VALUES (6742, 6906, 265299, 66, 3857, 29, 84);
INSERT INTO public.who_global_data VALUES (6743, 29, 2892, 2, 53, 29, 231);
INSERT INTO public.who_global_data VALUES (6744, 1215, 304071, 13, 3968, 29, 196);
INSERT INTO public.who_global_data VALUES (6745, 871, 207711, 0, 2845, 29, 105);
INSERT INTO public.who_global_data VALUES (6746, 335, 97733, 8, 1702, 29, 122);
INSERT INTO public.who_global_data VALUES (6747, 0, 0, 0, 0, 29, 159);
INSERT INTO public.who_global_data VALUES (6748, 309, 52900, 6, 1353, 29, 75);
INSERT INTO public.who_global_data VALUES (6749, 540, 152978, 0, 938, 29, 27);
INSERT INTO public.who_global_data VALUES (6750, 165, 81991, 2, 1365, 29, 54);
INSERT INTO public.who_global_data VALUES (6751, 0, 41, 0, 0, 29, 226);
INSERT INTO public.who_global_data VALUES (6752, 1374, 46545, 36, 790, 29, 79);
INSERT INTO public.who_global_data VALUES (6753, 4774, 204699, 16, 1553, 29, 56);
INSERT INTO public.who_global_data VALUES (6754, 0, 2577, 0, 50, 29, 117);
INSERT INTO public.who_global_data VALUES (6755, 0, 1800, 0, 83, 29, 152);
INSERT INTO public.who_global_data VALUES (6756, 635, 103515, 12, 1558, 29, 16);
INSERT INTO public.who_global_data VALUES (6757, 10, 2382, 2, 44, 29, 10);
INSERT INTO public.who_global_data VALUES (6758, 1994, 156542, 41, 2133, 29, 201);
INSERT INTO public.who_global_data VALUES (6759, 161, 47591, 4, 521, 29, 174);
INSERT INTO public.who_global_data VALUES (6760, 0, 17767, 0, 262, 29, 119);
INSERT INTO public.who_global_data VALUES (6761, 274, 7611, 4, 203, 29, 168);
INSERT INTO public.who_global_data VALUES (6762, 3027, 128465, 8, 521, 29, 99);
INSERT INTO public.who_global_data VALUES (6763, 21, 13988, 1, 49, 29, 171);
INSERT INTO public.who_global_data VALUES (6764, 0, 7395, 0, 285, 29, 87);
INSERT INTO public.who_global_data VALUES (6765, 191, 13967, 2, 230, 29, 123);
INSERT INTO public.who_global_data VALUES (6766, 0, 4, 0, 0, 29, 151);
INSERT INTO public.who_global_data VALUES (6767, 0, 6117, 0, 43, 29, 213);
INSERT INTO public.who_global_data VALUES (6768, 103, 15214, 5, 378, 29, 118);
INSERT INTO public.who_global_data VALUES (6769, 8, 539, 0, 10, 29, 134);
INSERT INTO public.who_global_data VALUES (6770, 0, 6045, 0, 56, 29, 65);
INSERT INTO public.who_global_data VALUES (6771, 13345, 1479835, 1165, 129987, 29, 102);
INSERT INTO public.who_global_data VALUES (6772, 0, 0, 0, 0, 29, 223);
INSERT INTO public.who_global_data VALUES (6773, 40, 1021, 1, 5, 29, 4);
INSERT INTO public.who_global_data VALUES (6774, 13, 1362, 0, 1, 29, 146);
INSERT INTO public.who_global_data VALUES (6775, 410, 51911, 6, 718, 29, 31);
INSERT INTO public.who_global_data VALUES (6776, 0, 13, 0, 1, 29, 127);
INSERT INTO public.who_global_data VALUES (6777, 1597, 448678, 27, 7645, 29, 22);
INSERT INTO public.who_global_data VALUES (6778, 294, 19961, 4, 176, 29, 115);
INSERT INTO public.who_global_data VALUES (6779, 594, 128772, 14, 2799, 29, 106);
INSERT INTO public.who_global_data VALUES (6780, 372, 26682, 5, 240, 29, 90);
INSERT INTO public.who_global_data VALUES (6781, 0, 0, 0, 0, 29, 70);
INSERT INTO public.who_global_data VALUES (6782, 412, 263605, 4, 1903, 29, 46);
INSERT INTO public.who_global_data VALUES (6783, 9690, 849880, 81, 12060, 29, 139);
INSERT INTO public.who_global_data VALUES (6784, 0, 40, 0, 0, 29, 42);
INSERT INTO public.who_global_data VALUES (6785, 0, 1832, 0, 25, 29, 80);
INSERT INTO public.who_global_data VALUES (6786, 0, 4867, 0, 166, 29, 203);
INSERT INTO public.who_global_data VALUES (6787, 0, 3322, 0, 104, 29, 136);
INSERT INTO public.who_global_data VALUES (6788, 1565, 95934, 6, 1330, 29, 63);
INSERT INTO public.who_global_data VALUES (6789, 0, 0, 0, 0, 29, 17);
INSERT INTO public.who_global_data VALUES (6790, 0, 125, 0, 2, 29, 172);
INSERT INTO public.who_global_data VALUES (6791, 166, 85494, 10, 2581, 29, 109);
INSERT INTO public.who_global_data VALUES (6792, 787, 52967, 1, 467, 29, 200);
INSERT INTO public.who_global_data VALUES (6793, 1251, 163573, 21, 1684, 29, 93);
INSERT INTO public.who_global_data VALUES (6794, 182, 130070, 1, 1505, 29, 5);
INSERT INTO public.who_global_data VALUES (6795, 0, 745, 0, 13, 29, 214);
INSERT INTO public.who_global_data VALUES (6796, 2481, 495075, 50, 10511, 29, 204);
INSERT INTO public.who_global_data VALUES (6797, 0, 0, 0, 0, 29, 198);
INSERT INTO public.who_global_data VALUES (6798, 5186, 264956, 45, 4283, 29, 173);
INSERT INTO public.who_global_data VALUES (6799, 0, 799, 0, 9, 29, 229);
INSERT INTO public.who_global_data VALUES (6800, 898, 111694, 16, 2337, 29, 76);
INSERT INTO public.who_global_data VALUES (6801, 2414, 1024432, 66, 37991, 29, 138);
INSERT INTO public.who_global_data VALUES (6802, 1346, 482083, 9, 9356, 29, 98);
INSERT INTO public.who_global_data VALUES (6803, 0, 0, 0, 0, 29, 103);
INSERT INTO public.who_global_data VALUES (6804, 8763, 1365645, 333, 30574, 29, 225);
INSERT INTO public.who_global_data VALUES (6805, 9927, 456533, 95, 7472, 29, 131);
INSERT INTO public.who_global_data VALUES (6806, 286, 79898, 18, 1588, 29, 235);
INSERT INTO public.who_global_data VALUES (6807, 210, 145271, 0, 245, 29, 137);
INSERT INTO public.who_global_data VALUES (6808, 674, 67350, 35, 1081, 29, 81);
INSERT INTO public.who_global_data VALUES (6809, 423, 148294, 18, 3106, 29, 182);
INSERT INTO public.who_global_data VALUES (6810, 0, 9173, 0, 42, 29, 145);
INSERT INTO public.who_global_data VALUES (6811, 4951, 658958, 111, 16410, 29, 26);
INSERT INTO public.who_global_data VALUES (6812, 23652, 3355794, 454, 60911, 29, 170);
INSERT INTO public.who_global_data VALUES (6813, 0, 9058, 0, 112, 29, 191);
INSERT INTO public.who_global_data VALUES (6814, 0, 5, 0, 0, 29, 221);
INSERT INTO public.who_global_data VALUES (6815, 0, 191, 0, 0, 29, 64);
INSERT INTO public.who_global_data VALUES (6816, 0, 0, 0, 0, 29, 116);
INSERT INTO public.who_global_data VALUES (6817, 0, 33, 0, 0, 29, 128);
INSERT INTO public.who_global_data VALUES (6818, 2, 382, 0, 5, 29, 6);
INSERT INTO public.who_global_data VALUES (6819, 0, 1002, 0, 12, 29, 227);
INSERT INTO public.who_global_data VALUES (6820, 0, 16, 0, 0, 29, 68);
INSERT INTO public.who_global_data VALUES (6821, 0, 149, 0, 0, 29, 184);
INSERT INTO public.who_global_data VALUES (6822, 0, 2, 0, 0, 29, 82);
INSERT INTO public.who_global_data VALUES (6823, 34, 2583, 2, 64, 29, 149);
INSERT INTO public.who_global_data VALUES (6824, 11, 1035, 0, 17, 29, 197);
INSERT INTO public.who_global_data VALUES (6825, 108, 363485, 6, 6278, 29, 78);
INSERT INTO public.who_global_data VALUES (6826, 220, 20376, 5, 438, 29, 233);
INSERT INTO public.who_global_data VALUES (6827, 1787, 353907, 35, 3479, 29, 133);
INSERT INTO public.who_global_data VALUES (6828, 45, 418, 0, 1, 29, 35);
INSERT INTO public.who_global_data VALUES (6829, 18, 2757, 1, 77, 29, 114);
INSERT INTO public.who_global_data VALUES (6830, 33, 58813, 0, 29, 29, 237);
INSERT INTO public.who_global_data VALUES (6831, 0, 19, 0, 0, 29, 55);
INSERT INTO public.who_global_data VALUES (6832, 8, 1512, 0, 27, 29, 176);
INSERT INTO public.who_global_data VALUES (6833, 2980, 201164, 71, 2788, 29, 202);
INSERT INTO public.who_global_data VALUES (6834, 2077, 136740, 28, 3240, 29, 155);
INSERT INTO public.who_global_data VALUES (6835, 0, 17, 0, 0, 29, 32);
INSERT INTO public.who_global_data VALUES (6836, 0, 4726, 0, 130, 29, 220);
INSERT INTO public.who_global_data VALUES (6837, 20999, 1170590, 441, 31809, 29, 30);
INSERT INTO public.who_global_data VALUES (6838, 0, 3604, 0, 63, 29, 147);
INSERT INTO public.who_global_data VALUES (6839, 13986, 2111836, 147, 52839, 29, 208);
INSERT INTO public.who_global_data VALUES (6840, 532, 46780, 0, 219, 29, 45);
INSERT INTO public.who_global_data VALUES (6841, 0, 26279, 0, 1603, 29, 110);
INSERT INTO public.who_global_data VALUES (6842, 80, 6666, 1, 126, 29, 88);
INSERT INTO public.who_global_data VALUES (6843, 5031, 482243, 82, 10378, 29, 51);
INSERT INTO public.who_global_data VALUES (6844, 3177, 476751, 57, 7728, 29, 209);
INSERT INTO public.who_global_data VALUES (6845, 96, 12084, 8, 755, 29, 205);
INSERT INTO public.who_global_data VALUES (6846, 4, 13705, 0, 91, 29, 18);
INSERT INTO public.who_global_data VALUES (6847, 205, 9841, 0, 67, 29, 72);
INSERT INTO public.who_global_data VALUES (6848, 52618, 2889423, 1162, 78508, 29, 44);
INSERT INTO public.who_global_data VALUES (6849, 0, 49, 0, 0, 29, 15);
INSERT INTO public.who_global_data VALUES (6850, 0, 3807, 0, 70, 29, 25);
INSERT INTO public.who_global_data VALUES (6851, 0, 0, 0, 0, 29, 179);
INSERT INTO public.who_global_data VALUES (6852, 0, 0, 0, 0, 29, 34);
INSERT INTO public.who_global_data VALUES (6853, 10, 7196, 0, 127, 29, 207);
INSERT INTO public.who_global_data VALUES (6854, 2373, 152254, 48, 5052, 29, 166);
INSERT INTO public.who_global_data VALUES (6855, 12171, 2296102, 194, 22264, 29, 126);
INSERT INTO public.who_global_data VALUES (6856, 0, 0, 0, 0, 29, 97);
INSERT INTO public.who_global_data VALUES (6857, 23, 941, 0, 6, 29, 36);
INSERT INTO public.who_global_data VALUES (6858, 0, 0, 0, 0, 29, 125);
INSERT INTO public.who_global_data VALUES (6859, 372, 37074, 3, 297, 29, 124);
INSERT INTO public.who_global_data VALUES (6860, 5676, 1105169, 83, 19588, 29, 185);
INSERT INTO public.who_global_data VALUES (6861, 2988, 221754, 5, 694, 29, 194);
INSERT INTO public.who_global_data VALUES (6862, 0, 509, 0, 21, 29, 144);
INSERT INTO public.who_global_data VALUES (6863, 299562, 21170475, 3825, 358111, 29, 19);
INSERT INTO public.who_global_data VALUES (6864, 23, 2106, 0, 24, 29, 217);
INSERT INTO public.who_global_data VALUES (6865, 944, 23048, 4, 221, 29, 148);
INSERT INTO public.who_global_data VALUES (6866, 73, 77485, 1, 616, 29, 86);
INSERT INTO public.who_global_data VALUES (6867, 0, 1, 0, 0, 29, 13);
INSERT INTO public.who_global_data VALUES (6868, 246, 114908, 5, 1047, 29, 157);
INSERT INTO public.who_global_data VALUES (6869, 4, 1509, 0, 35, 29, 8);
INSERT INTO public.who_global_data VALUES (6870, 0, 4, 0, 0, 29, 73);
INSERT INTO public.who_global_data VALUES (6871, 2, 2108, 0, 611, 29, 101);
INSERT INTO public.who_global_data VALUES (6872, 802, 24297, 6, 423, 29, 165);
INSERT INTO public.who_global_data VALUES (6873, 871, 18675, 15, 446, 29, 14);
INSERT INTO public.who_global_data VALUES (6874, 102, 53207, 9, 2253, 30, 193);
INSERT INTO public.who_global_data VALUES (6875, 725, 61008, 7, 1217, 30, 113);
INSERT INTO public.who_global_data VALUES (6876, 475, 101120, 9, 2786, 30, 143);
INSERT INTO public.who_global_data VALUES (6877, 0, 0, 0, 0, 30, 219);
INSERT INTO public.who_global_data VALUES (6878, 40, 8348, 0, 84, 30, 186);
INSERT INTO public.who_global_data VALUES (6879, 180, 17864, 5, 413, 30, 52);
INSERT INTO public.who_global_data VALUES (6880, 0, 15, 0, 0, 30, 180);
INSERT INTO public.who_global_data VALUES (6881, 0, 160, 0, 5, 30, 167);
INSERT INTO public.who_global_data VALUES (6882, 13790, 1662730, 151, 43785, 30, 154);
INSERT INTO public.who_global_data VALUES (6883, 201, 161054, 11, 2901, 30, 94);
INSERT INTO public.who_global_data VALUES (6884, 110, 5716, 1, 50, 30, 66);
INSERT INTO public.who_global_data VALUES (6885, 17, 28536, 0, 909, 30, 58);
INSERT INTO public.who_global_data VALUES (6886, 2877, 371657, 51, 6454, 30, 163);
INSERT INTO public.who_global_data VALUES (6887, 799, 222200, 26, 2818, 30, 37);
INSERT INTO public.who_global_data VALUES (6888, 17, 7945, 0, 175, 30, 142);
INSERT INTO public.who_global_data VALUES (6889, 289, 94284, 1, 353, 30, 83);
INSERT INTO public.who_global_data VALUES (6890, 978, 518898, 17, 7687, 30, 228);
INSERT INTO public.who_global_data VALUES (6891, 49, 692, 0, 7, 30, 188);
INSERT INTO public.who_global_data VALUES (6892, 1854, 204958, 9, 1480, 30, 62);
INSERT INTO public.who_global_data VALUES (6893, 2518, 660169, 54, 19924, 30, 160);
INSERT INTO public.who_global_data VALUES (6894, 80, 11018, 1, 258, 30, 50);
INSERT INTO public.who_global_data VALUES (6895, 0, 3304, 0, 44, 30, 33);
INSERT INTO public.who_global_data VALUES (6896, 8, 632, 1, 11, 30, 183);
INSERT INTO public.who_global_data VALUES (6897, 21, 755, 0, 0, 30, 92);
INSERT INTO public.who_global_data VALUES (6898, 1597, 165268, 22, 9241, 30, 158);
INSERT INTO public.who_global_data VALUES (6899, 12, 237, 0, 3, 30, 67);
INSERT INTO public.who_global_data VALUES (6900, 760, 114152, 37, 4248, 30, 57);
INSERT INTO public.who_global_data VALUES (6901, 0, 14805, 0, 42, 30, 38);
INSERT INTO public.who_global_data VALUES (6902, 56648, 7810400, 1171, 197732, 30, 141);
INSERT INTO public.who_global_data VALUES (6903, 0, 107, 0, 1, 30, 178);
INSERT INTO public.who_global_data VALUES (6904, 0, 172, 0, 3, 30, 108);
INSERT INTO public.who_global_data VALUES (6905, 1002, 206392, 59, 7961, 30, 39);
INSERT INTO public.who_global_data VALUES (6906, 437, 7563, 3, 89, 30, 2);
INSERT INTO public.who_global_data VALUES (6907, 43, 885, 0, 2, 30, 195);
INSERT INTO public.who_global_data VALUES (6908, 69, 12052, 0, 113, 30, 107);
INSERT INTO public.who_global_data VALUES (6909, 2, 385, 0, 0, 30, 161);
INSERT INTO public.who_global_data VALUES (6910, 0, 26848, 0, 448, 30, 212);
INSERT INTO public.who_global_data VALUES (6911, 7222, 618646, 159, 16233, 30, 181);
INSERT INTO public.who_global_data VALUES (6912, 3, 350, 0, 2, 30, 53);
INSERT INTO public.who_global_data VALUES (6913, 6, 4969, 0, 63, 30, 164);
INSERT INTO public.who_global_data VALUES (6914, 39, 2328, 0, 105, 30, 140);
INSERT INTO public.who_global_data VALUES (6915, 2382, 625483, 28, 16816, 30, 20);
INSERT INTO public.who_global_data VALUES (6916, 90, 97217, 1, 4795, 30, 112);
INSERT INTO public.who_global_data VALUES (6917, 16835, 1702966, 241, 44428, 30, 111);
INSERT INTO public.who_global_data VALUES (6918, 0, 864, 0, 13, 30, 71);
INSERT INTO public.who_global_data VALUES (6919, 960, 7160, 0, 100, 30, 218);
INSERT INTO public.who_global_data VALUES (6920, 0, 0, 0, 0, 30, 43);
INSERT INTO public.who_global_data VALUES (6921, 1155, 173591, 19, 2248, 30, 49);
INSERT INTO public.who_global_data VALUES (6922, 55, 22855, 0, 138, 30, 1);
INSERT INTO public.who_global_data VALUES (6923, 562, 216848, 43, 4266, 30, 48);
INSERT INTO public.who_global_data VALUES (6924, 201, 13165, 1, 148, 30, 232);
INSERT INTO public.who_global_data VALUES (6925, 19, 4342, 0, 16, 30, 175);
INSERT INTO public.who_global_data VALUES (6926, 573, 25781, 4, 138, 30, 21);
INSERT INTO public.who_global_data VALUES (6927, 17773, 794740, 185, 12621, 30, 156);
INSERT INTO public.who_global_data VALUES (6928, 0, 0, 0, 0, 30, 95);
INSERT INTO public.who_global_data VALUES (6929, 0, 18152, 0, 601, 30, 177);
INSERT INTO public.who_global_data VALUES (6930, 2216, 174995, 30, 1450, 30, 210);
INSERT INTO public.who_global_data VALUES (6931, 1, 5855, 0, 61, 30, 120);
INSERT INTO public.who_global_data VALUES (6932, 9, 105, 0, 0, 30, 135);
INSERT INTO public.who_global_data VALUES (6933, 529, 176378, 0, 2419, 30, 206);
INSERT INTO public.who_global_data VALUES (6934, 1294, 217377, 43, 14146, 30, 189);
INSERT INTO public.who_global_data VALUES (6935, 1007, 145590, 57, 7975, 30, 129);
INSERT INTO public.who_global_data VALUES (6936, 0, 47355, 0, 1373, 30, 121);
INSERT INTO public.who_global_data VALUES (6937, 7, 5286, 0, 86, 30, 59);
INSERT INTO public.who_global_data VALUES (6938, 0, 1445, 0, 3, 30, 96);
INSERT INTO public.who_global_data VALUES (6939, 1084, 31751, 7, 265, 30, 41);
INSERT INTO public.who_global_data VALUES (6940, 201, 10539, 9, 261, 30, 216);
INSERT INTO public.who_global_data VALUES (6941, 545, 126786, 2, 1965, 30, 236);
INSERT INTO public.who_global_data VALUES (6942, 0, 29, 0, 0, 30, 150);
INSERT INTO public.who_global_data VALUES (6943, 14, 640, 1, 1, 30, 61);
INSERT INTO public.who_global_data VALUES (6944, 4, 53, 0, 2, 30, 7);
INSERT INTO public.who_global_data VALUES (6945, 331, 37549, 0, 576, 30, 169);
INSERT INTO public.who_global_data VALUES (6946, 25189, 2660740, 282, 66184, 30, 28);
INSERT INTO public.who_global_data VALUES (6947, 135, 13632, 1, 73, 30, 85);
INSERT INTO public.who_global_data VALUES (6948, 43, 17131, 0, 121, 30, 211);
INSERT INTO public.who_global_data VALUES (6949, 36, 9641, 0, 66, 30, 60);
INSERT INTO public.who_global_data VALUES (6950, 21, 3833, 0, 125, 30, 3);
INSERT INTO public.who_global_data VALUES (6951, 1612, 235491, 28, 2694, 30, 11);
INSERT INTO public.who_global_data VALUES (6952, 26391, 1835038, 1070, 37607, 30, 89);
INSERT INTO public.who_global_data VALUES (6953, 0, 55168, 0, 335, 30, 24);
INSERT INTO public.who_global_data VALUES (6954, 113, 2626, 2, 10, 30, 162);
INSERT INTO public.who_global_data VALUES (6955, 814, 142267, 48, 5099, 30, 100);
INSERT INTO public.who_global_data VALUES (6956, 0, 28, 0, 0, 30, 47);
INSERT INTO public.who_global_data VALUES (6957, 0, 130, 0, 1, 30, 29);
INSERT INTO public.who_global_data VALUES (6958, 0, 8702, 0, 155, 30, 40);
INSERT INTO public.who_global_data VALUES (6959, 19, 7192, 0, 123, 30, 222);
INSERT INTO public.who_global_data VALUES (6960, 783, 140202, 40, 4899, 30, 132);
INSERT INTO public.who_global_data VALUES (6961, 1, 301, 0, 13, 30, 130);
INSERT INTO public.who_global_data VALUES (6962, 27, 13845, 0, 81, 30, 234);
INSERT INTO public.who_global_data VALUES (6963, 0, 2447, 0, 45, 30, 23);
INSERT INTO public.who_global_data VALUES (6964, 28, 6407, 0, 166, 30, 192);
INSERT INTO public.who_global_data VALUES (6965, 0, 10127, 0, 236, 30, 69);
INSERT INTO public.who_global_data VALUES (6966, 0, 26, 0, 0, 30, 187);
INSERT INTO public.who_global_data VALUES (6967, 424, 123822, 5, 3186, 30, 230);
INSERT INTO public.who_global_data VALUES (6968, 3068, 334836, 127, 10325, 30, 77);
INSERT INTO public.who_global_data VALUES (6969, 21, 5832, 0, 29, 30, 9);
INSERT INTO public.who_global_data VALUES (6970, 20346, 10395278, 222, 150336, 30, 74);
INSERT INTO public.who_global_data VALUES (6971, 8854, 788402, 187, 23296, 30, 224);
INSERT INTO public.who_global_data VALUES (6972, 6283, 1261903, 82, 55830, 30, 199);
INSERT INTO public.who_global_data VALUES (6973, 839, 599965, 9, 12865, 30, 190);
INSERT INTO public.who_global_data VALUES (6974, 7832, 121154, 17, 2299, 30, 12);
INSERT INTO public.who_global_data VALUES (6975, 6, 386, 0, 25, 30, 104);
INSERT INTO public.who_global_data VALUES (6976, 8236, 457799, 24, 3514, 30, 153);
INSERT INTO public.who_global_data VALUES (6977, 20326, 2201945, 548, 76877, 30, 91);
INSERT INTO public.who_global_data VALUES (6978, 84, 13330, 1, 306, 30, 215);
INSERT INTO public.who_global_data VALUES (6979, 6076, 258393, 72, 3791, 30, 84);
INSERT INTO public.who_global_data VALUES (6980, 21, 2863, 4, 51, 30, 231);
INSERT INTO public.who_global_data VALUES (6981, 1553, 302856, 15, 3955, 30, 196);
INSERT INTO public.who_global_data VALUES (6982, 907, 206840, 0, 2845, 30, 105);
INSERT INTO public.who_global_data VALUES (6983, 271, 97398, 4, 1694, 30, 122);
INSERT INTO public.who_global_data VALUES (6984, 0, 0, 0, 0, 30, 159);
INSERT INTO public.who_global_data VALUES (6985, 301, 52591, 2, 1347, 30, 75);
INSERT INTO public.who_global_data VALUES (6986, 411, 152438, 0, 938, 30, 27);
INSERT INTO public.who_global_data VALUES (6987, 170, 81826, 2, 1363, 30, 54);
INSERT INTO public.who_global_data VALUES (6988, 0, 41, 0, 0, 30, 226);
INSERT INTO public.who_global_data VALUES (6989, 1229, 45171, 32, 754, 30, 79);
INSERT INTO public.who_global_data VALUES (6990, 4166, 199925, 21, 1537, 30, 56);
INSERT INTO public.who_global_data VALUES (6991, 0, 2577, 0, 50, 30, 117);
INSERT INTO public.who_global_data VALUES (6992, 0, 1800, 0, 83, 30, 152);
INSERT INTO public.who_global_data VALUES (6993, 424, 102880, 10, 1546, 30, 16);
INSERT INTO public.who_global_data VALUES (6994, 10, 2372, 0, 42, 30, 10);
INSERT INTO public.who_global_data VALUES (6995, 2334, 154548, 43, 2092, 30, 201);
INSERT INTO public.who_global_data VALUES (6996, 282, 47430, 3, 517, 30, 174);
INSERT INTO public.who_global_data VALUES (6997, 0, 17767, 0, 262, 30, 119);
INSERT INTO public.who_global_data VALUES (6998, 227, 7337, 0, 199, 30, 168);
INSERT INTO public.who_global_data VALUES (6999, 2593, 125438, 4, 513, 30, 99);
INSERT INTO public.who_global_data VALUES (7000, 37, 13967, 0, 48, 30, 171);
INSERT INTO public.who_global_data VALUES (7001, 135, 7395, 6, 285, 30, 87);
INSERT INTO public.who_global_data VALUES (7002, 164, 13776, 1, 228, 30, 123);
INSERT INTO public.who_global_data VALUES (7003, 0, 4, 0, 0, 30, 151);
INSERT INTO public.who_global_data VALUES (7004, 0, 6117, 0, 43, 30, 213);
INSERT INTO public.who_global_data VALUES (7005, 130, 15111, 6, 373, 30, 118);
INSERT INTO public.who_global_data VALUES (7006, 0, 531, 0, 10, 30, 134);
INSERT INTO public.who_global_data VALUES (7007, 0, 6045, 0, 56, 30, 65);
INSERT INTO public.who_global_data VALUES (7008, 11271, 1466490, 1065, 128822, 30, 102);
INSERT INTO public.who_global_data VALUES (7009, 0, 0, 0, 0, 30, 223);
INSERT INTO public.who_global_data VALUES (7010, 31, 981, 0, 4, 30, 4);
INSERT INTO public.who_global_data VALUES (7011, 41, 1349, 0, 1, 30, 146);
INSERT INTO public.who_global_data VALUES (7012, 479, 51501, 7, 712, 30, 31);
INSERT INTO public.who_global_data VALUES (7013, 0, 13, 0, 1, 30, 127);
INSERT INTO public.who_global_data VALUES (7014, 1642, 447081, 37, 7618, 30, 22);
INSERT INTO public.who_global_data VALUES (7015, 204, 19667, 1, 172, 30, 115);
INSERT INTO public.who_global_data VALUES (7016, 596, 128178, 19, 2785, 30, 106);
INSERT INTO public.who_global_data VALUES (7017, 423, 26310, 13, 235, 30, 90);
INSERT INTO public.who_global_data VALUES (7018, 0, 0, 0, 0, 30, 70);
INSERT INTO public.who_global_data VALUES (7019, 409, 263193, 6, 1899, 30, 46);
INSERT INTO public.who_global_data VALUES (7020, 7101, 840190, 175, 11979, 30, 139);
INSERT INTO public.who_global_data VALUES (7021, 0, 40, 0, 0, 30, 42);
INSERT INTO public.who_global_data VALUES (7022, 4, 1832, 0, 25, 30, 80);
INSERT INTO public.who_global_data VALUES (7023, 0, 4867, 0, 166, 30, 203);
INSERT INTO public.who_global_data VALUES (7024, 0, 3322, 0, 104, 30, 136);
INSERT INTO public.who_global_data VALUES (7025, 1664, 94369, 5, 1324, 30, 63);
INSERT INTO public.who_global_data VALUES (7026, 0, 0, 0, 0, 30, 17);
INSERT INTO public.who_global_data VALUES (7027, 0, 125, 0, 2, 30, 172);
INSERT INTO public.who_global_data VALUES (7028, 619, 85328, 12, 2571, 30, 109);
INSERT INTO public.who_global_data VALUES (7029, 940, 52180, 14, 466, 30, 200);
INSERT INTO public.who_global_data VALUES (7030, 1088, 162322, 14, 1663, 30, 93);
INSERT INTO public.who_global_data VALUES (7031, 114, 129888, 2, 1504, 30, 5);
INSERT INTO public.who_global_data VALUES (7032, 0, 745, 0, 13, 30, 214);
INSERT INTO public.who_global_data VALUES (7033, 2118, 492594, 52, 10461, 30, 204);
INSERT INTO public.who_global_data VALUES (7034, 0, 0, 0, 0, 30, 198);
INSERT INTO public.who_global_data VALUES (7035, 3540, 259770, 41, 4238, 30, 173);
INSERT INTO public.who_global_data VALUES (7036, 0, 799, 0, 9, 30, 229);
INSERT INTO public.who_global_data VALUES (7037, 959, 110796, 16, 2321, 30, 76);
INSERT INTO public.who_global_data VALUES (7038, 960, 1022018, 52, 37925, 30, 138);
INSERT INTO public.who_global_data VALUES (7039, 1044, 480737, 26, 9347, 30, 98);
INSERT INTO public.who_global_data VALUES (7040, 0, 0, 0, 0, 30, 103);
INSERT INTO public.who_global_data VALUES (7041, 12119, 1356882, 186, 30241, 30, 225);
INSERT INTO public.who_global_data VALUES (7042, 10027, 446606, 91, 7377, 30, 131);
INSERT INTO public.who_global_data VALUES (7043, 293, 79612, 8, 1570, 30, 235);
INSERT INTO public.who_global_data VALUES (7044, 209, 145061, 0, 245, 30, 137);
INSERT INTO public.who_global_data VALUES (7045, 869, 66676, 19, 1046, 30, 81);
INSERT INTO public.who_global_data VALUES (7046, 950, 147871, 18, 3088, 30, 182);
INSERT INTO public.who_global_data VALUES (7047, 55, 9173, 0, 42, 30, 145);
INSERT INTO public.who_global_data VALUES (7048, 5719, 654007, 121, 16299, 30, 26);
INSERT INTO public.who_global_data VALUES (7049, 23541, 3332142, 506, 60457, 30, 170);
INSERT INTO public.who_global_data VALUES (7050, 210, 9058, 7, 112, 30, 191);
INSERT INTO public.who_global_data VALUES (7051, 0, 5, 0, 0, 30, 221);
INSERT INTO public.who_global_data VALUES (7052, 0, 191, 0, 0, 30, 64);
INSERT INTO public.who_global_data VALUES (7053, 0, 0, 0, 0, 30, 116);
INSERT INTO public.who_global_data VALUES (7054, 0, 33, 0, 0, 30, 128);
INSERT INTO public.who_global_data VALUES (7055, 20, 380, 0, 5, 30, 6);
INSERT INTO public.who_global_data VALUES (7056, 0, 1002, 0, 12, 30, 227);
INSERT INTO public.who_global_data VALUES (7057, 0, 16, 0, 0, 30, 68);
INSERT INTO public.who_global_data VALUES (7058, 16, 149, 0, 0, 30, 184);
INSERT INTO public.who_global_data VALUES (7059, 0, 2, 0, 0, 30, 82);
INSERT INTO public.who_global_data VALUES (7060, 0, 2549, 0, 62, 30, 149);
INSERT INTO public.who_global_data VALUES (7061, 0, 1024, 0, 17, 30, 197);
INSERT INTO public.who_global_data VALUES (7062, 118, 363377, 7, 6272, 30, 78);
INSERT INTO public.who_global_data VALUES (7063, 192, 20156, 5, 433, 30, 233);
INSERT INTO public.who_global_data VALUES (7064, 2882, 352120, 39, 3444, 30, 133);
INSERT INTO public.who_global_data VALUES (7065, 27, 373, 0, 1, 30, 35);
INSERT INTO public.who_global_data VALUES (7066, 15, 2739, 0, 76, 30, 114);
INSERT INTO public.who_global_data VALUES (7067, 31, 58780, 0, 29, 30, 237);
INSERT INTO public.who_global_data VALUES (7068, 0, 19, 0, 0, 30, 55);
INSERT INTO public.who_global_data VALUES (7069, 39, 1504, 0, 27, 30, 176);
INSERT INTO public.who_global_data VALUES (7070, 2137, 198184, 60, 2717, 30, 202);
INSERT INTO public.who_global_data VALUES (7071, 2690, 134663, 25, 3212, 30, 155);
INSERT INTO public.who_global_data VALUES (7072, 0, 17, 0, 0, 30, 32);
INSERT INTO public.who_global_data VALUES (7073, 12, 4726, 0, 130, 30, 220);
INSERT INTO public.who_global_data VALUES (7074, 21832, 1149591, 844, 31368, 30, 30);
INSERT INTO public.who_global_data VALUES (7075, 15, 3604, 0, 63, 30, 147);
INSERT INTO public.who_global_data VALUES (7076, 29434, 2097850, 193, 52692, 30, 208);
INSERT INTO public.who_global_data VALUES (7077, 522, 46248, 2, 219, 30, 45);
INSERT INTO public.who_global_data VALUES (7078, 0, 26279, 0, 1603, 30, 110);
INSERT INTO public.who_global_data VALUES (7079, 93, 6586, 1, 125, 30, 88);
INSERT INTO public.who_global_data VALUES (7080, 7546, 477212, 93, 10296, 30, 51);
INSERT INTO public.who_global_data VALUES (7081, 3346, 473574, 58, 7671, 30, 209);
INSERT INTO public.who_global_data VALUES (7082, 98, 11988, 6, 747, 30, 205);
INSERT INTO public.who_global_data VALUES (7083, 6, 13701, 0, 91, 30, 18);
INSERT INTO public.who_global_data VALUES (7084, 305, 9636, 1, 67, 30, 72);
INSERT INTO public.who_global_data VALUES (7085, 62322, 2836805, 1041, 77346, 30, 44);
INSERT INTO public.who_global_data VALUES (7086, 0, 49, 0, 0, 30, 15);
INSERT INTO public.who_global_data VALUES (7087, 85, 3807, 1, 70, 30, 25);
INSERT INTO public.who_global_data VALUES (7088, 0, 0, 0, 0, 30, 179);
INSERT INTO public.who_global_data VALUES (7089, 0, 0, 0, 0, 30, 34);
INSERT INTO public.who_global_data VALUES (7090, 8, 7186, 0, 127, 30, 207);
INSERT INTO public.who_global_data VALUES (7091, 2820, 149881, 70, 5004, 30, 166);
INSERT INTO public.who_global_data VALUES (7092, 13830, 2283931, 191, 22070, 30, 126);
INSERT INTO public.who_global_data VALUES (7093, 0, 0, 0, 0, 30, 97);
INSERT INTO public.who_global_data VALUES (7094, 8, 918, 0, 6, 30, 36);
INSERT INTO public.who_global_data VALUES (7095, 0, 0, 0, 0, 30, 125);
INSERT INTO public.who_global_data VALUES (7096, 652, 36702, 20, 294, 30, 124);
INSERT INTO public.who_global_data VALUES (7097, 8997, 1099493, 148, 19505, 30, 185);
INSERT INTO public.who_global_data VALUES (7098, 2067, 218766, 4, 689, 30, 194);
INSERT INTO public.who_global_data VALUES (7099, 0, 509, 0, 21, 30, 144);
INSERT INTO public.who_global_data VALUES (7100, 227369, 20870913, 3533, 354286, 30, 19);
INSERT INTO public.who_global_data VALUES (7101, 28, 2083, 0, 24, 30, 217);
INSERT INTO public.who_global_data VALUES (7102, 678, 22104, 6, 217, 30, 148);
INSERT INTO public.who_global_data VALUES (7103, 62, 77412, 0, 615, 30, 86);
INSERT INTO public.who_global_data VALUES (7104, 0, 1, 0, 0, 30, 13);
INSERT INTO public.who_global_data VALUES (7105, 255, 114662, 4, 1042, 30, 157);
INSERT INTO public.who_global_data VALUES (7106, 1, 1505, 0, 35, 30, 8);
INSERT INTO public.who_global_data VALUES (7107, 0, 4, 0, 0, 30, 73);
INSERT INTO public.who_global_data VALUES (7108, 1, 2106, 0, 611, 30, 101);
INSERT INTO public.who_global_data VALUES (7109, 850, 23495, 5, 417, 30, 165);
INSERT INTO public.who_global_data VALUES (7110, 610, 17804, 13, 431, 30, 14);
INSERT INTO public.who_global_data VALUES (7111, 94, 53105, 7, 2244, 31, 193);
INSERT INTO public.who_global_data VALUES (7112, 660, 60283, 11, 1210, 31, 113);
INSERT INTO public.who_global_data VALUES (7113, 0, 100645, 0, 2777, 31, 143);
INSERT INTO public.who_global_data VALUES (7114, 0, 0, 0, 0, 31, 219);
INSERT INTO public.who_global_data VALUES (7115, 59, 8308, 0, 84, 31, 186);
INSERT INTO public.who_global_data VALUES (7116, 0, 17684, 0, 408, 31, 52);
INSERT INTO public.who_global_data VALUES (7117, 0, 15, 0, 0, 31, 180);
INSERT INTO public.who_global_data VALUES (7118, 0, 160, 0, 5, 31, 167);
INSERT INTO public.who_global_data VALUES (7119, 8222, 1648940, 152, 43634, 31, 154);
INSERT INTO public.who_global_data VALUES (7120, 309, 160853, 12, 2890, 31, 94);
INSERT INTO public.who_global_data VALUES (7121, 42, 5606, 0, 49, 31, 66);
INSERT INTO public.who_global_data VALUES (7122, 15, 28519, 0, 909, 31, 58);
INSERT INTO public.who_global_data VALUES (7123, 2255, 368780, 77, 6403, 31, 163);
INSERT INTO public.who_global_data VALUES (7124, 802, 221401, 31, 2792, 31, 37);
INSERT INTO public.who_global_data VALUES (7125, 4, 7928, 0, 175, 31, 142);
INSERT INTO public.who_global_data VALUES (7126, 229, 93995, 0, 352, 31, 83);
INSERT INTO public.who_global_data VALUES (7127, 991, 517920, 20, 7670, 31, 228);
INSERT INTO public.who_global_data VALUES (7128, 37, 643, 0, 7, 31, 188);
INSERT INTO public.who_global_data VALUES (7129, 1273, 203104, 10, 1471, 31, 62);
INSERT INTO public.who_global_data VALUES (7130, 2823, 657651, 63, 19870, 31, 160);
INSERT INTO public.who_global_data VALUES (7131, 37, 10938, 7, 257, 31, 50);
INSERT INTO public.who_global_data VALUES (7132, 53, 3304, 0, 44, 31, 33);
INSERT INTO public.who_global_data VALUES (7133, 2, 624, 0, 10, 31, 183);
INSERT INTO public.who_global_data VALUES (7134, 0, 734, 0, 0, 31, 92);
INSERT INTO public.who_global_data VALUES (7135, 1010, 163671, 18, 9219, 31, 158);
INSERT INTO public.who_global_data VALUES (7136, 8, 225, 0, 3, 31, 67);
INSERT INTO public.who_global_data VALUES (7137, 564, 113392, 32, 4211, 31, 57);
INSERT INTO public.who_global_data VALUES (7138, 0, 14805, 0, 42, 31, 38);
INSERT INTO public.who_global_data VALUES (7139, 20006, 7753752, 543, 196561, 31, 141);
INSERT INTO public.who_global_data VALUES (7140, 10, 107, 0, 1, 31, 178);
INSERT INTO public.who_global_data VALUES (7141, 0, 172, 0, 3, 31, 108);
INSERT INTO public.who_global_data VALUES (7142, 1310, 205390, 67, 7902, 31, 39);
INSERT INTO public.who_global_data VALUES (7143, 0, 7126, 0, 86, 31, 2);
INSERT INTO public.who_global_data VALUES (7144, 0, 842, 0, 2, 31, 195);
INSERT INTO public.who_global_data VALUES (7145, 34, 11983, 0, 113, 31, 107);
INSERT INTO public.who_global_data VALUES (7146, 1, 383, 0, 0, 31, 161);
INSERT INTO public.who_global_data VALUES (7147, 0, 26848, 0, 448, 31, 212);
INSERT INTO public.who_global_data VALUES (7148, 9761, 611424, 209, 16074, 31, 181);
INSERT INTO public.who_global_data VALUES (7149, 9, 347, 0, 2, 31, 53);
INSERT INTO public.who_global_data VALUES (7150, 0, 4963, 0, 63, 31, 164);
INSERT INTO public.who_global_data VALUES (7151, 60, 2289, 1, 105, 31, 140);
INSERT INTO public.who_global_data VALUES (7152, 2460, 623101, 21, 16788, 31, 20);
INSERT INTO public.who_global_data VALUES (7153, 66, 97127, 0, 4794, 31, 112);
INSERT INTO public.who_global_data VALUES (7154, 10311, 1686131, 222, 44187, 31, 111);
INSERT INTO public.who_global_data VALUES (7155, 0, 864, 0, 13, 31, 71);
INSERT INTO public.who_global_data VALUES (7156, 0, 6200, 0, 100, 31, 218);
INSERT INTO public.who_global_data VALUES (7157, 0, 0, 0, 0, 31, 43);
INSERT INTO public.who_global_data VALUES (7158, 717, 172436, 11, 2229, 31, 49);
INSERT INTO public.who_global_data VALUES (7159, 152, 22800, 0, 138, 31, 1);
INSERT INTO public.who_global_data VALUES (7160, 1896, 216286, 44, 4223, 31, 48);
INSERT INTO public.who_global_data VALUES (7161, 224, 12964, 0, 147, 31, 232);
INSERT INTO public.who_global_data VALUES (7162, 6, 4323, 0, 16, 31, 175);
INSERT INTO public.who_global_data VALUES (7163, 569, 25208, 1, 134, 31, 21);
INSERT INTO public.who_global_data VALUES (7164, 17332, 776967, 179, 12436, 31, 156);
INSERT INTO public.who_global_data VALUES (7165, 0, 0, 0, 0, 31, 95);
INSERT INTO public.who_global_data VALUES (7166, 155, 18152, 5, 601, 31, 177);
INSERT INTO public.who_global_data VALUES (7167, 1992, 172779, 31, 1420, 31, 210);
INSERT INTO public.who_global_data VALUES (7168, 8, 5854, 0, 61, 31, 120);
INSERT INTO public.who_global_data VALUES (7169, 0, 96, 0, 0, 31, 135);
INSERT INTO public.who_global_data VALUES (7170, 2518, 175849, 1, 2419, 31, 206);
INSERT INTO public.who_global_data VALUES (7171, 1003, 216083, 34, 14103, 31, 189);
INSERT INTO public.who_global_data VALUES (7172, 1119, 144583, 55, 7918, 31, 129);
INSERT INTO public.who_global_data VALUES (7173, 268, 47355, 9, 1373, 31, 121);
INSERT INTO public.who_global_data VALUES (7174, 0, 5279, 0, 86, 31, 59);
INSERT INTO public.who_global_data VALUES (7175, 82, 1445, 0, 3, 31, 96);
INSERT INTO public.who_global_data VALUES (7176, 717, 30667, 0, 258, 31, 41);
INSERT INTO public.who_global_data VALUES (7177, 200, 10338, 8, 252, 31, 216);
INSERT INTO public.who_global_data VALUES (7178, 322, 126241, 13, 1963, 31, 236);
INSERT INTO public.who_global_data VALUES (7179, 0, 29, 0, 0, 31, 150);
INSERT INTO public.who_global_data VALUES (7180, 4, 626, 0, 0, 31, 61);
INSERT INTO public.who_global_data VALUES (7181, 0, 49, 0, 2, 31, 7);
INSERT INTO public.who_global_data VALUES (7182, 299, 37218, 11, 576, 31, 169);
INSERT INTO public.who_global_data VALUES (7183, 20366, 2635551, 867, 65902, 31, 28);
INSERT INTO public.who_global_data VALUES (7184, 123, 13497, 0, 72, 31, 85);
INSERT INTO public.who_global_data VALUES (7185, 100, 17088, 0, 121, 31, 211);
INSERT INTO public.who_global_data VALUES (7186, 0, 9605, 0, 66, 31, 60);
INSERT INTO public.who_global_data VALUES (7187, 6, 3812, 0, 125, 31, 3);
INSERT INTO public.who_global_data VALUES (7188, 1800, 233879, 20, 2666, 31, 11);
INSERT INTO public.who_global_data VALUES (7189, 21237, 1808647, 1019, 36537, 31, 89);
INSERT INTO public.who_global_data VALUES (7190, 0, 55168, 0, 335, 31, 24);
INSERT INTO public.who_global_data VALUES (7191, 107, 2513, 0, 8, 31, 162);
INSERT INTO public.who_global_data VALUES (7192, 927, 141453, 40, 5051, 31, 100);
INSERT INTO public.who_global_data VALUES (7193, 1, 28, 0, 0, 31, 47);
INSERT INTO public.who_global_data VALUES (7194, 0, 130, 0, 1, 31, 29);
INSERT INTO public.who_global_data VALUES (7195, 0, 8702, 0, 155, 31, 40);
INSERT INTO public.who_global_data VALUES (7196, 10, 7173, 0, 123, 31, 222);
INSERT INTO public.who_global_data VALUES (7197, 763, 139419, 24, 4859, 31, 132);
INSERT INTO public.who_global_data VALUES (7198, 0, 300, 0, 13, 31, 130);
INSERT INTO public.who_global_data VALUES (7199, 19, 13818, 0, 81, 31, 234);
INSERT INTO public.who_global_data VALUES (7200, 0, 2447, 0, 45, 31, 23);
INSERT INTO public.who_global_data VALUES (7201, 21, 6379, 2, 166, 31, 192);
INSERT INTO public.who_global_data VALUES (7202, 0, 10127, 0, 236, 31, 69);
INSERT INTO public.who_global_data VALUES (7203, 0, 26, 0, 0, 31, 187);
INSERT INTO public.who_global_data VALUES (7204, 29, 123398, 1, 3181, 31, 230);
INSERT INTO public.who_global_data VALUES (7205, 2047, 331768, 118, 10198, 31, 77);
INSERT INTO public.who_global_data VALUES (7206, 16, 5811, 0, 29, 31, 9);
INSERT INTO public.who_global_data VALUES (7207, 18088, 10374932, 264, 150114, 31, 74);
INSERT INTO public.who_global_data VALUES (7208, 7445, 779548, 198, 23109, 31, 224);
INSERT INTO public.who_global_data VALUES (7209, 6113, 1255620, 98, 55748, 31, 199);
INSERT INTO public.who_global_data VALUES (7210, 757, 599126, 12, 12856, 31, 190);
INSERT INTO public.who_global_data VALUES (7211, 5325, 113322, 17, 2282, 31, 12);
INSERT INTO public.who_global_data VALUES (7212, 0, 380, 0, 25, 31, 104);
INSERT INTO public.who_global_data VALUES (7213, 8404, 449563, 38, 3490, 31, 153);
INSERT INTO public.who_global_data VALUES (7214, 15375, 2181619, 649, 76329, 31, 91);
INSERT INTO public.who_global_data VALUES (7215, 43, 13246, 1, 305, 31, 215);
INSERT INTO public.who_global_data VALUES (7216, 4357, 252317, 64, 3719, 31, 84);
INSERT INTO public.who_global_data VALUES (7217, 21, 2842, 3, 47, 31, 231);
INSERT INTO public.who_global_data VALUES (7218, 1472, 301303, 21, 3940, 31, 196);
INSERT INTO public.who_global_data VALUES (7219, 869, 205933, 0, 2845, 31, 105);
INSERT INTO public.who_global_data VALUES (7220, 219, 97127, 4, 1690, 31, 122);
INSERT INTO public.who_global_data VALUES (7221, 0, 0, 0, 0, 31, 159);
INSERT INTO public.who_global_data VALUES (7222, 199, 52290, 4, 1345, 31, 75);
INSERT INTO public.who_global_data VALUES (7223, 312, 152027, 0, 938, 31, 27);
INSERT INTO public.who_global_data VALUES (7224, 144, 81656, 1, 1361, 31, 54);
INSERT INTO public.who_global_data VALUES (7225, 0, 41, 0, 0, 31, 226);
INSERT INTO public.who_global_data VALUES (7226, 824, 43942, 30, 722, 31, 79);
INSERT INTO public.who_global_data VALUES (7227, 3620, 195759, 17, 1516, 31, 56);
INSERT INTO public.who_global_data VALUES (7228, 0, 2577, 0, 50, 31, 117);
INSERT INTO public.who_global_data VALUES (7229, 0, 1800, 0, 83, 31, 152);
INSERT INTO public.who_global_data VALUES (7230, 481, 102456, 10, 1536, 31, 16);
INSERT INTO public.who_global_data VALUES (7231, 30, 2362, 0, 42, 31, 10);
INSERT INTO public.who_global_data VALUES (7232, 2717, 152214, 34, 2049, 31, 201);
INSERT INTO public.who_global_data VALUES (7233, 163, 47148, 6, 514, 31, 174);
INSERT INTO public.who_global_data VALUES (7234, 0, 17767, 0, 262, 31, 119);
INSERT INTO public.who_global_data VALUES (7235, 175, 7110, 3, 199, 31, 168);
INSERT INTO public.who_global_data VALUES (7236, 2027, 122845, 8, 509, 31, 99);
INSERT INTO public.who_global_data VALUES (7237, 37, 13930, 0, 48, 31, 171);
INSERT INTO public.who_global_data VALUES (7238, 0, 7260, 0, 279, 31, 87);
INSERT INTO public.who_global_data VALUES (7239, 224, 13612, 1, 227, 31, 123);
INSERT INTO public.who_global_data VALUES (7240, 0, 4, 0, 0, 31, 151);
INSERT INTO public.who_global_data VALUES (7241, 0, 6117, 0, 43, 31, 213);
INSERT INTO public.who_global_data VALUES (7242, 617, 14981, 20, 367, 31, 118);
INSERT INTO public.who_global_data VALUES (7243, 0, 531, 0, 10, 31, 134);
INSERT INTO public.who_global_data VALUES (7244, 0, 6045, 0, 56, 31, 65);
INSERT INTO public.who_global_data VALUES (7245, 6464, 1455219, 544, 127757, 31, 102);
INSERT INTO public.who_global_data VALUES (7246, 0, 0, 0, 0, 31, 223);
INSERT INTO public.who_global_data VALUES (7247, 30, 950, 0, 4, 31, 4);
INSERT INTO public.who_global_data VALUES (7248, 22, 1308, 1, 1, 31, 146);
INSERT INTO public.who_global_data VALUES (7249, 497, 51022, 6, 705, 31, 31);
INSERT INTO public.who_global_data VALUES (7250, 0, 13, 0, 1, 31, 127);
INSERT INTO public.who_global_data VALUES (7251, 1637, 445439, 43, 7581, 31, 22);
INSERT INTO public.who_global_data VALUES (7252, 0, 19463, 0, 171, 31, 115);
INSERT INTO public.who_global_data VALUES (7253, 647, 127582, 22, 2766, 31, 106);
INSERT INTO public.who_global_data VALUES (7254, 501, 25887, 4, 222, 31, 90);
INSERT INTO public.who_global_data VALUES (7255, 0, 0, 0, 0, 31, 70);
INSERT INTO public.who_global_data VALUES (7256, 522, 262784, 8, 1893, 31, 46);
INSERT INTO public.who_global_data VALUES (7257, 6381, 833089, 152, 11804, 31, 139);
INSERT INTO public.who_global_data VALUES (7258, 0, 40, 0, 0, 31, 42);
INSERT INTO public.who_global_data VALUES (7259, 0, 1828, 0, 25, 31, 80);
INSERT INTO public.who_global_data VALUES (7260, 38, 4867, 1, 166, 31, 203);
INSERT INTO public.who_global_data VALUES (7261, 0, 3322, 0, 104, 31, 136);
INSERT INTO public.who_global_data VALUES (7262, 1421, 92705, 1, 1319, 31, 63);
INSERT INTO public.who_global_data VALUES (7263, 0, 0, 0, 0, 31, 17);
INSERT INTO public.who_global_data VALUES (7264, 0, 125, 0, 2, 31, 172);
INSERT INTO public.who_global_data VALUES (7265, 580, 84709, 9, 2559, 31, 109);
INSERT INTO public.who_global_data VALUES (7266, 525, 51240, 3, 452, 31, 200);
INSERT INTO public.who_global_data VALUES (7267, 1191, 161234, 20, 1649, 31, 93);
INSERT INTO public.who_global_data VALUES (7268, 190, 129774, 0, 1502, 31, 5);
INSERT INTO public.who_global_data VALUES (7269, 0, 745, 0, 13, 31, 214);
INSERT INTO public.who_global_data VALUES (7270, 1947, 490476, 59, 10409, 31, 204);
INSERT INTO public.who_global_data VALUES (7271, 0, 0, 0, 0, 31, 198);
INSERT INTO public.who_global_data VALUES (7272, 2494, 256230, 57, 4197, 31, 173);
INSERT INTO public.who_global_data VALUES (7273, 0, 799, 0, 9, 31, 229);
INSERT INTO public.who_global_data VALUES (7274, 764, 109837, 13, 2305, 31, 76);
INSERT INTO public.who_global_data VALUES (7275, 1583, 1021058, 43, 37873, 31, 138);
INSERT INTO public.who_global_data VALUES (7276, 932, 479693, 58, 9321, 31, 98);
INSERT INTO public.who_global_data VALUES (7277, 0, 0, 0, 0, 31, 103);
INSERT INTO public.who_global_data VALUES (7278, 14220, 1344763, 553, 30055, 31, 225);
INSERT INTO public.who_global_data VALUES (7279, 4956, 436579, 90, 7286, 31, 131);
INSERT INTO public.who_global_data VALUES (7280, 514, 79319, 7, 1562, 31, 235);
INSERT INTO public.who_global_data VALUES (7281, 208, 144852, 0, 245, 31, 137);
INSERT INTO public.who_global_data VALUES (7282, 838, 65807, 20, 1027, 31, 81);
INSERT INTO public.who_global_data VALUES (7283, 612, 146921, 16, 3070, 31, 182);
INSERT INTO public.who_global_data VALUES (7284, 0, 9118, 0, 42, 31, 145);
INSERT INTO public.who_global_data VALUES (7285, 4729, 648288, 121, 16178, 31, 26);
INSERT INTO public.who_global_data VALUES (7286, 24217, 3308601, 445, 59951, 31, 170);
INSERT INTO public.who_global_data VALUES (7287, 0, 8848, 0, 105, 31, 191);
INSERT INTO public.who_global_data VALUES (7288, 0, 5, 0, 0, 31, 221);
INSERT INTO public.who_global_data VALUES (7289, 0, 191, 0, 0, 31, 64);
INSERT INTO public.who_global_data VALUES (7290, 0, 0, 0, 0, 31, 116);
INSERT INTO public.who_global_data VALUES (7291, 0, 33, 0, 0, 31, 128);
INSERT INTO public.who_global_data VALUES (7292, 7, 360, 0, 5, 31, 6);
INSERT INTO public.who_global_data VALUES (7293, 0, 1002, 0, 12, 31, 227);
INSERT INTO public.who_global_data VALUES (7294, 0, 16, 0, 0, 31, 68);
INSERT INTO public.who_global_data VALUES (7295, 9, 133, 0, 0, 31, 184);
INSERT INTO public.who_global_data VALUES (7296, 0, 2, 0, 0, 31, 82);
INSERT INTO public.who_global_data VALUES (7297, 56, 2549, 0, 62, 31, 149);
INSERT INTO public.who_global_data VALUES (7298, 0, 1024, 0, 17, 31, 197);
INSERT INTO public.who_global_data VALUES (7299, 104, 363259, 9, 6265, 31, 78);
INSERT INTO public.who_global_data VALUES (7300, 161, 19964, 4, 428, 31, 233);
INSERT INTO public.who_global_data VALUES (7301, 2653, 349238, 41, 3405, 31, 133);
INSERT INTO public.who_global_data VALUES (7302, 24, 346, 0, 1, 31, 35);
INSERT INTO public.who_global_data VALUES (7303, 51, 2724, 0, 76, 31, 114);
INSERT INTO public.who_global_data VALUES (7304, 28, 58749, 0, 29, 31, 237);
INSERT INTO public.who_global_data VALUES (7305, 0, 19, 0, 0, 31, 55);
INSERT INTO public.who_global_data VALUES (7306, 3, 1465, 0, 27, 31, 176);
INSERT INTO public.who_global_data VALUES (7307, 4959, 196047, 54, 2657, 31, 202);
INSERT INTO public.who_global_data VALUES (7308, 3421, 131973, 36, 3187, 31, 155);
INSERT INTO public.who_global_data VALUES (7309, 0, 17, 0, 0, 31, 32);
INSERT INTO public.who_global_data VALUES (7310, 0, 4714, 0, 130, 31, 220);
INSERT INTO public.who_global_data VALUES (7311, 14410, 1127759, 513, 30524, 31, 30);
INSERT INTO public.who_global_data VALUES (7312, 0, 3589, 0, 63, 31, 147);
INSERT INTO public.who_global_data VALUES (7313, 21018, 2068416, 150, 52499, 31, 208);
INSERT INTO public.who_global_data VALUES (7314, 484, 45726, 2, 217, 31, 45);
INSERT INTO public.who_global_data VALUES (7315, 0, 26279, 0, 1603, 31, 110);
INSERT INTO public.who_global_data VALUES (7316, 100, 6493, 1, 124, 31, 88);
INSERT INTO public.who_global_data VALUES (7317, 6984, 469666, 86, 10203, 31, 51);
INSERT INTO public.who_global_data VALUES (7318, 4161, 470228, 61, 7613, 31, 209);
INSERT INTO public.who_global_data VALUES (7319, 91, 11890, 7, 741, 31, 205);
INSERT INTO public.who_global_data VALUES (7320, 9, 13695, 0, 91, 31, 18);
INSERT INTO public.who_global_data VALUES (7321, 365, 9331, 1, 66, 31, 72);
INSERT INTO public.who_global_data VALUES (7322, 60916, 2774483, 874, 76305, 31, 44);
INSERT INTO public.who_global_data VALUES (7323, 5, 49, 0, 0, 31, 15);
INSERT INTO public.who_global_data VALUES (7324, 0, 3722, 0, 69, 31, 25);
INSERT INTO public.who_global_data VALUES (7325, 0, 0, 0, 0, 31, 179);
INSERT INTO public.who_global_data VALUES (7326, 0, 0, 0, 0, 31, 34);
INSERT INTO public.who_global_data VALUES (7327, 10, 7178, 0, 127, 31, 207);
INSERT INTO public.who_global_data VALUES (7328, 2265, 147061, 72, 4934, 31, 166);
INSERT INTO public.who_global_data VALUES (7329, 14494, 2270101, 194, 21879, 31, 126);
INSERT INTO public.who_global_data VALUES (7330, 0, 0, 0, 0, 31, 97);
INSERT INTO public.who_global_data VALUES (7331, 0, 910, 0, 6, 31, 36);
INSERT INTO public.who_global_data VALUES (7332, 0, 0, 0, 0, 31, 125);
INSERT INTO public.who_global_data VALUES (7333, 0, 36050, 0, 274, 31, 124);
INSERT INTO public.who_global_data VALUES (7334, 6911, 1090496, 228, 19357, 31, 185);
INSERT INTO public.who_global_data VALUES (7335, 1967, 216699, 3, 685, 31, 194);
INSERT INTO public.who_global_data VALUES (7336, 0, 509, 0, 21, 31, 144);
INSERT INTO public.who_global_data VALUES (7337, 173375, 20643544, 1791, 350753, 31, 19);
INSERT INTO public.who_global_data VALUES (7338, 13, 2055, 1, 24, 31, 217);
INSERT INTO public.who_global_data VALUES (7339, 603, 21426, 7, 211, 31, 148);
INSERT INTO public.who_global_data VALUES (7340, 55, 77350, 1, 615, 31, 86);
INSERT INTO public.who_global_data VALUES (7341, 0, 1, 0, 0, 31, 13);
INSERT INTO public.who_global_data VALUES (7342, 177, 114407, 4, 1038, 31, 157);
INSERT INTO public.who_global_data VALUES (7343, 7, 1504, 0, 35, 31, 8);
INSERT INTO public.who_global_data VALUES (7344, 0, 4, 0, 0, 31, 73);
INSERT INTO public.who_global_data VALUES (7345, 0, 2105, 0, 611, 31, 101);
INSERT INTO public.who_global_data VALUES (7346, 652, 22645, 14, 412, 31, 165);
INSERT INTO public.who_global_data VALUES (7347, 1365, 17194, 34, 418, 31, 14);
INSERT INTO public.who_global_data VALUES (7348, 102, 53011, 7, 2237, 32, 193);
INSERT INTO public.who_global_data VALUES (7349, 185, 59623, 6, 1199, 32, 113);
INSERT INTO public.who_global_data VALUES (7350, 486, 100645, 8, 2777, 32, 143);
INSERT INTO public.who_global_data VALUES (7351, 0, 0, 0, 0, 32, 219);
INSERT INTO public.who_global_data VALUES (7352, 57, 8249, 0, 84, 32, 186);
INSERT INTO public.who_global_data VALUES (7353, 42, 17684, 0, 408, 32, 52);
INSERT INTO public.who_global_data VALUES (7354, 0, 15, 0, 0, 32, 180);
INSERT INTO public.who_global_data VALUES (7355, 1, 160, 0, 5, 32, 167);
INSERT INTO public.who_global_data VALUES (7356, 5884, 1640718, 107, 43482, 32, 154);
INSERT INTO public.who_global_data VALUES (7357, 324, 160544, 14, 2878, 32, 94);
INSERT INTO public.who_global_data VALUES (7358, 122, 5564, 0, 49, 32, 66);
INSERT INTO public.who_global_data VALUES (7359, 21, 28504, 0, 909, 32, 58);
INSERT INTO public.who_global_data VALUES (7360, 1951, 366525, 73, 6326, 32, 163);
INSERT INTO public.who_global_data VALUES (7361, 334, 220599, 28, 2761, 32, 37);
INSERT INTO public.who_global_data VALUES (7362, 10, 7924, 0, 175, 32, 142);
INSERT INTO public.who_global_data VALUES (7363, 288, 93766, 0, 352, 32, 83);
INSERT INTO public.who_global_data VALUES (7364, 910, 516929, 24, 7650, 32, 228);
INSERT INTO public.who_global_data VALUES (7365, 211, 606, 0, 7, 32, 188);
INSERT INTO public.who_global_data VALUES (7366, 1869, 201831, 10, 1461, 32, 62);
INSERT INTO public.who_global_data VALUES (7367, 3121, 654828, 59, 19807, 32, 160);
INSERT INTO public.who_global_data VALUES (7368, 94, 10901, 1, 250, 32, 50);
INSERT INTO public.who_global_data VALUES (7369, 0, 3251, 0, 44, 32, 33);
INSERT INTO public.who_global_data VALUES (7370, 0, 622, 0, 10, 32, 183);
INSERT INTO public.who_global_data VALUES (7371, 18, 734, 0, 0, 32, 92);
INSERT INTO public.who_global_data VALUES (7372, 606, 162661, 15, 9201, 32, 158);
INSERT INTO public.who_global_data VALUES (7373, 52, 217, 0, 3, 32, 67);
INSERT INTO public.who_global_data VALUES (7374, 183, 112828, 48, 4179, 32, 57);
INSERT INTO public.who_global_data VALUES (7375, 0, 14805, 0, 42, 32, 38);
INSERT INTO public.who_global_data VALUES (7376, 17341, 7733746, 293, 196018, 32, 141);
INSERT INTO public.who_global_data VALUES (7377, 4, 97, 0, 1, 32, 178);
INSERT INTO public.who_global_data VALUES (7378, 0, 172, 0, 3, 32, 108);
INSERT INTO public.who_global_data VALUES (7379, 1029, 204080, 157, 7835, 32, 39);
INSERT INTO public.who_global_data VALUES (7380, 75, 7126, 0, 86, 32, 2);
INSERT INTO public.who_global_data VALUES (7381, 0, 842, 0, 2, 32, 195);
INSERT INTO public.who_global_data VALUES (7382, 29, 11949, 0, 113, 32, 107);
INSERT INTO public.who_global_data VALUES (7383, 0, 382, 0, 0, 32, 161);
INSERT INTO public.who_global_data VALUES (7384, 0, 26848, 0, 448, 32, 212);
INSERT INTO public.who_global_data VALUES (7385, 6578, 601663, 41, 15865, 32, 181);
INSERT INTO public.who_global_data VALUES (7386, 0, 338, 0, 2, 32, 53);
INSERT INTO public.who_global_data VALUES (7387, 0, 4963, 0, 63, 32, 164);
INSERT INTO public.who_global_data VALUES (7388, 16, 2229, 0, 104, 32, 140);
INSERT INTO public.who_global_data VALUES (7389, 2450, 620641, 0, 16767, 32, 20);
INSERT INTO public.who_global_data VALUES (7390, 89, 97061, 3, 4794, 32, 112);
INSERT INTO public.who_global_data VALUES (7391, 9412, 1675820, 200, 43965, 32, 111);
INSERT INTO public.who_global_data VALUES (7392, 0, 864, 0, 13, 32, 71);
INSERT INTO public.who_global_data VALUES (7393, 0, 6200, 0, 100, 32, 218);
INSERT INTO public.who_global_data VALUES (7394, 0, 0, 0, 0, 32, 43);
INSERT INTO public.who_global_data VALUES (7395, 589, 171719, 13, 2218, 32, 49);
INSERT INTO public.who_global_data VALUES (7396, 398, 22648, 1, 138, 32, 1);
INSERT INTO public.who_global_data VALUES (7397, 1071, 214390, 53, 4179, 32, 48);
INSERT INTO public.who_global_data VALUES (7398, 316, 12740, 0, 147, 32, 232);
INSERT INTO public.who_global_data VALUES (7399, 87, 4317, 2, 16, 32, 175);
INSERT INTO public.who_global_data VALUES (7400, 665, 24639, 2, 133, 32, 21);
INSERT INTO public.who_global_data VALUES (7401, 12921, 759635, 187, 12257, 32, 156);
INSERT INTO public.who_global_data VALUES (7402, 0, 0, 0, 0, 32, 95);
INSERT INTO public.who_global_data VALUES (7403, 0, 17997, 0, 596, 32, 177);
INSERT INTO public.who_global_data VALUES (7404, 2076, 170787, 15, 1389, 32, 210);
INSERT INTO public.who_global_data VALUES (7405, 4, 5846, 0, 61, 32, 120);
INSERT INTO public.who_global_data VALUES (7406, 0, 96, 0, 0, 32, 135);
INSERT INTO public.who_global_data VALUES (7407, 0, 173331, 0, 2418, 32, 206);
INSERT INTO public.who_global_data VALUES (7408, 466, 215080, 10, 14069, 32, 189);
INSERT INTO public.who_global_data VALUES (7409, 1277, 143464, 58, 7863, 32, 129);
INSERT INTO public.who_global_data VALUES (7410, 284, 47087, 6, 1364, 32, 121);
INSERT INTO public.who_global_data VALUES (7411, 2, 5279, 0, 86, 32, 59);
INSERT INTO public.who_global_data VALUES (7412, 43, 1363, 0, 3, 32, 96);
INSERT INTO public.who_global_data VALUES (7413, 429, 29950, 7, 258, 32, 41);
INSERT INTO public.who_global_data VALUES (7414, 195, 10138, 13, 244, 32, 216);
INSERT INTO public.who_global_data VALUES (7415, 297, 125919, 2, 1950, 32, 236);
INSERT INTO public.who_global_data VALUES (7416, 0, 29, 0, 0, 32, 150);
INSERT INTO public.who_global_data VALUES (7417, 2, 622, 0, 0, 32, 61);
INSERT INTO public.who_global_data VALUES (7418, 0, 49, 0, 2, 32, 7);
INSERT INTO public.who_global_data VALUES (7419, 147, 36919, 4, 565, 32, 169);
INSERT INTO public.who_global_data VALUES (7420, 3569, 2615185, 376, 65035, 32, 28);
INSERT INTO public.who_global_data VALUES (7421, 101, 13374, 1, 72, 32, 85);
INSERT INTO public.who_global_data VALUES (7422, 62, 16988, 7, 121, 32, 211);
INSERT INTO public.who_global_data VALUES (7423, 34, 9605, 2, 66, 32, 60);
INSERT INTO public.who_global_data VALUES (7424, 4, 3806, 1, 125, 32, 3);
INSERT INTO public.who_global_data VALUES (7425, 2316, 232079, 18, 2646, 32, 11);
INSERT INTO public.who_global_data VALUES (7426, 11897, 1787410, 944, 35518, 32, 89);
INSERT INTO public.who_global_data VALUES (7427, 0, 55168, 0, 335, 32, 24);
INSERT INTO public.who_global_data VALUES (7428, 102, 2406, 1, 8, 32, 162);
INSERT INTO public.who_global_data VALUES (7429, 427, 140526, 54, 5011, 32, 100);
INSERT INTO public.who_global_data VALUES (7430, 0, 27, 0, 0, 32, 47);
INSERT INTO public.who_global_data VALUES (7431, 0, 130, 0, 1, 32, 29);
INSERT INTO public.who_global_data VALUES (7432, 82, 8702, 0, 155, 32, 40);
INSERT INTO public.who_global_data VALUES (7433, 14, 7163, 0, 123, 32, 222);
INSERT INTO public.who_global_data VALUES (7434, 181, 138656, 2, 4835, 32, 132);
INSERT INTO public.who_global_data VALUES (7435, 1, 300, 0, 13, 32, 130);
INSERT INTO public.who_global_data VALUES (7436, 15, 13799, 0, 81, 32, 234);
INSERT INTO public.who_global_data VALUES (7437, 0, 2447, 0, 45, 32, 23);
INSERT INTO public.who_global_data VALUES (7438, 0, 6358, 0, 164, 32, 192);
INSERT INTO public.who_global_data VALUES (7439, 0, 10127, 0, 236, 32, 69);
INSERT INTO public.who_global_data VALUES (7440, 0, 26, 0, 0, 32, 187);
INSERT INTO public.who_global_data VALUES (7441, 225, 123369, 7, 3180, 32, 230);
INSERT INTO public.who_global_data VALUES (7442, 870, 329721, 103, 10080, 32, 77);
INSERT INTO public.who_global_data VALUES (7443, 0, 5795, 0, 29, 32, 9);
INSERT INTO public.who_global_data VALUES (7444, 16375, 10356844, 201, 149850, 32, 74);
INSERT INTO public.who_global_data VALUES (7445, 6753, 772103, 177, 22911, 32, 224);
INSERT INTO public.who_global_data VALUES (7446, 6073, 1249507, 110, 55650, 32, 199);
INSERT INTO public.who_global_data VALUES (7447, 595, 598369, 10, 12844, 32, 190);
INSERT INTO public.who_global_data VALUES (7448, 6110, 107997, 6, 2265, 32, 12);
INSERT INTO public.who_global_data VALUES (7449, 0, 380, 0, 25, 32, 104);
INSERT INTO public.who_global_data VALUES (7450, 5230, 441159, 24, 3452, 32, 153);
INSERT INTO public.who_global_data VALUES (7451, 10798, 2166244, 348, 75680, 32, 91);
INSERT INTO public.who_global_data VALUES (7452, 154, 13203, 0, 304, 32, 215);
INSERT INTO public.who_global_data VALUES (7453, 4113, 247960, 56, 3655, 32, 84);
INSERT INTO public.who_global_data VALUES (7454, 61, 2821, 0, 44, 32, 231);
INSERT INTO public.who_global_data VALUES (7455, 1623, 299831, 16, 3919, 32, 196);
INSERT INTO public.who_global_data VALUES (7456, 771, 205064, 0, 2845, 32, 105);
INSERT INTO public.who_global_data VALUES (7457, 106, 96908, 1, 1686, 32, 122);
INSERT INTO public.who_global_data VALUES (7458, 0, 0, 0, 0, 32, 159);
INSERT INTO public.who_global_data VALUES (7459, 169, 52091, 7, 1341, 32, 75);
INSERT INTO public.who_global_data VALUES (7460, 372, 151715, 1, 938, 32, 27);
INSERT INTO public.who_global_data VALUES (7461, 124, 81512, 0, 1360, 32, 54);
INSERT INTO public.who_global_data VALUES (7462, 0, 41, 0, 0, 32, 226);
INSERT INTO public.who_global_data VALUES (7463, 621, 43118, 12, 692, 32, 79);
INSERT INTO public.who_global_data VALUES (7464, 2861, 192139, 13, 1499, 32, 56);
INSERT INTO public.who_global_data VALUES (7465, 0, 2577, 0, 50, 32, 117);
INSERT INTO public.who_global_data VALUES (7466, 0, 1800, 0, 83, 32, 152);
INSERT INTO public.who_global_data VALUES (7467, 561, 101975, 16, 1526, 32, 16);
INSERT INTO public.who_global_data VALUES (7468, 31, 2332, 2, 42, 32, 10);
INSERT INTO public.who_global_data VALUES (7469, 1510, 149497, 40, 2015, 32, 201);
INSERT INTO public.who_global_data VALUES (7470, 66, 46985, 2, 508, 32, 174);
INSERT INTO public.who_global_data VALUES (7471, 0, 17767, 0, 262, 32, 119);
INSERT INTO public.who_global_data VALUES (7472, 91, 6935, 1, 196, 32, 168);
INSERT INTO public.who_global_data VALUES (7473, 1741, 120818, 7, 501, 32, 99);
INSERT INTO public.who_global_data VALUES (7474, 26, 13893, 0, 48, 32, 171);
INSERT INTO public.who_global_data VALUES (7475, 7, 7260, 1, 279, 32, 87);
INSERT INTO public.who_global_data VALUES (7476, 158, 13388, 4, 226, 32, 123);
INSERT INTO public.who_global_data VALUES (7477, 0, 4, 0, 0, 32, 151);
INSERT INTO public.who_global_data VALUES (7478, 26, 6117, 0, 43, 32, 213);
INSERT INTO public.who_global_data VALUES (7479, 0, 14364, 0, 347, 32, 118);
INSERT INTO public.who_global_data VALUES (7480, 4, 531, 0, 10, 32, 134);
INSERT INTO public.who_global_data VALUES (7481, 155, 6045, 1, 56, 32, 65);
INSERT INTO public.who_global_data VALUES (7482, 5211, 1448755, 362, 127213, 32, 102);
INSERT INTO public.who_global_data VALUES (7483, 0, 0, 0, 0, 32, 223);
INSERT INTO public.who_global_data VALUES (7484, 10, 920, 0, 4, 32, 4);
INSERT INTO public.who_global_data VALUES (7485, 23, 1286, 0, 0, 32, 146);
INSERT INTO public.who_global_data VALUES (7486, 526, 50525, 7, 699, 32, 31);
INSERT INTO public.who_global_data VALUES (7487, 0, 13, 0, 1, 32, 127);
INSERT INTO public.who_global_data VALUES (7488, 656, 443802, 53, 7538, 32, 22);
INSERT INTO public.who_global_data VALUES (7489, 154, 19463, 2, 171, 32, 115);
INSERT INTO public.who_global_data VALUES (7490, 590, 126935, 16, 2744, 32, 106);
INSERT INTO public.who_global_data VALUES (7491, 270, 25386, 3, 218, 32, 90);
INSERT INTO public.who_global_data VALUES (7492, 0, 0, 0, 0, 32, 70);
INSERT INTO public.who_global_data VALUES (7493, 403, 262262, 7, 1885, 32, 46);
INSERT INTO public.who_global_data VALUES (7494, 6641, 826708, 65, 11652, 32, 139);
INSERT INTO public.who_global_data VALUES (7495, 0, 40, 0, 0, 32, 42);
INSERT INTO public.who_global_data VALUES (7496, 3, 1828, 0, 25, 32, 80);
INSERT INTO public.who_global_data VALUES (7497, 0, 4829, 0, 165, 32, 203);
INSERT INTO public.who_global_data VALUES (7498, 114, 3322, 2, 104, 32, 136);
INSERT INTO public.who_global_data VALUES (7499, 1204, 91284, 7, 1318, 32, 63);
INSERT INTO public.who_global_data VALUES (7500, 0, 0, 0, 0, 32, 17);
INSERT INTO public.who_global_data VALUES (7501, 1, 125, 0, 2, 32, 172);
INSERT INTO public.who_global_data VALUES (7502, 105, 84129, 20, 2550, 32, 109);
INSERT INTO public.who_global_data VALUES (7503, 2437, 50715, 13, 449, 32, 200);
INSERT INTO public.who_global_data VALUES (7504, 1009, 160043, 20, 1629, 32, 93);
INSERT INTO public.who_global_data VALUES (7505, 180, 129584, 1, 1502, 32, 5);
INSERT INTO public.who_global_data VALUES (7506, 0, 745, 0, 13, 32, 214);
INSERT INTO public.who_global_data VALUES (7507, 1895, 488529, 39, 10350, 32, 204);
INSERT INTO public.who_global_data VALUES (7508, 0, 0, 0, 0, 32, 198);
INSERT INTO public.who_global_data VALUES (7509, 1972, 253736, 37, 4140, 32, 173);
INSERT INTO public.who_global_data VALUES (7510, 0, 799, 0, 9, 32, 229);
INSERT INTO public.who_global_data VALUES (7511, 355, 109073, 13, 2292, 32, 76);
INSERT INTO public.who_global_data VALUES (7512, 1376, 1019475, 57, 37830, 32, 138);
INSERT INTO public.who_global_data VALUES (7513, 954, 478761, 6, 9263, 32, 98);
INSERT INTO public.who_global_data VALUES (7514, 0, 0, 0, 0, 32, 103);
INSERT INTO public.who_global_data VALUES (7515, 7596, 1330543, 341, 29502, 32, 225);
INSERT INTO public.who_global_data VALUES (7516, 4369, 431623, 78, 7196, 32, 131);
INSERT INTO public.who_global_data VALUES (7517, 636, 78805, 10, 1555, 32, 235);
INSERT INTO public.who_global_data VALUES (7518, 207, 144644, 0, 245, 32, 137);
INSERT INTO public.who_global_data VALUES (7519, 714, 64969, 26, 1007, 32, 81);
INSERT INTO public.who_global_data VALUES (7520, 436, 146309, 17, 3054, 32, 182);
INSERT INTO public.who_global_data VALUES (7521, 81, 9118, 0, 42, 32, 145);
INSERT INTO public.who_global_data VALUES (7522, 3130, 643559, 78, 16057, 32, 26);
INSERT INTO public.who_global_data VALUES (7523, 24246, 3284384, 518, 59506, 32, 170);
INSERT INTO public.who_global_data VALUES (7524, 172, 8848, 4, 105, 32, 191);
INSERT INTO public.who_global_data VALUES (7525, 0, 5, 0, 0, 32, 221);
INSERT INTO public.who_global_data VALUES (7526, 1, 191, 0, 0, 32, 64);
INSERT INTO public.who_global_data VALUES (7527, 0, 0, 0, 0, 32, 116);
INSERT INTO public.who_global_data VALUES (7528, 0, 33, 0, 0, 32, 128);
INSERT INTO public.who_global_data VALUES (7529, 0, 353, 0, 5, 32, 6);
INSERT INTO public.who_global_data VALUES (7530, 7, 1002, 0, 12, 32, 227);
INSERT INTO public.who_global_data VALUES (7531, 0, 16, 0, 0, 32, 68);
INSERT INTO public.who_global_data VALUES (7532, 0, 124, 0, 0, 32, 184);
INSERT INTO public.who_global_data VALUES (7533, 0, 2, 0, 0, 32, 82);
INSERT INTO public.who_global_data VALUES (7534, 30, 2493, 1, 62, 32, 149);
INSERT INTO public.who_global_data VALUES (7535, 0, 1024, 0, 17, 32, 197);
INSERT INTO public.who_global_data VALUES (7536, 94, 363155, 10, 6256, 32, 78);
INSERT INTO public.who_global_data VALUES (7537, 106, 19803, 3, 424, 32, 233);
INSERT INTO public.who_global_data VALUES (7538, 2715, 346585, 39, 3364, 32, 133);
INSERT INTO public.who_global_data VALUES (7539, 26, 322, 1, 1, 32, 35);
INSERT INTO public.who_global_data VALUES (7540, 0, 2673, 0, 76, 32, 114);
INSERT INTO public.who_global_data VALUES (7541, 24, 58721, 0, 29, 32, 237);
INSERT INTO public.who_global_data VALUES (7542, 0, 19, 0, 0, 32, 55);
INSERT INTO public.who_global_data VALUES (7543, 28, 1462, 0, 27, 32, 176);
INSERT INTO public.who_global_data VALUES (7544, 2989, 191088, 82, 2603, 32, 202);
INSERT INTO public.who_global_data VALUES (7545, 2600, 128552, 30, 3151, 32, 155);
INSERT INTO public.who_global_data VALUES (7546, 0, 17, 0, 0, 32, 32);
INSERT INTO public.who_global_data VALUES (7547, 0, 4714, 0, 130, 32, 220);
INSERT INTO public.who_global_data VALUES (7548, 12601, 1113349, 434, 30011, 32, 30);
INSERT INTO public.who_global_data VALUES (7549, 31, 3589, 0, 63, 32, 147);
INSERT INTO public.who_global_data VALUES (7550, 9414, 2047398, 137, 52349, 32, 208);
INSERT INTO public.who_global_data VALUES (7551, 468, 45242, 2, 215, 32, 45);
INSERT INTO public.who_global_data VALUES (7552, 0, 26279, 0, 1603, 32, 110);
INSERT INTO public.who_global_data VALUES (7553, 50, 6393, 0, 123, 32, 88);
INSERT INTO public.who_global_data VALUES (7554, 2756, 462682, 83, 10117, 32, 51);
INSERT INTO public.who_global_data VALUES (7555, 5277, 466067, 46, 7552, 32, 209);
INSERT INTO public.who_global_data VALUES (7556, 89, 11799, 5, 734, 32, 205);
INSERT INTO public.who_global_data VALUES (7557, 10, 13686, 0, 91, 32, 18);
INSERT INTO public.who_global_data VALUES (7558, 527, 8966, 0, 65, 32, 72);
INSERT INTO public.who_global_data VALUES (7559, 58784, 2713567, 407, 75431, 32, 44);
INSERT INTO public.who_global_data VALUES (7560, 0, 44, 0, 0, 32, 15);
INSERT INTO public.who_global_data VALUES (7561, 20, 3722, 1, 69, 32, 25);
INSERT INTO public.who_global_data VALUES (7562, 0, 0, 0, 0, 32, 179);
INSERT INTO public.who_global_data VALUES (7563, 0, 0, 0, 0, 32, 34);
INSERT INTO public.who_global_data VALUES (7564, 6, 7168, 0, 127, 32, 207);
INSERT INTO public.who_global_data VALUES (7565, 1252, 144796, 62, 4862, 32, 166);
INSERT INTO public.who_global_data VALUES (7566, 13695, 2255607, 197, 21685, 32, 126);
INSERT INTO public.who_global_data VALUES (7567, 0, 0, 0, 0, 32, 97);
INSERT INTO public.who_global_data VALUES (7568, 1, 910, 0, 6, 32, 36);
INSERT INTO public.who_global_data VALUES (7569, 0, 0, 0, 0, 32, 125);
INSERT INTO public.who_global_data VALUES (7570, 128, 36050, 0, 274, 32, 124);
INSERT INTO public.who_global_data VALUES (7571, 5334, 1083585, 202, 19129, 32, 185);
INSERT INTO public.who_global_data VALUES (7572, 1501, 214732, 3, 682, 32, 194);
INSERT INTO public.who_global_data VALUES (7573, 0, 509, 0, 21, 32, 144);
INSERT INTO public.who_global_data VALUES (7574, 211444, 20470169, 1407, 348962, 32, 19);
INSERT INTO public.who_global_data VALUES (7575, 1, 2042, 0, 23, 32, 217);
INSERT INTO public.who_global_data VALUES (7576, 548, 20823, 3, 204, 32, 148);
INSERT INTO public.who_global_data VALUES (7577, 37, 77295, 0, 614, 32, 86);
INSERT INTO public.who_global_data VALUES (7578, 0, 1, 0, 0, 32, 13);
INSERT INTO public.who_global_data VALUES (7579, 147, 114230, 2, 1034, 32, 157);
INSERT INTO public.who_global_data VALUES (7580, 3, 1497, 0, 35, 32, 8);
INSERT INTO public.who_global_data VALUES (7581, 0, 4, 0, 0, 32, 73);
INSERT INTO public.who_global_data VALUES (7582, 0, 2105, 0, 611, 32, 101);
INSERT INTO public.who_global_data VALUES (7583, 410, 21993, 4, 398, 32, 165);
INSERT INTO public.who_global_data VALUES (7584, 564, 15829, 4, 384, 32, 14);
INSERT INTO public.who_global_data VALUES (7585, 200, 52909, 9, 2230, 33, 193);
INSERT INTO public.who_global_data VALUES (7586, 447, 59438, 3, 1193, 33, 113);
INSERT INTO public.who_global_data VALUES (7587, 0, 100159, 0, 2769, 33, 143);
INSERT INTO public.who_global_data VALUES (7588, 0, 0, 0, 0, 33, 219);
INSERT INTO public.who_global_data VALUES (7589, 26, 8192, 0, 84, 33, 186);
INSERT INTO public.who_global_data VALUES (7590, 34, 17642, 1, 408, 33, 52);
INSERT INTO public.who_global_data VALUES (7591, 0, 15, 0, 0, 33, 180);
INSERT INTO public.who_global_data VALUES (7592, 0, 159, 0, 5, 33, 167);
INSERT INTO public.who_global_data VALUES (7593, 5240, 1634834, 56, 43375, 33, 154);
INSERT INTO public.who_global_data VALUES (7594, 193, 160220, 14, 2864, 33, 94);
INSERT INTO public.who_global_data VALUES (7595, 0, 5442, 0, 49, 33, 66);
INSERT INTO public.who_global_data VALUES (7596, 21, 28483, 0, 909, 33, 58);
INSERT INTO public.who_global_data VALUES (7597, 1611, 364574, 39, 6253, 33, 163);
INSERT INTO public.who_global_data VALUES (7598, 803, 220265, 30, 2733, 33, 37);
INSERT INTO public.who_global_data VALUES (7599, 15, 7914, 4, 175, 33, 142);
INSERT INTO public.who_global_data VALUES (7600, 294, 93478, 0, 352, 33, 83);
INSERT INTO public.who_global_data VALUES (7601, 835, 516019, 27, 7626, 33, 228);
INSERT INTO public.who_global_data VALUES (7602, 0, 395, 0, 7, 33, 188);
INSERT INTO public.who_global_data VALUES (7603, 1837, 199962, 9, 1451, 33, 62);
INSERT INTO public.who_global_data VALUES (7604, 821, 651707, 42, 19748, 33, 160);
INSERT INTO public.who_global_data VALUES (7605, 0, 10807, 0, 249, 33, 50);
INSERT INTO public.who_global_data VALUES (7606, 0, 3251, 0, 44, 33, 33);
INSERT INTO public.who_global_data VALUES (7607, 18, 622, 0, 10, 33, 183);
INSERT INTO public.who_global_data VALUES (7608, 6, 716, 0, 0, 33, 92);
INSERT INTO public.who_global_data VALUES (7609, 0, 162055, 0, 9186, 33, 158);
INSERT INTO public.who_global_data VALUES (7610, 0, 165, 0, 3, 33, 67);
INSERT INTO public.who_global_data VALUES (7611, 300, 112645, 31, 4131, 33, 57);
INSERT INTO public.who_global_data VALUES (7612, 0, 14805, 0, 42, 33, 38);
INSERT INTO public.who_global_data VALUES (7613, 15827, 7716405, 314, 195725, 33, 141);
INSERT INTO public.who_global_data VALUES (7614, 0, 93, 0, 1, 33, 178);
INSERT INTO public.who_global_data VALUES (7615, 15, 172, 0, 3, 33, 108);
INSERT INTO public.who_global_data VALUES (7616, 171, 203051, 34, 7678, 33, 39);
INSERT INTO public.who_global_data VALUES (7617, 111, 7051, 0, 86, 33, 2);
INSERT INTO public.who_global_data VALUES (7618, 9, 842, 0, 2, 33, 195);
INSERT INTO public.who_global_data VALUES (7619, 37, 11920, 0, 113, 33, 107);
INSERT INTO public.who_global_data VALUES (7620, 1, 382, 0, 0, 33, 161);
INSERT INTO public.who_global_data VALUES (7621, 0, 26848, 0, 448, 33, 212);
INSERT INTO public.who_global_data VALUES (7622, 6808, 595085, 83, 15824, 33, 181);
INSERT INTO public.who_global_data VALUES (7623, 0, 338, 0, 2, 33, 53);
INSERT INTO public.who_global_data VALUES (7624, 0, 4963, 0, 63, 33, 164);
INSERT INTO public.who_global_data VALUES (7625, 44, 2213, 0, 104, 33, 140);
INSERT INTO public.who_global_data VALUES (7626, 2289, 618191, 43, 16767, 33, 20);
INSERT INTO public.who_global_data VALUES (7627, 78, 96972, 0, 4791, 33, 112);
INSERT INTO public.who_global_data VALUES (7628, 11528, 1666408, 270, 43765, 33, 111);
INSERT INTO public.who_global_data VALUES (7629, 0, 864, 0, 13, 33, 71);
INSERT INTO public.who_global_data VALUES (7630, 0, 6200, 0, 100, 33, 218);
INSERT INTO public.who_global_data VALUES (7631, 0, 0, 0, 0, 33, 43);
INSERT INTO public.who_global_data VALUES (7632, 539, 171130, 12, 2205, 33, 49);
INSERT INTO public.who_global_data VALUES (7633, 0, 22250, 0, 137, 33, 1);
INSERT INTO public.who_global_data VALUES (7634, 361, 213319, 54, 4126, 33, 48);
INSERT INTO public.who_global_data VALUES (7635, 199, 12424, 1, 147, 33, 232);
INSERT INTO public.who_global_data VALUES (7636, 0, 4230, 0, 14, 33, 175);
INSERT INTO public.who_global_data VALUES (7637, 529, 23974, 2, 131, 33, 21);
INSERT INTO public.who_global_data VALUES (7638, 6233, 746714, 110, 12070, 33, 156);
INSERT INTO public.who_global_data VALUES (7639, 0, 0, 0, 0, 33, 95);
INSERT INTO public.who_global_data VALUES (7640, 149, 17997, 5, 596, 33, 177);
INSERT INTO public.who_global_data VALUES (7641, 1170, 168711, 29, 1374, 33, 210);
INSERT INTO public.who_global_data VALUES (7642, 1, 5842, 0, 61, 33, 120);
INSERT INTO public.who_global_data VALUES (7643, 0, 96, 0, 0, 33, 135);
INSERT INTO public.who_global_data VALUES (7644, 366, 173331, 2, 2418, 33, 206);
INSERT INTO public.who_global_data VALUES (7645, 101, 214614, 0, 14059, 33, 189);
INSERT INTO public.who_global_data VALUES (7646, 1309, 142187, 64, 7805, 33, 129);
INSERT INTO public.who_global_data VALUES (7647, 561, 46803, 7, 1358, 33, 121);
INSERT INTO public.who_global_data VALUES (7648, 0, 5277, 0, 86, 33, 59);
INSERT INTO public.who_global_data VALUES (7649, 0, 1320, 0, 3, 33, 96);
INSERT INTO public.who_global_data VALUES (7650, 390, 29521, 7, 251, 33, 41);
INSERT INTO public.who_global_data VALUES (7651, 232, 9943, 4, 231, 33, 216);
INSERT INTO public.who_global_data VALUES (7652, 573, 125622, 4, 1948, 33, 236);
INSERT INTO public.who_global_data VALUES (7653, 0, 29, 0, 0, 33, 150);
INSERT INTO public.who_global_data VALUES (7654, 6, 620, 0, 0, 33, 61);
INSERT INTO public.who_global_data VALUES (7655, 0, 49, 0, 2, 33, 7);
INSERT INTO public.who_global_data VALUES (7656, 168, 36772, 0, 561, 33, 169);
INSERT INTO public.who_global_data VALUES (7657, 12489, 2611616, 116, 64659, 33, 28);
INSERT INTO public.who_global_data VALUES (7658, 0, 13273, 0, 71, 33, 85);
INSERT INTO public.who_global_data VALUES (7659, 0, 16926, 0, 114, 33, 211);
INSERT INTO public.who_global_data VALUES (7660, 0, 9571, 0, 64, 33, 60);
INSERT INTO public.who_global_data VALUES (7661, 0, 3802, 0, 124, 33, 3);
INSERT INTO public.who_global_data VALUES (7662, 594, 229763, 25, 2628, 33, 11);
INSERT INTO public.who_global_data VALUES (7663, 9847, 1775513, 302, 34574, 33, 89);
INSERT INTO public.who_global_data VALUES (7664, 104, 55168, 0, 335, 33, 24);
INSERT INTO public.who_global_data VALUES (7665, 92, 2304, 0, 7, 33, 162);
INSERT INTO public.who_global_data VALUES (7666, 390, 140099, 36, 4957, 33, 100);
INSERT INTO public.who_global_data VALUES (7667, 0, 27, 0, 0, 33, 47);
INSERT INTO public.who_global_data VALUES (7668, 0, 130, 0, 1, 33, 29);
INSERT INTO public.who_global_data VALUES (7669, 0, 8620, 0, 155, 33, 40);
INSERT INTO public.who_global_data VALUES (7670, 1, 7149, 0, 123, 33, 222);
INSERT INTO public.who_global_data VALUES (7671, 159, 138475, 6, 4833, 33, 132);
INSERT INTO public.who_global_data VALUES (7672, 0, 299, 0, 13, 33, 130);
INSERT INTO public.who_global_data VALUES (7673, 0, 13784, 0, 81, 33, 234);
INSERT INTO public.who_global_data VALUES (7674, 0, 2447, 0, 45, 33, 23);
INSERT INTO public.who_global_data VALUES (7675, 7, 6358, 0, 164, 33, 192);
INSERT INTO public.who_global_data VALUES (7676, 50, 10127, 0, 236, 33, 69);
INSERT INTO public.who_global_data VALUES (7677, 0, 26, 0, 0, 33, 187);
INSERT INTO public.who_global_data VALUES (7678, 170, 123144, 13, 3173, 33, 230);
INSERT INTO public.who_global_data VALUES (7679, 856, 328851, 93, 9977, 33, 77);
INSERT INTO public.who_global_data VALUES (7680, 41, 5795, 0, 29, 33, 9);
INSERT INTO public.who_global_data VALUES (7681, 16504, 10340469, 214, 149649, 33, 74);
INSERT INTO public.who_global_data VALUES (7682, 6877, 765350, 179, 22734, 33, 224);
INSERT INTO public.who_global_data VALUES (7683, 5960, 1243434, 102, 55540, 33, 199);
INSERT INTO public.who_global_data VALUES (7684, 741, 597774, 5, 12834, 33, 190);
INSERT INTO public.who_global_data VALUES (7685, 4961, 101887, 7, 2259, 33, 12);
INSERT INTO public.who_global_data VALUES (7686, 0, 380, 0, 25, 33, 104);
INSERT INTO public.who_global_data VALUES (7687, 4218, 435929, 26, 3428, 33, 153);
INSERT INTO public.who_global_data VALUES (7688, 14245, 2155446, 347, 75332, 33, 91);
INSERT INTO public.who_global_data VALUES (7689, 118, 13049, 1, 304, 33, 215);
INSERT INTO public.who_global_data VALUES (7690, 2893, 243847, 51, 3599, 33, 84);
INSERT INTO public.who_global_data VALUES (7691, 0, 2760, 0, 44, 33, 231);
INSERT INTO public.who_global_data VALUES (7692, 1540, 298208, 26, 3903, 33, 196);
INSERT INTO public.who_global_data VALUES (7693, 730, 204293, 0, 2845, 33, 105);
INSERT INTO public.who_global_data VALUES (7694, 124, 96802, 0, 1685, 33, 122);
INSERT INTO public.who_global_data VALUES (7695, 0, 0, 0, 0, 33, 159);
INSERT INTO public.who_global_data VALUES (7696, 234, 51922, 4, 1334, 33, 75);
INSERT INTO public.who_global_data VALUES (7697, 269, 151343, 0, 937, 33, 27);
INSERT INTO public.who_global_data VALUES (7698, 83, 81388, 1, 1360, 33, 54);
INSERT INTO public.who_global_data VALUES (7699, 0, 41, 0, 0, 33, 226);
INSERT INTO public.who_global_data VALUES (7700, 568, 42497, 12, 680, 33, 79);
INSERT INTO public.who_global_data VALUES (7701, 2870, 189278, 10, 1486, 33, 56);
INSERT INTO public.who_global_data VALUES (7702, 0, 2577, 0, 50, 33, 117);
INSERT INTO public.who_global_data VALUES (7703, 0, 1800, 0, 83, 33, 152);
INSERT INTO public.who_global_data VALUES (7704, 670, 101414, 23, 1510, 33, 16);
INSERT INTO public.who_global_data VALUES (7705, 19, 2301, 2, 40, 33, 10);
INSERT INTO public.who_global_data VALUES (7706, 1362, 147987, 37, 1975, 33, 201);
INSERT INTO public.who_global_data VALUES (7707, 81, 46919, 3, 506, 33, 174);
INSERT INTO public.who_global_data VALUES (7708, 0, 17767, 0, 262, 33, 119);
INSERT INTO public.who_global_data VALUES (7709, 133, 6844, 3, 195, 33, 168);
INSERT INTO public.who_global_data VALUES (7710, 1704, 119077, 11, 494, 33, 99);
INSERT INTO public.who_global_data VALUES (7711, 33, 13867, 0, 48, 33, 171);
INSERT INTO public.who_global_data VALUES (7712, 27, 7253, 2, 278, 33, 87);
INSERT INTO public.who_global_data VALUES (7713, 233, 13230, 2, 222, 33, 123);
INSERT INTO public.who_global_data VALUES (7714, 0, 4, 0, 0, 33, 151);
INSERT INTO public.who_global_data VALUES (7715, 0, 6091, 0, 43, 33, 213);
INSERT INTO public.who_global_data VALUES (7716, 0, 14364, 0, 347, 33, 118);
INSERT INTO public.who_global_data VALUES (7717, 0, 527, 0, 10, 33, 134);
INSERT INTO public.who_global_data VALUES (7718, 0, 5890, 0, 55, 33, 65);
INSERT INTO public.who_global_data VALUES (7719, 6359, 1443544, 344, 126851, 33, 102);
INSERT INTO public.who_global_data VALUES (7720, 0, 0, 0, 0, 33, 223);
INSERT INTO public.who_global_data VALUES (7721, 6, 910, 0, 4, 33, 4);
INSERT INTO public.who_global_data VALUES (7722, 21, 1263, 0, 0, 33, 146);
INSERT INTO public.who_global_data VALUES (7723, 520, 49999, 3, 692, 33, 31);
INSERT INTO public.who_global_data VALUES (7724, 0, 13, 0, 1, 33, 127);
INSERT INTO public.who_global_data VALUES (7725, 1005, 443146, 33, 7485, 33, 22);
INSERT INTO public.who_global_data VALUES (7726, 341, 19309, 1, 169, 33, 115);
INSERT INTO public.who_global_data VALUES (7727, 729, 126345, 17, 2728, 33, 106);
INSERT INTO public.who_global_data VALUES (7728, 462, 25116, 2, 215, 33, 90);
INSERT INTO public.who_global_data VALUES (7729, 0, 0, 0, 0, 33, 70);
INSERT INTO public.who_global_data VALUES (7730, 421, 261859, 8, 1878, 33, 46);
INSERT INTO public.who_global_data VALUES (7731, 7407, 820067, 47, 11587, 33, 139);
INSERT INTO public.who_global_data VALUES (7732, 0, 40, 0, 0, 33, 42);
INSERT INTO public.who_global_data VALUES (7733, 0, 1825, 0, 25, 33, 80);
INSERT INTO public.who_global_data VALUES (7734, 0, 4829, 0, 165, 33, 203);
INSERT INTO public.who_global_data VALUES (7735, 0, 3208, 0, 102, 33, 136);
INSERT INTO public.who_global_data VALUES (7736, 917, 90080, 9, 1311, 33, 63);
INSERT INTO public.who_global_data VALUES (7737, 0, 0, 0, 0, 33, 17);
INSERT INTO public.who_global_data VALUES (7738, 2, 124, 0, 2, 33, 172);
INSERT INTO public.who_global_data VALUES (7739, 235, 84024, 8, 2530, 33, 109);
INSERT INTO public.who_global_data VALUES (7740, 0, 48278, 0, 436, 33, 200);
INSERT INTO public.who_global_data VALUES (7741, 1155, 159034, 31, 1609, 33, 93);
INSERT INTO public.who_global_data VALUES (7742, 537, 129404, 2, 1501, 33, 5);
INSERT INTO public.who_global_data VALUES (7743, 0, 745, 0, 13, 33, 214);
INSERT INTO public.who_global_data VALUES (7744, 2272, 486634, 53, 10311, 33, 204);
INSERT INTO public.who_global_data VALUES (7745, 0, 0, 0, 0, 33, 198);
INSERT INTO public.who_global_data VALUES (7746, 2031, 251764, 39, 4103, 33, 173);
INSERT INTO public.who_global_data VALUES (7747, 19, 799, 0, 9, 33, 229);
INSERT INTO public.who_global_data VALUES (7748, 369, 108718, 17, 2279, 33, 76);
INSERT INTO public.who_global_data VALUES (7749, 900, 1018099, 49, 37773, 33, 138);
INSERT INTO public.who_global_data VALUES (7750, 891, 477807, 4, 9257, 33, 98);
INSERT INTO public.who_global_data VALUES (7751, 0, 0, 0, 0, 33, 103);
INSERT INTO public.who_global_data VALUES (7752, 4385, 1322947, 42, 29161, 33, 225);
INSERT INTO public.who_global_data VALUES (7753, 3384, 427254, 73, 7118, 33, 131);
INSERT INTO public.who_global_data VALUES (7754, 237, 78169, 19, 1545, 33, 235);
INSERT INTO public.who_global_data VALUES (7755, 197, 144437, 0, 245, 33, 137);
INSERT INTO public.who_global_data VALUES (7756, 1020, 64255, 19, 981, 33, 81);
INSERT INTO public.who_global_data VALUES (7757, 179, 145873, 17, 3037, 33, 182);
INSERT INTO public.who_global_data VALUES (7758, 0, 9037, 0, 42, 33, 145);
INSERT INTO public.who_global_data VALUES (7759, 3034, 640429, 60, 15979, 33, 26);
INSERT INTO public.who_global_data VALUES (7760, 23351, 3260138, 482, 58988, 33, 170);
INSERT INTO public.who_global_data VALUES (7761, 109, 8676, 3, 101, 33, 191);
INSERT INTO public.who_global_data VALUES (7762, 0, 5, 0, 0, 33, 221);
INSERT INTO public.who_global_data VALUES (7763, 0, 190, 0, 0, 33, 64);
INSERT INTO public.who_global_data VALUES (7764, 0, 0, 0, 0, 33, 116);
INSERT INTO public.who_global_data VALUES (7765, 0, 33, 0, 0, 33, 128);
INSERT INTO public.who_global_data VALUES (7766, 0, 353, 0, 5, 33, 6);
INSERT INTO public.who_global_data VALUES (7767, 0, 995, 0, 12, 33, 227);
INSERT INTO public.who_global_data VALUES (7768, 0, 16, 0, 0, 33, 68);
INSERT INTO public.who_global_data VALUES (7769, 2, 124, 0, 0, 33, 184);
INSERT INTO public.who_global_data VALUES (7770, 0, 2, 0, 0, 33, 82);
INSERT INTO public.who_global_data VALUES (7771, 0, 2463, 0, 61, 33, 149);
INSERT INTO public.who_global_data VALUES (7772, 0, 1024, 0, 17, 33, 197);
INSERT INTO public.who_global_data VALUES (7773, 82, 363061, 7, 6246, 33, 78);
INSERT INTO public.who_global_data VALUES (7774, 186, 19697, 5, 421, 33, 233);
INSERT INTO public.who_global_data VALUES (7775, 1966, 343870, 37, 3325, 33, 133);
INSERT INTO public.who_global_data VALUES (7776, 12, 296, 0, 0, 33, 35);
INSERT INTO public.who_global_data VALUES (7777, 113, 2673, 0, 76, 33, 114);
INSERT INTO public.who_global_data VALUES (7778, 35, 58697, 0, 29, 33, 237);
INSERT INTO public.who_global_data VALUES (7779, 0, 19, 0, 0, 33, 55);
INSERT INTO public.who_global_data VALUES (7780, 0, 1434, 0, 27, 33, 176);
INSERT INTO public.who_global_data VALUES (7781, 636, 188099, 204, 2521, 33, 202);
INSERT INTO public.who_global_data VALUES (7782, 764, 125952, 31, 3121, 33, 155);
INSERT INTO public.who_global_data VALUES (7783, 0, 17, 0, 0, 33, 32);
INSERT INTO public.who_global_data VALUES (7784, 0, 4714, 0, 130, 33, 220);
INSERT INTO public.who_global_data VALUES (7785, 11859, 1100748, 402, 29577, 33, 30);
INSERT INTO public.who_global_data VALUES (7786, 0, 3558, 0, 63, 33, 147);
INSERT INTO public.who_global_data VALUES (7787, 9900, 2037984, 153, 52212, 33, 208);
INSERT INTO public.who_global_data VALUES (7788, 403, 44774, 2, 213, 33, 45);
INSERT INTO public.who_global_data VALUES (7789, 240, 26279, 6, 1603, 33, 110);
INSERT INTO public.who_global_data VALUES (7790, 66, 6343, 0, 123, 33, 88);
INSERT INTO public.who_global_data VALUES (7791, 2532, 459926, 98, 10034, 33, 51);
INSERT INTO public.who_global_data VALUES (7792, 2219, 460790, 57, 7506, 33, 209);
INSERT INTO public.who_global_data VALUES (7793, 94, 11710, 6, 729, 33, 205);
INSERT INTO public.who_global_data VALUES (7794, 2, 13676, 0, 91, 33, 18);
INSERT INTO public.who_global_data VALUES (7795, 1060, 8439, 1, 65, 33, 72);
INSERT INTO public.who_global_data VALUES (7796, 54990, 2654783, 454, 75024, 33, 44);
INSERT INTO public.who_global_data VALUES (7797, 0, 44, 0, 0, 33, 15);
INSERT INTO public.who_global_data VALUES (7798, 19, 3702, 0, 68, 33, 25);
INSERT INTO public.who_global_data VALUES (7799, 0, 0, 0, 0, 33, 179);
INSERT INTO public.who_global_data VALUES (7800, 0, 0, 0, 0, 33, 34);
INSERT INTO public.who_global_data VALUES (7801, 4, 7162, 0, 127, 33, 207);
INSERT INTO public.who_global_data VALUES (7802, 1565, 143544, 35, 4800, 33, 166);
INSERT INTO public.who_global_data VALUES (7803, 9877, 2241912, 193, 21488, 33, 126);
INSERT INTO public.who_global_data VALUES (7804, 0, 0, 0, 0, 33, 97);
INSERT INTO public.who_global_data VALUES (7805, 1, 909, 0, 6, 33, 36);
INSERT INTO public.who_global_data VALUES (7806, 0, 0, 0, 0, 33, 125);
INSERT INTO public.who_global_data VALUES (7807, 210, 35922, 0, 274, 33, 124);
INSERT INTO public.who_global_data VALUES (7808, 4158, 1078251, 73, 18927, 33, 185);
INSERT INTO public.who_global_data VALUES (7809, 1590, 213231, 5, 679, 33, 194);
INSERT INTO public.who_global_data VALUES (7810, 0, 509, 0, 21, 33, 144);
INSERT INTO public.who_global_data VALUES (7811, 284312, 20258725, 2302, 347555, 33, 19);
INSERT INTO public.who_global_data VALUES (7812, 5, 2041, 0, 23, 33, 217);
INSERT INTO public.who_global_data VALUES (7813, 522, 20275, 8, 201, 33, 148);
INSERT INTO public.who_global_data VALUES (7814, 20, 77258, 0, 614, 33, 86);
INSERT INTO public.who_global_data VALUES (7815, 0, 1, 0, 0, 33, 13);
INSERT INTO public.who_global_data VALUES (7816, 521, 114083, 4, 1032, 33, 157);
INSERT INTO public.who_global_data VALUES (7817, 12, 1494, 0, 35, 33, 8);
INSERT INTO public.who_global_data VALUES (7818, 0, 4, 0, 0, 33, 73);
INSERT INTO public.who_global_data VALUES (7819, 0, 2105, 0, 611, 33, 101);
INSERT INTO public.who_global_data VALUES (7820, 353, 21583, 2, 394, 33, 165);
INSERT INTO public.who_global_data VALUES (7821, 774, 15265, 3, 380, 33, 14);
INSERT INTO public.who_global_data VALUES (7822, 123, 52709, 10, 2221, 34, 193);
INSERT INTO public.who_global_data VALUES (7823, 268, 58991, 4, 1190, 34, 113);
INSERT INTO public.who_global_data VALUES (7824, 549, 100159, 13, 2769, 34, 143);
INSERT INTO public.who_global_data VALUES (7825, 0, 0, 0, 0, 34, 219);
INSERT INTO public.who_global_data VALUES (7826, 49, 8166, 0, 84, 34, 186);
INSERT INTO public.who_global_data VALUES (7827, 55, 17608, 2, 407, 34, 52);
INSERT INTO public.who_global_data VALUES (7828, 1, 15, 0, 0, 34, 180);
INSERT INTO public.who_global_data VALUES (7829, 0, 159, 0, 5, 34, 167);
INSERT INTO public.who_global_data VALUES (7830, 4080, 1629594, 74, 43319, 34, 154);
INSERT INTO public.who_global_data VALUES (7831, 289, 160027, 22, 2850, 34, 94);
INSERT INTO public.who_global_data VALUES (7832, 0, 5442, 0, 49, 34, 66);
INSERT INTO public.who_global_data VALUES (7833, 35, 28462, 0, 909, 34, 58);
INSERT INTO public.who_global_data VALUES (7834, 1491, 362963, 37, 6214, 34, 163);
INSERT INTO public.who_global_data VALUES (7835, 421, 219462, 33, 2703, 34, 37);
INSERT INTO public.who_global_data VALUES (7836, 12, 7899, 0, 171, 34, 142);
INSERT INTO public.who_global_data VALUES (7837, 271, 93184, 0, 352, 34, 83);
INSERT INTO public.who_global_data VALUES (7838, 684, 515184, 23, 7599, 34, 228);
INSERT INTO public.who_global_data VALUES (7839, 12, 395, 0, 7, 34, 188);
INSERT INTO public.who_global_data VALUES (7840, 1902, 198125, 9, 1442, 34, 62);
INSERT INTO public.who_global_data VALUES (7841, 1120, 650886, 64, 19706, 34, 160);
INSERT INTO public.who_global_data VALUES (7842, 31, 10807, 1, 249, 34, 50);
INSERT INTO public.who_global_data VALUES (7843, 0, 3251, 0, 44, 34, 33);
INSERT INTO public.who_global_data VALUES (7844, 0, 604, 0, 10, 34, 183);
INSERT INTO public.who_global_data VALUES (7845, 21, 710, 0, 0, 34, 92);
INSERT INTO public.who_global_data VALUES (7846, 1931, 162055, 21, 9186, 34, 158);
INSERT INTO public.who_global_data VALUES (7847, 0, 165, 0, 3, 34, 67);
INSERT INTO public.who_global_data VALUES (7848, 202, 112345, 14, 4100, 34, 57);
INSERT INTO public.who_global_data VALUES (7849, 780, 14805, 2, 42, 34, 38);
INSERT INTO public.who_global_data VALUES (7850, 24605, 7700578, 462, 195411, 34, 141);
INSERT INTO public.who_global_data VALUES (7851, 0, 93, 0, 1, 34, 178);
INSERT INTO public.who_global_data VALUES (7852, 0, 157, 0, 3, 34, 108);
INSERT INTO public.who_global_data VALUES (7853, 340, 202880, 40, 7644, 34, 39);
INSERT INTO public.who_global_data VALUES (7854, 233, 6940, 1, 86, 34, 2);
INSERT INTO public.who_global_data VALUES (7855, 11, 833, 0, 2, 34, 195);
INSERT INTO public.who_global_data VALUES (7856, 43, 11883, 0, 113, 34, 107);
INSERT INTO public.who_global_data VALUES (7857, 2, 381, 0, 0, 34, 161);
INSERT INTO public.who_global_data VALUES (7858, 0, 26848, 0, 448, 34, 212);
INSERT INTO public.who_global_data VALUES (7859, 6875, 588277, 136, 15741, 34, 181);
INSERT INTO public.who_global_data VALUES (7860, 0, 338, 0, 2, 34, 53);
INSERT INTO public.who_global_data VALUES (7861, 0, 4963, 0, 63, 34, 164);
INSERT INTO public.who_global_data VALUES (7862, 56, 2169, 0, 104, 34, 140);
INSERT INTO public.who_global_data VALUES (7863, 3338, 615902, 64, 16724, 34, 20);
INSERT INTO public.who_global_data VALUES (7864, 65, 96894, 1, 4791, 34, 112);
INSERT INTO public.who_global_data VALUES (7865, 12105, 1654880, 282, 43495, 34, 111);
INSERT INTO public.who_global_data VALUES (7866, 99, 864, 4, 13, 34, 71);
INSERT INTO public.who_global_data VALUES (7867, 0, 6200, 0, 100, 34, 218);
INSERT INTO public.who_global_data VALUES (7868, 0, 0, 0, 0, 34, 43);
INSERT INTO public.who_global_data VALUES (7869, 1270, 170591, 8, 2193, 34, 49);
INSERT INTO public.who_global_data VALUES (7870, 0, 22250, 0, 137, 34, 1);
INSERT INTO public.who_global_data VALUES (7871, 696, 212958, 56, 4072, 34, 48);
INSERT INTO public.who_global_data VALUES (7872, 169, 12225, 0, 146, 34, 232);
INSERT INTO public.who_global_data VALUES (7873, 0, 4230, 0, 14, 34, 175);
INSERT INTO public.who_global_data VALUES (7874, 627, 23445, 2, 129, 34, 21);
INSERT INTO public.who_global_data VALUES (7875, 5012, 740481, 133, 11960, 34, 156);
INSERT INTO public.who_global_data VALUES (7876, 0, 0, 0, 0, 34, 95);
INSERT INTO public.who_global_data VALUES (7877, 474, 17848, 0, 591, 34, 177);
INSERT INTO public.who_global_data VALUES (7878, 1611, 167541, 23, 1345, 34, 210);
INSERT INTO public.who_global_data VALUES (7879, 1, 5841, 0, 61, 34, 120);
INSERT INTO public.who_global_data VALUES (7880, 0, 96, 0, 0, 34, 135);
INSERT INTO public.who_global_data VALUES (7881, 747, 172965, 0, 2416, 34, 206);
INSERT INTO public.who_global_data VALUES (7882, 1135, 214513, 8, 14059, 34, 189);
INSERT INTO public.who_global_data VALUES (7883, 1407, 140878, 54, 7741, 34, 129);
INSERT INTO public.who_global_data VALUES (7884, 282, 46242, 8, 1351, 34, 121);
INSERT INTO public.who_global_data VALUES (7885, 0, 5277, 0, 86, 34, 59);
INSERT INTO public.who_global_data VALUES (7886, 0, 1320, 0, 3, 34, 96);
INSERT INTO public.who_global_data VALUES (7887, 342, 29131, 3, 244, 34, 41);
INSERT INTO public.who_global_data VALUES (7888, 353, 9711, 21, 227, 34, 216);
INSERT INTO public.who_global_data VALUES (7889, 785, 125049, 21, 1944, 34, 236);
INSERT INTO public.who_global_data VALUES (7890, 0, 29, 0, 0, 34, 150);
INSERT INTO public.who_global_data VALUES (7891, 4, 614, 0, 0, 34, 61);
INSERT INTO public.who_global_data VALUES (7892, 0, 49, 0, 2, 34, 7);
INSERT INTO public.who_global_data VALUES (7893, 201, 36604, 0, 561, 34, 169);
INSERT INTO public.who_global_data VALUES (7894, 3466, 2599127, 156, 64543, 34, 28);
INSERT INTO public.who_global_data VALUES (7895, 0, 13273, 0, 71, 34, 85);
INSERT INTO public.who_global_data VALUES (7896, 0, 16926, 0, 114, 34, 211);
INSERT INTO public.who_global_data VALUES (7897, 0, 9571, 0, 64, 34, 60);
INSERT INTO public.who_global_data VALUES (7898, 2, 3802, 0, 124, 34, 3);
INSERT INTO public.who_global_data VALUES (7899, 417, 229169, 31, 2603, 34, 11);
INSERT INTO public.who_global_data VALUES (7900, 10315, 1765666, 312, 34272, 34, 89);
INSERT INTO public.who_global_data VALUES (7901, 293, 55064, 0, 335, 34, 24);
INSERT INTO public.who_global_data VALUES (7902, 172, 2212, 0, 7, 34, 162);
INSERT INTO public.who_global_data VALUES (7903, 262, 139709, 40, 4921, 34, 100);
INSERT INTO public.who_global_data VALUES (7904, 0, 27, 0, 0, 34, 47);
INSERT INTO public.who_global_data VALUES (7905, 0, 130, 0, 1, 34, 29);
INSERT INTO public.who_global_data VALUES (7906, 0, 8620, 0, 155, 34, 40);
INSERT INTO public.who_global_data VALUES (7907, 0, 7148, 1, 123, 34, 222);
INSERT INTO public.who_global_data VALUES (7908, 80, 138316, 7, 4827, 34, 132);
INSERT INTO public.who_global_data VALUES (7909, 1, 299, 0, 13, 34, 130);
INSERT INTO public.who_global_data VALUES (7910, 62, 13784, 0, 81, 34, 234);
INSERT INTO public.who_global_data VALUES (7911, 0, 2447, 0, 45, 34, 23);
INSERT INTO public.who_global_data VALUES (7912, 19, 6351, 0, 164, 34, 192);
INSERT INTO public.who_global_data VALUES (7913, 62, 10077, 0, 236, 34, 69);
INSERT INTO public.who_global_data VALUES (7914, 0, 26, 0, 0, 34, 187);
INSERT INTO public.who_global_data VALUES (7915, 211, 122974, 19, 3160, 34, 230);
INSERT INTO public.who_global_data VALUES (7916, 1307, 327995, 103, 9884, 34, 77);
INSERT INTO public.who_global_data VALUES (7917, 0, 5754, 0, 29, 34, 9);
INSERT INTO public.who_global_data VALUES (7918, 18177, 10323965, 217, 149435, 34, 74);
INSERT INTO public.who_global_data VALUES (7919, 7203, 758473, 226, 22555, 34, 224);
INSERT INTO public.who_global_data VALUES (7920, 6045, 1237474, 101, 55438, 34, 199);
INSERT INTO public.who_global_data VALUES (7921, 840, 597033, 5, 12829, 34, 190);
INSERT INTO public.who_global_data VALUES (7922, 3394, 96926, 4, 2252, 34, 12);
INSERT INTO public.who_global_data VALUES (7923, 0, 380, 0, 25, 34, 104);
INSERT INTO public.who_global_data VALUES (7924, 6022, 431711, 38, 3402, 34, 153);
INSERT INTO public.who_global_data VALUES (7925, 11825, 2141201, 364, 74985, 34, 91);
INSERT INTO public.who_global_data VALUES (7926, 16, 12931, 0, 303, 34, 215);
INSERT INTO public.who_global_data VALUES (7927, 2942, 240954, 34, 3548, 34, 84);
INSERT INTO public.who_global_data VALUES (7928, 0, 2760, 0, 44, 34, 231);
INSERT INTO public.who_global_data VALUES (7929, 903, 296668, 26, 3877, 34, 196);
INSERT INTO public.who_global_data VALUES (7930, 683, 203563, 96, 2845, 34, 105);
INSERT INTO public.who_global_data VALUES (7931, 220, 96678, 15, 1685, 34, 122);
INSERT INTO public.who_global_data VALUES (7932, 0, 0, 0, 0, 34, 159);
INSERT INTO public.who_global_data VALUES (7933, 229, 51688, 4, 1330, 34, 75);
INSERT INTO public.who_global_data VALUES (7934, 205, 151074, 1, 937, 34, 27);
INSERT INTO public.who_global_data VALUES (7935, 91, 81305, 1, 1359, 34, 54);
INSERT INTO public.who_global_data VALUES (7936, 0, 41, 0, 0, 34, 226);
INSERT INTO public.who_global_data VALUES (7937, 314, 41929, 24, 668, 34, 79);
INSERT INTO public.who_global_data VALUES (7938, 2520, 186408, 10, 1476, 34, 56);
INSERT INTO public.who_global_data VALUES (7939, 0, 2577, 0, 50, 34, 117);
INSERT INTO public.who_global_data VALUES (7940, 0, 1800, 0, 83, 34, 152);
INSERT INTO public.who_global_data VALUES (7941, 0, 100744, 0, 1487, 34, 16);
INSERT INTO public.who_global_data VALUES (7942, 23, 2282, 0, 38, 34, 10);
INSERT INTO public.who_global_data VALUES (7943, 1238, 146625, 49, 1938, 34, 201);
INSERT INTO public.who_global_data VALUES (7944, 25, 46838, 2, 503, 34, 174);
INSERT INTO public.who_global_data VALUES (7945, 53, 17767, 1, 262, 34, 119);
INSERT INTO public.who_global_data VALUES (7946, 128, 6711, 3, 192, 34, 168);
INSERT INTO public.who_global_data VALUES (7947, 2295, 117373, 9, 483, 34, 99);
INSERT INTO public.who_global_data VALUES (7948, 30, 13834, 0, 48, 34, 171);
INSERT INTO public.who_global_data VALUES (7949, 136, 7226, 7, 276, 34, 87);
INSERT INTO public.who_global_data VALUES (7950, 88, 12997, 1, 220, 34, 123);
INSERT INTO public.who_global_data VALUES (7951, 0, 4, 0, 0, 34, 151);
INSERT INTO public.who_global_data VALUES (7952, 0, 6091, 0, 43, 34, 213);
INSERT INTO public.who_global_data VALUES (7953, 722, 14364, 23, 347, 34, 118);
INSERT INTO public.who_global_data VALUES (7954, 0, 527, 0, 10, 34, 134);
INSERT INTO public.who_global_data VALUES (7955, 0, 5890, 0, 55, 34, 65);
INSERT INTO public.who_global_data VALUES (7956, 11091, 1437185, 700, 126507, 34, 102);
INSERT INTO public.who_global_data VALUES (7957, 0, 0, 0, 0, 34, 223);
INSERT INTO public.who_global_data VALUES (7958, 16, 904, 1, 4, 34, 4);
INSERT INTO public.who_global_data VALUES (7959, 22, 1242, 0, 0, 34, 146);
INSERT INTO public.who_global_data VALUES (7960, 300, 49479, 5, 689, 34, 31);
INSERT INTO public.who_global_data VALUES (7961, 0, 13, 0, 1, 34, 127);
INSERT INTO public.who_global_data VALUES (7962, 1171, 442141, 27, 7452, 34, 22);
INSERT INTO public.who_global_data VALUES (7963, 326, 18968, 2, 168, 34, 115);
INSERT INTO public.who_global_data VALUES (7964, 563, 125616, 14, 2711, 34, 106);
INSERT INTO public.who_global_data VALUES (7965, 713, 24654, 8, 213, 34, 90);
INSERT INTO public.who_global_data VALUES (7966, 0, 0, 0, 0, 34, 70);
INSERT INTO public.who_global_data VALUES (7967, 419, 261438, 6, 1870, 34, 46);
INSERT INTO public.who_global_data VALUES (7968, 8593, 812660, 38, 11540, 34, 139);
INSERT INTO public.who_global_data VALUES (7969, 2, 40, 0, 0, 34, 42);
INSERT INTO public.who_global_data VALUES (7970, 19, 1825, 0, 25, 34, 80);
INSERT INTO public.who_global_data VALUES (7971, 0, 4829, 0, 165, 34, 203);
INSERT INTO public.who_global_data VALUES (7972, 0, 3208, 0, 102, 34, 136);
INSERT INTO public.who_global_data VALUES (7973, 1653, 89163, 13, 1302, 34, 63);
INSERT INTO public.who_global_data VALUES (7974, 0, 0, 0, 0, 34, 17);
INSERT INTO public.who_global_data VALUES (7975, 0, 122, 0, 2, 34, 172);
INSERT INTO public.who_global_data VALUES (7976, 46, 83789, 12, 2522, 34, 109);
INSERT INTO public.who_global_data VALUES (7977, 0, 48278, 0, 436, 34, 200);
INSERT INTO public.who_global_data VALUES (7978, 1064, 157879, 28, 1578, 34, 93);
INSERT INTO public.who_global_data VALUES (7979, 0, 128867, 0, 1499, 34, 5);
INSERT INTO public.who_global_data VALUES (7980, 0, 745, 0, 13, 34, 214);
INSERT INTO public.who_global_data VALUES (7981, 2184, 484362, 82, 10258, 34, 204);
INSERT INTO public.who_global_data VALUES (7982, 0, 0, 0, 0, 34, 198);
INSERT INTO public.who_global_data VALUES (7983, 2943, 249733, 42, 4064, 34, 173);
INSERT INTO public.who_global_data VALUES (7984, 0, 780, 0, 9, 34, 229);
INSERT INTO public.who_global_data VALUES (7985, 417, 108349, 0, 2262, 34, 76);
INSERT INTO public.who_global_data VALUES (7986, 2062, 1017199, 44, 37724, 34, 138);
INSERT INTO public.who_global_data VALUES (7987, 1096, 476916, 5, 9253, 34, 98);
INSERT INTO public.who_global_data VALUES (7988, 0, 0, 0, 0, 34, 103);
INSERT INTO public.who_global_data VALUES (7989, 5782, 1318562, 61, 29119, 34, 225);
INSERT INTO public.who_global_data VALUES (7990, 3241, 423870, 73, 7045, 34, 131);
INSERT INTO public.who_global_data VALUES (7991, 878, 77932, 5, 1526, 34, 235);
INSERT INTO public.who_global_data VALUES (7992, 198, 144240, 0, 245, 34, 137);
INSERT INTO public.who_global_data VALUES (7993, 657, 63235, 20, 962, 34, 81);
INSERT INTO public.who_global_data VALUES (7994, 436, 145694, 16, 3020, 34, 182);
INSERT INTO public.who_global_data VALUES (7995, 0, 9037, 0, 42, 34, 145);
INSERT INTO public.who_global_data VALUES (7996, 1194, 637395, 78, 15919, 34, 26);
INSERT INTO public.who_global_data VALUES (7997, 24150, 3236787, 504, 58506, 34, 170);
INSERT INTO public.who_global_data VALUES (7998, 184, 8567, 6, 98, 34, 191);
INSERT INTO public.who_global_data VALUES (7999, 0, 5, 0, 0, 34, 221);
INSERT INTO public.who_global_data VALUES (8000, 0, 190, 0, 0, 34, 64);
INSERT INTO public.who_global_data VALUES (8001, 0, 0, 0, 0, 34, 116);
INSERT INTO public.who_global_data VALUES (8002, 1, 33, 0, 0, 34, 128);
INSERT INTO public.who_global_data VALUES (8003, 0, 353, 0, 5, 34, 6);
INSERT INTO public.who_global_data VALUES (8004, 0, 995, 0, 12, 34, 227);
INSERT INTO public.who_global_data VALUES (8005, 0, 16, 0, 0, 34, 68);
INSERT INTO public.who_global_data VALUES (8006, 1, 122, 0, 0, 34, 184);
INSERT INTO public.who_global_data VALUES (8007, 0, 2, 0, 0, 34, 82);
INSERT INTO public.who_global_data VALUES (8008, 35, 2463, 2, 61, 34, 149);
INSERT INTO public.who_global_data VALUES (8009, 10, 1024, 0, 17, 34, 197);
INSERT INTO public.who_global_data VALUES (8010, 101, 362979, 9, 6239, 34, 78);
INSERT INTO public.who_global_data VALUES (8011, 371, 19511, 6, 416, 34, 233);
INSERT INTO public.who_global_data VALUES (8012, 1907, 341904, 38, 3288, 34, 133);
INSERT INTO public.who_global_data VALUES (8013, 17, 284, 0, 0, 34, 35);
INSERT INTO public.who_global_data VALUES (8014, 0, 2560, 0, 76, 34, 114);
INSERT INTO public.who_global_data VALUES (8015, 33, 58662, 0, 29, 34, 237);
INSERT INTO public.who_global_data VALUES (8016, 0, 19, 0, 0, 34, 55);
INSERT INTO public.who_global_data VALUES (8017, 0, 1434, 0, 27, 34, 176);
INSERT INTO public.who_global_data VALUES (8018, 1219, 187463, 67, 2317, 34, 202);
INSERT INTO public.who_global_data VALUES (8019, 760, 125188, 35, 3090, 34, 155);
INSERT INTO public.who_global_data VALUES (8020, 0, 17, 0, 0, 34, 32);
INSERT INTO public.who_global_data VALUES (8021, 0, 4714, 0, 130, 34, 220);
INSERT INTO public.who_global_data VALUES (8022, 31328, 1088889, 706, 29175, 34, 30);
INSERT INTO public.who_global_data VALUES (8023, 0, 3558, 0, 63, 34, 147);
INSERT INTO public.who_global_data VALUES (8024, 7145, 2028084, 124, 52059, 34, 208);
INSERT INTO public.who_global_data VALUES (8025, 515, 44371, 7, 211, 34, 45);
INSERT INTO public.who_global_data VALUES (8026, 157, 26039, 9, 1597, 34, 110);
INSERT INTO public.who_global_data VALUES (8027, 67, 6277, 1, 123, 34, 88);
INSERT INTO public.who_global_data VALUES (8028, 2618, 457394, 86, 9936, 34, 51);
INSERT INTO public.who_global_data VALUES (8029, 2718, 458571, 62, 7449, 34, 209);
INSERT INTO public.who_global_data VALUES (8030, 90, 11616, 6, 723, 34, 205);
INSERT INTO public.who_global_data VALUES (8031, 3, 13674, 0, 91, 34, 18);
INSERT INTO public.who_global_data VALUES (8032, 216, 7379, 1, 64, 34, 72);
INSERT INTO public.who_global_data VALUES (8033, 57724, 2599793, 445, 74570, 34, 44);
INSERT INTO public.who_global_data VALUES (8034, 0, 44, 0, 0, 34, 15);
INSERT INTO public.who_global_data VALUES (8035, 50, 3683, 0, 68, 34, 25);
INSERT INTO public.who_global_data VALUES (8036, 0, 0, 0, 0, 34, 179);
INSERT INTO public.who_global_data VALUES (8037, 0, 0, 0, 0, 34, 34);
INSERT INTO public.who_global_data VALUES (8038, 8, 7158, 0, 127, 34, 207);
INSERT INTO public.who_global_data VALUES (8039, 1422, 141979, 35, 4765, 34, 166);
INSERT INTO public.who_global_data VALUES (8040, 11180, 2232035, 202, 21295, 34, 126);
INSERT INTO public.who_global_data VALUES (8041, 0, 0, 0, 0, 34, 97);
INSERT INTO public.who_global_data VALUES (8042, 15, 908, 0, 6, 34, 36);
INSERT INTO public.who_global_data VALUES (8043, 0, 0, 0, 0, 34, 125);
INSERT INTO public.who_global_data VALUES (8044, 496, 35712, 23, 274, 34, 124);
INSERT INTO public.who_global_data VALUES (8045, 4576, 1074093, 123, 18854, 34, 185);
INSERT INTO public.who_global_data VALUES (8046, 1963, 211641, 3, 674, 34, 194);
INSERT INTO public.who_global_data VALUES (8047, 0, 509, 0, 21, 34, 144);
INSERT INTO public.who_global_data VALUES (8048, 167759, 19974413, 2423, 345253, 34, 19);
INSERT INTO public.who_global_data VALUES (8049, 0, 2036, 0, 23, 34, 217);
INSERT INTO public.who_global_data VALUES (8050, 634, 19753, 12, 193, 34, 148);
INSERT INTO public.who_global_data VALUES (8051, 56, 77238, 0, 614, 34, 86);
INSERT INTO public.who_global_data VALUES (8052, 0, 1, 0, 0, 34, 13);
INSERT INTO public.who_global_data VALUES (8053, 0, 113562, 0, 1028, 34, 157);
INSERT INTO public.who_global_data VALUES (8054, 8, 1482, 0, 35, 34, 8);
INSERT INTO public.who_global_data VALUES (8055, 0, 4, 0, 0, 34, 73);
INSERT INTO public.who_global_data VALUES (8056, 0, 2105, 0, 611, 34, 101);
INSERT INTO public.who_global_data VALUES (8057, 505, 21230, 4, 392, 34, 165);
INSERT INTO public.who_global_data VALUES (8058, 624, 14491, 14, 377, 34, 14);
INSERT INTO public.who_global_data VALUES (8059, 73, 52586, 10, 2211, 35, 193);
INSERT INTO public.who_global_data VALUES (8060, 407, 58723, 5, 1186, 35, 113);
INSERT INTO public.who_global_data VALUES (8061, 0, 99610, 0, 2756, 35, 143);
INSERT INTO public.who_global_data VALUES (8062, 0, 0, 0, 0, 35, 219);
INSERT INTO public.who_global_data VALUES (8063, 68, 8117, 0, 84, 35, 186);
INSERT INTO public.who_global_data VALUES (8064, 0, 17553, 0, 405, 35, 52);
INSERT INTO public.who_global_data VALUES (8065, 1, 14, 0, 0, 35, 180);
INSERT INTO public.who_global_data VALUES (8066, 0, 159, 0, 5, 35, 167);
INSERT INTO public.who_global_data VALUES (8067, 11586, 1625514, 82, 43245, 35, 154);
INSERT INTO public.who_global_data VALUES (8068, 1016, 159738, 10, 2828, 35, 94);
INSERT INTO public.who_global_data VALUES (8069, 0, 5442, 0, 49, 35, 66);
INSERT INTO public.who_global_data VALUES (8070, 19, 28427, 0, 909, 35, 58);
INSERT INTO public.who_global_data VALUES (8071, 2110, 361472, 46, 6177, 35, 163);
INSERT INTO public.who_global_data VALUES (8072, 341, 219041, 29, 2670, 35, 37);
INSERT INTO public.who_global_data VALUES (8073, 16, 7887, 1, 171, 35, 142);
INSERT INTO public.who_global_data VALUES (8074, 238, 92913, 0, 352, 35, 83);
INSERT INTO public.who_global_data VALUES (8075, 990, 514500, 17, 7576, 35, 228);
INSERT INTO public.who_global_data VALUES (8076, 11, 383, 0, 7, 35, 188);
INSERT INTO public.who_global_data VALUES (8077, 1939, 196223, 9, 1433, 35, 62);
INSERT INTO public.who_global_data VALUES (8078, 471, 649766, 50, 19642, 35, 160);
INSERT INTO public.who_global_data VALUES (8079, 52, 10776, 6, 248, 35, 50);
INSERT INTO public.who_global_data VALUES (8080, 0, 3251, 0, 44, 35, 33);
INSERT INTO public.who_global_data VALUES (8081, 0, 604, 0, 10, 35, 183);
INSERT INTO public.who_global_data VALUES (8082, 19, 689, 0, 0, 35, 92);
INSERT INTO public.who_global_data VALUES (8083, 1752, 160124, 16, 9165, 35, 158);
INSERT INTO public.who_global_data VALUES (8084, 0, 165, 0, 3, 35, 67);
INSERT INTO public.who_global_data VALUES (8085, 500, 112143, 14, 4086, 35, 57);
INSERT INTO public.who_global_data VALUES (8086, 0, 14025, 0, 40, 35, 38);
INSERT INTO public.who_global_data VALUES (8087, 56773, 7675973, 1074, 194949, 35, 141);
INSERT INTO public.who_global_data VALUES (8088, 0, 93, 0, 1, 35, 178);
INSERT INTO public.who_global_data VALUES (8089, 0, 157, 0, 3, 35, 108);
INSERT INTO public.who_global_data VALUES (8090, 274, 202540, 28, 7604, 35, 39);
INSERT INTO public.who_global_data VALUES (8091, 0, 6707, 0, 85, 35, 2);
INSERT INTO public.who_global_data VALUES (8092, 0, 822, 0, 2, 35, 195);
INSERT INTO public.who_global_data VALUES (8093, 0, 11840, 0, 113, 35, 107);
INSERT INTO public.who_global_data VALUES (8094, 1, 379, 0, 0, 35, 161);
INSERT INTO public.who_global_data VALUES (8095, 0, 26848, 0, 448, 35, 212);
INSERT INTO public.who_global_data VALUES (8096, 8420, 581402, 133, 15605, 35, 181);
INSERT INTO public.who_global_data VALUES (8097, 8, 338, 0, 2, 35, 53);
INSERT INTO public.who_global_data VALUES (8098, 0, 4963, 0, 63, 35, 164);
INSERT INTO public.who_global_data VALUES (8099, 0, 2113, 0, 104, 35, 140);
INSERT INTO public.who_global_data VALUES (8100, 3591, 612564, 52, 16660, 35, 20);
INSERT INTO public.who_global_data VALUES (8101, 67, 96829, 1, 4790, 35, 112);
INSERT INTO public.who_global_data VALUES (8102, 16314, 1642775, 304, 43213, 35, 111);
INSERT INTO public.who_global_data VALUES (8103, 0, 765, 0, 9, 35, 71);
INSERT INTO public.who_global_data VALUES (8104, 0, 6200, 0, 100, 35, 218);
INSERT INTO public.who_global_data VALUES (8105, 0, 0, 0, 0, 35, 43);
INSERT INTO public.who_global_data VALUES (8106, 1207, 169321, 14, 2185, 35, 49);
INSERT INTO public.who_global_data VALUES (8107, 0, 22250, 0, 137, 35, 1);
INSERT INTO public.who_global_data VALUES (8108, 255, 212262, 55, 4016, 35, 48);
INSERT INTO public.who_global_data VALUES (8109, 193, 12056, 0, 146, 35, 232);
INSERT INTO public.who_global_data VALUES (8110, 0, 4230, 0, 14, 35, 175);
INSERT INTO public.who_global_data VALUES (8111, 167, 22818, 2, 127, 35, 21);
INSERT INTO public.who_global_data VALUES (8112, 3447, 735469, 116, 11827, 35, 156);
INSERT INTO public.who_global_data VALUES (8113, 0, 0, 0, 0, 35, 95);
INSERT INTO public.who_global_data VALUES (8114, 0, 17374, 0, 591, 35, 177);
INSERT INTO public.who_global_data VALUES (8115, 2451, 165930, 24, 1322, 35, 210);
INSERT INTO public.who_global_data VALUES (8116, 9, 5840, 0, 61, 35, 120);
INSERT INTO public.who_global_data VALUES (8117, 0, 96, 0, 0, 35, 135);
INSERT INTO public.who_global_data VALUES (8118, 1433, 172218, 2, 2416, 35, 206);
INSERT INTO public.who_global_data VALUES (8119, 866, 213378, 17, 14051, 35, 189);
INSERT INTO public.who_global_data VALUES (8120, 1409, 139471, 56, 7687, 35, 129);
INSERT INTO public.who_global_data VALUES (8121, 0, 45960, 7, 1343, 35, 121);
INSERT INTO public.who_global_data VALUES (8122, 0, 5277, 0, 86, 35, 59);
INSERT INTO public.who_global_data VALUES (8123, 0, 1320, 0, 3, 35, 96);
INSERT INTO public.who_global_data VALUES (8124, 383, 28789, 7, 241, 35, 41);
INSERT INTO public.who_global_data VALUES (8125, 0, 9358, 0, 206, 35, 216);
INSERT INTO public.who_global_data VALUES (8126, 0, 124264, 0, 1923, 35, 236);
INSERT INTO public.who_global_data VALUES (8127, 0, 29, 0, 0, 35, 150);
INSERT INTO public.who_global_data VALUES (8128, 0, 610, 0, 0, 35, 61);
INSERT INTO public.who_global_data VALUES (8129, 0, 49, 0, 2, 35, 7);
INSERT INTO public.who_global_data VALUES (8130, 296, 36403, 0, 561, 35, 169);
INSERT INTO public.who_global_data VALUES (8131, 19241, 2595661, 133, 64387, 35, 28);
INSERT INTO public.who_global_data VALUES (8132, 107, 13273, 0, 71, 35, 85);
INSERT INTO public.who_global_data VALUES (8133, 0, 16926, 0, 114, 35, 211);
INSERT INTO public.who_global_data VALUES (8134, 0, 9571, 0, 64, 35, 60);
INSERT INTO public.who_global_data VALUES (8135, 0, 3800, 0, 124, 35, 3);
INSERT INTO public.who_global_data VALUES (8136, 342, 228752, 44, 2572, 35, 11);
INSERT INTO public.who_global_data VALUES (8137, 12690, 1755351, 336, 33960, 35, 89);
INSERT INTO public.who_global_data VALUES (8138, 0, 54771, 0, 335, 35, 24);
INSERT INTO public.who_global_data VALUES (8139, 67, 2040, 1, 7, 35, 162);
INSERT INTO public.who_global_data VALUES (8140, 597, 139447, 43, 4881, 35, 100);
INSERT INTO public.who_global_data VALUES (8141, 0, 27, 0, 0, 35, 47);
INSERT INTO public.who_global_data VALUES (8142, 0, 130, 0, 1, 35, 29);
INSERT INTO public.who_global_data VALUES (8143, 0, 8620, 0, 155, 35, 40);
INSERT INTO public.who_global_data VALUES (8144, 9, 7148, 0, 122, 35, 222);
INSERT INTO public.who_global_data VALUES (8145, 224, 138236, 7, 4820, 35, 132);
INSERT INTO public.who_global_data VALUES (8146, 0, 298, 0, 13, 35, 130);
INSERT INTO public.who_global_data VALUES (8147, 0, 13722, 0, 81, 35, 234);
INSERT INTO public.who_global_data VALUES (8148, 0, 2447, 0, 45, 35, 23);
INSERT INTO public.who_global_data VALUES (8149, 13, 6332, 0, 164, 35, 192);
INSERT INTO public.who_global_data VALUES (8150, 0, 10015, 0, 236, 35, 69);
INSERT INTO public.who_global_data VALUES (8151, 0, 26, 0, 0, 35, 187);
INSERT INTO public.who_global_data VALUES (8152, 936, 122763, 11, 3141, 35, 230);
INSERT INTO public.who_global_data VALUES (8153, 1410, 326688, 114, 9781, 35, 77);
INSERT INTO public.who_global_data VALUES (8154, 0, 5754, 0, 29, 35, 9);
INSERT INTO public.who_global_data VALUES (8155, 19079, 10305788, 224, 149218, 35, 74);
INSERT INTO public.who_global_data VALUES (8156, 8072, 751270, 191, 22329, 35, 224);
INSERT INTO public.who_global_data VALUES (8157, 6286, 1231429, 114, 55337, 35, 199);
INSERT INTO public.who_global_data VALUES (8158, 902, 596193, 11, 12824, 35, 190);
INSERT INTO public.who_global_data VALUES (8159, 1753, 93532, 11, 2248, 35, 12);
INSERT INTO public.who_global_data VALUES (8160, 3, 380, 0, 25, 35, 104);
INSERT INTO public.who_global_data VALUES (8161, 5876, 425689, 35, 3364, 35, 153);
INSERT INTO public.who_global_data VALUES (8162, 22210, 2129376, 462, 74621, 35, 91);
INSERT INTO public.who_global_data VALUES (8163, 88, 12915, 1, 303, 35, 215);
INSERT INTO public.who_global_data VALUES (8164, 3617, 238012, 54, 3514, 35, 84);
INSERT INTO public.who_global_data VALUES (8165, 34, 2760, 2, 44, 35, 231);
INSERT INTO public.who_global_data VALUES (8166, 1271, 295765, 17, 3851, 35, 196);
INSERT INTO public.who_global_data VALUES (8167, 721, 202880, 0, 2749, 35, 105);
INSERT INTO public.who_global_data VALUES (8168, 0, 96458, 0, 1670, 35, 122);
INSERT INTO public.who_global_data VALUES (8169, 0, 0, 0, 0, 35, 159);
INSERT INTO public.who_global_data VALUES (8170, 174, 51459, 1, 1326, 35, 75);
INSERT INTO public.who_global_data VALUES (8171, 285, 150869, 2, 936, 35, 27);
INSERT INTO public.who_global_data VALUES (8172, 58, 81214, 2, 1358, 35, 54);
INSERT INTO public.who_global_data VALUES (8173, 0, 41, 0, 0, 35, 226);
INSERT INTO public.who_global_data VALUES (8174, 711, 41615, 9, 644, 35, 79);
INSERT INTO public.who_global_data VALUES (8175, 2385, 183888, 11, 1466, 35, 56);
INSERT INTO public.who_global_data VALUES (8176, 0, 2577, 0, 50, 35, 117);
INSERT INTO public.who_global_data VALUES (8177, 0, 1800, 0, 83, 35, 152);
INSERT INTO public.who_global_data VALUES (8178, 467, 100744, 9, 1487, 35, 16);
INSERT INTO public.who_global_data VALUES (8179, 14, 2259, 0, 38, 35, 10);
INSERT INTO public.who_global_data VALUES (8180, 1492, 145387, 51, 1889, 35, 201);
INSERT INTO public.who_global_data VALUES (8181, 215, 46813, 3, 501, 35, 174);
INSERT INTO public.who_global_data VALUES (8182, 0, 17714, 0, 261, 35, 119);
INSERT INTO public.who_global_data VALUES (8183, 0, 6583, 0, 189, 35, 168);
INSERT INTO public.who_global_data VALUES (8184, 2068, 115078, 3, 474, 35, 99);
INSERT INTO public.who_global_data VALUES (8185, 47, 13804, 0, 48, 35, 171);
INSERT INTO public.who_global_data VALUES (8186, 0, 7090, 0, 269, 35, 87);
INSERT INTO public.who_global_data VALUES (8187, 135, 12909, 0, 219, 35, 123);
INSERT INTO public.who_global_data VALUES (8188, 0, 4, 0, 0, 35, 151);
INSERT INTO public.who_global_data VALUES (8189, 0, 6091, 0, 43, 35, 213);
INSERT INTO public.who_global_data VALUES (8190, 0, 13642, 0, 324, 35, 118);
INSERT INTO public.who_global_data VALUES (8191, 0, 527, 0, 10, 35, 134);
INSERT INTO public.who_global_data VALUES (8192, 0, 5890, 0, 55, 35, 65);
INSERT INTO public.who_global_data VALUES (8193, 12159, 1426094, 910, 125807, 35, 102);
INSERT INTO public.who_global_data VALUES (8194, 0, 0, 0, 0, 35, 223);
INSERT INTO public.who_global_data VALUES (8195, 10, 888, 0, 3, 35, 4);
INSERT INTO public.who_global_data VALUES (8196, 5, 1220, 0, 0, 35, 146);
INSERT INTO public.who_global_data VALUES (8197, 386, 49179, 0, 684, 35, 31);
INSERT INTO public.who_global_data VALUES (8198, 0, 13, 0, 1, 35, 127);
INSERT INTO public.who_global_data VALUES (8199, 1777, 440970, 37, 7425, 35, 22);
INSERT INTO public.who_global_data VALUES (8200, 0, 18642, 0, 166, 35, 115);
INSERT INTO public.who_global_data VALUES (8201, 423, 125053, 15, 2697, 35, 106);
INSERT INTO public.who_global_data VALUES (8202, 0, 23941, 0, 205, 35, 90);
INSERT INTO public.who_global_data VALUES (8203, 0, 0, 0, 0, 35, 70);
INSERT INTO public.who_global_data VALUES (8204, 426, 261019, 8, 1864, 35, 46);
INSERT INTO public.who_global_data VALUES (8205, 8173, 804067, 98, 11502, 35, 139);
INSERT INTO public.who_global_data VALUES (8206, 0, 38, 0, 0, 35, 42);
INSERT INTO public.who_global_data VALUES (8207, 0, 1806, 0, 25, 35, 80);
INSERT INTO public.who_global_data VALUES (8208, 0, 4829, 0, 165, 35, 203);
INSERT INTO public.who_global_data VALUES (8209, 0, 3208, 0, 102, 35, 136);
INSERT INTO public.who_global_data VALUES (8210, 0, 87510, 0, 1289, 35, 63);
INSERT INTO public.who_global_data VALUES (8211, 0, 0, 0, 0, 35, 17);
INSERT INTO public.who_global_data VALUES (8212, 0, 122, 0, 2, 35, 172);
INSERT INTO public.who_global_data VALUES (8213, 414, 83743, 7, 2510, 35, 109);
INSERT INTO public.who_global_data VALUES (8214, 0, 48278, 0, 436, 35, 200);
INSERT INTO public.who_global_data VALUES (8215, 1450, 156815, 21, 1550, 35, 93);
INSERT INTO public.who_global_data VALUES (8216, 0, 128867, 0, 1499, 35, 5);
INSERT INTO public.who_global_data VALUES (8217, 0, 745, 0, 13, 35, 214);
INSERT INTO public.who_global_data VALUES (8218, 2463, 482178, 71, 10176, 35, 204);
INSERT INTO public.who_global_data VALUES (8219, 0, 0, 0, 0, 35, 198);
INSERT INTO public.who_global_data VALUES (8220, 4046, 246790, 47, 4022, 35, 173);
INSERT INTO public.who_global_data VALUES (8221, 0, 780, 0, 9, 35, 229);
INSERT INTO public.who_global_data VALUES (8222, 974, 107932, 20, 2262, 35, 76);
INSERT INTO public.who_global_data VALUES (8223, 2523, 1015137, 59, 37680, 35, 138);
INSERT INTO public.who_global_data VALUES (8224, 1756, 475820, 4, 9248, 35, 98);
INSERT INTO public.who_global_data VALUES (8225, 0, 0, 0, 0, 35, 103);
INSERT INTO public.who_global_data VALUES (8226, 7006, 1312780, 102, 29058, 35, 225);
INSERT INTO public.who_global_data VALUES (8227, 6951, 420629, 66, 6972, 35, 131);
INSERT INTO public.who_global_data VALUES (8228, 763, 77054, 18, 1521, 35, 235);
INSERT INTO public.who_global_data VALUES (8229, 208, 144042, 0, 245, 35, 137);
INSERT INTO public.who_global_data VALUES (8230, 824, 62578, 25, 942, 35, 81);
INSERT INTO public.who_global_data VALUES (8231, 440, 145258, 19, 3004, 35, 182);
INSERT INTO public.who_global_data VALUES (8232, 0, 9037, 0, 42, 35, 145);
INSERT INTO public.who_global_data VALUES (8233, 3938, 636201, 74, 15841, 35, 26);
INSERT INTO public.who_global_data VALUES (8234, 26301, 3212637, 447, 58002, 35, 170);
INSERT INTO public.who_global_data VALUES (8235, 0, 8383, 0, 92, 35, 191);
INSERT INTO public.who_global_data VALUES (8236, 0, 5, 0, 0, 35, 221);
INSERT INTO public.who_global_data VALUES (8237, 0, 190, 0, 0, 35, 64);
INSERT INTO public.who_global_data VALUES (8238, 0, 0, 0, 0, 35, 116);
INSERT INTO public.who_global_data VALUES (8239, 0, 32, 0, 0, 35, 128);
INSERT INTO public.who_global_data VALUES (8240, 0, 353, 0, 5, 35, 6);
INSERT INTO public.who_global_data VALUES (8241, 0, 995, 0, 12, 35, 227);
INSERT INTO public.who_global_data VALUES (8242, 0, 16, 0, 0, 35, 68);
INSERT INTO public.who_global_data VALUES (8243, 2, 121, 0, 0, 35, 184);
INSERT INTO public.who_global_data VALUES (8244, 0, 2, 0, 0, 35, 82);
INSERT INTO public.who_global_data VALUES (8245, 44, 2428, 0, 59, 35, 149);
INSERT INTO public.who_global_data VALUES (8246, 0, 1014, 0, 17, 35, 197);
INSERT INTO public.who_global_data VALUES (8247, 137, 362878, 7, 6230, 35, 78);
INSERT INTO public.who_global_data VALUES (8248, 0, 19140, 0, 410, 35, 233);
INSERT INTO public.who_global_data VALUES (8249, 2074, 339997, 39, 3250, 35, 133);
INSERT INTO public.who_global_data VALUES (8250, 0, 267, 0, 0, 35, 35);
INSERT INTO public.who_global_data VALUES (8251, 0, 2560, 0, 76, 35, 114);
INSERT INTO public.who_global_data VALUES (8252, 30, 58629, 0, 29, 35, 237);
INSERT INTO public.who_global_data VALUES (8253, 0, 19, 0, 0, 35, 55);
INSERT INTO public.who_global_data VALUES (8254, 0, 1434, 0, 27, 35, 176);
INSERT INTO public.who_global_data VALUES (8255, 1736, 186244, 0, 2250, 35, 202);
INSERT INTO public.who_global_data VALUES (8256, 398, 124428, 35, 3055, 35, 155);
INSERT INTO public.who_global_data VALUES (8257, 0, 17, 0, 0, 35, 32);
INSERT INTO public.who_global_data VALUES (8258, 0, 4714, 0, 130, 35, 220);
INSERT INTO public.who_global_data VALUES (8259, 0, 1057561, 0, 28469, 35, 30);
INSERT INTO public.who_global_data VALUES (8260, 0, 3558, 0, 63, 35, 147);
INSERT INTO public.who_global_data VALUES (8261, 13891, 2020939, 142, 51935, 35, 208);
INSERT INTO public.who_global_data VALUES (8262, 557, 43856, 0, 204, 35, 45);
INSERT INTO public.who_global_data VALUES (8263, 152, 25882, 12, 1588, 35, 110);
INSERT INTO public.who_global_data VALUES (8264, 29, 6210, 1, 122, 35, 88);
INSERT INTO public.who_global_data VALUES (8265, 7002, 454776, 110, 9850, 35, 51);
INSERT INTO public.who_global_data VALUES (8266, 1679, 455853, 72, 7387, 35, 209);
INSERT INTO public.who_global_data VALUES (8267, 92, 11526, 6, 717, 35, 205);
INSERT INTO public.who_global_data VALUES (8268, 6, 13671, 1, 91, 35, 18);
INSERT INTO public.who_global_data VALUES (8269, 279, 7163, 2, 63, 35, 72);
INSERT INTO public.who_global_data VALUES (8270, 53285, 2542069, 613, 74125, 35, 44);
INSERT INTO public.who_global_data VALUES (8271, 0, 44, 0, 0, 35, 15);
INSERT INTO public.who_global_data VALUES (8272, 0, 3633, 0, 68, 35, 25);
INSERT INTO public.who_global_data VALUES (8273, 0, 0, 0, 0, 35, 179);
INSERT INTO public.who_global_data VALUES (8274, 0, 0, 0, 0, 35, 34);
INSERT INTO public.who_global_data VALUES (8275, 18, 7150, 1, 127, 35, 207);
INSERT INTO public.who_global_data VALUES (8276, 1417, 140557, 54, 4730, 35, 166);
INSERT INTO public.who_global_data VALUES (8277, 12203, 2220855, 212, 21093, 35, 126);
INSERT INTO public.who_global_data VALUES (8278, 0, 0, 0, 0, 35, 97);
INSERT INTO public.who_global_data VALUES (8279, 19, 893, 0, 6, 35, 36);
INSERT INTO public.who_global_data VALUES (8280, 0, 0, 0, 0, 35, 125);
INSERT INTO public.who_global_data VALUES (8281, 0, 35216, 0, 251, 35, 124);
INSERT INTO public.who_global_data VALUES (8282, 5038, 1069517, 51, 18731, 35, 185);
INSERT INTO public.who_global_data VALUES (8283, 1856, 209678, 2, 671, 35, 194);
INSERT INTO public.who_global_data VALUES (8284, 0, 509, 0, 21, 35, 144);
INSERT INTO public.who_global_data VALUES (8285, 228437, 19806654, 3280, 342830, 35, 19);
INSERT INTO public.who_global_data VALUES (8286, 5, 2036, 0, 23, 35, 217);
INSERT INTO public.who_global_data VALUES (8287, 639, 19119, 7, 181, 35, 148);
INSERT INTO public.who_global_data VALUES (8288, 56, 77182, 0, 614, 35, 86);
INSERT INTO public.who_global_data VALUES (8289, 0, 1, 0, 0, 35, 13);
INSERT INTO public.who_global_data VALUES (8290, 441, 113562, 3, 1028, 35, 157);
INSERT INTO public.who_global_data VALUES (8291, 9, 1474, 0, 35, 35, 8);
INSERT INTO public.who_global_data VALUES (8292, 0, 4, 0, 0, 35, 73);
INSERT INTO public.who_global_data VALUES (8293, 2, 2105, 0, 611, 35, 101);
INSERT INTO public.who_global_data VALUES (8294, 0, 20725, 0, 388, 35, 165);
INSERT INTO public.who_global_data VALUES (8295, 0, 13867, 0, 363, 35, 14);
INSERT INTO public.who_global_data VALUES (8296, 183, 52513, 12, 2201, 36, 193);
INSERT INTO public.who_global_data VALUES (8297, 589, 58316, 7, 1181, 36, 113);
INSERT INTO public.who_global_data VALUES (8298, 299, 99610, 5, 2756, 36, 143);
INSERT INTO public.who_global_data VALUES (8299, 0, 0, 0, 0, 36, 219);
INSERT INTO public.who_global_data VALUES (8300, 66, 8049, 0, 84, 36, 186);
INSERT INTO public.who_global_data VALUES (8301, 182, 17553, 6, 405, 36, 52);
INSERT INTO public.who_global_data VALUES (8302, 0, 13, 0, 0, 36, 180);
INSERT INTO public.who_global_data VALUES (8303, 1, 159, 0, 5, 36, 167);
INSERT INTO public.who_global_data VALUES (8304, 11765, 1613928, 145, 43163, 36, 154);
INSERT INTO public.who_global_data VALUES (8305, 531, 158722, 16, 2818, 36, 94);
INSERT INTO public.who_global_data VALUES (8306, 69, 5442, 0, 49, 36, 66);
INSERT INTO public.who_global_data VALUES (8307, 27, 28408, 0, 909, 36, 58);
INSERT INTO public.who_global_data VALUES (8308, 3011, 359362, 45, 6131, 36, 163);
INSERT INTO public.who_global_data VALUES (8309, 1064, 218700, 32, 2641, 36, 37);
INSERT INTO public.who_global_data VALUES (8310, 14, 7871, 0, 170, 36, 142);
INSERT INTO public.who_global_data VALUES (8311, 250, 92675, 0, 352, 36, 83);
INSERT INTO public.who_global_data VALUES (8312, 1014, 513510, 28, 7559, 36, 228);
INSERT INTO public.who_global_data VALUES (8313, 0, 372, 0, 7, 36, 188);
INSERT INTO public.who_global_data VALUES (8314, 1923, 194284, 10, 1424, 36, 62);
INSERT INTO public.who_global_data VALUES (8315, 1721, 649295, 87, 19592, 36, 160);
INSERT INTO public.who_global_data VALUES (8316, 56, 10724, 1, 242, 36, 50);
INSERT INTO public.who_global_data VALUES (8317, 0, 3251, 0, 44, 36, 33);
INSERT INTO public.who_global_data VALUES (8318, 9, 604, 0, 10, 36, 183);
INSERT INTO public.who_global_data VALUES (8319, 15, 670, 0, 0, 36, 92);
INSERT INTO public.who_global_data VALUES (8320, 1485, 158372, 14, 9149, 36, 158);
INSERT INTO public.who_global_data VALUES (8321, 3, 165, 0, 3, 36, 67);
INSERT INTO public.who_global_data VALUES (8322, 658, 111643, 22, 4072, 36, 57);
INSERT INTO public.who_global_data VALUES (8323, 0, 14025, 0, 40, 36, 38);
INSERT INTO public.who_global_data VALUES (8324, 55649, 7619200, 1194, 193875, 36, 141);
INSERT INTO public.who_global_data VALUES (8325, 0, 93, 0, 1, 36, 178);
INSERT INTO public.who_global_data VALUES (8326, 0, 157, 0, 3, 36, 108);
INSERT INTO public.who_global_data VALUES (8327, 1046, 202266, 61, 7576, 36, 39);
INSERT INTO public.who_global_data VALUES (8328, 170, 6707, 3, 85, 36, 2);
INSERT INTO public.who_global_data VALUES (8329, 4, 822, 0, 2, 36, 195);
INSERT INTO public.who_global_data VALUES (8330, 47, 11840, 1, 113, 36, 107);
INSERT INTO public.who_global_data VALUES (8331, 12, 378, 0, 0, 36, 161);
INSERT INTO public.who_global_data VALUES (8332, 571, 26848, 0, 448, 36, 212);
INSERT INTO public.who_global_data VALUES (8333, 7476, 572982, 94, 15472, 36, 181);
INSERT INTO public.who_global_data VALUES (8334, 4, 330, 0, 2, 36, 53);
INSERT INTO public.who_global_data VALUES (8335, 0, 4963, 0, 63, 36, 164);
INSERT INTO public.who_global_data VALUES (8336, 36, 2113, 0, 104, 36, 140);
INSERT INTO public.who_global_data VALUES (8337, 3023, 608973, 109, 16608, 36, 20);
INSERT INTO public.who_global_data VALUES (8338, 89, 96762, 1, 4789, 36, 112);
INSERT INTO public.who_global_data VALUES (8339, 11639, 1626461, 289, 42909, 36, 111);
INSERT INTO public.who_global_data VALUES (8340, 0, 765, 0, 9, 36, 71);
INSERT INTO public.who_global_data VALUES (8341, 0, 6200, 0, 100, 36, 218);
INSERT INTO public.who_global_data VALUES (8342, 0, 0, 0, 0, 36, 43);
INSERT INTO public.who_global_data VALUES (8343, 1315, 168114, 15, 2171, 36, 49);
INSERT INTO public.who_global_data VALUES (8344, 0, 22250, 0, 137, 36, 1);
INSERT INTO public.who_global_data VALUES (8345, 1170, 212007, 41, 3961, 36, 48);
INSERT INTO public.who_global_data VALUES (8346, 176, 11863, 1, 146, 36, 232);
INSERT INTO public.who_global_data VALUES (8347, 51, 4230, 0, 14, 36, 175);
INSERT INTO public.who_global_data VALUES (8348, 632, 22651, 6, 125, 36, 21);
INSERT INTO public.who_global_data VALUES (8349, 13361, 732022, 131, 11711, 36, 156);
INSERT INTO public.who_global_data VALUES (8350, 0, 0, 0, 0, 36, 95);
INSERT INTO public.who_global_data VALUES (8351, 194, 17374, 7, 591, 36, 177);
INSERT INTO public.who_global_data VALUES (8352, 2249, 163479, 42, 1298, 36, 210);
INSERT INTO public.who_global_data VALUES (8353, 7, 5831, 0, 61, 36, 120);
INSERT INTO public.who_global_data VALUES (8354, 0, 96, 0, 0, 36, 135);
INSERT INTO public.who_global_data VALUES (8355, 1206, 170785, 5, 2414, 36, 206);
INSERT INTO public.who_global_data VALUES (8356, 1000, 212512, 11, 14034, 36, 189);
INSERT INTO public.who_global_data VALUES (8357, 1418, 138062, 55, 7631, 36, 129);
INSERT INTO public.who_global_data VALUES (8358, 0, 45960, 9, 1336, 36, 121);
INSERT INTO public.who_global_data VALUES (8359, 13, 5277, 0, 86, 36, 59);
INSERT INTO public.who_global_data VALUES (8360, 68, 1320, 2, 3, 36, 96);
INSERT INTO public.who_global_data VALUES (8361, 416, 28406, 5, 234, 36, 41);
INSERT INTO public.who_global_data VALUES (8362, 212, 9358, 21, 206, 36, 216);
INSERT INTO public.who_global_data VALUES (8363, 408, 124264, 5, 1923, 36, 236);
INSERT INTO public.who_global_data VALUES (8364, 0, 29, 0, 0, 36, 150);
INSERT INTO public.who_global_data VALUES (8365, 5, 610, 0, 0, 36, 61);
INSERT INTO public.who_global_data VALUES (8366, 0, 49, 0, 2, 36, 7);
INSERT INTO public.who_global_data VALUES (8367, 249, 36107, 5, 561, 36, 169);
INSERT INTO public.who_global_data VALUES (8368, 19712, 2576420, 250, 64254, 36, 28);
INSERT INTO public.who_global_data VALUES (8369, 121, 13166, 0, 71, 36, 85);
INSERT INTO public.who_global_data VALUES (8370, 75, 16926, 0, 114, 36, 211);
INSERT INTO public.who_global_data VALUES (8371, 0, 9571, 0, 64, 36, 60);
INSERT INTO public.who_global_data VALUES (8372, 3, 3800, 0, 124, 36, 3);
INSERT INTO public.who_global_data VALUES (8373, 990, 228410, 23, 2528, 36, 11);
INSERT INTO public.who_global_data VALUES (8374, 22924, 1742661, 553, 33624, 36, 89);
INSERT INTO public.who_global_data VALUES (8375, 0, 54771, 0, 335, 36, 24);
INSERT INTO public.who_global_data VALUES (8376, 180, 1973, 0, 6, 36, 162);
INSERT INTO public.who_global_data VALUES (8377, 932, 138850, 50, 4838, 36, 100);
INSERT INTO public.who_global_data VALUES (8378, 0, 27, 0, 0, 36, 47);
INSERT INTO public.who_global_data VALUES (8379, 0, 130, 0, 1, 36, 29);
INSERT INTO public.who_global_data VALUES (8380, 0, 8620, 0, 155, 36, 40);
INSERT INTO public.who_global_data VALUES (8381, 10, 7139, 1, 122, 36, 222);
INSERT INTO public.who_global_data VALUES (8382, 846, 138012, 10, 4813, 36, 132);
INSERT INTO public.who_global_data VALUES (8383, 1, 298, 0, 13, 36, 130);
INSERT INTO public.who_global_data VALUES (8384, 15, 13722, 1, 81, 36, 234);
INSERT INTO public.who_global_data VALUES (8385, 0, 2447, 0, 45, 36, 23);
INSERT INTO public.who_global_data VALUES (8386, 18, 6319, 0, 164, 36, 192);
INSERT INTO public.who_global_data VALUES (8387, 16, 10015, 0, 236, 36, 69);
INSERT INTO public.who_global_data VALUES (8388, 0, 26, 0, 0, 36, 187);
INSERT INTO public.who_global_data VALUES (8389, 915, 121827, 19, 3130, 36, 230);
INSERT INTO public.who_global_data VALUES (8390, 2764, 325278, 130, 9667, 36, 77);
INSERT INTO public.who_global_data VALUES (8391, 0, 5754, 0, 29, 36, 9);
INSERT INTO public.who_global_data VALUES (8392, 20035, 10286709, 256, 148994, 36, 74);
INSERT INTO public.who_global_data VALUES (8393, 8074, 743198, 194, 22138, 36, 224);
INSERT INTO public.who_global_data VALUES (8394, 6390, 1225143, 128, 55223, 36, 199);
INSERT INTO public.who_global_data VALUES (8395, 849, 595291, 5, 12813, 36, 190);
INSERT INTO public.who_global_data VALUES (8396, 1622, 91779, 11, 2237, 36, 12);
INSERT INTO public.who_global_data VALUES (8397, 3, 377, 0, 25, 36, 104);
INSERT INTO public.who_global_data VALUES (8398, 5868, 419813, 15, 3329, 36, 153);
INSERT INTO public.who_global_data VALUES (8399, 23477, 2107166, 555, 74159, 36, 91);
INSERT INTO public.who_global_data VALUES (8400, 34, 12827, 0, 302, 36, 215);
INSERT INTO public.who_global_data VALUES (8401, 4091, 234395, 46, 3460, 36, 84);
INSERT INTO public.who_global_data VALUES (8402, 19, 2726, 1, 42, 36, 231);
INSERT INTO public.who_global_data VALUES (8403, 1427, 294494, 19, 3834, 36, 196);
INSERT INTO public.who_global_data VALUES (8404, 846, 202159, 0, 2749, 36, 105);
INSERT INTO public.who_global_data VALUES (8405, 207, 96458, 3, 1670, 36, 122);
INSERT INTO public.who_global_data VALUES (8406, 0, 0, 0, 0, 36, 159);
INSERT INTO public.who_global_data VALUES (8407, 184, 51285, 3, 1325, 36, 75);
INSERT INTO public.who_global_data VALUES (8408, 286, 150584, 1, 934, 36, 27);
INSERT INTO public.who_global_data VALUES (8409, 122, 81156, 1, 1356, 36, 54);
INSERT INTO public.who_global_data VALUES (8410, 0, 41, 0, 0, 36, 226);
INSERT INTO public.who_global_data VALUES (8411, 1861, 40904, 9, 635, 36, 79);
INSERT INTO public.who_global_data VALUES (8412, 3507, 181503, 12, 1455, 36, 56);
INSERT INTO public.who_global_data VALUES (8413, 0, 2577, 0, 50, 36, 117);
INSERT INTO public.who_global_data VALUES (8414, 0, 1800, 0, 83, 36, 152);
INSERT INTO public.who_global_data VALUES (8415, 342, 100277, 19, 1478, 36, 16);
INSERT INTO public.who_global_data VALUES (8416, 24, 2245, 0, 38, 36, 10);
INSERT INTO public.who_global_data VALUES (8417, 3322, 143895, 41, 1838, 36, 201);
INSERT INTO public.who_global_data VALUES (8418, 187, 46598, 3, 498, 36, 174);
INSERT INTO public.who_global_data VALUES (8419, 0, 17714, 0, 261, 36, 119);
INSERT INTO public.who_global_data VALUES (8420, 112, 6583, 0, 189, 36, 168);
INSERT INTO public.who_global_data VALUES (8421, 2525, 113010, 8, 471, 36, 99);
INSERT INTO public.who_global_data VALUES (8422, 19, 13757, 0, 48, 36, 171);
INSERT INTO public.who_global_data VALUES (8423, 61, 7090, 0, 269, 36, 87);
INSERT INTO public.who_global_data VALUES (8424, 109, 12774, 4, 219, 36, 123);
INSERT INTO public.who_global_data VALUES (8425, 0, 4, 0, 0, 36, 151);
INSERT INTO public.who_global_data VALUES (8426, 19, 6091, 1, 43, 36, 213);
INSERT INTO public.who_global_data VALUES (8427, 0, 13642, 0, 324, 36, 118);
INSERT INTO public.who_global_data VALUES (8428, 0, 527, 0, 10, 36, 134);
INSERT INTO public.who_global_data VALUES (8429, 0, 5890, 0, 55, 36, 65);
INSERT INTO public.who_global_data VALUES (8430, 12406, 1413935, 1052, 124897, 36, 102);
INSERT INTO public.who_global_data VALUES (8431, 0, 0, 0, 0, 36, 223);
INSERT INTO public.who_global_data VALUES (8432, 22, 878, 0, 3, 36, 4);
INSERT INTO public.who_global_data VALUES (8433, 20, 1215, 0, 0, 36, 146);
INSERT INTO public.who_global_data VALUES (8434, 249, 48793, 2, 684, 36, 31);
INSERT INTO public.who_global_data VALUES (8435, 0, 13, 0, 1, 36, 127);
INSERT INTO public.who_global_data VALUES (8436, 1861, 439193, 33, 7388, 36, 22);
INSERT INTO public.who_global_data VALUES (8437, 269, 18642, 3, 166, 36, 115);
INSERT INTO public.who_global_data VALUES (8438, 890, 124630, 18, 2682, 36, 106);
INSERT INTO public.who_global_data VALUES (8439, 608, 23941, 9, 205, 36, 90);
INSERT INTO public.who_global_data VALUES (8440, 0, 0, 0, 0, 36, 70);
INSERT INTO public.who_global_data VALUES (8441, 534, 260593, 9, 1856, 36, 46);
INSERT INTO public.who_global_data VALUES (8442, 9669, 795894, 109, 11404, 36, 139);
INSERT INTO public.who_global_data VALUES (8443, 0, 38, 0, 0, 36, 42);
INSERT INTO public.who_global_data VALUES (8444, 0, 1806, 0, 25, 36, 80);
INSERT INTO public.who_global_data VALUES (8445, 0, 4829, 0, 165, 36, 203);
INSERT INTO public.who_global_data VALUES (8446, 98, 3208, 6, 102, 36, 136);
INSERT INTO public.who_global_data VALUES (8447, 934, 87510, 11, 1289, 36, 63);
INSERT INTO public.who_global_data VALUES (8448, 0, 0, 0, 0, 36, 17);
INSERT INTO public.who_global_data VALUES (8449, 0, 122, 0, 2, 36, 172);
INSERT INTO public.who_global_data VALUES (8450, 535, 83329, 15, 2503, 36, 109);
INSERT INTO public.who_global_data VALUES (8451, 0, 48278, 0, 436, 36, 200);
INSERT INTO public.who_global_data VALUES (8452, 1268, 155365, 29, 1529, 36, 93);
INSERT INTO public.who_global_data VALUES (8453, 148, 128867, 2, 1499, 36, 5);
INSERT INTO public.who_global_data VALUES (8454, 0, 745, 0, 13, 36, 214);
INSERT INTO public.who_global_data VALUES (8455, 2475, 479715, 58, 10105, 36, 204);
INSERT INTO public.who_global_data VALUES (8456, 0, 0, 0, 0, 36, 198);
INSERT INTO public.who_global_data VALUES (8457, 4465, 242744, 42, 3975, 36, 173);
INSERT INTO public.who_global_data VALUES (8458, 0, 780, 0, 9, 36, 229);
INSERT INTO public.who_global_data VALUES (8459, 822, 106958, 22, 2242, 36, 76);
INSERT INTO public.who_global_data VALUES (8460, 2118, 1012614, 47, 37621, 36, 138);
INSERT INTO public.who_global_data VALUES (8461, 1532, 474064, 14, 9244, 36, 98);
INSERT INTO public.who_global_data VALUES (8462, 0, 0, 0, 0, 36, 103);
INSERT INTO public.who_global_data VALUES (8463, 10896, 1305774, 402, 28956, 36, 225);
INSERT INTO public.who_global_data VALUES (8464, 7627, 413678, 76, 6906, 36, 131);
INSERT INTO public.who_global_data VALUES (8465, 403, 76291, 19, 1503, 36, 235);
INSERT INTO public.who_global_data VALUES (8466, 213, 143834, 0, 245, 36, 137);
INSERT INTO public.who_global_data VALUES (8467, 1028, 61754, 17, 917, 36, 81);
INSERT INTO public.who_global_data VALUES (8468, 977, 144818, 26, 2985, 36, 182);
INSERT INTO public.who_global_data VALUES (8469, 65, 9037, 0, 42, 36, 145);
INSERT INTO public.who_global_data VALUES (8470, 4322, 632263, 171, 15767, 36, 26);
INSERT INTO public.who_global_data VALUES (8471, 27039, 3186336, 536, 57555, 36, 170);
INSERT INTO public.who_global_data VALUES (8472, 133, 8383, 6, 92, 36, 191);
INSERT INTO public.who_global_data VALUES (8473, 0, 5, 0, 0, 36, 221);
INSERT INTO public.who_global_data VALUES (8474, 1, 190, 0, 0, 36, 64);
INSERT INTO public.who_global_data VALUES (8475, 0, 0, 0, 0, 36, 116);
INSERT INTO public.who_global_data VALUES (8476, 0, 32, 0, 0, 36, 128);
INSERT INTO public.who_global_data VALUES (8477, 13, 353, 0, 5, 36, 6);
INSERT INTO public.who_global_data VALUES (8478, 9, 995, 0, 12, 36, 227);
INSERT INTO public.who_global_data VALUES (8479, 0, 16, 0, 0, 36, 68);
INSERT INTO public.who_global_data VALUES (8480, 4, 119, 0, 0, 36, 184);
INSERT INTO public.who_global_data VALUES (8481, 0, 2, 0, 0, 36, 82);
INSERT INTO public.who_global_data VALUES (8482, 51, 2384, 0, 59, 36, 149);
INSERT INTO public.who_global_data VALUES (8483, 0, 1014, 0, 17, 36, 197);
INSERT INTO public.who_global_data VALUES (8484, 140, 362741, 9, 6223, 36, 78);
INSERT INTO public.who_global_data VALUES (8485, 195, 19140, 8, 410, 36, 233);
INSERT INTO public.who_global_data VALUES (8486, 2932, 337923, 48, 3211, 36, 133);
INSERT INTO public.who_global_data VALUES (8487, 41, 267, 0, 0, 36, 35);
INSERT INTO public.who_global_data VALUES (8488, 0, 2560, 0, 76, 36, 114);
INSERT INTO public.who_global_data VALUES (8489, 30, 58599, 0, 29, 36, 237);
INSERT INTO public.who_global_data VALUES (8490, 0, 19, 0, 0, 36, 55);
INSERT INTO public.who_global_data VALUES (8491, 11, 1434, 0, 27, 36, 176);
INSERT INTO public.who_global_data VALUES (8492, 4965, 184508, 112, 2250, 36, 202);
INSERT INTO public.who_global_data VALUES (8493, 1773, 124030, 42, 3020, 36, 155);
INSERT INTO public.who_global_data VALUES (8494, 0, 17, 0, 0, 36, 32);
INSERT INTO public.who_global_data VALUES (8495, 0, 4714, 0, 130, 36, 220);
INSERT INTO public.who_global_data VALUES (8496, 18400, 1057561, 436, 28469, 36, 30);
INSERT INTO public.who_global_data VALUES (8497, 18, 3558, 0, 63, 36, 147);
INSERT INTO public.who_global_data VALUES (8498, 20617, 2007048, 161, 51793, 36, 208);
INSERT INTO public.who_global_data VALUES (8499, 597, 43299, 5, 204, 36, 45);
INSERT INTO public.who_global_data VALUES (8500, 230, 25730, 15, 1576, 36, 110);
INSERT INTO public.who_global_data VALUES (8501, 83, 6181, 1, 121, 36, 88);
INSERT INTO public.who_global_data VALUES (8502, 10459, 447774, 90, 9740, 36, 51);
INSERT INTO public.who_global_data VALUES (8503, 3054, 454174, 75, 7315, 36, 209);
INSERT INTO public.who_global_data VALUES (8504, 90, 11434, 7, 711, 36, 205);
INSERT INTO public.who_global_data VALUES (8505, 0, 13665, 0, 90, 36, 18);
INSERT INTO public.who_global_data VALUES (8506, 194, 6884, 0, 61, 36, 72);
INSERT INTO public.who_global_data VALUES (8507, 55892, 2488784, 964, 73512, 36, 44);
INSERT INTO public.who_global_data VALUES (8508, 0, 44, 0, 0, 36, 15);
INSERT INTO public.who_global_data VALUES (8509, 29, 3633, 0, 68, 36, 25);
INSERT INTO public.who_global_data VALUES (8510, 0, 0, 0, 0, 36, 179);
INSERT INTO public.who_global_data VALUES (8511, 0, 0, 0, 0, 36, 34);
INSERT INTO public.who_global_data VALUES (8512, 0, 7132, 0, 126, 36, 207);
INSERT INTO public.who_global_data VALUES (8513, 1924, 139140, 56, 4676, 36, 166);
INSERT INTO public.who_global_data VALUES (8514, 14380, 2208652, 239, 20881, 36, 126);
INSERT INTO public.who_global_data VALUES (8515, 0, 0, 0, 0, 36, 97);
INSERT INTO public.who_global_data VALUES (8516, 9, 874, 0, 6, 36, 36);
INSERT INTO public.who_global_data VALUES (8517, 0, 0, 0, 0, 36, 125);
INSERT INTO public.who_global_data VALUES (8518, 539, 35216, 2, 251, 36, 124);
INSERT INTO public.who_global_data VALUES (8519, 9432, 1064479, 147, 18680, 36, 185);
INSERT INTO public.who_global_data VALUES (8520, 1730, 207822, 4, 669, 36, 194);
INSERT INTO public.who_global_data VALUES (8521, 0, 509, 0, 21, 36, 144);
INSERT INTO public.who_global_data VALUES (8522, 231427, 19578217, 3761, 339550, 36, 19);
INSERT INTO public.who_global_data VALUES (8523, 21, 2031, 0, 23, 36, 217);
INSERT INTO public.who_global_data VALUES (8524, 518, 18480, 6, 174, 36, 148);
INSERT INTO public.who_global_data VALUES (8525, 66, 77126, 0, 614, 36, 86);
INSERT INTO public.who_global_data VALUES (8526, 0, 1, 0, 0, 36, 13);
INSERT INTO public.who_global_data VALUES (8527, 260, 113121, 4, 1025, 36, 157);
INSERT INTO public.who_global_data VALUES (8528, 9, 1465, 0, 35, 36, 8);
INSERT INTO public.who_global_data VALUES (8529, 0, 4, 0, 0, 36, 73);
INSERT INTO public.who_global_data VALUES (8530, 2, 2103, 0, 611, 36, 101);
INSERT INTO public.who_global_data VALUES (8531, 263, 20725, 2, 388, 36, 165);
INSERT INTO public.who_global_data VALUES (8532, 242, 13867, 3, 363, 36, 14);
INSERT INTO public.who_global_data VALUES (8533, 0, 52330, 0, 2189, 37, 193);
INSERT INTO public.who_global_data VALUES (8534, 581, 57727, 4, 1174, 37, 113);
INSERT INTO public.who_global_data VALUES (8535, 705, 99311, 15, 2751, 37, 143);
INSERT INTO public.who_global_data VALUES (8536, 0, 0, 0, 0, 37, 219);
INSERT INTO public.who_global_data VALUES (8537, 64, 7983, 0, 84, 37, 186);
INSERT INTO public.who_global_data VALUES (8538, 0, 17371, 0, 399, 37, 52);
INSERT INTO public.who_global_data VALUES (8539, 0, 13, 0, 0, 37, 180);
INSERT INTO public.who_global_data VALUES (8540, 0, 158, 0, 5, 37, 167);
INSERT INTO public.who_global_data VALUES (8541, 11650, 1602163, 150, 43018, 37, 154);
INSERT INTO public.who_global_data VALUES (8542, 582, 158191, 10, 2802, 37, 94);
INSERT INTO public.who_global_data VALUES (8543, 50, 5373, 0, 49, 37, 66);
INSERT INTO public.who_global_data VALUES (8544, 31, 28381, 0, 909, 37, 58);
INSERT INTO public.who_global_data VALUES (8545, 3129, 356351, 81, 6086, 37, 163);
INSERT INTO public.who_global_data VALUES (8546, 1052, 217636, 34, 2609, 37, 37);
INSERT INTO public.who_global_data VALUES (8547, 11, 7857, 0, 170, 37, 142);
INSERT INTO public.who_global_data VALUES (8548, 256, 92425, 1, 352, 37, 83);
INSERT INTO public.who_global_data VALUES (8549, 1235, 512496, 22, 7531, 37, 228);
INSERT INTO public.who_global_data VALUES (8550, 7, 372, 0, 7, 37, 188);
INSERT INTO public.who_global_data VALUES (8551, 1957, 192361, 10, 1414, 37, 62);
INSERT INTO public.who_global_data VALUES (8552, 2081, 647574, 74, 19505, 37, 160);
INSERT INTO public.who_global_data VALUES (8553, 77, 10668, 5, 241, 37, 50);
INSERT INTO public.who_global_data VALUES (8554, 0, 3251, 0, 44, 37, 33);
INSERT INTO public.who_global_data VALUES (8555, 14, 595, 0, 10, 37, 183);
INSERT INTO public.who_global_data VALUES (8556, 19, 655, 0, 0, 37, 92);
INSERT INTO public.who_global_data VALUES (8557, 1293, 156887, 29, 9135, 37, 158);
INSERT INTO public.who_global_data VALUES (8558, 3, 162, 0, 3, 37, 67);
INSERT INTO public.who_global_data VALUES (8559, 531, 110985, 26, 4050, 37, 57);
INSERT INTO public.who_global_data VALUES (8560, 0, 14025, 0, 40, 37, 38);
INSERT INTO public.who_global_data VALUES (8561, 58718, 7563551, 1111, 192681, 37, 141);
INSERT INTO public.who_global_data VALUES (8562, 0, 93, 0, 1, 37, 178);
INSERT INTO public.who_global_data VALUES (8563, 5, 157, 0, 3, 37, 108);
INSERT INTO public.who_global_data VALUES (8564, 1729, 201220, 110, 7515, 37, 39);
INSERT INTO public.who_global_data VALUES (8565, 0, 6537, 0, 82, 37, 2);
INSERT INTO public.who_global_data VALUES (8566, 9, 818, 0, 2, 37, 195);
INSERT INTO public.who_global_data VALUES (8567, 41, 11793, 0, 112, 37, 107);
INSERT INTO public.who_global_data VALUES (8568, 2, 366, 0, 0, 37, 161);
INSERT INTO public.who_global_data VALUES (8569, 0, 26277, 0, 448, 37, 212);
INSERT INTO public.who_global_data VALUES (8570, 6442, 565506, 156, 15378, 37, 181);
INSERT INTO public.who_global_data VALUES (8571, 8, 326, 0, 2, 37, 53);
INSERT INTO public.who_global_data VALUES (8572, 0, 4963, 0, 63, 37, 164);
INSERT INTO public.who_global_data VALUES (8573, 62, 2077, 0, 104, 37, 140);
INSERT INTO public.who_global_data VALUES (8574, 1964, 605950, 11, 16499, 37, 20);
INSERT INTO public.who_global_data VALUES (8575, 81, 96673, 4, 4788, 37, 112);
INSERT INTO public.who_global_data VALUES (8576, 11015, 1614822, 246, 42620, 37, 111);
INSERT INTO public.who_global_data VALUES (8577, 34, 765, 2, 9, 37, 71);
INSERT INTO public.who_global_data VALUES (8578, 0, 6200, 0, 100, 37, 218);
INSERT INTO public.who_global_data VALUES (8579, 0, 0, 0, 0, 37, 43);
INSERT INTO public.who_global_data VALUES (8580, 1037, 166799, 12, 2156, 37, 49);
INSERT INTO public.who_global_data VALUES (8581, 0, 22250, 0, 137, 37, 1);
INSERT INTO public.who_global_data VALUES (8582, 2391, 210837, 60, 3920, 37, 48);
INSERT INTO public.who_global_data VALUES (8583, 86, 11687, 2, 145, 37, 232);
INSERT INTO public.who_global_data VALUES (8584, 28, 4179, 0, 14, 37, 175);
INSERT INTO public.who_global_data VALUES (8585, 704, 22019, 2, 119, 37, 21);
INSERT INTO public.who_global_data VALUES (8586, 17039, 718661, 151, 11580, 37, 156);
INSERT INTO public.who_global_data VALUES (8587, 0, 0, 0, 0, 37, 95);
INSERT INTO public.who_global_data VALUES (8588, 265, 17180, 0, 584, 37, 177);
INSERT INTO public.who_global_data VALUES (8589, 2783, 161230, 30, 1256, 37, 210);
INSERT INTO public.who_global_data VALUES (8590, 11, 5824, 0, 61, 37, 120);
INSERT INTO public.who_global_data VALUES (8591, 0, 96, 0, 0, 37, 135);
INSERT INTO public.who_global_data VALUES (8592, 1314, 169579, 4, 2409, 37, 206);
INSERT INTO public.who_global_data VALUES (8593, 1186, 211512, 22, 14023, 37, 189);
INSERT INTO public.who_global_data VALUES (8594, 1411, 136644, 56, 7576, 37, 129);
INSERT INTO public.who_global_data VALUES (8595, 545, 45960, 14, 1327, 37, 121);
INSERT INTO public.who_global_data VALUES (8596, 16, 5264, 0, 86, 37, 59);
INSERT INTO public.who_global_data VALUES (8597, 32, 1252, 0, 1, 37, 96);
INSERT INTO public.who_global_data VALUES (8598, 734, 27990, 3, 229, 37, 41);
INSERT INTO public.who_global_data VALUES (8599, 212, 9146, 9, 185, 37, 216);
INSERT INTO public.who_global_data VALUES (8600, 711, 123856, 6, 1918, 37, 236);
INSERT INTO public.who_global_data VALUES (8601, 0, 29, 0, 0, 37, 150);
INSERT INTO public.who_global_data VALUES (8602, 4, 605, 0, 0, 37, 61);
INSERT INTO public.who_global_data VALUES (8603, 0, 49, 0, 2, 37, 7);
INSERT INTO public.who_global_data VALUES (8604, 0, 35858, 0, 556, 37, 169);
INSERT INTO public.who_global_data VALUES (8605, 26308, 2556708, 303, 64004, 37, 28);
INSERT INTO public.who_global_data VALUES (8606, 149, 13045, 0, 71, 37, 85);
INSERT INTO public.who_global_data VALUES (8607, 56, 16851, 1, 114, 37, 211);
INSERT INTO public.who_global_data VALUES (8608, 61, 9571, 0, 64, 37, 60);
INSERT INTO public.who_global_data VALUES (8609, 0, 3797, 0, 124, 37, 3);
INSERT INTO public.who_global_data VALUES (8610, 1527, 227420, 24, 2505, 37, 11);
INSERT INTO public.who_global_data VALUES (8611, 32552, 1719737, 964, 33071, 37, 89);
INSERT INTO public.who_global_data VALUES (8612, 90, 54771, 0, 335, 37, 24);
INSERT INTO public.who_global_data VALUES (8613, 87, 1793, 0, 6, 37, 162);
INSERT INTO public.who_global_data VALUES (8614, 942, 137918, 58, 4788, 37, 100);
INSERT INTO public.who_global_data VALUES (8615, 0, 27, 0, 0, 37, 47);
INSERT INTO public.who_global_data VALUES (8616, 0, 130, 0, 1, 37, 29);
INSERT INTO public.who_global_data VALUES (8617, 0, 8620, 0, 155, 37, 40);
INSERT INTO public.who_global_data VALUES (8618, 15, 7129, 0, 121, 37, 222);
INSERT INTO public.who_global_data VALUES (8619, 879, 137166, 22, 4803, 37, 132);
INSERT INTO public.who_global_data VALUES (8620, 0, 297, 0, 13, 37, 130);
INSERT INTO public.who_global_data VALUES (8621, 19, 13707, 0, 80, 37, 234);
INSERT INTO public.who_global_data VALUES (8622, 0, 2447, 0, 45, 37, 23);
INSERT INTO public.who_global_data VALUES (8623, 3, 6301, 0, 164, 37, 192);
INSERT INTO public.who_global_data VALUES (8624, 0, 9999, 0, 236, 37, 69);
INSERT INTO public.who_global_data VALUES (8625, 0, 26, 0, 0, 37, 187);
INSERT INTO public.who_global_data VALUES (8626, 809, 120912, 23, 3111, 37, 230);
INSERT INTO public.who_global_data VALUES (8627, 2971, 322514, 108, 9537, 37, 77);
INSERT INTO public.who_global_data VALUES (8628, 0, 5754, 0, 29, 37, 9);
INSERT INTO public.who_global_data VALUES (8629, 21822, 10266674, 299, 148738, 37, 74);
INSERT INTO public.who_global_data VALUES (8630, 8002, 735124, 241, 21944, 37, 224);
INSERT INTO public.who_global_data VALUES (8631, 6272, 1218753, 149, 55095, 37, 199);
INSERT INTO public.who_global_data VALUES (8632, 901, 594442, 8, 12808, 37, 190);
INSERT INTO public.who_global_data VALUES (8633, 1718, 90157, 13, 2226, 37, 12);
INSERT INTO public.who_global_data VALUES (8634, 0, 374, 0, 25, 37, 104);
INSERT INTO public.who_global_data VALUES (8635, 5639, 413945, 26, 3314, 37, 153);
INSERT INTO public.who_global_data VALUES (8636, 16202, 2083689, 575, 73604, 37, 91);
INSERT INTO public.who_global_data VALUES (8637, 41, 12793, 4, 302, 37, 215);
INSERT INTO public.who_global_data VALUES (8638, 3708, 230304, 65, 3414, 37, 84);
INSERT INTO public.who_global_data VALUES (8639, 15, 2707, 0, 41, 37, 231);
INSERT INTO public.who_global_data VALUES (8640, 1674, 293067, 14, 3815, 37, 196);
INSERT INTO public.who_global_data VALUES (8641, 870, 201313, 0, 2749, 37, 105);
INSERT INTO public.who_global_data VALUES (8642, 259, 96251, 3, 1667, 37, 122);
INSERT INTO public.who_global_data VALUES (8643, 0, 0, 0, 0, 37, 159);
INSERT INTO public.who_global_data VALUES (8644, 234, 51101, 7, 1322, 37, 75);
INSERT INTO public.who_global_data VALUES (8645, 205, 150298, 1, 933, 37, 27);
INSERT INTO public.who_global_data VALUES (8646, 191, 81034, 1, 1355, 37, 54);
INSERT INTO public.who_global_data VALUES (8647, 0, 41, 0, 0, 37, 226);
INSERT INTO public.who_global_data VALUES (8648, 1367, 39043, 23, 626, 37, 79);
INSERT INTO public.who_global_data VALUES (8649, 2878, 177996, 13, 1443, 37, 56);
INSERT INTO public.who_global_data VALUES (8650, 0, 2577, 0, 50, 37, 117);
INSERT INTO public.who_global_data VALUES (8651, 0, 1800, 0, 83, 37, 152);
INSERT INTO public.who_global_data VALUES (8652, 585, 99935, 15, 1459, 37, 16);
INSERT INTO public.who_global_data VALUES (8653, 31, 2221, 1, 38, 37, 10);
INSERT INTO public.who_global_data VALUES (8654, 2375, 140573, 56, 1797, 37, 201);
INSERT INTO public.who_global_data VALUES (8655, 326, 46411, 6, 495, 37, 174);
INSERT INTO public.who_global_data VALUES (8656, 0, 17714, 0, 261, 37, 119);
INSERT INTO public.who_global_data VALUES (8657, 82, 6471, 1, 189, 37, 168);
INSERT INTO public.who_global_data VALUES (8658, 1870, 110485, 6, 463, 37, 99);
INSERT INTO public.who_global_data VALUES (8659, 47, 13738, 0, 48, 37, 171);
INSERT INTO public.who_global_data VALUES (8660, 326, 7029, 13, 269, 37, 87);
INSERT INTO public.who_global_data VALUES (8661, 124, 12665, 0, 215, 37, 123);
INSERT INTO public.who_global_data VALUES (8662, 0, 4, 0, 0, 37, 151);
INSERT INTO public.who_global_data VALUES (8663, 0, 6072, 0, 42, 37, 213);
INSERT INTO public.who_global_data VALUES (8664, 0, 13642, 0, 324, 37, 118);
INSERT INTO public.who_global_data VALUES (8665, 3, 527, 0, 10, 37, 134);
INSERT INTO public.who_global_data VALUES (8666, 0, 5890, 0, 55, 37, 65);
INSERT INTO public.who_global_data VALUES (8667, 12099, 1401529, 990, 123845, 37, 102);
INSERT INTO public.who_global_data VALUES (8668, 0, 0, 0, 0, 37, 223);
INSERT INTO public.who_global_data VALUES (8669, 26, 856, 0, 3, 37, 4);
INSERT INTO public.who_global_data VALUES (8670, 20, 1195, 0, 0, 37, 146);
INSERT INTO public.who_global_data VALUES (8671, 439, 48544, 1, 682, 37, 31);
INSERT INTO public.who_global_data VALUES (8672, 0, 13, 0, 1, 37, 127);
INSERT INTO public.who_global_data VALUES (8673, 2143, 437332, 41, 7355, 37, 22);
INSERT INTO public.who_global_data VALUES (8674, 63, 18373, 1, 163, 37, 115);
INSERT INTO public.who_global_data VALUES (8675, 587, 123740, 27, 2664, 37, 106);
INSERT INTO public.who_global_data VALUES (8676, 482, 23333, 1, 196, 37, 90);
INSERT INTO public.who_global_data VALUES (8677, 0, 0, 0, 0, 37, 70);
INSERT INTO public.who_global_data VALUES (8678, 511, 260059, 7, 1847, 37, 46);
INSERT INTO public.who_global_data VALUES (8679, 9459, 786225, 112, 11295, 37, 139);
INSERT INTO public.who_global_data VALUES (8680, 0, 38, 0, 0, 37, 42);
INSERT INTO public.who_global_data VALUES (8681, 11, 1806, 0, 25, 37, 80);
INSERT INTO public.who_global_data VALUES (8682, 0, 4829, 0, 165, 37, 203);
INSERT INTO public.who_global_data VALUES (8683, 0, 3110, 0, 96, 37, 136);
INSERT INTO public.who_global_data VALUES (8684, 1016, 86576, 11, 1278, 37, 63);
INSERT INTO public.who_global_data VALUES (8685, 0, 0, 0, 0, 37, 17);
INSERT INTO public.who_global_data VALUES (8686, 0, 122, 0, 2, 37, 172);
INSERT INTO public.who_global_data VALUES (8687, 493, 82794, 15, 2488, 37, 109);
INSERT INTO public.who_global_data VALUES (8688, 695, 48278, 3, 436, 37, 200);
INSERT INTO public.who_global_data VALUES (8689, 1539, 154097, 21, 1500, 37, 93);
INSERT INTO public.who_global_data VALUES (8690, 86, 128719, 0, 1497, 37, 5);
INSERT INTO public.who_global_data VALUES (8691, 0, 745, 0, 13, 37, 214);
INSERT INTO public.who_global_data VALUES (8692, 2155, 477240, 55, 10047, 37, 204);
INSERT INTO public.who_global_data VALUES (8693, 0, 0, 0, 0, 37, 198);
INSERT INTO public.who_global_data VALUES (8694, 4574, 238279, 41, 3933, 37, 173);
INSERT INTO public.who_global_data VALUES (8695, 0, 780, 0, 9, 37, 229);
INSERT INTO public.who_global_data VALUES (8696, 762, 106136, 18, 2220, 37, 76);
INSERT INTO public.who_global_data VALUES (8697, 1588, 1010496, 49, 37574, 37, 138);
INSERT INTO public.who_global_data VALUES (8698, 1006, 472532, 68, 9230, 37, 98);
INSERT INTO public.who_global_data VALUES (8699, 0, 0, 0, 0, 37, 103);
INSERT INTO public.who_global_data VALUES (8700, 13464, 1294878, 535, 28554, 37, 225);
INSERT INTO public.who_global_data VALUES (8701, 6049, 406051, 79, 6830, 37, 131);
INSERT INTO public.who_global_data VALUES (8702, 98, 75888, 24, 1484, 37, 235);
INSERT INTO public.who_global_data VALUES (8703, 193, 143621, 0, 245, 37, 137);
INSERT INTO public.who_global_data VALUES (8704, 967, 60726, 21, 900, 37, 81);
INSERT INTO public.who_global_data VALUES (8705, 990, 143841, 25, 2959, 37, 182);
INSERT INTO public.who_global_data VALUES (8706, 0, 8972, 0, 42, 37, 145);
INSERT INTO public.who_global_data VALUES (8707, 4875, 627941, 127, 15596, 37, 26);
INSERT INTO public.who_global_data VALUES (8708, 27747, 3159297, 593, 57019, 37, 170);
INSERT INTO public.who_global_data VALUES (8709, 229, 8250, 11, 86, 37, 191);
INSERT INTO public.who_global_data VALUES (8710, 0, 5, 0, 0, 37, 221);
INSERT INTO public.who_global_data VALUES (8711, 0, 189, 0, 0, 37, 64);
INSERT INTO public.who_global_data VALUES (8712, 0, 0, 0, 0, 37, 116);
INSERT INTO public.who_global_data VALUES (8713, 0, 32, 0, 0, 37, 128);
INSERT INTO public.who_global_data VALUES (8714, 9, 340, 0, 5, 37, 6);
INSERT INTO public.who_global_data VALUES (8715, 0, 986, 0, 12, 37, 227);
INSERT INTO public.who_global_data VALUES (8716, 0, 16, 0, 0, 37, 68);
INSERT INTO public.who_global_data VALUES (8717, 2, 115, 0, 0, 37, 184);
INSERT INTO public.who_global_data VALUES (8718, 0, 2, 0, 0, 37, 82);
INSERT INTO public.who_global_data VALUES (8719, 0, 2333, 0, 59, 37, 149);
INSERT INTO public.who_global_data VALUES (8720, 0, 1014, 0, 17, 37, 197);
INSERT INTO public.who_global_data VALUES (8721, 113, 362601, 10, 6214, 37, 78);
INSERT INTO public.who_global_data VALUES (8722, 139, 18945, 7, 402, 37, 233);
INSERT INTO public.who_global_data VALUES (8723, 3236, 334991, 44, 3163, 37, 133);
INSERT INTO public.who_global_data VALUES (8724, 0, 226, 0, 0, 37, 35);
INSERT INTO public.who_global_data VALUES (8725, 0, 2560, 0, 76, 37, 114);
INSERT INTO public.who_global_data VALUES (8726, 27, 58569, 0, 29, 37, 237);
INSERT INTO public.who_global_data VALUES (8727, 0, 19, 0, 0, 37, 55);
INSERT INTO public.who_global_data VALUES (8728, 12, 1423, 1, 27, 37, 176);
INSERT INTO public.who_global_data VALUES (8729, 6315, 179543, 73, 2138, 37, 202);
INSERT INTO public.who_global_data VALUES (8730, 2428, 122257, 28, 2978, 37, 155);
INSERT INTO public.who_global_data VALUES (8731, 0, 17, 0, 0, 37, 32);
INSERT INTO public.who_global_data VALUES (8732, 24, 4714, 3, 130, 37, 220);
INSERT INTO public.who_global_data VALUES (8733, 17710, 1039161, 465, 28033, 37, 30);
INSERT INTO public.who_global_data VALUES (8734, 49, 3540, 1, 63, 37, 147);
INSERT INTO public.who_global_data VALUES (8735, 19415, 1986431, 124, 51632, 37, 208);
INSERT INTO public.who_global_data VALUES (8736, 639, 42702, 5, 199, 37, 45);
INSERT INTO public.who_global_data VALUES (8737, 262, 25500, 12, 1561, 37, 110);
INSERT INTO public.who_global_data VALUES (8738, 85, 6098, 0, 120, 37, 88);
INSERT INTO public.who_global_data VALUES (8739, 8874, 437315, 72, 9650, 37, 51);
INSERT INTO public.who_global_data VALUES (8740, 4206, 451120, 85, 7240, 37, 209);
INSERT INTO public.who_global_data VALUES (8741, 101, 11344, 8, 704, 37, 205);
INSERT INTO public.who_global_data VALUES (8742, 3, 13665, 0, 90, 37, 18);
INSERT INTO public.who_global_data VALUES (8743, 250, 6690, 0, 61, 37, 72);
INSERT INTO public.who_global_data VALUES (8744, 50023, 2432892, 981, 72548, 37, 44);
INSERT INTO public.who_global_data VALUES (8745, 0, 44, 0, 0, 37, 15);
INSERT INTO public.who_global_data VALUES (8746, 28, 3604, 0, 68, 37, 25);
INSERT INTO public.who_global_data VALUES (8747, 0, 0, 0, 0, 37, 179);
INSERT INTO public.who_global_data VALUES (8748, 0, 0, 0, 0, 37, 34);
INSERT INTO public.who_global_data VALUES (8749, 5, 7132, 1, 126, 37, 207);
INSERT INTO public.who_global_data VALUES (8750, 2414, 137216, 50, 4620, 37, 166);
INSERT INTO public.who_global_data VALUES (8751, 15692, 2194272, 254, 20642, 37, 126);
INSERT INTO public.who_global_data VALUES (8752, 0, 0, 0, 0, 37, 97);
INSERT INTO public.who_global_data VALUES (8753, 0, 865, 0, 6, 37, 36);
INSERT INTO public.who_global_data VALUES (8754, 0, 0, 0, 0, 37, 125);
INSERT INTO public.who_global_data VALUES (8755, 396, 34677, 1, 249, 37, 124);
INSERT INTO public.who_global_data VALUES (8756, 9699, 1055047, 209, 18533, 37, 185);
INSERT INTO public.who_global_data VALUES (8757, 1723, 206092, 3, 665, 37, 194);
INSERT INTO public.who_global_data VALUES (8758, 0, 509, 0, 21, 37, 144);
INSERT INTO public.who_global_data VALUES (8759, 199163, 19346790, 3366, 335789, 37, 19);
INSERT INTO public.who_global_data VALUES (8760, 6, 2010, 0, 23, 37, 217);
INSERT INTO public.who_global_data VALUES (8761, 656, 17962, 8, 168, 37, 148);
INSERT INTO public.who_global_data VALUES (8762, 75, 77060, 0, 614, 37, 86);
INSERT INTO public.who_global_data VALUES (8763, 0, 1, 0, 0, 37, 13);
INSERT INTO public.who_global_data VALUES (8764, 225, 112861, 3, 1021, 37, 157);
INSERT INTO public.who_global_data VALUES (8765, 2, 1456, 0, 35, 37, 8);
INSERT INTO public.who_global_data VALUES (8766, 0, 4, 0, 0, 37, 73);
INSERT INTO public.who_global_data VALUES (8767, 1, 2101, 0, 611, 37, 101);
INSERT INTO public.who_global_data VALUES (8768, 519, 20462, 2, 386, 37, 165);
INSERT INTO public.who_global_data VALUES (8769, 477, 13625, 6, 360, 37, 14);
INSERT INTO public.who_global_data VALUES (8770, 183, 52330, 7, 2189, 38, 193);
INSERT INTO public.who_global_data VALUES (8771, 574, 57146, 6, 1170, 38, 113);
INSERT INTO public.who_global_data VALUES (8772, 357, 98606, 8, 2736, 38, 143);
INSERT INTO public.who_global_data VALUES (8773, 0, 0, 0, 0, 38, 219);
INSERT INTO public.who_global_data VALUES (8774, 44, 7919, 1, 84, 38, 186);
INSERT INTO public.who_global_data VALUES (8775, 131, 17371, 0, 399, 38, 52);
INSERT INTO public.who_global_data VALUES (8776, 0, 13, 0, 0, 38, 180);
INSERT INTO public.who_global_data VALUES (8777, 3, 158, 0, 5, 38, 167);
INSERT INTO public.who_global_data VALUES (8778, 6586, 1590513, 218, 42868, 38, 154);
INSERT INTO public.who_global_data VALUES (8779, 0, 157609, 0, 2792, 38, 94);
INSERT INTO public.who_global_data VALUES (8780, 18, 5323, 0, 49, 38, 66);
INSERT INTO public.who_global_data VALUES (8781, 13, 28350, 0, 909, 38, 58);
INSERT INTO public.who_global_data VALUES (8782, 1836, 353222, 133, 6005, 38, 163);
INSERT INTO public.who_global_data VALUES (8783, 1101, 216584, 37, 2575, 38, 37);
INSERT INTO public.who_global_data VALUES (8784, 12, 7846, 0, 170, 38, 142);
INSERT INTO public.who_global_data VALUES (8785, 234, 92169, 0, 351, 38, 83);
INSERT INTO public.who_global_data VALUES (8786, 1181, 511261, 30, 7509, 38, 228);
INSERT INTO public.who_global_data VALUES (8787, 9, 365, 0, 7, 38, 188);
INSERT INTO public.who_global_data VALUES (8788, 1816, 190404, 10, 1404, 38, 62);
INSERT INTO public.who_global_data VALUES (8789, 2420, 645493, 76, 19431, 38, 160);
INSERT INTO public.who_global_data VALUES (8790, 30, 10591, 3, 236, 38, 50);
INSERT INTO public.who_global_data VALUES (8791, 46, 3251, 0, 44, 38, 33);
INSERT INTO public.who_global_data VALUES (8792, 0, 581, 0, 10, 38, 183);
INSERT INTO public.who_global_data VALUES (8793, 13, 636, 0, 0, 38, 92);
INSERT INTO public.who_global_data VALUES (8794, 751, 155594, 8, 9106, 38, 158);
INSERT INTO public.who_global_data VALUES (8795, 0, 159, 0, 3, 38, 67);
INSERT INTO public.who_global_data VALUES (8796, 543, 110454, 48, 4024, 38, 57);
INSERT INTO public.who_global_data VALUES (8797, 403, 14025, 2, 40, 38, 38);
INSERT INTO public.who_global_data VALUES (8798, 20548, 7504833, 431, 191570, 38, 141);
INSERT INTO public.who_global_data VALUES (8799, 0, 93, 0, 1, 38, 178);
INSERT INTO public.who_global_data VALUES (8800, 0, 152, 0, 3, 38, 108);
INSERT INTO public.who_global_data VALUES (8801, 1438, 199491, 154, 7405, 38, 39);
INSERT INTO public.who_global_data VALUES (8802, 193, 6537, 4, 82, 38, 2);
INSERT INTO public.who_global_data VALUES (8803, 0, 809, 0, 2, 38, 195);
INSERT INTO public.who_global_data VALUES (8804, 29, 11752, 0, 112, 38, 107);
INSERT INTO public.who_global_data VALUES (8805, 0, 364, 0, 0, 38, 161);
INSERT INTO public.who_global_data VALUES (8806, 0, 26277, 0, 448, 38, 212);
INSERT INTO public.who_global_data VALUES (8807, 5790, 559064, 114, 15222, 38, 181);
INSERT INTO public.who_global_data VALUES (8808, 0, 318, 0, 2, 38, 53);
INSERT INTO public.who_global_data VALUES (8809, 2, 4963, 0, 63, 38, 164);
INSERT INTO public.who_global_data VALUES (8810, 0, 2015, 0, 104, 38, 140);
INSERT INTO public.who_global_data VALUES (8811, 1958, 603986, 45, 16488, 38, 20);
INSERT INTO public.who_global_data VALUES (8812, 79, 96592, 2, 4784, 38, 112);
INSERT INTO public.who_global_data VALUES (8813, 9310, 1603807, 203, 42374, 38, 111);
INSERT INTO public.who_global_data VALUES (8814, 0, 731, 0, 7, 38, 71);
INSERT INTO public.who_global_data VALUES (8815, 0, 6200, 0, 100, 38, 218);
INSERT INTO public.who_global_data VALUES (8816, 0, 0, 0, 0, 38, 43);
INSERT INTO public.who_global_data VALUES (8817, 558, 165762, 10, 2144, 38, 49);
INSERT INTO public.who_global_data VALUES (8818, 74, 22250, 0, 137, 38, 1);
INSERT INTO public.who_global_data VALUES (8819, 1850, 208446, 65, 3860, 38, 48);
INSERT INTO public.who_global_data VALUES (8820, 167, 11601, 0, 143, 38, 232);
INSERT INTO public.who_global_data VALUES (8821, 7, 4151, 0, 14, 38, 175);
INSERT INTO public.who_global_data VALUES (8822, 907, 21315, 4, 117, 38, 21);
INSERT INTO public.who_global_data VALUES (8823, 16420, 701622, 127, 11429, 38, 156);
INSERT INTO public.who_global_data VALUES (8824, 0, 0, 0, 0, 38, 95);
INSERT INTO public.who_global_data VALUES (8825, 78, 16915, 5, 584, 38, 177);
INSERT INTO public.who_global_data VALUES (8826, 2621, 158447, 22, 1226, 38, 210);
INSERT INTO public.who_global_data VALUES (8827, 0, 5813, 0, 61, 38, 120);
INSERT INTO public.who_global_data VALUES (8828, 0, 96, 0, 0, 38, 135);
INSERT INTO public.who_global_data VALUES (8829, 860, 168265, 1, 2405, 38, 206);
INSERT INTO public.who_global_data VALUES (8830, 568, 210326, 7, 14001, 38, 189);
INSERT INTO public.who_global_data VALUES (8831, 1333, 135233, 54, 7520, 38, 129);
INSERT INTO public.who_global_data VALUES (8832, 0, 45415, 0, 1313, 38, 121);
INSERT INTO public.who_global_data VALUES (8833, 0, 5248, 0, 86, 38, 59);
INSERT INTO public.who_global_data VALUES (8834, 181, 1220, -1, 1, 38, 96);
INSERT INTO public.who_global_data VALUES (8835, 973, 27256, 13, 226, 38, 41);
INSERT INTO public.who_global_data VALUES (8836, 450, 8934, 11, 176, 38, 216);
INSERT INTO public.who_global_data VALUES (8837, 0, 123145, 0, 1912, 38, 236);
INSERT INTO public.who_global_data VALUES (8838, 0, 29, 0, 0, 38, 150);
INSERT INTO public.who_global_data VALUES (8839, 19, 601, 0, 0, 38, 61);
INSERT INTO public.who_global_data VALUES (8840, 3, 49, 0, 2, 38, 7);
INSERT INTO public.who_global_data VALUES (8841, 438, 35858, 6, 556, 38, 169);
INSERT INTO public.who_global_data VALUES (8842, 11295, 2530400, 969, 63701, 38, 28);
INSERT INTO public.who_global_data VALUES (8843, 64, 12896, 0, 71, 38, 85);
INSERT INTO public.who_global_data VALUES (8844, 99, 16795, 0, 113, 38, 211);
INSERT INTO public.who_global_data VALUES (8845, 0, 9510, 0, 64, 38, 60);
INSERT INTO public.who_global_data VALUES (8846, 0, 3797, 1, 124, 38, 3);
INSERT INTO public.who_global_data VALUES (8847, 1738, 225893, 38, 2481, 38, 11);
INSERT INTO public.who_global_data VALUES (8848, 22459, 1687185, 1129, 32107, 38, 89);
INSERT INTO public.who_global_data VALUES (8849, 178, 54681, 2, 335, 38, 24);
INSERT INTO public.who_global_data VALUES (8850, 45, 1706, 0, 6, 38, 162);
INSERT INTO public.who_global_data VALUES (8851, 1045, 136976, 58, 4730, 38, 100);
INSERT INTO public.who_global_data VALUES (8852, 1, 27, 0, 0, 38, 47);
INSERT INTO public.who_global_data VALUES (8853, 0, 130, 0, 1, 38, 29);
INSERT INTO public.who_global_data VALUES (8854, 0, 8620, 0, 155, 38, 40);
INSERT INTO public.who_global_data VALUES (8855, 12, 7114, 0, 121, 38, 222);
INSERT INTO public.who_global_data VALUES (8856, 846, 136287, 8, 4781, 38, 132);
INSERT INTO public.who_global_data VALUES (8857, 0, 297, 0, 13, 38, 130);
INSERT INTO public.who_global_data VALUES (8858, 0, 13688, 0, 80, 38, 234);
INSERT INTO public.who_global_data VALUES (8859, 0, 2447, 0, 45, 38, 23);
INSERT INTO public.who_global_data VALUES (8860, 0, 6298, 0, 164, 38, 192);
INSERT INTO public.who_global_data VALUES (8861, 41, 9999, 0, 236, 38, 69);
INSERT INTO public.who_global_data VALUES (8862, 0, 26, 0, 0, 38, 187);
INSERT INTO public.who_global_data VALUES (8863, 390, 120103, 22, 3088, 38, 230);
INSERT INTO public.who_global_data VALUES (8864, 1972, 319543, 137, 9429, 38, 77);
INSERT INTO public.who_global_data VALUES (8865, 18, 5754, 0, 29, 38, 9);
INSERT INTO public.who_global_data VALUES (8866, 20549, 10244852, 286, 148439, 38, 74);
INSERT INTO public.who_global_data VALUES (8867, 7903, 727122, 251, 21703, 38, 224);
INSERT INTO public.who_global_data VALUES (8868, 6108, 1212481, 132, 54946, 38, 199);
INSERT INTO public.who_global_data VALUES (8869, 1013, 593541, 9, 12800, 38, 190);
INSERT INTO public.who_global_data VALUES (8870, 1545, 88439, 8, 2213, 38, 12);
INSERT INTO public.who_global_data VALUES (8871, 0, 374, 0, 25, 38, 104);
INSERT INTO public.who_global_data VALUES (8872, 5519, 408306, 34, 3288, 38, 153);
INSERT INTO public.who_global_data VALUES (8873, 11210, 2067487, 659, 73029, 38, 91);
INSERT INTO public.who_global_data VALUES (8874, 20, 12752, 0, 298, 38, 215);
INSERT INTO public.who_global_data VALUES (8875, 3476, 226596, 43, 3349, 38, 84);
INSERT INTO public.who_global_data VALUES (8876, 29, 2692, 0, 41, 38, 231);
INSERT INTO public.who_global_data VALUES (8877, 1645, 291393, 23, 3801, 38, 196);
INSERT INTO public.who_global_data VALUES (8878, 888, 200443, 0, 2749, 38, 105);
INSERT INTO public.who_global_data VALUES (8879, 0, 95992, 0, 1664, 38, 122);
INSERT INTO public.who_global_data VALUES (8880, 0, 0, 0, 0, 38, 159);
INSERT INTO public.who_global_data VALUES (8881, 109, 50867, 8, 1315, 38, 75);
INSERT INTO public.who_global_data VALUES (8882, 236, 150093, 0, 932, 38, 27);
INSERT INTO public.who_global_data VALUES (8883, 189, 80843, 1, 1354, 38, 54);
INSERT INTO public.who_global_data VALUES (8884, 0, 41, 0, 0, 38, 226);
INSERT INTO public.who_global_data VALUES (8885, 838, 37676, 25, 603, 38, 79);
INSERT INTO public.who_global_data VALUES (8886, 2298, 175118, 21, 1430, 38, 56);
INSERT INTO public.who_global_data VALUES (8887, 0, 2577, 0, 50, 38, 117);
INSERT INTO public.who_global_data VALUES (8888, 0, 1800, 0, 83, 38, 152);
INSERT INTO public.who_global_data VALUES (8889, 437, 99350, 4, 1444, 38, 16);
INSERT INTO public.who_global_data VALUES (8890, 37, 2190, 2, 37, 38, 10);
INSERT INTO public.who_global_data VALUES (8891, 3911, 138198, 44, 1741, 38, 201);
INSERT INTO public.who_global_data VALUES (8892, 239, 46085, 2, 489, 38, 174);
INSERT INTO public.who_global_data VALUES (8893, 0, 17714, 0, 261, 38, 119);
INSERT INTO public.who_global_data VALUES (8894, 35, 6389, 0, 188, 38, 168);
INSERT INTO public.who_global_data VALUES (8895, 1925, 108615, 2, 457, 38, 99);
INSERT INTO public.who_global_data VALUES (8896, 31, 13691, 0, 48, 38, 171);
INSERT INTO public.who_global_data VALUES (8897, 0, 6703, 0, 256, 38, 87);
INSERT INTO public.who_global_data VALUES (8898, 115, 12541, 0, 215, 38, 123);
INSERT INTO public.who_global_data VALUES (8899, 0, 4, 0, 0, 38, 151);
INSERT INTO public.who_global_data VALUES (8900, 0, 6072, 0, 42, 38, 213);
INSERT INTO public.who_global_data VALUES (8901, 0, 13642, 0, 324, 38, 118);
INSERT INTO public.who_global_data VALUES (8902, 0, 524, 0, 10, 38, 134);
INSERT INTO public.who_global_data VALUES (8903, 0, 5890, 0, 55, 38, 65);
INSERT INTO public.who_global_data VALUES (8904, 5996, 1389430, 429, 122855, 38, 102);
INSERT INTO public.who_global_data VALUES (8905, 0, 0, 0, 0, 38, 223);
INSERT INTO public.who_global_data VALUES (8906, 24, 830, 0, 3, 38, 4);
INSERT INTO public.who_global_data VALUES (8907, 38, 1175, 0, 0, 38, 146);
INSERT INTO public.who_global_data VALUES (8908, 436, 48105, 4, 681, 38, 31);
INSERT INTO public.who_global_data VALUES (8909, 0, 13, 0, 1, 38, 127);
INSERT INTO public.who_global_data VALUES (8910, 2160, 435189, 42, 7314, 38, 22);
INSERT INTO public.who_global_data VALUES (8911, 45, 18310, 1, 162, 38, 115);
INSERT INTO public.who_global_data VALUES (8912, 619, 123153, 19, 2637, 38, 106);
INSERT INTO public.who_global_data VALUES (8913, 928, 22851, 4, 195, 38, 90);
INSERT INTO public.who_global_data VALUES (8914, 0, 0, 0, 0, 38, 70);
INSERT INTO public.who_global_data VALUES (8915, 708, 259548, 8, 1840, 38, 46);
INSERT INTO public.who_global_data VALUES (8916, 7527, 776766, 169, 11183, 38, 139);
INSERT INTO public.who_global_data VALUES (8917, 0, 38, 0, 0, 38, 42);
INSERT INTO public.who_global_data VALUES (8918, 0, 1795, 0, 25, 38, 80);
INSERT INTO public.who_global_data VALUES (8919, 39, 4829, 1, 165, 38, 203);
INSERT INTO public.who_global_data VALUES (8920, 105, 3110, 5, 96, 38, 136);
INSERT INTO public.who_global_data VALUES (8921, 749, 85560, 3, 1267, 38, 63);
INSERT INTO public.who_global_data VALUES (8922, 0, 0, 0, 0, 38, 17);
INSERT INTO public.who_global_data VALUES (8923, 0, 122, 0, 2, 38, 172);
INSERT INTO public.who_global_data VALUES (8924, 497, 82301, 17, 2473, 38, 109);
INSERT INTO public.who_global_data VALUES (8925, 526, 47583, 4, 433, 38, 200);
INSERT INTO public.who_global_data VALUES (8926, 1149, 152558, 19, 1479, 38, 93);
INSERT INTO public.who_global_data VALUES (8927, 70, 128633, 2, 1497, 38, 5);
INSERT INTO public.who_global_data VALUES (8928, 0, 745, 0, 13, 38, 214);
INSERT INTO public.who_global_data VALUES (8929, 1776, 475085, 63, 9992, 38, 204);
INSERT INTO public.who_global_data VALUES (8930, 0, 0, 0, 0, 38, 198);
INSERT INTO public.who_global_data VALUES (8931, 2348, 233705, 52, 3892, 38, 173);
INSERT INTO public.who_global_data VALUES (8932, 0, 780, 0, 9, 38, 229);
INSERT INTO public.who_global_data VALUES (8933, 952, 105374, 14, 2202, 38, 76);
INSERT INTO public.who_global_data VALUES (8934, 1251, 1008908, 51, 37525, 38, 138);
INSERT INTO public.who_global_data VALUES (8935, 876, 471526, 38, 9162, 38, 98);
INSERT INTO public.who_global_data VALUES (8936, 0, 0, 0, 0, 38, 103);
INSERT INTO public.who_global_data VALUES (8937, 12780, 1281414, 565, 28019, 38, 225);
INSERT INTO public.who_global_data VALUES (8938, 3336, 400002, 74, 6751, 38, 131);
INSERT INTO public.who_global_data VALUES (8939, 2132, 75790, 4, 1460, 38, 235);
INSERT INTO public.who_global_data VALUES (8940, 206, 143428, 1, 245, 38, 137);
INSERT INTO public.who_global_data VALUES (8941, 1050, 59759, 20, 879, 38, 81);
INSERT INTO public.who_global_data VALUES (8942, 927, 142851, 25, 2934, 38, 182);
INSERT INTO public.who_global_data VALUES (8943, 36, 8972, 0, 42, 38, 145);
INSERT INTO public.who_global_data VALUES (8944, 4637, 623066, 135, 15469, 38, 26);
INSERT INTO public.who_global_data VALUES (8945, 26513, 3131550, 599, 56426, 38, 170);
INSERT INTO public.who_global_data VALUES (8946, 0, 8021, 0, 75, 38, 191);
INSERT INTO public.who_global_data VALUES (8947, 0, 5, 0, 0, 38, 221);
INSERT INTO public.who_global_data VALUES (8948, 0, 189, 0, 0, 38, 64);
INSERT INTO public.who_global_data VALUES (8949, 0, 0, 0, 0, 38, 116);
INSERT INTO public.who_global_data VALUES (8950, 0, 32, 0, 0, 38, 128);
INSERT INTO public.who_global_data VALUES (8951, 0, 331, 0, 5, 38, 6);
INSERT INTO public.who_global_data VALUES (8952, 0, 986, 0, 12, 38, 227);
INSERT INTO public.who_global_data VALUES (8953, 0, 16, 0, 0, 38, 68);
INSERT INTO public.who_global_data VALUES (8954, 4, 113, 0, 0, 38, 184);
INSERT INTO public.who_global_data VALUES (8955, 0, 2, 0, 0, 38, 82);
INSERT INTO public.who_global_data VALUES (8956, 57, 2333, 2, 59, 38, 149);
INSERT INTO public.who_global_data VALUES (8957, 0, 1014, 0, 17, 38, 197);
INSERT INTO public.who_global_data VALUES (8958, 149, 362488, 8, 6204, 38, 78);
INSERT INTO public.who_global_data VALUES (8959, 78, 18806, 5, 395, 38, 233);
INSERT INTO public.who_global_data VALUES (8960, 3136, 331755, 46, 3119, 38, 133);
INSERT INTO public.who_global_data VALUES (8961, 15, 226, 0, 0, 38, 35);
INSERT INTO public.who_global_data VALUES (8962, 0, 2560, 0, 76, 38, 114);
INSERT INTO public.who_global_data VALUES (8963, 13, 58542, 0, 29, 38, 237);
INSERT INTO public.who_global_data VALUES (8964, 0, 19, 0, 0, 38, 55);
INSERT INTO public.who_global_data VALUES (8965, 0, 1411, 0, 26, 38, 176);
INSERT INTO public.who_global_data VALUES (8966, 3041, 173228, 82, 2065, 38, 202);
INSERT INTO public.who_global_data VALUES (8967, 2429, 119829, 31, 2950, 38, 155);
INSERT INTO public.who_global_data VALUES (8968, 0, 17, 0, 0, 38, 32);
INSERT INTO public.who_global_data VALUES (8969, 0, 4690, 0, 127, 38, 220);
INSERT INTO public.who_global_data VALUES (8970, 9580, 1021451, 497, 27568, 38, 30);
INSERT INTO public.who_global_data VALUES (8971, 0, 3491, 0, 62, 38, 147);
INSERT INTO public.who_global_data VALUES (8972, 15990, 1967016, 161, 51508, 38, 208);
INSERT INTO public.who_global_data VALUES (8973, 460, 42063, 0, 194, 38, 45);
INSERT INTO public.who_global_data VALUES (8974, 178, 25238, 9, 1549, 38, 110);
INSERT INTO public.who_global_data VALUES (8975, 35, 6013, 1, 120, 38, 88);
INSERT INTO public.who_global_data VALUES (8976, 7095, 428441, 121, 9578, 38, 51);
INSERT INTO public.who_global_data VALUES (8977, 4463, 446914, 68, 7155, 38, 209);
INSERT INTO public.who_global_data VALUES (8978, 105, 11243, 10, 696, 38, 205);
INSERT INTO public.who_global_data VALUES (8979, 37, 13662, 0, 90, 38, 18);
INSERT INTO public.who_global_data VALUES (8980, 0, 6440, 0, 61, 38, 72);
INSERT INTO public.who_global_data VALUES (8981, 53135, 2382869, 458, 71567, 38, 44);
INSERT INTO public.who_global_data VALUES (8982, 3, 44, 0, 0, 38, 15);
INSERT INTO public.who_global_data VALUES (8983, 0, 3576, 0, 68, 38, 25);
INSERT INTO public.who_global_data VALUES (8984, 0, 0, 0, 0, 38, 179);
INSERT INTO public.who_global_data VALUES (8985, 0, 0, 0, 0, 38, 34);
INSERT INTO public.who_global_data VALUES (8986, 12, 7127, 0, 125, 38, 207);
INSERT INTO public.who_global_data VALUES (8987, 1598, 134802, 52, 4570, 38, 166);
INSERT INTO public.who_global_data VALUES (8988, 15805, 2178580, 253, 20388, 38, 126);
INSERT INTO public.who_global_data VALUES (8989, 0, 0, 0, 0, 38, 97);
INSERT INTO public.who_global_data VALUES (8990, 16, 865, 0, 6, 38, 36);
INSERT INTO public.who_global_data VALUES (8991, 0, 0, 0, 0, 38, 125);
INSERT INTO public.who_global_data VALUES (8992, 470, 34281, 0, 248, 38, 124);
INSERT INTO public.who_global_data VALUES (8993, 7986, 1045348, 243, 18324, 38, 185);
INSERT INTO public.who_global_data VALUES (8994, 1506, 204369, 2, 662, 38, 194);
INSERT INTO public.who_global_data VALUES (8995, 0, 509, 0, 21, 38, 144);
INSERT INTO public.who_global_data VALUES (8996, 174814, 19147627, 1779, 332423, 38, 19);
INSERT INTO public.who_global_data VALUES (8997, 16, 2004, 0, 23, 38, 217);
INSERT INTO public.who_global_data VALUES (8998, 578, 17306, 2, 160, 38, 148);
INSERT INTO public.who_global_data VALUES (8999, 78, 76985, 1, 614, 38, 86);
INSERT INTO public.who_global_data VALUES (9000, 0, 1, 0, 0, 38, 13);
INSERT INTO public.who_global_data VALUES (9001, 320, 112636, 4, 1018, 38, 157);
INSERT INTO public.who_global_data VALUES (9002, 3, 1454, 0, 35, 38, 8);
INSERT INTO public.who_global_data VALUES (9003, 0, 4, 0, 0, 38, 73);
INSERT INTO public.who_global_data VALUES (9004, 0, 2100, 2, 611, 38, 101);
INSERT INTO public.who_global_data VALUES (9005, 0, 19943, 0, 384, 38, 165);
INSERT INTO public.who_global_data VALUES (9006, 0, 13148, 0, 354, 38, 14);
INSERT INTO public.who_global_data VALUES (9007, 140, 52147, 12, 2182, 39, 193);
INSERT INTO public.who_global_data VALUES (9008, 318, 56572, 11, 1164, 39, 113);
INSERT INTO public.who_global_data VALUES (9009, 0, 98249, 0, 2728, 39, 143);
INSERT INTO public.who_global_data VALUES (9010, 0, 0, 0, 0, 39, 219);
INSERT INTO public.who_global_data VALUES (9011, 54, 7875, 0, 83, 39, 186);
INSERT INTO public.who_global_data VALUES (9012, 0, 17240, 0, 399, 39, 52);
INSERT INTO public.who_global_data VALUES (9013, 1, 13, 0, 0, 39, 180);
INSERT INTO public.who_global_data VALUES (9014, 0, 155, 0, 5, 39, 167);
INSERT INTO public.who_global_data VALUES (9015, 5660, 1583927, 149, 42650, 39, 154);
INSERT INTO public.who_global_data VALUES (9016, 348, 157609, 22, 2792, 39, 94);
INSERT INTO public.who_global_data VALUES (9017, 77, 5305, 2, 49, 39, 66);
INSERT INTO public.who_global_data VALUES (9018, 25, 28337, 1, 909, 39, 58);
INSERT INTO public.who_global_data VALUES (9019, 1651, 351386, 78, 5872, 39, 163);
INSERT INTO public.who_global_data VALUES (9020, 772, 215483, 39, 2538, 39, 37);
INSERT INTO public.who_global_data VALUES (9021, 46, 7834, 1, 170, 39, 142);
INSERT INTO public.who_global_data VALUES (9022, 202, 91935, 0, 351, 39, 83);
INSERT INTO public.who_global_data VALUES (9023, 932, 510080, 27, 7479, 39, 228);
INSERT INTO public.who_global_data VALUES (9024, 0, 356, 0, 7, 39, 188);
INSERT INTO public.who_global_data VALUES (9025, 1841, 188588, 9, 1394, 39, 62);
INSERT INTO public.who_global_data VALUES (9026, 2749, 643073, 63, 19355, 39, 160);
INSERT INTO public.who_global_data VALUES (9027, 71, 10561, 5, 233, 39, 50);
INSERT INTO public.who_global_data VALUES (9028, 0, 3205, 0, 44, 39, 33);
INSERT INTO public.who_global_data VALUES (9029, 0, 581, 0, 10, 39, 183);
INSERT INTO public.who_global_data VALUES (9030, 0, 623, 0, 0, 39, 92);
INSERT INTO public.who_global_data VALUES (9031, 494, 154843, 5, 9098, 39, 158);
INSERT INTO public.who_global_data VALUES (9032, 1, 159, 0, 3, 39, 67);
INSERT INTO public.who_global_data VALUES (9033, 220, 109911, 23, 3976, 39, 57);
INSERT INTO public.who_global_data VALUES (9034, 0, 13622, 0, 38, 39, 38);
INSERT INTO public.who_global_data VALUES (9035, 18479, 7484285, 344, 191139, 39, 141);
INSERT INTO public.who_global_data VALUES (9036, 0, 93, 0, 1, 39, 178);
INSERT INTO public.who_global_data VALUES (9037, 0, 152, 0, 3, 39, 108);
INSERT INTO public.who_global_data VALUES (9038, 337, 198053, 87, 7251, 39, 39);
INSERT INTO public.who_global_data VALUES (9039, 0, 6344, 0, 78, 39, 2);
INSERT INTO public.who_global_data VALUES (9040, 5, 809, 0, 2, 39, 195);
INSERT INTO public.who_global_data VALUES (9041, 9, 11723, 0, 112, 39, 107);
INSERT INTO public.who_global_data VALUES (9042, 0, 364, 0, 0, 39, 161);
INSERT INTO public.who_global_data VALUES (9043, 0, 26277, 0, 448, 39, 212);
INSERT INTO public.who_global_data VALUES (9044, 6774, 553274, 209, 15108, 39, 181);
INSERT INTO public.who_global_data VALUES (9045, 0, 318, 0, 2, 39, 53);
INSERT INTO public.who_global_data VALUES (9046, 13, 4961, 0, 63, 39, 164);
INSERT INTO public.who_global_data VALUES (9047, 29, 2015, 1, 104, 39, 140);
INSERT INTO public.who_global_data VALUES (9048, 1923, 602028, 0, 16443, 39, 20);
INSERT INTO public.who_global_data VALUES (9049, 96, 96513, 4, 4782, 39, 112);
INSERT INTO public.who_global_data VALUES (9050, 9594, 1594497, 228, 42171, 39, 111);
INSERT INTO public.who_global_data VALUES (9051, 16, 731, 0, 7, 39, 71);
INSERT INTO public.who_global_data VALUES (9052, 0, 6200, 0, 100, 39, 218);
INSERT INTO public.who_global_data VALUES (9053, 0, 0, 0, 0, 39, 43);
INSERT INTO public.who_global_data VALUES (9054, 597, 165204, 17, 2134, 39, 49);
INSERT INTO public.who_global_data VALUES (9055, 24, 22176, 2, 137, 39, 1);
INSERT INTO public.who_global_data VALUES (9056, 1350, 206596, 56, 3795, 39, 48);
INSERT INTO public.who_global_data VALUES (9057, 229, 11434, 1, 143, 39, 232);
INSERT INTO public.who_global_data VALUES (9058, 93, 4144, 2, 14, 39, 175);
INSERT INTO public.who_global_data VALUES (9059, 751, 20408, 1, 113, 39, 21);
INSERT INTO public.who_global_data VALUES (9060, 10862, 685202, 150, 11302, 39, 156);
INSERT INTO public.who_global_data VALUES (9061, 0, 0, 0, 0, 39, 95);
INSERT INTO public.who_global_data VALUES (9062, 557, 16837, 13, 579, 39, 177);
INSERT INTO public.who_global_data VALUES (9063, 2479, 155826, 30, 1204, 39, 210);
INSERT INTO public.who_global_data VALUES (9064, 0, 5813, 0, 61, 39, 120);
INSERT INTO public.who_global_data VALUES (9065, 0, 96, 0, 0, 39, 135);
INSERT INTO public.who_global_data VALUES (9066, 641, 167405, 0, 2404, 39, 206);
INSERT INTO public.who_global_data VALUES (9067, 403, 209758, 2, 13994, 39, 189);
INSERT INTO public.who_global_data VALUES (9068, 1359, 133900, 61, 7466, 39, 129);
INSERT INTO public.who_global_data VALUES (9069, 796, 45415, 8, 1313, 39, 121);
INSERT INTO public.who_global_data VALUES (9070, 0, 5248, 0, 86, 39, 59);
INSERT INTO public.who_global_data VALUES (9071, 0, 1039, 0, 2, 39, 96);
INSERT INTO public.who_global_data VALUES (9072, 475, 26283, 0, 213, 39, 41);
INSERT INTO public.who_global_data VALUES (9073, 0, 8484, 0, 165, 39, 216);
INSERT INTO public.who_global_data VALUES (9074, 732, 123145, 11, 1912, 39, 236);
INSERT INTO public.who_global_data VALUES (9075, 0, 29, 0, 0, 39, 150);
INSERT INTO public.who_global_data VALUES (9076, 3, 582, 0, 0, 39, 61);
INSERT INTO public.who_global_data VALUES (9077, 0, 46, 0, 2, 39, 7);
INSERT INTO public.who_global_data VALUES (9078, 283, 35420, 4, 550, 39, 169);
INSERT INTO public.who_global_data VALUES (9079, 2757, 2519105, 362, 62732, 39, 28);
INSERT INTO public.who_global_data VALUES (9080, 53, 12832, 0, 71, 39, 85);
INSERT INTO public.who_global_data VALUES (9081, 146, 16696, 5, 113, 39, 211);
INSERT INTO public.who_global_data VALUES (9082, 13, 9510, 0, 64, 39, 60);
INSERT INTO public.who_global_data VALUES (9083, 5, 3797, 0, 123, 39, 3);
INSERT INTO public.who_global_data VALUES (9084, 2012, 224155, 25, 2443, 39, 11);
INSERT INTO public.who_global_data VALUES (9085, 12892, 1664726, 852, 30978, 39, 89);
INSERT INTO public.who_global_data VALUES (9086, 102, 54503, 0, 333, 39, 24);
INSERT INTO public.who_global_data VALUES (9087, 68, 1661, 0, 6, 39, 162);
INSERT INTO public.who_global_data VALUES (9088, 475, 135931, 66, 4672, 39, 100);
INSERT INTO public.who_global_data VALUES (9089, 0, 26, 0, 0, 39, 47);
INSERT INTO public.who_global_data VALUES (9090, 14, 130, 1, 1, 39, 29);
INSERT INTO public.who_global_data VALUES (9091, 0, 8620, 0, 155, 39, 40);
INSERT INTO public.who_global_data VALUES (9092, 7, 7102, 0, 121, 39, 222);
INSERT INTO public.who_global_data VALUES (9093, 132, 135441, 5, 4773, 39, 132);
INSERT INTO public.who_global_data VALUES (9094, 0, 297, 0, 13, 39, 130);
INSERT INTO public.who_global_data VALUES (9095, 14, 13688, 0, 80, 39, 234);
INSERT INTO public.who_global_data VALUES (9096, 0, 2447, 0, 45, 39, 23);
INSERT INTO public.who_global_data VALUES (9097, 5, 6298, 0, 164, 39, 192);
INSERT INTO public.who_global_data VALUES (9098, 0, 9958, 0, 236, 39, 69);
INSERT INTO public.who_global_data VALUES (9099, 0, 26, 0, 0, 39, 187);
INSERT INTO public.who_global_data VALUES (9100, 616, 119713, 1, 3066, 39, 230);
INSERT INTO public.who_global_data VALUES (9101, 902, 317571, 131, 9292, 39, 77);
INSERT INTO public.who_global_data VALUES (9102, 10, 5736, 1, 29, 39, 9);
INSERT INTO public.who_global_data VALUES (9103, 16432, 10224303, 252, 148153, 39, 74);
INSERT INTO public.who_global_data VALUES (9104, 5854, 719219, 215, 21452, 39, 224);
INSERT INTO public.who_global_data VALUES (9105, 5908, 1206373, 121, 54814, 39, 199);
INSERT INTO public.who_global_data VALUES (9106, 931, 592528, 11, 12791, 39, 190);
INSERT INTO public.who_global_data VALUES (9107, 765, 86894, 1, 2205, 39, 12);
INSERT INTO public.who_global_data VALUES (9108, 0, 374, 0, 25, 39, 104);
INSERT INTO public.who_global_data VALUES (9109, 3528, 402787, 20, 3254, 39, 153);
INSERT INTO public.who_global_data VALUES (9110, 8581, 2056277, 445, 72370, 39, 91);
INSERT INTO public.who_global_data VALUES (9111, 9, 12732, 3, 298, 39, 215);
INSERT INTO public.who_global_data VALUES (9112, 2884, 223120, 54, 3306, 39, 84);
INSERT INTO public.who_global_data VALUES (9113, 80, 2663, 0, 41, 39, 231);
INSERT INTO public.who_global_data VALUES (9114, 1802, 289748, 20, 3778, 39, 196);
INSERT INTO public.who_global_data VALUES (9115, 896, 199555, 0, 2749, 39, 105);
INSERT INTO public.who_global_data VALUES (9116, 149, 95992, 9, 1664, 39, 122);
INSERT INTO public.who_global_data VALUES (9117, 0, 0, 0, 0, 39, 159);
INSERT INTO public.who_global_data VALUES (9118, 181, 50758, 8, 1307, 39, 75);
INSERT INTO public.who_global_data VALUES (9119, 204, 149857, 1, 932, 39, 27);
INSERT INTO public.who_global_data VALUES (9120, 119, 80654, 4, 1353, 39, 54);
INSERT INTO public.who_global_data VALUES (9121, 0, 41, 0, 0, 39, 226);
INSERT INTO public.who_global_data VALUES (9122, 508, 36838, 19, 578, 39, 79);
INSERT INTO public.who_global_data VALUES (9123, 1594, 172820, 15, 1409, 39, 56);
INSERT INTO public.who_global_data VALUES (9124, 0, 2577, 0, 50, 39, 117);
INSERT INTO public.who_global_data VALUES (9125, 0, 1800, 0, 83, 39, 152);
INSERT INTO public.who_global_data VALUES (9126, 532, 98913, 4, 1440, 39, 16);
INSERT INTO public.who_global_data VALUES (9127, 38, 2153, 1, 35, 39, 10);
INSERT INTO public.who_global_data VALUES (9128, 1923, 134287, 43, 1697, 39, 201);
INSERT INTO public.who_global_data VALUES (9129, 16, 45846, 9, 487, 39, 174);
INSERT INTO public.who_global_data VALUES (9130, 0, 17714, 0, 261, 39, 119);
INSERT INTO public.who_global_data VALUES (9131, 0, 6354, 0, 188, 39, 168);
INSERT INTO public.who_global_data VALUES (9132, 1594, 106690, 3, 455, 39, 99);
INSERT INTO public.who_global_data VALUES (9133, 16, 13660, 0, 48, 39, 171);
INSERT INTO public.who_global_data VALUES (9134, 74, 6703, 3, 256, 39, 87);
INSERT INTO public.who_global_data VALUES (9135, 101, 12426, 5, 215, 39, 123);
INSERT INTO public.who_global_data VALUES (9136, 0, 4, 0, 0, 39, 151);
INSERT INTO public.who_global_data VALUES (9137, 0, 6072, 0, 42, 39, 213);
INSERT INTO public.who_global_data VALUES (9138, 2671, 13642, 99, 324, 39, 118);
INSERT INTO public.who_global_data VALUES (9139, 0, 524, 0, 10, 39, 134);
INSERT INTO public.who_global_data VALUES (9140, 123, 5890, 1, 55, 39, 65);
INSERT INTO public.who_global_data VALUES (9141, 6217, 1383434, 400, 122426, 39, 102);
INSERT INTO public.who_global_data VALUES (9142, 0, 0, 0, 0, 39, 223);
INSERT INTO public.who_global_data VALUES (9143, 4, 806, 0, 3, 39, 4);
INSERT INTO public.who_global_data VALUES (9144, 16, 1137, 0, 0, 39, 146);
INSERT INTO public.who_global_data VALUES (9145, 352, 47669, 2, 677, 39, 31);
INSERT INTO public.who_global_data VALUES (9146, 0, 13, 0, 1, 39, 127);
INSERT INTO public.who_global_data VALUES (9147, 950, 433029, 32, 7272, 39, 22);
INSERT INTO public.who_global_data VALUES (9148, 0, 18265, 0, 161, 39, 115);
INSERT INTO public.who_global_data VALUES (9149, 648, 122534, 17, 2618, 39, 106);
INSERT INTO public.who_global_data VALUES (9150, 0, 21923, 0, 191, 39, 90);
INSERT INTO public.who_global_data VALUES (9151, 0, 0, 0, 0, 39, 70);
INSERT INTO public.who_global_data VALUES (9152, 659, 258840, 7, 1832, 39, 46);
INSERT INTO public.who_global_data VALUES (9153, 7408, 769239, 44, 11014, 39, 139);
INSERT INTO public.who_global_data VALUES (9154, 0, 38, 0, 0, 39, 42);
INSERT INTO public.who_global_data VALUES (9155, 7, 1795, 0, 25, 39, 80);
INSERT INTO public.who_global_data VALUES (9156, 0, 4790, 0, 164, 39, 203);
INSERT INTO public.who_global_data VALUES (9157, 0, 3005, 0, 91, 39, 136);
INSERT INTO public.who_global_data VALUES (9158, 397, 84811, 10, 1264, 39, 63);
INSERT INTO public.who_global_data VALUES (9159, 0, 0, 0, 0, 39, 17);
INSERT INTO public.who_global_data VALUES (9160, 0, 122, 0, 2, 39, 172);
INSERT INTO public.who_global_data VALUES (9161, 83, 81804, 11, 2456, 39, 109);
INSERT INTO public.who_global_data VALUES (9162, 2125, 47057, 8, 429, 39, 200);
INSERT INTO public.who_global_data VALUES (9163, 1363, 151409, 26, 1460, 39, 93);
INSERT INTO public.who_global_data VALUES (9164, 91, 128563, 0, 1495, 39, 5);
INSERT INTO public.who_global_data VALUES (9165, 0, 745, 0, 13, 39, 214);
INSERT INTO public.who_global_data VALUES (9166, 1974, 473309, 55, 9929, 39, 204);
INSERT INTO public.who_global_data VALUES (9167, 0, 0, 0, 0, 39, 198);
INSERT INTO public.who_global_data VALUES (9168, 2633, 231357, 41, 3840, 39, 173);
INSERT INTO public.who_global_data VALUES (9169, 0, 780, 0, 9, 39, 229);
INSERT INTO public.who_global_data VALUES (9170, 260, 104422, 14, 2188, 39, 76);
INSERT INTO public.who_global_data VALUES (9171, 1339, 1007657, 60, 37474, 39, 138);
INSERT INTO public.who_global_data VALUES (9172, 764, 470650, 15, 9124, 39, 98);
INSERT INTO public.who_global_data VALUES (9173, 0, 0, 0, 0, 39, 103);
INSERT INTO public.who_global_data VALUES (9174, 7624, 1268634, 307, 27454, 39, 225);
INSERT INTO public.who_global_data VALUES (9175, 2093, 396666, 58, 6677, 39, 131);
INSERT INTO public.who_global_data VALUES (9176, 431, 73658, 11, 1456, 39, 235);
INSERT INTO public.who_global_data VALUES (9177, 160, 143222, 0, 244, 39, 137);
INSERT INTO public.who_global_data VALUES (9178, 1044, 58709, 40, 859, 39, 81);
INSERT INTO public.who_global_data VALUES (9179, 569, 141924, 18, 2909, 39, 182);
INSERT INTO public.who_global_data VALUES (9180, 27, 8936, 0, 42, 39, 145);
INSERT INTO public.who_global_data VALUES (9181, 2620, 618429, 104, 15334, 39, 26);
INSERT INTO public.who_global_data VALUES (9182, 27002, 3105037, 562, 55827, 39, 170);
INSERT INTO public.who_global_data VALUES (9183, 51, 8021, 1, 75, 39, 191);
INSERT INTO public.who_global_data VALUES (9184, 0, 5, 0, 0, 39, 221);
INSERT INTO public.who_global_data VALUES (9185, 0, 189, 0, 0, 39, 64);
INSERT INTO public.who_global_data VALUES (9186, 0, 0, 0, 0, 39, 116);
INSERT INTO public.who_global_data VALUES (9187, 2, 32, 0, 0, 39, 128);
INSERT INTO public.who_global_data VALUES (9188, 26, 331, 0, 5, 39, 6);
INSERT INTO public.who_global_data VALUES (9189, 0, 986, 0, 12, 39, 227);
INSERT INTO public.who_global_data VALUES (9190, 0, 16, 0, 0, 39, 68);
INSERT INTO public.who_global_data VALUES (9191, 0, 109, 0, 0, 39, 184);
INSERT INTO public.who_global_data VALUES (9192, 0, 2, 0, 0, 39, 82);
INSERT INTO public.who_global_data VALUES (9193, 0, 2276, 0, 57, 39, 149);
INSERT INTO public.who_global_data VALUES (9194, 0, 1014, 0, 17, 39, 197);
INSERT INTO public.who_global_data VALUES (9195, 119, 362339, 11, 6196, 39, 78);
INSERT INTO public.who_global_data VALUES (9196, 119, 18728, 2, 390, 39, 233);
INSERT INTO public.who_global_data VALUES (9197, 2559, 328619, 43, 3073, 39, 133);
INSERT INTO public.who_global_data VALUES (9198, 0, 211, 0, 0, 39, 35);
INSERT INTO public.who_global_data VALUES (9199, 11, 2560, 0, 76, 39, 114);
INSERT INTO public.who_global_data VALUES (9200, 5, 58529, 0, 29, 39, 237);
INSERT INTO public.who_global_data VALUES (9201, 0, 19, 0, 0, 39, 55);
INSERT INTO public.who_global_data VALUES (9202, 41, 1411, 0, 26, 39, 176);
INSERT INTO public.who_global_data VALUES (9203, 2095, 170187, 104, 1983, 39, 202);
INSERT INTO public.who_global_data VALUES (9204, 1990, 117400, 44, 2919, 39, 155);
INSERT INTO public.who_global_data VALUES (9205, 0, 17, 0, 0, 39, 32);
INSERT INTO public.who_global_data VALUES (9206, 0, 4690, 0, 127, 39, 220);
INSERT INTO public.who_global_data VALUES (9207, 7458, 1011871, 336, 27071, 39, 30);
INSERT INTO public.who_global_data VALUES (9208, 183, 3491, 0, 62, 39, 147);
INSERT INTO public.who_global_data VALUES (9209, 6135, 1951026, 148, 51347, 39, 208);
INSERT INTO public.who_global_data VALUES (9210, 549, 41603, 3, 194, 39, 45);
INSERT INTO public.who_global_data VALUES (9211, 172, 25060, 4, 1540, 39, 110);
INSERT INTO public.who_global_data VALUES (9212, 40, 5978, 0, 119, 39, 88);
INSERT INTO public.who_global_data VALUES (9213, 3209, 421346, 98, 9457, 39, 51);
INSERT INTO public.who_global_data VALUES (9214, 5032, 442451, 70, 7087, 39, 209);
INSERT INTO public.who_global_data VALUES (9215, 105, 11138, 8, 686, 39, 205);
INSERT INTO public.who_global_data VALUES (9216, 34, 13625, 0, 90, 39, 18);
INSERT INTO public.who_global_data VALUES (9217, 299, 6440, 1, 61, 39, 72);
INSERT INTO public.who_global_data VALUES (9218, 41385, 2329734, 357, 71109, 39, 44);
INSERT INTO public.who_global_data VALUES (9219, 0, 41, 0, 0, 39, 15);
INSERT INTO public.who_global_data VALUES (9220, 21, 3576, 0, 68, 39, 25);
INSERT INTO public.who_global_data VALUES (9221, 0, 0, 0, 0, 39, 179);
INSERT INTO public.who_global_data VALUES (9222, 0, 0, 0, 0, 39, 34);
INSERT INTO public.who_global_data VALUES (9223, 11, 7115, 0, 125, 39, 207);
INSERT INTO public.who_global_data VALUES (9224, 1612, 133204, 52, 4518, 39, 166);
INSERT INTO public.who_global_data VALUES (9225, 15197, 2162775, 257, 20135, 39, 126);
INSERT INTO public.who_global_data VALUES (9226, 0, 0, 0, 0, 39, 97);
INSERT INTO public.who_global_data VALUES (9227, 5, 849, 0, 6, 39, 36);
INSERT INTO public.who_global_data VALUES (9228, 0, 0, 0, 0, 39, 125);
INSERT INTO public.who_global_data VALUES (9229, 0, 33811, 0, 248, 39, 124);
INSERT INTO public.who_global_data VALUES (9230, 6988, 1037362, 232, 18081, 39, 185);
INSERT INTO public.who_global_data VALUES (9231, 1027, 202863, 3, 660, 39, 194);
INSERT INTO public.who_global_data VALUES (9232, 0, 509, 0, 21, 39, 144);
INSERT INTO public.who_global_data VALUES (9233, 145513, 18972813, 1334, 330644, 39, 19);
INSERT INTO public.who_global_data VALUES (9234, 0, 1988, 0, 23, 39, 217);
INSERT INTO public.who_global_data VALUES (9235, 510, 16728, 11, 158, 39, 148);
INSERT INTO public.who_global_data VALUES (9236, 75, 76907, 0, 613, 39, 86);
INSERT INTO public.who_global_data VALUES (9237, 0, 1, 0, 0, 39, 13);
INSERT INTO public.who_global_data VALUES (9238, 365, 112316, 1, 1014, 39, 157);
INSERT INTO public.who_global_data VALUES (9239, 10, 1451, 0, 35, 39, 8);
INSERT INTO public.who_global_data VALUES (9240, 0, 4, 0, 0, 39, 73);
INSERT INTO public.who_global_data VALUES (9241, 2, 2100, 1, 609, 39, 101);
INSERT INTO public.who_global_data VALUES (9242, 272, 19943, 2, 384, 39, 165);
INSERT INTO public.who_global_data VALUES (9243, 185, 13148, 13, 354, 39, 14);
INSERT INTO public.who_global_data VALUES (9244, 159, 52007, 12, 2170, 40, 193);
INSERT INTO public.who_global_data VALUES (9245, 499, 56254, 10, 1153, 40, 113);
INSERT INTO public.who_global_data VALUES (9246, 392, 98249, 6, 2728, 40, 143);
INSERT INTO public.who_global_data VALUES (9247, 0, 0, 0, 0, 40, 219);
INSERT INTO public.who_global_data VALUES (9248, 15, 7821, 0, 83, 40, 186);
INSERT INTO public.who_global_data VALUES (9249, 91, 17240, 0, 399, 40, 52);
INSERT INTO public.who_global_data VALUES (9250, 0, 12, 0, 0, 40, 180);
INSERT INTO public.who_global_data VALUES (9251, 0, 155, 0, 5, 40, 167);
INSERT INTO public.who_global_data VALUES (9252, 3713, 1578267, 79, 42501, 40, 154);
INSERT INTO public.who_global_data VALUES (9253, 114, 157261, 7, 2770, 40, 94);
INSERT INTO public.who_global_data VALUES (9254, 0, 5228, 0, 47, 40, 66);
INSERT INTO public.who_global_data VALUES (9255, 16, 28312, 0, 908, 40, 58);
INSERT INTO public.who_global_data VALUES (9256, 1376, 349735, 42, 5794, 40, 163);
INSERT INTO public.who_global_data VALUES (9257, 1519, 214711, 45, 2499, 40, 37);
INSERT INTO public.who_global_data VALUES (9258, 0, 7788, 0, 169, 40, 142);
INSERT INTO public.who_global_data VALUES (9259, 215, 91733, 0, 351, 40, 83);
INSERT INTO public.who_global_data VALUES (9260, 1049, 509148, 24, 7452, 40, 228);
INSERT INTO public.who_global_data VALUES (9261, 9, 356, 0, 7, 40, 188);
INSERT INTO public.who_global_data VALUES (9262, 1825, 186747, 9, 1385, 40, 62);
INSERT INTO public.who_global_data VALUES (9263, 558, 640324, 61, 19292, 40, 160);
INSERT INTO public.who_global_data VALUES (9264, 0, 10490, 0, 228, 40, 50);
INSERT INTO public.who_global_data VALUES (9265, 0, 3205, 0, 44, 40, 33);
INSERT INTO public.who_global_data VALUES (9266, 20, 581, 1, 10, 40, 183);
INSERT INTO public.who_global_data VALUES (9267, 26, 623, 0, 0, 40, 92);
INSERT INTO public.who_global_data VALUES (9268, 759, 154349, 10, 9093, 40, 158);
INSERT INTO public.who_global_data VALUES (9269, 0, 158, 0, 3, 40, 67);
INSERT INTO public.who_global_data VALUES (9270, 361, 109691, 30, 3953, 40, 57);
INSERT INTO public.who_global_data VALUES (9271, 0, 13622, 0, 38, 40, 38);
INSERT INTO public.who_global_data VALUES (9272, 17246, 7465806, 307, 190795, 40, 141);
INSERT INTO public.who_global_data VALUES (9273, 0, 93, 0, 1, 40, 178);
INSERT INTO public.who_global_data VALUES (9274, 0, 152, 0, 3, 40, 108);
INSERT INTO public.who_global_data VALUES (9275, 332, 197716, 41, 7164, 40, 39);
INSERT INTO public.who_global_data VALUES (9276, 89, 6344, 1, 78, 40, 2);
INSERT INTO public.who_global_data VALUES (9277, 0, 804, 0, 2, 40, 195);
INSERT INTO public.who_global_data VALUES (9278, 16, 11714, 0, 112, 40, 107);
INSERT INTO public.who_global_data VALUES (9279, 0, 364, 0, 0, 40, 161);
INSERT INTO public.who_global_data VALUES (9280, 0, 26277, 0, 448, 40, 212);
INSERT INTO public.who_global_data VALUES (9281, 9827, 546500, 179, 14899, 40, 181);
INSERT INTO public.who_global_data VALUES (9282, 0, 318, 0, 2, 40, 53);
INSERT INTO public.who_global_data VALUES (9283, 0, 4948, 0, 63, 40, 164);
INSERT INTO public.who_global_data VALUES (9284, 0, 1986, 0, 103, 40, 140);
INSERT INTO public.who_global_data VALUES (9285, 1711, 600105, 39, 16443, 40, 20);
INSERT INTO public.who_global_data VALUES (9286, 93, 96417, 1, 4778, 40, 112);
INSERT INTO public.who_global_data VALUES (9287, 10196, 1584903, 253, 41943, 40, 111);
INSERT INTO public.who_global_data VALUES (9288, 0, 715, 0, 7, 40, 71);
INSERT INTO public.who_global_data VALUES (9289, 0, 6200, 0, 100, 40, 218);
INSERT INTO public.who_global_data VALUES (9290, 0, 0, 0, 0, 40, 43);
INSERT INTO public.who_global_data VALUES (9291, 545, 164607, 14, 2117, 40, 49);
INSERT INTO public.who_global_data VALUES (9292, 71, 22152, 2, 135, 40, 1);
INSERT INTO public.who_global_data VALUES (9293, 316, 205246, 68, 3739, 40, 48);
INSERT INTO public.who_global_data VALUES (9294, 167, 11205, 1, 142, 40, 232);
INSERT INTO public.who_global_data VALUES (9295, 0, 4051, 0, 12, 40, 175);
INSERT INTO public.who_global_data VALUES (9296, 266, 19657, 1, 112, 40, 21);
INSERT INTO public.who_global_data VALUES (9297, 3741, 674340, 108, 11152, 40, 156);
INSERT INTO public.who_global_data VALUES (9298, 0, 0, 0, 0, 40, 95);
INSERT INTO public.who_global_data VALUES (9299, 0, 16280, 0, 566, 40, 177);
INSERT INTO public.who_global_data VALUES (9300, 2180, 153347, 21, 1174, 40, 210);
INSERT INTO public.who_global_data VALUES (9301, 8, 5813, 0, 61, 40, 120);
INSERT INTO public.who_global_data VALUES (9302, 0, 96, 0, 0, 40, 135);
INSERT INTO public.who_global_data VALUES (9303, 824, 166764, 0, 2404, 40, 206);
INSERT INTO public.who_global_data VALUES (9304, 81, 209355, 2, 13992, 40, 189);
INSERT INTO public.who_global_data VALUES (9305, 1226, 132541, 53, 7405, 40, 129);
INSERT INTO public.who_global_data VALUES (9306, 0, 44619, 8, 1305, 40, 121);
INSERT INTO public.who_global_data VALUES (9307, 12, 5248, 1, 86, 40, 59);
INSERT INTO public.who_global_data VALUES (9308, 47, 1039, 1, 2, 40, 96);
INSERT INTO public.who_global_data VALUES (9309, 416, 25808, 9, 213, 40, 41);
INSERT INTO public.who_global_data VALUES (9310, 117, 8484, 2, 165, 40, 216);
INSERT INTO public.who_global_data VALUES (9311, 0, 122413, 0, 1901, 40, 236);
INSERT INTO public.who_global_data VALUES (9312, 0, 29, 0, 0, 40, 150);
INSERT INTO public.who_global_data VALUES (9313, 8, 579, 0, 0, 40, 61);
INSERT INTO public.who_global_data VALUES (9314, 0, 46, 0, 2, 40, 7);
INSERT INTO public.who_global_data VALUES (9315, 1053, 35137, 22, 546, 40, 169);
INSERT INTO public.who_global_data VALUES (9316, 8816, 2516348, 173, 62370, 40, 28);
INSERT INTO public.who_global_data VALUES (9317, 6, 12779, 0, 71, 40, 85);
INSERT INTO public.who_global_data VALUES (9318, 0, 16550, 0, 108, 40, 211);
INSERT INTO public.who_global_data VALUES (9319, 0, 9497, 0, 64, 40, 60);
INSERT INTO public.who_global_data VALUES (9320, 0, 3792, 0, 123, 40, 3);
INSERT INTO public.who_global_data VALUES (9321, 538, 222143, 41, 2418, 40, 11);
INSERT INTO public.who_global_data VALUES (9322, 10976, 1651834, 348, 30126, 40, 89);
INSERT INTO public.who_global_data VALUES (9323, 115, 54401, 0, 333, 40, 24);
INSERT INTO public.who_global_data VALUES (9324, 59, 1593, 0, 6, 40, 162);
INSERT INTO public.who_global_data VALUES (9325, 342, 135456, 53, 4606, 40, 100);
INSERT INTO public.who_global_data VALUES (9326, 0, 26, 0, 0, 40, 47);
INSERT INTO public.who_global_data VALUES (9327, 0, 116, 0, 0, 40, 29);
INSERT INTO public.who_global_data VALUES (9328, 0, 8620, 0, 155, 40, 40);
INSERT INTO public.who_global_data VALUES (9329, 1, 7095, 0, 121, 40, 222);
INSERT INTO public.who_global_data VALUES (9330, 138, 135309, 5, 4768, 40, 132);
INSERT INTO public.who_global_data VALUES (9331, 0, 297, 0, 13, 40, 130);
INSERT INTO public.who_global_data VALUES (9332, 28, 13674, 0, 80, 40, 234);
INSERT INTO public.who_global_data VALUES (9333, 0, 2447, 0, 45, 40, 23);
INSERT INTO public.who_global_data VALUES (9334, 4, 6293, 2, 164, 40, 192);
INSERT INTO public.who_global_data VALUES (9335, 112, 9958, 1, 236, 40, 69);
INSERT INTO public.who_global_data VALUES (9336, 0, 26, 0, 0, 40, 187);
INSERT INTO public.who_global_data VALUES (9337, 438, 119097, 4, 3065, 40, 230);
INSERT INTO public.who_global_data VALUES (9338, 609, 316669, 114, 9161, 40, 77);
INSERT INTO public.who_global_data VALUES (9339, 43, 5726, 0, 28, 40, 9);
INSERT INTO public.who_global_data VALUES (9340, 20021, 10207871, 279, 147901, 40, 74);
INSERT INTO public.who_global_data VALUES (9341, 6528, 713365, 243, 21237, 40, 224);
INSERT INTO public.who_global_data VALUES (9342, 5502, 1200465, 119, 54693, 40, 199);
INSERT INTO public.who_global_data VALUES (9343, 818, 591597, 13, 12780, 40, 190);
INSERT INTO public.who_global_data VALUES (9344, 735, 86129, 4, 2204, 40, 12);
INSERT INTO public.who_global_data VALUES (9345, 0, 374, 0, 25, 40, 104);
INSERT INTO public.who_global_data VALUES (9346, 2659, 399259, 23, 3234, 40, 153);
INSERT INTO public.who_global_data VALUES (9347, 8937, 2047696, 305, 71925, 40, 91);
INSERT INTO public.who_global_data VALUES (9348, 39, 12723, 1, 295, 40, 215);
INSERT INTO public.who_global_data VALUES (9349, 2924, 220236, 39, 3252, 40, 84);
INSERT INTO public.who_global_data VALUES (9350, 0, 2583, 0, 41, 40, 231);
INSERT INTO public.who_global_data VALUES (9351, 1590, 287946, 29, 3758, 40, 196);
INSERT INTO public.who_global_data VALUES (9352, 757, 198659, 0, 2749, 40, 105);
INSERT INTO public.who_global_data VALUES (9353, 0, 95843, 0, 1655, 40, 122);
INSERT INTO public.who_global_data VALUES (9354, 0, 0, 0, 0, 40, 159);
INSERT INTO public.who_global_data VALUES (9355, 215, 50577, 4, 1299, 40, 75);
INSERT INTO public.who_global_data VALUES (9356, 204, 149653, 2, 931, 40, 27);
INSERT INTO public.who_global_data VALUES (9357, 162, 80535, 1, 1349, 40, 54);
INSERT INTO public.who_global_data VALUES (9358, 0, 41, 0, 0, 40, 226);
INSERT INTO public.who_global_data VALUES (9359, 511, 36330, 44, 559, 40, 79);
INSERT INTO public.who_global_data VALUES (9360, 1754, 171226, 15, 1394, 40, 56);
INSERT INTO public.who_global_data VALUES (9361, 0, 2577, 0, 50, 40, 117);
INSERT INTO public.who_global_data VALUES (9362, 0, 1800, 0, 83, 40, 152);
INSERT INTO public.who_global_data VALUES (9363, 728, 98381, 21, 1436, 40, 16);
INSERT INTO public.who_global_data VALUES (9364, 29, 2115, 1, 34, 40, 10);
INSERT INTO public.who_global_data VALUES (9365, 1767, 132364, 39, 1654, 40, 201);
INSERT INTO public.who_global_data VALUES (9366, 54, 45830, 8, 478, 40, 174);
INSERT INTO public.who_global_data VALUES (9367, 81, 17714, 1, 261, 40, 119);
INSERT INTO public.who_global_data VALUES (9368, 11, 6354, 0, 188, 40, 168);
INSERT INTO public.who_global_data VALUES (9369, 1196, 105096, 1, 452, 40, 99);
INSERT INTO public.who_global_data VALUES (9370, 26, 13644, 0, 48, 40, 171);
INSERT INTO public.who_global_data VALUES (9371, 55, 6629, 4, 253, 40, 87);
INSERT INTO public.who_global_data VALUES (9372, 84, 12325, 4, 210, 40, 123);
INSERT INTO public.who_global_data VALUES (9373, 0, 4, 0, 0, 40, 151);
INSERT INTO public.who_global_data VALUES (9374, 0, 6072, 0, 42, 40, 213);
INSERT INTO public.who_global_data VALUES (9375, 0, 10971, 0, 225, 40, 118);
INSERT INTO public.who_global_data VALUES (9376, 0, 524, 0, 10, 40, 134);
INSERT INTO public.who_global_data VALUES (9377, 0, 5767, 0, 54, 40, 65);
INSERT INTO public.who_global_data VALUES (9378, 4974, 1377217, 189, 122026, 40, 102);
INSERT INTO public.who_global_data VALUES (9379, 0, 0, 0, 0, 40, 223);
INSERT INTO public.who_global_data VALUES (9380, 2, 802, 0, 3, 40, 4);
INSERT INTO public.who_global_data VALUES (9381, 39, 1121, 0, 0, 40, 146);
INSERT INTO public.who_global_data VALUES (9382, 388, 47317, 9, 675, 40, 31);
INSERT INTO public.who_global_data VALUES (9383, 0, 13, 0, 1, 40, 127);
INSERT INTO public.who_global_data VALUES (9384, 1517, 432079, 36, 7240, 40, 22);
INSERT INTO public.who_global_data VALUES (9385, 103, 18265, 2, 161, 40, 115);
INSERT INTO public.who_global_data VALUES (9386, 606, 121886, 22, 2601, 40, 106);
INSERT INTO public.who_global_data VALUES (9387, 525, 21923, 4, 191, 40, 90);
INSERT INTO public.who_global_data VALUES (9388, 0, 0, 0, 0, 40, 70);
INSERT INTO public.who_global_data VALUES (9389, 481, 258181, 6, 1825, 40, 46);
INSERT INTO public.who_global_data VALUES (9390, 9020, 761831, 28, 10970, 40, 139);
INSERT INTO public.who_global_data VALUES (9391, 0, 38, 0, 0, 40, 42);
INSERT INTO public.who_global_data VALUES (9392, 0, 1788, 0, 25, 40, 80);
INSERT INTO public.who_global_data VALUES (9393, 0, 4790, 0, 164, 40, 203);
INSERT INTO public.who_global_data VALUES (9394, 202, 3005, 2, 91, 40, 136);
INSERT INTO public.who_global_data VALUES (9395, 838, 84414, 7, 1254, 40, 63);
INSERT INTO public.who_global_data VALUES (9396, 0, 0, 0, 0, 40, 17);
INSERT INTO public.who_global_data VALUES (9397, 0, 122, 0, 2, 40, 172);
INSERT INTO public.who_global_data VALUES (9398, 296, 81721, 18, 2445, 40, 109);
INSERT INTO public.who_global_data VALUES (9399, 0, 44932, 0, 421, 40, 200);
INSERT INTO public.who_global_data VALUES (9400, 1506, 150046, 28, 1434, 40, 93);
INSERT INTO public.who_global_data VALUES (9401, 182, 128472, 4, 1495, 40, 5);
INSERT INTO public.who_global_data VALUES (9402, 0, 745, 0, 13, 40, 214);
INSERT INTO public.who_global_data VALUES (9403, 1853, 471335, 58, 9874, 40, 204);
INSERT INTO public.who_global_data VALUES (9404, 0, 0, 0, 0, 40, 198);
INSERT INTO public.who_global_data VALUES (9405, 2064, 228724, 43, 3799, 40, 173);
INSERT INTO public.who_global_data VALUES (9406, 0, 780, 0, 9, 40, 229);
INSERT INTO public.who_global_data VALUES (9407, 274, 104162, 20, 2174, 40, 76);
INSERT INTO public.who_global_data VALUES (9408, 772, 1006318, 46, 37414, 40, 138);
INSERT INTO public.who_global_data VALUES (9409, 881, 469886, 42, 9109, 40, 98);
INSERT INTO public.who_global_data VALUES (9410, 0, 0, 0, 0, 40, 103);
INSERT INTO public.who_global_data VALUES (9411, 3211, 1261010, 29, 27147, 40, 225);
INSERT INTO public.who_global_data VALUES (9412, 1577, 394573, 63, 6619, 40, 131);
INSERT INTO public.who_global_data VALUES (9413, 784, 73227, 13, 1445, 40, 235);
INSERT INTO public.who_global_data VALUES (9414, 159, 143062, 0, 244, 40, 137);
INSERT INTO public.who_global_data VALUES (9415, 807, 57665, 11, 819, 40, 81);
INSERT INTO public.who_global_data VALUES (9416, 359, 141355, 8, 2891, 40, 182);
INSERT INTO public.who_global_data VALUES (9417, 0, 8909, 0, 42, 40, 145);
INSERT INTO public.who_global_data VALUES (9418, 2049, 615809, 122, 15230, 40, 26);
INSERT INTO public.who_global_data VALUES (9419, 27787, 3078035, 487, 55265, 40, 170);
INSERT INTO public.who_global_data VALUES (9420, 153, 7970, 2, 74, 40, 191);
INSERT INTO public.who_global_data VALUES (9421, 0, 5, 0, 0, 40, 221);
INSERT INTO public.who_global_data VALUES (9422, 0, 189, 0, 0, 40, 64);
INSERT INTO public.who_global_data VALUES (9423, 0, 0, 0, 0, 40, 116);
INSERT INTO public.who_global_data VALUES (9424, 0, 30, 0, 0, 40, 128);
INSERT INTO public.who_global_data VALUES (9425, 0, 305, 0, 5, 40, 6);
INSERT INTO public.who_global_data VALUES (9426, 0, 986, 0, 12, 40, 227);
INSERT INTO public.who_global_data VALUES (9427, 0, 16, 0, 0, 40, 68);
INSERT INTO public.who_global_data VALUES (9428, 1, 109, 0, 0, 40, 184);
INSERT INTO public.who_global_data VALUES (9429, 0, 2, 0, 0, 40, 82);
INSERT INTO public.who_global_data VALUES (9430, 12, 2276, 0, 57, 40, 149);
INSERT INTO public.who_global_data VALUES (9431, 0, 1014, 0, 17, 40, 197);
INSERT INTO public.who_global_data VALUES (9432, 154, 362220, 9, 6185, 40, 78);
INSERT INTO public.who_global_data VALUES (9433, 86, 18609, 1, 388, 40, 233);
INSERT INTO public.who_global_data VALUES (9434, 2693, 326060, 47, 3030, 40, 133);
INSERT INTO public.who_global_data VALUES (9435, 0, 211, 0, 0, 40, 35);
INSERT INTO public.who_global_data VALUES (9436, 0, 2549, 0, 76, 40, 114);
INSERT INTO public.who_global_data VALUES (9437, 5, 58524, 0, 29, 40, 237);
INSERT INTO public.who_global_data VALUES (9438, 0, 19, 0, 0, 40, 55);
INSERT INTO public.who_global_data VALUES (9439, 0, 1370, 0, 26, 40, 176);
INSERT INTO public.who_global_data VALUES (9440, 569, 168092, 106, 1879, 40, 202);
INSERT INTO public.who_global_data VALUES (9441, 533, 115410, 48, 2875, 40, 155);
INSERT INTO public.who_global_data VALUES (9442, 0, 17, 0, 0, 40, 32);
INSERT INTO public.who_global_data VALUES (9443, 0, 4690, 0, 127, 40, 220);
INSERT INTO public.who_global_data VALUES (9444, 9502, 1004413, 214, 26735, 40, 30);
INSERT INTO public.who_global_data VALUES (9445, 0, 3308, 0, 62, 40, 147);
INSERT INTO public.who_global_data VALUES (9446, 6467, 1944891, 145, 51199, 40, 208);
INSERT INTO public.who_global_data VALUES (9447, 674, 41054, 4, 191, 40, 45);
INSERT INTO public.who_global_data VALUES (9448, 194, 24888, 16, 1536, 40, 110);
INSERT INTO public.who_global_data VALUES (9449, 58, 5938, 0, 119, 40, 88);
INSERT INTO public.who_global_data VALUES (9450, 2966, 418137, 94, 9359, 40, 51);
INSERT INTO public.who_global_data VALUES (9451, 2115, 437419, 88, 7017, 40, 209);
INSERT INTO public.who_global_data VALUES (9452, 101, 11033, 9, 678, 40, 205);
INSERT INTO public.who_global_data VALUES (9453, 36, 13591, 0, 90, 40, 18);
INSERT INTO public.who_global_data VALUES (9454, 121, 6141, 0, 60, 40, 72);
INSERT INTO public.who_global_data VALUES (9455, 32340, 2288349, 347, 70752, 40, 44);
INSERT INTO public.who_global_data VALUES (9456, 0, 41, 0, 0, 40, 15);
INSERT INTO public.who_global_data VALUES (9457, 0, 3555, 0, 68, 40, 25);
INSERT INTO public.who_global_data VALUES (9458, 0, 0, 0, 0, 40, 179);
INSERT INTO public.who_global_data VALUES (9459, 0, 0, 0, 0, 40, 34);
INSERT INTO public.who_global_data VALUES (9460, 7, 7104, 0, 125, 40, 207);
INSERT INTO public.who_global_data VALUES (9461, 1362, 131592, 40, 4466, 40, 166);
INSERT INTO public.who_global_data VALUES (9462, 14205, 2147578, 254, 19878, 40, 126);
INSERT INTO public.who_global_data VALUES (9463, 0, 0, 0, 0, 40, 97);
INSERT INTO public.who_global_data VALUES (9464, 0, 844, 0, 6, 40, 36);
INSERT INTO public.who_global_data VALUES (9465, 0, 0, 0, 0, 40, 125);
INSERT INTO public.who_global_data VALUES (9466, 248, 33811, 3, 248, 40, 124);
INSERT INTO public.who_global_data VALUES (9467, 4385, 1030374, 75, 17849, 40, 185);
INSERT INTO public.who_global_data VALUES (9468, 944, 201836, 2, 657, 40, 194);
INSERT INTO public.who_global_data VALUES (9469, 0, 509, 0, 21, 40, 144);
INSERT INTO public.who_global_data VALUES (9470, 178311, 18827300, 1296, 329310, 40, 19);
INSERT INTO public.who_global_data VALUES (9471, 9, 1988, 0, 23, 40, 217);
INSERT INTO public.who_global_data VALUES (9472, 370, 16218, 4, 147, 40, 148);
INSERT INTO public.who_global_data VALUES (9473, 81, 76832, 0, 613, 40, 86);
INSERT INTO public.who_global_data VALUES (9474, 0, 1, 0, 0, 40, 13);
INSERT INTO public.who_global_data VALUES (9475, 348, 111951, 3, 1013, 40, 157);
INSERT INTO public.who_global_data VALUES (9476, 1, 1441, 0, 35, 40, 8);
INSERT INTO public.who_global_data VALUES (9477, 0, 4, 0, 0, 40, 73);
INSERT INTO public.who_global_data VALUES (9478, 2, 2098, 1, 608, 40, 101);
INSERT INTO public.who_global_data VALUES (9479, 0, 19671, 0, 382, 40, 165);
INSERT INTO public.who_global_data VALUES (9480, 0, 12963, 0, 341, 40, 14);
INSERT INTO public.who_global_data VALUES (9481, 84, 51848, 10, 2158, 41, 193);
INSERT INTO public.who_global_data VALUES (9482, 375, 55755, 9, 1143, 41, 113);
INSERT INTO public.who_global_data VALUES (9483, 416, 97857, 6, 2722, 41, 143);
INSERT INTO public.who_global_data VALUES (9484, 0, 0, 0, 0, 41, 219);
INSERT INTO public.who_global_data VALUES (9485, 50, 7806, 0, 83, 41, 186);
INSERT INTO public.who_global_data VALUES (9486, 50, 17149, 3, 399, 41, 52);
INSERT INTO public.who_global_data VALUES (9487, 1, 12, 0, 0, 41, 180);
INSERT INTO public.who_global_data VALUES (9488, 1, 155, 0, 5, 41, 167);
INSERT INTO public.who_global_data VALUES (9489, 2874, 1574554, 30, 42422, 41, 154);
INSERT INTO public.who_global_data VALUES (9490, 485, 157147, 16, 2763, 41, 94);
INSERT INTO public.who_global_data VALUES (9491, 0, 5228, 0, 47, 41, 66);
INSERT INTO public.who_global_data VALUES (9492, 34, 28296, 0, 908, 41, 58);
INSERT INTO public.who_global_data VALUES (9493, 1258, 348359, 42, 5752, 41, 163);
INSERT INTO public.who_global_data VALUES (9494, 1428, 213192, 38, 2454, 41, 37);
INSERT INTO public.who_global_data VALUES (9495, 0, 7788, 0, 169, 41, 142);
INSERT INTO public.who_global_data VALUES (9496, 214, 91518, 0, 351, 41, 83);
INSERT INTO public.who_global_data VALUES (9497, 834, 508099, 30, 7428, 41, 228);
INSERT INTO public.who_global_data VALUES (9498, 2, 347, 0, 7, 41, 188);
INSERT INTO public.who_global_data VALUES (9499, 1916, 184922, 9, 1376, 41, 62);
INSERT INTO public.who_global_data VALUES (9500, 1159, 639766, 62, 19231, 41, 160);
INSERT INTO public.who_global_data VALUES (9501, 0, 10490, 0, 228, 41, 50);
INSERT INTO public.who_global_data VALUES (9502, 0, 3205, 0, 44, 41, 33);
INSERT INTO public.who_global_data VALUES (9503, 0, 561, 0, 9, 41, 183);
INSERT INTO public.who_global_data VALUES (9504, 21, 597, 0, 0, 41, 92);
INSERT INTO public.who_global_data VALUES (9505, 469, 153590, 7, 9083, 41, 158);
INSERT INTO public.who_global_data VALUES (9506, 0, 158, 0, 3, 41, 67);
INSERT INTO public.who_global_data VALUES (9507, 439, 109330, 22, 3923, 41, 57);
INSERT INTO public.who_global_data VALUES (9508, 0, 13622, 0, 38, 41, 38);
INSERT INTO public.who_global_data VALUES (9509, 22967, 7448560, 482, 190488, 41, 141);
INSERT INTO public.who_global_data VALUES (9510, 0, 93, 0, 1, 41, 178);
INSERT INTO public.who_global_data VALUES (9511, 0, 152, 0, 3, 41, 108);
INSERT INTO public.who_global_data VALUES (9512, 469, 197384, 50, 7123, 41, 39);
INSERT INTO public.who_global_data VALUES (9513, 121, 6255, 0, 77, 41, 2);
INSERT INTO public.who_global_data VALUES (9514, 18, 804, 0, 2, 41, 195);
INSERT INTO public.who_global_data VALUES (9515, 2, 11698, 0, 112, 41, 107);
INSERT INTO public.who_global_data VALUES (9516, 1, 364, 0, 0, 41, 161);
INSERT INTO public.who_global_data VALUES (9517, 428, 26277, 0, 448, 41, 212);
INSERT INTO public.who_global_data VALUES (9518, 1430, 536673, 0, 14720, 41, 181);
INSERT INTO public.who_global_data VALUES (9519, 0, 318, 0, 2, 41, 53);
INSERT INTO public.who_global_data VALUES (9520, 0, 4948, 0, 63, 41, 164);
INSERT INTO public.who_global_data VALUES (9521, 15, 1986, 1, 103, 41, 140);
INSERT INTO public.who_global_data VALUES (9522, 2563, 598394, 46, 16404, 41, 20);
INSERT INTO public.who_global_data VALUES (9523, 84, 96324, 0, 4777, 41, 112);
INSERT INTO public.who_global_data VALUES (9524, 14941, 1574707, 236, 41690, 41, 111);
INSERT INTO public.who_global_data VALUES (9525, 0, 715, 0, 7, 41, 71);
INSERT INTO public.who_global_data VALUES (9526, 0, 6200, 0, 100, 41, 218);
INSERT INTO public.who_global_data VALUES (9527, 0, 0, 0, 0, 41, 43);
INSERT INTO public.who_global_data VALUES (9528, 1072, 164062, 17, 2103, 41, 49);
INSERT INTO public.who_global_data VALUES (9529, 0, 22081, 0, 133, 41, 1);
INSERT INTO public.who_global_data VALUES (9530, 618, 204930, 58, 3671, 41, 48);
INSERT INTO public.who_global_data VALUES (9531, 138, 11038, 1, 141, 41, 232);
INSERT INTO public.who_global_data VALUES (9532, 0, 4051, 0, 12, 41, 175);
INSERT INTO public.who_global_data VALUES (9533, 25, 19391, 2, 111, 41, 21);
INSERT INTO public.who_global_data VALUES (9534, 3030, 670599, 94, 11044, 41, 156);
INSERT INTO public.who_global_data VALUES (9535, 0, 0, 0, 0, 41, 95);
INSERT INTO public.who_global_data VALUES (9536, 0, 16280, 0, 566, 41, 177);
INSERT INTO public.who_global_data VALUES (9537, 1834, 151167, 19, 1153, 41, 210);
INSERT INTO public.who_global_data VALUES (9538, 1, 5805, 0, 61, 41, 120);
INSERT INTO public.who_global_data VALUES (9539, 0, 96, 0, 0, 41, 135);
INSERT INTO public.who_global_data VALUES (9540, 905, 165940, 0, 2404, 41, 206);
INSERT INTO public.who_global_data VALUES (9541, 446, 209274, 6, 13990, 41, 189);
INSERT INTO public.who_global_data VALUES (9542, 1189, 131315, 43, 7352, 41, 129);
INSERT INTO public.who_global_data VALUES (9543, 0, 44619, 8, 1297, 41, 121);
INSERT INTO public.who_global_data VALUES (9544, 5, 5236, 0, 85, 41, 59);
INSERT INTO public.who_global_data VALUES (9545, 0, 992, 0, 1, 41, 96);
INSERT INTO public.who_global_data VALUES (9546, 365, 25392, 2, 204, 41, 41);
INSERT INTO public.who_global_data VALUES (9547, 197, 8367, 9, 163, 41, 216);
INSERT INTO public.who_global_data VALUES (9548, 533, 122413, 4, 1901, 41, 236);
INSERT INTO public.who_global_data VALUES (9549, 0, 29, 0, 0, 41, 150);
INSERT INTO public.who_global_data VALUES (9550, 4, 571, 0, 0, 41, 61);
INSERT INTO public.who_global_data VALUES (9551, 0, 46, 0, 2, 41, 7);
INSERT INTO public.who_global_data VALUES (9552, 0, 34084, 0, 524, 41, 169);
INSERT INTO public.who_global_data VALUES (9553, 2458, 2507532, 146, 62197, 41, 28);
INSERT INTO public.who_global_data VALUES (9554, 88, 12773, 0, 71, 41, 85);
INSERT INTO public.who_global_data VALUES (9555, 0, 16550, 0, 108, 41, 211);
INSERT INTO public.who_global_data VALUES (9556, 28, 9497, 0, 64, 41, 60);
INSERT INTO public.who_global_data VALUES (9557, 0, 3792, 0, 123, 41, 3);
INSERT INTO public.who_global_data VALUES (9558, 1097, 221605, 25, 2377, 41, 11);
INSERT INTO public.who_global_data VALUES (9559, 13755, 1640858, 356, 29778, 41, 89);
INSERT INTO public.who_global_data VALUES (9560, 243, 54286, 0, 333, 41, 24);
INSERT INTO public.who_global_data VALUES (9561, 58, 1534, 0, 6, 41, 162);
INSERT INTO public.who_global_data VALUES (9562, 262, 135114, 46, 4553, 41, 100);
INSERT INTO public.who_global_data VALUES (9563, 0, 26, 0, 0, 41, 47);
INSERT INTO public.who_global_data VALUES (9564, 0, 116, 0, 0, 41, 29);
INSERT INTO public.who_global_data VALUES (9565, 63, 8620, 0, 155, 41, 40);
INSERT INTO public.who_global_data VALUES (9566, 1, 7094, 0, 121, 41, 222);
INSERT INTO public.who_global_data VALUES (9567, 91, 135171, 6, 4763, 41, 132);
INSERT INTO public.who_global_data VALUES (9568, 0, 297, 0, 13, 41, 130);
INSERT INTO public.who_global_data VALUES (9569, 0, 13646, 0, 80, 41, 234);
INSERT INTO public.who_global_data VALUES (9570, 0, 2447, 0, 45, 41, 23);
INSERT INTO public.who_global_data VALUES (9571, 23, 6289, 0, 162, 41, 192);
INSERT INTO public.who_global_data VALUES (9572, 0, 9846, 0, 235, 41, 69);
INSERT INTO public.who_global_data VALUES (9573, 0, 26, 0, 0, 41, 187);
INSERT INTO public.who_global_data VALUES (9574, 238, 118659, 1, 3061, 41, 230);
INSERT INTO public.who_global_data VALUES (9575, 698, 316060, 96, 9047, 41, 77);
INSERT INTO public.who_global_data VALUES (9576, 0, 5683, 0, 28, 41, 9);
INSERT INTO public.who_global_data VALUES (9577, 18732, 10187850, 279, 147622, 41, 74);
INSERT INTO public.who_global_data VALUES (9578, 6740, 706837, 147, 20994, 41, 224);
INSERT INTO public.who_global_data VALUES (9579, 5760, 1194963, 134, 54574, 41, 199);
INSERT INTO public.who_global_data VALUES (9580, 836, 590779, 12, 12767, 41, 190);
INSERT INTO public.who_global_data VALUES (9581, 1296, 85394, 6, 2200, 41, 12);
INSERT INTO public.who_global_data VALUES (9582, 0, 374, 0, 25, 41, 104);
INSERT INTO public.who_global_data VALUES (9583, 4010, 396600, 20, 3211, 41, 153);
INSERT INTO public.who_global_data VALUES (9584, 10405, 2038759, 261, 71620, 41, 91);
INSERT INTO public.who_global_data VALUES (9585, 87, 12684, 0, 294, 41, 215);
INSERT INTO public.who_global_data VALUES (9586, 3765, 217312, 58, 3213, 41, 84);
INSERT INTO public.who_global_data VALUES (9587, 0, 2583, 0, 41, 41, 231);
INSERT INTO public.who_global_data VALUES (9588, 1050, 286356, 18, 3729, 41, 196);
INSERT INTO public.who_global_data VALUES (9589, 760, 197902, 80, 2749, 41, 105);
INSERT INTO public.who_global_data VALUES (9590, 130, 95843, 2, 1655, 41, 122);
INSERT INTO public.who_global_data VALUES (9591, 0, 0, 0, 0, 41, 159);
INSERT INTO public.who_global_data VALUES (9592, 270, 50362, 7, 1295, 41, 75);
INSERT INTO public.who_global_data VALUES (9593, 172, 149449, 3, 929, 41, 27);
INSERT INTO public.who_global_data VALUES (9594, 191, 80373, 4, 1348, 41, 54);
INSERT INTO public.who_global_data VALUES (9595, 0, 41, 0, 0, 41, 226);
INSERT INTO public.who_global_data VALUES (9596, 399, 35819, 13, 515, 41, 79);
INSERT INTO public.who_global_data VALUES (9597, 1403, 169472, 12, 1379, 41, 56);
INSERT INTO public.who_global_data VALUES (9598, 0, 2577, 0, 50, 41, 117);
INSERT INTO public.who_global_data VALUES (9599, 0, 1800, 0, 83, 41, 152);
INSERT INTO public.who_global_data VALUES (9600, 0, 97653, 0, 1415, 41, 16);
INSERT INTO public.who_global_data VALUES (9601, 23, 2086, 1, 33, 41, 10);
INSERT INTO public.who_global_data VALUES (9602, 1665, 130597, 42, 1615, 41, 201);
INSERT INTO public.who_global_data VALUES (9603, 52, 45776, 5, 470, 41, 174);
INSERT INTO public.who_global_data VALUES (9604, 0, 17633, 0, 260, 41, 119);
INSERT INTO public.who_global_data VALUES (9605, 4, 6343, 1, 188, 41, 168);
INSERT INTO public.who_global_data VALUES (9606, 2335, 103900, 2, 451, 41, 99);
INSERT INTO public.who_global_data VALUES (9607, 35, 13618, 0, 48, 41, 171);
INSERT INTO public.who_global_data VALUES (9608, 283, 6574, 24, 249, 41, 87);
INSERT INTO public.who_global_data VALUES (9609, 129, 12241, 3, 206, 41, 123);
INSERT INTO public.who_global_data VALUES (9610, 0, 4, 0, 0, 41, 151);
INSERT INTO public.who_global_data VALUES (9611, 438, 6072, 0, 42, 41, 213);
INSERT INTO public.who_global_data VALUES (9612, 0, 10971, 0, 225, 41, 118);
INSERT INTO public.who_global_data VALUES (9613, 0, 524, 0, 10, 41, 134);
INSERT INTO public.who_global_data VALUES (9614, 0, 5767, 0, 54, 41, 65);
INSERT INTO public.who_global_data VALUES (9615, 9679, 1372243, 665, 121837, 41, 102);
INSERT INTO public.who_global_data VALUES (9616, 0, 0, 0, 0, 41, 223);
INSERT INTO public.who_global_data VALUES (9617, 8, 800, 0, 3, 41, 4);
INSERT INTO public.who_global_data VALUES (9618, 7, 1082, 0, 0, 41, 146);
INSERT INTO public.who_global_data VALUES (9619, 296, 46929, 8, 666, 41, 31);
INSERT INTO public.who_global_data VALUES (9620, 0, 13, 0, 1, 41, 127);
INSERT INTO public.who_global_data VALUES (9621, 2369, 430562, 34, 7204, 41, 22);
INSERT INTO public.who_global_data VALUES (9622, 54, 18162, 3, 159, 41, 115);
INSERT INTO public.who_global_data VALUES (9623, 1492, 121280, 47, 2579, 41, 106);
INSERT INTO public.who_global_data VALUES (9624, 136, 21398, 0, 187, 41, 90);
INSERT INTO public.who_global_data VALUES (9625, 0, 0, 0, 0, 41, 70);
INSERT INTO public.who_global_data VALUES (9626, 500, 257700, 2, 1819, 41, 46);
INSERT INTO public.who_global_data VALUES (9627, 9831, 752811, 49, 10942, 41, 139);
INSERT INTO public.who_global_data VALUES (9628, 0, 38, 0, 0, 41, 42);
INSERT INTO public.who_global_data VALUES (9629, 16, 1788, 0, 25, 41, 80);
INSERT INTO public.who_global_data VALUES (9630, 0, 4790, 0, 164, 41, 203);
INSERT INTO public.who_global_data VALUES (9631, 0, 2803, 0, 89, 41, 136);
INSERT INTO public.who_global_data VALUES (9632, 829, 83576, 1, 1247, 41, 63);
INSERT INTO public.who_global_data VALUES (9633, 0, 0, 0, 0, 41, 17);
INSERT INTO public.who_global_data VALUES (9634, 0, 122, 0, 2, 41, 172);
INSERT INTO public.who_global_data VALUES (9635, 529, 81425, 26, 2427, 41, 109);
INSERT INTO public.who_global_data VALUES (9636, 0, 44932, 0, 421, 41, 200);
INSERT INTO public.who_global_data VALUES (9637, 1306, 148540, 21, 1406, 41, 93);
INSERT INTO public.who_global_data VALUES (9638, 0, 128290, 0, 1491, 41, 5);
INSERT INTO public.who_global_data VALUES (9639, 0, 745, 0, 13, 41, 214);
INSERT INTO public.who_global_data VALUES (9640, 2260, 469482, 63, 9816, 41, 204);
INSERT INTO public.who_global_data VALUES (9641, 0, 0, 0, 0, 41, 198);
INSERT INTO public.who_global_data VALUES (9642, 2986, 226660, 41, 3756, 41, 173);
INSERT INTO public.who_global_data VALUES (9643, 0, 780, 0, 9, 41, 229);
INSERT INTO public.who_global_data VALUES (9644, 559, 103888, 0, 2154, 41, 76);
INSERT INTO public.who_global_data VALUES (9645, 1564, 1005546, 51, 37368, 41, 138);
INSERT INTO public.who_global_data VALUES (9646, 1404, 469005, 5, 9067, 41, 98);
INSERT INTO public.who_global_data VALUES (9647, 0, 0, 0, 0, 41, 103);
INSERT INTO public.who_global_data VALUES (9648, 3842, 1257799, 57, 27118, 41, 225);
INSERT INTO public.who_global_data VALUES (9649, 1214, 392996, 78, 6556, 41, 131);
INSERT INTO public.who_global_data VALUES (9650, 1019, 72443, 0, 1432, 41, 235);
INSERT INTO public.who_global_data VALUES (9651, 169, 142903, 0, 244, 41, 137);
INSERT INTO public.who_global_data VALUES (9652, 970, 56858, 15, 808, 41, 81);
INSERT INTO public.who_global_data VALUES (9653, 746, 140996, 12, 2883, 41, 182);
INSERT INTO public.who_global_data VALUES (9654, 0, 8909, 0, 42, 41, 145);
INSERT INTO public.who_global_data VALUES (9655, 1387, 613760, 95, 15108, 41, 26);
INSERT INTO public.who_global_data VALUES (9656, 28284, 3050248, 552, 54778, 41, 170);
INSERT INTO public.who_global_data VALUES (9657, 306, 7817, 6, 72, 41, 191);
INSERT INTO public.who_global_data VALUES (9658, 0, 5, 0, 0, 41, 221);
INSERT INTO public.who_global_data VALUES (9659, 7, 189, 0, 0, 41, 64);
INSERT INTO public.who_global_data VALUES (9660, 0, 0, 0, 0, 41, 116);
INSERT INTO public.who_global_data VALUES (9661, 0, 30, 0, 0, 41, 128);
INSERT INTO public.who_global_data VALUES (9662, 0, 305, 0, 5, 41, 6);
INSERT INTO public.who_global_data VALUES (9663, 38, 986, 0, 12, 41, 227);
INSERT INTO public.who_global_data VALUES (9664, 0, 16, 0, 0, 41, 68);
INSERT INTO public.who_global_data VALUES (9665, 0, 108, 0, 0, 41, 184);
INSERT INTO public.who_global_data VALUES (9666, 0, 2, 0, 0, 41, 82);
INSERT INTO public.who_global_data VALUES (9667, 0, 2264, 0, 57, 41, 149);
INSERT INTO public.who_global_data VALUES (9668, 2, 1014, 0, 17, 41, 197);
INSERT INTO public.who_global_data VALUES (9669, 163, 362066, 8, 6176, 41, 78);
INSERT INTO public.who_global_data VALUES (9670, 154, 18523, 1, 387, 41, 233);
INSERT INTO public.who_global_data VALUES (9671, 3200, 323367, 52, 2983, 41, 133);
INSERT INTO public.who_global_data VALUES (9672, 0, 211, 0, 0, 41, 35);
INSERT INTO public.who_global_data VALUES (9673, 0, 2549, 0, 76, 41, 114);
INSERT INTO public.who_global_data VALUES (9674, 10, 58519, 0, 29, 41, 237);
INSERT INTO public.who_global_data VALUES (9675, 0, 19, 0, 0, 41, 55);
INSERT INTO public.who_global_data VALUES (9676, 0, 1370, 0, 26, 41, 176);
INSERT INTO public.who_global_data VALUES (9677, 874, 167523, 41, 1773, 41, 202);
INSERT INTO public.who_global_data VALUES (9678, 622, 114877, 27, 2827, 41, 155);
INSERT INTO public.who_global_data VALUES (9679, 0, 17, 0, 0, 41, 32);
INSERT INTO public.who_global_data VALUES (9680, 0, 4690, 0, 127, 41, 220);
INSERT INTO public.who_global_data VALUES (9681, 11552, 994911, 245, 26521, 41, 30);
INSERT INTO public.who_global_data VALUES (9682, 0, 3308, 0, 62, 41, 147);
INSERT INTO public.who_global_data VALUES (9683, 5027, 1938424, 116, 51054, 41, 208);
INSERT INTO public.who_global_data VALUES (9684, 598, 40380, 1, 187, 41, 45);
INSERT INTO public.who_global_data VALUES (9685, 106, 24694, 5, 1520, 41, 110);
INSERT INTO public.who_global_data VALUES (9686, 70, 5880, 1, 119, 41, 88);
INSERT INTO public.who_global_data VALUES (9687, 2793, 415171, 106, 9265, 41, 51);
INSERT INTO public.who_global_data VALUES (9688, 2355, 435304, 89, 6929, 41, 209);
INSERT INTO public.who_global_data VALUES (9689, 111, 10932, 9, 669, 41, 205);
INSERT INTO public.who_global_data VALUES (9690, 37, 13555, 0, 90, 41, 18);
INSERT INTO public.who_global_data VALUES (9691, 110, 6020, 0, 60, 41, 72);
INSERT INTO public.who_global_data VALUES (9692, 34693, 2256009, 210, 70405, 41, 44);
INSERT INTO public.who_global_data VALUES (9693, 0, 41, 0, 0, 41, 15);
INSERT INTO public.who_global_data VALUES (9694, 88, 3555, 2, 68, 41, 25);
INSERT INTO public.who_global_data VALUES (9695, 0, 0, 0, 0, 41, 179);
INSERT INTO public.who_global_data VALUES (9696, 0, 0, 0, 0, 41, 34);
INSERT INTO public.who_global_data VALUES (9697, 8, 7097, 0, 125, 41, 207);
INSERT INTO public.who_global_data VALUES (9698, 1652, 130230, 41, 4426, 41, 166);
INSERT INTO public.who_global_data VALUES (9699, 15118, 2133373, 253, 19624, 41, 126);
INSERT INTO public.who_global_data VALUES (9700, 0, 0, 0, 0, 41, 97);
INSERT INTO public.who_global_data VALUES (9701, 15, 844, 0, 6, 41, 36);
INSERT INTO public.who_global_data VALUES (9702, 0, 0, 0, 0, 41, 125);
INSERT INTO public.who_global_data VALUES (9703, 203, 33563, 0, 245, 41, 124);
INSERT INTO public.who_global_data VALUES (9704, 6113, 1025989, 72, 17774, 41, 185);
INSERT INTO public.who_global_data VALUES (9705, 1227, 200892, 2, 655, 41, 194);
INSERT INTO public.who_global_data VALUES (9706, 0, 509, 0, 21, 41, 144);
INSERT INTO public.who_global_data VALUES (9707, 145489, 18648989, 1692, 328014, 41, 19);
INSERT INTO public.who_global_data VALUES (9708, 0, 1979, 0, 23, 41, 217);
INSERT INTO public.who_global_data VALUES (9709, 391, 15848, 8, 143, 41, 148);
INSERT INTO public.who_global_data VALUES (9710, 85, 76751, 1, 613, 41, 86);
INSERT INTO public.who_global_data VALUES (9711, 0, 1, 0, 0, 41, 13);
INSERT INTO public.who_global_data VALUES (9712, 358, 111603, 4, 1010, 41, 157);
INSERT INTO public.who_global_data VALUES (9713, 1, 1440, 0, 35, 41, 8);
INSERT INTO public.who_global_data VALUES (9714, 0, 4, 0, 0, 41, 73);
INSERT INTO public.who_global_data VALUES (9715, 0, 2096, 0, 607, 41, 101);
INSERT INTO public.who_global_data VALUES (9716, 100, 19671, 1, 382, 41, 165);
INSERT INTO public.who_global_data VALUES (9717, 83, 12963, 0, 341, 41, 14);
INSERT INTO public.who_global_data VALUES (9718, 169, 51764, 13, 2148, 42, 193);
INSERT INTO public.who_global_data VALUES (9719, 553, 55380, 9, 1134, 42, 113);
INSERT INTO public.who_global_data VALUES (9720, 434, 97441, 11, 2716, 42, 143);
INSERT INTO public.who_global_data VALUES (9721, 0, 0, 0, 0, 42, 219);
INSERT INTO public.who_global_data VALUES (9722, 57, 7756, 0, 83, 42, 186);
INSERT INTO public.who_global_data VALUES (9723, 70, 17099, 1, 396, 42, 52);
INSERT INTO public.who_global_data VALUES (9724, 0, 11, 0, 0, 42, 180);
INSERT INTO public.who_global_data VALUES (9725, 0, 154, 0, 5, 42, 167);
INSERT INTO public.who_global_data VALUES (9726, 7815, 1571680, 78, 42392, 42, 154);
INSERT INTO public.who_global_data VALUES (9727, 586, 156662, 19, 2747, 42, 94);
INSERT INTO public.who_global_data VALUES (9728, 0, 5228, 0, 47, 42, 66);
INSERT INTO public.who_global_data VALUES (9729, 0, 28262, 0, 908, 42, 58);
INSERT INTO public.who_global_data VALUES (9730, 1750, 347101, 38, 5710, 42, 163);
INSERT INTO public.who_global_data VALUES (9731, 1703, 211764, 36, 2416, 42, 37);
INSERT INTO public.who_global_data VALUES (9732, 0, 7788, 0, 169, 42, 142);
INSERT INTO public.who_global_data VALUES (9733, 234, 91304, 1, 351, 42, 83);
INSERT INTO public.who_global_data VALUES (9734, 1163, 507265, 20, 7398, 42, 228);
INSERT INTO public.who_global_data VALUES (9735, 16, 345, 0, 7, 42, 188);
INSERT INTO public.who_global_data VALUES (9736, 1893, 183006, 9, 1367, 42, 62);
INSERT INTO public.who_global_data VALUES (9737, 520, 638607, 67, 19169, 42, 160);
INSERT INTO public.who_global_data VALUES (9738, 120, 10490, 2, 228, 42, 50);
INSERT INTO public.who_global_data VALUES (9739, 0, 3205, 0, 44, 42, 33);
INSERT INTO public.who_global_data VALUES (9740, 0, 561, 0, 9, 42, 183);
INSERT INTO public.who_global_data VALUES (9741, 35, 576, 0, 0, 42, 92);
INSERT INTO public.who_global_data VALUES (9742, 1057, 153121, 11, 9076, 42, 158);
INSERT INTO public.who_global_data VALUES (9743, 0, 158, 0, 3, 42, 67);
INSERT INTO public.who_global_data VALUES (9744, 593, 108891, 23, 3901, 42, 57);
INSERT INTO public.who_global_data VALUES (9745, 0, 13622, 0, 38, 42, 38);
INSERT INTO public.who_global_data VALUES (9746, 60076, 7425593, 786, 190006, 42, 141);
INSERT INTO public.who_global_data VALUES (9747, 0, 93, 0, 1, 42, 178);
INSERT INTO public.who_global_data VALUES (9748, 0, 152, 0, 3, 42, 108);
INSERT INTO public.who_global_data VALUES (9749, 257, 196915, 50, 7073, 42, 39);
INSERT INTO public.who_global_data VALUES (9750, 193, 6134, 0, 77, 42, 2);
INSERT INTO public.who_global_data VALUES (9751, 0, 786, 0, 2, 42, 195);
INSERT INTO public.who_global_data VALUES (9752, 28, 11696, 0, 112, 42, 107);
INSERT INTO public.who_global_data VALUES (9753, 0, 363, 0, 0, 42, 161);
INSERT INTO public.who_global_data VALUES (9754, 0, 25849, 0, 448, 42, 212);
INSERT INTO public.who_global_data VALUES (9755, 6889, 535243, 123, 14720, 42, 181);
INSERT INTO public.who_global_data VALUES (9756, 1, 318, 0, 2, 42, 53);
INSERT INTO public.who_global_data VALUES (9757, 0, 4948, 0, 63, 42, 164);
INSERT INTO public.who_global_data VALUES (9758, 13, 1971, 0, 102, 42, 140);
INSERT INTO public.who_global_data VALUES (9759, 2521, 595831, 55, 16358, 42, 20);
INSERT INTO public.who_global_data VALUES (9760, 81, 96240, 1, 4777, 42, 112);
INSERT INTO public.who_global_data VALUES (9761, 14940, 1559766, 281, 41454, 42, 111);
INSERT INTO public.who_global_data VALUES (9762, 32, 715, 0, 7, 42, 71);
INSERT INTO public.who_global_data VALUES (9763, 0, 6200, 0, 100, 42, 218);
INSERT INTO public.who_global_data VALUES (9764, 0, 0, 0, 0, 42, 43);
INSERT INTO public.who_global_data VALUES (9765, 1048, 162990, 21, 2086, 42, 49);
INSERT INTO public.who_global_data VALUES (9766, 97, 22081, 0, 133, 42, 1);
INSERT INTO public.who_global_data VALUES (9767, 350, 204312, 65, 3613, 42, 48);
INSERT INTO public.who_global_data VALUES (9768, 400, 10900, 1, 140, 42, 232);
INSERT INTO public.who_global_data VALUES (9769, 0, 4051, 0, 12, 42, 175);
INSERT INTO public.who_global_data VALUES (9770, 50, 19366, 2, 109, 42, 21);
INSERT INTO public.who_global_data VALUES (9771, 2706, 667569, 91, 10950, 42, 156);
INSERT INTO public.who_global_data VALUES (9772, 0, 0, 0, 0, 42, 95);
INSERT INTO public.who_global_data VALUES (9773, 243, 16280, 0, 566, 42, 177);
INSERT INTO public.who_global_data VALUES (9774, 2992, 149333, 20, 1134, 42, 210);
INSERT INTO public.who_global_data VALUES (9775, 4, 5804, 0, 61, 42, 120);
INSERT INTO public.who_global_data VALUES (9776, 0, 96, 0, 0, 42, 135);
INSERT INTO public.who_global_data VALUES (9777, 1381, 165035, 0, 2404, 42, 206);
INSERT INTO public.who_global_data VALUES (9778, 818, 208828, 7, 13984, 42, 189);
INSERT INTO public.who_global_data VALUES (9779, 1133, 130126, 49, 7309, 42, 129);
INSERT INTO public.who_global_data VALUES (9780, 0, 44619, 6, 1289, 42, 121);
INSERT INTO public.who_global_data VALUES (9781, 0, 5231, 0, 85, 42, 59);
INSERT INTO public.who_global_data VALUES (9782, 37, 992, 0, 1, 42, 96);
INSERT INTO public.who_global_data VALUES (9783, 445, 25027, 0, 202, 42, 41);
INSERT INTO public.who_global_data VALUES (9784, 138, 8170, 0, 154, 42, 216);
INSERT INTO public.who_global_data VALUES (9785, 481, 121880, 15, 1897, 42, 236);
INSERT INTO public.who_global_data VALUES (9786, 0, 29, 0, 0, 42, 150);
INSERT INTO public.who_global_data VALUES (9787, 6, 567, 0, 0, 42, 61);
INSERT INTO public.who_global_data VALUES (9788, 0, 46, 0, 2, 42, 7);
INSERT INTO public.who_global_data VALUES (9789, 0, 34084, 0, 524, 42, 169);
INSERT INTO public.who_global_data VALUES (9790, 20199, 2505074, 159, 62051, 42, 28);
INSERT INTO public.who_global_data VALUES (9791, 0, 12685, 0, 71, 42, 85);
INSERT INTO public.who_global_data VALUES (9792, 0, 16550, 0, 108, 42, 211);
INSERT INTO public.who_global_data VALUES (9793, 0, 9469, 0, 64, 42, 60);
INSERT INTO public.who_global_data VALUES (9794, 1, 3792, 0, 123, 42, 3);
INSERT INTO public.who_global_data VALUES (9795, 1784, 220508, 39, 2352, 42, 11);
INSERT INTO public.who_global_data VALUES (9796, 14455, 1627103, 240, 29422, 42, 89);
INSERT INTO public.who_global_data VALUES (9797, 0, 54043, 0, 333, 42, 24);
INSERT INTO public.who_global_data VALUES (9798, 78, 1476, 0, 6, 42, 162);
INSERT INTO public.who_global_data VALUES (9799, 617, 134852, 50, 4507, 42, 100);
INSERT INTO public.who_global_data VALUES (9800, 0, 26, 0, 0, 42, 47);
INSERT INTO public.who_global_data VALUES (9801, 4, 116, 0, 0, 42, 29);
INSERT INTO public.who_global_data VALUES (9802, 0, 8557, 0, 155, 42, 40);
INSERT INTO public.who_global_data VALUES (9803, 2, 7093, 0, 121, 42, 222);
INSERT INTO public.who_global_data VALUES (9804, 186, 135080, 8, 4757, 42, 132);
INSERT INTO public.who_global_data VALUES (9805, 0, 297, 0, 13, 42, 130);
INSERT INTO public.who_global_data VALUES (9806, 16, 13646, 0, 80, 42, 234);
INSERT INTO public.who_global_data VALUES (9807, 0, 2447, 0, 45, 42, 23);
INSERT INTO public.who_global_data VALUES (9808, 8, 6266, 0, 162, 42, 192);
INSERT INTO public.who_global_data VALUES (9809, 0, 9846, 0, 235, 42, 69);
INSERT INTO public.who_global_data VALUES (9810, 0, 26, 0, 0, 42, 187);
INSERT INTO public.who_global_data VALUES (9811, 385, 118421, 6, 3060, 42, 230);
INSERT INTO public.who_global_data VALUES (9812, 1198, 315362, 118, 8951, 42, 77);
INSERT INTO public.who_global_data VALUES (9813, 0, 5683, 0, 28, 42, 9);
INSERT INTO public.who_global_data VALUES (9814, 22273, 10169118, 251, 147343, 42, 74);
INSERT INTO public.who_global_data VALUES (9815, 7259, 700097, 258, 20847, 42, 224);
INSERT INTO public.who_global_data VALUES (9816, 6021, 1189203, 132, 54440, 42, 199);
INSERT INTO public.who_global_data VALUES (9817, 1140, 589943, 11, 12755, 42, 190);
INSERT INTO public.who_global_data VALUES (9818, 1025, 84098, 2, 2194, 42, 12);
INSERT INTO public.who_global_data VALUES (9819, 0, 374, 0, 25, 42, 104);
INSERT INTO public.who_global_data VALUES (9820, 4053, 392590, 15, 3191, 42, 153);
INSERT INTO public.who_global_data VALUES (9821, 19037, 2028354, 459, 71359, 42, 91);
INSERT INTO public.who_global_data VALUES (9822, 78, 12597, 2, 294, 42, 215);
INSERT INTO public.who_global_data VALUES (9823, 3567, 213547, 50, 3155, 42, 84);
INSERT INTO public.who_global_data VALUES (9824, 23, 2583, 1, 41, 42, 231);
INSERT INTO public.who_global_data VALUES (9825, 1616, 285306, 30, 3711, 42, 196);
INSERT INTO public.who_global_data VALUES (9826, 926, 197142, 0, 2669, 42, 105);
INSERT INTO public.who_global_data VALUES (9827, 282, 95713, 1, 1653, 42, 122);
INSERT INTO public.who_global_data VALUES (9828, 0, 0, 0, 0, 42, 159);
INSERT INTO public.who_global_data VALUES (9829, 249, 50092, 8, 1288, 42, 75);
INSERT INTO public.who_global_data VALUES (9830, 260, 149277, 0, 926, 42, 27);
INSERT INTO public.who_global_data VALUES (9831, 157, 80182, 4, 1344, 42, 54);
INSERT INTO public.who_global_data VALUES (9832, 0, 41, 0, 0, 42, 226);
INSERT INTO public.who_global_data VALUES (9833, 666, 35420, 16, 502, 42, 79);
INSERT INTO public.who_global_data VALUES (9834, 2136, 168069, 14, 1367, 42, 56);
INSERT INTO public.who_global_data VALUES (9835, 0, 2577, 0, 50, 42, 117);
INSERT INTO public.who_global_data VALUES (9836, 2, 1800, 0, 83, 42, 152);
INSERT INTO public.who_global_data VALUES (9837, 461, 97653, 16, 1415, 42, 16);
INSERT INTO public.who_global_data VALUES (9838, 29, 2063, 2, 32, 42, 10);
INSERT INTO public.who_global_data VALUES (9839, 2344, 128932, 61, 1573, 42, 201);
INSERT INTO public.who_global_data VALUES (9840, 253, 45724, 4, 465, 42, 174);
INSERT INTO public.who_global_data VALUES (9841, 0, 17633, 0, 260, 42, 119);
INSERT INTO public.who_global_data VALUES (9842, 62, 6339, 0, 187, 42, 168);
INSERT INTO public.who_global_data VALUES (9843, 1247, 101565, 3, 449, 42, 99);
INSERT INTO public.who_global_data VALUES (9844, 25, 13583, 0, 48, 42, 171);
INSERT INTO public.who_global_data VALUES (9845, 0, 6291, 0, 225, 42, 87);
INSERT INTO public.who_global_data VALUES (9846, 50, 12112, 0, 203, 42, 123);
INSERT INTO public.who_global_data VALUES (9847, 0, 4, 0, 0, 42, 151);
INSERT INTO public.who_global_data VALUES (9848, 0, 5634, 0, 42, 42, 213);
INSERT INTO public.who_global_data VALUES (9849, 0, 10971, 0, 225, 42, 118);
INSERT INTO public.who_global_data VALUES (9850, 0, 524, 0, 10, 42, 134);
INSERT INTO public.who_global_data VALUES (9851, 0, 5767, 0, 54, 42, 65);
INSERT INTO public.who_global_data VALUES (9852, 12485, 1362564, 861, 121172, 42, 102);
INSERT INTO public.who_global_data VALUES (9853, 0, 0, 0, 0, 42, 223);
INSERT INTO public.who_global_data VALUES (9854, 6, 792, 0, 3, 42, 4);
INSERT INTO public.who_global_data VALUES (9855, 6, 1075, 0, 0, 42, 146);
INSERT INTO public.who_global_data VALUES (9856, 356, 46633, 6, 658, 42, 31);
INSERT INTO public.who_global_data VALUES (9857, 0, 13, 0, 1, 42, 127);
INSERT INTO public.who_global_data VALUES (9858, 2329, 428193, 40, 7170, 42, 22);
INSERT INTO public.who_global_data VALUES (9859, 77, 18108, 0, 156, 42, 115);
INSERT INTO public.who_global_data VALUES (9860, 919, 119788, 25, 2532, 42, 106);
INSERT INTO public.who_global_data VALUES (9861, 683, 21262, 0, 187, 42, 90);
INSERT INTO public.who_global_data VALUES (9862, 0, 0, 0, 0, 42, 70);
INSERT INTO public.who_global_data VALUES (9863, 608, 257200, 9, 1817, 42, 46);
INSERT INTO public.who_global_data VALUES (9864, 11498, 742980, 93, 10893, 42, 139);
INSERT INTO public.who_global_data VALUES (9865, 0, 38, 0, 0, 42, 42);
INSERT INTO public.who_global_data VALUES (9866, 0, 1772, 0, 25, 42, 80);
INSERT INTO public.who_global_data VALUES (9867, 0, 4790, 0, 164, 42, 203);
INSERT INTO public.who_global_data VALUES (9868, 0, 2803, 0, 89, 42, 136);
INSERT INTO public.who_global_data VALUES (9869, 1825, 82747, 10, 1246, 42, 63);
INSERT INTO public.who_global_data VALUES (9870, 0, 0, 0, 0, 42, 17);
INSERT INTO public.who_global_data VALUES (9871, 0, 122, 0, 2, 42, 172);
INSERT INTO public.who_global_data VALUES (9872, 489, 80896, 26, 2401, 42, 109);
INSERT INTO public.who_global_data VALUES (9873, 0, 44932, 0, 421, 42, 200);
INSERT INTO public.who_global_data VALUES (9874, 1812, 147234, 21, 1385, 42, 93);
INSERT INTO public.who_global_data VALUES (9875, 0, 128290, 0, 1491, 42, 5);
INSERT INTO public.who_global_data VALUES (9876, 0, 745, 0, 13, 42, 214);
INSERT INTO public.who_global_data VALUES (9877, 2152, 467222, 85, 9753, 42, 204);
INSERT INTO public.who_global_data VALUES (9878, 0, 0, 0, 0, 42, 198);
INSERT INTO public.who_global_data VALUES (9879, 3413, 223674, 51, 3715, 42, 173);
INSERT INTO public.who_global_data VALUES (9880, 0, 780, 0, 9, 42, 229);
INSERT INTO public.who_global_data VALUES (9881, 958, 103329, 16, 2154, 42, 76);
INSERT INTO public.who_global_data VALUES (9882, 0, 1003982, 0, 37317, 42, 138);
INSERT INTO public.who_global_data VALUES (9883, 1877, 467601, 7, 9062, 42, 98);
INSERT INTO public.who_global_data VALUES (9884, 0, 0, 0, 0, 42, 103);
INSERT INTO public.who_global_data VALUES (9885, 4878, 1253957, 69, 27061, 42, 225);
INSERT INTO public.who_global_data VALUES (9886, 4146, 391782, 65, 6478, 42, 131);
INSERT INTO public.who_global_data VALUES (9887, 616, 71424, 9, 1432, 42, 235);
INSERT INTO public.who_global_data VALUES (9888, 129, 142734, 1, 244, 42, 137);
INSERT INTO public.who_global_data VALUES (9889, 1131, 55888, 20, 793, 42, 81);
INSERT INTO public.who_global_data VALUES (9890, 815, 140250, 23, 2871, 42, 182);
INSERT INTO public.who_global_data VALUES (9891, 63, 8909, 0, 42, 42, 145);
INSERT INTO public.who_global_data VALUES (9892, 3812, 612373, 101, 15013, 42, 26);
INSERT INTO public.who_global_data VALUES (9893, 29258, 3021964, 567, 54226, 42, 170);
INSERT INTO public.who_global_data VALUES (9894, 0, 7511, 0, 66, 42, 191);
INSERT INTO public.who_global_data VALUES (9895, 0, 5, 0, 0, 42, 221);
INSERT INTO public.who_global_data VALUES (9896, 0, 182, 0, 0, 42, 64);
INSERT INTO public.who_global_data VALUES (9897, 0, 0, 0, 0, 42, 116);
INSERT INTO public.who_global_data VALUES (9898, 0, 30, 0, 0, 42, 128);
INSERT INTO public.who_global_data VALUES (9899, 0, 305, 0, 5, 42, 6);
INSERT INTO public.who_global_data VALUES (9900, 0, 948, 0, 12, 42, 227);
INSERT INTO public.who_global_data VALUES (9901, 1, 16, 0, 0, 42, 68);
INSERT INTO public.who_global_data VALUES (9902, 0, 108, 0, 0, 42, 184);
INSERT INTO public.who_global_data VALUES (9903, 0, 2, 0, 0, 42, 82);
INSERT INTO public.who_global_data VALUES (9904, 33, 2264, 1, 57, 42, 149);
INSERT INTO public.who_global_data VALUES (9905, 0, 1012, 0, 17, 42, 197);
INSERT INTO public.who_global_data VALUES (9906, 178, 361903, 9, 6168, 42, 78);
INSERT INTO public.who_global_data VALUES (9907, 169, 18369, 5, 386, 42, 233);
INSERT INTO public.who_global_data VALUES (9908, 3823, 320167, 49, 2931, 42, 133);
INSERT INTO public.who_global_data VALUES (9909, 0, 211, 0, 0, 42, 35);
INSERT INTO public.who_global_data VALUES (9910, 52, 2549, 1, 76, 42, 114);
INSERT INTO public.who_global_data VALUES (9911, 14, 58509, 0, 29, 42, 237);
INSERT INTO public.who_global_data VALUES (9912, 0, 19, 0, 0, 42, 55);
INSERT INTO public.who_global_data VALUES (9913, 0, 1370, 0, 26, 42, 176);
INSERT INTO public.who_global_data VALUES (9914, 1041, 166649, 0, 1732, 42, 202);
INSERT INTO public.who_global_data VALUES (9915, 369, 114255, 33, 2800, 42, 155);
INSERT INTO public.who_global_data VALUES (9916, 0, 17, 0, 0, 42, 32);
INSERT INTO public.who_global_data VALUES (9917, 0, 4690, 0, 127, 42, 220);
INSERT INTO public.who_global_data VALUES (9918, 14796, 983359, 293, 26276, 42, 30);
INSERT INTO public.who_global_data VALUES (9919, 0, 3308, 0, 62, 42, 147);
INSERT INTO public.who_global_data VALUES (9920, 10250, 1933397, 134, 50938, 42, 208);
INSERT INTO public.who_global_data VALUES (9921, 1143, 39782, 2, 186, 42, 45);
INSERT INTO public.who_global_data VALUES (9922, 247, 24588, 8, 1515, 42, 110);
INSERT INTO public.who_global_data VALUES (9923, 76, 5810, 0, 118, 42, 88);
INSERT INTO public.who_global_data VALUES (9924, 5036, 412378, 87, 9159, 42, 51);
INSERT INTO public.who_global_data VALUES (9925, 1721, 432949, 59, 6840, 42, 209);
INSERT INTO public.who_global_data VALUES (9926, 120, 10821, 8, 660, 42, 205);
INSERT INTO public.who_global_data VALUES (9927, 43, 13518, 1, 90, 42, 18);
INSERT INTO public.who_global_data VALUES (9928, 81, 5910, 0, 60, 42, 72);
INSERT INTO public.who_global_data VALUES (9929, 32725, 2221316, 570, 70195, 42, 44);
INSERT INTO public.who_global_data VALUES (9930, 0, 41, 0, 0, 42, 15);
INSERT INTO public.who_global_data VALUES (9931, 0, 3467, 0, 66, 42, 25);
INSERT INTO public.who_global_data VALUES (9932, 0, 0, 0, 0, 42, 179);
INSERT INTO public.who_global_data VALUES (9933, 0, 0, 0, 0, 42, 34);
INSERT INTO public.who_global_data VALUES (9934, 18, 7089, 0, 125, 42, 207);
INSERT INTO public.who_global_data VALUES (9935, 1826, 128578, 61, 4385, 42, 166);
INSERT INTO public.who_global_data VALUES (9936, 17543, 2118255, 256, 19371, 42, 126);
INSERT INTO public.who_global_data VALUES (9937, 0, 0, 0, 0, 42, 97);
INSERT INTO public.who_global_data VALUES (9938, 19, 829, 0, 6, 42, 36);
INSERT INTO public.who_global_data VALUES (9939, 0, 0, 0, 0, 42, 125);
INSERT INTO public.who_global_data VALUES (9940, 446, 33360, 0, 245, 42, 124);
INSERT INTO public.who_global_data VALUES (9941, 7709, 1019876, 121, 17702, 42, 185);
INSERT INTO public.who_global_data VALUES (9942, 1230, 199665, 6, 653, 42, 194);
INSERT INTO public.who_global_data VALUES (9943, 0, 509, 0, 21, 42, 144);
INSERT INTO public.who_global_data VALUES (9944, 192095, 18503500, 2795, 326322, 42, 19);
INSERT INTO public.who_global_data VALUES (9945, 12, 1979, 0, 23, 42, 217);
INSERT INTO public.who_global_data VALUES (9946, 747, 15457, 7, 135, 42, 148);
INSERT INTO public.who_global_data VALUES (9947, 98, 76666, 0, 612, 42, 86);
INSERT INTO public.who_global_data VALUES (9948, 0, 1, 0, 0, 42, 13);
INSERT INTO public.who_global_data VALUES (9949, 221, 111245, 4, 1006, 42, 157);
INSERT INTO public.who_global_data VALUES (9950, 6, 1439, 0, 35, 42, 8);
INSERT INTO public.who_global_data VALUES (9951, 0, 4, 0, 0, 42, 73);
INSERT INTO public.who_global_data VALUES (9952, 0, 2096, 0, 607, 42, 101);
INSERT INTO public.who_global_data VALUES (9953, 337, 19571, 0, 381, 42, 165);
INSERT INTO public.who_global_data VALUES (9954, 94, 12880, 2, 341, 42, 14);
INSERT INTO public.who_global_data VALUES (9955, 238, 51595, 9, 2135, 43, 193);
INSERT INTO public.who_global_data VALUES (9956, 510, 54827, 8, 1125, 43, 113);
INSERT INTO public.who_global_data VALUES (9957, 458, 97007, 9, 2705, 43, 143);
INSERT INTO public.who_global_data VALUES (9958, 0, 0, 0, 0, 43, 219);
INSERT INTO public.who_global_data VALUES (9959, 30, 7699, 1, 83, 43, 186);
INSERT INTO public.who_global_data VALUES (9960, 98, 17029, 1, 395, 43, 52);
INSERT INTO public.who_global_data VALUES (9961, 0, 11, 0, 0, 43, 180);
INSERT INTO public.who_global_data VALUES (9962, 1, 154, 0, 5, 43, 167);
INSERT INTO public.who_global_data VALUES (9963, 8586, 1563865, 60, 42314, 43, 154);
INSERT INTO public.who_global_data VALUES (9964, 621, 156076, 19, 2728, 43, 94);
INSERT INTO public.who_global_data VALUES (9965, 29, 5228, 0, 47, 43, 66);
INSERT INTO public.who_global_data VALUES (9966, 24, 28262, 0, 908, 43, 58);
INSERT INTO public.who_global_data VALUES (9967, 2818, 345351, 61, 5672, 43, 163);
INSERT INTO public.who_global_data VALUES (9968, 1850, 210061, 40, 2380, 43, 37);
INSERT INTO public.who_global_data VALUES (9969, 10, 7788, 0, 169, 43, 142);
INSERT INTO public.who_global_data VALUES (9970, 253, 91070, 0, 350, 43, 83);
INSERT INTO public.who_global_data VALUES (9971, 1234, 506102, 19, 7378, 43, 228);
INSERT INTO public.who_global_data VALUES (9972, 2, 329, 0, 7, 43, 188);
INSERT INTO public.who_global_data VALUES (9973, 1917, 181113, 9, 1358, 43, 62);
INSERT INTO public.who_global_data VALUES (9974, 1783, 638087, 81, 19102, 43, 160);
INSERT INTO public.who_global_data VALUES (9975, 113, 10370, 0, 226, 43, 50);
INSERT INTO public.who_global_data VALUES (9976, 0, 3205, 0, 44, 43, 33);
INSERT INTO public.who_global_data VALUES (9977, 8, 561, 0, 9, 43, 183);
INSERT INTO public.who_global_data VALUES (9978, 22, 541, 0, 0, 43, 92);
INSERT INTO public.who_global_data VALUES (9979, 1005, 152064, 13, 9065, 43, 158);
INSERT INTO public.who_global_data VALUES (9980, 2, 158, 0, 3, 43, 67);
INSERT INTO public.who_global_data VALUES (9981, 728, 108298, 40, 3878, 43, 57);
INSERT INTO public.who_global_data VALUES (9982, 269, 13622, 0, 38, 43, 38);
INSERT INTO public.who_global_data VALUES (9983, 46696, 7365517, 961, 189220, 43, 141);
INSERT INTO public.who_global_data VALUES (9984, 7, 93, 0, 1, 43, 178);
INSERT INTO public.who_global_data VALUES (9985, 0, 152, 0, 3, 43, 108);
INSERT INTO public.who_global_data VALUES (9986, 772, 196658, 45, 7023, 43, 39);
INSERT INTO public.who_global_data VALUES (9987, 292, 5941, 0, 77, 43, 2);
INSERT INTO public.who_global_data VALUES (9988, 13, 786, 0, 2, 43, 195);
INSERT INTO public.who_global_data VALUES (9989, 0, 11668, 0, 112, 43, 107);
INSERT INTO public.who_global_data VALUES (9990, 0, 363, 0, 0, 43, 161);
INSERT INTO public.who_global_data VALUES (9991, 0, 25849, 0, 448, 43, 212);
INSERT INTO public.who_global_data VALUES (9992, 6845, 528354, 172, 14597, 43, 181);
INSERT INTO public.who_global_data VALUES (9993, 1, 317, 0, 2, 43, 53);
INSERT INTO public.who_global_data VALUES (9994, 0, 4948, 0, 63, 43, 164);
INSERT INTO public.who_global_data VALUES (9995, 42, 1958, 0, 102, 43, 140);
INSERT INTO public.who_global_data VALUES (9996, 2396, 593310, 75, 16303, 43, 20);
INSERT INTO public.who_global_data VALUES (9997, 85, 96159, 2, 4776, 43, 112);
INSERT INTO public.who_global_data VALUES (9998, 14233, 1544826, 242, 41173, 43, 111);
INSERT INTO public.who_global_data VALUES (9999, 17, 683, 0, 7, 43, 71);
INSERT INTO public.who_global_data VALUES (10000, 0, 6200, 0, 100, 43, 218);
INSERT INTO public.who_global_data VALUES (10001, 0, 0, 0, 0, 43, 43);
INSERT INTO public.who_global_data VALUES (10002, 1138, 161942, 14, 2065, 43, 49);
INSERT INTO public.who_global_data VALUES (10003, 0, 21984, 0, 133, 43, 1);
INSERT INTO public.who_global_data VALUES (10004, 1643, 203962, 84, 3548, 43, 48);
INSERT INTO public.who_global_data VALUES (10005, 0, 10500, 0, 139, 43, 232);
INSERT INTO public.who_global_data VALUES (10006, 45, 4051, 1, 12, 43, 175);
INSERT INTO public.who_global_data VALUES (10007, 433, 19316, 3, 107, 43, 21);
INSERT INTO public.who_global_data VALUES (10008, 4402, 664863, 83, 10859, 43, 156);
INSERT INTO public.who_global_data VALUES (10009, 0, 0, 0, 0, 43, 95);
INSERT INTO public.who_global_data VALUES (10010, 229, 16037, 0, 566, 43, 177);
INSERT INTO public.who_global_data VALUES (10011, 2869, 146341, 18, 1114, 43, 210);
INSERT INTO public.who_global_data VALUES (10012, 11, 5800, 0, 61, 43, 120);
INSERT INTO public.who_global_data VALUES (10013, 4, 96, 0, 0, 43, 135);
INSERT INTO public.who_global_data VALUES (10014, 1158, 163654, 3, 2404, 43, 206);
INSERT INTO public.who_global_data VALUES (10015, 926, 208010, 15, 13977, 43, 189);
INSERT INTO public.who_global_data VALUES (10016, 1021, 128993, 51, 7260, 43, 129);
INSERT INTO public.who_global_data VALUES (10017, 847, 44619, 9, 1283, 43, 121);
INSERT INTO public.who_global_data VALUES (10018, 0, 5231, 0, 85, 43, 59);
INSERT INTO public.who_global_data VALUES (10019, 78, 955, 0, 1, 43, 96);
INSERT INTO public.who_global_data VALUES (10020, 573, 24582, 7, 202, 43, 41);
INSERT INTO public.who_global_data VALUES (10021, 164, 8032, 1, 154, 43, 216);
INSERT INTO public.who_global_data VALUES (10022, 761, 121399, 18, 1882, 43, 236);
INSERT INTO public.who_global_data VALUES (10023, 0, 29, 0, 0, 43, 150);
INSERT INTO public.who_global_data VALUES (10024, 5, 561, 0, 0, 43, 61);
INSERT INTO public.who_global_data VALUES (10025, 0, 46, 0, 2, 43, 7);
INSERT INTO public.who_global_data VALUES (10026, 0, 34084, 0, 524, 43, 169);
INSERT INTO public.who_global_data VALUES (10027, 21496, 2484875, 290, 61892, 43, 28);
INSERT INTO public.who_global_data VALUES (10028, 138, 12685, 0, 71, 43, 85);
INSERT INTO public.who_global_data VALUES (10029, 84, 16550, 1, 108, 43, 211);
INSERT INTO public.who_global_data VALUES (10030, 0, 9469, 0, 64, 43, 60);
INSERT INTO public.who_global_data VALUES (10031, 0, 3791, 0, 123, 43, 3);
INSERT INTO public.who_global_data VALUES (10032, 1881, 218724, 37, 2313, 43, 11);
INSERT INTO public.who_global_data VALUES (10033, 25533, 1612648, 412, 29182, 43, 89);
INSERT INTO public.who_global_data VALUES (10034, 0, 54043, 0, 333, 43, 24);
INSERT INTO public.who_global_data VALUES (10035, 68, 1398, 0, 6, 43, 162);
INSERT INTO public.who_global_data VALUES (10036, 870, 134235, 55, 4457, 43, 100);
INSERT INTO public.who_global_data VALUES (10037, 2, 26, 0, 0, 43, 47);
INSERT INTO public.who_global_data VALUES (10038, 3, 112, 0, 0, 43, 29);
INSERT INTO public.who_global_data VALUES (10039, 0, 8557, 0, 155, 43, 40);
INSERT INTO public.who_global_data VALUES (10040, 7, 7091, 0, 121, 43, 222);
INSERT INTO public.who_global_data VALUES (10041, 638, 134894, 10, 4749, 43, 132);
INSERT INTO public.who_global_data VALUES (10042, 4, 297, 0, 13, 43, 130);
INSERT INTO public.who_global_data VALUES (10043, 0, 13630, 0, 80, 43, 234);
INSERT INTO public.who_global_data VALUES (10044, 0, 2447, 0, 45, 43, 23);
INSERT INTO public.who_global_data VALUES (10045, 42, 6258, 2, 162, 43, 192);
INSERT INTO public.who_global_data VALUES (10046, 41, 9846, 0, 235, 43, 69);
INSERT INTO public.who_global_data VALUES (10047, 0, 26, 0, 0, 43, 187);
INSERT INTO public.who_global_data VALUES (10048, 448, 118036, 8, 3054, 43, 230);
INSERT INTO public.who_global_data VALUES (10049, 2610, 314164, 104, 8833, 43, 77);
INSERT INTO public.who_global_data VALUES (10050, 0, 5683, 0, 28, 43, 9);
INSERT INTO public.who_global_data VALUES (10051, 23067, 10146845, 336, 147092, 43, 74);
INSERT INTO public.who_global_data VALUES (10052, 7199, 692838, 181, 20589, 43, 224);
INSERT INTO public.who_global_data VALUES (10053, 6178, 1183182, 152, 54308, 43, 199);
INSERT INTO public.who_global_data VALUES (10054, 1127, 588803, 7, 12744, 43, 190);
INSERT INTO public.who_global_data VALUES (10055, 918, 83073, 8, 2192, 43, 12);
INSERT INTO public.who_global_data VALUES (10056, 0, 374, 0, 25, 43, 104);
INSERT INTO public.who_global_data VALUES (10057, 4035, 388537, 25, 3176, 43, 153);
INSERT INTO public.who_global_data VALUES (10058, 18039, 2009317, 505, 70900, 43, 91);
INSERT INTO public.who_global_data VALUES (10059, 96, 12519, 2, 292, 43, 215);
INSERT INTO public.who_global_data VALUES (10060, 3841, 209980, 55, 3105, 43, 84);
INSERT INTO public.who_global_data VALUES (10061, 77, 2560, 1, 40, 43, 231);
INSERT INTO public.who_global_data VALUES (10062, 1707, 283690, 29, 3681, 43, 196);
INSERT INTO public.who_global_data VALUES (10063, 913, 196216, 0, 2669, 43, 105);
INSERT INTO public.who_global_data VALUES (10064, 663, 95431, 5, 1652, 43, 122);
INSERT INTO public.who_global_data VALUES (10065, 0, 0, 0, 0, 43, 159);
INSERT INTO public.who_global_data VALUES (10066, 309, 49843, 6, 1280, 43, 75);
INSERT INTO public.who_global_data VALUES (10067, 244, 149017, 2, 926, 43, 27);
INSERT INTO public.who_global_data VALUES (10068, 180, 80025, 0, 1340, 43, 54);
INSERT INTO public.who_global_data VALUES (10069, 0, 41, 0, 0, 43, 226);
INSERT INTO public.who_global_data VALUES (10070, 1270, 34754, 7, 486, 43, 79);
INSERT INTO public.who_global_data VALUES (10071, 2708, 165933, 20, 1353, 43, 56);
INSERT INTO public.who_global_data VALUES (10072, 292, 2577, 6, 50, 43, 117);
INSERT INTO public.who_global_data VALUES (10073, 0, 1798, 0, 83, 43, 152);
INSERT INTO public.who_global_data VALUES (10074, 846, 97192, 6, 1399, 43, 16);
INSERT INTO public.who_global_data VALUES (10075, 34, 2034, 1, 30, 43, 10);
INSERT INTO public.who_global_data VALUES (10076, 2688, 126588, 44, 1512, 43, 201);
INSERT INTO public.who_global_data VALUES (10077, 262, 45471, 3, 461, 43, 174);
INSERT INTO public.who_global_data VALUES (10078, 0, 17633, 0, 260, 43, 119);
INSERT INTO public.who_global_data VALUES (10079, 16, 6277, 0, 187, 43, 168);
INSERT INTO public.who_global_data VALUES (10080, 1581, 100318, 2, 446, 43, 99);
INSERT INTO public.who_global_data VALUES (10081, 21, 13558, 0, 48, 43, 171);
INSERT INTO public.who_global_data VALUES (10082, 0, 6291, 0, 225, 43, 87);
INSERT INTO public.who_global_data VALUES (10083, 70, 12062, 2, 203, 43, 123);
INSERT INTO public.who_global_data VALUES (10084, 0, 4, 0, 0, 43, 151);
INSERT INTO public.who_global_data VALUES (10085, 0, 5634, 0, 42, 43, 213);
INSERT INTO public.who_global_data VALUES (10086, 0, 10971, 0, 225, 43, 118);
INSERT INTO public.who_global_data VALUES (10087, 0, 524, 0, 10, 43, 134);
INSERT INTO public.who_global_data VALUES (10088, 0, 5767, 0, 54, 43, 65);
INSERT INTO public.who_global_data VALUES (10089, 11653, 1350079, 816, 120311, 43, 102);
INSERT INTO public.who_global_data VALUES (10090, 0, 0, 0, 0, 43, 223);
INSERT INTO public.who_global_data VALUES (10091, 16, 786, 0, 3, 43, 4);
INSERT INTO public.who_global_data VALUES (10092, 6, 1069, 0, 0, 43, 146);
INSERT INTO public.who_global_data VALUES (10093, 457, 46277, 4, 652, 43, 31);
INSERT INTO public.who_global_data VALUES (10094, 0, 13, 0, 1, 43, 127);
INSERT INTO public.who_global_data VALUES (10095, 2650, 425864, 44, 7130, 43, 22);
INSERT INTO public.who_global_data VALUES (10096, 75, 18031, 3, 156, 43, 115);
INSERT INTO public.who_global_data VALUES (10097, 923, 118869, 23, 2507, 43, 106);
INSERT INTO public.who_global_data VALUES (10098, 595, 20579, 4, 187, 43, 90);
INSERT INTO public.who_global_data VALUES (10099, 0, 0, 0, 0, 43, 70);
INSERT INTO public.who_global_data VALUES (10100, 613, 256592, 5, 1808, 43, 46);
INSERT INTO public.who_global_data VALUES (10101, 11502, 731482, 88, 10800, 43, 139);
INSERT INTO public.who_global_data VALUES (10102, 0, 38, 0, 0, 43, 42);
INSERT INTO public.who_global_data VALUES (10103, 0, 1772, 0, 25, 43, 80);
INSERT INTO public.who_global_data VALUES (10104, 0, 4790, 0, 164, 43, 203);
INSERT INTO public.who_global_data VALUES (10105, 0, 2803, 0, 89, 43, 136);
INSERT INTO public.who_global_data VALUES (10106, 0, 80922, 0, 1236, 43, 63);
INSERT INTO public.who_global_data VALUES (10107, 0, 0, 0, 0, 43, 17);
INSERT INTO public.who_global_data VALUES (10108, 4, 122, 0, 2, 43, 172);
INSERT INTO public.who_global_data VALUES (10109, 592, 80407, 21, 2375, 43, 109);
INSERT INTO public.who_global_data VALUES (10110, 0, 44932, 0, 421, 43, 200);
INSERT INTO public.who_global_data VALUES (10111, 1704, 145422, 17, 1364, 43, 93);
INSERT INTO public.who_global_data VALUES (10112, 54, 128290, 0, 1491, 43, 5);
INSERT INTO public.who_global_data VALUES (10113, 0, 745, 0, 13, 43, 214);
INSERT INTO public.who_global_data VALUES (10114, 2256, 465070, 111, 9668, 43, 204);
INSERT INTO public.who_global_data VALUES (10115, 0, 0, 0, 0, 43, 198);
INSERT INTO public.who_global_data VALUES (10116, 3059, 220261, 32, 3664, 43, 173);
INSERT INTO public.who_global_data VALUES (10117, 19, 780, 0, 9, 43, 229);
INSERT INTO public.who_global_data VALUES (10118, 827, 102371, 18, 2138, 43, 76);
INSERT INTO public.who_global_data VALUES (10119, 3829, 1003982, 99, 37317, 43, 138);
INSERT INTO public.who_global_data VALUES (10120, 1720, 465724, 7, 9055, 43, 98);
INSERT INTO public.who_global_data VALUES (10121, 0, 0, 0, 0, 43, 103);
INSERT INTO public.who_global_data VALUES (10122, 9081, 1249079, 240, 26992, 43, 225);
INSERT INTO public.who_global_data VALUES (10123, 4378, 387636, 70, 6413, 43, 131);
INSERT INTO public.who_global_data VALUES (10124, 320, 70808, 15, 1423, 43, 235);
INSERT INTO public.who_global_data VALUES (10125, 157, 142605, 0, 243, 43, 137);
INSERT INTO public.who_global_data VALUES (10126, 1235, 54757, 17, 773, 43, 81);
INSERT INTO public.who_global_data VALUES (10127, 1222, 139435, 23, 2848, 43, 182);
INSERT INTO public.who_global_data VALUES (10128, 0, 8846, 0, 42, 43, 145);
INSERT INTO public.who_global_data VALUES (10129, 4310, 608561, 146, 14912, 43, 26);
INSERT INTO public.who_global_data VALUES (10130, 29018, 2992706, 563, 53659, 43, 170);
INSERT INTO public.who_global_data VALUES (10131, 0, 7511, 0, 66, 43, 191);
INSERT INTO public.who_global_data VALUES (10132, 0, 5, 0, 0, 43, 221);
INSERT INTO public.who_global_data VALUES (10133, 0, 182, 0, 0, 43, 64);
INSERT INTO public.who_global_data VALUES (10134, 0, 0, 0, 0, 43, 116);
INSERT INTO public.who_global_data VALUES (10135, 0, 30, 0, 0, 43, 128);
INSERT INTO public.who_global_data VALUES (10136, 0, 305, 0, 5, 43, 6);
INSERT INTO public.who_global_data VALUES (10137, 0, 948, 0, 12, 43, 227);
INSERT INTO public.who_global_data VALUES (10138, 0, 15, 0, 0, 43, 68);
INSERT INTO public.who_global_data VALUES (10139, 0, 108, 0, 0, 43, 184);
INSERT INTO public.who_global_data VALUES (10140, 0, 2, 0, 0, 43, 82);
INSERT INTO public.who_global_data VALUES (10141, 25, 2231, 0, 56, 43, 149);
INSERT INTO public.who_global_data VALUES (10142, 0, 1012, 0, 17, 43, 197);
INSERT INTO public.who_global_data VALUES (10143, 189, 361725, 11, 6159, 43, 78);
INSERT INTO public.who_global_data VALUES (10144, 157, 18200, 3, 381, 43, 233);
INSERT INTO public.who_global_data VALUES (10145, 4091, 316344, 49, 2882, 43, 133);
INSERT INTO public.who_global_data VALUES (10146, 0, 211, 0, 0, 43, 35);
INSERT INTO public.who_global_data VALUES (10147, 0, 2497, 0, 75, 43, 114);
INSERT INTO public.who_global_data VALUES (10148, 13, 58495, 0, 29, 43, 237);
INSERT INTO public.who_global_data VALUES (10149, 0, 19, 0, 0, 43, 55);
INSERT INTO public.who_global_data VALUES (10150, 8, 1370, 0, 26, 43, 176);
INSERT INTO public.who_global_data VALUES (10151, 4046, 165608, 0, 1732, 43, 202);
INSERT INTO public.who_global_data VALUES (10152, 1809, 113886, 35, 2767, 43, 155);
INSERT INTO public.who_global_data VALUES (10153, 0, 17, 0, 0, 43, 32);
INSERT INTO public.who_global_data VALUES (10154, 0, 4690, 0, 127, 43, 220);
INSERT INTO public.who_global_data VALUES (10155, 14305, 968563, 326, 25983, 43, 30);
INSERT INTO public.who_global_data VALUES (10156, 32, 3308, 0, 62, 43, 147);
INSERT INTO public.who_global_data VALUES (10157, 14734, 1923147, 149, 50804, 43, 208);
INSERT INTO public.who_global_data VALUES (10158, 0, 38639, 0, 184, 43, 45);
INSERT INTO public.who_global_data VALUES (10159, 283, 24341, 10, 1507, 43, 110);
INSERT INTO public.who_global_data VALUES (10160, 65, 5734, 0, 118, 43, 88);
INSERT INTO public.who_global_data VALUES (10161, 11376, 407342, 87, 9072, 43, 51);
INSERT INTO public.who_global_data VALUES (10162, 3048, 431228, 88, 6781, 43, 209);
INSERT INTO public.who_global_data VALUES (10163, 130, 10701, 11, 652, 43, 205);
INSERT INTO public.who_global_data VALUES (10164, 36, 13475, 0, 89, 43, 18);
INSERT INTO public.who_global_data VALUES (10165, 0, 5829, 0, 60, 43, 72);
INSERT INTO public.who_global_data VALUES (10166, 39036, 2188591, 574, 69625, 43, 44);
INSERT INTO public.who_global_data VALUES (10167, 5, 41, 0, 0, 43, 15);
INSERT INTO public.who_global_data VALUES (10168, 0, 3467, 0, 66, 43, 25);
INSERT INTO public.who_global_data VALUES (10169, 0, 0, 0, 0, 43, 179);
INSERT INTO public.who_global_data VALUES (10170, 0, 0, 0, 0, 43, 34);
INSERT INTO public.who_global_data VALUES (10171, 47, 7071, 0, 125, 43, 207);
INSERT INTO public.who_global_data VALUES (10172, 1752, 126752, 49, 4324, 43, 166);
INSERT INTO public.who_global_data VALUES (10173, 18102, 2100712, 254, 19115, 43, 126);
INSERT INTO public.who_global_data VALUES (10174, 0, 0, 0, 0, 43, 97);
INSERT INTO public.who_global_data VALUES (10175, 3, 810, 0, 6, 43, 36);
INSERT INTO public.who_global_data VALUES (10176, 0, 0, 0, 0, 43, 125);
INSERT INTO public.who_global_data VALUES (10177, 515, 32914, 0, 245, 43, 124);
INSERT INTO public.who_global_data VALUES (10178, 11035, 1012167, 186, 17581, 43, 185);
INSERT INTO public.who_global_data VALUES (10179, 1311, 198435, 2, 647, 43, 194);
INSERT INTO public.who_global_data VALUES (10180, 0, 509, 0, 21, 43, 144);
INSERT INTO public.who_global_data VALUES (10181, 221145, 18311405, 3347, 323527, 43, 19);
INSERT INTO public.who_global_data VALUES (10182, 17, 1967, 0, 23, 43, 217);
INSERT INTO public.who_global_data VALUES (10183, 709, 14710, 8, 128, 43, 148);
INSERT INTO public.who_global_data VALUES (10184, 112, 76568, 0, 612, 43, 86);
INSERT INTO public.who_global_data VALUES (10185, 0, 1, 0, 0, 43, 13);
INSERT INTO public.who_global_data VALUES (10186, 196, 111024, 5, 1002, 43, 157);
INSERT INTO public.who_global_data VALUES (10187, 12, 1433, 0, 35, 43, 8);
INSERT INTO public.who_global_data VALUES (10188, 0, 4, 0, 0, 43, 73);
INSERT INTO public.who_global_data VALUES (10189, 1, 2096, 0, 607, 43, 101);
INSERT INTO public.who_global_data VALUES (10190, 353, 19234, 2, 381, 43, 165);
INSERT INTO public.who_global_data VALUES (10191, 242, 12786, 13, 339, 43, 14);
INSERT INTO public.who_global_data VALUES (10192, 287, 51357, 21, 2126, 44, 193);
INSERT INTO public.who_global_data VALUES (10193, 503, 54317, 6, 1117, 44, 113);
INSERT INTO public.who_global_data VALUES (10194, 480, 96549, 9, 2696, 44, 143);
INSERT INTO public.who_global_data VALUES (10195, 0, 0, 0, 0, 44, 219);
INSERT INTO public.who_global_data VALUES (10196, 36, 7669, 0, 82, 44, 186);
INSERT INTO public.who_global_data VALUES (10197, 129, 16931, 1, 394, 44, 52);
INSERT INTO public.who_global_data VALUES (10198, 1, 11, 0, 0, 44, 180);
INSERT INTO public.who_global_data VALUES (10199, 0, 153, 0, 5, 44, 167);
INSERT INTO public.who_global_data VALUES (10200, 8141, 1555279, 257, 42254, 44, 154);
INSERT INTO public.who_global_data VALUES (10201, 702, 155455, 23, 2709, 44, 94);
INSERT INTO public.who_global_data VALUES (10202, 23, 5199, 0, 47, 44, 66);
INSERT INTO public.who_global_data VALUES (10203, 19, 28238, 0, 908, 44, 58);
INSERT INTO public.who_global_data VALUES (10204, 2600, 342533, 141, 5611, 44, 163);
INSERT INTO public.who_global_data VALUES (10205, 2334, 208211, 46, 2340, 44, 37);
INSERT INTO public.who_global_data VALUES (10206, 6, 7778, 0, 169, 44, 142);
INSERT INTO public.who_global_data VALUES (10207, 183, 90817, 0, 350, 44, 83);
INSERT INTO public.who_global_data VALUES (10208, 1367, 504868, 30, 7359, 44, 228);
INSERT INTO public.who_global_data VALUES (10209, 5, 327, 0, 7, 44, 188);
INSERT INTO public.who_global_data VALUES (10210, 1922, 179196, 8, 1349, 44, 62);
INSERT INTO public.who_global_data VALUES (10211, 2462, 636304, 92, 19021, 44, 160);
INSERT INTO public.who_global_data VALUES (10212, 112, 10257, 2, 226, 44, 50);
INSERT INTO public.who_global_data VALUES (10213, 0, 3205, 0, 44, 44, 33);
INSERT INTO public.who_global_data VALUES (10214, 6, 553, 0, 9, 44, 183);
INSERT INTO public.who_global_data VALUES (10215, 37, 519, 0, 0, 44, 92);
INSERT INTO public.who_global_data VALUES (10216, 674, 151059, 9, 9052, 44, 158);
INSERT INTO public.who_global_data VALUES (10217, 1, 156, 0, 3, 44, 67);
INSERT INTO public.who_global_data VALUES (10218, 584, 107570, 46, 3838, 44, 57);
INSERT INTO public.who_global_data VALUES (10219, 0, 13353, 0, 38, 44, 38);
INSERT INTO public.who_global_data VALUES (10220, 55202, 7318821, 968, 188259, 44, 141);
INSERT INTO public.who_global_data VALUES (10221, 0, 86, 0, 1, 44, 178);
INSERT INTO public.who_global_data VALUES (10222, 0, 152, 0, 3, 44, 108);
INSERT INTO public.who_global_data VALUES (10223, 1615, 195886, 99, 6978, 44, 39);
INSERT INTO public.who_global_data VALUES (10224, 188, 5649, 0, 77, 44, 2);
INSERT INTO public.who_global_data VALUES (10225, 0, 773, 0, 2, 44, 195);
INSERT INTO public.who_global_data VALUES (10226, 32, 11668, 0, 112, 44, 107);
INSERT INTO public.who_global_data VALUES (10227, 0, 363, 0, 0, 44, 161);
INSERT INTO public.who_global_data VALUES (10228, 0, 25849, 0, 448, 44, 212);
INSERT INTO public.who_global_data VALUES (10229, 6195, 521509, 93, 14425, 44, 181);
INSERT INTO public.who_global_data VALUES (10230, 0, 316, 0, 2, 44, 53);
INSERT INTO public.who_global_data VALUES (10231, 0, 4948, 0, 63, 44, 164);
INSERT INTO public.who_global_data VALUES (10232, 0, 1916, 0, 102, 44, 140);
INSERT INTO public.who_global_data VALUES (10233, 1725, 590914, 11, 16228, 44, 20);
INSERT INTO public.who_global_data VALUES (10234, 76, 96074, 1, 4774, 44, 112);
INSERT INTO public.who_global_data VALUES (10235, 12526, 1530593, 251, 40931, 44, 111);
INSERT INTO public.who_global_data VALUES (10236, 0, 666, 0, 7, 44, 71);
INSERT INTO public.who_global_data VALUES (10237, 0, 6200, 0, 100, 44, 218);
INSERT INTO public.who_global_data VALUES (10238, 0, 0, 0, 0, 44, 43);
INSERT INTO public.who_global_data VALUES (10239, 911, 160804, 14, 2051, 44, 49);
INSERT INTO public.who_global_data VALUES (10240, 52, 21984, 0, 133, 44, 1);
INSERT INTO public.who_global_data VALUES (10241, 2233, 202319, 70, 3464, 44, 48);
INSERT INTO public.who_global_data VALUES (10242, 116, 10500, 0, 139, 44, 232);
INSERT INTO public.who_global_data VALUES (10243, 32, 4006, 0, 11, 44, 175);
INSERT INTO public.who_global_data VALUES (10244, 477, 18883, 3, 104, 44, 21);
INSERT INTO public.who_global_data VALUES (10245, 14149, 660461, 112, 10776, 44, 156);
INSERT INTO public.who_global_data VALUES (10246, 0, 0, 0, 0, 44, 95);
INSERT INTO public.who_global_data VALUES (10247, 141, 15808, 0, 566, 44, 177);
INSERT INTO public.who_global_data VALUES (10248, 3297, 143472, 26, 1096, 44, 210);
INSERT INTO public.who_global_data VALUES (10249, 3, 5789, 0, 61, 44, 120);
INSERT INTO public.who_global_data VALUES (10250, 0, 92, 0, 0, 44, 135);
INSERT INTO public.who_global_data VALUES (10251, 566, 162496, 3, 2401, 44, 206);
INSERT INTO public.who_global_data VALUES (10252, 720, 207084, 13, 13962, 44, 189);
INSERT INTO public.who_global_data VALUES (10253, 911, 127972, 42, 7209, 44, 129);
INSERT INTO public.who_global_data VALUES (10254, 0, 43772, 9, 1274, 44, 121);
INSERT INTO public.who_global_data VALUES (10255, 0, 5231, 0, 85, 44, 59);
INSERT INTO public.who_global_data VALUES (10256, 45, 877, 0, 1, 44, 96);
INSERT INTO public.who_global_data VALUES (10257, 700, 24009, 3, 195, 44, 41);
INSERT INTO public.who_global_data VALUES (10258, 153, 7868, 11, 153, 44, 216);
INSERT INTO public.who_global_data VALUES (10259, 0, 120638, 0, 1864, 44, 236);
INSERT INTO public.who_global_data VALUES (10260, 6, 29, 0, 0, 44, 150);
INSERT INTO public.who_global_data VALUES (10261, 6, 556, 0, 0, 44, 61);
INSERT INTO public.who_global_data VALUES (10262, 0, 46, 0, 2, 44, 7);
INSERT INTO public.who_global_data VALUES (10263, 367, 34084, 13, 524, 44, 169);
INSERT INTO public.who_global_data VALUES (10264, 14836, 2463379, 276, 61602, 44, 28);
INSERT INTO public.who_global_data VALUES (10265, 48, 12547, 0, 71, 44, 85);
INSERT INTO public.who_global_data VALUES (10266, 56, 16466, 1, 107, 44, 211);
INSERT INTO public.who_global_data VALUES (10267, 49, 9469, 0, 64, 44, 60);
INSERT INTO public.who_global_data VALUES (10268, 0, 3791, 0, 123, 44, 3);
INSERT INTO public.who_global_data VALUES (10269, 1972, 216843, 43, 2276, 44, 11);
INSERT INTO public.who_global_data VALUES (10270, 32195, 1587115, 802, 28770, 44, 89);
INSERT INTO public.who_global_data VALUES (10271, 89, 54043, 0, 333, 44, 24);
INSERT INTO public.who_global_data VALUES (10272, 48, 1330, 0, 6, 44, 162);
INSERT INTO public.who_global_data VALUES (10273, 935, 133365, 62, 4402, 44, 100);
INSERT INTO public.who_global_data VALUES (10274, 0, 24, 0, 0, 44, 47);
INSERT INTO public.who_global_data VALUES (10275, 2, 109, 0, 0, 44, 29);
INSERT INTO public.who_global_data VALUES (10276, 0, 8557, 0, 155, 44, 40);
INSERT INTO public.who_global_data VALUES (10277, 18, 7084, 0, 121, 44, 222);
INSERT INTO public.who_global_data VALUES (10278, 655, 134256, 21, 4739, 44, 132);
INSERT INTO public.who_global_data VALUES (10279, 0, 293, 0, 13, 44, 130);
INSERT INTO public.who_global_data VALUES (10280, 52, 13630, 0, 80, 44, 234);
INSERT INTO public.who_global_data VALUES (10281, 0, 2447, 1, 45, 44, 23);
INSERT INTO public.who_global_data VALUES (10282, 45, 6216, 1, 160, 44, 192);
INSERT INTO public.who_global_data VALUES (10283, 34, 9805, 0, 235, 44, 69);
INSERT INTO public.who_global_data VALUES (10284, 0, 26, 0, 0, 44, 187);
INSERT INTO public.who_global_data VALUES (10285, 398, 117588, 12, 3046, 44, 230);
INSERT INTO public.who_global_data VALUES (10286, 3292, 311554, 113, 8729, 44, 77);
INSERT INTO public.who_global_data VALUES (10287, 16, 5683, 0, 28, 44, 9);
INSERT INTO public.who_global_data VALUES (10288, 24712, 10123778, 312, 146756, 44, 74);
INSERT INTO public.who_global_data VALUES (10289, 7514, 685639, 151, 20408, 44, 224);
INSERT INTO public.who_global_data VALUES (10290, 6261, 1177004, 153, 54156, 44, 199);
INSERT INTO public.who_global_data VALUES (10291, 1173, 587676, 12, 12737, 44, 190);
INSERT INTO public.who_global_data VALUES (10292, 927, 82155, 13, 2184, 44, 12);
INSERT INTO public.who_global_data VALUES (10293, 0, 374, 0, 25, 44, 104);
INSERT INTO public.who_global_data VALUES (10294, 4376, 384502, 13, 3151, 44, 153);
INSERT INTO public.who_global_data VALUES (10295, 13908, 1991278, 553, 70395, 44, 91);
INSERT INTO public.who_global_data VALUES (10296, 69, 12423, 2, 290, 44, 215);
INSERT INTO public.who_global_data VALUES (10297, 3026, 206139, 56, 3050, 44, 84);
INSERT INTO public.who_global_data VALUES (10298, 38, 2483, 1, 39, 44, 231);
INSERT INTO public.who_global_data VALUES (10299, 2091, 281983, 25, 3652, 44, 196);
INSERT INTO public.who_global_data VALUES (10300, 890, 195303, 0, 2669, 44, 105);
INSERT INTO public.who_global_data VALUES (10301, 0, 94768, 0, 1647, 44, 122);
INSERT INTO public.who_global_data VALUES (10302, 0, 0, 0, 0, 44, 159);
INSERT INTO public.who_global_data VALUES (10303, 271, 49534, 12, 1274, 44, 75);
INSERT INTO public.who_global_data VALUES (10304, 266, 148773, 1, 924, 44, 27);
INSERT INTO public.who_global_data VALUES (10305, 186, 79845, 3, 1340, 44, 54);
INSERT INTO public.who_global_data VALUES (10306, 0, 41, 0, 0, 44, 226);
INSERT INTO public.who_global_data VALUES (10307, 1145, 33484, 20, 479, 44, 79);
INSERT INTO public.who_global_data VALUES (10308, 2246, 163225, 22, 1333, 44, 56);
INSERT INTO public.who_global_data VALUES (10309, 0, 2285, 0, 44, 44, 117);
INSERT INTO public.who_global_data VALUES (10310, 0, 1798, 0, 83, 44, 152);
INSERT INTO public.who_global_data VALUES (10311, 640, 96346, 8, 1393, 44, 16);
INSERT INTO public.who_global_data VALUES (10312, 50, 2000, 0, 29, 44, 10);
INSERT INTO public.who_global_data VALUES (10313, 3806, 123900, 36, 1468, 44, 201);
INSERT INTO public.who_global_data VALUES (10314, 400, 45209, 5, 458, 44, 174);
INSERT INTO public.who_global_data VALUES (10315, 0, 17633, 0, 260, 44, 119);
INSERT INTO public.who_global_data VALUES (10316, 13, 6261, 0, 187, 44, 168);
INSERT INTO public.who_global_data VALUES (10317, 1348, 98737, 5, 444, 44, 99);
INSERT INTO public.who_global_data VALUES (10318, 13, 13537, 0, 48, 44, 171);
INSERT INTO public.who_global_data VALUES (10319, 0, 6291, 0, 225, 44, 87);
INSERT INTO public.who_global_data VALUES (10320, 82, 11992, 5, 201, 44, 123);
INSERT INTO public.who_global_data VALUES (10321, 0, 4, 0, 0, 44, 151);
INSERT INTO public.who_global_data VALUES (10322, 0, 5634, 0, 42, 44, 213);
INSERT INTO public.who_global_data VALUES (10323, 0, 10971, 0, 225, 44, 118);
INSERT INTO public.who_global_data VALUES (10324, 0, 524, 0, 10, 44, 134);
INSERT INTO public.who_global_data VALUES (10325, 0, 5767, 0, 54, 44, 65);
INSERT INTO public.who_global_data VALUES (10326, 12511, 1338426, 897, 119495, 44, 102);
INSERT INTO public.who_global_data VALUES (10327, 0, 0, 0, 0, 44, 223);
INSERT INTO public.who_global_data VALUES (10328, 11, 770, 0, 3, 44, 4);
INSERT INTO public.who_global_data VALUES (10329, 57, 1063, 0, 0, 44, 146);
INSERT INTO public.who_global_data VALUES (10330, 440, 45820, 9, 648, 44, 31);
INSERT INTO public.who_global_data VALUES (10331, 0, 13, 0, 1, 44, 127);
INSERT INTO public.who_global_data VALUES (10332, 2566, 423214, 56, 7086, 44, 22);
INSERT INTO public.who_global_data VALUES (10333, 189, 17956, 3, 153, 44, 115);
INSERT INTO public.who_global_data VALUES (10334, 964, 117946, 19, 2484, 44, 106);
INSERT INTO public.who_global_data VALUES (10335, 355, 19984, 2, 183, 44, 90);
INSERT INTO public.who_global_data VALUES (10336, 0, 0, 0, 0, 44, 70);
INSERT INTO public.who_global_data VALUES (10337, 743, 255979, 5, 1803, 44, 46);
INSERT INTO public.who_global_data VALUES (10338, 10401, 719980, 105, 10712, 44, 139);
INSERT INTO public.who_global_data VALUES (10339, 0, 38, 0, 0, 44, 42);
INSERT INTO public.who_global_data VALUES (10340, 0, 1772, 0, 25, 44, 80);
INSERT INTO public.who_global_data VALUES (10341, 0, 4790, 0, 164, 44, 203);
INSERT INTO public.who_global_data VALUES (10342, 442, 2803, 7, 89, 44, 136);
INSERT INTO public.who_global_data VALUES (10343, 1133, 80922, 5, 1236, 44, 63);
INSERT INTO public.who_global_data VALUES (10344, 0, 0, 0, 0, 44, 17);
INSERT INTO public.who_global_data VALUES (10345, 0, 118, 0, 2, 44, 172);
INSERT INTO public.who_global_data VALUES (10346, 625, 79815, 14, 2354, 44, 109);
INSERT INTO public.who_global_data VALUES (10347, 596, 44932, 16, 421, 44, 200);
INSERT INTO public.who_global_data VALUES (10348, 2110, 143718, 31, 1347, 44, 93);
INSERT INTO public.who_global_data VALUES (10349, 93, 128236, 1, 1491, 44, 5);
INSERT INTO public.who_global_data VALUES (10350, 1, 745, 0, 13, 44, 214);
INSERT INTO public.who_global_data VALUES (10351, 2142, 462814, 83, 9557, 44, 204);
INSERT INTO public.who_global_data VALUES (10352, 0, 0, 0, 0, 44, 198);
INSERT INTO public.who_global_data VALUES (10353, 3164, 217202, 35, 3632, 44, 173);
INSERT INTO public.who_global_data VALUES (10354, 0, 761, 0, 9, 44, 229);
INSERT INTO public.who_global_data VALUES (10355, 932, 101544, 17, 2120, 44, 76);
INSERT INTO public.who_global_data VALUES (10356, 1678, 1000153, 45, 37218, 44, 138);
INSERT INTO public.who_global_data VALUES (10357, 1189, 464004, 27, 9048, 44, 98);
INSERT INTO public.who_global_data VALUES (10358, 0, 0, 0, 0, 44, 103);
INSERT INTO public.who_global_data VALUES (10359, 13115, 1239998, 497, 26752, 44, 225);
INSERT INTO public.who_global_data VALUES (10360, 4602, 383258, 89, 6343, 44, 131);
INSERT INTO public.who_global_data VALUES (10361, 576, 70488, 17, 1408, 44, 235);
INSERT INTO public.who_global_data VALUES (10362, 140, 142448, 0, 243, 44, 137);
INSERT INTO public.who_global_data VALUES (10363, 985, 53522, 17, 756, 44, 81);
INSERT INTO public.who_global_data VALUES (10364, 1282, 138213, 22, 2825, 44, 182);
INSERT INTO public.who_global_data VALUES (10365, 45, 8846, 0, 42, 44, 145);
INSERT INTO public.who_global_data VALUES (10366, 5459, 604251, 130, 14766, 44, 26);
INSERT INTO public.who_global_data VALUES (10367, 29935, 2963688, 635, 53096, 44, 170);
INSERT INTO public.who_global_data VALUES (10368, 0, 7511, 0, 66, 44, 191);
INSERT INTO public.who_global_data VALUES (10369, 0, 5, 0, 0, 44, 221);
INSERT INTO public.who_global_data VALUES (10370, 0, 182, 0, 0, 44, 64);
INSERT INTO public.who_global_data VALUES (10371, 0, 0, 0, 0, 44, 116);
INSERT INTO public.who_global_data VALUES (10372, 0, 30, 0, 0, 44, 128);
INSERT INTO public.who_global_data VALUES (10373, 2, 305, 0, 5, 44, 6);
INSERT INTO public.who_global_data VALUES (10374, 0, 948, 0, 12, 44, 227);
INSERT INTO public.who_global_data VALUES (10375, 0, 15, 0, 0, 44, 68);
INSERT INTO public.who_global_data VALUES (10376, 1, 108, 0, 0, 44, 184);
INSERT INTO public.who_global_data VALUES (10377, 0, 2, 0, 0, 44, 82);
INSERT INTO public.who_global_data VALUES (10378, 71, 2206, 1, 56, 44, 149);
INSERT INTO public.who_global_data VALUES (10379, 0, 1012, 0, 17, 44, 197);
INSERT INTO public.who_global_data VALUES (10380, 177, 361536, 9, 6148, 44, 78);
INSERT INTO public.who_global_data VALUES (10381, 98, 18043, 6, 378, 44, 233);
INSERT INTO public.who_global_data VALUES (10382, 4426, 312253, 51, 2833, 44, 133);
INSERT INTO public.who_global_data VALUES (10383, 0, 211, 0, 0, 44, 35);
INSERT INTO public.who_global_data VALUES (10384, 0, 2497, 0, 75, 44, 114);
INSERT INTO public.who_global_data VALUES (10385, 21, 58482, 0, 29, 44, 237);
INSERT INTO public.who_global_data VALUES (10386, 0, 19, 0, 0, 44, 55);
INSERT INTO public.who_global_data VALUES (10387, 24, 1362, 0, 26, 44, 176);
INSERT INTO public.who_global_data VALUES (10388, 2657, 161562, 46, 1732, 44, 202);
INSERT INTO public.who_global_data VALUES (10389, 2064, 112077, 32, 2732, 44, 155);
INSERT INTO public.who_global_data VALUES (10390, 0, 17, 0, 0, 44, 32);
INSERT INTO public.who_global_data VALUES (10391, 0, 4690, 0, 127, 44, 220);
INSERT INTO public.who_global_data VALUES (10392, 14046, 954258, 411, 25657, 44, 30);
INSERT INTO public.who_global_data VALUES (10393, 0, 3276, 0, 62, 44, 147);
INSERT INTO public.who_global_data VALUES (10394, 13833, 1908413, 147, 50655, 44, 208);
INSERT INTO public.who_global_data VALUES (10395, 580, 38639, 1, 184, 44, 45);
INSERT INTO public.who_global_data VALUES (10396, 212, 24058, 5, 1497, 44, 110);
INSERT INTO public.who_global_data VALUES (10397, 86, 5669, 0, 118, 44, 88);
INSERT INTO public.who_global_data VALUES (10398, 6597, 395966, 92, 8985, 44, 51);
INSERT INTO public.who_global_data VALUES (10399, 4474, 428180, 79, 6693, 44, 209);
INSERT INTO public.who_global_data VALUES (10400, 129, 10571, 11, 641, 44, 205);
INSERT INTO public.who_global_data VALUES (10401, 51, 13439, 0, 89, 44, 18);
INSERT INTO public.who_global_data VALUES (10402, 67, 5829, 0, 60, 44, 72);
INSERT INTO public.who_global_data VALUES (10403, 39237, 2149555, 744, 69051, 44, 44);
INSERT INTO public.who_global_data VALUES (10404, 3, 36, 0, 0, 44, 15);
INSERT INTO public.who_global_data VALUES (10405, 0, 3467, 0, 66, 44, 25);
INSERT INTO public.who_global_data VALUES (10406, 0, 0, 0, 0, 44, 179);
INSERT INTO public.who_global_data VALUES (10407, 0, 0, 0, 0, 44, 34);
INSERT INTO public.who_global_data VALUES (10408, 12, 7024, 0, 125, 44, 207);
INSERT INTO public.who_global_data VALUES (10409, 1677, 125000, 38, 4275, 44, 166);
INSERT INTO public.who_global_data VALUES (10410, 19650, 2082610, 259, 18861, 44, 126);
INSERT INTO public.who_global_data VALUES (10411, 0, 0, 0, 0, 44, 97);
INSERT INTO public.who_global_data VALUES (10412, 9, 807, 0, 6, 44, 36);
INSERT INTO public.who_global_data VALUES (10413, 0, 0, 0, 0, 44, 125);
INSERT INTO public.who_global_data VALUES (10414, 489, 32399, 7, 245, 44, 124);
INSERT INTO public.who_global_data VALUES (10415, 11490, 1001132, 223, 17395, 44, 185);
INSERT INTO public.who_global_data VALUES (10416, 1246, 197124, 3, 645, 44, 194);
INSERT INTO public.who_global_data VALUES (10417, 0, 509, 0, 21, 44, 144);
INSERT INTO public.who_global_data VALUES (10418, 195151, 18090260, 3148, 320180, 44, 19);
INSERT INTO public.who_global_data VALUES (10419, 16, 1950, 0, 23, 44, 217);
INSERT INTO public.who_global_data VALUES (10420, 524, 14001, 1, 120, 44, 148);
INSERT INTO public.who_global_data VALUES (10421, 141, 76456, 0, 612, 44, 86);
INSERT INTO public.who_global_data VALUES (10422, 0, 1, 0, 0, 44, 13);
INSERT INTO public.who_global_data VALUES (10423, 315, 110828, 4, 997, 44, 157);
INSERT INTO public.who_global_data VALUES (10424, 1, 1421, 0, 35, 44, 8);
INSERT INTO public.who_global_data VALUES (10425, 0, 4, 0, 0, 44, 73);
INSERT INTO public.who_global_data VALUES (10426, 1, 2095, 0, 607, 44, 101);
INSERT INTO public.who_global_data VALUES (10427, 0, 18881, 0, 379, 44, 165);
INSERT INTO public.who_global_data VALUES (10428, 0, 12544, 0, 326, 44, 14);
INSERT INTO public.who_global_data VALUES (10429, 182, 51070, 16, 2105, 45, 193);
INSERT INTO public.who_global_data VALUES (10430, 389, 53814, 13, 1111, 45, 113);
INSERT INTO public.who_global_data VALUES (10431, 410, 96069, 12, 2687, 45, 143);
INSERT INTO public.who_global_data VALUES (10432, 0, 0, 0, 0, 45, 219);
INSERT INTO public.who_global_data VALUES (10433, 31, 7633, 1, 82, 45, 186);
INSERT INTO public.who_global_data VALUES (10434, 116, 16802, 3, 393, 45, 52);
INSERT INTO public.who_global_data VALUES (10435, 0, 10, 0, 0, 45, 180);
INSERT INTO public.who_global_data VALUES (10436, 0, 153, 0, 5, 45, 167);
INSERT INTO public.who_global_data VALUES (10437, 5853, 1547138, 184, 41997, 45, 154);
INSERT INTO public.who_global_data VALUES (10438, 838, 154753, 18, 2686, 45, 94);
INSERT INTO public.who_global_data VALUES (10439, 13, 5176, 0, 47, 45, 66);
INSERT INTO public.who_global_data VALUES (10440, 21, 28219, 0, 908, 45, 58);
INSERT INTO public.who_global_data VALUES (10441, 2493, 339933, 114, 5470, 45, 163);
INSERT INTO public.who_global_data VALUES (10442, 2284, 205877, 41, 2294, 45, 37);
INSERT INTO public.who_global_data VALUES (10443, 4, 7772, 5, 169, 45, 142);
INSERT INTO public.who_global_data VALUES (10444, 184, 90634, 0, 350, 45, 83);
INSERT INTO public.who_global_data VALUES (10445, 1318, 503501, 17, 7329, 45, 228);
INSERT INTO public.who_global_data VALUES (10446, 1, 322, 0, 7, 45, 188);
INSERT INTO public.who_global_data VALUES (10447, 1858, 177274, 8, 1341, 45, 62);
INSERT INTO public.who_global_data VALUES (10448, 2707, 633842, 102, 18929, 45, 160);
INSERT INTO public.who_global_data VALUES (10449, 50, 10145, 4, 224, 45, 50);
INSERT INTO public.who_global_data VALUES (10450, 38, 3205, 0, 44, 45, 33);
INSERT INTO public.who_global_data VALUES (10451, 20, 547, 0, 9, 45, 183);
INSERT INTO public.who_global_data VALUES (10452, 3, 482, 0, 0, 45, 92);
INSERT INTO public.who_global_data VALUES (10453, 362, 150385, 7, 9043, 45, 158);
INSERT INTO public.who_global_data VALUES (10454, 0, 155, 0, 3, 45, 67);
INSERT INTO public.who_global_data VALUES (10455, 764, 106986, 86, 3792, 45, 57);
INSERT INTO public.who_global_data VALUES (10456, 0, 13353, 0, 38, 45, 38);
INSERT INTO public.who_global_data VALUES (10457, 25019, 7263619, 527, 187291, 45, 141);
INSERT INTO public.who_global_data VALUES (10458, 0, 86, 0, 1, 45, 178);
INSERT INTO public.who_global_data VALUES (10459, 0, 152, 0, 3, 45, 108);
INSERT INTO public.who_global_data VALUES (10460, 1799, 194271, 114, 6879, 45, 39);
INSERT INTO public.who_global_data VALUES (10461, 160, 5461, 1, 77, 45, 2);
INSERT INTO public.who_global_data VALUES (10462, 11, 773, 0, 2, 45, 195);
INSERT INTO public.who_global_data VALUES (10463, 36, 11636, 1, 112, 45, 107);
INSERT INTO public.who_global_data VALUES (10464, 0, 363, 0, 0, 45, 161);
INSERT INTO public.who_global_data VALUES (10465, 0, 25849, 0, 448, 45, 212);
INSERT INTO public.who_global_data VALUES (10466, 7519, 515314, 104, 14332, 45, 181);
INSERT INTO public.who_global_data VALUES (10467, 0, 316, 0, 2, 45, 53);
INSERT INTO public.who_global_data VALUES (10468, 0, 4948, 0, 63, 45, 164);
INSERT INTO public.who_global_data VALUES (10469, 14, 1916, 0, 102, 45, 140);
INSERT INTO public.who_global_data VALUES (10470, 1701, 589189, 20, 16217, 45, 20);
INSERT INTO public.who_global_data VALUES (10471, 82, 95998, 1, 4773, 45, 112);
INSERT INTO public.who_global_data VALUES (10472, 10845, 1518067, 205, 40680, 45, 111);
INSERT INTO public.who_global_data VALUES (10473, 0, 666, 0, 7, 45, 71);
INSERT INTO public.who_global_data VALUES (10474, 0, 6200, 0, 100, 45, 218);
INSERT INTO public.who_global_data VALUES (10475, 0, 0, 0, 0, 45, 43);
INSERT INTO public.who_global_data VALUES (10476, 635, 159893, 14, 2037, 45, 49);
INSERT INTO public.who_global_data VALUES (10477, 0, 21932, 0, 133, 45, 1);
INSERT INTO public.who_global_data VALUES (10478, 2763, 200086, 66, 3394, 45, 48);
INSERT INTO public.who_global_data VALUES (10479, 142, 10384, 2, 139, 45, 232);
INSERT INTO public.who_global_data VALUES (10480, 27, 3974, 0, 11, 45, 175);
INSERT INTO public.who_global_data VALUES (10481, 402, 18406, 5, 101, 45, 21);
INSERT INTO public.who_global_data VALUES (10482, 10898, 646312, 102, 10664, 45, 156);
INSERT INTO public.who_global_data VALUES (10483, 0, 0, 0, 0, 45, 95);
INSERT INTO public.who_global_data VALUES (10484, 174, 15667, 196, 566, 45, 177);
INSERT INTO public.who_global_data VALUES (10485, 2543, 140175, 17, 1070, 45, 210);
INSERT INTO public.who_global_data VALUES (10486, 3, 5786, 0, 61, 45, 120);
INSERT INTO public.who_global_data VALUES (10487, 0, 92, 0, 0, 45, 135);
INSERT INTO public.who_global_data VALUES (10488, 878, 161930, 13, 2398, 45, 206);
INSERT INTO public.who_global_data VALUES (10489, 35, 206364, 0, 13949, 45, 189);
INSERT INTO public.who_global_data VALUES (10490, 788, 127061, 37, 7167, 45, 129);
INSERT INTO public.who_global_data VALUES (10491, 0, 43772, 8, 1265, 45, 121);
INSERT INTO public.who_global_data VALUES (10492, 0, 5231, 0, 85, 45, 59);
INSERT INTO public.who_global_data VALUES (10493, 25, 832, 1, 1, 45, 96);
INSERT INTO public.who_global_data VALUES (10494, 662, 23309, 5, 192, 45, 41);
INSERT INTO public.who_global_data VALUES (10495, 153, 7715, 1, 142, 45, 216);
INSERT INTO public.who_global_data VALUES (10496, 290, 120638, 3, 1864, 45, 236);
INSERT INTO public.who_global_data VALUES (10497, 0, 23, 0, 0, 45, 150);
INSERT INTO public.who_global_data VALUES (10498, 3, 550, 0, 0, 45, 61);
INSERT INTO public.who_global_data VALUES (10499, 0, 46, 0, 2, 45, 7);
INSERT INTO public.who_global_data VALUES (10500, 303, 33717, 5, 511, 45, 169);
INSERT INTO public.who_global_data VALUES (10501, 11670, 2448543, 801, 61326, 45, 28);
INSERT INTO public.who_global_data VALUES (10502, 66, 12499, 0, 71, 45, 85);
INSERT INTO public.who_global_data VALUES (10503, 65, 16410, 0, 106, 45, 211);
INSERT INTO public.who_global_data VALUES (10504, 0, 9420, 0, 64, 45, 60);
INSERT INTO public.who_global_data VALUES (10505, 2, 3791, 0, 123, 45, 3);
INSERT INTO public.who_global_data VALUES (10506, 2345, 214871, 51, 2233, 45, 11);
INSERT INTO public.who_global_data VALUES (10507, 24740, 1554920, 962, 27968, 45, 89);
INSERT INTO public.who_global_data VALUES (10508, 0, 53954, 0, 333, 45, 24);
INSERT INTO public.who_global_data VALUES (10509, 38, 1282, 0, 6, 45, 162);
INSERT INTO public.who_global_data VALUES (10510, 833, 132430, 83, 4340, 45, 100);
INSERT INTO public.who_global_data VALUES (10511, 0, 24, 0, 0, 45, 47);
INSERT INTO public.who_global_data VALUES (10512, 0, 107, 0, 0, 45, 29);
INSERT INTO public.who_global_data VALUES (10513, 0, 8557, 0, 155, 45, 40);
INSERT INTO public.who_global_data VALUES (10514, 25, 7066, 1, 121, 45, 222);
INSERT INTO public.who_global_data VALUES (10515, 734, 133601, 30, 4718, 45, 132);
INSERT INTO public.who_global_data VALUES (10516, 0, 293, 0, 13, 45, 130);
INSERT INTO public.who_global_data VALUES (10517, 28, 13578, 0, 80, 45, 234);
INSERT INTO public.who_global_data VALUES (10518, 0, 2447, 0, 44, 45, 23);
INSERT INTO public.who_global_data VALUES (10519, 46, 6171, 0, 159, 45, 192);
INSERT INTO public.who_global_data VALUES (10520, 8, 9771, 1, 235, 45, 69);
INSERT INTO public.who_global_data VALUES (10521, 0, 26, 0, 0, 45, 187);
INSERT INTO public.who_global_data VALUES (10522, 168, 117190, 7, 3034, 45, 230);
INSERT INTO public.who_global_data VALUES (10523, 1894, 308262, 154, 8616, 45, 77);
INSERT INTO public.who_global_data VALUES (10524, 11, 5667, 0, 28, 45, 9);
INSERT INTO public.who_global_data VALUES (10525, 23950, 10099066, 333, 146444, 45, 74);
INSERT INTO public.who_global_data VALUES (10526, 6347, 678125, 172, 20257, 45, 224);
INSERT INTO public.who_global_data VALUES (10527, 6208, 1170743, 187, 54003, 45, 199);
INSERT INTO public.who_global_data VALUES (10528, 1158, 586503, 15, 12725, 45, 190);
INSERT INTO public.who_global_data VALUES (10529, 961, 81228, 13, 2171, 45, 12);
INSERT INTO public.who_global_data VALUES (10530, 0, 374, 0, 25, 45, 104);
INSERT INTO public.who_global_data VALUES (10531, 3781, 380126, 16, 3138, 45, 153);
INSERT INTO public.who_global_data VALUES (10532, 13316, 1977370, 628, 69842, 45, 91);
INSERT INTO public.who_global_data VALUES (10533, 65, 12354, 2, 288, 45, 215);
INSERT INTO public.who_global_data VALUES (10534, 2455, 203113, 50, 2994, 45, 84);
INSERT INTO public.who_global_data VALUES (10535, 109, 2445, 2, 38, 45, 231);
INSERT INTO public.who_global_data VALUES (10536, 2444, 279892, 23, 3627, 45, 196);
INSERT INTO public.who_global_data VALUES (10537, 910, 194413, 0, 2669, 45, 105);
INSERT INTO public.who_global_data VALUES (10538, 154, 94768, 3, 1647, 45, 122);
INSERT INTO public.who_global_data VALUES (10539, 0, 0, 0, 0, 45, 159);
INSERT INTO public.who_global_data VALUES (10540, 137, 49263, 10, 1262, 45, 75);
INSERT INTO public.who_global_data VALUES (10541, 298, 148507, 1, 923, 45, 27);
INSERT INTO public.who_global_data VALUES (10542, 230, 79659, 2, 1337, 45, 54);
INSERT INTO public.who_global_data VALUES (10543, 0, 41, 0, 0, 45, 226);
INSERT INTO public.who_global_data VALUES (10544, 1004, 32339, 16, 459, 45, 79);
INSERT INTO public.who_global_data VALUES (10545, 1693, 160979, 17, 1311, 45, 56);
INSERT INTO public.who_global_data VALUES (10546, 0, 2285, 0, 44, 45, 117);
INSERT INTO public.who_global_data VALUES (10547, 10, 1798, 0, 83, 45, 152);
INSERT INTO public.who_global_data VALUES (10548, 506, 95706, 16, 1385, 45, 16);
INSERT INTO public.who_global_data VALUES (10549, 59, 1950, 1, 29, 45, 10);
INSERT INTO public.who_global_data VALUES (10550, 3719, 120094, 35, 1432, 45, 201);
INSERT INTO public.who_global_data VALUES (10551, 227, 44809, 3, 453, 45, 174);
INSERT INTO public.who_global_data VALUES (10552, 0, 17633, 0, 260, 45, 119);
INSERT INTO public.who_global_data VALUES (10553, 46, 6248, 0, 187, 45, 168);
INSERT INTO public.who_global_data VALUES (10554, 2062, 97389, 1, 439, 45, 99);
INSERT INTO public.who_global_data VALUES (10555, 23, 13524, 0, 48, 45, 171);
INSERT INTO public.who_global_data VALUES (10556, 59, 6291, 0, 225, 45, 87);
INSERT INTO public.who_global_data VALUES (10557, 108, 11910, 6, 196, 45, 123);
INSERT INTO public.who_global_data VALUES (10558, 0, 4, 0, 0, 45, 151);
INSERT INTO public.who_global_data VALUES (10559, 0, 5634, 0, 42, 45, 213);
INSERT INTO public.who_global_data VALUES (10560, 0, 10971, 0, 225, 45, 118);
INSERT INTO public.who_global_data VALUES (10561, 0, 524, 0, 10, 45, 134);
INSERT INTO public.who_global_data VALUES (10562, 59, 5767, 1, 54, 45, 65);
INSERT INTO public.who_global_data VALUES (10563, 5370, 1325915, 396, 118598, 45, 102);
INSERT INTO public.who_global_data VALUES (10564, 0, 0, 0, 0, 45, 223);
INSERT INTO public.who_global_data VALUES (10565, 14, 759, 0, 3, 45, 4);
INSERT INTO public.who_global_data VALUES (10566, 13, 1006, 0, 0, 45, 146);
INSERT INTO public.who_global_data VALUES (10567, 379, 45380, 2, 639, 45, 31);
INSERT INTO public.who_global_data VALUES (10568, 0, 13, 0, 1, 45, 127);
INSERT INTO public.who_global_data VALUES (10569, 2646, 420648, 30, 7030, 45, 22);
INSERT INTO public.who_global_data VALUES (10570, 72, 17767, 1, 150, 45, 115);
INSERT INTO public.who_global_data VALUES (10571, 848, 116982, 22, 2465, 45, 106);
INSERT INTO public.who_global_data VALUES (10572, 330, 19629, 1, 181, 45, 90);
INSERT INTO public.who_global_data VALUES (10573, 0, 0, 0, 0, 45, 70);
INSERT INTO public.who_global_data VALUES (10574, 722, 255236, 3, 1798, 45, 46);
INSERT INTO public.who_global_data VALUES (10575, 9828, 709579, 113, 10607, 45, 139);
INSERT INTO public.who_global_data VALUES (10576, 1, 38, 0, 0, 45, 42);
INSERT INTO public.who_global_data VALUES (10577, 7, 1772, 0, 25, 45, 80);
INSERT INTO public.who_global_data VALUES (10578, 0, 4790, 0, 164, 45, 203);
INSERT INTO public.who_global_data VALUES (10579, 0, 2361, 0, 82, 45, 136);
INSERT INTO public.who_global_data VALUES (10580, 999, 79789, 4, 1231, 45, 63);
INSERT INTO public.who_global_data VALUES (10581, 0, 0, 0, 0, 45, 17);
INSERT INTO public.who_global_data VALUES (10582, 2, 118, 0, 2, 45, 172);
INSERT INTO public.who_global_data VALUES (10583, 756, 79190, 26, 2340, 45, 109);
INSERT INTO public.who_global_data VALUES (10584, 431, 44336, 0, 405, 45, 200);
INSERT INTO public.who_global_data VALUES (10585, 1561, 141608, 29, 1316, 45, 93);
INSERT INTO public.who_global_data VALUES (10586, 212, 128143, 1, 1490, 45, 5);
INSERT INTO public.who_global_data VALUES (10587, 0, 744, 0, 13, 45, 214);
INSERT INTO public.who_global_data VALUES (10588, 1704, 460672, 82, 9474, 45, 204);
INSERT INTO public.who_global_data VALUES (10589, 0, 0, 0, 0, 45, 198);
INSERT INTO public.who_global_data VALUES (10590, 1699, 214038, 31, 3597, 45, 173);
INSERT INTO public.who_global_data VALUES (10591, 0, 761, 0, 9, 45, 229);
INSERT INTO public.who_global_data VALUES (10592, 823, 100612, 15, 2103, 45, 76);
INSERT INTO public.who_global_data VALUES (10593, 958, 998475, 70, 37173, 45, 138);
INSERT INTO public.who_global_data VALUES (10594, 1310, 462815, 64, 9021, 45, 98);
INSERT INTO public.who_global_data VALUES (10595, 0, 0, 0, 0, 45, 103);
INSERT INTO public.who_global_data VALUES (10596, 12358, 1226883, 472, 26255, 45, 225);
INSERT INTO public.who_global_data VALUES (10597, 2436, 378656, 63, 6254, 45, 131);
INSERT INTO public.who_global_data VALUES (10598, 1063, 69912, 9, 1391, 45, 235);
INSERT INTO public.who_global_data VALUES (10599, 149, 142308, 0, 243, 45, 137);
INSERT INTO public.who_global_data VALUES (10600, 1090, 52537, 17, 739, 45, 81);
INSERT INTO public.who_global_data VALUES (10601, 1021, 136931, 25, 2803, 45, 182);
INSERT INTO public.who_global_data VALUES (10602, 0, 8801, 0, 42, 45, 145);
INSERT INTO public.who_global_data VALUES (10603, 5009, 598792, 155, 14636, 45, 26);
INSERT INTO public.who_global_data VALUES (10604, 27250, 2933753, 549, 52461, 45, 170);
INSERT INTO public.who_global_data VALUES (10605, 279, 7511, 7, 66, 45, 191);
INSERT INTO public.who_global_data VALUES (10606, 0, 5, 0, 0, 45, 221);
INSERT INTO public.who_global_data VALUES (10607, 0, 182, 0, 0, 45, 64);
INSERT INTO public.who_global_data VALUES (10608, 0, 0, 0, 0, 45, 116);
INSERT INTO public.who_global_data VALUES (10609, 0, 30, 0, 0, 45, 128);
INSERT INTO public.who_global_data VALUES (10610, 16, 303, 0, 5, 45, 6);
INSERT INTO public.who_global_data VALUES (10611, 0, 948, 0, 12, 45, 227);
INSERT INTO public.who_global_data VALUES (10612, 0, 15, 0, 0, 45, 68);
INSERT INTO public.who_global_data VALUES (10613, 3, 107, 0, 0, 45, 184);
INSERT INTO public.who_global_data VALUES (10614, 0, 2, 0, 0, 45, 82);
INSERT INTO public.who_global_data VALUES (10615, 0, 2135, 0, 55, 45, 149);
INSERT INTO public.who_global_data VALUES (10616, 0, 1012, 0, 17, 45, 197);
INSERT INTO public.who_global_data VALUES (10617, 181, 361359, 8, 6139, 45, 78);
INSERT INTO public.who_global_data VALUES (10618, 66, 17945, 1, 372, 45, 233);
INSERT INTO public.who_global_data VALUES (10619, 4080, 307827, 49, 2782, 45, 133);
INSERT INTO public.who_global_data VALUES (10620, 9, 211, 0, 0, 45, 35);
INSERT INTO public.who_global_data VALUES (10621, 0, 2497, 0, 75, 45, 114);
INSERT INTO public.who_global_data VALUES (10622, 29, 58461, 0, 29, 45, 237);
INSERT INTO public.who_global_data VALUES (10623, 0, 19, 0, 0, 45, 55);
INSERT INTO public.who_global_data VALUES (10624, 10, 1338, 0, 26, 45, 176);
INSERT INTO public.who_global_data VALUES (10625, 3687, 158905, 68, 1686, 45, 202);
INSERT INTO public.who_global_data VALUES (10626, 2157, 110013, 37, 2700, 45, 155);
INSERT INTO public.who_global_data VALUES (10627, 0, 17, 0, 0, 45, 32);
INSERT INTO public.who_global_data VALUES (10628, 28, 4690, 3, 127, 45, 220);
INSERT INTO public.who_global_data VALUES (10629, 9501, 940212, 339, 25246, 45, 30);
INSERT INTO public.who_global_data VALUES (10630, 42, 3276, 0, 62, 45, 147);
INSERT INTO public.who_global_data VALUES (10631, 11394, 1894580, 132, 50508, 45, 208);
INSERT INTO public.who_global_data VALUES (10632, 798, 38059, 7, 183, 45, 45);
INSERT INTO public.who_global_data VALUES (10633, 274, 23846, 10, 1492, 45, 110);
INSERT INTO public.who_global_data VALUES (10634, 31, 5583, 0, 118, 45, 88);
INSERT INTO public.who_global_data VALUES (10635, 5160, 389369, 77, 8893, 45, 51);
INSERT INTO public.who_global_data VALUES (10636, 4602, 423706, 82, 6614, 45, 209);
INSERT INTO public.who_global_data VALUES (10637, 124, 10442, 9, 630, 45, 205);
INSERT INTO public.who_global_data VALUES (10638, 52, 13388, 0, 89, 45, 18);
INSERT INTO public.who_global_data VALUES (10639, 473, 5762, 0, 60, 45, 72);
INSERT INTO public.who_global_data VALUES (10640, 36803, 2110318, 691, 68307, 45, 44);
INSERT INTO public.who_global_data VALUES (10641, 2, 33, 0, 0, 45, 15);
INSERT INTO public.who_global_data VALUES (10642, 31, 3467, 0, 66, 45, 25);
INSERT INTO public.who_global_data VALUES (10643, 0, 0, 0, 0, 45, 179);
INSERT INTO public.who_global_data VALUES (10644, 0, 0, 0, 0, 45, 34);
INSERT INTO public.who_global_data VALUES (10645, 12, 7012, 2, 125, 45, 207);
INSERT INTO public.who_global_data VALUES (10646, 1605, 123323, 38, 4237, 45, 166);
INSERT INTO public.who_global_data VALUES (10647, 19256, 2062960, 251, 18602, 45, 126);
INSERT INTO public.who_global_data VALUES (10648, 0, 0, 0, 0, 45, 97);
INSERT INTO public.who_global_data VALUES (10649, 0, 798, 0, 6, 45, 36);
INSERT INTO public.who_global_data VALUES (10650, 0, 0, 0, 0, 45, 125);
INSERT INTO public.who_global_data VALUES (10651, 526, 31910, 0, 238, 45, 124);
INSERT INTO public.who_global_data VALUES (10652, 10136, 989642, 275, 17172, 45, 185);
INSERT INTO public.who_global_data VALUES (10653, 1226, 195878, 3, 642, 45, 194);
INSERT INTO public.who_global_data VALUES (10654, 0, 509, 0, 21, 45, 144);
INSERT INTO public.who_global_data VALUES (10655, 182819, 17895109, 1714, 317032, 45, 19);
INSERT INTO public.who_global_data VALUES (10656, 13, 1934, 0, 23, 45, 217);
INSERT INTO public.who_global_data VALUES (10657, 429, 13477, 0, 119, 45, 148);
INSERT INTO public.who_global_data VALUES (10658, 267, 76315, 0, 612, 45, 86);
INSERT INTO public.who_global_data VALUES (10659, 0, 1, 0, 0, 45, 13);
INSERT INTO public.who_global_data VALUES (10660, 438, 110513, 5, 993, 45, 157);
INSERT INTO public.who_global_data VALUES (10661, 6, 1420, 0, 35, 45, 8);
INSERT INTO public.who_global_data VALUES (10662, 0, 4, 0, 0, 45, 73);
INSERT INTO public.who_global_data VALUES (10663, 3, 2094, 0, 607, 45, 101);
INSERT INTO public.who_global_data VALUES (10664, 113, 18881, 4, 379, 45, 165);
INSERT INTO public.who_global_data VALUES (10665, 122, 12544, 4, 326, 45, 14);
INSERT INTO public.who_global_data VALUES (10666, 210, 50888, 15, 2089, 46, 193);
INSERT INTO public.who_global_data VALUES (10667, 422, 53425, 10, 1098, 46, 113);
INSERT INTO public.who_global_data VALUES (10668, 456, 95659, 9, 2675, 46, 143);
INSERT INTO public.who_global_data VALUES (10669, 0, 0, 0, 0, 46, 219);
INSERT INTO public.who_global_data VALUES (10670, 25, 7602, 0, 81, 46, 186);
INSERT INTO public.who_global_data VALUES (10671, 42, 16686, 3, 390, 46, 52);
INSERT INTO public.who_global_data VALUES (10672, 0, 10, 0, 0, 46, 180);
INSERT INTO public.who_global_data VALUES (10673, 1, 153, 0, 5, 46, 167);
INSERT INTO public.who_global_data VALUES (10674, 4116, 1541285, 50, 41813, 46, 154);
INSERT INTO public.who_global_data VALUES (10675, 537, 153915, 17, 2668, 46, 94);
INSERT INTO public.who_global_data VALUES (10676, 39, 5163, 0, 47, 46, 66);
INSERT INTO public.who_global_data VALUES (10677, 27, 28198, 0, 908, 46, 58);
INSERT INTO public.who_global_data VALUES (10678, 1218, 337440, 140, 5356, 46, 163);
INSERT INTO public.who_global_data VALUES (10679, 1505, 203593, 43, 2253, 46, 37);
INSERT INTO public.who_global_data VALUES (10680, 3, 7768, 0, 164, 46, 142);
INSERT INTO public.who_global_data VALUES (10681, 168, 90450, 1, 350, 46, 83);
INSERT INTO public.who_global_data VALUES (10682, 1470, 502183, 32, 7312, 46, 228);
INSERT INTO public.who_global_data VALUES (10683, 14, 321, 0, 7, 46, 188);
INSERT INTO public.who_global_data VALUES (10684, 1893, 175416, 9, 1333, 46, 62);
INSERT INTO public.who_global_data VALUES (10685, 3395, 631135, 69, 18827, 46, 160);
INSERT INTO public.who_global_data VALUES (10686, 72, 10095, 4, 220, 46, 50);
INSERT INTO public.who_global_data VALUES (10687, 0, 3167, 0, 44, 46, 33);
INSERT INTO public.who_global_data VALUES (10688, 0, 527, 0, 9, 46, 183);
INSERT INTO public.who_global_data VALUES (10689, 12, 479, 0, 0, 46, 92);
INSERT INTO public.who_global_data VALUES (10690, 253, 150023, 1, 9036, 46, 158);
INSERT INTO public.who_global_data VALUES (10691, 1, 155, 0, 3, 46, 67);
INSERT INTO public.who_global_data VALUES (10692, 216, 106222, 53, 3706, 46, 57);
INSERT INTO public.who_global_data VALUES (10693, 480, 13353, 0, 38, 46, 38);
INSERT INTO public.who_global_data VALUES (10694, 25445, 7238600, 408, 186764, 46, 141);
INSERT INTO public.who_global_data VALUES (10695, 0, 86, 0, 1, 46, 178);
INSERT INTO public.who_global_data VALUES (10696, 0, 152, 0, 3, 46, 108);
INSERT INTO public.who_global_data VALUES (10697, 1277, 192472, 156, 6765, 46, 39);
INSERT INTO public.who_global_data VALUES (10698, 141, 5301, 0, 76, 46, 2);
INSERT INTO public.who_global_data VALUES (10699, 0, 762, 0, 2, 46, 195);
INSERT INTO public.who_global_data VALUES (10700, 21, 11600, 0, 111, 46, 107);
INSERT INTO public.who_global_data VALUES (10701, 0, 363, 0, 0, 46, 161);
INSERT INTO public.who_global_data VALUES (10702, 0, 25849, 0, 448, 46, 212);
INSERT INTO public.who_global_data VALUES (10703, 6201, 507795, 74, 14228, 46, 181);
INSERT INTO public.who_global_data VALUES (10704, 5, 316, 0, 2, 46, 53);
INSERT INTO public.who_global_data VALUES (10705, 10, 4948, 0, 63, 46, 164);
INSERT INTO public.who_global_data VALUES (10706, 12, 1902, 0, 102, 46, 140);
INSERT INTO public.who_global_data VALUES (10707, 1943, 587488, 43, 16197, 46, 20);
INSERT INTO public.who_global_data VALUES (10708, 100, 95916, 1, 4772, 46, 112);
INSERT INTO public.who_global_data VALUES (10709, 11160, 1507222, 207, 40475, 46, 111);
INSERT INTO public.who_global_data VALUES (10710, 23, 666, 0, 7, 46, 71);
INSERT INTO public.who_global_data VALUES (10711, 0, 6200, 0, 100, 46, 218);
INSERT INTO public.who_global_data VALUES (10712, 0, 0, 0, 0, 46, 43);
INSERT INTO public.who_global_data VALUES (10713, 767, 159258, 12, 2023, 46, 49);
INSERT INTO public.who_global_data VALUES (10714, 14, 21932, 0, 133, 46, 1);
INSERT INTO public.who_global_data VALUES (10715, 1595, 197323, 71, 3328, 46, 48);
INSERT INTO public.who_global_data VALUES (10716, 115, 10242, 0, 137, 46, 232);
INSERT INTO public.who_global_data VALUES (10717, 124, 3947, 0, 11, 46, 175);
INSERT INTO public.who_global_data VALUES (10718, 286, 18004, 5, 96, 46, 21);
INSERT INTO public.who_global_data VALUES (10719, 7891, 635414, 151, 10562, 46, 156);
INSERT INTO public.who_global_data VALUES (10720, 0, 0, 0, 0, 46, 95);
INSERT INTO public.who_global_data VALUES (10721, 283, 15493, 1, 370, 46, 177);
INSERT INTO public.who_global_data VALUES (10722, 3198, 137632, 18, 1053, 46, 210);
INSERT INTO public.who_global_data VALUES (10723, 2, 5783, 0, 61, 46, 120);
INSERT INTO public.who_global_data VALUES (10724, 0, 92, 0, 0, 46, 135);
INSERT INTO public.who_global_data VALUES (10725, 666, 161052, 1, 2385, 46, 206);
INSERT INTO public.who_global_data VALUES (10726, 72, 206329, 1, 13949, 46, 189);
INSERT INTO public.who_global_data VALUES (10727, 718, 126273, 32, 7130, 46, 129);
INSERT INTO public.who_global_data VALUES (10728, 295, 43772, 7, 1257, 46, 121);
INSERT INTO public.who_global_data VALUES (10729, 17, 5231, 0, 85, 46, 59);
INSERT INTO public.who_global_data VALUES (10730, 53, 807, 0, 0, 46, 96);
INSERT INTO public.who_global_data VALUES (10731, 564, 22647, 6, 187, 46, 41);
INSERT INTO public.who_global_data VALUES (10732, 135, 7562, 1, 141, 46, 216);
INSERT INTO public.who_global_data VALUES (10733, 397, 120348, 8, 1861, 46, 236);
INSERT INTO public.who_global_data VALUES (10734, 0, 23, 0, 0, 46, 150);
INSERT INTO public.who_global_data VALUES (10735, 1, 547, 0, 0, 46, 61);
INSERT INTO public.who_global_data VALUES (10736, 0, 46, 0, 2, 46, 7);
INSERT INTO public.who_global_data VALUES (10737, 832, 33414, 17, 506, 46, 169);
INSERT INTO public.who_global_data VALUES (10738, 5636, 2436873, 351, 60525, 46, 28);
INSERT INTO public.who_global_data VALUES (10739, 64, 12433, 0, 71, 46, 85);
INSERT INTO public.who_global_data VALUES (10740, 163, 16345, 3, 106, 46, 211);
INSERT INTO public.who_global_data VALUES (10741, 20, 9420, 0, 64, 46, 60);
INSERT INTO public.who_global_data VALUES (10742, 1, 3789, 0, 123, 46, 3);
INSERT INTO public.who_global_data VALUES (10743, 3064, 212526, 42, 2182, 46, 11);
INSERT INTO public.who_global_data VALUES (10744, 19528, 1530180, 731, 27006, 46, 89);
INSERT INTO public.who_global_data VALUES (10745, 301, 53954, 2, 333, 46, 24);
INSERT INTO public.who_global_data VALUES (10746, 33, 1244, 0, 6, 46, 162);
INSERT INTO public.who_global_data VALUES (10747, 525, 131597, 85, 4257, 46, 100);
INSERT INTO public.who_global_data VALUES (10748, 5, 24, 0, 0, 46, 47);
INSERT INTO public.who_global_data VALUES (10749, 13, 107, 0, 0, 46, 29);
INSERT INTO public.who_global_data VALUES (10750, 0, 8557, 0, 155, 46, 40);
INSERT INTO public.who_global_data VALUES (10751, 6, 7041, 1, 120, 46, 222);
INSERT INTO public.who_global_data VALUES (10752, 102, 132867, 32, 4688, 46, 132);
INSERT INTO public.who_global_data VALUES (10753, 1, 293, 0, 13, 46, 130);
INSERT INTO public.who_global_data VALUES (10754, 5, 13550, 0, 80, 46, 234);
INSERT INTO public.who_global_data VALUES (10755, 0, 2447, 0, 44, 46, 23);
INSERT INTO public.who_global_data VALUES (10756, 20, 6125, 0, 159, 46, 192);
INSERT INTO public.who_global_data VALUES (10757, 89, 9763, 0, 234, 46, 69);
INSERT INTO public.who_global_data VALUES (10758, 0, 26, 0, 0, 46, 187);
INSERT INTO public.who_global_data VALUES (10759, 162, 117022, 2, 3027, 46, 230);
INSERT INTO public.who_global_data VALUES (10760, 1238, 306368, 170, 8462, 46, 77);
INSERT INTO public.who_global_data VALUES (10761, 14, 5656, 0, 28, 46, 9);
INSERT INTO public.who_global_data VALUES (10762, 19556, 10075116, 301, 146111, 46, 74);
INSERT INTO public.who_global_data VALUES (10763, 6848, 671778, 205, 20085, 46, 224);
INSERT INTO public.who_global_data VALUES (10764, 6151, 1164535, 191, 53816, 46, 199);
INSERT INTO public.who_global_data VALUES (10765, 1200, 585345, 13, 12710, 46, 190);
INSERT INTO public.who_global_data VALUES (10766, 725, 80267, 0, 2158, 46, 12);
INSERT INTO public.who_global_data VALUES (10767, 1, 374, 0, 25, 46, 104);
INSERT INTO public.who_global_data VALUES (10768, 3093, 376345, 19, 3122, 46, 153);
INSERT INTO public.who_global_data VALUES (10769, 10869, 1964054, 415, 69214, 46, 91);
INSERT INTO public.who_global_data VALUES (10770, 65, 12289, 0, 286, 46, 215);
INSERT INTO public.who_global_data VALUES (10771, 2135, 200658, 44, 2944, 46, 84);
INSERT INTO public.who_global_data VALUES (10772, 80, 2336, 0, 36, 46, 231);
INSERT INTO public.who_global_data VALUES (10773, 2499, 277448, 36, 3604, 46, 196);
INSERT INTO public.who_global_data VALUES (10774, 924, 193503, 0, 2669, 46, 105);
INSERT INTO public.who_global_data VALUES (10775, 114, 94614, 5, 1644, 46, 122);
INSERT INTO public.who_global_data VALUES (10776, 0, 0, 0, 0, 46, 159);
INSERT INTO public.who_global_data VALUES (10777, 264, 49126, 6, 1252, 46, 75);
INSERT INTO public.who_global_data VALUES (10778, 230, 148209, 1, 922, 46, 27);
INSERT INTO public.who_global_data VALUES (10779, 175, 79429, 5, 1335, 46, 54);
INSERT INTO public.who_global_data VALUES (10780, 0, 41, 0, 0, 46, 226);
INSERT INTO public.who_global_data VALUES (10781, 395, 31335, 4, 443, 46, 79);
INSERT INTO public.who_global_data VALUES (10782, 1182, 159286, 13, 1294, 46, 56);
INSERT INTO public.who_global_data VALUES (10783, 0, 2285, 0, 44, 46, 117);
INSERT INTO public.who_global_data VALUES (10784, 0, 1788, 0, 83, 46, 152);
INSERT INTO public.who_global_data VALUES (10785, 640, 95200, 16, 1369, 46, 16);
INSERT INTO public.who_global_data VALUES (10786, 42, 1891, 1, 28, 46, 10);
INSERT INTO public.who_global_data VALUES (10787, 1883, 116375, 56, 1397, 46, 201);
INSERT INTO public.who_global_data VALUES (10788, 91, 44582, 6, 450, 46, 174);
INSERT INTO public.who_global_data VALUES (10789, 0, 17633, 0, 260, 46, 119);
INSERT INTO public.who_global_data VALUES (10790, 41, 6202, 0, 187, 46, 168);
INSERT INTO public.who_global_data VALUES (10791, 2018, 95327, 1, 438, 46, 99);
INSERT INTO public.who_global_data VALUES (10792, 8, 13501, 0, 48, 46, 171);
INSERT INTO public.who_global_data VALUES (10793, 41, 6232, 3, 225, 46, 87);
INSERT INTO public.who_global_data VALUES (10794, 88, 11802, 0, 190, 46, 123);
INSERT INTO public.who_global_data VALUES (10795, 0, 4, 0, 0, 46, 151);
INSERT INTO public.who_global_data VALUES (10796, 0, 5634, 0, 42, 46, 213);
INSERT INTO public.who_global_data VALUES (10797, 0, 10971, 0, 225, 46, 118);
INSERT INTO public.who_global_data VALUES (10798, 0, 524, 0, 10, 46, 134);
INSERT INTO public.who_global_data VALUES (10799, 0, 5708, 0, 53, 46, 65);
INSERT INTO public.who_global_data VALUES (10800, 6870, 1320545, 326, 118202, 46, 102);
INSERT INTO public.who_global_data VALUES (10801, 0, 0, 0, 0, 46, 223);
INSERT INTO public.who_global_data VALUES (10802, 14, 745, 0, 3, 46, 4);
INSERT INTO public.who_global_data VALUES (10803, 32, 993, 0, 0, 46, 146);
INSERT INTO public.who_global_data VALUES (10804, 380, 45001, 7, 637, 46, 31);
INSERT INTO public.who_global_data VALUES (10805, 0, 13, 0, 1, 46, 127);
INSERT INTO public.who_global_data VALUES (10806, 877, 418002, 43, 7000, 46, 22);
INSERT INTO public.who_global_data VALUES (10807, 127, 17695, 1, 149, 46, 115);
INSERT INTO public.who_global_data VALUES (10808, 947, 116134, 19, 2443, 46, 106);
INSERT INTO public.who_global_data VALUES (10809, 585, 19299, 3, 180, 46, 90);
INSERT INTO public.who_global_data VALUES (10810, 0, 0, 0, 0, 46, 70);
INSERT INTO public.who_global_data VALUES (10811, 742, 254514, 7, 1795, 46, 46);
INSERT INTO public.who_global_data VALUES (10812, 11162, 699751, 30, 10494, 46, 139);
INSERT INTO public.who_global_data VALUES (10813, 0, 37, 0, 0, 46, 42);
INSERT INTO public.who_global_data VALUES (10814, 0, 1765, 0, 25, 46, 80);
INSERT INTO public.who_global_data VALUES (10815, 42, 4790, 1, 164, 46, 203);
INSERT INTO public.who_global_data VALUES (10816, 0, 2361, 0, 82, 46, 136);
INSERT INTO public.who_global_data VALUES (10817, 356, 78790, 6, 1227, 46, 63);
INSERT INTO public.who_global_data VALUES (10818, 0, 0, 0, 0, 46, 17);
INSERT INTO public.who_global_data VALUES (10819, 0, 116, 0, 2, 46, 172);
INSERT INTO public.who_global_data VALUES (10820, 129, 78434, 22, 2314, 46, 109);
INSERT INTO public.who_global_data VALUES (10821, 1130, 43905, 1, 405, 46, 200);
INSERT INTO public.who_global_data VALUES (10822, 1514, 140047, 31, 1287, 46, 93);
INSERT INTO public.who_global_data VALUES (10823, 264, 127931, 1, 1489, 46, 5);
INSERT INTO public.who_global_data VALUES (10824, 0, 744, 0, 13, 46, 214);
INSERT INTO public.who_global_data VALUES (10825, 1680, 458968, 62, 9392, 46, 204);
INSERT INTO public.who_global_data VALUES (10826, 0, 0, 0, 0, 46, 198);
INSERT INTO public.who_global_data VALUES (10827, 2755, 212339, 39, 3566, 46, 173);
INSERT INTO public.who_global_data VALUES (10828, 1, 761, 1, 9, 46, 229);
INSERT INTO public.who_global_data VALUES (10829, 632, 99789, 16, 2088, 46, 76);
INSERT INTO public.who_global_data VALUES (10830, 1618, 997517, 69, 37103, 46, 138);
INSERT INTO public.who_global_data VALUES (10831, 1716, 461505, 10, 8957, 46, 98);
INSERT INTO public.who_global_data VALUES (10832, 0, 0, 0, 0, 46, 103);
INSERT INTO public.who_global_data VALUES (10833, 7192, 1214525, 309, 25783, 46, 225);
INSERT INTO public.who_global_data VALUES (10834, 2099, 376220, 57, 6191, 46, 131);
INSERT INTO public.who_global_data VALUES (10835, 416, 68849, 14, 1382, 46, 235);
INSERT INTO public.who_global_data VALUES (10836, 158, 142159, 0, 243, 46, 137);
INSERT INTO public.who_global_data VALUES (10837, 866, 51447, 24, 722, 46, 81);
INSERT INTO public.who_global_data VALUES (10838, 703, 135910, 26, 2778, 46, 182);
INSERT INTO public.who_global_data VALUES (10839, 97, 8801, 0, 42, 46, 145);
INSERT INTO public.who_global_data VALUES (10840, 2489, 593783, 87, 14481, 46, 26);
INSERT INTO public.who_global_data VALUES (10841, 28776, 2906503, 561, 51912, 46, 170);
INSERT INTO public.who_global_data VALUES (10842, 0, 7232, 0, 59, 46, 191);
INSERT INTO public.who_global_data VALUES (10843, 0, 5, 0, 0, 46, 221);
INSERT INTO public.who_global_data VALUES (10844, 0, 182, 0, 0, 46, 64);
INSERT INTO public.who_global_data VALUES (10845, 0, 0, 0, 0, 46, 116);
INSERT INTO public.who_global_data VALUES (10846, 0, 30, 0, 0, 46, 128);
INSERT INTO public.who_global_data VALUES (10847, 5, 287, 0, 5, 46, 6);
INSERT INTO public.who_global_data VALUES (10848, 0, 948, 0, 12, 46, 227);
INSERT INTO public.who_global_data VALUES (10849, 0, 15, 0, 0, 46, 68);
INSERT INTO public.who_global_data VALUES (10850, 0, 104, 0, 0, 46, 184);
INSERT INTO public.who_global_data VALUES (10851, 0, 2, 0, 0, 46, 82);
INSERT INTO public.who_global_data VALUES (10852, 28, 2135, 0, 55, 46, 149);
INSERT INTO public.who_global_data VALUES (10853, 0, 1012, 0, 17, 46, 197);
INSERT INTO public.who_global_data VALUES (10854, 168, 361178, 9, 6131, 46, 78);
INSERT INTO public.who_global_data VALUES (10855, 121, 17879, 6, 371, 46, 233);
INSERT INTO public.who_global_data VALUES (10856, 3685, 303747, 47, 2733, 46, 133);
INSERT INTO public.who_global_data VALUES (10857, 0, 202, 0, 0, 46, 35);
INSERT INTO public.who_global_data VALUES (10858, 0, 2497, 0, 75, 46, 114);
INSERT INTO public.who_global_data VALUES (10859, 10, 58432, 0, 29, 46, 237);
INSERT INTO public.who_global_data VALUES (10860, 1, 19, 0, 0, 46, 55);
INSERT INTO public.who_global_data VALUES (10861, 34, 1328, 0, 26, 46, 176);
INSERT INTO public.who_global_data VALUES (10862, 2663, 155218, 0, 1618, 46, 202);
INSERT INTO public.who_global_data VALUES (10863, 1550, 107856, 45, 2663, 46, 155);
INSERT INTO public.who_global_data VALUES (10864, 0, 17, 0, 0, 46, 32);
INSERT INTO public.who_global_data VALUES (10865, 0, 4662, 0, 124, 46, 220);
INSERT INTO public.who_global_data VALUES (10866, 8789, 930711, 216, 24907, 46, 30);
INSERT INTO public.who_global_data VALUES (10867, 6, 3234, 0, 62, 46, 147);
INSERT INTO public.who_global_data VALUES (10868, 4457, 1883186, 135, 50376, 46, 208);
INSERT INTO public.who_global_data VALUES (10869, 0, 37261, 0, 176, 46, 45);
INSERT INTO public.who_global_data VALUES (10870, 256, 23572, 14, 1482, 46, 110);
INSERT INTO public.who_global_data VALUES (10871, 41, 5552, 0, 118, 46, 88);
INSERT INTO public.who_global_data VALUES (10872, 3752, 384209, 92, 8816, 46, 51);
INSERT INTO public.who_global_data VALUES (10873, 5627, 419104, 85, 6532, 46, 209);
INSERT INTO public.who_global_data VALUES (10874, 123, 10318, 11, 621, 46, 205);
INSERT INTO public.who_global_data VALUES (10875, 56, 13336, 0, 89, 46, 18);
INSERT INTO public.who_global_data VALUES (10876, 382, 5289, 0, 60, 46, 72);
INSERT INTO public.who_global_data VALUES (10877, 33364, 2073515, 215, 67616, 46, 44);
INSERT INTO public.who_global_data VALUES (10878, 0, 31, 0, 0, 46, 15);
INSERT INTO public.who_global_data VALUES (10879, 40, 3436, 0, 66, 46, 25);
INSERT INTO public.who_global_data VALUES (10880, 0, 0, 0, 0, 46, 179);
INSERT INTO public.who_global_data VALUES (10881, 0, 0, 0, 0, 46, 34);
INSERT INTO public.who_global_data VALUES (10882, 26, 7000, 0, 123, 46, 207);
INSERT INTO public.who_global_data VALUES (10883, 1031, 121718, 41, 4199, 46, 166);
INSERT INTO public.who_global_data VALUES (10884, 19103, 2043704, 254, 18351, 46, 126);
INSERT INTO public.who_global_data VALUES (10885, 0, 0, 0, 0, 46, 97);
INSERT INTO public.who_global_data VALUES (10886, 0, 798, 0, 6, 46, 36);
INSERT INTO public.who_global_data VALUES (10887, 0, 0, 0, 0, 46, 125);
INSERT INTO public.who_global_data VALUES (10888, 197, 31384, 7, 238, 46, 124);
INSERT INTO public.who_global_data VALUES (10889, 8513, 979506, 232, 16897, 46, 185);
INSERT INTO public.who_global_data VALUES (10890, 1077, 194652, 2, 639, 46, 194);
INSERT INTO public.who_global_data VALUES (10891, 0, 509, 0, 21, 46, 144);
INSERT INTO public.who_global_data VALUES (10892, 197199, 17712290, 1570, 315318, 46, 19);
INSERT INTO public.who_global_data VALUES (10893, 0, 1921, 0, 23, 46, 217);
INSERT INTO public.who_global_data VALUES (10894, 491, 13048, 5, 119, 46, 148);
INSERT INTO public.who_global_data VALUES (10895, 0, 76048, 0, 612, 46, 86);
INSERT INTO public.who_global_data VALUES (10896, 0, 1, 0, 0, 46, 13);
INSERT INTO public.who_global_data VALUES (10897, 294, 110075, 4, 988, 46, 157);
INSERT INTO public.who_global_data VALUES (10898, 1, 1414, 0, 35, 46, 8);
INSERT INTO public.who_global_data VALUES (10899, 0, 4, 0, 0, 46, 73);
INSERT INTO public.who_global_data VALUES (10900, 0, 2091, 0, 607, 46, 101);
INSERT INTO public.who_global_data VALUES (10901, 52, 18768, 2, 375, 46, 165);
INSERT INTO public.who_global_data VALUES (10902, 97, 12422, 2, 322, 46, 14);
INSERT INTO public.who_global_data VALUES (10903, 142, 50678, 20, 2074, 47, 193);
INSERT INTO public.who_global_data VALUES (10904, 461, 53003, 14, 1088, 47, 113);
INSERT INTO public.who_global_data VALUES (10905, 422, 95203, 7, 2666, 47, 143);
INSERT INTO public.who_global_data VALUES (10906, 0, 0, 0, 0, 47, 219);
INSERT INTO public.who_global_data VALUES (10907, 17, 7577, 1, 81, 47, 186);
INSERT INTO public.who_global_data VALUES (10908, 18, 16644, 1, 387, 47, 52);
INSERT INTO public.who_global_data VALUES (10909, 0, 10, 0, 0, 47, 180);
INSERT INTO public.who_global_data VALUES (10910, 0, 152, 0, 5, 47, 167);
INSERT INTO public.who_global_data VALUES (10911, 5795, 1537169, 91, 41763, 47, 154);
INSERT INTO public.who_global_data VALUES (10912, 240, 153378, 26, 2651, 47, 94);
INSERT INTO public.who_global_data VALUES (10913, 0, 5124, 0, 47, 47, 66);
INSERT INTO public.who_global_data VALUES (10914, 43, 28171, 0, 908, 47, 58);
INSERT INTO public.who_global_data VALUES (10915, 1593, 336222, 89, 5216, 47, 163);
INSERT INTO public.who_global_data VALUES (10916, 2961, 202088, 35, 2210, 47, 37);
INSERT INTO public.who_global_data VALUES (10917, 32, 7765, 0, 164, 47, 142);
INSERT INTO public.who_global_data VALUES (10918, 220, 90282, 0, 349, 47, 83);
INSERT INTO public.who_global_data VALUES (10919, 1153, 500713, 38, 7280, 47, 228);
INSERT INTO public.who_global_data VALUES (10920, 0, 307, 0, 7, 47, 188);
INSERT INTO public.who_global_data VALUES (10921, 1944, 173523, 8, 1324, 47, 62);
INSERT INTO public.who_global_data VALUES (10922, 655, 627740, 89, 18758, 47, 160);
INSERT INTO public.who_global_data VALUES (10923, 94, 10023, 1, 216, 47, 50);
INSERT INTO public.who_global_data VALUES (10924, 15, 3167, 0, 44, 47, 33);
INSERT INTO public.who_global_data VALUES (10925, 11, 527, 0, 9, 47, 183);
INSERT INTO public.who_global_data VALUES (10926, 21, 467, 0, 0, 47, 92);
INSERT INTO public.who_global_data VALUES (10927, 621, 149770, 2, 9035, 47, 158);
INSERT INTO public.who_global_data VALUES (10928, 0, 154, 0, 3, 47, 67);
INSERT INTO public.who_global_data VALUES (10929, 482, 106006, 28, 3653, 47, 57);
INSERT INTO public.who_global_data VALUES (10930, 0, 12873, 0, 38, 47, 38);
INSERT INTO public.who_global_data VALUES (10931, 50177, 7213155, 706, 186356, 47, 141);
INSERT INTO public.who_global_data VALUES (10932, 0, 86, 0, 1, 47, 178);
INSERT INTO public.who_global_data VALUES (10933, 0, 152, 0, 3, 47, 108);
INSERT INTO public.who_global_data VALUES (10934, 166, 191195, 58, 6609, 47, 39);
INSERT INTO public.who_global_data VALUES (10935, 206, 5160, 2, 76, 47, 2);
INSERT INTO public.who_global_data VALUES (10936, 1, 762, 0, 2, 47, 195);
INSERT INTO public.who_global_data VALUES (10937, 12, 11579, 0, 111, 47, 107);
INSERT INTO public.who_global_data VALUES (10938, 1, 363, 0, 0, 47, 161);
INSERT INTO public.who_global_data VALUES (10939, 0, 25849, 0, 448, 47, 212);
INSERT INTO public.who_global_data VALUES (10940, 6248, 501594, 114, 14154, 47, 181);
INSERT INTO public.who_global_data VALUES (10941, 0, 311, 0, 2, 47, 53);
INSERT INTO public.who_global_data VALUES (10942, 2, 4938, 0, 63, 47, 164);
INSERT INTO public.who_global_data VALUES (10943, 23, 1890, 0, 102, 47, 140);
INSERT INTO public.who_global_data VALUES (10944, 2191, 585545, 53, 16154, 47, 20);
INSERT INTO public.who_global_data VALUES (10945, 100, 95816, 1, 4771, 47, 112);
INSERT INTO public.who_global_data VALUES (10946, 13990, 1496062, 249, 40268, 47, 111);
INSERT INTO public.who_global_data VALUES (10947, 0, 643, 0, 7, 47, 71);
INSERT INTO public.who_global_data VALUES (10948, 0, 6200, 0, 100, 47, 218);
INSERT INTO public.who_global_data VALUES (10949, 0, 0, 0, 0, 47, 43);
INSERT INTO public.who_global_data VALUES (10950, 1019, 158491, 15, 2011, 47, 49);
INSERT INTO public.who_global_data VALUES (10951, 146, 21918, 0, 133, 47, 1);
INSERT INTO public.who_global_data VALUES (10952, 766, 195728, 80, 3257, 47, 48);
INSERT INTO public.who_global_data VALUES (10953, 103, 10127, 0, 137, 47, 232);
INSERT INTO public.who_global_data VALUES (10954, 0, 3823, 0, 11, 47, 175);
INSERT INTO public.who_global_data VALUES (10955, 242, 17718, 2, 91, 47, 21);
INSERT INTO public.who_global_data VALUES (10956, 3383, 627523, 80, 10411, 47, 156);
INSERT INTO public.who_global_data VALUES (10957, 0, 0, 0, 0, 47, 95);
INSERT INTO public.who_global_data VALUES (10958, 0, 15210, 0, 369, 47, 177);
INSERT INTO public.who_global_data VALUES (10959, 2828, 134434, 16, 1035, 47, 210);
INSERT INTO public.who_global_data VALUES (10960, 0, 5781, 0, 61, 47, 120);
INSERT INTO public.who_global_data VALUES (10961, 4, 92, 0, 0, 47, 135);
INSERT INTO public.who_global_data VALUES (10962, 1322, 160386, 2, 2384, 47, 206);
INSERT INTO public.who_global_data VALUES (10963, 337, 206257, 0, 13948, 47, 189);
INSERT INTO public.who_global_data VALUES (10964, 664, 125555, 29, 7098, 47, 129);
INSERT INTO public.who_global_data VALUES (10965, 282, 43477, 8, 1250, 47, 121);
INSERT INTO public.who_global_data VALUES (10966, 0, 5214, 0, 85, 47, 59);
INSERT INTO public.who_global_data VALUES (10967, 0, 754, 0, 0, 47, 96);
INSERT INTO public.who_global_data VALUES (10968, 289, 22083, 7, 181, 47, 41);
INSERT INTO public.who_global_data VALUES (10969, 122, 7427, 3, 140, 47, 216);
INSERT INTO public.who_global_data VALUES (10970, 457, 119951, 7, 1853, 47, 236);
INSERT INTO public.who_global_data VALUES (10971, 0, 23, 0, 0, 47, 150);
INSERT INTO public.who_global_data VALUES (10972, 0, 546, 0, 0, 47, 61);
INSERT INTO public.who_global_data VALUES (10973, 0, 46, 0, 2, 47, 7);
INSERT INTO public.who_global_data VALUES (10974, 0, 32582, 0, 489, 47, 169);
INSERT INTO public.who_global_data VALUES (10975, 12798, 2431237, 131, 60174, 47, 28);
INSERT INTO public.who_global_data VALUES (10976, 0, 12369, 0, 71, 47, 85);
INSERT INTO public.who_global_data VALUES (10977, 0, 16182, 0, 103, 47, 211);
INSERT INTO public.who_global_data VALUES (10978, 0, 9400, 0, 64, 47, 60);
INSERT INTO public.who_global_data VALUES (10979, 0, 3788, 0, 123, 47, 3);
INSERT INTO public.who_global_data VALUES (10980, 824, 209462, 46, 2140, 47, 11);
INSERT INTO public.who_global_data VALUES (10981, 16643, 1510652, 226, 26275, 47, 89);
INSERT INTO public.who_global_data VALUES (10982, 0, 53653, 0, 331, 47, 24);
INSERT INTO public.who_global_data VALUES (10983, 27, 1211, 0, 6, 47, 162);
INSERT INTO public.who_global_data VALUES (10984, 587, 131072, 70, 4172, 47, 100);
INSERT INTO public.who_global_data VALUES (10985, 0, 19, 0, 0, 47, 47);
INSERT INTO public.who_global_data VALUES (10986, 0, 94, 0, 0, 47, 29);
INSERT INTO public.who_global_data VALUES (10987, 0, 8557, 0, 155, 47, 40);
INSERT INTO public.who_global_data VALUES (10988, 4, 7035, 0, 119, 47, 222);
INSERT INTO public.who_global_data VALUES (10989, 170, 132765, 32, 4656, 47, 132);
INSERT INTO public.who_global_data VALUES (10990, 1, 292, 0, 13, 47, 130);
INSERT INTO public.who_global_data VALUES (10991, 13, 13545, 0, 80, 47, 234);
INSERT INTO public.who_global_data VALUES (10992, 0, 2447, 0, 44, 47, 23);
INSERT INTO public.who_global_data VALUES (10993, 29, 6105, 0, 159, 47, 192);
INSERT INTO public.who_global_data VALUES (10994, 0, 9674, 0, 234, 47, 69);
INSERT INTO public.who_global_data VALUES (10995, 0, 26, 0, 0, 47, 187);
INSERT INTO public.who_global_data VALUES (10996, 648, 116860, 2, 3025, 47, 230);
INSERT INTO public.who_global_data VALUES (10997, 2141, 305130, 193, 8292, 47, 77);
INSERT INTO public.who_global_data VALUES (10998, 21, 5642, 0, 28, 47, 9);
INSERT INTO public.who_global_data VALUES (10999, 24337, 10055560, 333, 145810, 47, 74);
INSERT INTO public.who_global_data VALUES (11000, 6982, 664930, 221, 19880, 47, 224);
INSERT INTO public.who_global_data VALUES (11001, 6312, 1158384, 177, 53625, 47, 199);
INSERT INTO public.who_global_data VALUES (11002, 1027, 584145, 17, 12697, 47, 190);
INSERT INTO public.who_global_data VALUES (11003, 766, 79542, 4, 2158, 47, 12);
INSERT INTO public.who_global_data VALUES (11004, 0, 373, 0, 25, 47, 104);
INSERT INTO public.who_global_data VALUES (11005, 1887, 373252, 19, 3103, 47, 153);
INSERT INTO public.who_global_data VALUES (11006, 15102, 1953185, 352, 68799, 47, 91);
INSERT INTO public.who_global_data VALUES (11007, 89, 12224, 1, 286, 47, 215);
INSERT INTO public.who_global_data VALUES (11008, 2643, 198523, 27, 2900, 47, 84);
INSERT INTO public.who_global_data VALUES (11009, 22, 2256, 0, 36, 47, 231);
INSERT INTO public.who_global_data VALUES (11010, 2152, 274949, 23, 3568, 47, 196);
INSERT INTO public.who_global_data VALUES (11011, 929, 192579, 0, 2669, 47, 105);
INSERT INTO public.who_global_data VALUES (11012, 349, 94500, 6, 1639, 47, 122);
INSERT INTO public.who_global_data VALUES (11013, 0, 0, 0, 0, 47, 159);
INSERT INTO public.who_global_data VALUES (11014, 223, 48862, 8, 1246, 47, 75);
INSERT INTO public.who_global_data VALUES (11015, 204, 147979, 3, 921, 47, 27);
INSERT INTO public.who_global_data VALUES (11016, 132, 79254, 0, 1330, 47, 54);
INSERT INTO public.who_global_data VALUES (11017, 0, 41, 0, 0, 47, 226);
INSERT INTO public.who_global_data VALUES (11018, 643, 30940, 12, 439, 47, 79);
INSERT INTO public.who_global_data VALUES (11019, 1534, 158104, 11, 1281, 47, 56);
INSERT INTO public.who_global_data VALUES (11020, 0, 2285, 0, 44, 47, 117);
INSERT INTO public.who_global_data VALUES (11021, 9, 1788, 0, 83, 47, 152);
INSERT INTO public.who_global_data VALUES (11022, 788, 94560, 7, 1353, 47, 16);
INSERT INTO public.who_global_data VALUES (11023, 20, 1849, 2, 27, 47, 10);
INSERT INTO public.who_global_data VALUES (11024, 2133, 114492, 46, 1341, 47, 201);
INSERT INTO public.who_global_data VALUES (11025, 424, 44491, 4, 444, 47, 174);
INSERT INTO public.who_global_data VALUES (11026, 46, 17633, 1, 260, 47, 119);
INSERT INTO public.who_global_data VALUES (11027, 8, 6161, 0, 187, 47, 168);
INSERT INTO public.who_global_data VALUES (11028, 1340, 93309, 4, 437, 47, 99);
INSERT INTO public.who_global_data VALUES (11029, 19, 13493, 0, 48, 47, 171);
INSERT INTO public.who_global_data VALUES (11030, 27, 6191, 2, 222, 47, 87);
INSERT INTO public.who_global_data VALUES (11031, 93, 11714, 3, 190, 47, 123);
INSERT INTO public.who_global_data VALUES (11032, 0, 4, 0, 0, 47, 151);
INSERT INTO public.who_global_data VALUES (11033, 0, 5634, 0, 42, 47, 213);
INSERT INTO public.who_global_data VALUES (11034, 0, 10971, 0, 225, 47, 118);
INSERT INTO public.who_global_data VALUES (11035, 0, 524, 0, 10, 47, 134);
INSERT INTO public.who_global_data VALUES (11036, 0, 5708, 0, 53, 47, 65);
INSERT INTO public.who_global_data VALUES (11037, 12129, 1313675, 627, 117876, 47, 102);
INSERT INTO public.who_global_data VALUES (11038, 0, 0, 0, 0, 47, 223);
INSERT INTO public.who_global_data VALUES (11039, 5, 731, 0, 3, 47, 4);
INSERT INTO public.who_global_data VALUES (11040, 8, 961, 0, 0, 47, 146);
INSERT INTO public.who_global_data VALUES (11041, 350, 44621, 5, 630, 47, 31);
INSERT INTO public.who_global_data VALUES (11042, 0, 13, 0, 1, 47, 127);
INSERT INTO public.who_global_data VALUES (11043, 1899, 417125, 48, 6957, 47, 22);
INSERT INTO public.who_global_data VALUES (11044, 91, 17568, 1, 148, 47, 115);
INSERT INTO public.who_global_data VALUES (11045, 989, 115187, 26, 2424, 47, 106);
INSERT INTO public.who_global_data VALUES (11046, 277, 18714, 6, 177, 47, 90);
INSERT INTO public.who_global_data VALUES (11047, 0, 0, 0, 0, 47, 70);
INSERT INTO public.who_global_data VALUES (11048, 588, 253772, 11, 1788, 47, 46);
INSERT INTO public.who_global_data VALUES (11049, 12998, 688589, 31, 10464, 47, 139);
INSERT INTO public.who_global_data VALUES (11050, 0, 37, 0, 0, 47, 42);
INSERT INTO public.who_global_data VALUES (11051, 5, 1765, 0, 25, 47, 80);
INSERT INTO public.who_global_data VALUES (11052, 0, 4748, 0, 163, 47, 203);
INSERT INTO public.who_global_data VALUES (11053, 0, 2361, 0, 82, 47, 136);
INSERT INTO public.who_global_data VALUES (11054, 501, 78434, 3, 1221, 47, 63);
INSERT INTO public.who_global_data VALUES (11055, 0, 0, 0, 0, 47, 17);
INSERT INTO public.who_global_data VALUES (11056, 0, 116, 0, 2, 47, 172);
INSERT INTO public.who_global_data VALUES (11057, 356, 78305, 18, 2292, 47, 109);
INSERT INTO public.who_global_data VALUES (11058, 0, 42775, 0, 404, 47, 200);
INSERT INTO public.who_global_data VALUES (11059, 1427, 138533, 24, 1256, 47, 93);
INSERT INTO public.who_global_data VALUES (11060, 648, 127667, 5, 1488, 47, 5);
INSERT INTO public.who_global_data VALUES (11061, 0, 744, 0, 13, 47, 214);
INSERT INTO public.who_global_data VALUES (11062, 2615, 457288, 80, 9330, 47, 204);
INSERT INTO public.who_global_data VALUES (11063, 0, 0, 0, 0, 47, 198);
INSERT INTO public.who_global_data VALUES (11064, 3274, 209584, 23, 3527, 47, 173);
INSERT INTO public.who_global_data VALUES (11065, 0, 760, 0, 8, 47, 229);
INSERT INTO public.who_global_data VALUES (11066, 861, 99157, 22, 2072, 47, 76);
INSERT INTO public.who_global_data VALUES (11067, 2139, 995899, 65, 37034, 47, 138);
INSERT INTO public.who_global_data VALUES (11068, 1745, 459789, 36, 8947, 47, 98);
INSERT INTO public.who_global_data VALUES (11069, 0, 0, 0, 0, 47, 103);
INSERT INTO public.who_global_data VALUES (11070, 4633, 1207333, 77, 25474, 47, 225);
INSERT INTO public.who_global_data VALUES (11071, 3334, 374121, 71, 6134, 47, 131);
INSERT INTO public.who_global_data VALUES (11072, 1222, 68433, 26, 1368, 47, 235);
INSERT INTO public.who_global_data VALUES (11073, 143, 142001, 0, 243, 47, 137);
INSERT INTO public.who_global_data VALUES (11074, 924, 50581, 24, 698, 47, 81);
INSERT INTO public.who_global_data VALUES (11075, 629, 135207, 25, 2752, 47, 182);
INSERT INTO public.who_global_data VALUES (11076, 0, 8704, 0, 42, 47, 145);
INSERT INTO public.who_global_data VALUES (11077, 3350, 591294, 98, 14394, 47, 26);
INSERT INTO public.who_global_data VALUES (11078, 29350, 2877727, 493, 51351, 47, 170);
INSERT INTO public.who_global_data VALUES (11079, 0, 7232, 0, 59, 47, 191);
INSERT INTO public.who_global_data VALUES (11080, 0, 5, 0, 0, 47, 221);
INSERT INTO public.who_global_data VALUES (11081, 0, 182, 0, 0, 47, 64);
INSERT INTO public.who_global_data VALUES (11082, 0, 0, 0, 0, 47, 116);
INSERT INTO public.who_global_data VALUES (11083, 0, 30, 0, 0, 47, 128);
INSERT INTO public.who_global_data VALUES (11084, 2, 282, 0, 5, 47, 6);
INSERT INTO public.who_global_data VALUES (11085, 0, 948, 0, 12, 47, 227);
INSERT INTO public.who_global_data VALUES (11086, 1, 15, 0, 0, 47, 68);
INSERT INTO public.who_global_data VALUES (11087, 4, 104, 0, 0, 47, 184);
INSERT INTO public.who_global_data VALUES (11088, 0, 2, 0, 0, 47, 82);
INSERT INTO public.who_global_data VALUES (11089, 0, 2107, 0, 55, 47, 149);
INSERT INTO public.who_global_data VALUES (11090, 0, 1012, 0, 17, 47, 197);
INSERT INTO public.who_global_data VALUES (11091, 162, 361010, 10, 6122, 47, 78);
INSERT INTO public.who_global_data VALUES (11092, 88, 17758, 4, 365, 47, 233);
INSERT INTO public.who_global_data VALUES (11093, 3534, 300062, 54, 2686, 47, 133);
INSERT INTO public.who_global_data VALUES (11094, 0, 202, 0, 0, 47, 35);
INSERT INTO public.who_global_data VALUES (11095, 11, 2497, 0, 75, 47, 114);
INSERT INTO public.who_global_data VALUES (11096, 19, 58422, 0, 29, 47, 237);
INSERT INTO public.who_global_data VALUES (11097, 0, 18, 0, 0, 47, 55);
INSERT INTO public.who_global_data VALUES (11098, 0, 1294, 0, 26, 47, 176);
INSERT INTO public.who_global_data VALUES (11099, 1219, 152555, 63, 1618, 47, 202);
INSERT INTO public.who_global_data VALUES (11100, 396, 106306, 27, 2618, 47, 155);
INSERT INTO public.who_global_data VALUES (11101, 0, 17, 0, 0, 47, 32);
INSERT INTO public.who_global_data VALUES (11102, 0, 4662, 0, 124, 47, 220);
INSERT INTO public.who_global_data VALUES (11103, 9445, 921922, 152, 24691, 47, 30);
INSERT INTO public.who_global_data VALUES (11104, 0, 3228, 0, 62, 47, 147);
INSERT INTO public.who_global_data VALUES (11105, 6968, 1878729, 121, 50241, 47, 208);
INSERT INTO public.who_global_data VALUES (11106, 1212, 37261, 11, 176, 47, 45);
INSERT INTO public.who_global_data VALUES (11107, 216, 23316, 7, 1468, 47, 110);
INSERT INTO public.who_global_data VALUES (11108, 52, 5511, 1, 118, 47, 88);
INSERT INTO public.who_global_data VALUES (11109, 5510, 380457, 80, 8724, 47, 51);
INSERT INTO public.who_global_data VALUES (11110, 1947, 413477, 94, 6447, 47, 209);
INSERT INTO public.who_global_data VALUES (11111, 145, 10195, 9, 610, 47, 205);
INSERT INTO public.who_global_data VALUES (11112, 41, 13280, 0, 89, 47, 18);
INSERT INTO public.who_global_data VALUES (11113, 576, 4907, 0, 60, 47, 72);
INSERT INTO public.who_global_data VALUES (11114, 35928, 2040151, 326, 67401, 47, 44);
INSERT INTO public.who_global_data VALUES (11115, 0, 31, 0, 0, 47, 15);
INSERT INTO public.who_global_data VALUES (11116, 0, 3396, 0, 66, 47, 25);
INSERT INTO public.who_global_data VALUES (11117, 0, 0, 0, 0, 47, 179);
INSERT INTO public.who_global_data VALUES (11118, 0, 0, 0, 0, 47, 34);
INSERT INTO public.who_global_data VALUES (11119, 19, 6974, 0, 123, 47, 207);
INSERT INTO public.who_global_data VALUES (11120, 1536, 120687, 32, 4158, 47, 166);
INSERT INTO public.who_global_data VALUES (11121, 20316, 2024601, 246, 18097, 47, 126);
INSERT INTO public.who_global_data VALUES (11122, 0, 0, 0, 0, 47, 97);
INSERT INTO public.who_global_data VALUES (11123, 9, 798, 0, 6, 47, 36);
INSERT INTO public.who_global_data VALUES (11124, 0, 0, 0, 0, 47, 125);
INSERT INTO public.who_global_data VALUES (11125, 485, 31187, 1, 231, 47, 124);
INSERT INTO public.who_global_data VALUES (11126, 6545, 970993, 80, 16665, 47, 185);
INSERT INTO public.who_global_data VALUES (11127, 1171, 193575, 3, 637, 47, 194);
INSERT INTO public.who_global_data VALUES (11128, 0, 509, 0, 21, 47, 144);
INSERT INTO public.who_global_data VALUES (11129, 200257, 17515091, 2598, 313748, 47, 19);
INSERT INTO public.who_global_data VALUES (11130, 11, 1921, 0, 23, 47, 217);
INSERT INTO public.who_global_data VALUES (11131, 607, 12557, 5, 114, 47, 148);
INSERT INTO public.who_global_data VALUES (11132, 242, 76048, 0, 612, 47, 86);
INSERT INTO public.who_global_data VALUES (11133, 0, 1, 0, 0, 47, 13);
INSERT INTO public.who_global_data VALUES (11134, 386, 109781, 5, 984, 47, 157);
INSERT INTO public.who_global_data VALUES (11135, 2, 1413, 0, 35, 47, 8);
INSERT INTO public.who_global_data VALUES (11136, 0, 4, 0, 0, 47, 73);
INSERT INTO public.who_global_data VALUES (11137, 0, 2091, 0, 607, 47, 101);
INSERT INTO public.who_global_data VALUES (11138, 96, 18716, 0, 373, 47, 165);
INSERT INTO public.who_global_data VALUES (11139, 174, 12325, 2, 320, 47, 14);
INSERT INTO public.who_global_data VALUES (11140, 80, 50536, 17, 2054, 48, 193);
INSERT INTO public.who_global_data VALUES (11141, 538, 52542, 8, 1074, 48, 113);
INSERT INTO public.who_global_data VALUES (11142, 410, 94781, 12, 2659, 48, 143);
INSERT INTO public.who_global_data VALUES (11143, 0, 0, 0, 0, 48, 219);
INSERT INTO public.who_global_data VALUES (11144, 41, 7560, 0, 80, 48, 186);
INSERT INTO public.who_global_data VALUES (11145, 64, 16626, 2, 386, 48, 52);
INSERT INTO public.who_global_data VALUES (11146, 0, 10, 0, 0, 48, 180);
INSERT INTO public.who_global_data VALUES (11147, 1, 152, 0, 5, 48, 167);
INSERT INTO public.who_global_data VALUES (11148, 7002, 1531374, 138, 41672, 48, 154);
INSERT INTO public.who_global_data VALUES (11149, 652, 153138, 14, 2625, 48, 94);
INSERT INTO public.who_global_data VALUES (11150, 0, 5124, 0, 47, 48, 66);
INSERT INTO public.who_global_data VALUES (11151, 34, 28128, 0, 908, 48, 58);
INSERT INTO public.who_global_data VALUES (11152, 2258, 334629, 110, 5127, 48, 163);
INSERT INTO public.who_global_data VALUES (11153, 3705, 199127, 42, 2175, 48, 37);
INSERT INTO public.who_global_data VALUES (11154, 0, 7733, 0, 164, 48, 142);
INSERT INTO public.who_global_data VALUES (11155, 179, 90062, 0, 349, 48, 83);
INSERT INTO public.who_global_data VALUES (11156, 1267, 499560, 25, 7242, 48, 228);
INSERT INTO public.who_global_data VALUES (11157, 2, 307, 0, 7, 48, 188);
INSERT INTO public.who_global_data VALUES (11158, 1931, 171579, 8, 1316, 48, 62);
INSERT INTO public.who_global_data VALUES (11159, 1461, 627085, 93, 18669, 48, 160);
INSERT INTO public.who_global_data VALUES (11160, 138, 9929, 2, 215, 48, 50);
INSERT INTO public.who_global_data VALUES (11161, 0, 3152, 0, 44, 48, 33);
INSERT INTO public.who_global_data VALUES (11162, 19, 516, 0, 9, 48, 183);
INSERT INTO public.who_global_data VALUES (11163, 3, 446, 0, 0, 48, 92);
INSERT INTO public.who_global_data VALUES (11164, 484, 149149, 2, 9033, 48, 158);
INSERT INTO public.who_global_data VALUES (11165, 0, 154, 0, 3, 48, 67);
INSERT INTO public.who_global_data VALUES (11166, 643, 105524, 42, 3625, 48, 57);
INSERT INTO public.who_global_data VALUES (11167, 0, 12873, 0, 38, 48, 38);
INSERT INTO public.who_global_data VALUES (11168, 52544, 7162978, 823, 185650, 48, 141);
INSERT INTO public.who_global_data VALUES (11169, 0, 86, 0, 1, 48, 178);
INSERT INTO public.who_global_data VALUES (11170, 0, 152, 0, 3, 48, 108);
INSERT INTO public.who_global_data VALUES (11171, 1002, 191029, 55, 6551, 48, 39);
INSERT INTO public.who_global_data VALUES (11172, 122, 4954, 0, 74, 48, 2);
INSERT INTO public.who_global_data VALUES (11173, 0, 761, 1, 2, 48, 195);
INSERT INTO public.who_global_data VALUES (11174, 41, 11567, 1, 111, 48, 107);
INSERT INTO public.who_global_data VALUES (11175, 0, 362, 0, 0, 48, 161);
INSERT INTO public.who_global_data VALUES (11176, 125, 25849, 3, 448, 48, 212);
INSERT INTO public.who_global_data VALUES (11177, 6708, 495346, 124, 14040, 48, 181);
INSERT INTO public.who_global_data VALUES (11178, 0, 311, 0, 2, 48, 53);
INSERT INTO public.who_global_data VALUES (11179, 0, 4936, 0, 63, 48, 164);
INSERT INTO public.who_global_data VALUES (11180, 28, 1867, 0, 102, 48, 140);
INSERT INTO public.who_global_data VALUES (11181, 2219, 583354, 50, 16101, 48, 20);
INSERT INTO public.who_global_data VALUES (11182, 136, 95716, 0, 4770, 48, 112);
INSERT INTO public.who_global_data VALUES (11183, 13277, 1482072, 232, 40019, 48, 111);
INSERT INTO public.who_global_data VALUES (11184, 0, 643, 0, 7, 48, 71);
INSERT INTO public.who_global_data VALUES (11185, 0, 6200, 0, 100, 48, 218);
INSERT INTO public.who_global_data VALUES (11186, 0, 0, 0, 0, 48, 43);
INSERT INTO public.who_global_data VALUES (11187, 1084, 157472, 16, 1996, 48, 49);
INSERT INTO public.who_global_data VALUES (11188, 0, 21772, 0, 133, 48, 1);
INSERT INTO public.who_global_data VALUES (11189, 4727, 194962, 154, 3177, 48, 48);
INSERT INTO public.who_global_data VALUES (11190, 131, 10024, 0, 137, 48, 232);
INSERT INTO public.who_global_data VALUES (11191, 0, 3823, 0, 11, 48, 175);
INSERT INTO public.who_global_data VALUES (11192, 419, 17476, 2, 89, 48, 21);
INSERT INTO public.who_global_data VALUES (11193, 5304, 624140, 60, 10331, 48, 156);
INSERT INTO public.who_global_data VALUES (11194, 0, 0, 0, 0, 48, 95);
INSERT INTO public.who_global_data VALUES (11195, 123, 15210, 3, 369, 48, 177);
INSERT INTO public.who_global_data VALUES (11196, 3285, 131606, 12, 1019, 48, 210);
INSERT INTO public.who_global_data VALUES (11197, 1, 5781, 0, 61, 48, 120);
INSERT INTO public.who_global_data VALUES (11198, 0, 88, 0, 0, 48, 135);
INSERT INTO public.who_global_data VALUES (11199, 1135, 159064, 6, 2382, 48, 206);
INSERT INTO public.who_global_data VALUES (11200, 1671, 205920, 16, 13948, 48, 189);
INSERT INTO public.who_global_data VALUES (11201, 611, 124891, 28, 7069, 48, 129);
INSERT INTO public.who_global_data VALUES (11202, 798, 43195, 8, 1242, 48, 121);
INSERT INTO public.who_global_data VALUES (11203, 0, 5214, 0, 85, 48, 59);
INSERT INTO public.who_global_data VALUES (11204, 13, 754, 0, 0, 48, 96);
INSERT INTO public.who_global_data VALUES (11205, 575, 21794, 4, 174, 48, 41);
INSERT INTO public.who_global_data VALUES (11206, 103, 7305, 1, 137, 48, 216);
INSERT INTO public.who_global_data VALUES (11207, 469, 119494, 3, 1846, 48, 236);
INSERT INTO public.who_global_data VALUES (11208, 0, 23, 0, 0, 48, 150);
INSERT INTO public.who_global_data VALUES (11209, 0, 546, 0, 0, 48, 61);
INSERT INTO public.who_global_data VALUES (11210, 0, 46, 0, 2, 48, 7);
INSERT INTO public.who_global_data VALUES (11211, 0, 32582, 0, 489, 48, 169);
INSERT INTO public.who_global_data VALUES (11212, 17326, 2418439, 188, 60043, 48, 28);
INSERT INTO public.who_global_data VALUES (11213, 88, 12369, 0, 71, 48, 85);
INSERT INTO public.who_global_data VALUES (11214, 0, 16182, 0, 103, 48, 211);
INSERT INTO public.who_global_data VALUES (11215, 0, 9400, 0, 64, 48, 60);
INSERT INTO public.who_global_data VALUES (11216, 2, 3788, 0, 123, 48, 3);
INSERT INTO public.who_global_data VALUES (11217, 1731, 208638, 39, 2094, 48, 11);
INSERT INTO public.who_global_data VALUES (11218, 22771, 1494009, 409, 26049, 48, 89);
INSERT INTO public.who_global_data VALUES (11219, 0, 53653, 0, 331, 48, 24);
INSERT INTO public.who_global_data VALUES (11220, 31, 1184, 0, 6, 48, 162);
INSERT INTO public.who_global_data VALUES (11221, 901, 130485, 58, 4102, 48, 100);
INSERT INTO public.who_global_data VALUES (11222, 0, 19, 0, 0, 48, 47);
INSERT INTO public.who_global_data VALUES (11223, 0, 94, 0, 0, 48, 29);
INSERT INTO public.who_global_data VALUES (11224, 59, 8557, 1, 155, 48, 40);
INSERT INTO public.who_global_data VALUES (11225, 5, 7031, 0, 119, 48, 222);
INSERT INTO public.who_global_data VALUES (11226, 533, 132595, 35, 4624, 48, 132);
INSERT INTO public.who_global_data VALUES (11227, 0, 291, 0, 13, 48, 130);
INSERT INTO public.who_global_data VALUES (11228, 21, 13532, 0, 80, 48, 234);
INSERT INTO public.who_global_data VALUES (11229, 0, 2447, 0, 44, 48, 23);
INSERT INTO public.who_global_data VALUES (11230, 34, 6076, 1, 159, 48, 192);
INSERT INTO public.who_global_data VALUES (11231, 26, 9674, 0, 234, 48, 69);
INSERT INTO public.who_global_data VALUES (11232, 0, 26, 0, 0, 48, 187);
INSERT INTO public.who_global_data VALUES (11233, 738, 116212, 2, 3023, 48, 230);
INSERT INTO public.who_global_data VALUES (11234, 2967, 302989, 185, 8099, 48, 77);
INSERT INTO public.who_global_data VALUES (11235, 17, 5621, 0, 28, 48, 9);
INSERT INTO public.who_global_data VALUES (11236, 26624, 10031223, 341, 145477, 48, 74);
INSERT INTO public.who_global_data VALUES (11237, 7751, 657948, 145, 19659, 48, 224);
INSERT INTO public.who_global_data VALUES (11238, 6421, 1152072, 175, 53448, 48, 199);
INSERT INTO public.who_global_data VALUES (11239, 1307, 583118, 10, 12680, 48, 190);
INSERT INTO public.who_global_data VALUES (11240, 522, 78776, 5, 2154, 48, 12);
INSERT INTO public.who_global_data VALUES (11241, 0, 373, 0, 25, 48, 104);
INSERT INTO public.who_global_data VALUES (11242, 2792, 371365, 16, 3084, 48, 153);
INSERT INTO public.who_global_data VALUES (11243, 16305, 1938083, 553, 68447, 48, 91);
INSERT INTO public.who_global_data VALUES (11244, 96, 12135, 2, 285, 48, 215);
INSERT INTO public.who_global_data VALUES (11245, 2849, 195880, 45, 2873, 48, 84);
INSERT INTO public.who_global_data VALUES (11246, 136, 2234, 3, 36, 48, 231);
INSERT INTO public.who_global_data VALUES (11247, 1283, 272797, 27, 3545, 48, 196);
INSERT INTO public.who_global_data VALUES (11248, 681, 191650, 60, 2669, 48, 105);
INSERT INTO public.who_global_data VALUES (11249, 390, 94151, 4, 1633, 48, 122);
INSERT INTO public.who_global_data VALUES (11250, 0, 0, 0, 0, 48, 159);
INSERT INTO public.who_global_data VALUES (11251, 345, 48639, 8, 1238, 48, 75);
INSERT INTO public.who_global_data VALUES (11252, 244, 147775, 2, 918, 48, 27);
INSERT INTO public.who_global_data VALUES (11253, 211, 79122, 2, 1330, 48, 54);
INSERT INTO public.who_global_data VALUES (11254, 0, 41, 0, 0, 48, 226);
INSERT INTO public.who_global_data VALUES (11255, 870, 30297, 18, 427, 48, 79);
INSERT INTO public.who_global_data VALUES (11256, 1626, 156570, 11, 1270, 48, 56);
INSERT INTO public.who_global_data VALUES (11257, 0, 2285, 0, 44, 48, 117);
INSERT INTO public.who_global_data VALUES (11258, 0, 1779, 0, 83, 48, 152);
INSERT INTO public.who_global_data VALUES (11259, 0, 93772, 0, 1346, 48, 16);
INSERT INTO public.who_global_data VALUES (11260, 32, 1829, 0, 25, 48, 10);
INSERT INTO public.who_global_data VALUES (11261, 2917, 112359, 28, 1295, 48, 201);
INSERT INTO public.who_global_data VALUES (11262, 340, 44067, 6, 440, 48, 174);
INSERT INTO public.who_global_data VALUES (11263, 0, 17587, 0, 259, 48, 119);
INSERT INTO public.who_global_data VALUES (11264, 5, 6153, 0, 187, 48, 168);
INSERT INTO public.who_global_data VALUES (11265, 1153, 91969, 1, 433, 48, 99);
INSERT INTO public.who_global_data VALUES (11266, 30, 13474, 0, 48, 48, 171);
INSERT INTO public.who_global_data VALUES (11267, 115, 6164, 9, 220, 48, 87);
INSERT INTO public.who_global_data VALUES (11268, 52, 11621, 4, 187, 48, 123);
INSERT INTO public.who_global_data VALUES (11269, 0, 4, 0, 0, 48, 151);
INSERT INTO public.who_global_data VALUES (11270, 33, 5634, 0, 42, 48, 213);
INSERT INTO public.who_global_data VALUES (11271, 0, 10971, 0, 225, 48, 118);
INSERT INTO public.who_global_data VALUES (11272, 0, 524, 0, 10, 48, 134);
INSERT INTO public.who_global_data VALUES (11273, 0, 5708, 0, 53, 48, 65);
INSERT INTO public.who_global_data VALUES (11274, 12248, 1301546, 762, 117249, 48, 102);
INSERT INTO public.who_global_data VALUES (11275, 0, 0, 0, 0, 48, 223);
INSERT INTO public.who_global_data VALUES (11276, 8, 726, 0, 3, 48, 4);
INSERT INTO public.who_global_data VALUES (11277, 12, 953, 0, 0, 48, 146);
INSERT INTO public.who_global_data VALUES (11278, 268, 44271, 2, 625, 48, 31);
INSERT INTO public.who_global_data VALUES (11279, 0, 13, 0, 1, 48, 127);
INSERT INTO public.who_global_data VALUES (11280, 2833, 415226, 55, 6909, 48, 22);
INSERT INTO public.who_global_data VALUES (11281, 221, 17477, 2, 147, 48, 115);
INSERT INTO public.who_global_data VALUES (11282, 1116, 114198, 21, 2398, 48, 106);
INSERT INTO public.who_global_data VALUES (11283, 396, 18437, 2, 171, 48, 90);
INSERT INTO public.who_global_data VALUES (11284, 0, 0, 0, 0, 48, 70);
INSERT INTO public.who_global_data VALUES (11285, 710, 253184, 12, 1777, 48, 46);
INSERT INTO public.who_global_data VALUES (11286, 12229, 675591, 55, 10433, 48, 139);
INSERT INTO public.who_global_data VALUES (11287, 0, 37, 0, 0, 48, 42);
INSERT INTO public.who_global_data VALUES (11288, 6, 1760, 0, 25, 48, 80);
INSERT INTO public.who_global_data VALUES (11289, 0, 4748, 0, 163, 48, 203);
INSERT INTO public.who_global_data VALUES (11290, 0, 2361, 0, 82, 48, 136);
INSERT INTO public.who_global_data VALUES (11291, 920, 77933, 6, 1218, 48, 63);
INSERT INTO public.who_global_data VALUES (11292, 0, 0, 0, 0, 48, 17);
INSERT INTO public.who_global_data VALUES (11293, 1, 116, 0, 2, 48, 172);
INSERT INTO public.who_global_data VALUES (11294, 815, 77949, 20, 2274, 48, 109);
INSERT INTO public.who_global_data VALUES (11295, 0, 42775, 0, 404, 48, 200);
INSERT INTO public.who_global_data VALUES (11296, 1750, 137106, 25, 1232, 48, 93);
INSERT INTO public.who_global_data VALUES (11297, 0, 127019, 0, 1483, 48, 5);
INSERT INTO public.who_global_data VALUES (11298, 0, 744, 0, 13, 48, 214);
INSERT INTO public.who_global_data VALUES (11299, 3179, 454673, 86, 9250, 48, 204);
INSERT INTO public.who_global_data VALUES (11300, 0, 0, 0, 0, 48, 198);
INSERT INTO public.who_global_data VALUES (11301, 3015, 206310, 23, 3504, 48, 173);
INSERT INTO public.who_global_data VALUES (11302, 0, 760, 0, 8, 48, 229);
INSERT INTO public.who_global_data VALUES (11303, 1268, 98296, 18, 2050, 48, 76);
INSERT INTO public.who_global_data VALUES (11304, 2242, 993760, 68, 36969, 48, 138);
INSERT INTO public.who_global_data VALUES (11305, 1482, 458044, 36, 8911, 48, 98);
INSERT INTO public.who_global_data VALUES (11306, 0, 0, 0, 0, 48, 103);
INSERT INTO public.who_global_data VALUES (11307, 8590, 1202700, 143, 25397, 48, 225);
INSERT INTO public.who_global_data VALUES (11308, 3835, 370787, 86, 6063, 48, 131);
INSERT INTO public.who_global_data VALUES (11309, 1079, 67211, 9, 1342, 48, 235);
INSERT INTO public.who_global_data VALUES (11310, 142, 141858, 1, 243, 48, 137);
INSERT INTO public.who_global_data VALUES (11311, 1097, 49657, 15, 674, 48, 81);
INSERT INTO public.who_global_data VALUES (11312, 1218, 134578, 27, 2727, 48, 182);
INSERT INTO public.who_global_data VALUES (11313, 0, 8704, 0, 42, 48, 145);
INSERT INTO public.who_global_data VALUES (11314, 5158, 587944, 139, 14296, 48, 26);
INSERT INTO public.who_global_data VALUES (11315, 28948, 2848377, 511, 50858, 48, 170);
INSERT INTO public.who_global_data VALUES (11316, 127, 7232, 2, 59, 48, 191);
INSERT INTO public.who_global_data VALUES (11317, 0, 5, 0, 0, 48, 221);
INSERT INTO public.who_global_data VALUES (11318, 10, 182, 0, 0, 48, 64);
INSERT INTO public.who_global_data VALUES (11319, 0, 0, 0, 0, 48, 116);
INSERT INTO public.who_global_data VALUES (11320, 0, 30, 0, 0, 48, 128);
INSERT INTO public.who_global_data VALUES (11321, 0, 280, 0, 5, 48, 6);
INSERT INTO public.who_global_data VALUES (11322, 49, 948, 0, 12, 48, 227);
INSERT INTO public.who_global_data VALUES (11323, 0, 14, 0, 0, 48, 68);
INSERT INTO public.who_global_data VALUES (11324, 0, 100, 0, 0, 48, 184);
INSERT INTO public.who_global_data VALUES (11325, 0, 2, 0, 0, 48, 82);
INSERT INTO public.who_global_data VALUES (11326, 58, 2107, 0, 55, 48, 149);
INSERT INTO public.who_global_data VALUES (11327, 1, 1012, 0, 17, 48, 197);
INSERT INTO public.who_global_data VALUES (11328, 158, 360848, 11, 6112, 48, 78);
INSERT INTO public.who_global_data VALUES (11329, 111, 17670, 4, 361, 48, 233);
INSERT INTO public.who_global_data VALUES (11330, 3888, 296528, 52, 2632, 48, 133);
INSERT INTO public.who_global_data VALUES (11331, 0, 202, 0, 0, 48, 35);
INSERT INTO public.who_global_data VALUES (11332, 0, 2486, 0, 75, 48, 114);
INSERT INTO public.who_global_data VALUES (11333, 17, 58403, 0, 29, 48, 237);
INSERT INTO public.who_global_data VALUES (11334, 0, 18, 0, 0, 48, 55);
INSERT INTO public.who_global_data VALUES (11335, 0, 1294, 0, 26, 48, 176);
INSERT INTO public.who_global_data VALUES (11336, 2061, 151336, 45, 1555, 48, 202);
INSERT INTO public.who_global_data VALUES (11337, 884, 105910, 40, 2591, 48, 155);
INSERT INTO public.who_global_data VALUES (11338, 0, 17, 0, 0, 48, 32);
INSERT INTO public.who_global_data VALUES (11339, 0, 4662, 0, 124, 48, 220);
INSERT INTO public.who_global_data VALUES (11340, 10939, 912477, 254, 24539, 48, 30);
INSERT INTO public.who_global_data VALUES (11341, 0, 3228, 0, 62, 48, 147);
INSERT INTO public.who_global_data VALUES (11342, 12478, 1871761, 158, 50120, 48, 208);
INSERT INTO public.who_global_data VALUES (11343, 662, 36049, 5, 165, 48, 45);
INSERT INTO public.who_global_data VALUES (11344, 110, 23100, 11, 1461, 48, 110);
INSERT INTO public.who_global_data VALUES (11345, 31, 5459, 0, 117, 48, 88);
INSERT INTO public.who_global_data VALUES (11346, 7918, 374947, 71, 8644, 48, 51);
INSERT INTO public.who_global_data VALUES (11347, 2675, 411530, 79, 6353, 48, 209);
INSERT INTO public.who_global_data VALUES (11348, 122, 10050, 10, 601, 48, 205);
INSERT INTO public.who_global_data VALUES (11349, 57, 13239, 0, 89, 48, 18);
INSERT INTO public.who_global_data VALUES (11350, 34, 4331, 0, 60, 48, 72);
INSERT INTO public.who_global_data VALUES (11351, 27052, 2004223, 534, 67075, 48, 44);
INSERT INTO public.who_global_data VALUES (11352, 0, 31, 0, 0, 48, 15);
INSERT INTO public.who_global_data VALUES (11353, 81, 3396, 0, 66, 48, 25);
INSERT INTO public.who_global_data VALUES (11354, 0, 0, 0, 0, 48, 179);
INSERT INTO public.who_global_data VALUES (11355, 0, 0, 0, 0, 48, 34);
INSERT INTO public.who_global_data VALUES (11356, 15, 6955, 0, 123, 48, 207);
INSERT INTO public.who_global_data VALUES (11357, 1569, 119151, 36, 4126, 48, 166);
INSERT INTO public.who_global_data VALUES (11358, 22195, 2004285, 241, 17851, 48, 126);
INSERT INTO public.who_global_data VALUES (11359, 0, 0, 0, 0, 48, 97);
INSERT INTO public.who_global_data VALUES (11360, 8, 789, 0, 6, 48, 36);
INSERT INTO public.who_global_data VALUES (11361, 0, 0, 0, 0, 48, 125);
INSERT INTO public.who_global_data VALUES (11362, 631, 30702, 0, 230, 48, 124);
INSERT INTO public.who_global_data VALUES (11363, 8325, 964448, 116, 16585, 48, 185);
INSERT INTO public.who_global_data VALUES (11364, 1254, 192404, 4, 634, 48, 194);
INSERT INTO public.who_global_data VALUES (11365, 0, 509, 0, 21, 48, 144);
INSERT INTO public.who_global_data VALUES (11366, 402270, 17314834, 2747, 311150, 48, 19);
INSERT INTO public.who_global_data VALUES (11367, 10, 1910, 0, 23, 48, 217);
INSERT INTO public.who_global_data VALUES (11368, 514, 11950, 4, 109, 48, 148);
INSERT INTO public.who_global_data VALUES (11369, 0, 75806, 0, 612, 48, 86);
INSERT INTO public.who_global_data VALUES (11370, 0, 1, 0, 0, 48, 13);
INSERT INTO public.who_global_data VALUES (11371, 314, 109395, 4, 979, 48, 157);
INSERT INTO public.who_global_data VALUES (11372, 1, 1411, 0, 35, 48, 8);
INSERT INTO public.who_global_data VALUES (11373, 0, 4, 0, 0, 48, 73);
INSERT INTO public.who_global_data VALUES (11374, 0, 2091, 0, 607, 48, 101);
INSERT INTO public.who_global_data VALUES (11375, 44, 18620, 0, 373, 48, 165);
INSERT INTO public.who_global_data VALUES (11376, 104, 12151, 2, 318, 48, 14);
INSERT INTO public.who_global_data VALUES (11377, 254, 50456, 5, 2037, 49, 193);
INSERT INTO public.who_global_data VALUES (11378, 580, 52004, 11, 1066, 49, 113);
INSERT INTO public.who_global_data VALUES (11379, 438, 94371, 7, 2647, 49, 143);
INSERT INTO public.who_global_data VALUES (11380, 0, 0, 0, 0, 49, 219);
INSERT INTO public.who_global_data VALUES (11381, 53, 7519, 1, 80, 49, 186);
INSERT INTO public.who_global_data VALUES (11382, 78, 16562, 2, 384, 49, 52);
INSERT INTO public.who_global_data VALUES (11383, 0, 10, 0, 0, 49, 180);
INSERT INTO public.who_global_data VALUES (11384, 0, 151, 0, 5, 49, 167);
INSERT INTO public.who_global_data VALUES (11385, 7326, 1524372, 169, 41534, 49, 154);
INSERT INTO public.who_global_data VALUES (11386, 920, 152486, 20, 2611, 49, 94);
INSERT INTO public.who_global_data VALUES (11387, 18, 5124, 0, 47, 49, 66);
INSERT INTO public.who_global_data VALUES (11388, 22, 28094, 0, 908, 49, 58);
INSERT INTO public.who_global_data VALUES (11389, 1914, 332371, 131, 5017, 49, 163);
INSERT INTO public.who_global_data VALUES (11390, 3962, 195422, 45, 2133, 49, 37);
INSERT INTO public.who_global_data VALUES (11391, 8, 7733, 0, 164, 49, 142);
INSERT INTO public.who_global_data VALUES (11392, 140, 89883, 0, 349, 49, 83);
INSERT INTO public.who_global_data VALUES (11393, 1318, 498293, 25, 7217, 49, 228);
INSERT INTO public.who_global_data VALUES (11394, 4, 305, 0, 7, 49, 188);
INSERT INTO public.who_global_data VALUES (11395, 1917, 169648, 9, 1308, 49, 62);
INSERT INTO public.who_global_data VALUES (11396, 2835, 625624, 83, 18576, 49, 160);
INSERT INTO public.who_global_data VALUES (11397, 119, 9791, 1, 213, 49, 50);
INSERT INTO public.who_global_data VALUES (11398, 0, 3152, 0, 44, 49, 33);
INSERT INTO public.who_global_data VALUES (11399, 12, 497, 0, 9, 49, 183);
INSERT INTO public.who_global_data VALUES (11400, 1, 443, 0, 0, 49, 92);
INSERT INTO public.who_global_data VALUES (11401, 451, 148665, 2, 9031, 49, 158);
INSERT INTO public.who_global_data VALUES (11402, 0, 154, 0, 3, 49, 67);
INSERT INTO public.who_global_data VALUES (11403, 784, 104881, 34, 3583, 49, 57);
INSERT INTO public.who_global_data VALUES (11404, 0, 12873, 0, 38, 49, 38);
INSERT INTO public.who_global_data VALUES (11405, 69826, 7110434, 1092, 184827, 49, 141);
INSERT INTO public.who_global_data VALUES (11406, 3, 86, 0, 1, 49, 178);
INSERT INTO public.who_global_data VALUES (11407, 0, 152, 0, 3, 49, 108);
INSERT INTO public.who_global_data VALUES (11408, 1739, 190027, 157, 6496, 49, 39);
INSERT INTO public.who_global_data VALUES (11409, 221, 4832, 1, 74, 49, 2);
INSERT INTO public.who_global_data VALUES (11410, 5, 761, 0, 1, 49, 195);
INSERT INTO public.who_global_data VALUES (11411, 24, 11526, 0, 110, 49, 107);
INSERT INTO public.who_global_data VALUES (11412, 0, 362, 0, 0, 49, 161);
INSERT INTO public.who_global_data VALUES (11413, 252, 25724, 0, 445, 49, 212);
INSERT INTO public.who_global_data VALUES (11414, 7008, 488638, 117, 13916, 49, 181);
INSERT INTO public.who_global_data VALUES (11415, 3, 311, 0, 2, 49, 53);
INSERT INTO public.who_global_data VALUES (11416, 0, 4936, 0, 63, 49, 164);
INSERT INTO public.who_global_data VALUES (11417, 21, 1839, 0, 102, 49, 140);
INSERT INTO public.who_global_data VALUES (11418, 2403, 581135, 44, 16051, 49, 20);
INSERT INTO public.who_global_data VALUES (11419, 89, 95580, 4, 4770, 49, 112);
INSERT INTO public.who_global_data VALUES (11420, 12196, 1468795, 227, 39787, 49, 111);
INSERT INTO public.who_global_data VALUES (11421, 10, 643, 0, 7, 49, 71);
INSERT INTO public.who_global_data VALUES (11422, 0, 6200, 0, 100, 49, 218);
INSERT INTO public.who_global_data VALUES (11423, 0, 0, 0, 0, 49, 43);
INSERT INTO public.who_global_data VALUES (11424, 1125, 156388, 13, 1980, 49, 49);
INSERT INTO public.who_global_data VALUES (11425, 0, 21772, 0, 133, 49, 1);
INSERT INTO public.who_global_data VALUES (11426, 3272, 190235, 68, 3023, 49, 48);
INSERT INTO public.who_global_data VALUES (11427, 122, 9893, 0, 137, 49, 232);
INSERT INTO public.who_global_data VALUES (11428, 56, 3823, 0, 11, 49, 175);
INSERT INTO public.who_global_data VALUES (11429, 410, 17057, 2, 87, 49, 21);
INSERT INTO public.who_global_data VALUES (11430, 8830, 618836, 108, 10271, 49, 156);
INSERT INTO public.who_global_data VALUES (11431, 0, 0, 0, 0, 49, 95);
INSERT INTO public.who_global_data VALUES (11432, 159, 15087, 0, 366, 49, 177);
INSERT INTO public.who_global_data VALUES (11433, 4508, 128321, 15, 1007, 49, 210);
INSERT INTO public.who_global_data VALUES (11434, 10, 5780, 0, 61, 49, 120);
INSERT INTO public.who_global_data VALUES (11435, 0, 88, 0, 0, 49, 135);
INSERT INTO public.who_global_data VALUES (11436, 624, 157929, 1, 2376, 49, 206);
INSERT INTO public.who_global_data VALUES (11437, 0, 204249, 0, 13932, 49, 189);
INSERT INTO public.who_global_data VALUES (11438, 579, 124280, 26, 7041, 49, 129);
INSERT INTO public.who_global_data VALUES (11439, 0, 42397, 7, 1234, 49, 121);
INSERT INTO public.who_global_data VALUES (11440, 0, 5214, 0, 85, 49, 59);
INSERT INTO public.who_global_data VALUES (11441, 0, 741, 0, 0, 49, 96);
INSERT INTO public.who_global_data VALUES (11442, 561, 21219, 2, 170, 49, 41);
INSERT INTO public.who_global_data VALUES (11443, 109, 7202, 1, 136, 49, 216);
INSERT INTO public.who_global_data VALUES (11444, 544, 119025, 12, 1843, 49, 236);
INSERT INTO public.who_global_data VALUES (11445, 0, 23, 0, 0, 49, 150);
INSERT INTO public.who_global_data VALUES (11446, 12, 546, 0, 0, 49, 61);
INSERT INTO public.who_global_data VALUES (11447, 0, 46, 0, 2, 49, 7);
INSERT INTO public.who_global_data VALUES (11448, 354, 32582, 5, 489, 49, 169);
INSERT INTO public.who_global_data VALUES (11449, 15440, 2401113, 610, 59855, 49, 28);
INSERT INTO public.who_global_data VALUES (11450, 118, 12281, 0, 71, 49, 85);
INSERT INTO public.who_global_data VALUES (11451, 64, 16182, 2, 103, 49, 211);
INSERT INTO public.who_global_data VALUES (11452, 27, 9400, 1, 64, 49, 60);
INSERT INTO public.who_global_data VALUES (11453, 0, 3786, 0, 123, 49, 3);
INSERT INTO public.who_global_data VALUES (11454, 2904, 206907, 53, 2055, 49, 11);
INSERT INTO public.who_global_data VALUES (11455, 31300, 1471238, 702, 25640, 49, 89);
INSERT INTO public.who_global_data VALUES (11456, 100, 53653, 0, 331, 49, 24);
INSERT INTO public.who_global_data VALUES (11457, 28, 1153, 0, 6, 49, 162);
INSERT INTO public.who_global_data VALUES (11458, 874, 129584, 96, 4044, 49, 100);
INSERT INTO public.who_global_data VALUES (11459, 0, 19, 0, 0, 49, 47);
INSERT INTO public.who_global_data VALUES (11460, 9, 94, 0, 0, 49, 29);
INSERT INTO public.who_global_data VALUES (11461, 0, 8498, 0, 154, 49, 40);
INSERT INTO public.who_global_data VALUES (11462, 9, 7026, 0, 119, 49, 222);
INSERT INTO public.who_global_data VALUES (11463, 627, 132062, 38, 4589, 49, 132);
INSERT INTO public.who_global_data VALUES (11464, 0, 291, 0, 13, 49, 130);
INSERT INTO public.who_global_data VALUES (11465, 26, 13511, 0, 80, 49, 234);
INSERT INTO public.who_global_data VALUES (11466, 0, 2447, 0, 44, 49, 23);
INSERT INTO public.who_global_data VALUES (11467, 26, 6042, 0, 158, 49, 192);
INSERT INTO public.who_global_data VALUES (11468, 21, 9648, 0, 234, 49, 69);
INSERT INTO public.who_global_data VALUES (11469, 0, 26, 0, 0, 49, 187);
INSERT INTO public.who_global_data VALUES (11470, 157, 115474, 8, 3021, 49, 230);
INSERT INTO public.who_global_data VALUES (11471, 4045, 300022, 189, 7914, 49, 77);
INSERT INTO public.who_global_data VALUES (11472, 16, 5604, 0, 28, 49, 9);
INSERT INTO public.who_global_data VALUES (11473, 25152, 10004599, 347, 145136, 49, 74);
INSERT INTO public.who_global_data VALUES (11474, 6689, 650197, 124, 19514, 49, 224);
INSERT INTO public.who_global_data VALUES (11475, 7121, 1145651, 178, 53273, 49, 199);
INSERT INTO public.who_global_data VALUES (11476, 1362, 581811, 20, 12670, 49, 190);
INSERT INTO public.who_global_data VALUES (11477, 576, 78254, 6, 2149, 49, 12);
INSERT INTO public.who_global_data VALUES (11478, 0, 373, 0, 25, 49, 104);
INSERT INTO public.who_global_data VALUES (11479, 2846, 368573, 17, 3068, 49, 153);
INSERT INTO public.who_global_data VALUES (11480, 15401, 1921778, 674, 67894, 49, 91);
INSERT INTO public.who_global_data VALUES (11481, 71, 12039, 4, 283, 49, 215);
INSERT INTO public.who_global_data VALUES (11482, 2893, 193031, 45, 2828, 49, 84);
INSERT INTO public.who_global_data VALUES (11483, 97, 2098, 1, 33, 49, 231);
INSERT INTO public.who_global_data VALUES (11484, 1708, 271514, 22, 3518, 49, 196);
INSERT INTO public.who_global_data VALUES (11485, 677, 190969, 0, 2609, 49, 105);
INSERT INTO public.who_global_data VALUES (11486, 356, 93761, 11, 1629, 49, 122);
INSERT INTO public.who_global_data VALUES (11487, 0, 0, 0, 0, 49, 159);
INSERT INTO public.who_global_data VALUES (11488, 385, 48294, 7, 1230, 49, 75);
INSERT INTO public.who_global_data VALUES (11489, 339, 147531, 3, 916, 49, 27);
INSERT INTO public.who_global_data VALUES (11490, 232, 78911, 4, 1328, 49, 54);
INSERT INTO public.who_global_data VALUES (11491, 0, 41, 0, 0, 49, 226);
INSERT INTO public.who_global_data VALUES (11492, 892, 29427, 15, 409, 49, 79);
INSERT INTO public.who_global_data VALUES (11493, 2051, 154944, 11, 1259, 49, 56);
INSERT INTO public.who_global_data VALUES (11494, 0, 2285, 0, 44, 49, 117);
INSERT INTO public.who_global_data VALUES (11495, 8, 1779, 0, 83, 49, 152);
INSERT INTO public.who_global_data VALUES (11496, 489, 93772, 9, 1346, 49, 16);
INSERT INTO public.who_global_data VALUES (11497, 48, 1797, 2, 25, 49, 10);
INSERT INTO public.who_global_data VALUES (11498, 3222, 109442, 46, 1267, 49, 201);
INSERT INTO public.who_global_data VALUES (11499, 449, 43727, 6, 434, 49, 174);
INSERT INTO public.who_global_data VALUES (11500, 0, 17587, 0, 259, 49, 119);
INSERT INTO public.who_global_data VALUES (11501, 10, 6148, 0, 187, 49, 168);
INSERT INTO public.who_global_data VALUES (11502, 1683, 90816, 0, 432, 49, 99);
INSERT INTO public.who_global_data VALUES (11503, 26, 13444, 0, 48, 49, 171);
INSERT INTO public.who_global_data VALUES (11504, 0, 6049, 0, 211, 49, 87);
INSERT INTO public.who_global_data VALUES (11505, 94, 11569, 1, 183, 49, 123);
INSERT INTO public.who_global_data VALUES (11506, 0, 4, 0, 0, 49, 151);
INSERT INTO public.who_global_data VALUES (11507, 0, 5601, 0, 42, 49, 213);
INSERT INTO public.who_global_data VALUES (11508, 0, 10971, 0, 225, 49, 118);
INSERT INTO public.who_global_data VALUES (11509, 0, 524, 0, 10, 49, 134);
INSERT INTO public.who_global_data VALUES (11510, 0, 5708, 0, 53, 49, 65);
INSERT INTO public.who_global_data VALUES (11511, 11799, 1289298, 718, 116487, 49, 102);
INSERT INTO public.who_global_data VALUES (11512, 0, 0, 0, 0, 49, 223);
INSERT INTO public.who_global_data VALUES (11513, 15, 718, 0, 3, 49, 4);
INSERT INTO public.who_global_data VALUES (11514, 18, 941, 0, 0, 49, 146);
INSERT INTO public.who_global_data VALUES (11515, 304, 44003, 4, 623, 49, 31);
INSERT INTO public.who_global_data VALUES (11516, 0, 13, 0, 1, 49, 127);
INSERT INTO public.who_global_data VALUES (11517, 2647, 412393, 50, 6854, 49, 22);
INSERT INTO public.who_global_data VALUES (11518, 0, 17256, 0, 145, 49, 115);
INSERT INTO public.who_global_data VALUES (11519, 1182, 113082, 31, 2377, 49, 106);
INSERT INTO public.who_global_data VALUES (11520, 434, 18041, 5, 169, 49, 90);
INSERT INTO public.who_global_data VALUES (11521, 0, 0, 0, 0, 49, 70);
INSERT INTO public.who_global_data VALUES (11522, 782, 252474, 16, 1765, 49, 46);
INSERT INTO public.who_global_data VALUES (11523, 11962, 663362, 83, 10378, 49, 139);
INSERT INTO public.who_global_data VALUES (11524, 0, 37, 0, 0, 49, 42);
INSERT INTO public.who_global_data VALUES (11525, 0, 1754, 0, 25, 49, 80);
INSERT INTO public.who_global_data VALUES (11526, 0, 4748, 0, 163, 49, 203);
INSERT INTO public.who_global_data VALUES (11527, 283, 2361, 5, 82, 49, 136);
INSERT INTO public.who_global_data VALUES (11528, 806, 77013, 11, 1212, 49, 63);
INSERT INTO public.who_global_data VALUES (11529, 0, 0, 0, 0, 49, 17);
INSERT INTO public.who_global_data VALUES (11530, 0, 115, 0, 2, 49, 172);
INSERT INTO public.who_global_data VALUES (11531, 883, 77134, 29, 2254, 49, 109);
INSERT INTO public.who_global_data VALUES (11532, 463, 42775, 0, 404, 49, 200);
INSERT INTO public.who_global_data VALUES (11533, 2170, 135356, 21, 1207, 49, 93);
INSERT INTO public.who_global_data VALUES (11534, 0, 127019, 0, 1483, 49, 5);
INSERT INTO public.who_global_data VALUES (11535, 0, 744, 0, 13, 49, 214);
INSERT INTO public.who_global_data VALUES (11536, 2972, 451494, 84, 9164, 49, 204);
INSERT INTO public.who_global_data VALUES (11537, 0, 0, 0, 0, 49, 198);
INSERT INTO public.who_global_data VALUES (11538, 3348, 203295, 42, 3481, 49, 173);
INSERT INTO public.who_global_data VALUES (11539, 0, 760, 0, 8, 49, 229);
INSERT INTO public.who_global_data VALUES (11540, 819, 97028, 18, 2032, 49, 76);
INSERT INTO public.who_global_data VALUES (11541, 2061, 991518, 43, 36901, 49, 138);
INSERT INTO public.who_global_data VALUES (11542, 2115, 456562, 25, 8875, 49, 98);
INSERT INTO public.who_global_data VALUES (11543, 0, 0, 0, 0, 49, 103);
INSERT INTO public.who_global_data VALUES (11544, 11246, 1194110, 483, 25254, 49, 225);
INSERT INTO public.who_global_data VALUES (11545, 4336, 366952, 75, 5977, 49, 131);
INSERT INTO public.who_global_data VALUES (11546, 1381, 66132, 10, 1333, 49, 235);
INSERT INTO public.who_global_data VALUES (11547, 159, 141716, 0, 242, 49, 137);
INSERT INTO public.who_global_data VALUES (11548, 1046, 48560, 14, 659, 49, 81);
INSERT INTO public.who_global_data VALUES (11549, 1441, 133360, 26, 2700, 49, 182);
INSERT INTO public.who_global_data VALUES (11550, 116, 8704, 0, 42, 49, 145);
INSERT INTO public.who_global_data VALUES (11551, 5340, 582786, 188, 14157, 49, 26);
INSERT INTO public.who_global_data VALUES (11552, 28209, 2819429, 585, 50347, 49, 170);
INSERT INTO public.who_global_data VALUES (11553, 73, 7105, 0, 57, 49, 191);
INSERT INTO public.who_global_data VALUES (11554, 0, 5, 0, 0, 49, 221);
INSERT INTO public.who_global_data VALUES (11555, 0, 172, 0, 0, 49, 64);
INSERT INTO public.who_global_data VALUES (11556, 0, 0, 0, 0, 49, 116);
INSERT INTO public.who_global_data VALUES (11557, 2, 30, 0, 0, 49, 128);
INSERT INTO public.who_global_data VALUES (11558, 1, 280, 1, 5, 49, 6);
INSERT INTO public.who_global_data VALUES (11559, 0, 899, 0, 12, 49, 227);
INSERT INTO public.who_global_data VALUES (11560, 0, 14, 0, 0, 49, 68);
INSERT INTO public.who_global_data VALUES (11561, 0, 100, 0, 0, 49, 184);
INSERT INTO public.who_global_data VALUES (11562, 0, 2, 0, 0, 49, 82);
INSERT INTO public.who_global_data VALUES (11563, 0, 2049, 1, 55, 49, 149);
INSERT INTO public.who_global_data VALUES (11564, 0, 1011, 0, 17, 49, 197);
INSERT INTO public.who_global_data VALUES (11565, 174, 360690, 10, 6101, 49, 78);
INSERT INTO public.who_global_data VALUES (11566, 108, 17559, 2, 357, 49, 233);
INSERT INTO public.who_global_data VALUES (11567, 4910, 292640, 51, 2580, 49, 133);
INSERT INTO public.who_global_data VALUES (11568, 0, 202, 0, 0, 49, 35);
INSERT INTO public.who_global_data VALUES (11569, 22, 2486, 0, 75, 49, 114);
INSERT INTO public.who_global_data VALUES (11570, 9, 58386, 0, 29, 49, 237);
INSERT INTO public.who_global_data VALUES (11571, 0, 18, 0, 0, 49, 55);
INSERT INTO public.who_global_data VALUES (11572, 18, 1294, 0, 26, 49, 176);
INSERT INTO public.who_global_data VALUES (11573, 3151, 149275, 70, 1510, 49, 202);
INSERT INTO public.who_global_data VALUES (11574, 1430, 105026, 42, 2551, 49, 155);
INSERT INTO public.who_global_data VALUES (11575, 0, 17, 0, 0, 49, 32);
INSERT INTO public.who_global_data VALUES (11576, 0, 4662, 0, 124, 49, 220);
INSERT INTO public.who_global_data VALUES (11577, 8725, 901538, 274, 24285, 49, 30);
INSERT INTO public.who_global_data VALUES (11578, 5, 3228, 0, 62, 49, 147);
INSERT INTO public.who_global_data VALUES (11579, 11124, 1859283, 156, 49962, 49, 208);
INSERT INTO public.who_global_data VALUES (11580, 0, 35387, 0, 160, 49, 45);
INSERT INTO public.who_global_data VALUES (11581, 167, 22990, 16, 1450, 49, 110);
INSERT INTO public.who_global_data VALUES (11582, 27, 5428, 0, 117, 49, 88);
INSERT INTO public.who_global_data VALUES (11583, 9640, 367029, 117, 8573, 49, 51);
INSERT INTO public.who_global_data VALUES (11584, 4340, 408855, 88, 6274, 49, 209);
INSERT INTO public.who_global_data VALUES (11585, 169, 9928, 20, 591, 49, 205);
INSERT INTO public.who_global_data VALUES (11586, 46, 13182, 0, 89, 49, 18);
INSERT INTO public.who_global_data VALUES (11587, 16, 4297, 0, 60, 49, 72);
INSERT INTO public.who_global_data VALUES (11588, 28507, 1977171, 489, 66541, 49, 44);
INSERT INTO public.who_global_data VALUES (11589, 0, 31, 0, 0, 49, 15);
INSERT INTO public.who_global_data VALUES (11590, 0, 3315, 0, 66, 49, 25);
INSERT INTO public.who_global_data VALUES (11591, 0, 0, 0, 0, 49, 179);
INSERT INTO public.who_global_data VALUES (11592, 0, 0, 0, 0, 49, 34);
INSERT INTO public.who_global_data VALUES (11593, 23, 6940, 0, 123, 49, 207);
INSERT INTO public.who_global_data VALUES (11594, 1616, 117582, 58, 4090, 49, 166);
INSERT INTO public.who_global_data VALUES (11595, 26410, 1982090, 246, 17610, 49, 126);
INSERT INTO public.who_global_data VALUES (11596, 0, 0, 0, 0, 49, 97);
INSERT INTO public.who_global_data VALUES (11597, 9, 781, 0, 6, 49, 36);
INSERT INTO public.who_global_data VALUES (11598, 0, 0, 0, 0, 49, 125);
INSERT INTO public.who_global_data VALUES (11599, 710, 30071, 2, 230, 49, 124);
INSERT INTO public.who_global_data VALUES (11600, 11742, 956123, 213, 16469, 49, 185);
INSERT INTO public.who_global_data VALUES (11601, 1284, 191150, 1, 630, 49, 194);
INSERT INTO public.who_global_data VALUES (11602, 0, 509, 0, 21, 49, 144);
INSERT INTO public.who_global_data VALUES (11603, 229915, 16912564, 3443, 308403, 49, 19);
INSERT INTO public.who_global_data VALUES (11604, 22, 1900, 0, 23, 49, 217);
INSERT INTO public.who_global_data VALUES (11605, 543, 11436, 3, 105, 49, 148);
INSERT INTO public.who_global_data VALUES (11606, 131, 75806, 0, 612, 49, 86);
INSERT INTO public.who_global_data VALUES (11607, 0, 1, 0, 0, 49, 13);
INSERT INTO public.who_global_data VALUES (11608, 364, 109081, 5, 975, 49, 157);
INSERT INTO public.who_global_data VALUES (11609, 3, 1410, 0, 35, 49, 8);
INSERT INTO public.who_global_data VALUES (11610, 0, 4, 0, 0, 49, 73);
INSERT INTO public.who_global_data VALUES (11611, 0, 2091, 0, 607, 49, 101);
INSERT INTO public.who_global_data VALUES (11612, 72, 18576, 4, 373, 49, 165);
INSERT INTO public.who_global_data VALUES (11613, 181, 12047, 2, 316, 49, 14);
INSERT INTO public.who_global_data VALUES (11614, 275, 50202, 15, 2032, 50, 193);
INSERT INTO public.who_global_data VALUES (11615, 787, 51424, 15, 1055, 50, 113);
INSERT INTO public.who_global_data VALUES (11616, 426, 93933, 9, 2640, 50, 143);
INSERT INTO public.who_global_data VALUES (11617, 0, 0, 0, 0, 50, 219);
INSERT INTO public.who_global_data VALUES (11618, 20, 7466, 0, 79, 50, 186);
INSERT INTO public.who_global_data VALUES (11619, 77, 16484, 3, 382, 50, 52);
INSERT INTO public.who_global_data VALUES (11620, 0, 10, 0, 0, 50, 180);
INSERT INTO public.who_global_data VALUES (11621, 0, 151, 0, 5, 50, 167);
INSERT INTO public.who_global_data VALUES (11622, 6843, 1517046, 161, 41365, 50, 154);
INSERT INTO public.who_global_data VALUES (11623, 861, 151566, 15, 2591, 50, 94);
INSERT INTO public.who_global_data VALUES (11624, 27, 5106, 1, 47, 50, 66);
INSERT INTO public.who_global_data VALUES (11625, 13, 28072, 0, 908, 50, 58);
INSERT INTO public.who_global_data VALUES (11626, 2180, 330457, 108, 4886, 50, 163);
INSERT INTO public.who_global_data VALUES (11627, 4124, 191460, 38, 2088, 50, 37);
INSERT INTO public.who_global_data VALUES (11628, 11, 7725, 0, 164, 50, 142);
INSERT INTO public.who_global_data VALUES (11629, 143, 89743, 0, 349, 50, 83);
INSERT INTO public.who_global_data VALUES (11630, 1134, 496975, 36, 7192, 50, 228);
INSERT INTO public.who_global_data VALUES (11631, 0, 301, 0, 7, 50, 188);
INSERT INTO public.who_global_data VALUES (11632, 1834, 167731, 8, 1299, 50, 62);
INSERT INTO public.who_global_data VALUES (11633, 2794, 622789, 89, 18493, 50, 160);
INSERT INTO public.who_global_data VALUES (11634, 161, 9672, 1, 212, 50, 50);
INSERT INTO public.who_global_data VALUES (11635, 0, 3152, 0, 44, 50, 33);
INSERT INTO public.who_global_data VALUES (11636, 18, 485, 0, 9, 50, 183);
INSERT INTO public.who_global_data VALUES (11637, 2, 442, 0, 0, 50, 92);
INSERT INTO public.who_global_data VALUES (11638, 498, 148214, 3, 9029, 50, 158);
INSERT INTO public.who_global_data VALUES (11639, 0, 154, 0, 3, 50, 67);
INSERT INTO public.who_global_data VALUES (11640, 865, 104097, 38, 3549, 50, 57);
INSERT INTO public.who_global_data VALUES (11641, 0, 12873, 0, 38, 50, 38);
INSERT INTO public.who_global_data VALUES (11642, 70574, 7040608, 936, 183735, 50, 141);
INSERT INTO public.who_global_data VALUES (11643, 3, 83, 0, 1, 50, 178);
INSERT INTO public.who_global_data VALUES (11644, 0, 152, 0, 3, 50, 108);
INSERT INTO public.who_global_data VALUES (11645, 2042, 188288, 143, 6339, 50, 39);
INSERT INTO public.who_global_data VALUES (11646, 162, 4611, 0, 73, 50, 2);
INSERT INTO public.who_global_data VALUES (11647, 5, 756, 0, 1, 50, 195);
INSERT INTO public.who_global_data VALUES (11648, 44, 11502, 0, 110, 50, 107);
INSERT INTO public.who_global_data VALUES (11649, 0, 362, 0, 0, 50, 161);
INSERT INTO public.who_global_data VALUES (11650, 0, 25472, 0, 445, 50, 212);
INSERT INTO public.who_global_data VALUES (11651, 6416, 481630, 140, 13799, 50, 181);
INSERT INTO public.who_global_data VALUES (11652, 6, 308, 0, 2, 50, 53);
INSERT INTO public.who_global_data VALUES (11653, 0, 4936, 0, 63, 50, 164);
INSERT INTO public.who_global_data VALUES (11654, 34, 1818, 0, 102, 50, 140);
INSERT INTO public.who_global_data VALUES (11655, 2001, 578732, 48, 16007, 50, 20);
INSERT INTO public.who_global_data VALUES (11656, 116, 95491, 2, 4766, 50, 112);
INSERT INTO public.who_global_data VALUES (11657, 11953, 1456599, 204, 39560, 50, 111);
INSERT INTO public.who_global_data VALUES (11658, 0, 633, 0, 7, 50, 71);
INSERT INTO public.who_global_data VALUES (11659, 0, 6200, 0, 100, 50, 218);
INSERT INTO public.who_global_data VALUES (11660, 0, 0, 0, 0, 50, 43);
INSERT INTO public.who_global_data VALUES (11661, 1167, 155263, 11, 1967, 50, 49);
INSERT INTO public.who_global_data VALUES (11662, 31, 21772, 0, 133, 50, 1);
INSERT INTO public.who_global_data VALUES (11663, 3918, 186963, 85, 2955, 50, 48);
INSERT INTO public.who_global_data VALUES (11664, 100, 9771, 0, 137, 50, 232);
INSERT INTO public.who_global_data VALUES (11665, 68, 3767, 0, 11, 50, 175);
INSERT INTO public.who_global_data VALUES (11666, 457, 16647, 0, 85, 50, 21);
INSERT INTO public.who_global_data VALUES (11667, 7602, 610006, 127, 10163, 50, 156);
INSERT INTO public.who_global_data VALUES (11668, 0, 0, 0, 0, 50, 95);
INSERT INTO public.who_global_data VALUES (11669, 333, 14928, 2, 366, 50, 177);
INSERT INTO public.who_global_data VALUES (11670, 4034, 123813, 17, 992, 50, 210);
INSERT INTO public.who_global_data VALUES (11671, 11, 5770, 0, 61, 50, 120);
INSERT INTO public.who_global_data VALUES (11672, 0, 88, 0, 0, 50, 135);
INSERT INTO public.who_global_data VALUES (11673, 720, 157305, 3, 2375, 50, 206);
INSERT INTO public.who_global_data VALUES (11674, 788, 204249, 17, 13932, 50, 189);
INSERT INTO public.who_global_data VALUES (11675, 548, 123701, 25, 7015, 50, 129);
INSERT INTO public.who_global_data VALUES (11676, 0, 42397, 8, 1227, 50, 121);
INSERT INTO public.who_global_data VALUES (11677, 19, 5214, 0, 85, 50, 59);
INSERT INTO public.who_global_data VALUES (11678, 30, 741, 0, 0, 50, 96);
INSERT INTO public.who_global_data VALUES (11679, 654, 20658, 4, 168, 50, 41);
INSERT INTO public.who_global_data VALUES (11680, 67, 7093, 0, 135, 50, 216);
INSERT INTO public.who_global_data VALUES (11681, 939, 118481, 18, 1831, 50, 236);
INSERT INTO public.who_global_data VALUES (11682, 0, 23, 0, 0, 50, 150);
INSERT INTO public.who_global_data VALUES (11683, 2, 534, 0, 0, 50, 61);
INSERT INTO public.who_global_data VALUES (11684, 0, 46, 0, 2, 50, 7);
INSERT INTO public.who_global_data VALUES (11685, 358, 32228, 12, 484, 50, 169);
INSERT INTO public.who_global_data VALUES (11686, 18025, 2385673, 256, 59245, 50, 28);
INSERT INTO public.who_global_data VALUES (11687, 137, 12163, 0, 71, 50, 85);
INSERT INTO public.who_global_data VALUES (11688, 144, 16118, 3, 101, 50, 211);
INSERT INTO public.who_global_data VALUES (11689, 0, 9373, 0, 63, 50, 60);
INSERT INTO public.who_global_data VALUES (11690, 0, 3786, 0, 123, 50, 3);
INSERT INTO public.who_global_data VALUES (11691, 2635, 204003, 49, 2002, 50, 11);
INSERT INTO public.who_global_data VALUES (11692, 33777, 1439938, 813, 24938, 50, 89);
INSERT INTO public.who_global_data VALUES (11693, 167, 53553, 4, 331, 50, 24);
INSERT INTO public.who_global_data VALUES (11694, 21, 1125, 0, 6, 50, 162);
INSERT INTO public.who_global_data VALUES (11695, 1153, 128710, 78, 3948, 50, 100);
INSERT INTO public.who_global_data VALUES (11696, 0, 19, 0, 0, 50, 47);
INSERT INTO public.who_global_data VALUES (11697, 0, 85, 0, 0, 50, 29);
INSERT INTO public.who_global_data VALUES (11698, 0, 8498, 2, 154, 50, 40);
INSERT INTO public.who_global_data VALUES (11699, 13, 7017, 0, 119, 50, 222);
INSERT INTO public.who_global_data VALUES (11700, 607, 131435, 41, 4551, 50, 132);
INSERT INTO public.who_global_data VALUES (11701, 0, 291, 0, 13, 50, 130);
INSERT INTO public.who_global_data VALUES (11702, 11, 13485, 0, 80, 50, 234);
INSERT INTO public.who_global_data VALUES (11703, 0, 2447, 0, 44, 50, 23);
INSERT INTO public.who_global_data VALUES (11704, 43, 6016, 2, 158, 50, 192);
INSERT INTO public.who_global_data VALUES (11705, 30, 9627, 0, 234, 50, 69);
INSERT INTO public.who_global_data VALUES (11706, 0, 26, 0, 0, 50, 187);
INSERT INTO public.who_global_data VALUES (11707, 374, 115317, 12, 3013, 50, 230);
INSERT INTO public.who_global_data VALUES (11708, 4428, 295977, 187, 7725, 50, 77);
INSERT INTO public.who_global_data VALUES (11709, 0, 5588, 0, 28, 50, 9);
INSERT INTO public.who_global_data VALUES (11710, 22890, 9979447, 338, 144789, 50, 74);
INSERT INTO public.who_global_data VALUES (11711, 7354, 643508, 142, 19390, 50, 224);
INSERT INTO public.who_global_data VALUES (11712, 7453, 1138530, 212, 53095, 50, 199);
INSERT INTO public.who_global_data VALUES (11713, 1533, 580449, 14, 12650, 50, 190);
INSERT INTO public.who_global_data VALUES (11714, 481, 77678, 3, 2143, 50, 12);
INSERT INTO public.who_global_data VALUES (11715, 0, 373, 0, 25, 50, 104);
INSERT INTO public.who_global_data VALUES (11716, 2852, 365727, 14, 3051, 50, 153);
INSERT INTO public.who_global_data VALUES (11717, 18233, 1906377, 683, 67220, 50, 91);
INSERT INTO public.who_global_data VALUES (11718, 61, 11968, 3, 279, 50, 215);
INSERT INTO public.who_global_data VALUES (11719, 3035, 190138, 44, 2783, 50, 84);
INSERT INTO public.who_global_data VALUES (11720, 100, 2001, 0, 32, 50, 231);
INSERT INTO public.who_global_data VALUES (11721, 2221, 269806, 31, 3496, 50, 196);
INSERT INTO public.who_global_data VALUES (11722, 741, 190292, 0, 2609, 50, 105);
INSERT INTO public.who_global_data VALUES (11723, 946, 93405, 14, 1618, 50, 122);
INSERT INTO public.who_global_data VALUES (11724, 0, 0, 0, 0, 50, 159);
INSERT INTO public.who_global_data VALUES (11725, 453, 47909, 8, 1223, 50, 75);
INSERT INTO public.who_global_data VALUES (11726, 221, 147192, 0, 913, 50, 27);
INSERT INTO public.who_global_data VALUES (11727, 264, 78679, 3, 1324, 50, 54);
INSERT INTO public.who_global_data VALUES (11728, 0, 41, 0, 0, 50, 226);
INSERT INTO public.who_global_data VALUES (11729, 1040, 28535, 12, 394, 50, 79);
INSERT INTO public.who_global_data VALUES (11730, 1960, 152893, 14, 1248, 50, 56);
INSERT INTO public.who_global_data VALUES (11731, 0, 2285, 0, 44, 50, 117);
INSERT INTO public.who_global_data VALUES (11732, 0, 1771, 0, 83, 50, 152);
INSERT INTO public.who_global_data VALUES (11733, 706, 93283, 13, 1337, 50, 16);
INSERT INTO public.who_global_data VALUES (11734, 36, 1749, 2, 23, 50, 10);
INSERT INTO public.who_global_data VALUES (11735, 3183, 106220, 39, 1221, 50, 201);
INSERT INTO public.who_global_data VALUES (11736, 434, 43278, 7, 428, 50, 174);
INSERT INTO public.who_global_data VALUES (11737, 0, 17587, 0, 259, 50, 119);
INSERT INTO public.who_global_data VALUES (11738, 47, 6138, 0, 187, 50, 168);
INSERT INTO public.who_global_data VALUES (11739, 1220, 89133, 3, 432, 50, 99);
INSERT INTO public.who_global_data VALUES (11740, 16, 13418, 0, 48, 50, 171);
INSERT INTO public.who_global_data VALUES (11741, 80, 6049, 2, 211, 50, 87);
INSERT INTO public.who_global_data VALUES (11742, 60, 11475, 2, 182, 50, 123);
INSERT INTO public.who_global_data VALUES (11743, 0, 4, 0, 0, 50, 151);
INSERT INTO public.who_global_data VALUES (11744, 0, 5601, 0, 42, 50, 213);
INSERT INTO public.who_global_data VALUES (11745, 0, 10971, 0, 225, 50, 118);
INSERT INTO public.who_global_data VALUES (11746, 10, 524, 0, 10, 50, 134);
INSERT INTO public.who_global_data VALUES (11747, 92, 5708, 0, 53, 50, 65);
INSERT INTO public.who_global_data VALUES (11748, 10297, 1277499, 670, 115769, 50, 102);
INSERT INTO public.who_global_data VALUES (11749, 0, 0, 0, 0, 50, 223);
INSERT INTO public.who_global_data VALUES (11750, 15, 703, 0, 3, 50, 4);
INSERT INTO public.who_global_data VALUES (11751, 5, 923, 0, 0, 50, 146);
INSERT INTO public.who_global_data VALUES (11752, 399, 43699, 6, 619, 50, 31);
INSERT INTO public.who_global_data VALUES (11753, 0, 13, 0, 1, 50, 127);
INSERT INTO public.who_global_data VALUES (11754, 2776, 409746, 55, 6804, 50, 22);
INSERT INTO public.who_global_data VALUES (11755, 113, 17256, 0, 145, 50, 115);
INSERT INTO public.who_global_data VALUES (11756, 1233, 111900, 27, 2346, 50, 106);
INSERT INTO public.who_global_data VALUES (11757, 331, 17607, 0, 164, 50, 90);
INSERT INTO public.who_global_data VALUES (11758, 0, 0, 0, 0, 50, 70);
INSERT INTO public.who_global_data VALUES (11759, 776, 251692, 6, 1749, 50, 46);
INSERT INTO public.who_global_data VALUES (11760, 12784, 651400, 76, 10295, 50, 139);
INSERT INTO public.who_global_data VALUES (11761, 0, 37, 0, 0, 50, 42);
INSERT INTO public.who_global_data VALUES (11762, 10, 1754, 0, 25, 50, 80);
INSERT INTO public.who_global_data VALUES (11763, 0, 4748, 0, 163, 50, 203);
INSERT INTO public.who_global_data VALUES (11764, 0, 2078, 0, 77, 50, 136);
INSERT INTO public.who_global_data VALUES (11765, 1145, 76207, 1, 1201, 50, 63);
INSERT INTO public.who_global_data VALUES (11766, 0, 0, 0, 0, 50, 17);
INSERT INTO public.who_global_data VALUES (11767, 2, 115, 0, 2, 50, 172);
INSERT INTO public.who_global_data VALUES (11768, 654, 76251, 31, 2225, 50, 109);
INSERT INTO public.who_global_data VALUES (11769, 460, 42312, 2, 404, 50, 200);
INSERT INTO public.who_global_data VALUES (11770, 2149, 133186, 30, 1186, 50, 93);
INSERT INTO public.who_global_data VALUES (11771, 184, 127019, 3, 1483, 50, 5);
INSERT INTO public.who_global_data VALUES (11772, 0, 744, 0, 13, 50, 214);
INSERT INTO public.who_global_data VALUES (11773, 2545, 448522, 70, 9080, 50, 204);
INSERT INTO public.who_global_data VALUES (11774, 0, 0, 0, 0, 50, 198);
INSERT INTO public.who_global_data VALUES (11775, 2960, 199947, 28, 3439, 50, 173);
INSERT INTO public.who_global_data VALUES (11776, 31, 760, 0, 8, 50, 229);
INSERT INTO public.who_global_data VALUES (11777, 856, 96209, 23, 2014, 50, 76);
INSERT INTO public.who_global_data VALUES (11778, 1782, 989457, 41, 36858, 50, 138);
INSERT INTO public.who_global_data VALUES (11779, 1459, 454447, 17, 8850, 50, 98);
INSERT INTO public.who_global_data VALUES (11780, 0, 0, 0, 0, 50, 103);
INSERT INTO public.who_global_data VALUES (11781, 11010, 1182864, 426, 24771, 50, 225);
INSERT INTO public.who_global_data VALUES (11782, 4320, 362616, 87, 5902, 50, 131);
INSERT INTO public.who_global_data VALUES (11783, 1065, 64751, 11, 1323, 50, 235);
INSERT INTO public.who_global_data VALUES (11784, 140, 141557, 0, 242, 50, 137);
INSERT INTO public.who_global_data VALUES (11785, 1064, 47514, 11, 645, 50, 81);
INSERT INTO public.who_global_data VALUES (11786, 1590, 131919, 24, 2674, 50, 182);
INSERT INTO public.who_global_data VALUES (11787, 0, 8588, 0, 42, 50, 145);
INSERT INTO public.who_global_data VALUES (11788, 5697, 577446, 107, 13969, 50, 26);
INSERT INTO public.who_global_data VALUES (11789, 28552, 2791220, 611, 49762, 50, 170);
INSERT INTO public.who_global_data VALUES (11790, 200, 7032, 0, 57, 50, 191);
INSERT INTO public.who_global_data VALUES (11791, 0, 5, 0, 0, 50, 221);
INSERT INTO public.who_global_data VALUES (11792, 0, 172, 0, 0, 50, 64);
INSERT INTO public.who_global_data VALUES (11793, 0, 0, 0, 0, 50, 116);
INSERT INTO public.who_global_data VALUES (11794, 0, 28, 0, 0, 50, 128);
INSERT INTO public.who_global_data VALUES (11795, 1, 279, 0, 4, 50, 6);
INSERT INTO public.who_global_data VALUES (11796, 0, 899, 0, 12, 50, 227);
INSERT INTO public.who_global_data VALUES (11797, 0, 14, 0, 0, 50, 68);
INSERT INTO public.who_global_data VALUES (11798, 2, 100, 0, 0, 50, 184);
INSERT INTO public.who_global_data VALUES (11799, 0, 2, 0, 0, 50, 82);
INSERT INTO public.who_global_data VALUES (11800, 24, 2049, 0, 54, 50, 149);
INSERT INTO public.who_global_data VALUES (11801, 1, 1011, 0, 17, 50, 197);
INSERT INTO public.who_global_data VALUES (11802, 181, 360516, 11, 6091, 50, 78);
INSERT INTO public.who_global_data VALUES (11803, 115, 17451, 3, 355, 50, 233);
INSERT INTO public.who_global_data VALUES (11804, 5129, 287730, 47, 2529, 50, 133);
INSERT INTO public.who_global_data VALUES (11805, 0, 202, 0, 0, 50, 35);
INSERT INTO public.who_global_data VALUES (11806, 13, 2464, 0, 75, 50, 114);
INSERT INTO public.who_global_data VALUES (11807, 24, 58377, 0, 29, 50, 237);
INSERT INTO public.who_global_data VALUES (11808, 0, 18, 0, 0, 50, 55);
INSERT INTO public.who_global_data VALUES (11809, 7, 1276, 0, 26, 50, 176);
INSERT INTO public.who_global_data VALUES (11810, 3991, 146124, 62, 1440, 50, 202);
INSERT INTO public.who_global_data VALUES (11811, 1517, 103596, 39, 2509, 50, 155);
INSERT INTO public.who_global_data VALUES (11812, 0, 17, 0, 0, 50, 32);
INSERT INTO public.who_global_data VALUES (11813, 83, 4662, 3, 124, 50, 220);
INSERT INTO public.who_global_data VALUES (11814, 9126, 892813, 184, 24011, 50, 30);
INSERT INTO public.who_global_data VALUES (11815, 17, 3223, 0, 62, 50, 147);
INSERT INTO public.who_global_data VALUES (11816, 11975, 1848159, 124, 49806, 50, 208);
INSERT INTO public.who_global_data VALUES (11817, 1266, 35387, 6, 160, 50, 45);
INSERT INTO public.who_global_data VALUES (11818, 202, 22823, 9, 1434, 50, 110);
INSERT INTO public.who_global_data VALUES (11819, 20, 5401, 0, 117, 50, 88);
INSERT INTO public.who_global_data VALUES (11820, 8825, 357389, 102, 8456, 50, 51);
INSERT INTO public.who_global_data VALUES (11821, 4385, 404515, 82, 6186, 50, 209);
INSERT INTO public.who_global_data VALUES (11822, 156, 9759, 17, 571, 50, 205);
INSERT INTO public.who_global_data VALUES (11823, 64, 13136, 0, 89, 50, 18);
INSERT INTO public.who_global_data VALUES (11824, 20, 4281, 0, 60, 50, 72);
INSERT INTO public.who_global_data VALUES (11825, 35383, 1948664, 532, 66052, 50, 44);
INSERT INTO public.who_global_data VALUES (11826, 0, 31, 0, 0, 50, 15);
INSERT INTO public.who_global_data VALUES (11827, 0, 3315, 0, 66, 50, 25);
INSERT INTO public.who_global_data VALUES (11828, 0, 0, 0, 0, 50, 179);
INSERT INTO public.who_global_data VALUES (11829, 0, 0, 0, 0, 50, 34);
INSERT INTO public.who_global_data VALUES (11830, 17, 6917, 0, 123, 50, 207);
INSERT INTO public.who_global_data VALUES (11831, 1419, 115966, 35, 4032, 50, 166);
INSERT INTO public.who_global_data VALUES (11832, 27515, 1955680, 243, 17364, 50, 126);
INSERT INTO public.who_global_data VALUES (11833, 0, 0, 0, 0, 50, 97);
INSERT INTO public.who_global_data VALUES (11834, 1, 772, 0, 6, 50, 36);
INSERT INTO public.who_global_data VALUES (11835, 0, 0, 0, 0, 50, 125);
INSERT INTO public.who_global_data VALUES (11836, 628, 29361, 3, 228, 50, 124);
INSERT INTO public.who_global_data VALUES (11837, 12630, 944381, 260, 16256, 50, 185);
INSERT INTO public.who_global_data VALUES (11838, 1321, 189866, 3, 629, 50, 194);
INSERT INTO public.who_global_data VALUES (11839, 0, 509, 0, 21, 50, 144);
INSERT INTO public.who_global_data VALUES (11840, 235805, 16682649, 3424, 304960, 50, 19);
INSERT INTO public.who_global_data VALUES (11841, 28, 1878, 0, 23, 50, 217);
INSERT INTO public.who_global_data VALUES (11842, 475, 10893, 4, 102, 50, 148);
INSERT INTO public.who_global_data VALUES (11843, 137, 75675, 0, 612, 50, 86);
INSERT INTO public.who_global_data VALUES (11844, 0, 1, 0, 0, 50, 13);
INSERT INTO public.who_global_data VALUES (11845, 237, 108717, 5, 970, 50, 157);
INSERT INTO public.who_global_data VALUES (11846, 2, 1407, 0, 35, 50, 8);
INSERT INTO public.who_global_data VALUES (11847, 0, 4, 0, 0, 50, 73);
INSERT INTO public.who_global_data VALUES (11848, 2, 2091, 0, 607, 50, 101);
INSERT INTO public.who_global_data VALUES (11849, 76, 18504, 1, 369, 50, 165);
INSERT INTO public.who_global_data VALUES (11850, 344, 11866, 4, 314, 50, 14);
INSERT INTO public.who_global_data VALUES (11851, 224, 49927, 16, 2017, 51, 193);
INSERT INTO public.who_global_data VALUES (11852, 637, 50637, 12, 1040, 51, 113);
INSERT INTO public.who_global_data VALUES (11853, 442, 93507, 8, 2631, 51, 143);
INSERT INTO public.who_global_data VALUES (11854, 0, 0, 0, 0, 51, 219);
INSERT INTO public.who_global_data VALUES (11855, 32, 7446, 0, 79, 51, 186);
INSERT INTO public.who_global_data VALUES (11856, 45, 16407, 7, 379, 51, 52);
INSERT INTO public.who_global_data VALUES (11857, 0, 10, 0, 0, 51, 180);
INSERT INTO public.who_global_data VALUES (11858, 3, 151, 0, 5, 51, 167);
INSERT INTO public.who_global_data VALUES (11859, 6981, 1510203, 163, 41204, 51, 154);
INSERT INTO public.who_global_data VALUES (11860, 1174, 150705, 25, 2576, 51, 94);
INSERT INTO public.who_global_data VALUES (11861, 23, 5079, 0, 46, 51, 66);
INSERT INTO public.who_global_data VALUES (11862, 12, 28059, 0, 908, 51, 58);
INSERT INTO public.who_global_data VALUES (11863, 2766, 328277, 127, 4778, 51, 163);
INSERT INTO public.who_global_data VALUES (11864, 4077, 187336, 43, 2050, 51, 37);
INSERT INTO public.who_global_data VALUES (11865, 16, 7714, 0, 164, 51, 142);
INSERT INTO public.who_global_data VALUES (11866, 156, 89600, 1, 349, 51, 83);
INSERT INTO public.who_global_data VALUES (11867, 1632, 495841, 27, 7156, 51, 228);
INSERT INTO public.who_global_data VALUES (11868, 4, 301, 0, 7, 51, 188);
INSERT INTO public.who_global_data VALUES (11869, 1838, 165897, 9, 1291, 51, 62);
INSERT INTO public.who_global_data VALUES (11870, 2856, 619995, 97, 18404, 51, 160);
INSERT INTO public.who_global_data VALUES (11871, 134, 9511, 14, 211, 51, 50);
INSERT INTO public.who_global_data VALUES (11872, 0, 3152, 0, 44, 51, 33);
INSERT INTO public.who_global_data VALUES (11873, 11, 467, 0, 9, 51, 183);
INSERT INTO public.who_global_data VALUES (11874, 1, 440, 0, 0, 51, 92);
INSERT INTO public.who_global_data VALUES (11875, 371, 147716, 2, 9026, 51, 158);
INSERT INTO public.who_global_data VALUES (11876, 0, 154, 0, 3, 51, 67);
INSERT INTO public.who_global_data VALUES (11877, 902, 103232, 54, 3511, 51, 57);
INSERT INTO public.who_global_data VALUES (11878, 0, 12873, 0, 38, 51, 38);
INSERT INTO public.who_global_data VALUES (11879, 42889, 6970034, 964, 182799, 51, 141);
INSERT INTO public.who_global_data VALUES (11880, 0, 80, 0, 1, 51, 178);
INSERT INTO public.who_global_data VALUES (11881, 0, 152, 0, 3, 51, 108);
INSERT INTO public.who_global_data VALUES (11882, 1959, 186246, 191, 6196, 51, 39);
INSERT INTO public.who_global_data VALUES (11883, 149, 4449, 0, 73, 51, 2);
INSERT INTO public.who_global_data VALUES (11884, 10, 751, 0, 1, 51, 195);
INSERT INTO public.who_global_data VALUES (11885, 63, 11458, 0, 110, 51, 107);
INSERT INTO public.who_global_data VALUES (11886, 0, 362, 0, 0, 51, 161);
INSERT INTO public.who_global_data VALUES (11887, 0, 25472, 0, 445, 51, 212);
INSERT INTO public.who_global_data VALUES (11888, 6352, 475214, 106, 13659, 51, 181);
INSERT INTO public.who_global_data VALUES (11889, 0, 302, 0, 2, 51, 53);
INSERT INTO public.who_global_data VALUES (11890, 0, 4936, 0, 63, 51, 164);
INSERT INTO public.who_global_data VALUES (11891, 0, 1784, 0, 102, 51, 140);
INSERT INTO public.who_global_data VALUES (11892, 1402, 576731, 10, 15959, 51, 20);
INSERT INTO public.who_global_data VALUES (11893, 96, 95375, 0, 4764, 51, 112);
INSERT INTO public.who_global_data VALUES (11894, 10130, 1444646, 161, 39356, 51, 111);
INSERT INTO public.who_global_data VALUES (11895, 5, 633, 0, 7, 51, 71);
INSERT INTO public.who_global_data VALUES (11896, 0, 6200, 0, 100, 51, 218);
INSERT INTO public.who_global_data VALUES (11897, 0, 0, 0, 0, 51, 43);
INSERT INTO public.who_global_data VALUES (11898, 927, 154096, 20, 1956, 51, 49);
INSERT INTO public.who_global_data VALUES (11899, 24, 21741, 0, 133, 51, 1);
INSERT INTO public.who_global_data VALUES (11900, 3327, 183045, 92, 2870, 51, 48);
INSERT INTO public.who_global_data VALUES (11901, 83, 9671, 0, 137, 51, 232);
INSERT INTO public.who_global_data VALUES (11902, 38, 3699, 0, 11, 51, 175);
INSERT INTO public.who_global_data VALUES (11903, 401, 16190, 1, 85, 51, 21);
INSERT INTO public.who_global_data VALUES (11904, 8256, 602404, 154, 10036, 51, 156);
INSERT INTO public.who_global_data VALUES (11905, 0, 0, 0, 0, 51, 95);
INSERT INTO public.who_global_data VALUES (11906, 84, 14595, 6, 364, 51, 177);
INSERT INTO public.who_global_data VALUES (11907, 3692, 119779, 14, 975, 51, 210);
INSERT INTO public.who_global_data VALUES (11908, 10, 5759, 0, 61, 51, 120);
INSERT INTO public.who_global_data VALUES (11909, 0, 88, 0, 0, 51, 135);
INSERT INTO public.who_global_data VALUES (11910, 788, 156585, 5, 2372, 51, 206);
INSERT INTO public.who_global_data VALUES (11911, 1105, 203461, 19, 13915, 51, 189);
INSERT INTO public.who_global_data VALUES (11912, 544, 123153, 24, 6990, 51, 129);
INSERT INTO public.who_global_data VALUES (11913, 265, 42397, 7, 1219, 51, 121);
INSERT INTO public.who_global_data VALUES (11914, 0, 5195, 0, 85, 51, 59);
INSERT INTO public.who_global_data VALUES (11915, 0, 711, 0, 0, 51, 96);
INSERT INTO public.who_global_data VALUES (11916, 733, 20004, 7, 164, 51, 41);
INSERT INTO public.who_global_data VALUES (11917, 114, 7026, 3, 135, 51, 216);
INSERT INTO public.who_global_data VALUES (11918, 0, 117542, 0, 1813, 51, 236);
INSERT INTO public.who_global_data VALUES (11919, 4, 23, 0, 0, 51, 150);
INSERT INTO public.who_global_data VALUES (11920, 2, 532, 0, 0, 51, 61);
INSERT INTO public.who_global_data VALUES (11921, 0, 46, 0, 2, 51, 7);
INSERT INTO public.who_global_data VALUES (11922, 411, 31870, 6, 472, 51, 169);
INSERT INTO public.who_global_data VALUES (11923, 17441, 2367648, 289, 58989, 51, 28);
INSERT INTO public.who_global_data VALUES (11924, 120, 12026, 0, 71, 51, 85);
INSERT INTO public.who_global_data VALUES (11925, 104, 15974, 1, 98, 51, 211);
INSERT INTO public.who_global_data VALUES (11926, 22, 9373, 0, 63, 51, 60);
INSERT INTO public.who_global_data VALUES (11927, 0, 3786, 0, 123, 51, 3);
INSERT INTO public.who_global_data VALUES (11928, 2981, 201368, 31, 1953, 51, 11);
INSERT INTO public.who_global_data VALUES (11929, 26923, 1406161, 698, 24125, 51, 89);
INSERT INTO public.who_global_data VALUES (11930, 0, 53386, 0, 327, 51, 24);
INSERT INTO public.who_global_data VALUES (11931, 22, 1104, 0, 6, 51, 162);
INSERT INTO public.who_global_data VALUES (11932, 1185, 127557, 85, 3870, 51, 100);
INSERT INTO public.who_global_data VALUES (11933, 0, 19, 0, 0, 51, 47);
INSERT INTO public.who_global_data VALUES (11934, 14, 85, 0, 0, 51, 29);
INSERT INTO public.who_global_data VALUES (11935, 0, 8498, 0, 152, 51, 40);
INSERT INTO public.who_global_data VALUES (11936, 16, 7004, 0, 119, 51, 222);
INSERT INTO public.who_global_data VALUES (11937, 746, 130828, 34, 4510, 51, 132);
INSERT INTO public.who_global_data VALUES (11938, 0, 291, 0, 13, 51, 130);
INSERT INTO public.who_global_data VALUES (11939, 17, 13474, 0, 80, 51, 234);
INSERT INTO public.who_global_data VALUES (11940, 0, 2447, 0, 44, 51, 23);
INSERT INTO public.who_global_data VALUES (11941, 30, 5973, 0, 156, 51, 192);
INSERT INTO public.who_global_data VALUES (11942, 0, 9597, 0, 234, 51, 69);
INSERT INTO public.who_global_data VALUES (11943, 0, 26, 0, 0, 51, 187);
INSERT INTO public.who_global_data VALUES (11944, 301, 114943, 12, 3001, 51, 230);
INSERT INTO public.who_global_data VALUES (11945, 2982, 291549, 157, 7538, 51, 77);
INSERT INTO public.who_global_data VALUES (11946, 10, 5588, 0, 28, 51, 9);
INSERT INTO public.who_global_data VALUES (11947, 24010, 9956557, 355, 144451, 51, 74);
INSERT INTO public.who_global_data VALUES (11948, 6725, 636154, 137, 19248, 51, 224);
INSERT INTO public.who_global_data VALUES (11949, 7603, 1131077, 213, 52883, 51, 199);
INSERT INTO public.who_global_data VALUES (11950, 1553, 578916, 22, 12636, 51, 190);
INSERT INTO public.who_global_data VALUES (11951, 421, 77197, 6, 2140, 51, 12);
INSERT INTO public.who_global_data VALUES (11952, 0, 373, 0, 25, 51, 104);
INSERT INTO public.who_global_data VALUES (11953, 2891, 362875, 12, 3037, 51, 153);
INSERT INTO public.who_global_data VALUES (11954, 17568, 1888144, 680, 66537, 51, 91);
INSERT INTO public.who_global_data VALUES (11955, 32, 11907, 0, 276, 51, 215);
INSERT INTO public.who_global_data VALUES (11956, 3061, 187103, 51, 2739, 51, 84);
INSERT INTO public.who_global_data VALUES (11957, 59, 1901, 0, 32, 51, 231);
INSERT INTO public.who_global_data VALUES (11958, 2561, 267585, 28, 3465, 51, 196);
INSERT INTO public.who_global_data VALUES (11959, 714, 189551, 0, 2609, 51, 105);
INSERT INTO public.who_global_data VALUES (11960, 0, 92459, 0, 1604, 51, 122);
INSERT INTO public.who_global_data VALUES (11961, 0, 0, 0, 0, 51, 159);
INSERT INTO public.who_global_data VALUES (11962, 296, 47456, 5, 1215, 51, 75);
INSERT INTO public.who_global_data VALUES (11963, 261, 146971, 0, 913, 51, 27);
INSERT INTO public.who_global_data VALUES (11964, 264, 78415, 4, 1321, 51, 54);
INSERT INTO public.who_global_data VALUES (11965, 0, 41, 0, 0, 51, 226);
INSERT INTO public.who_global_data VALUES (11966, 1023, 27495, 25, 382, 51, 79);
INSERT INTO public.who_global_data VALUES (11967, 2056, 150933, 11, 1234, 51, 56);
INSERT INTO public.who_global_data VALUES (11968, 0, 2285, 0, 44, 51, 117);
INSERT INTO public.who_global_data VALUES (11969, 0, 1771, 0, 83, 51, 152);
INSERT INTO public.who_global_data VALUES (11970, 560, 92577, 5, 1324, 51, 16);
INSERT INTO public.who_global_data VALUES (11971, 35, 1713, 0, 21, 51, 10);
INSERT INTO public.who_global_data VALUES (11972, 3163, 103037, 43, 1182, 51, 201);
INSERT INTO public.who_global_data VALUES (11973, 595, 42844, 3, 421, 51, 174);
INSERT INTO public.who_global_data VALUES (11974, 0, 17587, 0, 259, 51, 119);
INSERT INTO public.who_global_data VALUES (11975, 11, 6091, 0, 187, 51, 168);
INSERT INTO public.who_global_data VALUES (11976, 1295, 87913, 7, 429, 51, 99);
INSERT INTO public.who_global_data VALUES (11977, 10, 13402, 0, 48, 51, 171);
INSERT INTO public.who_global_data VALUES (11978, 91, 5969, 4, 209, 51, 87);
INSERT INTO public.who_global_data VALUES (11979, 112, 11415, 3, 180, 51, 123);
INSERT INTO public.who_global_data VALUES (11980, 0, 4, 0, 0, 51, 151);
INSERT INTO public.who_global_data VALUES (11981, 0, 5601, 0, 42, 51, 213);
INSERT INTO public.who_global_data VALUES (11982, 0, 10971, 0, 225, 51, 118);
INSERT INTO public.who_global_data VALUES (11983, 0, 514, 0, 10, 51, 134);
INSERT INTO public.who_global_data VALUES (11984, 0, 5616, 0, 53, 51, 65);
INSERT INTO public.who_global_data VALUES (11985, 11228, 1267202, 801, 115099, 51, 102);
INSERT INTO public.who_global_data VALUES (11986, 0, 0, 0, 0, 51, 223);
INSERT INTO public.who_global_data VALUES (11987, 7, 688, 0, 3, 51, 4);
INSERT INTO public.who_global_data VALUES (11988, 1, 918, 0, 0, 51, 146);
INSERT INTO public.who_global_data VALUES (11989, 380, 43300, 4, 613, 51, 31);
INSERT INTO public.who_global_data VALUES (11990, 0, 13, 0, 1, 51, 127);
INSERT INTO public.who_global_data VALUES (11991, 3351, 406970, 38, 6749, 51, 22);
INSERT INTO public.who_global_data VALUES (11992, 101, 17143, 1, 145, 51, 115);
INSERT INTO public.who_global_data VALUES (11993, 1155, 110667, 27, 2319, 51, 106);
INSERT INTO public.who_global_data VALUES (11994, 363, 17276, 0, 164, 51, 90);
INSERT INTO public.who_global_data VALUES (11995, 0, 0, 0, 0, 51, 70);
INSERT INTO public.who_global_data VALUES (11996, 736, 250916, 13, 1743, 51, 46);
INSERT INTO public.who_global_data VALUES (11997, 11170, 638616, 76, 10219, 51, 139);
INSERT INTO public.who_global_data VALUES (11998, 1, 37, 0, 0, 51, 42);
INSERT INTO public.who_global_data VALUES (11999, 0, 1744, 0, 25, 51, 80);
INSERT INTO public.who_global_data VALUES (12000, 0, 4748, 0, 163, 51, 203);
INSERT INTO public.who_global_data VALUES (12001, 0, 2078, 0, 77, 51, 136);
INSERT INTO public.who_global_data VALUES (12002, 930, 75062, 0, 1200, 51, 63);
INSERT INTO public.who_global_data VALUES (12003, 0, 0, 0, 0, 51, 17);
INSERT INTO public.who_global_data VALUES (12004, 0, 113, 0, 2, 51, 172);
INSERT INTO public.who_global_data VALUES (12005, 865, 75597, 25, 2194, 51, 109);
INSERT INTO public.who_global_data VALUES (12006, 518, 41852, 7, 402, 51, 200);
INSERT INTO public.who_global_data VALUES (12007, 2525, 131037, 26, 1156, 51, 93);
INSERT INTO public.who_global_data VALUES (12008, 116, 126835, 5, 1480, 51, 5);
INSERT INTO public.who_global_data VALUES (12009, 0, 744, 0, 13, 51, 214);
INSERT INTO public.who_global_data VALUES (12010, 2731, 445977, 105, 9010, 51, 204);
INSERT INTO public.who_global_data VALUES (12011, 0, 0, 0, 0, 51, 198);
INSERT INTO public.who_global_data VALUES (12012, 2368, 196987, 29, 3411, 51, 173);
INSERT INTO public.who_global_data VALUES (12013, 0, 729, 0, 8, 51, 229);
INSERT INTO public.who_global_data VALUES (12014, 1130, 95353, 20, 1991, 51, 76);
INSERT INTO public.who_global_data VALUES (12015, 1545, 987675, 63, 36817, 51, 138);
INSERT INTO public.who_global_data VALUES (12016, 1149, 452988, 21, 8833, 51, 98);
INSERT INTO public.who_global_data VALUES (12017, 0, 0, 0, 0, 51, 103);
INSERT INTO public.who_global_data VALUES (12018, 11953, 1171854, 431, 24345, 51, 225);
INSERT INTO public.who_global_data VALUES (12019, 4720, 358296, 82, 5815, 51, 131);
INSERT INTO public.who_global_data VALUES (12020, 267, 63686, 18, 1312, 51, 235);
INSERT INTO public.who_global_data VALUES (12021, 145, 141417, 1, 242, 51, 137);
INSERT INTO public.who_global_data VALUES (12022, 1014, 46450, 22, 634, 51, 81);
INSERT INTO public.who_global_data VALUES (12023, 1673, 130329, 25, 2650, 51, 182);
INSERT INTO public.who_global_data VALUES (12024, 54, 8588, 0, 42, 51, 145);
INSERT INTO public.who_global_data VALUES (12025, 5991, 571749, 164, 13862, 51, 26);
INSERT INTO public.who_global_data VALUES (12026, 28214, 2762668, 587, 49151, 51, 170);
INSERT INTO public.who_global_data VALUES (12027, 0, 6832, 0, 57, 51, 191);
INSERT INTO public.who_global_data VALUES (12028, 0, 5, 0, 0, 51, 221);
INSERT INTO public.who_global_data VALUES (12029, 0, 172, 0, 0, 51, 64);
INSERT INTO public.who_global_data VALUES (12030, 0, 0, 0, 0, 51, 116);
INSERT INTO public.who_global_data VALUES (12031, 0, 28, 0, 0, 51, 128);
INSERT INTO public.who_global_data VALUES (12032, 0, 278, 0, 4, 51, 6);
INSERT INTO public.who_global_data VALUES (12033, 0, 899, 0, 12, 51, 227);
INSERT INTO public.who_global_data VALUES (12034, 0, 14, 0, 0, 51, 68);
INSERT INTO public.who_global_data VALUES (12035, 0, 98, 0, 0, 51, 184);
INSERT INTO public.who_global_data VALUES (12036, 0, 2, 0, 0, 51, 82);
INSERT INTO public.who_global_data VALUES (12037, 0, 2025, 0, 54, 51, 149);
INSERT INTO public.who_global_data VALUES (12038, 0, 1010, 0, 17, 51, 197);
INSERT INTO public.who_global_data VALUES (12039, 180, 360335, 11, 6080, 51, 78);
INSERT INTO public.who_global_data VALUES (12040, 120, 17336, 2, 352, 51, 233);
INSERT INTO public.who_global_data VALUES (12041, 5353, 282601, 49, 2482, 51, 133);
INSERT INTO public.who_global_data VALUES (12042, 17, 202, 0, 0, 51, 35);
INSERT INTO public.who_global_data VALUES (12043, 0, 2451, 0, 75, 51, 114);
INSERT INTO public.who_global_data VALUES (12044, 12, 58353, 0, 29, 51, 237);
INSERT INTO public.who_global_data VALUES (12045, 0, 18, 0, 0, 51, 55);
INSERT INTO public.who_global_data VALUES (12046, 20, 1269, 0, 26, 51, 176);
INSERT INTO public.who_global_data VALUES (12047, 3045, 142133, 69, 1378, 51, 202);
INSERT INTO public.who_global_data VALUES (12048, 1648, 102079, 42, 2470, 51, 155);
INSERT INTO public.who_global_data VALUES (12049, 0, 17, 0, 0, 51, 32);
INSERT INTO public.who_global_data VALUES (12050, 0, 4579, 0, 121, 51, 220);
INSERT INTO public.who_global_data VALUES (12051, 10008, 883687, 166, 23827, 51, 30);
INSERT INTO public.who_global_data VALUES (12052, 0, 3206, 0, 62, 51, 147);
INSERT INTO public.who_global_data VALUES (12053, 12412, 1836184, 155, 49682, 51, 208);
INSERT INTO public.who_global_data VALUES (12054, 0, 34121, 0, 154, 51, 45);
INSERT INTO public.who_global_data VALUES (12055, 356, 22621, 17, 1425, 51, 110);
INSERT INTO public.who_global_data VALUES (12056, 22, 5381, 0, 117, 51, 88);
INSERT INTO public.who_global_data VALUES (12057, 7001, 348564, 88, 8354, 51, 51);
INSERT INTO public.who_global_data VALUES (12058, 4815, 400130, 88, 6104, 51, 209);
INSERT INTO public.who_global_data VALUES (12059, 151, 9603, 11, 554, 51, 205);
INSERT INTO public.who_global_data VALUES (12060, 55, 13072, 0, 89, 51, 18);
INSERT INTO public.who_global_data VALUES (12061, 15, 4261, 0, 60, 51, 72);
INSERT INTO public.who_global_data VALUES (12062, 25161, 1913281, 612, 65520, 51, 44);
INSERT INTO public.who_global_data VALUES (12063, 0, 31, 0, 0, 51, 15);
INSERT INTO public.who_global_data VALUES (12064, 20, 3315, 0, 66, 51, 25);
INSERT INTO public.who_global_data VALUES (12065, 0, 0, 0, 0, 51, 179);
INSERT INTO public.who_global_data VALUES (12066, 0, 0, 0, 0, 51, 34);
INSERT INTO public.who_global_data VALUES (12067, 15, 6900, 0, 123, 51, 207);
INSERT INTO public.who_global_data VALUES (12068, 1306, 114547, 41, 3997, 51, 166);
INSERT INTO public.who_global_data VALUES (12069, 29718, 1928165, 240, 17121, 51, 126);
INSERT INTO public.who_global_data VALUES (12070, 0, 0, 0, 0, 51, 97);
INSERT INTO public.who_global_data VALUES (12071, 2, 771, 0, 6, 51, 36);
INSERT INTO public.who_global_data VALUES (12072, 0, 0, 0, 0, 51, 125);
INSERT INTO public.who_global_data VALUES (12073, 565, 28733, 0, 225, 51, 124);
INSERT INTO public.who_global_data VALUES (12074, 12047, 931751, 252, 15996, 51, 185);
INSERT INTO public.who_global_data VALUES (12075, 1278, 188545, 4, 626, 51, 194);
INSERT INTO public.who_global_data VALUES (12076, 0, 509, 0, 21, 51, 144);
INSERT INTO public.who_global_data VALUES (12077, 201468, 16446844, 2942, 301536, 51, 19);
INSERT INTO public.who_global_data VALUES (12078, 22, 1850, 0, 23, 51, 217);
INSERT INTO public.who_global_data VALUES (12079, 389, 10418, 3, 98, 51, 148);
INSERT INTO public.who_global_data VALUES (12080, 142, 75538, 0, 612, 51, 86);
INSERT INTO public.who_global_data VALUES (12081, 0, 1, 0, 0, 51, 13);
INSERT INTO public.who_global_data VALUES (12082, 355, 108480, 5, 965, 51, 157);
INSERT INTO public.who_global_data VALUES (12083, 0, 1405, 0, 35, 51, 8);
INSERT INTO public.who_global_data VALUES (12084, 0, 4, 0, 0, 51, 73);
INSERT INTO public.who_global_data VALUES (12085, 0, 2089, 0, 607, 51, 101);
INSERT INTO public.who_global_data VALUES (12086, 0, 18428, 0, 368, 51, 165);
INSERT INTO public.who_global_data VALUES (12087, 0, 11522, 0, 310, 51, 14);
INSERT INTO public.who_global_data VALUES (12088, 219, 49703, 26, 2001, 52, 193);
INSERT INTO public.who_global_data VALUES (12089, 809, 50000, 12, 1028, 52, 113);
INSERT INTO public.who_global_data VALUES (12090, 468, 93065, 14, 2623, 52, 143);
INSERT INTO public.who_global_data VALUES (12091, 0, 0, 0, 0, 52, 219);
INSERT INTO public.who_global_data VALUES (12092, 32, 7414, 0, 79, 52, 186);
INSERT INTO public.who_global_data VALUES (12093, 85, 16362, 0, 372, 52, 52);
INSERT INTO public.who_global_data VALUES (12094, 0, 10, 0, 0, 52, 180);
INSERT INTO public.who_global_data VALUES (12095, 0, 148, 0, 5, 52, 167);
INSERT INTO public.who_global_data VALUES (12096, 5062, 1503222, 275, 41041, 52, 154);
INSERT INTO public.who_global_data VALUES (12097, 1098, 149531, 27, 2551, 52, 94);
INSERT INTO public.who_global_data VALUES (12098, 7, 5056, 0, 46, 52, 66);
INSERT INTO public.who_global_data VALUES (12099, 8, 28047, 0, 908, 52, 58);
INSERT INTO public.who_global_data VALUES (12100, 2954, 325511, 141, 4651, 52, 163);
INSERT INTO public.who_global_data VALUES (12101, 4273, 183259, 41, 2007, 52, 37);
INSERT INTO public.who_global_data VALUES (12102, 8, 7698, 1, 164, 52, 142);
INSERT INTO public.who_global_data VALUES (12103, 177, 89444, 0, 348, 52, 83);
INSERT INTO public.who_global_data VALUES (12104, 1877, 494209, 40, 7129, 52, 228);
INSERT INTO public.who_global_data VALUES (12105, 1, 297, 0, 7, 52, 188);
INSERT INTO public.who_global_data VALUES (12106, 1911, 164059, 9, 1282, 52, 62);
INSERT INTO public.who_global_data VALUES (12107, 3239, 617139, 103, 18307, 52, 160);
INSERT INTO public.who_global_data VALUES (12108, 82, 9377, 2, 197, 52, 50);
INSERT INTO public.who_global_data VALUES (12109, 62, 3152, 0, 44, 52, 33);
INSERT INTO public.who_global_data VALUES (12110, 25, 456, 0, 9, 52, 183);
INSERT INTO public.who_global_data VALUES (12111, 1, 439, 0, 0, 52, 92);
INSERT INTO public.who_global_data VALUES (12112, 195, 147345, 6, 9024, 52, 158);
INSERT INTO public.who_global_data VALUES (12113, 0, 154, 0, 3, 52, 67);
INSERT INTO public.who_global_data VALUES (12114, 869, 102330, 66, 3457, 52, 57);
INSERT INTO public.who_global_data VALUES (12115, 372, 12873, 1, 38, 52, 38);
INSERT INTO public.who_global_data VALUES (12116, 25193, 6927145, 433, 181835, 52, 141);
INSERT INTO public.who_global_data VALUES (12117, 4, 80, 0, 1, 52, 178);
INSERT INTO public.who_global_data VALUES (12118, 0, 152, 0, 3, 52, 108);
INSERT INTO public.who_global_data VALUES (12119, 2743, 184287, 167, 6005, 52, 39);
INSERT INTO public.who_global_data VALUES (12120, 91, 4300, 2, 73, 52, 2);
INSERT INTO public.who_global_data VALUES (12121, 6, 741, 0, 1, 52, 195);
INSERT INTO public.who_global_data VALUES (12122, 34, 11395, 0, 110, 52, 107);
INSERT INTO public.who_global_data VALUES (12123, 0, 362, 0, 0, 52, 161);
INSERT INTO public.who_global_data VALUES (12124, 113, 25472, 0, 445, 52, 212);
INSERT INTO public.who_global_data VALUES (12125, 8119, 468862, 122, 13553, 52, 181);
INSERT INTO public.who_global_data VALUES (12126, 4, 302, 0, 2, 52, 53);
INSERT INTO public.who_global_data VALUES (12127, 0, 4936, 0, 63, 52, 164);
INSERT INTO public.who_global_data VALUES (12128, 13, 1784, 0, 102, 52, 140);
INSERT INTO public.who_global_data VALUES (12129, 1499, 575329, 18, 15949, 52, 20);
INSERT INTO public.who_global_data VALUES (12130, 112, 95279, 3, 4764, 52, 112);
INSERT INTO public.who_global_data VALUES (12131, 8742, 1434516, 142, 39195, 52, 111);
INSERT INTO public.who_global_data VALUES (12132, -1, 628, 0, 7, 52, 71);
INSERT INTO public.who_global_data VALUES (12133, 0, 6200, 0, 100, 52, 218);
INSERT INTO public.who_global_data VALUES (12134, 0, 0, 0, 0, 52, 43);
INSERT INTO public.who_global_data VALUES (12135, 549, 153169, 15, 1936, 52, 49);
INSERT INTO public.who_global_data VALUES (12136, 12, 21717, 0, 133, 52, 1);
INSERT INTO public.who_global_data VALUES (12137, 2360, 179718, 73, 2778, 52, 48);
INSERT INTO public.who_global_data VALUES (12138, 96, 9588, 0, 137, 52, 232);
INSERT INTO public.who_global_data VALUES (12139, 37, 3661, 0, 11, 52, 175);
INSERT INTO public.who_global_data VALUES (12140, 339, 15789, 2, 84, 52, 21);
INSERT INTO public.who_global_data VALUES (12141, 7897, 594148, 139, 9882, 52, 156);
INSERT INTO public.who_global_data VALUES (12142, 0, 0, 0, 0, 52, 95);
INSERT INTO public.who_global_data VALUES (12143, 51, 14511, 2, 358, 52, 177);
INSERT INTO public.who_global_data VALUES (12144, 2992, 116087, 11, 961, 52, 210);
INSERT INTO public.who_global_data VALUES (12145, 16, 5749, 0, 61, 52, 120);
INSERT INTO public.who_global_data VALUES (12146, 0, 88, 0, 0, 52, 135);
INSERT INTO public.who_global_data VALUES (12147, 613, 155797, 3, 2367, 52, 206);
INSERT INTO public.who_global_data VALUES (12148, 176, 202356, 21, 13896, 52, 189);
INSERT INTO public.who_global_data VALUES (12149, 523, 122609, 23, 6966, 52, 129);
INSERT INTO public.who_global_data VALUES (12150, 252, 42132, 7, 1212, 52, 121);
INSERT INTO public.who_global_data VALUES (12151, 10, 5195, 0, 85, 52, 59);
INSERT INTO public.who_global_data VALUES (12152, 0, 711, 0, 0, 52, 96);
INSERT INTO public.who_global_data VALUES (12153, 885, 19271, 3, 157, 52, 41);
INSERT INTO public.who_global_data VALUES (12154, 87, 6912, 2, 132, 52, 216);
INSERT INTO public.who_global_data VALUES (12155, 300, 117542, 4, 1813, 52, 236);
INSERT INTO public.who_global_data VALUES (12156, 0, 19, 0, 0, 52, 150);
INSERT INTO public.who_global_data VALUES (12157, 2, 530, 0, 0, 52, 61);
INSERT INTO public.who_global_data VALUES (12158, 0, 46, 0, 2, 52, 7);
INSERT INTO public.who_global_data VALUES (12159, 349, 31459, 5, 466, 52, 169);
INSERT INTO public.who_global_data VALUES (12160, 11481, 2350207, 790, 58700, 52, 28);
INSERT INTO public.who_global_data VALUES (12161, 51, 11906, 0, 71, 52, 85);
INSERT INTO public.who_global_data VALUES (12162, 123, 15870, 1, 97, 52, 211);
INSERT INTO public.who_global_data VALUES (12163, 0, 9351, 0, 63, 52, 60);
INSERT INTO public.who_global_data VALUES (12164, 1, 3786, 0, 123, 52, 3);
INSERT INTO public.who_global_data VALUES (12165, 3487, 198387, 39, 1922, 52, 11);
INSERT INTO public.who_global_data VALUES (12166, 27728, 1379238, 952, 23427, 52, 89);
INSERT INTO public.who_global_data VALUES (12167, 372, 53386, 0, 327, 52, 24);
INSERT INTO public.who_global_data VALUES (12168, 7, 1082, 1, 6, 52, 162);
INSERT INTO public.who_global_data VALUES (12169, 1199, 126372, 98, 3785, 52, 100);
INSERT INTO public.who_global_data VALUES (12170, 0, 19, 0, 0, 52, 47);
INSERT INTO public.who_global_data VALUES (12171, 0, 71, 0, 0, 52, 29);
INSERT INTO public.who_global_data VALUES (12172, 0, 8498, 0, 152, 52, 40);
INSERT INTO public.who_global_data VALUES (12173, 10, 6988, 0, 119, 52, 222);
INSERT INTO public.who_global_data VALUES (12174, 677, 130082, 31, 4476, 52, 132);
INSERT INTO public.who_global_data VALUES (12175, 2, 291, 0, 13, 52, 130);
INSERT INTO public.who_global_data VALUES (12176, 26, 13457, 1, 80, 52, 234);
INSERT INTO public.who_global_data VALUES (12177, 3, 2447, 0, 44, 52, 23);
INSERT INTO public.who_global_data VALUES (12178, 23, 5943, 1, 156, 52, 192);
INSERT INTO public.who_global_data VALUES (12179, 32, 9597, 0, 234, 52, 69);
INSERT INTO public.who_global_data VALUES (12180, 0, 26, 0, 0, 52, 187);
INSERT INTO public.who_global_data VALUES (12181, 283, 114642, 14, 2989, 52, 230);
INSERT INTO public.who_global_data VALUES (12182, 2804, 288567, 144, 7381, 52, 77);
INSERT INTO public.who_global_data VALUES (12183, 7, 5578, 0, 28, 52, 9);
INSERT INTO public.who_global_data VALUES (12184, 26382, 9932547, 387, 144096, 52, 74);
INSERT INTO public.who_global_data VALUES (12185, 6120, 629429, 155, 19111, 52, 224);
INSERT INTO public.who_global_data VALUES (12186, 7704, 1123474, 223, 52670, 52, 199);
INSERT INTO public.who_global_data VALUES (12187, 1391, 577363, 11, 12614, 52, 190);
INSERT INTO public.who_global_data VALUES (12188, 327, 76776, 8, 2134, 52, 12);
INSERT INTO public.who_global_data VALUES (12189, 3, 373, 0, 25, 52, 104);
INSERT INTO public.who_global_data VALUES (12190, 2315, 359984, 11, 3025, 52, 153);
INSERT INTO public.who_global_data VALUES (12191, 14839, 1870576, 846, 65857, 52, 91);
INSERT INTO public.who_global_data VALUES (12192, 83, 11875, 3, 276, 52, 215);
INSERT INTO public.who_global_data VALUES (12193, 2172, 184042, 45, 2688, 52, 84);
INSERT INTO public.who_global_data VALUES (12194, 63, 1842, 0, 32, 52, 231);
INSERT INTO public.who_global_data VALUES (12195, 2547, 265024, 30, 3437, 52, 196);
INSERT INTO public.who_global_data VALUES (12196, 947, 188837, 0, 2609, 52, 105);
INSERT INTO public.who_global_data VALUES (12197, 404, 92459, 11, 1604, 52, 122);
INSERT INTO public.who_global_data VALUES (12198, 0, 0, 0, 0, 52, 159);
INSERT INTO public.who_global_data VALUES (12199, 294, 47160, 17, 1210, 52, 75);
INSERT INTO public.who_global_data VALUES (12200, 261, 146710, 1, 913, 52, 27);
INSERT INTO public.who_global_data VALUES (12201, 241, 78151, 1, 1317, 52, 54);
INSERT INTO public.who_global_data VALUES (12202, 0, 41, 0, 0, 52, 226);
INSERT INTO public.who_global_data VALUES (12203, 587, 26472, 5, 357, 52, 79);
INSERT INTO public.who_global_data VALUES (12204, 1264, 148877, 13, 1223, 52, 56);
INSERT INTO public.who_global_data VALUES (12205, 135, 2285, 0, 44, 52, 117);
INSERT INTO public.who_global_data VALUES (12206, 0, 1771, 0, 83, 52, 152);
INSERT INTO public.who_global_data VALUES (12207, 660, 92017, 5, 1319, 52, 16);
INSERT INTO public.who_global_data VALUES (12208, 40, 1678, 0, 21, 52, 10);
INSERT INTO public.who_global_data VALUES (12209, 3422, 99874, 25, 1139, 52, 201);
INSERT INTO public.who_global_data VALUES (12210, 349, 42249, 8, 418, 52, 174);
INSERT INTO public.who_global_data VALUES (12211, 0, 17587, 0, 259, 52, 119);
INSERT INTO public.who_global_data VALUES (12212, 10, 6080, 0, 187, 52, 168);
INSERT INTO public.who_global_data VALUES (12213, 1772, 86618, 3, 422, 52, 99);
INSERT INTO public.who_global_data VALUES (12214, 13, 13392, 0, 48, 52, 171);
INSERT INTO public.who_global_data VALUES (12215, 42, 5878, 4, 205, 52, 87);
INSERT INTO public.who_global_data VALUES (12216, 49, 11303, 3, 177, 52, 123);
INSERT INTO public.who_global_data VALUES (12217, 0, 4, 0, 0, 52, 151);
INSERT INTO public.who_global_data VALUES (12218, 0, 5601, 0, 42, 52, 213);
INSERT INTO public.who_global_data VALUES (12219, 0, 10971, 0, 225, 52, 118);
INSERT INTO public.who_global_data VALUES (12220, 0, 514, 0, 10, 52, 134);
INSERT INTO public.who_global_data VALUES (12221, 0, 5616, 0, 53, 52, 65);
INSERT INTO public.who_global_data VALUES (12222, 5930, 1255974, 345, 114298, 52, 102);
INSERT INTO public.who_global_data VALUES (12223, 0, 0, 0, 0, 52, 223);
INSERT INTO public.who_global_data VALUES (12224, 6, 681, 0, 3, 52, 4);
INSERT INTO public.who_global_data VALUES (12225, 5, 917, 0, 0, 52, 146);
INSERT INTO public.who_global_data VALUES (12226, 405, 42920, 13, 609, 52, 31);
INSERT INTO public.who_global_data VALUES (12227, 0, 13, 0, 1, 52, 127);
INSERT INTO public.who_global_data VALUES (12228, 2793, 403619, 52, 6711, 52, 22);
INSERT INTO public.who_global_data VALUES (12229, 40, 17042, 1, 144, 52, 115);
INSERT INTO public.who_global_data VALUES (12230, 1170, 109512, 24, 2292, 52, 106);
INSERT INTO public.who_global_data VALUES (12231, 187, 16913, 1, 164, 52, 90);
INSERT INTO public.who_global_data VALUES (12232, 0, 0, 0, 0, 52, 70);
INSERT INTO public.who_global_data VALUES (12233, 936, 250180, 14, 1730, 52, 46);
INSERT INTO public.who_global_data VALUES (12234, 6640, 627446, 86, 10143, 52, 139);
INSERT INTO public.who_global_data VALUES (12235, 0, 36, 0, 0, 52, 42);
INSERT INTO public.who_global_data VALUES (12236, 4, 1744, 0, 25, 52, 80);
INSERT INTO public.who_global_data VALUES (12237, 39, 4748, 1, 163, 52, 203);
INSERT INTO public.who_global_data VALUES (12238, 0, 2078, 0, 77, 52, 136);
INSERT INTO public.who_global_data VALUES (12239, 758, 74132, 3, 1200, 52, 63);
INSERT INTO public.who_global_data VALUES (12240, 0, 0, 0, 0, 52, 17);
INSERT INTO public.who_global_data VALUES (12241, 0, 113, 0, 2, 52, 172);
INSERT INTO public.who_global_data VALUES (12242, 881, 74732, 22, 2169, 52, 109);
INSERT INTO public.who_global_data VALUES (12243, 331, 41334, 2, 395, 52, 200);
INSERT INTO public.who_global_data VALUES (12244, 2307, 128512, 23, 1130, 52, 93);
INSERT INTO public.who_global_data VALUES (12245, 215, 126719, 3, 1475, 52, 5);
INSERT INTO public.who_global_data VALUES (12246, 0, 744, 0, 13, 52, 214);
INSERT INTO public.who_global_data VALUES (12247, 2459, 443246, 73, 8905, 52, 204);
INSERT INTO public.who_global_data VALUES (12248, 0, 0, 0, 0, 52, 198);
INSERT INTO public.who_global_data VALUES (12249, 1612, 194619, 26, 3382, 52, 173);
INSERT INTO public.who_global_data VALUES (12250, 4, 729, 0, 8, 52, 229);
INSERT INTO public.who_global_data VALUES (12251, 641, 94223, 18, 1971, 52, 76);
INSERT INTO public.who_global_data VALUES (12252, 1157, 986130, 77, 36754, 52, 138);
INSERT INTO public.who_global_data VALUES (12253, 1106, 451839, 55, 8812, 52, 98);
INSERT INTO public.who_global_data VALUES (12254, 0, 0, 0, 0, 52, 103);
INSERT INTO public.who_global_data VALUES (12255, 12455, 1159901, 605, 23914, 52, 225);
INSERT INTO public.who_global_data VALUES (12256, 2638, 353576, 84, 5733, 52, 131);
INSERT INTO public.who_global_data VALUES (12257, 434, 63419, 12, 1294, 52, 235);
INSERT INTO public.who_global_data VALUES (12258, 151, 141272, 0, 241, 52, 137);
INSERT INTO public.who_global_data VALUES (12259, 1078, 45436, 12, 612, 52, 81);
INSERT INTO public.who_global_data VALUES (12260, 1403, 128656, 27, 2625, 52, 182);
INSERT INTO public.who_global_data VALUES (12261, 0, 8534, 0, 42, 52, 145);
INSERT INTO public.who_global_data VALUES (12262, 6171, 565758, 204, 13698, 52, 26);
INSERT INTO public.who_global_data VALUES (12263, 26509, 2734454, 596, 48564, 52, 170);
INSERT INTO public.who_global_data VALUES (12264, 85, 6832, 1, 57, 52, 191);
INSERT INTO public.who_global_data VALUES (12265, 0, 5, 0, 0, 52, 221);
INSERT INTO public.who_global_data VALUES (12266, 0, 172, 0, 0, 52, 64);
INSERT INTO public.who_global_data VALUES (12267, 0, 0, 0, 0, 52, 116);
INSERT INTO public.who_global_data VALUES (12268, 0, 28, 0, 0, 52, 128);
INSERT INTO public.who_global_data VALUES (12269, 3, 278, 0, 4, 52, 6);
INSERT INTO public.who_global_data VALUES (12270, 0, 899, 0, 12, 52, 227);
INSERT INTO public.who_global_data VALUES (12271, 0, 14, 0, 0, 52, 68);
INSERT INTO public.who_global_data VALUES (12272, 0, 98, 0, 0, 52, 184);
INSERT INTO public.who_global_data VALUES (12273, 0, 2, 0, 0, 52, 82);
INSERT INTO public.who_global_data VALUES (12274, 43, 2025, 2, 54, 52, 149);
INSERT INTO public.who_global_data VALUES (12275, 0, 1010, 0, 17, 52, 197);
INSERT INTO public.who_global_data VALUES (12276, 142, 360155, 10, 6069, 52, 78);
INSERT INTO public.who_global_data VALUES (12277, 70, 17216, 0, 350, 52, 233);
INSERT INTO public.who_global_data VALUES (12278, 5884, 277248, 53, 2433, 52, 133);
INSERT INTO public.who_global_data VALUES (12279, 0, 185, 0, 0, 52, 35);
INSERT INTO public.who_global_data VALUES (12280, 6, 2451, 0, 75, 52, 114);
INSERT INTO public.who_global_data VALUES (12281, 16, 58341, 0, 29, 52, 237);
INSERT INTO public.who_global_data VALUES (12282, 0, 18, 0, 0, 52, 55);
INSERT INTO public.who_global_data VALUES (12283, 17, 1249, 0, 26, 52, 176);
INSERT INTO public.who_global_data VALUES (12284, 3565, 139088, 58, 1309, 52, 202);
INSERT INTO public.who_global_data VALUES (12285, 2112, 100431, 52, 2428, 52, 155);
INSERT INTO public.who_global_data VALUES (12286, 0, 17, 0, 0, 52, 32);
INSERT INTO public.who_global_data VALUES (12287, 0, 4579, 0, 121, 52, 220);
INSERT INTO public.who_global_data VALUES (12288, 7552, 873679, 210, 23661, 52, 30);
INSERT INTO public.who_global_data VALUES (12289, 0, 3206, 0, 62, 52, 147);
INSERT INTO public.who_global_data VALUES (12290, 10142, 1823772, 146, 49527, 52, 208);
INSERT INTO public.who_global_data VALUES (12291, 643, 34121, 0, 154, 52, 45);
INSERT INTO public.who_global_data VALUES (12292, 183, 22265, 24, 1408, 52, 110);
INSERT INTO public.who_global_data VALUES (12293, 6, 5359, 0, 117, 52, 88);
INSERT INTO public.who_global_data VALUES (12294, 3534, 341563, 94, 8266, 52, 51);
INSERT INTO public.who_global_data VALUES (12295, 5166, 395315, 87, 6016, 52, 209);
INSERT INTO public.who_global_data VALUES (12296, 150, 9452, 13, 543, 52, 205);
INSERT INTO public.who_global_data VALUES (12297, 57, 13017, 2, 89, 52, 18);
INSERT INTO public.who_global_data VALUES (12298, 9, 4246, 0, 60, 52, 72);
INSERT INTO public.who_global_data VALUES (12299, 18450, 1888120, 506, 64908, 52, 44);
INSERT INTO public.who_global_data VALUES (12300, 0, 31, 0, 0, 52, 15);
INSERT INTO public.who_global_data VALUES (12301, 29, 3295, 0, 66, 52, 25);
INSERT INTO public.who_global_data VALUES (12302, 0, 0, 0, 0, 52, 179);
INSERT INTO public.who_global_data VALUES (12303, 0, 0, 0, 0, 52, 34);
INSERT INTO public.who_global_data VALUES (12304, 6, 6885, 1, 123, 52, 207);
INSERT INTO public.who_global_data VALUES (12305, 1483, 113241, 41, 3956, 52, 166);
INSERT INTO public.who_global_data VALUES (12306, 32102, 1898447, 235, 16881, 52, 126);
INSERT INTO public.who_global_data VALUES (12307, 0, 0, 0, 0, 52, 97);
INSERT INTO public.who_global_data VALUES (12308, 0, 769, 0, 6, 52, 36);
INSERT INTO public.who_global_data VALUES (12309, 0, 0, 0, 0, 52, 125);
INSERT INTO public.who_global_data VALUES (12310, 402, 28168, 1, 225, 52, 124);
INSERT INTO public.who_global_data VALUES (12311, 10622, 919704, 264, 15744, 52, 185);
INSERT INTO public.who_global_data VALUES (12312, 1226, 187267, 4, 622, 52, 194);
INSERT INTO public.who_global_data VALUES (12313, 0, 509, 0, 21, 52, 144);
INSERT INTO public.who_global_data VALUES (12314, 204281, 16245376, 1754, 298594, 52, 19);
INSERT INTO public.who_global_data VALUES (12315, 21, 1828, 0, 23, 52, 217);
INSERT INTO public.who_global_data VALUES (12316, 321, 10029, 3, 95, 52, 148);
INSERT INTO public.who_global_data VALUES (12317, 155, 75396, 0, 612, 52, 86);
INSERT INTO public.who_global_data VALUES (12318, 0, 1, 0, 0, 52, 13);
INSERT INTO public.who_global_data VALUES (12319, 339, 108125, 6, 960, 52, 157);
INSERT INTO public.who_global_data VALUES (12320, 3, 1405, 0, 35, 52, 8);
INSERT INTO public.who_global_data VALUES (12321, 0, 4, 0, 0, 52, 73);
INSERT INTO public.who_global_data VALUES (12322, 1, 2089, 0, 607, 52, 101);
INSERT INTO public.who_global_data VALUES (12323, 106, 18428, 1, 368, 52, 165);
INSERT INTO public.who_global_data VALUES (12324, 164, 11522, 1, 310, 52, 14);
INSERT INTO public.who_global_data VALUES (12325, 211, 49484, 4, 1975, 53, 193);
INSERT INTO public.who_global_data VALUES (12326, 661, 49191, 13, 1016, 53, 113);
INSERT INTO public.who_global_data VALUES (12327, 495, 92597, 13, 2609, 53, 143);
INSERT INTO public.who_global_data VALUES (12328, 0, 0, 0, 0, 53, 219);
INSERT INTO public.who_global_data VALUES (12329, 44, 7382, 0, 79, 53, 186);
INSERT INTO public.who_global_data VALUES (12330, 89, 16277, 1, 372, 53, 52);
INSERT INTO public.who_global_data VALUES (12331, 0, 10, 0, 0, 53, 180);
INSERT INTO public.who_global_data VALUES (12332, 0, 148, 1, 5, 53, 167);
INSERT INTO public.who_global_data VALUES (12333, 3558, 1498160, 98, 40766, 53, 154);
INSERT INTO public.who_global_data VALUES (12334, 438, 148433, 26, 2524, 53, 94);
INSERT INTO public.who_global_data VALUES (12335, 38, 5049, 0, 46, 53, 66);
INSERT INTO public.who_global_data VALUES (12336, 8, 28039, 0, 908, 53, 58);
INSERT INTO public.who_global_data VALUES (12337, 2521, 322557, 110, 4510, 53, 163);
INSERT INTO public.who_global_data VALUES (12338, 3112, 178986, 44, 1966, 53, 37);
INSERT INTO public.who_global_data VALUES (12339, 16, 7690, 0, 163, 53, 142);
INSERT INTO public.who_global_data VALUES (12340, 125, 89267, 0, 348, 53, 83);
INSERT INTO public.who_global_data VALUES (12341, 1799, 492332, 37, 7089, 53, 228);
INSERT INTO public.who_global_data VALUES (12342, 4, 296, 0, 7, 53, 188);
INSERT INTO public.who_global_data VALUES (12343, 1853, 162148, 10, 1273, 53, 62);
INSERT INTO public.who_global_data VALUES (12344, 3843, 613900, 100, 18204, 53, 160);
INSERT INTO public.who_global_data VALUES (12345, 122, 9295, 3, 195, 53, 50);
INSERT INTO public.who_global_data VALUES (12346, 0, 3090, 0, 44, 53, 33);
INSERT INTO public.who_global_data VALUES (12347, 40, 431, 0, 9, 53, 183);
INSERT INTO public.who_global_data VALUES (12348, 0, 438, 0, 0, 53, 92);
INSERT INTO public.who_global_data VALUES (12349, 120, 147150, 4, 9018, 53, 158);
INSERT INTO public.who_global_data VALUES (12350, 4, 154, 0, 3, 53, 67);
INSERT INTO public.who_global_data VALUES (12351, 344, 101461, 55, 3391, 53, 57);
INSERT INTO public.who_global_data VALUES (12352, 0, 12501, 0, 37, 53, 38);
INSERT INTO public.who_global_data VALUES (12353, 21825, 6901952, 279, 181402, 53, 141);
INSERT INTO public.who_global_data VALUES (12354, 0, 76, 0, 1, 53, 178);
INSERT INTO public.who_global_data VALUES (12355, 0, 152, 0, 3, 53, 108);
INSERT INTO public.who_global_data VALUES (12356, 2095, 181544, 150, 5838, 53, 39);
INSERT INTO public.who_global_data VALUES (12357, 179, 4209, 0, 71, 53, 2);
INSERT INTO public.who_global_data VALUES (12358, 6, 735, 0, 1, 53, 195);
INSERT INTO public.who_global_data VALUES (12359, 4, 11361, 0, 110, 53, 107);
INSERT INTO public.who_global_data VALUES (12360, 3, 362, 0, 0, 53, 161);
INSERT INTO public.who_global_data VALUES (12361, 145, 25359, 2, 445, 53, 212);
INSERT INTO public.who_global_data VALUES (12362, 5891, 460743, 81, 13431, 53, 181);
INSERT INTO public.who_global_data VALUES (12363, 0, 298, 0, 2, 53, 53);
INSERT INTO public.who_global_data VALUES (12364, 0, 4936, 0, 63, 53, 164);
INSERT INTO public.who_global_data VALUES (12365, 1, 1771, 0, 102, 53, 140);
INSERT INTO public.who_global_data VALUES (12366, 1911, 573830, 45, 15931, 53, 20);
INSERT INTO public.who_global_data VALUES (12367, 103, 95167, 3, 4761, 53, 112);
INSERT INTO public.who_global_data VALUES (12368, 8702, 1425774, 187, 39053, 53, 111);
INSERT INTO public.who_global_data VALUES (12369, 5, 629, 0, 7, 53, 71);
INSERT INTO public.who_global_data VALUES (12370, 0, 6200, 0, 100, 53, 218);
INSERT INTO public.who_global_data VALUES (12371, 0, 0, 0, 0, 53, 43);
INSERT INTO public.who_global_data VALUES (12372, 524, 152620, 8, 1921, 53, 49);
INSERT INTO public.who_global_data VALUES (12373, 25, 21705, 0, 133, 53, 1);
INSERT INTO public.who_global_data VALUES (12374, 1472, 177358, 65, 2705, 53, 48);
INSERT INTO public.who_global_data VALUES (12375, 69, 9492, 0, 137, 53, 232);
INSERT INTO public.who_global_data VALUES (12376, 220, 3624, 3, 11, 53, 175);
INSERT INTO public.who_global_data VALUES (12377, 349, 15450, 4, 82, 53, 21);
INSERT INTO public.who_global_data VALUES (12378, 5172, 586251, 134, 9743, 53, 156);
INSERT INTO public.who_global_data VALUES (12379, 0, 0, 0, 0, 53, 95);
INSERT INTO public.who_global_data VALUES (12380, 0, 14460, 4, 356, 53, 177);
INSERT INTO public.who_global_data VALUES (12381, 3337, 113095, 9, 950, 53, 210);
INSERT INTO public.who_global_data VALUES (12382, 4, 5733, 0, 61, 53, 120);
INSERT INTO public.who_global_data VALUES (12383, 1, 88, 0, 0, 53, 135);
INSERT INTO public.who_global_data VALUES (12384, 492, 155184, 3, 2364, 53, 206);
INSERT INTO public.who_global_data VALUES (12385, 70, 202180, 0, 13875, 53, 189);
INSERT INTO public.who_global_data VALUES (12386, 511, 122086, 23, 6943, 53, 129);
INSERT INTO public.who_global_data VALUES (12387, 486, 41880, 5, 1205, 53, 121);
INSERT INTO public.who_global_data VALUES (12388, 0, 5185, 0, 85, 53, 59);
INSERT INTO public.who_global_data VALUES (12389, 0, 711, 0, 0, 53, 96);
INSERT INTO public.who_global_data VALUES (12390, 331, 18386, 5, 154, 53, 41);
INSERT INTO public.who_global_data VALUES (12391, 57, 6825, 3, 130, 53, 216);
INSERT INTO public.who_global_data VALUES (12392, 473, 117242, 3, 1809, 53, 236);
INSERT INTO public.who_global_data VALUES (12393, 0, 19, 0, 0, 53, 150);
INSERT INTO public.who_global_data VALUES (12394, 0, 528, 0, 0, 53, 61);
INSERT INTO public.who_global_data VALUES (12395, 0, 46, 0, 2, 53, 7);
INSERT INTO public.who_global_data VALUES (12396, 300, 31110, 8, 461, 53, 169);
INSERT INTO public.who_global_data VALUES (12397, 2590, 2338726, 368, 57910, 53, 28);
INSERT INTO public.who_global_data VALUES (12398, 55, 11855, 0, 71, 53, 85);
INSERT INTO public.who_global_data VALUES (12399, 129, 15747, 5, 96, 53, 211);
INSERT INTO public.who_global_data VALUES (12400, 21, 9351, 0, 63, 53, 60);
INSERT INTO public.who_global_data VALUES (12401, 3, 3785, 0, 123, 53, 3);
INSERT INTO public.who_global_data VALUES (12402, 3837, 194900, 44, 1883, 53, 11);
INSERT INTO public.who_global_data VALUES (12403, 14432, 1351510, 500, 22475, 53, 89);
INSERT INTO public.who_global_data VALUES (12404, 81, 53014, 0, 327, 53, 24);
INSERT INTO public.who_global_data VALUES (12405, 3, 1075, 0, 5, 53, 162);
INSERT INTO public.who_global_data VALUES (12406, 639, 125173, 62, 3687, 53, 100);
INSERT INTO public.who_global_data VALUES (12407, 0, 19, 0, 0, 53, 47);
INSERT INTO public.who_global_data VALUES (12408, 2, 71, 0, 0, 53, 29);
INSERT INTO public.who_global_data VALUES (12409, 47, 8498, 0, 152, 53, 40);
INSERT INTO public.who_global_data VALUES (12410, 9, 6978, 1, 119, 53, 222);
INSERT INTO public.who_global_data VALUES (12411, 123, 129405, 22, 4445, 53, 132);
INSERT INTO public.who_global_data VALUES (12412, 0, 289, 0, 13, 53, 130);
INSERT INTO public.who_global_data VALUES (12413, 11, 13431, 0, 79, 53, 234);
INSERT INTO public.who_global_data VALUES (12414, 0, 2444, 0, 44, 53, 23);
INSERT INTO public.who_global_data VALUES (12415, 41, 5920, 1, 155, 53, 192);
INSERT INTO public.who_global_data VALUES (12416, 56, 9565, 0, 234, 53, 69);
INSERT INTO public.who_global_data VALUES (12417, 0, 26, 0, 0, 53, 187);
INSERT INTO public.who_global_data VALUES (12418, 316, 114359, 1, 2975, 53, 230);
INSERT INTO public.who_global_data VALUES (12419, 1893, 285763, 107, 7237, 53, 77);
INSERT INTO public.who_global_data VALUES (12420, 14, 5571, 0, 28, 53, 9);
INSERT INTO public.who_global_data VALUES (12421, 22065, 9906165, 354, 143709, 53, 74);
INSERT INTO public.who_global_data VALUES (12422, 5489, 623309, 137, 18956, 53, 224);
INSERT INTO public.who_global_data VALUES (12423, 7501, 1115770, 251, 52447, 53, 199);
INSERT INTO public.who_global_data VALUES (12424, 1338, 575972, 24, 12603, 53, 190);
INSERT INTO public.who_global_data VALUES (12425, 264, 76449, 2, 2126, 53, 12);
INSERT INTO public.who_global_data VALUES (12426, 0, 370, 0, 25, 53, 104);
INSERT INTO public.who_global_data VALUES (12427, 1729, 357669, 9, 3014, 53, 153);
INSERT INTO public.who_global_data VALUES (12428, 12025, 1855737, 491, 65011, 53, 91);
INSERT INTO public.who_global_data VALUES (12429, 82, 11792, 0, 273, 53, 215);
INSERT INTO public.who_global_data VALUES (12430, 2217, 181870, 58, 2643, 53, 84);
INSERT INTO public.who_global_data VALUES (12431, 91, 1779, 0, 32, 53, 231);
INSERT INTO public.who_global_data VALUES (12432, 2863, 262477, 42, 3407, 53, 196);
INSERT INTO public.who_global_data VALUES (12433, 930, 187890, 0, 2609, 53, 105);
INSERT INTO public.who_global_data VALUES (12434, 163, 92055, 6, 1593, 53, 122);
INSERT INTO public.who_global_data VALUES (12435, 0, 0, 0, 0, 53, 159);
INSERT INTO public.who_global_data VALUES (12436, 329, 46866, 5, 1193, 53, 75);
INSERT INTO public.who_global_data VALUES (12437, 231, 146449, 1, 912, 53, 27);
INSERT INTO public.who_global_data VALUES (12438, 236, 77910, 4, 1316, 53, 54);
INSERT INTO public.who_global_data VALUES (12439, 0, 41, 0, 0, 53, 226);
INSERT INTO public.who_global_data VALUES (12440, 210, 25885, 3, 352, 53, 79);
INSERT INTO public.who_global_data VALUES (12441, 1093, 147613, 10, 1210, 53, 56);
INSERT INTO public.who_global_data VALUES (12442, 0, 2150, 0, 44, 53, 117);
INSERT INTO public.who_global_data VALUES (12443, 0, 1771, 0, 83, 53, 152);
INSERT INTO public.who_global_data VALUES (12444, 578, 91357, 15, 1314, 53, 16);
INSERT INTO public.who_global_data VALUES (12445, 32, 1638, 0, 21, 53, 10);
INSERT INTO public.who_global_data VALUES (12446, 1436, 96452, 45, 1114, 53, 201);
INSERT INTO public.who_global_data VALUES (12447, 182, 41900, 8, 410, 53, 174);
INSERT INTO public.who_global_data VALUES (12448, 0, 17587, 0, 259, 53, 119);
INSERT INTO public.who_global_data VALUES (12449, 4, 6070, 0, 187, 53, 168);
INSERT INTO public.who_global_data VALUES (12450, 1371, 84846, 4, 419, 53, 99);
INSERT INTO public.who_global_data VALUES (12451, 11, 13379, 0, 48, 53, 171);
INSERT INTO public.who_global_data VALUES (12452, 22, 5836, 7, 201, 53, 87);
INSERT INTO public.who_global_data VALUES (12453, 101, 11254, 5, 174, 53, 123);
INSERT INTO public.who_global_data VALUES (12454, 0, 4, 0, 0, 53, 151);
INSERT INTO public.who_global_data VALUES (12455, 48, 5601, 1, 42, 53, 213);
INSERT INTO public.who_global_data VALUES (12456, 0, 10971, 0, 225, 53, 118);
INSERT INTO public.who_global_data VALUES (12457, 0, 514, 0, 10, 53, 134);
INSERT INTO public.who_global_data VALUES (12458, 65, 5616, 1, 53, 53, 65);
INSERT INTO public.who_global_data VALUES (12459, 8608, 1250044, 249, 113953, 53, 102);
INSERT INTO public.who_global_data VALUES (12460, 0, 0, 0, 0, 53, 223);
INSERT INTO public.who_global_data VALUES (12461, 4, 675, 0, 3, 53, 4);
INSERT INTO public.who_global_data VALUES (12462, 5, 912, 0, 0, 53, 146);
INSERT INTO public.who_global_data VALUES (12463, 378, 42515, 12, 596, 53, 31);
INSERT INTO public.who_global_data VALUES (12464, 0, 13, 0, 1, 53, 127);
INSERT INTO public.who_global_data VALUES (12465, 1217, 400826, 35, 6659, 53, 22);
INSERT INTO public.who_global_data VALUES (12466, 48, 17002, 1, 143, 53, 115);
INSERT INTO public.who_global_data VALUES (12467, 1127, 108342, 23, 2268, 53, 106);
INSERT INTO public.who_global_data VALUES (12468, 190, 16726, 3, 163, 53, 90);
INSERT INTO public.who_global_data VALUES (12469, 0, 0, 0, 0, 53, 70);
INSERT INTO public.who_global_data VALUES (12470, 821, 249244, 18, 1716, 53, 46);
INSERT INTO public.who_global_data VALUES (12471, 8465, 620806, 35, 10057, 53, 139);
INSERT INTO public.who_global_data VALUES (12472, 0, 36, 0, 0, 53, 42);
INSERT INTO public.who_global_data VALUES (12473, 0, 1740, 0, 25, 53, 80);
INSERT INTO public.who_global_data VALUES (12474, 0, 4709, 0, 162, 53, 203);
INSERT INTO public.who_global_data VALUES (12475, 0, 2078, 0, 77, 53, 136);
INSERT INTO public.who_global_data VALUES (12476, 199, 73374, 0, 1197, 53, 63);
INSERT INTO public.who_global_data VALUES (12477, 0, 0, 0, 0, 53, 17);
INSERT INTO public.who_global_data VALUES (12478, 0, 113, 0, 2, 53, 172);
INSERT INTO public.who_global_data VALUES (12479, 213, 73851, 26, 2147, 53, 109);
INSERT INTO public.who_global_data VALUES (12480, 981, 41003, 6, 393, 53, 200);
INSERT INTO public.who_global_data VALUES (12481, 1564, 126205, 28, 1107, 53, 93);
INSERT INTO public.who_global_data VALUES (12482, 264, 126504, 1, 1472, 53, 5);
INSERT INTO public.who_global_data VALUES (12483, 0, 744, 0, 13, 53, 214);
INSERT INTO public.who_global_data VALUES (12484, 2362, 440787, 36, 8832, 53, 204);
INSERT INTO public.who_global_data VALUES (12485, 0, 0, 0, 0, 53, 198);
INSERT INTO public.who_global_data VALUES (12486, 2422, 193007, 25, 3356, 53, 173);
INSERT INTO public.who_global_data VALUES (12487, 0, 725, 0, 8, 53, 229);
INSERT INTO public.who_global_data VALUES (12488, 669, 93582, 16, 1953, 53, 76);
INSERT INTO public.who_global_data VALUES (12489, 1928, 984973, 68, 36677, 53, 138);
INSERT INTO public.who_global_data VALUES (12490, 1333, 450733, 24, 8757, 53, 98);
INSERT INTO public.who_global_data VALUES (12491, 0, 0, 0, 0, 53, 103);
INSERT INTO public.who_global_data VALUES (12492, 11770, 1147446, 445, 23309, 53, 225);
INSERT INTO public.who_global_data VALUES (12493, 2194, 350938, 90, 5649, 53, 131);
INSERT INTO public.who_global_data VALUES (12494, 554, 62985, 10, 1282, 53, 235);
INSERT INTO public.who_global_data VALUES (12495, 160, 141121, 1, 241, 53, 137);
INSERT INTO public.who_global_data VALUES (12496, 880, 44358, 13, 600, 53, 81);
INSERT INTO public.who_global_data VALUES (12497, 735, 127253, 26, 2598, 53, 182);
INSERT INTO public.who_global_data VALUES (12498, 189, 8534, 1, 42, 53, 145);
INSERT INTO public.who_global_data VALUES (12499, 3252, 559587, 109, 13494, 53, 26);
INSERT INTO public.who_global_data VALUES (12500, 26689, 2707945, 577, 47968, 53, 170);
INSERT INTO public.who_global_data VALUES (12501, 88, 6747, 0, 56, 53, 191);
INSERT INTO public.who_global_data VALUES (12502, 0, 5, 0, 0, 53, 221);
INSERT INTO public.who_global_data VALUES (12503, 8, 172, 0, 0, 53, 64);
INSERT INTO public.who_global_data VALUES (12504, 0, 0, 0, 0, 53, 116);
INSERT INTO public.who_global_data VALUES (12505, 1, 28, 0, 0, 53, 128);
INSERT INTO public.who_global_data VALUES (12506, 0, 275, 0, 4, 53, 6);
INSERT INTO public.who_global_data VALUES (12507, 61, 899, 0, 12, 53, 227);
INSERT INTO public.who_global_data VALUES (12508, 0, 14, 0, 0, 53, 68);
INSERT INTO public.who_global_data VALUES (12509, 0, 98, 0, 0, 53, 184);
INSERT INTO public.who_global_data VALUES (12510, 0, 2, 0, 0, 53, 82);
INSERT INTO public.who_global_data VALUES (12511, 35, 1982, 1, 52, 53, 149);
INSERT INTO public.who_global_data VALUES (12512, 1, 1010, 0, 17, 53, 197);
INSERT INTO public.who_global_data VALUES (12513, 125, 360013, 11, 6059, 53, 78);
INSERT INTO public.who_global_data VALUES (12514, 71, 17146, 1, 350, 53, 233);
INSERT INTO public.who_global_data VALUES (12515, 4932, 271364, 49, 2380, 53, 133);
INSERT INTO public.who_global_data VALUES (12516, 0, 185, 0, 0, 53, 35);
INSERT INTO public.who_global_data VALUES (12517, 3, 2445, 0, 75, 53, 114);
INSERT INTO public.who_global_data VALUES (12518, 5, 58325, 0, 29, 53, 237);
INSERT INTO public.who_global_data VALUES (12519, 0, 18, 0, 0, 53, 55);
INSERT INTO public.who_global_data VALUES (12520, 31, 1232, 0, 26, 53, 176);
INSERT INTO public.who_global_data VALUES (12521, 2034, 135523, 46, 1251, 53, 202);
INSERT INTO public.who_global_data VALUES (12522, 1532, 98319, 55, 2376, 53, 155);
INSERT INTO public.who_global_data VALUES (12523, 0, 17, 0, 0, 53, 32);
INSERT INTO public.who_global_data VALUES (12524, 0, 4579, 0, 121, 53, 220);
INSERT INTO public.who_global_data VALUES (12525, 5163, 866127, 175, 23451, 53, 30);
INSERT INTO public.who_global_data VALUES (12526, 0, 3206, 0, 62, 53, 147);
INSERT INTO public.who_global_data VALUES (12527, 4340, 1813630, 139, 49381, 53, 208);
INSERT INTO public.who_global_data VALUES (12528, 688, 33478, 2, 154, 53, 45);
INSERT INTO public.who_global_data VALUES (12529, 218, 22082, 12, 1384, 53, 110);
INSERT INTO public.who_global_data VALUES (12530, 4, 5353, 0, 117, 53, 88);
INSERT INTO public.who_global_data VALUES (12531, 3057, 338029, 71, 8172, 53, 51);
INSERT INTO public.who_global_data VALUES (12532, 5915, 390149, 97, 5929, 53, 209);
INSERT INTO public.who_global_data VALUES (12533, 136, 9302, 12, 530, 53, 205);
INSERT INTO public.who_global_data VALUES (12534, 47, 12960, 0, 87, 53, 18);
INSERT INTO public.who_global_data VALUES (12535, 28, 4237, 0, 60, 53, 72);
INSERT INTO public.who_global_data VALUES (12536, 20263, 1869670, 232, 64402, 53, 44);
INSERT INTO public.who_global_data VALUES (12537, 0, 31, 0, 0, 53, 15);
INSERT INTO public.who_global_data VALUES (12538, 64, 3266, 0, 66, 53, 25);
INSERT INTO public.who_global_data VALUES (12539, 0, 0, 0, 0, 53, 179);
INSERT INTO public.who_global_data VALUES (12540, 0, 0, 0, 0, 53, 34);
INSERT INTO public.who_global_data VALUES (12541, 15, 6879, 0, 122, 53, 207);
INSERT INTO public.who_global_data VALUES (12542, 397, 111758, 21, 3915, 53, 166);
INSERT INTO public.who_global_data VALUES (12543, 29617, 1866345, 229, 16646, 53, 126);
INSERT INTO public.who_global_data VALUES (12544, 0, 0, 0, 0, 53, 97);
INSERT INTO public.who_global_data VALUES (12545, 0, 769, 0, 6, 53, 36);
INSERT INTO public.who_global_data VALUES (12546, 0, 0, 0, 0, 53, 125);
INSERT INTO public.who_global_data VALUES (12547, 234, 27766, 3, 224, 53, 124);
INSERT INTO public.who_global_data VALUES (12548, 8416, 909082, 233, 15480, 53, 185);
INSERT INTO public.who_global_data VALUES (12549, 1092, 186041, 1, 618, 53, 194);
INSERT INTO public.who_global_data VALUES (12550, 0, 509, 0, 21, 53, 144);
INSERT INTO public.who_global_data VALUES (12551, 180420, 16041095, 1434, 296840, 53, 19);
INSERT INTO public.who_global_data VALUES (12552, 16, 1807, 0, 23, 53, 217);
INSERT INTO public.who_global_data VALUES (12553, 528, 9708, 1, 92, 53, 148);
INSERT INTO public.who_global_data VALUES (12554, 147, 75241, 0, 612, 53, 86);
INSERT INTO public.who_global_data VALUES (12555, 0, 1, 0, 0, 53, 13);
INSERT INTO public.who_global_data VALUES (12556, 609, 107786, 5, 954, 53, 157);
INSERT INTO public.who_global_data VALUES (12557, 5, 1402, 0, 35, 53, 8);
INSERT INTO public.who_global_data VALUES (12558, 1, 4, 0, 0, 53, 73);
INSERT INTO public.who_global_data VALUES (12559, 1, 2088, 0, 607, 53, 101);
INSERT INTO public.who_global_data VALUES (12560, 48, 18322, 0, 367, 53, 165);
INSERT INTO public.who_global_data VALUES (12561, 112, 11358, 2, 309, 53, 14);
INSERT INTO public.who_global_data VALUES (12562, 321, 49273, 11, 1971, 54, 193);
INSERT INTO public.who_global_data VALUES (12563, 788, 48530, 14, 1003, 54, 113);
INSERT INTO public.who_global_data VALUES (12564, 464, 92102, 12, 2596, 54, 143);
INSERT INTO public.who_global_data VALUES (12565, 0, 0, 0, 0, 54, 219);
INSERT INTO public.who_global_data VALUES (12566, 50, 7338, 1, 79, 54, 186);
INSERT INTO public.who_global_data VALUES (12567, 27, 16188, 5, 371, 54, 52);
INSERT INTO public.who_global_data VALUES (12568, 0, 10, 0, 0, 54, 180);
INSERT INTO public.who_global_data VALUES (12569, 1, 148, 0, 4, 54, 167);
INSERT INTO public.who_global_data VALUES (12570, 5274, 1494602, 62, 40668, 54, 154);
INSERT INTO public.who_global_data VALUES (12571, 357, 147995, 17, 2498, 54, 94);
INSERT INTO public.who_global_data VALUES (12572, 0, 5011, 0, 46, 54, 66);
INSERT INTO public.who_global_data VALUES (12573, 6, 28031, 0, 908, 54, 58);
INSERT INTO public.who_global_data VALUES (12574, 3005, 320036, 45, 4400, 54, 163);
INSERT INTO public.who_global_data VALUES (12575, 4451, 175874, 39, 1922, 54, 37);
INSERT INTO public.who_global_data VALUES (12576, 15, 7674, 0, 163, 54, 142);
INSERT INTO public.who_global_data VALUES (12577, 178, 89142, 0, 348, 54, 83);
INSERT INTO public.who_global_data VALUES (12578, 1355, 490533, 32, 7052, 54, 228);
INSERT INTO public.who_global_data VALUES (12579, 0, 292, 0, 7, 54, 188);
INSERT INTO public.who_global_data VALUES (12580, 1961, 160295, 9, 1263, 54, 62);
INSERT INTO public.who_global_data VALUES (12581, 742, 610057, 92, 18104, 54, 160);
INSERT INTO public.who_global_data VALUES (12582, 208, 9173, 7, 192, 54, 50);
INSERT INTO public.who_global_data VALUES (12583, 0, 3090, 0, 44, 54, 33);
INSERT INTO public.who_global_data VALUES (12584, 0, 391, 0, 9, 54, 183);
INSERT INTO public.who_global_data VALUES (12585, 1, 438, 0, 0, 54, 92);
INSERT INTO public.who_global_data VALUES (12586, 333, 147030, 1, 9014, 54, 158);
INSERT INTO public.who_global_data VALUES (12587, 0, 150, 0, 3, 54, 67);
INSERT INTO public.who_global_data VALUES (12588, 811, 101117, 38, 3336, 54, 57);
INSERT INTO public.who_global_data VALUES (12589, 0, 12501, 0, 37, 54, 38);
INSERT INTO public.who_global_data VALUES (12590, 43900, 6880127, 686, 181123, 54, 141);
INSERT INTO public.who_global_data VALUES (12591, 0, 76, 0, 1, 54, 178);
INSERT INTO public.who_global_data VALUES (12592, 0, 152, 0, 3, 54, 108);
INSERT INTO public.who_global_data VALUES (12593, 497, 179449, 62, 5688, 54, 39);
INSERT INTO public.who_global_data VALUES (12594, 136, 4030, 0, 71, 54, 2);
INSERT INTO public.who_global_data VALUES (12595, 0, 729, 0, 1, 54, 195);
INSERT INTO public.who_global_data VALUES (12596, 55, 11357, 0, 110, 54, 107);
INSERT INTO public.who_global_data VALUES (12597, 0, 359, 0, 0, 54, 161);
INSERT INTO public.who_global_data VALUES (12598, 71, 25214, 0, 443, 54, 212);
INSERT INTO public.who_global_data VALUES (12599, 6011, 454852, 99, 13350, 54, 181);
INSERT INTO public.who_global_data VALUES (12600, 0, 298, 0, 2, 54, 53);
INSERT INTO public.who_global_data VALUES (12601, 0, 4936, 0, 63, 54, 164);
INSERT INTO public.who_global_data VALUES (12602, 31, 1770, 0, 102, 54, 140);
INSERT INTO public.who_global_data VALUES (12603, 2138, 571919, 40, 15886, 54, 20);
INSERT INTO public.who_global_data VALUES (12604, 114, 95064, 2, 4758, 54, 112);
INSERT INTO public.who_global_data VALUES (12605, 8163, 1417072, 197, 38866, 54, 111);
INSERT INTO public.who_global_data VALUES (12606, 0, 624, 0, 7, 54, 71);
INSERT INTO public.who_global_data VALUES (12607, 151, 6200, 1, 100, 54, 218);
INSERT INTO public.who_global_data VALUES (12608, 0, 0, 0, 0, 54, 43);
INSERT INTO public.who_global_data VALUES (12609, 1149, 152096, 18, 1913, 54, 49);
INSERT INTO public.who_global_data VALUES (12610, 41, 21680, 0, 133, 54, 1);
INSERT INTO public.who_global_data VALUES (12611, 3363, 175886, 78, 2640, 54, 48);
INSERT INTO public.who_global_data VALUES (12612, 69, 9423, 0, 137, 54, 232);
INSERT INTO public.who_global_data VALUES (12613, 0, 3404, 0, 8, 54, 175);
INSERT INTO public.who_global_data VALUES (12614, 301, 15101, 1, 78, 54, 21);
INSERT INTO public.who_global_data VALUES (12615, 2000, 581079, 74, 9609, 54, 156);
INSERT INTO public.who_global_data VALUES (12616, 0, 0, 0, 0, 54, 95);
INSERT INTO public.who_global_data VALUES (12617, 119, 14460, 0, 352, 54, 177);
INSERT INTO public.who_global_data VALUES (12618, 2642, 109758, 6, 941, 54, 210);
INSERT INTO public.who_global_data VALUES (12619, 4, 5729, 0, 61, 54, 120);
INSERT INTO public.who_global_data VALUES (12620, 0, 87, 0, 0, 54, 135);
INSERT INTO public.who_global_data VALUES (12621, 1107, 154692, 1, 2361, 54, 206);
INSERT INTO public.who_global_data VALUES (12622, 586, 202110, 1, 13875, 54, 189);
INSERT INTO public.who_global_data VALUES (12623, 486, 121575, 22, 6920, 54, 129);
INSERT INTO public.who_global_data VALUES (12624, 0, 41394, 7, 1200, 54, 121);
INSERT INTO public.who_global_data VALUES (12625, 0, 5185, 0, 85, 54, 59);
INSERT INTO public.who_global_data VALUES (12626, 55, 711, 0, 0, 54, 96);
INSERT INTO public.who_global_data VALUES (12627, 342, 18055, 1, 149, 54, 41);
INSERT INTO public.who_global_data VALUES (12628, 54, 6768, 0, 127, 54, 216);
INSERT INTO public.who_global_data VALUES (12629, 1409, 116769, 27, 1806, 54, 236);
INSERT INTO public.who_global_data VALUES (12630, 0, 19, 0, 0, 54, 150);
INSERT INTO public.who_global_data VALUES (12631, 3, 528, 0, 0, 54, 61);
INSERT INTO public.who_global_data VALUES (12632, 2, 46, 0, 2, 54, 7);
INSERT INTO public.who_global_data VALUES (12633, 360, 30810, 0, 453, 54, 169);
INSERT INTO public.who_global_data VALUES (12634, 11533, 2336136, 150, 57542, 54, 28);
INSERT INTO public.who_global_data VALUES (12635, 0, 11800, 0, 71, 54, 85);
INSERT INTO public.who_global_data VALUES (12636, 0, 15618, 0, 91, 54, 211);
INSERT INTO public.who_global_data VALUES (12637, 0, 9330, 0, 63, 54, 60);
INSERT INTO public.who_global_data VALUES (12638, 0, 3782, 0, 123, 54, 3);
INSERT INTO public.who_global_data VALUES (12639, 1337, 191063, 49, 1839, 54, 11);
INSERT INTO public.who_global_data VALUES (12640, 16362, 1337078, 188, 21975, 54, 89);
INSERT INTO public.who_global_data VALUES (12641, 0, 52933, 0, 327, 54, 24);
INSERT INTO public.who_global_data VALUES (12642, 2, 1072, 0, 5, 54, 162);
INSERT INTO public.who_global_data VALUES (12643, 692, 124534, 85, 3625, 54, 100);
INSERT INTO public.who_global_data VALUES (12644, 0, 19, 0, 0, 54, 47);
INSERT INTO public.who_global_data VALUES (12645, 26, 69, 0, 0, 54, 29);
INSERT INTO public.who_global_data VALUES (12646, 0, 8451, 0, 152, 54, 40);
INSERT INTO public.who_global_data VALUES (12647, 16, 6969, 1, 118, 54, 222);
INSERT INTO public.who_global_data VALUES (12648, 183, 129282, 18, 4423, 54, 132);
INSERT INTO public.who_global_data VALUES (12649, 0, 289, 0, 13, 54, 130);
INSERT INTO public.who_global_data VALUES (12650, 0, 13420, 0, 79, 54, 234);
INSERT INTO public.who_global_data VALUES (12651, 0, 2444, 0, 44, 54, 23);
INSERT INTO public.who_global_data VALUES (12652, 40, 5879, 0, 154, 54, 192);
INSERT INTO public.who_global_data VALUES (12653, 18, 9509, 1, 234, 54, 69);
INSERT INTO public.who_global_data VALUES (12654, 0, 26, 0, 0, 54, 187);
INSERT INTO public.who_global_data VALUES (12655, 335, 114043, 3, 2974, 54, 230);
INSERT INTO public.who_global_data VALUES (12656, 3470, 283870, 165, 7130, 54, 77);
INSERT INTO public.who_global_data VALUES (12657, 5, 5557, 0, 28, 54, 9);
INSERT INTO public.who_global_data VALUES (12658, 27071, 9884100, 336, 143355, 54, 74);
INSERT INTO public.who_global_data VALUES (12659, 6189, 617820, 166, 18819, 54, 224);
INSERT INTO public.who_global_data VALUES (12660, 7451, 1108269, 247, 52196, 54, 199);
INSERT INTO public.who_global_data VALUES (12661, 1012, 574634, 14, 12579, 54, 190);
INSERT INTO public.who_global_data VALUES (12662, 429, 76185, 1, 2124, 54, 12);
INSERT INTO public.who_global_data VALUES (12663, 0, 370, 0, 25, 54, 104);
INSERT INTO public.who_global_data VALUES (12664, 1296, 355940, 16, 3005, 54, 153);
INSERT INTO public.who_global_data VALUES (12665, 17937, 1843712, 484, 64520, 54, 91);
INSERT INTO public.who_global_data VALUES (12666, 102, 11710, 2, 273, 54, 215);
INSERT INTO public.who_global_data VALUES (12667, 2366, 179653, 23, 2585, 54, 84);
INSERT INTO public.who_global_data VALUES (12668, 51, 1688, 0, 32, 54, 231);
INSERT INTO public.who_global_data VALUES (12669, 2339, 259614, 30, 3365, 54, 196);
INSERT INTO public.who_global_data VALUES (12670, 683, 186960, 0, 2609, 54, 105);
INSERT INTO public.who_global_data VALUES (12671, 1587, 91892, 19, 1587, 54, 122);
INSERT INTO public.who_global_data VALUES (12672, 0, 0, 0, 0, 54, 159);
INSERT INTO public.who_global_data VALUES (12673, 462, 46537, 12, 1188, 54, 75);
INSERT INTO public.who_global_data VALUES (12674, 174, 146218, 0, 911, 54, 27);
INSERT INTO public.who_global_data VALUES (12675, 318, 77674, 5, 1312, 54, 54);
INSERT INTO public.who_global_data VALUES (12676, 0, 41, 0, 0, 54, 226);
INSERT INTO public.who_global_data VALUES (12677, 629, 25675, 25, 349, 54, 79);
INSERT INTO public.who_global_data VALUES (12678, 1275, 146520, 10, 1200, 54, 56);
INSERT INTO public.who_global_data VALUES (12679, 0, 2150, 0, 44, 54, 117);
INSERT INTO public.who_global_data VALUES (12680, 95, 1771, 0, 83, 54, 152);
INSERT INTO public.who_global_data VALUES (12681, 899, 90779, 21, 1299, 54, 16);
INSERT INTO public.who_global_data VALUES (12682, 31, 1606, 1, 21, 54, 10);
INSERT INTO public.who_global_data VALUES (12683, 1920, 95016, 28, 1069, 54, 201);
INSERT INTO public.who_global_data VALUES (12684, 446, 41718, 6, 402, 54, 174);
INSERT INTO public.who_global_data VALUES (12685, 0, 17587, 0, 259, 54, 119);
INSERT INTO public.who_global_data VALUES (12686, 0, 6066, 1, 187, 54, 168);
INSERT INTO public.who_global_data VALUES (12687, 1229, 83475, 4, 415, 54, 99);
INSERT INTO public.who_global_data VALUES (12688, 20, 13368, 0, 48, 54, 171);
INSERT INTO public.who_global_data VALUES (12689, 93, 5814, 3, 194, 54, 87);
INSERT INTO public.who_global_data VALUES (12690, 52, 11153, 3, 169, 54, 123);
INSERT INTO public.who_global_data VALUES (12691, 0, 4, 0, 0, 54, 151);
INSERT INTO public.who_global_data VALUES (12692, 0, 5553, 0, 41, 54, 213);
INSERT INTO public.who_global_data VALUES (12693, 1292, 10971, 31, 225, 54, 118);
INSERT INTO public.who_global_data VALUES (12694, 0, 514, 0, 10, 54, 134);
INSERT INTO public.who_global_data VALUES (12695, 0, 5551, 0, 52, 54, 65);
INSERT INTO public.who_global_data VALUES (12696, 12057, 1241436, 685, 113704, 54, 102);
INSERT INTO public.who_global_data VALUES (12697, 0, 0, 0, 0, 54, 223);
INSERT INTO public.who_global_data VALUES (12698, 0, 671, 0, 3, 54, 4);
INSERT INTO public.who_global_data VALUES (12699, 1, 907, 0, 0, 54, 146);
INSERT INTO public.who_global_data VALUES (12700, 432, 42137, 3, 584, 54, 31);
INSERT INTO public.who_global_data VALUES (12701, 0, 13, 0, 1, 54, 127);
INSERT INTO public.who_global_data VALUES (12702, 2012, 399609, 35, 6624, 54, 22);
INSERT INTO public.who_global_data VALUES (12703, 142, 16954, 2, 142, 54, 115);
INSERT INTO public.who_global_data VALUES (12704, 1352, 107215, 25, 2245, 54, 106);
INSERT INTO public.who_global_data VALUES (12705, 439, 16536, 0, 160, 54, 90);
INSERT INTO public.who_global_data VALUES (12706, 0, 0, 0, 0, 54, 70);
INSERT INTO public.who_global_data VALUES (12707, 830, 248423, 9, 1698, 54, 46);
INSERT INTO public.who_global_data VALUES (12708, 9881, 612341, 29, 10022, 54, 139);
INSERT INTO public.who_global_data VALUES (12709, 0, 36, 0, 0, 54, 42);
INSERT INTO public.who_global_data VALUES (12710, 0, 1740, 0, 25, 54, 80);
INSERT INTO public.who_global_data VALUES (12711, 0, 4709, 0, 162, 54, 203);
INSERT INTO public.who_global_data VALUES (12712, 222, 2078, 0, 77, 54, 136);
INSERT INTO public.who_global_data VALUES (12713, 418, 73175, 3, 1197, 54, 63);
INSERT INTO public.who_global_data VALUES (12714, 0, 0, 0, 0, 54, 17);
INSERT INTO public.who_global_data VALUES (12715, 0, 113, 0, 2, 54, 172);
INSERT INTO public.who_global_data VALUES (12716, 551, 73638, 25, 2121, 54, 109);
INSERT INTO public.who_global_data VALUES (12717, 0, 40022, 0, 387, 54, 200);
INSERT INTO public.who_global_data VALUES (12718, 1639, 124641, 17, 1079, 54, 93);
INSERT INTO public.who_global_data VALUES (12719, 571, 126240, 8, 1471, 54, 5);
INSERT INTO public.who_global_data VALUES (12720, 0, 744, 0, 13, 54, 214);
INSERT INTO public.who_global_data VALUES (12721, 3369, 438425, 72, 8796, 54, 204);
INSERT INTO public.who_global_data VALUES (12722, 0, 0, 0, 0, 54, 198);
INSERT INTO public.who_global_data VALUES (12723, 2806, 190585, 22, 3331, 54, 173);
INSERT INTO public.who_global_data VALUES (12724, 5, 725, 0, 8, 54, 229);
INSERT INTO public.who_global_data VALUES (12725, 800, 92913, 10, 1937, 54, 76);
INSERT INTO public.who_global_data VALUES (12726, 2102, 983045, 65, 36609, 54, 138);
INSERT INTO public.who_global_data VALUES (12727, 1069, 449400, 3, 8733, 54, 98);
INSERT INTO public.who_global_data VALUES (12728, 0, 0, 0, 0, 54, 103);
INSERT INTO public.who_global_data VALUES (12729, 8976, 1135676, 188, 22864, 54, 225);
INSERT INTO public.who_global_data VALUES (12730, 4044, 348744, 98, 5559, 54, 131);
INSERT INTO public.who_global_data VALUES (12731, 708, 62431, 6, 1272, 54, 235);
INSERT INTO public.who_global_data VALUES (12732, 134, 140961, 0, 240, 54, 137);
INSERT INTO public.who_global_data VALUES (12733, 718, 43478, 7, 587, 54, 81);
INSERT INTO public.who_global_data VALUES (12734, 795, 126518, 25, 2572, 54, 182);
INSERT INTO public.who_global_data VALUES (12735, 0, 8345, 0, 41, 54, 145);
INSERT INTO public.who_global_data VALUES (12736, 4435, 556335, 121, 13385, 54, 26);
INSERT INTO public.who_global_data VALUES (12737, 27328, 2681256, 450, 47391, 54, 170);
INSERT INTO public.who_global_data VALUES (12738, 131, 6659, 0, 56, 54, 191);
INSERT INTO public.who_global_data VALUES (12739, 0, 5, 0, 0, 54, 221);
INSERT INTO public.who_global_data VALUES (12740, 0, 164, 0, 0, 54, 64);
INSERT INTO public.who_global_data VALUES (12741, 0, 0, 0, 0, 54, 116);
INSERT INTO public.who_global_data VALUES (12742, 0, 27, 0, 0, 54, 128);
INSERT INTO public.who_global_data VALUES (12743, 1, 275, 0, 4, 54, 6);
INSERT INTO public.who_global_data VALUES (12744, 0, 838, 0, 12, 54, 227);
INSERT INTO public.who_global_data VALUES (12745, 0, 14, 0, 0, 54, 68);
INSERT INTO public.who_global_data VALUES (12746, 4, 98, 0, 0, 54, 184);
INSERT INTO public.who_global_data VALUES (12747, 0, 2, 0, 0, 54, 82);
INSERT INTO public.who_global_data VALUES (12748, 15, 1947, 0, 51, 54, 149);
INSERT INTO public.who_global_data VALUES (12749, 0, 1009, 0, 17, 54, 197);
INSERT INTO public.who_global_data VALUES (12750, 139, 359888, 12, 6048, 54, 78);
INSERT INTO public.who_global_data VALUES (12751, 14, 17075, 0, 349, 54, 233);
INSERT INTO public.who_global_data VALUES (12752, 4995, 266432, 56, 2331, 54, 133);
INSERT INTO public.who_global_data VALUES (12753, 0, 185, 0, 0, 54, 35);
INSERT INTO public.who_global_data VALUES (12754, 7, 2442, 0, 75, 54, 114);
INSERT INTO public.who_global_data VALUES (12755, 7, 58320, 0, 29, 54, 237);
INSERT INTO public.who_global_data VALUES (12756, 0, 18, 0, 0, 54, 55);
INSERT INTO public.who_global_data VALUES (12757, 0, 1201, 0, 26, 54, 176);
INSERT INTO public.who_global_data VALUES (12758, 505, 133489, 30, 1205, 54, 202);
INSERT INTO public.who_global_data VALUES (12759, 434, 96787, 46, 2321, 54, 155);
INSERT INTO public.who_global_data VALUES (12760, 0, 17, 0, 0, 54, 32);
INSERT INTO public.who_global_data VALUES (12761, 0, 4579, 0, 121, 54, 220);
INSERT INTO public.who_global_data VALUES (12762, 7999, 860964, 170, 23276, 54, 30);
INSERT INTO public.who_global_data VALUES (12763, 25, 3206, 0, 62, 54, 147);
INSERT INTO public.who_global_data VALUES (12764, 6653, 1809290, 149, 49242, 54, 208);
INSERT INTO public.who_global_data VALUES (12765, 655, 32790, 3, 152, 54, 45);
INSERT INTO public.who_global_data VALUES (12766, 273, 21864, 17, 1372, 54, 110);
INSERT INTO public.who_global_data VALUES (12767, 10, 5349, 0, 117, 54, 88);
INSERT INTO public.who_global_data VALUES (12768, 6538, 334972, 67, 8101, 54, 51);
INSERT INTO public.who_global_data VALUES (12769, 2086, 384234, 83, 5832, 54, 209);
INSERT INTO public.who_global_data VALUES (12770, 125, 9166, 12, 518, 54, 205);
INSERT INTO public.who_global_data VALUES (12771, 56, 12913, 0, 87, 54, 18);
INSERT INTO public.who_global_data VALUES (12772, 17, 4209, 0, 60, 54, 72);
INSERT INTO public.who_global_data VALUES (12773, 18447, 1849407, 144, 64170, 54, 44);
INSERT INTO public.who_global_data VALUES (12774, 0, 31, 0, 0, 54, 15);
INSERT INTO public.who_global_data VALUES (12775, 0, 3202, 0, 66, 54, 25);
INSERT INTO public.who_global_data VALUES (12776, 0, 0, 0, 0, 54, 179);
INSERT INTO public.who_global_data VALUES (12777, 0, 0, 0, 0, 54, 34);
INSERT INTO public.who_global_data VALUES (12778, 12, 6864, 0, 122, 54, 207);
INSERT INTO public.who_global_data VALUES (12779, 968, 111361, 58, 3894, 54, 166);
INSERT INTO public.who_global_data VALUES (12780, 26919, 1836728, 218, 16417, 54, 126);
INSERT INTO public.who_global_data VALUES (12781, 0, 0, 0, 0, 54, 97);
INSERT INTO public.who_global_data VALUES (12782, 0, 769, 0, 6, 54, 36);
INSERT INTO public.who_global_data VALUES (12783, 0, 0, 0, 0, 54, 125);
INSERT INTO public.who_global_data VALUES (12784, 461, 27532, 1, 221, 54, 124);
INSERT INTO public.who_global_data VALUES (12785, 6451, 900666, 93, 15247, 54, 185);
INSERT INTO public.who_global_data VALUES (12786, 1194, 184949, 8, 617, 54, 194);
INSERT INTO public.who_global_data VALUES (12787, 0, 509, 0, 21, 54, 144);
INSERT INTO public.who_global_data VALUES (12788, 212577, 15860675, 2277, 295406, 54, 19);
INSERT INTO public.who_global_data VALUES (12789, 0, 1791, 0, 23, 54, 217);
INSERT INTO public.who_global_data VALUES (12790, 331, 9180, 1, 91, 54, 148);
INSERT INTO public.who_global_data VALUES (12791, 283, 75094, 0, 612, 54, 86);
INSERT INTO public.who_global_data VALUES (12792, 0, 1, 0, 0, 54, 13);
INSERT INTO public.who_global_data VALUES (12793, 462, 107177, 5, 949, 54, 157);
INSERT INTO public.who_global_data VALUES (12794, 2, 1397, 0, 35, 54, 8);
INSERT INTO public.who_global_data VALUES (12795, 0, 3, 0, 0, 54, 73);
INSERT INTO public.who_global_data VALUES (12796, 0, 2087, 0, 607, 54, 101);
INSERT INTO public.who_global_data VALUES (12797, 183, 18274, 3, 367, 54, 165);
INSERT INTO public.who_global_data VALUES (12798, 165, 11246, 2, 307, 54, 14);
INSERT INTO public.who_global_data VALUES (12799, 126, 48952, 11, 1960, 55, 193);
INSERT INTO public.who_global_data VALUES (12800, 879, 47742, 12, 989, 55, 113);
INSERT INTO public.who_global_data VALUES (12801, 517, 91638, 9, 2584, 55, 143);
INSERT INTO public.who_global_data VALUES (12802, 0, 0, 0, 0, 55, 219);
INSERT INTO public.who_global_data VALUES (12803, 52, 7288, 0, 78, 55, 186);
INSERT INTO public.who_global_data VALUES (12804, 100, 16161, 1, 366, 55, 52);
INSERT INTO public.who_global_data VALUES (12805, 0, 10, 0, 0, 55, 180);
INSERT INTO public.who_global_data VALUES (12806, 0, 147, 0, 4, 55, 167);
INSERT INTO public.who_global_data VALUES (12807, 5952, 1489328, 164, 40606, 55, 154);
INSERT INTO public.who_global_data VALUES (12808, 1013, 147638, 24, 2481, 55, 94);
INSERT INTO public.who_global_data VALUES (12809, 0, 5011, 0, 46, 55, 66);
INSERT INTO public.who_global_data VALUES (12810, 13, 28025, 0, 908, 55, 58);
INSERT INTO public.who_global_data VALUES (12811, 2938, 317031, 96, 4355, 55, 163);
INSERT INTO public.who_global_data VALUES (12812, 4268, 171423, 43, 1883, 55, 37);
INSERT INTO public.who_global_data VALUES (12813, 36, 7659, 0, 163, 55, 142);
INSERT INTO public.who_global_data VALUES (12814, 145, 88964, 1, 348, 55, 83);
INSERT INTO public.who_global_data VALUES (12815, 1329, 489178, 34, 7020, 55, 228);
INSERT INTO public.who_global_data VALUES (12816, 1, 292, 0, 7, 55, 188);
INSERT INTO public.who_global_data VALUES (12817, 1975, 158334, 8, 1254, 55, 62);
INSERT INTO public.who_global_data VALUES (12818, 1595, 609315, 87, 18012, 55, 160);
INSERT INTO public.who_global_data VALUES (12819, 160, 8965, 2, 185, 55, 50);
INSERT INTO public.who_global_data VALUES (12820, 0, 3090, 0, 44, 55, 33);
INSERT INTO public.who_global_data VALUES (12821, 27, 391, 0, 9, 55, 183);
INSERT INTO public.who_global_data VALUES (12822, 1, 437, 0, 0, 55, 92);
INSERT INTO public.who_global_data VALUES (12823, 312, 146697, 5, 9013, 55, 158);
INSERT INTO public.who_global_data VALUES (12824, 0, 150, 0, 3, 55, 67);
INSERT INTO public.who_global_data VALUES (12825, 1703, 100306, 99, 3298, 55, 57);
INSERT INTO public.who_global_data VALUES (12826, 0, 12501, 0, 37, 55, 38);
INSERT INTO public.who_global_data VALUES (12827, 54428, 6836227, 672, 180437, 55, 141);
INSERT INTO public.who_global_data VALUES (12828, 0, 76, 0, 1, 55, 178);
INSERT INTO public.who_global_data VALUES (12829, 0, 152, 0, 3, 55, 108);
INSERT INTO public.who_global_data VALUES (12830, 1287, 178952, 64, 5626, 55, 39);
INSERT INTO public.who_global_data VALUES (12831, 315, 3894, 2, 71, 55, 2);
INSERT INTO public.who_global_data VALUES (12832, 1, 729, 0, 1, 55, 195);
INSERT INTO public.who_global_data VALUES (12833, 40, 11302, 0, 110, 55, 107);
INSERT INTO public.who_global_data VALUES (12834, 2, 359, 0, 0, 55, 161);
INSERT INTO public.who_global_data VALUES (12835, 0, 25143, 0, 443, 55, 212);
INSERT INTO public.who_global_data VALUES (12836, 6772, 448841, 142, 13251, 55, 181);
INSERT INTO public.who_global_data VALUES (12837, 0, 298, 0, 2, 55, 53);
INSERT INTO public.who_global_data VALUES (12838, 0, 4936, 0, 63, 55, 164);
INSERT INTO public.who_global_data VALUES (12839, 0, 1739, 0, 102, 55, 140);
INSERT INTO public.who_global_data VALUES (12840, 1807, 569781, 64, 15846, 55, 20);
INSERT INTO public.who_global_data VALUES (12841, 101, 94950, 1, 4756, 55, 112);
INSERT INTO public.who_global_data VALUES (12842, 8998, 1408909, 185, 38669, 55, 111);
INSERT INTO public.who_global_data VALUES (12843, 0, 624, 0, 7, 55, 71);
INSERT INTO public.who_global_data VALUES (12844, 0, 6049, 0, 99, 55, 218);
INSERT INTO public.who_global_data VALUES (12845, 0, 0, 0, 0, 55, 43);
INSERT INTO public.who_global_data VALUES (12846, 1132, 150947, 13, 1895, 55, 49);
INSERT INTO public.who_global_data VALUES (12847, 21, 21639, 0, 133, 55, 1);
INSERT INTO public.who_global_data VALUES (12848, 4135, 172523, 78, 2562, 55, 48);
INSERT INTO public.who_global_data VALUES (12849, 87, 9354, 1, 137, 55, 232);
INSERT INTO public.who_global_data VALUES (12850, 0, 3404, 0, 8, 55, 175);
INSERT INTO public.who_global_data VALUES (12851, 324, 14800, 2, 77, 55, 21);
INSERT INTO public.who_global_data VALUES (12852, 3657, 579079, 85, 9535, 55, 156);
INSERT INTO public.who_global_data VALUES (12853, 0, 0, 0, 0, 55, 95);
INSERT INTO public.who_global_data VALUES (12854, 172, 14341, 2, 352, 55, 177);
INSERT INTO public.who_global_data VALUES (12855, 3552, 107116, 8, 935, 55, 210);
INSERT INTO public.who_global_data VALUES (12856, 4, 5725, 0, 61, 55, 120);
INSERT INTO public.who_global_data VALUES (12857, 0, 87, 0, 0, 55, 135);
INSERT INTO public.who_global_data VALUES (12858, 1133, 153585, 1, 2360, 55, 206);
INSERT INTO public.who_global_data VALUES (12859, 759, 201524, 16, 13874, 55, 189);
INSERT INTO public.who_global_data VALUES (12860, 478, 121089, 21, 6898, 55, 129);
INSERT INTO public.who_global_data VALUES (12861, 653, 41394, 7, 1193, 55, 121);
INSERT INTO public.who_global_data VALUES (12862, 2, 5185, 0, 85, 55, 59);
INSERT INTO public.who_global_data VALUES (12863, 0, 656, 0, 0, 55, 96);
INSERT INTO public.who_global_data VALUES (12864, 757, 17713, 6, 148, 55, 41);
INSERT INTO public.who_global_data VALUES (12865, 29, 6714, 1, 127, 55, 216);
INSERT INTO public.who_global_data VALUES (12866, 0, 115360, 0, 1779, 55, 236);
INSERT INTO public.who_global_data VALUES (12867, 0, 19, 0, 0, 55, 150);
INSERT INTO public.who_global_data VALUES (12868, 5, 525, 0, 0, 55, 61);
INSERT INTO public.who_global_data VALUES (12869, 0, 44, 0, 2, 55, 7);
INSERT INTO public.who_global_data VALUES (12870, 377, 30450, 0, 453, 55, 169);
INSERT INTO public.who_global_data VALUES (12871, 13902, 2324603, 194, 57392, 55, 28);
INSERT INTO public.who_global_data VALUES (12872, 45, 11800, 0, 71, 55, 85);
INSERT INTO public.who_global_data VALUES (12873, 0, 15618, 0, 91, 55, 211);
INSERT INTO public.who_global_data VALUES (12874, 0, 9330, 0, 63, 55, 60);
INSERT INTO public.who_global_data VALUES (12875, 2, 3782, 0, 123, 55, 3);
INSERT INTO public.who_global_data VALUES (12876, 2720, 189726, 46, 1790, 55, 11);
INSERT INTO public.who_global_data VALUES (12877, 20200, 1320716, 321, 21787, 55, 89);
INSERT INTO public.who_global_data VALUES (12878, 195, 52933, 1, 327, 55, 24);
INSERT INTO public.who_global_data VALUES (12879, 1, 1070, 0, 5, 55, 162);
INSERT INTO public.who_global_data VALUES (12880, 1194, 123842, 68, 3540, 55, 100);
INSERT INTO public.who_global_data VALUES (12881, 0, 19, 0, 0, 55, 47);
INSERT INTO public.who_global_data VALUES (12882, 0, 43, 0, 0, 55, 29);
INSERT INTO public.who_global_data VALUES (12883, 0, 8451, 0, 152, 55, 40);
INSERT INTO public.who_global_data VALUES (12884, 11, 6953, 2, 117, 55, 222);
INSERT INTO public.who_global_data VALUES (12885, 558, 129099, 29, 4405, 55, 132);
INSERT INTO public.who_global_data VALUES (12886, 0, 289, 0, 13, 55, 130);
INSERT INTO public.who_global_data VALUES (12887, 22, 13420, 0, 79, 55, 234);
INSERT INTO public.who_global_data VALUES (12888, 0, 2444, 0, 44, 55, 23);
INSERT INTO public.who_global_data VALUES (12889, 28, 5839, 0, 154, 55, 192);
INSERT INTO public.who_global_data VALUES (12890, 26, 9491, 0, 233, 55, 69);
INSERT INTO public.who_global_data VALUES (12891, 0, 26, 0, 0, 55, 187);
INSERT INTO public.who_global_data VALUES (12892, 501, 113708, 3, 2971, 55, 230);
INSERT INTO public.who_global_data VALUES (12893, 4153, 280400, 181, 6965, 55, 77);
INSERT INTO public.who_global_data VALUES (12894, 13, 5552, 0, 28, 55, 9);
INSERT INTO public.who_global_data VALUES (12895, 30254, 9857029, 391, 143019, 55, 74);
INSERT INTO public.who_global_data VALUES (12896, 6388, 611631, 142, 18653, 55, 224);
INSERT INTO public.who_global_data VALUES (12897, 8201, 1100818, 221, 51949, 55, 199);
INSERT INTO public.who_global_data VALUES (12898, 1022, 573622, 16, 12565, 55, 190);
INSERT INTO public.who_global_data VALUES (12899, 249, 75756, 3, 2123, 55, 12);
INSERT INTO public.who_global_data VALUES (12900, 0, 370, 0, 25, 55, 104);
INSERT INTO public.who_global_data VALUES (12901, 1835, 354644, 12, 2989, 55, 153);
INSERT INTO public.who_global_data VALUES (12902, 19902, 1825775, 649, 64036, 55, 91);
INSERT INTO public.who_global_data VALUES (12903, 99, 11608, 1, 271, 55, 215);
INSERT INTO public.who_global_data VALUES (12904, 2988, 177287, 28, 2562, 55, 84);
INSERT INTO public.who_global_data VALUES (12905, 82, 1637, 0, 32, 55, 231);
INSERT INTO public.who_global_data VALUES (12906, 1816, 257275, 49, 3335, 55, 196);
INSERT INTO public.who_global_data VALUES (12907, 764, 186277, 67, 2609, 55, 105);
INSERT INTO public.who_global_data VALUES (12908, 0, 90305, 0, 1568, 55, 122);
INSERT INTO public.who_global_data VALUES (12909, 0, 0, 0, 0, 55, 159);
INSERT INTO public.who_global_data VALUES (12910, 524, 46075, 12, 1176, 55, 75);
INSERT INTO public.who_global_data VALUES (12911, 255, 146044, 1, 911, 55, 27);
INSERT INTO public.who_global_data VALUES (12912, 297, 77356, 0, 1307, 55, 54);
INSERT INTO public.who_global_data VALUES (12913, 0, 41, 0, 0, 55, 226);
INSERT INTO public.who_global_data VALUES (12914, 660, 25046, 5, 324, 55, 79);
INSERT INTO public.who_global_data VALUES (12915, 1540, 145245, 8, 1190, 55, 56);
INSERT INTO public.who_global_data VALUES (12916, 0, 2150, 0, 44, 55, 117);
INSERT INTO public.who_global_data VALUES (12917, 0, 1676, 0, 83, 55, 152);
INSERT INTO public.who_global_data VALUES (12918, 0, 89880, 0, 1278, 55, 16);
INSERT INTO public.who_global_data VALUES (12919, 27, 1575, 0, 20, 55, 10);
INSERT INTO public.who_global_data VALUES (12920, 2841, 93096, 54, 1041, 55, 201);
INSERT INTO public.who_global_data VALUES (12921, 517, 41272, 4, 396, 55, 174);
INSERT INTO public.who_global_data VALUES (12922, 114, 17587, 4, 259, 55, 119);
INSERT INTO public.who_global_data VALUES (12923, 11, 6066, 0, 186, 55, 168);
INSERT INTO public.who_global_data VALUES (12924, 1937, 82246, 9, 411, 55, 99);
INSERT INTO public.who_global_data VALUES (12925, 22, 13348, 0, 48, 55, 171);
INSERT INTO public.who_global_data VALUES (12926, 72, 5721, 6, 191, 55, 87);
INSERT INTO public.who_global_data VALUES (12927, 121, 11101, 0, 166, 55, 123);
INSERT INTO public.who_global_data VALUES (12928, 0, 4, 0, 0, 55, 151);
INSERT INTO public.who_global_data VALUES (12929, 0, 5553, 0, 41, 55, 213);
INSERT INTO public.who_global_data VALUES (12930, 0, 9679, 0, 194, 55, 118);
INSERT INTO public.who_global_data VALUES (12931, 0, 514, 0, 10, 55, 134);
INSERT INTO public.who_global_data VALUES (12932, 0, 5551, 0, 52, 55, 65);
INSERT INTO public.who_global_data VALUES (12933, 12253, 1229379, 693, 113019, 55, 102);
INSERT INTO public.who_global_data VALUES (12934, 0, 0, 0, 0, 55, 223);
INSERT INTO public.who_global_data VALUES (12935, 9, 671, 0, 3, 55, 4);
INSERT INTO public.who_global_data VALUES (12936, 1, 906, 0, 0, 55, 146);
INSERT INTO public.who_global_data VALUES (12937, 352, 41705, 4, 581, 55, 31);
INSERT INTO public.who_global_data VALUES (12938, 0, 13, 0, 1, 55, 127);
INSERT INTO public.who_global_data VALUES (12939, 3033, 397597, 47, 6589, 55, 22);
INSERT INTO public.who_global_data VALUES (12940, 132, 16812, 1, 140, 55, 115);
INSERT INTO public.who_global_data VALUES (12941, 1376, 105863, 19, 2220, 55, 106);
INSERT INTO public.who_global_data VALUES (12942, 0, 16097, 0, 160, 55, 90);
INSERT INTO public.who_global_data VALUES (12943, 0, 0, 0, 0, 55, 70);
INSERT INTO public.who_global_data VALUES (12944, 899, 247593, 15, 1689, 55, 46);
INSERT INTO public.who_global_data VALUES (12945, 9124, 602460, 53, 9993, 55, 139);
INSERT INTO public.who_global_data VALUES (12946, 0, 36, 0, 0, 55, 42);
INSERT INTO public.who_global_data VALUES (12947, 4, 1740, 0, 25, 55, 80);
INSERT INTO public.who_global_data VALUES (12948, 0, 4709, 0, 162, 55, 203);
INSERT INTO public.who_global_data VALUES (12949, 0, 1856, 0, 77, 55, 136);
INSERT INTO public.who_global_data VALUES (12950, 617, 72757, 4, 1194, 55, 63);
INSERT INTO public.who_global_data VALUES (12951, 0, 0, 0, 0, 55, 17);
INSERT INTO public.who_global_data VALUES (12952, 0, 113, 0, 2, 55, 172);
INSERT INTO public.who_global_data VALUES (12953, 1043, 73087, 19, 2096, 55, 109);
INSERT INTO public.who_global_data VALUES (12954, 0, 40022, 0, 387, 55, 200);
INSERT INTO public.who_global_data VALUES (12955, 1845, 123002, 33, 1062, 55, 93);
INSERT INTO public.who_global_data VALUES (12956, 0, 125669, 0, 1463, 55, 5);
INSERT INTO public.who_global_data VALUES (12957, 0, 744, 0, 13, 55, 214);
INSERT INTO public.who_global_data VALUES (12958, 2729, 435056, 71, 8724, 55, 204);
INSERT INTO public.who_global_data VALUES (12959, 0, 0, 0, 0, 55, 198);
INSERT INTO public.who_global_data VALUES (12960, 2355, 187779, 22, 3309, 55, 173);
INSERT INTO public.who_global_data VALUES (12961, 0, 720, 0, 8, 55, 229);
INSERT INTO public.who_global_data VALUES (12962, 1155, 92113, 13, 1927, 55, 76);
INSERT INTO public.who_global_data VALUES (12963, 1832, 980943, 45, 36544, 55, 138);
INSERT INTO public.who_global_data VALUES (12964, 1292, 448331, 21, 8730, 55, 98);
INSERT INTO public.who_global_data VALUES (12965, 0, 0, 0, 0, 55, 103);
INSERT INTO public.who_global_data VALUES (12966, 11499, 1126700, 502, 22676, 55, 225);
INSERT INTO public.who_global_data VALUES (12967, 4413, 344700, 88, 5461, 55, 131);
INSERT INTO public.who_global_data VALUES (12968, 721, 61723, 17, 1266, 55, 235);
INSERT INTO public.who_global_data VALUES (12969, 147, 140827, 0, 240, 55, 137);
INSERT INTO public.who_global_data VALUES (12970, 1030, 42760, 2, 580, 55, 81);
INSERT INTO public.who_global_data VALUES (12971, 1459, 125723, 26, 2547, 55, 182);
INSERT INTO public.who_global_data VALUES (12972, 0, 8345, 0, 41, 55, 145);
INSERT INTO public.who_global_data VALUES (12973, 6333, 551900, 148, 13264, 55, 26);
INSERT INTO public.who_global_data VALUES (12974, 28080, 2653928, 488, 46941, 55, 170);
INSERT INTO public.who_global_data VALUES (12975, 100, 6528, 2, 56, 55, 191);
INSERT INTO public.who_global_data VALUES (12976, 0, 5, 0, 0, 55, 221);
INSERT INTO public.who_global_data VALUES (12977, 0, 164, 0, 0, 55, 64);
INSERT INTO public.who_global_data VALUES (12978, 0, 0, 0, 0, 55, 116);
INSERT INTO public.who_global_data VALUES (12979, 0, 27, 0, 0, 55, 128);
INSERT INTO public.who_global_data VALUES (12980, 0, 274, 0, 4, 55, 6);
INSERT INTO public.who_global_data VALUES (12981, 0, 838, 0, 12, 55, 227);
INSERT INTO public.who_global_data VALUES (12982, 0, 14, 0, 0, 55, 68);
INSERT INTO public.who_global_data VALUES (12983, 0, 94, 0, 0, 55, 184);
INSERT INTO public.who_global_data VALUES (12984, 0, 2, 0, 0, 55, 82);
INSERT INTO public.who_global_data VALUES (12985, 24, 1932, 1, 51, 55, 149);
INSERT INTO public.who_global_data VALUES (12986, 0, 1009, 0, 17, 55, 197);
INSERT INTO public.who_global_data VALUES (12987, 166, 359749, 13, 6036, 55, 78);
INSERT INTO public.who_global_data VALUES (12988, 168, 17061, 4, 349, 55, 233);
INSERT INTO public.who_global_data VALUES (12989, 5679, 261437, 48, 2275, 55, 133);
INSERT INTO public.who_global_data VALUES (12990, 0, 185, 0, 0, 55, 35);
INSERT INTO public.who_global_data VALUES (12991, 0, 2435, 0, 75, 55, 114);
INSERT INTO public.who_global_data VALUES (12992, 8, 58313, 0, 29, 55, 237);
INSERT INTO public.who_global_data VALUES (12993, 0, 18, 0, 0, 55, 55);
INSERT INTO public.who_global_data VALUES (12994, 0, 1201, 0, 26, 55, 176);
INSERT INTO public.who_global_data VALUES (12995, 2190, 132984, 27, 1175, 55, 202);
INSERT INTO public.who_global_data VALUES (12996, 834, 96353, 39, 2275, 55, 155);
INSERT INTO public.who_global_data VALUES (12997, 0, 17, 0, 0, 55, 32);
INSERT INTO public.who_global_data VALUES (12998, 0, 4579, 0, 121, 55, 220);
INSERT INTO public.who_global_data VALUES (12999, 7882, 852965, 154, 23106, 55, 30);
INSERT INTO public.who_global_data VALUES (13000, 0, 3181, 0, 62, 55, 147);
INSERT INTO public.who_global_data VALUES (13001, 11536, 1802637, 176, 49093, 55, 208);
INSERT INTO public.who_global_data VALUES (13002, 1522, 32135, 3, 149, 55, 45);
INSERT INTO public.who_global_data VALUES (13003, 205, 21591, 8, 1355, 55, 110);
INSERT INTO public.who_global_data VALUES (13004, 2, 5339, 0, 117, 55, 88);
INSERT INTO public.who_global_data VALUES (13005, 7718, 328434, 88, 8034, 55, 51);
INSERT INTO public.who_global_data VALUES (13006, 2864, 382148, 84, 5749, 55, 209);
INSERT INTO public.who_global_data VALUES (13007, 130, 9041, 15, 506, 55, 205);
INSERT INTO public.who_global_data VALUES (13008, 59, 12857, 0, 87, 55, 18);
INSERT INTO public.who_global_data VALUES (13009, 12, 4192, 0, 60, 55, 72);
INSERT INTO public.who_global_data VALUES (13010, 21501, 1830960, 520, 64026, 55, 44);
INSERT INTO public.who_global_data VALUES (13011, 0, 31, 0, 0, 55, 15);
INSERT INTO public.who_global_data VALUES (13012, 70, 3202, 1, 66, 55, 25);
INSERT INTO public.who_global_data VALUES (13013, 0, 0, 0, 0, 55, 179);
INSERT INTO public.who_global_data VALUES (13014, 0, 0, 0, 0, 55, 34);
INSERT INTO public.who_global_data VALUES (13015, 19, 6852, 0, 122, 55, 207);
INSERT INTO public.who_global_data VALUES (13016, 1289, 110393, 35, 3836, 55, 166);
INSERT INTO public.who_global_data VALUES (13017, 29136, 1809809, 222, 16199, 55, 126);
INSERT INTO public.who_global_data VALUES (13018, 0, 0, 0, 0, 55, 97);
INSERT INTO public.who_global_data VALUES (13019, 1, 769, 0, 6, 55, 36);
INSERT INTO public.who_global_data VALUES (13020, 0, 0, 0, 0, 55, 125);
INSERT INTO public.who_global_data VALUES (13021, 702, 27071, 0, 220, 55, 124);
INSERT INTO public.who_global_data VALUES (13022, 9176, 894215, 156, 15154, 55, 185);
INSERT INTO public.who_global_data VALUES (13023, 1154, 183755, 2, 609, 55, 194);
INSERT INTO public.who_global_data VALUES (13024, 0, 509, 0, 21, 55, 144);
INSERT INTO public.who_global_data VALUES (13025, 243209, 15648098, 2996, 293129, 55, 19);
INSERT INTO public.who_global_data VALUES (13026, 58, 1791, 0, 23, 55, 217);
INSERT INTO public.who_global_data VALUES (13027, 362, 8849, 0, 90, 55, 148);
INSERT INTO public.who_global_data VALUES (13028, 0, 74811, 0, 612, 55, 86);
INSERT INTO public.who_global_data VALUES (13029, 0, 1, 0, 0, 55, 13);
INSERT INTO public.who_global_data VALUES (13030, 435, 106715, 6, 944, 55, 157);
INSERT INTO public.who_global_data VALUES (13031, 4, 1395, 0, 35, 55, 8);
INSERT INTO public.who_global_data VALUES (13032, 0, 3, 0, 0, 55, 73);
INSERT INTO public.who_global_data VALUES (13033, 1, 2087, 0, 607, 55, 101);
INSERT INTO public.who_global_data VALUES (13034, 0, 18091, 0, 364, 55, 165);
INSERT INTO public.who_global_data VALUES (13035, 0, 11081, 0, 305, 55, 14);
INSERT INTO public.who_global_data VALUES (13036, 73, 48826, 10, 1949, 56, 193);
INSERT INTO public.who_global_data VALUES (13037, 802, 46863, 12, 977, 56, 113);
INSERT INTO public.who_global_data VALUES (13038, 542, 91121, 11, 2575, 56, 143);
INSERT INTO public.who_global_data VALUES (13039, 0, 0, 0, 0, 56, 219);
INSERT INTO public.who_global_data VALUES (13040, 46, 7236, 0, 78, 56, 186);
INSERT INTO public.who_global_data VALUES (13041, 136, 16061, 3, 365, 56, 52);
INSERT INTO public.who_global_data VALUES (13042, 0, 10, 0, 0, 56, 180);
INSERT INTO public.who_global_data VALUES (13043, 1, 147, 0, 4, 56, 167);
INSERT INTO public.who_global_data VALUES (13044, 8154, 1483376, 220, 40442, 56, 154);
INSERT INTO public.who_global_data VALUES (13045, 995, 146625, 17, 2457, 56, 94);
INSERT INTO public.who_global_data VALUES (13046, 15, 5011, 0, 46, 56, 66);
INSERT INTO public.who_global_data VALUES (13047, 12, 28012, 0, 908, 56, 58);
INSERT INTO public.who_global_data VALUES (13048, 3026, 314093, 101, 4259, 56, 163);
INSERT INTO public.who_global_data VALUES (13049, 4381, 167155, 47, 1840, 56, 37);
INSERT INTO public.who_global_data VALUES (13050, 0, 7623, 0, 163, 56, 142);
INSERT INTO public.who_global_data VALUES (13051, 188, 88819, 0, 347, 56, 83);
INSERT INTO public.who_global_data VALUES (13052, 1884, 487849, 19, 6986, 56, 228);
INSERT INTO public.who_global_data VALUES (13053, 1, 291, 0, 7, 56, 188);
INSERT INTO public.who_global_data VALUES (13054, 1967, 156359, 8, 1246, 56, 62);
INSERT INTO public.who_global_data VALUES (13055, 2918, 607720, 114, 17925, 56, 160);
INSERT INTO public.who_global_data VALUES (13056, 286, 8805, 0, 183, 56, 50);
INSERT INTO public.who_global_data VALUES (13057, 0, 3090, 0, 44, 56, 33);
INSERT INTO public.who_global_data VALUES (13058, 0, 364, 0, 9, 56, 183);
INSERT INTO public.who_global_data VALUES (13059, 2, 436, 0, 0, 56, 92);
INSERT INTO public.who_global_data VALUES (13060, 325, 146385, 4, 9008, 56, 158);
INSERT INTO public.who_global_data VALUES (13061, 1, 150, 0, 3, 56, 67);
INSERT INTO public.who_global_data VALUES (13062, 0, 98603, 0, 3199, 56, 57);
INSERT INTO public.who_global_data VALUES (13063, 443, 12501, 3, 37, 56, 38);
INSERT INTO public.who_global_data VALUES (13064, 53347, 6781799, 770, 179765, 56, 141);
INSERT INTO public.who_global_data VALUES (13065, 1, 76, 0, 1, 56, 178);
INSERT INTO public.who_global_data VALUES (13066, 0, 152, 0, 3, 56, 108);
INSERT INTO public.who_global_data VALUES (13067, 3097, 177665, 157, 5562, 56, 39);
INSERT INTO public.who_global_data VALUES (13068, 0, 3579, 0, 69, 56, 2);
INSERT INTO public.who_global_data VALUES (13069, 5, 728, 0, 1, 56, 195);
INSERT INTO public.who_global_data VALUES (13070, 636, 11262, 5, 110, 56, 107);
INSERT INTO public.who_global_data VALUES (13071, 0, 357, 0, 0, 56, 161);
INSERT INTO public.who_global_data VALUES (13072, 0, 25143, 0, 443, 56, 212);
INSERT INTO public.who_global_data VALUES (13073, 6739, 442069, 126, 13109, 56, 181);
INSERT INTO public.who_global_data VALUES (13074, 6, 298, 0, 2, 56, 53);
INSERT INTO public.who_global_data VALUES (13075, 0, 4936, 0, 63, 56, 164);
INSERT INTO public.who_global_data VALUES (13076, 0, 1739, 0, 102, 56, 140);
INSERT INTO public.who_global_data VALUES (13077, 1534, 567974, 8, 15782, 56, 20);
INSERT INTO public.who_global_data VALUES (13078, 100, 94849, 0, 4755, 56, 112);
INSERT INTO public.who_global_data VALUES (13079, 7778, 1399911, 176, 38484, 56, 111);
INSERT INTO public.who_global_data VALUES (13080, 8, 624, 0, 7, 56, 71);
INSERT INTO public.who_global_data VALUES (13081, 0, 6049, 0, 99, 56, 218);
INSERT INTO public.who_global_data VALUES (13082, 0, 0, 0, 0, 56, 43);
INSERT INTO public.who_global_data VALUES (13083, 1127, 149815, 18, 1882, 56, 49);
INSERT INTO public.who_global_data VALUES (13084, 28, 21618, 0, 133, 56, 1);
INSERT INTO public.who_global_data VALUES (13085, 4396, 168388, 64, 2484, 56, 48);
INSERT INTO public.who_global_data VALUES (13086, 86, 9267, 0, 136, 56, 232);
INSERT INTO public.who_global_data VALUES (13087, 79, 3404, 0, 8, 56, 175);
INSERT INTO public.who_global_data VALUES (13088, 424, 14476, 3, 75, 56, 21);
INSERT INTO public.who_global_data VALUES (13089, 6217, 575422, 109, 9450, 56, 156);
INSERT INTO public.who_global_data VALUES (13090, 0, 0, 0, 0, 56, 95);
INSERT INTO public.who_global_data VALUES (13091, 175, 14169, 0, 350, 56, 177);
INSERT INTO public.who_global_data VALUES (13092, 3075, 103564, 9, 927, 56, 210);
INSERT INTO public.who_global_data VALUES (13093, 4, 5721, 0, 61, 56, 120);
INSERT INTO public.who_global_data VALUES (13094, 0, 87, 0, 0, 56, 135);
INSERT INTO public.who_global_data VALUES (13095, 731, 152452, 1, 2359, 56, 206);
INSERT INTO public.who_global_data VALUES (13096, 386, 200765, 8, 13858, 56, 189);
INSERT INTO public.who_global_data VALUES (13097, 464, 120611, 23, 6877, 56, 129);
INSERT INTO public.who_global_data VALUES (13098, 0, 40741, 6, 1186, 56, 121);
INSERT INTO public.who_global_data VALUES (13099, 0, 5183, 0, 85, 56, 59);
INSERT INTO public.who_global_data VALUES (13100, 0, 656, 0, 0, 56, 96);
INSERT INTO public.who_global_data VALUES (13101, 358, 16956, 1, 142, 56, 41);
INSERT INTO public.who_global_data VALUES (13102, 52, 6685, 0, 126, 56, 216);
INSERT INTO public.who_global_data VALUES (13103, 0, 115360, 0, 1779, 56, 236);
INSERT INTO public.who_global_data VALUES (13104, 0, 19, 0, 0, 56, 150);
INSERT INTO public.who_global_data VALUES (13105, 1, 520, 0, 0, 56, 61);
INSERT INTO public.who_global_data VALUES (13106, 0, 44, 0, 2, 56, 7);
INSERT INTO public.who_global_data VALUES (13107, 501, 30073, 11, 453, 56, 169);
INSERT INTO public.who_global_data VALUES (13108, 13276, 2310701, 626, 57198, 56, 28);
INSERT INTO public.who_global_data VALUES (13109, 78, 11755, 0, 71, 56, 85);
INSERT INTO public.who_global_data VALUES (13110, 83, 15618, 0, 91, 56, 211);
INSERT INTO public.who_global_data VALUES (13111, 30, 9330, 1, 63, 56, 60);
INSERT INTO public.who_global_data VALUES (13112, 1, 3780, 0, 123, 56, 3);
INSERT INTO public.who_global_data VALUES (13113, 3907, 187006, 50, 1744, 56, 11);
INSERT INTO public.who_global_data VALUES (13114, 28438, 1300516, 496, 21466, 56, 89);
INSERT INTO public.who_global_data VALUES (13115, 0, 52738, 0, 326, 56, 24);
INSERT INTO public.who_global_data VALUES (13116, 4, 1069, 0, 5, 56, 162);
INSERT INTO public.who_global_data VALUES (13117, 1395, 122648, 102, 3472, 56, 100);
INSERT INTO public.who_global_data VALUES (13118, 0, 19, 0, 0, 56, 47);
INSERT INTO public.who_global_data VALUES (13119, 0, 43, 0, 0, 56, 29);
INSERT INTO public.who_global_data VALUES (13120, 0, 8451, 0, 152, 56, 40);
INSERT INTO public.who_global_data VALUES (13121, 27, 6942, 0, 115, 56, 222);
INSERT INTO public.who_global_data VALUES (13122, 755, 128541, 31, 4376, 56, 132);
INSERT INTO public.who_global_data VALUES (13123, 0, 289, 0, 13, 56, 130);
INSERT INTO public.who_global_data VALUES (13124, 30, 13398, 0, 79, 56, 234);
INSERT INTO public.who_global_data VALUES (13125, 0, 2444, 0, 44, 56, 23);
INSERT INTO public.who_global_data VALUES (13126, 79, 5811, 0, 154, 56, 192);
INSERT INTO public.who_global_data VALUES (13127, 31, 9465, 0, 233, 56, 69);
INSERT INTO public.who_global_data VALUES (13128, 0, 26, 0, 0, 56, 187);
INSERT INTO public.who_global_data VALUES (13129, 415, 113207, 7, 2968, 56, 230);
INSERT INTO public.who_global_data VALUES (13130, 5047, 276247, 162, 6784, 56, 77);
INSERT INTO public.who_global_data VALUES (13131, 15, 5539, 0, 28, 56, 9);
INSERT INTO public.who_global_data VALUES (13132, 30006, 9826775, 442, 142628, 56, 74);
INSERT INTO public.who_global_data VALUES (13133, 6310, 605243, 175, 18511, 56, 224);
INSERT INTO public.who_global_data VALUES (13134, 9594, 1092617, 232, 51728, 56, 199);
INSERT INTO public.who_global_data VALUES (13135, 1347, 572600, 23, 12549, 56, 190);
INSERT INTO public.who_global_data VALUES (13136, 304, 75507, 3, 2120, 56, 12);
INSERT INTO public.who_global_data VALUES (13137, 0, 370, 0, 25, 56, 104);
INSERT INTO public.who_global_data VALUES (13138, 2005, 352809, 12, 2977, 56, 153);
INSERT INTO public.who_global_data VALUES (13139, 18726, 1805873, 761, 63387, 56, 91);
INSERT INTO public.who_global_data VALUES (13140, 66, 11509, 0, 270, 56, 215);
INSERT INTO public.who_global_data VALUES (13141, 2757, 174299, 32, 2534, 56, 84);
INSERT INTO public.who_global_data VALUES (13142, 58, 1555, 0, 32, 56, 231);
INSERT INTO public.who_global_data VALUES (13143, 2338, 255459, 36, 3286, 56, 196);
INSERT INTO public.who_global_data VALUES (13144, 956, 185513, 0, 2542, 56, 105);
INSERT INTO public.who_global_data VALUES (13145, 0, 90305, 0, 1568, 56, 122);
INSERT INTO public.who_global_data VALUES (13146, 0, 0, 0, 0, 56, 159);
INSERT INTO public.who_global_data VALUES (13147, 590, 45551, 13, 1164, 56, 75);
INSERT INTO public.who_global_data VALUES (13148, 294, 145789, 0, 910, 56, 27);
INSERT INTO public.who_global_data VALUES (13149, 341, 77059, 0, 1307, 56, 54);
INSERT INTO public.who_global_data VALUES (13150, 0, 41, 0, 0, 56, 226);
INSERT INTO public.who_global_data VALUES (13151, 680, 24386, 15, 319, 56, 79);
INSERT INTO public.who_global_data VALUES (13152, 1518, 143705, 12, 1182, 56, 56);
INSERT INTO public.who_global_data VALUES (13153, 0, 2150, 0, 44, 56, 117);
INSERT INTO public.who_global_data VALUES (13154, 0, 1676, 0, 83, 56, 152);
INSERT INTO public.who_global_data VALUES (13155, 697, 89880, 5, 1278, 56, 16);
INSERT INTO public.who_global_data VALUES (13156, 30, 1548, 0, 20, 56, 10);
INSERT INTO public.who_global_data VALUES (13157, 3302, 90255, 48, 987, 56, 201);
INSERT INTO public.who_global_data VALUES (13158, 718, 40755, 8, 392, 56, 174);
INSERT INTO public.who_global_data VALUES (13159, 0, 17473, 0, 255, 56, 119);
INSERT INTO public.who_global_data VALUES (13160, 2, 6055, 0, 186, 56, 168);
INSERT INTO public.who_global_data VALUES (13161, 1810, 80309, 6, 402, 56, 99);
INSERT INTO public.who_global_data VALUES (13162, 18, 13326, 1, 48, 56, 171);
INSERT INTO public.who_global_data VALUES (13163, 73, 5649, 1, 185, 56, 87);
INSERT INTO public.who_global_data VALUES (13164, 96, 10980, 2, 166, 56, 123);
INSERT INTO public.who_global_data VALUES (13165, 0, 4, 0, 0, 56, 151);
INSERT INTO public.who_global_data VALUES (13166, 0, 5553, 0, 41, 56, 213);
INSERT INTO public.who_global_data VALUES (13167, 0, 9679, 0, 194, 56, 118);
INSERT INTO public.who_global_data VALUES (13168, 0, 514, 0, 10, 56, 134);
INSERT INTO public.who_global_data VALUES (13169, 52, 5551, 1, 52, 56, 65);
INSERT INTO public.who_global_data VALUES (13170, 11897, 1217126, 671, 112326, 56, 102);
INSERT INTO public.who_global_data VALUES (13171, 0, 0, 0, 0, 56, 223);
INSERT INTO public.who_global_data VALUES (13172, 2, 662, 0, 3, 56, 4);
INSERT INTO public.who_global_data VALUES (13173, 7, 905, 0, 0, 56, 146);
INSERT INTO public.who_global_data VALUES (13174, 465, 41353, 9, 577, 56, 31);
INSERT INTO public.who_global_data VALUES (13175, 0, 13, 0, 1, 56, 127);
INSERT INTO public.who_global_data VALUES (13176, 3035, 394564, 50, 6542, 56, 22);
INSERT INTO public.who_global_data VALUES (13177, 159, 16680, 0, 139, 56, 115);
INSERT INTO public.who_global_data VALUES (13178, 1321, 104487, 27, 2201, 56, 106);
INSERT INTO public.who_global_data VALUES (13179, 324, 16097, 2, 160, 56, 90);
INSERT INTO public.who_global_data VALUES (13180, 0, 0, 0, 0, 56, 70);
INSERT INTO public.who_global_data VALUES (13181, 1044, 246694, 11, 1674, 56, 46);
INSERT INTO public.who_global_data VALUES (13182, 8839, 593336, 64, 9940, 56, 139);
INSERT INTO public.who_global_data VALUES (13183, 0, 36, 0, 0, 56, 42);
INSERT INTO public.who_global_data VALUES (13184, 0, 1736, 0, 25, 56, 80);
INSERT INTO public.who_global_data VALUES (13185, 0, 4709, 0, 162, 56, 203);
INSERT INTO public.who_global_data VALUES (13186, 0, 1856, 0, 77, 56, 136);
INSERT INTO public.who_global_data VALUES (13187, 796, 72140, 0, 1190, 56, 63);
INSERT INTO public.who_global_data VALUES (13188, 0, 0, 0, 0, 56, 17);
INSERT INTO public.who_global_data VALUES (13189, 0, 113, 0, 2, 56, 172);
INSERT INTO public.who_global_data VALUES (13190, 1161, 72044, 26, 2077, 56, 109);
INSERT INTO public.who_global_data VALUES (13191, 498, 40022, 5, 387, 56, 200);
INSERT INTO public.who_global_data VALUES (13192, 1743, 121157, 21, 1029, 56, 93);
INSERT INTO public.who_global_data VALUES (13193, 0, 125669, 0, 1463, 56, 5);
INSERT INTO public.who_global_data VALUES (13194, 0, 744, 0, 13, 56, 214);
INSERT INTO public.who_global_data VALUES (13195, 3047, 432327, 50, 8653, 56, 204);
INSERT INTO public.who_global_data VALUES (13196, 0, 0, 0, 0, 56, 198);
INSERT INTO public.who_global_data VALUES (13197, 2447, 185424, 23, 3287, 56, 173);
INSERT INTO public.who_global_data VALUES (13198, 36, 720, 1, 8, 56, 229);
INSERT INTO public.who_global_data VALUES (13199, 812, 90958, 13, 1914, 56, 76);
INSERT INTO public.who_global_data VALUES (13200, 1799, 979111, 44, 36499, 56, 138);
INSERT INTO public.who_global_data VALUES (13201, 1499, 447039, 8, 8709, 56, 98);
INSERT INTO public.who_global_data VALUES (13202, 0, 0, 0, 0, 56, 103);
INSERT INTO public.who_global_data VALUES (13203, 13105, 1115201, 544, 22174, 56, 225);
INSERT INTO public.who_global_data VALUES (13204, 5080, 340287, 95, 5373, 56, 131);
INSERT INTO public.who_global_data VALUES (13205, 1544, 61002, 11, 1249, 56, 235);
INSERT INTO public.who_global_data VALUES (13206, 164, 140680, 0, 240, 56, 137);
INSERT INTO public.who_global_data VALUES (13207, 950, 41730, 6, 578, 56, 81);
INSERT INTO public.who_global_data VALUES (13208, 1579, 124264, 21, 2521, 56, 182);
INSERT INTO public.who_global_data VALUES (13209, 0, 8345, 0, 41, 56, 145);
INSERT INTO public.who_global_data VALUES (13210, 6460, 545567, 168, 13116, 56, 26);
INSERT INTO public.who_global_data VALUES (13211, 28137, 2625848, 560, 46453, 56, 170);
INSERT INTO public.who_global_data VALUES (13212, 79, 6428, 1, 54, 56, 191);
INSERT INTO public.who_global_data VALUES (13213, 0, 5, 0, 0, 56, 221);
INSERT INTO public.who_global_data VALUES (13214, 0, 164, 0, 0, 56, 64);
INSERT INTO public.who_global_data VALUES (13215, 0, 0, 0, 0, 56, 116);
INSERT INTO public.who_global_data VALUES (13216, 1, 27, 0, 0, 56, 128);
INSERT INTO public.who_global_data VALUES (13217, 0, 274, 0, 4, 56, 6);
INSERT INTO public.who_global_data VALUES (13218, 0, 838, 0, 12, 56, 227);
INSERT INTO public.who_global_data VALUES (13219, 0, 14, 0, 0, 56, 68);
INSERT INTO public.who_global_data VALUES (13220, 3, 94, 0, 0, 56, 184);
INSERT INTO public.who_global_data VALUES (13221, 0, 2, 0, 0, 56, 82);
INSERT INTO public.who_global_data VALUES (13222, 40, 1908, 1, 50, 56, 149);
INSERT INTO public.who_global_data VALUES (13223, 0, 1009, 0, 17, 56, 197);
INSERT INTO public.who_global_data VALUES (13224, 168, 359583, 11, 6023, 56, 78);
INSERT INTO public.who_global_data VALUES (13225, 127, 16893, 2, 345, 56, 233);
INSERT INTO public.who_global_data VALUES (13226, 6534, 255758, 55, 2227, 56, 133);
INSERT INTO public.who_global_data VALUES (13227, 3, 185, 0, 0, 56, 35);
INSERT INTO public.who_global_data VALUES (13228, 0, 2435, 0, 75, 56, 114);
INSERT INTO public.who_global_data VALUES (13229, 8, 58305, 0, 29, 56, 237);
INSERT INTO public.who_global_data VALUES (13230, 2, 18, 0, 0, 56, 55);
INSERT INTO public.who_global_data VALUES (13231, 16, 1201, 0, 26, 56, 176);
INSERT INTO public.who_global_data VALUES (13232, 3707, 130794, 26, 1148, 56, 202);
INSERT INTO public.who_global_data VALUES (13233, 1750, 95519, 53, 2236, 56, 155);
INSERT INTO public.who_global_data VALUES (13234, 0, 17, 0, 0, 56, 32);
INSERT INTO public.who_global_data VALUES (13235, 0, 4579, 0, 121, 56, 220);
INSERT INTO public.who_global_data VALUES (13236, 8319, 845083, 205, 22952, 56, 30);
INSERT INTO public.who_global_data VALUES (13237, 0, 3181, 0, 62, 56, 147);
INSERT INTO public.who_global_data VALUES (13238, 10968, 1791101, 158, 48917, 56, 208);
INSERT INTO public.who_global_data VALUES (13239, 0, 30613, 0, 146, 56, 45);
INSERT INTO public.who_global_data VALUES (13240, 239, 21386, 3, 1347, 56, 110);
INSERT INTO public.who_global_data VALUES (13241, 4, 5337, 0, 117, 56, 88);
INSERT INTO public.who_global_data VALUES (13242, 6693, 320716, 86, 7946, 56, 51);
INSERT INTO public.who_global_data VALUES (13243, 4679, 379284, 87, 5665, 56, 209);
INSERT INTO public.who_global_data VALUES (13244, 124, 8911, 15, 491, 56, 205);
INSERT INTO public.who_global_data VALUES (13245, 76, 12798, 0, 87, 56, 18);
INSERT INTO public.who_global_data VALUES (13246, 11, 4180, 0, 60, 56, 72);
INSERT INTO public.who_global_data VALUES (13247, 21672, 1809459, 424, 63506, 56, 44);
INSERT INTO public.who_global_data VALUES (13248, 0, 31, 0, 0, 56, 15);
INSERT INTO public.who_global_data VALUES (13249, 0, 3132, 0, 65, 56, 25);
INSERT INTO public.who_global_data VALUES (13250, 0, 0, 0, 0, 56, 179);
INSERT INTO public.who_global_data VALUES (13251, 0, 0, 0, 0, 56, 34);
INSERT INTO public.who_global_data VALUES (13252, 25, 6833, 0, 122, 56, 207);
INSERT INTO public.who_global_data VALUES (13253, 1290, 109104, 43, 3801, 56, 166);
INSERT INTO public.who_global_data VALUES (13254, 32106, 1780673, 226, 15977, 56, 126);
INSERT INTO public.who_global_data VALUES (13255, 0, 0, 0, 0, 56, 97);
INSERT INTO public.who_global_data VALUES (13256, 0, 768, 0, 6, 56, 36);
INSERT INTO public.who_global_data VALUES (13257, 0, 0, 0, 0, 56, 125);
INSERT INTO public.who_global_data VALUES (13258, 639, 26369, 0, 220, 56, 124);
INSERT INTO public.who_global_data VALUES (13259, 12811, 885039, 243, 14998, 56, 185);
INSERT INTO public.who_global_data VALUES (13260, 1196, 182601, 5, 607, 56, 194);
INSERT INTO public.who_global_data VALUES (13261, 0, 509, 0, 21, 56, 144);
INSERT INTO public.who_global_data VALUES (13262, 201681, 15404889, 2749, 290133, 56, 19);
INSERT INTO public.who_global_data VALUES (13263, 0, 1733, 0, 23, 56, 217);
INSERT INTO public.who_global_data VALUES (13264, 383, 8487, 3, 90, 56, 148);
INSERT INTO public.who_global_data VALUES (13265, 147, 74811, 1, 612, 56, 86);
INSERT INTO public.who_global_data VALUES (13266, 0, 1, 0, 0, 56, 13);
INSERT INTO public.who_global_data VALUES (13267, 428, 106280, 5, 938, 56, 157);
INSERT INTO public.who_global_data VALUES (13268, 6, 1391, 0, 35, 56, 8);
INSERT INTO public.who_global_data VALUES (13269, 0, 3, 0, 0, 56, 73);
INSERT INTO public.who_global_data VALUES (13270, 1, 2086, 0, 607, 56, 101);
INSERT INTO public.who_global_data VALUES (13271, 0, 18091, 0, 364, 56, 165);
INSERT INTO public.who_global_data VALUES (13272, 0, 11081, 0, 305, 56, 14);
INSERT INTO public.who_global_data VALUES (13273, 213, 48753, 18, 1939, 57, 193);
INSERT INTO public.who_global_data VALUES (13274, 873, 46061, 14, 965, 57, 113);
INSERT INTO public.who_global_data VALUES (13275, 565, 90579, 10, 2564, 57, 143);
INSERT INTO public.who_global_data VALUES (13276, 0, 0, 0, 0, 57, 219);
INSERT INTO public.who_global_data VALUES (13277, 28, 7190, 0, 78, 57, 186);
INSERT INTO public.who_global_data VALUES (13278, 121, 15925, 4, 362, 57, 52);
INSERT INTO public.who_global_data VALUES (13279, 0, 10, 0, 0, 57, 180);
INSERT INTO public.who_global_data VALUES (13280, 0, 146, 0, 4, 57, 167);
INSERT INTO public.who_global_data VALUES (13281, 5303, 1475222, 213, 40222, 57, 154);
INSERT INTO public.who_global_data VALUES (13282, 1077, 145630, 29, 2440, 57, 94);
INSERT INTO public.who_global_data VALUES (13283, 12, 4996, 1, 46, 57, 66);
INSERT INTO public.who_global_data VALUES (13284, 7, 28000, 0, 908, 57, 58);
INSERT INTO public.who_global_data VALUES (13285, 2466, 311067, 125, 4158, 57, 163);
INSERT INTO public.who_global_data VALUES (13286, 4219, 162774, 38, 1793, 57, 37);
INSERT INTO public.who_global_data VALUES (13287, 38, 7623, 0, 163, 57, 142);
INSERT INTO public.who_global_data VALUES (13288, 137, 88631, 0, 347, 57, 83);
INSERT INTO public.who_global_data VALUES (13289, 1861, 485965, 37, 6967, 57, 228);
INSERT INTO public.who_global_data VALUES (13290, 0, 290, 0, 7, 57, 188);
INSERT INTO public.who_global_data VALUES (13291, 1939, 154392, 8, 1238, 57, 62);
INSERT INTO public.who_global_data VALUES (13292, 2675, 604802, 94, 17811, 57, 160);
INSERT INTO public.who_global_data VALUES (13293, 506, 8519, 4, 183, 57, 50);
INSERT INTO public.who_global_data VALUES (13294, 0, 3090, 0, 44, 57, 33);
INSERT INTO public.who_global_data VALUES (13295, 24, 364, 0, 9, 57, 183);
INSERT INTO public.who_global_data VALUES (13296, 1, 434, 0, 0, 57, 92);
INSERT INTO public.who_global_data VALUES (13297, 214, 146060, 2, 9004, 57, 158);
INSERT INTO public.who_global_data VALUES (13298, 3, 149, 0, 3, 57, 67);
INSERT INTO public.who_global_data VALUES (13299, 1286, 98603, 48, 3199, 57, 57);
INSERT INTO public.who_global_data VALUES (13300, 0, 12058, 0, 34, 57, 38);
INSERT INTO public.who_global_data VALUES (13301, 53453, 6728452, 836, 178995, 57, 141);
INSERT INTO public.who_global_data VALUES (13302, 0, 75, 0, 1, 57, 178);
INSERT INTO public.who_global_data VALUES (13303, 0, 152, 0, 3, 57, 108);
INSERT INTO public.who_global_data VALUES (13304, 3075, 174568, 122, 5405, 57, 39);
INSERT INTO public.who_global_data VALUES (13305, 110, 3579, 0, 69, 57, 2);
INSERT INTO public.who_global_data VALUES (13306, 2, 723, 0, 1, 57, 195);
INSERT INTO public.who_global_data VALUES (13307, 0, 10626, 0, 105, 57, 107);
INSERT INTO public.who_global_data VALUES (13308, 1, 357, 0, 0, 57, 161);
INSERT INTO public.who_global_data VALUES (13309, 0, 25143, 0, 443, 57, 212);
INSERT INTO public.who_global_data VALUES (13310, 6295, 435330, 116, 12983, 57, 181);
INSERT INTO public.who_global_data VALUES (13311, 1, 292, 0, 2, 57, 53);
INSERT INTO public.who_global_data VALUES (13312, 4, 4936, 0, 63, 57, 164);
INSERT INTO public.who_global_data VALUES (13313, 7, 1739, 0, 102, 57, 140);
INSERT INTO public.who_global_data VALUES (13314, 1662, 566440, 84, 15774, 57, 20);
INSERT INTO public.who_global_data VALUES (13315, 131, 94749, 0, 4755, 57, 112);
INSERT INTO public.who_global_data VALUES (13316, 7523, 1392133, 150, 38308, 57, 111);
INSERT INTO public.who_global_data VALUES (13317, 0, 616, 0, 7, 57, 71);
INSERT INTO public.who_global_data VALUES (13318, 0, 6049, 0, 99, 57, 218);
INSERT INTO public.who_global_data VALUES (13319, 0, 0, 0, 0, 57, 43);
INSERT INTO public.who_global_data VALUES (13320, 1258, 148688, 18, 1864, 57, 49);
INSERT INTO public.who_global_data VALUES (13321, 43, 21590, 0, 133, 57, 1);
INSERT INTO public.who_global_data VALUES (13322, 4620, 163992, 53, 2420, 57, 48);
INSERT INTO public.who_global_data VALUES (13323, 75, 9181, 0, 136, 57, 232);
INSERT INTO public.who_global_data VALUES (13324, 79, 3325, 0, 8, 57, 175);
INSERT INTO public.who_global_data VALUES (13325, 403, 14052, 2, 72, 57, 21);
INSERT INTO public.who_global_data VALUES (13326, 5872, 569205, 115, 9341, 57, 156);
INSERT INTO public.who_global_data VALUES (13327, 0, 0, 0, 0, 57, 95);
INSERT INTO public.who_global_data VALUES (13328, 152, 13994, 0, 350, 57, 177);
INSERT INTO public.who_global_data VALUES (13329, 3132, 100489, 14, 918, 57, 210);
INSERT INTO public.who_global_data VALUES (13330, 0, 5717, 0, 61, 57, 120);
INSERT INTO public.who_global_data VALUES (13331, 2, 87, 0, 0, 57, 135);
INSERT INTO public.who_global_data VALUES (13332, 1560, 151721, 8, 2358, 57, 206);
INSERT INTO public.who_global_data VALUES (13333, 1151, 200379, 36, 13850, 57, 189);
INSERT INTO public.who_global_data VALUES (13334, 445, 120147, 22, 6854, 57, 129);
INSERT INTO public.who_global_data VALUES (13335, 0, 40741, 6, 1180, 57, 121);
INSERT INTO public.who_global_data VALUES (13336, 0, 5183, 0, 85, 57, 59);
INSERT INTO public.who_global_data VALUES (13337, 7, 656, 0, 0, 57, 96);
INSERT INTO public.who_global_data VALUES (13338, 544, 16598, 2, 141, 57, 41);
INSERT INTO public.who_global_data VALUES (13339, 21, 6633, 1, 126, 57, 216);
INSERT INTO public.who_global_data VALUES (13340, 526, 115360, 10, 1779, 57, 236);
INSERT INTO public.who_global_data VALUES (13341, 2, 19, 0, 0, 57, 150);
INSERT INTO public.who_global_data VALUES (13342, 0, 519, 0, 0, 57, 61);
INSERT INTO public.who_global_data VALUES (13343, 0, 44, 0, 2, 57, 7);
INSERT INTO public.who_global_data VALUES (13344, 840, 29572, 9, 442, 57, 169);
INSERT INTO public.who_global_data VALUES (13345, 13673, 2297425, 292, 56572, 57, 28);
INSERT INTO public.who_global_data VALUES (13346, 77, 11677, 0, 71, 57, 85);
INSERT INTO public.who_global_data VALUES (13347, 124, 15535, 1, 91, 57, 211);
INSERT INTO public.who_global_data VALUES (13348, 0, 9300, 0, 62, 57, 60);
INSERT INTO public.who_global_data VALUES (13349, 1, 3779, 0, 123, 57, 3);
INSERT INTO public.who_global_data VALUES (13350, 4146, 183099, 37, 1694, 57, 11);
INSERT INTO public.who_global_data VALUES (13351, 29875, 1272078, 598, 20970, 57, 89);
INSERT INTO public.who_global_data VALUES (13352, 116, 52738, 0, 326, 57, 24);
INSERT INTO public.who_global_data VALUES (13353, 7, 1065, 0, 5, 57, 162);
INSERT INTO public.who_global_data VALUES (13354, 1533, 121253, 81, 3370, 57, 100);
INSERT INTO public.who_global_data VALUES (13355, 0, 19, 0, 0, 57, 47);
INSERT INTO public.who_global_data VALUES (13356, 0, 43, 0, 0, 57, 29);
INSERT INTO public.who_global_data VALUES (13357, 0, 8451, 0, 152, 57, 40);
INSERT INTO public.who_global_data VALUES (13358, 13, 6915, 2, 115, 57, 222);
INSERT INTO public.who_global_data VALUES (13359, 659, 127786, 34, 4345, 57, 132);
INSERT INTO public.who_global_data VALUES (13360, 1, 289, 0, 13, 57, 130);
INSERT INTO public.who_global_data VALUES (13361, 43, 13368, 0, 79, 57, 234);
INSERT INTO public.who_global_data VALUES (13362, 0, 2444, 0, 44, 57, 23);
INSERT INTO public.who_global_data VALUES (13363, 32, 5732, 0, 154, 57, 192);
INSERT INTO public.who_global_data VALUES (13364, 0, 9434, 0, 233, 57, 69);
INSERT INTO public.who_global_data VALUES (13365, 0, 26, 0, 0, 57, 187);
INSERT INTO public.who_global_data VALUES (13366, 617, 112792, 9, 2961, 57, 230);
INSERT INTO public.who_global_data VALUES (13367, 6197, 271200, 171, 6622, 57, 77);
INSERT INTO public.who_global_data VALUES (13368, 8, 5524, 0, 28, 57, 9);
INSERT INTO public.who_global_data VALUES (13369, 29398, 9796769, 414, 142186, 57, 74);
INSERT INTO public.who_global_data VALUES (13370, 6033, 598933, 165, 18336, 57, 224);
INSERT INTO public.who_global_data VALUES (13371, 10403, 1083023, 284, 51496, 57, 199);
INSERT INTO public.who_global_data VALUES (13372, 1380, 571253, 25, 12526, 57, 190);
INSERT INTO public.who_global_data VALUES (13373, 303, 75203, 15, 2117, 57, 12);
INSERT INTO public.who_global_data VALUES (13374, 0, 370, 0, 25, 57, 104);
INSERT INTO public.who_global_data VALUES (13375, 1866, 350804, 15, 2965, 57, 153);
INSERT INTO public.who_global_data VALUES (13376, 16998, 1787147, 887, 62626, 57, 91);
INSERT INTO public.who_global_data VALUES (13377, 74, 11443, 4, 270, 57, 215);
INSERT INTO public.who_global_data VALUES (13378, 2969, 171542, 37, 2502, 57, 84);
INSERT INTO public.who_global_data VALUES (13379, 37, 1497, 0, 32, 57, 231);
INSERT INTO public.who_global_data VALUES (13380, 2902, 253121, 44, 3250, 57, 196);
INSERT INTO public.who_global_data VALUES (13381, 927, 184557, 0, 2542, 57, 105);
INSERT INTO public.who_global_data VALUES (13382, 644, 90305, 16, 1568, 57, 122);
INSERT INTO public.who_global_data VALUES (13383, 0, 0, 0, 0, 57, 159);
INSERT INTO public.who_global_data VALUES (13384, 562, 44961, 13, 1151, 57, 75);
INSERT INTO public.who_global_data VALUES (13385, 291, 145495, 5, 910, 57, 27);
INSERT INTO public.who_global_data VALUES (13386, 327, 76718, 1, 1307, 57, 54);
INSERT INTO public.who_global_data VALUES (13387, 0, 41, 0, 0, 57, 226);
INSERT INTO public.who_global_data VALUES (13388, 890, 23706, 11, 304, 57, 79);
INSERT INTO public.who_global_data VALUES (13389, 1778, 142187, 14, 1170, 57, 56);
INSERT INTO public.who_global_data VALUES (13390, 0, 2150, 0, 44, 57, 117);
INSERT INTO public.who_global_data VALUES (13391, 0, 1676, 0, 83, 57, 152);
INSERT INTO public.who_global_data VALUES (13392, 661, 89183, 12, 1273, 57, 16);
INSERT INTO public.who_global_data VALUES (13393, 23, 1518, 1, 20, 57, 10);
INSERT INTO public.who_global_data VALUES (13394, 3071, 86953, 35, 939, 57, 201);
INSERT INTO public.who_global_data VALUES (13395, 1173, 40037, 15, 384, 57, 174);
INSERT INTO public.who_global_data VALUES (13396, 0, 17473, 0, 255, 57, 119);
INSERT INTO public.who_global_data VALUES (13397, 2, 6053, 0, 186, 57, 168);
INSERT INTO public.who_global_data VALUES (13398, 2234, 78499, 3, 396, 57, 99);
INSERT INTO public.who_global_data VALUES (13399, 34, 13308, 0, 47, 57, 171);
INSERT INTO public.who_global_data VALUES (13400, 134, 5576, 4, 184, 57, 87);
INSERT INTO public.who_global_data VALUES (13401, 106, 10884, 4, 164, 57, 123);
INSERT INTO public.who_global_data VALUES (13402, 0, 4, 0, 0, 57, 151);
INSERT INTO public.who_global_data VALUES (13403, 0, 5553, 0, 41, 57, 213);
INSERT INTO public.who_global_data VALUES (13404, 0, 9679, 0, 194, 57, 118);
INSERT INTO public.who_global_data VALUES (13405, 0, 514, 0, 10, 57, 134);
INSERT INTO public.who_global_data VALUES (13406, 0, 5499, 0, 51, 57, 65);
INSERT INTO public.who_global_data VALUES (13407, 11974, 1205229, 781, 111655, 57, 102);
INSERT INTO public.who_global_data VALUES (13408, 0, 0, 0, 0, 57, 223);
INSERT INTO public.who_global_data VALUES (13409, 2, 660, 0, 3, 57, 4);
INSERT INTO public.who_global_data VALUES (13410, 5, 898, 0, 0, 57, 146);
INSERT INTO public.who_global_data VALUES (13411, 375, 40888, 3, 568, 57, 31);
INSERT INTO public.who_global_data VALUES (13412, 0, 13, 0, 1, 57, 127);
INSERT INTO public.who_global_data VALUES (13413, 3345, 391529, 65, 6492, 57, 22);
INSERT INTO public.who_global_data VALUES (13414, 81, 16521, 1, 139, 57, 115);
INSERT INTO public.who_global_data VALUES (13415, 1427, 103166, 23, 2174, 57, 106);
INSERT INTO public.who_global_data VALUES (13416, 301, 15773, 3, 158, 57, 90);
INSERT INTO public.who_global_data VALUES (13417, 0, 0, 0, 0, 57, 70);
INSERT INTO public.who_global_data VALUES (13418, 1217, 245650, 12, 1663, 57, 46);
INSERT INTO public.who_global_data VALUES (13419, 8712, 584497, 63, 9876, 57, 139);
INSERT INTO public.who_global_data VALUES (13420, 0, 36, 0, 0, 57, 42);
INSERT INTO public.who_global_data VALUES (13421, 6, 1736, 0, 25, 57, 80);
INSERT INTO public.who_global_data VALUES (13422, 0, 4709, 0, 162, 57, 203);
INSERT INTO public.who_global_data VALUES (13423, 0, 1856, 0, 77, 57, 136);
INSERT INTO public.who_global_data VALUES (13424, 675, 71344, 6, 1190, 57, 63);
INSERT INTO public.who_global_data VALUES (13425, 0, 0, 0, 0, 57, 17);
INSERT INTO public.who_global_data VALUES (13426, 0, 113, 0, 2, 57, 172);
INSERT INTO public.who_global_data VALUES (13427, 929, 70883, 28, 2051, 57, 109);
INSERT INTO public.who_global_data VALUES (13428, 362, 39524, 21, 382, 57, 200);
INSERT INTO public.who_global_data VALUES (13429, 2181, 119414, 24, 1008, 57, 93);
INSERT INTO public.who_global_data VALUES (13430, 179, 125669, 2, 1463, 57, 5);
INSERT INTO public.who_global_data VALUES (13431, 0, 744, 0, 13, 57, 214);
INSERT INTO public.who_global_data VALUES (13432, 3138, 429280, 56, 8603, 57, 204);
INSERT INTO public.who_global_data VALUES (13433, 0, 0, 0, 0, 57, 198);
INSERT INTO public.who_global_data VALUES (13434, 1811, 182977, 23, 3264, 57, 173);
INSERT INTO public.who_global_data VALUES (13435, 0, 684, 0, 7, 57, 229);
INSERT INTO public.who_global_data VALUES (13436, 725, 90146, 14, 1901, 57, 76);
INSERT INTO public.who_global_data VALUES (13437, 691, 977312, 54, 36455, 57, 138);
INSERT INTO public.who_global_data VALUES (13438, 1376, 445540, 24, 8701, 57, 98);
INSERT INTO public.who_global_data VALUES (13439, 0, 0, 0, 0, 57, 103);
INSERT INTO public.who_global_data VALUES (13440, 13750, 1102096, 470, 21630, 57, 225);
INSERT INTO public.who_global_data VALUES (13441, 3134, 335207, 86, 5278, 57, 131);
INSERT INTO public.who_global_data VALUES (13442, 496, 59458, 19, 1238, 57, 235);
INSERT INTO public.who_global_data VALUES (13443, 163, 140516, 0, 240, 57, 137);
INSERT INTO public.who_global_data VALUES (13444, 689, 40780, 8, 572, 57, 81);
INSERT INTO public.who_global_data VALUES (13445, 1715, 122685, 19, 2500, 57, 182);
INSERT INTO public.who_global_data VALUES (13446, 0, 8345, 0, 41, 57, 145);
INSERT INTO public.who_global_data VALUES (13447, 7067, 539107, 127, 12948, 57, 26);
INSERT INTO public.who_global_data VALUES (13448, 28585, 2597711, 613, 45893, 57, 170);
INSERT INTO public.who_global_data VALUES (13449, 71, 6349, 0, 53, 57, 191);
INSERT INTO public.who_global_data VALUES (13450, 0, 5, 0, 0, 57, 221);
INSERT INTO public.who_global_data VALUES (13451, 0, 164, 0, 0, 57, 64);
INSERT INTO public.who_global_data VALUES (13452, 0, 0, 0, 0, 57, 116);
INSERT INTO public.who_global_data VALUES (13453, 1, 26, 0, 0, 57, 128);
INSERT INTO public.who_global_data VALUES (13454, 3, 274, 1, 4, 57, 6);
INSERT INTO public.who_global_data VALUES (13455, 0, 838, 0, 12, 57, 227);
INSERT INTO public.who_global_data VALUES (13456, 0, 14, 0, 0, 57, 68);
INSERT INTO public.who_global_data VALUES (13457, 1, 91, 0, 0, 57, 184);
INSERT INTO public.who_global_data VALUES (13458, 0, 2, 0, 0, 57, 82);
INSERT INTO public.who_global_data VALUES (13459, 34, 1868, 0, 49, 57, 149);
INSERT INTO public.who_global_data VALUES (13460, 4, 1009, 0, 17, 57, 197);
INSERT INTO public.who_global_data VALUES (13461, 141, 359415, 10, 6012, 57, 78);
INSERT INTO public.who_global_data VALUES (13462, 101, 16766, 2, 343, 57, 233);
INSERT INTO public.who_global_data VALUES (13463, 7393, 249224, 56, 2172, 57, 133);
INSERT INTO public.who_global_data VALUES (13464, 0, 182, 0, 0, 57, 35);
INSERT INTO public.who_global_data VALUES (13465, 1, 2435, 1, 75, 57, 114);
INSERT INTO public.who_global_data VALUES (13466, 6, 58297, 0, 29, 57, 237);
INSERT INTO public.who_global_data VALUES (13467, 0, 16, 0, 0, 57, 55);
INSERT INTO public.who_global_data VALUES (13468, 30, 1185, 0, 26, 57, 176);
INSERT INTO public.who_global_data VALUES (13469, 2166, 127087, 18, 1122, 57, 202);
INSERT INTO public.who_global_data VALUES (13470, 1816, 93769, 57, 2183, 57, 155);
INSERT INTO public.who_global_data VALUES (13471, 0, 17, 0, 0, 57, 32);
INSERT INTO public.who_global_data VALUES (13472, 0, 4579, 0, 121, 57, 220);
INSERT INTO public.who_global_data VALUES (13473, 8166, 836764, 173, 22747, 57, 30);
INSERT INTO public.who_global_data VALUES (13474, 0, 3181, 0, 62, 57, 147);
INSERT INTO public.who_global_data VALUES (13475, 8642, 1780133, 189, 48759, 57, 208);
INSERT INTO public.who_global_data VALUES (13476, 1235, 30613, 4, 146, 57, 45);
INSERT INTO public.who_global_data VALUES (13477, 303, 21147, 4, 1344, 57, 110);
INSERT INTO public.who_global_data VALUES (13478, 7, 5333, 0, 117, 57, 88);
INSERT INTO public.who_global_data VALUES (13479, 8398, 314023, 75, 7860, 57, 51);
INSERT INTO public.who_global_data VALUES (13480, 4638, 374605, 83, 5578, 57, 209);
INSERT INTO public.who_global_data VALUES (13481, 112, 8787, 11, 476, 57, 205);
INSERT INTO public.who_global_data VALUES (13482, 64, 12722, 0, 87, 57, 18);
INSERT INTO public.who_global_data VALUES (13483, 18, 4169, 0, 60, 57, 72);
INSERT INTO public.who_global_data VALUES (13484, 20964, 1787787, 516, 63082, 57, 44);
INSERT INTO public.who_global_data VALUES (13485, 0, 31, 0, 0, 57, 15);
INSERT INTO public.who_global_data VALUES (13486, 0, 3132, 0, 65, 57, 25);
INSERT INTO public.who_global_data VALUES (13487, 0, 0, 0, 0, 57, 179);
INSERT INTO public.who_global_data VALUES (13488, 0, 0, 0, 0, 57, 34);
INSERT INTO public.who_global_data VALUES (13489, 0, 6808, 0, 122, 57, 207);
INSERT INTO public.who_global_data VALUES (13490, 958, 107814, 41, 3758, 57, 166);
INSERT INTO public.who_global_data VALUES (13491, 30424, 1748567, 220, 15751, 57, 126);
INSERT INTO public.who_global_data VALUES (13492, 0, 0, 0, 0, 57, 97);
INSERT INTO public.who_global_data VALUES (13493, 7, 768, 0, 6, 57, 36);
INSERT INTO public.who_global_data VALUES (13494, 0, 0, 0, 0, 57, 125);
INSERT INTO public.who_global_data VALUES (13495, 671, 25730, 13, 220, 57, 124);
INSERT INTO public.who_global_data VALUES (13496, 13514, 872228, 285, 14755, 57, 185);
INSERT INTO public.who_global_data VALUES (13497, 1255, 181405, 4, 602, 57, 194);
INSERT INTO public.who_global_data VALUES (13498, 0, 509, 0, 21, 57, 144);
INSERT INTO public.who_global_data VALUES (13499, 230852, 15203208, 3390, 287384, 57, 19);
INSERT INTO public.who_global_data VALUES (13500, 35, 1733, 0, 23, 57, 217);
INSERT INTO public.who_global_data VALUES (13501, 298, 8104, 1, 87, 57, 148);
INSERT INTO public.who_global_data VALUES (13502, 166, 74664, 0, 611, 57, 86);
INSERT INTO public.who_global_data VALUES (13503, 0, 1, 0, 0, 57, 13);
INSERT INTO public.who_global_data VALUES (13504, 468, 105852, 5, 933, 57, 157);
INSERT INTO public.who_global_data VALUES (13505, 4, 1385, 0, 35, 57, 8);
INSERT INTO public.who_global_data VALUES (13506, 0, 3, 0, 0, 57, 73);
INSERT INTO public.who_global_data VALUES (13507, 2, 2085, 0, 607, 57, 101);
INSERT INTO public.who_global_data VALUES (13508, 29, 18091, 0, 364, 57, 165);
INSERT INTO public.who_global_data VALUES (13509, 74, 11081, 1, 305, 57, 14);
INSERT INTO public.who_global_data VALUES (13510, 174, 48540, 13, 1921, 58, 193);
INSERT INTO public.who_global_data VALUES (13511, 752, 45188, 15, 951, 58, 113);
INSERT INTO public.who_global_data VALUES (13512, 598, 90014, 15, 2554, 58, 143);
INSERT INTO public.who_global_data VALUES (13513, 0, 0, 0, 0, 58, 219);
INSERT INTO public.who_global_data VALUES (13514, 35, 7162, 0, 78, 58, 186);
INSERT INTO public.who_global_data VALUES (13515, 75, 15804, 3, 358, 58, 52);
INSERT INTO public.who_global_data VALUES (13516, 0, 10, 0, 0, 58, 180);
INSERT INTO public.who_global_data VALUES (13517, 0, 146, 0, 4, 58, 167);
INSERT INTO public.who_global_data VALUES (13518, 3610, 1469919, 121, 40009, 58, 154);
INSERT INTO public.who_global_data VALUES (13519, 1174, 144553, 23, 2411, 58, 94);
INSERT INTO public.who_global_data VALUES (13520, 18, 4984, 0, 45, 58, 66);
INSERT INTO public.who_global_data VALUES (13521, 6, 27993, 0, 908, 58, 58);
INSERT INTO public.who_global_data VALUES (13522, 2913, 308601, 126, 4033, 58, 163);
INSERT INTO public.who_global_data VALUES (13523, 4403, 158555, 42, 1755, 58, 37);
INSERT INTO public.who_global_data VALUES (13524, 5, 7585, 0, 163, 58, 142);
INSERT INTO public.who_global_data VALUES (13525, 201, 88494, 4, 347, 58, 83);
INSERT INTO public.who_global_data VALUES (13526, 2159, 484104, 24, 6930, 58, 228);
INSERT INTO public.who_global_data VALUES (13527, 1, 290, 0, 7, 58, 188);
INSERT INTO public.who_global_data VALUES (13528, 1851, 152453, 8, 1230, 58, 62);
INSERT INTO public.who_global_data VALUES (13529, 2769, 602127, 88, 17717, 58, 160);
INSERT INTO public.who_global_data VALUES (13530, 60, 8013, 3, 179, 58, 50);
INSERT INTO public.who_global_data VALUES (13531, 0, 3090, 0, 44, 58, 33);
INSERT INTO public.who_global_data VALUES (13532, 34, 340, 0, 9, 58, 183);
INSERT INTO public.who_global_data VALUES (13533, 0, 433, 0, 0, 58, 92);
INSERT INTO public.who_global_data VALUES (13534, 189, 145846, 5, 9002, 58, 158);
INSERT INTO public.who_global_data VALUES (13535, 0, 146, 0, 3, 58, 67);
INSERT INTO public.who_global_data VALUES (13536, 1296, 97317, 70, 3151, 58, 57);
INSERT INTO public.who_global_data VALUES (13537, 0, 12058, 0, 34, 58, 38);
INSERT INTO public.who_global_data VALUES (13538, 51088, 6674999, 842, 178159, 58, 141);
INSERT INTO public.who_global_data VALUES (13539, 2, 75, 0, 1, 58, 178);
INSERT INTO public.who_global_data VALUES (13540, 0, 152, 0, 3, 58, 108);
INSERT INTO public.who_global_data VALUES (13541, 3328, 171493, 127, 5283, 58, 39);
INSERT INTO public.who_global_data VALUES (13542, 0, 3469, 0, 69, 58, 2);
INSERT INTO public.who_global_data VALUES (13543, 1, 721, 0, 1, 58, 195);
INSERT INTO public.who_global_data VALUES (13544, 0, 10626, 0, 105, 58, 107);
INSERT INTO public.who_global_data VALUES (13545, 2, 356, 0, 0, 58, 161);
INSERT INTO public.who_global_data VALUES (13546, 180, 25143, 0, 443, 58, 212);
INSERT INTO public.who_global_data VALUES (13547, 5981, 429035, 90, 12867, 58, 181);
INSERT INTO public.who_global_data VALUES (13548, 1, 291, 0, 2, 58, 53);
INSERT INTO public.who_global_data VALUES (13549, 5, 4932, 0, 63, 58, 164);
INSERT INTO public.who_global_data VALUES (13550, 4, 1732, 0, 102, 58, 140);
INSERT INTO public.who_global_data VALUES (13551, 1244, 564778, 10, 15690, 58, 20);
INSERT INTO public.who_global_data VALUES (13552, 118, 94618, 2, 4755, 58, 112);
INSERT INTO public.who_global_data VALUES (13553, 7510, 1384610, 163, 38158, 58, 111);
INSERT INTO public.who_global_data VALUES (13554, 0, 616, 0, 7, 58, 71);
INSERT INTO public.who_global_data VALUES (13555, 0, 6049, 0, 99, 58, 218);
INSERT INTO public.who_global_data VALUES (13556, 0, 0, 0, 0, 58, 43);
INSERT INTO public.who_global_data VALUES (13557, 1009, 147430, 21, 1846, 58, 49);
INSERT INTO public.who_global_data VALUES (13558, 34, 21547, 1, 133, 58, 1);
INSERT INTO public.who_global_data VALUES (13559, 4520, 159372, 69, 2367, 58, 48);
INSERT INTO public.who_global_data VALUES (13560, 124, 9106, 0, 136, 58, 232);
INSERT INTO public.who_global_data VALUES (13561, 72, 3246, 0, 8, 58, 175);
INSERT INTO public.who_global_data VALUES (13562, 363, 13649, 2, 70, 58, 21);
INSERT INTO public.who_global_data VALUES (13563, 6406, 563333, 90, 9226, 58, 156);
INSERT INTO public.who_global_data VALUES (13564, 0, 0, 0, 0, 58, 95);
INSERT INTO public.who_global_data VALUES (13565, 93, 13842, 6, 350, 58, 177);
INSERT INTO public.who_global_data VALUES (13566, 2558, 97357, 3, 904, 58, 210);
INSERT INTO public.who_global_data VALUES (13567, 3, 5717, 0, 61, 58, 120);
INSERT INTO public.who_global_data VALUES (13568, 0, 85, 0, 0, 58, 135);
INSERT INTO public.who_global_data VALUES (13569, 531, 150161, 3, 2350, 58, 206);
INSERT INTO public.who_global_data VALUES (13570, 476, 199228, 20, 13814, 58, 189);
INSERT INTO public.who_global_data VALUES (13571, 421, 119702, 19, 6832, 58, 129);
INSERT INTO public.who_global_data VALUES (13572, 396, 40741, 6, 1174, 58, 121);
INSERT INTO public.who_global_data VALUES (13573, 17, 5183, 0, 85, 58, 59);
INSERT INTO public.who_global_data VALUES (13574, 0, 649, 0, 0, 58, 96);
INSERT INTO public.who_global_data VALUES (13575, 544, 16054, 2, 139, 58, 41);
INSERT INTO public.who_global_data VALUES (13576, 49, 6612, 1, 125, 58, 216);
INSERT INTO public.who_global_data VALUES (13577, 1099, 114834, 14, 1769, 58, 236);
INSERT INTO public.who_global_data VALUES (13578, 0, 17, 0, 0, 58, 150);
INSERT INTO public.who_global_data VALUES (13579, 5, 519, 0, 0, 58, 61);
INSERT INTO public.who_global_data VALUES (13580, 0, 44, 0, 2, 58, 7);
INSERT INTO public.who_global_data VALUES (13581, 490, 28732, 8, 433, 58, 169);
INSERT INTO public.who_global_data VALUES (13582, 14084, 2283752, 294, 56280, 58, 28);
INSERT INTO public.who_global_data VALUES (13583, 87, 11600, 0, 71, 58, 85);
INSERT INTO public.who_global_data VALUES (13584, 79, 15411, 4, 90, 58, 211);
INSERT INTO public.who_global_data VALUES (13585, 22, 9300, 2, 62, 58, 60);
INSERT INTO public.who_global_data VALUES (13586, 2, 3778, 0, 123, 58, 3);
INSERT INTO public.who_global_data VALUES (13587, 4570, 178953, 43, 1657, 58, 11);
INSERT INTO public.who_global_data VALUES (13588, 23679, 1242203, 440, 20372, 58, 89);
INSERT INTO public.who_global_data VALUES (13589, 122, 52622, 0, 326, 58, 24);
INSERT INTO public.who_global_data VALUES (13590, 3, 1058, 0, 5, 58, 162);
INSERT INTO public.who_global_data VALUES (13591, 1675, 119720, 95, 3289, 58, 100);
INSERT INTO public.who_global_data VALUES (13592, 1, 19, 0, 0, 58, 47);
INSERT INTO public.who_global_data VALUES (13593, 0, 43, 0, 0, 58, 29);
INSERT INTO public.who_global_data VALUES (13594, 0, 8451, 0, 152, 58, 40);
INSERT INTO public.who_global_data VALUES (13595, 12, 6902, 0, 113, 58, 222);
INSERT INTO public.who_global_data VALUES (13596, 654, 127127, 25, 4311, 58, 132);
INSERT INTO public.who_global_data VALUES (13597, 0, 288, 0, 13, 58, 130);
INSERT INTO public.who_global_data VALUES (13598, 61, 13325, 0, 79, 58, 234);
INSERT INTO public.who_global_data VALUES (13599, 0, 2444, 0, 44, 58, 23);
INSERT INTO public.who_global_data VALUES (13600, 3, 5700, 0, 154, 58, 192);
INSERT INTO public.who_global_data VALUES (13601, 35, 9434, 0, 233, 58, 69);
INSERT INTO public.who_global_data VALUES (13602, 0, 26, 0, 0, 58, 187);
INSERT INTO public.who_global_data VALUES (13603, 468, 112175, 2, 2952, 58, 230);
INSERT INTO public.who_global_data VALUES (13604, 5415, 265003, 171, 6451, 58, 77);
INSERT INTO public.who_global_data VALUES (13605, 10, 5516, 0, 28, 58, 9);
INSERT INTO public.who_global_data VALUES (13606, 31521, 9767371, 412, 141772, 58, 74);
INSERT INTO public.who_global_data VALUES (13607, 6058, 592900, 171, 18171, 58, 224);
INSERT INTO public.who_global_data VALUES (13608, 10223, 1072620, 295, 51212, 58, 199);
INSERT INTO public.who_global_data VALUES (13609, 1735, 569873, 24, 12501, 58, 190);
INSERT INTO public.who_global_data VALUES (13610, 218, 74900, 5, 2102, 58, 12);
INSERT INTO public.who_global_data VALUES (13611, 0, 370, 0, 25, 58, 104);
INSERT INTO public.who_global_data VALUES (13612, 1768, 348938, 12, 2950, 58, 153);
INSERT INTO public.who_global_data VALUES (13613, 12755, 1770149, 499, 61739, 58, 91);
INSERT INTO public.who_global_data VALUES (13614, 98, 11369, 1, 266, 58, 215);
INSERT INTO public.who_global_data VALUES (13615, 2733, 168573, 45, 2465, 58, 84);
INSERT INTO public.who_global_data VALUES (13616, 122, 1460, 0, 32, 58, 231);
INSERT INTO public.who_global_data VALUES (13617, 3088, 250219, 44, 3206, 58, 196);
INSERT INTO public.who_global_data VALUES (13618, 973, 183630, 0, 2542, 58, 105);
INSERT INTO public.who_global_data VALUES (13619, 1082, 89661, 21, 1552, 58, 122);
INSERT INTO public.who_global_data VALUES (13620, 0, 0, 0, 0, 58, 159);
INSERT INTO public.who_global_data VALUES (13621, 561, 44399, 11, 1138, 58, 75);
INSERT INTO public.who_global_data VALUES (13622, 304, 145204, 5, 905, 58, 27);
INSERT INTO public.who_global_data VALUES (13623, 379, 76391, 3, 1306, 58, 54);
INSERT INTO public.who_global_data VALUES (13624, 0, 41, 0, 0, 58, 226);
INSERT INTO public.who_global_data VALUES (13625, 712, 22816, 5, 293, 58, 79);
INSERT INTO public.who_global_data VALUES (13626, 1274, 140409, 20, 1156, 58, 56);
INSERT INTO public.who_global_data VALUES (13627, 0, 2150, 0, 44, 58, 117);
INSERT INTO public.who_global_data VALUES (13628, 0, 1676, 0, 83, 58, 152);
INSERT INTO public.who_global_data VALUES (13629, 536, 88522, 6, 1261, 58, 16);
INSERT INTO public.who_global_data VALUES (13630, 21, 1495, 0, 19, 58, 10);
INSERT INTO public.who_global_data VALUES (13631, 3325, 83882, 17, 904, 58, 201);
INSERT INTO public.who_global_data VALUES (13632, 388, 38864, 9, 369, 58, 174);
INSERT INTO public.who_global_data VALUES (13633, 0, 17473, 0, 255, 58, 119);
INSERT INTO public.who_global_data VALUES (13634, 0, 6051, 0, 186, 58, 168);
INSERT INTO public.who_global_data VALUES (13635, 959, 76265, 5, 393, 58, 99);
INSERT INTO public.who_global_data VALUES (13636, 26, 13274, 0, 47, 58, 171);
INSERT INTO public.who_global_data VALUES (13637, 0, 5442, 0, 180, 58, 87);
INSERT INTO public.who_global_data VALUES (13638, 79, 10778, 3, 160, 58, 123);
INSERT INTO public.who_global_data VALUES (13639, 0, 4, 0, 0, 58, 151);
INSERT INTO public.who_global_data VALUES (13640, 0, 5553, 0, 41, 58, 213);
INSERT INTO public.who_global_data VALUES (13641, 163, 9679, 6, 194, 58, 118);
INSERT INTO public.who_global_data VALUES (13642, 9, 514, 0, 10, 58, 134);
INSERT INTO public.who_global_data VALUES (13643, 318, 5499, 2, 51, 58, 65);
INSERT INTO public.who_global_data VALUES (13644, 11006, 1193255, 800, 110874, 58, 102);
INSERT INTO public.who_global_data VALUES (13645, 0, 0, 0, 0, 58, 223);
INSERT INTO public.who_global_data VALUES (13646, 7, 658, 0, 3, 58, 4);
INSERT INTO public.who_global_data VALUES (13647, 5, 893, 0, 0, 58, 146);
INSERT INTO public.who_global_data VALUES (13648, 417, 40513, 10, 565, 58, 31);
INSERT INTO public.who_global_data VALUES (13649, 0, 13, 0, 1, 58, 127);
INSERT INTO public.who_global_data VALUES (13650, 4096, 388184, 57, 6427, 58, 22);
INSERT INTO public.who_global_data VALUES (13651, 67, 16440, 2, 138, 58, 115);
INSERT INTO public.who_global_data VALUES (13652, 1308, 101739, 19, 2151, 58, 106);
INSERT INTO public.who_global_data VALUES (13653, 174, 15472, 1, 155, 58, 90);
INSERT INTO public.who_global_data VALUES (13654, 0, 0, 0, 0, 58, 70);
INSERT INTO public.who_global_data VALUES (13655, 1056, 244433, 14, 1651, 58, 46);
INSERT INTO public.who_global_data VALUES (13656, 6548, 575785, 66, 9813, 58, 139);
INSERT INTO public.who_global_data VALUES (13657, 0, 36, 0, 0, 58, 42);
INSERT INTO public.who_global_data VALUES (13658, 0, 1730, 0, 25, 58, 80);
INSERT INTO public.who_global_data VALUES (13659, 0, 4709, 0, 162, 58, 203);
INSERT INTO public.who_global_data VALUES (13660, 0, 1856, 0, 77, 58, 136);
INSERT INTO public.who_global_data VALUES (13661, 474, 70669, 2, 1184, 58, 63);
INSERT INTO public.who_global_data VALUES (13662, 0, 0, 0, 0, 58, 17);
INSERT INTO public.who_global_data VALUES (13663, 0, 113, 0, 2, 58, 172);
INSERT INTO public.who_global_data VALUES (13664, 502, 69954, 46, 2023, 58, 109);
INSERT INTO public.who_global_data VALUES (13665, 459, 39162, 0, 361, 58, 200);
INSERT INTO public.who_global_data VALUES (13666, 1883, 117233, 23, 984, 58, 93);
INSERT INTO public.who_global_data VALUES (13667, 164, 125490, 7, 1461, 58, 5);
INSERT INTO public.who_global_data VALUES (13668, 0, 744, 0, 13, 58, 214);
INSERT INTO public.who_global_data VALUES (13669, 2963, 426142, 60, 8547, 58, 204);
INSERT INTO public.who_global_data VALUES (13670, 0, 0, 0, 0, 58, 198);
INSERT INTO public.who_global_data VALUES (13671, 1936, 181166, 29, 3241, 58, 173);
INSERT INTO public.who_global_data VALUES (13672, 0, 684, 0, 7, 58, 229);
INSERT INTO public.who_global_data VALUES (13673, 698, 89421, 15, 1887, 58, 76);
INSERT INTO public.who_global_data VALUES (13674, 1505, 976621, 77, 36401, 58, 138);
INSERT INTO public.who_global_data VALUES (13675, 1379, 444164, 7, 8677, 58, 98);
INSERT INTO public.who_global_data VALUES (13676, 0, 0, 0, 0, 58, 103);
INSERT INTO public.who_global_data VALUES (13677, 12166, 1088346, 568, 21160, 58, 225);
INSERT INTO public.who_global_data VALUES (13678, 4097, 332073, 70, 5192, 58, 131);
INSERT INTO public.who_global_data VALUES (13679, 646, 58962, 13, 1219, 58, 235);
INSERT INTO public.who_global_data VALUES (13680, 150, 140353, 1, 240, 58, 137);
INSERT INTO public.who_global_data VALUES (13681, 680, 40091, 8, 564, 58, 81);
INSERT INTO public.who_global_data VALUES (13682, 1766, 120970, 21, 2481, 58, 182);
INSERT INTO public.who_global_data VALUES (13683, 51, 8345, 0, 41, 58, 145);
INSERT INTO public.who_global_data VALUES (13684, 7365, 532040, 161, 12821, 58, 26);
INSERT INTO public.who_global_data VALUES (13685, 27927, 2569126, 562, 45280, 58, 170);
INSERT INTO public.who_global_data VALUES (13686, 41, 6278, 2, 53, 58, 191);
INSERT INTO public.who_global_data VALUES (13687, 0, 5, 0, 0, 58, 221);
INSERT INTO public.who_global_data VALUES (13688, 0, 164, 0, 0, 58, 64);
INSERT INTO public.who_global_data VALUES (13689, 0, 0, 0, 0, 58, 116);
INSERT INTO public.who_global_data VALUES (13690, 0, 25, 0, 0, 58, 128);
INSERT INTO public.who_global_data VALUES (13691, 1, 271, 1, 3, 58, 6);
INSERT INTO public.who_global_data VALUES (13692, 0, 838, 0, 12, 58, 227);
INSERT INTO public.who_global_data VALUES (13693, 0, 14, 0, 0, 58, 68);
INSERT INTO public.who_global_data VALUES (13694, 3, 90, 0, 0, 58, 184);
INSERT INTO public.who_global_data VALUES (13695, 0, 2, 0, 0, 58, 82);
INSERT INTO public.who_global_data VALUES (13696, 2, 1834, 1, 49, 58, 149);
INSERT INTO public.who_global_data VALUES (13697, 0, 1005, 0, 17, 58, 197);
INSERT INTO public.who_global_data VALUES (13698, 159, 359274, 13, 6002, 58, 78);
INSERT INTO public.who_global_data VALUES (13699, 69, 16665, 1, 341, 58, 233);
INSERT INTO public.who_global_data VALUES (13700, 7804, 241831, 54, 2116, 58, 133);
INSERT INTO public.who_global_data VALUES (13701, 0, 182, 0, 0, 58, 35);
INSERT INTO public.who_global_data VALUES (13702, 6, 2434, 0, 74, 58, 114);
INSERT INTO public.who_global_data VALUES (13703, 6, 58291, 0, 29, 58, 237);
INSERT INTO public.who_global_data VALUES (13704, 0, 16, 0, 0, 58, 55);
INSERT INTO public.who_global_data VALUES (13705, 0, 1155, 0, 26, 58, 176);
INSERT INTO public.who_global_data VALUES (13706, 3125, 124921, 38, 1104, 58, 202);
INSERT INTO public.who_global_data VALUES (13707, 1852, 91953, 55, 2126, 58, 155);
INSERT INTO public.who_global_data VALUES (13708, 0, 17, 0, 0, 58, 32);
INSERT INTO public.who_global_data VALUES (13709, 0, 4579, 0, 121, 58, 220);
INSERT INTO public.who_global_data VALUES (13710, 6709, 828598, 142, 22574, 58, 30);
INSERT INTO public.who_global_data VALUES (13711, 0, 3181, 0, 62, 58, 147);
INSERT INTO public.who_global_data VALUES (13712, 4102, 1771491, 141, 48570, 58, 208);
INSERT INTO public.who_global_data VALUES (13713, 0, 29378, 0, 142, 58, 45);
INSERT INTO public.who_global_data VALUES (13714, 376, 20844, 21, 1340, 58, 110);
INSERT INTO public.who_global_data VALUES (13715, 1, 5326, 0, 117, 58, 88);
INSERT INTO public.who_global_data VALUES (13716, 7446, 305625, 54, 7785, 58, 51);
INSERT INTO public.who_global_data VALUES (13717, 5241, 369967, 81, 5495, 58, 209);
INSERT INTO public.who_global_data VALUES (13718, 95, 8675, 7, 465, 58, 205);
INSERT INTO public.who_global_data VALUES (13719, 66, 12658, 0, 87, 58, 18);
INSERT INTO public.who_global_data VALUES (13720, 25, 4151, 0, 60, 58, 72);
INSERT INTO public.who_global_data VALUES (13721, 16578, 1766823, 533, 62566, 58, 44);
INSERT INTO public.who_global_data VALUES (13722, 0, 31, 0, 0, 58, 15);
INSERT INTO public.who_global_data VALUES (13723, 0, 3132, 0, 65, 58, 25);
INSERT INTO public.who_global_data VALUES (13724, 0, 0, 0, 0, 58, 179);
INSERT INTO public.who_global_data VALUES (13725, 0, 0, 0, 0, 58, 34);
INSERT INTO public.who_global_data VALUES (13726, 33, 6808, 0, 122, 58, 207);
INSERT INTO public.who_global_data VALUES (13727, 1411, 106856, 49, 3717, 58, 166);
INSERT INTO public.who_global_data VALUES (13728, 31712, 1718143, 217, 15531, 58, 126);
INSERT INTO public.who_global_data VALUES (13729, 0, 0, 0, 0, 58, 97);
INSERT INTO public.who_global_data VALUES (13730, 5, 761, 0, 6, 58, 36);
INSERT INTO public.who_global_data VALUES (13731, 0, 0, 0, 0, 58, 125);
INSERT INTO public.who_global_data VALUES (13732, 1859, 25059, 0, 207, 58, 124);
INSERT INTO public.who_global_data VALUES (13733, 13371, 858714, 266, 14470, 58, 185);
INSERT INTO public.who_global_data VALUES (13734, 1313, 180150, 2, 598, 58, 194);
INSERT INTO public.who_global_data VALUES (13735, 0, 509, 0, 21, 58, 144);
INSERT INTO public.who_global_data VALUES (13736, 216360, 14972356, 2552, 283994, 58, 19);
INSERT INTO public.who_global_data VALUES (13737, 18, 1698, 0, 23, 58, 217);
INSERT INTO public.who_global_data VALUES (13738, 301, 7806, 3, 86, 58, 148);
INSERT INTO public.who_global_data VALUES (13739, 146, 74498, 0, 611, 58, 86);
INSERT INTO public.who_global_data VALUES (13740, 0, 1, 0, 0, 58, 13);
INSERT INTO public.who_global_data VALUES (13741, 942, 105384, 9, 928, 58, 157);
INSERT INTO public.who_global_data VALUES (13742, 4, 1381, 0, 35, 58, 8);
INSERT INTO public.who_global_data VALUES (13743, 0, 3, 0, 0, 58, 73);
INSERT INTO public.who_global_data VALUES (13744, 0, 2083, 0, 607, 58, 101);
INSERT INTO public.who_global_data VALUES (13745, 131, 18062, 0, 364, 58, 165);
INSERT INTO public.who_global_data VALUES (13746, 168, 11007, 10, 304, 58, 14);
INSERT INTO public.who_global_data VALUES (13747, 230, 48366, 6, 1908, 59, 193);
INSERT INTO public.who_global_data VALUES (13748, 753, 44436, 14, 936, 59, 113);
INSERT INTO public.who_global_data VALUES (13749, 591, 89416, 12, 2539, 59, 143);
INSERT INTO public.who_global_data VALUES (13750, 0, 0, 0, 0, 59, 219);
INSERT INTO public.who_global_data VALUES (13751, 43, 7127, 0, 78, 59, 186);
INSERT INTO public.who_global_data VALUES (13752, 81, 15729, 1, 355, 59, 52);
INSERT INTO public.who_global_data VALUES (13753, 1, 10, 0, 0, 59, 180);
INSERT INTO public.who_global_data VALUES (13754, 0, 146, 0, 4, 59, 167);
INSERT INTO public.who_global_data VALUES (13755, 3199, 1466309, 118, 39888, 59, 154);
INSERT INTO public.who_global_data VALUES (13756, 1138, 143379, 21, 2388, 59, 94);
INSERT INTO public.who_global_data VALUES (13757, 1, 4966, 0, 45, 59, 66);
INSERT INTO public.who_global_data VALUES (13758, 15, 27987, 0, 908, 59, 58);
INSERT INTO public.who_global_data VALUES (13759, 2531, 305688, 80, 3907, 59, 163);
INSERT INTO public.who_global_data VALUES (13760, 4387, 154152, 38, 1713, 59, 37);
INSERT INTO public.who_global_data VALUES (13761, 1, 7580, 0, 163, 59, 142);
INSERT INTO public.who_global_data VALUES (13762, 183, 88293, 2, 343, 59, 83);
INSERT INTO public.who_global_data VALUES (13763, 2202, 481945, 32, 6906, 59, 228);
INSERT INTO public.who_global_data VALUES (13764, 2, 289, 0, 7, 59, 188);
INSERT INTO public.who_global_data VALUES (13765, 1649, 150602, 7, 1222, 59, 62);
INSERT INTO public.who_global_data VALUES (13766, 2723, 599358, 94, 17629, 59, 160);
INSERT INTO public.who_global_data VALUES (13767, 184, 7953, 3, 176, 59, 50);
INSERT INTO public.who_global_data VALUES (13768, 17, 3090, 0, 44, 59, 33);
INSERT INTO public.who_global_data VALUES (13769, 0, 306, 0, 9, 59, 183);
INSERT INTO public.who_global_data VALUES (13770, 1, 433, 0, 0, 59, 92);
INSERT INTO public.who_global_data VALUES (13771, 97, 145657, 2, 8997, 59, 158);
INSERT INTO public.who_global_data VALUES (13772, 0, 146, 0, 3, 59, 67);
INSERT INTO public.who_global_data VALUES (13773, 1077, 96021, 69, 3081, 59, 57);
INSERT INTO public.who_global_data VALUES (13774, 527, 12058, 0, 34, 59, 38);
INSERT INTO public.who_global_data VALUES (13775, 20371, 6623911, 376, 177317, 59, 141);
INSERT INTO public.who_global_data VALUES (13776, 0, 73, 0, 1, 59, 178);
INSERT INTO public.who_global_data VALUES (13777, 1, 152, 0, 3, 59, 108);
INSERT INTO public.who_global_data VALUES (13778, 3980, 168165, 146, 5156, 59, 39);
INSERT INTO public.who_global_data VALUES (13779, 154, 3469, 1, 69, 59, 2);
INSERT INTO public.who_global_data VALUES (13780, 4, 720, 0, 1, 59, 195);
INSERT INTO public.who_global_data VALUES (13781, 0, 10626, 0, 105, 59, 107);
INSERT INTO public.who_global_data VALUES (13782, 4, 354, 0, 0, 59, 161);
INSERT INTO public.who_global_data VALUES (13783, 211, 24963, 0, 443, 59, 212);
INSERT INTO public.who_global_data VALUES (13784, 7872, 423054, 112, 12777, 59, 181);
INSERT INTO public.who_global_data VALUES (13785, 0, 290, 0, 2, 59, 53);
INSERT INTO public.who_global_data VALUES (13786, 0, 4927, 0, 63, 59, 164);
INSERT INTO public.who_global_data VALUES (13787, 0, 1728, 0, 102, 59, 140);
INSERT INTO public.who_global_data VALUES (13788, 1392, 563534, 17, 15680, 59, 20);
INSERT INTO public.who_global_data VALUES (13789, 117, 94500, 0, 4753, 59, 112);
INSERT INTO public.who_global_data VALUES (13790, 5997, 1377100, 187, 37995, 59, 111);
INSERT INTO public.who_global_data VALUES (13791, 0, 616, 0, 7, 59, 71);
INSERT INTO public.who_global_data VALUES (13792, 275, 6049, 5, 99, 59, 218);
INSERT INTO public.who_global_data VALUES (13793, 0, 0, 0, 0, 59, 43);
INSERT INTO public.who_global_data VALUES (13794, 576, 146421, 15, 1825, 59, 49);
INSERT INTO public.who_global_data VALUES (13795, 6, 21513, 0, 132, 59, 1);
INSERT INTO public.who_global_data VALUES (13796, 2613, 154852, 65, 2298, 59, 48);
INSERT INTO public.who_global_data VALUES (13797, 76, 8982, 0, 136, 59, 232);
INSERT INTO public.who_global_data VALUES (13798, 38, 3174, 1, 8, 59, 175);
INSERT INTO public.who_global_data VALUES (13799, 419, 13286, 5, 68, 59, 21);
INSERT INTO public.who_global_data VALUES (13800, 5857, 556927, 100, 9136, 59, 156);
INSERT INTO public.who_global_data VALUES (13801, 0, 0, 0, 0, 59, 95);
INSERT INTO public.who_global_data VALUES (13802, 155, 13749, 0, 344, 59, 177);
INSERT INTO public.who_global_data VALUES (13803, 2150, 94799, 7, 901, 59, 210);
INSERT INTO public.who_global_data VALUES (13804, 6, 5714, 0, 61, 59, 120);
INSERT INTO public.who_global_data VALUES (13805, 0, 85, 0, 0, 59, 135);
INSERT INTO public.who_global_data VALUES (13806, 492, 149630, 1, 2347, 59, 206);
INSERT INTO public.who_global_data VALUES (13807, 508, 198752, 14, 13794, 59, 189);
INSERT INTO public.who_global_data VALUES (13808, 434, 119281, 23, 6813, 59, 129);
INSERT INTO public.who_global_data VALUES (13809, 0, 40345, 4, 1168, 59, 121);
INSERT INTO public.who_global_data VALUES (13810, 0, 5166, 0, 85, 59, 59);
INSERT INTO public.who_global_data VALUES (13811, 0, 649, 0, 0, 59, 96);
INSERT INTO public.who_global_data VALUES (13812, 284, 15510, 3, 137, 59, 41);
INSERT INTO public.who_global_data VALUES (13813, 34, 6563, 1, 124, 59, 216);
INSERT INTO public.who_global_data VALUES (13814, 0, 113735, 0, 1755, 59, 236);
INSERT INTO public.who_global_data VALUES (13815, 0, 17, 0, 0, 59, 150);
INSERT INTO public.who_global_data VALUES (13816, 4, 514, 0, 0, 59, 61);
INSERT INTO public.who_global_data VALUES (13817, 0, 44, 0, 2, 59, 7);
INSERT INTO public.who_global_data VALUES (13818, 361, 28242, 1, 425, 59, 169);
INSERT INTO public.who_global_data VALUES (13819, 13713, 2269668, 828, 55986, 59, 28);
INSERT INTO public.who_global_data VALUES (13820, 55, 11513, 0, 71, 59, 85);
INSERT INTO public.who_global_data VALUES (13821, 225, 15332, 7, 86, 59, 211);
INSERT INTO public.who_global_data VALUES (13822, 0, 9278, 0, 60, 59, 60);
INSERT INTO public.who_global_data VALUES (13823, 4, 3776, 0, 123, 59, 3);
INSERT INTO public.who_global_data VALUES (13824, 4734, 174383, 38, 1614, 59, 11);
INSERT INTO public.who_global_data VALUES (13825, 20815, 1218524, 590, 19932, 59, 89);
INSERT INTO public.who_global_data VALUES (13826, 226, 52500, 1, 326, 59, 24);
INSERT INTO public.who_global_data VALUES (13827, 2, 1055, 0, 5, 59, 162);
INSERT INTO public.who_global_data VALUES (13828, 1324, 118045, 102, 3194, 59, 100);
INSERT INTO public.who_global_data VALUES (13829, 0, 18, 0, 0, 59, 47);
INSERT INTO public.who_global_data VALUES (13830, 0, 43, 0, 0, 59, 29);
INSERT INTO public.who_global_data VALUES (13831, 0, 8451, 3, 152, 59, 40);
INSERT INTO public.who_global_data VALUES (13832, 7, 6890, 0, 113, 59, 222);
INSERT INTO public.who_global_data VALUES (13833, 799, 126473, 12, 4286, 59, 132);
INSERT INTO public.who_global_data VALUES (13834, 0, 288, 0, 13, 59, 130);
INSERT INTO public.who_global_data VALUES (13835, 18, 13264, 2, 79, 59, 234);
INSERT INTO public.who_global_data VALUES (13836, 3, 2444, 0, 44, 59, 23);
INSERT INTO public.who_global_data VALUES (13837, 32, 5697, 1, 154, 59, 192);
INSERT INTO public.who_global_data VALUES (13838, 0, 9399, 0, 233, 59, 69);
INSERT INTO public.who_global_data VALUES (13839, 0, 26, 0, 0, 59, 187);
INSERT INTO public.who_global_data VALUES (13840, 684, 111707, 4, 2950, 59, 230);
INSERT INTO public.who_global_data VALUES (13841, 3221, 259588, 160, 6280, 59, 77);
INSERT INTO public.who_global_data VALUES (13842, 10, 5506, 1, 28, 59, 9);
INSERT INTO public.who_global_data VALUES (13843, 32080, 9735850, 402, 141360, 59, 74);
INSERT INTO public.who_global_data VALUES (13844, 5292, 586842, 133, 18000, 59, 224);
INSERT INTO public.who_global_data VALUES (13845, 11023, 1062397, 323, 50917, 59, 199);
INSERT INTO public.who_global_data VALUES (13846, 2123, 568138, 17, 12477, 59, 190);
INSERT INTO public.who_global_data VALUES (13847, 214, 74682, 0, 2097, 59, 12);
INSERT INTO public.who_global_data VALUES (13848, 0, 370, 0, 25, 59, 104);
INSERT INTO public.who_global_data VALUES (13849, 1860, 347170, 7, 2938, 59, 153);
INSERT INTO public.who_global_data VALUES (13850, 14837, 1757394, 634, 61240, 59, 91);
INSERT INTO public.who_global_data VALUES (13851, 87, 11271, 0, 265, 59, 215);
INSERT INTO public.who_global_data VALUES (13852, 1911, 165840, 38, 2420, 59, 84);
INSERT INTO public.who_global_data VALUES (13853, 100, 1338, 0, 32, 59, 231);
INSERT INTO public.who_global_data VALUES (13854, 3062, 247131, 46, 3162, 59, 196);
INSERT INTO public.who_global_data VALUES (13855, 936, 182657, 0, 2542, 59, 105);
INSERT INTO public.who_global_data VALUES (13856, 0, 88579, 0, 1531, 59, 122);
INSERT INTO public.who_global_data VALUES (13857, 0, 0, 0, 0, 59, 159);
INSERT INTO public.who_global_data VALUES (13858, 557, 43838, 17, 1127, 59, 75);
INSERT INTO public.who_global_data VALUES (13859, 301, 144900, 3, 900, 59, 27);
INSERT INTO public.who_global_data VALUES (13860, 322, 76012, 2, 1303, 59, 54);
INSERT INTO public.who_global_data VALUES (13861, 0, 41, 0, 0, 59, 226);
INSERT INTO public.who_global_data VALUES (13862, 584, 22104, 16, 288, 59, 79);
INSERT INTO public.who_global_data VALUES (13863, 1039, 139135, 21, 1136, 59, 56);
INSERT INTO public.who_global_data VALUES (13864, 0, 2150, 0, 44, 59, 117);
INSERT INTO public.who_global_data VALUES (13865, 0, 1676, 0, 83, 59, 152);
INSERT INTO public.who_global_data VALUES (13866, 889, 87986, 12, 1255, 59, 16);
INSERT INTO public.who_global_data VALUES (13867, 16, 1474, 0, 19, 59, 10);
INSERT INTO public.who_global_data VALUES (13868, 3127, 80557, 27, 887, 59, 201);
INSERT INTO public.who_global_data VALUES (13869, 261, 38476, 7, 360, 59, 174);
INSERT INTO public.who_global_data VALUES (13870, 0, 17473, 0, 255, 59, 119);
INSERT INTO public.who_global_data VALUES (13871, 0, 6051, 1, 186, 59, 168);
INSERT INTO public.who_global_data VALUES (13872, 1012, 75306, 4, 388, 59, 99);
INSERT INTO public.who_global_data VALUES (13873, 50, 13248, 0, 47, 59, 171);
INSERT INTO public.who_global_data VALUES (13874, 152, 5442, 5, 180, 59, 87);
INSERT INTO public.who_global_data VALUES (13875, 40, 10699, 2, 157, 59, 123);
INSERT INTO public.who_global_data VALUES (13876, 0, 4, 0, 0, 59, 151);
INSERT INTO public.who_global_data VALUES (13877, 0, 5553, 0, 41, 59, 213);
INSERT INTO public.who_global_data VALUES (13878, 0, 9516, 0, 188, 59, 118);
INSERT INTO public.who_global_data VALUES (13879, 0, 505, 0, 10, 59, 134);
INSERT INTO public.who_global_data VALUES (13880, 0, 5181, 0, 49, 59, 65);
INSERT INTO public.who_global_data VALUES (13881, 6399, 1182249, 357, 110074, 59, 102);
INSERT INTO public.who_global_data VALUES (13882, 0, 0, 0, 0, 59, 223);
INSERT INTO public.who_global_data VALUES (13883, 7, 651, 0, 3, 59, 4);
INSERT INTO public.who_global_data VALUES (13884, 1, 888, 0, 0, 59, 146);
INSERT INTO public.who_global_data VALUES (13885, 492, 40096, 7, 555, 59, 31);
INSERT INTO public.who_global_data VALUES (13886, 0, 13, 0, 1, 59, 127);
INSERT INTO public.who_global_data VALUES (13887, 2900, 384088, 50, 6370, 59, 22);
INSERT INTO public.who_global_data VALUES (13888, 47, 16373, 0, 136, 59, 115);
INSERT INTO public.who_global_data VALUES (13889, 1276, 100431, 22, 2132, 59, 106);
INSERT INTO public.who_global_data VALUES (13890, 79, 15298, 1, 154, 59, 90);
INSERT INTO public.who_global_data VALUES (13891, 0, 0, 0, 0, 59, 70);
INSERT INTO public.who_global_data VALUES (13892, 1382, 243377, 23, 1637, 59, 46);
INSERT INTO public.who_global_data VALUES (13893, 6124, 569237, 68, 9747, 59, 139);
INSERT INTO public.who_global_data VALUES (13894, 1, 36, 0, 0, 59, 42);
INSERT INTO public.who_global_data VALUES (13895, 1, 1730, 0, 25, 59, 80);
INSERT INTO public.who_global_data VALUES (13896, 38, 4709, 1, 162, 59, 203);
INSERT INTO public.who_global_data VALUES (13897, 67, 1856, 0, 77, 59, 136);
INSERT INTO public.who_global_data VALUES (13898, 550, 70195, 1, 1182, 59, 63);
INSERT INTO public.who_global_data VALUES (13899, 0, 0, 0, 0, 59, 17);
INSERT INTO public.who_global_data VALUES (13900, 2, 113, 0, 2, 59, 172);
INSERT INTO public.who_global_data VALUES (13901, 1120, 69452, 28, 1977, 59, 109);
INSERT INTO public.who_global_data VALUES (13902, 381, 38703, 2, 361, 59, 200);
INSERT INTO public.who_global_data VALUES (13903, 1595, 115350, 19, 961, 59, 93);
INSERT INTO public.who_global_data VALUES (13904, 211, 125326, 2, 1454, 59, 5);
INSERT INTO public.who_global_data VALUES (13905, 0, 744, 0, 13, 59, 214);
INSERT INTO public.who_global_data VALUES (13906, 2885, 423179, 89, 8487, 59, 204);
INSERT INTO public.who_global_data VALUES (13907, 0, 0, 0, 0, 59, 198);
INSERT INTO public.who_global_data VALUES (13908, 1511, 179230, 19, 3212, 59, 173);
INSERT INTO public.who_global_data VALUES (13909, 0, 684, 0, 7, 59, 229);
INSERT INTO public.who_global_data VALUES (13910, 803, 88723, 19, 1872, 59, 76);
INSERT INTO public.who_global_data VALUES (13911, 1204, 975116, 50, 36324, 59, 138);
INSERT INTO public.who_global_data VALUES (13912, 1386, 442785, 98, 8670, 59, 98);
INSERT INTO public.who_global_data VALUES (13913, 0, 0, 0, 0, 59, 103);
INSERT INTO public.who_global_data VALUES (13914, 8310, 1076180, 411, 20592, 59, 225);
INSERT INTO public.who_global_data VALUES (13915, 2905, 327976, 81, 5122, 59, 131);
INSERT INTO public.who_global_data VALUES (13916, 694, 58316, 3, 1206, 59, 235);
INSERT INTO public.who_global_data VALUES (13917, 117, 140203, 0, 239, 59, 137);
INSERT INTO public.who_global_data VALUES (13918, 670, 39411, 4, 556, 59, 81);
INSERT INTO public.who_global_data VALUES (13919, 1709, 119204, 22, 2460, 59, 182);
INSERT INTO public.who_global_data VALUES (13920, 0, 8294, 0, 41, 59, 145);
INSERT INTO public.who_global_data VALUES (13921, 7439, 524675, 213, 12660, 59, 26);
INSERT INTO public.who_global_data VALUES (13922, 26190, 2541199, 559, 44718, 59, 170);
INSERT INTO public.who_global_data VALUES (13923, 46, 6237, 0, 51, 59, 191);
INSERT INTO public.who_global_data VALUES (13924, 0, 5, 0, 0, 59, 221);
INSERT INTO public.who_global_data VALUES (13925, 0, 164, 0, 0, 59, 64);
INSERT INTO public.who_global_data VALUES (13926, 0, 0, 0, 0, 59, 116);
INSERT INTO public.who_global_data VALUES (13927, 0, 25, 0, 0, 59, 128);
INSERT INTO public.who_global_data VALUES (13928, 5, 270, 0, 2, 59, 6);
INSERT INTO public.who_global_data VALUES (13929, 0, 838, 0, 12, 59, 227);
INSERT INTO public.who_global_data VALUES (13930, 0, 14, 0, 0, 59, 68);
INSERT INTO public.who_global_data VALUES (13931, 0, 87, 0, 0, 59, 184);
INSERT INTO public.who_global_data VALUES (13932, 0, 2, 0, 0, 59, 82);
INSERT INTO public.who_global_data VALUES (13933, 32, 1832, 0, 48, 59, 149);
INSERT INTO public.who_global_data VALUES (13934, 3, 1005, 0, 17, 59, 197);
INSERT INTO public.who_global_data VALUES (13935, 193, 359115, 12, 5989, 59, 78);
INSERT INTO public.who_global_data VALUES (13936, 43, 16596, 0, 340, 59, 233);
INSERT INTO public.who_global_data VALUES (13937, 7818, 234027, 57, 2062, 59, 133);
INSERT INTO public.who_global_data VALUES (13938, 0, 182, 0, 0, 59, 35);
INSERT INTO public.who_global_data VALUES (13939, 0, 2428, 0, 74, 59, 114);
INSERT INTO public.who_global_data VALUES (13940, 12, 58285, 0, 29, 59, 237);
INSERT INTO public.who_global_data VALUES (13941, 0, 16, 0, 0, 59, 55);
INSERT INTO public.who_global_data VALUES (13942, 14, 1155, 1, 26, 59, 176);
INSERT INTO public.who_global_data VALUES (13943, 1949, 121796, 28, 1066, 59, 202);
INSERT INTO public.who_global_data VALUES (13944, 2140, 90101, 43, 2071, 59, 155);
INSERT INTO public.who_global_data VALUES (13945, 0, 17, 0, 0, 59, 32);
INSERT INTO public.who_global_data VALUES (13946, 0, 4579, 0, 121, 59, 220);
INSERT INTO public.who_global_data VALUES (13947, 4011, 821889, 183, 22432, 59, 30);
INSERT INTO public.who_global_data VALUES (13948, 0, 3181, 0, 62, 59, 147);
INSERT INTO public.who_global_data VALUES (13949, 5472, 1767389, 164, 48429, 59, 208);
INSERT INTO public.who_global_data VALUES (13950, 1501, 29378, 2, 142, 59, 45);
INSERT INTO public.who_global_data VALUES (13951, 172, 20468, 10, 1319, 59, 110);
INSERT INTO public.who_global_data VALUES (13952, 1, 5325, 0, 117, 59, 88);
INSERT INTO public.who_global_data VALUES (13953, 3782, 298179, 58, 7731, 59, 51);
INSERT INTO public.who_global_data VALUES (13954, 4670, 364726, 94, 5414, 59, 209);
INSERT INTO public.who_global_data VALUES (13955, 90, 8580, 6, 458, 59, 205);
INSERT INTO public.who_global_data VALUES (13956, 78, 12592, 0, 87, 59, 18);
INSERT INTO public.who_global_data VALUES (13957, 19, 4126, 0, 60, 59, 72);
INSERT INTO public.who_global_data VALUES (13958, 12281, 1750245, 599, 62033, 59, 44);
INSERT INTO public.who_global_data VALUES (13959, 0, 31, 0, 0, 59, 15);
INSERT INTO public.who_global_data VALUES (13960, 37, 3132, 0, 65, 59, 25);
INSERT INTO public.who_global_data VALUES (13961, 0, 0, 0, 0, 59, 179);
INSERT INTO public.who_global_data VALUES (13962, 0, 0, 0, 0, 59, 34);
INSERT INTO public.who_global_data VALUES (13963, 8, 6775, 0, 122, 59, 207);
INSERT INTO public.who_global_data VALUES (13964, 1116, 105445, 72, 3668, 59, 166);
INSERT INTO public.who_global_data VALUES (13965, 33198, 1686431, 211, 15314, 59, 126);
INSERT INTO public.who_global_data VALUES (13966, 0, 0, 0, 0, 59, 97);
INSERT INTO public.who_global_data VALUES (13967, 0, 756, 0, 6, 59, 36);
INSERT INTO public.who_global_data VALUES (13968, 0, 0, 0, 0, 59, 125);
INSERT INTO public.who_global_data VALUES (13969, 0, 23200, 0, 207, 59, 124);
INSERT INTO public.who_global_data VALUES (13970, 12585, 845343, 276, 14204, 59, 185);
INSERT INTO public.who_global_data VALUES (13971, 1260, 178837, 2, 596, 59, 194);
INSERT INTO public.who_global_data VALUES (13972, 0, 509, 0, 21, 59, 144);
INSERT INTO public.who_global_data VALUES (13973, 185473, 14755996, 1529, 281442, 59, 19);
INSERT INTO public.who_global_data VALUES (13974, 31, 1680, 0, 23, 59, 217);
INSERT INTO public.who_global_data VALUES (13975, 202, 7505, 1, 83, 59, 148);
INSERT INTO public.who_global_data VALUES (13976, 146, 74352, 0, 611, 59, 86);
INSERT INTO public.who_global_data VALUES (13977, 0, 1, 0, 0, 59, 13);
INSERT INTO public.who_global_data VALUES (13978, 0, 104442, 0, 919, 59, 157);
INSERT INTO public.who_global_data VALUES (13979, 10, 1377, 0, 35, 59, 8);
INSERT INTO public.who_global_data VALUES (13980, 0, 3, 0, 0, 59, 73);
INSERT INTO public.who_global_data VALUES (13981, 1, 2083, 0, 607, 59, 101);
INSERT INTO public.who_global_data VALUES (13982, 0, 17931, 0, 364, 59, 165);
INSERT INTO public.who_global_data VALUES (13983, 0, 10839, 0, 294, 59, 14);
INSERT INTO public.who_global_data VALUES (13984, 235, 48136, 27, 1902, 60, 193);
INSERT INTO public.who_global_data VALUES (13985, 695, 43683, 17, 922, 60, 113);
INSERT INTO public.who_global_data VALUES (13986, 573, 88825, 11, 2527, 60, 143);
INSERT INTO public.who_global_data VALUES (13987, 0, 0, 0, 0, 60, 219);
INSERT INTO public.who_global_data VALUES (13988, 34, 7084, 0, 78, 60, 186);
INSERT INTO public.who_global_data VALUES (13989, 112, 15648, 0, 354, 60, 52);
INSERT INTO public.who_global_data VALUES (13990, 2, 9, 0, 0, 60, 180);
INSERT INTO public.who_global_data VALUES (13991, 2, 146, 0, 4, 60, 167);
INSERT INTO public.who_global_data VALUES (13992, 3278, 1463110, 138, 39770, 60, 154);
INSERT INTO public.who_global_data VALUES (13993, 584, 142241, 28, 2367, 60, 94);
INSERT INTO public.who_global_data VALUES (13994, 42, 4965, 0, 45, 60, 66);
INSERT INTO public.who_global_data VALUES (13995, 7, 27972, 0, 908, 60, 58);
INSERT INTO public.who_global_data VALUES (13996, 2181, 303157, 95, 3827, 60, 163);
INSERT INTO public.who_global_data VALUES (13997, 3086, 149765, 43, 1675, 60, 37);
INSERT INTO public.who_global_data VALUES (13998, 4, 7579, 0, 163, 60, 142);
INSERT INTO public.who_global_data VALUES (13999, 181, 88110, 0, 341, 60, 83);
INSERT INTO public.who_global_data VALUES (14000, 2198, 479743, 36, 6874, 60, 228);
INSERT INTO public.who_global_data VALUES (14001, 2, 287, 0, 7, 60, 188);
INSERT INTO public.who_global_data VALUES (14002, 1796, 148953, 8, 1215, 60, 62);
INSERT INTO public.who_global_data VALUES (14003, 3371, 596635, 97, 17535, 60, 160);
INSERT INTO public.who_global_data VALUES (14004, 168, 7769, 1, 173, 60, 50);
INSERT INTO public.who_global_data VALUES (14005, 18, 3073, 0, 44, 60, 33);
INSERT INTO public.who_global_data VALUES (14006, 18, 306, 0, 9, 60, 183);
INSERT INTO public.who_global_data VALUES (14007, 2, 432, 0, 0, 60, 92);
INSERT INTO public.who_global_data VALUES (14008, 68, 145560, 3, 8995, 60, 158);
INSERT INTO public.who_global_data VALUES (14009, 1, 146, 0, 3, 60, 67);
INSERT INTO public.who_global_data VALUES (14010, 437, 94944, 60, 3012, 60, 57);
INSERT INTO public.who_global_data VALUES (14011, 314, 11531, 0, 34, 60, 38);
INSERT INTO public.who_global_data VALUES (14012, 26363, 6603540, 313, 176941, 60, 141);
INSERT INTO public.who_global_data VALUES (14013, 0, 73, 0, 1, 60, 178);
INSERT INTO public.who_global_data VALUES (14014, 0, 151, 0, 3, 60, 108);
INSERT INTO public.who_global_data VALUES (14015, 2764, 164185, 213, 5010, 60, 39);
INSERT INTO public.who_global_data VALUES (14016, 103, 3315, 0, 68, 60, 2);
INSERT INTO public.who_global_data VALUES (14017, 18, 716, 0, 1, 60, 195);
INSERT INTO public.who_global_data VALUES (14018, 0, 10626, 0, 105, 60, 107);
INSERT INTO public.who_global_data VALUES (14019, 2, 350, 0, 0, 60, 161);
INSERT INTO public.who_global_data VALUES (14020, 0, 24752, 0, 443, 60, 212);
INSERT INTO public.who_global_data VALUES (14021, 6261, 415182, 76, 12665, 60, 181);
INSERT INTO public.who_global_data VALUES (14022, 2, 290, 0, 2, 60, 53);
INSERT INTO public.who_global_data VALUES (14023, 5, 4927, 0, 63, 60, 164);
INSERT INTO public.who_global_data VALUES (14024, 3, 1728, 0, 102, 60, 140);
INSERT INTO public.who_global_data VALUES (14025, 1760, 562142, 35, 15663, 60, 20);
INSERT INTO public.who_global_data VALUES (14026, 90, 94383, 0, 4753, 60, 112);
INSERT INTO public.who_global_data VALUES (14027, 8854, 1371103, 175, 37808, 60, 111);
INSERT INTO public.who_global_data VALUES (14028, 1, 616, 0, 7, 60, 71);
INSERT INTO public.who_global_data VALUES (14029, 0, 5774, 0, 94, 60, 218);
INSERT INTO public.who_global_data VALUES (14030, 0, 0, 0, 0, 60, 43);
INSERT INTO public.who_global_data VALUES (14031, 2160, 145845, 37, 1810, 60, 49);
INSERT INTO public.who_global_data VALUES (14032, 22, 21507, 0, 132, 60, 1);
INSERT INTO public.who_global_data VALUES (14033, 1886, 152239, 59, 2233, 60, 48);
INSERT INTO public.who_global_data VALUES (14034, 124, 8906, 0, 136, 60, 232);
INSERT INTO public.who_global_data VALUES (14035, 396, 3136, 0, 7, 60, 175);
INSERT INTO public.who_global_data VALUES (14036, 416, 12867, 2, 63, 60, 21);
INSERT INTO public.who_global_data VALUES (14037, 4237, 551070, 134, 9036, 60, 156);
INSERT INTO public.who_global_data VALUES (14038, 0, 0, 0, 0, 60, 95);
INSERT INTO public.who_global_data VALUES (14039, 68, 13594, 0, 344, 60, 177);
INSERT INTO public.who_global_data VALUES (14040, 2046, 92649, 9, 894, 60, 210);
INSERT INTO public.who_global_data VALUES (14041, 7, 5708, 0, 61, 60, 120);
INSERT INTO public.who_global_data VALUES (14042, 0, 85, 0, 0, 60, 135);
INSERT INTO public.who_global_data VALUES (14043, 685, 149138, 1, 2346, 60, 206);
INSERT INTO public.who_global_data VALUES (14044, 246, 198244, 2, 13780, 60, 189);
INSERT INTO public.who_global_data VALUES (14045, 415, 118847, 19, 6790, 60, 129);
INSERT INTO public.who_global_data VALUES (14046, 214, 40345, 5, 1164, 60, 121);
INSERT INTO public.who_global_data VALUES (14047, 7, 5166, 0, 85, 60, 59);
INSERT INTO public.who_global_data VALUES (14048, 17, 649, 0, 0, 60, 96);
INSERT INTO public.who_global_data VALUES (14049, 248, 15226, 3, 134, 60, 41);
INSERT INTO public.who_global_data VALUES (14050, 28, 6529, 1, 123, 60, 216);
INSERT INTO public.who_global_data VALUES (14051, 440, 113735, 8, 1755, 60, 236);
INSERT INTO public.who_global_data VALUES (14052, 0, 17, 0, 0, 60, 150);
INSERT INTO public.who_global_data VALUES (14053, 0, 510, 0, 0, 60, 61);
INSERT INTO public.who_global_data VALUES (14054, 0, 44, 0, 2, 60, 7);
INSERT INTO public.who_global_data VALUES (14055, 250, 27881, 9, 424, 60, 169);
INSERT INTO public.who_global_data VALUES (14056, 3103, 2255955, 366, 55158, 60, 28);
INSERT INTO public.who_global_data VALUES (14057, 51, 11458, 0, 71, 60, 85);
INSERT INTO public.who_global_data VALUES (14058, 0, 15107, 0, 79, 60, 211);
INSERT INTO public.who_global_data VALUES (14059, 24, 9278, 0, 60, 60, 60);
INSERT INTO public.who_global_data VALUES (14060, 2, 3772, 0, 123, 60, 3);
INSERT INTO public.who_global_data VALUES (14061, 4673, 169649, 36, 1576, 60, 11);
INSERT INTO public.who_global_data VALUES (14062, 14055, 1197709, 423, 19342, 60, 89);
INSERT INTO public.who_global_data VALUES (14063, 0, 52274, 0, 325, 60, 24);
INSERT INTO public.who_global_data VALUES (14064, 5, 1053, 0, 5, 60, 162);
INSERT INTO public.who_global_data VALUES (14065, 1250, 116721, 89, 3092, 60, 100);
INSERT INTO public.who_global_data VALUES (14066, 0, 18, 0, 0, 60, 47);
INSERT INTO public.who_global_data VALUES (14067, 0, 43, 0, 0, 60, 29);
INSERT INTO public.who_global_data VALUES (14068, 24, 8451, 0, 149, 60, 40);
INSERT INTO public.who_global_data VALUES (14069, 11, 6883, 0, 113, 60, 222);
INSERT INTO public.who_global_data VALUES (14070, 124, 125674, 24, 4274, 60, 132);
INSERT INTO public.who_global_data VALUES (14071, 0, 288, 0, 13, 60, 130);
INSERT INTO public.who_global_data VALUES (14072, 13, 13246, 1, 77, 60, 234);
INSERT INTO public.who_global_data VALUES (14073, 0, 2441, 0, 44, 60, 23);
INSERT INTO public.who_global_data VALUES (14074, 28, 5665, 2, 153, 60, 192);
INSERT INTO public.who_global_data VALUES (14075, 29, 9399, 0, 233, 60, 69);
INSERT INTO public.who_global_data VALUES (14076, 0, 26, 0, 0, 60, 187);
INSERT INTO public.who_global_data VALUES (14077, 300, 111023, 1, 2946, 60, 230);
INSERT INTO public.who_global_data VALUES (14078, 2219, 256367, 136, 6120, 60, 77);
INSERT INTO public.who_global_data VALUES (14079, 14, 5496, 0, 27, 60, 9);
INSERT INTO public.who_global_data VALUES (14080, 26567, 9703770, 385, 140958, 60, 74);
INSERT INTO public.who_global_data VALUES (14081, 5754, 581550, 127, 17867, 60, 224);
INSERT INTO public.who_global_data VALUES (14082, 10827, 1051374, 284, 50594, 60, 199);
INSERT INTO public.who_global_data VALUES (14083, 1815, 566015, 28, 12460, 60, 190);
INSERT INTO public.who_global_data VALUES (14084, 222, 74468, 0, 2097, 60, 12);
INSERT INTO public.who_global_data VALUES (14085, 0, 370, 0, 25, 60, 104);
INSERT INTO public.who_global_data VALUES (14086, 1363, 345310, 8, 2931, 60, 153);
INSERT INTO public.who_global_data VALUES (14087, 13679, 1742557, 528, 60606, 60, 91);
INSERT INTO public.who_global_data VALUES (14088, 64, 11184, 0, 265, 60, 215);
INSERT INTO public.who_global_data VALUES (14089, 1862, 163929, 47, 2382, 60, 84);
INSERT INTO public.who_global_data VALUES (14090, 0, 1238, 0, 32, 60, 231);
INSERT INTO public.who_global_data VALUES (14091, 3980, 244069, 60, 3116, 60, 196);
INSERT INTO public.who_global_data VALUES (14092, 944, 181721, 0, 2542, 60, 105);
INSERT INTO public.who_global_data VALUES (14093, 199, 88579, 5, 1531, 60, 122);
INSERT INTO public.who_global_data VALUES (14094, 0, 0, 0, 0, 60, 159);
INSERT INTO public.who_global_data VALUES (14095, 519, 43281, 14, 1110, 60, 75);
INSERT INTO public.who_global_data VALUES (14096, 230, 144599, 6, 897, 60, 27);
INSERT INTO public.who_global_data VALUES (14097, 295, 75690, 4, 1301, 60, 54);
INSERT INTO public.who_global_data VALUES (14098, 2, 41, 0, 0, 60, 226);
INSERT INTO public.who_global_data VALUES (14099, 207, 21520, 10, 272, 60, 79);
INSERT INTO public.who_global_data VALUES (14100, 984, 138096, 16, 1115, 60, 56);
INSERT INTO public.who_global_data VALUES (14101, 13, 2150, 0, 44, 60, 117);
INSERT INTO public.who_global_data VALUES (14102, 0, 1676, 0, 83, 60, 152);
INSERT INTO public.who_global_data VALUES (14103, 517, 87097, 12, 1243, 60, 16);
INSERT INTO public.who_global_data VALUES (14104, 23, 1458, 0, 19, 60, 10);
INSERT INTO public.who_global_data VALUES (14105, 1393, 77430, 25, 860, 60, 201);
INSERT INTO public.who_global_data VALUES (14106, 531, 38215, 3, 353, 60, 174);
INSERT INTO public.who_global_data VALUES (14107, 0, 17473, 0, 255, 60, 119);
INSERT INTO public.who_global_data VALUES (14108, 0, 6051, 0, 185, 60, 168);
INSERT INTO public.who_global_data VALUES (14109, 1600, 74294, 2, 384, 60, 99);
INSERT INTO public.who_global_data VALUES (14110, 0, 13198, 0, 47, 60, 171);
INSERT INTO public.who_global_data VALUES (14111, 155, 5290, 7, 175, 60, 87);
INSERT INTO public.who_global_data VALUES (14112, 139, 10659, 4, 155, 60, 123);
INSERT INTO public.who_global_data VALUES (14113, 0, 4, 0, 0, 60, 151);
INSERT INTO public.who_global_data VALUES (14114, 33, 5553, 0, 41, 60, 213);
INSERT INTO public.who_global_data VALUES (14115, 1092, 9516, 16, 188, 60, 118);
INSERT INTO public.who_global_data VALUES (14116, 0, 505, 0, 10, 60, 134);
INSERT INTO public.who_global_data VALUES (14117, 0, 5181, 0, 49, 60, 65);
INSERT INTO public.who_global_data VALUES (14118, 7455, 1175850, 261, 109717, 60, 102);
INSERT INTO public.who_global_data VALUES (14119, 0, 0, 0, 0, 60, 223);
INSERT INTO public.who_global_data VALUES (14120, 3, 644, 0, 3, 60, 4);
INSERT INTO public.who_global_data VALUES (14121, 38, 887, 0, 0, 60, 146);
INSERT INTO public.who_global_data VALUES (14122, 528, 39604, 6, 548, 60, 31);
INSERT INTO public.who_global_data VALUES (14123, 0, 13, 0, 1, 60, 127);
INSERT INTO public.who_global_data VALUES (14124, 1531, 381188, 75, 6320, 60, 22);
INSERT INTO public.who_global_data VALUES (14125, 82, 16326, 3, 136, 60, 115);
INSERT INTO public.who_global_data VALUES (14126, 1108, 99155, 29, 2110, 60, 106);
INSERT INTO public.who_global_data VALUES (14127, 141, 15219, 0, 153, 60, 90);
INSERT INTO public.who_global_data VALUES (14128, 0, 0, 0, 0, 60, 70);
INSERT INTO public.who_global_data VALUES (14129, 1014, 241995, 20, 1614, 60, 46);
INSERT INTO public.who_global_data VALUES (14130, 7094, 563113, 19, 9679, 60, 139);
INSERT INTO public.who_global_data VALUES (14131, 0, 35, 0, 0, 60, 42);
INSERT INTO public.who_global_data VALUES (14132, 6, 1729, 0, 25, 60, 80);
INSERT INTO public.who_global_data VALUES (14133, 0, 4671, 0, 161, 60, 203);
INSERT INTO public.who_global_data VALUES (14134, 0, 1789, 0, 77, 60, 136);
INSERT INTO public.who_global_data VALUES (14135, 390, 69645, 1, 1181, 60, 63);
INSERT INTO public.who_global_data VALUES (14136, 0, 0, 0, 0, 60, 17);
INSERT INTO public.who_global_data VALUES (14137, 2, 111, 0, 2, 60, 172);
INSERT INTO public.who_global_data VALUES (14138, 364, 68332, 25, 1949, 60, 109);
INSERT INTO public.who_global_data VALUES (14139, 951, 38322, 5, 359, 60, 200);
INSERT INTO public.who_global_data VALUES (14140, 1720, 113755, 20, 942, 60, 93);
INSERT INTO public.who_global_data VALUES (14141, 229, 125115, 8, 1452, 60, 5);
INSERT INTO public.who_global_data VALUES (14142, 0, 744, 0, 13, 60, 214);
INSERT INTO public.who_global_data VALUES (14143, 3795, 420294, 37, 8398, 60, 204);
INSERT INTO public.who_global_data VALUES (14144, 0, 0, 0, 0, 60, 198);
INSERT INTO public.who_global_data VALUES (14145, 1812, 177719, 20, 3193, 60, 173);
INSERT INTO public.who_global_data VALUES (14146, 13, 684, 0, 7, 60, 229);
INSERT INTO public.who_global_data VALUES (14147, 707, 87920, 20, 1853, 60, 76);
INSERT INTO public.who_global_data VALUES (14148, 1224, 973912, 43, 36274, 60, 138);
INSERT INTO public.who_global_data VALUES (14149, 1565, 441399, 18, 8572, 60, 98);
INSERT INTO public.who_global_data VALUES (14150, 0, 0, 0, 0, 60, 103);
INSERT INTO public.who_global_data VALUES (14151, 4421, 1067870, 92, 20181, 60, 225);
INSERT INTO public.who_global_data VALUES (14152, 2597, 325071, 78, 5041, 60, 131);
INSERT INTO public.who_global_data VALUES (14153, 951, 57622, 11, 1203, 60, 235);
INSERT INTO public.who_global_data VALUES (14154, 178, 140086, 0, 239, 60, 137);
INSERT INTO public.who_global_data VALUES (14155, 589, 38741, 3, 552, 60, 81);
INSERT INTO public.who_global_data VALUES (14156, 860, 117495, 19, 2438, 60, 182);
INSERT INTO public.who_global_data VALUES (14157, 94, 8294, 0, 41, 60, 145);
INSERT INTO public.who_global_data VALUES (14158, 3660, 517236, 127, 12447, 60, 26);
INSERT INTO public.who_global_data VALUES (14159, 26097, 2515009, 562, 44159, 60, 170);
INSERT INTO public.who_global_data VALUES (14160, 62, 6191, 0, 51, 60, 191);
INSERT INTO public.who_global_data VALUES (14161, 0, 5, 0, 0, 60, 221);
INSERT INTO public.who_global_data VALUES (14162, 12, 164, 0, 0, 60, 64);
INSERT INTO public.who_global_data VALUES (14163, 0, 0, 0, 0, 60, 116);
INSERT INTO public.who_global_data VALUES (14164, 0, 25, 0, 0, 60, 128);
INSERT INTO public.who_global_data VALUES (14165, 0, 265, 0, 2, 60, 6);
INSERT INTO public.who_global_data VALUES (14166, 94, 838, 0, 12, 60, 227);
INSERT INTO public.who_global_data VALUES (14167, 0, 14, 0, 0, 60, 68);
INSERT INTO public.who_global_data VALUES (14168, 0, 87, 0, 0, 60, 184);
INSERT INTO public.who_global_data VALUES (14169, 0, 2, 0, 0, 60, 82);
INSERT INTO public.who_global_data VALUES (14170, 11, 1800, 0, 48, 60, 149);
INSERT INTO public.who_global_data VALUES (14171, 3, 1002, 0, 17, 60, 197);
INSERT INTO public.who_global_data VALUES (14172, 209, 358922, 12, 5977, 60, 78);
INSERT INTO public.who_global_data VALUES (14173, 76, 16553, 2, 340, 60, 233);
INSERT INTO public.who_global_data VALUES (14174, 6557, 226209, 56, 2005, 60, 133);
INSERT INTO public.who_global_data VALUES (14175, 0, 182, 0, 0, 60, 35);
INSERT INTO public.who_global_data VALUES (14176, 2, 2428, 0, 74, 60, 114);
INSERT INTO public.who_global_data VALUES (14177, 13, 58273, 0, 29, 60, 237);
INSERT INTO public.who_global_data VALUES (14178, 2, 16, 0, 0, 60, 55);
INSERT INTO public.who_global_data VALUES (14179, 36, 1141, 0, 25, 60, 176);
INSERT INTO public.who_global_data VALUES (14180, 552, 119847, 22, 1038, 60, 202);
INSERT INTO public.who_global_data VALUES (14181, 1630, 87961, 60, 2028, 60, 155);
INSERT INTO public.who_global_data VALUES (14182, 0, 17, 0, 0, 60, 32);
INSERT INTO public.who_global_data VALUES (14183, 54, 4579, 0, 121, 60, 220);
INSERT INTO public.who_global_data VALUES (14184, 3313, 817878, 43, 22249, 60, 30);
INSERT INTO public.who_global_data VALUES (14185, 0, 3181, 0, 62, 60, 147);
INSERT INTO public.who_global_data VALUES (14186, 3297, 1761917, 161, 48265, 60, 208);
INSERT INTO public.who_global_data VALUES (14187, 649, 27877, 3, 140, 60, 45);
INSERT INTO public.who_global_data VALUES (14188, 212, 20296, 2, 1309, 60, 110);
INSERT INTO public.who_global_data VALUES (14189, 0, 5324, 0, 117, 60, 88);
INSERT INTO public.who_global_data VALUES (14190, 1803, 294397, 81, 7673, 60, 51);
INSERT INTO public.who_global_data VALUES (14191, 5829, 360056, 73, 5320, 60, 209);
INSERT INTO public.who_global_data VALUES (14192, 87, 8490, 5, 452, 60, 205);
INSERT INTO public.who_global_data VALUES (14193, 58, 12514, 0, 87, 60, 18);
INSERT INTO public.who_global_data VALUES (14194, 21, 4107, 0, 60, 60, 72);
INSERT INTO public.who_global_data VALUES (14195, 14718, 1737964, 189, 61434, 60, 44);
INSERT INTO public.who_global_data VALUES (14196, 0, 31, 0, 0, 60, 15);
INSERT INTO public.who_global_data VALUES (14197, 10, 3095, 0, 65, 60, 25);
INSERT INTO public.who_global_data VALUES (14198, 0, 0, 0, 0, 60, 179);
INSERT INTO public.who_global_data VALUES (14199, 0, 0, 0, 0, 60, 34);
INSERT INTO public.who_global_data VALUES (14200, 16, 6767, 0, 122, 60, 207);
INSERT INTO public.who_global_data VALUES (14201, 327, 104329, 35, 3596, 60, 166);
INSERT INTO public.who_global_data VALUES (14202, 32137, 1653233, 203, 15103, 60, 126);
INSERT INTO public.who_global_data VALUES (14203, 0, 0, 0, 0, 60, 97);
INSERT INTO public.who_global_data VALUES (14204, 0, 756, 0, 6, 60, 36);
INSERT INTO public.who_global_data VALUES (14205, 0, 0, 0, 0, 60, 125);
INSERT INTO public.who_global_data VALUES (14206, 701, 23200, 1, 207, 60, 124);
INSERT INTO public.who_global_data VALUES (14207, 10811, 832758, 195, 13928, 60, 185);
INSERT INTO public.who_global_data VALUES (14208, 1148, 177577, 2, 594, 60, 194);
INSERT INTO public.who_global_data VALUES (14209, 0, 509, 0, 21, 60, 144);
INSERT INTO public.who_global_data VALUES (14210, 173388, 14570523, 1107, 279913, 60, 19);
INSERT INTO public.who_global_data VALUES (14211, 0, 1649, 0, 23, 60, 217);
INSERT INTO public.who_global_data VALUES (14212, 338, 7303, 1, 82, 60, 148);
INSERT INTO public.who_global_data VALUES (14213, 153, 74206, 0, 611, 60, 86);
INSERT INTO public.who_global_data VALUES (14214, 0, 1, 0, 0, 60, 13);
INSERT INTO public.who_global_data VALUES (14215, 265, 104442, 3, 919, 60, 157);
INSERT INTO public.who_global_data VALUES (14216, 1, 1367, 0, 35, 60, 8);
INSERT INTO public.who_global_data VALUES (14217, 0, 3, 0, 0, 60, 73);
INSERT INTO public.who_global_data VALUES (14218, 0, 2082, 0, 607, 60, 101);
INSERT INTO public.who_global_data VALUES (14219, 15, 17931, 0, 364, 60, 165);
INSERT INTO public.who_global_data VALUES (14220, 121, 10839, 3, 294, 60, 14);
INSERT INTO public.who_global_data VALUES (14221, 260, 47901, 10, 1875, 61, 193);
INSERT INTO public.who_global_data VALUES (14222, 840, 42988, 16, 905, 61, 113);
INSERT INTO public.who_global_data VALUES (14223, 750, 88252, 15, 2516, 61, 143);
INSERT INTO public.who_global_data VALUES (14224, 0, 0, 0, 0, 61, 219);
INSERT INTO public.who_global_data VALUES (14225, 45, 7050, 0, 78, 61, 186);
INSERT INTO public.who_global_data VALUES (14226, 0, 15536, 0, 354, 61, 52);
INSERT INTO public.who_global_data VALUES (14227, 0, 7, 0, 0, 61, 180);
INSERT INTO public.who_global_data VALUES (14228, 0, 144, 0, 4, 61, 167);
INSERT INTO public.who_global_data VALUES (14229, 5201, 1459832, 120, 39632, 61, 154);
INSERT INTO public.who_global_data VALUES (14230, 407, 141657, 18, 2339, 61, 94);
INSERT INTO public.who_global_data VALUES (14231, 0, 4923, 0, 45, 61, 66);
INSERT INTO public.who_global_data VALUES (14232, 9, 27965, 0, 908, 61, 58);
INSERT INTO public.who_global_data VALUES (14233, 2745, 300976, 58, 3732, 61, 163);
INSERT INTO public.who_global_data VALUES (14234, 4356, 146679, 39, 1632, 61, 37);
INSERT INTO public.who_global_data VALUES (14235, 5, 7575, 0, 163, 61, 142);
INSERT INTO public.who_global_data VALUES (14236, 198, 87929, 0, 341, 61, 83);
INSERT INTO public.who_global_data VALUES (14237, 1666, 477545, 31, 6838, 61, 228);
INSERT INTO public.who_global_data VALUES (14238, 0, 285, 0, 7, 61, 188);
INSERT INTO public.who_global_data VALUES (14239, 1878, 147157, 9, 1207, 61, 62);
INSERT INTO public.who_global_data VALUES (14240, 601, 593264, 84, 17438, 61, 160);
INSERT INTO public.who_global_data VALUES (14241, 218, 7601, 2, 172, 61, 50);
INSERT INTO public.who_global_data VALUES (14242, 0, 3055, 0, 44, 61, 33);
INSERT INTO public.who_global_data VALUES (14243, 0, 288, 0, 9, 61, 183);
INSERT INTO public.who_global_data VALUES (14244, 4, 430, 0, 0, 61, 92);
INSERT INTO public.who_global_data VALUES (14245, 167, 145492, 5, 8992, 61, 158);
INSERT INTO public.who_global_data VALUES (14246, 0, 145, 0, 3, 61, 67);
INSERT INTO public.who_global_data VALUES (14247, 739, 94507, 30, 2952, 61, 57);
INSERT INTO public.who_global_data VALUES (14248, 1225, 11217, 3, 34, 61, 38);
INSERT INTO public.who_global_data VALUES (14249, 43209, 6577177, 664, 176628, 61, 141);
INSERT INTO public.who_global_data VALUES (14250, 0, 73, 0, 1, 61, 178);
INSERT INTO public.who_global_data VALUES (14251, 0, 151, 0, 3, 61, 108);
INSERT INTO public.who_global_data VALUES (14252, 577, 161421, 68, 4797, 61, 39);
INSERT INTO public.who_global_data VALUES (14253, 56, 3212, 0, 68, 61, 2);
INSERT INTO public.who_global_data VALUES (14254, 4, 698, 0, 1, 61, 195);
INSERT INTO public.who_global_data VALUES (14255, 0, 10626, 0, 105, 61, 107);
INSERT INTO public.who_global_data VALUES (14256, 2, 348, 0, 0, 61, 161);
INSERT INTO public.who_global_data VALUES (14257, 0, 24752, 0, 443, 61, 212);
INSERT INTO public.who_global_data VALUES (14258, 6352, 408921, 93, 12589, 61, 181);
INSERT INTO public.who_global_data VALUES (14259, 0, 288, 0, 2, 61, 53);
INSERT INTO public.who_global_data VALUES (14260, 0, 4922, 0, 63, 61, 164);
INSERT INTO public.who_global_data VALUES (14261, 3, 1725, 0, 102, 61, 140);
INSERT INTO public.who_global_data VALUES (14262, 1714, 560382, 36, 15628, 61, 20);
INSERT INTO public.who_global_data VALUES (14263, 133, 94293, 0, 4753, 61, 112);
INSERT INTO public.who_global_data VALUES (14264, 9642, 1362249, 166, 37633, 61, 111);
INSERT INTO public.who_global_data VALUES (14265, 0, 615, 0, 7, 61, 71);
INSERT INTO public.who_global_data VALUES (14266, 0, 5774, 0, 94, 61, 218);
INSERT INTO public.who_global_data VALUES (14267, 0, 0, 0, 0, 61, 43);
INSERT INTO public.who_global_data VALUES (14268, 0, 143685, 0, 1773, 61, 49);
INSERT INTO public.who_global_data VALUES (14269, 44, 21485, 0, 132, 61, 1);
INSERT INTO public.who_global_data VALUES (14270, 2899, 150353, 72, 2174, 61, 48);
INSERT INTO public.who_global_data VALUES (14271, 68, 8782, 0, 136, 61, 232);
INSERT INTO public.who_global_data VALUES (14272, 0, 2740, 0, 7, 61, 175);
INSERT INTO public.who_global_data VALUES (14273, 270, 12451, 2, 61, 61, 21);
INSERT INTO public.who_global_data VALUES (14274, 2654, 546833, 87, 8902, 61, 156);
INSERT INTO public.who_global_data VALUES (14275, 0, 0, 0, 0, 61, 95);
INSERT INTO public.who_global_data VALUES (14276, 0, 13526, 0, 344, 61, 177);
INSERT INTO public.who_global_data VALUES (14277, 1745, 90603, 7, 885, 61, 210);
INSERT INTO public.who_global_data VALUES (14278, 9, 5701, 0, 61, 61, 120);
INSERT INTO public.who_global_data VALUES (14279, 0, 85, 0, 0, 61, 135);
INSERT INTO public.who_global_data VALUES (14280, 798, 148453, 0, 2345, 61, 206);
INSERT INTO public.who_global_data VALUES (14281, 607, 197998, 22, 13778, 61, 189);
INSERT INTO public.who_global_data VALUES (14282, 418, 118432, 21, 6771, 61, 129);
INSERT INTO public.who_global_data VALUES (14283, 413, 40131, 6, 1159, 61, 121);
INSERT INTO public.who_global_data VALUES (14284, 0, 5159, 0, 85, 61, 59);
INSERT INTO public.who_global_data VALUES (14285, 0, 632, 0, 0, 61, 96);
INSERT INTO public.who_global_data VALUES (14286, 478, 14978, 5, 131, 61, 41);
INSERT INTO public.who_global_data VALUES (14287, 6, 6501, 0, 122, 61, 216);
INSERT INTO public.who_global_data VALUES (14288, 555, 113295, 2, 1747, 61, 236);
INSERT INTO public.who_global_data VALUES (14289, 0, 17, 0, 0, 61, 150);
INSERT INTO public.who_global_data VALUES (14290, 4, 510, 0, 0, 61, 61);
INSERT INTO public.who_global_data VALUES (14291, 0, 44, 0, 2, 61, 7);
INSERT INTO public.who_global_data VALUES (14292, 413, 27631, 0, 415, 61, 169);
INSERT INTO public.who_global_data VALUES (14293, 11022, 2252852, 174, 54792, 61, 28);
INSERT INTO public.who_global_data VALUES (14294, 0, 11407, 0, 71, 61, 85);
INSERT INTO public.who_global_data VALUES (14295, 0, 15107, 0, 79, 61, 211);
INSERT INTO public.who_global_data VALUES (14296, 0, 9254, 0, 60, 61, 60);
INSERT INTO public.who_global_data VALUES (14297, 0, 3770, 0, 123, 61, 3);
INSERT INTO public.who_global_data VALUES (14298, 2501, 164976, 36, 1540, 61, 11);
INSERT INTO public.who_global_data VALUES (14299, 12332, 1183654, 147, 18919, 61, 89);
INSERT INTO public.who_global_data VALUES (14300, 178, 52274, 0, 325, 61, 24);
INSERT INTO public.who_global_data VALUES (14301, 6, 1048, 0, 5, 61, 162);
INSERT INTO public.who_global_data VALUES (14302, 903, 115471, 101, 3003, 61, 100);
INSERT INTO public.who_global_data VALUES (14303, 0, 18, 0, 0, 61, 47);
INSERT INTO public.who_global_data VALUES (14304, 2, 43, 0, 0, 61, 29);
INSERT INTO public.who_global_data VALUES (14305, 0, 8427, 0, 149, 61, 40);
INSERT INTO public.who_global_data VALUES (14306, 27, 6872, 0, 113, 61, 222);
INSERT INTO public.who_global_data VALUES (14307, 198, 125550, 11, 4250, 61, 132);
INSERT INTO public.who_global_data VALUES (14308, 0, 288, 0, 13, 61, 130);
INSERT INTO public.who_global_data VALUES (14309, 26, 13233, 0, 76, 61, 234);
INSERT INTO public.who_global_data VALUES (14310, 0, 2441, 0, 44, 61, 23);
INSERT INTO public.who_global_data VALUES (14311, 36, 5637, 0, 151, 61, 192);
INSERT INTO public.who_global_data VALUES (14312, 0, 9370, 0, 233, 61, 69);
INSERT INTO public.who_global_data VALUES (14313, 0, 26, 0, 0, 61, 187);
INSERT INTO public.who_global_data VALUES (14314, 763, 110723, 4, 2945, 61, 230);
INSERT INTO public.who_global_data VALUES (14315, 3870, 254148, 116, 5984, 61, 77);
INSERT INTO public.who_global_data VALUES (14316, 6, 5482, 0, 27, 61, 9);
INSERT INTO public.who_global_data VALUES (14317, 32981, 9677203, 391, 140573, 61, 74);
INSERT INTO public.who_global_data VALUES (14318, 6089, 575796, 151, 17740, 61, 224);
INSERT INTO public.who_global_data VALUES (14319, 11561, 1040547, 294, 50310, 61, 199);
INSERT INTO public.who_global_data VALUES (14320, 1680, 564200, 21, 12432, 61, 190);
INSERT INTO public.who_global_data VALUES (14321, 298, 74246, 0, 2097, 61, 12);
INSERT INTO public.who_global_data VALUES (14322, 0, 370, 0, 25, 61, 104);
INSERT INTO public.who_global_data VALUES (14323, 1000, 343947, 10, 2923, 61, 153);
INSERT INTO public.who_global_data VALUES (14324, 18887, 1728878, 564, 60078, 61, 91);
INSERT INTO public.who_global_data VALUES (14325, 57, 11120, 4, 265, 61, 215);
INSERT INTO public.who_global_data VALUES (14326, 1969, 162067, 20, 2335, 61, 84);
INSERT INTO public.who_global_data VALUES (14327, 0, 1238, 0, 32, 61, 231);
INSERT INTO public.who_global_data VALUES (14328, 2576, 240089, 46, 3056, 61, 196);
INSERT INTO public.who_global_data VALUES (14329, 688, 180777, 0, 2542, 61, 105);
INSERT INTO public.who_global_data VALUES (14330, 396, 88380, 8, 1526, 61, 122);
INSERT INTO public.who_global_data VALUES (14331, 0, 0, 0, 0, 61, 159);
INSERT INTO public.who_global_data VALUES (14332, 468, 42762, 19, 1096, 61, 75);
INSERT INTO public.who_global_data VALUES (14333, 205, 144369, 2, 891, 61, 27);
INSERT INTO public.who_global_data VALUES (14334, 293, 75395, 2, 1297, 61, 54);
INSERT INTO public.who_global_data VALUES (14335, 0, 39, 0, 0, 61, 226);
INSERT INTO public.who_global_data VALUES (14336, 526, 21313, 9, 262, 61, 79);
INSERT INTO public.who_global_data VALUES (14337, 1236, 137112, 9, 1099, 61, 56);
INSERT INTO public.who_global_data VALUES (14338, 0, 2137, 0, 44, 61, 117);
INSERT INTO public.who_global_data VALUES (14339, 0, 1676, 0, 83, 61, 152);
INSERT INTO public.who_global_data VALUES (14340, 1051, 86580, 12, 1231, 61, 16);
INSERT INTO public.who_global_data VALUES (14341, 4, 1435, 1, 19, 61, 10);
INSERT INTO public.who_global_data VALUES (14342, 1390, 76037, 44, 835, 61, 201);
INSERT INTO public.who_global_data VALUES (14343, 667, 37684, 5, 350, 61, 174);
INSERT INTO public.who_global_data VALUES (14344, 0, 17473, 0, 255, 61, 119);
INSERT INTO public.who_global_data VALUES (14345, 2, 6051, 0, 185, 61, 168);
INSERT INTO public.who_global_data VALUES (14346, 1335, 72694, 2, 382, 61, 99);
INSERT INTO public.who_global_data VALUES (14347, 39, 13198, 0, 47, 61, 171);
INSERT INTO public.who_global_data VALUES (14348, 73, 5135, 5, 168, 61, 87);
INSERT INTO public.who_global_data VALUES (14349, 97, 10520, 2, 151, 61, 123);
INSERT INTO public.who_global_data VALUES (14350, 0, 4, 0, 0, 61, 151);
INSERT INTO public.who_global_data VALUES (14351, 0, 5520, 0, 41, 61, 213);
INSERT INTO public.who_global_data VALUES (14352, 0, 8424, 0, 172, 61, 118);
INSERT INTO public.who_global_data VALUES (14353, 0, 505, 0, 10, 61, 134);
INSERT INTO public.who_global_data VALUES (14354, 0, 5181, 0, 49, 61, 65);
INSERT INTO public.who_global_data VALUES (14355, 11625, 1168395, 593, 109456, 61, 102);
INSERT INTO public.who_global_data VALUES (14356, 0, 0, 0, 0, 61, 223);
INSERT INTO public.who_global_data VALUES (14357, 1, 641, 0, 3, 61, 4);
INSERT INTO public.who_global_data VALUES (14358, 7, 849, 0, 0, 61, 146);
INSERT INTO public.who_global_data VALUES (14359, 529, 39076, 10, 542, 61, 31);
INSERT INTO public.who_global_data VALUES (14360, 0, 13, 0, 1, 61, 127);
INSERT INTO public.who_global_data VALUES (14361, 2919, 379657, 61, 6245, 61, 22);
INSERT INTO public.who_global_data VALUES (14362, 111, 16244, 0, 133, 61, 115);
INSERT INTO public.who_global_data VALUES (14363, 1527, 98047, 22, 2081, 61, 106);
INSERT INTO public.who_global_data VALUES (14364, 128, 15078, 0, 153, 61, 90);
INSERT INTO public.who_global_data VALUES (14365, 0, 0, 0, 0, 61, 70);
INSERT INTO public.who_global_data VALUES (14366, 1096, 240981, 17, 1594, 61, 46);
INSERT INTO public.who_global_data VALUES (14367, 6764, 556019, 24, 9660, 61, 139);
INSERT INTO public.who_global_data VALUES (14368, 0, 35, 0, 0, 61, 42);
INSERT INTO public.who_global_data VALUES (14369, 1, 1723, 0, 25, 61, 80);
INSERT INTO public.who_global_data VALUES (14370, 0, 4671, 0, 161, 61, 203);
INSERT INTO public.who_global_data VALUES (14371, 0, 1789, 0, 77, 61, 136);
INSERT INTO public.who_global_data VALUES (14372, 318, 69255, 0, 1180, 61, 63);
INSERT INTO public.who_global_data VALUES (14373, 0, 0, 0, 0, 61, 17);
INSERT INTO public.who_global_data VALUES (14374, 0, 109, 0, 2, 61, 172);
INSERT INTO public.who_global_data VALUES (14375, 657, 67968, 23, 1924, 61, 109);
INSERT INTO public.who_global_data VALUES (14376, 0, 37371, 0, 354, 61, 200);
INSERT INTO public.who_global_data VALUES (14377, 2333, 112035, 17, 922, 61, 93);
INSERT INTO public.who_global_data VALUES (14378, 557, 124886, 9, 1444, 61, 5);
INSERT INTO public.who_global_data VALUES (14379, 3, 744, 0, 13, 61, 214);
INSERT INTO public.who_global_data VALUES (14380, 3308, 416499, 58, 8361, 61, 204);
INSERT INTO public.who_global_data VALUES (14381, 0, 0, 0, 0, 61, 198);
INSERT INTO public.who_global_data VALUES (14382, 2300, 175907, 19, 3173, 61, 173);
INSERT INTO public.who_global_data VALUES (14383, 0, 671, 0, 7, 61, 229);
INSERT INTO public.who_global_data VALUES (14384, 714, 87213, 20, 1833, 61, 76);
INSERT INTO public.who_global_data VALUES (14385, 1828, 972688, 36, 36231, 61, 138);
INSERT INTO public.who_global_data VALUES (14386, 1765, 439834, 28, 8554, 61, 98);
INSERT INTO public.who_global_data VALUES (14387, 0, 0, 0, 0, 61, 103);
INSERT INTO public.who_global_data VALUES (14388, 9176, 1063449, 228, 20089, 61, 225);
INSERT INTO public.who_global_data VALUES (14389, 3834, 322474, 87, 4963, 61, 131);
INSERT INTO public.who_global_data VALUES (14390, 1139, 56671, 7, 1192, 61, 235);
INSERT INTO public.who_global_data VALUES (14391, 125, 139908, 0, 239, 61, 137);
INSERT INTO public.who_global_data VALUES (14392, 615, 38152, 4, 549, 61, 81);
INSERT INTO public.who_global_data VALUES (14393, 1078, 116635, 16, 2419, 61, 182);
INSERT INTO public.who_global_data VALUES (14394, 0, 8200, 0, 41, 61, 145);
INSERT INTO public.who_global_data VALUES (14395, 5231, 513576, 134, 12320, 61, 26);
INSERT INTO public.who_global_data VALUES (14396, 28142, 2488912, 456, 43597, 61, 170);
INSERT INTO public.who_global_data VALUES (14397, 45, 6129, 0, 51, 61, 191);
INSERT INTO public.who_global_data VALUES (14398, 0, 5, 0, 0, 61, 221);
INSERT INTO public.who_global_data VALUES (14399, 0, 152, 0, 0, 61, 64);
INSERT INTO public.who_global_data VALUES (14400, 0, 0, 0, 0, 61, 116);
INSERT INTO public.who_global_data VALUES (14401, 3, 25, 0, 0, 61, 128);
INSERT INTO public.who_global_data VALUES (14402, 0, 265, 0, 2, 61, 6);
INSERT INTO public.who_global_data VALUES (14403, 0, 744, 0, 12, 61, 227);
INSERT INTO public.who_global_data VALUES (14404, 0, 14, 0, 0, 61, 68);
INSERT INTO public.who_global_data VALUES (14405, 0, 87, 0, 0, 61, 184);
INSERT INTO public.who_global_data VALUES (14406, 0, 2, 0, 0, 61, 82);
INSERT INTO public.who_global_data VALUES (14407, 0, 1789, 0, 48, 61, 149);
INSERT INTO public.who_global_data VALUES (14408, 0, 999, 0, 17, 61, 197);
INSERT INTO public.who_global_data VALUES (14409, 187, 358713, 11, 5965, 61, 78);
INSERT INTO public.who_global_data VALUES (14410, 80, 16477, 1, 338, 61, 233);
INSERT INTO public.who_global_data VALUES (14411, 5809, 219652, 58, 1949, 61, 133);
INSERT INTO public.who_global_data VALUES (14412, 0, 182, 0, 0, 61, 35);
INSERT INTO public.who_global_data VALUES (14413, 6, 2426, 0, 74, 61, 114);
INSERT INTO public.who_global_data VALUES (14414, 5, 58260, 0, 29, 61, 237);
INSERT INTO public.who_global_data VALUES (14415, 0, 14, 0, 0, 61, 55);
INSERT INTO public.who_global_data VALUES (14416, 0, 1105, 0, 25, 61, 176);
INSERT INTO public.who_global_data VALUES (14417, 1269, 119295, 15, 1016, 61, 202);
INSERT INTO public.who_global_data VALUES (14418, 480, 86331, 59, 1968, 61, 155);
INSERT INTO public.who_global_data VALUES (14419, 0, 17, 0, 0, 61, 32);
INSERT INTO public.who_global_data VALUES (14420, 0, 4525, 0, 121, 61, 220);
INSERT INTO public.who_global_data VALUES (14421, 4116, 814565, 139, 22206, 61, 30);
INSERT INTO public.who_global_data VALUES (14422, 15, 3181, 1, 62, 61, 147);
INSERT INTO public.who_global_data VALUES (14423, 4987, 1758620, 156, 48104, 61, 208);
INSERT INTO public.who_global_data VALUES (14424, 0, 27228, 0, 137, 61, 45);
INSERT INTO public.who_global_data VALUES (14425, 337, 20084, 6, 1307, 61, 110);
INSERT INTO public.who_global_data VALUES (14426, 2, 5324, 0, 117, 61, 88);
INSERT INTO public.who_global_data VALUES (14427, 4864, 292594, 43, 7592, 61, 51);
INSERT INTO public.who_global_data VALUES (14428, 1939, 354227, 62, 5247, 61, 209);
INSERT INTO public.who_global_data VALUES (14429, 83, 8403, 5, 447, 61, 205);
INSERT INTO public.who_global_data VALUES (14430, 67, 12456, 0, 87, 61, 18);
INSERT INTO public.who_global_data VALUES (14431, 14, 4086, 0, 60, 61, 72);
INSERT INTO public.who_global_data VALUES (14432, 17271, 1723246, 231, 61245, 61, 44);
INSERT INTO public.who_global_data VALUES (14433, 0, 31, 0, 0, 61, 15);
INSERT INTO public.who_global_data VALUES (14434, 34, 3085, 0, 65, 61, 25);
INSERT INTO public.who_global_data VALUES (14435, 0, 0, 0, 0, 61, 179);
INSERT INTO public.who_global_data VALUES (14436, 0, 0, 0, 0, 61, 34);
INSERT INTO public.who_global_data VALUES (14437, 16, 6751, 1, 122, 61, 207);
INSERT INTO public.who_global_data VALUES (14438, 1011, 104002, 35, 3561, 61, 166);
INSERT INTO public.who_global_data VALUES (14439, 30402, 1621096, 195, 14900, 61, 126);
INSERT INTO public.who_global_data VALUES (14440, 0, 0, 0, 0, 61, 97);
INSERT INTO public.who_global_data VALUES (14441, 1, 756, 0, 6, 61, 36);
INSERT INTO public.who_global_data VALUES (14442, 0, 0, 0, 0, 61, 125);
INSERT INTO public.who_global_data VALUES (14443, 311, 22499, 0, 206, 61, 124);
INSERT INTO public.who_global_data VALUES (14444, 8641, 821947, 145, 13733, 61, 185);
INSERT INTO public.who_global_data VALUES (14445, 1153, 176429, 3, 592, 61, 194);
INSERT INTO public.who_global_data VALUES (14446, 0, 509, 0, 21, 61, 144);
INSERT INTO public.who_global_data VALUES (14447, 205837, 14397135, 2303, 278806, 61, 19);
INSERT INTO public.who_global_data VALUES (14448, 16, 1649, 0, 23, 61, 217);
INSERT INTO public.who_global_data VALUES (14449, 234, 6965, 1, 81, 61, 148);
INSERT INTO public.who_global_data VALUES (14450, 149, 74053, 0, 611, 61, 86);
INSERT INTO public.who_global_data VALUES (14451, 0, 1, 0, 0, 61, 13);
INSERT INTO public.who_global_data VALUES (14452, 300, 104177, 3, 916, 61, 157);
INSERT INTO public.who_global_data VALUES (14453, 1, 1366, 0, 35, 61, 8);
INSERT INTO public.who_global_data VALUES (14454, 0, 3, 0, 0, 61, 73);
INSERT INTO public.who_global_data VALUES (14455, 1, 2082, 0, 607, 61, 101);
INSERT INTO public.who_global_data VALUES (14456, 18, 17916, 0, 364, 61, 165);
INSERT INTO public.who_global_data VALUES (14457, 101, 10718, 0, 291, 61, 14);
INSERT INTO public.who_global_data VALUES (14458, 253, 47641, 18, 1865, 62, 193);
INSERT INTO public.who_global_data VALUES (14459, 846, 42148, 19, 889, 62, 113);
INSERT INTO public.who_global_data VALUES (14460, 772, 87502, 9, 2501, 62, 143);
INSERT INTO public.who_global_data VALUES (14461, 0, 0, 0, 0, 62, 219);
INSERT INTO public.who_global_data VALUES (14462, 50, 7005, 1, 78, 62, 186);
INSERT INTO public.who_global_data VALUES (14463, 43, 15536, 1, 354, 62, 52);
INSERT INTO public.who_global_data VALUES (14464, 0, 7, 0, 0, 62, 180);
INSERT INTO public.who_global_data VALUES (14465, 0, 144, 0, 4, 62, 167);
INSERT INTO public.who_global_data VALUES (14466, 6899, 1454631, 207, 39512, 62, 154);
INSERT INTO public.who_global_data VALUES (14467, 978, 141250, 17, 2321, 62, 94);
INSERT INTO public.who_global_data VALUES (14468, 0, 4923, 0, 45, 62, 66);
INSERT INTO public.who_global_data VALUES (14469, 7, 27956, 0, 908, 62, 58);
INSERT INTO public.who_global_data VALUES (14470, 3160, 298231, 87, 3674, 62, 163);
INSERT INTO public.who_global_data VALUES (14471, 4323, 142323, 42, 1593, 62, 37);
INSERT INTO public.who_global_data VALUES (14472, 5, 7570, 0, 163, 62, 142);
INSERT INTO public.who_global_data VALUES (14473, 132, 87731, 0, 341, 62, 83);
INSERT INTO public.who_global_data VALUES (14474, 1888, 475879, 35, 6807, 62, 228);
INSERT INTO public.who_global_data VALUES (14475, 4, 285, 0, 7, 62, 188);
INSERT INTO public.who_global_data VALUES (14476, 1896, 145279, 8, 1198, 62, 62);
INSERT INTO public.who_global_data VALUES (14477, 1101, 592663, 87, 17354, 62, 160);
INSERT INTO public.who_global_data VALUES (14478, 147, 7383, 6, 170, 62, 50);
INSERT INTO public.who_global_data VALUES (14479, 0, 3055, 0, 44, 62, 33);
INSERT INTO public.who_global_data VALUES (14480, 10, 288, 0, 9, 62, 183);
INSERT INTO public.who_global_data VALUES (14481, 2, 426, 0, 0, 62, 92);
INSERT INTO public.who_global_data VALUES (14482, 139, 145325, 5, 8987, 62, 158);
INSERT INTO public.who_global_data VALUES (14483, 0, 145, 0, 3, 62, 67);
INSERT INTO public.who_global_data VALUES (14484, 975, 93768, 57, 2922, 62, 57);
INSERT INTO public.who_global_data VALUES (14485, 0, 9992, 0, 31, 62, 38);
INSERT INTO public.who_global_data VALUES (14486, 46884, 6533968, 694, 175964, 62, 141);
INSERT INTO public.who_global_data VALUES (14487, 0, 73, 0, 1, 62, 178);
INSERT INTO public.who_global_data VALUES (14488, 0, 151, 0, 3, 62, 108);
INSERT INTO public.who_global_data VALUES (14489, 2037, 160844, 79, 4729, 62, 39);
INSERT INTO public.who_global_data VALUES (14490, 65, 3156, 0, 68, 62, 2);
INSERT INTO public.who_global_data VALUES (14491, 0, 694, 0, 1, 62, 195);
INSERT INTO public.who_global_data VALUES (14492, 0, 10626, 0, 105, 62, 107);
INSERT INTO public.who_global_data VALUES (14493, 1, 346, 0, 0, 62, 161);
INSERT INTO public.who_global_data VALUES (14494, 0, 24752, 0, 443, 62, 212);
INSERT INTO public.who_global_data VALUES (14495, 6299, 402569, 89, 12496, 62, 181);
INSERT INTO public.who_global_data VALUES (14496, 0, 288, 0, 2, 62, 53);
INSERT INTO public.who_global_data VALUES (14497, 0, 4922, 0, 63, 62, 164);
INSERT INTO public.who_global_data VALUES (14498, 3, 1722, 0, 102, 62, 140);
INSERT INTO public.who_global_data VALUES (14499, 1533, 558668, 34, 15592, 62, 20);
INSERT INTO public.who_global_data VALUES (14500, 122, 94160, 0, 4753, 62, 112);
INSERT INTO public.who_global_data VALUES (14501, 9285, 1352607, 162, 37467, 62, 111);
INSERT INTO public.who_global_data VALUES (14502, 0, 615, 0, 7, 62, 71);
INSERT INTO public.who_global_data VALUES (14503, 0, 5774, 0, 94, 62, 218);
INSERT INTO public.who_global_data VALUES (14504, 0, 0, 0, 0, 62, 43);
INSERT INTO public.who_global_data VALUES (14505, 1180, 143685, 16, 1773, 62, 49);
INSERT INTO public.who_global_data VALUES (14506, 29, 21441, 0, 132, 62, 1);
INSERT INTO public.who_global_data VALUES (14507, 4084, 147454, 70, 2102, 62, 48);
INSERT INTO public.who_global_data VALUES (14508, 104, 8714, 0, 136, 62, 232);
INSERT INTO public.who_global_data VALUES (14509, 0, 2740, 0, 7, 62, 175);
INSERT INTO public.who_global_data VALUES (14510, 369, 12181, 2, 59, 62, 21);
INSERT INTO public.who_global_data VALUES (14511, 1773, 544179, 77, 8815, 62, 156);
INSERT INTO public.who_global_data VALUES (14512, 0, 0, 0, 0, 62, 95);
INSERT INTO public.who_global_data VALUES (14513, 246, 13526, 7, 344, 62, 177);
INSERT INTO public.who_global_data VALUES (14514, 2115, 88858, 11, 878, 62, 210);
INSERT INTO public.who_global_data VALUES (14515, 2, 5692, 0, 61, 62, 120);
INSERT INTO public.who_global_data VALUES (14516, 0, 85, 0, 0, 62, 135);
INSERT INTO public.who_global_data VALUES (14517, 975, 147655, 2, 2345, 62, 206);
INSERT INTO public.who_global_data VALUES (14518, 1507, 197391, 144, 13756, 62, 189);
INSERT INTO public.who_global_data VALUES (14519, 431, 118014, 18, 6750, 62, 129);
INSERT INTO public.who_global_data VALUES (14520, 0, 39718, 11, 1153, 62, 121);
INSERT INTO public.who_global_data VALUES (14521, 0, 5159, 0, 85, 62, 59);
INSERT INTO public.who_global_data VALUES (14522, 0, 632, 0, 0, 62, 96);
INSERT INTO public.who_global_data VALUES (14523, 561, 14500, 1, 126, 62, 41);
INSERT INTO public.who_global_data VALUES (14524, 15, 6495, 0, 122, 62, 216);
INSERT INTO public.who_global_data VALUES (14525, 649, 112740, 11, 1745, 62, 236);
INSERT INTO public.who_global_data VALUES (14526, 0, 17, 0, 0, 62, 150);
INSERT INTO public.who_global_data VALUES (14527, 1, 506, 0, 0, 62, 61);
INSERT INTO public.who_global_data VALUES (14528, 0, 44, 0, 2, 62, 7);
INSERT INTO public.who_global_data VALUES (14529, 460, 27218, 0, 415, 62, 169);
INSERT INTO public.who_global_data VALUES (14530, 12850, 2241830, 214, 54618, 62, 28);
INSERT INTO public.who_global_data VALUES (14531, 73, 11407, 0, 71, 62, 85);
INSERT INTO public.who_global_data VALUES (14532, 0, 15107, 0, 79, 62, 211);
INSERT INTO public.who_global_data VALUES (14533, 0, 9254, 0, 60, 62, 60);
INSERT INTO public.who_global_data VALUES (14534, 2, 3770, 0, 123, 62, 3);
INSERT INTO public.who_global_data VALUES (14535, 4321, 162475, 42, 1504, 62, 11);
INSERT INTO public.who_global_data VALUES (14536, 17767, 1171322, 255, 18772, 62, 89);
INSERT INTO public.who_global_data VALUES (14537, 0, 52096, 0, 325, 62, 24);
INSERT INTO public.who_global_data VALUES (14538, 4, 1042, 0, 5, 62, 162);
INSERT INTO public.who_global_data VALUES (14539, 1383, 114568, 98, 2902, 62, 100);
INSERT INTO public.who_global_data VALUES (14540, 0, 18, 0, 0, 62, 47);
INSERT INTO public.who_global_data VALUES (14541, 0, 41, 0, 0, 62, 29);
INSERT INTO public.who_global_data VALUES (14542, 0, 8427, 0, 149, 62, 40);
INSERT INTO public.who_global_data VALUES (14543, 18, 6845, 0, 113, 62, 222);
INSERT INTO public.who_global_data VALUES (14544, 547, 125352, 15, 4239, 62, 132);
INSERT INTO public.who_global_data VALUES (14545, 0, 288, 0, 13, 62, 130);
INSERT INTO public.who_global_data VALUES (14546, 21, 13207, 0, 76, 62, 234);
INSERT INTO public.who_global_data VALUES (14547, 16, 2441, 0, 44, 62, 23);
INSERT INTO public.who_global_data VALUES (14548, 73, 5601, 0, 151, 62, 192);
INSERT INTO public.who_global_data VALUES (14549, 23, 9370, 0, 233, 62, 69);
INSERT INTO public.who_global_data VALUES (14550, 0, 26, 0, 0, 62, 187);
INSERT INTO public.who_global_data VALUES (14551, 200, 109960, 3, 2941, 62, 230);
INSERT INTO public.who_global_data VALUES (14552, 6697, 250278, 162, 5868, 62, 77);
INSERT INTO public.who_global_data VALUES (14553, 14, 5476, 0, 27, 62, 9);
INSERT INTO public.who_global_data VALUES (14554, 36011, 9644222, 482, 140182, 62, 74);
INSERT INTO public.who_global_data VALUES (14555, 6027, 569707, 110, 17589, 62, 224);
INSERT INTO public.who_global_data VALUES (14556, 12151, 1028986, 321, 50016, 62, 199);
INSERT INTO public.who_global_data VALUES (14557, 1898, 562520, 24, 12411, 62, 190);
INSERT INTO public.who_global_data VALUES (14558, 457, 73948, 11, 2097, 62, 12);
INSERT INTO public.who_global_data VALUES (14559, 1, 370, 0, 25, 62, 104);
INSERT INTO public.who_global_data VALUES (14560, 1514, 342947, 10, 2913, 62, 153);
INSERT INTO public.who_global_data VALUES (14561, 21052, 1709991, 662, 59514, 62, 91);
INSERT INTO public.who_global_data VALUES (14562, 76, 11063, 1, 261, 62, 215);
INSERT INTO public.who_global_data VALUES (14563, 2424, 160098, 32, 2315, 62, 84);
INSERT INTO public.who_global_data VALUES (14564, 68, 1238, 0, 32, 62, 231);
INSERT INTO public.who_global_data VALUES (14565, 3160, 237513, 50, 3010, 62, 196);
INSERT INTO public.who_global_data VALUES (14566, 745, 180089, 65, 2542, 62, 105);
INSERT INTO public.who_global_data VALUES (14567, 735, 87984, 12, 1518, 62, 122);
INSERT INTO public.who_global_data VALUES (14568, 0, 0, 0, 0, 62, 159);
INSERT INTO public.who_global_data VALUES (14569, 560, 42294, 14, 1077, 62, 75);
INSERT INTO public.who_global_data VALUES (14570, 247, 144164, 3, 889, 62, 27);
INSERT INTO public.who_global_data VALUES (14571, 328, 75102, 5, 1295, 62, 54);
INSERT INTO public.who_global_data VALUES (14572, 0, 39, 0, 0, 62, 226);
INSERT INTO public.who_global_data VALUES (14573, 794, 20787, 11, 253, 62, 79);
INSERT INTO public.who_global_data VALUES (14574, 1622, 135876, 12, 1090, 62, 56);
INSERT INTO public.who_global_data VALUES (14575, 0, 2137, 0, 44, 62, 117);
INSERT INTO public.who_global_data VALUES (14576, 13, 1676, 0, 83, 62, 152);
INSERT INTO public.who_global_data VALUES (14577, 0, 85529, 0, 1219, 62, 16);
INSERT INTO public.who_global_data VALUES (14578, 13, 1431, 1, 18, 62, 10);
INSERT INTO public.who_global_data VALUES (14579, 2217, 74647, 24, 791, 62, 201);
INSERT INTO public.who_global_data VALUES (14580, 588, 37017, 6, 345, 62, 174);
INSERT INTO public.who_global_data VALUES (14581, 132, 17473, 4, 255, 62, 119);
INSERT INTO public.who_global_data VALUES (14582, 2, 6049, 0, 185, 62, 168);
INSERT INTO public.who_global_data VALUES (14583, 1123, 71359, 4, 380, 62, 99);
INSERT INTO public.who_global_data VALUES (14584, 16, 13159, 0, 47, 62, 171);
INSERT INTO public.who_global_data VALUES (14585, 124, 5062, 0, 163, 62, 87);
INSERT INTO public.who_global_data VALUES (14586, 103, 10423, 0, 149, 62, 123);
INSERT INTO public.who_global_data VALUES (14587, 0, 4, 0, 0, 62, 151);
INSERT INTO public.who_global_data VALUES (14588, 0, 5520, 0, 41, 62, 213);
INSERT INTO public.who_global_data VALUES (14589, 0, 8424, 0, 172, 62, 118);
INSERT INTO public.who_global_data VALUES (14590, 0, 505, 0, 10, 62, 134);
INSERT INTO public.who_global_data VALUES (14591, 0, 5181, 0, 49, 62, 65);
INSERT INTO public.who_global_data VALUES (14592, 12127, 1156770, 690, 108863, 62, 102);
INSERT INTO public.who_global_data VALUES (14593, 0, 0, 0, 0, 62, 223);
INSERT INTO public.who_global_data VALUES (14594, 7, 640, 0, 3, 62, 4);
INSERT INTO public.who_global_data VALUES (14595, 11, 842, 0, 0, 62, 146);
INSERT INTO public.who_global_data VALUES (14596, 289, 38547, 3, 532, 62, 31);
INSERT INTO public.who_global_data VALUES (14597, 0, 13, 0, 1, 62, 127);
INSERT INTO public.who_global_data VALUES (14598, 4118, 376738, 48, 6184, 62, 22);
INSERT INTO public.who_global_data VALUES (14599, 95, 16133, 0, 133, 62, 115);
INSERT INTO public.who_global_data VALUES (14600, 1502, 96520, 31, 2059, 62, 106);
INSERT INTO public.who_global_data VALUES (14601, 170, 14950, 0, 153, 62, 90);
INSERT INTO public.who_global_data VALUES (14602, 0, 0, 0, 0, 62, 70);
INSERT INTO public.who_global_data VALUES (14603, 1024, 239885, 10, 1577, 62, 46);
INSERT INTO public.who_global_data VALUES (14604, 6531, 549255, 39, 9636, 62, 139);
INSERT INTO public.who_global_data VALUES (14605, 0, 35, 0, 0, 62, 42);
INSERT INTO public.who_global_data VALUES (14606, 0, 1722, 0, 25, 62, 80);
INSERT INTO public.who_global_data VALUES (14607, 0, 4671, 0, 161, 62, 203);
INSERT INTO public.who_global_data VALUES (14608, 149, 1789, 1, 77, 62, 136);
INSERT INTO public.who_global_data VALUES (14609, 310, 68937, 1, 1180, 62, 63);
INSERT INTO public.who_global_data VALUES (14610, 0, 0, 0, 0, 62, 17);
INSERT INTO public.who_global_data VALUES (14611, 3, 109, 0, 2, 62, 172);
INSERT INTO public.who_global_data VALUES (14612, 981, 67311, 24, 1901, 62, 109);
INSERT INTO public.who_global_data VALUES (14613, 0, 37371, 0, 354, 62, 200);
INSERT INTO public.who_global_data VALUES (14614, 1422, 109702, 15, 905, 62, 93);
INSERT INTO public.who_global_data VALUES (14615, 0, 124329, 0, 1435, 62, 5);
INSERT INTO public.who_global_data VALUES (14616, 0, 741, 0, 13, 62, 214);
INSERT INTO public.who_global_data VALUES (14617, 3119, 413191, 43, 8303, 62, 204);
INSERT INTO public.who_global_data VALUES (14618, 0, 0, 0, 0, 62, 198);
INSERT INTO public.who_global_data VALUES (14619, 2388, 173607, 13, 3154, 62, 173);
INSERT INTO public.who_global_data VALUES (14620, 0, 671, 0, 7, 62, 229);
INSERT INTO public.who_global_data VALUES (14621, 1022, 86499, 17, 1813, 62, 76);
INSERT INTO public.who_global_data VALUES (14622, 2014, 970860, 91, 36195, 62, 138);
INSERT INTO public.who_global_data VALUES (14623, 1724, 438069, 17, 8526, 62, 98);
INSERT INTO public.who_global_data VALUES (14624, 0, 0, 0, 0, 62, 103);
INSERT INTO public.who_global_data VALUES (14625, 12427, 1054273, 502, 19861, 62, 225);
INSERT INTO public.who_global_data VALUES (14626, 6087, 318640, 73, 4876, 62, 131);
INSERT INTO public.who_global_data VALUES (14627, 935, 55532, 12, 1185, 62, 235);
INSERT INTO public.who_global_data VALUES (14628, 140, 139783, 0, 239, 62, 137);
INSERT INTO public.who_global_data VALUES (14629, 631, 37537, 5, 545, 62, 81);
INSERT INTO public.who_global_data VALUES (14630, 1728, 115557, 19, 2403, 62, 182);
INSERT INTO public.who_global_data VALUES (14631, 0, 8200, 0, 41, 62, 145);
INSERT INTO public.who_global_data VALUES (14632, 8072, 508345, 134, 12186, 62, 26);
INSERT INTO public.who_global_data VALUES (14633, 29039, 2460770, 457, 43141, 62, 170);
INSERT INTO public.who_global_data VALUES (14634, 41, 6084, 0, 51, 62, 191);
INSERT INTO public.who_global_data VALUES (14635, 0, 5, 0, 0, 62, 221);
INSERT INTO public.who_global_data VALUES (14636, 0, 152, 0, 0, 62, 64);
INSERT INTO public.who_global_data VALUES (14637, 0, 0, 0, 0, 62, 116);
INSERT INTO public.who_global_data VALUES (14638, 0, 22, 0, 0, 62, 128);
INSERT INTO public.who_global_data VALUES (14639, 3, 265, 0, 2, 62, 6);
INSERT INTO public.who_global_data VALUES (14640, 0, 744, 0, 12, 62, 227);
INSERT INTO public.who_global_data VALUES (14641, 0, 14, 0, 0, 62, 68);
INSERT INTO public.who_global_data VALUES (14642, 0, 87, 0, 0, 62, 184);
INSERT INTO public.who_global_data VALUES (14643, 0, 2, 0, 0, 62, 82);
INSERT INTO public.who_global_data VALUES (14644, 33, 1789, 1, 48, 62, 149);
INSERT INTO public.who_global_data VALUES (14645, 0, 999, 0, 17, 62, 197);
INSERT INTO public.who_global_data VALUES (14646, 190, 358526, 14, 5954, 62, 78);
INSERT INTO public.who_global_data VALUES (14647, 100, 16397, 1, 337, 62, 233);
INSERT INTO public.who_global_data VALUES (14648, 6903, 213843, 57, 1891, 62, 133);
INSERT INTO public.who_global_data VALUES (14649, 0, 182, 0, 0, 62, 35);
INSERT INTO public.who_global_data VALUES (14650, 0, 2420, 0, 74, 62, 114);
INSERT INTO public.who_global_data VALUES (14651, 13, 58255, 0, 29, 62, 237);
INSERT INTO public.who_global_data VALUES (14652, 0, 14, 0, 0, 62, 55);
INSERT INTO public.who_global_data VALUES (14653, 0, 1105, 0, 25, 62, 176);
INSERT INTO public.who_global_data VALUES (14654, 2070, 118026, 24, 1001, 62, 202);
INSERT INTO public.who_global_data VALUES (14655, 1033, 85851, 49, 1909, 62, 155);
INSERT INTO public.who_global_data VALUES (14656, 0, 17, 0, 0, 62, 32);
INSERT INTO public.who_global_data VALUES (14657, 0, 4525, 0, 121, 62, 220);
INSERT INTO public.who_global_data VALUES (14658, 4645, 810449, 104, 22067, 62, 30);
INSERT INTO public.who_global_data VALUES (14659, 12, 3166, -1, 61, 62, 147);
INSERT INTO public.who_global_data VALUES (14660, 8557, 1753633, 197, 47948, 62, 208);
INSERT INTO public.who_global_data VALUES (14661, 1190, 27228, 8, 137, 62, 45);
INSERT INTO public.who_global_data VALUES (14662, 279, 19747, 6, 1301, 62, 110);
INSERT INTO public.who_global_data VALUES (14663, 0, 5322, 0, 117, 62, 88);
INSERT INTO public.who_global_data VALUES (14664, 7338, 287730, 70, 7549, 62, 51);
INSERT INTO public.who_global_data VALUES (14665, 2518, 352288, 94, 5185, 62, 209);
INSERT INTO public.who_global_data VALUES (14666, 87, 8320, 5, 442, 62, 205);
INSERT INTO public.who_global_data VALUES (14667, 40, 12389, 0, 87, 62, 18);
INSERT INTO public.who_global_data VALUES (14668, 19, 4072, 0, 60, 62, 72);
INSERT INTO public.who_global_data VALUES (14669, 15539, 1705975, 397, 61014, 62, 44);
INSERT INTO public.who_global_data VALUES (14670, 0, 31, 0, 0, 62, 15);
INSERT INTO public.who_global_data VALUES (14671, 0, 3051, 0, 65, 62, 25);
INSERT INTO public.who_global_data VALUES (14672, 0, 0, 0, 0, 62, 179);
INSERT INTO public.who_global_data VALUES (14673, 0, 0, 0, 0, 62, 34);
INSERT INTO public.who_global_data VALUES (14674, 10, 6735, 0, 121, 62, 207);
INSERT INTO public.who_global_data VALUES (14675, 1091, 102991, 45, 3526, 62, 166);
INSERT INTO public.who_global_data VALUES (14676, 31896, 1590694, 196, 14705, 62, 126);
INSERT INTO public.who_global_data VALUES (14677, 0, 0, 0, 0, 62, 97);
INSERT INTO public.who_global_data VALUES (14678, 4, 755, 0, 6, 62, 36);
INSERT INTO public.who_global_data VALUES (14679, 0, 0, 0, 0, 62, 125);
INSERT INTO public.who_global_data VALUES (14680, 290, 22188, 0, 206, 62, 124);
INSERT INTO public.who_global_data VALUES (14681, 11590, 813306, 167, 13588, 62, 185);
INSERT INTO public.who_global_data VALUES (14682, 1214, 175276, 3, 589, 62, 194);
INSERT INTO public.who_global_data VALUES (14683, 0, 509, 0, 21, 62, 144);
INSERT INTO public.who_global_data VALUES (14684, 213127, 14191298, 2426, 276503, 62, 19);
INSERT INTO public.who_global_data VALUES (14685, 20, 1633, 0, 23, 62, 217);
INSERT INTO public.who_global_data VALUES (14686, 276, 6731, 0, 80, 62, 148);
INSERT INTO public.who_global_data VALUES (14687, 153, 73904, 0, 611, 62, 86);
INSERT INTO public.who_global_data VALUES (14688, 0, 1, 0, 0, 62, 13);
INSERT INTO public.who_global_data VALUES (14689, 329, 103877, 4, 913, 62, 157);
INSERT INTO public.who_global_data VALUES (14690, 4, 1365, 0, 35, 62, 8);
INSERT INTO public.who_global_data VALUES (14691, 0, 3, 0, 0, 62, 73);
INSERT INTO public.who_global_data VALUES (14692, 0, 2081, 0, 607, 62, 101);
INSERT INTO public.who_global_data VALUES (14693, 41, 17898, 0, 364, 62, 165);
INSERT INTO public.who_global_data VALUES (14694, 70, 10617, 10, 291, 62, 14);
INSERT INTO public.who_global_data VALUES (14695, 130, 47388, 6, 1847, 63, 193);
INSERT INTO public.who_global_data VALUES (14696, 801, 41302, 18, 870, 63, 113);
INSERT INTO public.who_global_data VALUES (14697, 803, 86730, 12, 2492, 63, 143);
INSERT INTO public.who_global_data VALUES (14698, 0, 0, 0, 0, 63, 219);
INSERT INTO public.who_global_data VALUES (14699, 51, 6955, 0, 77, 63, 186);
INSERT INTO public.who_global_data VALUES (14700, 132, 15493, 1, 353, 63, 52);
INSERT INTO public.who_global_data VALUES (14701, 1, 7, 0, 0, 63, 180);
INSERT INTO public.who_global_data VALUES (14702, 0, 144, 0, 4, 63, 167);
INSERT INTO public.who_global_data VALUES (14703, 7629, 1447732, 149, 39305, 63, 154);
INSERT INTO public.who_global_data VALUES (14704, 1267, 140272, 32, 2304, 63, 94);
INSERT INTO public.who_global_data VALUES (14705, 21, 4923, 0, 45, 63, 66);
INSERT INTO public.who_global_data VALUES (14706, 10, 27949, 0, 908, 63, 58);
INSERT INTO public.who_global_data VALUES (14707, 3634, 295071, 140, 3587, 63, 163);
INSERT INTO public.who_global_data VALUES (14708, 4267, 138000, 41, 1551, 63, 37);
INSERT INTO public.who_global_data VALUES (14709, 16, 7565, 0, 163, 63, 142);
INSERT INTO public.who_global_data VALUES (14710, 167, 87599, 0, 341, 63, 83);
INSERT INTO public.who_global_data VALUES (14711, 2252, 473991, 24, 6772, 63, 228);
INSERT INTO public.who_global_data VALUES (14712, 2, 281, 0, 7, 63, 188);
INSERT INTO public.who_global_data VALUES (14713, 1774, 143383, 9, 1190, 63, 62);
INSERT INTO public.who_global_data VALUES (14714, 2567, 591562, 109, 17267, 63, 160);
INSERT INTO public.who_global_data VALUES (14715, 241, 7236, 4, 164, 63, 50);
INSERT INTO public.who_global_data VALUES (14716, 0, 3055, 0, 44, 63, 33);
INSERT INTO public.who_global_data VALUES (14717, 6, 278, 0, 9, 63, 183);
INSERT INTO public.who_global_data VALUES (14718, 6, 424, 0, 0, 63, 92);
INSERT INTO public.who_global_data VALUES (14719, 192, 145186, 10, 8982, 63, 158);
INSERT INTO public.who_global_data VALUES (14720, 0, 145, 0, 3, 63, 67);
INSERT INTO public.who_global_data VALUES (14721, 1254, 92793, 53, 2865, 63, 57);
INSERT INTO public.who_global_data VALUES (14722, 0, 9992, 0, 31, 63, 38);
INSERT INTO public.who_global_data VALUES (14723, 50434, 6487084, 755, 175270, 63, 141);
INSERT INTO public.who_global_data VALUES (14724, 0, 73, 0, 1, 63, 178);
INSERT INTO public.who_global_data VALUES (14725, 0, 151, 0, 3, 63, 108);
INSERT INTO public.who_global_data VALUES (14726, 3614, 158807, 147, 4650, 63, 39);
INSERT INTO public.who_global_data VALUES (14727, 29, 3091, 0, 68, 63, 2);
INSERT INTO public.who_global_data VALUES (14728, 2, 694, 0, 1, 63, 195);
INSERT INTO public.who_global_data VALUES (14729, 0, 10626, 0, 105, 63, 107);
INSERT INTO public.who_global_data VALUES (14730, 10, 345, 0, 0, 63, 161);
INSERT INTO public.who_global_data VALUES (14731, 0, 24752, 0, 443, 63, 212);
INSERT INTO public.who_global_data VALUES (14732, 6495, 396270, 82, 12407, 63, 181);
INSERT INTO public.who_global_data VALUES (14733, 3, 288, 0, 2, 63, 53);
INSERT INTO public.who_global_data VALUES (14734, 4, 4922, 0, 63, 63, 164);
INSERT INTO public.who_global_data VALUES (14735, 11, 1719, 0, 102, 63, 140);
INSERT INTO public.who_global_data VALUES (14736, 1729, 557135, 39, 15558, 63, 20);
INSERT INTO public.who_global_data VALUES (14737, 133, 94038, 1, 4753, 63, 112);
INSERT INTO public.who_global_data VALUES (14738, 9233, 1343322, 188, 37305, 63, 111);
INSERT INTO public.who_global_data VALUES (14739, 0, 615, 0, 7, 63, 71);
INSERT INTO public.who_global_data VALUES (14740, 0, 5774, 0, 94, 63, 218);
INSERT INTO public.who_global_data VALUES (14741, 0, 0, 0, 0, 63, 43);
INSERT INTO public.who_global_data VALUES (14742, 1165, 142505, 18, 1757, 63, 49);
INSERT INTO public.who_global_data VALUES (14743, 23, 21412, 0, 132, 63, 1);
INSERT INTO public.who_global_data VALUES (14744, 3955, 143370, 68, 2032, 63, 48);
INSERT INTO public.who_global_data VALUES (14745, 79, 8610, 0, 136, 63, 232);
INSERT INTO public.who_global_data VALUES (14746, 82, 2740, 0, 7, 63, 175);
INSERT INTO public.who_global_data VALUES (14747, 289, 11812, 3, 57, 63, 21);
INSERT INTO public.who_global_data VALUES (14748, 4743, 542406, 97, 8738, 63, 156);
INSERT INTO public.who_global_data VALUES (14749, 0, 0, 0, 0, 63, 95);
INSERT INTO public.who_global_data VALUES (14750, 149, 13280, 0, 337, 63, 177);
INSERT INTO public.who_global_data VALUES (14751, 1603, 86743, 9, 867, 63, 210);
INSERT INTO public.who_global_data VALUES (14752, 1, 5690, 0, 61, 63, 120);
INSERT INTO public.who_global_data VALUES (14753, 0, 85, 0, 0, 63, 135);
INSERT INTO public.who_global_data VALUES (14754, 671, 146680, 8, 2343, 63, 206);
INSERT INTO public.who_global_data VALUES (14755, 0, 195884, 0, 13612, 63, 189);
INSERT INTO public.who_global_data VALUES (14756, 427, 117583, 19, 6732, 63, 129);
INSERT INTO public.who_global_data VALUES (14757, 588, 39718, 8, 1142, 63, 121);
INSERT INTO public.who_global_data VALUES (14758, 0, 5159, 0, 85, 63, 59);
INSERT INTO public.who_global_data VALUES (14759, 38, 632, 0, 0, 63, 96);
INSERT INTO public.who_global_data VALUES (14760, 470, 13939, 2, 125, 63, 41);
INSERT INTO public.who_global_data VALUES (14761, 6, 6480, 0, 122, 63, 216);
INSERT INTO public.who_global_data VALUES (14762, 512, 112091, 10, 1734, 63, 236);
INSERT INTO public.who_global_data VALUES (14763, 0, 17, 0, 0, 63, 150);
INSERT INTO public.who_global_data VALUES (14764, 0, 505, 0, 0, 63, 61);
INSERT INTO public.who_global_data VALUES (14765, 0, 44, 0, 2, 63, 7);
INSERT INTO public.who_global_data VALUES (14766, 316, 26758, 7, 415, 63, 169);
INSERT INTO public.who_global_data VALUES (14767, 11107, 2228980, 625, 54404, 63, 28);
INSERT INTO public.who_global_data VALUES (14768, 16, 11334, 1, 71, 63, 85);
INSERT INTO public.who_global_data VALUES (14769, 210, 15107, 1, 79, 63, 211);
INSERT INTO public.who_global_data VALUES (14770, 15, 9254, 0, 60, 63, 60);
INSERT INTO public.who_global_data VALUES (14771, 1, 3768, 0, 123, 63, 3);
INSERT INTO public.who_global_data VALUES (14772, 5450, 158154, 37, 1462, 63, 11);
INSERT INTO public.who_global_data VALUES (14773, 23318, 1153555, 483, 18517, 63, 89);
INSERT INTO public.who_global_data VALUES (14774, 429, 52096, 2, 325, 63, 24);
INSERT INTO public.who_global_data VALUES (14775, 3, 1038, 0, 5, 63, 162);
INSERT INTO public.who_global_data VALUES (14776, 1648, 113185, 98, 2804, 63, 100);
INSERT INTO public.who_global_data VALUES (14777, 0, 18, 0, 0, 63, 47);
INSERT INTO public.who_global_data VALUES (14778, 0, 41, 0, 0, 63, 29);
INSERT INTO public.who_global_data VALUES (14779, 0, 8427, 0, 149, 63, 40);
INSERT INTO public.who_global_data VALUES (14780, 25, 6827, 1, 113, 63, 222);
INSERT INTO public.who_global_data VALUES (14781, 752, 124805, 15, 4224, 63, 132);
INSERT INTO public.who_global_data VALUES (14782, 1, 288, 0, 13, 63, 130);
INSERT INTO public.who_global_data VALUES (14783, 19, 13186, 0, 76, 63, 234);
INSERT INTO public.who_global_data VALUES (14784, 0, 2425, 0, 44, 63, 23);
INSERT INTO public.who_global_data VALUES (14785, 79, 5528, 0, 151, 63, 192);
INSERT INTO public.who_global_data VALUES (14786, 34, 9347, 0, 233, 63, 69);
INSERT INTO public.who_global_data VALUES (14787, 0, 26, 0, 0, 63, 187);
INSERT INTO public.who_global_data VALUES (14788, 616, 109760, 8, 2938, 63, 230);
INSERT INTO public.who_global_data VALUES (14789, 5525, 243581, 193, 5706, 63, 77);
INSERT INTO public.who_global_data VALUES (14790, 14, 5462, 0, 27, 63, 9);
INSERT INTO public.who_global_data VALUES (14791, 36652, 9608211, 512, 139700, 63, 74);
INSERT INTO public.who_global_data VALUES (14792, 5803, 563680, 124, 17479, 63, 224);
INSERT INTO public.who_global_data VALUES (14793, 13341, 1016835, 347, 49695, 63, 199);
INSERT INTO public.who_global_data VALUES (14794, 1855, 560622, 26, 12387, 63, 190);
INSERT INTO public.who_global_data VALUES (14795, 263, 73491, 6, 2086, 63, 12);
INSERT INTO public.who_global_data VALUES (14796, 0, 369, 0, 25, 63, 104);
INSERT INTO public.who_global_data VALUES (14797, 1451, 341433, 10, 2903, 63, 153);
INSERT INTO public.who_global_data VALUES (14798, 24110, 1688939, 814, 58852, 63, 91);
INSERT INTO public.who_global_data VALUES (14799, 76, 10987, 1, 260, 63, 215);
INSERT INTO public.who_global_data VALUES (14800, 2442, 157674, 43, 2283, 63, 84);
INSERT INTO public.who_global_data VALUES (14801, 130, 1170, 0, 32, 63, 231);
INSERT INTO public.who_global_data VALUES (14802, 3116, 234353, 51, 2960, 63, 196);
INSERT INTO public.who_global_data VALUES (14803, 966, 179344, 0, 2477, 63, 105);
INSERT INTO public.who_global_data VALUES (14804, 866, 87249, 6, 1506, 63, 122);
INSERT INTO public.who_global_data VALUES (14805, 0, 0, 0, 0, 63, 159);
INSERT INTO public.who_global_data VALUES (14806, 478, 41734, 11, 1063, 63, 75);
INSERT INTO public.who_global_data VALUES (14807, 343, 143917, 2, 886, 63, 27);
INSERT INTO public.who_global_data VALUES (14808, 401, 74774, 5, 1290, 63, 54);
INSERT INTO public.who_global_data VALUES (14809, 0, 39, 0, 0, 63, 226);
INSERT INTO public.who_global_data VALUES (14810, 686, 19993, 7, 242, 63, 79);
INSERT INTO public.who_global_data VALUES (14811, 1478, 134254, 11, 1078, 63, 56);
INSERT INTO public.who_global_data VALUES (14812, 0, 2137, 0, 44, 63, 117);
INSERT INTO public.who_global_data VALUES (14813, 65, 1663, 0, 83, 63, 152);
INSERT INTO public.who_global_data VALUES (14814, 680, 85529, 7, 1219, 63, 16);
INSERT INTO public.who_global_data VALUES (14815, 17, 1418, 0, 17, 63, 10);
INSERT INTO public.who_global_data VALUES (14816, 2849, 72430, 34, 767, 63, 201);
INSERT INTO public.who_global_data VALUES (14817, 627, 36429, 5, 339, 63, 174);
INSERT INTO public.who_global_data VALUES (14818, 0, 17341, 0, 251, 63, 119);
INSERT INTO public.who_global_data VALUES (14819, 4, 6047, 0, 185, 63, 168);
INSERT INTO public.who_global_data VALUES (14820, 1141, 70236, 0, 376, 63, 99);
INSERT INTO public.who_global_data VALUES (14821, 37, 13143, 0, 47, 63, 171);
INSERT INTO public.who_global_data VALUES (14822, 58, 4938, 1, 163, 63, 87);
INSERT INTO public.who_global_data VALUES (14823, 123, 10320, 1, 149, 63, 123);
INSERT INTO public.who_global_data VALUES (14824, 0, 4, 0, 0, 63, 151);
INSERT INTO public.who_global_data VALUES (14825, 0, 5520, 0, 41, 63, 213);
INSERT INTO public.who_global_data VALUES (14826, 0, 8424, 0, 172, 63, 118);
INSERT INTO public.who_global_data VALUES (14827, 0, 505, 0, 10, 63, 134);
INSERT INTO public.who_global_data VALUES (14828, 0, 5181, 0, 49, 63, 65);
INSERT INTO public.who_global_data VALUES (14829, 11030, 1144643, 608, 108173, 63, 102);
INSERT INTO public.who_global_data VALUES (14830, 0, 0, 0, 0, 63, 223);
INSERT INTO public.who_global_data VALUES (14831, 0, 633, 0, 3, 63, 4);
INSERT INTO public.who_global_data VALUES (14832, 12, 831, 0, 0, 63, 146);
INSERT INTO public.who_global_data VALUES (14833, 396, 38258, 8, 529, 63, 31);
INSERT INTO public.who_global_data VALUES (14834, 0, 13, 0, 1, 63, 127);
INSERT INTO public.who_global_data VALUES (14835, 3996, 372620, 73, 6136, 63, 22);
INSERT INTO public.who_global_data VALUES (14836, 120, 16038, 1, 133, 63, 115);
INSERT INTO public.who_global_data VALUES (14837, 1418, 95018, 30, 2028, 63, 106);
INSERT INTO public.who_global_data VALUES (14838, 181, 14780, 1, 153, 63, 90);
INSERT INTO public.who_global_data VALUES (14839, 0, 0, 0, 0, 63, 70);
INSERT INTO public.who_global_data VALUES (14840, 1272, 238861, 16, 1567, 63, 46);
INSERT INTO public.who_global_data VALUES (14841, 5893, 542724, 57, 9597, 63, 139);
INSERT INTO public.who_global_data VALUES (14842, 1, 35, 0, 0, 63, 42);
INSERT INTO public.who_global_data VALUES (14843, 9, 1722, 0, 25, 63, 80);
INSERT INTO public.who_global_data VALUES (14844, 0, 4671, 0, 161, 63, 203);
INSERT INTO public.who_global_data VALUES (14845, 0, 1640, 0, 76, 63, 136);
INSERT INTO public.who_global_data VALUES (14846, 324, 68627, 0, 1179, 63, 63);
INSERT INTO public.who_global_data VALUES (14847, 0, 0, 0, 0, 63, 17);
INSERT INTO public.who_global_data VALUES (14848, 0, 106, 0, 2, 63, 172);
INSERT INTO public.who_global_data VALUES (14849, 1099, 66330, 30, 1877, 63, 109);
INSERT INTO public.who_global_data VALUES (14850, 403, 37371, 1, 354, 63, 200);
INSERT INTO public.who_global_data VALUES (14851, 1968, 108280, 17, 890, 63, 93);
INSERT INTO public.who_global_data VALUES (14852, 0, 124329, 0, 1435, 63, 5);
INSERT INTO public.who_global_data VALUES (14853, 0, 741, 0, 13, 63, 214);
INSERT INTO public.who_global_data VALUES (14854, 3262, 410072, 55, 8260, 63, 204);
INSERT INTO public.who_global_data VALUES (14855, 0, 0, 0, 0, 63, 198);
INSERT INTO public.who_global_data VALUES (14856, 1880, 171219, 27, 3141, 63, 173);
INSERT INTO public.who_global_data VALUES (14857, 0, 671, 0, 7, 63, 229);
INSERT INTO public.who_global_data VALUES (14858, 995, 85477, 13, 1796, 63, 76);
INSERT INTO public.who_global_data VALUES (14859, 1771, 968846, 28, 36104, 63, 138);
INSERT INTO public.who_global_data VALUES (14860, 932, 436345, 63, 8509, 63, 98);
INSERT INTO public.who_global_data VALUES (14861, 0, 0, 0, 0, 63, 103);
INSERT INTO public.who_global_data VALUES (14862, 13236, 1041846, 531, 19359, 63, 225);
INSERT INTO public.who_global_data VALUES (14863, 4935, 312553, 79, 4803, 63, 131);
INSERT INTO public.who_global_data VALUES (14864, 492, 54597, 18, 1173, 63, 235);
INSERT INTO public.who_global_data VALUES (14865, 166, 139643, 0, 239, 63, 137);
INSERT INTO public.who_global_data VALUES (14866, 577, 36906, 4, 540, 63, 81);
INSERT INTO public.who_global_data VALUES (14867, 1522, 113829, 21, 2384, 63, 182);
INSERT INTO public.who_global_data VALUES (14868, 98, 8200, 1, 41, 63, 145);
INSERT INTO public.who_global_data VALUES (14869, 8062, 500273, 176, 12052, 63, 26);
INSERT INTO public.who_global_data VALUES (14870, 28782, 2431731, 508, 42684, 63, 170);
INSERT INTO public.who_global_data VALUES (14871, 32, 6043, 1, 51, 63, 191);
INSERT INTO public.who_global_data VALUES (14872, 0, 5, 0, 0, 63, 221);
INSERT INTO public.who_global_data VALUES (14873, 0, 152, 0, 0, 63, 64);
INSERT INTO public.who_global_data VALUES (14874, 0, 0, 0, 0, 63, 116);
INSERT INTO public.who_global_data VALUES (14875, 0, 22, 0, 0, 63, 128);
INSERT INTO public.who_global_data VALUES (14876, 0, 262, 0, 2, 63, 6);
INSERT INTO public.who_global_data VALUES (14877, 0, 744, 0, 12, 63, 227);
INSERT INTO public.who_global_data VALUES (14878, 0, 14, 0, 0, 63, 68);
INSERT INTO public.who_global_data VALUES (14879, 2, 87, 0, 0, 63, 184);
INSERT INTO public.who_global_data VALUES (14880, 0, 2, 0, 0, 63, 82);
INSERT INTO public.who_global_data VALUES (14881, 42, 1756, 1, 47, 63, 149);
INSERT INTO public.who_global_data VALUES (14882, 2, 999, 0, 17, 63, 197);
INSERT INTO public.who_global_data VALUES (14883, 234, 358336, 10, 5940, 63, 78);
INSERT INTO public.who_global_data VALUES (14884, 80, 16297, 1, 336, 63, 233);
INSERT INTO public.who_global_data VALUES (14885, 7782, 206940, 69, 1834, 63, 133);
INSERT INTO public.who_global_data VALUES (14886, 1, 182, 0, 0, 63, 35);
INSERT INTO public.who_global_data VALUES (14887, 4, 2420, 0, 74, 63, 114);
INSERT INTO public.who_global_data VALUES (14888, 3, 58242, 0, 29, 63, 237);
INSERT INTO public.who_global_data VALUES (14889, 0, 14, 0, 0, 63, 55);
INSERT INTO public.who_global_data VALUES (14890, 13, 1105, 0, 25, 63, 176);
INSERT INTO public.who_global_data VALUES (14891, 2184, 115956, 27, 977, 63, 202);
INSERT INTO public.who_global_data VALUES (14892, 1647, 84818, 51, 1860, 63, 155);
INSERT INTO public.who_global_data VALUES (14893, 0, 17, 0, 0, 63, 32);
INSERT INTO public.who_global_data VALUES (14894, 0, 4525, 0, 121, 63, 220);
INSERT INTO public.who_global_data VALUES (14895, 4932, 805804, 160, 21963, 63, 30);
INSERT INTO public.who_global_data VALUES (14896, 0, 3154, 0, 62, 63, 147);
INSERT INTO public.who_global_data VALUES (14897, 8249, 1745076, 186, 47751, 63, 208);
INSERT INTO public.who_global_data VALUES (14898, 628, 26038, 5, 129, 63, 45);
INSERT INTO public.who_global_data VALUES (14899, 272, 19468, 5, 1295, 63, 110);
INSERT INTO public.who_global_data VALUES (14900, 2, 5322, 0, 117, 63, 88);
INSERT INTO public.who_global_data VALUES (14901, 6986, 280392, 77, 7479, 63, 51);
INSERT INTO public.who_global_data VALUES (14902, 4554, 349770, 75, 5091, 63, 209);
INSERT INTO public.who_global_data VALUES (14903, 86, 8233, 5, 437, 63, 205);
INSERT INTO public.who_global_data VALUES (14904, 41, 12349, 0, 87, 63, 18);
INSERT INTO public.who_global_data VALUES (14905, 14, 4053, 0, 60, 63, 72);
INSERT INTO public.who_global_data VALUES (14906, 16298, 1690436, 504, 60617, 63, 44);
INSERT INTO public.who_global_data VALUES (14907, 0, 31, 0, 0, 63, 15);
INSERT INTO public.who_global_data VALUES (14908, 37, 3051, 0, 65, 63, 25);
INSERT INTO public.who_global_data VALUES (14909, 0, 0, 0, 0, 63, 179);
INSERT INTO public.who_global_data VALUES (14910, 0, 0, 0, 0, 63, 34);
INSERT INTO public.who_global_data VALUES (14911, 21, 6725, 0, 121, 63, 207);
INSERT INTO public.who_global_data VALUES (14912, 1217, 101900, 66, 3481, 63, 166);
INSERT INTO public.who_global_data VALUES (14913, 32736, 1558798, 193, 14509, 63, 126);
INSERT INTO public.who_global_data VALUES (14914, 0, 0, 0, 0, 63, 97);
INSERT INTO public.who_global_data VALUES (14915, 0, 751, 0, 6, 63, 36);
INSERT INTO public.who_global_data VALUES (14916, 0, 0, 0, 0, 63, 125);
INSERT INTO public.who_global_data VALUES (14917, 286, 21898, 0, 206, 63, 124);
INSERT INTO public.who_global_data VALUES (14918, 13825, 801716, 226, 13421, 63, 185);
INSERT INTO public.who_global_data VALUES (14919, 1311, 174062, 1, 586, 63, 194);
INSERT INTO public.who_global_data VALUES (14920, 0, 509, 0, 21, 63, 144);
INSERT INTO public.who_global_data VALUES (14921, 218671, 13978171, 2844, 274077, 63, 19);
INSERT INTO public.who_global_data VALUES (14922, 24, 1613, 0, 23, 63, 217);
INSERT INTO public.who_global_data VALUES (14923, 230, 6455, 0, 80, 63, 148);
INSERT INTO public.who_global_data VALUES (14924, 159, 73751, 0, 611, 63, 86);
INSERT INTO public.who_global_data VALUES (14925, 0, 1, 0, 0, 63, 13);
INSERT INTO public.who_global_data VALUES (14926, 481, 103548, 4, 909, 63, 157);
INSERT INTO public.who_global_data VALUES (14927, 0, 1361, 0, 35, 63, 8);
INSERT INTO public.who_global_data VALUES (14928, 0, 3, 0, 0, 63, 73);
INSERT INTO public.who_global_data VALUES (14929, 0, 2081, 0, 607, 63, 101);
INSERT INTO public.who_global_data VALUES (14930, 127, 17857, 7, 364, 63, 165);
INSERT INTO public.who_global_data VALUES (14931, 123, 10547, 1, 281, 63, 14);
INSERT INTO public.who_global_data VALUES (14932, 278, 47258, 19, 1841, 64, 193);
INSERT INTO public.who_global_data VALUES (14933, 782, 40501, 13, 852, 64, 113);
INSERT INTO public.who_global_data VALUES (14934, 843, 85927, 16, 2480, 64, 143);
INSERT INTO public.who_global_data VALUES (14935, 0, 0, 0, 0, 64, 219);
INSERT INTO public.who_global_data VALUES (14936, 62, 6904, 1, 77, 64, 186);
INSERT INTO public.who_global_data VALUES (14937, 42, 15361, 1, 352, 64, 52);
INSERT INTO public.who_global_data VALUES (14938, 0, 6, 0, 0, 64, 180);
INSERT INTO public.who_global_data VALUES (14939, 2, 144, 0, 4, 64, 167);
INSERT INTO public.who_global_data VALUES (14940, 7533, 1440103, 228, 39156, 64, 154);
INSERT INTO public.who_global_data VALUES (14941, 1184, 139005, 23, 2272, 64, 94);
INSERT INTO public.who_global_data VALUES (14942, 30, 4902, 0, 45, 64, 66);
INSERT INTO public.who_global_data VALUES (14943, 16, 27939, 0, 908, 64, 58);
INSERT INTO public.who_global_data VALUES (14944, 3783, 291437, 118, 3447, 64, 163);
INSERT INTO public.who_global_data VALUES (14945, 4189, 133733, 40, 1510, 64, 37);
INSERT INTO public.who_global_data VALUES (14946, 6, 7549, 0, 163, 64, 142);
INSERT INTO public.who_global_data VALUES (14947, 162, 87432, 0, 341, 64, 83);
INSERT INTO public.who_global_data VALUES (14948, 2316, 471739, 35, 6748, 64, 228);
INSERT INTO public.who_global_data VALUES (14949, 1, 279, 0, 7, 64, 188);
INSERT INTO public.who_global_data VALUES (14950, 1701, 141609, 7, 1181, 64, 62);
INSERT INTO public.who_global_data VALUES (14951, 2386, 588995, 94, 17158, 64, 160);
INSERT INTO public.who_global_data VALUES (14952, 1141, 6995, 12, 160, 64, 50);
INSERT INTO public.who_global_data VALUES (14953, 0, 3055, 0, 44, 64, 33);
INSERT INTO public.who_global_data VALUES (14954, 5, 272, 0, 9, 64, 183);
INSERT INTO public.who_global_data VALUES (14955, 3, 418, 0, 0, 64, 92);
INSERT INTO public.who_global_data VALUES (14956, 184, 144994, 9, 8972, 64, 158);
INSERT INTO public.who_global_data VALUES (14957, 1, 145, 0, 3, 64, 67);
INSERT INTO public.who_global_data VALUES (14958, 1161, 91539, 39, 2812, 64, 57);
INSERT INTO public.who_global_data VALUES (14959, 0, 9992, 0, 31, 64, 38);
INSERT INTO public.who_global_data VALUES (14960, 49863, 6436650, 698, 174515, 64, 141);
INSERT INTO public.who_global_data VALUES (14961, 0, 73, 0, 1, 64, 178);
INSERT INTO public.who_global_data VALUES (14962, 0, 151, 0, 3, 64, 108);
INSERT INTO public.who_global_data VALUES (14963, 3280, 155193, 156, 4503, 64, 39);
INSERT INTO public.who_global_data VALUES (14964, 52, 3062, 0, 68, 64, 2);
INSERT INTO public.who_global_data VALUES (14965, 0, 692, 0, 1, 64, 195);
INSERT INTO public.who_global_data VALUES (14966, 0, 10626, 0, 105, 64, 107);
INSERT INTO public.who_global_data VALUES (14967, 4, 335, 0, 0, 64, 161);
INSERT INTO public.who_global_data VALUES (14968, 265, 24752, 2, 443, 64, 212);
INSERT INTO public.who_global_data VALUES (14969, 6307, 389775, 114, 12325, 64, 181);
INSERT INTO public.who_global_data VALUES (14970, 0, 285, 0, 2, 64, 53);
INSERT INTO public.who_global_data VALUES (14971, 0, 4918, 0, 63, 64, 164);
INSERT INTO public.who_global_data VALUES (14972, 3, 1708, 0, 102, 64, 140);
INSERT INTO public.who_global_data VALUES (14973, 1508, 555406, 81, 15519, 64, 20);
INSERT INTO public.who_global_data VALUES (14974, 108, 93905, 1, 4752, 64, 112);
INSERT INTO public.who_global_data VALUES (14975, 9297, 1334089, 183, 37117, 64, 111);
INSERT INTO public.who_global_data VALUES (14976, 2, 615, 0, 7, 64, 71);
INSERT INTO public.who_global_data VALUES (14977, 0, 5774, 0, 94, 64, 218);
INSERT INTO public.who_global_data VALUES (14978, 0, 0, 0, 0, 64, 43);
INSERT INTO public.who_global_data VALUES (14979, 1168, 141340, 8, 1739, 64, 49);
INSERT INTO public.who_global_data VALUES (14980, 28, 21389, 0, 132, 64, 1);
INSERT INTO public.who_global_data VALUES (14981, 4534, 139415, 48, 1964, 64, 48);
INSERT INTO public.who_global_data VALUES (14982, 75, 8531, 0, 136, 64, 232);
INSERT INTO public.who_global_data VALUES (14983, 155, 2658, 0, 7, 64, 175);
INSERT INTO public.who_global_data VALUES (14984, 348, 11523, 2, 54, 64, 21);
INSERT INTO public.who_global_data VALUES (14985, 4621, 537663, 126, 8641, 64, 156);
INSERT INTO public.who_global_data VALUES (14986, 0, 0, 0, 0, 64, 95);
INSERT INTO public.who_global_data VALUES (14987, 145, 13131, 1, 337, 64, 177);
INSERT INTO public.who_global_data VALUES (14988, 1605, 85140, 6, 858, 64, 210);
INSERT INTO public.who_global_data VALUES (14989, 7, 5689, 0, 61, 64, 120);
INSERT INTO public.who_global_data VALUES (14990, 0, 85, 0, 0, 64, 135);
INSERT INTO public.who_global_data VALUES (14991, 812, 146009, 1, 2335, 64, 206);
INSERT INTO public.who_global_data VALUES (14992, 1008, 195884, 50, 13612, 64, 189);
INSERT INTO public.who_global_data VALUES (14993, 432, 117156, 19, 6713, 64, 129);
INSERT INTO public.who_global_data VALUES (14994, 0, 39130, 5, 1134, 64, 121);
INSERT INTO public.who_global_data VALUES (14995, 3, 5159, 0, 85, 64, 59);
INSERT INTO public.who_global_data VALUES (14996, 17, 594, 0, 0, 64, 96);
INSERT INTO public.who_global_data VALUES (14997, 450, 13469, 1, 123, 64, 41);
INSERT INTO public.who_global_data VALUES (14998, 19, 6474, 0, 122, 64, 216);
INSERT INTO public.who_global_data VALUES (14999, 595, 111579, 9, 1724, 64, 236);
INSERT INTO public.who_global_data VALUES (15000, 0, 17, 0, 0, 64, 150);
INSERT INTO public.who_global_data VALUES (15001, 2, 505, 0, 0, 64, 61);
INSERT INTO public.who_global_data VALUES (15002, 2, 44, 0, 2, 64, 7);
INSERT INTO public.who_global_data VALUES (15003, 560, 26442, 0, 408, 64, 169);
INSERT INTO public.who_global_data VALUES (15004, 12661, 2217873, 324, 53779, 64, 28);
INSERT INTO public.who_global_data VALUES (15005, 35, 11318, 0, 70, 64, 85);
INSERT INTO public.who_global_data VALUES (15006, 181, 14897, 1, 78, 64, 211);
INSERT INTO public.who_global_data VALUES (15007, 0, 9239, 0, 60, 64, 60);
INSERT INTO public.who_global_data VALUES (15008, 3, 3767, 0, 123, 64, 3);
INSERT INTO public.who_global_data VALUES (15009, 5068, 152704, 38, 1425, 64, 11);
INSERT INTO public.who_global_data VALUES (15010, 23448, 1130237, 432, 18034, 64, 89);
INSERT INTO public.who_global_data VALUES (15011, 0, 51667, 0, 323, 64, 24);
INSERT INTO public.who_global_data VALUES (15012, 5, 1035, 0, 5, 64, 162);
INSERT INTO public.who_global_data VALUES (15013, 1882, 111537, 100, 2706, 64, 100);
INSERT INTO public.who_global_data VALUES (15014, 0, 18, 0, 0, 64, 47);
INSERT INTO public.who_global_data VALUES (15015, 0, 41, 0, 0, 64, 29);
INSERT INTO public.who_global_data VALUES (15016, 0, 8427, 0, 149, 64, 40);
INSERT INTO public.who_global_data VALUES (15017, 20, 6802, 0, 112, 64, 222);
INSERT INTO public.who_global_data VALUES (15018, 593, 124053, 18, 4209, 64, 132);
INSERT INTO public.who_global_data VALUES (15019, 0, 287, 0, 13, 64, 130);
INSERT INTO public.who_global_data VALUES (15020, 24, 13167, 0, 76, 64, 234);
INSERT INTO public.who_global_data VALUES (15021, 0, 2425, 0, 44, 64, 23);
INSERT INTO public.who_global_data VALUES (15022, 26, 5449, 0, 151, 64, 192);
INSERT INTO public.who_global_data VALUES (15023, 10, 9313, 0, 233, 64, 69);
INSERT INTO public.who_global_data VALUES (15024, 0, 26, 0, 0, 64, 187);
INSERT INTO public.who_global_data VALUES (15025, 503, 109144, 3, 2930, 64, 230);
INSERT INTO public.who_global_data VALUES (15026, 6212, 238056, 189, 5513, 64, 77);
INSERT INTO public.who_global_data VALUES (15027, 15, 5448, 0, 27, 64, 9);
INSERT INTO public.who_global_data VALUES (15028, 36595, 9571559, 540, 139188, 64, 74);
INSERT INTO public.who_global_data VALUES (15029, 8369, 557877, 156, 17355, 64, 224);
INSERT INTO public.who_global_data VALUES (15030, 13922, 1003494, 358, 49348, 64, 199);
INSERT INTO public.who_global_data VALUES (15031, 2039, 558767, 21, 12361, 64, 190);
INSERT INTO public.who_global_data VALUES (15032, 162, 73228, 6, 2080, 64, 12);
INSERT INTO public.who_global_data VALUES (15033, 0, 369, 0, 25, 64, 104);
INSERT INTO public.who_global_data VALUES (15034, 1588, 339982, 5, 2893, 64, 153);
INSERT INTO public.who_global_data VALUES (15035, 23219, 1664829, 993, 58038, 64, 91);
INSERT INTO public.who_global_data VALUES (15036, 47, 10911, 1, 259, 64, 215);
INSERT INTO public.who_global_data VALUES (15037, 2405, 155232, 27, 2240, 64, 84);
INSERT INTO public.who_global_data VALUES (15038, 0, 1040, 0, 32, 64, 231);
INSERT INTO public.who_global_data VALUES (15039, 4029, 231237, 55, 2909, 64, 196);
INSERT INTO public.who_global_data VALUES (15040, 992, 178378, 0, 2477, 64, 105);
INSERT INTO public.who_global_data VALUES (15041, 1253, 86383, 16, 1500, 64, 122);
INSERT INTO public.who_global_data VALUES (15042, 0, 0, 0, 0, 64, 159);
INSERT INTO public.who_global_data VALUES (15043, 627, 41256, 22, 1052, 64, 75);
INSERT INTO public.who_global_data VALUES (15044, 314, 143574, 2, 884, 64, 27);
INSERT INTO public.who_global_data VALUES (15045, 440, 74373, 4, 1285, 64, 54);
INSERT INTO public.who_global_data VALUES (15046, 0, 39, 0, 0, 64, 226);
INSERT INTO public.who_global_data VALUES (15047, 930, 19307, 11, 235, 64, 79);
INSERT INTO public.who_global_data VALUES (15048, 1520, 132776, 12, 1067, 64, 56);
INSERT INTO public.who_global_data VALUES (15049, 28, 2137, 0, 44, 64, 117);
INSERT INTO public.who_global_data VALUES (15050, 0, 1598, 0, 83, 64, 152);
INSERT INTO public.who_global_data VALUES (15051, 762, 84849, 12, 1212, 64, 16);
INSERT INTO public.who_global_data VALUES (15052, 17, 1401, 0, 17, 64, 10);
INSERT INTO public.who_global_data VALUES (15053, 2513, 69581, 38, 733, 64, 201);
INSERT INTO public.who_global_data VALUES (15054, 673, 35802, 4, 334, 64, 174);
INSERT INTO public.who_global_data VALUES (15055, 0, 17341, 0, 251, 64, 119);
INSERT INTO public.who_global_data VALUES (15056, 3, 6043, 0, 185, 64, 168);
INSERT INTO public.who_global_data VALUES (15057, 1075, 69095, 11, 376, 64, 99);
INSERT INTO public.who_global_data VALUES (15058, 36, 13106, 0, 47, 64, 171);
INSERT INTO public.who_global_data VALUES (15059, 43, 4880, 1, 162, 64, 87);
INSERT INTO public.who_global_data VALUES (15060, 96, 10197, 2, 148, 64, 123);
INSERT INTO public.who_global_data VALUES (15061, 0, 4, 0, 0, 64, 151);
INSERT INTO public.who_global_data VALUES (15062, 0, 5520, 0, 41, 64, 213);
INSERT INTO public.who_global_data VALUES (15063, 0, 8424, 0, 172, 64, 118);
INSERT INTO public.who_global_data VALUES (15064, 0, 505, 0, 10, 64, 134);
INSERT INTO public.who_global_data VALUES (15065, 0, 5181, 0, 49, 64, 65);
INSERT INTO public.who_global_data VALUES (15066, 11251, 1133613, 800, 107565, 64, 102);
INSERT INTO public.who_global_data VALUES (15067, 0, 0, 0, 0, 64, 223);
INSERT INTO public.who_global_data VALUES (15068, 9, 633, 0, 3, 64, 4);
INSERT INTO public.who_global_data VALUES (15069, 7, 819, 0, 0, 64, 146);
INSERT INTO public.who_global_data VALUES (15070, 488, 37862, 6, 521, 64, 31);
INSERT INTO public.who_global_data VALUES (15071, 0, 13, 0, 1, 64, 127);
INSERT INTO public.who_global_data VALUES (15072, 4434, 368624, 78, 6063, 64, 22);
INSERT INTO public.who_global_data VALUES (15073, 52, 15918, 0, 132, 64, 115);
INSERT INTO public.who_global_data VALUES (15074, 1411, 93600, 26, 1998, 64, 106);
INSERT INTO public.who_global_data VALUES (15075, 122, 14599, 0, 152, 64, 90);
INSERT INTO public.who_global_data VALUES (15076, 0, 0, 0, 0, 64, 70);
INSERT INTO public.who_global_data VALUES (15077, 1343, 237589, 13, 1551, 64, 46);
INSERT INTO public.who_global_data VALUES (15078, 5596, 536831, 59, 9540, 64, 139);
INSERT INTO public.who_global_data VALUES (15079, 1, 34, 0, 0, 64, 42);
INSERT INTO public.who_global_data VALUES (15080, 0, 1713, 0, 25, 64, 80);
INSERT INTO public.who_global_data VALUES (15081, 0, 4671, 0, 161, 64, 203);
INSERT INTO public.who_global_data VALUES (15082, 0, 1640, 0, 76, 64, 136);
INSERT INTO public.who_global_data VALUES (15083, 343, 68303, 2, 1179, 64, 63);
INSERT INTO public.who_global_data VALUES (15084, 0, 0, 0, 0, 64, 17);
INSERT INTO public.who_global_data VALUES (15085, 0, 106, 0, 2, 64, 172);
INSERT INTO public.who_global_data VALUES (15086, 1341, 65231, 22, 1847, 64, 109);
INSERT INTO public.who_global_data VALUES (15087, 377, 36968, 2, 353, 64, 200);
INSERT INTO public.who_global_data VALUES (15088, 2738, 106312, 19, 873, 64, 93);
INSERT INTO public.who_global_data VALUES (15089, 184, 124329, 5, 1435, 64, 5);
INSERT INTO public.who_global_data VALUES (15090, 0, 741, 0, 13, 64, 214);
INSERT INTO public.who_global_data VALUES (15091, 3499, 406810, 39, 8205, 64, 204);
INSERT INTO public.who_global_data VALUES (15092, 0, 0, 0, 0, 64, 198);
INSERT INTO public.who_global_data VALUES (15093, 2028, 169339, 16, 3114, 64, 173);
INSERT INTO public.who_global_data VALUES (15094, 2, 671, 0, 7, 64, 229);
INSERT INTO public.who_global_data VALUES (15095, 1003, 84482, 12, 1783, 64, 76);
INSERT INTO public.who_global_data VALUES (15096, 1847, 967075, 45, 36076, 64, 138);
INSERT INTO public.who_global_data VALUES (15097, 1056, 435413, 10, 8446, 64, 98);
INSERT INTO public.who_global_data VALUES (15098, 0, 0, 0, 0, 64, 103);
INSERT INTO public.who_global_data VALUES (15099, 14863, 1028610, 620, 18828, 64, 225);
INSERT INTO public.who_global_data VALUES (15100, 3772, 307618, 79, 4724, 64, 131);
INSERT INTO public.who_global_data VALUES (15101, 397, 54105, 11, 1155, 64, 235);
INSERT INTO public.who_global_data VALUES (15102, 221, 139477, 0, 239, 64, 137);
INSERT INTO public.who_global_data VALUES (15103, 628, 36329, 7, 536, 64, 81);
INSERT INTO public.who_global_data VALUES (15104, 1727, 112307, 20, 2363, 64, 182);
INSERT INTO public.who_global_data VALUES (15105, 0, 8102, 0, 40, 64, 145);
INSERT INTO public.who_global_data VALUES (15106, 7661, 492211, 211, 11876, 64, 26);
INSERT INTO public.who_global_data VALUES (15107, 27403, 2402949, 569, 42176, 64, 170);
INSERT INTO public.who_global_data VALUES (15108, 17, 6011, 0, 50, 64, 191);
INSERT INTO public.who_global_data VALUES (15109, 0, 5, 0, 0, 64, 221);
INSERT INTO public.who_global_data VALUES (15110, 0, 152, 0, 0, 64, 64);
INSERT INTO public.who_global_data VALUES (15111, 0, 0, 0, 0, 64, 116);
INSERT INTO public.who_global_data VALUES (15112, 0, 22, 0, 0, 64, 128);
INSERT INTO public.who_global_data VALUES (15113, 1, 262, 0, 2, 64, 6);
INSERT INTO public.who_global_data VALUES (15114, 0, 744, 0, 12, 64, 227);
INSERT INTO public.who_global_data VALUES (15115, 0, 14, 0, 0, 64, 68);
INSERT INTO public.who_global_data VALUES (15116, 0, 85, 0, 0, 64, 184);
INSERT INTO public.who_global_data VALUES (15117, 0, 2, 0, 0, 64, 82);
INSERT INTO public.who_global_data VALUES (15118, 27, 1714, 0, 46, 64, 149);
INSERT INTO public.who_global_data VALUES (15119, 0, 997, 0, 17, 64, 197);
INSERT INTO public.who_global_data VALUES (15120, 230, 358102, 11, 5930, 64, 78);
INSERT INTO public.who_global_data VALUES (15121, 44, 16217, 1, 335, 64, 233);
INSERT INTO public.who_global_data VALUES (15122, 7802, 199158, 61, 1765, 64, 133);
INSERT INTO public.who_global_data VALUES (15123, 0, 181, 0, 0, 64, 35);
INSERT INTO public.who_global_data VALUES (15124, 0, 2416, 0, 74, 64, 114);
INSERT INTO public.who_global_data VALUES (15125, 9, 58239, 0, 29, 64, 237);
INSERT INTO public.who_global_data VALUES (15126, 0, 14, 0, 0, 64, 55);
INSERT INTO public.who_global_data VALUES (15127, 20, 1092, 0, 25, 64, 176);
INSERT INTO public.who_global_data VALUES (15128, 1982, 113772, 32, 950, 64, 202);
INSERT INTO public.who_global_data VALUES (15129, 1786, 83171, 74, 1809, 64, 155);
INSERT INTO public.who_global_data VALUES (15130, 0, 17, 0, 0, 64, 32);
INSERT INTO public.who_global_data VALUES (15131, 0, 4525, 0, 121, 64, 220);
INSERT INTO public.who_global_data VALUES (15132, 4400, 800872, 94, 21803, 64, 30);
INSERT INTO public.who_global_data VALUES (15133, 45, 3154, 1, 62, 64, 147);
INSERT INTO public.who_global_data VALUES (15134, 9015, 1736827, 199, 47565, 64, 208);
INSERT INTO public.who_global_data VALUES (15135, 0, 25410, 0, 124, 64, 45);
INSERT INTO public.who_global_data VALUES (15136, 312, 19196, 10, 1290, 64, 110);
INSERT INTO public.who_global_data VALUES (15137, 1, 5320, 0, 117, 64, 88);
INSERT INTO public.who_global_data VALUES (15138, 6547, 273406, 71, 7402, 64, 51);
INSERT INTO public.who_global_data VALUES (15139, 4318, 345216, 78, 5016, 64, 209);
INSERT INTO public.who_global_data VALUES (15140, 88, 8147, 6, 432, 64, 205);
INSERT INTO public.who_global_data VALUES (15141, 39, 12308, 0, 87, 64, 18);
INSERT INTO public.who_global_data VALUES (15142, 13, 4039, 0, 60, 64, 72);
INSERT INTO public.who_global_data VALUES (15143, 14878, 1674138, 414, 60113, 64, 44);
INSERT INTO public.who_global_data VALUES (15144, 0, 31, 0, 0, 64, 15);
INSERT INTO public.who_global_data VALUES (15145, 0, 3014, 0, 65, 64, 25);
INSERT INTO public.who_global_data VALUES (15146, 0, 0, 0, 0, 64, 179);
INSERT INTO public.who_global_data VALUES (15147, 0, 0, 0, 0, 64, 34);
INSERT INTO public.who_global_data VALUES (15148, 19, 6704, 1, 121, 64, 207);
INSERT INTO public.who_global_data VALUES (15149, 1403, 100683, 56, 3415, 64, 166);
INSERT INTO public.who_global_data VALUES (15150, 32381, 1526062, 187, 14316, 64, 126);
INSERT INTO public.who_global_data VALUES (15151, 0, 0, 0, 0, 64, 97);
INSERT INTO public.who_global_data VALUES (15152, 1, 751, 0, 6, 64, 36);
INSERT INTO public.who_global_data VALUES (15153, 0, 0, 0, 0, 64, 125);
INSERT INTO public.who_global_data VALUES (15154, 203, 21612, 0, 206, 64, 124);
INSERT INTO public.who_global_data VALUES (15155, 15131, 787891, 235, 13195, 64, 185);
INSERT INTO public.who_global_data VALUES (15156, 1317, 172751, 5, 585, 64, 194);
INSERT INTO public.who_global_data VALUES (15157, 0, 509, 0, 21, 64, 144);
INSERT INTO public.who_global_data VALUES (15158, 195769, 13759500, 2751, 271233, 64, 19);
INSERT INTO public.who_global_data VALUES (15159, 26, 1589, 0, 23, 64, 217);
INSERT INTO public.who_global_data VALUES (15160, 201, 6225, 2, 80, 64, 148);
INSERT INTO public.who_global_data VALUES (15161, 161, 73592, 0, 611, 64, 86);
INSERT INTO public.who_global_data VALUES (15162, 0, 1, 0, 0, 64, 13);
INSERT INTO public.who_global_data VALUES (15163, 446, 103067, 4, 905, 64, 157);
INSERT INTO public.who_global_data VALUES (15164, 3, 1361, 0, 35, 64, 8);
INSERT INTO public.who_global_data VALUES (15165, 0, 3, 0, 0, 64, 73);
INSERT INTO public.who_global_data VALUES (15166, 0, 2081, 1, 607, 64, 101);
INSERT INTO public.who_global_data VALUES (15167, 30, 17730, 0, 357, 64, 165);
INSERT INTO public.who_global_data VALUES (15168, 181, 10424, 3, 280, 64, 14);
INSERT INTO public.who_global_data VALUES (15169, 263, 46980, 27, 1822, 65, 193);
INSERT INTO public.who_global_data VALUES (15170, 705, 39719, 17, 839, 65, 113);
INSERT INTO public.who_global_data VALUES (15171, 932, 85084, 17, 2464, 65, 143);
INSERT INTO public.who_global_data VALUES (15172, 0, 0, 0, 0, 65, 219);
INSERT INTO public.who_global_data VALUES (15173, 52, 6842, 0, 76, 65, 186);
INSERT INTO public.who_global_data VALUES (15174, 68, 15319, 1, 351, 65, 52);
INSERT INTO public.who_global_data VALUES (15175, 0, 6, 0, 0, 65, 180);
INSERT INTO public.who_global_data VALUES (15176, 1, 142, 0, 4, 65, 167);
INSERT INTO public.who_global_data VALUES (15177, 8037, 1432570, 198, 38928, 65, 154);
INSERT INTO public.who_global_data VALUES (15178, 1277, 137821, 26, 2249, 65, 94);
INSERT INTO public.who_global_data VALUES (15179, 27, 4872, 0, 45, 65, 66);
INSERT INTO public.who_global_data VALUES (15180, 11, 27923, 0, 908, 65, 58);
INSERT INTO public.who_global_data VALUES (15181, 3660, 287654, 133, 3329, 65, 163);
INSERT INTO public.who_global_data VALUES (15182, 3942, 129544, 37, 1470, 65, 37);
INSERT INTO public.who_global_data VALUES (15183, 2, 7543, 0, 163, 65, 142);
INSERT INTO public.who_global_data VALUES (15184, 133, 87270, 0, 341, 65, 83);
INSERT INTO public.who_global_data VALUES (15185, 2198, 469423, 38, 6713, 65, 228);
INSERT INTO public.who_global_data VALUES (15186, 0, 278, 0, 7, 65, 188);
INSERT INTO public.who_global_data VALUES (15187, 1689, 139908, 8, 1174, 65, 62);
INSERT INTO public.who_global_data VALUES (15188, 2618, 586609, 117, 17064, 65, 160);
INSERT INTO public.who_global_data VALUES (15189, 0, 5854, 0, 148, 65, 50);
INSERT INTO public.who_global_data VALUES (15190, 0, 3055, 0, 44, 65, 33);
INSERT INTO public.who_global_data VALUES (15191, 7, 267, 0, 9, 65, 183);
INSERT INTO public.who_global_data VALUES (15192, 1, 415, 0, 0, 65, 92);
INSERT INTO public.who_global_data VALUES (15193, 102, 144810, 6, 8963, 65, 158);
INSERT INTO public.who_global_data VALUES (15194, 1, 144, 0, 3, 65, 67);
INSERT INTO public.who_global_data VALUES (15195, 1293, 90378, 46, 2773, 65, 57);
INSERT INTO public.who_global_data VALUES (15196, 0, 9992, 0, 31, 65, 38);
INSERT INTO public.who_global_data VALUES (15197, 50909, 6386787, 697, 173817, 65, 141);
INSERT INTO public.who_global_data VALUES (15198, 0, 73, 0, 1, 65, 178);
INSERT INTO public.who_global_data VALUES (15199, 0, 151, 0, 3, 65, 108);
INSERT INTO public.who_global_data VALUES (15200, 3138, 151913, 159, 4347, 65, 39);
INSERT INTO public.who_global_data VALUES (15201, 79, 3010, 0, 68, 65, 2);
INSERT INTO public.who_global_data VALUES (15202, 3, 692, 0, 1, 65, 195);
INSERT INTO public.who_global_data VALUES (15203, 0, 10626, 0, 105, 65, 107);
INSERT INTO public.who_global_data VALUES (15204, 2, 331, 0, 0, 65, 161);
INSERT INTO public.who_global_data VALUES (15205, 0, 24487, 0, 441, 65, 212);
INSERT INTO public.who_global_data VALUES (15206, 5329, 383468, 81, 12211, 65, 181);
INSERT INTO public.who_global_data VALUES (15207, 3, 285, 0, 2, 65, 53);
INSERT INTO public.who_global_data VALUES (15208, 0, 4918, 0, 63, 65, 164);
INSERT INTO public.who_global_data VALUES (15209, 5, 1705, 0, 102, 65, 140);
INSERT INTO public.who_global_data VALUES (15210, 1034, 553898, 8, 15438, 65, 20);
INSERT INTO public.who_global_data VALUES (15211, 129, 93797, 1, 4751, 65, 112);
INSERT INTO public.who_global_data VALUES (15212, 7986, 1324792, 168, 36934, 65, 111);
INSERT INTO public.who_global_data VALUES (15213, 2, 613, 0, 7, 65, 71);
INSERT INTO public.who_global_data VALUES (15214, 0, 5774, 0, 94, 65, 218);
INSERT INTO public.who_global_data VALUES (15215, 0, 0, 0, 0, 65, 43);
INSERT INTO public.who_global_data VALUES (15216, 534, 140172, 5, 1731, 65, 49);
INSERT INTO public.who_global_data VALUES (15217, 27, 21361, 0, 132, 65, 1);
INSERT INTO public.who_global_data VALUES (15218, 3539, 134881, 55, 1916, 65, 48);
INSERT INTO public.who_global_data VALUES (15219, 75, 8456, 0, 136, 65, 232);
INSERT INTO public.who_global_data VALUES (15220, 124, 2503, 3, 7, 65, 175);
INSERT INTO public.who_global_data VALUES (15221, 292, 11175, 3, 52, 65, 21);
INSERT INTO public.who_global_data VALUES (15222, 4568, 533042, 108, 8515, 65, 156);
INSERT INTO public.who_global_data VALUES (15223, 0, 0, 0, 0, 65, 95);
INSERT INTO public.who_global_data VALUES (15224, 128, 12986, 1, 336, 65, 177);
INSERT INTO public.who_global_data VALUES (15225, 1586, 83535, 6, 852, 65, 210);
INSERT INTO public.who_global_data VALUES (15226, 2, 5682, 0, 61, 65, 120);
INSERT INTO public.who_global_data VALUES (15227, 0, 85, 0, 0, 65, 135);
INSERT INTO public.who_global_data VALUES (15228, 895, 145197, 1, 2334, 65, 206);
INSERT INTO public.who_global_data VALUES (15229, 1203, 194876, 61, 13562, 65, 189);
INSERT INTO public.who_global_data VALUES (15230, 421, 116724, 28, 6694, 65, 129);
INSERT INTO public.who_global_data VALUES (15231, 0, 39130, 9, 1129, 65, 121);
INSERT INTO public.who_global_data VALUES (15232, 0, 5156, 0, 85, 65, 59);
INSERT INTO public.who_global_data VALUES (15233, 0, 577, 0, 0, 65, 96);
INSERT INTO public.who_global_data VALUES (15234, 522, 13019, 1, 122, 65, 41);
INSERT INTO public.who_global_data VALUES (15235, 13, 6455, 0, 122, 65, 216);
INSERT INTO public.who_global_data VALUES (15236, 430, 110984, 6, 1715, 65, 236);
INSERT INTO public.who_global_data VALUES (15237, 0, 17, 0, 0, 65, 150);
INSERT INTO public.who_global_data VALUES (15238, 0, 503, 0, 0, 65, 61);
INSERT INTO public.who_global_data VALUES (15239, 0, 42, 0, 2, 65, 7);
INSERT INTO public.who_global_data VALUES (15240, 420, 25882, 9, 408, 65, 169);
INSERT INTO public.who_global_data VALUES (15241, 13938, 2205212, 309, 53455, 65, 28);
INSERT INTO public.who_global_data VALUES (15242, 43, 11283, 0, 70, 65, 85);
INSERT INTO public.who_global_data VALUES (15243, 157, 14716, 1, 77, 65, 211);
INSERT INTO public.who_global_data VALUES (15244, 48, 9239, 1, 60, 65, 60);
INSERT INTO public.who_global_data VALUES (15245, 22, 3764, 0, 123, 65, 3);
INSERT INTO public.who_global_data VALUES (15246, 4260, 147636, 45, 1387, 65, 11);
INSERT INTO public.who_global_data VALUES (15247, 22046, 1106789, 479, 17602, 65, 89);
INSERT INTO public.who_global_data VALUES (15248, 0, 51667, 0, 323, 65, 24);
INSERT INTO public.who_global_data VALUES (15249, 10, 1030, 0, 5, 65, 162);
INSERT INTO public.who_global_data VALUES (15250, 2185, 109655, 89, 2606, 65, 100);
INSERT INTO public.who_global_data VALUES (15251, 0, 18, 0, 0, 65, 47);
INSERT INTO public.who_global_data VALUES (15252, 0, 41, 0, 0, 65, 29);
INSERT INTO public.who_global_data VALUES (15253, 49, 8427, 0, 149, 65, 40);
INSERT INTO public.who_global_data VALUES (15254, 25, 6782, 0, 112, 65, 222);
INSERT INTO public.who_global_data VALUES (15255, 686, 123460, 13, 4191, 65, 132);
INSERT INTO public.who_global_data VALUES (15256, 0, 287, 0, 13, 65, 130);
INSERT INTO public.who_global_data VALUES (15257, 24, 13143, 0, 76, 65, 234);
INSERT INTO public.who_global_data VALUES (15258, 0, 2425, 0, 44, 65, 23);
INSERT INTO public.who_global_data VALUES (15259, 17, 5423, 0, 151, 65, 192);
INSERT INTO public.who_global_data VALUES (15260, 7, 9303, 0, 233, 65, 69);
INSERT INTO public.who_global_data VALUES (15261, 0, 26, 0, 0, 65, 187);
INSERT INTO public.who_global_data VALUES (15262, 388, 108641, 9, 2927, 65, 230);
INSERT INTO public.who_global_data VALUES (15263, 6635, 231844, 182, 5324, 65, 77);
INSERT INTO public.who_global_data VALUES (15264, 20, 5433, 0, 27, 65, 9);
INSERT INTO public.who_global_data VALUES (15265, 35551, 9534964, 526, 138648, 65, 74);
INSERT INTO public.who_global_data VALUES (15266, 5533, 549508, 118, 17199, 65, 224);
INSERT INTO public.who_global_data VALUES (15267, 13621, 989572, 362, 48990, 65, 199);
INSERT INTO public.who_global_data VALUES (15268, 1961, 556728, 34, 12340, 65, 190);
INSERT INTO public.who_global_data VALUES (15269, 268, 73066, 5, 2074, 65, 12);
INSERT INTO public.who_global_data VALUES (15270, 0, 369, 0, 25, 65, 104);
INSERT INTO public.who_global_data VALUES (15271, 1199, 338394, 10, 2888, 65, 153);
INSERT INTO public.who_global_data VALUES (15272, 20709, 1641610, 684, 57045, 65, 91);
INSERT INTO public.who_global_data VALUES (15273, 54, 10864, 0, 258, 65, 215);
INSERT INTO public.who_global_data VALUES (15274, 2441, 152827, 41, 2213, 65, 84);
INSERT INTO public.who_global_data VALUES (15275, 32, 1040, 0, 32, 65, 231);
INSERT INTO public.who_global_data VALUES (15276, 3591, 227208, 52, 2854, 65, 196);
INSERT INTO public.who_global_data VALUES (15277, 1044, 177386, 0, 2477, 65, 105);
INSERT INTO public.who_global_data VALUES (15278, 961, 85130, 10, 1484, 65, 122);
INSERT INTO public.who_global_data VALUES (15279, 0, 0, 0, 0, 65, 159);
INSERT INTO public.who_global_data VALUES (15280, 555, 40629, 14, 1030, 65, 75);
INSERT INTO public.who_global_data VALUES (15281, 268, 143260, 1, 882, 65, 27);
INSERT INTO public.who_global_data VALUES (15282, 420, 73933, 4, 1281, 65, 54);
INSERT INTO public.who_global_data VALUES (15283, 0, 39, 0, 0, 65, 226);
INSERT INTO public.who_global_data VALUES (15284, 690, 18377, 14, 224, 65, 79);
INSERT INTO public.who_global_data VALUES (15285, 1842, 131256, 22, 1055, 65, 56);
INSERT INTO public.who_global_data VALUES (15286, 0, 2109, 0, 44, 65, 117);
INSERT INTO public.who_global_data VALUES (15287, 0, 1598, 0, 83, 65, 152);
INSERT INTO public.who_global_data VALUES (15288, 670, 84087, 4, 1200, 65, 16);
INSERT INTO public.who_global_data VALUES (15289, 15, 1384, 1, 17, 65, 10);
INSERT INTO public.who_global_data VALUES (15290, 2452, 67068, 19, 695, 65, 201);
INSERT INTO public.who_global_data VALUES (15291, 451, 35129, 9, 330, 65, 174);
INSERT INTO public.who_global_data VALUES (15292, 0, 17341, 0, 251, 65, 119);
INSERT INTO public.who_global_data VALUES (15293, 12, 6040, 0, 185, 65, 168);
INSERT INTO public.who_global_data VALUES (15294, 851, 68020, 2, 365, 65, 99);
INSERT INTO public.who_global_data VALUES (15295, 21, 13070, 0, 47, 65, 171);
INSERT INTO public.who_global_data VALUES (15296, 75, 4837, 1, 161, 65, 87);
INSERT INTO public.who_global_data VALUES (15297, 126, 10101, 5, 146, 65, 123);
INSERT INTO public.who_global_data VALUES (15298, 0, 4, 0, 0, 65, 151);
INSERT INTO public.who_global_data VALUES (15299, 34, 5520, 1, 41, 65, 213);
INSERT INTO public.who_global_data VALUES (15300, 0, 8424, 0, 172, 65, 118);
INSERT INTO public.who_global_data VALUES (15301, 0, 505, 0, 10, 65, 134);
INSERT INTO public.who_global_data VALUES (15302, 0, 5181, 0, 49, 65, 65);
INSERT INTO public.who_global_data VALUES (15303, 8819, 1122362, 825, 106765, 65, 102);
INSERT INTO public.who_global_data VALUES (15304, 0, 0, 0, 0, 65, 223);
INSERT INTO public.who_global_data VALUES (15305, 4, 624, 0, 3, 65, 4);
INSERT INTO public.who_global_data VALUES (15306, 11, 812, 0, 0, 65, 146);
INSERT INTO public.who_global_data VALUES (15307, 529, 37374, 6, 515, 65, 31);
INSERT INTO public.who_global_data VALUES (15308, 0, 13, 0, 1, 65, 127);
INSERT INTO public.who_global_data VALUES (15309, 4346, 364190, 70, 5985, 65, 22);
INSERT INTO public.who_global_data VALUES (15310, 96, 15866, 1, 132, 65, 115);
INSERT INTO public.who_global_data VALUES (15311, 1476, 92189, 31, 1972, 65, 106);
INSERT INTO public.who_global_data VALUES (15312, 61, 14477, 0, 152, 65, 90);
INSERT INTO public.who_global_data VALUES (15313, 0, 0, 0, 0, 65, 70);
INSERT INTO public.who_global_data VALUES (15314, 1490, 236246, 9, 1538, 65, 46);
INSERT INTO public.who_global_data VALUES (15315, 4908, 531235, 66, 9481, 65, 139);
INSERT INTO public.who_global_data VALUES (15316, 0, 33, 0, 0, 65, 42);
INSERT INTO public.who_global_data VALUES (15317, 9, 1713, 0, 25, 65, 80);
INSERT INTO public.who_global_data VALUES (15318, 0, 4671, 0, 161, 65, 203);
INSERT INTO public.who_global_data VALUES (15319, 92, 1640, 4, 76, 65, 136);
INSERT INTO public.who_global_data VALUES (15320, 122, 67960, 1, 1177, 65, 63);
INSERT INTO public.who_global_data VALUES (15321, 0, 0, 0, 0, 65, 17);
INSERT INTO public.who_global_data VALUES (15322, 0, 106, 0, 2, 65, 172);
INSERT INTO public.who_global_data VALUES (15323, 945, 63890, 33, 1825, 65, 109);
INSERT INTO public.who_global_data VALUES (15324, 441, 36591, 17, 351, 65, 200);
INSERT INTO public.who_global_data VALUES (15325, 2188, 103574, 16, 854, 65, 93);
INSERT INTO public.who_global_data VALUES (15326, 237, 124145, 0, 1430, 65, 5);
INSERT INTO public.who_global_data VALUES (15327, 0, 741, 0, 13, 65, 214);
INSERT INTO public.who_global_data VALUES (15328, 2829, 403311, 75, 8166, 65, 204);
INSERT INTO public.who_global_data VALUES (15329, 0, 0, 0, 0, 65, 198);
INSERT INTO public.who_global_data VALUES (15330, 1505, 167311, 19, 3098, 65, 173);
INSERT INTO public.who_global_data VALUES (15331, 13, 669, 0, 7, 65, 229);
INSERT INTO public.who_global_data VALUES (15332, 1055, 83479, 15, 1771, 65, 76);
INSERT INTO public.who_global_data VALUES (15333, 1623, 965228, 65, 36031, 65, 138);
INSERT INTO public.who_global_data VALUES (15334, 1432, 434357, 18, 8436, 65, 98);
INSERT INTO public.who_global_data VALUES (15335, 0, 0, 0, 0, 65, 103);
INSERT INTO public.who_global_data VALUES (15336, 13823, 1013747, 609, 18208, 65, 225);
INSERT INTO public.who_global_data VALUES (15337, 3384, 303846, 68, 4645, 65, 131);
INSERT INTO public.who_global_data VALUES (15338, 388, 53708, 22, 1144, 65, 235);
INSERT INTO public.who_global_data VALUES (15339, 255, 139256, 1, 239, 65, 137);
INSERT INTO public.who_global_data VALUES (15340, 540, 35701, 3, 529, 65, 81);
INSERT INTO public.who_global_data VALUES (15341, 1717, 110580, 20, 2343, 65, 182);
INSERT INTO public.who_global_data VALUES (15342, 0, 8102, 0, 40, 65, 145);
INSERT INTO public.who_global_data VALUES (15343, 4916, 484550, 135, 11665, 65, 26);
INSERT INTO public.who_global_data VALUES (15344, 28145, 2375546, 554, 41607, 65, 170);
INSERT INTO public.who_global_data VALUES (15345, 46, 5994, 1, 50, 65, 191);
INSERT INTO public.who_global_data VALUES (15346, 0, 5, 0, 0, 65, 221);
INSERT INTO public.who_global_data VALUES (15347, 0, 152, 0, 0, 65, 64);
INSERT INTO public.who_global_data VALUES (15348, 0, 0, 0, 0, 65, 116);
INSERT INTO public.who_global_data VALUES (15349, 0, 22, 0, 0, 65, 128);
INSERT INTO public.who_global_data VALUES (15350, 2, 261, 0, 2, 65, 6);
INSERT INTO public.who_global_data VALUES (15351, 0, 744, 0, 12, 65, 227);
INSERT INTO public.who_global_data VALUES (15352, 0, 14, 0, 0, 65, 68);
INSERT INTO public.who_global_data VALUES (15353, 0, 85, 0, 0, 65, 184);
INSERT INTO public.who_global_data VALUES (15354, 0, 2, 0, 0, 65, 82);
INSERT INTO public.who_global_data VALUES (15355, 37, 1687, 0, 46, 65, 149);
INSERT INTO public.who_global_data VALUES (15356, 1, 997, 0, 17, 65, 197);
INSERT INTO public.who_global_data VALUES (15357, 249, 357872, 12, 5919, 65, 78);
INSERT INTO public.who_global_data VALUES (15358, 66, 16173, 1, 334, 65, 233);
INSERT INTO public.who_global_data VALUES (15359, 7919, 191356, 52, 1704, 65, 133);
INSERT INTO public.who_global_data VALUES (15360, 9, 181, 0, 0, 65, 35);
INSERT INTO public.who_global_data VALUES (15361, 3, 2416, 0, 74, 65, 114);
INSERT INTO public.who_global_data VALUES (15362, 2, 58230, 0, 29, 65, 237);
INSERT INTO public.who_global_data VALUES (15363, 0, 14, 0, 0, 65, 55);
INSERT INTO public.who_global_data VALUES (15364, 3, 1072, 0, 25, 65, 176);
INSERT INTO public.who_global_data VALUES (15365, 2043, 111790, 30, 918, 65, 202);
INSERT INTO public.who_global_data VALUES (15366, 1776, 81385, 49, 1735, 65, 155);
INSERT INTO public.who_global_data VALUES (15367, 0, 17, 0, 0, 65, 32);
INSERT INTO public.who_global_data VALUES (15368, 74, 4525, 8, 121, 65, 220);
INSERT INTO public.who_global_data VALUES (15369, 4173, 796472, 65, 21709, 65, 30);
INSERT INTO public.who_global_data VALUES (15370, 0, 3109, 0, 61, 65, 147);
INSERT INTO public.who_global_data VALUES (15371, 9739, 1727812, 204, 47366, 65, 208);
INSERT INTO public.who_global_data VALUES (15372, 878, 25410, 2, 124, 65, 45);
INSERT INTO public.who_global_data VALUES (15373, 349, 18884, 9, 1280, 65, 110);
INSERT INTO public.who_global_data VALUES (15374, 7, 5319, 0, 117, 65, 88);
INSERT INTO public.who_global_data VALUES (15375, 5820, 266859, 68, 7331, 65, 51);
INSERT INTO public.who_global_data VALUES (15376, 4421, 340898, 87, 4938, 65, 209);
INSERT INTO public.who_global_data VALUES (15377, 86, 8059, 4, 426, 65, 205);
INSERT INTO public.who_global_data VALUES (15378, 38, 12269, 1, 87, 65, 18);
INSERT INTO public.who_global_data VALUES (15379, 18, 4026, 0, 60, 65, 72);
INSERT INTO public.who_global_data VALUES (15380, 16170, 1659260, 648, 59699, 65, 44);
INSERT INTO public.who_global_data VALUES (15381, 1, 31, 0, 0, 65, 15);
INSERT INTO public.who_global_data VALUES (15382, 68, 3014, 1, 65, 65, 25);
INSERT INTO public.who_global_data VALUES (15383, 0, 0, 0, 0, 65, 179);
INSERT INTO public.who_global_data VALUES (15384, 0, 0, 0, 0, 65, 34);
INSERT INTO public.who_global_data VALUES (15385, 16, 6685, 0, 120, 65, 207);
INSERT INTO public.who_global_data VALUES (15386, 1208, 99280, 48, 3359, 65, 166);
INSERT INTO public.who_global_data VALUES (15387, 31923, 1493681, 193, 14129, 65, 126);
INSERT INTO public.who_global_data VALUES (15388, 0, 0, 0, 0, 65, 97);
INSERT INTO public.who_global_data VALUES (15389, 2, 750, 0, 6, 65, 36);
INSERT INTO public.who_global_data VALUES (15390, 0, 0, 0, 0, 65, 125);
INSERT INTO public.who_global_data VALUES (15391, 374, 21409, 1, 206, 65, 124);
INSERT INTO public.who_global_data VALUES (15392, 14496, 772760, 243, 12960, 65, 185);
INSERT INTO public.who_global_data VALUES (15393, 1285, 171434, 4, 580, 65, 194);
INSERT INTO public.who_global_data VALUES (15394, 0, 509, 0, 21, 65, 144);
INSERT INTO public.who_global_data VALUES (15395, 177976, 13563731, 2439, 268482, 65, 19);
INSERT INTO public.who_global_data VALUES (15396, 13, 1563, 0, 23, 65, 217);
INSERT INTO public.who_global_data VALUES (15397, 167, 6024, 1, 78, 65, 148);
INSERT INTO public.who_global_data VALUES (15398, 155, 73431, 0, 611, 65, 86);
INSERT INTO public.who_global_data VALUES (15399, 0, 1, 0, 0, 65, 13);
INSERT INTO public.who_global_data VALUES (15400, 227, 102621, 4, 901, 65, 157);
INSERT INTO public.who_global_data VALUES (15401, 7, 1358, 0, 35, 65, 8);
INSERT INTO public.who_global_data VALUES (15402, 0, 3, 0, 0, 65, 73);
INSERT INTO public.who_global_data VALUES (15403, 0, 2081, 0, 606, 65, 101);
INSERT INTO public.who_global_data VALUES (15404, 35, 17700, 0, 357, 65, 165);
INSERT INTO public.who_global_data VALUES (15405, 114, 10243, 0, 277, 65, 14);
INSERT INTO public.who_global_data VALUES (15406, 219, 46717, 21, 1795, 66, 193);
INSERT INTO public.who_global_data VALUES (15407, 832, 39014, 12, 822, 66, 113);
INSERT INTO public.who_global_data VALUES (15408, 953, 84152, 16, 2447, 66, 143);
INSERT INTO public.who_global_data VALUES (15409, 0, 0, 0, 0, 66, 219);
INSERT INTO public.who_global_data VALUES (15410, 45, 6790, 0, 76, 66, 186);
INSERT INTO public.who_global_data VALUES (15411, 112, 15251, 2, 350, 66, 52);
INSERT INTO public.who_global_data VALUES (15412, 0, 6, 0, 0, 66, 180);
INSERT INTO public.who_global_data VALUES (15413, 0, 141, 0, 4, 66, 167);
INSERT INTO public.who_global_data VALUES (15414, 5726, 1424533, 257, 38730, 66, 154);
INSERT INTO public.who_global_data VALUES (15415, 1264, 136544, 35, 2223, 66, 94);
INSERT INTO public.who_global_data VALUES (15416, 7, 4845, 0, 45, 66, 66);
INSERT INTO public.who_global_data VALUES (15417, 8, 27912, 0, 908, 66, 58);
INSERT INTO public.who_global_data VALUES (15418, 3464, 283994, 213, 3196, 66, 163);
INSERT INTO public.who_global_data VALUES (15419, 4426, 125602, 41, 1433, 66, 37);
INSERT INTO public.who_global_data VALUES (15420, 24, 7541, 0, 163, 66, 142);
INSERT INTO public.who_global_data VALUES (15421, 181, 87137, 0, 341, 66, 83);
INSERT INTO public.who_global_data VALUES (15422, 2293, 467225, 31, 6675, 66, 228);
INSERT INTO public.who_global_data VALUES (15423, 2, 278, 0, 7, 66, 188);
INSERT INTO public.who_global_data VALUES (15424, 1572, 138219, 8, 1166, 66, 62);
INSERT INTO public.who_global_data VALUES (15425, 2698, 583991, 109, 16947, 66, 160);
INSERT INTO public.who_global_data VALUES (15426, 111, 5854, 1, 148, 66, 50);
INSERT INTO public.who_global_data VALUES (15427, 40, 3055, 1, 44, 66, 33);
INSERT INTO public.who_global_data VALUES (15428, 0, 260, 0, 9, 66, 183);
INSERT INTO public.who_global_data VALUES (15429, 4, 414, 0, 0, 66, 92);
INSERT INTO public.who_global_data VALUES (15430, 86, 144708, 5, 8957, 66, 158);
INSERT INTO public.who_global_data VALUES (15431, 0, 143, 0, 3, 66, 67);
INSERT INTO public.who_global_data VALUES (15432, 1184, 89085, 46, 2727, 66, 57);
INSERT INTO public.who_global_data VALUES (15433, 0, 9992, 0, 31, 66, 38);
INSERT INTO public.who_global_data VALUES (15434, 21138, 6335878, 287, 173120, 66, 141);
INSERT INTO public.who_global_data VALUES (15435, 0, 73, 0, 1, 66, 178);
INSERT INTO public.who_global_data VALUES (15436, 1, 151, 0, 3, 66, 108);
INSERT INTO public.who_global_data VALUES (15437, 3475, 148775, 153, 4188, 66, 39);
INSERT INTO public.who_global_data VALUES (15438, 45, 2931, 0, 68, 66, 2);
INSERT INTO public.who_global_data VALUES (15439, 0, 689, 0, 1, 66, 195);
INSERT INTO public.who_global_data VALUES (15440, 100, 10626, 1, 105, 66, 107);
INSERT INTO public.who_global_data VALUES (15441, 3, 329, 0, 0, 66, 161);
INSERT INTO public.who_global_data VALUES (15442, 0, 24487, 0, 441, 66, 212);
INSERT INTO public.who_global_data VALUES (15443, 7861, 378139, 98, 12130, 66, 181);
INSERT INTO public.who_global_data VALUES (15444, 8, 282, 0, 2, 66, 53);
INSERT INTO public.who_global_data VALUES (15445, 0, 4918, 0, 63, 66, 164);
INSERT INTO public.who_global_data VALUES (15446, 12, 1700, 1, 102, 66, 140);
INSERT INTO public.who_global_data VALUES (15447, 1121, 552864, 20, 15430, 66, 20);
INSERT INTO public.who_global_data VALUES (15448, 91, 93668, 0, 4750, 66, 112);
INSERT INTO public.who_global_data VALUES (15449, 8430, 1316806, 182, 36766, 66, 111);
INSERT INTO public.who_global_data VALUES (15450, 0, 611, 0, 7, 66, 71);
INSERT INTO public.who_global_data VALUES (15451, 0, 5774, 0, 94, 66, 218);
INSERT INTO public.who_global_data VALUES (15452, 0, 0, 0, 0, 66, 43);
INSERT INTO public.who_global_data VALUES (15453, 539, 139638, 11, 1726, 66, 49);
INSERT INTO public.who_global_data VALUES (15454, 3, 21334, 0, 132, 66, 1);
INSERT INTO public.who_global_data VALUES (15455, 2900, 131342, 75, 1861, 66, 48);
INSERT INTO public.who_global_data VALUES (15456, 97, 8381, 1, 136, 66, 232);
INSERT INTO public.who_global_data VALUES (15457, 15, 2379, 0, 4, 66, 175);
INSERT INTO public.who_global_data VALUES (15458, 318, 10883, 0, 49, 66, 21);
INSERT INTO public.who_global_data VALUES (15459, 5176, 528474, 112, 8407, 66, 156);
INSERT INTO public.who_global_data VALUES (15460, 0, 0, 0, 0, 66, 95);
INSERT INTO public.who_global_data VALUES (15461, 87, 12858, 2, 335, 66, 177);
INSERT INTO public.who_global_data VALUES (15462, 1468, 81949, 9, 846, 66, 210);
INSERT INTO public.who_global_data VALUES (15463, 1, 5680, 0, 61, 66, 120);
INSERT INTO public.who_global_data VALUES (15464, 0, 85, 0, 0, 66, 135);
INSERT INTO public.who_global_data VALUES (15465, 314, 144302, 2, 2333, 66, 206);
INSERT INTO public.who_global_data VALUES (15466, 988, 193673, 40, 13501, 66, 189);
INSERT INTO public.who_global_data VALUES (15467, 392, 116303, 16, 6666, 66, 129);
INSERT INTO public.who_global_data VALUES (15468, 725, 39130, 6, 1120, 66, 121);
INSERT INTO public.who_global_data VALUES (15469, 3, 5156, 0, 85, 66, 59);
INSERT INTO public.who_global_data VALUES (15470, 0, 577, 0, 0, 66, 96);
INSERT INTO public.who_global_data VALUES (15471, 189, 12497, 3, 121, 66, 41);
INSERT INTO public.who_global_data VALUES (15472, 23, 6442, 0, 122, 66, 216);
INSERT INTO public.who_global_data VALUES (15473, 480, 110554, 3, 1709, 66, 236);
INSERT INTO public.who_global_data VALUES (15474, 0, 17, 0, 0, 66, 150);
INSERT INTO public.who_global_data VALUES (15475, 0, 503, 0, 0, 66, 61);
INSERT INTO public.who_global_data VALUES (15476, 0, 42, 0, 2, 66, 7);
INSERT INTO public.who_global_data VALUES (15477, 550, 25462, 0, 399, 66, 169);
INSERT INTO public.who_global_data VALUES (15478, 7999, 2191274, 775, 53146, 66, 28);
INSERT INTO public.who_global_data VALUES (15479, 36, 11240, 0, 70, 66, 85);
INSERT INTO public.who_global_data VALUES (15480, 187, 14559, 1, 76, 66, 211);
INSERT INTO public.who_global_data VALUES (15481, 0, 9191, 0, 59, 66, 60);
INSERT INTO public.who_global_data VALUES (15482, 0, 3742, 0, 123, 66, 3);
INSERT INTO public.who_global_data VALUES (15483, 4033, 143376, 39, 1342, 66, 11);
INSERT INTO public.who_global_data VALUES (15484, 17270, 1084743, 487, 17123, 66, 89);
INSERT INTO public.who_global_data VALUES (15485, 0, 51667, 0, 323, 66, 24);
INSERT INTO public.who_global_data VALUES (15486, 6, 1020, 0, 5, 66, 162);
INSERT INTO public.who_global_data VALUES (15487, 2199, 107470, 111, 2517, 66, 100);
INSERT INTO public.who_global_data VALUES (15488, 0, 18, 0, 0, 66, 47);
INSERT INTO public.who_global_data VALUES (15489, 0, 41, 0, 0, 66, 29);
INSERT INTO public.who_global_data VALUES (15490, 0, 8378, 0, 149, 66, 40);
INSERT INTO public.who_global_data VALUES (15491, 35, 6757, 0, 112, 66, 222);
INSERT INTO public.who_global_data VALUES (15492, 712, 122774, 7, 4178, 66, 132);
INSERT INTO public.who_global_data VALUES (15493, 1, 287, 0, 13, 66, 130);
INSERT INTO public.who_global_data VALUES (15494, 22, 13119, 0, 76, 66, 234);
INSERT INTO public.who_global_data VALUES (15495, 3, 2425, 1, 44, 66, 23);
INSERT INTO public.who_global_data VALUES (15496, 30, 5406, 1, 151, 66, 192);
INSERT INTO public.who_global_data VALUES (15497, 2, 9296, 0, 233, 66, 69);
INSERT INTO public.who_global_data VALUES (15498, 0, 26, 0, 0, 66, 187);
INSERT INTO public.who_global_data VALUES (15499, 365, 108253, 9, 2918, 66, 230);
INSERT INTO public.who_global_data VALUES (15500, 4136, 225209, 165, 5142, 66, 77);
INSERT INTO public.who_global_data VALUES (15501, 21, 5413, 1, 27, 66, 9);
INSERT INTO public.who_global_data VALUES (15502, 36604, 9499413, 501, 138122, 66, 74);
INSERT INTO public.who_global_data VALUES (15503, 5092, 543975, 136, 17081, 66, 224);
INSERT INTO public.who_global_data VALUES (15504, 13881, 975951, 382, 48628, 66, 199);
INSERT INTO public.who_global_data VALUES (15505, 2218, 554767, 48, 12306, 66, 190);
INSERT INTO public.who_global_data VALUES (15506, 254, 72798, 16, 2069, 66, 12);
INSERT INTO public.who_global_data VALUES (15507, 0, 369, 0, 25, 66, 104);
INSERT INTO public.who_global_data VALUES (15508, 1253, 337195, 7, 2878, 66, 153);
INSERT INTO public.who_global_data VALUES (15509, 19347, 1620901, 785, 56361, 66, 91);
INSERT INTO public.who_global_data VALUES (15510, 47, 10810, 1, 258, 66, 215);
INSERT INTO public.who_global_data VALUES (15511, 1692, 150386, 33, 2172, 66, 84);
INSERT INTO public.who_global_data VALUES (15512, 85, 1008, 0, 32, 66, 231);
INSERT INTO public.who_global_data VALUES (15513, 4187, 223617, 51, 2802, 66, 196);
INSERT INTO public.who_global_data VALUES (15514, 777, 176342, 0, 2477, 66, 105);
INSERT INTO public.who_global_data VALUES (15515, 551, 84169, 5, 1474, 66, 122);
INSERT INTO public.who_global_data VALUES (15516, 0, 0, 0, 0, 66, 159);
INSERT INTO public.who_global_data VALUES (15517, 521, 40074, 10, 1016, 66, 75);
INSERT INTO public.who_global_data VALUES (15518, 357, 142992, 1, 881, 66, 27);
INSERT INTO public.who_global_data VALUES (15519, 335, 73513, 2, 1277, 66, 54);
INSERT INTO public.who_global_data VALUES (15520, 0, 39, 0, 0, 66, 226);
INSERT INTO public.who_global_data VALUES (15521, 612, 17687, 4, 210, 66, 79);
INSERT INTO public.who_global_data VALUES (15522, 1511, 129414, 15, 1033, 66, 56);
INSERT INTO public.who_global_data VALUES (15523, 0, 2109, 0, 44, 66, 117);
INSERT INTO public.who_global_data VALUES (15524, 0, 1598, 0, 83, 66, 152);
INSERT INTO public.who_global_data VALUES (15525, 608, 83417, 13, 1196, 66, 16);
INSERT INTO public.who_global_data VALUES (15526, 24, 1369, 0, 16, 66, 10);
INSERT INTO public.who_global_data VALUES (15527, 2107, 64616, 34, 676, 66, 201);
INSERT INTO public.who_global_data VALUES (15528, 140, 34678, 9, 321, 66, 174);
INSERT INTO public.who_global_data VALUES (15529, 0, 17341, 0, 251, 66, 119);
INSERT INTO public.who_global_data VALUES (15530, 0, 6028, 0, 185, 66, 168);
INSERT INTO public.who_global_data VALUES (15531, 1472, 67169, 3, 363, 66, 99);
INSERT INTO public.who_global_data VALUES (15532, 38, 13049, 1, 47, 66, 171);
INSERT INTO public.who_global_data VALUES (15533, 74, 4762, 8, 160, 66, 87);
INSERT INTO public.who_global_data VALUES (15534, 102, 9975, 4, 141, 66, 123);
INSERT INTO public.who_global_data VALUES (15535, 0, 4, 0, 0, 66, 151);
INSERT INTO public.who_global_data VALUES (15536, 0, 5486, 0, 40, 66, 213);
INSERT INTO public.who_global_data VALUES (15537, 0, 8424, 0, 172, 66, 118);
INSERT INTO public.who_global_data VALUES (15538, 1, 505, 0, 10, 66, 134);
INSERT INTO public.who_global_data VALUES (15539, 0, 5181, 0, 49, 66, 65);
INSERT INTO public.who_global_data VALUES (15540, 6472, 1113543, 285, 105940, 66, 102);
INSERT INTO public.who_global_data VALUES (15541, 0, 0, 0, 0, 66, 223);
INSERT INTO public.who_global_data VALUES (15542, 8, 620, 0, 3, 66, 4);
INSERT INTO public.who_global_data VALUES (15543, 10, 801, 0, 0, 66, 146);
INSERT INTO public.who_global_data VALUES (15544, 568, 36845, 6, 509, 66, 31);
INSERT INTO public.who_global_data VALUES (15545, 0, 13, 0, 1, 66, 127);
INSERT INTO public.who_global_data VALUES (15546, 3509, 359844, 69, 5915, 66, 22);
INSERT INTO public.who_global_data VALUES (15547, 69, 15770, 0, 131, 66, 115);
INSERT INTO public.who_global_data VALUES (15548, 1227, 90713, 23, 1941, 66, 106);
INSERT INTO public.who_global_data VALUES (15549, 36, 14416, 0, 152, 66, 90);
INSERT INTO public.who_global_data VALUES (15550, 0, 0, 0, 0, 66, 70);
INSERT INTO public.who_global_data VALUES (15551, 1304, 234756, 21, 1529, 66, 46);
INSERT INTO public.who_global_data VALUES (15552, 4038, 526327, 61, 9415, 66, 139);
INSERT INTO public.who_global_data VALUES (15553, 0, 33, 0, 0, 66, 42);
INSERT INTO public.who_global_data VALUES (15554, 1, 1704, 0, 25, 66, 80);
INSERT INTO public.who_global_data VALUES (15555, 42, 4671, 1, 161, 66, 203);
INSERT INTO public.who_global_data VALUES (15556, 0, 1548, 0, 72, 66, 136);
INSERT INTO public.who_global_data VALUES (15557, 281, 67838, 3, 1176, 66, 63);
INSERT INTO public.who_global_data VALUES (15558, 0, 0, 0, 0, 66, 17);
INSERT INTO public.who_global_data VALUES (15559, 0, 106, 0, 2, 66, 172);
INSERT INTO public.who_global_data VALUES (15560, 1067, 62945, 29, 1792, 66, 109);
INSERT INTO public.who_global_data VALUES (15561, 324, 36150, 2, 334, 66, 200);
INSERT INTO public.who_global_data VALUES (15562, 2536, 101386, 16, 838, 66, 93);
INSERT INTO public.who_global_data VALUES (15563, 209, 123908, 7, 1430, 66, 5);
INSERT INTO public.who_global_data VALUES (15564, 0, 741, 0, 13, 66, 214);
INSERT INTO public.who_global_data VALUES (15565, 2458, 400482, 66, 8091, 66, 204);
INSERT INTO public.who_global_data VALUES (15566, 0, 0, 0, 0, 66, 198);
INSERT INTO public.who_global_data VALUES (15567, 1077, 165806, 19, 3079, 66, 173);
INSERT INTO public.who_global_data VALUES (15568, 0, 656, 0, 7, 66, 229);
INSERT INTO public.who_global_data VALUES (15569, 518, 82424, 13, 1756, 66, 76);
INSERT INTO public.who_global_data VALUES (15570, 1075, 963605, 43, 35966, 66, 138);
INSERT INTO public.who_global_data VALUES (15571, 1295, 432925, 26, 8418, 66, 98);
INSERT INTO public.who_global_data VALUES (15572, 0, 0, 0, 0, 66, 103);
INSERT INTO public.who_global_data VALUES (15573, 9113, 999924, 449, 17599, 66, 225);
INSERT INTO public.who_global_data VALUES (15574, 2401, 300462, 72, 4577, 66, 131);
INSERT INTO public.who_global_data VALUES (15575, 775, 53320, 16, 1122, 66, 235);
INSERT INTO public.who_global_data VALUES (15576, 168, 139001, 1, 238, 66, 137);
INSERT INTO public.who_global_data VALUES (15577, 511, 35161, 0, 526, 66, 81);
INSERT INTO public.who_global_data VALUES (15578, 1499, 108863, 19, 2323, 66, 182);
INSERT INTO public.who_global_data VALUES (15579, 48, 8102, 0, 40, 66, 145);
INSERT INTO public.who_global_data VALUES (15580, 4272, 479634, 199, 11530, 66, 26);
INSERT INTO public.who_global_data VALUES (15581, 25345, 2347401, 589, 41053, 66, 170);
INSERT INTO public.who_global_data VALUES (15582, 14, 5948, 0, 49, 66, 191);
INSERT INTO public.who_global_data VALUES (15583, 0, 5, 0, 0, 66, 221);
INSERT INTO public.who_global_data VALUES (15584, 0, 152, 0, 0, 66, 64);
INSERT INTO public.who_global_data VALUES (15585, 0, 0, 0, 0, 66, 116);
INSERT INTO public.who_global_data VALUES (15586, 0, 22, 0, 0, 66, 128);
INSERT INTO public.who_global_data VALUES (15587, 2, 259, 0, 2, 66, 6);
INSERT INTO public.who_global_data VALUES (15588, 0, 744, 0, 12, 66, 227);
INSERT INTO public.who_global_data VALUES (15589, 0, 14, 0, 0, 66, 68);
INSERT INTO public.who_global_data VALUES (15590, 0, 85, 0, 0, 66, 184);
INSERT INTO public.who_global_data VALUES (15591, 2, 2, 0, 0, 66, 82);
INSERT INTO public.who_global_data VALUES (15592, 38, 1650, 0, 46, 66, 149);
INSERT INTO public.who_global_data VALUES (15593, 5, 996, 0, 17, 66, 197);
INSERT INTO public.who_global_data VALUES (15594, 263, 357623, 11, 5907, 66, 78);
INSERT INTO public.who_global_data VALUES (15595, 18, 16107, 0, 333, 66, 233);
INSERT INTO public.who_global_data VALUES (15596, 7999, 183437, 48, 1652, 66, 133);
INSERT INTO public.who_global_data VALUES (15597, 0, 172, 0, 0, 66, 35);
INSERT INTO public.who_global_data VALUES (15598, 1, 2413, 0, 74, 66, 114);
INSERT INTO public.who_global_data VALUES (15599, 10, 58228, 0, 29, 66, 237);
INSERT INTO public.who_global_data VALUES (15600, 0, 14, 0, 0, 66, 55);
INSERT INTO public.who_global_data VALUES (15601, 3, 1069, 0, 25, 66, 176);
INSERT INTO public.who_global_data VALUES (15602, 1254, 109747, 29, 888, 66, 202);
INSERT INTO public.who_global_data VALUES (15603, 2438, 79609, 64, 1686, 66, 155);
INSERT INTO public.who_global_data VALUES (15604, 0, 17, 0, 0, 66, 32);
INSERT INTO public.who_global_data VALUES (15605, 0, 4451, 0, 113, 66, 220);
INSERT INTO public.who_global_data VALUES (15606, 2295, 792299, 109, 21644, 66, 30);
INSERT INTO public.who_global_data VALUES (15607, 0, 3109, 0, 61, 66, 147);
INSERT INTO public.who_global_data VALUES (15608, 7576, 1718073, 199, 47162, 66, 208);
INSERT INTO public.who_global_data VALUES (15609, 1048, 24532, 6, 122, 66, 45);
INSERT INTO public.who_global_data VALUES (15610, 281, 18535, 6, 1271, 66, 110);
INSERT INTO public.who_global_data VALUES (15611, 0, 5312, 0, 117, 66, 88);
INSERT INTO public.who_global_data VALUES (15612, 3482, 261039, 66, 7263, 66, 51);
INSERT INTO public.who_global_data VALUES (15613, 4252, 336477, 88, 4851, 66, 209);
INSERT INTO public.who_global_data VALUES (15614, 86, 7973, 5, 422, 66, 205);
INSERT INTO public.who_global_data VALUES (15615, 37, 12231, 0, 86, 66, 18);
INSERT INTO public.who_global_data VALUES (15616, 10, 4008, 0, 60, 66, 72);
INSERT INTO public.who_global_data VALUES (15617, 13429, 1643090, 603, 59051, 66, 44);
INSERT INTO public.who_global_data VALUES (15618, 0, 30, 0, 0, 66, 15);
INSERT INTO public.who_global_data VALUES (15619, 0, 2946, 0, 64, 66, 25);
INSERT INTO public.who_global_data VALUES (15620, 0, 0, 0, 0, 66, 179);
INSERT INTO public.who_global_data VALUES (15621, 0, 0, 0, 0, 66, 34);
INSERT INTO public.who_global_data VALUES (15622, 9, 6669, 0, 120, 66, 207);
INSERT INTO public.who_global_data VALUES (15623, 1303, 98072, 51, 3311, 66, 166);
INSERT INTO public.who_global_data VALUES (15624, 30110, 1461758, 190, 13936, 66, 126);
INSERT INTO public.who_global_data VALUES (15625, 0, 0, 0, 0, 66, 97);
INSERT INTO public.who_global_data VALUES (15626, 0, 748, 0, 6, 66, 36);
INSERT INTO public.who_global_data VALUES (15627, 0, 0, 0, 0, 66, 125);
INSERT INTO public.who_global_data VALUES (15628, 576, 21035, 0, 205, 66, 124);
INSERT INTO public.who_global_data VALUES (15629, 13141, 758264, 169, 12717, 66, 185);
INSERT INTO public.who_global_data VALUES (15630, 1289, 170149, 4, 576, 66, 194);
INSERT INTO public.who_global_data VALUES (15631, 0, 509, 0, 21, 66, 144);
INSERT INTO public.who_global_data VALUES (15632, 151204, 13385755, 1235, 266043, 66, 19);
INSERT INTO public.who_global_data VALUES (15633, 6, 1550, 0, 23, 66, 217);
INSERT INTO public.who_global_data VALUES (15634, 141, 5857, 1, 77, 66, 148);
INSERT INTO public.who_global_data VALUES (15635, 182, 73276, 1, 611, 66, 86);
INSERT INTO public.who_global_data VALUES (15636, 0, 1, 0, 0, 66, 13);
INSERT INTO public.who_global_data VALUES (15637, 354, 102394, 3, 897, 66, 157);
INSERT INTO public.who_global_data VALUES (15638, 4, 1351, 0, 35, 66, 8);
INSERT INTO public.who_global_data VALUES (15639, 0, 3, 0, 0, 66, 73);
INSERT INTO public.who_global_data VALUES (15640, 0, 2081, 0, 606, 66, 101);
INSERT INTO public.who_global_data VALUES (15641, 18, 17665, 0, 357, 66, 165);
INSERT INTO public.who_global_data VALUES (15642, 95, 10129, 0, 277, 66, 14);
INSERT INTO public.who_global_data VALUES (15643, 283, 46498, 11, 1774, 67, 193);
INSERT INTO public.who_global_data VALUES (15644, 557, 38182, 12, 810, 67, 113);
INSERT INTO public.who_global_data VALUES (15645, 1987, 83199, 38, 2431, 67, 143);
INSERT INTO public.who_global_data VALUES (15646, 0, 0, 0, 0, 67, 219);
INSERT INTO public.who_global_data VALUES (15647, 33, 6745, 0, 76, 67, 186);
INSERT INTO public.who_global_data VALUES (15648, 36, 15139, 2, 348, 67, 52);
INSERT INTO public.who_global_data VALUES (15649, 0, 6, 0, 0, 67, 180);
INSERT INTO public.who_global_data VALUES (15650, 0, 141, 0, 4, 67, 167);
INSERT INTO public.who_global_data VALUES (15651, 5432, 1418807, 151, 38473, 67, 154);
INSERT INTO public.who_global_data VALUES (15652, 843, 135280, 29, 2188, 67, 94);
INSERT INTO public.who_global_data VALUES (15653, 47, 4838, 0, 45, 67, 66);
INSERT INTO public.who_global_data VALUES (15654, 11, 27904, 1, 908, 67, 58);
INSERT INTO public.who_global_data VALUES (15655, 2348, 280530, 79, 2983, 67, 163);
INSERT INTO public.who_global_data VALUES (15656, 2981, 121176, 31, 1392, 67, 37);
INSERT INTO public.who_global_data VALUES (15657, 14, 7517, 0, 163, 67, 142);
INSERT INTO public.who_global_data VALUES (15658, 169, 86956, 0, 341, 67, 83);
INSERT INTO public.who_global_data VALUES (15659, 2525, 464932, 35, 6644, 67, 228);
INSERT INTO public.who_global_data VALUES (15660, 1, 276, 0, 7, 67, 188);
INSERT INTO public.who_global_data VALUES (15661, 1639, 136647, 7, 1158, 67, 62);
INSERT INTO public.who_global_data VALUES (15662, 3304, 581293, 99, 16838, 67, 160);
INSERT INTO public.who_global_data VALUES (15663, 96, 5743, 3, 147, 67, 50);
INSERT INTO public.who_global_data VALUES (15664, 41, 3015, 0, 43, 67, 33);
INSERT INTO public.who_global_data VALUES (15665, 9, 260, 0, 9, 67, 183);
INSERT INTO public.who_global_data VALUES (15666, 14, 410, 0, 0, 67, 92);
INSERT INTO public.who_global_data VALUES (15667, 30, 144622, 3, 8952, 67, 158);
INSERT INTO public.who_global_data VALUES (15668, 1, 143, 0, 3, 67, 67);
INSERT INTO public.who_global_data VALUES (15669, 527, 87901, 61, 2681, 67, 57);
INSERT INTO public.who_global_data VALUES (15670, 0, 9992, 0, 31, 67, 38);
INSERT INTO public.who_global_data VALUES (15671, 24468, 6314740, 272, 172833, 67, 141);
INSERT INTO public.who_global_data VALUES (15672, 0, 73, 0, 1, 67, 178);
INSERT INTO public.who_global_data VALUES (15673, 0, 150, 0, 3, 67, 108);
INSERT INTO public.who_global_data VALUES (15674, 2814, 145300, 221, 4035, 67, 39);
INSERT INTO public.who_global_data VALUES (15675, 30, 2886, 0, 68, 67, 2);
INSERT INTO public.who_global_data VALUES (15676, 1, 689, 0, 1, 67, 195);
INSERT INTO public.who_global_data VALUES (15677, 0, 10526, 0, 104, 67, 107);
INSERT INTO public.who_global_data VALUES (15678, 3, 326, 0, 0, 67, 161);
INSERT INTO public.who_global_data VALUES (15679, 42, 24487, 4, 441, 67, 212);
INSERT INTO public.who_global_data VALUES (15680, 5468, 370278, 56, 12032, 67, 181);
INSERT INTO public.who_global_data VALUES (15681, 0, 274, 0, 2, 67, 53);
INSERT INTO public.who_global_data VALUES (15682, 5, 4918, 0, 63, 67, 164);
INSERT INTO public.who_global_data VALUES (15683, 6, 1688, 0, 101, 67, 140);
INSERT INTO public.who_global_data VALUES (15684, 1313, 551743, 54, 15410, 67, 20);
INSERT INTO public.who_global_data VALUES (15685, 112, 93577, 0, 4750, 67, 112);
INSERT INTO public.who_global_data VALUES (15686, 8763, 1308376, 183, 36584, 67, 111);
INSERT INTO public.who_global_data VALUES (15687, 1, 611, 0, 7, 67, 71);
INSERT INTO public.who_global_data VALUES (15688, 0, 5774, 0, 94, 67, 218);
INSERT INTO public.who_global_data VALUES (15689, 0, 0, 0, 0, 67, 43);
INSERT INTO public.who_global_data VALUES (15690, 2006, 139099, 25, 1715, 67, 49);
INSERT INTO public.who_global_data VALUES (15691, 21, 21331, 1, 132, 67, 1);
INSERT INTO public.who_global_data VALUES (15692, 1830, 128442, 74, 1786, 67, 48);
INSERT INTO public.who_global_data VALUES (15693, 51, 8284, 1, 135, 67, 232);
INSERT INTO public.who_global_data VALUES (15694, 318, 2364, 1, 4, 67, 175);
INSERT INTO public.who_global_data VALUES (15695, 182, 10565, 1, 49, 67, 21);
INSERT INTO public.who_global_data VALUES (15696, 3575, 523298, 157, 8295, 67, 156);
INSERT INTO public.who_global_data VALUES (15697, 0, 0, 0, 0, 67, 95);
INSERT INTO public.who_global_data VALUES (15698, 70, 12771, 0, 333, 67, 177);
INSERT INTO public.who_global_data VALUES (15699, 1129, 80481, 8, 837, 67, 210);
INSERT INTO public.who_global_data VALUES (15700, 2, 5679, 0, 61, 67, 120);
INSERT INTO public.who_global_data VALUES (15701, 0, 85, 0, 0, 67, 135);
INSERT INTO public.who_global_data VALUES (15702, 515, 143988, 1, 2331, 67, 206);
INSERT INTO public.who_global_data VALUES (15703, 568, 192685, 38, 13461, 67, 189);
INSERT INTO public.who_global_data VALUES (15704, 370, 115911, 14, 6650, 67, 129);
INSERT INTO public.who_global_data VALUES (15705, 0, 38405, 3, 1114, 67, 121);
INSERT INTO public.who_global_data VALUES (15706, 0, 5153, 0, 85, 67, 59);
INSERT INTO public.who_global_data VALUES (15707, 0, 577, 0, 0, 67, 96);
INSERT INTO public.who_global_data VALUES (15708, 256, 12308, 6, 118, 67, 41);
INSERT INTO public.who_global_data VALUES (15709, 9, 6419, 1, 122, 67, 216);
INSERT INTO public.who_global_data VALUES (15710, 540, 110074, 6, 1706, 67, 236);
INSERT INTO public.who_global_data VALUES (15711, 0, 17, 0, 0, 67, 150);
INSERT INTO public.who_global_data VALUES (15712, 1, 503, 0, 0, 67, 61);
INSERT INTO public.who_global_data VALUES (15713, 4, 42, 0, 2, 67, 7);
INSERT INTO public.who_global_data VALUES (15714, 283, 24912, 6, 399, 67, 169);
INSERT INTO public.who_global_data VALUES (15715, 3794, 2183275, 406, 52371, 67, 28);
INSERT INTO public.who_global_data VALUES (15716, 25, 11204, 0, 70, 67, 85);
INSERT INTO public.who_global_data VALUES (15717, 276, 14372, 2, 75, 67, 211);
INSERT INTO public.who_global_data VALUES (15718, 0, 9191, 0, 59, 67, 60);
INSERT INTO public.who_global_data VALUES (15719, 8, 3742, 0, 123, 67, 3);
INSERT INTO public.who_global_data VALUES (15720, 3759, 139343, 36, 1303, 67, 11);
INSERT INTO public.who_global_data VALUES (15721, 13604, 1067473, 388, 16636, 67, 89);
INSERT INTO public.who_global_data VALUES (15722, 98, 51667, 0, 323, 67, 24);
INSERT INTO public.who_global_data VALUES (15723, 5, 1014, 0, 5, 67, 162);
INSERT INTO public.who_global_data VALUES (15724, 1044, 105271, 85, 2406, 67, 100);
INSERT INTO public.who_global_data VALUES (15725, 0, 18, 0, 0, 67, 47);
INSERT INTO public.who_global_data VALUES (15726, 0, 41, 0, 0, 67, 29);
INSERT INTO public.who_global_data VALUES (15727, 34, 8378, 0, 149, 67, 40);
INSERT INTO public.who_global_data VALUES (15728, 31, 6722, 0, 112, 67, 222);
INSERT INTO public.who_global_data VALUES (15729, 91, 122062, 5, 4171, 67, 132);
INSERT INTO public.who_global_data VALUES (15730, 0, 286, 0, 13, 67, 130);
INSERT INTO public.who_global_data VALUES (15731, 58, 13097, 0, 76, 67, 234);
INSERT INTO public.who_global_data VALUES (15732, 0, 2422, 0, 43, 67, 23);
INSERT INTO public.who_global_data VALUES (15733, 38, 5376, 1, 150, 67, 192);
INSERT INTO public.who_global_data VALUES (15734, 22, 9294, 1, 233, 67, 69);
INSERT INTO public.who_global_data VALUES (15735, 0, 26, 0, 0, 67, 187);
INSERT INTO public.who_global_data VALUES (15736, 375, 107888, 4, 2909, 67, 230);
INSERT INTO public.who_global_data VALUES (15737, 3951, 221073, 154, 4977, 67, 77);
INSERT INTO public.who_global_data VALUES (15738, 11, 5392, 0, 26, 67, 9);
INSERT INTO public.who_global_data VALUES (15739, 31118, 9462809, 482, 137621, 67, 74);
INSERT INTO public.who_global_data VALUES (15740, 4617, 538883, 130, 16945, 67, 224);
INSERT INTO public.who_global_data VALUES (15741, 13321, 962070, 371, 48246, 67, 199);
INSERT INTO public.who_global_data VALUES (15742, 2114, 552549, 34, 12258, 67, 190);
INSERT INTO public.who_global_data VALUES (15743, 303, 72544, 1, 2053, 67, 12);
INSERT INTO public.who_global_data VALUES (15744, 0, 369, 0, 25, 67, 104);
INSERT INTO public.who_global_data VALUES (15745, 1024, 335942, 10, 2871, 67, 153);
INSERT INTO public.who_global_data VALUES (15746, 16376, 1601554, 672, 55576, 67, 91);
INSERT INTO public.who_global_data VALUES (15747, 54, 10763, 1, 257, 67, 215);
INSERT INTO public.who_global_data VALUES (15748, 1934, 148694, 20, 2139, 67, 84);
INSERT INTO public.who_global_data VALUES (15749, 0, 923, 0, 32, 67, 231);
INSERT INTO public.who_global_data VALUES (15750, 5123, 219430, 57, 2751, 67, 196);
INSERT INTO public.who_global_data VALUES (15751, 1002, 175565, 0, 2477, 67, 105);
INSERT INTO public.who_global_data VALUES (15752, 302, 83618, 17, 1469, 67, 122);
INSERT INTO public.who_global_data VALUES (15753, 0, 0, 0, 0, 67, 159);
INSERT INTO public.who_global_data VALUES (15754, 539, 39553, 11, 1006, 67, 75);
INSERT INTO public.who_global_data VALUES (15755, 209, 142635, 2, 880, 67, 27);
INSERT INTO public.who_global_data VALUES (15756, 371, 73178, 4, 1275, 67, 54);
INSERT INTO public.who_global_data VALUES (15757, 0, 39, 0, 0, 67, 226);
INSERT INTO public.who_global_data VALUES (15758, 100, 17075, 9, 206, 67, 79);
INSERT INTO public.who_global_data VALUES (15759, 1000, 127903, 14, 1018, 67, 56);
INSERT INTO public.who_global_data VALUES (15760, 0, 2109, 0, 44, 67, 117);
INSERT INTO public.who_global_data VALUES (15761, 0, 1598, 0, 83, 67, 152);
INSERT INTO public.who_global_data VALUES (15762, 379, 82809, 17, 1183, 67, 16);
INSERT INTO public.who_global_data VALUES (15763, 33, 1345, 0, 16, 67, 10);
INSERT INTO public.who_global_data VALUES (15764, 1188, 62509, 20, 642, 67, 201);
INSERT INTO public.who_global_data VALUES (15765, 565, 34538, 6, 312, 67, 174);
INSERT INTO public.who_global_data VALUES (15766, 0, 17341, 0, 251, 67, 119);
INSERT INTO public.who_global_data VALUES (15767, 3, 6028, 0, 185, 67, 168);
INSERT INTO public.who_global_data VALUES (15768, 1212, 65697, 3, 360, 67, 99);
INSERT INTO public.who_global_data VALUES (15769, 17, 13011, 0, 46, 67, 171);
INSERT INTO public.who_global_data VALUES (15770, 0, 4688, 0, 152, 67, 87);
INSERT INTO public.who_global_data VALUES (15771, 121, 9873, 4, 137, 67, 123);
INSERT INTO public.who_global_data VALUES (15772, 0, 4, 0, 0, 67, 151);
INSERT INTO public.who_global_data VALUES (15773, 73, 5486, 0, 40, 67, 213);
INSERT INTO public.who_global_data VALUES (15774, 0, 8424, 0, 172, 67, 118);
INSERT INTO public.who_global_data VALUES (15775, 3, 504, 0, 10, 67, 134);
INSERT INTO public.who_global_data VALUES (15776, 0, 5181, 0, 49, 67, 65);
INSERT INTO public.who_global_data VALUES (15777, 6388, 1107071, 196, 105655, 67, 102);
INSERT INTO public.who_global_data VALUES (15778, 0, 0, 0, 0, 67, 223);
INSERT INTO public.who_global_data VALUES (15779, 1, 612, 0, 3, 67, 4);
INSERT INTO public.who_global_data VALUES (15780, 7, 791, 0, 0, 67, 146);
INSERT INTO public.who_global_data VALUES (15781, 492, 36277, 5, 503, 67, 31);
INSERT INTO public.who_global_data VALUES (15782, 0, 13, 0, 1, 67, 127);
INSERT INTO public.who_global_data VALUES (15783, 2532, 356335, 57, 5846, 67, 22);
INSERT INTO public.who_global_data VALUES (15784, 88, 15701, 1, 131, 67, 115);
INSERT INTO public.who_global_data VALUES (15785, 1509, 89486, 31, 1918, 67, 106);
INSERT INTO public.who_global_data VALUES (15786, 35, 14380, 1, 152, 67, 90);
INSERT INTO public.who_global_data VALUES (15787, 0, 0, 0, 0, 67, 70);
INSERT INTO public.who_global_data VALUES (15788, 1474, 233452, 29, 1508, 67, 46);
INSERT INTO public.who_global_data VALUES (15789, 4573, 522289, 28, 9354, 67, 139);
INSERT INTO public.who_global_data VALUES (15790, 1, 33, 0, 0, 67, 42);
INSERT INTO public.who_global_data VALUES (15791, 3, 1703, 0, 25, 67, 80);
INSERT INTO public.who_global_data VALUES (15792, 0, 4629, 0, 160, 67, 203);
INSERT INTO public.who_global_data VALUES (15793, 32, 1548, 2, 72, 67, 136);
INSERT INTO public.who_global_data VALUES (15794, 145, 67557, 0, 1173, 67, 63);
INSERT INTO public.who_global_data VALUES (15795, 0, 0, 0, 0, 67, 17);
INSERT INTO public.who_global_data VALUES (15796, 1, 106, 0, 2, 67, 172);
INSERT INTO public.who_global_data VALUES (15797, 335, 61878, 32, 1763, 67, 109);
INSERT INTO public.who_global_data VALUES (15798, 1079, 35826, 4, 332, 67, 200);
INSERT INTO public.who_global_data VALUES (15799, 2062, 98850, 15, 822, 67, 93);
INSERT INTO public.who_global_data VALUES (15800, 215, 123699, 5, 1423, 67, 5);
INSERT INTO public.who_global_data VALUES (15801, 0, 741, 0, 13, 67, 214);
INSERT INTO public.who_global_data VALUES (15802, 2839, 398024, 40, 8025, 67, 204);
INSERT INTO public.who_global_data VALUES (15803, 0, 0, 0, 0, 67, 198);
INSERT INTO public.who_global_data VALUES (15804, 1276, 164729, 21, 3060, 67, 173);
INSERT INTO public.who_global_data VALUES (15805, 1, 656, 0, 7, 67, 229);
INSERT INTO public.who_global_data VALUES (15806, 775, 81906, 12, 1743, 67, 76);
INSERT INTO public.who_global_data VALUES (15807, 2162, 962530, 44, 35923, 67, 138);
INSERT INTO public.who_global_data VALUES (15808, 1766, 431630, 19, 8392, 67, 98);
INSERT INTO public.who_global_data VALUES (15809, 0, 0, 0, 0, 67, 103);
INSERT INTO public.who_global_data VALUES (15810, 5736, 990811, 121, 17150, 67, 225);
INSERT INTO public.who_global_data VALUES (15811, 3262, 298061, 78, 4505, 67, 131);
INSERT INTO public.who_global_data VALUES (15812, 843, 52545, 12, 1106, 67, 235);
INSERT INTO public.who_global_data VALUES (15813, 185, 138833, 0, 237, 67, 137);
INSERT INTO public.who_global_data VALUES (15814, 451, 34650, 0, 526, 67, 81);
INSERT INTO public.who_global_data VALUES (15815, 347, 107364, 14, 2304, 67, 182);
INSERT INTO public.who_global_data VALUES (15816, 0, 8054, 0, 40, 67, 145);
INSERT INTO public.who_global_data VALUES (15817, 3826, 475362, 138, 11331, 67, 26);
INSERT INTO public.who_global_data VALUES (15818, 26402, 2322056, 569, 40464, 67, 170);
INSERT INTO public.who_global_data VALUES (15819, 15, 5934, 1, 49, 67, 191);
INSERT INTO public.who_global_data VALUES (15820, 0, 5, 0, 0, 67, 221);
INSERT INTO public.who_global_data VALUES (15821, 25, 152, 0, 0, 67, 64);
INSERT INTO public.who_global_data VALUES (15822, 0, 0, 0, 0, 67, 116);
INSERT INTO public.who_global_data VALUES (15823, 0, 22, 0, 0, 67, 128);
INSERT INTO public.who_global_data VALUES (15824, 5, 257, 0, 2, 67, 6);
INSERT INTO public.who_global_data VALUES (15825, 54, 744, 0, 12, 67, 227);
INSERT INTO public.who_global_data VALUES (15826, 0, 14, 0, 0, 67, 68);
INSERT INTO public.who_global_data VALUES (15827, 0, 85, 0, 0, 67, 184);
INSERT INTO public.who_global_data VALUES (15828, 0, 0, 0, 0, 67, 82);
INSERT INTO public.who_global_data VALUES (15829, 3, 1612, 1, 46, 67, 149);
INSERT INTO public.who_global_data VALUES (15830, 2, 991, 0, 17, 67, 197);
INSERT INTO public.who_global_data VALUES (15831, 232, 357360, 12, 5896, 67, 78);
INSERT INTO public.who_global_data VALUES (15832, 14, 16089, 0, 333, 67, 233);
INSERT INTO public.who_global_data VALUES (15833, 6224, 175438, 55, 1604, 67, 133);
INSERT INTO public.who_global_data VALUES (15834, 0, 172, 0, 0, 67, 35);
INSERT INTO public.who_global_data VALUES (15835, 1, 2412, 0, 74, 67, 114);
INSERT INTO public.who_global_data VALUES (15836, 5, 58218, 0, 29, 67, 237);
INSERT INTO public.who_global_data VALUES (15837, 0, 14, 0, 0, 67, 55);
INSERT INTO public.who_global_data VALUES (15838, 25, 1066, 0, 25, 67, 176);
INSERT INTO public.who_global_data VALUES (15839, 2760, 108493, 43, 859, 67, 202);
INSERT INTO public.who_global_data VALUES (15840, 1299, 77171, 58, 1622, 67, 155);
INSERT INTO public.who_global_data VALUES (15841, 0, 17, 0, 0, 67, 32);
INSERT INTO public.who_global_data VALUES (15842, 0, 4451, 0, 113, 67, 220);
INSERT INTO public.who_global_data VALUES (15843, 2302, 790004, 58, 21535, 67, 30);
INSERT INTO public.who_global_data VALUES (15844, 5, 3109, 0, 61, 67, 147);
INSERT INTO public.who_global_data VALUES (15845, 3453, 1710497, 181, 46963, 67, 208);
INSERT INTO public.who_global_data VALUES (15846, 496, 23484, 7, 116, 67, 45);
INSERT INTO public.who_global_data VALUES (15847, 209, 18254, 10, 1265, 67, 110);
INSERT INTO public.who_global_data VALUES (15848, 0, 5312, 0, 117, 67, 88);
INSERT INTO public.who_global_data VALUES (15849, 2753, 257557, 50, 7197, 67, 51);
INSERT INTO public.who_global_data VALUES (15850, 5270, 332225, 91, 4763, 67, 209);
INSERT INTO public.who_global_data VALUES (15851, 90, 7887, 4, 417, 67, 205);
INSERT INTO public.who_global_data VALUES (15852, 39, 12194, 0, 86, 67, 18);
INSERT INTO public.who_global_data VALUES (15853, 21, 3998, 0, 60, 67, 72);
INSERT INTO public.who_global_data VALUES (15854, 12330, 1629661, 203, 58448, 67, 44);
INSERT INTO public.who_global_data VALUES (15855, 0, 30, 0, 0, 67, 15);
INSERT INTO public.who_global_data VALUES (15856, 0, 2946, 0, 64, 67, 25);
INSERT INTO public.who_global_data VALUES (15857, 0, 0, 0, 0, 67, 179);
INSERT INTO public.who_global_data VALUES (15858, 0, 0, 0, 0, 67, 34);
INSERT INTO public.who_global_data VALUES (15859, 30, 6660, 2, 120, 67, 207);
INSERT INTO public.who_global_data VALUES (15860, 518, 96769, 41, 3260, 67, 166);
INSERT INTO public.who_global_data VALUES (15861, 31219, 1431648, 188, 13746, 67, 126);
INSERT INTO public.who_global_data VALUES (15862, 0, 0, 0, 0, 67, 97);
INSERT INTO public.who_global_data VALUES (15863, 0, 748, 0, 6, 67, 36);
INSERT INTO public.who_global_data VALUES (15864, 0, 0, 0, 0, 67, 125);
INSERT INTO public.who_global_data VALUES (15865, 314, 20459, 4, 205, 67, 124);
INSERT INTO public.who_global_data VALUES (15866, 12498, 745123, 221, 12548, 67, 185);
INSERT INTO public.who_global_data VALUES (15867, 1107, 168860, 2, 572, 67, 194);
INSERT INTO public.who_global_data VALUES (15868, 0, 509, 0, 21, 67, 144);
INSERT INTO public.who_global_data VALUES (15869, 151674, 13234551, 862, 264808, 67, 19);
INSERT INTO public.who_global_data VALUES (15870, 0, 1544, 0, 23, 67, 217);
INSERT INTO public.who_global_data VALUES (15871, 205, 5716, 1, 76, 67, 148);
INSERT INTO public.who_global_data VALUES (15872, 174, 73094, 2, 610, 67, 86);
INSERT INTO public.who_global_data VALUES (15873, 0, 1, 0, 0, 67, 13);
INSERT INTO public.who_global_data VALUES (15874, 280, 102040, 2, 894, 67, 157);
INSERT INTO public.who_global_data VALUES (15875, 4, 1347, 0, 35, 67, 8);
INSERT INTO public.who_global_data VALUES (15876, 0, 3, 0, 0, 67, 73);
INSERT INTO public.who_global_data VALUES (15877, 0, 2081, 0, 606, 67, 101);
INSERT INTO public.who_global_data VALUES (15878, 39, 17647, 0, 357, 67, 165);
INSERT INTO public.who_global_data VALUES (15879, 84, 10034, 1, 277, 67, 14);
INSERT INTO public.who_global_data VALUES (15880, 249, 46215, 11, 1763, 68, 193);
INSERT INTO public.who_global_data VALUES (15881, 835, 37625, 11, 798, 68, 113);
INSERT INTO public.who_global_data VALUES (15882, 0, 81212, 0, 2393, 68, 143);
INSERT INTO public.who_global_data VALUES (15883, 0, 0, 0, 0, 68, 219);
INSERT INTO public.who_global_data VALUES (15884, 102, 6712, 0, 76, 68, 186);
INSERT INTO public.who_global_data VALUES (15885, 16, 15103, 1, 346, 68, 52);
INSERT INTO public.who_global_data VALUES (15886, 2, 6, 0, 0, 68, 180);
INSERT INTO public.who_global_data VALUES (15887, 0, 141, 0, 4, 68, 167);
INSERT INTO public.who_global_data VALUES (15888, 6098, 1413375, 106, 38322, 68, 154);
INSERT INTO public.who_global_data VALUES (15889, 356, 134437, 22, 2159, 68, 94);
INSERT INTO public.who_global_data VALUES (15890, 0, 4791, 0, 45, 68, 66);
INSERT INTO public.who_global_data VALUES (15891, 8, 27893, 0, 907, 68, 58);
INSERT INTO public.who_global_data VALUES (15892, 3907, 278182, 82, 2904, 68, 163);
INSERT INTO public.who_global_data VALUES (15893, 4170, 118195, 38, 1361, 68, 37);
INSERT INTO public.who_global_data VALUES (15894, 7, 7503, 0, 163, 68, 142);
INSERT INTO public.who_global_data VALUES (15895, 142, 86787, 0, 341, 68, 83);
INSERT INTO public.who_global_data VALUES (15896, 1788, 462407, 29, 6609, 68, 228);
INSERT INTO public.who_global_data VALUES (15897, 5, 275, 0, 7, 68, 188);
INSERT INTO public.who_global_data VALUES (15898, 1684, 135008, 8, 1151, 68, 62);
INSERT INTO public.who_global_data VALUES (15899, 560, 577989, 118, 16739, 68, 160);
INSERT INTO public.who_global_data VALUES (15900, 60, 5647, 3, 144, 68, 50);
INSERT INTO public.who_global_data VALUES (15901, 0, 2974, 0, 43, 68, 33);
INSERT INTO public.who_global_data VALUES (15902, 4, 251, 0, 9, 68, 183);
INSERT INTO public.who_global_data VALUES (15903, 0, 396, 0, 0, 68, 92);
INSERT INTO public.who_global_data VALUES (15904, 98, 144592, 6, 8949, 68, 158);
INSERT INTO public.who_global_data VALUES (15905, 0, 142, 0, 3, 68, 67);
INSERT INTO public.who_global_data VALUES (15906, 664, 87374, 44, 2620, 68, 57);
INSERT INTO public.who_global_data VALUES (15907, 0, 9992, 0, 31, 68, 38);
INSERT INTO public.who_global_data VALUES (15908, 51922, 6290272, 587, 172561, 68, 141);
INSERT INTO public.who_global_data VALUES (15909, 1, 73, 0, 1, 68, 178);
INSERT INTO public.who_global_data VALUES (15910, 0, 150, 0, 3, 68, 108);
INSERT INTO public.who_global_data VALUES (15911, 739, 142486, 65, 3814, 68, 39);
INSERT INTO public.who_global_data VALUES (15912, 40, 2856, 0, 68, 68, 2);
INSERT INTO public.who_global_data VALUES (15913, 7, 688, 0, 1, 68, 195);
INSERT INTO public.who_global_data VALUES (15914, 0, 10526, 0, 104, 68, 107);
INSERT INTO public.who_global_data VALUES (15915, 8, 323, 0, 0, 68, 161);
INSERT INTO public.who_global_data VALUES (15916, 328, 24445, 0, 437, 68, 212);
INSERT INTO public.who_global_data VALUES (15917, 5746, 364810, 82, 11976, 68, 181);
INSERT INTO public.who_global_data VALUES (15918, 0, 274, 0, 2, 68, 53);
INSERT INTO public.who_global_data VALUES (15919, 0, 4913, 0, 63, 68, 164);
INSERT INTO public.who_global_data VALUES (15920, 19, 1682, 0, 101, 68, 140);
INSERT INTO public.who_global_data VALUES (15921, 1489, 550430, 34, 15356, 68, 20);
INSERT INTO public.who_global_data VALUES (15922, 136, 93465, 0, 4750, 68, 112);
INSERT INTO public.who_global_data VALUES (15923, 9103, 1299613, 187, 36401, 68, 111);
INSERT INTO public.who_global_data VALUES (15924, 0, 610, 0, 7, 68, 71);
INSERT INTO public.who_global_data VALUES (15925, 0, 5774, 0, 94, 68, 218);
INSERT INTO public.who_global_data VALUES (15926, 0, 0, 0, 0, 68, 43);
INSERT INTO public.who_global_data VALUES (15927, 0, 137093, 0, 1690, 68, 49);
INSERT INTO public.who_global_data VALUES (15928, 49, 21310, 0, 131, 68, 1);
INSERT INTO public.who_global_data VALUES (15929, 2919, 126612, 57, 1712, 68, 48);
INSERT INTO public.who_global_data VALUES (15930, 60, 8233, 1, 134, 68, 232);
INSERT INTO public.who_global_data VALUES (15931, 0, 2046, 0, 3, 68, 175);
INSERT INTO public.who_global_data VALUES (15932, 152, 10383, 0, 48, 68, 21);
INSERT INTO public.who_global_data VALUES (15933, 1074, 519723, 84, 8138, 68, 156);
INSERT INTO public.who_global_data VALUES (15934, 0, 0, 0, 0, 68, 95);
INSERT INTO public.who_global_data VALUES (15935, 94, 12701, 0, 333, 68, 177);
INSERT INTO public.who_global_data VALUES (15936, 998, 79352, 6, 829, 68, 210);
INSERT INTO public.who_global_data VALUES (15937, 1, 5677, 0, 61, 68, 120);
INSERT INTO public.who_global_data VALUES (15938, 0, 85, 0, 0, 68, 135);
INSERT INTO public.who_global_data VALUES (15939, 820, 143473, 2, 2330, 68, 206);
INSERT INTO public.who_global_data VALUES (15940, 1208, 192117, 52, 13423, 68, 189);
INSERT INTO public.who_global_data VALUES (15941, 358, 115541, 15, 6636, 68, 129);
INSERT INTO public.who_global_data VALUES (15942, 0, 38405, 4, 1111, 68, 121);
INSERT INTO public.who_global_data VALUES (15943, 0, 5153, 0, 85, 68, 59);
INSERT INTO public.who_global_data VALUES (15944, 0, 577, 0, 0, 68, 96);
INSERT INTO public.who_global_data VALUES (15945, 354, 12052, 3, 112, 68, 41);
INSERT INTO public.who_global_data VALUES (15946, 4, 6410, 0, 121, 68, 216);
INSERT INTO public.who_global_data VALUES (15947, 604, 109534, 5, 1700, 68, 236);
INSERT INTO public.who_global_data VALUES (15948, 0, 17, 0, 0, 68, 150);
INSERT INTO public.who_global_data VALUES (15949, 0, 502, 0, 0, 68, 61);
INSERT INTO public.who_global_data VALUES (15950, 0, 38, 0, 2, 68, 7);
INSERT INTO public.who_global_data VALUES (15951, 322, 24629, 0, 393, 68, 169);
INSERT INTO public.who_global_data VALUES (15952, 9670, 2179481, 198, 51965, 68, 28);
INSERT INTO public.who_global_data VALUES (15953, 0, 11179, 0, 70, 68, 85);
INSERT INTO public.who_global_data VALUES (15954, 0, 14096, 0, 73, 68, 211);
INSERT INTO public.who_global_data VALUES (15955, 0, 9191, 0, 59, 68, 60);
INSERT INTO public.who_global_data VALUES (15956, 0, 3734, 0, 123, 68, 3);
INSERT INTO public.who_global_data VALUES (15957, 3216, 135584, 37, 1267, 68, 11);
INSERT INTO public.who_global_data VALUES (15958, 11169, 1053869, 125, 16248, 68, 89);
INSERT INTO public.who_global_data VALUES (15959, 190, 51569, 0, 323, 68, 24);
INSERT INTO public.who_global_data VALUES (15960, 10, 1009, 0, 5, 68, 162);
INSERT INTO public.who_global_data VALUES (15961, 1193, 104227, 98, 2321, 68, 100);
INSERT INTO public.who_global_data VALUES (15962, 0, 18, 0, 0, 68, 47);
INSERT INTO public.who_global_data VALUES (15963, 0, 41, 0, 0, 68, 29);
INSERT INTO public.who_global_data VALUES (15964, 0, 8344, 0, 149, 68, 40);
INSERT INTO public.who_global_data VALUES (15965, 36, 6691, 0, 112, 68, 222);
INSERT INTO public.who_global_data VALUES (15966, 173, 121971, 5, 4166, 68, 132);
INSERT INTO public.who_global_data VALUES (15967, 0, 286, 0, 13, 68, 130);
INSERT INTO public.who_global_data VALUES (15968, 0, 13039, 0, 76, 68, 234);
INSERT INTO public.who_global_data VALUES (15969, 0, 2422, 0, 43, 68, 23);
INSERT INTO public.who_global_data VALUES (15970, 28, 5338, 0, 149, 68, 192);
INSERT INTO public.who_global_data VALUES (15971, 8, 9272, 0, 232, 68, 69);
INSERT INTO public.who_global_data VALUES (15972, 0, 26, 0, 0, 68, 187);
INSERT INTO public.who_global_data VALUES (15973, 379, 107513, 6, 2905, 68, 230);
INSERT INTO public.who_global_data VALUES (15974, 5595, 217122, 151, 4823, 68, 77);
INSERT INTO public.who_global_data VALUES (15975, 10, 5381, 0, 26, 68, 9);
INSERT INTO public.who_global_data VALUES (15976, 38772, 9431691, 443, 137139, 68, 74);
INSERT INTO public.who_global_data VALUES (15977, 6267, 534266, 169, 16815, 68, 224);
INSERT INTO public.who_global_data VALUES (15978, 12950, 948749, 389, 47875, 68, 199);
INSERT INTO public.who_global_data VALUES (15979, 1614, 550435, 24, 12224, 68, 190);
INSERT INTO public.who_global_data VALUES (15980, 299, 72241, 2, 2052, 68, 12);
INSERT INTO public.who_global_data VALUES (15981, 0, 369, 0, 25, 68, 104);
INSERT INTO public.who_global_data VALUES (15982, 582, 334918, 10, 2861, 68, 153);
INSERT INTO public.who_global_data VALUES (15983, 20646, 1585178, 541, 54904, 68, 91);
INSERT INTO public.who_global_data VALUES (15984, 40, 10709, 5, 256, 68, 215);
INSERT INTO public.who_global_data VALUES (15985, 2107, 146760, 13, 2119, 68, 84);
INSERT INTO public.who_global_data VALUES (15986, 0, 923, 0, 32, 68, 231);
INSERT INTO public.who_global_data VALUES (15987, 3598, 214307, 68, 2694, 68, 196);
INSERT INTO public.who_global_data VALUES (15988, 757, 174563, 0, 2477, 68, 105);
INSERT INTO public.who_global_data VALUES (15989, 711, 83316, 7, 1452, 68, 122);
INSERT INTO public.who_global_data VALUES (15990, 0, 0, 0, 0, 68, 159);
INSERT INTO public.who_global_data VALUES (15991, 626, 39014, 16, 995, 68, 75);
INSERT INTO public.who_global_data VALUES (15992, 231, 142426, 3, 878, 68, 27);
INSERT INTO public.who_global_data VALUES (15993, 380, 72807, 5, 1271, 68, 54);
INSERT INTO public.who_global_data VALUES (15994, 0, 39, 0, 0, 68, 226);
INSERT INTO public.who_global_data VALUES (15995, 414, 16975, 4, 197, 68, 79);
INSERT INTO public.who_global_data VALUES (15996, 1266, 126903, 13, 1004, 68, 56);
INSERT INTO public.who_global_data VALUES (15997, 0, 2109, 0, 44, 68, 117);
INSERT INTO public.who_global_data VALUES (15998, 3, 1598, 0, 83, 68, 152);
INSERT INTO public.who_global_data VALUES (15999, 1157, 82430, 13, 1166, 68, 16);
INSERT INTO public.who_global_data VALUES (16000, 11, 1312, 0, 16, 68, 10);
INSERT INTO public.who_global_data VALUES (16001, 1136, 61321, 27, 622, 68, 201);
INSERT INTO public.who_global_data VALUES (16002, 564, 33973, 6, 306, 68, 174);
INSERT INTO public.who_global_data VALUES (16003, 0, 17341, 0, 251, 68, 119);
INSERT INTO public.who_global_data VALUES (16004, 0, 6025, 0, 185, 68, 168);
INSERT INTO public.who_global_data VALUES (16005, 1309, 64485, 3, 357, 68, 99);
INSERT INTO public.who_global_data VALUES (16006, 47, 12994, 0, 46, 68, 171);
INSERT INTO public.who_global_data VALUES (16007, 121, 4688, 3, 152, 68, 87);
INSERT INTO public.who_global_data VALUES (16008, 143, 9752, 1, 133, 68, 123);
INSERT INTO public.who_global_data VALUES (16009, 0, 4, 0, 0, 68, 151);
INSERT INTO public.who_global_data VALUES (16010, 0, 5413, 0, 40, 68, 213);
INSERT INTO public.who_global_data VALUES (16011, 0, 8424, 0, 172, 68, 118);
INSERT INTO public.who_global_data VALUES (16012, 0, 501, 0, 10, 68, 134);
INSERT INTO public.who_global_data VALUES (16013, 0, 5181, 0, 49, 68, 65);
INSERT INTO public.who_global_data VALUES (16014, 10008, 1100683, 586, 105459, 68, 102);
INSERT INTO public.who_global_data VALUES (16015, 0, 0, 0, 0, 68, 223);
INSERT INTO public.who_global_data VALUES (16016, 1, 611, 0, 3, 68, 4);
INSERT INTO public.who_global_data VALUES (16017, 24, 784, 0, 0, 68, 146);
INSERT INTO public.who_global_data VALUES (16018, 558, 35785, 12, 498, 68, 31);
INSERT INTO public.who_global_data VALUES (16019, 0, 13, 0, 1, 68, 127);
INSERT INTO public.who_global_data VALUES (16020, 4115, 353803, 50, 5789, 68, 22);
INSERT INTO public.who_global_data VALUES (16021, 27, 15613, 1, 130, 68, 115);
INSERT INTO public.who_global_data VALUES (16022, 1344, 87977, 22, 1887, 68, 106);
INSERT INTO public.who_global_data VALUES (16023, 60, 14345, 1, 151, 68, 90);
INSERT INTO public.who_global_data VALUES (16024, 0, 0, 0, 0, 68, 70);
INSERT INTO public.who_global_data VALUES (16025, 1255, 231978, 25, 1479, 68, 46);
INSERT INTO public.who_global_data VALUES (16026, 5565, 517716, 25, 9326, 68, 139);
INSERT INTO public.who_global_data VALUES (16027, 0, 32, 0, 0, 68, 42);
INSERT INTO public.who_global_data VALUES (16028, 4, 1700, 0, 25, 68, 80);
INSERT INTO public.who_global_data VALUES (16029, 0, 4629, 0, 160, 68, 203);
INSERT INTO public.who_global_data VALUES (16030, 44, 1516, 0, 70, 68, 136);
INSERT INTO public.who_global_data VALUES (16031, 82, 67412, 2, 1173, 68, 63);
INSERT INTO public.who_global_data VALUES (16032, 0, 0, 0, 0, 68, 17);
INSERT INTO public.who_global_data VALUES (16033, 0, 105, 0, 2, 68, 172);
INSERT INTO public.who_global_data VALUES (16034, 820, 61543, 32, 1731, 68, 109);
INSERT INTO public.who_global_data VALUES (16035, 0, 34747, 0, 328, 68, 200);
INSERT INTO public.who_global_data VALUES (16036, 1927, 96788, 16, 807, 68, 93);
INSERT INTO public.who_global_data VALUES (16037, 905, 123484, 27, 1418, 68, 5);
INSERT INTO public.who_global_data VALUES (16038, 0, 741, 0, 13, 68, 214);
INSERT INTO public.who_global_data VALUES (16039, 2829, 395185, 43, 7985, 68, 204);
INSERT INTO public.who_global_data VALUES (16040, 0, 0, 0, 0, 68, 198);
INSERT INTO public.who_global_data VALUES (16041, 1709, 163453, 9, 3039, 68, 173);
INSERT INTO public.who_global_data VALUES (16042, 10, 655, 0, 7, 68, 229);
INSERT INTO public.who_global_data VALUES (16043, 695, 81131, 11, 1731, 68, 76);
INSERT INTO public.who_global_data VALUES (16044, 2044, 960368, 40, 35879, 68, 138);
INSERT INTO public.who_global_data VALUES (16045, 2067, 429864, 40, 8373, 68, 98);
INSERT INTO public.who_global_data VALUES (16046, 0, 0, 0, 0, 68, 103);
INSERT INTO public.who_global_data VALUES (16047, 11482, 985075, 283, 17029, 68, 225);
INSERT INTO public.who_global_data VALUES (16048, 4093, 294799, 64, 4427, 68, 131);
INSERT INTO public.who_global_data VALUES (16049, 121, 51702, 11, 1094, 68, 235);
INSERT INTO public.who_global_data VALUES (16050, 171, 138648, 0, 237, 68, 137);
INSERT INTO public.who_global_data VALUES (16051, 438, 34199, 3, 526, 68, 81);
INSERT INTO public.who_global_data VALUES (16052, 1165, 107017, 21, 2290, 68, 182);
INSERT INTO public.who_global_data VALUES (16053, 114, 8054, 0, 40, 68, 145);
INSERT INTO public.who_global_data VALUES (16054, 5554, 471536, 148, 11193, 68, 26);
INSERT INTO public.who_global_data VALUES (16055, 26338, 2295654, 368, 39895, 68, 170);
INSERT INTO public.who_global_data VALUES (16056, 47, 5919, 1, 48, 68, 191);
INSERT INTO public.who_global_data VALUES (16057, 0, 5, 0, 0, 68, 221);
INSERT INTO public.who_global_data VALUES (16058, 0, 127, 0, 0, 68, 64);
INSERT INTO public.who_global_data VALUES (16059, 0, 0, 0, 0, 68, 116);
INSERT INTO public.who_global_data VALUES (16060, 0, 22, 0, 0, 68, 128);
INSERT INTO public.who_global_data VALUES (16061, 6, 252, 0, 2, 68, 6);
INSERT INTO public.who_global_data VALUES (16062, 0, 690, 0, 12, 68, 227);
INSERT INTO public.who_global_data VALUES (16063, 0, 14, 0, 0, 68, 68);
INSERT INTO public.who_global_data VALUES (16064, 0, 85, 0, 0, 68, 184);
INSERT INTO public.who_global_data VALUES (16065, 0, 0, 0, 0, 68, 82);
INSERT INTO public.who_global_data VALUES (16066, 23, 1609, 0, 45, 68, 149);
INSERT INTO public.who_global_data VALUES (16067, 4, 989, 0, 17, 68, 197);
INSERT INTO public.who_global_data VALUES (16068, 217, 357128, 14, 5884, 68, 78);
INSERT INTO public.who_global_data VALUES (16069, 48, 16075, 1, 333, 68, 233);
INSERT INTO public.who_global_data VALUES (16070, 6179, 169214, 65, 1549, 68, 133);
INSERT INTO public.who_global_data VALUES (16071, 0, 172, 0, 0, 68, 35);
INSERT INTO public.who_global_data VALUES (16072, 1, 2411, 0, 74, 68, 114);
INSERT INTO public.who_global_data VALUES (16073, 8, 58213, 0, 29, 68, 237);
INSERT INTO public.who_global_data VALUES (16074, 0, 14, 0, 0, 68, 55);
INSERT INTO public.who_global_data VALUES (16075, 0, 1041, 0, 25, 68, 176);
INSERT INTO public.who_global_data VALUES (16076, 1101, 105733, 18, 816, 68, 202);
INSERT INTO public.who_global_data VALUES (16077, 427, 75872, 51, 1564, 68, 155);
INSERT INTO public.who_global_data VALUES (16078, 0, 17, 0, 0, 68, 32);
INSERT INTO public.who_global_data VALUES (16079, 0, 4451, 0, 113, 68, 220);
INSERT INTO public.who_global_data VALUES (16080, 2563, 787702, 38, 21477, 68, 30);
INSERT INTO public.who_global_data VALUES (16081, 0, 3104, 0, 61, 68, 147);
INSERT INTO public.who_global_data VALUES (16082, 5612, 1707044, 192, 46782, 68, 208);
INSERT INTO public.who_global_data VALUES (16083, 487, 22988, 2, 109, 68, 45);
INSERT INTO public.who_global_data VALUES (16084, 235, 18045, 6, 1255, 68, 110);
INSERT INTO public.who_global_data VALUES (16085, 1, 5312, 0, 117, 68, 88);
INSERT INTO public.who_global_data VALUES (16086, 3825, 254804, 50, 7147, 68, 51);
INSERT INTO public.who_global_data VALUES (16087, 1692, 326955, 81, 4672, 68, 209);
INSERT INTO public.who_global_data VALUES (16088, 82, 7797, 4, 413, 68, 205);
INSERT INTO public.who_global_data VALUES (16089, 37, 12155, 0, 86, 68, 18);
INSERT INTO public.who_global_data VALUES (16090, 11, 3977, 0, 60, 68, 72);
INSERT INTO public.who_global_data VALUES (16091, 12155, 1617331, 215, 58245, 68, 44);
INSERT INTO public.who_global_data VALUES (16092, 0, 30, 0, 0, 68, 15);
INSERT INTO public.who_global_data VALUES (16093, 20, 2946, 0, 64, 68, 25);
INSERT INTO public.who_global_data VALUES (16094, 0, 0, 0, 0, 68, 179);
INSERT INTO public.who_global_data VALUES (16095, 0, 0, 0, 0, 68, 34);
INSERT INTO public.who_global_data VALUES (16096, 44, 6630, 0, 118, 68, 207);
INSERT INTO public.who_global_data VALUES (16097, 1271, 96251, 66, 3219, 68, 166);
INSERT INTO public.who_global_data VALUES (16098, 29281, 1400429, 185, 13558, 68, 126);
INSERT INTO public.who_global_data VALUES (16099, 0, 0, 0, 0, 68, 97);
INSERT INTO public.who_global_data VALUES (16100, 0, 748, 0, 6, 68, 36);
INSERT INTO public.who_global_data VALUES (16101, 0, 0, 0, 0, 68, 125);
INSERT INTO public.who_global_data VALUES (16102, 201, 20145, 0, 201, 68, 124);
INSERT INTO public.who_global_data VALUES (16103, 9946, 732625, 114, 12327, 68, 185);
INSERT INTO public.who_global_data VALUES (16104, 1251, 167753, 1, 570, 68, 194);
INSERT INTO public.who_global_data VALUES (16105, 0, 509, 0, 21, 68, 144);
INSERT INTO public.who_global_data VALUES (16106, 143211, 13082877, 1210, 263946, 68, 19);
INSERT INTO public.who_global_data VALUES (16107, 6, 1544, 0, 23, 68, 217);
INSERT INTO public.who_global_data VALUES (16108, 208, 5511, 1, 75, 68, 148);
INSERT INTO public.who_global_data VALUES (16109, 111, 72920, 0, 608, 68, 86);
INSERT INTO public.who_global_data VALUES (16110, 0, 1, 0, 0, 68, 13);
INSERT INTO public.who_global_data VALUES (16111, 236, 101760, 4, 892, 68, 157);
INSERT INTO public.who_global_data VALUES (16112, 2, 1343, 0, 35, 68, 8);
INSERT INTO public.who_global_data VALUES (16113, 0, 3, 0, 0, 68, 73);
INSERT INTO public.who_global_data VALUES (16114, 3, 2081, 1, 606, 68, 101);
INSERT INTO public.who_global_data VALUES (16115, 19, 17608, 0, 357, 68, 165);
INSERT INTO public.who_global_data VALUES (16116, 128, 9950, 1, 276, 68, 14);
INSERT INTO public.who_global_data VALUES (16117, 127, 45966, 12, 1752, 69, 193);
INSERT INTO public.who_global_data VALUES (16118, 545, 36790, 16, 787, 69, 113);
INSERT INTO public.who_global_data VALUES (16119, 1044, 81212, 21, 2393, 69, 143);
INSERT INTO public.who_global_data VALUES (16120, 0, 0, 0, 0, 69, 219);
INSERT INTO public.who_global_data VALUES (16121, 0, 6610, 0, 76, 69, 186);
INSERT INTO public.who_global_data VALUES (16122, 79, 15087, 3, 345, 69, 52);
INSERT INTO public.who_global_data VALUES (16123, 0, 4, 0, 0, 69, 180);
INSERT INTO public.who_global_data VALUES (16124, 0, 141, 0, 4, 69, 167);
INSERT INTO public.who_global_data VALUES (16125, 7846, 1407277, 275, 38216, 69, 154);
INSERT INTO public.who_global_data VALUES (16126, 1174, 134081, 21, 2137, 69, 94);
INSERT INTO public.who_global_data VALUES (16127, 0, 4791, 0, 45, 69, 66);
INSERT INTO public.who_global_data VALUES (16128, 11, 27885, 0, 907, 69, 58);
INSERT INTO public.who_global_data VALUES (16129, 4765, 274275, 58, 2822, 69, 163);
INSERT INTO public.who_global_data VALUES (16130, 4212, 114025, 32, 1323, 69, 37);
INSERT INTO public.who_global_data VALUES (16131, 0, 7496, 0, 163, 69, 142);
INSERT INTO public.who_global_data VALUES (16132, 130, 86645, 0, 341, 69, 83);
INSERT INTO public.who_global_data VALUES (16133, 1908, 460619, 36, 6580, 69, 228);
INSERT INTO public.who_global_data VALUES (16134, 0, 270, 0, 7, 69, 188);
INSERT INTO public.who_global_data VALUES (16135, 1691, 133324, 7, 1143, 69, 62);
INSERT INTO public.who_global_data VALUES (16136, 1006, 577429, 115, 16621, 69, 160);
INSERT INTO public.who_global_data VALUES (16137, 72, 5587, 10, 141, 69, 50);
INSERT INTO public.who_global_data VALUES (16138, 0, 2974, 0, 43, 69, 33);
INSERT INTO public.who_global_data VALUES (16139, 5, 247, 0, 9, 69, 183);
INSERT INTO public.who_global_data VALUES (16140, 1, 396, 0, 0, 69, 92);
INSERT INTO public.who_global_data VALUES (16141, 104, 144494, 4, 8943, 69, 158);
INSERT INTO public.who_global_data VALUES (16142, 0, 142, 0, 3, 69, 67);
INSERT INTO public.who_global_data VALUES (16143, 1279, 86710, 34, 2576, 69, 57);
INSERT INTO public.who_global_data VALUES (16144, 0, 9992, 0, 31, 69, 38);
INSERT INTO public.who_global_data VALUES (16145, 34130, 6238350, 514, 171974, 69, 141);
INSERT INTO public.who_global_data VALUES (16146, 0, 72, 0, 1, 69, 178);
INSERT INTO public.who_global_data VALUES (16147, 0, 150, 0, 3, 69, 108);
INSERT INTO public.who_global_data VALUES (16148, 1792, 141747, 69, 3749, 69, 39);
INSERT INTO public.who_global_data VALUES (16149, 0, 2816, 0, 68, 69, 2);
INSERT INTO public.who_global_data VALUES (16150, 0, 681, 0, 1, 69, 195);
INSERT INTO public.who_global_data VALUES (16151, 0, 10526, 0, 104, 69, 107);
INSERT INTO public.who_global_data VALUES (16152, 7, 315, 0, 0, 69, 161);
INSERT INTO public.who_global_data VALUES (16153, 0, 24117, 0, 437, 69, 212);
INSERT INTO public.who_global_data VALUES (16154, 5967, 359064, 95, 11894, 69, 181);
INSERT INTO public.who_global_data VALUES (16155, 5, 274, 0, 2, 69, 53);
INSERT INTO public.who_global_data VALUES (16156, 0, 4913, 0, 63, 69, 164);
INSERT INTO public.who_global_data VALUES (16157, 0, 1663, 0, 101, 69, 140);
INSERT INTO public.who_global_data VALUES (16158, 1718, 548941, 44, 15322, 69, 20);
INSERT INTO public.who_global_data VALUES (16159, 104, 93329, 1, 4750, 69, 112);
INSERT INTO public.who_global_data VALUES (16160, 10023, 1290510, 195, 36214, 69, 111);
INSERT INTO public.who_global_data VALUES (16161, 0, 610, 0, 7, 69, 71);
INSERT INTO public.who_global_data VALUES (16162, 0, 5774, 0, 94, 69, 218);
INSERT INTO public.who_global_data VALUES (16163, 0, 0, 0, 0, 69, 43);
INSERT INTO public.who_global_data VALUES (16164, 1351, 137093, 11, 1690, 69, 49);
INSERT INTO public.who_global_data VALUES (16165, 29, 21261, 0, 131, 69, 1);
INSERT INTO public.who_global_data VALUES (16166, 3987, 123693, 55, 1655, 69, 48);
INSERT INTO public.who_global_data VALUES (16167, 63, 8173, 0, 133, 69, 232);
INSERT INTO public.who_global_data VALUES (16168, 0, 2046, 0, 3, 69, 175);
INSERT INTO public.who_global_data VALUES (16169, 248, 10231, 0, 48, 69, 21);
INSERT INTO public.who_global_data VALUES (16170, 2665, 518649, 87, 8054, 69, 156);
INSERT INTO public.who_global_data VALUES (16171, 0, 0, 0, 0, 69, 95);
INSERT INTO public.who_global_data VALUES (16172, 67, 12607, 0, 333, 69, 177);
INSERT INTO public.who_global_data VALUES (16173, 1636, 78354, 7, 823, 69, 210);
INSERT INTO public.who_global_data VALUES (16174, 0, 5676, 0, 61, 69, 120);
INSERT INTO public.who_global_data VALUES (16175, 0, 85, 0, 0, 69, 135);
INSERT INTO public.who_global_data VALUES (16176, 876, 142653, 4, 2328, 69, 206);
INSERT INTO public.who_global_data VALUES (16177, 1375, 190909, 13, 13371, 69, 189);
INSERT INTO public.who_global_data VALUES (16178, 351, 115183, 13, 6621, 69, 129);
INSERT INTO public.who_global_data VALUES (16179, 0, 38405, 5, 1107, 69, 121);
INSERT INTO public.who_global_data VALUES (16180, 0, 5153, 0, 85, 69, 59);
INSERT INTO public.who_global_data VALUES (16181, 11, 577, 0, 0, 69, 96);
INSERT INTO public.who_global_data VALUES (16182, 375, 11698, 5, 109, 69, 41);
INSERT INTO public.who_global_data VALUES (16183, 44, 6406, 1, 121, 69, 216);
INSERT INTO public.who_global_data VALUES (16184, 492, 108930, 9, 1695, 69, 236);
INSERT INTO public.who_global_data VALUES (16185, 1, 17, 0, 0, 69, 150);
INSERT INTO public.who_global_data VALUES (16186, 2, 502, 0, 0, 69, 61);
INSERT INTO public.who_global_data VALUES (16187, 0, 38, 0, 2, 69, 7);
INSERT INTO public.who_global_data VALUES (16188, 541, 24307, 0, 393, 69, 169);
INSERT INTO public.who_global_data VALUES (16189, 12479, 2169811, 213, 51767, 69, 28);
INSERT INTO public.who_global_data VALUES (16190, 21, 11179, 0, 70, 69, 85);
INSERT INTO public.who_global_data VALUES (16191, 0, 14096, 0, 73, 69, 211);
INSERT INTO public.who_global_data VALUES (16192, 0, 9191, 0, 59, 69, 60);
INSERT INTO public.who_global_data VALUES (16193, 3, 3734, 0, 123, 69, 3);
INSERT INTO public.who_global_data VALUES (16194, 4426, 132368, 35, 1230, 69, 11);
INSERT INTO public.who_global_data VALUES (16195, 14611, 1042700, 158, 16123, 69, 89);
INSERT INTO public.who_global_data VALUES (16196, 154, 51379, 0, 323, 69, 24);
INSERT INTO public.who_global_data VALUES (16197, 8, 999, 0, 5, 69, 162);
INSERT INTO public.who_global_data VALUES (16198, 1747, 103034, 121, 2223, 69, 100);
INSERT INTO public.who_global_data VALUES (16199, 0, 18, 0, 0, 69, 47);
INSERT INTO public.who_global_data VALUES (16200, 0, 41, 0, 0, 69, 29);
INSERT INTO public.who_global_data VALUES (16201, 0, 8344, 0, 149, 69, 40);
INSERT INTO public.who_global_data VALUES (16202, 14, 6655, 0, 112, 69, 222);
INSERT INTO public.who_global_data VALUES (16203, 666, 121798, 20, 4161, 69, 132);
INSERT INTO public.who_global_data VALUES (16204, 0, 286, 0, 13, 69, 130);
INSERT INTO public.who_global_data VALUES (16205, 0, 13039, 0, 76, 69, 234);
INSERT INTO public.who_global_data VALUES (16206, 0, 2422, 0, 43, 69, 23);
INSERT INTO public.who_global_data VALUES (16207, 34, 5310, 0, 149, 69, 192);
INSERT INTO public.who_global_data VALUES (16208, 0, 9264, 0, 232, 69, 69);
INSERT INTO public.who_global_data VALUES (16209, 0, 26, 0, 0, 69, 187);
INSERT INTO public.who_global_data VALUES (16210, 453, 107134, 7, 2899, 69, 230);
INSERT INTO public.who_global_data VALUES (16211, 6819, 211527, 156, 4672, 69, 77);
INSERT INTO public.who_global_data VALUES (16212, 25, 5371, 0, 26, 69, 9);
INSERT INTO public.who_global_data VALUES (16213, 41810, 9392919, 496, 136696, 69, 74);
INSERT INTO public.who_global_data VALUES (16214, 5418, 527999, 125, 16646, 69, 224);
INSERT INTO public.who_global_data VALUES (16215, 13402, 935799, 391, 47486, 69, 199);
INSERT INTO public.who_global_data VALUES (16216, 1606, 548821, 33, 12200, 69, 190);
INSERT INTO public.who_global_data VALUES (16217, 243, 71942, 7, 2050, 69, 12);
INSERT INTO public.who_global_data VALUES (16218, 0, 369, 0, 25, 69, 104);
INSERT INTO public.who_global_data VALUES (16219, 1031, 334336, 6, 2851, 69, 153);
INSERT INTO public.who_global_data VALUES (16220, 26315, 1564532, 686, 54363, 69, 91);
INSERT INTO public.who_global_data VALUES (16221, 69, 10669, 1, 251, 69, 215);
INSERT INTO public.who_global_data VALUES (16222, 2585, 144653, 32, 2106, 69, 84);
INSERT INTO public.who_global_data VALUES (16223, 31, 923, 0, 32, 69, 231);
INSERT INTO public.who_global_data VALUES (16224, 3108, 210709, 56, 2626, 69, 196);
INSERT INTO public.who_global_data VALUES (16225, 837, 173806, 60, 2477, 69, 105);
INSERT INTO public.who_global_data VALUES (16226, 949, 82605, 4, 1445, 69, 122);
INSERT INTO public.who_global_data VALUES (16227, 0, 0, 0, 0, 69, 159);
INSERT INTO public.who_global_data VALUES (16228, 639, 38388, 14, 979, 69, 75);
INSERT INTO public.who_global_data VALUES (16229, 319, 142195, 1, 875, 69, 27);
INSERT INTO public.who_global_data VALUES (16230, 456, 72427, 4, 1266, 69, 54);
INSERT INTO public.who_global_data VALUES (16231, 0, 39, 0, 0, 69, 226);
INSERT INTO public.who_global_data VALUES (16232, 753, 16561, 3, 193, 69, 79);
INSERT INTO public.who_global_data VALUES (16233, 1696, 125637, 11, 991, 69, 56);
INSERT INTO public.who_global_data VALUES (16234, 0, 2109, 0, 44, 69, 117);
INSERT INTO public.who_global_data VALUES (16235, 0, 1595, 0, 83, 69, 152);
INSERT INTO public.who_global_data VALUES (16236, 0, 81273, 0, 1153, 69, 16);
INSERT INTO public.who_global_data VALUES (16237, 16, 1301, 0, 16, 69, 10);
INSERT INTO public.who_global_data VALUES (16238, 1967, 60185, 22, 595, 69, 201);
INSERT INTO public.who_global_data VALUES (16239, 0, 33409, 0, 300, 69, 174);
INSERT INTO public.who_global_data VALUES (16240, 0, 17341, 0, 251, 69, 119);
INSERT INTO public.who_global_data VALUES (16241, 1, 6025, 0, 185, 69, 168);
INSERT INTO public.who_global_data VALUES (16242, 1315, 63176, 4, 354, 69, 99);
INSERT INTO public.who_global_data VALUES (16243, 14, 12947, 0, 46, 69, 171);
INSERT INTO public.who_global_data VALUES (16244, 0, 4567, 0, 149, 69, 87);
INSERT INTO public.who_global_data VALUES (16245, 108, 9609, 4, 132, 69, 123);
INSERT INTO public.who_global_data VALUES (16246, 0, 4, 0, 0, 69, 151);
INSERT INTO public.who_global_data VALUES (16247, 0, 5413, 0, 40, 69, 213);
INSERT INTO public.who_global_data VALUES (16248, 0, 8424, 0, 172, 69, 118);
INSERT INTO public.who_global_data VALUES (16249, 0, 501, 0, 10, 69, 134);
INSERT INTO public.who_global_data VALUES (16250, 0, 5181, 0, 49, 69, 65);
INSERT INTO public.who_global_data VALUES (16251, 12081, 1090675, 631, 104873, 69, 102);
INSERT INTO public.who_global_data VALUES (16252, 0, 0, 0, 0, 69, 223);
INSERT INTO public.who_global_data VALUES (16253, 4, 610, 0, 3, 69, 4);
INSERT INTO public.who_global_data VALUES (16254, 22, 760, 0, 0, 69, 146);
INSERT INTO public.who_global_data VALUES (16255, 453, 35227, 6, 486, 69, 31);
INSERT INTO public.who_global_data VALUES (16256, 0, 13, 0, 1, 69, 127);
INSERT INTO public.who_global_data VALUES (16257, 4412, 349688, 50, 5739, 69, 22);
INSERT INTO public.who_global_data VALUES (16258, 80, 15586, 1, 129, 69, 115);
INSERT INTO public.who_global_data VALUES (16259, 0, 86633, 0, 1865, 69, 106);
INSERT INTO public.who_global_data VALUES (16260, 78, 14285, 1, 150, 69, 90);
INSERT INTO public.who_global_data VALUES (16261, 0, 0, 0, 0, 69, 70);
INSERT INTO public.who_global_data VALUES (16262, 1380, 230723, 19, 1454, 69, 46);
INSERT INTO public.who_global_data VALUES (16263, 4469, 512151, 56, 9301, 69, 139);
INSERT INTO public.who_global_data VALUES (16264, 0, 32, 0, 0, 69, 42);
INSERT INTO public.who_global_data VALUES (16265, 2, 1696, 0, 25, 69, 80);
INSERT INTO public.who_global_data VALUES (16266, 0, 4629, 0, 160, 69, 203);
INSERT INTO public.who_global_data VALUES (16267, 0, 1472, 0, 70, 69, 136);
INSERT INTO public.who_global_data VALUES (16268, 110, 67330, 0, 1171, 69, 63);
INSERT INTO public.who_global_data VALUES (16269, 0, 0, 0, 0, 69, 17);
INSERT INTO public.who_global_data VALUES (16270, 1, 105, 0, 2, 69, 172);
INSERT INTO public.who_global_data VALUES (16271, 1022, 60723, 41, 1699, 69, 109);
INSERT INTO public.who_global_data VALUES (16272, 0, 34747, 0, 328, 69, 200);
INSERT INTO public.who_global_data VALUES (16273, 1461, 94861, 15, 791, 69, 93);
INSERT INTO public.who_global_data VALUES (16274, 0, 122579, 0, 1391, 69, 5);
INSERT INTO public.who_global_data VALUES (16275, 0, 741, 0, 13, 69, 214);
INSERT INTO public.who_global_data VALUES (16276, 3045, 392356, 45, 7942, 69, 204);
INSERT INTO public.who_global_data VALUES (16277, 0, 0, 0, 0, 69, 198);
INSERT INTO public.who_global_data VALUES (16278, 1457, 161744, 12, 3030, 69, 173);
INSERT INTO public.who_global_data VALUES (16279, 0, 645, 0, 7, 69, 229);
INSERT INTO public.who_global_data VALUES (16280, 919, 80436, 16, 1720, 69, 76);
INSERT INTO public.who_global_data VALUES (16281, 1977, 958324, 54, 35839, 69, 138);
INSERT INTO public.who_global_data VALUES (16282, 1879, 427797, 78, 8333, 69, 98);
INSERT INTO public.who_global_data VALUES (16283, 0, 0, 0, 0, 69, 103);
INSERT INTO public.who_global_data VALUES (16284, 15177, 973593, 599, 16746, 69, 225);
INSERT INTO public.who_global_data VALUES (16285, 4868, 290706, 87, 4363, 69, 131);
INSERT INTO public.who_global_data VALUES (16286, 903, 51581, 7, 1083, 69, 235);
INSERT INTO public.who_global_data VALUES (16287, 227, 138477, 0, 237, 69, 137);
INSERT INTO public.who_global_data VALUES (16288, 450, 33761, 1, 523, 69, 81);
INSERT INTO public.who_global_data VALUES (16289, 1712, 105852, 19, 2269, 69, 182);
INSERT INTO public.who_global_data VALUES (16290, 0, 7940, 0, 40, 69, 145);
INSERT INTO public.who_global_data VALUES (16291, 8134, 465982, 161, 11045, 69, 26);
INSERT INTO public.who_global_data VALUES (16292, 26683, 2269316, 459, 39527, 69, 170);
INSERT INTO public.who_global_data VALUES (16293, 0, 5872, 0, 47, 69, 191);
INSERT INTO public.who_global_data VALUES (16294, 0, 5, 0, 0, 69, 221);
INSERT INTO public.who_global_data VALUES (16295, 0, 127, 0, 0, 69, 64);
INSERT INTO public.who_global_data VALUES (16296, 0, 0, 0, 0, 69, 116);
INSERT INTO public.who_global_data VALUES (16297, 0, 22, 0, 0, 69, 128);
INSERT INTO public.who_global_data VALUES (16298, 0, 246, 0, 2, 69, 6);
INSERT INTO public.who_global_data VALUES (16299, 0, 690, 0, 12, 69, 227);
INSERT INTO public.who_global_data VALUES (16300, 0, 14, 0, 0, 69, 68);
INSERT INTO public.who_global_data VALUES (16301, 0, 85, 0, 0, 69, 184);
INSERT INTO public.who_global_data VALUES (16302, 0, 0, 0, 0, 69, 82);
INSERT INTO public.who_global_data VALUES (16303, 32, 1586, 1, 45, 69, 149);
INSERT INTO public.who_global_data VALUES (16304, 0, 985, 0, 17, 69, 197);
INSERT INTO public.who_global_data VALUES (16305, 220, 356911, 13, 5870, 69, 78);
INSERT INTO public.who_global_data VALUES (16306, 46, 16027, 0, 332, 69, 233);
INSERT INTO public.who_global_data VALUES (16307, 7041, 163035, 61, 1484, 69, 133);
INSERT INTO public.who_global_data VALUES (16308, 5, 172, 0, 0, 69, 35);
INSERT INTO public.who_global_data VALUES (16309, 0, 2410, 0, 74, 69, 114);
INSERT INTO public.who_global_data VALUES (16310, 6, 58205, 1, 29, 69, 237);
INSERT INTO public.who_global_data VALUES (16311, 0, 14, 0, 0, 69, 55);
INSERT INTO public.who_global_data VALUES (16312, 0, 1041, 0, 25, 69, 176);
INSERT INTO public.who_global_data VALUES (16313, 1526, 104632, 27, 798, 69, 202);
INSERT INTO public.who_global_data VALUES (16314, 1109, 75445, 46, 1513, 69, 155);
INSERT INTO public.who_global_data VALUES (16315, 0, 17, 0, 0, 69, 32);
INSERT INTO public.who_global_data VALUES (16316, 0, 4451, 0, 113, 69, 220);
INSERT INTO public.who_global_data VALUES (16317, 3198, 785139, 61, 21439, 69, 30);
INSERT INTO public.who_global_data VALUES (16318, 0, 3104, 0, 61, 69, 147);
INSERT INTO public.who_global_data VALUES (16319, 10145, 1701432, 240, 46590, 69, 208);
INSERT INTO public.who_global_data VALUES (16320, 0, 22501, 0, 107, 69, 45);
INSERT INTO public.who_global_data VALUES (16321, 183, 17810, 8, 1249, 69, 110);
INSERT INTO public.who_global_data VALUES (16322, 4, 5311, 0, 117, 69, 88);
INSERT INTO public.who_global_data VALUES (16323, 6462, 250979, 65, 7097, 69, 51);
INSERT INTO public.who_global_data VALUES (16324, 2311, 325263, 86, 4591, 69, 209);
INSERT INTO public.who_global_data VALUES (16325, 80, 7715, 5, 409, 69, 205);
INSERT INTO public.who_global_data VALUES (16326, 36, 12118, 0, 86, 69, 18);
INSERT INTO public.who_global_data VALUES (16327, 0, 3966, 0, 60, 69, 72);
INSERT INTO public.who_global_data VALUES (16328, 15871, 1605176, 479, 58030, 69, 44);
INSERT INTO public.who_global_data VALUES (16329, 0, 30, 0, 0, 69, 15);
INSERT INTO public.who_global_data VALUES (16330, 0, 2926, 0, 64, 69, 25);
INSERT INTO public.who_global_data VALUES (16331, 0, 0, 0, 0, 69, 179);
INSERT INTO public.who_global_data VALUES (16332, 0, 0, 0, 0, 69, 34);
INSERT INTO public.who_global_data VALUES (16333, 16, 6586, 2, 118, 69, 207);
INSERT INTO public.who_global_data VALUES (16334, 1210, 94980, 47, 3153, 69, 166);
INSERT INTO public.who_global_data VALUES (16335, 30103, 1371148, 182, 13373, 69, 126);
INSERT INTO public.who_global_data VALUES (16336, 0, 0, 0, 0, 69, 97);
INSERT INTO public.who_global_data VALUES (16337, 2, 748, 0, 6, 69, 36);
INSERT INTO public.who_global_data VALUES (16338, 0, 0, 0, 0, 69, 125);
INSERT INTO public.who_global_data VALUES (16339, 356, 19944, 4, 201, 69, 124);
INSERT INTO public.who_global_data VALUES (16340, 12978, 722679, 120, 12213, 69, 185);
INSERT INTO public.who_global_data VALUES (16341, 1252, 166502, 2, 569, 69, 194);
INSERT INTO public.who_global_data VALUES (16342, 0, 509, 0, 21, 69, 144);
INSERT INTO public.who_global_data VALUES (16343, 175669, 12939666, 1276, 262736, 69, 19);
INSERT INTO public.who_global_data VALUES (16344, 0, 1538, 0, 23, 69, 217);
INSERT INTO public.who_global_data VALUES (16345, 186, 5303, 0, 74, 69, 148);
INSERT INTO public.who_global_data VALUES (16346, 227, 72809, 0, 608, 69, 86);
INSERT INTO public.who_global_data VALUES (16347, 0, 1, 0, 0, 69, 13);
INSERT INTO public.who_global_data VALUES (16348, 309, 101524, 4, 888, 69, 157);
INSERT INTO public.who_global_data VALUES (16349, 2, 1341, 0, 35, 69, 8);
INSERT INTO public.who_global_data VALUES (16350, 0, 3, 0, 0, 69, 73);
INSERT INTO public.who_global_data VALUES (16351, 0, 2078, 0, 605, 69, 101);
INSERT INTO public.who_global_data VALUES (16352, 20, 17589, 0, 357, 69, 165);
INSERT INTO public.who_global_data VALUES (16353, 108, 9822, 0, 275, 69, 14);
INSERT INTO public.who_global_data VALUES (16354, 123, 45839, 3, 1740, 70, 193);
INSERT INTO public.who_global_data VALUES (16355, 645, 36245, 18, 771, 70, 113);
INSERT INTO public.who_global_data VALUES (16356, 1058, 80168, 20, 2372, 70, 143);
INSERT INTO public.who_global_data VALUES (16357, 0, 0, 0, 0, 70, 219);
INSERT INTO public.who_global_data VALUES (16358, 76, 6610, 0, 76, 70, 186);
INSERT INTO public.who_global_data VALUES (16359, 88, 15008, 1, 342, 70, 52);
INSERT INTO public.who_global_data VALUES (16360, 0, 4, 0, 0, 70, 180);
INSERT INTO public.who_global_data VALUES (16361, 1, 141, 0, 4, 70, 167);
INSERT INTO public.who_global_data VALUES (16362, 9043, 1399431, 227, 37941, 70, 154);
INSERT INTO public.who_global_data VALUES (16363, 1248, 132907, 31, 2116, 70, 94);
INSERT INTO public.who_global_data VALUES (16364, 13, 4791, 0, 45, 70, 66);
INSERT INTO public.who_global_data VALUES (16365, 7, 27874, 0, 907, 70, 58);
INSERT INTO public.who_global_data VALUES (16366, 4818, 269510, 148, 2764, 70, 163);
INSERT INTO public.who_global_data VALUES (16367, 3712, 109813, 35, 1291, 70, 37);
INSERT INTO public.who_global_data VALUES (16368, 14, 7496, 0, 163, 70, 142);
INSERT INTO public.who_global_data VALUES (16369, 168, 86515, 0, 341, 70, 83);
INSERT INTO public.who_global_data VALUES (16370, 2273, 458711, 20, 6544, 70, 228);
INSERT INTO public.who_global_data VALUES (16371, 4, 270, 0, 7, 70, 188);
INSERT INTO public.who_global_data VALUES (16372, 1621, 131633, 8, 1136, 70, 62);
INSERT INTO public.who_global_data VALUES (16373, 2741, 576423, 125, 16506, 70, 160);
INSERT INTO public.who_global_data VALUES (16374, 92, 5515, 2, 131, 70, 50);
INSERT INTO public.who_global_data VALUES (16375, 0, 2974, 0, 43, 70, 33);
INSERT INTO public.who_global_data VALUES (16376, 1, 242, 0, 9, 70, 183);
INSERT INTO public.who_global_data VALUES (16377, 6, 395, 0, 0, 70, 92);
INSERT INTO public.who_global_data VALUES (16378, 114, 144390, 6, 8939, 70, 158);
INSERT INTO public.who_global_data VALUES (16379, 0, 142, 0, 3, 70, 67);
INSERT INTO public.who_global_data VALUES (16380, 1179, 85431, 62, 2542, 70, 57);
INSERT INTO public.who_global_data VALUES (16381, 0, 9992, 0, 31, 70, 38);
INSERT INTO public.who_global_data VALUES (16382, 37614, 6204220, 691, 171460, 70, 141);
INSERT INTO public.who_global_data VALUES (16383, 0, 72, 0, 1, 70, 178);
INSERT INTO public.who_global_data VALUES (16384, 0, 150, 0, 3, 70, 108);
INSERT INTO public.who_global_data VALUES (16385, 3327, 139955, 151, 3680, 70, 39);
INSERT INTO public.who_global_data VALUES (16386, 39, 2816, 0, 68, 70, 2);
INSERT INTO public.who_global_data VALUES (16387, 0, 681, 0, 1, 70, 195);
INSERT INTO public.who_global_data VALUES (16388, 0, 10526, 0, 104, 70, 107);
INSERT INTO public.who_global_data VALUES (16389, 1, 308, 0, 0, 70, 161);
INSERT INTO public.who_global_data VALUES (16390, 0, 24117, 0, 437, 70, 212);
INSERT INTO public.who_global_data VALUES (16391, 5631, 353097, 89, 11799, 70, 181);
INSERT INTO public.who_global_data VALUES (16392, 0, 269, 0, 2, 70, 53);
INSERT INTO public.who_global_data VALUES (16393, 0, 4913, 0, 63, 70, 164);
INSERT INTO public.who_global_data VALUES (16394, 2, 1663, 0, 101, 70, 140);
INSERT INTO public.who_global_data VALUES (16395, 1561, 547223, 43, 15278, 70, 20);
INSERT INTO public.who_global_data VALUES (16396, 112, 93225, 0, 4749, 70, 112);
INSERT INTO public.who_global_data VALUES (16397, 9496, 1280487, 159, 36019, 70, 111);
INSERT INTO public.who_global_data VALUES (16398, 3, 610, 0, 7, 70, 71);
INSERT INTO public.who_global_data VALUES (16399, 0, 5774, 0, 94, 70, 218);
INSERT INTO public.who_global_data VALUES (16400, 0, 0, 0, 0, 70, 43);
INSERT INTO public.who_global_data VALUES (16401, 1222, 135742, 5, 1679, 70, 49);
INSERT INTO public.who_global_data VALUES (16402, 33, 21232, 0, 131, 70, 1);
INSERT INTO public.who_global_data VALUES (16403, 4080, 119706, 48, 1600, 70, 48);
INSERT INTO public.who_global_data VALUES (16404, 35, 8110, 0, 133, 70, 232);
INSERT INTO public.who_global_data VALUES (16405, 117, 2046, 0, 3, 70, 175);
INSERT INTO public.who_global_data VALUES (16406, 310, 9983, 0, 48, 70, 21);
INSERT INTO public.who_global_data VALUES (16407, 4464, 515984, 188, 7967, 70, 156);
INSERT INTO public.who_global_data VALUES (16408, 0, 0, 0, 0, 70, 95);
INSERT INTO public.who_global_data VALUES (16409, 71, 12540, 0, 333, 70, 177);
INSERT INTO public.who_global_data VALUES (16410, 1323, 76718, 5, 816, 70, 210);
INSERT INTO public.who_global_data VALUES (16411, 0, 5676, 0, 61, 70, 120);
INSERT INTO public.who_global_data VALUES (16412, 5, 85, 0, 0, 70, 135);
INSERT INTO public.who_global_data VALUES (16413, 855, 141777, 7, 2324, 70, 206);
INSERT INTO public.who_global_data VALUES (16414, 1396, 189534, 42, 13358, 70, 189);
INSERT INTO public.who_global_data VALUES (16415, 357, 114832, 12, 6608, 70, 129);
INSERT INTO public.who_global_data VALUES (16416, 521, 38405, 4, 1102, 70, 121);
INSERT INTO public.who_global_data VALUES (16417, 7, 5153, 0, 85, 70, 59);
INSERT INTO public.who_global_data VALUES (16418, 0, 566, 0, 0, 70, 96);
INSERT INTO public.who_global_data VALUES (16419, 368, 11323, 5, 104, 70, 41);
INSERT INTO public.who_global_data VALUES (16420, 33, 6362, 0, 120, 70, 216);
INSERT INTO public.who_global_data VALUES (16421, 769, 108438, 14, 1686, 70, 236);
INSERT INTO public.who_global_data VALUES (16422, 0, 16, 0, 0, 70, 150);
INSERT INTO public.who_global_data VALUES (16423, 0, 500, 0, 0, 70, 61);
INSERT INTO public.who_global_data VALUES (16424, 0, 38, 0, 2, 70, 7);
INSERT INTO public.who_global_data VALUES (16425, 618, 23766, 5, 393, 70, 169);
INSERT INTO public.who_global_data VALUES (16426, 12415, 2157332, 956, 51554, 70, 28);
INSERT INTO public.who_global_data VALUES (16427, 20, 11158, 0, 70, 70, 85);
INSERT INTO public.who_global_data VALUES (16428, 213, 14096, 1, 73, 70, 211);
INSERT INTO public.who_global_data VALUES (16429, 18, 9191, 0, 59, 70, 60);
INSERT INTO public.who_global_data VALUES (16430, 3, 3731, 0, 123, 70, 3);
INSERT INTO public.who_global_data VALUES (16431, 4472, 127942, 34, 1195, 70, 11);
INSERT INTO public.who_global_data VALUES (16432, 21695, 1028089, 379, 15965, 70, 89);
INSERT INTO public.who_global_data VALUES (16433, 0, 51225, 0, 323, 70, 24);
INSERT INTO public.who_global_data VALUES (16434, 0, 991, 0, 5, 70, 162);
INSERT INTO public.who_global_data VALUES (16435, 1981, 101287, 101, 2102, 70, 100);
INSERT INTO public.who_global_data VALUES (16436, 0, 18, 0, 0, 70, 47);
INSERT INTO public.who_global_data VALUES (16437, 0, 41, 0, 0, 70, 29);
INSERT INTO public.who_global_data VALUES (16438, 0, 8344, 0, 149, 70, 40);
INSERT INTO public.who_global_data VALUES (16439, 18, 6641, 1, 112, 70, 222);
INSERT INTO public.who_global_data VALUES (16440, 447, 121132, 8, 4141, 70, 132);
INSERT INTO public.who_global_data VALUES (16441, 1, 286, 0, 13, 70, 130);
INSERT INTO public.who_global_data VALUES (16442, 90, 13039, 0, 76, 70, 234);
INSERT INTO public.who_global_data VALUES (16443, 0, 2422, 0, 43, 70, 23);
INSERT INTO public.who_global_data VALUES (16444, 40, 5276, 2, 149, 70, 192);
INSERT INTO public.who_global_data VALUES (16445, 8, 9264, 0, 232, 70, 69);
INSERT INTO public.who_global_data VALUES (16446, 0, 26, 0, 0, 70, 187);
INSERT INTO public.who_global_data VALUES (16447, 565, 106681, 4, 2892, 70, 230);
INSERT INTO public.who_global_data VALUES (16448, 6268, 204708, 152, 4516, 70, 77);
INSERT INTO public.who_global_data VALUES (16449, 23, 5346, 0, 26, 70, 9);
INSERT INTO public.who_global_data VALUES (16450, 41322, 9351109, 485, 136200, 70, 74);
INSERT INTO public.who_global_data VALUES (16451, 5828, 522581, 169, 16521, 70, 224);
INSERT INTO public.who_global_data VALUES (16452, 14051, 922397, 406, 47095, 70, 199);
INSERT INTO public.who_global_data VALUES (16453, 2545, 547215, 42, 12167, 70, 190);
INSERT INTO public.who_global_data VALUES (16454, 205, 71699, 7, 2043, 70, 12);
INSERT INTO public.who_global_data VALUES (16455, 0, 369, 0, 25, 70, 104);
INSERT INTO public.who_global_data VALUES (16456, 1087, 333305, 9, 2845, 70, 153);
INSERT INTO public.who_global_data VALUES (16457, 28342, 1538217, 827, 53677, 70, 91);
INSERT INTO public.who_global_data VALUES (16458, 59, 10600, 2, 250, 70, 215);
INSERT INTO public.who_global_data VALUES (16459, 2577, 142068, 23, 2074, 70, 84);
INSERT INTO public.who_global_data VALUES (16460, 37, 892, 0, 32, 70, 231);
INSERT INTO public.who_global_data VALUES (16461, 4580, 207601, 61, 2570, 70, 196);
INSERT INTO public.who_global_data VALUES (16462, 990, 172969, 0, 2417, 70, 105);
INSERT INTO public.who_global_data VALUES (16463, 1554, 81656, 14, 1441, 70, 122);
INSERT INTO public.who_global_data VALUES (16464, 0, 0, 0, 0, 70, 159);
INSERT INTO public.who_global_data VALUES (16465, 764, 37749, 12, 965, 70, 75);
INSERT INTO public.who_global_data VALUES (16466, 329, 141876, 2, 874, 70, 27);
INSERT INTO public.who_global_data VALUES (16467, 423, 71971, 6, 1262, 70, 54);
INSERT INTO public.who_global_data VALUES (16468, 0, 39, 0, 0, 70, 226);
INSERT INTO public.who_global_data VALUES (16469, 637, 15808, 2, 190, 70, 79);
INSERT INTO public.who_global_data VALUES (16470, 1782, 123941, 6, 980, 70, 56);
INSERT INTO public.who_global_data VALUES (16471, 0, 2109, 0, 44, 70, 117);
INSERT INTO public.who_global_data VALUES (16472, 4, 1595, 0, 83, 70, 152);
INSERT INTO public.who_global_data VALUES (16473, 866, 81273, 13, 1153, 70, 16);
INSERT INTO public.who_global_data VALUES (16474, 6, 1285, 1, 16, 70, 10);
INSERT INTO public.who_global_data VALUES (16475, 2124, 58218, 22, 573, 70, 201);
INSERT INTO public.who_global_data VALUES (16476, 1309, 33409, 12, 300, 70, 174);
INSERT INTO public.who_global_data VALUES (16477, 0, 17341, 0, 251, 70, 119);
INSERT INTO public.who_global_data VALUES (16478, 4, 6024, 0, 185, 70, 168);
INSERT INTO public.who_global_data VALUES (16479, 1109, 61861, 2, 350, 70, 99);
INSERT INTO public.who_global_data VALUES (16480, 44, 12933, 0, 46, 70, 171);
INSERT INTO public.who_global_data VALUES (16481, 62, 4567, 1, 149, 70, 87);
INSERT INTO public.who_global_data VALUES (16482, 70, 9501, 6, 128, 70, 123);
INSERT INTO public.who_global_data VALUES (16483, 0, 4, 0, 0, 70, 151);
INSERT INTO public.who_global_data VALUES (16484, 0, 5413, 0, 40, 70, 213);
INSERT INTO public.who_global_data VALUES (16485, 349, 8424, 3, 172, 70, 118);
INSERT INTO public.who_global_data VALUES (16486, 4, 501, 0, 10, 70, 134);
INSERT INTO public.who_global_data VALUES (16487, 0, 5181, 0, 49, 70, 65);
INSERT INTO public.who_global_data VALUES (16488, 8107, 1078594, 645, 104242, 70, 102);
INSERT INTO public.who_global_data VALUES (16489, 0, 0, 0, 0, 70, 223);
INSERT INTO public.who_global_data VALUES (16490, 3, 606, 0, 3, 70, 4);
INSERT INTO public.who_global_data VALUES (16491, 26, 738, 0, 0, 70, 146);
INSERT INTO public.who_global_data VALUES (16492, 393, 34774, 7, 480, 70, 31);
INSERT INTO public.who_global_data VALUES (16493, 0, 13, 0, 1, 70, 127);
INSERT INTO public.who_global_data VALUES (16494, 4592, 345276, 70, 5689, 70, 22);
INSERT INTO public.who_global_data VALUES (16495, 39, 15506, 0, 128, 70, 115);
INSERT INTO public.who_global_data VALUES (16496, 1428, 86633, 19, 1865, 70, 106);
INSERT INTO public.who_global_data VALUES (16497, 52, 14207, 2, 149, 70, 90);
INSERT INTO public.who_global_data VALUES (16498, 0, 0, 0, 0, 70, 70);
INSERT INTO public.who_global_data VALUES (16499, 1703, 229343, 23, 1435, 70, 46);
INSERT INTO public.who_global_data VALUES (16500, 5754, 507682, 83, 9245, 70, 139);
INSERT INTO public.who_global_data VALUES (16501, 0, 32, 0, 0, 70, 42);
INSERT INTO public.who_global_data VALUES (16502, 3, 1694, 0, 25, 70, 80);
INSERT INTO public.who_global_data VALUES (16503, 0, 4629, 0, 160, 70, 203);
INSERT INTO public.who_global_data VALUES (16504, 29, 1472, 0, 70, 70, 136);
INSERT INTO public.who_global_data VALUES (16505, 246, 67220, 2, 1171, 70, 63);
INSERT INTO public.who_global_data VALUES (16506, 0, 0, 0, 0, 70, 17);
INSERT INTO public.who_global_data VALUES (16507, 0, 104, 0, 2, 70, 172);
INSERT INTO public.who_global_data VALUES (16508, 1093, 59701, 28, 1658, 70, 109);
INSERT INTO public.who_global_data VALUES (16509, 480, 34747, 12, 328, 70, 200);
INSERT INTO public.who_global_data VALUES (16510, 1936, 93400, 9, 776, 70, 93);
INSERT INTO public.who_global_data VALUES (16511, 0, 122579, 0, 1391, 70, 5);
INSERT INTO public.who_global_data VALUES (16512, 0, 741, 0, 13, 70, 214);
INSERT INTO public.who_global_data VALUES (16513, 3113, 389311, 54, 7897, 70, 204);
INSERT INTO public.who_global_data VALUES (16514, 0, 0, 0, 0, 70, 198);
INSERT INTO public.who_global_data VALUES (16515, 1755, 160287, 16, 3018, 70, 173);
INSERT INTO public.who_global_data VALUES (16516, 0, 645, 0, 7, 70, 229);
INSERT INTO public.who_global_data VALUES (16517, 639, 79517, 13, 1704, 70, 76);
INSERT INTO public.who_global_data VALUES (16518, 1888, 956347, 58, 35785, 70, 138);
INSERT INTO public.who_global_data VALUES (16519, 1621, 425918, 13, 8255, 70, 98);
INSERT INTO public.who_global_data VALUES (16520, 0, 0, 0, 0, 70, 103);
INSERT INTO public.who_global_data VALUES (16521, 17304, 958416, 579, 16147, 70, 225);
INSERT INTO public.who_global_data VALUES (16522, 5444, 285838, 67, 4276, 70, 131);
INSERT INTO public.who_global_data VALUES (16523, 1452, 50678, 7, 1076, 70, 235);
INSERT INTO public.who_global_data VALUES (16524, 184, 138250, 0, 237, 70, 137);
INSERT INTO public.who_global_data VALUES (16525, 503, 33311, 6, 522, 70, 81);
INSERT INTO public.who_global_data VALUES (16526, 1246, 104140, 21, 2250, 70, 182);
INSERT INTO public.who_global_data VALUES (16527, 104, 7940, 1, 40, 70, 145);
INSERT INTO public.who_global_data VALUES (16528, 8499, 457848, 172, 10884, 70, 26);
INSERT INTO public.who_global_data VALUES (16529, 27100, 2242633, 510, 39068, 70, 170);
INSERT INTO public.who_global_data VALUES (16530, 21, 5872, 0, 47, 70, 191);
INSERT INTO public.who_global_data VALUES (16531, 0, 5, 0, 0, 70, 221);
INSERT INTO public.who_global_data VALUES (16532, 0, 127, 0, 0, 70, 64);
INSERT INTO public.who_global_data VALUES (16533, 0, 0, 0, 0, 70, 116);
INSERT INTO public.who_global_data VALUES (16534, 0, 22, 0, 0, 70, 128);
INSERT INTO public.who_global_data VALUES (16535, 8, 246, 0, 2, 70, 6);
INSERT INTO public.who_global_data VALUES (16536, 0, 690, 0, 12, 70, 227);
INSERT INTO public.who_global_data VALUES (16537, 0, 14, 0, 0, 70, 68);
INSERT INTO public.who_global_data VALUES (16538, 1, 85, 0, 0, 70, 184);
INSERT INTO public.who_global_data VALUES (16539, 0, 0, 0, 0, 70, 82);
INSERT INTO public.who_global_data VALUES (16540, 40, 1554, 0, 44, 70, 149);
INSERT INTO public.who_global_data VALUES (16541, 0, 985, 0, 17, 70, 197);
INSERT INTO public.who_global_data VALUES (16542, 302, 356691, 17, 5857, 70, 78);
INSERT INTO public.who_global_data VALUES (16543, 21, 15981, 1, 332, 70, 233);
INSERT INTO public.who_global_data VALUES (16544, 7780, 155994, 57, 1423, 70, 133);
INSERT INTO public.who_global_data VALUES (16545, 0, 167, 0, 0, 70, 35);
INSERT INTO public.who_global_data VALUES (16546, 1, 2410, 0, 74, 70, 114);
INSERT INTO public.who_global_data VALUES (16547, 4, 58199, 0, 28, 70, 237);
INSERT INTO public.who_global_data VALUES (16548, 0, 14, 0, 0, 70, 55);
INSERT INTO public.who_global_data VALUES (16549, 5, 1041, 0, 25, 70, 176);
INSERT INTO public.who_global_data VALUES (16550, 1849, 103106, 22, 771, 70, 202);
INSERT INTO public.who_global_data VALUES (16551, 1601, 74336, 63, 1467, 70, 155);
INSERT INTO public.who_global_data VALUES (16552, 0, 17, 0, 0, 70, 32);
INSERT INTO public.who_global_data VALUES (16553, 0, 4451, 0, 113, 70, 220);
INSERT INTO public.who_global_data VALUES (16554, 3370, 781941, 89, 21378, 70, 30);
INSERT INTO public.who_global_data VALUES (16555, 57, 3104, 1, 61, 70, 147);
INSERT INTO public.who_global_data VALUES (16556, 9779, 1691287, 258, 46350, 70, 208);
INSERT INTO public.who_global_data VALUES (16557, 473, 22501, 8, 107, 70, 45);
INSERT INTO public.who_global_data VALUES (16558, 223, 17627, 6, 1241, 70, 110);
INSERT INTO public.who_global_data VALUES (16559, 2, 5307, 0, 117, 70, 88);
INSERT INTO public.who_global_data VALUES (16560, 6903, 244517, 60, 7032, 70, 51);
INSERT INTO public.who_global_data VALUES (16561, 4071, 322952, 87, 4505, 70, 209);
INSERT INTO public.who_global_data VALUES (16562, 93, 7635, 5, 404, 70, 205);
INSERT INTO public.who_global_data VALUES (16563, 38, 12082, 0, 86, 70, 18);
INSERT INTO public.who_global_data VALUES (16564, 5, 3966, 0, 60, 70, 72);
INSERT INTO public.who_global_data VALUES (16565, 14739, 1589305, 520, 57551, 70, 44);
INSERT INTO public.who_global_data VALUES (16566, 0, 30, 0, 0, 70, 15);
INSERT INTO public.who_global_data VALUES (16567, 54, 2926, 0, 64, 70, 25);
INSERT INTO public.who_global_data VALUES (16568, 0, 0, 0, 0, 70, 179);
INSERT INTO public.who_global_data VALUES (16569, 0, 0, 0, 0, 70, 34);
INSERT INTO public.who_global_data VALUES (16570, 67, 6570, 0, 116, 70, 207);
INSERT INTO public.who_global_data VALUES (16571, 1295, 93770, 72, 3106, 70, 166);
INSERT INTO public.who_global_data VALUES (16572, 29845, 1341045, 177, 13191, 70, 126);
INSERT INTO public.who_global_data VALUES (16573, 0, 0, 0, 0, 70, 97);
INSERT INTO public.who_global_data VALUES (16574, 0, 746, 0, 6, 70, 36);
INSERT INTO public.who_global_data VALUES (16575, 0, 0, 0, 0, 70, 125);
INSERT INTO public.who_global_data VALUES (16576, 473, 19588, 6, 197, 70, 124);
INSERT INTO public.who_global_data VALUES (16577, 16294, 709701, 184, 12093, 70, 185);
INSERT INTO public.who_global_data VALUES (16578, 1283, 165250, 3, 567, 70, 194);
INSERT INTO public.who_global_data VALUES (16579, 0, 509, 0, 21, 70, 144);
INSERT INTO public.who_global_data VALUES (16580, 141222, 12763997, 1387, 261460, 70, 19);
INSERT INTO public.who_global_data VALUES (16581, 2, 1538, 0, 23, 70, 217);
INSERT INTO public.who_global_data VALUES (16582, 129, 5117, 1, 74, 70, 148);
INSERT INTO public.who_global_data VALUES (16583, 173, 72582, 1, 608, 70, 86);
INSERT INTO public.who_global_data VALUES (16584, 0, 1, 0, 0, 70, 13);
INSERT INTO public.who_global_data VALUES (16585, 398, 101215, 4, 884, 70, 157);
INSERT INTO public.who_global_data VALUES (16586, 8, 1339, 0, 35, 70, 8);
INSERT INTO public.who_global_data VALUES (16587, 0, 3, 0, 0, 70, 73);
INSERT INTO public.who_global_data VALUES (16588, 0, 2078, 0, 605, 70, 101);
INSERT INTO public.who_global_data VALUES (16589, 16, 17569, 0, 357, 70, 165);
INSERT INTO public.who_global_data VALUES (16590, 91, 9714, 1, 275, 70, 14);
INSERT INTO public.who_global_data VALUES (16591, 226, 45716, 12, 1737, 71, 193);
INSERT INTO public.who_global_data VALUES (16592, 656, 35600, 10, 753, 71, 113);
INSERT INTO public.who_global_data VALUES (16593, 1085, 79110, 23, 2352, 71, 143);
INSERT INTO public.who_global_data VALUES (16594, 0, 0, 0, 0, 71, 219);
INSERT INTO public.who_global_data VALUES (16595, 106, 6534, 0, 76, 71, 186);
INSERT INTO public.who_global_data VALUES (16596, 99, 14920, 1, 341, 71, 52);
INSERT INTO public.who_global_data VALUES (16597, 0, 4, 0, 0, 71, 180);
INSERT INTO public.who_global_data VALUES (16598, 0, 140, 0, 4, 71, 167);
INSERT INTO public.who_global_data VALUES (16599, 8593, 1390388, 282, 37714, 71, 154);
INSERT INTO public.who_global_data VALUES (16600, 1476, 131659, 22, 2085, 71, 94);
INSERT INTO public.who_global_data VALUES (16601, 27, 4778, 0, 45, 71, 66);
INSERT INTO public.who_global_data VALUES (16602, 13, 27867, 0, 907, 71, 58);
INSERT INTO public.who_global_data VALUES (16603, 5447, 264692, 114, 2616, 71, 163);
INSERT INTO public.who_global_data VALUES (16604, 3705, 106101, 32, 1256, 71, 37);
INSERT INTO public.who_global_data VALUES (16605, 13, 7482, 0, 163, 71, 142);
INSERT INTO public.who_global_data VALUES (16606, 162, 86347, 1, 341, 71, 83);
INSERT INTO public.who_global_data VALUES (16607, 2292, 456438, 37, 6524, 71, 228);
INSERT INTO public.who_global_data VALUES (16608, 4, 266, 0, 7, 71, 188);
INSERT INTO public.who_global_data VALUES (16609, 1563, 130012, 9, 1128, 71, 62);
INSERT INTO public.who_global_data VALUES (16610, 2428, 573682, 118, 16381, 71, 160);
INSERT INTO public.who_global_data VALUES (16611, 88, 5423, 4, 129, 71, 50);
INSERT INTO public.who_global_data VALUES (16612, 0, 2974, 0, 43, 71, 33);
INSERT INTO public.who_global_data VALUES (16613, 2, 241, 0, 9, 71, 183);
INSERT INTO public.who_global_data VALUES (16614, 3, 389, 0, 0, 71, 92);
INSERT INTO public.who_global_data VALUES (16615, 129, 144276, 5, 8933, 71, 158);
INSERT INTO public.who_global_data VALUES (16616, 0, 142, 0, 3, 71, 67);
INSERT INTO public.who_global_data VALUES (16617, 924, 84252, 51, 2480, 71, 57);
INSERT INTO public.who_global_data VALUES (16618, 0, 9992, 0, 31, 71, 38);
INSERT INTO public.who_global_data VALUES (16619, 47898, 6166606, 654, 170769, 71, 141);
INSERT INTO public.who_global_data VALUES (16620, 0, 72, 0, 1, 71, 178);
INSERT INTO public.who_global_data VALUES (16621, 0, 150, 0, 3, 71, 108);
INSERT INTO public.who_global_data VALUES (16622, 3568, 136628, 162, 3529, 71, 39);
INSERT INTO public.who_global_data VALUES (16623, 0, 2777, 0, 68, 71, 2);
INSERT INTO public.who_global_data VALUES (16624, 4, 681, 0, 1, 71, 195);
INSERT INTO public.who_global_data VALUES (16625, 0, 10526, 0, 104, 71, 107);
INSERT INTO public.who_global_data VALUES (16626, 0, 307, 0, 0, 71, 161);
INSERT INTO public.who_global_data VALUES (16627, 95, 24117, 0, 437, 71, 212);
INSERT INTO public.who_global_data VALUES (16628, 5022, 347466, 92, 11710, 71, 181);
INSERT INTO public.who_global_data VALUES (16629, 3, 269, 0, 2, 71, 53);
INSERT INTO public.who_global_data VALUES (16630, 0, 4913, 0, 63, 71, 164);
INSERT INTO public.who_global_data VALUES (16631, 6, 1661, 0, 101, 71, 140);
INSERT INTO public.who_global_data VALUES (16632, 1570, 545662, 97, 15235, 71, 20);
INSERT INTO public.who_global_data VALUES (16633, 88, 93113, 0, 4749, 71, 112);
INSERT INTO public.who_global_data VALUES (16634, 8497, 1270991, 183, 35860, 71, 111);
INSERT INTO public.who_global_data VALUES (16635, 0, 607, 0, 7, 71, 71);
INSERT INTO public.who_global_data VALUES (16636, 142, 5774, 1, 94, 71, 218);
INSERT INTO public.who_global_data VALUES (16637, 0, 0, 0, 0, 71, 43);
INSERT INTO public.who_global_data VALUES (16638, 1330, 134520, 12, 1674, 71, 49);
INSERT INTO public.who_global_data VALUES (16639, 31, 21199, 0, 131, 71, 1);
INSERT INTO public.who_global_data VALUES (16640, 4009, 115626, 51, 1552, 71, 48);
INSERT INTO public.who_global_data VALUES (16641, 49, 8075, 0, 133, 71, 232);
INSERT INTO public.who_global_data VALUES (16642, 102, 1929, 0, 3, 71, 175);
INSERT INTO public.who_global_data VALUES (16643, 220, 9673, 1, 48, 71, 21);
INSERT INTO public.who_global_data VALUES (16644, 6305, 511520, 168, 7779, 71, 156);
INSERT INTO public.who_global_data VALUES (16645, 0, 0, 0, 0, 71, 95);
INSERT INTO public.who_global_data VALUES (16646, 105, 12469, 2, 333, 71, 177);
INSERT INTO public.who_global_data VALUES (16647, 1191, 75395, 9, 811, 71, 210);
INSERT INTO public.who_global_data VALUES (16648, 6, 5676, 0, 61, 71, 120);
INSERT INTO public.who_global_data VALUES (16649, 3, 80, 0, 0, 71, 135);
INSERT INTO public.who_global_data VALUES (16650, 1258, 140922, 2, 2317, 71, 206);
INSERT INTO public.who_global_data VALUES (16651, 908, 188138, 28, 13316, 71, 189);
INSERT INTO public.who_global_data VALUES (16652, 368, 114475, 11, 6596, 71, 129);
INSERT INTO public.who_global_data VALUES (16653, 0, 37884, 12, 1098, 71, 121);
INSERT INTO public.who_global_data VALUES (16654, 0, 5146, 0, 85, 71, 59);
INSERT INTO public.who_global_data VALUES (16655, 8, 566, 0, 0, 71, 96);
INSERT INTO public.who_global_data VALUES (16656, 414, 10955, 2, 99, 71, 41);
INSERT INTO public.who_global_data VALUES (16657, 57, 6329, 0, 120, 71, 216);
INSERT INTO public.who_global_data VALUES (16658, 560, 107669, 8, 1672, 71, 236);
INSERT INTO public.who_global_data VALUES (16659, 0, 16, 0, 0, 71, 150);
INSERT INTO public.who_global_data VALUES (16660, 0, 500, 0, 0, 71, 61);
INSERT INTO public.who_global_data VALUES (16661, 0, 38, 0, 2, 71, 7);
INSERT INTO public.who_global_data VALUES (16662, 496, 23148, 0, 388, 71, 169);
INSERT INTO public.who_global_data VALUES (16663, 13541, 2144917, 339, 50598, 71, 28);
INSERT INTO public.who_global_data VALUES (16664, 22, 11138, 0, 70, 71, 85);
INSERT INTO public.who_global_data VALUES (16665, 100, 13883, 2, 72, 71, 211);
INSERT INTO public.who_global_data VALUES (16666, 0, 9173, 0, 59, 71, 60);
INSERT INTO public.who_global_data VALUES (16667, 1, 3728, 0, 123, 71, 3);
INSERT INTO public.who_global_data VALUES (16668, 4780, 123470, 37, 1161, 71, 11);
INSERT INTO public.who_global_data VALUES (16669, 22806, 1006394, 426, 15586, 71, 89);
INSERT INTO public.who_global_data VALUES (16670, 0, 51225, 0, 323, 71, 24);
INSERT INTO public.who_global_data VALUES (16671, 10, 991, 0, 5, 71, 162);
INSERT INTO public.who_global_data VALUES (16672, 2018, 99306, 99, 2001, 71, 100);
INSERT INTO public.who_global_data VALUES (16673, 0, 18, 0, 0, 71, 47);
INSERT INTO public.who_global_data VALUES (16674, 0, 41, 0, 0, 71, 29);
INSERT INTO public.who_global_data VALUES (16675, 0, 8344, 0, 149, 71, 40);
INSERT INTO public.who_global_data VALUES (16676, 43, 6623, 2, 111, 71, 222);
INSERT INTO public.who_global_data VALUES (16677, 696, 120685, 26, 4133, 71, 132);
INSERT INTO public.who_global_data VALUES (16678, 2, 285, 0, 13, 71, 130);
INSERT INTO public.who_global_data VALUES (16679, 86, 12949, 1, 76, 71, 234);
INSERT INTO public.who_global_data VALUES (16680, 0, 2422, 0, 43, 71, 23);
INSERT INTO public.who_global_data VALUES (16681, 47, 5236, 0, 147, 71, 192);
INSERT INTO public.who_global_data VALUES (16682, 8, 9256, 0, 232, 71, 69);
INSERT INTO public.who_global_data VALUES (16683, 0, 26, 0, 0, 71, 187);
INSERT INTO public.who_global_data VALUES (16684, 544, 106116, 11, 2888, 71, 230);
INSERT INTO public.who_global_data VALUES (16685, 6393, 198440, 135, 4364, 71, 77);
INSERT INTO public.who_global_data VALUES (16686, 11, 5323, 0, 26, 71, 9);
INSERT INTO public.who_global_data VALUES (16687, 43082, 9309787, 492, 135715, 71, 74);
INSERT INTO public.who_global_data VALUES (16688, 4917, 516753, 127, 16352, 71, 224);
INSERT INTO public.who_global_data VALUES (16689, 13961, 908346, 482, 46689, 71, 199);
INSERT INTO public.who_global_data VALUES (16690, 2483, 544670, 39, 12125, 71, 190);
INSERT INTO public.who_global_data VALUES (16691, 307, 71494, 3, 2036, 71, 12);
INSERT INTO public.who_global_data VALUES (16692, 0, 369, 0, 25, 71, 104);
INSERT INTO public.who_global_data VALUES (16693, 1079, 332218, 5, 2836, 71, 153);
INSERT INTO public.who_global_data VALUES (16694, 29001, 1509875, 822, 52850, 71, 91);
INSERT INTO public.who_global_data VALUES (16695, 53, 10541, 1, 248, 71, 215);
INSERT INTO public.who_global_data VALUES (16696, 2230, 139491, 29, 2051, 71, 84);
INSERT INTO public.who_global_data VALUES (16697, 19, 855, 0, 32, 71, 231);
INSERT INTO public.who_global_data VALUES (16698, 5000, 203021, 67, 2509, 71, 196);
INSERT INTO public.who_global_data VALUES (16699, 1010, 171979, 0, 2417, 71, 105);
INSERT INTO public.who_global_data VALUES (16700, 780, 80102, 10, 1427, 71, 122);
INSERT INTO public.who_global_data VALUES (16701, 0, 0, 0, 0, 71, 159);
INSERT INTO public.who_global_data VALUES (16702, 775, 36985, 15, 953, 71, 75);
INSERT INTO public.who_global_data VALUES (16703, 330, 141547, 1, 872, 71, 27);
INSERT INTO public.who_global_data VALUES (16704, 377, 71548, 5, 1256, 71, 54);
INSERT INTO public.who_global_data VALUES (16705, 0, 39, 0, 0, 71, 226);
INSERT INTO public.who_global_data VALUES (16706, 898, 15171, 4, 188, 71, 79);
INSERT INTO public.who_global_data VALUES (16707, 1859, 122159, 24, 974, 71, 56);
INSERT INTO public.who_global_data VALUES (16708, 17, 2109, 0, 44, 71, 117);
INSERT INTO public.who_global_data VALUES (16709, 13, 1591, 0, 83, 71, 152);
INSERT INTO public.who_global_data VALUES (16710, 610, 80407, 15, 1140, 71, 16);
INSERT INTO public.who_global_data VALUES (16711, 17, 1279, 1, 15, 71, 10);
INSERT INTO public.who_global_data VALUES (16712, 2333, 56094, 23, 551, 71, 201);
INSERT INTO public.who_global_data VALUES (16713, 616, 32100, 5, 288, 71, 174);
INSERT INTO public.who_global_data VALUES (16714, 0, 17341, 0, 251, 71, 119);
INSERT INTO public.who_global_data VALUES (16715, 2, 6020, 0, 185, 71, 168);
INSERT INTO public.who_global_data VALUES (16716, 935, 60752, 3, 348, 71, 99);
INSERT INTO public.who_global_data VALUES (16717, 35, 12889, 0, 46, 71, 171);
INSERT INTO public.who_global_data VALUES (16718, 44, 4505, 0, 148, 71, 87);
INSERT INTO public.who_global_data VALUES (16719, 70, 9431, 0, 122, 71, 123);
INSERT INTO public.who_global_data VALUES (16720, 0, 4, 0, 0, 71, 151);
INSERT INTO public.who_global_data VALUES (16721, 0, 5413, 0, 40, 71, 213);
INSERT INTO public.who_global_data VALUES (16722, 0, 8075, 0, 169, 71, 118);
INSERT INTO public.who_global_data VALUES (16723, 0, 497, 0, 10, 71, 134);
INSERT INTO public.who_global_data VALUES (16724, 0, 5181, 0, 49, 71, 65);
INSERT INTO public.who_global_data VALUES (16725, 10335, 1070487, 858, 103597, 71, 102);
INSERT INTO public.who_global_data VALUES (16726, 0, 0, 0, 0, 71, 223);
INSERT INTO public.who_global_data VALUES (16727, 6, 603, 0, 3, 71, 4);
INSERT INTO public.who_global_data VALUES (16728, 13, 712, 0, 0, 71, 146);
INSERT INTO public.who_global_data VALUES (16729, 569, 34381, 5, 473, 71, 31);
INSERT INTO public.who_global_data VALUES (16730, 0, 13, 0, 1, 71, 127);
INSERT INTO public.who_global_data VALUES (16731, 4178, 340684, 80, 5619, 71, 22);
INSERT INTO public.who_global_data VALUES (16732, 165, 15467, 0, 128, 71, 115);
INSERT INTO public.who_global_data VALUES (16733, 1639, 85205, 36, 1846, 71, 106);
INSERT INTO public.who_global_data VALUES (16734, 149, 14155, 2, 147, 71, 90);
INSERT INTO public.who_global_data VALUES (16735, 0, 0, 0, 0, 71, 70);
INSERT INTO public.who_global_data VALUES (16736, 1614, 227640, 23, 1412, 71, 46);
INSERT INTO public.who_global_data VALUES (16737, 4472, 501928, 74, 9162, 71, 139);
INSERT INTO public.who_global_data VALUES (16738, 0, 32, 0, 0, 71, 42);
INSERT INTO public.who_global_data VALUES (16739, 7, 1691, 0, 25, 71, 80);
INSERT INTO public.who_global_data VALUES (16740, 0, 4629, 0, 160, 71, 203);
INSERT INTO public.who_global_data VALUES (16741, 24, 1443, 0, 70, 71, 136);
INSERT INTO public.who_global_data VALUES (16742, 169, 66974, 0, 1169, 71, 63);
INSERT INTO public.who_global_data VALUES (16743, 0, 0, 0, 0, 71, 17);
INSERT INTO public.who_global_data VALUES (16744, 0, 104, 0, 2, 71, 172);
INSERT INTO public.who_global_data VALUES (16745, 1157, 58608, 30, 1630, 71, 109);
INSERT INTO public.who_global_data VALUES (16746, 553, 34267, 0, 316, 71, 200);
INSERT INTO public.who_global_data VALUES (16747, 1906, 91464, 18, 767, 71, 93);
INSERT INTO public.who_global_data VALUES (16748, 0, 122579, 0, 1391, 71, 5);
INSERT INTO public.who_global_data VALUES (16749, 0, 741, 0, 13, 71, 214);
INSERT INTO public.who_global_data VALUES (16750, 3306, 386198, 40, 7843, 71, 204);
INSERT INTO public.who_global_data VALUES (16751, 0, 0, 0, 0, 71, 198);
INSERT INTO public.who_global_data VALUES (16752, 1602, 158532, 16, 3002, 71, 173);
INSERT INTO public.who_global_data VALUES (16753, 0, 645, 0, 7, 71, 229);
INSERT INTO public.who_global_data VALUES (16754, 987, 78878, 14, 1691, 71, 76);
INSERT INTO public.who_global_data VALUES (16755, 2020, 954459, 42, 35727, 71, 138);
INSERT INTO public.who_global_data VALUES (16756, 1382, 424297, 27, 8242, 71, 98);
INSERT INTO public.who_global_data VALUES (16757, 0, 0, 0, 0, 71, 103);
INSERT INTO public.who_global_data VALUES (16758, 16690, 941112, 580, 15568, 71, 225);
INSERT INTO public.who_global_data VALUES (16759, 6383, 280394, 82, 4209, 71, 131);
INSERT INTO public.who_global_data VALUES (16760, 501, 49226, 17, 1069, 71, 235);
INSERT INTO public.who_global_data VALUES (16761, 215, 138066, 0, 237, 71, 137);
INSERT INTO public.who_global_data VALUES (16762, 555, 32808, 1, 516, 71, 81);
INSERT INTO public.who_global_data VALUES (16763, 1691, 102894, 20, 2229, 71, 182);
INSERT INTO public.who_global_data VALUES (16764, 0, 7836, 0, 39, 71, 145);
INSERT INTO public.who_global_data VALUES (16765, 9005, 449349, 171, 10712, 71, 26);
INSERT INTO public.who_global_data VALUES (16766, 27543, 2215533, 496, 38558, 71, 170);
INSERT INTO public.who_global_data VALUES (16767, 72, 5851, 0, 47, 71, 191);
INSERT INTO public.who_global_data VALUES (16768, 0, 5, 0, 0, 71, 221);
INSERT INTO public.who_global_data VALUES (16769, 0, 127, 0, 0, 71, 64);
INSERT INTO public.who_global_data VALUES (16770, 0, 0, 0, 0, 71, 116);
INSERT INTO public.who_global_data VALUES (16771, 0, 22, 0, 0, 71, 128);
INSERT INTO public.who_global_data VALUES (16772, 3, 238, 0, 2, 71, 6);
INSERT INTO public.who_global_data VALUES (16773, 0, 690, 0, 12, 71, 227);
INSERT INTO public.who_global_data VALUES (16774, 0, 14, 0, 0, 71, 68);
INSERT INTO public.who_global_data VALUES (16775, 0, 84, 0, 0, 71, 184);
INSERT INTO public.who_global_data VALUES (16776, 0, 0, 0, 0, 71, 82);
INSERT INTO public.who_global_data VALUES (16777, 22, 1514, 0, 44, 71, 149);
INSERT INTO public.who_global_data VALUES (16778, 3, 985, 0, 17, 71, 197);
INSERT INTO public.who_global_data VALUES (16779, 322, 356389, 15, 5840, 71, 78);
INSERT INTO public.who_global_data VALUES (16780, 33, 15960, 0, 331, 71, 233);
INSERT INTO public.who_global_data VALUES (16781, 7606, 148214, 51, 1366, 71, 133);
INSERT INTO public.who_global_data VALUES (16782, 0, 167, 0, 0, 71, 35);
INSERT INTO public.who_global_data VALUES (16783, 1, 2409, 0, 74, 71, 114);
INSERT INTO public.who_global_data VALUES (16784, 5, 58195, 0, 28, 71, 237);
INSERT INTO public.who_global_data VALUES (16785, 0, 14, 0, 0, 71, 55);
INSERT INTO public.who_global_data VALUES (16786, 16, 1036, 0, 25, 71, 176);
INSERT INTO public.who_global_data VALUES (16787, 1953, 101257, 17, 749, 71, 202);
INSERT INTO public.who_global_data VALUES (16788, 1612, 72735, 47, 1404, 71, 155);
INSERT INTO public.who_global_data VALUES (16789, 0, 17, 0, 0, 71, 32);
INSERT INTO public.who_global_data VALUES (16790, 6, 4451, 0, 113, 71, 220);
INSERT INTO public.who_global_data VALUES (16791, 3069, 778571, 88, 21289, 71, 30);
INSERT INTO public.who_global_data VALUES (16792, 0, 3047, 0, 60, 71, 147);
INSERT INTO public.who_global_data VALUES (16793, 10118, 1681508, 255, 46092, 71, 208);
INSERT INTO public.who_global_data VALUES (16794, 559, 22028, 3, 99, 71, 45);
INSERT INTO public.who_global_data VALUES (16795, 336, 17404, 15, 1235, 71, 110);
INSERT INTO public.who_global_data VALUES (16796, 5, 5305, 0, 117, 71, 88);
INSERT INTO public.who_global_data VALUES (16797, 6066, 237614, 69, 6972, 71, 51);
INSERT INTO public.who_global_data VALUES (16798, 3955, 318881, 72, 4418, 71, 209);
INSERT INTO public.who_global_data VALUES (16799, 83, 7542, 8, 399, 71, 205);
INSERT INTO public.who_global_data VALUES (16800, 36, 12044, 0, 86, 71, 18);
INSERT INTO public.who_global_data VALUES (16801, 19, 3961, 0, 60, 71, 72);
INSERT INTO public.who_global_data VALUES (16802, 17555, 1574566, 498, 57031, 71, 44);
INSERT INTO public.who_global_data VALUES (16803, 0, 30, 0, 0, 71, 15);
INSERT INTO public.who_global_data VALUES (16804, 0, 2872, 0, 64, 71, 25);
INSERT INTO public.who_global_data VALUES (16805, 0, 0, 0, 0, 71, 179);
INSERT INTO public.who_global_data VALUES (16806, 0, 0, 0, 0, 71, 34);
INSERT INTO public.who_global_data VALUES (16807, 15, 6503, 1, 116, 71, 207);
INSERT INTO public.who_global_data VALUES (16808, 1168, 92475, 51, 3034, 71, 166);
INSERT INTO public.who_global_data VALUES (16809, 29132, 1311200, 174, 13014, 71, 126);
INSERT INTO public.who_global_data VALUES (16810, 0, 0, 0, 0, 71, 97);
INSERT INTO public.who_global_data VALUES (16811, 0, 746, 0, 6, 71, 36);
INSERT INTO public.who_global_data VALUES (16812, 0, 0, 0, 0, 71, 125);
INSERT INTO public.who_global_data VALUES (16813, 225, 19115, 0, 191, 71, 124);
INSERT INTO public.who_global_data VALUES (16814, 16218, 693407, 192, 11909, 71, 185);
INSERT INTO public.who_global_data VALUES (16815, 1305, 163967, 1, 564, 71, 194);
INSERT INTO public.who_global_data VALUES (16816, 0, 509, 0, 21, 71, 144);
INSERT INTO public.who_global_data VALUES (16817, 180850, 12622775, 2248, 260073, 71, 19);
INSERT INTO public.who_global_data VALUES (16818, 15, 1536, 0, 23, 71, 217);
INSERT INTO public.who_global_data VALUES (16819, 118, 4988, 1, 73, 71, 148);
INSERT INTO public.who_global_data VALUES (16820, 182, 72409, 1, 607, 71, 86);
INSERT INTO public.who_global_data VALUES (16821, 0, 1, 0, 0, 71, 13);
INSERT INTO public.who_global_data VALUES (16822, 319, 100817, 4, 880, 71, 157);
INSERT INTO public.who_global_data VALUES (16823, 10, 1331, 0, 35, 71, 8);
INSERT INTO public.who_global_data VALUES (16824, 0, 3, 0, 0, 71, 73);
INSERT INTO public.who_global_data VALUES (16825, 1, 2078, 0, 605, 71, 101);
INSERT INTO public.who_global_data VALUES (16826, 18, 17553, 0, 357, 71, 165);
INSERT INTO public.who_global_data VALUES (16827, 115, 9623, 0, 274, 71, 14);
INSERT INTO public.who_global_data VALUES (16828, 212, 45490, 13, 1725, 72, 193);
INSERT INTO public.who_global_data VALUES (16829, 644, 34944, 8, 743, 72, 113);
INSERT INTO public.who_global_data VALUES (16830, 1025, 78025, 20, 2329, 72, 143);
INSERT INTO public.who_global_data VALUES (16831, 0, 0, 0, 0, 72, 219);
INSERT INTO public.who_global_data VALUES (16832, 77, 6428, 0, 76, 72, 186);
INSERT INTO public.who_global_data VALUES (16833, 79, 14821, 2, 340, 72, 52);
INSERT INTO public.who_global_data VALUES (16834, 0, 4, 0, 0, 72, 180);
INSERT INTO public.who_global_data VALUES (16835, 1, 140, 0, 4, 72, 167);
INSERT INTO public.who_global_data VALUES (16836, 7164, 1381795, 310, 37432, 72, 154);
INSERT INTO public.who_global_data VALUES (16837, 1785, 130183, 28, 2063, 72, 94);
INSERT INTO public.who_global_data VALUES (16838, 14, 4751, 0, 45, 72, 66);
INSERT INTO public.who_global_data VALUES (16839, 6, 27854, 0, 907, 72, 58);
INSERT INTO public.who_global_data VALUES (16840, 5896, 259245, 94, 2502, 72, 163);
INSERT INTO public.who_global_data VALUES (16841, 3469, 102396, 30, 1224, 72, 37);
INSERT INTO public.who_global_data VALUES (16842, 9, 7469, 0, 163, 72, 142);
INSERT INTO public.who_global_data VALUES (16843, 169, 86185, 0, 340, 72, 83);
INSERT INTO public.who_global_data VALUES (16844, 2156, 454146, 39, 6487, 72, 228);
INSERT INTO public.who_global_data VALUES (16845, 2, 262, 0, 7, 72, 188);
INSERT INTO public.who_global_data VALUES (16846, 1496, 128449, 7, 1119, 72, 62);
INSERT INTO public.who_global_data VALUES (16847, 2683, 571254, 138, 16263, 72, 160);
INSERT INTO public.who_global_data VALUES (16848, 86, 5335, 5, 125, 72, 50);
INSERT INTO public.who_global_data VALUES (16849, 0, 2974, 0, 43, 72, 33);
INSERT INTO public.who_global_data VALUES (16850, 4, 239, 0, 9, 72, 183);
INSERT INTO public.who_global_data VALUES (16851, 0, 386, 0, 0, 72, 92);
INSERT INTO public.who_global_data VALUES (16852, 113, 144147, 12, 8928, 72, 158);
INSERT INTO public.who_global_data VALUES (16853, 0, 142, 0, 3, 72, 67);
INSERT INTO public.who_global_data VALUES (16854, 1589, 83328, 35, 2429, 72, 57);
INSERT INTO public.who_global_data VALUES (16855, 0, 9992, 0, 31, 72, 38);
INSERT INTO public.who_global_data VALUES (16856, 31100, 6118708, 630, 170115, 72, 141);
INSERT INTO public.who_global_data VALUES (16857, 0, 72, 0, 1, 72, 178);
INSERT INTO public.who_global_data VALUES (16858, 0, 150, 0, 3, 72, 108);
INSERT INTO public.who_global_data VALUES (16859, 3712, 133060, 141, 3367, 72, 39);
INSERT INTO public.who_global_data VALUES (16860, 20, 2777, 0, 68, 72, 2);
INSERT INTO public.who_global_data VALUES (16861, 4, 677, 0, 1, 72, 195);
INSERT INTO public.who_global_data VALUES (16862, 126, 10526, 0, 104, 72, 107);
INSERT INTO public.who_global_data VALUES (16863, 0, 307, 0, 0, 72, 161);
INSERT INTO public.who_global_data VALUES (16864, 107, 24022, 0, 437, 72, 212);
INSERT INTO public.who_global_data VALUES (16865, 4889, 342444, 97, 11618, 72, 181);
INSERT INTO public.who_global_data VALUES (16866, 1, 266, 0, 2, 72, 53);
INSERT INTO public.who_global_data VALUES (16867, 2, 4913, 0, 63, 72, 164);
INSERT INTO public.who_global_data VALUES (16868, 6, 1655, 0, 101, 72, 140);
INSERT INTO public.who_global_data VALUES (16869, 1005, 544092, 7, 15138, 72, 20);
INSERT INTO public.who_global_data VALUES (16870, 111, 93025, 0, 4749, 72, 112);
INSERT INTO public.who_global_data VALUES (16871, 7515, 1262494, 198, 35677, 72, 111);
INSERT INTO public.who_global_data VALUES (16872, 11, 607, 0, 7, 72, 71);
INSERT INTO public.who_global_data VALUES (16873, 0, 5632, 0, 93, 72, 218);
INSERT INTO public.who_global_data VALUES (16874, 0, 0, 0, 0, 72, 43);
INSERT INTO public.who_global_data VALUES (16875, 895, 133190, 21, 1662, 72, 49);
INSERT INTO public.who_global_data VALUES (16876, 12, 21168, 0, 131, 72, 1);
INSERT INTO public.who_global_data VALUES (16877, 3603, 111617, 56, 1501, 72, 48);
INSERT INTO public.who_global_data VALUES (16878, 76, 8026, 0, 133, 72, 232);
INSERT INTO public.who_global_data VALUES (16879, 54, 1827, 0, 3, 72, 175);
INSERT INTO public.who_global_data VALUES (16880, 254, 9453, 1, 47, 72, 21);
INSERT INTO public.who_global_data VALUES (16881, 2681, 505215, 112, 7611, 72, 156);
INSERT INTO public.who_global_data VALUES (16882, 0, 0, 0, 0, 72, 95);
INSERT INTO public.who_global_data VALUES (16883, 55, 12364, 0, 331, 72, 177);
INSERT INTO public.who_global_data VALUES (16884, 1183, 74204, 5, 802, 72, 210);
INSERT INTO public.who_global_data VALUES (16885, 1, 5670, 0, 61, 72, 120);
INSERT INTO public.who_global_data VALUES (16886, 0, 77, 0, 0, 72, 135);
INSERT INTO public.who_global_data VALUES (16887, 553, 139664, 2, 2315, 72, 206);
INSERT INTO public.who_global_data VALUES (16888, 794, 187230, 24, 13288, 72, 189);
INSERT INTO public.who_global_data VALUES (16889, 365, 114107, 12, 6585, 72, 129);
INSERT INTO public.who_global_data VALUES (16890, 0, 37884, 0, 1086, 72, 121);
INSERT INTO public.who_global_data VALUES (16891, 9, 5146, 0, 85, 72, 59);
INSERT INTO public.who_global_data VALUES (16892, 0, 558, 0, 0, 72, 96);
INSERT INTO public.who_global_data VALUES (16893, 382, 10541, 3, 97, 72, 41);
INSERT INTO public.who_global_data VALUES (16894, 25, 6272, 0, 120, 72, 216);
INSERT INTO public.who_global_data VALUES (16895, 518, 107109, 3, 1664, 72, 236);
INSERT INTO public.who_global_data VALUES (16896, 0, 16, 0, 0, 72, 150);
INSERT INTO public.who_global_data VALUES (16897, 0, 500, 0, 0, 72, 61);
INSERT INTO public.who_global_data VALUES (16898, 3, 38, 0, 2, 72, 7);
INSERT INTO public.who_global_data VALUES (16899, 363, 22652, 4, 388, 72, 169);
INSERT INTO public.who_global_data VALUES (16900, 15598, 2131376, 371, 50259, 72, 28);
INSERT INTO public.who_global_data VALUES (16901, 37, 11116, 0, 70, 72, 85);
INSERT INTO public.who_global_data VALUES (16902, 266, 13783, 0, 70, 72, 211);
INSERT INTO public.who_global_data VALUES (16903, 23, 9173, 0, 59, 72, 60);
INSERT INTO public.who_global_data VALUES (16904, 1, 3727, 0, 123, 72, 3);
INSERT INTO public.who_global_data VALUES (16905, 3801, 118690, 39, 1124, 72, 11);
INSERT INTO public.who_global_data VALUES (16906, 22268, 983588, 389, 15160, 72, 89);
INSERT INTO public.who_global_data VALUES (16907, 41, 51225, 0, 323, 72, 24);
INSERT INTO public.who_global_data VALUES (16908, 14, 981, 0, 5, 72, 162);
INSERT INTO public.who_global_data VALUES (16909, 2151, 97288, 87, 1902, 72, 100);
INSERT INTO public.who_global_data VALUES (16910, 0, 18, 0, 0, 72, 47);
INSERT INTO public.who_global_data VALUES (16911, 0, 41, 0, 0, 72, 29);
INSERT INTO public.who_global_data VALUES (16912, 119, 8344, 5, 149, 72, 40);
INSERT INTO public.who_global_data VALUES (16913, 47, 6580, 2, 109, 72, 222);
INSERT INTO public.who_global_data VALUES (16914, 640, 119989, 8, 4107, 72, 132);
INSERT INTO public.who_global_data VALUES (16915, 0, 283, 0, 13, 72, 130);
INSERT INTO public.who_global_data VALUES (16916, 0, 12863, 0, 75, 72, 234);
INSERT INTO public.who_global_data VALUES (16917, 0, 2422, 0, 43, 72, 23);
INSERT INTO public.who_global_data VALUES (16918, 35, 5189, 1, 147, 72, 192);
INSERT INTO public.who_global_data VALUES (16919, 19, 9248, 0, 232, 72, 69);
INSERT INTO public.who_global_data VALUES (16920, 0, 26, 0, 0, 72, 187);
INSERT INTO public.who_global_data VALUES (16921, 361, 105572, 8, 2877, 72, 230);
INSERT INTO public.who_global_data VALUES (16922, 6360, 192047, 115, 4229, 72, 77);
INSERT INTO public.who_global_data VALUES (16923, 14, 5312, 0, 26, 72, 9);
INSERT INTO public.who_global_data VALUES (16924, 44489, 9266705, 524, 135223, 72, 74);
INSERT INTO public.who_global_data VALUES (16925, 5534, 511836, 114, 16225, 72, 224);
INSERT INTO public.who_global_data VALUES (16926, 13843, 894385, 469, 46207, 72, 199);
INSERT INTO public.who_global_data VALUES (16927, 2438, 542187, 55, 12086, 72, 190);
INSERT INTO public.who_global_data VALUES (16928, 257, 71187, 5, 2033, 72, 12);
INSERT INTO public.who_global_data VALUES (16929, 0, 369, 0, 25, 72, 104);
INSERT INTO public.who_global_data VALUES (16930, 857, 331139, 6, 2831, 72, 153);
INSERT INTO public.who_global_data VALUES (16931, 25852, 1480874, 722, 52028, 72, 91);
INSERT INTO public.who_global_data VALUES (16932, 66, 10488, 4, 247, 72, 215);
INSERT INTO public.who_global_data VALUES (16933, 1861, 137261, 21, 2022, 72, 84);
INSERT INTO public.who_global_data VALUES (16934, 6, 836, 0, 32, 72, 231);
INSERT INTO public.who_global_data VALUES (16935, 5025, 198021, 62, 2442, 72, 196);
INSERT INTO public.who_global_data VALUES (16936, 974, 170969, 0, 2417, 72, 105);
INSERT INTO public.who_global_data VALUES (16937, 810, 79322, 8, 1417, 72, 122);
INSERT INTO public.who_global_data VALUES (16938, 0, 0, 0, 0, 72, 159);
INSERT INTO public.who_global_data VALUES (16939, 704, 36210, 9, 938, 72, 75);
INSERT INTO public.who_global_data VALUES (16940, 422, 141217, 1, 871, 72, 27);
INSERT INTO public.who_global_data VALUES (16941, 427, 71171, 6, 1251, 72, 54);
INSERT INTO public.who_global_data VALUES (16942, 0, 39, 0, 0, 72, 226);
INSERT INTO public.who_global_data VALUES (16943, 580, 14273, 9, 184, 72, 79);
INSERT INTO public.who_global_data VALUES (16944, 1636, 120300, 16, 950, 72, 56);
INSERT INTO public.who_global_data VALUES (16945, 7, 2092, 0, 44, 72, 117);
INSERT INTO public.who_global_data VALUES (16946, 24, 1578, 1, 83, 72, 152);
INSERT INTO public.who_global_data VALUES (16947, 617, 79797, 15, 1125, 72, 16);
INSERT INTO public.who_global_data VALUES (16948, 30, 1262, 0, 14, 72, 10);
INSERT INTO public.who_global_data VALUES (16949, 2101, 53761, 27, 528, 72, 201);
INSERT INTO public.who_global_data VALUES (16950, 373, 31484, 10, 283, 72, 174);
INSERT INTO public.who_global_data VALUES (16951, 0, 17341, 0, 251, 72, 119);
INSERT INTO public.who_global_data VALUES (16952, 1, 6018, 0, 185, 72, 168);
INSERT INTO public.who_global_data VALUES (16953, 970, 59817, 4, 345, 72, 99);
INSERT INTO public.who_global_data VALUES (16954, 44, 12854, 0, 46, 72, 171);
INSERT INTO public.who_global_data VALUES (16955, 135, 4461, 2, 148, 72, 87);
INSERT INTO public.who_global_data VALUES (16956, 69, 9361, 5, 122, 72, 123);
INSERT INTO public.who_global_data VALUES (16957, 0, 4, 0, 0, 72, 151);
INSERT INTO public.who_global_data VALUES (16958, 322, 5413, 1, 40, 72, 213);
INSERT INTO public.who_global_data VALUES (16959, 0, 8075, 0, 169, 72, 118);
INSERT INTO public.who_global_data VALUES (16960, 0, 497, 0, 10, 72, 134);
INSERT INTO public.who_global_data VALUES (16961, 59, 5181, 0, 49, 72, 65);
INSERT INTO public.who_global_data VALUES (16962, 10794, 1060152, 813, 102739, 72, 102);
INSERT INTO public.who_global_data VALUES (16963, 0, 0, 0, 0, 72, 223);
INSERT INTO public.who_global_data VALUES (16964, 7, 597, 0, 3, 72, 4);
INSERT INTO public.who_global_data VALUES (16965, 27, 699, 0, 0, 72, 146);
INSERT INTO public.who_global_data VALUES (16966, 592, 33812, 10, 468, 72, 31);
INSERT INTO public.who_global_data VALUES (16967, 0, 13, 0, 1, 72, 127);
INSERT INTO public.who_global_data VALUES (16968, 4979, 336506, 43, 5539, 72, 22);
INSERT INTO public.who_global_data VALUES (16969, 71, 15302, 1, 128, 72, 115);
INSERT INTO public.who_global_data VALUES (16970, 1330, 83566, 26, 1810, 72, 106);
INSERT INTO public.who_global_data VALUES (16971, 68, 14006, 0, 145, 72, 90);
INSERT INTO public.who_global_data VALUES (16972, 0, 0, 0, 0, 72, 70);
INSERT INTO public.who_global_data VALUES (16973, 1948, 226026, 28, 1389, 72, 46);
INSERT INTO public.who_global_data VALUES (16974, 4912, 497456, 74, 9088, 72, 139);
INSERT INTO public.who_global_data VALUES (16975, 0, 32, 0, 0, 72, 42);
INSERT INTO public.who_global_data VALUES (16976, 1, 1684, 0, 25, 72, 80);
INSERT INTO public.who_global_data VALUES (16977, 0, 4629, 0, 160, 72, 203);
INSERT INTO public.who_global_data VALUES (16978, 38, 1419, 0, 70, 72, 136);
INSERT INTO public.who_global_data VALUES (16979, 198, 66805, 0, 1169, 72, 63);
INSERT INTO public.who_global_data VALUES (16980, 0, 0, 0, 0, 72, 17);
INSERT INTO public.who_global_data VALUES (16981, 0, 104, 0, 2, 72, 172);
INSERT INTO public.who_global_data VALUES (16982, 1287, 57451, 39, 1600, 72, 109);
INSERT INTO public.who_global_data VALUES (16983, 531, 33714, 2, 316, 72, 200);
INSERT INTO public.who_global_data VALUES (16984, 1720, 89558, 9, 749, 72, 93);
INSERT INTO public.who_global_data VALUES (16985, 0, 122579, 0, 1391, 72, 5);
INSERT INTO public.who_global_data VALUES (16986, 0, 741, 0, 13, 72, 214);
INSERT INTO public.who_global_data VALUES (16987, 3009, 382892, 59, 7803, 72, 204);
INSERT INTO public.who_global_data VALUES (16988, 0, 0, 0, 0, 72, 198);
INSERT INTO public.who_global_data VALUES (16989, 1272, 156930, 13, 2986, 72, 173);
INSERT INTO public.who_global_data VALUES (16990, 15, 645, 0, 7, 72, 229);
INSERT INTO public.who_global_data VALUES (16991, 819, 77891, 12, 1677, 72, 76);
INSERT INTO public.who_global_data VALUES (16992, 1882, 952439, 44, 35685, 72, 138);
INSERT INTO public.who_global_data VALUES (16993, 1193, 422915, 30, 8215, 72, 98);
INSERT INTO public.who_global_data VALUES (16994, 0, 0, 0, 0, 72, 103);
INSERT INTO public.who_global_data VALUES (16995, 15356, 924422, 674, 14988, 72, 225);
INSERT INTO public.who_global_data VALUES (16996, 5290, 274011, 71, 4127, 72, 131);
INSERT INTO public.who_global_data VALUES (16997, 177, 48725, 14, 1052, 72, 235);
INSERT INTO public.who_global_data VALUES (16998, 209, 137851, 1, 237, 72, 137);
INSERT INTO public.who_global_data VALUES (16999, 581, 32253, 2, 515, 72, 81);
INSERT INTO public.who_global_data VALUES (17000, 1570, 101203, 21, 2209, 72, 182);
INSERT INTO public.who_global_data VALUES (17001, 147, 7836, 4, 39, 72, 145);
INSERT INTO public.who_global_data VALUES (17002, 9739, 440344, 168, 10541, 72, 26);
INSERT INTO public.who_global_data VALUES (17003, 25487, 2187990, 524, 38062, 72, 170);
INSERT INTO public.who_global_data VALUES (17004, 29, 5779, 0, 47, 72, 191);
INSERT INTO public.who_global_data VALUES (17005, 0, 5, 0, 0, 72, 221);
INSERT INTO public.who_global_data VALUES (17006, 0, 127, 0, 0, 72, 64);
INSERT INTO public.who_global_data VALUES (17007, 0, 0, 0, 0, 72, 116);
INSERT INTO public.who_global_data VALUES (17008, 0, 22, 0, 0, 72, 128);
INSERT INTO public.who_global_data VALUES (17009, 9, 235, 0, 2, 72, 6);
INSERT INTO public.who_global_data VALUES (17010, 0, 690, 0, 12, 72, 227);
INSERT INTO public.who_global_data VALUES (17011, 0, 14, 0, 0, 72, 68);
INSERT INTO public.who_global_data VALUES (17012, 0, 84, 0, 0, 72, 184);
INSERT INTO public.who_global_data VALUES (17013, 0, 0, 0, 0, 72, 82);
INSERT INTO public.who_global_data VALUES (17014, 38, 1492, 0, 44, 72, 149);
INSERT INTO public.who_global_data VALUES (17015, 1, 982, 0, 17, 72, 197);
INSERT INTO public.who_global_data VALUES (17016, 326, 356067, 14, 5825, 72, 78);
INSERT INTO public.who_global_data VALUES (17017, 19, 15927, 0, 331, 72, 233);
INSERT INTO public.who_global_data VALUES (17018, 7579, 140608, 41, 1315, 72, 133);
INSERT INTO public.who_global_data VALUES (17019, 0, 167, 0, 0, 72, 35);
INSERT INTO public.who_global_data VALUES (17020, 2, 2408, 0, 74, 72, 114);
INSERT INTO public.who_global_data VALUES (17021, 7, 58190, 0, 28, 72, 237);
INSERT INTO public.who_global_data VALUES (17022, 0, 14, 0, 0, 72, 55);
INSERT INTO public.who_global_data VALUES (17023, 3, 1020, 0, 25, 72, 176);
INSERT INTO public.who_global_data VALUES (17024, 1811, 99304, 23, 732, 72, 202);
INSERT INTO public.who_global_data VALUES (17025, 1782, 71123, 54, 1357, 72, 155);
INSERT INTO public.who_global_data VALUES (17026, 0, 17, 0, 0, 72, 32);
INSERT INTO public.who_global_data VALUES (17027, 0, 4445, 0, 113, 72, 220);
INSERT INTO public.who_global_data VALUES (17028, 3250, 775502, 118, 21201, 72, 30);
INSERT INTO public.who_global_data VALUES (17029, 0, 3047, 0, 60, 72, 147);
INSERT INTO public.who_global_data VALUES (17030, 11058, 1671390, 228, 45837, 72, 208);
INSERT INTO public.who_global_data VALUES (17031, 502, 21469, 2, 96, 72, 45);
INSERT INTO public.who_global_data VALUES (17032, 204, 17068, 5, 1220, 72, 110);
INSERT INTO public.who_global_data VALUES (17033, 3, 5300, 1, 117, 72, 88);
INSERT INTO public.who_global_data VALUES (17034, 5674, 231548, 68, 6903, 72, 51);
INSERT INTO public.who_global_data VALUES (17035, 4302, 314926, 84, 4346, 72, 209);
INSERT INTO public.who_global_data VALUES (17036, 90, 7459, 6, 391, 72, 205);
INSERT INTO public.who_global_data VALUES (17037, 37, 12008, 0, 86, 72, 18);
INSERT INTO public.who_global_data VALUES (17038, 16, 3942, 0, 60, 72, 72);
INSERT INTO public.who_global_data VALUES (17039, 18213, 1557011, 695, 56533, 72, 44);
INSERT INTO public.who_global_data VALUES (17040, 0, 30, 0, 0, 72, 15);
INSERT INTO public.who_global_data VALUES (17041, 15, 2872, 0, 64, 72, 25);
INSERT INTO public.who_global_data VALUES (17042, 0, 0, 0, 0, 72, 179);
INSERT INTO public.who_global_data VALUES (17043, 0, 0, 0, 0, 72, 34);
INSERT INTO public.who_global_data VALUES (17044, 13, 6488, 0, 115, 72, 207);
INSERT INTO public.who_global_data VALUES (17045, 1094, 91307, 48, 2983, 72, 166);
INSERT INTO public.who_global_data VALUES (17046, 13545, 1282068, 168, 12840, 72, 126);
INSERT INTO public.who_global_data VALUES (17047, 0, 0, 0, 0, 72, 97);
INSERT INTO public.who_global_data VALUES (17048, 0, 746, 0, 6, 72, 36);
INSERT INTO public.who_global_data VALUES (17049, 0, 0, 0, 0, 72, 125);
INSERT INTO public.who_global_data VALUES (17050, 484, 18890, 5, 191, 72, 124);
INSERT INTO public.who_global_data VALUES (17051, 15331, 677189, 225, 11717, 72, 185);
INSERT INTO public.who_global_data VALUES (17052, 1297, 162662, 4, 563, 72, 194);
INSERT INTO public.who_global_data VALUES (17053, 0, 509, 0, 21, 72, 144);
INSERT INTO public.who_global_data VALUES (17054, 165091, 12441925, 1975, 257825, 72, 19);
INSERT INTO public.who_global_data VALUES (17055, 14, 1521, 0, 23, 72, 217);
INSERT INTO public.who_global_data VALUES (17056, 107, 4870, 1, 72, 72, 148);
INSERT INTO public.who_global_data VALUES (17057, 188, 72227, 1, 606, 72, 86);
INSERT INTO public.who_global_data VALUES (17058, 0, 1, 0, 0, 72, 13);
INSERT INTO public.who_global_data VALUES (17059, 355, 100498, 3, 876, 72, 157);
INSERT INTO public.who_global_data VALUES (17060, 5, 1321, 0, 35, 72, 8);
INSERT INTO public.who_global_data VALUES (17061, 0, 3, 0, 0, 72, 73);
INSERT INTO public.who_global_data VALUES (17062, 0, 2077, 0, 605, 72, 101);
INSERT INTO public.who_global_data VALUES (17063, 69, 17535, 0, 357, 72, 165);
INSERT INTO public.who_global_data VALUES (17064, 110, 9508, 0, 274, 72, 14);
INSERT INTO public.who_global_data VALUES (17065, 290, 45278, 17, 1712, 73, 193);
INSERT INTO public.who_global_data VALUES (17066, 744, 34300, 19, 735, 73, 113);
INSERT INTO public.who_global_data VALUES (17067, 1133, 77000, 15, 2309, 73, 143);
INSERT INTO public.who_global_data VALUES (17068, 0, 0, 0, 0, 73, 219);
INSERT INTO public.who_global_data VALUES (17069, 47, 6351, 0, 76, 73, 186);
INSERT INTO public.who_global_data VALUES (17070, 108, 14742, 1, 338, 73, 52);
INSERT INTO public.who_global_data VALUES (17071, 0, 4, 0, 0, 73, 180);
INSERT INTO public.who_global_data VALUES (17072, 0, 139, 0, 4, 73, 167);
INSERT INTO public.who_global_data VALUES (17073, 4265, 1374631, 120, 37122, 73, 154);
INSERT INTO public.who_global_data VALUES (17074, 1563, 128398, 38, 2035, 73, 94);
INSERT INTO public.who_global_data VALUES (17075, 6, 4737, 0, 45, 73, 66);
INSERT INTO public.who_global_data VALUES (17076, 13, 27848, 0, 907, 73, 58);
INSERT INTO public.who_global_data VALUES (17077, 4135, 253349, 115, 2408, 73, 163);
INSERT INTO public.who_global_data VALUES (17078, 3646, 98927, 34, 1194, 73, 37);
INSERT INTO public.who_global_data VALUES (17079, 29, 7460, 0, 163, 73, 142);
INSERT INTO public.who_global_data VALUES (17080, 130, 86016, 1, 340, 73, 83);
INSERT INTO public.who_global_data VALUES (17081, 2230, 451990, 32, 6448, 73, 228);
INSERT INTO public.who_global_data VALUES (17082, 1, 260, 0, 7, 73, 188);
INSERT INTO public.who_global_data VALUES (17083, 1471, 126953, 8, 1112, 73, 62);
INSERT INTO public.who_global_data VALUES (17084, 2877, 568571, 121, 16125, 73, 160);
INSERT INTO public.who_global_data VALUES (17085, 66, 5249, 4, 120, 73, 50);
INSERT INTO public.who_global_data VALUES (17086, 58, 2974, 0, 43, 73, 33);
INSERT INTO public.who_global_data VALUES (17087, 8, 235, 0, 9, 73, 183);
INSERT INTO public.who_global_data VALUES (17088, 0, 386, 0, 0, 73, 92);
INSERT INTO public.who_global_data VALUES (17089, 56, 144034, 9, 8916, 73, 158);
INSERT INTO public.who_global_data VALUES (17090, 0, 142, 0, 3, 73, 67);
INSERT INTO public.who_global_data VALUES (17091, 1186, 81739, 52, 2394, 73, 57);
INSERT INTO public.who_global_data VALUES (17092, 398, 9992, 0, 31, 73, 38);
INSERT INTO public.who_global_data VALUES (17093, 16207, 6087608, 302, 169485, 73, 141);
INSERT INTO public.who_global_data VALUES (17094, 0, 72, 0, 1, 73, 178);
INSERT INTO public.who_global_data VALUES (17095, 1, 150, 0, 3, 73, 108);
INSERT INTO public.who_global_data VALUES (17096, 4382, 129348, 157, 3226, 73, 39);
INSERT INTO public.who_global_data VALUES (17097, 3, 2757, 0, 68, 73, 2);
INSERT INTO public.who_global_data VALUES (17098, 0, 673, 0, 1, 73, 195);
INSERT INTO public.who_global_data VALUES (17099, 98, 10400, 0, 104, 73, 107);
INSERT INTO public.who_global_data VALUES (17100, 1, 307, 0, 0, 73, 161);
INSERT INTO public.who_global_data VALUES (17101, 46, 23915, 1, 437, 73, 212);
INSERT INTO public.who_global_data VALUES (17102, 7052, 337555, 66, 11521, 73, 181);
INSERT INTO public.who_global_data VALUES (17103, 4, 265, 0, 2, 73, 53);
INSERT INTO public.who_global_data VALUES (17104, 0, 4911, 0, 63, 73, 164);
INSERT INTO public.who_global_data VALUES (17105, 1, 1649, 0, 101, 73, 140);
INSERT INTO public.who_global_data VALUES (17106, 1007, 543087, 25, 15131, 73, 20);
INSERT INTO public.who_global_data VALUES (17107, 85, 92914, 0, 4749, 73, 112);
INSERT INTO public.who_global_data VALUES (17108, 6562, 1254979, 192, 35479, 73, 111);
INSERT INTO public.who_global_data VALUES (17109, 0, 596, 0, 7, 73, 71);
INSERT INTO public.who_global_data VALUES (17110, 0, 5632, 0, 93, 73, 218);
INSERT INTO public.who_global_data VALUES (17111, 0, 0, 0, 0, 73, 43);
INSERT INTO public.who_global_data VALUES (17112, 2877, 132295, 33, 1641, 73, 49);
INSERT INTO public.who_global_data VALUES (17113, 8, 21156, 0, 131, 73, 1);
INSERT INTO public.who_global_data VALUES (17114, 2323, 108014, 47, 1445, 73, 48);
INSERT INTO public.who_global_data VALUES (17115, 71, 7950, 1, 133, 73, 232);
INSERT INTO public.who_global_data VALUES (17116, 24, 1773, 0, 3, 73, 175);
INSERT INTO public.who_global_data VALUES (17117, 252, 9199, 2, 46, 73, 21);
INSERT INTO public.who_global_data VALUES (17118, 5896, 502534, 139, 7499, 73, 156);
INSERT INTO public.who_global_data VALUES (17119, 0, 0, 0, 0, 73, 95);
INSERT INTO public.who_global_data VALUES (17120, 32, 12309, 2, 331, 73, 177);
INSERT INTO public.who_global_data VALUES (17121, 1367, 73021, 8, 797, 73, 210);
INSERT INTO public.who_global_data VALUES (17122, 1, 5669, 0, 61, 73, 120);
INSERT INTO public.who_global_data VALUES (17123, 0, 77, 0, 0, 73, 135);
INSERT INTO public.who_global_data VALUES (17124, 282, 139111, 2, 2313, 73, 206);
INSERT INTO public.who_global_data VALUES (17125, 492, 186436, 39, 13264, 73, 189);
INSERT INTO public.who_global_data VALUES (17126, 361, 113742, 13, 6573, 73, 129);
INSERT INTO public.who_global_data VALUES (17127, 322, 37884, 5, 1086, 73, 121);
INSERT INTO public.who_global_data VALUES (17128, 0, 5137, 0, 85, 73, 59);
INSERT INTO public.who_global_data VALUES (17129, 0, 558, 0, 0, 73, 96);
INSERT INTO public.who_global_data VALUES (17130, 203, 10159, 2, 94, 73, 41);
INSERT INTO public.who_global_data VALUES (17131, 14, 6247, 0, 120, 73, 216);
INSERT INTO public.who_global_data VALUES (17132, 388, 106591, 10, 1661, 73, 236);
INSERT INTO public.who_global_data VALUES (17133, 0, 16, 0, 0, 73, 150);
INSERT INTO public.who_global_data VALUES (17134, 0, 500, 0, 0, 73, 61);
INSERT INTO public.who_global_data VALUES (17135, 0, 35, 0, 2, 73, 7);
INSERT INTO public.who_global_data VALUES (17136, 353, 22289, 0, 384, 73, 169);
INSERT INTO public.who_global_data VALUES (17137, 9118, 2115778, 1005, 49888, 73, 28);
INSERT INTO public.who_global_data VALUES (17138, 37, 11079, 0, 70, 73, 85);
INSERT INTO public.who_global_data VALUES (17139, 231, 13517, 2, 70, 73, 211);
INSERT INTO public.who_global_data VALUES (17140, 0, 9150, 0, 59, 73, 60);
INSERT INTO public.who_global_data VALUES (17141, 0, 3726, 0, 123, 73, 3);
INSERT INTO public.who_global_data VALUES (17142, 3071, 114889, 34, 1085, 73, 11);
INSERT INTO public.who_global_data VALUES (17143, 18633, 961320, 410, 14771, 73, 89);
INSERT INTO public.who_global_data VALUES (17144, 243, 51184, 0, 323, 73, 24);
INSERT INTO public.who_global_data VALUES (17145, 9, 967, 1, 5, 73, 162);
INSERT INTO public.who_global_data VALUES (17146, 2131, 95137, 101, 1815, 73, 100);
INSERT INTO public.who_global_data VALUES (17147, 0, 18, 0, 0, 73, 47);
INSERT INTO public.who_global_data VALUES (17148, 0, 41, 0, 0, 73, 29);
INSERT INTO public.who_global_data VALUES (17149, 0, 8225, 0, 144, 73, 40);
INSERT INTO public.who_global_data VALUES (17150, 52, 6533, 1, 107, 73, 222);
INSERT INTO public.who_global_data VALUES (17151, 627, 119349, 7, 4099, 73, 132);
INSERT INTO public.who_global_data VALUES (17152, 0, 283, 0, 13, 73, 130);
INSERT INTO public.who_global_data VALUES (17153, 0, 12863, 0, 75, 73, 234);
INSERT INTO public.who_global_data VALUES (17154, 0, 2422, 0, 43, 73, 23);
INSERT INTO public.who_global_data VALUES (17155, 21, 5154, 3, 146, 73, 192);
INSERT INTO public.who_global_data VALUES (17156, 5, 9229, 0, 232, 73, 69);
INSERT INTO public.who_global_data VALUES (17157, 0, 26, 0, 0, 73, 187);
INSERT INTO public.who_global_data VALUES (17158, 296, 105211, 10, 2869, 73, 230);
INSERT INTO public.who_global_data VALUES (17159, 3806, 185687, 106, 4114, 73, 77);
INSERT INTO public.who_global_data VALUES (17160, 9, 5298, 0, 26, 73, 9);
INSERT INTO public.who_global_data VALUES (17161, 44376, 9222216, 481, 134699, 73, 74);
INSERT INTO public.who_global_data VALUES (17162, 4192, 506302, 109, 16111, 73, 224);
INSERT INTO public.who_global_data VALUES (17163, 13721, 880542, 483, 45738, 73, 199);
INSERT INTO public.who_global_data VALUES (17164, 2292, 539749, 35, 12031, 73, 190);
INSERT INTO public.who_global_data VALUES (17165, 219, 70930, 6, 2028, 73, 12);
INSERT INTO public.who_global_data VALUES (17166, 0, 369, 0, 25, 73, 104);
INSERT INTO public.who_global_data VALUES (17167, 959, 330282, 7, 2825, 73, 153);
INSERT INTO public.who_global_data VALUES (17168, 23227, 1455022, 853, 51306, 73, 91);
INSERT INTO public.who_global_data VALUES (17169, 79, 10422, 4, 243, 73, 215);
INSERT INTO public.who_global_data VALUES (17170, 1471, 135400, 12, 2001, 73, 84);
INSERT INTO public.who_global_data VALUES (17171, 24, 830, 0, 32, 73, 231);
INSERT INTO public.who_global_data VALUES (17172, 4586, 192996, 78, 2380, 73, 196);
INSERT INTO public.who_global_data VALUES (17173, 988, 169995, 0, 2417, 73, 105);
INSERT INTO public.who_global_data VALUES (17174, 727, 78512, 17, 1409, 73, 122);
INSERT INTO public.who_global_data VALUES (17175, 0, 0, 0, 0, 73, 159);
INSERT INTO public.who_global_data VALUES (17176, 609, 35506, 13, 929, 73, 75);
INSERT INTO public.who_global_data VALUES (17177, 402, 140795, 2, 870, 73, 27);
INSERT INTO public.who_global_data VALUES (17178, 378, 70744, 4, 1245, 73, 54);
INSERT INTO public.who_global_data VALUES (17179, 0, 39, 0, 0, 73, 226);
INSERT INTO public.who_global_data VALUES (17180, 457, 13693, 13, 175, 73, 79);
INSERT INTO public.who_global_data VALUES (17181, 1188, 118664, 23, 934, 73, 56);
INSERT INTO public.who_global_data VALUES (17182, 0, 2085, 0, 44, 73, 117);
INSERT INTO public.who_global_data VALUES (17183, 0, 1554, 0, 82, 73, 152);
INSERT INTO public.who_global_data VALUES (17184, 707, 79180, 8, 1110, 73, 16);
INSERT INTO public.who_global_data VALUES (17185, 22, 1232, 1, 14, 73, 10);
INSERT INTO public.who_global_data VALUES (17186, 2288, 51660, 22, 501, 73, 201);
INSERT INTO public.who_global_data VALUES (17187, 176, 31111, 7, 273, 73, 174);
INSERT INTO public.who_global_data VALUES (17188, 0, 17341, 0, 251, 73, 119);
INSERT INTO public.who_global_data VALUES (17189, 8, 6017, 0, 185, 73, 168);
INSERT INTO public.who_global_data VALUES (17190, 2188, 58847, 4, 341, 73, 99);
INSERT INTO public.who_global_data VALUES (17191, 52, 12810, 0, 46, 73, 171);
INSERT INTO public.who_global_data VALUES (17192, 0, 4326, 0, 146, 73, 87);
INSERT INTO public.who_global_data VALUES (17193, 166, 9292, 3, 117, 73, 123);
INSERT INTO public.who_global_data VALUES (17194, 0, 4, 0, 0, 73, 151);
INSERT INTO public.who_global_data VALUES (17195, 0, 5091, 0, 39, 73, 213);
INSERT INTO public.who_global_data VALUES (17196, 0, 8075, 0, 169, 73, 118);
INSERT INTO public.who_global_data VALUES (17197, 6, 497, 0, 10, 73, 134);
INSERT INTO public.who_global_data VALUES (17198, 0, 5122, 0, 49, 73, 65);
INSERT INTO public.who_global_data VALUES (17199, 7483, 1049358, 250, 101926, 73, 102);
INSERT INTO public.who_global_data VALUES (17200, 0, 0, 0, 0, 73, 223);
INSERT INTO public.who_global_data VALUES (17201, 4, 590, 0, 3, 73, 4);
INSERT INTO public.who_global_data VALUES (17202, 32, 672, 0, 0, 73, 146);
INSERT INTO public.who_global_data VALUES (17203, 558, 33220, 9, 458, 73, 31);
INSERT INTO public.who_global_data VALUES (17204, 0, 13, 0, 1, 73, 127);
INSERT INTO public.who_global_data VALUES (17205, 3999, 331527, 100, 5496, 73, 22);
INSERT INTO public.who_global_data VALUES (17206, 122, 15231, 1, 127, 73, 115);
INSERT INTO public.who_global_data VALUES (17207, 1731, 82236, 19, 1784, 73, 106);
INSERT INTO public.who_global_data VALUES (17208, 41, 13938, 0, 145, 73, 90);
INSERT INTO public.who_global_data VALUES (17209, 0, 0, 0, 0, 73, 70);
INSERT INTO public.who_global_data VALUES (17210, 1790, 224078, 24, 1361, 73, 46);
INSERT INTO public.who_global_data VALUES (17211, 3947, 492544, 90, 9014, 73, 139);
INSERT INTO public.who_global_data VALUES (17212, 0, 32, 0, 0, 73, 42);
INSERT INTO public.who_global_data VALUES (17213, 8, 1683, 0, 25, 73, 80);
INSERT INTO public.who_global_data VALUES (17214, 46, 4629, 1, 160, 73, 203);
INSERT INTO public.who_global_data VALUES (17215, 0, 1381, 0, 70, 73, 136);
INSERT INTO public.who_global_data VALUES (17216, 168, 66607, 1, 1169, 73, 63);
INSERT INTO public.who_global_data VALUES (17217, 0, 0, 0, 0, 73, 17);
INSERT INTO public.who_global_data VALUES (17218, 0, 104, 0, 2, 73, 172);
INSERT INTO public.who_global_data VALUES (17219, 1037, 56164, 15, 1561, 73, 109);
INSERT INTO public.who_global_data VALUES (17220, 416, 33183, 3, 314, 73, 200);
INSERT INTO public.who_global_data VALUES (17221, 1946, 87838, 17, 740, 73, 93);
INSERT INTO public.who_global_data VALUES (17222, 223, 122579, 5, 1391, 73, 5);
INSERT INTO public.who_global_data VALUES (17223, 0, 741, 0, 13, 73, 214);
INSERT INTO public.who_global_data VALUES (17224, 2954, 379883, 48, 7744, 73, 204);
INSERT INTO public.who_global_data VALUES (17225, 0, 0, 0, 0, 73, 198);
INSERT INTO public.who_global_data VALUES (17226, 875, 155658, 16, 2973, 73, 173);
INSERT INTO public.who_global_data VALUES (17227, 18, 630, 0, 7, 73, 229);
INSERT INTO public.who_global_data VALUES (17228, 596, 77072, 8, 1665, 73, 76);
INSERT INTO public.who_global_data VALUES (17229, 887, 950557, 46, 35641, 73, 138);
INSERT INTO public.who_global_data VALUES (17230, 1108, 421722, 12, 8185, 73, 98);
INSERT INTO public.who_global_data VALUES (17231, 0, 0, 0, 0, 73, 103);
INSERT INTO public.who_global_data VALUES (17232, 32733, 909066, 540, 14314, 73, 225);
INSERT INTO public.who_global_data VALUES (17233, 3919, 268721, 85, 4056, 73, 131);
INSERT INTO public.who_global_data VALUES (17234, 348, 48548, 6, 1038, 73, 235);
INSERT INTO public.who_global_data VALUES (17235, 227, 137642, 0, 236, 73, 137);
INSERT INTO public.who_global_data VALUES (17236, 382, 31672, 3, 513, 73, 81);
INSERT INTO public.who_global_data VALUES (17237, 1215, 99633, 19, 2188, 73, 182);
INSERT INTO public.who_global_data VALUES (17238, 0, 7689, 0, 35, 73, 145);
INSERT INTO public.who_global_data VALUES (17239, 7753, 430605, 196, 10373, 73, 26);
INSERT INTO public.who_global_data VALUES (17240, 23675, 2162503, 507, 37538, 73, 170);
INSERT INTO public.who_global_data VALUES (17241, 24, 5750, 0, 47, 73, 191);
INSERT INTO public.who_global_data VALUES (17242, 0, 5, 0, 0, 73, 221);
INSERT INTO public.who_global_data VALUES (17243, 0, 127, 0, 0, 73, 64);
INSERT INTO public.who_global_data VALUES (17244, 0, 0, 0, 0, 73, 116);
INSERT INTO public.who_global_data VALUES (17245, 2, 22, 0, 0, 73, 128);
INSERT INTO public.who_global_data VALUES (17246, 3, 226, 0, 2, 73, 6);
INSERT INTO public.who_global_data VALUES (17247, 0, 690, 0, 12, 73, 227);
INSERT INTO public.who_global_data VALUES (17248, 0, 14, 0, 0, 73, 68);
INSERT INTO public.who_global_data VALUES (17249, 0, 84, 0, 0, 73, 184);
INSERT INTO public.who_global_data VALUES (17250, 0, 0, 0, 0, 73, 82);
INSERT INTO public.who_global_data VALUES (17251, 26, 1454, 0, 44, 73, 149);
INSERT INTO public.who_global_data VALUES (17252, 0, 981, 0, 17, 73, 197);
INSERT INTO public.who_global_data VALUES (17253, 252, 355741, 15, 5811, 73, 78);
INSERT INTO public.who_global_data VALUES (17254, 11, 15908, 1, 331, 73, 233);
INSERT INTO public.who_global_data VALUES (17255, 6842, 133029, 37, 1274, 73, 133);
INSERT INTO public.who_global_data VALUES (17256, 6, 167, 0, 0, 73, 35);
INSERT INTO public.who_global_data VALUES (17257, 0, 2406, 0, 74, 73, 114);
INSERT INTO public.who_global_data VALUES (17258, 18, 58183, 0, 28, 73, 237);
INSERT INTO public.who_global_data VALUES (17259, 0, 14, 0, 0, 73, 55);
INSERT INTO public.who_global_data VALUES (17260, 10, 1017, 0, 25, 73, 176);
INSERT INTO public.who_global_data VALUES (17261, 1021, 97493, 16, 709, 73, 202);
INSERT INTO public.who_global_data VALUES (17262, 2235, 69341, 44, 1303, 73, 155);
INSERT INTO public.who_global_data VALUES (17263, 0, 17, 0, 0, 73, 32);
INSERT INTO public.who_global_data VALUES (17264, 0, 4445, 0, 113, 73, 220);
INSERT INTO public.who_global_data VALUES (17265, 2493, 772252, 115, 21083, 73, 30);
INSERT INTO public.who_global_data VALUES (17266, 0, 3047, 0, 60, 73, 147);
INSERT INTO public.who_global_data VALUES (17267, 9268, 1660332, 257, 45609, 73, 208);
INSERT INTO public.who_global_data VALUES (17268, 459, 20967, 4, 94, 73, 45);
INSERT INTO public.who_global_data VALUES (17269, 215, 16864, 5, 1215, 73, 110);
INSERT INTO public.who_global_data VALUES (17270, 1, 5297, 0, 116, 73, 88);
INSERT INTO public.who_global_data VALUES (17271, 3876, 225874, 55, 6835, 73, 51);
INSERT INTO public.who_global_data VALUES (17272, 4432, 310624, 89, 4262, 73, 209);
INSERT INTO public.who_global_data VALUES (17273, 74, 7369, 5, 385, 73, 205);
INSERT INTO public.who_global_data VALUES (17274, 39, 11971, 0, 86, 73, 18);
INSERT INTO public.who_global_data VALUES (17275, 4, 3926, 0, 60, 73, 72);
INSERT INTO public.who_global_data VALUES (17276, 11299, 1538798, 608, 55838, 73, 44);
INSERT INTO public.who_global_data VALUES (17277, 0, 30, 0, 0, 73, 15);
INSERT INTO public.who_global_data VALUES (17278, 28, 2857, 0, 64, 73, 25);
INSERT INTO public.who_global_data VALUES (17279, 0, 0, 0, 0, 73, 179);
INSERT INTO public.who_global_data VALUES (17280, 0, 0, 0, 0, 73, 34);
INSERT INTO public.who_global_data VALUES (17281, 25, 6475, 0, 115, 73, 207);
INSERT INTO public.who_global_data VALUES (17282, 1017, 90213, 73, 2935, 73, 166);
INSERT INTO public.who_global_data VALUES (17283, 14112, 1268523, 161, 12672, 73, 126);
INSERT INTO public.who_global_data VALUES (17284, 0, 0, 0, 0, 73, 97);
INSERT INTO public.who_global_data VALUES (17285, 0, 746, 0, 6, 73, 36);
INSERT INTO public.who_global_data VALUES (17286, 0, 0, 0, 0, 73, 125);
INSERT INTO public.who_global_data VALUES (17287, 241, 18406, 5, 186, 73, 124);
INSERT INTO public.who_global_data VALUES (17288, 13882, 661858, 229, 11492, 73, 185);
INSERT INTO public.who_global_data VALUES (17289, 1310, 161365, 5, 559, 73, 194);
INSERT INTO public.who_global_data VALUES (17290, 0, 509, 0, 21, 73, 144);
INSERT INTO public.who_global_data VALUES (17291, 157180, 12276834, 1052, 255850, 73, 19);
INSERT INTO public.who_global_data VALUES (17292, 3, 1507, 0, 23, 73, 217);
INSERT INTO public.who_global_data VALUES (17293, 64, 4763, 0, 71, 73, 148);
INSERT INTO public.who_global_data VALUES (17294, 192, 72039, 1, 605, 73, 86);
INSERT INTO public.who_global_data VALUES (17295, 0, 1, 0, 0, 73, 13);
INSERT INTO public.who_global_data VALUES (17296, 308, 100143, 2, 873, 73, 157);
INSERT INTO public.who_global_data VALUES (17297, 4, 1316, 0, 35, 73, 8);
INSERT INTO public.who_global_data VALUES (17298, 1, 3, 0, 0, 73, 73);
INSERT INTO public.who_global_data VALUES (17299, 1, 2077, 0, 605, 73, 101);
INSERT INTO public.who_global_data VALUES (17300, 12, 17466, 0, 357, 73, 165);
INSERT INTO public.who_global_data VALUES (17301, 90, 9398, 1, 274, 73, 14);
INSERT INTO public.who_global_data VALUES (17302, 282, 44988, 8, 1695, 74, 193);
INSERT INTO public.who_global_data VALUES (17303, 795, 33556, 17, 716, 74, 113);
INSERT INTO public.who_global_data VALUES (17304, 1005, 75867, 19, 2294, 74, 143);
INSERT INTO public.who_global_data VALUES (17305, 0, 0, 0, 0, 74, 219);
INSERT INTO public.who_global_data VALUES (17306, 48, 6304, 0, 76, 74, 186);
INSERT INTO public.who_global_data VALUES (17307, 141, 14634, 0, 337, 74, 52);
INSERT INTO public.who_global_data VALUES (17308, 0, 4, 0, 0, 74, 180);
INSERT INTO public.who_global_data VALUES (17309, 0, 139, 0, 4, 74, 167);
INSERT INTO public.who_global_data VALUES (17310, 4184, 1370366, 0, 37002, 74, 154);
INSERT INTO public.who_global_data VALUES (17311, 813, 126835, 26, 1997, 74, 94);
INSERT INTO public.who_global_data VALUES (17312, 38, 4731, 0, 45, 74, 66);
INSERT INTO public.who_global_data VALUES (17313, 14, 27835, 0, 907, 74, 58);
INSERT INTO public.who_global_data VALUES (17314, 3090, 249214, 94, 2293, 74, 163);
INSERT INTO public.who_global_data VALUES (17315, 2187, 95281, 29, 1160, 74, 37);
INSERT INTO public.who_global_data VALUES (17316, 18, 7431, 0, 163, 74, 142);
INSERT INTO public.who_global_data VALUES (17317, 181, 85886, 1, 339, 74, 83);
INSERT INTO public.who_global_data VALUES (17318, 2419, 449760, 28, 6416, 74, 228);
INSERT INTO public.who_global_data VALUES (17319, 0, 259, 0, 7, 74, 188);
INSERT INTO public.who_global_data VALUES (17320, 1483, 125482, 8, 1104, 74, 62);
INSERT INTO public.who_global_data VALUES (17321, 3958, 565694, 139, 16004, 74, 160);
INSERT INTO public.who_global_data VALUES (17322, 73, 5183, 4, 116, 74, 50);
INSERT INTO public.who_global_data VALUES (17323, 0, 2916, 0, 43, 74, 33);
INSERT INTO public.who_global_data VALUES (17324, 0, 227, 0, 9, 74, 183);
INSERT INTO public.who_global_data VALUES (17325, 4, 386, 0, 0, 74, 92);
INSERT INTO public.who_global_data VALUES (17326, 56, 143978, 3, 8907, 74, 158);
INSERT INTO public.who_global_data VALUES (17327, 3, 142, 0, 3, 74, 67);
INSERT INTO public.who_global_data VALUES (17328, 546, 80553, 66, 2342, 74, 57);
INSERT INTO public.who_global_data VALUES (17329, 0, 9594, 0, 31, 74, 38);
INSERT INTO public.who_global_data VALUES (17330, 18615, 6071401, 194, 169183, 74, 141);
INSERT INTO public.who_global_data VALUES (17331, 0, 72, 0, 1, 74, 178);
INSERT INTO public.who_global_data VALUES (17332, 1, 149, 0, 3, 74, 108);
INSERT INTO public.who_global_data VALUES (17333, 3146, 124966, 189, 3069, 74, 39);
INSERT INTO public.who_global_data VALUES (17334, 19, 2754, 0, 68, 74, 2);
INSERT INTO public.who_global_data VALUES (17335, 9, 673, 0, 1, 74, 195);
INSERT INTO public.who_global_data VALUES (17336, 26, 10302, 0, 104, 74, 107);
INSERT INTO public.who_global_data VALUES (17337, 0, 306, 0, 0, 74, 161);
INSERT INTO public.who_global_data VALUES (17338, 27, 23869, 1, 436, 74, 212);
INSERT INTO public.who_global_data VALUES (17339, 4792, 330503, 49, 11455, 74, 181);
INSERT INTO public.who_global_data VALUES (17340, 0, 261, 0, 2, 74, 53);
INSERT INTO public.who_global_data VALUES (17341, 0, 4911, 0, 63, 74, 164);
INSERT INTO public.who_global_data VALUES (17342, 6, 1648, 0, 101, 74, 140);
INSERT INTO public.who_global_data VALUES (17343, 1440, 542080, 37, 15106, 74, 20);
INSERT INTO public.who_global_data VALUES (17344, 96, 92829, 0, 4749, 74, 112);
INSERT INTO public.who_global_data VALUES (17345, 7924, 1248417, 183, 35287, 74, 111);
INSERT INTO public.who_global_data VALUES (17346, 4, 596, 0, 7, 74, 71);
INSERT INTO public.who_global_data VALUES (17347, 0, 5632, 0, 93, 74, 218);
INSERT INTO public.who_global_data VALUES (17348, 0, 0, 0, 0, 74, 43);
INSERT INTO public.who_global_data VALUES (17349, 0, 129418, 0, 1608, 74, 49);
INSERT INTO public.who_global_data VALUES (17350, 10, 21148, 0, 131, 74, 1);
INSERT INTO public.who_global_data VALUES (17351, 1973, 105691, 45, 1398, 74, 48);
INSERT INTO public.who_global_data VALUES (17352, 33, 7879, 0, 132, 74, 232);
INSERT INTO public.who_global_data VALUES (17353, 188, 1749, 0, 3, 74, 175);
INSERT INTO public.who_global_data VALUES (17354, 304, 8947, 0, 44, 74, 21);
INSERT INTO public.who_global_data VALUES (17355, 4375, 496638, 164, 7360, 74, 156);
INSERT INTO public.who_global_data VALUES (17356, 0, 0, 0, 0, 74, 95);
INSERT INTO public.who_global_data VALUES (17357, 39, 12277, 1, 329, 74, 177);
INSERT INTO public.who_global_data VALUES (17358, 1169, 71654, 5, 789, 74, 210);
INSERT INTO public.who_global_data VALUES (17359, 0, 5668, 0, 61, 74, 120);
INSERT INTO public.who_global_data VALUES (17360, 0, 77, 0, 0, 74, 135);
INSERT INTO public.who_global_data VALUES (17361, 419, 138829, 1, 2311, 74, 206);
INSERT INTO public.who_global_data VALUES (17362, 301, 185944, 24, 13225, 74, 189);
INSERT INTO public.who_global_data VALUES (17363, 354, 113381, 12, 6560, 74, 129);
INSERT INTO public.who_global_data VALUES (17364, 0, 37562, 6, 1081, 74, 121);
INSERT INTO public.who_global_data VALUES (17365, 7, 5137, 0, 85, 74, 59);
INSERT INTO public.who_global_data VALUES (17366, 7, 558, 0, 0, 74, 96);
INSERT INTO public.who_global_data VALUES (17367, 232, 9956, 4, 92, 74, 41);
INSERT INTO public.who_global_data VALUES (17368, 14, 6233, 0, 120, 74, 216);
INSERT INTO public.who_global_data VALUES (17369, 418, 106203, 4, 1651, 74, 236);
INSERT INTO public.who_global_data VALUES (17370, 0, 16, 0, 0, 74, 150);
INSERT INTO public.who_global_data VALUES (17371, 0, 500, 0, 0, 74, 61);
INSERT INTO public.who_global_data VALUES (17372, 0, 35, 0, 2, 74, 7);
INSERT INTO public.who_global_data VALUES (17373, 297, 21936, 9, 384, 74, 169);
INSERT INTO public.who_global_data VALUES (17374, 4150, 2106660, 499, 48883, 74, 28);
INSERT INTO public.who_global_data VALUES (17375, 28, 11042, 0, 70, 74, 85);
INSERT INTO public.who_global_data VALUES (17376, 308, 13286, 5, 68, 74, 211);
INSERT INTO public.who_global_data VALUES (17377, 19, 9150, 0, 59, 74, 60);
INSERT INTO public.who_global_data VALUES (17378, 0, 3726, 0, 123, 74, 3);
INSERT INTO public.who_global_data VALUES (17379, 3128, 111818, 39, 1051, 74, 11);
INSERT INTO public.who_global_data VALUES (17380, 13554, 942687, 249, 14361, 74, 89);
INSERT INTO public.who_global_data VALUES (17381, 67, 50941, 0, 323, 74, 24);
INSERT INTO public.who_global_data VALUES (17382, 5, 958, 1, 4, 74, 162);
INSERT INTO public.who_global_data VALUES (17383, 1387, 93006, 84, 1714, 74, 100);
INSERT INTO public.who_global_data VALUES (17384, 0, 18, 0, 0, 74, 47);
INSERT INTO public.who_global_data VALUES (17385, 0, 41, 0, 0, 74, 29);
INSERT INTO public.who_global_data VALUES (17386, 0, 8225, 0, 144, 74, 40);
INSERT INTO public.who_global_data VALUES (17387, 53, 6481, 0, 106, 74, 222);
INSERT INTO public.who_global_data VALUES (17388, 93, 118722, 16, 4092, 74, 132);
INSERT INTO public.who_global_data VALUES (17389, 0, 283, 0, 13, 74, 130);
INSERT INTO public.who_global_data VALUES (17390, 37, 12863, 0, 75, 74, 234);
INSERT INTO public.who_global_data VALUES (17391, 1, 2422, 0, 43, 74, 23);
INSERT INTO public.who_global_data VALUES (17392, 40, 5133, 0, 143, 74, 192);
INSERT INTO public.who_global_data VALUES (17393, 10, 9224, 0, 232, 74, 69);
INSERT INTO public.who_global_data VALUES (17394, 0, 26, 0, 0, 74, 187);
INSERT INTO public.who_global_data VALUES (17395, 480, 104915, 2, 2859, 74, 230);
INSERT INTO public.who_global_data VALUES (17396, 3929, 181881, 117, 4008, 74, 77);
INSERT INTO public.who_global_data VALUES (17397, 12, 5289, 0, 26, 74, 9);
INSERT INTO public.who_global_data VALUES (17398, 37975, 9177840, 480, 134218, 74, 74);
INSERT INTO public.who_global_data VALUES (17399, 4442, 502110, 118, 16002, 74, 224);
INSERT INTO public.who_global_data VALUES (17400, 12460, 866821, 453, 45255, 74, 199);
INSERT INTO public.who_global_data VALUES (17401, 2136, 537457, 38, 11996, 74, 190);
INSERT INTO public.who_global_data VALUES (17402, 250, 70711, 0, 2022, 74, 12);
INSERT INTO public.who_global_data VALUES (17403, 1, 369, 0, 25, 74, 104);
INSERT INTO public.who_global_data VALUES (17404, 762, 329323, 17, 2818, 74, 153);
INSERT INTO public.who_global_data VALUES (17405, 22927, 1431795, 630, 50453, 74, 91);
INSERT INTO public.who_global_data VALUES (17406, 59, 10343, 1, 239, 74, 215);
INSERT INTO public.who_global_data VALUES (17407, 1571, 133929, 8, 1989, 74, 84);
INSERT INTO public.who_global_data VALUES (17408, 0, 806, 0, 32, 74, 231);
INSERT INTO public.who_global_data VALUES (17409, 4981, 188410, 66, 2302, 74, 196);
INSERT INTO public.who_global_data VALUES (17410, 924, 169007, 0, 2417, 74, 105);
INSERT INTO public.who_global_data VALUES (17411, 413, 77785, 12, 1392, 74, 122);
INSERT INTO public.who_global_data VALUES (17412, 0, 0, 0, 0, 74, 159);
INSERT INTO public.who_global_data VALUES (17413, 645, 34897, 12, 916, 74, 75);
INSERT INTO public.who_global_data VALUES (17414, 337, 140393, 2, 868, 74, 27);
INSERT INTO public.who_global_data VALUES (17415, 481, 70366, 4, 1241, 74, 54);
INSERT INTO public.who_global_data VALUES (17416, 14, 39, 0, 0, 74, 226);
INSERT INTO public.who_global_data VALUES (17417, 116, 13236, 9, 162, 74, 79);
INSERT INTO public.who_global_data VALUES (17418, 1041, 117476, 11, 911, 74, 56);
INSERT INTO public.who_global_data VALUES (17419, 0, 2085, 0, 44, 74, 117);
INSERT INTO public.who_global_data VALUES (17420, 0, 1554, 0, 82, 74, 152);
INSERT INTO public.who_global_data VALUES (17421, 650, 78473, 13, 1102, 74, 16);
INSERT INTO public.who_global_data VALUES (17422, 28, 1210, 1, 13, 74, 10);
INSERT INTO public.who_global_data VALUES (17423, 1171, 49372, 18, 479, 74, 201);
INSERT INTO public.who_global_data VALUES (17424, 602, 30935, 4, 266, 74, 174);
INSERT INTO public.who_global_data VALUES (17425, 0, 17341, 0, 251, 74, 119);
INSERT INTO public.who_global_data VALUES (17426, 6, 6009, 0, 185, 74, 168);
INSERT INTO public.who_global_data VALUES (17427, 1884, 56659, 2, 337, 74, 99);
INSERT INTO public.who_global_data VALUES (17428, 150, 12758, 0, 46, 74, 171);
INSERT INTO public.who_global_data VALUES (17429, 71, 4326, 1, 146, 74, 87);
INSERT INTO public.who_global_data VALUES (17430, 133, 9126, 4, 114, 74, 123);
INSERT INTO public.who_global_data VALUES (17431, 0, 4, 0, 0, 74, 151);
INSERT INTO public.who_global_data VALUES (17432, 0, 5091, 0, 39, 74, 213);
INSERT INTO public.who_global_data VALUES (17433, 0, 8075, 0, 169, 74, 118);
INSERT INTO public.who_global_data VALUES (17434, 0, 491, 0, 10, 74, 134);
INSERT INTO public.who_global_data VALUES (17435, 86, 5122, 1, 49, 74, 65);
INSERT INTO public.who_global_data VALUES (17436, 9187, 1041875, 303, 101676, 74, 102);
INSERT INTO public.who_global_data VALUES (17437, 0, 0, 0, 0, 74, 223);
INSERT INTO public.who_global_data VALUES (17438, 1, 586, 0, 3, 74, 4);
INSERT INTO public.who_global_data VALUES (17439, 11, 640, 0, 0, 74, 146);
INSERT INTO public.who_global_data VALUES (17440, 538, 32662, 6, 449, 74, 31);
INSERT INTO public.who_global_data VALUES (17441, 0, 13, 0, 1, 74, 127);
INSERT INTO public.who_global_data VALUES (17442, 2587, 327528, 80, 5396, 74, 22);
INSERT INTO public.who_global_data VALUES (17443, 72, 15109, 2, 126, 74, 115);
INSERT INTO public.who_global_data VALUES (17444, 1259, 80505, 26, 1765, 74, 106);
INSERT INTO public.who_global_data VALUES (17445, 32, 13897, 1, 145, 74, 90);
INSERT INTO public.who_global_data VALUES (17446, 0, 0, 0, 0, 74, 70);
INSERT INTO public.who_global_data VALUES (17447, 1980, 222288, 16, 1337, 74, 46);
INSERT INTO public.who_global_data VALUES (17448, 5184, 488597, 54, 8924, 74, 139);
INSERT INTO public.who_global_data VALUES (17449, 0, 32, 0, 0, 74, 42);
INSERT INTO public.who_global_data VALUES (17450, 2, 1675, 0, 25, 74, 80);
INSERT INTO public.who_global_data VALUES (17451, 0, 4583, 0, 159, 74, 203);
INSERT INTO public.who_global_data VALUES (17452, 13, 1381, 0, 70, 74, 136);
INSERT INTO public.who_global_data VALUES (17453, 56, 66439, 1, 1168, 74, 63);
INSERT INTO public.who_global_data VALUES (17454, 0, 0, 0, 0, 74, 17);
INSERT INTO public.who_global_data VALUES (17455, 0, 104, 0, 2, 74, 172);
INSERT INTO public.who_global_data VALUES (17456, 384, 55127, 35, 1546, 74, 109);
INSERT INTO public.who_global_data VALUES (17457, 1329, 32767, 5, 311, 74, 200);
INSERT INTO public.who_global_data VALUES (17458, 1552, 85892, 9, 723, 74, 93);
INSERT INTO public.who_global_data VALUES (17459, 275, 122356, 6, 1386, 74, 5);
INSERT INTO public.who_global_data VALUES (17460, 0, 741, 0, 13, 74, 214);
INSERT INTO public.who_global_data VALUES (17461, 2756, 376929, 34, 7696, 74, 204);
INSERT INTO public.who_global_data VALUES (17462, 0, 0, 0, 0, 74, 198);
INSERT INTO public.who_global_data VALUES (17463, 1206, 154783, 11, 2957, 74, 173);
INSERT INTO public.who_global_data VALUES (17464, 8, 612, 0, 7, 74, 229);
INSERT INTO public.who_global_data VALUES (17465, 619, 76476, 5, 1657, 74, 76);
INSERT INTO public.who_global_data VALUES (17466, 1589, 949670, 46, 35595, 74, 138);
INSERT INTO public.who_global_data VALUES (17467, 1796, 420614, 50, 8173, 74, 98);
INSERT INTO public.who_global_data VALUES (17468, 0, 0, 0, 0, 74, 103);
INSERT INTO public.who_global_data VALUES (17469, 15002, 876333, 156, 13774, 74, 225);
INSERT INTO public.who_global_data VALUES (17470, 4044, 264802, 74, 3971, 74, 131);
INSERT INTO public.who_global_data VALUES (17471, 741, 48200, 15, 1032, 74, 235);
INSERT INTO public.who_global_data VALUES (17472, 186, 137415, 0, 236, 74, 137);
INSERT INTO public.who_global_data VALUES (17473, 349, 31290, 1, 510, 74, 81);
INSERT INTO public.who_global_data VALUES (17474, 477, 98418, 20, 2169, 74, 182);
INSERT INTO public.who_global_data VALUES (17475, 188, 7689, 0, 35, 74, 145);
INSERT INTO public.who_global_data VALUES (17476, 4207, 422852, 130, 10177, 74, 26);
INSERT INTO public.who_global_data VALUES (17477, 24326, 2138828, 491, 37031, 74, 170);
INSERT INTO public.who_global_data VALUES (17478, 61, 5726, 0, 47, 74, 191);
INSERT INTO public.who_global_data VALUES (17479, 0, 5, 0, 0, 74, 221);
INSERT INTO public.who_global_data VALUES (17480, 0, 127, 0, 0, 74, 64);
INSERT INTO public.who_global_data VALUES (17481, 0, 0, 0, 0, 74, 116);
INSERT INTO public.who_global_data VALUES (17482, 0, 20, 0, 0, 74, 128);
INSERT INTO public.who_global_data VALUES (17483, 19, 223, 0, 2, 74, 6);
INSERT INTO public.who_global_data VALUES (17484, 0, 690, 0, 12, 74, 227);
INSERT INTO public.who_global_data VALUES (17485, 0, 14, 0, 0, 74, 68);
INSERT INTO public.who_global_data VALUES (17486, 0, 84, 0, 0, 74, 184);
INSERT INTO public.who_global_data VALUES (17487, 0, 0, 0, 0, 74, 82);
INSERT INTO public.who_global_data VALUES (17488, 0, 1428, 0, 44, 74, 149);
INSERT INTO public.who_global_data VALUES (17489, 2, 981, 0, 17, 74, 197);
INSERT INTO public.who_global_data VALUES (17490, 231, 355489, 16, 5796, 74, 78);
INSERT INTO public.who_global_data VALUES (17491, 15, 15897, 0, 330, 74, 233);
INSERT INTO public.who_global_data VALUES (17492, 5067, 126187, 38, 1237, 74, 133);
INSERT INTO public.who_global_data VALUES (17493, 0, 161, 0, 0, 74, 35);
INSERT INTO public.who_global_data VALUES (17494, 1, 2406, 0, 74, 74, 114);
INSERT INTO public.who_global_data VALUES (17495, 5, 58165, 0, 28, 74, 237);
INSERT INTO public.who_global_data VALUES (17496, 0, 14, 0, 0, 74, 55);
INSERT INTO public.who_global_data VALUES (17497, 34, 1007, 1, 25, 74, 176);
INSERT INTO public.who_global_data VALUES (17498, 231, 96472, 22, 693, 74, 202);
INSERT INTO public.who_global_data VALUES (17499, 1308, 67106, 56, 1259, 74, 155);
INSERT INTO public.who_global_data VALUES (17500, 1, 17, 0, 0, 74, 32);
INSERT INTO public.who_global_data VALUES (17501, 0, 4445, 0, 113, 74, 220);
INSERT INTO public.who_global_data VALUES (17502, 2080, 769759, 65, 20968, 74, 30);
INSERT INTO public.who_global_data VALUES (17503, 0, 3047, 0, 60, 74, 147);
INSERT INTO public.who_global_data VALUES (17504, 4658, 1651064, 234, 45352, 74, 208);
INSERT INTO public.who_global_data VALUES (17505, 337, 20508, 3, 90, 74, 45);
INSERT INTO public.who_global_data VALUES (17506, 218, 16649, 8, 1210, 74, 110);
INSERT INTO public.who_global_data VALUES (17507, 1, 5296, 0, 116, 74, 88);
INSERT INTO public.who_global_data VALUES (17508, 2422, 221998, 59, 6780, 74, 51);
INSERT INTO public.who_global_data VALUES (17509, 5434, 306192, 95, 4173, 74, 209);
INSERT INTO public.who_global_data VALUES (17510, 70, 7295, 4, 380, 74, 205);
INSERT INTO public.who_global_data VALUES (17511, 38, 11932, 0, 86, 74, 18);
INSERT INTO public.who_global_data VALUES (17512, 2, 3922, 0, 60, 74, 72);
INSERT INTO public.who_global_data VALUES (17513, 15450, 1527499, 479, 55230, 74, 44);
INSERT INTO public.who_global_data VALUES (17514, 0, 30, 0, 0, 74, 15);
INSERT INTO public.who_global_data VALUES (17515, 0, 2829, 0, 64, 74, 25);
INSERT INTO public.who_global_data VALUES (17516, 0, 0, 0, 0, 74, 179);
INSERT INTO public.who_global_data VALUES (17517, 0, 0, 0, 0, 74, 34);
INSERT INTO public.who_global_data VALUES (17518, 126, 6450, 0, 115, 74, 207);
INSERT INTO public.who_global_data VALUES (17519, 485, 89196, 41, 2862, 74, 166);
INSERT INTO public.who_global_data VALUES (17520, 13444, 1254411, 153, 12511, 74, 126);
INSERT INTO public.who_global_data VALUES (17521, 0, 0, 0, 0, 74, 97);
INSERT INTO public.who_global_data VALUES (17522, 0, 746, 0, 6, 74, 36);
INSERT INTO public.who_global_data VALUES (17523, 0, 0, 0, 0, 74, 125);
INSERT INTO public.who_global_data VALUES (17524, 197, 18165, 9, 181, 74, 124);
INSERT INTO public.who_global_data VALUES (17525, 12287, 647976, 188, 11263, 74, 185);
INSERT INTO public.who_global_data VALUES (17526, 1065, 160055, 2, 554, 74, 194);
INSERT INTO public.who_global_data VALUES (17527, 0, 509, 0, 21, 74, 144);
INSERT INTO public.who_global_data VALUES (17528, 147098, 12119654, 867, 254798, 74, 19);
INSERT INTO public.who_global_data VALUES (17529, 0, 1504, 0, 23, 74, 217);
INSERT INTO public.who_global_data VALUES (17530, 135, 4699, 2, 71, 74, 148);
INSERT INTO public.who_global_data VALUES (17531, 134, 71847, 1, 604, 74, 86);
INSERT INTO public.who_global_data VALUES (17532, 0, 1, 0, 0, 74, 13);
INSERT INTO public.who_global_data VALUES (17533, 400, 99835, 2, 871, 74, 157);
INSERT INTO public.who_global_data VALUES (17534, 5, 1312, 0, 35, 74, 8);
INSERT INTO public.who_global_data VALUES (17535, 0, 2, 0, 0, 74, 73);
INSERT INTO public.who_global_data VALUES (17536, 3, 2076, 0, 605, 74, 101);
INSERT INTO public.who_global_data VALUES (17537, 30, 17454, 0, 357, 74, 165);
INSERT INTO public.who_global_data VALUES (17538, 88, 9308, 5, 273, 74, 14);
INSERT INTO public.who_global_data VALUES (17539, 203, 44706, 12, 1687, 75, 193);
INSERT INTO public.who_global_data VALUES (17540, 565, 32761, 14, 699, 75, 113);
INSERT INTO public.who_global_data VALUES (17541, 1088, 74862, 17, 2275, 75, 143);
INSERT INTO public.who_global_data VALUES (17542, 0, 0, 0, 0, 75, 219);
INSERT INTO public.who_global_data VALUES (17543, 49, 6256, 0, 76, 75, 186);
INSERT INTO public.who_global_data VALUES (17544, 80, 14493, 1, 337, 75, 52);
INSERT INTO public.who_global_data VALUES (17545, 1, 4, 0, 0, 75, 180);
INSERT INTO public.who_global_data VALUES (17546, 0, 139, 0, 4, 75, 167);
INSERT INTO public.who_global_data VALUES (17547, 7140, 1366182, 212, 37002, 75, 154);
INSERT INTO public.who_global_data VALUES (17548, 485, 126022, 24, 1971, 75, 94);
INSERT INTO public.who_global_data VALUES (17549, 0, 4693, 0, 45, 75, 66);
INSERT INTO public.who_global_data VALUES (17550, 14, 27821, 0, 907, 75, 58);
INSERT INTO public.who_global_data VALUES (17551, 5215, 246124, 44, 2199, 75, 163);
INSERT INTO public.who_global_data VALUES (17552, 3196, 93094, 24, 1131, 75, 37);
INSERT INTO public.who_global_data VALUES (17553, 46, 7413, 0, 163, 75, 142);
INSERT INTO public.who_global_data VALUES (17554, 114, 85705, 0, 338, 75, 83);
INSERT INTO public.who_global_data VALUES (17555, 2060, 447341, 38, 6388, 75, 228);
INSERT INTO public.who_global_data VALUES (17556, 4, 259, 0, 7, 75, 188);
INSERT INTO public.who_global_data VALUES (17557, 1564, 123999, 7, 1096, 75, 62);
INSERT INTO public.who_global_data VALUES (17558, 589, 561736, 135, 15865, 75, 160);
INSERT INTO public.who_global_data VALUES (17559, 54, 5110, 5, 112, 75, 50);
INSERT INTO public.who_global_data VALUES (17560, 0, 2916, 0, 43, 75, 33);
INSERT INTO public.who_global_data VALUES (17561, 0, 227, 0, 9, 75, 183);
INSERT INTO public.who_global_data VALUES (17562, 3, 382, 0, 0, 75, 92);
INSERT INTO public.who_global_data VALUES (17563, 68, 143922, 4, 8904, 75, 158);
INSERT INTO public.who_global_data VALUES (17564, 0, 139, 0, 3, 75, 67);
INSERT INTO public.who_global_data VALUES (17565, 698, 80007, 30, 2276, 75, 57);
INSERT INTO public.who_global_data VALUES (17566, 0, 9594, 0, 31, 75, 38);
INSERT INTO public.who_global_data VALUES (17567, 32622, 6052786, 376, 168989, 75, 141);
INSERT INTO public.who_global_data VALUES (17568, 0, 72, 0, 1, 75, 178);
INSERT INTO public.who_global_data VALUES (17569, 0, 148, 0, 3, 75, 108);
INSERT INTO public.who_global_data VALUES (17570, 1123, 121820, 60, 2880, 75, 39);
INSERT INTO public.who_global_data VALUES (17571, 32, 2735, 0, 68, 75, 2);
INSERT INTO public.who_global_data VALUES (17572, 2, 664, 0, 1, 75, 195);
INSERT INTO public.who_global_data VALUES (17573, 42, 10276, 0, 104, 75, 107);
INSERT INTO public.who_global_data VALUES (17574, 0, 306, 0, 0, 75, 161);
INSERT INTO public.who_global_data VALUES (17575, 314, 23842, 0, 435, 75, 212);
INSERT INTO public.who_global_data VALUES (17576, 4992, 325711, 72, 11406, 75, 181);
INSERT INTO public.who_global_data VALUES (17577, 0, 261, 0, 2, 75, 53);
INSERT INTO public.who_global_data VALUES (17578, 0, 4911, 0, 63, 75, 164);
INSERT INTO public.who_global_data VALUES (17579, 9, 1642, 0, 101, 75, 140);
INSERT INTO public.who_global_data VALUES (17580, 1497, 540640, 39, 15069, 75, 20);
INSERT INTO public.who_global_data VALUES (17581, 85, 92733, 0, 4749, 75, 112);
INSERT INTO public.who_global_data VALUES (17582, 7049, 1240493, 175, 35104, 75, 111);
INSERT INTO public.who_global_data VALUES (17583, 0, 592, 0, 7, 75, 71);
INSERT INTO public.who_global_data VALUES (17584, 0, 5632, 0, 93, 75, 218);
INSERT INTO public.who_global_data VALUES (17585, 0, 0, 0, 0, 75, 43);
INSERT INTO public.who_global_data VALUES (17586, 0, 129418, 0, 1608, 75, 49);
INSERT INTO public.who_global_data VALUES (17587, 12, 21138, 2, 131, 75, 1);
INSERT INTO public.who_global_data VALUES (17588, 3308, 103718, 49, 1353, 75, 48);
INSERT INTO public.who_global_data VALUES (17589, 48, 7846, 0, 132, 75, 232);
INSERT INTO public.who_global_data VALUES (17590, 0, 1561, 0, 3, 75, 175);
INSERT INTO public.who_global_data VALUES (17591, 187, 8643, 1, 44, 75, 21);
INSERT INTO public.who_global_data VALUES (17592, 1513, 492263, 101, 7196, 75, 156);
INSERT INTO public.who_global_data VALUES (17593, 0, 0, 0, 0, 75, 95);
INSERT INTO public.who_global_data VALUES (17594, 59, 12238, 1, 328, 75, 177);
INSERT INTO public.who_global_data VALUES (17595, 850, 70485, 3, 784, 75, 210);
INSERT INTO public.who_global_data VALUES (17596, 7, 5668, 0, 61, 75, 120);
INSERT INTO public.who_global_data VALUES (17597, 5, 77, 0, 0, 75, 135);
INSERT INTO public.who_global_data VALUES (17598, 640, 138410, 2, 2310, 75, 206);
INSERT INTO public.who_global_data VALUES (17599, 767, 185643, 62, 13201, 75, 189);
INSERT INTO public.who_global_data VALUES (17600, 351, 113027, 13, 6548, 75, 129);
INSERT INTO public.who_global_data VALUES (17601, 312, 37562, 5, 1075, 75, 121);
INSERT INTO public.who_global_data VALUES (17602, 0, 5130, 0, 85, 75, 59);
INSERT INTO public.who_global_data VALUES (17603, 0, 551, 0, 0, 75, 96);
INSERT INTO public.who_global_data VALUES (17604, 349, 9724, 1, 88, 75, 41);
INSERT INTO public.who_global_data VALUES (17605, 14, 6219, 1, 120, 75, 216);
INSERT INTO public.who_global_data VALUES (17606, 433, 105785, 11, 1647, 75, 236);
INSERT INTO public.who_global_data VALUES (17607, 0, 16, 0, 0, 75, 150);
INSERT INTO public.who_global_data VALUES (17608, 1, 500, 0, 0, 75, 61);
INSERT INTO public.who_global_data VALUES (17609, 0, 35, 0, 2, 75, 7);
INSERT INTO public.who_global_data VALUES (17610, 423, 21639, 0, 375, 75, 169);
INSERT INTO public.who_global_data VALUES (17611, 13157, 2102510, 214, 48384, 75, 28);
INSERT INTO public.who_global_data VALUES (17612, 0, 11014, 0, 70, 75, 85);
INSERT INTO public.who_global_data VALUES (17613, 0, 12978, 0, 63, 75, 211);
INSERT INTO public.who_global_data VALUES (17614, 0, 9131, 0, 59, 75, 60);
INSERT INTO public.who_global_data VALUES (17615, 0, 3726, 0, 123, 75, 3);
INSERT INTO public.who_global_data VALUES (17616, 3958, 108690, 36, 1012, 75, 11);
INSERT INTO public.who_global_data VALUES (17617, 10864, 929133, 90, 14112, 75, 89);
INSERT INTO public.who_global_data VALUES (17618, 0, 50874, 0, 323, 75, 24);
INSERT INTO public.who_global_data VALUES (17619, 10, 953, 0, 3, 75, 162);
INSERT INTO public.who_global_data VALUES (17620, 1498, 91619, 103, 1630, 75, 100);
INSERT INTO public.who_global_data VALUES (17621, 0, 18, 0, 0, 75, 47);
INSERT INTO public.who_global_data VALUES (17622, 0, 41, 0, 0, 75, 29);
INSERT INTO public.who_global_data VALUES (17623, 0, 8225, 0, 144, 75, 40);
INSERT INTO public.who_global_data VALUES (17624, 73, 6428, 2, 106, 75, 222);
INSERT INTO public.who_global_data VALUES (17625, 212, 118629, 2, 4076, 75, 132);
INSERT INTO public.who_global_data VALUES (17626, 0, 283, 0, 13, 75, 130);
INSERT INTO public.who_global_data VALUES (17627, 28, 12826, 0, 75, 75, 234);
INSERT INTO public.who_global_data VALUES (17628, 0, 2421, 0, 43, 75, 23);
INSERT INTO public.who_global_data VALUES (17629, 88, 5093, 0, 143, 75, 192);
INSERT INTO public.who_global_data VALUES (17630, 0, 9214, 0, 232, 75, 69);
INSERT INTO public.who_global_data VALUES (17631, 0, 26, 0, 0, 75, 187);
INSERT INTO public.who_global_data VALUES (17632, 256, 104435, 2, 2857, 75, 230);
INSERT INTO public.who_global_data VALUES (17633, 3334, 177952, 91, 3891, 75, 77);
INSERT INTO public.who_global_data VALUES (17634, 8, 5277, 0, 26, 75, 9);
INSERT INTO public.who_global_data VALUES (17635, 44059, 9139865, 511, 133738, 75, 74);
INSERT INTO public.who_global_data VALUES (17636, 4360, 497668, 110, 15884, 75, 224);
INSERT INTO public.who_global_data VALUES (17637, 13053, 854361, 475, 44802, 75, 199);
INSERT INTO public.who_global_data VALUES (17638, 1766, 535321, 33, 11958, 75, 190);
INSERT INTO public.who_global_data VALUES (17639, 318, 70461, 0, 2022, 75, 12);
INSERT INTO public.who_global_data VALUES (17640, 0, 368, 0, 25, 75, 104);
INSERT INTO public.who_global_data VALUES (17641, 422, 328561, 12, 2801, 75, 153);
INSERT INTO public.who_global_data VALUES (17642, 28337, 1408868, 562, 49823, 75, 91);
INSERT INTO public.who_global_data VALUES (17643, 44, 10284, 1, 238, 75, 215);
INSERT INTO public.who_global_data VALUES (17644, 2179, 132358, 7, 1981, 75, 84);
INSERT INTO public.who_global_data VALUES (17645, 0, 806, 0, 32, 75, 231);
INSERT INTO public.who_global_data VALUES (17646, 5268, 183429, 64, 2236, 75, 196);
INSERT INTO public.who_global_data VALUES (17647, 698, 168083, 0, 2417, 75, 105);
INSERT INTO public.who_global_data VALUES (17648, 968, 77372, 14, 1380, 75, 122);
INSERT INTO public.who_global_data VALUES (17649, 0, 0, 0, 0, 75, 159);
INSERT INTO public.who_global_data VALUES (17650, 707, 34252, 10, 904, 75, 75);
INSERT INTO public.who_global_data VALUES (17651, 322, 140056, 3, 866, 75, 27);
INSERT INTO public.who_global_data VALUES (17652, 304, 69885, 6, 1237, 75, 54);
INSERT INTO public.who_global_data VALUES (17653, 0, 25, 0, 0, 75, 226);
INSERT INTO public.who_global_data VALUES (17654, 376, 13120, 0, 153, 75, 79);
INSERT INTO public.who_global_data VALUES (17655, 1193, 116435, 6, 900, 75, 56);
INSERT INTO public.who_global_data VALUES (17656, 27, 2085, 0, 44, 75, 117);
INSERT INTO public.who_global_data VALUES (17657, 0, 1554, 0, 82, 75, 152);
INSERT INTO public.who_global_data VALUES (17658, 1015, 77823, 21, 1089, 75, 16);
INSERT INTO public.who_global_data VALUES (17659, 31, 1182, 3, 12, 75, 10);
INSERT INTO public.who_global_data VALUES (17660, 1190, 48201, 20, 461, 75, 201);
INSERT INTO public.who_global_data VALUES (17661, 571, 30333, 2, 262, 75, 174);
INSERT INTO public.who_global_data VALUES (17662, 31, 17341, 1, 251, 75, 119);
INSERT INTO public.who_global_data VALUES (17663, 0, 6003, 0, 185, 75, 168);
INSERT INTO public.who_global_data VALUES (17664, 1096, 54775, 3, 335, 75, 99);
INSERT INTO public.who_global_data VALUES (17665, 30, 12608, 1, 46, 75, 171);
INSERT INTO public.who_global_data VALUES (17666, 49, 4255, 2, 145, 75, 87);
INSERT INTO public.who_global_data VALUES (17667, 80, 8993, 3, 110, 75, 123);
INSERT INTO public.who_global_data VALUES (17668, 0, 4, 0, 0, 75, 151);
INSERT INTO public.who_global_data VALUES (17669, 0, 5091, 0, 39, 75, 213);
INSERT INTO public.who_global_data VALUES (17670, 0, 8075, 0, 169, 75, 118);
INSERT INTO public.who_global_data VALUES (17671, 0, 491, 0, 10, 75, 134);
INSERT INTO public.who_global_data VALUES (17672, 0, 5036, 0, 48, 75, 65);
INSERT INTO public.who_global_data VALUES (17673, 6719, 1032688, 550, 101373, 75, 102);
INSERT INTO public.who_global_data VALUES (17674, 0, 0, 0, 0, 75, 223);
INSERT INTO public.who_global_data VALUES (17675, 1, 585, 0, 3, 75, 4);
INSERT INTO public.who_global_data VALUES (17676, 47, 629, 0, 0, 75, 146);
INSERT INTO public.who_global_data VALUES (17677, 639, 32124, 5, 443, 75, 31);
INSERT INTO public.who_global_data VALUES (17678, 0, 13, 0, 1, 75, 127);
INSERT INTO public.who_global_data VALUES (17679, 3979, 324941, 60, 5316, 75, 22);
INSERT INTO public.who_global_data VALUES (17680, 56, 15037, 1, 124, 75, 115);
INSERT INTO public.who_global_data VALUES (17681, 1398, 79246, 17, 1739, 75, 106);
INSERT INTO public.who_global_data VALUES (17682, 54, 13865, 1, 144, 75, 90);
INSERT INTO public.who_global_data VALUES (17683, 0, 0, 0, 0, 75, 70);
INSERT INTO public.who_global_data VALUES (17684, 1669, 220308, 16, 1321, 75, 46);
INSERT INTO public.who_global_data VALUES (17685, 5362, 483413, 21, 8870, 75, 139);
INSERT INTO public.who_global_data VALUES (17686, 0, 32, 0, 0, 75, 42);
INSERT INTO public.who_global_data VALUES (17687, 1, 1673, 0, 25, 75, 80);
INSERT INTO public.who_global_data VALUES (17688, 0, 4583, 0, 159, 75, 203);
INSERT INTO public.who_global_data VALUES (17689, 17, 1368, 0, 70, 75, 136);
INSERT INTO public.who_global_data VALUES (17690, 155, 66383, 1, 1167, 75, 63);
INSERT INTO public.who_global_data VALUES (17691, 0, 0, 0, 0, 75, 17);
INSERT INTO public.who_global_data VALUES (17692, 0, 104, 0, 2, 75, 172);
INSERT INTO public.who_global_data VALUES (17693, 1112, 54743, 24, 1511, 75, 109);
INSERT INTO public.who_global_data VALUES (17694, 0, 31438, 0, 306, 75, 200);
INSERT INTO public.who_global_data VALUES (17695, 1560, 84340, 16, 714, 75, 93);
INSERT INTO public.who_global_data VALUES (17696, 721, 122081, 15, 1380, 75, 5);
INSERT INTO public.who_global_data VALUES (17697, 0, 741, 0, 13, 75, 214);
INSERT INTO public.who_global_data VALUES (17698, 2665, 374173, 59, 7662, 75, 204);
INSERT INTO public.who_global_data VALUES (17699, 0, 0, 0, 0, 75, 198);
INSERT INTO public.who_global_data VALUES (17700, 1288, 153577, 14, 2946, 75, 173);
INSERT INTO public.who_global_data VALUES (17701, 0, 604, 0, 7, 75, 229);
INSERT INTO public.who_global_data VALUES (17702, 799, 75857, 5, 1652, 75, 76);
INSERT INTO public.who_global_data VALUES (17703, 1994, 948081, 65, 35549, 75, 138);
INSERT INTO public.who_global_data VALUES (17704, 1966, 418818, 43, 8123, 75, 98);
INSERT INTO public.who_global_data VALUES (17705, 0, 0, 0, 0, 75, 103);
INSERT INTO public.who_global_data VALUES (17706, 17856, 861331, 330, 13618, 75, 225);
INSERT INTO public.who_global_data VALUES (17707, 4788, 260758, 73, 3897, 75, 131);
INSERT INTO public.who_global_data VALUES (17708, 1025, 47459, 5, 1017, 75, 235);
INSERT INTO public.who_global_data VALUES (17709, 167, 137229, 1, 236, 75, 137);
INSERT INTO public.who_global_data VALUES (17710, 271, 30941, 4, 509, 75, 81);
INSERT INTO public.who_global_data VALUES (17711, 1252, 97941, 19, 2149, 75, 182);
INSERT INTO public.who_global_data VALUES (17712, 0, 7501, 0, 35, 75, 145);
INSERT INTO public.who_global_data VALUES (17713, 5837, 418645, 131, 10047, 75, 26);
INSERT INTO public.who_global_data VALUES (17714, 25173, 2114502, 361, 36540, 75, 170);
INSERT INTO public.who_global_data VALUES (17715, 45, 5665, 1, 47, 75, 191);
INSERT INTO public.who_global_data VALUES (17716, 0, 5, 0, 0, 75, 221);
INSERT INTO public.who_global_data VALUES (17717, 0, 127, 0, 0, 75, 64);
INSERT INTO public.who_global_data VALUES (17718, 0, 0, 0, 0, 75, 116);
INSERT INTO public.who_global_data VALUES (17719, 1, 20, 0, 0, 75, 128);
INSERT INTO public.who_global_data VALUES (17720, 1, 204, 0, 2, 75, 6);
INSERT INTO public.who_global_data VALUES (17721, 0, 690, 0, 12, 75, 227);
INSERT INTO public.who_global_data VALUES (17722, 0, 14, 0, 0, 75, 68);
INSERT INTO public.who_global_data VALUES (17723, 0, 84, 0, 0, 75, 184);
INSERT INTO public.who_global_data VALUES (17724, 0, 0, 0, 0, 75, 82);
INSERT INTO public.who_global_data VALUES (17725, 1, 1428, 1, 44, 75, 149);
INSERT INTO public.who_global_data VALUES (17726, 0, 979, 0, 17, 75, 197);
INSERT INTO public.who_global_data VALUES (17727, 224, 355258, 19, 5780, 75, 78);
INSERT INTO public.who_global_data VALUES (17728, 17, 15882, 0, 330, 75, 233);
INSERT INTO public.who_global_data VALUES (17729, 4995, 121120, 31, 1199, 75, 133);
INSERT INTO public.who_global_data VALUES (17730, 0, 161, 0, 0, 75, 35);
INSERT INTO public.who_global_data VALUES (17731, 0, 2405, 0, 74, 75, 114);
INSERT INTO public.who_global_data VALUES (17732, 12, 58160, 0, 28, 75, 237);
INSERT INTO public.who_global_data VALUES (17733, 0, 14, 0, 0, 75, 55);
INSERT INTO public.who_global_data VALUES (17734, 0, 973, 0, 24, 75, 176);
INSERT INTO public.who_global_data VALUES (17735, 984, 96241, 27, 671, 75, 202);
INSERT INTO public.who_global_data VALUES (17736, 471, 65798, 53, 1203, 75, 155);
INSERT INTO public.who_global_data VALUES (17737, 0, 16, 0, 0, 75, 32);
INSERT INTO public.who_global_data VALUES (17738, 63, 4445, 5, 113, 75, 220);
INSERT INTO public.who_global_data VALUES (17739, 2270, 767679, 58, 20903, 75, 30);
INSERT INTO public.who_global_data VALUES (17740, 0, 3047, 0, 60, 75, 147);
INSERT INTO public.who_global_data VALUES (17741, 7270, 1646406, 253, 45118, 75, 208);
INSERT INTO public.who_global_data VALUES (17742, 400, 20171, 4, 87, 75, 45);
INSERT INTO public.who_global_data VALUES (17743, 244, 16431, 3, 1202, 75, 110);
INSERT INTO public.who_global_data VALUES (17744, 6, 5295, 0, 116, 75, 88);
INSERT INTO public.who_global_data VALUES (17745, 4492, 219576, 51, 6721, 75, 51);
INSERT INTO public.who_global_data VALUES (17746, 1871, 300758, 76, 4078, 75, 209);
INSERT INTO public.who_global_data VALUES (17747, 71, 7225, 4, 376, 75, 205);
INSERT INTO public.who_global_data VALUES (17748, 40, 11894, 0, 86, 75, 18);
INSERT INTO public.who_global_data VALUES (17749, 7, 3920, 0, 60, 75, 72);
INSERT INTO public.who_global_data VALUES (17750, 18662, 1512049, 125, 54751, 75, 44);
INSERT INTO public.who_global_data VALUES (17751, 0, 30, 0, 0, 75, 15);
INSERT INTO public.who_global_data VALUES (17752, 58, 2829, 1, 64, 75, 25);
INSERT INTO public.who_global_data VALUES (17753, 0, 0, 0, 0, 75, 179);
INSERT INTO public.who_global_data VALUES (17754, 0, 0, 0, 0, 75, 34);
INSERT INTO public.who_global_data VALUES (17755, 63, 6324, 2, 115, 75, 207);
INSERT INTO public.who_global_data VALUES (17756, 1240, 88711, 69, 2821, 75, 166);
INSERT INTO public.who_global_data VALUES (17757, 12748, 1240967, 139, 12358, 75, 126);
INSERT INTO public.who_global_data VALUES (17758, 0, 0, 0, 0, 75, 97);
INSERT INTO public.who_global_data VALUES (17759, 20, 746, 0, 6, 75, 36);
INSERT INTO public.who_global_data VALUES (17760, 0, 0, 0, 0, 75, 125);
INSERT INTO public.who_global_data VALUES (17761, 301, 17968, 4, 172, 75, 124);
INSERT INTO public.who_global_data VALUES (17762, 10945, 635689, 124, 11075, 75, 185);
INSERT INTO public.who_global_data VALUES (17763, 1205, 158990, 4, 552, 75, 194);
INSERT INTO public.who_global_data VALUES (17764, 0, 509, 0, 21, 75, 144);
INSERT INTO public.who_global_data VALUES (17765, 183544, 11972556, 1471, 253931, 75, 19);
INSERT INTO public.who_global_data VALUES (17766, 13, 1504, 0, 23, 75, 217);
INSERT INTO public.who_global_data VALUES (17767, 87, 4564, 0, 69, 75, 148);
INSERT INTO public.who_global_data VALUES (17768, 161, 71713, 0, 603, 75, 86);
INSERT INTO public.who_global_data VALUES (17769, 0, 1, 0, 0, 75, 13);
INSERT INTO public.who_global_data VALUES (17770, 418, 99435, 3, 869, 75, 157);
INSERT INTO public.who_global_data VALUES (17771, 1, 1307, 0, 35, 75, 8);
INSERT INTO public.who_global_data VALUES (17772, 0, 2, 0, 0, 75, 73);
INSERT INTO public.who_global_data VALUES (17773, 0, 2073, 0, 605, 75, 101);
INSERT INTO public.who_global_data VALUES (17774, 30, 17424, 1, 357, 75, 165);
INSERT INTO public.who_global_data VALUES (17775, 100, 9220, 3, 268, 75, 14);
INSERT INTO public.who_global_data VALUES (17776, 60, 44503, 14, 1675, 76, 193);
INSERT INTO public.who_global_data VALUES (17777, 737, 32196, 13, 685, 76, 113);
INSERT INTO public.who_global_data VALUES (17778, 1019, 73774, 19, 2258, 76, 143);
INSERT INTO public.who_global_data VALUES (17779, 0, 0, 0, 0, 76, 219);
INSERT INTO public.who_global_data VALUES (17780, 65, 6207, 0, 76, 76, 186);
INSERT INTO public.who_global_data VALUES (17781, 146, 14413, 2, 336, 76, 52);
INSERT INTO public.who_global_data VALUES (17782, 0, 3, 0, 0, 76, 180);
INSERT INTO public.who_global_data VALUES (17783, 0, 139, 0, 4, 76, 167);
INSERT INTO public.who_global_data VALUES (17784, 9608, 1359042, 258, 36790, 76, 154);
INSERT INTO public.who_global_data VALUES (17785, 1385, 125537, 21, 1947, 76, 94);
INSERT INTO public.who_global_data VALUES (17786, 0, 4693, 0, 45, 76, 66);
INSERT INTO public.who_global_data VALUES (17787, 18, 27807, 0, 907, 76, 58);
INSERT INTO public.who_global_data VALUES (17788, 6239, 240909, 58, 2155, 76, 163);
INSERT INTO public.who_global_data VALUES (17789, 2735, 89898, 28, 1107, 76, 37);
INSERT INTO public.who_global_data VALUES (17790, 0, 7367, 0, 163, 76, 142);
INSERT INTO public.who_global_data VALUES (17791, 124, 85591, 0, 338, 76, 83);
INSERT INTO public.who_global_data VALUES (17792, 1847, 445281, 28, 6350, 76, 228);
INSERT INTO public.who_global_data VALUES (17793, 2, 255, 0, 7, 76, 188);
INSERT INTO public.who_global_data VALUES (17794, 1588, 122435, 8, 1089, 76, 62);
INSERT INTO public.who_global_data VALUES (17795, 1263, 561147, 139, 15730, 76, 160);
INSERT INTO public.who_global_data VALUES (17796, 38, 5056, 5, 107, 76, 50);
INSERT INTO public.who_global_data VALUES (17797, 0, 2916, 0, 43, 76, 33);
INSERT INTO public.who_global_data VALUES (17798, 0, 227, 0, 9, 76, 183);
INSERT INTO public.who_global_data VALUES (17799, 1, 379, 0, 0, 76, 92);
INSERT INTO public.who_global_data VALUES (17800, 98, 143854, 11, 8900, 76, 158);
INSERT INTO public.who_global_data VALUES (17801, 0, 139, 0, 3, 76, 67);
INSERT INTO public.who_global_data VALUES (17802, 1315, 79309, 37, 2246, 76, 57);
INSERT INTO public.who_global_data VALUES (17803, 0, 9594, 0, 31, 76, 38);
INSERT INTO public.who_global_data VALUES (17804, 38397, 6020164, 552, 168613, 76, 141);
INSERT INTO public.who_global_data VALUES (17805, 0, 72, 0, 1, 76, 178);
INSERT INTO public.who_global_data VALUES (17806, 0, 148, 0, 3, 76, 108);
INSERT INTO public.who_global_data VALUES (17807, 2279, 120697, 42, 2820, 76, 39);
INSERT INTO public.who_global_data VALUES (17808, 17, 2703, 0, 68, 76, 2);
INSERT INTO public.who_global_data VALUES (17809, 6, 662, 0, 1, 76, 195);
INSERT INTO public.who_global_data VALUES (17810, 82, 10234, 0, 104, 76, 107);
INSERT INTO public.who_global_data VALUES (17811, 1, 306, 0, 0, 76, 161);
INSERT INTO public.who_global_data VALUES (17812, 0, 23528, 0, 435, 76, 212);
INSERT INTO public.who_global_data VALUES (17813, 4968, 320719, 69, 11334, 76, 181);
INSERT INTO public.who_global_data VALUES (17814, 2, 261, 0, 2, 76, 53);
INSERT INTO public.who_global_data VALUES (17815, 0, 4911, 0, 63, 76, 164);
INSERT INTO public.who_global_data VALUES (17816, 7, 1633, 0, 101, 76, 140);
INSERT INTO public.who_global_data VALUES (17817, 1558, 539143, 27, 15030, 76, 20);
INSERT INTO public.who_global_data VALUES (17818, 60, 92648, 0, 4749, 76, 112);
INSERT INTO public.who_global_data VALUES (17819, 7954, 1233444, 168, 34929, 76, 111);
INSERT INTO public.who_global_data VALUES (17820, 0, 592, 0, 7, 76, 71);
INSERT INTO public.who_global_data VALUES (17821, 0, 5632, 0, 93, 76, 218);
INSERT INTO public.who_global_data VALUES (17822, 0, 0, 0, 0, 76, 43);
INSERT INTO public.who_global_data VALUES (17823, 1187, 129418, 9, 1608, 76, 49);
INSERT INTO public.who_global_data VALUES (17824, 27, 21126, 0, 129, 76, 1);
INSERT INTO public.who_global_data VALUES (17825, 3573, 100410, 47, 1304, 76, 48);
INSERT INTO public.who_global_data VALUES (17826, 35, 7798, 1, 132, 76, 232);
INSERT INTO public.who_global_data VALUES (17827, 0, 1561, 0, 3, 76, 175);
INSERT INTO public.who_global_data VALUES (17828, 245, 8456, 0, 43, 76, 21);
INSERT INTO public.who_global_data VALUES (17829, 3187, 490750, 74, 7095, 76, 156);
INSERT INTO public.who_global_data VALUES (17830, 0, 0, 0, 0, 76, 95);
INSERT INTO public.who_global_data VALUES (17831, 51, 12179, 3, 327, 76, 177);
INSERT INTO public.who_global_data VALUES (17832, 1273, 69635, 3, 781, 76, 210);
INSERT INTO public.who_global_data VALUES (17833, 1, 5661, 0, 61, 76, 120);
INSERT INTO public.who_global_data VALUES (17834, 0, 72, 0, 0, 76, 135);
INSERT INTO public.who_global_data VALUES (17835, 986, 137770, 2, 2308, 76, 206);
INSERT INTO public.who_global_data VALUES (17836, 1036, 184876, 44, 13139, 76, 189);
INSERT INTO public.who_global_data VALUES (17837, 358, 112676, 14, 6535, 76, 129);
INSERT INTO public.who_global_data VALUES (17838, 0, 37250, 6, 1070, 76, 121);
INSERT INTO public.who_global_data VALUES (17839, 9, 5130, 0, 85, 76, 59);
INSERT INTO public.who_global_data VALUES (17840, 24, 551, 0, 0, 76, 96);
INSERT INTO public.who_global_data VALUES (17841, 299, 9375, 0, 87, 76, 41);
INSERT INTO public.who_global_data VALUES (17842, 20, 6205, 0, 119, 76, 216);
INSERT INTO public.who_global_data VALUES (17843, 473, 105352, 16, 1636, 76, 236);
INSERT INTO public.who_global_data VALUES (17844, 0, 16, 0, 0, 76, 150);
INSERT INTO public.who_global_data VALUES (17845, 1, 499, 0, 0, 76, 61);
INSERT INTO public.who_global_data VALUES (17846, 0, 35, 0, 2, 76, 7);
INSERT INTO public.who_global_data VALUES (17847, 469, 21216, 0, 375, 76, 169);
INSERT INTO public.who_global_data VALUES (17848, 17854, 2089353, 253, 48170, 76, 28);
INSERT INTO public.who_global_data VALUES (17849, 27, 11014, 0, 70, 76, 85);
INSERT INTO public.who_global_data VALUES (17850, 0, 12978, 0, 63, 76, 211);
INSERT INTO public.who_global_data VALUES (17851, 0, 9131, 0, 59, 76, 60);
INSERT INTO public.who_global_data VALUES (17852, 10, 3726, 1, 123, 76, 3);
INSERT INTO public.who_global_data VALUES (17853, 4048, 104732, 49, 976, 76, 11);
INSERT INTO public.who_global_data VALUES (17854, 15741, 918269, 138, 14022, 76, 89);
INSERT INTO public.who_global_data VALUES (17855, 243, 50874, 0, 323, 76, 24);
INSERT INTO public.who_global_data VALUES (17856, 12, 943, 0, 3, 76, 162);
INSERT INTO public.who_global_data VALUES (17857, 2309, 90121, 108, 1527, 76, 100);
INSERT INTO public.who_global_data VALUES (17858, 0, 18, 0, 0, 76, 47);
INSERT INTO public.who_global_data VALUES (17859, 0, 41, 0, 0, 76, 29);
INSERT INTO public.who_global_data VALUES (17860, 0, 8225, 0, 144, 76, 40);
INSERT INTO public.who_global_data VALUES (17861, 24, 6355, 1, 104, 76, 222);
INSERT INTO public.who_global_data VALUES (17862, 660, 118417, 7, 4074, 76, 132);
INSERT INTO public.who_global_data VALUES (17863, 1, 283, 0, 13, 76, 130);
INSERT INTO public.who_global_data VALUES (17864, 0, 12798, 0, 75, 76, 234);
INSERT INTO public.who_global_data VALUES (17865, 0, 2421, 0, 43, 76, 23);
INSERT INTO public.who_global_data VALUES (17866, 29, 5005, 0, 143, 76, 192);
INSERT INTO public.who_global_data VALUES (17867, 3, 9214, 0, 232, 76, 69);
INSERT INTO public.who_global_data VALUES (17868, 0, 26, 0, 0, 76, 187);
INSERT INTO public.who_global_data VALUES (17869, 628, 104179, 2, 2855, 76, 230);
INSERT INTO public.who_global_data VALUES (17870, 4320, 174618, 111, 3800, 76, 77);
INSERT INTO public.who_global_data VALUES (17871, 18, 5269, 0, 26, 76, 9);
INSERT INTO public.who_global_data VALUES (17872, 45209, 9095806, 501, 133227, 76, 74);
INSERT INTO public.who_global_data VALUES (17873, 4998, 493308, 96, 15774, 76, 224);
INSERT INTO public.who_global_data VALUES (17874, 12931, 841308, 431, 44327, 76, 199);
INSERT INTO public.who_global_data VALUES (17875, 1786, 533555, 42, 11925, 76, 190);
INSERT INTO public.who_global_data VALUES (17876, 341, 70143, 4, 2022, 76, 12);
INSERT INTO public.who_global_data VALUES (17877, 2, 368, 0, 25, 76, 104);
INSERT INTO public.who_global_data VALUES (17878, 773, 328139, 6, 2789, 76, 153);
INSERT INTO public.who_global_data VALUES (17879, 34764, 1380531, 692, 49261, 76, 91);
INSERT INTO public.who_global_data VALUES (17880, 89, 10240, 2, 237, 76, 215);
INSERT INTO public.who_global_data VALUES (17881, 2514, 130179, 11, 1974, 76, 84);
INSERT INTO public.who_global_data VALUES (17882, 14, 806, 0, 32, 76, 231);
INSERT INTO public.who_global_data VALUES (17883, 3826, 178161, 56, 2172, 76, 196);
INSERT INTO public.who_global_data VALUES (17884, 760, 167385, 52, 2417, 76, 105);
INSERT INTO public.who_global_data VALUES (17885, 1211, 76404, 17, 1366, 76, 122);
INSERT INTO public.who_global_data VALUES (17886, 0, 0, 0, 0, 76, 159);
INSERT INTO public.who_global_data VALUES (17887, 711, 33545, 19, 894, 76, 75);
INSERT INTO public.who_global_data VALUES (17888, 426, 139734, 2, 863, 76, 27);
INSERT INTO public.who_global_data VALUES (17889, 432, 69581, 4, 1231, 76, 54);
INSERT INTO public.who_global_data VALUES (17890, 0, 25, 0, 0, 76, 226);
INSERT INTO public.who_global_data VALUES (17891, 642, 12744, 7, 153, 76, 79);
INSERT INTO public.who_global_data VALUES (17892, 1628, 115242, 10, 894, 76, 56);
INSERT INTO public.who_global_data VALUES (17893, 0, 2058, 0, 44, 76, 117);
INSERT INTO public.who_global_data VALUES (17894, 15, 1554, 0, 82, 76, 152);
INSERT INTO public.who_global_data VALUES (17895, 0, 76808, 0, 1068, 76, 16);
INSERT INTO public.who_global_data VALUES (17896, 14, 1151, 1, 9, 76, 10);
INSERT INTO public.who_global_data VALUES (17897, 2309, 47011, 27, 441, 76, 201);
INSERT INTO public.who_global_data VALUES (17898, 519, 29762, 6, 260, 76, 174);
INSERT INTO public.who_global_data VALUES (17899, 0, 17310, 0, 250, 76, 119);
INSERT INTO public.who_global_data VALUES (17900, 0, 6003, 0, 185, 76, 168);
INSERT INTO public.who_global_data VALUES (17901, 1041, 53679, 3, 332, 76, 99);
INSERT INTO public.who_global_data VALUES (17902, 32, 12578, 0, 45, 76, 171);
INSERT INTO public.who_global_data VALUES (17903, 37, 4206, 0, 143, 76, 87);
INSERT INTO public.who_global_data VALUES (17904, 102, 8913, 2, 107, 76, 123);
INSERT INTO public.who_global_data VALUES (17905, 0, 4, 0, 0, 76, 151);
INSERT INTO public.who_global_data VALUES (17906, 0, 5091, 0, 39, 76, 213);
INSERT INTO public.who_global_data VALUES (17907, 0, 8075, 0, 169, 76, 118);
INSERT INTO public.who_global_data VALUES (17908, 0, 491, 0, 10, 76, 134);
INSERT INTO public.who_global_data VALUES (17909, 0, 5036, 0, 48, 76, 65);
INSERT INTO public.who_global_data VALUES (17910, 6426, 1025969, 719, 100823, 76, 102);
INSERT INTO public.who_global_data VALUES (17911, 0, 0, 0, 0, 76, 223);
INSERT INTO public.who_global_data VALUES (17912, 4, 584, 0, 3, 76, 4);
INSERT INTO public.who_global_data VALUES (17913, 25, 582, 0, 0, 76, 146);
INSERT INTO public.who_global_data VALUES (17914, 409, 31485, 5, 438, 76, 31);
INSERT INTO public.who_global_data VALUES (17915, 0, 13, 0, 1, 76, 127);
INSERT INTO public.who_global_data VALUES (17916, 4702, 320962, 74, 5256, 76, 22);
INSERT INTO public.who_global_data VALUES (17917, 104, 14981, 2, 123, 76, 115);
INSERT INTO public.who_global_data VALUES (17918, 1434, 77848, 27, 1722, 76, 106);
INSERT INTO public.who_global_data VALUES (17919, 99, 13811, 0, 143, 76, 90);
INSERT INTO public.who_global_data VALUES (17920, 0, 0, 0, 0, 76, 70);
INSERT INTO public.who_global_data VALUES (17921, 1674, 218639, 7, 1305, 76, 46);
INSERT INTO public.who_global_data VALUES (17922, 6006, 478051, 47, 8849, 76, 139);
INSERT INTO public.who_global_data VALUES (17923, 0, 32, 0, 0, 76, 42);
INSERT INTO public.who_global_data VALUES (17924, 9, 1672, 0, 25, 76, 80);
INSERT INTO public.who_global_data VALUES (17925, 0, 4583, 0, 159, 76, 203);
INSERT INTO public.who_global_data VALUES (17926, 16, 1351, 0, 70, 76, 136);
INSERT INTO public.who_global_data VALUES (17927, 246, 66228, 1, 1166, 76, 63);
INSERT INTO public.who_global_data VALUES (17928, 0, 0, 0, 0, 76, 17);
INSERT INTO public.who_global_data VALUES (17929, 1, 104, 0, 2, 76, 172);
INSERT INTO public.who_global_data VALUES (17930, 1182, 53631, 25, 1487, 76, 109);
INSERT INTO public.who_global_data VALUES (17931, 0, 31438, 0, 306, 76, 200);
INSERT INTO public.who_global_data VALUES (17932, 1486, 82780, 14, 698, 76, 93);
INSERT INTO public.who_global_data VALUES (17933, 0, 121360, 0, 1365, 76, 5);
INSERT INTO public.who_global_data VALUES (17934, 0, 741, 0, 13, 76, 214);
INSERT INTO public.who_global_data VALUES (17935, 2843, 371508, 42, 7603, 76, 204);
INSERT INTO public.who_global_data VALUES (17936, 0, 0, 0, 0, 76, 198);
INSERT INTO public.who_global_data VALUES (17937, 1200, 152289, 10, 2932, 76, 173);
INSERT INTO public.who_global_data VALUES (17938, 0, 604, 0, 7, 76, 229);
INSERT INTO public.who_global_data VALUES (17939, 563, 75058, 11, 1647, 76, 76);
INSERT INTO public.who_global_data VALUES (17940, 2170, 946087, 38, 35484, 76, 138);
INSERT INTO public.who_global_data VALUES (17941, 1785, 416852, 55, 8080, 76, 98);
INSERT INTO public.who_global_data VALUES (17942, 0, 0, 0, 0, 76, 103);
INSERT INTO public.who_global_data VALUES (17943, 24213, 843475, 574, 13288, 76, 225);
INSERT INTO public.who_global_data VALUES (17944, 6472, 255970, 62, 3824, 76, 131);
INSERT INTO public.who_global_data VALUES (17945, 1099, 46434, 21, 1012, 76, 235);
INSERT INTO public.who_global_data VALUES (17946, 174, 137062, 0, 235, 76, 137);
INSERT INTO public.who_global_data VALUES (17947, 330, 30670, 2, 505, 76, 81);
INSERT INTO public.who_global_data VALUES (17948, 1306, 96689, 19, 2130, 76, 182);
INSERT INTO public.who_global_data VALUES (17949, 0, 7501, 0, 35, 76, 145);
INSERT INTO public.who_global_data VALUES (17950, 9685, 412808, 160, 9916, 76, 26);
INSERT INTO public.who_global_data VALUES (17951, 24581, 2089329, 401, 36179, 76, 170);
INSERT INTO public.who_global_data VALUES (17952, 34, 5620, 0, 46, 76, 191);
INSERT INTO public.who_global_data VALUES (17953, 0, 5, 0, 0, 76, 221);
INSERT INTO public.who_global_data VALUES (17954, 0, 127, 0, 0, 76, 64);
INSERT INTO public.who_global_data VALUES (17955, 0, 0, 0, 0, 76, 116);
INSERT INTO public.who_global_data VALUES (17956, 0, 19, 0, 0, 76, 128);
INSERT INTO public.who_global_data VALUES (17957, 0, 203, 0, 2, 76, 6);
INSERT INTO public.who_global_data VALUES (17958, 0, 690, 0, 12, 76, 227);
INSERT INTO public.who_global_data VALUES (17959, 0, 14, 0, 0, 76, 68);
INSERT INTO public.who_global_data VALUES (17960, 0, 84, 0, 0, 76, 184);
INSERT INTO public.who_global_data VALUES (17961, 0, 0, 0, 0, 76, 82);
INSERT INTO public.who_global_data VALUES (17962, 32, 1427, 0, 43, 76, 149);
INSERT INTO public.who_global_data VALUES (17963, 5, 979, 0, 17, 76, 197);
INSERT INTO public.who_global_data VALUES (17964, 221, 355034, 16, 5761, 76, 78);
INSERT INTO public.who_global_data VALUES (17965, 17, 15865, 0, 330, 76, 233);
INSERT INTO public.who_global_data VALUES (17966, 5774, 116125, 28, 1168, 76, 133);
INSERT INTO public.who_global_data VALUES (17967, 0, 161, 0, 0, 76, 35);
INSERT INTO public.who_global_data VALUES (17968, 6, 2405, 0, 74, 76, 114);
INSERT INTO public.who_global_data VALUES (17969, 5, 58148, 0, 28, 76, 237);
INSERT INTO public.who_global_data VALUES (17970, 0, 14, 0, 0, 76, 55);
INSERT INTO public.who_global_data VALUES (17971, 0, 973, 0, 24, 76, 176);
INSERT INTO public.who_global_data VALUES (17972, 1861, 95257, 30, 644, 76, 202);
INSERT INTO public.who_global_data VALUES (17973, 1025, 65327, 26, 1150, 76, 155);
INSERT INTO public.who_global_data VALUES (17974, 0, 16, 0, 0, 76, 32);
INSERT INTO public.who_global_data VALUES (17975, 0, 4382, 0, 108, 76, 220);
INSERT INTO public.who_global_data VALUES (17976, 2646, 765409, 86, 20845, 76, 30);
INSERT INTO public.who_global_data VALUES (17977, 0, 3047, 0, 60, 76, 147);
INSERT INTO public.who_global_data VALUES (17978, 12693, 1639136, 286, 44865, 76, 208);
INSERT INTO public.who_global_data VALUES (17979, 491, 19771, 9, 83, 76, 45);
INSERT INTO public.who_global_data VALUES (17980, 135, 16187, 2, 1199, 76, 110);
INSERT INTO public.who_global_data VALUES (17981, 5, 5289, 0, 116, 76, 88);
INSERT INTO public.who_global_data VALUES (17982, 5459, 215084, 45, 6670, 76, 51);
INSERT INTO public.who_global_data VALUES (17983, 2571, 298887, 76, 4002, 76, 209);
INSERT INTO public.who_global_data VALUES (17984, 75, 7154, 4, 372, 76, 205);
INSERT INTO public.who_global_data VALUES (17985, 39, 11854, 0, 86, 76, 18);
INSERT INTO public.who_global_data VALUES (17986, 11, 3913, 0, 60, 76, 72);
INSERT INTO public.who_global_data VALUES (17987, 19875, 1493387, 340, 54626, 76, 44);
INSERT INTO public.who_global_data VALUES (17988, 0, 30, 0, 0, 76, 15);
INSERT INTO public.who_global_data VALUES (17989, 0, 2771, 0, 63, 76, 25);
INSERT INTO public.who_global_data VALUES (17990, 0, 0, 0, 0, 76, 179);
INSERT INTO public.who_global_data VALUES (17991, 0, 0, 0, 0, 76, 34);
INSERT INTO public.who_global_data VALUES (17992, 28, 6261, 0, 113, 76, 207);
INSERT INTO public.who_global_data VALUES (17993, 1206, 87471, 68, 2752, 76, 166);
INSERT INTO public.who_global_data VALUES (17994, 12263, 1228219, 135, 12219, 76, 126);
INSERT INTO public.who_global_data VALUES (17995, 0, 0, 0, 0, 76, 97);
INSERT INTO public.who_global_data VALUES (17996, 0, 726, 0, 6, 76, 36);
INSERT INTO public.who_global_data VALUES (17997, 0, 0, 0, 0, 76, 125);
INSERT INTO public.who_global_data VALUES (17998, 236, 17667, 0, 168, 76, 124);
INSERT INTO public.who_global_data VALUES (17999, 12079, 624744, 138, 10951, 76, 185);
INSERT INTO public.who_global_data VALUES (18000, 1262, 157785, 1, 548, 76, 194);
INSERT INTO public.who_global_data VALUES (18001, 0, 509, 0, 21, 76, 144);
INSERT INTO public.who_global_data VALUES (18002, 191033, 11789012, 1853, 252460, 76, 19);
INSERT INTO public.who_global_data VALUES (18003, 9, 1491, 0, 23, 76, 217);
INSERT INTO public.who_global_data VALUES (18004, 100, 4477, 0, 69, 76, 148);
INSERT INTO public.who_global_data VALUES (18005, 272, 71552, 0, 603, 76, 86);
INSERT INTO public.who_global_data VALUES (18006, 0, 1, 0, 0, 76, 13);
INSERT INTO public.who_global_data VALUES (18007, 352, 99017, 3, 866, 76, 157);
INSERT INTO public.who_global_data VALUES (18008, 1, 1306, 0, 35, 76, 8);
INSERT INTO public.who_global_data VALUES (18009, 0, 2, 0, 0, 76, 73);
INSERT INTO public.who_global_data VALUES (18010, 0, 2073, 0, 605, 76, 101);
INSERT INTO public.who_global_data VALUES (18011, 21, 17394, 0, 356, 76, 165);
INSERT INTO public.who_global_data VALUES (18012, 0, 9120, 0, 265, 76, 14);
INSERT INTO public.who_global_data VALUES (18013, 215, 44443, 11, 1661, 77, 193);
INSERT INTO public.who_global_data VALUES (18014, 836, 31459, 15, 672, 77, 113);
INSERT INTO public.who_global_data VALUES (18015, 1103, 72755, 15, 2239, 77, 143);
INSERT INTO public.who_global_data VALUES (18016, 0, 0, 0, 0, 77, 219);
INSERT INTO public.who_global_data VALUES (18017, 76, 6142, 0, 76, 77, 186);
INSERT INTO public.who_global_data VALUES (18018, 133, 14267, 1, 334, 77, 52);
INSERT INTO public.who_global_data VALUES (18019, 0, 3, 0, 0, 77, 180);
INSERT INTO public.who_global_data VALUES (18020, 0, 139, 0, 4, 77, 167);
INSERT INTO public.who_global_data VALUES (18021, 10097, 1349434, 185, 36532, 77, 154);
INSERT INTO public.who_global_data VALUES (18022, 1193, 124152, 31, 1926, 77, 94);
INSERT INTO public.who_global_data VALUES (18023, 8, 4693, 0, 45, 77, 66);
INSERT INTO public.who_global_data VALUES (18024, 5, 27789, 0, 907, 77, 58);
INSERT INTO public.who_global_data VALUES (18025, 6612, 234670, 79, 2097, 77, 163);
INSERT INTO public.who_global_data VALUES (18026, 3169, 87163, 26, 1079, 77, 37);
INSERT INTO public.who_global_data VALUES (18027, 19, 7367, 0, 163, 77, 142);
INSERT INTO public.who_global_data VALUES (18028, 150, 85467, 1, 338, 77, 83);
INSERT INTO public.who_global_data VALUES (18029, 2275, 443434, 17, 6322, 77, 228);
INSERT INTO public.who_global_data VALUES (18030, 0, 253, 0, 7, 77, 188);
INSERT INTO public.who_global_data VALUES (18031, 1457, 120847, 7, 1081, 77, 62);
INSERT INTO public.who_global_data VALUES (18032, 3082, 559884, 169, 15591, 77, 160);
INSERT INTO public.who_global_data VALUES (18033, 60, 5018, 2, 102, 77, 50);
INSERT INTO public.who_global_data VALUES (18034, 0, 2916, 0, 43, 77, 33);
INSERT INTO public.who_global_data VALUES (18035, 3, 227, 0, 9, 77, 183);
INSERT INTO public.who_global_data VALUES (18036, 0, 378, 0, 0, 77, 92);
INSERT INTO public.who_global_data VALUES (18037, 187, 143756, 14, 8889, 77, 158);
INSERT INTO public.who_global_data VALUES (18038, 0, 139, 0, 3, 77, 67);
INSERT INTO public.who_global_data VALUES (18039, 1237, 77994, 56, 2209, 77, 57);
INSERT INTO public.who_global_data VALUES (18040, 0, 9594, 0, 31, 77, 38);
INSERT INTO public.who_global_data VALUES (18041, 35918, 5981767, 606, 168061, 77, 141);
INSERT INTO public.who_global_data VALUES (18042, 0, 72, 0, 1, 77, 178);
INSERT INTO public.who_global_data VALUES (18043, 0, 148, 0, 3, 77, 108);
INSERT INTO public.who_global_data VALUES (18044, 3983, 118418, 129, 2778, 77, 39);
INSERT INTO public.who_global_data VALUES (18045, 0, 2686, 0, 68, 77, 2);
INSERT INTO public.who_global_data VALUES (18046, 7, 656, 0, 1, 77, 195);
INSERT INTO public.who_global_data VALUES (18047, 70, 10152, 0, 104, 77, 107);
INSERT INTO public.who_global_data VALUES (18048, 1, 305, 0, 0, 77, 161);
INSERT INTO public.who_global_data VALUES (18049, 0, 23528, 0, 435, 77, 212);
INSERT INTO public.who_global_data VALUES (18050, 4642, 315751, 79, 11265, 77, 181);
INSERT INTO public.who_global_data VALUES (18051, 1, 259, 0, 2, 77, 53);
INSERT INTO public.who_global_data VALUES (18052, 0, 4911, 0, 63, 77, 164);
INSERT INTO public.who_global_data VALUES (18053, 6, 1626, 0, 101, 77, 140);
INSERT INTO public.who_global_data VALUES (18054, 1573, 537585, 48, 15003, 77, 20);
INSERT INTO public.who_global_data VALUES (18055, 44, 92588, 0, 4749, 77, 112);
INSERT INTO public.who_global_data VALUES (18056, 7487, 1225490, 198, 34761, 77, 111);
INSERT INTO public.who_global_data VALUES (18057, 0, 592, 0, 7, 77, 71);
INSERT INTO public.who_global_data VALUES (18058, 0, 5632, 0, 93, 77, 218);
INSERT INTO public.who_global_data VALUES (18059, 0, 0, 0, 0, 77, 43);
INSERT INTO public.who_global_data VALUES (18060, 1219, 128231, 11, 1599, 77, 49);
INSERT INTO public.who_global_data VALUES (18061, 16, 21099, 0, 129, 77, 1);
INSERT INTO public.who_global_data VALUES (18062, 2958, 96837, 57, 1257, 77, 48);
INSERT INTO public.who_global_data VALUES (18063, 38, 7763, 0, 131, 77, 232);
INSERT INTO public.who_global_data VALUES (18064, 79, 1561, 1, 3, 77, 175);
INSERT INTO public.who_global_data VALUES (18065, 232, 8211, 2, 43, 77, 21);
INSERT INTO public.who_global_data VALUES (18066, 5808, 487563, 147, 7021, 77, 156);
INSERT INTO public.who_global_data VALUES (18067, 0, 0, 0, 0, 77, 95);
INSERT INTO public.who_global_data VALUES (18068, 121, 12128, 1, 324, 77, 177);
INSERT INTO public.who_global_data VALUES (18069, 1257, 68362, 5, 778, 77, 210);
INSERT INTO public.who_global_data VALUES (18070, 2, 5660, 0, 61, 77, 120);
INSERT INTO public.who_global_data VALUES (18071, 0, 72, 0, 0, 77, 135);
INSERT INTO public.who_global_data VALUES (18072, 601, 136784, 5, 2306, 77, 206);
INSERT INTO public.who_global_data VALUES (18073, 594, 183840, 22, 13095, 77, 189);
INSERT INTO public.who_global_data VALUES (18074, 363, 112318, 13, 6521, 77, 129);
INSERT INTO public.who_global_data VALUES (18075, 285, 37250, 3, 1064, 77, 121);
INSERT INTO public.who_global_data VALUES (18076, 0, 5121, 0, 85, 77, 59);
INSERT INTO public.who_global_data VALUES (18077, 0, 527, 0, 0, 77, 96);
INSERT INTO public.who_global_data VALUES (18078, 361, 9076, 1, 87, 77, 41);
INSERT INTO public.who_global_data VALUES (18079, 29, 6185, 0, 119, 77, 216);
INSERT INTO public.who_global_data VALUES (18080, 452, 104879, 13, 1620, 77, 236);
INSERT INTO public.who_global_data VALUES (18081, 0, 16, 0, 0, 77, 150);
INSERT INTO public.who_global_data VALUES (18082, 0, 498, 0, 0, 77, 61);
INSERT INTO public.who_global_data VALUES (18083, 0, 35, 0, 2, 77, 7);
INSERT INTO public.who_global_data VALUES (18084, 461, 20747, 1, 375, 77, 169);
INSERT INTO public.who_global_data VALUES (18085, 22642, 2071499, 1137, 47917, 77, 28);
INSERT INTO public.who_global_data VALUES (18086, 37, 10987, 0, 70, 77, 85);
INSERT INTO public.who_global_data VALUES (18087, 162, 12978, 1, 63, 77, 211);
INSERT INTO public.who_global_data VALUES (18088, 15, 9131, 0, 59, 77, 60);
INSERT INTO public.who_global_data VALUES (18089, 10, 3716, 0, 122, 77, 3);
INSERT INTO public.who_global_data VALUES (18090, 3824, 100684, 33, 927, 77, 11);
INSERT INTO public.who_global_data VALUES (18091, 22964, 902528, 254, 13884, 77, 89);
INSERT INTO public.who_global_data VALUES (18092, 0, 50631, 0, 323, 77, 24);
INSERT INTO public.who_global_data VALUES (18093, 5, 931, 1, 3, 77, 162);
INSERT INTO public.who_global_data VALUES (18094, 2551, 87812, 72, 1419, 77, 100);
INSERT INTO public.who_global_data VALUES (18095, 0, 18, 0, 0, 77, 47);
INSERT INTO public.who_global_data VALUES (18096, 5, 41, 0, 0, 77, 29);
INSERT INTO public.who_global_data VALUES (18097, 0, 8225, 0, 144, 77, 40);
INSERT INTO public.who_global_data VALUES (18098, 36, 6331, 2, 103, 77, 222);
INSERT INTO public.who_global_data VALUES (18099, 691, 117757, 17, 4067, 77, 132);
INSERT INTO public.who_global_data VALUES (18100, 0, 282, 0, 13, 77, 130);
INSERT INTO public.who_global_data VALUES (18101, 85, 12798, 0, 75, 77, 234);
INSERT INTO public.who_global_data VALUES (18102, 0, 2421, 0, 43, 77, 23);
INSERT INTO public.who_global_data VALUES (18103, 62, 4976, 1, 143, 77, 192);
INSERT INTO public.who_global_data VALUES (18104, 3, 9211, 0, 232, 77, 69);
INSERT INTO public.who_global_data VALUES (18105, 0, 26, 0, 0, 77, 187);
INSERT INTO public.who_global_data VALUES (18106, 63, 103551, 14, 2853, 77, 230);
INSERT INTO public.who_global_data VALUES (18107, 4397, 170298, 121, 3689, 77, 77);
INSERT INTO public.who_global_data VALUES (18108, 20, 5251, 1, 26, 77, 9);
INSERT INTO public.who_global_data VALUES (18109, 46232, 9050597, 564, 132726, 77, 74);
INSERT INTO public.who_global_data VALUES (18110, 4792, 488310, 78, 15678, 77, 224);
INSERT INTO public.who_global_data VALUES (18111, 13260, 828377, 479, 43896, 77, 199);
INSERT INTO public.who_global_data VALUES (18112, 2543, 531769, 49, 11883, 77, 190);
INSERT INTO public.who_global_data VALUES (18113, 329, 69802, 8, 2018, 77, 12);
INSERT INTO public.who_global_data VALUES (18114, 2, 366, 0, 25, 77, 104);
INSERT INTO public.who_global_data VALUES (18115, 771, 327366, 8, 2783, 77, 153);
INSERT INTO public.who_global_data VALUES (18116, 37239, 1345767, 699, 48569, 77, 91);
INSERT INTO public.who_global_data VALUES (18117, 63, 10151, 0, 235, 77, 215);
INSERT INTO public.who_global_data VALUES (18118, 2398, 127665, 20, 1963, 77, 84);
INSERT INTO public.who_global_data VALUES (18119, 10, 792, 0, 32, 77, 231);
INSERT INTO public.who_global_data VALUES (18120, 4939, 174335, 63, 2116, 77, 196);
INSERT INTO public.who_global_data VALUES (18121, 913, 166625, 0, 2365, 77, 105);
INSERT INTO public.who_global_data VALUES (18122, 1048, 75193, 19, 1349, 77, 122);
INSERT INTO public.who_global_data VALUES (18123, 0, 0, 0, 0, 77, 159);
INSERT INTO public.who_global_data VALUES (18124, 855, 32834, 11, 875, 77, 75);
INSERT INTO public.who_global_data VALUES (18125, 486, 139308, 2, 861, 77, 27);
INSERT INTO public.who_global_data VALUES (18126, 447, 69149, 4, 1227, 77, 54);
INSERT INTO public.who_global_data VALUES (18127, 0, 25, 0, 0, 77, 226);
INSERT INTO public.who_global_data VALUES (18128, 380, 12102, 5, 146, 77, 79);
INSERT INTO public.who_global_data VALUES (18129, 1668, 113614, 16, 884, 77, 56);
INSERT INTO public.who_global_data VALUES (18130, 0, 2058, 0, 44, 77, 117);
INSERT INTO public.who_global_data VALUES (18131, 0, 1539, 0, 82, 77, 152);
INSERT INTO public.who_global_data VALUES (18132, 802, 76808, 6, 1068, 77, 16);
INSERT INTO public.who_global_data VALUES (18133, 16, 1137, 0, 8, 77, 10);
INSERT INTO public.who_global_data VALUES (18134, 1978, 44702, 20, 414, 77, 201);
INSERT INTO public.who_global_data VALUES (18135, 670, 29243, 6, 254, 77, 174);
INSERT INTO public.who_global_data VALUES (18136, 0, 17310, 0, 250, 77, 119);
INSERT INTO public.who_global_data VALUES (18137, 1, 6003, 0, 185, 77, 168);
INSERT INTO public.who_global_data VALUES (18138, 958, 52638, 3, 329, 77, 99);
INSERT INTO public.who_global_data VALUES (18139, 94, 12546, 0, 45, 77, 171);
INSERT INTO public.who_global_data VALUES (18140, 76, 4169, 1, 143, 77, 87);
INSERT INTO public.who_global_data VALUES (18141, 141, 8811, 2, 105, 77, 123);
INSERT INTO public.who_global_data VALUES (18142, 0, 4, 0, 0, 77, 151);
INSERT INTO public.who_global_data VALUES (18143, 0, 5091, 0, 39, 77, 213);
INSERT INTO public.who_global_data VALUES (18144, 123, 8075, 4, 169, 77, 118);
INSERT INTO public.who_global_data VALUES (18145, 0, 491, 0, 10, 77, 134);
INSERT INTO public.who_global_data VALUES (18146, 0, 5036, 0, 48, 77, 65);
INSERT INTO public.who_global_data VALUES (18147, 4472, 1019543, 576, 100104, 77, 102);
INSERT INTO public.who_global_data VALUES (18148, 0, 0, 0, 0, 77, 223);
INSERT INTO public.who_global_data VALUES (18149, 4, 580, 0, 3, 77, 4);
INSERT INTO public.who_global_data VALUES (18150, 39, 557, 0, 0, 77, 146);
INSERT INTO public.who_global_data VALUES (18151, 467, 31076, 5, 433, 77, 31);
INSERT INTO public.who_global_data VALUES (18152, 0, 13, 0, 1, 77, 127);
INSERT INTO public.who_global_data VALUES (18153, 4706, 316260, 92, 5182, 77, 22);
INSERT INTO public.who_global_data VALUES (18154, 154, 14877, 1, 121, 77, 115);
INSERT INTO public.who_global_data VALUES (18155, 1532, 76414, 19, 1695, 77, 106);
INSERT INTO public.who_global_data VALUES (18156, 50, 13712, 2, 143, 77, 90);
INSERT INTO public.who_global_data VALUES (18157, 0, 0, 0, 0, 77, 70);
INSERT INTO public.who_global_data VALUES (18158, 1945, 216965, 22, 1298, 77, 46);
INSERT INTO public.who_global_data VALUES (18159, 5934, 472045, 49, 8802, 77, 139);
INSERT INTO public.who_global_data VALUES (18160, 2, 32, 0, 0, 77, 42);
INSERT INTO public.who_global_data VALUES (18161, 6, 1663, 0, 25, 77, 80);
INSERT INTO public.who_global_data VALUES (18162, 0, 4583, 0, 159, 77, 203);
INSERT INTO public.who_global_data VALUES (18163, 0, 1335, 0, 70, 77, 136);
INSERT INTO public.who_global_data VALUES (18164, 143, 65982, 0, 1165, 77, 63);
INSERT INTO public.who_global_data VALUES (18165, 0, 0, 0, 0, 77, 17);
INSERT INTO public.who_global_data VALUES (18166, 0, 103, 0, 2, 77, 172);
INSERT INTO public.who_global_data VALUES (18167, 1236, 52449, 39, 1462, 77, 109);
INSERT INTO public.who_global_data VALUES (18168, 670, 31438, 1, 306, 77, 200);
INSERT INTO public.who_global_data VALUES (18169, 1472, 81294, 8, 684, 77, 93);
INSERT INTO public.who_global_data VALUES (18170, 0, 121360, 0, 1365, 77, 5);
INSERT INTO public.who_global_data VALUES (18171, 0, 741, 0, 13, 77, 214);
INSERT INTO public.who_global_data VALUES (18172, 2738, 368665, 313, 7561, 77, 204);
INSERT INTO public.who_global_data VALUES (18173, 0, 0, 0, 0, 77, 198);
INSERT INTO public.who_global_data VALUES (18174, 1256, 151089, 15, 2922, 77, 173);
INSERT INTO public.who_global_data VALUES (18175, 0, 604, 0, 7, 77, 229);
INSERT INTO public.who_global_data VALUES (18176, 856, 74495, 12, 1636, 77, 76);
INSERT INTO public.who_global_data VALUES (18177, 1966, 943917, 44, 35446, 77, 138);
INSERT INTO public.who_global_data VALUES (18178, 1637, 415067, 27, 8025, 77, 98);
INSERT INTO public.who_global_data VALUES (18179, 0, 0, 0, 0, 77, 103);
INSERT INTO public.who_global_data VALUES (18180, 22464, 819262, 626, 12714, 77, 225);
INSERT INTO public.who_global_data VALUES (18181, 6489, 249498, 61, 3762, 77, 131);
INSERT INTO public.who_global_data VALUES (18182, 904, 45335, 9, 991, 77, 235);
INSERT INTO public.who_global_data VALUES (18183, 239, 136888, 0, 235, 77, 137);
INSERT INTO public.who_global_data VALUES (18184, 386, 30340, 2, 503, 77, 81);
INSERT INTO public.who_global_data VALUES (18185, 1422, 95383, 20, 2111, 77, 182);
INSERT INTO public.who_global_data VALUES (18186, 203, 7501, 1, 35, 77, 145);
INSERT INTO public.who_global_data VALUES (18187, 9272, 403123, 160, 9756, 77, 26);
INSERT INTO public.who_global_data VALUES (18188, 24822, 2064748, 467, 35778, 77, 170);
INSERT INTO public.who_global_data VALUES (18189, 43, 5586, 0, 46, 77, 191);
INSERT INTO public.who_global_data VALUES (18190, 0, 5, 0, 0, 77, 221);
INSERT INTO public.who_global_data VALUES (18191, 0, 127, 0, 0, 77, 64);
INSERT INTO public.who_global_data VALUES (18192, 0, 0, 0, 0, 77, 116);
INSERT INTO public.who_global_data VALUES (18193, 0, 19, 0, 0, 77, 128);
INSERT INTO public.who_global_data VALUES (18194, 0, 203, 0, 2, 77, 6);
INSERT INTO public.who_global_data VALUES (18195, 0, 690, 0, 12, 77, 227);
INSERT INTO public.who_global_data VALUES (18196, 0, 14, 0, 0, 77, 68);
INSERT INTO public.who_global_data VALUES (18197, 1, 84, 0, 0, 77, 184);
INSERT INTO public.who_global_data VALUES (18198, 0, 0, 0, 0, 77, 82);
INSERT INTO public.who_global_data VALUES (18199, 22, 1395, 0, 43, 77, 149);
INSERT INTO public.who_global_data VALUES (18200, 0, 974, 1, 17, 77, 197);
INSERT INTO public.who_global_data VALUES (18201, 286, 354813, 16, 5745, 77, 78);
INSERT INTO public.who_global_data VALUES (18202, 13, 15848, 1, 330, 77, 233);
INSERT INTO public.who_global_data VALUES (18203, 6254, 110351, 30, 1140, 77, 133);
INSERT INTO public.who_global_data VALUES (18204, 0, 161, 0, 0, 77, 35);
INSERT INTO public.who_global_data VALUES (18205, 2, 2399, 0, 74, 77, 114);
INSERT INTO public.who_global_data VALUES (18206, 4, 58143, 0, 28, 77, 237);
INSERT INTO public.who_global_data VALUES (18207, 0, 14, 0, 0, 77, 55);
INSERT INTO public.who_global_data VALUES (18208, 9, 973, 0, 24, 77, 176);
INSERT INTO public.who_global_data VALUES (18209, 1818, 93396, 35, 614, 77, 202);
INSERT INTO public.who_global_data VALUES (18210, 1691, 64302, 43, 1124, 77, 155);
INSERT INTO public.who_global_data VALUES (18211, 0, 16, 0, 0, 77, 32);
INSERT INTO public.who_global_data VALUES (18212, 0, 4382, 0, 108, 77, 220);
INSERT INTO public.who_global_data VALUES (18213, 3105, 762763, 88, 20759, 77, 30);
INSERT INTO public.who_global_data VALUES (18214, 31, 3047, 1, 60, 77, 147);
INSERT INTO public.who_global_data VALUES (18215, 13318, 1626443, 288, 44579, 77, 208);
INSERT INTO public.who_global_data VALUES (18216, 439, 19280, 1, 74, 77, 45);
INSERT INTO public.who_global_data VALUES (18217, 213, 16052, 4, 1197, 77, 110);
INSERT INTO public.who_global_data VALUES (18218, 2, 5284, 0, 116, 77, 88);
INSERT INTO public.who_global_data VALUES (18219, 7609, 209625, 46, 6625, 77, 51);
INSERT INTO public.who_global_data VALUES (18220, 4323, 296316, 80, 3926, 77, 209);
INSERT INTO public.who_global_data VALUES (18221, 88, 7079, 5, 368, 77, 205);
INSERT INTO public.who_global_data VALUES (18222, 43, 11815, 0, 86, 77, 18);
INSERT INTO public.who_global_data VALUES (18223, 10, 3902, 0, 60, 77, 72);
INSERT INTO public.who_global_data VALUES (18224, 20252, 1473512, 511, 54286, 77, 44);
INSERT INTO public.who_global_data VALUES (18225, 0, 30, 0, 0, 77, 15);
INSERT INTO public.who_global_data VALUES (18226, 0, 2771, 0, 63, 77, 25);
INSERT INTO public.who_global_data VALUES (18227, 0, 0, 0, 0, 77, 179);
INSERT INTO public.who_global_data VALUES (18228, 0, 0, 0, 0, 77, 34);
INSERT INTO public.who_global_data VALUES (18229, 53, 6233, 0, 113, 77, 207);
INSERT INTO public.who_global_data VALUES (18230, 1223, 86265, 70, 2684, 77, 166);
INSERT INTO public.who_global_data VALUES (18231, 11834, 1215956, 141, 12084, 77, 126);
INSERT INTO public.who_global_data VALUES (18232, 0, 0, 0, 0, 77, 97);
INSERT INTO public.who_global_data VALUES (18233, 5, 726, 0, 6, 77, 36);
INSERT INTO public.who_global_data VALUES (18234, 0, 0, 0, 0, 77, 125);
INSERT INTO public.who_global_data VALUES (18235, 283, 17431, 10, 168, 77, 124);
INSERT INTO public.who_global_data VALUES (18236, 14580, 612665, 215, 10813, 77, 185);
INSERT INTO public.who_global_data VALUES (18237, 1269, 156523, 3, 547, 77, 194);
INSERT INTO public.who_global_data VALUES (18238, 0, 509, 0, 21, 77, 144);
INSERT INTO public.who_global_data VALUES (18239, 184191, 11597979, 2036, 250607, 77, 19);
INSERT INTO public.who_global_data VALUES (18240, 13, 1482, 0, 23, 77, 217);
INSERT INTO public.who_global_data VALUES (18241, 81, 4377, 1, 69, 77, 148);
INSERT INTO public.who_global_data VALUES (18242, 209, 71280, 1, 603, 77, 86);
INSERT INTO public.who_global_data VALUES (18243, 0, 1, 0, 0, 77, 13);
INSERT INTO public.who_global_data VALUES (18244, 315, 98665, 3, 863, 77, 157);
INSERT INTO public.who_global_data VALUES (18245, 1, 1305, 0, 35, 77, 8);
INSERT INTO public.who_global_data VALUES (18246, 0, 2, 0, 0, 77, 73);
INSERT INTO public.who_global_data VALUES (18247, 1, 2073, 0, 605, 77, 101);
INSERT INTO public.who_global_data VALUES (18248, 23, 17373, 0, 356, 77, 165);
INSERT INTO public.who_global_data VALUES (18249, 74, 9120, 0, 265, 77, 14);
INSERT INTO public.who_global_data VALUES (18250, 377, 44228, 5, 1650, 78, 193);
INSERT INTO public.who_global_data VALUES (18251, 786, 30623, 11, 657, 78, 113);
INSERT INTO public.who_global_data VALUES (18252, 1023, 71652, 18, 2224, 78, 143);
INSERT INTO public.who_global_data VALUES (18253, 0, 0, 0, 0, 78, 219);
INSERT INTO public.who_global_data VALUES (18254, 48, 6066, 0, 76, 78, 186);
INSERT INTO public.who_global_data VALUES (18255, 212, 14134, 1, 333, 78, 52);
INSERT INTO public.who_global_data VALUES (18256, 0, 3, 0, 0, 78, 180);
INSERT INTO public.who_global_data VALUES (18257, 1, 139, 0, 4, 78, 167);
INSERT INTO public.who_global_data VALUES (18258, 10332, 1339337, 241, 36347, 78, 154);
INSERT INTO public.who_global_data VALUES (18259, 1667, 122959, 30, 1895, 78, 94);
INSERT INTO public.who_global_data VALUES (18260, 9, 4685, 1, 45, 78, 66);
INSERT INTO public.who_global_data VALUES (18261, 7, 27784, 0, 907, 78, 58);
INSERT INTO public.who_global_data VALUES (18262, 6830, 228058, 90, 2018, 78, 163);
INSERT INTO public.who_global_data VALUES (18263, 2597, 83994, 23, 1053, 78, 37);
INSERT INTO public.who_global_data VALUES (18264, 25, 7348, 0, 163, 78, 142);
INSERT INTO public.who_global_data VALUES (18265, 135, 85317, 0, 337, 78, 83);
INSERT INTO public.who_global_data VALUES (18266, 2364, 441159, 30, 6305, 78, 228);
INSERT INTO public.who_global_data VALUES (18267, 3, 253, 0, 7, 78, 188);
INSERT INTO public.who_global_data VALUES (18268, 1382, 119390, 7, 1074, 78, 62);
INSERT INTO public.who_global_data VALUES (18269, 3019, 556802, 172, 15422, 78, 160);
INSERT INTO public.who_global_data VALUES (18270, 38, 4958, 4, 100, 78, 50);
INSERT INTO public.who_global_data VALUES (18271, 0, 2916, 0, 43, 78, 33);
INSERT INTO public.who_global_data VALUES (18272, 1, 224, 0, 9, 78, 183);
INSERT INTO public.who_global_data VALUES (18273, 0, 378, 0, 0, 78, 92);
INSERT INTO public.who_global_data VALUES (18274, 96, 143569, 9, 8875, 78, 158);
INSERT INTO public.who_global_data VALUES (18275, 0, 139, 0, 3, 78, 67);
INSERT INTO public.who_global_data VALUES (18276, 1180, 76757, 64, 2153, 78, 57);
INSERT INTO public.who_global_data VALUES (18277, 491, 9594, 2, 31, 78, 38);
INSERT INTO public.who_global_data VALUES (18278, 34091, 5945849, 756, 167455, 78, 141);
INSERT INTO public.who_global_data VALUES (18279, 0, 72, 0, 1, 78, 178);
INSERT INTO public.who_global_data VALUES (18280, 0, 148, 0, 3, 78, 108);
INSERT INTO public.who_global_data VALUES (18281, 3899, 114435, 119, 2649, 78, 39);
INSERT INTO public.who_global_data VALUES (18282, 16, 2686, 0, 68, 78, 2);
INSERT INTO public.who_global_data VALUES (18283, 7, 649, 0, 1, 78, 195);
INSERT INTO public.who_global_data VALUES (18284, 82, 10082, 0, 104, 78, 107);
INSERT INTO public.who_global_data VALUES (18285, 0, 304, 0, 0, 78, 161);
INSERT INTO public.who_global_data VALUES (18286, 632, 23528, 2, 435, 78, 212);
INSERT INTO public.who_global_data VALUES (18287, 4641, 311109, 100, 11186, 78, 181);
INSERT INTO public.who_global_data VALUES (18288, 1, 258, 0, 2, 78, 53);
INSERT INTO public.who_global_data VALUES (18289, 4, 4911, 0, 63, 78, 164);
INSERT INTO public.who_global_data VALUES (18290, 4, 1620, 0, 101, 78, 140);
INSERT INTO public.who_global_data VALUES (18291, 1454, 536012, 58, 14955, 78, 20);
INSERT INTO public.who_global_data VALUES (18292, 31, 92544, 0, 4749, 78, 112);
INSERT INTO public.who_global_data VALUES (18293, 6875, 1218003, 182, 34563, 78, 111);
INSERT INTO public.who_global_data VALUES (18294, 1, 592, 0, 7, 78, 71);
INSERT INTO public.who_global_data VALUES (18295, 0, 5632, 0, 93, 78, 218);
INSERT INTO public.who_global_data VALUES (18296, 0, 0, 0, 0, 78, 43);
INSERT INTO public.who_global_data VALUES (18297, 1422, 127012, 10, 1588, 78, 49);
INSERT INTO public.who_global_data VALUES (18298, 38, 21083, 0, 129, 78, 1);
INSERT INTO public.who_global_data VALUES (18299, 3164, 93879, 49, 1200, 78, 48);
INSERT INTO public.who_global_data VALUES (18300, 21, 7725, 0, 131, 78, 232);
INSERT INTO public.who_global_data VALUES (18301, 67, 1482, 0, 2, 78, 175);
INSERT INTO public.who_global_data VALUES (18302, 268, 7979, 0, 41, 78, 21);
INSERT INTO public.who_global_data VALUES (18303, 6471, 481755, 134, 6874, 78, 156);
INSERT INTO public.who_global_data VALUES (18304, 0, 0, 0, 0, 78, 95);
INSERT INTO public.who_global_data VALUES (18305, 90, 12007, 0, 323, 78, 177);
INSERT INTO public.who_global_data VALUES (18306, 1297, 67105, 3, 773, 78, 210);
INSERT INTO public.who_global_data VALUES (18307, 0, 5658, 0, 61, 78, 120);
INSERT INTO public.who_global_data VALUES (18308, 4, 72, 0, 0, 78, 135);
INSERT INTO public.who_global_data VALUES (18309, 1026, 136183, 8, 2301, 78, 206);
INSERT INTO public.who_global_data VALUES (18310, 996, 183246, 21, 13073, 78, 189);
INSERT INTO public.who_global_data VALUES (18311, 342, 111955, 13, 6508, 78, 129);
INSERT INTO public.who_global_data VALUES (18312, 0, 36965, 5, 1061, 78, 121);
INSERT INTO public.who_global_data VALUES (18313, 0, 5121, 0, 85, 78, 59);
INSERT INTO public.who_global_data VALUES (18314, 9, 527, 0, 0, 78, 96);
INSERT INTO public.who_global_data VALUES (18315, 411, 8715, 1, 86, 78, 41);
INSERT INTO public.who_global_data VALUES (18316, 12, 6156, 0, 119, 78, 216);
INSERT INTO public.who_global_data VALUES (18317, 499, 104427, 6, 1607, 78, 236);
INSERT INTO public.who_global_data VALUES (18318, 0, 16, 0, 0, 78, 150);
INSERT INTO public.who_global_data VALUES (18319, 0, 498, 0, 0, 78, 61);
INSERT INTO public.who_global_data VALUES (18320, 0, 35, 0, 2, 78, 7);
INSERT INTO public.who_global_data VALUES (18321, 351, 20286, 0, 374, 78, 169);
INSERT INTO public.who_global_data VALUES (18322, 21130, 2048857, 429, 46780, 78, 28);
INSERT INTO public.who_global_data VALUES (18323, 20, 10950, 0, 70, 78, 85);
INSERT INTO public.who_global_data VALUES (18324, 229, 12816, 0, 62, 78, 211);
INSERT INTO public.who_global_data VALUES (18325, 54, 9116, 1, 59, 78, 60);
INSERT INTO public.who_global_data VALUES (18326, 1, 3706, 0, 122, 78, 3);
INSERT INTO public.who_global_data VALUES (18327, 3768, 96860, 41, 894, 78, 11);
INSERT INTO public.who_global_data VALUES (18328, 23648, 879564, 260, 13630, 78, 89);
INSERT INTO public.who_global_data VALUES (18329, 174, 50631, 0, 323, 78, 24);
INSERT INTO public.who_global_data VALUES (18330, 11, 926, 0, 2, 78, 162);
INSERT INTO public.who_global_data VALUES (18331, 3227, 85261, 59, 1347, 78, 100);
INSERT INTO public.who_global_data VALUES (18332, 0, 18, 0, 0, 78, 47);
INSERT INTO public.who_global_data VALUES (18333, 0, 36, 0, 0, 78, 29);
INSERT INTO public.who_global_data VALUES (18334, 0, 8225, 0, 144, 78, 40);
INSERT INTO public.who_global_data VALUES (18335, 70, 6295, 1, 101, 78, 222);
INSERT INTO public.who_global_data VALUES (18336, 685, 117066, 42, 4050, 78, 132);
INSERT INTO public.who_global_data VALUES (18337, 0, 282, 0, 13, 78, 130);
INSERT INTO public.who_global_data VALUES (18338, 30, 12713, 0, 75, 78, 234);
INSERT INTO public.who_global_data VALUES (18339, 0, 2421, 0, 43, 78, 23);
INSERT INTO public.who_global_data VALUES (18340, 24, 4914, 2, 142, 78, 192);
INSERT INTO public.who_global_data VALUES (18341, 17, 9208, 0, 232, 78, 69);
INSERT INTO public.who_global_data VALUES (18342, 0, 26, 0, 0, 78, 187);
INSERT INTO public.who_global_data VALUES (18343, 0, 103488, 0, 2839, 78, 230);
INSERT INTO public.who_global_data VALUES (18344, 4440, 165901, 96, 3568, 78, 77);
INSERT INTO public.who_global_data VALUES (18345, 5, 5231, 0, 25, 78, 9);
INSERT INTO public.who_global_data VALUES (18346, 45882, 9004365, 584, 132162, 78, 74);
INSERT INTO public.who_global_data VALUES (18347, 4798, 483518, 97, 15600, 78, 224);
INSERT INTO public.who_global_data VALUES (18348, 13223, 815117, 476, 43417, 78, 199);
INSERT INTO public.who_global_data VALUES (18349, 2374, 529226, 39, 11834, 78, 190);
INSERT INTO public.who_global_data VALUES (18350, 415, 69473, 4, 2010, 78, 12);
INSERT INTO public.who_global_data VALUES (18351, 0, 364, 0, 25, 78, 104);
INSERT INTO public.who_global_data VALUES (18352, 795, 326595, 7, 2775, 78, 153);
INSERT INTO public.who_global_data VALUES (18353, 36176, 1308528, 653, 47870, 78, 91);
INSERT INTO public.who_global_data VALUES (18354, 69, 10088, 2, 235, 78, 215);
INSERT INTO public.who_global_data VALUES (18355, 2301, 125267, 21, 1943, 78, 84);
INSERT INTO public.who_global_data VALUES (18356, 11, 782, 0, 32, 78, 231);
INSERT INTO public.who_global_data VALUES (18357, 5470, 169396, 84, 2053, 78, 196);
INSERT INTO public.who_global_data VALUES (18358, 976, 165712, 0, 2365, 78, 105);
INSERT INTO public.who_global_data VALUES (18359, 1459, 74145, 17, 1330, 78, 122);
INSERT INTO public.who_global_data VALUES (18360, 0, 0, 0, 0, 78, 159);
INSERT INTO public.who_global_data VALUES (18361, 807, 31979, 14, 864, 78, 75);
INSERT INTO public.who_global_data VALUES (18362, 485, 138822, 2, 859, 78, 27);
INSERT INTO public.who_global_data VALUES (18363, 386, 68702, 6, 1223, 78, 54);
INSERT INTO public.who_global_data VALUES (18364, 0, 25, 0, 0, 78, 226);
INSERT INTO public.who_global_data VALUES (18365, 366, 11722, 4, 141, 78, 79);
INSERT INTO public.who_global_data VALUES (18366, 1909, 111946, 16, 868, 78, 56);
INSERT INTO public.who_global_data VALUES (18367, 17, 2058, 0, 44, 78, 117);
INSERT INTO public.who_global_data VALUES (18368, 22, 1539, 0, 82, 78, 152);
INSERT INTO public.who_global_data VALUES (18369, 541, 76006, 9, 1062, 78, 16);
INSERT INTO public.who_global_data VALUES (18370, 19, 1121, 0, 8, 78, 10);
INSERT INTO public.who_global_data VALUES (18371, 2269, 42724, 19, 394, 78, 201);
INSERT INTO public.who_global_data VALUES (18372, 892, 28573, 8, 248, 78, 174);
INSERT INTO public.who_global_data VALUES (18373, 0, 17310, 0, 250, 78, 119);
INSERT INTO public.who_global_data VALUES (18374, 4, 6002, 0, 185, 78, 168);
INSERT INTO public.who_global_data VALUES (18375, 1290, 51680, 4, 326, 78, 99);
INSERT INTO public.who_global_data VALUES (18376, 68, 12452, 0, 45, 78, 171);
INSERT INTO public.who_global_data VALUES (18377, 113, 4093, 1, 142, 78, 87);
INSERT INTO public.who_global_data VALUES (18378, 121, 8670, 2, 103, 78, 123);
INSERT INTO public.who_global_data VALUES (18379, 0, 4, 0, 0, 78, 151);
INSERT INTO public.who_global_data VALUES (18380, 0, 5091, 0, 39, 78, 213);
INSERT INTO public.who_global_data VALUES (18381, 0, 7952, 0, 165, 78, 118);
INSERT INTO public.who_global_data VALUES (18382, 0, 491, 0, 10, 78, 134);
INSERT INTO public.who_global_data VALUES (18383, 0, 5036, 0, 48, 78, 65);
INSERT INTO public.who_global_data VALUES (18384, 3918, 1015071, 502, 99528, 78, 102);
INSERT INTO public.who_global_data VALUES (18385, 0, 0, 0, 0, 78, 223);
INSERT INTO public.who_global_data VALUES (18386, 8, 576, 0, 3, 78, 4);
INSERT INTO public.who_global_data VALUES (18387, 45, 518, 0, 0, 78, 146);
INSERT INTO public.who_global_data VALUES (18388, 621, 30609, 9, 428, 78, 31);
INSERT INTO public.who_global_data VALUES (18389, 0, 13, 0, 1, 78, 127);
INSERT INTO public.who_global_data VALUES (18390, 4559, 311554, 77, 5090, 78, 22);
INSERT INTO public.who_global_data VALUES (18391, 94, 14723, 1, 120, 78, 115);
INSERT INTO public.who_global_data VALUES (18392, 1560, 74882, 26, 1676, 78, 106);
INSERT INTO public.who_global_data VALUES (18393, 52, 13662, 1, 141, 78, 90);
INSERT INTO public.who_global_data VALUES (18394, 0, 0, 0, 0, 78, 70);
INSERT INTO public.who_global_data VALUES (18395, 2103, 215020, 17, 1276, 78, 46);
INSERT INTO public.who_global_data VALUES (18396, 5688, 466111, 75, 8753, 78, 139);
INSERT INTO public.who_global_data VALUES (18397, 0, 30, 0, 0, 78, 42);
INSERT INTO public.who_global_data VALUES (18398, 3, 1657, 0, 25, 78, 80);
INSERT INTO public.who_global_data VALUES (18399, 0, 4583, 0, 159, 78, 203);
INSERT INTO public.who_global_data VALUES (18400, 4, 1335, 0, 70, 78, 136);
INSERT INTO public.who_global_data VALUES (18401, 146, 65839, 2, 1165, 78, 63);
INSERT INTO public.who_global_data VALUES (18402, 0, 0, 0, 0, 78, 17);
INSERT INTO public.who_global_data VALUES (18403, 0, 103, 0, 2, 78, 172);
INSERT INTO public.who_global_data VALUES (18404, 1198, 51213, 26, 1423, 78, 109);
INSERT INTO public.who_global_data VALUES (18405, 655, 30768, 6, 305, 78, 200);
INSERT INTO public.who_global_data VALUES (18406, 1251, 79822, 9, 676, 78, 93);
INSERT INTO public.who_global_data VALUES (18407, 231, 121360, 5, 1365, 78, 5);
INSERT INTO public.who_global_data VALUES (18408, 0, 741, 0, 13, 78, 214);
INSERT INTO public.who_global_data VALUES (18409, 2547, 365927, 18, 7248, 78, 204);
INSERT INTO public.who_global_data VALUES (18410, 0, 0, 0, 0, 78, 198);
INSERT INTO public.who_global_data VALUES (18411, 1112, 149833, 14, 2907, 78, 173);
INSERT INTO public.who_global_data VALUES (18412, 0, 604, 0, 7, 78, 229);
INSERT INTO public.who_global_data VALUES (18413, 782, 73639, 11, 1624, 78, 76);
INSERT INTO public.who_global_data VALUES (18414, 2020, 941951, 85, 35402, 78, 138);
INSERT INTO public.who_global_data VALUES (18415, 1333, 413430, 41, 7998, 78, 98);
INSERT INTO public.who_global_data VALUES (18416, 0, 0, 0, 0, 78, 103);
INSERT INTO public.who_global_data VALUES (18417, 23975, 796798, 637, 12088, 78, 225);
INSERT INTO public.who_global_data VALUES (18418, 6994, 243009, 69, 3701, 78, 131);
INSERT INTO public.who_global_data VALUES (18419, 521, 44431, 11, 982, 78, 235);
INSERT INTO public.who_global_data VALUES (18420, 208, 136649, 0, 235, 78, 137);
INSERT INTO public.who_global_data VALUES (18421, 348, 29954, 3, 501, 78, 81);
INSERT INTO public.who_global_data VALUES (18422, 1442, 93961, 19, 2091, 78, 182);
INSERT INTO public.who_global_data VALUES (18423, 0, 7298, 0, 34, 78, 145);
INSERT INTO public.who_global_data VALUES (18424, 10108, 393851, 167, 9596, 78, 26);
INSERT INTO public.who_global_data VALUES (18425, 24318, 2039926, 461, 35311, 78, 170);
INSERT INTO public.who_global_data VALUES (18426, 0, 5543, 0, 46, 78, 191);
INSERT INTO public.who_global_data VALUES (18427, 0, 5, 0, 0, 78, 221);
INSERT INTO public.who_global_data VALUES (18428, 0, 127, 0, 0, 78, 64);
INSERT INTO public.who_global_data VALUES (18429, 0, 0, 0, 0, 78, 116);
INSERT INTO public.who_global_data VALUES (18430, 0, 19, 0, 0, 78, 128);
INSERT INTO public.who_global_data VALUES (18431, 20, 203, 0, 2, 78, 6);
INSERT INTO public.who_global_data VALUES (18432, 0, 690, 0, 12, 78, 227);
INSERT INTO public.who_global_data VALUES (18433, 0, 14, 0, 0, 78, 68);
INSERT INTO public.who_global_data VALUES (18434, 0, 83, 0, 0, 78, 184);
INSERT INTO public.who_global_data VALUES (18435, 0, 0, 0, 0, 78, 82);
INSERT INTO public.who_global_data VALUES (18436, 15, 1373, 0, 43, 78, 149);
INSERT INTO public.who_global_data VALUES (18437, 7, 974, 0, 16, 78, 197);
INSERT INTO public.who_global_data VALUES (18438, 319, 354527, 19, 5729, 78, 78);
INSERT INTO public.who_global_data VALUES (18439, 12, 15835, 0, 329, 78, 233);
INSERT INTO public.who_global_data VALUES (18440, 6109, 104097, 29, 1110, 78, 133);
INSERT INTO public.who_global_data VALUES (18441, 0, 161, 0, 0, 78, 35);
INSERT INTO public.who_global_data VALUES (18442, 0, 2397, 0, 74, 78, 114);
INSERT INTO public.who_global_data VALUES (18443, 4, 58139, 0, 28, 78, 237);
INSERT INTO public.who_global_data VALUES (18444, 0, 14, 0, 0, 78, 55);
INSERT INTO public.who_global_data VALUES (18445, 10, 964, 0, 24, 78, 176);
INSERT INTO public.who_global_data VALUES (18446, 1665, 91578, 0, 579, 78, 202);
INSERT INTO public.who_global_data VALUES (18447, 1549, 62611, 37, 1081, 78, 155);
INSERT INTO public.who_global_data VALUES (18448, 0, 16, 0, 0, 78, 32);
INSERT INTO public.who_global_data VALUES (18449, 0, 4382, 0, 108, 78, 220);
INSERT INTO public.who_global_data VALUES (18450, 2514, 759658, 115, 20671, 78, 30);
INSERT INTO public.who_global_data VALUES (18451, 0, 3016, 0, 59, 78, 147);
INSERT INTO public.who_global_data VALUES (18452, 14862, 1613125, 265, 44291, 78, 208);
INSERT INTO public.who_global_data VALUES (18453, 439, 18841, 4, 73, 78, 45);
INSERT INTO public.who_global_data VALUES (18454, 309, 15839, 8, 1193, 78, 110);
INSERT INTO public.who_global_data VALUES (18455, 4, 5282, 0, 116, 78, 88);
INSERT INTO public.who_global_data VALUES (18456, 4961, 202016, 50, 6579, 78, 51);
INSERT INTO public.who_global_data VALUES (18457, 4493, 291993, 79, 3846, 78, 209);
INSERT INTO public.who_global_data VALUES (18458, 72, 6991, 5, 363, 78, 205);
INSERT INTO public.who_global_data VALUES (18459, 41, 11772, 0, 86, 78, 18);
INSERT INTO public.who_global_data VALUES (18460, 4, 3892, 0, 60, 78, 72);
INSERT INTO public.who_global_data VALUES (18461, 22915, 1453260, 501, 53775, 78, 44);
INSERT INTO public.who_global_data VALUES (18462, 0, 30, 0, 0, 78, 15);
INSERT INTO public.who_global_data VALUES (18463, 19, 2771, 0, 63, 78, 25);
INSERT INTO public.who_global_data VALUES (18464, 0, 0, 0, 0, 78, 179);
INSERT INTO public.who_global_data VALUES (18465, 0, 0, 0, 0, 78, 34);
INSERT INTO public.who_global_data VALUES (18466, 45, 6180, 0, 113, 78, 207);
INSERT INTO public.who_global_data VALUES (18467, 1270, 85042, 73, 2614, 78, 166);
INSERT INTO public.who_global_data VALUES (18468, 11273, 1204122, 123, 11943, 78, 126);
INSERT INTO public.who_global_data VALUES (18469, 0, 0, 0, 0, 78, 97);
INSERT INTO public.who_global_data VALUES (18470, 0, 721, 0, 6, 78, 36);
INSERT INTO public.who_global_data VALUES (18471, 0, 0, 0, 0, 78, 125);
INSERT INTO public.who_global_data VALUES (18472, 243, 17148, 1, 158, 78, 124);
INSERT INTO public.who_global_data VALUES (18473, 14575, 598085, 229, 10598, 78, 185);
INSERT INTO public.who_global_data VALUES (18474, 1153, 155254, 2, 544, 78, 194);
INSERT INTO public.who_global_data VALUES (18475, 0, 509, 0, 21, 78, 144);
INSERT INTO public.who_global_data VALUES (18476, 164560, 11413788, 1825, 248571, 78, 19);
INSERT INTO public.who_global_data VALUES (18477, 6, 1469, 0, 23, 78, 217);
INSERT INTO public.who_global_data VALUES (18478, 88, 4296, 0, 68, 78, 148);
INSERT INTO public.who_global_data VALUES (18479, 213, 71071, 1, 602, 78, 86);
INSERT INTO public.who_global_data VALUES (18480, 0, 1, 0, 0, 78, 13);
INSERT INTO public.who_global_data VALUES (18481, 300, 98350, 2, 860, 78, 157);
INSERT INTO public.who_global_data VALUES (18482, 4, 1304, 0, 35, 78, 8);
INSERT INTO public.who_global_data VALUES (18483, 0, 2, 0, 0, 78, 73);
INSERT INTO public.who_global_data VALUES (18484, 0, 2072, 1, 605, 78, 101);
INSERT INTO public.who_global_data VALUES (18485, 70, 17350, 0, 356, 78, 165);
INSERT INTO public.who_global_data VALUES (18486, 65, 9046, 4, 265, 78, 14);
INSERT INTO public.who_global_data VALUES (18487, 223, 43851, 7, 1645, 79, 193);
INSERT INTO public.who_global_data VALUES (18488, 711, 29837, 9, 646, 79, 113);
INSERT INTO public.who_global_data VALUES (18489, 1038, 70629, 20, 2206, 79, 143);
INSERT INTO public.who_global_data VALUES (18490, 0, 0, 0, 0, 79, 219);
INSERT INTO public.who_global_data VALUES (18491, 67, 6018, 0, 76, 79, 186);
INSERT INTO public.who_global_data VALUES (18492, 104, 13922, 4, 332, 79, 52);
INSERT INTO public.who_global_data VALUES (18493, 0, 3, 0, 0, 79, 180);
INSERT INTO public.who_global_data VALUES (18494, 4, 138, 0, 4, 79, 167);
INSERT INTO public.who_global_data VALUES (18495, 10621, 1329005, 379, 36106, 79, 154);
INSERT INTO public.who_global_data VALUES (18496, 1520, 121292, 31, 1865, 79, 94);
INSERT INTO public.who_global_data VALUES (18497, 8, 4676, 0, 44, 79, 66);
INSERT INTO public.who_global_data VALUES (18498, 21, 27777, 0, 907, 79, 58);
INSERT INTO public.who_global_data VALUES (18499, 7766, 221228, 113, 1928, 79, 163);
INSERT INTO public.who_global_data VALUES (18500, 2239, 81397, 25, 1030, 79, 37);
INSERT INTO public.who_global_data VALUES (18501, 11, 7323, 0, 163, 79, 142);
INSERT INTO public.who_global_data VALUES (18502, 174, 85182, 0, 337, 79, 83);
INSERT INTO public.who_global_data VALUES (18503, 2111, 438795, 21, 6275, 79, 228);
INSERT INTO public.who_global_data VALUES (18504, 0, 250, 0, 7, 79, 188);
INSERT INTO public.who_global_data VALUES (18505, 1309, 118008, 7, 1067, 79, 62);
INSERT INTO public.who_global_data VALUES (18506, 3703, 553783, 158, 15250, 79, 160);
INSERT INTO public.who_global_data VALUES (18507, 37, 4920, 2, 96, 79, 50);
INSERT INTO public.who_global_data VALUES (18508, 0, 2916, 0, 43, 79, 33);
INSERT INTO public.who_global_data VALUES (18509, 0, 223, 0, 9, 79, 183);
INSERT INTO public.who_global_data VALUES (18510, 0, 378, 0, 0, 79, 92);
INSERT INTO public.who_global_data VALUES (18511, 102, 143473, 7, 8866, 79, 158);
INSERT INTO public.who_global_data VALUES (18512, 1, 139, 0, 3, 79, 67);
INSERT INTO public.who_global_data VALUES (18513, 1633, 75577, 47, 2089, 79, 57);
INSERT INTO public.who_global_data VALUES (18514, 0, 9103, 0, 29, 79, 38);
INSERT INTO public.who_global_data VALUES (18515, 35294, 5911758, 685, 166699, 79, 141);
INSERT INTO public.who_global_data VALUES (18516, 0, 72, 0, 1, 79, 178);
INSERT INTO public.who_global_data VALUES (18517, 0, 148, 0, 3, 79, 108);
INSERT INTO public.who_global_data VALUES (18518, 3938, 110536, 117, 2530, 79, 39);
INSERT INTO public.who_global_data VALUES (18519, 18, 2670, 0, 68, 79, 2);
INSERT INTO public.who_global_data VALUES (18520, 0, 642, 0, 1, 79, 195);
INSERT INTO public.who_global_data VALUES (18521, 40, 10000, 1, 104, 79, 107);
INSERT INTO public.who_global_data VALUES (18522, 0, 304, 0, 0, 79, 161);
INSERT INTO public.who_global_data VALUES (18523, 0, 22896, 0, 433, 79, 212);
INSERT INTO public.who_global_data VALUES (18524, 4276, 306468, 59, 11086, 79, 181);
INSERT INTO public.who_global_data VALUES (18525, 0, 257, 0, 2, 79, 53);
INSERT INTO public.who_global_data VALUES (18526, 7, 4907, 0, 63, 79, 164);
INSERT INTO public.who_global_data VALUES (18527, 8, 1616, 0, 101, 79, 140);
INSERT INTO public.who_global_data VALUES (18528, 948, 534558, 14, 14897, 79, 20);
INSERT INTO public.who_global_data VALUES (18529, 23, 92513, 0, 4749, 79, 112);
INSERT INTO public.who_global_data VALUES (18530, 5911, 1211128, 158, 34381, 79, 111);
INSERT INTO public.who_global_data VALUES (18531, 12, 591, 0, 7, 79, 71);
INSERT INTO public.who_global_data VALUES (18532, 117, 5632, 1, 93, 79, 218);
INSERT INTO public.who_global_data VALUES (18533, 0, 0, 0, 0, 79, 43);
INSERT INTO public.who_global_data VALUES (18534, 998, 125590, 12, 1578, 79, 49);
INSERT INTO public.who_global_data VALUES (18535, 41, 21045, 0, 129, 79, 1);
INSERT INTO public.who_global_data VALUES (18536, 3251, 90715, 38, 1151, 79, 48);
INSERT INTO public.who_global_data VALUES (18537, 37, 7704, 0, 131, 79, 232);
INSERT INTO public.who_global_data VALUES (18538, 41, 1415, 0, 2, 79, 175);
INSERT INTO public.who_global_data VALUES (18539, 198, 7711, 1, 41, 79, 21);
INSERT INTO public.who_global_data VALUES (18540, 5515, 475284, 182, 6740, 79, 156);
INSERT INTO public.who_global_data VALUES (18541, 0, 0, 0, 0, 79, 95);
INSERT INTO public.who_global_data VALUES (18542, 52, 11917, 1, 323, 79, 177);
INSERT INTO public.who_global_data VALUES (18543, 1257, 65808, 2, 770, 79, 210);
INSERT INTO public.who_global_data VALUES (18544, 2, 5658, 0, 61, 79, 120);
INSERT INTO public.who_global_data VALUES (18545, 0, 68, 0, 0, 79, 135);
INSERT INTO public.who_global_data VALUES (18546, 460, 135157, 3, 2293, 79, 206);
INSERT INTO public.who_global_data VALUES (18547, 1146, 182250, 27, 13052, 79, 189);
INSERT INTO public.who_global_data VALUES (18548, 329, 111613, 14, 6495, 79, 129);
INSERT INTO public.who_global_data VALUES (18549, 296, 36965, 4, 1056, 79, 121);
INSERT INTO public.who_global_data VALUES (18550, 0, 5121, 0, 85, 79, 59);
INSERT INTO public.who_global_data VALUES (18551, 0, 518, 0, 0, 79, 96);
INSERT INTO public.who_global_data VALUES (18552, 271, 8304, 1, 85, 79, 41);
INSERT INTO public.who_global_data VALUES (18553, 20, 6144, 0, 119, 79, 216);
INSERT INTO public.who_global_data VALUES (18554, 533, 103928, 13, 1601, 79, 236);
INSERT INTO public.who_global_data VALUES (18555, 1, 16, 0, 0, 79, 150);
INSERT INTO public.who_global_data VALUES (18556, 0, 498, 0, 0, 79, 61);
INSERT INTO public.who_global_data VALUES (18557, 0, 35, 0, 2, 79, 7);
INSERT INTO public.who_global_data VALUES (18558, 288, 19935, 3, 374, 79, 169);
INSERT INTO public.who_global_data VALUES (18559, 27667, 2027727, 413, 46351, 79, 28);
INSERT INTO public.who_global_data VALUES (18560, 30, 10930, 0, 70, 79, 85);
INSERT INTO public.who_global_data VALUES (18561, 225, 12587, 1, 62, 79, 211);
INSERT INTO public.who_global_data VALUES (18562, 0, 9062, 0, 58, 79, 60);
INSERT INTO public.who_global_data VALUES (18563, 0, 3705, 0, 122, 79, 3);
INSERT INTO public.who_global_data VALUES (18564, 3697, 93092, 38, 853, 79, 11);
INSERT INTO public.who_global_data VALUES (18565, 22609, 855916, 251, 13370, 79, 89);
INSERT INTO public.who_global_data VALUES (18566, 0, 50457, 0, 323, 79, 24);
INSERT INTO public.who_global_data VALUES (18567, 8, 915, 1, 2, 79, 162);
INSERT INTO public.who_global_data VALUES (18568, 3209, 82034, 60, 1288, 79, 100);
INSERT INTO public.who_global_data VALUES (18569, 0, 18, 0, 0, 79, 47);
INSERT INTO public.who_global_data VALUES (18570, 3, 36, 0, 0, 79, 29);
INSERT INTO public.who_global_data VALUES (18571, 44, 8225, 5, 144, 79, 40);
INSERT INTO public.who_global_data VALUES (18572, 104, 6225, 0, 100, 79, 222);
INSERT INTO public.who_global_data VALUES (18573, 651, 116381, 61, 4008, 79, 132);
INSERT INTO public.who_global_data VALUES (18574, 0, 282, 0, 13, 79, 130);
INSERT INTO public.who_global_data VALUES (18575, 29, 12683, 0, 75, 79, 234);
INSERT INTO public.who_global_data VALUES (18576, 0, 2421, 0, 43, 79, 23);
INSERT INTO public.who_global_data VALUES (18577, 16, 4890, 1, 140, 79, 192);
INSERT INTO public.who_global_data VALUES (18578, 0, 9191, 0, 232, 79, 69);
INSERT INTO public.who_global_data VALUES (18579, 0, 26, 0, 0, 79, 187);
INSERT INTO public.who_global_data VALUES (18580, 249, 103488, 0, 2839, 79, 230);
INSERT INTO public.who_global_data VALUES (18581, 4512, 161461, 92, 3472, 79, 77);
INSERT INTO public.who_global_data VALUES (18582, 11, 5226, 0, 25, 79, 9);
INSERT INTO public.who_global_data VALUES (18583, 45576, 8958483, 585, 131578, 79, 74);
INSERT INTO public.who_global_data VALUES (18584, 4265, 478720, 110, 15503, 79, 224);
INSERT INTO public.who_global_data VALUES (18585, 13421, 801894, 480, 42941, 79, 199);
INSERT INTO public.who_global_data VALUES (18586, 2349, 526852, 43, 11795, 79, 190);
INSERT INTO public.who_global_data VALUES (18587, 372, 69058, 11, 2006, 79, 12);
INSERT INTO public.who_global_data VALUES (18588, 0, 364, 0, 25, 79, 104);
INSERT INTO public.who_global_data VALUES (18589, 829, 325800, 12, 2768, 79, 153);
INSERT INTO public.who_global_data VALUES (18590, 34280, 1272352, 753, 47217, 79, 91);
INSERT INTO public.who_global_data VALUES (18591, 60, 10019, 2, 233, 79, 215);
INSERT INTO public.who_global_data VALUES (18592, 2151, 122966, 9, 1922, 79, 84);
INSERT INTO public.who_global_data VALUES (18593, 10, 771, 0, 32, 79, 231);
INSERT INTO public.who_global_data VALUES (18594, 7933, 163926, 60, 1969, 79, 196);
INSERT INTO public.who_global_data VALUES (18595, 949, 164736, 0, 2365, 79, 105);
INSERT INTO public.who_global_data VALUES (18596, 957, 72686, 11, 1313, 79, 122);
INSERT INTO public.who_global_data VALUES (18597, 0, 0, 0, 0, 79, 159);
INSERT INTO public.who_global_data VALUES (18598, 720, 31172, 11, 850, 79, 75);
INSERT INTO public.who_global_data VALUES (18599, 452, 138337, 9, 857, 79, 27);
INSERT INTO public.who_global_data VALUES (18600, 422, 68316, 5, 1217, 79, 54);
INSERT INTO public.who_global_data VALUES (18601, 0, 25, 0, 0, 79, 226);
INSERT INTO public.who_global_data VALUES (18602, 442, 11356, 5, 137, 79, 79);
INSERT INTO public.who_global_data VALUES (18603, 2084, 110037, 13, 852, 79, 56);
INSERT INTO public.who_global_data VALUES (18604, 74, 2041, 0, 44, 79, 117);
INSERT INTO public.who_global_data VALUES (18605, 5, 1517, 0, 82, 79, 152);
INSERT INTO public.who_global_data VALUES (18606, 529, 75465, 12, 1053, 79, 16);
INSERT INTO public.who_global_data VALUES (18607, 19, 1102, 0, 8, 79, 10);
INSERT INTO public.who_global_data VALUES (18608, 1668, 40455, 23, 375, 79, 201);
INSERT INTO public.who_global_data VALUES (18609, 425, 27681, 4, 240, 79, 174);
INSERT INTO public.who_global_data VALUES (18610, 0, 17310, 0, 250, 79, 119);
INSERT INTO public.who_global_data VALUES (18611, 27, 5998, 0, 185, 79, 168);
INSERT INTO public.who_global_data VALUES (18612, 660, 50390, 4, 322, 79, 99);
INSERT INTO public.who_global_data VALUES (18613, 29, 12384, 0, 45, 79, 171);
INSERT INTO public.who_global_data VALUES (18614, 0, 3980, 0, 141, 79, 87);
INSERT INTO public.who_global_data VALUES (18615, 140, 8549, 2, 101, 79, 123);
INSERT INTO public.who_global_data VALUES (18616, 0, 4, 0, 0, 79, 151);
INSERT INTO public.who_global_data VALUES (18617, 359, 5091, 2, 39, 79, 213);
INSERT INTO public.who_global_data VALUES (18618, 0, 7952, 0, 165, 79, 118);
INSERT INTO public.who_global_data VALUES (18619, 0, 491, 0, 10, 79, 134);
INSERT INTO public.who_global_data VALUES (18620, 93, 5036, 2, 48, 79, 65);
INSERT INTO public.who_global_data VALUES (18621, 1757, 1011153, 165, 99026, 79, 102);
INSERT INTO public.who_global_data VALUES (18622, 0, 0, 0, 0, 79, 223);
INSERT INTO public.who_global_data VALUES (18623, 8, 568, 0, 3, 79, 4);
INSERT INTO public.who_global_data VALUES (18624, 33, 473, 0, 0, 79, 146);
INSERT INTO public.who_global_data VALUES (18625, 536, 29988, 6, 419, 79, 31);
INSERT INTO public.who_global_data VALUES (18626, 0, 13, 0, 1, 79, 127);
INSERT INTO public.who_global_data VALUES (18627, 5391, 306995, 81, 5013, 79, 22);
INSERT INTO public.who_global_data VALUES (18628, 63, 14629, 1, 119, 79, 115);
INSERT INTO public.who_global_data VALUES (18629, 1592, 73322, 25, 1650, 79, 106);
INSERT INTO public.who_global_data VALUES (18630, 44, 13610, 0, 140, 79, 90);
INSERT INTO public.who_global_data VALUES (18631, 0, 0, 0, 0, 79, 70);
INSERT INTO public.who_global_data VALUES (18632, 1442, 212917, 12, 1259, 79, 46);
INSERT INTO public.who_global_data VALUES (18633, 4587, 460423, 82, 8678, 79, 139);
INSERT INTO public.who_global_data VALUES (18634, 0, 30, 0, 0, 79, 42);
INSERT INTO public.who_global_data VALUES (18635, 2, 1654, 0, 25, 79, 80);
INSERT INTO public.who_global_data VALUES (18636, 0, 4583, 0, 159, 79, 203);
INSERT INTO public.who_global_data VALUES (18637, 4, 1331, 0, 70, 79, 136);
INSERT INTO public.who_global_data VALUES (18638, 236, 65693, 0, 1163, 79, 63);
INSERT INTO public.who_global_data VALUES (18639, 0, 0, 0, 0, 79, 17);
INSERT INTO public.who_global_data VALUES (18640, 0, 103, 0, 2, 79, 172);
INSERT INTO public.who_global_data VALUES (18641, 1402, 50015, 21, 1397, 79, 109);
INSERT INTO public.who_global_data VALUES (18642, 603, 30113, 1, 299, 79, 200);
INSERT INTO public.who_global_data VALUES (18643, 1251, 78571, 9, 667, 79, 93);
INSERT INTO public.who_global_data VALUES (18644, 411, 121129, 10, 1360, 79, 5);
INSERT INTO public.who_global_data VALUES (18645, 0, 741, 0, 13, 79, 214);
INSERT INTO public.who_global_data VALUES (18646, 2298, 363380, 37, 7230, 79, 204);
INSERT INTO public.who_global_data VALUES (18647, 0, 0, 0, 0, 79, 198);
INSERT INTO public.who_global_data VALUES (18648, 1054, 148721, 12, 2893, 79, 173);
INSERT INTO public.who_global_data VALUES (18649, 0, 604, 0, 7, 79, 229);
INSERT INTO public.who_global_data VALUES (18650, 758, 72857, 11, 1613, 79, 76);
INSERT INTO public.who_global_data VALUES (18651, 1663, 939931, 46, 35317, 79, 138);
INSERT INTO public.who_global_data VALUES (18652, 1379, 412097, 95, 7957, 79, 98);
INSERT INTO public.who_global_data VALUES (18653, 0, 0, 0, 0, 79, 103);
INSERT INTO public.who_global_data VALUES (18654, 19883, 772823, 603, 11451, 79, 225);
INSERT INTO public.who_global_data VALUES (18655, 5891, 236015, 79, 3632, 79, 131);
INSERT INTO public.who_global_data VALUES (18656, 325, 43910, 20, 971, 79, 235);
INSERT INTO public.who_global_data VALUES (18657, 219, 136441, 0, 235, 79, 137);
INSERT INTO public.who_global_data VALUES (18658, 325, 29606, 2, 498, 79, 81);
INSERT INTO public.who_global_data VALUES (18659, 1607, 92519, 18, 2072, 79, 182);
INSERT INTO public.who_global_data VALUES (18660, 137, 7298, 3, 34, 79, 145);
INSERT INTO public.who_global_data VALUES (18661, 10269, 383743, 168, 9429, 79, 26);
INSERT INTO public.who_global_data VALUES (18662, 23610, 2015608, 463, 34850, 79, 170);
INSERT INTO public.who_global_data VALUES (18663, 36, 5543, 0, 46, 79, 191);
INSERT INTO public.who_global_data VALUES (18664, 0, 5, 0, 0, 79, 221);
INSERT INTO public.who_global_data VALUES (18665, 18, 127, 0, 0, 79, 64);
INSERT INTO public.who_global_data VALUES (18666, 0, 0, 0, 0, 79, 116);
INSERT INTO public.who_global_data VALUES (18667, 0, 19, 0, 0, 79, 128);
INSERT INTO public.who_global_data VALUES (18668, 5, 183, 0, 2, 79, 6);
INSERT INTO public.who_global_data VALUES (18669, 35, 690, 0, 12, 79, 227);
INSERT INTO public.who_global_data VALUES (18670, 0, 14, 0, 0, 79, 68);
INSERT INTO public.who_global_data VALUES (18671, 5, 83, 0, 0, 79, 184);
INSERT INTO public.who_global_data VALUES (18672, 0, 0, 0, 0, 79, 82);
INSERT INTO public.who_global_data VALUES (18673, 37, 1358, 0, 43, 79, 149);
INSERT INTO public.who_global_data VALUES (18674, 0, 967, 0, 16, 79, 197);
INSERT INTO public.who_global_data VALUES (18675, 290, 354208, 18, 5710, 79, 78);
INSERT INTO public.who_global_data VALUES (18676, 17, 15823, 0, 329, 79, 233);
INSERT INTO public.who_global_data VALUES (18677, 5613, 97988, 27, 1081, 79, 133);
INSERT INTO public.who_global_data VALUES (18678, 0, 161, 0, 0, 79, 35);
INSERT INTO public.who_global_data VALUES (18679, 6, 2397, 0, 74, 79, 114);
INSERT INTO public.who_global_data VALUES (18680, 5, 58135, 0, 28, 79, 237);
INSERT INTO public.who_global_data VALUES (18681, 0, 14, 0, 0, 79, 55);
INSERT INTO public.who_global_data VALUES (18682, 15, 954, 0, 24, 79, 176);
INSERT INTO public.who_global_data VALUES (18683, 1311, 89913, 22, 579, 79, 202);
INSERT INTO public.who_global_data VALUES (18684, 2068, 61062, 43, 1044, 79, 155);
INSERT INTO public.who_global_data VALUES (18685, 0, 16, 0, 0, 79, 32);
INSERT INTO public.who_global_data VALUES (18686, 0, 4382, 0, 108, 79, 220);
INSERT INTO public.who_global_data VALUES (18687, 2888, 757144, 123, 20556, 79, 30);
INSERT INTO public.who_global_data VALUES (18688, 0, 3016, 0, 59, 79, 147);
INSERT INTO public.who_global_data VALUES (18689, 16015, 1598263, 343, 44026, 79, 208);
INSERT INTO public.who_global_data VALUES (18690, 327, 18402, 3, 69, 79, 45);
INSERT INTO public.who_global_data VALUES (18691, 231, 15530, 6, 1185, 79, 110);
INSERT INTO public.who_global_data VALUES (18692, 3, 5278, 1, 116, 79, 88);
INSERT INTO public.who_global_data VALUES (18693, 4458, 197055, 44, 6529, 79, 51);
INSERT INTO public.who_global_data VALUES (18694, 4858, 287500, 103, 3767, 79, 209);
INSERT INTO public.who_global_data VALUES (18695, 83, 6919, 4, 358, 79, 205);
INSERT INTO public.who_global_data VALUES (18696, 42, 11731, 1, 86, 79, 18);
INSERT INTO public.who_global_data VALUES (18697, 8, 3888, 0, 60, 79, 72);
INSERT INTO public.who_global_data VALUES (18698, 19609, 1430345, 529, 53274, 79, 44);
INSERT INTO public.who_global_data VALUES (18699, 0, 30, 0, 0, 79, 15);
INSERT INTO public.who_global_data VALUES (18700, 30, 2752, 1, 63, 79, 25);
INSERT INTO public.who_global_data VALUES (18701, 0, 0, 0, 0, 79, 179);
INSERT INTO public.who_global_data VALUES (18702, 0, 0, 0, 0, 79, 34);
INSERT INTO public.who_global_data VALUES (18703, 39, 6135, 1, 113, 79, 207);
INSERT INTO public.who_global_data VALUES (18704, 2049, 83772, 96, 2541, 79, 166);
INSERT INTO public.who_global_data VALUES (18705, 10946, 1192849, 116, 11820, 79, 126);
INSERT INTO public.who_global_data VALUES (18706, 0, 0, 0, 0, 79, 97);
INSERT INTO public.who_global_data VALUES (18707, 1, 721, 0, 6, 79, 36);
INSERT INTO public.who_global_data VALUES (18708, 0, 0, 0, 0, 79, 125);
INSERT INTO public.who_global_data VALUES (18709, 342, 16905, 7, 157, 79, 124);
INSERT INTO public.who_global_data VALUES (18710, 13357, 583510, 257, 10369, 79, 185);
INSERT INTO public.who_global_data VALUES (18711, 1292, 154101, 4, 542, 79, 194);
INSERT INTO public.who_global_data VALUES (18712, 0, 509, 0, 21, 79, 144);
INSERT INTO public.who_global_data VALUES (18713, 164044, 11249228, 1582, 246746, 79, 19);
INSERT INTO public.who_global_data VALUES (18714, 13, 1463, 0, 23, 79, 217);
INSERT INTO public.who_global_data VALUES (18715, 104, 4208, 1, 68, 79, 148);
INSERT INTO public.who_global_data VALUES (18716, 210, 70858, 2, 601, 79, 86);
INSERT INTO public.who_global_data VALUES (18717, 0, 1, 0, 0, 79, 13);
INSERT INTO public.who_global_data VALUES (18718, 311, 98050, 3, 858, 79, 157);
INSERT INTO public.who_global_data VALUES (18719, 12, 1300, 0, 35, 79, 8);
INSERT INTO public.who_global_data VALUES (18720, 0, 2, 0, 0, 79, 73);
INSERT INTO public.who_global_data VALUES (18721, 0, 2072, 0, 604, 79, 101);
INSERT INTO public.who_global_data VALUES (18722, 37, 17280, 3, 356, 79, 165);
INSERT INTO public.who_global_data VALUES (18723, 36, 8981, 2, 261, 79, 14);
INSERT INTO public.who_global_data VALUES (18724, 225, 43628, 12, 1638, 80, 193);
INSERT INTO public.who_global_data VALUES (18725, 694, 29126, 6, 637, 80, 113);
INSERT INTO public.who_global_data VALUES (18726, 1002, 69591, 18, 2186, 80, 143);
INSERT INTO public.who_global_data VALUES (18727, 0, 0, 0, 0, 80, 219);
INSERT INTO public.who_global_data VALUES (18728, 37, 5951, 0, 76, 80, 186);
INSERT INTO public.who_global_data VALUES (18729, 203, 13818, 4, 328, 80, 52);
INSERT INTO public.who_global_data VALUES (18730, 0, 3, 0, 0, 80, 180);
INSERT INTO public.who_global_data VALUES (18731, 0, 134, 0, 4, 80, 167);
INSERT INTO public.who_global_data VALUES (18732, 7893, 1318384, 291, 35727, 80, 154);
INSERT INTO public.who_global_data VALUES (18733, 1589, 119772, 28, 1834, 80, 94);
INSERT INTO public.who_global_data VALUES (18734, 6, 4668, 0, 44, 80, 66);
INSERT INTO public.who_global_data VALUES (18735, 6, 27756, 0, 907, 80, 58);
INSERT INTO public.who_global_data VALUES (18736, 5664, 213462, 74, 1815, 80, 163);
INSERT INTO public.who_global_data VALUES (18737, 2075, 79158, 20, 1005, 80, 37);
INSERT INTO public.who_global_data VALUES (18738, 56, 7312, 0, 163, 80, 142);
INSERT INTO public.who_global_data VALUES (18739, 126, 85008, 0, 337, 80, 83);
INSERT INTO public.who_global_data VALUES (18740, 2212, 436684, 39, 6254, 80, 228);
INSERT INTO public.who_global_data VALUES (18741, 0, 250, 0, 7, 80, 188);
INSERT INTO public.who_global_data VALUES (18742, 1251, 116699, 7, 1060, 80, 62);
INSERT INTO public.who_global_data VALUES (18743, 4829, 550080, 156, 15092, 80, 160);
INSERT INTO public.who_global_data VALUES (18744, 22, 4883, 4, 94, 80, 50);
INSERT INTO public.who_global_data VALUES (18745, 32, 2916, 0, 43, 80, 33);
INSERT INTO public.who_global_data VALUES (18746, 1, 223, 0, 9, 80, 183);
INSERT INTO public.who_global_data VALUES (18747, 1, 378, 0, 0, 80, 92);
INSERT INTO public.who_global_data VALUES (18748, 125, 143371, 10, 8859, 80, 158);
INSERT INTO public.who_global_data VALUES (18749, 0, 138, 0, 3, 80, 67);
INSERT INTO public.who_global_data VALUES (18750, 1255, 73944, 69, 2042, 80, 57);
INSERT INTO public.who_global_data VALUES (18751, 878, 9103, 2, 29, 80, 38);
INSERT INTO public.who_global_data VALUES (18752, 13371, 5876464, 216, 166014, 80, 141);
INSERT INTO public.who_global_data VALUES (18753, 0, 72, 0, 1, 80, 178);
INSERT INTO public.who_global_data VALUES (18754, 0, 148, 0, 3, 80, 108);
INSERT INTO public.who_global_data VALUES (18755, 4828, 106598, 131, 2413, 80, 39);
INSERT INTO public.who_global_data VALUES (18756, 0, 2652, 0, 68, 80, 2);
INSERT INTO public.who_global_data VALUES (18757, 11, 642, 0, 1, 80, 195);
INSERT INTO public.who_global_data VALUES (18758, 120, 9960, 0, 103, 80, 107);
INSERT INTO public.who_global_data VALUES (18759, 1, 304, 0, 0, 80, 161);
INSERT INTO public.who_global_data VALUES (18760, 0, 22896, 0, 433, 80, 212);
INSERT INTO public.who_global_data VALUES (18761, 6115, 302192, 74, 11027, 80, 181);
INSERT INTO public.who_global_data VALUES (18762, 3, 257, 1, 2, 80, 53);
INSERT INTO public.who_global_data VALUES (18763, 0, 4900, 0, 63, 80, 164);
INSERT INTO public.who_global_data VALUES (18764, 5, 1608, 0, 101, 80, 140);
INSERT INTO public.who_global_data VALUES (18765, 1006, 533610, 20, 14883, 80, 20);
INSERT INTO public.who_global_data VALUES (18766, 14, 92490, 0, 4749, 80, 112);
INSERT INTO public.who_global_data VALUES (18767, 6471, 1205217, 192, 34223, 80, 111);
INSERT INTO public.who_global_data VALUES (18768, 0, 579, 0, 7, 80, 71);
INSERT INTO public.who_global_data VALUES (18769, 0, 5515, 0, 92, 80, 218);
INSERT INTO public.who_global_data VALUES (18770, 0, 0, 0, 0, 80, 43);
INSERT INTO public.who_global_data VALUES (18771, 643, 124592, 11, 1566, 80, 49);
INSERT INTO public.who_global_data VALUES (18772, 28, 21004, 1, 129, 80, 1);
INSERT INTO public.who_global_data VALUES (18773, 1945, 87464, 31, 1113, 80, 48);
INSERT INTO public.who_global_data VALUES (18774, 28, 7667, 0, 131, 80, 232);
INSERT INTO public.who_global_data VALUES (18775, 34, 1374, 0, 2, 80, 175);
INSERT INTO public.who_global_data VALUES (18776, 228, 7513, 0, 40, 80, 21);
INSERT INTO public.who_global_data VALUES (18777, 4246, 469769, 142, 6558, 80, 156);
INSERT INTO public.who_global_data VALUES (18778, 0, 0, 0, 0, 80, 95);
INSERT INTO public.who_global_data VALUES (18779, 77, 11865, 3, 322, 80, 177);
INSERT INTO public.who_global_data VALUES (18780, 1220, 64551, 4, 768, 80, 210);
INSERT INTO public.who_global_data VALUES (18781, 1, 5656, 0, 61, 80, 120);
INSERT INTO public.who_global_data VALUES (18782, 0, 68, 0, 0, 80, 135);
INSERT INTO public.who_global_data VALUES (18783, 494, 134697, 4, 2290, 80, 206);
INSERT INTO public.who_global_data VALUES (18784, 428, 181104, 9, 13025, 80, 189);
INSERT INTO public.who_global_data VALUES (18785, 275, 111284, 16, 6481, 80, 129);
INSERT INTO public.who_global_data VALUES (18786, 0, 36669, 5, 1052, 80, 121);
INSERT INTO public.who_global_data VALUES (18787, 0, 5121, 0, 85, 80, 59);
INSERT INTO public.who_global_data VALUES (18788, 0, 518, 0, 0, 80, 96);
INSERT INTO public.who_global_data VALUES (18789, 185, 8033, 3, 84, 80, 41);
INSERT INTO public.who_global_data VALUES (18790, 19, 6124, 0, 119, 80, 216);
INSERT INTO public.who_global_data VALUES (18791, 339, 103395, 7, 1588, 80, 236);
INSERT INTO public.who_global_data VALUES (18792, 0, 15, 0, 0, 80, 150);
INSERT INTO public.who_global_data VALUES (18793, 0, 498, 0, 0, 80, 61);
INSERT INTO public.who_global_data VALUES (18794, 0, 35, 0, 2, 80, 7);
INSERT INTO public.who_global_data VALUES (18795, 228, 19647, 0, 371, 80, 169);
INSERT INTO public.who_global_data VALUES (18796, 45498, 2000060, 1219, 45938, 80, 28);
INSERT INTO public.who_global_data VALUES (18797, 24, 10900, 0, 70, 80, 85);
INSERT INTO public.who_global_data VALUES (18798, 241, 12362, 5, 61, 80, 211);
INSERT INTO public.who_global_data VALUES (18799, 0, 9062, 0, 58, 80, 60);
INSERT INTO public.who_global_data VALUES (18800, 3, 3705, 0, 122, 80, 3);
INSERT INTO public.who_global_data VALUES (18801, 3443, 89395, 37, 815, 80, 11);
INSERT INTO public.who_global_data VALUES (18802, 17561, 833307, 305, 13119, 80, 89);
INSERT INTO public.who_global_data VALUES (18803, 334, 50457, 1, 323, 80, 24);
INSERT INTO public.who_global_data VALUES (18804, 5, 907, 0, 1, 80, 162);
INSERT INTO public.who_global_data VALUES (18805, 2422, 78825, 63, 1228, 80, 100);
INSERT INTO public.who_global_data VALUES (18806, 0, 18, 0, 0, 80, 47);
INSERT INTO public.who_global_data VALUES (18807, 0, 33, 0, 0, 80, 29);
INSERT INTO public.who_global_data VALUES (18808, 0, 8181, 0, 139, 80, 40);
INSERT INTO public.who_global_data VALUES (18809, 59, 6121, 2, 100, 80, 222);
INSERT INTO public.who_global_data VALUES (18810, 698, 115730, 9, 3947, 80, 132);
INSERT INTO public.who_global_data VALUES (18811, 0, 282, 0, 13, 80, 130);
INSERT INTO public.who_global_data VALUES (18812, 30, 12654, 0, 75, 80, 234);
INSERT INTO public.who_global_data VALUES (18813, 0, 2421, 0, 43, 80, 23);
INSERT INTO public.who_global_data VALUES (18814, 51, 4874, 0, 139, 80, 192);
INSERT INTO public.who_global_data VALUES (18815, 3, 9191, 0, 232, 80, 69);
INSERT INTO public.who_global_data VALUES (18816, 0, 26, 0, 0, 80, 187);
INSERT INTO public.who_global_data VALUES (18817, 137, 103239, 16, 2839, 80, 230);
INSERT INTO public.who_global_data VALUES (18818, 4290, 156949, 99, 3380, 80, 77);
INSERT INTO public.who_global_data VALUES (18819, 10, 5215, 0, 25, 80, 9);
INSERT INTO public.who_global_data VALUES (18820, 38617, 8912907, 474, 130993, 80, 74);
INSERT INTO public.who_global_data VALUES (18821, 3807, 474455, 97, 15393, 80, 224);
INSERT INTO public.who_global_data VALUES (18822, 13352, 788473, 482, 42461, 80, 199);
INSERT INTO public.who_global_data VALUES (18823, 2961, 524503, 40, 11752, 80, 190);
INSERT INTO public.who_global_data VALUES (18824, 330, 68686, 11, 1995, 80, 12);
INSERT INTO public.who_global_data VALUES (18825, 1, 364, 0, 25, 80, 104);
INSERT INTO public.who_global_data VALUES (18826, 873, 324971, 8, 2756, 80, 153);
INSERT INTO public.who_global_data VALUES (18827, 32191, 1238072, 731, 46464, 80, 91);
INSERT INTO public.who_global_data VALUES (18828, 30, 9959, 0, 231, 80, 215);
INSERT INTO public.who_global_data VALUES (18829, 1489, 120815, 10, 1913, 80, 84);
INSERT INTO public.who_global_data VALUES (18830, 33, 761, 0, 32, 80, 231);
INSERT INTO public.who_global_data VALUES (18831, 6454, 155993, 66, 1909, 80, 196);
INSERT INTO public.who_global_data VALUES (18832, 964, 163787, 0, 2365, 80, 105);
INSERT INTO public.who_global_data VALUES (18833, 925, 71729, 15, 1302, 80, 122);
INSERT INTO public.who_global_data VALUES (18834, 0, 0, 0, 0, 80, 159);
INSERT INTO public.who_global_data VALUES (18835, 690, 30452, 16, 839, 80, 75);
INSERT INTO public.who_global_data VALUES (18836, 556, 137885, 6, 848, 80, 27);
INSERT INTO public.who_global_data VALUES (18837, 425, 67894, 5, 1212, 80, 54);
INSERT INTO public.who_global_data VALUES (18838, 1, 25, 0, 0, 80, 226);
INSERT INTO public.who_global_data VALUES (18839, 278, 10914, 6, 132, 80, 79);
INSERT INTO public.who_global_data VALUES (18840, 1507, 107953, 12, 839, 80, 56);
INSERT INTO public.who_global_data VALUES (18841, 0, 1967, 0, 44, 80, 117);
INSERT INTO public.who_global_data VALUES (18842, 0, 1512, 0, 82, 80, 152);
INSERT INTO public.who_global_data VALUES (18843, 612, 74936, 16, 1041, 80, 16);
INSERT INTO public.who_global_data VALUES (18844, 35, 1083, 0, 8, 80, 10);
INSERT INTO public.who_global_data VALUES (18845, 1943, 38787, 21, 352, 80, 201);
INSERT INTO public.who_global_data VALUES (18846, 164, 27256, 10, 236, 80, 174);
INSERT INTO public.who_global_data VALUES (18847, 0, 17310, 0, 250, 80, 119);
INSERT INTO public.who_global_data VALUES (18848, 0, 5971, 0, 185, 80, 168);
INSERT INTO public.who_global_data VALUES (18849, 1210, 49730, 5, 318, 80, 99);
INSERT INTO public.who_global_data VALUES (18850, 41, 12355, 1, 45, 80, 171);
INSERT INTO public.who_global_data VALUES (18851, 32, 3980, 0, 141, 80, 87);
INSERT INTO public.who_global_data VALUES (18852, 173, 8409, 1, 99, 80, 123);
INSERT INTO public.who_global_data VALUES (18853, 3, 4, 0, 0, 80, 151);
INSERT INTO public.who_global_data VALUES (18854, 0, 4732, 0, 37, 80, 213);
INSERT INTO public.who_global_data VALUES (18855, 0, 7952, 0, 165, 80, 118);
INSERT INTO public.who_global_data VALUES (18856, 0, 491, 0, 10, 80, 134);
INSERT INTO public.who_global_data VALUES (18857, 0, 4943, 0, 46, 80, 65);
INSERT INTO public.who_global_data VALUES (18858, 2874, 1009396, 319, 98861, 80, 102);
INSERT INTO public.who_global_data VALUES (18859, 0, 0, 0, 0, 80, 223);
INSERT INTO public.who_global_data VALUES (18860, 5, 560, 1, 3, 80, 4);
INSERT INTO public.who_global_data VALUES (18861, 9, 440, 0, 0, 80, 146);
INSERT INTO public.who_global_data VALUES (18862, 565, 29452, 9, 413, 80, 31);
INSERT INTO public.who_global_data VALUES (18863, 0, 13, 0, 1, 80, 127);
INSERT INTO public.who_global_data VALUES (18864, 5415, 301604, 82, 4932, 80, 22);
INSERT INTO public.who_global_data VALUES (18865, 52, 14566, 2, 118, 80, 115);
INSERT INTO public.who_global_data VALUES (18866, 1569, 71730, 26, 1625, 80, 106);
INSERT INTO public.who_global_data VALUES (18867, 11, 13566, 2, 140, 80, 90);
INSERT INTO public.who_global_data VALUES (18868, 0, 0, 0, 0, 80, 70);
INSERT INTO public.who_global_data VALUES (18869, 502, 211475, 17, 1247, 80, 46);
INSERT INTO public.who_global_data VALUES (18870, 4282, 455836, 85, 8596, 80, 139);
INSERT INTO public.who_global_data VALUES (18871, 0, 30, 0, 0, 80, 42);
INSERT INTO public.who_global_data VALUES (18872, 3, 1652, 0, 25, 80, 80);
INSERT INTO public.who_global_data VALUES (18873, 50, 4583, 1, 159, 80, 203);
INSERT INTO public.who_global_data VALUES (18874, 11, 1327, 0, 70, 80, 136);
INSERT INTO public.who_global_data VALUES (18875, 152, 65457, 0, 1163, 80, 63);
INSERT INTO public.who_global_data VALUES (18876, 0, 0, 0, 0, 80, 17);
INSERT INTO public.who_global_data VALUES (18877, 0, 103, 0, 2, 80, 172);
INSERT INTO public.who_global_data VALUES (18878, 977, 48613, 31, 1376, 80, 109);
INSERT INTO public.who_global_data VALUES (18879, 547, 29510, 4, 298, 80, 200);
INSERT INTO public.who_global_data VALUES (18880, 1158, 77320, 11, 658, 80, 93);
INSERT INTO public.who_global_data VALUES (18881, 0, 120718, 0, 1350, 80, 5);
INSERT INTO public.who_global_data VALUES (18882, 0, 741, 0, 13, 80, 214);
INSERT INTO public.who_global_data VALUES (18883, 2050, 361082, 33, 7193, 80, 204);
INSERT INTO public.who_global_data VALUES (18884, 0, 0, 0, 0, 80, 198);
INSERT INTO public.who_global_data VALUES (18885, 1014, 147667, 8, 2881, 80, 173);
INSERT INTO public.who_global_data VALUES (18886, 2, 604, 0, 7, 80, 229);
INSERT INTO public.who_global_data VALUES (18887, 525, 72099, 15, 1602, 80, 76);
INSERT INTO public.who_global_data VALUES (18888, 1257, 938268, 40, 35271, 80, 138);
INSERT INTO public.who_global_data VALUES (18889, 1144, 410718, 23, 7862, 80, 98);
INSERT INTO public.who_global_data VALUES (18890, 0, 0, 0, 0, 80, 103);
INSERT INTO public.who_global_data VALUES (18891, 19152, 752940, 357, 10848, 80, 225);
INSERT INTO public.who_global_data VALUES (18892, 4452, 230124, 81, 3553, 80, 131);
INSERT INTO public.who_global_data VALUES (18893, 569, 43585, 9, 951, 80, 235);
INSERT INTO public.who_global_data VALUES (18894, 194, 136222, 0, 235, 80, 137);
INSERT INTO public.who_global_data VALUES (18895, 285, 29281, 2, 496, 80, 81);
INSERT INTO public.who_global_data VALUES (18896, 1069, 90912, 19, 2054, 80, 182);
INSERT INTO public.who_global_data VALUES (18897, 0, 7161, 0, 31, 80, 145);
INSERT INTO public.who_global_data VALUES (18898, 8262, 373474, 186, 9261, 80, 26);
INSERT INTO public.who_global_data VALUES (18899, 20985, 1991998, 456, 34387, 80, 170);
INSERT INTO public.who_global_data VALUES (18900, 16, 5507, 1, 46, 80, 191);
INSERT INTO public.who_global_data VALUES (18901, 0, 5, 0, 0, 80, 221);
INSERT INTO public.who_global_data VALUES (18902, 0, 109, 0, 0, 80, 64);
INSERT INTO public.who_global_data VALUES (18903, 0, 0, 0, 0, 80, 116);
INSERT INTO public.who_global_data VALUES (18904, 0, 19, 0, 0, 80, 128);
INSERT INTO public.who_global_data VALUES (18905, 5, 178, 0, 2, 80, 6);
INSERT INTO public.who_global_data VALUES (18906, 0, 655, 0, 12, 80, 227);
INSERT INTO public.who_global_data VALUES (18907, 0, 14, 0, 0, 80, 68);
INSERT INTO public.who_global_data VALUES (18908, 0, 78, 0, 0, 80, 184);
INSERT INTO public.who_global_data VALUES (18909, 0, 0, 0, 0, 80, 82);
INSERT INTO public.who_global_data VALUES (18910, 31, 1321, 1, 43, 80, 149);
INSERT INTO public.who_global_data VALUES (18911, 2, 967, 0, 16, 80, 197);
INSERT INTO public.who_global_data VALUES (18912, 362, 353918, 16, 5692, 80, 78);
INSERT INTO public.who_global_data VALUES (18913, 13, 15806, 1, 329, 80, 233);
INSERT INTO public.who_global_data VALUES (18914, 4994, 92375, 24, 1054, 80, 133);
INSERT INTO public.who_global_data VALUES (18915, 3, 161, 0, 0, 80, 35);
INSERT INTO public.who_global_data VALUES (18916, 0, 2391, 0, 74, 80, 114);
INSERT INTO public.who_global_data VALUES (18917, 6, 58130, 0, 28, 80, 237);
INSERT INTO public.who_global_data VALUES (18918, 0, 14, 0, 0, 80, 55);
INSERT INTO public.who_global_data VALUES (18919, 6, 939, 0, 24, 80, 176);
INSERT INTO public.who_global_data VALUES (18920, 1326, 88602, 31, 557, 80, 202);
INSERT INTO public.who_global_data VALUES (18921, 2018, 58994, 45, 1001, 80, 155);
INSERT INTO public.who_global_data VALUES (18922, 0, 16, 0, 0, 80, 32);
INSERT INTO public.who_global_data VALUES (18923, 81, 4382, 1, 108, 80, 220);
INSERT INTO public.who_global_data VALUES (18924, 1987, 754256, 119, 20433, 80, 30);
INSERT INTO public.who_global_data VALUES (18925, 0, 3016, 0, 59, 80, 147);
INSERT INTO public.who_global_data VALUES (18926, 12933, 1582248, 265, 43683, 80, 208);
INSERT INTO public.who_global_data VALUES (18927, 401, 18075, 5, 66, 80, 45);
INSERT INTO public.who_global_data VALUES (18928, 146, 15299, 1, 1179, 80, 110);
INSERT INTO public.who_global_data VALUES (18929, 1, 5275, 1, 115, 80, 88);
INSERT INTO public.who_global_data VALUES (18930, 2544, 192597, 37, 6485, 80, 51);
INSERT INTO public.who_global_data VALUES (18931, 5417, 282642, 85, 3664, 80, 209);
INSERT INTO public.who_global_data VALUES (18932, 77, 6836, 4, 354, 80, 205);
INSERT INTO public.who_global_data VALUES (18933, 40, 11689, 0, 85, 80, 18);
INSERT INTO public.who_global_data VALUES (18934, 2, 3880, 0, 60, 80, 72);
INSERT INTO public.who_global_data VALUES (18935, 20051, 1410736, 598, 52745, 80, 44);
INSERT INTO public.who_global_data VALUES (18936, 0, 30, 0, 0, 80, 15);
INSERT INTO public.who_global_data VALUES (18937, 117, 2722, 2, 62, 80, 25);
INSERT INTO public.who_global_data VALUES (18938, 0, 0, 0, 0, 80, 179);
INSERT INTO public.who_global_data VALUES (18939, 0, 0, 0, 0, 80, 34);
INSERT INTO public.who_global_data VALUES (18940, 16, 6096, 0, 112, 80, 207);
INSERT INTO public.who_global_data VALUES (18941, 720, 81723, 56, 2445, 80, 166);
INSERT INTO public.who_global_data VALUES (18942, 10549, 1181903, 103, 11704, 80, 126);
INSERT INTO public.who_global_data VALUES (18943, 0, 0, 0, 0, 80, 97);
INSERT INTO public.who_global_data VALUES (18944, 0, 720, 0, 6, 80, 36);
INSERT INTO public.who_global_data VALUES (18945, 0, 0, 0, 0, 80, 125);
INSERT INTO public.who_global_data VALUES (18946, 306, 16563, 0, 150, 80, 124);
INSERT INTO public.who_global_data VALUES (18947, 12496, 570153, 256, 10112, 80, 185);
INSERT INTO public.who_global_data VALUES (18948, 1255, 152809, 4, 538, 80, 194);
INSERT INTO public.who_global_data VALUES (18949, 0, 509, 0, 21, 80, 144);
INSERT INTO public.who_global_data VALUES (18950, 151266, 11085184, 753, 245164, 80, 19);
INSERT INTO public.who_global_data VALUES (18951, 16, 1450, 0, 23, 80, 217);
INSERT INTO public.who_global_data VALUES (18952, 74, 4104, 2, 67, 80, 148);
INSERT INTO public.who_global_data VALUES (18953, 204, 70648, 1, 599, 80, 86);
INSERT INTO public.who_global_data VALUES (18954, 0, 1, 0, 0, 80, 13);
INSERT INTO public.who_global_data VALUES (18955, 387, 97739, 4, 855, 80, 157);
INSERT INTO public.who_global_data VALUES (18956, 5, 1288, 0, 35, 80, 8);
INSERT INTO public.who_global_data VALUES (18957, 0, 2, 0, 0, 80, 73);
INSERT INTO public.who_global_data VALUES (18958, 0, 2072, 0, 604, 80, 101);
INSERT INTO public.who_global_data VALUES (18959, 56, 17243, 0, 353, 80, 165);
INSERT INTO public.who_global_data VALUES (18960, 48, 8945, 2, 259, 80, 14);
INSERT INTO public.who_global_data VALUES (18961, 163, 43403, 9, 1626, 81, 193);
INSERT INTO public.who_global_data VALUES (18962, 602, 28432, 8, 631, 81, 113);
INSERT INTO public.who_global_data VALUES (18963, 910, 68589, 14, 2168, 81, 143);
INSERT INTO public.who_global_data VALUES (18964, 0, 0, 0, 0, 81, 219);
INSERT INTO public.who_global_data VALUES (18965, 42, 5914, 0, 76, 81, 186);
INSERT INTO public.who_global_data VALUES (18966, 164, 13615, 2, 324, 81, 52);
INSERT INTO public.who_global_data VALUES (18967, 0, 3, 0, 0, 81, 180);
INSERT INTO public.who_global_data VALUES (18968, 0, 134, 0, 4, 81, 167);
INSERT INTO public.who_global_data VALUES (18969, 5645, 1310491, 129, 35436, 81, 154);
INSERT INTO public.who_global_data VALUES (18970, 984, 118183, 23, 1806, 81, 94);
INSERT INTO public.who_global_data VALUES (18971, 23, 4662, 1, 44, 81, 66);
INSERT INTO public.who_global_data VALUES (18972, 25, 27750, 0, 907, 81, 58);
INSERT INTO public.who_global_data VALUES (18973, 4304, 207798, 62, 1741, 81, 163);
INSERT INTO public.who_global_data VALUES (18974, 1395, 77083, 18, 985, 81, 37);
INSERT INTO public.who_global_data VALUES (18975, 93, 7256, 8, 163, 81, 142);
INSERT INTO public.who_global_data VALUES (18976, 179, 84882, 3, 337, 81, 83);
INSERT INTO public.who_global_data VALUES (18977, 2139, 434472, 21, 6215, 81, 228);
INSERT INTO public.who_global_data VALUES (18978, 1, 250, 0, 7, 81, 188);
INSERT INTO public.who_global_data VALUES (18979, 1263, 115448, 7, 1053, 81, 62);
INSERT INTO public.who_global_data VALUES (18980, 5821, 545251, 194, 14936, 81, 160);
INSERT INTO public.who_global_data VALUES (18981, 78, 4861, 2, 90, 81, 50);
INSERT INTO public.who_global_data VALUES (18982, 40, 2884, 0, 43, 81, 33);
INSERT INTO public.who_global_data VALUES (18983, 0, 222, 0, 9, 81, 183);
INSERT INTO public.who_global_data VALUES (18984, 2, 377, 0, 0, 81, 92);
INSERT INTO public.who_global_data VALUES (18985, 65, 143246, 8, 8849, 81, 158);
INSERT INTO public.who_global_data VALUES (18986, 2, 138, 0, 3, 81, 67);
INSERT INTO public.who_global_data VALUES (18987, 730, 72689, 75, 1973, 81, 57);
INSERT INTO public.who_global_data VALUES (18988, 0, 8225, 0, 27, 81, 38);
INSERT INTO public.who_global_data VALUES (18989, 14134, 5863093, 140, 165798, 81, 141);
INSERT INTO public.who_global_data VALUES (18990, 0, 72, 0, 1, 81, 178);
INSERT INTO public.who_global_data VALUES (18991, 0, 148, 0, 3, 81, 108);
INSERT INTO public.who_global_data VALUES (18992, 3519, 101770, 152, 2282, 81, 39);
INSERT INTO public.who_global_data VALUES (18993, 11, 2652, 0, 68, 81, 2);
INSERT INTO public.who_global_data VALUES (18994, 1, 631, 0, 1, 81, 195);
INSERT INTO public.who_global_data VALUES (18995, 18, 9840, 0, 103, 81, 107);
INSERT INTO public.who_global_data VALUES (18996, 1, 303, 0, 0, 81, 161);
INSERT INTO public.who_global_data VALUES (18997, 204, 22896, 0, 433, 81, 212);
INSERT INTO public.who_global_data VALUES (18998, 4146, 296077, 62, 10953, 81, 181);
INSERT INTO public.who_global_data VALUES (18999, 0, 254, 0, 1, 81, 53);
INSERT INTO public.who_global_data VALUES (19000, 0, 4900, 0, 63, 81, 164);
INSERT INTO public.who_global_data VALUES (19001, 6, 1603, 0, 101, 81, 140);
INSERT INTO public.who_global_data VALUES (19002, 1331, 532604, 44, 14863, 81, 20);
INSERT INTO public.who_global_data VALUES (19003, 24, 92476, 0, 4749, 81, 112);
INSERT INTO public.who_global_data VALUES (19004, 7742, 1198746, 202, 34031, 81, 111);
INSERT INTO public.who_global_data VALUES (19005, 5, 579, 0, 7, 81, 71);
INSERT INTO public.who_global_data VALUES (19006, 0, 5515, 0, 92, 81, 218);
INSERT INTO public.who_global_data VALUES (19007, 0, 0, 0, 0, 81, 43);
INSERT INTO public.who_global_data VALUES (19008, 726, 123949, 9, 1555, 81, 49);
INSERT INTO public.who_global_data VALUES (19009, 0, 20976, 0, 128, 81, 1);
INSERT INTO public.who_global_data VALUES (19010, 1313, 85519, 33, 1082, 81, 48);
INSERT INTO public.who_global_data VALUES (19011, 49, 7639, 0, 131, 81, 232);
INSERT INTO public.who_global_data VALUES (19012, 125, 1340, 0, 2, 81, 175);
INSERT INTO public.who_global_data VALUES (19013, 107, 7285, 0, 40, 81, 21);
INSERT INTO public.who_global_data VALUES (19014, 5407, 465523, 208, 6416, 81, 156);
INSERT INTO public.who_global_data VALUES (19015, 0, 0, 0, 0, 81, 95);
INSERT INTO public.who_global_data VALUES (19016, 0, 11788, 0, 319, 81, 177);
INSERT INTO public.who_global_data VALUES (19017, 1195, 63331, 4, 764, 81, 210);
INSERT INTO public.who_global_data VALUES (19018, 6, 5655, 0, 61, 81, 120);
INSERT INTO public.who_global_data VALUES (19019, 0, 68, 0, 0, 81, 135);
INSERT INTO public.who_global_data VALUES (19020, 479, 134203, 1, 2286, 81, 206);
INSERT INTO public.who_global_data VALUES (19021, 381, 180676, 8, 13016, 81, 189);
INSERT INTO public.who_global_data VALUES (19022, 242, 111009, 12, 6465, 81, 129);
INSERT INTO public.who_global_data VALUES (19023, 311, 36669, 3, 1047, 81, 121);
INSERT INTO public.who_global_data VALUES (19024, 17, 5121, 0, 85, 81, 59);
INSERT INTO public.who_global_data VALUES (19025, 25, 518, 0, 0, 81, 96);
INSERT INTO public.who_global_data VALUES (19026, 211, 7848, 0, 81, 81, 41);
INSERT INTO public.who_global_data VALUES (19027, 10, 6105, 0, 119, 81, 216);
INSERT INTO public.who_global_data VALUES (19028, 336, 103056, 12, 1581, 81, 236);
INSERT INTO public.who_global_data VALUES (19029, 0, 15, 0, 0, 81, 150);
INSERT INTO public.who_global_data VALUES (19030, 0, 498, 0, 0, 81, 61);
INSERT INTO public.who_global_data VALUES (19031, 0, 35, 0, 2, 81, 7);
INSERT INTO public.who_global_data VALUES (19032, 104, 19419, 2, 371, 81, 169);
INSERT INTO public.who_global_data VALUES (19033, 9094, 1954562, 504, 44719, 81, 28);
INSERT INTO public.who_global_data VALUES (19034, 32, 10876, 0, 70, 81, 85);
INSERT INTO public.who_global_data VALUES (19035, 415, 12121, 3, 56, 81, 211);
INSERT INTO public.who_global_data VALUES (19036, 0, 9062, 0, 58, 81, 60);
INSERT INTO public.who_global_data VALUES (19037, 0, 3702, 0, 122, 81, 3);
INSERT INTO public.who_global_data VALUES (19038, 3117, 85952, 45, 778, 81, 11);
INSERT INTO public.who_global_data VALUES (19039, 14419, 815746, 267, 12814, 81, 89);
INSERT INTO public.who_global_data VALUES (19040, 0, 50123, 0, 322, 81, 24);
INSERT INTO public.who_global_data VALUES (19041, 15, 902, 0, 1, 81, 162);
INSERT INTO public.who_global_data VALUES (19042, 2198, 76403, 59, 1165, 81, 100);
INSERT INTO public.who_global_data VALUES (19043, 1, 18, 0, 0, 81, 47);
INSERT INTO public.who_global_data VALUES (19044, 0, 33, 0, 0, 81, 29);
INSERT INTO public.who_global_data VALUES (19045, 0, 8181, 0, 139, 81, 40);
INSERT INTO public.who_global_data VALUES (19046, 52, 6062, 4, 98, 81, 222);
INSERT INTO public.who_global_data VALUES (19047, 147, 115032, 6, 3938, 81, 132);
INSERT INTO public.who_global_data VALUES (19048, 0, 282, 0, 13, 81, 130);
INSERT INTO public.who_global_data VALUES (19049, 13, 12624, 0, 75, 81, 234);
INSERT INTO public.who_global_data VALUES (19050, 2, 2421, 0, 43, 81, 23);
INSERT INTO public.who_global_data VALUES (19051, 29, 4823, 1, 139, 81, 192);
INSERT INTO public.who_global_data VALUES (19052, 9, 9188, 0, 232, 81, 69);
INSERT INTO public.who_global_data VALUES (19053, 0, 26, 0, 0, 81, 187);
INSERT INTO public.who_global_data VALUES (19054, 547, 103102, 1, 2823, 81, 230);
INSERT INTO public.who_global_data VALUES (19055, 5203, 152659, 91, 3281, 81, 77);
INSERT INTO public.who_global_data VALUES (19056, 16, 5205, 0, 25, 81, 9);
INSERT INTO public.who_global_data VALUES (19057, 29163, 8874290, 449, 130519, 81, 74);
INSERT INTO public.who_global_data VALUES (19058, 3535, 470648, 85, 15296, 81, 224);
INSERT INTO public.who_global_data VALUES (19059, 13053, 775121, 486, 41979, 81, 199);
INSERT INTO public.who_global_data VALUES (19060, 2390, 521542, 42, 11712, 81, 190);
INSERT INTO public.who_global_data VALUES (19061, 453, 68356, 5, 1984, 81, 12);
INSERT INTO public.who_global_data VALUES (19062, 0, 363, 0, 25, 81, 104);
INSERT INTO public.who_global_data VALUES (19063, 625, 324098, 9, 2748, 81, 153);
INSERT INTO public.who_global_data VALUES (19064, 27352, 1205881, 504, 45733, 81, 91);
INSERT INTO public.who_global_data VALUES (19065, 45, 9929, 0, 231, 81, 215);
INSERT INTO public.who_global_data VALUES (19066, 1190, 119326, 18, 1903, 81, 84);
INSERT INTO public.who_global_data VALUES (19067, 0, 728, 0, 32, 81, 231);
INSERT INTO public.who_global_data VALUES (19068, 5861, 149539, 71, 1843, 81, 196);
INSERT INTO public.who_global_data VALUES (19069, 950, 162823, 0, 2365, 81, 105);
INSERT INTO public.who_global_data VALUES (19070, 559, 70804, 18, 1287, 81, 122);
INSERT INTO public.who_global_data VALUES (19071, 0, 0, 0, 0, 81, 159);
INSERT INTO public.who_global_data VALUES (19072, 688, 29762, 11, 823, 81, 75);
INSERT INTO public.who_global_data VALUES (19073, 489, 137329, 4, 842, 81, 27);
INSERT INTO public.who_global_data VALUES (19074, 486, 67469, 4, 1207, 81, 54);
INSERT INTO public.who_global_data VALUES (19075, 0, 24, 0, 0, 81, 226);
INSERT INTO public.who_global_data VALUES (19076, 89, 10636, 3, 126, 81, 79);
INSERT INTO public.who_global_data VALUES (19077, 1016, 106446, 10, 827, 81, 56);
INSERT INTO public.who_global_data VALUES (19078, 0, 1967, 0, 44, 81, 117);
INSERT INTO public.who_global_data VALUES (19079, 5, 1512, 0, 82, 81, 152);
INSERT INTO public.who_global_data VALUES (19080, 722, 74324, 8, 1025, 81, 16);
INSERT INTO public.who_global_data VALUES (19081, 26, 1048, 1, 8, 81, 10);
INSERT INTO public.who_global_data VALUES (19082, 966, 36844, 20, 331, 81, 201);
INSERT INTO public.who_global_data VALUES (19083, 548, 27092, 4, 226, 81, 174);
INSERT INTO public.who_global_data VALUES (19084, 77, 17310, 1, 250, 81, 119);
INSERT INTO public.who_global_data VALUES (19085, 6, 5971, 0, 185, 81, 168);
INSERT INTO public.who_global_data VALUES (19086, 1103, 48520, 4, 313, 81, 99);
INSERT INTO public.who_global_data VALUES (19087, 110, 12314, 1, 44, 81, 171);
INSERT INTO public.who_global_data VALUES (19088, 48, 3948, 0, 141, 81, 87);
INSERT INTO public.who_global_data VALUES (19089, 110, 8236, 3, 98, 81, 123);
INSERT INTO public.who_global_data VALUES (19090, 0, 1, 0, 0, 81, 151);
INSERT INTO public.who_global_data VALUES (19091, 0, 4732, 0, 37, 81, 213);
INSERT INTO public.who_global_data VALUES (19092, 67, 7952, 0, 165, 81, 118);
INSERT INTO public.who_global_data VALUES (19093, 21, 491, 0, 10, 81, 134);
INSERT INTO public.who_global_data VALUES (19094, 0, 4943, 0, 46, 81, 65);
INSERT INTO public.who_global_data VALUES (19095, 3269, 1006522, 283, 98542, 81, 102);
INSERT INTO public.who_global_data VALUES (19096, 0, 0, 0, 0, 81, 223);
INSERT INTO public.who_global_data VALUES (19097, 4, 555, 0, 2, 81, 4);
INSERT INTO public.who_global_data VALUES (19098, 3, 431, 0, 0, 81, 146);
INSERT INTO public.who_global_data VALUES (19099, 585, 28887, 9, 404, 81, 31);
INSERT INTO public.who_global_data VALUES (19100, 0, 13, 0, 1, 81, 127);
INSERT INTO public.who_global_data VALUES (19101, 3012, 296189, 71, 4850, 81, 22);
INSERT INTO public.who_global_data VALUES (19102, 66, 14514, 3, 116, 81, 115);
INSERT INTO public.who_global_data VALUES (19103, 1167, 70161, 22, 1599, 81, 106);
INSERT INTO public.who_global_data VALUES (19104, 47, 13555, 0, 138, 81, 90);
INSERT INTO public.who_global_data VALUES (19105, 0, 0, 0, 0, 81, 70);
INSERT INTO public.who_global_data VALUES (19106, 1197, 210973, 9, 1230, 81, 46);
INSERT INTO public.who_global_data VALUES (19107, 4843, 451554, 45, 8511, 81, 139);
INSERT INTO public.who_global_data VALUES (19108, 0, 30, 0, 0, 81, 42);
INSERT INTO public.who_global_data VALUES (19109, 4, 1649, 0, 25, 81, 80);
INSERT INTO public.who_global_data VALUES (19110, 0, 4533, 0, 158, 81, 203);
INSERT INTO public.who_global_data VALUES (19111, 9, 1316, 0, 70, 81, 136);
INSERT INTO public.who_global_data VALUES (19112, 157, 65305, 0, 1163, 81, 63);
INSERT INTO public.who_global_data VALUES (19113, 0, 0, 0, 0, 81, 17);
INSERT INTO public.who_global_data VALUES (19114, 1, 103, 0, 2, 81, 172);
INSERT INTO public.who_global_data VALUES (19115, 586, 47636, 40, 1345, 81, 109);
INSERT INTO public.who_global_data VALUES (19116, 1737, 28963, 0, 294, 81, 200);
INSERT INTO public.who_global_data VALUES (19117, 836, 76162, 7, 647, 81, 93);
INSERT INTO public.who_global_data VALUES (19118, 329, 120718, 12, 1350, 81, 5);
INSERT INTO public.who_global_data VALUES (19119, 0, 741, 0, 13, 81, 214);
INSERT INTO public.who_global_data VALUES (19120, 2128, 359032, 19, 7160, 81, 204);
INSERT INTO public.who_global_data VALUES (19121, 0, 0, 0, 0, 81, 198);
INSERT INTO public.who_global_data VALUES (19122, 1344, 146653, 6, 2873, 81, 173);
INSERT INTO public.who_global_data VALUES (19123, 0, 602, 0, 7, 81, 229);
INSERT INTO public.who_global_data VALUES (19124, 509, 71574, 18, 1587, 81, 76);
INSERT INTO public.who_global_data VALUES (19125, 2112, 937011, 54, 35231, 81, 138);
INSERT INTO public.who_global_data VALUES (19126, 1736, 409574, 7, 7839, 81, 98);
INSERT INTO public.who_global_data VALUES (19127, 0, 0, 0, 0, 81, 103);
INSERT INTO public.who_global_data VALUES (19128, 20816, 733788, 143, 10491, 81, 225);
INSERT INTO public.who_global_data VALUES (19129, 8371, 225672, 91, 3472, 81, 131);
INSERT INTO public.who_global_data VALUES (19130, 537, 43016, 7, 942, 81, 235);
INSERT INTO public.who_global_data VALUES (19131, 243, 136028, 1, 235, 81, 137);
INSERT INTO public.who_global_data VALUES (19132, 230, 28996, 0, 494, 81, 81);
INSERT INTO public.who_global_data VALUES (19133, 564, 89843, 16, 2035, 81, 182);
INSERT INTO public.who_global_data VALUES (19134, 280, 7161, 2, 31, 81, 145);
INSERT INTO public.who_global_data VALUES (19135, 4931, 365212, 149, 9075, 81, 26);
INSERT INTO public.who_global_data VALUES (19136, 22410, 1971013, 442, 33931, 81, 170);
INSERT INTO public.who_global_data VALUES (19137, 36, 5491, 3, 45, 81, 191);
INSERT INTO public.who_global_data VALUES (19138, 0, 5, 0, 0, 81, 221);
INSERT INTO public.who_global_data VALUES (19139, 0, 109, 0, 0, 81, 64);
INSERT INTO public.who_global_data VALUES (19140, 0, 0, 0, 0, 81, 116);
INSERT INTO public.who_global_data VALUES (19141, 0, 19, 0, 0, 81, 128);
INSERT INTO public.who_global_data VALUES (19142, 11, 173, 0, 2, 81, 6);
INSERT INTO public.who_global_data VALUES (19143, 0, 655, 0, 12, 81, 227);
INSERT INTO public.who_global_data VALUES (19144, 0, 14, 0, 0, 81, 68);
INSERT INTO public.who_global_data VALUES (19145, 0, 78, 0, 0, 81, 184);
INSERT INTO public.who_global_data VALUES (19146, 0, 0, 0, 0, 81, 82);
INSERT INTO public.who_global_data VALUES (19147, 0, 1290, 0, 42, 81, 149);
INSERT INTO public.who_global_data VALUES (19148, 0, 965, 0, 16, 81, 197);
INSERT INTO public.who_global_data VALUES (19149, 301, 353556, 19, 5676, 81, 78);
INSERT INTO public.who_global_data VALUES (19150, 0, 15793, 0, 328, 81, 233);
INSERT INTO public.who_global_data VALUES (19151, 2813, 87381, 21, 1030, 81, 133);
INSERT INTO public.who_global_data VALUES (19152, 0, 158, 0, 0, 81, 35);
INSERT INTO public.who_global_data VALUES (19153, 0, 2391, 0, 74, 81, 114);
INSERT INTO public.who_global_data VALUES (19154, 5, 58124, 0, 28, 81, 237);
INSERT INTO public.who_global_data VALUES (19155, 0, 14, 0, 0, 81, 55);
INSERT INTO public.who_global_data VALUES (19156, 19, 933, 1, 24, 81, 176);
INSERT INTO public.who_global_data VALUES (19157, 509, 87276, 16, 526, 81, 202);
INSERT INTO public.who_global_data VALUES (19158, 1393, 56976, 44, 956, 81, 155);
INSERT INTO public.who_global_data VALUES (19159, 0, 16, 0, 0, 81, 32);
INSERT INTO public.who_global_data VALUES (19160, 0, 4301, 0, 107, 81, 220);
INSERT INTO public.who_global_data VALUES (19161, 1245, 752269, 73, 20314, 81, 30);
INSERT INTO public.who_global_data VALUES (19162, 4, 3016, 0, 59, 81, 147);
INSERT INTO public.who_global_data VALUES (19163, 6682, 1569315, 248, 43418, 81, 208);
INSERT INTO public.who_global_data VALUES (19164, 387, 17674, 3, 61, 81, 45);
INSERT INTO public.who_global_data VALUES (19165, 106, 15153, 3, 1178, 81, 110);
INSERT INTO public.who_global_data VALUES (19166, 0, 5274, 0, 114, 81, 88);
INSERT INTO public.who_global_data VALUES (19167, 1581, 190053, 39, 6448, 81, 51);
INSERT INTO public.who_global_data VALUES (19168, 6584, 277225, 88, 3579, 81, 209);
INSERT INTO public.who_global_data VALUES (19169, 75, 6759, 5, 350, 81, 205);
INSERT INTO public.who_global_data VALUES (19170, 39, 11649, 0, 85, 81, 18);
INSERT INTO public.who_global_data VALUES (19171, 3, 3878, 0, 60, 81, 72);
INSERT INTO public.who_global_data VALUES (19172, 21363, 1390685, 213, 52147, 81, 44);
INSERT INTO public.who_global_data VALUES (19173, 0, 30, 0, 0, 81, 15);
INSERT INTO public.who_global_data VALUES (19174, 0, 2605, 0, 60, 81, 25);
INSERT INTO public.who_global_data VALUES (19175, 0, 0, 0, 0, 81, 179);
INSERT INTO public.who_global_data VALUES (19176, 0, 0, 0, 0, 81, 34);
INSERT INTO public.who_global_data VALUES (19177, 3, 6080, 0, 112, 81, 207);
INSERT INTO public.who_global_data VALUES (19178, 599, 81003, 44, 2389, 81, 166);
INSERT INTO public.who_global_data VALUES (19179, 10046, 1171354, 94, 11601, 81, 126);
INSERT INTO public.who_global_data VALUES (19180, 0, 0, 0, 0, 81, 97);
INSERT INTO public.who_global_data VALUES (19181, 0, 720, 0, 6, 81, 36);
INSERT INTO public.who_global_data VALUES (19182, 0, 0, 0, 0, 81, 125);
INSERT INTO public.who_global_data VALUES (19183, 237, 16257, 5, 150, 81, 124);
INSERT INTO public.who_global_data VALUES (19184, 11968, 557657, 159, 9856, 81, 185);
INSERT INTO public.who_global_data VALUES (19185, 1209, 151554, 4, 534, 81, 194);
INSERT INTO public.who_global_data VALUES (19186, 0, 509, 0, 21, 81, 144);
INSERT INTO public.who_global_data VALUES (19187, 137486, 10933918, 653, 244411, 81, 19);
INSERT INTO public.who_global_data VALUES (19188, 0, 1434, 0, 23, 81, 217);
INSERT INTO public.who_global_data VALUES (19189, 73, 4030, 1, 65, 81, 148);
INSERT INTO public.who_global_data VALUES (19190, 201, 70444, 0, 598, 81, 86);
INSERT INTO public.who_global_data VALUES (19191, 0, 1, 0, 0, 81, 13);
INSERT INTO public.who_global_data VALUES (19192, 419, 97352, 3, 851, 81, 157);
INSERT INTO public.who_global_data VALUES (19193, 2, 1283, 0, 35, 81, 8);
INSERT INTO public.who_global_data VALUES (19194, 1, 2, 0, 0, 81, 73);
INSERT INTO public.who_global_data VALUES (19195, 0, 2072, 0, 604, 81, 101);
INSERT INTO public.who_global_data VALUES (19196, 64, 17187, 0, 353, 81, 165);
INSERT INTO public.who_global_data VALUES (19197, 68, 8897, 0, 257, 81, 14);
INSERT INTO public.who_global_data VALUES (19198, 205, 43240, 12, 1617, 82, 193);
INSERT INTO public.who_global_data VALUES (19199, 597, 27830, 11, 623, 82, 113);
INSERT INTO public.who_global_data VALUES (19200, 1704, 67679, 29, 2154, 82, 143);
INSERT INTO public.who_global_data VALUES (19201, 0, 0, 0, 0, 82, 219);
INSERT INTO public.who_global_data VALUES (19202, 147, 5872, 1, 76, 82, 186);
INSERT INTO public.who_global_data VALUES (19203, 77, 13451, 0, 322, 82, 52);
INSERT INTO public.who_global_data VALUES (19204, 0, 3, 0, 0, 82, 180);
INSERT INTO public.who_global_data VALUES (19205, 1, 134, 0, 4, 82, 167);
INSERT INTO public.who_global_data VALUES (19206, 8468, 1304846, 262, 35307, 82, 154);
INSERT INTO public.who_global_data VALUES (19207, 549, 117199, 25, 1783, 82, 94);
INSERT INTO public.who_global_data VALUES (19208, 0, 4639, 0, 43, 82, 66);
INSERT INTO public.who_global_data VALUES (19209, 14, 27725, 0, 907, 82, 58);
INSERT INTO public.who_global_data VALUES (19210, 5278, 203494, 50, 1679, 82, 163);
INSERT INTO public.who_global_data VALUES (19211, 2259, 75688, 21, 967, 82, 37);
INSERT INTO public.who_global_data VALUES (19212, 0, 7163, 0, 155, 82, 142);
INSERT INTO public.who_global_data VALUES (19213, 180, 84703, 1, 334, 82, 83);
INSERT INTO public.who_global_data VALUES (19214, 1837, 432333, 21, 6194, 82, 228);
INSERT INTO public.who_global_data VALUES (19215, 0, 249, 0, 7, 82, 188);
INSERT INTO public.who_global_data VALUES (19216, 1315, 114185, 7, 1046, 82, 62);
INSERT INTO public.who_global_data VALUES (19217, 1057, 539430, 192, 14742, 82, 160);
INSERT INTO public.who_global_data VALUES (19218, 68, 4783, 3, 88, 82, 50);
INSERT INTO public.who_global_data VALUES (19219, 0, 2844, 0, 43, 82, 33);
INSERT INTO public.who_global_data VALUES (19220, 0, 222, 0, 9, 82, 183);
INSERT INTO public.who_global_data VALUES (19221, 0, 375, 0, 0, 82, 92);
INSERT INTO public.who_global_data VALUES (19222, 112, 143181, 6, 8841, 82, 158);
INSERT INTO public.who_global_data VALUES (19223, 0, 136, 0, 3, 82, 67);
INSERT INTO public.who_global_data VALUES (19224, 1059, 71959, 41, 1898, 82, 57);
INSERT INTO public.who_global_data VALUES (19225, 0, 8225, 0, 27, 82, 38);
INSERT INTO public.who_global_data VALUES (19226, 38307, 5848959, 921, 165658, 82, 141);
INSERT INTO public.who_global_data VALUES (19227, 0, 72, 0, 1, 82, 178);
INSERT INTO public.who_global_data VALUES (19228, 0, 148, 0, 3, 82, 108);
INSERT INTO public.who_global_data VALUES (19229, 816, 98251, 39, 2130, 82, 39);
INSERT INTO public.who_global_data VALUES (19230, 6, 2641, 0, 68, 82, 2);
INSERT INTO public.who_global_data VALUES (19231, 2, 630, 0, 1, 82, 195);
INSERT INTO public.who_global_data VALUES (19232, 42, 9822, 1, 103, 82, 107);
INSERT INTO public.who_global_data VALUES (19233, 0, 302, 0, 0, 82, 161);
INSERT INTO public.who_global_data VALUES (19234, 0, 22692, 0, 433, 82, 212);
INSERT INTO public.who_global_data VALUES (19235, 4613, 291931, 63, 10891, 82, 181);
INSERT INTO public.who_global_data VALUES (19236, 0, 254, 0, 1, 82, 53);
INSERT INTO public.who_global_data VALUES (19237, 0, 4900, 0, 63, 82, 164);
INSERT INTO public.who_global_data VALUES (19238, 6, 1597, 1, 101, 82, 140);
INSERT INTO public.who_global_data VALUES (19239, 1597, 531273, 42, 14819, 82, 20);
INSERT INTO public.who_global_data VALUES (19240, 24, 92452, 0, 4749, 82, 112);
INSERT INTO public.who_global_data VALUES (19241, 8307, 1191004, 160, 33829, 82, 111);
INSERT INTO public.who_global_data VALUES (19242, 0, 574, 0, 7, 82, 71);
INSERT INTO public.who_global_data VALUES (19243, 0, 5515, 0, 92, 82, 218);
INSERT INTO public.who_global_data VALUES (19244, 0, 0, 0, 0, 82, 43);
INSERT INTO public.who_global_data VALUES (19245, 1100, 123223, 9, 1546, 82, 49);
INSERT INTO public.who_global_data VALUES (19246, 31, 20976, 0, 128, 82, 1);
INSERT INTO public.who_global_data VALUES (19247, 2362, 84206, 43, 1049, 82, 48);
INSERT INTO public.who_global_data VALUES (19248, 22, 7590, 0, 131, 82, 232);
INSERT INTO public.who_global_data VALUES (19249, 0, 1215, 0, 2, 82, 175);
INSERT INTO public.who_global_data VALUES (19250, 127, 7178, 1, 40, 82, 21);
INSERT INTO public.who_global_data VALUES (19251, 1887, 460116, 150, 6208, 82, 156);
INSERT INTO public.who_global_data VALUES (19252, 0, 0, 0, 0, 82, 95);
INSERT INTO public.who_global_data VALUES (19253, 29, 11788, 1, 319, 82, 177);
INSERT INTO public.who_global_data VALUES (19254, 1058, 62136, 3, 760, 82, 210);
INSERT INTO public.who_global_data VALUES (19255, 4, 5649, 0, 61, 82, 120);
INSERT INTO public.who_global_data VALUES (19256, 0, 68, 0, 0, 82, 135);
INSERT INTO public.who_global_data VALUES (19257, 499, 133724, 3, 2285, 82, 206);
INSERT INTO public.who_global_data VALUES (19258, 668, 180295, 11, 13008, 82, 189);
INSERT INTO public.who_global_data VALUES (19259, 220, 110767, 11, 6453, 82, 129);
INSERT INTO public.who_global_data VALUES (19260, 0, 36358, 5, 1044, 82, 121);
INSERT INTO public.who_global_data VALUES (19261, 0, 5104, 0, 85, 82, 59);
INSERT INTO public.who_global_data VALUES (19262, 0, 493, 0, 0, 82, 96);
INSERT INTO public.who_global_data VALUES (19263, 489, 7637, 1, 81, 82, 41);
INSERT INTO public.who_global_data VALUES (19264, 2, 6095, 0, 119, 82, 216);
INSERT INTO public.who_global_data VALUES (19265, 399, 102720, 4, 1569, 82, 236);
INSERT INTO public.who_global_data VALUES (19266, 0, 15, 0, 0, 82, 150);
INSERT INTO public.who_global_data VALUES (19267, 1, 498, 0, 0, 82, 61);
INSERT INTO public.who_global_data VALUES (19268, 0, 35, 0, 2, 82, 7);
INSERT INTO public.who_global_data VALUES (19269, 213, 19315, 0, 369, 82, 169);
INSERT INTO public.who_global_data VALUES (19270, 27123, 1945468, 302, 44215, 82, 28);
INSERT INTO public.who_global_data VALUES (19271, 0, 10844, 0, 70, 82, 85);
INSERT INTO public.who_global_data VALUES (19272, 0, 11706, 0, 53, 82, 211);
INSERT INTO public.who_global_data VALUES (19273, 0, 9062, 0, 58, 82, 60);
INSERT INTO public.who_global_data VALUES (19274, 0, 3702, 0, 122, 82, 3);
INSERT INTO public.who_global_data VALUES (19275, 3157, 82835, 30, 733, 82, 11);
INSERT INTO public.who_global_data VALUES (19276, 10824, 801327, 62, 12547, 82, 89);
INSERT INTO public.who_global_data VALUES (19277, 105, 50123, 2, 322, 82, 24);
INSERT INTO public.who_global_data VALUES (19278, 11, 887, 0, 1, 82, 162);
INSERT INTO public.who_global_data VALUES (19279, 1695, 74205, 71, 1106, 82, 100);
INSERT INTO public.who_global_data VALUES (19280, 0, 17, 0, 0, 82, 47);
INSERT INTO public.who_global_data VALUES (19281, 1, 33, 0, 0, 82, 29);
INSERT INTO public.who_global_data VALUES (19282, 83, 8181, 0, 139, 82, 40);
INSERT INTO public.who_global_data VALUES (19283, 156, 6010, 1, 94, 82, 222);
INSERT INTO public.who_global_data VALUES (19284, 166, 114885, 12, 3932, 82, 132);
INSERT INTO public.who_global_data VALUES (19285, 0, 282, 0, 13, 82, 130);
INSERT INTO public.who_global_data VALUES (19286, 26, 12611, 1, 75, 82, 234);
INSERT INTO public.who_global_data VALUES (19287, 0, 2419, 0, 43, 82, 23);
INSERT INTO public.who_global_data VALUES (19288, 70, 4794, 0, 138, 82, 192);
INSERT INTO public.who_global_data VALUES (19289, 11, 9179, 0, 232, 82, 69);
INSERT INTO public.who_global_data VALUES (19290, 0, 26, 0, 0, 82, 187);
INSERT INTO public.who_global_data VALUES (19291, 476, 102555, 2, 2822, 82, 230);
INSERT INTO public.who_global_data VALUES (19292, 6495, 147456, 93, 3190, 82, 77);
INSERT INTO public.who_global_data VALUES (19293, 3, 5189, 0, 25, 82, 9);
INSERT INTO public.who_global_data VALUES (19294, 30548, 8845127, 435, 130070, 82, 74);
INSERT INTO public.who_global_data VALUES (19295, 4106, 467113, 63, 15211, 82, 224);
INSERT INTO public.who_global_data VALUES (19296, 12543, 762068, 459, 41493, 82, 199);
INSERT INTO public.who_global_data VALUES (19297, 2237, 519152, 47, 11670, 82, 190);
INSERT INTO public.who_global_data VALUES (19298, 377, 67903, 1, 1979, 82, 12);
INSERT INTO public.who_global_data VALUES (19299, 0, 363, 0, 25, 82, 104);
INSERT INTO public.who_global_data VALUES (19300, 291, 323473, 12, 2739, 82, 153);
INSERT INTO public.who_global_data VALUES (19301, 33977, 1178529, 546, 45229, 82, 91);
INSERT INTO public.who_global_data VALUES (19302, 104, 9884, 2, 231, 82, 215);
INSERT INTO public.who_global_data VALUES (19303, 1459, 118136, 2, 1885, 82, 84);
INSERT INTO public.who_global_data VALUES (19304, 0, 728, 0, 32, 82, 231);
INSERT INTO public.who_global_data VALUES (19305, 2373, 143678, 68, 1772, 82, 196);
INSERT INTO public.who_global_data VALUES (19306, 625, 161873, 0, 2365, 82, 105);
INSERT INTO public.who_global_data VALUES (19307, 972, 70245, 20, 1269, 82, 122);
INSERT INTO public.who_global_data VALUES (19308, 0, 0, 0, 0, 82, 159);
INSERT INTO public.who_global_data VALUES (19309, 501, 29074, 13, 812, 82, 75);
INSERT INTO public.who_global_data VALUES (19310, 499, 136840, 3, 838, 82, 27);
INSERT INTO public.who_global_data VALUES (19311, 479, 66983, 4, 1203, 82, 54);
INSERT INTO public.who_global_data VALUES (19312, 0, 24, 0, 0, 82, 226);
INSERT INTO public.who_global_data VALUES (19313, 316, 10547, 2, 123, 82, 79);
INSERT INTO public.who_global_data VALUES (19314, 1163, 105430, 11, 817, 82, 56);
INSERT INTO public.who_global_data VALUES (19315, 0, 1967, 0, 44, 82, 117);
INSERT INTO public.who_global_data VALUES (19316, 9, 1507, 0, 82, 82, 152);
INSERT INTO public.who_global_data VALUES (19317, 974, 73602, 22, 1017, 82, 16);
INSERT INTO public.who_global_data VALUES (19318, 11, 1022, 2, 7, 82, 10);
INSERT INTO public.who_global_data VALUES (19319, 1148, 35878, 15, 311, 82, 201);
INSERT INTO public.who_global_data VALUES (19320, 613, 26544, 3, 222, 82, 174);
INSERT INTO public.who_global_data VALUES (19321, 0, 17233, 0, 249, 82, 119);
INSERT INTO public.who_global_data VALUES (19322, 1, 5965, 0, 185, 82, 168);
INSERT INTO public.who_global_data VALUES (19323, 1208, 47417, 3, 309, 82, 99);
INSERT INTO public.who_global_data VALUES (19324, 50, 12204, 1, 43, 82, 171);
INSERT INTO public.who_global_data VALUES (19325, 32, 3900, 2, 141, 82, 87);
INSERT INTO public.who_global_data VALUES (19326, 103, 8126, 1, 95, 82, 123);
INSERT INTO public.who_global_data VALUES (19327, 0, 1, 0, 0, 82, 151);
INSERT INTO public.who_global_data VALUES (19328, 0, 4732, 0, 37, 82, 213);
INSERT INTO public.who_global_data VALUES (19329, 0, 7885, 0, 165, 82, 118);
INSERT INTO public.who_global_data VALUES (19330, 0, 470, 0, 10, 82, 134);
INSERT INTO public.who_global_data VALUES (19331, 22, 4943, 0, 46, 82, 65);
INSERT INTO public.who_global_data VALUES (19332, 5860, 1003253, 635, 98259, 82, 102);
INSERT INTO public.who_global_data VALUES (19333, 0, 0, 0, 0, 82, 223);
INSERT INTO public.who_global_data VALUES (19334, 3, 551, 0, 2, 82, 4);
INSERT INTO public.who_global_data VALUES (19335, 12, 428, 0, 0, 82, 146);
INSERT INTO public.who_global_data VALUES (19336, 625, 28302, 5, 395, 82, 31);
INSERT INTO public.who_global_data VALUES (19337, 0, 13, 0, 1, 82, 127);
INSERT INTO public.who_global_data VALUES (19338, 4966, 293177, 82, 4779, 82, 22);
INSERT INTO public.who_global_data VALUES (19339, 108, 14448, 3, 113, 82, 115);
INSERT INTO public.who_global_data VALUES (19340, 2260, 68994, 43, 1577, 82, 106);
INSERT INTO public.who_global_data VALUES (19341, 59, 13508, 0, 138, 82, 90);
INSERT INTO public.who_global_data VALUES (19342, 0, 0, 0, 0, 82, 70);
INSERT INTO public.who_global_data VALUES (19343, 1477, 209776, 6, 1221, 82, 46);
INSERT INTO public.who_global_data VALUES (19344, 5419, 446711, 44, 8466, 82, 139);
INSERT INTO public.who_global_data VALUES (19345, 0, 30, 0, 0, 82, 42);
INSERT INTO public.who_global_data VALUES (19346, 0, 1645, 0, 25, 82, 80);
INSERT INTO public.who_global_data VALUES (19347, 0, 4533, 0, 158, 82, 203);
INSERT INTO public.who_global_data VALUES (19348, 6, 1307, 0, 70, 82, 136);
INSERT INTO public.who_global_data VALUES (19349, 152, 65148, 0, 1163, 82, 63);
INSERT INTO public.who_global_data VALUES (19350, 0, 0, 0, 0, 82, 17);
INSERT INTO public.who_global_data VALUES (19351, 0, 102, 0, 2, 82, 172);
INSERT INTO public.who_global_data VALUES (19352, 988, 47050, 24, 1305, 82, 109);
INSERT INTO public.who_global_data VALUES (19353, 0, 27226, 0, 294, 82, 200);
INSERT INTO public.who_global_data VALUES (19354, 976, 75326, 7, 640, 82, 93);
INSERT INTO public.who_global_data VALUES (19355, 947, 120389, 12, 1338, 82, 5);
INSERT INTO public.who_global_data VALUES (19356, 0, 741, 0, 13, 82, 214);
INSERT INTO public.who_global_data VALUES (19357, 2443, 356904, 32, 7141, 82, 204);
INSERT INTO public.who_global_data VALUES (19358, 0, 0, 0, 0, 82, 198);
INSERT INTO public.who_global_data VALUES (19359, 832, 145309, 11, 2867, 82, 173);
INSERT INTO public.who_global_data VALUES (19360, 2, 602, 0, 7, 82, 229);
INSERT INTO public.who_global_data VALUES (19361, 673, 71065, 13, 1569, 82, 76);
INSERT INTO public.who_global_data VALUES (19362, 2249, 934899, 71, 35177, 82, 138);
INSERT INTO public.who_global_data VALUES (19363, 1501, 407838, 41, 7832, 82, 98);
INSERT INTO public.who_global_data VALUES (19364, 0, 0, 0, 0, 82, 103);
INSERT INTO public.who_global_data VALUES (19365, 21854, 712972, 303, 10348, 82, 225);
INSERT INTO public.who_global_data VALUES (19366, 6035, 217301, 76, 3381, 82, 131);
INSERT INTO public.who_global_data VALUES (19367, 707, 42479, 14, 935, 82, 235);
INSERT INTO public.who_global_data VALUES (19368, 215, 135785, 0, 234, 82, 137);
INSERT INTO public.who_global_data VALUES (19369, 222, 28766, 1, 494, 82, 81);
INSERT INTO public.who_global_data VALUES (19370, 507, 89279, 13, 2019, 82, 182);
INSERT INTO public.who_global_data VALUES (19371, 0, 6881, 0, 29, 82, 145);
INSERT INTO public.who_global_data VALUES (19372, 7096, 360281, 113, 8926, 82, 26);
INSERT INTO public.who_global_data VALUES (19373, 22778, 1948603, 303, 33489, 82, 170);
INSERT INTO public.who_global_data VALUES (19374, 61, 5455, 0, 42, 82, 191);
INSERT INTO public.who_global_data VALUES (19375, 0, 5, 0, 0, 82, 221);
INSERT INTO public.who_global_data VALUES (19376, 0, 109, 0, 0, 82, 64);
INSERT INTO public.who_global_data VALUES (19377, 0, 0, 0, 0, 82, 116);
INSERT INTO public.who_global_data VALUES (19378, 0, 19, 0, 0, 82, 128);
INSERT INTO public.who_global_data VALUES (19379, 2, 162, 0, 2, 82, 6);
INSERT INTO public.who_global_data VALUES (19380, 0, 655, 0, 12, 82, 227);
INSERT INTO public.who_global_data VALUES (19381, 0, 14, 0, 0, 82, 68);
INSERT INTO public.who_global_data VALUES (19382, 0, 78, 0, 0, 82, 184);
INSERT INTO public.who_global_data VALUES (19383, 0, 0, 0, 0, 82, 82);
INSERT INTO public.who_global_data VALUES (19384, 37, 1290, 0, 42, 82, 149);
INSERT INTO public.who_global_data VALUES (19385, 1, 965, 0, 16, 82, 197);
INSERT INTO public.who_global_data VALUES (19386, 305, 353255, 16, 5657, 82, 78);
INSERT INTO public.who_global_data VALUES (19387, 14, 15793, 1, 328, 82, 233);
INSERT INTO public.who_global_data VALUES (19388, 3482, 84568, 20, 1009, 82, 133);
INSERT INTO public.who_global_data VALUES (19389, 0, 158, 0, 0, 82, 35);
INSERT INTO public.who_global_data VALUES (19390, 2, 2391, 0, 74, 82, 114);
INSERT INTO public.who_global_data VALUES (19391, 3, 58119, 0, 28, 82, 237);
INSERT INTO public.who_global_data VALUES (19392, 0, 14, 0, 0, 82, 55);
INSERT INTO public.who_global_data VALUES (19393, 0, 914, 0, 23, 82, 176);
INSERT INTO public.who_global_data VALUES (19394, 1200, 86767, 0, 510, 82, 202);
INSERT INTO public.who_global_data VALUES (19395, 500, 55583, 34, 912, 82, 155);
INSERT INTO public.who_global_data VALUES (19396, 0, 16, 0, 0, 82, 32);
INSERT INTO public.who_global_data VALUES (19397, 0, 4301, 0, 107, 82, 220);
INSERT INTO public.who_global_data VALUES (19398, 1842, 751024, 35, 20241, 82, 30);
INSERT INTO public.who_global_data VALUES (19399, 9, 3012, 0, 59, 82, 147);
INSERT INTO public.who_global_data VALUES (19400, 10591, 1562633, 267, 43170, 82, 208);
INSERT INTO public.who_global_data VALUES (19401, 1096, 17287, 5, 58, 82, 45);
INSERT INTO public.who_global_data VALUES (19402, 319, 15047, 56, 1175, 82, 110);
INSERT INTO public.who_global_data VALUES (19403, 6, 5274, 0, 114, 82, 88);
INSERT INTO public.who_global_data VALUES (19404, 3513, 188472, 38, 6409, 82, 51);
INSERT INTO public.who_global_data VALUES (19405, 2314, 270641, 83, 3491, 82, 209);
INSERT INTO public.who_global_data VALUES (19406, 71, 6684, 4, 345, 82, 205);
INSERT INTO public.who_global_data VALUES (19407, 37, 11610, 0, 85, 82, 18);
INSERT INTO public.who_global_data VALUES (19408, 9, 3875, 0, 60, 82, 72);
INSERT INTO public.who_global_data VALUES (19409, 24962, 1369322, 168, 51934, 82, 44);
INSERT INTO public.who_global_data VALUES (19410, 0, 30, 0, 0, 82, 15);
INSERT INTO public.who_global_data VALUES (19411, 0, 2605, 0, 60, 82, 25);
INSERT INTO public.who_global_data VALUES (19412, 0, 0, 0, 0, 82, 179);
INSERT INTO public.who_global_data VALUES (19413, 0, 0, 0, 0, 82, 34);
INSERT INTO public.who_global_data VALUES (19414, 97, 6077, 1, 112, 82, 207);
INSERT INTO public.who_global_data VALUES (19415, 1065, 80404, 66, 2345, 82, 166);
INSERT INTO public.who_global_data VALUES (19416, 9953, 1161308, 89, 11507, 82, 126);
INSERT INTO public.who_global_data VALUES (19417, 0, 0, 0, 0, 82, 97);
INSERT INTO public.who_global_data VALUES (19418, 4, 720, 0, 6, 82, 36);
INSERT INTO public.who_global_data VALUES (19419, 0, 0, 0, 0, 82, 125);
INSERT INTO public.who_global_data VALUES (19420, 231, 16020, 1, 145, 82, 124);
INSERT INTO public.who_global_data VALUES (19421, 9832, 545689, 94, 9697, 82, 185);
INSERT INTO public.who_global_data VALUES (19422, 1210, 150345, 2, 530, 82, 194);
INSERT INTO public.who_global_data VALUES (19423, 0, 509, 0, 21, 82, 144);
INSERT INTO public.who_global_data VALUES (19424, 155001, 10796432, 1216, 243758, 82, 19);
INSERT INTO public.who_global_data VALUES (19425, 0, 1434, 0, 23, 82, 217);
INSERT INTO public.who_global_data VALUES (19426, 74, 3957, 0, 64, 82, 148);
INSERT INTO public.who_global_data VALUES (19427, 141, 70243, 0, 598, 82, 86);
INSERT INTO public.who_global_data VALUES (19428, 0, 1, 0, 0, 82, 13);
INSERT INTO public.who_global_data VALUES (19429, 492, 96933, 4, 848, 82, 157);
INSERT INTO public.who_global_data VALUES (19430, 16, 1281, 0, 35, 82, 8);
INSERT INTO public.who_global_data VALUES (19431, 0, 1, 0, 0, 82, 73);
INSERT INTO public.who_global_data VALUES (19432, 0, 2072, 1, 604, 82, 101);
INSERT INTO public.who_global_data VALUES (19433, 26, 17123, 3, 353, 82, 165);
INSERT INTO public.who_global_data VALUES (19434, 43, 8829, 0, 257, 82, 14);
INSERT INTO public.who_global_data VALUES (19435, 66, 43035, 10, 1605, 83, 193);
INSERT INTO public.who_global_data VALUES (19436, 532, 27233, 7, 612, 83, 113);
INSERT INTO public.who_global_data VALUES (19437, 0, 65975, 0, 2125, 83, 143);
INSERT INTO public.who_global_data VALUES (19438, 0, 0, 0, 0, 83, 219);
INSERT INTO public.who_global_data VALUES (19439, 0, 5725, 0, 75, 83, 186);
INSERT INTO public.who_global_data VALUES (19440, 146, 13374, 5, 322, 83, 52);
INSERT INTO public.who_global_data VALUES (19441, 0, 3, 0, 0, 83, 180);
INSERT INTO public.who_global_data VALUES (19442, 0, 133, 1, 4, 83, 167);
INSERT INTO public.who_global_data VALUES (19443, 11859, 1296378, 263, 35045, 83, 154);
INSERT INTO public.who_global_data VALUES (19444, 1482, 116650, 25, 1758, 83, 94);
INSERT INTO public.who_global_data VALUES (19445, 0, 4639, 0, 43, 83, 66);
INSERT INTO public.who_global_data VALUES (19446, 8, 27711, 0, 907, 83, 58);
INSERT INTO public.who_global_data VALUES (19447, 7192, 198216, 55, 1629, 83, 163);
INSERT INTO public.who_global_data VALUES (19448, 1849, 73429, 19, 946, 83, 37);
INSERT INTO public.who_global_data VALUES (19449, 0, 7163, 0, 155, 83, 142);
INSERT INTO public.who_global_data VALUES (19450, 174, 84523, 1, 333, 83, 83);
INSERT INTO public.who_global_data VALUES (19451, 1531, 430496, 14, 6173, 83, 228);
INSERT INTO public.who_global_data VALUES (19452, 0, 249, 0, 7, 83, 188);
INSERT INTO public.who_global_data VALUES (19453, 1248, 112870, 6, 1039, 83, 62);
INSERT INTO public.who_global_data VALUES (19454, 2371, 538373, 176, 14550, 83, 160);
INSERT INTO public.who_global_data VALUES (19455, 119, 4715, 10, 85, 83, 50);
INSERT INTO public.who_global_data VALUES (19456, 0, 2844, 0, 43, 83, 33);
INSERT INTO public.who_global_data VALUES (19457, 0, 222, 0, 9, 83, 183);
INSERT INTO public.who_global_data VALUES (19458, 6, 375, 0, 0, 83, 92);
INSERT INTO public.who_global_data VALUES (19459, 180, 143069, 10, 8835, 83, 158);
INSERT INTO public.who_global_data VALUES (19460, 0, 136, 0, 3, 83, 67);
INSERT INTO public.who_global_data VALUES (19461, 1275, 70900, 49, 1857, 83, 57);
INSERT INTO public.who_global_data VALUES (19462, 0, 8225, 0, 27, 83, 38);
INSERT INTO public.who_global_data VALUES (19463, 29070, 5810652, 456, 164737, 83, 141);
INSERT INTO public.who_global_data VALUES (19464, 0, 72, 0, 1, 83, 178);
INSERT INTO public.who_global_data VALUES (19465, 0, 148, 0, 3, 83, 108);
INSERT INTO public.who_global_data VALUES (19466, 2498, 97435, 36, 2091, 83, 39);
INSERT INTO public.who_global_data VALUES (19467, 26, 2635, 0, 68, 83, 2);
INSERT INTO public.who_global_data VALUES (19468, 1, 628, 0, 1, 83, 195);
INSERT INTO public.who_global_data VALUES (19469, 39, 9780, 0, 102, 83, 107);
INSERT INTO public.who_global_data VALUES (19470, 0, 302, 0, 0, 83, 161);
INSERT INTO public.who_global_data VALUES (19471, 0, 22692, 0, 433, 83, 212);
INSERT INTO public.who_global_data VALUES (19472, 4741, 287318, 60, 10828, 83, 181);
INSERT INTO public.who_global_data VALUES (19473, 0, 254, 0, 1, 83, 53);
INSERT INTO public.who_global_data VALUES (19474, 4, 4900, 0, 63, 83, 164);
INSERT INTO public.who_global_data VALUES (19475, 2, 1591, 0, 100, 83, 140);
INSERT INTO public.who_global_data VALUES (19476, 1646, 529676, 39, 14777, 83, 20);
INSERT INTO public.who_global_data VALUES (19477, 24, 92428, 0, 4749, 83, 112);
INSERT INTO public.who_global_data VALUES (19478, 8685, 1182697, 178, 33669, 83, 111);
INSERT INTO public.who_global_data VALUES (19479, 0, 574, 0, 7, 83, 71);
INSERT INTO public.who_global_data VALUES (19480, 0, 5515, 0, 92, 83, 218);
INSERT INTO public.who_global_data VALUES (19481, 0, 0, 0, 0, 83, 43);
INSERT INTO public.who_global_data VALUES (19482, 1184, 122123, 10, 1537, 83, 49);
INSERT INTO public.who_global_data VALUES (19483, 46, 20945, 1, 128, 83, 1);
INSERT INTO public.who_global_data VALUES (19484, 2866, 81844, 38, 1006, 83, 48);
INSERT INTO public.who_global_data VALUES (19485, 27, 7568, 0, 131, 83, 232);
INSERT INTO public.who_global_data VALUES (19486, 0, 1215, 0, 2, 83, 175);
INSERT INTO public.who_global_data VALUES (19487, 198, 7051, 1, 39, 83, 21);
INSERT INTO public.who_global_data VALUES (19488, 4199, 458229, 132, 6058, 83, 156);
INSERT INTO public.who_global_data VALUES (19489, 0, 0, 0, 0, 83, 95);
INSERT INTO public.who_global_data VALUES (19490, 68, 11759, 0, 318, 83, 177);
INSERT INTO public.who_global_data VALUES (19491, 1078, 61078, 1, 757, 83, 210);
INSERT INTO public.who_global_data VALUES (19492, 1, 5645, 0, 61, 83, 120);
INSERT INTO public.who_global_data VALUES (19493, 0, 68, 0, 0, 83, 135);
INSERT INTO public.who_global_data VALUES (19494, 671, 133225, 2, 2282, 83, 206);
INSERT INTO public.who_global_data VALUES (19495, 953, 179627, 20, 12997, 83, 189);
INSERT INTO public.who_global_data VALUES (19496, 228, 110547, 13, 6442, 83, 129);
INSERT INTO public.who_global_data VALUES (19497, 163, 36358, 6, 1039, 83, 121);
INSERT INTO public.who_global_data VALUES (19498, 0, 5104, 0, 85, 83, 59);
INSERT INTO public.who_global_data VALUES (19499, 0, 493, 0, 0, 83, 96);
INSERT INTO public.who_global_data VALUES (19500, 0, 7148, 0, 80, 83, 41);
INSERT INTO public.who_global_data VALUES (19501, 17, 6093, 1, 119, 83, 216);
INSERT INTO public.who_global_data VALUES (19502, 564, 102321, 7, 1565, 83, 236);
INSERT INTO public.who_global_data VALUES (19503, 0, 15, 0, 0, 83, 150);
INSERT INTO public.who_global_data VALUES (19504, 0, 497, 0, 0, 83, 61);
INSERT INTO public.who_global_data VALUES (19505, 0, 35, 0, 2, 83, 7);
INSERT INTO public.who_global_data VALUES (19506, 244, 19102, 0, 369, 83, 169);
INSERT INTO public.who_global_data VALUES (19507, 32059, 1918345, 354, 43913, 83, 28);
INSERT INTO public.who_global_data VALUES (19508, 36, 10844, 0, 70, 83, 85);
INSERT INTO public.who_global_data VALUES (19509, 0, 11706, 0, 53, 83, 211);
INSERT INTO public.who_global_data VALUES (19510, 0, 9062, 0, 58, 83, 60);
INSERT INTO public.who_global_data VALUES (19511, 4, 3702, 0, 122, 83, 3);
INSERT INTO public.who_global_data VALUES (19512, 3020, 79678, 34, 703, 83, 11);
INSERT INTO public.who_global_data VALUES (19513, 16947, 790503, 107, 12485, 83, 89);
INSERT INTO public.who_global_data VALUES (19514, 0, 50018, 0, 320, 83, 24);
INSERT INTO public.who_global_data VALUES (19515, 12, 876, 0, 1, 83, 162);
INSERT INTO public.who_global_data VALUES (19516, 2835, 72510, 38, 1035, 83, 100);
INSERT INTO public.who_global_data VALUES (19517, 0, 17, 0, 0, 83, 47);
INSERT INTO public.who_global_data VALUES (19518, 0, 32, 0, 0, 83, 29);
INSERT INTO public.who_global_data VALUES (19519, 0, 8098, 0, 139, 83, 40);
INSERT INTO public.who_global_data VALUES (19520, 41, 5854, 0, 93, 83, 222);
INSERT INTO public.who_global_data VALUES (19521, 596, 114719, 40, 3920, 83, 132);
INSERT INTO public.who_global_data VALUES (19522, 0, 282, 0, 13, 83, 130);
INSERT INTO public.who_global_data VALUES (19523, 48, 12585, 0, 74, 83, 234);
INSERT INTO public.who_global_data VALUES (19524, 0, 2419, 0, 43, 83, 23);
INSERT INTO public.who_global_data VALUES (19525, 62, 4724, 0, 138, 83, 192);
INSERT INTO public.who_global_data VALUES (19526, 0, 9168, 0, 232, 83, 69);
INSERT INTO public.who_global_data VALUES (19527, 0, 26, 0, 0, 83, 187);
INSERT INTO public.who_global_data VALUES (19528, 611, 102079, 16, 2820, 83, 230);
INSERT INTO public.who_global_data VALUES (19529, 4238, 140961, 107, 3097, 83, 77);
INSERT INTO public.who_global_data VALUES (19530, 16, 5186, 0, 25, 83, 9);
INSERT INTO public.who_global_data VALUES (19531, 41100, 8814579, 447, 129635, 83, 74);
INSERT INTO public.who_global_data VALUES (19532, 5272, 463007, 111, 15148, 83, 224);
INSERT INTO public.who_global_data VALUES (19533, 11203, 749525, 452, 41034, 83, 199);
INSERT INTO public.who_global_data VALUES (19534, 2419, 516915, 43, 11623, 83, 190);
INSERT INTO public.who_global_data VALUES (19535, 427, 67526, 6, 1978, 83, 12);
INSERT INTO public.who_global_data VALUES (19536, 0, 363, 0, 25, 83, 104);
INSERT INTO public.who_global_data VALUES (19537, 761, 323182, 5, 2727, 83, 153);
INSERT INTO public.who_global_data VALUES (19538, 37249, 1144552, 544, 44683, 83, 91);
INSERT INTO public.who_global_data VALUES (19539, 57, 9780, 2, 229, 83, 215);
INSERT INTO public.who_global_data VALUES (19540, 1694, 116677, 3, 1883, 83, 84);
INSERT INTO public.who_global_data VALUES (19541, 7, 728, 0, 32, 83, 231);
INSERT INTO public.who_global_data VALUES (19542, 4750, 141305, 86, 1704, 83, 196);
INSERT INTO public.who_global_data VALUES (19543, 636, 161248, 59, 2365, 83, 105);
INSERT INTO public.who_global_data VALUES (19544, 1080, 69273, 21, 1249, 83, 122);
INSERT INTO public.who_global_data VALUES (19545, 0, 0, 0, 0, 83, 159);
INSERT INTO public.who_global_data VALUES (19546, 765, 28573, 11, 799, 83, 75);
INSERT INTO public.who_global_data VALUES (19547, 691, 136341, 2, 835, 83, 27);
INSERT INTO public.who_global_data VALUES (19548, 551, 66504, 3, 1199, 83, 54);
INSERT INTO public.who_global_data VALUES (19549, 0, 24, 0, 0, 83, 226);
INSERT INTO public.who_global_data VALUES (19550, 395, 10231, 5, 121, 83, 79);
INSERT INTO public.who_global_data VALUES (19551, 1660, 104267, 10, 806, 83, 56);
INSERT INTO public.who_global_data VALUES (19552, 0, 1967, 0, 44, 83, 117);
INSERT INTO public.who_global_data VALUES (19553, 7, 1498, 0, 82, 83, 152);
INSERT INTO public.who_global_data VALUES (19554, 0, 72628, 0, 995, 83, 16);
INSERT INTO public.who_global_data VALUES (19555, 18, 1011, 0, 5, 83, 10);
INSERT INTO public.who_global_data VALUES (19556, 1374, 34730, 14, 296, 83, 201);
INSERT INTO public.who_global_data VALUES (19557, 713, 25931, 8, 219, 83, 174);
INSERT INTO public.who_global_data VALUES (19558, 0, 17233, 0, 249, 83, 119);
INSERT INTO public.who_global_data VALUES (19559, 2, 5964, 0, 185, 83, 168);
INSERT INTO public.who_global_data VALUES (19560, 1114, 46209, 2, 306, 83, 99);
INSERT INTO public.who_global_data VALUES (19561, 42, 12154, 1, 42, 83, 171);
INSERT INTO public.who_global_data VALUES (19562, 62, 3868, 0, 139, 83, 87);
INSERT INTO public.who_global_data VALUES (19563, 117, 8023, 3, 94, 83, 123);
INSERT INTO public.who_global_data VALUES (19564, 0, 1, 0, 0, 83, 151);
INSERT INTO public.who_global_data VALUES (19565, 0, 4732, 0, 37, 83, 213);
INSERT INTO public.who_global_data VALUES (19566, 0, 7885, 0, 165, 83, 118);
INSERT INTO public.who_global_data VALUES (19567, 0, 470, 0, 10, 83, 134);
INSERT INTO public.who_global_data VALUES (19568, 0, 4921, 0, 46, 83, 65);
INSERT INTO public.who_global_data VALUES (19569, 5558, 997393, 568, 97624, 83, 102);
INSERT INTO public.who_global_data VALUES (19570, 0, 0, 0, 0, 83, 223);
INSERT INTO public.who_global_data VALUES (19571, 5, 548, 0, 2, 83, 4);
INSERT INTO public.who_global_data VALUES (19572, 4, 416, 0, 0, 83, 146);
INSERT INTO public.who_global_data VALUES (19573, 463, 27677, 6, 390, 83, 31);
INSERT INTO public.who_global_data VALUES (19574, 0, 13, 0, 1, 83, 127);
INSERT INTO public.who_global_data VALUES (19575, 5875, 288211, 66, 4697, 83, 22);
INSERT INTO public.who_global_data VALUES (19576, 113, 14340, 0, 110, 83, 115);
INSERT INTO public.who_global_data VALUES (19577, 1136, 66734, 26, 1534, 83, 106);
INSERT INTO public.who_global_data VALUES (19578, 77, 13449, 0, 138, 83, 90);
INSERT INTO public.who_global_data VALUES (19579, 0, 0, 0, 0, 83, 70);
INSERT INTO public.who_global_data VALUES (19580, 1946, 208299, 13, 1215, 83, 46);
INSERT INTO public.who_global_data VALUES (19581, 5901, 441292, 84, 8422, 83, 139);
INSERT INTO public.who_global_data VALUES (19582, 0, 30, 0, 0, 83, 42);
INSERT INTO public.who_global_data VALUES (19583, 3, 1645, 0, 25, 83, 80);
INSERT INTO public.who_global_data VALUES (19584, 0, 4533, 0, 158, 83, 203);
INSERT INTO public.who_global_data VALUES (19585, 19, 1301, 1, 70, 83, 136);
INSERT INTO public.who_global_data VALUES (19586, 112, 64996, 0, 1163, 83, 63);
INSERT INTO public.who_global_data VALUES (19587, 0, 0, 0, 0, 83, 17);
INSERT INTO public.who_global_data VALUES (19588, 2, 102, 0, 2, 83, 172);
INSERT INTO public.who_global_data VALUES (19589, 1164, 46062, 18, 1281, 83, 109);
INSERT INTO public.who_global_data VALUES (19590, 0, 27226, 0, 294, 83, 200);
INSERT INTO public.who_global_data VALUES (19591, 653, 74350, 10, 633, 83, 93);
INSERT INTO public.who_global_data VALUES (19592, 0, 119442, 0, 1326, 83, 5);
INSERT INTO public.who_global_data VALUES (19593, 0, 741, 0, 13, 83, 214);
INSERT INTO public.who_global_data VALUES (19594, 2165, 354461, 17, 7109, 83, 204);
INSERT INTO public.who_global_data VALUES (19595, 0, 0, 0, 0, 83, 198);
INSERT INTO public.who_global_data VALUES (19596, 1125, 144477, 26, 2856, 83, 173);
INSERT INTO public.who_global_data VALUES (19597, 0, 600, 0, 7, 83, 229);
INSERT INTO public.who_global_data VALUES (19598, 739, 70392, 13, 1556, 83, 76);
INSERT INTO public.who_global_data VALUES (19599, 2413, 932650, 39, 35106, 83, 138);
INSERT INTO public.who_global_data VALUES (19600, 1624, 406337, 39, 7791, 83, 98);
INSERT INTO public.who_global_data VALUES (19601, 0, 0, 0, 0, 83, 103);
INSERT INTO public.who_global_data VALUES (19602, 25571, 691118, 546, 10045, 83, 225);
INSERT INTO public.who_global_data VALUES (19603, 6602, 211266, 55, 3305, 83, 131);
INSERT INTO public.who_global_data VALUES (19604, 653, 41772, 7, 921, 83, 235);
INSERT INTO public.who_global_data VALUES (19605, 203, 135570, 0, 234, 83, 137);
INSERT INTO public.who_global_data VALUES (19606, 208, 28544, 1, 493, 83, 81);
INSERT INTO public.who_global_data VALUES (19607, 1411, 88772, 19, 2006, 83, 182);
INSERT INTO public.who_global_data VALUES (19608, 0, 6881, 0, 29, 83, 145);
INSERT INTO public.who_global_data VALUES (19609, 9460, 353185, 129, 8813, 83, 26);
INSERT INTO public.who_global_data VALUES (19610, 22572, 1925825, 352, 33186, 83, 170);
INSERT INTO public.who_global_data VALUES (19611, 32, 5394, 0, 42, 83, 191);
INSERT INTO public.who_global_data VALUES (19612, 0, 5, 0, 0, 83, 221);
INSERT INTO public.who_global_data VALUES (19613, 0, 109, 0, 0, 83, 64);
INSERT INTO public.who_global_data VALUES (19614, 0, 0, 0, 0, 83, 116);
INSERT INTO public.who_global_data VALUES (19615, 0, 19, 0, 0, 83, 128);
INSERT INTO public.who_global_data VALUES (19616, 4, 160, 0, 2, 83, 6);
INSERT INTO public.who_global_data VALUES (19617, 0, 655, 0, 12, 83, 227);
INSERT INTO public.who_global_data VALUES (19618, 0, 14, 0, 0, 83, 68);
INSERT INTO public.who_global_data VALUES (19619, 0, 78, 0, 0, 83, 184);
INSERT INTO public.who_global_data VALUES (19620, 0, 0, 0, 0, 83, 82);
INSERT INTO public.who_global_data VALUES (19621, 0, 1253, 0, 42, 83, 149);
INSERT INTO public.who_global_data VALUES (19622, 1, 964, 0, 16, 83, 197);
INSERT INTO public.who_global_data VALUES (19623, 349, 352950, 16, 5641, 83, 78);
INSERT INTO public.who_global_data VALUES (19624, 24, 15779, 1, 327, 83, 233);
INSERT INTO public.who_global_data VALUES (19625, 3822, 81086, 17, 989, 83, 133);
INSERT INTO public.who_global_data VALUES (19626, 0, 158, 0, 0, 83, 35);
INSERT INTO public.who_global_data VALUES (19627, 0, 2389, 0, 74, 83, 114);
INSERT INTO public.who_global_data VALUES (19628, 2, 58116, 0, 28, 83, 237);
INSERT INTO public.who_global_data VALUES (19629, 0, 14, 0, 0, 83, 55);
INSERT INTO public.who_global_data VALUES (19630, 0, 914, 0, 23, 83, 176);
INSERT INTO public.who_global_data VALUES (19631, 1771, 85567, 19, 510, 83, 202);
INSERT INTO public.who_global_data VALUES (19632, 922, 55083, 31, 878, 83, 155);
INSERT INTO public.who_global_data VALUES (19633, 0, 16, 0, 0, 83, 32);
INSERT INTO public.who_global_data VALUES (19634, 0, 4301, 0, 107, 83, 220);
INSERT INTO public.who_global_data VALUES (19635, 2237, 749182, 53, 20206, 83, 30);
INSERT INTO public.who_global_data VALUES (19636, 0, 3003, 0, 59, 83, 147);
INSERT INTO public.who_global_data VALUES (19637, 18318, 1552042, 302, 42903, 83, 208);
INSERT INTO public.who_global_data VALUES (19638, 468, 16191, 5, 53, 83, 45);
INSERT INTO public.who_global_data VALUES (19639, 102, 14728, 3, 1119, 83, 110);
INSERT INTO public.who_global_data VALUES (19640, 7, 5268, 0, 114, 83, 88);
INSERT INTO public.who_global_data VALUES (19641, 6730, 184959, 33, 6371, 83, 51);
INSERT INTO public.who_global_data VALUES (19642, 3203, 268327, 77, 3408, 83, 209);
INSERT INTO public.who_global_data VALUES (19643, 61, 6613, 4, 341, 83, 205);
INSERT INTO public.who_global_data VALUES (19644, 39, 11573, 0, 85, 83, 18);
INSERT INTO public.who_global_data VALUES (19645, 5, 3866, 0, 60, 83, 72);
INSERT INTO public.who_global_data VALUES (19646, 26860, 1344360, 462, 51766, 83, 44);
INSERT INTO public.who_global_data VALUES (19647, 0, 30, 0, 0, 83, 15);
INSERT INTO public.who_global_data VALUES (19648, 0, 2605, 0, 60, 83, 25);
INSERT INTO public.who_global_data VALUES (19649, 0, 0, 0, 0, 83, 179);
INSERT INTO public.who_global_data VALUES (19650, 0, 0, 0, 0, 83, 34);
INSERT INTO public.who_global_data VALUES (19651, 50, 5980, 0, 111, 83, 207);
INSERT INTO public.who_global_data VALUES (19652, 1671, 79339, 70, 2279, 83, 166);
INSERT INTO public.who_global_data VALUES (19653, 9846, 1151355, 92, 11418, 83, 126);
INSERT INTO public.who_global_data VALUES (19654, 0, 0, 0, 0, 83, 97);
INSERT INTO public.who_global_data VALUES (19655, 0, 716, 0, 6, 83, 36);
INSERT INTO public.who_global_data VALUES (19656, 0, 0, 0, 0, 83, 125);
INSERT INTO public.who_global_data VALUES (19657, 387, 15789, 0, 144, 83, 124);
INSERT INTO public.who_global_data VALUES (19658, 10681, 535857, 95, 9603, 83, 185);
INSERT INTO public.who_global_data VALUES (19659, 1174, 149135, 0, 528, 83, 194);
INSERT INTO public.who_global_data VALUES (19660, 0, 509, 0, 21, 83, 144);
INSERT INTO public.who_global_data VALUES (19661, 181066, 10641431, 1356, 242542, 83, 19);
INSERT INTO public.who_global_data VALUES (19662, 8, 1434, 0, 23, 83, 217);
INSERT INTO public.who_global_data VALUES (19663, 88, 3883, 1, 64, 83, 148);
INSERT INTO public.who_global_data VALUES (19664, 188, 70102, 2, 598, 83, 86);
INSERT INTO public.who_global_data VALUES (19665, 0, 1, 0, 0, 83, 13);
INSERT INTO public.who_global_data VALUES (19666, 301, 96441, 3, 844, 83, 157);
INSERT INTO public.who_global_data VALUES (19667, 9, 1265, 0, 35, 83, 8);
INSERT INTO public.who_global_data VALUES (19668, 0, 1, 0, 0, 83, 73);
INSERT INTO public.who_global_data VALUES (19669, 0, 2072, 0, 603, 83, 101);
INSERT INTO public.who_global_data VALUES (19670, 4, 17097, 0, 350, 83, 165);
INSERT INTO public.who_global_data VALUES (19671, 21, 8786, 0, 257, 83, 14);
INSERT INTO public.who_global_data VALUES (19672, 174, 42969, 4, 1595, 84, 193);
INSERT INTO public.who_global_data VALUES (19673, 490, 26701, 7, 605, 84, 113);
INSERT INTO public.who_global_data VALUES (19674, 867, 65975, 14, 2125, 84, 143);
INSERT INTO public.who_global_data VALUES (19675, 0, 0, 0, 0, 84, 219);
INSERT INTO public.who_global_data VALUES (19676, 109, 5725, 0, 75, 84, 186);
INSERT INTO public.who_global_data VALUES (19677, 171, 13228, 2, 317, 84, 52);
INSERT INTO public.who_global_data VALUES (19678, 0, 3, 0, 0, 84, 180);
INSERT INTO public.who_global_data VALUES (19679, 2, 133, 0, 3, 84, 167);
INSERT INTO public.who_global_data VALUES (19680, 11163, 1284519, 251, 34782, 84, 154);
INSERT INTO public.who_global_data VALUES (19681, 1472, 115168, 41, 1733, 84, 94);
INSERT INTO public.who_global_data VALUES (19682, 8, 4639, 0, 43, 84, 66);
INSERT INTO public.who_global_data VALUES (19683, 5, 27703, 0, 907, 84, 58);
INSERT INTO public.who_global_data VALUES (19684, 8962, 191024, 64, 1574, 84, 163);
INSERT INTO public.who_global_data VALUES (19685, 1364, 71580, 22, 927, 84, 37);
INSERT INTO public.who_global_data VALUES (19686, 39, 7163, 0, 155, 84, 142);
INSERT INTO public.who_global_data VALUES (19687, 157, 84349, 0, 332, 84, 83);
INSERT INTO public.who_global_data VALUES (19688, 1767, 428965, 19, 6159, 84, 228);
INSERT INTO public.who_global_data VALUES (19689, 0, 249, 0, 7, 84, 188);
INSERT INTO public.who_global_data VALUES (19690, 1167, 111622, 6, 1033, 84, 62);
INSERT INTO public.who_global_data VALUES (19691, 5711, 536002, 183, 14374, 84, 160);
INSERT INTO public.who_global_data VALUES (19692, 76, 4596, 0, 75, 84, 50);
INSERT INTO public.who_global_data VALUES (19693, 0, 2844, 0, 43, 84, 33);
INSERT INTO public.who_global_data VALUES (19694, 2, 222, 0, 9, 84, 183);
INSERT INTO public.who_global_data VALUES (19695, 0, 369, 0, 0, 84, 92);
INSERT INTO public.who_global_data VALUES (19696, 113, 142889, 7, 8825, 84, 158);
INSERT INTO public.who_global_data VALUES (19697, 0, 136, 0, 3, 84, 67);
INSERT INTO public.who_global_data VALUES (19698, 1332, 69625, 58, 1808, 84, 57);
INSERT INTO public.who_global_data VALUES (19699, 390, 8225, 0, 27, 84, 38);
INSERT INTO public.who_global_data VALUES (19700, 33207, 5781582, 908, 164281, 84, 141);
INSERT INTO public.who_global_data VALUES (19701, 0, 72, 0, 1, 84, 178);
INSERT INTO public.who_global_data VALUES (19702, 0, 148, 0, 3, 84, 108);
INSERT INTO public.who_global_data VALUES (19703, 4212, 94937, 85, 2055, 84, 39);
INSERT INTO public.who_global_data VALUES (19704, 23, 2609, 1, 68, 84, 2);
INSERT INTO public.who_global_data VALUES (19705, 3, 627, 0, 1, 84, 195);
INSERT INTO public.who_global_data VALUES (19706, 47, 9741, 0, 102, 84, 107);
INSERT INTO public.who_global_data VALUES (19707, 1, 302, 0, 0, 84, 161);
INSERT INTO public.who_global_data VALUES (19708, 109, 22692, 0, 433, 84, 212);
INSERT INTO public.who_global_data VALUES (19709, 5516, 282577, 83, 10768, 84, 181);
INSERT INTO public.who_global_data VALUES (19710, 1, 254, 0, 1, 84, 53);
INSERT INTO public.who_global_data VALUES (19711, 8, 4896, 1, 63, 84, 164);
INSERT INTO public.who_global_data VALUES (19712, 11, 1589, 0, 100, 84, 140);
INSERT INTO public.who_global_data VALUES (19713, 1592, 528030, 39, 14738, 84, 20);
INSERT INTO public.who_global_data VALUES (19714, 32, 92404, 0, 4749, 84, 112);
INSERT INTO public.who_global_data VALUES (19715, 8686, 1174012, 179, 33491, 84, 111);
INSERT INTO public.who_global_data VALUES (19716, 0, 574, 0, 7, 84, 71);
INSERT INTO public.who_global_data VALUES (19717, 0, 5515, 0, 92, 84, 218);
INSERT INTO public.who_global_data VALUES (19718, 0, 0, 0, 0, 84, 43);
INSERT INTO public.who_global_data VALUES (19719, 1171, 120939, 14, 1527, 84, 49);
INSERT INTO public.who_global_data VALUES (19720, 17, 20899, 0, 127, 84, 1);
INSERT INTO public.who_global_data VALUES (19721, 3056, 78978, 43, 968, 84, 48);
INSERT INTO public.who_global_data VALUES (19722, 54, 7541, 0, 131, 84, 232);
INSERT INTO public.who_global_data VALUES (19723, 33, 1215, 0, 2, 84, 175);
INSERT INTO public.who_global_data VALUES (19724, 207, 6853, 4, 38, 84, 21);
INSERT INTO public.who_global_data VALUES (19725, 7355, 454030, 171, 5926, 84, 156);
INSERT INTO public.who_global_data VALUES (19726, 0, 0, 0, 0, 84, 95);
INSERT INTO public.who_global_data VALUES (19727, 0, 11691, 0, 318, 84, 177);
INSERT INTO public.who_global_data VALUES (19728, 1037, 60000, 1, 756, 84, 210);
INSERT INTO public.who_global_data VALUES (19729, 3, 5644, 0, 61, 84, 120);
INSERT INTO public.who_global_data VALUES (19730, 0, 68, 0, 0, 84, 135);
INSERT INTO public.who_global_data VALUES (19731, 918, 132554, 6, 2280, 84, 206);
INSERT INTO public.who_global_data VALUES (19732, 1161, 178674, 31, 12977, 84, 189);
INSERT INTO public.who_global_data VALUES (19733, 224, 110319, 12, 6429, 84, 129);
INSERT INTO public.who_global_data VALUES (19734, 165, 36195, 5, 1033, 84, 121);
INSERT INTO public.who_global_data VALUES (19735, 0, 5104, 0, 85, 84, 59);
INSERT INTO public.who_global_data VALUES (19736, 0, 493, 0, 0, 84, 96);
INSERT INTO public.who_global_data VALUES (19737, 267, 7148, 4, 80, 84, 41);
INSERT INTO public.who_global_data VALUES (19738, 16, 6076, 1, 118, 84, 216);
INSERT INTO public.who_global_data VALUES (19739, 509, 101757, 4, 1558, 84, 236);
INSERT INTO public.who_global_data VALUES (19740, 0, 15, 0, 0, 84, 150);
INSERT INTO public.who_global_data VALUES (19741, 0, 497, 0, 0, 84, 61);
INSERT INTO public.who_global_data VALUES (19742, 0, 35, 0, 2, 84, 7);
INSERT INTO public.who_global_data VALUES (19743, 316, 18858, 4, 369, 84, 169);
INSERT INTO public.who_global_data VALUES (19744, 23620, 1886286, 931, 43559, 84, 28);
INSERT INTO public.who_global_data VALUES (19745, 28, 10808, 0, 70, 84, 85);
INSERT INTO public.who_global_data VALUES (19746, 221, 11706, 1, 53, 84, 211);
INSERT INTO public.who_global_data VALUES (19747, 14, 9062, 1, 58, 84, 60);
INSERT INTO public.who_global_data VALUES (19748, 0, 3698, 0, 122, 84, 3);
INSERT INTO public.who_global_data VALUES (19749, 3504, 76658, 33, 669, 84, 11);
INSERT INTO public.who_global_data VALUES (19750, 22461, 773556, 178, 12378, 84, 89);
INSERT INTO public.who_global_data VALUES (19751, 0, 50018, 0, 320, 84, 24);
INSERT INTO public.who_global_data VALUES (19752, 22, 864, 0, 1, 84, 162);
INSERT INTO public.who_global_data VALUES (19753, 3038, 69675, 38, 997, 84, 100);
INSERT INTO public.who_global_data VALUES (19754, 0, 17, 0, 0, 84, 47);
INSERT INTO public.who_global_data VALUES (19755, 0, 32, 0, 0, 84, 29);
INSERT INTO public.who_global_data VALUES (19756, 0, 8098, 0, 139, 84, 40);
INSERT INTO public.who_global_data VALUES (19757, 73, 5813, 2, 93, 84, 222);
INSERT INTO public.who_global_data VALUES (19758, 580, 114123, 22, 3880, 84, 132);
INSERT INTO public.who_global_data VALUES (19759, 0, 282, 0, 13, 84, 130);
INSERT INTO public.who_global_data VALUES (19760, 21, 12537, 0, 74, 84, 234);
INSERT INTO public.who_global_data VALUES (19761, 0, 2419, 0, 43, 84, 23);
INSERT INTO public.who_global_data VALUES (19762, 44, 4662, 1, 138, 84, 192);
INSERT INTO public.who_global_data VALUES (19763, 16, 9168, 0, 232, 84, 69);
INSERT INTO public.who_global_data VALUES (19764, 0, 26, 0, 0, 84, 187);
INSERT INTO public.who_global_data VALUES (19765, 299, 101468, 7, 2804, 84, 230);
INSERT INTO public.who_global_data VALUES (19766, 4836, 136723, 107, 2990, 84, 77);
INSERT INTO public.who_global_data VALUES (19767, 10, 5170, 0, 25, 84, 9);
INSERT INTO public.who_global_data VALUES (19768, 44684, 8773479, 520, 129188, 84, 74);
INSERT INTO public.who_global_data VALUES (19769, 5444, 457735, 104, 15037, 84, 224);
INSERT INTO public.who_global_data VALUES (19770, 11737, 738322, 461, 40582, 84, 199);
INSERT INTO public.who_global_data VALUES (19771, 2690, 514496, 48, 11580, 84, 190);
INSERT INTO public.who_global_data VALUES (19772, 467, 67099, 7, 1972, 84, 12);
INSERT INTO public.who_global_data VALUES (19773, 2, 363, 0, 25, 84, 104);
INSERT INTO public.who_global_data VALUES (19774, 836, 322421, 12, 2722, 84, 153);
INSERT INTO public.who_global_data VALUES (19775, 40902, 1107303, 550, 44139, 84, 91);
INSERT INTO public.who_global_data VALUES (19776, 89, 9723, 2, 227, 84, 215);
INSERT INTO public.who_global_data VALUES (19777, 1685, 114983, 13, 1880, 84, 84);
INSERT INTO public.who_global_data VALUES (19778, 17, 721, 0, 32, 84, 231);
INSERT INTO public.who_global_data VALUES (19779, 4469, 136555, 71, 1618, 84, 196);
INSERT INTO public.who_global_data VALUES (19780, 856, 160612, 0, 2306, 84, 105);
INSERT INTO public.who_global_data VALUES (19781, 1470, 68193, 25, 1228, 84, 122);
INSERT INTO public.who_global_data VALUES (19782, 0, 0, 0, 0, 84, 159);
INSERT INTO public.who_global_data VALUES (19783, 963, 27808, 13, 788, 84, 75);
INSERT INTO public.who_global_data VALUES (19784, 718, 135650, 3, 833, 84, 27);
INSERT INTO public.who_global_data VALUES (19785, 499, 65953, 1, 1196, 84, 54);
INSERT INTO public.who_global_data VALUES (19786, 0, 24, 0, 0, 84, 226);
INSERT INTO public.who_global_data VALUES (19787, 455, 9836, 9, 116, 84, 79);
INSERT INTO public.who_global_data VALUES (19788, 1904, 102607, 21, 796, 84, 56);
INSERT INTO public.who_global_data VALUES (19789, 0, 1967, 0, 44, 84, 117);
INSERT INTO public.who_global_data VALUES (19790, 23, 1491, 0, 82, 84, 152);
INSERT INTO public.who_global_data VALUES (19791, 824, 72628, 10, 995, 84, 16);
INSERT INTO public.who_global_data VALUES (19792, 25, 993, 0, 5, 84, 10);
INSERT INTO public.who_global_data VALUES (19793, 1528, 33356, 17, 282, 84, 201);
INSERT INTO public.who_global_data VALUES (19794, 713, 25218, 5, 211, 84, 174);
INSERT INTO public.who_global_data VALUES (19795, 0, 17233, 0, 249, 84, 119);
INSERT INTO public.who_global_data VALUES (19796, 4, 5962, 0, 185, 84, 168);
INSERT INTO public.who_global_data VALUES (19797, 1304, 45095, 1, 304, 84, 99);
INSERT INTO public.who_global_data VALUES (19798, 27, 12112, 0, 41, 84, 171);
INSERT INTO public.who_global_data VALUES (19799, 14, 3806, 1, 139, 84, 87);
INSERT INTO public.who_global_data VALUES (19800, 121, 7906, 4, 91, 84, 123);
INSERT INTO public.who_global_data VALUES (19801, 0, 1, 0, 0, 84, 151);
INSERT INTO public.who_global_data VALUES (19802, 0, 4732, 0, 37, 84, 213);
INSERT INTO public.who_global_data VALUES (19803, 0, 7885, 0, 165, 84, 118);
INSERT INTO public.who_global_data VALUES (19804, 0, 470, 0, 10, 84, 134);
INSERT INTO public.who_global_data VALUES (19805, 0, 4921, 0, 46, 84, 65);
INSERT INTO public.who_global_data VALUES (19806, 5658, 991835, 626, 97056, 84, 102);
INSERT INTO public.who_global_data VALUES (19807, 0, 0, 0, 0, 84, 223);
INSERT INTO public.who_global_data VALUES (19808, 8, 543, 0, 2, 84, 4);
INSERT INTO public.who_global_data VALUES (19809, 6, 412, 0, 0, 84, 146);
INSERT INTO public.who_global_data VALUES (19810, 541, 27214, 8, 384, 84, 31);
INSERT INTO public.who_global_data VALUES (19811, 0, 13, 0, 1, 84, 127);
INSERT INTO public.who_global_data VALUES (19812, 5515, 282336, 61, 4631, 84, 22);
INSERT INTO public.who_global_data VALUES (19813, 133, 14227, 6, 110, 84, 115);
INSERT INTO public.who_global_data VALUES (19814, 1145, 65598, 28, 1508, 84, 106);
INSERT INTO public.who_global_data VALUES (19815, 27, 13372, 3, 138, 84, 90);
INSERT INTO public.who_global_data VALUES (19816, 0, 0, 0, 0, 84, 70);
INSERT INTO public.who_global_data VALUES (19817, 2111, 206353, 13, 1202, 84, 46);
INSERT INTO public.who_global_data VALUES (19818, 6069, 435391, 54, 8338, 84, 139);
INSERT INTO public.who_global_data VALUES (19819, 0, 30, 0, 0, 84, 42);
INSERT INTO public.who_global_data VALUES (19820, 3, 1642, 0, 25, 84, 80);
INSERT INTO public.who_global_data VALUES (19821, 0, 4533, 0, 158, 84, 203);
INSERT INTO public.who_global_data VALUES (19822, 19, 1282, 0, 69, 84, 136);
INSERT INTO public.who_global_data VALUES (19823, 156, 64884, 1, 1163, 84, 63);
INSERT INTO public.who_global_data VALUES (19824, 0, 0, 0, 0, 84, 17);
INSERT INTO public.who_global_data VALUES (19825, 0, 100, 0, 2, 84, 172);
INSERT INTO public.who_global_data VALUES (19826, 1063, 44898, 25, 1263, 84, 109);
INSERT INTO public.who_global_data VALUES (19827, 723, 27226, 3, 294, 84, 200);
INSERT INTO public.who_global_data VALUES (19828, 730, 73697, 6, 623, 84, 93);
INSERT INTO public.who_global_data VALUES (19829, 0, 119442, 0, 1326, 84, 5);
INSERT INTO public.who_global_data VALUES (19830, 0, 741, 0, 13, 84, 214);
INSERT INTO public.who_global_data VALUES (19831, 2304, 352296, 37, 7092, 84, 204);
INSERT INTO public.who_global_data VALUES (19832, 0, 0, 0, 0, 84, 198);
INSERT INTO public.who_global_data VALUES (19833, 887, 143352, 7, 2830, 84, 173);
INSERT INTO public.who_global_data VALUES (19834, 0, 600, 0, 7, 84, 229);
INSERT INTO public.who_global_data VALUES (19835, 547, 69653, 11, 1543, 84, 76);
INSERT INTO public.who_global_data VALUES (19836, 2231, 930237, 36, 35067, 84, 138);
INSERT INTO public.who_global_data VALUES (19837, 1893, 404713, 31, 7752, 84, 98);
INSERT INTO public.who_global_data VALUES (19838, 0, 0, 0, 0, 84, 103);
INSERT INTO public.who_global_data VALUES (19839, 24051, 665547, 419, 9499, 84, 225);
INSERT INTO public.who_global_data VALUES (19840, 6653, 204664, 69, 3250, 84, 131);
INSERT INTO public.who_global_data VALUES (19841, 667, 41119, 5, 914, 84, 235);
INSERT INTO public.who_global_data VALUES (19842, 235, 135367, 0, 234, 84, 137);
INSERT INTO public.who_global_data VALUES (19843, 205, 28336, 4, 492, 84, 81);
INSERT INTO public.who_global_data VALUES (19844, 1323, 87361, 18, 1987, 84, 182);
INSERT INTO public.who_global_data VALUES (19845, 146, 6881, 1, 29, 84, 145);
INSERT INTO public.who_global_data VALUES (19846, 9489, 343725, 174, 8684, 84, 26);
INSERT INTO public.who_global_data VALUES (19847, 22702, 1903253, 391, 32834, 84, 170);
INSERT INTO public.who_global_data VALUES (19848, 43, 5362, 1, 42, 84, 191);
INSERT INTO public.who_global_data VALUES (19849, 0, 5, 0, 0, 84, 221);
INSERT INTO public.who_global_data VALUES (19850, 0, 109, 0, 0, 84, 64);
INSERT INTO public.who_global_data VALUES (19851, 0, 0, 0, 0, 84, 116);
INSERT INTO public.who_global_data VALUES (19852, 0, 19, 0, 0, 84, 128);
INSERT INTO public.who_global_data VALUES (19853, 0, 156, 0, 2, 84, 6);
INSERT INTO public.who_global_data VALUES (19854, 0, 655, 0, 12, 84, 227);
INSERT INTO public.who_global_data VALUES (19855, 0, 14, 0, 0, 84, 68);
INSERT INTO public.who_global_data VALUES (19856, 1, 78, 0, 0, 84, 184);
INSERT INTO public.who_global_data VALUES (19857, 0, 0, 0, 0, 84, 82);
INSERT INTO public.who_global_data VALUES (19858, 19, 1253, 0, 42, 84, 149);
INSERT INTO public.who_global_data VALUES (19859, 0, 963, 0, 16, 84, 197);
INSERT INTO public.who_global_data VALUES (19860, 441, 352601, 20, 5625, 84, 78);
INSERT INTO public.who_global_data VALUES (19861, 11, 15755, 0, 326, 84, 233);
INSERT INTO public.who_global_data VALUES (19862, 3499, 77264, 17, 972, 84, 133);
INSERT INTO public.who_global_data VALUES (19863, 0, 158, 0, 0, 84, 35);
INSERT INTO public.who_global_data VALUES (19864, 3, 2389, 0, 74, 84, 114);
INSERT INTO public.who_global_data VALUES (19865, 12, 58114, 0, 28, 84, 237);
INSERT INTO public.who_global_data VALUES (19866, 0, 14, 0, 0, 84, 55);
INSERT INTO public.who_global_data VALUES (19867, 6, 914, 0, 23, 84, 176);
INSERT INTO public.who_global_data VALUES (19868, 2024, 83796, 27, 491, 84, 202);
INSERT INTO public.who_global_data VALUES (19869, 1740, 54161, 41, 847, 84, 155);
INSERT INTO public.who_global_data VALUES (19870, 0, 16, 0, 0, 84, 32);
INSERT INTO public.who_global_data VALUES (19871, 0, 4301, 0, 107, 84, 220);
INSERT INTO public.who_global_data VALUES (19872, 2213, 746945, 77, 20153, 84, 30);
INSERT INTO public.who_global_data VALUES (19873, 23, 3003, 0, 59, 84, 147);
INSERT INTO public.who_global_data VALUES (19874, 19098, 1533724, 316, 42601, 84, 208);
INSERT INTO public.who_global_data VALUES (19875, 373, 15723, 2, 48, 84, 45);
INSERT INTO public.who_global_data VALUES (19876, 128, 14626, 0, 1116, 84, 110);
INSERT INTO public.who_global_data VALUES (19877, 7, 5261, 1, 114, 84, 88);
INSERT INTO public.who_global_data VALUES (19878, 5564, 178229, 28, 6338, 84, 51);
INSERT INTO public.who_global_data VALUES (19879, 5679, 265124, 85, 3331, 84, 209);
INSERT INTO public.who_global_data VALUES (19880, 66, 6552, 4, 337, 84, 205);
INSERT INTO public.who_global_data VALUES (19881, 38, 11534, 1, 85, 84, 18);
INSERT INTO public.who_global_data VALUES (19882, 0, 3861, 0, 60, 84, 72);
INSERT INTO public.who_global_data VALUES (19883, 27301, 1317500, 376, 51304, 84, 44);
INSERT INTO public.who_global_data VALUES (19884, 0, 30, 0, 0, 84, 15);
INSERT INTO public.who_global_data VALUES (19885, 0, 2605, 0, 60, 84, 25);
INSERT INTO public.who_global_data VALUES (19886, 0, 0, 0, 0, 84, 179);
INSERT INTO public.who_global_data VALUES (19887, 0, 0, 0, 0, 84, 34);
INSERT INTO public.who_global_data VALUES (19888, 26, 5930, 0, 111, 84, 207);
INSERT INTO public.who_global_data VALUES (19889, 1562, 77668, 58, 2209, 84, 166);
INSERT INTO public.who_global_data VALUES (19890, 9775, 1141509, 93, 11326, 84, 126);
INSERT INTO public.who_global_data VALUES (19891, 0, 0, 0, 0, 84, 97);
INSERT INTO public.who_global_data VALUES (19892, 0, 716, 0, 6, 84, 36);
INSERT INTO public.who_global_data VALUES (19893, 0, 0, 0, 0, 84, 125);
INSERT INTO public.who_global_data VALUES (19894, 185, 15402, 1, 144, 84, 124);
INSERT INTO public.who_global_data VALUES (19895, 12524, 525176, 191, 9508, 84, 185);
INSERT INTO public.who_global_data VALUES (19896, 1226, 147961, 5, 528, 84, 194);
INSERT INTO public.who_global_data VALUES (19897, 0, 509, 0, 21, 84, 144);
INSERT INTO public.who_global_data VALUES (19898, 193734, 10460365, 1142, 241186, 84, 19);
INSERT INTO public.who_global_data VALUES (19899, 13, 1426, 0, 23, 84, 217);
INSERT INTO public.who_global_data VALUES (19900, 95, 3795, 0, 63, 84, 148);
INSERT INTO public.who_global_data VALUES (19901, 234, 69914, 2, 596, 84, 86);
INSERT INTO public.who_global_data VALUES (19902, 0, 1, 0, 0, 84, 13);
INSERT INTO public.who_global_data VALUES (19903, 390, 96140, 3, 841, 84, 157);
INSERT INTO public.who_global_data VALUES (19904, 3, 1256, 0, 35, 84, 8);
INSERT INTO public.who_global_data VALUES (19905, 0, 1, 0, 0, 84, 73);
INSERT INTO public.who_global_data VALUES (19906, 0, 2072, 0, 603, 84, 101);
INSERT INTO public.who_global_data VALUES (19907, 37, 17093, 0, 350, 84, 165);
INSERT INTO public.who_global_data VALUES (19908, 69, 8765, 2, 257, 84, 14);
INSERT INTO public.who_global_data VALUES (19909, 186, 42795, 10, 1591, 85, 193);
INSERT INTO public.who_global_data VALUES (19910, 410, 26211, 8, 598, 85, 113);
INSERT INTO public.who_global_data VALUES (19911, 851, 65108, 18, 2111, 85, 143);
INSERT INTO public.who_global_data VALUES (19912, 0, 0, 0, 0, 85, 219);
INSERT INTO public.who_global_data VALUES (19913, 49, 5616, 0, 75, 85, 186);
INSERT INTO public.who_global_data VALUES (19914, 104, 13057, 3, 315, 85, 52);
INSERT INTO public.who_global_data VALUES (19915, 0, 3, 0, 0, 85, 180);
INSERT INTO public.who_global_data VALUES (19916, 0, 131, 0, 3, 85, 167);
INSERT INTO public.who_global_data VALUES (19917, 10880, 1273356, 348, 34531, 85, 154);
INSERT INTO public.who_global_data VALUES (19918, 1703, 113696, 29, 1692, 85, 94);
INSERT INTO public.who_global_data VALUES (19919, 9, 4631, 1, 43, 85, 66);
INSERT INTO public.who_global_data VALUES (19920, 12, 27698, 0, 907, 85, 58);
INSERT INTO public.who_global_data VALUES (19921, 10368, 182062, 37, 1510, 85, 163);
INSERT INTO public.who_global_data VALUES (19922, 1622, 70216, 20, 905, 85, 37);
INSERT INTO public.who_global_data VALUES (19923, 64, 7124, 1, 155, 85, 142);
INSERT INTO public.who_global_data VALUES (19924, 150, 84192, 0, 332, 85, 83);
INSERT INTO public.who_global_data VALUES (19925, 1845, 427198, 13, 6140, 85, 228);
INSERT INTO public.who_global_data VALUES (19926, 6, 249, 0, 7, 85, 188);
INSERT INTO public.who_global_data VALUES (19927, 1098, 110455, 5, 1027, 85, 62);
INSERT INTO public.who_global_data VALUES (19928, 6482, 530291, 172, 14191, 85, 160);
INSERT INTO public.who_global_data VALUES (19929, 106, 4520, 2, 75, 85, 50);
INSERT INTO public.who_global_data VALUES (19930, 0, 2844, 0, 43, 85, 33);
INSERT INTO public.who_global_data VALUES (19931, 5, 220, 0, 9, 85, 183);
INSERT INTO public.who_global_data VALUES (19932, 5, 369, 0, 0, 85, 92);
INSERT INTO public.who_global_data VALUES (19933, 112, 142776, 10, 8818, 85, 158);
INSERT INTO public.who_global_data VALUES (19934, 0, 136, 0, 3, 85, 67);
INSERT INTO public.who_global_data VALUES (19935, 1728, 68293, 49, 1750, 85, 57);
INSERT INTO public.who_global_data VALUES (19936, 0, 7835, 0, 27, 85, 38);
INSERT INTO public.who_global_data VALUES (19937, 48331, 5748375, 544, 163373, 85, 141);
INSERT INTO public.who_global_data VALUES (19938, 0, 72, 0, 1, 85, 178);
INSERT INTO public.who_global_data VALUES (19939, 0, 148, 0, 3, 85, 108);
INSERT INTO public.who_global_data VALUES (19940, 3414, 90725, 72, 1970, 85, 39);
INSERT INTO public.who_global_data VALUES (19941, 0, 2586, 0, 67, 85, 2);
INSERT INTO public.who_global_data VALUES (19942, 1, 624, 0, 1, 85, 195);
INSERT INTO public.who_global_data VALUES (19943, 134, 9694, 0, 102, 85, 107);
INSERT INTO public.who_global_data VALUES (19944, 0, 301, 0, 0, 85, 161);
INSERT INTO public.who_global_data VALUES (19945, 93, 22583, 0, 433, 85, 212);
INSERT INTO public.who_global_data VALUES (19946, 4024, 277061, 53, 10685, 85, 181);
INSERT INTO public.who_global_data VALUES (19947, 0, 253, 0, 1, 85, 53);
INSERT INTO public.who_global_data VALUES (19948, 0, 4888, 0, 62, 85, 164);
INSERT INTO public.who_global_data VALUES (19949, 13, 1578, 1, 100, 85, 140);
INSERT INTO public.who_global_data VALUES (19950, 1634, 526438, 66, 14699, 85, 20);
INSERT INTO public.who_global_data VALUES (19951, 36, 92372, 0, 4749, 85, 112);
INSERT INTO public.who_global_data VALUES (19952, 8651, 1165326, 164, 33312, 85, 111);
INSERT INTO public.who_global_data VALUES (19953, 5, 574, 0, 7, 85, 71);
INSERT INTO public.who_global_data VALUES (19954, 136, 5515, 0, 92, 85, 218);
INSERT INTO public.who_global_data VALUES (19955, 0, 0, 0, 0, 85, 43);
INSERT INTO public.who_global_data VALUES (19956, 1202, 119768, 11, 1513, 85, 49);
INSERT INTO public.who_global_data VALUES (19957, 27, 20882, 0, 127, 85, 1);
INSERT INTO public.who_global_data VALUES (19958, 3082, 75922, 32, 925, 85, 48);
INSERT INTO public.who_global_data VALUES (19959, 58, 7487, 1, 131, 85, 232);
INSERT INTO public.who_global_data VALUES (19960, 51, 1182, 0, 2, 85, 175);
INSERT INTO public.who_global_data VALUES (19961, 185, 6646, 2, 34, 85, 21);
INSERT INTO public.who_global_data VALUES (19962, 7870, 446675, 185, 5755, 85, 156);
INSERT INTO public.who_global_data VALUES (19963, 0, 0, 0, 0, 85, 95);
INSERT INTO public.who_global_data VALUES (19964, 36, 11691, 2, 318, 85, 177);
INSERT INTO public.who_global_data VALUES (19965, 1011, 58963, 2, 755, 85, 210);
INSERT INTO public.who_global_data VALUES (19966, 6, 5641, 0, 61, 85, 120);
INSERT INTO public.who_global_data VALUES (19967, 5, 68, 0, 0, 85, 135);
INSERT INTO public.who_global_data VALUES (19968, 371, 131636, 2, 2274, 85, 206);
INSERT INTO public.who_global_data VALUES (19969, 883, 177513, 26, 12946, 85, 189);
INSERT INTO public.who_global_data VALUES (19970, 214, 110095, 12, 6417, 85, 129);
INSERT INTO public.who_global_data VALUES (19971, 885, 36030, 4, 1028, 85, 121);
INSERT INTO public.who_global_data VALUES (19972, 0, 5104, 0, 85, 85, 59);
INSERT INTO public.who_global_data VALUES (19973, 2, 493, 0, 0, 85, 96);
INSERT INTO public.who_global_data VALUES (19974, 373, 6881, 0, 76, 85, 41);
INSERT INTO public.who_global_data VALUES (19975, 16, 6060, 0, 117, 85, 216);
INSERT INTO public.who_global_data VALUES (19976, 521, 101248, 9, 1554, 85, 236);
INSERT INTO public.who_global_data VALUES (19977, 1, 15, 0, 0, 85, 150);
INSERT INTO public.who_global_data VALUES (19978, 0, 497, 0, 0, 85, 61);
INSERT INTO public.who_global_data VALUES (19979, 0, 35, 0, 2, 85, 7);
INSERT INTO public.who_global_data VALUES (19980, 197, 18542, 0, 365, 85, 169);
INSERT INTO public.who_global_data VALUES (19981, 32978, 1862666, 425, 42628, 85, 28);
INSERT INTO public.who_global_data VALUES (19982, 18, 10780, 0, 70, 85, 85);
INSERT INTO public.who_global_data VALUES (19983, 169, 11485, 0, 52, 85, 211);
INSERT INTO public.who_global_data VALUES (19984, 0, 9048, 0, 57, 85, 60);
INSERT INTO public.who_global_data VALUES (19985, 1, 3698, 0, 122, 85, 3);
INSERT INTO public.who_global_data VALUES (19986, 3473, 73154, 37, 636, 85, 11);
INSERT INTO public.who_global_data VALUES (19987, 23542, 751095, 218, 12200, 85, 89);
INSERT INTO public.who_global_data VALUES (19988, 716, 50018, 0, 320, 85, 24);
INSERT INTO public.who_global_data VALUES (19989, 28, 842, 1, 1, 85, 162);
INSERT INTO public.who_global_data VALUES (19990, 3316, 66637, 50, 959, 85, 100);
INSERT INTO public.who_global_data VALUES (19991, 0, 17, 0, 0, 85, 47);
INSERT INTO public.who_global_data VALUES (19992, 0, 32, 0, 0, 85, 29);
INSERT INTO public.who_global_data VALUES (19993, 0, 8098, 0, 139, 85, 40);
INSERT INTO public.who_global_data VALUES (19994, 87, 5740, 0, 91, 85, 222);
INSERT INTO public.who_global_data VALUES (19995, 732, 113543, 13, 3858, 85, 132);
INSERT INTO public.who_global_data VALUES (19996, 0, 282, 0, 13, 85, 130);
INSERT INTO public.who_global_data VALUES (19997, 32, 12516, 0, 74, 85, 234);
INSERT INTO public.who_global_data VALUES (19998, 0, 2419, 0, 43, 85, 23);
INSERT INTO public.who_global_data VALUES (19999, 88, 4618, 0, 137, 85, 192);
INSERT INTO public.who_global_data VALUES (20000, 0, 9152, 0, 232, 85, 69);
INSERT INTO public.who_global_data VALUES (20001, 0, 26, 0, 0, 85, 187);
INSERT INTO public.who_global_data VALUES (20002, 365, 101169, 17, 2797, 85, 230);
INSERT INTO public.who_global_data VALUES (20003, 5097, 131887, 99, 2883, 85, 77);
INSERT INTO public.who_global_data VALUES (20004, 18, 5160, 1, 25, 85, 9);
INSERT INTO public.who_global_data VALUES (20005, 44879, 8728795, 547, 128668, 85, 74);
INSERT INTO public.who_global_data VALUES (20006, 4173, 452291, 97, 14933, 85, 224);
INSERT INTO public.who_global_data VALUES (20007, 11517, 726585, 457, 40121, 85, 199);
INSERT INTO public.who_global_data VALUES (20008, 3298, 511806, 50, 11532, 85, 190);
INSERT INTO public.who_global_data VALUES (20009, 385, 66632, 0, 1965, 85, 12);
INSERT INTO public.who_global_data VALUES (20010, 2, 361, 0, 25, 85, 104);
INSERT INTO public.who_global_data VALUES (20011, 764, 321585, 7, 2710, 85, 153);
INSERT INTO public.who_global_data VALUES (20012, 37977, 1066401, 636, 43589, 85, 91);
INSERT INTO public.who_global_data VALUES (20013, 53, 9634, 0, 225, 85, 215);
INSERT INTO public.who_global_data VALUES (20014, 1587, 113298, 16, 1867, 85, 84);
INSERT INTO public.who_global_data VALUES (20015, 14, 704, 0, 32, 85, 231);
INSERT INTO public.who_global_data VALUES (20016, 5685, 132086, 80, 1547, 85, 196);
INSERT INTO public.who_global_data VALUES (20017, 903, 159756, 0, 2306, 85, 105);
INSERT INTO public.who_global_data VALUES (20018, 919, 66723, 23, 1203, 85, 122);
INSERT INTO public.who_global_data VALUES (20019, 0, 0, 0, 0, 85, 159);
INSERT INTO public.who_global_data VALUES (20020, 767, 26845, 8, 775, 85, 75);
INSERT INTO public.who_global_data VALUES (20021, 773, 134932, 4, 830, 85, 27);
INSERT INTO public.who_global_data VALUES (20022, 567, 65454, 2, 1195, 85, 54);
INSERT INTO public.who_global_data VALUES (20023, 0, 24, 0, 0, 85, 226);
INSERT INTO public.who_global_data VALUES (20024, 533, 9381, 4, 107, 85, 79);
INSERT INTO public.who_global_data VALUES (20025, 1874, 100703, 12, 775, 85, 56);
INSERT INTO public.who_global_data VALUES (20026, 0, 1967, 0, 44, 85, 117);
INSERT INTO public.who_global_data VALUES (20027, 7, 1468, 0, 82, 85, 152);
INSERT INTO public.who_global_data VALUES (20028, 919, 71804, 15, 985, 85, 16);
INSERT INTO public.who_global_data VALUES (20029, 21, 968, 1, 5, 85, 10);
INSERT INTO public.who_global_data VALUES (20030, 2057, 31828, 14, 265, 85, 201);
INSERT INTO public.who_global_data VALUES (20031, 795, 24505, 8, 206, 85, 174);
INSERT INTO public.who_global_data VALUES (20032, 0, 17233, 0, 249, 85, 119);
INSERT INTO public.who_global_data VALUES (20033, 3, 5958, 0, 185, 85, 168);
INSERT INTO public.who_global_data VALUES (20034, 919, 43791, 1, 303, 85, 99);
INSERT INTO public.who_global_data VALUES (20035, 26, 12085, 0, 41, 85, 171);
INSERT INTO public.who_global_data VALUES (20036, 39, 3792, 0, 138, 85, 87);
INSERT INTO public.who_global_data VALUES (20037, 150, 7785, 1, 87, 85, 123);
INSERT INTO public.who_global_data VALUES (20038, 0, 1, 0, 0, 85, 151);
INSERT INTO public.who_global_data VALUES (20039, 0, 4732, 0, 37, 85, 213);
INSERT INTO public.who_global_data VALUES (20040, 0, 7885, 0, 165, 85, 118);
INSERT INTO public.who_global_data VALUES (20041, 3, 470, 0, 10, 85, 134);
INSERT INTO public.who_global_data VALUES (20042, 106, 4921, 0, 46, 85, 65);
INSERT INTO public.who_global_data VALUES (20043, 7646, 986177, 588, 96430, 85, 102);
INSERT INTO public.who_global_data VALUES (20044, 0, 0, 0, 0, 85, 223);
INSERT INTO public.who_global_data VALUES (20045, 8, 535, 0, 2, 85, 4);
INSERT INTO public.who_global_data VALUES (20046, 24, 406, 0, 0, 85, 146);
INSERT INTO public.who_global_data VALUES (20047, 620, 26673, 13, 376, 85, 31);
INSERT INTO public.who_global_data VALUES (20048, 0, 13, 0, 1, 85, 127);
INSERT INTO public.who_global_data VALUES (20049, 6195, 276821, 64, 4570, 85, 22);
INSERT INTO public.who_global_data VALUES (20050, 103, 14094, 0, 104, 85, 115);
INSERT INTO public.who_global_data VALUES (20051, 0, 64453, 0, 1480, 85, 106);
INSERT INTO public.who_global_data VALUES (20052, 53, 13345, 1, 135, 85, 90);
INSERT INTO public.who_global_data VALUES (20053, 0, 0, 0, 0, 85, 70);
INSERT INTO public.who_global_data VALUES (20054, 1913, 204242, 15, 1189, 85, 46);
INSERT INTO public.who_global_data VALUES (20055, 5619, 429322, 85, 8284, 85, 139);
INSERT INTO public.who_global_data VALUES (20056, 1, 30, 0, 0, 85, 42);
INSERT INTO public.who_global_data VALUES (20057, 4, 1639, 0, 25, 85, 80);
INSERT INTO public.who_global_data VALUES (20058, 0, 4533, 0, 158, 85, 203);
INSERT INTO public.who_global_data VALUES (20059, 7, 1263, 0, 69, 85, 136);
INSERT INTO public.who_global_data VALUES (20060, 212, 64728, 0, 1162, 85, 63);
INSERT INTO public.who_global_data VALUES (20061, 0, 0, 0, 0, 85, 17);
INSERT INTO public.who_global_data VALUES (20062, 0, 100, 0, 2, 85, 172);
INSERT INTO public.who_global_data VALUES (20063, 1295, 43835, 26, 1238, 85, 109);
INSERT INTO public.who_global_data VALUES (20064, 618, 26503, 6, 291, 85, 200);
INSERT INTO public.who_global_data VALUES (20065, 823, 72967, 5, 617, 85, 93);
INSERT INTO public.who_global_data VALUES (20066, 256, 119442, 5, 1326, 85, 5);
INSERT INTO public.who_global_data VALUES (20067, 0, 741, 0, 13, 85, 214);
INSERT INTO public.who_global_data VALUES (20068, 1808, 349992, 34, 7055, 85, 204);
INSERT INTO public.who_global_data VALUES (20069, 0, 0, 0, 0, 85, 198);
INSERT INTO public.who_global_data VALUES (20070, 1163, 142465, 6, 2823, 85, 173);
INSERT INTO public.who_global_data VALUES (20071, 1, 600, 0, 7, 85, 229);
INSERT INTO public.who_global_data VALUES (20072, 609, 69106, 16, 1532, 85, 76);
INSERT INTO public.who_global_data VALUES (20073, 2575, 928006, 39, 35031, 85, 138);
INSERT INTO public.who_global_data VALUES (20074, 1404, 402820, 11, 7721, 85, 98);
INSERT INTO public.who_global_data VALUES (20075, 0, 0, 0, 0, 85, 103);
INSERT INTO public.who_global_data VALUES (20076, 22683, 641496, 275, 9080, 85, 225);
INSERT INTO public.who_global_data VALUES (20077, 5839, 198011, 78, 3181, 85, 131);
INSERT INTO public.who_global_data VALUES (20078, 1332, 40452, 8, 909, 85, 235);
INSERT INTO public.who_global_data VALUES (20079, 245, 135132, 1, 234, 85, 137);
INSERT INTO public.who_global_data VALUES (20080, 191, 28131, 1, 488, 85, 81);
INSERT INTO public.who_global_data VALUES (20081, 1331, 86038, 19, 1969, 85, 182);
INSERT INTO public.who_global_data VALUES (20082, 0, 6735, 0, 28, 85, 145);
INSERT INTO public.who_global_data VALUES (20083, 10142, 334236, 121, 8510, 85, 26);
INSERT INTO public.who_global_data VALUES (20084, 21983, 1880551, 411, 32443, 85, 170);
INSERT INTO public.who_global_data VALUES (20085, 7, 5319, 0, 41, 85, 191);
INSERT INTO public.who_global_data VALUES (20086, 0, 5, 0, 0, 85, 221);
INSERT INTO public.who_global_data VALUES (20087, 19, 109, 0, 0, 85, 64);
INSERT INTO public.who_global_data VALUES (20088, 0, 0, 0, 0, 85, 116);
INSERT INTO public.who_global_data VALUES (20089, 0, 19, 0, 0, 85, 128);
INSERT INTO public.who_global_data VALUES (20090, 8, 156, 0, 2, 85, 6);
INSERT INTO public.who_global_data VALUES (20091, 51, 655, 0, 12, 85, 227);
INSERT INTO public.who_global_data VALUES (20092, 0, 14, 0, 0, 85, 68);
INSERT INTO public.who_global_data VALUES (20093, 1, 77, 0, 0, 85, 184);
INSERT INTO public.who_global_data VALUES (20094, 0, 0, 0, 0, 85, 82);
INSERT INTO public.who_global_data VALUES (20095, 44, 1234, 0, 42, 85, 149);
INSERT INTO public.who_global_data VALUES (20096, 1, 963, 0, 16, 85, 197);
INSERT INTO public.who_global_data VALUES (20097, 311, 352160, 15, 5605, 85, 78);
INSERT INTO public.who_global_data VALUES (20098, 9, 15744, 0, 326, 85, 233);
INSERT INTO public.who_global_data VALUES (20099, 3341, 73765, 19, 955, 85, 133);
INSERT INTO public.who_global_data VALUES (20100, 0, 158, 0, 0, 85, 35);
INSERT INTO public.who_global_data VALUES (20101, 0, 2386, 0, 74, 85, 114);
INSERT INTO public.who_global_data VALUES (20102, 11, 58102, 0, 28, 85, 237);
INSERT INTO public.who_global_data VALUES (20103, 0, 14, 0, 0, 85, 55);
INSERT INTO public.who_global_data VALUES (20104, 0, 908, 0, 23, 85, 176);
INSERT INTO public.who_global_data VALUES (20105, 2591, 81772, 50, 464, 85, 202);
INSERT INTO public.who_global_data VALUES (20106, 1516, 52421, 43, 806, 85, 155);
INSERT INTO public.who_global_data VALUES (20107, 0, 16, 0, 0, 85, 32);
INSERT INTO public.who_global_data VALUES (20108, 0, 4301, 0, 107, 85, 220);
INSERT INTO public.who_global_data VALUES (20109, 2338, 744732, 65, 20076, 85, 30);
INSERT INTO public.who_global_data VALUES (20110, 20, 2980, 0, 59, 85, 147);
INSERT INTO public.who_global_data VALUES (20111, 19775, 1514626, 324, 42285, 85, 208);
INSERT INTO public.who_global_data VALUES (20112, 635, 15350, 5, 46, 85, 45);
INSERT INTO public.who_global_data VALUES (20113, 97, 14498, 0, 1116, 85, 110);
INSERT INTO public.who_global_data VALUES (20114, 9, 5254, 0, 113, 85, 88);
INSERT INTO public.who_global_data VALUES (20115, 5709, 172665, 27, 6310, 85, 51);
INSERT INTO public.who_global_data VALUES (20116, 5962, 259445, 102, 3246, 85, 209);
INSERT INTO public.who_global_data VALUES (20117, 65, 6486, 4, 333, 85, 205);
INSERT INTO public.who_global_data VALUES (20118, 40, 11496, 0, 84, 85, 18);
INSERT INTO public.who_global_data VALUES (20119, 9, 3861, 0, 60, 85, 72);
INSERT INTO public.who_global_data VALUES (20120, 33470, 1290199, 563, 50928, 85, 44);
INSERT INTO public.who_global_data VALUES (20121, 0, 30, 0, 0, 85, 15);
INSERT INTO public.who_global_data VALUES (20122, 47, 2605, 3, 60, 85, 25);
INSERT INTO public.who_global_data VALUES (20123, 0, 0, 0, 0, 85, 179);
INSERT INTO public.who_global_data VALUES (20124, 0, 0, 0, 0, 85, 34);
INSERT INTO public.who_global_data VALUES (20125, 24, 5904, 0, 111, 85, 207);
INSERT INTO public.who_global_data VALUES (20126, 1584, 76106, 51, 2151, 85, 166);
INSERT INTO public.who_global_data VALUES (20127, 9571, 1131734, 88, 11233, 85, 126);
INSERT INTO public.who_global_data VALUES (20128, 0, 0, 0, 0, 85, 97);
INSERT INTO public.who_global_data VALUES (20129, 5, 716, 0, 6, 85, 36);
INSERT INTO public.who_global_data VALUES (20130, 0, 0, 0, 0, 85, 125);
INSERT INTO public.who_global_data VALUES (20131, 224, 15217, 4, 143, 85, 124);
INSERT INTO public.who_global_data VALUES (20132, 11787, 512652, 172, 9317, 85, 185);
INSERT INTO public.who_global_data VALUES (20133, 1136, 146735, 3, 523, 85, 194);
INSERT INTO public.who_global_data VALUES (20134, 0, 509, 0, 21, 85, 144);
INSERT INTO public.who_global_data VALUES (20135, 142076, 10266631, 1471, 240044, 85, 19);
INSERT INTO public.who_global_data VALUES (20136, 0, 1413, 0, 23, 85, 217);
INSERT INTO public.who_global_data VALUES (20137, 80, 3700, 1, 63, 85, 148);
INSERT INTO public.who_global_data VALUES (20138, 283, 69680, 3, 594, 85, 86);
INSERT INTO public.who_global_data VALUES (20139, 0, 1, 0, 0, 85, 13);
INSERT INTO public.who_global_data VALUES (20140, 305, 95750, 4, 838, 85, 157);
INSERT INTO public.who_global_data VALUES (20141, 1, 1253, 0, 35, 85, 8);
INSERT INTO public.who_global_data VALUES (20142, 0, 1, 0, 0, 85, 73);
INSERT INTO public.who_global_data VALUES (20143, 2, 2072, 1, 603, 85, 101);
INSERT INTO public.who_global_data VALUES (20144, 20, 17056, 0, 350, 85, 165);
INSERT INTO public.who_global_data VALUES (20145, 29, 8696, 0, 255, 85, 14);
INSERT INTO public.who_global_data VALUES (20146, 146, 42609, 4, 1581, 86, 193);
INSERT INTO public.who_global_data VALUES (20147, 507, 25801, 11, 590, 86, 113);
INSERT INTO public.who_global_data VALUES (20148, 811, 64257, 16, 2093, 86, 143);
INSERT INTO public.who_global_data VALUES (20149, 0, 0, 0, 0, 86, 219);
INSERT INTO public.who_global_data VALUES (20150, 90, 5567, 0, 75, 86, 186);
INSERT INTO public.who_global_data VALUES (20151, 137, 12953, 4, 312, 86, 52);
INSERT INTO public.who_global_data VALUES (20152, 0, 3, 0, 0, 86, 180);
INSERT INTO public.who_global_data VALUES (20153, 0, 131, 0, 3, 86, 167);
INSERT INTO public.who_global_data VALUES (20154, 11977, 1262476, 276, 34183, 86, 154);
INSERT INTO public.who_global_data VALUES (20155, 2132, 111993, 32, 1663, 86, 94);
INSERT INTO public.who_global_data VALUES (20156, 16, 4622, 1, 42, 86, 66);
INSERT INTO public.who_global_data VALUES (20157, 8, 27686, 0, 907, 86, 58);
INSERT INTO public.who_global_data VALUES (20158, 9643, 171694, 55, 1473, 86, 163);
INSERT INTO public.who_global_data VALUES (20159, 1202, 68594, 18, 885, 86, 37);
INSERT INTO public.who_global_data VALUES (20160, 48, 7060, 0, 154, 86, 142);
INSERT INTO public.who_global_data VALUES (20161, 231, 84042, 1, 332, 86, 83);
INSERT INTO public.who_global_data VALUES (20162, 1733, 425353, 19, 6127, 86, 228);
INSERT INTO public.who_global_data VALUES (20163, 0, 243, 0, 7, 86, 188);
INSERT INTO public.who_global_data VALUES (20164, 1057, 109357, 6, 1022, 86, 62);
INSERT INTO public.who_global_data VALUES (20165, 2004, 523809, 194, 14019, 86, 160);
INSERT INTO public.who_global_data VALUES (20166, 184, 4414, 2, 73, 86, 50);
INSERT INTO public.who_global_data VALUES (20167, 0, 2844, 0, 43, 86, 33);
INSERT INTO public.who_global_data VALUES (20168, 1, 215, 0, 9, 86, 183);
INSERT INTO public.who_global_data VALUES (20169, 0, 364, 0, 0, 86, 92);
INSERT INTO public.who_global_data VALUES (20170, 103, 142664, 6, 8808, 86, 158);
INSERT INTO public.who_global_data VALUES (20171, 1, 136, 0, 3, 86, 67);
INSERT INTO public.who_global_data VALUES (20172, 1540, 66565, 72, 1701, 86, 57);
INSERT INTO public.who_global_data VALUES (20173, 0, 7835, 0, 27, 86, 38);
INSERT INTO public.who_global_data VALUES (20174, 25012, 5700044, 201, 162829, 86, 141);
INSERT INTO public.who_global_data VALUES (20175, 0, 72, 0, 1, 86, 178);
INSERT INTO public.who_global_data VALUES (20176, 0, 148, 0, 3, 86, 108);
INSERT INTO public.who_global_data VALUES (20177, 3945, 87311, 47, 1898, 86, 39);
INSERT INTO public.who_global_data VALUES (20178, 4, 2586, 0, 67, 86, 2);
INSERT INTO public.who_global_data VALUES (20179, 3, 623, 0, 1, 86, 195);
INSERT INTO public.who_global_data VALUES (20180, 61, 9560, 1, 102, 86, 107);
INSERT INTO public.who_global_data VALUES (20181, 0, 301, 0, 0, 86, 161);
INSERT INTO public.who_global_data VALUES (20182, 0, 22490, 0, 433, 86, 212);
INSERT INTO public.who_global_data VALUES (20183, 4302, 273037, 68, 10632, 86, 181);
INSERT INTO public.who_global_data VALUES (20184, 0, 253, 0, 1, 86, 53);
INSERT INTO public.who_global_data VALUES (20185, 4, 4888, 0, 62, 86, 164);
INSERT INTO public.who_global_data VALUES (20186, 4, 1565, 0, 99, 86, 140);
INSERT INTO public.who_global_data VALUES (20187, 897, 524804, 22, 14633, 86, 20);
INSERT INTO public.who_global_data VALUES (20188, 37, 92336, 0, 4749, 86, 112);
INSERT INTO public.who_global_data VALUES (20189, 7612, 1156675, 174, 33148, 86, 111);
INSERT INTO public.who_global_data VALUES (20190, 6, 569, 0, 7, 86, 71);
INSERT INTO public.who_global_data VALUES (20191, 0, 5379, 0, 92, 86, 218);
INSERT INTO public.who_global_data VALUES (20192, 0, 0, 0, 0, 86, 43);
INSERT INTO public.who_global_data VALUES (20193, 979, 118566, 11, 1502, 86, 49);
INSERT INTO public.who_global_data VALUES (20194, 8, 20855, 1, 127, 86, 1);
INSERT INTO public.who_global_data VALUES (20195, 2597, 72840, 28, 893, 86, 48);
INSERT INTO public.who_global_data VALUES (20196, 37, 7429, 0, 130, 86, 232);
INSERT INTO public.who_global_data VALUES (20197, 29, 1131, 0, 2, 86, 175);
INSERT INTO public.who_global_data VALUES (20198, 165, 6461, 3, 32, 86, 21);
INSERT INTO public.who_global_data VALUES (20199, 8925, 438805, 247, 5570, 86, 156);
INSERT INTO public.who_global_data VALUES (20200, 0, 0, 0, 0, 86, 95);
INSERT INTO public.who_global_data VALUES (20201, 14, 11655, 0, 316, 86, 177);
INSERT INTO public.who_global_data VALUES (20202, 994, 57952, 3, 753, 86, 210);
INSERT INTO public.who_global_data VALUES (20203, 2, 5635, 0, 61, 86, 120);
INSERT INTO public.who_global_data VALUES (20204, 0, 63, 0, 0, 86, 135);
INSERT INTO public.who_global_data VALUES (20205, 134, 131265, 3, 2272, 86, 206);
INSERT INTO public.who_global_data VALUES (20206, 919, 176630, 71, 12920, 86, 189);
INSERT INTO public.who_global_data VALUES (20207, 227, 109881, 11, 6405, 86, 129);
INSERT INTO public.who_global_data VALUES (20208, 0, 35145, 4, 1024, 86, 121);
INSERT INTO public.who_global_data VALUES (20209, 2, 5104, 0, 85, 86, 59);
INSERT INTO public.who_global_data VALUES (20210, 0, 491, 0, 0, 86, 96);
INSERT INTO public.who_global_data VALUES (20211, 132, 6508, 0, 76, 86, 41);
INSERT INTO public.who_global_data VALUES (20212, 20, 6044, 0, 117, 86, 216);
INSERT INTO public.who_global_data VALUES (20213, 400, 100727, 8, 1545, 86, 236);
INSERT INTO public.who_global_data VALUES (20214, 0, 14, 0, 0, 86, 150);
INSERT INTO public.who_global_data VALUES (20215, 0, 497, 0, 0, 86, 61);
INSERT INTO public.who_global_data VALUES (20216, 1, 35, 0, 2, 86, 7);
INSERT INTO public.who_global_data VALUES (20217, 238, 18345, 2, 365, 86, 169);
INSERT INTO public.who_global_data VALUES (20218, 34971, 1829688, 318, 42203, 86, 28);
INSERT INTO public.who_global_data VALUES (20219, 33, 10762, 0, 70, 86, 85);
INSERT INTO public.who_global_data VALUES (20220, 345, 11316, 0, 52, 86, 211);
INSERT INTO public.who_global_data VALUES (20221, 19, 9048, 0, 57, 86, 60);
INSERT INTO public.who_global_data VALUES (20222, 12, 3697, 0, 122, 86, 3);
INSERT INTO public.who_global_data VALUES (20223, 3120, 69681, 33, 599, 86, 11);
INSERT INTO public.who_global_data VALUES (20224, 21866, 727553, 215, 11982, 86, 89);
INSERT INTO public.who_global_data VALUES (20225, 0, 49302, 0, 320, 86, 24);
INSERT INTO public.who_global_data VALUES (20226, 9, 814, 0, 0, 86, 162);
INSERT INTO public.who_global_data VALUES (20227, 2751, 63321, 43, 909, 86, 100);
INSERT INTO public.who_global_data VALUES (20228, 0, 17, 0, 0, 86, 47);
INSERT INTO public.who_global_data VALUES (20229, 0, 32, 0, 0, 86, 29);
INSERT INTO public.who_global_data VALUES (20230, 195, 8098, 6, 139, 86, 40);
INSERT INTO public.who_global_data VALUES (20231, 101, 5653, 0, 91, 86, 222);
INSERT INTO public.who_global_data VALUES (20232, 682, 112811, 13, 3845, 86, 132);
INSERT INTO public.who_global_data VALUES (20233, 3, 282, 0, 13, 86, 130);
INSERT INTO public.who_global_data VALUES (20234, 25, 12484, 0, 74, 86, 234);
INSERT INTO public.who_global_data VALUES (20235, 5, 2419, 1, 43, 86, 23);
INSERT INTO public.who_global_data VALUES (20236, 6, 4530, 2, 137, 86, 192);
INSERT INTO public.who_global_data VALUES (20237, 15, 9152, 0, 232, 86, 69);
INSERT INTO public.who_global_data VALUES (20238, 0, 26, 0, 0, 86, 187);
INSERT INTO public.who_global_data VALUES (20239, 231, 100804, 15, 2780, 86, 230);
INSERT INTO public.who_global_data VALUES (20240, 3927, 126790, 87, 2784, 86, 77);
INSERT INTO public.who_global_data VALUES (20241, 28, 5142, 0, 24, 86, 9);
INSERT INTO public.who_global_data VALUES (20242, 47905, 8683916, 550, 128121, 86, 74);
INSERT INTO public.who_global_data VALUES (20243, 3770, 448118, 75, 14836, 86, 224);
INSERT INTO public.who_global_data VALUES (20244, 11780, 715068, 462, 39664, 86, 199);
INSERT INTO public.who_global_data VALUES (20245, 3198, 508508, 50, 11482, 86, 190);
INSERT INTO public.who_global_data VALUES (20246, 358, 66247, 2, 1965, 86, 12);
INSERT INTO public.who_global_data VALUES (20247, 2, 359, 0, 25, 86, 104);
INSERT INTO public.who_global_data VALUES (20248, 675, 320821, 10, 2703, 86, 153);
INSERT INTO public.who_global_data VALUES (20249, 32961, 1028424, 623, 42953, 86, 91);
INSERT INTO public.who_global_data VALUES (20250, 8, 9581, 1, 225, 86, 215);
INSERT INTO public.who_global_data VALUES (20251, 1555, 111711, 10, 1851, 86, 84);
INSERT INTO public.who_global_data VALUES (20252, 18, 690, 0, 32, 86, 231);
INSERT INTO public.who_global_data VALUES (20253, 5419, 126401, 81, 1467, 86, 196);
INSERT INTO public.who_global_data VALUES (20254, 817, 158853, 0, 2306, 86, 105);
INSERT INTO public.who_global_data VALUES (20255, 1216, 65804, 26, 1180, 86, 122);
INSERT INTO public.who_global_data VALUES (20256, 0, 0, 0, 0, 86, 159);
INSERT INTO public.who_global_data VALUES (20257, 733, 26078, 4, 767, 86, 75);
INSERT INTO public.who_global_data VALUES (20258, 778, 134159, 5, 826, 86, 27);
INSERT INTO public.who_global_data VALUES (20259, 527, 64887, 5, 1193, 86, 54);
INSERT INTO public.who_global_data VALUES (20260, 0, 24, 0, 0, 86, 226);
INSERT INTO public.who_global_data VALUES (20261, 453, 8848, 0, 103, 86, 79);
INSERT INTO public.who_global_data VALUES (20262, 1922, 98829, 14, 763, 86, 56);
INSERT INTO public.who_global_data VALUES (20263, 0, 1967, 0, 44, 86, 117);
INSERT INTO public.who_global_data VALUES (20264, 0, 1461, 0, 82, 86, 152);
INSERT INTO public.who_global_data VALUES (20265, 875, 70885, 13, 970, 86, 16);
INSERT INTO public.who_global_data VALUES (20266, 23, 947, 0, 4, 86, 10);
INSERT INTO public.who_global_data VALUES (20267, 1555, 29771, 11, 251, 86, 201);
INSERT INTO public.who_global_data VALUES (20268, 483, 23710, 5, 198, 86, 174);
INSERT INTO public.who_global_data VALUES (20269, 0, 17233, 0, 249, 86, 119);
INSERT INTO public.who_global_data VALUES (20270, 2, 5955, 0, 185, 86, 168);
INSERT INTO public.who_global_data VALUES (20271, 822, 42872, 2, 302, 86, 99);
INSERT INTO public.who_global_data VALUES (20272, 29, 12059, 0, 41, 86, 171);
INSERT INTO public.who_global_data VALUES (20273, 8, 3753, 1, 138, 86, 87);
INSERT INTO public.who_global_data VALUES (20274, 109, 7635, 4, 86, 86, 123);
INSERT INTO public.who_global_data VALUES (20275, 0, 1, 0, 0, 86, 151);
INSERT INTO public.who_global_data VALUES (20276, 517, 4732, 4, 37, 86, 213);
INSERT INTO public.who_global_data VALUES (20277, 37, 7885, 0, 165, 86, 118);
INSERT INTO public.who_global_data VALUES (20278, 0, 467, 0, 10, 86, 134);
INSERT INTO public.who_global_data VALUES (20279, 0, 4815, 0, 46, 86, 65);
INSERT INTO public.who_global_data VALUES (20280, 5746, 978531, 617, 95842, 86, 102);
INSERT INTO public.who_global_data VALUES (20281, 0, 0, 0, 0, 86, 223);
INSERT INTO public.who_global_data VALUES (20282, 12, 527, 0, 2, 86, 4);
INSERT INTO public.who_global_data VALUES (20283, 8, 382, 0, 0, 86, 146);
INSERT INTO public.who_global_data VALUES (20284, 666, 26053, 8, 363, 86, 31);
INSERT INTO public.who_global_data VALUES (20285, 0, 13, 0, 1, 86, 127);
INSERT INTO public.who_global_data VALUES (20286, 5461, 270626, 81, 4506, 86, 22);
INSERT INTO public.who_global_data VALUES (20287, 99, 13991, 5, 104, 86, 115);
INSERT INTO public.who_global_data VALUES (20288, 1212, 64453, 19, 1480, 86, 106);
INSERT INTO public.who_global_data VALUES (20289, 39, 13292, 0, 134, 86, 90);
INSERT INTO public.who_global_data VALUES (20290, 0, 0, 0, 0, 86, 70);
INSERT INTO public.who_global_data VALUES (20291, 2569, 202329, 26, 1174, 86, 46);
INSERT INTO public.who_global_data VALUES (20292, 5384, 423703, 76, 8199, 86, 139);
INSERT INTO public.who_global_data VALUES (20293, 0, 29, 0, 0, 86, 42);
INSERT INTO public.who_global_data VALUES (20294, 3, 1635, 0, 25, 86, 80);
INSERT INTO public.who_global_data VALUES (20295, 0, 4533, 0, 158, 86, 203);
INSERT INTO public.who_global_data VALUES (20296, 0, 1256, 0, 69, 86, 136);
INSERT INTO public.who_global_data VALUES (20297, 180, 64516, 2, 1162, 86, 63);
INSERT INTO public.who_global_data VALUES (20298, 0, 0, 0, 0, 86, 17);
INSERT INTO public.who_global_data VALUES (20299, 0, 100, 0, 2, 86, 172);
INSERT INTO public.who_global_data VALUES (20300, 1318, 42540, 26, 1212, 86, 109);
INSERT INTO public.who_global_data VALUES (20301, 564, 25885, 0, 285, 86, 200);
INSERT INTO public.who_global_data VALUES (20302, 643, 72144, 5, 612, 86, 93);
INSERT INTO public.who_global_data VALUES (20303, 302, 119186, 5, 1321, 86, 5);
INSERT INTO public.who_global_data VALUES (20304, 0, 741, 0, 13, 86, 214);
INSERT INTO public.who_global_data VALUES (20305, 1708, 348184, 21, 7021, 86, 204);
INSERT INTO public.who_global_data VALUES (20306, 0, 0, 0, 0, 86, 198);
INSERT INTO public.who_global_data VALUES (20307, 971, 141302, 9, 2817, 86, 173);
INSERT INTO public.who_global_data VALUES (20308, 0, 599, 0, 7, 86, 229);
INSERT INTO public.who_global_data VALUES (20309, 549, 68497, 14, 1516, 86, 76);
INSERT INTO public.who_global_data VALUES (20310, 1904, 925431, 49, 34992, 86, 138);
INSERT INTO public.who_global_data VALUES (20311, 1667, 401416, 49, 7710, 86, 98);
INSERT INTO public.who_global_data VALUES (20312, 0, 0, 0, 0, 86, 103);
INSERT INTO public.who_global_data VALUES (20313, 25221, 618813, 430, 8805, 86, 225);
INSERT INTO public.who_global_data VALUES (20314, 4935, 192172, 82, 3103, 86, 131);
INSERT INTO public.who_global_data VALUES (20315, 264, 39120, 12, 901, 86, 235);
INSERT INTO public.who_global_data VALUES (20316, 224, 134887, 0, 233, 86, 137);
INSERT INTO public.who_global_data VALUES (20317, 143, 27940, 0, 487, 86, 81);
INSERT INTO public.who_global_data VALUES (20318, 1115, 84707, 20, 1950, 86, 182);
INSERT INTO public.who_global_data VALUES (20319, 163, 6735, 0, 28, 86, 145);
INSERT INTO public.who_global_data VALUES (20320, 9799, 324094, 203, 8389, 86, 26);
INSERT INTO public.who_global_data VALUES (20321, 21608, 1858568, 439, 32032, 86, 170);
INSERT INTO public.who_global_data VALUES (20322, 50, 5312, 1, 41, 86, 191);
INSERT INTO public.who_global_data VALUES (20323, 0, 5, 0, 0, 86, 221);
INSERT INTO public.who_global_data VALUES (20324, 0, 90, 0, 0, 86, 64);
INSERT INTO public.who_global_data VALUES (20325, 0, 0, 0, 0, 86, 116);
INSERT INTO public.who_global_data VALUES (20326, 0, 19, 0, 0, 86, 128);
INSERT INTO public.who_global_data VALUES (20327, 6, 148, 1, 2, 86, 6);
INSERT INTO public.who_global_data VALUES (20328, 0, 604, 0, 12, 86, 227);
INSERT INTO public.who_global_data VALUES (20329, 0, 14, 0, 0, 86, 68);
INSERT INTO public.who_global_data VALUES (20330, 0, 76, 0, 0, 86, 184);
INSERT INTO public.who_global_data VALUES (20331, 0, 0, 0, 0, 86, 82);
INSERT INTO public.who_global_data VALUES (20332, 35, 1190, 0, 42, 86, 149);
INSERT INTO public.who_global_data VALUES (20333, 0, 962, 0, 16, 86, 197);
INSERT INTO public.who_global_data VALUES (20334, 394, 351849, 14, 5590, 86, 78);
INSERT INTO public.who_global_data VALUES (20335, 15, 15735, 0, 326, 86, 233);
INSERT INTO public.who_global_data VALUES (20336, 3536, 70424, 21, 936, 86, 133);
INSERT INTO public.who_global_data VALUES (20337, 0, 158, 0, 0, 86, 35);
INSERT INTO public.who_global_data VALUES (20338, 3, 2386, 0, 74, 86, 114);
INSERT INTO public.who_global_data VALUES (20339, 18, 58091, 0, 28, 86, 237);
INSERT INTO public.who_global_data VALUES (20340, 0, 14, 0, 0, 86, 55);
INSERT INTO public.who_global_data VALUES (20341, 12, 908, 0, 23, 86, 176);
INSERT INTO public.who_global_data VALUES (20342, 2058, 79181, 24, 414, 86, 202);
INSERT INTO public.who_global_data VALUES (20343, 1932, 50905, 49, 763, 86, 155);
INSERT INTO public.who_global_data VALUES (20344, 0, 16, 0, 0, 86, 32);
INSERT INTO public.who_global_data VALUES (20345, 0, 4301, 0, 107, 86, 220);
INSERT INTO public.who_global_data VALUES (20346, 2140, 742394, 60, 20011, 86, 30);
INSERT INTO public.who_global_data VALUES (20347, 0, 2960, 0, 59, 86, 147);
INSERT INTO public.who_global_data VALUES (20348, 20694, 1494851, 306, 41961, 86, 208);
INSERT INTO public.who_global_data VALUES (20349, 0, 14715, 0, 41, 86, 45);
INSERT INTO public.who_global_data VALUES (20350, 55, 14401, 0, 1116, 86, 110);
INSERT INTO public.who_global_data VALUES (20351, 4, 5245, 0, 113, 86, 88);
INSERT INTO public.who_global_data VALUES (20352, 4497, 166956, 35, 6283, 86, 51);
INSERT INTO public.who_global_data VALUES (20353, 6354, 253483, 89, 3144, 86, 209);
INSERT INTO public.who_global_data VALUES (20354, 69, 6421, 4, 329, 86, 205);
INSERT INTO public.who_global_data VALUES (20355, 39, 11456, 0, 84, 86, 18);
INSERT INTO public.who_global_data VALUES (20356, 5, 3852, 0, 60, 86, 72);
INSERT INTO public.who_global_data VALUES (20357, 22950, 1256729, 595, 50365, 86, 44);
INSERT INTO public.who_global_data VALUES (20358, 0, 30, 0, 0, 86, 15);
INSERT INTO public.who_global_data VALUES (20359, 0, 2558, 0, 57, 86, 25);
INSERT INTO public.who_global_data VALUES (20360, 0, 0, 0, 0, 86, 179);
INSERT INTO public.who_global_data VALUES (20361, 0, 0, 0, 0, 86, 34);
INSERT INTO public.who_global_data VALUES (20362, 31, 5880, 0, 111, 86, 207);
INSERT INTO public.who_global_data VALUES (20363, 1529, 74522, 94, 2100, 86, 166);
INSERT INTO public.who_global_data VALUES (20364, 9423, 1122163, 86, 11145, 86, 126);
INSERT INTO public.who_global_data VALUES (20365, 0, 0, 0, 0, 86, 97);
INSERT INTO public.who_global_data VALUES (20366, 4, 711, 0, 6, 86, 36);
INSERT INTO public.who_global_data VALUES (20367, 0, 0, 0, 0, 86, 125);
INSERT INTO public.who_global_data VALUES (20368, 289, 14993, 6, 139, 86, 124);
INSERT INTO public.who_global_data VALUES (20369, 11057, 500865, 198, 9145, 86, 185);
INSERT INTO public.who_global_data VALUES (20370, 1214, 145599, 2, 520, 86, 194);
INSERT INTO public.who_global_data VALUES (20371, 0, 509, 0, 21, 86, 144);
INSERT INTO public.who_global_data VALUES (20372, 133935, 10124555, 1846, 238573, 86, 19);
INSERT INTO public.who_global_data VALUES (20373, 3, 1413, 0, 23, 86, 217);
INSERT INTO public.who_global_data VALUES (20374, 60, 3620, 0, 62, 86, 148);
INSERT INTO public.who_global_data VALUES (20375, 224, 69397, 2, 591, 86, 86);
INSERT INTO public.who_global_data VALUES (20376, 0, 1, 0, 0, 86, 13);
INSERT INTO public.who_global_data VALUES (20377, 296, 95445, 4, 834, 86, 157);
INSERT INTO public.who_global_data VALUES (20378, 26, 1252, 0, 35, 86, 8);
INSERT INTO public.who_global_data VALUES (20379, 0, 1, 0, 0, 86, 73);
INSERT INTO public.who_global_data VALUES (20380, 0, 2070, 0, 602, 86, 101);
INSERT INTO public.who_global_data VALUES (20381, 39, 17036, 0, 350, 86, 165);
INSERT INTO public.who_global_data VALUES (20382, 57, 8667, 0, 255, 86, 14);
INSERT INTO public.who_global_data VALUES (20383, 166, 42463, 3, 1577, 87, 193);
INSERT INTO public.who_global_data VALUES (20384, 563, 25294, 8, 579, 87, 113);
INSERT INTO public.who_global_data VALUES (20385, 753, 63446, 15, 2077, 87, 143);
INSERT INTO public.who_global_data VALUES (20386, 0, 0, 0, 0, 87, 219);
INSERT INTO public.who_global_data VALUES (20387, 40, 5477, 0, 75, 87, 186);
INSERT INTO public.who_global_data VALUES (20388, 136, 12816, 0, 308, 87, 52);
INSERT INTO public.who_global_data VALUES (20389, 0, 3, 0, 0, 87, 180);
INSERT INTO public.who_global_data VALUES (20390, 0, 131, 0, 3, 87, 167);
INSERT INTO public.who_global_data VALUES (20391, 8317, 1250499, 347, 33907, 87, 154);
INSERT INTO public.who_global_data VALUES (20392, 1861, 109861, 27, 1631, 87, 94);
INSERT INTO public.who_global_data VALUES (20393, 6, 4606, 1, 41, 87, 66);
INSERT INTO public.who_global_data VALUES (20394, 10, 27678, 0, 907, 87, 58);
INSERT INTO public.who_global_data VALUES (20395, 3839, 162051, 35, 1418, 87, 163);
INSERT INTO public.who_global_data VALUES (20396, 1346, 67392, 15, 867, 87, 37);
INSERT INTO public.who_global_data VALUES (20397, 28, 7012, 0, 154, 87, 142);
INSERT INTO public.who_global_data VALUES (20398, 179, 83811, 2, 331, 87, 83);
INSERT INTO public.who_global_data VALUES (20399, 1699, 423620, 16, 6108, 87, 228);
INSERT INTO public.who_global_data VALUES (20400, 0, 243, 0, 7, 87, 188);
INSERT INTO public.who_global_data VALUES (20401, 1038, 108300, 5, 1016, 87, 62);
INSERT INTO public.who_global_data VALUES (20402, 7701, 521805, 217, 13825, 87, 160);
INSERT INTO public.who_global_data VALUES (20403, 54, 4230, 1, 71, 87, 50);
INSERT INTO public.who_global_data VALUES (20404, 63, 2844, 0, 43, 87, 33);
INSERT INTO public.who_global_data VALUES (20405, 0, 214, 0, 9, 87, 183);
INSERT INTO public.who_global_data VALUES (20406, 0, 364, 0, 0, 87, 92);
INSERT INTO public.who_global_data VALUES (20407, 86, 142561, 7, 8802, 87, 158);
INSERT INTO public.who_global_data VALUES (20408, 0, 135, 0, 3, 87, 67);
INSERT INTO public.who_global_data VALUES (20409, 1605, 65025, 46, 1629, 87, 57);
INSERT INTO public.who_global_data VALUES (20410, 0, 7835, 0, 27, 87, 38);
INSERT INTO public.who_global_data VALUES (20411, 10917, 5675032, 231, 162628, 87, 141);
INSERT INTO public.who_global_data VALUES (20412, 0, 72, 0, 1, 87, 178);
INSERT INTO public.who_global_data VALUES (20413, 0, 148, 0, 3, 87, 108);
INSERT INTO public.who_global_data VALUES (20414, 4390, 83366, 80, 1851, 87, 39);
INSERT INTO public.who_global_data VALUES (20415, 1, 2582, 0, 67, 87, 2);
INSERT INTO public.who_global_data VALUES (20416, 5, 620, 0, 1, 87, 195);
INSERT INTO public.who_global_data VALUES (20417, 80, 9499, 1, 101, 87, 107);
INSERT INTO public.who_global_data VALUES (20418, 1, 301, 0, 0, 87, 161);
INSERT INTO public.who_global_data VALUES (20419, 110, 22490, 2, 433, 87, 212);
INSERT INTO public.who_global_data VALUES (20420, 4622, 268735, 42, 10564, 87, 181);
INSERT INTO public.who_global_data VALUES (20421, 3, 253, 0, 1, 87, 53);
INSERT INTO public.who_global_data VALUES (20422, 0, 4884, 0, 62, 87, 164);
INSERT INTO public.who_global_data VALUES (20423, 10, 1561, 0, 99, 87, 140);
INSERT INTO public.who_global_data VALUES (20424, 1028, 523907, 23, 14611, 87, 20);
INSERT INTO public.who_global_data VALUES (20425, 28, 92299, 1, 4749, 87, 112);
INSERT INTO public.who_global_data VALUES (20426, 5176, 1149063, 183, 32974, 87, 111);
INSERT INTO public.who_global_data VALUES (20427, 0, 563, 0, 7, 87, 71);
INSERT INTO public.who_global_data VALUES (20428, 0, 5379, 0, 92, 87, 218);
INSERT INTO public.who_global_data VALUES (20429, 0, 0, 0, 0, 87, 43);
INSERT INTO public.who_global_data VALUES (20430, 488, 117587, 15, 1491, 87, 49);
INSERT INTO public.who_global_data VALUES (20431, 15, 20847, 0, 126, 87, 1);
INSERT INTO public.who_global_data VALUES (20432, 1467, 70243, 33, 865, 87, 48);
INSERT INTO public.who_global_data VALUES (20433, 43, 7392, 0, 130, 87, 232);
INSERT INTO public.who_global_data VALUES (20434, 5, 1102, 0, 2, 87, 175);
INSERT INTO public.who_global_data VALUES (20435, 198, 6296, 2, 29, 87, 21);
INSERT INTO public.who_global_data VALUES (20436, 9005, 429880, 249, 5323, 87, 156);
INSERT INTO public.who_global_data VALUES (20437, 0, 0, 0, 0, 87, 95);
INSERT INTO public.who_global_data VALUES (20438, 34, 11641, 0, 316, 87, 177);
INSERT INTO public.who_global_data VALUES (20439, 1066, 56958, 3, 750, 87, 210);
INSERT INTO public.who_global_data VALUES (20440, 6, 5633, 0, 61, 87, 120);
INSERT INTO public.who_global_data VALUES (20441, 0, 63, 0, 0, 87, 135);
INSERT INTO public.who_global_data VALUES (20442, 528, 131131, 2, 2269, 87, 206);
INSERT INTO public.who_global_data VALUES (20443, 442, 175711, 10, 12849, 87, 189);
INSERT INTO public.who_global_data VALUES (20444, 232, 109654, 14, 6394, 87, 129);
INSERT INTO public.who_global_data VALUES (20445, 0, 35145, 6, 1020, 87, 121);
INSERT INTO public.who_global_data VALUES (20446, 10, 5102, 0, 85, 87, 59);
INSERT INTO public.who_global_data VALUES (20447, 0, 491, 0, 0, 87, 96);
INSERT INTO public.who_global_data VALUES (20448, 126, 6376, 0, 76, 87, 41);
INSERT INTO public.who_global_data VALUES (20449, 11, 6024, 0, 117, 87, 216);
INSERT INTO public.who_global_data VALUES (20450, 345, 100327, 7, 1537, 87, 236);
INSERT INTO public.who_global_data VALUES (20451, 1, 14, 0, 0, 87, 150);
INSERT INTO public.who_global_data VALUES (20452, 0, 497, 0, 0, 87, 61);
INSERT INTO public.who_global_data VALUES (20453, 0, 34, 0, 2, 87, 7);
INSERT INTO public.who_global_data VALUES (20454, 220, 18107, 0, 363, 87, 169);
INSERT INTO public.who_global_data VALUES (20455, 22166, 1794717, 1220, 41885, 87, 28);
INSERT INTO public.who_global_data VALUES (20456, 14, 10729, 0, 70, 87, 85);
INSERT INTO public.who_global_data VALUES (20457, 291, 10971, 3, 52, 87, 211);
INSERT INTO public.who_global_data VALUES (20458, 0, 9029, 0, 57, 87, 60);
INSERT INTO public.who_global_data VALUES (20459, 1, 3685, 1, 122, 87, 3);
INSERT INTO public.who_global_data VALUES (20460, 2911, 66561, 45, 566, 87, 11);
INSERT INTO public.who_global_data VALUES (20461, 18487, 705687, 261, 11767, 87, 89);
INSERT INTO public.who_global_data VALUES (20462, 100, 49302, 0, 320, 87, 24);
INSERT INTO public.who_global_data VALUES (20463, 12, 805, 0, 0, 87, 162);
INSERT INTO public.who_global_data VALUES (20464, 2383, 60570, 41, 866, 87, 100);
INSERT INTO public.who_global_data VALUES (20465, 0, 17, 0, 0, 87, 47);
INSERT INTO public.who_global_data VALUES (20466, 0, 32, 0, 0, 87, 29);
INSERT INTO public.who_global_data VALUES (20467, 0, 7903, 0, 133, 87, 40);
INSERT INTO public.who_global_data VALUES (20468, 177, 5552, 1, 91, 87, 222);
INSERT INTO public.who_global_data VALUES (20469, 769, 112129, 9, 3832, 87, 132);
INSERT INTO public.who_global_data VALUES (20470, 0, 279, 0, 13, 87, 130);
INSERT INTO public.who_global_data VALUES (20471, 33, 12459, 0, 74, 87, 234);
INSERT INTO public.who_global_data VALUES (20472, 0, 2414, 0, 42, 87, 23);
INSERT INTO public.who_global_data VALUES (20473, 10, 4524, 1, 135, 87, 192);
INSERT INTO public.who_global_data VALUES (20474, 10, 9137, 0, 232, 87, 69);
INSERT INTO public.who_global_data VALUES (20475, 0, 26, 0, 0, 87, 187);
INSERT INTO public.who_global_data VALUES (20476, 65, 100573, 14, 2765, 87, 230);
INSERT INTO public.who_global_data VALUES (20477, 3945, 122863, 101, 2697, 87, 77);
INSERT INTO public.who_global_data VALUES (20478, 13, 5114, 1, 24, 87, 9);
INSERT INTO public.who_global_data VALUES (20479, 44281, 8636011, 512, 127571, 87, 74);
INSERT INTO public.who_global_data VALUES (20480, 3779, 444348, 72, 14761, 87, 224);
INSERT INTO public.who_global_data VALUES (20481, 10339, 703288, 453, 39202, 87, 199);
INSERT INTO public.who_global_data VALUES (20482, 3577, 505310, 52, 11432, 87, 190);
INSERT INTO public.who_global_data VALUES (20483, 230, 65889, 15, 1963, 87, 12);
INSERT INTO public.who_global_data VALUES (20484, 0, 357, 0, 25, 87, 104);
INSERT INTO public.who_global_data VALUES (20485, 719, 320146, 6, 2693, 87, 153);
INSERT INTO public.who_global_data VALUES (20486, 35090, 995463, 580, 42330, 87, 91);
INSERT INTO public.who_global_data VALUES (20487, 31, 9573, 3, 224, 87, 215);
INSERT INTO public.who_global_data VALUES (20488, 1173, 110156, 12, 1841, 87, 84);
INSERT INTO public.who_global_data VALUES (20489, 29, 672, 0, 32, 87, 231);
INSERT INTO public.who_global_data VALUES (20490, 5996, 120982, 91, 1386, 87, 196);
INSERT INTO public.who_global_data VALUES (20491, 775, 158036, 0, 2306, 87, 105);
INSERT INTO public.who_global_data VALUES (20492, 1344, 64588, 24, 1154, 87, 122);
INSERT INTO public.who_global_data VALUES (20493, 0, 0, 0, 0, 87, 159);
INSERT INTO public.who_global_data VALUES (20494, 596, 25345, 5, 763, 87, 75);
INSERT INTO public.who_global_data VALUES (20495, 903, 133381, 5, 821, 87, 27);
INSERT INTO public.who_global_data VALUES (20496, 400, 64360, 3, 1188, 87, 54);
INSERT INTO public.who_global_data VALUES (20497, 0, 24, 0, 0, 87, 226);
INSERT INTO public.who_global_data VALUES (20498, 208, 8395, 2, 103, 87, 79);
INSERT INTO public.who_global_data VALUES (20499, 1552, 96907, 17, 749, 87, 56);
INSERT INTO public.who_global_data VALUES (20500, 0, 1967, 0, 44, 87, 117);
INSERT INTO public.who_global_data VALUES (20501, 13, 1461, 0, 82, 87, 152);
INSERT INTO public.who_global_data VALUES (20502, 970, 70010, 13, 957, 87, 16);
INSERT INTO public.who_global_data VALUES (20503, 35, 924, 0, 4, 87, 10);
INSERT INTO public.who_global_data VALUES (20504, 1435, 28216, 10, 240, 87, 201);
INSERT INTO public.who_global_data VALUES (20505, 176, 23227, 5, 193, 87, 174);
INSERT INTO public.who_global_data VALUES (20506, 0, 17233, 0, 249, 87, 119);
INSERT INTO public.who_global_data VALUES (20507, 0, 5953, 0, 185, 87, 168);
INSERT INTO public.who_global_data VALUES (20508, 869, 42050, 6, 300, 87, 99);
INSERT INTO public.who_global_data VALUES (20509, 21, 12030, 1, 41, 87, 171);
INSERT INTO public.who_global_data VALUES (20510, 39, 3745, 0, 137, 87, 87);
INSERT INTO public.who_global_data VALUES (20511, 141, 7526, 3, 82, 87, 123);
INSERT INTO public.who_global_data VALUES (20512, 0, 1, 0, 0, 87, 151);
INSERT INTO public.who_global_data VALUES (20513, 0, 4215, 0, 33, 87, 213);
INSERT INTO public.who_global_data VALUES (20514, 28, 7848, 0, 165, 87, 118);
INSERT INTO public.who_global_data VALUES (20515, 12, 467, 0, 10, 87, 134);
INSERT INTO public.who_global_data VALUES (20516, 0, 4815, 0, 46, 87, 65);
INSERT INTO public.who_global_data VALUES (20517, 4960, 972785, 198, 95225, 87, 102);
INSERT INTO public.who_global_data VALUES (20518, 0, 0, 0, 0, 87, 223);
INSERT INTO public.who_global_data VALUES (20519, 22, 515, 0, 2, 87, 4);
INSERT INTO public.who_global_data VALUES (20520, 6, 374, 0, 0, 87, 146);
INSERT INTO public.who_global_data VALUES (20521, 719, 25387, 7, 355, 87, 31);
INSERT INTO public.who_global_data VALUES (20522, 0, 13, 0, 1, 87, 127);
INSERT INTO public.who_global_data VALUES (20523, 5214, 265165, 69, 4425, 87, 22);
INSERT INTO public.who_global_data VALUES (20524, 69, 13892, 0, 99, 87, 115);
INSERT INTO public.who_global_data VALUES (20525, 1266, 63241, 24, 1461, 87, 106);
INSERT INTO public.who_global_data VALUES (20526, 13, 13253, 0, 134, 87, 90);
INSERT INTO public.who_global_data VALUES (20527, 0, 0, 0, 0, 87, 70);
INSERT INTO public.who_global_data VALUES (20528, 2736, 199760, 22, 1148, 87, 46);
INSERT INTO public.who_global_data VALUES (20529, 4646, 418319, 95, 8123, 87, 139);
INSERT INTO public.who_global_data VALUES (20530, 0, 29, 0, 0, 87, 42);
INSERT INTO public.who_global_data VALUES (20531, 1, 1632, 0, 25, 87, 80);
INSERT INTO public.who_global_data VALUES (20532, 53, 4533, 1, 158, 87, 203);
INSERT INTO public.who_global_data VALUES (20533, 13, 1256, 0, 69, 87, 136);
INSERT INTO public.who_global_data VALUES (20534, 152, 64336, 2, 1160, 87, 63);
INSERT INTO public.who_global_data VALUES (20535, 0, 0, 0, 0, 87, 17);
INSERT INTO public.who_global_data VALUES (20536, 0, 100, 0, 2, 87, 172);
INSERT INTO public.who_global_data VALUES (20537, 947, 41222, 30, 1186, 87, 109);
INSERT INTO public.who_global_data VALUES (20538, 594, 25321, 0, 285, 87, 200);
INSERT INTO public.who_global_data VALUES (20539, 660, 71501, 14, 607, 87, 93);
INSERT INTO public.who_global_data VALUES (20540, 381, 118884, 6, 1316, 87, 5);
INSERT INTO public.who_global_data VALUES (20541, 0, 741, 0, 13, 87, 214);
INSERT INTO public.who_global_data VALUES (20542, 1637, 346476, 23, 7000, 87, 204);
INSERT INTO public.who_global_data VALUES (20543, 0, 0, 0, 0, 87, 198);
INSERT INTO public.who_global_data VALUES (20544, 804, 140331, 10, 2808, 87, 173);
INSERT INTO public.who_global_data VALUES (20545, 0, 599, 0, 7, 87, 229);
INSERT INTO public.who_global_data VALUES (20546, 359, 67948, 12, 1502, 87, 76);
INSERT INTO public.who_global_data VALUES (20547, 1194, 923527, 64, 34943, 87, 138);
INSERT INTO public.who_global_data VALUES (20548, 1300, 399749, 14, 7661, 87, 98);
INSERT INTO public.who_global_data VALUES (20549, 0, 0, 0, 0, 87, 103);
INSERT INTO public.who_global_data VALUES (20550, 25454, 593592, 330, 8375, 87, 225);
INSERT INTO public.who_global_data VALUES (20551, 3817, 187237, 62, 3021, 87, 131);
INSERT INTO public.who_global_data VALUES (20552, 275, 38856, 7, 889, 87, 235);
INSERT INTO public.who_global_data VALUES (20553, 230, 134663, 1, 233, 87, 137);
INSERT INTO public.who_global_data VALUES (20554, 145, 27797, 2, 487, 87, 81);
INSERT INTO public.who_global_data VALUES (20555, 915, 83592, 18, 1930, 87, 182);
INSERT INTO public.who_global_data VALUES (20556, 0, 6572, 0, 28, 87, 145);
INSERT INTO public.who_global_data VALUES (20557, 7304, 314295, 177, 8186, 87, 26);
INSERT INTO public.who_global_data VALUES (20558, 19851, 1836960, 432, 31593, 87, 170);
INSERT INTO public.who_global_data VALUES (20559, 20, 5262, 2, 40, 87, 191);
INSERT INTO public.who_global_data VALUES (20560, 0, 5, 0, 0, 87, 221);
INSERT INTO public.who_global_data VALUES (20561, 0, 90, 0, 0, 87, 64);
INSERT INTO public.who_global_data VALUES (20562, 0, 0, 0, 0, 87, 116);
INSERT INTO public.who_global_data VALUES (20563, 0, 19, 0, 0, 87, 128);
INSERT INTO public.who_global_data VALUES (20564, 11, 142, 1, 1, 87, 6);
INSERT INTO public.who_global_data VALUES (20565, 0, 604, 0, 12, 87, 227);
INSERT INTO public.who_global_data VALUES (20566, 0, 14, 0, 0, 87, 68);
INSERT INTO public.who_global_data VALUES (20567, 0, 76, 0, 0, 87, 184);
INSERT INTO public.who_global_data VALUES (20568, 0, 0, 0, 0, 87, 82);
INSERT INTO public.who_global_data VALUES (20569, 41, 1155, 0, 42, 87, 149);
INSERT INTO public.who_global_data VALUES (20570, 0, 962, 0, 16, 87, 197);
INSERT INTO public.who_global_data VALUES (20571, 471, 351455, 17, 5576, 87, 78);
INSERT INTO public.who_global_data VALUES (20572, 9, 15720, 0, 326, 87, 233);
INSERT INTO public.who_global_data VALUES (20573, 2823, 66888, 14, 915, 87, 133);
INSERT INTO public.who_global_data VALUES (20574, 4, 158, 0, 0, 87, 35);
INSERT INTO public.who_global_data VALUES (20575, 0, 2383, 0, 74, 87, 114);
INSERT INTO public.who_global_data VALUES (20576, 9, 58073, 0, 28, 87, 237);
INSERT INTO public.who_global_data VALUES (20577, 0, 14, 0, 0, 87, 55);
INSERT INTO public.who_global_data VALUES (20578, 0, 896, 0, 23, 87, 176);
INSERT INTO public.who_global_data VALUES (20579, 1051, 77123, 24, 390, 87, 202);
INSERT INTO public.who_global_data VALUES (20580, 2228, 48973, 43, 714, 87, 155);
INSERT INTO public.who_global_data VALUES (20581, 0, 16, 0, 0, 87, 32);
INSERT INTO public.who_global_data VALUES (20582, 0, 4301, 0, 107, 87, 220);
INSERT INTO public.who_global_data VALUES (20583, 1729, 740254, 106, 19951, 87, 30);
INSERT INTO public.who_global_data VALUES (20584, 0, 2960, 0, 59, 87, 147);
INSERT INTO public.who_global_data VALUES (20585, 16650, 1474157, 280, 41655, 87, 208);
INSERT INTO public.who_global_data VALUES (20586, 430, 14715, 6, 41, 87, 45);
INSERT INTO public.who_global_data VALUES (20587, 45, 14346, 0, 1116, 87, 110);
INSERT INTO public.who_global_data VALUES (20588, 2, 5241, 0, 113, 87, 88);
INSERT INTO public.who_global_data VALUES (20589, 3725, 162459, 35, 6248, 87, 51);
INSERT INTO public.who_global_data VALUES (20590, 7387, 247129, 83, 3055, 87, 209);
INSERT INTO public.who_global_data VALUES (20591, 68, 6352, 4, 325, 87, 205);
INSERT INTO public.who_global_data VALUES (20592, 41, 11417, 1, 84, 87, 18);
INSERT INTO public.who_global_data VALUES (20593, 3, 3847, 0, 60, 87, 72);
INSERT INTO public.who_global_data VALUES (20594, 20412, 1233779, 532, 49770, 87, 44);
INSERT INTO public.who_global_data VALUES (20595, 0, 30, 0, 0, 87, 15);
INSERT INTO public.who_global_data VALUES (20596, 42, 2558, 0, 57, 87, 25);
INSERT INTO public.who_global_data VALUES (20597, 0, 0, 0, 0, 87, 179);
INSERT INTO public.who_global_data VALUES (20598, 0, 0, 0, 0, 87, 34);
INSERT INTO public.who_global_data VALUES (20599, 0, 5849, 0, 111, 87, 207);
INSERT INTO public.who_global_data VALUES (20600, 1424, 72993, 86, 2006, 87, 166);
INSERT INTO public.who_global_data VALUES (20601, 9259, 1112740, 87, 11059, 87, 126);
INSERT INTO public.who_global_data VALUES (20602, 0, 0, 0, 0, 87, 97);
INSERT INTO public.who_global_data VALUES (20603, 0, 707, 0, 6, 87, 36);
INSERT INTO public.who_global_data VALUES (20604, 0, 0, 0, 0, 87, 125);
INSERT INTO public.who_global_data VALUES (20605, 130, 14704, 0, 133, 87, 124);
INSERT INTO public.who_global_data VALUES (20606, 10611, 489808, 191, 8947, 87, 185);
INSERT INTO public.who_global_data VALUES (20607, 1096, 144385, 3, 518, 87, 194);
INSERT INTO public.who_global_data VALUES (20608, 0, 509, 0, 21, 87, 144);
INSERT INTO public.who_global_data VALUES (20609, 122231, 9990620, 685, 236727, 87, 19);
INSERT INTO public.who_global_data VALUES (20610, 5, 1410, 0, 23, 87, 217);
INSERT INTO public.who_global_data VALUES (20611, 46, 3560, 0, 62, 87, 148);
INSERT INTO public.who_global_data VALUES (20612, 146, 69173, 1, 589, 87, 86);
INSERT INTO public.who_global_data VALUES (20613, 1, 1, 0, 0, 87, 13);
INSERT INTO public.who_global_data VALUES (20614, 266, 95149, 4, 830, 87, 157);
INSERT INTO public.who_global_data VALUES (20615, 10, 1226, 0, 35, 87, 8);
INSERT INTO public.who_global_data VALUES (20616, 0, 1, 0, 0, 87, 73);
INSERT INTO public.who_global_data VALUES (20617, 0, 2070, 0, 602, 87, 101);
INSERT INTO public.who_global_data VALUES (20618, 26, 16997, 1, 350, 87, 165);
INSERT INTO public.who_global_data VALUES (20619, 49, 8610, 1, 255, 87, 14);
INSERT INTO public.who_global_data VALUES (20620, 138, 42297, 12, 1574, 88, 193);
INSERT INTO public.who_global_data VALUES (20621, 525, 24731, 12, 571, 88, 113);
INSERT INTO public.who_global_data VALUES (20622, 2524, 62693, 51, 2062, 88, 143);
INSERT INTO public.who_global_data VALUES (20623, 0, 0, 0, 0, 88, 219);
INSERT INTO public.who_global_data VALUES (20624, 54, 5437, 0, 75, 88, 186);
INSERT INTO public.who_global_data VALUES (20625, 247, 12680, 1, 308, 88, 52);
INSERT INTO public.who_global_data VALUES (20626, 0, 3, 0, 0, 88, 180);
INSERT INTO public.who_global_data VALUES (20627, 0, 131, 0, 3, 88, 167);
INSERT INTO public.who_global_data VALUES (20628, 5331, 1242182, 212, 33560, 88, 154);
INSERT INTO public.who_global_data VALUES (20629, 1221, 108000, 29, 1604, 88, 94);
INSERT INTO public.who_global_data VALUES (20630, 36, 4600, 1, 40, 88, 66);
INSERT INTO public.who_global_data VALUES (20631, 10, 27668, 0, 907, 88, 58);
INSERT INTO public.who_global_data VALUES (20632, 5704, 158212, 48, 1383, 88, 163);
INSERT INTO public.who_global_data VALUES (20633, 635, 66046, 12, 852, 88, 37);
INSERT INTO public.who_global_data VALUES (20634, 37, 6984, 2, 154, 88, 142);
INSERT INTO public.who_global_data VALUES (20635, 176, 83632, 0, 329, 88, 83);
INSERT INTO public.who_global_data VALUES (20636, 1683, 421921, 25, 6092, 88, 228);
INSERT INTO public.who_global_data VALUES (20637, 0, 243, 0, 7, 88, 188);
INSERT INTO public.who_global_data VALUES (20638, 983, 107262, 4, 1011, 88, 62);
INSERT INTO public.who_global_data VALUES (20639, 8636, 514104, 194, 13608, 88, 160);
INSERT INTO public.who_global_data VALUES (20640, 100, 4176, 2, 70, 88, 50);
INSERT INTO public.who_global_data VALUES (20641, 36, 2781, 0, 43, 88, 33);
INSERT INTO public.who_global_data VALUES (20642, 5, 214, 0, 9, 88, 183);
INSERT INTO public.who_global_data VALUES (20643, 5, 364, 0, 0, 88, 92);
INSERT INTO public.who_global_data VALUES (20644, 48, 142475, 5, 8795, 88, 158);
INSERT INTO public.who_global_data VALUES (20645, 0, 135, 0, 3, 88, 67);
INSERT INTO public.who_global_data VALUES (20646, 997, 63420, 73, 1583, 88, 57);
INSERT INTO public.who_global_data VALUES (20647, 0, 7835, 0, 27, 88, 38);
INSERT INTO public.who_global_data VALUES (20648, 10554, 5664115, 128, 162397, 88, 141);
INSERT INTO public.who_global_data VALUES (20649, 0, 72, 0, 1, 88, 178);
INSERT INTO public.who_global_data VALUES (20650, 0, 148, 0, 3, 88, 108);
INSERT INTO public.who_global_data VALUES (20651, 3816, 78976, 106, 1771, 88, 39);
INSERT INTO public.who_global_data VALUES (20652, 12, 2581, 0, 67, 88, 2);
INSERT INTO public.who_global_data VALUES (20653, 1, 615, 0, 1, 88, 195);
INSERT INTO public.who_global_data VALUES (20654, 50, 9419, 0, 100, 88, 107);
INSERT INTO public.who_global_data VALUES (20655, 3, 300, 0, 0, 88, 161);
INSERT INTO public.who_global_data VALUES (20656, 38, 22380, 2, 431, 88, 212);
INSERT INTO public.who_global_data VALUES (20657, 4058, 264113, 32, 10522, 88, 181);
INSERT INTO public.who_global_data VALUES (20658, 0, 250, 0, 1, 88, 53);
INSERT INTO public.who_global_data VALUES (20659, 4, 4884, 0, 62, 88, 164);
INSERT INTO public.who_global_data VALUES (20660, 4, 1551, 0, 99, 88, 140);
INSERT INTO public.who_global_data VALUES (20661, 1321, 522879, 45, 14588, 88, 20);
INSERT INTO public.who_global_data VALUES (20662, 29, 92271, 0, 4748, 88, 112);
INSERT INTO public.who_global_data VALUES (20663, 7440, 1143887, 196, 32791, 88, 111);
INSERT INTO public.who_global_data VALUES (20664, 0, 563, 0, 7, 88, 71);
INSERT INTO public.who_global_data VALUES (20665, 0, 5379, 0, 92, 88, 218);
INSERT INTO public.who_global_data VALUES (20666, 0, 0, 0, 0, 88, 43);
INSERT INTO public.who_global_data VALUES (20667, 736, 117099, 12, 1476, 88, 49);
INSERT INTO public.who_global_data VALUES (20668, 31, 20832, 0, 126, 88, 1);
INSERT INTO public.who_global_data VALUES (20669, 1529, 68776, 38, 832, 88, 48);
INSERT INTO public.who_global_data VALUES (20670, 52, 7349, 0, 130, 88, 232);
INSERT INTO public.who_global_data VALUES (20671, 67, 1097, 0, 2, 88, 175);
INSERT INTO public.who_global_data VALUES (20672, 111, 6098, 0, 27, 88, 21);
INSERT INTO public.who_global_data VALUES (20673, 6047, 420875, 216, 5074, 88, 156);
INSERT INTO public.who_global_data VALUES (20674, 0, 0, 0, 0, 88, 95);
INSERT INTO public.who_global_data VALUES (20675, 17, 11607, 0, 316, 88, 177);
INSERT INTO public.who_global_data VALUES (20676, 771, 55892, 4, 747, 88, 210);
INSERT INTO public.who_global_data VALUES (20677, 19, 5627, 0, 61, 88, 120);
INSERT INTO public.who_global_data VALUES (20678, 0, 63, 0, 0, 88, 135);
INSERT INTO public.who_global_data VALUES (20679, 421, 130603, 2, 2267, 88, 206);
INSERT INTO public.who_global_data VALUES (20680, 362, 175269, 9, 12839, 88, 189);
INSERT INTO public.who_global_data VALUES (20681, 221, 109422, 12, 6380, 88, 129);
INSERT INTO public.who_global_data VALUES (20682, 0, 35145, 4, 1014, 88, 121);
INSERT INTO public.who_global_data VALUES (20683, 0, 5092, 0, 85, 88, 59);
INSERT INTO public.who_global_data VALUES (20684, 0, 491, 0, 0, 88, 96);
INSERT INTO public.who_global_data VALUES (20685, 125, 6250, 1, 76, 88, 41);
INSERT INTO public.who_global_data VALUES (20686, 10, 6013, 0, 117, 88, 216);
INSERT INTO public.who_global_data VALUES (20687, 307, 99982, 7, 1530, 88, 236);
INSERT INTO public.who_global_data VALUES (20688, 0, 13, 0, 0, 88, 150);
INSERT INTO public.who_global_data VALUES (20689, 0, 497, 0, 0, 88, 61);
INSERT INTO public.who_global_data VALUES (20690, 0, 34, 0, 2, 88, 7);
INSERT INTO public.who_global_data VALUES (20691, 90, 17887, 1, 363, 88, 169);
INSERT INTO public.who_global_data VALUES (20692, 19571, 1772551, 546, 40665, 88, 28);
INSERT INTO public.who_global_data VALUES (20693, 11, 10715, 0, 70, 88, 85);
INSERT INTO public.who_global_data VALUES (20694, 685, 10680, 10, 49, 88, 211);
INSERT INTO public.who_global_data VALUES (20695, 7, 9029, 2, 57, 88, 60);
INSERT INTO public.who_global_data VALUES (20696, 0, 3684, 1, 121, 88, 3);
INSERT INTO public.who_global_data VALUES (20697, 2970, 63650, 22, 521, 88, 11);
INSERT INTO public.who_global_data VALUES (20698, 15332, 687200, 154, 11506, 88, 89);
INSERT INTO public.who_global_data VALUES (20699, 0, 49202, 0, 320, 88, 24);
INSERT INTO public.who_global_data VALUES (20700, 8, 793, 0, 0, 88, 162);
INSERT INTO public.who_global_data VALUES (20701, 1489, 58187, 41, 825, 88, 100);
INSERT INTO public.who_global_data VALUES (20702, 0, 17, 0, 0, 88, 47);
INSERT INTO public.who_global_data VALUES (20703, 2, 32, 0, 0, 88, 29);
INSERT INTO public.who_global_data VALUES (20704, 0, 7903, 0, 133, 88, 40);
INSERT INTO public.who_global_data VALUES (20705, 221, 5375, 0, 90, 88, 222);
INSERT INTO public.who_global_data VALUES (20706, 98, 111360, 2, 3823, 88, 132);
INSERT INTO public.who_global_data VALUES (20707, 0, 279, 0, 13, 88, 130);
INSERT INTO public.who_global_data VALUES (20708, 12, 12426, 0, 74, 88, 234);
INSERT INTO public.who_global_data VALUES (20709, 1, 2414, 1, 42, 88, 23);
INSERT INTO public.who_global_data VALUES (20710, 30, 4514, 0, 134, 88, 192);
INSERT INTO public.who_global_data VALUES (20711, 0, 9127, 0, 232, 88, 69);
INSERT INTO public.who_global_data VALUES (20712, 0, 26, 0, 0, 88, 187);
INSERT INTO public.who_global_data VALUES (20713, 467, 100508, 6, 2751, 88, 230);
INSERT INTO public.who_global_data VALUES (20714, 4140, 118918, 103, 2596, 88, 77);
INSERT INTO public.who_global_data VALUES (20715, 23, 5101, 3, 23, 88, 9);
INSERT INTO public.who_global_data VALUES (20716, 38073, 8591730, 448, 127059, 88, 74);
INSERT INTO public.who_global_data VALUES (20717, 2853, 440569, 75, 14689, 88, 224);
INSERT INTO public.who_global_data VALUES (20718, 10463, 692949, 458, 38749, 88, 199);
INSERT INTO public.who_global_data VALUES (20719, 3184, 501733, 53, 11380, 88, 190);
INSERT INTO public.who_global_data VALUES (20720, 265, 65659, 1, 1948, 88, 12);
INSERT INTO public.who_global_data VALUES (20721, 0, 357, 0, 25, 88, 104);
INSERT INTO public.who_global_data VALUES (20722, 534, 319427, 7, 2687, 88, 153);
INSERT INTO public.who_global_data VALUES (20723, 25269, 960373, 356, 41750, 88, 91);
INSERT INTO public.who_global_data VALUES (20724, 36, 9542, 0, 221, 88, 215);
INSERT INTO public.who_global_data VALUES (20725, 899, 108983, 11, 1829, 88, 84);
INSERT INTO public.who_global_data VALUES (20726, 0, 643, 0, 32, 88, 231);
INSERT INTO public.who_global_data VALUES (20727, 5665, 114986, 62, 1295, 88, 196);
INSERT INTO public.who_global_data VALUES (20728, 810, 157261, 0, 2306, 88, 105);
INSERT INTO public.who_global_data VALUES (20729, 756, 63244, 19, 1130, 88, 122);
INSERT INTO public.who_global_data VALUES (20730, 0, 0, 0, 0, 88, 159);
INSERT INTO public.who_global_data VALUES (20731, 637, 24749, 13, 758, 88, 75);
INSERT INTO public.who_global_data VALUES (20732, 735, 132478, 5, 816, 88, 27);
INSERT INTO public.who_global_data VALUES (20733, 570, 63960, 3, 1185, 88, 54);
INSERT INTO public.who_global_data VALUES (20734, 0, 24, 0, 0, 88, 226);
INSERT INTO public.who_global_data VALUES (20735, 92, 8187, 2, 101, 88, 79);
INSERT INTO public.who_global_data VALUES (20736, 1119, 95355, 9, 732, 88, 56);
INSERT INTO public.who_global_data VALUES (20737, 4, 1967, 0, 44, 88, 117);
INSERT INTO public.who_global_data VALUES (20738, 0, 1448, 0, 82, 88, 152);
INSERT INTO public.who_global_data VALUES (20739, 923, 69040, 15, 944, 88, 16);
INSERT INTO public.who_global_data VALUES (20740, 49, 889, 0, 4, 88, 10);
INSERT INTO public.who_global_data VALUES (20741, 1109, 26781, 17, 230, 88, 201);
INSERT INTO public.who_global_data VALUES (20742, 570, 23051, 3, 188, 88, 174);
INSERT INTO public.who_global_data VALUES (20743, 0, 17233, 0, 249, 88, 119);
INSERT INTO public.who_global_data VALUES (20744, 2, 5953, 1, 185, 88, 168);
INSERT INTO public.who_global_data VALUES (20745, 972, 41181, 8, 294, 88, 99);
INSERT INTO public.who_global_data VALUES (20746, 23, 12009, 0, 40, 88, 171);
INSERT INTO public.who_global_data VALUES (20747, 0, 3706, 0, 137, 88, 87);
INSERT INTO public.who_global_data VALUES (20748, 153, 7385, 4, 79, 88, 123);
INSERT INTO public.who_global_data VALUES (20749, 0, 1, 0, 0, 88, 151);
INSERT INTO public.who_global_data VALUES (20750, 0, 4215, 0, 33, 88, 213);
INSERT INTO public.who_global_data VALUES (20751, 0, 7820, 0, 165, 88, 118);
INSERT INTO public.who_global_data VALUES (20752, 3, 455, 0, 10, 88, 134);
INSERT INTO public.who_global_data VALUES (20753, 265, 4815, 1, 46, 88, 65);
INSERT INTO public.who_global_data VALUES (20754, 5887, 967825, 219, 95027, 88, 102);
INSERT INTO public.who_global_data VALUES (20755, 0, 0, 0, 0, 88, 223);
INSERT INTO public.who_global_data VALUES (20756, 4, 493, 0, 2, 88, 4);
INSERT INTO public.who_global_data VALUES (20757, 6, 368, 0, 0, 88, 146);
INSERT INTO public.who_global_data VALUES (20758, 617, 24668, 7, 348, 88, 31);
INSERT INTO public.who_global_data VALUES (20759, 0, 13, 0, 1, 88, 127);
INSERT INTO public.who_global_data VALUES (20760, 3170, 259951, 84, 4356, 88, 22);
INSERT INTO public.who_global_data VALUES (20761, 55, 13823, 0, 99, 88, 115);
INSERT INTO public.who_global_data VALUES (20762, 598, 61975, 17, 1437, 88, 106);
INSERT INTO public.who_global_data VALUES (20763, 29, 13240, 0, 134, 88, 90);
INSERT INTO public.who_global_data VALUES (20764, 0, 0, 0, 0, 88, 70);
INSERT INTO public.who_global_data VALUES (20765, 2571, 197024, 18, 1126, 88, 46);
INSERT INTO public.who_global_data VALUES (20766, 4672, 413673, 38, 8028, 88, 139);
INSERT INTO public.who_global_data VALUES (20767, 0, 29, 0, 0, 88, 42);
INSERT INTO public.who_global_data VALUES (20768, 1, 1631, 0, 25, 88, 80);
INSERT INTO public.who_global_data VALUES (20769, 0, 4480, 0, 157, 88, 203);
INSERT INTO public.who_global_data VALUES (20770, 0, 1243, 0, 69, 88, 136);
INSERT INTO public.who_global_data VALUES (20771, 94, 64184, 2, 1158, 88, 63);
INSERT INTO public.who_global_data VALUES (20772, 0, 0, 0, 0, 88, 17);
INSERT INTO public.who_global_data VALUES (20773, 2, 100, 0, 2, 88, 172);
INSERT INTO public.who_global_data VALUES (20774, 515, 40275, 20, 1156, 88, 109);
INSERT INTO public.who_global_data VALUES (20775, 1502, 24727, 0, 285, 88, 200);
INSERT INTO public.who_global_data VALUES (20776, 680, 70841, 6, 593, 88, 93);
INSERT INTO public.who_global_data VALUES (20777, 363, 118503, 9, 1310, 88, 5);
INSERT INTO public.who_global_data VALUES (20778, 0, 741, 0, 13, 88, 214);
INSERT INTO public.who_global_data VALUES (20779, 1650, 344839, 9, 6977, 88, 204);
INSERT INTO public.who_global_data VALUES (20780, 0, 0, 0, 0, 88, 198);
INSERT INTO public.who_global_data VALUES (20781, 1021, 139527, 17, 2798, 88, 173);
INSERT INTO public.who_global_data VALUES (20782, 0, 599, 0, 7, 88, 229);
INSERT INTO public.who_global_data VALUES (20783, 648, 67589, 11, 1490, 88, 76);
INSERT INTO public.who_global_data VALUES (20784, 2323, 922333, 39, 34879, 88, 138);
INSERT INTO public.who_global_data VALUES (20785, 2054, 398449, 108, 7647, 88, 98);
INSERT INTO public.who_global_data VALUES (20786, 0, 0, 0, 0, 88, 103);
INSERT INTO public.who_global_data VALUES (20787, 21713, 568138, 173, 8045, 88, 225);
INSERT INTO public.who_global_data VALUES (20788, 4096, 183420, 63, 2959, 88, 131);
INSERT INTO public.who_global_data VALUES (20789, 481, 38581, 10, 882, 88, 235);
INSERT INTO public.who_global_data VALUES (20790, 230, 134433, 0, 232, 88, 137);
INSERT INTO public.who_global_data VALUES (20791, 100, 27652, 5, 485, 88, 81);
INSERT INTO public.who_global_data VALUES (20792, 331, 82677, 19, 1912, 88, 182);
INSERT INTO public.who_global_data VALUES (20793, 308, 6572, 1, 28, 88, 145);
INSERT INTO public.who_global_data VALUES (20794, 3240, 306991, 130, 8009, 88, 26);
INSERT INTO public.who_global_data VALUES (20795, 20977, 1817109, 368, 31161, 88, 170);
INSERT INTO public.who_global_data VALUES (20796, 20, 5242, 2, 38, 88, 191);
INSERT INTO public.who_global_data VALUES (20797, 0, 5, 0, 0, 88, 221);
INSERT INTO public.who_global_data VALUES (20798, 0, 90, 0, 0, 88, 64);
INSERT INTO public.who_global_data VALUES (20799, 0, 0, 0, 0, 88, 116);
INSERT INTO public.who_global_data VALUES (20800, 0, 19, 0, 0, 88, 128);
INSERT INTO public.who_global_data VALUES (20801, 8, 131, 0, 0, 88, 6);
INSERT INTO public.who_global_data VALUES (20802, 0, 604, 0, 12, 88, 227);
INSERT INTO public.who_global_data VALUES (20803, 0, 14, 0, 0, 88, 68);
INSERT INTO public.who_global_data VALUES (20804, 0, 76, 0, 0, 88, 184);
INSERT INTO public.who_global_data VALUES (20805, 0, 0, 0, 0, 88, 82);
INSERT INTO public.who_global_data VALUES (20806, 13, 1114, 0, 42, 88, 149);
INSERT INTO public.who_global_data VALUES (20807, 0, 962, 0, 16, 88, 197);
INSERT INTO public.who_global_data VALUES (20808, 392, 350984, 19, 5559, 88, 78);
INSERT INTO public.who_global_data VALUES (20809, 3, 15711, 0, 326, 88, 233);
INSERT INTO public.who_global_data VALUES (20810, 1318, 64065, 11, 901, 88, 133);
INSERT INTO public.who_global_data VALUES (20811, 0, 154, 0, 0, 88, 35);
INSERT INTO public.who_global_data VALUES (20812, 0, 2383, 0, 74, 88, 114);
INSERT INTO public.who_global_data VALUES (20813, 8, 58064, 0, 28, 88, 237);
INSERT INTO public.who_global_data VALUES (20814, 0, 14, 0, 0, 88, 55);
INSERT INTO public.who_global_data VALUES (20815, 26, 896, 1, 23, 88, 176);
INSERT INTO public.who_global_data VALUES (20816, 577, 76072, 15, 366, 88, 202);
INSERT INTO public.who_global_data VALUES (20817, 1089, 46745, 28, 671, 88, 155);
INSERT INTO public.who_global_data VALUES (20818, 3, 16, 0, 0, 88, 32);
INSERT INTO public.who_global_data VALUES (20819, 72, 4301, 0, 107, 88, 220);
INSERT INTO public.who_global_data VALUES (20820, 1247, 738525, 36, 19845, 88, 30);
INSERT INTO public.who_global_data VALUES (20821, 0, 2960, 0, 59, 88, 147);
INSERT INTO public.who_global_data VALUES (20822, 9879, 1457507, 280, 41375, 88, 208);
INSERT INTO public.who_global_data VALUES (20823, 356, 14285, 0, 35, 88, 45);
INSERT INTO public.who_global_data VALUES (20824, 96, 14301, 0, 1116, 88, 110);
INSERT INTO public.who_global_data VALUES (20825, 5, 5239, 0, 113, 88, 88);
INSERT INTO public.who_global_data VALUES (20826, 2097, 158734, 22, 6213, 88, 51);
INSERT INTO public.who_global_data VALUES (20827, 8683, 239742, 85, 2972, 88, 209);
INSERT INTO public.who_global_data VALUES (20828, 69, 6284, 4, 321, 88, 205);
INSERT INTO public.who_global_data VALUES (20829, 40, 11376, 0, 83, 88, 18);
INSERT INTO public.who_global_data VALUES (20830, 4, 3844, 0, 60, 88, 72);
INSERT INTO public.who_global_data VALUES (20831, 21350, 1213367, 194, 49238, 88, 44);
INSERT INTO public.who_global_data VALUES (20832, 0, 30, 0, 0, 88, 15);
INSERT INTO public.who_global_data VALUES (20833, 33, 2516, 0, 57, 88, 25);
INSERT INTO public.who_global_data VALUES (20834, 0, 0, 0, 0, 88, 179);
INSERT INTO public.who_global_data VALUES (20835, 0, 0, 0, 0, 88, 34);
INSERT INTO public.who_global_data VALUES (20836, 11, 5849, 0, 111, 88, 207);
INSERT INTO public.who_global_data VALUES (20837, 438, 71569, 47, 1920, 88, 166);
INSERT INTO public.who_global_data VALUES (20838, 9306, 1103481, 85, 10972, 88, 126);
INSERT INTO public.who_global_data VALUES (20839, 0, 0, 0, 0, 88, 97);
INSERT INTO public.who_global_data VALUES (20840, 0, 707, 0, 6, 88, 36);
INSERT INTO public.who_global_data VALUES (20841, 0, 0, 0, 0, 88, 125);
INSERT INTO public.who_global_data VALUES (20842, 171, 14574, 1, 133, 88, 124);
INSERT INTO public.who_global_data VALUES (20843, 10179, 479197, 191, 8756, 88, 185);
INSERT INTO public.who_global_data VALUES (20844, 1146, 143289, 1, 515, 88, 194);
INSERT INTO public.who_global_data VALUES (20845, 0, 509, 0, 21, 88, 144);
INSERT INTO public.who_global_data VALUES (20846, 104659, 9868389, 480, 236042, 88, 19);
INSERT INTO public.who_global_data VALUES (20847, 0, 1405, 0, 23, 88, 217);
INSERT INTO public.who_global_data VALUES (20848, 73, 3514, 1, 62, 88, 148);
INSERT INTO public.who_global_data VALUES (20849, 239, 69027, 3, 588, 88, 86);
INSERT INTO public.who_global_data VALUES (20850, 0, 0, 0, 0, 88, 13);
INSERT INTO public.who_global_data VALUES (20851, 185, 94883, 2, 826, 88, 157);
INSERT INTO public.who_global_data VALUES (20852, 3, 1216, 0, 35, 88, 8);
INSERT INTO public.who_global_data VALUES (20853, 0, 1, 0, 0, 88, 73);
INSERT INTO public.who_global_data VALUES (20854, 0, 2070, 0, 602, 88, 101);
INSERT INTO public.who_global_data VALUES (20855, 17, 16971, 0, 349, 88, 165);
INSERT INTO public.who_global_data VALUES (20856, 30, 8561, 1, 254, 88, 14);
INSERT INTO public.who_global_data VALUES (20857, 126, 42159, 6, 1562, 89, 193);
INSERT INTO public.who_global_data VALUES (20858, 501, 24206, 2, 559, 89, 113);
INSERT INTO public.who_global_data VALUES (20859, 0, 60169, 0, 2011, 89, 143);
INSERT INTO public.who_global_data VALUES (20860, 0, 0, 0, 0, 89, 219);
INSERT INTO public.who_global_data VALUES (20861, 64, 5383, 0, 75, 89, 186);
INSERT INTO public.who_global_data VALUES (20862, 98, 12433, 4, 307, 89, 52);
INSERT INTO public.who_global_data VALUES (20863, 0, 3, 0, 0, 89, 180);
INSERT INTO public.who_global_data VALUES (20864, 1, 131, 0, 3, 89, 167);
INSERT INTO public.who_global_data VALUES (20865, 8037, 1236851, 212, 33348, 89, 154);
INSERT INTO public.who_global_data VALUES (20866, 1042, 106779, 21, 1575, 89, 94);
INSERT INTO public.who_global_data VALUES (20867, 0, 4564, 0, 39, 89, 66);
INSERT INTO public.who_global_data VALUES (20868, 6, 27658, 0, 907, 89, 58);
INSERT INTO public.who_global_data VALUES (20869, 6006, 152508, 17, 1335, 89, 163);
INSERT INTO public.who_global_data VALUES (20870, 1663, 65411, 16, 840, 89, 37);
INSERT INTO public.who_global_data VALUES (20871, 31, 6947, 1, 152, 89, 142);
INSERT INTO public.who_global_data VALUES (20872, 192, 83456, 0, 329, 89, 83);
INSERT INTO public.who_global_data VALUES (20873, 1474, 420238, 18, 6067, 89, 228);
INSERT INTO public.who_global_data VALUES (20874, 1, 243, 0, 7, 89, 188);
INSERT INTO public.who_global_data VALUES (20875, 996, 106279, 3, 1007, 89, 62);
INSERT INTO public.who_global_data VALUES (20876, 1449, 505468, 209, 13414, 89, 160);
INSERT INTO public.who_global_data VALUES (20877, 60, 4076, 1, 68, 89, 50);
INSERT INTO public.who_global_data VALUES (20878, 0, 2745, 0, 43, 89, 33);
INSERT INTO public.who_global_data VALUES (20879, 0, 209, 0, 9, 89, 183);
INSERT INTO public.who_global_data VALUES (20880, 0, 359, 0, 0, 89, 92);
INSERT INTO public.who_global_data VALUES (20881, 84, 142427, 9, 8790, 89, 158);
INSERT INTO public.who_global_data VALUES (20882, 0, 135, 0, 3, 89, 67);
INSERT INTO public.who_global_data VALUES (20883, 1211, 62423, 20, 1510, 89, 57);
INSERT INTO public.who_global_data VALUES (20884, 0, 7835, 0, 27, 89, 38);
INSERT INTO public.who_global_data VALUES (20885, 22380, 5653561, 254, 162269, 89, 141);
INSERT INTO public.who_global_data VALUES (20886, 0, 72, 0, 1, 89, 178);
INSERT INTO public.who_global_data VALUES (20887, 0, 148, 0, 3, 89, 108);
INSERT INTO public.who_global_data VALUES (20888, 675, 75160, 33, 1665, 89, 39);
INSERT INTO public.who_global_data VALUES (20889, 4, 2569, 0, 67, 89, 2);
INSERT INTO public.who_global_data VALUES (20890, 0, 614, 0, 1, 89, 195);
INSERT INTO public.who_global_data VALUES (20891, 78, 9369, 0, 100, 89, 107);
INSERT INTO public.who_global_data VALUES (20892, 2, 297, 0, 0, 89, 161);
INSERT INTO public.who_global_data VALUES (20893, 0, 22342, 0, 429, 89, 212);
INSERT INTO public.who_global_data VALUES (20894, 4246, 260055, 54, 10490, 89, 181);
INSERT INTO public.who_global_data VALUES (20895, 0, 250, 0, 1, 89, 53);
INSERT INTO public.who_global_data VALUES (20896, 1, 4880, 0, 62, 89, 164);
INSERT INTO public.who_global_data VALUES (20897, 4, 1547, 0, 99, 89, 140);
INSERT INTO public.who_global_data VALUES (20898, 1581, 521558, 44, 14543, 89, 20);
INSERT INTO public.who_global_data VALUES (20899, 47, 92242, 0, 4748, 89, 112);
INSERT INTO public.who_global_data VALUES (20900, 8714, 1136447, 190, 32595, 89, 111);
INSERT INTO public.who_global_data VALUES (20901, 6, 563, 0, 7, 89, 71);
INSERT INTO public.who_global_data VALUES (20902, 0, 5379, 0, 92, 89, 218);
INSERT INTO public.who_global_data VALUES (20903, 0, 0, 0, 0, 89, 43);
INSERT INTO public.who_global_data VALUES (20904, 946, 116363, 11, 1464, 89, 49);
INSERT INTO public.who_global_data VALUES (20905, 0, 20801, 0, 126, 89, 1);
INSERT INTO public.who_global_data VALUES (20906, 2543, 67247, 42, 794, 89, 48);
INSERT INTO public.who_global_data VALUES (20907, 30, 7297, 0, 130, 89, 232);
INSERT INTO public.who_global_data VALUES (20908, 0, 1030, 0, 2, 89, 175);
INSERT INTO public.who_global_data VALUES (20909, 116, 5987, 0, 27, 89, 21);
INSERT INTO public.who_global_data VALUES (20910, 3608, 414828, 177, 4858, 89, 156);
INSERT INTO public.who_global_data VALUES (20911, 0, 0, 0, 0, 89, 95);
INSERT INTO public.who_global_data VALUES (20912, 74, 11590, 1, 316, 89, 177);
INSERT INTO public.who_global_data VALUES (20913, 891, 55121, 3, 743, 89, 210);
INSERT INTO public.who_global_data VALUES (20914, 3, 5608, 0, 61, 89, 120);
INSERT INTO public.who_global_data VALUES (20915, 0, 63, 0, 0, 89, 135);
INSERT INTO public.who_global_data VALUES (20916, 537, 130182, 2, 2265, 89, 206);
INSERT INTO public.who_global_data VALUES (20917, 1421, 174907, 15, 12830, 89, 189);
INSERT INTO public.who_global_data VALUES (20918, 239, 109201, 13, 6368, 89, 129);
INSERT INTO public.who_global_data VALUES (20919, 0, 35145, 4, 1010, 89, 121);
INSERT INTO public.who_global_data VALUES (20920, 0, 5092, 0, 85, 89, 59);
INSERT INTO public.who_global_data VALUES (20921, 0, 491, 0, 0, 89, 96);
INSERT INTO public.who_global_data VALUES (20922, 192, 6125, 2, 75, 89, 41);
INSERT INTO public.who_global_data VALUES (20923, 14, 6003, 0, 117, 89, 216);
INSERT INTO public.who_global_data VALUES (20924, 471, 99675, 5, 1523, 89, 236);
INSERT INTO public.who_global_data VALUES (20925, 0, 13, 0, 0, 89, 150);
INSERT INTO public.who_global_data VALUES (20926, 2, 497, 0, 0, 89, 61);
INSERT INTO public.who_global_data VALUES (20927, 0, 34, 0, 2, 89, 7);
INSERT INTO public.who_global_data VALUES (20928, 412, 17797, 0, 362, 89, 169);
INSERT INTO public.who_global_data VALUES (20929, 38619, 1752980, 270, 40119, 89, 28);
INSERT INTO public.who_global_data VALUES (20930, 0, 10704, 0, 70, 89, 85);
INSERT INTO public.who_global_data VALUES (20931, 0, 9995, 0, 39, 89, 211);
INSERT INTO public.who_global_data VALUES (20932, 0, 9022, 0, 55, 89, 60);
INSERT INTO public.who_global_data VALUES (20933, 3, 3684, 0, 120, 89, 3);
INSERT INTO public.who_global_data VALUES (20934, 2927, 60680, 24, 499, 89, 11);
INSERT INTO public.who_global_data VALUES (20935, 13363, 671868, 63, 11352, 89, 89);
INSERT INTO public.who_global_data VALUES (20936, 414, 49202, 0, 320, 89, 24);
INSERT INTO public.who_global_data VALUES (20937, 15, 785, 0, 0, 89, 162);
INSERT INTO public.who_global_data VALUES (20938, 1889, 56698, 35, 784, 89, 100);
INSERT INTO public.who_global_data VALUES (20939, 0, 17, 0, 0, 89, 47);
INSERT INTO public.who_global_data VALUES (20940, 0, 30, 0, 0, 89, 29);
INSERT INTO public.who_global_data VALUES (20941, 0, 7903, 0, 133, 89, 40);
INSERT INTO public.who_global_data VALUES (20942, 120, 5154, 1, 90, 89, 222);
INSERT INTO public.who_global_data VALUES (20943, 212, 111262, 10, 3821, 89, 132);
INSERT INTO public.who_global_data VALUES (20944, 1, 279, 0, 13, 89, 130);
INSERT INTO public.who_global_data VALUES (20945, 14, 12414, 1, 74, 89, 234);
INSERT INTO public.who_global_data VALUES (20946, 0, 2413, 0, 41, 89, 23);
INSERT INTO public.who_global_data VALUES (20947, 27, 4484, 1, 134, 89, 192);
INSERT INTO public.who_global_data VALUES (20948, 0, 9127, 0, 232, 89, 69);
INSERT INTO public.who_global_data VALUES (20949, 0, 26, 0, 0, 89, 187);
INSERT INTO public.who_global_data VALUES (20950, 465, 100041, 4, 2745, 89, 230);
INSERT INTO public.who_global_data VALUES (20951, 5162, 114778, 55, 2493, 89, 77);
INSERT INTO public.who_global_data VALUES (20952, 15, 5078, 2, 20, 89, 9);
INSERT INTO public.who_global_data VALUES (20953, 45903, 8553657, 490, 126611, 89, 74);
INSERT INTO public.who_global_data VALUES (20954, 3880, 437716, 74, 14614, 89, 224);
INSERT INTO public.who_global_data VALUES (20955, 9236, 682486, 459, 38291, 89, 199);
INSERT INTO public.who_global_data VALUES (20956, 2530, 498549, 44, 11327, 89, 190);
INSERT INTO public.who_global_data VALUES (20957, 539, 65394, 2, 1947, 89, 12);
INSERT INTO public.who_global_data VALUES (20958, 0, 357, 1, 25, 89, 104);
INSERT INTO public.who_global_data VALUES (20959, 212, 318893, 8, 2680, 89, 153);
INSERT INTO public.who_global_data VALUES (20960, 32614, 935104, 331, 41394, 89, 91);
INSERT INTO public.who_global_data VALUES (20961, 34, 9506, 3, 221, 89, 215);
INSERT INTO public.who_global_data VALUES (20962, 998, 108084, 6, 1818, 89, 84);
INSERT INTO public.who_global_data VALUES (20963, 0, 643, 0, 32, 89, 231);
INSERT INTO public.who_global_data VALUES (20964, 4519, 109321, 52, 1233, 89, 196);
INSERT INTO public.who_global_data VALUES (20965, 575, 156451, 0, 2306, 89, 105);
INSERT INTO public.who_global_data VALUES (20966, 719, 62488, 8, 1111, 89, 122);
INSERT INTO public.who_global_data VALUES (20967, 0, 0, 0, 0, 89, 159);
INSERT INTO public.who_global_data VALUES (20968, 730, 24112, 11, 745, 89, 75);
INSERT INTO public.who_global_data VALUES (20969, 538, 131743, 3, 811, 89, 27);
INSERT INTO public.who_global_data VALUES (20970, 571, 63390, 5, 1182, 89, 54);
INSERT INTO public.who_global_data VALUES (20971, 0, 24, 0, 0, 89, 226);
INSERT INTO public.who_global_data VALUES (20972, 215, 8095, 3, 99, 89, 79);
INSERT INTO public.who_global_data VALUES (20973, 1139, 94236, 10, 723, 89, 56);
INSERT INTO public.who_global_data VALUES (20974, 0, 1963, 0, 44, 89, 117);
INSERT INTO public.who_global_data VALUES (20975, 6, 1448, 0, 82, 89, 152);
INSERT INTO public.who_global_data VALUES (20976, 1078, 68117, 9, 929, 89, 16);
INSERT INTO public.who_global_data VALUES (20977, 22, 840, 1, 4, 89, 10);
INSERT INTO public.who_global_data VALUES (20978, 1038, 25672, 8, 213, 89, 201);
INSERT INTO public.who_global_data VALUES (20979, 0, 22481, 0, 185, 89, 174);
INSERT INTO public.who_global_data VALUES (20980, 122, 17233, 5, 249, 89, 119);
INSERT INTO public.who_global_data VALUES (20981, 3, 5951, 0, 184, 89, 168);
INSERT INTO public.who_global_data VALUES (20982, 852, 40209, 4, 286, 89, 99);
INSERT INTO public.who_global_data VALUES (20983, 24, 11986, 1, 40, 89, 171);
INSERT INTO public.who_global_data VALUES (20984, 30, 3706, 0, 137, 89, 87);
INSERT INTO public.who_global_data VALUES (20985, 102, 7232, 3, 75, 89, 123);
INSERT INTO public.who_global_data VALUES (20986, 0, 1, 0, 0, 89, 151);
INSERT INTO public.who_global_data VALUES (20987, 0, 4215, 0, 33, 89, 213);
INSERT INTO public.who_global_data VALUES (20988, 95, 7820, 2, 165, 89, 118);
INSERT INTO public.who_global_data VALUES (20989, 0, 452, 0, 10, 89, 134);
INSERT INTO public.who_global_data VALUES (20990, 0, 4550, 0, 45, 89, 65);
INSERT INTO public.who_global_data VALUES (20991, 6810, 961938, 485, 94808, 89, 102);
INSERT INTO public.who_global_data VALUES (20992, 0, 0, 0, 0, 89, 223);
INSERT INTO public.who_global_data VALUES (20993, 3, 489, 0, 2, 89, 4);
INSERT INTO public.who_global_data VALUES (20994, 5, 362, 0, 0, 89, 146);
INSERT INTO public.who_global_data VALUES (20995, 956, 24051, 5, 341, 89, 31);
INSERT INTO public.who_global_data VALUES (20996, 0, 13, 0, 1, 89, 127);
INSERT INTO public.who_global_data VALUES (20997, 4596, 256781, 75, 4272, 89, 22);
INSERT INTO public.who_global_data VALUES (20998, 191, 13768, 0, 99, 89, 115);
INSERT INTO public.who_global_data VALUES (20999, 1029, 61377, 24, 1420, 89, 106);
INSERT INTO public.who_global_data VALUES (21000, 41, 13211, 0, 134, 89, 90);
INSERT INTO public.who_global_data VALUES (21001, 0, 0, 0, 0, 89, 70);
INSERT INTO public.who_global_data VALUES (21002, 2817, 194453, 21, 1108, 89, 46);
INSERT INTO public.who_global_data VALUES (21003, 5657, 409001, 43, 7990, 89, 139);
INSERT INTO public.who_global_data VALUES (21004, 0, 29, 0, 0, 89, 42);
INSERT INTO public.who_global_data VALUES (21005, 4, 1630, 0, 25, 89, 80);
INSERT INTO public.who_global_data VALUES (21006, 0, 4480, 0, 157, 89, 203);
INSERT INTO public.who_global_data VALUES (21007, 1, 1243, 0, 69, 89, 136);
INSERT INTO public.who_global_data VALUES (21008, 300, 64090, 0, 1156, 89, 63);
INSERT INTO public.who_global_data VALUES (21009, 0, 0, 0, 0, 89, 17);
INSERT INTO public.who_global_data VALUES (21010, 0, 98, 0, 2, 89, 172);
INSERT INTO public.who_global_data VALUES (21011, 978, 39760, 26, 1136, 89, 109);
INSERT INTO public.who_global_data VALUES (21012, 0, 23225, 0, 285, 89, 200);
INSERT INTO public.who_global_data VALUES (21013, 549, 70161, 3, 587, 89, 93);
INSERT INTO public.who_global_data VALUES (21014, 973, 118140, 15, 1301, 89, 5);
INSERT INTO public.who_global_data VALUES (21015, 0, 741, 0, 13, 89, 214);
INSERT INTO public.who_global_data VALUES (21016, 1436, 343189, 25, 6968, 89, 204);
INSERT INTO public.who_global_data VALUES (21017, 0, 0, 0, 0, 89, 198);
INSERT INTO public.who_global_data VALUES (21018, 746, 138506, 11, 2781, 89, 173);
INSERT INTO public.who_global_data VALUES (21019, 2, 599, 0, 7, 89, 229);
INSERT INTO public.who_global_data VALUES (21020, 460, 66941, 7, 1479, 89, 76);
INSERT INTO public.who_global_data VALUES (21021, 2507, 920010, 57, 34840, 89, 138);
INSERT INTO public.who_global_data VALUES (21022, 2434, 396395, 54, 7539, 89, 98);
INSERT INTO public.who_global_data VALUES (21023, 0, 0, 0, 0, 89, 103);
INSERT INTO public.who_global_data VALUES (21024, 24785, 546425, 236, 7872, 89, 225);
INSERT INTO public.who_global_data VALUES (21025, 5784, 179324, 48, 2896, 89, 131);
INSERT INTO public.who_global_data VALUES (21026, 533, 38100, 10, 872, 89, 235);
INSERT INTO public.who_global_data VALUES (21027, 190, 134203, 0, 232, 89, 137);
INSERT INTO public.who_global_data VALUES (21028, 126, 27552, 2, 480, 89, 81);
INSERT INTO public.who_global_data VALUES (21029, 671, 82346, 2, 1893, 89, 182);
INSERT INTO public.who_global_data VALUES (21030, 0, 6264, 0, 27, 89, 145);
INSERT INTO public.who_global_data VALUES (21031, 6752, 303751, 86, 7879, 89, 26);
INSERT INTO public.who_global_data VALUES (21032, 21798, 1796132, 256, 30793, 89, 170);
INSERT INTO public.who_global_data VALUES (21033, 9, 5222, 0, 36, 89, 191);
INSERT INTO public.who_global_data VALUES (21034, 0, 5, 0, 0, 89, 221);
INSERT INTO public.who_global_data VALUES (21035, 0, 90, 0, 0, 89, 64);
INSERT INTO public.who_global_data VALUES (21036, 0, 0, 0, 0, 89, 116);
INSERT INTO public.who_global_data VALUES (21037, 0, 19, 0, 0, 89, 128);
INSERT INTO public.who_global_data VALUES (21038, 13, 123, 0, 0, 89, 6);
INSERT INTO public.who_global_data VALUES (21039, 0, 604, 0, 12, 89, 227);
INSERT INTO public.who_global_data VALUES (21040, 0, 14, 0, 0, 89, 68);
INSERT INTO public.who_global_data VALUES (21041, 0, 76, 0, 0, 89, 184);
INSERT INTO public.who_global_data VALUES (21042, 0, 0, 0, 0, 89, 82);
INSERT INTO public.who_global_data VALUES (21043, 0, 1101, 0, 42, 89, 149);
INSERT INTO public.who_global_data VALUES (21044, 0, 962, 0, 16, 89, 197);
INSERT INTO public.who_global_data VALUES (21045, 363, 350592, 15, 5540, 89, 78);
INSERT INTO public.who_global_data VALUES (21046, 40, 15708, 0, 326, 89, 233);
INSERT INTO public.who_global_data VALUES (21047, 2112, 62747, 10, 890, 89, 133);
INSERT INTO public.who_global_data VALUES (21048, 0, 154, 0, 0, 89, 35);
INSERT INTO public.who_global_data VALUES (21049, 10, 2383, 0, 74, 89, 114);
INSERT INTO public.who_global_data VALUES (21050, 2, 58056, 0, 28, 89, 237);
INSERT INTO public.who_global_data VALUES (21051, 0, 14, 0, 0, 89, 55);
INSERT INTO public.who_global_data VALUES (21052, 0, 870, 0, 22, 89, 176);
INSERT INTO public.who_global_data VALUES (21053, 1828, 75495, 0, 351, 89, 202);
INSERT INTO public.who_global_data VALUES (21054, 466, 45656, 25, 643, 89, 155);
INSERT INTO public.who_global_data VALUES (21055, 0, 13, 0, 0, 89, 32);
INSERT INTO public.who_global_data VALUES (21056, 0, 4229, 0, 107, 89, 220);
INSERT INTO public.who_global_data VALUES (21057, 1372, 737278, 20, 19809, 89, 30);
INSERT INTO public.who_global_data VALUES (21058, 17, 2960, 0, 59, 89, 147);
INSERT INTO public.who_global_data VALUES (21059, 14826, 1447628, 244, 41095, 89, 208);
INSERT INTO public.who_global_data VALUES (21060, 510, 13929, 1, 35, 89, 45);
INSERT INTO public.who_global_data VALUES (21061, 50, 14205, 0, 1116, 89, 110);
INSERT INTO public.who_global_data VALUES (21062, 7, 5234, 1, 113, 89, 88);
INSERT INTO public.who_global_data VALUES (21063, 4451, 156637, 27, 6191, 89, 51);
INSERT INTO public.who_global_data VALUES (21064, 2979, 231059, 88, 2887, 89, 209);
INSERT INTO public.who_global_data VALUES (21065, 68, 6215, 4, 317, 89, 205);
INSERT INTO public.who_global_data VALUES (21066, 42, 11336, 0, 83, 89, 18);
INSERT INTO public.who_global_data VALUES (21067, 3, 3840, 0, 60, 89, 72);
INSERT INTO public.who_global_data VALUES (21068, 20572, 1192017, 156, 49044, 89, 44);
INSERT INTO public.who_global_data VALUES (21069, 0, 30, 0, 0, 89, 15);
INSERT INTO public.who_global_data VALUES (21070, 41, 2483, 0, 57, 89, 25);
INSERT INTO public.who_global_data VALUES (21071, 0, 0, 0, 0, 89, 179);
INSERT INTO public.who_global_data VALUES (21072, 0, 0, 0, 0, 89, 34);
INSERT INTO public.who_global_data VALUES (21073, 40, 5838, 0, 111, 89, 207);
INSERT INTO public.who_global_data VALUES (21074, 1588, 71131, 25, 1873, 89, 166);
INSERT INTO public.who_global_data VALUES (21075, 9246, 1094175, 84, 10887, 89, 126);
INSERT INTO public.who_global_data VALUES (21076, 0, 0, 0, 0, 89, 97);
INSERT INTO public.who_global_data VALUES (21077, 0, 707, 0, 6, 89, 36);
INSERT INTO public.who_global_data VALUES (21078, 0, 0, 0, 0, 89, 125);
INSERT INTO public.who_global_data VALUES (21079, 337, 14403, 1, 132, 89, 124);
INSERT INTO public.who_global_data VALUES (21080, 8687, 469018, 115, 8565, 89, 185);
INSERT INTO public.who_global_data VALUES (21081, 1111, 142143, 0, 514, 89, 194);
INSERT INTO public.who_global_data VALUES (21082, 0, 509, 0, 21, 89, 144);
INSERT INTO public.who_global_data VALUES (21083, 127151, 9763730, 1062, 235562, 89, 19);
INSERT INTO public.who_global_data VALUES (21084, 15, 1405, 0, 23, 89, 217);
INSERT INTO public.who_global_data VALUES (21085, 71, 3441, 0, 61, 89, 148);
INSERT INTO public.who_global_data VALUES (21086, 195, 68788, 4, 585, 89, 86);
INSERT INTO public.who_global_data VALUES (21087, 0, 0, 0, 0, 89, 13);
INSERT INTO public.who_global_data VALUES (21088, 393, 94698, 3, 824, 89, 157);
INSERT INTO public.who_global_data VALUES (21089, 0, 1213, 0, 35, 89, 8);
INSERT INTO public.who_global_data VALUES (21090, 0, 1, 0, 0, 89, 73);
INSERT INTO public.who_global_data VALUES (21091, 0, 2070, 0, 602, 89, 101);
INSERT INTO public.who_global_data VALUES (21092, 46, 16954, 0, 349, 89, 165);
INSERT INTO public.who_global_data VALUES (21093, 60, 8531, 3, 253, 89, 14);
INSERT INTO public.who_global_data VALUES (21094, 58, 42033, 2, 1556, 90, 193);
INSERT INTO public.who_global_data VALUES (21095, 495, 23705, 8, 557, 90, 113);
INSERT INTO public.who_global_data VALUES (21096, 0, 60169, 0, 2011, 90, 143);
INSERT INTO public.who_global_data VALUES (21097, 0, 0, 0, 0, 90, 219);
INSERT INTO public.who_global_data VALUES (21098, 184, 5319, 0, 75, 90, 186);
INSERT INTO public.who_global_data VALUES (21099, 112, 12335, 3, 303, 90, 52);
INSERT INTO public.who_global_data VALUES (21100, 0, 3, 0, 0, 90, 180);
INSERT INTO public.who_global_data VALUES (21101, 0, 130, 0, 3, 90, 167);
INSERT INTO public.who_global_data VALUES (21102, 11786, 1228814, 370, 33136, 90, 154);
INSERT INTO public.who_global_data VALUES (21103, 2175, 105737, 26, 1554, 90, 94);
INSERT INTO public.who_global_data VALUES (21104, 0, 4564, 0, 39, 90, 66);
INSERT INTO public.who_global_data VALUES (21105, 7, 27652, 0, 907, 90, 58);
INSERT INTO public.who_global_data VALUES (21106, 7898, 146502, 23, 1318, 90, 163);
INSERT INTO public.who_global_data VALUES (21107, 1410, 63748, 13, 824, 90, 37);
INSERT INTO public.who_global_data VALUES (21108, 0, 6916, 0, 151, 90, 142);
INSERT INTO public.who_global_data VALUES (21109, 241, 83264, 1, 329, 90, 83);
INSERT INTO public.who_global_data VALUES (21110, 1289, 418764, 13, 6049, 90, 228);
INSERT INTO public.who_global_data VALUES (21111, 3, 242, 0, 7, 90, 188);
INSERT INTO public.who_global_data VALUES (21112, 0, 105283, 0, 1004, 90, 62);
INSERT INTO public.who_global_data VALUES (21113, 3046, 504019, 208, 13205, 90, 160);
INSERT INTO public.who_global_data VALUES (21114, 39, 4016, 1, 67, 90, 50);
INSERT INTO public.who_global_data VALUES (21115, 0, 2745, 0, 43, 90, 33);
INSERT INTO public.who_global_data VALUES (21116, 2, 209, 0, 9, 90, 183);
INSERT INTO public.who_global_data VALUES (21117, 1, 359, 0, 0, 90, 92);
INSERT INTO public.who_global_data VALUES (21118, 142, 142343, 13, 8781, 90, 158);
INSERT INTO public.who_global_data VALUES (21119, 0, 135, 0, 3, 90, 67);
INSERT INTO public.who_global_data VALUES (21120, 1784, 61212, 33, 1490, 90, 57);
INSERT INTO public.who_global_data VALUES (21121, 0, 7835, 0, 27, 90, 38);
INSERT INTO public.who_global_data VALUES (21122, 18862, 5631181, 279, 162015, 90, 141);
INSERT INTO public.who_global_data VALUES (21123, 0, 72, 0, 1, 90, 178);
INSERT INTO public.who_global_data VALUES (21124, 0, 148, 0, 3, 90, 108);
INSERT INTO public.who_global_data VALUES (21125, 2301, 74485, 56, 1632, 90, 39);
INSERT INTO public.who_global_data VALUES (21126, 3, 2565, 0, 67, 90, 2);
INSERT INTO public.who_global_data VALUES (21127, 2, 614, 0, 1, 90, 195);
INSERT INTO public.who_global_data VALUES (21128, 67, 9291, 0, 100, 90, 107);
INSERT INTO public.who_global_data VALUES (21129, 1, 295, 0, 0, 90, 161);
INSERT INTO public.who_global_data VALUES (21130, 0, 22342, 0, 429, 90, 212);
INSERT INTO public.who_global_data VALUES (21131, 4471, 255809, 55, 10436, 90, 181);
INSERT INTO public.who_global_data VALUES (21132, 5, 250, 0, 1, 90, 53);
INSERT INTO public.who_global_data VALUES (21133, 0, 4879, 0, 62, 90, 164);
INSERT INTO public.who_global_data VALUES (21134, 5, 1543, 0, 99, 90, 140);
INSERT INTO public.who_global_data VALUES (21135, 1587, 519977, 49, 14499, 90, 20);
INSERT INTO public.who_global_data VALUES (21136, 31, 92195, 0, 4748, 90, 112);
INSERT INTO public.who_global_data VALUES (21137, 9756, 1127733, 196, 32405, 90, 111);
INSERT INTO public.who_global_data VALUES (21138, 0, 557, 0, 7, 90, 71);
INSERT INTO public.who_global_data VALUES (21139, 0, 5379, 0, 92, 90, 218);
INSERT INTO public.who_global_data VALUES (21140, 0, 0, 0, 0, 90, 43);
INSERT INTO public.who_global_data VALUES (21141, 1050, 115417, 9, 1453, 90, 49);
INSERT INTO public.who_global_data VALUES (21142, 0, 20801, 0, 126, 90, 1);
INSERT INTO public.who_global_data VALUES (21143, 2399, 64704, 35, 752, 90, 48);
INSERT INTO public.who_global_data VALUES (21144, 39, 7267, 0, 130, 90, 232);
INSERT INTO public.who_global_data VALUES (21145, 0, 1030, 0, 2, 90, 175);
INSERT INTO public.who_global_data VALUES (21146, 314, 5871, 1, 27, 90, 21);
INSERT INTO public.who_global_data VALUES (21147, 7723, 411220, 155, 4681, 90, 156);
INSERT INTO public.who_global_data VALUES (21148, 0, 0, 0, 0, 90, 95);
INSERT INTO public.who_global_data VALUES (21149, 0, 11516, 0, 315, 90, 177);
INSERT INTO public.who_global_data VALUES (21150, 1050, 54230, 2, 740, 90, 210);
INSERT INTO public.who_global_data VALUES (21151, 1, 5605, 0, 61, 90, 120);
INSERT INTO public.who_global_data VALUES (21152, 13, 63, 0, 0, 90, 135);
INSERT INTO public.who_global_data VALUES (21153, 345, 129645, 2, 2263, 90, 206);
INSERT INTO public.who_global_data VALUES (21154, 978, 173486, 54, 12815, 90, 189);
INSERT INTO public.who_global_data VALUES (21155, 208, 108962, 12, 6355, 90, 129);
INSERT INTO public.who_global_data VALUES (21156, 179, 35145, 4, 1006, 90, 121);
INSERT INTO public.who_global_data VALUES (21157, 0, 5092, 0, 85, 90, 59);
INSERT INTO public.who_global_data VALUES (21158, 7, 491, 0, 0, 90, 96);
INSERT INTO public.who_global_data VALUES (21159, 228, 5933, 0, 73, 90, 41);
INSERT INTO public.who_global_data VALUES (21160, 13, 5989, 0, 117, 90, 216);
INSERT INTO public.who_global_data VALUES (21161, 458, 99204, 6, 1518, 90, 236);
INSERT INTO public.who_global_data VALUES (21162, 0, 13, 0, 0, 90, 150);
INSERT INTO public.who_global_data VALUES (21163, 0, 495, 0, 0, 90, 61);
INSERT INTO public.who_global_data VALUES (21164, 0, 34, 0, 2, 90, 7);
INSERT INTO public.who_global_data VALUES (21165, 0, 17385, 0, 362, 90, 169);
INSERT INTO public.who_global_data VALUES (21166, 86794, 1714361, 304, 39849, 90, 28);
INSERT INTO public.who_global_data VALUES (21167, 57, 10704, 0, 70, 90, 85);
INSERT INTO public.who_global_data VALUES (21168, 0, 9995, 0, 39, 90, 211);
INSERT INTO public.who_global_data VALUES (21169, 0, 9022, 0, 55, 90, 60);
INSERT INTO public.who_global_data VALUES (21170, 0, 3681, 0, 120, 90, 3);
INSERT INTO public.who_global_data VALUES (21171, 2901, 57753, 34, 475, 90, 11);
INSERT INTO public.who_global_data VALUES (21172, 16017, 658505, 63, 11289, 90, 89);
INSERT INTO public.who_global_data VALUES (21173, 0, 48788, 0, 320, 90, 24);
INSERT INTO public.who_global_data VALUES (21174, 16, 770, 0, 0, 90, 162);
INSERT INTO public.who_global_data VALUES (21175, 2555, 54809, 34, 749, 90, 100);
INSERT INTO public.who_global_data VALUES (21176, 0, 17, 0, 0, 90, 47);
INSERT INTO public.who_global_data VALUES (21177, 0, 30, 0, 0, 90, 29);
INSERT INTO public.who_global_data VALUES (21178, 0, 7903, 0, 133, 90, 40);
INSERT INTO public.who_global_data VALUES (21179, 36, 5034, 1, 89, 90, 222);
INSERT INTO public.who_global_data VALUES (21180, 548, 111050, 17, 3811, 90, 132);
INSERT INTO public.who_global_data VALUES (21181, 4, 278, 0, 13, 90, 130);
INSERT INTO public.who_global_data VALUES (21182, 37, 12400, 0, 73, 90, 234);
INSERT INTO public.who_global_data VALUES (21183, 0, 2413, 0, 41, 90, 23);
INSERT INTO public.who_global_data VALUES (21184, 64, 4457, 3, 133, 90, 192);
INSERT INTO public.who_global_data VALUES (21185, 18, 9127, 0, 232, 90, 69);
INSERT INTO public.who_global_data VALUES (21186, 0, 26, 0, 0, 90, 187);
INSERT INTO public.who_global_data VALUES (21187, 229, 99576, 5, 2741, 90, 230);
INSERT INTO public.who_global_data VALUES (21188, 4673, 109616, 81, 2438, 90, 77);
INSERT INTO public.who_global_data VALUES (21189, 24, 5063, 0, 18, 90, 9);
INSERT INTO public.who_global_data VALUES (21190, 45674, 8507754, 559, 126121, 90, 74);
INSERT INTO public.who_global_data VALUES (21191, 4262, 433836, 98, 14540, 90, 224);
INSERT INTO public.who_global_data VALUES (21192, 9450, 673250, 423, 37832, 90, 199);
INSERT INTO public.who_global_data VALUES (21193, 2880, 496019, 39, 11283, 90, 190);
INSERT INTO public.who_global_data VALUES (21194, 317, 64855, 5, 1945, 90, 12);
INSERT INTO public.who_global_data VALUES (21195, 0, 357, 0, 24, 90, 104);
INSERT INTO public.who_global_data VALUES (21196, 691, 318681, 16, 2672, 90, 153);
INSERT INTO public.who_global_data VALUES (21197, 39809, 902490, 425, 41063, 90, 91);
INSERT INTO public.who_global_data VALUES (21198, 46, 9472, 0, 218, 90, 215);
INSERT INTO public.who_global_data VALUES (21199, 1172, 107086, 3, 1812, 90, 84);
INSERT INTO public.who_global_data VALUES (21200, 11, 643, 0, 32, 90, 231);
INSERT INTO public.who_global_data VALUES (21201, 3554, 104802, 45, 1181, 90, 196);
INSERT INTO public.who_global_data VALUES (21202, 656, 155876, 47, 2306, 90, 105);
INSERT INTO public.who_global_data VALUES (21203, 1065, 61769, 10, 1103, 90, 122);
INSERT INTO public.who_global_data VALUES (21204, 0, 0, 0, 0, 90, 159);
INSERT INTO public.who_global_data VALUES (21205, 491, 23382, 12, 734, 90, 75);
INSERT INTO public.who_global_data VALUES (21206, 742, 131205, 4, 808, 90, 27);
INSERT INTO public.who_global_data VALUES (21207, 515, 62819, 5, 1177, 90, 54);
INSERT INTO public.who_global_data VALUES (21208, 0, 24, 0, 0, 90, 226);
INSERT INTO public.who_global_data VALUES (21209, 404, 7880, 1, 96, 90, 79);
INSERT INTO public.who_global_data VALUES (21210, 1769, 93097, 13, 713, 90, 56);
INSERT INTO public.who_global_data VALUES (21211, 0, 1963, 0, 44, 90, 117);
INSERT INTO public.who_global_data VALUES (21212, 6, 1442, 0, 82, 90, 152);
INSERT INTO public.who_global_data VALUES (21213, 595, 67039, 5, 920, 90, 16);
INSERT INTO public.who_global_data VALUES (21214, 15, 818, 0, 3, 90, 10);
INSERT INTO public.who_global_data VALUES (21215, 1975, 24634, 9, 205, 90, 201);
INSERT INTO public.who_global_data VALUES (21216, 675, 22481, 5, 185, 90, 174);
INSERT INTO public.who_global_data VALUES (21217, 0, 17111, 0, 244, 90, 119);
INSERT INTO public.who_global_data VALUES (21218, 6, 5948, 0, 184, 90, 168);
INSERT INTO public.who_global_data VALUES (21219, 1168, 39357, 3, 282, 90, 99);
INSERT INTO public.who_global_data VALUES (21220, 30, 11962, 0, 39, 90, 171);
INSERT INTO public.who_global_data VALUES (21221, 43, 3676, 0, 137, 90, 87);
INSERT INTO public.who_global_data VALUES (21222, 102, 7130, 2, 72, 90, 123);
INSERT INTO public.who_global_data VALUES (21223, 0, 1, 0, 0, 90, 151);
INSERT INTO public.who_global_data VALUES (21224, 0, 4215, 0, 33, 90, 213);
INSERT INTO public.who_global_data VALUES (21225, 0, 7725, 0, 163, 90, 118);
INSERT INTO public.who_global_data VALUES (21226, 0, 452, 0, 10, 90, 134);
INSERT INTO public.who_global_data VALUES (21227, 0, 4550, 0, 45, 90, 65);
INSERT INTO public.who_global_data VALUES (21228, 5931, 955128, 551, 94323, 90, 102);
INSERT INTO public.who_global_data VALUES (21229, 0, 0, 0, 0, 90, 223);
INSERT INTO public.who_global_data VALUES (21230, 29, 486, 0, 2, 90, 4);
INSERT INTO public.who_global_data VALUES (21231, 1, 357, 0, 0, 90, 146);
INSERT INTO public.who_global_data VALUES (21232, 382, 23095, 4, 336, 90, 31);
INSERT INTO public.who_global_data VALUES (21233, 0, 13, 0, 1, 90, 127);
INSERT INTO public.who_global_data VALUES (21234, 5836, 252185, 70, 4197, 90, 22);
INSERT INTO public.who_global_data VALUES (21235, 92, 13577, 0, 99, 90, 115);
INSERT INTO public.who_global_data VALUES (21236, 1071, 60348, 20, 1396, 90, 106);
INSERT INTO public.who_global_data VALUES (21237, 27, 13170, 1, 134, 90, 90);
INSERT INTO public.who_global_data VALUES (21238, 0, 0, 0, 0, 90, 70);
INSERT INTO public.who_global_data VALUES (21239, 2753, 191636, 17, 1087, 90, 46);
INSERT INTO public.who_global_data VALUES (21240, 6618, 403344, 72, 7947, 90, 139);
INSERT INTO public.who_global_data VALUES (21241, 0, 29, 0, 0, 90, 42);
INSERT INTO public.who_global_data VALUES (21242, 6, 1626, 0, 25, 90, 80);
INSERT INTO public.who_global_data VALUES (21243, 0, 4480, 0, 157, 90, 203);
INSERT INTO public.who_global_data VALUES (21244, 20, 1242, 0, 69, 90, 136);
INSERT INTO public.who_global_data VALUES (21245, 59, 63790, 0, 1156, 90, 63);
INSERT INTO public.who_global_data VALUES (21246, 0, 0, 0, 0, 90, 17);
INSERT INTO public.who_global_data VALUES (21247, 0, 98, 0, 2, 90, 172);
INSERT INTO public.who_global_data VALUES (21248, 1283, 38782, 14, 1110, 90, 109);
INSERT INTO public.who_global_data VALUES (21249, 0, 23225, 0, 285, 90, 200);
INSERT INTO public.who_global_data VALUES (21250, 431, 69612, 1, 584, 90, 93);
INSERT INTO public.who_global_data VALUES (21251, 0, 117167, 0, 1286, 90, 5);
INSERT INTO public.who_global_data VALUES (21252, 0, 741, 0, 13, 90, 214);
INSERT INTO public.who_global_data VALUES (21253, 1502, 341753, 20, 6943, 90, 204);
INSERT INTO public.who_global_data VALUES (21254, 0, 0, 0, 0, 90, 198);
INSERT INTO public.who_global_data VALUES (21255, 1193, 137760, 14, 2770, 90, 173);
INSERT INTO public.who_global_data VALUES (21256, 0, 597, 0, 7, 90, 229);
INSERT INTO public.who_global_data VALUES (21257, 703, 66481, 10, 1472, 90, 76);
INSERT INTO public.who_global_data VALUES (21258, 2781, 917503, 53, 34783, 90, 138);
INSERT INTO public.who_global_data VALUES (21259, 2152, 393961, 24, 7485, 90, 98);
INSERT INTO public.who_global_data VALUES (21260, 0, 0, 0, 0, 90, 103);
INSERT INTO public.who_global_data VALUES (21261, 27875, 521640, 349, 7636, 90, 225);
INSERT INTO public.who_global_data VALUES (21262, 6640, 173540, 56, 2848, 90, 131);
INSERT INTO public.who_global_data VALUES (21263, -32952, 37567, 0, 862, 90, 235);
INSERT INTO public.who_global_data VALUES (21264, 202, 134013, 0, 232, 90, 137);
INSERT INTO public.who_global_data VALUES (21265, 143, 27426, 1, 478, 90, 81);
INSERT INTO public.who_global_data VALUES (21266, 1174, 81675, 9, 1891, 90, 182);
INSERT INTO public.who_global_data VALUES (21267, 0, 6264, 0, 27, 90, 145);
INSERT INTO public.who_global_data VALUES (21268, 9937, 296999, 130, 7793, 90, 26);
INSERT INTO public.who_global_data VALUES (21269, 20498, 1774334, 286, 30537, 90, 170);
INSERT INTO public.who_global_data VALUES (21270, 5, 5213, 0, 36, 90, 191);
INSERT INTO public.who_global_data VALUES (21271, 0, 5, 0, 0, 90, 221);
INSERT INTO public.who_global_data VALUES (21272, 0, 90, 0, 0, 90, 64);
INSERT INTO public.who_global_data VALUES (21273, 0, 0, 0, 0, 90, 116);
INSERT INTO public.who_global_data VALUES (21274, 0, 19, 0, 0, 90, 128);
INSERT INTO public.who_global_data VALUES (21275, 0, 110, 0, 0, 90, 6);
INSERT INTO public.who_global_data VALUES (21276, 0, 604, 0, 12, 90, 227);
INSERT INTO public.who_global_data VALUES (21277, 1, 14, 0, 0, 90, 68);
INSERT INTO public.who_global_data VALUES (21278, 0, 76, 0, 0, 90, 184);
INSERT INTO public.who_global_data VALUES (21279, 0, 0, 0, 0, 90, 82);
INSERT INTO public.who_global_data VALUES (21280, 0, 1101, 0, 42, 90, 149);
INSERT INTO public.who_global_data VALUES (21281, 2, 962, 0, 16, 90, 197);
INSERT INTO public.who_global_data VALUES (21282, 407, 350229, 19, 5525, 90, 78);
INSERT INTO public.who_global_data VALUES (21283, 0, 15668, 0, 326, 90, 233);
INSERT INTO public.who_global_data VALUES (21284, 2677, 60635, 9, 880, 90, 133);
INSERT INTO public.who_global_data VALUES (21285, 0, 154, 0, 0, 90, 35);
INSERT INTO public.who_global_data VALUES (21286, 0, 2373, 0, 74, 90, 114);
INSERT INTO public.who_global_data VALUES (21287, 7, 58054, 0, 28, 90, 237);
INSERT INTO public.who_global_data VALUES (21288, 0, 14, 0, 0, 90, 55);
INSERT INTO public.who_global_data VALUES (21289, 0, 870, 0, 22, 90, 176);
INSERT INTO public.who_global_data VALUES (21290, 2579, 73667, 34, 351, 90, 202);
INSERT INTO public.who_global_data VALUES (21291, 891, 45190, 21, 618, 90, 155);
INSERT INTO public.who_global_data VALUES (21292, 0, 13, 0, 0, 90, 32);
INSERT INTO public.who_global_data VALUES (21293, 0, 4229, 0, 107, 90, 220);
INSERT INTO public.who_global_data VALUES (21294, 1731, 735906, 40, 19789, 90, 30);
INSERT INTO public.who_global_data VALUES (21295, 0, 2943, 0, 59, 90, 147);
INSERT INTO public.who_global_data VALUES (21296, 23785, 1432802, 334, 40851, 90, 208);
INSERT INTO public.who_global_data VALUES (21297, 449, 13419, 4, 34, 90, 45);
INSERT INTO public.who_global_data VALUES (21298, 65, 14155, 1, 1116, 90, 110);
INSERT INTO public.who_global_data VALUES (21299, 2, 5227, 0, 112, 90, 88);
INSERT INTO public.who_global_data VALUES (21300, 4454, 152186, 25, 6164, 90, 51);
INSERT INTO public.who_global_data VALUES (21301, 4189, 228080, 69, 2799, 90, 209);
INSERT INTO public.who_global_data VALUES (21302, 45, 6147, 4, 313, 90, 205);
INSERT INTO public.who_global_data VALUES (21303, 38, 11294, 0, 83, 90, 18);
INSERT INTO public.who_global_data VALUES (21304, 7, 3837, 0, 60, 90, 72);
INSERT INTO public.who_global_data VALUES (21305, 24957, 1171445, 413, 48888, 90, 44);
INSERT INTO public.who_global_data VALUES (21306, 0, 30, 0, 0, 90, 15);
INSERT INTO public.who_global_data VALUES (21307, 0, 2442, 0, 57, 90, 25);
INSERT INTO public.who_global_data VALUES (21308, 0, 0, 0, 0, 90, 179);
INSERT INTO public.who_global_data VALUES (21309, 0, 0, 0, 0, 90, 34);
INSERT INTO public.who_global_data VALUES (21310, 24, 5798, 0, 111, 90, 207);
INSERT INTO public.who_global_data VALUES (21311, 1584, 69543, 61, 1848, 90, 166);
INSERT INTO public.who_global_data VALUES (21312, 9213, 1084929, 81, 10803, 90, 126);
INSERT INTO public.who_global_data VALUES (21313, 0, 0, 0, 0, 90, 97);
INSERT INTO public.who_global_data VALUES (21314, 2, 707, 0, 6, 90, 36);
INSERT INTO public.who_global_data VALUES (21315, 0, 0, 0, 0, 90, 125);
INSERT INTO public.who_global_data VALUES (21316, 214, 14066, 0, 131, 90, 124);
INSERT INTO public.who_global_data VALUES (21317, 9397, 460331, 138, 8450, 90, 185);
INSERT INTO public.who_global_data VALUES (21318, 1141, 141032, 4, 514, 90, 194);
INSERT INTO public.who_global_data VALUES (21319, 0, 509, 0, 21, 90, 144);
INSERT INTO public.who_global_data VALUES (21320, 131821, 9636579, 1208, 234500, 90, 19);
INSERT INTO public.who_global_data VALUES (21321, 0, 1390, 0, 23, 90, 217);
INSERT INTO public.who_global_data VALUES (21322, 61, 3370, 0, 61, 90, 148);
INSERT INTO public.who_global_data VALUES (21323, 370, 68593, 2, 581, 90, 86);
INSERT INTO public.who_global_data VALUES (21324, 0, 0, 0, 0, 90, 13);
INSERT INTO public.who_global_data VALUES (21325, 384, 94305, 2, 821, 90, 157);
INSERT INTO public.who_global_data VALUES (21326, 0, 1213, 0, 35, 90, 8);
INSERT INTO public.who_global_data VALUES (21327, 0, 1, 0, 0, 90, 73);
INSERT INTO public.who_global_data VALUES (21328, 0, 2070, 0, 602, 90, 101);
INSERT INTO public.who_global_data VALUES (21329, 89, 16908, 0, 349, 90, 165);
INSERT INTO public.who_global_data VALUES (21330, 0, 8471, 0, 250, 90, 14);
INSERT INTO public.who_global_data VALUES (21331, 40, 41975, 0, 1554, 91, 193);
INSERT INTO public.who_global_data VALUES (21332, 489, 23210, 6, 549, 91, 113);
INSERT INTO public.who_global_data VALUES (21333, 1897, 60169, 38, 2011, 91, 143);
INSERT INTO public.who_global_data VALUES (21334, 0, 0, 0, 0, 91, 219);
INSERT INTO public.who_global_data VALUES (21335, 0, 5135, 0, 75, 91, 186);
INSERT INTO public.who_global_data VALUES (21336, 121, 12223, 1, 300, 91, 52);
INSERT INTO public.who_global_data VALUES (21337, 0, 3, 0, 0, 91, 180);
INSERT INTO public.who_global_data VALUES (21338, 0, 130, 0, 3, 91, 167);
INSERT INTO public.who_global_data VALUES (21339, 11100, 1217028, 246, 32766, 91, 154);
INSERT INTO public.who_global_data VALUES (21340, 2476, 103562, 27, 1528, 91, 94);
INSERT INTO public.who_global_data VALUES (21341, 11, 4564, 0, 39, 91, 66);
INSERT INTO public.who_global_data VALUES (21342, 12, 27645, 0, 907, 91, 58);
INSERT INTO public.who_global_data VALUES (21343, 6324, 138604, 44, 1295, 91, 163);
INSERT INTO public.who_global_data VALUES (21344, 1465, 62338, 17, 811, 91, 37);
INSERT INTO public.who_global_data VALUES (21345, 34, 6916, 1, 151, 91, 142);
INSERT INTO public.who_global_data VALUES (21346, 237, 83023, 0, 328, 91, 83);
INSERT INTO public.who_global_data VALUES (21347, 1469, 417475, 15, 6036, 91, 228);
INSERT INTO public.who_global_data VALUES (21348, 0, 239, 0, 7, 91, 188);
INSERT INTO public.who_global_data VALUES (21349, 1988, 105283, 6, 1004, 91, 62);
INSERT INTO public.who_global_data VALUES (21350, 6648, 500973, 211, 12997, 91, 160);
INSERT INTO public.who_global_data VALUES (21351, 72, 3977, 2, 66, 91, 50);
INSERT INTO public.who_global_data VALUES (21352, 0, 2745, 0, 43, 91, 33);
INSERT INTO public.who_global_data VALUES (21353, 1, 207, 0, 9, 91, 183);
INSERT INTO public.who_global_data VALUES (21354, 0, 358, 0, 0, 91, 92);
INSERT INTO public.who_global_data VALUES (21355, 139, 142201, 10, 8768, 91, 158);
INSERT INTO public.who_global_data VALUES (21356, 0, 135, 0, 3, 91, 67);
INSERT INTO public.who_global_data VALUES (21357, 1907, 59428, 55, 1457, 91, 57);
INSERT INTO public.who_global_data VALUES (21358, 0, 7835, 0, 27, 91, 38);
INSERT INTO public.who_global_data VALUES (21359, 22294, 5612319, 630, 161736, 91, 141);
INSERT INTO public.who_global_data VALUES (21360, 0, 72, 0, 1, 91, 178);
INSERT INTO public.who_global_data VALUES (21361, 0, 148, 0, 3, 91, 108);
INSERT INTO public.who_global_data VALUES (21362, 3839, 72184, 58, 1576, 91, 39);
INSERT INTO public.who_global_data VALUES (21363, 12, 2562, 0, 67, 91, 2);
INSERT INTO public.who_global_data VALUES (21364, 7, 612, 0, 1, 91, 195);
INSERT INTO public.who_global_data VALUES (21365, 75, 9224, 3, 100, 91, 107);
INSERT INTO public.who_global_data VALUES (21366, 2, 294, 0, 0, 91, 161);
INSERT INTO public.who_global_data VALUES (21367, 239, 22342, 0, 429, 91, 212);
INSERT INTO public.who_global_data VALUES (21368, 3635, 251338, 50, 10381, 91, 181);
INSERT INTO public.who_global_data VALUES (21369, 1, 245, 0, 1, 91, 53);
INSERT INTO public.who_global_data VALUES (21370, 13, 4879, 0, 62, 91, 164);
INSERT INTO public.who_global_data VALUES (21371, 9, 1538, 0, 99, 91, 140);
INSERT INTO public.who_global_data VALUES (21372, 1808, 518390, 46, 14450, 91, 20);
INSERT INTO public.who_global_data VALUES (21373, 43, 92164, 0, 4748, 91, 112);
INSERT INTO public.who_global_data VALUES (21374, 9893, 1117977, 196, 32209, 91, 111);
INSERT INTO public.who_global_data VALUES (21375, 0, 557, 0, 7, 91, 71);
INSERT INTO public.who_global_data VALUES (21376, 0, 5379, 0, 92, 91, 218);
INSERT INTO public.who_global_data VALUES (21377, 0, 0, 0, 0, 91, 43);
INSERT INTO public.who_global_data VALUES (21378, 1106, 114367, 13, 1444, 91, 49);
INSERT INTO public.who_global_data VALUES (21379, 12, 20801, 0, 126, 91, 1);
INSERT INTO public.who_global_data VALUES (21380, 2890, 62305, 34, 717, 91, 48);
INSERT INTO public.who_global_data VALUES (21381, 44, 7228, 1, 130, 91, 232);
INSERT INTO public.who_global_data VALUES (21382, 9, 1030, 0, 2, 91, 175);
INSERT INTO public.who_global_data VALUES (21383, 224, 5557, 0, 26, 91, 21);
INSERT INTO public.who_global_data VALUES (21384, 11552, 403497, 196, 4526, 91, 156);
INSERT INTO public.who_global_data VALUES (21385, 0, 0, 0, 0, 91, 95);
INSERT INTO public.who_global_data VALUES (21386, 31, 11516, 0, 315, 91, 177);
INSERT INTO public.who_global_data VALUES (21387, 1427, 53180, 5, 738, 91, 210);
INSERT INTO public.who_global_data VALUES (21388, 5, 5604, 0, 61, 91, 120);
INSERT INTO public.who_global_data VALUES (21389, 0, 50, 0, 0, 91, 135);
INSERT INTO public.who_global_data VALUES (21390, 476, 129300, 1, 2261, 91, 206);
INSERT INTO public.who_global_data VALUES (21391, 725, 172508, 31, 12761, 91, 189);
INSERT INTO public.who_global_data VALUES (21392, 224, 108754, 14, 6343, 91, 129);
INSERT INTO public.who_global_data VALUES (21393, 184, 34966, 5, 1002, 91, 121);
INSERT INTO public.who_global_data VALUES (21394, 0, 5092, 0, 85, 91, 59);
INSERT INTO public.who_global_data VALUES (21395, 0, 484, 0, 0, 91, 96);
INSERT INTO public.who_global_data VALUES (21396, 241, 5705, 0, 73, 91, 41);
INSERT INTO public.who_global_data VALUES (21397, 9, 5976, 0, 117, 91, 216);
INSERT INTO public.who_global_data VALUES (21398, 355, 98746, 4, 1512, 91, 236);
INSERT INTO public.who_global_data VALUES (21399, 0, 13, 0, 0, 91, 150);
INSERT INTO public.who_global_data VALUES (21400, 0, 495, 0, 0, 91, 61);
INSERT INTO public.who_global_data VALUES (21401, 0, 34, 0, 2, 91, 7);
INSERT INTO public.who_global_data VALUES (21402, 266, 17385, 1, 362, 91, 169);
INSERT INTO public.who_global_data VALUES (21403, 60235, 1627567, 827, 39545, 91, 28);
INSERT INTO public.who_global_data VALUES (21404, 27, 10647, 0, 70, 91, 85);
INSERT INTO public.who_global_data VALUES (21405, 241, 9995, 0, 39, 91, 211);
INSERT INTO public.who_global_data VALUES (21406, 17, 9022, 0, 55, 91, 60);
INSERT INTO public.who_global_data VALUES (21407, 1, 3681, 0, 120, 91, 3);
INSERT INTO public.who_global_data VALUES (21408, 2859, 54852, 18, 441, 91, 11);
INSERT INTO public.who_global_data VALUES (21409, 23399, 642488, 130, 11226, 91, 89);
INSERT INTO public.who_global_data VALUES (21410, 0, 48788, 0, 320, 91, 24);
INSERT INTO public.who_global_data VALUES (21411, 11, 754, 0, 0, 91, 162);
INSERT INTO public.who_global_data VALUES (21412, 2447, 52254, 13, 715, 91, 100);
INSERT INTO public.who_global_data VALUES (21413, 0, 17, 0, 0, 91, 47);
INSERT INTO public.who_global_data VALUES (21414, 0, 30, 0, 0, 91, 29);
INSERT INTO public.who_global_data VALUES (21415, 0, 7903, 0, 133, 91, 40);
INSERT INTO public.who_global_data VALUES (21416, 67, 4998, 1, 88, 91, 222);
INSERT INTO public.who_global_data VALUES (21417, 653, 110502, 28, 3794, 91, 132);
INSERT INTO public.who_global_data VALUES (21418, 1, 274, 0, 13, 91, 130);
INSERT INTO public.who_global_data VALUES (21419, 0, 12363, 0, 73, 91, 234);
INSERT INTO public.who_global_data VALUES (21420, 0, 2413, 0, 41, 91, 23);
INSERT INTO public.who_global_data VALUES (21421, 69, 4393, 0, 130, 91, 192);
INSERT INTO public.who_global_data VALUES (21422, 0, 9109, 0, 232, 91, 69);
INSERT INTO public.who_global_data VALUES (21423, 0, 26, 0, 0, 91, 187);
INSERT INTO public.who_global_data VALUES (21424, 223, 99347, 6, 2736, 91, 230);
INSERT INTO public.who_global_data VALUES (21425, 5318, 104943, 107, 2357, 91, 77);
INSERT INTO public.who_global_data VALUES (21426, 22, 5039, 0, 18, 91, 9);
INSERT INTO public.who_global_data VALUES (21427, 50356, 8462080, 577, 125562, 91, 74);
INSERT INTO public.who_global_data VALUES (21428, 0, 429574, 0, 14442, 91, 224);
INSERT INTO public.who_global_data VALUES (21429, 8864, 663800, 424, 37409, 91, 199);
INSERT INTO public.who_global_data VALUES (21430, 3568, 493139, 69, 11244, 91, 190);
INSERT INTO public.who_global_data VALUES (21431, 492, 64538, 7, 1940, 91, 12);
INSERT INTO public.who_global_data VALUES (21432, 0, 357, 0, 24, 91, 104);
INSERT INTO public.who_global_data VALUES (21433, 570, 317990, 14, 2656, 91, 153);
INSERT INTO public.who_global_data VALUES (21434, 37802, 862681, 446, 40638, 91, 91);
INSERT INTO public.who_global_data VALUES (21435, 53, 9426, 1, 218, 91, 215);
INSERT INTO public.who_global_data VALUES (21436, 1132, 105914, 3, 1809, 91, 84);
INSERT INTO public.who_global_data VALUES (21437, 12, 632, 0, 32, 91, 231);
INSERT INTO public.who_global_data VALUES (21438, 5384, 101248, 67, 1136, 91, 196);
INSERT INTO public.who_global_data VALUES (21439, 899, 155220, 0, 2259, 91, 105);
INSERT INTO public.who_global_data VALUES (21440, 1109, 60704, 21, 1093, 91, 122);
INSERT INTO public.who_global_data VALUES (21441, 0, 0, 0, 0, 91, 159);
INSERT INTO public.who_global_data VALUES (21442, 728, 22891, 12, 722, 91, 75);
INSERT INTO public.who_global_data VALUES (21443, 825, 130463, 5, 804, 91, 27);
INSERT INTO public.who_global_data VALUES (21444, 556, 62304, 2, 1172, 91, 54);
INSERT INTO public.who_global_data VALUES (21445, 0, 24, 0, 0, 91, 226);
INSERT INTO public.who_global_data VALUES (21446, 357, 7476, 7, 95, 91, 79);
INSERT INTO public.who_global_data VALUES (21447, 2142, 91328, 17, 700, 91, 56);
INSERT INTO public.who_global_data VALUES (21448, 0, 1963, 0, 44, 91, 117);
INSERT INTO public.who_global_data VALUES (21449, 0, 1436, 0, 82, 91, 152);
INSERT INTO public.who_global_data VALUES (21450, 1004, 66444, 8, 915, 91, 16);
INSERT INTO public.who_global_data VALUES (21451, 22, 803, 0, 3, 91, 10);
INSERT INTO public.who_global_data VALUES (21452, 1939, 22659, 10, 196, 91, 201);
INSERT INTO public.who_global_data VALUES (21453, 659, 21806, 3, 180, 91, 174);
INSERT INTO public.who_global_data VALUES (21454, 0, 17111, 0, 244, 91, 119);
INSERT INTO public.who_global_data VALUES (21455, 2, 5942, 0, 184, 91, 168);
INSERT INTO public.who_global_data VALUES (21456, 1755, 38189, 2, 279, 91, 99);
INSERT INTO public.who_global_data VALUES (21457, 39, 11932, 1, 39, 91, 171);
INSERT INTO public.who_global_data VALUES (21458, 0, 3633, 0, 137, 91, 87);
INSERT INTO public.who_global_data VALUES (21459, 146, 7028, 0, 70, 91, 123);
INSERT INTO public.who_global_data VALUES (21460, 0, 1, 0, 0, 91, 151);
INSERT INTO public.who_global_data VALUES (21461, 0, 4215, 0, 33, 91, 213);
INSERT INTO public.who_global_data VALUES (21462, 0, 7725, 0, 163, 91, 118);
INSERT INTO public.who_global_data VALUES (21463, 0, 452, 0, 10, 91, 134);
INSERT INTO public.who_global_data VALUES (21464, 0, 4550, 0, 45, 91, 65);
INSERT INTO public.who_global_data VALUES (21465, 5567, 949197, 544, 93772, 91, 102);
INSERT INTO public.who_global_data VALUES (21466, 0, 0, 0, 0, 91, 223);
INSERT INTO public.who_global_data VALUES (21467, 24, 457, 0, 2, 91, 4);
INSERT INTO public.who_global_data VALUES (21468, 3, 356, 0, 0, 91, 146);
INSERT INTO public.who_global_data VALUES (21469, 429, 22713, 3, 332, 91, 31);
INSERT INTO public.who_global_data VALUES (21470, 0, 13, 0, 1, 91, 127);
INSERT INTO public.who_global_data VALUES (21471, 5398, 246349, 68, 4127, 91, 22);
INSERT INTO public.who_global_data VALUES (21472, 94, 13485, 2, 99, 91, 115);
INSERT INTO public.who_global_data VALUES (21473, 1342, 59277, 24, 1376, 91, 106);
INSERT INTO public.who_global_data VALUES (21474, 52, 13143, 0, 133, 91, 90);
INSERT INTO public.who_global_data VALUES (21475, 0, 0, 0, 0, 91, 70);
INSERT INTO public.who_global_data VALUES (21476, 2909, 188883, 18, 1070, 91, 46);
INSERT INTO public.who_global_data VALUES (21477, 7229, 396726, 116, 7875, 91, 139);
INSERT INTO public.who_global_data VALUES (21478, 0, 29, 0, 0, 91, 42);
INSERT INTO public.who_global_data VALUES (21479, 2, 1620, 0, 25, 91, 80);
INSERT INTO public.who_global_data VALUES (21480, 0, 4480, 0, 157, 91, 203);
INSERT INTO public.who_global_data VALUES (21481, 0, 1222, 0, 69, 91, 136);
INSERT INTO public.who_global_data VALUES (21482, 223, 63731, 1, 1156, 91, 63);
INSERT INTO public.who_global_data VALUES (21483, 0, 0, 0, 0, 91, 17);
INSERT INTO public.who_global_data VALUES (21484, 0, 98, 0, 2, 91, 172);
INSERT INTO public.who_global_data VALUES (21485, 1127, 37499, 12, 1096, 91, 109);
INSERT INTO public.who_global_data VALUES (21486, 650, 23225, 1, 285, 91, 200);
INSERT INTO public.who_global_data VALUES (21487, 681, 69181, 3, 583, 91, 93);
INSERT INTO public.who_global_data VALUES (21488, 0, 117167, 0, 1286, 91, 5);
INSERT INTO public.who_global_data VALUES (21489, 0, 741, 0, 13, 91, 214);
INSERT INTO public.who_global_data VALUES (21490, 1376, 340251, 30, 6923, 91, 204);
INSERT INTO public.who_global_data VALUES (21491, 0, 0, 0, 0, 91, 198);
INSERT INTO public.who_global_data VALUES (21492, 543, 136567, 12, 2756, 91, 173);
INSERT INTO public.who_global_data VALUES (21493, 0, 597, 0, 7, 91, 229);
INSERT INTO public.who_global_data VALUES (21494, 520, 65778, 8, 1462, 91, 76);
INSERT INTO public.who_global_data VALUES (21495, 2935, 914722, 59, 34730, 91, 138);
INSERT INTO public.who_global_data VALUES (21496, 2084, 391809, 52, 7461, 91, 98);
INSERT INTO public.who_global_data VALUES (21497, 0, 0, 0, 0, 91, 103);
INSERT INTO public.who_global_data VALUES (21498, 27086, 493765, 445, 7287, 91, 225);
INSERT INTO public.who_global_data VALUES (21499, 5550, 166900, 52, 2792, 91, 131);
INSERT INTO public.who_global_data VALUES (21500, 1103, 70519, 7, 862, 91, 235);
INSERT INTO public.who_global_data VALUES (21501, 192, 133811, 0, 232, 91, 137);
INSERT INTO public.who_global_data VALUES (21502, 89, 27283, 1, 477, 91, 81);
INSERT INTO public.who_global_data VALUES (21503, 935, 80501, 16, 1882, 91, 182);
INSERT INTO public.who_global_data VALUES (21504, 227, 6264, 1, 27, 91, 145);
INSERT INTO public.who_global_data VALUES (21505, 10260, 287062, 123, 7663, 91, 26);
INSERT INTO public.who_global_data VALUES (21506, 20396, 1753836, 364, 30251, 91, 170);
INSERT INTO public.who_global_data VALUES (21507, 16, 5208, 0, 36, 91, 191);
INSERT INTO public.who_global_data VALUES (21508, 0, 5, 0, 0, 91, 221);
INSERT INTO public.who_global_data VALUES (21509, 0, 90, 0, 0, 91, 64);
INSERT INTO public.who_global_data VALUES (21510, 0, 0, 0, 0, 91, 116);
INSERT INTO public.who_global_data VALUES (21511, 0, 19, 0, 0, 91, 128);
INSERT INTO public.who_global_data VALUES (21512, 4, 110, 0, 0, 91, 6);
INSERT INTO public.who_global_data VALUES (21513, 0, 604, 0, 12, 91, 227);
INSERT INTO public.who_global_data VALUES (21514, 0, 13, 0, 0, 91, 68);
INSERT INTO public.who_global_data VALUES (21515, 1, 76, 0, 0, 91, 184);
INSERT INTO public.who_global_data VALUES (21516, 0, 0, 0, 0, 91, 82);
INSERT INTO public.who_global_data VALUES (21517, 58, 1101, 0, 42, 91, 149);
INSERT INTO public.who_global_data VALUES (21518, 2, 960, 0, 16, 91, 197);
INSERT INTO public.who_global_data VALUES (21519, 436, 349822, 17, 5506, 91, 78);
INSERT INTO public.who_global_data VALUES (21520, 0, 15668, 0, 326, 91, 233);
INSERT INTO public.who_global_data VALUES (21521, 2282, 57958, 10, 871, 91, 133);
INSERT INTO public.who_global_data VALUES (21522, 0, 154, 0, 0, 91, 35);
INSERT INTO public.who_global_data VALUES (21523, 0, 2373, 0, 74, 91, 114);
INSERT INTO public.who_global_data VALUES (21524, 4, 58047, 0, 28, 91, 237);
INSERT INTO public.who_global_data VALUES (21525, 0, 14, 0, 0, 91, 55);
INSERT INTO public.who_global_data VALUES (21526, 0, 870, 0, 22, 91, 176);
INSERT INTO public.who_global_data VALUES (21527, 2354, 71088, 31, 317, 91, 202);
INSERT INTO public.who_global_data VALUES (21528, 1613, 44299, 35, 597, 91, 155);
INSERT INTO public.who_global_data VALUES (21529, 0, 13, 0, 0, 91, 32);
INSERT INTO public.who_global_data VALUES (21530, 0, 4229, 0, 107, 91, 220);
INSERT INTO public.who_global_data VALUES (21531, 1761, 734175, 72, 19749, 91, 30);
INSERT INTO public.who_global_data VALUES (21532, 0, 2943, 0, 59, 91, 147);
INSERT INTO public.who_global_data VALUES (21533, 24028, 1409017, 296, 40517, 91, 208);
INSERT INTO public.who_global_data VALUES (21534, 400, 12970, 1, 30, 91, 45);
INSERT INTO public.who_global_data VALUES (21535, 57, 14090, 0, 1115, 91, 110);
INSERT INTO public.who_global_data VALUES (21536, 5, 5225, 0, 112, 91, 88);
INSERT INTO public.who_global_data VALUES (21537, 4744, 147732, 22, 6139, 91, 51);
INSERT INTO public.who_global_data VALUES (21538, 7377, 223891, 91, 2730, 91, 209);
INSERT INTO public.who_global_data VALUES (21539, 62, 6102, 4, 309, 91, 205);
INSERT INTO public.who_global_data VALUES (21540, 37, 11256, 0, 83, 91, 18);
INSERT INTO public.who_global_data VALUES (21541, 12, 3830, 0, 60, 91, 72);
INSERT INTO public.who_global_data VALUES (21542, 23287, 1146488, 355, 48475, 91, 44);
INSERT INTO public.who_global_data VALUES (21543, 0, 30, 0, 0, 91, 15);
INSERT INTO public.who_global_data VALUES (21544, 0, 2442, 0, 57, 91, 25);
INSERT INTO public.who_global_data VALUES (21545, 0, 0, 0, 0, 91, 179);
INSERT INTO public.who_global_data VALUES (21546, 0, 0, 0, 0, 91, 34);
INSERT INTO public.who_global_data VALUES (21547, 10, 5774, 1, 111, 91, 207);
INSERT INTO public.who_global_data VALUES (21548, 1625, 67959, 66, 1787, 91, 166);
INSERT INTO public.who_global_data VALUES (21549, 9166, 1075716, 83, 10722, 91, 126);
INSERT INTO public.who_global_data VALUES (21550, 0, 0, 0, 0, 91, 97);
INSERT INTO public.who_global_data VALUES (21551, 0, 705, 0, 6, 91, 36);
INSERT INTO public.who_global_data VALUES (21552, 0, 0, 0, 0, 91, 125);
INSERT INTO public.who_global_data VALUES (21553, 284, 13852, 14, 131, 91, 124);
INSERT INTO public.who_global_data VALUES (21554, 10746, 450934, 186, 8312, 91, 185);
INSERT INTO public.who_global_data VALUES (21555, 1292, 139891, 2, 510, 91, 194);
INSERT INTO public.who_global_data VALUES (21556, 0, 509, 0, 21, 91, 144);
INSERT INTO public.who_global_data VALUES (21557, 116780, 9504758, 1126, 233292, 91, 19);
INSERT INTO public.who_global_data VALUES (21558, 2, 1390, 0, 23, 91, 217);
INSERT INTO public.who_global_data VALUES (21559, 64, 3309, 0, 61, 91, 148);
INSERT INTO public.who_global_data VALUES (21560, 84, 68223, 0, 579, 91, 86);
INSERT INTO public.who_global_data VALUES (21561, 0, 0, 0, 0, 91, 13);
INSERT INTO public.who_global_data VALUES (21562, 441, 93921, 5, 819, 91, 157);
INSERT INTO public.who_global_data VALUES (21563, 3, 1213, 0, 35, 91, 8);
INSERT INTO public.who_global_data VALUES (21564, 0, 1, 0, 0, 91, 73);
INSERT INTO public.who_global_data VALUES (21565, 0, 2070, 0, 602, 91, 101);
INSERT INTO public.who_global_data VALUES (21566, 49, 16819, 0, 349, 91, 165);
INSERT INTO public.who_global_data VALUES (21567, 28, 8471, 2, 250, 91, 14);
INSERT INTO public.who_global_data VALUES (21568, 121, 41935, 6, 1554, 92, 193);
INSERT INTO public.who_global_data VALUES (21569, 421, 22721, 7, 543, 92, 113);
INSERT INTO public.who_global_data VALUES (21570, 330, 58272, 9, 1973, 92, 143);
INSERT INTO public.who_global_data VALUES (21571, 0, 0, 0, 0, 92, 219);
INSERT INTO public.who_global_data VALUES (21572, 90, 5135, 0, 75, 92, 186);
INSERT INTO public.who_global_data VALUES (21573, 289, 12102, 3, 299, 92, 52);
INSERT INTO public.who_global_data VALUES (21574, 0, 3, 0, 0, 92, 180);
INSERT INTO public.who_global_data VALUES (21575, 0, 130, 0, 3, 92, 167);
INSERT INTO public.who_global_data VALUES (21576, 9516, 1205928, 468, 32520, 92, 154);
INSERT INTO public.who_global_data VALUES (21577, 2210, 101086, 30, 1501, 92, 94);
INSERT INTO public.who_global_data VALUES (21578, 15, 4553, 1, 39, 92, 66);
INSERT INTO public.who_global_data VALUES (21579, 11, 27633, 0, 907, 92, 58);
INSERT INTO public.who_global_data VALUES (21580, 7051, 132280, 47, 1251, 92, 163);
INSERT INTO public.who_global_data VALUES (21581, 1364, 60873, 14, 794, 92, 37);
INSERT INTO public.who_global_data VALUES (21582, 39, 6882, 0, 150, 92, 142);
INSERT INTO public.who_global_data VALUES (21583, 162, 82786, 1, 328, 92, 83);
INSERT INTO public.who_global_data VALUES (21584, 1842, 416006, 17, 6021, 92, 228);
INSERT INTO public.who_global_data VALUES (21585, 1, 239, 0, 7, 92, 188);
INSERT INTO public.who_global_data VALUES (21586, 982, 103295, 3, 998, 92, 62);
INSERT INTO public.who_global_data VALUES (21587, 7660, 494325, 207, 12786, 92, 160);
INSERT INTO public.who_global_data VALUES (21588, 115, 3905, 3, 64, 92, 50);
INSERT INTO public.who_global_data VALUES (21589, 0, 2745, 0, 43, 92, 33);
INSERT INTO public.who_global_data VALUES (21590, 0, 206, 0, 9, 92, 183);
INSERT INTO public.who_global_data VALUES (21591, 0, 358, 0, 0, 92, 92);
INSERT INTO public.who_global_data VALUES (21592, 126, 142062, 7, 8758, 92, 158);
INSERT INTO public.who_global_data VALUES (21593, 1, 135, 0, 3, 92, 67);
INSERT INTO public.who_global_data VALUES (21594, 1919, 57521, 43, 1402, 92, 57);
INSERT INTO public.who_global_data VALUES (21595, 1193, 7835, 3, 27, 92, 38);
INSERT INTO public.who_global_data VALUES (21596, 23976, 5590025, 610, 161106, 92, 141);
INSERT INTO public.who_global_data VALUES (21597, 0, 72, 0, 1, 92, 178);
INSERT INTO public.who_global_data VALUES (21598, 0, 148, 0, 3, 92, 108);
INSERT INTO public.who_global_data VALUES (21599, 3754, 68345, 52, 1518, 92, 39);
INSERT INTO public.who_global_data VALUES (21600, 11, 2550, 0, 67, 92, 2);
INSERT INTO public.who_global_data VALUES (21601, 5, 605, 0, 1, 92, 195);
INSERT INTO public.who_global_data VALUES (21602, 96, 9149, 2, 97, 92, 107);
INSERT INTO public.who_global_data VALUES (21603, 0, 292, 0, 0, 92, 161);
INSERT INTO public.who_global_data VALUES (21604, 0, 22103, 0, 429, 92, 212);
INSERT INTO public.who_global_data VALUES (21605, 2768, 247703, 52, 10331, 92, 181);
INSERT INTO public.who_global_data VALUES (21606, 2, 244, 0, 1, 92, 53);
INSERT INTO public.who_global_data VALUES (21607, 0, 4866, 0, 62, 92, 164);
INSERT INTO public.who_global_data VALUES (21608, 12, 1529, 0, 99, 92, 140);
INSERT INTO public.who_global_data VALUES (21609, 1540, 516582, 64, 14404, 92, 20);
INSERT INTO public.who_global_data VALUES (21610, 44, 92121, 1, 4748, 92, 112);
INSERT INTO public.who_global_data VALUES (21611, 8692, 1108084, 166, 32013, 92, 111);
INSERT INTO public.who_global_data VALUES (21612, 3, 557, 0, 7, 92, 71);
INSERT INTO public.who_global_data VALUES (21613, 31, 5379, 0, 92, 92, 218);
INSERT INTO public.who_global_data VALUES (21614, 0, 0, 0, 0, 92, 43);
INSERT INTO public.who_global_data VALUES (21615, 1141, 113261, 12, 1431, 92, 49);
INSERT INTO public.who_global_data VALUES (21616, 11, 20789, 0, 126, 92, 1);
INSERT INTO public.who_global_data VALUES (21617, 2848, 59415, 29, 683, 92, 48);
INSERT INTO public.who_global_data VALUES (21618, 40, 7184, 0, 129, 92, 232);
INSERT INTO public.who_global_data VALUES (21619, 21, 1021, 1, 2, 92, 175);
INSERT INTO public.who_global_data VALUES (21620, 233, 5333, 0, 26, 92, 21);
INSERT INTO public.who_global_data VALUES (21621, 13229, 391945, 197, 4330, 92, 156);
INSERT INTO public.who_global_data VALUES (21622, 0, 0, 0, 0, 92, 95);
INSERT INTO public.who_global_data VALUES (21623, 36, 11485, 0, 315, 92, 177);
INSERT INTO public.who_global_data VALUES (21624, 1223, 51753, 4, 733, 92, 210);
INSERT INTO public.who_global_data VALUES (21625, 19, 5599, 0, 61, 92, 120);
INSERT INTO public.who_global_data VALUES (21626, 0, 50, 0, 0, 92, 135);
INSERT INTO public.who_global_data VALUES (21627, 546, 128824, 3, 2260, 92, 206);
INSERT INTO public.who_global_data VALUES (21628, 350, 171783, 26, 12730, 92, 189);
INSERT INTO public.who_global_data VALUES (21629, 201, 108530, 11, 6329, 92, 129);
INSERT INTO public.who_global_data VALUES (21630, 767, 34782, 5, 997, 92, 121);
INSERT INTO public.who_global_data VALUES (21631, 3, 5092, 2, 85, 92, 59);
INSERT INTO public.who_global_data VALUES (21632, 4, 484, 0, 0, 92, 96);
INSERT INTO public.who_global_data VALUES (21633, 131, 5464, 0, 73, 92, 41);
INSERT INTO public.who_global_data VALUES (21634, 12, 5967, 0, 117, 92, 216);
INSERT INTO public.who_global_data VALUES (21635, 510, 98391, 5, 1508, 92, 236);
INSERT INTO public.who_global_data VALUES (21636, 0, 13, 0, 0, 92, 150);
INSERT INTO public.who_global_data VALUES (21637, 0, 495, 0, 0, 92, 61);
INSERT INTO public.who_global_data VALUES (21638, 0, 34, 0, 2, 92, 7);
INSERT INTO public.who_global_data VALUES (21639, 189, 17119, 0, 361, 92, 169);
INSERT INTO public.who_global_data VALUES (21640, 58017, 1567332, 363, 38718, 92, 28);
INSERT INTO public.who_global_data VALUES (21641, 29, 10620, 0, 70, 92, 85);
INSERT INTO public.who_global_data VALUES (21642, 467, 9754, 0, 39, 92, 211);
INSERT INTO public.who_global_data VALUES (21643, 0, 9005, 0, 55, 92, 60);
INSERT INTO public.who_global_data VALUES (21644, 1, 3680, 1, 120, 92, 3);
INSERT INTO public.who_global_data VALUES (21645, 2775, 51993, 22, 423, 92, 11);
INSERT INTO public.who_global_data VALUES (21646, 21506, 619089, 166, 11096, 92, 89);
INSERT INTO public.who_global_data VALUES (21647, 145, 48788, 0, 320, 92, 24);
INSERT INTO public.who_global_data VALUES (21648, 13, 743, 0, 0, 92, 162);
INSERT INTO public.who_global_data VALUES (21649, 2915, 49807, 29, 702, 92, 100);
INSERT INTO public.who_global_data VALUES (21650, 0, 17, 0, 0, 92, 47);
INSERT INTO public.who_global_data VALUES (21651, 1, 30, 0, 0, 92, 29);
INSERT INTO public.who_global_data VALUES (21652, 0, 7903, 0, 133, 92, 40);
INSERT INTO public.who_global_data VALUES (21653, 101, 4931, 4, 87, 92, 222);
INSERT INTO public.who_global_data VALUES (21654, 702, 109849, 14, 3766, 92, 132);
INSERT INTO public.who_global_data VALUES (21655, 1, 273, 0, 13, 92, 130);
INSERT INTO public.who_global_data VALUES (21656, 32, 12363, 0, 73, 92, 234);
INSERT INTO public.who_global_data VALUES (21657, 0, 2413, 0, 41, 92, 23);
INSERT INTO public.who_global_data VALUES (21658, 79, 4324, 2, 130, 92, 192);
INSERT INTO public.who_global_data VALUES (21659, 9, 9109, 0, 232, 92, 69);
INSERT INTO public.who_global_data VALUES (21660, 0, 26, 0, 0, 92, 187);
INSERT INTO public.who_global_data VALUES (21661, 436, 99124, 24, 2730, 92, 230);
INSERT INTO public.who_global_data VALUES (21662, 4709, 99625, 103, 2250, 92, 77);
INSERT INTO public.who_global_data VALUES (21663, 28, 5017, 1, 18, 92, 9);
INSERT INTO public.who_global_data VALUES (21664, 47638, 8411724, 670, 124985, 92, 74);
INSERT INTO public.who_global_data VALUES (21665, 7843, 429574, 183, 14442, 92, 224);
INSERT INTO public.who_global_data VALUES (21666, 8772, 654936, 406, 36985, 92, 199);
INSERT INTO public.who_global_data VALUES (21667, 3701, 489571, 47, 11175, 92, 190);
INSERT INTO public.who_global_data VALUES (21668, 563, 64046, 3, 1933, 92, 12);
INSERT INTO public.who_global_data VALUES (21669, 1, 357, 0, 24, 92, 104);
INSERT INTO public.who_global_data VALUES (21670, 769, 317420, 16, 2642, 92, 153);
INSERT INTO public.who_global_data VALUES (21671, 34502, 824879, 428, 40192, 92, 91);
INSERT INTO public.who_global_data VALUES (21672, 47, 9373, 2, 217, 92, 215);
INSERT INTO public.who_global_data VALUES (21673, 944, 104782, 12, 1806, 92, 84);
INSERT INTO public.who_global_data VALUES (21674, 12, 620, 0, 32, 92, 231);
INSERT INTO public.who_global_data VALUES (21675, 4630, 95864, 40, 1069, 92, 196);
INSERT INTO public.who_global_data VALUES (21676, 774, 154321, 0, 2259, 92, 105);
INSERT INTO public.who_global_data VALUES (21677, 1008, 59595, 21, 1072, 92, 122);
INSERT INTO public.who_global_data VALUES (21678, 0, 0, 0, 0, 92, 159);
INSERT INTO public.who_global_data VALUES (21679, 661, 22163, 6, 710, 92, 75);
INSERT INTO public.who_global_data VALUES (21680, 795, 129638, 5, 799, 92, 27);
INSERT INTO public.who_global_data VALUES (21681, 439, 61748, 3, 1170, 92, 54);
INSERT INTO public.who_global_data VALUES (21682, 0, 24, 0, 0, 92, 226);
INSERT INTO public.who_global_data VALUES (21683, 367, 7119, 3, 88, 92, 79);
INSERT INTO public.who_global_data VALUES (21684, 2089, 89186, 7, 683, 92, 56);
INSERT INTO public.who_global_data VALUES (21685, 2, 1963, 0, 44, 92, 117);
INSERT INTO public.who_global_data VALUES (21686, 0, 1436, 0, 82, 92, 152);
INSERT INTO public.who_global_data VALUES (21687, 853, 65440, 7, 907, 92, 16);
INSERT INTO public.who_global_data VALUES (21688, 39, 781, 0, 3, 92, 10);
INSERT INTO public.who_global_data VALUES (21689, 1649, 20720, 7, 186, 92, 201);
INSERT INTO public.who_global_data VALUES (21690, 803, 21147, 6, 177, 92, 174);
INSERT INTO public.who_global_data VALUES (21691, 0, 17111, 0, 244, 92, 119);
INSERT INTO public.who_global_data VALUES (21692, 6, 5940, 0, 184, 92, 168);
INSERT INTO public.who_global_data VALUES (21693, 1009, 36434, 6, 277, 92, 99);
INSERT INTO public.who_global_data VALUES (21694, 71, 11893, 0, 38, 92, 171);
INSERT INTO public.who_global_data VALUES (21695, 49, 3633, 1, 137, 92, 87);
INSERT INTO public.who_global_data VALUES (21696, 129, 6882, 4, 70, 92, 123);
INSERT INTO public.who_global_data VALUES (21697, 0, 1, 0, 0, 92, 151);
INSERT INTO public.who_global_data VALUES (21698, 0, 4215, 0, 33, 92, 213);
INSERT INTO public.who_global_data VALUES (21699, 0, 7725, 0, 163, 92, 118);
INSERT INTO public.who_global_data VALUES (21700, 0, 452, 0, 10, 92, 134);
INSERT INTO public.who_global_data VALUES (21701, 0, 4550, 0, 45, 92, 65);
INSERT INTO public.who_global_data VALUES (21702, 5225, 943630, 635, 93228, 92, 102);
INSERT INTO public.who_global_data VALUES (21703, 0, 0, 0, 0, 92, 223);
INSERT INTO public.who_global_data VALUES (21704, 18, 433, 0, 2, 92, 4);
INSERT INTO public.who_global_data VALUES (21705, 1, 353, 0, 0, 92, 146);
INSERT INTO public.who_global_data VALUES (21706, 465, 22284, 1, 329, 92, 31);
INSERT INTO public.who_global_data VALUES (21707, 0, 13, 0, 1, 92, 127);
INSERT INTO public.who_global_data VALUES (21708, 5641, 240951, 77, 4059, 92, 22);
INSERT INTO public.who_global_data VALUES (21709, 108, 13391, 2, 97, 92, 115);
INSERT INTO public.who_global_data VALUES (21710, 995, 57935, 22, 1352, 92, 106);
INSERT INTO public.who_global_data VALUES (21711, 45, 13091, 0, 133, 92, 90);
INSERT INTO public.who_global_data VALUES (21712, 0, 0, 0, 0, 92, 70);
INSERT INTO public.who_global_data VALUES (21713, 3051, 185974, 18, 1052, 92, 46);
INSERT INTO public.who_global_data VALUES (21714, 6948, 389497, 87, 7759, 92, 139);
INSERT INTO public.who_global_data VALUES (21715, 1, 29, 0, 0, 92, 42);
INSERT INTO public.who_global_data VALUES (21716, 1, 1618, 0, 25, 92, 80);
INSERT INTO public.who_global_data VALUES (21717, 0, 4480, 0, 157, 92, 203);
INSERT INTO public.who_global_data VALUES (21718, 0, 1222, 0, 69, 92, 136);
INSERT INTO public.who_global_data VALUES (21719, 180, 63508, 0, 1155, 92, 63);
INSERT INTO public.who_global_data VALUES (21720, 0, 0, 0, 0, 92, 17);
INSERT INTO public.who_global_data VALUES (21721, 2, 98, 0, 2, 92, 172);
INSERT INTO public.who_global_data VALUES (21722, 1275, 36372, 13, 1084, 92, 109);
INSERT INTO public.who_global_data VALUES (21723, 621, 22575, 2, 284, 92, 200);
INSERT INTO public.who_global_data VALUES (21724, 582, 68500, 4, 580, 92, 93);
INSERT INTO public.who_global_data VALUES (21725, 320, 117167, 11, 1286, 92, 5);
INSERT INTO public.who_global_data VALUES (21726, 0, 741, 0, 13, 92, 214);
INSERT INTO public.who_global_data VALUES (21727, 1302, 338875, 26, 6893, 92, 204);
INSERT INTO public.who_global_data VALUES (21728, 0, 0, 0, 0, 92, 198);
INSERT INTO public.who_global_data VALUES (21729, 432, 136024, 13, 2744, 92, 173);
INSERT INTO public.who_global_data VALUES (21730, 0, 597, 0, 7, 92, 229);
INSERT INTO public.who_global_data VALUES (21731, 630, 65258, 13, 1454, 92, 76);
INSERT INTO public.who_global_data VALUES (21732, 2885, 911787, 48, 34671, 92, 138);
INSERT INTO public.who_global_data VALUES (21733, 1588, 389725, 42, 7409, 92, 98);
INSERT INTO public.who_global_data VALUES (21734, 0, 0, 0, 0, 92, 103);
INSERT INTO public.who_global_data VALUES (21735, 27143, 466679, 367, 6842, 92, 225);
INSERT INTO public.who_global_data VALUES (21736, 4410, 161350, 46, 2740, 92, 131);
INSERT INTO public.who_global_data VALUES (21737, 396, 69416, 5, 855, 92, 235);
INSERT INTO public.who_global_data VALUES (21738, 249, 133619, 0, 232, 92, 137);
INSERT INTO public.who_global_data VALUES (21739, 145, 27194, 1, 476, 92, 81);
INSERT INTO public.who_global_data VALUES (21740, 1059, 79566, 15, 1866, 92, 182);
INSERT INTO public.who_global_data VALUES (21741, 0, 6037, 0, 26, 92, 145);
INSERT INTO public.who_global_data VALUES (21742, 9714, 276802, 121, 7540, 92, 26);
INSERT INTO public.who_global_data VALUES (21743, 20582, 1733440, 378, 29887, 92, 170);
INSERT INTO public.who_global_data VALUES (21744, 18, 5192, 1, 36, 92, 191);
INSERT INTO public.who_global_data VALUES (21745, 0, 5, 0, 0, 92, 221);
INSERT INTO public.who_global_data VALUES (21746, 0, 90, 0, 0, 92, 64);
INSERT INTO public.who_global_data VALUES (21747, 0, 0, 0, 0, 92, 116);
INSERT INTO public.who_global_data VALUES (21748, 0, 19, 0, 0, 92, 128);
INSERT INTO public.who_global_data VALUES (21749, 1, 106, 0, 0, 92, 6);
INSERT INTO public.who_global_data VALUES (21750, 0, 604, 0, 12, 92, 227);
INSERT INTO public.who_global_data VALUES (21751, 1, 13, 0, 0, 92, 68);
INSERT INTO public.who_global_data VALUES (21752, 0, 75, 0, 0, 92, 184);
INSERT INTO public.who_global_data VALUES (21753, 0, 0, 0, 0, 92, 82);
INSERT INTO public.who_global_data VALUES (21754, 41, 1043, 0, 42, 92, 149);
INSERT INTO public.who_global_data VALUES (21755, 0, 958, 0, 16, 92, 197);
INSERT INTO public.who_global_data VALUES (21756, 450, 349386, 18, 5489, 92, 78);
INSERT INTO public.who_global_data VALUES (21757, 18, 15668, 0, 326, 92, 233);
INSERT INTO public.who_global_data VALUES (21758, 2181, 55676, 11, 861, 92, 133);
INSERT INTO public.who_global_data VALUES (21759, 0, 154, 0, 0, 92, 35);
INSERT INTO public.who_global_data VALUES (21760, 4, 2373, 0, 74, 92, 114);
INSERT INTO public.who_global_data VALUES (21761, 7, 58043, 0, 28, 92, 237);
INSERT INTO public.who_global_data VALUES (21762, 0, 14, 0, 0, 92, 55);
INSERT INTO public.who_global_data VALUES (21763, 11, 870, 0, 22, 92, 176);
INSERT INTO public.who_global_data VALUES (21764, 1962, 68734, 25, 286, 92, 202);
INSERT INTO public.who_global_data VALUES (21765, 1567, 42686, 28, 562, 92, 155);
INSERT INTO public.who_global_data VALUES (21766, 0, 13, 0, 0, 92, 32);
INSERT INTO public.who_global_data VALUES (21767, 0, 4229, 0, 107, 92, 220);
INSERT INTO public.who_global_data VALUES (21768, 1866, 732414, 92, 19677, 92, 30);
INSERT INTO public.who_global_data VALUES (21769, 0, 2943, 0, 59, 92, 147);
INSERT INTO public.who_global_data VALUES (21770, 24680, 1384989, 318, 40221, 92, 208);
INSERT INTO public.who_global_data VALUES (21771, 383, 12570, 5, 29, 92, 45);
INSERT INTO public.who_global_data VALUES (21772, 37, 14033, 0, 1115, 92, 110);
INSERT INTO public.who_global_data VALUES (21773, 2, 5220, 1, 112, 92, 88);
INSERT INTO public.who_global_data VALUES (21774, 4482, 142988, 21, 6117, 92, 51);
INSERT INTO public.who_global_data VALUES (21775, 7828, 216514, 77, 2639, 92, 209);
INSERT INTO public.who_global_data VALUES (21776, 76, 6040, 4, 305, 92, 205);
INSERT INTO public.who_global_data VALUES (21777, 39, 11219, 0, 83, 92, 18);
INSERT INTO public.who_global_data VALUES (21778, 8, 3818, 1, 60, 92, 72);
INSERT INTO public.who_global_data VALUES (21779, 24138, 1123201, 378, 48120, 92, 44);
INSERT INTO public.who_global_data VALUES (21780, 0, 30, 0, 0, 92, 15);
INSERT INTO public.who_global_data VALUES (21781, 61, 2442, 0, 57, 92, 25);
INSERT INTO public.who_global_data VALUES (21782, 0, 0, 0, 0, 92, 179);
INSERT INTO public.who_global_data VALUES (21783, 0, 0, 0, 0, 92, 34);
INSERT INTO public.who_global_data VALUES (21784, 10, 5764, 0, 110, 92, 207);
INSERT INTO public.who_global_data VALUES (21785, 0, 66334, 144, 1721, 92, 166);
INSERT INTO public.who_global_data VALUES (21786, 9041, 1066550, 81, 10639, 92, 126);
INSERT INTO public.who_global_data VALUES (21787, 0, 0, 0, 0, 92, 97);
INSERT INTO public.who_global_data VALUES (21788, 1, 705, 0, 6, 92, 36);
INSERT INTO public.who_global_data VALUES (21789, 0, 0, 0, 0, 92, 125);
INSERT INTO public.who_global_data VALUES (21790, 217, 13568, 0, 117, 92, 124);
INSERT INTO public.who_global_data VALUES (21791, 9721, 440188, 202, 8126, 92, 185);
INSERT INTO public.who_global_data VALUES (21792, 1289, 138599, 3, 508, 92, 194);
INSERT INTO public.who_global_data VALUES (21793, 0, 509, 0, 21, 92, 144);
INSERT INTO public.who_global_data VALUES (21794, 106050, 9387978, 1132, 232166, 92, 19);
INSERT INTO public.who_global_data VALUES (21795, 0, 1388, 0, 23, 92, 217);
INSERT INTO public.who_global_data VALUES (21796, 49, 3245, 0, 61, 92, 148);
INSERT INTO public.who_global_data VALUES (21797, 207, 68139, 0, 579, 92, 86);
INSERT INTO public.who_global_data VALUES (21798, 0, 0, 0, 0, 92, 13);
INSERT INTO public.who_global_data VALUES (21799, 380, 93480, 4, 814, 92, 157);
INSERT INTO public.who_global_data VALUES (21800, 3, 1210, 0, 35, 92, 8);
INSERT INTO public.who_global_data VALUES (21801, 0, 1, 0, 0, 92, 73);
INSERT INTO public.who_global_data VALUES (21802, 1, 2070, 0, 602, 92, 101);
INSERT INTO public.who_global_data VALUES (21803, 72, 16770, 0, 349, 92, 165);
INSERT INTO public.who_global_data VALUES (21804, 16, 8443, 0, 248, 92, 14);
INSERT INTO public.who_global_data VALUES (21805, 86, 41814, 4, 1548, 93, 193);
INSERT INTO public.who_global_data VALUES (21806, 396, 22300, 4, 536, 93, 113);
INSERT INTO public.who_global_data VALUES (21807, 0, 57942, 0, 1964, 93, 143);
INSERT INTO public.who_global_data VALUES (21808, 0, 0, 0, 0, 93, 219);
INSERT INTO public.who_global_data VALUES (21809, 135, 5045, 0, 75, 93, 186);
INSERT INTO public.who_global_data VALUES (21810, 236, 11813, 5, 296, 93, 52);
INSERT INTO public.who_global_data VALUES (21811, 0, 3, 0, 0, 93, 180);
INSERT INTO public.who_global_data VALUES (21812, 2, 130, 0, 3, 93, 167);
INSERT INTO public.who_global_data VALUES (21813, 13281, 1196412, 429, 32052, 93, 154);
INSERT INTO public.who_global_data VALUES (21814, 2413, 98876, 28, 1471, 93, 94);
INSERT INTO public.who_global_data VALUES (21815, 14, 4538, 0, 38, 93, 66);
INSERT INTO public.who_global_data VALUES (21816, 12, 27622, 0, 907, 93, 58);
INSERT INTO public.who_global_data VALUES (21817, 6514, 125229, 35, 1204, 93, 163);
INSERT INTO public.who_global_data VALUES (21818, 1227, 59509, 12, 780, 93, 37);
INSERT INTO public.who_global_data VALUES (21819, 53, 6843, 1, 150, 93, 142);
INSERT INTO public.who_global_data VALUES (21820, 261, 82624, 3, 327, 93, 83);
INSERT INTO public.who_global_data VALUES (21821, 1517, 414164, 21, 6004, 93, 228);
INSERT INTO public.who_global_data VALUES (21822, 0, 238, 0, 7, 93, 188);
INSERT INTO public.who_global_data VALUES (21823, 984, 102313, 3, 995, 93, 62);
INSERT INTO public.who_global_data VALUES (21824, 9230, 486665, 196, 12579, 93, 160);
INSERT INTO public.who_global_data VALUES (21825, 166, 3790, 2, 61, 93, 50);
INSERT INTO public.who_global_data VALUES (21826, 0, 2745, 0, 43, 93, 33);
INSERT INTO public.who_global_data VALUES (21827, 0, 206, 0, 9, 93, 183);
INSERT INTO public.who_global_data VALUES (21828, 0, 358, 0, 0, 93, 92);
INSERT INTO public.who_global_data VALUES (21829, 69, 141936, 10, 8751, 93, 158);
INSERT INTO public.who_global_data VALUES (21830, 0, 134, 0, 3, 93, 67);
INSERT INTO public.who_global_data VALUES (21831, 1753, 55602, 41, 1359, 93, 57);
INSERT INTO public.who_global_data VALUES (21832, 0, 6642, 0, 24, 93, 38);
INSERT INTO public.who_global_data VALUES (21833, 11843, 5566049, 243, 160496, 93, 141);
INSERT INTO public.who_global_data VALUES (21834, 0, 72, 0, 1, 93, 178);
INSERT INTO public.who_global_data VALUES (21835, 0, 148, 0, 3, 93, 108);
INSERT INTO public.who_global_data VALUES (21836, 4054, 64591, 54, 1466, 93, 39);
INSERT INTO public.who_global_data VALUES (21837, 9, 2539, 0, 67, 93, 2);
INSERT INTO public.who_global_data VALUES (21838, -6, 600, 0, 1, 93, 195);
INSERT INTO public.who_global_data VALUES (21839, 109, 9053, 0, 95, 93, 107);
INSERT INTO public.who_global_data VALUES (21840, 0, 292, 0, 0, 93, 161);
INSERT INTO public.who_global_data VALUES (21841, 0, 22103, 0, 429, 93, 212);
INSERT INTO public.who_global_data VALUES (21842, 4672, 244935, 71, 10279, 93, 181);
INSERT INTO public.who_global_data VALUES (21843, 0, 242, 0, 1, 93, 53);
INSERT INTO public.who_global_data VALUES (21844, 0, 4866, 0, 62, 93, 164);
INSERT INTO public.who_global_data VALUES (21845, 4, 1517, 1, 99, 93, 140);
INSERT INTO public.who_global_data VALUES (21846, 840, 515042, 21, 14340, 93, 20);
INSERT INTO public.who_global_data VALUES (21847, 32, 92077, 1, 4747, 93, 112);
INSERT INTO public.who_global_data VALUES (21848, 6136, 1099392, 177, 31847, 93, 111);
INSERT INTO public.who_global_data VALUES (21849, 9, 554, 0, 7, 93, 71);
INSERT INTO public.who_global_data VALUES (21850, 0, 5348, 0, 92, 93, 218);
INSERT INTO public.who_global_data VALUES (21851, 0, 0, 0, 0, 93, 43);
INSERT INTO public.who_global_data VALUES (21852, 863, 112120, 15, 1419, 93, 49);
INSERT INTO public.who_global_data VALUES (21853, 13, 20778, 0, 126, 93, 1);
INSERT INTO public.who_global_data VALUES (21854, 2480, 56567, 26, 654, 93, 48);
INSERT INTO public.who_global_data VALUES (21855, 109, 7144, 0, 129, 93, 232);
INSERT INTO public.who_global_data VALUES (21856, 5, 1000, 0, 1, 93, 175);
INSERT INTO public.who_global_data VALUES (21857, 166, 5100, 0, 26, 93, 21);
INSERT INTO public.who_global_data VALUES (21858, 15731, 378716, 220, 4133, 93, 156);
INSERT INTO public.who_global_data VALUES (21859, 0, 0, 0, 0, 93, 95);
INSERT INTO public.who_global_data VALUES (21860, 23, 11449, 0, 315, 93, 177);
INSERT INTO public.who_global_data VALUES (21861, 936, 50530, 1, 729, 93, 210);
INSERT INTO public.who_global_data VALUES (21862, 5, 5580, 0, 61, 93, 120);
INSERT INTO public.who_global_data VALUES (21863, 0, 50, 0, 0, 93, 135);
INSERT INTO public.who_global_data VALUES (21864, 430, 128278, 5, 2257, 93, 206);
INSERT INTO public.who_global_data VALUES (21865, 1323, 171433, 6, 12704, 93, 189);
INSERT INTO public.who_global_data VALUES (21866, 207, 108329, 13, 6318, 93, 129);
INSERT INTO public.who_global_data VALUES (21867, 0, 34015, 5, 992, 93, 121);
INSERT INTO public.who_global_data VALUES (21868, 0, 5089, 0, 83, 93, 59);
INSERT INTO public.who_global_data VALUES (21869, 0, 480, 0, 0, 93, 96);
INSERT INTO public.who_global_data VALUES (21870, 208, 5333, 0, 73, 93, 41);
INSERT INTO public.who_global_data VALUES (21871, 13, 5955, 0, 117, 93, 216);
INSERT INTO public.who_global_data VALUES (21872, 379, 97881, 9, 1503, 93, 236);
INSERT INTO public.who_global_data VALUES (21873, 0, 13, 0, 0, 93, 150);
INSERT INTO public.who_global_data VALUES (21874, 0, 495, 0, 0, 93, 61);
INSERT INTO public.who_global_data VALUES (21875, 0, 34, 0, 2, 93, 7);
INSERT INTO public.who_global_data VALUES (21876, 293, 16930, 2, 361, 93, 169);
INSERT INTO public.who_global_data VALUES (21877, 39807, 1509315, 386, 38355, 93, 28);
INSERT INTO public.who_global_data VALUES (21878, 14, 10591, 0, 70, 93, 85);
INSERT INTO public.who_global_data VALUES (21879, 338, 9287, 1, 39, 93, 211);
INSERT INTO public.who_global_data VALUES (21880, 21, 9005, 0, 55, 93, 60);
INSERT INTO public.who_global_data VALUES (21881, 0, 3679, 0, 119, 93, 3);
INSERT INTO public.who_global_data VALUES (21882, 2401, 49218, 20, 401, 93, 11);
INSERT INTO public.who_global_data VALUES (21883, 19990, 597583, 118, 10930, 93, 89);
INSERT INTO public.who_global_data VALUES (21884, 443, 48643, 0, 320, 93, 24);
INSERT INTO public.who_global_data VALUES (21885, 23, 730, 0, 0, 93, 162);
INSERT INTO public.who_global_data VALUES (21886, 2646, 46892, 18, 673, 93, 100);
INSERT INTO public.who_global_data VALUES (21887, 0, 17, 0, 0, 93, 47);
INSERT INTO public.who_global_data VALUES (21888, 0, 29, 0, 0, 93, 29);
INSERT INTO public.who_global_data VALUES (21889, 161, 7903, 7, 133, 93, 40);
INSERT INTO public.who_global_data VALUES (21890, 82, 4830, 3, 83, 93, 222);
INSERT INTO public.who_global_data VALUES (21891, 664, 109147, 4, 3752, 93, 132);
INSERT INTO public.who_global_data VALUES (21892, 1, 272, 0, 13, 93, 130);
INSERT INTO public.who_global_data VALUES (21893, 118, 12331, 0, 73, 93, 234);
INSERT INTO public.who_global_data VALUES (21894, 0, 2413, 0, 41, 93, 23);
INSERT INTO public.who_global_data VALUES (21895, 7, 4245, 0, 128, 93, 192);
INSERT INTO public.who_global_data VALUES (21896, 46, 9100, 0, 232, 93, 69);
INSERT INTO public.who_global_data VALUES (21897, 0, 26, 0, 0, 93, 187);
INSERT INTO public.who_global_data VALUES (21898, 283, 98688, 18, 2706, 93, 230);
INSERT INTO public.who_global_data VALUES (21899, 3928, 94916, 84, 2147, 93, 77);
INSERT INTO public.who_global_data VALUES (21900, 32, 4989, 0, 17, 93, 9);
INSERT INTO public.who_global_data VALUES (21901, 50210, 8364086, 704, 124315, 93, 74);
INSERT INTO public.who_global_data VALUES (21902, 3356, 421731, 113, 14259, 93, 224);
INSERT INTO public.who_global_data VALUES (21903, 8452, 646164, 419, 36579, 93, 199);
INSERT INTO public.who_global_data VALUES (21904, 3574, 485870, 60, 11128, 93, 190);
INSERT INTO public.who_global_data VALUES (21905, 435, 63483, 8, 1930, 93, 12);
INSERT INTO public.who_global_data VALUES (21906, 1, 356, 0, 24, 93, 104);
INSERT INTO public.who_global_data VALUES (21907, 845, 316651, 26, 2626, 93, 153);
INSERT INTO public.who_global_data VALUES (21908, 30548, 790377, 352, 39764, 93, 91);
INSERT INTO public.who_global_data VALUES (21909, 30, 9326, 1, 215, 93, 215);
INSERT INTO public.who_global_data VALUES (21910, 938, 103838, 8, 1794, 93, 84);
INSERT INTO public.who_global_data VALUES (21911, 17, 608, 0, 32, 93, 231);
INSERT INTO public.who_global_data VALUES (21912, 4658, 91234, 62, 1029, 93, 196);
INSERT INTO public.who_global_data VALUES (21913, 822, 153547, 0, 2259, 93, 105);
INSERT INTO public.who_global_data VALUES (21914, 1494, 58587, 12, 1051, 93, 122);
INSERT INTO public.who_global_data VALUES (21915, 0, 0, 0, 0, 93, 159);
INSERT INTO public.who_global_data VALUES (21916, 546, 21502, 9, 704, 93, 75);
INSERT INTO public.who_global_data VALUES (21917, 763, 128843, 5, 794, 93, 27);
INSERT INTO public.who_global_data VALUES (21918, 535, 61309, 4, 1167, 93, 54);
INSERT INTO public.who_global_data VALUES (21919, 0, 24, 0, 0, 93, 226);
INSERT INTO public.who_global_data VALUES (21920, 313, 6752, 6, 85, 93, 79);
INSERT INTO public.who_global_data VALUES (21921, 1888, 87097, 9, 676, 93, 56);
INSERT INTO public.who_global_data VALUES (21922, 0, 1961, 0, 44, 93, 117);
INSERT INTO public.who_global_data VALUES (21923, 0, 1436, 0, 82, 93, 152);
INSERT INTO public.who_global_data VALUES (21924, 899, 64587, 7, 900, 93, 16);
INSERT INTO public.who_global_data VALUES (21925, 39, 742, 0, 3, 93, 10);
INSERT INTO public.who_global_data VALUES (21926, 993, 19071, 2, 179, 93, 201);
INSERT INTO public.who_global_data VALUES (21927, 710, 20344, 4, 171, 93, 174);
INSERT INTO public.who_global_data VALUES (21928, 0, 17111, 0, 244, 93, 119);
INSERT INTO public.who_global_data VALUES (21929, 0, 5934, 0, 184, 93, 168);
INSERT INTO public.who_global_data VALUES (21930, 1032, 35425, 8, 271, 93, 99);
INSERT INTO public.who_global_data VALUES (21931, 26, 11822, 0, 38, 93, 171);
INSERT INTO public.who_global_data VALUES (21932, 0, 3584, 0, 136, 93, 87);
INSERT INTO public.who_global_data VALUES (21933, 173, 6753, 4, 66, 93, 123);
INSERT INTO public.who_global_data VALUES (21934, 0, 1, 0, 0, 93, 151);
INSERT INTO public.who_global_data VALUES (21935, 397, 4215, 2, 33, 93, 213);
INSERT INTO public.who_global_data VALUES (21936, 0, 7725, 0, 163, 93, 118);
INSERT INTO public.who_global_data VALUES (21937, 0, 452, 0, 10, 93, 134);
INSERT INTO public.who_global_data VALUES (21938, 26, 4550, 0, 45, 93, 65);
INSERT INTO public.who_global_data VALUES (21939, 5250, 938405, 493, 92593, 93, 102);
INSERT INTO public.who_global_data VALUES (21940, 0, 0, 0, 0, 93, 223);
INSERT INTO public.who_global_data VALUES (21941, 15, 415, 0, 2, 93, 4);
INSERT INTO public.who_global_data VALUES (21942, 2, 352, 0, 0, 93, 146);
INSERT INTO public.who_global_data VALUES (21943, 504, 21819, 3, 328, 93, 31);
INSERT INTO public.who_global_data VALUES (21944, 0, 13, 0, 1, 93, 127);
INSERT INTO public.who_global_data VALUES (21945, 5745, 235310, 82, 3982, 93, 22);
INSERT INTO public.who_global_data VALUES (21946, 81, 13283, 0, 95, 93, 115);
INSERT INTO public.who_global_data VALUES (21947, 1136, 56940, 23, 1330, 93, 106);
INSERT INTO public.who_global_data VALUES (21948, 16, 13046, 0, 133, 93, 90);
INSERT INTO public.who_global_data VALUES (21949, 0, 0, 0, 0, 93, 70);
INSERT INTO public.who_global_data VALUES (21950, 3309, 182923, 30, 1034, 93, 46);
INSERT INTO public.who_global_data VALUES (21951, 7601, 382549, 102, 7672, 93, 139);
INSERT INTO public.who_global_data VALUES (21952, 0, 28, 0, 0, 93, 42);
INSERT INTO public.who_global_data VALUES (21953, 2, 1617, 0, 25, 93, 80);
INSERT INTO public.who_global_data VALUES (21954, 0, 4480, 0, 157, 93, 203);
INSERT INTO public.who_global_data VALUES (21955, 0, 1222, 0, 69, 93, 136);
INSERT INTO public.who_global_data VALUES (21956, 155, 63328, 4, 1155, 93, 63);
INSERT INTO public.who_global_data VALUES (21957, 0, 0, 0, 0, 93, 17);
INSERT INTO public.who_global_data VALUES (21958, 0, 96, 0, 2, 93, 172);
INSERT INTO public.who_global_data VALUES (21959, 1189, 35097, 22, 1071, 93, 109);
INSERT INTO public.who_global_data VALUES (21960, 620, 21954, 0, 282, 93, 200);
INSERT INTO public.who_global_data VALUES (21961, 734, 67918, 3, 576, 93, 93);
INSERT INTO public.who_global_data VALUES (21962, 319, 116847, 11, 1275, 93, 5);
INSERT INTO public.who_global_data VALUES (21963, 0, 741, 0, 13, 93, 214);
INSERT INTO public.who_global_data VALUES (21964, 1313, 337573, 18, 6867, 93, 204);
INSERT INTO public.who_global_data VALUES (21965, 0, 0, 0, 0, 93, 198);
INSERT INTO public.who_global_data VALUES (21966, 677, 135592, 11, 2731, 93, 173);
INSERT INTO public.who_global_data VALUES (21967, 0, 597, 0, 7, 93, 229);
INSERT INTO public.who_global_data VALUES (21968, 472, 64628, 12, 1441, 93, 76);
INSERT INTO public.who_global_data VALUES (21969, 2357, 908902, 38, 34623, 93, 138);
INSERT INTO public.who_global_data VALUES (21970, 976, 388137, 49, 7367, 93, 98);
INSERT INTO public.who_global_data VALUES (21971, 0, 0, 0, 0, 93, 103);
INSERT INTO public.who_global_data VALUES (21972, 24692, 439536, 373, 6475, 93, 225);
INSERT INTO public.who_global_data VALUES (21973, 7497, 156940, 59, 2694, 93, 131);
INSERT INTO public.who_global_data VALUES (21974, 77, 69020, 8, 850, 93, 235);
INSERT INTO public.who_global_data VALUES (21975, 227, 133370, 0, 232, 93, 137);
INSERT INTO public.who_global_data VALUES (21976, 125, 27049, 1, 475, 93, 81);
INSERT INTO public.who_global_data VALUES (21977, 1020, 78507, 13, 1851, 93, 182);
INSERT INTO public.who_global_data VALUES (21978, 139, 6037, 0, 26, 93, 145);
INSERT INTO public.who_global_data VALUES (21979, 8651, 267088, 146, 7419, 93, 26);
INSERT INTO public.who_global_data VALUES (21980, 19404, 1712858, 292, 29509, 93, 170);
INSERT INTO public.who_global_data VALUES (21981, 12, 5174, 0, 35, 93, 191);
INSERT INTO public.who_global_data VALUES (21982, 0, 5, 0, 0, 93, 221);
INSERT INTO public.who_global_data VALUES (21983, 1, 90, 0, 0, 93, 64);
INSERT INTO public.who_global_data VALUES (21984, 0, 0, 0, 0, 93, 116);
INSERT INTO public.who_global_data VALUES (21985, 0, 19, 0, 0, 93, 128);
INSERT INTO public.who_global_data VALUES (21986, 8, 105, 0, 0, 93, 6);
INSERT INTO public.who_global_data VALUES (21987, 13, 604, 3, 12, 93, 227);
INSERT INTO public.who_global_data VALUES (21988, 0, 12, 0, 0, 93, 68);
INSERT INTO public.who_global_data VALUES (21989, 0, 75, 0, 0, 93, 184);
INSERT INTO public.who_global_data VALUES (21990, 0, 0, 0, 0, 93, 82);
INSERT INTO public.who_global_data VALUES (21991, 8, 1002, 0, 42, 93, 149);
INSERT INTO public.who_global_data VALUES (21992, 4, 958, 0, 16, 93, 197);
INSERT INTO public.who_global_data VALUES (21993, 426, 348936, 15, 5471, 93, 78);
INSERT INTO public.who_global_data VALUES (21994, 10, 15650, 0, 326, 93, 233);
INSERT INTO public.who_global_data VALUES (21995, 2412, 53495, 6, 850, 93, 133);
INSERT INTO public.who_global_data VALUES (21996, 0, 154, 0, 0, 93, 35);
INSERT INTO public.who_global_data VALUES (21997, 1, 2369, 0, 74, 93, 114);
INSERT INTO public.who_global_data VALUES (21998, 7, 58036, 0, 28, 93, 237);
INSERT INTO public.who_global_data VALUES (21999, 0, 14, 0, 0, 93, 55);
INSERT INTO public.who_global_data VALUES (22000, 15, 859, 0, 22, 93, 176);
INSERT INTO public.who_global_data VALUES (22001, 3216, 66772, 26, 261, 93, 202);
INSERT INTO public.who_global_data VALUES (22002, 1691, 41119, 31, 534, 93, 155);
INSERT INTO public.who_global_data VALUES (22003, 0, 13, 0, 0, 93, 32);
INSERT INTO public.who_global_data VALUES (22004, 0, 4229, 0, 107, 93, 220);
INSERT INTO public.who_global_data VALUES (22005, 1712, 730548, 46, 19585, 93, 30);
INSERT INTO public.who_global_data VALUES (22006, 0, 2943, 0, 59, 93, 147);
INSERT INTO public.who_global_data VALUES (22007, 22487, 1360309, 297, 39903, 93, 208);
INSERT INTO public.who_global_data VALUES (22008, 443, 12187, 1, 24, 93, 45);
INSERT INTO public.who_global_data VALUES (22009, 91, 13996, 278, 1115, 93, 110);
INSERT INTO public.who_global_data VALUES (22010, 6, 5218, 0, 111, 93, 88);
INSERT INTO public.who_global_data VALUES (22011, 3608, 138506, 20, 6096, 93, 51);
INSERT INTO public.who_global_data VALUES (22012, 8708, 208686, 81, 2562, 93, 209);
INSERT INTO public.who_global_data VALUES (22013, 76, 5964, 3, 301, 93, 205);
INSERT INTO public.who_global_data VALUES (22014, 41, 11180, 0, 83, 93, 18);
INSERT INTO public.who_global_data VALUES (22015, 6, 3810, 0, 59, 93, 72);
INSERT INTO public.who_global_data VALUES (22016, 25177, 1099063, 492, 47742, 93, 44);
INSERT INTO public.who_global_data VALUES (22017, 0, 30, 0, 0, 93, 15);
INSERT INTO public.who_global_data VALUES (22018, 0, 2381, 0, 57, 93, 25);
INSERT INTO public.who_global_data VALUES (22019, 0, 0, 0, 0, 93, 179);
INSERT INTO public.who_global_data VALUES (22020, 0, 0, 0, 0, 93, 34);
INSERT INTO public.who_global_data VALUES (22021, 50, 5754, 1, 110, 93, 207);
INSERT INTO public.who_global_data VALUES (22022, 1971, 66334, 65, 1577, 93, 166);
INSERT INTO public.who_global_data VALUES (22023, 9121, 1057509, 77, 10558, 93, 126);
INSERT INTO public.who_global_data VALUES (22024, 0, 0, 0, 0, 93, 97);
INSERT INTO public.who_global_data VALUES (22025, 0, 704, 0, 6, 93, 36);
INSERT INTO public.who_global_data VALUES (22026, 0, 0, 0, 0, 93, 125);
INSERT INTO public.who_global_data VALUES (22027, 252, 13351, 2, 117, 93, 124);
INSERT INTO public.who_global_data VALUES (22028, 9850, 430467, 193, 7924, 93, 185);
INSERT INTO public.who_global_data VALUES (22029, 1161, 137310, 2, 505, 93, 194);
INSERT INTO public.who_global_data VALUES (22030, 0, 509, 0, 21, 93, 144);
INSERT INTO public.who_global_data VALUES (22031, 88163, 9281928, 1086, 231034, 93, 19);
INSERT INTO public.who_global_data VALUES (22032, 3, 1388, 1, 23, 93, 217);
INSERT INTO public.who_global_data VALUES (22033, 31, 3196, 1, 61, 93, 148);
INSERT INTO public.who_global_data VALUES (22034, 234, 67932, 4, 579, 93, 86);
INSERT INTO public.who_global_data VALUES (22035, 0, 0, 0, 0, 93, 13);
INSERT INTO public.who_global_data VALUES (22036, 395, 93100, 5, 810, 93, 157);
INSERT INTO public.who_global_data VALUES (22037, 4, 1207, 0, 35, 93, 8);
INSERT INTO public.who_global_data VALUES (22038, 0, 1, 0, 0, 93, 73);
INSERT INTO public.who_global_data VALUES (22039, 0, 2069, 0, 602, 93, 101);
INSERT INTO public.who_global_data VALUES (22040, 37, 16698, 0, 349, 93, 165);
INSERT INTO public.who_global_data VALUES (22041, 17, 8427, 2, 248, 93, 14);
INSERT INTO public.who_global_data VALUES (22042, 95, 41728, 3, 1544, 94, 193);
INSERT INTO public.who_global_data VALUES (22043, 381, 21904, 5, 532, 94, 113);
INSERT INTO public.who_global_data VALUES (22044, 0, 57942, 0, 1964, 94, 143);
INSERT INTO public.who_global_data VALUES (22045, 0, 0, 0, 0, 94, 219);
INSERT INTO public.who_global_data VALUES (22046, 22, 4910, 0, 75, 94, 186);
INSERT INTO public.who_global_data VALUES (22047, 349, 11577, 2, 291, 94, 52);
INSERT INTO public.who_global_data VALUES (22048, 0, 3, 0, 0, 94, 180);
INSERT INTO public.who_global_data VALUES (22049, 0, 128, 0, 3, 94, 167);
INSERT INTO public.who_global_data VALUES (22050, 9598, 1183131, 483, 31623, 94, 154);
INSERT INTO public.who_global_data VALUES (22051, 2374, 96463, 35, 1443, 94, 94);
INSERT INTO public.who_global_data VALUES (22052, 5, 4524, 0, 38, 94, 66);
INSERT INTO public.who_global_data VALUES (22053, 8, 27610, 0, 907, 94, 58);
INSERT INTO public.who_global_data VALUES (22054, 4445, 118715, 34, 1169, 94, 163);
INSERT INTO public.who_global_data VALUES (22055, 1242, 58282, 15, 768, 94, 37);
INSERT INTO public.who_global_data VALUES (22056, 31, 6790, 1, 149, 94, 142);
INSERT INTO public.who_global_data VALUES (22057, 230, 82363, 2, 324, 94, 83);
INSERT INTO public.who_global_data VALUES (22058, 1659, 412647, 17, 5983, 94, 228);
INSERT INTO public.who_global_data VALUES (22059, 1, 238, 0, 7, 94, 188);
INSERT INTO public.who_global_data VALUES (22060, 929, 101329, 3, 992, 94, 62);
INSERT INTO public.who_global_data VALUES (22061, 12103, 477435, 173, 12383, 94, 160);
INSERT INTO public.who_global_data VALUES (22062, 47, 3624, 0, 59, 94, 50);
INSERT INTO public.who_global_data VALUES (22063, 62, 2745, 2, 43, 94, 33);
INSERT INTO public.who_global_data VALUES (22064, 0, 206, 0, 9, 94, 183);
INSERT INTO public.who_global_data VALUES (22065, 2, 358, 0, 0, 94, 92);
INSERT INTO public.who_global_data VALUES (22066, 34, 141867, 10, 8741, 94, 158);
INSERT INTO public.who_global_data VALUES (22067, 0, 134, 0, 3, 94, 67);
INSERT INTO public.who_global_data VALUES (22068, 1580, 53849, 38, 1318, 94, 57);
INSERT INTO public.who_global_data VALUES (22069, 0, 6642, 0, 24, 94, 38);
INSERT INTO public.who_global_data VALUES (22070, 8501, 5554206, 179, 160253, 94, 141);
INSERT INTO public.who_global_data VALUES (22071, 0, 72, 0, 1, 94, 178);
INSERT INTO public.who_global_data VALUES (22072, 0, 148, 0, 3, 94, 108);
INSERT INTO public.who_global_data VALUES (22073, 4041, 60537, 63, 1412, 94, 39);
INSERT INTO public.who_global_data VALUES (22074, 13, 2530, 0, 67, 94, 2);
INSERT INTO public.who_global_data VALUES (22075, 9, 606, 0, 1, 94, 195);
INSERT INTO public.who_global_data VALUES (22076, 62, 8944, 0, 95, 94, 107);
INSERT INTO public.who_global_data VALUES (22077, 0, 292, 0, 0, 94, 161);
INSERT INTO public.who_global_data VALUES (22078, 0, 22103, 0, 429, 94, 212);
INSERT INTO public.who_global_data VALUES (22079, 3422, 240263, 29, 10208, 94, 181);
INSERT INTO public.who_global_data VALUES (22080, 2, 242, 0, 1, 94, 53);
INSERT INTO public.who_global_data VALUES (22081, 0, 4866, 0, 62, 94, 164);
INSERT INTO public.who_global_data VALUES (22082, 14, 1513, 0, 98, 94, 140);
INSERT INTO public.who_global_data VALUES (22083, 1014, 514202, 17, 14319, 94, 20);
INSERT INTO public.who_global_data VALUES (22084, 30, 92045, 0, 4746, 94, 112);
INSERT INTO public.who_global_data VALUES (22085, 9935, 1093256, 155, 31670, 94, 111);
INSERT INTO public.who_global_data VALUES (22086, 0, 545, 0, 7, 94, 71);
INSERT INTO public.who_global_data VALUES (22087, 0, 5348, 0, 92, 94, 218);
INSERT INTO public.who_global_data VALUES (22088, 0, 0, 0, 0, 94, 43);
INSERT INTO public.who_global_data VALUES (22089, 540, 111257, 8, 1404, 94, 49);
INSERT INTO public.who_global_data VALUES (22090, 12, 20765, 0, 126, 94, 1);
INSERT INTO public.who_global_data VALUES (22091, 1427, 54087, 34, 628, 94, 48);
INSERT INTO public.who_global_data VALUES (22092, 65, 7035, 0, 129, 94, 232);
INSERT INTO public.who_global_data VALUES (22093, 8, 995, 0, 1, 94, 175);
INSERT INTO public.who_global_data VALUES (22094, 174, 4934, 0, 26, 94, 21);
INSERT INTO public.who_global_data VALUES (22095, 12089, 362985, 259, 3913, 94, 156);
INSERT INTO public.who_global_data VALUES (22096, 0, 0, 0, 0, 94, 95);
INSERT INTO public.who_global_data VALUES (22097, 32, 11426, 7, 315, 94, 177);
INSERT INTO public.who_global_data VALUES (22098, 1353, 49594, 4, 728, 94, 210);
INSERT INTO public.who_global_data VALUES (22099, 2, 5575, 0, 61, 94, 120);
INSERT INTO public.who_global_data VALUES (22100, 0, 50, 0, 0, 94, 135);
INSERT INTO public.who_global_data VALUES (22101, 257, 127848, 2, 2252, 94, 206);
INSERT INTO public.who_global_data VALUES (22102, 548, 170110, 6, 12698, 94, 189);
INSERT INTO public.who_global_data VALUES (22103, 197, 108122, 14, 6305, 94, 129);
INSERT INTO public.who_global_data VALUES (22104, 0, 34015, 4, 987, 94, 121);
INSERT INTO public.who_global_data VALUES (22105, 0, 5089, 0, 83, 94, 59);
INSERT INTO public.who_global_data VALUES (22106, 0, 480, 0, 0, 94, 96);
INSERT INTO public.who_global_data VALUES (22107, 79, 5125, 0, 73, 94, 41);
INSERT INTO public.who_global_data VALUES (22108, 13, 5942, 0, 117, 94, 216);
INSERT INTO public.who_global_data VALUES (22109, 560, 97502, 5, 1494, 94, 236);
INSERT INTO public.who_global_data VALUES (22110, 0, 13, 0, 0, 94, 150);
INSERT INTO public.who_global_data VALUES (22111, 0, 495, 0, 0, 94, 61);
INSERT INTO public.who_global_data VALUES (22112, 0, 34, 0, 2, 94, 7);
INSERT INTO public.who_global_data VALUES (22113, 237, 16637, 0, 359, 94, 169);
INSERT INTO public.who_global_data VALUES (22114, 36254, 1469508, 854, 37969, 94, 28);
INSERT INTO public.who_global_data VALUES (22115, 41, 10577, 0, 70, 94, 85);
INSERT INTO public.who_global_data VALUES (22116, 303, 8949, 0, 38, 94, 211);
INSERT INTO public.who_global_data VALUES (22117, 0, 8984, 0, 55, 94, 60);
INSERT INTO public.who_global_data VALUES (22118, 7, 3679, 0, 119, 94, 3);
INSERT INTO public.who_global_data VALUES (22119, 2295, 46817, 19, 381, 94, 11);
INSERT INTO public.who_global_data VALUES (22120, 17214, 577593, 151, 10812, 94, 89);
INSERT INTO public.who_global_data VALUES (22121, 76, 48200, 0, 320, 94, 24);
INSERT INTO public.who_global_data VALUES (22122, 4, 707, 0, 0, 94, 162);
INSERT INTO public.who_global_data VALUES (22123, 2166, 44246, 13, 655, 94, 100);
INSERT INTO public.who_global_data VALUES (22124, 0, 17, 0, 0, 94, 47);
INSERT INTO public.who_global_data VALUES (22125, 1, 29, 0, 0, 94, 29);
INSERT INTO public.who_global_data VALUES (22126, 0, 7742, 0, 126, 94, 40);
INSERT INTO public.who_global_data VALUES (22127, 104, 4748, 1, 80, 94, 222);
INSERT INTO public.who_global_data VALUES (22128, 379, 108483, 10, 3748, 94, 132);
INSERT INTO public.who_global_data VALUES (22129, 1, 271, 0, 13, 94, 130);
INSERT INTO public.who_global_data VALUES (22130, 0, 12213, 0, 73, 94, 234);
INSERT INTO public.who_global_data VALUES (22131, 0, 2413, 0, 41, 94, 23);
INSERT INTO public.who_global_data VALUES (22132, 30, 4238, 2, 128, 94, 192);
INSERT INTO public.who_global_data VALUES (22133, 0, 9054, 0, 232, 94, 69);
INSERT INTO public.who_global_data VALUES (22134, 0, 26, 0, 0, 94, 187);
INSERT INTO public.who_global_data VALUES (22135, 193, 98405, 13, 2688, 94, 230);
INSERT INTO public.who_global_data VALUES (22136, 4219, 90988, 90, 2063, 94, 77);
INSERT INTO public.who_global_data VALUES (22137, 26, 4957, 5, 17, 94, 9);
INSERT INTO public.who_global_data VALUES (22138, 46253, 8313876, 514, 123611, 94, 74);
INSERT INTO public.who_global_data VALUES (22139, 2973, 418375, 102, 14146, 94, 224);
INSERT INTO public.who_global_data VALUES (22140, 8932, 637712, 422, 36160, 94, 199);
INSERT INTO public.who_global_data VALUES (22141, 3595, 482296, 51, 11068, 94, 190);
INSERT INTO public.who_global_data VALUES (22142, 298, 63048, 5, 1922, 94, 12);
INSERT INTO public.who_global_data VALUES (22143, 2, 355, 0, 24, 94, 104);
INSERT INTO public.who_global_data VALUES (22144, 788, 315806, 15, 2600, 94, 153);
INSERT INTO public.who_global_data VALUES (22145, 28241, 759829, 353, 39412, 94, 91);
INSERT INTO public.who_global_data VALUES (22146, 39, 9296, 4, 214, 94, 215);
INSERT INTO public.who_global_data VALUES (22147, 619, 102900, 6, 1786, 94, 84);
INSERT INTO public.who_global_data VALUES (22148, 17, 591, 0, 32, 94, 231);
INSERT INTO public.who_global_data VALUES (22149, 4833, 86576, 54, 967, 94, 196);
INSERT INTO public.who_global_data VALUES (22150, 703, 152725, 0, 2259, 94, 105);
INSERT INTO public.who_global_data VALUES (22151, 492, 57093, 12, 1039, 94, 122);
INSERT INTO public.who_global_data VALUES (22152, 0, 0, 0, 0, 94, 159);
INSERT INTO public.who_global_data VALUES (22153, 334, 20956, 8, 695, 94, 75);
INSERT INTO public.who_global_data VALUES (22154, 787, 128080, 3, 789, 94, 27);
INSERT INTO public.who_global_data VALUES (22155, 495, 60774, 4, 1163, 94, 54);
INSERT INTO public.who_global_data VALUES (22156, 0, 24, 0, 0, 94, 226);
INSERT INTO public.who_global_data VALUES (22157, 171, 6439, 2, 79, 94, 79);
INSERT INTO public.who_global_data VALUES (22158, 1512, 85209, 15, 667, 94, 56);
INSERT INTO public.who_global_data VALUES (22159, 0, 1961, 0, 44, 94, 117);
INSERT INTO public.who_global_data VALUES (22160, 10, 1436, 0, 82, 94, 152);
INSERT INTO public.who_global_data VALUES (22161, 781, 63688, 13, 893, 94, 16);
INSERT INTO public.who_global_data VALUES (22162, 35, 703, 0, 3, 94, 10);
INSERT INTO public.who_global_data VALUES (22163, 653, 18078, 6, 177, 94, 201);
INSERT INTO public.who_global_data VALUES (22164, 533, 19634, 7, 167, 94, 174);
INSERT INTO public.who_global_data VALUES (22165, 0, 17111, 0, 244, 94, 119);
INSERT INTO public.who_global_data VALUES (22166, 1, 5934, 0, 184, 94, 168);
INSERT INTO public.who_global_data VALUES (22167, 1054, 34393, 12, 263, 94, 99);
INSERT INTO public.who_global_data VALUES (22168, 59, 11796, 0, 38, 94, 171);
INSERT INTO public.who_global_data VALUES (22169, 11, 3584, 0, 136, 94, 87);
INSERT INTO public.who_global_data VALUES (22170, 84, 6580, 0, 62, 94, 123);
INSERT INTO public.who_global_data VALUES (22171, 0, 1, 0, 0, 94, 151);
INSERT INTO public.who_global_data VALUES (22172, 0, 3818, 0, 31, 94, 213);
INSERT INTO public.who_global_data VALUES (22173, 0, 7725, 0, 163, 94, 118);
INSERT INTO public.who_global_data VALUES (22174, 0, 452, 0, 10, 94, 134);
INSERT INTO public.who_global_data VALUES (22175, 35, 4524, 0, 45, 94, 65);
INSERT INTO public.who_global_data VALUES (22176, 3763, 933155, 205, 92100, 94, 102);
INSERT INTO public.who_global_data VALUES (22177, 0, 0, 0, 0, 94, 223);
INSERT INTO public.who_global_data VALUES (22178, 22, 400, 0, 2, 94, 4);
INSERT INTO public.who_global_data VALUES (22179, 1, 350, 0, 0, 94, 146);
INSERT INTO public.who_global_data VALUES (22180, 526, 21315, 4, 325, 94, 31);
INSERT INTO public.who_global_data VALUES (22181, 0, 13, 0, 1, 94, 127);
INSERT INTO public.who_global_data VALUES (22182, 4495, 229565, 74, 3900, 94, 22);
INSERT INTO public.who_global_data VALUES (22183, 72, 13202, 1, 95, 94, 115);
INSERT INTO public.who_global_data VALUES (22184, 1197, 55804, 25, 1307, 94, 106);
INSERT INTO public.who_global_data VALUES (22185, 18, 13030, 0, 133, 94, 90);
INSERT INTO public.who_global_data VALUES (22186, 0, 0, 0, 0, 94, 70);
INSERT INTO public.who_global_data VALUES (22187, 3114, 179614, 20, 1004, 94, 46);
INSERT INTO public.who_global_data VALUES (22188, 7739, 374948, 112, 7570, 94, 139);
INSERT INTO public.who_global_data VALUES (22189, 0, 28, 0, 0, 94, 42);
INSERT INTO public.who_global_data VALUES (22190, 3, 1615, 0, 25, 94, 80);
INSERT INTO public.who_global_data VALUES (22191, 56, 4480, 1, 157, 94, 203);
INSERT INTO public.who_global_data VALUES (22192, 1, 1222, 0, 69, 94, 136);
INSERT INTO public.who_global_data VALUES (22193, 137, 63173, 4, 1151, 94, 63);
INSERT INTO public.who_global_data VALUES (22194, 0, 0, 0, 0, 94, 17);
INSERT INTO public.who_global_data VALUES (22195, 0, 96, 0, 2, 94, 172);
INSERT INTO public.who_global_data VALUES (22196, 911, 33908, 24, 1049, 94, 109);
INSERT INTO public.who_global_data VALUES (22197, 700, 21334, 0, 282, 94, 200);
INSERT INTO public.who_global_data VALUES (22198, 633, 67184, 8, 573, 94, 93);
INSERT INTO public.who_global_data VALUES (22199, 376, 116528, 8, 1264, 94, 5);
INSERT INTO public.who_global_data VALUES (22200, 0, 741, 0, 13, 94, 214);
INSERT INTO public.who_global_data VALUES (22201, 1167, 336260, 14, 6849, 94, 204);
INSERT INTO public.who_global_data VALUES (22202, 0, 0, 0, 0, 94, 198);
INSERT INTO public.who_global_data VALUES (22203, 579, 134915, 14, 2720, 94, 173);
INSERT INTO public.who_global_data VALUES (22204, 5, 597, 0, 7, 94, 229);
INSERT INTO public.who_global_data VALUES (22205, 425, 64156, 11, 1429, 94, 76);
INSERT INTO public.who_global_data VALUES (22206, 1634, 906545, 56, 34585, 94, 138);
INSERT INTO public.who_global_data VALUES (22207, 1761, 387161, 49, 7318, 94, 98);
INSERT INTO public.who_global_data VALUES (22208, 0, 0, 0, 0, 94, 103);
INSERT INTO public.who_global_data VALUES (22209, 19364, 414844, 227, 6102, 94, 225);
INSERT INTO public.who_global_data VALUES (22210, 2596, 149443, 45, 2635, 94, 131);
INSERT INTO public.who_global_data VALUES (22211, 771, 68943, 3, 842, 94, 235);
INSERT INTO public.who_global_data VALUES (22212, 226, 133143, 0, 232, 94, 137);
INSERT INTO public.who_global_data VALUES (22213, 117, 26924, 2, 474, 94, 81);
INSERT INTO public.who_global_data VALUES (22214, 710, 77487, 20, 1838, 94, 182);
INSERT INTO public.who_global_data VALUES (22215, 0, 5898, 0, 26, 94, 145);
INSERT INTO public.who_global_data VALUES (22216, 7733, 258437, 120, 7273, 94, 26);
INSERT INTO public.who_global_data VALUES (22217, 19768, 1693454, 389, 29217, 94, 170);
INSERT INTO public.who_global_data VALUES (22218, 7, 5162, 0, 35, 94, 191);
INSERT INTO public.who_global_data VALUES (22219, 0, 5, 0, 0, 94, 221);
INSERT INTO public.who_global_data VALUES (22220, 0, 89, 0, 0, 94, 64);
INSERT INTO public.who_global_data VALUES (22221, 0, 0, 0, 0, 94, 116);
INSERT INTO public.who_global_data VALUES (22222, 0, 19, 0, 0, 94, 128);
INSERT INTO public.who_global_data VALUES (22223, 13, 97, 0, 0, 94, 6);
INSERT INTO public.who_global_data VALUES (22224, 0, 591, 0, 9, 94, 227);
INSERT INTO public.who_global_data VALUES (22225, 0, 12, 0, 0, 94, 68);
INSERT INTO public.who_global_data VALUES (22226, 0, 75, 0, 0, 94, 184);
INSERT INTO public.who_global_data VALUES (22227, 0, 0, 0, 0, 94, 82);
INSERT INTO public.who_global_data VALUES (22228, 36, 994, 0, 42, 94, 149);
INSERT INTO public.who_global_data VALUES (22229, 5, 954, 0, 16, 94, 197);
INSERT INTO public.who_global_data VALUES (22230, 473, 348510, 19, 5456, 94, 78);
INSERT INTO public.who_global_data VALUES (22231, 10, 15640, 1, 326, 94, 233);
INSERT INTO public.who_global_data VALUES (22232, 1878, 51083, 11, 844, 94, 133);
INSERT INTO public.who_global_data VALUES (22233, 0, 154, 0, 0, 94, 35);
INSERT INTO public.who_global_data VALUES (22234, 2, 2368, 0, 74, 94, 114);
INSERT INTO public.who_global_data VALUES (22235, 9, 58029, 0, 28, 94, 237);
INSERT INTO public.who_global_data VALUES (22236, 0, 14, 0, 0, 94, 55);
INSERT INTO public.who_global_data VALUES (22237, 13, 844, 0, 22, 94, 176);
INSERT INTO public.who_global_data VALUES (22238, 1727, 63556, 16, 235, 94, 202);
INSERT INTO public.who_global_data VALUES (22239, 2032, 39428, 31, 503, 94, 155);
INSERT INTO public.who_global_data VALUES (22240, 0, 13, 0, 0, 94, 32);
INSERT INTO public.who_global_data VALUES (22241, 288, 4229, 3, 107, 94, 220);
INSERT INTO public.who_global_data VALUES (22242, 1241, 728836, 74, 19539, 94, 30);
INSERT INTO public.who_global_data VALUES (22243, 3, 2943, 0, 59, 94, 147);
INSERT INTO public.who_global_data VALUES (22244, 16117, 1337822, 266, 39606, 94, 208);
INSERT INTO public.who_global_data VALUES (22245, 409, 11744, 2, 23, 94, 45);
INSERT INTO public.who_global_data VALUES (22246, 39, 13905, 0, 837, 94, 110);
INSERT INTO public.who_global_data VALUES (22247, 2, 5212, 0, 111, 94, 88);
INSERT INTO public.who_global_data VALUES (22248, 1569, 134898, 20, 6076, 94, 51);
INSERT INTO public.who_global_data VALUES (22249, 9595, 199978, 78, 2481, 94, 209);
INSERT INTO public.who_global_data VALUES (22250, 45, 5888, 3, 298, 94, 205);
INSERT INTO public.who_global_data VALUES (22251, 43, 11139, 1, 83, 94, 18);
INSERT INTO public.who_global_data VALUES (22252, 7, 3804, 0, 59, 94, 72);
INSERT INTO public.who_global_data VALUES (22253, 20018, 1073886, 397, 47250, 94, 44);
INSERT INTO public.who_global_data VALUES (22254, 0, 30, 0, 0, 94, 15);
INSERT INTO public.who_global_data VALUES (22255, 24, 2381, 0, 57, 94, 25);
INSERT INTO public.who_global_data VALUES (22256, 0, 0, 0, 0, 94, 179);
INSERT INTO public.who_global_data VALUES (22257, 0, 0, 0, 0, 94, 34);
INSERT INTO public.who_global_data VALUES (22258, 0, 5704, 0, 109, 94, 207);
INSERT INTO public.who_global_data VALUES (22259, 1237, 64363, 29, 1512, 94, 166);
INSERT INTO public.who_global_data VALUES (22260, 9073, 1048388, 79, 10481, 94, 126);
INSERT INTO public.who_global_data VALUES (22261, 0, 0, 0, 0, 94, 97);
INSERT INTO public.who_global_data VALUES (22262, 0, 704, 0, 6, 94, 36);
INSERT INTO public.who_global_data VALUES (22263, 0, 0, 0, 0, 94, 125);
INSERT INTO public.who_global_data VALUES (22264, 128, 13099, 1, 115, 94, 124);
INSERT INTO public.who_global_data VALUES (22265, 9524, 420617, 199, 7731, 94, 185);
INSERT INTO public.who_global_data VALUES (22266, 1008, 136149, 6, 503, 94, 194);
INSERT INTO public.who_global_data VALUES (22267, 0, 509, 0, 21, 94, 144);
INSERT INTO public.who_global_data VALUES (22268, 85412, 9193765, 506, 229948, 94, 19);
INSERT INTO public.who_global_data VALUES (22269, 7, 1385, 1, 22, 94, 217);
INSERT INTO public.who_global_data VALUES (22270, 16, 3165, 1, 60, 94, 148);
INSERT INTO public.who_global_data VALUES (22271, 197, 67698, 2, 575, 94, 86);
INSERT INTO public.who_global_data VALUES (22272, 0, 0, 0, 0, 94, 13);
INSERT INTO public.who_global_data VALUES (22273, 380, 92705, 4, 805, 94, 157);
INSERT INTO public.who_global_data VALUES (22274, 11, 1203, 0, 35, 94, 8);
INSERT INTO public.who_global_data VALUES (22275, 0, 1, 0, 0, 94, 73);
INSERT INTO public.who_global_data VALUES (22276, 2, 2069, 0, 602, 94, 101);
INSERT INTO public.who_global_data VALUES (22277, 118, 16661, 0, 349, 94, 165);
INSERT INTO public.who_global_data VALUES (22278, 21, 8410, 1, 246, 94, 14);
INSERT INTO public.who_global_data VALUES (22279, 132, 41633, 5, 1541, 95, 193);
INSERT INTO public.who_global_data VALUES (22280, 321, 21523, 9, 527, 95, 113);
INSERT INTO public.who_global_data VALUES (22281, 0, 57942, 0, 1964, 95, 143);
INSERT INTO public.who_global_data VALUES (22282, 0, 0, 0, 0, 95, 219);
INSERT INTO public.who_global_data VALUES (22283, 63, 4888, 0, 75, 95, 186);
INSERT INTO public.who_global_data VALUES (22284, 193, 11228, 3, 289, 95, 52);
INSERT INTO public.who_global_data VALUES (22285, 0, 3, 0, 0, 95, 180);
INSERT INTO public.who_global_data VALUES (22286, 0, 128, 0, 3, 95, 167);
INSERT INTO public.who_global_data VALUES (22287, 6609, 1173533, 138, 31140, 95, 154);
INSERT INTO public.who_global_data VALUES (22288, 1328, 94089, 22, 1408, 95, 94);
INSERT INTO public.who_global_data VALUES (22289, 47, 4519, 1, 38, 95, 66);
INSERT INTO public.who_global_data VALUES (22290, 7, 27602, 0, 907, 95, 58);
INSERT INTO public.who_global_data VALUES (22291, 3160, 114270, 21, 1135, 95, 163);
INSERT INTO public.who_global_data VALUES (22292, 596, 57040, 13, 753, 95, 37);
INSERT INTO public.who_global_data VALUES (22293, 24, 6759, 2, 148, 95, 142);
INSERT INTO public.who_global_data VALUES (22294, 210, 82133, 1, 322, 95, 83);
INSERT INTO public.who_global_data VALUES (22295, 1736, 410988, 25, 5966, 95, 228);
INSERT INTO public.who_global_data VALUES (22296, 0, 237, 0, 7, 95, 188);
INSERT INTO public.who_global_data VALUES (22297, 941, 100400, 4, 989, 95, 62);
INSERT INTO public.who_global_data VALUES (22298, 13858, 465332, 207, 12210, 95, 160);
INSERT INTO public.who_global_data VALUES (22299, 90, 3577, 0, 59, 95, 50);
INSERT INTO public.who_global_data VALUES (22300, 0, 2683, 0, 41, 95, 33);
INSERT INTO public.who_global_data VALUES (22301, 7, 206, 0, 9, 95, 183);
INSERT INTO public.who_global_data VALUES (22302, 2, 356, 0, 0, 95, 92);
INSERT INTO public.who_global_data VALUES (22303, 76, 141833, 6, 8731, 95, 158);
INSERT INTO public.who_global_data VALUES (22304, 0, 134, 0, 3, 95, 67);
INSERT INTO public.who_global_data VALUES (22305, 764, 52269, 32, 1280, 95, 57);
INSERT INTO public.who_global_data VALUES (22306, 0, 6642, 0, 24, 95, 38);
INSERT INTO public.who_global_data VALUES (22307, 10100, 5545705, 190, 160074, 95, 141);
INSERT INTO public.who_global_data VALUES (22308, 0, 72, 0, 1, 95, 178);
INSERT INTO public.who_global_data VALUES (22309, 0, 148, 0, 3, 95, 108);
INSERT INTO public.who_global_data VALUES (22310, 2427, 56496, 51, 1349, 95, 39);
INSERT INTO public.who_global_data VALUES (22311, 17, 2517, 0, 67, 95, 2);
INSERT INTO public.who_global_data VALUES (22312, 8, 597, 0, 1, 95, 195);
INSERT INTO public.who_global_data VALUES (22313, 34, 8882, 0, 95, 95, 107);
INSERT INTO public.who_global_data VALUES (22314, 0, 292, 0, 0, 95, 161);
INSERT INTO public.who_global_data VALUES (22315, 310, 22103, 3, 429, 95, 212);
INSERT INTO public.who_global_data VALUES (22316, 2330, 236841, 43, 10179, 95, 181);
INSERT INTO public.who_global_data VALUES (22317, 0, 240, 0, 1, 95, 53);
INSERT INTO public.who_global_data VALUES (22318, 0, 4866, 0, 62, 95, 164);
INSERT INTO public.who_global_data VALUES (22319, 1, 1499, 0, 98, 95, 140);
INSERT INTO public.who_global_data VALUES (22320, 1324, 513188, 55, 14302, 95, 20);
INSERT INTO public.who_global_data VALUES (22321, 60, 92015, 0, 4746, 95, 112);
INSERT INTO public.who_global_data VALUES (22322, 9137, 1083321, 201, 31515, 95, 111);
INSERT INTO public.who_global_data VALUES (22323, 0, 545, 0, 7, 95, 71);
INSERT INTO public.who_global_data VALUES (22324, 58, 5348, 0, 92, 95, 218);
INSERT INTO public.who_global_data VALUES (22325, 0, 0, 0, 0, 95, 43);
INSERT INTO public.who_global_data VALUES (22326, 746, 110717, 11, 1396, 95, 49);
INSERT INTO public.who_global_data VALUES (22327, 37, 20753, 0, 126, 95, 1);
INSERT INTO public.who_global_data VALUES (22328, 1165, 52660, 32, 594, 95, 48);
INSERT INTO public.who_global_data VALUES (22329, 35, 6970, 1, 129, 95, 232);
INSERT INTO public.who_global_data VALUES (22330, 43, 987, 0, 1, 95, 175);
INSERT INTO public.who_global_data VALUES (22331, 197, 4760, 0, 26, 95, 21);
INSERT INTO public.who_global_data VALUES (22332, 9252, 350896, 225, 3654, 95, 156);
INSERT INTO public.who_global_data VALUES (22333, 0, 0, 0, 0, 95, 95);
INSERT INTO public.who_global_data VALUES (22334, 22, 11394, 0, 308, 95, 177);
INSERT INTO public.who_global_data VALUES (22335, 942, 48241, 1, 724, 95, 210);
INSERT INTO public.who_global_data VALUES (22336, 10, 5573, 0, 61, 95, 120);
INSERT INTO public.who_global_data VALUES (22337, 0, 50, 0, 0, 95, 135);
INSERT INTO public.who_global_data VALUES (22338, 259, 127591, 1, 2250, 95, 206);
INSERT INTO public.who_global_data VALUES (22339, 368, 169562, 8, 12692, 95, 189);
INSERT INTO public.who_global_data VALUES (22340, 189, 107925, 13, 6291, 95, 129);
INSERT INTO public.who_global_data VALUES (22341, 0, 34015, 4, 983, 95, 121);
INSERT INTO public.who_global_data VALUES (22342, 1, 5089, 0, 83, 95, 59);
INSERT INTO public.who_global_data VALUES (22343, 17, 480, 0, 0, 95, 96);
INSERT INTO public.who_global_data VALUES (22344, 61, 5046, 0, 73, 95, 41);
INSERT INTO public.who_global_data VALUES (22345, 4, 5929, 0, 117, 95, 216);
INSERT INTO public.who_global_data VALUES (22346, 359, 96942, 11, 1489, 95, 236);
INSERT INTO public.who_global_data VALUES (22347, 0, 13, 0, 0, 95, 150);
INSERT INTO public.who_global_data VALUES (22348, 0, 495, 0, 0, 95, 61);
INSERT INTO public.who_global_data VALUES (22349, 0, 34, 0, 2, 95, 7);
INSERT INTO public.who_global_data VALUES (22350, 109, 16400, 1, 359, 95, 169);
INSERT INTO public.who_global_data VALUES (22351, 52156, 1433254, 411, 37115, 95, 28);
INSERT INTO public.who_global_data VALUES (22352, 0, 10536, 0, 70, 95, 85);
INSERT INTO public.who_global_data VALUES (22353, 1384, 8646, 9, 38, 95, 211);
INSERT INTO public.who_global_data VALUES (22354, 16, 8984, 0, 55, 95, 60);
INSERT INTO public.who_global_data VALUES (22355, 0, 3672, 0, 119, 95, 3);
INSERT INTO public.who_global_data VALUES (22356, 1943, 44522, 20, 362, 95, 11);
INSERT INTO public.who_global_data VALUES (22357, 15352, 560379, 131, 10661, 95, 89);
INSERT INTO public.who_global_data VALUES (22358, 69, 48124, 0, 320, 95, 24);
INSERT INTO public.who_global_data VALUES (22359, 6, 703, 0, 0, 95, 162);
INSERT INTO public.who_global_data VALUES (22360, 1151, 42080, 7, 642, 95, 100);
INSERT INTO public.who_global_data VALUES (22361, 0, 17, 0, 0, 95, 47);
INSERT INTO public.who_global_data VALUES (22362, 0, 28, 0, 0, 95, 29);
INSERT INTO public.who_global_data VALUES (22363, 0, 7742, 0, 126, 95, 40);
INSERT INTO public.who_global_data VALUES (22364, 3, 4644, 0, 79, 95, 222);
INSERT INTO public.who_global_data VALUES (22365, 0, 108104, 0, 3738, 95, 132);
INSERT INTO public.who_global_data VALUES (22366, 2, 270, 0, 13, 95, 130);
INSERT INTO public.who_global_data VALUES (22367, 18, 12213, 0, 73, 95, 234);
INSERT INTO public.who_global_data VALUES (22368, 0, 2413, 0, 41, 95, 23);
INSERT INTO public.who_global_data VALUES (22369, 46, 4208, 2, 126, 95, 192);
INSERT INTO public.who_global_data VALUES (22370, 0, 9054, 0, 232, 95, 69);
INSERT INTO public.who_global_data VALUES (22371, 0, 26, 0, 0, 95, 187);
INSERT INTO public.who_global_data VALUES (22372, 808, 98212, 3, 2675, 95, 230);
INSERT INTO public.who_global_data VALUES (22373, 3989, 86769, 84, 1973, 95, 77);
INSERT INTO public.who_global_data VALUES (22374, 41, 4931, 0, 12, 95, 9);
INSERT INTO public.who_global_data VALUES (22375, 38310, 8267623, 490, 123097, 95, 74);
INSERT INTO public.who_global_data VALUES (22376, 2618, 415402, 101, 14044, 95, 224);
INSERT INTO public.who_global_data VALUES (22377, 8289, 628780, 440, 35738, 95, 199);
INSERT INTO public.who_global_data VALUES (22378, 3413, 478701, 51, 11017, 95, 190);
INSERT INTO public.who_global_data VALUES (22379, 748, 62750, 2, 1917, 95, 12);
INSERT INTO public.who_global_data VALUES (22380, 0, 353, 0, 24, 95, 104);
INSERT INTO public.who_global_data VALUES (22381, 658, 315018, 19, 2585, 95, 153);
INSERT INTO public.who_global_data VALUES (22382, 22253, 731588, 233, 39059, 95, 91);
INSERT INTO public.who_global_data VALUES (22383, 126, 9257, 1, 210, 95, 215);
INSERT INTO public.who_global_data VALUES (22384, 468, 102281, 6, 1780, 95, 84);
INSERT INTO public.who_global_data VALUES (22385, 0, 574, 0, 32, 95, 231);
INSERT INTO public.who_global_data VALUES (22386, 5877, 81743, 47, 913, 95, 196);
INSERT INTO public.who_global_data VALUES (22387, 701, 152022, 0, 2259, 95, 105);
INSERT INTO public.who_global_data VALUES (22388, 724, 56601, 14, 1027, 95, 122);
INSERT INTO public.who_global_data VALUES (22389, 0, 0, 0, 0, 95, 159);
INSERT INTO public.who_global_data VALUES (22390, 486, 20622, 9, 687, 95, 75);
INSERT INTO public.who_global_data VALUES (22391, 759, 127293, 4, 786, 95, 27);
INSERT INTO public.who_global_data VALUES (22392, 400, 60279, 4, 1159, 95, 54);
INSERT INTO public.who_global_data VALUES (22393, 0, 24, 0, 0, 95, 226);
INSERT INTO public.who_global_data VALUES (22394, 132, 6268, 3, 77, 95, 79);
INSERT INTO public.who_global_data VALUES (22395, 1080, 83697, 9, 652, 95, 56);
INSERT INTO public.who_global_data VALUES (22396, 8, 1961, 0, 44, 95, 117);
INSERT INTO public.who_global_data VALUES (22397, 0, 1426, 0, 82, 95, 152);
INSERT INTO public.who_global_data VALUES (22398, 862, 62907, 9, 880, 95, 16);
INSERT INTO public.who_global_data VALUES (22399, 45, 668, 0, 3, 95, 10);
INSERT INTO public.who_global_data VALUES (22400, 893, 17425, 11, 171, 95, 201);
INSERT INTO public.who_global_data VALUES (22401, 319, 19101, 0, 160, 95, 174);
INSERT INTO public.who_global_data VALUES (22402, 0, 17111, 0, 244, 95, 119);
INSERT INTO public.who_global_data VALUES (22403, 1, 5933, 0, 184, 95, 168);
INSERT INTO public.who_global_data VALUES (22404, 834, 33339, 2, 251, 95, 99);
INSERT INTO public.who_global_data VALUES (22405, 36, 11737, 0, 38, 95, 171);
INSERT INTO public.who_global_data VALUES (22406, 8, 3573, 0, 136, 95, 87);
INSERT INTO public.who_global_data VALUES (22407, 106, 6496, 1, 62, 95, 123);
INSERT INTO public.who_global_data VALUES (22408, 0, 1, 0, 0, 95, 151);
INSERT INTO public.who_global_data VALUES (22409, 0, 3818, 0, 31, 95, 213);
INSERT INTO public.who_global_data VALUES (22410, 62, 7725, 0, 163, 95, 118);
INSERT INTO public.who_global_data VALUES (22411, 11, 452, 0, 10, 95, 134);
INSERT INTO public.who_global_data VALUES (22412, 123, 4489, 1, 45, 95, 65);
INSERT INTO public.who_global_data VALUES (22413, 4430, 929392, 142, 91895, 95, 102);
INSERT INTO public.who_global_data VALUES (22414, 0, 0, 0, 0, 95, 223);
INSERT INTO public.who_global_data VALUES (22415, 9, 378, 0, 2, 95, 4);
INSERT INTO public.who_global_data VALUES (22416, 3, 349, 0, 0, 95, 146);
INSERT INTO public.who_global_data VALUES (22417, 533, 20789, 2, 321, 95, 31);
INSERT INTO public.who_global_data VALUES (22418, 0, 13, 0, 1, 95, 127);
INSERT INTO public.who_global_data VALUES (22419, 2526, 225070, 64, 3826, 95, 22);
INSERT INTO public.who_global_data VALUES (22420, 142, 13130, 1, 94, 95, 115);
INSERT INTO public.who_global_data VALUES (22421, 1202, 54607, 24, 1282, 95, 106);
INSERT INTO public.who_global_data VALUES (22422, 24, 13012, 0, 133, 95, 90);
INSERT INTO public.who_global_data VALUES (22423, 0, 0, 0, 0, 95, 70);
INSERT INTO public.who_global_data VALUES (22424, 2933, 176500, 24, 984, 95, 46);
INSERT INTO public.who_global_data VALUES (22425, 8267, 367209, 29, 7458, 95, 139);
INSERT INTO public.who_global_data VALUES (22426, 0, 28, 0, 0, 95, 42);
INSERT INTO public.who_global_data VALUES (22427, 5, 1612, 0, 25, 95, 80);
INSERT INTO public.who_global_data VALUES (22428, 0, 4424, 0, 156, 95, 203);
INSERT INTO public.who_global_data VALUES (22429, 0, 1221, 0, 69, 95, 136);
INSERT INTO public.who_global_data VALUES (22430, 72, 63036, 1, 1147, 95, 63);
INSERT INTO public.who_global_data VALUES (22431, 0, 0, 0, 0, 95, 17);
INSERT INTO public.who_global_data VALUES (22432, 0, 96, 0, 2, 95, 172);
INSERT INTO public.who_global_data VALUES (22433, 561, 32997, 21, 1025, 95, 109);
INSERT INTO public.who_global_data VALUES (22434, 1071, 20634, 0, 282, 95, 200);
INSERT INTO public.who_global_data VALUES (22435, 749, 66551, 4, 565, 95, 93);
INSERT INTO public.who_global_data VALUES (22436, 418, 116152, 10, 1256, 95, 5);
INSERT INTO public.who_global_data VALUES (22437, 0, 741, 0, 13, 95, 214);
INSERT INTO public.who_global_data VALUES (22438, 1123, 335093, 12, 6835, 95, 204);
INSERT INTO public.who_global_data VALUES (22439, 0, 0, 0, 0, 95, 198);
INSERT INTO public.who_global_data VALUES (22440, 738, 134336, 6, 2706, 95, 173);
INSERT INTO public.who_global_data VALUES (22441, 2, 592, 0, 7, 95, 229);
INSERT INTO public.who_global_data VALUES (22442, 546, 63731, 14, 1418, 95, 76);
INSERT INTO public.who_global_data VALUES (22443, 2408, 904911, 53, 34529, 95, 138);
INSERT INTO public.who_global_data VALUES (22444, 2287, 385400, 31, 7269, 95, 98);
INSERT INTO public.who_global_data VALUES (22445, 0, 0, 0, 0, 95, 103);
INSERT INTO public.who_global_data VALUES (22446, 15578, 395480, 92, 5875, 95, 225);
INSERT INTO public.who_global_data VALUES (22447, 2506, 146847, 46, 2590, 95, 131);
INSERT INTO public.who_global_data VALUES (22448, 1511, 68172, 7, 839, 95, 235);
INSERT INTO public.who_global_data VALUES (22449, 197, 132917, 0, 232, 95, 137);
INSERT INTO public.who_global_data VALUES (22450, 75, 26807, 4, 472, 95, 81);
INSERT INTO public.who_global_data VALUES (22451, 195, 76777, 18, 1818, 95, 182);
INSERT INTO public.who_global_data VALUES (22452, 239, 5898, 4, 26, 95, 145);
INSERT INTO public.who_global_data VALUES (22453, 4041, 250704, 86, 7153, 95, 26);
INSERT INTO public.who_global_data VALUES (22454, 18652, 1673686, 355, 28828, 95, 170);
INSERT INTO public.who_global_data VALUES (22455, 9, 5155, 0, 35, 95, 191);
INSERT INTO public.who_global_data VALUES (22456, 0, 5, 0, 0, 95, 221);
INSERT INTO public.who_global_data VALUES (22457, 0, 89, 0, 0, 95, 64);
INSERT INTO public.who_global_data VALUES (22458, 0, 0, 0, 0, 95, 116);
INSERT INTO public.who_global_data VALUES (22459, 0, 19, 0, 0, 95, 128);
INSERT INTO public.who_global_data VALUES (22460, 0, 84, 0, 0, 95, 6);
INSERT INTO public.who_global_data VALUES (22461, 0, 591, 0, 9, 95, 227);
INSERT INTO public.who_global_data VALUES (22462, 0, 12, 0, 0, 95, 68);
INSERT INTO public.who_global_data VALUES (22463, 0, 75, 0, 0, 95, 184);
INSERT INTO public.who_global_data VALUES (22464, 0, 0, 0, 0, 95, 82);
INSERT INTO public.who_global_data VALUES (22465, 0, 958, 0, 42, 95, 149);
INSERT INTO public.who_global_data VALUES (22466, 0, 949, 0, 16, 95, 197);
INSERT INTO public.who_global_data VALUES (22467, 381, 348037, 17, 5437, 95, 78);
INSERT INTO public.who_global_data VALUES (22468, 14, 15630, 1, 325, 95, 233);
INSERT INTO public.who_global_data VALUES (22469, 802, 49205, 7, 833, 95, 133);
INSERT INTO public.who_global_data VALUES (22470, 0, 154, 0, 0, 95, 35);
INSERT INTO public.who_global_data VALUES (22471, 0, 2366, 0, 74, 95, 114);
INSERT INTO public.who_global_data VALUES (22472, 1, 58020, 0, 28, 95, 237);
INSERT INTO public.who_global_data VALUES (22473, 0, 14, 0, 0, 95, 55);
INSERT INTO public.who_global_data VALUES (22474, 26, 831, 0, 22, 95, 176);
INSERT INTO public.who_global_data VALUES (22475, 1883, 61829, 0, 219, 95, 202);
INSERT INTO public.who_global_data VALUES (22476, 1177, 37396, 31, 472, 95, 155);
INSERT INTO public.who_global_data VALUES (22477, 5, 13, 0, 0, 95, 32);
INSERT INTO public.who_global_data VALUES (22478, 0, 3941, 0, 104, 95, 220);
INSERT INTO public.who_global_data VALUES (22479, 772, 727595, 54, 19465, 95, 30);
INSERT INTO public.who_global_data VALUES (22480, 14, 2940, 0, 59, 95, 147);
INSERT INTO public.who_global_data VALUES (22481, 11149, 1321705, 240, 39340, 95, 208);
INSERT INTO public.who_global_data VALUES (22482, 275, 11335, 0, 21, 95, 45);
INSERT INTO public.who_global_data VALUES (22483, 47, 13866, 0, 837, 95, 110);
INSERT INTO public.who_global_data VALUES (22484, 7, 5210, 0, 111, 95, 88);
INSERT INTO public.who_global_data VALUES (22485, 1297, 133329, 22, 6056, 95, 51);
INSERT INTO public.who_global_data VALUES (22486, 10514, 190383, 58, 2403, 95, 209);
INSERT INTO public.who_global_data VALUES (22487, 54, 5843, 3, 295, 95, 205);
INSERT INTO public.who_global_data VALUES (22488, 42, 11096, 0, 82, 95, 18);
INSERT INTO public.who_global_data VALUES (22489, 10, 3797, 0, 59, 95, 72);
INSERT INTO public.who_global_data VALUES (22490, 18950, 1053868, 136, 46853, 95, 44);
INSERT INTO public.who_global_data VALUES (22491, 0, 30, 0, 0, 95, 15);
INSERT INTO public.who_global_data VALUES (22492, 0, 2357, 0, 57, 95, 25);
INSERT INTO public.who_global_data VALUES (22493, 0, 0, 0, 0, 95, 179);
INSERT INTO public.who_global_data VALUES (22494, 0, 0, 0, 0, 95, 34);
INSERT INTO public.who_global_data VALUES (22495, 0, 5704, 1, 109, 95, 207);
INSERT INTO public.who_global_data VALUES (22496, 1220, 63126, 102, 1483, 95, 166);
INSERT INTO public.who_global_data VALUES (22497, 9032, 1039315, 76, 10402, 95, 126);
INSERT INTO public.who_global_data VALUES (22498, 0, 0, 0, 0, 95, 97);
INSERT INTO public.who_global_data VALUES (22499, 1, 704, 0, 6, 95, 36);
INSERT INTO public.who_global_data VALUES (22500, 0, 0, 0, 0, 95, 125);
INSERT INTO public.who_global_data VALUES (22501, 228, 12971, 2, 114, 95, 124);
INSERT INTO public.who_global_data VALUES (22502, 8899, 411093, 157, 7532, 95, 185);
INSERT INTO public.who_global_data VALUES (22503, 1234, 135141, 1, 497, 95, 194);
INSERT INTO public.who_global_data VALUES (22504, 0, 509, 0, 21, 95, 144);
INSERT INTO public.who_global_data VALUES (22505, 75888, 9108353, 444, 229442, 95, 19);
INSERT INTO public.who_global_data VALUES (22506, 2, 1378, 0, 21, 95, 217);
INSERT INTO public.who_global_data VALUES (22507, 25, 3149, 1, 59, 95, 148);
INSERT INTO public.who_global_data VALUES (22508, 247, 67501, 2, 573, 95, 86);
INSERT INTO public.who_global_data VALUES (22509, 0, 0, 0, 0, 95, 13);
INSERT INTO public.who_global_data VALUES (22510, 312, 92325, 3, 801, 95, 157);
INSERT INTO public.who_global_data VALUES (22511, 12, 1192, 0, 35, 95, 8);
INSERT INTO public.who_global_data VALUES (22512, 0, 1, 0, 0, 95, 73);
INSERT INTO public.who_global_data VALUES (22513, 0, 2067, 1, 602, 95, 101);
INSERT INTO public.who_global_data VALUES (22514, 63, 16543, 0, 349, 95, 165);
INSERT INTO public.who_global_data VALUES (22515, 15, 8389, 2, 245, 95, 14);
INSERT INTO public.who_global_data VALUES (22516, 76, 41501, 0, 1536, 96, 193);
INSERT INTO public.who_global_data VALUES (22517, 327, 21202, 9, 518, 96, 113);
INSERT INTO public.who_global_data VALUES (22518, 291, 57942, 8, 1964, 96, 143);
INSERT INTO public.who_global_data VALUES (22519, 0, 0, 0, 0, 96, 219);
INSERT INTO public.who_global_data VALUES (22520, 69, 4825, 0, 75, 96, 186);
INSERT INTO public.who_global_data VALUES (22521, 230, 11035, 2, 286, 96, 52);
INSERT INTO public.who_global_data VALUES (22522, 0, 3, 0, 0, 96, 180);
INSERT INTO public.who_global_data VALUES (22523, 1, 128, 0, 3, 96, 167);
INSERT INTO public.who_global_data VALUES (22524, 9745, 1166924, 210, 31002, 96, 154);
INSERT INTO public.who_global_data VALUES (22525, 1194, 92761, 28, 1386, 96, 94);
INSERT INTO public.who_global_data VALUES (22526, 0, 4472, 0, 37, 96, 66);
INSERT INTO public.who_global_data VALUES (22527, 5, 27595, 0, 907, 96, 58);
INSERT INTO public.who_global_data VALUES (22528, 4526, 111110, 17, 1114, 96, 163);
INSERT INTO public.who_global_data VALUES (22529, 1175, 56444, 10, 740, 96, 37);
INSERT INTO public.who_global_data VALUES (22530, 91, 6735, 4, 146, 96, 142);
INSERT INTO public.who_global_data VALUES (22531, 278, 81923, 0, 321, 96, 83);
INSERT INTO public.who_global_data VALUES (22532, 1568, 409252, 18, 5941, 96, 228);
INSERT INTO public.who_global_data VALUES (22533, 1, 237, 0, 7, 96, 188);
INSERT INTO public.who_global_data VALUES (22534, 0, 99459, 0, 985, 96, 62);
INSERT INTO public.who_global_data VALUES (22535, 2667, 451474, 163, 12003, 96, 160);
INSERT INTO public.who_global_data VALUES (22536, 25, 3487, 1, 59, 96, 50);
INSERT INTO public.who_global_data VALUES (22537, 40, 2683, 0, 41, 96, 33);
INSERT INTO public.who_global_data VALUES (22538, 0, 199, 0, 9, 96, 183);
INSERT INTO public.who_global_data VALUES (22539, 5, 354, 0, 0, 96, 92);
INSERT INTO public.who_global_data VALUES (22540, 126, 141757, 10, 8725, 96, 158);
INSERT INTO public.who_global_data VALUES (22541, 0, 134, 0, 3, 96, 67);
INSERT INTO public.who_global_data VALUES (22542, 1415, 51505, 14, 1248, 96, 57);
INSERT INTO public.who_global_data VALUES (22543, 0, 6642, 0, 24, 96, 38);
INSERT INTO public.who_global_data VALUES (22544, 18947, 5535605, 407, 159884, 96, 141);
INSERT INTO public.who_global_data VALUES (22545, 0, 72, 0, 1, 96, 178);
INSERT INTO public.who_global_data VALUES (22546, 0, 148, 0, 3, 96, 108);
INSERT INTO public.who_global_data VALUES (22547, 1225, 54069, 19, 1298, 96, 39);
INSERT INTO public.who_global_data VALUES (22548, 0, 2500, 0, 67, 96, 2);
INSERT INTO public.who_global_data VALUES (22549, 0, 589, 0, 1, 96, 195);
INSERT INTO public.who_global_data VALUES (22550, 55, 8848, 0, 95, 96, 107);
INSERT INTO public.who_global_data VALUES (22551, 1, 292, 0, 0, 96, 161);
INSERT INTO public.who_global_data VALUES (22552, 0, 21793, 0, 426, 96, 212);
INSERT INTO public.who_global_data VALUES (22553, 2512, 234511, 26, 10136, 96, 181);
INSERT INTO public.who_global_data VALUES (22554, 0, 240, 0, 1, 96, 53);
INSERT INTO public.who_global_data VALUES (22555, 0, 4866, 0, 62, 96, 164);
INSERT INTO public.who_global_data VALUES (22556, 15, 1498, 0, 98, 96, 140);
INSERT INTO public.who_global_data VALUES (22557, 1608, 511864, 40, 14247, 96, 20);
INSERT INTO public.who_global_data VALUES (22558, 34, 91955, 0, 4746, 96, 112);
INSERT INTO public.who_global_data VALUES (22559, 11033, 1074184, 179, 31314, 96, 111);
INSERT INTO public.who_global_data VALUES (22560, 15, 545, 0, 7, 96, 71);
INSERT INTO public.who_global_data VALUES (22561, 0, 5290, 0, 92, 96, 218);
INSERT INTO public.who_global_data VALUES (22562, 0, 0, 0, 0, 96, 43);
INSERT INTO public.who_global_data VALUES (22563, 1105, 109971, 14, 1385, 96, 49);
INSERT INTO public.who_global_data VALUES (22564, 24, 20716, 2, 126, 96, 1);
INSERT INTO public.who_global_data VALUES (22565, 2179, 51495, 16, 562, 96, 48);
INSERT INTO public.who_global_data VALUES (22566, 48, 6935, 0, 128, 96, 232);
INSERT INTO public.who_global_data VALUES (22567, 0, 944, 0, 1, 96, 175);
INSERT INTO public.who_global_data VALUES (22568, 197, 4563, 0, 26, 96, 21);
INSERT INTO public.who_global_data VALUES (22569, 6542, 341644, 178, 3429, 96, 156);
INSERT INTO public.who_global_data VALUES (22570, 0, 0, 0, 0, 96, 95);
INSERT INTO public.who_global_data VALUES (22571, 67, 11372, 1, 308, 96, 177);
INSERT INTO public.who_global_data VALUES (22572, 948, 47299, 2, 723, 96, 210);
INSERT INTO public.who_global_data VALUES (22573, 2, 5563, 0, 61, 96, 120);
INSERT INTO public.who_global_data VALUES (22574, 0, 50, 0, 0, 96, 135);
INSERT INTO public.who_global_data VALUES (22575, 314, 127332, 4, 2249, 96, 206);
INSERT INTO public.who_global_data VALUES (22576, 1002, 169194, 14, 12684, 96, 189);
INSERT INTO public.who_global_data VALUES (22577, 181, 107736, 12, 6278, 96, 129);
INSERT INTO public.who_global_data VALUES (22578, 570, 34015, 4, 979, 96, 121);
INSERT INTO public.who_global_data VALUES (22579, 0, 5088, 0, 83, 96, 59);
INSERT INTO public.who_global_data VALUES (22580, 0, 463, 0, 0, 96, 96);
INSERT INTO public.who_global_data VALUES (22581, 80, 4985, 0, 73, 96, 41);
INSERT INTO public.who_global_data VALUES (22582, 8, 5925, 0, 117, 96, 216);
INSERT INTO public.who_global_data VALUES (22583, 414, 96583, 9, 1478, 96, 236);
INSERT INTO public.who_global_data VALUES (22584, 0, 13, 0, 0, 96, 150);
INSERT INTO public.who_global_data VALUES (22585, 0, 495, 0, 0, 96, 61);
INSERT INTO public.who_global_data VALUES (22586, 0, 34, 0, 2, 96, 7);
INSERT INTO public.who_global_data VALUES (22587, 178, 16291, 0, 358, 96, 169);
INSERT INTO public.who_global_data VALUES (22588, 49290, 1381098, 231, 36704, 96, 28);
INSERT INTO public.who_global_data VALUES (22589, 0, 10536, 0, 70, 96, 85);
INSERT INTO public.who_global_data VALUES (22590, 0, 7262, 0, 29, 96, 211);
INSERT INTO public.who_global_data VALUES (22591, 0, 8968, 0, 55, 96, 60);
INSERT INTO public.who_global_data VALUES (22592, 2, 3672, 0, 119, 96, 3);
INSERT INTO public.who_global_data VALUES (22593, 1852, 42579, 7, 342, 96, 11);
INSERT INTO public.who_global_data VALUES (22594, 12097, 545027, 49, 10530, 96, 89);
INSERT INTO public.who_global_data VALUES (22595, 0, 48055, 0, 320, 96, 24);
INSERT INTO public.who_global_data VALUES (22596, 4, 697, 0, 0, 96, 162);
INSERT INTO public.who_global_data VALUES (22597, 1678, 40929, 9, 635, 96, 100);
INSERT INTO public.who_global_data VALUES (22598, 0, 17, 0, 0, 96, 47);
INSERT INTO public.who_global_data VALUES (22599, 0, 28, 0, 0, 96, 29);
INSERT INTO public.who_global_data VALUES (22600, 0, 7742, 0, 126, 96, 40);
INSERT INTO public.who_global_data VALUES (22601, 9, 4641, 0, 79, 96, 222);
INSERT INTO public.who_global_data VALUES (22602, 165, 108104, 9, 3738, 96, 132);
INSERT INTO public.who_global_data VALUES (22603, 1, 268, 0, 13, 96, 130);
INSERT INTO public.who_global_data VALUES (22604, 123, 12195, 1, 73, 96, 234);
INSERT INTO public.who_global_data VALUES (22605, 0, 2413, 0, 41, 96, 23);
INSERT INTO public.who_global_data VALUES (22606, 19, 4162, 0, 124, 96, 192);
INSERT INTO public.who_global_data VALUES (22607, 0, 9054, 0, 232, 96, 69);
INSERT INTO public.who_global_data VALUES (22608, 0, 26, 0, 0, 96, 187);
INSERT INTO public.who_global_data VALUES (22609, 516, 97404, 3, 2672, 96, 230);
INSERT INTO public.who_global_data VALUES (22610, 3581, 82780, 70, 1889, 96, 77);
INSERT INTO public.who_global_data VALUES (22611, 25, 4890, 0, 12, 96, 9);
INSERT INTO public.who_global_data VALUES (22612, 45231, 8229313, 496, 122607, 96, 74);
INSERT INTO public.who_global_data VALUES (22613, 2696, 412784, 74, 13943, 96, 224);
INSERT INTO public.who_global_data VALUES (22614, 7719, 620491, 434, 35298, 96, 199);
INSERT INTO public.who_global_data VALUES (22615, 2658, 475288, 56, 10966, 96, 190);
INSERT INTO public.who_global_data VALUES (22616, 546, 62002, 2, 1915, 96, 12);
INSERT INTO public.who_global_data VALUES (22617, 0, 353, 0, 24, 96, 104);
INSERT INTO public.who_global_data VALUES (22618, 228, 314360, 25, 2566, 96, 153);
INSERT INTO public.who_global_data VALUES (22619, 29905, 709335, 208, 38826, 96, 91);
INSERT INTO public.who_global_data VALUES (22620, 37, 9131, 3, 209, 96, 215);
INSERT INTO public.who_global_data VALUES (22621, 667, 101813, 8, 1774, 96, 84);
INSERT INTO public.who_global_data VALUES (22622, 0, 574, 0, 32, 96, 231);
INSERT INTO public.who_global_data VALUES (22623, 3259, 75866, 37, 866, 96, 196);
INSERT INTO public.who_global_data VALUES (22624, 458, 151321, 0, 2259, 96, 105);
INSERT INTO public.who_global_data VALUES (22625, 685, 55877, 17, 1013, 96, 122);
INSERT INTO public.who_global_data VALUES (22626, 0, 0, 0, 0, 96, 159);
INSERT INTO public.who_global_data VALUES (22627, 337, 20136, 7, 678, 96, 75);
INSERT INTO public.who_global_data VALUES (22628, 608, 126534, 3, 782, 96, 27);
INSERT INTO public.who_global_data VALUES (22629, 436, 59879, 5, 1155, 96, 54);
INSERT INTO public.who_global_data VALUES (22630, 0, 24, 0, 0, 96, 226);
INSERT INTO public.who_global_data VALUES (22631, 242, 6136, 3, 74, 96, 79);
INSERT INTO public.who_global_data VALUES (22632, 1389, 82617, 6, 643, 96, 56);
INSERT INTO public.who_global_data VALUES (22633, 6, 1953, 1, 44, 96, 117);
INSERT INTO public.who_global_data VALUES (22634, 0, 1426, 0, 82, 96, 152);
INSERT INTO public.who_global_data VALUES (22635, 950, 62045, 14, 871, 96, 16);
INSERT INTO public.who_global_data VALUES (22636, 22, 623, 0, 3, 96, 10);
INSERT INTO public.who_global_data VALUES (22637, 834, 16532, 4, 160, 96, 201);
INSERT INTO public.who_global_data VALUES (22638, 849, 18782, 3, 160, 96, 174);
INSERT INTO public.who_global_data VALUES (22639, 0, 17111, 0, 244, 96, 119);
INSERT INTO public.who_global_data VALUES (22640, 2, 5932, 0, 184, 96, 168);
INSERT INTO public.who_global_data VALUES (22641, 957, 32505, 0, 249, 96, 99);
INSERT INTO public.who_global_data VALUES (22642, 42, 11701, 0, 38, 96, 171);
INSERT INTO public.who_global_data VALUES (22643, 11, 3565, 0, 136, 96, 87);
INSERT INTO public.who_global_data VALUES (22644, 218, 6390, 0, 61, 96, 123);
INSERT INTO public.who_global_data VALUES (22645, 0, 1, 0, 0, 96, 151);
INSERT INTO public.who_global_data VALUES (22646, 0, 3818, 0, 31, 96, 213);
INSERT INTO public.who_global_data VALUES (22647, 0, 7663, 0, 163, 96, 118);
INSERT INTO public.who_global_data VALUES (22648, 0, 441, 0, 10, 96, 134);
INSERT INTO public.who_global_data VALUES (22649, 0, 4366, 0, 44, 96, 65);
INSERT INTO public.who_global_data VALUES (22650, 6151, 924962, 464, 91753, 96, 102);
INSERT INTO public.who_global_data VALUES (22651, 0, 0, 0, 0, 96, 223);
INSERT INTO public.who_global_data VALUES (22652, 7, 369, 0, 2, 96, 4);
INSERT INTO public.who_global_data VALUES (22653, 0, 346, 0, 0, 96, 146);
INSERT INTO public.who_global_data VALUES (22654, 550, 20256, 7, 319, 96, 31);
INSERT INTO public.who_global_data VALUES (22655, 0, 13, 0, 1, 96, 127);
INSERT INTO public.who_global_data VALUES (22656, 3460, 222544, 67, 3762, 96, 22);
INSERT INTO public.who_global_data VALUES (22657, 119, 12988, 1, 93, 96, 115);
INSERT INTO public.who_global_data VALUES (22658, 699, 53405, 21, 1258, 96, 106);
INSERT INTO public.who_global_data VALUES (22659, 53, 12988, 0, 133, 96, 90);
INSERT INTO public.who_global_data VALUES (22660, 0, 0, 0, 0, 96, 70);
INSERT INTO public.who_global_data VALUES (22661, 2824, 173567, 23, 960, 96, 46);
INSERT INTO public.who_global_data VALUES (22662, 8682, 358942, 39, 7429, 96, 139);
INSERT INTO public.who_global_data VALUES (22663, 0, 28, 0, 0, 96, 42);
INSERT INTO public.who_global_data VALUES (22664, 4, 1607, 0, 25, 96, 80);
INSERT INTO public.who_global_data VALUES (22665, 0, 4424, 0, 156, 96, 203);
INSERT INTO public.who_global_data VALUES (22666, 1, 1221, 0, 69, 96, 136);
INSERT INTO public.who_global_data VALUES (22667, 111, 62964, 2, 1146, 96, 63);
INSERT INTO public.who_global_data VALUES (22668, 0, 0, 0, 0, 96, 17);
INSERT INTO public.who_global_data VALUES (22669, 0, 96, 0, 2, 96, 172);
INSERT INTO public.who_global_data VALUES (22670, 859, 32436, 10, 1004, 96, 109);
INSERT INTO public.who_global_data VALUES (22671, 0, 19563, 0, 282, 96, 200);
INSERT INTO public.who_global_data VALUES (22672, 540, 65802, 6, 561, 96, 93);
INSERT INTO public.who_global_data VALUES (22673, 1300, 115734, 38, 1246, 96, 5);
INSERT INTO public.who_global_data VALUES (22674, 0, 741, 0, 13, 96, 214);
INSERT INTO public.who_global_data VALUES (22675, 977, 333970, 17, 6823, 96, 204);
INSERT INTO public.who_global_data VALUES (22676, 0, 0, 0, 0, 96, 198);
INSERT INTO public.who_global_data VALUES (22677, 731, 133598, 12, 2700, 96, 173);
INSERT INTO public.who_global_data VALUES (22678, 1, 590, 0, 7, 96, 229);
INSERT INTO public.who_global_data VALUES (22679, 589, 63185, 17, 1404, 96, 76);
INSERT INTO public.who_global_data VALUES (22680, 2323, 902503, 65, 34476, 96, 138);
INSERT INTO public.who_global_data VALUES (22681, 2384, 383113, 17, 7238, 96, 98);
INSERT INTO public.who_global_data VALUES (22682, 0, 0, 0, 0, 96, 103);
INSERT INTO public.who_global_data VALUES (22683, 17171, 379902, 152, 5783, 96, 225);
INSERT INTO public.who_global_data VALUES (22684, 3062, 144341, 37, 2544, 96, 131);
INSERT INTO public.who_global_data VALUES (22685, 533, 66661, 10, 832, 96, 235);
INSERT INTO public.who_global_data VALUES (22686, 164, 132720, 0, 232, 96, 137);
INSERT INTO public.who_global_data VALUES (22687, 97, 26732, 2, 468, 96, 81);
INSERT INTO public.who_global_data VALUES (22688, 542, 76582, 15, 1800, 96, 182);
INSERT INTO public.who_global_data VALUES (22689, 0, 5659, 0, 22, 96, 145);
INSERT INTO public.who_global_data VALUES (22690, 5324, 246663, 99, 7067, 96, 26);
INSERT INTO public.who_global_data VALUES (22691, 18253, 1655034, 238, 28473, 96, 170);
INSERT INTO public.who_global_data VALUES (22692, 9, 5146, 0, 35, 96, 191);
INSERT INTO public.who_global_data VALUES (22693, 0, 5, 0, 0, 96, 221);
INSERT INTO public.who_global_data VALUES (22694, 0, 89, 0, 0, 96, 64);
INSERT INTO public.who_global_data VALUES (22695, 0, 0, 0, 0, 96, 116);
INSERT INTO public.who_global_data VALUES (22696, 0, 19, 0, 0, 96, 128);
INSERT INTO public.who_global_data VALUES (22697, 6, 84, 0, 0, 96, 6);
INSERT INTO public.who_global_data VALUES (22698, 0, 591, 0, 9, 96, 227);
INSERT INTO public.who_global_data VALUES (22699, 0, 12, 0, 0, 96, 68);
INSERT INTO public.who_global_data VALUES (22700, 1, 75, 0, 0, 96, 184);
INSERT INTO public.who_global_data VALUES (22701, 0, 0, 0, 0, 96, 82);
INSERT INTO public.who_global_data VALUES (22702, 0, 958, 0, 42, 96, 149);
INSERT INTO public.who_global_data VALUES (22703, 4, 949, 0, 16, 96, 197);
INSERT INTO public.who_global_data VALUES (22704, 374, 347656, 18, 5420, 96, 78);
INSERT INTO public.who_global_data VALUES (22705, 0, 15616, 0, 324, 96, 233);
INSERT INTO public.who_global_data VALUES (22706, 1449, 48403, 6, 826, 96, 133);
INSERT INTO public.who_global_data VALUES (22707, 0, 154, 0, 0, 96, 35);
INSERT INTO public.who_global_data VALUES (22708, 0, 2366, 0, 74, 96, 114);
INSERT INTO public.who_global_data VALUES (22709, 4, 58019, 0, 28, 96, 237);
INSERT INTO public.who_global_data VALUES (22710, 0, 14, 0, 0, 96, 55);
INSERT INTO public.who_global_data VALUES (22711, 0, 805, 0, 22, 96, 176);
INSERT INTO public.who_global_data VALUES (22712, 2282, 59946, 0, 219, 96, 202);
INSERT INTO public.who_global_data VALUES (22713, 557, 36219, 23, 441, 96, 155);
INSERT INTO public.who_global_data VALUES (22714, 0, 8, 0, 0, 96, 32);
INSERT INTO public.who_global_data VALUES (22715, 0, 3941, 0, 104, 96, 220);
INSERT INTO public.who_global_data VALUES (22716, 1371, 726823, 135, 19411, 96, 30);
INSERT INTO public.who_global_data VALUES (22717, 0, 2926, 0, 59, 96, 147);
INSERT INTO public.who_global_data VALUES (22718, 16480, 1310556, 234, 39100, 96, 208);
INSERT INTO public.who_global_data VALUES (22719, 397, 11060, 1, 21, 96, 45);
INSERT INTO public.who_global_data VALUES (22720, 15, 13819, 0, 837, 96, 110);
INSERT INTO public.who_global_data VALUES (22721, 2, 5203, 0, 111, 96, 88);
INSERT INTO public.who_global_data VALUES (22722, 2987, 132032, 13, 6034, 96, 51);
INSERT INTO public.who_global_data VALUES (22723, 3626, 179869, 59, 2345, 96, 209);
INSERT INTO public.who_global_data VALUES (22724, 61, 5789, 4, 292, 96, 205);
INSERT INTO public.who_global_data VALUES (22725, 37, 11054, 0, 82, 96, 18);
INSERT INTO public.who_global_data VALUES (22726, 3, 3787, 0, 59, 96, 72);
INSERT INTO public.who_global_data VALUES (22727, 23254, 1034918, 162, 46717, 96, 44);
INSERT INTO public.who_global_data VALUES (22728, 0, 30, 0, 0, 96, 15);
INSERT INTO public.who_global_data VALUES (22729, 61, 2357, 2, 57, 96, 25);
INSERT INTO public.who_global_data VALUES (22730, 0, 0, 0, 0, 96, 179);
INSERT INTO public.who_global_data VALUES (22731, 0, 0, 0, 0, 96, 34);
INSERT INTO public.who_global_data VALUES (22732, 36, 5704, 1, 108, 96, 207);
INSERT INTO public.who_global_data VALUES (22733, 791, 61906, 33, 1381, 96, 166);
INSERT INTO public.who_global_data VALUES (22734, 8836, 1030283, 74, 10326, 96, 126);
INSERT INTO public.who_global_data VALUES (22735, 0, 0, 0, 0, 96, 97);
INSERT INTO public.who_global_data VALUES (22736, 0, 703, 0, 6, 96, 36);
INSERT INTO public.who_global_data VALUES (22737, 0, 0, 0, 0, 96, 125);
INSERT INTO public.who_global_data VALUES (22738, 248, 12743, 1, 112, 96, 124);
INSERT INTO public.who_global_data VALUES (22739, 6754, 402194, 69, 7375, 96, 185);
INSERT INTO public.who_global_data VALUES (22740, 1278, 133907, 1, 496, 96, 194);
INSERT INTO public.who_global_data VALUES (22741, 0, 509, 0, 21, 96, 144);
INSERT INTO public.who_global_data VALUES (22742, 80379, 9032465, 813, 228998, 96, 19);
INSERT INTO public.who_global_data VALUES (22743, 0, 1376, 0, 21, 96, 217);
INSERT INTO public.who_global_data VALUES (22744, 42, 3124, 0, 58, 96, 148);
INSERT INTO public.who_global_data VALUES (22745, 199, 67254, 3, 571, 96, 86);
INSERT INTO public.who_global_data VALUES (22746, 0, 0, 0, 0, 96, 13);
INSERT INTO public.who_global_data VALUES (22747, 424, 92013, 5, 798, 96, 157);
INSERT INTO public.who_global_data VALUES (22748, 0, 1180, 0, 35, 96, 8);
INSERT INTO public.who_global_data VALUES (22749, 0, 1, 0, 0, 96, 73);
INSERT INTO public.who_global_data VALUES (22750, 0, 2067, 1, 601, 96, 101);
INSERT INTO public.who_global_data VALUES (22751, 48, 16480, 0, 349, 96, 165);
INSERT INTO public.who_global_data VALUES (22752, 7, 8374, 0, 243, 96, 14);
INSERT INTO public.who_global_data VALUES (22753, 91, 41425, 3, 1536, 97, 193);
INSERT INTO public.who_global_data VALUES (22754, 241, 20875, 7, 509, 97, 113);
INSERT INTO public.who_global_data VALUES (22755, 319, 57651, 7, 1956, 97, 143);
INSERT INTO public.who_global_data VALUES (22756, 0, 0, 0, 0, 97, 219);
INSERT INTO public.who_global_data VALUES (22757, 91, 4756, 0, 75, 97, 186);
INSERT INTO public.who_global_data VALUES (22758, 247, 10805, 5, 284, 97, 52);
INSERT INTO public.who_global_data VALUES (22759, 0, 3, 0, 0, 97, 180);
INSERT INTO public.who_global_data VALUES (22760, 0, 127, 0, 3, 97, 167);
INSERT INTO public.who_global_data VALUES (22761, 13379, 1157179, 350, 30792, 97, 154);
INSERT INTO public.who_global_data VALUES (22762, 2441, 91567, 22, 1358, 97, 94);
INSERT INTO public.who_global_data VALUES (22763, 0, 4472, 0, 37, 97, 66);
INSERT INTO public.who_global_data VALUES (22764, 8, 27590, 0, 907, 97, 58);
INSERT INTO public.who_global_data VALUES (22765, 5141, 106584, 18, 1097, 97, 163);
INSERT INTO public.who_global_data VALUES (22766, 1095, 55269, 12, 730, 97, 37);
INSERT INTO public.who_global_data VALUES (22767, 0, 6644, 0, 142, 97, 142);
INSERT INTO public.who_global_data VALUES (22768, 179, 81645, 2, 321, 97, 83);
INSERT INTO public.who_global_data VALUES (22769, 1320, 407684, 18, 5923, 97, 228);
INSERT INTO public.who_global_data VALUES (22770, 0, 236, 0, 7, 97, 188);
INSERT INTO public.who_global_data VALUES (22771, 1960, 99459, 8, 985, 97, 62);
INSERT INTO public.who_global_data VALUES (22772, 6308, 448807, 176, 11840, 97, 160);
INSERT INTO public.who_global_data VALUES (22773, 80, 3462, 2, 58, 97, 50);
INSERT INTO public.who_global_data VALUES (22774, 0, 2643, 0, 41, 97, 33);
INSERT INTO public.who_global_data VALUES (22775, 0, 199, 0, 9, 97, 183);
INSERT INTO public.who_global_data VALUES (22776, 1, 349, 0, 0, 97, 92);
INSERT INTO public.who_global_data VALUES (22777, 147, 141631, 10, 8715, 97, 158);
INSERT INTO public.who_global_data VALUES (22778, 0, 134, 0, 3, 97, 67);
INSERT INTO public.who_global_data VALUES (22779, 1937, 50090, 22, 1234, 97, 57);
INSERT INTO public.who_global_data VALUES (22780, 0, 6642, 0, 24, 97, 38);
INSERT INTO public.who_global_data VALUES (22781, 22282, 5516658, 508, 159477, 97, 141);
INSERT INTO public.who_global_data VALUES (22782, 0, 72, 0, 1, 97, 178);
INSERT INTO public.who_global_data VALUES (22783, 0, 148, 0, 3, 97, 108);
INSERT INTO public.who_global_data VALUES (22784, 1803, 52844, 25, 1279, 97, 39);
INSERT INTO public.who_global_data VALUES (22785, 23, 2500, 0, 67, 97, 2);
INSERT INTO public.who_global_data VALUES (22786, 4, 589, 0, 1, 97, 195);
INSERT INTO public.who_global_data VALUES (22787, 99, 8793, 0, 95, 97, 107);
INSERT INTO public.who_global_data VALUES (22788, 0, 291, 0, 0, 97, 161);
INSERT INTO public.who_global_data VALUES (22789, 0, 21793, 0, 426, 97, 212);
INSERT INTO public.who_global_data VALUES (22790, 3457, 231999, 36, 10110, 97, 181);
INSERT INTO public.who_global_data VALUES (22791, 0, 240, 0, 1, 97, 53);
INSERT INTO public.who_global_data VALUES (22792, 0, 4866, 0, 62, 97, 164);
INSERT INTO public.who_global_data VALUES (22793, 0, 1483, 0, 98, 97, 140);
INSERT INTO public.who_global_data VALUES (22794, 1685, 510256, 49, 14207, 97, 20);
INSERT INTO public.who_global_data VALUES (22795, 28, 91921, 0, 4746, 97, 112);
INSERT INTO public.who_global_data VALUES (22796, 10029, 1063151, 209, 31135, 97, 111);
INSERT INTO public.who_global_data VALUES (22797, 0, 530, 0, 7, 97, 71);
INSERT INTO public.who_global_data VALUES (22798, 0, 5290, 0, 92, 97, 218);
INSERT INTO public.who_global_data VALUES (22799, 0, 0, 0, 0, 97, 43);
INSERT INTO public.who_global_data VALUES (22800, 1296, 108866, 14, 1371, 97, 49);
INSERT INTO public.who_global_data VALUES (22801, 64, 20692, 0, 124, 97, 1);
INSERT INTO public.who_global_data VALUES (22802, 2769, 49316, 15, 546, 97, 48);
INSERT INTO public.who_global_data VALUES (22803, 86, 6887, 0, 128, 97, 232);
INSERT INTO public.who_global_data VALUES (22804, 0, 944, 0, 1, 97, 175);
INSERT INTO public.who_global_data VALUES (22805, 149, 4366, 1, 26, 97, 21);
INSERT INTO public.who_global_data VALUES (22806, 11429, 335102, 173, 3251, 97, 156);
INSERT INTO public.who_global_data VALUES (22807, 0, 0, 0, 0, 97, 95);
INSERT INTO public.who_global_data VALUES (22808, 0, 11305, 0, 307, 97, 177);
INSERT INTO public.who_global_data VALUES (22809, 1126, 46351, 2, 721, 97, 210);
INSERT INTO public.who_global_data VALUES (22810, 2, 5561, 0, 61, 97, 120);
INSERT INTO public.who_global_data VALUES (22811, 8, 50, 0, 0, 97, 135);
INSERT INTO public.who_global_data VALUES (22812, 686, 127018, 9, 2245, 97, 206);
INSERT INTO public.who_global_data VALUES (22813, 1045, 168192, 38, 12670, 97, 189);
INSERT INTO public.who_global_data VALUES (22814, 170, 107555, 8, 6266, 97, 129);
INSERT INTO public.who_global_data VALUES (22815, 0, 33445, 4, 975, 97, 121);
INSERT INTO public.who_global_data VALUES (22816, 5, 5088, 0, 83, 97, 59);
INSERT INTO public.who_global_data VALUES (22817, 0, 463, 0, 0, 97, 96);
INSERT INTO public.who_global_data VALUES (22818, 134, 4905, 0, 73, 97, 41);
INSERT INTO public.who_global_data VALUES (22819, 8, 5917, 0, 117, 97, 216);
INSERT INTO public.who_global_data VALUES (22820, 380, 96169, 5, 1469, 97, 236);
INSERT INTO public.who_global_data VALUES (22821, 0, 13, 0, 0, 97, 150);
INSERT INTO public.who_global_data VALUES (22822, 1, 495, 0, 0, 97, 61);
INSERT INTO public.who_global_data VALUES (22823, 0, 34, 0, 2, 97, 7);
INSERT INTO public.who_global_data VALUES (22824, 203, 16113, 0, 358, 97, 169);
INSERT INTO public.who_global_data VALUES (22825, 32530, 1331808, 223, 36473, 97, 28);
INSERT INTO public.who_global_data VALUES (22826, 111, 10536, 0, 70, 97, 85);
INSERT INTO public.who_global_data VALUES (22827, 0, 7262, 0, 29, 97, 211);
INSERT INTO public.who_global_data VALUES (22828, 11, 8968, 0, 55, 97, 60);
INSERT INTO public.who_global_data VALUES (22829, 4, 3670, 0, 119, 97, 3);
INSERT INTO public.who_global_data VALUES (22830, 1791, 40727, 28, 335, 97, 11);
INSERT INTO public.who_global_data VALUES (22831, 14177, 532930, 29, 10481, 97, 89);
INSERT INTO public.who_global_data VALUES (22832, 0, 48055, 0, 320, 97, 24);
INSERT INTO public.who_global_data VALUES (22833, 5, 693, 0, 0, 97, 162);
INSERT INTO public.who_global_data VALUES (22834, 2055, 39251, 6, 626, 97, 100);
INSERT INTO public.who_global_data VALUES (22835, 0, 17, 0, 0, 97, 47);
INSERT INTO public.who_global_data VALUES (22836, 0, 28, 0, 0, 97, 29);
INSERT INTO public.who_global_data VALUES (22837, 0, 7742, 0, 126, 97, 40);
INSERT INTO public.who_global_data VALUES (22838, 53, 4632, 0, 79, 97, 222);
INSERT INTO public.who_global_data VALUES (22839, 600, 107939, 15, 3729, 97, 132);
INSERT INTO public.who_global_data VALUES (22840, 0, 267, 0, 13, 97, 130);
INSERT INTO public.who_global_data VALUES (22841, 52, 12072, 1, 72, 97, 234);
INSERT INTO public.who_global_data VALUES (22842, 0, 2413, 0, 41, 97, 23);
INSERT INTO public.who_global_data VALUES (22843, 45, 4143, 1, 124, 97, 192);
INSERT INTO public.who_global_data VALUES (22844, 0, 9054, 0, 232, 97, 69);
INSERT INTO public.who_global_data VALUES (22845, 0, 26, 0, 0, 97, 187);
INSERT INTO public.who_global_data VALUES (22846, 738, 96888, 8, 2669, 97, 230);
INSERT INTO public.who_global_data VALUES (22847, 3878, 79199, 69, 1819, 97, 77);
INSERT INTO public.who_global_data VALUES (22848, 68, 4865, 0, 12, 97, 9);
INSERT INTO public.who_global_data VALUES (22849, 46963, 8184082, 470, 122111, 97, 74);
INSERT INTO public.who_global_data VALUES (22850, 3143, 410088, 87, 13869, 97, 224);
INSERT INTO public.who_global_data VALUES (22851, 7820, 612772, 386, 34864, 97, 199);
INSERT INTO public.who_global_data VALUES (22852, 1997, 472630, 48, 10910, 97, 190);
INSERT INTO public.who_global_data VALUES (22853, 397, 61456, 5, 1913, 97, 12);
INSERT INTO public.who_global_data VALUES (22854, 1, 353, 0, 24, 97, 104);
INSERT INTO public.who_global_data VALUES (22855, 680, 314132, 12, 2541, 97, 153);
INSERT INTO public.who_global_data VALUES (22856, 31756, 679430, 297, 38618, 97, 91);
INSERT INTO public.who_global_data VALUES (22857, 89, 9094, 1, 206, 97, 215);
INSERT INTO public.who_global_data VALUES (22858, 754, 101146, 11, 1766, 97, 84);
INSERT INTO public.who_global_data VALUES (22859, 5, 574, 0, 32, 97, 231);
INSERT INTO public.who_global_data VALUES (22860, 3301, 72607, 57, 829, 97, 196);
INSERT INTO public.who_global_data VALUES (22861, 483, 150863, 40, 2259, 97, 105);
INSERT INTO public.who_global_data VALUES (22862, 1395, 55192, 15, 996, 97, 122);
INSERT INTO public.who_global_data VALUES (22863, 0, 0, 0, 0, 97, 159);
INSERT INTO public.who_global_data VALUES (22864, 514, 19799, 3, 671, 97, 75);
INSERT INTO public.who_global_data VALUES (22865, 589, 125926, 6, 779, 97, 27);
INSERT INTO public.who_global_data VALUES (22866, 565, 59443, 5, 1150, 97, 54);
INSERT INTO public.who_global_data VALUES (22867, 0, 24, 0, 0, 97, 226);
INSERT INTO public.who_global_data VALUES (22868, 215, 5894, 2, 71, 97, 79);
INSERT INTO public.who_global_data VALUES (22869, 1699, 81228, 12, 637, 97, 56);
INSERT INTO public.who_global_data VALUES (22870, 0, 1947, 0, 43, 97, 117);
INSERT INTO public.who_global_data VALUES (22871, 0, 1426, 0, 82, 97, 152);
INSERT INTO public.who_global_data VALUES (22872, 467, 61095, 10, 857, 97, 16);
INSERT INTO public.who_global_data VALUES (22873, 25, 601, 0, 3, 97, 10);
INSERT INTO public.who_global_data VALUES (22874, 883, 15698, 3, 156, 97, 201);
INSERT INTO public.who_global_data VALUES (22875, 799, 17933, 5, 157, 97, 174);
INSERT INTO public.who_global_data VALUES (22876, 143, 17111, 0, 244, 97, 119);
INSERT INTO public.who_global_data VALUES (22877, 7, 5930, 0, 184, 97, 168);
INSERT INTO public.who_global_data VALUES (22878, 659, 31548, 0, 249, 97, 99);
INSERT INTO public.who_global_data VALUES (22879, 16, 11659, 1, 38, 97, 171);
INSERT INTO public.who_global_data VALUES (22880, 9, 3554, 0, 136, 97, 87);
INSERT INTO public.who_global_data VALUES (22881, 140, 6172, 2, 61, 97, 123);
INSERT INTO public.who_global_data VALUES (22882, 0, 1, 0, 0, 97, 151);
INSERT INTO public.who_global_data VALUES (22883, 0, 3818, 0, 31, 97, 213);
INSERT INTO public.who_global_data VALUES (22884, 0, 7663, 0, 163, 97, 118);
INSERT INTO public.who_global_data VALUES (22885, 0, 441, 0, 10, 97, 134);
INSERT INTO public.who_global_data VALUES (22886, 0, 4366, 0, 44, 97, 65);
INSERT INTO public.who_global_data VALUES (22887, 6000, 918811, 516, 91289, 97, 102);
INSERT INTO public.who_global_data VALUES (22888, 0, 0, 0, 0, 97, 223);
INSERT INTO public.who_global_data VALUES (22889, 4, 362, 0, 2, 97, 4);
INSERT INTO public.who_global_data VALUES (22890, 6, 346, 0, 0, 97, 146);
INSERT INTO public.who_global_data VALUES (22891, 357, 19706, 11, 312, 97, 31);
INSERT INTO public.who_global_data VALUES (22892, 0, 13, 0, 1, 97, 127);
INSERT INTO public.who_global_data VALUES (22893, 3790, 219084, 70, 3695, 97, 22);
INSERT INTO public.who_global_data VALUES (22894, 92, 12869, 1, 92, 97, 115);
INSERT INTO public.who_global_data VALUES (22895, 1210, 52706, 18, 1237, 97, 106);
INSERT INTO public.who_global_data VALUES (22896, 28, 12935, 0, 133, 97, 90);
INSERT INTO public.who_global_data VALUES (22897, 0, 0, 0, 0, 97, 70);
INSERT INTO public.who_global_data VALUES (22898, 2508, 170743, 17, 937, 97, 46);
INSERT INTO public.who_global_data VALUES (22899, 9773, 350260, 51, 7390, 97, 139);
INSERT INTO public.who_global_data VALUES (22900, 0, 28, 0, 0, 97, 42);
INSERT INTO public.who_global_data VALUES (22901, 2, 1603, 0, 25, 97, 80);
INSERT INTO public.who_global_data VALUES (22902, 0, 4424, 0, 156, 97, 203);
INSERT INTO public.who_global_data VALUES (22903, 0, 1220, 0, 69, 97, 136);
INSERT INTO public.who_global_data VALUES (22904, 162, 62853, 0, 1144, 97, 63);
INSERT INTO public.who_global_data VALUES (22905, 0, 0, 0, 0, 97, 17);
INSERT INTO public.who_global_data VALUES (22906, 4, 96, 0, 2, 97, 172);
INSERT INTO public.who_global_data VALUES (22907, 1089, 31577, 12, 994, 97, 109);
INSERT INTO public.who_global_data VALUES (22908, 0, 19563, 0, 282, 97, 200);
INSERT INTO public.who_global_data VALUES (22909, 521, 65262, 2, 555, 97, 93);
INSERT INTO public.who_global_data VALUES (22910, 0, 114434, 0, 1208, 97, 5);
INSERT INTO public.who_global_data VALUES (22911, 0, 741, 0, 13, 97, 214);
INSERT INTO public.who_global_data VALUES (22912, 807, 332993, 11, 6806, 97, 204);
INSERT INTO public.who_global_data VALUES (22913, 0, 0, 0, 0, 97, 198);
INSERT INTO public.who_global_data VALUES (22914, 822, 132867, 10, 2688, 97, 173);
INSERT INTO public.who_global_data VALUES (22915, 0, 589, 0, 7, 97, 229);
INSERT INTO public.who_global_data VALUES (22916, 546, 62596, 14, 1387, 97, 76);
INSERT INTO public.who_global_data VALUES (22917, 2586, 900180, 49, 34411, 97, 138);
INSERT INTO public.who_global_data VALUES (22918, 1796, 380729, 36, 7221, 97, 98);
INSERT INTO public.who_global_data VALUES (22919, 0, 0, 0, 0, 97, 103);
INSERT INTO public.who_global_data VALUES (22920, 21897, 362731, 280, 5631, 97, 225);
INSERT INTO public.who_global_data VALUES (22921, 4007, 141279, 39, 2507, 97, 131);
INSERT INTO public.who_global_data VALUES (22922, 385, 66128, 2, 822, 97, 235);
INSERT INTO public.who_global_data VALUES (22923, 213, 132556, 0, 232, 97, 137);
INSERT INTO public.who_global_data VALUES (22924, 124, 26635, 2, 466, 97, 81);
INSERT INTO public.who_global_data VALUES (22925, 839, 76040, 19, 1785, 97, 182);
INSERT INTO public.who_global_data VALUES (22926, 0, 5659, 0, 22, 97, 145);
INSERT INTO public.who_global_data VALUES (22927, 5753, 241339, 101, 6968, 97, 26);
INSERT INTO public.who_global_data VALUES (22928, 18665, 1636781, 245, 28235, 97, 170);
INSERT INTO public.who_global_data VALUES (22929, 3, 5137, 0, 35, 97, 191);
INSERT INTO public.who_global_data VALUES (22930, 0, 5, 0, 0, 97, 221);
INSERT INTO public.who_global_data VALUES (22931, 0, 89, 0, 0, 97, 64);
INSERT INTO public.who_global_data VALUES (22932, 0, 0, 0, 0, 97, 116);
INSERT INTO public.who_global_data VALUES (22933, 0, 19, 0, 0, 97, 128);
INSERT INTO public.who_global_data VALUES (22934, 2, 78, 0, 0, 97, 6);
INSERT INTO public.who_global_data VALUES (22935, 0, 591, 0, 9, 97, 227);
INSERT INTO public.who_global_data VALUES (22936, 0, 12, 0, 0, 97, 68);
INSERT INTO public.who_global_data VALUES (22937, 0, 74, 0, 0, 97, 184);
INSERT INTO public.who_global_data VALUES (22938, 0, 0, 0, 0, 97, 82);
INSERT INTO public.who_global_data VALUES (22939, 0, 958, 0, 42, 97, 149);
INSERT INTO public.who_global_data VALUES (22940, 0, 945, 0, 16, 97, 197);
INSERT INTO public.who_global_data VALUES (22941, 402, 347282, 19, 5402, 97, 78);
INSERT INTO public.who_global_data VALUES (22942, 23, 15616, 1, 324, 97, 233);
INSERT INTO public.who_global_data VALUES (22943, 1817, 46954, 6, 820, 97, 133);
INSERT INTO public.who_global_data VALUES (22944, 2, 154, 0, 0, 97, 35);
INSERT INTO public.who_global_data VALUES (22945, 1, 2366, 0, 74, 97, 114);
INSERT INTO public.who_global_data VALUES (22946, 12, 58015, 0, 28, 97, 237);
INSERT INTO public.who_global_data VALUES (22947, 0, 14, 0, 0, 97, 55);
INSERT INTO public.who_global_data VALUES (22948, 0, 805, 0, 22, 97, 176);
INSERT INTO public.who_global_data VALUES (22949, 2573, 57664, 7, 219, 97, 202);
INSERT INTO public.who_global_data VALUES (22950, 1347, 35662, 27, 418, 97, 155);
INSERT INTO public.who_global_data VALUES (22951, 0, 8, 0, 0, 97, 32);
INSERT INTO public.who_global_data VALUES (22952, 0, 3941, 0, 104, 97, 220);
INSERT INTO public.who_global_data VALUES (22953, 1770, 725452, 46, 19276, 97, 30);
INSERT INTO public.who_global_data VALUES (22954, 21, 2926, 1, 59, 97, 147);
INSERT INTO public.who_global_data VALUES (22955, 25591, 1294076, 232, 38866, 97, 208);
INSERT INTO public.who_global_data VALUES (22956, 239, 10663, 1, 20, 97, 45);
INSERT INTO public.who_global_data VALUES (22957, 0, 13804, 0, 837, 97, 110);
INSERT INTO public.who_global_data VALUES (22958, 4, 5201, 0, 111, 97, 88);
INSERT INTO public.who_global_data VALUES (22959, 4056, 129045, 9, 6021, 97, 51);
INSERT INTO public.who_global_data VALUES (22960, 5128, 176243, 58, 2286, 97, 209);
INSERT INTO public.who_global_data VALUES (22961, 45, 5728, 3, 288, 97, 205);
INSERT INTO public.who_global_data VALUES (22962, 40, 11017, 0, 82, 97, 18);
INSERT INTO public.who_global_data VALUES (22963, 4, 3784, 0, 59, 97, 72);
INSERT INTO public.who_global_data VALUES (22964, 21915, 1011664, 326, 46555, 97, 44);
INSERT INTO public.who_global_data VALUES (22965, 0, 30, 0, 0, 97, 15);
INSERT INTO public.who_global_data VALUES (22966, 0, 2296, 0, 55, 97, 25);
INSERT INTO public.who_global_data VALUES (22967, 0, 0, 0, 0, 97, 179);
INSERT INTO public.who_global_data VALUES (22968, 0, 0, 0, 0, 97, 34);
INSERT INTO public.who_global_data VALUES (22969, 32, 5668, 0, 107, 97, 207);
INSERT INTO public.who_global_data VALUES (22970, 1302, 61115, 31, 1348, 97, 166);
INSERT INTO public.who_global_data VALUES (22971, 8943, 1021447, 75, 10252, 97, 126);
INSERT INTO public.who_global_data VALUES (22972, 0, 0, 0, 0, 97, 97);
INSERT INTO public.who_global_data VALUES (22973, 0, 703, 0, 6, 97, 36);
INSERT INTO public.who_global_data VALUES (22974, 0, 0, 0, 0, 97, 125);
INSERT INTO public.who_global_data VALUES (22975, 85, 12495, 1, 111, 97, 124);
INSERT INTO public.who_global_data VALUES (22976, 7959, 395440, 110, 7306, 97, 185);
INSERT INTO public.who_global_data VALUES (22977, 1121, 132629, 5, 495, 97, 194);
INSERT INTO public.who_global_data VALUES (22978, 0, 509, 0, 21, 97, 144);
INSERT INTO public.who_global_data VALUES (22979, 99356, 8952086, 1007, 228185, 97, 19);
INSERT INTO public.who_global_data VALUES (22980, 14, 1376, 0, 21, 97, 217);
INSERT INTO public.who_global_data VALUES (22981, 38, 3082, 1, 58, 97, 148);
INSERT INTO public.who_global_data VALUES (22982, 254, 67055, 4, 568, 97, 86);
INSERT INTO public.who_global_data VALUES (22983, 0, 0, 0, 0, 97, 13);
INSERT INTO public.who_global_data VALUES (22984, 309, 91589, 4, 793, 97, 157);
INSERT INTO public.who_global_data VALUES (22985, 3, 1180, 0, 35, 97, 8);
INSERT INTO public.who_global_data VALUES (22986, 0, 1, 0, 0, 97, 73);
INSERT INTO public.who_global_data VALUES (22987, 1, 2067, 0, 600, 97, 101);
INSERT INTO public.who_global_data VALUES (22988, 17, 16432, 0, 349, 97, 165);
INSERT INTO public.who_global_data VALUES (22989, 5, 8367, 1, 243, 97, 14);
INSERT INTO public.who_global_data VALUES (22990, 66, 41334, 1, 1533, 98, 193);
INSERT INTO public.who_global_data VALUES (22991, 319, 20634, 3, 502, 98, 113);
INSERT INTO public.who_global_data VALUES (22992, 306, 57332, 8, 1949, 98, 143);
INSERT INTO public.who_global_data VALUES (22993, 0, 0, 0, 0, 98, 219);
INSERT INTO public.who_global_data VALUES (22994, 98, 4665, 2, 75, 98, 186);
INSERT INTO public.who_global_data VALUES (22995, 289, 10558, 4, 279, 98, 52);
INSERT INTO public.who_global_data VALUES (22996, 0, 3, 0, 0, 98, 180);
INSERT INTO public.who_global_data VALUES (22997, 3, 127, 0, 3, 98, 167);
INSERT INTO public.who_global_data VALUES (22998, 13267, 1143800, 371, 30442, 98, 154);
INSERT INTO public.who_global_data VALUES (22999, 2381, 89126, 41, 1336, 98, 94);
INSERT INTO public.who_global_data VALUES (23000, 17, 4472, 0, 37, 98, 66);
INSERT INTO public.who_global_data VALUES (23001, 13, 27582, 0, 907, 98, 58);
INSERT INTO public.who_global_data VALUES (23002, 5243, 101443, 15, 1079, 98, 163);
INSERT INTO public.who_global_data VALUES (23003, 1022, 54174, 10, 718, 98, 37);
INSERT INTO public.who_global_data VALUES (23004, 37, 6644, 4, 142, 98, 142);
INSERT INTO public.who_global_data VALUES (23005, 204, 81466, 2, 319, 98, 83);
INSERT INTO public.who_global_data VALUES (23006, 1604, 406364, 19, 5905, 98, 228);
INSERT INTO public.who_global_data VALUES (23007, 1, 236, 0, 7, 98, 188);
INSERT INTO public.who_global_data VALUES (23008, 970, 97499, 4, 977, 98, 62);
INSERT INTO public.who_global_data VALUES (23009, 15403, 442499, 184, 11664, 98, 160);
INSERT INTO public.who_global_data VALUES (23010, 121, 3382, 4, 56, 98, 50);
INSERT INTO public.who_global_data VALUES (23011, 0, 2643, 0, 41, 98, 33);
INSERT INTO public.who_global_data VALUES (23012, 1, 199, 0, 9, 98, 183);
INSERT INTO public.who_global_data VALUES (23013, 2, 348, 0, 0, 98, 92);
INSERT INTO public.who_global_data VALUES (23014, 163, 141484, 11, 8705, 98, 158);
INSERT INTO public.who_global_data VALUES (23015, 0, 134, 0, 3, 98, 67);
INSERT INTO public.who_global_data VALUES (23016, 1485, 48153, 30, 1212, 98, 57);
INSERT INTO public.who_global_data VALUES (23017, 0, 6642, 0, 24, 98, 38);
INSERT INTO public.who_global_data VALUES (23018, 26106, 5494376, 513, 158969, 98, 141);
INSERT INTO public.who_global_data VALUES (23019, 0, 72, 0, 1, 98, 178);
INSERT INTO public.who_global_data VALUES (23020, 0, 148, 0, 3, 98, 108);
INSERT INTO public.who_global_data VALUES (23021, 2891, 51041, 29, 1254, 98, 39);
INSERT INTO public.who_global_data VALUES (23022, 0, 2477, 0, 67, 98, 2);
INSERT INTO public.who_global_data VALUES (23023, 3, 585, 0, 1, 98, 195);
INSERT INTO public.who_global_data VALUES (23024, 91, 8694, 0, 95, 98, 107);
INSERT INTO public.who_global_data VALUES (23025, 0, 291, 0, 0, 98, 161);
INSERT INTO public.who_global_data VALUES (23026, 0, 21793, 0, 426, 98, 212);
INSERT INTO public.who_global_data VALUES (23027, 2956, 228542, 42, 10074, 98, 181);
INSERT INTO public.who_global_data VALUES (23028, 1, 240, 0, 1, 98, 53);
INSERT INTO public.who_global_data VALUES (23029, 0, 4866, 0, 62, 98, 164);
INSERT INTO public.who_global_data VALUES (23030, 10, 1483, 1, 98, 98, 140);
INSERT INTO public.who_global_data VALUES (23031, 1521, 508571, 40, 14158, 98, 20);
INSERT INTO public.who_global_data VALUES (23032, 41, 91893, 0, 4746, 98, 112);
INSERT INTO public.who_global_data VALUES (23033, 11187, 1053122, 173, 30926, 98, 111);
INSERT INTO public.who_global_data VALUES (23034, 0, 530, 0, 7, 98, 71);
INSERT INTO public.who_global_data VALUES (23035, 0, 5290, 0, 92, 98, 218);
INSERT INTO public.who_global_data VALUES (23036, 0, 0, 0, 0, 98, 43);
INSERT INTO public.who_global_data VALUES (23037, 1017, 107570, 17, 1357, 98, 49);
INSERT INTO public.who_global_data VALUES (23038, 0, 20628, 0, 124, 98, 1);
INSERT INTO public.who_global_data VALUES (23039, 2772, 46547, 20, 531, 98, 48);
INSERT INTO public.who_global_data VALUES (23040, 35, 6801, 0, 128, 98, 232);
INSERT INTO public.who_global_data VALUES (23041, 37, 944, 0, 1, 98, 175);
INSERT INTO public.who_global_data VALUES (23042, 166, 4217, 0, 25, 98, 21);
INSERT INTO public.who_global_data VALUES (23043, 13605, 323673, 216, 3078, 98, 156);
INSERT INTO public.who_global_data VALUES (23044, 0, 0, 0, 0, 98, 95);
INSERT INTO public.who_global_data VALUES (23045, 53, 11305, 2, 307, 98, 177);
INSERT INTO public.who_global_data VALUES (23046, 1191, 45225, 3, 719, 98, 210);
INSERT INTO public.who_global_data VALUES (23047, 1, 5559, 0, 61, 98, 120);
INSERT INTO public.who_global_data VALUES (23048, 0, 42, 0, 0, 98, 135);
INSERT INTO public.who_global_data VALUES (23049, 419, 126332, 2, 2236, 98, 206);
INSERT INTO public.who_global_data VALUES (23050, 845, 167147, 10, 12632, 98, 189);
INSERT INTO public.who_global_data VALUES (23051, 176, 107385, 11, 6258, 98, 129);
INSERT INTO public.who_global_data VALUES (23052, 0, 33445, 4, 971, 98, 121);
INSERT INTO public.who_global_data VALUES (23053, 0, 5083, 0, 83, 98, 59);
INSERT INTO public.who_global_data VALUES (23054, 2, 463, 0, 0, 98, 96);
INSERT INTO public.who_global_data VALUES (23055, 100, 4771, 0, 73, 98, 41);
INSERT INTO public.who_global_data VALUES (23056, 10, 5909, 0, 117, 98, 216);
INSERT INTO public.who_global_data VALUES (23057, 488, 95789, 7, 1464, 98, 236);
INSERT INTO public.who_global_data VALUES (23058, 0, 13, 0, 0, 98, 150);
INSERT INTO public.who_global_data VALUES (23059, 0, 494, 0, 0, 98, 61);
INSERT INTO public.who_global_data VALUES (23060, 1, 34, 0, 2, 98, 7);
INSERT INTO public.who_global_data VALUES (23061, 344, 15910, 4, 358, 98, 169);
INSERT INTO public.who_global_data VALUES (23062, 48573, 1299278, 531, 36250, 98, 28);
INSERT INTO public.who_global_data VALUES (23063, 0, 10425, 0, 70, 98, 85);
INSERT INTO public.who_global_data VALUES (23064, 0, 7262, 0, 29, 98, 211);
INSERT INTO public.who_global_data VALUES (23065, 0, 8957, 0, 55, 98, 60);
INSERT INTO public.who_global_data VALUES (23066, 0, 3666, 0, 119, 98, 3);
INSERT INTO public.who_global_data VALUES (23067, 1673, 38936, 22, 307, 98, 11);
INSERT INTO public.who_global_data VALUES (23068, 19059, 518753, 103, 10452, 98, 89);
INSERT INTO public.who_global_data VALUES (23069, 0, 48055, 0, 320, 98, 24);
INSERT INTO public.who_global_data VALUES (23070, 6, 688, 0, 0, 98, 162);
INSERT INTO public.who_global_data VALUES (23071, 1686, 37196, 5, 620, 98, 100);
INSERT INTO public.who_global_data VALUES (23072, 0, 17, 0, 0, 98, 47);
INSERT INTO public.who_global_data VALUES (23073, 0, 28, 0, 0, 98, 29);
INSERT INTO public.who_global_data VALUES (23074, 137, 7742, 0, 126, 98, 40);
INSERT INTO public.who_global_data VALUES (23075, 75, 4579, 1, 79, 98, 222);
INSERT INTO public.who_global_data VALUES (23076, 549, 107339, 10, 3714, 98, 132);
INSERT INTO public.who_global_data VALUES (23077, 0, 267, 0, 13, 98, 130);
INSERT INTO public.who_global_data VALUES (23078, 0, 12020, 0, 71, 98, 234);
INSERT INTO public.who_global_data VALUES (23079, 10, 2413, 0, 41, 98, 23);
INSERT INTO public.who_global_data VALUES (23080, 24, 4098, 0, 123, 98, 192);
INSERT INTO public.who_global_data VALUES (23081, 0, 9054, 0, 232, 98, 69);
INSERT INTO public.who_global_data VALUES (23082, 0, 26, 0, 0, 98, 187);
INSERT INTO public.who_global_data VALUES (23083, 951, 96150, 9, 2661, 98, 230);
INSERT INTO public.who_global_data VALUES (23084, 3908, 75321, 51, 1750, 98, 77);
INSERT INTO public.who_global_data VALUES (23085, 78, 4797, 0, 12, 98, 9);
INSERT INTO public.who_global_data VALUES (23086, 48268, 8137119, 551, 121641, 98, 74);
INSERT INTO public.who_global_data VALUES (23087, 2897, 406945, 81, 13782, 98, 224);
INSERT INTO public.who_global_data VALUES (23088, 8011, 604952, 365, 34478, 98, 199);
INSERT INTO public.who_global_data VALUES (23089, 2878, 470633, 47, 10862, 98, 190);
INSERT INTO public.who_global_data VALUES (23090, 762, 61059, 6, 1908, 98, 12);
INSERT INTO public.who_global_data VALUES (23091, 0, 352, 0, 24, 98, 104);
INSERT INTO public.who_global_data VALUES (23092, 644, 313452, 19, 2529, 98, 153);
INSERT INTO public.who_global_data VALUES (23093, 31079, 647674, 199, 38321, 98, 91);
INSERT INTO public.who_global_data VALUES (23094, 78, 9005, 3, 205, 98, 215);
INSERT INTO public.who_global_data VALUES (23095, 770, 100392, 11, 1755, 98, 84);
INSERT INTO public.who_global_data VALUES (23096, 4, 569, 0, 32, 98, 231);
INSERT INTO public.who_global_data VALUES (23097, 3921, 69306, 32, 772, 98, 196);
INSERT INTO public.who_global_data VALUES (23098, 681, 150380, 0, 2219, 98, 105);
INSERT INTO public.who_global_data VALUES (23099, 1185, 53797, 17, 981, 98, 122);
INSERT INTO public.who_global_data VALUES (23100, 0, 0, 0, 0, 98, 159);
INSERT INTO public.who_global_data VALUES (23101, 418, 19285, 4, 668, 98, 75);
INSERT INTO public.who_global_data VALUES (23102, 671, 125337, 6, 773, 98, 27);
INSERT INTO public.who_global_data VALUES (23103, 484, 58878, 3, 1145, 98, 54);
INSERT INTO public.who_global_data VALUES (23104, 0, 24, 0, 0, 98, 226);
INSERT INTO public.who_global_data VALUES (23105, 284, 5679, 5, 69, 98, 79);
INSERT INTO public.who_global_data VALUES (23106, 1751, 79529, 15, 625, 98, 56);
INSERT INTO public.who_global_data VALUES (23107, 0, 1947, 0, 43, 98, 117);
INSERT INTO public.who_global_data VALUES (23108, 0, 1426, 0, 82, 98, 152);
INSERT INTO public.who_global_data VALUES (23109, 972, 60628, 16, 847, 98, 16);
INSERT INTO public.who_global_data VALUES (23110, 29, 576, 1, 3, 98, 10);
INSERT INTO public.who_global_data VALUES (23111, 1000, 14815, 8, 153, 98, 201);
INSERT INTO public.who_global_data VALUES (23112, 778, 17134, 2, 152, 98, 174);
INSERT INTO public.who_global_data VALUES (23113, 0, 16968, 0, 244, 98, 119);
INSERT INTO public.who_global_data VALUES (23114, 7, 5923, 0, 184, 98, 168);
INSERT INTO public.who_global_data VALUES (23115, 799, 30889, 3, 249, 98, 99);
INSERT INTO public.who_global_data VALUES (23116, 27, 11643, 0, 37, 98, 171);
INSERT INTO public.who_global_data VALUES (23117, 8, 3545, 0, 136, 98, 87);
INSERT INTO public.who_global_data VALUES (23118, 100, 6032, 2, 59, 98, 123);
INSERT INTO public.who_global_data VALUES (23119, 0, 1, 0, 0, 98, 151);
INSERT INTO public.who_global_data VALUES (23120, 266, 3818, 1, 31, 98, 213);
INSERT INTO public.who_global_data VALUES (23121, 0, 7663, 0, 163, 98, 118);
INSERT INTO public.who_global_data VALUES (23122, 0, 441, 0, 10, 98, 134);
INSERT INTO public.who_global_data VALUES (23123, 0, 4366, 0, 44, 98, 65);
INSERT INTO public.who_global_data VALUES (23124, 5948, 912811, 464, 90773, 98, 102);
INSERT INTO public.who_global_data VALUES (23125, 0, 0, 0, 0, 98, 223);
INSERT INTO public.who_global_data VALUES (23126, 8, 358, 0, 2, 98, 4);
INSERT INTO public.who_global_data VALUES (23127, 0, 340, 0, 0, 98, 146);
INSERT INTO public.who_global_data VALUES (23128, 342, 19349, 7, 301, 98, 31);
INSERT INTO public.who_global_data VALUES (23129, 0, 13, 0, 1, 98, 127);
INSERT INTO public.who_global_data VALUES (23130, 3256, 215294, 53, 3625, 98, 22);
INSERT INTO public.who_global_data VALUES (23131, 252, 12777, 0, 91, 98, 115);
INSERT INTO public.who_global_data VALUES (23132, 1093, 51496, 20, 1219, 98, 106);
INSERT INTO public.who_global_data VALUES (23133, 49, 12907, 0, 133, 98, 90);
INSERT INTO public.who_global_data VALUES (23134, 0, 0, 0, 0, 98, 70);
INSERT INTO public.who_global_data VALUES (23135, 3517, 168235, 16, 920, 98, 46);
INSERT INTO public.who_global_data VALUES (23136, 11071, 340487, 86, 7339, 98, 139);
INSERT INTO public.who_global_data VALUES (23137, 1, 28, 0, 0, 98, 42);
INSERT INTO public.who_global_data VALUES (23138, 7, 1601, 0, 25, 98, 80);
INSERT INTO public.who_global_data VALUES (23139, 0, 4424, 0, 156, 98, 203);
INSERT INTO public.who_global_data VALUES (23140, 1, 1220, 0, 69, 98, 136);
INSERT INTO public.who_global_data VALUES (23141, 170, 62691, 3, 1144, 98, 63);
INSERT INTO public.who_global_data VALUES (23142, 0, 0, 0, 0, 98, 17);
INSERT INTO public.who_global_data VALUES (23143, 0, 92, 0, 2, 98, 172);
INSERT INTO public.who_global_data VALUES (23144, 930, 30488, 5, 982, 98, 109);
INSERT INTO public.who_global_data VALUES (23145, 497, 19563, 1, 282, 98, 200);
INSERT INTO public.who_global_data VALUES (23146, 504, 64741, 8, 553, 98, 93);
INSERT INTO public.who_global_data VALUES (23147, 0, 114434, 0, 1208, 98, 5);
INSERT INTO public.who_global_data VALUES (23148, 0, 741, 0, 13, 98, 214);
INSERT INTO public.who_global_data VALUES (23149, 1078, 332186, 20, 6795, 98, 204);
INSERT INTO public.who_global_data VALUES (23150, 0, 0, 0, 0, 98, 198);
INSERT INTO public.who_global_data VALUES (23151, 798, 132045, 15, 2678, 98, 173);
INSERT INTO public.who_global_data VALUES (23152, 0, 589, 0, 7, 98, 229);
INSERT INTO public.who_global_data VALUES (23153, 760, 62050, 14, 1373, 98, 76);
INSERT INTO public.who_global_data VALUES (23154, 2666, 897594, 47, 34362, 98, 138);
INSERT INTO public.who_global_data VALUES (23155, 1998, 378933, 38, 7185, 98, 98);
INSERT INTO public.who_global_data VALUES (23156, 0, 0, 0, 0, 98, 103);
INSERT INTO public.who_global_data VALUES (23157, 21629, 340834, 202, 5351, 98, 225);
INSERT INTO public.who_global_data VALUES (23158, 4656, 137272, 40, 2468, 98, 131);
INSERT INTO public.who_global_data VALUES (23159, 945, 65743, 6, 820, 98, 235);
INSERT INTO public.who_global_data VALUES (23160, 193, 132343, 1, 232, 98, 137);
INSERT INTO public.who_global_data VALUES (23161, 127, 26511, 1, 464, 98, 81);
INSERT INTO public.who_global_data VALUES (23162, 968, 75201, 19, 1766, 98, 182);
INSERT INTO public.who_global_data VALUES (23163, 187, 5659, 0, 22, 98, 145);
INSERT INTO public.who_global_data VALUES (23164, 6546, 235586, 103, 6867, 98, 26);
INSERT INTO public.who_global_data VALUES (23165, 18140, 1618116, 334, 27990, 98, 170);
INSERT INTO public.who_global_data VALUES (23166, 3, 5134, 0, 35, 98, 191);
INSERT INTO public.who_global_data VALUES (23167, 0, 5, 0, 0, 98, 221);
INSERT INTO public.who_global_data VALUES (23168, 6, 89, 0, 0, 98, 64);
INSERT INTO public.who_global_data VALUES (23169, 0, 0, 0, 0, 98, 116);
INSERT INTO public.who_global_data VALUES (23170, 0, 19, 0, 0, 98, 128);
INSERT INTO public.who_global_data VALUES (23171, 0, 76, 0, 0, 98, 6);
INSERT INTO public.who_global_data VALUES (23172, 25, 591, 0, 9, 98, 227);
INSERT INTO public.who_global_data VALUES (23173, 0, 12, 0, 0, 98, 68);
INSERT INTO public.who_global_data VALUES (23174, 0, 74, 0, 0, 98, 184);
INSERT INTO public.who_global_data VALUES (23175, 0, 0, 0, 0, 98, 82);
INSERT INTO public.who_global_data VALUES (23176, 29, 958, 0, 42, 98, 149);
INSERT INTO public.who_global_data VALUES (23177, 1, 945, 0, 16, 98, 197);
INSERT INTO public.who_global_data VALUES (23178, 398, 346880, 20, 5383, 98, 78);
INSERT INTO public.who_global_data VALUES (23179, 0, 15593, 0, 323, 98, 233);
INSERT INTO public.who_global_data VALUES (23180, 1545, 45137, 5, 814, 98, 133);
INSERT INTO public.who_global_data VALUES (23181, 0, 152, 0, 0, 98, 35);
INSERT INTO public.who_global_data VALUES (23182, 3, 2365, 0, 74, 98, 114);
INSERT INTO public.who_global_data VALUES (23183, 9, 58003, 0, 28, 98, 237);
INSERT INTO public.who_global_data VALUES (23184, 0, 14, 0, 0, 98, 55);
INSERT INTO public.who_global_data VALUES (23185, 0, 805, 0, 22, 98, 176);
INSERT INTO public.who_global_data VALUES (23186, 3363, 55091, 12, 212, 98, 202);
INSERT INTO public.who_global_data VALUES (23187, 1797, 34315, 27, 391, 98, 155);
INSERT INTO public.who_global_data VALUES (23188, 0, 8, 0, 0, 98, 32);
INSERT INTO public.who_global_data VALUES (23189, 0, 3941, 0, 104, 98, 220);
INSERT INTO public.who_global_data VALUES (23190, 1912, 723682, 66, 19230, 98, 30);
INSERT INTO public.who_global_data VALUES (23191, 2, 2905, 0, 58, 98, 147);
INSERT INTO public.who_global_data VALUES (23192, 24728, 1268485, 226, 38634, 98, 208);
INSERT INTO public.who_global_data VALUES (23193, 633, 10424, 0, 19, 98, 45);
INSERT INTO public.who_global_data VALUES (23194, 0, 13804, 0, 837, 98, 110);
INSERT INTO public.who_global_data VALUES (23195, 5, 5197, 0, 111, 98, 88);
INSERT INTO public.who_global_data VALUES (23196, 3262, 124989, 9, 6012, 98, 51);
INSERT INTO public.who_global_data VALUES (23197, 8943, 171115, 40, 2228, 98, 209);
INSERT INTO public.who_global_data VALUES (23198, 50, 5683, 4, 285, 98, 205);
INSERT INTO public.who_global_data VALUES (23199, 38, 10977, 0, 82, 98, 18);
INSERT INTO public.who_global_data VALUES (23200, 5, 3780, 0, 59, 98, 72);
INSERT INTO public.who_global_data VALUES (23201, 24405, 989749, 274, 46229, 98, 44);
INSERT INTO public.who_global_data VALUES (23202, 0, 30, 0, 0, 98, 15);
INSERT INTO public.who_global_data VALUES (23203, 0, 2296, 0, 55, 98, 25);
INSERT INTO public.who_global_data VALUES (23204, 0, 0, 0, 0, 98, 179);
INSERT INTO public.who_global_data VALUES (23205, 0, 0, 0, 0, 98, 34);
INSERT INTO public.who_global_data VALUES (23206, 42, 5636, 0, 107, 98, 207);
INSERT INTO public.who_global_data VALUES (23207, 1784, 59813, 64, 1317, 98, 166);
INSERT INTO public.who_global_data VALUES (23208, 9052, 1012504, 78, 10177, 98, 126);
INSERT INTO public.who_global_data VALUES (23209, 0, 0, 0, 0, 98, 97);
INSERT INTO public.who_global_data VALUES (23210, 0, 703, 0, 6, 98, 36);
INSERT INTO public.who_global_data VALUES (23211, 0, 0, 0, 0, 98, 125);
INSERT INTO public.who_global_data VALUES (23212, 209, 12410, 2, 110, 98, 124);
INSERT INTO public.who_global_data VALUES (23213, 8752, 387481, 155, 7196, 98, 185);
INSERT INTO public.who_global_data VALUES (23214, 1172, 131508, 2, 490, 98, 194);
INSERT INTO public.who_global_data VALUES (23215, 0, 509, 0, 21, 98, 144);
INSERT INTO public.who_global_data VALUES (23216, 89048, 8852730, 1046, 227178, 98, 19);
INSERT INTO public.who_global_data VALUES (23217, 9, 1362, 0, 21, 98, 217);
INSERT INTO public.who_global_data VALUES (23218, 63, 3044, 2, 57, 98, 148);
INSERT INTO public.who_global_data VALUES (23219, 259, 66801, 2, 564, 98, 86);
INSERT INTO public.who_global_data VALUES (23220, 0, 0, 0, 0, 98, 13);
INSERT INTO public.who_global_data VALUES (23221, 404, 91280, 5, 789, 98, 157);
INSERT INTO public.who_global_data VALUES (23222, 0, 1177, 0, 35, 98, 8);
INSERT INTO public.who_global_data VALUES (23223, 0, 1, 0, 0, 98, 73);
INSERT INTO public.who_global_data VALUES (23224, 0, 2066, 0, 600, 98, 101);
INSERT INTO public.who_global_data VALUES (23225, 90, 16415, 1, 349, 98, 165);
INSERT INTO public.who_global_data VALUES (23226, 41, 8362, 0, 242, 98, 14);
INSERT INTO public.who_global_data VALUES (23227, 123, 41268, 3, 1532, 99, 193);
INSERT INTO public.who_global_data VALUES (23228, 275, 20315, 6, 499, 99, 113);
INSERT INTO public.who_global_data VALUES (23229, 320, 57026, 10, 1941, 99, 143);
INSERT INTO public.who_global_data VALUES (23230, 0, 0, 0, 0, 99, 219);
INSERT INTO public.who_global_data VALUES (23231, 50, 4567, 1, 73, 99, 186);
INSERT INTO public.who_global_data VALUES (23232, 195, 10269, 0, 275, 99, 52);
INSERT INTO public.who_global_data VALUES (23233, 0, 3, 0, 0, 99, 180);
INSERT INTO public.who_global_data VALUES (23234, 0, 124, 0, 3, 99, 167);
INSERT INTO public.who_global_data VALUES (23235, 13924, 1130533, 341, 30071, 99, 154);
INSERT INTO public.who_global_data VALUES (23236, 2398, 86745, 28, 1295, 99, 94);
INSERT INTO public.who_global_data VALUES (23237, 18, 4455, 1, 37, 99, 66);
INSERT INTO public.who_global_data VALUES (23238, 15, 27569, 0, 907, 99, 58);
INSERT INTO public.who_global_data VALUES (23239, 4305, 96200, 24, 1064, 99, 163);
INSERT INTO public.who_global_data VALUES (23240, 1015, 53152, 9, 708, 99, 37);
INSERT INTO public.who_global_data VALUES (23241, 58, 6607, 2, 138, 99, 142);
INSERT INTO public.who_global_data VALUES (23242, 240, 81262, 0, 317, 99, 83);
INSERT INTO public.who_global_data VALUES (23243, 1681, 404760, 25, 5886, 99, 228);
INSERT INTO public.who_global_data VALUES (23244, 2, 235, 0, 7, 99, 188);
INSERT INTO public.who_global_data VALUES (23245, 984, 96529, 4, 973, 99, 62);
INSERT INTO public.who_global_data VALUES (23246, 15090, 427096, 140, 11480, 99, 160);
INSERT INTO public.who_global_data VALUES (23247, 29, 3261, 1, 52, 99, 50);
INSERT INTO public.who_global_data VALUES (23248, 0, 2643, 0, 41, 99, 33);
INSERT INTO public.who_global_data VALUES (23249, 4, 198, 0, 9, 99, 183);
INSERT INTO public.who_global_data VALUES (23250, 0, 346, 0, 0, 99, 92);
INSERT INTO public.who_global_data VALUES (23251, 197, 141321, 22, 8694, 99, 158);
INSERT INTO public.who_global_data VALUES (23252, 0, 134, 0, 3, 99, 67);
INSERT INTO public.who_global_data VALUES (23253, 1910, 46668, 21, 1182, 99, 57);
INSERT INTO public.who_global_data VALUES (23254, 359, 6642, 3, 24, 99, 38);
INSERT INTO public.who_global_data VALUES (23255, 28629, 5468270, 510, 158456, 99, 141);
INSERT INTO public.who_global_data VALUES (23256, 0, 72, 0, 1, 99, 178);
INSERT INTO public.who_global_data VALUES (23257, 0, 148, 0, 3, 99, 108);
INSERT INTO public.who_global_data VALUES (23258, 2689, 48150, 28, 1225, 99, 39);
INSERT INTO public.who_global_data VALUES (23259, 11, 2477, 0, 67, 99, 2);
INSERT INTO public.who_global_data VALUES (23260, 22, 582, 0, 1, 99, 195);
INSERT INTO public.who_global_data VALUES (23261, 55, 8603, 1, 95, 99, 107);
INSERT INTO public.who_global_data VALUES (23262, 1, 291, 0, 0, 99, 161);
INSERT INTO public.who_global_data VALUES (23263, 0, 21793, 0, 426, 99, 212);
INSERT INTO public.who_global_data VALUES (23264, 2699, 225586, 31, 10032, 99, 181);
INSERT INTO public.who_global_data VALUES (23265, 0, 239, 0, 1, 99, 53);
INSERT INTO public.who_global_data VALUES (23266, 3, 4866, 0, 62, 99, 164);
INSERT INTO public.who_global_data VALUES (23267, 5, 1473, 0, 97, 99, 140);
INSERT INTO public.who_global_data VALUES (23268, 1520, 507050, 86, 14118, 99, 20);
INSERT INTO public.who_global_data VALUES (23269, 31, 91852, 0, 4746, 99, 112);
INSERT INTO public.who_global_data VALUES (23270, 8717, 1041935, 188, 30753, 99, 111);
INSERT INTO public.who_global_data VALUES (23271, 0, 530, 0, 7, 99, 71);
INSERT INTO public.who_global_data VALUES (23272, 0, 5290, 0, 92, 99, 218);
INSERT INTO public.who_global_data VALUES (23273, 0, 0, 0, 0, 99, 43);
INSERT INTO public.who_global_data VALUES (23274, 1231, 106553, 11, 1340, 99, 49);
INSERT INTO public.who_global_data VALUES (23275, 73, 20628, 0, 124, 99, 1);
INSERT INTO public.who_global_data VALUES (23276, 2776, 43775, 18, 511, 99, 48);
INSERT INTO public.who_global_data VALUES (23277, 39, 6766, 0, 128, 99, 232);
INSERT INTO public.who_global_data VALUES (23278, 23, 907, 0, 1, 99, 175);
INSERT INTO public.who_global_data VALUES (23279, 234, 4051, 0, 25, 99, 21);
INSERT INTO public.who_global_data VALUES (23280, 13055, 310068, 187, 2862, 99, 156);
INSERT INTO public.who_global_data VALUES (23281, 0, 0, 0, 0, 99, 95);
INSERT INTO public.who_global_data VALUES (23282, 42, 11252, 0, 305, 99, 177);
INSERT INTO public.who_global_data VALUES (23283, 860, 44034, 1, 716, 99, 210);
INSERT INTO public.who_global_data VALUES (23284, 3, 5558, 0, 61, 99, 120);
INSERT INTO public.who_global_data VALUES (23285, 4, 42, 0, 0, 99, 135);
INSERT INTO public.who_global_data VALUES (23286, 343, 125913, 2, 2234, 99, 206);
INSERT INTO public.who_global_data VALUES (23287, 1394, 166302, 14, 12622, 99, 189);
INSERT INTO public.who_global_data VALUES (23288, 179, 107209, 13, 6247, 99, 129);
INSERT INTO public.who_global_data VALUES (23289, 520, 33445, 5, 967, 99, 121);
INSERT INTO public.who_global_data VALUES (23290, 0, 5083, 0, 83, 99, 59);
INSERT INTO public.who_global_data VALUES (23291, 0, 461, 0, 0, 99, 96);
INSERT INTO public.who_global_data VALUES (23292, 81, 4671, 0, 73, 99, 41);
INSERT INTO public.who_global_data VALUES (23293, 13, 5899, 1, 117, 99, 216);
INSERT INTO public.who_global_data VALUES (23294, 481, 95301, 6, 1457, 99, 236);
INSERT INTO public.who_global_data VALUES (23295, 0, 13, 0, 0, 99, 150);
INSERT INTO public.who_global_data VALUES (23296, 0, 494, 0, 0, 99, 61);
INSERT INTO public.who_global_data VALUES (23297, 0, 33, 0, 2, 99, 7);
INSERT INTO public.who_global_data VALUES (23298, 188, 15566, 0, 354, 99, 169);
INSERT INTO public.who_global_data VALUES (23299, 47637, 1250705, 235, 35719, 99, 28);
INSERT INTO public.who_global_data VALUES (23300, 21, 10425, 0, 70, 99, 85);
INSERT INTO public.who_global_data VALUES (23301, 0, 7262, 0, 29, 99, 211);
INSERT INTO public.who_global_data VALUES (23302, 0, 8957, 0, 55, 99, 60);
INSERT INTO public.who_global_data VALUES (23303, 0, 3666, 0, 119, 99, 3);
INSERT INTO public.who_global_data VALUES (23304, 1696, 37263, 12, 285, 99, 11);
INSERT INTO public.who_global_data VALUES (23305, 18681, 499694, 77, 10349, 99, 89);
INSERT INTO public.who_global_data VALUES (23306, 280, 48055, 4, 320, 99, 24);
INSERT INTO public.who_global_data VALUES (23307, 3, 682, 0, 0, 99, 162);
INSERT INTO public.who_global_data VALUES (23308, 1211, 35510, 12, 615, 99, 100);
INSERT INTO public.who_global_data VALUES (23309, 0, 17, 0, 0, 99, 47);
INSERT INTO public.who_global_data VALUES (23310, 0, 28, 0, 0, 99, 29);
INSERT INTO public.who_global_data VALUES (23311, 0, 7605, 0, 126, 99, 40);
INSERT INTO public.who_global_data VALUES (23312, 72, 4504, 1, 78, 99, 222);
INSERT INTO public.who_global_data VALUES (23313, 470, 106790, 22, 3704, 99, 132);
INSERT INTO public.who_global_data VALUES (23314, 1, 267, 0, 13, 99, 130);
INSERT INTO public.who_global_data VALUES (23315, 201, 12020, 0, 71, 99, 234);
INSERT INTO public.who_global_data VALUES (23316, 0, 2403, 0, 41, 99, 23);
INSERT INTO public.who_global_data VALUES (23317, 13, 4074, 4, 123, 99, 192);
INSERT INTO public.who_global_data VALUES (23318, 8, 9054, 0, 232, 99, 69);
INSERT INTO public.who_global_data VALUES (23319, 0, 26, 0, 0, 99, 187);
INSERT INTO public.who_global_data VALUES (23320, 576, 95199, 13, 2652, 99, 230);
INSERT INTO public.who_global_data VALUES (23321, 3286, 71413, 65, 1699, 99, 77);
INSERT INTO public.who_global_data VALUES (23322, 48, 4719, 0, 12, 99, 9);
INSERT INTO public.who_global_data VALUES (23323, 48648, 8088851, 563, 121090, 99, 74);
INSERT INTO public.who_global_data VALUES (23324, 3565, 404048, 89, 13701, 99, 224);
INSERT INTO public.who_global_data VALUES (23325, 8293, 596941, 399, 34113, 99, 199);
INSERT INTO public.who_global_data VALUES (23326, 3804, 467755, 45, 10815, 99, 190);
INSERT INTO public.who_global_data VALUES (23327, 863, 60297, 6, 1902, 99, 12);
INSERT INTO public.who_global_data VALUES (23328, 0, 352, 0, 24, 99, 104);
INSERT INTO public.who_global_data VALUES (23329, 723, 312808, 10, 2510, 99, 153);
INSERT INTO public.who_global_data VALUES (23330, 26829, 616595, 217, 38122, 99, 91);
INSERT INTO public.who_global_data VALUES (23331, 76, 8927, 4, 202, 99, 215);
INSERT INTO public.who_global_data VALUES (23332, 770, 99622, 11, 1744, 99, 84);
INSERT INTO public.who_global_data VALUES (23333, 5, 565, 0, 32, 99, 231);
INSERT INTO public.who_global_data VALUES (23334, 3443, 65385, 40, 740, 99, 196);
INSERT INTO public.who_global_data VALUES (23335, 633, 149699, 0, 2219, 99, 105);
INSERT INTO public.who_global_data VALUES (23336, 761, 52612, 14, 964, 99, 122);
INSERT INTO public.who_global_data VALUES (23337, 0, 0, 0, 0, 99, 159);
INSERT INTO public.who_global_data VALUES (23338, 284, 18867, 1, 664, 99, 75);
INSERT INTO public.who_global_data VALUES (23339, 760, 124666, 4, 767, 99, 27);
INSERT INTO public.who_global_data VALUES (23340, 596, 58394, 3, 1142, 99, 54);
INSERT INTO public.who_global_data VALUES (23341, 0, 24, 0, 0, 99, 226);
INSERT INTO public.who_global_data VALUES (23342, 251, 5395, 1, 64, 99, 79);
INSERT INTO public.who_global_data VALUES (23343, 1933, 77778, 8, 610, 99, 56);
INSERT INTO public.who_global_data VALUES (23344, 0, 1947, 0, 43, 99, 117);
INSERT INTO public.who_global_data VALUES (23345, 7, 1426, 0, 82, 99, 152);
INSERT INTO public.who_global_data VALUES (23346, 782, 59656, 8, 831, 99, 16);
INSERT INTO public.who_global_data VALUES (23347, 27, 547, 1, 2, 99, 10);
INSERT INTO public.who_global_data VALUES (23348, 725, 13815, 6, 145, 99, 201);
INSERT INTO public.who_global_data VALUES (23349, 698, 16356, 3, 150, 99, 174);
INSERT INTO public.who_global_data VALUES (23350, 0, 16968, 0, 244, 99, 119);
INSERT INTO public.who_global_data VALUES (23351, 12, 5916, 0, 184, 99, 168);
INSERT INTO public.who_global_data VALUES (23352, 649, 30090, 0, 246, 99, 99);
INSERT INTO public.who_global_data VALUES (23353, 25, 11616, 0, 37, 99, 171);
INSERT INTO public.who_global_data VALUES (23354, 7, 3537, 0, 136, 99, 87);
INSERT INTO public.who_global_data VALUES (23355, 76, 5932, 1, 57, 99, 123);
INSERT INTO public.who_global_data VALUES (23356, 0, 1, 0, 0, 99, 151);
INSERT INTO public.who_global_data VALUES (23357, 0, 3552, 0, 30, 99, 213);
INSERT INTO public.who_global_data VALUES (23358, 0, 7663, 0, 163, 99, 118);
INSERT INTO public.who_global_data VALUES (23359, 0, 441, 0, 10, 99, 134);
INSERT INTO public.who_global_data VALUES (23360, 0, 4366, 0, 44, 99, 65);
INSERT INTO public.who_global_data VALUES (23361, 5595, 906863, 495, 90309, 99, 102);
INSERT INTO public.who_global_data VALUES (23362, 0, 0, 0, 0, 99, 223);
INSERT INTO public.who_global_data VALUES (23363, 10, 350, 0, 2, 99, 4);
INSERT INTO public.who_global_data VALUES (23364, 0, 340, 0, 0, 99, 146);
INSERT INTO public.who_global_data VALUES (23365, 550, 19007, 4, 294, 99, 31);
INSERT INTO public.who_global_data VALUES (23366, 0, 13, 0, 1, 99, 127);
INSERT INTO public.who_global_data VALUES (23367, 4320, 212038, 66, 3572, 99, 22);
INSERT INTO public.who_global_data VALUES (23368, 110, 12525, 0, 91, 99, 115);
INSERT INTO public.who_global_data VALUES (23369, 1331, 50403, 27, 1199, 99, 106);
INSERT INTO public.who_global_data VALUES (23370, 52, 12858, 0, 133, 99, 90);
INSERT INTO public.who_global_data VALUES (23371, 0, 0, 0, 0, 99, 70);
INSERT INTO public.who_global_data VALUES (23372, 2364, 164718, 17, 904, 99, 46);
INSERT INTO public.who_global_data VALUES (23373, 10248, 329416, 62, 7253, 99, 139);
INSERT INTO public.who_global_data VALUES (23374, 0, 27, 0, 0, 99, 42);
INSERT INTO public.who_global_data VALUES (23375, 1, 1594, 0, 25, 99, 80);
INSERT INTO public.who_global_data VALUES (23376, 0, 4424, 0, 156, 99, 203);
INSERT INTO public.who_global_data VALUES (23377, 1, 1219, 0, 69, 99, 136);
INSERT INTO public.who_global_data VALUES (23378, 150, 62521, 2, 1141, 99, 63);
INSERT INTO public.who_global_data VALUES (23379, 0, 0, 0, 0, 99, 17);
INSERT INTO public.who_global_data VALUES (23380, 0, 92, 0, 2, 99, 172);
INSERT INTO public.who_global_data VALUES (23381, 861, 29558, 14, 977, 99, 109);
INSERT INTO public.who_global_data VALUES (23382, 403, 19066, 1, 281, 99, 200);
INSERT INTO public.who_global_data VALUES (23383, 623, 64237, 8, 545, 99, 93);
INSERT INTO public.who_global_data VALUES (23384, 0, 114434, 0, 1208, 99, 5);
INSERT INTO public.who_global_data VALUES (23385, 0, 741, 0, 13, 99, 214);
INSERT INTO public.who_global_data VALUES (23386, 908, 331108, 16, 6775, 99, 204);
INSERT INTO public.who_global_data VALUES (23387, 0, 0, 0, 0, 99, 198);
INSERT INTO public.who_global_data VALUES (23388, 825, 131247, 13, 2663, 99, 173);
INSERT INTO public.who_global_data VALUES (23389, 0, 589, 0, 7, 99, 229);
INSERT INTO public.who_global_data VALUES (23390, 733, 61290, 12, 1359, 99, 76);
INSERT INTO public.who_global_data VALUES (23391, 2431, 894928, 58, 34315, 99, 138);
INSERT INTO public.who_global_data VALUES (23392, 1755, 376935, 33, 7147, 99, 98);
INSERT INTO public.who_global_data VALUES (23393, 0, 0, 0, 0, 99, 103);
INSERT INTO public.who_global_data VALUES (23394, 20156, 319205, 298, 5149, 99, 225);
INSERT INTO public.who_global_data VALUES (23395, 4224, 132616, 33, 2428, 99, 131);
INSERT INTO public.who_global_data VALUES (23396, 1211, 64798, 1, 814, 99, 235);
INSERT INTO public.who_global_data VALUES (23397, 211, 132150, 1, 231, 99, 137);
INSERT INTO public.who_global_data VALUES (23398, 113, 26384, 1, 463, 99, 81);
INSERT INTO public.who_global_data VALUES (23399, 912, 74233, 18, 1747, 99, 182);
INSERT INTO public.who_global_data VALUES (23400, 0, 5472, 0, 22, 99, 145);
INSERT INTO public.who_global_data VALUES (23401, 6481, 229040, 83, 6764, 99, 26);
INSERT INTO public.who_global_data VALUES (23402, 18283, 1599976, 355, 27656, 99, 170);
INSERT INTO public.who_global_data VALUES (23403, 2, 5131, 0, 35, 99, 191);
INSERT INTO public.who_global_data VALUES (23404, 0, 5, 0, 0, 99, 221);
INSERT INTO public.who_global_data VALUES (23405, 0, 83, 0, 0, 99, 64);
INSERT INTO public.who_global_data VALUES (23406, 0, 0, 0, 0, 99, 116);
INSERT INTO public.who_global_data VALUES (23407, 0, 19, 0, 0, 99, 128);
INSERT INTO public.who_global_data VALUES (23408, 11, 76, 0, 0, 99, 6);
INSERT INTO public.who_global_data VALUES (23409, 0, 566, 0, 9, 99, 227);
INSERT INTO public.who_global_data VALUES (23410, 0, 12, 0, 0, 99, 68);
INSERT INTO public.who_global_data VALUES (23411, 0, 74, 0, 0, 99, 184);
INSERT INTO public.who_global_data VALUES (23412, 0, 0, 0, 0, 99, 82);
INSERT INTO public.who_global_data VALUES (23413, 26, 929, 0, 42, 99, 149);
INSERT INTO public.who_global_data VALUES (23414, 1, 944, 1, 16, 99, 197);
INSERT INTO public.who_global_data VALUES (23415, 435, 346482, 15, 5363, 99, 78);
INSERT INTO public.who_global_data VALUES (23416, 11, 15593, 1, 323, 99, 233);
INSERT INTO public.who_global_data VALUES (23417, 1384, 43592, 6, 809, 99, 133);
INSERT INTO public.who_global_data VALUES (23418, 0, 152, 0, 0, 99, 35);
INSERT INTO public.who_global_data VALUES (23419, 8, 2362, 0, 74, 99, 114);
INSERT INTO public.who_global_data VALUES (23420, 7, 57994, 0, 28, 99, 237);
INSERT INTO public.who_global_data VALUES (23421, 0, 14, 0, 0, 99, 55);
INSERT INTO public.who_global_data VALUES (23422, 13, 805, 0, 22, 99, 176);
INSERT INTO public.who_global_data VALUES (23423, 2785, 51728, 16, 200, 99, 202);
INSERT INTO public.who_global_data VALUES (23424, 1800, 32518, 25, 364, 99, 155);
INSERT INTO public.who_global_data VALUES (23425, 0, 8, 0, 0, 99, 32);
INSERT INTO public.who_global_data VALUES (23426, 0, 3941, 0, 104, 99, 220);
INSERT INTO public.who_global_data VALUES (23427, 2056, 721770, 53, 19164, 99, 30);
INSERT INTO public.who_global_data VALUES (23428, 0, 2903, 0, 58, 99, 147);
INSERT INTO public.who_global_data VALUES (23429, 25192, 1243757, 227, 38408, 99, 208);
INSERT INTO public.who_global_data VALUES (23430, 586, 9791, 0, 19, 99, 45);
INSERT INTO public.who_global_data VALUES (23431, 27, 13804, 0, 837, 99, 110);
INSERT INTO public.who_global_data VALUES (23432, 5, 5192, 0, 111, 99, 88);
INSERT INTO public.who_global_data VALUES (23433, 3390, 121727, 9, 6003, 99, 51);
INSERT INTO public.who_global_data VALUES (23434, 8984, 162172, 57, 2188, 99, 209);
INSERT INTO public.who_global_data VALUES (23435, 53, 5633, 3, 281, 99, 205);
INSERT INTO public.who_global_data VALUES (23436, 39, 10939, 0, 82, 99, 18);
INSERT INTO public.who_global_data VALUES (23437, 12, 3775, 0, 59, 99, 72);
INSERT INTO public.who_global_data VALUES (23438, 23065, 965344, 280, 45955, 99, 44);
INSERT INTO public.who_global_data VALUES (23439, 0, 30, 0, 0, 99, 15);
INSERT INTO public.who_global_data VALUES (23440, 58, 2296, 1, 55, 99, 25);
INSERT INTO public.who_global_data VALUES (23441, 0, 0, 0, 0, 99, 179);
INSERT INTO public.who_global_data VALUES (23442, 0, 0, 0, 0, 99, 34);
INSERT INTO public.who_global_data VALUES (23443, 26, 5594, 1, 107, 99, 207);
INSERT INTO public.who_global_data VALUES (23444, 3751, 58029, 100, 1253, 99, 166);
INSERT INTO public.who_global_data VALUES (23445, 9049, 1003452, 72, 10099, 99, 126);
INSERT INTO public.who_global_data VALUES (23446, 0, 0, 0, 0, 99, 97);
INSERT INTO public.who_global_data VALUES (23447, 0, 703, 0, 6, 99, 36);
INSERT INTO public.who_global_data VALUES (23448, 0, 0, 0, 0, 99, 125);
INSERT INTO public.who_global_data VALUES (23449, 434, 12201, 2, 108, 99, 124);
INSERT INTO public.who_global_data VALUES (23450, 8312, 378729, 173, 7041, 99, 185);
INSERT INTO public.who_global_data VALUES (23451, 1312, 130336, 3, 488, 99, 194);
INSERT INTO public.who_global_data VALUES (23452, 0, 509, 0, 21, 99, 144);
INSERT INTO public.who_global_data VALUES (23453, 80384, 8763682, 1059, 226132, 99, 19);
INSERT INTO public.who_global_data VALUES (23454, 0, 1353, 0, 21, 99, 217);
INSERT INTO public.who_global_data VALUES (23455, 65, 2981, 1, 55, 99, 148);
INSERT INTO public.who_global_data VALUES (23456, 229, 66542, 2, 562, 99, 86);
INSERT INTO public.who_global_data VALUES (23457, 0, 0, 0, 0, 99, 13);
INSERT INTO public.who_global_data VALUES (23458, 476, 90876, 4, 784, 99, 157);
INSERT INTO public.who_global_data VALUES (23459, 4, 1177, 0, 35, 99, 8);
INSERT INTO public.who_global_data VALUES (23460, 0, 1, 0, 0, 99, 73);
INSERT INTO public.who_global_data VALUES (23461, 1, 2066, 0, 600, 99, 101);
INSERT INTO public.who_global_data VALUES (23462, 125, 16325, 0, 348, 99, 165);
INSERT INTO public.who_global_data VALUES (23463, 1, 8321, 0, 242, 99, 14);
INSERT INTO public.who_global_data VALUES (23464, 113, 41145, 6, 1529, 100, 193);
INSERT INTO public.who_global_data VALUES (23465, 311, 20040, 6, 493, 100, 113);
INSERT INTO public.who_global_data VALUES (23466, 287, 56706, 9, 1931, 100, 143);
INSERT INTO public.who_global_data VALUES (23467, 0, 0, 0, 0, 100, 219);
INSERT INTO public.who_global_data VALUES (23468, 107, 4517, 0, 72, 100, 186);
INSERT INTO public.who_global_data VALUES (23469, 203, 10074, 4, 275, 100, 52);
INSERT INTO public.who_global_data VALUES (23470, 0, 3, 0, 0, 100, 180);
INSERT INTO public.who_global_data VALUES (23471, 0, 124, 0, 3, 100, 167);
INSERT INTO public.who_global_data VALUES (23472, 14308, 1116609, 429, 29730, 100, 154);
INSERT INTO public.who_global_data VALUES (23473, 2383, 84347, 29, 1267, 100, 94);
INSERT INTO public.who_global_data VALUES (23474, 15, 4437, 0, 36, 100, 66);
INSERT INTO public.who_global_data VALUES (23475, 13, 27554, 2, 907, 100, 58);
INSERT INTO public.who_global_data VALUES (23476, 4149, 91895, 34, 1040, 100, 163);
INSERT INTO public.who_global_data VALUES (23477, 988, 52137, 11, 699, 100, 37);
INSERT INTO public.who_global_data VALUES (23478, 47, 6549, 0, 136, 100, 142);
INSERT INTO public.who_global_data VALUES (23479, 257, 81022, 1, 317, 100, 83);
INSERT INTO public.who_global_data VALUES (23480, 1493, 403079, 23, 5861, 100, 228);
INSERT INTO public.who_global_data VALUES (23481, 0, 233, 0, 7, 100, 188);
INSERT INTO public.who_global_data VALUES (23482, 936, 95545, 4, 969, 100, 62);
INSERT INTO public.who_global_data VALUES (23483, 17998, 412006, 142, 11340, 100, 160);
INSERT INTO public.who_global_data VALUES (23484, 32, 3232, 0, 51, 100, 50);
INSERT INTO public.who_global_data VALUES (23485, 0, 2643, 0, 41, 100, 33);
INSERT INTO public.who_global_data VALUES (23486, 1, 194, 0, 9, 100, 183);
INSERT INTO public.who_global_data VALUES (23487, 1, 346, 0, 0, 100, 92);
INSERT INTO public.who_global_data VALUES (23488, 172, 141124, 14, 8672, 100, 158);
INSERT INTO public.who_global_data VALUES (23489, 3, 134, 0, 3, 100, 67);
INSERT INTO public.who_global_data VALUES (23490, 1584, 44758, 36, 1161, 100, 57);
INSERT INTO public.who_global_data VALUES (23491, 0, 6283, 0, 21, 100, 38);
INSERT INTO public.who_global_data VALUES (23492, 29787, 5439641, 549, 157946, 100, 141);
INSERT INTO public.who_global_data VALUES (23493, 0, 72, 0, 1, 100, 178);
INSERT INTO public.who_global_data VALUES (23494, 0, 148, 0, 3, 100, 108);
INSERT INTO public.who_global_data VALUES (23495, 2760, 45461, 36, 1197, 100, 39);
INSERT INTO public.who_global_data VALUES (23496, 0, 2466, 0, 67, 100, 2);
INSERT INTO public.who_global_data VALUES (23497, 1, 560, 0, 1, 100, 195);
INSERT INTO public.who_global_data VALUES (23498, 76, 8548, 0, 94, 100, 107);
INSERT INTO public.who_global_data VALUES (23499, 0, 290, 0, 0, 100, 161);
INSERT INTO public.who_global_data VALUES (23500, 0, 21793, 0, 426, 100, 212);
INSERT INTO public.who_global_data VALUES (23501, 2674, 222887, 28, 10001, 100, 181);
INSERT INTO public.who_global_data VALUES (23502, 0, 239, 0, 1, 100, 53);
INSERT INTO public.who_global_data VALUES (23503, 0, 4863, 0, 62, 100, 164);
INSERT INTO public.who_global_data VALUES (23504, 8, 1468, 1, 97, 100, 140);
INSERT INTO public.who_global_data VALUES (23505, 1005, 505530, 6, 14032, 100, 20);
INSERT INTO public.who_global_data VALUES (23506, 49, 91821, 0, 4746, 100, 112);
INSERT INTO public.who_global_data VALUES (23507, 8166, 1033218, 217, 30565, 100, 111);
INSERT INTO public.who_global_data VALUES (23508, 5, 530, 0, 7, 100, 71);
INSERT INTO public.who_global_data VALUES (23509, 37, 5290, 0, 92, 100, 218);
INSERT INTO public.who_global_data VALUES (23510, 0, 0, 0, 0, 100, 43);
INSERT INTO public.who_global_data VALUES (23511, 862, 105322, 17, 1329, 100, 49);
INSERT INTO public.who_global_data VALUES (23512, 67, 20555, 2, 124, 100, 1);
INSERT INTO public.who_global_data VALUES (23513, 2378, 40999, 23, 493, 100, 48);
INSERT INTO public.who_global_data VALUES (23514, 49, 6727, 0, 128, 100, 232);
INSERT INTO public.who_global_data VALUES (23515, 11, 884, 0, 1, 100, 175);
INSERT INTO public.who_global_data VALUES (23516, 0, 3817, 0, 25, 100, 21);
INSERT INTO public.who_global_data VALUES (23517, 12980, 297013, 128, 2675, 100, 156);
INSERT INTO public.who_global_data VALUES (23518, 0, 0, 0, 0, 100, 95);
INSERT INTO public.who_global_data VALUES (23519, 20, 11210, 0, 305, 100, 177);
INSERT INTO public.who_global_data VALUES (23520, 1017, 43174, 6, 715, 100, 210);
INSERT INTO public.who_global_data VALUES (23521, 14, 5555, 0, 61, 100, 120);
INSERT INTO public.who_global_data VALUES (23522, 0, 38, 0, 0, 100, 135);
INSERT INTO public.who_global_data VALUES (23523, 562, 125570, 6, 2232, 100, 206);
INSERT INTO public.who_global_data VALUES (23524, 1716, 164908, 20, 12608, 100, 189);
INSERT INTO public.who_global_data VALUES (23525, 153, 107030, 12, 6234, 100, 129);
INSERT INTO public.who_global_data VALUES (23526, 0, 32925, 5, 962, 100, 121);
INSERT INTO public.who_global_data VALUES (23527, 0, 5083, 0, 83, 100, 59);
INSERT INTO public.who_global_data VALUES (23528, 0, 461, 0, 0, 100, 96);
INSERT INTO public.who_global_data VALUES (23529, 125, 4590, 0, 73, 100, 41);
INSERT INTO public.who_global_data VALUES (23530, 11, 5886, 0, 116, 100, 216);
INSERT INTO public.who_global_data VALUES (23531, 602, 94820, 6, 1451, 100, 236);
INSERT INTO public.who_global_data VALUES (23532, 0, 13, 0, 0, 100, 150);
INSERT INTO public.who_global_data VALUES (23533, 0, 494, 0, 0, 100, 61);
INSERT INTO public.who_global_data VALUES (23534, 0, 33, 0, 2, 100, 7);
INSERT INTO public.who_global_data VALUES (23535, 215, 15378, 0, 354, 100, 169);
INSERT INTO public.who_global_data VALUES (23536, 35367, 1203068, 241, 35484, 100, 28);
INSERT INTO public.who_global_data VALUES (23537, 7, 10404, 0, 70, 100, 85);
INSERT INTO public.who_global_data VALUES (23538, 769, 7262, 3, 29, 100, 211);
INSERT INTO public.who_global_data VALUES (23539, 20, 8957, 1, 55, 100, 60);
INSERT INTO public.who_global_data VALUES (23540, 0, 3666, 0, 119, 100, 3);
INSERT INTO public.who_global_data VALUES (23541, 1709, 35567, 20, 273, 100, 11);
INSERT INTO public.who_global_data VALUES (23542, 16774, 481013, 89, 10272, 100, 89);
INSERT INTO public.who_global_data VALUES (23543, 0, 47775, 0, 316, 100, 24);
INSERT INTO public.who_global_data VALUES (23544, 9, 679, 0, 0, 100, 162);
INSERT INTO public.who_global_data VALUES (23545, 1547, 34299, 10, 603, 100, 100);
INSERT INTO public.who_global_data VALUES (23546, 0, 17, 0, 0, 100, 47);
INSERT INTO public.who_global_data VALUES (23547, 0, 28, 0, 0, 100, 29);
INSERT INTO public.who_global_data VALUES (23548, 131, 7605, 0, 126, 100, 40);
INSERT INTO public.who_global_data VALUES (23549, 48, 4432, 2, 77, 100, 222);
INSERT INTO public.who_global_data VALUES (23550, 749, 106320, 17, 3682, 100, 132);
INSERT INTO public.who_global_data VALUES (23551, 0, 266, 0, 13, 100, 130);
INSERT INTO public.who_global_data VALUES (23552, 0, 11819, 0, 71, 100, 234);
INSERT INTO public.who_global_data VALUES (23553, 0, 2403, 0, 41, 100, 23);
INSERT INTO public.who_global_data VALUES (23554, 35, 4061, 0, 119, 100, 192);
INSERT INTO public.who_global_data VALUES (23555, 20, 9046, 0, 232, 100, 69);
INSERT INTO public.who_global_data VALUES (23556, 0, 26, 0, 0, 100, 187);
INSERT INTO public.who_global_data VALUES (23557, 657, 94623, 6, 2639, 100, 230);
INSERT INTO public.who_global_data VALUES (23558, 2194, 68127, 56, 1634, 100, 77);
INSERT INTO public.who_global_data VALUES (23559, 97, 4671, 1, 12, 100, 9);
INSERT INTO public.who_global_data VALUES (23560, 49881, 8040203, 517, 120527, 100, 74);
INSERT INTO public.who_global_data VALUES (23561, 4029, 400483, 100, 13612, 100, 224);
INSERT INTO public.who_global_data VALUES (23562, 6824, 588648, 415, 33714, 100, 199);
INSERT INTO public.who_global_data VALUES (23563, 4043, 463951, 46, 10770, 100, 190);
INSERT INTO public.who_global_data VALUES (23564, 667, 59434, 6, 1896, 100, 12);
INSERT INTO public.who_global_data VALUES (23565, 1, 352, 0, 24, 100, 104);
INSERT INTO public.who_global_data VALUES (23566, 887, 312085, 28, 2500, 100, 153);
INSERT INTO public.who_global_data VALUES (23567, 24988, 589766, 205, 37905, 100, 91);
INSERT INTO public.who_global_data VALUES (23568, 64, 8851, 2, 198, 100, 215);
INSERT INTO public.who_global_data VALUES (23569, 736, 98852, 3, 1733, 100, 84);
INSERT INTO public.who_global_data VALUES (23570, 4, 560, 0, 32, 100, 231);
INSERT INTO public.who_global_data VALUES (23571, 3087, 61942, 32, 700, 100, 196);
INSERT INTO public.who_global_data VALUES (23572, 587, 149066, 0, 2219, 100, 105);
INSERT INTO public.who_global_data VALUES (23573, 1018, 51851, 16, 950, 100, 122);
INSERT INTO public.who_global_data VALUES (23574, 0, 0, 0, 0, 100, 159);
INSERT INTO public.who_global_data VALUES (23575, 281, 18583, 4, 663, 100, 75);
INSERT INTO public.who_global_data VALUES (23576, 814, 123906, 7, 763, 100, 27);
INSERT INTO public.who_global_data VALUES (23577, 522, 57798, 1, 1139, 100, 54);
INSERT INTO public.who_global_data VALUES (23578, 0, 24, 0, 0, 100, 226);
INSERT INTO public.who_global_data VALUES (23579, 251, 5144, 0, 63, 100, 79);
INSERT INTO public.who_global_data VALUES (23580, 1850, 75845, 12, 602, 100, 56);
INSERT INTO public.who_global_data VALUES (23581, 0, 1947, 0, 43, 100, 117);
INSERT INTO public.who_global_data VALUES (23582, 0, 1419, 0, 82, 100, 152);
INSERT INTO public.who_global_data VALUES (23583, 899, 58874, 11, 823, 100, 16);
INSERT INTO public.who_global_data VALUES (23584, 36, 520, 0, 1, 100, 10);
INSERT INTO public.who_global_data VALUES (23585, 948, 13090, 4, 139, 100, 201);
INSERT INTO public.who_global_data VALUES (23586, 774, 15658, 0, 147, 100, 174);
INSERT INTO public.who_global_data VALUES (23587, 0, 16968, 0, 244, 100, 119);
INSERT INTO public.who_global_data VALUES (23588, 7, 5904, 1, 184, 100, 168);
INSERT INTO public.who_global_data VALUES (23589, 801, 29441, 8, 246, 100, 99);
INSERT INTO public.who_global_data VALUES (23590, 24, 11591, 0, 37, 100, 171);
INSERT INTO public.who_global_data VALUES (23591, 15, 3530, 0, 136, 100, 87);
INSERT INTO public.who_global_data VALUES (23592, 106, 5856, 0, 56, 100, 123);
INSERT INTO public.who_global_data VALUES (23593, 0, 1, 0, 0, 100, 151);
INSERT INTO public.who_global_data VALUES (23594, 752, 3552, 3, 30, 100, 213);
INSERT INTO public.who_global_data VALUES (23595, 0, 7663, 0, 163, 100, 118);
INSERT INTO public.who_global_data VALUES (23596, 2, 441, 0, 10, 100, 134);
INSERT INTO public.who_global_data VALUES (23597, 45, 4366, 0, 44, 100, 65);
INSERT INTO public.who_global_data VALUES (23598, 5942, 901268, 643, 89814, 100, 102);
INSERT INTO public.who_global_data VALUES (23599, 0, 0, 0, 0, 100, 223);
INSERT INTO public.who_global_data VALUES (23600, 17, 340, 0, 2, 100, 4);
INSERT INTO public.who_global_data VALUES (23601, 0, 340, 0, 0, 100, 146);
INSERT INTO public.who_global_data VALUES (23602, 347, 18457, 8, 290, 100, 31);
INSERT INTO public.who_global_data VALUES (23603, 0, 13, 0, 1, 100, 127);
INSERT INTO public.who_global_data VALUES (23604, 3985, 207718, 61, 3506, 100, 22);
INSERT INTO public.who_global_data VALUES (23605, 142, 12415, 2, 91, 100, 115);
INSERT INTO public.who_global_data VALUES (23606, 1406, 49072, 25, 1172, 100, 106);
INSERT INTO public.who_global_data VALUES (23607, 77, 12806, 0, 133, 100, 90);
INSERT INTO public.who_global_data VALUES (23608, 0, 0, 0, 0, 100, 70);
INSERT INTO public.who_global_data VALUES (23609, 1954, 162354, 11, 887, 100, 46);
INSERT INTO public.who_global_data VALUES (23610, 8077, 319168, 54, 7191, 100, 139);
INSERT INTO public.who_global_data VALUES (23611, 0, 27, 0, 0, 100, 42);
INSERT INTO public.who_global_data VALUES (23612, 6, 1593, 0, 25, 100, 80);
INSERT INTO public.who_global_data VALUES (23613, 0, 4424, 0, 156, 100, 203);
INSERT INTO public.who_global_data VALUES (23614, 0, 1218, 0, 69, 100, 136);
INSERT INTO public.who_global_data VALUES (23615, 147, 62371, 4, 1139, 100, 63);
INSERT INTO public.who_global_data VALUES (23616, 0, 0, 0, 0, 100, 17);
INSERT INTO public.who_global_data VALUES (23617, 0, 92, 0, 2, 100, 172);
INSERT INTO public.who_global_data VALUES (23618, 870, 28697, 14, 963, 100, 109);
INSERT INTO public.who_global_data VALUES (23619, 322, 18663, 0, 280, 100, 200);
INSERT INTO public.who_global_data VALUES (23620, 450, 63614, 8, 537, 100, 93);
INSERT INTO public.who_global_data VALUES (23621, 614, 114434, 5, 1208, 100, 5);
INSERT INTO public.who_global_data VALUES (23622, 0, 741, 0, 13, 100, 214);
INSERT INTO public.who_global_data VALUES (23623, 825, 330200, 14, 6759, 100, 204);
INSERT INTO public.who_global_data VALUES (23624, 0, 0, 0, 0, 100, 198);
INSERT INTO public.who_global_data VALUES (23625, 671, 130422, 12, 2650, 100, 173);
INSERT INTO public.who_global_data VALUES (23626, 1, 589, 0, 7, 100, 229);
INSERT INTO public.who_global_data VALUES (23627, 448, 60557, 14, 1347, 100, 76);
INSERT INTO public.who_global_data VALUES (23628, 1923, 892497, 60, 34257, 100, 138);
INSERT INTO public.who_global_data VALUES (23629, 2036, 375180, 61, 7114, 100, 98);
INSERT INTO public.who_global_data VALUES (23630, 0, 0, 0, 0, 100, 103);
INSERT INTO public.who_global_data VALUES (23631, 18820, 299049, 236, 4851, 100, 225);
INSERT INTO public.who_global_data VALUES (23632, 3960, 128392, 24, 2395, 100, 131);
INSERT INTO public.who_global_data VALUES (23633, 90, 63587, 5, 813, 100, 235);
INSERT INTO public.who_global_data VALUES (23634, 250, 131939, 0, 230, 100, 137);
INSERT INTO public.who_global_data VALUES (23635, 125, 26271, 1, 462, 100, 81);
INSERT INTO public.who_global_data VALUES (23636, 861, 73321, 19, 1729, 100, 182);
INSERT INTO public.who_global_data VALUES (23637, 111, 5472, 0, 22, 100, 145);
INSERT INTO public.who_global_data VALUES (23638, 5343, 222559, 107, 6681, 100, 26);
INSERT INTO public.who_global_data VALUES (23639, 17717, 1581693, 366, 27301, 100, 170);
INSERT INTO public.who_global_data VALUES (23640, 45, 5129, 0, 35, 100, 191);
INSERT INTO public.who_global_data VALUES (23641, 0, 5, 0, 0, 100, 221);
INSERT INTO public.who_global_data VALUES (23642, 0, 83, 0, 0, 100, 64);
INSERT INTO public.who_global_data VALUES (23643, 0, 0, 0, 0, 100, 116);
INSERT INTO public.who_global_data VALUES (23644, 0, 19, 0, 0, 100, 128);
INSERT INTO public.who_global_data VALUES (23645, 2, 65, 0, 0, 100, 6);
INSERT INTO public.who_global_data VALUES (23646, 24, 566, 1, 9, 100, 227);
INSERT INTO public.who_global_data VALUES (23647, 0, 12, 0, 0, 100, 68);
INSERT INTO public.who_global_data VALUES (23648, 0, 74, 0, 0, 100, 184);
INSERT INTO public.who_global_data VALUES (23649, 0, 0, 0, 0, 100, 82);
INSERT INTO public.who_global_data VALUES (23650, 20, 903, 0, 42, 100, 149);
INSERT INTO public.who_global_data VALUES (23651, 2, 943, 0, 15, 100, 197);
INSERT INTO public.who_global_data VALUES (23652, 416, 346047, 19, 5348, 100, 78);
INSERT INTO public.who_global_data VALUES (23653, 11, 15582, 0, 322, 100, 233);
INSERT INTO public.who_global_data VALUES (23654, 1328, 42208, 5, 803, 100, 133);
INSERT INTO public.who_global_data VALUES (23655, 0, 152, 0, 0, 100, 35);
INSERT INTO public.who_global_data VALUES (23656, 4, 2354, 0, 74, 100, 114);
INSERT INTO public.who_global_data VALUES (23657, 7, 57987, 0, 28, 100, 237);
INSERT INTO public.who_global_data VALUES (23658, 0, 14, 0, 0, 100, 55);
INSERT INTO public.who_global_data VALUES (23659, 3, 792, 0, 22, 100, 176);
INSERT INTO public.who_global_data VALUES (23660, 2887, 48943, 8, 184, 100, 202);
INSERT INTO public.who_global_data VALUES (23661, 2492, 30718, 20, 339, 100, 155);
INSERT INTO public.who_global_data VALUES (23662, 0, 8, 0, 0, 100, 32);
INSERT INTO public.who_global_data VALUES (23663, 0, 3941, 0, 104, 100, 220);
INSERT INTO public.who_global_data VALUES (23664, 1863, 719714, 58, 19111, 100, 30);
INSERT INTO public.who_global_data VALUES (23665, 13, 2903, 2, 58, 100, 147);
INSERT INTO public.who_global_data VALUES (23666, 25091, 1218565, 235, 38181, 100, 208);
INSERT INTO public.who_global_data VALUES (23667, 335, 9205, 0, 19, 100, 45);
INSERT INTO public.who_global_data VALUES (23668, 12, 13777, 0, 837, 100, 110);
INSERT INTO public.who_global_data VALUES (23669, 7, 5187, 1, 111, 100, 88);
INSERT INTO public.who_global_data VALUES (23670, 2414, 118337, 9, 5994, 100, 51);
INSERT INTO public.who_global_data VALUES (23671, 9302, 153188, 42, 2131, 100, 209);
INSERT INTO public.who_global_data VALUES (23672, 52, 5580, 3, 278, 100, 205);
INSERT INTO public.who_global_data VALUES (23673, 40, 10900, 1, 82, 100, 18);
INSERT INTO public.who_global_data VALUES (23674, 4, 3763, 0, 59, 100, 72);
INSERT INTO public.who_global_data VALUES (23675, 24700, 942279, 310, 45675, 100, 44);
INSERT INTO public.who_global_data VALUES (23676, 0, 30, 0, 0, 100, 15);
INSERT INTO public.who_global_data VALUES (23677, 51, 2238, 2, 54, 100, 25);
INSERT INTO public.who_global_data VALUES (23678, 0, 0, 0, 0, 100, 179);
INSERT INTO public.who_global_data VALUES (23679, 0, 0, 0, 0, 100, 34);
INSERT INTO public.who_global_data VALUES (23680, 33, 5568, 0, 106, 100, 207);
INSERT INTO public.who_global_data VALUES (23681, 0, 54278, 0, 1153, 100, 166);
INSERT INTO public.who_global_data VALUES (23682, 9035, 994403, 77, 10027, 100, 126);
INSERT INTO public.who_global_data VALUES (23683, 0, 0, 0, 0, 100, 97);
INSERT INTO public.who_global_data VALUES (23684, 2, 703, 0, 6, 100, 36);
INSERT INTO public.who_global_data VALUES (23685, 0, 0, 0, 0, 100, 125);
INSERT INTO public.who_global_data VALUES (23686, 146, 11767, 3, 106, 100, 124);
INSERT INTO public.who_global_data VALUES (23687, 7342, 370417, 113, 6868, 100, 185);
INSERT INTO public.who_global_data VALUES (23688, 1400, 129024, 3, 485, 100, 194);
INSERT INTO public.who_global_data VALUES (23689, 0, 509, 0, 21, 100, 144);
INSERT INTO public.who_global_data VALUES (23690, 72042, 8683298, 895, 225073, 100, 19);
INSERT INTO public.who_global_data VALUES (23691, 2, 1353, 0, 21, 100, 217);
INSERT INTO public.who_global_data VALUES (23692, 44, 2916, 0, 54, 100, 148);
INSERT INTO public.who_global_data VALUES (23693, 276, 66313, 3, 560, 100, 86);
INSERT INTO public.who_global_data VALUES (23694, 0, 0, 0, 0, 100, 13);
INSERT INTO public.who_global_data VALUES (23695, 353, 90400, 3, 780, 100, 157);
INSERT INTO public.who_global_data VALUES (23696, 1, 1173, 0, 35, 100, 8);
INSERT INTO public.who_global_data VALUES (23697, 0, 1, 0, 0, 100, 73);
INSERT INTO public.who_global_data VALUES (23698, 1, 2065, 0, 600, 100, 101);
INSERT INTO public.who_global_data VALUES (23699, 0, 16200, 0, 348, 100, 165);
INSERT INTO public.who_global_data VALUES (23700, 5, 8320, 0, 242, 100, 14);
INSERT INTO public.who_global_data VALUES (23701, 95, 41032, 5, 1523, 101, 193);
INSERT INTO public.who_global_data VALUES (23702, 284, 19729, 7, 487, 101, 113);
INSERT INTO public.who_global_data VALUES (23703, 789, 56419, 25, 1922, 101, 143);
INSERT INTO public.who_global_data VALUES (23704, 0, 0, 0, 0, 101, 219);
INSERT INTO public.who_global_data VALUES (23705, 85, 4410, 0, 72, 101, 186);
INSERT INTO public.who_global_data VALUES (23706, 227, 9871, 1, 271, 101, 52);
INSERT INTO public.who_global_data VALUES (23707, 0, 3, 0, 0, 101, 180);
INSERT INTO public.who_global_data VALUES (23708, 0, 124, 0, 3, 101, 167);
INSERT INTO public.who_global_data VALUES (23709, 11712, 1102301, 405, 29301, 101, 154);
INSERT INTO public.who_global_data VALUES (23710, 2241, 81964, 21, 1238, 101, 94);
INSERT INTO public.who_global_data VALUES (23711, 2, 4422, 0, 36, 101, 66);
INSERT INTO public.who_global_data VALUES (23712, 14, 27541, 0, 905, 101, 58);
INSERT INTO public.who_global_data VALUES (23713, 2698, 87746, 18, 1006, 101, 163);
INSERT INTO public.who_global_data VALUES (23714, 663, 51149, 9, 688, 101, 37);
INSERT INTO public.who_global_data VALUES (23715, 36, 6502, 4, 136, 101, 142);
INSERT INTO public.who_global_data VALUES (23716, 232, 80765, 0, 316, 101, 83);
INSERT INTO public.who_global_data VALUES (23717, 1335, 401586, 20, 5838, 101, 228);
INSERT INTO public.who_global_data VALUES (23718, 0, 233, 0, 7, 101, 188);
INSERT INTO public.who_global_data VALUES (23719, 902, 94609, 4, 965, 101, 62);
INSERT INTO public.who_global_data VALUES (23720, 22210, 394008, 130, 11198, 101, 160);
INSERT INTO public.who_global_data VALUES (23721, 55, 3200, 1, 51, 101, 50);
INSERT INTO public.who_global_data VALUES (23722, 86, 2643, 0, 41, 101, 33);
INSERT INTO public.who_global_data VALUES (23723, 3, 193, 0, 9, 101, 183);
INSERT INTO public.who_global_data VALUES (23724, 3, 345, 0, 0, 101, 92);
INSERT INTO public.who_global_data VALUES (23725, 99, 140952, 13, 8658, 101, 158);
INSERT INTO public.who_global_data VALUES (23726, 0, 131, 0, 3, 101, 67);
INSERT INTO public.who_global_data VALUES (23727, 1558, 43174, 21, 1125, 101, 57);
INSERT INTO public.who_global_data VALUES (23728, 360, 6283, 0, 21, 101, 38);
INSERT INTO public.who_global_data VALUES (23729, 15726, 5409854, 263, 157397, 101, 141);
INSERT INTO public.who_global_data VALUES (23730, 0, 72, 0, 1, 101, 178);
INSERT INTO public.who_global_data VALUES (23731, 0, 148, 0, 3, 101, 108);
INSERT INTO public.who_global_data VALUES (23732, 2569, 42701, 25, 1161, 101, 39);
INSERT INTO public.who_global_data VALUES (23733, 7, 2466, 0, 67, 101, 2);
INSERT INTO public.who_global_data VALUES (23734, 1, 559, 0, 1, 101, 195);
INSERT INTO public.who_global_data VALUES (23735, 49, 8472, 0, 94, 101, 107);
INSERT INTO public.who_global_data VALUES (23736, 2, 290, 0, 0, 101, 161);
INSERT INTO public.who_global_data VALUES (23737, 0, 21793, 0, 426, 101, 212);
INSERT INTO public.who_global_data VALUES (23738, 4109, 220213, 27, 9973, 101, 181);
INSERT INTO public.who_global_data VALUES (23739, 0, 239, 0, 1, 101, 53);
INSERT INTO public.who_global_data VALUES (23740, 0, 4863, 0, 62, 101, 164);
INSERT INTO public.who_global_data VALUES (23741, 19, 1460, 0, 96, 101, 140);
INSERT INTO public.who_global_data VALUES (23742, 927, 504525, 23, 14026, 101, 20);
INSERT INTO public.who_global_data VALUES (23743, 47, 91772, 0, 4746, 101, 112);
INSERT INTO public.who_global_data VALUES (23744, 9167, 1025052, 194, 30348, 101, 111);
INSERT INTO public.who_global_data VALUES (23745, 8, 525, 0, 7, 101, 71);
INSERT INTO public.who_global_data VALUES (23746, 0, 5253, 0, 92, 101, 218);
INSERT INTO public.who_global_data VALUES (23747, 0, 0, 0, 0, 101, 43);
INSERT INTO public.who_global_data VALUES (23748, 511, 104460, 14, 1312, 101, 49);
INSERT INTO public.who_global_data VALUES (23749, 18, 20488, 0, 122, 101, 1);
INSERT INTO public.who_global_data VALUES (23750, 1413, 38621, 18, 470, 101, 48);
INSERT INTO public.who_global_data VALUES (23751, 83, 6678, 0, 128, 101, 232);
INSERT INTO public.who_global_data VALUES (23752, 15, 873, 0, 1, 101, 175);
INSERT INTO public.who_global_data VALUES (23753, 181, 3817, 0, 25, 101, 21);
INSERT INTO public.who_global_data VALUES (23754, 15663, 284033, 182, 2547, 101, 156);
INSERT INTO public.who_global_data VALUES (23755, 0, 0, 0, 0, 101, 95);
INSERT INTO public.who_global_data VALUES (23756, 17, 11190, 0, 305, 101, 177);
INSERT INTO public.who_global_data VALUES (23757, 745, 42157, 1, 709, 101, 210);
INSERT INTO public.who_global_data VALUES (23758, 0, 5541, 0, 61, 101, 120);
INSERT INTO public.who_global_data VALUES (23759, 0, 38, 0, 0, 101, 135);
INSERT INTO public.who_global_data VALUES (23760, 165, 125008, 1, 2226, 101, 206);
INSERT INTO public.who_global_data VALUES (23761, 1014, 163192, 15, 12588, 101, 189);
INSERT INTO public.who_global_data VALUES (23762, 170, 106877, 11, 6222, 101, 129);
INSERT INTO public.who_global_data VALUES (23763, 0, 32925, 4, 957, 101, 121);
INSERT INTO public.who_global_data VALUES (23764, 4, 5083, 0, 83, 101, 59);
INSERT INTO public.who_global_data VALUES (23765, 0, 461, 0, 0, 101, 96);
INSERT INTO public.who_global_data VALUES (23766, 37, 4465, 0, 73, 101, 41);
INSERT INTO public.who_global_data VALUES (23767, 12, 5875, 0, 116, 101, 216);
INSERT INTO public.who_global_data VALUES (23768, 511, 94218, 8, 1445, 101, 236);
INSERT INTO public.who_global_data VALUES (23769, 0, 13, 0, 0, 101, 150);
INSERT INTO public.who_global_data VALUES (23770, 4, 494, 0, 0, 101, 61);
INSERT INTO public.who_global_data VALUES (23771, 0, 33, 0, 2, 101, 7);
INSERT INTO public.who_global_data VALUES (23772, 193, 15163, 0, 354, 101, 169);
INSERT INTO public.who_global_data VALUES (23773, 33405, 1167701, 522, 35243, 101, 28);
INSERT INTO public.who_global_data VALUES (23774, 12, 10397, 1, 70, 101, 85);
INSERT INTO public.who_global_data VALUES (23775, 0, 6493, 0, 26, 101, 211);
INSERT INTO public.who_global_data VALUES (23776, 0, 8937, 0, 54, 101, 60);
INSERT INTO public.who_global_data VALUES (23777, 6, 3666, 0, 119, 101, 3);
INSERT INTO public.who_global_data VALUES (23778, 1731, 33858, 15, 253, 101, 11);
INSERT INTO public.who_global_data VALUES (23779, 14964, 464239, 85, 10183, 101, 89);
INSERT INTO public.who_global_data VALUES (23780, 85, 47775, 0, 316, 101, 24);
INSERT INTO public.who_global_data VALUES (23781, 3, 670, 0, 0, 101, 162);
INSERT INTO public.who_global_data VALUES (23782, 1256, 32752, 12, 593, 101, 100);
INSERT INTO public.who_global_data VALUES (23783, 0, 17, 0, 0, 101, 47);
INSERT INTO public.who_global_data VALUES (23784, 0, 28, 0, 0, 101, 29);
INSERT INTO public.who_global_data VALUES (23785, 0, 7474, 0, 126, 101, 40);
INSERT INTO public.who_global_data VALUES (23786, 76, 4384, 0, 75, 101, 222);
INSERT INTO public.who_global_data VALUES (23787, 677, 105571, 14, 3665, 101, 132);
INSERT INTO public.who_global_data VALUES (23788, 0, 266, 0, 13, 101, 130);
INSERT INTO public.who_global_data VALUES (23789, 150, 11819, 0, 71, 101, 234);
INSERT INTO public.who_global_data VALUES (23790, 0, 2403, 0, 41, 101, 23);
INSERT INTO public.who_global_data VALUES (23791, 3, 4026, 0, 119, 101, 192);
INSERT INTO public.who_global_data VALUES (23792, 0, 9026, 0, 232, 101, 69);
INSERT INTO public.who_global_data VALUES (23793, 0, 26, 0, 0, 101, 187);
INSERT INTO public.who_global_data VALUES (23794, 752, 93966, 10, 2633, 101, 230);
INSERT INTO public.who_global_data VALUES (23795, 2291, 65933, 43, 1578, 101, 77);
INSERT INTO public.who_global_data VALUES (23796, 70, 4574, 0, 11, 101, 9);
INSERT INTO public.who_global_data VALUES (23797, 43893, 7990322, 508, 120010, 101, 74);
INSERT INTO public.who_global_data VALUES (23798, 3520, 396454, 101, 13512, 101, 224);
INSERT INTO public.who_global_data VALUES (23799, 6968, 581824, 346, 33299, 101, 199);
INSERT INTO public.who_global_data VALUES (23800, 4510, 459908, 53, 10724, 101, 190);
INSERT INTO public.who_global_data VALUES (23801, 700, 58767, 5, 1890, 101, 12);
INSERT INTO public.who_global_data VALUES (23802, 3, 351, 0, 24, 101, 104);
INSERT INTO public.who_global_data VALUES (23803, 884, 311198, 28, 2472, 101, 153);
INSERT INTO public.who_global_data VALUES (23804, 21989, 564778, 221, 37700, 101, 91);
INSERT INTO public.who_global_data VALUES (23805, 38, 8787, 4, 196, 101, 215);
INSERT INTO public.who_global_data VALUES (23806, 618, 98116, 5, 1730, 101, 84);
INSERT INTO public.who_global_data VALUES (23807, 26, 556, 0, 32, 101, 231);
INSERT INTO public.who_global_data VALUES (23808, 3800, 58855, 44, 668, 101, 196);
INSERT INTO public.who_global_data VALUES (23809, 442, 148479, 0, 2219, 101, 105);
INSERT INTO public.who_global_data VALUES (23810, 836, 50833, 14, 934, 101, 122);
INSERT INTO public.who_global_data VALUES (23811, 0, 0, 0, 0, 101, 159);
INSERT INTO public.who_global_data VALUES (23812, 197, 18302, 3, 659, 101, 75);
INSERT INTO public.who_global_data VALUES (23813, 775, 123092, 7, 756, 101, 27);
INSERT INTO public.who_global_data VALUES (23814, 538, 57276, 2, 1138, 101, 54);
INSERT INTO public.who_global_data VALUES (23815, 0, 24, 0, 0, 101, 226);
INSERT INTO public.who_global_data VALUES (23816, 136, 4893, 3, 63, 101, 79);
INSERT INTO public.who_global_data VALUES (23817, 1809, 73995, 11, 590, 101, 56);
INSERT INTO public.who_global_data VALUES (23818, 7, 1947, 0, 43, 101, 117);
INSERT INTO public.who_global_data VALUES (23819, 3, 1419, 0, 82, 101, 152);
INSERT INTO public.who_global_data VALUES (23820, 752, 57975, 11, 812, 101, 16);
INSERT INTO public.who_global_data VALUES (23821, 23, 484, 0, 1, 101, 10);
INSERT INTO public.who_global_data VALUES (23822, 771, 12142, 5, 135, 101, 201);
INSERT INTO public.who_global_data VALUES (23823, 485, 14884, 0, 147, 101, 174);
INSERT INTO public.who_global_data VALUES (23824, 0, 16968, 0, 244, 101, 119);
INSERT INTO public.who_global_data VALUES (23825, 3, 5897, 0, 183, 101, 168);
INSERT INTO public.who_global_data VALUES (23826, 835, 28640, 2, 238, 101, 99);
INSERT INTO public.who_global_data VALUES (23827, 35, 11567, 0, 37, 101, 171);
INSERT INTO public.who_global_data VALUES (23828, 16, 3515, 3, 136, 101, 87);
INSERT INTO public.who_global_data VALUES (23829, 76, 5750, 2, 56, 101, 123);
INSERT INTO public.who_global_data VALUES (23830, 1, 1, 0, 0, 101, 151);
INSERT INTO public.who_global_data VALUES (23831, 0, 2800, 0, 27, 101, 213);
INSERT INTO public.who_global_data VALUES (23832, 0, 7663, 0, 163, 101, 118);
INSERT INTO public.who_global_data VALUES (23833, 0, 439, 0, 10, 101, 134);
INSERT INTO public.who_global_data VALUES (23834, 0, 4321, 0, 44, 101, 65);
INSERT INTO public.who_global_data VALUES (23835, 4166, 895326, 247, 89171, 101, 102);
INSERT INTO public.who_global_data VALUES (23836, 0, 0, 0, 0, 101, 223);
INSERT INTO public.who_global_data VALUES (23837, 10, 323, 0, 2, 101, 4);
INSERT INTO public.who_global_data VALUES (23838, 1, 340, 0, 0, 101, 146);
INSERT INTO public.who_global_data VALUES (23839, 519, 18110, 7, 282, 101, 31);
INSERT INTO public.who_global_data VALUES (23840, 0, 13, 0, 1, 101, 127);
INSERT INTO public.who_global_data VALUES (23841, 3988, 203733, 72, 3445, 101, 22);
INSERT INTO public.who_global_data VALUES (23842, 112, 12273, 1, 89, 101, 115);
INSERT INTO public.who_global_data VALUES (23843, 1466, 47666, 25, 1147, 101, 106);
INSERT INTO public.who_global_data VALUES (23844, 54, 12729, 0, 133, 101, 90);
INSERT INTO public.who_global_data VALUES (23845, 0, 0, 0, 0, 101, 70);
INSERT INTO public.who_global_data VALUES (23846, 570, 160400, 14, 876, 101, 46);
INSERT INTO public.who_global_data VALUES (23847, 10267, 311091, 69, 7137, 101, 139);
INSERT INTO public.who_global_data VALUES (23848, 0, 27, 0, 0, 101, 42);
INSERT INTO public.who_global_data VALUES (23849, 2, 1587, 0, 25, 101, 80);
INSERT INTO public.who_global_data VALUES (23850, 62, 4424, 1, 156, 101, 203);
INSERT INTO public.who_global_data VALUES (23851, 3, 1218, 0, 69, 101, 136);
INSERT INTO public.who_global_data VALUES (23852, 113, 62224, 3, 1135, 101, 63);
INSERT INTO public.who_global_data VALUES (23853, 0, 0, 0, 0, 101, 17);
INSERT INTO public.who_global_data VALUES (23854, 0, 92, 0, 2, 101, 172);
INSERT INTO public.who_global_data VALUES (23855, 628, 27827, 15, 949, 101, 109);
INSERT INTO public.who_global_data VALUES (23856, 433, 18341, 1, 280, 101, 200);
INSERT INTO public.who_global_data VALUES (23857, 576, 63164, 4, 529, 101, 93);
INSERT INTO public.who_global_data VALUES (23858, 466, 113820, 13, 1203, 101, 5);
INSERT INTO public.who_global_data VALUES (23859, 0, 741, 0, 13, 101, 214);
INSERT INTO public.who_global_data VALUES (23860, 773, 329375, 6, 6745, 101, 204);
INSERT INTO public.who_global_data VALUES (23861, 0, 0, 0, 0, 101, 198);
INSERT INTO public.who_global_data VALUES (23862, 551, 129751, 5, 2638, 101, 173);
INSERT INTO public.who_global_data VALUES (23863, 0, 588, 0, 7, 101, 229);
INSERT INTO public.who_global_data VALUES (23864, 515, 60109, 24, 1333, 101, 76);
INSERT INTO public.who_global_data VALUES (23865, 1859, 890574, 48, 34197, 101, 138);
INSERT INTO public.who_global_data VALUES (23866, 1514, 373144, 14, 7053, 101, 98);
INSERT INTO public.who_global_data VALUES (23867, 0, 0, 0, 0, 101, 103);
INSERT INTO public.who_global_data VALUES (23868, 16300, 280229, 132, 4615, 101, 225);
INSERT INTO public.who_global_data VALUES (23869, 3299, 124432, 28, 2371, 101, 131);
INSERT INTO public.who_global_data VALUES (23870, 362, 63497, 4, 808, 101, 235);
INSERT INTO public.who_global_data VALUES (23871, 257, 131689, 0, 230, 101, 137);
INSERT INTO public.who_global_data VALUES (23872, 103, 26146, 1, 461, 101, 81);
INSERT INTO public.who_global_data VALUES (23873, 649, 72460, 10, 1710, 101, 182);
INSERT INTO public.who_global_data VALUES (23874, 0, 5361, 0, 22, 101, 145);
INSERT INTO public.who_global_data VALUES (23875, 4724, 217216, 104, 6574, 101, 26);
INSERT INTO public.who_global_data VALUES (23876, 16202, 1563976, 346, 26935, 101, 170);
INSERT INTO public.who_global_data VALUES (23877, 11, 5084, 1, 35, 101, 191);
INSERT INTO public.who_global_data VALUES (23878, 0, 5, 0, 0, 101, 221);
INSERT INTO public.who_global_data VALUES (23879, 0, 83, 0, 0, 101, 64);
INSERT INTO public.who_global_data VALUES (23880, 0, 0, 0, 0, 101, 116);
INSERT INTO public.who_global_data VALUES (23881, 0, 19, 0, 0, 101, 128);
INSERT INTO public.who_global_data VALUES (23882, 9, 63, 0, 0, 101, 6);
INSERT INTO public.who_global_data VALUES (23883, 0, 542, 0, 8, 101, 227);
INSERT INTO public.who_global_data VALUES (23884, 0, 12, 0, 0, 101, 68);
INSERT INTO public.who_global_data VALUES (23885, 1, 74, 0, 0, 101, 184);
INSERT INTO public.who_global_data VALUES (23886, 0, 0, 0, 0, 101, 82);
INSERT INTO public.who_global_data VALUES (23887, 31, 883, 0, 42, 101, 149);
INSERT INTO public.who_global_data VALUES (23888, 0, 941, 0, 15, 101, 197);
INSERT INTO public.who_global_data VALUES (23889, 399, 345631, 16, 5329, 101, 78);
INSERT INTO public.who_global_data VALUES (23890, 6, 15571, 0, 322, 101, 233);
INSERT INTO public.who_global_data VALUES (23891, 1053, 40880, 5, 798, 101, 133);
INSERT INTO public.who_global_data VALUES (23892, 0, 152, 0, 0, 101, 35);
INSERT INTO public.who_global_data VALUES (23893, 4, 2350, 0, 74, 101, 114);
INSERT INTO public.who_global_data VALUES (23894, 7, 57980, 0, 28, 101, 237);
INSERT INTO public.who_global_data VALUES (23895, 0, 14, 0, 0, 101, 55);
INSERT INTO public.who_global_data VALUES (23896, 5, 789, 0, 22, 101, 176);
INSERT INTO public.who_global_data VALUES (23897, 901, 46056, 11, 176, 101, 202);
INSERT INTO public.who_global_data VALUES (23898, 2611, 28226, 16, 319, 101, 155);
INSERT INTO public.who_global_data VALUES (23899, 4, 8, 0, 0, 101, 32);
INSERT INTO public.who_global_data VALUES (23900, 0, 3941, 0, 104, 101, 220);
INSERT INTO public.who_global_data VALUES (23901, 1092, 717851, 45, 19053, 101, 30);
INSERT INTO public.who_global_data VALUES (23902, 0, 2890, 0, 56, 101, 147);
INSERT INTO public.who_global_data VALUES (23903, 20610, 1193474, 203, 37946, 101, 208);
INSERT INTO public.who_global_data VALUES (23904, 457, 8870, 3, 19, 101, 45);
INSERT INTO public.who_global_data VALUES (23905, 18, 13765, 0, 837, 101, 110);
INSERT INTO public.who_global_data VALUES (23906, 10, 5180, 1, 110, 101, 88);
INSERT INTO public.who_global_data VALUES (23907, 1069, 115923, 11, 5985, 101, 51);
INSERT INTO public.who_global_data VALUES (23908, 9753, 143886, 39, 2089, 101, 209);
INSERT INTO public.who_global_data VALUES (23909, 67, 5528, 3, 275, 101, 205);
INSERT INTO public.who_global_data VALUES (23910, 41, 10860, 0, 81, 101, 18);
INSERT INTO public.who_global_data VALUES (23911, 13, 3759, 0, 59, 101, 72);
INSERT INTO public.who_global_data VALUES (23912, 22885, 917579, 367, 45365, 101, 44);
INSERT INTO public.who_global_data VALUES (23913, 0, 30, 0, 0, 101, 15);
INSERT INTO public.who_global_data VALUES (23914, 0, 2187, 0, 52, 101, 25);
INSERT INTO public.who_global_data VALUES (23915, 0, 0, 0, 0, 101, 179);
INSERT INTO public.who_global_data VALUES (23916, 0, 0, 0, 0, 101, 34);
INSERT INTO public.who_global_data VALUES (23917, 24, 5535, 1, 106, 101, 207);
INSERT INTO public.who_global_data VALUES (23918, 0, 54278, 0, 1153, 101, 166);
INSERT INTO public.who_global_data VALUES (23919, 8939, 985368, 76, 9950, 101, 126);
INSERT INTO public.who_global_data VALUES (23920, 0, 0, 0, 0, 101, 97);
INSERT INTO public.who_global_data VALUES (23921, 0, 701, 0, 6, 101, 36);
INSERT INTO public.who_global_data VALUES (23922, 0, 0, 0, 0, 101, 125);
INSERT INTO public.who_global_data VALUES (23923, 64, 11621, 2, 103, 101, 124);
INSERT INTO public.who_global_data VALUES (23924, 7474, 363075, 165, 6755, 101, 185);
INSERT INTO public.who_global_data VALUES (23925, 1390, 127624, 2, 482, 101, 194);
INSERT INTO public.who_global_data VALUES (23926, 0, 509, 0, 21, 101, 144);
INSERT INTO public.who_global_data VALUES (23927, 63145, 8611256, 479, 224178, 101, 19);
INSERT INTO public.who_global_data VALUES (23928, 3, 1351, 0, 21, 101, 217);
INSERT INTO public.who_global_data VALUES (23929, 21, 2872, 1, 54, 101, 148);
INSERT INTO public.who_global_data VALUES (23930, 272, 66037, 3, 557, 101, 86);
INSERT INTO public.who_global_data VALUES (23931, 0, 0, 0, 0, 101, 13);
INSERT INTO public.who_global_data VALUES (23932, 482, 90047, 4, 777, 101, 157);
INSERT INTO public.who_global_data VALUES (23933, 3, 1172, 0, 35, 101, 8);
INSERT INTO public.who_global_data VALUES (23934, 0, 1, 0, 0, 101, 73);
INSERT INTO public.who_global_data VALUES (23935, 0, 2064, 0, 600, 101, 101);
INSERT INTO public.who_global_data VALUES (23936, 0, 16200, 0, 348, 101, 165);
INSERT INTO public.who_global_data VALUES (23937, 12, 8315, 0, 242, 101, 14);
INSERT INTO public.who_global_data VALUES (23938, 104, 40937, 4, 1518, 102, 193);
INSERT INTO public.who_global_data VALUES (23939, 288, 19445, 3, 480, 102, 113);
INSERT INTO public.who_global_data VALUES (23940, 0, 55630, 0, 1897, 102, 143);
INSERT INTO public.who_global_data VALUES (23941, 0, 0, 0, 0, 102, 219);
INSERT INTO public.who_global_data VALUES (23942, 287, 4325, 3, 72, 102, 186);
INSERT INTO public.who_global_data VALUES (23943, 263, 9644, 2, 270, 102, 52);
INSERT INTO public.who_global_data VALUES (23944, 0, 3, 0, 0, 102, 180);
INSERT INTO public.who_global_data VALUES (23945, 0, 124, 0, 3, 102, 167);
INSERT INTO public.who_global_data VALUES (23946, 9253, 1090589, 283, 28896, 102, 154);
INSERT INTO public.who_global_data VALUES (23947, 1600, 79723, 26, 1217, 102, 94);
INSERT INTO public.who_global_data VALUES (23948, 31, 4420, 0, 36, 102, 66);
INSERT INTO public.who_global_data VALUES (23949, 7, 27527, 0, 905, 102, 58);
INSERT INTO public.who_global_data VALUES (23950, 2512, 85048, 4, 988, 102, 163);
INSERT INTO public.who_global_data VALUES (23951, 527, 50486, 8, 679, 102, 37);
INSERT INTO public.who_global_data VALUES (23952, 56, 6466, 0, 132, 102, 142);
INSERT INTO public.who_global_data VALUES (23953, 278, 80533, 4, 316, 102, 83);
INSERT INTO public.who_global_data VALUES (23954, 1436, 400251, 15, 5818, 102, 228);
INSERT INTO public.who_global_data VALUES (23955, 3, 233, 0, 7, 102, 188);
INSERT INTO public.who_global_data VALUES (23956, 884, 93707, 4, 961, 102, 62);
INSERT INTO public.who_global_data VALUES (23957, 19868, 371798, 121, 11068, 102, 160);
INSERT INTO public.who_global_data VALUES (23958, 39, 3145, 2, 50, 102, 50);
INSERT INTO public.who_global_data VALUES (23959, 0, 2557, 0, 41, 102, 33);
INSERT INTO public.who_global_data VALUES (23960, 0, 190, 0, 9, 102, 183);
INSERT INTO public.who_global_data VALUES (23961, 0, 342, 0, 0, 102, 92);
INSERT INTO public.who_global_data VALUES (23962, 74, 140853, 18, 8645, 102, 158);
INSERT INTO public.who_global_data VALUES (23963, 0, 131, 0, 3, 102, 67);
INSERT INTO public.who_global_data VALUES (23964, 722, 41616, 18, 1104, 102, 57);
INSERT INTO public.who_global_data VALUES (23965, 0, 5923, 0, 21, 102, 38);
INSERT INTO public.who_global_data VALUES (23966, 13493, 5394128, 231, 157134, 102, 141);
INSERT INTO public.who_global_data VALUES (23967, 0, 72, 0, 1, 102, 178);
INSERT INTO public.who_global_data VALUES (23968, 0, 148, 0, 3, 102, 108);
INSERT INTO public.who_global_data VALUES (23969, 2243, 40132, 42, 1136, 102, 39);
INSERT INTO public.who_global_data VALUES (23970, 8, 2459, 2, 67, 102, 2);
INSERT INTO public.who_global_data VALUES (23971, 1, 558, 0, 1, 102, 195);
INSERT INTO public.who_global_data VALUES (23972, 27, 8423, 0, 94, 102, 107);
INSERT INTO public.who_global_data VALUES (23973, 1, 288, 0, 0, 102, 161);
INSERT INTO public.who_global_data VALUES (23974, 0, 21793, 0, 426, 102, 212);
INSERT INTO public.who_global_data VALUES (23975, 2145, 216104, 24, 9946, 102, 181);
INSERT INTO public.who_global_data VALUES (23976, 0, 239, 0, 1, 102, 53);
INSERT INTO public.who_global_data VALUES (23977, 0, 4863, 0, 62, 102, 164);
INSERT INTO public.who_global_data VALUES (23978, 4, 1441, 0, 96, 102, 140);
INSERT INTO public.who_global_data VALUES (23979, 1535, 503598, 59, 14003, 102, 20);
INSERT INTO public.who_global_data VALUES (23980, 24, 91725, 0, 4746, 102, 112);
INSERT INTO public.who_global_data VALUES (23981, 8174, 1015885, 154, 30154, 102, 111);
INSERT INTO public.who_global_data VALUES (23982, 0, 517, 0, 7, 102, 71);
INSERT INTO public.who_global_data VALUES (23983, 0, 5253, 0, 92, 102, 218);
INSERT INTO public.who_global_data VALUES (23984, 0, 0, 0, 0, 102, 43);
INSERT INTO public.who_global_data VALUES (23985, 861, 103949, 16, 1298, 102, 49);
INSERT INTO public.who_global_data VALUES (23986, 0, 20470, 0, 122, 102, 1);
INSERT INTO public.who_global_data VALUES (23987, 828, 37208, 15, 452, 102, 48);
INSERT INTO public.who_global_data VALUES (23988, 29, 6595, 0, 128, 102, 232);
INSERT INTO public.who_global_data VALUES (23989, 55, 858, 0, 1, 102, 175);
INSERT INTO public.who_global_data VALUES (23990, 91, 3636, 0, 25, 102, 21);
INSERT INTO public.who_global_data VALUES (23991, 10273, 268370, 164, 2365, 102, 156);
INSERT INTO public.who_global_data VALUES (23992, 0, 0, 0, 0, 102, 95);
INSERT INTO public.who_global_data VALUES (23993, 13, 11173, 0, 305, 102, 177);
INSERT INTO public.who_global_data VALUES (23994, 1056, 41412, 6, 708, 102, 210);
INSERT INTO public.who_global_data VALUES (23995, 5, 5541, 0, 61, 102, 120);
INSERT INTO public.who_global_data VALUES (23996, 0, 38, 0, 0, 102, 135);
INSERT INTO public.who_global_data VALUES (23997, 316, 124843, 2, 2225, 102, 206);
INSERT INTO public.who_global_data VALUES (23998, 543, 162178, 20, 12573, 102, 189);
INSERT INTO public.who_global_data VALUES (23999, 167, 106707, 12, 6211, 102, 129);
INSERT INTO public.who_global_data VALUES (24000, 340, 32925, 4, 953, 102, 121);
INSERT INTO public.who_global_data VALUES (24001, 0, 5079, 0, 83, 102, 59);
INSERT INTO public.who_global_data VALUES (24002, 0, 461, 0, 0, 102, 96);
INSERT INTO public.who_global_data VALUES (24003, 17, 4428, 0, 73, 102, 41);
INSERT INTO public.who_global_data VALUES (24004, 9, 5863, 0, 116, 102, 216);
INSERT INTO public.who_global_data VALUES (24005, 364, 93707, 11, 1437, 102, 236);
INSERT INTO public.who_global_data VALUES (24006, 0, 13, 0, 0, 102, 150);
INSERT INTO public.who_global_data VALUES (24007, 0, 490, 0, 0, 102, 61);
INSERT INTO public.who_global_data VALUES (24008, 0, 33, 0, 2, 102, 7);
INSERT INTO public.who_global_data VALUES (24009, 122, 14970, 1, 354, 102, 169);
INSERT INTO public.who_global_data VALUES (24010, 26344, 1134296, 243, 34721, 102, 28);
INSERT INTO public.who_global_data VALUES (24011, 9, 10385, 0, 69, 102, 85);
INSERT INTO public.who_global_data VALUES (24012, 634, 6493, 6, 26, 102, 211);
INSERT INTO public.who_global_data VALUES (24013, 18, 8937, 0, 54, 102, 60);
INSERT INTO public.who_global_data VALUES (24014, 0, 3660, 0, 119, 102, 3);
INSERT INTO public.who_global_data VALUES (24015, 1824, 32127, 23, 238, 102, 11);
INSERT INTO public.who_global_data VALUES (24016, 11409, 449275, 42, 10098, 102, 89);
INSERT INTO public.who_global_data VALUES (24017, 0, 47690, 0, 316, 102, 24);
INSERT INTO public.who_global_data VALUES (24018, 7, 667, 0, 0, 102, 162);
INSERT INTO public.who_global_data VALUES (24019, 714, 31496, 7, 581, 102, 100);
INSERT INTO public.who_global_data VALUES (24020, 0, 17, 0, 0, 102, 47);
INSERT INTO public.who_global_data VALUES (24021, 0, 28, 0, 0, 102, 29);
INSERT INTO public.who_global_data VALUES (24022, 0, 7474, 0, 126, 102, 40);
INSERT INTO public.who_global_data VALUES (24023, 112, 4308, 4, 75, 102, 222);
INSERT INTO public.who_global_data VALUES (24024, 107, 104894, 7, 3651, 102, 132);
INSERT INTO public.who_global_data VALUES (24025, 1, 266, 0, 13, 102, 130);
INSERT INTO public.who_global_data VALUES (24026, 0, 11669, 0, 71, 102, 234);
INSERT INTO public.who_global_data VALUES (24027, 0, 2403, 0, 41, 102, 23);
INSERT INTO public.who_global_data VALUES (24028, 29, 4023, 2, 119, 102, 192);
INSERT INTO public.who_global_data VALUES (24029, 0, 9026, 0, 232, 102, 69);
INSERT INTO public.who_global_data VALUES (24030, 0, 26, 0, 0, 102, 187);
INSERT INTO public.who_global_data VALUES (24031, 490, 93214, 6, 2623, 102, 230);
INSERT INTO public.who_global_data VALUES (24032, 2079, 63642, 63, 1535, 102, 77);
INSERT INTO public.who_global_data VALUES (24033, 56, 4504, 0, 11, 102, 9);
INSERT INTO public.who_global_data VALUES (24034, 36470, 7946429, 488, 119502, 102, 74);
INSERT INTO public.who_global_data VALUES (24035, 3222, 392934, 112, 13411, 102, 224);
INSERT INTO public.who_global_data VALUES (24036, 5960, 574856, 337, 32953, 102, 199);
INSERT INTO public.who_global_data VALUES (24037, 3691, 455398, 48, 10671, 102, 190);
INSERT INTO public.who_global_data VALUES (24038, 939, 58067, 3, 1885, 102, 12);
INSERT INTO public.who_global_data VALUES (24039, 0, 348, 0, 24, 102, 104);
INSERT INTO public.who_global_data VALUES (24040, 607, 310314, 35, 2444, 102, 153);
INSERT INTO public.who_global_data VALUES (24041, 17007, 542789, 141, 37479, 102, 91);
INSERT INTO public.who_global_data VALUES (24042, 35, 8749, 4, 192, 102, 215);
INSERT INTO public.who_global_data VALUES (24043, 424, 97498, 7, 1725, 102, 84);
INSERT INTO public.who_global_data VALUES (24044, 0, 530, 0, 32, 102, 231);
INSERT INTO public.who_global_data VALUES (24045, 1968, 55055, 45, 624, 102, 196);
INSERT INTO public.who_global_data VALUES (24046, 422, 148037, 0, 2219, 102, 105);
INSERT INTO public.who_global_data VALUES (24047, 276, 49997, 18, 920, 102, 122);
INSERT INTO public.who_global_data VALUES (24048, 0, 0, 0, 0, 102, 159);
INSERT INTO public.who_global_data VALUES (24049, 205, 18105, 3, 656, 102, 75);
INSERT INTO public.who_global_data VALUES (24050, 682, 122317, 3, 749, 102, 27);
INSERT INTO public.who_global_data VALUES (24051, 568, 56738, 2, 1136, 102, 54);
INSERT INTO public.who_global_data VALUES (24052, 0, 24, 0, 0, 102, 226);
INSERT INTO public.who_global_data VALUES (24053, 79, 4757, 4, 60, 102, 79);
INSERT INTO public.who_global_data VALUES (24054, 796, 72186, 14, 579, 102, 56);
INSERT INTO public.who_global_data VALUES (24055, 0, 1940, 0, 43, 102, 117);
INSERT INTO public.who_global_data VALUES (24056, 21, 1416, 0, 82, 102, 152);
INSERT INTO public.who_global_data VALUES (24057, 1210, 57223, 6, 801, 102, 16);
INSERT INTO public.who_global_data VALUES (24058, 26, 461, 0, 1, 102, 10);
INSERT INTO public.who_global_data VALUES (24059, 422, 11371, 5, 130, 102, 201);
INSERT INTO public.who_global_data VALUES (24060, 195, 14399, 2, 147, 102, 174);
INSERT INTO public.who_global_data VALUES (24061, 0, 16968, 0, 244, 102, 119);
INSERT INTO public.who_global_data VALUES (24062, 4, 5894, 0, 183, 102, 168);
INSERT INTO public.who_global_data VALUES (24063, 1240, 27805, 7, 236, 102, 99);
INSERT INTO public.who_global_data VALUES (24064, 27, 11532, 0, 37, 102, 171);
INSERT INTO public.who_global_data VALUES (24065, 27, 3499, 1, 133, 102, 87);
INSERT INTO public.who_global_data VALUES (24066, 107, 5674, 1, 54, 102, 123);
INSERT INTO public.who_global_data VALUES (24067, 0, 0, 0, 0, 102, 151);
INSERT INTO public.who_global_data VALUES (24068, 0, 2800, 0, 27, 102, 213);
INSERT INTO public.who_global_data VALUES (24069, 0, 7663, 0, 163, 102, 118);
INSERT INTO public.who_global_data VALUES (24070, 4, 439, 0, 10, 102, 134);
INSERT INTO public.who_global_data VALUES (24071, 45, 4321, 0, 44, 102, 65);
INSERT INTO public.who_global_data VALUES (24072, 4360, 891160, 181, 88924, 102, 102);
INSERT INTO public.who_global_data VALUES (24073, 0, 0, 0, 0, 102, 223);
INSERT INTO public.who_global_data VALUES (24074, 4, 313, 0, 2, 102, 4);
INSERT INTO public.who_global_data VALUES (24075, 1, 339, 0, 0, 102, 146);
INSERT INTO public.who_global_data VALUES (24076, 237, 17591, 5, 275, 102, 31);
INSERT INTO public.who_global_data VALUES (24077, 0, 13, 0, 1, 102, 127);
INSERT INTO public.who_global_data VALUES (24078, 2264, 199745, 72, 3373, 102, 22);
INSERT INTO public.who_global_data VALUES (24079, 175, 12161, 2, 88, 102, 115);
INSERT INTO public.who_global_data VALUES (24080, 1426, 46200, 27, 1122, 102, 106);
INSERT INTO public.who_global_data VALUES (24081, 15, 12675, 0, 133, 102, 90);
INSERT INTO public.who_global_data VALUES (24082, 0, 0, 0, 0, 102, 70);
INSERT INTO public.who_global_data VALUES (24083, 1741, 159830, 15, 862, 102, 46);
INSERT INTO public.who_global_data VALUES (24084, 10303, 300824, 26, 7068, 102, 139);
INSERT INTO public.who_global_data VALUES (24085, 0, 27, 0, 0, 102, 42);
INSERT INTO public.who_global_data VALUES (24086, 1, 1585, 0, 25, 102, 80);
INSERT INTO public.who_global_data VALUES (24087, 0, 4362, 0, 155, 102, 203);
INSERT INTO public.who_global_data VALUES (24088, 0, 1215, 0, 69, 102, 136);
INSERT INTO public.who_global_data VALUES (24089, 119, 62111, 2, 1132, 102, 63);
INSERT INTO public.who_global_data VALUES (24090, 0, 0, 0, 0, 102, 17);
INSERT INTO public.who_global_data VALUES (24091, 4, 92, 0, 2, 102, 172);
INSERT INTO public.who_global_data VALUES (24092, 245, 27199, 15, 934, 102, 109);
INSERT INTO public.who_global_data VALUES (24093, 676, 17908, 0, 279, 102, 200);
INSERT INTO public.who_global_data VALUES (24094, 542, 62588, 6, 525, 102, 93);
INSERT INTO public.who_global_data VALUES (24095, 422, 113354, 16, 1190, 102, 5);
INSERT INTO public.who_global_data VALUES (24096, 0, 741, 0, 13, 102, 214);
INSERT INTO public.who_global_data VALUES (24097, 707, 328602, 3, 6739, 102, 204);
INSERT INTO public.who_global_data VALUES (24098, 0, 0, 0, 0, 102, 198);
INSERT INTO public.who_global_data VALUES (24099, 685, 129200, 5, 2633, 102, 173);
INSERT INTO public.who_global_data VALUES (24100, 0, 588, 0, 7, 102, 229);
INSERT INTO public.who_global_data VALUES (24101, 551, 59594, 16, 1309, 102, 76);
INSERT INTO public.who_global_data VALUES (24102, 2501, 888715, 54, 34149, 102, 138);
INSERT INTO public.who_global_data VALUES (24103, 1602, 371630, 62, 7039, 102, 98);
INSERT INTO public.who_global_data VALUES (24104, 0, 0, 0, 0, 102, 103);
INSERT INTO public.who_global_data VALUES (24105, 10241, 263929, 45, 4483, 102, 225);
INSERT INTO public.who_global_data VALUES (24106, 2447, 121133, 27, 2343, 102, 131);
INSERT INTO public.who_global_data VALUES (24107, 632, 63135, 3, 804, 102, 235);
INSERT INTO public.who_global_data VALUES (24108, 262, 131432, 0, 230, 102, 137);
INSERT INTO public.who_global_data VALUES (24109, 88, 26043, 3, 460, 102, 81);
INSERT INTO public.who_global_data VALUES (24110, 308, 71811, 15, 1700, 102, 182);
INSERT INTO public.who_global_data VALUES (24111, 212, 5361, 2, 22, 102, 145);
INSERT INTO public.who_global_data VALUES (24112, 2844, 212492, 79, 6470, 102, 26);
INSERT INTO public.who_global_data VALUES (24113, 16550, 1547774, 320, 26589, 102, 170);
INSERT INTO public.who_global_data VALUES (24114, 7, 5073, 0, 34, 102, 191);
INSERT INTO public.who_global_data VALUES (24115, 0, 5, 0, 0, 102, 221);
INSERT INTO public.who_global_data VALUES (24116, 0, 83, 0, 0, 102, 64);
INSERT INTO public.who_global_data VALUES (24117, 0, 0, 0, 0, 102, 116);
INSERT INTO public.who_global_data VALUES (24118, 0, 19, 0, 0, 102, 128);
INSERT INTO public.who_global_data VALUES (24119, 0, 54, 0, 0, 102, 6);
INSERT INTO public.who_global_data VALUES (24120, 0, 542, 0, 8, 102, 227);
INSERT INTO public.who_global_data VALUES (24121, 0, 12, 0, 0, 102, 68);
INSERT INTO public.who_global_data VALUES (24122, 0, 73, 0, 0, 102, 184);
INSERT INTO public.who_global_data VALUES (24123, 0, 0, 0, 0, 102, 82);
INSERT INTO public.who_global_data VALUES (24124, 8, 852, 0, 42, 102, 149);
INSERT INTO public.who_global_data VALUES (24125, 1, 941, 0, 15, 102, 197);
INSERT INTO public.who_global_data VALUES (24126, 357, 345232, 17, 5313, 102, 78);
INSERT INTO public.who_global_data VALUES (24127, 14, 15565, 1, 322, 102, 233);
INSERT INTO public.who_global_data VALUES (24128, 341, 39827, 1, 793, 102, 133);
INSERT INTO public.who_global_data VALUES (24129, 0, 152, 0, 0, 102, 35);
INSERT INTO public.who_global_data VALUES (24130, 0, 2346, 0, 74, 102, 114);
INSERT INTO public.who_global_data VALUES (24131, 3, 57973, 0, 28, 102, 237);
INSERT INTO public.who_global_data VALUES (24132, 0, 14, 0, 0, 102, 55);
INSERT INTO public.who_global_data VALUES (24133, 8, 784, 0, 22, 102, 176);
INSERT INTO public.who_global_data VALUES (24134, 1312, 45155, 6, 165, 102, 202);
INSERT INTO public.who_global_data VALUES (24135, 1502, 25615, 15, 303, 102, 155);
INSERT INTO public.who_global_data VALUES (24136, 0, 4, 0, 0, 102, 32);
INSERT INTO public.who_global_data VALUES (24137, 0, 3941, 0, 104, 102, 220);
INSERT INTO public.who_global_data VALUES (24138, 891, 716759, 40, 19008, 102, 30);
INSERT INTO public.who_global_data VALUES (24139, 7, 2890, 0, 56, 102, 147);
INSERT INTO public.who_global_data VALUES (24140, 11531, 1172864, 182, 37743, 102, 208);
INSERT INTO public.who_global_data VALUES (24141, 541, 8413, 1, 16, 102, 45);
INSERT INTO public.who_global_data VALUES (24142, 5, 13747, 0, 837, 102, 110);
INSERT INTO public.who_global_data VALUES (24143, 4, 5170, 0, 109, 102, 88);
INSERT INTO public.who_global_data VALUES (24144, 514, 114854, 8, 5974, 102, 51);
INSERT INTO public.who_global_data VALUES (24145, 10111, 134133, 20, 2050, 102, 209);
INSERT INTO public.who_global_data VALUES (24146, 53, 5461, 3, 272, 102, 205);
INSERT INTO public.who_global_data VALUES (24147, 43, 10819, 0, 81, 102, 18);
INSERT INTO public.who_global_data VALUES (24148, 3, 3746, 0, 59, 102, 72);
INSERT INTO public.who_global_data VALUES (24149, 20890, 894694, 102, 44998, 102, 44);
INSERT INTO public.who_global_data VALUES (24150, 1, 30, 0, 0, 102, 15);
INSERT INTO public.who_global_data VALUES (24151, 25, 2187, 0, 52, 102, 25);
INSERT INTO public.who_global_data VALUES (24152, 0, 0, 0, 0, 102, 179);
INSERT INTO public.who_global_data VALUES (24153, 0, 0, 0, 0, 102, 34);
INSERT INTO public.who_global_data VALUES (24154, 8, 5511, 0, 105, 102, 207);
INSERT INTO public.who_global_data VALUES (24155, 1879, 54278, 170, 1153, 102, 166);
INSERT INTO public.who_global_data VALUES (24156, 8928, 976429, 75, 9874, 102, 126);
INSERT INTO public.who_global_data VALUES (24157, 0, 0, 0, 0, 102, 97);
INSERT INTO public.who_global_data VALUES (24158, 0, 701, 0, 6, 102, 36);
INSERT INTO public.who_global_data VALUES (24159, 0, 0, 0, 0, 102, 125);
INSERT INTO public.who_global_data VALUES (24160, 114, 11557, 0, 101, 102, 124);
INSERT INTO public.who_global_data VALUES (24161, 6677, 355601, 126, 6590, 102, 185);
INSERT INTO public.who_global_data VALUES (24162, 1111, 126234, 3, 480, 102, 194);
INSERT INTO public.who_global_data VALUES (24163, 0, 509, 0, 21, 102, 144);
INSERT INTO public.who_global_data VALUES (24164, 62364, 8548111, 371, 223699, 102, 19);
INSERT INTO public.who_global_data VALUES (24165, 2, 1348, 0, 21, 102, 217);
INSERT INTO public.who_global_data VALUES (24166, 44, 2851, 0, 53, 102, 148);
INSERT INTO public.who_global_data VALUES (24167, 285, 65765, 4, 554, 102, 86);
INSERT INTO public.who_global_data VALUES (24168, 0, 0, 0, 0, 102, 13);
INSERT INTO public.who_global_data VALUES (24169, 423, 89565, 3, 773, 102, 157);
INSERT INTO public.who_global_data VALUES (24170, 1, 1169, 0, 35, 102, 8);
INSERT INTO public.who_global_data VALUES (24171, 0, 1, 0, 0, 102, 73);
INSERT INTO public.who_global_data VALUES (24172, 0, 2064, 0, 600, 102, 101);
INSERT INTO public.who_global_data VALUES (24173, 83, 16200, 0, 348, 102, 165);
INSERT INTO public.who_global_data VALUES (24174, 27, 8303, 5, 242, 102, 14);
INSERT INTO public.who_global_data VALUES (24175, 65, 40833, 3, 1514, 103, 193);
INSERT INTO public.who_global_data VALUES (24176, 299, 19157, 4, 477, 103, 113);
INSERT INTO public.who_global_data VALUES (24177, 0, 55630, 0, 1897, 103, 143);
INSERT INTO public.who_global_data VALUES (24178, 0, 0, 0, 0, 103, 219);
INSERT INTO public.who_global_data VALUES (24179, 0, 4038, 0, 69, 103, 186);
INSERT INTO public.who_global_data VALUES (24180, 355, 9381, 1, 268, 103, 52);
INSERT INTO public.who_global_data VALUES (24181, 0, 3, 0, 0, 103, 180);
INSERT INTO public.who_global_data VALUES (24182, 2, 124, 0, 3, 103, 167);
INSERT INTO public.who_global_data VALUES (24183, 11968, 1081336, 275, 28613, 103, 154);
INSERT INTO public.who_global_data VALUES (24184, 973, 78123, 16, 1191, 103, 94);
INSERT INTO public.who_global_data VALUES (24185, 0, 4389, 0, 36, 103, 66);
INSERT INTO public.who_global_data VALUES (24186, 21, 27520, 0, 905, 103, 58);
INSERT INTO public.who_global_data VALUES (24187, 2766, 82536, 6, 984, 103, 163);
INSERT INTO public.who_global_data VALUES (24188, 946, 49959, 7, 671, 103, 37);
INSERT INTO public.who_global_data VALUES (24189, 142, 6410, 2, 132, 103, 142);
INSERT INTO public.who_global_data VALUES (24190, 280, 80255, 0, 312, 103, 83);
INSERT INTO public.who_global_data VALUES (24191, 1308, 398815, 23, 5803, 103, 228);
INSERT INTO public.who_global_data VALUES (24192, 3, 230, 0, 7, 103, 188);
INSERT INTO public.who_global_data VALUES (24193, 1656, 92823, 12, 957, 103, 62);
INSERT INTO public.who_global_data VALUES (24194, 4895, 351930, 95, 10947, 103, 160);
INSERT INTO public.who_global_data VALUES (24195, 56, 3106, 1, 48, 103, 50);
INSERT INTO public.who_global_data VALUES (24196, 0, 2557, 0, 41, 103, 33);
INSERT INTO public.who_global_data VALUES (24197, 0, 190, 0, 9, 103, 183);
INSERT INTO public.who_global_data VALUES (24198, 2, 342, 0, 0, 103, 92);
INSERT INTO public.who_global_data VALUES (24199, 167, 140779, 19, 8627, 103, 158);
INSERT INTO public.who_global_data VALUES (24200, 0, 131, 0, 3, 103, 67);
INSERT INTO public.who_global_data VALUES (24201, 1136, 40894, 11, 1086, 103, 57);
INSERT INTO public.who_global_data VALUES (24202, 0, 5923, 0, 21, 103, 38);
INSERT INTO public.who_global_data VALUES (24203, 26979, 5380635, 432, 156903, 103, 141);
INSERT INTO public.who_global_data VALUES (24204, 0, 72, 0, 1, 103, 178);
INSERT INTO public.who_global_data VALUES (24205, 0, 148, 0, 3, 103, 108);
INSERT INTO public.who_global_data VALUES (24206, 327, 37889, 10, 1094, 103, 39);
INSERT INTO public.who_global_data VALUES (24207, 7, 2451, 0, 65, 103, 2);
INSERT INTO public.who_global_data VALUES (24208, 1, 557, 0, 1, 103, 195);
INSERT INTO public.who_global_data VALUES (24209, 74, 8396, 0, 94, 103, 107);
INSERT INTO public.who_global_data VALUES (24210, 0, 287, 0, 0, 103, 161);
INSERT INTO public.who_global_data VALUES (24211, 223, 21793, 1, 426, 103, 212);
INSERT INTO public.who_global_data VALUES (24212, 2227, 213959, 34, 9922, 103, 181);
INSERT INTO public.who_global_data VALUES (24213, 0, 239, 0, 1, 103, 53);
INSERT INTO public.who_global_data VALUES (24214, 1, 4863, 0, 62, 103, 164);
INSERT INTO public.who_global_data VALUES (24215, 3, 1437, 0, 96, 103, 140);
INSERT INTO public.who_global_data VALUES (24216, 1521, 502063, 52, 13944, 103, 20);
INSERT INTO public.who_global_data VALUES (24217, 26, 91701, 0, 4746, 103, 112);
INSERT INTO public.who_global_data VALUES (24218, 8769, 1007711, 198, 30000, 103, 111);
INSERT INTO public.who_global_data VALUES (24219, 0, 517, 0, 7, 103, 71);
INSERT INTO public.who_global_data VALUES (24220, 0, 5253, 0, 92, 103, 218);
INSERT INTO public.who_global_data VALUES (24221, 0, 0, 0, 0, 103, 43);
INSERT INTO public.who_global_data VALUES (24222, 1262, 103088, 17, 1282, 103, 49);
INSERT INTO public.who_global_data VALUES (24223, 65, 20470, 1, 122, 103, 1);
INSERT INTO public.who_global_data VALUES (24224, 2421, 36380, 8, 437, 103, 48);
INSERT INTO public.who_global_data VALUES (24225, 32, 6566, 0, 128, 103, 232);
INSERT INTO public.who_global_data VALUES (24226, 0, 803, 0, 1, 103, 175);
INSERT INTO public.who_global_data VALUES (24227, 101, 3545, 0, 25, 103, 21);
INSERT INTO public.who_global_data VALUES (24228, 7300, 258097, 124, 2201, 103, 156);
INSERT INTO public.who_global_data VALUES (24229, 0, 0, 0, 0, 103, 95);
INSERT INTO public.who_global_data VALUES (24230, 39, 11160, 1, 305, 103, 177);
INSERT INTO public.who_global_data VALUES (24231, 945, 40356, 2, 702, 103, 210);
INSERT INTO public.who_global_data VALUES (24232, 6, 5536, 0, 61, 103, 120);
INSERT INTO public.who_global_data VALUES (24233, 0, 38, 0, 0, 103, 135);
INSERT INTO public.who_global_data VALUES (24234, 509, 124527, 3, 2223, 103, 206);
INSERT INTO public.who_global_data VALUES (24235, 2021, 161635, 11, 12553, 103, 189);
INSERT INTO public.who_global_data VALUES (24236, 143, 106540, 12, 6199, 103, 129);
INSERT INTO public.who_global_data VALUES (24237, 0, 32585, 5, 949, 103, 121);
INSERT INTO public.who_global_data VALUES (24238, 0, 5079, 0, 83, 103, 59);
INSERT INTO public.who_global_data VALUES (24239, 0, 461, 0, 0, 103, 96);
INSERT INTO public.who_global_data VALUES (24240, 60, 4411, 0, 73, 103, 41);
INSERT INTO public.who_global_data VALUES (24241, 7, 5854, 0, 116, 103, 216);
INSERT INTO public.who_global_data VALUES (24242, 485, 93343, 7, 1426, 103, 236);
INSERT INTO public.who_global_data VALUES (24243, 0, 13, 0, 0, 103, 150);
INSERT INTO public.who_global_data VALUES (24244, 0, 490, 0, 0, 103, 61);
INSERT INTO public.who_global_data VALUES (24245, 0, 33, 0, 2, 103, 7);
INSERT INTO public.who_global_data VALUES (24246, 196, 14848, 0, 353, 103, 169);
INSERT INTO public.who_global_data VALUES (24247, 52010, 1107952, 116, 34478, 103, 28);
INSERT INTO public.who_global_data VALUES (24248, 0, 10376, 0, 69, 103, 85);
INSERT INTO public.who_global_data VALUES (24249, 0, 5859, 0, 20, 103, 211);
INSERT INTO public.who_global_data VALUES (24250, 0, 8919, 0, 54, 103, 60);
INSERT INTO public.who_global_data VALUES (24251, 1, 3660, 0, 119, 103, 3);
INSERT INTO public.who_global_data VALUES (24252, 1872, 30303, 14, 215, 103, 11);
INSERT INTO public.who_global_data VALUES (24253, 8685, 437866, 24, 10056, 103, 89);
INSERT INTO public.who_global_data VALUES (24254, 0, 47690, 0, 316, 103, 24);
INSERT INTO public.who_global_data VALUES (24255, 19, 660, 0, 0, 103, 162);
INSERT INTO public.who_global_data VALUES (24256, 790, 30782, 10, 574, 103, 100);
INSERT INTO public.who_global_data VALUES (24257, 0, 17, 0, 0, 103, 47);
INSERT INTO public.who_global_data VALUES (24258, 1, 28, 0, 0, 103, 29);
INSERT INTO public.who_global_data VALUES (24259, 145, 7474, 11, 126, 103, 40);
INSERT INTO public.who_global_data VALUES (24260, 41, 4196, 0, 71, 103, 222);
INSERT INTO public.who_global_data VALUES (24261, 155, 104787, 35, 3644, 103, 132);
INSERT INTO public.who_global_data VALUES (24262, 0, 265, 0, 13, 103, 130);
INSERT INTO public.who_global_data VALUES (24263, 0, 11669, 0, 71, 103, 234);
INSERT INTO public.who_global_data VALUES (24264, 0, 2403, 0, 41, 103, 23);
INSERT INTO public.who_global_data VALUES (24265, 34, 3994, 0, 117, 103, 192);
INSERT INTO public.who_global_data VALUES (24266, 11, 9026, 1, 232, 103, 69);
INSERT INTO public.who_global_data VALUES (24267, 0, 26, 0, 0, 103, 187);
INSERT INTO public.who_global_data VALUES (24268, 842, 92724, 5, 2617, 103, 230);
INSERT INTO public.who_global_data VALUES (24269, 2316, 61563, 47, 1472, 103, 77);
INSERT INTO public.who_global_data VALUES (24270, 54, 4448, 0, 11, 103, 9);
INSERT INTO public.who_global_data VALUES (24271, 45148, 7909959, 480, 119014, 103, 74);
INSERT INTO public.who_global_data VALUES (24272, 3732, 389712, 94, 13299, 103, 224);
INSERT INTO public.who_global_data VALUES (24273, 6191, 568896, 296, 32616, 103, 199);
INSERT INTO public.who_global_data VALUES (24274, 2554, 451707, 55, 10623, 103, 190);
INSERT INTO public.who_global_data VALUES (24275, 1020, 57128, 0, 1882, 103, 12);
INSERT INTO public.who_global_data VALUES (24276, 0, 348, 0, 24, 103, 104);
INSERT INTO public.who_global_data VALUES (24277, 246, 309707, 27, 2409, 103, 153);
INSERT INTO public.who_global_data VALUES (24278, 21273, 525782, 128, 37338, 103, 91);
INSERT INTO public.who_global_data VALUES (24279, 44, 8714, 2, 188, 103, 215);
INSERT INTO public.who_global_data VALUES (24280, 540, 97074, 7, 1718, 103, 84);
INSERT INTO public.who_global_data VALUES (24281, 0, 530, 0, 32, 103, 231);
INSERT INTO public.who_global_data VALUES (24282, 2337, 53087, 39, 579, 103, 196);
INSERT INTO public.who_global_data VALUES (24283, 152, 147615, 0, 2219, 103, 105);
INSERT INTO public.who_global_data VALUES (24284, 931, 49721, 6, 902, 103, 122);
INSERT INTO public.who_global_data VALUES (24285, 0, 0, 0, 0, 103, 159);
INSERT INTO public.who_global_data VALUES (24286, 186, 17900, 2, 653, 103, 75);
INSERT INTO public.who_global_data VALUES (24287, 708, 121635, 2, 746, 103, 27);
INSERT INTO public.who_global_data VALUES (24288, 420, 56170, 0, 1134, 103, 54);
INSERT INTO public.who_global_data VALUES (24289, 0, 24, 0, 0, 103, 226);
INSERT INTO public.who_global_data VALUES (24290, 211, 4678, 2, 56, 103, 79);
INSERT INTO public.who_global_data VALUES (24291, 1484, 71390, 3, 565, 103, 56);
INSERT INTO public.who_global_data VALUES (24292, 6, 1940, 0, 43, 103, 117);
INSERT INTO public.who_global_data VALUES (24293, 0, 1395, 0, 82, 103, 152);
INSERT INTO public.who_global_data VALUES (24294, 1639, 56013, 5, 795, 103, 16);
INSERT INTO public.who_global_data VALUES (24295, 23, 435, 0, 1, 103, 10);
INSERT INTO public.who_global_data VALUES (24296, 765, 10949, 2, 125, 103, 201);
INSERT INTO public.who_global_data VALUES (24297, 491, 14204, 1, 145, 103, 174);
INSERT INTO public.who_global_data VALUES (24298, 0, 16968, 0, 244, 103, 119);
INSERT INTO public.who_global_data VALUES (24299, 3, 5890, 0, 183, 103, 168);
INSERT INTO public.who_global_data VALUES (24300, 823, 26565, 8, 229, 103, 99);
INSERT INTO public.who_global_data VALUES (24301, 84, 11505, 0, 37, 103, 171);
INSERT INTO public.who_global_data VALUES (24302, 0, 3472, 0, 132, 103, 87);
INSERT INTO public.who_global_data VALUES (24303, 80, 5567, 2, 53, 103, 123);
INSERT INTO public.who_global_data VALUES (24304, 0, 0, 0, 0, 103, 151);
INSERT INTO public.who_global_data VALUES (24305, 6, 2800, 0, 27, 103, 213);
INSERT INTO public.who_global_data VALUES (24306, 1, 7663, 0, 163, 103, 118);
INSERT INTO public.who_global_data VALUES (24307, 0, 435, 0, 10, 103, 134);
INSERT INTO public.who_global_data VALUES (24308, 0, 4276, 0, 44, 103, 65);
INSERT INTO public.who_global_data VALUES (24309, 6025, 886800, 431, 88743, 103, 102);
INSERT INTO public.who_global_data VALUES (24310, 0, 0, 0, 0, 103, 223);
INSERT INTO public.who_global_data VALUES (24311, 10, 309, 0, 2, 103, 4);
INSERT INTO public.who_global_data VALUES (24312, 1, 338, 0, 0, 103, 146);
INSERT INTO public.who_global_data VALUES (24313, 332, 17354, 4, 270, 103, 31);
INSERT INTO public.who_global_data VALUES (24314, 0, 13, 0, 1, 103, 127);
INSERT INTO public.who_global_data VALUES (24315, 3020, 197481, 46, 3301, 103, 22);
INSERT INTO public.who_global_data VALUES (24316, 91, 11986, 1, 86, 103, 115);
INSERT INTO public.who_global_data VALUES (24317, 986, 44774, 29, 1095, 103, 106);
INSERT INTO public.who_global_data VALUES (24318, 81, 12660, 0, 133, 103, 90);
INSERT INTO public.who_global_data VALUES (24319, 0, 0, 0, 0, 103, 70);
INSERT INTO public.who_global_data VALUES (24320, 2856, 158089, 5, 847, 103, 46);
INSERT INTO public.who_global_data VALUES (24321, 10171, 290521, 27, 7042, 103, 139);
INSERT INTO public.who_global_data VALUES (24322, 0, 27, 0, 0, 103, 42);
INSERT INTO public.who_global_data VALUES (24323, 5, 1584, 0, 25, 103, 80);
INSERT INTO public.who_global_data VALUES (24324, 0, 4362, 0, 155, 103, 203);
INSERT INTO public.who_global_data VALUES (24325, 0, 1215, 0, 69, 103, 136);
INSERT INTO public.who_global_data VALUES (24326, 62, 61992, 1, 1130, 103, 63);
INSERT INTO public.who_global_data VALUES (24327, 0, 0, 0, 0, 103, 17);
INSERT INTO public.who_global_data VALUES (24328, 0, 88, 0, 2, 103, 172);
INSERT INTO public.who_global_data VALUES (24329, 560, 26954, 22, 919, 103, 109);
INSERT INTO public.who_global_data VALUES (24330, 0, 17232, 0, 279, 103, 200);
INSERT INTO public.who_global_data VALUES (24331, 453, 62046, 5, 519, 103, 93);
INSERT INTO public.who_global_data VALUES (24332, 1095, 112932, 27, 1174, 103, 5);
INSERT INTO public.who_global_data VALUES (24333, 0, 741, 0, 13, 103, 214);
INSERT INTO public.who_global_data VALUES (24334, 839, 327895, 9, 6736, 103, 204);
INSERT INTO public.who_global_data VALUES (24335, 0, 0, 0, 0, 103, 198);
INSERT INTO public.who_global_data VALUES (24336, 649, 128515, 6, 2628, 103, 173);
INSERT INTO public.who_global_data VALUES (24337, 5, 588, 0, 7, 103, 229);
INSERT INTO public.who_global_data VALUES (24338, 784, 59043, 15, 1293, 103, 76);
INSERT INTO public.who_global_data VALUES (24339, 3098, 886214, 62, 34095, 103, 138);
INSERT INTO public.who_global_data VALUES (24340, 2209, 370028, 43, 6977, 103, 98);
INSERT INTO public.who_global_data VALUES (24341, 0, 0, 0, 0, 103, 103);
INSERT INTO public.who_global_data VALUES (24342, 11742, 253688, 87, 4438, 103, 225);
INSERT INTO public.who_global_data VALUES (24343, 2577, 118686, 19, 2316, 103, 131);
INSERT INTO public.who_global_data VALUES (24344, 1223, 62503, 7, 801, 103, 235);
INSERT INTO public.who_global_data VALUES (24345, 205, 131170, 1, 230, 103, 137);
INSERT INTO public.who_global_data VALUES (24346, 119, 25955, 0, 457, 103, 81);
INSERT INTO public.who_global_data VALUES (24347, 414, 71503, 16, 1685, 103, 182);
INSERT INTO public.who_global_data VALUES (24348, 0, 5149, 0, 20, 103, 145);
INSERT INTO public.who_global_data VALUES (24349, 3855, 209648, 73, 6391, 103, 26);
INSERT INTO public.who_global_data VALUES (24350, 17347, 1531224, 219, 26269, 103, 170);
INSERT INTO public.who_global_data VALUES (24351, 6, 5066, 0, 34, 103, 191);
INSERT INTO public.who_global_data VALUES (24352, 0, 5, 0, 0, 103, 221);
INSERT INTO public.who_global_data VALUES (24353, 6, 83, 0, 0, 103, 64);
INSERT INTO public.who_global_data VALUES (24354, 0, 0, 0, 0, 103, 116);
INSERT INTO public.who_global_data VALUES (24355, 0, 19, 0, 0, 103, 128);
INSERT INTO public.who_global_data VALUES (24356, 2, 54, 0, 0, 103, 6);
INSERT INTO public.who_global_data VALUES (24357, 4, 542, 0, 8, 103, 227);
INSERT INTO public.who_global_data VALUES (24358, 0, 12, 0, 0, 103, 68);
INSERT INTO public.who_global_data VALUES (24359, 0, 73, 0, 0, 103, 184);
INSERT INTO public.who_global_data VALUES (24360, 0, 0, 0, 0, 103, 82);
INSERT INTO public.who_global_data VALUES (24361, 0, 844, 0, 42, 103, 149);
INSERT INTO public.who_global_data VALUES (24362, 0, 940, 0, 15, 103, 197);
INSERT INTO public.who_global_data VALUES (24363, 323, 344875, 15, 5296, 103, 78);
INSERT INTO public.who_global_data VALUES (24364, 8, 15551, 0, 321, 103, 233);
INSERT INTO public.who_global_data VALUES (24365, 614, 39486, 3, 792, 103, 133);
INSERT INTO public.who_global_data VALUES (24366, 0, 152, 0, 0, 103, 35);
INSERT INTO public.who_global_data VALUES (24367, 1, 2346, 0, 74, 103, 114);
INSERT INTO public.who_global_data VALUES (24368, 5, 57970, 0, 28, 103, 237);
INSERT INTO public.who_global_data VALUES (24369, 0, 14, 0, 0, 103, 55);
INSERT INTO public.who_global_data VALUES (24370, 0, 776, 0, 22, 103, 176);
INSERT INTO public.who_global_data VALUES (24371, 3042, 43843, 0, 159, 103, 202);
INSERT INTO public.who_global_data VALUES (24372, 1118, 24113, 17, 288, 103, 155);
INSERT INTO public.who_global_data VALUES (24373, 0, 4, 0, 0, 103, 32);
INSERT INTO public.who_global_data VALUES (24374, 44, 3941, 2, 104, 103, 220);
INSERT INTO public.who_global_data VALUES (24375, 1622, 715868, 24, 18968, 103, 30);
INSERT INTO public.who_global_data VALUES (24376, 0, 2883, 0, 56, 103, 147);
INSERT INTO public.who_global_data VALUES (24377, 15857, 1161333, 186, 37561, 103, 208);
INSERT INTO public.who_global_data VALUES (24378, 351, 7872, 1, 15, 103, 45);
INSERT INTO public.who_global_data VALUES (24379, 0, 13742, 0, 837, 103, 110);
INSERT INTO public.who_global_data VALUES (24380, 11, 5166, 0, 109, 103, 88);
INSERT INTO public.who_global_data VALUES (24381, 1477, 114340, 8, 5966, 103, 51);
INSERT INTO public.who_global_data VALUES (24382, 3204, 124022, 21, 2030, 103, 209);
INSERT INTO public.who_global_data VALUES (24383, 49, 5408, 2, 269, 103, 205);
INSERT INTO public.who_global_data VALUES (24384, 40, 10776, 0, 81, 103, 18);
INSERT INTO public.who_global_data VALUES (24385, 7, 3743, 0, 59, 103, 72);
INSERT INTO public.who_global_data VALUES (24386, 19790, 873804, 151, 44896, 103, 44);
INSERT INTO public.who_global_data VALUES (24387, 0, 29, 0, 0, 103, 15);
INSERT INTO public.who_global_data VALUES (24388, 0, 2162, 0, 52, 103, 25);
INSERT INTO public.who_global_data VALUES (24389, 0, 0, 0, 0, 103, 179);
INSERT INTO public.who_global_data VALUES (24390, 0, 0, 0, 0, 103, 34);
INSERT INTO public.who_global_data VALUES (24391, 16, 5503, 1, 105, 103, 207);
INSERT INTO public.who_global_data VALUES (24392, 0, 52399, 0, 983, 103, 166);
INSERT INTO public.who_global_data VALUES (24393, 8747, 967501, 72, 9799, 103, 126);
INSERT INTO public.who_global_data VALUES (24394, 0, 0, 0, 0, 103, 97);
INSERT INTO public.who_global_data VALUES (24395, 2, 701, 0, 6, 103, 36);
INSERT INTO public.who_global_data VALUES (24396, 0, 0, 0, 0, 103, 125);
INSERT INTO public.who_global_data VALUES (24397, 146, 11443, 2, 101, 103, 124);
INSERT INTO public.who_global_data VALUES (24398, 5426, 348924, 73, 6464, 103, 185);
INSERT INTO public.who_global_data VALUES (24399, 1359, 125123, 2, 477, 103, 194);
INSERT INTO public.who_global_data VALUES (24400, 0, 509, 0, 21, 103, 144);
INSERT INTO public.who_global_data VALUES (24401, 82626, 8485747, 821, 223328, 103, 19);
INSERT INTO public.who_global_data VALUES (24402, 0, 1346, 0, 21, 103, 217);
INSERT INTO public.who_global_data VALUES (24403, 48, 2807, 0, 53, 103, 148);
INSERT INTO public.who_global_data VALUES (24404, 280, 65480, 3, 550, 103, 86);
INSERT INTO public.who_global_data VALUES (24405, 0, 0, 0, 0, 103, 13);
INSERT INTO public.who_global_data VALUES (24406, 726, 89142, 11, 770, 103, 157);
INSERT INTO public.who_global_data VALUES (24407, 8, 1168, 0, 35, 103, 8);
INSERT INTO public.who_global_data VALUES (24408, 0, 1, 0, 0, 103, 73);
INSERT INTO public.who_global_data VALUES (24409, 0, 2064, 0, 600, 103, 101);
INSERT INTO public.who_global_data VALUES (24410, 0, 16117, 0, 348, 103, 165);
INSERT INTO public.who_global_data VALUES (24411, 7, 8276, 1, 237, 103, 14);
INSERT INTO public.who_global_data VALUES (24412, 81, 40768, 4, 1511, 104, 193);
INSERT INTO public.who_global_data VALUES (24413, 302, 18858, 4, 473, 104, 113);
INSERT INTO public.who_global_data VALUES (24414, 0, 55630, 0, 1897, 104, 143);
INSERT INTO public.who_global_data VALUES (24415, 0, 0, 0, 0, 104, 219);
INSERT INTO public.who_global_data VALUES (24416, 0, 4038, 0, 69, 104, 186);
INSERT INTO public.who_global_data VALUES (24417, 197, 9026, 2, 267, 104, 52);
INSERT INTO public.who_global_data VALUES (24418, 0, 3, 0, 0, 104, 180);
INSERT INTO public.who_global_data VALUES (24419, 0, 122, 0, 3, 104, 167);
INSERT INTO public.who_global_data VALUES (24420, 15718, 1069368, 381, 28338, 104, 154);
INSERT INTO public.who_global_data VALUES (24421, 2314, 77150, 23, 1175, 104, 94);
INSERT INTO public.who_global_data VALUES (24422, 0, 4389, 0, 36, 104, 66);
INSERT INTO public.who_global_data VALUES (24423, 15, 27499, 0, 905, 104, 58);
INSERT INTO public.who_global_data VALUES (24424, 2989, 79770, 6, 978, 104, 163);
INSERT INTO public.who_global_data VALUES (24425, 792, 49013, 8, 664, 104, 37);
INSERT INTO public.who_global_data VALUES (24426, 0, 6268, 0, 130, 104, 142);
INSERT INTO public.who_global_data VALUES (24427, 401, 79975, 1, 312, 104, 83);
INSERT INTO public.who_global_data VALUES (24428, 1094, 397507, 19, 5780, 104, 228);
INSERT INTO public.who_global_data VALUES (24429, 3, 227, 0, 7, 104, 188);
INSERT INTO public.who_global_data VALUES (24430, 0, 91167, 0, 945, 104, 62);
INSERT INTO public.who_global_data VALUES (24431, 11557, 347035, 94, 10852, 104, 160);
INSERT INTO public.who_global_data VALUES (24432, 55, 3050, 1, 47, 104, 50);
INSERT INTO public.who_global_data VALUES (24433, 0, 2557, 0, 41, 104, 33);
INSERT INTO public.who_global_data VALUES (24434, 0, 190, 0, 9, 104, 183);
INSERT INTO public.who_global_data VALUES (24435, 4, 340, 0, 0, 104, 92);
INSERT INTO public.who_global_data VALUES (24436, 167, 140612, 24, 8608, 104, 158);
INSERT INTO public.who_global_data VALUES (24437, 0, 131, 0, 3, 104, 67);
INSERT INTO public.who_global_data VALUES (24438, 1258, 39758, 10, 1075, 104, 57);
INSERT INTO public.who_global_data VALUES (24439, 0, 5923, 0, 21, 104, 38);
INSERT INTO public.who_global_data VALUES (24440, 30026, 5353656, 571, 156471, 104, 141);
INSERT INTO public.who_global_data VALUES (24441, 0, 72, 0, 1, 104, 178);
INSERT INTO public.who_global_data VALUES (24442, 0, 148, 0, 3, 104, 108);
INSERT INTO public.who_global_data VALUES (24443, 1043, 37562, 7, 1084, 104, 39);
INSERT INTO public.who_global_data VALUES (24444, 11, 2444, 0, 65, 104, 2);
INSERT INTO public.who_global_data VALUES (24445, 1, 556, 0, 1, 104, 195);
INSERT INTO public.who_global_data VALUES (24446, 124, 8322, 0, 94, 104, 107);
INSERT INTO public.who_global_data VALUES (24447, 0, 287, 0, 0, 104, 161);
INSERT INTO public.who_global_data VALUES (24448, 0, 21570, 0, 425, 104, 212);
INSERT INTO public.who_global_data VALUES (24449, 2584, 211732, 26, 9888, 104, 181);
INSERT INTO public.who_global_data VALUES (24450, 3, 239, 0, 1, 104, 53);
INSERT INTO public.who_global_data VALUES (24451, 0, 4862, 0, 62, 104, 164);
INSERT INTO public.who_global_data VALUES (24452, 11, 1434, 0, 96, 104, 140);
INSERT INTO public.who_global_data VALUES (24453, 1636, 500542, 48, 13892, 104, 20);
INSERT INTO public.who_global_data VALUES (24454, 22, 91675, 0, 4746, 104, 112);
INSERT INTO public.who_global_data VALUES (24455, 8672, 998942, 166, 29802, 104, 111);
INSERT INTO public.who_global_data VALUES (24456, 13, 517, 0, 7, 104, 71);
INSERT INTO public.who_global_data VALUES (24457, 0, 5253, 0, 92, 104, 218);
INSERT INTO public.who_global_data VALUES (24458, 0, 0, 0, 0, 104, 43);
INSERT INTO public.who_global_data VALUES (24459, 1210, 101826, 14, 1265, 104, 49);
INSERT INTO public.who_global_data VALUES (24460, 0, 20405, 0, 121, 104, 1);
INSERT INTO public.who_global_data VALUES (24461, 2242, 33959, 16, 429, 104, 48);
INSERT INTO public.who_global_data VALUES (24462, 55, 6534, 0, 128, 104, 232);
INSERT INTO public.who_global_data VALUES (24463, 0, 803, 0, 1, 104, 175);
INSERT INTO public.who_global_data VALUES (24464, 130, 3444, 0, 25, 104, 21);
INSERT INTO public.who_global_data VALUES (24465, 12474, 250797, 106, 2077, 104, 156);
INSERT INTO public.who_global_data VALUES (24466, 0, 0, 0, 0, 104, 95);
INSERT INTO public.who_global_data VALUES (24467, 0, 11121, 0, 304, 104, 177);
INSERT INTO public.who_global_data VALUES (24468, 789, 39411, 3, 700, 104, 210);
INSERT INTO public.who_global_data VALUES (24469, 2, 5530, 0, 61, 104, 120);
INSERT INTO public.who_global_data VALUES (24470, 1, 38, 0, 0, 104, 135);
INSERT INTO public.who_global_data VALUES (24471, 1145, 124018, 8, 2220, 104, 206);
INSERT INTO public.who_global_data VALUES (24472, 3163, 159614, 42, 12542, 104, 189);
INSERT INTO public.who_global_data VALUES (24473, 167, 106397, 11, 6187, 104, 129);
INSERT INTO public.who_global_data VALUES (24474, 164, 32585, 4, 944, 104, 121);
INSERT INTO public.who_global_data VALUES (24475, 0, 5079, 0, 83, 104, 59);
INSERT INTO public.who_global_data VALUES (24476, 0, 461, 0, 0, 104, 96);
INSERT INTO public.who_global_data VALUES (24477, 51, 4351, 0, 73, 104, 41);
INSERT INTO public.who_global_data VALUES (24478, 16, 5847, 0, 116, 104, 216);
INSERT INTO public.who_global_data VALUES (24479, 629, 92858, 19, 1419, 104, 236);
INSERT INTO public.who_global_data VALUES (24480, 0, 13, 0, 0, 104, 150);
INSERT INTO public.who_global_data VALUES (24481, 0, 490, 0, 0, 104, 61);
INSERT INTO public.who_global_data VALUES (24482, 0, 33, 0, 2, 104, 7);
INSERT INTO public.who_global_data VALUES (24483, 178, 14652, 0, 353, 104, 169);
INSERT INTO public.who_global_data VALUES (24484, 45388, 1055942, 137, 34362, 104, 28);
INSERT INTO public.who_global_data VALUES (24485, 34, 10376, 0, 69, 104, 85);
INSERT INTO public.who_global_data VALUES (24486, 0, 5859, 0, 20, 104, 211);
INSERT INTO public.who_global_data VALUES (24487, 0, 8919, 0, 54, 104, 60);
INSERT INTO public.who_global_data VALUES (24488, 0, 3659, 0, 119, 104, 3);
INSERT INTO public.who_global_data VALUES (24489, 1928, 28431, 8, 201, 104, 11);
INSERT INTO public.who_global_data VALUES (24490, 11176, 429181, 29, 10032, 104, 89);
INSERT INTO public.who_global_data VALUES (24491, 89, 47690, 2, 316, 104, 24);
INSERT INTO public.who_global_data VALUES (24492, 11, 641, 0, 0, 104, 162);
INSERT INTO public.who_global_data VALUES (24493, 935, 29992, 5, 564, 104, 100);
INSERT INTO public.who_global_data VALUES (24494, 0, 17, 0, 0, 104, 47);
INSERT INTO public.who_global_data VALUES (24495, 0, 27, 0, 0, 104, 29);
INSERT INTO public.who_global_data VALUES (24496, 0, 7329, 0, 115, 104, 40);
INSERT INTO public.who_global_data VALUES (24497, 34, 4155, 2, 71, 104, 222);
INSERT INTO public.who_global_data VALUES (24498, 730, 104632, 15, 3609, 104, 132);
INSERT INTO public.who_global_data VALUES (24499, 0, 265, 0, 13, 104, 130);
INSERT INTO public.who_global_data VALUES (24500, 0, 11669, 0, 71, 104, 234);
INSERT INTO public.who_global_data VALUES (24501, 0, 2403, 0, 41, 104, 23);
INSERT INTO public.who_global_data VALUES (24502, 83, 3960, 0, 117, 104, 192);
INSERT INTO public.who_global_data VALUES (24503, 16, 9015, 0, 231, 104, 69);
INSERT INTO public.who_global_data VALUES (24504, 0, 26, 0, 0, 104, 187);
INSERT INTO public.who_global_data VALUES (24505, 373, 91882, 8, 2612, 104, 230);
INSERT INTO public.who_global_data VALUES (24506, 3149, 59247, 35, 1425, 104, 77);
INSERT INTO public.who_global_data VALUES (24507, 86, 4394, 0, 11, 104, 9);
INSERT INTO public.who_global_data VALUES (24508, 50129, 7864811, 578, 118534, 104, 74);
INSERT INTO public.who_global_data VALUES (24509, 4070, 385980, 128, 13205, 104, 224);
INSERT INTO public.who_global_data VALUES (24510, 5814, 562705, 335, 32320, 104, 199);
INSERT INTO public.who_global_data VALUES (24511, 3204, 449153, 55, 10568, 104, 190);
INSERT INTO public.who_global_data VALUES (24512, 847, 56108, 4, 1882, 104, 12);
INSERT INTO public.who_global_data VALUES (24513, 0, 348, 0, 24, 104, 104);
INSERT INTO public.who_global_data VALUES (24514, 849, 309461, 26, 2382, 104, 153);
INSERT INTO public.who_global_data VALUES (24515, 19640, 504509, 151, 37210, 104, 91);
INSERT INTO public.who_global_data VALUES (24516, 32, 8670, 4, 186, 104, 215);
INSERT INTO public.who_global_data VALUES (24517, 699, 96534, 5, 1711, 104, 84);
INSERT INTO public.who_global_data VALUES (24518, 4, 530, 0, 32, 104, 231);
INSERT INTO public.who_global_data VALUES (24519, 1820, 50750, 32, 540, 104, 196);
INSERT INTO public.who_global_data VALUES (24520, 166, 147463, 41, 2219, 104, 105);
INSERT INTO public.who_global_data VALUES (24521, 947, 48790, 12, 896, 104, 122);
INSERT INTO public.who_global_data VALUES (24522, 0, 0, 0, 0, 104, 159);
INSERT INTO public.who_global_data VALUES (24523, 166, 17714, 2, 651, 104, 75);
INSERT INTO public.who_global_data VALUES (24524, 695, 120927, 4, 744, 104, 27);
INSERT INTO public.who_global_data VALUES (24525, 606, 55750, 4, 1134, 104, 54);
INSERT INTO public.who_global_data VALUES (24526, 0, 24, 0, 0, 104, 226);
INSERT INTO public.who_global_data VALUES (24527, 259, 4467, 4, 54, 104, 79);
INSERT INTO public.who_global_data VALUES (24528, 1427, 69906, 3, 562, 104, 56);
INSERT INTO public.who_global_data VALUES (24529, 0, 1934, 0, 43, 104, 117);
INSERT INTO public.who_global_data VALUES (24530, 2, 1395, 0, 82, 104, 152);
INSERT INTO public.who_global_data VALUES (24531, 990, 54374, 16, 790, 104, 16);
INSERT INTO public.who_global_data VALUES (24532, 37, 412, 0, 1, 104, 10);
INSERT INTO public.who_global_data VALUES (24533, 596, 10184, 6, 123, 104, 201);
INSERT INTO public.who_global_data VALUES (24534, 862, 13713, 3, 144, 104, 174);
INSERT INTO public.who_global_data VALUES (24535, 158, 16968, 6, 244, 104, 119);
INSERT INTO public.who_global_data VALUES (24536, 2, 5887, 0, 183, 104, 168);
INSERT INTO public.who_global_data VALUES (24537, 1228, 25742, 7, 221, 104, 99);
INSERT INTO public.who_global_data VALUES (24538, 30, 11421, 0, 37, 104, 171);
INSERT INTO public.who_global_data VALUES (24539, 32, 3472, 0, 132, 104, 87);
INSERT INTO public.who_global_data VALUES (24540, 122, 5487, 1, 51, 104, 123);
INSERT INTO public.who_global_data VALUES (24541, 0, 0, 0, 0, 104, 151);
INSERT INTO public.who_global_data VALUES (24542, 0, 2794, 0, 27, 104, 213);
INSERT INTO public.who_global_data VALUES (24543, 0, 7662, 0, 163, 104, 118);
INSERT INTO public.who_global_data VALUES (24544, 0, 435, 0, 10, 104, 134);
INSERT INTO public.who_global_data VALUES (24545, 0, 4276, 0, 44, 104, 65);
INSERT INTO public.who_global_data VALUES (24546, 6604, 880775, 418, 88312, 104, 102);
INSERT INTO public.who_global_data VALUES (24547, 0, 0, 0, 0, 104, 223);
INSERT INTO public.who_global_data VALUES (24548, 1, 299, 0, 2, 104, 4);
INSERT INTO public.who_global_data VALUES (24549, 9, 337, 0, 0, 104, 146);
INSERT INTO public.who_global_data VALUES (24550, 292, 17022, 3, 266, 104, 31);
INSERT INTO public.who_global_data VALUES (24551, 0, 13, 0, 1, 104, 127);
INSERT INTO public.who_global_data VALUES (24552, 4045, 194461, 50, 3255, 104, 22);
INSERT INTO public.who_global_data VALUES (24553, 147, 11895, 3, 85, 104, 115);
INSERT INTO public.who_global_data VALUES (24554, 1423, 43788, 28, 1066, 104, 106);
INSERT INTO public.who_global_data VALUES (24555, 78, 12579, 0, 133, 104, 90);
INSERT INTO public.who_global_data VALUES (24556, 0, 0, 0, 0, 104, 70);
INSERT INTO public.who_global_data VALUES (24557, 2225, 155233, 13, 842, 104, 46);
INSERT INTO public.who_global_data VALUES (24558, 8643, 280350, 55, 7015, 104, 139);
INSERT INTO public.who_global_data VALUES (24559, 0, 27, 0, 0, 104, 42);
INSERT INTO public.who_global_data VALUES (24560, 1, 1579, 0, 25, 104, 80);
INSERT INTO public.who_global_data VALUES (24561, 0, 4362, 0, 155, 104, 203);
INSERT INTO public.who_global_data VALUES (24562, 0, 1215, 0, 69, 104, 136);
INSERT INTO public.who_global_data VALUES (24563, 48, 61930, 0, 1129, 104, 63);
INSERT INTO public.who_global_data VALUES (24564, 0, 0, 0, 0, 104, 17);
INSERT INTO public.who_global_data VALUES (24565, 0, 88, 0, 2, 104, 172);
INSERT INTO public.who_global_data VALUES (24566, 403, 26394, 14, 897, 104, 109);
INSERT INTO public.who_global_data VALUES (24567, 0, 17232, 0, 279, 104, 200);
INSERT INTO public.who_global_data VALUES (24568, 410, 61593, 4, 514, 104, 93);
INSERT INTO public.who_global_data VALUES (24569, 0, 111837, 0, 1147, 104, 5);
INSERT INTO public.who_global_data VALUES (24570, 0, 741, 0, 13, 104, 214);
INSERT INTO public.who_global_data VALUES (24571, 847, 327056, 12, 6727, 104, 204);
INSERT INTO public.who_global_data VALUES (24572, 0, 0, 0, 0, 104, 198);
INSERT INTO public.who_global_data VALUES (24573, 639, 127866, 10, 2622, 104, 173);
INSERT INTO public.who_global_data VALUES (24574, 0, 583, 0, 7, 104, 229);
INSERT INTO public.who_global_data VALUES (24575, 733, 58259, 11, 1278, 104, 76);
INSERT INTO public.who_global_data VALUES (24576, 3240, 883116, 49, 34033, 104, 138);
INSERT INTO public.who_global_data VALUES (24577, 2020, 367819, 19, 6934, 104, 98);
INSERT INTO public.who_global_data VALUES (24578, 0, 0, 0, 0, 104, 103);
INSERT INTO public.who_global_data VALUES (24579, 13628, 241946, 179, 4351, 104, 225);
INSERT INTO public.who_global_data VALUES (24580, 3669, 116109, 21, 2297, 104, 131);
INSERT INTO public.who_global_data VALUES (24581, 296, 61280, 3, 794, 104, 235);
INSERT INTO public.who_global_data VALUES (24582, 254, 130965, 0, 229, 104, 137);
INSERT INTO public.who_global_data VALUES (24583, 61, 25836, 0, 457, 104, 81);
INSERT INTO public.who_global_data VALUES (24584, 833, 71089, 14, 1669, 104, 182);
INSERT INTO public.who_global_data VALUES (24585, 0, 5149, 0, 20, 104, 145);
INSERT INTO public.who_global_data VALUES (24586, 4761, 205793, 73, 6318, 104, 26);
INSERT INTO public.who_global_data VALUES (24587, 16710, 1513877, 229, 26050, 104, 170);
INSERT INTO public.who_global_data VALUES (24588, 8, 5060, 0, 34, 104, 191);
INSERT INTO public.who_global_data VALUES (24589, 0, 5, 0, 0, 104, 221);
INSERT INTO public.who_global_data VALUES (24590, 0, 77, 0, 0, 104, 64);
INSERT INTO public.who_global_data VALUES (24591, 0, 0, 0, 0, 104, 116);
INSERT INTO public.who_global_data VALUES (24592, 0, 19, 0, 0, 104, 128);
INSERT INTO public.who_global_data VALUES (24593, 4, 52, 0, 0, 104, 6);
INSERT INTO public.who_global_data VALUES (24594, 0, 538, 0, 8, 104, 227);
INSERT INTO public.who_global_data VALUES (24595, 0, 12, 0, 0, 104, 68);
INSERT INTO public.who_global_data VALUES (24596, 0, 73, 0, 0, 104, 184);
INSERT INTO public.who_global_data VALUES (24597, 0, 0, 0, 0, 104, 82);
INSERT INTO public.who_global_data VALUES (24598, 25, 844, 0, 42, 104, 149);
INSERT INTO public.who_global_data VALUES (24599, 2, 940, 0, 15, 104, 197);
INSERT INTO public.who_global_data VALUES (24600, 395, 344552, 17, 5281, 104, 78);
INSERT INTO public.who_global_data VALUES (24601, 18, 15543, 0, 321, 104, 233);
INSERT INTO public.who_global_data VALUES (24602, 757, 38872, 3, 789, 104, 133);
INSERT INTO public.who_global_data VALUES (24603, 0, 152, 0, 0, 104, 35);
INSERT INTO public.who_global_data VALUES (24604, 2, 2345, 0, 74, 104, 114);
INSERT INTO public.who_global_data VALUES (24605, 14, 57965, 0, 28, 104, 237);
INSERT INTO public.who_global_data VALUES (24606, 0, 14, 0, 0, 104, 55);
INSERT INTO public.who_global_data VALUES (24607, 0, 776, 0, 22, 104, 176);
INSERT INTO public.who_global_data VALUES (24608, 2890, 40801, 25, 159, 104, 202);
INSERT INTO public.who_global_data VALUES (24609, 1702, 22995, 5, 271, 104, 155);
INSERT INTO public.who_global_data VALUES (24610, 0, 4, 0, 0, 104, 32);
INSERT INTO public.who_global_data VALUES (24611, 0, 3897, 0, 102, 104, 220);
INSERT INTO public.who_global_data VALUES (24612, 1834, 714246, 53, 18944, 104, 30);
INSERT INTO public.who_global_data VALUES (24613, 5, 2883, 0, 56, 104, 147);
INSERT INTO public.who_global_data VALUES (24614, 25808, 1145476, 216, 37375, 104, 208);
INSERT INTO public.who_global_data VALUES (24615, 368, 7521, 0, 14, 104, 45);
INSERT INTO public.who_global_data VALUES (24616, 9, 13742, 1, 837, 104, 110);
INSERT INTO public.who_global_data VALUES (24617, 1, 5155, 0, 109, 104, 88);
INSERT INTO public.who_global_data VALUES (24618, 1868, 112863, 7, 5958, 104, 51);
INSERT INTO public.who_global_data VALUES (24619, 4655, 120818, 25, 2009, 104, 209);
INSERT INTO public.who_global_data VALUES (24620, 40, 5359, 3, 267, 104, 205);
INSERT INTO public.who_global_data VALUES (24621, 41, 10736, 0, 81, 104, 18);
INSERT INTO public.who_global_data VALUES (24622, 5, 3736, 0, 59, 104, 72);
INSERT INTO public.who_global_data VALUES (24623, 23012, 854014, 174, 44745, 104, 44);
INSERT INTO public.who_global_data VALUES (24624, 0, 29, 0, 0, 104, 15);
INSERT INTO public.who_global_data VALUES (24625, 0, 2162, 0, 52, 104, 25);
INSERT INTO public.who_global_data VALUES (24626, 0, 0, 0, 0, 104, 179);
INSERT INTO public.who_global_data VALUES (24627, 0, 0, 0, 0, 104, 34);
INSERT INTO public.who_global_data VALUES (24628, 41, 5487, 1, 104, 104, 207);
INSERT INTO public.who_global_data VALUES (24629, 1994, 52399, 106, 983, 104, 166);
INSERT INTO public.who_global_data VALUES (24630, 8821, 958754, 69, 9727, 104, 126);
INSERT INTO public.who_global_data VALUES (24631, 0, 0, 0, 0, 104, 97);
INSERT INTO public.who_global_data VALUES (24632, 0, 699, 0, 6, 104, 36);
INSERT INTO public.who_global_data VALUES (24633, 0, 0, 0, 0, 104, 125);
INSERT INTO public.who_global_data VALUES (24634, 134, 11297, 0, 99, 104, 124);
INSERT INTO public.who_global_data VALUES (24635, 6088, 343498, 102, 6391, 104, 185);
INSERT INTO public.who_global_data VALUES (24636, 1491, 123764, 0, 475, 104, 194);
INSERT INTO public.who_global_data VALUES (24637, 0, 509, 0, 21, 104, 144);
INSERT INTO public.who_global_data VALUES (24638, 82630, 8403121, 943, 222507, 104, 19);
INSERT INTO public.who_global_data VALUES (24639, 0, 1346, 0, 21, 104, 217);
INSERT INTO public.who_global_data VALUES (24640, 58, 2759, 0, 53, 104, 148);
INSERT INTO public.who_global_data VALUES (24641, 277, 65200, 3, 547, 104, 86);
INSERT INTO public.who_global_data VALUES (24642, 0, 0, 0, 0, 104, 13);
INSERT INTO public.who_global_data VALUES (24643, 0, 88416, 0, 759, 104, 157);
INSERT INTO public.who_global_data VALUES (24644, 12, 1160, 0, 35, 104, 8);
INSERT INTO public.who_global_data VALUES (24645, 0, 1, 0, 0, 104, 73);
INSERT INTO public.who_global_data VALUES (24646, 0, 2064, 0, 600, 104, 101);
INSERT INTO public.who_global_data VALUES (24647, 22, 16117, 2, 348, 104, 165);
INSERT INTO public.who_global_data VALUES (24648, 12, 8269, 0, 236, 104, 14);
INSERT INTO public.who_global_data VALUES (24649, 61, 40687, 2, 1507, 105, 193);
INSERT INTO public.who_global_data VALUES (24650, 306, 18556, 4, 469, 105, 113);
INSERT INTO public.who_global_data VALUES (24651, 273, 55630, 9, 1897, 105, 143);
INSERT INTO public.who_global_data VALUES (24652, 0, 0, 0, 0, 105, 219);
INSERT INTO public.who_global_data VALUES (24653, 227, 4038, 6, 69, 105, 186);
INSERT INTO public.who_global_data VALUES (24654, 247, 8829, 5, 265, 105, 52);
INSERT INTO public.who_global_data VALUES (24655, 0, 3, 0, 0, 105, 180);
INSERT INTO public.who_global_data VALUES (24656, 0, 122, 0, 3, 105, 167);
INSERT INTO public.who_global_data VALUES (24657, 16325, 1053650, 438, 27957, 105, 154);
INSERT INTO public.who_global_data VALUES (24658, 2213, 74836, 12, 1152, 105, 94);
INSERT INTO public.who_global_data VALUES (24659, 20, 4389, 1, 36, 105, 66);
INSERT INTO public.who_global_data VALUES (24660, 18, 27484, 0, 905, 105, 58);
INSERT INTO public.who_global_data VALUES (24661, 3442, 76781, 15, 972, 105, 163);
INSERT INTO public.who_global_data VALUES (24662, 803, 48221, 8, 656, 105, 37);
INSERT INTO public.who_global_data VALUES (24663, 133, 6268, 0, 130, 105, 142);
INSERT INTO public.who_global_data VALUES (24664, 363, 79574, 3, 311, 105, 83);
INSERT INTO public.who_global_data VALUES (24665, 1586, 396413, 14, 5761, 105, 228);
INSERT INTO public.who_global_data VALUES (24666, 0, 224, 0, 7, 105, 188);
INSERT INTO public.who_global_data VALUES (24667, 787, 91167, 0, 945, 105, 62);
INSERT INTO public.who_global_data VALUES (24668, 18877, 335478, 93, 10758, 105, 160);
INSERT INTO public.who_global_data VALUES (24669, 58, 2995, 0, 46, 105, 50);
INSERT INTO public.who_global_data VALUES (24670, 0, 2557, 0, 41, 105, 33);
INSERT INTO public.who_global_data VALUES (24671, 2, 190, 0, 9, 105, 183);
INSERT INTO public.who_global_data VALUES (24672, 0, 336, 0, 0, 105, 92);
INSERT INTO public.who_global_data VALUES (24673, 217, 140445, 26, 8584, 105, 158);
INSERT INTO public.who_global_data VALUES (24674, 0, 131, 0, 3, 105, 67);
INSERT INTO public.who_global_data VALUES (24675, 1178, 38500, 14, 1065, 105, 57);
INSERT INTO public.who_global_data VALUES (24676, 314, 5923, 0, 21, 105, 38);
INSERT INTO public.who_global_data VALUES (24677, 24858, 5323630, 497, 155900, 105, 141);
INSERT INTO public.who_global_data VALUES (24678, 0, 72, 0, 1, 105, 178);
INSERT INTO public.who_global_data VALUES (24679, 0, 148, 0, 3, 105, 108);
INSERT INTO public.who_global_data VALUES (24680, 1589, 36519, 13, 1077, 105, 39);
INSERT INTO public.who_global_data VALUES (24681, 12, 2433, 0, 65, 105, 2);
INSERT INTO public.who_global_data VALUES (24682, 2, 555, 0, 1, 105, 195);
INSERT INTO public.who_global_data VALUES (24683, 76, 8198, 3, 94, 105, 107);
INSERT INTO public.who_global_data VALUES (24684, 1, 287, 0, 0, 105, 161);
INSERT INTO public.who_global_data VALUES (24685, 0, 21570, 0, 425, 105, 212);
INSERT INTO public.who_global_data VALUES (24686, 2788, 209148, 33, 9862, 105, 181);
INSERT INTO public.who_global_data VALUES (24687, 0, 236, 0, 1, 105, 53);
INSERT INTO public.who_global_data VALUES (24688, 0, 4862, 0, 62, 105, 164);
INSERT INTO public.who_global_data VALUES (24689, 13, 1423, 0, 96, 105, 140);
INSERT INTO public.who_global_data VALUES (24690, 1775, 498906, 52, 13844, 105, 20);
INSERT INTO public.who_global_data VALUES (24691, 32, 91653, 0, 4746, 105, 112);
INSERT INTO public.who_global_data VALUES (24692, 8570, 990270, 172, 29636, 105, 111);
INSERT INTO public.who_global_data VALUES (24693, 0, 504, 0, 7, 105, 71);
INSERT INTO public.who_global_data VALUES (24694, 97, 5253, 0, 92, 105, 218);
INSERT INTO public.who_global_data VALUES (24695, 0, 0, 0, 0, 105, 43);
INSERT INTO public.who_global_data VALUES (24696, 1191, 100616, 15, 1251, 105, 49);
INSERT INTO public.who_global_data VALUES (24697, 15, 20405, 0, 121, 105, 1);
INSERT INTO public.who_global_data VALUES (24698, 1867, 31717, 7, 413, 105, 48);
INSERT INTO public.who_global_data VALUES (24699, 58, 6479, 0, 128, 105, 232);
INSERT INTO public.who_global_data VALUES (24700, 19, 803, 0, 1, 105, 175);
INSERT INTO public.who_global_data VALUES (24701, 160, 3314, 0, 25, 105, 21);
INSERT INTO public.who_global_data VALUES (24702, 15258, 238323, 126, 1971, 105, 156);
INSERT INTO public.who_global_data VALUES (24703, 0, 0, 0, 0, 105, 95);
INSERT INTO public.who_global_data VALUES (24704, 25, 11121, 0, 304, 105, 177);
INSERT INTO public.who_global_data VALUES (24705, 859, 38622, 3, 697, 105, 210);
INSERT INTO public.who_global_data VALUES (24706, 6, 5528, 0, 61, 105, 120);
INSERT INTO public.who_global_data VALUES (24707, 4, 37, 0, 0, 105, 135);
INSERT INTO public.who_global_data VALUES (24708, 0, 122873, 0, 2212, 105, 206);
INSERT INTO public.who_global_data VALUES (24709, 0, 156451, 0, 12500, 105, 189);
INSERT INTO public.who_global_data VALUES (24710, 170, 106230, 10, 6176, 105, 129);
INSERT INTO public.who_global_data VALUES (24711, 159, 32421, 4, 940, 105, 121);
INSERT INTO public.who_global_data VALUES (24712, 3, 5079, 0, 83, 105, 59);
INSERT INTO public.who_global_data VALUES (24713, 9, 461, 0, 0, 105, 96);
INSERT INTO public.who_global_data VALUES (24714, 53, 4300, 2, 73, 105, 41);
INSERT INTO public.who_global_data VALUES (24715, 17, 5831, 0, 116, 105, 216);
INSERT INTO public.who_global_data VALUES (24716, 536, 92229, 4, 1400, 105, 236);
INSERT INTO public.who_global_data VALUES (24717, 0, 13, 0, 0, 105, 150);
INSERT INTO public.who_global_data VALUES (24718, 0, 490, 0, 0, 105, 61);
INSERT INTO public.who_global_data VALUES (24719, 0, 33, 0, 2, 105, 7);
INSERT INTO public.who_global_data VALUES (24720, 219, 14474, 0, 353, 105, 169);
INSERT INTO public.who_global_data VALUES (24721, 41825, 1010554, 297, 34225, 105, 28);
INSERT INTO public.who_global_data VALUES (24722, 0, 10342, 0, 69, 105, 85);
INSERT INTO public.who_global_data VALUES (24723, 698, 5859, 1, 20, 105, 211);
INSERT INTO public.who_global_data VALUES (24724, 18, 8919, 0, 54, 105, 60);
INSERT INTO public.who_global_data VALUES (24725, 0, 3659, 0, 119, 105, 3);
INSERT INTO public.who_global_data VALUES (24726, 1941, 26503, 10, 193, 105, 11);
INSERT INTO public.who_global_data VALUES (24727, 14714, 418005, 49, 10003, 105, 89);
INSERT INTO public.who_global_data VALUES (24728, 63, 47601, 2, 314, 105, 24);
INSERT INTO public.who_global_data VALUES (24729, 9, 630, 0, 0, 105, 162);
INSERT INTO public.who_global_data VALUES (24730, 841, 29057, 10, 559, 105, 100);
INSERT INTO public.who_global_data VALUES (24731, 0, 17, 0, 0, 105, 47);
INSERT INTO public.who_global_data VALUES (24732, 0, 27, 0, 0, 105, 29);
INSERT INTO public.who_global_data VALUES (24733, 0, 7329, 0, 115, 105, 40);
INSERT INTO public.who_global_data VALUES (24734, 84, 4121, 0, 69, 105, 222);
INSERT INTO public.who_global_data VALUES (24735, 730, 103902, 14, 3594, 105, 132);
INSERT INTO public.who_global_data VALUES (24736, 5, 265, 0, 13, 105, 130);
INSERT INTO public.who_global_data VALUES (24737, 34, 11669, 0, 71, 105, 234);
INSERT INTO public.who_global_data VALUES (24738, 0, 2403, 0, 41, 105, 23);
INSERT INTO public.who_global_data VALUES (24739, 27, 3877, 1, 117, 105, 192);
INSERT INTO public.who_global_data VALUES (24740, 20, 8999, 0, 231, 105, 69);
INSERT INTO public.who_global_data VALUES (24741, 0, 26, 0, 0, 105, 187);
INSERT INTO public.who_global_data VALUES (24742, 431, 91509, 8, 2604, 105, 230);
INSERT INTO public.who_global_data VALUES (24743, 1820, 56098, 38, 1390, 105, 77);
INSERT INTO public.who_global_data VALUES (24744, 40, 4308, 0, 11, 105, 9);
INSERT INTO public.who_global_data VALUES (24745, 53370, 7814682, 650, 117956, 105, 74);
INSERT INTO public.who_global_data VALUES (24746, 4369, 381910, 118, 13077, 105, 224);
INSERT INTO public.who_global_data VALUES (24747, 6134, 556891, 335, 31985, 105, 199);
INSERT INTO public.who_global_data VALUES (24748, 3785, 445949, 48, 10513, 105, 190);
INSERT INTO public.who_global_data VALUES (24749, 785, 55261, 7, 1878, 105, 12);
INSERT INTO public.who_global_data VALUES (24750, 0, 348, 0, 24, 105, 104);
INSERT INTO public.who_global_data VALUES (24751, 1032, 308612, 29, 2356, 105, 153);
INSERT INTO public.who_global_data VALUES (24752, 19143, 484869, 91, 37059, 105, 91);
INSERT INTO public.who_global_data VALUES (24753, 38, 8638, 3, 182, 105, 215);
INSERT INTO public.who_global_data VALUES (24754, 697, 95835, 12, 1706, 105, 84);
INSERT INTO public.who_global_data VALUES (24755, 3, 526, 0, 32, 105, 231);
INSERT INTO public.who_global_data VALUES (24756, 2489, 48930, 27, 508, 105, 196);
INSERT INTO public.who_global_data VALUES (24757, 315, 147297, 0, 2178, 105, 105);
INSERT INTO public.who_global_data VALUES (24758, 631, 47843, 14, 884, 105, 122);
INSERT INTO public.who_global_data VALUES (24759, 0, 0, 0, 0, 105, 159);
INSERT INTO public.who_global_data VALUES (24760, 169, 17548, 2, 649, 105, 75);
INSERT INTO public.who_global_data VALUES (24761, 812, 120232, 10, 740, 105, 27);
INSERT INTO public.who_global_data VALUES (24762, 556, 55144, 4, 1130, 105, 54);
INSERT INTO public.who_global_data VALUES (24763, 0, 24, 0, 0, 105, 226);
INSERT INTO public.who_global_data VALUES (24764, 250, 4208, 1, 50, 105, 79);
INSERT INTO public.who_global_data VALUES (24765, 1534, 68479, 7, 559, 105, 56);
INSERT INTO public.who_global_data VALUES (24766, 11, 1934, 0, 43, 105, 117);
INSERT INTO public.who_global_data VALUES (24767, 8, 1393, 0, 82, 105, 152);
INSERT INTO public.who_global_data VALUES (24768, 764, 53384, 6, 774, 105, 16);
INSERT INTO public.who_global_data VALUES (24769, 23, 375, 0, 1, 105, 10);
INSERT INTO public.who_global_data VALUES (24770, 480, 9588, 1, 117, 105, 201);
INSERT INTO public.who_global_data VALUES (24771, 518, 12851, 1, 141, 105, 174);
INSERT INTO public.who_global_data VALUES (24772, 0, 16810, 0, 238, 105, 119);
INSERT INTO public.who_global_data VALUES (24773, 11, 5885, 0, 183, 105, 168);
INSERT INTO public.who_global_data VALUES (24774, 710, 24514, 10, 214, 105, 99);
INSERT INTO public.who_global_data VALUES (24775, 33, 11391, 0, 37, 105, 171);
INSERT INTO public.who_global_data VALUES (24776, 0, 3440, 0, 132, 105, 87);
INSERT INTO public.who_global_data VALUES (24777, 115, 5365, 1, 50, 105, 123);
INSERT INTO public.who_global_data VALUES (24778, 0, 0, 0, 0, 105, 151);
INSERT INTO public.who_global_data VALUES (24779, 0, 2794, 0, 27, 105, 213);
INSERT INTO public.who_global_data VALUES (24780, 24, 7662, 0, 163, 105, 118);
INSERT INTO public.who_global_data VALUES (24781, 14, 435, 0, 10, 105, 134);
INSERT INTO public.who_global_data VALUES (24782, 73, 4276, 0, 44, 105, 65);
INSERT INTO public.who_global_data VALUES (24783, 6612, 874171, 479, 87894, 105, 102);
INSERT INTO public.who_global_data VALUES (24784, 0, 0, 0, 0, 105, 223);
INSERT INTO public.who_global_data VALUES (24785, 14, 298, 0, 2, 105, 4);
INSERT INTO public.who_global_data VALUES (24786, 0, 328, 0, 0, 105, 146);
INSERT INTO public.who_global_data VALUES (24787, 194, 16730, 8, 263, 105, 31);
INSERT INTO public.who_global_data VALUES (24788, 0, 13, 0, 1, 105, 127);
INSERT INTO public.who_global_data VALUES (24789, 3685, 190416, 73, 3205, 105, 22);
INSERT INTO public.who_global_data VALUES (24790, 189, 11748, 1, 82, 105, 115);
INSERT INTO public.who_global_data VALUES (24791, 1357, 42365, 33, 1038, 105, 106);
INSERT INTO public.who_global_data VALUES (24792, 41, 12501, 0, 133, 105, 90);
INSERT INTO public.who_global_data VALUES (24793, 0, 0, 0, 0, 105, 70);
INSERT INTO public.who_global_data VALUES (24794, 4499, 153008, 17, 829, 105, 46);
INSERT INTO public.who_global_data VALUES (24795, 9978, 271707, 47, 6960, 105, 139);
INSERT INTO public.who_global_data VALUES (24796, 0, 27, 0, 0, 105, 42);
INSERT INTO public.who_global_data VALUES (24797, 11, 1578, 0, 25, 105, 80);
INSERT INTO public.who_global_data VALUES (24798, 0, 4362, 0, 155, 105, 203);
INSERT INTO public.who_global_data VALUES (24799, 0, 1215, 0, 69, 105, 136);
INSERT INTO public.who_global_data VALUES (24800, 77, 61882, 2, 1129, 105, 63);
INSERT INTO public.who_global_data VALUES (24801, 0, 0, 0, 0, 105, 17);
INSERT INTO public.who_global_data VALUES (24802, 0, 88, 0, 2, 105, 172);
INSERT INTO public.who_global_data VALUES (24803, 518, 25991, 9, 883, 105, 109);
INSERT INTO public.who_global_data VALUES (24804, 268, 17232, 0, 279, 105, 200);
INSERT INTO public.who_global_data VALUES (24805, 513, 61183, 4, 510, 105, 93);
INSERT INTO public.who_global_data VALUES (24806, 0, 111837, 0, 1147, 105, 5);
INSERT INTO public.who_global_data VALUES (24807, 0, 741, 0, 13, 105, 214);
INSERT INTO public.who_global_data VALUES (24808, 736, 326209, 13, 6715, 105, 204);
INSERT INTO public.who_global_data VALUES (24809, 0, 0, 0, 0, 105, 198);
INSERT INTO public.who_global_data VALUES (24810, 792, 127227, 15, 2612, 105, 173);
INSERT INTO public.who_global_data VALUES (24811, 0, 583, 0, 7, 105, 229);
INSERT INTO public.who_global_data VALUES (24812, 707, 57526, 17, 1267, 105, 76);
INSERT INTO public.who_global_data VALUES (24813, 2991, 879876, 47, 33984, 105, 138);
INSERT INTO public.who_global_data VALUES (24814, 1911, 365799, 132, 6915, 105, 98);
INSERT INTO public.who_global_data VALUES (24815, 0, 0, 0, 0, 105, 103);
INSERT INTO public.who_global_data VALUES (24816, 13632, 228318, 153, 4172, 105, 225);
INSERT INTO public.who_global_data VALUES (24817, 2899, 112440, 31, 2276, 105, 131);
INSERT INTO public.who_global_data VALUES (24818, 1947, 60984, 8, 791, 105, 235);
INSERT INTO public.who_global_data VALUES (24819, 249, 130711, 1, 229, 105, 137);
INSERT INTO public.who_global_data VALUES (24820, 77, 25775, 2, 457, 105, 81);
INSERT INTO public.who_global_data VALUES (24821, 688, 70256, 14, 1655, 105, 182);
INSERT INTO public.who_global_data VALUES (24822, 134, 5149, 1, 20, 105, 145);
INSERT INTO public.who_global_data VALUES (24823, 5028, 201032, 82, 6245, 105, 26);
INSERT INTO public.who_global_data VALUES (24824, 16521, 1497167, 296, 25821, 105, 170);
INSERT INTO public.who_global_data VALUES (24825, 35, 5052, 0, 34, 105, 191);
INSERT INTO public.who_global_data VALUES (24826, 0, 5, 0, 0, 105, 221);
INSERT INTO public.who_global_data VALUES (24827, 0, 77, 0, 0, 105, 64);
INSERT INTO public.who_global_data VALUES (24828, 0, 0, 0, 0, 105, 116);
INSERT INTO public.who_global_data VALUES (24829, 0, 19, 0, 0, 105, 128);
INSERT INTO public.who_global_data VALUES (24830, 6, 48, 0, 0, 105, 6);
INSERT INTO public.who_global_data VALUES (24831, 0, 538, 0, 8, 105, 227);
INSERT INTO public.who_global_data VALUES (24832, 0, 12, 0, 0, 105, 68);
INSERT INTO public.who_global_data VALUES (24833, 5, 73, 0, 0, 105, 184);
INSERT INTO public.who_global_data VALUES (24834, 0, 0, 0, 0, 105, 82);
INSERT INTO public.who_global_data VALUES (24835, 17, 819, 0, 42, 105, 149);
INSERT INTO public.who_global_data VALUES (24836, 3, 938, 0, 15, 105, 197);
INSERT INTO public.who_global_data VALUES (24837, 383, 344157, 14, 5264, 105, 78);
INSERT INTO public.who_global_data VALUES (24838, 17, 15525, 0, 321, 105, 233);
INSERT INTO public.who_global_data VALUES (24839, 579, 38115, 3, 786, 105, 133);
INSERT INTO public.who_global_data VALUES (24840, 0, 152, 0, 0, 105, 35);
INSERT INTO public.who_global_data VALUES (24841, 3, 2343, 1, 74, 105, 114);
INSERT INTO public.who_global_data VALUES (24842, 10, 57951, 0, 28, 105, 237);
INSERT INTO public.who_global_data VALUES (24843, 0, 14, 0, 0, 105, 55);
INSERT INTO public.who_global_data VALUES (24844, 7, 776, 0, 22, 105, 176);
INSERT INTO public.who_global_data VALUES (24845, 2581, 37911, 19, 134, 105, 202);
INSERT INTO public.who_global_data VALUES (24846, 1969, 21293, 20, 266, 105, 155);
INSERT INTO public.who_global_data VALUES (24847, 0, 4, 0, 0, 105, 32);
INSERT INTO public.who_global_data VALUES (24848, 0, 3897, 0, 102, 105, 220);
INSERT INTO public.who_global_data VALUES (24849, 1897, 712412, 48, 18891, 105, 30);
INSERT INTO public.who_global_data VALUES (24850, 2, 2878, 0, 56, 105, 147);
INSERT INTO public.who_global_data VALUES (24851, 24851, 1119668, 201, 37159, 105, 208);
INSERT INTO public.who_global_data VALUES (24852, 866, 7153, 0, 14, 105, 45);
INSERT INTO public.who_global_data VALUES (24853, 0, 13733, 0, 836, 105, 110);
INSERT INTO public.who_global_data VALUES (24854, 4, 5154, 0, 109, 105, 88);
INSERT INTO public.who_global_data VALUES (24855, 1666, 110995, 9, 5951, 105, 51);
INSERT INTO public.who_global_data VALUES (24856, 7506, 116163, 25, 1984, 105, 209);
INSERT INTO public.who_global_data VALUES (24857, 52, 5319, 4, 264, 105, 205);
INSERT INTO public.who_global_data VALUES (24858, 42, 10695, 0, 81, 105, 18);
INSERT INTO public.who_global_data VALUES (24859, 4, 3731, 0, 59, 105, 72);
INSERT INTO public.who_global_data VALUES (24860, 20531, 831002, 224, 44571, 105, 44);
INSERT INTO public.who_global_data VALUES (24861, 0, 29, 0, 0, 105, 15);
INSERT INTO public.who_global_data VALUES (24862, 23, 2162, 0, 52, 105, 25);
INSERT INTO public.who_global_data VALUES (24863, 0, 0, 0, 0, 105, 179);
INSERT INTO public.who_global_data VALUES (24864, 0, 0, 0, 0, 105, 34);
INSERT INTO public.who_global_data VALUES (24865, 54, 5446, 2, 103, 105, 207);
INSERT INTO public.who_global_data VALUES (24866, 1606, 50405, 58, 877, 105, 166);
INSERT INTO public.who_global_data VALUES (24867, 8895, 949933, 74, 9658, 105, 126);
INSERT INTO public.who_global_data VALUES (24868, 0, 0, 0, 0, 105, 97);
INSERT INTO public.who_global_data VALUES (24869, 1, 699, 0, 6, 105, 36);
INSERT INTO public.who_global_data VALUES (24870, 0, 0, 0, 0, 105, 125);
INSERT INTO public.who_global_data VALUES (24871, 122, 11163, 1, 99, 105, 124);
INSERT INTO public.who_global_data VALUES (24872, 7014, 337410, 125, 6289, 105, 185);
INSERT INTO public.who_global_data VALUES (24873, 1563, 122273, 1, 475, 105, 194);
INSERT INTO public.who_global_data VALUES (24874, 0, 509, 0, 21, 105, 144);
INSERT INTO public.who_global_data VALUES (24875, 72342, 8320491, 1001, 221564, 105, 19);
INSERT INTO public.who_global_data VALUES (24876, 3, 1346, 0, 21, 105, 217);
INSERT INTO public.who_global_data VALUES (24877, 38, 2701, 0, 53, 105, 148);
INSERT INTO public.who_global_data VALUES (24878, 290, 64923, 3, 544, 105, 86);
INSERT INTO public.who_global_data VALUES (24879, 0, 0, 0, 0, 105, 13);
INSERT INTO public.who_global_data VALUES (24880, 381, 88416, 6, 759, 105, 157);
INSERT INTO public.who_global_data VALUES (24881, 0, 1148, 0, 35, 105, 8);
INSERT INTO public.who_global_data VALUES (24882, 0, 1, 0, 0, 105, 73);
INSERT INTO public.who_global_data VALUES (24883, 3, 2064, 2, 600, 105, 101);
INSERT INTO public.who_global_data VALUES (24884, 60, 16095, 0, 346, 105, 165);
INSERT INTO public.who_global_data VALUES (24885, 15, 8257, 0, 236, 105, 14);
INSERT INTO public.who_global_data VALUES (24886, 116, 40626, 2, 1505, 106, 193);
INSERT INTO public.who_global_data VALUES (24887, 302, 18250, 3, 465, 106, 113);
INSERT INTO public.who_global_data VALUES (24888, 266, 55357, 8, 1888, 106, 143);
INSERT INTO public.who_global_data VALUES (24889, 0, 0, 0, 0, 106, 219);
INSERT INTO public.who_global_data VALUES (24890, 0, 3811, 0, 63, 106, 186);
INSERT INTO public.who_global_data VALUES (24891, 244, 8582, 5, 260, 106, 52);
INSERT INTO public.who_global_data VALUES (24892, 0, 3, 0, 0, 106, 180);
INSERT INTO public.who_global_data VALUES (24893, 0, 122, 0, 3, 106, 167);
INSERT INTO public.who_global_data VALUES (24894, 15928, 1037325, 344, 27519, 106, 154);
INSERT INTO public.who_global_data VALUES (24895, 2474, 72623, 14, 1140, 106, 94);
INSERT INTO public.who_global_data VALUES (24896, 14, 4369, 1, 35, 106, 66);
INSERT INTO public.who_global_data VALUES (24897, 22, 27466, 0, 905, 106, 58);
INSERT INTO public.who_global_data VALUES (24898, 2570, 73339, 17, 957, 106, 163);
INSERT INTO public.who_global_data VALUES (24899, 825, 47418, 6, 648, 106, 37);
INSERT INTO public.who_global_data VALUES (24900, 84, 6135, 3, 130, 106, 142);
INSERT INTO public.who_global_data VALUES (24901, 304, 79211, 0, 308, 106, 83);
INSERT INTO public.who_global_data VALUES (24902, 1696, 394827, 24, 5747, 106, 228);
INSERT INTO public.who_global_data VALUES (24903, 2, 224, 0, 7, 106, 188);
INSERT INTO public.who_global_data VALUES (24904, 738, 90380, 4, 945, 106, 62);
INSERT INTO public.who_global_data VALUES (24905, 17687, 316601, 55, 10665, 106, 160);
INSERT INTO public.who_global_data VALUES (24906, 51, 2937, 1, 46, 106, 50);
INSERT INTO public.who_global_data VALUES (24907, 0, 2557, 0, 41, 106, 33);
INSERT INTO public.who_global_data VALUES (24908, 0, 188, 0, 9, 106, 183);
INSERT INTO public.who_global_data VALUES (24909, 4, 336, 0, 0, 106, 92);
INSERT INTO public.who_global_data VALUES (24910, 191, 140228, 32, 8558, 106, 158);
INSERT INTO public.who_global_data VALUES (24911, 0, 131, 0, 3, 106, 67);
INSERT INTO public.who_global_data VALUES (24912, 1003, 37322, 20, 1051, 106, 57);
INSERT INTO public.who_global_data VALUES (24913, 0, 5609, 0, 21, 106, 38);
INSERT INTO public.who_global_data VALUES (24914, 24818, 5298772, 566, 155403, 106, 141);
INSERT INTO public.who_global_data VALUES (24915, 0, 72, 0, 1, 106, 178);
INSERT INTO public.who_global_data VALUES (24916, 1, 148, 0, 3, 106, 108);
INSERT INTO public.who_global_data VALUES (24917, 1595, 34930, 16, 1064, 106, 39);
INSERT INTO public.who_global_data VALUES (24918, 15, 2421, 0, 65, 106, 2);
INSERT INTO public.who_global_data VALUES (24919, 2, 553, 0, 1, 106, 195);
INSERT INTO public.who_global_data VALUES (24920, 89, 8122, 1, 91, 106, 107);
INSERT INTO public.who_global_data VALUES (24921, 0, 286, 0, 0, 106, 161);
INSERT INTO public.who_global_data VALUES (24922, 0, 21570, 0, 425, 106, 212);
INSERT INTO public.who_global_data VALUES (24923, 2672, 206360, 35, 9829, 106, 181);
INSERT INTO public.who_global_data VALUES (24924, 1, 236, 0, 1, 106, 53);
INSERT INTO public.who_global_data VALUES (24925, 0, 4862, 0, 62, 106, 164);
INSERT INTO public.who_global_data VALUES (24926, 6, 1410, 0, 96, 106, 140);
INSERT INTO public.who_global_data VALUES (24927, 1494, 497131, 73, 13792, 106, 20);
INSERT INTO public.who_global_data VALUES (24928, 33, 91621, 0, 4746, 106, 112);
INSERT INTO public.who_global_data VALUES (24929, 7561, 981700, 192, 29464, 106, 111);
INSERT INTO public.who_global_data VALUES (24930, 0, 504, 0, 7, 106, 71);
INSERT INTO public.who_global_data VALUES (24931, 0, 5156, 0, 92, 106, 218);
INSERT INTO public.who_global_data VALUES (24932, 0, 0, 0, 0, 106, 43);
INSERT INTO public.who_global_data VALUES (24933, 1503, 99425, 14, 1236, 106, 49);
INSERT INTO public.who_global_data VALUES (24934, 27, 20390, 0, 121, 106, 1);
INSERT INTO public.who_global_data VALUES (24935, 1563, 29850, 13, 406, 106, 48);
INSERT INTO public.who_global_data VALUES (24936, 53, 6421, 1, 128, 106, 232);
INSERT INTO public.who_global_data VALUES (24937, 25, 784, 0, 1, 106, 175);
INSERT INTO public.who_global_data VALUES (24938, 188, 3154, 0, 25, 106, 21);
INSERT INTO public.who_global_data VALUES (24939, 14150, 223065, 106, 1845, 106, 156);
INSERT INTO public.who_global_data VALUES (24940, 0, 0, 0, 0, 106, 95);
INSERT INTO public.who_global_data VALUES (24941, 19, 11096, 1, 304, 106, 177);
INSERT INTO public.who_global_data VALUES (24942, 760, 37763, 4, 694, 106, 210);
INSERT INTO public.who_global_data VALUES (24943, 10, 5522, 0, 61, 106, 120);
INSERT INTO public.who_global_data VALUES (24944, 0, 33, 0, 0, 106, 135);
INSERT INTO public.who_global_data VALUES (24945, 475, 122873, 6, 2212, 106, 206);
INSERT INTO public.who_global_data VALUES (24946, 826, 156451, 47, 12500, 106, 189);
INSERT INTO public.who_global_data VALUES (24947, 177, 106060, 11, 6166, 106, 129);
INSERT INTO public.who_global_data VALUES (24948, 142, 32262, 3, 936, 106, 121);
INSERT INTO public.who_global_data VALUES (24949, 2, 5076, 0, 83, 106, 59);
INSERT INTO public.who_global_data VALUES (24950, 0, 452, 0, 0, 106, 96);
INSERT INTO public.who_global_data VALUES (24951, 76, 4247, 0, 71, 106, 41);
INSERT INTO public.who_global_data VALUES (24952, 9, 5814, 0, 116, 106, 216);
INSERT INTO public.who_global_data VALUES (24953, 575, 91693, 12, 1396, 106, 236);
INSERT INTO public.who_global_data VALUES (24954, 0, 13, 0, 0, 106, 150);
INSERT INTO public.who_global_data VALUES (24955, 2, 490, 0, 0, 106, 61);
INSERT INTO public.who_global_data VALUES (24956, 0, 33, 0, 2, 106, 7);
INSERT INTO public.who_global_data VALUES (24957, 184, 14255, 0, 353, 106, 169);
INSERT INTO public.who_global_data VALUES (24958, 41536, 968729, 162, 33928, 106, 28);
INSERT INTO public.who_global_data VALUES (24959, 47, 10342, 0, 69, 106, 85);
INSERT INTO public.who_global_data VALUES (24960, 0, 5161, 0, 19, 106, 211);
INSERT INTO public.who_global_data VALUES (24961, 0, 8901, 0, 54, 106, 60);
INSERT INTO public.who_global_data VALUES (24962, 2, 3659, 1, 119, 106, 3);
INSERT INTO public.who_global_data VALUES (24963, 1759, 24562, 4, 183, 106, 11);
INSERT INTO public.who_global_data VALUES (24964, 11242, 403291, 49, 9954, 106, 89);
INSERT INTO public.who_global_data VALUES (24965, 77, 47538, 0, 312, 106, 24);
INSERT INTO public.who_global_data VALUES (24966, 13, 621, 0, 0, 106, 162);
INSERT INTO public.who_global_data VALUES (24967, 882, 28216, 15, 549, 106, 100);
INSERT INTO public.who_global_data VALUES (24968, 1, 17, 0, 0, 106, 47);
INSERT INTO public.who_global_data VALUES (24969, 0, 27, 0, 0, 106, 29);
INSERT INTO public.who_global_data VALUES (24970, 0, 7329, 0, 115, 106, 40);
INSERT INTO public.who_global_data VALUES (24971, 87, 4037, 0, 69, 106, 222);
INSERT INTO public.who_global_data VALUES (24972, 757, 103172, 13, 3580, 106, 132);
INSERT INTO public.who_global_data VALUES (24973, 0, 260, 0, 13, 106, 130);
INSERT INTO public.who_global_data VALUES (24974, 0, 11635, 0, 71, 106, 234);
INSERT INTO public.who_global_data VALUES (24975, 0, 2403, 0, 41, 106, 23);
INSERT INTO public.who_global_data VALUES (24976, 54, 3850, 2, 116, 106, 192);
INSERT INTO public.who_global_data VALUES (24977, 0, 8979, 0, 231, 106, 69);
INSERT INTO public.who_global_data VALUES (24978, 0, 26, 0, 0, 106, 187);
INSERT INTO public.who_global_data VALUES (24979, 846, 91078, 14, 2596, 106, 230);
INSERT INTO public.who_global_data VALUES (24980, 2066, 54278, 47, 1352, 106, 77);
INSERT INTO public.who_global_data VALUES (24981, 38, 4268, 0, 11, 106, 9);
INSERT INTO public.who_global_data VALUES (24982, 54366, 7761312, 690, 117306, 106, 74);
INSERT INTO public.who_global_data VALUES (24983, 4432, 377541, 102, 12959, 106, 224);
INSERT INTO public.who_global_data VALUES (24984, 5471, 550757, 304, 31650, 106, 199);
INSERT INTO public.who_global_data VALUES (24985, 3899, 442164, 47, 10465, 106, 190);
INSERT INTO public.who_global_data VALUES (24986, 1054, 54476, 3, 1871, 106, 12);
INSERT INTO public.who_global_data VALUES (24987, 0, 348, 0, 24, 106, 104);
INSERT INTO public.who_global_data VALUES (24988, 1172, 307580, 25, 2327, 106, 153);
INSERT INTO public.who_global_data VALUES (24989, 16078, 465726, 136, 36968, 106, 91);
INSERT INTO public.who_global_data VALUES (24990, 155, 8600, 5, 179, 106, 215);
INSERT INTO public.who_global_data VALUES (24991, 614, 95138, 9, 1694, 106, 84);
INSERT INTO public.who_global_data VALUES (24992, 5, 523, 0, 32, 106, 231);
INSERT INTO public.who_global_data VALUES (24993, 2821, 46441, 38, 481, 106, 196);
INSERT INTO public.who_global_data VALUES (24994, 329, 146982, 0, 2178, 106, 105);
INSERT INTO public.who_global_data VALUES (24995, 1068, 47212, 12, 870, 106, 122);
INSERT INTO public.who_global_data VALUES (24996, 0, 0, 0, 0, 106, 159);
INSERT INTO public.who_global_data VALUES (24997, 159, 17379, 0, 647, 106, 75);
INSERT INTO public.who_global_data VALUES (24998, 889, 119420, 9, 730, 106, 27);
INSERT INTO public.who_global_data VALUES (24999, 582, 54588, 4, 1126, 106, 54);
INSERT INTO public.who_global_data VALUES (25000, 0, 24, 0, 0, 106, 226);
INSERT INTO public.who_global_data VALUES (25001, 161, 3958, 1, 49, 106, 79);
INSERT INTO public.who_global_data VALUES (25002, 1368, 66945, 16, 552, 106, 56);
INSERT INTO public.who_global_data VALUES (25003, 90, 1923, 1, 43, 106, 117);
INSERT INTO public.who_global_data VALUES (25004, 0, 1385, 0, 82, 106, 152);
INSERT INTO public.who_global_data VALUES (25005, 995, 52620, 3, 768, 106, 16);
INSERT INTO public.who_global_data VALUES (25006, 26, 352, 0, 1, 106, 10);
INSERT INTO public.who_global_data VALUES (25007, 445, 9108, 3, 116, 106, 201);
INSERT INTO public.who_global_data VALUES (25008, 662, 12333, 2, 140, 106, 174);
INSERT INTO public.who_global_data VALUES (25009, 0, 16810, 0, 238, 106, 119);
INSERT INTO public.who_global_data VALUES (25010, 10, 5874, 0, 183, 106, 168);
INSERT INTO public.who_global_data VALUES (25011, 847, 23804, 5, 204, 106, 99);
INSERT INTO public.who_global_data VALUES (25012, 42, 11358, 0, 37, 106, 171);
INSERT INTO public.who_global_data VALUES (25013, 12, 3440, 0, 132, 106, 87);
INSERT INTO public.who_global_data VALUES (25014, 121, 5250, 0, 49, 106, 123);
INSERT INTO public.who_global_data VALUES (25015, 0, 0, 0, 0, 106, 151);
INSERT INTO public.who_global_data VALUES (25016, 0, 2794, 0, 27, 106, 213);
INSERT INTO public.who_global_data VALUES (25017, 0, 7638, 0, 163, 106, 118);
INSERT INTO public.who_global_data VALUES (25018, 0, 421, 0, 10, 106, 134);
INSERT INTO public.who_global_data VALUES (25019, 0, 4203, 0, 44, 106, 65);
INSERT INTO public.who_global_data VALUES (25020, 6845, 867559, 522, 87415, 106, 102);
INSERT INTO public.who_global_data VALUES (25021, 0, 0, 0, 0, 106, 223);
INSERT INTO public.who_global_data VALUES (25022, 8, 284, 0, 2, 106, 4);
INSERT INTO public.who_global_data VALUES (25023, 1, 328, 0, 0, 106, 146);
INSERT INTO public.who_global_data VALUES (25024, 189, 16536, 2, 255, 106, 31);
INSERT INTO public.who_global_data VALUES (25025, 0, 13, 0, 1, 106, 127);
INSERT INTO public.who_global_data VALUES (25026, 4151, 186731, 35, 3132, 106, 22);
INSERT INTO public.who_global_data VALUES (25027, 228, 11559, 2, 81, 106, 115);
INSERT INTO public.who_global_data VALUES (25028, 1312, 41008, 33, 1005, 106, 106);
INSERT INTO public.who_global_data VALUES (25029, 54, 12460, 0, 133, 106, 90);
INSERT INTO public.who_global_data VALUES (25030, 0, 0, 0, 0, 106, 70);
INSERT INTO public.who_global_data VALUES (25031, 3637, 148509, 21, 812, 106, 46);
INSERT INTO public.who_global_data VALUES (25032, 9252, 261729, 46, 6913, 106, 139);
INSERT INTO public.who_global_data VALUES (25033, 0, 27, 0, 0, 106, 42);
INSERT INTO public.who_global_data VALUES (25034, 9, 1567, 0, 25, 106, 80);
INSERT INTO public.who_global_data VALUES (25035, 0, 4362, 0, 155, 106, 203);
INSERT INTO public.who_global_data VALUES (25036, 1, 1215, 0, 69, 106, 136);
INSERT INTO public.who_global_data VALUES (25037, 138, 61805, 2, 1127, 106, 63);
INSERT INTO public.who_global_data VALUES (25038, 0, 0, 0, 0, 106, 17);
INSERT INTO public.who_global_data VALUES (25039, 0, 88, 0, 2, 106, 172);
INSERT INTO public.who_global_data VALUES (25040, 637, 25473, 12, 874, 106, 109);
INSERT INTO public.who_global_data VALUES (25041, 193, 16964, 0, 279, 106, 200);
INSERT INTO public.who_global_data VALUES (25042, 506, 60670, 8, 506, 106, 93);
INSERT INTO public.who_global_data VALUES (25043, 353, 111837, 10, 1147, 106, 5);
INSERT INTO public.who_global_data VALUES (25044, 0, 741, 0, 13, 106, 214);
INSERT INTO public.who_global_data VALUES (25045, 736, 325473, 10, 6702, 106, 204);
INSERT INTO public.who_global_data VALUES (25046, 0, 0, 0, 0, 106, 198);
INSERT INTO public.who_global_data VALUES (25047, 696, 126435, 12, 2597, 106, 173);
INSERT INTO public.who_global_data VALUES (25048, 2, 583, 0, 7, 106, 229);
INSERT INTO public.who_global_data VALUES (25049, 746, 56819, 19, 1250, 106, 76);
INSERT INTO public.who_global_data VALUES (25050, 2767, 876885, 62, 33937, 106, 138);
INSERT INTO public.who_global_data VALUES (25051, 1645, 363888, 36, 6783, 106, 98);
INSERT INTO public.who_global_data VALUES (25052, 0, 0, 0, 0, 106, 103);
INSERT INTO public.who_global_data VALUES (25053, 12107, 214686, 168, 4019, 106, 225);
INSERT INTO public.who_global_data VALUES (25054, 3270, 109541, 16, 2245, 106, 131);
INSERT INTO public.who_global_data VALUES (25055, 207, 59037, 9, 783, 106, 235);
INSERT INTO public.who_global_data VALUES (25056, 252, 130462, 3, 228, 106, 137);
INSERT INTO public.who_global_data VALUES (25057, 155, 25698, 2, 455, 106, 81);
INSERT INTO public.who_global_data VALUES (25058, 777, 69568, 11, 1641, 106, 182);
INSERT INTO public.who_global_data VALUES (25059, 0, 5015, 0, 19, 106, 145);
INSERT INTO public.who_global_data VALUES (25060, 4902, 196004, 98, 6163, 106, 26);
INSERT INTO public.who_global_data VALUES (25061, 17340, 1480646, 283, 25525, 106, 170);
INSERT INTO public.who_global_data VALUES (25062, 5, 5017, 0, 34, 106, 191);
INSERT INTO public.who_global_data VALUES (25063, 0, 5, 0, 0, 106, 221);
INSERT INTO public.who_global_data VALUES (25064, 5, 77, 0, 0, 106, 64);
INSERT INTO public.who_global_data VALUES (25065, 0, 0, 0, 0, 106, 116);
INSERT INTO public.who_global_data VALUES (25066, 0, 19, 0, 0, 106, 128);
INSERT INTO public.who_global_data VALUES (25067, 4, 42, 0, 0, 106, 6);
INSERT INTO public.who_global_data VALUES (25068, 7, 538, 0, 8, 106, 227);
INSERT INTO public.who_global_data VALUES (25069, 0, 12, 0, 0, 106, 68);
INSERT INTO public.who_global_data VALUES (25070, 0, 68, 0, 0, 106, 184);
INSERT INTO public.who_global_data VALUES (25071, 0, 0, 0, 0, 106, 82);
INSERT INTO public.who_global_data VALUES (25072, 6, 802, 0, 42, 106, 149);
INSERT INTO public.who_global_data VALUES (25073, 0, 935, 0, 15, 106, 197);
INSERT INTO public.who_global_data VALUES (25074, 401, 343774, 15, 5250, 106, 78);
INSERT INTO public.who_global_data VALUES (25075, 24, 15508, 0, 321, 106, 233);
INSERT INTO public.who_global_data VALUES (25076, 416, 37536, 2, 783, 106, 133);
INSERT INTO public.who_global_data VALUES (25077, 3, 152, 0, 0, 106, 35);
INSERT INTO public.who_global_data VALUES (25078, 3, 2340, 0, 73, 106, 114);
INSERT INTO public.who_global_data VALUES (25079, 8, 57941, 0, 28, 106, 237);
INSERT INTO public.who_global_data VALUES (25080, 0, 14, 0, 0, 106, 55);
INSERT INTO public.who_global_data VALUES (25081, 7, 769, 0, 22, 106, 176);
INSERT INTO public.who_global_data VALUES (25082, 1728, 35330, 17, 115, 106, 202);
INSERT INTO public.who_global_data VALUES (25083, 1661, 19324, 9, 246, 106, 155);
INSERT INTO public.who_global_data VALUES (25084, 1, 4, 0, 0, 106, 32);
INSERT INTO public.who_global_data VALUES (25085, 7, 3897, 1, 102, 106, 220);
INSERT INTO public.who_global_data VALUES (25086, 2156, 710515, 102, 18843, 106, 30);
INSERT INTO public.who_global_data VALUES (25087, 4, 2876, 1, 56, 106, 147);
INSERT INTO public.who_global_data VALUES (25088, 24044, 1094817, 166, 36958, 106, 208);
INSERT INTO public.who_global_data VALUES (25089, 309, 6287, 1, 14, 106, 45);
INSERT INTO public.who_global_data VALUES (25090, 5, 13733, 0, 836, 106, 110);
INSERT INTO public.who_global_data VALUES (25091, 6, 5150, 0, 109, 106, 88);
INSERT INTO public.who_global_data VALUES (25092, 1571, 109329, 3, 5942, 106, 51);
INSERT INTO public.who_global_data VALUES (25093, 6766, 108657, 24, 1959, 106, 209);
INSERT INTO public.who_global_data VALUES (25094, 43, 5267, 3, 260, 106, 205);
INSERT INTO public.who_global_data VALUES (25095, 40, 10653, 1, 81, 106, 18);
INSERT INTO public.who_global_data VALUES (25096, 8, 3727, 0, 59, 106, 72);
INSERT INTO public.who_global_data VALUES (25097, 21238, 810471, 189, 44347, 106, 44);
INSERT INTO public.who_global_data VALUES (25098, 0, 29, 0, 0, 106, 15);
INSERT INTO public.who_global_data VALUES (25099, 19, 2139, 1, 52, 106, 25);
INSERT INTO public.who_global_data VALUES (25100, 0, 0, 0, 0, 106, 179);
INSERT INTO public.who_global_data VALUES (25101, 0, 0, 0, 0, 106, 34);
INSERT INTO public.who_global_data VALUES (25102, 59, 5392, 3, 101, 106, 207);
INSERT INTO public.who_global_data VALUES (25103, 1585, 48799, 35, 819, 106, 166);
INSERT INTO public.who_global_data VALUES (25104, 8832, 941038, 71, 9584, 106, 126);
INSERT INTO public.who_global_data VALUES (25105, 0, 0, 0, 0, 106, 97);
INSERT INTO public.who_global_data VALUES (25106, 0, 698, 0, 6, 106, 36);
INSERT INTO public.who_global_data VALUES (25107, 0, 0, 0, 0, 106, 125);
INSERT INTO public.who_global_data VALUES (25108, 108, 11041, 0, 98, 106, 124);
INSERT INTO public.who_global_data VALUES (25109, 7517, 330396, 121, 6164, 106, 185);
INSERT INTO public.who_global_data VALUES (25110, 1578, 120710, 2, 474, 106, 194);
INSERT INTO public.who_global_data VALUES (25111, 0, 509, 0, 21, 106, 144);
INSERT INTO public.who_global_data VALUES (25112, 63361, 8248149, 1066, 220563, 106, 19);
INSERT INTO public.who_global_data VALUES (25113, 6, 1343, 0, 21, 106, 217);
INSERT INTO public.who_global_data VALUES (25114, 40, 2663, 1, 53, 106, 148);
INSERT INTO public.who_global_data VALUES (25115, 298, 64633, 3, 541, 106, 86);
INSERT INTO public.who_global_data VALUES (25116, 0, 0, 0, 0, 106, 13);
INSERT INTO public.who_global_data VALUES (25117, 391, 88035, 6, 753, 106, 157);
INSERT INTO public.who_global_data VALUES (25118, 3, 1148, 0, 35, 106, 8);
INSERT INTO public.who_global_data VALUES (25119, 0, 1, 0, 0, 106, 73);
INSERT INTO public.who_global_data VALUES (25120, 0, 2061, 0, 598, 106, 101);
INSERT INTO public.who_global_data VALUES (25121, 35, 16035, 0, 346, 106, 165);
INSERT INTO public.who_global_data VALUES (25122, 27, 8242, 0, 236, 106, 14);
INSERT INTO public.who_global_data VALUES (25123, 49, 40510, 0, 1503, 107, 193);
INSERT INTO public.who_global_data VALUES (25124, 297, 17948, 4, 462, 107, 113);
INSERT INTO public.who_global_data VALUES (25125, 252, 55091, 7, 1880, 107, 143);
INSERT INTO public.who_global_data VALUES (25126, 0, 0, 0, 0, 107, 219);
INSERT INTO public.who_global_data VALUES (25127, 188, 3811, 1, 63, 107, 186);
INSERT INTO public.who_global_data VALUES (25128, 289, 8338, 4, 255, 107, 52);
INSERT INTO public.who_global_data VALUES (25129, 0, 3, 0, 0, 107, 180);
INSERT INTO public.who_global_data VALUES (25130, 3, 122, 0, 3, 107, 167);
INSERT INTO public.who_global_data VALUES (25131, 18735, 1021397, 459, 27175, 107, 154);
INSERT INTO public.who_global_data VALUES (25132, 2306, 70149, 10, 1126, 107, 94);
INSERT INTO public.who_global_data VALUES (25133, 21, 4355, 0, 34, 107, 66);
INSERT INTO public.who_global_data VALUES (25134, 14, 27444, 0, 905, 107, 58);
INSERT INTO public.who_global_data VALUES (25135, 2355, 70769, 13, 940, 107, 163);
INSERT INTO public.who_global_data VALUES (25136, 714, 46593, 7, 642, 107, 37);
INSERT INTO public.who_global_data VALUES (25137, 128, 6051, 3, 127, 107, 142);
INSERT INTO public.who_global_data VALUES (25138, 374, 78907, 3, 308, 107, 83);
INSERT INTO public.who_global_data VALUES (25139, 1545, 393131, 24, 5723, 107, 228);
INSERT INTO public.who_global_data VALUES (25140, 0, 222, 0, 7, 107, 188);
INSERT INTO public.who_global_data VALUES (25141, 733, 89642, 4, 941, 107, 62);
INSERT INTO public.who_global_data VALUES (25142, 17487, 298914, 61, 10610, 107, 160);
INSERT INTO public.who_global_data VALUES (25143, 53, 2886, 0, 45, 107, 50);
INSERT INTO public.who_global_data VALUES (25144, 0, 2557, 0, 41, 107, 33);
INSERT INTO public.who_global_data VALUES (25145, 0, 188, 0, 9, 107, 183);
INSERT INTO public.who_global_data VALUES (25146, 1, 332, 0, 0, 107, 92);
INSERT INTO public.who_global_data VALUES (25147, 147, 140037, 24, 8526, 107, 158);
INSERT INTO public.who_global_data VALUES (25148, 0, 131, 0, 3, 107, 67);
INSERT INTO public.who_global_data VALUES (25149, 928, 36319, 14, 1031, 107, 57);
INSERT INTO public.who_global_data VALUES (25150, 0, 5609, 0, 21, 107, 38);
INSERT INTO public.who_global_data VALUES (25151, 23227, 5273954, 661, 154837, 107, 141);
INSERT INTO public.who_global_data VALUES (25152, 0, 72, 0, 1, 107, 178);
INSERT INTO public.who_global_data VALUES (25153, 0, 147, 0, 3, 107, 108);
INSERT INTO public.who_global_data VALUES (25154, 1472, 33335, 29, 1048, 107, 39);
INSERT INTO public.who_global_data VALUES (25155, 0, 2406, 0, 65, 107, 2);
INSERT INTO public.who_global_data VALUES (25156, 1, 551, 0, 1, 107, 195);
INSERT INTO public.who_global_data VALUES (25157, 132, 8033, 3, 90, 107, 107);
INSERT INTO public.who_global_data VALUES (25158, 0, 286, 0, 0, 107, 161);
INSERT INTO public.who_global_data VALUES (25159, 0, 21570, 0, 425, 107, 212);
INSERT INTO public.who_global_data VALUES (25160, 2251, 203688, 16, 9794, 107, 181);
INSERT INTO public.who_global_data VALUES (25161, 0, 235, 0, 1, 107, 53);
INSERT INTO public.who_global_data VALUES (25162, 4, 4862, 0, 62, 107, 164);
INSERT INTO public.who_global_data VALUES (25163, 5, 1404, 3, 96, 107, 140);
INSERT INTO public.who_global_data VALUES (25164, 1159, 495637, 17, 13719, 107, 20);
INSERT INTO public.who_global_data VALUES (25165, 23, 91588, 0, 4746, 107, 112);
INSERT INTO public.who_global_data VALUES (25166, 8256, 974139, 170, 29272, 107, 111);
INSERT INTO public.who_global_data VALUES (25167, 0, 504, 0, 7, 107, 71);
INSERT INTO public.who_global_data VALUES (25168, 0, 5156, 0, 92, 107, 218);
INSERT INTO public.who_global_data VALUES (25169, 0, 0, 0, 0, 107, 43);
INSERT INTO public.who_global_data VALUES (25170, 847, 97922, 18, 1222, 107, 49);
INSERT INTO public.who_global_data VALUES (25171, 21, 20363, 0, 121, 107, 1);
INSERT INTO public.who_global_data VALUES (25172, 1424, 28287, 11, 393, 107, 48);
INSERT INTO public.who_global_data VALUES (25173, 63, 6368, 0, 127, 107, 232);
INSERT INTO public.who_global_data VALUES (25174, 8, 759, 0, 1, 107, 175);
INSERT INTO public.who_global_data VALUES (25175, 127, 2966, 0, 25, 107, 21);
INSERT INTO public.who_global_data VALUES (25176, 14969, 208915, 120, 1739, 107, 156);
INSERT INTO public.who_global_data VALUES (25177, 0, 0, 0, 0, 107, 95);
INSERT INTO public.who_global_data VALUES (25178, 26, 11077, 0, 303, 107, 177);
INSERT INTO public.who_global_data VALUES (25179, 630, 37003, 2, 690, 107, 210);
INSERT INTO public.who_global_data VALUES (25180, 13, 5512, 0, 61, 107, 120);
INSERT INTO public.who_global_data VALUES (25181, 0, 33, 0, 0, 107, 135);
INSERT INTO public.who_global_data VALUES (25182, 425, 122398, 2, 2206, 107, 206);
INSERT INTO public.who_global_data VALUES (25183, 1510, 155625, 49, 12453, 107, 189);
INSERT INTO public.who_global_data VALUES (25184, 178, 105883, 13, 6155, 107, 129);
INSERT INTO public.who_global_data VALUES (25185, 145, 32120, 4, 933, 107, 121);
INSERT INTO public.who_global_data VALUES (25186, 0, 5074, 0, 83, 107, 59);
INSERT INTO public.who_global_data VALUES (25187, 0, 452, 0, 0, 107, 96);
INSERT INTO public.who_global_data VALUES (25188, 44, 4171, 0, 71, 107, 41);
INSERT INTO public.who_global_data VALUES (25189, 5, 5805, 0, 116, 107, 216);
INSERT INTO public.who_global_data VALUES (25190, 628, 91118, 13, 1384, 107, 236);
INSERT INTO public.who_global_data VALUES (25191, 0, 13, 0, 0, 107, 150);
INSERT INTO public.who_global_data VALUES (25192, 0, 488, 0, 0, 107, 61);
INSERT INTO public.who_global_data VALUES (25193, 0, 33, 0, 2, 107, 7);
INSERT INTO public.who_global_data VALUES (25194, 222, 14071, 2, 353, 107, 169);
INSERT INTO public.who_global_data VALUES (25195, 25847, 927193, 155, 33766, 107, 28);
INSERT INTO public.who_global_data VALUES (25196, 27, 10295, 0, 69, 107, 85);
INSERT INTO public.who_global_data VALUES (25197, 551, 5161, 3, 19, 107, 211);
INSERT INTO public.who_global_data VALUES (25198, 17, 8901, 0, 54, 107, 60);
INSERT INTO public.who_global_data VALUES (25199, 2, 3657, 0, 118, 107, 3);
INSERT INTO public.who_global_data VALUES (25200, 1595, 22803, 7, 179, 107, 11);
INSERT INTO public.who_global_data VALUES (25201, 11287, 392049, 30, 9905, 107, 89);
INSERT INTO public.who_global_data VALUES (25202, 89, 47461, 2, 312, 107, 24);
INSERT INTO public.who_global_data VALUES (25203, 31, 608, 0, 0, 107, 162);
INSERT INTO public.who_global_data VALUES (25204, 865, 27334, 6, 534, 107, 100);
INSERT INTO public.who_global_data VALUES (25205, 0, 16, 0, 0, 107, 47);
INSERT INTO public.who_global_data VALUES (25206, 0, 27, 0, 0, 107, 29);
INSERT INTO public.who_global_data VALUES (25207, 207, 7329, 4, 115, 107, 40);
INSERT INTO public.who_global_data VALUES (25208, 81, 3950, 2, 69, 107, 222);
INSERT INTO public.who_global_data VALUES (25209, 196, 102415, 21, 3567, 107, 132);
INSERT INTO public.who_global_data VALUES (25210, 2, 260, 0, 13, 107, 130);
INSERT INTO public.who_global_data VALUES (25211, 97, 11635, 1, 71, 107, 234);
INSERT INTO public.who_global_data VALUES (25212, 0, 2403, 0, 41, 107, 23);
INSERT INTO public.who_global_data VALUES (25213, 31, 3796, 3, 114, 107, 192);
INSERT INTO public.who_global_data VALUES (25214, 3, 8979, 0, 231, 107, 69);
INSERT INTO public.who_global_data VALUES (25215, 0, 26, 0, 0, 107, 187);
INSERT INTO public.who_global_data VALUES (25216, 851, 90232, 6, 2582, 107, 230);
INSERT INTO public.who_global_data VALUES (25217, 2032, 52212, 46, 1305, 107, 77);
INSERT INTO public.who_global_data VALUES (25218, 37, 4230, 0, 11, 107, 9);
INSERT INTO public.who_global_data VALUES (25219, 55839, 7706946, 702, 116616, 107, 74);
INSERT INTO public.who_global_data VALUES (25220, 4267, 373109, 123, 12857, 107, 224);
INSERT INTO public.who_global_data VALUES (25221, 5616, 545286, 312, 31346, 107, 199);
INSERT INTO public.who_global_data VALUES (25222, 3667, 438265, 52, 10418, 107, 190);
INSERT INTO public.who_global_data VALUES (25223, 1166, 53422, 3, 1868, 107, 12);
INSERT INTO public.who_global_data VALUES (25224, 0, 348, 0, 24, 107, 104);
INSERT INTO public.who_global_data VALUES (25225, 1193, 306408, 20, 2302, 107, 153);
INSERT INTO public.who_global_data VALUES (25226, 15199, 449648, 127, 36832, 107, 91);
INSERT INTO public.who_global_data VALUES (25227, 71, 8445, 0, 174, 107, 215);
INSERT INTO public.who_global_data VALUES (25228, 591, 94524, 6, 1685, 107, 84);
INSERT INTO public.who_global_data VALUES (25229, 9, 518, 0, 32, 107, 231);
INSERT INTO public.who_global_data VALUES (25230, 2580, 43620, 29, 443, 107, 196);
INSERT INTO public.who_global_data VALUES (25231, 365, 146653, 0, 2178, 107, 105);
INSERT INTO public.who_global_data VALUES (25232, 497, 46144, 16, 858, 107, 122);
INSERT INTO public.who_global_data VALUES (25233, 0, 0, 0, 0, 107, 159);
INSERT INTO public.who_global_data VALUES (25234, 124, 17220, 0, 647, 107, 75);
INSERT INTO public.who_global_data VALUES (25235, 813, 118531, 7, 721, 107, 27);
INSERT INTO public.who_global_data VALUES (25236, 547, 54006, 4, 1122, 107, 54);
INSERT INTO public.who_global_data VALUES (25237, 1, 24, 0, 0, 107, 226);
INSERT INTO public.who_global_data VALUES (25238, 188, 3797, 2, 48, 107, 79);
INSERT INTO public.who_global_data VALUES (25239, 1241, 65577, 5, 536, 107, 56);
INSERT INTO public.who_global_data VALUES (25240, 0, 1833, 0, 42, 107, 117);
INSERT INTO public.who_global_data VALUES (25241, 1, 1385, 0, 82, 107, 152);
INSERT INTO public.who_global_data VALUES (25242, 719, 51625, 19, 765, 107, 16);
INSERT INTO public.who_global_data VALUES (25243, 37, 326, 0, 1, 107, 10);
INSERT INTO public.who_global_data VALUES (25244, 427, 8663, 4, 113, 107, 201);
INSERT INTO public.who_global_data VALUES (25245, 430, 11671, 2, 138, 107, 174);
INSERT INTO public.who_global_data VALUES (25246, 0, 16810, 0, 238, 107, 119);
INSERT INTO public.who_global_data VALUES (25247, 3, 5864, 1, 183, 107, 168);
INSERT INTO public.who_global_data VALUES (25248, 732, 22957, 6, 199, 107, 99);
INSERT INTO public.who_global_data VALUES (25249, 45, 11316, 0, 37, 107, 171);
INSERT INTO public.who_global_data VALUES (25250, 17, 3428, 0, 132, 107, 87);
INSERT INTO public.who_global_data VALUES (25251, 111, 5129, 3, 49, 107, 123);
INSERT INTO public.who_global_data VALUES (25252, 0, 0, 0, 0, 107, 151);
INSERT INTO public.who_global_data VALUES (25253, 528, 2794, 2, 27, 107, 213);
INSERT INTO public.who_global_data VALUES (25254, 4, 7638, 0, 163, 107, 118);
INSERT INTO public.who_global_data VALUES (25255, 0, 421, 0, 10, 107, 134);
INSERT INTO public.who_global_data VALUES (25256, 0, 4203, 0, 44, 107, 65);
INSERT INTO public.who_global_data VALUES (25257, 5788, 860714, 555, 86893, 107, 102);
INSERT INTO public.who_global_data VALUES (25258, 0, 0, 0, 0, 107, 223);
INSERT INTO public.who_global_data VALUES (25259, 2, 276, 0, 2, 107, 4);
INSERT INTO public.who_global_data VALUES (25260, 1, 327, 0, 0, 107, 146);
INSERT INTO public.who_global_data VALUES (25261, 155, 16347, 3, 253, 107, 31);
INSERT INTO public.who_global_data VALUES (25262, 0, 13, 0, 1, 107, 127);
INSERT INTO public.who_global_data VALUES (25263, 3577, 182580, 70, 3097, 107, 22);
INSERT INTO public.who_global_data VALUES (25264, 141, 11331, 1, 79, 107, 115);
INSERT INTO public.who_global_data VALUES (25265, 1194, 39696, 27, 972, 107, 106);
INSERT INTO public.who_global_data VALUES (25266, 39, 12406, 1, 133, 107, 90);
INSERT INTO public.who_global_data VALUES (25267, 0, 0, 0, 0, 107, 70);
INSERT INTO public.who_global_data VALUES (25268, 5743, 144872, 26, 791, 107, 46);
INSERT INTO public.who_global_data VALUES (25269, 8719, 252477, 57, 6867, 107, 139);
INSERT INTO public.who_global_data VALUES (25270, 0, 27, 0, 0, 107, 42);
INSERT INTO public.who_global_data VALUES (25271, 2, 1558, 0, 25, 107, 80);
INSERT INTO public.who_global_data VALUES (25272, 0, 4362, 0, 155, 107, 203);
INSERT INTO public.who_global_data VALUES (25273, 2, 1214, 0, 69, 107, 136);
INSERT INTO public.who_global_data VALUES (25274, 37, 61667, 0, 1125, 107, 63);
INSERT INTO public.who_global_data VALUES (25275, 0, 0, 0, 0, 107, 17);
INSERT INTO public.who_global_data VALUES (25276, 0, 88, 0, 2, 107, 172);
INSERT INTO public.who_global_data VALUES (25277, 640, 24836, 12, 862, 107, 109);
INSERT INTO public.who_global_data VALUES (25278, 168, 16771, 1, 279, 107, 200);
INSERT INTO public.who_global_data VALUES (25279, 569, 60164, 6, 498, 107, 93);
INSERT INTO public.who_global_data VALUES (25280, 451, 111484, 15, 1137, 107, 5);
INSERT INTO public.who_global_data VALUES (25281, 0, 741, 0, 13, 107, 214);
INSERT INTO public.who_global_data VALUES (25282, 660, 324737, 19, 6692, 107, 204);
INSERT INTO public.who_global_data VALUES (25283, 0, 0, 0, 0, 107, 198);
INSERT INTO public.who_global_data VALUES (25284, 558, 125739, 11, 2585, 107, 173);
INSERT INTO public.who_global_data VALUES (25285, 0, 581, 0, 7, 107, 229);
INSERT INTO public.who_global_data VALUES (25286, 621, 56073, 24, 1231, 107, 76);
INSERT INTO public.who_global_data VALUES (25287, 3242, 874118, 55, 33875, 107, 138);
INSERT INTO public.who_global_data VALUES (25288, 1468, 362243, 57, 6747, 107, 98);
INSERT INTO public.who_global_data VALUES (25289, 0, 0, 0, 0, 107, 103);
INSERT INTO public.who_global_data VALUES (25290, 10040, 202579, 130, 3851, 107, 225);
INSERT INTO public.who_global_data VALUES (25291, 2535, 106271, 16, 2229, 107, 131);
INSERT INTO public.who_global_data VALUES (25292, 187, 58830, 5, 774, 107, 235);
INSERT INTO public.who_global_data VALUES (25293, 266, 130210, 1, 225, 107, 137);
INSERT INTO public.who_global_data VALUES (25294, 121, 25543, 3, 453, 107, 81);
INSERT INTO public.who_global_data VALUES (25295, 833, 68791, 13, 1630, 107, 182);
INSERT INTO public.who_global_data VALUES (25296, 94, 5015, 2, 19, 107, 145);
INSERT INTO public.who_global_data VALUES (25297, 4848, 191102, 69, 6065, 107, 26);
INSERT INTO public.who_global_data VALUES (25298, 15971, 1463306, 290, 25242, 107, 170);
INSERT INTO public.who_global_data VALUES (25299, 16, 5012, 0, 34, 107, 191);
INSERT INTO public.who_global_data VALUES (25300, 0, 5, 0, 0, 107, 221);
INSERT INTO public.who_global_data VALUES (25301, 0, 72, 0, 0, 107, 64);
INSERT INTO public.who_global_data VALUES (25302, 0, 0, 0, 0, 107, 116);
INSERT INTO public.who_global_data VALUES (25303, 0, 19, 0, 0, 107, 128);
INSERT INTO public.who_global_data VALUES (25304, 2, 38, 0, 0, 107, 6);
INSERT INTO public.who_global_data VALUES (25305, 0, 531, 0, 8, 107, 227);
INSERT INTO public.who_global_data VALUES (25306, 0, 12, 0, 0, 107, 68);
INSERT INTO public.who_global_data VALUES (25307, 0, 68, 0, 0, 107, 184);
INSERT INTO public.who_global_data VALUES (25308, 0, 0, 0, 0, 107, 82);
INSERT INTO public.who_global_data VALUES (25309, 2, 796, 0, 42, 107, 149);
INSERT INTO public.who_global_data VALUES (25310, 2, 935, 0, 15, 107, 197);
INSERT INTO public.who_global_data VALUES (25311, 405, 343373, 18, 5235, 107, 78);
INSERT INTO public.who_global_data VALUES (25312, 25, 15484, 1, 321, 107, 233);
INSERT INTO public.who_global_data VALUES (25313, 512, 37120, 1, 781, 107, 133);
INSERT INTO public.who_global_data VALUES (25314, 1, 149, 0, 0, 107, 35);
INSERT INTO public.who_global_data VALUES (25315, 1, 2337, 0, 73, 107, 114);
INSERT INTO public.who_global_data VALUES (25316, 12, 57933, 0, 28, 107, 237);
INSERT INTO public.who_global_data VALUES (25317, 0, 14, 0, 0, 107, 55);
INSERT INTO public.who_global_data VALUES (25318, 6, 762, 0, 22, 107, 176);
INSERT INTO public.who_global_data VALUES (25319, 2202, 33602, 0, 98, 107, 202);
INSERT INTO public.who_global_data VALUES (25320, 1670, 17663, 8, 237, 107, 155);
INSERT INTO public.who_global_data VALUES (25321, 0, 3, 0, 0, 107, 32);
INSERT INTO public.who_global_data VALUES (25322, 0, 3890, 0, 101, 107, 220);
INSERT INTO public.who_global_data VALUES (25323, 2055, 708359, 85, 18741, 107, 30);
INSERT INTO public.who_global_data VALUES (25324, 2, 2872, 0, 55, 107, 147);
INSERT INTO public.who_global_data VALUES (25325, 21778, 1070773, 184, 36792, 107, 208);
INSERT INTO public.who_global_data VALUES (25326, 167, 5978, 0, 13, 107, 45);
INSERT INTO public.who_global_data VALUES (25327, 0, 13728, 0, 836, 107, 110);
INSERT INTO public.who_global_data VALUES (25328, 11, 5144, 0, 109, 107, 88);
INSERT INTO public.who_global_data VALUES (25329, 1289, 107758, 4, 5939, 107, 51);
INSERT INTO public.who_global_data VALUES (25330, 6450, 101891, 18, 1935, 107, 209);
INSERT INTO public.who_global_data VALUES (25331, 44, 5224, 3, 257, 107, 205);
INSERT INTO public.who_global_data VALUES (25332, 39, 10613, 0, 80, 107, 18);
INSERT INTO public.who_global_data VALUES (25333, 10, 3719, 0, 59, 107, 72);
INSERT INTO public.who_global_data VALUES (25334, 26687, 789233, 191, 44158, 107, 44);
INSERT INTO public.who_global_data VALUES (25335, 0, 29, 0, 0, 107, 15);
INSERT INTO public.who_global_data VALUES (25336, 16, 2120, 0, 51, 107, 25);
INSERT INTO public.who_global_data VALUES (25337, 0, 0, 0, 0, 107, 179);
INSERT INTO public.who_global_data VALUES (25338, 0, 0, 0, 0, 107, 34);
INSERT INTO public.who_global_data VALUES (25339, 35, 5333, 1, 98, 107, 207);
INSERT INTO public.who_global_data VALUES (25340, 1322, 47214, 44, 784, 107, 166);
INSERT INTO public.who_global_data VALUES (25341, 8743, 932206, 68, 9513, 107, 126);
INSERT INTO public.who_global_data VALUES (25342, 0, 0, 0, 0, 107, 97);
INSERT INTO public.who_global_data VALUES (25343, 0, 698, 0, 6, 107, 36);
INSERT INTO public.who_global_data VALUES (25344, 0, 0, 0, 0, 107, 125);
INSERT INTO public.who_global_data VALUES (25345, 145, 10933, 1, 98, 107, 124);
INSERT INTO public.who_global_data VALUES (25346, 7053, 322879, 116, 6043, 107, 185);
INSERT INTO public.who_global_data VALUES (25347, 1538, 119132, 2, 472, 107, 194);
INSERT INTO public.who_global_data VALUES (25348, 0, 509, 0, 21, 107, 144);
INSERT INTO public.who_global_data VALUES (25349, 60155, 8184788, 856, 219497, 107, 19);
INSERT INTO public.who_global_data VALUES (25350, 2, 1337, 0, 21, 107, 217);
INSERT INTO public.who_global_data VALUES (25351, 63, 2623, 1, 52, 107, 148);
INSERT INTO public.who_global_data VALUES (25352, 325, 64335, 4, 538, 107, 86);
INSERT INTO public.who_global_data VALUES (25353, 0, 0, 0, 0, 107, 13);
INSERT INTO public.who_global_data VALUES (25354, 483, 87644, 6, 747, 107, 157);
INSERT INTO public.who_global_data VALUES (25355, 4, 1145, 0, 35, 107, 8);
INSERT INTO public.who_global_data VALUES (25356, 0, 1, 0, 0, 107, 73);
INSERT INTO public.who_global_data VALUES (25357, 0, 2061, 0, 598, 107, 101);
INSERT INTO public.who_global_data VALUES (25358, 18, 16000, 0, 346, 107, 165);
INSERT INTO public.who_global_data VALUES (25359, 28, 8215, 3, 236, 107, 14);
INSERT INTO public.who_global_data VALUES (25360, 0, 40461, 0, 1503, 108, 193);
INSERT INTO public.who_global_data VALUES (25361, 301, 17651, 4, 458, 108, 113);
INSERT INTO public.who_global_data VALUES (25362, 223, 54839, 8, 1873, 108, 143);
INSERT INTO public.who_global_data VALUES (25363, 0, 0, 0, 0, 108, 219);
INSERT INTO public.who_global_data VALUES (25364, 0, 3623, 0, 62, 108, 186);
INSERT INTO public.who_global_data VALUES (25365, 220, 8049, 3, 251, 108, 52);
INSERT INTO public.who_global_data VALUES (25366, 0, 3, 0, 0, 108, 180);
INSERT INTO public.who_global_data VALUES (25367, 0, 119, 0, 3, 108, 167);
INSERT INTO public.who_global_data VALUES (25368, 12982, 1002662, 449, 26716, 108, 154);
INSERT INTO public.who_global_data VALUES (25369, 1836, 67843, 20, 1116, 108, 94);
INSERT INTO public.who_global_data VALUES (25370, 12, 4334, 0, 34, 108, 66);
INSERT INTO public.who_global_data VALUES (25371, 31, 27430, 0, 905, 108, 58);
INSERT INTO public.who_global_data VALUES (25372, 1803, 68414, 8, 927, 108, 163);
INSERT INTO public.who_global_data VALUES (25373, 584, 45879, 5, 635, 108, 37);
INSERT INTO public.who_global_data VALUES (25374, 150, 5923, 1, 124, 108, 142);
INSERT INTO public.who_global_data VALUES (25375, 309, 78533, 3, 305, 108, 83);
INSERT INTO public.who_global_data VALUES (25376, 1380, 391586, 18, 5699, 108, 228);
INSERT INTO public.who_global_data VALUES (25377, 0, 222, 0, 7, 108, 188);
INSERT INTO public.who_global_data VALUES (25378, 619, 88909, 4, 937, 108, 62);
INSERT INTO public.who_global_data VALUES (25379, 19265, 281427, 52, 10549, 108, 160);
INSERT INTO public.who_global_data VALUES (25380, 20, 2833, 1, 45, 108, 50);
INSERT INTO public.who_global_data VALUES (25381, 61, 2557, 0, 41, 108, 33);
INSERT INTO public.who_global_data VALUES (25382, 3, 188, 0, 9, 108, 183);
INSERT INTO public.who_global_data VALUES (25383, 1, 331, 0, 0, 108, 92);
INSERT INTO public.who_global_data VALUES (25384, 119, 139890, 21, 8502, 108, 158);
INSERT INTO public.who_global_data VALUES (25385, 0, 131, 0, 3, 108, 67);
INSERT INTO public.who_global_data VALUES (25386, 726, 35391, 20, 1017, 108, 57);
INSERT INTO public.who_global_data VALUES (25387, 367, 5609, 1, 21, 108, 38);
INSERT INTO public.who_global_data VALUES (25388, 15383, 5250727, 271, 154176, 108, 141);
INSERT INTO public.who_global_data VALUES (25389, 0, 72, 0, 1, 108, 178);
INSERT INTO public.who_global_data VALUES (25390, 0, 147, 0, 3, 108, 108);
INSERT INTO public.who_global_data VALUES (25391, 1336, 31863, 11, 1019, 108, 39);
INSERT INTO public.who_global_data VALUES (25392, 19, 2406, 0, 65, 108, 2);
INSERT INTO public.who_global_data VALUES (25393, 0, 550, 0, 1, 108, 195);
INSERT INTO public.who_global_data VALUES (25394, 101, 7901, 0, 87, 108, 107);
INSERT INTO public.who_global_data VALUES (25395, 1, 286, 0, 0, 108, 161);
INSERT INTO public.who_global_data VALUES (25396, 0, 21570, 0, 425, 108, 212);
INSERT INTO public.who_global_data VALUES (25397, 3289, 201437, 18, 9778, 108, 181);
INSERT INTO public.who_global_data VALUES (25398, 2, 235, 0, 1, 108, 53);
INSERT INTO public.who_global_data VALUES (25399, 0, 4858, 0, 62, 108, 164);
INSERT INTO public.who_global_data VALUES (25400, 9, 1399, 0, 93, 108, 140);
INSERT INTO public.who_global_data VALUES (25401, 1173, 494478, 26, 13702, 108, 20);
INSERT INTO public.who_global_data VALUES (25402, 19, 91565, 0, 4746, 108, 112);
INSERT INTO public.who_global_data VALUES (25403, 6311, 965883, 132, 29102, 108, 111);
INSERT INTO public.who_global_data VALUES (25404, 2, 504, 0, 7, 108, 71);
INSERT INTO public.who_global_data VALUES (25405, 0, 5156, 0, 92, 108, 218);
INSERT INTO public.who_global_data VALUES (25406, 0, 0, 0, 0, 108, 43);
INSERT INTO public.who_global_data VALUES (25407, 632, 97075, 10, 1204, 108, 49);
INSERT INTO public.who_global_data VALUES (25408, 18, 20342, 0, 121, 108, 1);
INSERT INTO public.who_global_data VALUES (25409, 890, 26863, 8, 382, 108, 48);
INSERT INTO public.who_global_data VALUES (25410, 47, 6305, 0, 127, 108, 232);
INSERT INTO public.who_global_data VALUES (25411, 7, 751, 0, 1, 108, 175);
INSERT INTO public.who_global_data VALUES (25412, 152, 2839, 0, 25, 108, 21);
INSERT INTO public.who_global_data VALUES (25413, 11984, 193946, 106, 1619, 108, 156);
INSERT INTO public.who_global_data VALUES (25414, 0, 0, 0, 0, 108, 95);
INSERT INTO public.who_global_data VALUES (25415, 0, 11051, 0, 303, 108, 177);
INSERT INTO public.who_global_data VALUES (25416, 529, 36373, 2, 688, 108, 210);
INSERT INTO public.who_global_data VALUES (25417, 30, 5499, 0, 61, 108, 120);
INSERT INTO public.who_global_data VALUES (25418, 0, 33, 0, 0, 108, 135);
INSERT INTO public.who_global_data VALUES (25419, 306, 121973, 1, 2204, 108, 206);
INSERT INTO public.who_global_data VALUES (25420, 692, 154115, 9, 12404, 108, 189);
INSERT INTO public.who_global_data VALUES (25421, 158, 105705, 12, 6142, 108, 129);
INSERT INTO public.who_global_data VALUES (25422, 309, 31975, 3, 929, 108, 121);
INSERT INTO public.who_global_data VALUES (25423, 0, 5074, 0, 83, 108, 59);
INSERT INTO public.who_global_data VALUES (25424, 27, 452, 0, 0, 108, 96);
INSERT INTO public.who_global_data VALUES (25425, 42, 4127, 3, 71, 108, 41);
INSERT INTO public.who_global_data VALUES (25426, 12, 5800, 0, 116, 108, 216);
INSERT INTO public.who_global_data VALUES (25427, 630, 90490, 6, 1371, 108, 236);
INSERT INTO public.who_global_data VALUES (25428, 0, 13, 0, 0, 108, 150);
INSERT INTO public.who_global_data VALUES (25429, 3, 488, 0, 0, 108, 61);
INSERT INTO public.who_global_data VALUES (25430, 1, 33, 0, 2, 108, 7);
INSERT INTO public.who_global_data VALUES (25431, 294, 13849, 0, 351, 108, 169);
INSERT INTO public.who_global_data VALUES (25432, 20424, 901346, 261, 33611, 108, 28);
INSERT INTO public.who_global_data VALUES (25433, 0, 10268, 0, 69, 108, 85);
INSERT INTO public.who_global_data VALUES (25434, 0, 4610, 0, 16, 108, 211);
INSERT INTO public.who_global_data VALUES (25435, 0, 8884, 0, 54, 108, 60);
INSERT INTO public.who_global_data VALUES (25436, 0, 3655, 0, 118, 108, 3);
INSERT INTO public.who_global_data VALUES (25437, 1351, 21208, 14, 172, 108, 11);
INSERT INTO public.who_global_data VALUES (25438, 7595, 380762, 39, 9875, 108, 89);
INSERT INTO public.who_global_data VALUES (25439, 0, 47372, 0, 310, 108, 24);
INSERT INTO public.who_global_data VALUES (25440, 6, 577, 0, 0, 108, 162);
INSERT INTO public.who_global_data VALUES (25441, 667, 26469, 8, 528, 108, 100);
INSERT INTO public.who_global_data VALUES (25442, 0, 16, 0, 0, 108, 47);
INSERT INTO public.who_global_data VALUES (25443, 0, 27, 0, 0, 108, 29);
INSERT INTO public.who_global_data VALUES (25444, 0, 7122, 0, 111, 108, 40);
INSERT INTO public.who_global_data VALUES (25445, 127, 3869, 1, 67, 108, 222);
INSERT INTO public.who_global_data VALUES (25446, 620, 102219, 5, 3546, 108, 132);
INSERT INTO public.who_global_data VALUES (25447, 0, 258, 0, 13, 108, 130);
INSERT INTO public.who_global_data VALUES (25448, 20, 11538, 0, 70, 108, 234);
INSERT INTO public.who_global_data VALUES (25449, 0, 2403, 0, 41, 108, 23);
INSERT INTO public.who_global_data VALUES (25450, 31, 3765, 2, 111, 108, 192);
INSERT INTO public.who_global_data VALUES (25451, 51, 8976, 0, 231, 108, 69);
INSERT INTO public.who_global_data VALUES (25452, 0, 26, 0, 0, 108, 187);
INSERT INTO public.who_global_data VALUES (25453, 946, 89381, 8, 2576, 108, 230);
INSERT INTO public.who_global_data VALUES (25454, 1423, 50180, 48, 1259, 108, 77);
INSERT INTO public.who_global_data VALUES (25455, 92, 4193, 0, 11, 108, 9);
INSERT INTO public.who_global_data VALUES (25456, 54044, 7651107, 717, 115914, 108, 74);
INSERT INTO public.who_global_data VALUES (25457, 3602, 368842, 117, 12734, 108, 224);
INSERT INTO public.who_global_data VALUES (25458, 5039, 539670, 322, 31034, 108, 199);
INSERT INTO public.who_global_data VALUES (25459, 3920, 434598, 49, 10366, 108, 190);
INSERT INTO public.who_global_data VALUES (25460, 1263, 52256, 13, 1865, 108, 12);
INSERT INTO public.who_global_data VALUES (25461, 0, 348, 0, 24, 108, 104);
INSERT INTO public.who_global_data VALUES (25462, 1517, 305215, 31, 2282, 108, 153);
INSERT INTO public.who_global_data VALUES (25463, 10871, 434449, 89, 36705, 108, 91);
INSERT INTO public.who_global_data VALUES (25464, 53, 8374, 1, 174, 108, 215);
INSERT INTO public.who_global_data VALUES (25465, 453, 93933, 3, 1679, 108, 84);
INSERT INTO public.who_global_data VALUES (25466, 18, 509, 0, 32, 108, 231);
INSERT INTO public.who_global_data VALUES (25467, 2035, 41040, 34, 414, 108, 196);
INSERT INTO public.who_global_data VALUES (25468, 322, 146288, 0, 2178, 108, 105);
INSERT INTO public.who_global_data VALUES (25469, 571, 45647, 3, 842, 108, 122);
INSERT INTO public.who_global_data VALUES (25470, 0, 0, 0, 0, 108, 159);
INSERT INTO public.who_global_data VALUES (25471, 130, 17096, 1, 647, 108, 75);
INSERT INTO public.who_global_data VALUES (25472, 886, 117718, 4, 714, 108, 27);
INSERT INTO public.who_global_data VALUES (25473, 549, 53459, 5, 1118, 108, 54);
INSERT INTO public.who_global_data VALUES (25474, 0, 23, 0, 0, 108, 226);
INSERT INTO public.who_global_data VALUES (25475, 115, 3609, 4, 46, 108, 79);
INSERT INTO public.who_global_data VALUES (25476, 1392, 64336, 5, 531, 108, 56);
INSERT INTO public.who_global_data VALUES (25477, 0, 1833, 0, 42, 108, 117);
INSERT INTO public.who_global_data VALUES (25478, 3, 1384, 0, 82, 108, 152);
INSERT INTO public.who_global_data VALUES (25479, 0, 50906, 0, 746, 108, 16);
INSERT INTO public.who_global_data VALUES (25480, 31, 289, 0, 1, 108, 10);
INSERT INTO public.who_global_data VALUES (25481, 313, 8236, 4, 109, 108, 201);
INSERT INTO public.who_global_data VALUES (25482, 353, 11241, 3, 136, 108, 174);
INSERT INTO public.who_global_data VALUES (25483, 0, 16810, 0, 238, 108, 119);
INSERT INTO public.who_global_data VALUES (25484, 1, 5861, 1, 182, 108, 168);
INSERT INTO public.who_global_data VALUES (25485, 862, 22225, 3, 193, 108, 99);
INSERT INTO public.who_global_data VALUES (25486, 39, 11271, 0, 37, 108, 171);
INSERT INTO public.who_global_data VALUES (25487, 4, 3411, 0, 132, 108, 87);
INSERT INTO public.who_global_data VALUES (25488, 155, 5018, 1, 46, 108, 123);
INSERT INTO public.who_global_data VALUES (25489, 0, 0, 0, 0, 108, 151);
INSERT INTO public.who_global_data VALUES (25490, 0, 2266, 0, 25, 108, 213);
INSERT INTO public.who_global_data VALUES (25491, 13, 7634, 0, 163, 108, 118);
INSERT INTO public.who_global_data VALUES (25492, 14, 421, 0, 10, 108, 134);
INSERT INTO public.who_global_data VALUES (25493, 44, 4203, 1, 44, 108, 65);
INSERT INTO public.who_global_data VALUES (25494, 3699, 854926, 171, 86338, 108, 102);
INSERT INTO public.who_global_data VALUES (25495, 0, 0, 0, 0, 108, 223);
INSERT INTO public.who_global_data VALUES (25496, 3, 274, 0, 2, 108, 4);
INSERT INTO public.who_global_data VALUES (25497, 2, 326, 0, 0, 108, 146);
INSERT INTO public.who_global_data VALUES (25498, 164, 16192, 3, 250, 108, 31);
INSERT INTO public.who_global_data VALUES (25499, 0, 13, 0, 1, 108, 127);
INSERT INTO public.who_global_data VALUES (25500, 3254, 179003, 51, 3027, 108, 22);
INSERT INTO public.who_global_data VALUES (25501, 110, 11190, 3, 78, 108, 115);
INSERT INTO public.who_global_data VALUES (25502, 1297, 38502, 31, 945, 108, 106);
INSERT INTO public.who_global_data VALUES (25503, 41, 12367, 1, 132, 108, 90);
INSERT INTO public.who_global_data VALUES (25504, 0, 0, 0, 0, 108, 70);
INSERT INTO public.who_global_data VALUES (25505, 3093, 139129, 8, 765, 108, 46);
INSERT INTO public.who_global_data VALUES (25506, 8147, 243758, 46, 6810, 108, 139);
INSERT INTO public.who_global_data VALUES (25507, 0, 27, 0, 0, 108, 42);
INSERT INTO public.who_global_data VALUES (25508, 25, 1556, 0, 25, 108, 80);
INSERT INTO public.who_global_data VALUES (25509, 65, 4362, 1, 155, 108, 203);
INSERT INTO public.who_global_data VALUES (25510, 1, 1212, 0, 69, 108, 136);
INSERT INTO public.who_global_data VALUES (25511, 72, 61630, 0, 1125, 108, 63);
INSERT INTO public.who_global_data VALUES (25512, 0, 0, 0, 0, 108, 17);
INSERT INTO public.who_global_data VALUES (25513, 2, 88, 0, 2, 108, 172);
INSERT INTO public.who_global_data VALUES (25514, 408, 24196, 4, 850, 108, 109);
INSERT INTO public.who_global_data VALUES (25515, 147, 16603, 0, 278, 108, 200);
INSERT INTO public.who_global_data VALUES (25516, 513, 59595, 8, 492, 108, 93);
INSERT INTO public.who_global_data VALUES (25517, 439, 111033, 8, 1122, 108, 5);
INSERT INTO public.who_global_data VALUES (25518, 0, 741, 0, 13, 108, 214);
INSERT INTO public.who_global_data VALUES (25519, 0, 324077, 0, 6673, 108, 204);
INSERT INTO public.who_global_data VALUES (25520, 0, 0, 0, 0, 108, 198);
INSERT INTO public.who_global_data VALUES (25521, 436, 125181, 10, 2574, 108, 173);
INSERT INTO public.who_global_data VALUES (25522, 0, 581, 0, 7, 108, 229);
INSERT INTO public.who_global_data VALUES (25523, 728, 55452, 19, 1207, 108, 76);
INSERT INTO public.who_global_data VALUES (25524, 2201, 870876, 61, 33820, 108, 138);
INSERT INTO public.who_global_data VALUES (25525, 1606, 360775, 15, 6690, 108, 98);
INSERT INTO public.who_global_data VALUES (25526, 0, 0, 0, 0, 108, 103);
INSERT INTO public.who_global_data VALUES (25527, 9291, 192539, 107, 3721, 108, 225);
INSERT INTO public.who_global_data VALUES (25528, 1876, 103736, 15, 2213, 108, 131);
INSERT INTO public.who_global_data VALUES (25529, 693, 58643, 1, 769, 108, 235);
INSERT INTO public.who_global_data VALUES (25530, 273, 129944, 0, 224, 108, 137);
INSERT INTO public.who_global_data VALUES (25531, 89, 25422, 3, 450, 108, 81);
INSERT INTO public.who_global_data VALUES (25532, 656, 67958, 16, 1617, 108, 182);
INSERT INTO public.who_global_data VALUES (25533, 0, 4921, 0, 17, 108, 145);
INSERT INTO public.who_global_data VALUES (25534, 3400, 186254, 65, 5996, 108, 26);
INSERT INTO public.who_global_data VALUES (25535, 15700, 1447335, 317, 24952, 108, 170);
INSERT INTO public.who_global_data VALUES (25536, 4, 4996, 0, 34, 108, 191);
INSERT INTO public.who_global_data VALUES (25537, 0, 5, 0, 0, 108, 221);
INSERT INTO public.who_global_data VALUES (25538, 0, 72, 0, 0, 108, 64);
INSERT INTO public.who_global_data VALUES (25539, 0, 0, 0, 0, 108, 116);
INSERT INTO public.who_global_data VALUES (25540, 0, 19, 0, 0, 108, 128);
INSERT INTO public.who_global_data VALUES (25541, 0, 36, 0, 0, 108, 6);
INSERT INTO public.who_global_data VALUES (25542, 0, 531, 0, 8, 108, 227);
INSERT INTO public.who_global_data VALUES (25543, 0, 12, 0, 0, 108, 68);
INSERT INTO public.who_global_data VALUES (25544, 1, 68, 0, 0, 108, 184);
INSERT INTO public.who_global_data VALUES (25545, 0, 0, 0, 0, 108, 82);
INSERT INTO public.who_global_data VALUES (25546, 5, 794, 0, 42, 108, 149);
INSERT INTO public.who_global_data VALUES (25547, 0, 933, 0, 15, 108, 197);
INSERT INTO public.who_global_data VALUES (25548, 385, 342968, 16, 5217, 108, 78);
INSERT INTO public.who_global_data VALUES (25549, 27, 15459, 1, 320, 108, 233);
INSERT INTO public.who_global_data VALUES (25550, 326, 36608, 2, 780, 108, 133);
INSERT INTO public.who_global_data VALUES (25551, 0, 148, 0, 0, 108, 35);
INSERT INTO public.who_global_data VALUES (25552, 5, 2336, 0, 73, 108, 114);
INSERT INTO public.who_global_data VALUES (25553, 6, 57921, 0, 28, 108, 237);
INSERT INTO public.who_global_data VALUES (25554, 0, 14, 0, 0, 108, 55);
INSERT INTO public.who_global_data VALUES (25555, 3, 756, 0, 22, 108, 176);
INSERT INTO public.who_global_data VALUES (25556, 705, 31400, 6, 98, 108, 202);
INSERT INTO public.who_global_data VALUES (25557, 1505, 15993, 11, 229, 108, 155);
INSERT INTO public.who_global_data VALUES (25558, 0, 3, 0, 0, 108, 32);
INSERT INTO public.who_global_data VALUES (25559, 26, 3890, 2, 101, 108, 220);
INSERT INTO public.who_global_data VALUES (25560, 1050, 706304, 164, 18656, 108, 30);
INSERT INTO public.who_global_data VALUES (25561, 23, 2870, 0, 55, 108, 147);
INSERT INTO public.who_global_data VALUES (25562, 16143, 1048995, 164, 36608, 108, 208);
INSERT INTO public.who_global_data VALUES (25563, 186, 5811, 0, 13, 108, 45);
INSERT INTO public.who_global_data VALUES (25564, 4, 13728, 0, 836, 108, 110);
INSERT INTO public.who_global_data VALUES (25565, 3, 5133, 0, 109, 108, 88);
INSERT INTO public.who_global_data VALUES (25566, 771, 106469, 4, 5935, 108, 51);
INSERT INTO public.who_global_data VALUES (25567, 5669, 95441, 13, 1917, 108, 209);
INSERT INTO public.who_global_data VALUES (25568, 46, 5180, 3, 254, 108, 205);
INSERT INTO public.who_global_data VALUES (25569, 41, 10574, 0, 80, 108, 18);
INSERT INTO public.who_global_data VALUES (25570, 9, 3709, 0, 59, 108, 72);
INSERT INTO public.who_global_data VALUES (25571, 21330, 762546, 241, 43967, 108, 44);
INSERT INTO public.who_global_data VALUES (25572, 0, 29, 0, 0, 108, 15);
INSERT INTO public.who_global_data VALUES (25573, 33, 2104, 0, 51, 108, 25);
INSERT INTO public.who_global_data VALUES (25574, 0, 0, 0, 0, 108, 179);
INSERT INTO public.who_global_data VALUES (25575, 0, 0, 0, 0, 108, 34);
INSERT INTO public.who_global_data VALUES (25576, 1, 5298, 1, 97, 108, 207);
INSERT INTO public.who_global_data VALUES (25577, 1442, 45892, 29, 740, 108, 166);
INSERT INTO public.who_global_data VALUES (25578, 8624, 923463, 74, 9445, 108, 126);
INSERT INTO public.who_global_data VALUES (25579, 0, 0, 0, 0, 108, 97);
INSERT INTO public.who_global_data VALUES (25580, 0, 698, 0, 6, 108, 36);
INSERT INTO public.who_global_data VALUES (25581, 0, 0, 0, 0, 108, 125);
INSERT INTO public.who_global_data VALUES (25582, 97, 10788, 0, 97, 108, 124);
INSERT INTO public.who_global_data VALUES (25583, 6719, 315826, 141, 5927, 108, 185);
INSERT INTO public.who_global_data VALUES (25584, 1077, 117594, 4, 470, 108, 194);
INSERT INTO public.who_global_data VALUES (25585, 0, 509, 0, 21, 108, 144);
INSERT INTO public.who_global_data VALUES (25586, 59018, 8124633, 510, 218641, 108, 19);
INSERT INTO public.who_global_data VALUES (25587, 0, 1335, 0, 21, 108, 217);
INSERT INTO public.who_global_data VALUES (25588, 29, 2560, 0, 51, 108, 148);
INSERT INTO public.who_global_data VALUES (25589, 273, 64010, 1, 534, 108, 86);
INSERT INTO public.who_global_data VALUES (25590, 0, 0, 0, 0, 108, 13);
INSERT INTO public.who_global_data VALUES (25591, 525, 87161, 5, 741, 108, 157);
INSERT INTO public.who_global_data VALUES (25592, 1, 1141, 0, 35, 108, 8);
INSERT INTO public.who_global_data VALUES (25593, 0, 1, 0, 0, 108, 73);
INSERT INTO public.who_global_data VALUES (25594, 1, 2061, 0, 598, 108, 101);
INSERT INTO public.who_global_data VALUES (25595, 85, 15982, 0, 346, 108, 165);
INSERT INTO public.who_global_data VALUES (25596, 28, 8187, 1, 233, 108, 14);
INSERT INTO public.who_global_data VALUES (25597, 88, 40461, 2, 1503, 109, 193);
INSERT INTO public.who_global_data VALUES (25598, 295, 17350, 3, 454, 109, 113);
INSERT INTO public.who_global_data VALUES (25599, 214, 54616, 9, 1865, 109, 143);
INSERT INTO public.who_global_data VALUES (25600, 0, 0, 0, 0, 109, 219);
INSERT INTO public.who_global_data VALUES (25601, 246, 3623, 3, 62, 109, 186);
INSERT INTO public.who_global_data VALUES (25602, 207, 7829, 1, 248, 109, 52);
INSERT INTO public.who_global_data VALUES (25603, 0, 3, 0, 0, 109, 180);
INSERT INTO public.who_global_data VALUES (25604, 0, 119, 0, 3, 109, 167);
INSERT INTO public.who_global_data VALUES (25605, 10561, 989680, 160, 26267, 109, 154);
INSERT INTO public.who_global_data VALUES (25606, 1234, 66007, 10, 1096, 109, 94);
INSERT INTO public.who_global_data VALUES (25607, 37, 4322, 2, 34, 109, 66);
INSERT INTO public.who_global_data VALUES (25608, 9, 27399, 1, 905, 109, 58);
INSERT INTO public.who_global_data VALUES (25609, 1054, 66611, 9, 919, 109, 163);
INSERT INTO public.who_global_data VALUES (25610, 331, 45295, 4, 630, 109, 37);
INSERT INTO public.who_global_data VALUES (25611, 70, 5773, 1, 123, 109, 142);
INSERT INTO public.who_global_data VALUES (25612, 322, 78224, 2, 302, 109, 83);
INSERT INTO public.who_global_data VALUES (25613, 1637, 390206, 21, 5681, 109, 228);
INSERT INTO public.who_global_data VALUES (25614, 3, 222, 0, 7, 109, 188);
INSERT INTO public.who_global_data VALUES (25615, 592, 88290, 4, 933, 109, 62);
INSERT INTO public.who_global_data VALUES (25616, 15561, 262162, 52, 10497, 109, 160);
INSERT INTO public.who_global_data VALUES (25617, 38, 2813, 1, 44, 109, 50);
INSERT INTO public.who_global_data VALUES (25618, 0, 2496, 0, 41, 109, 33);
INSERT INTO public.who_global_data VALUES (25619, 0, 185, 0, 9, 109, 183);
INSERT INTO public.who_global_data VALUES (25620, 3, 330, 0, 0, 109, 92);
INSERT INTO public.who_global_data VALUES (25621, 61, 139771, 18, 8481, 109, 158);
INSERT INTO public.who_global_data VALUES (25622, 0, 131, 0, 3, 109, 67);
INSERT INTO public.who_global_data VALUES (25623, 545, 34665, 13, 997, 109, 57);
INSERT INTO public.who_global_data VALUES (25624, 0, 5242, 0, 20, 109, 38);
INSERT INTO public.who_global_data VALUES (25625, 10982, 5235344, 230, 153905, 109, 141);
INSERT INTO public.who_global_data VALUES (25626, 0, 72, 0, 1, 109, 178);
INSERT INTO public.who_global_data VALUES (25627, 0, 147, 0, 3, 109, 108);
INSERT INTO public.who_global_data VALUES (25628, 1024, 30527, 22, 1008, 109, 39);
INSERT INTO public.who_global_data VALUES (25629, 6, 2387, 0, 65, 109, 2);
INSERT INTO public.who_global_data VALUES (25630, 1, 550, 0, 1, 109, 195);
INSERT INTO public.who_global_data VALUES (25631, 48, 7800, 1, 87, 109, 107);
INSERT INTO public.who_global_data VALUES (25632, 2, 285, 0, 0, 109, 161);
INSERT INTO public.who_global_data VALUES (25633, 64, 21570, 1, 425, 109, 212);
INSERT INTO public.who_global_data VALUES (25634, 1827, 198148, 14, 9760, 109, 181);
INSERT INTO public.who_global_data VALUES (25635, 0, 233, 0, 1, 109, 53);
INSERT INTO public.who_global_data VALUES (25636, 2, 4858, 0, 62, 109, 164);
INSERT INTO public.who_global_data VALUES (25637, 11, 1390, 0, 93, 109, 140);
INSERT INTO public.who_global_data VALUES (25638, 1545, 493305, 41, 13676, 109, 20);
INSERT INTO public.who_global_data VALUES (25639, 39, 91546, 0, 4746, 109, 112);
INSERT INTO public.who_global_data VALUES (25640, 7201, 959572, 167, 28970, 109, 111);
INSERT INTO public.who_global_data VALUES (25641, 6, 502, 0, 7, 109, 71);
INSERT INTO public.who_global_data VALUES (25642, 0, 5156, 0, 92, 109, 218);
INSERT INTO public.who_global_data VALUES (25643, 0, 0, 0, 0, 109, 43);
INSERT INTO public.who_global_data VALUES (25644, 929, 96443, 11, 1194, 109, 49);
INSERT INTO public.who_global_data VALUES (25645, 1, 20324, 0, 121, 109, 1);
INSERT INTO public.who_global_data VALUES (25646, 393, 25973, 11, 374, 109, 48);
INSERT INTO public.who_global_data VALUES (25647, 38, 6258, 2, 127, 109, 232);
INSERT INTO public.who_global_data VALUES (25648, 71, 744, 0, 1, 109, 175);
INSERT INTO public.who_global_data VALUES (25649, 43, 2687, 0, 25, 109, 21);
INSERT INTO public.who_global_data VALUES (25650, 8077, 181962, 91, 1513, 109, 156);
INSERT INTO public.who_global_data VALUES (25651, 0, 0, 0, 0, 109, 95);
INSERT INTO public.who_global_data VALUES (25652, 46, 11051, 1, 303, 109, 177);
INSERT INTO public.who_global_data VALUES (25653, 452, 35844, 6, 686, 109, 210);
INSERT INTO public.who_global_data VALUES (25654, 10, 5469, 0, 61, 109, 120);
INSERT INTO public.who_global_data VALUES (25655, 0, 33, 0, 0, 109, 135);
INSERT INTO public.who_global_data VALUES (25656, 320, 121667, 4, 2203, 109, 206);
INSERT INTO public.who_global_data VALUES (25657, 134, 153423, 8, 12395, 109, 189);
INSERT INTO public.who_global_data VALUES (25658, 123, 105547, 10, 6130, 109, 129);
INSERT INTO public.who_global_data VALUES (25659, 0, 31666, 4, 926, 109, 121);
INSERT INTO public.who_global_data VALUES (25660, 4, 5074, 0, 83, 109, 59);
INSERT INTO public.who_global_data VALUES (25661, 0, 425, 0, 0, 109, 96);
INSERT INTO public.who_global_data VALUES (25662, 7, 4085, 0, 68, 109, 41);
INSERT INTO public.who_global_data VALUES (25663, 8, 5788, 0, 116, 109, 216);
INSERT INTO public.who_global_data VALUES (25664, 723, 89860, 13, 1365, 109, 236);
INSERT INTO public.who_global_data VALUES (25665, 0, 13, 0, 0, 109, 150);
INSERT INTO public.who_global_data VALUES (25666, 0, 485, 0, 0, 109, 61);
INSERT INTO public.who_global_data VALUES (25667, 0, 32, 0, 2, 109, 7);
INSERT INTO public.who_global_data VALUES (25668, 131, 13555, 0, 351, 109, 169);
INSERT INTO public.who_global_data VALUES (25669, 12944, 880922, 146, 33350, 109, 28);
INSERT INTO public.who_global_data VALUES (25670, 25, 10268, 0, 69, 109, 85);
INSERT INTO public.who_global_data VALUES (25671, 813, 4610, 2, 16, 109, 211);
INSERT INTO public.who_global_data VALUES (25672, 3, 8884, 0, 54, 109, 60);
INSERT INTO public.who_global_data VALUES (25673, 6, 3655, 0, 118, 109, 3);
INSERT INTO public.who_global_data VALUES (25674, 1194, 19857, 15, 158, 109, 11);
INSERT INTO public.who_global_data VALUES (25675, 6868, 373167, 47, 9836, 109, 89);
INSERT INTO public.who_global_data VALUES (25676, 140, 47372, 0, 310, 109, 24);
INSERT INTO public.who_global_data VALUES (25677, 13, 571, 0, 0, 109, 162);
INSERT INTO public.who_global_data VALUES (25678, 432, 25802, 11, 520, 109, 100);
INSERT INTO public.who_global_data VALUES (25679, 0, 16, 0, 0, 109, 47);
INSERT INTO public.who_global_data VALUES (25680, 0, 27, 0, 0, 109, 29);
INSERT INTO public.who_global_data VALUES (25681, 0, 7122, 0, 111, 109, 40);
INSERT INTO public.who_global_data VALUES (25682, 78, 3742, 0, 66, 109, 222);
INSERT INTO public.who_global_data VALUES (25683, 239, 101599, 11, 3541, 109, 132);
INSERT INTO public.who_global_data VALUES (25684, 0, 258, 0, 13, 109, 130);
INSERT INTO public.who_global_data VALUES (25685, 0, 11518, 0, 70, 109, 234);
INSERT INTO public.who_global_data VALUES (25686, 14, 2403, 0, 41, 109, 23);
INSERT INTO public.who_global_data VALUES (25687, 24, 3734, 0, 109, 109, 192);
INSERT INTO public.who_global_data VALUES (25688, 0, 8925, 0, 231, 109, 69);
INSERT INTO public.who_global_data VALUES (25689, 0, 26, 0, 0, 109, 187);
INSERT INTO public.who_global_data VALUES (25690, 841, 88435, 5, 2568, 109, 230);
INSERT INTO public.who_global_data VALUES (25691, 989, 48757, 38, 1211, 109, 77);
INSERT INTO public.who_global_data VALUES (25692, 46, 4101, 0, 11, 109, 9);
INSERT INTO public.who_global_data VALUES (25693, 46790, 7597063, 587, 115197, 109, 74);
INSERT INTO public.who_global_data VALUES (25694, 3373, 365240, 106, 12617, 109, 224);
INSERT INTO public.who_global_data VALUES (25695, 4251, 534631, 337, 30712, 109, 199);
INSERT INTO public.who_global_data VALUES (25696, 4044, 430678, 63, 10317, 109, 190);
INSERT INTO public.who_global_data VALUES (25697, 1031, 50993, 0, 1852, 109, 12);
INSERT INTO public.who_global_data VALUES (25698, 0, 348, 0, 24, 109, 104);
INSERT INTO public.who_global_data VALUES (25699, 922, 303698, 33, 2251, 109, 153);
INSERT INTO public.who_global_data VALUES (25700, 9337, 423578, 73, 36616, 109, 91);
INSERT INTO public.who_global_data VALUES (25701, 47, 8321, 2, 173, 109, 215);
INSERT INTO public.who_global_data VALUES (25702, 353, 93480, 2, 1676, 109, 84);
INSERT INTO public.who_global_data VALUES (25703, 0, 491, 0, 32, 109, 231);
INSERT INTO public.who_global_data VALUES (25704, 1364, 39005, 35, 380, 109, 196);
INSERT INTO public.who_global_data VALUES (25705, 363, 145966, 0, 2178, 109, 105);
INSERT INTO public.who_global_data VALUES (25706, 195, 45076, 7, 839, 109, 122);
INSERT INTO public.who_global_data VALUES (25707, 0, 0, 0, 0, 109, 159);
INSERT INTO public.who_global_data VALUES (25708, 118, 16966, 3, 646, 109, 75);
INSERT INTO public.who_global_data VALUES (25709, 686, 116832, 9, 710, 109, 27);
INSERT INTO public.who_global_data VALUES (25710, 384, 52910, 2, 1113, 109, 54);
INSERT INTO public.who_global_data VALUES (25711, 0, 23, 0, 0, 109, 226);
INSERT INTO public.who_global_data VALUES (25712, 44, 3494, 0, 42, 109, 79);
INSERT INTO public.who_global_data VALUES (25713, 995, 62944, 6, 526, 109, 56);
INSERT INTO public.who_global_data VALUES (25714, 0, 1833, 0, 42, 109, 117);
INSERT INTO public.who_global_data VALUES (25715, 1, 1381, 0, 82, 109, 152);
INSERT INTO public.who_global_data VALUES (25716, 957, 50906, 14, 746, 109, 16);
INSERT INTO public.who_global_data VALUES (25717, 30, 258, 0, 1, 109, 10);
INSERT INTO public.who_global_data VALUES (25718, 203, 7923, 3, 105, 109, 201);
INSERT INTO public.who_global_data VALUES (25719, 242, 10888, 0, 133, 109, 174);
INSERT INTO public.who_global_data VALUES (25720, 0, 16810, 0, 238, 109, 119);
INSERT INTO public.who_global_data VALUES (25721, 3, 5860, 0, 181, 109, 168);
INSERT INTO public.who_global_data VALUES (25722, 865, 21363, 3, 190, 109, 99);
INSERT INTO public.who_global_data VALUES (25723, 22, 11232, 0, 37, 109, 171);
INSERT INTO public.who_global_data VALUES (25724, 19, 3407, 0, 132, 109, 87);
INSERT INTO public.who_global_data VALUES (25725, 134, 4863, 0, 45, 109, 123);
INSERT INTO public.who_global_data VALUES (25726, 0, 0, 0, 0, 109, 151);
INSERT INTO public.who_global_data VALUES (25727, 0, 2266, 0, 25, 109, 213);
INSERT INTO public.who_global_data VALUES (25728, 13, 7621, 0, 163, 109, 118);
INSERT INTO public.who_global_data VALUES (25729, 0, 407, 0, 10, 109, 134);
INSERT INTO public.who_global_data VALUES (25730, 129, 4159, 0, 43, 109, 65);
INSERT INTO public.who_global_data VALUES (25731, 4119, 851227, 108, 86167, 109, 102);
INSERT INTO public.who_global_data VALUES (25732, 0, 0, 0, 0, 109, 223);
INSERT INTO public.who_global_data VALUES (25733, 3, 271, 0, 2, 109, 4);
INSERT INTO public.who_global_data VALUES (25734, 0, 324, 0, 0, 109, 146);
INSERT INTO public.who_global_data VALUES (25735, 180, 16028, 7, 247, 109, 31);
INSERT INTO public.who_global_data VALUES (25736, 0, 13, 0, 1, 109, 127);
INSERT INTO public.who_global_data VALUES (25737, 2117, 175749, 48, 2976, 109, 22);
INSERT INTO public.who_global_data VALUES (25738, 214, 11080, 0, 75, 109, 115);
INSERT INTO public.who_global_data VALUES (25739, 1180, 37205, 34, 914, 109, 106);
INSERT INTO public.who_global_data VALUES (25740, 33, 12326, 0, 131, 109, 90);
INSERT INTO public.who_global_data VALUES (25741, 0, 0, 0, 0, 109, 70);
INSERT INTO public.who_global_data VALUES (25742, 3790, 136036, 18, 757, 109, 46);
INSERT INTO public.who_global_data VALUES (25743, 7991, 235611, 17, 6764, 109, 139);
INSERT INTO public.who_global_data VALUES (25744, 0, 27, 0, 0, 109, 42);
INSERT INTO public.who_global_data VALUES (25745, 1, 1531, 0, 25, 109, 80);
INSERT INTO public.who_global_data VALUES (25746, 0, 4297, 0, 154, 109, 203);
INSERT INTO public.who_global_data VALUES (25747, 1, 1211, 0, 69, 109, 136);
INSERT INTO public.who_global_data VALUES (25748, 118, 61558, 0, 1125, 109, 63);
INSERT INTO public.who_global_data VALUES (25749, 0, 0, 0, 0, 109, 17);
INSERT INTO public.who_global_data VALUES (25750, 0, 86, 0, 2, 109, 172);
INSERT INTO public.who_global_data VALUES (25751, 160, 23788, 12, 846, 109, 109);
INSERT INTO public.who_global_data VALUES (25752, 320, 16456, 0, 278, 109, 200);
INSERT INTO public.who_global_data VALUES (25753, 543, 59082, 6, 484, 109, 93);
INSERT INTO public.who_global_data VALUES (25754, 641, 110594, 13, 1114, 109, 5);
INSERT INTO public.who_global_data VALUES (25755, 0, 741, 0, 13, 109, 214);
INSERT INTO public.who_global_data VALUES (25756, 618, 324077, 14, 6673, 109, 204);
INSERT INTO public.who_global_data VALUES (25757, 0, 0, 0, 0, 109, 198);
INSERT INTO public.who_global_data VALUES (25758, 638, 124745, 7, 2564, 109, 173);
INSERT INTO public.who_global_data VALUES (25759, 0, 581, 0, 7, 109, 229);
INSERT INTO public.who_global_data VALUES (25760, 709, 54724, 9, 1188, 109, 76);
INSERT INTO public.who_global_data VALUES (25761, 3126, 868675, 57, 33759, 109, 138);
INSERT INTO public.who_global_data VALUES (25762, 2551, 359169, 23, 6675, 109, 98);
INSERT INTO public.who_global_data VALUES (25763, 0, 0, 0, 0, 109, 103);
INSERT INTO public.who_global_data VALUES (25764, 7482, 183248, 41, 3614, 109, 225);
INSERT INTO public.who_global_data VALUES (25765, 1949, 101860, 17, 2198, 109, 131);
INSERT INTO public.who_global_data VALUES (25766, 657, 57950, 2, 768, 109, 235);
INSERT INTO public.who_global_data VALUES (25767, 240, 129671, 0, 224, 109, 137);
INSERT INTO public.who_global_data VALUES (25768, 58, 25333, 3, 447, 109, 81);
INSERT INTO public.who_global_data VALUES (25769, 252, 67302, 17, 1601, 109, 182);
INSERT INTO public.who_global_data VALUES (25770, 145, 4921, 0, 17, 109, 145);
INSERT INTO public.who_global_data VALUES (25771, 2466, 182854, 59, 5931, 109, 26);
INSERT INTO public.who_global_data VALUES (25772, 16319, 1431635, 269, 24635, 109, 170);
INSERT INTO public.who_global_data VALUES (25773, 18, 4992, 0, 34, 109, 191);
INSERT INTO public.who_global_data VALUES (25774, 0, 5, 0, 0, 109, 221);
INSERT INTO public.who_global_data VALUES (25775, 0, 72, 0, 0, 109, 64);
INSERT INTO public.who_global_data VALUES (25776, 0, 0, 0, 0, 109, 116);
INSERT INTO public.who_global_data VALUES (25777, 0, 19, 0, 0, 109, 128);
INSERT INTO public.who_global_data VALUES (25778, 3, 36, 0, 0, 109, 6);
INSERT INTO public.who_global_data VALUES (25779, 0, 531, 0, 8, 109, 227);
INSERT INTO public.who_global_data VALUES (25780, 0, 12, 0, 0, 109, 68);
INSERT INTO public.who_global_data VALUES (25781, 0, 67, 0, 0, 109, 184);
INSERT INTO public.who_global_data VALUES (25782, 0, 0, 0, 0, 109, 82);
INSERT INTO public.who_global_data VALUES (25783, 5, 789, 0, 42, 109, 149);
INSERT INTO public.who_global_data VALUES (25784, 0, 933, 0, 15, 109, 197);
INSERT INTO public.who_global_data VALUES (25785, 381, 342583, 16, 5201, 109, 78);
INSERT INTO public.who_global_data VALUES (25786, 14, 15432, 2, 319, 109, 233);
INSERT INTO public.who_global_data VALUES (25787, 122, 36282, 2, 778, 109, 133);
INSERT INTO public.who_global_data VALUES (25788, 0, 148, 0, 0, 109, 35);
INSERT INTO public.who_global_data VALUES (25789, 1, 2331, 0, 73, 109, 114);
INSERT INTO public.who_global_data VALUES (25790, 4, 57915, 0, 28, 109, 237);
INSERT INTO public.who_global_data VALUES (25791, 0, 14, 0, 0, 109, 55);
INSERT INTO public.who_global_data VALUES (25792, 16, 753, 0, 22, 109, 176);
INSERT INTO public.who_global_data VALUES (25793, 860, 30695, 4, 92, 109, 202);
INSERT INTO public.who_global_data VALUES (25794, 802, 14488, 6, 218, 109, 155);
INSERT INTO public.who_global_data VALUES (25795, 0, 3, 0, 0, 109, 32);
INSERT INTO public.who_global_data VALUES (25796, 0, 3864, 0, 99, 109, 220);
INSERT INTO public.who_global_data VALUES (25797, 1461, 705254, 21, 18492, 109, 30);
INSERT INTO public.who_global_data VALUES (25798, 0, 2847, 0, 55, 109, 147);
INSERT INTO public.who_global_data VALUES (25799, 8458, 1032852, 143, 36444, 109, 208);
INSERT INTO public.who_global_data VALUES (25800, 87, 5625, 0, 13, 109, 45);
INSERT INTO public.who_global_data VALUES (25801, 0, 13724, 0, 836, 109, 110);
INSERT INTO public.who_global_data VALUES (25802, 7, 5130, 0, 109, 109, 88);
INSERT INTO public.who_global_data VALUES (25803, 321, 105698, 1, 5931, 109, 51);
INSERT INTO public.who_global_data VALUES (25804, 5397, 89772, 16, 1904, 109, 209);
INSERT INTO public.who_global_data VALUES (25805, 57, 5134, 3, 251, 109, 205);
INSERT INTO public.who_global_data VALUES (25806, 40, 10533, 0, 80, 109, 18);
INSERT INTO public.who_global_data VALUES (25807, 9, 3700, 0, 59, 109, 72);
INSERT INTO public.who_global_data VALUES (25808, 18803, 741216, 80, 43726, 109, 44);
INSERT INTO public.who_global_data VALUES (25809, 0, 29, 0, 0, 109, 15);
INSERT INTO public.who_global_data VALUES (25810, 14, 2071, 0, 51, 109, 25);
INSERT INTO public.who_global_data VALUES (25811, 0, 0, 0, 0, 109, 179);
INSERT INTO public.who_global_data VALUES (25812, 0, 0, 0, 0, 109, 34);
INSERT INTO public.who_global_data VALUES (25813, 16, 5297, 1, 96, 109, 207);
INSERT INTO public.who_global_data VALUES (25814, 1723, 44450, 24, 711, 109, 166);
INSERT INTO public.who_global_data VALUES (25815, 8756, 914839, 75, 9371, 109, 126);
INSERT INTO public.who_global_data VALUES (25816, 0, 0, 0, 0, 109, 97);
INSERT INTO public.who_global_data VALUES (25817, 0, 698, 0, 6, 109, 36);
INSERT INTO public.who_global_data VALUES (25818, 0, 0, 0, 0, 109, 125);
INSERT INTO public.who_global_data VALUES (25819, 101, 10691, 0, 97, 109, 124);
INSERT INTO public.who_global_data VALUES (25820, 5469, 309107, 113, 5786, 109, 185);
INSERT INTO public.who_global_data VALUES (25821, 915, 116517, 3, 466, 109, 194);
INSERT INTO public.who_global_data VALUES (25822, 0, 509, 0, 21, 109, 144);
INSERT INTO public.who_global_data VALUES (25823, 46378, 8065615, 472, 218131, 109, 19);
INSERT INTO public.who_global_data VALUES (25824, 0, 1335, 0, 21, 109, 217);
INSERT INTO public.who_global_data VALUES (25825, 30, 2531, 0, 51, 109, 148);
INSERT INTO public.who_global_data VALUES (25826, 307, 63737, 4, 533, 109, 86);
INSERT INTO public.who_global_data VALUES (25827, 0, 0, 0, 0, 109, 13);
INSERT INTO public.who_global_data VALUES (25828, 347, 86636, 5, 736, 109, 157);
INSERT INTO public.who_global_data VALUES (25829, 6, 1140, 0, 35, 109, 8);
INSERT INTO public.who_global_data VALUES (25830, 0, 1, 0, 0, 109, 73);
INSERT INTO public.who_global_data VALUES (25831, 0, 2060, 0, 598, 109, 101);
INSERT INTO public.who_global_data VALUES (25832, 44, 15897, 0, 346, 109, 165);
INSERT INTO public.who_global_data VALUES (25833, 12, 8159, 1, 232, 109, 14);
INSERT INTO public.who_global_data VALUES (25834, 87, 40373, 5, 1501, 110, 193);
INSERT INTO public.who_global_data VALUES (25835, 281, 17055, 3, 451, 110, 113);
INSERT INTO public.who_global_data VALUES (25836, 199, 54402, 10, 1856, 110, 143);
INSERT INTO public.who_global_data VALUES (25837, 0, 0, 0, 0, 110, 219);
INSERT INTO public.who_global_data VALUES (25838, 0, 3377, 0, 59, 110, 186);
INSERT INTO public.who_global_data VALUES (25839, 160, 7622, 6, 247, 110, 52);
INSERT INTO public.who_global_data VALUES (25840, 0, 3, 0, 0, 110, 180);
INSERT INTO public.who_global_data VALUES (25841, 6, 119, 0, 3, 110, 167);
INSERT INTO public.who_global_data VALUES (25842, 13510, 979119, 384, 26107, 110, 154);
INSERT INTO public.who_global_data VALUES (25843, 766, 64773, 10, 1086, 110, 94);
INSERT INTO public.who_global_data VALUES (25844, 0, 4285, 0, 32, 110, 66);
INSERT INTO public.who_global_data VALUES (25845, 7, 27390, 0, 904, 110, 58);
INSERT INTO public.who_global_data VALUES (25846, 1062, 65557, 3, 910, 110, 163);
INSERT INTO public.who_global_data VALUES (25847, 647, 44964, 3, 626, 110, 37);
INSERT INTO public.who_global_data VALUES (25848, 75, 5703, 6, 122, 110, 142);
INSERT INTO public.who_global_data VALUES (25849, 331, 77902, 7, 300, 110, 83);
INSERT INTO public.who_global_data VALUES (25850, 1274, 388569, 14, 5660, 110, 228);
INSERT INTO public.who_global_data VALUES (25851, 0, 219, 0, 7, 110, 188);
INSERT INTO public.who_global_data VALUES (25852, 635, 87698, 4, 929, 110, 62);
INSERT INTO public.who_global_data VALUES (25853, 4289, 246601, 31, 10445, 110, 160);
INSERT INTO public.who_global_data VALUES (25854, 47, 2775, 0, 43, 110, 50);
INSERT INTO public.who_global_data VALUES (25855, 0, 2496, 0, 41, 110, 33);
INSERT INTO public.who_global_data VALUES (25856, 0, 185, 0, 9, 110, 183);
INSERT INTO public.who_global_data VALUES (25857, 2, 327, 0, 0, 110, 92);
INSERT INTO public.who_global_data VALUES (25858, 148, 139710, 24, 8463, 110, 158);
INSERT INTO public.who_global_data VALUES (25859, 0, 131, 1, 3, 110, 67);
INSERT INTO public.who_global_data VALUES (25860, 559, 34120, 4, 984, 110, 57);
INSERT INTO public.who_global_data VALUES (25861, 0, 5242, 0, 20, 110, 38);
INSERT INTO public.who_global_data VALUES (25862, 24062, 5224362, 461, 153675, 110, 141);
INSERT INTO public.who_global_data VALUES (25863, 0, 72, 0, 1, 110, 178);
INSERT INTO public.who_global_data VALUES (25864, 0, 147, 0, 3, 110, 108);
INSERT INTO public.who_global_data VALUES (25865, 395, 29503, 18, 986, 110, 39);
INSERT INTO public.who_global_data VALUES (25866, 7, 2381, 0, 65, 110, 2);
INSERT INTO public.who_global_data VALUES (25867, 7, 549, 0, 1, 110, 195);
INSERT INTO public.who_global_data VALUES (25868, 114, 7752, 1, 86, 110, 107);
INSERT INTO public.who_global_data VALUES (25869, 0, 283, 0, 0, 110, 161);
INSERT INTO public.who_global_data VALUES (25870, 65, 21506, 1, 424, 110, 212);
INSERT INTO public.who_global_data VALUES (25871, 2215, 196321, 24, 9746, 110, 181);
INSERT INTO public.who_global_data VALUES (25872, 0, 233, 0, 1, 110, 53);
INSERT INTO public.who_global_data VALUES (25873, 1, 4856, 0, 62, 110, 164);
INSERT INTO public.who_global_data VALUES (25874, 14, 1379, 0, 93, 110, 140);
INSERT INTO public.who_global_data VALUES (25875, 1757, 491760, 47, 13635, 110, 20);
INSERT INTO public.who_global_data VALUES (25876, 17, 91507, 0, 4746, 110, 112);
INSERT INTO public.who_global_data VALUES (25877, 7017, 952371, 187, 28803, 110, 111);
INSERT INTO public.who_global_data VALUES (25878, 0, 496, 0, 7, 110, 71);
INSERT INTO public.who_global_data VALUES (25879, 0, 5156, 0, 92, 110, 218);
INSERT INTO public.who_global_data VALUES (25880, 0, 0, 0, 0, 110, 43);
INSERT INTO public.who_global_data VALUES (25881, 1166, 95514, 15, 1183, 110, 49);
INSERT INTO public.who_global_data VALUES (25882, 48, 20323, 0, 121, 110, 1);
INSERT INTO public.who_global_data VALUES (25883, 819, 25580, 8, 363, 110, 48);
INSERT INTO public.who_global_data VALUES (25884, 50, 6220, 0, 125, 110, 232);
INSERT INTO public.who_global_data VALUES (25885, 0, 673, 0, 1, 110, 175);
INSERT INTO public.who_global_data VALUES (25886, 265, 2644, 0, 25, 110, 21);
INSERT INTO public.who_global_data VALUES (25887, 5058, 173885, 70, 1422, 110, 156);
INSERT INTO public.who_global_data VALUES (25888, 0, 0, 0, 0, 110, 95);
INSERT INTO public.who_global_data VALUES (25889, 6, 11005, 0, 302, 110, 177);
INSERT INTO public.who_global_data VALUES (25890, 451, 35392, 1, 680, 110, 210);
INSERT INTO public.who_global_data VALUES (25891, 7, 5459, 0, 61, 110, 120);
INSERT INTO public.who_global_data VALUES (25892, 0, 33, 0, 0, 110, 135);
INSERT INTO public.who_global_data VALUES (25893, 422, 121347, 4, 2199, 110, 206);
INSERT INTO public.who_global_data VALUES (25894, 867, 153289, 12, 12387, 110, 189);
INSERT INTO public.who_global_data VALUES (25895, 127, 105424, 11, 6120, 110, 129);
INSERT INTO public.who_global_data VALUES (25896, 210, 31666, 5, 922, 110, 121);
INSERT INTO public.who_global_data VALUES (25897, 0, 5070, 0, 83, 110, 59);
INSERT INTO public.who_global_data VALUES (25898, 0, 425, 0, 0, 110, 96);
INSERT INTO public.who_global_data VALUES (25899, 26, 4078, 0, 68, 110, 41);
INSERT INTO public.who_global_data VALUES (25900, 15, 5780, 1, 116, 110, 216);
INSERT INTO public.who_global_data VALUES (25901, 703, 89137, 6, 1352, 110, 236);
INSERT INTO public.who_global_data VALUES (25902, 0, 13, 0, 0, 110, 150);
INSERT INTO public.who_global_data VALUES (25903, 2, 485, 0, 0, 110, 61);
INSERT INTO public.who_global_data VALUES (25904, 0, 32, 0, 2, 110, 7);
INSERT INTO public.who_global_data VALUES (25905, 131, 13424, 0, 351, 110, 169);
INSERT INTO public.who_global_data VALUES (25906, 29833, 867978, 85, 33204, 110, 28);
INSERT INTO public.who_global_data VALUES (25907, 4, 10243, 0, 69, 110, 85);
INSERT INTO public.who_global_data VALUES (25908, 0, 3797, 0, 14, 110, 211);
INSERT INTO public.who_global_data VALUES (25909, 0, 8881, 0, 54, 110, 60);
INSERT INTO public.who_global_data VALUES (25910, 0, 3649, 0, 118, 110, 3);
INSERT INTO public.who_global_data VALUES (25911, 1186, 18663, 7, 143, 110, 11);
INSERT INTO public.who_global_data VALUES (25912, 4325, 366299, 12, 9789, 110, 89);
INSERT INTO public.who_global_data VALUES (25913, 59, 47232, 0, 310, 110, 24);
INSERT INTO public.who_global_data VALUES (25914, 14, 558, 0, 0, 110, 162);
INSERT INTO public.who_global_data VALUES (25915, 438, 25370, 9, 509, 110, 100);
INSERT INTO public.who_global_data VALUES (25916, 0, 16, 0, 0, 110, 47);
INSERT INTO public.who_global_data VALUES (25917, 0, 27, 0, 0, 110, 29);
INSERT INTO public.who_global_data VALUES (25918, 0, 7122, 0, 111, 110, 40);
INSERT INTO public.who_global_data VALUES (25919, 58, 3664, 0, 66, 110, 222);
INSERT INTO public.who_global_data VALUES (25920, 332, 101360, 15, 3530, 110, 132);
INSERT INTO public.who_global_data VALUES (25921, 0, 258, 0, 13, 110, 130);
INSERT INTO public.who_global_data VALUES (25922, 40, 11518, 0, 70, 110, 234);
INSERT INTO public.who_global_data VALUES (25923, 0, 2389, 0, 41, 110, 23);
INSERT INTO public.who_global_data VALUES (25924, 38, 3710, 2, 109, 110, 192);
INSERT INTO public.who_global_data VALUES (25925, 0, 8925, 0, 231, 110, 69);
INSERT INTO public.who_global_data VALUES (25926, 0, 26, 0, 0, 110, 187);
INSERT INTO public.who_global_data VALUES (25927, 903, 87594, 7, 2563, 110, 230);
INSERT INTO public.who_global_data VALUES (25928, 1478, 47768, 31, 1173, 110, 77);
INSERT INTO public.who_global_data VALUES (25929, 57, 4055, 0, 11, 110, 9);
INSERT INTO public.who_global_data VALUES (25930, 55722, 7550273, 579, 114610, 110, 74);
INSERT INTO public.who_global_data VALUES (25931, 4105, 361867, 80, 12511, 110, 224);
INSERT INTO public.who_global_data VALUES (25932, 3890, 530380, 252, 30375, 110, 199);
INSERT INTO public.who_global_data VALUES (25933, 3110, 426634, 56, 10254, 110, 190);
INSERT INTO public.who_global_data VALUES (25934, 1284, 49962, 3, 1852, 110, 12);
INSERT INTO public.who_global_data VALUES (25935, 0, 348, 0, 24, 110, 104);
INSERT INTO public.who_global_data VALUES (25936, 412, 302776, 32, 2218, 110, 153);
INSERT INTO public.who_global_data VALUES (25937, 11705, 414241, 69, 36543, 110, 91);
INSERT INTO public.who_global_data VALUES (25938, 79, 8274, 3, 171, 110, 215);
INSERT INTO public.who_global_data VALUES (25939, 471, 93127, 4, 1674, 110, 84);
INSERT INTO public.who_global_data VALUES (25940, 0, 491, 0, 32, 110, 231);
INSERT INTO public.who_global_data VALUES (25941, 1520, 37641, 15, 345, 110, 196);
INSERT INTO public.who_global_data VALUES (25942, 130, 145603, 0, 2178, 110, 105);
INSERT INTO public.who_global_data VALUES (25943, 685, 44881, 7, 832, 110, 122);
INSERT INTO public.who_global_data VALUES (25944, 0, 0, 0, 0, 110, 159);
INSERT INTO public.who_global_data VALUES (25945, 137, 16848, 1, 643, 110, 75);
INSERT INTO public.who_global_data VALUES (25946, 663, 116146, 7, 701, 110, 27);
INSERT INTO public.who_global_data VALUES (25947, 482, 52526, 0, 1111, 110, 54);
INSERT INTO public.who_global_data VALUES (25948, 0, 23, 0, 0, 110, 226);
INSERT INTO public.who_global_data VALUES (25949, 58, 3450, 0, 42, 110, 79);
INSERT INTO public.who_global_data VALUES (25950, 1002, 61949, 3, 520, 110, 56);
INSERT INTO public.who_global_data VALUES (25951, 0, 1833, 0, 42, 110, 117);
INSERT INTO public.who_global_data VALUES (25952, 3, 1380, 0, 82, 110, 152);
INSERT INTO public.who_global_data VALUES (25953, 1159, 49949, 7, 732, 110, 16);
INSERT INTO public.who_global_data VALUES (25954, 2, 228, 0, 1, 110, 10);
INSERT INTO public.who_global_data VALUES (25955, 206, 7720, 2, 102, 110, 201);
INSERT INTO public.who_global_data VALUES (25956, 175, 10646, 0, 133, 110, 174);
INSERT INTO public.who_global_data VALUES (25957, -4, 16810, 0, 238, 110, 119);
INSERT INTO public.who_global_data VALUES (25958, 5, 5857, 0, 181, 110, 168);
INSERT INTO public.who_global_data VALUES (25959, 871, 20498, 7, 187, 110, 99);
INSERT INTO public.who_global_data VALUES (25960, 32, 11210, 1, 37, 110, 171);
INSERT INTO public.who_global_data VALUES (25961, 9, 3388, 0, 132, 110, 87);
INSERT INTO public.who_global_data VALUES (25962, 109, 4729, 0, 45, 110, 123);
INSERT INTO public.who_global_data VALUES (25963, 0, 0, 0, 0, 110, 151);
INSERT INTO public.who_global_data VALUES (25964, 0, 2266, 0, 25, 110, 213);
INSERT INTO public.who_global_data VALUES (25965, 5, 7608, 0, 163, 110, 118);
INSERT INTO public.who_global_data VALUES (25966, 0, 407, 0, 10, 110, 134);
INSERT INTO public.who_global_data VALUES (25967, 0, 4030, 0, 43, 110, 65);
INSERT INTO public.who_global_data VALUES (25968, 5447, 847108, 355, 86059, 110, 102);
INSERT INTO public.who_global_data VALUES (25969, 0, 0, 0, 0, 110, 223);
INSERT INTO public.who_global_data VALUES (25970, 5, 268, 0, 2, 110, 4);
INSERT INTO public.who_global_data VALUES (25971, 4, 324, 0, 0, 110, 146);
INSERT INTO public.who_global_data VALUES (25972, 118, 15848, 4, 240, 110, 31);
INSERT INTO public.who_global_data VALUES (25973, 0, 13, 0, 1, 110, 127);
INSERT INTO public.who_global_data VALUES (25974, 2721, 173632, 50, 2928, 110, 22);
INSERT INTO public.who_global_data VALUES (25975, 159, 10866, 1, 75, 110, 115);
INSERT INTO public.who_global_data VALUES (25976, 1150, 36025, 42, 880, 110, 106);
INSERT INTO public.who_global_data VALUES (25977, 30, 12293, 0, 131, 110, 90);
INSERT INTO public.who_global_data VALUES (25978, 0, 0, 0, 0, 110, 70);
INSERT INTO public.who_global_data VALUES (25979, 2942, 132246, 12, 739, 110, 46);
INSERT INTO public.who_global_data VALUES (25980, 8149, 227620, 14, 6747, 110, 139);
INSERT INTO public.who_global_data VALUES (25981, 0, 27, 0, 0, 110, 42);
INSERT INTO public.who_global_data VALUES (25982, 0, 1530, 0, 25, 110, 80);
INSERT INTO public.who_global_data VALUES (25983, 0, 4297, 0, 154, 110, 203);
INSERT INTO public.who_global_data VALUES (25984, 1, 1210, 0, 69, 110, 136);
INSERT INTO public.who_global_data VALUES (25985, 133, 61440, 2, 1125, 110, 63);
INSERT INTO public.who_global_data VALUES (25986, 0, 0, 0, 0, 110, 17);
INSERT INTO public.who_global_data VALUES (25987, 0, 86, 0, 2, 110, 172);
INSERT INTO public.who_global_data VALUES (25988, 427, 23628, 10, 834, 110, 109);
INSERT INTO public.who_global_data VALUES (25989, 0, 16136, 0, 278, 110, 200);
INSERT INTO public.who_global_data VALUES (25990, 389, 58539, 6, 478, 110, 93);
INSERT INTO public.who_global_data VALUES (25991, 1657, 109953, 30, 1101, 110, 5);
INSERT INTO public.who_global_data VALUES (25992, 0, 741, 0, 13, 110, 214);
INSERT INTO public.who_global_data VALUES (25993, 440, 323459, 5, 6659, 110, 204);
INSERT INTO public.who_global_data VALUES (25994, 0, 0, 0, 0, 110, 198);
INSERT INTO public.who_global_data VALUES (25995, 609, 124107, 11, 2557, 110, 173);
INSERT INTO public.who_global_data VALUES (25996, 0, 581, 0, 7, 110, 229);
INSERT INTO public.who_global_data VALUES (25997, 533, 54015, 13, 1179, 110, 76);
INSERT INTO public.who_global_data VALUES (25998, 3132, 865549, 54, 33702, 110, 138);
INSERT INTO public.who_global_data VALUES (25999, 2280, 356618, 49, 6652, 110, 98);
INSERT INTO public.who_global_data VALUES (26000, 0, 0, 0, 0, 110, 103);
INSERT INTO public.who_global_data VALUES (26001, 8536, 175766, 49, 3573, 110, 225);
INSERT INTO public.who_global_data VALUES (26002, 1856, 99911, 19, 2181, 110, 131);
INSERT INTO public.who_global_data VALUES (26003, 643, 57293, 5, 766, 110, 235);
INSERT INTO public.who_global_data VALUES (26004, 204, 129431, 1, 224, 110, 137);
INSERT INTO public.who_global_data VALUES (26005, 76, 25275, 0, 444, 110, 81);
INSERT INTO public.who_global_data VALUES (26006, 398, 67050, 15, 1584, 110, 182);
INSERT INTO public.who_global_data VALUES (26007, 0, 4776, 0, 17, 110, 145);
INSERT INTO public.who_global_data VALUES (26008, 3920, 180388, 60, 5872, 110, 26);
INSERT INTO public.who_global_data VALUES (26009, 15982, 1415316, 179, 24366, 110, 170);
INSERT INTO public.who_global_data VALUES (26010, 3, 4974, 0, 34, 110, 191);
INSERT INTO public.who_global_data VALUES (26011, 0, 5, 0, 0, 110, 221);
INSERT INTO public.who_global_data VALUES (26012, 0, 72, 0, 0, 110, 64);
INSERT INTO public.who_global_data VALUES (26013, 0, 0, 0, 0, 110, 116);
INSERT INTO public.who_global_data VALUES (26014, 0, 19, 0, 0, 110, 128);
INSERT INTO public.who_global_data VALUES (26015, 0, 33, 0, 0, 110, 6);
INSERT INTO public.who_global_data VALUES (26016, 0, 531, 0, 8, 110, 227);
INSERT INTO public.who_global_data VALUES (26017, 0, 12, 0, 0, 110, 68);
INSERT INTO public.who_global_data VALUES (26018, 0, 67, 0, 0, 110, 184);
INSERT INTO public.who_global_data VALUES (26019, 0, 0, 0, 0, 110, 82);
INSERT INTO public.who_global_data VALUES (26020, 0, 784, 0, 42, 110, 149);
INSERT INTO public.who_global_data VALUES (26021, 1, 933, 0, 15, 110, 197);
INSERT INTO public.who_global_data VALUES (26022, 348, 342202, 20, 5185, 110, 78);
INSERT INTO public.who_global_data VALUES (26023, 50, 15418, 0, 317, 110, 233);
INSERT INTO public.who_global_data VALUES (26024, 214, 36160, 2, 776, 110, 133);
INSERT INTO public.who_global_data VALUES (26025, 0, 148, 0, 0, 110, 35);
INSERT INTO public.who_global_data VALUES (26026, 3, 2330, 0, 73, 110, 114);
INSERT INTO public.who_global_data VALUES (26027, 7, 57911, 0, 28, 110, 237);
INSERT INTO public.who_global_data VALUES (26028, 0, 14, 0, 0, 110, 55);
INSERT INTO public.who_global_data VALUES (26029, 0, 737, 0, 22, 110, 176);
INSERT INTO public.who_global_data VALUES (26030, 1567, 29835, 6, 88, 110, 202);
INSERT INTO public.who_global_data VALUES (26031, 537, 13686, 4, 212, 110, 155);
INSERT INTO public.who_global_data VALUES (26032, 0, 3, 0, 0, 110, 32);
INSERT INTO public.who_global_data VALUES (26033, 0, 3864, 0, 99, 110, 220);
INSERT INTO public.who_global_data VALUES (26034, 1662, 703793, 63, 18471, 110, 30);
INSERT INTO public.who_global_data VALUES (26035, 5, 2847, 0, 55, 110, 147);
INSERT INTO public.who_global_data VALUES (26036, 12219, 1024394, 124, 36301, 110, 208);
INSERT INTO public.who_global_data VALUES (26037, 63, 5538, 0, 13, 110, 45);
INSERT INTO public.who_global_data VALUES (26038, 13, 13724, 0, 836, 110, 110);
INSERT INTO public.who_global_data VALUES (26039, 10, 5123, 0, 109, 110, 88);
INSERT INTO public.who_global_data VALUES (26040, 697, 105377, 4, 5930, 110, 51);
INSERT INTO public.who_global_data VALUES (26041, 1788, 84375, 7, 1888, 110, 209);
INSERT INTO public.who_global_data VALUES (26042, 44, 5077, 3, 248, 110, 205);
INSERT INTO public.who_global_data VALUES (26043, 38, 10493, 0, 80, 110, 18);
INSERT INTO public.who_global_data VALUES (26044, 5, 3691, 0, 59, 110, 72);
INSERT INTO public.who_global_data VALUES (26045, 16981, 722413, 67, 43646, 110, 44);
INSERT INTO public.who_global_data VALUES (26046, 0, 29, 0, 0, 110, 15);
INSERT INTO public.who_global_data VALUES (26047, 8, 2057, 0, 51, 110, 25);
INSERT INTO public.who_global_data VALUES (26048, 0, 0, 0, 0, 110, 179);
INSERT INTO public.who_global_data VALUES (26049, 0, 0, 0, 0, 110, 34);
INSERT INTO public.who_global_data VALUES (26050, 40, 5281, 0, 95, 110, 207);
INSERT INTO public.who_global_data VALUES (26051, 2185, 42727, 61, 687, 110, 166);
INSERT INTO public.who_global_data VALUES (26052, 8545, 906083, 72, 9296, 110, 126);
INSERT INTO public.who_global_data VALUES (26053, 0, 0, 0, 0, 110, 97);
INSERT INTO public.who_global_data VALUES (26054, 1, 698, 0, 6, 110, 36);
INSERT INTO public.who_global_data VALUES (26055, 0, 0, 0, 0, 110, 125);
INSERT INTO public.who_global_data VALUES (26056, 135, 10590, 1, 97, 110, 124);
INSERT INTO public.who_global_data VALUES (26057, 4766, 303638, 66, 5673, 110, 185);
INSERT INTO public.who_global_data VALUES (26058, 1215, 115602, 4, 463, 110, 194);
INSERT INTO public.who_global_data VALUES (26059, 0, 509, 0, 21, 110, 144);
INSERT INTO public.who_global_data VALUES (26060, 52508, 8019237, 588, 217659, 110, 19);
INSERT INTO public.who_global_data VALUES (26061, 6, 1335, 0, 21, 110, 217);
INSERT INTO public.who_global_data VALUES (26062, 51, 2501, 0, 51, 110, 148);
INSERT INTO public.who_global_data VALUES (26063, 306, 63430, 4, 529, 110, 86);
INSERT INTO public.who_global_data VALUES (26064, 0, 0, 0, 0, 110, 13);
INSERT INTO public.who_global_data VALUES (26065, 531, 86289, 6, 731, 110, 157);
INSERT INTO public.who_global_data VALUES (26066, 8, 1134, 0, 35, 110, 8);
INSERT INTO public.who_global_data VALUES (26067, 1, 1, 0, 0, 110, 73);
INSERT INTO public.who_global_data VALUES (26068, 1, 2060, 1, 598, 110, 101);
INSERT INTO public.who_global_data VALUES (26069, 64, 15853, 0, 346, 110, 165);
INSERT INTO public.who_global_data VALUES (26070, 37, 8147, 0, 231, 110, 14);
INSERT INTO public.who_global_data VALUES (26071, 59, 40286, 4, 1496, 111, 193);
INSERT INTO public.who_global_data VALUES (26072, 273, 16774, 5, 448, 111, 113);
INSERT INTO public.who_global_data VALUES (26073, 205, 54203, 5, 1846, 111, 143);
INSERT INTO public.who_global_data VALUES (26074, 0, 0, 0, 0, 111, 219);
INSERT INTO public.who_global_data VALUES (26075, 0, 3377, 0, 59, 111, 186);
INSERT INTO public.who_global_data VALUES (26076, 240, 7462, 7, 241, 111, 52);
INSERT INTO public.who_global_data VALUES (26077, 0, 3, 0, 0, 111, 180);
INSERT INTO public.who_global_data VALUES (26078, 1, 113, 0, 3, 111, 167);
INSERT INTO public.who_global_data VALUES (26079, 16546, 965609, 381, 25723, 111, 154);
INSERT INTO public.who_global_data VALUES (26080, 1694, 64007, 14, 1076, 111, 94);
INSERT INTO public.who_global_data VALUES (26081, 0, 4285, 0, 32, 111, 66);
INSERT INTO public.who_global_data VALUES (26082, 12, 27383, 0, 904, 111, 58);
INSERT INTO public.who_global_data VALUES (26083, 2040, 64495, 6, 907, 111, 163);
INSERT INTO public.who_global_data VALUES (26084, 528, 44317, 2, 623, 111, 37);
INSERT INTO public.who_global_data VALUES (26085, 111, 5628, 2, 116, 111, 142);
INSERT INTO public.who_global_data VALUES (26086, 246, 77571, 1, 293, 111, 83);
INSERT INTO public.who_global_data VALUES (26087, 1209, 387295, 23, 5646, 111, 228);
INSERT INTO public.who_global_data VALUES (26088, 1, 219, 0, 7, 111, 188);
INSERT INTO public.who_global_data VALUES (26089, 671, 87063, 4, 925, 111, 62);
INSERT INTO public.who_global_data VALUES (26090, 7995, 242312, 23, 10414, 111, 160);
INSERT INTO public.who_global_data VALUES (26091, 46, 2728, 2, 43, 111, 50);
INSERT INTO public.who_global_data VALUES (26092, 0, 2496, 0, 41, 111, 33);
INSERT INTO public.who_global_data VALUES (26093, 0, 185, 0, 9, 111, 183);
INSERT INTO public.who_global_data VALUES (26094, 9, 325, 0, 0, 111, 92);
INSERT INTO public.who_global_data VALUES (26095, 243, 139562, 32, 8439, 111, 158);
INSERT INTO public.who_global_data VALUES (26096, 0, 131, 0, 2, 111, 67);
INSERT INTO public.who_global_data VALUES (26097, 713, 33561, 2, 980, 111, 57);
INSERT INTO public.who_global_data VALUES (26098, 0, 5242, 0, 20, 111, 38);
INSERT INTO public.who_global_data VALUES (26099, 30914, 5200300, 754, 153214, 111, 141);
INSERT INTO public.who_global_data VALUES (26100, 0, 72, 0, 1, 111, 178);
INSERT INTO public.who_global_data VALUES (26101, 0, 147, 0, 3, 111, 108);
INSERT INTO public.who_global_data VALUES (26102, 603, 29108, 10, 968, 111, 39);
INSERT INTO public.who_global_data VALUES (26103, 31, 2374, 0, 65, 111, 2);
INSERT INTO public.who_global_data VALUES (26104, 6, 542, 0, 1, 111, 195);
INSERT INTO public.who_global_data VALUES (26105, 112, 7638, 3, 85, 111, 107);
INSERT INTO public.who_global_data VALUES (26106, 0, 283, 0, 0, 111, 161);
INSERT INTO public.who_global_data VALUES (26107, 0, 21441, 0, 423, 111, 212);
INSERT INTO public.who_global_data VALUES (26108, 2374, 194106, 23, 9722, 111, 181);
INSERT INTO public.who_global_data VALUES (26109, 8, 233, 0, 1, 111, 53);
INSERT INTO public.who_global_data VALUES (26110, 0, 4855, 0, 62, 111, 164);
INSERT INTO public.who_global_data VALUES (26111, 4, 1365, 0, 93, 111, 140);
INSERT INTO public.who_global_data VALUES (26112, 1813, 490003, 59, 13588, 111, 20);
INSERT INTO public.who_global_data VALUES (26113, 30, 91490, 0, 4746, 111, 112);
INSERT INTO public.who_global_data VALUES (26114, 8372, 945354, 159, 28616, 111, 111);
INSERT INTO public.who_global_data VALUES (26115, 0, 496, 0, 7, 111, 71);
INSERT INTO public.who_global_data VALUES (26116, 0, 5156, 0, 92, 111, 218);
INSERT INTO public.who_global_data VALUES (26117, 0, 0, 0, 0, 111, 43);
INSERT INTO public.who_global_data VALUES (26118, 1196, 94348, 9, 1168, 111, 49);
INSERT INTO public.who_global_data VALUES (26119, 18, 20275, 0, 121, 111, 1);
INSERT INTO public.who_global_data VALUES (26120, 1096, 24761, 10, 355, 111, 48);
INSERT INTO public.who_global_data VALUES (26121, 52, 6170, 1, 125, 111, 232);
INSERT INTO public.who_global_data VALUES (26122, 0, 673, 0, 1, 111, 175);
INSERT INTO public.who_global_data VALUES (26123, 0, 2379, 0, 25, 111, 21);
INSERT INTO public.who_global_data VALUES (26124, 8715, 168827, 69, 1352, 111, 156);
INSERT INTO public.who_global_data VALUES (26125, 0, 0, 0, 0, 111, 95);
INSERT INTO public.who_global_data VALUES (26126, 65, 10999, 21, 302, 111, 177);
INSERT INTO public.who_global_data VALUES (26127, 500, 34941, 2, 679, 111, 210);
INSERT INTO public.who_global_data VALUES (26128, 3, 5452, 0, 61, 111, 120);
INSERT INTO public.who_global_data VALUES (26129, 0, 33, 0, 0, 111, 135);
INSERT INTO public.who_global_data VALUES (26130, 475, 120925, 3, 2195, 111, 206);
INSERT INTO public.who_global_data VALUES (26131, 763, 152422, 18, 12375, 111, 189);
INSERT INTO public.who_global_data VALUES (26132, 138, 105297, 10, 6109, 111, 129);
INSERT INTO public.who_global_data VALUES (26133, 191, 31456, 5, 917, 111, 121);
INSERT INTO public.who_global_data VALUES (26134, 2, 5070, 0, 83, 111, 59);
INSERT INTO public.who_global_data VALUES (26135, 3, 425, 0, 0, 111, 96);
INSERT INTO public.who_global_data VALUES (26136, 35, 4052, 0, 68, 111, 41);
INSERT INTO public.who_global_data VALUES (26137, 19, 5765, 0, 115, 111, 216);
INSERT INTO public.who_global_data VALUES (26138, 600, 88434, 9, 1346, 111, 236);
INSERT INTO public.who_global_data VALUES (26139, 0, 13, 0, 0, 111, 150);
INSERT INTO public.who_global_data VALUES (26140, 1, 483, 0, 0, 111, 61);
INSERT INTO public.who_global_data VALUES (26141, 0, 32, 0, 2, 111, 7);
INSERT INTO public.who_global_data VALUES (26142, 160, 13293, 0, 351, 111, 169);
INSERT INTO public.who_global_data VALUES (26143, 32427, 838145, 89, 33119, 111, 28);
INSERT INTO public.who_global_data VALUES (26144, 0, 10239, 0, 69, 111, 85);
INSERT INTO public.who_global_data VALUES (26145, 0, 3797, 0, 14, 111, 211);
INSERT INTO public.who_global_data VALUES (26146, 0, 8881, 0, 54, 111, 60);
INSERT INTO public.who_global_data VALUES (26147, 5, 3649, 0, 118, 111, 3);
INSERT INTO public.who_global_data VALUES (26148, 1192, 17477, 8, 136, 111, 11);
INSERT INTO public.who_global_data VALUES (26149, 5587, 361974, 10, 9777, 111, 89);
INSERT INTO public.who_global_data VALUES (26150, 0, 47173, 0, 310, 111, 24);
INSERT INTO public.who_global_data VALUES (26151, 13, 544, 0, 0, 111, 162);
INSERT INTO public.who_global_data VALUES (26152, 482, 24932, 10, 500, 111, 100);
INSERT INTO public.who_global_data VALUES (26153, 0, 16, 0, 0, 111, 47);
INSERT INTO public.who_global_data VALUES (26154, 2, 27, 0, 0, 111, 29);
INSERT INTO public.who_global_data VALUES (26155, 0, 7122, 0, 111, 111, 40);
INSERT INTO public.who_global_data VALUES (26156, 79, 3606, 3, 66, 111, 222);
INSERT INTO public.who_global_data VALUES (26157, 597, 101028, 37, 3515, 111, 132);
INSERT INTO public.who_global_data VALUES (26158, 0, 258, 0, 13, 111, 130);
INSERT INTO public.who_global_data VALUES (26159, 116, 11478, 0, 70, 111, 234);
INSERT INTO public.who_global_data VALUES (26160, 0, 2389, 0, 41, 111, 23);
INSERT INTO public.who_global_data VALUES (26161, 52, 3672, 0, 107, 111, 192);
INSERT INTO public.who_global_data VALUES (26162, 0, 8925, 0, 231, 111, 69);
INSERT INTO public.who_global_data VALUES (26163, 0, 26, 0, 0, 111, 187);
INSERT INTO public.who_global_data VALUES (26164, 602, 86691, 4, 2556, 111, 230);
INSERT INTO public.who_global_data VALUES (26165, 1474, 46290, 33, 1142, 111, 77);
INSERT INTO public.who_global_data VALUES (26166, 69, 3998, 0, 11, 111, 9);
INSERT INTO public.who_global_data VALUES (26167, 61871, 7494551, 1033, 114031, 111, 74);
INSERT INTO public.who_global_data VALUES (26168, 4301, 357762, 84, 12431, 111, 224);
INSERT INTO public.who_global_data VALUES (26169, 4103, 526490, 253, 30123, 111, 199);
INSERT INTO public.who_global_data VALUES (26170, 3221, 423524, 56, 10198, 111, 190);
INSERT INTO public.who_global_data VALUES (26171, 1251, 48678, 8, 1849, 111, 12);
INSERT INTO public.who_global_data VALUES (26172, 0, 348, 0, 24, 111, 104);
INSERT INTO public.who_global_data VALUES (26173, 1500, 302364, 36, 2186, 111, 153);
INSERT INTO public.who_global_data VALUES (26174, 10925, 402536, 47, 36474, 111, 91);
INSERT INTO public.who_global_data VALUES (26175, 63, 8195, 6, 168, 111, 215);
INSERT INTO public.who_global_data VALUES (26176, 593, 92656, 9, 1670, 111, 84);
INSERT INTO public.who_global_data VALUES (26177, 1, 491, 0, 32, 111, 231);
INSERT INTO public.who_global_data VALUES (26178, 1505, 36121, 20, 330, 111, 196);
INSERT INTO public.who_global_data VALUES (26179, 153, 145473, 42, 2178, 111, 105);
INSERT INTO public.who_global_data VALUES (26180, 616, 44196, 12, 825, 111, 122);
INSERT INTO public.who_global_data VALUES (26181, 0, 0, 0, 0, 111, 159);
INSERT INTO public.who_global_data VALUES (26182, 148, 16711, 0, 642, 111, 75);
INSERT INTO public.who_global_data VALUES (26183, 739, 115483, 4, 694, 111, 27);
INSERT INTO public.who_global_data VALUES (26184, 554, 52044, 3, 1111, 111, 54);
INSERT INTO public.who_global_data VALUES (26185, 0, 23, 0, 0, 111, 226);
INSERT INTO public.who_global_data VALUES (26186, 188, 3392, 0, 42, 111, 79);
INSERT INTO public.who_global_data VALUES (26187, 1068, 60947, 8, 517, 111, 56);
INSERT INTO public.who_global_data VALUES (26188, 0, 1833, 0, 42, 111, 117);
INSERT INTO public.who_global_data VALUES (26189, 0, 1377, 0, 82, 111, 152);
INSERT INTO public.who_global_data VALUES (26190, 945, 48790, 26, 725, 111, 16);
INSERT INTO public.who_global_data VALUES (26191, 6, 226, 0, 1, 111, 10);
INSERT INTO public.who_global_data VALUES (26192, 253, 7514, 2, 100, 111, 201);
INSERT INTO public.who_global_data VALUES (26193, 0, 10471, 0, 133, 111, 174);
INSERT INTO public.who_global_data VALUES (26194, 0, 16814, 0, 238, 111, 119);
INSERT INTO public.who_global_data VALUES (26195, 10, 5852, 0, 181, 111, 168);
INSERT INTO public.who_global_data VALUES (26196, 869, 19627, 4, 180, 111, 99);
INSERT INTO public.who_global_data VALUES (26197, 24, 11178, 1, 36, 111, 171);
INSERT INTO public.who_global_data VALUES (26198, 11, 3379, 0, 132, 111, 87);
INSERT INTO public.who_global_data VALUES (26199, 142, 4620, 0, 45, 111, 123);
INSERT INTO public.who_global_data VALUES (26200, 0, 0, 0, 0, 111, 151);
INSERT INTO public.who_global_data VALUES (26201, 0, 2266, 0, 25, 111, 213);
INSERT INTO public.who_global_data VALUES (26202, 0, 7603, 0, 163, 111, 118);
INSERT INTO public.who_global_data VALUES (26203, 0, 407, 0, 10, 111, 134);
INSERT INTO public.who_global_data VALUES (26204, 0, 4030, 0, 43, 111, 65);
INSERT INTO public.who_global_data VALUES (26205, 6751, 841661, 419, 85704, 111, 102);
INSERT INTO public.who_global_data VALUES (26206, 0, 0, 0, 0, 111, 223);
INSERT INTO public.who_global_data VALUES (26207, 5, 263, 0, 2, 111, 4);
INSERT INTO public.who_global_data VALUES (26208, 0, 320, 0, 0, 111, 146);
INSERT INTO public.who_global_data VALUES (26209, 139, 15730, 5, 236, 111, 31);
INSERT INTO public.who_global_data VALUES (26210, 0, 13, 0, 1, 111, 127);
INSERT INTO public.who_global_data VALUES (26211, 3763, 170911, 60, 2878, 111, 22);
INSERT INTO public.who_global_data VALUES (26212, 95, 10707, 1, 74, 111, 115);
INSERT INTO public.who_global_data VALUES (26213, 1387, 34875, 39, 838, 111, 106);
INSERT INTO public.who_global_data VALUES (26214, 48, 12263, 0, 131, 111, 90);
INSERT INTO public.who_global_data VALUES (26215, 0, 0, 0, 0, 111, 70);
INSERT INTO public.who_global_data VALUES (26216, 3167, 129304, 12, 727, 111, 46);
INSERT INTO public.who_global_data VALUES (26217, 8108, 219471, 28, 6733, 111, 139);
INSERT INTO public.who_global_data VALUES (26218, 0, 27, 0, 0, 111, 42);
INSERT INTO public.who_global_data VALUES (26219, 3, 1530, 0, 25, 111, 80);
INSERT INTO public.who_global_data VALUES (26220, 0, 4297, 0, 154, 111, 203);
INSERT INTO public.who_global_data VALUES (26221, 0, 1209, 0, 69, 111, 136);
INSERT INTO public.who_global_data VALUES (26222, 113, 61307, 4, 1123, 111, 63);
INSERT INTO public.who_global_data VALUES (26223, 0, 0, 0, 0, 111, 17);
INSERT INTO public.who_global_data VALUES (26224, 6, 86, 0, 2, 111, 172);
INSERT INTO public.who_global_data VALUES (26225, 594, 23201, 3, 824, 111, 109);
INSERT INTO public.who_global_data VALUES (26226, 0, 16136, 0, 278, 111, 200);
INSERT INTO public.who_global_data VALUES (26227, 312, 58150, 0, 472, 111, 93);
INSERT INTO public.who_global_data VALUES (26228, 0, 108296, 0, 1071, 111, 5);
INSERT INTO public.who_global_data VALUES (26229, 0, 741, 0, 13, 111, 214);
INSERT INTO public.who_global_data VALUES (26230, 567, 323019, 16, 6654, 111, 204);
INSERT INTO public.who_global_data VALUES (26231, 0, 0, 0, 0, 111, 198);
INSERT INTO public.who_global_data VALUES (26232, 615, 123498, 17, 2546, 111, 173);
INSERT INTO public.who_global_data VALUES (26233, 3, 581, 0, 7, 111, 229);
INSERT INTO public.who_global_data VALUES (26234, 886, 53482, 16, 1166, 111, 76);
INSERT INTO public.who_global_data VALUES (26235, 2677, 862417, 71, 33648, 111, 138);
INSERT INTO public.who_global_data VALUES (26236, 2588, 354338, 72, 6603, 111, 98);
INSERT INTO public.who_global_data VALUES (26237, 0, 0, 0, 0, 111, 103);
INSERT INTO public.who_global_data VALUES (26238, 9622, 167230, 84, 3524, 111, 225);
INSERT INTO public.who_global_data VALUES (26239, 2153, 98055, 13, 2162, 111, 131);
INSERT INTO public.who_global_data VALUES (26240, 238, 56650, 3, 761, 111, 235);
INSERT INTO public.who_global_data VALUES (26241, 235, 129227, 1, 223, 111, 137);
INSERT INTO public.who_global_data VALUES (26242, 91, 25199, 1, 444, 111, 81);
INSERT INTO public.who_global_data VALUES (26243, 792, 66652, 20, 1569, 111, 182);
INSERT INTO public.who_global_data VALUES (26244, 0, 4776, 0, 17, 111, 145);
INSERT INTO public.who_global_data VALUES (26245, 3952, 176468, 63, 5812, 111, 26);
INSERT INTO public.who_global_data VALUES (26246, 15099, 1399334, 185, 24187, 111, 170);
INSERT INTO public.who_global_data VALUES (26247, 6, 4971, 0, 34, 111, 191);
INSERT INTO public.who_global_data VALUES (26248, 0, 5, 0, 0, 111, 221);
INSERT INTO public.who_global_data VALUES (26249, 0, 72, 0, 0, 111, 64);
INSERT INTO public.who_global_data VALUES (26250, 0, 0, 0, 0, 111, 116);
INSERT INTO public.who_global_data VALUES (26251, 0, 19, 0, 0, 111, 128);
INSERT INTO public.who_global_data VALUES (26252, 1, 33, 0, 0, 111, 6);
INSERT INTO public.who_global_data VALUES (26253, 0, 531, 0, 8, 111, 227);
INSERT INTO public.who_global_data VALUES (26254, 0, 12, 0, 0, 111, 68);
INSERT INTO public.who_global_data VALUES (26255, 2, 67, 0, 0, 111, 184);
INSERT INTO public.who_global_data VALUES (26256, 0, 0, 0, 0, 111, 82);
INSERT INTO public.who_global_data VALUES (26257, 0, 784, 0, 42, 111, 149);
INSERT INTO public.who_global_data VALUES (26258, 0, 932, 0, 15, 111, 197);
INSERT INTO public.who_global_data VALUES (26259, 359, 341854, 21, 5165, 111, 78);
INSERT INTO public.who_global_data VALUES (26260, 0, 15368, 0, 317, 111, 233);
INSERT INTO public.who_global_data VALUES (26261, 227, 35946, 2, 774, 111, 133);
INSERT INTO public.who_global_data VALUES (26262, 0, 148, 0, 0, 111, 35);
INSERT INTO public.who_global_data VALUES (26263, 2, 2327, 0, 73, 111, 114);
INSERT INTO public.who_global_data VALUES (26264, 3, 57904, 0, 28, 111, 237);
INSERT INTO public.who_global_data VALUES (26265, 0, 14, 0, 0, 111, 55);
INSERT INTO public.who_global_data VALUES (26266, 0, 737, 0, 22, 111, 176);
INSERT INTO public.who_global_data VALUES (26267, 1968, 28268, 11, 82, 111, 202);
INSERT INTO public.who_global_data VALUES (26268, 727, 13149, 6, 208, 111, 155);
INSERT INTO public.who_global_data VALUES (26269, 0, 3, 0, 0, 111, 32);
INSERT INTO public.who_global_data VALUES (26270, 0, 3864, 0, 99, 111, 220);
INSERT INTO public.who_global_data VALUES (26271, 1928, 702131, 38, 18408, 111, 30);
INSERT INTO public.who_global_data VALUES (26272, 25, 2842, 0, 55, 111, 147);
INSERT INTO public.who_global_data VALUES (26273, 18774, 1012175, 146, 36177, 111, 208);
INSERT INTO public.who_global_data VALUES (26274, 121, 5475, 0, 13, 111, 45);
INSERT INTO public.who_global_data VALUES (26275, 11, 13711, 0, 836, 111, 110);
INSERT INTO public.who_global_data VALUES (26276, 19, 5113, 0, 109, 111, 88);
INSERT INTO public.who_global_data VALUES (26277, 1179, 104680, 2, 5926, 111, 51);
INSERT INTO public.who_global_data VALUES (26278, 2377, 82587, 7, 1881, 111, 209);
INSERT INTO public.who_global_data VALUES (26279, 46, 5033, 4, 245, 111, 205);
INSERT INTO public.who_global_data VALUES (26280, 41, 10455, 0, 80, 111, 18);
INSERT INTO public.who_global_data VALUES (26281, 7, 3686, 0, 59, 111, 72);
INSERT INTO public.who_global_data VALUES (26282, 16171, 705432, 150, 43579, 111, 44);
INSERT INTO public.who_global_data VALUES (26283, 0, 29, 0, 0, 111, 15);
INSERT INTO public.who_global_data VALUES (26284, 22, 2049, 0, 51, 111, 25);
INSERT INTO public.who_global_data VALUES (26285, 0, 0, 0, 0, 111, 179);
INSERT INTO public.who_global_data VALUES (26286, 0, 0, 0, 0, 111, 34);
INSERT INTO public.who_global_data VALUES (26287, 47, 5241, 2, 95, 111, 207);
INSERT INTO public.who_global_data VALUES (26288, 0, 40542, 0, 626, 111, 166);
INSERT INTO public.who_global_data VALUES (26289, 8453, 897538, 71, 9224, 111, 126);
INSERT INTO public.who_global_data VALUES (26290, 0, 0, 0, 0, 111, 97);
INSERT INTO public.who_global_data VALUES (26291, 1, 697, 0, 6, 111, 36);
INSERT INTO public.who_global_data VALUES (26292, 0, 0, 0, 0, 111, 125);
INSERT INTO public.who_global_data VALUES (26293, 121, 10455, 0, 96, 111, 124);
INSERT INTO public.who_global_data VALUES (26294, 5231, 298872, 90, 5607, 111, 185);
INSERT INTO public.who_global_data VALUES (26295, 1538, 114387, 4, 459, 111, 194);
INSERT INTO public.who_global_data VALUES (26296, 0, 509, 0, 21, 111, 144);
INSERT INTO public.who_global_data VALUES (26297, 69834, 7966729, 998, 217071, 111, 19);
INSERT INTO public.who_global_data VALUES (26298, 0, 1329, 0, 21, 111, 217);
INSERT INTO public.who_global_data VALUES (26299, 33, 2450, 0, 51, 111, 148);
INSERT INTO public.who_global_data VALUES (26300, 315, 63124, 3, 525, 111, 86);
INSERT INTO public.who_global_data VALUES (26301, 0, 0, 0, 0, 111, 13);
INSERT INTO public.who_global_data VALUES (26302, 289, 85758, 5, 725, 111, 157);
INSERT INTO public.who_global_data VALUES (26303, 2, 1126, 0, 35, 111, 8);
INSERT INTO public.who_global_data VALUES (26304, 0, 0, 0, 0, 111, 73);
INSERT INTO public.who_global_data VALUES (26305, 0, 2059, 0, 597, 111, 101);
INSERT INTO public.who_global_data VALUES (26306, 130, 15789, 0, 346, 111, 165);
INSERT INTO public.who_global_data VALUES (26307, 11, 8110, 0, 231, 111, 14);
INSERT INTO public.who_global_data VALUES (26308, 68, 40227, 3, 1492, 112, 193);
INSERT INTO public.who_global_data VALUES (26309, 289, 16501, 4, 443, 112, 113);
INSERT INTO public.who_global_data VALUES (26310, 221, 53998, 5, 1841, 112, 143);
INSERT INTO public.who_global_data VALUES (26311, 0, 0, 0, 0, 112, 219);
INSERT INTO public.who_global_data VALUES (26312, 187, 3377, 0, 59, 112, 186);
INSERT INTO public.who_global_data VALUES (26313, 126, 7222, 6, 234, 112, 52);
INSERT INTO public.who_global_data VALUES (26314, 0, 3, 0, 0, 112, 180);
INSERT INTO public.who_global_data VALUES (26315, 0, 112, 0, 3, 112, 167);
INSERT INTO public.who_global_data VALUES (26316, 17096, 949063, 421, 25342, 112, 154);
INSERT INTO public.who_global_data VALUES (26317, 1540, 62313, 11, 1062, 112, 94);
INSERT INTO public.who_global_data VALUES (26318, 30, 4285, 0, 32, 112, 66);
INSERT INTO public.who_global_data VALUES (26319, 9, 27371, 0, 904, 112, 58);
INSERT INTO public.who_global_data VALUES (26320, 1691, 62455, 7, 901, 112, 163);
INSERT INTO public.who_global_data VALUES (26321, 509, 43789, 2, 621, 112, 37);
INSERT INTO public.who_global_data VALUES (26322, 132, 5517, 2, 114, 112, 142);
INSERT INTO public.who_global_data VALUES (26323, 371, 77325, 3, 292, 112, 83);
INSERT INTO public.who_global_data VALUES (26324, 1527, 386086, 15, 5623, 112, 228);
INSERT INTO public.who_global_data VALUES (26325, 3, 218, 0, 7, 112, 188);
INSERT INTO public.who_global_data VALUES (26326, 658, 86392, 5, 921, 112, 62);
INSERT INTO public.who_global_data VALUES (26327, 13477, 234317, 36, 10391, 112, 160);
INSERT INTO public.who_global_data VALUES (26328, 63, 2682, 1, 41, 112, 50);
INSERT INTO public.who_global_data VALUES (26329, 0, 2496, 0, 41, 112, 33);
INSERT INTO public.who_global_data VALUES (26330, 0, 185, 0, 9, 112, 183);
INSERT INTO public.who_global_data VALUES (26331, 0, 316, 0, 0, 112, 92);
INSERT INTO public.who_global_data VALUES (26332, 178, 139319, 30, 8407, 112, 158);
INSERT INTO public.who_global_data VALUES (26333, 0, 131, 0, 2, 112, 67);
INSERT INTO public.who_global_data VALUES (26334, 618, 32848, 8, 978, 112, 57);
INSERT INTO public.who_global_data VALUES (26335, 0, 5242, 0, 20, 112, 38);
INSERT INTO public.who_global_data VALUES (26336, 28523, 5169386, 713, 152460, 112, 141);
INSERT INTO public.who_global_data VALUES (26337, 0, 72, 0, 1, 112, 178);
INSERT INTO public.who_global_data VALUES (26338, 0, 147, 0, 3, 112, 108);
INSERT INTO public.who_global_data VALUES (26339, 998, 28505, 14, 958, 112, 39);
INSERT INTO public.who_global_data VALUES (26340, 8, 2343, 0, 65, 112, 2);
INSERT INTO public.who_global_data VALUES (26341, 5, 536, 0, 1, 112, 195);
INSERT INTO public.who_global_data VALUES (26342, 82, 7526, 3, 82, 112, 107);
INSERT INTO public.who_global_data VALUES (26343, 0, 283, 0, 0, 112, 161);
INSERT INTO public.who_global_data VALUES (26344, 0, 21441, 0, 423, 112, 212);
INSERT INTO public.who_global_data VALUES (26345, 2345, 191732, 35, 9699, 112, 181);
INSERT INTO public.who_global_data VALUES (26346, 0, 225, 0, 1, 112, 53);
INSERT INTO public.who_global_data VALUES (26347, 0, 4855, 0, 62, 112, 164);
INSERT INTO public.who_global_data VALUES (26348, 11, 1361, 1, 93, 112, 140);
INSERT INTO public.who_global_data VALUES (26349, 1694, 488190, 95, 13529, 112, 20);
INSERT INTO public.who_global_data VALUES (26350, 24, 91460, 0, 4746, 112, 112);
INSERT INTO public.who_global_data VALUES (26351, 6823, 936982, 151, 28457, 112, 111);
INSERT INTO public.who_global_data VALUES (26352, 0, 496, 0, 7, 112, 71);
INSERT INTO public.who_global_data VALUES (26353, 0, 5156, 0, 92, 112, 218);
INSERT INTO public.who_global_data VALUES (26354, 0, 0, 0, 0, 112, 43);
INSERT INTO public.who_global_data VALUES (26355, 1372, 93152, 25, 1159, 112, 49);
INSERT INTO public.who_global_data VALUES (26356, 0, 20257, 0, 121, 112, 1);
INSERT INTO public.who_global_data VALUES (26357, 1131, 23665, 1, 345, 112, 48);
INSERT INTO public.who_global_data VALUES (26358, 56, 6118, 1, 124, 112, 232);
INSERT INTO public.who_global_data VALUES (26359, 28, 673, 0, 1, 112, 175);
INSERT INTO public.who_global_data VALUES (26360, 198, 2379, 0, 25, 112, 21);
INSERT INTO public.who_global_data VALUES (26361, 11102, 160112, 53, 1283, 112, 156);
INSERT INTO public.who_global_data VALUES (26362, 0, 0, 0, 0, 112, 95);
INSERT INTO public.who_global_data VALUES (26363, 0, 10934, 0, 281, 112, 177);
INSERT INTO public.who_global_data VALUES (26364, 418, 34441, 0, 677, 112, 210);
INSERT INTO public.who_global_data VALUES (26365, 6, 5449, 0, 61, 112, 120);
INSERT INTO public.who_global_data VALUES (26366, 0, 33, 0, 0, 112, 135);
INSERT INTO public.who_global_data VALUES (26367, 384, 120450, 3, 2192, 112, 206);
INSERT INTO public.who_global_data VALUES (26368, 1299, 151659, 51, 12357, 112, 189);
INSERT INTO public.who_global_data VALUES (26369, 126, 105159, 11, 6099, 112, 129);
INSERT INTO public.who_global_data VALUES (26370, 204, 31265, 4, 912, 112, 121);
INSERT INTO public.who_global_data VALUES (26371, 0, 5068, 0, 83, 112, 59);
INSERT INTO public.who_global_data VALUES (26372, 0, 422, 0, 0, 112, 96);
INSERT INTO public.who_global_data VALUES (26373, 37, 4017, 0, 68, 112, 41);
INSERT INTO public.who_global_data VALUES (26374, 13, 5746, 0, 115, 112, 216);
INSERT INTO public.who_global_data VALUES (26375, 665, 87834, 12, 1337, 112, 236);
INSERT INTO public.who_global_data VALUES (26376, 0, 13, 0, 0, 112, 150);
INSERT INTO public.who_global_data VALUES (26377, 2, 482, 0, 0, 112, 61);
INSERT INTO public.who_global_data VALUES (26378, 0, 32, 0, 2, 112, 7);
INSERT INTO public.who_global_data VALUES (26379, 139, 13133, 1, 351, 112, 169);
INSERT INTO public.who_global_data VALUES (26380, 24724, 805718, 162, 33030, 112, 28);
INSERT INTO public.who_global_data VALUES (26381, 6, 10239, 0, 69, 112, 85);
INSERT INTO public.who_global_data VALUES (26382, 224, 3797, 1, 14, 112, 211);
INSERT INTO public.who_global_data VALUES (26383, 12, 8881, 0, 54, 112, 60);
INSERT INTO public.who_global_data VALUES (26384, 0, 3644, 0, 118, 112, 3);
INSERT INTO public.who_global_data VALUES (26385, 958, 16285, 4, 128, 112, 11);
INSERT INTO public.who_global_data VALUES (26386, 7830, 356387, 33, 9767, 112, 89);
INSERT INTO public.who_global_data VALUES (26387, 22, 47173, 0, 310, 112, 24);
INSERT INTO public.who_global_data VALUES (26388, 15, 531, 0, 0, 112, 162);
INSERT INTO public.who_global_data VALUES (26389, 503, 24450, 8, 490, 112, 100);
INSERT INTO public.who_global_data VALUES (26390, 0, 16, 0, 0, 112, 47);
INSERT INTO public.who_global_data VALUES (26391, 0, 25, 0, 0, 112, 29);
INSERT INTO public.who_global_data VALUES (26392, 214, 7122, 15, 111, 112, 40);
INSERT INTO public.who_global_data VALUES (26393, 100, 3527, 0, 63, 112, 222);
INSERT INTO public.who_global_data VALUES (26394, 666, 100431, 25, 3478, 112, 132);
INSERT INTO public.who_global_data VALUES (26395, 0, 258, 0, 13, 112, 130);
INSERT INTO public.who_global_data VALUES (26396, 107, 11362, 0, 70, 112, 234);
INSERT INTO public.who_global_data VALUES (26397, 0, 2389, 0, 41, 112, 23);
INSERT INTO public.who_global_data VALUES (26398, 31, 3620, 1, 107, 112, 192);
INSERT INTO public.who_global_data VALUES (26399, 17, 8925, 0, 231, 112, 69);
INSERT INTO public.who_global_data VALUES (26400, 0, 26, 0, 0, 112, 187);
INSERT INTO public.who_global_data VALUES (26401, 631, 86089, 19, 2552, 112, 230);
INSERT INTO public.who_global_data VALUES (26402, 1791, 44816, 24, 1109, 112, 77);
INSERT INTO public.who_global_data VALUES (26403, 92, 3929, 1, 11, 112, 9);
INSERT INTO public.who_global_data VALUES (26404, 62212, 7432680, 837, 112998, 112, 74);
INSERT INTO public.who_global_data VALUES (26405, 4301, 353461, 79, 12347, 112, 224);
INSERT INTO public.who_global_data VALUES (26406, 4552, 522387, 265, 29870, 112, 199);
INSERT INTO public.who_global_data VALUES (26407, 3501, 420303, 56, 10142, 112, 190);
INSERT INTO public.who_global_data VALUES (26408, 998, 47427, 3, 1841, 112, 12);
INSERT INTO public.who_global_data VALUES (26409, 0, 348, 0, 24, 112, 104);
INSERT INTO public.who_global_data VALUES (26410, 1612, 300864, 31, 2150, 112, 153);
INSERT INTO public.who_global_data VALUES (26411, 10009, 391611, 55, 36427, 112, 91);
INSERT INTO public.who_global_data VALUES (26412, 65, 8132, 2, 162, 112, 215);
INSERT INTO public.who_global_data VALUES (26413, 632, 92063, 11, 1661, 112, 84);
INSERT INTO public.who_global_data VALUES (26414, 3, 490, 0, 32, 112, 231);
INSERT INTO public.who_global_data VALUES (26415, 1539, 34616, 28, 310, 112, 196);
INSERT INTO public.who_global_data VALUES (26416, 301, 145320, 0, 2136, 112, 105);
INSERT INTO public.who_global_data VALUES (26417, 437, 43580, 8, 813, 112, 122);
INSERT INTO public.who_global_data VALUES (26418, 0, 0, 0, 0, 112, 159);
INSERT INTO public.who_global_data VALUES (26419, 104, 16563, 2, 642, 112, 75);
INSERT INTO public.who_global_data VALUES (26420, 729, 114744, 6, 690, 112, 27);
INSERT INTO public.who_global_data VALUES (26421, 470, 51490, 5, 1108, 112, 54);
INSERT INTO public.who_global_data VALUES (26422, 0, 23, 0, 0, 112, 226);
INSERT INTO public.who_global_data VALUES (26423, 148, 3204, 1, 42, 112, 79);
INSERT INTO public.who_global_data VALUES (26424, 1366, 59879, 8, 509, 112, 56);
INSERT INTO public.who_global_data VALUES (26425, 0, 1833, 0, 42, 112, 117);
INSERT INTO public.who_global_data VALUES (26426, 5, 1377, 0, 82, 112, 152);
INSERT INTO public.who_global_data VALUES (26427, 0, 47845, 0, 699, 112, 16);
INSERT INTO public.who_global_data VALUES (26428, 18, 220, 0, 1, 112, 10);
INSERT INTO public.who_global_data VALUES (26429, 228, 7261, 1, 98, 112, 201);
INSERT INTO public.who_global_data VALUES (26430, 227, 10471, 0, 133, 112, 174);
INSERT INTO public.who_global_data VALUES (26431, 60, 16814, 1, 238, 112, 119);
INSERT INTO public.who_global_data VALUES (26432, 6, 5842, 0, 181, 112, 168);
INSERT INTO public.who_global_data VALUES (26433, 629, 18758, 6, 176, 112, 99);
INSERT INTO public.who_global_data VALUES (26434, 41, 11154, 0, 35, 112, 171);
INSERT INTO public.who_global_data VALUES (26435, 0, 3368, 0, 132, 112, 87);
INSERT INTO public.who_global_data VALUES (26436, 204, 4478, 0, 45, 112, 123);
INSERT INTO public.who_global_data VALUES (26437, 0, 0, 0, 0, 112, 151);
INSERT INTO public.who_global_data VALUES (26438, 9, 2266, 1, 25, 112, 213);
INSERT INTO public.who_global_data VALUES (26439, 18, 7603, 0, 163, 112, 118);
INSERT INTO public.who_global_data VALUES (26440, 3, 407, 0, 10, 112, 134);
INSERT INTO public.who_global_data VALUES (26441, 0, 4030, 0, 43, 112, 65);
INSERT INTO public.who_global_data VALUES (26442, 5514, 834910, 387, 85285, 112, 102);
INSERT INTO public.who_global_data VALUES (26443, 0, 0, 0, 0, 112, 223);
INSERT INTO public.who_global_data VALUES (26444, 2, 258, 0, 2, 112, 4);
INSERT INTO public.who_global_data VALUES (26445, 0, 320, 0, 0, 112, 146);
INSERT INTO public.who_global_data VALUES (26446, 84, 15591, 3, 231, 112, 31);
INSERT INTO public.who_global_data VALUES (26447, 0, 13, 0, 1, 112, 127);
INSERT INTO public.who_global_data VALUES (26448, 3498, 167148, 46, 2818, 112, 22);
INSERT INTO public.who_global_data VALUES (26449, 75, 10612, 0, 73, 112, 115);
INSERT INTO public.who_global_data VALUES (26450, 1137, 33488, 34, 799, 112, 106);
INSERT INTO public.who_global_data VALUES (26451, 112, 12215, 1, 131, 112, 90);
INSERT INTO public.who_global_data VALUES (26452, 0, 0, 0, 0, 112, 70);
INSERT INTO public.who_global_data VALUES (26453, 4392, 126137, 21, 715, 112, 46);
INSERT INTO public.who_global_data VALUES (26454, 7956, 211363, 18, 6705, 112, 139);
INSERT INTO public.who_global_data VALUES (26455, 0, 27, 0, 0, 112, 42);
INSERT INTO public.who_global_data VALUES (26456, 3, 1527, 0, 25, 112, 80);
INSERT INTO public.who_global_data VALUES (26457, 0, 4297, 0, 154, 112, 203);
INSERT INTO public.who_global_data VALUES (26458, 4, 1209, 0, 69, 112, 136);
INSERT INTO public.who_global_data VALUES (26459, 212, 61194, 3, 1119, 112, 63);
INSERT INTO public.who_global_data VALUES (26460, 0, 0, 0, 0, 112, 17);
INSERT INTO public.who_global_data VALUES (26461, 0, 80, 0, 2, 112, 172);
INSERT INTO public.who_global_data VALUES (26462, 437, 22607, 6, 821, 112, 109);
INSERT INTO public.who_global_data VALUES (26463, 183, 16136, 0, 278, 112, 200);
INSERT INTO public.who_global_data VALUES (26464, 397, 57838, 1, 472, 112, 93);
INSERT INTO public.who_global_data VALUES (26465, 0, 108296, 0, 1071, 112, 5);
INSERT INTO public.who_global_data VALUES (26466, 0, 741, 0, 13, 112, 214);
INSERT INTO public.who_global_data VALUES (26467, 641, 322452, 17, 6638, 112, 204);
INSERT INTO public.who_global_data VALUES (26468, 0, 0, 0, 0, 112, 198);
INSERT INTO public.who_global_data VALUES (26469, 755, 122883, 10, 2529, 112, 173);
INSERT INTO public.who_global_data VALUES (26470, 0, 578, 0, 7, 112, 229);
INSERT INTO public.who_global_data VALUES (26471, 751, 52596, 19, 1150, 112, 76);
INSERT INTO public.who_global_data VALUES (26472, 2789, 859740, 65, 33577, 112, 138);
INSERT INTO public.who_global_data VALUES (26473, 3052, 351750, 34, 6531, 112, 98);
INSERT INTO public.who_global_data VALUES (26474, 0, 0, 0, 0, 112, 103);
INSERT INTO public.who_global_data VALUES (26475, 7705, 157608, 132, 3440, 112, 225);
INSERT INTO public.who_global_data VALUES (26476, 2608, 95902, 21, 2149, 112, 131);
INSERT INTO public.who_global_data VALUES (26477, 327, 56412, 15, 758, 112, 235);
INSERT INTO public.who_global_data VALUES (26478, 189, 128992, 0, 222, 112, 137);
INSERT INTO public.who_global_data VALUES (26479, 73, 25108, 2, 443, 112, 81);
INSERT INTO public.who_global_data VALUES (26480, 784, 65860, 19, 1549, 112, 182);
INSERT INTO public.who_global_data VALUES (26481, 98, 4776, 0, 17, 112, 145);
INSERT INTO public.who_global_data VALUES (26482, 4026, 172516, 75, 5749, 112, 26);
INSERT INTO public.who_global_data VALUES (26483, 14922, 1384235, 279, 24002, 112, 170);
INSERT INTO public.who_global_data VALUES (26484, 12, 4965, 1, 34, 112, 191);
INSERT INTO public.who_global_data VALUES (26485, 0, 5, 0, 0, 112, 221);
INSERT INTO public.who_global_data VALUES (26486, 5, 72, 0, 0, 112, 64);
INSERT INTO public.who_global_data VALUES (26487, 0, 0, 0, 0, 112, 116);
INSERT INTO public.who_global_data VALUES (26488, 0, 19, 0, 0, 112, 128);
INSERT INTO public.who_global_data VALUES (26489, 1, 32, 0, 0, 112, 6);
INSERT INTO public.who_global_data VALUES (26490, 30, 531, 0, 8, 112, 227);
INSERT INTO public.who_global_data VALUES (26491, 0, 12, 0, 0, 112, 68);
INSERT INTO public.who_global_data VALUES (26492, 1, 65, 0, 0, 112, 184);
INSERT INTO public.who_global_data VALUES (26493, 0, 0, 0, 0, 112, 82);
INSERT INTO public.who_global_data VALUES (26494, 3, 784, 0, 42, 112, 149);
INSERT INTO public.who_global_data VALUES (26495, 3, 932, 0, 15, 112, 197);
INSERT INTO public.who_global_data VALUES (26496, 433, 341495, 17, 5144, 112, 78);
INSERT INTO public.who_global_data VALUES (26497, 20, 15368, 1, 317, 112, 233);
INSERT INTO public.who_global_data VALUES (26498, 265, 35719, 2, 772, 112, 133);
INSERT INTO public.who_global_data VALUES (26499, 0, 148, 0, 0, 112, 35);
INSERT INTO public.who_global_data VALUES (26500, 2, 2325, 0, 73, 112, 114);
INSERT INTO public.who_global_data VALUES (26501, 9, 57901, 0, 28, 112, 237);
INSERT INTO public.who_global_data VALUES (26502, 0, 14, 0, 0, 112, 55);
INSERT INTO public.who_global_data VALUES (26503, 8, 737, 0, 22, 112, 176);
INSERT INTO public.who_global_data VALUES (26504, 2075, 26300, 0, 71, 112, 202);
INSERT INTO public.who_global_data VALUES (26505, 898, 12422, 5, 202, 112, 155);
INSERT INTO public.who_global_data VALUES (26506, 0, 3, 0, 0, 112, 32);
INSERT INTO public.who_global_data VALUES (26507, 0, 3864, 0, 99, 112, 220);
INSERT INTO public.who_global_data VALUES (26508, 2019, 700203, 61, 18370, 112, 30);
INSERT INTO public.who_global_data VALUES (26509, 0, 2817, 0, 55, 112, 147);
INSERT INTO public.who_global_data VALUES (26510, 17979, 993401, 144, 36031, 112, 208);
INSERT INTO public.who_global_data VALUES (26511, 110, 5354, 0, 13, 112, 45);
INSERT INTO public.who_global_data VALUES (26512, 0, 13700, 0, 836, 112, 110);
INSERT INTO public.who_global_data VALUES (26513, 11, 5094, 1, 109, 112, 88);
INSERT INTO public.who_global_data VALUES (26514, 902, 103501, 3, 5924, 112, 51);
INSERT INTO public.who_global_data VALUES (26515, 3680, 80210, 9, 1874, 112, 209);
INSERT INTO public.who_global_data VALUES (26516, 56, 4987, 3, 241, 112, 205);
INSERT INTO public.who_global_data VALUES (26517, 40, 10414, 0, 80, 112, 18);
INSERT INTO public.who_global_data VALUES (26518, 10, 3679, 0, 59, 112, 72);
INSERT INTO public.who_global_data VALUES (26519, 15635, 689261, 136, 43429, 112, 44);
INSERT INTO public.who_global_data VALUES (26520, 0, 29, 0, 0, 112, 15);
INSERT INTO public.who_global_data VALUES (26521, 31, 2027, 0, 51, 112, 25);
INSERT INTO public.who_global_data VALUES (26522, 0, 0, 0, 0, 112, 179);
INSERT INTO public.who_global_data VALUES (26523, 0, 0, 0, 0, 112, 34);
INSERT INTO public.who_global_data VALUES (26524, 40, 5194, 0, 93, 112, 207);
INSERT INTO public.who_global_data VALUES (26525, 5752, 40542, 114, 626, 112, 166);
INSERT INTO public.who_global_data VALUES (26526, 8542, 889085, 73, 9153, 112, 126);
INSERT INTO public.who_global_data VALUES (26527, 0, 0, 0, 0, 112, 97);
INSERT INTO public.who_global_data VALUES (26528, 0, 696, 0, 6, 112, 36);
INSERT INTO public.who_global_data VALUES (26529, 0, 0, 0, 0, 112, 125);
INSERT INTO public.who_global_data VALUES (26530, 217, 10334, 0, 96, 112, 124);
INSERT INTO public.who_global_data VALUES (26531, 6410, 293641, 109, 5517, 112, 185);
INSERT INTO public.who_global_data VALUES (26532, 1412, 112849, 3, 455, 112, 194);
INSERT INTO public.who_global_data VALUES (26533, 0, 509, 0, 21, 112, 144);
INSERT INTO public.who_global_data VALUES (26534, 63044, 7896895, 874, 216073, 112, 19);
INSERT INTO public.who_global_data VALUES (26535, 2, 1329, 1, 21, 112, 217);
INSERT INTO public.who_global_data VALUES (26536, 29, 2417, 0, 51, 112, 148);
INSERT INTO public.who_global_data VALUES (26537, 325, 62809, 3, 522, 112, 86);
INSERT INTO public.who_global_data VALUES (26538, 0, 0, 0, 0, 112, 13);
INSERT INTO public.who_global_data VALUES (26539, 464, 85469, 6, 720, 112, 157);
INSERT INTO public.who_global_data VALUES (26540, 0, 1124, 0, 35, 112, 8);
INSERT INTO public.who_global_data VALUES (26541, 0, 0, 0, 0, 112, 73);
INSERT INTO public.who_global_data VALUES (26542, 2, 2059, 0, 597, 112, 101);
INSERT INTO public.who_global_data VALUES (26543, 0, 15659, 0, 346, 112, 165);
INSERT INTO public.who_global_data VALUES (26544, 24, 8099, 0, 231, 112, 14);
INSERT INTO public.who_global_data VALUES (26545, 47, 40159, 4, 1489, 113, 193);
INSERT INTO public.who_global_data VALUES (26546, 257, 16212, 5, 439, 113, 113);
INSERT INTO public.who_global_data VALUES (26547, 378, 53777, 18, 1836, 113, 143);
INSERT INTO public.who_global_data VALUES (26548, 0, 0, 0, 0, 113, 219);
INSERT INTO public.who_global_data VALUES (26549, 0, 3190, 0, 59, 113, 186);
INSERT INTO public.who_global_data VALUES (26550, 250, 7096, 1, 228, 113, 52);
INSERT INTO public.who_global_data VALUES (26551, 0, 3, 0, 0, 113, 180);
INSERT INTO public.who_global_data VALUES (26552, 0, 112, 0, 3, 113, 167);
INSERT INTO public.who_global_data VALUES (26553, 14932, 931967, 349, 24921, 113, 154);
INSERT INTO public.who_global_data VALUES (26554, 1465, 60773, 10, 1051, 113, 94);
INSERT INTO public.who_global_data VALUES (26555, 26, 4255, 0, 32, 113, 66);
INSERT INTO public.who_global_data VALUES (26556, 21, 27362, 0, 904, 113, 58);
INSERT INTO public.who_global_data VALUES (26557, 1396, 60764, 6, 894, 113, 163);
INSERT INTO public.who_global_data VALUES (26558, 530, 43280, 3, 619, 113, 37);
INSERT INTO public.who_global_data VALUES (26559, 194, 5385, 3, 112, 113, 142);
INSERT INTO public.who_global_data VALUES (26560, 333, 76954, 2, 289, 113, 83);
INSERT INTO public.who_global_data VALUES (26561, 1600, 384559, 15, 5608, 113, 228);
INSERT INTO public.who_global_data VALUES (26562, 5, 215, 0, 7, 113, 188);
INSERT INTO public.who_global_data VALUES (26563, 613, 85734, 5, 916, 113, 62);
INSERT INTO public.who_global_data VALUES (26564, 11818, 220840, 35, 10355, 113, 160);
INSERT INTO public.who_global_data VALUES (26565, 34, 2619, 1, 40, 113, 50);
INSERT INTO public.who_global_data VALUES (26566, 0, 2496, 0, 41, 113, 33);
INSERT INTO public.who_global_data VALUES (26567, 0, 185, 0, 9, 113, 183);
INSERT INTO public.who_global_data VALUES (26568, 0, 316, 0, 0, 113, 92);
INSERT INTO public.who_global_data VALUES (26569, 219, 139141, 26, 8377, 113, 158);
INSERT INTO public.who_global_data VALUES (26570, 0, 131, 0, 2, 113, 67);
INSERT INTO public.who_global_data VALUES (26571, 578, 32230, 15, 970, 113, 57);
INSERT INTO public.who_global_data VALUES (26572, 203, 5242, 0, 20, 113, 38);
INSERT INTO public.who_global_data VALUES (26573, 27235, 5140863, 749, 151747, 113, 141);
INSERT INTO public.who_global_data VALUES (26574, 0, 72, 0, 1, 113, 178);
INSERT INTO public.who_global_data VALUES (26575, 0, 147, 0, 3, 113, 108);
INSERT INTO public.who_global_data VALUES (26576, 914, 27507, 15, 944, 113, 39);
INSERT INTO public.who_global_data VALUES (26577, 41, 2335, 2, 65, 113, 2);
INSERT INTO public.who_global_data VALUES (26578, 2, 531, 0, 1, 113, 195);
INSERT INTO public.who_global_data VALUES (26579, 73, 7444, 0, 79, 113, 107);
INSERT INTO public.who_global_data VALUES (26580, 0, 283, 0, 0, 113, 161);
INSERT INTO public.who_global_data VALUES (26581, 0, 21441, 0, 423, 113, 212);
INSERT INTO public.who_global_data VALUES (26582, 2506, 189387, 10, 9664, 113, 181);
INSERT INTO public.who_global_data VALUES (26583, 4, 225, 0, 1, 113, 53);
INSERT INTO public.who_global_data VALUES (26584, 0, 4855, 0, 62, 113, 164);
INSERT INTO public.who_global_data VALUES (26585, 21, 1350, 0, 92, 113, 140);
INSERT INTO public.who_global_data VALUES (26586, 1124, 486496, 19, 13434, 113, 20);
INSERT INTO public.who_global_data VALUES (26587, 37, 91436, 0, 4746, 113, 112);
INSERT INTO public.who_global_data VALUES (26588, 6061, 930159, 165, 28306, 113, 111);
INSERT INTO public.who_global_data VALUES (26589, 0, 496, 0, 7, 113, 71);
INSERT INTO public.who_global_data VALUES (26590, 0, 5156, 0, 92, 113, 218);
INSERT INTO public.who_global_data VALUES (26591, 0, 0, 0, 0, 113, 43);
INSERT INTO public.who_global_data VALUES (26592, 1542, 91780, 10, 1134, 113, 49);
INSERT INTO public.who_global_data VALUES (26593, 40, 20257, 0, 121, 113, 1);
INSERT INTO public.who_global_data VALUES (26594, 793, 22534, 10, 344, 113, 48);
INSERT INTO public.who_global_data VALUES (26595, 27, 6062, 0, 123, 113, 232);
INSERT INTO public.who_global_data VALUES (26596, 26, 645, 0, 1, 113, 175);
INSERT INTO public.who_global_data VALUES (26597, 51, 2181, 0, 25, 113, 21);
INSERT INTO public.who_global_data VALUES (26598, 9720, 149010, 58, 1230, 113, 156);
INSERT INTO public.who_global_data VALUES (26599, 0, 0, 0, 0, 113, 95);
INSERT INTO public.who_global_data VALUES (26600, 0, 10934, 0, 281, 113, 177);
INSERT INTO public.who_global_data VALUES (26601, 430, 34023, 2, 677, 113, 210);
INSERT INTO public.who_global_data VALUES (26602, 3, 5443, 0, 61, 113, 120);
INSERT INTO public.who_global_data VALUES (26603, 1, 33, 0, 0, 113, 135);
INSERT INTO public.who_global_data VALUES (26604, 404, 120066, 3, 2189, 113, 206);
INSERT INTO public.who_global_data VALUES (26605, 1277, 150360, 42, 12306, 113, 189);
INSERT INTO public.who_global_data VALUES (26606, 118, 105033, 11, 6088, 113, 129);
INSERT INTO public.who_global_data VALUES (26607, 295, 31061, 4, 908, 113, 121);
INSERT INTO public.who_global_data VALUES (26608, 0, 5068, 0, 83, 113, 59);
INSERT INTO public.who_global_data VALUES (26609, 8, 422, 0, 0, 113, 96);
INSERT INTO public.who_global_data VALUES (26610, 33, 3980, 0, 68, 113, 41);
INSERT INTO public.who_global_data VALUES (26611, 18, 5733, 1, 115, 113, 216);
INSERT INTO public.who_global_data VALUES (26612, 739, 87169, 13, 1325, 113, 236);
INSERT INTO public.who_global_data VALUES (26613, 0, 13, 0, 0, 113, 150);
INSERT INTO public.who_global_data VALUES (26614, 2, 480, 0, 0, 113, 61);
INSERT INTO public.who_global_data VALUES (26615, 0, 32, 0, 2, 113, 7);
INSERT INTO public.who_global_data VALUES (26616, 291, 12994, 0, 350, 113, 169);
INSERT INTO public.who_global_data VALUES (26617, 30553, 780994, 88, 32868, 113, 28);
INSERT INTO public.who_global_data VALUES (26618, 31, 10233, 0, 69, 113, 85);
INSERT INTO public.who_global_data VALUES (26619, 0, 3573, 0, 13, 113, 211);
INSERT INTO public.who_global_data VALUES (26620, 0, 8869, 0, 54, 113, 60);
INSERT INTO public.who_global_data VALUES (26621, 0, 3644, 0, 118, 113, 3);
INSERT INTO public.who_global_data VALUES (26622, 887, 15327, 11, 124, 113, 11);
INSERT INTO public.who_global_data VALUES (26623, 7334, 348557, 24, 9734, 113, 89);
INSERT INTO public.who_global_data VALUES (26624, 25, 47151, 0, 310, 113, 24);
INSERT INTO public.who_global_data VALUES (26625, 17, 516, 0, 0, 113, 162);
INSERT INTO public.who_global_data VALUES (26626, 452, 23947, 13, 482, 113, 100);
INSERT INTO public.who_global_data VALUES (26627, 0, 16, 0, 0, 113, 47);
INSERT INTO public.who_global_data VALUES (26628, 0, 25, 0, 0, 113, 29);
INSERT INTO public.who_global_data VALUES (26629, 0, 6908, 0, 96, 113, 40);
INSERT INTO public.who_global_data VALUES (26630, 86, 3427, 2, 63, 113, 222);
INSERT INTO public.who_global_data VALUES (26631, 671, 99765, 23, 3453, 113, 132);
INSERT INTO public.who_global_data VALUES (26632, 0, 258, 0, 13, 113, 130);
INSERT INTO public.who_global_data VALUES (26633, 67, 11255, 0, 70, 113, 234);
INSERT INTO public.who_global_data VALUES (26634, 4, 2389, 1, 41, 113, 23);
INSERT INTO public.who_global_data VALUES (26635, 24, 3589, 0, 106, 113, 192);
INSERT INTO public.who_global_data VALUES (26636, 0, 8908, 0, 231, 113, 69);
INSERT INTO public.who_global_data VALUES (26637, 7, 26, 0, 0, 113, 187);
INSERT INTO public.who_global_data VALUES (26638, 606, 85458, 5, 2533, 113, 230);
INSERT INTO public.who_global_data VALUES (26639, 1293, 43025, 33, 1085, 113, 77);
INSERT INTO public.who_global_data VALUES (26640, 80, 3837, 0, 10, 113, 9);
INSERT INTO public.who_global_data VALUES (26641, 63371, 7370468, 895, 112161, 113, 74);
INSERT INTO public.who_global_data VALUES (26642, 4411, 349160, 112, 12268, 113, 224);
INSERT INTO public.who_global_data VALUES (26643, 4616, 517835, 256, 29605, 113, 199);
INSERT INTO public.who_global_data VALUES (26644, 3587, 416802, 65, 10086, 113, 190);
INSERT INTO public.who_global_data VALUES (26645, 1186, 46429, 3, 1838, 113, 12);
INSERT INTO public.who_global_data VALUES (26646, 2, 348, 0, 24, 113, 104);
INSERT INTO public.who_global_data VALUES (26647, 2118, 299252, 35, 2119, 113, 153);
INSERT INTO public.who_global_data VALUES (26648, 8803, 381602, 83, 36372, 113, 91);
INSERT INTO public.who_global_data VALUES (26649, 78, 8067, 9, 160, 113, 215);
INSERT INTO public.who_global_data VALUES (26650, 721, 91431, 4, 1650, 113, 84);
INSERT INTO public.who_global_data VALUES (26651, 3, 487, 0, 32, 113, 231);
INSERT INTO public.who_global_data VALUES (26652, 2459, 33077, 25, 282, 113, 196);
INSERT INTO public.who_global_data VALUES (26653, 258, 145019, 0, 2136, 113, 105);
INSERT INTO public.who_global_data VALUES (26654, 602, 43143, 8, 805, 113, 122);
INSERT INTO public.who_global_data VALUES (26655, 0, 0, 0, 0, 113, 159);
INSERT INTO public.who_global_data VALUES (26656, 77, 16459, 0, 640, 113, 75);
INSERT INTO public.who_global_data VALUES (26657, 746, 114015, 8, 684, 113, 27);
INSERT INTO public.who_global_data VALUES (26658, 431, 51020, 4, 1103, 113, 54);
INSERT INTO public.who_global_data VALUES (26659, 0, 23, 0, 0, 113, 226);
INSERT INTO public.who_global_data VALUES (26660, 114, 3056, 0, 41, 113, 79);
INSERT INTO public.who_global_data VALUES (26661, 1418, 58513, 2, 501, 113, 56);
INSERT INTO public.who_global_data VALUES (26662, 0, 1833, 0, 42, 113, 117);
INSERT INTO public.who_global_data VALUES (26663, 0, 1372, 0, 82, 113, 152);
INSERT INTO public.who_global_data VALUES (26664, 1169, 47845, 18, 699, 113, 16);
INSERT INTO public.who_global_data VALUES (26665, 17, 202, 0, 1, 113, 10);
INSERT INTO public.who_global_data VALUES (26666, 281, 7033, 3, 97, 113, 201);
INSERT INTO public.who_global_data VALUES (26667, 214, 10244, 0, 133, 113, 174);
INSERT INTO public.who_global_data VALUES (26668, 0, 16754, 0, 237, 113, 119);
INSERT INTO public.who_global_data VALUES (26669, 7, 5836, 0, 181, 113, 168);
INSERT INTO public.who_global_data VALUES (26670, 589, 18129, 3, 170, 113, 99);
INSERT INTO public.who_global_data VALUES (26671, 51, 11113, 0, 35, 113, 171);
INSERT INTO public.who_global_data VALUES (26672, 16, 3368, 0, 132, 113, 87);
INSERT INTO public.who_global_data VALUES (26673, 122, 4274, 0, 45, 113, 123);
INSERT INTO public.who_global_data VALUES (26674, 0, 0, 0, 0, 113, 151);
INSERT INTO public.who_global_data VALUES (26675, 0, 2257, 0, 24, 113, 213);
INSERT INTO public.who_global_data VALUES (26676, 20, 7585, 0, 163, 113, 118);
INSERT INTO public.who_global_data VALUES (26677, 0, 404, 0, 10, 113, 134);
INSERT INTO public.who_global_data VALUES (26678, 0, 4030, 0, 43, 113, 65);
INSERT INTO public.who_global_data VALUES (26679, 4056, 829396, 478, 84898, 113, 102);
INSERT INTO public.who_global_data VALUES (26680, 0, 0, 0, 0, 113, 223);
INSERT INTO public.who_global_data VALUES (26681, 5, 256, 0, 2, 113, 4);
INSERT INTO public.who_global_data VALUES (26682, 0, 320, 0, 0, 113, 146);
INSERT INTO public.who_global_data VALUES (26683, 233, 15507, 7, 228, 113, 31);
INSERT INTO public.who_global_data VALUES (26684, 0, 13, 0, 1, 113, 127);
INSERT INTO public.who_global_data VALUES (26685, 3317, 163650, 46, 2772, 113, 22);
INSERT INTO public.who_global_data VALUES (26686, 145, 10537, 0, 73, 113, 115);
INSERT INTO public.who_global_data VALUES (26687, 1026, 32351, 33, 765, 113, 106);
INSERT INTO public.who_global_data VALUES (26688, 34, 12103, 0, 130, 113, 90);
INSERT INTO public.who_global_data VALUES (26689, 0, 0, 0, 0, 113, 70);
INSERT INTO public.who_global_data VALUES (26690, 3749, 121745, 19, 694, 113, 46);
INSERT INTO public.who_global_data VALUES (26691, 7790, 203407, 29, 6687, 113, 139);
INSERT INTO public.who_global_data VALUES (26692, 0, 27, 0, 0, 113, 42);
INSERT INTO public.who_global_data VALUES (26693, 4, 1524, 0, 25, 113, 80);
INSERT INTO public.who_global_data VALUES (26694, 0, 4297, 0, 154, 113, 203);
INSERT INTO public.who_global_data VALUES (26695, 0, 1205, 0, 69, 113, 136);
INSERT INTO public.who_global_data VALUES (26696, 148, 60982, 0, 1116, 113, 63);
INSERT INTO public.who_global_data VALUES (26697, 0, 0, 0, 0, 113, 17);
INSERT INTO public.who_global_data VALUES (26698, 3, 80, 0, 2, 113, 172);
INSERT INTO public.who_global_data VALUES (26699, 534, 22170, 6, 815, 113, 109);
INSERT INTO public.who_global_data VALUES (26700, 162, 15953, 1, 278, 113, 200);
INSERT INTO public.who_global_data VALUES (26701, 442, 57441, 8, 471, 113, 93);
INSERT INTO public.who_global_data VALUES (26702, 520, 108296, 10, 1071, 113, 5);
INSERT INTO public.who_global_data VALUES (26703, 0, 741, 0, 13, 113, 214);
INSERT INTO public.who_global_data VALUES (26704, 593, 321811, 7, 6621, 113, 204);
INSERT INTO public.who_global_data VALUES (26705, 0, 0, 0, 0, 113, 198);
INSERT INTO public.who_global_data VALUES (26706, 832, 122128, 8, 2519, 113, 173);
INSERT INTO public.who_global_data VALUES (26707, 0, 578, 0, 7, 113, 229);
INSERT INTO public.who_global_data VALUES (26708, 648, 51845, 23, 1131, 113, 76);
INSERT INTO public.who_global_data VALUES (26709, 2977, 856951, 93, 33512, 113, 138);
INSERT INTO public.who_global_data VALUES (26710, 2162, 348698, 48, 6497, 113, 98);
INSERT INTO public.who_global_data VALUES (26711, 0, 0, 0, 0, 113, 103);
INSERT INTO public.who_global_data VALUES (26712, 8099, 149903, 91, 3308, 113, 225);
INSERT INTO public.who_global_data VALUES (26713, 2101, 93294, 11, 2128, 113, 131);
INSERT INTO public.who_global_data VALUES (26714, 569, 56085, 1, 743, 113, 235);
INSERT INTO public.who_global_data VALUES (26715, 200, 128803, 2, 222, 113, 137);
INSERT INTO public.who_global_data VALUES (26716, 47, 25035, 2, 441, 113, 81);
INSERT INTO public.who_global_data VALUES (26717, 652, 65076, 16, 1530, 113, 182);
INSERT INTO public.who_global_data VALUES (26718, 0, 4678, 0, 17, 113, 145);
INSERT INTO public.who_global_data VALUES (26719, 4013, 168490, 73, 5674, 113, 26);
INSERT INTO public.who_global_data VALUES (26720, 15150, 1369313, 232, 23723, 113, 170);
INSERT INTO public.who_global_data VALUES (26721, 13, 4953, 0, 33, 113, 191);
INSERT INTO public.who_global_data VALUES (26722, 0, 5, 0, 0, 113, 221);
INSERT INTO public.who_global_data VALUES (26723, 2, 67, 0, 0, 113, 64);
INSERT INTO public.who_global_data VALUES (26724, 0, 0, 0, 0, 113, 116);
INSERT INTO public.who_global_data VALUES (26725, 0, 19, 0, 0, 113, 128);
INSERT INTO public.who_global_data VALUES (26726, 2, 31, 0, 0, 113, 6);
INSERT INTO public.who_global_data VALUES (26727, 35, 501, 0, 8, 113, 227);
INSERT INTO public.who_global_data VALUES (26728, 0, 12, 0, 0, 113, 68);
INSERT INTO public.who_global_data VALUES (26729, 0, 64, 0, 0, 113, 184);
INSERT INTO public.who_global_data VALUES (26730, 0, 0, 0, 0, 113, 82);
INSERT INTO public.who_global_data VALUES (26731, 9, 781, 0, 42, 113, 149);
INSERT INTO public.who_global_data VALUES (26732, 0, 929, 0, 15, 113, 197);
INSERT INTO public.who_global_data VALUES (26733, 472, 341062, 19, 5127, 113, 78);
INSERT INTO public.who_global_data VALUES (26734, 17, 15348, 0, 316, 113, 233);
INSERT INTO public.who_global_data VALUES (26735, 203, 35454, 2, 770, 113, 133);
INSERT INTO public.who_global_data VALUES (26736, 0, 148, 0, 0, 113, 35);
INSERT INTO public.who_global_data VALUES (26737, 8, 2323, 0, 73, 113, 114);
INSERT INTO public.who_global_data VALUES (26738, 3, 57892, 0, 28, 113, 237);
INSERT INTO public.who_global_data VALUES (26739, 0, 14, 0, 0, 113, 55);
INSERT INTO public.who_global_data VALUES (26740, 10, 729, 0, 22, 113, 176);
INSERT INTO public.who_global_data VALUES (26741, 1929, 24225, 5, 71, 113, 202);
INSERT INTO public.who_global_data VALUES (26742, 836, 11524, 8, 197, 113, 155);
INSERT INTO public.who_global_data VALUES (26743, 1, 3, 0, 0, 113, 32);
INSERT INTO public.who_global_data VALUES (26744, 0, 3864, 0, 99, 113, 220);
INSERT INTO public.who_global_data VALUES (26745, 1770, 698184, 158, 18309, 113, 30);
INSERT INTO public.who_global_data VALUES (26746, 10, 2817, 0, 55, 113, 147);
INSERT INTO public.who_global_data VALUES (26747, 16821, 975422, 135, 35887, 113, 208);
INSERT INTO public.who_global_data VALUES (26748, 76, 5244, 0, 13, 113, 45);
INSERT INTO public.who_global_data VALUES (26749, 3, 13700, 0, 836, 113, 110);
INSERT INTO public.who_global_data VALUES (26750, 11, 5083, 1, 108, 113, 88);
INSERT INTO public.who_global_data VALUES (26751, 968, 102599, 2, 5921, 113, 51);
INSERT INTO public.who_global_data VALUES (26752, 3393, 76530, 5, 1865, 113, 209);
INSERT INTO public.who_global_data VALUES (26753, 48, 4931, 4, 238, 113, 205);
INSERT INTO public.who_global_data VALUES (26754, 38, 10374, 1, 80, 113, 18);
INSERT INTO public.who_global_data VALUES (26755, 4, 3669, 0, 59, 113, 72);
INSERT INTO public.who_global_data VALUES (26756, 18978, 673626, 138, 43293, 113, 44);
INSERT INTO public.who_global_data VALUES (26757, 0, 29, 0, 0, 113, 15);
INSERT INTO public.who_global_data VALUES (26758, 24, 1996, 1, 51, 113, 25);
INSERT INTO public.who_global_data VALUES (26759, 0, 0, 0, 0, 113, 179);
INSERT INTO public.who_global_data VALUES (26760, 0, 0, 0, 0, 113, 34);
INSERT INTO public.who_global_data VALUES (26761, 27, 5154, 0, 93, 113, 207);
INSERT INTO public.who_global_data VALUES (26762, 0, 34790, 0, 512, 113, 166);
INSERT INTO public.who_global_data VALUES (26763, 8423, 880543, 66, 9080, 113, 126);
INSERT INTO public.who_global_data VALUES (26764, 0, 0, 0, 0, 113, 97);
INSERT INTO public.who_global_data VALUES (26765, 0, 696, 0, 6, 113, 36);
INSERT INTO public.who_global_data VALUES (26766, 0, 0, 0, 0, 113, 125);
INSERT INTO public.who_global_data VALUES (26767, 48, 10117, 1, 96, 113, 124);
INSERT INTO public.who_global_data VALUES (26768, 5992, 287231, 106, 5408, 113, 185);
INSERT INTO public.who_global_data VALUES (26769, 1398, 111437, 2, 452, 113, 194);
INSERT INTO public.who_global_data VALUES (26770, 0, 509, 0, 21, 113, 144);
INSERT INTO public.who_global_data VALUES (26771, 59106, 7833851, 830, 215199, 113, 19);
INSERT INTO public.who_global_data VALUES (26772, -1, 1327, 0, 20, 113, 217);
INSERT INTO public.who_global_data VALUES (26773, 51, 2388, 0, 51, 113, 148);
INSERT INTO public.who_global_data VALUES (26774, 309, 62484, 3, 519, 113, 86);
INSERT INTO public.who_global_data VALUES (26775, 0, 0, 0, 0, 113, 13);
INSERT INTO public.who_global_data VALUES (26776, 614, 85005, 4, 714, 113, 157);
INSERT INTO public.who_global_data VALUES (26777, 2, 1124, 0, 35, 113, 8);
INSERT INTO public.who_global_data VALUES (26778, 0, 0, 0, 0, 113, 73);
INSERT INTO public.who_global_data VALUES (26779, 0, 2057, 0, 597, 113, 101);
INSERT INTO public.who_global_data VALUES (26780, 43, 15659, 2, 346, 113, 165);
INSERT INTO public.who_global_data VALUES (26781, 20, 8075, 0, 231, 113, 14);
INSERT INTO public.who_global_data VALUES (26782, 32, 40112, 0, 1485, 114, 193);
INSERT INTO public.who_global_data VALUES (26783, 203, 15955, 5, 434, 114, 113);
INSERT INTO public.who_global_data VALUES (26784, 0, 53399, 0, 1818, 114, 143);
INSERT INTO public.who_global_data VALUES (26785, 0, 0, 0, 0, 114, 219);
INSERT INTO public.who_global_data VALUES (26786, 195, 3190, 2, 59, 114, 186);
INSERT INTO public.who_global_data VALUES (26787, 166, 6846, 5, 227, 114, 52);
INSERT INTO public.who_global_data VALUES (26788, 0, 3, 0, 0, 114, 180);
INSERT INTO public.who_global_data VALUES (26789, 1, 112, 0, 3, 114, 167);
INSERT INTO public.who_global_data VALUES (26790, 13305, 917035, 386, 24572, 114, 154);
INSERT INTO public.who_global_data VALUES (26791, 1371, 59308, 7, 1041, 114, 94);
INSERT INTO public.who_global_data VALUES (26792, 32, 4229, 0, 32, 114, 66);
INSERT INTO public.who_global_data VALUES (26793, 24, 27341, 5, 904, 114, 58);
INSERT INTO public.who_global_data VALUES (26794, 1606, 59368, 9, 888, 114, 163);
INSERT INTO public.who_global_data VALUES (26795, 369, 42750, 4, 616, 114, 37);
INSERT INTO public.who_global_data VALUES (26796, 28, 5191, 1, 109, 114, 142);
INSERT INTO public.who_global_data VALUES (26797, 349, 76621, 2, 287, 114, 83);
INSERT INTO public.who_global_data VALUES (26798, 1684, 382959, 16, 5593, 114, 228);
INSERT INTO public.who_global_data VALUES (26799, 2, 210, 0, 7, 114, 188);
INSERT INTO public.who_global_data VALUES (26800, 597, 85121, 5, 911, 114, 62);
INSERT INTO public.who_global_data VALUES (26801, 12303, 209022, 41, 10320, 114, 160);
INSERT INTO public.who_global_data VALUES (26802, 16, 2585, 2, 39, 114, 50);
INSERT INTO public.who_global_data VALUES (26803, 0, 2496, 0, 41, 114, 33);
INSERT INTO public.who_global_data VALUES (26804, 1, 185, 0, 9, 114, 183);
INSERT INTO public.who_global_data VALUES (26805, 3, 316, 0, 0, 114, 92);
INSERT INTO public.who_global_data VALUES (26806, 227, 138922, 25, 8351, 114, 158);
INSERT INTO public.who_global_data VALUES (26807, 0, 131, 0, 2, 114, 67);
INSERT INTO public.who_global_data VALUES (26808, 479, 31652, 12, 955, 114, 57);
INSERT INTO public.who_global_data VALUES (26809, 0, 5039, 0, 20, 114, 38);
INSERT INTO public.who_global_data VALUES (26810, 10220, 5113628, 309, 150998, 114, 141);
INSERT INTO public.who_global_data VALUES (26811, 1, 72, 0, 1, 114, 178);
INSERT INTO public.who_global_data VALUES (26812, 1, 147, 0, 3, 114, 108);
INSERT INTO public.who_global_data VALUES (26813, 819, 26593, 6, 929, 114, 39);
INSERT INTO public.who_global_data VALUES (26814, 14, 2294, 0, 63, 114, 2);
INSERT INTO public.who_global_data VALUES (26815, 0, 529, 0, 1, 114, 195);
INSERT INTO public.who_global_data VALUES (26816, 117, 7371, 2, 79, 114, 107);
INSERT INTO public.who_global_data VALUES (26817, 0, 283, 0, 0, 114, 161);
INSERT INTO public.who_global_data VALUES (26818, 0, 21441, 0, 423, 114, 212);
INSERT INTO public.who_global_data VALUES (26819, 4042, 186881, 27, 9654, 114, 181);
INSERT INTO public.who_global_data VALUES (26820, 0, 221, 0, 1, 114, 53);
INSERT INTO public.who_global_data VALUES (26821, 0, 4855, 0, 62, 114, 164);
INSERT INTO public.who_global_data VALUES (26822, 8, 1329, 0, 92, 114, 140);
INSERT INTO public.who_global_data VALUES (26823, 1092, 485372, 19, 13415, 114, 20);
INSERT INTO public.who_global_data VALUES (26824, 12, 91399, 0, 4746, 114, 112);
INSERT INTO public.who_global_data VALUES (26825, 5015, 924098, 156, 28141, 114, 111);
INSERT INTO public.who_global_data VALUES (26826, 0, 496, 0, 7, 114, 71);
INSERT INTO public.who_global_data VALUES (26827, 0, 5156, 0, 92, 114, 218);
INSERT INTO public.who_global_data VALUES (26828, 0, 0, 0, 0, 114, 43);
INSERT INTO public.who_global_data VALUES (26829, 1015, 90238, 16, 1124, 114, 49);
INSERT INTO public.who_global_data VALUES (26830, 34, 20217, 1, 121, 114, 1);
INSERT INTO public.who_global_data VALUES (26831, 748, 21741, 4, 334, 114, 48);
INSERT INTO public.who_global_data VALUES (26832, 18, 6035, 0, 123, 114, 232);
INSERT INTO public.who_global_data VALUES (26833, 34, 619, 0, 1, 114, 175);
INSERT INTO public.who_global_data VALUES (26834, 83, 2130, 0, 25, 114, 21);
INSERT INTO public.who_global_data VALUES (26835, 9543, 139290, 66, 1172, 114, 156);
INSERT INTO public.who_global_data VALUES (26836, 0, 0, 0, 0, 114, 95);
INSERT INTO public.who_global_data VALUES (26837, 63, 10934, 5, 281, 114, 177);
INSERT INTO public.who_global_data VALUES (26838, 492, 33593, 1, 675, 114, 210);
INSERT INTO public.who_global_data VALUES (26839, 12, 5440, 0, 61, 114, 120);
INSERT INTO public.who_global_data VALUES (26840, 0, 32, 0, 0, 114, 135);
INSERT INTO public.who_global_data VALUES (26841, 654, 119662, 3, 2186, 114, 206);
INSERT INTO public.who_global_data VALUES (26842, 912, 149083, 29, 12264, 114, 189);
INSERT INTO public.who_global_data VALUES (26843, 128, 104915, 6, 6077, 114, 129);
INSERT INTO public.who_global_data VALUES (26844, 286, 30766, 5, 904, 114, 121);
INSERT INTO public.who_global_data VALUES (26845, 2, 5068, 0, 83, 114, 59);
INSERT INTO public.who_global_data VALUES (26846, 0, 414, 0, 0, 114, 96);
INSERT INTO public.who_global_data VALUES (26847, 39, 3947, 0, 68, 114, 41);
INSERT INTO public.who_global_data VALUES (26848, 19, 5715, 0, 114, 114, 216);
INSERT INTO public.who_global_data VALUES (26849, 712, 86430, 7, 1312, 114, 236);
INSERT INTO public.who_global_data VALUES (26850, 0, 13, 0, 0, 114, 150);
INSERT INTO public.who_global_data VALUES (26851, 1, 478, 0, 0, 114, 61);
INSERT INTO public.who_global_data VALUES (26852, 0, 32, 0, 2, 114, 7);
INSERT INTO public.who_global_data VALUES (26853, 204, 12703, 4, 350, 114, 169);
INSERT INTO public.who_global_data VALUES (26854, 21696, 750441, 101, 32780, 114, 28);
INSERT INTO public.who_global_data VALUES (26855, 10, 10202, 0, 69, 114, 85);
INSERT INTO public.who_global_data VALUES (26856, 322, 3573, 2, 13, 114, 211);
INSERT INTO public.who_global_data VALUES (26857, 9, 8869, 0, 54, 114, 60);
INSERT INTO public.who_global_data VALUES (26858, 8, 3644, 0, 118, 114, 3);
INSERT INTO public.who_global_data VALUES (26859, 919, 14440, 4, 113, 114, 11);
INSERT INTO public.who_global_data VALUES (26860, 6638, 341223, 33, 9710, 114, 89);
INSERT INTO public.who_global_data VALUES (26861, 29, 47126, 2, 310, 114, 24);
INSERT INTO public.who_global_data VALUES (26862, 13, 499, 0, 0, 114, 162);
INSERT INTO public.who_global_data VALUES (26863, 435, 23495, 7, 469, 114, 100);
INSERT INTO public.who_global_data VALUES (26864, 0, 16, 0, 0, 114, 47);
INSERT INTO public.who_global_data VALUES (26865, 0, 25, 0, 0, 114, 29);
INSERT INTO public.who_global_data VALUES (26866, 425, 6908, 1, 96, 114, 40);
INSERT INTO public.who_global_data VALUES (26867, 75, 3341, 0, 61, 114, 222);
INSERT INTO public.who_global_data VALUES (26868, 714, 99094, 20, 3430, 114, 132);
INSERT INTO public.who_global_data VALUES (26869, 0, 258, 0, 13, 114, 130);
INSERT INTO public.who_global_data VALUES (26870, 54, 11188, 0, 70, 114, 234);
INSERT INTO public.who_global_data VALUES (26871, 0, 2385, 0, 40, 114, 23);
INSERT INTO public.who_global_data VALUES (26872, 44, 3565, 2, 106, 114, 192);
INSERT INTO public.who_global_data VALUES (26873, 21, 8908, 1, 231, 114, 69);
INSERT INTO public.who_global_data VALUES (26874, 0, 19, 0, 0, 114, 187);
INSERT INTO public.who_global_data VALUES (26875, 439, 84852, 7, 2528, 114, 230);
INSERT INTO public.who_global_data VALUES (26876, 950, 41732, 29, 1052, 114, 77);
INSERT INTO public.who_global_data VALUES (26877, 89, 3757, 0, 10, 114, 9);
INSERT INTO public.who_global_data VALUES (26878, 67708, 7307097, 680, 111266, 114, 74);
INSERT INTO public.who_global_data VALUES (26879, 4127, 344749, 129, 12156, 114, 224);
INSERT INTO public.who_global_data VALUES (26880, 4830, 513219, 279, 29349, 114, 199);
INSERT INTO public.who_global_data VALUES (26881, 3857, 413215, 51, 10021, 114, 190);
INSERT INTO public.who_global_data VALUES (26882, 1084, 45243, 5, 1835, 114, 12);
INSERT INTO public.who_global_data VALUES (26883, 0, 346, 0, 24, 114, 104);
INSERT INTO public.who_global_data VALUES (26884, 2336, 297134, 38, 2084, 114, 153);
INSERT INTO public.who_global_data VALUES (26885, 7332, 372799, 43, 36289, 114, 91);
INSERT INTO public.who_global_data VALUES (26886, 79, 7989, 5, 151, 114, 215);
INSERT INTO public.who_global_data VALUES (26887, 570, 90710, 8, 1646, 114, 84);
INSERT INTO public.who_global_data VALUES (26888, 5, 484, 0, 32, 114, 231);
INSERT INTO public.who_global_data VALUES (26889, 2423, 30618, 32, 257, 114, 196);
INSERT INTO public.who_global_data VALUES (26890, 274, 144761, 0, 2136, 114, 105);
INSERT INTO public.who_global_data VALUES (26891, 602, 42541, 10, 797, 114, 122);
INSERT INTO public.who_global_data VALUES (26892, 0, 0, 0, 0, 114, 159);
INSERT INTO public.who_global_data VALUES (26893, 80, 16382, 1, 640, 114, 75);
INSERT INTO public.who_global_data VALUES (26894, 532, 113269, 4, 676, 114, 27);
INSERT INTO public.who_global_data VALUES (26895, 388, 50589, 5, 1099, 114, 54);
INSERT INTO public.who_global_data VALUES (26896, 0, 23, 0, 0, 114, 226);
INSERT INTO public.who_global_data VALUES (26897, 102, 2942, 0, 41, 114, 79);
INSERT INTO public.who_global_data VALUES (26898, 1226, 57095, 20, 499, 114, 56);
INSERT INTO public.who_global_data VALUES (26899, 28, 1833, 0, 42, 114, 117);
INSERT INTO public.who_global_data VALUES (26900, 0, 1372, 0, 82, 114, 152);
INSERT INTO public.who_global_data VALUES (26901, 855, 46676, 12, 681, 114, 16);
INSERT INTO public.who_global_data VALUES (26902, 8, 185, 0, 1, 114, 10);
INSERT INTO public.who_global_data VALUES (26903, 255, 6752, 0, 94, 114, 201);
INSERT INTO public.who_global_data VALUES (26904, 190, 10030, 0, 133, 114, 174);
INSERT INTO public.who_global_data VALUES (26905, 0, 16754, 0, 237, 114, 119);
INSERT INTO public.who_global_data VALUES (26906, 2, 5829, 0, 181, 114, 168);
INSERT INTO public.who_global_data VALUES (26907, 660, 17540, 4, 167, 114, 99);
INSERT INTO public.who_global_data VALUES (26908, 69, 11062, 0, 35, 114, 171);
INSERT INTO public.who_global_data VALUES (26909, 55, 3352, 0, 132, 114, 87);
INSERT INTO public.who_global_data VALUES (26910, 112, 4152, 1, 45, 114, 123);
INSERT INTO public.who_global_data VALUES (26911, 0, 0, 0, 0, 114, 151);
INSERT INTO public.who_global_data VALUES (26912, 406, 2257, 2, 24, 114, 213);
INSERT INTO public.who_global_data VALUES (26913, 0, 7565, 0, 163, 114, 118);
INSERT INTO public.who_global_data VALUES (26914, 0, 404, 0, 10, 114, 134);
INSERT INTO public.who_global_data VALUES (26915, 0, 4030, 0, 43, 114, 65);
INSERT INTO public.who_global_data VALUES (26916, 4295, 825340, 475, 84420, 114, 102);
INSERT INTO public.who_global_data VALUES (26917, 0, 0, 0, 0, 114, 223);
INSERT INTO public.who_global_data VALUES (26918, 7, 251, 0, 2, 114, 4);
INSERT INTO public.who_global_data VALUES (26919, 0, 320, 0, 0, 114, 146);
INSERT INTO public.who_global_data VALUES (26920, 221, 15274, 2, 221, 114, 31);
INSERT INTO public.who_global_data VALUES (26921, 0, 13, 0, 1, 114, 127);
INSERT INTO public.who_global_data VALUES (26922, 3387, 160333, 41, 2726, 114, 22);
INSERT INTO public.who_global_data VALUES (26923, 134, 10392, 0, 73, 114, 115);
INSERT INTO public.who_global_data VALUES (26924, 888, 31325, 39, 732, 114, 106);
INSERT INTO public.who_global_data VALUES (26925, 69, 12069, 1, 130, 114, 90);
INSERT INTO public.who_global_data VALUES (26926, 0, 0, 0, 0, 114, 70);
INSERT INTO public.who_global_data VALUES (26927, 2638, 117996, 12, 675, 114, 46);
INSERT INTO public.who_global_data VALUES (26928, 7253, 195617, 32, 6658, 114, 139);
INSERT INTO public.who_global_data VALUES (26929, 0, 27, 0, 0, 114, 42);
INSERT INTO public.who_global_data VALUES (26930, 2, 1520, 0, 25, 114, 80);
INSERT INTO public.who_global_data VALUES (26931, 0, 4297, 0, 154, 114, 203);
INSERT INTO public.who_global_data VALUES (26932, 4, 1205, 0, 69, 114, 136);
INSERT INTO public.who_global_data VALUES (26933, 179, 60834, 0, 1116, 114, 63);
INSERT INTO public.who_global_data VALUES (26934, 0, 0, 0, 0, 114, 17);
INSERT INTO public.who_global_data VALUES (26935, 0, 77, 0, 2, 114, 172);
INSERT INTO public.who_global_data VALUES (26936, 443, 21636, 9, 809, 114, 109);
INSERT INTO public.who_global_data VALUES (26937, 152, 15791, 0, 277, 114, 200);
INSERT INTO public.who_global_data VALUES (26938, 532, 56999, 4, 463, 114, 93);
INSERT INTO public.who_global_data VALUES (26939, 563, 107776, 8, 1061, 114, 5);
INSERT INTO public.who_global_data VALUES (26940, 0, 741, 0, 13, 114, 214);
INSERT INTO public.who_global_data VALUES (26941, 755, 321218, 13, 6614, 114, 204);
INSERT INTO public.who_global_data VALUES (26942, 0, 0, 0, 0, 114, 198);
INSERT INTO public.who_global_data VALUES (26943, 494, 121296, 9, 2511, 114, 173);
INSERT INTO public.who_global_data VALUES (26944, 13, 578, 0, 7, 114, 229);
INSERT INTO public.who_global_data VALUES (26945, 853, 51197, 12, 1108, 114, 76);
INSERT INTO public.who_global_data VALUES (26946, 2803, 853974, 62, 33419, 114, 138);
INSERT INTO public.who_global_data VALUES (26947, 1823, 346536, 77, 6449, 114, 98);
INSERT INTO public.who_global_data VALUES (26948, 0, 0, 0, 0, 114, 103);
INSERT INTO public.who_global_data VALUES (26949, 6526, 141804, 116, 3217, 114, 225);
INSERT INTO public.who_global_data VALUES (26950, 2072, 91193, 7, 2117, 114, 131);
INSERT INTO public.who_global_data VALUES (26951, 976, 55516, 4, 742, 114, 235);
INSERT INTO public.who_global_data VALUES (26952, 198, 128603, 0, 220, 114, 137);
INSERT INTO public.who_global_data VALUES (26953, 110, 24988, 1, 439, 114, 81);
INSERT INTO public.who_global_data VALUES (26954, 1149, 64424, 19, 1514, 114, 182);
INSERT INTO public.who_global_data VALUES (26955, 54, 4678, 0, 17, 114, 145);
INSERT INTO public.who_global_data VALUES (26956, 4016, 164477, 66, 5601, 114, 26);
INSERT INTO public.who_global_data VALUES (26957, 13754, 1354163, 286, 23491, 114, 170);
INSERT INTO public.who_global_data VALUES (26958, 32, 4940, 1, 33, 114, 191);
INSERT INTO public.who_global_data VALUES (26959, 0, 5, 0, 0, 114, 221);
INSERT INTO public.who_global_data VALUES (26960, 0, 65, 0, 0, 114, 64);
INSERT INTO public.who_global_data VALUES (26961, 0, 0, 0, 0, 114, 116);
INSERT INTO public.who_global_data VALUES (26962, 0, 19, 0, 0, 114, 128);
INSERT INTO public.who_global_data VALUES (26963, 0, 29, 0, 0, 114, 6);
INSERT INTO public.who_global_data VALUES (26964, 0, 466, 0, 8, 114, 227);
INSERT INTO public.who_global_data VALUES (26965, 0, 12, 0, 0, 114, 68);
INSERT INTO public.who_global_data VALUES (26966, 0, 64, 0, 0, 114, 184);
INSERT INTO public.who_global_data VALUES (26967, 0, 0, 0, 0, 114, 82);
INSERT INTO public.who_global_data VALUES (26968, 0, 772, 0, 42, 114, 149);
INSERT INTO public.who_global_data VALUES (26969, 0, 929, 0, 15, 114, 197);
INSERT INTO public.who_global_data VALUES (26970, 501, 340590, 21, 5108, 114, 78);
INSERT INTO public.who_global_data VALUES (26971, 24, 15331, 1, 316, 114, 233);
INSERT INTO public.who_global_data VALUES (26972, 245, 35251, 1, 768, 114, 133);
INSERT INTO public.who_global_data VALUES (26973, 1, 148, 0, 0, 114, 35);
INSERT INTO public.who_global_data VALUES (26974, 6, 2315, 1, 73, 114, 114);
INSERT INTO public.who_global_data VALUES (26975, 5, 57889, 0, 28, 114, 237);
INSERT INTO public.who_global_data VALUES (26976, 0, 14, 0, 0, 114, 55);
INSERT INTO public.who_global_data VALUES (26977, 9, 719, 0, 22, 114, 176);
INSERT INTO public.who_global_data VALUES (26978, 1410, 22296, 5, 66, 114, 202);
INSERT INTO public.who_global_data VALUES (26979, 748, 10688, 3, 189, 114, 155);
INSERT INTO public.who_global_data VALUES (26980, 0, 2, 0, 0, 114, 32);
INSERT INTO public.who_global_data VALUES (26981, 0, 3864, 0, 99, 114, 220);
INSERT INTO public.who_global_data VALUES (26982, 1877, 696414, 123, 18151, 114, 30);
INSERT INTO public.who_global_data VALUES (26983, 9, 2807, 0, 55, 114, 147);
INSERT INTO public.who_global_data VALUES (26984, 12699, 958601, 144, 35752, 114, 208);
INSERT INTO public.who_global_data VALUES (26985, 130, 5168, 0, 13, 114, 45);
INSERT INTO public.who_global_data VALUES (26986, 0, 13697, 0, 836, 114, 110);
INSERT INTO public.who_global_data VALUES (26987, 14, 5072, 0, 107, 114, 88);
INSERT INTO public.who_global_data VALUES (26988, 916, 101631, 1, 5919, 114, 51);
INSERT INTO public.who_global_data VALUES (26989, 2997, 73137, 5, 1860, 114, 209);
INSERT INTO public.who_global_data VALUES (26990, 57, 4883, 3, 234, 114, 205);
INSERT INTO public.who_global_data VALUES (26991, 39, 10336, 0, 79, 114, 18);
INSERT INTO public.who_global_data VALUES (26992, 13, 3665, 0, 59, 114, 72);
INSERT INTO public.who_global_data VALUES (26993, 19724, 654648, 137, 43155, 114, 44);
INSERT INTO public.who_global_data VALUES (26994, 0, 29, 0, 0, 114, 15);
INSERT INTO public.who_global_data VALUES (26995, 0, 1972, 0, 50, 114, 25);
INSERT INTO public.who_global_data VALUES (26996, 0, 0, 0, 0, 114, 179);
INSERT INTO public.who_global_data VALUES (26997, 0, 0, 0, 0, 114, 34);
INSERT INTO public.who_global_data VALUES (26998, 11, 5127, 1, 93, 114, 207);
INSERT INTO public.who_global_data VALUES (26999, 0, 34790, 0, 512, 114, 166);
INSERT INTO public.who_global_data VALUES (27000, 8401, 872120, 57, 9014, 114, 126);
INSERT INTO public.who_global_data VALUES (27001, 0, 0, 0, 0, 114, 97);
INSERT INTO public.who_global_data VALUES (27002, 0, 696, 0, 6, 114, 36);
INSERT INTO public.who_global_data VALUES (27003, 0, 0, 0, 0, 114, 125);
INSERT INTO public.who_global_data VALUES (27004, 124, 10069, 0, 95, 114, 124);
INSERT INTO public.who_global_data VALUES (27005, 5062, 281239, 73, 5302, 114, 185);
INSERT INTO public.who_global_data VALUES (27006, 1431, 110039, 2, 450, 114, 194);
INSERT INTO public.who_global_data VALUES (27007, 0, 509, 0, 21, 114, 144);
INSERT INTO public.who_global_data VALUES (27008, 46309, 7774745, 743, 214369, 114, 19);
INSERT INTO public.who_global_data VALUES (27009, 3, 1328, 0, 20, 114, 217);
INSERT INTO public.who_global_data VALUES (27010, 24, 2337, 0, 51, 114, 148);
INSERT INTO public.who_global_data VALUES (27011, 316, 62175, 4, 516, 114, 86);
INSERT INTO public.who_global_data VALUES (27012, 0, 0, 0, 0, 114, 13);
INSERT INTO public.who_global_data VALUES (27013, 635, 84391, 6, 710, 114, 157);
INSERT INTO public.who_global_data VALUES (27014, 9, 1122, 0, 35, 114, 8);
INSERT INTO public.who_global_data VALUES (27015, 0, 0, 0, 0, 114, 73);
INSERT INTO public.who_global_data VALUES (27016, 0, 2057, 0, 597, 114, 101);
INSERT INTO public.who_global_data VALUES (27017, 67, 15616, 0, 344, 114, 165);
INSERT INTO public.who_global_data VALUES (27018, 19, 8055, 1, 231, 114, 14);
INSERT INTO public.who_global_data VALUES (27019, 66, 40080, 1, 1485, 115, 193);
INSERT INTO public.who_global_data VALUES (27020, 182, 15752, 5, 429, 115, 113);
INSERT INTO public.who_global_data VALUES (27021, 174, 53399, 9, 1818, 115, 143);
INSERT INTO public.who_global_data VALUES (27022, 0, 0, 0, 0, 115, 219);
INSERT INTO public.who_global_data VALUES (27023, 0, 2995, 0, 57, 115, 186);
INSERT INTO public.who_global_data VALUES (27024, 192, 6680, 3, 222, 115, 52);
INSERT INTO public.who_global_data VALUES (27025, 0, 3, 0, 0, 115, 180);
INSERT INTO public.who_global_data VALUES (27026, 0, 111, 0, 3, 115, 167);
INSERT INTO public.who_global_data VALUES (27027, 9524, 903730, 318, 24186, 115, 154);
INSERT INTO public.who_global_data VALUES (27028, 1058, 57937, 7, 1034, 115, 94);
INSERT INTO public.who_global_data VALUES (27029, 3, 4197, 0, 32, 115, 66);
INSERT INTO public.who_global_data VALUES (27030, 31, 27317, 1, 899, 115, 58);
INSERT INTO public.who_global_data VALUES (27031, 1171, 57762, 10, 879, 115, 163);
INSERT INTO public.who_global_data VALUES (27032, 277, 42381, 3, 612, 115, 37);
INSERT INTO public.who_global_data VALUES (27033, 85, 5163, 1, 108, 115, 142);
INSERT INTO public.who_global_data VALUES (27034, 324, 76272, 5, 285, 115, 83);
INSERT INTO public.who_global_data VALUES (27035, 1537, 381275, 22, 5577, 115, 228);
INSERT INTO public.who_global_data VALUES (27036, 0, 208, 0, 7, 115, 188);
INSERT INTO public.who_global_data VALUES (27037, 526, 84524, 5, 906, 115, 62);
INSERT INTO public.who_global_data VALUES (27038, 12578, 196719, 34, 10279, 115, 160);
INSERT INTO public.who_global_data VALUES (27039, 38, 2569, 0, 37, 115, 50);
INSERT INTO public.who_global_data VALUES (27040, 85, 2496, 0, 41, 115, 33);
INSERT INTO public.who_global_data VALUES (27041, 0, 184, 0, 9, 115, 183);
INSERT INTO public.who_global_data VALUES (27042, 4, 313, 0, 0, 115, 92);
INSERT INTO public.who_global_data VALUES (27043, 121, 138695, 18, 8326, 115, 158);
INSERT INTO public.who_global_data VALUES (27044, 0, 131, 0, 2, 115, 67);
INSERT INTO public.who_global_data VALUES (27045, 339, 31173, 13, 943, 115, 57);
INSERT INTO public.who_global_data VALUES (27046, 0, 5039, 0, 20, 115, 38);
INSERT INTO public.who_global_data VALUES (27047, 8429, 5103408, 201, 150689, 115, 141);
INSERT INTO public.who_global_data VALUES (27048, 0, 71, 0, 1, 115, 178);
INSERT INTO public.who_global_data VALUES (27049, 0, 146, 0, 3, 115, 108);
INSERT INTO public.who_global_data VALUES (27050, 785, 25774, 8, 923, 115, 39);
INSERT INTO public.who_global_data VALUES (27051, 0, 2280, 0, 63, 115, 2);
INSERT INTO public.who_global_data VALUES (27052, 0, 529, 0, 1, 115, 195);
INSERT INTO public.who_global_data VALUES (27053, 99, 7254, 2, 77, 115, 107);
INSERT INTO public.who_global_data VALUES (27054, 0, 283, 0, 0, 115, 161);
INSERT INTO public.who_global_data VALUES (27055, 108, 21441, 0, 423, 115, 212);
INSERT INTO public.who_global_data VALUES (27056, 975, 182839, 14, 9627, 115, 181);
INSERT INTO public.who_global_data VALUES (27057, 0, 221, 0, 1, 115, 53);
INSERT INTO public.who_global_data VALUES (27058, 0, 4855, 0, 62, 115, 164);
INSERT INTO public.who_global_data VALUES (27059, 13, 1321, 0, 92, 115, 140);
INSERT INTO public.who_global_data VALUES (27060, 1392, 484280, 17, 13396, 115, 20);
INSERT INTO public.who_global_data VALUES (27061, 28, 91387, 0, 4746, 115, 112);
INSERT INTO public.who_global_data VALUES (27062, 7767, 919083, 151, 27985, 115, 111);
INSERT INTO public.who_global_data VALUES (27063, 1, 496, 0, 7, 115, 71);
INSERT INTO public.who_global_data VALUES (27064, 38, 5156, 2, 92, 115, 218);
INSERT INTO public.who_global_data VALUES (27065, 0, 0, 0, 0, 115, 43);
INSERT INTO public.who_global_data VALUES (27066, 733, 89223, 18, 1108, 115, 49);
INSERT INTO public.who_global_data VALUES (27067, 29, 20183, 0, 120, 115, 1);
INSERT INTO public.who_global_data VALUES (27068, 372, 20993, 3, 330, 115, 48);
INSERT INTO public.who_global_data VALUES (27069, 17, 6017, 0, 123, 115, 232);
INSERT INTO public.who_global_data VALUES (27070, 2, 585, 0, 1, 115, 175);
INSERT INTO public.who_global_data VALUES (27071, 0, 2047, 0, 25, 115, 21);
INSERT INTO public.who_global_data VALUES (27072, 8326, 129747, 55, 1106, 115, 156);
INSERT INTO public.who_global_data VALUES (27073, 0, 0, 0, 0, 115, 95);
INSERT INTO public.who_global_data VALUES (27074, 4, 10871, 0, 276, 115, 177);
INSERT INTO public.who_global_data VALUES (27075, 290, 33101, 3, 674, 115, 210);
INSERT INTO public.who_global_data VALUES (27076, 2, 5428, 0, 61, 115, 120);
INSERT INTO public.who_global_data VALUES (27077, 0, 32, 0, 0, 115, 135);
INSERT INTO public.who_global_data VALUES (27078, 165, 119008, 4, 2183, 115, 206);
INSERT INTO public.who_global_data VALUES (27079, 856, 148171, 17, 12235, 115, 189);
INSERT INTO public.who_global_data VALUES (27080, 139, 104787, 9, 6071, 115, 129);
INSERT INTO public.who_global_data VALUES (27081, 284, 30480, 5, 899, 115, 121);
INSERT INTO public.who_global_data VALUES (27082, 0, 5066, 0, 83, 115, 59);
INSERT INTO public.who_global_data VALUES (27083, 0, 414, 0, 0, 115, 96);
INSERT INTO public.who_global_data VALUES (27084, 25, 3908, 0, 68, 115, 41);
INSERT INTO public.who_global_data VALUES (27085, 13, 5696, 1, 114, 115, 216);
INSERT INTO public.who_global_data VALUES (27086, 582, 85718, 4, 1305, 115, 236);
INSERT INTO public.who_global_data VALUES (27087, 0, 13, 0, 0, 115, 150);
INSERT INTO public.who_global_data VALUES (27088, 0, 477, 0, 0, 115, 61);
INSERT INTO public.who_global_data VALUES (27089, 0, 32, 0, 2, 115, 7);
INSERT INTO public.who_global_data VALUES (27090, 287, 12499, 0, 346, 115, 169);
INSERT INTO public.who_global_data VALUES (27091, 12981, 728745, 108, 32679, 115, 28);
INSERT INTO public.who_global_data VALUES (27092, 12, 10192, 0, 69, 115, 85);
INSERT INTO public.who_global_data VALUES (27093, 0, 3251, 0, 11, 115, 211);
INSERT INTO public.who_global_data VALUES (27094, 0, 8860, 0, 54, 115, 60);
INSERT INTO public.who_global_data VALUES (27095, 4, 3636, 1, 118, 115, 3);
INSERT INTO public.who_global_data VALUES (27096, 680, 13521, 7, 109, 115, 11);
INSERT INTO public.who_global_data VALUES (27097, 5132, 334585, 43, 9677, 115, 89);
INSERT INTO public.who_global_data VALUES (27098, 92, 47097, 2, 308, 115, 24);
INSERT INTO public.who_global_data VALUES (27099, 1, 486, 0, 0, 115, 162);
INSERT INTO public.who_global_data VALUES (27100, 408, 23060, 6, 462, 115, 100);
INSERT INTO public.who_global_data VALUES (27101, 0, 16, 0, 0, 115, 47);
INSERT INTO public.who_global_data VALUES (27102, 1, 25, 0, 0, 115, 29);
INSERT INTO public.who_global_data VALUES (27103, 0, 6483, 0, 95, 115, 40);
INSERT INTO public.who_global_data VALUES (27104, 96, 3266, 1, 61, 115, 222);
INSERT INTO public.who_global_data VALUES (27105, 554, 98380, 23, 3410, 115, 132);
INSERT INTO public.who_global_data VALUES (27106, 0, 258, 0, 13, 115, 130);
INSERT INTO public.who_global_data VALUES (27107, 72, 11134, 0, 70, 115, 234);
INSERT INTO public.who_global_data VALUES (27108, 0, 2385, 0, 40, 115, 23);
INSERT INTO public.who_global_data VALUES (27109, 52, 3521, 1, 104, 115, 192);
INSERT INTO public.who_global_data VALUES (27110, 5, 8887, 0, 230, 115, 69);
INSERT INTO public.who_global_data VALUES (27111, 0, 19, 0, 0, 115, 187);
INSERT INTO public.who_global_data VALUES (27112, 332, 84413, 9, 2521, 115, 230);
INSERT INTO public.who_global_data VALUES (27113, 920, 40782, 27, 1023, 115, 77);
INSERT INTO public.who_global_data VALUES (27114, 86, 3668, 0, 10, 115, 9);
INSERT INTO public.who_global_data VALUES (27115, 63509, 7239389, 730, 110586, 115, 74);
INSERT INTO public.who_global_data VALUES (27116, 3906, 340622, 92, 12027, 115, 224);
INSERT INTO public.who_global_data VALUES (27117, 4108, 508389, 254, 29070, 115, 199);
INSERT INTO public.who_global_data VALUES (27118, 3921, 409358, 58, 9970, 115, 190);
INSERT INTO public.who_global_data VALUES (27119, 808, 44159, 3, 1830, 115, 12);
INSERT INTO public.who_global_data VALUES (27120, 0, 346, 0, 24, 115, 104);
INSERT INTO public.who_global_data VALUES (27121, 3169, 294798, 30, 2046, 115, 153);
INSERT INTO public.who_global_data VALUES (27122, 5898, 365467, 41, 36246, 115, 91);
INSERT INTO public.who_global_data VALUES (27123, 97, 7910, 0, 146, 115, 215);
INSERT INTO public.who_global_data VALUES (27124, 467, 90140, 4, 1638, 115, 84);
INSERT INTO public.who_global_data VALUES (27125, 30, 479, 0, 32, 115, 231);
INSERT INTO public.who_global_data VALUES (27126, 2054, 28195, 18, 225, 115, 196);
INSERT INTO public.who_global_data VALUES (27127, 269, 144487, 0, 2136, 115, 105);
INSERT INTO public.who_global_data VALUES (27128, 320, 41939, 10, 787, 115, 122);
INSERT INTO public.who_global_data VALUES (27129, 0, 0, 0, 0, 115, 159);
INSERT INTO public.who_global_data VALUES (27130, 98, 16302, 1, 639, 115, 75);
INSERT INTO public.who_global_data VALUES (27131, 844, 112737, 8, 672, 115, 27);
INSERT INTO public.who_global_data VALUES (27132, 330, 50201, 2, 1094, 115, 54);
INSERT INTO public.who_global_data VALUES (27133, 0, 23, 0, 0, 115, 226);
INSERT INTO public.who_global_data VALUES (27134, 75, 2840, 1, 41, 115, 79);
INSERT INTO public.who_global_data VALUES (27135, 1245, 55869, 13, 479, 115, 56);
INSERT INTO public.who_global_data VALUES (27136, 0, 1805, 0, 42, 115, 117);
INSERT INTO public.who_global_data VALUES (27137, 2, 1372, 0, 82, 115, 152);
INSERT INTO public.who_global_data VALUES (27138, 836, 45821, 13, 669, 115, 16);
INSERT INTO public.who_global_data VALUES (27139, 13, 177, 0, 1, 115, 10);
INSERT INTO public.who_global_data VALUES (27140, 137, 6497, 4, 94, 115, 201);
INSERT INTO public.who_global_data VALUES (27141, 109, 9840, 0, 133, 115, 174);
INSERT INTO public.who_global_data VALUES (27142, 28, 16754, 0, 237, 115, 119);
INSERT INTO public.who_global_data VALUES (27143, 3, 5827, 1, 181, 115, 168);
INSERT INTO public.who_global_data VALUES (27144, 660, 16880, 4, 163, 115, 99);
INSERT INTO public.who_global_data VALUES (27145, 50, 10993, 0, 35, 115, 171);
INSERT INTO public.who_global_data VALUES (27146, 1, 3297, 0, 132, 115, 87);
INSERT INTO public.who_global_data VALUES (27147, 111, 4040, 0, 44, 115, 123);
INSERT INTO public.who_global_data VALUES (27148, 0, 0, 0, 0, 115, 151);
INSERT INTO public.who_global_data VALUES (27149, 0, 1851, 0, 22, 115, 213);
INSERT INTO public.who_global_data VALUES (27150, 11, 7565, 0, 163, 115, 118);
INSERT INTO public.who_global_data VALUES (27151, 0, 404, 0, 10, 115, 134);
INSERT INTO public.who_global_data VALUES (27152, 0, 4030, 0, 43, 115, 65);
INSERT INTO public.who_global_data VALUES (27153, 3542, 821045, 164, 83945, 115, 102);
INSERT INTO public.who_global_data VALUES (27154, 0, 0, 0, 0, 115, 223);
INSERT INTO public.who_global_data VALUES (27155, 5, 244, 0, 2, 115, 4);
INSERT INTO public.who_global_data VALUES (27156, 2, 320, 0, 0, 115, 146);
INSERT INTO public.who_global_data VALUES (27157, 319, 15053, 4, 219, 115, 31);
INSERT INTO public.who_global_data VALUES (27158, 0, 13, 0, 1, 115, 127);
INSERT INTO public.who_global_data VALUES (27159, 3185, 156946, 49, 2685, 115, 22);
INSERT INTO public.who_global_data VALUES (27160, 170, 10258, 1, 73, 115, 115);
INSERT INTO public.who_global_data VALUES (27161, 1123, 30437, 29, 693, 115, 106);
INSERT INTO public.who_global_data VALUES (27162, 11, 12000, 0, 129, 115, 90);
INSERT INTO public.who_global_data VALUES (27163, 0, 0, 0, 0, 115, 70);
INSERT INTO public.who_global_data VALUES (27164, 3556, 115358, 18, 663, 115, 46);
INSERT INTO public.who_global_data VALUES (27165, 7336, 188364, 33, 6626, 115, 139);
INSERT INTO public.who_global_data VALUES (27166, 0, 27, 0, 0, 115, 42);
INSERT INTO public.who_global_data VALUES (27167, 2, 1518, 0, 25, 115, 80);
INSERT INTO public.who_global_data VALUES (27168, 72, 4297, 1, 154, 115, 203);
INSERT INTO public.who_global_data VALUES (27169, 0, 1201, 0, 69, 115, 136);
INSERT INTO public.who_global_data VALUES (27170, 225, 60655, 1, 1116, 115, 63);
INSERT INTO public.who_global_data VALUES (27171, 0, 0, 0, 0, 115, 17);
INSERT INTO public.who_global_data VALUES (27172, 0, 77, 0, 2, 115, 172);
INSERT INTO public.who_global_data VALUES (27173, 80, 21193, 3, 800, 115, 109);
INSERT INTO public.who_global_data VALUES (27174, 115, 15639, 1, 277, 115, 200);
INSERT INTO public.who_global_data VALUES (27175, 516, 56467, 4, 459, 115, 93);
INSERT INTO public.who_global_data VALUES (27176, 638, 107213, 7, 1053, 115, 5);
INSERT INTO public.who_global_data VALUES (27177, 0, 741, 0, 13, 115, 214);
INSERT INTO public.who_global_data VALUES (27178, 615, 320463, 13, 6601, 115, 204);
INSERT INTO public.who_global_data VALUES (27179, 0, 0, 0, 0, 115, 198);
INSERT INTO public.who_global_data VALUES (27180, 489, 120802, 11, 2502, 115, 173);
INSERT INTO public.who_global_data VALUES (27181, 0, 565, 0, 7, 115, 229);
INSERT INTO public.who_global_data VALUES (27182, 669, 50344, 19, 1096, 115, 76);
INSERT INTO public.who_global_data VALUES (27183, 1800, 851171, 52, 33357, 115, 138);
INSERT INTO public.who_global_data VALUES (27184, 1897, 344713, 40, 6372, 115, 98);
INSERT INTO public.who_global_data VALUES (27185, 0, 0, 0, 0, 115, 103);
INSERT INTO public.who_global_data VALUES (27186, 5068, 135278, 62, 3101, 115, 225);
INSERT INTO public.who_global_data VALUES (27187, 1208, 89121, 16, 2110, 115, 131);
INSERT INTO public.who_global_data VALUES (27188, 306, 54540, 3, 738, 115, 235);
INSERT INTO public.who_global_data VALUES (27189, 214, 128405, 0, 220, 115, 137);
INSERT INTO public.who_global_data VALUES (27190, 73, 24878, 4, 438, 115, 81);
INSERT INTO public.who_global_data VALUES (27191, 657, 63275, 17, 1495, 115, 182);
INSERT INTO public.who_global_data VALUES (27192, 0, 4624, 0, 17, 115, 145);
INSERT INTO public.who_global_data VALUES (27193, 3109, 160461, 68, 5535, 115, 26);
INSERT INTO public.who_global_data VALUES (27194, 14231, 1340409, 239, 23205, 115, 170);
INSERT INTO public.who_global_data VALUES (27195, 3, 4908, 0, 32, 115, 191);
INSERT INTO public.who_global_data VALUES (27196, 0, 5, 0, 0, 115, 221);
INSERT INTO public.who_global_data VALUES (27197, 0, 65, 0, 0, 115, 64);
INSERT INTO public.who_global_data VALUES (27198, 0, 0, 0, 0, 115, 116);
INSERT INTO public.who_global_data VALUES (27199, 0, 19, 0, 0, 115, 128);
INSERT INTO public.who_global_data VALUES (27200, 0, 29, 0, 0, 115, 6);
INSERT INTO public.who_global_data VALUES (27201, 0, 466, 0, 8, 115, 227);
INSERT INTO public.who_global_data VALUES (27202, 0, 12, 0, 0, 115, 68);
INSERT INTO public.who_global_data VALUES (27203, 0, 64, 0, 0, 115, 184);
INSERT INTO public.who_global_data VALUES (27204, 0, 0, 0, 0, 115, 82);
INSERT INTO public.who_global_data VALUES (27205, 6, 772, 0, 42, 115, 149);
INSERT INTO public.who_global_data VALUES (27206, 0, 929, 0, 15, 115, 197);
INSERT INTO public.who_global_data VALUES (27207, 474, 340089, 19, 5087, 115, 78);
INSERT INTO public.who_global_data VALUES (27208, 15, 15307, 0, 315, 115, 233);
INSERT INTO public.who_global_data VALUES (27209, 152, 35006, 2, 767, 115, 133);
INSERT INTO public.who_global_data VALUES (27210, 0, 147, 0, 0, 115, 35);
INSERT INTO public.who_global_data VALUES (27211, 3, 2309, 0, 72, 115, 114);
INSERT INTO public.who_global_data VALUES (27212, 4, 57884, 0, 28, 115, 237);
INSERT INTO public.who_global_data VALUES (27213, 0, 14, 0, 0, 115, 55);
INSERT INTO public.who_global_data VALUES (27214, 0, 710, 0, 22, 115, 176);
INSERT INTO public.who_global_data VALUES (27215, 531, 20886, 0, 61, 115, 202);
INSERT INTO public.who_global_data VALUES (27216, 707, 9940, 5, 186, 115, 155);
INSERT INTO public.who_global_data VALUES (27217, 0, 2, 0, 0, 115, 32);
INSERT INTO public.who_global_data VALUES (27218, 0, 3864, 0, 99, 115, 220);
INSERT INTO public.who_global_data VALUES (27219, 1178, 694537, 165, 18028, 115, 30);
INSERT INTO public.who_global_data VALUES (27220, 0, 2798, 0, 55, 115, 147);
INSERT INTO public.who_global_data VALUES (27221, 6401, 945902, 125, 35608, 115, 208);
INSERT INTO public.who_global_data VALUES (27222, 194, 5038, 0, 13, 115, 45);
INSERT INTO public.who_global_data VALUES (27223, 6, 13697, 0, 836, 115, 110);
INSERT INTO public.who_global_data VALUES (27224, 7, 5058, 0, 107, 115, 88);
INSERT INTO public.who_global_data VALUES (27225, 637, 100715, 3, 5918, 115, 51);
INSERT INTO public.who_global_data VALUES (27226, 2687, 70140, 6, 1855, 115, 209);
INSERT INTO public.who_global_data VALUES (27227, 52, 4826, 3, 231, 115, 205);
INSERT INTO public.who_global_data VALUES (27228, 37, 10297, 0, 79, 115, 18);
INSERT INTO public.who_global_data VALUES (27229, 9, 3652, 0, 59, 115, 72);
INSERT INTO public.who_global_data VALUES (27230, 17232, 634924, 143, 43018, 115, 44);
INSERT INTO public.who_global_data VALUES (27231, 0, 29, 0, 0, 115, 15);
INSERT INTO public.who_global_data VALUES (27232, 23, 1972, 1, 50, 115, 25);
INSERT INTO public.who_global_data VALUES (27233, 0, 0, 0, 0, 115, 179);
INSERT INTO public.who_global_data VALUES (27234, 0, 0, 0, 0, 115, 34);
INSERT INTO public.who_global_data VALUES (27235, 15, 5116, 2, 92, 115, 207);
INSERT INTO public.who_global_data VALUES (27236, 0, 34790, 0, 512, 115, 166);
INSERT INTO public.who_global_data VALUES (27237, 8362, 863719, 62, 8957, 115, 126);
INSERT INTO public.who_global_data VALUES (27238, 0, 0, 0, 0, 115, 97);
INSERT INTO public.who_global_data VALUES (27239, 0, 696, 0, 6, 115, 36);
INSERT INTO public.who_global_data VALUES (27240, 0, 0, 0, 0, 115, 125);
INSERT INTO public.who_global_data VALUES (27241, 81, 9945, 1, 95, 115, 124);
INSERT INTO public.who_global_data VALUES (27242, 5590, 276177, 107, 5229, 115, 185);
INSERT INTO public.who_global_data VALUES (27243, 1315, 108608, 2, 448, 115, 194);
INSERT INTO public.who_global_data VALUES (27244, 0, 509, 0, 21, 115, 144);
INSERT INTO public.who_global_data VALUES (27245, 46308, 7728436, 335, 213626, 115, 19);
INSERT INTO public.who_global_data VALUES (27246, 0, 1325, 0, 20, 115, 217);
INSERT INTO public.who_global_data VALUES (27247, 19, 2313, 1, 51, 115, 148);
INSERT INTO public.who_global_data VALUES (27248, 325, 61859, 2, 512, 115, 86);
INSERT INTO public.who_global_data VALUES (27249, 0, 0, 0, 0, 115, 13);
INSERT INTO public.who_global_data VALUES (27250, 619, 83756, 7, 704, 115, 157);
INSERT INTO public.who_global_data VALUES (27251, 3, 1113, 0, 35, 115, 8);
INSERT INTO public.who_global_data VALUES (27252, 0, 0, 0, 0, 115, 73);
INSERT INTO public.who_global_data VALUES (27253, 1, 2057, 0, 597, 115, 101);
INSERT INTO public.who_global_data VALUES (27254, 0, 15549, 0, 344, 115, 165);
INSERT INTO public.who_global_data VALUES (27255, 15, 8036, 0, 230, 115, 14);
INSERT INTO public.who_global_data VALUES (27256, 58, 40014, 1, 1484, 116, 193);
INSERT INTO public.who_global_data VALUES (27257, 171, 15570, 4, 424, 116, 113);
INSERT INTO public.who_global_data VALUES (27258, 153, 53225, 8, 1809, 116, 143);
INSERT INTO public.who_global_data VALUES (27259, 0, 0, 0, 0, 116, 219);
INSERT INTO public.who_global_data VALUES (27260, 299, 2995, 2, 57, 116, 186);
INSERT INTO public.who_global_data VALUES (27261, 122, 6488, 1, 219, 116, 52);
INSERT INTO public.who_global_data VALUES (27262, 0, 3, 0, 0, 116, 180);
INSERT INTO public.who_global_data VALUES (27263, 0, 111, 0, 3, 116, 167);
INSERT INTO public.who_global_data VALUES (27264, 10324, 894206, 287, 23868, 116, 154);
INSERT INTO public.who_global_data VALUES (27265, 745, 56879, 6, 1027, 116, 94);
INSERT INTO public.who_global_data VALUES (27266, 44, 4194, 1, 32, 116, 66);
INSERT INTO public.who_global_data VALUES (27267, 22, 27286, 0, 898, 116, 58);
INSERT INTO public.who_global_data VALUES (27268, 608, 56591, 5, 869, 116, 163);
INSERT INTO public.who_global_data VALUES (27269, 122, 42104, 0, 609, 116, 37);
INSERT INTO public.who_global_data VALUES (27270, 55, 5078, 1, 107, 116, 142);
INSERT INTO public.who_global_data VALUES (27271, 334, 75948, 5, 280, 116, 83);
INSERT INTO public.who_global_data VALUES (27272, 1472, 379738, 31, 5555, 116, 228);
INSERT INTO public.who_global_data VALUES (27273, 2, 208, 0, 7, 116, 188);
INSERT INTO public.who_global_data VALUES (27274, 464, 83998, 5, 901, 116, 62);
INSERT INTO public.who_global_data VALUES (27275, 9736, 184141, 36, 10245, 116, 160);
INSERT INTO public.who_global_data VALUES (27276, 35, 2531, 1, 37, 116, 50);
INSERT INTO public.who_global_data VALUES (27277, 0, 2411, 0, 41, 116, 33);
INSERT INTO public.who_global_data VALUES (27278, 0, 184, 0, 9, 116, 183);
INSERT INTO public.who_global_data VALUES (27279, 0, 309, 0, 0, 116, 92);
INSERT INTO public.who_global_data VALUES (27280, 111, 138574, 16, 8308, 116, 158);
INSERT INTO public.who_global_data VALUES (27281, 0, 131, 0, 2, 116, 67);
INSERT INTO public.who_global_data VALUES (27282, 189, 30834, 9, 930, 116, 57);
INSERT INTO public.who_global_data VALUES (27283, 1820, 5039, 2, 20, 116, 38);
INSERT INTO public.who_global_data VALUES (27284, 12342, 5094979, 290, 150488, 116, 141);
INSERT INTO public.who_global_data VALUES (27285, 0, 71, 0, 1, 116, 178);
INSERT INTO public.who_global_data VALUES (27286, 0, 146, 0, 3, 116, 108);
INSERT INTO public.who_global_data VALUES (27287, 587, 24989, 23, 915, 116, 39);
INSERT INTO public.who_global_data VALUES (27288, 39, 2280, 3, 63, 116, 2);
INSERT INTO public.who_global_data VALUES (27289, 4, 529, 0, 1, 116, 195);
INSERT INTO public.who_global_data VALUES (27290, 83, 7155, 0, 75, 116, 107);
INSERT INTO public.who_global_data VALUES (27291, 0, 283, 0, 0, 116, 161);
INSERT INTO public.who_global_data VALUES (27292, 173, 21333, 3, 423, 116, 212);
INSERT INTO public.who_global_data VALUES (27293, 1685, 181864, 5, 9613, 116, 181);
INSERT INTO public.who_global_data VALUES (27294, 0, 221, 0, 1, 116, 53);
INSERT INTO public.who_global_data VALUES (27295, 1, 4855, 0, 62, 116, 164);
INSERT INTO public.who_global_data VALUES (27296, 4, 1308, 0, 92, 116, 140);
INSERT INTO public.who_global_data VALUES (27297, 1517, 482888, 61, 13379, 116, 20);
INSERT INTO public.who_global_data VALUES (27298, 26, 91359, 0, 4746, 116, 112);
INSERT INTO public.who_global_data VALUES (27299, 8569, 911316, 174, 27834, 116, 111);
INSERT INTO public.who_global_data VALUES (27300, 0, 495, 0, 7, 116, 71);
INSERT INTO public.who_global_data VALUES (27301, 0, 5118, 0, 90, 116, 218);
INSERT INTO public.who_global_data VALUES (27302, 0, 0, 0, 0, 116, 43);
INSERT INTO public.who_global_data VALUES (27303, 1051, 88490, 14, 1090, 116, 49);
INSERT INTO public.who_global_data VALUES (27304, 118, 20154, 0, 120, 116, 1);
INSERT INTO public.who_global_data VALUES (27305, 181, 20621, 3, 327, 116, 48);
INSERT INTO public.who_global_data VALUES (27306, 22, 6000, 0, 123, 116, 232);
INSERT INTO public.who_global_data VALUES (27307, 51, 583, 0, 1, 116, 175);
INSERT INTO public.who_global_data VALUES (27308, 61, 2047, 0, 25, 116, 21);
INSERT INTO public.who_global_data VALUES (27309, 4311, 121421, 17, 1051, 116, 156);
INSERT INTO public.who_global_data VALUES (27310, 0, 0, 0, 0, 116, 95);
INSERT INTO public.who_global_data VALUES (27311, 27, 10867, 0, 276, 116, 177);
INSERT INTO public.who_global_data VALUES (27312, 389, 32811, 2, 671, 116, 210);
INSERT INTO public.who_global_data VALUES (27313, 2, 5426, 0, 61, 116, 120);
INSERT INTO public.who_global_data VALUES (27314, 0, 32, 0, 0, 116, 135);
INSERT INTO public.who_global_data VALUES (27315, 366, 118843, 6, 2179, 116, 206);
INSERT INTO public.who_global_data VALUES (27316, 487, 147315, 30, 12218, 116, 189);
INSERT INTO public.who_global_data VALUES (27317, 132, 104648, 10, 6062, 116, 129);
INSERT INTO public.who_global_data VALUES (27318, 0, 30196, 4, 894, 116, 121);
INSERT INTO public.who_global_data VALUES (27319, 3, 5066, 0, 83, 116, 59);
INSERT INTO public.who_global_data VALUES (27320, 0, 414, 0, 0, 116, 96);
INSERT INTO public.who_global_data VALUES (27321, 18, 3883, 0, 68, 116, 41);
INSERT INTO public.who_global_data VALUES (27322, 14, 5683, 0, 113, 116, 216);
INSERT INTO public.who_global_data VALUES (27323, 841, 85136, 14, 1301, 116, 236);
INSERT INTO public.who_global_data VALUES (27324, 0, 13, 0, 0, 116, 150);
INSERT INTO public.who_global_data VALUES (27325, 0, 477, 0, 0, 116, 61);
INSERT INTO public.who_global_data VALUES (27326, 0, 32, 0, 2, 116, 7);
INSERT INTO public.who_global_data VALUES (27327, 214, 12212, 0, 346, 116, 169);
INSERT INTO public.who_global_data VALUES (27328, 8295, 715764, 94, 32571, 116, 28);
INSERT INTO public.who_global_data VALUES (27329, 36, 10180, 0, 69, 116, 85);
INSERT INTO public.who_global_data VALUES (27330, 497, 3251, 1, 11, 116, 211);
INSERT INTO public.who_global_data VALUES (27331, 45, 8860, 0, 54, 116, 60);
INSERT INTO public.who_global_data VALUES (27332, 4, 3632, 0, 117, 116, 3);
INSERT INTO public.who_global_data VALUES (27333, 569, 12841, 11, 102, 116, 11);
INSERT INTO public.who_global_data VALUES (27334, 4122, 329453, 13, 9634, 116, 89);
INSERT INTO public.who_global_data VALUES (27335, 0, 47005, 0, 306, 116, 24);
INSERT INTO public.who_global_data VALUES (27336, 9, 485, 0, 0, 116, 162);
INSERT INTO public.who_global_data VALUES (27337, 294, 22652, 7, 456, 116, 100);
INSERT INTO public.who_global_data VALUES (27338, 0, 16, 0, 0, 116, 47);
INSERT INTO public.who_global_data VALUES (27339, 0, 24, 0, 0, 116, 29);
INSERT INTO public.who_global_data VALUES (27340, 0, 6483, 0, 95, 116, 40);
INSERT INTO public.who_global_data VALUES (27341, 92, 3170, 0, 60, 116, 222);
INSERT INTO public.who_global_data VALUES (27342, 111, 97826, 3, 3387, 116, 132);
INSERT INTO public.who_global_data VALUES (27343, 0, 258, 0, 13, 116, 130);
INSERT INTO public.who_global_data VALUES (27344, 40, 11062, 1, 70, 116, 234);
INSERT INTO public.who_global_data VALUES (27345, 0, 2385, 0, 40, 116, 23);
INSERT INTO public.who_global_data VALUES (27346, 64, 3469, 1, 103, 116, 192);
INSERT INTO public.who_global_data VALUES (27347, 0, 8882, 0, 230, 116, 69);
INSERT INTO public.who_global_data VALUES (27348, 7, 19, 0, 0, 116, 187);
INSERT INTO public.who_global_data VALUES (27349, 935, 84081, 8, 2512, 116, 230);
INSERT INTO public.who_global_data VALUES (27350, 1285, 39862, 28, 996, 116, 77);
INSERT INTO public.who_global_data VALUES (27351, 56, 3582, 0, 10, 116, 9);
INSERT INTO public.who_global_data VALUES (27352, 55342, 7175880, 706, 109856, 116, 74);
INSERT INTO public.who_global_data VALUES (27353, 3267, 336716, 91, 11935, 116, 224);
INSERT INTO public.who_global_data VALUES (27354, 4206, 504281, 272, 28816, 116, 199);
INSERT INTO public.who_global_data VALUES (27355, 3107, 405437, 60, 9912, 116, 190);
INSERT INTO public.who_global_data VALUES (27356, 823, 43351, 1, 1827, 116, 12);
INSERT INTO public.who_global_data VALUES (27357, 1, 346, 0, 24, 116, 104);
INSERT INTO public.who_global_data VALUES (27358, 1646, 291629, 46, 2016, 116, 153);
INSERT INTO public.who_global_data VALUES (27359, 4619, 359569, 39, 36205, 116, 91);
INSERT INTO public.who_global_data VALUES (27360, 95, 7813, 7, 146, 116, 215);
INSERT INTO public.who_global_data VALUES (27361, 326, 89673, 5, 1634, 116, 84);
INSERT INTO public.who_global_data VALUES (27362, 0, 449, 0, 32, 116, 231);
INSERT INTO public.who_global_data VALUES (27363, 1147, 26141, 16, 207, 116, 196);
INSERT INTO public.who_global_data VALUES (27364, 404, 144218, 0, 2136, 116, 105);
INSERT INTO public.who_global_data VALUES (27365, 73, 41619, 11, 777, 116, 122);
INSERT INTO public.who_global_data VALUES (27366, 0, 0, 0, 0, 116, 159);
INSERT INTO public.who_global_data VALUES (27367, 68, 16204, 1, 638, 116, 75);
INSERT INTO public.who_global_data VALUES (27368, 777, 111893, 6, 664, 116, 27);
INSERT INTO public.who_global_data VALUES (27369, 343, 49871, 2, 1092, 116, 54);
INSERT INTO public.who_global_data VALUES (27370, 0, 23, 0, 0, 116, 226);
INSERT INTO public.who_global_data VALUES (27371, 95, 2765, 0, 40, 116, 79);
INSERT INTO public.who_global_data VALUES (27372, 1056, 54624, 7, 466, 116, 56);
INSERT INTO public.who_global_data VALUES (27373, 38, 1805, 2, 42, 116, 117);
INSERT INTO public.who_global_data VALUES (27374, 0, 1370, 0, 82, 116, 152);
INSERT INTO public.who_global_data VALUES (27375, 1164, 44985, 12, 656, 116, 16);
INSERT INTO public.who_global_data VALUES (27376, 14, 164, 0, 1, 116, 10);
INSERT INTO public.who_global_data VALUES (27377, 118, 6360, 1, 90, 116, 201);
INSERT INTO public.who_global_data VALUES (27378, 371, 9731, 3, 133, 116, 174);
INSERT INTO public.who_global_data VALUES (27379, 8, 16726, 0, 237, 116, 119);
INSERT INTO public.who_global_data VALUES (27380, 3, 5824, 0, 180, 116, 168);
INSERT INTO public.who_global_data VALUES (27381, 563, 16220, 2, 159, 116, 99);
INSERT INTO public.who_global_data VALUES (27382, 49, 10943, 0, 35, 116, 171);
INSERT INTO public.who_global_data VALUES (27383, 10, 3296, 0, 132, 116, 87);
INSERT INTO public.who_global_data VALUES (27384, 94, 3929, 1, 44, 116, 123);
INSERT INTO public.who_global_data VALUES (27385, 0, 0, 0, 0, 116, 151);
INSERT INTO public.who_global_data VALUES (27386, 0, 1851, 0, 22, 116, 213);
INSERT INTO public.who_global_data VALUES (27387, 4, 7554, 0, 163, 116, 118);
INSERT INTO public.who_global_data VALUES (27388, 9, 404, 0, 10, 116, 134);
INSERT INTO public.who_global_data VALUES (27389, 41, 4030, 0, 43, 116, 65);
INSERT INTO public.who_global_data VALUES (27390, 3175, 817503, 139, 83781, 116, 102);
INSERT INTO public.who_global_data VALUES (27391, 0, 0, 0, 0, 116, 223);
INSERT INTO public.who_global_data VALUES (27392, 2, 239, 0, 2, 116, 4);
INSERT INTO public.who_global_data VALUES (27393, 2, 318, 0, 0, 116, 146);
INSERT INTO public.who_global_data VALUES (27394, 462, 14734, 2, 215, 116, 31);
INSERT INTO public.who_global_data VALUES (27395, 0, 13, 0, 1, 116, 127);
INSERT INTO public.who_global_data VALUES (27396, 1357, 153761, 31, 2636, 116, 22);
INSERT INTO public.who_global_data VALUES (27397, 87, 10088, 1, 72, 116, 115);
INSERT INTO public.who_global_data VALUES (27398, 1340, 29314, 18, 664, 116, 106);
INSERT INTO public.who_global_data VALUES (27399, 53, 11989, 1, 129, 116, 90);
INSERT INTO public.who_global_data VALUES (27400, 0, 0, 0, 0, 116, 70);
INSERT INTO public.who_global_data VALUES (27401, 4047, 111802, 9, 645, 116, 46);
INSERT INTO public.who_global_data VALUES (27402, 6804, 181028, 13, 6593, 116, 139);
INSERT INTO public.who_global_data VALUES (27403, 0, 27, 0, 0, 116, 42);
INSERT INTO public.who_global_data VALUES (27404, 1, 1516, 0, 25, 116, 80);
INSERT INTO public.who_global_data VALUES (27405, 0, 4225, 0, 153, 116, 203);
INSERT INTO public.who_global_data VALUES (27406, 0, 1201, 0, 69, 116, 136);
INSERT INTO public.who_global_data VALUES (27407, 164, 60430, 0, 1115, 116, 63);
INSERT INTO public.who_global_data VALUES (27408, 0, 0, 0, 0, 116, 17);
INSERT INTO public.who_global_data VALUES (27409, 0, 77, 0, 2, 116, 172);
INSERT INTO public.who_global_data VALUES (27410, 176, 21113, 5, 797, 116, 109);
INSERT INTO public.who_global_data VALUES (27411, 303, 15524, 1, 276, 116, 200);
INSERT INTO public.who_global_data VALUES (27412, 395, 55951, 10, 455, 116, 93);
INSERT INTO public.who_global_data VALUES (27413, 685, 106575, 8, 1046, 116, 5);
INSERT INTO public.who_global_data VALUES (27414, 0, 741, 0, 13, 116, 214);
INSERT INTO public.who_global_data VALUES (27415, 531, 319848, 8, 6588, 116, 204);
INSERT INTO public.who_global_data VALUES (27416, 0, 0, 0, 0, 116, 198);
INSERT INTO public.who_global_data VALUES (27417, 647, 120313, 9, 2491, 116, 173);
INSERT INTO public.who_global_data VALUES (27418, 11, 565, 0, 7, 116, 229);
INSERT INTO public.who_global_data VALUES (27419, 697, 49675, 12, 1077, 116, 76);
INSERT INTO public.who_global_data VALUES (27420, 3283, 849371, 82, 33305, 116, 138);
INSERT INTO public.who_global_data VALUES (27421, 3475, 342816, 11, 6332, 116, 98);
INSERT INTO public.who_global_data VALUES (27422, 0, 0, 0, 0, 116, 103);
INSERT INTO public.who_global_data VALUES (27423, 4394, 130210, 35, 3039, 116, 225);
INSERT INTO public.who_global_data VALUES (27424, 1249, 87913, 14, 2094, 116, 131);
INSERT INTO public.who_global_data VALUES (27425, 563, 54234, 5, 735, 116, 235);
INSERT INTO public.who_global_data VALUES (27426, 206, 128191, 0, 220, 116, 137);
INSERT INTO public.who_global_data VALUES (27427, 102, 24805, 1, 434, 116, 81);
INSERT INTO public.who_global_data VALUES (27428, 467, 62618, 17, 1478, 116, 182);
INSERT INTO public.who_global_data VALUES (27429, 133, 4624, 1, 17, 116, 145);
INSERT INTO public.who_global_data VALUES (27430, 2069, 157352, 56, 5467, 116, 26);
INSERT INTO public.who_global_data VALUES (27431, 13868, 1326178, 244, 22966, 116, 170);
INSERT INTO public.who_global_data VALUES (27432, 9, 4905, 1, 32, 116, 191);
INSERT INTO public.who_global_data VALUES (27433, 0, 5, 0, 0, 116, 221);
INSERT INTO public.who_global_data VALUES (27434, 0, 65, 0, 0, 116, 64);
INSERT INTO public.who_global_data VALUES (27435, 0, 0, 0, 0, 116, 116);
INSERT INTO public.who_global_data VALUES (27436, 0, 19, 0, 0, 116, 128);
INSERT INTO public.who_global_data VALUES (27437, 0, 29, 0, 0, 116, 6);
INSERT INTO public.who_global_data VALUES (27438, 0, 466, 0, 8, 116, 227);
INSERT INTO public.who_global_data VALUES (27439, 0, 12, 0, 0, 116, 68);
INSERT INTO public.who_global_data VALUES (27440, 0, 64, 0, 0, 116, 184);
INSERT INTO public.who_global_data VALUES (27441, 0, 0, 0, 0, 116, 82);
INSERT INTO public.who_global_data VALUES (27442, 0, 766, 0, 42, 116, 149);
INSERT INTO public.who_global_data VALUES (27443, 0, 929, 0, 15, 116, 197);
INSERT INTO public.who_global_data VALUES (27444, 348, 339615, 25, 5068, 116, 78);
INSERT INTO public.who_global_data VALUES (27445, 79, 15292, 2, 315, 116, 233);
INSERT INTO public.who_global_data VALUES (27446, 67, 34854, 2, 765, 116, 133);
INSERT INTO public.who_global_data VALUES (27447, 0, 147, 0, 0, 116, 35);
INSERT INTO public.who_global_data VALUES (27448, 6, 2306, 0, 72, 116, 114);
INSERT INTO public.who_global_data VALUES (27449, 4, 57880, 1, 28, 116, 237);
INSERT INTO public.who_global_data VALUES (27450, 0, 14, 0, 0, 116, 55);
INSERT INTO public.who_global_data VALUES (27451, 11, 710, 0, 22, 116, 176);
INSERT INTO public.who_global_data VALUES (27452, 504, 20355, 0, 61, 116, 202);
INSERT INTO public.who_global_data VALUES (27453, 399, 9233, 3, 181, 116, 155);
INSERT INTO public.who_global_data VALUES (27454, 0, 2, 0, 0, 116, 32);
INSERT INTO public.who_global_data VALUES (27455, 0, 3864, 0, 99, 116, 220);
INSERT INTO public.who_global_data VALUES (27456, 888, 693359, 83, 17863, 116, 30);
INSERT INTO public.who_global_data VALUES (27457, 11, 2798, 0, 55, 116, 147);
INSERT INTO public.who_global_data VALUES (27458, 6925, 939501, 114, 35483, 116, 208);
INSERT INTO public.who_global_data VALUES (27459, 92, 4844, 0, 13, 116, 45);
INSERT INTO public.who_global_data VALUES (27460, 0, 13691, 0, 836, 116, 110);
INSERT INTO public.who_global_data VALUES (27461, 16, 5051, 0, 107, 116, 88);
INSERT INTO public.who_global_data VALUES (27462, 161, 100078, 2, 5915, 116, 51);
INSERT INTO public.who_global_data VALUES (27463, 2557, 67453, 5, 1849, 116, 209);
INSERT INTO public.who_global_data VALUES (27464, 56, 4774, 4, 228, 116, 205);
INSERT INTO public.who_global_data VALUES (27465, 38, 10260, 0, 79, 116, 18);
INSERT INTO public.who_global_data VALUES (27466, 2, 3643, 0, 59, 116, 72);
INSERT INTO public.who_global_data VALUES (27467, 13972, 617692, 50, 42875, 116, 44);
INSERT INTO public.who_global_data VALUES (27468, 1, 29, 0, 0, 116, 15);
INSERT INTO public.who_global_data VALUES (27469, 9, 1949, 0, 49, 116, 25);
INSERT INTO public.who_global_data VALUES (27470, 0, 0, 0, 0, 116, 179);
INSERT INTO public.who_global_data VALUES (27471, 0, 0, 0, 0, 116, 34);
INSERT INTO public.who_global_data VALUES (27472, 58, 5101, 0, 90, 116, 207);
INSERT INTO public.who_global_data VALUES (27473, 2234, 34790, 34, 512, 116, 166);
INSERT INTO public.who_global_data VALUES (27474, 8344, 855357, 58, 8895, 116, 126);
INSERT INTO public.who_global_data VALUES (27475, 0, 0, 0, 0, 116, 97);
INSERT INTO public.who_global_data VALUES (27476, 0, 696, 0, 6, 116, 36);
INSERT INTO public.who_global_data VALUES (27477, 0, 0, 0, 0, 116, 125);
INSERT INTO public.who_global_data VALUES (27478, 63, 9864, 1, 94, 116, 124);
INSERT INTO public.who_global_data VALUES (27479, 5133, 270587, 107, 5122, 116, 185);
INSERT INTO public.who_global_data VALUES (27480, 1064, 107293, 1, 446, 116, 194);
INSERT INTO public.who_global_data VALUES (27481, 0, 509, 0, 21, 116, 144);
INSERT INTO public.who_global_data VALUES (27482, 45325, 7682128, 487, 213291, 116, 19);
INSERT INTO public.who_global_data VALUES (27483, 0, 1325, 0, 20, 116, 217);
INSERT INTO public.who_global_data VALUES (27484, 26, 2294, 0, 50, 116, 148);
INSERT INTO public.who_global_data VALUES (27485, 329, 61534, 3, 510, 116, 86);
INSERT INTO public.who_global_data VALUES (27486, 0, 0, 0, 0, 116, 13);
INSERT INTO public.who_global_data VALUES (27487, 684, 83137, 6, 697, 116, 157);
INSERT INTO public.who_global_data VALUES (27488, 1, 1110, 0, 35, 116, 8);
INSERT INTO public.who_global_data VALUES (27489, 0, 0, 0, 0, 116, 73);
INSERT INTO public.who_global_data VALUES (27490, 0, 2056, 1, 597, 116, 101);
INSERT INTO public.who_global_data VALUES (27491, 91, 15549, 8, 344, 116, 165);
INSERT INTO public.who_global_data VALUES (27492, 10, 8021, 0, 230, 116, 14);
INSERT INTO public.who_global_data VALUES (27493, 71, 39956, 2, 1483, 117, 193);
INSERT INTO public.who_global_data VALUES (27494, 168, 15399, 4, 420, 117, 113);
INSERT INTO public.who_global_data VALUES (27495, 132, 53072, 6, 1801, 117, 143);
INSERT INTO public.who_global_data VALUES (27496, 0, 0, 0, 0, 117, 219);
INSERT INTO public.who_global_data VALUES (27497, 0, 2696, 0, 55, 117, 186);
INSERT INTO public.who_global_data VALUES (27498, 120, 6366, 0, 218, 117, 52);
INSERT INTO public.who_global_data VALUES (27499, 0, 3, 0, 0, 117, 180);
INSERT INTO public.who_global_data VALUES (27500, 0, 111, 0, 3, 117, 167);
INSERT INTO public.who_global_data VALUES (27501, 12414, 883882, 356, 23581, 117, 154);
INSERT INTO public.who_global_data VALUES (27502, 370, 56134, 6, 1021, 117, 94);
INSERT INTO public.who_global_data VALUES (27503, 0, 4150, 0, 31, 117, 66);
INSERT INTO public.who_global_data VALUES (27504, 20, 27264, 1, 898, 117, 58);
INSERT INTO public.who_global_data VALUES (27505, 1298, 55983, 6, 864, 117, 163);
INSERT INTO public.who_global_data VALUES (27506, 230, 41982, 1, 609, 117, 37);
INSERT INTO public.who_global_data VALUES (27507, 68, 5023, 0, 106, 117, 142);
INSERT INTO public.who_global_data VALUES (27508, 327, 75614, 2, 275, 117, 83);
INSERT INTO public.who_global_data VALUES (27509, 1193, 378266, 24, 5524, 117, 228);
INSERT INTO public.who_global_data VALUES (27510, 1, 206, 0, 7, 117, 188);
INSERT INTO public.who_global_data VALUES (27511, 511, 83534, 5, 896, 117, 62);
INSERT INTO public.who_global_data VALUES (27512, 2403, 174405, 26, 10209, 117, 160);
INSERT INTO public.who_global_data VALUES (27513, 69, 2496, 1, 36, 117, 50);
INSERT INTO public.who_global_data VALUES (27514, 0, 2411, 0, 41, 117, 33);
INSERT INTO public.who_global_data VALUES (27515, 0, 184, 0, 9, 117, 183);
INSERT INTO public.who_global_data VALUES (27516, 3, 309, 0, 0, 117, 92);
INSERT INTO public.who_global_data VALUES (27517, 237, 138463, 30, 8292, 117, 158);
INSERT INTO public.who_global_data VALUES (27518, 1, 131, 0, 2, 117, 67);
INSERT INTO public.who_global_data VALUES (27519, 302, 30645, 1, 921, 117, 57);
INSERT INTO public.who_global_data VALUES (27520, 0, 3219, 0, 18, 117, 38);
INSERT INTO public.who_global_data VALUES (27521, 26749, 5082637, 559, 150198, 117, 141);
INSERT INTO public.who_global_data VALUES (27522, 0, 71, 0, 1, 117, 178);
INSERT INTO public.who_global_data VALUES (27523, 0, 146, 0, 3, 117, 108);
INSERT INTO public.who_global_data VALUES (27524, 531, 24402, 5, 892, 117, 39);
INSERT INTO public.who_global_data VALUES (27525, 0, 2241, 0, 60, 117, 2);
INSERT INTO public.who_global_data VALUES (27526, 1, 525, 0, 1, 117, 195);
INSERT INTO public.who_global_data VALUES (27527, 159, 7072, 1, 75, 117, 107);
INSERT INTO public.who_global_data VALUES (27528, 0, 283, 0, 0, 117, 161);
INSERT INTO public.who_global_data VALUES (27529, 0, 21160, 0, 420, 117, 212);
INSERT INTO public.who_global_data VALUES (27530, 2062, 180179, 23, 9608, 117, 181);
INSERT INTO public.who_global_data VALUES (27531, 1, 221, 0, 1, 117, 53);
INSERT INTO public.who_global_data VALUES (27532, 0, 4854, 0, 62, 117, 164);
INSERT INTO public.who_global_data VALUES (27533, 13, 1304, 0, 92, 117, 140);
INSERT INTO public.who_global_data VALUES (27534, 1776, 481371, 46, 13318, 117, 20);
INSERT INTO public.who_global_data VALUES (27535, 28, 91333, 0, 4746, 117, 112);
INSERT INTO public.who_global_data VALUES (27536, 8447, 902747, 165, 27660, 117, 111);
INSERT INTO public.who_global_data VALUES (27537, 4, 495, 0, 7, 117, 71);
INSERT INTO public.who_global_data VALUES (27538, 0, 5118, 0, 90, 117, 218);
INSERT INTO public.who_global_data VALUES (27539, 0, 0, 0, 0, 117, 43);
INSERT INTO public.who_global_data VALUES (27540, 1386, 87439, 21, 1076, 117, 49);
INSERT INTO public.who_global_data VALUES (27541, 0, 20036, 0, 120, 117, 1);
INSERT INTO public.who_global_data VALUES (27542, 508, 20440, 7, 324, 117, 48);
INSERT INTO public.who_global_data VALUES (27543, 30, 5978, 0, 123, 117, 232);
INSERT INTO public.who_global_data VALUES (27544, 0, 532, 0, 1, 117, 175);
INSERT INTO public.who_global_data VALUES (27545, 0, 1986, 0, 25, 117, 21);
INSERT INTO public.who_global_data VALUES (27546, 3103, 117110, 39, 1034, 117, 156);
INSERT INTO public.who_global_data VALUES (27547, 0, 0, 0, 0, 117, 95);
INSERT INTO public.who_global_data VALUES (27548, 0, 10840, 0, 276, 117, 177);
INSERT INTO public.who_global_data VALUES (27549, 340, 32422, 2, 669, 117, 210);
INSERT INTO public.who_global_data VALUES (27550, 1, 5424, 0, 61, 117, 120);
INSERT INTO public.who_global_data VALUES (27551, 0, 32, 0, 0, 117, 135);
INSERT INTO public.who_global_data VALUES (27552, 463, 118477, 6, 2173, 117, 206);
INSERT INTO public.who_global_data VALUES (27553, 0, 146828, 0, 12188, 117, 189);
INSERT INTO public.who_global_data VALUES (27554, 129, 104516, 12, 6052, 117, 129);
INSERT INTO public.who_global_data VALUES (27555, 245, 30196, 3, 890, 117, 121);
INSERT INTO public.who_global_data VALUES (27556, 0, 5063, 0, 83, 117, 59);
INSERT INTO public.who_global_data VALUES (27557, 0, 414, 0, 0, 117, 96);
INSERT INTO public.who_global_data VALUES (27558, 19, 3865, 0, 68, 117, 41);
INSERT INTO public.who_global_data VALUES (27559, 9, 5669, 0, 113, 117, 216);
INSERT INTO public.who_global_data VALUES (27560, 866, 84295, 10, 1287, 117, 236);
INSERT INTO public.who_global_data VALUES (27561, 0, 13, 0, 0, 117, 150);
INSERT INTO public.who_global_data VALUES (27562, 0, 477, 0, 0, 117, 61);
INSERT INTO public.who_global_data VALUES (27563, 0, 32, 0, 2, 117, 7);
INSERT INTO public.who_global_data VALUES (27564, 149, 11998, 0, 346, 117, 169);
INSERT INTO public.who_global_data VALUES (27565, 16101, 707469, 46, 32477, 117, 28);
INSERT INTO public.who_global_data VALUES (27566, 0, 10144, 0, 69, 117, 85);
INSERT INTO public.who_global_data VALUES (27567, 0, 2754, 0, 10, 117, 211);
INSERT INTO public.who_global_data VALUES (27568, 0, 8815, 0, 54, 117, 60);
INSERT INTO public.who_global_data VALUES (27569, 0, 3628, 0, 117, 117, 3);
INSERT INTO public.who_global_data VALUES (27570, 478, 12272, 6, 91, 117, 11);
INSERT INTO public.who_global_data VALUES (27571, 2467, 325331, 6, 9621, 117, 89);
INSERT INTO public.who_global_data VALUES (27572, 18, 47005, 0, 306, 117, 24);
INSERT INTO public.who_global_data VALUES (27573, 8, 476, 0, 0, 117, 162);
INSERT INTO public.who_global_data VALUES (27574, 280, 22358, 13, 449, 117, 100);
INSERT INTO public.who_global_data VALUES (27575, 0, 16, 0, 0, 117, 47);
INSERT INTO public.who_global_data VALUES (27576, 0, 24, 0, 0, 117, 29);
INSERT INTO public.who_global_data VALUES (27577, 0, 6483, 0, 95, 117, 40);
INSERT INTO public.who_global_data VALUES (27578, 22, 3078, 1, 60, 117, 222);
INSERT INTO public.who_global_data VALUES (27579, 171, 97715, 19, 3384, 117, 132);
INSERT INTO public.who_global_data VALUES (27580, 0, 258, 0, 13, 117, 130);
INSERT INTO public.who_global_data VALUES (27581, 26, 11022, 0, 69, 117, 234);
INSERT INTO public.who_global_data VALUES (27582, 0, 2385, 0, 40, 117, 23);
INSERT INTO public.who_global_data VALUES (27583, 47, 3405, 2, 102, 117, 192);
INSERT INTO public.who_global_data VALUES (27584, 22, 8882, 0, 230, 117, 69);
INSERT INTO public.who_global_data VALUES (27585, 0, 12, 0, 0, 117, 187);
INSERT INTO public.who_global_data VALUES (27586, 594, 83146, 12, 2504, 117, 230);
INSERT INTO public.who_global_data VALUES (27587, 913, 38577, 14, 968, 117, 77);
INSERT INTO public.who_global_data VALUES (27588, 66, 3526, 0, 10, 117, 9);
INSERT INTO public.who_global_data VALUES (27589, 66732, 7120538, 816, 109150, 117, 74);
INSERT INTO public.who_global_data VALUES (27590, 4497, 333449, 79, 11844, 117, 224);
INSERT INTO public.who_global_data VALUES (27591, 3822, 500075, 251, 28544, 117, 199);
INSERT INTO public.who_global_data VALUES (27592, 2206, 402330, 62, 9852, 117, 190);
INSERT INTO public.who_global_data VALUES (27593, 814, 42528, 5, 1826, 117, 12);
INSERT INTO public.who_global_data VALUES (27594, 0, 345, 0, 24, 117, 104);
INSERT INTO public.who_global_data VALUES (27595, 916, 289983, 35, 1970, 117, 153);
INSERT INTO public.who_global_data VALUES (27596, 5456, 354950, 26, 36166, 117, 91);
INSERT INTO public.who_global_data VALUES (27597, 159, 7718, 1, 139, 117, 215);
INSERT INTO public.who_global_data VALUES (27598, 435, 89347, 2, 1629, 117, 84);
INSERT INTO public.who_global_data VALUES (27599, 0, 449, 0, 32, 117, 231);
INSERT INTO public.who_global_data VALUES (27600, 928, 24994, 10, 191, 117, 196);
INSERT INTO public.who_global_data VALUES (27601, 74, 143814, 0, 2136, 117, 105);
INSERT INTO public.who_global_data VALUES (27602, 388, 41546, 6, 766, 117, 122);
INSERT INTO public.who_global_data VALUES (27603, 0, 0, 0, 0, 117, 159);
INSERT INTO public.who_global_data VALUES (27604, 49, 16136, 2, 637, 117, 75);
INSERT INTO public.who_global_data VALUES (27605, 548, 111116, 3, 658, 117, 27);
INSERT INTO public.who_global_data VALUES (27606, 298, 49528, 5, 1090, 117, 54);
INSERT INTO public.who_global_data VALUES (27607, 0, 23, 0, 0, 117, 226);
INSERT INTO public.who_global_data VALUES (27608, 74, 2670, 0, 40, 117, 79);
INSERT INTO public.who_global_data VALUES (27609, 1010, 53568, 4, 459, 117, 56);
INSERT INTO public.who_global_data VALUES (27610, 0, 1767, 0, 40, 117, 117);
INSERT INTO public.who_global_data VALUES (27611, 7, 1370, 0, 82, 117, 152);
INSERT INTO public.who_global_data VALUES (27612, 1109, 43821, 13, 644, 117, 16);
INSERT INTO public.who_global_data VALUES (27613, 0, 150, 0, 1, 117, 10);
INSERT INTO public.who_global_data VALUES (27614, 126, 6242, 0, 89, 117, 201);
INSERT INTO public.who_global_data VALUES (27615, 0, 9360, 0, 130, 117, 174);
INSERT INTO public.who_global_data VALUES (27616, 16, 16718, 0, 237, 117, 119);
INSERT INTO public.who_global_data VALUES (27617, 0, 5821, 0, 180, 117, 168);
INSERT INTO public.who_global_data VALUES (27618, 561, 15657, 2, 157, 117, 99);
INSERT INTO public.who_global_data VALUES (27619, 35, 10894, 1, 35, 117, 171);
INSERT INTO public.who_global_data VALUES (27620, 13, 3286, 0, 132, 117, 87);
INSERT INTO public.who_global_data VALUES (27621, 68, 3835, 2, 43, 117, 123);
INSERT INTO public.who_global_data VALUES (27622, 0, 0, 0, 0, 117, 151);
INSERT INTO public.who_global_data VALUES (27623, 0, 1851, 0, 22, 117, 213);
INSERT INTO public.who_global_data VALUES (27624, 27, 7550, 2, 163, 117, 118);
INSERT INTO public.who_global_data VALUES (27625, 0, 395, 0, 10, 117, 134);
INSERT INTO public.who_global_data VALUES (27626, 0, 3989, 0, 43, 117, 65);
INSERT INTO public.who_global_data VALUES (27627, 4577, 814328, 135, 83642, 117, 102);
INSERT INTO public.who_global_data VALUES (27628, 0, 0, 0, 0, 117, 223);
INSERT INTO public.who_global_data VALUES (27629, 1, 237, 0, 2, 117, 4);
INSERT INTO public.who_global_data VALUES (27630, 1, 316, 0, 0, 117, 146);
INSERT INTO public.who_global_data VALUES (27631, 288, 14272, 9, 213, 117, 31);
INSERT INTO public.who_global_data VALUES (27632, 0, 13, 0, 1, 117, 127);
INSERT INTO public.who_global_data VALUES (27633, 2563, 152404, 33, 2605, 117, 22);
INSERT INTO public.who_global_data VALUES (27634, 157, 10001, 1, 71, 117, 115);
INSERT INTO public.who_global_data VALUES (27635, 1910, 27974, 48, 646, 117, 106);
INSERT INTO public.who_global_data VALUES (27636, 45, 11936, 0, 128, 117, 90);
INSERT INTO public.who_global_data VALUES (27637, 0, 0, 0, 0, 117, 70);
INSERT INTO public.who_global_data VALUES (27638, 2071, 107755, 22, 636, 117, 46);
INSERT INTO public.who_global_data VALUES (27639, 6346, 174224, 16, 6580, 117, 139);
INSERT INTO public.who_global_data VALUES (27640, 0, 27, 0, 0, 117, 42);
INSERT INTO public.who_global_data VALUES (27641, 0, 1515, 0, 25, 117, 80);
INSERT INTO public.who_global_data VALUES (27642, 0, 4225, 0, 153, 117, 203);
INSERT INTO public.who_global_data VALUES (27643, 1, 1201, 0, 69, 117, 136);
INSERT INTO public.who_global_data VALUES (27644, 163, 60266, 0, 1115, 117, 63);
INSERT INTO public.who_global_data VALUES (27645, 0, 0, 0, 0, 117, 17);
INSERT INTO public.who_global_data VALUES (27646, 0, 77, 0, 2, 117, 172);
INSERT INTO public.who_global_data VALUES (27647, 382, 20937, 7, 792, 117, 109);
INSERT INTO public.who_global_data VALUES (27648, 0, 15221, 0, 275, 117, 200);
INSERT INTO public.who_global_data VALUES (27649, 422, 55556, 3, 445, 117, 93);
INSERT INTO public.who_global_data VALUES (27650, 1761, 105890, 29, 1038, 117, 5);
INSERT INTO public.who_global_data VALUES (27651, 0, 741, 0, 13, 117, 214);
INSERT INTO public.who_global_data VALUES (27652, 385, 319317, 10, 6580, 117, 204);
INSERT INTO public.who_global_data VALUES (27653, 0, 0, 0, 0, 117, 198);
INSERT INTO public.who_global_data VALUES (27654, 825, 119666, 8, 2482, 117, 173);
INSERT INTO public.who_global_data VALUES (27655, 4, 554, 0, 7, 117, 229);
INSERT INTO public.who_global_data VALUES (27656, 703, 48978, 20, 1065, 117, 76);
INSERT INTO public.who_global_data VALUES (27657, 2733, 846088, 65, 33223, 117, 138);
INSERT INTO public.who_global_data VALUES (27658, 2415, 339341, 83, 6321, 117, 98);
INSERT INTO public.who_global_data VALUES (27659, 0, 0, 0, 0, 117, 103);
INSERT INTO public.who_global_data VALUES (27660, 4178, 125816, 32, 3004, 117, 225);
INSERT INTO public.who_global_data VALUES (27661, 1090, 86664, 13, 2080, 117, 131);
INSERT INTO public.who_global_data VALUES (27662, 307, 53671, 2, 730, 117, 235);
INSERT INTO public.who_global_data VALUES (27663, 207, 127985, 1, 220, 117, 137);
INSERT INTO public.who_global_data VALUES (27664, 97, 24703, 1, 433, 117, 81);
INSERT INTO public.who_global_data VALUES (27665, 389, 62151, 3, 1461, 117, 182);
INSERT INTO public.who_global_data VALUES (27666, 0, 4491, 0, 16, 117, 145);
INSERT INTO public.who_global_data VALUES (27667, 2880, 155283, 53, 5411, 117, 26);
INSERT INTO public.who_global_data VALUES (27668, 13592, 1312310, 125, 22722, 117, 170);
INSERT INTO public.who_global_data VALUES (27669, 4, 4896, 1, 31, 117, 191);
INSERT INTO public.who_global_data VALUES (27670, 0, 5, 0, 0, 117, 221);
INSERT INTO public.who_global_data VALUES (27671, 0, 65, 0, 0, 117, 64);
INSERT INTO public.who_global_data VALUES (27672, 0, 0, 0, 0, 117, 116);
INSERT INTO public.who_global_data VALUES (27673, 0, 19, 0, 0, 117, 128);
INSERT INTO public.who_global_data VALUES (27674, 0, 29, 0, 0, 117, 6);
INSERT INTO public.who_global_data VALUES (27675, 0, 466, 0, 8, 117, 227);
INSERT INTO public.who_global_data VALUES (27676, 0, 12, 0, 0, 117, 68);
INSERT INTO public.who_global_data VALUES (27677, 0, 64, 0, 0, 117, 184);
INSERT INTO public.who_global_data VALUES (27678, 0, 0, 0, 0, 117, 82);
INSERT INTO public.who_global_data VALUES (27679, 0, 766, 0, 42, 117, 149);
INSERT INTO public.who_global_data VALUES (27680, 7, 929, 0, 15, 117, 197);
INSERT INTO public.who_global_data VALUES (27681, 323, 339267, 25, 5043, 117, 78);
INSERT INTO public.who_global_data VALUES (27682, 0, 15213, 0, 313, 117, 233);
INSERT INTO public.who_global_data VALUES (27683, 102, 34787, 1, 763, 117, 133);
INSERT INTO public.who_global_data VALUES (27684, 0, 147, 0, 0, 117, 35);
INSERT INTO public.who_global_data VALUES (27685, 0, 2300, 0, 72, 117, 114);
INSERT INTO public.who_global_data VALUES (27686, 10, 57876, 0, 27, 117, 237);
INSERT INTO public.who_global_data VALUES (27687, 1, 14, 0, 0, 117, 55);
INSERT INTO public.who_global_data VALUES (27688, 0, 699, 0, 22, 117, 176);
INSERT INTO public.who_global_data VALUES (27689, 1054, 19851, 0, 61, 117, 202);
INSERT INTO public.who_global_data VALUES (27690, 169, 8834, 2, 178, 117, 155);
INSERT INTO public.who_global_data VALUES (27691, 1, 2, 0, 0, 117, 32);
INSERT INTO public.who_global_data VALUES (27692, 17, 3864, 0, 99, 117, 220);
INSERT INTO public.who_global_data VALUES (27693, 1575, 692471, 107, 17780, 117, 30);
INSERT INTO public.who_global_data VALUES (27694, 10, 2787, 0, 55, 117, 147);
INSERT INTO public.who_global_data VALUES (27695, 8876, 932576, 133, 35369, 117, 208);
INSERT INTO public.who_global_data VALUES (27696, 124, 4752, 0, 13, 117, 45);
INSERT INTO public.who_global_data VALUES (27697, 6, 13691, 0, 836, 117, 110);
INSERT INTO public.who_global_data VALUES (27698, 17, 5035, 1, 107, 117, 88);
INSERT INTO public.who_global_data VALUES (27699, 509, 99917, 5, 5913, 117, 51);
INSERT INTO public.who_global_data VALUES (27700, 812, 64896, 3, 1844, 117, 209);
INSERT INTO public.who_global_data VALUES (27701, 45, 4718, 3, 224, 117, 205);
INSERT INTO public.who_global_data VALUES (27702, 42, 10222, 0, 79, 117, 18);
INSERT INTO public.who_global_data VALUES (27703, 5, 3641, 0, 59, 117, 72);
INSERT INTO public.who_global_data VALUES (27704, 12872, 603720, 65, 42825, 117, 44);
INSERT INTO public.who_global_data VALUES (27705, 0, 28, 0, 0, 117, 15);
INSERT INTO public.who_global_data VALUES (27706, 5, 1940, 0, 49, 117, 25);
INSERT INTO public.who_global_data VALUES (27707, 0, 0, 0, 0, 117, 179);
INSERT INTO public.who_global_data VALUES (27708, 0, 0, 0, 0, 117, 34);
INSERT INTO public.who_global_data VALUES (27709, 0, 5043, 0, 90, 117, 207);
INSERT INTO public.who_global_data VALUES (27710, 0, 32556, 0, 478, 117, 166);
INSERT INTO public.who_global_data VALUES (27711, 8232, 847013, 59, 8837, 117, 126);
INSERT INTO public.who_global_data VALUES (27712, 0, 0, 0, 0, 117, 97);
INSERT INTO public.who_global_data VALUES (27713, 1, 696, 0, 6, 117, 36);
INSERT INTO public.who_global_data VALUES (27714, 0, 0, 0, 0, 117, 125);
INSERT INTO public.who_global_data VALUES (27715, 263, 9801, 7, 93, 117, 124);
INSERT INTO public.who_global_data VALUES (27716, 4420, 265454, 43, 5015, 117, 185);
INSERT INTO public.who_global_data VALUES (27717, 1096, 106229, 2, 445, 117, 194);
INSERT INTO public.who_global_data VALUES (27718, 0, 509, 0, 21, 117, 144);
INSERT INTO public.who_global_data VALUES (27719, 53055, 7636803, 575, 212804, 117, 19);
INSERT INTO public.who_global_data VALUES (27720, 1, 1325, 0, 20, 117, 217);
INSERT INTO public.who_global_data VALUES (27721, 17, 2268, 1, 50, 117, 148);
INSERT INTO public.who_global_data VALUES (27722, 311, 61205, 4, 507, 117, 86);
INSERT INTO public.who_global_data VALUES (27723, 0, 0, 0, 0, 117, 13);
INSERT INTO public.who_global_data VALUES (27724, 757, 82453, 7, 691, 117, 157);
INSERT INTO public.who_global_data VALUES (27725, 2, 1109, 0, 35, 117, 8);
INSERT INTO public.who_global_data VALUES (27726, 0, 0, 0, 0, 117, 73);
INSERT INTO public.who_global_data VALUES (27727, 1, 2056, 0, 596, 117, 101);
INSERT INTO public.who_global_data VALUES (27728, 43, 15458, 0, 336, 117, 165);
INSERT INTO public.who_global_data VALUES (27729, 17, 8011, 1, 230, 117, 14);
INSERT INTO public.who_global_data VALUES (27730, 96, 39885, 4, 1481, 118, 193);
INSERT INTO public.who_global_data VALUES (27731, 165, 15231, 3, 416, 118, 113);
INSERT INTO public.who_global_data VALUES (27732, 136, 52940, 6, 1795, 118, 143);
INSERT INTO public.who_global_data VALUES (27733, 0, 0, 0, 0, 118, 219);
INSERT INTO public.who_global_data VALUES (27734, 0, 2696, 0, 55, 118, 186);
INSERT INTO public.who_global_data VALUES (27735, 215, 6246, 6, 218, 118, 52);
INSERT INTO public.who_global_data VALUES (27736, 0, 3, 0, 0, 118, 180);
INSERT INTO public.who_global_data VALUES (27737, 0, 111, 0, 3, 118, 167);
INSERT INTO public.who_global_data VALUES (27738, 15099, 871468, 515, 23225, 118, 154);
INSERT INTO public.who_global_data VALUES (27739, 715, 55764, 4, 1015, 118, 94);
INSERT INTO public.who_global_data VALUES (27740, 0, 4150, 0, 31, 118, 66);
INSERT INTO public.who_global_data VALUES (27741, 15, 27244, 0, 897, 118, 58);
INSERT INTO public.who_global_data VALUES (27742, 901, 54685, 1, 858, 118, 163);
INSERT INTO public.who_global_data VALUES (27743, 233, 41752, 3, 608, 118, 37);
INSERT INTO public.who_global_data VALUES (27744, 91, 4955, 4, 106, 118, 142);
INSERT INTO public.who_global_data VALUES (27745, 427, 75287, 2, 273, 118, 83);
INSERT INTO public.who_global_data VALUES (27746, 1203, 377073, 23, 5500, 118, 228);
INSERT INTO public.who_global_data VALUES (27747, 2, 205, 0, 7, 118, 188);
INSERT INTO public.who_global_data VALUES (27748, 552, 83023, 6, 891, 118, 62);
INSERT INTO public.who_global_data VALUES (27749, 4310, 172002, 22, 10183, 118, 160);
INSERT INTO public.who_global_data VALUES (27750, 54, 2427, 1, 35, 118, 50);
INSERT INTO public.who_global_data VALUES (27751, 0, 2411, 0, 41, 118, 33);
INSERT INTO public.who_global_data VALUES (27752, 0, 184, 0, 9, 118, 183);
INSERT INTO public.who_global_data VALUES (27753, 0, 306, 0, 0, 118, 92);
INSERT INTO public.who_global_data VALUES (27754, 257, 138226, 34, 8262, 118, 158);
INSERT INTO public.who_global_data VALUES (27755, 0, 130, 0, 2, 118, 67);
INSERT INTO public.who_global_data VALUES (27756, 428, 30343, 1, 920, 118, 57);
INSERT INTO public.who_global_data VALUES (27757, 0, 3219, 0, 18, 118, 38);
INSERT INTO public.who_global_data VALUES (27758, 27444, 5055888, 682, 149639, 118, 141);
INSERT INTO public.who_global_data VALUES (27759, 0, 71, 0, 1, 118, 178);
INSERT INTO public.who_global_data VALUES (27760, 0, 146, 0, 3, 118, 108);
INSERT INTO public.who_global_data VALUES (27761, 0, 23871, 0, 887, 118, 39);
INSERT INTO public.who_global_data VALUES (27762, 0, 2241, 0, 60, 118, 2);
INSERT INTO public.who_global_data VALUES (27763, 7, 524, 0, 1, 118, 195);
INSERT INTO public.who_global_data VALUES (27764, 104, 6913, 1, 74, 118, 107);
INSERT INTO public.who_global_data VALUES (27765, 0, 283, 0, 0, 118, 161);
INSERT INTO public.who_global_data VALUES (27766, 0, 21160, 0, 420, 118, 212);
INSERT INTO public.who_global_data VALUES (27767, 2558, 178117, 28, 9585, 118, 181);
INSERT INTO public.who_global_data VALUES (27768, 6, 220, 0, 1, 118, 53);
INSERT INTO public.who_global_data VALUES (27769, 0, 4854, 0, 62, 118, 164);
INSERT INTO public.who_global_data VALUES (27770, 17, 1291, 2, 92, 118, 140);
INSERT INTO public.who_global_data VALUES (27771, 1826, 479595, 52, 13272, 118, 20);
INSERT INTO public.who_global_data VALUES (27772, 27, 91305, 0, 4746, 118, 112);
INSERT INTO public.who_global_data VALUES (27773, 8121, 894300, 164, 27495, 118, 111);
INSERT INTO public.who_global_data VALUES (27774, 0, 491, 0, 7, 118, 71);
INSERT INTO public.who_global_data VALUES (27775, 0, 5118, 0, 90, 118, 218);
INSERT INTO public.who_global_data VALUES (27776, 0, 0, 0, 0, 118, 43);
INSERT INTO public.who_global_data VALUES (27777, 1225, 86053, 15, 1055, 118, 49);
INSERT INTO public.who_global_data VALUES (27778, 54, 20036, 0, 120, 118, 1);
INSERT INTO public.who_global_data VALUES (27779, 486, 19932, 4, 317, 118, 48);
INSERT INTO public.who_global_data VALUES (27780, 5, 5948, 0, 123, 118, 232);
INSERT INTO public.who_global_data VALUES (27781, 0, 532, 0, 1, 118, 175);
INSERT INTO public.who_global_data VALUES (27782, 35, 1986, 0, 25, 118, 21);
INSERT INTO public.who_global_data VALUES (27783, 4633, 114007, 90, 995, 118, 156);
INSERT INTO public.who_global_data VALUES (27784, 0, 0, 0, 0, 118, 95);
INSERT INTO public.who_global_data VALUES (27785, 6, 10840, 0, 276, 118, 177);
INSERT INTO public.who_global_data VALUES (27786, 444, 32082, 2, 667, 118, 210);
INSERT INTO public.who_global_data VALUES (27787, 0, 5423, 0, 61, 118, 120);
INSERT INTO public.who_global_data VALUES (27788, 0, 32, 0, 0, 118, 135);
INSERT INTO public.who_global_data VALUES (27789, 557, 118014, 2, 2167, 118, 206);
INSERT INTO public.who_global_data VALUES (27790, 1783, 146828, 47, 12188, 118, 189);
INSERT INTO public.who_global_data VALUES (27791, 125, 104387, 11, 6040, 118, 129);
INSERT INTO public.who_global_data VALUES (27792, 0, 29951, 6, 887, 118, 121);
INSERT INTO public.who_global_data VALUES (27793, 1, 5063, 0, 83, 118, 59);
INSERT INTO public.who_global_data VALUES (27794, 9, 414, 0, 0, 118, 96);
INSERT INTO public.who_global_data VALUES (27795, 37, 3846, 0, 68, 118, 41);
INSERT INTO public.who_global_data VALUES (27796, 16, 5660, 0, 113, 118, 216);
INSERT INTO public.who_global_data VALUES (27797, 767, 83429, 6, 1277, 118, 236);
INSERT INTO public.who_global_data VALUES (27798, 0, 13, 0, 0, 118, 150);
INSERT INTO public.who_global_data VALUES (27799, 0, 477, 0, 0, 118, 61);
INSERT INTO public.who_global_data VALUES (27800, 0, 32, 0, 2, 118, 7);
INSERT INTO public.who_global_data VALUES (27801, 269, 11849, 0, 346, 118, 169);
INSERT INTO public.who_global_data VALUES (27802, 26675, 691368, 54, 32431, 118, 28);
INSERT INTO public.who_global_data VALUES (27803, 0, 10144, 0, 69, 118, 85);
INSERT INTO public.who_global_data VALUES (27804, 0, 2754, 0, 10, 118, 211);
INSERT INTO public.who_global_data VALUES (27805, 0, 8815, 0, 54, 118, 60);
INSERT INTO public.who_global_data VALUES (27806, 0, 3628, 0, 117, 118, 3);
INSERT INTO public.who_global_data VALUES (27807, 523, 11794, 7, 85, 118, 11);
INSERT INTO public.who_global_data VALUES (27808, 3483, 322864, 11, 9615, 118, 89);
INSERT INTO public.who_global_data VALUES (27809, 0, 46987, 0, 306, 118, 24);
INSERT INTO public.who_global_data VALUES (27810, 16, 468, 0, 0, 118, 162);
INSERT INTO public.who_global_data VALUES (27811, 306, 22078, 5, 436, 118, 100);
INSERT INTO public.who_global_data VALUES (27812, 0, 16, 0, 0, 118, 47);
INSERT INTO public.who_global_data VALUES (27813, 0, 24, 0, 0, 118, 29);
INSERT INTO public.who_global_data VALUES (27814, 164, 6483, 0, 95, 118, 40);
INSERT INTO public.who_global_data VALUES (27815, 67, 3056, 1, 59, 118, 222);
INSERT INTO public.who_global_data VALUES (27816, 609, 97544, 9, 3365, 118, 132);
INSERT INTO public.who_global_data VALUES (27817, 0, 258, 0, 13, 118, 130);
INSERT INTO public.who_global_data VALUES (27818, 42, 10996, 1, 69, 118, 234);
INSERT INTO public.who_global_data VALUES (27819, 23, 2385, 1, 40, 118, 23);
INSERT INTO public.who_global_data VALUES (27820, 29, 3358, 2, 100, 118, 192);
INSERT INTO public.who_global_data VALUES (27821, 6, 8860, 0, 230, 118, 69);
INSERT INTO public.who_global_data VALUES (27822, 0, 12, 0, 0, 118, 187);
INSERT INTO public.who_global_data VALUES (27823, 880, 82552, 15, 2492, 118, 230);
INSERT INTO public.who_global_data VALUES (27824, 1068, 37664, 21, 954, 118, 77);
INSERT INTO public.who_global_data VALUES (27825, 87, 3460, 0, 10, 118, 9);
INSERT INTO public.who_global_data VALUES (27826, 74383, 7053806, 918, 108334, 118, 74);
INSERT INTO public.who_global_data VALUES (27827, 4294, 328952, 88, 11765, 118, 224);
INSERT INTO public.who_global_data VALUES (27828, 3875, 496253, 195, 28293, 118, 199);
INSERT INTO public.who_global_data VALUES (27829, 2344, 400124, 55, 9790, 118, 190);
INSERT INTO public.who_global_data VALUES (27830, 1011, 41714, 0, 1821, 118, 12);
INSERT INTO public.who_global_data VALUES (27831, 0, 345, 0, 24, 118, 104);
INSERT INTO public.who_global_data VALUES (27832, 2963, 289067, 40, 1935, 118, 153);
INSERT INTO public.who_global_data VALUES (27833, 5724, 349494, 29, 36140, 118, 91);
INSERT INTO public.who_global_data VALUES (27834, 196, 7559, 6, 138, 118, 215);
INSERT INTO public.who_global_data VALUES (27835, 679, 88912, 3, 1627, 118, 84);
INSERT INTO public.who_global_data VALUES (27836, 6, 449, 0, 32, 118, 231);
INSERT INTO public.who_global_data VALUES (27837, 1235, 24066, 15, 181, 118, 196);
INSERT INTO public.who_global_data VALUES (27838, 108, 143740, 30, 2136, 118, 105);
INSERT INTO public.who_global_data VALUES (27839, 538, 41158, 5, 760, 118, 122);
INSERT INTO public.who_global_data VALUES (27840, 0, 0, 0, 0, 118, 159);
INSERT INTO public.who_global_data VALUES (27841, 80, 16087, 4, 635, 118, 75);
INSERT INTO public.who_global_data VALUES (27842, 492, 110568, 6, 655, 118, 27);
INSERT INTO public.who_global_data VALUES (27843, 306, 49230, 3, 1085, 118, 54);
INSERT INTO public.who_global_data VALUES (27844, 0, 23, 0, 0, 118, 226);
INSERT INTO public.who_global_data VALUES (27845, 89, 2596, 0, 40, 118, 79);
INSERT INTO public.who_global_data VALUES (27846, 1388, 52558, 5, 455, 118, 56);
INSERT INTO public.who_global_data VALUES (27847, 0, 1767, 0, 40, 118, 117);
INSERT INTO public.who_global_data VALUES (27848, 3, 1363, 0, 82, 118, 152);
INSERT INTO public.who_global_data VALUES (27849, 1026, 42712, 8, 631, 118, 16);
INSERT INTO public.who_global_data VALUES (27850, 5, 150, 0, 1, 118, 10);
INSERT INTO public.who_global_data VALUES (27851, 160, 6116, 2, 89, 118, 201);
INSERT INTO public.who_global_data VALUES (27852, 0, 9360, 0, 130, 118, 174);
INSERT INTO public.who_global_data VALUES (27853, 26, 16702, 0, 237, 118, 119);
INSERT INTO public.who_global_data VALUES (27854, 8, 5821, 0, 180, 118, 168);
INSERT INTO public.who_global_data VALUES (27855, 374, 15096, 3, 155, 118, 99);
INSERT INTO public.who_global_data VALUES (27856, 51, 10859, 0, 34, 118, 171);
INSERT INTO public.who_global_data VALUES (27857, 25, 3273, 1, 132, 118, 87);
INSERT INTO public.who_global_data VALUES (27858, 95, 3767, 0, 41, 118, 123);
INSERT INTO public.who_global_data VALUES (27859, 0, 0, 0, 0, 118, 151);
INSERT INTO public.who_global_data VALUES (27860, 0, 1851, 0, 22, 118, 213);
INSERT INTO public.who_global_data VALUES (27861, 0, 7523, 0, 161, 118, 118);
INSERT INTO public.who_global_data VALUES (27862, 0, 395, 0, 10, 118, 134);
INSERT INTO public.who_global_data VALUES (27863, 0, 3989, 0, 43, 118, 65);
INSERT INTO public.who_global_data VALUES (27864, 5263, 809751, 411, 83507, 118, 102);
INSERT INTO public.who_global_data VALUES (27865, 0, 0, 0, 0, 118, 223);
INSERT INTO public.who_global_data VALUES (27866, 0, 236, 0, 2, 118, 4);
INSERT INTO public.who_global_data VALUES (27867, 0, 315, 0, 0, 118, 146);
INSERT INTO public.who_global_data VALUES (27868, 223, 13984, 5, 204, 118, 31);
INSERT INTO public.who_global_data VALUES (27869, 0, 13, 0, 1, 118, 127);
INSERT INTO public.who_global_data VALUES (27870, 3443, 149841, 42, 2572, 118, 22);
INSERT INTO public.who_global_data VALUES (27871, 102, 9844, 1, 70, 118, 115);
INSERT INTO public.who_global_data VALUES (27872, 2158, 26064, 32, 598, 118, 106);
INSERT INTO public.who_global_data VALUES (27873, 62, 11891, 1, 128, 118, 90);
INSERT INTO public.who_global_data VALUES (27874, 0, 0, 0, 0, 118, 70);
INSERT INTO public.who_global_data VALUES (27875, 5008, 105684, 14, 614, 118, 46);
INSERT INTO public.who_global_data VALUES (27876, 6481, 167878, 23, 6564, 118, 139);
INSERT INTO public.who_global_data VALUES (27877, 0, 27, 0, 0, 118, 42);
INSERT INTO public.who_global_data VALUES (27878, 1, 1515, 0, 25, 118, 80);
INSERT INTO public.who_global_data VALUES (27879, 0, 4225, 0, 153, 118, 203);
INSERT INTO public.who_global_data VALUES (27880, 0, 1200, 0, 69, 118, 136);
INSERT INTO public.who_global_data VALUES (27881, 111, 60103, 2, 1115, 118, 63);
INSERT INTO public.who_global_data VALUES (27882, 0, 0, 0, 0, 118, 17);
INSERT INTO public.who_global_data VALUES (27883, 2, 77, 0, 2, 118, 172);
INSERT INTO public.who_global_data VALUES (27884, 392, 20555, 4, 785, 118, 109);
INSERT INTO public.who_global_data VALUES (27885, 0, 15221, 0, 275, 118, 200);
INSERT INTO public.who_global_data VALUES (27886, 281, 55134, 11, 442, 118, 93);
INSERT INTO public.who_global_data VALUES (27887, 0, 104129, 0, 1009, 118, 5);
INSERT INTO public.who_global_data VALUES (27888, 0, 741, 0, 13, 118, 214);
INSERT INTO public.who_global_data VALUES (27889, 666, 318932, 12, 6570, 118, 204);
INSERT INTO public.who_global_data VALUES (27890, 0, 0, 0, 0, 118, 198);
INSERT INTO public.who_global_data VALUES (27891, 787, 118841, 11, 2474, 118, 173);
INSERT INTO public.who_global_data VALUES (27892, 0, 550, 0, 7, 118, 229);
INSERT INTO public.who_global_data VALUES (27893, 959, 48275, 33, 1045, 118, 76);
INSERT INTO public.who_global_data VALUES (27894, 4741, 843355, 60, 33158, 118, 138);
INSERT INTO public.who_global_data VALUES (27895, 2156, 336926, 86, 6238, 118, 98);
INSERT INTO public.who_global_data VALUES (27896, 0, 0, 0, 0, 118, 103);
INSERT INTO public.who_global_data VALUES (27897, 5300, 121638, 53, 2972, 118, 225);
INSERT INTO public.who_global_data VALUES (27898, 1646, 85574, 5, 2067, 118, 131);
INSERT INTO public.who_global_data VALUES (27899, 472, 53364, 8, 728, 118, 235);
INSERT INTO public.who_global_data VALUES (27900, 178, 127778, 0, 219, 118, 137);
INSERT INTO public.who_global_data VALUES (27901, 58, 24606, 2, 432, 118, 81);
INSERT INTO public.who_global_data VALUES (27902, 929, 61762, 16, 1458, 118, 182);
INSERT INTO public.who_global_data VALUES (27903, 0, 4491, 0, 16, 118, 145);
INSERT INTO public.who_global_data VALUES (27904, 3517, 152403, 59, 5358, 118, 26);
INSERT INTO public.who_global_data VALUES (27905, 13634, 1298718, 143, 22597, 118, 170);
INSERT INTO public.who_global_data VALUES (27906, 2, 4892, 1, 30, 118, 191);
INSERT INTO public.who_global_data VALUES (27907, 0, 5, 0, 0, 118, 221);
INSERT INTO public.who_global_data VALUES (27908, 3, 65, 0, 0, 118, 64);
INSERT INTO public.who_global_data VALUES (27909, 0, 0, 0, 0, 118, 116);
INSERT INTO public.who_global_data VALUES (27910, 0, 19, 0, 0, 118, 128);
INSERT INTO public.who_global_data VALUES (27911, 1, 29, 0, 0, 118, 6);
INSERT INTO public.who_global_data VALUES (27912, 54, 466, 0, 8, 118, 227);
INSERT INTO public.who_global_data VALUES (27913, 0, 12, 0, 0, 118, 68);
INSERT INTO public.who_global_data VALUES (27914, 0, 64, 0, 0, 118, 184);
INSERT INTO public.who_global_data VALUES (27915, 0, 0, 0, 0, 118, 82);
INSERT INTO public.who_global_data VALUES (27916, 0, 766, 0, 42, 118, 149);
INSERT INTO public.who_global_data VALUES (27917, 0, 922, 0, 15, 118, 197);
INSERT INTO public.who_global_data VALUES (27918, 405, 338944, 22, 5018, 118, 78);
INSERT INTO public.who_global_data VALUES (27919, 0, 15213, 0, 313, 118, 233);
INSERT INTO public.who_global_data VALUES (27920, 168, 34685, 1, 762, 118, 133);
INSERT INTO public.who_global_data VALUES (27921, 0, 147, 0, 0, 118, 35);
INSERT INTO public.who_global_data VALUES (27922, 5, 2300, 0, 72, 118, 114);
INSERT INTO public.who_global_data VALUES (27923, 7, 57866, 0, 27, 118, 237);
INSERT INTO public.who_global_data VALUES (27924, 0, 13, 0, 0, 118, 55);
INSERT INTO public.who_global_data VALUES (27925, 0, 699, 0, 22, 118, 176);
INSERT INTO public.who_global_data VALUES (27926, 1887, 18797, 4, 61, 118, 202);
INSERT INTO public.who_global_data VALUES (27927, 411, 8665, 0, 176, 118, 155);
INSERT INTO public.who_global_data VALUES (27928, 0, 1, 0, 0, 118, 32);
INSERT INTO public.who_global_data VALUES (27929, 102, 3847, 0, 99, 118, 220);
INSERT INTO public.who_global_data VALUES (27930, 2364, 690896, 126, 17673, 118, 30);
INSERT INTO public.who_global_data VALUES (27931, 16, 2777, 1, 55, 118, 147);
INSERT INTO public.who_global_data VALUES (27932, 15097, 923700, 153, 35236, 118, 208);
INSERT INTO public.who_global_data VALUES (27933, 105, 4628, 0, 13, 118, 45);
INSERT INTO public.who_global_data VALUES (27934, 3, 13685, 0, 836, 118, 110);
INSERT INTO public.who_global_data VALUES (27935, 14, 5018, 0, 106, 118, 88);
INSERT INTO public.who_global_data VALUES (27936, 783, 99408, 5, 5908, 118, 51);
INSERT INTO public.who_global_data VALUES (27937, 1251, 64084, 3, 1841, 118, 209);
INSERT INTO public.who_global_data VALUES (27938, 57, 4673, 3, 221, 118, 205);
INSERT INTO public.who_global_data VALUES (27939, 43, 10180, 0, 79, 118, 18);
INSERT INTO public.who_global_data VALUES (27940, 2, 3636, 0, 59, 118, 72);
INSERT INTO public.who_global_data VALUES (27941, 15165, 590848, 81, 42760, 118, 44);
INSERT INTO public.who_global_data VALUES (27942, 0, 28, 0, 0, 118, 15);
INSERT INTO public.who_global_data VALUES (27943, 28, 1935, 0, 49, 118, 25);
INSERT INTO public.who_global_data VALUES (27944, 0, 0, 0, 0, 118, 179);
INSERT INTO public.who_global_data VALUES (27945, 0, 0, 0, 0, 118, 34);
INSERT INTO public.who_global_data VALUES (27946, 80, 5043, 4, 90, 118, 207);
INSERT INTO public.who_global_data VALUES (27947, 1297, 32556, 22, 478, 118, 166);
INSERT INTO public.who_global_data VALUES (27948, 8379, 838781, 56, 8778, 118, 126);
INSERT INTO public.who_global_data VALUES (27949, 0, 0, 0, 0, 118, 97);
INSERT INTO public.who_global_data VALUES (27950, 0, 695, 0, 6, 118, 36);
INSERT INTO public.who_global_data VALUES (27951, 0, 0, 0, 0, 118, 125);
INSERT INTO public.who_global_data VALUES (27952, 0, 9538, 0, 86, 118, 124);
INSERT INTO public.who_global_data VALUES (27953, 4768, 261034, 85, 4972, 118, 185);
INSERT INTO public.who_global_data VALUES (27954, 1129, 105133, 1, 443, 118, 194);
INSERT INTO public.who_global_data VALUES (27955, 0, 509, 0, 21, 118, 144);
INSERT INTO public.who_global_data VALUES (27956, 57828, 7583748, 918, 212229, 118, 19);
INSERT INTO public.who_global_data VALUES (27957, 0, 1324, 0, 20, 118, 217);
INSERT INTO public.who_global_data VALUES (27958, 25, 2251, 0, 49, 118, 148);
INSERT INTO public.who_global_data VALUES (27959, 332, 60894, 3, 503, 118, 86);
INSERT INTO public.who_global_data VALUES (27960, 0, 0, 0, 0, 118, 13);
INSERT INTO public.who_global_data VALUES (27961, 677, 81696, 6, 684, 118, 157);
INSERT INTO public.who_global_data VALUES (27962, 2, 1107, 0, 35, 118, 8);
INSERT INTO public.who_global_data VALUES (27963, 0, 0, 0, 0, 118, 73);
INSERT INTO public.who_global_data VALUES (27964, 0, 2055, 2, 596, 118, 101);
INSERT INTO public.who_global_data VALUES (27965, 76, 15415, 0, 336, 118, 165);
INSERT INTO public.who_global_data VALUES (27966, 0, 7994, 0, 229, 118, 14);
INSERT INTO public.who_global_data VALUES (27967, 10, 39789, 1, 1477, 119, 193);
INSERT INTO public.who_global_data VALUES (27968, 167, 15066, 2, 413, 119, 113);
INSERT INTO public.who_global_data VALUES (27969, 146, 52804, 6, 1789, 119, 143);
INSERT INTO public.who_global_data VALUES (27970, 0, 0, 0, 0, 119, 219);
INSERT INTO public.who_global_data VALUES (27971, 128, 2696, 1, 55, 119, 186);
INSERT INTO public.who_global_data VALUES (27972, 73, 6031, 4, 212, 119, 52);
INSERT INTO public.who_global_data VALUES (27973, 0, 3, 0, 0, 119, 180);
INSERT INTO public.who_global_data VALUES (27974, 3, 111, 0, 3, 119, 167);
INSERT INTO public.who_global_data VALUES (27975, 15454, 856369, 484, 22710, 119, 154);
INSERT INTO public.who_global_data VALUES (27976, 649, 55049, 6, 1011, 119, 94);
INSERT INTO public.who_global_data VALUES (27977, 17, 4150, 0, 31, 119, 66);
INSERT INTO public.who_global_data VALUES (27978, 23, 27229, 0, 897, 119, 58);
INSERT INTO public.who_global_data VALUES (27979, 1181, 53784, 4, 857, 119, 163);
INSERT INTO public.who_global_data VALUES (27980, 215, 41519, 2, 605, 119, 37);
INSERT INTO public.who_global_data VALUES (27981, 151, 4864, 0, 102, 119, 142);
INSERT INTO public.who_global_data VALUES (27982, 438, 74860, 7, 271, 119, 83);
INSERT INTO public.who_global_data VALUES (27983, 1278, 375870, 17, 5477, 119, 228);
INSERT INTO public.who_global_data VALUES (27984, 0, 203, 0, 7, 119, 188);
INSERT INTO public.who_global_data VALUES (27985, 489, 82471, 5, 885, 119, 62);
INSERT INTO public.who_global_data VALUES (27986, 7790, 167692, 19, 10161, 119, 160);
INSERT INTO public.who_global_data VALUES (27987, 63, 2373, 0, 34, 119, 50);
INSERT INTO public.who_global_data VALUES (27988, 0, 2411, 0, 41, 119, 33);
INSERT INTO public.who_global_data VALUES (27989, 2, 184, 0, 9, 119, 183);
INSERT INTO public.who_global_data VALUES (27990, 2, 306, 0, 0, 119, 92);
INSERT INTO public.who_global_data VALUES (27991, 263, 137969, 36, 8228, 119, 158);
INSERT INTO public.who_global_data VALUES (27992, 0, 130, 0, 2, 119, 67);
INSERT INTO public.who_global_data VALUES (27993, 390, 29915, 13, 919, 119, 57);
INSERT INTO public.who_global_data VALUES (27994, 0, 3219, 0, 18, 119, 38);
INSERT INTO public.who_global_data VALUES (27995, 27750, 5028444, 729, 148957, 119, 141);
INSERT INTO public.who_global_data VALUES (27996, 0, 71, 0, 1, 119, 178);
INSERT INTO public.who_global_data VALUES (27997, 0, 146, 0, 3, 119, 108);
INSERT INTO public.who_global_data VALUES (27998, 612, 23871, 7, 887, 119, 39);
INSERT INTO public.who_global_data VALUES (27999, 19, 2241, 1, 60, 119, 2);
INSERT INTO public.who_global_data VALUES (28000, 2, 517, 0, 1, 119, 195);
INSERT INTO public.who_global_data VALUES (28001, 92, 6809, 2, 73, 119, 107);
INSERT INTO public.who_global_data VALUES (28002, 1, 283, 0, 0, 119, 161);
INSERT INTO public.who_global_data VALUES (28003, 0, 21160, 0, 420, 119, 212);
INSERT INTO public.who_global_data VALUES (28004, 2436, 175559, 16, 9557, 119, 181);
INSERT INTO public.who_global_data VALUES (28005, 1, 214, 0, 1, 119, 53);
INSERT INTO public.who_global_data VALUES (28006, 1, 4854, 0, 62, 119, 164);
INSERT INTO public.who_global_data VALUES (28007, 12, 1274, 1, 90, 119, 140);
INSERT INTO public.who_global_data VALUES (28008, 1753, 477769, 53, 13220, 119, 20);
INSERT INTO public.who_global_data VALUES (28009, 26, 91278, 0, 4746, 119, 112);
INSERT INTO public.who_global_data VALUES (28010, 8496, 886179, 151, 27331, 119, 111);
INSERT INTO public.who_global_data VALUES (28011, 4, 491, 0, 7, 119, 71);
INSERT INTO public.who_global_data VALUES (28012, 0, 5118, 0, 90, 119, 218);
INSERT INTO public.who_global_data VALUES (28013, 0, 0, 0, 0, 119, 43);
INSERT INTO public.who_global_data VALUES (28014, 1331, 84828, 16, 1040, 119, 49);
INSERT INTO public.who_global_data VALUES (28015, 0, 19982, 0, 120, 119, 1);
INSERT INTO public.who_global_data VALUES (28016, 457, 19446, 3, 313, 119, 48);
INSERT INTO public.who_global_data VALUES (28017, 26, 5943, 0, 123, 119, 232);
INSERT INTO public.who_global_data VALUES (28018, 27, 532, 0, 1, 119, 175);
INSERT INTO public.who_global_data VALUES (28019, 33, 1951, 1, 25, 119, 21);
INSERT INTO public.who_global_data VALUES (28020, 8617, 109374, 36, 905, 119, 156);
INSERT INTO public.who_global_data VALUES (28021, 0, 0, 0, 0, 119, 95);
INSERT INTO public.who_global_data VALUES (28022, 13, 10834, 0, 276, 119, 177);
INSERT INTO public.who_global_data VALUES (28023, 482, 31638, 0, 665, 119, 210);
INSERT INTO public.who_global_data VALUES (28024, 0, 5423, 0, 61, 119, 120);
INSERT INTO public.who_global_data VALUES (28025, 0, 32, 0, 0, 119, 135);
INSERT INTO public.who_global_data VALUES (28026, 585, 117457, 2, 2165, 119, 206);
INSERT INTO public.who_global_data VALUES (28027, 0, 145045, 0, 12141, 119, 189);
INSERT INTO public.who_global_data VALUES (28028, 106, 104262, 12, 6029, 119, 129);
INSERT INTO public.who_global_data VALUES (28029, 109, 29951, 4, 881, 119, 121);
INSERT INTO public.who_global_data VALUES (28030, 0, 5062, 0, 83, 119, 59);
INSERT INTO public.who_global_data VALUES (28031, 0, 405, 0, 0, 119, 96);
INSERT INTO public.who_global_data VALUES (28032, 49, 3809, 1, 68, 119, 41);
INSERT INTO public.who_global_data VALUES (28033, 12, 5644, 0, 113, 119, 216);
INSERT INTO public.who_global_data VALUES (28034, 865, 82662, 9, 1271, 119, 236);
INSERT INTO public.who_global_data VALUES (28035, 0, 13, 0, 0, 119, 150);
INSERT INTO public.who_global_data VALUES (28036, 0, 477, 0, 0, 119, 61);
INSERT INTO public.who_global_data VALUES (28037, 0, 32, 0, 2, 119, 7);
INSERT INTO public.who_global_data VALUES (28038, 235, 11580, 0, 346, 119, 169);
INSERT INTO public.who_global_data VALUES (28039, 20120, 664693, 90, 32377, 119, 28);
INSERT INTO public.who_global_data VALUES (28040, 16, 10144, 0, 69, 119, 85);
INSERT INTO public.who_global_data VALUES (28041, 334, 2754, 0, 10, 119, 211);
INSERT INTO public.who_global_data VALUES (28042, 0, 8815, 0, 54, 119, 60);
INSERT INTO public.who_global_data VALUES (28043, 7, 3628, 0, 117, 119, 3);
INSERT INTO public.who_global_data VALUES (28044, 519, 11271, 6, 78, 119, 11);
INSERT INTO public.who_global_data VALUES (28045, 4721, 319381, 15, 9604, 119, 89);
INSERT INTO public.who_global_data VALUES (28046, 40, 46987, 0, 306, 119, 24);
INSERT INTO public.who_global_data VALUES (28047, 7, 452, 0, 0, 119, 162);
INSERT INTO public.who_global_data VALUES (28048, 391, 21772, 1, 431, 119, 100);
INSERT INTO public.who_global_data VALUES (28049, 1, 16, 0, 0, 119, 47);
INSERT INTO public.who_global_data VALUES (28050, 0, 24, 0, 0, 119, 29);
INSERT INTO public.who_global_data VALUES (28051, 0, 6319, 18, 95, 119, 40);
INSERT INTO public.who_global_data VALUES (28052, 55, 2989, 0, 58, 119, 222);
INSERT INTO public.who_global_data VALUES (28053, 455, 96935, 9, 3356, 119, 132);
INSERT INTO public.who_global_data VALUES (28054, 0, 258, 0, 13, 119, 130);
INSERT INTO public.who_global_data VALUES (28055, 53, 10954, 0, 68, 119, 234);
INSERT INTO public.who_global_data VALUES (28056, 0, 2362, 0, 39, 119, 23);
INSERT INTO public.who_global_data VALUES (28057, 37, 3329, 3, 98, 119, 192);
INSERT INTO public.who_global_data VALUES (28058, 0, 8854, 0, 230, 119, 69);
INSERT INTO public.who_global_data VALUES (28059, 0, 12, 0, 0, 119, 187);
INSERT INTO public.who_global_data VALUES (28060, 512, 81672, 11, 2477, 119, 230);
INSERT INTO public.who_global_data VALUES (28061, 1374, 36596, 20, 933, 119, 77);
INSERT INTO public.who_global_data VALUES (28062, 106, 3373, 0, 10, 119, 9);
INSERT INTO public.who_global_data VALUES (28063, 73272, 6979423, 926, 107416, 119, 74);
INSERT INTO public.who_global_data VALUES (28064, 4094, 324658, 97, 11677, 119, 224);
INSERT INTO public.who_global_data VALUES (28065, 4142, 492378, 210, 28098, 119, 199);
INSERT INTO public.who_global_data VALUES (28066, 3214, 397780, 52, 9735, 119, 190);
INSERT INTO public.who_global_data VALUES (28067, 617, 40703, 4, 1821, 119, 12);
INSERT INTO public.who_global_data VALUES (28068, 0, 345, 0, 24, 119, 104);
INSERT INTO public.who_global_data VALUES (28069, 3755, 286104, 47, 1895, 119, 153);
INSERT INTO public.who_global_data VALUES (28070, 5372, 343770, 28, 36111, 119, 91);
INSERT INTO public.who_global_data VALUES (28071, 90, 7363, 4, 132, 119, 215);
INSERT INTO public.who_global_data VALUES (28072, 594, 88233, 8, 1624, 119, 84);
INSERT INTO public.who_global_data VALUES (28073, 2, 443, 0, 32, 119, 231);
INSERT INTO public.who_global_data VALUES (28074, 1246, 22831, 22, 166, 119, 196);
INSERT INTO public.who_global_data VALUES (28075, 352, 143632, 0, 2106, 119, 105);
INSERT INTO public.who_global_data VALUES (28076, 442, 40620, 4, 755, 119, 122);
INSERT INTO public.who_global_data VALUES (28077, 0, 0, 0, 0, 119, 159);
INSERT INTO public.who_global_data VALUES (28078, 79, 16007, 3, 631, 119, 75);
INSERT INTO public.who_global_data VALUES (28079, 635, 110076, 7, 649, 119, 27);
INSERT INTO public.who_global_data VALUES (28080, 307, 48924, 5, 1082, 119, 54);
INSERT INTO public.who_global_data VALUES (28081, 0, 23, 0, 0, 119, 226);
INSERT INTO public.who_global_data VALUES (28082, 137, 2507, 0, 40, 119, 79);
INSERT INTO public.who_global_data VALUES (28083, 1426, 51170, 11, 450, 119, 56);
INSERT INTO public.who_global_data VALUES (28084, 0, 1767, 0, 40, 119, 117);
INSERT INTO public.who_global_data VALUES (28085, 0, 1360, 0, 82, 119, 152);
INSERT INTO public.who_global_data VALUES (28086, 318, 41686, 2, 623, 119, 16);
INSERT INTO public.who_global_data VALUES (28087, 6, 145, 0, 1, 119, 10);
INSERT INTO public.who_global_data VALUES (28088, 204, 5956, 0, 87, 119, 201);
INSERT INTO public.who_global_data VALUES (28089, 141, 9360, 1, 130, 119, 174);
INSERT INTO public.who_global_data VALUES (28090, 22, 16676, 2, 237, 119, 119);
INSERT INTO public.who_global_data VALUES (28091, 4, 5813, 0, 180, 119, 168);
INSERT INTO public.who_global_data VALUES (28092, 354, 14722, 6, 152, 119, 99);
INSERT INTO public.who_global_data VALUES (28093, 66, 10808, 0, 34, 119, 171);
INSERT INTO public.who_global_data VALUES (28094, 13, 3248, 0, 131, 119, 87);
INSERT INTO public.who_global_data VALUES (28095, 100, 3672, 0, 41, 119, 123);
INSERT INTO public.who_global_data VALUES (28096, 0, 0, 0, 0, 119, 151);
INSERT INTO public.who_global_data VALUES (28097, 0, 1851, 0, 22, 119, 213);
INSERT INTO public.who_global_data VALUES (28098, 0, 7523, 0, 161, 119, 118);
INSERT INTO public.who_global_data VALUES (28099, 0, 395, 0, 10, 119, 134);
INSERT INTO public.who_global_data VALUES (28100, 97, 3989, 1, 43, 119, 65);
INSERT INTO public.who_global_data VALUES (28101, 30468, 804488, 3013, 83096, 119, 102);
INSERT INTO public.who_global_data VALUES (28102, 0, 0, 0, 0, 119, 223);
INSERT INTO public.who_global_data VALUES (28103, 4, 236, 0, 2, 119, 4);
INSERT INTO public.who_global_data VALUES (28104, 0, 315, 0, 0, 119, 146);
INSERT INTO public.who_global_data VALUES (28105, 203, 13761, 4, 199, 119, 31);
INSERT INTO public.who_global_data VALUES (28106, 0, 13, 0, 1, 119, 127);
INSERT INTO public.who_global_data VALUES (28107, 3445, 146398, 44, 2530, 119, 22);
INSERT INTO public.who_global_data VALUES (28108, 103, 9742, 1, 69, 119, 115);
INSERT INTO public.who_global_data VALUES (28109, 1461, 23906, 31, 566, 119, 106);
INSERT INTO public.who_global_data VALUES (28110, 48, 11829, 0, 127, 119, 90);
INSERT INTO public.who_global_data VALUES (28111, 0, 0, 0, 0, 119, 70);
INSERT INTO public.who_global_data VALUES (28112, 2059, 100676, 10, 600, 119, 46);
INSERT INTO public.who_global_data VALUES (28113, 5962, 161397, 14, 6541, 119, 139);
INSERT INTO public.who_global_data VALUES (28114, 0, 27, 0, 0, 119, 42);
INSERT INTO public.who_global_data VALUES (28115, 4, 1514, 0, 25, 119, 80);
INSERT INTO public.who_global_data VALUES (28116, 0, 4225, 0, 153, 119, 203);
INSERT INTO public.who_global_data VALUES (28117, 0, 1200, 0, 69, 119, 136);
INSERT INTO public.who_global_data VALUES (28118, 151, 59992, 0, 1113, 119, 63);
INSERT INTO public.who_global_data VALUES (28119, 0, 0, 0, 0, 119, 17);
INSERT INTO public.who_global_data VALUES (28120, 0, 75, 0, 2, 119, 172);
INSERT INTO public.who_global_data VALUES (28121, 386, 20163, 6, 781, 119, 109);
INSERT INTO public.who_global_data VALUES (28122, 209, 15221, 0, 275, 119, 200);
INSERT INTO public.who_global_data VALUES (28123, 498, 54853, 9, 431, 119, 93);
INSERT INTO public.who_global_data VALUES (28124, 0, 104129, 0, 1009, 119, 5);
INSERT INTO public.who_global_data VALUES (28125, 0, 741, 0, 13, 119, 214);
INSERT INTO public.who_global_data VALUES (28126, 671, 318266, 6, 6558, 119, 204);
INSERT INTO public.who_global_data VALUES (28127, 0, 0, 0, 0, 119, 198);
INSERT INTO public.who_global_data VALUES (28128, 754, 118054, 15, 2463, 119, 173);
INSERT INTO public.who_global_data VALUES (28129, 1, 550, 0, 7, 119, 229);
INSERT INTO public.who_global_data VALUES (28130, 881, 47316, 23, 1012, 119, 76);
INSERT INTO public.who_global_data VALUES (28131, 2952, 838614, 89, 33098, 119, 138);
INSERT INTO public.who_global_data VALUES (28132, 2901, 334770, 83, 6152, 119, 98);
INSERT INTO public.who_global_data VALUES (28133, 0, 0, 0, 0, 119, 103);
INSERT INTO public.who_global_data VALUES (28134, 4739, 116338, 52, 2919, 119, 225);
INSERT INTO public.who_global_data VALUES (28135, 1394, 83928, 12, 2062, 119, 131);
INSERT INTO public.who_global_data VALUES (28136, 598, 52892, 5, 720, 119, 235);
INSERT INTO public.who_global_data VALUES (28137, 206, 127600, 1, 219, 119, 137);
INSERT INTO public.who_global_data VALUES (28138, 72, 24548, 2, 430, 119, 81);
INSERT INTO public.who_global_data VALUES (28139, 918, 60833, 18, 1442, 119, 182);
INSERT INTO public.who_global_data VALUES (28140, 106, 4491, 0, 16, 119, 145);
INSERT INTO public.who_global_data VALUES (28141, 3186, 148886, 52, 5299, 119, 26);
INSERT INTO public.who_global_data VALUES (28142, 12846, 1285084, 197, 22454, 119, 170);
INSERT INTO public.who_global_data VALUES (28143, 5, 4890, 0, 29, 119, 191);
INSERT INTO public.who_global_data VALUES (28144, 0, 5, 0, 0, 119, 221);
INSERT INTO public.who_global_data VALUES (28145, 0, 62, 0, 0, 119, 64);
INSERT INTO public.who_global_data VALUES (28146, 0, 0, 0, 0, 119, 116);
INSERT INTO public.who_global_data VALUES (28147, 0, 19, 0, 0, 119, 128);
INSERT INTO public.who_global_data VALUES (28148, 0, 28, 0, 0, 119, 6);
INSERT INTO public.who_global_data VALUES (28149, 0, 412, 0, 8, 119, 227);
INSERT INTO public.who_global_data VALUES (28150, 0, 12, 0, 0, 119, 68);
INSERT INTO public.who_global_data VALUES (28151, 0, 64, 0, 0, 119, 184);
INSERT INTO public.who_global_data VALUES (28152, 0, 0, 0, 0, 119, 82);
INSERT INTO public.who_global_data VALUES (28153, 14, 766, 0, 42, 119, 149);
INSERT INTO public.who_global_data VALUES (28154, 1, 922, 0, 15, 119, 197);
INSERT INTO public.who_global_data VALUES (28155, 407, 338539, 24, 4996, 119, 78);
INSERT INTO public.who_global_data VALUES (28156, 23, 15213, 0, 313, 119, 233);
INSERT INTO public.who_global_data VALUES (28157, 173, 34517, 1, 761, 119, 133);
INSERT INTO public.who_global_data VALUES (28158, 0, 147, 0, 0, 119, 35);
INSERT INTO public.who_global_data VALUES (28159, 2, 2295, 0, 72, 119, 114);
INSERT INTO public.who_global_data VALUES (28160, 10, 57859, 0, 27, 119, 237);
INSERT INTO public.who_global_data VALUES (28161, 0, 13, 0, 0, 119, 55);
INSERT INTO public.who_global_data VALUES (28162, 1, 699, 0, 22, 119, 176);
INSERT INTO public.who_global_data VALUES (28163, 1184, 16910, 0, 57, 119, 202);
INSERT INTO public.who_global_data VALUES (28164, 380, 8254, 7, 176, 119, 155);
INSERT INTO public.who_global_data VALUES (28165, 0, 1, 0, 0, 119, 32);
INSERT INTO public.who_global_data VALUES (28166, 0, 3745, 0, 99, 119, 220);
INSERT INTO public.who_global_data VALUES (28167, 1641, 688532, 139, 17547, 119, 30);
INSERT INTO public.who_global_data VALUES (28168, 0, 2761, 0, 54, 119, 147);
INSERT INTO public.who_global_data VALUES (28169, 14216, 908603, 129, 35083, 119, 208);
INSERT INTO public.who_global_data VALUES (28170, 35, 4523, 0, 13, 119, 45);
INSERT INTO public.who_global_data VALUES (28171, 9, 13682, 0, 836, 119, 110);
INSERT INTO public.who_global_data VALUES (28172, 25, 5004, 0, 106, 119, 88);
INSERT INTO public.who_global_data VALUES (28173, 834, 98625, 1, 5903, 119, 51);
INSERT INTO public.who_global_data VALUES (28174, 1722, 62833, 3, 1838, 119, 209);
INSERT INTO public.who_global_data VALUES (28175, 50, 4616, 3, 218, 119, 205);
INSERT INTO public.who_global_data VALUES (28176, 40, 10137, 1, 79, 119, 18);
INSERT INTO public.who_global_data VALUES (28177, 6, 3634, 0, 59, 119, 72);
INSERT INTO public.who_global_data VALUES (28178, 13864, 575683, 87, 42679, 119, 44);
INSERT INTO public.who_global_data VALUES (28179, 0, 28, 0, 0, 119, 15);
INSERT INTO public.who_global_data VALUES (28180, 0, 1907, 0, 49, 119, 25);
INSERT INTO public.who_global_data VALUES (28181, 0, 0, 0, 0, 119, 179);
INSERT INTO public.who_global_data VALUES (28182, 0, 0, 0, 0, 119, 34);
INSERT INTO public.who_global_data VALUES (28183, 76, 4963, 2, 86, 119, 207);
INSERT INTO public.who_global_data VALUES (28184, 3137, 31259, 47, 456, 119, 166);
INSERT INTO public.who_global_data VALUES (28185, 8359, 830402, 55, 8722, 119, 126);
INSERT INTO public.who_global_data VALUES (28186, 0, 0, 0, 0, 119, 97);
INSERT INTO public.who_global_data VALUES (28187, 0, 695, 0, 6, 119, 36);
INSERT INTO public.who_global_data VALUES (28188, 0, 0, 0, 0, 119, 125);
INSERT INTO public.who_global_data VALUES (28189, 96, 9538, 1, 86, 119, 124);
INSERT INTO public.who_global_data VALUES (28190, 5728, 256266, 108, 4887, 119, 185);
INSERT INTO public.who_global_data VALUES (28191, 1075, 104004, 4, 442, 119, 194);
INSERT INTO public.who_global_data VALUES (28192, 0, 509, 0, 21, 119, 144);
INSERT INTO public.who_global_data VALUES (28193, 54232, 7525920, 973, 211311, 119, 19);
INSERT INTO public.who_global_data VALUES (28194, 2, 1324, 0, 20, 119, 217);
INSERT INTO public.who_global_data VALUES (28195, 20, 2226, 0, 49, 119, 148);
INSERT INTO public.who_global_data VALUES (28196, 329, 60562, 3, 500, 119, 86);
INSERT INTO public.who_global_data VALUES (28197, 0, 0, 0, 0, 119, 13);
INSERT INTO public.who_global_data VALUES (28198, 615, 81019, 7, 678, 119, 157);
INSERT INTO public.who_global_data VALUES (28199, 5, 1105, 0, 35, 119, 8);
INSERT INTO public.who_global_data VALUES (28200, 0, 0, 0, 0, 119, 73);
INSERT INTO public.who_global_data VALUES (28201, 1, 2055, 0, 594, 119, 101);
INSERT INTO public.who_global_data VALUES (28202, 38, 15339, 1, 336, 119, 165);
INSERT INTO public.who_global_data VALUES (28203, 43, 7994, 0, 229, 119, 14);
INSERT INTO public.who_global_data VALUES (28204, 77, 39779, 2, 1476, 120, 193);
INSERT INTO public.who_global_data VALUES (28205, 169, 14899, 4, 411, 120, 113);
INSERT INTO public.who_global_data VALUES (28206, 138, 52658, 4, 1783, 120, 143);
INSERT INTO public.who_global_data VALUES (28207, 0, 0, 0, 0, 120, 219);
INSERT INTO public.who_global_data VALUES (28208, 0, 2568, 1, 54, 120, 186);
INSERT INTO public.who_global_data VALUES (28209, 95, 5958, 2, 208, 120, 52);
INSERT INTO public.who_global_data VALUES (28210, 0, 3, 0, 0, 120, 180);
INSERT INTO public.who_global_data VALUES (28211, 0, 108, 0, 3, 120, 167);
INSERT INTO public.who_global_data VALUES (28212, 16447, 840915, 399, 22226, 120, 154);
INSERT INTO public.who_global_data VALUES (28213, 614, 54400, 6, 1005, 120, 94);
INSERT INTO public.who_global_data VALUES (28214, 25, 4133, 0, 31, 120, 66);
INSERT INTO public.who_global_data VALUES (28215, 24, 27206, 0, 897, 120, 58);
INSERT INTO public.who_global_data VALUES (28216, 1221, 52603, 9, 853, 120, 163);
INSERT INTO public.who_global_data VALUES (28217, 191, 41304, 1, 603, 120, 37);
INSERT INTO public.who_global_data VALUES (28218, 81, 4713, 0, 102, 120, 142);
INSERT INTO public.who_global_data VALUES (28219, 490, 74422, 2, 264, 120, 83);
INSERT INTO public.who_global_data VALUES (28220, 1441, 374592, 20, 5460, 120, 228);
INSERT INTO public.who_global_data VALUES (28221, 0, 203, 0, 7, 120, 188);
INSERT INTO public.who_global_data VALUES (28222, 477, 81982, 6, 880, 120, 62);
INSERT INTO public.who_global_data VALUES (28223, 6588, 159902, 20, 10142, 120, 160);
INSERT INTO public.who_global_data VALUES (28224, 67, 2310, 0, 34, 120, 50);
INSERT INTO public.who_global_data VALUES (28225, 0, 2411, 0, 41, 120, 33);
INSERT INTO public.who_global_data VALUES (28226, 1, 182, 0, 9, 120, 183);
INSERT INTO public.who_global_data VALUES (28227, 0, 304, 0, 0, 120, 92);
INSERT INTO public.who_global_data VALUES (28228, 238, 137706, 36, 8192, 120, 158);
INSERT INTO public.who_global_data VALUES (28229, 1, 130, 0, 2, 120, 67);
INSERT INTO public.who_global_data VALUES (28230, 454, 29525, 5, 906, 120, 57);
INSERT INTO public.who_global_data VALUES (28231, 47, 3219, 2, 18, 120, 38);
INSERT INTO public.who_global_data VALUES (28232, 31553, 5000694, 734, 148228, 120, 141);
INSERT INTO public.who_global_data VALUES (28233, 0, 71, 0, 1, 120, 178);
INSERT INTO public.who_global_data VALUES (28234, 0, 146, 0, 3, 120, 108);
INSERT INTO public.who_global_data VALUES (28235, 516, 23259, 7, 880, 120, 39);
INSERT INTO public.who_global_data VALUES (28236, 25, 2222, 0, 59, 120, 2);
INSERT INTO public.who_global_data VALUES (28237, 0, 515, 0, 1, 120, 195);
INSERT INTO public.who_global_data VALUES (28238, 93, 6717, 0, 71, 120, 107);
INSERT INTO public.who_global_data VALUES (28239, 1, 282, 0, 0, 120, 161);
INSERT INTO public.who_global_data VALUES (28240, 0, 21160, 0, 420, 120, 212);
INSERT INTO public.who_global_data VALUES (28241, 1800, 173123, 11, 9541, 120, 181);
INSERT INTO public.who_global_data VALUES (28242, 0, 213, 0, 1, 120, 53);
INSERT INTO public.who_global_data VALUES (28243, 0, 4853, 0, 62, 120, 164);
INSERT INTO public.who_global_data VALUES (28244, 11, 1262, 0, 89, 120, 140);
INSERT INTO public.who_global_data VALUES (28245, 1576, 476016, 77, 13167, 120, 20);
INSERT INTO public.who_global_data VALUES (28246, 40, 91252, 0, 4746, 120, 112);
INSERT INTO public.who_global_data VALUES (28247, 7875, 877683, 163, 27180, 120, 111);
INSERT INTO public.who_global_data VALUES (28248, 0, 487, 0, 7, 120, 71);
INSERT INTO public.who_global_data VALUES (28249, 29, 5118, 1, 90, 120, 218);
INSERT INTO public.who_global_data VALUES (28250, 0, 0, 0, 0, 120, 43);
INSERT INTO public.who_global_data VALUES (28251, 1355, 83497, 20, 1024, 120, 49);
INSERT INTO public.who_global_data VALUES (28252, 79, 19982, 0, 120, 120, 1);
INSERT INTO public.who_global_data VALUES (28253, 542, 18989, 1, 310, 120, 48);
INSERT INTO public.who_global_data VALUES (28254, 19, 5917, 0, 123, 120, 232);
INSERT INTO public.who_global_data VALUES (28255, 29, 505, 0, 1, 120, 175);
INSERT INTO public.who_global_data VALUES (28256, 21, 1918, 0, 24, 120, 21);
INSERT INTO public.who_global_data VALUES (28257, 5397, 100757, 40, 869, 120, 156);
INSERT INTO public.who_global_data VALUES (28258, 0, 0, 0, 0, 120, 95);
INSERT INTO public.who_global_data VALUES (28259, 18, 10821, 0, 276, 120, 177);
INSERT INTO public.who_global_data VALUES (28260, 446, 31156, 2, 665, 120, 210);
INSERT INTO public.who_global_data VALUES (28261, 0, 5423, 0, 61, 120, 120);
INSERT INTO public.who_global_data VALUES (28262, 1, 32, 0, 0, 120, 135);
INSERT INTO public.who_global_data VALUES (28263, 724, 116872, 4, 2163, 120, 206);
INSERT INTO public.who_global_data VALUES (28264, 1514, 145045, 398, 12141, 120, 189);
INSERT INTO public.who_global_data VALUES (28265, 121, 104156, 7, 6017, 120, 129);
INSERT INTO public.who_global_data VALUES (28266, 105, 29842, 4, 877, 120, 121);
INSERT INTO public.who_global_data VALUES (28267, 10, 5062, 0, 83, 120, 59);
INSERT INTO public.who_global_data VALUES (28268, 7, 405, 0, 0, 120, 96);
INSERT INTO public.who_global_data VALUES (28269, 45, 3760, 0, 67, 120, 41);
INSERT INTO public.who_global_data VALUES (28270, 15, 5632, 0, 113, 120, 216);
INSERT INTO public.who_global_data VALUES (28271, 902, 81797, 7, 1262, 120, 236);
INSERT INTO public.who_global_data VALUES (28272, 0, 13, 0, 0, 120, 150);
INSERT INTO public.who_global_data VALUES (28273, 1, 477, 0, 0, 120, 61);
INSERT INTO public.who_global_data VALUES (28274, 0, 32, 0, 2, 120, 7);
INSERT INTO public.who_global_data VALUES (28275, 296, 11345, 0, 346, 120, 169);
INSERT INTO public.who_global_data VALUES (28276, 18104, 644573, 76, 32287, 120, 28);
INSERT INTO public.who_global_data VALUES (28277, 25, 10128, 0, 69, 120, 85);
INSERT INTO public.who_global_data VALUES (28278, 0, 2420, 0, 10, 120, 211);
INSERT INTO public.who_global_data VALUES (28279, 0, 8815, 0, 54, 120, 60);
INSERT INTO public.who_global_data VALUES (28280, 8, 3621, 0, 117, 120, 3);
INSERT INTO public.who_global_data VALUES (28281, 527, 10752, 6, 72, 120, 11);
INSERT INTO public.who_global_data VALUES (28282, 4516, 314660, 11, 9589, 120, 89);
INSERT INTO public.who_global_data VALUES (28283, 118, 46947, 3, 306, 120, 24);
INSERT INTO public.who_global_data VALUES (28284, 8, 445, 0, 0, 120, 162);
INSERT INTO public.who_global_data VALUES (28285, 434, 21381, 6, 430, 120, 100);
INSERT INTO public.who_global_data VALUES (28286, 1, 15, 0, 0, 120, 47);
INSERT INTO public.who_global_data VALUES (28287, 0, 24, 0, 0, 120, 29);
INSERT INTO public.who_global_data VALUES (28288, 0, 6319, 0, 77, 120, 40);
INSERT INTO public.who_global_data VALUES (28289, 66, 2934, 1, 58, 120, 222);
INSERT INTO public.who_global_data VALUES (28290, 776, 96480, 12, 3347, 120, 132);
INSERT INTO public.who_global_data VALUES (28291, 1, 258, 0, 13, 120, 130);
INSERT INTO public.who_global_data VALUES (28292, 38, 10901, 0, 68, 120, 234);
INSERT INTO public.who_global_data VALUES (28293, 0, 2362, 0, 39, 120, 23);
INSERT INTO public.who_global_data VALUES (28294, 104, 3292, 3, 95, 120, 192);
INSERT INTO public.who_global_data VALUES (28295, 16, 8854, 1, 230, 120, 69);
INSERT INTO public.who_global_data VALUES (28296, 0, 12, 0, 0, 120, 187);
INSERT INTO public.who_global_data VALUES (28297, 498, 81160, 19, 2466, 120, 230);
INSERT INTO public.who_global_data VALUES (28298, 1176, 35222, 15, 913, 120, 77);
INSERT INTO public.who_global_data VALUES (28299, 95, 3267, 0, 10, 120, 9);
INSERT INTO public.who_global_data VALUES (28300, 70496, 6906151, 964, 106490, 120, 74);
INSERT INTO public.who_global_data VALUES (28301, 4850, 320564, 108, 11580, 120, 224);
INSERT INTO public.who_global_data VALUES (28302, 4392, 488236, 230, 27888, 120, 199);
INSERT INTO public.who_global_data VALUES (28303, 3522, 394566, 79, 9683, 120, 190);
INSERT INTO public.who_global_data VALUES (28304, 502, 40086, 1, 1817, 120, 12);
INSERT INTO public.who_global_data VALUES (28305, 0, 345, 0, 24, 120, 104);
INSERT INTO public.who_global_data VALUES (28306, 4165, 282349, 26, 1848, 120, 153);
INSERT INTO public.who_global_data VALUES (28307, 4458, 338398, 22, 36083, 120, 91);
INSERT INTO public.who_global_data VALUES (28308, 82, 7273, 2, 128, 120, 215);
INSERT INTO public.who_global_data VALUES (28309, 619, 87639, 3, 1616, 120, 84);
INSERT INTO public.who_global_data VALUES (28310, 3, 441, 0, 32, 120, 231);
INSERT INTO public.who_global_data VALUES (28311, 1317, 21585, 13, 144, 120, 196);
INSERT INTO public.who_global_data VALUES (28312, 335, 143280, 0, 2106, 120, 105);
INSERT INTO public.who_global_data VALUES (28313, 271, 40178, 3, 751, 120, 122);
INSERT INTO public.who_global_data VALUES (28314, 0, 0, 0, 0, 120, 159);
INSERT INTO public.who_global_data VALUES (28315, 33, 15928, 0, 628, 120, 75);
INSERT INTO public.who_global_data VALUES (28316, 698, 109441, 3, 642, 120, 27);
INSERT INTO public.who_global_data VALUES (28317, 275, 48617, 4, 1077, 120, 54);
INSERT INTO public.who_global_data VALUES (28318, 0, 23, 0, 0, 120, 226);
INSERT INTO public.who_global_data VALUES (28319, 109, 2370, 0, 40, 120, 79);
INSERT INTO public.who_global_data VALUES (28320, 1367, 49744, 6, 439, 120, 56);
INSERT INTO public.who_global_data VALUES (28321, 84, 1767, 1, 40, 120, 117);
INSERT INTO public.who_global_data VALUES (28322, 6, 1360, 0, 82, 120, 152);
INSERT INTO public.who_global_data VALUES (28323, 1076, 41368, 5, 621, 120, 16);
INSERT INTO public.who_global_data VALUES (28324, 3, 139, 0, 1, 120, 10);
INSERT INTO public.who_global_data VALUES (28325, 133, 5752, 1, 87, 120, 201);
INSERT INTO public.who_global_data VALUES (28326, 100, 9219, 1, 129, 120, 174);
INSERT INTO public.who_global_data VALUES (28327, 21, 16654, 0, 235, 120, 119);
INSERT INTO public.who_global_data VALUES (28328, 6, 5809, 0, 180, 120, 168);
INSERT INTO public.who_global_data VALUES (28329, 375, 14368, 5, 146, 120, 99);
INSERT INTO public.who_global_data VALUES (28330, 86, 10742, 0, 34, 120, 171);
INSERT INTO public.who_global_data VALUES (28331, 25, 3235, 0, 131, 120, 87);
INSERT INTO public.who_global_data VALUES (28332, 75, 3572, 0, 41, 120, 123);
INSERT INTO public.who_global_data VALUES (28333, 0, 0, 0, 0, 120, 151);
INSERT INTO public.who_global_data VALUES (28334, 0, 1851, 0, 22, 120, 213);
INSERT INTO public.who_global_data VALUES (28335, 0, 7523, 0, 161, 120, 118);
INSERT INTO public.who_global_data VALUES (28336, 0, 395, 0, 10, 120, 134);
INSERT INTO public.who_global_data VALUES (28337, 0, 3892, 0, 42, 120, 65);
INSERT INTO public.who_global_data VALUES (28338, 4462, 774020, 369, 80083, 120, 102);
INSERT INTO public.who_global_data VALUES (28339, 0, 0, 0, 0, 120, 223);
INSERT INTO public.who_global_data VALUES (28340, 2, 232, 0, 2, 120, 4);
INSERT INTO public.who_global_data VALUES (28341, 0, 315, 0, 0, 120, 146);
INSERT INTO public.who_global_data VALUES (28342, 362, 13558, 3, 195, 120, 31);
INSERT INTO public.who_global_data VALUES (28343, 0, 13, 0, 1, 120, 127);
INSERT INTO public.who_global_data VALUES (28344, 2929, 142953, 47, 2486, 120, 22);
INSERT INTO public.who_global_data VALUES (28345, 145, 9639, 0, 68, 120, 115);
INSERT INTO public.who_global_data VALUES (28346, 1012, 22445, 25, 535, 120, 106);
INSERT INTO public.who_global_data VALUES (28347, 67, 11781, 1, 127, 120, 90);
INSERT INTO public.who_global_data VALUES (28348, 0, 0, 0, 0, 120, 70);
INSERT INTO public.who_global_data VALUES (28349, 4364, 98617, 12, 590, 120, 46);
INSERT INTO public.who_global_data VALUES (28350, 5789, 155435, 12, 6527, 120, 139);
INSERT INTO public.who_global_data VALUES (28351, 0, 27, 0, 0, 120, 42);
INSERT INTO public.who_global_data VALUES (28352, 2, 1510, 0, 25, 120, 80);
INSERT INTO public.who_global_data VALUES (28353, 0, 4225, 0, 153, 120, 203);
INSERT INTO public.who_global_data VALUES (28354, 0, 1200, 0, 69, 120, 136);
INSERT INTO public.who_global_data VALUES (28355, 103, 59841, 0, 1113, 120, 63);
INSERT INTO public.who_global_data VALUES (28356, 0, 0, 0, 0, 120, 17);
INSERT INTO public.who_global_data VALUES (28357, 0, 75, 0, 2, 120, 172);
INSERT INTO public.who_global_data VALUES (28358, 364, 19777, 3, 775, 120, 109);
INSERT INTO public.who_global_data VALUES (28359, 228, 15012, 0, 275, 120, 200);
INSERT INTO public.who_global_data VALUES (28360, 416, 54355, 4, 422, 120, 93);
INSERT INTO public.who_global_data VALUES (28361, 664, 104129, 9, 1009, 120, 5);
INSERT INTO public.who_global_data VALUES (28362, 0, 741, 0, 13, 120, 214);
INSERT INTO public.who_global_data VALUES (28363, 661, 317595, 8, 6552, 120, 204);
INSERT INTO public.who_global_data VALUES (28364, 0, 0, 0, 0, 120, 198);
INSERT INTO public.who_global_data VALUES (28365, 698, 117300, 8, 2448, 120, 173);
INSERT INTO public.who_global_data VALUES (28366, 8, 549, 0, 7, 120, 229);
INSERT INTO public.who_global_data VALUES (28367, 788, 46435, 23, 989, 120, 76);
INSERT INTO public.who_global_data VALUES (28368, 2733, 835662, 95, 33009, 120, 138);
INSERT INTO public.who_global_data VALUES (28369, 2232, 331869, 144, 6069, 120, 98);
INSERT INTO public.who_global_data VALUES (28370, 0, 0, 0, 0, 120, 103);
INSERT INTO public.who_global_data VALUES (28371, 4280, 111599, 75, 2867, 120, 225);
INSERT INTO public.who_global_data VALUES (28372, 1278, 82534, 10, 2050, 120, 131);
INSERT INTO public.who_global_data VALUES (28373, 526, 52294, 10, 715, 120, 235);
INSERT INTO public.who_global_data VALUES (28374, 213, 127394, 0, 218, 120, 137);
INSERT INTO public.who_global_data VALUES (28375, 54, 24476, 1, 428, 120, 81);
INSERT INTO public.who_global_data VALUES (28376, 1121, 59915, 18, 1424, 120, 182);
INSERT INTO public.who_global_data VALUES (28377, 0, 4385, 0, 16, 120, 145);
INSERT INTO public.who_global_data VALUES (28378, 3130, 145700, 44, 5247, 120, 26);
INSERT INTO public.who_global_data VALUES (28379, 12126, 1272238, 201, 22257, 120, 170);
INSERT INTO public.who_global_data VALUES (28380, 2, 4885, 0, 29, 120, 191);
INSERT INTO public.who_global_data VALUES (28381, 0, 5, 0, 0, 120, 221);
INSERT INTO public.who_global_data VALUES (28382, 0, 62, 0, 0, 120, 64);
INSERT INTO public.who_global_data VALUES (28383, 0, 0, 0, 0, 120, 116);
INSERT INTO public.who_global_data VALUES (28384, 0, 19, 0, 0, 120, 128);
INSERT INTO public.who_global_data VALUES (28385, 0, 28, 0, 0, 120, 6);
INSERT INTO public.who_global_data VALUES (28386, 0, 412, 0, 8, 120, 227);
INSERT INTO public.who_global_data VALUES (28387, 0, 12, 0, 0, 120, 68);
INSERT INTO public.who_global_data VALUES (28388, 0, 64, 0, 0, 120, 184);
INSERT INTO public.who_global_data VALUES (28389, 0, 0, 0, 0, 120, 82);
INSERT INTO public.who_global_data VALUES (28390, 0, 752, 0, 42, 120, 149);
INSERT INTO public.who_global_data VALUES (28391, 7, 921, 0, 15, 120, 197);
INSERT INTO public.who_global_data VALUES (28392, 421, 338132, 25, 4972, 120, 78);
INSERT INTO public.who_global_data VALUES (28393, 49, 15190, 1, 313, 120, 233);
INSERT INTO public.who_global_data VALUES (28394, 151, 34344, 2, 760, 120, 133);
INSERT INTO public.who_global_data VALUES (28395, 0, 147, 0, 0, 120, 35);
INSERT INTO public.who_global_data VALUES (28396, 6, 2293, 0, 72, 120, 114);
INSERT INTO public.who_global_data VALUES (28397, 9, 57849, 0, 27, 120, 237);
INSERT INTO public.who_global_data VALUES (28398, 0, 13, 0, 0, 120, 55);
INSERT INTO public.who_global_data VALUES (28399, 9, 698, 0, 22, 120, 176);
INSERT INTO public.who_global_data VALUES (28400, 1037, 15726, 2, 57, 120, 202);
INSERT INTO public.who_global_data VALUES (28401, 363, 7874, 2, 169, 120, 155);
INSERT INTO public.who_global_data VALUES (28402, 0, 1, 0, 0, 120, 32);
INSERT INTO public.who_global_data VALUES (28403, 0, 3745, 0, 99, 120, 220);
INSERT INTO public.who_global_data VALUES (28404, 3649, 686891, 305, 17408, 120, 30);
INSERT INTO public.who_global_data VALUES (28405, 12, 2761, 1, 54, 120, 147);
INSERT INTO public.who_global_data VALUES (28406, 12666, 894387, 134, 34954, 120, 208);
INSERT INTO public.who_global_data VALUES (28407, 29, 4488, 0, 13, 120, 45);
INSERT INTO public.who_global_data VALUES (28408, 3, 13673, 0, 836, 120, 110);
INSERT INTO public.who_global_data VALUES (28409, 14, 4979, 0, 106, 120, 88);
INSERT INTO public.who_global_data VALUES (28410, 831, 97791, 3, 5902, 120, 51);
INSERT INTO public.who_global_data VALUES (28411, 1471, 61111, 3, 1835, 120, 209);
INSERT INTO public.who_global_data VALUES (28412, 62, 4566, 3, 215, 120, 205);
INSERT INTO public.who_global_data VALUES (28413, 42, 10097, 0, 78, 120, 18);
INSERT INTO public.who_global_data VALUES (28414, 6, 3628, 0, 59, 120, 72);
INSERT INTO public.who_global_data VALUES (28415, 17540, 561819, 77, 42592, 120, 44);
INSERT INTO public.who_global_data VALUES (28416, 0, 28, 0, 0, 120, 15);
INSERT INTO public.who_global_data VALUES (28417, 9, 1907, 0, 49, 120, 25);
INSERT INTO public.who_global_data VALUES (28418, 0, 0, 0, 0, 120, 179);
INSERT INTO public.who_global_data VALUES (28419, 0, 0, 0, 0, 120, 34);
INSERT INTO public.who_global_data VALUES (28420, 11, 4887, 0, 84, 120, 207);
INSERT INTO public.who_global_data VALUES (28421, 0, 28122, 0, 409, 120, 166);
INSERT INTO public.who_global_data VALUES (28422, 8345, 822043, 58, 8667, 120, 126);
INSERT INTO public.who_global_data VALUES (28423, 0, 0, 0, 0, 120, 97);
INSERT INTO public.who_global_data VALUES (28424, 0, 695, 0, 6, 120, 36);
INSERT INTO public.who_global_data VALUES (28425, 0, 0, 0, 0, 120, 125);
INSERT INTO public.who_global_data VALUES (28426, 182, 9442, 0, 85, 120, 124);
INSERT INTO public.who_global_data VALUES (28427, 5804, 250538, 89, 4779, 120, 185);
INSERT INTO public.who_global_data VALUES (28428, 1089, 102929, 2, 438, 120, 194);
INSERT INTO public.who_global_data VALUES (28429, 0, 509, 0, 21, 120, 144);
INSERT INTO public.who_global_data VALUES (28430, 52458, 7471688, 888, 210338, 120, 19);
INSERT INTO public.who_global_data VALUES (28431, 1, 1322, 0, 20, 120, 217);
INSERT INTO public.who_global_data VALUES (28432, 29, 2206, 0, 49, 120, 148);
INSERT INTO public.who_global_data VALUES (28433, 328, 60233, 3, 497, 120, 86);
INSERT INTO public.who_global_data VALUES (28434, 0, 0, 0, 0, 120, 13);
INSERT INTO public.who_global_data VALUES (28435, 608, 80404, 6, 671, 120, 157);
INSERT INTO public.who_global_data VALUES (28436, 1, 1100, 0, 35, 120, 8);
INSERT INTO public.who_global_data VALUES (28437, 0, 0, 0, 0, 120, 73);
INSERT INTO public.who_global_data VALUES (28438, 1, 2054, 0, 594, 120, 101);
INSERT INTO public.who_global_data VALUES (28439, 77, 15301, 0, 335, 120, 165);
INSERT INTO public.who_global_data VALUES (28440, 32, 7951, 0, 229, 120, 14);
INSERT INTO public.who_global_data VALUES (28441, 68, 39702, 1, 1474, 121, 193);
INSERT INTO public.who_global_data VALUES (28442, 162, 14730, 4, 407, 121, 113);
INSERT INTO public.who_global_data VALUES (28443, 121, 52520, 6, 1779, 121, 143);
INSERT INTO public.who_global_data VALUES (28444, 0, 0, 0, 0, 121, 219);
INSERT INTO public.who_global_data VALUES (28445, 198, 2568, 0, 53, 121, 186);
INSERT INTO public.who_global_data VALUES (28446, 333, 5863, 14, 206, 121, 52);
INSERT INTO public.who_global_data VALUES (28447, 0, 3, 0, 0, 121, 180);
INSERT INTO public.who_global_data VALUES (28448, 1, 108, 0, 3, 121, 167);
INSERT INTO public.who_global_data VALUES (28449, 14740, 824468, 359, 21827, 121, 154);
INSERT INTO public.who_global_data VALUES (28450, 718, 53786, 9, 999, 121, 94);
INSERT INTO public.who_global_data VALUES (28451, 14, 4108, 0, 31, 121, 66);
INSERT INTO public.who_global_data VALUES (28452, 8, 27182, 2, 897, 121, 58);
INSERT INTO public.who_global_data VALUES (28453, 947, 51382, 4, 844, 121, 163);
INSERT INTO public.who_global_data VALUES (28454, 182, 41113, 2, 602, 121, 37);
INSERT INTO public.who_global_data VALUES (28455, 73, 4632, 2, 102, 121, 142);
INSERT INTO public.who_global_data VALUES (28456, 456, 73932, 0, 262, 121, 83);
INSERT INTO public.who_global_data VALUES (28457, 1520, 373151, 35, 5440, 121, 228);
INSERT INTO public.who_global_data VALUES (28458, 3, 203, 0, 7, 121, 188);
INSERT INTO public.who_global_data VALUES (28459, 415, 81505, 6, 874, 121, 62);
INSERT INTO public.who_global_data VALUES (28460, 6803, 153314, 20, 10122, 121, 160);
INSERT INTO public.who_global_data VALUES (28461, 39, 2243, 4, 34, 121, 50);
INSERT INTO public.who_global_data VALUES (28462, 0, 2411, 0, 41, 121, 33);
INSERT INTO public.who_global_data VALUES (28463, 0, 181, 0, 9, 121, 183);
INSERT INTO public.who_global_data VALUES (28464, 4, 304, 0, 0, 121, 92);
INSERT INTO public.who_global_data VALUES (28465, 361, 137468, 27, 8156, 121, 158);
INSERT INTO public.who_global_data VALUES (28466, 2, 129, 0, 2, 121, 67);
INSERT INTO public.who_global_data VALUES (28467, 364, 29071, 5, 901, 121, 57);
INSERT INTO public.who_global_data VALUES (28468, 0, 3172, 0, 16, 121, 38);
INSERT INTO public.who_global_data VALUES (28469, 41906, 4969141, 819, 147494, 121, 141);
INSERT INTO public.who_global_data VALUES (28470, 0, 71, 0, 1, 121, 178);
INSERT INTO public.who_global_data VALUES (28471, 0, 146, 0, 3, 121, 108);
INSERT INTO public.who_global_data VALUES (28472, 437, 22743, 11, 873, 121, 39);
INSERT INTO public.who_global_data VALUES (28473, 30, 2197, 0, 59, 121, 2);
INSERT INTO public.who_global_data VALUES (28474, 0, 515, 0, 1, 121, 195);
INSERT INTO public.who_global_data VALUES (28475, 106, 6624, 2, 71, 121, 107);
INSERT INTO public.who_global_data VALUES (28476, 1, 281, 0, 0, 121, 161);
INSERT INTO public.who_global_data VALUES (28477, 236, 21160, 0, 420, 121, 212);
INSERT INTO public.who_global_data VALUES (28478, 2363, 171323, 26, 9530, 121, 181);
INSERT INTO public.who_global_data VALUES (28479, 0, 213, 0, 1, 121, 53);
INSERT INTO public.who_global_data VALUES (28480, 0, 4853, 0, 62, 121, 164);
INSERT INTO public.who_global_data VALUES (28481, 13, 1251, 1, 89, 121, 140);
INSERT INTO public.who_global_data VALUES (28482, 1134, 474440, 20, 13090, 121, 20);
INSERT INTO public.who_global_data VALUES (28483, 24, 91212, 0, 4746, 121, 112);
INSERT INTO public.who_global_data VALUES (28484, 7650, 869808, 173, 27017, 121, 111);
INSERT INTO public.who_global_data VALUES (28485, 0, 487, 0, 7, 121, 71);
INSERT INTO public.who_global_data VALUES (28486, 0, 5089, 0, 89, 121, 218);
INSERT INTO public.who_global_data VALUES (28487, 0, 0, 0, 0, 121, 43);
INSERT INTO public.who_global_data VALUES (28488, 1013, 82142, 17, 1004, 121, 49);
INSERT INTO public.who_global_data VALUES (28489, 18, 19903, 0, 120, 121, 1);
INSERT INTO public.who_global_data VALUES (28490, 363, 18447, 5, 309, 121, 48);
INSERT INTO public.who_global_data VALUES (28491, 15, 5898, 0, 123, 121, 232);
INSERT INTO public.who_global_data VALUES (28492, 14, 476, 0, 1, 121, 175);
INSERT INTO public.who_global_data VALUES (28493, 21, 1897, 1, 24, 121, 21);
INSERT INTO public.who_global_data VALUES (28494, 5338, 95360, 35, 829, 121, 156);
INSERT INTO public.who_global_data VALUES (28495, 0, 0, 0, 0, 121, 95);
INSERT INTO public.who_global_data VALUES (28496, 15, 10803, 2, 276, 121, 177);
INSERT INTO public.who_global_data VALUES (28497, 331, 30710, 0, 663, 121, 210);
INSERT INTO public.who_global_data VALUES (28498, 0, 5423, 0, 61, 121, 120);
INSERT INTO public.who_global_data VALUES (28499, 0, 31, 0, 0, 121, 135);
INSERT INTO public.who_global_data VALUES (28500, 777, 116148, 10, 2159, 121, 206);
INSERT INTO public.who_global_data VALUES (28501, 1475, 143531, 41, 11743, 121, 189);
INSERT INTO public.who_global_data VALUES (28502, 133, 104035, 9, 6010, 121, 129);
INSERT INTO public.who_global_data VALUES (28503, 103, 29737, 4, 873, 121, 121);
INSERT INTO public.who_global_data VALUES (28504, 0, 5052, 0, 83, 121, 59);
INSERT INTO public.who_global_data VALUES (28505, 0, 398, 0, 0, 121, 96);
INSERT INTO public.who_global_data VALUES (28506, 56, 3715, 0, 67, 121, 41);
INSERT INTO public.who_global_data VALUES (28507, 19, 5617, 1, 113, 121, 216);
INSERT INTO public.who_global_data VALUES (28508, 892, 80895, 17, 1255, 121, 236);
INSERT INTO public.who_global_data VALUES (28509, 0, 13, 0, 0, 121, 150);
INSERT INTO public.who_global_data VALUES (28510, 1, 476, 0, 0, 121, 61);
INSERT INTO public.who_global_data VALUES (28511, 0, 32, 0, 2, 121, 7);
INSERT INTO public.who_global_data VALUES (28512, 120, 11049, 0, 346, 121, 169);
INSERT INTO public.who_global_data VALUES (28513, 17932, 626469, 77, 32211, 121, 28);
INSERT INTO public.who_global_data VALUES (28514, 33, 10103, 0, 69, 121, 85);
INSERT INTO public.who_global_data VALUES (28515, 130, 2420, 1, 10, 121, 211);
INSERT INTO public.who_global_data VALUES (28516, 7, 8815, 0, 54, 121, 60);
INSERT INTO public.who_global_data VALUES (28517, 0, 3613, 0, 117, 121, 3);
INSERT INTO public.who_global_data VALUES (28518, 472, 10225, 4, 66, 121, 11);
INSERT INTO public.who_global_data VALUES (28519, 4058, 310144, 16, 9578, 121, 89);
INSERT INTO public.who_global_data VALUES (28520, 0, 46829, 0, 303, 121, 24);
INSERT INTO public.who_global_data VALUES (28521, 5, 437, 0, 0, 121, 162);
INSERT INTO public.who_global_data VALUES (28522, 406, 20947, 4, 424, 121, 100);
INSERT INTO public.who_global_data VALUES (28523, 0, 14, 0, 0, 121, 47);
INSERT INTO public.who_global_data VALUES (28524, 0, 24, 0, 0, 121, 29);
INSERT INTO public.who_global_data VALUES (28525, 416, 6319, 2, 77, 121, 40);
INSERT INTO public.who_global_data VALUES (28526, 50, 2868, 2, 57, 121, 222);
INSERT INTO public.who_global_data VALUES (28527, 834, 95704, 25, 3335, 121, 132);
INSERT INTO public.who_global_data VALUES (28528, 0, 257, 0, 13, 121, 130);
INSERT INTO public.who_global_data VALUES (28529, 0, 10863, 0, 68, 121, 234);
INSERT INTO public.who_global_data VALUES (28530, 0, 2362, 0, 39, 121, 23);
INSERT INTO public.who_global_data VALUES (28531, 0, 3188, 2, 92, 121, 192);
INSERT INTO public.who_global_data VALUES (28532, 19, 8838, 0, 229, 121, 69);
INSERT INTO public.who_global_data VALUES (28533, 0, 12, 0, 0, 121, 187);
INSERT INTO public.who_global_data VALUES (28534, 642, 80662, 14, 2447, 121, 230);
INSERT INTO public.who_global_data VALUES (28535, 932, 34046, 21, 898, 121, 77);
INSERT INTO public.who_global_data VALUES (28536, 91, 3172, 0, 10, 121, 9);
INSERT INTO public.who_global_data VALUES (28537, 78524, 6835655, 971, 105526, 121, 74);
INSERT INTO public.who_global_data VALUES (28538, 4538, 315714, 98, 11472, 121, 224);
INSERT INTO public.who_global_data VALUES (28539, 4019, 483844, 239, 27658, 121, 199);
INSERT INTO public.who_global_data VALUES (28540, 3923, 391044, 73, 9604, 121, 190);
INSERT INTO public.who_global_data VALUES (28541, 609, 39584, 5, 1816, 121, 12);
INSERT INTO public.who_global_data VALUES (28542, 1, 345, 0, 24, 121, 104);
INSERT INTO public.who_global_data VALUES (28543, 4724, 278184, 45, 1822, 121, 153);
INSERT INTO public.who_global_data VALUES (28544, 3677, 333940, 31, 36061, 121, 91);
INSERT INTO public.who_global_data VALUES (28545, 82, 7191, 3, 126, 121, 215);
INSERT INTO public.who_global_data VALUES (28546, 477, 87020, 8, 1613, 121, 84);
INSERT INTO public.who_global_data VALUES (28547, 7, 438, 0, 32, 121, 231);
INSERT INTO public.who_global_data VALUES (28548, 1199, 20268, 9, 131, 121, 196);
INSERT INTO public.who_global_data VALUES (28549, 348, 142945, 0, 2106, 121, 105);
INSERT INTO public.who_global_data VALUES (28550, 321, 39907, 5, 748, 121, 122);
INSERT INTO public.who_global_data VALUES (28551, 0, 0, 0, 0, 121, 159);
INSERT INTO public.who_global_data VALUES (28552, 49, 15895, 3, 628, 121, 75);
INSERT INTO public.who_global_data VALUES (28553, 475, 108743, 7, 639, 121, 27);
INSERT INTO public.who_global_data VALUES (28554, 245, 48342, 4, 1073, 121, 54);
INSERT INTO public.who_global_data VALUES (28555, 0, 23, 0, 0, 121, 226);
INSERT INTO public.who_global_data VALUES (28556, 67, 2261, 1, 40, 121, 79);
INSERT INTO public.who_global_data VALUES (28557, 1459, 48377, 9, 433, 121, 56);
INSERT INTO public.who_global_data VALUES (28558, 44, 1683, 1, 39, 121, 117);
INSERT INTO public.who_global_data VALUES (28559, 0, 1354, 0, 82, 121, 152);
INSERT INTO public.who_global_data VALUES (28560, 779, 40292, 8, 616, 121, 16);
INSERT INTO public.who_global_data VALUES (28561, 3, 136, 0, 1, 121, 10);
INSERT INTO public.who_global_data VALUES (28562, 142, 5619, 1, 86, 121, 201);
INSERT INTO public.who_global_data VALUES (28563, 140, 9119, 0, 128, 121, 174);
INSERT INTO public.who_global_data VALUES (28564, 63, 16633, 2, 235, 121, 119);
INSERT INTO public.who_global_data VALUES (28565, 7, 5803, 0, 180, 121, 168);
INSERT INTO public.who_global_data VALUES (28566, 489, 13993, 0, 141, 121, 99);
INSERT INTO public.who_global_data VALUES (28567, 35, 10656, 0, 34, 121, 171);
INSERT INTO public.who_global_data VALUES (28568, 15, 3210, 0, 131, 121, 87);
INSERT INTO public.who_global_data VALUES (28569, 64, 3497, 0, 41, 121, 123);
INSERT INTO public.who_global_data VALUES (28570, 0, 0, 0, 0, 121, 151);
INSERT INTO public.who_global_data VALUES (28571, 308, 1851, 1, 22, 121, 213);
INSERT INTO public.who_global_data VALUES (28572, 0, 7523, 0, 161, 121, 118);
INSERT INTO public.who_global_data VALUES (28573, 0, 395, 0, 10, 121, 134);
INSERT INTO public.who_global_data VALUES (28574, 0, 3892, 0, 42, 121, 65);
INSERT INTO public.who_global_data VALUES (28575, 4476, 769558, 446, 79714, 121, 102);
INSERT INTO public.who_global_data VALUES (28576, 0, 0, 0, 0, 121, 223);
INSERT INTO public.who_global_data VALUES (28577, 3, 230, 0, 2, 121, 4);
INSERT INTO public.who_global_data VALUES (28578, 0, 315, 0, 0, 121, 146);
INSERT INTO public.who_global_data VALUES (28579, 279, 13196, 1, 192, 121, 31);
INSERT INTO public.who_global_data VALUES (28580, 0, 13, 0, 1, 121, 127);
INSERT INTO public.who_global_data VALUES (28581, 2776, 140024, 29, 2439, 121, 22);
INSERT INTO public.who_global_data VALUES (28582, 298, 9494, 2, 68, 121, 115);
INSERT INTO public.who_global_data VALUES (28583, 1400, 21433, 39, 510, 121, 106);
INSERT INTO public.who_global_data VALUES (28584, 41, 11714, 1, 126, 121, 90);
INSERT INTO public.who_global_data VALUES (28585, 0, 0, 0, 0, 121, 70);
INSERT INTO public.who_global_data VALUES (28586, 3439, 94253, 15, 578, 121, 46);
INSERT INTO public.who_global_data VALUES (28587, 4976, 149646, 36, 6515, 121, 139);
INSERT INTO public.who_global_data VALUES (28588, 0, 27, 0, 0, 121, 42);
INSERT INTO public.who_global_data VALUES (28589, 3, 1508, 0, 25, 121, 80);
INSERT INTO public.who_global_data VALUES (28590, 0, 4225, 0, 153, 121, 203);
INSERT INTO public.who_global_data VALUES (28591, 0, 1200, 0, 69, 121, 136);
INSERT INTO public.who_global_data VALUES (28592, 155, 59738, 0, 1113, 121, 63);
INSERT INTO public.who_global_data VALUES (28593, 0, 0, 0, 0, 121, 17);
INSERT INTO public.who_global_data VALUES (28594, 0, 75, 0, 2, 121, 172);
INSERT INTO public.who_global_data VALUES (28595, 317, 19413, 4, 772, 121, 109);
INSERT INTO public.who_global_data VALUES (28596, 180, 14784, 0, 275, 121, 200);
INSERT INTO public.who_global_data VALUES (28597, 510, 53939, 6, 418, 121, 93);
INSERT INTO public.who_global_data VALUES (28598, 817, 103465, 10, 1000, 121, 5);
INSERT INTO public.who_global_data VALUES (28599, 0, 741, 0, 13, 121, 214);
INSERT INTO public.who_global_data VALUES (28600, 583, 316934, 9, 6544, 121, 204);
INSERT INTO public.who_global_data VALUES (28601, 0, 0, 0, 0, 121, 198);
INSERT INTO public.who_global_data VALUES (28602, 683, 116602, 10, 2440, 121, 173);
INSERT INTO public.who_global_data VALUES (28603, 0, 541, 0, 7, 121, 229);
INSERT INTO public.who_global_data VALUES (28604, 932, 45647, 19, 966, 121, 76);
INSERT INTO public.who_global_data VALUES (28605, 2930, 832929, 80, 32914, 121, 138);
INSERT INTO public.who_global_data VALUES (28606, 2804, 329637, 60, 5925, 121, 98);
INSERT INTO public.who_global_data VALUES (28607, 0, 0, 0, 0, 121, 103);
INSERT INTO public.who_global_data VALUES (28608, 3003, 107319, 75, 2792, 121, 225);
INSERT INTO public.who_global_data VALUES (28609, 944, 81256, 8, 2040, 121, 131);
INSERT INTO public.who_global_data VALUES (28610, 31, 51768, 9, 705, 121, 235);
INSERT INTO public.who_global_data VALUES (28611, 238, 127181, 2, 218, 121, 137);
INSERT INTO public.who_global_data VALUES (28612, 69, 24422, 2, 427, 121, 81);
INSERT INTO public.who_global_data VALUES (28613, 1062, 58794, 17, 1406, 121, 182);
INSERT INTO public.who_global_data VALUES (28614, 57, 4385, 0, 16, 121, 145);
INSERT INTO public.who_global_data VALUES (28615, 2958, 142570, 82, 5203, 121, 26);
INSERT INTO public.who_global_data VALUES (28616, 11493, 1260112, 191, 22056, 121, 170);
INSERT INTO public.who_global_data VALUES (28617, 10, 4883, 0, 29, 121, 191);
INSERT INTO public.who_global_data VALUES (28618, 0, 5, 0, 0, 121, 221);
INSERT INTO public.who_global_data VALUES (28619, 0, 62, 0, 0, 121, 64);
INSERT INTO public.who_global_data VALUES (28620, 0, 0, 0, 0, 121, 116);
INSERT INTO public.who_global_data VALUES (28621, 0, 19, 0, 0, 121, 128);
INSERT INTO public.who_global_data VALUES (28622, 1, 28, 0, 0, 121, 6);
INSERT INTO public.who_global_data VALUES (28623, 0, 412, 0, 8, 121, 227);
INSERT INTO public.who_global_data VALUES (28624, 0, 12, 0, 0, 121, 68);
INSERT INTO public.who_global_data VALUES (28625, 0, 64, 0, 0, 121, 184);
INSERT INTO public.who_global_data VALUES (28626, 0, 0, 0, 0, 121, 82);
INSERT INTO public.who_global_data VALUES (28627, 1, 752, 0, 42, 121, 149);
INSERT INTO public.who_global_data VALUES (28628, 0, 914, 0, 15, 121, 197);
INSERT INTO public.who_global_data VALUES (28629, 468, 337711, 24, 4947, 121, 78);
INSERT INTO public.who_global_data VALUES (28630, 0, 15141, 0, 312, 121, 233);
INSERT INTO public.who_global_data VALUES (28631, 121, 34193, 1, 758, 121, 133);
INSERT INTO public.who_global_data VALUES (28632, 1, 147, 0, 0, 121, 35);
INSERT INTO public.who_global_data VALUES (28633, 10, 2287, 0, 72, 121, 114);
INSERT INTO public.who_global_data VALUES (28634, 10, 57840, 0, 27, 121, 237);
INSERT INTO public.who_global_data VALUES (28635, 0, 13, 0, 0, 121, 55);
INSERT INTO public.who_global_data VALUES (28636, 3, 689, 0, 22, 121, 176);
INSERT INTO public.who_global_data VALUES (28637, 877, 14689, 0, 55, 121, 202);
INSERT INTO public.who_global_data VALUES (28638, 388, 7511, 1, 167, 121, 155);
INSERT INTO public.who_global_data VALUES (28639, 0, 1, 0, 0, 121, 32);
INSERT INTO public.who_global_data VALUES (28640, 0, 3745, 0, 99, 121, 220);
INSERT INTO public.who_global_data VALUES (28641, 0, 683242, 0, 17103, 121, 30);
INSERT INTO public.who_global_data VALUES (28642, 1, 2749, 3, 53, 121, 147);
INSERT INTO public.who_global_data VALUES (28643, 12473, 881721, 130, 34820, 121, 208);
INSERT INTO public.who_global_data VALUES (28644, 207, 4459, 0, 13, 121, 45);
INSERT INTO public.who_global_data VALUES (28645, 2, 13670, 0, 836, 121, 110);
INSERT INTO public.who_global_data VALUES (28646, 11, 4965, 0, 106, 121, 88);
INSERT INTO public.who_global_data VALUES (28647, 786, 96960, 4, 5899, 121, 51);
INSERT INTO public.who_global_data VALUES (28648, 1377, 59640, 2, 1832, 121, 209);
INSERT INTO public.who_global_data VALUES (28649, 47, 4504, 3, 212, 121, 205);
INSERT INTO public.who_global_data VALUES (28650, 41, 10055, 0, 78, 121, 18);
INSERT INTO public.who_global_data VALUES (28651, 7, 3622, 0, 59, 121, 72);
INSERT INTO public.who_global_data VALUES (28652, 14162, 544279, 70, 42515, 121, 44);
INSERT INTO public.who_global_data VALUES (28653, 0, 28, 0, 0, 121, 15);
INSERT INTO public.who_global_data VALUES (28654, 17, 1898, 0, 49, 121, 25);
INSERT INTO public.who_global_data VALUES (28655, 0, 0, 0, 0, 121, 179);
INSERT INTO public.who_global_data VALUES (28656, 0, 0, 0, 0, 121, 34);
INSERT INTO public.who_global_data VALUES (28657, 58, 4876, 1, 84, 121, 207);
INSERT INTO public.who_global_data VALUES (28658, 2357, 28122, 45, 409, 121, 166);
INSERT INTO public.who_global_data VALUES (28659, 8311, 813698, 56, 8609, 121, 126);
INSERT INTO public.who_global_data VALUES (28660, 0, 0, 0, 0, 121, 97);
INSERT INTO public.who_global_data VALUES (28661, 0, 695, 0, 6, 121, 36);
INSERT INTO public.who_global_data VALUES (28662, 0, 0, 0, 0, 121, 125);
INSERT INTO public.who_global_data VALUES (28663, 178, 9260, 1, 85, 121, 124);
INSERT INTO public.who_global_data VALUES (28664, 5397, 244734, 93, 4690, 121, 185);
INSERT INTO public.who_global_data VALUES (28665, 1046, 101840, 1, 436, 121, 194);
INSERT INTO public.who_global_data VALUES (28666, 0, 509, 0, 21, 121, 144);
INSERT INTO public.who_global_data VALUES (28667, 38904, 7419230, 663, 209450, 121, 19);
INSERT INTO public.who_global_data VALUES (28668, -1, 1321, 0, 20, 121, 217);
INSERT INTO public.who_global_data VALUES (28669, 22, 2177, 1, 49, 121, 148);
INSERT INTO public.who_global_data VALUES (28670, 326, 59905, 3, 494, 121, 86);
INSERT INTO public.who_global_data VALUES (28671, 0, 0, 0, 0, 121, 13);
INSERT INTO public.who_global_data VALUES (28672, 679, 79796, 7, 665, 121, 157);
INSERT INTO public.who_global_data VALUES (28673, 1, 1099, 0, 35, 121, 8);
INSERT INTO public.who_global_data VALUES (28674, 0, 0, 0, 0, 121, 73);
INSERT INTO public.who_global_data VALUES (28675, 2, 2053, 0, 594, 121, 101);
INSERT INTO public.who_global_data VALUES (28676, 54, 15224, 0, 335, 121, 165);
INSERT INTO public.who_global_data VALUES (28677, 4, 7919, 0, 229, 121, 14);
INSERT INTO public.who_global_data VALUES (28678, 62, 39634, 2, 1473, 122, 193);
INSERT INTO public.who_global_data VALUES (28679, 158, 14568, 3, 403, 122, 113);
INSERT INTO public.who_global_data VALUES (28680, 129, 52399, 5, 1773, 122, 143);
INSERT INTO public.who_global_data VALUES (28681, 0, 0, 0, 0, 122, 219);
INSERT INTO public.who_global_data VALUES (28682, 0, 2370, 0, 53, 122, 186);
INSERT INTO public.who_global_data VALUES (28683, 0, 5530, 0, 192, 122, 52);
INSERT INTO public.who_global_data VALUES (28684, 0, 3, 0, 0, 122, 180);
INSERT INTO public.who_global_data VALUES (28685, 0, 107, 0, 3, 122, 167);
INSERT INTO public.who_global_data VALUES (28686, 11242, 809728, 450, 21468, 122, 154);
INSERT INTO public.who_global_data VALUES (28687, 672, 53068, 5, 990, 122, 94);
INSERT INTO public.who_global_data VALUES (28688, 15, 4094, 1, 31, 122, 66);
INSERT INTO public.who_global_data VALUES (28689, 25, 27174, 1, 895, 122, 58);
INSERT INTO public.who_global_data VALUES (28690, 549, 50435, 22, 840, 122, 163);
INSERT INTO public.who_global_data VALUES (28691, 143, 40931, 2, 600, 122, 37);
INSERT INTO public.who_global_data VALUES (28692, 107, 4559, 4, 100, 122, 142);
INSERT INTO public.who_global_data VALUES (28693, 360, 73476, 1, 262, 122, 83);
INSERT INTO public.who_global_data VALUES (28694, 1499, 371631, 30, 5405, 122, 228);
INSERT INTO public.who_global_data VALUES (28695, 1, 200, 0, 7, 122, 188);
INSERT INTO public.who_global_data VALUES (28696, 394, 81090, 6, 868, 122, 62);
INSERT INTO public.who_global_data VALUES (28697, 5687, 146511, 18, 10102, 122, 160);
INSERT INTO public.who_global_data VALUES (28698, 8, 2204, 0, 30, 122, 50);
INSERT INTO public.who_global_data VALUES (28699, 54, 2411, 0, 41, 122, 33);
INSERT INTO public.who_global_data VALUES (28700, 0, 181, 0, 9, 122, 183);
INSERT INTO public.who_global_data VALUES (28701, 1, 300, 0, 0, 122, 92);
INSERT INTO public.who_global_data VALUES (28702, 239, 137107, 28, 8129, 122, 158);
INSERT INTO public.who_global_data VALUES (28703, 4, 127, 0, 2, 122, 67);
INSERT INTO public.who_global_data VALUES (28704, 261, 28707, 15, 896, 122, 57);
INSERT INTO public.who_global_data VALUES (28705, 0, 3172, 0, 16, 122, 38);
INSERT INTO public.who_global_data VALUES (28706, 11946, 4927235, 323, 146675, 122, 141);
INSERT INTO public.who_global_data VALUES (28707, 0, 71, 0, 1, 122, 178);
INSERT INTO public.who_global_data VALUES (28708, 0, 146, 0, 3, 122, 108);
INSERT INTO public.who_global_data VALUES (28709, 436, 22306, 8, 862, 122, 39);
INSERT INTO public.who_global_data VALUES (28710, 0, 2167, 0, 59, 122, 2);
INSERT INTO public.who_global_data VALUES (28711, 1, 515, 0, 1, 122, 195);
INSERT INTO public.who_global_data VALUES (28712, 85, 6518, 1, 69, 122, 107);
INSERT INTO public.who_global_data VALUES (28713, 0, 280, 0, 0, 122, 161);
INSERT INTO public.who_global_data VALUES (28714, 0, 20924, 0, 420, 122, 212);
INSERT INTO public.who_global_data VALUES (28715, 2804, 168960, 23, 9504, 122, 181);
INSERT INTO public.who_global_data VALUES (28716, 0, 213, 0, 1, 122, 53);
INSERT INTO public.who_global_data VALUES (28717, 3, 4853, 0, 62, 122, 164);
INSERT INTO public.who_global_data VALUES (28718, 15, 1238, 2, 88, 122, 140);
INSERT INTO public.who_global_data VALUES (28719, 1560, 473306, 33, 13070, 122, 20);
INSERT INTO public.who_global_data VALUES (28720, 18, 91188, 0, 4746, 122, 112);
INSERT INTO public.who_global_data VALUES (28721, 7106, 862158, 132, 26844, 122, 111);
INSERT INTO public.who_global_data VALUES (28722, 0, 487, 0, 7, 122, 71);
INSERT INTO public.who_global_data VALUES (28723, 0, 5089, 0, 89, 122, 218);
INSERT INTO public.who_global_data VALUES (28724, 0, 0, 0, 0, 122, 43);
INSERT INTO public.who_global_data VALUES (28725, 722, 81129, 16, 987, 122, 49);
INSERT INTO public.who_global_data VALUES (28726, 0, 19885, 0, 120, 122, 1);
INSERT INTO public.who_global_data VALUES (28727, 287, 18084, 4, 304, 122, 48);
INSERT INTO public.who_global_data VALUES (28728, 38, 5883, 0, 123, 122, 232);
INSERT INTO public.who_global_data VALUES (28729, 10, 462, 0, 1, 122, 175);
INSERT INTO public.who_global_data VALUES (28730, 29, 1876, 1, 23, 122, 21);
INSERT INTO public.who_global_data VALUES (28731, 4456, 90022, 36, 794, 122, 156);
INSERT INTO public.who_global_data VALUES (28732, 0, 0, 0, 0, 122, 95);
INSERT INTO public.who_global_data VALUES (28733, 11, 10788, 0, 274, 122, 177);
INSERT INTO public.who_global_data VALUES (28734, 322, 30379, 4, 663, 122, 210);
INSERT INTO public.who_global_data VALUES (28735, 2, 5423, 0, 61, 122, 120);
INSERT INTO public.who_global_data VALUES (28736, 0, 31, 0, 0, 122, 135);
INSERT INTO public.who_global_data VALUES (28737, 317, 115371, 5, 2149, 122, 206);
INSERT INTO public.who_global_data VALUES (28738, 717, 142056, 21, 11702, 122, 189);
INSERT INTO public.who_global_data VALUES (28739, 121, 103902, 11, 6001, 122, 129);
INSERT INTO public.who_global_data VALUES (28740, 95, 29634, 4, 869, 122, 121);
INSERT INTO public.who_global_data VALUES (28741, 0, 5052, 0, 83, 122, 59);
INSERT INTO public.who_global_data VALUES (28742, 0, 398, 0, 0, 122, 96);
INSERT INTO public.who_global_data VALUES (28743, 42, 3659, 0, 67, 122, 41);
INSERT INTO public.who_global_data VALUES (28744, 19, 5598, 0, 112, 122, 216);
INSERT INTO public.who_global_data VALUES (28745, 566, 80003, 8, 1238, 122, 236);
INSERT INTO public.who_global_data VALUES (28746, 0, 13, 0, 0, 122, 150);
INSERT INTO public.who_global_data VALUES (28747, 0, 475, 0, 0, 122, 61);
INSERT INTO public.who_global_data VALUES (28748, 0, 32, 0, 2, 122, 7);
INSERT INTO public.who_global_data VALUES (28749, 227, 10929, 0, 346, 122, 169);
INSERT INTO public.who_global_data VALUES (28750, 10476, 608537, 65, 32134, 122, 28);
INSERT INTO public.who_global_data VALUES (28751, 13, 10070, 1, 69, 122, 85);
INSERT INTO public.who_global_data VALUES (28752, 0, 2290, 0, 9, 122, 211);
INSERT INTO public.who_global_data VALUES (28753, 0, 8808, 0, 54, 122, 60);
INSERT INTO public.who_global_data VALUES (28754, 19, 3613, 2, 117, 122, 3);
INSERT INTO public.who_global_data VALUES (28755, 508, 9753, 4, 62, 122, 11);
INSERT INTO public.who_global_data VALUES (28756, 2828, 306086, 16, 9562, 122, 89);
INSERT INTO public.who_global_data VALUES (28757, 0, 46829, 0, 303, 122, 24);
INSERT INTO public.who_global_data VALUES (28758, 0, 432, 0, 0, 122, 162);
INSERT INTO public.who_global_data VALUES (28759, 399, 20541, 3, 420, 122, 100);
INSERT INTO public.who_global_data VALUES (28760, 0, 14, 0, 0, 122, 47);
INSERT INTO public.who_global_data VALUES (28761, 0, 24, 0, 0, 122, 29);
INSERT INTO public.who_global_data VALUES (28762, 0, 5903, 0, 75, 122, 40);
INSERT INTO public.who_global_data VALUES (28763, 65, 2818, 0, 55, 122, 222);
INSERT INTO public.who_global_data VALUES (28764, 688, 94870, 8, 3310, 122, 132);
INSERT INTO public.who_global_data VALUES (28765, 0, 257, 0, 13, 122, 130);
INSERT INTO public.who_global_data VALUES (28766, 63, 10863, 1, 68, 122, 234);
INSERT INTO public.who_global_data VALUES (28767, 0, 2362, 0, 39, 122, 23);
INSERT INTO public.who_global_data VALUES (28768, 95, 3188, 3, 90, 122, 192);
INSERT INTO public.who_global_data VALUES (28769, 0, 8819, 0, 229, 122, 69);
INSERT INTO public.who_global_data VALUES (28770, 0, 12, 0, 0, 122, 187);
INSERT INTO public.who_global_data VALUES (28771, 391, 80020, 11, 2433, 122, 230);
INSERT INTO public.who_global_data VALUES (28772, 816, 33114, 24, 877, 122, 77);
INSERT INTO public.who_global_data VALUES (28773, 101, 3081, 0, 10, 122, 9);
INSERT INTO public.who_global_data VALUES (28774, 72049, 6757131, 986, 104555, 122, 74);
INSERT INTO public.who_global_data VALUES (28775, 4056, 311176, 121, 11374, 122, 224);
INSERT INTO public.who_global_data VALUES (28776, 4151, 479825, 227, 27419, 122, 199);
INSERT INTO public.who_global_data VALUES (28777, 4172, 387121, 67, 9531, 122, 190);
INSERT INTO public.who_global_data VALUES (28778, 424, 38975, 1, 1811, 122, 12);
INSERT INTO public.who_global_data VALUES (28779, 2, 344, 0, 24, 122, 104);
INSERT INTO public.who_global_data VALUES (28780, 5721, 273460, 27, 1777, 122, 153);
INSERT INTO public.who_global_data VALUES (28781, 2677, 330263, 28, 36030, 122, 91);
INSERT INTO public.who_global_data VALUES (28782, 97, 7109, 3, 123, 122, 215);
INSERT INTO public.who_global_data VALUES (28783, 496, 86543, 3, 1605, 122, 84);
INSERT INTO public.who_global_data VALUES (28784, 10, 431, 0, 32, 122, 231);
INSERT INTO public.who_global_data VALUES (28785, 1537, 19069, 12, 122, 122, 196);
INSERT INTO public.who_global_data VALUES (28786, 358, 142597, 0, 2106, 122, 105);
INSERT INTO public.who_global_data VALUES (28787, 137, 39586, 8, 743, 122, 122);
INSERT INTO public.who_global_data VALUES (28788, 0, 0, 0, 0, 122, 159);
INSERT INTO public.who_global_data VALUES (28789, 34, 15846, 3, 625, 122, 75);
INSERT INTO public.who_global_data VALUES (28790, 676, 108268, 4, 632, 122, 27);
INSERT INTO public.who_global_data VALUES (28791, 298, 48097, 3, 1069, 122, 54);
INSERT INTO public.who_global_data VALUES (28792, 0, 23, 0, 0, 122, 226);
INSERT INTO public.who_global_data VALUES (28793, 68, 2194, 0, 39, 122, 79);
INSERT INTO public.who_global_data VALUES (28794, 1261, 46918, 10, 424, 122, 56);
INSERT INTO public.who_global_data VALUES (28795, 0, 1639, 0, 38, 122, 117);
INSERT INTO public.who_global_data VALUES (28796, 0, 1354, 0, 82, 122, 152);
INSERT INTO public.who_global_data VALUES (28797, 1045, 39513, 6, 608, 122, 16);
INSERT INTO public.who_global_data VALUES (28798, 1, 133, 0, 1, 122, 10);
INSERT INTO public.who_global_data VALUES (28799, 116, 5477, 1, 85, 122, 201);
INSERT INTO public.who_global_data VALUES (28800, 54, 8979, 1, 128, 122, 174);
INSERT INTO public.who_global_data VALUES (28801, 0, 16570, 0, 233, 122, 119);
INSERT INTO public.who_global_data VALUES (28802, 2, 5796, 0, 180, 122, 168);
INSERT INTO public.who_global_data VALUES (28803, 691, 13504, 4, 141, 122, 99);
INSERT INTO public.who_global_data VALUES (28804, 54, 10621, 0, 34, 122, 171);
INSERT INTO public.who_global_data VALUES (28805, 6, 3195, 0, 131, 122, 87);
INSERT INTO public.who_global_data VALUES (28806, 68, 3433, 1, 41, 122, 123);
INSERT INTO public.who_global_data VALUES (28807, 0, 0, 0, 0, 122, 151);
INSERT INTO public.who_global_data VALUES (28808, 0, 1543, 0, 21, 122, 213);
INSERT INTO public.who_global_data VALUES (28809, 0, 7523, 0, 161, 122, 118);
INSERT INTO public.who_global_data VALUES (28810, 8, 395, 0, 10, 122, 134);
INSERT INTO public.who_global_data VALUES (28811, 0, 3892, 0, 42, 122, 65);
INSERT INTO public.who_global_data VALUES (28812, 3417, 765082, 180, 79268, 122, 102);
INSERT INTO public.who_global_data VALUES (28813, 0, 0, 0, 0, 122, 223);
INSERT INTO public.who_global_data VALUES (28814, 1, 227, 0, 2, 122, 4);
INSERT INTO public.who_global_data VALUES (28815, 1, 315, 0, 0, 122, 146);
INSERT INTO public.who_global_data VALUES (28816, 218, 12917, 2, 191, 122, 31);
INSERT INTO public.who_global_data VALUES (28817, 0, 13, 0, 1, 122, 127);
INSERT INTO public.who_global_data VALUES (28818, 2553, 137248, 41, 2410, 122, 22);
INSERT INTO public.who_global_data VALUES (28819, 0, 9196, 0, 66, 122, 115);
INSERT INTO public.who_global_data VALUES (28820, 1252, 20033, 27, 471, 122, 106);
INSERT INTO public.who_global_data VALUES (28821, 19, 11673, 0, 125, 122, 90);
INSERT INTO public.who_global_data VALUES (28822, 0, 0, 0, 0, 122, 70);
INSERT INTO public.who_global_data VALUES (28823, 1551, 90814, 9, 563, 122, 46);
INSERT INTO public.who_global_data VALUES (28824, 4525, 144670, 21, 6479, 122, 139);
INSERT INTO public.who_global_data VALUES (28825, 0, 27, 0, 0, 122, 42);
INSERT INTO public.who_global_data VALUES (28826, 3, 1505, 0, 25, 122, 80);
INSERT INTO public.who_global_data VALUES (28827, 79, 4225, 2, 153, 122, 203);
INSERT INTO public.who_global_data VALUES (28828, 0, 1200, 0, 69, 122, 136);
INSERT INTO public.who_global_data VALUES (28829, 118, 59583, 0, 1113, 122, 63);
INSERT INTO public.who_global_data VALUES (28830, 0, 0, 0, 0, 122, 17);
INSERT INTO public.who_global_data VALUES (28831, 0, 75, 0, 2, 122, 172);
INSERT INTO public.who_global_data VALUES (28832, 223, 19096, 8, 768, 122, 109);
INSERT INTO public.who_global_data VALUES (28833, 147, 14604, 0, 275, 122, 200);
INSERT INTO public.who_global_data VALUES (28834, 475, 53429, 10, 412, 122, 93);
INSERT INTO public.who_global_data VALUES (28835, 834, 102648, 5, 990, 122, 5);
INSERT INTO public.who_global_data VALUES (28836, 0, 741, 0, 13, 122, 214);
INSERT INTO public.who_global_data VALUES (28837, 624, 316351, 12, 6535, 122, 204);
INSERT INTO public.who_global_data VALUES (28838, 0, 0, 0, 0, 122, 198);
INSERT INTO public.who_global_data VALUES (28839, 633, 115919, 7, 2430, 122, 173);
INSERT INTO public.who_global_data VALUES (28840, 0, 541, 0, 7, 122, 229);
INSERT INTO public.who_global_data VALUES (28841, 533, 44715, 18, 947, 122, 76);
INSERT INTO public.who_global_data VALUES (28842, 1830, 829999, 92, 32834, 122, 138);
INSERT INTO public.who_global_data VALUES (28843, 2071, 326833, 25, 5865, 122, 98);
INSERT INTO public.who_global_data VALUES (28844, 0, 0, 0, 0, 122, 103);
INSERT INTO public.who_global_data VALUES (28845, 2236, 104316, 58, 2717, 122, 225);
INSERT INTO public.who_global_data VALUES (28846, 427, 80312, 14, 2032, 122, 131);
INSERT INTO public.who_global_data VALUES (28847, 432, 51737, 1, 696, 122, 235);
INSERT INTO public.who_global_data VALUES (28848, 251, 126943, 0, 216, 122, 137);
INSERT INTO public.who_global_data VALUES (28849, 114, 24353, 3, 425, 122, 81);
INSERT INTO public.who_global_data VALUES (28850, 831, 57732, 14, 1389, 122, 182);
INSERT INTO public.who_global_data VALUES (28851, 0, 4328, 0, 16, 122, 145);
INSERT INTO public.who_global_data VALUES (28852, 2121, 139612, 73, 5121, 122, 26);
INSERT INTO public.who_global_data VALUES (28853, 11115, 1248619, 202, 21865, 122, 170);
INSERT INTO public.who_global_data VALUES (28854, 6, 4873, 0, 29, 122, 191);
INSERT INTO public.who_global_data VALUES (28855, 0, 5, 0, 0, 122, 221);
INSERT INTO public.who_global_data VALUES (28856, 0, 62, 0, 0, 122, 64);
INSERT INTO public.who_global_data VALUES (28857, 0, 0, 0, 0, 122, 116);
INSERT INTO public.who_global_data VALUES (28858, 0, 19, 0, 0, 122, 128);
INSERT INTO public.who_global_data VALUES (28859, 0, 27, 0, 0, 122, 6);
INSERT INTO public.who_global_data VALUES (28860, 0, 412, 0, 8, 122, 227);
INSERT INTO public.who_global_data VALUES (28861, 0, 12, 0, 0, 122, 68);
INSERT INTO public.who_global_data VALUES (28862, 0, 64, 0, 0, 122, 184);
INSERT INTO public.who_global_data VALUES (28863, 0, 0, 0, 0, 122, 82);
INSERT INTO public.who_global_data VALUES (28864, 0, 751, 0, 42, 122, 149);
INSERT INTO public.who_global_data VALUES (28865, 1, 914, 0, 15, 122, 197);
INSERT INTO public.who_global_data VALUES (28866, 477, 337243, 25, 4923, 122, 78);
INSERT INTO public.who_global_data VALUES (28867, 19, 15141, 0, 312, 122, 233);
INSERT INTO public.who_global_data VALUES (28868, 120, 34072, 1, 757, 122, 133);
INSERT INTO public.who_global_data VALUES (28869, 4, 146, 0, 0, 122, 35);
INSERT INTO public.who_global_data VALUES (28870, 8, 2277, 0, 72, 122, 114);
INSERT INTO public.who_global_data VALUES (28871, 11, 57830, 0, 27, 122, 237);
INSERT INTO public.who_global_data VALUES (28872, 0, 13, 0, 0, 122, 55);
INSERT INTO public.who_global_data VALUES (28873, 7, 686, 0, 22, 122, 176);
INSERT INTO public.who_global_data VALUES (28874, 320, 13812, 0, 55, 122, 202);
INSERT INTO public.who_global_data VALUES (28875, 357, 7123, 0, 166, 122, 155);
INSERT INTO public.who_global_data VALUES (28876, 0, 1, 0, 0, 122, 32);
INSERT INTO public.who_global_data VALUES (28877, 0, 3745, 0, 99, 122, 220);
INSERT INTO public.who_global_data VALUES (28878, 1027, 683242, 87, 17103, 122, 30);
INSERT INTO public.who_global_data VALUES (28879, 14, 2748, 0, 50, 122, 147);
INSERT INTO public.who_global_data VALUES (28880, 9038, 869248, 132, 34690, 122, 208);
INSERT INTO public.who_global_data VALUES (28881, 519, 4252, 0, 13, 122, 45);
INSERT INTO public.who_global_data VALUES (28882, 0, 13668, 0, 836, 122, 110);
INSERT INTO public.who_global_data VALUES (28883, 13, 4954, 0, 106, 122, 88);
INSERT INTO public.who_global_data VALUES (28884, 374, 96174, 2, 5895, 122, 51);
INSERT INTO public.who_global_data VALUES (28885, 1097, 58263, 1, 1830, 122, 209);
INSERT INTO public.who_global_data VALUES (28886, 46, 4457, 2, 209, 122, 205);
INSERT INTO public.who_global_data VALUES (28887, 40, 10014, 0, 78, 122, 18);
INSERT INTO public.who_global_data VALUES (28888, 15, 3615, 0, 59, 122, 72);
INSERT INTO public.who_global_data VALUES (28889, 14542, 530117, 76, 42445, 122, 44);
INSERT INTO public.who_global_data VALUES (28890, 0, 28, 0, 0, 122, 15);
INSERT INTO public.who_global_data VALUES (28891, 17, 1881, 1, 49, 122, 25);
INSERT INTO public.who_global_data VALUES (28892, 0, 0, 0, 0, 122, 179);
INSERT INTO public.who_global_data VALUES (28893, 0, 0, 0, 0, 122, 34);
INSERT INTO public.who_global_data VALUES (28894, 52, 4818, 2, 83, 122, 207);
INSERT INTO public.who_global_data VALUES (28895, 0, 25765, 0, 364, 122, 166);
INSERT INTO public.who_global_data VALUES (28896, 8241, 805387, 55, 8553, 122, 126);
INSERT INTO public.who_global_data VALUES (28897, 0, 0, 0, 0, 122, 97);
INSERT INTO public.who_global_data VALUES (28898, 0, 695, 0, 6, 122, 36);
INSERT INTO public.who_global_data VALUES (28899, 0, 0, 0, 0, 122, 125);
INSERT INTO public.who_global_data VALUES (28900, 117, 9082, 2, 84, 122, 124);
INSERT INTO public.who_global_data VALUES (28901, 4753, 239337, 77, 4597, 122, 185);
INSERT INTO public.who_global_data VALUES (28902, 1061, 100794, 6, 435, 122, 194);
INSERT INTO public.who_global_data VALUES (28903, 0, 509, 0, 21, 122, 144);
INSERT INTO public.who_global_data VALUES (28904, 38920, 7380326, 354, 208787, 122, 19);
INSERT INTO public.who_global_data VALUES (28905, -5, 1322, 0, 20, 122, 217);
INSERT INTO public.who_global_data VALUES (28906, 10, 2155, 0, 48, 122, 148);
INSERT INTO public.who_global_data VALUES (28907, 382, 59579, 4, 491, 122, 86);
INSERT INTO public.who_global_data VALUES (28908, 0, 0, 0, 0, 122, 13);
INSERT INTO public.who_global_data VALUES (28909, 683, 79117, 5, 658, 122, 157);
INSERT INTO public.who_global_data VALUES (28910, 1, 1098, 0, 35, 122, 8);
INSERT INTO public.who_global_data VALUES (28911, 0, 0, 0, 0, 122, 73);
INSERT INTO public.who_global_data VALUES (28912, 6, 2051, 1, 594, 122, 101);
INSERT INTO public.who_global_data VALUES (28913, 81, 15170, 1, 335, 122, 165);
INSERT INTO public.who_global_data VALUES (28914, 17, 7915, 1, 229, 122, 14);
INSERT INTO public.who_global_data VALUES (28915, 64, 39572, 1, 1471, 123, 193);
INSERT INTO public.who_global_data VALUES (28916, 144, 14410, 4, 400, 123, 113);
INSERT INTO public.who_global_data VALUES (28917, 134, 52270, 8, 1768, 123, 143);
INSERT INTO public.who_global_data VALUES (28918, 0, 0, 0, 0, 123, 219);
INSERT INTO public.who_global_data VALUES (28919, 260, 2370, 0, 53, 123, 186);
INSERT INTO public.who_global_data VALUES (28920, 160, 5530, 7, 192, 123, 52);
INSERT INTO public.who_global_data VALUES (28921, 0, 3, 0, 0, 123, 180);
INSERT INTO public.who_global_data VALUES (28922, 0, 107, 0, 3, 123, 167);
INSERT INTO public.who_global_data VALUES (28923, 7668, 798486, 223, 21018, 123, 154);
INSERT INTO public.who_global_data VALUES (28924, 406, 52396, 6, 985, 123, 94);
INSERT INTO public.who_global_data VALUES (28925, 81, 4079, 3, 30, 123, 66);
INSERT INTO public.who_global_data VALUES (28926, 13, 27149, 0, 894, 123, 58);
INSERT INTO public.who_global_data VALUES (28927, 1268, 49886, 5, 818, 123, 163);
INSERT INTO public.who_global_data VALUES (28928, 97, 40788, 2, 598, 123, 37);
INSERT INTO public.who_global_data VALUES (28929, 43, 4452, 0, 96, 123, 142);
INSERT INTO public.who_global_data VALUES (28930, 454, 73116, 1, 261, 123, 83);
INSERT INTO public.who_global_data VALUES (28931, 1442, 370132, 27, 5375, 123, 228);
INSERT INTO public.who_global_data VALUES (28932, 3, 199, 0, 7, 123, 188);
INSERT INTO public.who_global_data VALUES (28933, 401, 80696, 5, 862, 123, 62);
INSERT INTO public.who_global_data VALUES (28934, 5249, 140824, 14, 10084, 123, 160);
INSERT INTO public.who_global_data VALUES (28935, 65, 2196, 1, 30, 123, 50);
INSERT INTO public.who_global_data VALUES (28936, 0, 2357, 0, 41, 123, 33);
INSERT INTO public.who_global_data VALUES (28937, 0, 181, 0, 9, 123, 183);
INSERT INTO public.who_global_data VALUES (28938, 1, 299, 0, 0, 123, 92);
INSERT INTO public.who_global_data VALUES (28939, 299, 136868, 28, 8101, 123, 158);
INSERT INTO public.who_global_data VALUES (28940, 10, 123, 0, 2, 123, 67);
INSERT INTO public.who_global_data VALUES (28941, 144, 28446, 9, 881, 123, 57);
INSERT INTO public.who_global_data VALUES (28942, 0, 3172, 0, 16, 123, 38);
INSERT INTO public.who_global_data VALUES (28943, 8456, 4915289, 365, 146352, 123, 141);
INSERT INTO public.who_global_data VALUES (28944, 0, 71, 0, 1, 123, 178);
INSERT INTO public.who_global_data VALUES (28945, 0, 146, 0, 3, 123, 108);
INSERT INTO public.who_global_data VALUES (28946, 283, 21870, 10, 854, 123, 39);
INSERT INTO public.who_global_data VALUES (28947, 13, 2167, 0, 59, 123, 2);
INSERT INTO public.who_global_data VALUES (28948, 0, 514, 0, 1, 123, 195);
INSERT INTO public.who_global_data VALUES (28949, 73, 6433, 3, 68, 123, 107);
INSERT INTO public.who_global_data VALUES (28950, 0, 280, 0, 0, 123, 161);
INSERT INTO public.who_global_data VALUES (28951, 49, 20924, 2, 420, 123, 212);
INSERT INTO public.who_global_data VALUES (28952, 1685, 166156, 19, 9481, 123, 181);
INSERT INTO public.who_global_data VALUES (28953, 0, 213, 0, 1, 123, 53);
INSERT INTO public.who_global_data VALUES (28954, 5, 4850, 0, 62, 123, 164);
INSERT INTO public.who_global_data VALUES (28955, 6, 1223, 0, 86, 123, 140);
INSERT INTO public.who_global_data VALUES (28956, 1567, 471746, 58, 13037, 123, 20);
INSERT INTO public.who_global_data VALUES (28957, 24, 91170, 0, 4746, 123, 112);
INSERT INTO public.who_global_data VALUES (28958, 6905, 855052, 156, 26712, 123, 111);
INSERT INTO public.who_global_data VALUES (28959, 0, 487, 0, 7, 123, 71);
INSERT INTO public.who_global_data VALUES (28960, 0, 5089, 0, 89, 123, 218);
INSERT INTO public.who_global_data VALUES (28961, 0, 0, 0, 0, 123, 43);
INSERT INTO public.who_global_data VALUES (28962, 1225, 80407, 21, 971, 123, 49);
INSERT INTO public.who_global_data VALUES (28963, 36, 19885, 0, 120, 123, 1);
INSERT INTO public.who_global_data VALUES (28964, 138, 17797, 2, 300, 123, 48);
INSERT INTO public.who_global_data VALUES (28965, 36, 5845, 1, 123, 123, 232);
INSERT INTO public.who_global_data VALUES (28966, 53, 452, 0, 1, 123, 175);
INSERT INTO public.who_global_data VALUES (28967, 23, 1847, 0, 22, 123, 21);
INSERT INTO public.who_global_data VALUES (28968, 3120, 85566, 31, 758, 123, 156);
INSERT INTO public.who_global_data VALUES (28969, 0, 0, 0, 0, 123, 95);
INSERT INTO public.who_global_data VALUES (28970, 18, 10777, 0, 274, 123, 177);
INSERT INTO public.who_global_data VALUES (28971, 377, 30057, 1, 659, 123, 210);
INSERT INTO public.who_global_data VALUES (28972, 2, 5421, 0, 61, 123, 120);
INSERT INTO public.who_global_data VALUES (28973, 0, 31, 0, 0, 123, 135);
INSERT INTO public.who_global_data VALUES (28974, 574, 115054, 10, 2144, 123, 206);
INSERT INTO public.who_global_data VALUES (28975, 305, 141339, 34, 11681, 123, 189);
INSERT INTO public.who_global_data VALUES (28976, 98, 103781, 9, 5990, 123, 129);
INSERT INTO public.who_global_data VALUES (28977, 89, 29539, 2, 865, 123, 121);
INSERT INTO public.who_global_data VALUES (28978, 7, 5052, 0, 83, 123, 59);
INSERT INTO public.who_global_data VALUES (28979, 0, 398, 0, 0, 123, 96);
INSERT INTO public.who_global_data VALUES (28980, 10, 3617, 0, 67, 123, 41);
INSERT INTO public.who_global_data VALUES (28981, 10, 5579, 1, 112, 123, 216);
INSERT INTO public.who_global_data VALUES (28982, 618, 79437, 8, 1230, 123, 236);
INSERT INTO public.who_global_data VALUES (28983, 0, 13, 0, 0, 123, 150);
INSERT INTO public.who_global_data VALUES (28984, 1, 475, 0, 0, 123, 61);
INSERT INTO public.who_global_data VALUES (28985, 0, 32, 0, 2, 123, 7);
INSERT INTO public.who_global_data VALUES (28986, 164, 10702, 1, 346, 123, 169);
INSERT INTO public.who_global_data VALUES (28987, 4813, 598061, 68, 32069, 123, 28);
INSERT INTO public.who_global_data VALUES (28988, 28, 10057, 1, 68, 123, 85);
INSERT INTO public.who_global_data VALUES (28989, 264, 2290, 1, 9, 123, 211);
INSERT INTO public.who_global_data VALUES (28990, 11, 8808, 0, 54, 123, 60);
INSERT INTO public.who_global_data VALUES (28991, 0, 3594, 0, 115, 123, 3);
INSERT INTO public.who_global_data VALUES (28992, 549, 9245, 6, 58, 123, 11);
INSERT INTO public.who_global_data VALUES (28993, 2639, 303258, 12, 9546, 123, 89);
INSERT INTO public.who_global_data VALUES (28994, 0, 46829, 0, 303, 123, 24);
INSERT INTO public.who_global_data VALUES (28995, 4, 432, 0, 0, 123, 162);
INSERT INTO public.who_global_data VALUES (28996, 300, 20142, 8, 417, 123, 100);
INSERT INTO public.who_global_data VALUES (28997, 0, 14, 0, 0, 123, 47);
INSERT INTO public.who_global_data VALUES (28998, 0, 24, 0, 0, 123, 29);
INSERT INTO public.who_global_data VALUES (28999, 0, 5903, 0, 75, 123, 40);
INSERT INTO public.who_global_data VALUES (29000, 53, 2753, 3, 55, 123, 222);
INSERT INTO public.who_global_data VALUES (29001, 219, 94182, 9, 3302, 123, 132);
INSERT INTO public.who_global_data VALUES (29002, 0, 257, 0, 13, 123, 130);
INSERT INTO public.who_global_data VALUES (29003, 46, 10800, 1, 67, 123, 234);
INSERT INTO public.who_global_data VALUES (29004, 0, 2362, 0, 39, 123, 23);
INSERT INTO public.who_global_data VALUES (29005, 88, 3093, 2, 87, 123, 192);
INSERT INTO public.who_global_data VALUES (29006, 0, 8819, 0, 229, 123, 69);
INSERT INTO public.who_global_data VALUES (29007, 0, 12, 0, 0, 123, 187);
INSERT INTO public.who_global_data VALUES (29008, 841, 79629, 23, 2422, 123, 230);
INSERT INTO public.who_global_data VALUES (29009, 818, 32298, 20, 853, 123, 77);
INSERT INTO public.who_global_data VALUES (29010, 59, 2980, 0, 10, 123, 9);
INSERT INTO public.who_global_data VALUES (29011, 61267, 6685082, 884, 103569, 123, 74);
INSERT INTO public.who_global_data VALUES (29012, 3622, 307120, 102, 11253, 123, 224);
INSERT INTO public.who_global_data VALUES (29013, 3902, 475674, 235, 27192, 123, 199);
INSERT INTO public.who_global_data VALUES (29014, 3808, 382949, 65, 9464, 123, 190);
INSERT INTO public.who_global_data VALUES (29015, 519, 38551, 0, 1810, 123, 12);
INSERT INTO public.who_global_data VALUES (29016, 0, 342, 0, 24, 123, 104);
INSERT INTO public.who_global_data VALUES (29017, 2938, 267739, 37, 1750, 123, 153);
INSERT INTO public.who_global_data VALUES (29018, 2257, 327586, 16, 36002, 123, 91);
INSERT INTO public.who_global_data VALUES (29019, 117, 7012, 0, 120, 123, 215);
INSERT INTO public.who_global_data VALUES (29020, 308, 86047, 3, 1602, 123, 84);
INSERT INTO public.who_global_data VALUES (29021, 0, 421, 0, 32, 123, 231);
INSERT INTO public.who_global_data VALUES (29022, 1824, 17532, 9, 110, 123, 196);
INSERT INTO public.who_global_data VALUES (29023, 328, 142239, 0, 2106, 123, 105);
INSERT INTO public.who_global_data VALUES (29024, 22, 39449, 4, 735, 123, 122);
INSERT INTO public.who_global_data VALUES (29025, 0, 0, 0, 0, 123, 159);
INSERT INTO public.who_global_data VALUES (29026, 41, 15812, 2, 622, 123, 75);
INSERT INTO public.who_global_data VALUES (29027, 567, 107592, 4, 628, 123, 27);
INSERT INTO public.who_global_data VALUES (29028, 164, 47799, 0, 1066, 123, 54);
INSERT INTO public.who_global_data VALUES (29029, 0, 23, 0, 0, 123, 226);
INSERT INTO public.who_global_data VALUES (29030, 40, 2126, 1, 39, 123, 79);
INSERT INTO public.who_global_data VALUES (29031, 1175, 45657, 8, 414, 123, 56);
INSERT INTO public.who_global_data VALUES (29032, 0, 1639, 0, 38, 123, 117);
INSERT INTO public.who_global_data VALUES (29033, 6, 1354, 0, 82, 123, 152);
INSERT INTO public.who_global_data VALUES (29034, 1031, 38468, 6, 602, 123, 16);
INSERT INTO public.who_global_data VALUES (29035, 3, 132, 0, 1, 123, 10);
INSERT INTO public.who_global_data VALUES (29036, 80, 5361, 2, 84, 123, 201);
INSERT INTO public.who_global_data VALUES (29037, 216, 8925, 2, 127, 123, 174);
INSERT INTO public.who_global_data VALUES (29038, 12, 16570, 1, 233, 123, 119);
INSERT INTO public.who_global_data VALUES (29039, 8, 5794, 1, 180, 123, 168);
INSERT INTO public.who_global_data VALUES (29040, 432, 12813, 0, 137, 123, 99);
INSERT INTO public.who_global_data VALUES (29041, 37, 10567, 0, 34, 123, 171);
INSERT INTO public.who_global_data VALUES (29042, 5, 3189, 0, 131, 123, 87);
INSERT INTO public.who_global_data VALUES (29043, 47, 3365, 1, 40, 123, 123);
INSERT INTO public.who_global_data VALUES (29044, 0, 0, 0, 0, 123, 151);
INSERT INTO public.who_global_data VALUES (29045, 0, 1543, 0, 21, 123, 213);
INSERT INTO public.who_global_data VALUES (29046, 3, 7523, 0, 161, 123, 118);
INSERT INTO public.who_global_data VALUES (29047, 2, 387, 0, 10, 123, 134);
INSERT INTO public.who_global_data VALUES (29048, 113, 3892, 0, 42, 123, 65);
INSERT INTO public.who_global_data VALUES (29049, 3712, 761665, 208, 79088, 123, 102);
INSERT INTO public.who_global_data VALUES (29050, 0, 0, 0, 0, 123, 223);
INSERT INTO public.who_global_data VALUES (29051, 1, 226, 0, 2, 123, 4);
INSERT INTO public.who_global_data VALUES (29052, 1, 314, 0, 0, 123, 146);
INSERT INTO public.who_global_data VALUES (29053, 192, 12699, 5, 189, 123, 31);
INSERT INTO public.who_global_data VALUES (29054, 0, 13, 0, 1, 123, 127);
INSERT INTO public.who_global_data VALUES (29055, 1423, 134695, 39, 2369, 123, 22);
INSERT INTO public.who_global_data VALUES (29056, 0, 9196, 0, 66, 123, 115);
INSERT INTO public.who_global_data VALUES (29057, 987, 18781, 32, 444, 123, 106);
INSERT INTO public.who_global_data VALUES (29058, 28, 11654, 2, 125, 123, 90);
INSERT INTO public.who_global_data VALUES (29059, 0, 0, 0, 0, 123, 70);
INSERT INTO public.who_global_data VALUES (29060, 2440, 89263, 19, 554, 123, 46);
INSERT INTO public.who_global_data VALUES (29061, 4556, 140145, 7, 6458, 123, 139);
INSERT INTO public.who_global_data VALUES (29062, 0, 27, 0, 0, 123, 42);
INSERT INTO public.who_global_data VALUES (29063, 3, 1502, 0, 25, 123, 80);
INSERT INTO public.who_global_data VALUES (29064, 0, 4146, 0, 151, 123, 203);
INSERT INTO public.who_global_data VALUES (29065, 0, 1200, 0, 69, 123, 136);
INSERT INTO public.who_global_data VALUES (29066, 120, 59465, 0, 1113, 123, 63);
INSERT INTO public.who_global_data VALUES (29067, 0, 0, 0, 0, 123, 17);
INSERT INTO public.who_global_data VALUES (29068, 2, 75, 0, 2, 123, 172);
INSERT INTO public.who_global_data VALUES (29069, 83, 18873, 4, 760, 123, 109);
INSERT INTO public.who_global_data VALUES (29070, 308, 14457, 0, 275, 123, 200);
INSERT INTO public.who_global_data VALUES (29071, 521, 52954, 11, 402, 123, 93);
INSERT INTO public.who_global_data VALUES (29072, 544, 101814, 8, 985, 123, 5);
INSERT INTO public.who_global_data VALUES (29073, 0, 741, 0, 13, 123, 214);
INSERT INTO public.who_global_data VALUES (29074, 467, 315727, 6, 6523, 123, 204);
INSERT INTO public.who_global_data VALUES (29075, 0, 0, 0, 0, 123, 198);
INSERT INTO public.who_global_data VALUES (29076, 633, 115286, 9, 2423, 123, 173);
INSERT INTO public.who_global_data VALUES (29077, 1, 541, 0, 7, 123, 229);
INSERT INTO public.who_global_data VALUES (29078, 730, 44182, 16, 929, 123, 76);
INSERT INTO public.who_global_data VALUES (29079, 3184, 828169, 77, 32742, 123, 138);
INSERT INTO public.who_global_data VALUES (29080, 2265, 324762, 64, 5840, 123, 98);
INSERT INTO public.who_global_data VALUES (29081, 0, 0, 0, 0, 123, 103);
INSERT INTO public.who_global_data VALUES (29082, 3940, 102080, 55, 2659, 123, 225);
INSERT INTO public.who_global_data VALUES (29083, 1638, 79885, 23, 2018, 123, 131);
INSERT INTO public.who_global_data VALUES (29084, 630, 51305, 9, 695, 123, 235);
INSERT INTO public.who_global_data VALUES (29085, 194, 126692, 0, 216, 123, 137);
INSERT INTO public.who_global_data VALUES (29086, 75, 24239, 0, 422, 123, 81);
INSERT INTO public.who_global_data VALUES (29087, 322, 56901, 9, 1375, 123, 182);
INSERT INTO public.who_global_data VALUES (29088, 150, 4328, 0, 16, 123, 145);
INSERT INTO public.who_global_data VALUES (29089, 3426, 137491, 101, 5048, 123, 26);
INSERT INTO public.who_global_data VALUES (29090, 11615, 1237504, 188, 21663, 123, 170);
INSERT INTO public.who_global_data VALUES (29091, 1, 4867, 0, 29, 123, 191);
INSERT INTO public.who_global_data VALUES (29092, 0, 5, 0, 0, 123, 221);
INSERT INTO public.who_global_data VALUES (29093, 0, 62, 0, 0, 123, 64);
INSERT INTO public.who_global_data VALUES (29094, 0, 0, 0, 0, 123, 116);
INSERT INTO public.who_global_data VALUES (29095, 0, 19, 0, 0, 123, 128);
INSERT INTO public.who_global_data VALUES (29096, 0, 27, 0, 0, 123, 6);
INSERT INTO public.who_global_data VALUES (29097, 0, 412, 0, 8, 123, 227);
INSERT INTO public.who_global_data VALUES (29098, 0, 12, 0, 0, 123, 68);
INSERT INTO public.who_global_data VALUES (29099, 0, 64, 0, 0, 123, 184);
INSERT INTO public.who_global_data VALUES (29100, 0, 0, 0, 0, 123, 82);
INSERT INTO public.who_global_data VALUES (29101, 1, 751, 0, 42, 123, 149);
INSERT INTO public.who_global_data VALUES (29102, 0, 913, 0, 15, 123, 197);
INSERT INTO public.who_global_data VALUES (29103, 379, 336766, 23, 4898, 123, 78);
INSERT INTO public.who_global_data VALUES (29104, 28, 15122, 0, 312, 123, 233);
INSERT INTO public.who_global_data VALUES (29105, 51, 33952, 2, 756, 123, 133);
INSERT INTO public.who_global_data VALUES (29106, 0, 142, 0, 0, 123, 35);
INSERT INTO public.who_global_data VALUES (29107, 0, 2269, 0, 72, 123, 114);
INSERT INTO public.who_global_data VALUES (29108, 7, 57819, 0, 27, 123, 237);
INSERT INTO public.who_global_data VALUES (29109, 0, 13, 0, 0, 123, 55);
INSERT INTO public.who_global_data VALUES (29110, 11, 679, 0, 22, 123, 176);
INSERT INTO public.who_global_data VALUES (29111, 353, 13492, 0, 55, 123, 202);
INSERT INTO public.who_global_data VALUES (29112, 190, 6766, 5, 166, 123, 155);
INSERT INTO public.who_global_data VALUES (29113, 0, 1, 0, 0, 123, 32);
INSERT INTO public.who_global_data VALUES (29114, 0, 3745, 0, 99, 123, 220);
INSERT INTO public.who_global_data VALUES (29115, 926, 682215, 40, 17016, 123, 30);
INSERT INTO public.who_global_data VALUES (29116, 8, 2734, 0, 50, 123, 147);
INSERT INTO public.who_global_data VALUES (29117, 5187, 860210, 89, 34558, 123, 208);
INSERT INTO public.who_global_data VALUES (29118, 262, 3733, 0, 13, 123, 45);
INSERT INTO public.who_global_data VALUES (29119, 8, 13668, 0, 836, 123, 110);
INSERT INTO public.who_global_data VALUES (29120, 17, 4941, 0, 106, 123, 88);
INSERT INTO public.who_global_data VALUES (29121, 156, 95800, 3, 5893, 123, 51);
INSERT INTO public.who_global_data VALUES (29122, 1018, 57166, 2, 1829, 123, 209);
INSERT INTO public.who_global_data VALUES (29123, 45, 4411, 2, 207, 123, 205);
INSERT INTO public.who_global_data VALUES (29124, 39, 9974, 0, 78, 123, 18);
INSERT INTO public.who_global_data VALUES (29125, 10, 3600, 0, 59, 123, 72);
INSERT INTO public.who_global_data VALUES (29126, 12593, 515575, 19, 42369, 123, 44);
INSERT INTO public.who_global_data VALUES (29127, 0, 28, 0, 0, 123, 15);
INSERT INTO public.who_global_data VALUES (29128, 10, 1864, 0, 48, 123, 25);
INSERT INTO public.who_global_data VALUES (29129, 0, 0, 0, 0, 123, 179);
INSERT INTO public.who_global_data VALUES (29130, 0, 0, 0, 0, 123, 34);
INSERT INTO public.who_global_data VALUES (29131, 25, 4766, 0, 81, 123, 207);
INSERT INTO public.who_global_data VALUES (29132, 2312, 25765, 43, 364, 123, 166);
INSERT INTO public.who_global_data VALUES (29133, 8333, 797146, 57, 8498, 123, 126);
INSERT INTO public.who_global_data VALUES (29134, 0, 0, 0, 0, 123, 97);
INSERT INTO public.who_global_data VALUES (29135, 0, 695, 0, 6, 123, 36);
INSERT INTO public.who_global_data VALUES (29136, 0, 0, 0, 0, 123, 125);
INSERT INTO public.who_global_data VALUES (29137, 157, 8965, 1, 82, 123, 124);
INSERT INTO public.who_global_data VALUES (29138, 4348, 234584, 90, 4520, 123, 185);
INSERT INTO public.who_global_data VALUES (29139, 932, 99733, 3, 429, 123, 194);
INSERT INTO public.who_global_data VALUES (29140, 0, 509, 0, 21, 123, 144);
INSERT INTO public.who_global_data VALUES (29141, 36136, 7341406, 369, 208433, 123, 19);
INSERT INTO public.who_global_data VALUES (29142, 1, 1327, 0, 20, 123, 217);
INSERT INTO public.who_global_data VALUES (29143, 23, 2145, 0, 48, 123, 148);
INSERT INTO public.who_global_data VALUES (29144, 338, 59197, 4, 487, 123, 86);
INSERT INTO public.who_global_data VALUES (29145, 0, 0, 0, 0, 123, 13);
INSERT INTO public.who_global_data VALUES (29146, 788, 78434, 4, 653, 123, 157);
INSERT INTO public.who_global_data VALUES (29147, 1, 1097, 0, 35, 123, 8);
INSERT INTO public.who_global_data VALUES (29148, 0, 0, 0, 0, 123, 73);
INSERT INTO public.who_global_data VALUES (29149, 0, 2045, 1, 593, 123, 101);
INSERT INTO public.who_global_data VALUES (29150, 37, 15089, 1, 334, 123, 165);
INSERT INTO public.who_global_data VALUES (29151, 10, 7898, 0, 228, 123, 14);
INSERT INTO public.who_global_data VALUES (29152, 81, 39508, 4, 1470, 124, 193);
INSERT INTO public.who_global_data VALUES (29153, 149, 14266, 4, 396, 124, 113);
INSERT INTO public.who_global_data VALUES (29154, 141, 52136, 4, 1760, 124, 143);
INSERT INTO public.who_global_data VALUES (29155, 0, 0, 0, 0, 124, 219);
INSERT INTO public.who_global_data VALUES (29156, 0, 2110, 0, 53, 124, 186);
INSERT INTO public.who_global_data VALUES (29157, 0, 5370, -4, 185, 124, 52);
INSERT INTO public.who_global_data VALUES (29158, 0, 3, 0, 0, 124, 180);
INSERT INTO public.who_global_data VALUES (29159, 1, 107, 0, 3, 124, 167);
INSERT INTO public.who_global_data VALUES (29160, 11129, 790818, 196, 20795, 124, 154);
INSERT INTO public.who_global_data VALUES (29161, 181, 51990, 7, 979, 124, 94);
INSERT INTO public.who_global_data VALUES (29162, 0, 3998, 0, 27, 124, 66);
INSERT INTO public.who_global_data VALUES (29163, 15, 27136, 1, 894, 124, 58);
INSERT INTO public.who_global_data VALUES (29164, 599, 48618, 4, 813, 124, 163);
INSERT INTO public.who_global_data VALUES (29165, 130, 40691, 1, 596, 124, 37);
INSERT INTO public.who_global_data VALUES (29166, 77, 4409, 0, 96, 124, 142);
INSERT INTO public.who_global_data VALUES (29167, 352, 72662, 2, 260, 124, 83);
INSERT INTO public.who_global_data VALUES (29168, 1125, 368690, 23, 5348, 124, 228);
INSERT INTO public.who_global_data VALUES (29169, 0, 196, 0, 7, 124, 188);
INSERT INTO public.who_global_data VALUES (29170, 443, 80295, 6, 857, 124, 62);
INSERT INTO public.who_global_data VALUES (29171, 1035, 135575, 14, 10070, 124, 160);
INSERT INTO public.who_global_data VALUES (29172, 51, 2131, 1, 29, 124, 50);
INSERT INTO public.who_global_data VALUES (29173, 0, 2357, 0, 41, 124, 33);
INSERT INTO public.who_global_data VALUES (29174, 0, 181, 0, 9, 124, 183);
INSERT INTO public.who_global_data VALUES (29175, 15, 298, 0, 0, 124, 92);
INSERT INTO public.who_global_data VALUES (29176, 350, 136569, 28, 8073, 124, 158);
INSERT INTO public.who_global_data VALUES (29177, 10, 113, 1, 2, 124, 67);
INSERT INTO public.who_global_data VALUES (29178, 68, 28302, 2, 872, 124, 57);
INSERT INTO public.who_global_data VALUES (29179, 0, 3172, 0, 16, 124, 38);
INSERT INTO public.who_global_data VALUES (29180, 26310, 4906833, 599, 145987, 124, 141);
INSERT INTO public.who_global_data VALUES (29181, 0, 71, 0, 1, 124, 178);
INSERT INTO public.who_global_data VALUES (29182, 0, 146, 0, 3, 124, 108);
INSERT INTO public.who_global_data VALUES (29183, 69, 21587, 3, 844, 124, 39);
INSERT INTO public.who_global_data VALUES (29184, 66, 2154, 1, 59, 124, 2);
INSERT INTO public.who_global_data VALUES (29185, 1, 514, 0, 1, 124, 195);
INSERT INTO public.who_global_data VALUES (29186, 64, 6360, 3, 65, 124, 107);
INSERT INTO public.who_global_data VALUES (29187, 2, 280, 0, 0, 124, 161);
INSERT INTO public.who_global_data VALUES (29188, 37, 20875, 0, 418, 124, 212);
INSERT INTO public.who_global_data VALUES (29189, 1812, 164471, 53, 9462, 124, 181);
INSERT INTO public.who_global_data VALUES (29190, 0, 213, 0, 1, 124, 53);
INSERT INTO public.who_global_data VALUES (29191, 0, 4845, 0, 62, 124, 164);
INSERT INTO public.who_global_data VALUES (29192, 6, 1217, 1, 86, 124, 140);
INSERT INTO public.who_global_data VALUES (29193, 1708, 470179, 60, 12979, 124, 20);
INSERT INTO public.who_global_data VALUES (29194, 25, 91146, 0, 4746, 124, 112);
INSERT INTO public.who_global_data VALUES (29195, 6616, 848147, 159, 26556, 124, 111);
INSERT INTO public.who_global_data VALUES (29196, 3, 487, 0, 7, 124, 71);
INSERT INTO public.who_global_data VALUES (29197, 0, 5089, 0, 89, 124, 218);
INSERT INTO public.who_global_data VALUES (29198, 0, 0, 0, 0, 124, 43);
INSERT INTO public.who_global_data VALUES (29199, 1353, 79182, 20, 950, 124, 49);
INSERT INTO public.who_global_data VALUES (29200, 56, 19849, 0, 120, 124, 1);
INSERT INTO public.who_global_data VALUES (29201, 258, 17659, 5, 298, 124, 48);
INSERT INTO public.who_global_data VALUES (29202, 29, 5809, 0, 122, 124, 232);
INSERT INTO public.who_global_data VALUES (29203, 0, 399, 0, 1, 124, 175);
INSERT INTO public.who_global_data VALUES (29204, 13, 1824, 0, 22, 124, 21);
INSERT INTO public.who_global_data VALUES (29205, 1841, 82446, 16, 727, 124, 156);
INSERT INTO public.who_global_data VALUES (29206, 0, 0, 0, 0, 124, 95);
INSERT INTO public.who_global_data VALUES (29207, 8, 10759, 0, 274, 124, 177);
INSERT INTO public.who_global_data VALUES (29208, 378, 29680, 4, 658, 124, 210);
INSERT INTO public.who_global_data VALUES (29209, 1, 5419, 0, 61, 124, 120);
INSERT INTO public.who_global_data VALUES (29210, 0, 31, 0, 0, 124, 135);
INSERT INTO public.who_global_data VALUES (29211, 554, 114480, 6, 2134, 124, 206);
INSERT INTO public.who_global_data VALUES (29212, 683, 141034, 50, 11647, 124, 189);
INSERT INTO public.who_global_data VALUES (29213, 108, 103683, 11, 5981, 124, 129);
INSERT INTO public.who_global_data VALUES (29214, 92, 29450, 6, 863, 124, 121);
INSERT INTO public.who_global_data VALUES (29215, 0, 5045, 0, 83, 124, 59);
INSERT INTO public.who_global_data VALUES (29216, 0, 398, 0, 0, 124, 96);
INSERT INTO public.who_global_data VALUES (29217, 30, 3607, 0, 67, 124, 41);
INSERT INTO public.who_global_data VALUES (29218, 39, 5569, 0, 111, 124, 216);
INSERT INTO public.who_global_data VALUES (29219, 959, 78819, 8, 1222, 124, 236);
INSERT INTO public.who_global_data VALUES (29220, 0, 13, 0, 0, 124, 150);
INSERT INTO public.who_global_data VALUES (29221, 1, 474, 0, 0, 124, 61);
INSERT INTO public.who_global_data VALUES (29222, 0, 32, 0, 2, 124, 7);
INSERT INTO public.who_global_data VALUES (29223, 294, 10538, 0, 345, 124, 169);
INSERT INTO public.who_global_data VALUES (29224, 12545, 593248, 32, 32001, 124, 28);
INSERT INTO public.who_global_data VALUES (29225, 0, 10029, 0, 67, 124, 85);
INSERT INTO public.who_global_data VALUES (29226, 0, 2026, 0, 8, 124, 211);
INSERT INTO public.who_global_data VALUES (29227, 0, 8797, 0, 54, 124, 60);
INSERT INTO public.who_global_data VALUES (29228, 4, 3594, 0, 115, 124, 3);
INSERT INTO public.who_global_data VALUES (29229, 578, 8696, 2, 52, 124, 11);
INSERT INTO public.who_global_data VALUES (29230, 1382, 300619, 5, 9534, 124, 89);
INSERT INTO public.who_global_data VALUES (29231, 61, 46829, 2, 303, 124, 24);
INSERT INTO public.who_global_data VALUES (29232, 12, 428, 0, 0, 124, 162);
INSERT INTO public.who_global_data VALUES (29233, 229, 19842, 4, 409, 124, 100);
INSERT INTO public.who_global_data VALUES (29234, 0, 14, 0, 0, 124, 47);
INSERT INTO public.who_global_data VALUES (29235, 0, 24, 0, 0, 124, 29);
INSERT INTO public.who_global_data VALUES (29236, 0, 5903, 0, 75, 124, 40);
INSERT INTO public.who_global_data VALUES (29237, 1, 2700, 1, 52, 124, 222);
INSERT INTO public.who_global_data VALUES (29238, 215, 93963, 8, 3293, 124, 132);
INSERT INTO public.who_global_data VALUES (29239, 1, 257, 0, 13, 124, 130);
INSERT INTO public.who_global_data VALUES (29240, 19, 10754, 0, 66, 124, 234);
INSERT INTO public.who_global_data VALUES (29241, 0, 2362, 0, 39, 124, 23);
INSERT INTO public.who_global_data VALUES (29242, 37, 3005, 0, 85, 124, 192);
INSERT INTO public.who_global_data VALUES (29243, 27, 8819, 0, 229, 124, 69);
INSERT INTO public.who_global_data VALUES (29244, 0, 12, 0, 0, 124, 187);
INSERT INTO public.who_global_data VALUES (29245, 519, 78788, 13, 2399, 124, 230);
INSERT INTO public.who_global_data VALUES (29246, 905, 31480, 11, 833, 124, 77);
INSERT INTO public.who_global_data VALUES (29247, 49, 2921, 0, 10, 124, 9);
INSERT INTO public.who_global_data VALUES (29248, 74442, 6623815, 903, 102685, 124, 74);
INSERT INTO public.who_global_data VALUES (29249, 3992, 303498, 96, 11151, 124, 224);
INSERT INTO public.who_global_data VALUES (29250, 3653, 471772, 211, 26957, 124, 199);
INSERT INTO public.who_global_data VALUES (29251, 3210, 379141, 52, 9399, 124, 190);
INSERT INTO public.who_global_data VALUES (29252, 364, 38032, 0, 1810, 124, 12);
INSERT INTO public.who_global_data VALUES (29253, 1, 342, 0, 24, 124, 104);
INSERT INTO public.who_global_data VALUES (29254, 2595, 264801, 37, 1713, 124, 153);
INSERT INTO public.who_global_data VALUES (29255, 2578, 325329, 18, 35986, 124, 91);
INSERT INTO public.who_global_data VALUES (29256, 100, 6895, 1, 120, 124, 215);
INSERT INTO public.who_global_data VALUES (29257, 400, 85739, 2, 1599, 124, 84);
INSERT INTO public.who_global_data VALUES (29258, 0, 421, 0, 32, 124, 231);
INSERT INTO public.who_global_data VALUES (29259, 891, 15708, 13, 101, 124, 196);
INSERT INTO public.who_global_data VALUES (29260, 67, 141911, 0, 2106, 124, 105);
INSERT INTO public.who_global_data VALUES (29261, 504, 39427, 6, 731, 124, 122);
INSERT INTO public.who_global_data VALUES (29262, 0, 0, 0, 0, 124, 159);
INSERT INTO public.who_global_data VALUES (29263, 56, 15771, 0, 620, 124, 75);
INSERT INTO public.who_global_data VALUES (29264, 567, 107025, 4, 624, 124, 27);
INSERT INTO public.who_global_data VALUES (29265, 207, 47635, 0, 1066, 124, 54);
INSERT INTO public.who_global_data VALUES (29266, 0, 23, 0, 0, 124, 226);
INSERT INTO public.who_global_data VALUES (29267, 67, 2086, 0, 38, 124, 79);
INSERT INTO public.who_global_data VALUES (29268, 1002, 44482, 8, 406, 124, 56);
INSERT INTO public.who_global_data VALUES (29269, 0, 1639, 0, 38, 124, 117);
INSERT INTO public.who_global_data VALUES (29270, 1, 1348, 0, 82, 124, 152);
INSERT INTO public.who_global_data VALUES (29271, 628, 37437, 4, 596, 124, 16);
INSERT INTO public.who_global_data VALUES (29272, 1, 129, 0, 1, 124, 10);
INSERT INTO public.who_global_data VALUES (29273, 100, 5281, 1, 82, 124, 201);
INSERT INTO public.who_global_data VALUES (29274, 0, 8709, 0, 125, 124, 174);
INSERT INTO public.who_global_data VALUES (29275, 29, 16558, 0, 232, 124, 119);
INSERT INTO public.who_global_data VALUES (29276, 3, 5786, 0, 179, 124, 168);
INSERT INTO public.who_global_data VALUES (29277, 293, 12381, 0, 137, 124, 99);
INSERT INTO public.who_global_data VALUES (29278, 65, 10530, 0, 34, 124, 171);
INSERT INTO public.who_global_data VALUES (29279, 14, 3184, 0, 131, 124, 87);
INSERT INTO public.who_global_data VALUES (29280, 57, 3318, 0, 39, 124, 123);
INSERT INTO public.who_global_data VALUES (29281, 0, 0, 0, 0, 124, 151);
INSERT INTO public.who_global_data VALUES (29282, 0, 1543, 0, 21, 124, 213);
INSERT INTO public.who_global_data VALUES (29283, 9, 7520, 0, 161, 124, 118);
INSERT INTO public.who_global_data VALUES (29284, 4, 385, 0, 10, 124, 134);
INSERT INTO public.who_global_data VALUES (29285, 0, 3779, 0, 42, 124, 65);
INSERT INTO public.who_global_data VALUES (29286, 4863, 757953, 388, 78880, 124, 102);
INSERT INTO public.who_global_data VALUES (29287, 0, 0, 0, 0, 124, 223);
INSERT INTO public.who_global_data VALUES (29288, 0, 225, 0, 2, 124, 4);
INSERT INTO public.who_global_data VALUES (29289, 0, 313, 0, 0, 124, 146);
INSERT INTO public.who_global_data VALUES (29290, 259, 12507, 4, 184, 124, 31);
INSERT INTO public.who_global_data VALUES (29291, 0, 13, 0, 1, 124, 127);
INSERT INTO public.who_global_data VALUES (29292, 2044, 133272, 37, 2330, 124, 22);
INSERT INTO public.who_global_data VALUES (29293, 147, 9196, 2, 66, 124, 115);
INSERT INTO public.who_global_data VALUES (29294, 1291, 17794, 41, 412, 124, 106);
INSERT INTO public.who_global_data VALUES (29295, 54, 11626, 0, 123, 124, 90);
INSERT INTO public.who_global_data VALUES (29296, 0, 0, 0, 0, 124, 70);
INSERT INTO public.who_global_data VALUES (29297, 2253, 86823, 7, 535, 124, 46);
INSERT INTO public.who_global_data VALUES (29298, 3987, 135589, 4, 6451, 124, 139);
INSERT INTO public.who_global_data VALUES (29299, 0, 27, 0, 0, 124, 42);
INSERT INTO public.who_global_data VALUES (29300, 1, 1499, 0, 25, 124, 80);
INSERT INTO public.who_global_data VALUES (29301, 0, 4146, 0, 151, 124, 203);
INSERT INTO public.who_global_data VALUES (29302, 0, 1200, 0, 69, 124, 136);
INSERT INTO public.who_global_data VALUES (29303, 58, 59345, 0, 1113, 124, 63);
INSERT INTO public.who_global_data VALUES (29304, 0, 0, 0, 0, 124, 17);
INSERT INTO public.who_global_data VALUES (29305, 0, 73, 0, 2, 124, 172);
INSERT INTO public.who_global_data VALUES (29306, 188, 18790, 3, 756, 124, 109);
INSERT INTO public.who_global_data VALUES (29307, 0, 14149, 0, 275, 124, 200);
INSERT INTO public.who_global_data VALUES (29308, 420, 52433, 1, 391, 124, 93);
INSERT INTO public.who_global_data VALUES (29309, 2685, 101270, 42, 977, 124, 5);
INSERT INTO public.who_global_data VALUES (29310, 0, 741, 0, 13, 124, 214);
INSERT INTO public.who_global_data VALUES (29311, 644, 315260, 4, 6517, 124, 204);
INSERT INTO public.who_global_data VALUES (29312, 0, 0, 0, 0, 124, 198);
INSERT INTO public.who_global_data VALUES (29313, 691, 114653, 8, 2414, 124, 173);
INSERT INTO public.who_global_data VALUES (29314, 0, 540, 0, 7, 124, 229);
INSERT INTO public.who_global_data VALUES (29315, 768, 43452, 23, 913, 124, 76);
INSERT INTO public.who_global_data VALUES (29316, 3421, 824985, 56, 32665, 124, 138);
INSERT INTO public.who_global_data VALUES (29317, 3167, 322497, 98, 5776, 124, 98);
INSERT INTO public.who_global_data VALUES (29318, 0, 0, 0, 0, 124, 103);
INSERT INTO public.who_global_data VALUES (29319, 0, 98140, 0, 2604, 124, 225);
INSERT INTO public.who_global_data VALUES (29320, 0, 78247, 0, 1995, 124, 131);
INSERT INTO public.who_global_data VALUES (29321, 300, 50675, 5, 686, 124, 235);
INSERT INTO public.who_global_data VALUES (29322, 159, 126498, 0, 216, 124, 137);
INSERT INTO public.who_global_data VALUES (29323, 73, 24164, 1, 422, 124, 81);
INSERT INTO public.who_global_data VALUES (29324, 691, 56579, 13, 1366, 124, 182);
INSERT INTO public.who_global_data VALUES (29325, 0, 4178, 0, 16, 124, 145);
INSERT INTO public.who_global_data VALUES (29326, 0, 134065, 0, 4947, 124, 26);
INSERT INTO public.who_global_data VALUES (29327, 10888, 1225889, 117, 21475, 124, 170);
INSERT INTO public.who_global_data VALUES (29328, 14, 4866, 0, 29, 124, 191);
INSERT INTO public.who_global_data VALUES (29329, 0, 5, 0, 0, 124, 221);
INSERT INTO public.who_global_data VALUES (29330, 0, 62, 0, 0, 124, 64);
INSERT INTO public.who_global_data VALUES (29331, 0, 0, 0, 0, 124, 116);
INSERT INTO public.who_global_data VALUES (29332, 0, 19, 0, 0, 124, 128);
INSERT INTO public.who_global_data VALUES (29333, 0, 27, 0, 0, 124, 6);
INSERT INTO public.who_global_data VALUES (29334, 0, 412, 0, 8, 124, 227);
INSERT INTO public.who_global_data VALUES (29335, 0, 12, 0, 0, 124, 68);
INSERT INTO public.who_global_data VALUES (29336, 0, 64, 0, 0, 124, 184);
INSERT INTO public.who_global_data VALUES (29337, 0, 0, 0, 0, 124, 82);
INSERT INTO public.who_global_data VALUES (29338, 0, 750, 0, 42, 124, 149);
INSERT INTO public.who_global_data VALUES (29339, 0, 913, 0, 15, 124, 197);
INSERT INTO public.who_global_data VALUES (29340, 390, 336387, 25, 4875, 124, 78);
INSERT INTO public.who_global_data VALUES (29341, 43, 15094, 0, 312, 124, 233);
INSERT INTO public.who_global_data VALUES (29342, 59, 33901, 1, 754, 124, 133);
INSERT INTO public.who_global_data VALUES (29343, 0, 142, 0, 0, 124, 35);
INSERT INTO public.who_global_data VALUES (29344, 10, 2269, 0, 72, 124, 114);
INSERT INTO public.who_global_data VALUES (29345, 12, 57812, 0, 27, 124, 237);
INSERT INTO public.who_global_data VALUES (29346, 0, 13, 0, 0, 124, 55);
INSERT INTO public.who_global_data VALUES (29347, 0, 668, 0, 22, 124, 176);
INSERT INTO public.who_global_data VALUES (29348, 818, 13139, 1, 55, 124, 202);
INSERT INTO public.who_global_data VALUES (29349, 75, 6576, 2, 161, 124, 155);
INSERT INTO public.who_global_data VALUES (29350, 0, 1, 0, 0, 124, 32);
INSERT INTO public.who_global_data VALUES (29351, 152, 3745, 0, 99, 124, 220);
INSERT INTO public.who_global_data VALUES (29352, 1573, 681289, 38, 16976, 124, 30);
INSERT INTO public.who_global_data VALUES (29353, 0, 2726, 0, 50, 124, 147);
INSERT INTO public.who_global_data VALUES (29354, 7039, 855023, 103, 34469, 124, 208);
INSERT INTO public.who_global_data VALUES (29355, 76, 3471, 0, 13, 124, 45);
INSERT INTO public.who_global_data VALUES (29356, 0, 13660, 0, 836, 124, 110);
INSERT INTO public.who_global_data VALUES (29357, 25, 4924, 1, 106, 124, 88);
INSERT INTO public.who_global_data VALUES (29358, 461, 95644, 3, 5890, 124, 51);
INSERT INTO public.who_global_data VALUES (29359, 316, 56148, 1, 1827, 124, 209);
INSERT INTO public.who_global_data VALUES (29360, 37, 4366, 1, 205, 124, 205);
INSERT INTO public.who_global_data VALUES (29361, 40, 9935, 1, 78, 124, 18);
INSERT INTO public.who_global_data VALUES (29362, 5, 3590, 0, 59, 124, 72);
INSERT INTO public.who_global_data VALUES (29363, 22961, 502982, 33, 42350, 124, 44);
INSERT INTO public.who_global_data VALUES (29364, 0, 28, 0, 0, 124, 15);
INSERT INTO public.who_global_data VALUES (29365, 14, 1854, 0, 48, 124, 25);
INSERT INTO public.who_global_data VALUES (29366, 0, 0, 0, 0, 124, 179);
INSERT INTO public.who_global_data VALUES (29367, 0, 0, 0, 0, 124, 34);
INSERT INTO public.who_global_data VALUES (29368, 32, 4741, 3, 81, 124, 207);
INSERT INTO public.who_global_data VALUES (29369, 0, 23453, 0, 321, 124, 166);
INSERT INTO public.who_global_data VALUES (29370, 8159, 788813, 57, 8441, 124, 126);
INSERT INTO public.who_global_data VALUES (29371, 0, 0, 0, 0, 124, 97);
INSERT INTO public.who_global_data VALUES (29372, 0, 695, 0, 6, 124, 36);
INSERT INTO public.who_global_data VALUES (29373, 0, 0, 0, 0, 124, 125);
INSERT INTO public.who_global_data VALUES (29374, 317, 8808, 2, 81, 124, 124);
INSERT INTO public.who_global_data VALUES (29375, 3774, 230236, 33, 4430, 124, 185);
INSERT INTO public.who_global_data VALUES (29376, 1041, 98801, 0, 426, 124, 194);
INSERT INTO public.who_global_data VALUES (29377, 0, 509, 0, 21, 124, 144);
INSERT INTO public.who_global_data VALUES (29378, 49036, 7305270, 698, 208064, 124, 19);
INSERT INTO public.who_global_data VALUES (29379, 0, 1326, 0, 20, 124, 217);
INSERT INTO public.who_global_data VALUES (29380, 25, 2122, 0, 48, 124, 148);
INSERT INTO public.who_global_data VALUES (29381, 438, 58859, 4, 483, 124, 86);
INSERT INTO public.who_global_data VALUES (29382, 0, 0, 0, 0, 124, 13);
INSERT INTO public.who_global_data VALUES (29383, 826, 77646, 6, 649, 124, 157);
INSERT INTO public.who_global_data VALUES (29384, 0, 1096, 0, 35, 124, 8);
INSERT INTO public.who_global_data VALUES (29385, 0, 0, 0, 0, 124, 73);
INSERT INTO public.who_global_data VALUES (29386, 0, 2045, 2, 592, 124, 101);
INSERT INTO public.who_global_data VALUES (29387, 222, 15052, 0, 333, 124, 165);
INSERT INTO public.who_global_data VALUES (29388, 30, 7888, 0, 228, 124, 14);
INSERT INTO public.who_global_data VALUES (29389, 44, 39427, 0, 1466, 125, 193);
INSERT INTO public.who_global_data VALUES (29390, 152, 14117, 3, 392, 125, 113);
INSERT INTO public.who_global_data VALUES (29391, 148, 51995, 7, 1756, 125, 143);
INSERT INTO public.who_global_data VALUES (29392, 0, 0, 0, 0, 125, 219);
INSERT INTO public.who_global_data VALUES (29393, 0, 2110, 0, 53, 125, 186);
INSERT INTO public.who_global_data VALUES (29394, 159, 5370, 0, 189, 125, 52);
INSERT INTO public.who_global_data VALUES (29395, 0, 3, 0, 0, 125, 180);
INSERT INTO public.who_global_data VALUES (29396, 0, 106, 0, 3, 125, 167);
INSERT INTO public.who_global_data VALUES (29397, 14687, 779689, 311, 20599, 125, 154);
INSERT INTO public.who_global_data VALUES (29398, 571, 51809, 5, 972, 125, 94);
INSERT INTO public.who_global_data VALUES (29399, 0, 3998, 0, 27, 125, 66);
INSERT INTO public.who_global_data VALUES (29400, 8, 27121, 3, 893, 125, 58);
INSERT INTO public.who_global_data VALUES (29401, 830, 48019, 6, 809, 125, 163);
INSERT INTO public.who_global_data VALUES (29402, 108, 40561, 1, 595, 125, 37);
INSERT INTO public.who_global_data VALUES (29403, 112, 4332, 0, 96, 125, 142);
INSERT INTO public.who_global_data VALUES (29404, 507, 72310, 3, 258, 125, 83);
INSERT INTO public.who_global_data VALUES (29405, 1182, 367565, 20, 5325, 125, 228);
INSERT INTO public.who_global_data VALUES (29406, 3, 196, 0, 7, 125, 188);
INSERT INTO public.who_global_data VALUES (29407, 431, 79852, 7, 851, 125, 62);
INSERT INTO public.who_global_data VALUES (29408, 1709, 134540, 15, 10056, 125, 160);
INSERT INTO public.who_global_data VALUES (29409, 54, 2080, 1, 28, 125, 50);
INSERT INTO public.who_global_data VALUES (29410, 0, 2357, 0, 41, 125, 33);
INSERT INTO public.who_global_data VALUES (29411, 0, 181, 0, 9, 125, 183);
INSERT INTO public.who_global_data VALUES (29412, 0, 283, 0, 0, 125, 92);
INSERT INTO public.who_global_data VALUES (29413, 503, 136219, 44, 8045, 125, 158);
INSERT INTO public.who_global_data VALUES (29414, 0, 103, 0, 1, 125, 67);
INSERT INTO public.who_global_data VALUES (29415, 263, 28234, 6, 870, 125, 57);
INSERT INTO public.who_global_data VALUES (29416, 0, 3172, 0, 16, 125, 38);
INSERT INTO public.who_global_data VALUES (29417, 33431, 4880523, 708, 145388, 125, 141);
INSERT INTO public.who_global_data VALUES (29418, 0, 71, 0, 1, 125, 178);
INSERT INTO public.who_global_data VALUES (29419, 0, 146, 0, 3, 125, 108);
INSERT INTO public.who_global_data VALUES (29420, 182, 21518, 3, 841, 125, 39);
INSERT INTO public.who_global_data VALUES (29421, 0, 2088, 0, 58, 125, 2);
INSERT INTO public.who_global_data VALUES (29422, 0, 513, 0, 1, 125, 195);
INSERT INTO public.who_global_data VALUES (29423, 91, 6296, 0, 62, 125, 107);
INSERT INTO public.who_global_data VALUES (29424, 0, 278, 0, 0, 125, 161);
INSERT INTO public.who_global_data VALUES (29425, 0, 20838, 0, 418, 125, 212);
INSERT INTO public.who_global_data VALUES (29426, 2124, 162659, 90, 9409, 125, 181);
INSERT INTO public.who_global_data VALUES (29427, 2, 213, 0, 1, 125, 53);
INSERT INTO public.who_global_data VALUES (29428, 0, 4845, 0, 62, 125, 164);
INSERT INTO public.who_global_data VALUES (29429, 0, 1211, 0, 85, 125, 140);
INSERT INTO public.who_global_data VALUES (29430, 1881, 468471, 52, 12919, 125, 20);
INSERT INTO public.who_global_data VALUES (29431, 20, 91121, 0, 4746, 125, 112);
INSERT INTO public.who_global_data VALUES (29432, 6192, 841531, 201, 26397, 125, 111);
INSERT INTO public.who_global_data VALUES (29433, 5, 484, 0, 7, 125, 71);
INSERT INTO public.who_global_data VALUES (29434, 0, 5089, 0, 89, 125, 218);
INSERT INTO public.who_global_data VALUES (29435, 0, 0, 0, 0, 125, 43);
INSERT INTO public.who_global_data VALUES (29436, 1001, 77829, 13, 930, 125, 49);
INSERT INTO public.who_global_data VALUES (29437, 0, 19793, 0, 120, 125, 1);
INSERT INTO public.who_global_data VALUES (29438, 241, 17401, 2, 293, 125, 48);
INSERT INTO public.who_global_data VALUES (29439, 62, 5780, 0, 122, 125, 232);
INSERT INTO public.who_global_data VALUES (29440, 0, 399, 0, 1, 125, 175);
INSERT INTO public.who_global_data VALUES (29441, 22, 1811, 0, 22, 125, 21);
INSERT INTO public.who_global_data VALUES (29442, 2554, 80605, 12, 711, 125, 156);
INSERT INTO public.who_global_data VALUES (29443, 0, 0, 0, 0, 125, 95);
INSERT INTO public.who_global_data VALUES (29444, 23, 10751, 2, 274, 125, 177);
INSERT INTO public.who_global_data VALUES (29445, 370, 29302, 2, 654, 125, 210);
INSERT INTO public.who_global_data VALUES (29446, 1, 5418, 0, 61, 125, 120);
INSERT INTO public.who_global_data VALUES (29447, 0, 31, 0, 0, 125, 135);
INSERT INTO public.who_global_data VALUES (29448, 576, 113926, 11, 2128, 125, 206);
INSERT INTO public.who_global_data VALUES (29449, 817, 140351, 102, 11597, 125, 189);
INSERT INTO public.who_global_data VALUES (29450, 109, 103575, 14, 5970, 125, 129);
INSERT INTO public.who_global_data VALUES (29451, 183, 29358, 4, 857, 125, 121);
INSERT INTO public.who_global_data VALUES (29452, 0, 5045, 0, 83, 125, 59);
INSERT INTO public.who_global_data VALUES (29453, 17, 398, 0, 0, 125, 96);
INSERT INTO public.who_global_data VALUES (29454, 70, 3577, 1, 67, 125, 41);
INSERT INTO public.who_global_data VALUES (29455, 9, 5530, 0, 111, 125, 216);
INSERT INTO public.who_global_data VALUES (29456, 872, 77860, 7, 1214, 125, 236);
INSERT INTO public.who_global_data VALUES (29457, 0, 13, 0, 0, 125, 150);
INSERT INTO public.who_global_data VALUES (29458, 1, 473, 0, 0, 125, 61);
INSERT INTO public.who_global_data VALUES (29459, 0, 32, 0, 2, 125, 7);
INSERT INTO public.who_global_data VALUES (29460, 40, 10244, 0, 345, 125, 169);
INSERT INTO public.who_global_data VALUES (29461, 16911, 580703, 43, 31969, 125, 28);
INSERT INTO public.who_global_data VALUES (29462, 61, 10029, 0, 67, 125, 85);
INSERT INTO public.who_global_data VALUES (29463, 0, 2026, 0, 8, 125, 211);
INSERT INTO public.who_global_data VALUES (29464, 0, 8797, 0, 54, 125, 60);
INSERT INTO public.who_global_data VALUES (29465, 0, 3590, 0, 115, 125, 3);
INSERT INTO public.who_global_data VALUES (29466, 554, 8118, 2, 50, 125, 11);
INSERT INTO public.who_global_data VALUES (29467, 2279, 299237, 2, 9529, 125, 89);
INSERT INTO public.who_global_data VALUES (29468, 112, 46768, 0, 301, 125, 24);
INSERT INTO public.who_global_data VALUES (29469, 6, 416, 0, 0, 125, 162);
INSERT INTO public.who_global_data VALUES (29470, 267, 19613, 7, 405, 125, 100);
INSERT INTO public.who_global_data VALUES (29471, 0, 14, 0, 0, 125, 47);
INSERT INTO public.who_global_data VALUES (29472, 0, 24, 0, 0, 125, 29);
INSERT INTO public.who_global_data VALUES (29473, 0, 5903, 0, 75, 125, 40);
INSERT INTO public.who_global_data VALUES (29474, 82, 2699, 1, 51, 125, 222);
INSERT INTO public.who_global_data VALUES (29475, 658, 93748, 18, 3285, 125, 132);
INSERT INTO public.who_global_data VALUES (29476, 0, 256, 0, 13, 125, 130);
INSERT INTO public.who_global_data VALUES (29477, 0, 10735, 0, 66, 125, 234);
INSERT INTO public.who_global_data VALUES (29478, 0, 2362, 0, 39, 125, 23);
INSERT INTO public.who_global_data VALUES (29479, 39, 2968, 3, 85, 125, 192);
INSERT INTO public.who_global_data VALUES (29480, 0, 8792, 0, 229, 125, 69);
INSERT INTO public.who_global_data VALUES (29481, 0, 12, 0, 0, 125, 187);
INSERT INTO public.who_global_data VALUES (29482, 671, 78269, 6, 2386, 125, 230);
INSERT INTO public.who_global_data VALUES (29483, 858, 30575, 10, 822, 125, 77);
INSERT INTO public.who_global_data VALUES (29484, 63, 2872, 0, 10, 125, 9);
INSERT INTO public.who_global_data VALUES (29485, 75829, 6549373, 940, 101782, 125, 74);
INSERT INTO public.who_global_data VALUES (29486, 4007, 299506, 83, 11055, 125, 224);
INSERT INTO public.who_global_data VALUES (29487, 3523, 468119, 179, 26746, 125, 199);
INSERT INTO public.who_global_data VALUES (29488, 3672, 375931, 49, 9347, 125, 190);
INSERT INTO public.who_global_data VALUES (29489, 605, 37668, 9, 1810, 125, 12);
INSERT INTO public.who_global_data VALUES (29490, 1, 341, 0, 24, 125, 104);
INSERT INTO public.who_global_data VALUES (29491, 7059, 262206, 25, 1676, 125, 153);
INSERT INTO public.who_global_data VALUES (29492, 2843, 322751, 27, 35968, 125, 91);
INSERT INTO public.who_global_data VALUES (29493, 91, 6795, 3, 119, 125, 215);
INSERT INTO public.who_global_data VALUES (29494, 571, 85339, 7, 1597, 125, 84);
INSERT INTO public.who_global_data VALUES (29495, 2, 421, 0, 32, 125, 231);
INSERT INTO public.who_global_data VALUES (29496, 1099, 14817, 9, 88, 125, 196);
INSERT INTO public.who_global_data VALUES (29497, 96, 141844, 31, 2106, 125, 105);
INSERT INTO public.who_global_data VALUES (29498, 0, 38923, 0, 725, 125, 122);
INSERT INTO public.who_global_data VALUES (29499, 0, 0, 0, 0, 125, 159);
INSERT INTO public.who_global_data VALUES (29500, 53, 15715, 3, 620, 125, 75);
INSERT INTO public.who_global_data VALUES (29501, 371, 106458, 5, 620, 125, 27);
INSERT INTO public.who_global_data VALUES (29502, 244, 47428, 0, 1066, 125, 54);
INSERT INTO public.who_global_data VALUES (29503, 0, 23, 0, 0, 125, 226);
INSERT INTO public.who_global_data VALUES (29504, 74, 2019, 0, 38, 125, 79);
INSERT INTO public.who_global_data VALUES (29505, 1321, 43480, 12, 398, 125, 56);
INSERT INTO public.who_global_data VALUES (29506, 0, 1639, 0, 38, 125, 117);
INSERT INTO public.who_global_data VALUES (29507, 4, 1347, 0, 82, 125, 152);
INSERT INTO public.who_global_data VALUES (29508, 722, 36809, 14, 592, 125, 16);
INSERT INTO public.who_global_data VALUES (29509, 3, 128, 0, 1, 125, 10);
INSERT INTO public.who_global_data VALUES (29510, 105, 5181, 1, 81, 125, 201);
INSERT INTO public.who_global_data VALUES (29511, 0, 8709, 0, 125, 125, 174);
INSERT INTO public.who_global_data VALUES (29512, 36, 16529, 0, 232, 125, 119);
INSERT INTO public.who_global_data VALUES (29513, 0, 5783, 0, 179, 125, 168);
INSERT INTO public.who_global_data VALUES (29514, 317, 12088, 1, 137, 125, 99);
INSERT INTO public.who_global_data VALUES (29515, 67, 10465, 0, 34, 125, 171);
INSERT INTO public.who_global_data VALUES (29516, 14, 3170, 0, 131, 125, 87);
INSERT INTO public.who_global_data VALUES (29517, 66, 3261, 1, 39, 125, 123);
INSERT INTO public.who_global_data VALUES (29518, 0, 0, 0, 0, 125, 151);
INSERT INTO public.who_global_data VALUES (29519, 0, 1543, 0, 21, 125, 213);
INSERT INTO public.who_global_data VALUES (29520, 0, 7511, 0, 161, 125, 118);
INSERT INTO public.who_global_data VALUES (29521, 0, 381, 0, 10, 125, 134);
INSERT INTO public.who_global_data VALUES (29522, 0, 3779, 0, 42, 125, 65);
INSERT INTO public.who_global_data VALUES (29523, 4775, 753090, 414, 78492, 125, 102);
INSERT INTO public.who_global_data VALUES (29524, 0, 0, 0, 0, 125, 223);
INSERT INTO public.who_global_data VALUES (29525, 1, 225, 0, 2, 125, 4);
INSERT INTO public.who_global_data VALUES (29526, 0, 313, 0, 0, 125, 146);
INSERT INTO public.who_global_data VALUES (29527, 165, 12248, 5, 180, 125, 31);
INSERT INTO public.who_global_data VALUES (29528, 0, 13, 0, 1, 125, 127);
INSERT INTO public.who_global_data VALUES (29529, 2663, 131228, 30, 2293, 125, 22);
INSERT INTO public.who_global_data VALUES (29530, 70, 9049, 0, 64, 125, 115);
INSERT INTO public.who_global_data VALUES (29531, 978, 16503, 18, 371, 125, 106);
INSERT INTO public.who_global_data VALUES (29532, 92, 11572, 0, 123, 125, 90);
INSERT INTO public.who_global_data VALUES (29533, 0, 0, 0, 0, 125, 70);
INSERT INTO public.who_global_data VALUES (29534, 2120, 84570, 8, 528, 125, 46);
INSERT INTO public.who_global_data VALUES (29535, 3937, 131602, 20, 6447, 125, 139);
INSERT INTO public.who_global_data VALUES (29536, 0, 27, 0, 0, 125, 42);
INSERT INTO public.who_global_data VALUES (29537, 5, 1498, 0, 25, 125, 80);
INSERT INTO public.who_global_data VALUES (29538, 0, 4146, 0, 151, 125, 203);
INSERT INTO public.who_global_data VALUES (29539, 3, 1200, 0, 69, 125, 136);
INSERT INTO public.who_global_data VALUES (29540, 160, 59287, 1, 1113, 125, 63);
INSERT INTO public.who_global_data VALUES (29541, 0, 0, 0, 0, 125, 17);
INSERT INTO public.who_global_data VALUES (29542, 0, 73, 0, 2, 125, 172);
INSERT INTO public.who_global_data VALUES (29543, 239, 18602, 4, 753, 125, 109);
INSERT INTO public.who_global_data VALUES (29544, 0, 14149, 0, 275, 125, 200);
INSERT INTO public.who_global_data VALUES (29545, 406, 52013, 11, 390, 125, 93);
INSERT INTO public.who_global_data VALUES (29546, 0, 98585, 0, 935, 125, 5);
INSERT INTO public.who_global_data VALUES (29547, 0, 741, 0, 13, 125, 214);
INSERT INTO public.who_global_data VALUES (29548, 632, 314616, 6, 6513, 125, 204);
INSERT INTO public.who_global_data VALUES (29549, 0, 0, 0, 0, 125, 198);
INSERT INTO public.who_global_data VALUES (29550, 620, 113962, 19, 2406, 125, 173);
INSERT INTO public.who_global_data VALUES (29551, 1, 540, 0, 7, 125, 229);
INSERT INTO public.who_global_data VALUES (29552, 885, 42684, 21, 890, 125, 76);
INSERT INTO public.who_global_data VALUES (29553, 3267, 821564, 74, 32609, 125, 138);
INSERT INTO public.who_global_data VALUES (29554, 2652, 319330, 62, 5678, 125, 98);
INSERT INTO public.who_global_data VALUES (29555, 0, 0, 0, 0, 125, 103);
INSERT INTO public.who_global_data VALUES (29556, 2367, 98140, 34, 2604, 125, 225);
INSERT INTO public.who_global_data VALUES (29557, 963, 78247, 12, 1995, 125, 131);
INSERT INTO public.who_global_data VALUES (29558, 628, 50375, 8, 681, 125, 235);
INSERT INTO public.who_global_data VALUES (29559, 175, 126339, 1, 216, 125, 137);
INSERT INTO public.who_global_data VALUES (29560, 64, 24091, 1, 421, 125, 81);
INSERT INTO public.who_global_data VALUES (29561, 872, 55888, 9, 1353, 125, 182);
INSERT INTO public.who_global_data VALUES (29562, 0, 4178, 0, 16, 125, 145);
INSERT INTO public.who_global_data VALUES (29563, 2064, 134065, 32, 4947, 125, 26);
INSERT INTO public.who_global_data VALUES (29564, 10499, 1215001, 107, 21358, 125, 170);
INSERT INTO public.who_global_data VALUES (29565, 5, 4852, 0, 29, 125, 191);
INSERT INTO public.who_global_data VALUES (29566, 0, 5, 0, 0, 125, 221);
INSERT INTO public.who_global_data VALUES (29567, 0, 62, 0, 0, 125, 64);
INSERT INTO public.who_global_data VALUES (29568, 0, 0, 0, 0, 125, 116);
INSERT INTO public.who_global_data VALUES (29569, 0, 19, 0, 0, 125, 128);
INSERT INTO public.who_global_data VALUES (29570, 0, 27, 0, 0, 125, 6);
INSERT INTO public.who_global_data VALUES (29571, 0, 412, 0, 8, 125, 227);
INSERT INTO public.who_global_data VALUES (29572, 0, 12, 0, 0, 125, 68);
INSERT INTO public.who_global_data VALUES (29573, 0, 64, 0, 0, 125, 184);
INSERT INTO public.who_global_data VALUES (29574, 0, 0, 0, 0, 125, 82);
INSERT INTO public.who_global_data VALUES (29575, 0, 750, 0, 42, 125, 149);
INSERT INTO public.who_global_data VALUES (29576, 2, 913, 0, 15, 125, 197);
INSERT INTO public.who_global_data VALUES (29577, 419, 335997, 27, 4850, 125, 78);
INSERT INTO public.who_global_data VALUES (29578, 32, 15051, 1, 312, 125, 233);
INSERT INTO public.who_global_data VALUES (29579, 107, 33842, 2, 753, 125, 133);
INSERT INTO public.who_global_data VALUES (29580, 0, 142, 0, 0, 125, 35);
INSERT INTO public.who_global_data VALUES (29581, 7, 2259, 0, 72, 125, 114);
INSERT INTO public.who_global_data VALUES (29582, 6, 57800, 0, 27, 125, 237);
INSERT INTO public.who_global_data VALUES (29583, 0, 13, 0, 0, 125, 55);
INSERT INTO public.who_global_data VALUES (29584, 0, 668, 0, 22, 125, 176);
INSERT INTO public.who_global_data VALUES (29585, 704, 12321, 0, 54, 125, 202);
INSERT INTO public.who_global_data VALUES (29586, 168, 6501, 0, 159, 125, 155);
INSERT INTO public.who_global_data VALUES (29587, 1, 1, 0, 0, 125, 32);
INSERT INTO public.who_global_data VALUES (29588, 0, 3593, 0, 99, 125, 220);
INSERT INTO public.who_global_data VALUES (29589, 1883, 679716, 29, 16938, 125, 30);
INSERT INTO public.who_global_data VALUES (29590, 11, 2726, 0, 50, 125, 147);
INSERT INTO public.who_global_data VALUES (29591, 12614, 847984, 141, 34366, 125, 208);
INSERT INTO public.who_global_data VALUES (29592, 7, 3395, 0, 13, 125, 45);
INSERT INTO public.who_global_data VALUES (29593, 2, 13660, 0, 836, 125, 110);
INSERT INTO public.who_global_data VALUES (29594, 8, 4899, 0, 105, 125, 88);
INSERT INTO public.who_global_data VALUES (29595, 712, 95183, 3, 5887, 125, 51);
INSERT INTO public.who_global_data VALUES (29596, 512, 55832, 0, 1826, 125, 209);
INSERT INTO public.who_global_data VALUES (29597, 40, 4329, 1, 204, 125, 205);
INSERT INTO public.who_global_data VALUES (29598, 43, 9895, 0, 77, 125, 18);
INSERT INTO public.who_global_data VALUES (29599, 2, 3585, 0, 59, 125, 72);
INSERT INTO public.who_global_data VALUES (29600, 12871, 480021, 49, 42317, 125, 44);
INSERT INTO public.who_global_data VALUES (29601, 0, 28, 0, 0, 125, 15);
INSERT INTO public.who_global_data VALUES (29602, 22, 1840, 0, 48, 125, 25);
INSERT INTO public.who_global_data VALUES (29603, 0, 0, 0, 0, 125, 179);
INSERT INTO public.who_global_data VALUES (29604, 0, 0, 0, 0, 125, 34);
INSERT INTO public.who_global_data VALUES (29605, 96, 4709, 2, 78, 125, 207);
INSERT INTO public.who_global_data VALUES (29606, 2509, 23453, 45, 321, 125, 166);
INSERT INTO public.who_global_data VALUES (29607, 8232, 780654, 59, 8384, 125, 126);
INSERT INTO public.who_global_data VALUES (29608, 0, 0, 0, 0, 125, 97);
INSERT INTO public.who_global_data VALUES (29609, 5, 695, 0, 6, 125, 36);
INSERT INTO public.who_global_data VALUES (29610, 0, 0, 0, 0, 125, 125);
INSERT INTO public.who_global_data VALUES (29611, 0, 8491, 0, 79, 125, 124);
INSERT INTO public.who_global_data VALUES (29612, 4140, 226462, 44, 4397, 125, 185);
INSERT INTO public.who_global_data VALUES (29613, 1231, 97760, 2, 426, 125, 194);
INSERT INTO public.who_global_data VALUES (29614, 0, 509, 0, 21, 125, 144);
INSERT INTO public.who_global_data VALUES (29615, 49465, 7256234, 808, 207366, 125, 19);
INSERT INTO public.who_global_data VALUES (29616, 0, 1326, 0, 20, 125, 217);
INSERT INTO public.who_global_data VALUES (29617, 36, 2097, 0, 48, 125, 148);
INSERT INTO public.who_global_data VALUES (29618, 645, 58421, 4, 479, 125, 86);
INSERT INTO public.who_global_data VALUES (29619, 0, 0, 0, 0, 125, 13);
INSERT INTO public.who_global_data VALUES (29620, 791, 76820, 8, 643, 125, 157);
INSERT INTO public.who_global_data VALUES (29621, 0, 1096, 0, 35, 125, 8);
INSERT INTO public.who_global_data VALUES (29622, 0, 0, 0, 0, 125, 73);
INSERT INTO public.who_global_data VALUES (29623, 1, 2045, 0, 590, 125, 101);
INSERT INTO public.who_global_data VALUES (29624, 0, 14830, 0, 333, 125, 165);
INSERT INTO public.who_global_data VALUES (29625, 0, 7858, 0, 228, 125, 14);
INSERT INTO public.who_global_data VALUES (29626, 7, 39383, 4, 1466, 126, 193);
INSERT INTO public.who_global_data VALUES (29627, 159, 13965, 1, 389, 126, 113);
INSERT INTO public.who_global_data VALUES (29628, 157, 51847, 8, 1749, 126, 143);
INSERT INTO public.who_global_data VALUES (29629, 0, 0, 0, 0, 126, 219);
INSERT INTO public.who_global_data VALUES (29630, 60, 2110, 0, 53, 126, 186);
INSERT INTO public.who_global_data VALUES (29631, 97, 5211, 4, 189, 126, 52);
INSERT INTO public.who_global_data VALUES (29632, 0, 3, 0, 0, 126, 180);
INSERT INTO public.who_global_data VALUES (29633, 5, 106, 0, 3, 126, 167);
INSERT INTO public.who_global_data VALUES (29634, 14001, 765002, 3351, 20288, 126, 154);
INSERT INTO public.who_global_data VALUES (29635, 543, 51238, 6, 967, 126, 94);
INSERT INTO public.who_global_data VALUES (29636, 35, 3998, 0, 27, 126, 66);
INSERT INTO public.who_global_data VALUES (29637, 17, 27113, 2, 890, 126, 58);
INSERT INTO public.who_global_data VALUES (29638, 872, 47189, 1, 803, 126, 163);
INSERT INTO public.who_global_data VALUES (29639, 144, 40453, 1, 594, 126, 37);
INSERT INTO public.who_global_data VALUES (29640, 97, 4220, 0, 96, 126, 142);
INSERT INTO public.who_global_data VALUES (29641, 429, 71803, 1, 255, 126, 83);
INSERT INTO public.who_global_data VALUES (29642, 1396, 366383, 33, 5305, 126, 228);
INSERT INTO public.who_global_data VALUES (29643, 3, 193, 0, 7, 126, 188);
INSERT INTO public.who_global_data VALUES (29644, 402, 79421, 5, 844, 126, 62);
INSERT INTO public.who_global_data VALUES (29645, 3721, 132831, 11, 10041, 126, 160);
INSERT INTO public.who_global_data VALUES (29646, 34, 2026, 0, 27, 126, 50);
INSERT INTO public.who_global_data VALUES (29647, 0, 2357, 0, 41, 126, 33);
INSERT INTO public.who_global_data VALUES (29648, 0, 181, 0, 9, 126, 183);
INSERT INTO public.who_global_data VALUES (29649, 1, 283, 0, 0, 126, 92);
INSERT INTO public.who_global_data VALUES (29650, 405, 135716, 36, 8001, 126, 158);
INSERT INTO public.who_global_data VALUES (29651, 0, 103, 0, 1, 126, 67);
INSERT INTO public.who_global_data VALUES (29652, 226, 27971, 10, 864, 126, 57);
INSERT INTO public.who_global_data VALUES (29653, 0, 3172, 0, 16, 126, 38);
INSERT INTO public.who_global_data VALUES (29654, 36157, 4847092, 728, 144680, 126, 141);
INSERT INTO public.who_global_data VALUES (29655, 0, 71, 0, 1, 126, 178);
INSERT INTO public.who_global_data VALUES (29656, 0, 146, 0, 3, 126, 108);
INSERT INTO public.who_global_data VALUES (29657, 240, 21336, 6, 838, 126, 39);
INSERT INTO public.who_global_data VALUES (29658, 32, 2088, 0, 58, 126, 2);
INSERT INTO public.who_global_data VALUES (29659, 0, 513, 0, 1, 126, 195);
INSERT INTO public.who_global_data VALUES (29660, 79, 6205, 1, 62, 126, 107);
INSERT INTO public.who_global_data VALUES (29661, 0, 278, 0, 0, 126, 161);
INSERT INTO public.who_global_data VALUES (29662, 0, 20838, 0, 418, 126, 212);
INSERT INTO public.who_global_data VALUES (29663, 1777, 160535, 22, 9319, 126, 181);
INSERT INTO public.who_global_data VALUES (29664, 0, 211, 0, 1, 126, 53);
INSERT INTO public.who_global_data VALUES (29665, 16, 4845, 0, 62, 126, 164);
INSERT INTO public.who_global_data VALUES (29666, 8, 1211, 0, 85, 126, 140);
INSERT INTO public.who_global_data VALUES (29667, 1840, 466590, 45, 12867, 126, 20);
INSERT INTO public.who_global_data VALUES (29668, 19, 91101, 0, 4746, 126, 112);
INSERT INTO public.who_global_data VALUES (29669, 5660, 835339, 198, 26196, 126, 111);
INSERT INTO public.who_global_data VALUES (29670, 0, 479, 0, 7, 126, 71);
INSERT INTO public.who_global_data VALUES (29671, 0, 5089, 0, 89, 126, 218);
INSERT INTO public.who_global_data VALUES (29672, 0, 0, 0, 0, 126, 43);
INSERT INTO public.who_global_data VALUES (29673, 1068, 76828, 13, 917, 126, 49);
INSERT INTO public.who_global_data VALUES (29674, 38, 19793, 0, 120, 126, 1);
INSERT INTO public.who_global_data VALUES (29675, 333, 17160, 7, 291, 126, 48);
INSERT INTO public.who_global_data VALUES (29676, 48, 5718, 0, 122, 126, 232);
INSERT INTO public.who_global_data VALUES (29677, 7, 399, 0, 1, 126, 175);
INSERT INTO public.who_global_data VALUES (29678, 17, 1789, 0, 22, 126, 21);
INSERT INTO public.who_global_data VALUES (29679, 3796, 78051, 21, 699, 126, 156);
INSERT INTO public.who_global_data VALUES (29680, 0, 0, 0, 0, 126, 95);
INSERT INTO public.who_global_data VALUES (29681, 44, 10728, 0, 272, 126, 177);
INSERT INTO public.who_global_data VALUES (29682, 536, 28932, 1, 652, 126, 210);
INSERT INTO public.who_global_data VALUES (29683, 0, 5417, 0, 61, 126, 120);
INSERT INTO public.who_global_data VALUES (29684, 0, 31, 0, 0, 126, 135);
INSERT INTO public.who_global_data VALUES (29685, 622, 113350, 9, 2117, 126, 206);
INSERT INTO public.who_global_data VALUES (29686, 950, 139534, 62, 11495, 126, 189);
INSERT INTO public.who_global_data VALUES (29687, 149, 103466, 10, 5956, 126, 129);
INSERT INTO public.who_global_data VALUES (29688, 0, 29175, 5, 853, 126, 121);
INSERT INTO public.who_global_data VALUES (29689, 15, 5045, 0, 83, 126, 59);
INSERT INTO public.who_global_data VALUES (29690, 6, 381, 0, 0, 126, 96);
INSERT INTO public.who_global_data VALUES (29691, 57, 3507, 1, 66, 126, 41);
INSERT INTO public.who_global_data VALUES (29692, 21, 5521, 0, 111, 126, 216);
INSERT INTO public.who_global_data VALUES (29693, 890, 76988, 3, 1207, 126, 236);
INSERT INTO public.who_global_data VALUES (29694, 0, 13, 0, 0, 126, 150);
INSERT INTO public.who_global_data VALUES (29695, 0, 472, 0, 0, 126, 61);
INSERT INTO public.who_global_data VALUES (29696, 0, 32, 0, 2, 126, 7);
INSERT INTO public.who_global_data VALUES (29697, 101, 10204, 1, 345, 126, 169);
INSERT INTO public.who_global_data VALUES (29698, 11543, 563792, 118, 31926, 126, 28);
INSERT INTO public.who_global_data VALUES (29699, 2, 9968, 0, 67, 126, 85);
INSERT INTO public.who_global_data VALUES (29700, 174, 2026, 1, 8, 126, 211);
INSERT INTO public.who_global_data VALUES (29701, 31, 8797, 0, 54, 126, 60);
INSERT INTO public.who_global_data VALUES (29702, 6, 3590, 2, 115, 126, 3);
INSERT INTO public.who_global_data VALUES (29703, 471, 7564, 5, 48, 126, 11);
INSERT INTO public.who_global_data VALUES (29704, 2563, 296958, 19, 9527, 126, 89);
INSERT INTO public.who_global_data VALUES (29705, 0, 46656, 0, 301, 126, 24);
INSERT INTO public.who_global_data VALUES (29706, 14, 410, 0, 0, 126, 162);
INSERT INTO public.who_global_data VALUES (29707, 460, 19346, 5, 398, 126, 100);
INSERT INTO public.who_global_data VALUES (29708, 0, 14, 0, 0, 126, 47);
INSERT INTO public.who_global_data VALUES (29709, 0, 24, 0, 0, 126, 29);
INSERT INTO public.who_global_data VALUES (29710, 375, 5903, 18, 75, 126, 40);
INSERT INTO public.who_global_data VALUES (29711, 67, 2617, 1, 50, 126, 222);
INSERT INTO public.who_global_data VALUES (29712, 681, 93090, 6, 3267, 126, 132);
INSERT INTO public.who_global_data VALUES (29713, 0, 256, 0, 13, 126, 130);
INSERT INTO public.who_global_data VALUES (29714, 35, 10735, 0, 66, 126, 234);
INSERT INTO public.who_global_data VALUES (29715, 0, 2362, 0, 39, 126, 23);
INSERT INTO public.who_global_data VALUES (29716, 35, 2929, 2, 82, 126, 192);
INSERT INTO public.who_global_data VALUES (29717, 26, 8792, 0, 229, 126, 69);
INSERT INTO public.who_global_data VALUES (29718, 0, 12, 0, 0, 126, 187);
INSERT INTO public.who_global_data VALUES (29719, 698, 77598, 27, 2380, 126, 230);
INSERT INTO public.who_global_data VALUES (29720, 1086, 29717, 14, 812, 126, 77);
INSERT INTO public.who_global_data VALUES (29721, 40, 2809, 0, 10, 126, 9);
INSERT INTO public.who_global_data VALUES (29722, 79476, 6473544, 1069, 100842, 126, 74);
INSERT INTO public.who_global_data VALUES (29723, 4317, 295499, 116, 10972, 126, 224);
INSERT INTO public.who_global_data VALUES (29724, 3552, 464596, 187, 26567, 126, 199);
INSERT INTO public.who_global_data VALUES (29725, 4785, 372259, 67, 9298, 126, 190);
INSERT INTO public.who_global_data VALUES (29726, 466, 37063, -5, 1801, 126, 12);
INSERT INTO public.who_global_data VALUES (29727, 0, 340, 0, 24, 126, 104);
INSERT INTO public.who_global_data VALUES (29728, 7731, 255147, 46, 1651, 126, 153);
INSERT INTO public.who_global_data VALUES (29729, 2499, 319908, 23, 35941, 126, 91);
INSERT INTO public.who_global_data VALUES (29730, 149, 6704, 5, 116, 126, 215);
INSERT INTO public.who_global_data VALUES (29731, 553, 84768, 12, 1590, 126, 84);
INSERT INTO public.who_global_data VALUES (29732, 5, 419, 0, 32, 126, 231);
INSERT INTO public.who_global_data VALUES (29733, 549, 13718, 10, 79, 126, 196);
INSERT INTO public.who_global_data VALUES (29734, 264, 141748, 0, 2075, 126, 105);
INSERT INTO public.who_global_data VALUES (29735, 210, 38923, 7, 725, 126, 122);
INSERT INTO public.who_global_data VALUES (29736, 0, 0, 0, 0, 126, 159);
INSERT INTO public.who_global_data VALUES (29737, 42, 15662, 0, 617, 126, 75);
INSERT INTO public.who_global_data VALUES (29738, 411, 106087, 3, 615, 126, 27);
INSERT INTO public.who_global_data VALUES (29739, 128, 47184, 1, 1066, 126, 54);
INSERT INTO public.who_global_data VALUES (29740, 0, 23, 0, 0, 126, 226);
INSERT INTO public.who_global_data VALUES (29741, 77, 1945, 1, 38, 126, 79);
INSERT INTO public.who_global_data VALUES (29742, 1291, 42159, 12, 386, 126, 56);
INSERT INTO public.who_global_data VALUES (29743, 44, 1639, 2, 38, 126, 117);
INSERT INTO public.who_global_data VALUES (29744, 0, 1343, 0, 82, 126, 152);
INSERT INTO public.who_global_data VALUES (29745, 370, 36087, 8, 578, 126, 16);
INSERT INTO public.who_global_data VALUES (29746, 3, 125, 0, 1, 126, 10);
INSERT INTO public.who_global_data VALUES (29747, 125, 5076, 2, 80, 126, 201);
INSERT INTO public.who_global_data VALUES (29748, 114, 8709, 0, 125, 126, 174);
INSERT INTO public.who_global_data VALUES (29749, 39, 16493, 0, 232, 126, 119);
INSERT INTO public.who_global_data VALUES (29750, 4, 5783, 0, 179, 126, 168);
INSERT INTO public.who_global_data VALUES (29751, 287, 11771, 0, 136, 126, 99);
INSERT INTO public.who_global_data VALUES (29752, 44, 10398, 0, 34, 126, 171);
INSERT INTO public.who_global_data VALUES (29753, 25, 3156, 0, 131, 126, 87);
INSERT INTO public.who_global_data VALUES (29754, 65, 3195, 1, 38, 126, 123);
INSERT INTO public.who_global_data VALUES (29755, 0, 0, 0, 0, 126, 151);
INSERT INTO public.who_global_data VALUES (29756, 0, 1543, 0, 21, 126, 213);
INSERT INTO public.who_global_data VALUES (29757, 6, 7511, 0, 161, 126, 118);
INSERT INTO public.who_global_data VALUES (29758, 0, 381, 0, 10, 126, 134);
INSERT INTO public.who_global_data VALUES (29759, 0, 3779, 0, 42, 126, 65);
INSERT INTO public.who_global_data VALUES (29760, 5099, 748315, 432, 78078, 126, 102);
INSERT INTO public.who_global_data VALUES (29761, 0, 0, 0, 0, 126, 223);
INSERT INTO public.who_global_data VALUES (29762, 2, 224, 0, 2, 126, 4);
INSERT INTO public.who_global_data VALUES (29763, 0, 313, 0, 0, 126, 146);
INSERT INTO public.who_global_data VALUES (29764, 241, 12083, 2, 175, 126, 31);
INSERT INTO public.who_global_data VALUES (29765, 0, 13, 0, 1, 126, 127);
INSERT INTO public.who_global_data VALUES (29766, 2521, 128565, 34, 2263, 126, 22);
INSERT INTO public.who_global_data VALUES (29767, 91, 8979, 2, 64, 126, 115);
INSERT INTO public.who_global_data VALUES (29768, 1142, 15525, 32, 353, 126, 106);
INSERT INTO public.who_global_data VALUES (29769, 101, 11480, 0, 123, 126, 90);
INSERT INTO public.who_global_data VALUES (29770, 0, 0, 0, 0, 126, 70);
INSERT INTO public.who_global_data VALUES (29771, 2722, 82450, 11, 520, 126, 46);
INSERT INTO public.who_global_data VALUES (29772, 3805, 127665, 9, 6427, 126, 139);
INSERT INTO public.who_global_data VALUES (29773, 0, 27, 0, 0, 126, 42);
INSERT INTO public.who_global_data VALUES (29774, 1, 1493, 0, 25, 126, 80);
INSERT INTO public.who_global_data VALUES (29775, 0, 4146, 0, 151, 126, 203);
INSERT INTO public.who_global_data VALUES (29776, 0, 1197, 0, 69, 126, 136);
INSERT INTO public.who_global_data VALUES (29777, 126, 59127, 0, 1112, 126, 63);
INSERT INTO public.who_global_data VALUES (29778, 0, 0, 0, 0, 126, 17);
INSERT INTO public.who_global_data VALUES (29779, 0, 73, 0, 2, 126, 172);
INSERT INTO public.who_global_data VALUES (29780, 225, 18363, 6, 749, 126, 109);
INSERT INTO public.who_global_data VALUES (29781, 122, 14149, 1, 275, 126, 200);
INSERT INTO public.who_global_data VALUES (29782, 545, 51607, 3, 379, 126, 93);
INSERT INTO public.who_global_data VALUES (29783, 0, 98585, 0, 935, 126, 5);
INSERT INTO public.who_global_data VALUES (29784, 0, 741, 0, 13, 126, 214);
INSERT INTO public.who_global_data VALUES (29785, 553, 313984, 8, 6507, 126, 204);
INSERT INTO public.who_global_data VALUES (29786, 0, 0, 0, 0, 126, 198);
INSERT INTO public.who_global_data VALUES (29787, 747, 113342, 15, 2387, 126, 173);
INSERT INTO public.who_global_data VALUES (29788, 0, 539, 0, 7, 126, 229);
INSERT INTO public.who_global_data VALUES (29789, 1041, 41799, 12, 869, 126, 76);
INSERT INTO public.who_global_data VALUES (29790, 3468, 818297, 72, 32535, 126, 138);
INSERT INTO public.who_global_data VALUES (29791, 2599, 316678, 54, 5616, 126, 98);
INSERT INTO public.who_global_data VALUES (29792, 0, 0, 0, 0, 126, 103);
INSERT INTO public.who_global_data VALUES (29793, 2292, 95773, 27, 2570, 126, 225);
INSERT INTO public.who_global_data VALUES (29794, 888, 77284, 6, 1983, 126, 131);
INSERT INTO public.who_global_data VALUES (29795, 680, 49747, 8, 673, 126, 235);
INSERT INTO public.who_global_data VALUES (29796, 205, 126164, 1, 215, 126, 137);
INSERT INTO public.who_global_data VALUES (29797, 75, 24027, 4, 420, 126, 81);
INSERT INTO public.who_global_data VALUES (29798, 952, 55016, 8, 1344, 126, 182);
INSERT INTO public.who_global_data VALUES (29799, 185, 4178, 0, 16, 126, 145);
INSERT INTO public.who_global_data VALUES (29800, 2343, 132001, 53, 4915, 126, 26);
INSERT INTO public.who_global_data VALUES (29801, 9859, 1204502, 174, 21251, 126, 170);
INSERT INTO public.who_global_data VALUES (29802, 4, 4847, 0, 29, 126, 191);
INSERT INTO public.who_global_data VALUES (29803, 0, 5, 0, 0, 126, 221);
INSERT INTO public.who_global_data VALUES (29804, 14, 62, 0, 0, 126, 64);
INSERT INTO public.who_global_data VALUES (29805, 0, 0, 0, 0, 126, 116);
INSERT INTO public.who_global_data VALUES (29806, 0, 19, 0, 0, 126, 128);
INSERT INTO public.who_global_data VALUES (29807, 0, 27, 0, 0, 126, 6);
INSERT INTO public.who_global_data VALUES (29808, 29, 412, 0, 8, 126, 227);
INSERT INTO public.who_global_data VALUES (29809, 0, 12, 0, 0, 126, 68);
INSERT INTO public.who_global_data VALUES (29810, 0, 64, 0, 0, 126, 184);
INSERT INTO public.who_global_data VALUES (29811, 0, 0, 0, 0, 126, 82);
INSERT INTO public.who_global_data VALUES (29812, 0, 750, 0, 42, 126, 149);
INSERT INTO public.who_global_data VALUES (29813, 0, 911, 0, 15, 126, 197);
INSERT INTO public.who_global_data VALUES (29814, 481, 335578, 29, 4823, 126, 78);
INSERT INTO public.who_global_data VALUES (29815, 0, 15019, 0, 311, 126, 233);
INSERT INTO public.who_global_data VALUES (29816, 73, 33735, 1, 751, 126, 133);
INSERT INTO public.who_global_data VALUES (29817, 0, 142, 0, 0, 126, 35);
INSERT INTO public.who_global_data VALUES (29818, 14, 2252, 0, 72, 126, 114);
INSERT INTO public.who_global_data VALUES (29819, 10, 57794, 0, 27, 126, 237);
INSERT INTO public.who_global_data VALUES (29820, 0, 13, 0, 0, 126, 55);
INSERT INTO public.who_global_data VALUES (29821, 9, 668, 0, 22, 126, 176);
INSERT INTO public.who_global_data VALUES (29822, 679, 11617, 6, 54, 126, 202);
INSERT INTO public.who_global_data VALUES (29823, 228, 6333, 0, 159, 126, 155);
INSERT INTO public.who_global_data VALUES (29824, 0, 0, 0, 0, 126, 32);
INSERT INTO public.who_global_data VALUES (29825, 0, 3593, 0, 99, 126, 220);
INSERT INTO public.who_global_data VALUES (29826, 1749, 677833, 43, 16909, 126, 30);
INSERT INTO public.who_global_data VALUES (29827, 0, 2715, 0, 50, 126, 147);
INSERT INTO public.who_global_data VALUES (29828, 11199, 835370, 130, 34225, 126, 208);
INSERT INTO public.who_global_data VALUES (29829, 6, 3388, 0, 13, 126, 45);
INSERT INTO public.who_global_data VALUES (29830, 1, 13658, 0, 836, 126, 110);
INSERT INTO public.who_global_data VALUES (29831, 14, 4891, 1, 105, 126, 88);
INSERT INTO public.who_global_data VALUES (29832, 633, 94471, 1, 5884, 126, 51);
INSERT INTO public.who_global_data VALUES (29833, 677, 55320, 1, 1826, 126, 209);
INSERT INTO public.who_global_data VALUES (29834, 42, 4289, 1, 203, 126, 205);
INSERT INTO public.who_global_data VALUES (29835, 41, 9852, 0, 77, 126, 18);
INSERT INTO public.who_global_data VALUES (29836, 8, 3583, 0, 59, 126, 72);
INSERT INTO public.who_global_data VALUES (29837, 6968, 467150, 66, 42268, 126, 44);
INSERT INTO public.who_global_data VALUES (29838, 0, 28, 0, 0, 126, 15);
INSERT INTO public.who_global_data VALUES (29839, 9, 1818, 0, 48, 126, 25);
INSERT INTO public.who_global_data VALUES (29840, 0, 0, 0, 0, 126, 179);
INSERT INTO public.who_global_data VALUES (29841, 0, 0, 0, 0, 126, 34);
INSERT INTO public.who_global_data VALUES (29842, 71, 4613, 0, 76, 126, 207);
INSERT INTO public.who_global_data VALUES (29843, 0, 20944, 0, 276, 126, 166);
INSERT INTO public.who_global_data VALUES (29844, 8172, 772422, 63, 8325, 126, 126);
INSERT INTO public.who_global_data VALUES (29845, 0, 0, 0, 0, 126, 97);
INSERT INTO public.who_global_data VALUES (29846, 1, 690, 0, 6, 126, 36);
INSERT INTO public.who_global_data VALUES (29847, 0, 0, 0, 0, 126, 125);
INSERT INTO public.who_global_data VALUES (29848, 204, 8491, 4, 79, 126, 124);
INSERT INTO public.who_global_data VALUES (29849, 4661, 222322, 92, 4353, 126, 185);
INSERT INTO public.who_global_data VALUES (29850, 1181, 96529, 3, 424, 126, 194);
INSERT INTO public.who_global_data VALUES (29851, 0, 509, 0, 21, 126, 144);
INSERT INTO public.who_global_data VALUES (29852, 46293, 7206769, 892, 206558, 126, 19);
INSERT INTO public.who_global_data VALUES (29853, 3, 1326, 0, 20, 126, 217);
INSERT INTO public.who_global_data VALUES (29854, 15, 2061, 0, 48, 126, 148);
INSERT INTO public.who_global_data VALUES (29855, 0, 57776, 0, 475, 126, 86);
INSERT INTO public.who_global_data VALUES (29856, 0, 0, 0, 0, 126, 13);
INSERT INTO public.who_global_data VALUES (29857, 907, 76029, 7, 635, 126, 157);
INSERT INTO public.who_global_data VALUES (29858, 1, 1096, 0, 35, 126, 8);
INSERT INTO public.who_global_data VALUES (29859, 0, 0, 0, 0, 126, 73);
INSERT INTO public.who_global_data VALUES (29860, 1, 2044, 2, 590, 126, 101);
INSERT INTO public.who_global_data VALUES (29861, 28, 14830, 0, 333, 126, 165);
INSERT INTO public.who_global_data VALUES (29862, 8, 7858, 0, 228, 126, 14);
INSERT INTO public.who_global_data VALUES (29863, 5, 39376, 0, 1462, 127, 193);
INSERT INTO public.who_global_data VALUES (29864, 157, 13806, 1, 388, 127, 113);
INSERT INTO public.who_global_data VALUES (29865, 160, 51690, 5, 1741, 127, 143);
INSERT INTO public.who_global_data VALUES (29866, 0, 0, 0, 0, 127, 219);
INSERT INTO public.who_global_data VALUES (29867, 0, 2050, 0, 53, 127, 186);
INSERT INTO public.who_global_data VALUES (29868, 142, 5114, 2, 185, 127, 52);
INSERT INTO public.who_global_data VALUES (29869, 0, 3, 0, 0, 127, 180);
INSERT INTO public.who_global_data VALUES (29870, 0, 101, 0, 3, 127, 167);
INSERT INTO public.who_global_data VALUES (29871, 14392, 751001, 418, 16937, 127, 154);
INSERT INTO public.who_global_data VALUES (29872, 532, 50695, 3, 961, 127, 94);
INSERT INTO public.who_global_data VALUES (29873, 29, 3963, 1, 27, 127, 66);
INSERT INTO public.who_global_data VALUES (29874, 18, 27096, 2, 888, 127, 58);
INSERT INTO public.who_global_data VALUES (29875, 564, 46317, 3, 802, 127, 163);
INSERT INTO public.who_global_data VALUES (29876, 80, 40309, 2, 593, 127, 37);
INSERT INTO public.who_global_data VALUES (29877, 101, 4123, 1, 96, 127, 142);
INSERT INTO public.who_global_data VALUES (29878, 510, 71374, 3, 254, 127, 83);
INSERT INTO public.who_global_data VALUES (29879, 1508, 364987, 21, 5272, 127, 228);
INSERT INTO public.who_global_data VALUES (29880, 0, 190, 0, 7, 127, 188);
INSERT INTO public.who_global_data VALUES (29881, 388, 79019, 6, 839, 127, 62);
INSERT INTO public.who_global_data VALUES (29882, 3410, 129110, 15, 10030, 127, 160);
INSERT INTO public.who_global_data VALUES (29883, 49, 1992, 1, 27, 127, 50);
INSERT INTO public.who_global_data VALUES (29884, 0, 2357, 0, 41, 127, 33);
INSERT INTO public.who_global_data VALUES (29885, 0, 181, 0, 9, 127, 183);
INSERT INTO public.who_global_data VALUES (29886, 0, 282, 0, 0, 127, 92);
INSERT INTO public.who_global_data VALUES (29887, 670, 135311, 34, 7965, 127, 158);
INSERT INTO public.who_global_data VALUES (29888, 0, 103, 0, 1, 127, 67);
INSERT INTO public.who_global_data VALUES (29889, 280, 27745, 5, 854, 127, 57);
INSERT INTO public.who_global_data VALUES (29890, 0, 3172, 0, 16, 127, 38);
INSERT INTO public.who_global_data VALUES (29891, 33413, 4810935, 1031, 143952, 127, 141);
INSERT INTO public.who_global_data VALUES (29892, 0, 71, 0, 1, 127, 178);
INSERT INTO public.who_global_data VALUES (29893, 0, 146, 0, 3, 127, 108);
INSERT INTO public.who_global_data VALUES (29894, 263, 21096, 7, 832, 127, 39);
INSERT INTO public.who_global_data VALUES (29895, 28, 2056, 1, 58, 127, 2);
INSERT INTO public.who_global_data VALUES (29896, 3, 513, 0, 1, 127, 195);
INSERT INTO public.who_global_data VALUES (29897, 102, 6126, 1, 61, 127, 107);
INSERT INTO public.who_global_data VALUES (29898, 1, 278, 0, 0, 127, 161);
INSERT INTO public.who_global_data VALUES (29899, 0, 20838, 0, 418, 127, 212);
INSERT INTO public.who_global_data VALUES (29900, 1797, 158758, 6, 9297, 127, 181);
INSERT INTO public.who_global_data VALUES (29901, 0, 211, 0, 1, 127, 53);
INSERT INTO public.who_global_data VALUES (29902, 0, 4829, 0, 62, 127, 164);
INSERT INTO public.who_global_data VALUES (29903, 3, 1203, 0, 85, 127, 140);
INSERT INTO public.who_global_data VALUES (29904, 1759, 464750, 81, 12822, 127, 20);
INSERT INTO public.who_global_data VALUES (29905, 21, 91082, 0, 4746, 127, 112);
INSERT INTO public.who_global_data VALUES (29906, 5637, 829679, 170, 25998, 127, 111);
INSERT INTO public.who_global_data VALUES (29907, 0, 479, 0, 7, 127, 71);
INSERT INTO public.who_global_data VALUES (29908, 0, 5089, 0, 89, 127, 218);
INSERT INTO public.who_global_data VALUES (29909, 0, 0, 0, 0, 127, 43);
INSERT INTO public.who_global_data VALUES (29910, 1156, 75760, 24, 904, 127, 49);
INSERT INTO public.who_global_data VALUES (29911, 31, 19755, 0, 120, 127, 1);
INSERT INTO public.who_global_data VALUES (29912, 234, 16827, 4, 284, 127, 48);
INSERT INTO public.who_global_data VALUES (29913, 73, 5670, 0, 122, 127, 232);
INSERT INTO public.who_global_data VALUES (29914, 22, 392, 0, 1, 127, 175);
INSERT INTO public.who_global_data VALUES (29915, 17, 1772, 0, 22, 127, 21);
INSERT INTO public.who_global_data VALUES (29916, 5336, 74255, 23, 678, 127, 156);
INSERT INTO public.who_global_data VALUES (29917, 0, 0, 0, 0, 127, 95);
INSERT INTO public.who_global_data VALUES (29918, 26, 10684, 0, 272, 127, 177);
INSERT INTO public.who_global_data VALUES (29919, 398, 28396, 1, 651, 127, 210);
INSERT INTO public.who_global_data VALUES (29920, 1, 5417, 0, 61, 127, 120);
INSERT INTO public.who_global_data VALUES (29921, 1, 31, 0, 0, 127, 135);
INSERT INTO public.who_global_data VALUES (29922, 519, 112728, 3, 2108, 127, 206);
INSERT INTO public.who_global_data VALUES (29923, 1537, 138584, 78, 11433, 127, 189);
INSERT INTO public.who_global_data VALUES (29924, 119, 103317, 16, 5946, 127, 129);
INSERT INTO public.who_global_data VALUES (29925, 98, 29175, 5, 848, 127, 121);
INSERT INTO public.who_global_data VALUES (29926, 0, 5030, 0, 83, 127, 59);
INSERT INTO public.who_global_data VALUES (29927, 0, 375, 0, 0, 127, 96);
INSERT INTO public.who_global_data VALUES (29928, 79, 3450, 1, 65, 127, 41);
INSERT INTO public.who_global_data VALUES (29929, 18, 5500, 2, 111, 127, 216);
INSERT INTO public.who_global_data VALUES (29930, 730, 76098, 6, 1204, 127, 236);
INSERT INTO public.who_global_data VALUES (29931, 0, 13, 0, 0, 127, 150);
INSERT INTO public.who_global_data VALUES (29932, 5, 472, 0, 0, 127, 61);
INSERT INTO public.who_global_data VALUES (29933, 0, 32, 0, 2, 127, 7);
INSERT INTO public.who_global_data VALUES (29934, 111, 10103, 0, 344, 127, 169);
INSERT INTO public.who_global_data VALUES (29935, 13959, 552249, 62, 31808, 127, 28);
INSERT INTO public.who_global_data VALUES (29936, 11, 9966, 1, 67, 127, 85);
INSERT INTO public.who_global_data VALUES (29937, 0, 1852, 0, 7, 127, 211);
INSERT INTO public.who_global_data VALUES (29938, 0, 8766, 0, 54, 127, 60);
INSERT INTO public.who_global_data VALUES (29939, 5, 3584, 1, 113, 127, 3);
INSERT INTO public.who_global_data VALUES (29940, 453, 7093, 3, 43, 127, 11);
INSERT INTO public.who_global_data VALUES (29941, 2673, 294395, 8, 9508, 127, 89);
INSERT INTO public.who_global_data VALUES (29942, 0, 46656, 0, 301, 127, 24);
INSERT INTO public.who_global_data VALUES (29943, 5, 396, 0, 0, 127, 162);
INSERT INTO public.who_global_data VALUES (29944, 411, 18886, 2, 393, 127, 100);
INSERT INTO public.who_global_data VALUES (29945, 0, 14, 0, 0, 127, 47);
INSERT INTO public.who_global_data VALUES (29946, 0, 24, 0, 0, 127, 29);
INSERT INTO public.who_global_data VALUES (29947, 0, 5528, 0, 57, 127, 40);
INSERT INTO public.who_global_data VALUES (29948, 62, 2550, 0, 49, 127, 222);
INSERT INTO public.who_global_data VALUES (29949, 663, 92409, 15, 3261, 127, 132);
INSERT INTO public.who_global_data VALUES (29950, 0, 256, 0, 13, 127, 130);
INSERT INTO public.who_global_data VALUES (29951, 48, 10700, 0, 66, 127, 234);
INSERT INTO public.who_global_data VALUES (29952, 38, 2362, 0, 39, 127, 23);
INSERT INTO public.who_global_data VALUES (29953, 48, 2894, 2, 80, 127, 192);
INSERT INTO public.who_global_data VALUES (29954, 0, 8766, 0, 229, 127, 69);
INSERT INTO public.who_global_data VALUES (29955, 0, 12, 0, 0, 127, 187);
INSERT INTO public.who_global_data VALUES (29956, 802, 76900, 30, 2353, 127, 230);
INSERT INTO public.who_global_data VALUES (29957, 1322, 28631, 17, 798, 127, 77);
INSERT INTO public.who_global_data VALUES (29958, 41, 2769, 0, 10, 127, 9);
INSERT INTO public.who_global_data VALUES (29959, 81484, 6394068, 1095, 99773, 127, 74);
INSERT INTO public.who_global_data VALUES (29960, 4174, 291182, 116, 10856, 127, 224);
INSERT INTO public.who_global_data VALUES (29961, 3825, 461044, 211, 26380, 127, 199);
INSERT INTO public.who_global_data VALUES (29962, 4493, 367474, 50, 9231, 127, 190);
INSERT INTO public.who_global_data VALUES (29963, 442, 36597, 2, 1806, 127, 12);
INSERT INTO public.who_global_data VALUES (29964, 0, 340, 0, 24, 127, 104);
INSERT INTO public.who_global_data VALUES (29965, 9078, 247416, 37, 1605, 127, 153);
INSERT INTO public.who_global_data VALUES (29966, 2548, 317409, 24, 35918, 127, 91);
INSERT INTO public.who_global_data VALUES (29967, 73, 6555, 4, 111, 127, 215);
INSERT INTO public.who_global_data VALUES (29968, 652, 84215, 7, 1578, 127, 84);
INSERT INTO public.who_global_data VALUES (29969, 5, 414, 0, 32, 127, 231);
INSERT INTO public.who_global_data VALUES (29970, 1276, 13169, 8, 69, 127, 196);
INSERT INTO public.who_global_data VALUES (29971, 228, 141484, 0, 2075, 127, 105);
INSERT INTO public.who_global_data VALUES (29972, 184, 38713, 7, 718, 127, 122);
INSERT INTO public.who_global_data VALUES (29973, 0, 0, 0, 0, 127, 159);
INSERT INTO public.who_global_data VALUES (29974, 43, 15620, 2, 617, 127, 75);
INSERT INTO public.who_global_data VALUES (29975, 494, 105676, 2, 612, 127, 27);
INSERT INTO public.who_global_data VALUES (29976, 215, 47056, 0, 1065, 127, 54);
INSERT INTO public.who_global_data VALUES (29977, 0, 23, 0, 0, 127, 226);
INSERT INTO public.who_global_data VALUES (29978, 44, 1868, 0, 37, 127, 79);
INSERT INTO public.who_global_data VALUES (29979, 1248, 40868, 7, 374, 127, 56);
INSERT INTO public.who_global_data VALUES (29980, 0, 1595, 0, 36, 127, 117);
INSERT INTO public.who_global_data VALUES (29981, 0, 1343, 0, 82, 127, 152);
INSERT INTO public.who_global_data VALUES (29982, 509, 35717, 11, 570, 127, 16);
INSERT INTO public.who_global_data VALUES (29983, 1, 122, 0, 1, 127, 10);
INSERT INTO public.who_global_data VALUES (29984, 172, 4951, -14, 78, 127, 201);
INSERT INTO public.who_global_data VALUES (29985, 86, 8595, 1, 125, 127, 174);
INSERT INTO public.who_global_data VALUES (29986, 46, 16454, 2, 232, 127, 119);
INSERT INTO public.who_global_data VALUES (29987, 6, 5779, 0, 179, 127, 168);
INSERT INTO public.who_global_data VALUES (29988, 260, 11484, 0, 136, 127, 99);
INSERT INTO public.who_global_data VALUES (29989, 63, 10354, 0, 34, 127, 171);
INSERT INTO public.who_global_data VALUES (29990, 13, 3131, 0, 131, 127, 87);
INSERT INTO public.who_global_data VALUES (29991, 44, 3130, 2, 37, 127, 123);
INSERT INTO public.who_global_data VALUES (29992, 0, 0, 0, 0, 127, 151);
INSERT INTO public.who_global_data VALUES (29993, 0, 1543, 0, 21, 127, 213);
INSERT INTO public.who_global_data VALUES (29994, 3, 7505, 0, 161, 127, 118);
INSERT INTO public.who_global_data VALUES (29995, 0, 381, 0, 10, 127, 134);
INSERT INTO public.who_global_data VALUES (29996, 0, 3779, 0, 42, 127, 65);
INSERT INTO public.who_global_data VALUES (29997, 5053, 743216, 483, 77646, 127, 102);
INSERT INTO public.who_global_data VALUES (29998, 0, 0, 0, 0, 127, 223);
INSERT INTO public.who_global_data VALUES (29999, 1, 222, 0, 2, 127, 4);
INSERT INTO public.who_global_data VALUES (30000, 0, 313, 0, 0, 127, 146);
INSERT INTO public.who_global_data VALUES (30001, 186, 11842, 3, 173, 127, 31);
INSERT INTO public.who_global_data VALUES (30002, 0, 13, 0, 1, 127, 127);
INSERT INTO public.who_global_data VALUES (30003, 2391, 126044, 35, 2229, 127, 22);
INSERT INTO public.who_global_data VALUES (30004, 160, 8888, 1, 62, 127, 115);
INSERT INTO public.who_global_data VALUES (30005, 1010, 14383, 11, 321, 127, 106);
INSERT INTO public.who_global_data VALUES (30006, 114, 11379, 2, 123, 127, 90);
INSERT INTO public.who_global_data VALUES (30007, 0, 0, 0, 0, 127, 70);
INSERT INTO public.who_global_data VALUES (30008, 1911, 79728, 11, 509, 127, 46);
INSERT INTO public.who_global_data VALUES (30009, 3255, 123860, 13, 6418, 127, 139);
INSERT INTO public.who_global_data VALUES (30010, 0, 27, 0, 0, 127, 42);
INSERT INTO public.who_global_data VALUES (30011, 0, 1492, 0, 25, 127, 80);
INSERT INTO public.who_global_data VALUES (30012, 0, 4146, 0, 151, 127, 203);
INSERT INTO public.who_global_data VALUES (30013, 0, 1197, 0, 69, 127, 136);
INSERT INTO public.who_global_data VALUES (30014, 153, 59001, 0, 1112, 127, 63);
INSERT INTO public.who_global_data VALUES (30015, 0, 0, 0, 0, 127, 17);
INSERT INTO public.who_global_data VALUES (30016, 3, 73, 0, 2, 127, 172);
INSERT INTO public.who_global_data VALUES (30017, 161, 18138, 4, 743, 127, 109);
INSERT INTO public.who_global_data VALUES (30018, 113, 14027, 0, 274, 127, 200);
INSERT INTO public.who_global_data VALUES (30019, 521, 51062, 8, 376, 127, 93);
INSERT INTO public.who_global_data VALUES (30020, 0, 98585, 0, 935, 127, 5);
INSERT INTO public.who_global_data VALUES (30021, 0, 741, 0, 13, 127, 214);
INSERT INTO public.who_global_data VALUES (30022, 625, 313431, 15, 6499, 127, 204);
INSERT INTO public.who_global_data VALUES (30023, 0, 0, 0, 0, 127, 198);
INSERT INTO public.who_global_data VALUES (30024, 742, 112595, 8, 2372, 127, 173);
INSERT INTO public.who_global_data VALUES (30025, 5, 539, 0, 7, 127, 229);
INSERT INTO public.who_global_data VALUES (30026, 657, 40758, 16, 857, 127, 76);
INSERT INTO public.who_global_data VALUES (30027, 3061, 814829, 67, 32463, 127, 138);
INSERT INTO public.who_global_data VALUES (30028, 2385, 314079, 58, 5562, 127, 98);
INSERT INTO public.who_global_data VALUES (30029, 0, 0, 0, 0, 127, 103);
INSERT INTO public.who_global_data VALUES (30030, 1967, 93481, 30, 2543, 127, 225);
INSERT INTO public.who_global_data VALUES (30031, 854, 76396, 6, 1977, 127, 131);
INSERT INTO public.who_global_data VALUES (30032, 312, 49067, 4, 665, 127, 235);
INSERT INTO public.who_global_data VALUES (30033, 199, 125959, 0, 214, 127, 137);
INSERT INTO public.who_global_data VALUES (30034, 63, 23952, 1, 416, 127, 81);
INSERT INTO public.who_global_data VALUES (30035, 1022, 54064, 16, 1336, 127, 182);
INSERT INTO public.who_global_data VALUES (30036, 0, 3993, 0, 16, 127, 145);
INSERT INTO public.who_global_data VALUES (30037, 2086, 129658, 37, 4862, 127, 26);
INSERT INTO public.who_global_data VALUES (30038, 9412, 1194643, 186, 21077, 127, 170);
INSERT INTO public.who_global_data VALUES (30039, 3, 4843, 0, 29, 127, 191);
INSERT INTO public.who_global_data VALUES (30040, 0, 5, 0, 0, 127, 221);
INSERT INTO public.who_global_data VALUES (30041, 0, 48, 0, 0, 127, 64);
INSERT INTO public.who_global_data VALUES (30042, 0, 0, 0, 0, 127, 116);
INSERT INTO public.who_global_data VALUES (30043, 0, 19, 0, 0, 127, 128);
INSERT INTO public.who_global_data VALUES (30044, 0, 27, 0, 0, 127, 6);
INSERT INTO public.who_global_data VALUES (30045, 0, 383, 0, 8, 127, 227);
INSERT INTO public.who_global_data VALUES (30046, 0, 12, 0, 0, 127, 68);
INSERT INTO public.who_global_data VALUES (30047, 0, 64, 0, 0, 127, 184);
INSERT INTO public.who_global_data VALUES (30048, 0, 0, 0, 0, 127, 82);
INSERT INTO public.who_global_data VALUES (30049, 0, 750, 0, 42, 127, 149);
INSERT INTO public.who_global_data VALUES (30050, 0, 911, 0, 15, 127, 197);
INSERT INTO public.who_global_data VALUES (30051, 492, 335097, 26, 4794, 127, 78);
INSERT INTO public.who_global_data VALUES (30052, 37, 15019, 0, 311, 127, 233);
INSERT INTO public.who_global_data VALUES (30053, 111, 33662, 1, 750, 127, 133);
INSERT INTO public.who_global_data VALUES (30054, 0, 142, 0, 0, 127, 35);
INSERT INTO public.who_global_data VALUES (30055, 7, 2238, 0, 72, 127, 114);
INSERT INTO public.who_global_data VALUES (30056, 19, 57784, 0, 27, 127, 237);
INSERT INTO public.who_global_data VALUES (30057, 0, 13, 0, 0, 127, 55);
INSERT INTO public.who_global_data VALUES (30058, 14, 659, 0, 22, 127, 176);
INSERT INTO public.who_global_data VALUES (30059, 797, 10938, 0, 48, 127, 202);
INSERT INTO public.who_global_data VALUES (30060, 239, 6105, 2, 159, 127, 155);
INSERT INTO public.who_global_data VALUES (30061, 0, 0, 0, 0, 127, 32);
INSERT INTO public.who_global_data VALUES (30062, 5, 3593, 0, 99, 127, 220);
INSERT INTO public.who_global_data VALUES (30063, 1745, 676084, 132, 16866, 127, 30);
INSERT INTO public.who_global_data VALUES (30064, 11, 2715, 1, 50, 127, 147);
INSERT INTO public.who_global_data VALUES (30065, 11500, 824171, 154, 34095, 127, 208);
INSERT INTO public.who_global_data VALUES (30066, 2, 3382, 0, 13, 127, 45);
INSERT INTO public.who_global_data VALUES (30067, 4, 13657, 0, 836, 127, 110);
INSERT INTO public.who_global_data VALUES (30068, 14, 4877, 0, 104, 127, 88);
INSERT INTO public.who_global_data VALUES (30069, 689, 93838, 4, 5883, 127, 51);
INSERT INTO public.who_global_data VALUES (30070, 601, 54643, 5, 1825, 127, 209);
INSERT INTO public.who_global_data VALUES (30071, 47, 4247, 2, 202, 127, 205);
INSERT INTO public.who_global_data VALUES (30072, 42, 9811, 1, 77, 127, 18);
INSERT INTO public.who_global_data VALUES (30073, 6, 3575, 0, 59, 127, 72);
INSERT INTO public.who_global_data VALUES (30074, 6914, 460182, 59, 42202, 127, 44);
INSERT INTO public.who_global_data VALUES (30075, 0, 28, 0, 0, 127, 15);
INSERT INTO public.who_global_data VALUES (30076, 25, 1809, 0, 48, 127, 25);
INSERT INTO public.who_global_data VALUES (30077, 0, 0, 0, 0, 127, 179);
INSERT INTO public.who_global_data VALUES (30078, 0, 0, 0, 0, 127, 34);
INSERT INTO public.who_global_data VALUES (30079, 25, 4542, 1, 76, 127, 207);
INSERT INTO public.who_global_data VALUES (30080, 1223, 20944, 5, 276, 127, 166);
INSERT INTO public.who_global_data VALUES (30081, 8137, 764250, 67, 8262, 127, 126);
INSERT INTO public.who_global_data VALUES (30082, 0, 0, 0, 0, 127, 97);
INSERT INTO public.who_global_data VALUES (30083, 3, 689, 0, 6, 127, 36);
INSERT INTO public.who_global_data VALUES (30084, 0, 0, 0, 0, 127, 125);
INSERT INTO public.who_global_data VALUES (30085, 158, 8287, 0, 75, 127, 124);
INSERT INTO public.who_global_data VALUES (30086, 4633, 217661, 68, 4261, 127, 185);
INSERT INTO public.who_global_data VALUES (30087, 1158, 95348, 2, 421, 127, 194);
INSERT INTO public.who_global_data VALUES (30088, 0, 509, 0, 21, 127, 144);
INSERT INTO public.who_global_data VALUES (30089, 44985, 7160476, 1024, 205666, 127, 19);
INSERT INTO public.who_global_data VALUES (30090, 5, 1323, 0, 20, 127, 217);
INSERT INTO public.who_global_data VALUES (30091, 13, 2046, 0, 48, 127, 148);
INSERT INTO public.who_global_data VALUES (30092, 457, 57776, 1, 475, 127, 86);
INSERT INTO public.who_global_data VALUES (30093, 0, 0, 0, 0, 127, 13);
INSERT INTO public.who_global_data VALUES (30094, 759, 75122, 7, 628, 127, 157);
INSERT INTO public.who_global_data VALUES (30095, 0, 1095, 0, 35, 127, 8);
INSERT INTO public.who_global_data VALUES (30096, 0, 0, 0, 0, 127, 73);
INSERT INTO public.who_global_data VALUES (30097, 5, 2043, 0, 588, 127, 101);
INSERT INTO public.who_global_data VALUES (30098, 43, 14802, 1, 333, 127, 165);
INSERT INTO public.who_global_data VALUES (30099, 12, 7850, 0, 228, 127, 14);
INSERT INTO public.who_global_data VALUES (30100, 17, 39371, 0, 1462, 128, 193);
INSERT INTO public.who_global_data VALUES (30101, 131, 13649, 3, 387, 128, 113);
INSERT INTO public.who_global_data VALUES (30102, 162, 51530, 10, 1736, 128, 143);
INSERT INTO public.who_global_data VALUES (30103, 0, 0, 0, 0, 128, 219);
INSERT INTO public.who_global_data VALUES (30104, 84, 2050, 0, 53, 128, 186);
INSERT INTO public.who_global_data VALUES (30105, 67, 4972, 4, 183, 128, 52);
INSERT INTO public.who_global_data VALUES (30106, 0, 3, 0, 0, 128, 180);
INSERT INTO public.who_global_data VALUES (30107, 0, 101, 0, 3, 128, 167);
INSERT INTO public.who_global_data VALUES (30108, 13477, 736609, 406, 16519, 128, 154);
INSERT INTO public.who_global_data VALUES (30109, 491, 50163, 4, 958, 128, 94);
INSERT INTO public.who_global_data VALUES (30110, 62, 3934, 1, 26, 128, 66);
INSERT INTO public.who_global_data VALUES (30111, 15, 27078, 4, 886, 128, 58);
INSERT INTO public.who_global_data VALUES (30112, 1146, 45753, 3, 799, 128, 163);
INSERT INTO public.who_global_data VALUES (30113, 110, 40229, 1, 591, 128, 37);
INSERT INTO public.who_global_data VALUES (30114, 119, 4022, 4, 95, 128, 142);
INSERT INTO public.who_global_data VALUES (30115, 442, 70864, 5, 251, 128, 83);
INSERT INTO public.who_global_data VALUES (30116, 1436, 363479, 32, 5251, 128, 228);
INSERT INTO public.who_global_data VALUES (30117, 0, 190, 0, 7, 128, 188);
INSERT INTO public.who_global_data VALUES (30118, 371, 78631, 5, 833, 128, 62);
INSERT INTO public.who_global_data VALUES (30119, 3243, 125700, 6, 10015, 128, 160);
INSERT INTO public.who_global_data VALUES (30120, 52, 1943, 2, 26, 128, 50);
INSERT INTO public.who_global_data VALUES (30121, 0, 2357, 0, 41, 128, 33);
INSERT INTO public.who_global_data VALUES (30122, 0, 181, 0, 9, 128, 183);
INSERT INTO public.who_global_data VALUES (30123, 1, 282, 0, 0, 128, 92);
INSERT INTO public.who_global_data VALUES (30124, 418, 134641, 31, 7931, 128, 158);
INSERT INTO public.who_global_data VALUES (30125, 5, 103, 0, 1, 128, 67);
INSERT INTO public.who_global_data VALUES (30126, 243, 27465, 13, 849, 128, 57);
INSERT INTO public.who_global_data VALUES (30127, 0, 3172, 0, 16, 128, 38);
INSERT INTO public.who_global_data VALUES (30128, 32058, 4777522, 863, 142921, 128, 141);
INSERT INTO public.who_global_data VALUES (30129, 0, 71, 0, 1, 128, 178);
INSERT INTO public.who_global_data VALUES (30130, 0, 146, 0, 3, 128, 108);
INSERT INTO public.who_global_data VALUES (30131, 286, 20833, 11, 825, 128, 39);
INSERT INTO public.who_global_data VALUES (30132, 0, 2028, 0, 57, 128, 2);
INSERT INTO public.who_global_data VALUES (30133, 2, 510, 0, 1, 128, 195);
INSERT INTO public.who_global_data VALUES (30134, 124, 6024, 1, 60, 128, 107);
INSERT INTO public.who_global_data VALUES (30135, 0, 277, 0, 0, 128, 161);
INSERT INTO public.who_global_data VALUES (30136, 0, 20838, 0, 418, 128, 212);
INSERT INTO public.who_global_data VALUES (30137, 1660, 156961, 13, 9291, 128, 181);
INSERT INTO public.who_global_data VALUES (30138, 0, 211, 0, 1, 128, 53);
INSERT INTO public.who_global_data VALUES (30139, 0, 4829, 0, 62, 128, 164);
INSERT INTO public.who_global_data VALUES (30140, 7, 1200, 0, 85, 128, 140);
INSERT INTO public.who_global_data VALUES (30141, 1691, 462991, 16, 12741, 128, 20);
INSERT INTO public.who_global_data VALUES (30142, 20, 91061, 0, 4746, 128, 112);
INSERT INTO public.who_global_data VALUES (30143, 5839, 824042, 187, 25828, 128, 111);
INSERT INTO public.who_global_data VALUES (30144, 1, 479, 0, 7, 128, 71);
INSERT INTO public.who_global_data VALUES (30145, 0, 5089, 0, 89, 128, 218);
INSERT INTO public.who_global_data VALUES (30146, 0, 0, 0, 0, 128, 43);
INSERT INTO public.who_global_data VALUES (30147, 890, 74604, 19, 880, 128, 49);
INSERT INTO public.who_global_data VALUES (30148, 55, 19724, 0, 120, 128, 1);
INSERT INTO public.who_global_data VALUES (30149, 213, 16593, 5, 280, 128, 48);
INSERT INTO public.who_global_data VALUES (30150, 66, 5597, 0, 122, 128, 232);
INSERT INTO public.who_global_data VALUES (30151, 6, 370, 0, 1, 128, 175);
INSERT INTO public.who_global_data VALUES (30152, 12, 1755, 0, 22, 128, 21);
INSERT INTO public.who_global_data VALUES (30153, 1076, 68919, 19, 655, 128, 156);
INSERT INTO public.who_global_data VALUES (30154, 0, 0, 0, 0, 128, 95);
INSERT INTO public.who_global_data VALUES (30155, 28, 10658, 0, 272, 128, 177);
INSERT INTO public.who_global_data VALUES (30156, 534, 27998, 0, 650, 128, 210);
INSERT INTO public.who_global_data VALUES (30157, 0, 5416, 0, 61, 128, 120);
INSERT INTO public.who_global_data VALUES (30158, 0, 30, 0, 0, 128, 135);
INSERT INTO public.who_global_data VALUES (30159, 309, 112209, 4, 2105, 128, 206);
INSERT INTO public.who_global_data VALUES (30160, 1298, 137047, 43, 11355, 128, 189);
INSERT INTO public.who_global_data VALUES (30161, 119, 103198, 16, 5930, 128, 129);
INSERT INTO public.who_global_data VALUES (30162, 96, 29077, 4, 843, 128, 121);
INSERT INTO public.who_global_data VALUES (30163, 2, 5030, 0, 83, 128, 59);
INSERT INTO public.who_global_data VALUES (30164, 0, 375, 0, 0, 128, 96);
INSERT INTO public.who_global_data VALUES (30165, 56, 3371, 0, 64, 128, 41);
INSERT INTO public.who_global_data VALUES (30166, 20, 5482, 1, 109, 128, 216);
INSERT INTO public.who_global_data VALUES (30167, 784, 75368, 7, 1198, 128, 236);
INSERT INTO public.who_global_data VALUES (30168, 0, 13, 0, 0, 128, 150);
INSERT INTO public.who_global_data VALUES (30169, 4, 467, 0, 0, 128, 61);
INSERT INTO public.who_global_data VALUES (30170, 0, 32, 0, 2, 128, 7);
INSERT INTO public.who_global_data VALUES (30171, 100, 9992, 1, 344, 128, 169);
INSERT INTO public.who_global_data VALUES (30172, 11889, 538290, 56, 31746, 128, 28);
INSERT INTO public.who_global_data VALUES (30173, 26, 9955, 0, 66, 128, 85);
INSERT INTO public.who_global_data VALUES (30174, 124, 1852, 0, 7, 128, 211);
INSERT INTO public.who_global_data VALUES (30175, 14, 8766, 0, 54, 128, 60);
INSERT INTO public.who_global_data VALUES (30176, 0, 3579, 0, 112, 128, 3);
INSERT INTO public.who_global_data VALUES (30177, 448, 6640, 4, 40, 128, 11);
INSERT INTO public.who_global_data VALUES (30178, 2503, 291722, 12, 9500, 128, 89);
INSERT INTO public.who_global_data VALUES (30179, 174, 46656, 0, 301, 128, 24);
INSERT INTO public.who_global_data VALUES (30180, 9, 391, 0, 0, 128, 162);
INSERT INTO public.who_global_data VALUES (30181, 352, 18475, 3, 391, 128, 100);
INSERT INTO public.who_global_data VALUES (30182, 0, 14, 0, 0, 128, 47);
INSERT INTO public.who_global_data VALUES (30183, 0, 24, 0, 0, 128, 29);
INSERT INTO public.who_global_data VALUES (30184, 574, 5528, 4, 57, 128, 40);
INSERT INTO public.who_global_data VALUES (30185, 45, 2488, 2, 49, 128, 222);
INSERT INTO public.who_global_data VALUES (30186, 778, 91746, 8, 3246, 128, 132);
INSERT INTO public.who_global_data VALUES (30187, 0, 256, 0, 13, 128, 130);
INSERT INTO public.who_global_data VALUES (30188, 18, 10652, 0, 66, 128, 234);
INSERT INTO public.who_global_data VALUES (30189, 0, 2324, 0, 39, 128, 23);
INSERT INTO public.who_global_data VALUES (30190, 59, 2846, 0, 78, 128, 192);
INSERT INTO public.who_global_data VALUES (30191, 26, 8766, 2, 229, 128, 69);
INSERT INTO public.who_global_data VALUES (30192, 0, 12, 0, 0, 128, 187);
INSERT INTO public.who_global_data VALUES (30193, 561, 76098, 22, 2323, 128, 230);
INSERT INTO public.who_global_data VALUES (30194, 848, 27309, 16, 781, 128, 77);
INSERT INTO public.who_global_data VALUES (30195, 33, 2728, 0, 10, 128, 9);
INSERT INTO public.who_global_data VALUES (30196, 86821, 6312584, 1181, 98678, 128, 74);
INSERT INTO public.who_global_data VALUES (30197, 4284, 287008, 139, 10740, 128, 224);
INSERT INTO public.who_global_data VALUES (30198, 3582, 457219, 183, 26169, 128, 199);
INSERT INTO public.who_global_data VALUES (30199, 4691, 362981, 59, 9181, 128, 190);
INSERT INTO public.who_global_data VALUES (30200, 415, 36155, 1, 1804, 128, 12);
INSERT INTO public.who_global_data VALUES (30201, 0, 340, 0, 24, 128, 104);
INSERT INTO public.who_global_data VALUES (30202, 4992, 238338, 35, 1568, 128, 153);
INSERT INTO public.who_global_data VALUES (30203, 1850, 314861, 19, 35894, 128, 91);
INSERT INTO public.who_global_data VALUES (30204, 74, 6482, 6, 107, 128, 215);
INSERT INTO public.who_global_data VALUES (30205, 553, 83563, 7, 1571, 128, 84);
INSERT INTO public.who_global_data VALUES (30206, 1, 409, 0, 32, 128, 231);
INSERT INTO public.who_global_data VALUES (30207, 1776, 11893, 4, 61, 128, 196);
INSERT INTO public.who_global_data VALUES (30208, 299, 141256, 0, 2075, 128, 105);
INSERT INTO public.who_global_data VALUES (30209, 151, 38529, 4, 711, 128, 122);
INSERT INTO public.who_global_data VALUES (30210, 0, 0, 0, 0, 128, 159);
INSERT INTO public.who_global_data VALUES (30211, 46, 15577, 0, 615, 128, 75);
INSERT INTO public.who_global_data VALUES (30212, 614, 105182, 3, 610, 128, 27);
INSERT INTO public.who_global_data VALUES (30213, 172, 46841, 1, 1065, 128, 54);
INSERT INTO public.who_global_data VALUES (30214, 0, 23, 0, 0, 128, 226);
INSERT INTO public.who_global_data VALUES (30215, 95, 1824, 0, 37, 128, 79);
INSERT INTO public.who_global_data VALUES (30216, 1257, 39620, 6, 367, 128, 56);
INSERT INTO public.who_global_data VALUES (30217, 30, 1595, 1, 36, 128, 117);
INSERT INTO public.who_global_data VALUES (30218, 4, 1343, 0, 82, 128, 152);
INSERT INTO public.who_global_data VALUES (30219, 683, 35208, 8, 559, 128, 16);
INSERT INTO public.who_global_data VALUES (30220, 1, 121, 0, 1, 128, 10);
INSERT INTO public.who_global_data VALUES (30221, 91, 4779, 0, 92, 128, 201);
INSERT INTO public.who_global_data VALUES (30222, 78, 8509, 0, 124, 128, 174);
INSERT INTO public.who_global_data VALUES (30223, 31, 16408, 1, 230, 128, 119);
INSERT INTO public.who_global_data VALUES (30224, 1, 5773, 0, 179, 128, 168);
INSERT INTO public.who_global_data VALUES (30225, 89, 11224, 2, 136, 128, 99);
INSERT INTO public.who_global_data VALUES (30226, 97, 10291, 0, 34, 128, 171);
INSERT INTO public.who_global_data VALUES (30227, 17, 3118, 0, 131, 128, 87);
INSERT INTO public.who_global_data VALUES (30228, 37, 3086, 1, 35, 128, 123);
INSERT INTO public.who_global_data VALUES (30229, 0, 0, 0, 0, 128, 151);
INSERT INTO public.who_global_data VALUES (30230, 245, 1543, 1, 21, 128, 213);
INSERT INTO public.who_global_data VALUES (30231, 14, 7502, 0, 161, 128, 118);
INSERT INTO public.who_global_data VALUES (30232, 0, 381, 0, 10, 128, 134);
INSERT INTO public.who_global_data VALUES (30233, 0, 3779, 0, 42, 128, 65);
INSERT INTO public.who_global_data VALUES (30234, 4446, 738163, 560, 77163, 128, 102);
INSERT INTO public.who_global_data VALUES (30235, 0, 0, 0, 0, 128, 223);
INSERT INTO public.who_global_data VALUES (30236, 4, 221, 0, 2, 128, 4);
INSERT INTO public.who_global_data VALUES (30237, 0, 313, 0, 0, 128, 146);
INSERT INTO public.who_global_data VALUES (30238, 203, 11656, 1, 170, 128, 31);
INSERT INTO public.who_global_data VALUES (30239, 0, 13, 0, 1, 128, 127);
INSERT INTO public.who_global_data VALUES (30240, 2470, 123653, 42, 2194, 128, 22);
INSERT INTO public.who_global_data VALUES (30241, 172, 8728, 2, 61, 128, 115);
INSERT INTO public.who_global_data VALUES (30242, 948, 13373, 26, 310, 128, 106);
INSERT INTO public.who_global_data VALUES (30243, 125, 11265, 0, 121, 128, 90);
INSERT INTO public.who_global_data VALUES (30244, 0, 0, 0, 0, 128, 70);
INSERT INTO public.who_global_data VALUES (30245, 1559, 77817, 7, 498, 128, 46);
INSERT INTO public.who_global_data VALUES (30246, 3286, 120605, 13, 6405, 128, 139);
INSERT INTO public.who_global_data VALUES (30247, 0, 27, 0, 0, 128, 42);
INSERT INTO public.who_global_data VALUES (30248, 12, 1492, 0, 25, 128, 80);
INSERT INTO public.who_global_data VALUES (30249, 0, 4146, 0, 151, 128, 203);
INSERT INTO public.who_global_data VALUES (30250, 1, 1197, 0, 69, 128, 136);
INSERT INTO public.who_global_data VALUES (30251, 201, 58848, 1, 1112, 128, 63);
INSERT INTO public.who_global_data VALUES (30252, 0, 0, 0, 0, 128, 17);
INSERT INTO public.who_global_data VALUES (30253, 0, 70, 0, 2, 128, 172);
INSERT INTO public.who_global_data VALUES (30254, 191, 17977, 2, 739, 128, 109);
INSERT INTO public.who_global_data VALUES (30255, 126, 13914, 0, 274, 128, 200);
INSERT INTO public.who_global_data VALUES (30256, 426, 50541, 8, 368, 128, 93);
INSERT INTO public.who_global_data VALUES (30257, 0, 98585, 0, 935, 128, 5);
INSERT INTO public.who_global_data VALUES (30258, 0, 741, 0, 13, 128, 214);
INSERT INTO public.who_global_data VALUES (30259, 543, 312806, 5, 6484, 128, 204);
INSERT INTO public.who_global_data VALUES (30260, 0, 0, 0, 0, 128, 198);
INSERT INTO public.who_global_data VALUES (30261, 576, 111853, 16, 2364, 128, 173);
INSERT INTO public.who_global_data VALUES (30262, 0, 534, 0, 7, 128, 229);
INSERT INTO public.who_global_data VALUES (30263, 669, 40101, 23, 841, 128, 76);
INSERT INTO public.who_global_data VALUES (30264, 3054, 811768, 72, 32396, 128, 138);
INSERT INTO public.who_global_data VALUES (30265, 2391, 311694, 56, 5504, 128, 98);
INSERT INTO public.who_global_data VALUES (30266, 0, 0, 0, 0, 128, 103);
INSERT INTO public.who_global_data VALUES (30267, 1552, 91514, 30, 2513, 128, 225);
INSERT INTO public.who_global_data VALUES (30268, 825, 75542, 8, 1971, 128, 131);
INSERT INTO public.who_global_data VALUES (30269, 288, 48755, 7, 661, 128, 235);
INSERT INTO public.who_global_data VALUES (30270, 227, 125760, 0, 214, 128, 137);
INSERT INTO public.who_global_data VALUES (30271, 77, 23889, 2, 415, 128, 81);
INSERT INTO public.who_global_data VALUES (30272, 1013, 53042, 10, 1320, 128, 182);
INSERT INTO public.who_global_data VALUES (30273, 111, 3993, 2, 16, 128, 145);
INSERT INTO public.who_global_data VALUES (30274, 2158, 127572, 33, 4825, 128, 26);
INSERT INTO public.who_global_data VALUES (30275, 8945, 1185231, 169, 20891, 128, 170);
INSERT INTO public.who_global_data VALUES (30276, 4, 4840, 0, 29, 128, 191);
INSERT INTO public.who_global_data VALUES (30277, 0, 5, 0, 0, 128, 221);
INSERT INTO public.who_global_data VALUES (30278, 0, 48, 0, 0, 128, 64);
INSERT INTO public.who_global_data VALUES (30279, 0, 0, 0, 0, 128, 116);
INSERT INTO public.who_global_data VALUES (30280, 0, 19, 0, 0, 128, 128);
INSERT INTO public.who_global_data VALUES (30281, 0, 27, 0, 0, 128, 6);
INSERT INTO public.who_global_data VALUES (30282, 0, 383, 0, 8, 128, 227);
INSERT INTO public.who_global_data VALUES (30283, 0, 12, 0, 0, 128, 68);
INSERT INTO public.who_global_data VALUES (30284, 0, 64, 0, 0, 128, 184);
INSERT INTO public.who_global_data VALUES (30285, 0, 0, 0, 0, 128, 82);
INSERT INTO public.who_global_data VALUES (30286, 1, 750, 0, 42, 128, 149);
INSERT INTO public.who_global_data VALUES (30287, 0, 911, 0, 15, 128, 197);
INSERT INTO public.who_global_data VALUES (30288, 418, 334605, 29, 4768, 128, 78);
INSERT INTO public.who_global_data VALUES (30289, 63, 14982, 2, 311, 128, 233);
INSERT INTO public.who_global_data VALUES (30290, 72, 33551, 0, 749, 128, 133);
INSERT INTO public.who_global_data VALUES (30291, 1, 142, 0, 0, 128, 35);
INSERT INTO public.who_global_data VALUES (30292, 9, 2231, 0, 72, 128, 114);
INSERT INTO public.who_global_data VALUES (30293, 23, 57765, 0, 27, 128, 237);
INSERT INTO public.who_global_data VALUES (30294, 0, 13, 0, 0, 128, 55);
INSERT INTO public.who_global_data VALUES (30295, 0, 645, 0, 22, 128, 176);
INSERT INTO public.who_global_data VALUES (30296, 567, 10141, 3, 48, 128, 202);
INSERT INTO public.who_global_data VALUES (30297, 175, 5866, 2, 157, 128, 155);
INSERT INTO public.who_global_data VALUES (30298, 0, 0, 0, 0, 128, 32);
INSERT INTO public.who_global_data VALUES (30299, 0, 3588, 0, 99, 128, 220);
INSERT INTO public.who_global_data VALUES (30300, 1767, 674339, 67, 16734, 128, 30);
INSERT INTO public.who_global_data VALUES (30301, 0, 2704, 0, 49, 128, 147);
INSERT INTO public.who_global_data VALUES (30302, 11568, 812671, 146, 33941, 128, 208);
INSERT INTO public.who_global_data VALUES (30303, 6, 3380, 0, 13, 128, 45);
INSERT INTO public.who_global_data VALUES (30304, 7, 13653, 0, 836, 128, 110);
INSERT INTO public.who_global_data VALUES (30305, 27, 4863, 2, 104, 128, 88);
INSERT INTO public.who_global_data VALUES (30306, 613, 93149, 2, 5879, 128, 51);
INSERT INTO public.who_global_data VALUES (30307, 540, 54042, 0, 1820, 128, 209);
INSERT INTO public.who_global_data VALUES (30308, 52, 4200, 3, 200, 128, 205);
INSERT INTO public.who_global_data VALUES (30309, 43, 9769, 1, 76, 128, 18);
INSERT INTO public.who_global_data VALUES (30310, 5, 3569, 0, 59, 128, 72);
INSERT INTO public.who_global_data VALUES (30311, 7108, 453268, 71, 42143, 128, 44);
INSERT INTO public.who_global_data VALUES (30312, 0, 28, 0, 0, 128, 15);
INSERT INTO public.who_global_data VALUES (30313, 25, 1784, 0, 48, 128, 25);
INSERT INTO public.who_global_data VALUES (30314, 0, 0, 0, 0, 128, 179);
INSERT INTO public.who_global_data VALUES (30315, 0, 0, 0, 0, 128, 34);
INSERT INTO public.who_global_data VALUES (30316, 76, 4517, 1, 75, 128, 207);
INSERT INTO public.who_global_data VALUES (30317, 1308, 19721, 6, 271, 128, 166);
INSERT INTO public.who_global_data VALUES (30318, 8121, 756113, 65, 8195, 128, 126);
INSERT INTO public.who_global_data VALUES (30319, 0, 0, 0, 0, 128, 97);
INSERT INTO public.who_global_data VALUES (30320, 4, 686, 1, 6, 128, 36);
INSERT INTO public.who_global_data VALUES (30321, 0, 0, 0, 0, 128, 125);
INSERT INTO public.who_global_data VALUES (30322, 112, 8129, 0, 75, 128, 124);
INSERT INTO public.who_global_data VALUES (30323, 4069, 213028, 64, 4193, 128, 185);
INSERT INTO public.who_global_data VALUES (30324, 1100, 94190, 3, 419, 128, 194);
INSERT INTO public.who_global_data VALUES (30325, 0, 509, 0, 21, 128, 144);
INSERT INTO public.who_global_data VALUES (30326, 38476, 7115491, 767, 204642, 128, 19);
INSERT INTO public.who_global_data VALUES (30327, 0, 1318, 0, 20, 128, 217);
INSERT INTO public.who_global_data VALUES (30328, 23, 2033, 1, 48, 128, 148);
INSERT INTO public.who_global_data VALUES (30329, 800, 57319, 6, 474, 128, 86);
INSERT INTO public.who_global_data VALUES (30330, 0, 0, 0, 0, 128, 13);
INSERT INTO public.who_global_data VALUES (30331, 835, 74363, 7, 621, 128, 157);
INSERT INTO public.who_global_data VALUES (30332, 1, 1095, 0, 35, 128, 8);
INSERT INTO public.who_global_data VALUES (30333, 0, 0, 0, 0, 128, 73);
INSERT INTO public.who_global_data VALUES (30334, 3, 2038, 0, 588, 128, 101);
INSERT INTO public.who_global_data VALUES (30335, 44, 14759, 0, 332, 128, 165);
INSERT INTO public.who_global_data VALUES (30336, 1, 7838, 0, 228, 128, 14);
INSERT INTO public.who_global_data VALUES (30337, 14, 39354, 0, 1462, 129, 193);
INSERT INTO public.who_global_data VALUES (30338, 127, 13518, 4, 384, 129, 113);
INSERT INTO public.who_global_data VALUES (30339, 155, 51368, 7, 1726, 129, 143);
INSERT INTO public.who_global_data VALUES (30340, 0, 0, 0, 0, 129, 219);
INSERT INTO public.who_global_data VALUES (30341, 0, 1966, 0, 53, 129, 186);
INSERT INTO public.who_global_data VALUES (30342, 108, 4905, 3, 179, 129, 52);
INSERT INTO public.who_global_data VALUES (30343, 0, 3, 0, 0, 129, 180);
INSERT INTO public.who_global_data VALUES (30344, 0, 101, 0, 3, 129, 167);
INSERT INTO public.who_global_data VALUES (30345, 11807, 723132, 364, 16113, 129, 154);
INSERT INTO public.who_global_data VALUES (30346, 458, 49672, 1, 954, 129, 94);
INSERT INTO public.who_global_data VALUES (30347, 28, 3872, 0, 25, 129, 66);
INSERT INTO public.who_global_data VALUES (30348, 19, 27063, 7, 882, 129, 58);
INSERT INTO public.who_global_data VALUES (30349, 722, 44607, 6, 796, 129, 163);
INSERT INTO public.who_global_data VALUES (30350, 58, 40119, 2, 590, 129, 37);
INSERT INTO public.who_global_data VALUES (30351, 65, 3903, 2, 91, 129, 142);
INSERT INTO public.who_global_data VALUES (30352, 574, 70422, 1, 246, 129, 83);
INSERT INTO public.who_global_data VALUES (30353, 1488, 362043, 26, 5219, 129, 228);
INSERT INTO public.who_global_data VALUES (30354, 0, 190, 0, 7, 129, 188);
INSERT INTO public.who_global_data VALUES (30355, 314, 78260, 6, 828, 129, 62);
INSERT INTO public.who_global_data VALUES (30356, 2984, 122457, 10, 10009, 129, 160);
INSERT INTO public.who_global_data VALUES (30357, 37, 1891, 0, 24, 129, 50);
INSERT INTO public.who_global_data VALUES (30358, 17, 2357, 1, 41, 129, 33);
INSERT INTO public.who_global_data VALUES (30359, 0, 181, 0, 9, 129, 183);
INSERT INTO public.who_global_data VALUES (30360, 1, 281, 0, 0, 129, 92);
INSERT INTO public.who_global_data VALUES (30361, 322, 134223, 42, 7900, 129, 158);
INSERT INTO public.who_global_data VALUES (30362, 1, 98, 0, 1, 129, 67);
INSERT INTO public.who_global_data VALUES (30363, 225, 27222, 14, 836, 129, 57);
INSERT INTO public.who_global_data VALUES (30364, 0, 3172, 0, 16, 129, 38);
INSERT INTO public.who_global_data VALUES (30365, 13155, 4745464, 317, 142058, 129, 141);
INSERT INTO public.who_global_data VALUES (30366, 0, 71, 0, 1, 129, 178);
INSERT INTO public.who_global_data VALUES (30367, 0, 146, 0, 3, 129, 108);
INSERT INTO public.who_global_data VALUES (30368, 276, 20547, 7, 814, 129, 39);
INSERT INTO public.who_global_data VALUES (30369, 99, 2028, 1, 57, 129, 2);
INSERT INTO public.who_global_data VALUES (30370, 2, 508, 0, 1, 129, 195);
INSERT INTO public.who_global_data VALUES (30371, 83, 5900, 0, 59, 129, 107);
INSERT INTO public.who_global_data VALUES (30372, 0, 277, 0, 0, 129, 161);
INSERT INTO public.who_global_data VALUES (30373, 0, 20838, 0, 418, 129, 212);
INSERT INTO public.who_global_data VALUES (30374, 2176, 155301, 10, 9278, 129, 181);
INSERT INTO public.who_global_data VALUES (30375, 1, 211, 0, 1, 129, 53);
INSERT INTO public.who_global_data VALUES (30376, 4, 4829, 0, 62, 129, 164);
INSERT INTO public.who_global_data VALUES (30377, 8, 1193, 0, 85, 129, 140);
INSERT INTO public.who_global_data VALUES (30378, 1629, 461300, 27, 12725, 129, 20);
INSERT INTO public.who_global_data VALUES (30379, 23, 91041, 0, 4746, 129, 112);
INSERT INTO public.who_global_data VALUES (30380, 5147, 818203, 153, 25641, 129, 111);
INSERT INTO public.who_global_data VALUES (30381, 4, 478, 0, 7, 129, 71);
INSERT INTO public.who_global_data VALUES (30382, 81, 5089, 0, 89, 129, 218);
INSERT INTO public.who_global_data VALUES (30383, 0, 0, 0, 0, 129, 43);
INSERT INTO public.who_global_data VALUES (30384, 730, 73714, 14, 861, 129, 49);
INSERT INTO public.who_global_data VALUES (30385, 28, 19669, 0, 120, 129, 1);
INSERT INTO public.who_global_data VALUES (30386, 135, 16380, 3, 275, 129, 48);
INSERT INTO public.who_global_data VALUES (30387, 48, 5531, 0, 122, 129, 232);
INSERT INTO public.who_global_data VALUES (30388, 4, 364, 0, 1, 129, 175);
INSERT INTO public.who_global_data VALUES (30389, 30, 1743, 0, 22, 129, 21);
INSERT INTO public.who_global_data VALUES (30390, 1960, 67843, 18, 636, 129, 156);
INSERT INTO public.who_global_data VALUES (30391, 0, 0, 0, 0, 129, 95);
INSERT INTO public.who_global_data VALUES (30392, 7, 10630, 1, 272, 129, 177);
INSERT INTO public.who_global_data VALUES (30393, 392, 27464, 1, 650, 129, 210);
INSERT INTO public.who_global_data VALUES (30394, 6, 5416, 0, 61, 129, 120);
INSERT INTO public.who_global_data VALUES (30395, 0, 30, 0, 0, 129, 135);
INSERT INTO public.who_global_data VALUES (30396, 234, 111900, 3, 2101, 129, 206);
INSERT INTO public.who_global_data VALUES (30397, 784, 135749, 32, 11312, 129, 189);
INSERT INTO public.who_global_data VALUES (30398, 124, 103079, 13, 5914, 129, 129);
INSERT INTO public.who_global_data VALUES (30399, 172, 28981, 8, 839, 129, 121);
INSERT INTO public.who_global_data VALUES (30400, 0, 5028, 0, 83, 129, 59);
INSERT INTO public.who_global_data VALUES (30401, 0, 375, 0, 0, 129, 96);
INSERT INTO public.who_global_data VALUES (30402, 48, 3315, 0, 64, 129, 41);
INSERT INTO public.who_global_data VALUES (30403, 10, 5462, 0, 108, 129, 216);
INSERT INTO public.who_global_data VALUES (30404, 640, 74584, 14, 1191, 129, 236);
INSERT INTO public.who_global_data VALUES (30405, 0, 13, 0, 0, 129, 150);
INSERT INTO public.who_global_data VALUES (30406, 3, 463, 0, 0, 129, 61);
INSERT INTO public.who_global_data VALUES (30407, 0, 32, 0, 2, 129, 7);
INSERT INTO public.who_global_data VALUES (30408, 158, 9892, 0, 343, 129, 169);
INSERT INTO public.who_global_data VALUES (30409, 7779, 526401, 82, 31690, 129, 28);
INSERT INTO public.who_global_data VALUES (30410, 34, 9929, 1, 66, 129, 85);
INSERT INTO public.who_global_data VALUES (30411, 149, 1728, 0, 7, 129, 211);
INSERT INTO public.who_global_data VALUES (30412, 0, 8752, 0, 54, 129, 60);
INSERT INTO public.who_global_data VALUES (30413, 0, 3579, 0, 112, 129, 3);
INSERT INTO public.who_global_data VALUES (30414, 326, 6192, 3, 36, 129, 11);
INSERT INTO public.who_global_data VALUES (30415, 1798, 289219, 17, 9488, 129, 89);
INSERT INTO public.who_global_data VALUES (30416, 260, 46482, 2, 301, 129, 24);
INSERT INTO public.who_global_data VALUES (30417, 3, 382, 0, 0, 129, 162);
INSERT INTO public.who_global_data VALUES (30418, 416, 18123, 5, 388, 129, 100);
INSERT INTO public.who_global_data VALUES (30419, 0, 14, 0, 0, 129, 47);
INSERT INTO public.who_global_data VALUES (30420, 0, 24, 0, 0, 129, 29);
INSERT INTO public.who_global_data VALUES (30421, 0, 4954, 0, 53, 129, 40);
INSERT INTO public.who_global_data VALUES (30422, 53, 2443, 1, 47, 129, 222);
INSERT INTO public.who_global_data VALUES (30423, 705, 90968, 4, 3238, 129, 132);
INSERT INTO public.who_global_data VALUES (30424, 0, 256, 0, 13, 129, 130);
INSERT INTO public.who_global_data VALUES (30425, 36, 10634, 0, 66, 129, 234);
INSERT INTO public.who_global_data VALUES (30426, 0, 2324, 0, 39, 129, 23);
INSERT INTO public.who_global_data VALUES (30427, 15, 2787, 2, 78, 129, 192);
INSERT INTO public.who_global_data VALUES (30428, 0, 8740, 0, 227, 129, 69);
INSERT INTO public.who_global_data VALUES (30429, 0, 12, 0, 0, 129, 187);
INSERT INTO public.who_global_data VALUES (30430, 428, 75537, 12, 2301, 129, 230);
INSERT INTO public.who_global_data VALUES (30431, 894, 26461, 8, 765, 129, 77);
INSERT INTO public.who_global_data VALUES (30432, 32, 2695, 0, 10, 129, 9);
INSERT INTO public.who_global_data VALUES (30433, 80472, 6225763, 1179, 97497, 129, 74);
INSERT INTO public.who_global_data VALUES (30434, 4002, 282724, 128, 10601, 129, 224);
INSERT INTO public.who_global_data VALUES (30435, 3677, 453637, 207, 25986, 129, 199);
INSERT INTO public.who_global_data VALUES (30436, 4724, 358290, 70, 9122, 129, 190);
INSERT INTO public.who_global_data VALUES (30437, 362, 35740, 1, 1803, 129, 12);
INSERT INTO public.who_global_data VALUES (30438, 0, 340, 0, 24, 129, 104);
INSERT INTO public.who_global_data VALUES (30439, 1159, 233346, 28, 1533, 129, 153);
INSERT INTO public.who_global_data VALUES (30440, 1647, 313011, 24, 35875, 129, 91);
INSERT INTO public.who_global_data VALUES (30441, 238, 6408, 8, 101, 129, 215);
INSERT INTO public.who_global_data VALUES (30442, 516, 83010, 7, 1564, 129, 84);
INSERT INTO public.who_global_data VALUES (30443, 6, 408, 0, 32, 129, 231);
INSERT INTO public.who_global_data VALUES (30444, 823, 10117, 6, 57, 129, 196);
INSERT INTO public.who_global_data VALUES (30445, 250, 140957, 0, 2075, 129, 105);
INSERT INTO public.who_global_data VALUES (30446, 210, 38378, 7, 707, 129, 122);
INSERT INTO public.who_global_data VALUES (30447, 0, 0, 0, 0, 129, 159);
INSERT INTO public.who_global_data VALUES (30448, 54, 15531, 0, 615, 129, 75);
INSERT INTO public.who_global_data VALUES (30449, 587, 104568, 2, 607, 129, 27);
INSERT INTO public.who_global_data VALUES (30450, 147, 46669, 0, 1064, 129, 54);
INSERT INTO public.who_global_data VALUES (30451, 0, 23, 0, 0, 129, 226);
INSERT INTO public.who_global_data VALUES (30452, 32, 1729, 1, 37, 129, 79);
INSERT INTO public.who_global_data VALUES (30453, 1105, 38363, 10, 361, 129, 56);
INSERT INTO public.who_global_data VALUES (30454, 0, 1565, 0, 35, 129, 117);
INSERT INTO public.who_global_data VALUES (30455, 0, 1339, 0, 82, 129, 152);
INSERT INTO public.who_global_data VALUES (30456, 511, 34525, 11, 551, 129, 16);
INSERT INTO public.who_global_data VALUES (30457, 0, 120, 0, 1, 129, 10);
INSERT INTO public.who_global_data VALUES (30458, 115, 4688, 0, 92, 129, 201);
INSERT INTO public.who_global_data VALUES (30459, 55, 8431, 0, 124, 129, 174);
INSERT INTO public.who_global_data VALUES (30460, 29, 16377, 0, 229, 129, 119);
INSERT INTO public.who_global_data VALUES (30461, 2, 5772, 0, 179, 129, 168);
INSERT INTO public.who_global_data VALUES (30462, 101, 11135, 0, 134, 129, 99);
INSERT INTO public.who_global_data VALUES (30463, 37, 10194, 0, 34, 129, 171);
INSERT INTO public.who_global_data VALUES (30464, 11, 3101, 1, 131, 129, 87);
INSERT INTO public.who_global_data VALUES (30465, 23, 3049, 0, 34, 129, 123);
INSERT INTO public.who_global_data VALUES (30466, 0, 0, 0, 0, 129, 151);
INSERT INTO public.who_global_data VALUES (30467, 0, 1298, 0, 20, 129, 213);
INSERT INTO public.who_global_data VALUES (30468, 14, 7488, 0, 161, 129, 118);
INSERT INTO public.who_global_data VALUES (30469, 11, 381, 0, 10, 129, 134);
INSERT INTO public.who_global_data VALUES (30470, 238, 3779, 2, 42, 129, 65);
INSERT INTO public.who_global_data VALUES (30471, 3400, 733717, 173, 76603, 129, 102);
INSERT INTO public.who_global_data VALUES (30472, 0, 0, 0, 0, 129, 223);
INSERT INTO public.who_global_data VALUES (30473, 2, 217, 0, 2, 129, 4);
INSERT INTO public.who_global_data VALUES (30474, 0, 313, 0, 0, 129, 146);
INSERT INTO public.who_global_data VALUES (30475, 247, 11453, 5, 169, 129, 31);
INSERT INTO public.who_global_data VALUES (30476, 0, 13, 0, 1, 129, 127);
INSERT INTO public.who_global_data VALUES (30477, 2076, 121183, 39, 2152, 129, 22);
INSERT INTO public.who_global_data VALUES (30478, 268, 8556, 0, 59, 129, 115);
INSERT INTO public.who_global_data VALUES (30479, 794, 12425, 28, 284, 129, 106);
INSERT INTO public.who_global_data VALUES (30480, 19, 11140, 0, 121, 129, 90);
INSERT INTO public.who_global_data VALUES (30481, 0, 0, 0, 0, 129, 70);
INSERT INTO public.who_global_data VALUES (30482, 1513, 76258, 10, 491, 129, 46);
INSERT INTO public.who_global_data VALUES (30483, 3004, 117319, 13, 6392, 129, 139);
INSERT INTO public.who_global_data VALUES (30484, 0, 27, 0, 0, 129, 42);
INSERT INTO public.who_global_data VALUES (30485, 1, 1480, 0, 25, 129, 80);
INSERT INTO public.who_global_data VALUES (30486, 81, 4146, 2, 151, 129, 203);
INSERT INTO public.who_global_data VALUES (30487, 0, 1196, 0, 69, 129, 136);
INSERT INTO public.who_global_data VALUES (30488, 187, 58647, 0, 1111, 129, 63);
INSERT INTO public.who_global_data VALUES (30489, 0, 0, 0, 0, 129, 17);
INSERT INTO public.who_global_data VALUES (30490, 0, 70, 0, 2, 129, 172);
INSERT INTO public.who_global_data VALUES (30491, 112, 17786, 8, 737, 129, 109);
INSERT INTO public.who_global_data VALUES (30492, 90, 13788, 0, 274, 129, 200);
INSERT INTO public.who_global_data VALUES (30493, 420, 50115, 7, 360, 129, 93);
INSERT INTO public.who_global_data VALUES (30494, 528, 98585, 11, 935, 129, 5);
INSERT INTO public.who_global_data VALUES (30495, 0, 741, 0, 13, 129, 214);
INSERT INTO public.who_global_data VALUES (30496, 747, 312263, 5, 6479, 129, 204);
INSERT INTO public.who_global_data VALUES (30497, 0, 0, 0, 0, 129, 198);
INSERT INTO public.who_global_data VALUES (30498, 722, 111277, 8, 2348, 129, 173);
INSERT INTO public.who_global_data VALUES (30499, 0, 534, 0, 7, 129, 229);
INSERT INTO public.who_global_data VALUES (30500, 748, 39432, 15, 818, 129, 76);
INSERT INTO public.who_global_data VALUES (30501, 3412, 808714, 62, 32324, 129, 138);
INSERT INTO public.who_global_data VALUES (30502, 2015, 309303, 67, 5448, 129, 98);
INSERT INTO public.who_global_data VALUES (30503, 0, 0, 0, 0, 129, 103);
INSERT INTO public.who_global_data VALUES (30504, 1326, 89962, 36, 2483, 129, 225);
INSERT INTO public.who_global_data VALUES (30505, 688, 74717, 6, 1963, 129, 131);
INSERT INTO public.who_global_data VALUES (30506, 1045, 48467, 6, 654, 129, 235);
INSERT INTO public.who_global_data VALUES (30507, 222, 125533, 0, 214, 129, 137);
INSERT INTO public.who_global_data VALUES (30508, 113, 23812, 6, 413, 129, 81);
INSERT INTO public.who_global_data VALUES (30509, 835, 52029, 9, 1310, 129, 182);
INSERT INTO public.who_global_data VALUES (30510, 0, 3882, 0, 14, 129, 145);
INSERT INTO public.who_global_data VALUES (30511, 1470, 125414, 44, 4792, 129, 26);
INSERT INTO public.who_global_data VALUES (30512, 8481, 1176286, 177, 20722, 129, 170);
INSERT INTO public.who_global_data VALUES (30513, 4, 4836, 0, 29, 129, 191);
INSERT INTO public.who_global_data VALUES (30514, 0, 5, 0, 0, 129, 221);
INSERT INTO public.who_global_data VALUES (30515, 0, 48, 0, 0, 129, 64);
INSERT INTO public.who_global_data VALUES (30516, 0, 0, 0, 0, 129, 116);
INSERT INTO public.who_global_data VALUES (30517, 0, 19, 0, 0, 129, 128);
INSERT INTO public.who_global_data VALUES (30518, 0, 27, 0, 0, 129, 6);
INSERT INTO public.who_global_data VALUES (30519, 0, 383, 0, 8, 129, 227);
INSERT INTO public.who_global_data VALUES (30520, 0, 12, 0, 0, 129, 68);
INSERT INTO public.who_global_data VALUES (30521, 0, 64, 0, 0, 129, 184);
INSERT INTO public.who_global_data VALUES (30522, 0, 0, 0, 0, 129, 82);
INSERT INTO public.who_global_data VALUES (30523, 0, 749, 0, 42, 129, 149);
INSERT INTO public.who_global_data VALUES (30524, 0, 911, 0, 15, 129, 197);
INSERT INTO public.who_global_data VALUES (30525, 539, 334187, 27, 4739, 129, 78);
INSERT INTO public.who_global_data VALUES (30526, 0, 14919, 0, 309, 129, 233);
INSERT INTO public.who_global_data VALUES (30527, 65, 33479, 1, 749, 129, 133);
INSERT INTO public.who_global_data VALUES (30528, 0, 141, 0, 0, 129, 35);
INSERT INTO public.who_global_data VALUES (30529, 7, 2222, 0, 72, 129, 114);
INSERT INTO public.who_global_data VALUES (30530, 27, 57742, 0, 27, 129, 237);
INSERT INTO public.who_global_data VALUES (30531, 0, 13, 0, 0, 129, 55);
INSERT INTO public.who_global_data VALUES (30532, 1, 645, 0, 22, 129, 176);
INSERT INTO public.who_global_data VALUES (30533, 231, 9574, 1, 45, 129, 202);
INSERT INTO public.who_global_data VALUES (30534, 202, 5691, 1, 155, 129, 155);
INSERT INTO public.who_global_data VALUES (30535, 0, 0, 0, 0, 129, 32);
INSERT INTO public.who_global_data VALUES (30536, 0, 3588, 0, 99, 129, 220);
INSERT INTO public.who_global_data VALUES (30537, 903, 672572, 81, 16667, 129, 30);
INSERT INTO public.who_global_data VALUES (30538, 4, 2704, 0, 49, 129, 147);
INSERT INTO public.who_global_data VALUES (30539, 7243, 801103, 143, 33795, 129, 208);
INSERT INTO public.who_global_data VALUES (30540, 11, 3374, 0, 13, 129, 45);
INSERT INTO public.who_global_data VALUES (30541, 6, 13646, 0, 836, 129, 110);
INSERT INTO public.who_global_data VALUES (30542, 1, 4836, 0, 102, 129, 88);
INSERT INTO public.who_global_data VALUES (30543, 378, 92536, 1, 5877, 129, 51);
INSERT INTO public.who_global_data VALUES (30544, 449, 53502, 1, 1820, 129, 209);
INSERT INTO public.who_global_data VALUES (30545, 46, 4148, 3, 197, 129, 205);
INSERT INTO public.who_global_data VALUES (30546, 41, 9726, 0, 75, 129, 18);
INSERT INTO public.who_global_data VALUES (30547, 5, 3564, 0, 59, 129, 72);
INSERT INTO public.who_global_data VALUES (30548, 7143, 446160, 71, 42072, 129, 44);
INSERT INTO public.who_global_data VALUES (30549, 0, 28, 0, 0, 129, 15);
INSERT INTO public.who_global_data VALUES (30550, 10, 1759, 1, 48, 129, 25);
INSERT INTO public.who_global_data VALUES (30551, 0, 0, 0, 0, 129, 179);
INSERT INTO public.who_global_data VALUES (30552, 0, 0, 0, 0, 129, 34);
INSERT INTO public.who_global_data VALUES (30553, 59, 4441, 2, 74, 129, 207);
INSERT INTO public.who_global_data VALUES (30554, 1008, 18413, 19, 265, 129, 166);
INSERT INTO public.who_global_data VALUES (30555, 8157, 747992, 68, 8130, 129, 126);
INSERT INTO public.who_global_data VALUES (30556, 0, 0, 0, 0, 129, 97);
INSERT INTO public.who_global_data VALUES (30557, 0, 682, 0, 5, 129, 36);
INSERT INTO public.who_global_data VALUES (30558, 0, 0, 0, 0, 129, 125);
INSERT INTO public.who_global_data VALUES (30559, 240, 8017, 0, 75, 129, 124);
INSERT INTO public.who_global_data VALUES (30560, 4027, 208959, 64, 4129, 129, 185);
INSERT INTO public.who_global_data VALUES (30561, 995, 93090, 3, 416, 129, 194);
INSERT INTO public.who_global_data VALUES (30562, 0, 509, 0, 21, 129, 144);
INSERT INTO public.who_global_data VALUES (30563, 32688, 7077015, 255, 203875, 129, 19);
INSERT INTO public.who_global_data VALUES (30564, 1, 1318, 1, 20, 129, 217);
INSERT INTO public.who_global_data VALUES (30565, 2, 2010, 0, 47, 129, 148);
INSERT INTO public.who_global_data VALUES (30566, 451, 56519, 5, 468, 129, 86);
INSERT INTO public.who_global_data VALUES (30567, 0, 0, 0, 0, 129, 13);
INSERT INTO public.who_global_data VALUES (30568, 837, 73528, 8, 614, 129, 157);
INSERT INTO public.who_global_data VALUES (30569, 17, 1094, 0, 35, 129, 8);
INSERT INTO public.who_global_data VALUES (30570, 0, 0, 0, 0, 129, 73);
INSERT INTO public.who_global_data VALUES (30571, 0, 2035, 0, 588, 129, 101);
INSERT INTO public.who_global_data VALUES (30572, 55, 14715, 0, 332, 129, 165);
INSERT INTO public.who_global_data VALUES (30573, 21, 7837, 0, 228, 129, 14);
INSERT INTO public.who_global_data VALUES (30574, 15, 39340, 2, 1462, 130, 193);
INSERT INTO public.who_global_data VALUES (30575, 132, 13391, 3, 380, 130, 113);
INSERT INTO public.who_global_data VALUES (30576, 146, 51213, 5, 1719, 130, 143);
INSERT INTO public.who_global_data VALUES (30577, 0, 0, 0, 0, 130, 219);
INSERT INTO public.who_global_data VALUES (30578, 130, 1966, 0, 53, 130, 186);
INSERT INTO public.who_global_data VALUES (30579, 79, 4797, 2, 176, 130, 52);
INSERT INTO public.who_global_data VALUES (30580, 0, 3, 0, 0, 130, 180);
INSERT INTO public.who_global_data VALUES (30581, 0, 101, 0, 3, 130, 167);
INSERT INTO public.who_global_data VALUES (30582, 8841, 711325, 206, 15749, 130, 154);
INSERT INTO public.who_global_data VALUES (30583, 327, 49214, 1, 953, 130, 94);
INSERT INTO public.who_global_data VALUES (30584, 88, 3844, 0, 25, 130, 66);
INSERT INTO public.who_global_data VALUES (30585, 4, 27044, 3, 875, 130, 58);
INSERT INTO public.who_global_data VALUES (30586, 419, 43885, 3, 790, 130, 163);
INSERT INTO public.who_global_data VALUES (30587, 38, 40061, 2, 588, 130, 37);
INSERT INTO public.who_global_data VALUES (30588, 0, 3838, 0, 89, 130, 142);
INSERT INTO public.who_global_data VALUES (30589, 487, 69848, 3, 245, 130, 83);
INSERT INTO public.who_global_data VALUES (30590, 1407, 360555, 32, 5193, 130, 228);
INSERT INTO public.who_global_data VALUES (30591, 0, 190, 0, 7, 130, 188);
INSERT INTO public.who_global_data VALUES (30592, 337, 77946, 4, 822, 130, 62);
INSERT INTO public.who_global_data VALUES (30593, 2782, 119473, 13, 9999, 130, 160);
INSERT INTO public.who_global_data VALUES (30594, 29, 1854, 0, 24, 130, 50);
INSERT INTO public.who_global_data VALUES (30595, 0, 2340, 0, 40, 130, 33);
INSERT INTO public.who_global_data VALUES (30596, 0, 181, 0, 9, 130, 183);
INSERT INTO public.who_global_data VALUES (30597, 7, 280, 0, 0, 130, 92);
INSERT INTO public.who_global_data VALUES (30598, 309, 133901, 30, 7858, 130, 158);
INSERT INTO public.who_global_data VALUES (30599, 9, 97, 0, 1, 130, 67);
INSERT INTO public.who_global_data VALUES (30600, 80, 26997, 12, 822, 130, 57);
INSERT INTO public.who_global_data VALUES (30601, 251, 3172, 3, 16, 130, 38);
INSERT INTO public.who_global_data VALUES (30602, 14318, 4732309, 335, 141741, 130, 141);
INSERT INTO public.who_global_data VALUES (30603, 0, 71, 0, 1, 130, 178);
INSERT INTO public.who_global_data VALUES (30604, 0, 146, 0, 3, 130, 108);
INSERT INTO public.who_global_data VALUES (30605, 216, 20271, 11, 807, 130, 39);
INSERT INTO public.who_global_data VALUES (30606, 0, 1929, 0, 56, 130, 2);
INSERT INTO public.who_global_data VALUES (30607, 4, 506, 0, 1, 130, 195);
INSERT INTO public.who_global_data VALUES (30608, 46, 5817, 2, 59, 130, 107);
INSERT INTO public.who_global_data VALUES (30609, 1, 277, 0, 0, 130, 161);
INSERT INTO public.who_global_data VALUES (30610, 0, 20838, 0, 418, 130, 212);
INSERT INTO public.who_global_data VALUES (30611, 1454, 153125, 6, 9268, 130, 181);
INSERT INTO public.who_global_data VALUES (30612, 0, 210, 0, 1, 130, 53);
INSERT INTO public.who_global_data VALUES (30613, 19, 4825, 0, 62, 130, 164);
INSERT INTO public.who_global_data VALUES (30614, 7, 1185, 1, 85, 130, 140);
INSERT INTO public.who_global_data VALUES (30615, 1770, 459671, 57, 12698, 130, 20);
INSERT INTO public.who_global_data VALUES (30616, 25, 91018, 0, 4746, 130, 112);
INSERT INTO public.who_global_data VALUES (30617, 7018, 813056, 192, 25488, 130, 111);
INSERT INTO public.who_global_data VALUES (30618, 0, 474, 0, 7, 130, 71);
INSERT INTO public.who_global_data VALUES (30619, 0, 5008, 0, 89, 130, 218);
INSERT INTO public.who_global_data VALUES (30620, 0, 0, 0, 0, 130, 43);
INSERT INTO public.who_global_data VALUES (30621, 935, 72984, 19, 847, 130, 49);
INSERT INTO public.who_global_data VALUES (30622, 12, 19641, 0, 120, 130, 1);
INSERT INTO public.who_global_data VALUES (30623, 48, 16245, 0, 272, 130, 48);
INSERT INTO public.who_global_data VALUES (30624, 26, 5483, 0, 122, 130, 232);
INSERT INTO public.who_global_data VALUES (30625, 45, 360, 0, 1, 130, 175);
INSERT INTO public.who_global_data VALUES (30626, 17, 1713, 0, 22, 130, 21);
INSERT INTO public.who_global_data VALUES (30627, 1286, 65883, 12, 618, 130, 156);
INSERT INTO public.who_global_data VALUES (30628, 0, 0, 0, 0, 130, 95);
INSERT INTO public.who_global_data VALUES (30629, 12, 10623, 0, 271, 130, 177);
INSERT INTO public.who_global_data VALUES (30630, 435, 27072, 0, 649, 130, 210);
INSERT INTO public.who_global_data VALUES (30631, 1, 5410, 0, 61, 130, 120);
INSERT INTO public.who_global_data VALUES (30632, 0, 30, 0, 0, 130, 135);
INSERT INTO public.who_global_data VALUES (30633, 280, 111666, 3, 2098, 130, 206);
INSERT INTO public.who_global_data VALUES (30634, 218, 134965, 1, 11280, 130, 189);
INSERT INTO public.who_global_data VALUES (30635, 115, 102955, 18, 5901, 130, 129);
INSERT INTO public.who_global_data VALUES (30636, 179, 28809, 5, 831, 130, 121);
INSERT INTO public.who_global_data VALUES (30637, 0, 5028, 0, 83, 130, 59);
INSERT INTO public.who_global_data VALUES (30638, 0, 375, 0, 0, 130, 96);
INSERT INTO public.who_global_data VALUES (30639, 67, 3267, 0, 64, 130, 41);
INSERT INTO public.who_global_data VALUES (30640, 21, 5452, 0, 108, 130, 216);
INSERT INTO public.who_global_data VALUES (30641, 612, 73944, 7, 1177, 130, 236);
INSERT INTO public.who_global_data VALUES (30642, 0, 13, 0, 0, 130, 150);
INSERT INTO public.who_global_data VALUES (30643, 0, 460, 0, 0, 130, 61);
INSERT INTO public.who_global_data VALUES (30644, 0, 32, 0, 2, 130, 7);
INSERT INTO public.who_global_data VALUES (30645, 52, 9734, 0, 343, 130, 169);
INSERT INTO public.who_global_data VALUES (30646, 3841, 518622, 67, 31608, 130, 28);
INSERT INTO public.who_global_data VALUES (30647, 32, 9895, 0, 65, 130, 85);
INSERT INTO public.who_global_data VALUES (30648, 0, 1579, 1, 7, 130, 211);
INSERT INTO public.who_global_data VALUES (30649, 24, 8752, 0, 54, 130, 60);
INSERT INTO public.who_global_data VALUES (30650, 10, 3579, 1, 112, 130, 3);
INSERT INTO public.who_global_data VALUES (30651, 314, 5866, 5, 33, 130, 11);
INSERT INTO public.who_global_data VALUES (30652, 2089, 287421, 11, 9471, 130, 89);
INSERT INTO public.who_global_data VALUES (30653, 0, 46222, 0, 299, 130, 24);
INSERT INTO public.who_global_data VALUES (30654, 7, 379, 0, 0, 130, 162);
INSERT INTO public.who_global_data VALUES (30655, 263, 17707, 4, 383, 130, 100);
INSERT INTO public.who_global_data VALUES (30656, 0, 14, 0, 0, 130, 47);
INSERT INTO public.who_global_data VALUES (30657, 0, 24, 0, 0, 130, 29);
INSERT INTO public.who_global_data VALUES (30658, 0, 4954, 11, 53, 130, 40);
INSERT INTO public.who_global_data VALUES (30659, 35, 2390, 3, 46, 130, 222);
INSERT INTO public.who_global_data VALUES (30660, 171, 90263, 5, 3234, 130, 132);
INSERT INTO public.who_global_data VALUES (30661, 0, 256, 0, 13, 130, 130);
INSERT INTO public.who_global_data VALUES (30662, 18, 10598, 0, 66, 130, 234);
INSERT INTO public.who_global_data VALUES (30663, 0, 2324, 0, 39, 130, 23);
INSERT INTO public.who_global_data VALUES (30664, 47, 2772, 2, 76, 130, 192);
INSERT INTO public.who_global_data VALUES (30665, 17, 8740, 0, 227, 130, 69);
INSERT INTO public.who_global_data VALUES (30666, 0, 12, 0, 0, 130, 187);
INSERT INTO public.who_global_data VALUES (30667, 561, 75109, 1, 2289, 130, 230);
INSERT INTO public.who_global_data VALUES (30668, 851, 25567, 8, 757, 130, 77);
INSERT INTO public.who_global_data VALUES (30669, 40, 2663, 0, 10, 130, 9);
INSERT INTO public.who_global_data VALUES (30670, 70589, 6145291, 776, 96318, 130, 74);
INSERT INTO public.who_global_data VALUES (30671, 3509, 278722, 87, 10473, 130, 224);
INSERT INTO public.who_global_data VALUES (30672, 3512, 449960, 190, 25779, 130, 199);
INSERT INTO public.who_global_data VALUES (30673, 4116, 353566, 62, 9052, 130, 190);
INSERT INTO public.who_global_data VALUES (30674, 388, 35378, 0, 1802, 130, 12);
INSERT INTO public.who_global_data VALUES (30675, 0, 340, 0, 24, 130, 104);
INSERT INTO public.who_global_data VALUES (30676, 3413, 232187, 32, 1505, 130, 153);
INSERT INTO public.who_global_data VALUES (30677, 1494, 311364, 16, 35851, 130, 91);
INSERT INTO public.who_global_data VALUES (30678, 153, 6170, 4, 93, 130, 215);
INSERT INTO public.who_global_data VALUES (30679, 363, 82494, 9, 1557, 130, 84);
INSERT INTO public.who_global_data VALUES (30680, 0, 402, 0, 32, 130, 231);
INSERT INTO public.who_global_data VALUES (30681, 734, 9294, 6, 51, 130, 196);
INSERT INTO public.who_global_data VALUES (30682, 374, 140707, 0, 2075, 130, 105);
INSERT INTO public.who_global_data VALUES (30683, 53, 38168, 9, 700, 130, 122);
INSERT INTO public.who_global_data VALUES (30684, 0, 0, 0, 0, 130, 159);
INSERT INTO public.who_global_data VALUES (30685, 48, 15477, 3, 615, 130, 75);
INSERT INTO public.who_global_data VALUES (30686, 437, 103981, 4, 605, 130, 27);
INSERT INTO public.who_global_data VALUES (30687, 167, 46522, 0, 1064, 130, 54);
INSERT INTO public.who_global_data VALUES (30688, 0, 23, 0, 0, 130, 226);
INSERT INTO public.who_global_data VALUES (30689, 21, 1697, 0, 36, 130, 79);
INSERT INTO public.who_global_data VALUES (30690, 1018, 37258, 4, 351, 130, 56);
INSERT INTO public.who_global_data VALUES (30691, 7, 1565, 0, 35, 130, 117);
INSERT INTO public.who_global_data VALUES (30692, 0, 1339, 0, 82, 130, 152);
INSERT INTO public.who_global_data VALUES (30693, 801, 34014, 13, 540, 130, 16);
INSERT INTO public.who_global_data VALUES (30694, 1, 120, 0, 1, 130, 10);
INSERT INTO public.who_global_data VALUES (30695, 88, 4573, 0, 92, 130, 201);
INSERT INTO public.who_global_data VALUES (30696, 19, 8376, 0, 124, 130, 174);
INSERT INTO public.who_global_data VALUES (30697, 63, 16348, 0, 229, 130, 119);
INSERT INTO public.who_global_data VALUES (30698, 2, 5770, 0, 179, 130, 168);
INSERT INTO public.who_global_data VALUES (30699, 115, 11034, 0, 134, 130, 99);
INSERT INTO public.who_global_data VALUES (30700, 59, 10157, 0, 34, 130, 171);
INSERT INTO public.who_global_data VALUES (30701, 4, 3090, 0, 130, 130, 87);
INSERT INTO public.who_global_data VALUES (30702, 19, 3026, 2, 34, 130, 123);
INSERT INTO public.who_global_data VALUES (30703, 0, 0, 0, 0, 130, 151);
INSERT INTO public.who_global_data VALUES (30704, 0, 1298, 0, 20, 130, 213);
INSERT INTO public.who_global_data VALUES (30705, 12, 7474, 0, 161, 130, 118);
INSERT INTO public.who_global_data VALUES (30706, 3, 370, 0, 10, 130, 134);
INSERT INTO public.who_global_data VALUES (30707, 0, 3541, 0, 40, 130, 65);
INSERT INTO public.who_global_data VALUES (30708, 3886, 730317, 187, 76430, 130, 102);
INSERT INTO public.who_global_data VALUES (30709, 0, 0, 0, 0, 130, 223);
INSERT INTO public.who_global_data VALUES (30710, 2, 215, 0, 2, 130, 4);
INSERT INTO public.who_global_data VALUES (30711, 0, 313, 0, 0, 130, 146);
INSERT INTO public.who_global_data VALUES (30712, 266, 11206, 1, 164, 130, 31);
INSERT INTO public.who_global_data VALUES (30713, 0, 13, 0, 1, 130, 127);
INSERT INTO public.who_global_data VALUES (30714, 1422, 119107, 44, 2113, 130, 22);
INSERT INTO public.who_global_data VALUES (30715, 305, 8288, 1, 59, 130, 115);
INSERT INTO public.who_global_data VALUES (30716, 897, 11631, 30, 256, 130, 106);
INSERT INTO public.who_global_data VALUES (30717, 88, 11121, 1, 121, 130, 90);
INSERT INTO public.who_global_data VALUES (30718, 0, 0, 0, 0, 130, 70);
INSERT INTO public.who_global_data VALUES (30719, 1351, 74745, 4, 481, 130, 46);
INSERT INTO public.who_global_data VALUES (30720, 2903, 114315, 6, 6379, 130, 139);
INSERT INTO public.who_global_data VALUES (30721, 0, 27, 0, 0, 130, 42);
INSERT INTO public.who_global_data VALUES (30722, 2, 1479, 0, 25, 130, 80);
INSERT INTO public.who_global_data VALUES (30723, 0, 4065, 0, 149, 130, 203);
INSERT INTO public.who_global_data VALUES (30724, 0, 1196, 0, 69, 130, 136);
INSERT INTO public.who_global_data VALUES (30725, 136, 58460, 3, 1111, 130, 63);
INSERT INTO public.who_global_data VALUES (30726, 0, 0, 0, 0, 130, 17);
INSERT INTO public.who_global_data VALUES (30727, 0, 70, 0, 2, 130, 172);
INSERT INTO public.who_global_data VALUES (30728, 45, 17674, 4, 729, 130, 109);
INSERT INTO public.who_global_data VALUES (30729, 292, 13698, 4, 274, 130, 200);
INSERT INTO public.who_global_data VALUES (30730, 503, 49695, 10, 353, 130, 93);
INSERT INTO public.who_global_data VALUES (30731, 607, 98057, 15, 924, 130, 5);
INSERT INTO public.who_global_data VALUES (30732, 0, 741, 0, 13, 130, 214);
INSERT INTO public.who_global_data VALUES (30733, 675, 311516, 8, 6474, 130, 204);
INSERT INTO public.who_global_data VALUES (30734, 0, 0, 0, 0, 130, 198);
INSERT INTO public.who_global_data VALUES (30735, 447, 110555, 17, 2340, 130, 173);
INSERT INTO public.who_global_data VALUES (30736, 0, 534, 0, 7, 130, 229);
INSERT INTO public.who_global_data VALUES (30737, 762, 38684, 21, 803, 130, 76);
INSERT INTO public.who_global_data VALUES (30738, 5160, 805302, 120, 32262, 130, 138);
INSERT INTO public.who_global_data VALUES (30739, 3062, 307288, 37, 5381, 130, 98);
INSERT INTO public.who_global_data VALUES (30740, 0, 0, 0, 0, 130, 103);
INSERT INTO public.who_global_data VALUES (30741, 1306, 88636, 15, 2447, 130, 225);
INSERT INTO public.who_global_data VALUES (30742, 425, 74029, 4, 1957, 130, 131);
INSERT INTO public.who_global_data VALUES (30743, 1118, 47422, 4, 648, 130, 235);
INSERT INTO public.who_global_data VALUES (30744, 227, 125311, 0, 214, 130, 137);
INSERT INTO public.who_global_data VALUES (30745, 38, 23699, 1, 407, 130, 81);
INSERT INTO public.who_global_data VALUES (30746, 319, 51194, 14, 1301, 130, 182);
INSERT INTO public.who_global_data VALUES (30747, 197, 3882, 3, 14, 130, 145);
INSERT INTO public.who_global_data VALUES (30748, 1271, 123944, 30, 4748, 130, 26);
INSERT INTO public.who_global_data VALUES (30749, 8232, 1167805, 160, 20545, 130, 170);
INSERT INTO public.who_global_data VALUES (30750, 12, 4832, 0, 29, 130, 191);
INSERT INTO public.who_global_data VALUES (30751, 0, 5, 0, 0, 130, 221);
INSERT INTO public.who_global_data VALUES (30752, 0, 48, 0, 0, 130, 64);
INSERT INTO public.who_global_data VALUES (30753, 0, 0, 0, 0, 130, 116);
INSERT INTO public.who_global_data VALUES (30754, 0, 19, 0, 0, 130, 128);
INSERT INTO public.who_global_data VALUES (30755, 0, 27, 0, 0, 130, 6);
INSERT INTO public.who_global_data VALUES (30756, 0, 383, 0, 8, 130, 227);
INSERT INTO public.who_global_data VALUES (30757, 0, 12, 0, 0, 130, 68);
INSERT INTO public.who_global_data VALUES (30758, 0, 64, 0, 0, 130, 184);
INSERT INTO public.who_global_data VALUES (30759, 0, 0, 0, 0, 130, 82);
INSERT INTO public.who_global_data VALUES (30760, 3, 749, 0, 42, 130, 149);
INSERT INTO public.who_global_data VALUES (30761, 0, 911, 0, 15, 130, 197);
INSERT INTO public.who_global_data VALUES (30762, 455, 333648, 29, 4712, 130, 78);
INSERT INTO public.who_global_data VALUES (30763, 10, 14919, 1, 309, 130, 233);
INSERT INTO public.who_global_data VALUES (30764, 30, 33414, 1, 748, 130, 133);
INSERT INTO public.who_global_data VALUES (30765, 0, 141, 0, 0, 130, 35);
INSERT INTO public.who_global_data VALUES (30766, 0, 2215, 0, 72, 130, 114);
INSERT INTO public.who_global_data VALUES (30767, 15, 57715, 0, 27, 130, 237);
INSERT INTO public.who_global_data VALUES (30768, 0, 13, 0, 0, 130, 55);
INSERT INTO public.who_global_data VALUES (30769, 26, 644, 0, 22, 130, 176);
INSERT INTO public.who_global_data VALUES (30770, 265, 9343, 0, 44, 130, 202);
INSERT INTO public.who_global_data VALUES (30771, 99, 5489, 0, 154, 130, 155);
INSERT INTO public.who_global_data VALUES (30772, 0, 0, 0, 0, 130, 32);
INSERT INTO public.who_global_data VALUES (30773, 0, 3588, 0, 99, 130, 220);
INSERT INTO public.who_global_data VALUES (30774, 903, 671669, 188, 16586, 130, 30);
INSERT INTO public.who_global_data VALUES (30775, 8, 2700, 0, 49, 130, 147);
INSERT INTO public.who_global_data VALUES (30776, 5099, 793860, 120, 33652, 130, 208);
INSERT INTO public.who_global_data VALUES (30777, 3, 3363, 0, 13, 130, 45);
INSERT INTO public.who_global_data VALUES (30778, 27, 13640, 0, 836, 130, 110);
INSERT INTO public.who_global_data VALUES (30779, 4, 4835, 0, 102, 130, 88);
INSERT INTO public.who_global_data VALUES (30780, 167, 92158, 1, 5876, 130, 51);
INSERT INTO public.who_global_data VALUES (30781, 368, 53053, 3, 1819, 130, 209);
INSERT INTO public.who_global_data VALUES (30782, 30, 4102, 2, 194, 130, 205);
INSERT INTO public.who_global_data VALUES (30783, 39, 9685, 0, 75, 130, 18);
INSERT INTO public.who_global_data VALUES (30784, 14, 3559, 0, 59, 130, 72);
INSERT INTO public.who_global_data VALUES (30785, 4044, 439017, 13, 42001, 130, 44);
INSERT INTO public.who_global_data VALUES (30786, 1, 28, 0, 0, 130, 15);
INSERT INTO public.who_global_data VALUES (30787, 6, 1749, 1, 47, 130, 25);
INSERT INTO public.who_global_data VALUES (30788, 0, 0, 0, 0, 130, 179);
INSERT INTO public.who_global_data VALUES (30789, 0, 0, 0, 0, 130, 34);
INSERT INTO public.who_global_data VALUES (30790, 61, 4382, 2, 72, 130, 207);
INSERT INTO public.who_global_data VALUES (30791, 1291, 17405, 32, 246, 130, 166);
INSERT INTO public.who_global_data VALUES (30792, 8142, 739835, 65, 8062, 130, 126);
INSERT INTO public.who_global_data VALUES (30793, 0, 0, 0, 0, 130, 97);
INSERT INTO public.who_global_data VALUES (30794, 1, 682, 0, 5, 130, 36);
INSERT INTO public.who_global_data VALUES (30795, 0, 0, 0, 0, 130, 125);
INSERT INTO public.who_global_data VALUES (30796, 247, 7777, 2, 75, 130, 124);
INSERT INTO public.who_global_data VALUES (30797, 3627, 204932, 69, 4065, 130, 185);
INSERT INTO public.who_global_data VALUES (30798, 626, 92095, 1, 413, 130, 194);
INSERT INTO public.who_global_data VALUES (30799, 0, 509, 0, 21, 130, 144);
INSERT INTO public.who_global_data VALUES (30800, 35217, 7044327, 291, 203620, 130, 19);
INSERT INTO public.who_global_data VALUES (30801, 0, 1317, 0, 19, 130, 217);
INSERT INTO public.who_global_data VALUES (30802, 10, 2008, 0, 47, 130, 148);
INSERT INTO public.who_global_data VALUES (30803, 475, 56068, 3, 463, 130, 86);
INSERT INTO public.who_global_data VALUES (30804, 0, 0, 0, 0, 130, 13);
INSERT INTO public.who_global_data VALUES (30805, 751, 72691, 6, 606, 130, 157);
INSERT INTO public.who_global_data VALUES (30806, 3, 1077, 0, 35, 130, 8);
INSERT INTO public.who_global_data VALUES (30807, 0, 0, 0, 0, 130, 73);
INSERT INTO public.who_global_data VALUES (30808, 1, 2035, 0, 588, 130, 101);
INSERT INTO public.who_global_data VALUES (30809, 19, 14660, 0, 332, 130, 165);
INSERT INTO public.who_global_data VALUES (30810, 4, 7816, 1, 228, 130, 14);
INSERT INTO public.who_global_data VALUES (30811, 12, 39325, 3, 1460, 131, 193);
INSERT INTO public.who_global_data VALUES (30812, 106, 13259, 2, 377, 131, 113);
INSERT INTO public.who_global_data VALUES (30813, 153, 51067, 3, 1714, 131, 143);
INSERT INTO public.who_global_data VALUES (30814, 0, 0, 0, 0, 131, 219);
INSERT INTO public.who_global_data VALUES (30815, 0, 1836, 0, 53, 131, 186);
INSERT INTO public.who_global_data VALUES (30816, 46, 4718, 3, 174, 131, 52);
INSERT INTO public.who_global_data VALUES (30817, 0, 3, 0, 0, 131, 180);
INSERT INTO public.who_global_data VALUES (30818, 3, 101, 0, 3, 131, 167);
INSERT INTO public.who_global_data VALUES (30819, 11249, 702484, 335, 15543, 131, 154);
INSERT INTO public.who_global_data VALUES (30820, 174, 48887, 6, 952, 131, 94);
INSERT INTO public.who_global_data VALUES (30821, 0, 3756, 0, 25, 131, 66);
INSERT INTO public.who_global_data VALUES (30822, 24, 27040, 2, 872, 131, 58);
INSERT INTO public.who_global_data VALUES (30823, 526, 43466, 0, 787, 131, 163);
INSERT INTO public.who_global_data VALUES (30824, 128, 40023, 1, 586, 131, 37);
INSERT INTO public.who_global_data VALUES (30825, 48, 3838, 0, 89, 131, 142);
INSERT INTO public.who_global_data VALUES (30826, 586, 69361, 3, 242, 131, 83);
INSERT INTO public.who_global_data VALUES (30827, 1275, 359148, 32, 5161, 131, 228);
INSERT INTO public.who_global_data VALUES (30828, 0, 190, 0, 7, 131, 188);
INSERT INTO public.who_global_data VALUES (30829, 320, 77609, 5, 818, 131, 62);
INSERT INTO public.who_global_data VALUES (30830, 540, 116691, 12, 9986, 131, 160);
INSERT INTO public.who_global_data VALUES (30831, 17, 1825, 1, 24, 131, 50);
INSERT INTO public.who_global_data VALUES (30832, 15, 2340, 0, 40, 131, 33);
INSERT INTO public.who_global_data VALUES (30833, 0, 181, 0, 9, 131, 183);
INSERT INTO public.who_global_data VALUES (30834, 2, 273, 0, 0, 131, 92);
INSERT INTO public.who_global_data VALUES (30835, 370, 133592, 28, 7828, 131, 158);
INSERT INTO public.who_global_data VALUES (30836, 21, 88, 0, 1, 131, 67);
INSERT INTO public.who_global_data VALUES (30837, 122, 26917, 2, 810, 131, 57);
INSERT INTO public.who_global_data VALUES (30838, 0, 2921, 0, 13, 131, 38);
INSERT INTO public.who_global_data VALUES (30839, 28378, 4717991, 869, 141406, 131, 141);
INSERT INTO public.who_global_data VALUES (30840, 0, 71, 0, 1, 131, 178);
INSERT INTO public.who_global_data VALUES (30841, 0, 146, 0, 3, 131, 108);
INSERT INTO public.who_global_data VALUES (30842, 58, 20055, 7, 796, 131, 39);
INSERT INTO public.who_global_data VALUES (30843, 0, 1929, 0, 56, 131, 2);
INSERT INTO public.who_global_data VALUES (30844, 18, 502, 0, 1, 131, 195);
INSERT INTO public.who_global_data VALUES (30845, 70, 5771, 1, 57, 131, 107);
INSERT INTO public.who_global_data VALUES (30846, 0, 276, 0, 0, 131, 161);
INSERT INTO public.who_global_data VALUES (30847, 103, 20838, 0, 418, 131, 212);
INSERT INTO public.who_global_data VALUES (30848, 1215, 151671, 7, 9262, 131, 181);
INSERT INTO public.who_global_data VALUES (30849, 0, 210, 0, 1, 131, 53);
INSERT INTO public.who_global_data VALUES (30850, 0, 4806, 0, 62, 131, 164);
INSERT INTO public.who_global_data VALUES (30851, 1, 1178, 1, 84, 131, 140);
INSERT INTO public.who_global_data VALUES (30852, 1922, 457901, 50, 12641, 131, 20);
INSERT INTO public.who_global_data VALUES (30853, 27, 90993, 0, 4746, 131, 112);
INSERT INTO public.who_global_data VALUES (30854, 7721, 806038, 193, 25296, 131, 111);
INSERT INTO public.who_global_data VALUES (30855, 0, 474, 0, 7, 131, 71);
INSERT INTO public.who_global_data VALUES (30856, 0, 5008, 0, 89, 131, 218);
INSERT INTO public.who_global_data VALUES (30857, 0, 0, 0, 0, 131, 43);
INSERT INTO public.who_global_data VALUES (30858, 1233, 72049, 16, 828, 131, 49);
INSERT INTO public.who_global_data VALUES (30859, 73, 19629, 0, 120, 131, 1);
INSERT INTO public.who_global_data VALUES (30860, 190, 16197, 3, 272, 131, 48);
INSERT INTO public.who_global_data VALUES (30861, 45, 5457, 2, 122, 131, 232);
INSERT INTO public.who_global_data VALUES (30862, 0, 315, 0, 1, 131, 175);
INSERT INTO public.who_global_data VALUES (30863, 12, 1696, 0, 22, 131, 21);
INSERT INTO public.who_global_data VALUES (30864, 1303, 64597, 15, 606, 131, 156);
INSERT INTO public.who_global_data VALUES (30865, 0, 0, 0, 0, 131, 95);
INSERT INTO public.who_global_data VALUES (30866, 19, 10611, 0, 271, 131, 177);
INSERT INTO public.who_global_data VALUES (30867, 424, 26637, 1, 649, 131, 210);
INSERT INTO public.who_global_data VALUES (30868, 0, 5409, 0, 61, 131, 120);
INSERT INTO public.who_global_data VALUES (30869, 6, 30, 0, 0, 131, 135);
INSERT INTO public.who_global_data VALUES (30870, 429, 111386, 2, 2095, 131, 206);
INSERT INTO public.who_global_data VALUES (30871, 766, 134747, 6, 11279, 131, 189);
INSERT INTO public.who_global_data VALUES (30872, 104, 102840, 14, 5883, 131, 129);
INSERT INTO public.who_global_data VALUES (30873, 215, 28630, 0, 826, 131, 121);
INSERT INTO public.who_global_data VALUES (30874, 0, 5028, 0, 83, 131, 59);
INSERT INTO public.who_global_data VALUES (30875, 0, 375, 0, 0, 131, 96);
INSERT INTO public.who_global_data VALUES (30876, 35, 3200, 0, 64, 131, 41);
INSERT INTO public.who_global_data VALUES (30877, 12, 5431, 0, 108, 131, 216);
INSERT INTO public.who_global_data VALUES (30878, 632, 73332, 5, 1170, 131, 236);
INSERT INTO public.who_global_data VALUES (30879, 0, 13, 0, 0, 131, 150);
INSERT INTO public.who_global_data VALUES (30880, 0, 460, 0, 0, 131, 61);
INSERT INTO public.who_global_data VALUES (30881, 0, 32, 0, 2, 131, 7);
INSERT INTO public.who_global_data VALUES (30882, 105, 9682, 0, 343, 131, 169);
INSERT INTO public.who_global_data VALUES (30883, 11123, 514781, 27, 31541, 131, 28);
INSERT INTO public.who_global_data VALUES (30884, 0, 9863, 0, 65, 131, 85);
INSERT INTO public.who_global_data VALUES (30885, 0, 1579, 0, 6, 131, 211);
INSERT INTO public.who_global_data VALUES (30886, 0, 8728, 0, 54, 131, 60);
INSERT INTO public.who_global_data VALUES (30887, 5, 3569, 1, 111, 131, 3);
INSERT INTO public.who_global_data VALUES (30888, 298, 5552, 0, 28, 131, 11);
INSERT INTO public.who_global_data VALUES (30889, 1192, 285332, 3, 9460, 131, 89);
INSERT INTO public.who_global_data VALUES (30890, 0, 46222, 0, 299, 131, 24);
INSERT INTO public.who_global_data VALUES (30891, 8, 372, 0, 0, 131, 162);
INSERT INTO public.who_global_data VALUES (30892, 216, 17444, 3, 379, 131, 100);
INSERT INTO public.who_global_data VALUES (30893, 0, 14, 0, 0, 131, 47);
INSERT INTO public.who_global_data VALUES (30894, 0, 24, 0, 0, 131, 29);
INSERT INTO public.who_global_data VALUES (30895, 0, 4954, 0, 42, 131, 40);
INSERT INTO public.who_global_data VALUES (30896, 1, 2355, 0, 43, 131, 222);
INSERT INTO public.who_global_data VALUES (30897, 390, 90092, 16, 3229, 131, 132);
INSERT INTO public.who_global_data VALUES (30898, 0, 256, 0, 13, 131, 130);
INSERT INTO public.who_global_data VALUES (30899, 32, 10580, 0, 66, 131, 234);
INSERT INTO public.who_global_data VALUES (30900, 0, 2324, 0, 39, 131, 23);
INSERT INTO public.who_global_data VALUES (30901, 16, 2725, 1, 74, 131, 192);
INSERT INTO public.who_global_data VALUES (30902, 39, 8723, 0, 227, 131, 69);
INSERT INTO public.who_global_data VALUES (30903, 0, 12, 0, 0, 131, 187);
INSERT INTO public.who_global_data VALUES (30904, 708, 74548, 17, 2288, 131, 230);
INSERT INTO public.who_global_data VALUES (30905, 702, 24716, 13, 749, 131, 77);
INSERT INTO public.who_global_data VALUES (30906, 22, 2623, 0, 10, 131, 9);
INSERT INTO public.who_global_data VALUES (30907, 82170, 6074702, 1039, 95542, 131, 74);
INSERT INTO public.who_global_data VALUES (30908, 3874, 275213, 78, 10386, 131, 224);
INSERT INTO public.who_global_data VALUES (30909, 3362, 446448, 195, 25589, 131, 199);
INSERT INTO public.who_global_data VALUES (30910, 3481, 349450, 55, 8990, 131, 190);
INSERT INTO public.who_global_data VALUES (30911, 430, 34990, 0, 1802, 131, 12);
INSERT INTO public.who_global_data VALUES (30912, 0, 340, 0, 24, 131, 104);
INSERT INTO public.who_global_data VALUES (30913, 5882, 228774, 26, 1473, 131, 153);
INSERT INTO public.who_global_data VALUES (30914, 1766, 309870, 17, 35835, 131, 91);
INSERT INTO public.who_global_data VALUES (30915, 163, 6017, 1, 89, 131, 215);
INSERT INTO public.who_global_data VALUES (30916, 441, 82131, 3, 1548, 131, 84);
INSERT INTO public.who_global_data VALUES (30917, 0, 402, 0, 32, 131, 231);
INSERT INTO public.who_global_data VALUES (30918, 431, 8560, 2, 45, 131, 196);
INSERT INTO public.who_global_data VALUES (30919, 68, 140333, 0, 2075, 131, 105);
INSERT INTO public.who_global_data VALUES (30920, 244, 38115, 2, 691, 131, 122);
INSERT INTO public.who_global_data VALUES (30921, 0, 0, 0, 0, 131, 159);
INSERT INTO public.who_global_data VALUES (30922, 47, 15429, 3, 612, 131, 75);
INSERT INTO public.who_global_data VALUES (30923, 345, 103544, 4, 601, 131, 27);
INSERT INTO public.who_global_data VALUES (30924, 104, 46355, 1, 1064, 131, 54);
INSERT INTO public.who_global_data VALUES (30925, 0, 23, 0, 0, 131, 226);
INSERT INTO public.who_global_data VALUES (30926, 22, 1676, 0, 36, 131, 79);
INSERT INTO public.who_global_data VALUES (30927, 1012, 36240, 7, 347, 131, 56);
INSERT INTO public.who_global_data VALUES (30928, 0, 1558, 0, 35, 131, 117);
INSERT INTO public.who_global_data VALUES (30929, 1, 1339, 0, 82, 131, 152);
INSERT INTO public.who_global_data VALUES (30930, 849, 33213, 7, 527, 131, 16);
INSERT INTO public.who_global_data VALUES (30931, 0, 119, 0, 1, 131, 10);
INSERT INTO public.who_global_data VALUES (30932, 104, 4485, 0, 92, 131, 201);
INSERT INTO public.who_global_data VALUES (30933, 46, 8357, 0, 124, 131, 174);
INSERT INTO public.who_global_data VALUES (30934, 28, 16285, 0, 229, 131, 119);
INSERT INTO public.who_global_data VALUES (30935, 2, 5768, 0, 179, 131, 168);
INSERT INTO public.who_global_data VALUES (30936, 150, 10919, 1, 134, 131, 99);
INSERT INTO public.who_global_data VALUES (30937, 53, 10098, 0, 34, 131, 171);
INSERT INTO public.who_global_data VALUES (30938, 6, 3086, 0, 130, 131, 87);
INSERT INTO public.who_global_data VALUES (30939, 27, 3007, 1, 32, 131, 123);
INSERT INTO public.who_global_data VALUES (30940, 0, 0, 0, 0, 131, 151);
INSERT INTO public.who_global_data VALUES (30941, 0, 1298, 0, 20, 131, 213);
INSERT INTO public.who_global_data VALUES (30942, 0, 7462, 0, 161, 131, 118);
INSERT INTO public.who_global_data VALUES (30943, 0, 367, 0, 10, 131, 134);
INSERT INTO public.who_global_data VALUES (30944, 0, 3541, 0, 40, 131, 65);
INSERT INTO public.who_global_data VALUES (30945, 5573, 726431, 399, 76243, 131, 102);
INSERT INTO public.who_global_data VALUES (30946, 0, 0, 0, 0, 131, 223);
INSERT INTO public.who_global_data VALUES (30947, 0, 213, 0, 2, 131, 4);
INSERT INTO public.who_global_data VALUES (30948, 0, 313, 0, 0, 131, 146);
INSERT INTO public.who_global_data VALUES (30949, 371, 10940, 5, 163, 131, 31);
INSERT INTO public.who_global_data VALUES (30950, 0, 13, 0, 1, 131, 127);
INSERT INTO public.who_global_data VALUES (30951, 2444, 117685, 28, 2069, 131, 22);
INSERT INTO public.who_global_data VALUES (30952, 226, 7983, 4, 58, 131, 115);
INSERT INTO public.who_global_data VALUES (30953, 743, 10734, 28, 226, 131, 106);
INSERT INTO public.who_global_data VALUES (30954, 115, 11033, 0, 120, 131, 90);
INSERT INTO public.who_global_data VALUES (30955, 0, 0, 0, 0, 131, 70);
INSERT INTO public.who_global_data VALUES (30956, 1573, 73394, 10, 477, 131, 46);
INSERT INTO public.who_global_data VALUES (30957, 2976, 111412, 8, 6373, 131, 139);
INSERT INTO public.who_global_data VALUES (30958, 0, 27, 0, 0, 131, 42);
INSERT INTO public.who_global_data VALUES (30959, 0, 1477, 0, 25, 131, 80);
INSERT INTO public.who_global_data VALUES (30960, 0, 4065, 0, 149, 131, 203);
INSERT INTO public.who_global_data VALUES (30961, 2, 1196, 0, 69, 131, 136);
INSERT INTO public.who_global_data VALUES (30962, 126, 58324, 2, 1108, 131, 63);
INSERT INTO public.who_global_data VALUES (30963, 0, 0, 0, 0, 131, 17);
INSERT INTO public.who_global_data VALUES (30964, 0, 70, 0, 2, 131, 172);
INSERT INTO public.who_global_data VALUES (30965, 286, 17629, 4, 725, 131, 109);
INSERT INTO public.who_global_data VALUES (30966, 0, 13406, 0, 270, 131, 200);
INSERT INTO public.who_global_data VALUES (30967, 620, 49192, 9, 343, 131, 93);
INSERT INTO public.who_global_data VALUES (30968, 1543, 97450, 24, 909, 131, 5);
INSERT INTO public.who_global_data VALUES (30969, 0, 741, 0, 13, 131, 214);
INSERT INTO public.who_global_data VALUES (30970, 566, 310841, 9, 6466, 131, 204);
INSERT INTO public.who_global_data VALUES (30971, 0, 0, 0, 0, 131, 198);
INSERT INTO public.who_global_data VALUES (30972, 677, 110108, 12, 2323, 131, 173);
INSERT INTO public.who_global_data VALUES (30973, 2, 534, 0, 7, 131, 229);
INSERT INTO public.who_global_data VALUES (30974, 696, 37922, 21, 782, 131, 76);
INSERT INTO public.who_global_data VALUES (30975, 5558, 800142, 105, 32142, 131, 138);
INSERT INTO public.who_global_data VALUES (30976, 2970, 304226, 60, 5344, 131, 98);
INSERT INTO public.who_global_data VALUES (30977, 0, 0, 0, 0, 131, 103);
INSERT INTO public.who_global_data VALUES (30978, 1350, 87330, 8, 2432, 131, 225);
INSERT INTO public.who_global_data VALUES (30979, 665, 73604, 9, 1953, 131, 131);
INSERT INTO public.who_global_data VALUES (30980, 891, 46304, 2, 644, 131, 235);
INSERT INTO public.who_global_data VALUES (30981, 234, 125084, 0, 214, 131, 137);
INSERT INTO public.who_global_data VALUES (30982, 50, 23661, 5, 406, 131, 81);
INSERT INTO public.who_global_data VALUES (30983, 341, 50875, 8, 1287, 131, 182);
INSERT INTO public.who_global_data VALUES (30984, 0, 3685, 0, 11, 131, 145);
INSERT INTO public.who_global_data VALUES (30985, 1438, 122673, 31, 4718, 131, 26);
INSERT INTO public.who_global_data VALUES (30986, 8135, 1159573, 61, 20385, 131, 170);
INSERT INTO public.who_global_data VALUES (30987, 9, 4820, 0, 29, 131, 191);
INSERT INTO public.who_global_data VALUES (30988, 0, 5, 0, 0, 131, 221);
INSERT INTO public.who_global_data VALUES (30989, 0, 48, 0, 0, 131, 64);
INSERT INTO public.who_global_data VALUES (30990, 0, 0, 0, 0, 131, 116);
INSERT INTO public.who_global_data VALUES (30991, 0, 19, 0, 0, 131, 128);
INSERT INTO public.who_global_data VALUES (30992, 0, 27, 0, 0, 131, 6);
INSERT INTO public.who_global_data VALUES (30993, 0, 383, 0, 8, 131, 227);
INSERT INTO public.who_global_data VALUES (30994, 0, 12, 0, 0, 131, 68);
INSERT INTO public.who_global_data VALUES (30995, 0, 64, 0, 0, 131, 184);
INSERT INTO public.who_global_data VALUES (30996, 0, 0, 0, 0, 131, 82);
INSERT INTO public.who_global_data VALUES (30997, 0, 746, 0, 42, 131, 149);
INSERT INTO public.who_global_data VALUES (30998, 0, 911, 0, 15, 131, 197);
INSERT INTO public.who_global_data VALUES (30999, 403, 333193, 28, 4683, 131, 78);
INSERT INTO public.who_global_data VALUES (31000, 40, 14909, 2, 308, 131, 233);
INSERT INTO public.who_global_data VALUES (31001, 72, 33384, 1, 747, 131, 133);
INSERT INTO public.who_global_data VALUES (31002, 0, 141, 0, 0, 131, 35);
INSERT INTO public.who_global_data VALUES (31003, 7, 2215, 0, 72, 131, 114);
INSERT INTO public.who_global_data VALUES (31004, 15, 57700, 0, 27, 131, 237);
INSERT INTO public.who_global_data VALUES (31005, 0, 13, 0, 0, 131, 55);
INSERT INTO public.who_global_data VALUES (31006, 0, 618, 0, 22, 131, 176);
INSERT INTO public.who_global_data VALUES (31007, 478, 9078, 0, 44, 131, 202);
INSERT INTO public.who_global_data VALUES (31008, 39, 5390, 2, 154, 131, 155);
INSERT INTO public.who_global_data VALUES (31009, 0, 0, 0, 0, 131, 32);
INSERT INTO public.who_global_data VALUES (31010, 0, 3588, 0, 99, 131, 220);
INSERT INTO public.who_global_data VALUES (31011, 1268, 670766, 22, 16398, 131, 30);
INSERT INTO public.who_global_data VALUES (31012, 6, 2692, 0, 49, 131, 147);
INSERT INTO public.who_global_data VALUES (31013, 7786, 788761, 115, 33532, 131, 208);
INSERT INTO public.who_global_data VALUES (31014, 11, 3360, 0, 13, 131, 45);
INSERT INTO public.who_global_data VALUES (31015, 3, 13613, 0, 836, 131, 110);
INSERT INTO public.who_global_data VALUES (31016, 14, 4831, 0, 102, 131, 88);
INSERT INTO public.who_global_data VALUES (31017, 325, 91991, 2, 5875, 131, 51);
INSERT INTO public.who_global_data VALUES (31018, 120, 52685, 1, 1816, 131, 209);
INSERT INTO public.who_global_data VALUES (31019, 34, 4072, 4, 192, 131, 205);
INSERT INTO public.who_global_data VALUES (31020, 41, 9646, 0, 75, 131, 18);
INSERT INTO public.who_global_data VALUES (31021, 22, 3545, 0, 59, 131, 72);
INSERT INTO public.who_global_data VALUES (31022, 5692, 434973, 17, 41988, 131, 44);
INSERT INTO public.who_global_data VALUES (31023, 0, 27, 0, 0, 131, 15);
INSERT INTO public.who_global_data VALUES (31024, 7, 1743, 0, 46, 131, 25);
INSERT INTO public.who_global_data VALUES (31025, 0, 0, 0, 0, 131, 179);
INSERT INTO public.who_global_data VALUES (31026, 0, 0, 0, 0, 131, 34);
INSERT INTO public.who_global_data VALUES (31027, 36, 4321, 0, 70, 131, 207);
INSERT INTO public.who_global_data VALUES (31028, 0, 16114, 0, 214, 131, 166);
INSERT INTO public.who_global_data VALUES (31029, 8197, 731693, 68, 7997, 131, 126);
INSERT INTO public.who_global_data VALUES (31030, 0, 0, 0, 0, 131, 97);
INSERT INTO public.who_global_data VALUES (31031, 1, 681, 0, 5, 131, 36);
INSERT INTO public.who_global_data VALUES (31032, 0, 0, 0, 0, 131, 125);
INSERT INTO public.who_global_data VALUES (31033, 166, 7530, 2, 73, 131, 124);
INSERT INTO public.who_global_data VALUES (31034, 2671, 201305, 37, 3996, 131, 185);
INSERT INTO public.who_global_data VALUES (31035, 851, 91469, 1, 412, 131, 194);
INSERT INTO public.who_global_data VALUES (31036, 0, 509, 0, 21, 131, 144);
INSERT INTO public.who_global_data VALUES (31037, 48958, 7009110, 851, 203329, 131, 19);
INSERT INTO public.who_global_data VALUES (31038, 21, 1317, 0, 19, 131, 217);
INSERT INTO public.who_global_data VALUES (31039, 31, 1998, 0, 47, 131, 148);
INSERT INTO public.who_global_data VALUES (31040, 640, 55593, 6, 460, 131, 86);
INSERT INTO public.who_global_data VALUES (31041, 0, 0, 0, 0, 131, 13);
INSERT INTO public.who_global_data VALUES (31042, 667, 71940, 9, 600, 131, 157);
INSERT INTO public.who_global_data VALUES (31043, 5, 1074, 0, 35, 131, 8);
INSERT INTO public.who_global_data VALUES (31044, 0, 0, 0, 0, 131, 73);
INSERT INTO public.who_global_data VALUES (31045, 0, 2034, 0, 588, 131, 101);
INSERT INTO public.who_global_data VALUES (31046, 29, 14641, 0, 332, 131, 165);
INSERT INTO public.who_global_data VALUES (31047, 9, 7812, 0, 227, 131, 14);
INSERT INTO public.who_global_data VALUES (31048, 35, 39313, 0, 1457, 132, 193);
INSERT INTO public.who_global_data VALUES (31049, 108, 13153, 2, 375, 132, 113);
INSERT INTO public.who_global_data VALUES (31050, 160, 50914, 4, 1711, 132, 143);
INSERT INTO public.who_global_data VALUES (31051, 0, 0, 0, 0, 132, 219);
INSERT INTO public.who_global_data VALUES (31052, 0, 1836, 0, 53, 132, 186);
INSERT INTO public.who_global_data VALUES (31053, 82, 4672, 4, 171, 132, 52);
INSERT INTO public.who_global_data VALUES (31054, 0, 3, 0, 0, 132, 180);
INSERT INTO public.who_global_data VALUES (31055, 0, 98, 0, 3, 132, 167);
INSERT INTO public.who_global_data VALUES (31056, 12969, 691235, 442, 15208, 132, 154);
INSERT INTO public.who_global_data VALUES (31057, 328, 48713, 3, 946, 132, 94);
INSERT INTO public.who_global_data VALUES (31058, 0, 3756, 0, 25, 132, 66);
INSERT INTO public.who_global_data VALUES (31059, 16, 27016, 1, 870, 132, 58);
INSERT INTO public.who_global_data VALUES (31060, 623, 42940, 1, 787, 132, 163);
INSERT INTO public.who_global_data VALUES (31061, 108, 39895, 2, 585, 132, 37);
INSERT INTO public.who_global_data VALUES (31062, 91, 3790, 3, 89, 132, 142);
INSERT INTO public.who_global_data VALUES (31063, 585, 68775, 3, 239, 132, 83);
INSERT INTO public.who_global_data VALUES (31064, 1106, 357873, 36, 5129, 132, 228);
INSERT INTO public.who_global_data VALUES (31065, 1, 190, 0, 7, 132, 188);
INSERT INTO public.who_global_data VALUES (31066, 332, 77289, 6, 813, 132, 62);
INSERT INTO public.who_global_data VALUES (31067, 944, 116151, 6, 9974, 132, 160);
INSERT INTO public.who_global_data VALUES (31068, 50, 1808, 1, 23, 132, 50);
INSERT INTO public.who_global_data VALUES (31069, 0, 2325, 0, 40, 132, 33);
INSERT INTO public.who_global_data VALUES (31070, 0, 181, 0, 9, 132, 183);
INSERT INTO public.who_global_data VALUES (31071, 8, 271, 0, 0, 132, 92);
INSERT INTO public.who_global_data VALUES (31072, 604, 133222, 35, 7800, 132, 158);
INSERT INTO public.who_global_data VALUES (31073, 0, 67, 0, 1, 132, 67);
INSERT INTO public.who_global_data VALUES (31074, 235, 26795, 7, 808, 132, 57);
INSERT INTO public.who_global_data VALUES (31075, 0, 2921, 0, 13, 132, 38);
INSERT INTO public.who_global_data VALUES (31076, 31911, 4689613, 729, 140537, 132, 141);
INSERT INTO public.who_global_data VALUES (31077, 0, 71, 0, 1, 132, 178);
INSERT INTO public.who_global_data VALUES (31078, 0, 146, 0, 3, 132, 108);
INSERT INTO public.who_global_data VALUES (31079, 169, 19997, 0, 789, 132, 39);
INSERT INTO public.who_global_data VALUES (31080, 0, 1929, 0, 56, 132, 2);
INSERT INTO public.who_global_data VALUES (31081, 0, 484, 0, 1, 132, 195);
INSERT INTO public.who_global_data VALUES (31082, 73, 5701, 1, 56, 132, 107);
INSERT INTO public.who_global_data VALUES (31083, 1, 276, 0, 0, 132, 161);
INSERT INTO public.who_global_data VALUES (31084, 0, 20735, 0, 418, 132, 212);
INSERT INTO public.who_global_data VALUES (31085, 1362, 150456, 6, 9255, 132, 181);
INSERT INTO public.who_global_data VALUES (31086, 0, 210, 0, 1, 132, 53);
INSERT INTO public.who_global_data VALUES (31087, 0, 4806, 0, 62, 132, 164);
INSERT INTO public.who_global_data VALUES (31088, 2, 1177, 0, 83, 132, 140);
INSERT INTO public.who_global_data VALUES (31089, 2111, 455979, 64, 12591, 132, 20);
INSERT INTO public.who_global_data VALUES (31090, 15, 90966, 0, 4746, 132, 112);
INSERT INTO public.who_global_data VALUES (31091, 7494, 798317, 179, 25103, 132, 111);
INSERT INTO public.who_global_data VALUES (31092, 0, 474, 0, 7, 132, 71);
INSERT INTO public.who_global_data VALUES (31093, 3, 5008, 0, 89, 132, 218);
INSERT INTO public.who_global_data VALUES (31094, 0, 0, 0, 0, 132, 43);
INSERT INTO public.who_global_data VALUES (31095, 1357, 70816, 17, 812, 132, 49);
INSERT INTO public.who_global_data VALUES (31096, 0, 19556, 0, 120, 132, 1);
INSERT INTO public.who_global_data VALUES (31097, 212, 16007, 3, 269, 132, 48);
INSERT INTO public.who_global_data VALUES (31098, 62, 5412, 2, 120, 132, 232);
INSERT INTO public.who_global_data VALUES (31099, 0, 315, 0, 1, 132, 175);
INSERT INTO public.who_global_data VALUES (31100, 13, 1684, 0, 22, 132, 21);
INSERT INTO public.who_global_data VALUES (31101, 1976, 63294, 10, 591, 132, 156);
INSERT INTO public.who_global_data VALUES (31102, 0, 0, 0, 0, 132, 95);
INSERT INTO public.who_global_data VALUES (31103, 15, 10592, 0, 271, 132, 177);
INSERT INTO public.who_global_data VALUES (31104, 619, 26213, 1, 648, 132, 210);
INSERT INTO public.who_global_data VALUES (31105, 0, 5409, 0, 61, 132, 120);
INSERT INTO public.who_global_data VALUES (31106, 0, 24, 0, 0, 132, 135);
INSERT INTO public.who_global_data VALUES (31107, 360, 110957, 6, 2093, 132, 206);
INSERT INTO public.who_global_data VALUES (31108, 1506, 133981, 37, 11273, 132, 189);
INSERT INTO public.who_global_data VALUES (31109, 111, 102736, 16, 5869, 132, 129);
INSERT INTO public.who_global_data VALUES (31110, 0, 28415, 3, 826, 132, 121);
INSERT INTO public.who_global_data VALUES (31111, 10, 5028, 0, 83, 132, 59);
INSERT INTO public.who_global_data VALUES (31112, 6, 375, 0, 0, 132, 96);
INSERT INTO public.who_global_data VALUES (31113, 47, 3165, 0, 64, 132, 41);
INSERT INTO public.who_global_data VALUES (31114, 20, 5419, 0, 108, 132, 216);
INSERT INTO public.who_global_data VALUES (31115, 527, 72700, 10, 1165, 132, 236);
INSERT INTO public.who_global_data VALUES (31116, 0, 13, 0, 0, 132, 150);
INSERT INTO public.who_global_data VALUES (31117, 2, 460, 0, 0, 132, 61);
INSERT INTO public.who_global_data VALUES (31118, 0, 32, 0, 2, 132, 7);
INSERT INTO public.who_global_data VALUES (31119, 93, 9577, 0, 343, 132, 169);
INSERT INTO public.who_global_data VALUES (31120, 13886, 503658, 39, 31514, 132, 28);
INSERT INTO public.who_global_data VALUES (31121, 32, 9863, 0, 65, 132, 85);
INSERT INTO public.who_global_data VALUES (31122, 0, 1579, 0, 6, 132, 211);
INSERT INTO public.who_global_data VALUES (31123, 0, 8728, 0, 54, 132, 60);
INSERT INTO public.who_global_data VALUES (31124, 9, 3564, 0, 110, 132, 3);
INSERT INTO public.who_global_data VALUES (31125, 294, 5254, 1, 28, 132, 11);
INSERT INTO public.who_global_data VALUES (31126, 1410, 284140, 5, 9457, 132, 89);
INSERT INTO public.who_global_data VALUES (31127, 0, 46222, 0, 299, 132, 24);
INSERT INTO public.who_global_data VALUES (31128, 3, 364, 0, 0, 132, 162);
INSERT INTO public.who_global_data VALUES (31129, 315, 17228, 7, 376, 132, 100);
INSERT INTO public.who_global_data VALUES (31130, 0, 14, 0, 0, 132, 47);
INSERT INTO public.who_global_data VALUES (31131, 0, 24, 0, 0, 132, 29);
INSERT INTO public.who_global_data VALUES (31132, 467, 4954, 0, 42, 132, 40);
INSERT INTO public.who_global_data VALUES (31133, 68, 2354, 2, 43, 132, 222);
INSERT INTO public.who_global_data VALUES (31134, 824, 89702, 27, 3213, 132, 132);
INSERT INTO public.who_global_data VALUES (31135, 0, 256, 0, 13, 132, 130);
INSERT INTO public.who_global_data VALUES (31136, 70, 10548, 1, 66, 132, 234);
INSERT INTO public.who_global_data VALUES (31137, 0, 2324, 0, 39, 132, 23);
INSERT INTO public.who_global_data VALUES (31138, 130, 2709, 2, 73, 132, 192);
INSERT INTO public.who_global_data VALUES (31139, 0, 8684, 0, 227, 132, 69);
INSERT INTO public.who_global_data VALUES (31140, 0, 12, 0, 0, 132, 187);
INSERT INTO public.who_global_data VALUES (31141, 647, 73840, 22, 2271, 132, 230);
INSERT INTO public.who_global_data VALUES (31142, 937, 24014, 6, 736, 132, 77);
INSERT INTO public.who_global_data VALUES (31143, 40, 2601, 0, 10, 132, 9);
INSERT INTO public.who_global_data VALUES (31144, 88600, 5992532, 1124, 94503, 132, 74);
INSERT INTO public.who_global_data VALUES (31145, 4494, 271339, 90, 10308, 132, 224);
INSERT INTO public.who_global_data VALUES (31146, 3204, 443086, 172, 25394, 132, 199);
INSERT INTO public.who_global_data VALUES (31147, 4270, 345969, 68, 8935, 132, 190);
INSERT INTO public.who_global_data VALUES (31148, 245, 34560, 5, 1802, 132, 12);
INSERT INTO public.who_global_data VALUES (31149, 0, 340, 0, 24, 132, 104);
INSERT INTO public.who_global_data VALUES (31150, 8389, 222892, 30, 1447, 132, 153);
INSERT INTO public.who_global_data VALUES (31151, 1869, 308104, 17, 35818, 132, 91);
INSERT INTO public.who_global_data VALUES (31152, 131, 5854, 8, 88, 132, 215);
INSERT INTO public.who_global_data VALUES (31153, 635, 81690, 5, 1545, 132, 84);
INSERT INTO public.who_global_data VALUES (31154, 3, 402, 0, 32, 132, 231);
INSERT INTO public.who_global_data VALUES (31155, 850, 8129, 4, 43, 132, 196);
INSERT INTO public.who_global_data VALUES (31156, 90, 140265, 32, 2075, 132, 105);
INSERT INTO public.who_global_data VALUES (31157, 164, 37871, 7, 689, 132, 122);
INSERT INTO public.who_global_data VALUES (31158, 0, 0, 0, 0, 132, 159);
INSERT INTO public.who_global_data VALUES (31159, 46, 15382, 2, 609, 132, 75);
INSERT INTO public.who_global_data VALUES (31160, 758, 103199, 2, 597, 132, 27);
INSERT INTO public.who_global_data VALUES (31161, 161, 46251, 0, 1063, 132, 54);
INSERT INTO public.who_global_data VALUES (31162, 0, 23, 0, 0, 132, 226);
INSERT INTO public.who_global_data VALUES (31163, 29, 1654, 0, 36, 132, 79);
INSERT INTO public.who_global_data VALUES (31164, 1280, 35228, 7, 340, 132, 56);
INSERT INTO public.who_global_data VALUES (31165, 4, 1558, 0, 35, 132, 117);
INSERT INTO public.who_global_data VALUES (31166, 0, 1338, 0, 82, 132, 152);
INSERT INTO public.who_global_data VALUES (31167, 536, 32364, 21, 520, 132, 16);
INSERT INTO public.who_global_data VALUES (31168, 0, 119, 0, 1, 132, 10);
INSERT INTO public.who_global_data VALUES (31169, 91, 4381, 2, 92, 132, 201);
INSERT INTO public.who_global_data VALUES (31170, 78, 8311, 0, 124, 132, 174);
INSERT INTO public.who_global_data VALUES (31171, 36, 16257, 1, 229, 132, 119);
INSERT INTO public.who_global_data VALUES (31172, 2, 5766, 0, 179, 132, 168);
INSERT INTO public.who_global_data VALUES (31173, 82, 10769, 0, 133, 132, 99);
INSERT INTO public.who_global_data VALUES (31174, 31, 10045, 0, 34, 132, 171);
INSERT INTO public.who_global_data VALUES (31175, 16, 3080, 0, 130, 132, 87);
INSERT INTO public.who_global_data VALUES (31176, 21, 2980, 1, 31, 132, 123);
INSERT INTO public.who_global_data VALUES (31177, 0, 0, 0, 0, 132, 151);
INSERT INTO public.who_global_data VALUES (31178, 8, 1298, 0, 20, 132, 213);
INSERT INTO public.who_global_data VALUES (31179, 5, 7462, 0, 161, 132, 118);
INSERT INTO public.who_global_data VALUES (31180, 0, 367, 0, 10, 132, 134);
INSERT INTO public.who_global_data VALUES (31181, 0, 3541, 0, 40, 132, 65);
INSERT INTO public.who_global_data VALUES (31182, 5401, 720858, 405, 75844, 132, 102);
INSERT INTO public.who_global_data VALUES (31183, 0, 0, 0, 0, 132, 223);
INSERT INTO public.who_global_data VALUES (31184, 0, 213, 0, 2, 132, 4);
INSERT INTO public.who_global_data VALUES (31185, 0, 313, 0, 0, 132, 146);
INSERT INTO public.who_global_data VALUES (31186, 212, 10569, 0, 158, 132, 31);
INSERT INTO public.who_global_data VALUES (31187, 0, 13, 0, 1, 132, 127);
INSERT INTO public.who_global_data VALUES (31188, 2719, 115241, 43, 2041, 132, 22);
INSERT INTO public.who_global_data VALUES (31189, 168, 7757, 1, 54, 132, 115);
INSERT INTO public.who_global_data VALUES (31190, 879, 9991, 24, 198, 132, 106);
INSERT INTO public.who_global_data VALUES (31191, 83, 10918, 1, 120, 132, 90);
INSERT INTO public.who_global_data VALUES (31192, 0, 0, 0, 0, 132, 70);
INSERT INTO public.who_global_data VALUES (31193, 1207, 71821, 8, 467, 132, 46);
INSERT INTO public.who_global_data VALUES (31194, 2701, 108436, 38, 6365, 132, 139);
INSERT INTO public.who_global_data VALUES (31195, 0, 27, 0, 0, 132, 42);
INSERT INTO public.who_global_data VALUES (31196, 2, 1477, 0, 25, 132, 80);
INSERT INTO public.who_global_data VALUES (31197, 0, 4065, 0, 149, 132, 203);
INSERT INTO public.who_global_data VALUES (31198, 0, 1194, 0, 69, 132, 136);
INSERT INTO public.who_global_data VALUES (31199, 136, 58198, 3, 1106, 132, 63);
INSERT INTO public.who_global_data VALUES (31200, 0, 0, 0, 0, 132, 17);
INSERT INTO public.who_global_data VALUES (31201, 1, 70, 0, 2, 132, 172);
INSERT INTO public.who_global_data VALUES (31202, 0, 17343, 0, 721, 132, 109);
INSERT INTO public.who_global_data VALUES (31203, 0, 13406, 0, 270, 132, 200);
INSERT INTO public.who_global_data VALUES (31204, 290, 48572, 7, 334, 132, 93);
INSERT INTO public.who_global_data VALUES (31205, 0, 95907, 0, 885, 132, 5);
INSERT INTO public.who_global_data VALUES (31206, 0, 741, 0, 13, 132, 214);
INSERT INTO public.who_global_data VALUES (31207, 694, 310275, 6, 6457, 132, 204);
INSERT INTO public.who_global_data VALUES (31208, 0, 0, 0, 0, 132, 198);
INSERT INTO public.who_global_data VALUES (31209, 705, 109431, 14, 2311, 132, 173);
INSERT INTO public.who_global_data VALUES (31210, 1, 532, 0, 7, 132, 229);
INSERT INTO public.who_global_data VALUES (31211, 822, 37226, 18, 761, 132, 76);
INSERT INTO public.who_global_data VALUES (31212, 5654, 794584, 99, 32037, 132, 138);
INSERT INTO public.who_global_data VALUES (31213, 1895, 301256, 88, 5284, 132, 98);
INSERT INTO public.who_global_data VALUES (31214, 0, 0, 0, 0, 132, 103);
INSERT INTO public.who_global_data VALUES (31215, 1584, 85980, 32, 2424, 132, 225);
INSERT INTO public.who_global_data VALUES (31216, 884, 72939, 8, 1944, 132, 131);
INSERT INTO public.who_global_data VALUES (31217, 508, 45413, 7, 642, 132, 235);
INSERT INTO public.who_global_data VALUES (31218, 200, 124850, 2, 214, 132, 137);
INSERT INTO public.who_global_data VALUES (31219, 95, 23611, 2, 401, 132, 81);
INSERT INTO public.who_global_data VALUES (31220, 868, 50534, 15, 1279, 132, 182);
INSERT INTO public.who_global_data VALUES (31221, 0, 3685, 0, 11, 132, 145);
INSERT INTO public.who_global_data VALUES (31222, 1552, 121235, 54, 4687, 132, 26);
INSERT INTO public.who_global_data VALUES (31223, 7867, 1151438, 99, 20324, 132, 170);
INSERT INTO public.who_global_data VALUES (31224, 13, 4811, 0, 29, 132, 191);
INSERT INTO public.who_global_data VALUES (31225, 0, 5, 0, 0, 132, 221);
INSERT INTO public.who_global_data VALUES (31226, 3, 48, 0, 0, 132, 64);
INSERT INTO public.who_global_data VALUES (31227, 0, 0, 0, 0, 132, 116);
INSERT INTO public.who_global_data VALUES (31228, 0, 19, 0, 0, 132, 128);
INSERT INTO public.who_global_data VALUES (31229, 0, 27, 0, 0, 132, 6);
INSERT INTO public.who_global_data VALUES (31230, 16, 383, 0, 8, 132, 227);
INSERT INTO public.who_global_data VALUES (31231, 0, 12, 0, 0, 132, 68);
INSERT INTO public.who_global_data VALUES (31232, 0, 64, 0, 0, 132, 184);
INSERT INTO public.who_global_data VALUES (31233, 0, 0, 0, 0, 132, 82);
INSERT INTO public.who_global_data VALUES (31234, 0, 746, 0, 42, 132, 149);
INSERT INTO public.who_global_data VALUES (31235, 0, 911, 0, 15, 132, 197);
INSERT INTO public.who_global_data VALUES (31236, 461, 332790, 30, 4655, 132, 78);
INSERT INTO public.who_global_data VALUES (31237, 53, 14869, 2, 306, 132, 233);
INSERT INTO public.who_global_data VALUES (31238, 74, 33312, 0, 746, 132, 133);
INSERT INTO public.who_global_data VALUES (31239, 0, 141, 0, 0, 132, 35);
INSERT INTO public.who_global_data VALUES (31240, 9, 2208, 0, 72, 132, 114);
INSERT INTO public.who_global_data VALUES (31241, 20, 57685, 0, 27, 132, 237);
INSERT INTO public.who_global_data VALUES (31242, 0, 13, 0, 0, 132, 55);
INSERT INTO public.who_global_data VALUES (31243, 0, 618, 0, 22, 132, 176);
INSERT INTO public.who_global_data VALUES (31244, 552, 8600, 3, 44, 132, 202);
INSERT INTO public.who_global_data VALUES (31245, 158, 5351, 1, 152, 132, 155);
INSERT INTO public.who_global_data VALUES (31246, 0, 0, 0, 0, 132, 32);
INSERT INTO public.who_global_data VALUES (31247, 123, 3588, 1, 99, 132, 220);
INSERT INTO public.who_global_data VALUES (31248, 969, 669498, 64, 16376, 132, 30);
INSERT INTO public.who_global_data VALUES (31249, 10, 2686, 0, 49, 132, 147);
INSERT INTO public.who_global_data VALUES (31250, 13723, 780975, 127, 33417, 132, 208);
INSERT INTO public.who_global_data VALUES (31251, 4, 3349, 0, 13, 132, 45);
INSERT INTO public.who_global_data VALUES (31252, 4, 13610, 0, 836, 132, 110);
INSERT INTO public.who_global_data VALUES (31253, 28, 4817, 0, 102, 132, 88);
INSERT INTO public.who_global_data VALUES (31254, 630, 91666, 4, 5873, 132, 51);
INSERT INTO public.who_global_data VALUES (31255, 222, 52565, 2, 1815, 132, 209);
INSERT INTO public.who_global_data VALUES (31256, 37, 4038, 3, 188, 132, 205);
INSERT INTO public.who_global_data VALUES (31257, 43, 9605, 1, 75, 132, 18);
INSERT INTO public.who_global_data VALUES (31258, 1, 3523, 0, 59, 132, 72);
INSERT INTO public.who_global_data VALUES (31259, 6041, 429281, 35, 41971, 132, 44);
INSERT INTO public.who_global_data VALUES (31260, 0, 27, 0, 0, 132, 15);
INSERT INTO public.who_global_data VALUES (31261, 14, 1736, 2, 46, 132, 25);
INSERT INTO public.who_global_data VALUES (31262, 0, 0, 0, 0, 132, 179);
INSERT INTO public.who_global_data VALUES (31263, 0, 0, 0, 0, 132, 34);
INSERT INTO public.who_global_data VALUES (31264, 25, 4285, 1, 70, 132, 207);
INSERT INTO public.who_global_data VALUES (31265, 936, 16114, 7, 214, 132, 166);
INSERT INTO public.who_global_data VALUES (31266, 8241, 723496, 71, 7929, 132, 126);
INSERT INTO public.who_global_data VALUES (31267, 0, 0, 0, 0, 132, 97);
INSERT INTO public.who_global_data VALUES (31268, 1, 680, 0, 5, 132, 36);
INSERT INTO public.who_global_data VALUES (31269, 0, 0, 0, 0, 132, 125);
INSERT INTO public.who_global_data VALUES (31270, 146, 7364, 0, 71, 132, 124);
INSERT INTO public.who_global_data VALUES (31271, 3130, 198634, 56, 3959, 132, 185);
INSERT INTO public.who_global_data VALUES (31272, 1078, 90618, 2, 411, 132, 194);
INSERT INTO public.who_global_data VALUES (31273, 0, 509, 0, 21, 132, 144);
INSERT INTO public.who_global_data VALUES (31274, 50070, 6960152, 844, 202478, 132, 19);
INSERT INTO public.who_global_data VALUES (31275, 0, 1296, 0, 19, 132, 217);
INSERT INTO public.who_global_data VALUES (31276, 8, 1967, 0, 47, 132, 148);
INSERT INTO public.who_global_data VALUES (31277, 491, 54953, 4, 454, 132, 86);
INSERT INTO public.who_global_data VALUES (31278, 0, 0, 0, 0, 132, 13);
INSERT INTO public.who_global_data VALUES (31279, 867, 71273, 10, 591, 132, 157);
INSERT INTO public.who_global_data VALUES (31280, 0, 1069, 0, 35, 132, 8);
INSERT INTO public.who_global_data VALUES (31281, 0, 0, 0, 0, 132, 73);
INSERT INTO public.who_global_data VALUES (31282, 1, 2034, 0, 588, 132, 101);
INSERT INTO public.who_global_data VALUES (31283, 97, 14612, 0, 332, 132, 165);
INSERT INTO public.who_global_data VALUES (31284, 16, 7803, 0, 227, 132, 14);
INSERT INTO public.who_global_data VALUES (31285, 6, 39278, 2, 1457, 133, 193);
INSERT INTO public.who_global_data VALUES (31286, 124, 13045, 3, 373, 133, 113);
INSERT INTO public.who_global_data VALUES (31287, 354, 50754, 9, 1707, 133, 143);
INSERT INTO public.who_global_data VALUES (31288, 0, 0, 0, 0, 133, 219);
INSERT INTO public.who_global_data VALUES (31289, 83, 1836, 0, 53, 133, 186);
INSERT INTO public.who_global_data VALUES (31290, 115, 4590, 5, 167, 133, 52);
INSERT INTO public.who_global_data VALUES (31291, 0, 3, 0, 0, 133, 180);
INSERT INTO public.who_global_data VALUES (31292, 1, 98, 0, 3, 133, 167);
INSERT INTO public.who_global_data VALUES (31293, 13467, 678266, 390, 14766, 133, 154);
INSERT INTO public.who_global_data VALUES (31294, 429, 48385, 1, 943, 133, 94);
INSERT INTO public.who_global_data VALUES (31295, 35, 3756, 0, 25, 133, 66);
INSERT INTO public.who_global_data VALUES (31296, 17, 27000, 8, 869, 133, 58);
INSERT INTO public.who_global_data VALUES (31297, 1071, 42317, 3, 786, 133, 163);
INSERT INTO public.who_global_data VALUES (31298, 101, 39787, 2, 583, 133, 37);
INSERT INTO public.who_global_data VALUES (31299, 81, 3699, 6, 86, 133, 142);
INSERT INTO public.who_global_data VALUES (31300, 489, 68190, 5, 236, 133, 83);
INSERT INTO public.who_global_data VALUES (31301, 1383, 356767, 21, 5093, 133, 228);
INSERT INTO public.who_global_data VALUES (31302, 0, 189, 0, 7, 133, 188);
INSERT INTO public.who_global_data VALUES (31303, 306, 76957, 5, 807, 133, 62);
INSERT INTO public.who_global_data VALUES (31304, 1623, 115207, 5, 9968, 133, 160);
INSERT INTO public.who_global_data VALUES (31305, 52, 1758, 0, 22, 133, 50);
INSERT INTO public.who_global_data VALUES (31306, 0, 2325, 0, 40, 133, 33);
INSERT INTO public.who_global_data VALUES (31307, 0, 181, 0, 9, 133, 183);
INSERT INTO public.who_global_data VALUES (31308, 0, 263, 0, 0, 133, 92);
INSERT INTO public.who_global_data VALUES (31309, 628, 132618, 34, 7765, 133, 158);
INSERT INTO public.who_global_data VALUES (31310, 0, 67, 0, 1, 133, 67);
INSERT INTO public.who_global_data VALUES (31311, 247, 26560, 6, 801, 133, 57);
INSERT INTO public.who_global_data VALUES (31312, 0, 2921, 0, 13, 133, 38);
INSERT INTO public.who_global_data VALUES (31313, 32817, 4657702, 831, 139808, 133, 141);
INSERT INTO public.who_global_data VALUES (31314, 0, 71, 0, 1, 133, 178);
INSERT INTO public.who_global_data VALUES (31315, 0, 146, 0, 3, 133, 108);
INSERT INTO public.who_global_data VALUES (31316, 255, 19828, 4, 789, 133, 39);
INSERT INTO public.who_global_data VALUES (31317, 0, 1929, 0, 56, 133, 2);
INSERT INTO public.who_global_data VALUES (31318, 1, 484, 0, 1, 133, 195);
INSERT INTO public.who_global_data VALUES (31319, 149, 5628, 0, 55, 133, 107);
INSERT INTO public.who_global_data VALUES (31320, 0, 275, 0, 0, 133, 161);
INSERT INTO public.who_global_data VALUES (31321, 45, 20735, 2, 418, 133, 212);
INSERT INTO public.who_global_data VALUES (31322, 1341, 149094, 6, 9249, 133, 181);
INSERT INTO public.who_global_data VALUES (31323, 0, 210, 0, 1, 133, 53);
INSERT INTO public.who_global_data VALUES (31324, 2, 4806, 0, 62, 133, 164);
INSERT INTO public.who_global_data VALUES (31325, 4, 1175, 1, 83, 133, 140);
INSERT INTO public.who_global_data VALUES (31326, 2234, 453868, 58, 12527, 133, 20);
INSERT INTO public.who_global_data VALUES (31327, 18, 90951, 1, 4746, 133, 112);
INSERT INTO public.who_global_data VALUES (31328, 6555, 790823, 178, 24924, 133, 111);
INSERT INTO public.who_global_data VALUES (31329, 4, 474, 0, 7, 133, 71);
INSERT INTO public.who_global_data VALUES (31330, 0, 5005, 0, 89, 133, 218);
INSERT INTO public.who_global_data VALUES (31331, 0, 0, 0, 0, 133, 43);
INSERT INTO public.who_global_data VALUES (31332, 1400, 69459, 14, 795, 133, 49);
INSERT INTO public.who_global_data VALUES (31333, 55, 19556, 0, 120, 133, 1);
INSERT INTO public.who_global_data VALUES (31334, 223, 15795, 5, 266, 133, 48);
INSERT INTO public.who_global_data VALUES (31335, 40, 5350, 0, 118, 133, 232);
INSERT INTO public.who_global_data VALUES (31336, 14, 315, 0, 1, 133, 175);
INSERT INTO public.who_global_data VALUES (31337, 8, 1671, 0, 22, 133, 21);
INSERT INTO public.who_global_data VALUES (31338, 2944, 61318, 14, 581, 133, 156);
INSERT INTO public.who_global_data VALUES (31339, 0, 0, 0, 0, 133, 95);
INSERT INTO public.who_global_data VALUES (31340, 23, 10577, 0, 271, 133, 177);
INSERT INTO public.who_global_data VALUES (31341, 678, 25594, 2, 647, 133, 210);
INSERT INTO public.who_global_data VALUES (31342, 2, 5409, 0, 61, 133, 120);
INSERT INTO public.who_global_data VALUES (31343, 0, 24, 0, 0, 133, 135);
INSERT INTO public.who_global_data VALUES (31344, 475, 110597, 11, 2087, 133, 206);
INSERT INTO public.who_global_data VALUES (31345, 1329, 132475, 23, 11236, 133, 189);
INSERT INTO public.who_global_data VALUES (31346, 112, 102625, 18, 5853, 133, 129);
INSERT INTO public.who_global_data VALUES (31347, 214, 28415, 0, 823, 133, 121);
INSERT INTO public.who_global_data VALUES (31348, 0, 5018, 0, 83, 133, 59);
INSERT INTO public.who_global_data VALUES (31349, 0, 369, 0, 0, 133, 96);
INSERT INTO public.who_global_data VALUES (31350, 42, 3118, 0, 64, 133, 41);
INSERT INTO public.who_global_data VALUES (31351, 24, 5399, 0, 108, 133, 216);
INSERT INTO public.who_global_data VALUES (31352, 486, 72173, 7, 1155, 133, 236);
INSERT INTO public.who_global_data VALUES (31353, 0, 13, 0, 0, 133, 150);
INSERT INTO public.who_global_data VALUES (31354, 3, 458, 0, 0, 133, 61);
INSERT INTO public.who_global_data VALUES (31355, 0, 32, 0, 2, 133, 7);
INSERT INTO public.who_global_data VALUES (31356, 105, 9484, 0, 343, 133, 169);
INSERT INTO public.who_global_data VALUES (31357, 15572, 489772, 150, 31475, 133, 28);
INSERT INTO public.who_global_data VALUES (31358, 41, 9831, 0, 65, 133, 85);
INSERT INTO public.who_global_data VALUES (31359, 110, 1579, 1, 6, 133, 211);
INSERT INTO public.who_global_data VALUES (31360, 12, 8728, 0, 54, 133, 60);
INSERT INTO public.who_global_data VALUES (31361, 3, 3555, 0, 110, 133, 3);
INSERT INTO public.who_global_data VALUES (31362, 296, 4960, 1, 27, 133, 11);
INSERT INTO public.who_global_data VALUES (31363, 2507, 282730, 9, 9452, 133, 89);
INSERT INTO public.who_global_data VALUES (31364, 69, 46222, 0, 299, 133, 24);
INSERT INTO public.who_global_data VALUES (31365, 4, 361, 0, 0, 133, 162);
INSERT INTO public.who_global_data VALUES (31366, 286, 16913, 3, 369, 133, 100);
INSERT INTO public.who_global_data VALUES (31367, 0, 14, 0, 0, 133, 47);
INSERT INTO public.who_global_data VALUES (31368, 0, 24, 0, 0, 133, 29);
INSERT INTO public.who_global_data VALUES (31369, 0, 4487, 0, 42, 133, 40);
INSERT INTO public.who_global_data VALUES (31370, 23, 2286, 2, 41, 133, 222);
INSERT INTO public.who_global_data VALUES (31371, 945, 88878, 16, 3186, 133, 132);
INSERT INTO public.who_global_data VALUES (31372, 0, 256, 0, 13, 133, 130);
INSERT INTO public.who_global_data VALUES (31373, 0, 10478, 0, 65, 133, 234);
INSERT INTO public.who_global_data VALUES (31374, 0, 2324, 0, 39, 133, 23);
INSERT INTO public.who_global_data VALUES (31375, 44, 2579, 2, 71, 133, 192);
INSERT INTO public.who_global_data VALUES (31376, 38, 8684, 2, 227, 133, 69);
INSERT INTO public.who_global_data VALUES (31377, 0, 12, 0, 0, 133, 187);
INSERT INTO public.who_global_data VALUES (31378, 518, 73193, 27, 2249, 133, 230);
INSERT INTO public.who_global_data VALUES (31379, 950, 23077, 12, 730, 133, 77);
INSERT INTO public.who_global_data VALUES (31380, 49, 2561, 0, 10, 133, 9);
INSERT INTO public.who_global_data VALUES (31381, 85362, 5903932, 1089, 93379, 133, 74);
INSERT INTO public.who_global_data VALUES (31382, 4823, 266845, 113, 10218, 133, 224);
INSERT INTO public.who_global_data VALUES (31383, 3563, 439882, 207, 25222, 133, 199);
INSERT INTO public.who_global_data VALUES (31384, 4593, 341699, 68, 8867, 133, 190);
INSERT INTO public.who_global_data VALUES (31385, 321, 34315, 0, 1797, 133, 12);
INSERT INTO public.who_global_data VALUES (31386, 0, 340, 0, 24, 133, 104);
INSERT INTO public.who_global_data VALUES (31387, 8234, 214503, 31, 1417, 133, 153);
INSERT INTO public.who_global_data VALUES (31388, 1912, 306235, 20, 35801, 133, 91);
INSERT INTO public.who_global_data VALUES (31389, 135, 5723, 3, 80, 133, 215);
INSERT INTO public.who_global_data VALUES (31390, 558, 81055, 8, 1540, 133, 84);
INSERT INTO public.who_global_data VALUES (31391, 0, 399, 0, 32, 133, 231);
INSERT INTO public.who_global_data VALUES (31392, 620, 7279, 3, 39, 133, 196);
INSERT INTO public.who_global_data VALUES (31393, 293, 140175, 0, 2043, 133, 105);
INSERT INTO public.who_global_data VALUES (31394, 218, 37707, 13, 682, 133, 122);
INSERT INTO public.who_global_data VALUES (31395, 0, 0, 0, 0, 133, 159);
INSERT INTO public.who_global_data VALUES (31396, 46, 15336, 1, 607, 133, 75);
INSERT INTO public.who_global_data VALUES (31397, 590, 102441, 3, 595, 133, 27);
INSERT INTO public.who_global_data VALUES (31398, 158, 46090, 0, 1063, 133, 54);
INSERT INTO public.who_global_data VALUES (31399, 0, 23, 0, 0, 133, 226);
INSERT INTO public.who_global_data VALUES (31400, 31, 1625, 0, 36, 133, 79);
INSERT INTO public.who_global_data VALUES (31401, 1143, 33948, 4, 333, 133, 56);
INSERT INTO public.who_global_data VALUES (31402, 0, 1554, 0, 35, 133, 117);
INSERT INTO public.who_global_data VALUES (31403, 0, 1338, 0, 82, 133, 152);
INSERT INTO public.who_global_data VALUES (31404, 538, 31828, 8, 499, 133, 16);
INSERT INTO public.who_global_data VALUES (31405, 1, 119, 0, 1, 133, 10);
INSERT INTO public.who_global_data VALUES (31406, 111, 4290, 0, 90, 133, 201);
INSERT INTO public.who_global_data VALUES (31407, 75, 8233, 0, 124, 133, 174);
INSERT INTO public.who_global_data VALUES (31408, 30, 16221, 1, 228, 133, 119);
INSERT INTO public.who_global_data VALUES (31409, 17, 5764, 0, 179, 133, 168);
INSERT INTO public.who_global_data VALUES (31410, 111, 10687, 0, 133, 133, 99);
INSERT INTO public.who_global_data VALUES (31411, 75, 10014, 0, 34, 133, 171);
INSERT INTO public.who_global_data VALUES (31412, 23, 3064, 0, 130, 133, 87);
INSERT INTO public.who_global_data VALUES (31413, 29, 2959, 2, 30, 133, 123);
INSERT INTO public.who_global_data VALUES (31414, 0, 0, 0, 0, 133, 151);
INSERT INTO public.who_global_data VALUES (31415, 0, 1290, 0, 20, 133, 213);
INSERT INTO public.who_global_data VALUES (31416, 24, 7457, 0, 161, 133, 118);
INSERT INTO public.who_global_data VALUES (31417, 0, 367, 0, 10, 133, 134);
INSERT INTO public.who_global_data VALUES (31418, 0, 3541, 0, 40, 133, 65);
INSERT INTO public.who_global_data VALUES (31419, 5408, 715457, 490, 75439, 133, 102);
INSERT INTO public.who_global_data VALUES (31420, 0, 0, 0, 0, 133, 223);
INSERT INTO public.who_global_data VALUES (31421, 5, 213, 1, 2, 133, 4);
INSERT INTO public.who_global_data VALUES (31422, 0, 313, 0, 0, 133, 146);
INSERT INTO public.who_global_data VALUES (31423, 255, 10357, 2, 158, 133, 31);
INSERT INTO public.who_global_data VALUES (31424, 0, 13, 0, 1, 133, 127);
INSERT INTO public.who_global_data VALUES (31425, 2423, 112522, 42, 1998, 133, 22);
INSERT INTO public.who_global_data VALUES (31426, 190, 7589, 2, 53, 133, 115);
INSERT INTO public.who_global_data VALUES (31427, 597, 9112, 19, 174, 133, 106);
INSERT INTO public.who_global_data VALUES (31428, 95, 10835, 0, 119, 133, 90);
INSERT INTO public.who_global_data VALUES (31429, 0, 0, 0, 0, 133, 70);
INSERT INTO public.who_global_data VALUES (31430, 1313, 70614, 6, 459, 133, 46);
INSERT INTO public.who_global_data VALUES (31431, 2764, 105735, 16, 6327, 133, 139);
INSERT INTO public.who_global_data VALUES (31432, 1, 27, 0, 0, 133, 42);
INSERT INTO public.who_global_data VALUES (31433, 2, 1475, 0, 25, 133, 80);
INSERT INTO public.who_global_data VALUES (31434, 0, 4065, 0, 149, 133, 203);
INSERT INTO public.who_global_data VALUES (31435, 1, 1194, 0, 69, 133, 136);
INSERT INTO public.who_global_data VALUES (31436, 213, 58062, 1, 1103, 133, 63);
INSERT INTO public.who_global_data VALUES (31437, 0, 0, 0, 0, 133, 17);
INSERT INTO public.who_global_data VALUES (31438, 0, 69, 0, 2, 133, 172);
INSERT INTO public.who_global_data VALUES (31439, 143, 17343, 9, 721, 133, 109);
INSERT INTO public.who_global_data VALUES (31440, 131, 13406, 0, 270, 133, 200);
INSERT INTO public.who_global_data VALUES (31441, 452, 48282, 5, 327, 133, 93);
INSERT INTO public.who_global_data VALUES (31442, 0, 95907, 0, 885, 133, 5);
INSERT INTO public.who_global_data VALUES (31443, 0, 741, 0, 13, 133, 214);
INSERT INTO public.who_global_data VALUES (31444, 566, 309581, 7, 6451, 133, 204);
INSERT INTO public.who_global_data VALUES (31445, 0, 0, 0, 0, 133, 198);
INSERT INTO public.who_global_data VALUES (31446, 736, 108726, 6, 2297, 133, 173);
INSERT INTO public.who_global_data VALUES (31447, 0, 531, 0, 7, 133, 229);
INSERT INTO public.who_global_data VALUES (31448, 833, 36404, 16, 743, 133, 76);
INSERT INTO public.who_global_data VALUES (31449, 6235, 788930, 68, 31938, 133, 138);
INSERT INTO public.who_global_data VALUES (31450, 2606, 299361, 69, 5196, 133, 98);
INSERT INTO public.who_global_data VALUES (31451, 0, 0, 0, 0, 133, 103);
INSERT INTO public.who_global_data VALUES (31452, 1587, 84396, 23, 2392, 133, 225);
INSERT INTO public.who_global_data VALUES (31453, 899, 72055, 5, 1936, 133, 131);
INSERT INTO public.who_global_data VALUES (31454, 1063, 44905, 8, 635, 133, 235);
INSERT INTO public.who_global_data VALUES (31455, 225, 124650, 0, 212, 133, 137);
INSERT INTO public.who_global_data VALUES (31456, 61, 23516, 4, 399, 133, 81);
INSERT INTO public.who_global_data VALUES (31457, 713, 49666, 12, 1264, 133, 182);
INSERT INTO public.who_global_data VALUES (31458, 184, 3685, 0, 11, 133, 145);
INSERT INTO public.who_global_data VALUES (31459, 1629, 119683, 42, 4633, 133, 26);
INSERT INTO public.who_global_data VALUES (31460, 7523, 1143571, 169, 20225, 133, 170);
INSERT INTO public.who_global_data VALUES (31461, 9, 4798, 2, 29, 133, 191);
INSERT INTO public.who_global_data VALUES (31462, 0, 5, 0, 0, 133, 221);
INSERT INTO public.who_global_data VALUES (31463, 0, 45, 0, 0, 133, 64);
INSERT INTO public.who_global_data VALUES (31464, 0, 0, 0, 0, 133, 116);
INSERT INTO public.who_global_data VALUES (31465, 0, 19, 0, 0, 133, 128);
INSERT INTO public.who_global_data VALUES (31466, 0, 27, 0, 0, 133, 6);
INSERT INTO public.who_global_data VALUES (31467, 0, 367, 0, 8, 133, 227);
INSERT INTO public.who_global_data VALUES (31468, 0, 12, 0, 0, 133, 68);
INSERT INTO public.who_global_data VALUES (31469, 0, 64, 0, 0, 133, 184);
INSERT INTO public.who_global_data VALUES (31470, 0, 0, 0, 0, 133, 82);
INSERT INTO public.who_global_data VALUES (31471, 0, 746, 0, 42, 133, 149);
INSERT INTO public.who_global_data VALUES (31472, 1, 911, 0, 15, 133, 197);
INSERT INTO public.who_global_data VALUES (31473, 472, 332329, 26, 4625, 133, 78);
INSERT INTO public.who_global_data VALUES (31474, 0, 14816, 0, 304, 133, 233);
INSERT INTO public.who_global_data VALUES (31475, 75, 33238, 1, 746, 133, 133);
INSERT INTO public.who_global_data VALUES (31476, 2, 141, 0, 0, 133, 35);
INSERT INTO public.who_global_data VALUES (31477, 11, 2199, 0, 72, 133, 114);
INSERT INTO public.who_global_data VALUES (31478, 11, 57665, 0, 27, 133, 237);
INSERT INTO public.who_global_data VALUES (31479, 0, 13, 0, 0, 133, 55);
INSERT INTO public.who_global_data VALUES (31480, 2, 618, 1, 22, 133, 176);
INSERT INTO public.who_global_data VALUES (31481, 419, 8048, 0, 41, 133, 202);
INSERT INTO public.who_global_data VALUES (31482, 184, 5193, 1, 151, 133, 155);
INSERT INTO public.who_global_data VALUES (31483, 0, 0, 0, 0, 133, 32);
INSERT INTO public.who_global_data VALUES (31484, 0, 3465, 0, 98, 133, 220);
INSERT INTO public.who_global_data VALUES (31485, 1480, 668529, 29, 16312, 133, 30);
INSERT INTO public.who_global_data VALUES (31486, 0, 2676, 0, 49, 133, 147);
INSERT INTO public.who_global_data VALUES (31487, 12789, 767252, 131, 33290, 133, 208);
INSERT INTO public.who_global_data VALUES (31488, 12, 3345, 0, 13, 133, 45);
INSERT INTO public.who_global_data VALUES (31489, 2, 13606, 0, 836, 133, 110);
INSERT INTO public.who_global_data VALUES (31490, 10, 4789, 1, 102, 133, 88);
INSERT INTO public.who_global_data VALUES (31491, 540, 91036, 1, 5869, 133, 51);
INSERT INTO public.who_global_data VALUES (31492, 359, 52343, 1, 1813, 133, 209);
INSERT INTO public.who_global_data VALUES (31493, 35, 4001, 2, 185, 133, 205);
INSERT INTO public.who_global_data VALUES (31494, 42, 9562, 0, 74, 133, 18);
INSERT INTO public.who_global_data VALUES (31495, 3, 3522, 0, 59, 133, 72);
INSERT INTO public.who_global_data VALUES (31496, 6873, 423240, 34, 41936, 133, 44);
INSERT INTO public.who_global_data VALUES (31497, 0, 27, 0, 0, 133, 15);
INSERT INTO public.who_global_data VALUES (31498, 15, 1722, 0, 44, 133, 25);
INSERT INTO public.who_global_data VALUES (31499, 0, 0, 0, 0, 133, 179);
INSERT INTO public.who_global_data VALUES (31500, 0, 0, 0, 0, 133, 34);
INSERT INTO public.who_global_data VALUES (31501, 38, 4260, 2, 69, 133, 207);
INSERT INTO public.who_global_data VALUES (31502, 786, 15178, 16, 207, 133, 166);
INSERT INTO public.who_global_data VALUES (31503, 8395, 715255, 73, 7858, 133, 126);
INSERT INTO public.who_global_data VALUES (31504, 0, 0, 0, 0, 133, 97);
INSERT INTO public.who_global_data VALUES (31505, 3, 679, 0, 5, 133, 36);
INSERT INTO public.who_global_data VALUES (31506, 0, 0, 0, 0, 133, 125);
INSERT INTO public.who_global_data VALUES (31507, 154, 7218, 1, 71, 133, 124);
INSERT INTO public.who_global_data VALUES (31508, 3833, 195504, 76, 3903, 133, 185);
INSERT INTO public.who_global_data VALUES (31509, 1008, 89540, 2, 409, 133, 194);
INSERT INTO public.who_global_data VALUES (31510, 0, 509, 0, 21, 133, 144);
INSERT INTO public.who_global_data VALUES (31511, 41254, 6910082, 909, 201634, 133, 19);
INSERT INTO public.who_global_data VALUES (31512, 6, 1296, 0, 19, 133, 217);
INSERT INTO public.who_global_data VALUES (31513, 13, 1959, 0, 47, 133, 148);
INSERT INTO public.who_global_data VALUES (31514, 281, 54462, 2, 450, 133, 86);
INSERT INTO public.who_global_data VALUES (31515, 0, 0, 0, 0, 133, 13);
INSERT INTO public.who_global_data VALUES (31516, 967, 70406, 7, 581, 133, 157);
INSERT INTO public.who_global_data VALUES (31517, 0, 1069, 0, 35, 133, 8);
INSERT INTO public.who_global_data VALUES (31518, 0, 0, 0, 0, 133, 73);
INSERT INTO public.who_global_data VALUES (31519, 0, 2033, 1, 588, 133, 101);
INSERT INTO public.who_global_data VALUES (31520, 24, 14515, 0, 332, 133, 165);
INSERT INTO public.who_global_data VALUES (31521, 62, 7787, 0, 227, 133, 14);
INSERT INTO public.who_global_data VALUES (31522, 16, 39272, 0, 1455, 134, 193);
INSERT INTO public.who_global_data VALUES (31523, 134, 12921, 0, 370, 134, 113);
INSERT INTO public.who_global_data VALUES (31524, 0, 50400, 0, 1698, 134, 143);
INSERT INTO public.who_global_data VALUES (31525, 0, 0, 0, 0, 134, 219);
INSERT INTO public.who_global_data VALUES (31526, 0, 1753, 0, 53, 134, 186);
INSERT INTO public.who_global_data VALUES (31527, 112, 4475, 3, 162, 134, 52);
INSERT INTO public.who_global_data VALUES (31528, 0, 3, 0, 0, 134, 180);
INSERT INTO public.who_global_data VALUES (31529, 0, 97, 0, 3, 134, 167);
INSERT INTO public.who_global_data VALUES (31530, 12625, 664799, 424, 14376, 134, 154);
INSERT INTO public.who_global_data VALUES (31531, 392, 47956, 2, 942, 134, 94);
INSERT INTO public.who_global_data VALUES (31532, 56, 3721, 0, 25, 134, 66);
INSERT INTO public.who_global_data VALUES (31533, 10, 26983, 2, 861, 134, 58);
INSERT INTO public.who_global_data VALUES (31534, 688, 41246, 6, 783, 134, 163);
INSERT INTO public.who_global_data VALUES (31535, 162, 39686, 1, 581, 134, 37);
INSERT INTO public.who_global_data VALUES (31536, 151, 3618, 3, 80, 134, 142);
INSERT INTO public.who_global_data VALUES (31537, 687, 67701, 0, 231, 134, 83);
INSERT INTO public.who_global_data VALUES (31538, 1540, 355384, 28, 5072, 134, 228);
INSERT INTO public.who_global_data VALUES (31539, 0, 189, 0, 7, 134, 188);
INSERT INTO public.who_global_data VALUES (31540, 294, 76651, 6, 802, 134, 62);
INSERT INTO public.who_global_data VALUES (31541, 1795, 113584, 4, 9963, 134, 160);
INSERT INTO public.who_global_data VALUES (31542, 37, 1706, 1, 22, 134, 50);
INSERT INTO public.who_global_data VALUES (31543, 0, 2325, 0, 40, 134, 33);
INSERT INTO public.who_global_data VALUES (31544, 1, 181, 0, 9, 134, 183);
INSERT INTO public.who_global_data VALUES (31545, 2, 263, 0, 0, 134, 92);
INSERT INTO public.who_global_data VALUES (31546, 537, 131990, 38, 7731, 134, 158);
INSERT INTO public.who_global_data VALUES (31547, 7, 67, 0, 1, 134, 67);
INSERT INTO public.who_global_data VALUES (31548, 237, 26313, 12, 795, 134, 57);
INSERT INTO public.who_global_data VALUES (31549, 354, 2921, 0, 13, 134, 38);
INSERT INTO public.who_global_data VALUES (31550, 33281, 4624885, 869, 138977, 134, 141);
INSERT INTO public.who_global_data VALUES (31551, 0, 71, 0, 1, 134, 178);
INSERT INTO public.who_global_data VALUES (31552, 1, 146, 0, 3, 134, 108);
INSERT INTO public.who_global_data VALUES (31553, 290, 19573, 6, 785, 134, 39);
INSERT INTO public.who_global_data VALUES (31554, 22, 1929, 0, 56, 134, 2);
INSERT INTO public.who_global_data VALUES (31555, 6, 483, 0, 1, 134, 195);
INSERT INTO public.who_global_data VALUES (31556, 67, 5479, 1, 55, 134, 107);
INSERT INTO public.who_global_data VALUES (31557, 0, 275, 0, 0, 134, 161);
INSERT INTO public.who_global_data VALUES (31558, 0, 20690, 0, 416, 134, 212);
INSERT INTO public.who_global_data VALUES (31559, 1090, 147753, 9, 9243, 134, 181);
INSERT INTO public.who_global_data VALUES (31560, 0, 210, 0, 1, 134, 53);
INSERT INTO public.who_global_data VALUES (31561, 0, 4804, 0, 62, 134, 164);
INSERT INTO public.who_global_data VALUES (31562, 7, 1171, 0, 82, 134, 140);
INSERT INTO public.who_global_data VALUES (31563, 1731, 451634, 124, 12469, 134, 20);
INSERT INTO public.who_global_data VALUES (31564, 15, 90933, 0, 4745, 134, 112);
INSERT INTO public.who_global_data VALUES (31565, 6731, 784268, 176, 24746, 134, 111);
INSERT INTO public.who_global_data VALUES (31566, 0, 470, 0, 7, 134, 71);
INSERT INTO public.who_global_data VALUES (31567, 0, 5005, 0, 89, 134, 218);
INSERT INTO public.who_global_data VALUES (31568, 0, 0, 0, 0, 134, 43);
INSERT INTO public.who_global_data VALUES (31569, 1370, 68059, 21, 781, 134, 49);
INSERT INTO public.who_global_data VALUES (31570, 71, 19501, 0, 120, 134, 1);
INSERT INTO public.who_global_data VALUES (31571, 232, 15572, 4, 261, 134, 48);
INSERT INTO public.who_global_data VALUES (31572, 40, 5310, 0, 118, 134, 232);
INSERT INTO public.who_global_data VALUES (31573, 10, 301, 0, 1, 134, 175);
INSERT INTO public.who_global_data VALUES (31574, 9, 1663, 0, 22, 134, 21);
INSERT INTO public.who_global_data VALUES (31575, 2910, 58374, 12, 567, 134, 156);
INSERT INTO public.who_global_data VALUES (31576, 0, 0, 0, 0, 134, 95);
INSERT INTO public.who_global_data VALUES (31577, 18, 10554, 0, 271, 134, 177);
INSERT INTO public.who_global_data VALUES (31578, 559, 24916, 2, 645, 134, 210);
INSERT INTO public.who_global_data VALUES (31579, 0, 5407, 0, 61, 134, 120);
INSERT INTO public.who_global_data VALUES (31580, 0, 24, 0, 0, 134, 135);
INSERT INTO public.who_global_data VALUES (31581, 385, 110122, 2, 2076, 134, 206);
INSERT INTO public.who_global_data VALUES (31582, 1164, 131146, 42, 11213, 134, 189);
INSERT INTO public.who_global_data VALUES (31583, 138, 102513, 13, 5835, 134, 129);
INSERT INTO public.who_global_data VALUES (31584, 247, 28201, 4, 823, 134, 121);
INSERT INTO public.who_global_data VALUES (31585, 0, 5018, 0, 83, 134, 59);
INSERT INTO public.who_global_data VALUES (31586, 5, 369, 0, 0, 134, 96);
INSERT INTO public.who_global_data VALUES (31587, 43, 3076, 0, 64, 134, 41);
INSERT INTO public.who_global_data VALUES (31588, 32, 5375, 0, 108, 134, 216);
INSERT INTO public.who_global_data VALUES (31589, 604, 71687, 7, 1148, 134, 236);
INSERT INTO public.who_global_data VALUES (31590, 0, 13, 0, 0, 134, 150);
INSERT INTO public.who_global_data VALUES (31591, 4, 455, 0, 0, 134, 61);
INSERT INTO public.who_global_data VALUES (31592, 0, 32, 0, 2, 134, 7);
INSERT INTO public.who_global_data VALUES (31593, 91, 9379, 0, 343, 134, 169);
INSERT INTO public.who_global_data VALUES (31594, 16068, 474200, 52, 31325, 134, 28);
INSERT INTO public.who_global_data VALUES (31595, 28, 9790, 0, 65, 134, 85);
INSERT INTO public.who_global_data VALUES (31596, 0, 1469, 0, 5, 134, 211);
INSERT INTO public.who_global_data VALUES (31597, 0, 8716, 0, 54, 134, 60);
INSERT INTO public.who_global_data VALUES (31598, 0, 3552, 0, 110, 134, 3);
INSERT INTO public.who_global_data VALUES (31599, 265, 4664, 1, 26, 134, 11);
INSERT INTO public.who_global_data VALUES (31600, 2153, 280223, 15, 9443, 134, 89);
INSERT INTO public.who_global_data VALUES (31601, 37, 46153, 2, 299, 134, 24);
INSERT INTO public.who_global_data VALUES (31602, 2, 357, 0, 0, 134, 162);
INSERT INTO public.who_global_data VALUES (31603, 341, 16627, 9, 366, 134, 100);
INSERT INTO public.who_global_data VALUES (31604, 0, 14, 0, 0, 134, 47);
INSERT INTO public.who_global_data VALUES (31605, 0, 24, 0, 0, 134, 29);
INSERT INTO public.who_global_data VALUES (31606, 0, 4487, 0, 42, 134, 40);
INSERT INTO public.who_global_data VALUES (31607, 28, 2263, 1, 39, 134, 222);
INSERT INTO public.who_global_data VALUES (31608, 491, 87933, 16, 3170, 134, 132);
INSERT INTO public.who_global_data VALUES (31609, 0, 256, 0, 13, 134, 130);
INSERT INTO public.who_global_data VALUES (31610, 44, 10478, 0, 65, 134, 234);
INSERT INTO public.who_global_data VALUES (31611, 21, 2324, 0, 39, 134, 23);
INSERT INTO public.who_global_data VALUES (31612, 98, 2535, 1, 69, 134, 192);
INSERT INTO public.who_global_data VALUES (31613, 0, 8646, 0, 225, 134, 69);
INSERT INTO public.who_global_data VALUES (31614, 0, 12, 0, 0, 134, 187);
INSERT INTO public.who_global_data VALUES (31615, 369, 72675, 16, 2222, 134, 230);
INSERT INTO public.who_global_data VALUES (31616, 927, 22127, 9, 718, 134, 77);
INSERT INTO public.who_global_data VALUES (31617, 36, 2512, 0, 10, 134, 9);
INSERT INTO public.who_global_data VALUES (31618, 86052, 5818570, 1141, 92290, 134, 74);
INSERT INTO public.who_global_data VALUES (31619, 4634, 262022, 128, 10105, 134, 224);
INSERT INTO public.who_global_data VALUES (31620, 3521, 436319, 175, 25015, 134, 199);
INSERT INTO public.who_global_data VALUES (31621, 4471, 337106, 45, 8799, 134, 190);
INSERT INTO public.who_global_data VALUES (31622, 319, 33994, 3, 1797, 134, 12);
INSERT INTO public.who_global_data VALUES (31623, 0, 340, 0, 24, 134, 104);
INSERT INTO public.who_global_data VALUES (31624, 7125, 206269, 25, 1386, 134, 153);
INSERT INTO public.who_global_data VALUES (31625, 1786, 304323, 23, 35781, 134, 91);
INSERT INTO public.who_global_data VALUES (31626, 193, 5588, 1, 77, 134, 215);
INSERT INTO public.who_global_data VALUES (31627, 456, 80497, 12, 1532, 134, 84);
INSERT INTO public.who_global_data VALUES (31628, 1, 399, 0, 32, 134, 231);
INSERT INTO public.who_global_data VALUES (31629, 549, 6659, 1, 36, 134, 196);
INSERT INTO public.who_global_data VALUES (31630, 301, 139882, 0, 2043, 134, 105);
INSERT INTO public.who_global_data VALUES (31631, 141, 37489, 5, 669, 134, 122);
INSERT INTO public.who_global_data VALUES (31632, 0, 0, 0, 0, 134, 159);
INSERT INTO public.who_global_data VALUES (31633, 63, 15290, 0, 606, 134, 75);
INSERT INTO public.who_global_data VALUES (31634, 552, 101851, 2, 592, 134, 27);
INSERT INTO public.who_global_data VALUES (31635, 175, 45932, 0, 1063, 134, 54);
INSERT INTO public.who_global_data VALUES (31636, 0, 23, 0, 0, 134, 226);
INSERT INTO public.who_global_data VALUES (31637, 22, 1594, 0, 36, 134, 79);
INSERT INTO public.who_global_data VALUES (31638, 1027, 32805, 1, 329, 134, 56);
INSERT INTO public.who_global_data VALUES (31639, 47, 1554, 0, 35, 134, 117);
INSERT INTO public.who_global_data VALUES (31640, 1, 1338, 0, 82, 134, 152);
INSERT INTO public.who_global_data VALUES (31641, 658, 31290, 17, 491, 134, 16);
INSERT INTO public.who_global_data VALUES (31642, 1, 118, 0, 1, 134, 10);
INSERT INTO public.who_global_data VALUES (31643, 114, 4179, 0, 90, 134, 201);
INSERT INTO public.who_global_data VALUES (31644, 68, 8158, 0, 124, 134, 174);
INSERT INTO public.who_global_data VALUES (31645, 24, 16191, 1, 227, 134, 119);
INSERT INTO public.who_global_data VALUES (31646, 1, 5747, 0, 179, 134, 168);
INSERT INTO public.who_global_data VALUES (31647, 71, 10576, 0, 133, 134, 99);
INSERT INTO public.who_global_data VALUES (31648, 54, 9939, 0, 34, 134, 171);
INSERT INTO public.who_global_data VALUES (31649, 7, 3041, 0, 130, 134, 87);
INSERT INTO public.who_global_data VALUES (31650, 31, 2930, 2, 28, 134, 123);
INSERT INTO public.who_global_data VALUES (31651, 0, 0, 0, 0, 134, 151);
INSERT INTO public.who_global_data VALUES (31652, 0, 1290, 0, 20, 134, 213);
INSERT INTO public.who_global_data VALUES (31653, 8, 7433, 0, 161, 134, 118);
INSERT INTO public.who_global_data VALUES (31654, 0, 367, 0, 10, 134, 134);
INSERT INTO public.who_global_data VALUES (31655, 0, 3541, 0, 40, 134, 65);
INSERT INTO public.who_global_data VALUES (31656, 4786, 710049, 601, 74949, 134, 102);
INSERT INTO public.who_global_data VALUES (31657, 0, 0, 0, 0, 134, 223);
INSERT INTO public.who_global_data VALUES (31658, 6, 208, 0, 1, 134, 4);
INSERT INTO public.who_global_data VALUES (31659, 0, 313, 0, 0, 134, 146);
INSERT INTO public.who_global_data VALUES (31660, 196, 10102, 2, 156, 134, 31);
INSERT INTO public.who_global_data VALUES (31661, 0, 13, 0, 1, 134, 127);
INSERT INTO public.who_global_data VALUES (31662, 2356, 110099, 38, 1956, 134, 22);
INSERT INTO public.who_global_data VALUES (31663, 137, 7399, 2, 51, 134, 115);
INSERT INTO public.who_global_data VALUES (31664, 688, 8515, 25, 155, 134, 106);
INSERT INTO public.who_global_data VALUES (31665, 77, 10740, 2, 119, 134, 90);
INSERT INTO public.who_global_data VALUES (31666, 0, 0, 0, 0, 134, 70);
INSERT INTO public.who_global_data VALUES (31667, 1497, 69301, 17, 453, 134, 46);
INSERT INTO public.who_global_data VALUES (31668, 2537, 102971, 16, 6311, 134, 139);
INSERT INTO public.who_global_data VALUES (31669, 0, 26, 0, 0, 134, 42);
INSERT INTO public.who_global_data VALUES (31670, 2, 1473, 0, 25, 134, 80);
INSERT INTO public.who_global_data VALUES (31671, 0, 4065, 0, 149, 134, 203);
INSERT INTO public.who_global_data VALUES (31672, 0, 1193, 0, 69, 134, 136);
INSERT INTO public.who_global_data VALUES (31673, 125, 57849, 0, 1102, 134, 63);
INSERT INTO public.who_global_data VALUES (31674, 0, 0, 0, 0, 134, 17);
INSERT INTO public.who_global_data VALUES (31675, 0, 69, 0, 2, 134, 172);
INSERT INTO public.who_global_data VALUES (31676, 151, 17200, 2, 712, 134, 109);
INSERT INTO public.who_global_data VALUES (31677, 123, 13275, 3, 270, 134, 200);
INSERT INTO public.who_global_data VALUES (31678, 713, 47830, 5, 322, 134, 93);
INSERT INTO public.who_global_data VALUES (31679, 568, 95907, 10, 885, 134, 5);
INSERT INTO public.who_global_data VALUES (31680, 0, 741, 0, 13, 134, 214);
INSERT INTO public.who_global_data VALUES (31681, 798, 309015, 7, 6444, 134, 204);
INSERT INTO public.who_global_data VALUES (31682, 0, 0, 0, 0, 134, 198);
INSERT INTO public.who_global_data VALUES (31683, 706, 107990, 6, 2291, 134, 173);
INSERT INTO public.who_global_data VALUES (31684, 0, 531, 0, 7, 134, 229);
INSERT INTO public.who_global_data VALUES (31685, 743, 35571, 22, 727, 134, 76);
INSERT INTO public.who_global_data VALUES (31686, 6149, 782695, 302, 31870, 134, 138);
INSERT INTO public.who_global_data VALUES (31687, 2164, 296755, 36, 5127, 134, 98);
INSERT INTO public.who_global_data VALUES (31688, 0, 0, 0, 0, 134, 103);
INSERT INTO public.who_global_data VALUES (31689, 1136, 82809, 25, 2369, 134, 225);
INSERT INTO public.who_global_data VALUES (31690, 691, 71156, 3, 1931, 134, 131);
INSERT INTO public.who_global_data VALUES (31691, 1182, 43842, 10, 627, 134, 235);
INSERT INTO public.who_global_data VALUES (31692, 250, 124425, 0, 212, 134, 137);
INSERT INTO public.who_global_data VALUES (31693, 114, 23455, 2, 395, 134, 81);
INSERT INTO public.who_global_data VALUES (31694, 721, 48953, 8, 1252, 134, 182);
INSERT INTO public.who_global_data VALUES (31695, 0, 3501, 0, 11, 134, 145);
INSERT INTO public.who_global_data VALUES (31696, 1639, 118054, 41, 4591, 134, 26);
INSERT INTO public.who_global_data VALUES (31697, 7212, 1136048, 108, 20056, 134, 170);
INSERT INTO public.who_global_data VALUES (31698, 10, 4789, 0, 27, 134, 191);
INSERT INTO public.who_global_data VALUES (31699, 0, 5, 0, 0, 134, 221);
INSERT INTO public.who_global_data VALUES (31700, 0, 45, 0, 0, 134, 64);
INSERT INTO public.who_global_data VALUES (31701, 0, 0, 0, 0, 134, 116);
INSERT INTO public.who_global_data VALUES (31702, 0, 19, 0, 0, 134, 128);
INSERT INTO public.who_global_data VALUES (31703, 0, 27, 0, 0, 134, 6);
INSERT INTO public.who_global_data VALUES (31704, 0, 367, 0, 8, 134, 227);
INSERT INTO public.who_global_data VALUES (31705, 0, 12, 0, 0, 134, 68);
INSERT INTO public.who_global_data VALUES (31706, 0, 64, 0, 0, 134, 184);
INSERT INTO public.who_global_data VALUES (31707, 0, 0, 0, 0, 134, 82);
INSERT INTO public.who_global_data VALUES (31708, 0, 746, 0, 42, 134, 149);
INSERT INTO public.who_global_data VALUES (31709, 2, 910, 0, 15, 134, 197);
INSERT INTO public.who_global_data VALUES (31710, 498, 331857, 30, 4599, 134, 78);
INSERT INTO public.who_global_data VALUES (31711, 21, 14816, 1, 304, 134, 233);
INSERT INTO public.who_global_data VALUES (31712, 83, 33163, 1, 745, 134, 133);
INSERT INTO public.who_global_data VALUES (31713, 0, 139, 0, 0, 134, 35);
INSERT INTO public.who_global_data VALUES (31714, 5, 2188, 0, 72, 134, 114);
INSERT INTO public.who_global_data VALUES (31715, 15, 57654, 0, 27, 134, 237);
INSERT INTO public.who_global_data VALUES (31716, 0, 13, 0, 0, 134, 55);
INSERT INTO public.who_global_data VALUES (31717, 22, 616, 1, 21, 134, 176);
INSERT INTO public.who_global_data VALUES (31718, 360, 7629, 0, 41, 134, 202);
INSERT INTO public.who_global_data VALUES (31719, 193, 5009, 1, 150, 134, 155);
INSERT INTO public.who_global_data VALUES (31720, 0, 0, 0, 0, 134, 32);
INSERT INTO public.who_global_data VALUES (31721, 0, 3465, 0, 98, 134, 220);
INSERT INTO public.who_global_data VALUES (31722, 1861, 667049, 77, 16283, 134, 30);
INSERT INTO public.who_global_data VALUES (31723, 7, 2676, 0, 49, 134, 147);
INSERT INTO public.who_global_data VALUES (31724, 12911, 754463, 111, 33159, 134, 208);
INSERT INTO public.who_global_data VALUES (31725, 9, 3333, 0, 13, 134, 45);
INSERT INTO public.who_global_data VALUES (31726, 12, 13604, 0, 836, 134, 110);
INSERT INTO public.who_global_data VALUES (31727, 20, 4779, 1, 101, 134, 88);
INSERT INTO public.who_global_data VALUES (31728, 553, 90496, 0, 5868, 134, 51);
INSERT INTO public.who_global_data VALUES (31729, 308, 51984, 3, 1812, 134, 209);
INSERT INTO public.who_global_data VALUES (31730, 42, 3966, 2, 183, 134, 205);
INSERT INTO public.who_global_data VALUES (31731, 45, 9520, 0, 74, 134, 18);
INSERT INTO public.who_global_data VALUES (31732, 3, 3519, 0, 59, 134, 72);
INSERT INTO public.who_global_data VALUES (31733, 6634, 416367, 40, 41902, 134, 44);
INSERT INTO public.who_global_data VALUES (31734, 0, 27, 0, 0, 134, 15);
INSERT INTO public.who_global_data VALUES (31735, 6, 1707, 3, 44, 134, 25);
INSERT INTO public.who_global_data VALUES (31736, 0, 0, 0, 0, 134, 179);
INSERT INTO public.who_global_data VALUES (31737, 0, 0, 0, 0, 134, 34);
INSERT INTO public.who_global_data VALUES (31738, 176, 4222, 0, 67, 134, 207);
INSERT INTO public.who_global_data VALUES (31739, 1087, 14392, 11, 191, 134, 166);
INSERT INTO public.who_global_data VALUES (31740, 8451, 706860, 74, 7785, 134, 126);
INSERT INTO public.who_global_data VALUES (31741, 0, 0, 0, 0, 134, 97);
INSERT INTO public.who_global_data VALUES (31742, 4, 676, 0, 5, 134, 36);
INSERT INTO public.who_global_data VALUES (31743, 0, 0, 0, 0, 134, 125);
INSERT INTO public.who_global_data VALUES (31744, 185, 7064, 1, 70, 134, 124);
INSERT INTO public.who_global_data VALUES (31745, 3565, 191671, 70, 3827, 134, 185);
INSERT INTO public.who_global_data VALUES (31746, 1002, 88532, 1, 407, 134, 194);
INSERT INTO public.who_global_data VALUES (31747, 0, 509, 0, 21, 134, 144);
INSERT INTO public.who_global_data VALUES (31748, 40043, 6868828, 1125, 200725, 134, 19);
INSERT INTO public.who_global_data VALUES (31749, 12, 1290, 0, 19, 134, 217);
INSERT INTO public.who_global_data VALUES (31750, 12, 1946, 1, 47, 134, 148);
INSERT INTO public.who_global_data VALUES (31751, 514, 54181, 3, 448, 134, 86);
INSERT INTO public.who_global_data VALUES (31752, 0, 0, 0, 0, 134, 13);
INSERT INTO public.who_global_data VALUES (31753, 986, 69439, 10, 574, 134, 157);
INSERT INTO public.who_global_data VALUES (31754, 0, 1069, 0, 35, 134, 8);
INSERT INTO public.who_global_data VALUES (31755, 0, 0, 0, 0, 134, 73);
INSERT INTO public.who_global_data VALUES (31756, 0, 2033, 0, 587, 134, 101);
INSERT INTO public.who_global_data VALUES (31757, 48, 14491, 0, 332, 134, 165);
INSERT INTO public.who_global_data VALUES (31758, 0, 7725, 0, 227, 134, 14);
INSERT INTO public.who_global_data VALUES (31759, 25, 39256, 5, 1455, 135, 193);
INSERT INTO public.who_global_data VALUES (31760, 121, 12787, 3, 370, 135, 113);
INSERT INTO public.who_global_data VALUES (31761, 186, 50400, 9, 1698, 135, 143);
INSERT INTO public.who_global_data VALUES (31762, 0, 0, 0, 0, 135, 219);
INSERT INTO public.who_global_data VALUES (31763, 72, 1753, 0, 53, 135, 186);
INSERT INTO public.who_global_data VALUES (31764, 127, 4363, 4, 159, 135, 52);
INSERT INTO public.who_global_data VALUES (31765, 0, 3, 0, 0, 135, 180);
INSERT INTO public.who_global_data VALUES (31766, 1, 97, 0, 3, 135, 167);
INSERT INTO public.who_global_data VALUES (31767, 12027, 652174, 470, 13952, 135, 154);
INSERT INTO public.who_global_data VALUES (31768, 374, 47564, 3, 940, 135, 94);
INSERT INTO public.who_global_data VALUES (31769, 78, 3665, 1, 25, 135, 66);
INSERT INTO public.who_global_data VALUES (31770, 31, 26973, 5, 859, 135, 58);
INSERT INTO public.who_global_data VALUES (31771, 661, 40558, 6, 777, 135, 163);
INSERT INTO public.who_global_data VALUES (31772, 146, 39524, 2, 580, 135, 37);
INSERT INTO public.who_global_data VALUES (31773, 49, 3467, 2, 77, 135, 142);
INSERT INTO public.who_global_data VALUES (31774, 612, 67014, 4, 231, 135, 83);
INSERT INTO public.who_global_data VALUES (31775, 1666, 353844, 37, 5044, 135, 228);
INSERT INTO public.who_global_data VALUES (31776, 0, 189, 0, 7, 135, 188);
INSERT INTO public.who_global_data VALUES (31777, 253, 76357, 5, 796, 135, 62);
INSERT INTO public.who_global_data VALUES (31778, 2096, 111789, 8, 9959, 135, 160);
INSERT INTO public.who_global_data VALUES (31779, 34, 1669, 0, 21, 135, 50);
INSERT INTO public.who_global_data VALUES (31780, 0, 2325, 0, 40, 135, 33);
INSERT INTO public.who_global_data VALUES (31781, 0, 180, 0, 9, 135, 183);
INSERT INTO public.who_global_data VALUES (31782, 0, 261, 0, 0, 135, 92);
INSERT INTO public.who_global_data VALUES (31783, 467, 131453, 39, 7693, 135, 158);
INSERT INTO public.who_global_data VALUES (31784, 8, 60, 0, 1, 135, 67);
INSERT INTO public.who_global_data VALUES (31785, 344, 26076, 12, 783, 135, 57);
INSERT INTO public.who_global_data VALUES (31786, 0, 2567, 0, 13, 135, 38);
INSERT INTO public.who_global_data VALUES (31787, 33536, 4591604, 836, 138108, 135, 141);
INSERT INTO public.who_global_data VALUES (31788, 0, 71, 0, 1, 135, 178);
INSERT INTO public.who_global_data VALUES (31789, 0, 145, 0, 3, 135, 108);
INSERT INTO public.who_global_data VALUES (31790, 160, 19283, 12, 779, 135, 39);
INSERT INTO public.who_global_data VALUES (31791, 11, 1907, 0, 56, 135, 2);
INSERT INTO public.who_global_data VALUES (31792, 1, 477, 0, 1, 135, 195);
INSERT INTO public.who_global_data VALUES (31793, 75, 5412, 2, 54, 135, 107);
INSERT INTO public.who_global_data VALUES (31794, 0, 275, 0, 0, 135, 161);
INSERT INTO public.who_global_data VALUES (31795, 0, 20690, 0, 416, 135, 212);
INSERT INTO public.who_global_data VALUES (31796, 1248, 146663, 6, 9234, 135, 181);
INSERT INTO public.who_global_data VALUES (31797, 0, 210, 0, 1, 135, 53);
INSERT INTO public.who_global_data VALUES (31798, 2, 4804, 0, 62, 135, 164);
INSERT INTO public.who_global_data VALUES (31799, 9, 1164, 1, 82, 135, 140);
INSERT INTO public.who_global_data VALUES (31800, 1380, 449903, 24, 12345, 135, 20);
INSERT INTO public.who_global_data VALUES (31801, 10, 90918, 1, 4745, 135, 112);
INSERT INTO public.who_global_data VALUES (31802, 7102, 777537, 173, 24570, 135, 111);
INSERT INTO public.who_global_data VALUES (31803, 0, 470, 0, 7, 135, 71);
INSERT INTO public.who_global_data VALUES (31804, 0, 5005, 0, 89, 135, 218);
INSERT INTO public.who_global_data VALUES (31805, 0, 0, 0, 0, 135, 43);
INSERT INTO public.who_global_data VALUES (31806, 1087, 66689, 15, 760, 135, 49);
INSERT INTO public.who_global_data VALUES (31807, 103, 19430, 0, 120, 135, 1);
INSERT INTO public.who_global_data VALUES (31808, 204, 15340, 2, 257, 135, 48);
INSERT INTO public.who_global_data VALUES (31809, 48, 5270, 1, 118, 135, 232);
INSERT INTO public.who_global_data VALUES (31810, 9, 291, 0, 1, 135, 175);
INSERT INTO public.who_global_data VALUES (31811, 36, 1654, 0, 22, 135, 21);
INSERT INTO public.who_global_data VALUES (31812, 2306, 55464, 24, 555, 135, 156);
INSERT INTO public.who_global_data VALUES (31813, 0, 0, 0, 0, 135, 95);
INSERT INTO public.who_global_data VALUES (31814, 14, 10536, 0, 271, 135, 177);
INSERT INTO public.who_global_data VALUES (31815, 558, 24357, 2, 643, 135, 210);
INSERT INTO public.who_global_data VALUES (31816, 0, 5407, 0, 61, 135, 120);
INSERT INTO public.who_global_data VALUES (31817, 0, 24, 0, 0, 135, 135);
INSERT INTO public.who_global_data VALUES (31818, 468, 109737, 10, 2074, 135, 206);
INSERT INTO public.who_global_data VALUES (31819, 2339, 129982, 45, 11171, 135, 189);
INSERT INTO public.who_global_data VALUES (31820, 121, 102375, 16, 5822, 135, 129);
INSERT INTO public.who_global_data VALUES (31821, 156, 27954, 5, 819, 135, 121);
INSERT INTO public.who_global_data VALUES (31822, 0, 5018, 0, 83, 135, 59);
INSERT INTO public.who_global_data VALUES (31823, 0, 364, 0, 0, 135, 96);
INSERT INTO public.who_global_data VALUES (31824, 57, 3033, 0, 64, 135, 41);
INSERT INTO public.who_global_data VALUES (31825, 36, 5343, 2, 108, 135, 216);
INSERT INTO public.who_global_data VALUES (31826, 661, 71083, 14, 1141, 135, 236);
INSERT INTO public.who_global_data VALUES (31827, 0, 13, 0, 0, 135, 150);
INSERT INTO public.who_global_data VALUES (31828, 3, 451, 0, 0, 135, 61);
INSERT INTO public.who_global_data VALUES (31829, 0, 32, 0, 2, 135, 7);
INSERT INTO public.who_global_data VALUES (31830, 93, 9288, 2, 343, 135, 169);
INSERT INTO public.who_global_data VALUES (31831, 12730, 458132, 39, 31273, 135, 28);
INSERT INTO public.who_global_data VALUES (31832, 24, 9762, 0, 65, 135, 85);
INSERT INTO public.who_global_data VALUES (31833, 75, 1469, 0, 5, 135, 211);
INSERT INTO public.who_global_data VALUES (31834, 12, 8716, 0, 54, 135, 60);
INSERT INTO public.who_global_data VALUES (31835, 12, 3552, 0, 110, 135, 3);
INSERT INTO public.who_global_data VALUES (31836, 259, 4399, 1, 25, 135, 11);
INSERT INTO public.who_global_data VALUES (31837, 2143, 278070, 19, 9428, 135, 89);
INSERT INTO public.who_global_data VALUES (31838, 54, 46116, 0, 297, 135, 24);
INSERT INTO public.who_global_data VALUES (31839, 5, 355, 0, 0, 135, 162);
INSERT INTO public.who_global_data VALUES (31840, 358, 16286, 5, 357, 135, 100);
INSERT INTO public.who_global_data VALUES (31841, 0, 14, 0, 0, 135, 47);
INSERT INTO public.who_global_data VALUES (31842, 0, 24, 0, 0, 135, 29);
INSERT INTO public.who_global_data VALUES (31843, 0, 4487, 0, 42, 135, 40);
INSERT INTO public.who_global_data VALUES (31844, 45, 2235, 1, 38, 135, 222);
INSERT INTO public.who_global_data VALUES (31845, 819, 87442, 17, 3154, 135, 132);
INSERT INTO public.who_global_data VALUES (31846, 0, 256, 0, 13, 135, 130);
INSERT INTO public.who_global_data VALUES (31847, 47, 10434, 0, 65, 135, 234);
INSERT INTO public.who_global_data VALUES (31848, 0, 2303, 0, 39, 135, 23);
INSERT INTO public.who_global_data VALUES (31849, 35, 2437, 1, 68, 135, 192);
INSERT INTO public.who_global_data VALUES (31850, 22, 8646, 4, 225, 135, 69);
INSERT INTO public.who_global_data VALUES (31851, 0, 12, 0, 0, 135, 187);
INSERT INTO public.who_global_data VALUES (31852, 231, 72306, 2, 2206, 135, 230);
INSERT INTO public.who_global_data VALUES (31853, 750, 21200, 7, 709, 135, 77);
INSERT INTO public.who_global_data VALUES (31854, 57, 2476, 0, 10, 135, 9);
INSERT INTO public.who_global_data VALUES (31855, 86508, 5732518, 1129, 91149, 135, 74);
INSERT INTO public.who_global_data VALUES (31856, 4465, 257388, 140, 9977, 135, 224);
INSERT INTO public.who_global_data VALUES (31857, 3605, 432798, 184, 24840, 135, 199);
INSERT INTO public.who_global_data VALUES (31858, 5055, 332635, 72, 8754, 135, 190);
INSERT INTO public.who_global_data VALUES (31859, 231, 33675, 2, 1794, 135, 12);
INSERT INTO public.who_global_data VALUES (31860, 0, 340, 0, 24, 135, 104);
INSERT INTO public.who_global_data VALUES (31861, 7021, 199144, 26, 1361, 135, 153);
INSERT INTO public.who_global_data VALUES (31862, 1640, 302537, 20, 35758, 135, 91);
INSERT INTO public.who_global_data VALUES (31863, 125, 5395, 1, 76, 135, 215);
INSERT INTO public.who_global_data VALUES (31864, 273, 80041, 8, 1520, 135, 84);
INSERT INTO public.who_global_data VALUES (31865, 2, 398, 0, 32, 135, 231);
INSERT INTO public.who_global_data VALUES (31866, 363, 6110, 2, 35, 135, 196);
INSERT INTO public.who_global_data VALUES (31867, 292, 139581, 0, 2043, 135, 105);
INSERT INTO public.who_global_data VALUES (31868, 130, 37348, 5, 664, 135, 122);
INSERT INTO public.who_global_data VALUES (31869, 0, 0, 0, 0, 135, 159);
INSERT INTO public.who_global_data VALUES (31870, 62, 15227, 1, 606, 135, 75);
INSERT INTO public.who_global_data VALUES (31871, 616, 101299, 2, 590, 135, 27);
INSERT INTO public.who_global_data VALUES (31872, 127, 45757, 0, 1063, 135, 54);
INSERT INTO public.who_global_data VALUES (31873, 0, 23, 0, 0, 135, 226);
INSERT INTO public.who_global_data VALUES (31874, 12, 1572, 0, 36, 135, 79);
INSERT INTO public.who_global_data VALUES (31875, 940, 31778, 13, 328, 135, 56);
INSERT INTO public.who_global_data VALUES (31876, 117, 1507, 2, 35, 135, 117);
INSERT INTO public.who_global_data VALUES (31877, 1, 1337, 0, 82, 135, 152);
INSERT INTO public.who_global_data VALUES (31878, 535, 30632, 5, 474, 135, 16);
INSERT INTO public.who_global_data VALUES (31879, 0, 117, 0, 1, 135, 10);
INSERT INTO public.who_global_data VALUES (31880, 138, 4065, 2, 90, 135, 201);
INSERT INTO public.who_global_data VALUES (31881, 74, 8090, 0, 124, 135, 174);
INSERT INTO public.who_global_data VALUES (31882, 31, 16167, 0, 226, 135, 119);
INSERT INTO public.who_global_data VALUES (31883, 7, 5746, 0, 179, 135, 168);
INSERT INTO public.who_global_data VALUES (31884, 147, 10505, 3, 133, 135, 99);
INSERT INTO public.who_global_data VALUES (31885, 67, 9885, 0, 34, 135, 171);
INSERT INTO public.who_global_data VALUES (31886, 4, 3034, 1, 130, 135, 87);
INSERT INTO public.who_global_data VALUES (31887, 42, 2899, 1, 26, 135, 123);
INSERT INTO public.who_global_data VALUES (31888, 0, 0, 0, 0, 135, 151);
INSERT INTO public.who_global_data VALUES (31889, 168, 1290, 2, 20, 135, 213);
INSERT INTO public.who_global_data VALUES (31890, 22, 7425, 0, 161, 135, 118);
INSERT INTO public.who_global_data VALUES (31891, 0, 367, 0, 10, 135, 134);
INSERT INTO public.who_global_data VALUES (31892, 0, 3541, 0, 40, 135, 65);
INSERT INTO public.who_global_data VALUES (31893, 4683, 705263, 651, 74348, 135, 102);
INSERT INTO public.who_global_data VALUES (31894, 0, 0, 0, 0, 135, 223);
INSERT INTO public.who_global_data VALUES (31895, 2, 202, 0, 1, 135, 4);
INSERT INTO public.who_global_data VALUES (31896, 0, 313, 0, 0, 135, 146);
INSERT INTO public.who_global_data VALUES (31897, 279, 9906, 3, 154, 135, 31);
INSERT INTO public.who_global_data VALUES (31898, 0, 13, 0, 1, 135, 127);
INSERT INTO public.who_global_data VALUES (31899, 2397, 107743, 29, 1918, 135, 22);
INSERT INTO public.who_global_data VALUES (31900, 148, 7262, 4, 49, 135, 115);
INSERT INTO public.who_global_data VALUES (31901, 868, 7827, 14, 130, 135, 106);
INSERT INTO public.who_global_data VALUES (31902, 56, 10663, 1, 117, 135, 90);
INSERT INTO public.who_global_data VALUES (31903, 0, 0, 0, 0, 135, 70);
INSERT INTO public.who_global_data VALUES (31904, 1172, 67804, 7, 436, 135, 46);
INSERT INTO public.who_global_data VALUES (31905, 2335, 100434, 5, 6295, 135, 139);
INSERT INTO public.who_global_data VALUES (31906, 0, 26, 0, 0, 135, 42);
INSERT INTO public.who_global_data VALUES (31907, 3, 1471, 0, 25, 135, 80);
INSERT INTO public.who_global_data VALUES (31908, 0, 4065, 0, 149, 135, 203);
INSERT INTO public.who_global_data VALUES (31909, 4, 1193, 0, 69, 135, 136);
INSERT INTO public.who_global_data VALUES (31910, 111, 57724, 2, 1102, 135, 63);
INSERT INTO public.who_global_data VALUES (31911, 0, 0, 0, 0, 135, 17);
INSERT INTO public.who_global_data VALUES (31912, 0, 69, 0, 2, 135, 172);
INSERT INTO public.who_global_data VALUES (31913, 182, 17049, 5, 710, 135, 109);
INSERT INTO public.who_global_data VALUES (31914, 152, 13152, 0, 267, 135, 200);
INSERT INTO public.who_global_data VALUES (31915, 503, 47117, 3, 317, 135, 93);
INSERT INTO public.who_global_data VALUES (31916, 628, 95339, 10, 875, 135, 5);
INSERT INTO public.who_global_data VALUES (31917, 0, 741, 0, 13, 135, 214);
INSERT INTO public.who_global_data VALUES (31918, 799, 308217, 5, 6437, 135, 204);
INSERT INTO public.who_global_data VALUES (31919, 0, 0, 0, 0, 135, 198);
INSERT INTO public.who_global_data VALUES (31920, 474, 107284, 13, 2285, 135, 173);
INSERT INTO public.who_global_data VALUES (31921, 4, 531, 0, 7, 135, 229);
INSERT INTO public.who_global_data VALUES (31922, 568, 34828, 29, 705, 135, 76);
INSERT INTO public.who_global_data VALUES (31923, 3650, 776546, 94, 31568, 135, 138);
INSERT INTO public.who_global_data VALUES (31924, 2802, 294591, 42, 5091, 135, 98);
INSERT INTO public.who_global_data VALUES (31925, 0, 0, 0, 0, 135, 103);
INSERT INTO public.who_global_data VALUES (31926, 974, 81673, 28, 2344, 135, 225);
INSERT INTO public.who_global_data VALUES (31927, 802, 70465, 3, 1928, 135, 131);
INSERT INTO public.who_global_data VALUES (31928, 64, 42660, 4, 617, 135, 235);
INSERT INTO public.who_global_data VALUES (31929, 258, 124175, 1, 212, 135, 137);
INSERT INTO public.who_global_data VALUES (31930, 125, 23341, 5, 393, 135, 81);
INSERT INTO public.who_global_data VALUES (31931, 786, 48232, 14, 1244, 135, 182);
INSERT INTO public.who_global_data VALUES (31932, 86, 3501, 0, 11, 135, 145);
INSERT INTO public.who_global_data VALUES (31933, 1767, 116415, 47, 4550, 135, 26);
INSERT INTO public.who_global_data VALUES (31934, 6595, 1128836, 149, 19948, 135, 170);
INSERT INTO public.who_global_data VALUES (31935, 41, 4779, 0, 27, 135, 191);
INSERT INTO public.who_global_data VALUES (31936, 0, 5, 0, 0, 135, 221);
INSERT INTO public.who_global_data VALUES (31937, 22, 45, 0, 0, 135, 64);
INSERT INTO public.who_global_data VALUES (31938, 0, 0, 0, 0, 135, 116);
INSERT INTO public.who_global_data VALUES (31939, 0, 19, 0, 0, 135, 128);
INSERT INTO public.who_global_data VALUES (31940, 0, 27, 0, 0, 135, 6);
INSERT INTO public.who_global_data VALUES (31941, 37, 367, 2, 8, 135, 227);
INSERT INTO public.who_global_data VALUES (31942, 1, 12, 0, 0, 135, 68);
INSERT INTO public.who_global_data VALUES (31943, 0, 64, 0, 0, 135, 184);
INSERT INTO public.who_global_data VALUES (31944, 0, 0, 0, 0, 135, 82);
INSERT INTO public.who_global_data VALUES (31945, 4, 746, 0, 42, 135, 149);
INSERT INTO public.who_global_data VALUES (31946, 0, 908, 0, 15, 135, 197);
INSERT INTO public.who_global_data VALUES (31947, 561, 331359, 27, 4569, 135, 78);
INSERT INTO public.who_global_data VALUES (31948, 36, 14795, 1, 303, 135, 233);
INSERT INTO public.who_global_data VALUES (31949, 81, 33080, 1, 744, 135, 133);
INSERT INTO public.who_global_data VALUES (31950, 0, 139, 0, 0, 135, 35);
INSERT INTO public.who_global_data VALUES (31951, 9, 2183, 0, 72, 135, 114);
INSERT INTO public.who_global_data VALUES (31952, 12, 57639, 0, 27, 135, 237);
INSERT INTO public.who_global_data VALUES (31953, 1, 13, 0, 0, 135, 55);
INSERT INTO public.who_global_data VALUES (31954, 3, 594, 0, 20, 135, 176);
INSERT INTO public.who_global_data VALUES (31955, 338, 7269, 1, 41, 135, 202);
INSERT INTO public.who_global_data VALUES (31956, 121, 4816, 2, 149, 135, 155);
INSERT INTO public.who_global_data VALUES (31957, 0, 0, 0, 0, 135, 32);
INSERT INTO public.who_global_data VALUES (31958, 0, 3465, 0, 98, 135, 220);
INSERT INTO public.who_global_data VALUES (31959, 1906, 665188, 88, 16206, 135, 30);
INSERT INTO public.who_global_data VALUES (31960, 5, 2669, 0, 49, 135, 147);
INSERT INTO public.who_global_data VALUES (31961, 12947, 741552, 122, 33048, 135, 208);
INSERT INTO public.who_global_data VALUES (31962, 11, 3324, 0, 13, 135, 45);
INSERT INTO public.who_global_data VALUES (31963, 14, 13592, 0, 836, 135, 110);
INSERT INTO public.who_global_data VALUES (31964, 19, 4759, 3, 100, 135, 88);
INSERT INTO public.who_global_data VALUES (31965, 438, 89943, 1, 5868, 135, 51);
INSERT INTO public.who_global_data VALUES (31966, 389, 51676, 1, 1809, 135, 209);
INSERT INTO public.who_global_data VALUES (31967, 47, 3924, 3, 181, 135, 205);
INSERT INTO public.who_global_data VALUES (31968, 43, 9475, 1, 74, 135, 18);
INSERT INTO public.who_global_data VALUES (31969, 2, 3516, 0, 59, 135, 72);
INSERT INTO public.who_global_data VALUES (31970, 6178, 409733, 37, 41862, 135, 44);
INSERT INTO public.who_global_data VALUES (31971, 0, 27, 0, 0, 135, 15);
INSERT INTO public.who_global_data VALUES (31972, 18, 1701, 0, 41, 135, 25);
INSERT INTO public.who_global_data VALUES (31973, 0, 0, 0, 0, 135, 179);
INSERT INTO public.who_global_data VALUES (31974, 0, 0, 0, 0, 135, 34);
INSERT INTO public.who_global_data VALUES (31975, 72, 4046, 2, 67, 135, 207);
INSERT INTO public.who_global_data VALUES (31976, 826, 13305, 6, 180, 135, 166);
INSERT INTO public.who_global_data VALUES (31977, 8497, 698409, 72, 7711, 135, 126);
INSERT INTO public.who_global_data VALUES (31978, 0, 0, 0, 0, 135, 97);
INSERT INTO public.who_global_data VALUES (31979, 4, 672, 0, 5, 135, 36);
INSERT INTO public.who_global_data VALUES (31980, 0, 0, 0, 0, 135, 125);
INSERT INTO public.who_global_data VALUES (31981, 167, 6879, 5, 69, 135, 124);
INSERT INTO public.who_global_data VALUES (31982, 3372, 188106, 52, 3757, 135, 185);
INSERT INTO public.who_global_data VALUES (31983, 1083, 87530, 1, 406, 135, 194);
INSERT INTO public.who_global_data VALUES (31984, 0, 509, 0, 21, 135, 144);
INSERT INTO public.who_global_data VALUES (31985, 49176, 6828785, 807, 199600, 135, 19);
INSERT INTO public.who_global_data VALUES (31986, 2, 1278, 0, 19, 135, 217);
INSERT INTO public.who_global_data VALUES (31987, 7, 1934, 0, 46, 135, 148);
INSERT INTO public.who_global_data VALUES (31988, 616, 53667, 2, 445, 135, 86);
INSERT INTO public.who_global_data VALUES (31989, 0, 0, 0, 0, 135, 13);
INSERT INTO public.who_global_data VALUES (31990, 1010, 68453, 9, 564, 135, 157);
INSERT INTO public.who_global_data VALUES (31991, 1, 1069, 0, 35, 135, 8);
INSERT INTO public.who_global_data VALUES (31992, 0, 0, 0, 0, 135, 73);
INSERT INTO public.who_global_data VALUES (31993, 1, 2033, 0, 587, 135, 101);
INSERT INTO public.who_global_data VALUES (31994, 54, 14443, 1, 332, 135, 165);
INSERT INTO public.who_global_data VALUES (31995, 14, 7725, 1, 227, 135, 14);
INSERT INTO public.who_global_data VALUES (31996, 49, 39231, 1, 1450, 136, 193);
INSERT INTO public.who_global_data VALUES (31997, 131, 12666, 3, 367, 136, 113);
INSERT INTO public.who_global_data VALUES (31998, 191, 50214, 10, 1689, 136, 143);
INSERT INTO public.who_global_data VALUES (31999, 0, 0, 0, 0, 136, 219);
INSERT INTO public.who_global_data VALUES (32000, 0, 1681, 0, 53, 136, 186);
INSERT INTO public.who_global_data VALUES (32001, 245, 4236, 3, 155, 136, 52);
INSERT INTO public.who_global_data VALUES (32002, 0, 3, 0, 0, 136, 180);
INSERT INTO public.who_global_data VALUES (32003, 0, 96, 0, 3, 136, 167);
INSERT INTO public.who_global_data VALUES (32004, 8782, 640147, 429, 13482, 136, 154);
INSERT INTO public.who_global_data VALUES (32005, 210, 47190, 4, 937, 136, 94);
INSERT INTO public.who_global_data VALUES (32006, 36, 3587, 1, 24, 136, 66);
INSERT INTO public.who_global_data VALUES (32007, 30, 26942, 3, 854, 136, 58);
INSERT INTO public.who_global_data VALUES (32008, 747, 39897, 4, 771, 136, 163);
INSERT INTO public.who_global_data VALUES (32009, 98, 39378, 2, 578, 136, 37);
INSERT INTO public.who_global_data VALUES (32010, 48, 3418, 1, 75, 136, 142);
INSERT INTO public.who_global_data VALUES (32011, 650, 66402, 3, 227, 136, 83);
INSERT INTO public.who_global_data VALUES (32012, 1557, 352178, 28, 5007, 136, 228);
INSERT INTO public.who_global_data VALUES (32013, 0, 189, 0, 7, 136, 188);
INSERT INTO public.who_global_data VALUES (32014, 206, 76104, 6, 791, 136, 62);
INSERT INTO public.who_global_data VALUES (32015, 2074, 109693, 1, 9951, 136, 160);
INSERT INTO public.who_global_data VALUES (32016, 8, 1635, 0, 21, 136, 50);
INSERT INTO public.who_global_data VALUES (32017, 31, 2325, 0, 40, 136, 33);
INSERT INTO public.who_global_data VALUES (32018, 0, 180, 0, 9, 136, 183);
INSERT INTO public.who_global_data VALUES (32019, 0, 261, 0, 0, 136, 92);
INSERT INTO public.who_global_data VALUES (32020, 310, 130986, 37, 7654, 136, 158);
INSERT INTO public.who_global_data VALUES (32021, 5, 52, 0, 1, 136, 67);
INSERT INTO public.who_global_data VALUES (32022, 216, 25732, 8, 771, 136, 57);
INSERT INTO public.who_global_data VALUES (32023, 0, 2567, 0, 13, 136, 38);
INSERT INTO public.who_global_data VALUES (32024, 13439, 4558068, 377, 137272, 136, 141);
INSERT INTO public.who_global_data VALUES (32025, 0, 71, 0, 1, 136, 178);
INSERT INTO public.who_global_data VALUES (32026, 0, 145, 0, 3, 136, 108);
INSERT INTO public.who_global_data VALUES (32027, 109, 19123, 2, 767, 136, 39);
INSERT INTO public.who_global_data VALUES (32028, 0, 1896, 0, 56, 136, 2);
INSERT INTO public.who_global_data VALUES (32029, 2, 476, 0, 1, 136, 195);
INSERT INTO public.who_global_data VALUES (32030, 56, 5337, 0, 52, 136, 107);
INSERT INTO public.who_global_data VALUES (32031, 0, 275, 0, 0, 136, 161);
INSERT INTO public.who_global_data VALUES (32032, 92, 20690, 0, 416, 136, 212);
INSERT INTO public.who_global_data VALUES (32033, 1766, 145415, 11, 9228, 136, 181);
INSERT INTO public.who_global_data VALUES (32034, 1, 210, 0, 1, 136, 53);
INSERT INTO public.who_global_data VALUES (32035, 0, 4802, 0, 62, 136, 164);
INSERT INTO public.who_global_data VALUES (32036, 2, 1155, 0, 81, 136, 140);
INSERT INTO public.who_global_data VALUES (32037, 1055, 448523, 23, 12321, 136, 20);
INSERT INTO public.who_global_data VALUES (32038, 18, 90908, 0, 4744, 136, 112);
INSERT INTO public.who_global_data VALUES (32039, 5359, 770435, 189, 24397, 136, 111);
INSERT INTO public.who_global_data VALUES (32040, 0, 470, 0, 7, 136, 71);
INSERT INTO public.who_global_data VALUES (32041, 3, 5005, 0, 89, 136, 218);
INSERT INTO public.who_global_data VALUES (32042, 0, 0, 0, 0, 136, 43);
INSERT INTO public.who_global_data VALUES (32043, 703, 65602, 18, 745, 136, 49);
INSERT INTO public.who_global_data VALUES (32044, 7, 19327, 0, 120, 136, 1);
INSERT INTO public.who_global_data VALUES (32045, 144, 15136, 2, 255, 136, 48);
INSERT INTO public.who_global_data VALUES (32046, 81, 5222, 1, 117, 136, 232);
INSERT INTO public.who_global_data VALUES (32047, 0, 282, 0, 1, 136, 175);
INSERT INTO public.who_global_data VALUES (32048, 15, 1618, 0, 22, 136, 21);
INSERT INTO public.who_global_data VALUES (32049, 2394, 53158, 9, 531, 136, 156);
INSERT INTO public.who_global_data VALUES (32050, 0, 0, 0, 0, 136, 95);
INSERT INTO public.who_global_data VALUES (32051, 4, 10522, 0, 271, 136, 177);
INSERT INTO public.who_global_data VALUES (32052, 476, 23799, 1, 641, 136, 210);
INSERT INTO public.who_global_data VALUES (32053, 3, 5407, 0, 61, 136, 120);
INSERT INTO public.who_global_data VALUES (32054, 0, 24, 0, 0, 136, 135);
INSERT INTO public.who_global_data VALUES (32055, 486, 109269, 10, 2064, 136, 206);
INSERT INTO public.who_global_data VALUES (32056, 932, 127643, 31, 11126, 136, 189);
INSERT INTO public.who_global_data VALUES (32057, 113, 102254, 19, 5806, 136, 129);
INSERT INTO public.who_global_data VALUES (32058, 0, 27798, 2, 814, 136, 121);
INSERT INTO public.who_global_data VALUES (32059, 16, 5018, 0, 83, 136, 59);
INSERT INTO public.who_global_data VALUES (32060, 0, 364, 0, 0, 136, 96);
INSERT INTO public.who_global_data VALUES (32061, 35, 2976, 0, 64, 136, 41);
INSERT INTO public.who_global_data VALUES (32062, 25, 5307, 2, 106, 136, 216);
INSERT INTO public.who_global_data VALUES (32063, 713, 70422, 19, 1127, 136, 236);
INSERT INTO public.who_global_data VALUES (32064, 0, 13, 0, 0, 136, 150);
INSERT INTO public.who_global_data VALUES (32065, 11, 448, 0, 0, 136, 61);
INSERT INTO public.who_global_data VALUES (32066, 0, 32, 0, 2, 136, 7);
INSERT INTO public.who_global_data VALUES (32067, 149, 9195, 0, 341, 136, 169);
INSERT INTO public.who_global_data VALUES (32068, 8921, 445402, 62, 31234, 136, 28);
INSERT INTO public.who_global_data VALUES (32069, 26, 9738, 0, 65, 136, 85);
INSERT INTO public.who_global_data VALUES (32070, 0, 1394, 3, 5, 136, 211);
INSERT INTO public.who_global_data VALUES (32071, 0, 8704, 0, 54, 136, 60);
INSERT INTO public.who_global_data VALUES (32072, 0, 3540, 0, 110, 136, 3);
INSERT INTO public.who_global_data VALUES (32073, 227, 4140, 2, 24, 136, 11);
INSERT INTO public.who_global_data VALUES (32074, 1769, 275927, 13, 9409, 136, 89);
INSERT INTO public.who_global_data VALUES (32075, 58, 46062, 0, 297, 136, 24);
INSERT INTO public.who_global_data VALUES (32076, 0, 350, 0, 0, 136, 162);
INSERT INTO public.who_global_data VALUES (32077, 333, 15928, 8, 352, 136, 100);
INSERT INTO public.who_global_data VALUES (32078, 0, 14, 0, 0, 136, 47);
INSERT INTO public.who_global_data VALUES (32079, 0, 24, 0, 0, 136, 29);
INSERT INTO public.who_global_data VALUES (32080, 1061, 4487, 16, 42, 136, 40);
INSERT INTO public.who_global_data VALUES (32081, 43, 2190, 2, 37, 136, 222);
INSERT INTO public.who_global_data VALUES (32082, 942, 86623, 13, 3137, 136, 132);
INSERT INTO public.who_global_data VALUES (32083, 0, 256, 0, 13, 136, 130);
INSERT INTO public.who_global_data VALUES (32084, 43, 10387, 0, 65, 136, 234);
INSERT INTO public.who_global_data VALUES (32085, 0, 2303, 0, 39, 136, 23);
INSERT INTO public.who_global_data VALUES (32086, 133, 2402, 3, 67, 136, 192);
INSERT INTO public.who_global_data VALUES (32087, 0, 8624, 0, 221, 136, 69);
INSERT INTO public.who_global_data VALUES (32088, 0, 12, 0, 0, 136, 187);
INSERT INTO public.who_global_data VALUES (32089, 459, 72075, 20, 2204, 136, 230);
INSERT INTO public.who_global_data VALUES (32090, 951, 20450, 8, 702, 136, 77);
INSERT INTO public.who_global_data VALUES (32091, 42, 2419, 0, 10, 136, 9);
INSERT INTO public.who_global_data VALUES (32092, 83347, 5646010, 1085, 90020, 136, 74);
INSERT INTO public.who_global_data VALUES (32093, 4071, 252923, 160, 9837, 136, 224);
INSERT INTO public.who_global_data VALUES (32094, 3712, 429193, 178, 24656, 136, 199);
INSERT INTO public.who_global_data VALUES (32095, 4724, 327580, 57, 8682, 136, 190);
INSERT INTO public.who_global_data VALUES (32096, 323, 33444, 0, 1792, 136, 12);
INSERT INTO public.who_global_data VALUES (32097, 1, 340, 0, 24, 136, 104);
INSERT INTO public.who_global_data VALUES (32098, 3865, 192123, 32, 1335, 136, 153);
INSERT INTO public.who_global_data VALUES (32099, 1391, 300897, 14, 35738, 136, 91);
INSERT INTO public.who_global_data VALUES (32100, 127, 5270, 5, 75, 136, 215);
INSERT INTO public.who_global_data VALUES (32101, 330, 79768, 4, 1512, 136, 84);
INSERT INTO public.who_global_data VALUES (32102, 3, 396, 0, 32, 136, 231);
INSERT INTO public.who_global_data VALUES (32103, 634, 5747, 1, 33, 136, 196);
INSERT INTO public.who_global_data VALUES (32104, 307, 139289, 0, 2043, 136, 105);
INSERT INTO public.who_global_data VALUES (32105, 139, 37218, 9, 659, 136, 122);
INSERT INTO public.who_global_data VALUES (32106, 0, 0, 0, 0, 136, 159);
INSERT INTO public.who_global_data VALUES (32107, 66, 15165, 0, 605, 136, 75);
INSERT INTO public.who_global_data VALUES (32108, 719, 100683, 3, 588, 136, 27);
INSERT INTO public.who_global_data VALUES (32109, 88, 45630, 0, 1063, 136, 54);
INSERT INTO public.who_global_data VALUES (32110, 0, 23, 0, 0, 136, 226);
INSERT INTO public.who_global_data VALUES (32111, 34, 1560, 0, 36, 136, 79);
INSERT INTO public.who_global_data VALUES (32112, 851, 30838, 8, 315, 136, 56);
INSERT INTO public.who_global_data VALUES (32113, 0, 1390, 0, 33, 136, 117);
INSERT INTO public.who_global_data VALUES (32114, 0, 1336, 0, 82, 136, 152);
INSERT INTO public.who_global_data VALUES (32115, 651, 30097, 9, 469, 136, 16);
INSERT INTO public.who_global_data VALUES (32116, 1, 117, 0, 1, 136, 10);
INSERT INTO public.who_global_data VALUES (32117, 73, 3927, 0, 88, 136, 201);
INSERT INTO public.who_global_data VALUES (32118, 100, 8016, 0, 124, 136, 174);
INSERT INTO public.who_global_data VALUES (32119, 63, 16136, 1, 226, 136, 119);
INSERT INTO public.who_global_data VALUES (32120, 6, 5739, 0, 179, 136, 168);
INSERT INTO public.who_global_data VALUES (32121, 82, 10358, 0, 130, 136, 99);
INSERT INTO public.who_global_data VALUES (32122, 48, 9818, 0, 34, 136, 171);
INSERT INTO public.who_global_data VALUES (32123, 6, 3030, 1, 129, 136, 87);
INSERT INTO public.who_global_data VALUES (32124, 42, 2857, 2, 25, 136, 123);
INSERT INTO public.who_global_data VALUES (32125, 0, 0, 0, 0, 136, 151);
INSERT INTO public.who_global_data VALUES (32126, 0, 1122, 0, 18, 136, 213);
INSERT INTO public.who_global_data VALUES (32127, 19, 7403, 0, 161, 136, 118);
INSERT INTO public.who_global_data VALUES (32128, 0, 367, 0, 10, 136, 134);
INSERT INTO public.who_global_data VALUES (32129, 0, 3541, 0, 40, 136, 65);
INSERT INTO public.who_global_data VALUES (32130, 2917, 700580, 204, 73697, 136, 102);
INSERT INTO public.who_global_data VALUES (32131, 0, 0, 0, 0, 136, 223);
INSERT INTO public.who_global_data VALUES (32132, 2, 200, 0, 1, 136, 4);
INSERT INTO public.who_global_data VALUES (32133, 1, 313, 0, 0, 136, 146);
INSERT INTO public.who_global_data VALUES (32134, 269, 9627, 5, 151, 136, 31);
INSERT INTO public.who_global_data VALUES (32135, 0, 13, 0, 1, 136, 127);
INSERT INTO public.who_global_data VALUES (32136, 2227, 105346, 34, 1889, 136, 22);
INSERT INTO public.who_global_data VALUES (32137, 202, 7114, 1, 45, 136, 115);
INSERT INTO public.who_global_data VALUES (32138, 488, 6959, 16, 116, 136, 106);
INSERT INTO public.who_global_data VALUES (32139, 81, 10607, 3, 116, 136, 90);
INSERT INTO public.who_global_data VALUES (32140, 0, 0, 0, 0, 136, 70);
INSERT INTO public.who_global_data VALUES (32141, 1356, 66632, 2, 429, 136, 46);
INSERT INTO public.who_global_data VALUES (32142, 2237, 98099, 10, 6290, 136, 139);
INSERT INTO public.who_global_data VALUES (32143, 0, 26, 0, 0, 136, 42);
INSERT INTO public.who_global_data VALUES (32144, 4, 1468, 0, 25, 136, 80);
INSERT INTO public.who_global_data VALUES (32145, 86, 4065, 2, 149, 136, 203);
INSERT INTO public.who_global_data VALUES (32146, 0, 1189, 0, 69, 136, 136);
INSERT INTO public.who_global_data VALUES (32147, 176, 57613, 0, 1100, 136, 63);
INSERT INTO public.who_global_data VALUES (32148, 0, 0, 0, 0, 136, 17);
INSERT INTO public.who_global_data VALUES (32149, 0, 69, 0, 2, 136, 172);
INSERT INTO public.who_global_data VALUES (32150, 87, 16867, 5, 705, 136, 109);
INSERT INTO public.who_global_data VALUES (32151, 104, 13000, 0, 267, 136, 200);
INSERT INTO public.who_global_data VALUES (32152, 557, 46614, 5, 314, 136, 93);
INSERT INTO public.who_global_data VALUES (32153, 660, 94711, 12, 865, 136, 5);
INSERT INTO public.who_global_data VALUES (32154, 0, 741, 0, 13, 136, 214);
INSERT INTO public.who_global_data VALUES (32155, 532, 307418, 8, 6432, 136, 204);
INSERT INTO public.who_global_data VALUES (32156, 0, 0, 0, 0, 136, 198);
INSERT INTO public.who_global_data VALUES (32157, 607, 106810, 15, 2272, 136, 173);
INSERT INTO public.who_global_data VALUES (32158, 1, 527, 0, 7, 136, 229);
INSERT INTO public.who_global_data VALUES (32159, 740, 34260, 17, 676, 136, 76);
INSERT INTO public.who_global_data VALUES (32160, 4001, 772896, 105, 31474, 136, 138);
INSERT INTO public.who_global_data VALUES (32161, 1599, 291789, 50, 5049, 136, 98);
INSERT INTO public.who_global_data VALUES (32162, 0, 0, 0, 0, 136, 103);
INSERT INTO public.who_global_data VALUES (32163, 711, 80699, 18, 2316, 136, 225);
INSERT INTO public.who_global_data VALUES (32164, 463, 69663, 5, 1925, 136, 131);
INSERT INTO public.who_global_data VALUES (32165, 120, 42596, 4, 613, 136, 235);
INSERT INTO public.who_global_data VALUES (32166, 313, 123917, 0, 211, 136, 137);
INSERT INTO public.who_global_data VALUES (32167, 110, 23216, 0, 388, 136, 81);
INSERT INTO public.who_global_data VALUES (32168, 650, 47446, 19, 1230, 136, 182);
INSERT INTO public.who_global_data VALUES (32169, 0, 3415, 0, 11, 136, 145);
INSERT INTO public.who_global_data VALUES (32170, 1059, 114648, 45, 4503, 136, 26);
INSERT INTO public.who_global_data VALUES (32171, 6431, 1122241, 150, 19799, 136, 170);
INSERT INTO public.who_global_data VALUES (32172, 16, 4738, 0, 27, 136, 191);
INSERT INTO public.who_global_data VALUES (32173, 0, 5, 0, 0, 136, 221);
INSERT INTO public.who_global_data VALUES (32174, 0, 23, 0, 0, 136, 64);
INSERT INTO public.who_global_data VALUES (32175, 0, 0, 0, 0, 136, 116);
INSERT INTO public.who_global_data VALUES (32176, 0, 19, 0, 0, 136, 128);
INSERT INTO public.who_global_data VALUES (32177, 0, 27, 0, 0, 136, 6);
INSERT INTO public.who_global_data VALUES (32178, 0, 330, 0, 6, 136, 227);
INSERT INTO public.who_global_data VALUES (32179, 0, 11, 0, 0, 136, 68);
INSERT INTO public.who_global_data VALUES (32180, 0, 64, 0, 0, 136, 184);
INSERT INTO public.who_global_data VALUES (32181, 0, 0, 0, 0, 136, 82);
INSERT INTO public.who_global_data VALUES (32182, 0, 742, 0, 42, 136, 149);
INSERT INTO public.who_global_data VALUES (32183, 0, 908, 0, 15, 136, 197);
INSERT INTO public.who_global_data VALUES (32184, 552, 330798, 30, 4542, 136, 78);
INSERT INTO public.who_global_data VALUES (32185, 21, 14759, 0, 302, 136, 233);
INSERT INTO public.who_global_data VALUES (32186, 61, 32999, 0, 743, 136, 133);
INSERT INTO public.who_global_data VALUES (32187, 0, 139, 0, 0, 136, 35);
INSERT INTO public.who_global_data VALUES (32188, 6, 2174, 0, 72, 136, 114);
INSERT INTO public.who_global_data VALUES (32189, 21, 57627, 0, 27, 136, 237);
INSERT INTO public.who_global_data VALUES (32190, 0, 12, 0, 0, 136, 55);
INSERT INTO public.who_global_data VALUES (32191, 7, 591, 0, 20, 136, 176);
INSERT INTO public.who_global_data VALUES (32192, 175, 6931, 1, 40, 136, 202);
INSERT INTO public.who_global_data VALUES (32193, 136, 4695, 1, 147, 136, 155);
INSERT INTO public.who_global_data VALUES (32194, 0, 0, 0, 0, 136, 32);
INSERT INTO public.who_global_data VALUES (32195, 0, 3465, 0, 98, 136, 220);
INSERT INTO public.who_global_data VALUES (32196, 1346, 663282, 126, 16118, 136, 30);
INSERT INTO public.who_global_data VALUES (32197, 4, 2664, 0, 49, 136, 147);
INSERT INTO public.who_global_data VALUES (32198, 8254, 728605, 129, 32926, 136, 208);
INSERT INTO public.who_global_data VALUES (32199, 14, 3313, 0, 13, 136, 45);
INSERT INTO public.who_global_data VALUES (32200, 0, 13578, 0, 836, 136, 110);
INSERT INTO public.who_global_data VALUES (32201, 17, 4740, 0, 97, 136, 88);
INSERT INTO public.who_global_data VALUES (32202, 266, 89505, 2, 5867, 136, 51);
INSERT INTO public.who_global_data VALUES (32203, 425, 51287, 1, 1808, 136, 209);
INSERT INTO public.who_global_data VALUES (32204, 44, 3877, 3, 178, 136, 205);
INSERT INTO public.who_global_data VALUES (32205, 44, 9432, 0, 73, 136, 18);
INSERT INTO public.who_global_data VALUES (32206, 3, 3514, 0, 59, 136, 72);
INSERT INTO public.who_global_data VALUES (32207, 4926, 403555, 37, 41825, 136, 44);
INSERT INTO public.who_global_data VALUES (32208, 0, 27, 0, 0, 136, 15);
INSERT INTO public.who_global_data VALUES (32209, 14, 1683, 0, 41, 136, 25);
INSERT INTO public.who_global_data VALUES (32210, 0, 0, 0, 0, 136, 179);
INSERT INTO public.who_global_data VALUES (32211, 0, 0, 0, 0, 136, 34);
INSERT INTO public.who_global_data VALUES (32212, 44, 3974, 0, 65, 136, 207);
INSERT INTO public.who_global_data VALUES (32213, 1219, 12479, 10, 174, 136, 166);
INSERT INTO public.who_global_data VALUES (32214, 8422, 689912, 65, 7639, 136, 126);
INSERT INTO public.who_global_data VALUES (32215, 0, 0, 0, 0, 136, 97);
INSERT INTO public.who_global_data VALUES (32216, 0, 668, 0, 5, 136, 36);
INSERT INTO public.who_global_data VALUES (32217, 0, 0, 0, 0, 136, 125);
INSERT INTO public.who_global_data VALUES (32218, 244, 6712, 1, 64, 136, 124);
INSERT INTO public.who_global_data VALUES (32219, 3497, 184734, 63, 3705, 136, 185);
INSERT INTO public.who_global_data VALUES (32220, 852, 86447, 0, 405, 136, 194);
INSERT INTO public.who_global_data VALUES (32221, 0, 509, 0, 21, 136, 144);
INSERT INTO public.who_global_data VALUES (32222, 39145, 6779609, 430, 198793, 136, 19);
INSERT INTO public.who_global_data VALUES (32223, 7, 1276, 0, 19, 136, 217);
INSERT INTO public.who_global_data VALUES (32224, 10, 1927, 0, 46, 136, 148);
INSERT INTO public.who_global_data VALUES (32225, 560, 53051, 3, 443, 136, 86);
INSERT INTO public.who_global_data VALUES (32226, 0, 0, 0, 0, 136, 13);
INSERT INTO public.who_global_data VALUES (32227, 787, 67443, 8, 555, 136, 157);
INSERT INTO public.who_global_data VALUES (32228, 0, 1068, 0, 35, 136, 8);
INSERT INTO public.who_global_data VALUES (32229, 0, 0, 0, 0, 136, 73);
INSERT INTO public.who_global_data VALUES (32230, 0, 2032, 0, 587, 136, 101);
INSERT INTO public.who_global_data VALUES (32231, 214, 14389, 0, 331, 136, 165);
INSERT INTO public.who_global_data VALUES (32232, 28, 7711, 1, 226, 136, 14);
INSERT INTO public.who_global_data VALUES (32233, 22, 39182, 1, 1449, 137, 193);
INSERT INTO public.who_global_data VALUES (32234, 150, 12535, 2, 364, 137, 113);
INSERT INTO public.who_global_data VALUES (32235, 197, 50023, 7, 1679, 137, 143);
INSERT INTO public.who_global_data VALUES (32236, 0, 0, 0, 0, 137, 219);
INSERT INTO public.who_global_data VALUES (32237, 117, 1681, 0, 53, 137, 186);
INSERT INTO public.who_global_data VALUES (32238, 0, 3991, 0, 152, 137, 52);
INSERT INTO public.who_global_data VALUES (32239, 0, 3, 0, 0, 137, 180);
INSERT INTO public.who_global_data VALUES (32240, 0, 96, 0, 3, 137, 167);
INSERT INTO public.who_global_data VALUES (32241, 8431, 631365, 144, 13053, 137, 154);
INSERT INTO public.who_global_data VALUES (32242, 115, 46980, 2, 933, 137, 94);
INSERT INTO public.who_global_data VALUES (32243, 169, 3551, 0, 23, 137, 66);
INSERT INTO public.who_global_data VALUES (32244, 14, 26912, 2, 851, 137, 58);
INSERT INTO public.who_global_data VALUES (32245, 593, 39150, 1, 767, 137, 163);
INSERT INTO public.who_global_data VALUES (32246, 92, 39280, 1, 576, 137, 37);
INSERT INTO public.who_global_data VALUES (32247, 55, 3370, 0, 74, 137, 142);
INSERT INTO public.who_global_data VALUES (32248, 713, 65752, 3, 224, 137, 83);
INSERT INTO public.who_global_data VALUES (32249, 1705, 350621, 40, 4979, 137, 228);
INSERT INTO public.who_global_data VALUES (32250, 4, 189, 0, 7, 137, 188);
INSERT INTO public.who_global_data VALUES (32251, 224, 75898, 5, 785, 137, 62);
INSERT INTO public.who_global_data VALUES (32252, 2202, 107619, 3, 9950, 137, 160);
INSERT INTO public.who_global_data VALUES (32253, 21, 1627, 1, 21, 137, 50);
INSERT INTO public.who_global_data VALUES (32254, 14, 2294, 0, 40, 137, 33);
INSERT INTO public.who_global_data VALUES (32255, 0, 180, 0, 9, 137, 183);
INSERT INTO public.who_global_data VALUES (32256, 0, 261, 0, 0, 137, 92);
INSERT INTO public.who_global_data VALUES (32257, 206, 130676, 31, 7617, 137, 158);
INSERT INTO public.who_global_data VALUES (32258, 7, 47, 0, 1, 137, 67);
INSERT INTO public.who_global_data VALUES (32259, 92, 25516, 6, 763, 137, 57);
INSERT INTO public.who_global_data VALUES (32260, 0, 2567, 0, 13, 137, 38);
INSERT INTO public.who_global_data VALUES (32261, 16389, 4544629, 363, 136895, 137, 141);
INSERT INTO public.who_global_data VALUES (32262, 0, 71, 0, 1, 137, 178);
INSERT INTO public.who_global_data VALUES (32263, 0, 145, 0, 3, 137, 108);
INSERT INTO public.who_global_data VALUES (32264, 151, 19014, 4, 765, 137, 39);
INSERT INTO public.who_global_data VALUES (32265, 80, 1896, 0, 56, 137, 2);
INSERT INTO public.who_global_data VALUES (32266, 0, 474, 0, 1, 137, 195);
INSERT INTO public.who_global_data VALUES (32267, 24, 5281, 1, 52, 137, 107);
INSERT INTO public.who_global_data VALUES (32268, 0, 275, 0, 0, 137, 161);
INSERT INTO public.who_global_data VALUES (32269, 0, 20598, 0, 416, 137, 212);
INSERT INTO public.who_global_data VALUES (32270, 875, 143649, 6, 9217, 137, 181);
INSERT INTO public.who_global_data VALUES (32271, 1, 209, 0, 1, 137, 53);
INSERT INTO public.who_global_data VALUES (32272, 9, 4802, 0, 62, 137, 164);
INSERT INTO public.who_global_data VALUES (32273, 2, 1153, 0, 81, 137, 140);
INSERT INTO public.who_global_data VALUES (32274, 1194, 447468, 12, 12298, 137, 20);
INSERT INTO public.who_global_data VALUES (32275, 14, 90890, 0, 4744, 137, 112);
INSERT INTO public.who_global_data VALUES (32276, 6678, 765076, 169, 24208, 137, 111);
INSERT INTO public.who_global_data VALUES (32277, 0, 470, 0, 7, 137, 71);
INSERT INTO public.who_global_data VALUES (32278, 0, 5002, 0, 89, 137, 218);
INSERT INTO public.who_global_data VALUES (32279, 0, 0, 0, 0, 137, 43);
INSERT INTO public.who_global_data VALUES (32280, 1187, 64899, 21, 727, 137, 49);
INSERT INTO public.who_global_data VALUES (32281, 51, 19320, 0, 120, 137, 1);
INSERT INTO public.who_global_data VALUES (32282, 70, 14992, 5, 253, 137, 48);
INSERT INTO public.who_global_data VALUES (32283, 50, 5141, 1, 116, 137, 232);
INSERT INTO public.who_global_data VALUES (32284, 72, 282, 0, 1, 137, 175);
INSERT INTO public.who_global_data VALUES (32285, 3, 1603, 0, 22, 137, 21);
INSERT INTO public.who_global_data VALUES (32286, 1524, 50764, 19, 522, 137, 156);
INSERT INTO public.who_global_data VALUES (32287, 0, 0, 0, 0, 137, 95);
INSERT INTO public.who_global_data VALUES (32288, 4, 10518, 0, 271, 137, 177);
INSERT INTO public.who_global_data VALUES (32289, 1476, 23323, 5, 640, 137, 210);
INSERT INTO public.who_global_data VALUES (32290, 1, 5404, 0, 61, 137, 120);
INSERT INTO public.who_global_data VALUES (32291, 0, 24, 0, 0, 137, 135);
INSERT INTO public.who_global_data VALUES (32292, 494, 108783, 7, 2054, 137, 206);
INSERT INTO public.who_global_data VALUES (32293, 292, 126711, 5, 11095, 137, 189);
INSERT INTO public.who_global_data VALUES (32294, 126, 102141, 17, 5787, 137, 129);
INSERT INTO public.who_global_data VALUES (32295, 245, 27798, 1, 812, 137, 121);
INSERT INTO public.who_global_data VALUES (32296, 0, 5002, 0, 83, 137, 59);
INSERT INTO public.who_global_data VALUES (32297, 0, 364, 0, 0, 137, 96);
INSERT INTO public.who_global_data VALUES (32298, 17, 2941, 0, 64, 137, 41);
INSERT INTO public.who_global_data VALUES (32299, 13, 5282, 0, 104, 137, 216);
INSERT INTO public.who_global_data VALUES (32300, 889, 69709, 12, 1108, 137, 236);
INSERT INTO public.who_global_data VALUES (32301, 0, 13, 0, 0, 137, 150);
INSERT INTO public.who_global_data VALUES (32302, 3, 437, 0, 0, 137, 61);
INSERT INTO public.who_global_data VALUES (32303, 0, 32, 0, 2, 137, 7);
INSERT INTO public.who_global_data VALUES (32304, 66, 9046, 2, 341, 137, 169);
INSERT INTO public.who_global_data VALUES (32305, 4057, 436481, 52, 31172, 137, 28);
INSERT INTO public.who_global_data VALUES (32306, 20, 9712, 0, 65, 137, 85);
INSERT INTO public.who_global_data VALUES (32307, 41, 1394, 0, 2, 137, 211);
INSERT INTO public.who_global_data VALUES (32308, 8, 8704, 1, 54, 137, 60);
INSERT INTO public.who_global_data VALUES (32309, 14, 3540, 2, 110, 137, 3);
INSERT INTO public.who_global_data VALUES (32310, 218, 3913, 2, 22, 137, 11);
INSERT INTO public.who_global_data VALUES (32311, 1821, 274158, 10, 9396, 137, 89);
INSERT INTO public.who_global_data VALUES (32312, 0, 46004, 0, 297, 137, 24);
INSERT INTO public.who_global_data VALUES (32313, 0, 350, 0, 0, 137, 162);
INSERT INTO public.who_global_data VALUES (32314, 453, 15595, 6, 344, 137, 100);
INSERT INTO public.who_global_data VALUES (32315, 0, 14, 0, 0, 137, 47);
INSERT INTO public.who_global_data VALUES (32316, 0, 24, 0, 0, 137, 29);
INSERT INTO public.who_global_data VALUES (32317, 0, 3426, 0, 26, 137, 40);
INSERT INTO public.who_global_data VALUES (32318, 30, 2147, 1, 35, 137, 222);
INSERT INTO public.who_global_data VALUES (32319, 237, 85681, 5, 3124, 137, 132);
INSERT INTO public.who_global_data VALUES (32320, 2, 256, 0, 13, 137, 130);
INSERT INTO public.who_global_data VALUES (32321, 19, 10344, 1, 65, 137, 234);
INSERT INTO public.who_global_data VALUES (32322, 0, 2303, 0, 39, 137, 23);
INSERT INTO public.who_global_data VALUES (32323, 101, 2269, 0, 64, 137, 192);
INSERT INTO public.who_global_data VALUES (32324, 24, 8624, 0, 221, 137, 69);
INSERT INTO public.who_global_data VALUES (32325, 0, 12, 0, 0, 137, 187);
INSERT INTO public.who_global_data VALUES (32326, 473, 71616, 18, 2184, 137, 230);
INSERT INTO public.who_global_data VALUES (32327, 633, 19499, 8, 694, 137, 77);
INSERT INTO public.who_global_data VALUES (32328, 31, 2377, 0, 10, 137, 9);
INSERT INTO public.who_global_data VALUES (32329, 75083, 5562663, 1053, 88935, 137, 74);
INSERT INTO public.who_global_data VALUES (32330, 4176, 248852, 124, 9677, 137, 224);
INSERT INTO public.who_global_data VALUES (32331, 3341, 425481, 177, 24478, 137, 199);
INSERT INTO public.who_global_data VALUES (32332, 3821, 322856, 70, 8625, 137, 190);
INSERT INTO public.who_global_data VALUES (32333, 188, 33121, 0, 1792, 137, 12);
INSERT INTO public.who_global_data VALUES (32334, 0, 339, 0, 24, 137, 104);
INSERT INTO public.who_global_data VALUES (32335, 2579, 188258, 21, 1303, 137, 153);
INSERT INTO public.who_global_data VALUES (32336, 1350, 299506, 17, 35724, 137, 91);
INSERT INTO public.who_global_data VALUES (32337, 155, 5143, 3, 70, 137, 215);
INSERT INTO public.who_global_data VALUES (32338, 298, 79438, 8, 1508, 137, 84);
INSERT INTO public.who_global_data VALUES (32339, 0, 393, 0, 32, 137, 231);
INSERT INTO public.who_global_data VALUES (32340, 266, 5113, 2, 32, 137, 196);
INSERT INTO public.who_global_data VALUES (32341, 440, 138982, 0, 2043, 137, 105);
INSERT INTO public.who_global_data VALUES (32342, 98, 37079, 2, 650, 137, 122);
INSERT INTO public.who_global_data VALUES (32343, 0, 0, 0, 0, 137, 159);
INSERT INTO public.who_global_data VALUES (32344, 79, 15099, 2, 605, 137, 75);
INSERT INTO public.who_global_data VALUES (32345, 530, 99964, 1, 585, 137, 27);
INSERT INTO public.who_global_data VALUES (32346, 71, 45542, 0, 1063, 137, 54);
INSERT INTO public.who_global_data VALUES (32347, 0, 23, 0, 0, 137, 226);
INSERT INTO public.who_global_data VALUES (32348, 1, 1526, 0, 36, 137, 79);
INSERT INTO public.who_global_data VALUES (32349, 684, 29987, 10, 307, 137, 56);
INSERT INTO public.who_global_data VALUES (32350, 0, 1390, 0, 33, 137, 117);
INSERT INTO public.who_global_data VALUES (32351, 0, 1336, 0, 82, 137, 152);
INSERT INTO public.who_global_data VALUES (32352, 650, 29446, 10, 460, 137, 16);
INSERT INTO public.who_global_data VALUES (32353, 1, 116, 0, 1, 137, 10);
INSERT INTO public.who_global_data VALUES (32354, 45, 3854, 0, 88, 137, 201);
INSERT INTO public.who_global_data VALUES (32355, 112, 7916, 0, 124, 137, 174);
INSERT INTO public.who_global_data VALUES (32356, 20, 16073, 2, 225, 137, 119);
INSERT INTO public.who_global_data VALUES (32357, 2, 5733, 0, 179, 137, 168);
INSERT INTO public.who_global_data VALUES (32358, 57, 10276, 0, 130, 137, 99);
INSERT INTO public.who_global_data VALUES (32359, 46, 9770, 1, 34, 137, 171);
INSERT INTO public.who_global_data VALUES (32360, 11, 3024, 0, 128, 137, 87);
INSERT INTO public.who_global_data VALUES (32361, 38, 2815, 2, 23, 137, 123);
INSERT INTO public.who_global_data VALUES (32362, 0, 0, 0, 0, 137, 151);
INSERT INTO public.who_global_data VALUES (32363, 0, 1122, 0, 18, 137, 213);
INSERT INTO public.who_global_data VALUES (32364, 16, 7384, 0, 161, 137, 118);
INSERT INTO public.who_global_data VALUES (32365, 0, 367, 0, 10, 137, 134);
INSERT INTO public.who_global_data VALUES (32366, 0, 3541, 0, 40, 137, 65);
INSERT INTO public.who_global_data VALUES (32367, 3542, 697663, 235, 73493, 137, 102);
INSERT INTO public.who_global_data VALUES (32368, 0, 0, 0, 0, 137, 223);
INSERT INTO public.who_global_data VALUES (32369, 2, 198, 0, 1, 137, 4);
INSERT INTO public.who_global_data VALUES (32370, 0, 312, 0, 0, 137, 146);
INSERT INTO public.who_global_data VALUES (32371, 320, 9358, 8, 146, 137, 31);
INSERT INTO public.who_global_data VALUES (32372, 0, 13, 0, 1, 137, 127);
INSERT INTO public.who_global_data VALUES (32373, 1376, 103119, 25, 1855, 137, 22);
INSERT INTO public.who_global_data VALUES (32374, 141, 6912, 1, 44, 137, 115);
INSERT INTO public.who_global_data VALUES (32375, 666, 6471, 6, 100, 137, 106);
INSERT INTO public.who_global_data VALUES (32376, 149, 10526, 1, 113, 137, 90);
INSERT INTO public.who_global_data VALUES (32377, 0, 0, 0, 0, 137, 70);
INSERT INTO public.who_global_data VALUES (32378, 1154, 65276, 16, 427, 137, 46);
INSERT INTO public.who_global_data VALUES (32379, 2212, 95862, 2, 6280, 137, 139);
INSERT INTO public.who_global_data VALUES (32380, 0, 26, 0, 0, 137, 42);
INSERT INTO public.who_global_data VALUES (32381, 0, 1464, 0, 25, 137, 80);
INSERT INTO public.who_global_data VALUES (32382, 0, 3979, 0, 147, 137, 203);
INSERT INTO public.who_global_data VALUES (32383, 6, 1189, 0, 69, 137, 136);
INSERT INTO public.who_global_data VALUES (32384, 195, 57437, 2, 1100, 137, 63);
INSERT INTO public.who_global_data VALUES (32385, 0, 0, 0, 0, 137, 17);
INSERT INTO public.who_global_data VALUES (32386, 1, 69, 0, 2, 137, 172);
INSERT INTO public.who_global_data VALUES (32387, 45, 16780, 7, 700, 137, 109);
INSERT INTO public.who_global_data VALUES (32388, 251, 12896, 0, 267, 137, 200);
INSERT INTO public.who_global_data VALUES (32389, 611, 46057, 9, 309, 137, 93);
INSERT INTO public.who_global_data VALUES (32390, 576, 94051, 7, 853, 137, 5);
INSERT INTO public.who_global_data VALUES (32391, 0, 741, 0, 13, 137, 214);
INSERT INTO public.who_global_data VALUES (32392, 582, 306886, 4, 6424, 137, 204);
INSERT INTO public.who_global_data VALUES (32393, 0, 0, 0, 0, 137, 198);
INSERT INTO public.who_global_data VALUES (32394, 602, 106203, 10, 2257, 137, 173);
INSERT INTO public.who_global_data VALUES (32395, 9, 526, 0, 7, 137, 229);
INSERT INTO public.who_global_data VALUES (32396, 505, 33520, 23, 659, 137, 76);
INSERT INTO public.who_global_data VALUES (32397, 6030, 768895, 0, 31369, 137, 138);
INSERT INTO public.who_global_data VALUES (32398, 3447, 290190, 15, 4999, 137, 98);
INSERT INTO public.who_global_data VALUES (32399, 0, 0, 0, 0, 137, 103);
INSERT INTO public.who_global_data VALUES (32400, 748, 79988, 5, 2298, 137, 225);
INSERT INTO public.who_global_data VALUES (32401, 623, 69200, 8, 1920, 137, 131);
INSERT INTO public.who_global_data VALUES (32402, 638, 42476, 1, 609, 137, 235);
INSERT INTO public.who_global_data VALUES (32403, 228, 123604, 1, 211, 137, 137);
INSERT INTO public.who_global_data VALUES (32404, 61, 23106, 3, 388, 137, 81);
INSERT INTO public.who_global_data VALUES (32405, 200, 46796, 8, 1211, 137, 182);
INSERT INTO public.who_global_data VALUES (32406, 221, 3415, 1, 11, 137, 145);
INSERT INTO public.who_global_data VALUES (32407, 808, 113589, 23, 4458, 137, 26);
INSERT INTO public.who_global_data VALUES (32408, 6215, 1115810, 160, 19649, 137, 170);
INSERT INTO public.who_global_data VALUES (32409, 11, 4722, 1, 27, 137, 191);
INSERT INTO public.who_global_data VALUES (32410, 0, 5, 0, 0, 137, 221);
INSERT INTO public.who_global_data VALUES (32411, 0, 23, 0, 0, 137, 64);
INSERT INTO public.who_global_data VALUES (32412, 0, 0, 0, 0, 137, 116);
INSERT INTO public.who_global_data VALUES (32413, 2, 19, 0, 0, 137, 128);
INSERT INTO public.who_global_data VALUES (32414, 0, 27, 0, 0, 137, 6);
INSERT INTO public.who_global_data VALUES (32415, 0, 330, 0, 6, 137, 227);
INSERT INTO public.who_global_data VALUES (32416, 0, 11, 0, 0, 137, 68);
INSERT INTO public.who_global_data VALUES (32417, 0, 64, 0, 0, 137, 184);
INSERT INTO public.who_global_data VALUES (32418, 0, 0, 0, 0, 137, 82);
INSERT INTO public.who_global_data VALUES (32419, 0, 742, 0, 42, 137, 149);
INSERT INTO public.who_global_data VALUES (32420, 0, 908, 0, 15, 137, 197);
INSERT INTO public.who_global_data VALUES (32421, 492, 330246, 27, 4512, 137, 78);
INSERT INTO public.who_global_data VALUES (32422, 24, 14738, 0, 302, 137, 233);
INSERT INTO public.who_global_data VALUES (32423, 30, 32938, 2, 743, 137, 133);
INSERT INTO public.who_global_data VALUES (32424, 0, 139, 0, 0, 137, 35);
INSERT INTO public.who_global_data VALUES (32425, 0, 2168, 0, 72, 137, 114);
INSERT INTO public.who_global_data VALUES (32426, 30, 57606, 0, 27, 137, 237);
INSERT INTO public.who_global_data VALUES (32427, 1, 12, 0, 0, 137, 55);
INSERT INTO public.who_global_data VALUES (32428, 19, 584, 1, 20, 137, 176);
INSERT INTO public.who_global_data VALUES (32429, 79, 6756, 0, 39, 137, 202);
INSERT INTO public.who_global_data VALUES (32430, 88, 4559, 1, 146, 137, 155);
INSERT INTO public.who_global_data VALUES (32431, 0, 0, 0, 0, 137, 32);
INSERT INTO public.who_global_data VALUES (32432, 23, 3465, 0, 98, 137, 220);
INSERT INTO public.who_global_data VALUES (32433, 725, 661936, 39, 15992, 137, 30);
INSERT INTO public.who_global_data VALUES (32434, 11, 2660, 0, 49, 137, 147);
INSERT INTO public.who_global_data VALUES (32435, 5905, 720351, 99, 32797, 137, 208);
INSERT INTO public.who_global_data VALUES (32436, 12, 3299, 0, 13, 137, 45);
INSERT INTO public.who_global_data VALUES (32437, 2, 13578, 0, 836, 137, 110);
INSERT INTO public.who_global_data VALUES (32438, 14, 4723, 0, 97, 137, 88);
INSERT INTO public.who_global_data VALUES (32439, 133, 89239, 4, 5865, 137, 51);
INSERT INTO public.who_global_data VALUES (32440, 395, 50862, 3, 1807, 137, 209);
INSERT INTO public.who_global_data VALUES (32441, 33, 3833, 3, 175, 137, 205);
INSERT INTO public.who_global_data VALUES (32442, 42, 9388, 0, 73, 137, 18);
INSERT INTO public.who_global_data VALUES (32443, 5, 3511, 0, 59, 137, 72);
INSERT INTO public.who_global_data VALUES (32444, 4368, 398629, 11, 41788, 137, 44);
INSERT INTO public.who_global_data VALUES (32445, 0, 27, 0, 0, 137, 15);
INSERT INTO public.who_global_data VALUES (32446, 3, 1669, 0, 41, 137, 25);
INSERT INTO public.who_global_data VALUES (32447, 0, 0, 0, 0, 137, 179);
INSERT INTO public.who_global_data VALUES (32448, 0, 0, 0, 0, 137, 34);
INSERT INTO public.who_global_data VALUES (32449, 64, 3930, 1, 65, 137, 207);
INSERT INTO public.who_global_data VALUES (32450, 0, 11260, 0, 164, 137, 166);
INSERT INTO public.who_global_data VALUES (32451, 8473, 681490, 68, 7574, 137, 126);
INSERT INTO public.who_global_data VALUES (32452, 0, 0, 0, 0, 137, 97);
INSERT INTO public.who_global_data VALUES (32453, 0, 668, 0, 5, 137, 36);
INSERT INTO public.who_global_data VALUES (32454, 0, 0, 0, 0, 137, 125);
INSERT INTO public.who_global_data VALUES (32455, 181, 6468, 0, 63, 137, 124);
INSERT INTO public.who_global_data VALUES (32456, 2884, 181237, 59, 3642, 137, 185);
INSERT INTO public.who_global_data VALUES (32457, 679, 85595, 1, 405, 137, 194);
INSERT INTO public.who_global_data VALUES (32458, 0, 509, 0, 21, 137, 144);
INSERT INTO public.who_global_data VALUES (32459, 36766, 6740464, 269, 198363, 137, 19);
INSERT INTO public.who_global_data VALUES (32460, 0, 1269, 0, 19, 137, 217);
INSERT INTO public.who_global_data VALUES (32461, 13, 1917, 0, 46, 137, 148);
INSERT INTO public.who_global_data VALUES (32462, 702, 52491, 5, 440, 137, 86);
INSERT INTO public.who_global_data VALUES (32463, 0, 0, 0, 0, 137, 13);
INSERT INTO public.who_global_data VALUES (32464, 707, 66656, 8, 547, 137, 157);
INSERT INTO public.who_global_data VALUES (32465, 0, 1068, 0, 35, 137, 8);
INSERT INTO public.who_global_data VALUES (32466, 0, 0, 0, 0, 137, 73);
INSERT INTO public.who_global_data VALUES (32467, 2, 2032, 0, 587, 137, 101);
INSERT INTO public.who_global_data VALUES (32468, 44, 14175, 1, 331, 137, 165);
INSERT INTO public.who_global_data VALUES (32469, 0, 7683, 0, 225, 137, 14);
INSERT INTO public.who_global_data VALUES (32470, 30, 39160, 3, 1448, 138, 193);
INSERT INTO public.who_global_data VALUES (32471, 159, 12385, 4, 362, 138, 113);
INSERT INTO public.who_global_data VALUES (32472, 203, 49826, 7, 1672, 138, 143);
INSERT INTO public.who_global_data VALUES (32473, 0, 0, 0, 0, 138, 219);
INSERT INTO public.who_global_data VALUES (32474, 0, 1564, 0, 53, 138, 186);
INSERT INTO public.who_global_data VALUES (32475, 90, 3991, 5, 152, 138, 52);
INSERT INTO public.who_global_data VALUES (32476, 0, 3, 0, 0, 138, 180);
INSERT INTO public.who_global_data VALUES (32477, 1, 96, 0, 3, 138, 167);
INSERT INTO public.who_global_data VALUES (32478, 9276, 622934, 204, 12909, 138, 154);
INSERT INTO public.who_global_data VALUES (32479, 121, 46865, 6, 931, 138, 94);
INSERT INTO public.who_global_data VALUES (32480, 0, 3382, 0, 23, 138, 66);
INSERT INTO public.who_global_data VALUES (32481, 13, 26898, 5, 849, 138, 58);
INSERT INTO public.who_global_data VALUES (32482, 609, 38557, 1, 766, 138, 163);
INSERT INTO public.who_global_data VALUES (32483, 146, 39188, 1, 575, 138, 37);
INSERT INTO public.who_global_data VALUES (32484, 138, 3315, 5, 74, 138, 142);
INSERT INTO public.who_global_data VALUES (32485, 540, 65039, 0, 221, 138, 83);
INSERT INTO public.who_global_data VALUES (32486, 1544, 348916, 26, 4939, 138, 228);
INSERT INTO public.who_global_data VALUES (32487, 0, 185, 0, 7, 138, 188);
INSERT INTO public.who_global_data VALUES (32488, 213, 75674, 4, 780, 138, 62);
INSERT INTO public.who_global_data VALUES (32489, 461, 105417, 3, 9947, 138, 160);
INSERT INTO public.who_global_data VALUES (32490, 16, 1606, 0, 20, 138, 50);
INSERT INTO public.who_global_data VALUES (32491, 0, 2280, 0, 40, 138, 33);
INSERT INTO public.who_global_data VALUES (32492, 2, 180, 0, 9, 138, 183);
INSERT INTO public.who_global_data VALUES (32493, 2, 261, 0, 0, 138, 92);
INSERT INTO public.who_global_data VALUES (32494, 419, 130470, 36, 7586, 138, 158);
INSERT INTO public.who_global_data VALUES (32495, 20, 40, 0, 1, 138, 67);
INSERT INTO public.who_global_data VALUES (32496, 212, 25424, 5, 757, 138, 57);
INSERT INTO public.who_global_data VALUES (32497, 0, 2567, 0, 13, 138, 38);
INSERT INTO public.who_global_data VALUES (32498, 33057, 4528240, 739, 136532, 138, 141);
INSERT INTO public.who_global_data VALUES (32499, 0, 71, 0, 1, 138, 178);
INSERT INTO public.who_global_data VALUES (32500, 0, 145, 0, 3, 138, 108);
INSERT INTO public.who_global_data VALUES (32501, 44, 18863, 6, 761, 138, 39);
INSERT INTO public.who_global_data VALUES (32502, 19, 1816, 0, 56, 138, 2);
INSERT INTO public.who_global_data VALUES (32503, 1, 474, 0, 1, 138, 195);
INSERT INTO public.who_global_data VALUES (32504, 71, 5257, 1, 51, 138, 107);
INSERT INTO public.who_global_data VALUES (32505, 0, 275, 0, 0, 138, 161);
INSERT INTO public.who_global_data VALUES (32506, 167, 20598, 0, 416, 138, 212);
INSERT INTO public.who_global_data VALUES (32507, 863, 142774, 6, 9211, 138, 181);
INSERT INTO public.who_global_data VALUES (32508, 0, 208, 0, 1, 138, 53);
INSERT INTO public.who_global_data VALUES (32509, 0, 4793, 0, 62, 138, 164);
INSERT INTO public.who_global_data VALUES (32510, 2, 1151, 0, 81, 138, 140);
INSERT INTO public.who_global_data VALUES (32511, 1600, 446274, 32, 12286, 138, 20);
INSERT INTO public.who_global_data VALUES (32512, 36, 90876, 0, 4744, 138, 112);
INSERT INTO public.who_global_data VALUES (32513, 7927, 758398, 189, 24039, 138, 111);
INSERT INTO public.who_global_data VALUES (32514, 0, 470, 0, 7, 138, 71);
INSERT INTO public.who_global_data VALUES (32515, 16, 5002, 0, 89, 138, 218);
INSERT INTO public.who_global_data VALUES (32516, 0, 0, 0, 0, 138, 43);
INSERT INTO public.who_global_data VALUES (32517, 1338, 63712, 20, 706, 138, 49);
INSERT INTO public.who_global_data VALUES (32518, 69, 19269, 0, 120, 138, 1);
INSERT INTO public.who_global_data VALUES (32519, 197, 14922, 4, 248, 138, 48);
INSERT INTO public.who_global_data VALUES (32520, 36, 5091, 2, 115, 138, 232);
INSERT INTO public.who_global_data VALUES (32521, 0, 210, 0, 1, 138, 175);
INSERT INTO public.who_global_data VALUES (32522, 20, 1600, 0, 22, 138, 21);
INSERT INTO public.who_global_data VALUES (32523, 934, 49240, 4, 503, 138, 156);
INSERT INTO public.who_global_data VALUES (32524, 0, 0, 0, 0, 138, 95);
INSERT INTO public.who_global_data VALUES (32525, 27, 10514, 3, 271, 138, 177);
INSERT INTO public.who_global_data VALUES (32526, 0, 21847, 0, 635, 138, 210);
INSERT INTO public.who_global_data VALUES (32527, 0, 5403, 0, 61, 138, 120);
INSERT INTO public.who_global_data VALUES (32528, 0, 24, 0, 0, 138, 135);
INSERT INTO public.who_global_data VALUES (32529, 589, 108289, 3, 2047, 138, 206);
INSERT INTO public.who_global_data VALUES (32530, 799, 126419, 1, 11090, 138, 189);
INSERT INTO public.who_global_data VALUES (32531, 115, 102015, 20, 5770, 138, 129);
INSERT INTO public.who_global_data VALUES (32532, 125, 27553, 3, 811, 138, 121);
INSERT INTO public.who_global_data VALUES (32533, 0, 5002, 0, 83, 138, 59);
INSERT INTO public.who_global_data VALUES (32534, 0, 364, 0, 0, 138, 96);
INSERT INTO public.who_global_data VALUES (32535, 49, 2924, 0, 64, 138, 41);
INSERT INTO public.who_global_data VALUES (32536, 24, 5269, 0, 104, 138, 216);
INSERT INTO public.who_global_data VALUES (32537, 689, 68820, 7, 1096, 138, 236);
INSERT INTO public.who_global_data VALUES (32538, 0, 13, 0, 0, 138, 150);
INSERT INTO public.who_global_data VALUES (32539, 3, 434, 0, 0, 138, 61);
INSERT INTO public.who_global_data VALUES (32540, 0, 32, 0, 2, 138, 7);
INSERT INTO public.who_global_data VALUES (32541, 58, 8980, 0, 339, 138, 169);
INSERT INTO public.who_global_data VALUES (32542, 11569, 432424, 11, 31120, 138, 28);
INSERT INTO public.who_global_data VALUES (32543, 0, 9692, 0, 65, 138, 85);
INSERT INTO public.who_global_data VALUES (32544, 35, 1353, 0, 2, 138, 211);
INSERT INTO public.who_global_data VALUES (32545, 0, 8696, 0, 53, 138, 60);
INSERT INTO public.who_global_data VALUES (32546, 22, 3526, 0, 108, 138, 3);
INSERT INTO public.who_global_data VALUES (32547, 193, 3695, 1, 20, 138, 11);
INSERT INTO public.who_global_data VALUES (32548, 922, 272337, 0, 9386, 138, 89);
INSERT INTO public.who_global_data VALUES (32549, 127, 46004, 0, 297, 138, 24);
INSERT INTO public.who_global_data VALUES (32550, 4, 350, 0, 0, 138, 162);
INSERT INTO public.who_global_data VALUES (32551, 164, 15142, 7, 338, 138, 100);
INSERT INTO public.who_global_data VALUES (32552, 0, 14, 0, 0, 138, 47);
INSERT INTO public.who_global_data VALUES (32553, 0, 24, 0, 0, 138, 29);
INSERT INTO public.who_global_data VALUES (32554, 0, 3426, 0, 26, 138, 40);
INSERT INTO public.who_global_data VALUES (32555, 0, 2117, 0, 34, 138, 222);
INSERT INTO public.who_global_data VALUES (32556, 292, 85444, 14, 3119, 138, 132);
INSERT INTO public.who_global_data VALUES (32557, 0, 254, 0, 13, 138, 130);
INSERT INTO public.who_global_data VALUES (32558, 39, 10325, 1, 64, 138, 234);
INSERT INTO public.who_global_data VALUES (32559, 0, 2303, 0, 39, 138, 23);
INSERT INTO public.who_global_data VALUES (32560, 66, 2168, 2, 64, 138, 192);
INSERT INTO public.who_global_data VALUES (32561, 0, 8600, 0, 221, 138, 69);
INSERT INTO public.who_global_data VALUES (32562, 0, 12, 0, 0, 138, 187);
INSERT INTO public.who_global_data VALUES (32563, 532, 71143, 20, 2166, 138, 230);
INSERT INTO public.who_global_data VALUES (32564, 876, 18866, 3, 686, 138, 77);
INSERT INTO public.who_global_data VALUES (32565, 39, 2346, 0, 10, 138, 9);
INSERT INTO public.who_global_data VALUES (32566, 86961, 5487580, 1130, 87882, 138, 74);
INSERT INTO public.who_global_data VALUES (32567, 3989, 244676, 105, 9553, 138, 224);
INSERT INTO public.who_global_data VALUES (32568, 3097, 422140, 183, 24301, 138, 199);
INSERT INTO public.who_global_data VALUES (32569, 3438, 319035, 64, 8555, 138, 190);
INSERT INTO public.who_global_data VALUES (32570, 395, 32933, 0, 1792, 138, 12);
INSERT INTO public.who_global_data VALUES (32571, 0, 339, 0, 24, 138, 104);
INSERT INTO public.who_global_data VALUES (32572, 3809, 185679, 27, 1282, 138, 153);
INSERT INTO public.who_global_data VALUES (32573, 1587, 298156, 15, 35707, 138, 91);
INSERT INTO public.who_global_data VALUES (32574, 230, 4988, 7, 67, 138, 215);
INSERT INTO public.who_global_data VALUES (32575, 483, 79140, 0, 1500, 138, 84);
INSERT INTO public.who_global_data VALUES (32576, 0, 393, 0, 32, 138, 231);
INSERT INTO public.who_global_data VALUES (32577, 239, 4847, 0, 30, 138, 196);
INSERT INTO public.who_global_data VALUES (32578, 87, 138542, 0, 2043, 138, 105);
INSERT INTO public.who_global_data VALUES (32579, 152, 36981, 2, 648, 138, 122);
INSERT INTO public.who_global_data VALUES (32580, 0, 0, 0, 0, 138, 159);
INSERT INTO public.who_global_data VALUES (32581, 61, 15020, 2, 603, 138, 75);
INSERT INTO public.who_global_data VALUES (32582, 385, 99434, 3, 584, 138, 27);
INSERT INTO public.who_global_data VALUES (32583, 55, 45471, 0, 1063, 138, 54);
INSERT INTO public.who_global_data VALUES (32584, 0, 23, 0, 0, 138, 226);
INSERT INTO public.who_global_data VALUES (32585, 10, 1525, 0, 36, 138, 79);
INSERT INTO public.who_global_data VALUES (32586, 1006, 29303, 11, 297, 138, 56);
INSERT INTO public.who_global_data VALUES (32587, 0, 1390, 0, 33, 138, 117);
INSERT INTO public.who_global_data VALUES (32588, 1, 1336, 0, 82, 138, 152);
INSERT INTO public.who_global_data VALUES (32589, 847, 28796, 16, 450, 138, 16);
INSERT INTO public.who_global_data VALUES (32590, 1, 115, 0, 1, 138, 10);
INSERT INTO public.who_global_data VALUES (32591, 70, 3809, 0, 88, 138, 201);
INSERT INTO public.who_global_data VALUES (32592, 86, 7804, 0, 124, 138, 174);
INSERT INTO public.who_global_data VALUES (32593, 33, 16053, 4, 223, 138, 119);
INSERT INTO public.who_global_data VALUES (32594, 13, 5731, 0, 179, 138, 168);
INSERT INTO public.who_global_data VALUES (32595, 52, 10219, 0, 130, 138, 99);
INSERT INTO public.who_global_data VALUES (32596, 75, 9724, 0, 33, 138, 171);
INSERT INTO public.who_global_data VALUES (32597, 7, 3013, 0, 128, 138, 87);
INSERT INTO public.who_global_data VALUES (32598, 46, 2777, 1, 21, 138, 123);
INSERT INTO public.who_global_data VALUES (32599, 0, 0, 0, 0, 138, 151);
INSERT INTO public.who_global_data VALUES (32600, 0, 1122, 0, 18, 138, 213);
INSERT INTO public.who_global_data VALUES (32601, 3, 7368, 0, 161, 138, 118);
INSERT INTO public.who_global_data VALUES (32602, 0, 367, 0, 10, 138, 134);
INSERT INTO public.who_global_data VALUES (32603, 0, 3541, 0, 40, 138, 65);
INSERT INTO public.who_global_data VALUES (32604, 5167, 694121, 455, 73258, 138, 102);
INSERT INTO public.who_global_data VALUES (32605, 0, 0, 0, 0, 138, 223);
INSERT INTO public.who_global_data VALUES (32606, 1, 196, 0, 1, 138, 4);
INSERT INTO public.who_global_data VALUES (32607, 1, 312, 0, 0, 138, 146);
INSERT INTO public.who_global_data VALUES (32608, 199, 9038, 2, 138, 138, 31);
INSERT INTO public.who_global_data VALUES (32609, 0, 13, 0, 1, 138, 127);
INSERT INTO public.who_global_data VALUES (32610, 1927, 101743, 35, 1830, 138, 22);
INSERT INTO public.who_global_data VALUES (32611, 234, 6771, 2, 43, 138, 115);
INSERT INTO public.who_global_data VALUES (32612, 542, 5805, 13, 94, 138, 106);
INSERT INTO public.who_global_data VALUES (32613, 85, 10377, 1, 112, 138, 90);
INSERT INTO public.who_global_data VALUES (32614, 0, 0, 0, 0, 138, 70);
INSERT INTO public.who_global_data VALUES (32615, 1325, 64122, 10, 411, 138, 46);
INSERT INTO public.who_global_data VALUES (32616, 1844, 93650, 4, 6278, 138, 139);
INSERT INTO public.who_global_data VALUES (32617, 0, 26, 0, 0, 138, 42);
INSERT INTO public.who_global_data VALUES (32618, 0, 1464, 0, 25, 138, 80);
INSERT INTO public.who_global_data VALUES (32619, 0, 3979, 0, 147, 138, 203);
INSERT INTO public.who_global_data VALUES (32620, 1, 1183, 0, 69, 138, 136);
INSERT INTO public.who_global_data VALUES (32621, 97, 57242, 3, 1098, 138, 63);
INSERT INTO public.who_global_data VALUES (32622, 0, 0, 0, 0, 138, 17);
INSERT INTO public.who_global_data VALUES (32623, 0, 68, 0, 2, 138, 172);
INSERT INTO public.who_global_data VALUES (32624, 178, 16735, 4, 693, 138, 109);
INSERT INTO public.who_global_data VALUES (32625, 0, 12645, 0, 267, 138, 200);
INSERT INTO public.who_global_data VALUES (32626, 683, 45446, 9, 300, 138, 93);
INSERT INTO public.who_global_data VALUES (32627, 1722, 93475, 28, 846, 138, 5);
INSERT INTO public.who_global_data VALUES (32628, 0, 741, 0, 13, 138, 214);
INSERT INTO public.who_global_data VALUES (32629, 633, 306304, 4, 6420, 138, 204);
INSERT INTO public.who_global_data VALUES (32630, 0, 0, 0, 0, 138, 198);
INSERT INTO public.who_global_data VALUES (32631, 722, 105601, 18, 2247, 138, 173);
INSERT INTO public.who_global_data VALUES (32632, 1, 517, 1, 7, 138, 229);
INSERT INTO public.who_global_data VALUES (32633, 888, 33015, 25, 636, 138, 76);
INSERT INTO public.who_global_data VALUES (32634, 6453, 762865, 86, 31369, 138, 138);
INSERT INTO public.who_global_data VALUES (32635, 3283, 286743, 54, 4984, 138, 98);
INSERT INTO public.who_global_data VALUES (32636, 0, 0, 0, 0, 138, 103);
INSERT INTO public.who_global_data VALUES (32637, 910, 79240, 11, 2293, 138, 225);
INSERT INTO public.who_global_data VALUES (32638, 552, 68577, 13, 1912, 138, 131);
INSERT INTO public.who_global_data VALUES (32639, 845, 41838, 3, 608, 138, 235);
INSERT INTO public.who_global_data VALUES (32640, 230, 123376, 1, 210, 138, 137);
INSERT INTO public.who_global_data VALUES (32641, 70, 23045, 2, 385, 138, 81);
INSERT INTO public.who_global_data VALUES (32642, 260, 46596, 2, 1203, 138, 182);
INSERT INTO public.who_global_data VALUES (32643, 0, 3194, 0, 10, 138, 145);
INSERT INTO public.who_global_data VALUES (32644, 1231, 112781, 33, 4435, 138, 26);
INSERT INTO public.who_global_data VALUES (32645, 6196, 1109595, 71, 19489, 138, 170);
INSERT INTO public.who_global_data VALUES (32646, 40, 4711, 1, 26, 138, 191);
INSERT INTO public.who_global_data VALUES (32647, 0, 5, 0, 0, 138, 221);
INSERT INTO public.who_global_data VALUES (32648, 0, 23, 0, 0, 138, 64);
INSERT INTO public.who_global_data VALUES (32649, 0, 0, 0, 0, 138, 116);
INSERT INTO public.who_global_data VALUES (32650, 0, 17, 0, 0, 138, 128);
INSERT INTO public.who_global_data VALUES (32651, 0, 27, 0, 0, 138, 6);
INSERT INTO public.who_global_data VALUES (32652, 0, 330, 0, 6, 138, 227);
INSERT INTO public.who_global_data VALUES (32653, 0, 11, 0, 0, 138, 68);
INSERT INTO public.who_global_data VALUES (32654, 0, 64, 0, 0, 138, 184);
INSERT INTO public.who_global_data VALUES (32655, 0, 0, 0, 0, 138, 82);
INSERT INTO public.who_global_data VALUES (32656, 0, 742, 0, 42, 138, 149);
INSERT INTO public.who_global_data VALUES (32657, 0, 908, 0, 15, 138, 197);
INSERT INTO public.who_global_data VALUES (32658, 483, 329754, 27, 4485, 138, 78);
INSERT INTO public.who_global_data VALUES (32659, 26, 14714, 0, 302, 138, 233);
INSERT INTO public.who_global_data VALUES (32660, 68, 32908, 1, 741, 138, 133);
INSERT INTO public.who_global_data VALUES (32661, 0, 139, 0, 0, 138, 35);
INSERT INTO public.who_global_data VALUES (32662, 9, 2168, 0, 72, 138, 114);
INSERT INTO public.who_global_data VALUES (32663, 18, 57576, 0, 27, 138, 237);
INSERT INTO public.who_global_data VALUES (32664, 0, 11, 0, 0, 138, 55);
INSERT INTO public.who_global_data VALUES (32665, 0, 565, 0, 19, 138, 176);
INSERT INTO public.who_global_data VALUES (32666, 131, 6677, 0, 39, 138, 202);
INSERT INTO public.who_global_data VALUES (32667, 50, 4471, 0, 145, 138, 155);
INSERT INTO public.who_global_data VALUES (32668, 0, 0, 0, 0, 138, 32);
INSERT INTO public.who_global_data VALUES (32669, 41, 3442, 0, 98, 138, 220);
INSERT INTO public.who_global_data VALUES (32670, 1555, 661211, 13, 15953, 138, 30);
INSERT INTO public.who_global_data VALUES (32671, 7, 2649, 0, 49, 138, 147);
INSERT INTO public.who_global_data VALUES (32672, 8428, 714446, 117, 32698, 138, 208);
INSERT INTO public.who_global_data VALUES (32673, 4, 3287, 0, 13, 138, 45);
INSERT INTO public.who_global_data VALUES (32674, 21, 13576, 0, 836, 138, 110);
INSERT INTO public.who_global_data VALUES (32675, 18, 4709, 1, 97, 138, 88);
INSERT INTO public.who_global_data VALUES (32676, 279, 89106, 1, 5861, 138, 51);
INSERT INTO public.who_global_data VALUES (32677, 200, 50467, 0, 1804, 138, 209);
INSERT INTO public.who_global_data VALUES (32678, 35, 3800, 2, 172, 138, 205);
INSERT INTO public.who_global_data VALUES (32679, 43, 9346, 0, 73, 138, 18);
INSERT INTO public.who_global_data VALUES (32680, 0, 3506, 0, 59, 138, 72);
INSERT INTO public.who_global_data VALUES (32681, 3899, 394261, 18, 41777, 138, 44);
INSERT INTO public.who_global_data VALUES (32682, 0, 27, 0, 0, 138, 15);
INSERT INTO public.who_global_data VALUES (32683, 26, 1666, 0, 41, 138, 25);
INSERT INTO public.who_global_data VALUES (32684, 0, 0, 0, 0, 138, 179);
INSERT INTO public.who_global_data VALUES (32685, 0, 0, 0, 0, 138, 34);
INSERT INTO public.who_global_data VALUES (32686, 127, 3866, 4, 64, 138, 207);
INSERT INTO public.who_global_data VALUES (32687, 528, 11260, 5, 164, 138, 166);
INSERT INTO public.who_global_data VALUES (32688, 8249, 673017, 61, 7506, 138, 126);
INSERT INTO public.who_global_data VALUES (32689, 0, 0, 0, 0, 138, 97);
INSERT INTO public.who_global_data VALUES (32690, 1, 668, 0, 5, 138, 36);
INSERT INTO public.who_global_data VALUES (32691, 0, 0, 0, 0, 138, 125);
INSERT INTO public.who_global_data VALUES (32692, 270, 6287, 0, 63, 138, 124);
INSERT INTO public.who_global_data VALUES (32693, 2675, 178353, 26, 3583, 138, 185);
INSERT INTO public.who_global_data VALUES (32694, 674, 84916, 0, 404, 138, 194);
INSERT INTO public.who_global_data VALUES (32695, 0, 509, 0, 21, 138, 144);
INSERT INTO public.who_global_data VALUES (32696, 41695, 6703698, 652, 198094, 138, 19);
INSERT INTO public.who_global_data VALUES (32697, 27, 1269, 0, 19, 138, 217);
INSERT INTO public.who_global_data VALUES (32698, 14, 1904, 0, 46, 138, 148);
INSERT INTO public.who_global_data VALUES (32699, 554, 51789, 6, 435, 138, 86);
INSERT INTO public.who_global_data VALUES (32700, 0, 0, 0, 0, 138, 13);
INSERT INTO public.who_global_data VALUES (32701, 775, 65949, 9, 539, 138, 157);
INSERT INTO public.who_global_data VALUES (32702, 0, 1068, 0, 35, 138, 8);
INSERT INTO public.who_global_data VALUES (32703, 0, 0, 0, 0, 138, 73);
INSERT INTO public.who_global_data VALUES (32704, 0, 2030, 1, 587, 138, 101);
INSERT INTO public.who_global_data VALUES (32705, 107, 14131, 1, 330, 138, 165);
INSERT INTO public.who_global_data VALUES (32706, 11, 7683, 0, 225, 138, 14);
INSERT INTO public.who_global_data VALUES (32707, 125, 39130, 4, 1445, 139, 193);
INSERT INTO public.who_global_data VALUES (32708, 153, 12226, 5, 358, 139, 113);
INSERT INTO public.who_global_data VALUES (32709, 210, 49623, 6, 1665, 139, 143);
INSERT INTO public.who_global_data VALUES (32710, 0, 0, 0, 0, 139, 219);
INSERT INTO public.who_global_data VALUES (32711, 0, 1564, 0, 53, 139, 186);
INSERT INTO public.who_global_data VALUES (32712, 53, 3901, 0, 147, 139, 52);
INSERT INTO public.who_global_data VALUES (32713, 0, 3, 0, 0, 139, 180);
INSERT INTO public.who_global_data VALUES (32714, 0, 95, 0, 3, 139, 167);
INSERT INTO public.who_global_data VALUES (32715, 11945, 613658, 214, 12705, 139, 154);
INSERT INTO public.who_global_data VALUES (32716, 277, 46744, 2, 925, 139, 94);
INSERT INTO public.who_global_data VALUES (32717, 0, 3382, 0, 23, 139, 66);
INSERT INTO public.who_global_data VALUES (32718, 24, 26885, 7, 844, 139, 58);
INSERT INTO public.who_global_data VALUES (32719, 757, 37948, 2, 765, 139, 163);
INSERT INTO public.who_global_data VALUES (32720, 148, 39042, 2, 574, 139, 37);
INSERT INTO public.who_global_data VALUES (32721, 0, 3177, 0, 69, 139, 142);
INSERT INTO public.who_global_data VALUES (32722, 620, 64499, 1, 221, 139, 83);
INSERT INTO public.who_global_data VALUES (32723, 1567, 347372, 32, 4913, 139, 228);
INSERT INTO public.who_global_data VALUES (32724, 0, 185, 0, 7, 139, 188);
INSERT INTO public.who_global_data VALUES (32725, 231, 75461, 3, 776, 139, 62);
INSERT INTO public.who_global_data VALUES (32726, 894, 104956, 8, 9944, 139, 160);
INSERT INTO public.who_global_data VALUES (32727, 23, 1590, 1, 20, 139, 50);
INSERT INTO public.who_global_data VALUES (32728, 0, 2280, 0, 40, 139, 33);
INSERT INTO public.who_global_data VALUES (32729, 0, 178, 0, 9, 139, 183);
INSERT INTO public.who_global_data VALUES (32730, 1, 259, 0, 0, 139, 92);
INSERT INTO public.who_global_data VALUES (32731, 632, 130051, 39, 7550, 139, 158);
INSERT INTO public.who_global_data VALUES (32732, 0, 20, 0, 1, 139, 67);
INSERT INTO public.who_global_data VALUES (32733, 320, 25212, 6, 752, 139, 57);
INSERT INTO public.who_global_data VALUES (32734, 0, 2567, 0, 13, 139, 38);
INSERT INTO public.who_global_data VALUES (32735, 39797, 4495183, 858, 135793, 139, 141);
INSERT INTO public.who_global_data VALUES (32736, 2, 71, 0, 1, 139, 178);
INSERT INTO public.who_global_data VALUES (32737, 0, 145, 0, 3, 139, 108);
INSERT INTO public.who_global_data VALUES (32738, 86, 18819, 2, 755, 139, 39);
INSERT INTO public.who_global_data VALUES (32739, 30, 1797, 0, 56, 139, 2);
INSERT INTO public.who_global_data VALUES (32740, 0, 473, 0, 1, 139, 195);
INSERT INTO public.who_global_data VALUES (32741, 45, 5186, 0, 50, 139, 107);
INSERT INTO public.who_global_data VALUES (32742, 0, 275, 0, 0, 139, 161);
INSERT INTO public.who_global_data VALUES (32743, 0, 20431, 0, 416, 139, 212);
INSERT INTO public.who_global_data VALUES (32744, 1044, 141911, 5, 9205, 139, 181);
INSERT INTO public.who_global_data VALUES (32745, 0, 208, 0, 1, 139, 53);
INSERT INTO public.who_global_data VALUES (32746, 7, 4793, 0, 62, 139, 164);
INSERT INTO public.who_global_data VALUES (32747, 2, 1149, 0, 81, 139, 140);
INSERT INTO public.who_global_data VALUES (32748, 1847, 444674, 55, 12254, 139, 20);
INSERT INTO public.who_global_data VALUES (32749, 26, 90840, 0, 4744, 139, 112);
INSERT INTO public.who_global_data VALUES (32750, 6526, 750471, 185, 23850, 139, 111);
INSERT INTO public.who_global_data VALUES (32751, 0, 470, 0, 7, 139, 71);
INSERT INTO public.who_global_data VALUES (32752, 0, 4986, 0, 89, 139, 218);
INSERT INTO public.who_global_data VALUES (32753, 0, 0, 0, 0, 139, 43);
INSERT INTO public.who_global_data VALUES (32754, 1556, 62374, 20, 686, 139, 49);
INSERT INTO public.who_global_data VALUES (32755, 0, 19200, 0, 120, 139, 1);
INSERT INTO public.who_global_data VALUES (32756, 212, 14725, 0, 244, 139, 48);
INSERT INTO public.who_global_data VALUES (32757, 51, 5055, 2, 113, 139, 232);
INSERT INTO public.who_global_data VALUES (32758, 0, 210, 0, 1, 139, 175);
INSERT INTO public.who_global_data VALUES (32759, 15, 1580, 0, 22, 139, 21);
INSERT INTO public.who_global_data VALUES (32760, 2044, 48306, 4, 499, 139, 156);
INSERT INTO public.who_global_data VALUES (32761, 0, 0, 0, 0, 139, 95);
INSERT INTO public.who_global_data VALUES (32762, 32, 10487, 0, 268, 139, 177);
INSERT INTO public.who_global_data VALUES (32763, 0, 21847, 0, 635, 139, 210);
INSERT INTO public.who_global_data VALUES (32764, 0, 5403, 0, 61, 139, 120);
INSERT INTO public.who_global_data VALUES (32765, 0, 24, 0, 0, 139, 135);
INSERT INTO public.who_global_data VALUES (32766, 968, 107700, 10, 2044, 139, 206);
INSERT INTO public.who_global_data VALUES (32767, 3363, 125620, 60, 11089, 139, 189);
INSERT INTO public.who_global_data VALUES (32768, 128, 101900, 17, 5750, 139, 129);
INSERT INTO public.who_global_data VALUES (32769, 82, 27428, 4, 808, 139, 121);
INSERT INTO public.who_global_data VALUES (32770, 0, 5002, 0, 83, 139, 59);
INSERT INTO public.who_global_data VALUES (32771, 0, 364, 0, 0, 139, 96);
INSERT INTO public.who_global_data VALUES (32772, 61, 2875, 0, 64, 139, 41);
INSERT INTO public.who_global_data VALUES (32773, 30, 5245, 1, 104, 139, 216);
INSERT INTO public.who_global_data VALUES (32774, 616, 68131, 17, 1089, 139, 236);
INSERT INTO public.who_global_data VALUES (32775, 0, 13, 0, 0, 139, 150);
INSERT INTO public.who_global_data VALUES (32776, 1, 431, 0, 0, 139, 61);
INSERT INTO public.who_global_data VALUES (32777, 0, 32, 0, 2, 139, 7);
INSERT INTO public.who_global_data VALUES (32778, 64, 8922, 0, 339, 139, 169);
INSERT INTO public.who_global_data VALUES (32779, 13465, 420855, 25, 31109, 139, 28);
INSERT INTO public.who_global_data VALUES (32780, 33, 9692, 0, 65, 139, 85);
INSERT INTO public.who_global_data VALUES (32781, 47, 1318, 0, 2, 139, 211);
INSERT INTO public.who_global_data VALUES (32782, 0, 8696, 0, 53, 139, 60);
INSERT INTO public.who_global_data VALUES (32783, 0, 3504, 0, 108, 139, 3);
INSERT INTO public.who_global_data VALUES (32784, 196, 3502, 0, 19, 139, 11);
INSERT INTO public.who_global_data VALUES (32785, 1345, 271415, 2, 9386, 139, 89);
INSERT INTO public.who_global_data VALUES (32786, 20, 45877, 2, 297, 139, 24);
INSERT INTO public.who_global_data VALUES (32787, 3, 346, 0, 0, 139, 162);
INSERT INTO public.who_global_data VALUES (32788, 240, 14978, 4, 331, 139, 100);
INSERT INTO public.who_global_data VALUES (32789, 0, 14, 0, 0, 139, 47);
INSERT INTO public.who_global_data VALUES (32790, 0, 24, 0, 0, 139, 29);
INSERT INTO public.who_global_data VALUES (32791, 0, 3426, 0, 26, 139, 40);
INSERT INTO public.who_global_data VALUES (32792, 43, 2117, 1, 34, 139, 222);
INSERT INTO public.who_global_data VALUES (32793, 808, 85152, 29, 3105, 139, 132);
INSERT INTO public.who_global_data VALUES (32794, 1, 254, 0, 13, 139, 130);
INSERT INTO public.who_global_data VALUES (32795, 55, 10286, 0, 63, 139, 234);
INSERT INTO public.who_global_data VALUES (32796, 0, 2303, 0, 39, 139, 23);
INSERT INTO public.who_global_data VALUES (32797, 75, 2102, 0, 62, 139, 192);
INSERT INTO public.who_global_data VALUES (32798, 44, 8600, 1, 221, 139, 69);
INSERT INTO public.who_global_data VALUES (32799, 0, 12, 0, 0, 139, 187);
INSERT INTO public.who_global_data VALUES (32800, 491, 70611, 24, 2146, 139, 230);
INSERT INTO public.who_global_data VALUES (32801, 1070, 17990, 8, 683, 139, 77);
INSERT INTO public.who_global_data VALUES (32802, 77, 2307, 0, 10, 139, 9);
INSERT INTO public.who_global_data VALUES (32803, 92605, 5400619, 1133, 86752, 139, 74);
INSERT INTO public.who_global_data VALUES (32804, 4168, 240687, 112, 9448, 139, 224);
INSERT INTO public.who_global_data VALUES (32805, 2845, 419043, 166, 24118, 139, 199);
INSERT INTO public.who_global_data VALUES (32806, 3907, 315597, 83, 8491, 139, 190);
INSERT INTO public.who_global_data VALUES (32807, 267, 32538, 0, 1792, 139, 12);
INSERT INTO public.who_global_data VALUES (32808, 0, 339, 0, 24, 139, 104);
INSERT INTO public.who_global_data VALUES (32809, 5340, 181870, 20, 1255, 139, 153);
INSERT INTO public.who_global_data VALUES (32810, 1637, 296569, 24, 35692, 139, 91);
INSERT INTO public.who_global_data VALUES (32811, 187, 4758, 5, 60, 139, 215);
INSERT INTO public.who_global_data VALUES (32812, 584, 78657, 5, 1500, 139, 84);
INSERT INTO public.who_global_data VALUES (32813, 2, 393, 0, 32, 139, 231);
INSERT INTO public.who_global_data VALUES (32814, 196, 4608, 1, 30, 139, 196);
INSERT INTO public.who_global_data VALUES (32815, 107, 138455, 44, 2043, 139, 105);
INSERT INTO public.who_global_data VALUES (32816, 105, 36829, 0, 646, 139, 122);
INSERT INTO public.who_global_data VALUES (32817, 0, 0, 0, 0, 139, 159);
INSERT INTO public.who_global_data VALUES (32818, 63, 14959, 0, 601, 139, 75);
INSERT INTO public.who_global_data VALUES (32819, 521, 99049, 1, 581, 139, 27);
INSERT INTO public.who_global_data VALUES (32820, 81, 45416, 0, 1063, 139, 54);
INSERT INTO public.who_global_data VALUES (32821, 0, 23, 0, 0, 139, 226);
INSERT INTO public.who_global_data VALUES (32822, 17, 1515, 0, 36, 139, 79);
INSERT INTO public.who_global_data VALUES (32823, 779, 28297, 5, 286, 139, 56);
INSERT INTO public.who_global_data VALUES (32824, 0, 1390, 0, 33, 139, 117);
INSERT INTO public.who_global_data VALUES (32825, 1, 1335, 0, 82, 139, 152);
INSERT INTO public.who_global_data VALUES (32826, 715, 27949, 8, 434, 139, 16);
INSERT INTO public.who_global_data VALUES (32827, 1, 114, 0, 1, 139, 10);
INSERT INTO public.who_global_data VALUES (32828, 80, 3739, 0, 88, 139, 201);
INSERT INTO public.who_global_data VALUES (32829, 0, 7718, 0, 124, 139, 174);
INSERT INTO public.who_global_data VALUES (32830, 49, 16020, 2, 219, 139, 119);
INSERT INTO public.who_global_data VALUES (32831, 2, 5718, 0, 179, 139, 168);
INSERT INTO public.who_global_data VALUES (32832, 20, 10167, 1, 130, 139, 99);
INSERT INTO public.who_global_data VALUES (32833, 81, 9649, 0, 33, 139, 171);
INSERT INTO public.who_global_data VALUES (32834, 15, 3006, 0, 128, 139, 87);
INSERT INTO public.who_global_data VALUES (32835, 32, 2731, 1, 20, 139, 123);
INSERT INTO public.who_global_data VALUES (32836, 0, 0, 0, 0, 139, 151);
INSERT INTO public.who_global_data VALUES (32837, 0, 1122, 0, 18, 139, 213);
INSERT INTO public.who_global_data VALUES (32838, 4, 7365, 0, 161, 139, 118);
INSERT INTO public.who_global_data VALUES (32839, 0, 367, 0, 10, 139, 134);
INSERT INTO public.who_global_data VALUES (32840, 0, 3541, 0, 40, 139, 65);
INSERT INTO public.who_global_data VALUES (32841, 4841, 688954, 624, 72803, 139, 102);
INSERT INTO public.who_global_data VALUES (32842, 0, 0, 0, 0, 139, 223);
INSERT INTO public.who_global_data VALUES (32843, 1, 195, 0, 1, 139, 4);
INSERT INTO public.who_global_data VALUES (32844, 0, 311, 0, 0, 139, 146);
INSERT INTO public.who_global_data VALUES (32845, 238, 8839, 2, 136, 139, 31);
INSERT INTO public.who_global_data VALUES (32846, 0, 13, 0, 1, 139, 127);
INSERT INTO public.who_global_data VALUES (32847, 2552, 99816, 40, 1795, 139, 22);
INSERT INTO public.who_global_data VALUES (32848, 273, 6537, 1, 41, 139, 115);
INSERT INTO public.who_global_data VALUES (32849, 642, 5263, 6, 81, 139, 106);
INSERT INTO public.who_global_data VALUES (32850, 85, 10292, 3, 111, 139, 90);
INSERT INTO public.who_global_data VALUES (32851, 0, 0, 0, 0, 139, 70);
INSERT INTO public.who_global_data VALUES (32852, 1204, 62797, 11, 401, 139, 46);
INSERT INTO public.who_global_data VALUES (32853, 1892, 91806, 3, 6274, 139, 139);
INSERT INTO public.who_global_data VALUES (32854, 0, 26, 0, 0, 139, 42);
INSERT INTO public.who_global_data VALUES (32855, 4, 1464, 0, 25, 139, 80);
INSERT INTO public.who_global_data VALUES (32856, 0, 3979, 0, 147, 139, 203);
INSERT INTO public.who_global_data VALUES (32857, 0, 1182, 0, 69, 139, 136);
INSERT INTO public.who_global_data VALUES (32858, 189, 57145, 1, 1095, 139, 63);
INSERT INTO public.who_global_data VALUES (32859, 0, 0, 0, 0, 139, 17);
INSERT INTO public.who_global_data VALUES (32860, 6, 68, 0, 2, 139, 172);
INSERT INTO public.who_global_data VALUES (32861, 140, 16557, 6, 689, 139, 109);
INSERT INTO public.who_global_data VALUES (32862, 0, 12645, 0, 267, 139, 200);
INSERT INTO public.who_global_data VALUES (32863, 726, 44763, 5, 291, 139, 93);
INSERT INTO public.who_global_data VALUES (32864, 0, 91753, 0, 818, 139, 5);
INSERT INTO public.who_global_data VALUES (32865, 0, 741, 0, 13, 139, 214);
INSERT INTO public.who_global_data VALUES (32866, 640, 305671, 1, 6416, 139, 204);
INSERT INTO public.who_global_data VALUES (32867, 0, 0, 0, 0, 139, 198);
INSERT INTO public.who_global_data VALUES (32868, 741, 104879, 16, 2229, 139, 173);
INSERT INTO public.who_global_data VALUES (32869, 0, 516, 0, 6, 139, 229);
INSERT INTO public.who_global_data VALUES (32870, 1014, 32127, 27, 611, 139, 76);
INSERT INTO public.who_global_data VALUES (32871, 6314, 756412, 137, 31283, 139, 138);
INSERT INTO public.who_global_data VALUES (32872, 3934, 283460, 100, 4930, 139, 98);
INSERT INTO public.who_global_data VALUES (32873, 0, 0, 0, 0, 139, 103);
INSERT INTO public.who_global_data VALUES (32874, 1002, 78330, 12, 2282, 139, 225);
INSERT INTO public.who_global_data VALUES (32875, 849, 68025, 5, 1899, 139, 131);
INSERT INTO public.who_global_data VALUES (32876, 1309, 40993, 6, 605, 139, 235);
INSERT INTO public.who_global_data VALUES (32877, 229, 123146, 0, 209, 139, 137);
INSERT INTO public.who_global_data VALUES (32878, 82, 22975, 5, 383, 139, 81);
INSERT INTO public.who_global_data VALUES (32879, 688, 46336, 15, 1201, 139, 182);
INSERT INTO public.who_global_data VALUES (32880, 0, 3194, 0, 10, 139, 145);
INSERT INTO public.who_global_data VALUES (32881, 1333, 111550, 42, 4402, 139, 26);
INSERT INTO public.who_global_data VALUES (32882, 6148, 1103399, 79, 19418, 139, 170);
INSERT INTO public.who_global_data VALUES (32883, 0, 4671, 0, 25, 139, 191);
INSERT INTO public.who_global_data VALUES (32884, 0, 5, 0, 0, 139, 221);
INSERT INTO public.who_global_data VALUES (32885, 0, 23, 0, 0, 139, 64);
INSERT INTO public.who_global_data VALUES (32886, 0, 0, 0, 0, 139, 116);
INSERT INTO public.who_global_data VALUES (32887, 0, 17, 0, 0, 139, 128);
INSERT INTO public.who_global_data VALUES (32888, 0, 27, 0, 0, 139, 6);
INSERT INTO public.who_global_data VALUES (32889, 0, 330, 0, 6, 139, 227);
INSERT INTO public.who_global_data VALUES (32890, 0, 11, 0, 0, 139, 68);
INSERT INTO public.who_global_data VALUES (32891, 0, 64, 0, 0, 139, 184);
INSERT INTO public.who_global_data VALUES (32892, 0, 0, 0, 0, 139, 82);
INSERT INTO public.who_global_data VALUES (32893, 0, 742, 0, 42, 139, 149);
INSERT INTO public.who_global_data VALUES (32894, 0, 908, 0, 15, 139, 197);
INSERT INTO public.who_global_data VALUES (32895, 551, 329271, 28, 4458, 139, 78);
INSERT INTO public.who_global_data VALUES (32896, 43, 14688, 1, 302, 139, 233);
INSERT INTO public.who_global_data VALUES (32897, 83, 32840, 1, 740, 139, 133);
INSERT INTO public.who_global_data VALUES (32898, 0, 139, 0, 0, 139, 35);
INSERT INTO public.who_global_data VALUES (32899, 6, 2159, 0, 72, 139, 114);
INSERT INTO public.who_global_data VALUES (32900, 15, 57558, 0, 27, 139, 237);
INSERT INTO public.who_global_data VALUES (32901, 0, 11, 0, 0, 139, 55);
INSERT INTO public.who_global_data VALUES (32902, 0, 565, 0, 19, 139, 176);
INSERT INTO public.who_global_data VALUES (32903, 290, 6546, 0, 39, 139, 202);
INSERT INTO public.who_global_data VALUES (32904, 111, 4421, 1, 145, 139, 155);
INSERT INTO public.who_global_data VALUES (32905, 0, 0, 0, 0, 139, 32);
INSERT INTO public.who_global_data VALUES (32906, 11, 3401, 0, 98, 139, 220);
INSERT INTO public.who_global_data VALUES (32907, 2029, 659656, 83, 15940, 139, 30);
INSERT INTO public.who_global_data VALUES (32908, 0, 2642, 0, 49, 139, 147);
INSERT INTO public.who_global_data VALUES (32909, 16960, 706018, 115, 32581, 139, 208);
INSERT INTO public.who_global_data VALUES (32910, 2, 3283, 0, 13, 139, 45);
INSERT INTO public.who_global_data VALUES (32911, 0, 13555, 0, 836, 139, 110);
INSERT INTO public.who_global_data VALUES (32912, 20, 4691, 1, 96, 139, 88);
INSERT INTO public.who_global_data VALUES (32913, 437, 88827, 1, 5860, 139, 51);
INSERT INTO public.who_global_data VALUES (32914, 284, 50267, 1, 1804, 139, 209);
INSERT INTO public.who_global_data VALUES (32915, 34, 3765, 2, 170, 139, 205);
INSERT INTO public.who_global_data VALUES (32916, 44, 9303, 0, 73, 139, 18);
INSERT INTO public.who_global_data VALUES (32917, 6, 3506, 0, 59, 139, 72);
INSERT INTO public.who_global_data VALUES (32918, 4422, 390362, 27, 41759, 139, 44);
INSERT INTO public.who_global_data VALUES (32919, 0, 27, 0, 0, 139, 15);
INSERT INTO public.who_global_data VALUES (32920, 0, 1640, 0, 41, 139, 25);
INSERT INTO public.who_global_data VALUES (32921, 0, 0, 0, 0, 139, 179);
INSERT INTO public.who_global_data VALUES (32922, 0, 0, 0, 0, 139, 34);
INSERT INTO public.who_global_data VALUES (32923, 227, 3739, 0, 60, 139, 207);
INSERT INTO public.who_global_data VALUES (32924, 996, 10732, 4, 159, 139, 166);
INSERT INTO public.who_global_data VALUES (32925, 8268, 664768, 68, 7445, 139, 126);
INSERT INTO public.who_global_data VALUES (32926, 0, 0, 0, 0, 139, 97);
INSERT INTO public.who_global_data VALUES (32927, 4, 667, 0, 5, 139, 36);
INSERT INTO public.who_global_data VALUES (32928, 0, 0, 0, 0, 139, 125);
INSERT INTO public.who_global_data VALUES (32929, 427, 6017, 2, 63, 139, 124);
INSERT INTO public.who_global_data VALUES (32930, 2966, 175678, 41, 3557, 139, 185);
INSERT INTO public.who_global_data VALUES (32931, 809, 84242, 1, 404, 139, 194);
INSERT INTO public.who_global_data VALUES (32932, 0, 509, 0, 21, 139, 144);
INSERT INTO public.who_global_data VALUES (32933, 48266, 6662003, 977, 197442, 139, 19);
INSERT INTO public.who_global_data VALUES (32934, 0, 1242, 0, 19, 139, 217);
INSERT INTO public.who_global_data VALUES (32935, 14, 1890, 0, 46, 139, 148);
INSERT INTO public.who_global_data VALUES (32936, 601, 51235, 6, 429, 139, 86);
INSERT INTO public.who_global_data VALUES (32937, 0, 0, 0, 0, 139, 13);
INSERT INTO public.who_global_data VALUES (32938, 890, 65174, 10, 530, 139, 157);
INSERT INTO public.who_global_data VALUES (32939, 0, 1068, 0, 35, 139, 8);
INSERT INTO public.who_global_data VALUES (32940, 0, 0, 0, 0, 139, 73);
INSERT INTO public.who_global_data VALUES (32941, 2, 2030, 0, 586, 139, 101);
INSERT INTO public.who_global_data VALUES (32942, 0, 14024, 0, 329, 139, 165);
INSERT INTO public.who_global_data VALUES (32943, 25, 7672, 1, 225, 139, 14);
INSERT INTO public.who_global_data VALUES (32944, 36, 39005, 0, 1441, 140, 193);
INSERT INTO public.who_global_data VALUES (32945, 125, 12073, 6, 353, 140, 113);
INSERT INTO public.who_global_data VALUES (32946, 219, 49413, 5, 1659, 140, 143);
INSERT INTO public.who_global_data VALUES (32947, 0, 0, 0, 0, 140, 219);
INSERT INTO public.who_global_data VALUES (32948, 81, 1564, 0, 53, 140, 186);
INSERT INTO public.who_global_data VALUES (32949, 59, 3848, 3, 147, 140, 52);
INSERT INTO public.who_global_data VALUES (32950, 0, 3, 0, 0, 140, 180);
INSERT INTO public.who_global_data VALUES (32951, 0, 95, 0, 3, 140, 167);
INSERT INTO public.who_global_data VALUES (32952, 12701, 601713, 262, 12491, 140, 154);
INSERT INTO public.who_global_data VALUES (32953, 244, 46467, 2, 923, 140, 94);
INSERT INTO public.who_global_data VALUES (32954, 54, 3382, 1, 23, 140, 66);
INSERT INTO public.who_global_data VALUES (32955, 48, 26861, 5, 837, 140, 58);
INSERT INTO public.who_global_data VALUES (32956, 821, 37191, 5, 763, 140, 163);
INSERT INTO public.who_global_data VALUES (32957, 117, 38894, 1, 572, 140, 37);
INSERT INTO public.who_global_data VALUES (32958, 90, 3177, 0, 69, 140, 142);
INSERT INTO public.who_global_data VALUES (32959, 690, 63879, 3, 220, 140, 83);
INSERT INTO public.who_global_data VALUES (32960, 1541, 345805, 22, 4881, 140, 228);
INSERT INTO public.who_global_data VALUES (32961, 0, 185, 0, 7, 140, 188);
INSERT INTO public.who_global_data VALUES (32962, 243, 75230, 2, 773, 140, 62);
INSERT INTO public.who_global_data VALUES (32963, 1709, 104062, 6, 9936, 140, 160);
INSERT INTO public.who_global_data VALUES (32964, 31, 1567, 0, 19, 140, 50);
INSERT INTO public.who_global_data VALUES (32965, 0, 2280, 0, 40, 140, 33);
INSERT INTO public.who_global_data VALUES (32966, 0, 178, 0, 9, 140, 183);
INSERT INTO public.who_global_data VALUES (32967, 6, 258, 0, 0, 140, 92);
INSERT INTO public.who_global_data VALUES (32968, 547, 129419, 33, 7511, 140, 158);
INSERT INTO public.who_global_data VALUES (32969, 0, 20, 0, 1, 140, 67);
INSERT INTO public.who_global_data VALUES (32970, 292, 24892, 5, 746, 140, 57);
INSERT INTO public.who_global_data VALUES (32971, 0, 2567, 0, 13, 140, 38);
INSERT INTO public.who_global_data VALUES (32972, 36303, 4455386, 829, 134935, 140, 141);
INSERT INTO public.who_global_data VALUES (32973, 0, 69, 0, 1, 140, 178);
INSERT INTO public.who_global_data VALUES (32974, 0, 145, 0, 3, 140, 108);
INSERT INTO public.who_global_data VALUES (32975, 189, 18733, 9, 753, 140, 39);
INSERT INTO public.who_global_data VALUES (32976, 19, 1767, 0, 56, 140, 2);
INSERT INTO public.who_global_data VALUES (32977, 0, 473, 0, 1, 140, 195);
INSERT INTO public.who_global_data VALUES (32978, 78, 5141, 1, 50, 140, 107);
INSERT INTO public.who_global_data VALUES (32979, 0, 275, 0, 0, 140, 161);
INSERT INTO public.who_global_data VALUES (32980, 128, 20431, 1, 416, 140, 212);
INSERT INTO public.who_global_data VALUES (32981, 1120, 140867, 7, 9200, 140, 181);
INSERT INTO public.who_global_data VALUES (32982, 0, 208, 0, 1, 140, 53);
INSERT INTO public.who_global_data VALUES (32983, 0, 4786, 0, 62, 140, 164);
INSERT INTO public.who_global_data VALUES (32984, 32, 1147, 0, 81, 140, 140);
INSERT INTO public.who_global_data VALUES (32985, 1677, 442827, 57, 12199, 140, 20);
INSERT INTO public.who_global_data VALUES (32986, 17, 90814, 1, 4744, 140, 112);
INSERT INTO public.who_global_data VALUES (32987, 7568, 743945, 187, 23665, 140, 111);
INSERT INTO public.who_global_data VALUES (32988, 0, 470, 0, 7, 140, 71);
INSERT INTO public.who_global_data VALUES (32989, 6, 4986, 0, 89, 140, 218);
INSERT INTO public.who_global_data VALUES (32990, 0, 0, 0, 0, 140, 43);
INSERT INTO public.who_global_data VALUES (32991, 1302, 60818, 17, 666, 140, 49);
INSERT INTO public.who_global_data VALUES (32992, 42, 19200, 0, 120, 140, 1);
INSERT INTO public.who_global_data VALUES (32993, 234, 14513, 6, 244, 140, 48);
INSERT INTO public.who_global_data VALUES (32994, 71, 5004, 2, 111, 140, 232);
INSERT INTO public.who_global_data VALUES (32995, 0, 210, 0, 1, 140, 175);
INSERT INTO public.who_global_data VALUES (32996, 7, 1565, 0, 22, 140, 21);
INSERT INTO public.who_global_data VALUES (32997, 2107, 46262, 6, 495, 140, 156);
INSERT INTO public.who_global_data VALUES (32998, 0, 0, 0, 0, 140, 95);
INSERT INTO public.who_global_data VALUES (32999, 14, 10455, 1, 268, 140, 177);
INSERT INTO public.who_global_data VALUES (33000, 454, 21847, 0, 635, 140, 210);
INSERT INTO public.who_global_data VALUES (33001, 2, 5403, 0, 61, 140, 120);
INSERT INTO public.who_global_data VALUES (33002, 0, 24, 0, 0, 140, 135);
INSERT INTO public.who_global_data VALUES (33003, 596, 106732, 12, 2034, 140, 206);
INSERT INTO public.who_global_data VALUES (33004, 0, 122257, 0, 11029, 140, 189);
INSERT INTO public.who_global_data VALUES (33005, 131, 101772, 18, 5733, 140, 129);
INSERT INTO public.who_global_data VALUES (33006, 97, 27346, 3, 804, 140, 121);
INSERT INTO public.who_global_data VALUES (33007, 0, 5002, 0, 83, 140, 59);
INSERT INTO public.who_global_data VALUES (33008, 0, 364, 0, 0, 140, 96);
INSERT INTO public.who_global_data VALUES (33009, 36, 2814, 0, 64, 140, 41);
INSERT INTO public.who_global_data VALUES (33010, 24, 5215, 0, 103, 140, 216);
INSERT INTO public.who_global_data VALUES (33011, 602, 67515, 12, 1072, 140, 236);
INSERT INTO public.who_global_data VALUES (33012, 0, 13, 0, 0, 140, 150);
INSERT INTO public.who_global_data VALUES (33013, 1, 430, 0, 0, 140, 61);
INSERT INTO public.who_global_data VALUES (33014, 0, 32, 0, 2, 140, 7);
INSERT INTO public.who_global_data VALUES (33015, 59, 8858, 0, 339, 140, 169);
INSERT INTO public.who_global_data VALUES (33016, 13084, 407390, 154, 31084, 140, 28);
INSERT INTO public.who_global_data VALUES (33017, 36, 9659, 0, 65, 140, 85);
INSERT INTO public.who_global_data VALUES (33018, 47, 1271, 0, 2, 140, 211);
INSERT INTO public.who_global_data VALUES (33019, 18, 8696, 0, 53, 140, 60);
INSERT INTO public.who_global_data VALUES (33020, 19, 3504, 0, 108, 140, 3);
INSERT INTO public.who_global_data VALUES (33021, 187, 3306, 0, 19, 140, 11);
INSERT INTO public.who_global_data VALUES (33022, 2297, 270070, 6, 9384, 140, 89);
INSERT INTO public.who_global_data VALUES (33023, 143, 45857, 1, 295, 140, 24);
INSERT INTO public.who_global_data VALUES (33024, 3, 343, 0, 0, 140, 162);
INSERT INTO public.who_global_data VALUES (33025, 338, 14738, 2, 327, 140, 100);
INSERT INTO public.who_global_data VALUES (33026, 0, 14, 0, 0, 140, 47);
INSERT INTO public.who_global_data VALUES (33027, 0, 24, 0, 0, 140, 29);
INSERT INTO public.who_global_data VALUES (33028, 0, 3426, 0, 26, 140, 40);
INSERT INTO public.who_global_data VALUES (33029, 29, 2074, 2, 33, 140, 222);
INSERT INTO public.who_global_data VALUES (33030, 680, 84344, 40, 3076, 140, 132);
INSERT INTO public.who_global_data VALUES (33031, 0, 253, 0, 13, 140, 130);
INSERT INTO public.who_global_data VALUES (33032, 77, 10231, 0, 63, 140, 234);
INSERT INTO public.who_global_data VALUES (33033, 0, 2303, 0, 39, 140, 23);
INSERT INTO public.who_global_data VALUES (33034, 43, 2027, 2, 62, 140, 192);
INSERT INTO public.who_global_data VALUES (33035, 0, 8556, 0, 220, 140, 69);
INSERT INTO public.who_global_data VALUES (33036, 0, 12, 0, 0, 140, 187);
INSERT INTO public.who_global_data VALUES (33037, 460, 70120, 20, 2122, 140, 230);
INSERT INTO public.who_global_data VALUES (33038, 809, 16920, 6, 675, 140, 77);
INSERT INTO public.who_global_data VALUES (33039, 24, 2230, 0, 10, 140, 9);
INSERT INTO public.who_global_data VALUES (33040, 93337, 5308014, 1247, 85619, 140, 74);
INSERT INTO public.who_global_data VALUES (33041, 3891, 236519, 114, 9336, 140, 224);
INSERT INTO public.who_global_data VALUES (33042, 3049, 416198, 144, 23952, 140, 199);
INSERT INTO public.who_global_data VALUES (33043, 4305, 311690, 76, 8408, 140, 190);
INSERT INTO public.who_global_data VALUES (33044, 248, 32271, 3, 1792, 140, 12);
INSERT INTO public.who_global_data VALUES (33045, 0, 339, 0, 24, 140, 104);
INSERT INTO public.who_global_data VALUES (33046, 5385, 176530, 17, 1235, 140, 153);
INSERT INTO public.who_global_data VALUES (33047, 1907, 294932, 10, 35668, 140, 91);
INSERT INTO public.who_global_data VALUES (33048, 197, 4571, 4, 55, 140, 215);
INSERT INTO public.who_global_data VALUES (33049, 579, 78073, 13, 1495, 140, 84);
INSERT INTO public.who_global_data VALUES (33050, 2, 391, 0, 32, 140, 231);
INSERT INTO public.who_global_data VALUES (33051, 213, 4412, 3, 29, 140, 196);
INSERT INTO public.who_global_data VALUES (33052, 335, 138348, 0, 1999, 140, 105);
INSERT INTO public.who_global_data VALUES (33053, 148, 36724, 4, 646, 140, 122);
INSERT INTO public.who_global_data VALUES (33054, 0, 0, 0, 0, 140, 159);
INSERT INTO public.who_global_data VALUES (33055, 57, 14896, 4, 601, 140, 75);
INSERT INTO public.who_global_data VALUES (33056, 704, 98528, 5, 580, 140, 27);
INSERT INTO public.who_global_data VALUES (33057, 91, 45335, 0, 1063, 140, 54);
INSERT INTO public.who_global_data VALUES (33058, 0, 23, 0, 0, 140, 226);
INSERT INTO public.who_global_data VALUES (33059, 4, 1498, 0, 36, 140, 79);
INSERT INTO public.who_global_data VALUES (33060, 750, 27518, 18, 281, 140, 56);
INSERT INTO public.who_global_data VALUES (33061, 63, 1390, 0, 33, 140, 117);
INSERT INTO public.who_global_data VALUES (33062, 1, 1334, 0, 82, 140, 152);
INSERT INTO public.who_global_data VALUES (33063, 796, 27234, 8, 426, 140, 16);
INSERT INTO public.who_global_data VALUES (33064, 1, 113, 0, 1, 140, 10);
INSERT INTO public.who_global_data VALUES (33065, 99, 3659, 0, 88, 140, 201);
INSERT INTO public.who_global_data VALUES (33066, 177, 7718, 0, 124, 140, 174);
INSERT INTO public.who_global_data VALUES (33067, 46, 15971, 1, 217, 140, 119);
INSERT INTO public.who_global_data VALUES (33068, 5, 5716, 0, 179, 140, 168);
INSERT INTO public.who_global_data VALUES (33069, 95, 10147, 1, 129, 140, 99);
INSERT INTO public.who_global_data VALUES (33070, 74, 9568, 0, 33, 140, 171);
INSERT INTO public.who_global_data VALUES (33071, 8, 2991, 0, 128, 140, 87);
INSERT INTO public.who_global_data VALUES (33072, 65, 2699, 2, 19, 140, 123);
INSERT INTO public.who_global_data VALUES (33073, 0, 0, 0, 0, 140, 151);
INSERT INTO public.who_global_data VALUES (33074, 0, 1122, 0, 18, 140, 213);
INSERT INTO public.who_global_data VALUES (33075, 15, 7361, 0, 161, 140, 118);
INSERT INTO public.who_global_data VALUES (33076, 1, 367, 0, 10, 140, 134);
INSERT INTO public.who_global_data VALUES (33077, 0, 3541, 0, 40, 140, 65);
INSERT INTO public.who_global_data VALUES (33078, 3182, 684113, 201, 72179, 140, 102);
INSERT INTO public.who_global_data VALUES (33079, 0, 0, 0, 0, 140, 223);
INSERT INTO public.who_global_data VALUES (33080, 5, 194, 0, 1, 140, 4);
INSERT INTO public.who_global_data VALUES (33081, 0, 311, 0, 0, 140, 146);
INSERT INTO public.who_global_data VALUES (33082, 284, 8601, 1, 134, 140, 31);
INSERT INTO public.who_global_data VALUES (33083, 0, 13, 0, 1, 140, 127);
INSERT INTO public.who_global_data VALUES (33084, 2760, 97264, 41, 1755, 140, 22);
INSERT INTO public.who_global_data VALUES (33085, 103, 6264, 1, 40, 140, 115);
INSERT INTO public.who_global_data VALUES (33086, 322, 4621, 14, 75, 140, 106);
INSERT INTO public.who_global_data VALUES (33087, 129, 10207, 0, 108, 140, 90);
INSERT INTO public.who_global_data VALUES (33088, 0, 0, 0, 0, 140, 70);
INSERT INTO public.who_global_data VALUES (33089, 2020, 61593, 7, 390, 140, 46);
INSERT INTO public.who_global_data VALUES (33090, 1958, 89914, 6, 6271, 140, 139);
INSERT INTO public.who_global_data VALUES (33091, 0, 26, 0, 0, 140, 42);
INSERT INTO public.who_global_data VALUES (33092, 2, 1460, 0, 25, 140, 80);
INSERT INTO public.who_global_data VALUES (33093, 0, 3979, 0, 147, 140, 203);
INSERT INTO public.who_global_data VALUES (33094, 2, 1182, 0, 69, 140, 136);
INSERT INTO public.who_global_data VALUES (33095, 221, 56956, 1, 1094, 140, 63);
INSERT INTO public.who_global_data VALUES (33096, 0, 0, 0, 0, 140, 17);
INSERT INTO public.who_global_data VALUES (33097, 0, 62, 0, 2, 140, 172);
INSERT INTO public.who_global_data VALUES (33098, 143, 16417, 8, 683, 140, 109);
INSERT INTO public.who_global_data VALUES (33099, 146, 12645, 1, 267, 140, 200);
INSERT INTO public.who_global_data VALUES (33100, 692, 44037, 8, 286, 140, 93);
INSERT INTO public.who_global_data VALUES (33101, 0, 91753, 0, 818, 140, 5);
INSERT INTO public.who_global_data VALUES (33102, 0, 741, 0, 13, 140, 214);
INSERT INTO public.who_global_data VALUES (33103, 645, 305031, 7, 6415, 140, 204);
INSERT INTO public.who_global_data VALUES (33104, 0, 0, 0, 0, 140, 198);
INSERT INTO public.who_global_data VALUES (33105, 672, 104138, 15, 2213, 140, 173);
INSERT INTO public.who_global_data VALUES (33106, 0, 516, 0, 6, 140, 229);
INSERT INTO public.who_global_data VALUES (33107, 694, 31113, 18, 584, 140, 76);
INSERT INTO public.who_global_data VALUES (33108, 5698, 750098, 95, 31146, 140, 138);
INSERT INTO public.who_global_data VALUES (33109, 3237, 279526, 45, 4830, 140, 98);
INSERT INTO public.who_global_data VALUES (33110, 0, 0, 0, 0, 140, 103);
INSERT INTO public.who_global_data VALUES (33111, 757, 77328, 17, 2270, 140, 225);
INSERT INTO public.who_global_data VALUES (33112, 780, 67176, 6, 1894, 140, 131);
INSERT INTO public.who_global_data VALUES (33113, 817, 39684, 11, 599, 140, 235);
INSERT INTO public.who_global_data VALUES (33114, 224, 122917, 1, 209, 140, 137);
INSERT INTO public.who_global_data VALUES (33115, 110, 22893, 1, 378, 140, 81);
INSERT INTO public.who_global_data VALUES (33116, 665, 45648, 16, 1186, 140, 182);
INSERT INTO public.who_global_data VALUES (33117, 95, 3194, 0, 10, 140, 145);
INSERT INTO public.who_global_data VALUES (33118, 1527, 110217, 48, 4360, 140, 26);
INSERT INTO public.who_global_data VALUES (33119, 6065, 1097251, 144, 19339, 140, 170);
INSERT INTO public.who_global_data VALUES (33120, 18, 4671, 2, 25, 140, 191);
INSERT INTO public.who_global_data VALUES (33121, 0, 5, 0, 0, 140, 221);
INSERT INTO public.who_global_data VALUES (33122, 0, 23, 0, 0, 140, 64);
INSERT INTO public.who_global_data VALUES (33123, 0, 0, 0, 0, 140, 116);
INSERT INTO public.who_global_data VALUES (33124, 0, 17, 0, 0, 140, 128);
INSERT INTO public.who_global_data VALUES (33125, 0, 27, 0, 0, 140, 6);
INSERT INTO public.who_global_data VALUES (33126, 0, 330, 0, 6, 140, 227);
INSERT INTO public.who_global_data VALUES (33127, 0, 11, 0, 0, 140, 68);
INSERT INTO public.who_global_data VALUES (33128, 0, 64, 0, 0, 140, 184);
INSERT INTO public.who_global_data VALUES (33129, 0, 0, 0, 0, 140, 82);
INSERT INTO public.who_global_data VALUES (33130, 0, 742, 0, 42, 140, 149);
INSERT INTO public.who_global_data VALUES (33131, 1, 908, 0, 15, 140, 197);
INSERT INTO public.who_global_data VALUES (33132, 576, 328720, 31, 4430, 140, 78);
INSERT INTO public.who_global_data VALUES (33133, 27, 14645, 1, 301, 140, 233);
INSERT INTO public.who_global_data VALUES (33134, 62, 32757, 1, 739, 140, 133);
INSERT INTO public.who_global_data VALUES (33135, 0, 139, 0, 0, 140, 35);
INSERT INTO public.who_global_data VALUES (33136, 16, 2153, 0, 72, 140, 114);
INSERT INTO public.who_global_data VALUES (33137, 11, 57543, 0, 27, 140, 237);
INSERT INTO public.who_global_data VALUES (33138, 0, 11, 0, 0, 140, 55);
INSERT INTO public.who_global_data VALUES (33139, 8, 565, 0, 19, 140, 176);
INSERT INTO public.who_global_data VALUES (33140, 235, 6256, 0, 39, 140, 202);
INSERT INTO public.who_global_data VALUES (33141, 113, 4310, 2, 144, 140, 155);
INSERT INTO public.who_global_data VALUES (33142, 0, 0, 0, 0, 140, 32);
INSERT INTO public.who_global_data VALUES (33143, 0, 3390, 0, 98, 140, 220);
INSERT INTO public.who_global_data VALUES (33144, 2055, 657627, 85, 15857, 140, 30);
INSERT INTO public.who_global_data VALUES (33145, 33, 2642, 0, 49, 140, 147);
INSERT INTO public.who_global_data VALUES (33146, 13953, 689058, 120, 32466, 140, 208);
INSERT INTO public.who_global_data VALUES (33147, 5, 3281, 0, 13, 140, 45);
INSERT INTO public.who_global_data VALUES (33148, 0, 13555, 0, 836, 140, 110);
INSERT INTO public.who_global_data VALUES (33149, 26, 4671, 0, 95, 140, 88);
INSERT INTO public.who_global_data VALUES (33150, 389, 88390, 1, 5859, 140, 51);
INSERT INTO public.who_global_data VALUES (33151, 444, 49983, 2, 1803, 140, 209);
INSERT INTO public.who_global_data VALUES (33152, 40, 3731, 3, 168, 140, 205);
INSERT INTO public.who_global_data VALUES (33153, 45, 9259, 0, 73, 140, 18);
INSERT INTO public.who_global_data VALUES (33154, 3, 3500, 1, 59, 140, 72);
INSERT INTO public.who_global_data VALUES (33155, 4322, 385940, 27, 41732, 140, 44);
INSERT INTO public.who_global_data VALUES (33156, 0, 27, 0, 0, 140, 15);
INSERT INTO public.who_global_data VALUES (33157, 22, 1640, 0, 41, 140, 25);
INSERT INTO public.who_global_data VALUES (33158, 0, 0, 0, 0, 140, 179);
INSERT INTO public.who_global_data VALUES (33159, 0, 0, 0, 0, 140, 34);
INSERT INTO public.who_global_data VALUES (33160, 176, 3512, 2, 60, 140, 207);
INSERT INTO public.who_global_data VALUES (33161, 0, 9736, 0, 155, 140, 166);
INSERT INTO public.who_global_data VALUES (33162, 8501, 656500, 62, 7377, 140, 126);
INSERT INTO public.who_global_data VALUES (33163, 0, 0, 0, 0, 140, 97);
INSERT INTO public.who_global_data VALUES (33164, 4, 663, 0, 5, 140, 36);
INSERT INTO public.who_global_data VALUES (33165, 0, 0, 0, 0, 140, 125);
INSERT INTO public.who_global_data VALUES (33166, 210, 5590, 1, 61, 140, 124);
INSERT INTO public.who_global_data VALUES (33167, 3240, 172712, 48, 3516, 140, 185);
INSERT INTO public.who_global_data VALUES (33168, 865, 83433, 1, 403, 140, 194);
INSERT INTO public.who_global_data VALUES (33169, 0, 509, 0, 21, 140, 144);
INSERT INTO public.who_global_data VALUES (33170, 42618, 6613737, 827, 196465, 140, 19);
INSERT INTO public.who_global_data VALUES (33171, 4, 1242, 0, 19, 140, 217);
INSERT INTO public.who_global_data VALUES (33172, 20, 1876, 1, 46, 140, 148);
INSERT INTO public.who_global_data VALUES (33173, 640, 50634, 6, 423, 140, 86);
INSERT INTO public.who_global_data VALUES (33174, 0, 0, 0, 0, 140, 13);
INSERT INTO public.who_global_data VALUES (33175, 868, 64284, 9, 520, 140, 157);
INSERT INTO public.who_global_data VALUES (33176, 2, 1068, 0, 35, 140, 8);
INSERT INTO public.who_global_data VALUES (33177, 0, 0, 0, 0, 140, 73);
INSERT INTO public.who_global_data VALUES (33178, 2, 2028, 0, 586, 140, 101);
INSERT INTO public.who_global_data VALUES (33179, 96, 14024, 3, 329, 140, 165);
INSERT INTO public.who_global_data VALUES (33180, 14, 7647, 0, 224, 140, 14);
INSERT INTO public.who_global_data VALUES (33181, 11, 38969, 1, 1441, 141, 193);
INSERT INTO public.who_global_data VALUES (33182, 132, 11948, 4, 347, 141, 113);
INSERT INTO public.who_global_data VALUES (33183, 228, 49194, 9, 1654, 141, 143);
INSERT INTO public.who_global_data VALUES (33184, 0, 0, 0, 0, 141, 219);
INSERT INTO public.who_global_data VALUES (33185, 0, 1483, 0, 53, 141, 186);
INSERT INTO public.who_global_data VALUES (33186, 114, 3789, 1, 144, 141, 52);
INSERT INTO public.who_global_data VALUES (33187, 0, 3, 0, 0, 141, 180);
INSERT INTO public.who_global_data VALUES (33188, 0, 95, 0, 3, 141, 167);
INSERT INTO public.who_global_data VALUES (33189, 11674, 589012, 319, 12229, 141, 154);
INSERT INTO public.who_global_data VALUES (33190, 239, 46223, 1, 921, 141, 94);
INSERT INTO public.who_global_data VALUES (33191, 176, 3328, 0, 22, 141, 66);
INSERT INTO public.who_global_data VALUES (33192, 34, 26813, 8, 832, 141, 58);
INSERT INTO public.who_global_data VALUES (33193, 922, 36370, 0, 758, 141, 163);
INSERT INTO public.who_global_data VALUES (33194, 119, 38777, 2, 571, 141, 37);
INSERT INTO public.who_global_data VALUES (33195, 55, 3087, 0, 69, 141, 142);
INSERT INTO public.who_global_data VALUES (33196, 705, 63189, 1, 217, 141, 83);
INSERT INTO public.who_global_data VALUES (33197, 1593, 344264, 36, 4859, 141, 228);
INSERT INTO public.who_global_data VALUES (33198, 1, 185, 0, 7, 141, 188);
INSERT INTO public.who_global_data VALUES (33199, 224, 74987, 4, 771, 141, 62);
INSERT INTO public.who_global_data VALUES (33200, 1750, 102353, 1, 9930, 141, 160);
INSERT INTO public.who_global_data VALUES (33201, 8, 1536, 0, 19, 141, 50);
INSERT INTO public.who_global_data VALUES (33202, 0, 2280, 0, 40, 141, 33);
INSERT INTO public.who_global_data VALUES (33203, 1, 178, 0, 9, 141, 183);
INSERT INTO public.who_global_data VALUES (33204, 6, 252, 0, 0, 141, 92);
INSERT INTO public.who_global_data VALUES (33205, 586, 128872, 31, 7478, 141, 158);
INSERT INTO public.who_global_data VALUES (33206, 0, 20, 0, 1, 141, 67);
INSERT INTO public.who_global_data VALUES (33207, 394, 24600, 12, 741, 141, 57);
INSERT INTO public.who_global_data VALUES (33208, 104, 2567, 2, 13, 141, 38);
INSERT INTO public.who_global_data VALUES (33209, 36820, 4419083, 987, 134106, 141, 141);
INSERT INTO public.who_global_data VALUES (33210, 0, 69, 0, 1, 141, 178);
INSERT INTO public.who_global_data VALUES (33211, 0, 145, 0, 3, 141, 108);
INSERT INTO public.who_global_data VALUES (33212, 154, 18544, 0, 744, 141, 39);
INSERT INTO public.who_global_data VALUES (33213, 15, 1748, 0, 56, 141, 2);
INSERT INTO public.who_global_data VALUES (33214, 0, 473, 0, 1, 141, 195);
INSERT INTO public.who_global_data VALUES (33215, 85, 5063, 2, 49, 141, 107);
INSERT INTO public.who_global_data VALUES (33216, 0, 275, 0, 0, 141, 161);
INSERT INTO public.who_global_data VALUES (33217, 0, 20303, 0, 415, 141, 212);
INSERT INTO public.who_global_data VALUES (33218, 944, 139747, 5, 9193, 141, 181);
INSERT INTO public.who_global_data VALUES (33219, 0, 208, 0, 1, 141, 53);
INSERT INTO public.who_global_data VALUES (33220, 4, 4786, 0, 62, 141, 164);
INSERT INTO public.who_global_data VALUES (33221, 25, 1115, 0, 81, 141, 140);
INSERT INTO public.who_global_data VALUES (33222, 1863, 441150, 84, 12142, 141, 20);
INSERT INTO public.who_global_data VALUES (33223, 44, 90797, 0, 4743, 141, 112);
INSERT INTO public.who_global_data VALUES (33224, 7787, 736377, 190, 23478, 141, 111);
INSERT INTO public.who_global_data VALUES (33225, 3, 470, 0, 7, 141, 71);
INSERT INTO public.who_global_data VALUES (33226, 0, 4980, 0, 89, 141, 218);
INSERT INTO public.who_global_data VALUES (33227, 0, 0, 0, 0, 141, 43);
INSERT INTO public.who_global_data VALUES (33228, 1378, 59516, 16, 649, 141, 49);
INSERT INTO public.who_global_data VALUES (33229, 26, 19158, 0, 120, 141, 1);
INSERT INTO public.who_global_data VALUES (33230, 250, 14279, 2, 238, 141, 48);
INSERT INTO public.who_global_data VALUES (33231, 57, 4933, 0, 109, 141, 232);
INSERT INTO public.who_global_data VALUES (33232, 18, 210, 0, 1, 141, 175);
INSERT INTO public.who_global_data VALUES (33233, 10, 1558, 0, 22, 141, 21);
INSERT INTO public.who_global_data VALUES (33234, 3123, 44155, 7, 489, 141, 156);
INSERT INTO public.who_global_data VALUES (33235, 0, 0, 0, 0, 141, 95);
INSERT INTO public.who_global_data VALUES (33236, 28, 10441, 0, 267, 141, 177);
INSERT INTO public.who_global_data VALUES (33237, 822, 21393, 2, 635, 141, 210);
INSERT INTO public.who_global_data VALUES (33238, 2, 5401, 0, 61, 141, 120);
INSERT INTO public.who_global_data VALUES (33239, 0, 24, 0, 0, 141, 135);
INSERT INTO public.who_global_data VALUES (33240, 615, 106136, 13, 2022, 141, 206);
INSERT INTO public.who_global_data VALUES (33241, 732, 122257, 33, 11029, 141, 189);
INSERT INTO public.who_global_data VALUES (33242, 141, 101641, 19, 5715, 141, 129);
INSERT INTO public.who_global_data VALUES (33243, 86, 27249, 5, 801, 141, 121);
INSERT INTO public.who_global_data VALUES (33244, 2, 5002, 0, 83, 141, 59);
INSERT INTO public.who_global_data VALUES (33245, 0, 364, 0, 0, 141, 96);
INSERT INTO public.who_global_data VALUES (33246, 22, 2778, 0, 64, 141, 41);
INSERT INTO public.who_global_data VALUES (33247, 36, 5191, 2, 103, 141, 216);
INSERT INTO public.who_global_data VALUES (33248, 689, 66913, 15, 1060, 141, 236);
INSERT INTO public.who_global_data VALUES (33249, 0, 13, 0, 0, 141, 150);
INSERT INTO public.who_global_data VALUES (33250, 1, 429, 0, 0, 141, 61);
INSERT INTO public.who_global_data VALUES (33251, 0, 32, 0, 2, 141, 7);
INSERT INTO public.who_global_data VALUES (33252, 49, 8799, 0, 339, 141, 169);
INSERT INTO public.who_global_data VALUES (33253, 10468, 394306, 50, 30930, 141, 28);
INSERT INTO public.who_global_data VALUES (33254, 28, 9623, 0, 65, 141, 85);
INSERT INTO public.who_global_data VALUES (33255, 34, 1224, 0, 2, 141, 211);
INSERT INTO public.who_global_data VALUES (33256, 0, 8678, 0, 53, 141, 60);
INSERT INTO public.who_global_data VALUES (33257, 12, 3485, 1, 108, 141, 3);
INSERT INTO public.who_global_data VALUES (33258, 182, 3119, 0, 19, 141, 11);
INSERT INTO public.who_global_data VALUES (33259, 1916, 267773, 7, 9378, 141, 89);
INSERT INTO public.who_global_data VALUES (33260, 59, 45714, 0, 294, 141, 24);
INSERT INTO public.who_global_data VALUES (33261, 6, 340, 0, 0, 141, 162);
INSERT INTO public.who_global_data VALUES (33262, 359, 14400, 9, 325, 141, 100);
INSERT INTO public.who_global_data VALUES (33263, 0, 14, 0, 0, 141, 47);
INSERT INTO public.who_global_data VALUES (33264, 0, 24, 0, 0, 141, 29);
INSERT INTO public.who_global_data VALUES (33265, 0, 3426, 0, 26, 141, 40);
INSERT INTO public.who_global_data VALUES (33266, 32, 2045, 1, 31, 141, 222);
INSERT INTO public.who_global_data VALUES (33267, 740, 83664, 27, 3036, 141, 132);
INSERT INTO public.who_global_data VALUES (33268, 0, 253, 0, 13, 141, 130);
INSERT INTO public.who_global_data VALUES (33269, 0, 10154, 0, 63, 141, 234);
INSERT INTO public.who_global_data VALUES (33270, 28, 2303, 0, 39, 141, 23);
INSERT INTO public.who_global_data VALUES (33271, 26, 1984, 2, 60, 141, 192);
INSERT INTO public.who_global_data VALUES (33272, 26, 8556, 0, 220, 141, 69);
INSERT INTO public.who_global_data VALUES (33273, 0, 12, 0, 0, 141, 187);
INSERT INTO public.who_global_data VALUES (33274, 1040, 69660, 15, 2102, 141, 230);
INSERT INTO public.who_global_data VALUES (33275, 941, 16111, 6, 669, 141, 77);
INSERT INTO public.who_global_data VALUES (33276, 17, 2206, 0, 10, 141, 9);
INSERT INTO public.who_global_data VALUES (33277, 96424, 5214677, 1174, 84372, 141, 74);
INSERT INTO public.who_global_data VALUES (33278, 3635, 232628, 122, 9222, 141, 224);
INSERT INTO public.who_global_data VALUES (33279, 2815, 413149, 176, 23808, 141, 199);
INSERT INTO public.who_global_data VALUES (33280, 4326, 307385, 84, 8332, 141, 190);
INSERT INTO public.who_global_data VALUES (33281, 224, 32023, 1, 1789, 141, 12);
INSERT INTO public.who_global_data VALUES (33282, 0, 339, 0, 24, 141, 104);
INSERT INTO public.who_global_data VALUES (33283, 4574, 171145, 26, 1218, 141, 153);
INSERT INTO public.who_global_data VALUES (33284, 1583, 293025, 13, 35658, 141, 91);
INSERT INTO public.who_global_data VALUES (33285, 210, 4374, 5, 51, 141, 215);
INSERT INTO public.who_global_data VALUES (33286, 485, 77494, 9, 1482, 141, 84);
INSERT INTO public.who_global_data VALUES (33287, 3, 389, 0, 32, 141, 231);
INSERT INTO public.who_global_data VALUES (33288, 279, 4199, 0, 26, 141, 196);
INSERT INTO public.who_global_data VALUES (33289, 300, 138013, 0, 1999, 141, 105);
INSERT INTO public.who_global_data VALUES (33290, 275, 36576, 8, 642, 141, 122);
INSERT INTO public.who_global_data VALUES (33291, 0, 0, 0, 0, 141, 159);
INSERT INTO public.who_global_data VALUES (33292, 43, 14839, 3, 597, 141, 75);
INSERT INTO public.who_global_data VALUES (33293, 825, 97824, 4, 575, 141, 27);
INSERT INTO public.who_global_data VALUES (33294, 91, 45244, 0, 1063, 141, 54);
INSERT INTO public.who_global_data VALUES (33295, 0, 23, 0, 0, 141, 226);
INSERT INTO public.who_global_data VALUES (33296, 8, 1494, 1, 36, 141, 79);
INSERT INTO public.who_global_data VALUES (33297, 685, 26768, 4, 263, 141, 56);
INSERT INTO public.who_global_data VALUES (33298, 0, 1327, 0, 33, 141, 117);
INSERT INTO public.who_global_data VALUES (33299, 6, 1333, 0, 82, 141, 152);
INSERT INTO public.who_global_data VALUES (33300, 616, 26438, 13, 418, 141, 16);
INSERT INTO public.who_global_data VALUES (33301, 0, 112, 0, 1, 141, 10);
INSERT INTO public.who_global_data VALUES (33302, 61, 3560, 0, 88, 141, 201);
INSERT INTO public.who_global_data VALUES (33303, 147, 7541, 0, 124, 141, 174);
INSERT INTO public.who_global_data VALUES (33304, 54, 15925, 1, 216, 141, 119);
INSERT INTO public.who_global_data VALUES (33305, 7, 5711, 1, 179, 141, 168);
INSERT INTO public.who_global_data VALUES (33306, 21, 10052, 0, 128, 141, 99);
INSERT INTO public.who_global_data VALUES (33307, 67, 9494, 0, 33, 141, 171);
INSERT INTO public.who_global_data VALUES (33308, 17, 2983, 0, 128, 141, 87);
INSERT INTO public.who_global_data VALUES (33309, 38, 2634, 1, 17, 141, 123);
INSERT INTO public.who_global_data VALUES (33310, 0, 0, 0, 0, 141, 151);
INSERT INTO public.who_global_data VALUES (33311, 0, 1122, 0, 18, 141, 213);
INSERT INTO public.who_global_data VALUES (33312, 14, 7346, 0, 161, 141, 118);
INSERT INTO public.who_global_data VALUES (33313, 1, 366, 0, 10, 141, 134);
INSERT INTO public.who_global_data VALUES (33314, 0, 3541, 0, 40, 141, 65);
INSERT INTO public.who_global_data VALUES (33315, 4444, 680931, 300, 71978, 141, 102);
INSERT INTO public.who_global_data VALUES (33316, 0, 0, 0, 0, 141, 223);
INSERT INTO public.who_global_data VALUES (33317, 5, 189, 0, 1, 141, 4);
INSERT INTO public.who_global_data VALUES (33318, 0, 311, 0, 0, 141, 146);
INSERT INTO public.who_global_data VALUES (33319, 233, 8317, 4, 133, 141, 31);
INSERT INTO public.who_global_data VALUES (33320, 0, 13, 0, 1, 141, 127);
INSERT INTO public.who_global_data VALUES (33321, 2488, 94504, 28, 1714, 141, 22);
INSERT INTO public.who_global_data VALUES (33322, 167, 6161, 0, 39, 141, 115);
INSERT INTO public.who_global_data VALUES (33323, 405, 4299, 15, 61, 141, 106);
INSERT INTO public.who_global_data VALUES (33324, 114, 10078, 0, 108, 141, 90);
INSERT INTO public.who_global_data VALUES (33325, 0, 0, 0, 0, 141, 70);
INSERT INTO public.who_global_data VALUES (33326, 1246, 59573, 4, 383, 141, 46);
INSERT INTO public.who_global_data VALUES (33327, 1739, 87956, 6, 6265, 141, 139);
INSERT INTO public.who_global_data VALUES (33328, 0, 26, 0, 0, 141, 42);
INSERT INTO public.who_global_data VALUES (33329, 0, 1458, 0, 25, 141, 80);
INSERT INTO public.who_global_data VALUES (33330, 0, 3979, 0, 147, 141, 203);
INSERT INTO public.who_global_data VALUES (33331, 0, 1180, 0, 69, 141, 136);
INSERT INTO public.who_global_data VALUES (33332, 131, 56735, 2, 1093, 141, 63);
INSERT INTO public.who_global_data VALUES (33333, 0, 0, 0, 0, 141, 17);
INSERT INTO public.who_global_data VALUES (33334, 1, 62, 0, 2, 141, 172);
INSERT INTO public.who_global_data VALUES (33335, 186, 16274, 7, 675, 141, 109);
INSERT INTO public.who_global_data VALUES (33336, 106, 12499, 1, 266, 141, 200);
INSERT INTO public.who_global_data VALUES (33337, 966, 43345, 2, 278, 141, 93);
INSERT INTO public.who_global_data VALUES (33338, 557, 91753, 13, 818, 141, 5);
INSERT INTO public.who_global_data VALUES (33339, 0, 741, 0, 13, 141, 214);
INSERT INTO public.who_global_data VALUES (33340, 752, 304386, 9, 6408, 141, 204);
INSERT INTO public.who_global_data VALUES (33341, 0, 0, 0, 0, 141, 198);
INSERT INTO public.who_global_data VALUES (33342, 634, 103466, 11, 2198, 141, 173);
INSERT INTO public.who_global_data VALUES (33343, 0, 516, 0, 6, 141, 229);
INSERT INTO public.who_global_data VALUES (33344, 1121, 30419, 14, 566, 141, 76);
INSERT INTO public.who_global_data VALUES (33345, 6380, 744400, 124, 31051, 141, 138);
INSERT INTO public.who_global_data VALUES (33346, 3355, 276289, 53, 4785, 141, 98);
INSERT INTO public.who_global_data VALUES (33347, 0, 0, 0, 0, 141, 103);
INSERT INTO public.who_global_data VALUES (33348, 837, 76571, 16, 2253, 141, 225);
INSERT INTO public.who_global_data VALUES (33349, 770, 66396, 10, 1888, 141, 131);
INSERT INTO public.who_global_data VALUES (33350, 583, 38867, 18, 588, 141, 235);
INSERT INTO public.who_global_data VALUES (33351, 244, 122693, 0, 208, 141, 137);
INSERT INTO public.who_global_data VALUES (33352, 126, 22783, 5, 377, 141, 81);
INSERT INTO public.who_global_data VALUES (33353, 622, 44983, 11, 1170, 141, 182);
INSERT INTO public.who_global_data VALUES (33354, 97, 3099, 0, 10, 141, 145);
INSERT INTO public.who_global_data VALUES (33355, 1679, 108690, 27, 4312, 141, 26);
INSERT INTO public.who_global_data VALUES (33356, 5905, 1091186, 134, 19195, 141, 170);
INSERT INTO public.who_global_data VALUES (33357, 19, 4653, 1, 23, 141, 191);
INSERT INTO public.who_global_data VALUES (33358, 0, 5, 0, 0, 141, 221);
INSERT INTO public.who_global_data VALUES (33359, 0, 23, 0, 0, 141, 64);
INSERT INTO public.who_global_data VALUES (33360, 0, 0, 0, 0, 141, 116);
INSERT INTO public.who_global_data VALUES (33361, 0, 17, 0, 0, 141, 128);
INSERT INTO public.who_global_data VALUES (33362, 0, 27, 0, 0, 141, 6);
INSERT INTO public.who_global_data VALUES (33363, 0, 330, 0, 6, 141, 227);
INSERT INTO public.who_global_data VALUES (33364, 0, 11, 0, 0, 141, 68);
INSERT INTO public.who_global_data VALUES (33365, 0, 64, 0, 0, 141, 184);
INSERT INTO public.who_global_data VALUES (33366, 0, 0, 0, 0, 141, 82);
INSERT INTO public.who_global_data VALUES (33367, 0, 742, 0, 42, 141, 149);
INSERT INTO public.who_global_data VALUES (33368, 0, 907, 0, 15, 141, 197);
INSERT INTO public.who_global_data VALUES (33369, 593, 328144, 30, 4399, 141, 78);
INSERT INTO public.who_global_data VALUES (33370, 50, 14618, 1, 300, 141, 233);
INSERT INTO public.who_global_data VALUES (33371, 82, 32695, 2, 738, 141, 133);
INSERT INTO public.who_global_data VALUES (33372, 1, 139, 0, 0, 141, 35);
INSERT INTO public.who_global_data VALUES (33373, 4, 2137, 0, 72, 141, 114);
INSERT INTO public.who_global_data VALUES (33374, 18, 57532, 0, 27, 141, 237);
INSERT INTO public.who_global_data VALUES (33375, 0, 11, 0, 0, 141, 55);
INSERT INTO public.who_global_data VALUES (33376, 8, 557, 0, 19, 141, 176);
INSERT INTO public.who_global_data VALUES (33377, 161, 6021, 1, 39, 141, 202);
INSERT INTO public.who_global_data VALUES (33378, 137, 4197, 4, 142, 141, 155);
INSERT INTO public.who_global_data VALUES (33379, 0, 0, 0, 0, 141, 32);
INSERT INTO public.who_global_data VALUES (33380, 0, 3390, 0, 98, 141, 220);
INSERT INTO public.who_global_data VALUES (33381, 2128, 655572, 67, 15772, 141, 30);
INSERT INTO public.who_global_data VALUES (33382, 10, 2609, 0, 49, 141, 147);
INSERT INTO public.who_global_data VALUES (33383, 14279, 675105, 109, 32346, 141, 208);
INSERT INTO public.who_global_data VALUES (33384, 5, 3276, 0, 13, 141, 45);
INSERT INTO public.who_global_data VALUES (33385, 20, 13555, 0, 836, 141, 110);
INSERT INTO public.who_global_data VALUES (33386, 20, 4645, 0, 95, 141, 88);
INSERT INTO public.who_global_data VALUES (33387, 330, 88001, 2, 5858, 141, 51);
INSERT INTO public.who_global_data VALUES (33388, 499, 49539, 4, 1801, 141, 209);
INSERT INTO public.who_global_data VALUES (33389, 37, 3691, 2, 165, 141, 205);
INSERT INTO public.who_global_data VALUES (33390, 43, 9214, 0, 73, 141, 18);
INSERT INTO public.who_global_data VALUES (33391, 7, 3497, 0, 58, 141, 72);
INSERT INTO public.who_global_data VALUES (33392, 3395, 381618, 21, 41705, 141, 44);
INSERT INTO public.who_global_data VALUES (33393, 0, 27, 0, 0, 141, 15);
INSERT INTO public.who_global_data VALUES (33394, 10, 1618, 1, 41, 141, 25);
INSERT INTO public.who_global_data VALUES (33395, 0, 0, 0, 0, 141, 179);
INSERT INTO public.who_global_data VALUES (33396, 0, 0, 0, 0, 141, 34);
INSERT INTO public.who_global_data VALUES (33397, 43, 3336, 1, 58, 141, 207);
INSERT INTO public.who_global_data VALUES (33398, 626, 9736, 17, 155, 141, 166);
INSERT INTO public.who_global_data VALUES (33399, 8378, 647999, 66, 7315, 141, 126);
INSERT INTO public.who_global_data VALUES (33400, 0, 0, 0, 0, 141, 97);
INSERT INTO public.who_global_data VALUES (33401, 9, 659, 0, 5, 141, 36);
INSERT INTO public.who_global_data VALUES (33402, 0, 0, 0, 0, 141, 125);
INSERT INTO public.who_global_data VALUES (33403, 114, 5380, 0, 60, 141, 124);
INSERT INTO public.who_global_data VALUES (33404, 3228, 169472, 68, 3468, 141, 185);
INSERT INTO public.who_global_data VALUES (33405, 786, 82568, 0, 402, 141, 194);
INSERT INTO public.who_global_data VALUES (33406, 0, 509, 0, 21, 141, 144);
INSERT INTO public.who_global_data VALUES (33407, 40795, 6571119, 1204, 195638, 141, 19);
INSERT INTO public.who_global_data VALUES (33408, 6, 1238, 0, 19, 141, 217);
INSERT INTO public.who_global_data VALUES (33409, 29, 1856, 0, 45, 141, 148);
INSERT INTO public.who_global_data VALUES (33410, 609, 49994, 6, 417, 141, 86);
INSERT INTO public.who_global_data VALUES (33411, 0, 0, 0, 0, 141, 13);
INSERT INTO public.who_global_data VALUES (33412, 761, 63416, 9, 511, 141, 157);
INSERT INTO public.who_global_data VALUES (33413, 3, 1066, 0, 35, 141, 8);
INSERT INTO public.who_global_data VALUES (33414, 0, 0, 0, 0, 141, 73);
INSERT INTO public.who_global_data VALUES (33415, 3, 2026, 2, 586, 141, 101);
INSERT INTO public.who_global_data VALUES (33416, 41, 13928, 0, 326, 141, 165);
INSERT INTO public.who_global_data VALUES (33417, 35, 7633, 0, 224, 141, 14);
INSERT INTO public.who_global_data VALUES (33418, 17, 38958, 0, 1440, 142, 193);
INSERT INTO public.who_global_data VALUES (33419, 144, 11816, 3, 343, 142, 113);
INSERT INTO public.who_global_data VALUES (33420, 232, 48966, 13, 1645, 142, 143);
INSERT INTO public.who_global_data VALUES (33421, 0, 0, 0, 0, 142, 219);
INSERT INTO public.who_global_data VALUES (33422, 45, 1483, 0, 53, 142, 186);
INSERT INTO public.who_global_data VALUES (33423, 106, 3675, 4, 143, 142, 52);
INSERT INTO public.who_global_data VALUES (33424, 0, 3, 0, 0, 142, 180);
INSERT INTO public.who_global_data VALUES (33425, 0, 95, 0, 3, 142, 167);
INSERT INTO public.who_global_data VALUES (33426, 11892, 577338, 200, 11910, 142, 154);
INSERT INTO public.who_global_data VALUES (33427, 295, 45984, 2, 920, 142, 94);
INSERT INTO public.who_global_data VALUES (33428, 92, 3152, 2, 22, 142, 66);
INSERT INTO public.who_global_data VALUES (33429, 41, 26779, 8, 824, 142, 58);
INSERT INTO public.who_global_data VALUES (33430, 704, 35448, 1, 758, 142, 163);
INSERT INTO public.who_global_data VALUES (33431, 141, 38658, 3, 569, 142, 37);
INSERT INTO public.who_global_data VALUES (33432, 24, 3032, 1, 69, 142, 142);
INSERT INTO public.who_global_data VALUES (33433, 841, 62484, 3, 216, 142, 83);
INSERT INTO public.who_global_data VALUES (33434, 1615, 342671, 21, 4823, 142, 228);
INSERT INTO public.who_global_data VALUES (33435, 1, 184, 0, 7, 142, 188);
INSERT INTO public.who_global_data VALUES (33436, 211, 74763, 6, 767, 142, 62);
INSERT INTO public.who_global_data VALUES (33437, 1942, 100603, 2, 9929, 142, 160);
INSERT INTO public.who_global_data VALUES (33438, 27, 1528, 0, 19, 142, 50);
INSERT INTO public.who_global_data VALUES (33439, 0, 2280, 0, 40, 142, 33);
INSERT INTO public.who_global_data VALUES (33440, 0, 177, 0, 9, 142, 183);
INSERT INTO public.who_global_data VALUES (33441, 0, 246, 0, 0, 142, 92);
INSERT INTO public.who_global_data VALUES (33442, 667, 128286, 53, 7447, 142, 158);
INSERT INTO public.who_global_data VALUES (33443, 4, 20, 0, 1, 142, 67);
INSERT INTO public.who_global_data VALUES (33444, 282, 24206, 11, 729, 142, 57);
INSERT INTO public.who_global_data VALUES (33445, 0, 2463, 0, 11, 142, 38);
INSERT INTO public.who_global_data VALUES (33446, 36653, 4382263, 1113, 133119, 142, 141);
INSERT INTO public.who_global_data VALUES (33447, 3, 69, 0, 1, 142, 178);
INSERT INTO public.who_global_data VALUES (33448, 0, 145, 0, 3, 142, 108);
INSERT INTO public.who_global_data VALUES (33449, 174, 18390, 8, 744, 142, 39);
INSERT INTO public.who_global_data VALUES (33450, 16, 1733, 0, 56, 142, 2);
INSERT INTO public.who_global_data VALUES (33451, 1, 473, 0, 1, 142, 195);
INSERT INTO public.who_global_data VALUES (33452, 74, 4978, 1, 47, 142, 107);
INSERT INTO public.who_global_data VALUES (33453, 0, 275, 0, 0, 142, 161);
INSERT INTO public.who_global_data VALUES (33454, 0, 20303, 0, 415, 142, 212);
INSERT INTO public.who_global_data VALUES (33455, 793, 138803, 9, 9188, 142, 181);
INSERT INTO public.who_global_data VALUES (33456, 0, 208, 0, 1, 142, 53);
INSERT INTO public.who_global_data VALUES (33457, 10, 4782, 0, 62, 142, 164);
INSERT INTO public.who_global_data VALUES (33458, 3, 1090, 0, 81, 142, 140);
INSERT INTO public.who_global_data VALUES (33459, 1304, 439287, 18, 12058, 142, 20);
INSERT INTO public.who_global_data VALUES (33460, 19, 90753, 0, 4743, 142, 112);
INSERT INTO public.who_global_data VALUES (33461, 6698, 728590, 165, 23288, 142, 111);
INSERT INTO public.who_global_data VALUES (33462, 10, 467, 0, 7, 142, 71);
INSERT INTO public.who_global_data VALUES (33463, 46, 4980, 1, 89, 142, 218);
INSERT INTO public.who_global_data VALUES (33464, 0, 0, 0, 0, 142, 43);
INSERT INTO public.who_global_data VALUES (33465, 777, 58138, 12, 633, 142, 49);
INSERT INTO public.who_global_data VALUES (33466, 32, 19132, 0, 120, 142, 1);
INSERT INTO public.who_global_data VALUES (33467, 280, 14029, 6, 236, 142, 48);
INSERT INTO public.who_global_data VALUES (33468, 73, 4876, 1, 109, 142, 232);
INSERT INTO public.who_global_data VALUES (33469, 23, 192, 0, 1, 142, 175);
INSERT INTO public.who_global_data VALUES (33470, 8, 1548, 0, 22, 142, 21);
INSERT INTO public.who_global_data VALUES (33471, 2136, 41032, 6, 482, 142, 156);
INSERT INTO public.who_global_data VALUES (33472, 0, 0, 0, 0, 142, 95);
INSERT INTO public.who_global_data VALUES (33473, 13, 10413, 0, 267, 142, 177);
INSERT INTO public.who_global_data VALUES (33474, 442, 20571, 0, 633, 142, 210);
INSERT INTO public.who_global_data VALUES (33475, 3, 5399, 0, 61, 142, 120);
INSERT INTO public.who_global_data VALUES (33476, 0, 24, 0, 0, 142, 135);
INSERT INTO public.who_global_data VALUES (33477, 718, 105521, 11, 2009, 142, 206);
INSERT INTO public.who_global_data VALUES (33478, 1972, 121525, 33, 10996, 142, 189);
INSERT INTO public.who_global_data VALUES (33479, 160, 101500, 17, 5696, 142, 129);
INSERT INTO public.who_global_data VALUES (33480, 75, 27163, 4, 796, 142, 121);
INSERT INTO public.who_global_data VALUES (33481, 0, 5000, 0, 83, 142, 59);
INSERT INTO public.who_global_data VALUES (33482, 0, 364, 0, 0, 142, 96);
INSERT INTO public.who_global_data VALUES (33483, 34, 2756, 0, 64, 142, 41);
INSERT INTO public.who_global_data VALUES (33484, 27, 5155, 0, 101, 142, 216);
INSERT INTO public.who_global_data VALUES (33485, 738, 66224, 10, 1045, 142, 236);
INSERT INTO public.who_global_data VALUES (33486, 0, 13, 0, 0, 142, 150);
INSERT INTO public.who_global_data VALUES (33487, 0, 428, 0, 0, 142, 61);
INSERT INTO public.who_global_data VALUES (33488, 0, 32, 0, 2, 142, 7);
INSERT INTO public.who_global_data VALUES (33489, 25, 8750, 0, 339, 142, 169);
INSERT INTO public.who_global_data VALUES (33490, 9138, 383838, 43, 30880, 142, 28);
INSERT INTO public.who_global_data VALUES (33491, 17, 9595, 1, 65, 142, 85);
INSERT INTO public.who_global_data VALUES (33492, 55, 1190, 0, 2, 142, 211);
INSERT INTO public.who_global_data VALUES (33493, 24, 8678, 0, 53, 142, 60);
INSERT INTO public.who_global_data VALUES (33494, 33, 3473, 0, 107, 142, 3);
INSERT INTO public.who_global_data VALUES (33495, 179, 2937, 0, 19, 142, 11);
INSERT INTO public.who_global_data VALUES (33496, 2194, 265857, 3, 9371, 142, 89);
INSERT INTO public.who_global_data VALUES (33497, 0, 45655, 0, 294, 142, 24);
INSERT INTO public.who_global_data VALUES (33498, 4, 334, 0, 0, 142, 162);
INSERT INTO public.who_global_data VALUES (33499, 311, 14041, 3, 316, 142, 100);
INSERT INTO public.who_global_data VALUES (33500, 0, 14, 0, 0, 142, 47);
INSERT INTO public.who_global_data VALUES (33501, 0, 24, 0, 0, 142, 29);
INSERT INTO public.who_global_data VALUES (33502, 346, 3426, 2, 26, 142, 40);
INSERT INTO public.who_global_data VALUES (33503, 47, 2013, 1, 30, 142, 222);
INSERT INTO public.who_global_data VALUES (33504, 240, 82924, 25, 3009, 142, 132);
INSERT INTO public.who_global_data VALUES (33505, 0, 253, 0, 13, 142, 130);
INSERT INTO public.who_global_data VALUES (33506, 43, 10154, 0, 63, 142, 234);
INSERT INTO public.who_global_data VALUES (33507, 0, 2275, 0, 39, 142, 23);
INSERT INTO public.who_global_data VALUES (33508, 74, 1958, 2, 58, 142, 192);
INSERT INTO public.who_global_data VALUES (33509, 31, 8530, 1, 220, 142, 69);
INSERT INTO public.who_global_data VALUES (33510, 0, 12, 0, 0, 142, 187);
INSERT INTO public.who_global_data VALUES (33511, 0, 68620, 0, 2087, 142, 230);
INSERT INTO public.who_global_data VALUES (33512, 710, 15170, 9, 663, 142, 77);
INSERT INTO public.who_global_data VALUES (33513, 15, 2189, 0, 10, 142, 9);
INSERT INTO public.who_global_data VALUES (33514, 97894, 5118253, 1132, 83198, 142, 74);
INSERT INTO public.who_global_data VALUES (33515, 3963, 228993, 135, 9100, 142, 224);
INSERT INTO public.who_global_data VALUES (33516, 2981, 410334, 179, 23632, 142, 199);
INSERT INTO public.who_global_data VALUES (33517, 4357, 303059, 82, 8248, 142, 190);
INSERT INTO public.who_global_data VALUES (33518, 250, 31799, 1, 1788, 142, 12);
INSERT INTO public.who_global_data VALUES (33519, 0, 339, 0, 24, 142, 104);
INSERT INTO public.who_global_data VALUES (33520, 5539, 166571, 16, 1192, 142, 153);
INSERT INTO public.who_global_data VALUES (33521, 1452, 291442, 12, 35645, 142, 91);
INSERT INTO public.who_global_data VALUES (33522, 122, 4164, 0, 46, 142, 215);
INSERT INTO public.who_global_data VALUES (33523, 561, 77009, 12, 1473, 142, 84);
INSERT INTO public.who_global_data VALUES (33524, 0, 386, 0, 32, 142, 231);
INSERT INTO public.who_global_data VALUES (33525, 175, 3920, 0, 26, 142, 196);
INSERT INTO public.who_global_data VALUES (33526, 320, 137713, 0, 1999, 142, 105);
INSERT INTO public.who_global_data VALUES (33527, 0, 36301, 0, 634, 142, 122);
INSERT INTO public.who_global_data VALUES (33528, 0, 0, 0, 0, 142, 159);
INSERT INTO public.who_global_data VALUES (33529, 76, 14796, 3, 594, 142, 75);
INSERT INTO public.who_global_data VALUES (33530, 698, 96999, 3, 571, 142, 27);
INSERT INTO public.who_global_data VALUES (33531, 81, 45153, 0, 1063, 142, 54);
INSERT INTO public.who_global_data VALUES (33532, 0, 23, 0, 0, 142, 226);
INSERT INTO public.who_global_data VALUES (33533, 4, 1486, 0, 35, 142, 79);
INSERT INTO public.who_global_data VALUES (33534, 634, 26083, 7, 259, 142, 56);
INSERT INTO public.who_global_data VALUES (33535, 0, 1327, 0, 33, 142, 117);
INSERT INTO public.who_global_data VALUES (33536, 0, 1327, 0, 82, 142, 152);
INSERT INTO public.who_global_data VALUES (33537, 886, 25822, 11, 405, 142, 16);
INSERT INTO public.who_global_data VALUES (33538, 1, 112, 0, 1, 142, 10);
INSERT INTO public.who_global_data VALUES (33539, 62, 3499, 0, 88, 142, 201);
INSERT INTO public.who_global_data VALUES (33540, 110, 7394, 0, 124, 142, 174);
INSERT INTO public.who_global_data VALUES (33541, 68, 15871, 1, 215, 142, 119);
INSERT INTO public.who_global_data VALUES (33542, 3, 5704, 0, 178, 142, 168);
INSERT INTO public.who_global_data VALUES (33543, 62, 10031, 0, 128, 142, 99);
INSERT INTO public.who_global_data VALUES (33544, 99, 9427, 0, 33, 142, 171);
INSERT INTO public.who_global_data VALUES (33545, 26, 2966, 0, 128, 142, 87);
INSERT INTO public.who_global_data VALUES (33546, 35, 2596, 0, 16, 142, 123);
INSERT INTO public.who_global_data VALUES (33547, 0, 0, 0, 0, 142, 151);
INSERT INTO public.who_global_data VALUES (33548, 183, 1122, 0, 18, 142, 213);
INSERT INTO public.who_global_data VALUES (33549, 13, 7332, 0, 161, 142, 118);
INSERT INTO public.who_global_data VALUES (33550, 0, 365, 0, 10, 142, 134);
INSERT INTO public.who_global_data VALUES (33551, 0, 3541, 0, 40, 142, 65);
INSERT INTO public.who_global_data VALUES (33552, 4771, 676487, 629, 71678, 142, 102);
INSERT INTO public.who_global_data VALUES (33553, 0, 0, 0, 0, 142, 223);
INSERT INTO public.who_global_data VALUES (33554, 3, 184, 0, 1, 142, 4);
INSERT INTO public.who_global_data VALUES (33555, 0, 311, 0, 0, 142, 146);
INSERT INTO public.who_global_data VALUES (33556, 201, 8084, 2, 129, 142, 31);
INSERT INTO public.who_global_data VALUES (33557, 0, 13, 0, 1, 142, 127);
INSERT INTO public.who_global_data VALUES (33558, 1692, 92016, 38, 1686, 142, 22);
INSERT INTO public.who_global_data VALUES (33559, 281, 5994, 2, 39, 142, 115);
INSERT INTO public.who_global_data VALUES (33560, 258, 3894, 7, 46, 142, 106);
INSERT INTO public.who_global_data VALUES (33561, 63, 9964, 2, 108, 142, 90);
INSERT INTO public.who_global_data VALUES (33562, 0, 0, 0, 0, 142, 70);
INSERT INTO public.who_global_data VALUES (33563, 1539, 58327, 8, 379, 142, 46);
INSERT INTO public.who_global_data VALUES (33564, 1537, 86217, 2, 6259, 142, 139);
INSERT INTO public.who_global_data VALUES (33565, 0, 26, 0, 0, 142, 42);
INSERT INTO public.who_global_data VALUES (33566, 7, 1458, 0, 25, 142, 80);
INSERT INTO public.who_global_data VALUES (33567, 0, 3979, 0, 147, 142, 203);
INSERT INTO public.who_global_data VALUES (33568, 0, 1180, 0, 69, 142, 136);
INSERT INTO public.who_global_data VALUES (33569, 126, 56604, 3, 1091, 142, 63);
INSERT INTO public.who_global_data VALUES (33570, 0, 0, 0, 0, 142, 17);
INSERT INTO public.who_global_data VALUES (33571, 0, 61, 0, 2, 142, 172);
INSERT INTO public.who_global_data VALUES (33572, 163, 16088, 7, 668, 142, 109);
INSERT INTO public.who_global_data VALUES (33573, 116, 12393, 0, 265, 142, 200);
INSERT INTO public.who_global_data VALUES (33574, 963, 42379, 15, 276, 142, 93);
INSERT INTO public.who_global_data VALUES (33575, 536, 91196, 8, 805, 142, 5);
INSERT INTO public.who_global_data VALUES (33576, 0, 741, 0, 13, 142, 214);
INSERT INTO public.who_global_data VALUES (33577, 545, 303634, 6, 6399, 142, 204);
INSERT INTO public.who_global_data VALUES (33578, 0, 0, 0, 0, 142, 198);
INSERT INTO public.who_global_data VALUES (33579, 628, 102832, 14, 2187, 142, 173);
INSERT INTO public.who_global_data VALUES (33580, 5, 516, 0, 6, 142, 229);
INSERT INTO public.who_global_data VALUES (33581, 811, 29298, 13, 552, 142, 76);
INSERT INTO public.who_global_data VALUES (33582, 4160, 738020, 115, 30927, 142, 138);
INSERT INTO public.who_global_data VALUES (33583, 3527, 272934, 69, 4732, 142, 98);
INSERT INTO public.who_global_data VALUES (33584, 0, 0, 0, 0, 142, 103);
INSERT INTO public.who_global_data VALUES (33585, 600, 75734, 10, 2237, 142, 225);
INSERT INTO public.who_global_data VALUES (33586, 605, 65626, 3, 1878, 142, 131);
INSERT INTO public.who_global_data VALUES (33587, 112, 38284, 19, 570, 142, 235);
INSERT INTO public.who_global_data VALUES (33588, 235, 122449, 0, 208, 142, 137);
INSERT INTO public.who_global_data VALUES (33589, 153, 22657, 5, 372, 142, 81);
INSERT INTO public.who_global_data VALUES (33590, 627, 44361, 15, 1159, 142, 182);
INSERT INTO public.who_global_data VALUES (33591, 100, 3002, 0, 10, 142, 145);
INSERT INTO public.who_global_data VALUES (33592, 1713, 107011, 49, 4285, 142, 26);
INSERT INTO public.who_global_data VALUES (33593, 5762, 1085281, 144, 19061, 142, 170);
INSERT INTO public.who_global_data VALUES (33594, 10, 4634, 0, 22, 142, 191);
INSERT INTO public.who_global_data VALUES (33595, 0, 5, 0, 0, 142, 221);
INSERT INTO public.who_global_data VALUES (33596, 0, 23, 0, 0, 142, 64);
INSERT INTO public.who_global_data VALUES (33597, 0, 0, 0, 0, 142, 116);
INSERT INTO public.who_global_data VALUES (33598, 0, 17, 0, 0, 142, 128);
INSERT INTO public.who_global_data VALUES (33599, 0, 27, 0, 0, 142, 6);
INSERT INTO public.who_global_data VALUES (33600, 0, 330, 0, 6, 142, 227);
INSERT INTO public.who_global_data VALUES (33601, 0, 11, 0, 0, 142, 68);
INSERT INTO public.who_global_data VALUES (33602, 0, 64, 0, 0, 142, 184);
INSERT INTO public.who_global_data VALUES (33603, 0, 0, 0, 0, 142, 82);
INSERT INTO public.who_global_data VALUES (33604, 1, 742, 0, 42, 142, 149);
INSERT INTO public.who_global_data VALUES (33605, 0, 907, 0, 15, 142, 197);
INSERT INTO public.who_global_data VALUES (33606, 621, 327551, 31, 4369, 142, 78);
INSERT INTO public.who_global_data VALUES (33607, 39, 14568, 1, 299, 142, 233);
INSERT INTO public.who_global_data VALUES (33608, 102, 32613, 1, 736, 142, 133);
INSERT INTO public.who_global_data VALUES (33609, 0, 138, 0, 0, 142, 35);
INSERT INTO public.who_global_data VALUES (33610, 7, 2133, 0, 72, 142, 114);
INSERT INTO public.who_global_data VALUES (33611, 26, 57514, 0, 27, 142, 237);
INSERT INTO public.who_global_data VALUES (33612, 0, 11, 0, 0, 142, 55);
INSERT INTO public.who_global_data VALUES (33613, 0, 549, 0, 19, 142, 176);
INSERT INTO public.who_global_data VALUES (33614, 92, 5860, 0, 38, 142, 202);
INSERT INTO public.who_global_data VALUES (33615, 104, 4060, 1, 138, 142, 155);
INSERT INTO public.who_global_data VALUES (33616, 0, 0, 0, 0, 142, 32);
INSERT INTO public.who_global_data VALUES (33617, 0, 3390, 0, 98, 142, 220);
INSERT INTO public.who_global_data VALUES (33618, 1923, 653444, 64, 15705, 142, 30);
INSERT INTO public.who_global_data VALUES (33619, 5, 2599, 0, 49, 142, 147);
INSERT INTO public.who_global_data VALUES (33620, 14040, 660826, 126, 32237, 142, 208);
INSERT INTO public.who_global_data VALUES (33621, 0, 3271, 0, 13, 142, 45);
INSERT INTO public.who_global_data VALUES (33622, 0, 13535, 0, 836, 142, 110);
INSERT INTO public.who_global_data VALUES (33623, 14, 4625, 0, 95, 142, 88);
INSERT INTO public.who_global_data VALUES (33624, 292, 87671, 1, 5856, 142, 51);
INSERT INTO public.who_global_data VALUES (33625, 516, 49040, 5, 1797, 142, 209);
INSERT INTO public.who_global_data VALUES (33626, 40, 3654, 3, 163, 142, 205);
INSERT INTO public.who_global_data VALUES (33627, 42, 9171, 0, 73, 142, 18);
INSERT INTO public.who_global_data VALUES (33628, 0, 3490, 0, 58, 142, 72);
INSERT INTO public.who_global_data VALUES (33629, 3991, 378223, 20, 41684, 142, 44);
INSERT INTO public.who_global_data VALUES (33630, 0, 27, 0, 0, 142, 15);
INSERT INTO public.who_global_data VALUES (33631, 13, 1608, 0, 40, 142, 25);
INSERT INTO public.who_global_data VALUES (33632, 0, 0, 0, 0, 142, 179);
INSERT INTO public.who_global_data VALUES (33633, 0, 0, 0, 0, 142, 34);
INSERT INTO public.who_global_data VALUES (33634, 110, 3293, 1, 57, 142, 207);
INSERT INTO public.who_global_data VALUES (33635, 540, 9110, 5, 138, 142, 166);
INSERT INTO public.who_global_data VALUES (33636, 8501, 639621, 63, 7249, 142, 126);
INSERT INTO public.who_global_data VALUES (33637, 0, 0, 0, 0, 142, 97);
INSERT INTO public.who_global_data VALUES (33638, 2, 650, 0, 5, 142, 36);
INSERT INTO public.who_global_data VALUES (33639, 0, 0, 0, 0, 142, 125);
INSERT INTO public.who_global_data VALUES (33640, 143, 5266, 2, 60, 142, 124);
INSERT INTO public.who_global_data VALUES (33641, 3584, 166244, 60, 3400, 142, 185);
INSERT INTO public.who_global_data VALUES (33642, 842, 81782, 1, 402, 142, 194);
INSERT INTO public.who_global_data VALUES (33643, 0, 509, 0, 21, 142, 144);
INSERT INTO public.who_global_data VALUES (33644, 34078, 6530324, 940, 194434, 142, 19);
INSERT INTO public.who_global_data VALUES (33645, 7, 1232, 0, 19, 142, 217);
INSERT INTO public.who_global_data VALUES (33646, 15, 1827, 0, 45, 142, 148);
INSERT INTO public.who_global_data VALUES (33647, 609, 49385, 6, 411, 142, 86);
INSERT INTO public.who_global_data VALUES (33648, 0, 0, 0, 0, 142, 13);
INSERT INTO public.who_global_data VALUES (33649, 1086, 62655, 8, 502, 142, 157);
INSERT INTO public.who_global_data VALUES (33650, 0, 1063, 0, 35, 142, 8);
INSERT INTO public.who_global_data VALUES (33651, 0, 0, 0, 0, 142, 73);
INSERT INTO public.who_global_data VALUES (33652, 3, 2023, 0, 584, 142, 101);
INSERT INTO public.who_global_data VALUES (33653, 68, 13887, 2, 326, 142, 165);
INSERT INTO public.who_global_data VALUES (33654, 22, 7598, 0, 224, 142, 14);
INSERT INTO public.who_global_data VALUES (33655, 40, 38941, 10, 1440, 143, 193);
INSERT INTO public.who_global_data VALUES (33656, 152, 11672, 2, 340, 143, 113);
INSERT INTO public.who_global_data VALUES (33657, 238, 48734, 12, 1632, 143, 143);
INSERT INTO public.who_global_data VALUES (33658, 0, 0, 0, 0, 143, 219);
INSERT INTO public.who_global_data VALUES (33659, 0, 1438, 0, 53, 143, 186);
INSERT INTO public.who_global_data VALUES (33660, 130, 3569, 5, 139, 143, 52);
INSERT INTO public.who_global_data VALUES (33661, 0, 3, 0, 0, 143, 180);
INSERT INTO public.who_global_data VALUES (33662, 0, 95, 0, 3, 143, 167);
INSERT INTO public.who_global_data VALUES (33663, 9909, 565446, 298, 11710, 143, 154);
INSERT INTO public.who_global_data VALUES (33664, 257, 45689, 3, 918, 143, 94);
INSERT INTO public.who_global_data VALUES (33665, 14, 3060, 2, 20, 143, 66);
INSERT INTO public.who_global_data VALUES (33666, 46, 26738, 0, 816, 143, 58);
INSERT INTO public.who_global_data VALUES (33667, 860, 34744, 0, 757, 143, 163);
INSERT INTO public.who_global_data VALUES (33668, 114, 38517, 2, 566, 143, 37);
INSERT INTO public.who_global_data VALUES (33669, 34, 3008, 1, 68, 143, 142);
INSERT INTO public.who_global_data VALUES (33670, 678, 61643, 0, 213, 143, 83);
INSERT INTO public.who_global_data VALUES (33671, 1724, 341056, 43, 4802, 143, 228);
INSERT INTO public.who_global_data VALUES (33672, 0, 183, 0, 7, 143, 188);
INSERT INTO public.who_global_data VALUES (33673, 192, 74552, 5, 761, 143, 62);
INSERT INTO public.who_global_data VALUES (33674, 1628, 98661, 3, 9927, 143, 160);
INSERT INTO public.who_global_data VALUES (33675, 21, 1501, 0, 19, 143, 50);
INSERT INTO public.who_global_data VALUES (33676, 13, 2280, 0, 40, 143, 33);
INSERT INTO public.who_global_data VALUES (33677, 0, 177, 0, 9, 143, 183);
INSERT INTO public.who_global_data VALUES (33678, 0, 246, 0, 0, 143, 92);
INSERT INTO public.who_global_data VALUES (33679, 828, 127619, 50, 7394, 143, 158);
INSERT INTO public.who_global_data VALUES (33680, 4, 16, 0, 1, 143, 67);
INSERT INTO public.who_global_data VALUES (33681, 294, 23924, 20, 718, 143, 57);
INSERT INTO public.who_global_data VALUES (33682, 211, 2463, 1, 11, 143, 38);
INSERT INTO public.who_global_data VALUES (33683, 15155, 4345610, 381, 132006, 143, 141);
INSERT INTO public.who_global_data VALUES (33684, 0, 66, 0, 1, 143, 178);
INSERT INTO public.who_global_data VALUES (33685, 0, 145, 0, 3, 143, 108);
INSERT INTO public.who_global_data VALUES (33686, 155, 18216, 6, 736, 143, 39);
INSERT INTO public.who_global_data VALUES (33687, 25, 1717, 0, 56, 143, 2);
INSERT INTO public.who_global_data VALUES (33688, 0, 472, 0, 1, 143, 195);
INSERT INTO public.who_global_data VALUES (33689, 65, 4904, 1, 46, 143, 107);
INSERT INTO public.who_global_data VALUES (33690, 0, 275, 0, 0, 143, 161);
INSERT INTO public.who_global_data VALUES (33691, 32, 20303, 0, 415, 143, 212);
INSERT INTO public.who_global_data VALUES (33692, 1351, 138010, 8, 9179, 143, 181);
INSERT INTO public.who_global_data VALUES (33693, 0, 208, 0, 1, 143, 53);
INSERT INTO public.who_global_data VALUES (33694, 0, 4772, 0, 62, 143, 164);
INSERT INTO public.who_global_data VALUES (33695, 2, 1087, 0, 81, 143, 140);
INSERT INTO public.who_global_data VALUES (33696, 1550, 437983, 27, 12040, 143, 20);
INSERT INTO public.who_global_data VALUES (33697, 16, 90734, 1, 4743, 143, 112);
INSERT INTO public.who_global_data VALUES (33698, 5573, 721892, 199, 23123, 143, 111);
INSERT INTO public.who_global_data VALUES (33699, 0, 457, 0, 7, 143, 71);
INSERT INTO public.who_global_data VALUES (33700, 0, 4934, 0, 88, 143, 218);
INSERT INTO public.who_global_data VALUES (33701, 0, 0, 0, 0, 143, 43);
INSERT INTO public.who_global_data VALUES (33702, 937, 57361, 16, 621, 143, 49);
INSERT INTO public.who_global_data VALUES (33703, 87, 19100, 0, 120, 143, 1);
INSERT INTO public.who_global_data VALUES (33704, 151, 13749, 3, 230, 143, 48);
INSERT INTO public.who_global_data VALUES (33705, 77, 4803, 0, 108, 143, 232);
INSERT INTO public.who_global_data VALUES (33706, 12, 169, 0, 1, 143, 175);
INSERT INTO public.who_global_data VALUES (33707, 6, 1540, 0, 22, 143, 21);
INSERT INTO public.who_global_data VALUES (33708, 1674, 38896, 11, 476, 143, 156);
INSERT INTO public.who_global_data VALUES (33709, 0, 0, 0, 0, 143, 95);
INSERT INTO public.who_global_data VALUES (33710, 11, 10400, 3, 267, 143, 177);
INSERT INTO public.who_global_data VALUES (33711, 329, 20129, 0, 633, 143, 210);
INSERT INTO public.who_global_data VALUES (33712, 0, 5396, 0, 61, 143, 120);
INSERT INTO public.who_global_data VALUES (33713, 0, 24, 0, 0, 143, 135);
INSERT INTO public.who_global_data VALUES (33714, 693, 104803, 14, 1998, 143, 206);
INSERT INTO public.who_global_data VALUES (33715, 642, 119553, 41, 10963, 143, 189);
INSERT INTO public.who_global_data VALUES (33716, 163, 101340, 18, 5679, 143, 129);
INSERT INTO public.who_global_data VALUES (33717, 79, 27088, 4, 792, 143, 121);
INSERT INTO public.who_global_data VALUES (33718, 0, 5000, 0, 83, 143, 59);
INSERT INTO public.who_global_data VALUES (33719, 3, 364, 0, 0, 143, 96);
INSERT INTO public.who_global_data VALUES (33720, 24, 2722, 0, 64, 143, 41);
INSERT INTO public.who_global_data VALUES (33721, 24, 5128, 0, 101, 143, 216);
INSERT INTO public.who_global_data VALUES (33722, 700, 65486, 13, 1035, 143, 236);
INSERT INTO public.who_global_data VALUES (33723, 0, 13, 0, 0, 143, 150);
INSERT INTO public.who_global_data VALUES (33724, 5, 428, 0, 0, 143, 61);
INSERT INTO public.who_global_data VALUES (33725, 0, 32, 0, 2, 143, 7);
INSERT INTO public.who_global_data VALUES (33726, 98, 8725, 0, 339, 143, 169);
INSERT INTO public.who_global_data VALUES (33727, 7720, 374700, 48, 30837, 143, 28);
INSERT INTO public.who_global_data VALUES (33728, 26, 9578, 1, 64, 143, 85);
INSERT INTO public.who_global_data VALUES (33729, 36, 1135, 0, 2, 143, 211);
INSERT INTO public.who_global_data VALUES (33730, 0, 8654, 0, 53, 143, 60);
INSERT INTO public.who_global_data VALUES (33731, 35, 3440, 4, 107, 143, 3);
INSERT INTO public.who_global_data VALUES (33732, 196, 2758, 0, 19, 143, 11);
INSERT INTO public.who_global_data VALUES (33733, 1901, 263663, 6, 9368, 143, 89);
INSERT INTO public.who_global_data VALUES (33734, 221, 45655, 8, 294, 143, 24);
INSERT INTO public.who_global_data VALUES (33735, 0, 330, 0, 0, 143, 162);
INSERT INTO public.who_global_data VALUES (33736, 310, 13730, 3, 313, 143, 100);
INSERT INTO public.who_global_data VALUES (33737, 0, 14, 0, 0, 143, 47);
INSERT INTO public.who_global_data VALUES (33738, 0, 24, 0, 0, 143, 29);
INSERT INTO public.who_global_data VALUES (33739, 0, 3080, 0, 24, 143, 40);
INSERT INTO public.who_global_data VALUES (33740, 39, 1966, 3, 29, 143, 222);
INSERT INTO public.who_global_data VALUES (33741, 512, 82684, 12, 2984, 143, 132);
INSERT INTO public.who_global_data VALUES (33742, 0, 253, 0, 13, 143, 130);
INSERT INTO public.who_global_data VALUES (33743, 50, 10111, 0, 63, 143, 234);
INSERT INTO public.who_global_data VALUES (33744, 0, 2275, 0, 39, 143, 23);
INSERT INTO public.who_global_data VALUES (33745, 31, 1884, 0, 56, 143, 192);
INSERT INTO public.who_global_data VALUES (33746, 6, 8499, 0, 219, 143, 69);
INSERT INTO public.who_global_data VALUES (33747, 0, 12, 0, 0, 143, 187);
INSERT INTO public.who_global_data VALUES (33748, 831, 68620, 8, 2087, 143, 230);
INSERT INTO public.who_global_data VALUES (33749, 1307, 14460, 12, 654, 143, 77);
INSERT INTO public.who_global_data VALUES (33750, 6, 2174, 0, 10, 143, 9);
INSERT INTO public.who_global_data VALUES (33751, 90123, 5020359, 1290, 82066, 143, 74);
INSERT INTO public.who_global_data VALUES (33752, 3507, 225030, 124, 8965, 143, 224);
INSERT INTO public.who_global_data VALUES (33753, 2705, 407353, 140, 23453, 143, 199);
INSERT INTO public.who_global_data VALUES (33754, 4224, 298702, 80, 8166, 143, 190);
INSERT INTO public.who_global_data VALUES (33755, 357, 31549, 3, 1787, 143, 12);
INSERT INTO public.who_global_data VALUES (33756, 1, 339, 0, 24, 143, 104);
INSERT INTO public.who_global_data VALUES (33757, 4805, 161032, 20, 1176, 143, 153);
INSERT INTO public.who_global_data VALUES (33758, 1229, 289990, 9, 35633, 143, 91);
INSERT INTO public.who_global_data VALUES (33759, 109, 4042, 2, 46, 143, 215);
INSERT INTO public.who_global_data VALUES (33760, 490, 76448, 10, 1461, 143, 84);
INSERT INTO public.who_global_data VALUES (33761, 6, 386, 0, 32, 143, 231);
INSERT INTO public.who_global_data VALUES (33762, 149, 3745, 0, 26, 143, 196);
INSERT INTO public.who_global_data VALUES (33763, 335, 137393, 0, 1999, 143, 105);
INSERT INTO public.who_global_data VALUES (33764, 96, 36301, 10, 634, 143, 122);
INSERT INTO public.who_global_data VALUES (33765, 0, 0, 0, 0, 143, 159);
INSERT INTO public.who_global_data VALUES (33766, 71, 14720, 1, 591, 143, 75);
INSERT INTO public.who_global_data VALUES (33767, 829, 96301, 5, 568, 143, 27);
INSERT INTO public.who_global_data VALUES (33768, 73, 45072, 0, 1063, 143, 54);
INSERT INTO public.who_global_data VALUES (33769, 0, 23, 0, 0, 143, 226);
INSERT INTO public.who_global_data VALUES (33770, 5, 1482, 0, 35, 143, 79);
INSERT INTO public.who_global_data VALUES (33771, 592, 25449, 6, 252, 143, 56);
INSERT INTO public.who_global_data VALUES (33772, 82, 1327, 0, 33, 143, 117);
INSERT INTO public.who_global_data VALUES (33773, 16, 1327, 0, 82, 143, 152);
INSERT INTO public.who_global_data VALUES (33774, 792, 24936, 11, 394, 143, 16);
INSERT INTO public.who_global_data VALUES (33775, 0, 111, 0, 1, 143, 10);
INSERT INTO public.who_global_data VALUES (33776, 45, 3437, 1, 88, 143, 201);
INSERT INTO public.who_global_data VALUES (33777, 40, 7284, 0, 124, 143, 174);
INSERT INTO public.who_global_data VALUES (33778, 34, 15803, 1, 214, 143, 119);
INSERT INTO public.who_global_data VALUES (33779, 4, 5701, 0, 178, 143, 168);
INSERT INTO public.who_global_data VALUES (33780, 23, 9969, 0, 128, 143, 99);
INSERT INTO public.who_global_data VALUES (33781, 85, 9328, 0, 33, 143, 171);
INSERT INTO public.who_global_data VALUES (33782, 5, 2940, 0, 128, 143, 87);
INSERT INTO public.who_global_data VALUES (33783, 106, 2561, 0, 16, 143, 123);
INSERT INTO public.who_global_data VALUES (33784, 0, 0, 0, 0, 143, 151);
INSERT INTO public.who_global_data VALUES (33785, 0, 939, 0, 18, 143, 213);
INSERT INTO public.who_global_data VALUES (33786, 24, 7319, 0, 161, 143, 118);
INSERT INTO public.who_global_data VALUES (33787, 3, 365, 0, 10, 143, 134);
INSERT INTO public.who_global_data VALUES (33788, 0, 3541, 0, 40, 143, 65);
INSERT INTO public.who_global_data VALUES (33789, 3335, 671716, 228, 71049, 143, 102);
INSERT INTO public.who_global_data VALUES (33790, 0, 0, 0, 0, 143, 223);
INSERT INTO public.who_global_data VALUES (33791, 1, 181, 0, 1, 143, 4);
INSERT INTO public.who_global_data VALUES (33792, 0, 311, 0, 0, 143, 146);
INSERT INTO public.who_global_data VALUES (33793, 202, 7883, 4, 127, 143, 31);
INSERT INTO public.who_global_data VALUES (33794, 0, 13, 0, 1, 143, 127);
INSERT INTO public.who_global_data VALUES (33795, 2121, 90324, 34, 1648, 143, 22);
INSERT INTO public.who_global_data VALUES (33796, 231, 5713, 2, 37, 143, 115);
INSERT INTO public.who_global_data VALUES (33797, 337, 3636, 7, 39, 143, 106);
INSERT INTO public.who_global_data VALUES (33798, 83, 9901, 3, 106, 143, 90);
INSERT INTO public.who_global_data VALUES (33799, 0, 0, 0, 0, 143, 70);
INSERT INTO public.who_global_data VALUES (33800, 1459, 56788, 11, 371, 143, 46);
INSERT INTO public.who_global_data VALUES (33801, 1376, 84680, 2, 6257, 143, 139);
INSERT INTO public.who_global_data VALUES (33802, 0, 26, 0, 0, 143, 42);
INSERT INTO public.who_global_data VALUES (33803, 1, 1451, 1, 25, 143, 80);
INSERT INTO public.who_global_data VALUES (33804, 102, 3979, 3, 147, 143, 203);
INSERT INTO public.who_global_data VALUES (33805, 2, 1180, 0, 69, 143, 136);
INSERT INTO public.who_global_data VALUES (33806, 90, 56478, 5, 1088, 143, 63);
INSERT INTO public.who_global_data VALUES (33807, 0, 0, 0, 0, 143, 17);
INSERT INTO public.who_global_data VALUES (33808, 0, 61, 0, 2, 143, 172);
INSERT INTO public.who_global_data VALUES (33809, 98, 15925, 9, 661, 143, 109);
INSERT INTO public.who_global_data VALUES (33810, 122, 12277, 0, 265, 143, 200);
INSERT INTO public.who_global_data VALUES (33811, 1118, 41416, 6, 261, 143, 93);
INSERT INTO public.who_global_data VALUES (33812, 438, 90660, 7, 797, 143, 5);
INSERT INTO public.who_global_data VALUES (33813, 0, 741, 0, 13, 143, 214);
INSERT INTO public.who_global_data VALUES (33814, 665, 303089, 4, 6393, 143, 204);
INSERT INTO public.who_global_data VALUES (33815, 0, 0, 0, 0, 143, 198);
INSERT INTO public.who_global_data VALUES (33816, 459, 102204, 7, 2173, 143, 173);
INSERT INTO public.who_global_data VALUES (33817, 0, 511, 0, 6, 143, 229);
INSERT INTO public.who_global_data VALUES (33818, 670, 28487, 14, 539, 143, 76);
INSERT INTO public.who_global_data VALUES (33819, 4241, 733860, 102, 30812, 143, 138);
INSERT INTO public.who_global_data VALUES (33820, 3519, 269407, 33, 4663, 143, 98);
INSERT INTO public.who_global_data VALUES (33821, 0, 0, 0, 0, 143, 103);
INSERT INTO public.who_global_data VALUES (33822, 605, 75134, 24, 2227, 143, 225);
INSERT INTO public.who_global_data VALUES (33823, 425, 65021, 4, 1875, 143, 131);
INSERT INTO public.who_global_data VALUES (33824, 422, 38172, 9, 551, 143, 235);
INSERT INTO public.who_global_data VALUES (33825, 239, 122214, 1, 208, 143, 137);
INSERT INTO public.who_global_data VALUES (33826, 113, 22504, 0, 367, 143, 81);
INSERT INTO public.who_global_data VALUES (33827, 527, 43734, 14, 1144, 143, 182);
INSERT INTO public.who_global_data VALUES (33828, 30, 2902, 0, 10, 143, 145);
INSERT INTO public.who_global_data VALUES (33829, 1111, 105298, 51, 4236, 143, 26);
INSERT INTO public.who_global_data VALUES (33830, 5670, 1079519, 132, 18917, 143, 170);
INSERT INTO public.who_global_data VALUES (33831, 22, 4624, 0, 22, 143, 191);
INSERT INTO public.who_global_data VALUES (33832, 0, 5, 0, 0, 143, 221);
INSERT INTO public.who_global_data VALUES (33833, 2, 23, 0, 0, 143, 64);
INSERT INTO public.who_global_data VALUES (33834, 0, 0, 0, 0, 143, 116);
INSERT INTO public.who_global_data VALUES (33835, 0, 17, 0, 0, 143, 128);
INSERT INTO public.who_global_data VALUES (33836, 0, 27, 0, 0, 143, 6);
INSERT INTO public.who_global_data VALUES (33837, 74, 330, 0, 6, 143, 227);
INSERT INTO public.who_global_data VALUES (33838, 0, 11, 0, 0, 143, 68);
INSERT INTO public.who_global_data VALUES (33839, 0, 64, 0, 0, 143, 184);
INSERT INTO public.who_global_data VALUES (33840, 0, 0, 0, 0, 143, 82);
INSERT INTO public.who_global_data VALUES (33841, 0, 741, 0, 42, 143, 149);
INSERT INTO public.who_global_data VALUES (33842, 1, 907, 0, 15, 143, 197);
INSERT INTO public.who_global_data VALUES (33843, 672, 326930, 33, 4338, 143, 78);
INSERT INTO public.who_global_data VALUES (33844, 223, 14529, 1, 298, 143, 233);
INSERT INTO public.who_global_data VALUES (33845, 74, 32511, 2, 735, 143, 133);
INSERT INTO public.who_global_data VALUES (33846, 3, 138, 0, 0, 143, 35);
INSERT INTO public.who_global_data VALUES (33847, 15, 2126, 0, 72, 143, 114);
INSERT INTO public.who_global_data VALUES (33848, 34, 57488, 0, 27, 143, 237);
INSERT INTO public.who_global_data VALUES (33849, 0, 11, 0, 0, 143, 55);
INSERT INTO public.who_global_data VALUES (33850, 0, 549, 0, 19, 143, 176);
INSERT INTO public.who_global_data VALUES (33851, 188, 5768, 0, 38, 143, 202);
INSERT INTO public.who_global_data VALUES (33852, 123, 3956, 0, 137, 143, 155);
INSERT INTO public.who_global_data VALUES (33853, 0, 0, 0, 0, 143, 32);
INSERT INTO public.who_global_data VALUES (33854, 1, 3390, 0, 98, 143, 220);
INSERT INTO public.who_global_data VALUES (33855, 772, 651521, 142, 15641, 143, 30);
INSERT INTO public.who_global_data VALUES (33856, 2, 2594, 0, 49, 143, 147);
INSERT INTO public.who_global_data VALUES (33857, 8384, 646786, 97, 32111, 143, 208);
INSERT INTO public.who_global_data VALUES (33858, 9, 3271, 1, 13, 143, 45);
INSERT INTO public.who_global_data VALUES (33859, 0, 13535, 0, 836, 143, 110);
INSERT INTO public.who_global_data VALUES (33860, 29, 4611, 2, 95, 143, 88);
INSERT INTO public.who_global_data VALUES (33861, 220, 87379, 2, 5855, 143, 51);
INSERT INTO public.who_global_data VALUES (33862, 458, 48524, 3, 1792, 143, 209);
INSERT INTO public.who_global_data VALUES (33863, 38, 3614, 3, 160, 143, 205);
INSERT INTO public.who_global_data VALUES (33864, 41, 9129, 1, 73, 143, 18);
INSERT INTO public.who_global_data VALUES (33865, 10, 3490, 0, 58, 143, 72);
INSERT INTO public.who_global_data VALUES (33866, 3103, 374232, 27, 41664, 143, 44);
INSERT INTO public.who_global_data VALUES (33867, 0, 27, 0, 0, 143, 15);
INSERT INTO public.who_global_data VALUES (33868, 17, 1595, 0, 40, 143, 25);
INSERT INTO public.who_global_data VALUES (33869, 0, 0, 0, 0, 143, 179);
INSERT INTO public.who_global_data VALUES (33870, 0, 0, 0, 0, 143, 34);
INSERT INTO public.who_global_data VALUES (33871, 92, 3183, 2, 56, 143, 207);
INSERT INTO public.who_global_data VALUES (33872, 470, 8570, 4, 133, 143, 166);
INSERT INTO public.who_global_data VALUES (33873, 8472, 631120, 67, 7186, 143, 126);
INSERT INTO public.who_global_data VALUES (33874, 0, 0, 0, 0, 143, 97);
INSERT INTO public.who_global_data VALUES (33875, 2, 648, 0, 5, 143, 36);
INSERT INTO public.who_global_data VALUES (33876, 0, 0, 0, 0, 143, 125);
INSERT INTO public.who_global_data VALUES (33877, 145, 5123, 2, 58, 143, 124);
INSERT INTO public.who_global_data VALUES (33878, 2958, 162660, 76, 3340, 143, 185);
INSERT INTO public.who_global_data VALUES (33879, 674, 80940, 2, 401, 143, 194);
INSERT INTO public.who_global_data VALUES (33880, 0, 509, 0, 21, 143, 144);
INSERT INTO public.who_global_data VALUES (33881, 34111, 6496246, 375, 193494, 143, 19);
INSERT INTO public.who_global_data VALUES (33882, 4, 1225, 0, 19, 143, 217);
INSERT INTO public.who_global_data VALUES (33883, 4, 1812, 0, 45, 143, 148);
INSERT INTO public.who_global_data VALUES (33884, 584, 48776, 5, 405, 143, 86);
INSERT INTO public.who_global_data VALUES (33885, 0, 0, 0, 0, 143, 13);
INSERT INTO public.who_global_data VALUES (33886, 0, 61569, 0, 494, 143, 157);
INSERT INTO public.who_global_data VALUES (33887, 0, 1063, 0, 35, 143, 8);
INSERT INTO public.who_global_data VALUES (33888, 0, 0, 0, 0, 143, 73);
INSERT INTO public.who_global_data VALUES (33889, 3, 2020, 0, 584, 143, 101);
INSERT INTO public.who_global_data VALUES (33890, 99, 13819, 4, 324, 143, 165);
INSERT INTO public.who_global_data VALUES (33891, 45, 7576, 0, 224, 143, 14);
INSERT INTO public.who_global_data VALUES (33892, 43, 38901, 1, 1430, 144, 193);
INSERT INTO public.who_global_data VALUES (33893, 167, 11520, 4, 338, 144, 113);
INSERT INTO public.who_global_data VALUES (33894, 489, 48496, 15, 1620, 144, 143);
INSERT INTO public.who_global_data VALUES (33895, 0, 0, 0, 0, 144, 219);
INSERT INTO public.who_global_data VALUES (33896, 94, 1438, 0, 53, 144, 186);
INSERT INTO public.who_global_data VALUES (33897, 51, 3439, 0, 134, 144, 52);
INSERT INTO public.who_global_data VALUES (33898, 0, 3, 0, 0, 144, 180);
INSERT INTO public.who_global_data VALUES (33899, 0, 95, 0, 3, 144, 167);
INSERT INTO public.who_global_data VALUES (33900, 9056, 555537, 105, 11412, 144, 154);
INSERT INTO public.who_global_data VALUES (33901, 150, 45432, 1, 915, 144, 94);
INSERT INTO public.who_global_data VALUES (33902, 227, 3046, 2, 18, 144, 66);
INSERT INTO public.who_global_data VALUES (33903, 41, 26692, 6, 816, 144, 58);
INSERT INTO public.who_global_data VALUES (33904, 549, 33884, 1, 757, 144, 163);
INSERT INTO public.who_global_data VALUES (33905, 76, 38403, 2, 564, 144, 37);
INSERT INTO public.who_global_data VALUES (33906, 46, 2974, 0, 67, 144, 142);
INSERT INTO public.who_global_data VALUES (33907, 658, 60965, 0, 213, 144, 83);
INSERT INTO public.who_global_data VALUES (33908, 1812, 339332, 26, 4759, 144, 228);
INSERT INTO public.who_global_data VALUES (33909, 2, 183, 0, 7, 144, 188);
INSERT INTO public.who_global_data VALUES (33910, 187, 74360, 6, 756, 144, 62);
INSERT INTO public.who_global_data VALUES (33911, 1724, 97033, 4, 9924, 144, 160);
INSERT INTO public.who_global_data VALUES (33912, 22, 1480, 0, 19, 144, 50);
INSERT INTO public.who_global_data VALUES (33913, 0, 2267, 0, 40, 144, 33);
INSERT INTO public.who_global_data VALUES (33914, 0, 177, 0, 9, 144, 183);
INSERT INTO public.who_global_data VALUES (33915, 1, 246, 0, 0, 144, 92);
INSERT INTO public.who_global_data VALUES (33916, 809, 126791, 47, 7344, 144, 158);
INSERT INTO public.who_global_data VALUES (33917, 1, 12, 0, 1, 144, 67);
INSERT INTO public.who_global_data VALUES (33918, 168, 23630, 9, 698, 144, 57);
INSERT INTO public.who_global_data VALUES (33919, 0, 2252, 0, 10, 144, 38);
INSERT INTO public.who_global_data VALUES (33920, 14768, 4330455, 415, 131625, 144, 141);
INSERT INTO public.who_global_data VALUES (33921, 0, 66, 0, 1, 144, 178);
INSERT INTO public.who_global_data VALUES (33922, 0, 145, 0, 3, 144, 108);
INSERT INTO public.who_global_data VALUES (33923, 143, 18061, 10, 730, 144, 39);
INSERT INTO public.who_global_data VALUES (33924, 193, 1692, 0, 56, 144, 2);
INSERT INTO public.who_global_data VALUES (33925, 0, 472, 0, 1, 144, 195);
INSERT INTO public.who_global_data VALUES (33926, 26, 4839, 1, 45, 144, 107);
INSERT INTO public.who_global_data VALUES (33927, 0, 275, 0, 0, 144, 161);
INSERT INTO public.who_global_data VALUES (33928, 43, 20271, 0, 415, 144, 212);
INSERT INTO public.who_global_data VALUES (33929, 518, 136659, 1, 9171, 144, 181);
INSERT INTO public.who_global_data VALUES (33930, 0, 208, 0, 1, 144, 53);
INSERT INTO public.who_global_data VALUES (33931, 23, 4772, 0, 62, 144, 164);
INSERT INTO public.who_global_data VALUES (33932, 1, 1085, 1, 81, 144, 140);
INSERT INTO public.who_global_data VALUES (33933, 1685, 436433, 64, 12013, 144, 20);
INSERT INTO public.who_global_data VALUES (33934, 23, 90718, 1, 4742, 144, 112);
INSERT INTO public.who_global_data VALUES (33935, 7355, 716319, 190, 22924, 144, 111);
INSERT INTO public.who_global_data VALUES (33936, 1, 457, 0, 7, 144, 71);
INSERT INTO public.who_global_data VALUES (33937, 0, 4934, 0, 88, 144, 218);
INSERT INTO public.who_global_data VALUES (33938, 0, 0, 0, 0, 144, 43);
INSERT INTO public.who_global_data VALUES (33939, 970, 56424, 15, 605, 144, 49);
INSERT INTO public.who_global_data VALUES (33940, 26, 19013, 0, 120, 144, 1);
INSERT INTO public.who_global_data VALUES (33941, 65, 13598, 3, 227, 144, 48);
INSERT INTO public.who_global_data VALUES (33942, 42, 4726, 0, 108, 144, 232);
INSERT INTO public.who_global_data VALUES (33943, 22, 157, 0, 1, 144, 175);
INSERT INTO public.who_global_data VALUES (33944, 8, 1534, 1, 22, 144, 21);
INSERT INTO public.who_global_data VALUES (33945, 1034, 37222, 9, 465, 144, 156);
INSERT INTO public.who_global_data VALUES (33946, 0, 0, 0, 0, 144, 95);
INSERT INTO public.who_global_data VALUES (33947, 0, 10389, 0, 264, 144, 177);
INSERT INTO public.who_global_data VALUES (33948, 584, 19800, 4, 633, 144, 210);
INSERT INTO public.who_global_data VALUES (33949, 1, 5396, 0, 61, 144, 120);
INSERT INTO public.who_global_data VALUES (33950, 0, 24, 0, 0, 144, 135);
INSERT INTO public.who_global_data VALUES (33951, 450, 104110, 16, 1984, 144, 206);
INSERT INTO public.who_global_data VALUES (33952, 317, 118911, 19, 10922, 144, 189);
INSERT INTO public.who_global_data VALUES (33953, 168, 101177, 13, 5661, 144, 129);
INSERT INTO public.who_global_data VALUES (33954, 81, 27009, 3, 788, 144, 121);
INSERT INTO public.who_global_data VALUES (33955, 4, 5000, 0, 83, 144, 59);
INSERT INTO public.who_global_data VALUES (33956, 0, 361, 0, 0, 144, 96);
INSERT INTO public.who_global_data VALUES (33957, 22, 2698, 0, 64, 144, 41);
INSERT INTO public.who_global_data VALUES (33958, 29, 5104, 3, 101, 144, 216);
INSERT INTO public.who_global_data VALUES (33959, 485, 64786, 9, 1022, 144, 236);
INSERT INTO public.who_global_data VALUES (33960, 0, 13, 0, 0, 144, 150);
INSERT INTO public.who_global_data VALUES (33961, 0, 423, 0, 0, 144, 61);
INSERT INTO public.who_global_data VALUES (33962, 0, 32, 0, 2, 144, 7);
INSERT INTO public.who_global_data VALUES (33963, 47, 8627, 2, 339, 144, 169);
INSERT INTO public.who_global_data VALUES (33964, 5893, 366980, 34, 30789, 144, 28);
INSERT INTO public.who_global_data VALUES (33965, 31, 9552, 0, 63, 144, 85);
INSERT INTO public.who_global_data VALUES (33966, 44, 1099, 0, 2, 144, 211);
INSERT INTO public.who_global_data VALUES (33967, 11, 8654, 0, 53, 144, 60);
INSERT INTO public.who_global_data VALUES (33968, 0, 3405, 0, 103, 144, 3);
INSERT INTO public.who_global_data VALUES (33969, 170, 2562, 0, 19, 144, 11);
INSERT INTO public.who_global_data VALUES (33970, 1407, 261762, 12, 9362, 144, 89);
INSERT INTO public.who_global_data VALUES (33971, 0, 45434, 0, 286, 144, 24);
INSERT INTO public.who_global_data VALUES (33972, 3, 330, 0, 0, 144, 162);
INSERT INTO public.who_global_data VALUES (33973, 180, 13420, 5, 310, 144, 100);
INSERT INTO public.who_global_data VALUES (33974, 0, 14, 0, 0, 144, 47);
INSERT INTO public.who_global_data VALUES (33975, 0, 24, 0, 0, 144, 29);
INSERT INTO public.who_global_data VALUES (33976, 0, 3080, 0, 24, 144, 40);
INSERT INTO public.who_global_data VALUES (33977, 36, 1927, 0, 26, 144, 222);
INSERT INTO public.who_global_data VALUES (33978, 263, 82172, 15, 2972, 144, 132);
INSERT INTO public.who_global_data VALUES (33979, 0, 253, 0, 13, 144, 130);
INSERT INTO public.who_global_data VALUES (33980, 16, 10061, 0, 63, 144, 234);
INSERT INTO public.who_global_data VALUES (33981, 0, 2275, 0, 39, 144, 23);
INSERT INTO public.who_global_data VALUES (33982, 41, 1853, 2, 56, 144, 192);
INSERT INTO public.who_global_data VALUES (33983, 15, 8493, 0, 219, 144, 69);
INSERT INTO public.who_global_data VALUES (33984, 0, 12, 0, 0, 144, 187);
INSERT INTO public.who_global_data VALUES (33985, 653, 67789, 14, 2079, 144, 230);
INSERT INTO public.who_global_data VALUES (33986, 844, 13153, 5, 642, 144, 77);
INSERT INTO public.who_global_data VALUES (33987, 3, 2168, 0, 10, 144, 9);
INSERT INTO public.who_global_data VALUES (33988, 83809, 4930236, 1054, 80776, 144, 74);
INSERT INTO public.who_global_data VALUES (33989, 3141, 221523, 118, 8841, 144, 224);
INSERT INTO public.who_global_data VALUES (33990, 2619, 404648, 156, 23313, 144, 199);
INSERT INTO public.who_global_data VALUES (33991, 4169, 294478, 72, 8086, 144, 190);
INSERT INTO public.who_global_data VALUES (33992, 207, 31192, 0, 1784, 144, 12);
INSERT INTO public.who_global_data VALUES (33993, 1, 338, 0, 24, 144, 104);
INSERT INTO public.who_global_data VALUES (33994, 3175, 156227, 17, 1156, 144, 153);
INSERT INTO public.who_global_data VALUES (33995, 1008, 288761, 14, 35624, 144, 91);
INSERT INTO public.who_global_data VALUES (33996, 162, 3933, 2, 44, 144, 215);
INSERT INTO public.who_global_data VALUES (33997, 301, 75958, 9, 1451, 144, 84);
INSERT INTO public.who_global_data VALUES (33998, 0, 380, 0, 32, 144, 231);
INSERT INTO public.who_global_data VALUES (33999, 214, 3596, 2, 26, 144, 196);
INSERT INTO public.who_global_data VALUES (34000, 472, 137058, 0, 1999, 144, 105);
INSERT INTO public.who_global_data VALUES (34001, 48, 36205, 2, 624, 144, 122);
INSERT INTO public.who_global_data VALUES (34002, 0, 0, 0, 0, 144, 159);
INSERT INTO public.who_global_data VALUES (34003, 55, 14649, 4, 590, 144, 75);
INSERT INTO public.who_global_data VALUES (34004, 708, 95472, 3, 563, 144, 27);
INSERT INTO public.who_global_data VALUES (34005, 71, 44999, 0, 1063, 144, 54);
INSERT INTO public.who_global_data VALUES (34006, 0, 23, 0, 0, 144, 226);
INSERT INTO public.who_global_data VALUES (34007, 3, 1477, 0, 35, 144, 79);
INSERT INTO public.who_global_data VALUES (34008, 547, 24857, 5, 246, 144, 56);
INSERT INTO public.who_global_data VALUES (34009, 0, 1245, 0, 33, 144, 117);
INSERT INTO public.who_global_data VALUES (34010, 0, 1311, 0, 82, 144, 152);
INSERT INTO public.who_global_data VALUES (34011, 629, 24144, 15, 383, 144, 16);
INSERT INTO public.who_global_data VALUES (34012, 0, 111, 0, 1, 144, 10);
INSERT INTO public.who_global_data VALUES (34013, 11, 3392, 0, 87, 144, 201);
INSERT INTO public.who_global_data VALUES (34014, 50, 7244, 0, 124, 144, 174);
INSERT INTO public.who_global_data VALUES (34015, 12, 15769, 2, 213, 144, 119);
INSERT INTO public.who_global_data VALUES (34016, 7, 5697, 1, 178, 144, 168);
INSERT INTO public.who_global_data VALUES (34017, 31, 9946, 0, 128, 144, 99);
INSERT INTO public.who_global_data VALUES (34018, 70, 9243, 1, 33, 144, 171);
INSERT INTO public.who_global_data VALUES (34019, 11, 2935, 0, 128, 144, 87);
INSERT INTO public.who_global_data VALUES (34020, 49, 2455, 1, 16, 144, 123);
INSERT INTO public.who_global_data VALUES (34021, 0, 0, 0, 0, 144, 151);
INSERT INTO public.who_global_data VALUES (34022, 0, 939, 0, 18, 144, 213);
INSERT INTO public.who_global_data VALUES (34023, 19, 7295, 0, 161, 144, 118);
INSERT INTO public.who_global_data VALUES (34024, 1, 362, 0, 10, 144, 134);
INSERT INTO public.who_global_data VALUES (34025, 167, 3541, 0, 40, 144, 65);
INSERT INTO public.who_global_data VALUES (34026, 4408, 668381, 217, 70821, 144, 102);
INSERT INTO public.who_global_data VALUES (34027, 0, 0, 0, 0, 144, 223);
INSERT INTO public.who_global_data VALUES (34028, 6, 180, 0, 1, 144, 4);
INSERT INTO public.who_global_data VALUES (34029, 0, 311, 0, 0, 144, 146);
INSERT INTO public.who_global_data VALUES (34030, 174, 7681, 2, 123, 144, 31);
INSERT INTO public.who_global_data VALUES (34031, 0, 13, 0, 1, 144, 127);
INSERT INTO public.who_global_data VALUES (34032, 1517, 88203, 36, 1614, 144, 22);
INSERT INTO public.who_global_data VALUES (34033, 213, 5482, 0, 35, 144, 115);
INSERT INTO public.who_global_data VALUES (34034, 284, 3299, 8, 32, 144, 106);
INSERT INTO public.who_global_data VALUES (34035, 99, 9818, 2, 103, 144, 90);
INSERT INTO public.who_global_data VALUES (34036, 0, 0, 0, 0, 144, 70);
INSERT INTO public.who_global_data VALUES (34037, 1170, 55329, 15, 360, 144, 46);
INSERT INTO public.who_global_data VALUES (34038, 1297, 83304, 2, 6255, 144, 139);
INSERT INTO public.who_global_data VALUES (34039, 0, 26, 0, 0, 144, 42);
INSERT INTO public.who_global_data VALUES (34040, 3, 1450, 0, 24, 144, 80);
INSERT INTO public.who_global_data VALUES (34041, 0, 3877, 0, 144, 144, 203);
INSERT INTO public.who_global_data VALUES (34042, 0, 1178, 0, 69, 144, 136);
INSERT INTO public.who_global_data VALUES (34043, 132, 56388, 1, 1083, 144, 63);
INSERT INTO public.who_global_data VALUES (34044, 0, 0, 0, 0, 144, 17);
INSERT INTO public.who_global_data VALUES (34045, 1, 61, 0, 2, 144, 172);
INSERT INTO public.who_global_data VALUES (34046, 36, 15827, 4, 652, 144, 109);
INSERT INTO public.who_global_data VALUES (34047, 289, 12155, 0, 265, 144, 200);
INSERT INTO public.who_global_data VALUES (34048, 788, 40298, 5, 255, 144, 93);
INSERT INTO public.who_global_data VALUES (34049, 476, 90222, 10, 790, 144, 5);
INSERT INTO public.who_global_data VALUES (34050, 0, 741, 0, 13, 144, 214);
INSERT INTO public.who_global_data VALUES (34051, 404, 302424, 6, 6389, 144, 204);
INSERT INTO public.who_global_data VALUES (34052, 0, 0, 0, 0, 144, 198);
INSERT INTO public.who_global_data VALUES (34053, 704, 101745, 11, 2166, 144, 173);
INSERT INTO public.who_global_data VALUES (34054, 0, 511, 0, 6, 144, 229);
INSERT INTO public.who_global_data VALUES (34055, 493, 27817, 11, 525, 144, 76);
INSERT INTO public.who_global_data VALUES (34056, 6787, 729619, 117, 30710, 144, 138);
INSERT INTO public.who_global_data VALUES (34057, 4672, 265888, 259, 4630, 144, 98);
INSERT INTO public.who_global_data VALUES (34058, 0, 0, 0, 0, 144, 103);
INSERT INTO public.who_global_data VALUES (34059, 377, 74529, 15, 2203, 144, 225);
INSERT INTO public.who_global_data VALUES (34060, 613, 64596, 4, 1871, 144, 131);
INSERT INTO public.who_global_data VALUES (34061, 370, 37750, 3, 542, 144, 235);
INSERT INTO public.who_global_data VALUES (34062, 235, 121975, 2, 207, 144, 137);
INSERT INTO public.who_global_data VALUES (34063, 106, 22391, 4, 367, 144, 81);
INSERT INTO public.who_global_data VALUES (34064, 229, 43207, 7, 1130, 144, 182);
INSERT INTO public.who_global_data VALUES (34065, 67, 2872, 0, 10, 144, 145);
INSERT INTO public.who_global_data VALUES (34066, 692, 104187, 22, 4185, 144, 26);
INSERT INTO public.who_global_data VALUES (34067, 5529, 1073849, 150, 18785, 144, 170);
INSERT INTO public.who_global_data VALUES (34068, 11, 4602, 0, 22, 144, 191);
INSERT INTO public.who_global_data VALUES (34069, 0, 5, 0, 0, 144, 221);
INSERT INTO public.who_global_data VALUES (34070, 0, 21, 0, 0, 144, 64);
INSERT INTO public.who_global_data VALUES (34071, 0, 0, 0, 0, 144, 116);
INSERT INTO public.who_global_data VALUES (34072, 0, 17, 0, 0, 144, 128);
INSERT INTO public.who_global_data VALUES (34073, 0, 27, 0, 0, 144, 6);
INSERT INTO public.who_global_data VALUES (34074, 0, 256, 0, 6, 144, 227);
INSERT INTO public.who_global_data VALUES (34075, 0, 11, 0, 0, 144, 68);
INSERT INTO public.who_global_data VALUES (34076, 0, 64, 0, 0, 144, 184);
INSERT INTO public.who_global_data VALUES (34077, 0, 0, 0, 0, 144, 82);
INSERT INTO public.who_global_data VALUES (34078, 0, 741, 0, 42, 144, 149);
INSERT INTO public.who_global_data VALUES (34079, 0, 906, 0, 15, 144, 197);
INSERT INTO public.who_global_data VALUES (34080, 607, 326258, 37, 4305, 144, 78);
INSERT INTO public.who_global_data VALUES (34081, 113, 14306, 4, 297, 144, 233);
INSERT INTO public.who_global_data VALUES (34082, 29, 32437, 0, 733, 144, 133);
INSERT INTO public.who_global_data VALUES (34083, 0, 135, 0, 0, 144, 35);
INSERT INTO public.who_global_data VALUES (34084, 2, 2111, 0, 72, 144, 114);
INSERT INTO public.who_global_data VALUES (34085, 48, 57454, 0, 27, 144, 237);
INSERT INTO public.who_global_data VALUES (34086, 0, 11, 0, 0, 144, 55);
INSERT INTO public.who_global_data VALUES (34087, 19, 549, 0, 19, 144, 176);
INSERT INTO public.who_global_data VALUES (34088, 48, 5580, 0, 38, 144, 202);
INSERT INTO public.who_global_data VALUES (34089, 83, 3833, 0, 137, 144, 155);
INSERT INTO public.who_global_data VALUES (34090, 0, 0, 0, 0, 144, 32);
INSERT INTO public.who_global_data VALUES (34091, 0, 3389, 0, 98, 144, 220);
INSERT INTO public.who_global_data VALUES (34092, 956, 650749, 52, 15499, 144, 30);
INSERT INTO public.who_global_data VALUES (34093, 5, 2592, 0, 49, 144, 147);
INSERT INTO public.who_global_data VALUES (34094, 6524, 638402, 101, 32014, 144, 208);
INSERT INTO public.who_global_data VALUES (34095, 28, 3262, 0, 12, 144, 45);
INSERT INTO public.who_global_data VALUES (34096, 3, 13535, 0, 836, 144, 110);
INSERT INTO public.who_global_data VALUES (34097, 3, 4582, 0, 93, 144, 88);
INSERT INTO public.who_global_data VALUES (34098, 106, 87159, 2, 5853, 144, 51);
INSERT INTO public.who_global_data VALUES (34099, 504, 48066, 0, 1789, 144, 209);
INSERT INTO public.who_global_data VALUES (34100, 36, 3576, 2, 157, 144, 205);
INSERT INTO public.who_global_data VALUES (34101, 39, 9088, 0, 72, 144, 18);
INSERT INTO public.who_global_data VALUES (34102, 5, 3480, 0, 58, 144, 72);
INSERT INTO public.who_global_data VALUES (34103, 2621, 371129, 9, 41637, 144, 44);
INSERT INTO public.who_global_data VALUES (34104, 0, 27, 0, 0, 144, 15);
INSERT INTO public.who_global_data VALUES (34105, 6, 1578, 3, 40, 144, 25);
INSERT INTO public.who_global_data VALUES (34106, 0, 0, 0, 0, 144, 179);
INSERT INTO public.who_global_data VALUES (34107, 0, 0, 0, 0, 144, 34);
INSERT INTO public.who_global_data VALUES (34108, 72, 3091, 1, 54, 144, 207);
INSERT INTO public.who_global_data VALUES (34109, 477, 8100, 6, 129, 144, 166);
INSERT INTO public.who_global_data VALUES (34110, 8446, 622648, 63, 7119, 144, 126);
INSERT INTO public.who_global_data VALUES (34111, 0, 0, 0, 0, 144, 97);
INSERT INTO public.who_global_data VALUES (34112, 2, 646, 0, 5, 144, 36);
INSERT INTO public.who_global_data VALUES (34113, 0, 0, 0, 0, 144, 125);
INSERT INTO public.who_global_data VALUES (34114, 179, 4978, 1, 56, 144, 124);
INSERT INTO public.who_global_data VALUES (34115, 2905, 159702, 53, 3264, 144, 185);
INSERT INTO public.who_global_data VALUES (34116, 777, 80266, 0, 399, 144, 194);
INSERT INTO public.who_global_data VALUES (34117, 0, 509, 0, 21, 144, 144);
INSERT INTO public.who_global_data VALUES (34118, 35177, 6462135, 507, 193119, 144, 19);
INSERT INTO public.who_global_data VALUES (34119, 1, 1221, 0, 19, 144, 217);
INSERT INTO public.who_global_data VALUES (34120, 28, 1808, 0, 45, 144, 148);
INSERT INTO public.who_global_data VALUES (34121, 572, 48192, 6, 400, 144, 86);
INSERT INTO public.who_global_data VALUES (34122, 0, 0, 0, 0, 144, 13);
INSERT INTO public.who_global_data VALUES (34123, 1939, 61569, 17, 494, 144, 157);
INSERT INTO public.who_global_data VALUES (34124, 0, 1063, 0, 35, 144, 8);
INSERT INTO public.who_global_data VALUES (34125, 0, 0, 0, 0, 144, 73);
INSERT INTO public.who_global_data VALUES (34126, 2, 2017, 0, 584, 144, 101);
INSERT INTO public.who_global_data VALUES (34127, 181, 13720, 8, 320, 144, 165);
INSERT INTO public.who_global_data VALUES (34128, 5, 7531, 0, 224, 144, 14);
INSERT INTO public.who_global_data VALUES (34129, 56, 38858, 5, 1429, 145, 193);
INSERT INTO public.who_global_data VALUES (34130, 168, 11353, 4, 334, 145, 113);
INSERT INTO public.who_global_data VALUES (34131, 0, 48007, 0, 1605, 145, 143);
INSERT INTO public.who_global_data VALUES (34132, 0, 0, 0, 0, 145, 219);
INSERT INTO public.who_global_data VALUES (34133, 0, 1344, 0, 53, 145, 186);
INSERT INTO public.who_global_data VALUES (34134, 53, 3388, 2, 134, 145, 52);
INSERT INTO public.who_global_data VALUES (34135, 0, 3, 0, 0, 145, 180);
INSERT INTO public.who_global_data VALUES (34136, 0, 95, 0, 3, 145, 167);
INSERT INTO public.who_global_data VALUES (34137, 10776, 546481, 101, 11307, 145, 154);
INSERT INTO public.who_global_data VALUES (34138, 107, 45282, 3, 914, 145, 94);
INSERT INTO public.who_global_data VALUES (34139, 0, 2819, 0, 16, 145, 66);
INSERT INTO public.who_global_data VALUES (34140, 44, 26651, 7, 810, 145, 58);
INSERT INTO public.who_global_data VALUES (34141, 384, 33335, 2, 756, 145, 163);
INSERT INTO public.who_global_data VALUES (34142, 155, 38327, 3, 562, 145, 37);
INSERT INTO public.who_global_data VALUES (34143, 54, 2928, 0, 67, 145, 142);
INSERT INTO public.who_global_data VALUES (34144, 721, 60307, 1, 213, 145, 83);
INSERT INTO public.who_global_data VALUES (34145, 1476, 337520, 31, 4733, 145, 228);
INSERT INTO public.who_global_data VALUES (34146, 1, 181, 0, 7, 145, 188);
INSERT INTO public.who_global_data VALUES (34147, 198, 74173, 6, 750, 145, 62);
INSERT INTO public.who_global_data VALUES (34148, 301, 95309, 1, 9920, 145, 160);
INSERT INTO public.who_global_data VALUES (34149, 23, 1458, 0, 19, 145, 50);
INSERT INTO public.who_global_data VALUES (34150, 25, 2267, 0, 40, 145, 33);
INSERT INTO public.who_global_data VALUES (34151, 0, 177, 0, 9, 145, 183);
INSERT INTO public.who_global_data VALUES (34152, 1, 245, 0, 0, 145, 92);
INSERT INTO public.who_global_data VALUES (34153, 810, 125982, 47, 7297, 145, 158);
INSERT INTO public.who_global_data VALUES (34154, 1, 11, 1, 1, 145, 67);
INSERT INTO public.who_global_data VALUES (34155, 328, 23462, 6, 689, 145, 57);
INSERT INTO public.who_global_data VALUES (34156, 0, 2252, 0, 10, 145, 38);
INSERT INTO public.who_global_data VALUES (34157, 33523, 4315687, 814, 131210, 145, 141);
INSERT INTO public.who_global_data VALUES (34158, 0, 66, 0, 1, 145, 178);
INSERT INTO public.who_global_data VALUES (34159, 0, 145, 0, 3, 145, 108);
INSERT INTO public.who_global_data VALUES (34160, 27, 17918, 3, 720, 145, 39);
INSERT INTO public.who_global_data VALUES (34161, 0, 1499, 0, 56, 145, 2);
INSERT INTO public.who_global_data VALUES (34162, 0, 472, 0, 1, 145, 195);
INSERT INTO public.who_global_data VALUES (34163, 102, 4813, 0, 44, 145, 107);
INSERT INTO public.who_global_data VALUES (34164, 0, 275, 0, 0, 145, 161);
INSERT INTO public.who_global_data VALUES (34165, 61, 20228, 0, 415, 145, 212);
INSERT INTO public.who_global_data VALUES (34166, 515, 136141, 7, 9170, 145, 181);
INSERT INTO public.who_global_data VALUES (34167, 0, 208, 0, 1, 145, 53);
INSERT INTO public.who_global_data VALUES (34168, 0, 4749, 0, 62, 145, 164);
INSERT INTO public.who_global_data VALUES (34169, 1, 1084, 0, 80, 145, 140);
INSERT INTO public.who_global_data VALUES (34170, 2082, 434748, 54, 11949, 145, 20);
INSERT INTO public.who_global_data VALUES (34171, 29, 90695, 0, 4741, 145, 112);
INSERT INTO public.who_global_data VALUES (34172, 6876, 708964, 216, 22734, 145, 111);
INSERT INTO public.who_global_data VALUES (34173, 0, 456, 0, 7, 145, 71);
INSERT INTO public.who_global_data VALUES (34174, 0, 4934, 0, 88, 145, 218);
INSERT INTO public.who_global_data VALUES (34175, 0, 0, 0, 0, 145, 43);
INSERT INTO public.who_global_data VALUES (34176, 1485, 55454, 7, 590, 145, 49);
INSERT INTO public.who_global_data VALUES (34177, 0, 18987, 0, 120, 145, 1);
INSERT INTO public.who_global_data VALUES (34178, 165, 13533, 6, 224, 145, 48);
INSERT INTO public.who_global_data VALUES (34179, 31, 4684, 0, 108, 145, 232);
INSERT INTO public.who_global_data VALUES (34180, 0, 135, 0, 1, 145, 175);
INSERT INTO public.who_global_data VALUES (34181, 3, 1526, 0, 21, 145, 21);
INSERT INTO public.who_global_data VALUES (34182, 787, 36188, 3, 456, 145, 156);
INSERT INTO public.who_global_data VALUES (34183, 0, 0, 0, 0, 145, 95);
INSERT INTO public.who_global_data VALUES (34184, 5, 10389, 2, 264, 145, 177);
INSERT INTO public.who_global_data VALUES (34185, 0, 19216, 0, 629, 145, 210);
INSERT INTO public.who_global_data VALUES (34186, 1, 5395, 0, 61, 145, 120);
INSERT INTO public.who_global_data VALUES (34187, 0, 24, 0, 0, 145, 135);
INSERT INTO public.who_global_data VALUES (34188, 1428, 103660, 27, 1968, 145, 206);
INSERT INTO public.who_global_data VALUES (34189, 3862, 118594, 67, 10903, 145, 189);
INSERT INTO public.who_global_data VALUES (34190, 153, 101009, 21, 5648, 145, 129);
INSERT INTO public.who_global_data VALUES (34191, 77, 26928, 3, 785, 145, 121);
INSERT INTO public.who_global_data VALUES (34192, 0, 4996, 0, 83, 145, 59);
INSERT INTO public.who_global_data VALUES (34193, 0, 361, 0, 0, 145, 96);
INSERT INTO public.who_global_data VALUES (34194, 21, 2676, 0, 64, 145, 41);
INSERT INTO public.who_global_data VALUES (34195, 25, 5075, 0, 98, 145, 216);
INSERT INTO public.who_global_data VALUES (34196, 413, 64301, 17, 1013, 145, 236);
INSERT INTO public.who_global_data VALUES (34197, 0, 13, 0, 0, 145, 150);
INSERT INTO public.who_global_data VALUES (34198, 5, 423, 0, 0, 145, 61);
INSERT INTO public.who_global_data VALUES (34199, 0, 32, 0, 2, 145, 7);
INSERT INTO public.who_global_data VALUES (34200, 23, 8580, 0, 337, 145, 169);
INSERT INTO public.who_global_data VALUES (34201, 7101, 361087, 6, 30755, 145, 28);
INSERT INTO public.who_global_data VALUES (34202, 0, 9521, 0, 63, 145, 85);
INSERT INTO public.who_global_data VALUES (34203, 35, 1055, 0, 2, 145, 211);
INSERT INTO public.who_global_data VALUES (34204, 0, 8643, 0, 53, 145, 60);
INSERT INTO public.who_global_data VALUES (34205, 29, 3405, 1, 103, 145, 3);
INSERT INTO public.who_global_data VALUES (34206, 165, 2392, 0, 19, 145, 11);
INSERT INTO public.who_global_data VALUES (34207, 927, 260355, 1, 9350, 145, 89);
INSERT INTO public.who_global_data VALUES (34208, 0, 45434, 0, 286, 145, 24);
INSERT INTO public.who_global_data VALUES (34209, 4, 327, 0, 0, 145, 162);
INSERT INTO public.who_global_data VALUES (34210, 204, 13240, 3, 305, 145, 100);
INSERT INTO public.who_global_data VALUES (34211, 0, 14, 0, 0, 145, 47);
INSERT INTO public.who_global_data VALUES (34212, 0, 24, 0, 0, 145, 29);
INSERT INTO public.who_global_data VALUES (34213, 0, 3080, 0, 24, 145, 40);
INSERT INTO public.who_global_data VALUES (34214, 0, 1891, 1, 26, 145, 222);
INSERT INTO public.who_global_data VALUES (34215, 251, 81909, 8, 2957, 145, 132);
INSERT INTO public.who_global_data VALUES (34216, 0, 253, 0, 13, 145, 130);
INSERT INTO public.who_global_data VALUES (34217, 25, 10045, 0, 63, 145, 234);
INSERT INTO public.who_global_data VALUES (34218, 0, 2275, 0, 39, 145, 23);
INSERT INTO public.who_global_data VALUES (34219, 49, 1812, 2, 54, 145, 192);
INSERT INTO public.who_global_data VALUES (34220, 21, 8478, 3, 219, 145, 69);
INSERT INTO public.who_global_data VALUES (34221, 0, 12, 0, 0, 145, 187);
INSERT INTO public.who_global_data VALUES (34222, 1087, 67136, 7, 2065, 145, 230);
INSERT INTO public.who_global_data VALUES (34223, 484, 12309, 4, 637, 145, 77);
INSERT INTO public.who_global_data VALUES (34224, 3, 2165, 0, 10, 145, 9);
INSERT INTO public.who_global_data VALUES (34225, 92071, 4846427, 1136, 79722, 145, 74);
INSERT INTO public.who_global_data VALUES (34226, 3636, 218382, 73, 8723, 145, 224);
INSERT INTO public.who_global_data VALUES (34227, 2089, 402029, 128, 23157, 145, 199);
INSERT INTO public.who_global_data VALUES (34228, 3531, 290309, 73, 8014, 145, 190);
INSERT INTO public.who_global_data VALUES (34229, 255, 30985, 1, 1784, 145, 12);
INSERT INTO public.who_global_data VALUES (34230, 0, 337, 0, 24, 145, 104);
INSERT INTO public.who_global_data VALUES (34231, 2718, 153052, 15, 1139, 145, 153);
INSERT INTO public.who_global_data VALUES (34232, 1456, 287753, 7, 35610, 145, 91);
INSERT INTO public.who_global_data VALUES (34233, 260, 3771, 2, 42, 145, 215);
INSERT INTO public.who_global_data VALUES (34234, 439, 75657, 3, 1442, 145, 84);
INSERT INTO public.who_global_data VALUES (34235, 0, 380, 0, 32, 145, 231);
INSERT INTO public.who_global_data VALUES (34236, 252, 3382, 2, 24, 145, 196);
INSERT INTO public.who_global_data VALUES (34237, 73, 136586, 0, 1999, 145, 105);
INSERT INTO public.who_global_data VALUES (34238, 194, 36157, 3, 622, 145, 122);
INSERT INTO public.who_global_data VALUES (34239, 0, 0, 0, 0, 145, 159);
INSERT INTO public.who_global_data VALUES (34240, 71, 14594, 7, 586, 145, 75);
INSERT INTO public.who_global_data VALUES (34241, 553, 94764, 2, 560, 145, 27);
INSERT INTO public.who_global_data VALUES (34242, 47, 44928, 0, 1063, 145, 54);
INSERT INTO public.who_global_data VALUES (34243, 0, 23, 0, 0, 145, 226);
INSERT INTO public.who_global_data VALUES (34244, 10, 1474, 0, 35, 145, 79);
INSERT INTO public.who_global_data VALUES (34245, 641, 24310, 2, 241, 145, 56);
INSERT INTO public.who_global_data VALUES (34246, 0, 1245, 0, 33, 145, 117);
INSERT INTO public.who_global_data VALUES (34247, 0, 1311, 0, 82, 145, 152);
INSERT INTO public.who_global_data VALUES (34248, 734, 23515, 6, 368, 145, 16);
INSERT INTO public.who_global_data VALUES (34249, 0, 111, 0, 1, 145, 10);
INSERT INTO public.who_global_data VALUES (34250, 51, 3381, 0, 87, 145, 201);
INSERT INTO public.who_global_data VALUES (34251, 35, 7194, 0, 124, 145, 174);
INSERT INTO public.who_global_data VALUES (34252, 20, 15757, 1, 211, 145, 119);
INSERT INTO public.who_global_data VALUES (34253, 21, 5690, 0, 177, 145, 168);
INSERT INTO public.who_global_data VALUES (34254, 47, 9915, 0, 128, 145, 99);
INSERT INTO public.who_global_data VALUES (34255, 121, 9173, 1, 32, 145, 171);
INSERT INTO public.who_global_data VALUES (34256, 8, 2924, 0, 128, 145, 87);
INSERT INTO public.who_global_data VALUES (34257, 53, 2406, 0, 15, 145, 123);
INSERT INTO public.who_global_data VALUES (34258, 0, 0, 0, 0, 145, 151);
INSERT INTO public.who_global_data VALUES (34259, 0, 939, 0, 18, 145, 213);
INSERT INTO public.who_global_data VALUES (34260, 2, 7276, 0, 161, 145, 118);
INSERT INTO public.who_global_data VALUES (34261, 0, 361, 0, 10, 145, 134);
INSERT INTO public.who_global_data VALUES (34262, 0, 3374, 0, 40, 145, 65);
INSERT INTO public.who_global_data VALUES (34263, 5674, 663973, 421, 70604, 145, 102);
INSERT INTO public.who_global_data VALUES (34264, 0, 0, 0, 0, 145, 223);
INSERT INTO public.who_global_data VALUES (34265, 2, 174, 0, 1, 145, 4);
INSERT INTO public.who_global_data VALUES (34266, 0, 311, 0, 0, 145, 146);
INSERT INTO public.who_global_data VALUES (34267, 334, 7507, 1, 121, 145, 31);
INSERT INTO public.who_global_data VALUES (34268, 0, 13, 0, 1, 145, 127);
INSERT INTO public.who_global_data VALUES (34269, 2251, 86686, 25, 1578, 145, 22);
INSERT INTO public.who_global_data VALUES (34270, 229, 5269, 0, 35, 145, 115);
INSERT INTO public.who_global_data VALUES (34271, 219, 3015, 8, 24, 145, 106);
INSERT INTO public.who_global_data VALUES (34272, 115, 9719, 3, 101, 145, 90);
INSERT INTO public.who_global_data VALUES (34273, 0, 0, 0, 0, 145, 70);
INSERT INTO public.who_global_data VALUES (34274, 1039, 54159, 9, 345, 145, 46);
INSERT INTO public.who_global_data VALUES (34275, 1088, 82007, 1, 6253, 145, 139);
INSERT INTO public.who_global_data VALUES (34276, 0, 26, 0, 0, 145, 42);
INSERT INTO public.who_global_data VALUES (34277, 1, 1447, 0, 24, 145, 80);
INSERT INTO public.who_global_data VALUES (34278, 0, 3877, 0, 144, 145, 203);
INSERT INTO public.who_global_data VALUES (34279, 0, 1178, 0, 69, 145, 136);
INSERT INTO public.who_global_data VALUES (34280, 79, 56256, 4, 1082, 145, 63);
INSERT INTO public.who_global_data VALUES (34281, 0, 0, 0, 0, 145, 17);
INSERT INTO public.who_global_data VALUES (34282, 0, 60, 0, 2, 145, 172);
INSERT INTO public.who_global_data VALUES (34283, 97, 15791, 2, 648, 145, 109);
INSERT INTO public.who_global_data VALUES (34284, 0, 11866, 0, 265, 145, 200);
INSERT INTO public.who_global_data VALUES (34285, 994, 39510, 12, 250, 145, 93);
INSERT INTO public.who_global_data VALUES (34286, 1409, 89746, 18, 780, 145, 5);
INSERT INTO public.who_global_data VALUES (34287, 0, 741, 0, 13, 145, 214);
INSERT INTO public.who_global_data VALUES (34288, 539, 302020, 4, 6383, 145, 204);
INSERT INTO public.who_global_data VALUES (34289, 0, 0, 0, 0, 145, 198);
INSERT INTO public.who_global_data VALUES (34290, 711, 101041, 15, 2155, 145, 173);
INSERT INTO public.who_global_data VALUES (34291, 3, 511, 1, 6, 145, 229);
INSERT INTO public.who_global_data VALUES (34292, 812, 27324, 18, 514, 145, 76);
INSERT INTO public.who_global_data VALUES (34293, 6162, 722832, 123, 30593, 145, 138);
INSERT INTO public.who_global_data VALUES (34294, 3353, 261216, 79, 4371, 145, 98);
INSERT INTO public.who_global_data VALUES (34295, 0, 0, 0, 0, 145, 103);
INSERT INTO public.who_global_data VALUES (34296, 502, 74152, 6, 2188, 145, 225);
INSERT INTO public.who_global_data VALUES (34297, 673, 63983, 7, 1867, 145, 131);
INSERT INTO public.who_global_data VALUES (34298, 288, 37380, 4, 539, 145, 235);
INSERT INTO public.who_global_data VALUES (34299, 217, 121740, 0, 205, 145, 137);
INSERT INTO public.who_global_data VALUES (34300, 109, 22285, 5, 363, 145, 81);
INSERT INTO public.who_global_data VALUES (34301, 264, 42978, 5, 1123, 145, 182);
INSERT INTO public.who_global_data VALUES (34302, 82, 2805, 0, 10, 145, 145);
INSERT INTO public.who_global_data VALUES (34303, 1109, 103495, 36, 4163, 145, 26);
INSERT INTO public.who_global_data VALUES (34304, 5509, 1068320, 57, 18635, 145, 170);
INSERT INTO public.who_global_data VALUES (34305, 26, 4591, 0, 22, 145, 191);
INSERT INTO public.who_global_data VALUES (34306, 0, 5, 0, 0, 145, 221);
INSERT INTO public.who_global_data VALUES (34307, 0, 21, 0, 0, 145, 64);
INSERT INTO public.who_global_data VALUES (34308, 0, 0, 0, 0, 145, 116);
INSERT INTO public.who_global_data VALUES (34309, 0, 17, 0, 0, 145, 128);
INSERT INTO public.who_global_data VALUES (34310, 0, 27, 0, 0, 145, 6);
INSERT INTO public.who_global_data VALUES (34311, 0, 256, 0, 6, 145, 227);
INSERT INTO public.who_global_data VALUES (34312, 0, 11, 0, 0, 145, 68);
INSERT INTO public.who_global_data VALUES (34313, 0, 64, 0, 0, 145, 184);
INSERT INTO public.who_global_data VALUES (34314, 0, 0, 0, 0, 145, 82);
INSERT INTO public.who_global_data VALUES (34315, 0, 741, 0, 42, 145, 149);
INSERT INTO public.who_global_data VALUES (34316, 0, 906, 0, 15, 145, 197);
INSERT INTO public.who_global_data VALUES (34317, 601, 325651, 28, 4268, 145, 78);
INSERT INTO public.who_global_data VALUES (34318, 0, 14193, 0, 293, 145, 233);
INSERT INTO public.who_global_data VALUES (34319, 108, 32408, 2, 733, 145, 133);
INSERT INTO public.who_global_data VALUES (34320, 0, 135, 0, 0, 145, 35);
INSERT INTO public.who_global_data VALUES (34321, 13, 2109, 0, 72, 145, 114);
INSERT INTO public.who_global_data VALUES (34322, 49, 57406, 0, 27, 145, 237);
INSERT INTO public.who_global_data VALUES (34323, 1, 11, 0, 0, 145, 55);
INSERT INTO public.who_global_data VALUES (34324, 0, 530, 0, 19, 145, 176);
INSERT INTO public.who_global_data VALUES (34325, 79, 5532, 0, 38, 145, 202);
INSERT INTO public.who_global_data VALUES (34326, 47, 3750, 0, 137, 145, 155);
INSERT INTO public.who_global_data VALUES (34327, 0, 0, 0, 0, 145, 32);
INSERT INTO public.who_global_data VALUES (34328, 13, 3389, 0, 98, 145, 220);
INSERT INTO public.who_global_data VALUES (34329, 1579, 649793, 20, 15447, 145, 30);
INSERT INTO public.who_global_data VALUES (34330, 9, 2587, 0, 49, 145, 147);
INSERT INTO public.who_global_data VALUES (34331, 8401, 631878, 98, 31913, 145, 208);
INSERT INTO public.who_global_data VALUES (34332, 30, 3234, 0, 12, 145, 45);
INSERT INTO public.who_global_data VALUES (34333, 0, 13532, 0, 836, 145, 110);
INSERT INTO public.who_global_data VALUES (34334, 50, 4579, 0, 93, 145, 88);
INSERT INTO public.who_global_data VALUES (34335, 206, 87053, 1, 5851, 145, 51);
INSERT INTO public.who_global_data VALUES (34336, 238, 47562, 1, 1789, 145, 209);
INSERT INTO public.who_global_data VALUES (34337, 34, 3540, 3, 155, 145, 205);
INSERT INTO public.who_global_data VALUES (34338, 35, 9049, 0, 72, 145, 18);
INSERT INTO public.who_global_data VALUES (34339, 2, 3475, 0, 58, 145, 72);
INSERT INTO public.who_global_data VALUES (34340, 3330, 368508, 5, 41628, 145, 44);
INSERT INTO public.who_global_data VALUES (34341, 0, 27, 0, 0, 145, 15);
INSERT INTO public.who_global_data VALUES (34342, 17, 1572, 0, 37, 145, 25);
INSERT INTO public.who_global_data VALUES (34343, 0, 0, 0, 0, 145, 179);
INSERT INTO public.who_global_data VALUES (34344, 0, 0, 0, 0, 145, 34);
INSERT INTO public.who_global_data VALUES (34345, 127, 3019, 3, 53, 145, 207);
INSERT INTO public.who_global_data VALUES (34346, 241, 7623, 6, 123, 145, 166);
INSERT INTO public.who_global_data VALUES (34347, 8257, 614202, 57, 7056, 145, 126);
INSERT INTO public.who_global_data VALUES (34348, 0, 0, 0, 0, 145, 97);
INSERT INTO public.who_global_data VALUES (34349, 3, 644, 0, 5, 145, 36);
INSERT INTO public.who_global_data VALUES (34350, 0, 0, 0, 0, 145, 125);
INSERT INTO public.who_global_data VALUES (34351, 96, 4799, 3, 55, 145, 124);
INSERT INTO public.who_global_data VALUES (34352, 2462, 156797, 33, 3211, 145, 185);
INSERT INTO public.who_global_data VALUES (34353, 640, 79489, 0, 399, 145, 194);
INSERT INTO public.who_global_data VALUES (34354, 0, 509, 0, 21, 145, 144);
INSERT INTO public.who_global_data VALUES (34355, 40126, 6426958, 803, 192612, 145, 19);
INSERT INTO public.who_global_data VALUES (34356, 9, 1220, 0, 19, 145, 217);
INSERT INTO public.who_global_data VALUES (34357, 7, 1780, 0, 45, 145, 148);
INSERT INTO public.who_global_data VALUES (34358, 578, 47620, 6, 394, 145, 86);
INSERT INTO public.who_global_data VALUES (34359, 0, 0, 0, 0, 145, 13);
INSERT INTO public.who_global_data VALUES (34360, 967, 59630, 9, 477, 145, 157);
INSERT INTO public.who_global_data VALUES (34361, 3, 1063, 0, 35, 145, 8);
INSERT INTO public.who_global_data VALUES (34362, 0, 0, 0, 0, 145, 73);
INSERT INTO public.who_global_data VALUES (34363, 2, 2015, 1, 584, 145, 101);
INSERT INTO public.who_global_data VALUES (34364, 73, 13539, 0, 312, 145, 165);
INSERT INTO public.who_global_data VALUES (34365, 18, 7526, 0, 224, 145, 14);
INSERT INTO public.who_global_data VALUES (34366, 75, 38802, 0, 1424, 146, 193);
INSERT INTO public.who_global_data VALUES (34367, 164, 11185, 3, 330, 146, 113);
INSERT INTO public.who_global_data VALUES (34368, 255, 48007, 6, 1605, 146, 143);
INSERT INTO public.who_global_data VALUES (34369, 0, 0, 0, 0, 146, 219);
INSERT INTO public.who_global_data VALUES (34370, 0, 1344, 0, 53, 146, 186);
INSERT INTO public.who_global_data VALUES (34371, 56, 3335, 1, 132, 146, 52);
INSERT INTO public.who_global_data VALUES (34372, 0, 3, 0, 0, 146, 180);
INSERT INTO public.who_global_data VALUES (34373, 0, 95, 0, 3, 146, 167);
INSERT INTO public.who_global_data VALUES (34374, 11507, 535705, 212, 11206, 146, 154);
INSERT INTO public.who_global_data VALUES (34375, 187, 45175, 5, 911, 146, 94);
INSERT INTO public.who_global_data VALUES (34376, 0, 2819, 0, 16, 146, 66);
INSERT INTO public.who_global_data VALUES (34377, 42, 26607, 6, 803, 146, 58);
INSERT INTO public.who_global_data VALUES (34378, 495, 32951, 4, 754, 146, 163);
INSERT INTO public.who_global_data VALUES (34379, 135, 38172, 2, 559, 146, 37);
INSERT INTO public.who_global_data VALUES (34380, 60, 2874, 2, 67, 146, 142);
INSERT INTO public.who_global_data VALUES (34381, 747, 59586, 4, 212, 146, 83);
INSERT INTO public.who_global_data VALUES (34382, 1282, 336044, 34, 4702, 146, 228);
INSERT INTO public.who_global_data VALUES (34383, 0, 180, 0, 7, 146, 188);
INSERT INTO public.who_global_data VALUES (34384, 191, 73975, 6, 744, 146, 62);
INSERT INTO public.who_global_data VALUES (34385, 617, 95008, 1, 9919, 146, 160);
INSERT INTO public.who_global_data VALUES (34386, 36, 1435, 0, 19, 146, 50);
INSERT INTO public.who_global_data VALUES (34387, 0, 2242, 0, 40, 146, 33);
INSERT INTO public.who_global_data VALUES (34388, 0, 177, 0, 9, 146, 183);
INSERT INTO public.who_global_data VALUES (34389, 3, 244, 0, 0, 146, 92);
INSERT INTO public.who_global_data VALUES (34390, 967, 125172, 57, 7250, 146, 158);
INSERT INTO public.who_global_data VALUES (34391, 0, 10, 0, 0, 146, 67);
INSERT INTO public.who_global_data VALUES (34392, 305, 23134, 4, 683, 146, 57);
INSERT INTO public.who_global_data VALUES (34393, 126, 2252, 1, 10, 146, 38);
INSERT INTO public.who_global_data VALUES (34394, 43718, 4282164, 874, 130396, 146, 141);
INSERT INTO public.who_global_data VALUES (34395, 2, 66, 0, 1, 146, 178);
INSERT INTO public.who_global_data VALUES (34396, 0, 145, 0, 3, 146, 108);
INSERT INTO public.who_global_data VALUES (34397, 92, 17891, 4, 717, 146, 39);
INSERT INTO public.who_global_data VALUES (34398, 13, 1499, 0, 56, 146, 2);
INSERT INTO public.who_global_data VALUES (34399, 1, 472, 0, 1, 146, 195);
INSERT INTO public.who_global_data VALUES (34400, 60, 4711, 0, 44, 146, 107);
INSERT INTO public.who_global_data VALUES (34401, 1, 275, 0, 0, 146, 161);
INSERT INTO public.who_global_data VALUES (34402, 158, 20167, 0, 415, 146, 212);
INSERT INTO public.who_global_data VALUES (34403, 702, 135626, 0, 9163, 146, 181);
INSERT INTO public.who_global_data VALUES (34404, 0, 208, 0, 1, 146, 53);
INSERT INTO public.who_global_data VALUES (34405, 0, 4749, 0, 62, 146, 164);
INSERT INTO public.who_global_data VALUES (34406, 2, 1083, 1, 80, 146, 140);
INSERT INTO public.who_global_data VALUES (34407, 2131, 432666, 45, 11895, 146, 20);
INSERT INTO public.who_global_data VALUES (34408, 23, 90666, 1, 4741, 146, 112);
INSERT INTO public.who_global_data VALUES (34409, 7424, 702088, 243, 22518, 146, 111);
INSERT INTO public.who_global_data VALUES (34410, 0, 456, 0, 7, 146, 71);
INSERT INTO public.who_global_data VALUES (34411, 21, 4934, 0, 88, 146, 218);
INSERT INTO public.who_global_data VALUES (34412, 0, 0, 0, 0, 146, 43);
INSERT INTO public.who_global_data VALUES (34413, 1420, 53969, 16, 583, 146, 49);
INSERT INTO public.who_global_data VALUES (34414, 118, 18987, 1, 120, 146, 1);
INSERT INTO public.who_global_data VALUES (34415, 261, 13368, 7, 218, 146, 48);
INSERT INTO public.who_global_data VALUES (34416, 60, 4653, 2, 108, 146, 232);
INSERT INTO public.who_global_data VALUES (34417, 0, 135, 0, 1, 146, 175);
INSERT INTO public.who_global_data VALUES (34418, 3, 1523, 0, 21, 146, 21);
INSERT INTO public.who_global_data VALUES (34419, 1541, 35401, 3, 453, 146, 156);
INSERT INTO public.who_global_data VALUES (34420, 0, 0, 0, 0, 146, 95);
INSERT INTO public.who_global_data VALUES (34421, 24, 10384, 0, 262, 146, 177);
INSERT INTO public.who_global_data VALUES (34422, 0, 19216, 0, 629, 146, 210);
INSERT INTO public.who_global_data VALUES (34423, 0, 5394, 0, 61, 146, 120);
INSERT INTO public.who_global_data VALUES (34424, 0, 24, 0, 0, 146, 135);
INSERT INTO public.who_global_data VALUES (34425, 0, 102232, 0, 1941, 146, 206);
INSERT INTO public.who_global_data VALUES (34426, 1526, 114732, 87, 10836, 146, 189);
INSERT INTO public.who_global_data VALUES (34427, 148, 100856, 20, 5627, 146, 129);
INSERT INTO public.who_global_data VALUES (34428, 78, 26851, 5, 782, 146, 121);
INSERT INTO public.who_global_data VALUES (34429, 0, 4996, 0, 83, 146, 59);
INSERT INTO public.who_global_data VALUES (34430, 0, 361, 0, 0, 146, 96);
INSERT INTO public.who_global_data VALUES (34431, 23, 2655, 0, 64, 146, 41);
INSERT INTO public.who_global_data VALUES (34432, 25, 5050, 0, 98, 146, 216);
INSERT INTO public.who_global_data VALUES (34433, 521, 63888, 10, 996, 146, 236);
INSERT INTO public.who_global_data VALUES (34434, 0, 13, 0, 0, 146, 150);
INSERT INTO public.who_global_data VALUES (34435, 2, 418, 0, 0, 146, 61);
INSERT INTO public.who_global_data VALUES (34436, 0, 32, 0, 2, 146, 7);
INSERT INTO public.who_global_data VALUES (34437, 45, 8557, 0, 337, 146, 169);
INSERT INTO public.who_global_data VALUES (34438, 9641, 353986, 15, 30749, 146, 28);
INSERT INTO public.who_global_data VALUES (34439, 27, 9521, 0, 63, 146, 85);
INSERT INTO public.who_global_data VALUES (34440, 67, 1020, 0, 2, 146, 211);
INSERT INTO public.who_global_data VALUES (34441, 0, 8643, 0, 53, 146, 60);
INSERT INTO public.who_global_data VALUES (34442, 14, 3376, 2, 102, 146, 3);
INSERT INTO public.who_global_data VALUES (34443, 152, 2227, 0, 19, 146, 11);
INSERT INTO public.who_global_data VALUES (34444, 948, 259428, 2, 9349, 146, 89);
INSERT INTO public.who_global_data VALUES (34445, 46, 45434, 1, 286, 146, 24);
INSERT INTO public.who_global_data VALUES (34446, 0, 323, 0, 0, 146, 162);
INSERT INTO public.who_global_data VALUES (34447, 302, 13036, 2, 302, 146, 100);
INSERT INTO public.who_global_data VALUES (34448, 0, 14, 0, 0, 146, 47);
INSERT INTO public.who_global_data VALUES (34449, 0, 24, 0, 0, 146, 29);
INSERT INTO public.who_global_data VALUES (34450, 793, 3080, 1, 24, 146, 40);
INSERT INTO public.who_global_data VALUES (34451, 28, 1891, 2, 25, 146, 222);
INSERT INTO public.who_global_data VALUES (34452, 649, 81658, 20, 2949, 146, 132);
INSERT INTO public.who_global_data VALUES (34453, 0, 253, 0, 13, 146, 130);
INSERT INTO public.who_global_data VALUES (34454, 41, 10020, 0, 63, 146, 234);
INSERT INTO public.who_global_data VALUES (34455, 0, 2275, 0, 39, 146, 23);
INSERT INTO public.who_global_data VALUES (34456, 13, 1763, 3, 52, 146, 192);
INSERT INTO public.who_global_data VALUES (34457, 0, 8457, 0, 216, 146, 69);
INSERT INTO public.who_global_data VALUES (34458, 0, 12, 0, 0, 146, 187);
INSERT INTO public.who_global_data VALUES (34459, 247, 66049, 9, 2058, 146, 230);
INSERT INTO public.who_global_data VALUES (34460, 916, 11825, 2, 633, 146, 77);
INSERT INTO public.who_global_data VALUES (34461, 1, 2162, 0, 10, 146, 9);
INSERT INTO public.who_global_data VALUES (34462, 94372, 4754356, 1114, 78586, 146, 74);
INSERT INTO public.who_global_data VALUES (34463, 3806, 214746, 106, 8650, 146, 224);
INSERT INTO public.who_global_data VALUES (34464, 2139, 399940, 116, 23029, 146, 199);
INSERT INTO public.who_global_data VALUES (34465, 4106, 286778, 60, 7941, 146, 190);
INSERT INTO public.who_global_data VALUES (34466, 159, 30730, 2, 1783, 146, 12);
INSERT INTO public.who_global_data VALUES (34467, 0, 337, 0, 24, 146, 104);
INSERT INTO public.who_global_data VALUES (34468, 3975, 150334, 20, 1124, 146, 153);
INSERT INTO public.who_global_data VALUES (34469, 1501, 286297, 6, 35603, 146, 91);
INSERT INTO public.who_global_data VALUES (34470, 0, 3511, 0, 40, 146, 215);
INSERT INTO public.who_global_data VALUES (34471, 674, 75218, 16, 1439, 146, 84);
INSERT INTO public.who_global_data VALUES (34472, 1, 380, 0, 32, 146, 231);
INSERT INTO public.who_global_data VALUES (34473, 117, 3130, 1, 22, 146, 196);
INSERT INTO public.who_global_data VALUES (34474, 129, 136513, 51, 1999, 146, 105);
INSERT INTO public.who_global_data VALUES (34475, 170, 35963, 3, 619, 146, 122);
INSERT INTO public.who_global_data VALUES (34476, 0, 0, 0, 0, 146, 159);
INSERT INTO public.who_global_data VALUES (34477, 70, 14523, 3, 579, 146, 75);
INSERT INTO public.who_global_data VALUES (34478, 736, 94211, 1, 558, 146, 27);
INSERT INTO public.who_global_data VALUES (34479, 53, 44881, 0, 1063, 146, 54);
INSERT INTO public.who_global_data VALUES (34480, 0, 23, 0, 0, 146, 226);
INSERT INTO public.who_global_data VALUES (34481, 5, 1464, 0, 35, 146, 79);
INSERT INTO public.who_global_data VALUES (34482, 686, 23669, 10, 239, 146, 56);
INSERT INTO public.who_global_data VALUES (34483, 0, 1245, 0, 33, 146, 117);
INSERT INTO public.who_global_data VALUES (34484, 0, 1311, 0, 82, 146, 152);
INSERT INTO public.who_global_data VALUES (34485, 433, 22781, 8, 362, 146, 16);
INSERT INTO public.who_global_data VALUES (34486, 0, 111, 0, 1, 146, 10);
INSERT INTO public.who_global_data VALUES (34487, 39, 3330, 1, 87, 146, 201);
INSERT INTO public.who_global_data VALUES (34488, 0, 7159, 0, 124, 146, 174);
INSERT INTO public.who_global_data VALUES (34489, 68, 15737, 1, 210, 146, 119);
INSERT INTO public.who_global_data VALUES (34490, 0, 5669, 0, 177, 146, 168);
INSERT INTO public.who_global_data VALUES (34491, 58, 9868, 0, 128, 146, 99);
INSERT INTO public.who_global_data VALUES (34492, 62, 9052, 0, 31, 146, 171);
INSERT INTO public.who_global_data VALUES (34493, 4, 2916, 0, 128, 146, 87);
INSERT INTO public.who_global_data VALUES (34494, 78, 2353, 0, 15, 146, 123);
INSERT INTO public.who_global_data VALUES (34495, 0, 0, 0, 0, 146, 151);
INSERT INTO public.who_global_data VALUES (34496, 0, 939, 0, 18, 146, 213);
INSERT INTO public.who_global_data VALUES (34497, 8, 7274, 0, 161, 146, 118);
INSERT INTO public.who_global_data VALUES (34498, 0, 361, 0, 10, 146, 134);
INSERT INTO public.who_global_data VALUES (34499, 0, 3374, 0, 40, 146, 65);
INSERT INTO public.who_global_data VALUES (34500, 5935, 658299, 534, 70183, 146, 102);
INSERT INTO public.who_global_data VALUES (34501, 0, 0, 0, 0, 146, 223);
INSERT INTO public.who_global_data VALUES (34502, 1, 172, 0, 1, 146, 4);
INSERT INTO public.who_global_data VALUES (34503, 0, 311, 0, 0, 146, 146);
INSERT INTO public.who_global_data VALUES (34504, 348, 7173, 2, 120, 146, 31);
INSERT INTO public.who_global_data VALUES (34505, 0, 13, 0, 1, 146, 127);
INSERT INTO public.who_global_data VALUES (34506, 2238, 84435, 29, 1553, 146, 22);
INSERT INTO public.who_global_data VALUES (34507, 122, 5040, 4, 35, 146, 115);
INSERT INTO public.who_global_data VALUES (34508, 351, 2796, 2, 16, 146, 106);
INSERT INTO public.who_global_data VALUES (34509, 167, 9604, 0, 98, 146, 90);
INSERT INTO public.who_global_data VALUES (34510, 0, 0, 0, 0, 146, 70);
INSERT INTO public.who_global_data VALUES (34511, 1201, 53120, 14, 336, 146, 46);
INSERT INTO public.who_global_data VALUES (34512, 1222, 80919, 1, 6252, 146, 139);
INSERT INTO public.who_global_data VALUES (34513, 0, 26, 0, 0, 146, 42);
INSERT INTO public.who_global_data VALUES (34514, 2, 1446, 0, 24, 146, 80);
INSERT INTO public.who_global_data VALUES (34515, 0, 3877, 0, 144, 146, 203);
INSERT INTO public.who_global_data VALUES (34516, 0, 1178, 0, 69, 146, 136);
INSERT INTO public.who_global_data VALUES (34517, 160, 56177, 2, 1078, 146, 63);
INSERT INTO public.who_global_data VALUES (34518, 0, 0, 0, 0, 146, 17);
INSERT INTO public.who_global_data VALUES (34519, 1, 60, 0, 2, 146, 172);
INSERT INTO public.who_global_data VALUES (34520, 139, 15694, 4, 646, 146, 109);
INSERT INTO public.who_global_data VALUES (34521, 0, 11866, 0, 265, 146, 200);
INSERT INTO public.who_global_data VALUES (34522, 650, 38516, 6, 238, 146, 93);
INSERT INTO public.who_global_data VALUES (34523, 0, 88337, 0, 762, 146, 5);
INSERT INTO public.who_global_data VALUES (34524, 0, 741, 0, 13, 146, 214);
INSERT INTO public.who_global_data VALUES (34525, 526, 301481, 6, 6379, 146, 204);
INSERT INTO public.who_global_data VALUES (34526, 0, 0, 0, 0, 146, 198);
INSERT INTO public.who_global_data VALUES (34527, 615, 100330, 13, 2140, 146, 173);
INSERT INTO public.who_global_data VALUES (34528, 0, 508, 0, 5, 146, 229);
INSERT INTO public.who_global_data VALUES (34529, 881, 26512, 11, 496, 146, 76);
INSERT INTO public.who_global_data VALUES (34530, 6603, 716670, 126, 30470, 146, 138);
INSERT INTO public.who_global_data VALUES (34531, 4899, 257863, 184, 4292, 146, 98);
INSERT INTO public.who_global_data VALUES (34532, 0, 0, 0, 0, 146, 103);
INSERT INTO public.who_global_data VALUES (34533, 603, 73650, 13, 2182, 146, 225);
INSERT INTO public.who_global_data VALUES (34534, 497, 63310, 5, 1860, 146, 131);
INSERT INTO public.who_global_data VALUES (34535, 511, 37092, 12, 535, 146, 235);
INSERT INTO public.who_global_data VALUES (34536, 236, 121523, 0, 205, 146, 137);
INSERT INTO public.who_global_data VALUES (34537, 121, 22176, 3, 358, 146, 81);
INSERT INTO public.who_global_data VALUES (34538, 531, 42714, 4, 1118, 146, 182);
INSERT INTO public.who_global_data VALUES (34539, 100, 2723, 1, 10, 146, 145);
INSERT INTO public.who_global_data VALUES (34540, 1311, 102386, 27, 4127, 146, 26);
INSERT INTO public.who_global_data VALUES (34541, 5449, 1062811, 94, 18578, 146, 170);
INSERT INTO public.who_global_data VALUES (34542, 31, 4565, 0, 22, 146, 191);
INSERT INTO public.who_global_data VALUES (34543, 0, 5, 0, 0, 146, 221);
INSERT INTO public.who_global_data VALUES (34544, 0, 21, 0, 0, 146, 64);
INSERT INTO public.who_global_data VALUES (34545, 0, 0, 0, 0, 146, 116);
INSERT INTO public.who_global_data VALUES (34546, 0, 17, 0, 0, 146, 128);
INSERT INTO public.who_global_data VALUES (34547, 0, 27, 0, 0, 146, 6);
INSERT INTO public.who_global_data VALUES (34548, 0, 256, 0, 6, 146, 227);
INSERT INTO public.who_global_data VALUES (34549, 0, 11, 0, 0, 146, 68);
INSERT INTO public.who_global_data VALUES (34550, 2, 64, 0, 0, 146, 184);
INSERT INTO public.who_global_data VALUES (34551, 0, 0, 0, 0, 146, 82);
INSERT INTO public.who_global_data VALUES (34552, 0, 741, 0, 42, 146, 149);
INSERT INTO public.who_global_data VALUES (34553, 0, 906, 0, 15, 146, 197);
INSERT INTO public.who_global_data VALUES (34554, 643, 325050, 27, 4240, 146, 78);
INSERT INTO public.who_global_data VALUES (34555, 0, 14193, 0, 293, 146, 233);
INSERT INTO public.who_global_data VALUES (34556, 72, 32300, 1, 731, 146, 133);
INSERT INTO public.who_global_data VALUES (34557, 0, 135, 0, 0, 146, 35);
INSERT INTO public.who_global_data VALUES (34558, 9, 2096, 0, 72, 146, 114);
INSERT INTO public.who_global_data VALUES (34559, 42, 57357, 0, 27, 146, 237);
INSERT INTO public.who_global_data VALUES (34560, 0, 10, 0, 0, 146, 55);
INSERT INTO public.who_global_data VALUES (34561, 0, 530, 0, 19, 146, 176);
INSERT INTO public.who_global_data VALUES (34562, 201, 5453, 1, 38, 146, 202);
INSERT INTO public.who_global_data VALUES (34563, 99, 3703, 1, 137, 146, 155);
INSERT INTO public.who_global_data VALUES (34564, 0, 0, 0, 0, 146, 32);
INSERT INTO public.who_global_data VALUES (34565, 0, 3376, 0, 98, 146, 220);
INSERT INTO public.who_global_data VALUES (34566, 1816, 648214, 49, 15427, 146, 30);
INSERT INTO public.who_global_data VALUES (34567, 0, 2578, 0, 49, 146, 147);
INSERT INTO public.who_global_data VALUES (34568, 14468, 623477, 97, 31815, 146, 208);
INSERT INTO public.who_global_data VALUES (34569, 35, 3204, 0, 12, 146, 45);
INSERT INTO public.who_global_data VALUES (34570, 0, 13532, 0, 836, 146, 110);
INSERT INTO public.who_global_data VALUES (34571, 52, 4529, 0, 93, 146, 88);
INSERT INTO public.who_global_data VALUES (34572, 291, 86847, 4, 5850, 146, 51);
INSERT INTO public.who_global_data VALUES (34573, 266, 47324, 3, 1788, 146, 209);
INSERT INTO public.who_global_data VALUES (34574, 30, 3506, 2, 152, 146, 205);
INSERT INTO public.who_global_data VALUES (34575, 37, 9014, 0, 72, 146, 18);
INSERT INTO public.who_global_data VALUES (34576, 7, 3473, 0, 58, 146, 72);
INSERT INTO public.who_global_data VALUES (34577, 3497, 365178, 9, 41623, 146, 44);
INSERT INTO public.who_global_data VALUES (34578, 0, 27, 0, 0, 146, 15);
INSERT INTO public.who_global_data VALUES (34579, 7, 1555, 0, 37, 146, 25);
INSERT INTO public.who_global_data VALUES (34580, 0, 0, 0, 0, 146, 179);
INSERT INTO public.who_global_data VALUES (34581, 0, 0, 0, 0, 146, 34);
INSERT INTO public.who_global_data VALUES (34582, 115, 2892, 5, 50, 146, 207);
INSERT INTO public.who_global_data VALUES (34583, 747, 7382, 10, 117, 146, 166);
INSERT INTO public.who_global_data VALUES (34584, 8239, 605945, 48, 6999, 146, 126);
INSERT INTO public.who_global_data VALUES (34585, 0, 0, 0, 0, 146, 97);
INSERT INTO public.who_global_data VALUES (34586, 3, 641, 0, 5, 146, 36);
INSERT INTO public.who_global_data VALUES (34587, 0, 0, 0, 0, 146, 125);
INSERT INTO public.who_global_data VALUES (34588, 326, 4703, 3, 52, 146, 124);
INSERT INTO public.who_global_data VALUES (34589, 2476, 154335, 30, 3178, 146, 185);
INSERT INTO public.who_global_data VALUES (34590, 1007, 78849, 1, 399, 146, 194);
INSERT INTO public.who_global_data VALUES (34591, 0, 509, 0, 21, 146, 144);
INSERT INTO public.who_global_data VALUES (34592, 45523, 6386832, 1022, 191809, 146, 19);
INSERT INTO public.who_global_data VALUES (34593, 10, 1211, 1, 19, 146, 217);
INSERT INTO public.who_global_data VALUES (34594, 14, 1773, 0, 45, 146, 148);
INSERT INTO public.who_global_data VALUES (34595, 544, 47042, 6, 388, 146, 86);
INSERT INTO public.who_global_data VALUES (34596, 0, 0, 0, 0, 146, 13);
INSERT INTO public.who_global_data VALUES (34597, 840, 58663, 8, 468, 146, 157);
INSERT INTO public.who_global_data VALUES (34598, 0, 1060, 0, 35, 146, 8);
INSERT INTO public.who_global_data VALUES (34599, 0, 0, 0, 0, 146, 73);
INSERT INTO public.who_global_data VALUES (34600, 2, 2013, 0, 583, 146, 101);
INSERT INTO public.who_global_data VALUES (34601, 143, 13466, 6, 312, 146, 165);
INSERT INTO public.who_global_data VALUES (34602, 29, 7508, 0, 224, 146, 14);
INSERT INTO public.who_global_data VALUES (34603, 35, 38727, 0, 1424, 147, 193);
INSERT INTO public.who_global_data VALUES (34604, 161, 11021, 3, 327, 147, 113);
INSERT INTO public.who_global_data VALUES (34605, 264, 47752, 8, 1599, 147, 143);
INSERT INTO public.who_global_data VALUES (34606, 0, 0, 0, 0, 147, 219);
INSERT INTO public.who_global_data VALUES (34607, 43, 1344, 0, 53, 147, 186);
INSERT INTO public.who_global_data VALUES (34608, 62, 3279, 1, 131, 147, 52);
INSERT INTO public.who_global_data VALUES (34609, 0, 3, 0, 0, 147, 180);
INSERT INTO public.who_global_data VALUES (34610, 0, 95, 0, 3, 147, 167);
INSERT INTO public.who_global_data VALUES (34611, 11905, 524198, 281, 10994, 147, 154);
INSERT INTO public.who_global_data VALUES (34612, 172, 44988, 2, 906, 147, 94);
INSERT INTO public.who_global_data VALUES (34613, 89, 2819, 1, 16, 147, 66);
INSERT INTO public.who_global_data VALUES (34614, 52, 26565, 9, 797, 147, 58);
INSERT INTO public.who_global_data VALUES (34615, 1005, 32456, 2, 750, 147, 163);
INSERT INTO public.who_global_data VALUES (34616, 163, 38037, 1, 557, 147, 37);
INSERT INTO public.who_global_data VALUES (34617, 93, 2814, 2, 65, 147, 142);
INSERT INTO public.who_global_data VALUES (34618, 632, 58839, 1, 208, 147, 83);
INSERT INTO public.who_global_data VALUES (34619, 1792, 334762, 34, 4668, 147, 228);
INSERT INTO public.who_global_data VALUES (34620, 0, 180, 0, 7, 147, 188);
INSERT INTO public.who_global_data VALUES (34621, 193, 73784, 6, 738, 147, 62);
INSERT INTO public.who_global_data VALUES (34622, 1284, 94391, 5, 9918, 147, 160);
INSERT INTO public.who_global_data VALUES (34623, 34, 1399, 1, 19, 147, 50);
INSERT INTO public.who_global_data VALUES (34624, 0, 2242, 0, 40, 147, 33);
INSERT INTO public.who_global_data VALUES (34625, 0, 177, 0, 9, 147, 183);
INSERT INTO public.who_global_data VALUES (34626, 3, 241, 0, 0, 147, 92);
INSERT INTO public.who_global_data VALUES (34627, 860, 124205, 47, 7193, 147, 158);
INSERT INTO public.who_global_data VALUES (34628, 0, 10, 0, 0, 147, 67);
INSERT INTO public.who_global_data VALUES (34629, 290, 22829, 6, 679, 147, 57);
INSERT INTO public.who_global_data VALUES (34630, 0, 2126, 0, 9, 147, 38);
INSERT INTO public.who_global_data VALUES (34631, 40557, 4238446, 983, 129522, 147, 141);
INSERT INTO public.who_global_data VALUES (34632, 1, 64, 0, 1, 147, 178);
INSERT INTO public.who_global_data VALUES (34633, 0, 145, 0, 3, 147, 108);
INSERT INTO public.who_global_data VALUES (34634, 201, 17799, 7, 713, 147, 39);
INSERT INTO public.who_global_data VALUES (34635, 10, 1486, 0, 56, 147, 2);
INSERT INTO public.who_global_data VALUES (34636, 2, 471, 0, 1, 147, 195);
INSERT INTO public.who_global_data VALUES (34637, 94, 4651, 1, 44, 147, 107);
INSERT INTO public.who_global_data VALUES (34638, 0, 274, 0, 0, 147, 161);
INSERT INTO public.who_global_data VALUES (34639, 0, 20009, 0, 415, 147, 212);
INSERT INTO public.who_global_data VALUES (34640, 630, 134924, 8, 9163, 147, 181);
INSERT INTO public.who_global_data VALUES (34641, 1, 208, 0, 1, 147, 53);
INSERT INTO public.who_global_data VALUES (34642, 2, 4749, 0, 62, 147, 164);
INSERT INTO public.who_global_data VALUES (34643, 30, 1081, 0, 79, 147, 140);
INSERT INTO public.who_global_data VALUES (34644, 1866, 430535, 69, 11850, 147, 20);
INSERT INTO public.who_global_data VALUES (34645, 20, 90643, 0, 4740, 147, 112);
INSERT INTO public.who_global_data VALUES (34646, 7813, 694664, 222, 22275, 147, 111);
INSERT INTO public.who_global_data VALUES (34647, 0, 456, 0, 7, 147, 71);
INSERT INTO public.who_global_data VALUES (34648, 0, 4913, 0, 88, 147, 218);
INSERT INTO public.who_global_data VALUES (34649, 0, 0, 0, 0, 147, 43);
INSERT INTO public.who_global_data VALUES (34650, 1325, 52549, 24, 567, 147, 49);
INSERT INTO public.who_global_data VALUES (34651, 0, 18869, 0, 119, 147, 1);
INSERT INTO public.who_global_data VALUES (34652, 190, 13107, 3, 211, 147, 48);
INSERT INTO public.who_global_data VALUES (34653, 42, 4593, 0, 106, 147, 232);
INSERT INTO public.who_global_data VALUES (34654, 19, 135, 0, 1, 147, 175);
INSERT INTO public.who_global_data VALUES (34655, 3, 1520, 0, 21, 147, 21);
INSERT INTO public.who_global_data VALUES (34656, 1447, 33860, 2, 450, 147, 156);
INSERT INTO public.who_global_data VALUES (34657, 0, 0, 0, 0, 147, 95);
INSERT INTO public.who_global_data VALUES (34658, 18, 10360, 0, 262, 147, 177);
INSERT INTO public.who_global_data VALUES (34659, 292, 19216, 0, 629, 147, 210);
INSERT INTO public.who_global_data VALUES (34660, 0, 5394, 0, 61, 147, 120);
INSERT INTO public.who_global_data VALUES (34661, 0, 24, 0, 0, 147, 135);
INSERT INTO public.who_global_data VALUES (34662, 516, 102232, 15, 1941, 147, 206);
INSERT INTO public.who_global_data VALUES (34663, 0, 113206, 0, 10749, 147, 189);
INSERT INTO public.who_global_data VALUES (34664, 151, 100708, 17, 5607, 147, 129);
INSERT INTO public.who_global_data VALUES (34665, 85, 26773, 3, 777, 147, 121);
INSERT INTO public.who_global_data VALUES (34666, 6, 4996, 0, 83, 147, 59);
INSERT INTO public.who_global_data VALUES (34667, 0, 361, 0, 0, 147, 96);
INSERT INTO public.who_global_data VALUES (34668, 32, 2632, 0, 64, 147, 41);
INSERT INTO public.who_global_data VALUES (34669, 31, 5025, 0, 98, 147, 216);
INSERT INTO public.who_global_data VALUES (34670, 789, 63367, 12, 986, 147, 236);
INSERT INTO public.who_global_data VALUES (34671, 0, 13, 0, 0, 147, 150);
INSERT INTO public.who_global_data VALUES (34672, 1, 416, 0, 0, 147, 61);
INSERT INTO public.who_global_data VALUES (34673, 0, 32, 0, 2, 147, 7);
INSERT INTO public.who_global_data VALUES (34674, 43, 8512, 0, 337, 147, 169);
INSERT INTO public.who_global_data VALUES (34675, 9260, 344345, 80, 30734, 147, 28);
INSERT INTO public.who_global_data VALUES (34676, 32, 9494, 0, 63, 147, 85);
INSERT INTO public.who_global_data VALUES (34677, 22, 953, 1, 2, 147, 211);
INSERT INTO public.who_global_data VALUES (34678, 22, 8643, 0, 53, 147, 60);
INSERT INTO public.who_global_data VALUES (34679, 32, 3362, 0, 100, 147, 3);
INSERT INTO public.who_global_data VALUES (34680, 158, 2075, 0, 19, 147, 11);
INSERT INTO public.who_global_data VALUES (34681, 1630, 258480, 5, 9347, 147, 89);
INSERT INTO public.who_global_data VALUES (34682, 75, 45388, 2, 285, 147, 24);
INSERT INTO public.who_global_data VALUES (34683, 1, 323, 0, 0, 147, 162);
INSERT INTO public.who_global_data VALUES (34684, 282, 12734, 3, 300, 147, 100);
INSERT INTO public.who_global_data VALUES (34685, 0, 14, 0, 0, 147, 47);
INSERT INTO public.who_global_data VALUES (34686, 0, 24, 0, 0, 147, 29);
INSERT INTO public.who_global_data VALUES (34687, 0, 2287, 0, 23, 147, 40);
INSERT INTO public.who_global_data VALUES (34688, 17, 1863, 0, 23, 147, 222);
INSERT INTO public.who_global_data VALUES (34689, 703, 81009, 11, 2929, 147, 132);
INSERT INTO public.who_global_data VALUES (34690, 0, 253, 0, 13, 147, 130);
INSERT INTO public.who_global_data VALUES (34691, 33, 9979, 0, 63, 147, 234);
INSERT INTO public.who_global_data VALUES (34692, 0, 2275, 0, 39, 147, 23);
INSERT INTO public.who_global_data VALUES (34693, 47, 1750, 1, 49, 147, 192);
INSERT INTO public.who_global_data VALUES (34694, 28, 8457, 1, 216, 147, 69);
INSERT INTO public.who_global_data VALUES (34695, 0, 12, 0, 0, 147, 187);
INSERT INTO public.who_global_data VALUES (34696, 205, 65802, 5, 2049, 147, 230);
INSERT INTO public.who_global_data VALUES (34697, 718, 10909, 1, 631, 147, 77);
INSERT INTO public.who_global_data VALUES (34698, 4, 2161, 0, 10, 147, 9);
INSERT INTO public.who_global_data VALUES (34699, 97570, 4659984, 1201, 77472, 147, 74);
INSERT INTO public.who_global_data VALUES (34700, 3737, 210940, 88, 8544, 147, 224);
INSERT INTO public.who_global_data VALUES (34701, 2313, 397801, 115, 22913, 147, 199);
INSERT INTO public.who_global_data VALUES (34702, 4254, 282672, 67, 7881, 147, 190);
INSERT INTO public.who_global_data VALUES (34703, 211, 30571, 0, 1781, 147, 12);
INSERT INTO public.who_global_data VALUES (34704, 0, 337, 0, 24, 147, 104);
INSERT INTO public.who_global_data VALUES (34705, 4161, 146359, 14, 1104, 147, 153);
INSERT INTO public.who_global_data VALUES (34706, 1616, 284796, 10, 35597, 147, 91);
INSERT INTO public.who_global_data VALUES (34707, 74, 3511, 2, 40, 147, 215);
INSERT INTO public.who_global_data VALUES (34708, 643, 74544, 11, 1423, 147, 84);
INSERT INTO public.who_global_data VALUES (34709, 1, 379, 0, 32, 147, 231);
INSERT INTO public.who_global_data VALUES (34710, 206, 3013, 1, 21, 147, 196);
INSERT INTO public.who_global_data VALUES (34711, 420, 136384, 0, 1948, 147, 105);
INSERT INTO public.who_global_data VALUES (34712, 190, 35793, 4, 616, 147, 122);
INSERT INTO public.who_global_data VALUES (34713, 0, 0, 0, 0, 147, 159);
INSERT INTO public.who_global_data VALUES (34714, 50, 14453, 5, 576, 147, 75);
INSERT INTO public.who_global_data VALUES (34715, 653, 93475, 1, 557, 147, 27);
INSERT INTO public.who_global_data VALUES (34716, 67, 44828, 0, 1063, 147, 54);
INSERT INTO public.who_global_data VALUES (34717, 1, 23, 0, 0, 147, 226);
INSERT INTO public.who_global_data VALUES (34718, 11, 1459, 0, 35, 147, 79);
INSERT INTO public.who_global_data VALUES (34719, 546, 22983, 10, 229, 147, 56);
INSERT INTO public.who_global_data VALUES (34720, 0, 1245, 0, 33, 147, 117);
INSERT INTO public.who_global_data VALUES (34721, 0, 1311, 0, 82, 147, 152);
INSERT INTO public.who_global_data VALUES (34722, 440, 22348, 2, 354, 147, 16);
INSERT INTO public.who_global_data VALUES (34723, 2, 111, 0, 1, 147, 10);
INSERT INTO public.who_global_data VALUES (34724, 53, 3291, 0, 86, 147, 201);
INSERT INTO public.who_global_data VALUES (34725, 71, 7159, 0, 124, 147, 174);
INSERT INTO public.who_global_data VALUES (34726, 149, 15669, 3, 209, 147, 119);
INSERT INTO public.who_global_data VALUES (34727, 14, 5669, 1, 177, 147, 168);
INSERT INTO public.who_global_data VALUES (34728, 182, 9810, 0, 128, 147, 99);
INSERT INTO public.who_global_data VALUES (34729, 90, 8990, 0, 31, 147, 171);
INSERT INTO public.who_global_data VALUES (34730, 3, 2912, 0, 128, 147, 87);
INSERT INTO public.who_global_data VALUES (34731, 27, 2275, 0, 15, 147, 123);
INSERT INTO public.who_global_data VALUES (34732, 0, 0, 0, 0, 147, 151);
INSERT INTO public.who_global_data VALUES (34733, 0, 939, 0, 18, 147, 213);
INSERT INTO public.who_global_data VALUES (34734, 44, 7266, 0, 161, 147, 118);
INSERT INTO public.who_global_data VALUES (34735, 0, 361, 0, 10, 147, 134);
INSERT INTO public.who_global_data VALUES (34736, 0, 3374, 0, 40, 147, 65);
INSERT INTO public.who_global_data VALUES (34737, 4857, 652364, 554, 69649, 147, 102);
INSERT INTO public.who_global_data VALUES (34738, 0, 0, 0, 0, 147, 223);
INSERT INTO public.who_global_data VALUES (34739, 3, 171, 0, 1, 147, 4);
INSERT INTO public.who_global_data VALUES (34740, 1, 311, 0, 0, 147, 146);
INSERT INTO public.who_global_data VALUES (34741, 351, 6825, 1, 118, 147, 31);
INSERT INTO public.who_global_data VALUES (34742, 0, 13, 0, 1, 147, 127);
INSERT INTO public.who_global_data VALUES (34743, 2430, 82197, 33, 1524, 147, 22);
INSERT INTO public.who_global_data VALUES (34744, 86, 4918, 0, 31, 147, 115);
INSERT INTO public.who_global_data VALUES (34745, 180, 2445, 0, 14, 147, 106);
INSERT INTO public.who_global_data VALUES (34746, 181, 9437, 2, 98, 147, 90);
INSERT INTO public.who_global_data VALUES (34747, 0, 0, 0, 0, 147, 70);
INSERT INTO public.who_global_data VALUES (34748, 1454, 51919, 5, 322, 147, 46);
INSERT INTO public.who_global_data VALUES (34749, 1272, 79697, 3, 6251, 147, 139);
INSERT INTO public.who_global_data VALUES (34750, 0, 26, 0, 0, 147, 42);
INSERT INTO public.who_global_data VALUES (34751, 2, 1444, 0, 24, 147, 80);
INSERT INTO public.who_global_data VALUES (34752, 0, 3877, 0, 144, 147, 203);
INSERT INTO public.who_global_data VALUES (34753, 0, 1178, 0, 69, 147, 136);
INSERT INTO public.who_global_data VALUES (34754, 188, 56017, 1, 1076, 147, 63);
INSERT INTO public.who_global_data VALUES (34755, 0, 0, 0, 0, 147, 17);
INSERT INTO public.who_global_data VALUES (34756, 0, 59, 0, 2, 147, 172);
INSERT INTO public.who_global_data VALUES (34757, 141, 15555, 5, 642, 147, 109);
INSERT INTO public.who_global_data VALUES (34758, 120, 11866, 0, 265, 147, 200);
INSERT INTO public.who_global_data VALUES (34759, 652, 37866, 8, 232, 147, 93);
INSERT INTO public.who_global_data VALUES (34760, 0, 88337, 0, 762, 147, 5);
INSERT INTO public.who_global_data VALUES (34761, 0, 741, 0, 13, 147, 214);
INSERT INTO public.who_global_data VALUES (34762, 584, 300955, 3, 6373, 147, 204);
INSERT INTO public.who_global_data VALUES (34763, 0, 0, 0, 0, 147, 198);
INSERT INTO public.who_global_data VALUES (34764, 673, 99715, 11, 2127, 147, 173);
INSERT INTO public.who_global_data VALUES (34765, 1, 508, 0, 5, 147, 229);
INSERT INTO public.who_global_data VALUES (34766, 605, 25631, 11, 485, 147, 76);
INSERT INTO public.who_global_data VALUES (34767, 7291, 710067, 108, 30344, 147, 138);
INSERT INTO public.who_global_data VALUES (34768, 4017, 252964, 42, 4108, 147, 98);
INSERT INTO public.who_global_data VALUES (34769, 0, 0, 0, 0, 147, 103);
INSERT INTO public.who_global_data VALUES (34770, 594, 73047, 10, 2169, 147, 225);
INSERT INTO public.who_global_data VALUES (34771, 687, 62813, 3, 1855, 147, 131);
INSERT INTO public.who_global_data VALUES (34772, 302, 36581, 11, 523, 147, 235);
INSERT INTO public.who_global_data VALUES (34773, 235, 121287, 0, 205, 147, 137);
INSERT INTO public.who_global_data VALUES (34774, 136, 22055, 5, 355, 147, 81);
INSERT INTO public.who_global_data VALUES (34775, 479, 42183, 8, 1114, 147, 182);
INSERT INTO public.who_global_data VALUES (34776, 113, 2623, 0, 9, 147, 145);
INSERT INTO public.who_global_data VALUES (34777, 1391, 101075, 35, 4100, 147, 26);
INSERT INTO public.who_global_data VALUES (34778, 5488, 1057362, 119, 18484, 147, 170);
INSERT INTO public.who_global_data VALUES (34779, 55, 4534, 0, 22, 147, 191);
INSERT INTO public.who_global_data VALUES (34780, 0, 5, 0, 0, 147, 221);
INSERT INTO public.who_global_data VALUES (34781, 0, 21, 0, 0, 147, 64);
INSERT INTO public.who_global_data VALUES (34782, 0, 0, 0, 0, 147, 116);
INSERT INTO public.who_global_data VALUES (34783, 0, 17, 0, 0, 147, 128);
INSERT INTO public.who_global_data VALUES (34784, 0, 27, 0, 0, 147, 6);
INSERT INTO public.who_global_data VALUES (34785, 0, 256, 0, 6, 147, 227);
INSERT INTO public.who_global_data VALUES (34786, 1, 11, 0, 0, 147, 68);
INSERT INTO public.who_global_data VALUES (34787, 0, 62, 0, 0, 147, 184);
INSERT INTO public.who_global_data VALUES (34788, 0, 0, 0, 0, 147, 82);
INSERT INTO public.who_global_data VALUES (34789, 0, 741, 0, 42, 147, 149);
INSERT INTO public.who_global_data VALUES (34790, 5, 906, 0, 15, 147, 197);
INSERT INTO public.who_global_data VALUES (34791, 687, 324407, 24, 4213, 147, 78);
INSERT INTO public.who_global_data VALUES (34792, 43, 14193, 0, 293, 147, 233);
INSERT INTO public.who_global_data VALUES (34793, 92, 32228, 1, 730, 147, 133);
INSERT INTO public.who_global_data VALUES (34794, 0, 135, 0, 0, 147, 35);
INSERT INTO public.who_global_data VALUES (34795, 18, 2087, 0, 72, 147, 114);
INSERT INTO public.who_global_data VALUES (34796, 86, 57315, 0, 27, 147, 237);
INSERT INTO public.who_global_data VALUES (34797, 0, 10, 0, 0, 147, 55);
INSERT INTO public.who_global_data VALUES (34798, 0, 530, 0, 19, 147, 176);
INSERT INTO public.who_global_data VALUES (34799, 231, 5252, 0, 37, 147, 202);
INSERT INTO public.who_global_data VALUES (34800, 105, 3604, 1, 136, 147, 155);
INSERT INTO public.who_global_data VALUES (34801, 0, 0, 0, 0, 147, 32);
INSERT INTO public.who_global_data VALUES (34802, 0, 3376, 0, 98, 147, 220);
INSERT INTO public.who_global_data VALUES (34803, 1960, 646398, 113, 15378, 147, 30);
INSERT INTO public.who_global_data VALUES (34804, 10, 2578, 1, 49, 147, 147);
INSERT INTO public.who_global_data VALUES (34805, 13160, 609009, 90, 31718, 147, 208);
INSERT INTO public.who_global_data VALUES (34806, 14, 3169, 0, 12, 147, 45);
INSERT INTO public.who_global_data VALUES (34807, 16, 13532, 1, 836, 147, 110);
INSERT INTO public.who_global_data VALUES (34808, 30, 4477, 1, 93, 147, 88);
INSERT INTO public.who_global_data VALUES (34809, 254, 86556, 2, 5846, 147, 51);
INSERT INTO public.who_global_data VALUES (34810, 533, 47058, 4, 1785, 147, 209);
INSERT INTO public.who_global_data VALUES (34811, 60, 3476, 3, 150, 147, 205);
INSERT INTO public.who_global_data VALUES (34812, 38, 8977, 0, 72, 147, 18);
INSERT INTO public.who_global_data VALUES (34813, 5, 3466, 0, 58, 147, 72);
INSERT INTO public.who_global_data VALUES (34814, 3539, 361681, 6, 41614, 147, 44);
INSERT INTO public.who_global_data VALUES (34815, 0, 27, 0, 0, 147, 15);
INSERT INTO public.who_global_data VALUES (34816, 11, 1548, 0, 37, 147, 25);
INSERT INTO public.who_global_data VALUES (34817, 0, 0, 0, 0, 147, 179);
INSERT INTO public.who_global_data VALUES (34818, 0, 0, 0, 0, 147, 34);
INSERT INTO public.who_global_data VALUES (34819, 114, 2777, 5, 45, 147, 207);
INSERT INTO public.who_global_data VALUES (34820, 0, 6635, 0, 107, 147, 166);
INSERT INTO public.who_global_data VALUES (34821, 8401, 597706, 56, 6951, 147, 126);
INSERT INTO public.who_global_data VALUES (34822, 0, 0, 0, 0, 147, 97);
INSERT INTO public.who_global_data VALUES (34823, 10, 638, 0, 5, 147, 36);
INSERT INTO public.who_global_data VALUES (34824, 0, 0, 0, 0, 147, 125);
INSERT INTO public.who_global_data VALUES (34825, 86, 4377, 1, 49, 147, 124);
INSERT INTO public.who_global_data VALUES (34826, 3103, 151859, 72, 3148, 147, 185);
INSERT INTO public.who_global_data VALUES (34827, 931, 77842, 0, 398, 147, 194);
INSERT INTO public.who_global_data VALUES (34828, 0, 509, 0, 21, 147, 144);
INSERT INTO public.who_global_data VALUES (34829, 37128, 6341309, 1078, 190787, 147, 19);
INSERT INTO public.who_global_data VALUES (34830, 4, 1201, 0, 18, 147, 217);
INSERT INTO public.who_global_data VALUES (34831, 18, 1759, 0, 45, 147, 148);
INSERT INTO public.who_global_data VALUES (34832, 571, 46498, 7, 382, 147, 86);
INSERT INTO public.who_global_data VALUES (34833, 0, 0, 0, 0, 147, 13);
INSERT INTO public.who_global_data VALUES (34834, 1072, 57823, 8, 460, 147, 157);
INSERT INTO public.who_global_data VALUES (34835, 1, 1060, 0, 35, 147, 8);
INSERT INTO public.who_global_data VALUES (34836, 0, 0, 0, 0, 147, 73);
INSERT INTO public.who_global_data VALUES (34837, 4, 2011, 2, 583, 147, 101);
INSERT INTO public.who_global_data VALUES (34838, 109, 13323, 6, 306, 147, 165);
INSERT INTO public.who_global_data VALUES (34839, 26, 7479, 2, 224, 147, 14);
INSERT INTO public.who_global_data VALUES (34840, 34, 38692, 0, 1424, 148, 193);
INSERT INTO public.who_global_data VALUES (34841, 156, 10860, 2, 324, 148, 113);
INSERT INTO public.who_global_data VALUES (34842, 272, 47488, 10, 1591, 148, 143);
INSERT INTO public.who_global_data VALUES (34843, 0, 0, 0, 0, 148, 219);
INSERT INTO public.who_global_data VALUES (34844, 0, 1301, 0, 53, 148, 186);
INSERT INTO public.who_global_data VALUES (34845, 125, 3217, 4, 130, 148, 52);
INSERT INTO public.who_global_data VALUES (34846, 0, 3, 0, 0, 148, 180);
INSERT INTO public.who_global_data VALUES (34847, 0, 95, 0, 3, 148, 167);
INSERT INTO public.who_global_data VALUES (34848, 12259, 512293, 256, 10713, 148, 154);
INSERT INTO public.who_global_data VALUES (34849, 177, 44816, 3, 904, 148, 94);
INSERT INTO public.who_global_data VALUES (34850, 141, 2730, 0, 15, 148, 66);
INSERT INTO public.who_global_data VALUES (34851, 48, 26513, 7, 788, 148, 58);
INSERT INTO public.who_global_data VALUES (34852, 497, 31451, 1, 748, 148, 163);
INSERT INTO public.who_global_data VALUES (34853, 142, 37874, 1, 556, 148, 37);
INSERT INTO public.who_global_data VALUES (34854, 64, 2721, 0, 63, 148, 142);
INSERT INTO public.who_global_data VALUES (34855, 757, 58207, 4, 207, 148, 83);
INSERT INTO public.who_global_data VALUES (34856, 1892, 332970, 41, 4634, 148, 228);
INSERT INTO public.who_global_data VALUES (34857, 0, 180, 0, 7, 148, 188);
INSERT INTO public.who_global_data VALUES (34858, 189, 73591, 6, 732, 148, 62);
INSERT INTO public.who_global_data VALUES (34859, 1143, 93107, 3, 9913, 148, 160);
INSERT INTO public.who_global_data VALUES (34860, 4, 1365, 2, 18, 148, 50);
INSERT INTO public.who_global_data VALUES (34861, 0, 2242, 0, 40, 148, 33);
INSERT INTO public.who_global_data VALUES (34862, 0, 177, 0, 9, 148, 183);
INSERT INTO public.who_global_data VALUES (34863, 4, 238, 0, 0, 148, 92);
INSERT INTO public.who_global_data VALUES (34864, 1037, 123345, 49, 7146, 148, 158);
INSERT INTO public.who_global_data VALUES (34865, 0, 10, 0, 0, 148, 67);
INSERT INTO public.who_global_data VALUES (34866, 285, 22539, 5, 673, 148, 57);
INSERT INTO public.who_global_data VALUES (34867, 0, 2126, 0, 9, 148, 38);
INSERT INTO public.who_global_data VALUES (34868, 35816, 4197889, 1075, 128539, 148, 141);
INSERT INTO public.who_global_data VALUES (34869, 0, 63, 0, 1, 148, 178);
INSERT INTO public.who_global_data VALUES (34870, 0, 145, 0, 3, 148, 108);
INSERT INTO public.who_global_data VALUES (34871, 163, 17598, 4, 706, 148, 39);
INSERT INTO public.who_global_data VALUES (34872, 10, 1476, 0, 56, 148, 2);
INSERT INTO public.who_global_data VALUES (34873, 0, 469, 0, 1, 148, 195);
INSERT INTO public.who_global_data VALUES (34874, 84, 4557, 0, 43, 148, 107);
INSERT INTO public.who_global_data VALUES (34875, 0, 274, 0, 0, 148, 161);
INSERT INTO public.who_global_data VALUES (34876, 161, 20009, 0, 415, 148, 212);
INSERT INTO public.who_global_data VALUES (34877, 546, 134294, 2, 9155, 148, 181);
INSERT INTO public.who_global_data VALUES (34878, 2, 207, 0, 1, 148, 53);
INSERT INTO public.who_global_data VALUES (34879, 11, 4747, 0, 62, 148, 164);
INSERT INTO public.who_global_data VALUES (34880, 3, 1051, 0, 79, 148, 140);
INSERT INTO public.who_global_data VALUES (34881, 1642, 428669, 79, 11781, 148, 20);
INSERT INTO public.who_global_data VALUES (34882, 28, 90623, 0, 4740, 148, 112);
INSERT INTO public.who_global_data VALUES (34883, 7338, 686851, 236, 22053, 148, 111);
INSERT INTO public.who_global_data VALUES (34884, 0, 456, 0, 7, 148, 71);
INSERT INTO public.who_global_data VALUES (34885, 22, 4913, 6, 88, 148, 218);
INSERT INTO public.who_global_data VALUES (34886, 0, 0, 0, 0, 148, 43);
INSERT INTO public.who_global_data VALUES (34887, 1327, 51224, 12, 543, 148, 49);
INSERT INTO public.who_global_data VALUES (34888, 54, 18869, 0, 119, 148, 1);
INSERT INTO public.who_global_data VALUES (34889, 291, 12917, 2, 208, 148, 48);
INSERT INTO public.who_global_data VALUES (34890, 92, 4551, 2, 106, 148, 232);
INSERT INTO public.who_global_data VALUES (34891, 0, 116, 0, 1, 148, 175);
INSERT INTO public.who_global_data VALUES (34892, 3, 1517, 0, 21, 148, 21);
INSERT INTO public.who_global_data VALUES (34893, 1377, 32413, 4, 448, 148, 156);
INSERT INTO public.who_global_data VALUES (34894, 0, 0, 0, 0, 148, 95);
INSERT INTO public.who_global_data VALUES (34895, 19, 10342, 2, 262, 148, 177);
INSERT INTO public.who_global_data VALUES (34896, 317, 18924, 1, 629, 148, 210);
INSERT INTO public.who_global_data VALUES (34897, 3, 5394, 0, 61, 148, 120);
INSERT INTO public.who_global_data VALUES (34898, 0, 24, 0, 0, 148, 135);
INSERT INTO public.who_global_data VALUES (34899, 779, 101716, 12, 1926, 148, 206);
INSERT INTO public.who_global_data VALUES (34900, 1040, 113206, 48, 10749, 148, 189);
INSERT INTO public.who_global_data VALUES (34901, 154, 100557, 13, 5590, 148, 129);
INSERT INTO public.who_global_data VALUES (34902, 86, 26688, 4, 774, 148, 121);
INSERT INTO public.who_global_data VALUES (34903, 0, 4990, 0, 83, 148, 59);
INSERT INTO public.who_global_data VALUES (34904, 20, 361, 0, 0, 148, 96);
INSERT INTO public.who_global_data VALUES (34905, 15, 2600, 0, 64, 148, 41);
INSERT INTO public.who_global_data VALUES (34906, 58, 4994, 1, 98, 148, 216);
INSERT INTO public.who_global_data VALUES (34907, 878, 62578, 8, 974, 148, 236);
INSERT INTO public.who_global_data VALUES (34908, 0, 13, 0, 0, 148, 150);
INSERT INTO public.who_global_data VALUES (34909, 0, 415, 0, 0, 148, 61);
INSERT INTO public.who_global_data VALUES (34910, 0, 32, 0, 2, 148, 7);
INSERT INTO public.who_global_data VALUES (34911, 39, 8469, 0, 337, 148, 169);
INSERT INTO public.who_global_data VALUES (34912, 9685, 335085, 18, 30654, 148, 28);
INSERT INTO public.who_global_data VALUES (34913, 44, 9462, 1, 63, 148, 85);
INSERT INTO public.who_global_data VALUES (34914, 74, 931, 1, 1, 148, 211);
INSERT INTO public.who_global_data VALUES (34915, 0, 8621, 0, 53, 148, 60);
INSERT INTO public.who_global_data VALUES (34916, 37, 3330, 1, 100, 148, 3);
INSERT INTO public.who_global_data VALUES (34917, 87, 1917, 0, 19, 148, 11);
INSERT INTO public.who_global_data VALUES (34918, 1484, 256850, 1, 9342, 148, 89);
INSERT INTO public.who_global_data VALUES (34919, 301, 45313, 0, 283, 148, 24);
INSERT INTO public.who_global_data VALUES (34920, 2, 322, 0, 0, 148, 162);
INSERT INTO public.who_global_data VALUES (34921, 372, 12452, 4, 297, 148, 100);
INSERT INTO public.who_global_data VALUES (34922, 0, 14, 0, 0, 148, 47);
INSERT INTO public.who_global_data VALUES (34923, 0, 24, 0, 0, 148, 29);
INSERT INTO public.who_global_data VALUES (34924, 0, 2287, 0, 23, 148, 40);
INSERT INTO public.who_global_data VALUES (34925, 88, 1846, 2, 23, 148, 222);
INSERT INTO public.who_global_data VALUES (34926, 684, 80306, 21, 2918, 148, 132);
INSERT INTO public.who_global_data VALUES (34927, 0, 253, 0, 13, 148, 130);
INSERT INTO public.who_global_data VALUES (34928, 61, 9946, 0, 63, 148, 234);
INSERT INTO public.who_global_data VALUES (34929, 0, 2275, 0, 39, 148, 23);
INSERT INTO public.who_global_data VALUES (34930, 90, 1703, 0, 48, 148, 192);
INSERT INTO public.who_global_data VALUES (34931, 53, 8429, 1, 215, 148, 69);
INSERT INTO public.who_global_data VALUES (34932, 0, 12, 0, 0, 148, 187);
INSERT INTO public.who_global_data VALUES (34933, 379, 65597, 10, 2044, 148, 230);
INSERT INTO public.who_global_data VALUES (34934, 476, 10191, 2, 630, 148, 77);
INSERT INTO public.who_global_data VALUES (34935, 4, 2157, 0, 10, 148, 9);
INSERT INTO public.who_global_data VALUES (34936, 96551, 4562414, 1209, 76271, 148, 74);
INSERT INTO public.who_global_data VALUES (34937, 3861, 207203, 120, 8456, 148, 224);
INSERT INTO public.who_global_data VALUES (34938, 2063, 395488, 129, 22798, 148, 199);
INSERT INTO public.who_global_data VALUES (34939, 4597, 278418, 82, 7814, 148, 190);
INSERT INTO public.who_global_data VALUES (34940, 196, 30360, 0, 1781, 148, 12);
INSERT INTO public.who_global_data VALUES (34941, 0, 337, 0, 24, 148, 104);
INSERT INTO public.who_global_data VALUES (34942, 3994, 142198, 16, 1090, 148, 153);
INSERT INTO public.who_global_data VALUES (34943, 1597, 283180, 10, 35587, 148, 91);
INSERT INTO public.who_global_data VALUES (34944, 114, 3437, 2, 38, 148, 215);
INSERT INTO public.who_global_data VALUES (34945, 680, 73901, 6, 1412, 148, 84);
INSERT INTO public.who_global_data VALUES (34946, -7, 378, 0, 32, 148, 231);
INSERT INTO public.who_global_data VALUES (34947, 80, 2807, 1, 20, 148, 196);
INSERT INTO public.who_global_data VALUES (34948, 375, 135964, 0, 1948, 148, 105);
INSERT INTO public.who_global_data VALUES (34949, 143, 35603, 5, 612, 148, 122);
INSERT INTO public.who_global_data VALUES (34950, 0, 0, 0, 0, 148, 159);
INSERT INTO public.who_global_data VALUES (34951, 69, 14403, 7, 571, 148, 75);
INSERT INTO public.who_global_data VALUES (34952, 740, 92822, 4, 556, 148, 27);
INSERT INTO public.who_global_data VALUES (34953, 77, 44761, 0, 1063, 148, 54);
INSERT INTO public.who_global_data VALUES (34954, 0, 22, 0, 0, 148, 226);
INSERT INTO public.who_global_data VALUES (34955, 5, 1448, 0, 35, 148, 79);
INSERT INTO public.who_global_data VALUES (34956, 560, 22437, 7, 219, 148, 56);
INSERT INTO public.who_global_data VALUES (34957, 81, 1245, 2, 33, 148, 117);
INSERT INTO public.who_global_data VALUES (34958, 0, 1311, 0, 82, 148, 152);
INSERT INTO public.who_global_data VALUES (34959, 969, 21908, 13, 352, 148, 16);
INSERT INTO public.who_global_data VALUES (34960, 0, 109, 0, 1, 148, 10);
INSERT INTO public.who_global_data VALUES (34961, 44, 3238, 0, 86, 148, 201);
INSERT INTO public.who_global_data VALUES (34962, 65, 7088, 0, 124, 148, 174);
INSERT INTO public.who_global_data VALUES (34963, 0, 15520, 0, 206, 148, 119);
INSERT INTO public.who_global_data VALUES (34964, 2, 5655, 0, 176, 148, 168);
INSERT INTO public.who_global_data VALUES (34965, 45, 9628, 0, 128, 148, 99);
INSERT INTO public.who_global_data VALUES (34966, 66, 8900, 0, 31, 148, 171);
INSERT INTO public.who_global_data VALUES (34967, 11, 2909, 0, 128, 148, 87);
INSERT INTO public.who_global_data VALUES (34968, 43, 2248, 1, 15, 148, 123);
INSERT INTO public.who_global_data VALUES (34969, 0, 0, 0, 0, 148, 151);
INSERT INTO public.who_global_data VALUES (34970, 0, 939, 0, 18, 148, 213);
INSERT INTO public.who_global_data VALUES (34971, 20, 7222, 0, 161, 148, 118);
INSERT INTO public.who_global_data VALUES (34972, 4, 361, 0, 10, 148, 134);
INSERT INTO public.who_global_data VALUES (34973, 0, 3374, 0, 40, 148, 65);
INSERT INTO public.who_global_data VALUES (34974, 4647, 647507, 611, 69095, 148, 102);
INSERT INTO public.who_global_data VALUES (34975, 0, 0, 0, 0, 148, 223);
INSERT INTO public.who_global_data VALUES (34976, 4, 168, 0, 1, 148, 4);
INSERT INTO public.who_global_data VALUES (34977, 0, 310, 0, 0, 148, 146);
INSERT INTO public.who_global_data VALUES (34978, 140, 6474, 3, 117, 148, 31);
INSERT INTO public.who_global_data VALUES (34979, 0, 13, 0, 1, 148, 127);
INSERT INTO public.who_global_data VALUES (34980, 1889, 79767, 38, 1491, 148, 22);
INSERT INTO public.who_global_data VALUES (34981, 68, 4832, 3, 31, 148, 115);
INSERT INTO public.who_global_data VALUES (34982, 256, 2265, 0, 14, 148, 106);
INSERT INTO public.who_global_data VALUES (34983, 148, 9256, 3, 96, 148, 90);
INSERT INTO public.who_global_data VALUES (34984, 0, 0, 0, 0, 148, 70);
INSERT INTO public.who_global_data VALUES (34985, 1246, 50465, 5, 317, 148, 46);
INSERT INTO public.who_global_data VALUES (34986, 837, 78425, 3, 6248, 148, 139);
INSERT INTO public.who_global_data VALUES (34987, 0, 26, 0, 0, 148, 42);
INSERT INTO public.who_global_data VALUES (34988, 1, 1442, 0, 24, 148, 80);
INSERT INTO public.who_global_data VALUES (34989, 0, 3877, 0, 144, 148, 203);
INSERT INTO public.who_global_data VALUES (34990, 0, 1178, 0, 69, 148, 136);
INSERT INTO public.who_global_data VALUES (34991, 197, 55829, 5, 1075, 148, 63);
INSERT INTO public.who_global_data VALUES (34992, 0, 0, 0, 0, 148, 17);
INSERT INTO public.who_global_data VALUES (34993, 0, 59, 0, 2, 148, 172);
INSERT INTO public.who_global_data VALUES (34994, 121, 15414, 3, 637, 148, 109);
INSERT INTO public.who_global_data VALUES (34995, 122, 11746, 1, 265, 148, 200);
INSERT INTO public.who_global_data VALUES (34996, 1000, 37214, 7, 224, 148, 93);
INSERT INTO public.who_global_data VALUES (34997, 398, 88337, 11, 762, 148, 5);
INSERT INTO public.who_global_data VALUES (34998, 0, 741, 0, 13, 148, 214);
INSERT INTO public.who_global_data VALUES (34999, 516, 300371, 5, 6370, 148, 204);
INSERT INTO public.who_global_data VALUES (35000, 0, 0, 0, 0, 148, 198);
INSERT INTO public.who_global_data VALUES (35001, 635, 99042, 9, 2116, 148, 173);
INSERT INTO public.who_global_data VALUES (35002, 3, 507, 0, 5, 148, 229);
INSERT INTO public.who_global_data VALUES (35003, 812, 25026, 11, 474, 148, 76);
INSERT INTO public.who_global_data VALUES (35004, 6586, 702776, 113, 30236, 148, 138);
INSERT INTO public.who_global_data VALUES (35005, 3804, 248947, 80, 4066, 148, 98);
INSERT INTO public.who_global_data VALUES (35006, 0, 0, 0, 0, 148, 103);
INSERT INTO public.who_global_data VALUES (35007, 506, 72453, 12, 2159, 148, 225);
INSERT INTO public.who_global_data VALUES (35008, 585, 62126, 3, 1852, 148, 131);
INSERT INTO public.who_global_data VALUES (35009, 772, 36279, 12, 512, 148, 235);
INSERT INTO public.who_global_data VALUES (35010, 206, 121052, 0, 205, 148, 137);
INSERT INTO public.who_global_data VALUES (35011, 176, 21919, 4, 350, 148, 81);
INSERT INTO public.who_global_data VALUES (35012, 560, 41704, 10, 1106, 148, 182);
INSERT INTO public.who_global_data VALUES (35013, 94, 2510, 0, 9, 148, 145);
INSERT INTO public.who_global_data VALUES (35014, 1380, 99684, 47, 4065, 148, 26);
INSERT INTO public.who_global_data VALUES (35015, 5504, 1051874, 102, 18365, 148, 170);
INSERT INTO public.who_global_data VALUES (35016, 19, 4479, 1, 22, 148, 191);
INSERT INTO public.who_global_data VALUES (35017, 0, 5, 0, 0, 148, 221);
INSERT INTO public.who_global_data VALUES (35018, 3, 21, 0, 0, 148, 64);
INSERT INTO public.who_global_data VALUES (35019, 0, 0, 0, 0, 148, 116);
INSERT INTO public.who_global_data VALUES (35020, 0, 17, 0, 0, 148, 128);
INSERT INTO public.who_global_data VALUES (35021, 0, 27, 0, 0, 148, 6);
INSERT INTO public.who_global_data VALUES (35022, 17, 256, 0, 6, 148, 227);
INSERT INTO public.who_global_data VALUES (35023, 0, 10, 0, 0, 148, 68);
INSERT INTO public.who_global_data VALUES (35024, 0, 62, 0, 0, 148, 184);
INSERT INTO public.who_global_data VALUES (35025, 0, 0, 0, 0, 148, 82);
INSERT INTO public.who_global_data VALUES (35026, 6, 741, 0, 42, 148, 149);
INSERT INTO public.who_global_data VALUES (35027, 3, 901, 0, 15, 148, 197);
INSERT INTO public.who_global_data VALUES (35028, 708, 323720, 24, 4189, 148, 78);
INSERT INTO public.who_global_data VALUES (35029, 48, 14150, 0, 293, 148, 233);
INSERT INTO public.who_global_data VALUES (35030, 58, 32136, 1, 729, 148, 133);
INSERT INTO public.who_global_data VALUES (35031, 0, 135, 0, 0, 148, 35);
INSERT INTO public.who_global_data VALUES (35032, 2, 2069, 0, 72, 148, 114);
INSERT INTO public.who_global_data VALUES (35033, 63, 57229, 0, 27, 148, 237);
INSERT INTO public.who_global_data VALUES (35034, 0, 10, 0, 0, 148, 55);
INSERT INTO public.who_global_data VALUES (35035, 3, 530, 0, 19, 148, 176);
INSERT INTO public.who_global_data VALUES (35036, 133, 5021, 0, 37, 148, 202);
INSERT INTO public.who_global_data VALUES (35037, 108, 3499, 0, 135, 148, 155);
INSERT INTO public.who_global_data VALUES (35038, 0, 0, 0, 0, 148, 32);
INSERT INTO public.who_global_data VALUES (35039, 5, 3376, 1, 98, 148, 220);
INSERT INTO public.who_global_data VALUES (35040, 2007, 644438, 97, 15265, 148, 30);
INSERT INTO public.who_global_data VALUES (35041, 13, 2568, 0, 48, 148, 147);
INSERT INTO public.who_global_data VALUES (35042, 12947, 595849, 89, 31628, 148, 208);
INSERT INTO public.who_global_data VALUES (35043, 8, 3155, 0, 12, 148, 45);
INSERT INTO public.who_global_data VALUES (35044, 46, 13516, 1, 835, 148, 110);
INSERT INTO public.who_global_data VALUES (35045, 28, 4447, 1, 92, 148, 88);
INSERT INTO public.who_global_data VALUES (35046, 314, 86302, 2, 5844, 148, 51);
INSERT INTO public.who_global_data VALUES (35047, 507, 46525, 0, 1781, 148, 209);
INSERT INTO public.who_global_data VALUES (35048, 65, 3416, 4, 147, 148, 205);
INSERT INTO public.who_global_data VALUES (35049, 40, 8939, 1, 72, 148, 18);
INSERT INTO public.who_global_data VALUES (35050, 7, 3461, 0, 58, 148, 72);
INSERT INTO public.who_global_data VALUES (35051, 2919, 358142, 14, 41608, 148, 44);
INSERT INTO public.who_global_data VALUES (35052, 0, 27, 0, 0, 148, 15);
INSERT INTO public.who_global_data VALUES (35053, 9, 1537, 1, 37, 148, 25);
INSERT INTO public.who_global_data VALUES (35054, 0, 0, 0, 0, 148, 179);
INSERT INTO public.who_global_data VALUES (35055, 0, 0, 0, 0, 148, 34);
INSERT INTO public.who_global_data VALUES (35056, 170, 2663, 1, 40, 148, 207);
INSERT INTO public.who_global_data VALUES (35057, 376, 6635, 4, 107, 148, 166);
INSERT INTO public.who_global_data VALUES (35058, 8242, 589305, 58, 6895, 148, 126);
INSERT INTO public.who_global_data VALUES (35059, 0, 0, 0, 0, 148, 97);
INSERT INTO public.who_global_data VALUES (35060, 14, 628, 0, 5, 148, 36);
INSERT INTO public.who_global_data VALUES (35061, 0, 0, 0, 0, 148, 125);
INSERT INTO public.who_global_data VALUES (35062, 190, 4291, 2, 48, 148, 124);
INSERT INTO public.who_global_data VALUES (35063, 3144, 148756, 53, 3076, 148, 185);
INSERT INTO public.who_global_data VALUES (35064, 930, 76911, 5, 398, 148, 194);
INSERT INTO public.who_global_data VALUES (35065, 0, 509, 0, 21, 148, 144);
INSERT INTO public.who_global_data VALUES (35066, 31988, 6304181, 1101, 189709, 148, 19);
INSERT INTO public.who_global_data VALUES (35067, 6, 1197, 0, 18, 148, 217);
INSERT INTO public.who_global_data VALUES (35068, 29, 1741, 0, 45, 148, 148);
INSERT INTO public.who_global_data VALUES (35069, 767, 45927, 7, 375, 148, 86);
INSERT INTO public.who_global_data VALUES (35070, 0, 0, 0, 0, 148, 13);
INSERT INTO public.who_global_data VALUES (35071, 1188, 56751, 8, 452, 148, 157);
INSERT INTO public.who_global_data VALUES (35072, 0, 1059, 0, 35, 148, 8);
INSERT INTO public.who_global_data VALUES (35073, 0, 0, 0, 0, 148, 73);
INSERT INTO public.who_global_data VALUES (35074, 4, 2007, 4, 581, 148, 101);
INSERT INTO public.who_global_data VALUES (35075, 102, 13214, 0, 300, 148, 165);
INSERT INTO public.who_global_data VALUES (35076, 24, 7453, 0, 222, 148, 14);
INSERT INTO public.who_global_data VALUES (35077, 28, 38658, 0, 1424, 149, 193);
INSERT INTO public.who_global_data VALUES (35078, 151, 10704, 1, 322, 149, 113);
INSERT INTO public.who_global_data VALUES (35079, 278, 47216, 10, 1581, 149, 143);
INSERT INTO public.who_global_data VALUES (35080, 0, 0, 0, 0, 149, 219);
INSERT INTO public.who_global_data VALUES (35081, 40, 1301, 0, 53, 149, 186);
INSERT INTO public.who_global_data VALUES (35082, 59, 3092, 2, 126, 149, 52);
INSERT INTO public.who_global_data VALUES (35083, 0, 3, 0, 0, 149, 180);
INSERT INTO public.who_global_data VALUES (35084, 0, 95, 0, 3, 149, 167);
INSERT INTO public.who_global_data VALUES (35085, 12027, 500034, 278, 10457, 149, 154);
INSERT INTO public.who_global_data VALUES (35086, 174, 44639, 1, 901, 149, 94);
INSERT INTO public.who_global_data VALUES (35087, 107, 2589, 0, 15, 149, 66);
INSERT INTO public.who_global_data VALUES (35088, 91, 26465, 11, 781, 149, 58);
INSERT INTO public.who_global_data VALUES (35089, 754, 30954, 0, 747, 149, 163);
INSERT INTO public.who_global_data VALUES (35090, 175, 37732, 3, 555, 149, 37);
INSERT INTO public.who_global_data VALUES (35091, 72, 2657, 4, 63, 149, 142);
INSERT INTO public.who_global_data VALUES (35092, 672, 57450, 1, 203, 149, 83);
INSERT INTO public.who_global_data VALUES (35093, 1827, 331078, 41, 4593, 149, 228);
INSERT INTO public.who_global_data VALUES (35094, 0, 180, 0, 7, 149, 188);
INSERT INTO public.who_global_data VALUES (35095, 194, 73402, 5, 726, 149, 62);
INSERT INTO public.who_global_data VALUES (35096, 1024, 91964, 2, 9910, 149, 160);
INSERT INTO public.who_global_data VALUES (35097, 54, 1361, 0, 16, 149, 50);
INSERT INTO public.who_global_data VALUES (35098, 0, 2242, 0, 40, 149, 33);
INSERT INTO public.who_global_data VALUES (35099, 2, 177, 0, 9, 149, 183);
INSERT INTO public.who_global_data VALUES (35100, 0, 234, 0, 0, 149, 92);
INSERT INTO public.who_global_data VALUES (35101, 704, 122308, 43, 7097, 149, 158);
INSERT INTO public.who_global_data VALUES (35102, 0, 10, 0, 0, 149, 67);
INSERT INTO public.who_global_data VALUES (35103, 295, 22254, 6, 668, 149, 57);
INSERT INTO public.who_global_data VALUES (35104, 0, 2126, 0, 9, 149, 38);
INSERT INTO public.who_global_data VALUES (35105, 14279, 4162073, 504, 127464, 149, 141);
INSERT INTO public.who_global_data VALUES (35106, 0, 63, 0, 1, 149, 178);
INSERT INTO public.who_global_data VALUES (35107, 0, 145, 0, 3, 149, 108);
INSERT INTO public.who_global_data VALUES (35108, 122, 17435, 10, 702, 149, 39);
INSERT INTO public.who_global_data VALUES (35109, 3, 1466, 0, 56, 149, 2);
INSERT INTO public.who_global_data VALUES (35110, 3, 469, 0, 1, 149, 195);
INSERT INTO public.who_global_data VALUES (35111, 73, 4473, 1, 43, 149, 107);
INSERT INTO public.who_global_data VALUES (35112, 0, 274, 0, 0, 149, 161);
INSERT INTO public.who_global_data VALUES (35113, 0, 19848, 0, 415, 149, 212);
INSERT INTO public.who_global_data VALUES (35114, 1606, 133748, 7, 9153, 149, 181);
INSERT INTO public.who_global_data VALUES (35115, 0, 205, 0, 1, 149, 53);
INSERT INTO public.who_global_data VALUES (35116, 0, 4736, 0, 62, 149, 164);
INSERT INTO public.who_global_data VALUES (35117, 3, 1048, 0, 79, 149, 140);
INSERT INTO public.who_global_data VALUES (35118, 1486, 427027, 20, 11702, 149, 20);
INSERT INTO public.who_global_data VALUES (35119, 13, 90595, 0, 4740, 149, 112);
INSERT INTO public.who_global_data VALUES (35120, 7665, 679513, 202, 21817, 149, 111);
INSERT INTO public.who_global_data VALUES (35121, 0, 456, 0, 7, 149, 71);
INSERT INTO public.who_global_data VALUES (35122, 0, 4891, 0, 82, 149, 218);
INSERT INTO public.who_global_data VALUES (35123, 0, 0, 0, 0, 149, 43);
INSERT INTO public.who_global_data VALUES (35124, 1117, 49897, 21, 531, 149, 49);
INSERT INTO public.who_global_data VALUES (35125, 37, 18815, 0, 119, 149, 1);
INSERT INTO public.who_global_data VALUES (35126, 341, 12626, 3, 206, 149, 48);
INSERT INTO public.who_global_data VALUES (35127, 82, 4459, 0, 104, 149, 232);
INSERT INTO public.who_global_data VALUES (35128, 9, 116, 0, 1, 149, 175);
INSERT INTO public.who_global_data VALUES (35129, 3, 1514, 0, 21, 149, 21);
INSERT INTO public.who_global_data VALUES (35130, 1159, 31036, 3, 444, 149, 156);
INSERT INTO public.who_global_data VALUES (35131, 0, 0, 0, 0, 149, 95);
INSERT INTO public.who_global_data VALUES (35132, 32, 10323, 0, 260, 149, 177);
INSERT INTO public.who_global_data VALUES (35133, 251, 18607, 0, 628, 149, 210);
INSERT INTO public.who_global_data VALUES (35134, 3, 5391, 0, 61, 149, 120);
INSERT INTO public.who_global_data VALUES (35135, 2, 24, 0, 0, 149, 135);
INSERT INTO public.who_global_data VALUES (35136, 806, 100937, 25, 1914, 149, 206);
INSERT INTO public.who_global_data VALUES (35137, 1409, 112166, 74, 10701, 149, 189);
INSERT INTO public.who_global_data VALUES (35138, 175, 100403, 17, 5577, 149, 129);
INSERT INTO public.who_global_data VALUES (35139, 91, 26602, 5, 770, 149, 121);
INSERT INTO public.who_global_data VALUES (35140, 5, 4990, 0, 83, 149, 59);
INSERT INTO public.who_global_data VALUES (35141, 0, 341, 0, 0, 149, 96);
INSERT INTO public.who_global_data VALUES (35142, 22, 2585, 0, 64, 149, 41);
INSERT INTO public.who_global_data VALUES (35143, 32, 4936, 1, 97, 149, 216);
INSERT INTO public.who_global_data VALUES (35144, 916, 61700, 17, 966, 149, 236);
INSERT INTO public.who_global_data VALUES (35145, 0, 13, 0, 0, 149, 150);
INSERT INTO public.who_global_data VALUES (35146, 1, 415, 0, 0, 149, 61);
INSERT INTO public.who_global_data VALUES (35147, 0, 32, 0, 2, 149, 7);
INSERT INTO public.who_global_data VALUES (35148, 93, 8430, 1, 337, 149, 169);
INSERT INTO public.who_global_data VALUES (35149, 8294, 325400, 29, 30636, 149, 28);
INSERT INTO public.who_global_data VALUES (35150, 31, 9418, 0, 62, 149, 85);
INSERT INTO public.who_global_data VALUES (35151, 37, 857, 0, 0, 149, 211);
INSERT INTO public.who_global_data VALUES (35152, 13, 8621, 0, 53, 149, 60);
INSERT INTO public.who_global_data VALUES (35153, 18, 3293, 0, 99, 149, 3);
INSERT INTO public.who_global_data VALUES (35154, 57, 1830, 0, 19, 149, 11);
INSERT INTO public.who_global_data VALUES (35155, 1892, 255366, 3, 9341, 149, 89);
INSERT INTO public.who_global_data VALUES (35156, 0, 45012, 0, 283, 149, 24);
INSERT INTO public.who_global_data VALUES (35157, 5, 320, 0, 0, 149, 162);
INSERT INTO public.who_global_data VALUES (35158, 248, 12080, 3, 293, 149, 100);
INSERT INTO public.who_global_data VALUES (35159, 0, 14, 0, 0, 149, 47);
INSERT INTO public.who_global_data VALUES (35160, 0, 24, 0, 0, 149, 29);
INSERT INTO public.who_global_data VALUES (35161, 0, 2287, 0, 23, 149, 40);
INSERT INTO public.who_global_data VALUES (35162, 45, 1758, 2, 21, 149, 222);
INSERT INTO public.who_global_data VALUES (35163, 901, 79622, 7, 2897, 149, 132);
INSERT INTO public.who_global_data VALUES (35164, 0, 253, 0, 13, 149, 130);
INSERT INTO public.who_global_data VALUES (35165, 37, 9885, 0, 63, 149, 234);
INSERT INTO public.who_global_data VALUES (35166, 30, 2275, 1, 39, 149, 23);
INSERT INTO public.who_global_data VALUES (35167, 53, 1613, 1, 48, 149, 192);
INSERT INTO public.who_global_data VALUES (35168, 14, 8376, 0, 214, 149, 69);
INSERT INTO public.who_global_data VALUES (35169, 0, 12, 0, 0, 149, 187);
INSERT INTO public.who_global_data VALUES (35170, 404, 65218, 11, 2034, 149, 230);
INSERT INTO public.who_global_data VALUES (35171, 411, 9715, 2, 628, 149, 77);
INSERT INTO public.who_global_data VALUES (35172, 3, 2153, 0, 10, 149, 9);
INSERT INTO public.who_global_data VALUES (35173, 95735, 4465863, 1172, 75062, 149, 74);
INSERT INTO public.who_global_data VALUES (35174, 3307, 203342, 106, 8336, 149, 224);
INSERT INTO public.who_global_data VALUES (35175, 2313, 393425, 127, 22669, 149, 199);
INSERT INTO public.who_global_data VALUES (35176, 4243, 273821, 75, 7732, 149, 190);
INSERT INTO public.who_global_data VALUES (35177, 84, 30164, 3, 1781, 149, 12);
INSERT INTO public.who_global_data VALUES (35178, 0, 337, 0, 24, 149, 104);
INSERT INTO public.who_global_data VALUES (35179, 3489, 138204, 20, 1074, 149, 153);
INSERT INTO public.who_global_data VALUES (35180, 1430, 281583, 14, 35577, 149, 91);
INSERT INTO public.who_global_data VALUES (35181, 140, 3323, 2, 36, 149, 215);
INSERT INTO public.who_global_data VALUES (35182, 495, 73221, 13, 1406, 149, 84);
INSERT INTO public.who_global_data VALUES (35183, 0, 385, 0, 32, 149, 231);
INSERT INTO public.who_global_data VALUES (35184, 78, 2727, 0, 19, 149, 196);
INSERT INTO public.who_global_data VALUES (35185, 430, 135589, 0, 1948, 149, 105);
INSERT INTO public.who_global_data VALUES (35186, 104, 35460, 8, 607, 149, 122);
INSERT INTO public.who_global_data VALUES (35187, 0, 0, 0, 0, 149, 159);
INSERT INTO public.who_global_data VALUES (35188, 76, 14334, 6, 564, 149, 75);
INSERT INTO public.who_global_data VALUES (35189, 838, 92082, 4, 552, 149, 27);
INSERT INTO public.who_global_data VALUES (35190, 71, 44684, 0, 1063, 149, 54);
INSERT INTO public.who_global_data VALUES (35191, 0, 22, 0, 0, 149, 226);
INSERT INTO public.who_global_data VALUES (35192, 11, 1443, 0, 35, 149, 79);
INSERT INTO public.who_global_data VALUES (35193, 553, 21877, 5, 212, 149, 56);
INSERT INTO public.who_global_data VALUES (35194, 0, 1164, 0, 31, 149, 117);
INSERT INTO public.who_global_data VALUES (35195, 0, 1311, 0, 82, 149, 152);
INSERT INTO public.who_global_data VALUES (35196, 477, 20939, 15, 339, 149, 16);
INSERT INTO public.who_global_data VALUES (35197, 0, 109, 0, 1, 149, 10);
INSERT INTO public.who_global_data VALUES (35198, 36, 3194, 0, 86, 149, 201);
INSERT INTO public.who_global_data VALUES (35199, 49, 7023, 0, 124, 149, 174);
INSERT INTO public.who_global_data VALUES (35200, 85, 15520, 0, 206, 149, 119);
INSERT INTO public.who_global_data VALUES (35201, 23, 5653, 0, 176, 149, 168);
INSERT INTO public.who_global_data VALUES (35202, 24, 9583, 0, 128, 149, 99);
INSERT INTO public.who_global_data VALUES (35203, 93, 8834, 2, 31, 149, 171);
INSERT INTO public.who_global_data VALUES (35204, 16, 2898, 1, 128, 149, 87);
INSERT INTO public.who_global_data VALUES (35205, 42, 2205, 0, 14, 149, 123);
INSERT INTO public.who_global_data VALUES (35206, 0, 0, 0, 0, 149, 151);
INSERT INTO public.who_global_data VALUES (35207, 181, 939, 0, 18, 149, 213);
INSERT INTO public.who_global_data VALUES (35208, 38, 7202, 1, 161, 149, 118);
INSERT INTO public.who_global_data VALUES (35209, 0, 357, 0, 10, 149, 134);
INSERT INTO public.who_global_data VALUES (35210, 0, 3374, 0, 40, 149, 65);
INSERT INTO public.who_global_data VALUES (35211, 5351, 642860, 703, 68484, 149, 102);
INSERT INTO public.who_global_data VALUES (35212, 0, 0, 0, 0, 149, 223);
INSERT INTO public.who_global_data VALUES (35213, 5, 164, 0, 1, 149, 4);
INSERT INTO public.who_global_data VALUES (35214, 0, 310, 0, 0, 149, 146);
INSERT INTO public.who_global_data VALUES (35215, 169, 6334, 0, 114, 149, 31);
INSERT INTO public.who_global_data VALUES (35216, 0, 13, 0, 1, 149, 127);
INSERT INTO public.who_global_data VALUES (35217, 2157, 77878, 26, 1453, 149, 22);
INSERT INTO public.who_global_data VALUES (35218, 117, 4764, 0, 28, 149, 115);
INSERT INTO public.who_global_data VALUES (35219, 202, 2009, 2, 14, 149, 106);
INSERT INTO public.who_global_data VALUES (35220, 180, 9108, 4, 93, 149, 90);
INSERT INTO public.who_global_data VALUES (35221, 0, 0, 0, 0, 149, 70);
INSERT INTO public.who_global_data VALUES (35222, 1081, 49219, 6, 312, 149, 46);
INSERT INTO public.who_global_data VALUES (35223, 1140, 77588, 2, 6245, 149, 139);
INSERT INTO public.who_global_data VALUES (35224, 0, 26, 0, 0, 149, 42);
INSERT INTO public.who_global_data VALUES (35225, 4, 1441, 0, 24, 149, 80);
INSERT INTO public.who_global_data VALUES (35226, 0, 3877, 0, 144, 149, 203);
INSERT INTO public.who_global_data VALUES (35227, 0, 1178, 0, 69, 149, 136);
INSERT INTO public.who_global_data VALUES (35228, 176, 55632, 3, 1070, 149, 63);
INSERT INTO public.who_global_data VALUES (35229, 0, 0, 0, 0, 149, 17);
INSERT INTO public.who_global_data VALUES (35230, 0, 59, 0, 2, 149, 172);
INSERT INTO public.who_global_data VALUES (35231, 67, 15293, 3, 634, 149, 109);
INSERT INTO public.who_global_data VALUES (35232, 105, 11624, 0, 264, 149, 200);
INSERT INTO public.who_global_data VALUES (35233, 696, 36214, 2, 217, 149, 93);
INSERT INTO public.who_global_data VALUES (35234, 349, 87939, 9, 751, 149, 5);
INSERT INTO public.who_global_data VALUES (35235, 0, 741, 0, 13, 149, 214);
INSERT INTO public.who_global_data VALUES (35236, 196, 299855, 6, 6365, 149, 204);
INSERT INTO public.who_global_data VALUES (35237, 0, 0, 0, 0, 149, 198);
INSERT INTO public.who_global_data VALUES (35238, 829, 98407, 8, 2107, 149, 173);
INSERT INTO public.who_global_data VALUES (35239, 1, 504, 0, 5, 149, 229);
INSERT INTO public.who_global_data VALUES (35240, 861, 24214, 14, 463, 149, 76);
INSERT INTO public.who_global_data VALUES (35241, 4615, 696190, 147, 30123, 149, 138);
INSERT INTO public.who_global_data VALUES (35242, 3156, 245143, 70, 3986, 149, 98);
INSERT INTO public.who_global_data VALUES (35243, 0, 0, 0, 0, 149, 103);
INSERT INTO public.who_global_data VALUES (35244, 421, 71947, 11, 2147, 149, 225);
INSERT INTO public.who_global_data VALUES (35245, 646, 61541, 3, 1849, 149, 131);
INSERT INTO public.who_global_data VALUES (35246, 3, 35507, 18, 500, 149, 235);
INSERT INTO public.who_global_data VALUES (35247, 267, 120846, 0, 205, 149, 137);
INSERT INTO public.who_global_data VALUES (35248, 155, 21743, 2, 346, 149, 81);
INSERT INTO public.who_global_data VALUES (35249, 588, 41144, 9, 1096, 149, 182);
INSERT INTO public.who_global_data VALUES (35250, 70, 2416, 1, 9, 149, 145);
INSERT INTO public.who_global_data VALUES (35251, 1271, 98304, 51, 4018, 149, 26);
INSERT INTO public.who_global_data VALUES (35252, 5363, 1046370, 128, 18263, 149, 170);
INSERT INTO public.who_global_data VALUES (35253, 21, 4460, 1, 21, 149, 191);
INSERT INTO public.who_global_data VALUES (35254, 0, 5, 0, 0, 149, 221);
INSERT INTO public.who_global_data VALUES (35255, 0, 18, 0, 0, 149, 64);
INSERT INTO public.who_global_data VALUES (35256, 0, 0, 0, 0, 149, 116);
INSERT INTO public.who_global_data VALUES (35257, 0, 17, 0, 0, 149, 128);
INSERT INTO public.who_global_data VALUES (35258, 1, 27, 0, 0, 149, 6);
INSERT INTO public.who_global_data VALUES (35259, 0, 239, 0, 6, 149, 227);
INSERT INTO public.who_global_data VALUES (35260, 1, 10, 0, 0, 149, 68);
INSERT INTO public.who_global_data VALUES (35261, 0, 62, 0, 0, 149, 184);
INSERT INTO public.who_global_data VALUES (35262, 0, 0, 0, 0, 149, 82);
INSERT INTO public.who_global_data VALUES (35263, 0, 735, 0, 42, 149, 149);
INSERT INTO public.who_global_data VALUES (35264, 0, 898, 0, 15, 149, 197);
INSERT INTO public.who_global_data VALUES (35265, 775, 323012, 28, 4165, 149, 78);
INSERT INTO public.who_global_data VALUES (35266, 88, 14102, 2, 293, 149, 233);
INSERT INTO public.who_global_data VALUES (35267, 84, 32078, 1, 728, 149, 133);
INSERT INTO public.who_global_data VALUES (35268, 0, 135, 0, 0, 149, 35);
INSERT INTO public.who_global_data VALUES (35269, 3, 2067, 0, 72, 149, 114);
INSERT INTO public.who_global_data VALUES (35270, 75, 57166, 0, 27, 149, 237);
INSERT INTO public.who_global_data VALUES (35271, 0, 10, 0, 0, 149, 55);
INSERT INTO public.who_global_data VALUES (35272, 11, 527, 0, 19, 149, 176);
INSERT INTO public.who_global_data VALUES (35273, 161, 4888, 0, 37, 149, 202);
INSERT INTO public.who_global_data VALUES (35274, 78, 3391, 0, 135, 149, 155);
INSERT INTO public.who_global_data VALUES (35275, 0, 0, 0, 0, 149, 32);
INSERT INTO public.who_global_data VALUES (35276, 9, 3371, 0, 97, 149, 220);
INSERT INTO public.who_global_data VALUES (35277, 1990, 642431, 82, 15168, 149, 30);
INSERT INTO public.who_global_data VALUES (35278, 0, 2555, -1, 48, 149, 147);
INSERT INTO public.who_global_data VALUES (35279, 12097, 582902, 83, 31539, 149, 208);
INSERT INTO public.who_global_data VALUES (35280, 7, 3147, 0, 12, 149, 45);
INSERT INTO public.who_global_data VALUES (35281, 0, 13470, 0, 834, 149, 110);
INSERT INTO public.who_global_data VALUES (35282, 59, 4419, 0, 91, 149, 88);
INSERT INTO public.who_global_data VALUES (35283, 236, 85988, 1, 5842, 149, 51);
INSERT INTO public.who_global_data VALUES (35284, 462, 46018, 7, 1781, 149, 209);
INSERT INTO public.who_global_data VALUES (35285, 62, 3351, 3, 143, 149, 205);
INSERT INTO public.who_global_data VALUES (35286, 39, 8899, 1, 71, 149, 18);
INSERT INTO public.who_global_data VALUES (35287, 7, 3454, 0, 58, 149, 72);
INSERT INTO public.who_global_data VALUES (35288, 2659, 355223, 8, 41594, 149, 44);
INSERT INTO public.who_global_data VALUES (35289, 0, 27, 0, 0, 149, 15);
INSERT INTO public.who_global_data VALUES (35290, 35, 1528, 3, 36, 149, 25);
INSERT INTO public.who_global_data VALUES (35291, 0, 0, 0, 0, 149, 179);
INSERT INTO public.who_global_data VALUES (35292, 0, 0, 0, 0, 149, 34);
INSERT INTO public.who_global_data VALUES (35293, 146, 2493, 1, 39, 149, 207);
INSERT INTO public.who_global_data VALUES (35294, 377, 6259, 4, 103, 149, 166);
INSERT INTO public.who_global_data VALUES (35295, 8403, 581063, 55, 6837, 149, 126);
INSERT INTO public.who_global_data VALUES (35296, 0, 0, 0, 0, 149, 97);
INSERT INTO public.who_global_data VALUES (35297, 15, 614, 0, 5, 149, 36);
INSERT INTO public.who_global_data VALUES (35298, 0, 0, 0, 0, 149, 125);
INSERT INTO public.who_global_data VALUES (35299, 201, 4101, 0, 46, 149, 124);
INSERT INTO public.who_global_data VALUES (35300, 2582, 145612, 44, 3023, 149, 185);
INSERT INTO public.who_global_data VALUES (35301, 883, 75981, 2, 393, 149, 194);
INSERT INTO public.who_global_data VALUES (35302, 0, 509, 0, 21, 149, 144);
INSERT INTO public.who_global_data VALUES (35303, 23204, 6272193, 436, 188608, 149, 19);
INSERT INTO public.who_global_data VALUES (35304, 0, 1191, 0, 18, 149, 217);
INSERT INTO public.who_global_data VALUES (35305, 19, 1712, 0, 45, 149, 148);
INSERT INTO public.who_global_data VALUES (35306, 603, 45160, 6, 368, 149, 86);
INSERT INTO public.who_global_data VALUES (35307, 0, 0, 0, 0, 149, 13);
INSERT INTO public.who_global_data VALUES (35308, 1213, 55563, 8, 444, 149, 157);
INSERT INTO public.who_global_data VALUES (35309, 5, 1059, 0, 35, 149, 8);
INSERT INTO public.who_global_data VALUES (35310, 0, 0, 0, 0, 149, 73);
INSERT INTO public.who_global_data VALUES (35311, 5, 2003, 0, 577, 149, 101);
INSERT INTO public.who_global_data VALUES (35312, 160, 13112, 3, 300, 149, 165);
INSERT INTO public.who_global_data VALUES (35313, 41, 7429, 4, 222, 149, 14);
INSERT INTO public.who_global_data VALUES (35314, 24, 38630, 2, 1424, 150, 193);
INSERT INTO public.who_global_data VALUES (35315, 147, 10553, 2, 321, 150, 113);
INSERT INTO public.who_global_data VALUES (35316, 285, 46938, 9, 1571, 150, 143);
INSERT INTO public.who_global_data VALUES (35317, 0, 0, 0, 0, 150, 219);
INSERT INTO public.who_global_data VALUES (35318, 0, 1261, 0, 53, 150, 186);
INSERT INTO public.who_global_data VALUES (35319, 52, 3033, 4, 124, 150, 52);
INSERT INTO public.who_global_data VALUES (35320, 0, 3, 0, 0, 150, 180);
INSERT INTO public.who_global_data VALUES (35321, 0, 95, 0, 3, 150, 167);
INSERT INTO public.who_global_data VALUES (35322, 9215, 488007, 267, 10179, 150, 154);
INSERT INTO public.who_global_data VALUES (35323, 199, 44465, 2, 900, 150, 94);
INSERT INTO public.who_global_data VALUES (35324, 33, 2482, 1, 15, 150, 66);
INSERT INTO public.who_global_data VALUES (35325, 52, 26374, 8, 770, 150, 58);
INSERT INTO public.who_global_data VALUES (35326, 495, 30200, 1, 747, 150, 163);
INSERT INTO public.who_global_data VALUES (35327, 139, 37557, 1, 552, 150, 37);
INSERT INTO public.who_global_data VALUES (35328, 39, 2585, 1, 59, 150, 142);
INSERT INTO public.who_global_data VALUES (35329, 702, 56778, 2, 202, 150, 83);
INSERT INTO public.who_global_data VALUES (35330, 1892, 329251, 36, 4552, 150, 228);
INSERT INTO public.who_global_data VALUES (35331, 1, 180, 0, 7, 150, 188);
INSERT INTO public.who_global_data VALUES (35332, 177, 73208, 5, 721, 150, 62);
INSERT INTO public.who_global_data VALUES (35333, 871, 90940, 3, 9908, 150, 160);
INSERT INTO public.who_global_data VALUES (35334, 46, 1307, 1, 16, 150, 50);
INSERT INTO public.who_global_data VALUES (35335, 29, 2242, 0, 40, 150, 33);
INSERT INTO public.who_global_data VALUES (35336, 0, 175, 0, 9, 150, 183);
INSERT INTO public.who_global_data VALUES (35337, 1, 234, 0, 0, 150, 92);
INSERT INTO public.who_global_data VALUES (35338, 835, 121604, 46, 7054, 150, 158);
INSERT INTO public.who_global_data VALUES (35339, 0, 10, 0, 0, 150, 67);
INSERT INTO public.who_global_data VALUES (35340, 303, 21959, 5, 662, 150, 57);
INSERT INTO public.who_global_data VALUES (35341, 0, 2126, 0, 9, 150, 38);
INSERT INTO public.who_global_data VALUES (35342, 10273, 4147794, 310, 126960, 150, 141);
INSERT INTO public.who_global_data VALUES (35343, 0, 63, 0, 1, 150, 178);
INSERT INTO public.who_global_data VALUES (35344, 0, 145, 0, 3, 150, 108);
INSERT INTO public.who_global_data VALUES (35345, 167, 17313, 15, 692, 150, 39);
INSERT INTO public.who_global_data VALUES (35346, 11, 1463, 1, 56, 150, 2);
INSERT INTO public.who_global_data VALUES (35347, 0, 466, 0, 1, 150, 195);
INSERT INTO public.who_global_data VALUES (35348, 42, 4400, 0, 42, 150, 107);
INSERT INTO public.who_global_data VALUES (35349, 0, 274, 0, 0, 150, 161);
INSERT INTO public.who_global_data VALUES (35350, 0, 19848, 0, 415, 150, 212);
INSERT INTO public.who_global_data VALUES (35351, 247, 132142, 1, 9146, 150, 181);
INSERT INTO public.who_global_data VALUES (35352, 0, 205, 0, 1, 150, 53);
INSERT INTO public.who_global_data VALUES (35353, 7, 4736, 0, 62, 150, 164);
INSERT INTO public.who_global_data VALUES (35354, 5, 1045, 0, 79, 150, 140);
INSERT INTO public.who_global_data VALUES (35355, 1267, 425541, 30, 11682, 150, 20);
INSERT INTO public.who_global_data VALUES (35356, 9, 90582, 1, 4740, 150, 112);
INSERT INTO public.who_global_data VALUES (35357, 5327, 671848, 203, 21615, 150, 111);
INSERT INTO public.who_global_data VALUES (35358, 8, 456, 0, 7, 150, 71);
INSERT INTO public.who_global_data VALUES (35359, 0, 4891, 0, 82, 150, 218);
INSERT INTO public.who_global_data VALUES (35360, 0, 0, 0, 0, 150, 43);
INSERT INTO public.who_global_data VALUES (35361, 833, 48780, 19, 510, 150, 49);
INSERT INTO public.who_global_data VALUES (35362, 77, 18778, 0, 119, 150, 1);
INSERT INTO public.who_global_data VALUES (35363, 204, 12285, 2, 203, 150, 48);
INSERT INTO public.who_global_data VALUES (35364, 25, 4377, 2, 104, 150, 232);
INSERT INTO public.who_global_data VALUES (35365, 15, 107, 0, 1, 150, 175);
INSERT INTO public.who_global_data VALUES (35366, 1, 1511, 0, 21, 150, 21);
INSERT INTO public.who_global_data VALUES (35367, 1161, 29877, 4, 441, 150, 156);
INSERT INTO public.who_global_data VALUES (35368, 0, 0, 0, 0, 150, 95);
INSERT INTO public.who_global_data VALUES (35369, 59, 10291, 0, 260, 150, 177);
INSERT INTO public.who_global_data VALUES (35370, 243, 18356, 0, 628, 150, 210);
INSERT INTO public.who_global_data VALUES (35371, 0, 5388, 0, 61, 150, 120);
INSERT INTO public.who_global_data VALUES (35372, 0, 22, 0, 0, 150, 135);
INSERT INTO public.who_global_data VALUES (35373, 233, 100131, 25, 1889, 150, 206);
INSERT INTO public.who_global_data VALUES (35374, 665, 110757, 51, 10627, 150, 189);
INSERT INTO public.who_global_data VALUES (35375, 187, 100228, 19, 5560, 150, 129);
INSERT INTO public.who_global_data VALUES (35376, 98, 26511, 1, 765, 150, 121);
INSERT INTO public.who_global_data VALUES (35377, 0, 4985, 0, 83, 150, 59);
INSERT INTO public.who_global_data VALUES (35378, 11, 341, 0, 0, 150, 96);
INSERT INTO public.who_global_data VALUES (35379, 32, 2563, 0, 64, 150, 41);
INSERT INTO public.who_global_data VALUES (35380, 20, 4904, 2, 96, 150, 216);
INSERT INTO public.who_global_data VALUES (35381, 1136, 60784, 16, 949, 150, 236);
INSERT INTO public.who_global_data VALUES (35382, 0, 13, 0, 0, 150, 150);
INSERT INTO public.who_global_data VALUES (35383, 1, 414, 0, 0, 150, 61);
INSERT INTO public.who_global_data VALUES (35384, 1, 32, 0, 2, 150, 7);
INSERT INTO public.who_global_data VALUES (35385, 10, 8337, 0, 336, 150, 169);
INSERT INTO public.who_global_data VALUES (35386, 5519, 317106, 35, 30607, 150, 28);
INSERT INTO public.who_global_data VALUES (35387, 32, 9387, 0, 62, 150, 85);
INSERT INTO public.who_global_data VALUES (35388, 47, 820, 0, 0, 150, 211);
INSERT INTO public.who_global_data VALUES (35389, 0, 8608, 0, 53, 150, 60);
INSERT INTO public.who_global_data VALUES (35390, 79, 3275, 0, 99, 150, 3);
INSERT INTO public.who_global_data VALUES (35391, 44, 1773, 0, 19, 150, 11);
INSERT INTO public.who_global_data VALUES (35392, 1176, 253474, 9, 9338, 150, 89);
INSERT INTO public.who_global_data VALUES (35393, 235, 45012, 0, 283, 150, 24);
INSERT INTO public.who_global_data VALUES (35394, 0, 315, 0, 0, 150, 162);
INSERT INTO public.who_global_data VALUES (35395, 169, 11832, 1, 290, 150, 100);
INSERT INTO public.who_global_data VALUES (35396, 0, 14, 0, 0, 150, 47);
INSERT INTO public.who_global_data VALUES (35397, 0, 24, 0, 0, 150, 29);
INSERT INTO public.who_global_data VALUES (35398, 924, 2287, 3, 23, 150, 40);
INSERT INTO public.who_global_data VALUES (35399, 41, 1713, 1, 19, 150, 222);
INSERT INTO public.who_global_data VALUES (35400, 893, 78721, 28, 2890, 150, 132);
INSERT INTO public.who_global_data VALUES (35401, 1, 253, 0, 13, 150, 130);
INSERT INTO public.who_global_data VALUES (35402, 32, 9848, 1, 63, 150, 234);
INSERT INTO public.who_global_data VALUES (35403, 0, 2245, 0, 38, 150, 23);
INSERT INTO public.who_global_data VALUES (35404, 92, 1560, 1, 47, 150, 192);
INSERT INTO public.who_global_data VALUES (35405, 2, 8362, 0, 214, 150, 69);
INSERT INTO public.who_global_data VALUES (35406, 0, 12, 0, 0, 150, 187);
INSERT INTO public.who_global_data VALUES (35407, 50, 64814, 16, 2023, 150, 230);
INSERT INTO public.who_global_data VALUES (35408, 341, 9304, 1, 626, 150, 77);
INSERT INTO public.who_global_data VALUES (35409, 7, 2150, 0, 10, 150, 9);
INSERT INTO public.who_global_data VALUES (35410, 89706, 4370128, 1115, 73890, 150, 74);
INSERT INTO public.who_global_data VALUES (35411, 3046, 200035, 100, 8230, 150, 224);
INSERT INTO public.who_global_data VALUES (35412, 2302, 391112, 132, 22542, 150, 199);
INSERT INTO public.who_global_data VALUES (35413, 4894, 269578, 68, 7657, 150, 190);
INSERT INTO public.who_global_data VALUES (35414, 306, 30080, 1, 1778, 150, 12);
INSERT INTO public.who_global_data VALUES (35415, 0, 337, 0, 24, 150, 104);
INSERT INTO public.who_global_data VALUES (35416, 3388, 134715, 17, 1054, 150, 153);
INSERT INTO public.who_global_data VALUES (35417, 1369, 280153, 10, 35563, 150, 91);
INSERT INTO public.who_global_data VALUES (35418, 80, 3183, 1, 34, 150, 215);
INSERT INTO public.who_global_data VALUES (35419, 492, 72726, 16, 1393, 150, 84);
INSERT INTO public.who_global_data VALUES (35420, 1, 385, 0, 32, 150, 231);
INSERT INTO public.who_global_data VALUES (35421, 103, 2649, 2, 19, 150, 196);
INSERT INTO public.who_global_data VALUES (35422, 523, 135159, 0, 1948, 150, 105);
INSERT INTO public.who_global_data VALUES (35423, 151, 35356, 0, 599, 150, 122);
INSERT INTO public.who_global_data VALUES (35424, 0, 0, 0, 0, 150, 159);
INSERT INTO public.who_global_data VALUES (35425, 97, 14258, 0, 558, 150, 75);
INSERT INTO public.who_global_data VALUES (35426, 857, 91244, 2, 548, 150, 27);
INSERT INTO public.who_global_data VALUES (35427, 87, 44613, 1, 1063, 150, 54);
INSERT INTO public.who_global_data VALUES (35428, 0, 22, 0, 0, 150, 226);
INSERT INTO public.who_global_data VALUES (35429, 3, 1432, 0, 35, 150, 79);
INSERT INTO public.who_global_data VALUES (35430, 498, 21324, 7, 207, 150, 56);
INSERT INTO public.who_global_data VALUES (35431, 0, 1164, 0, 31, 150, 117);
INSERT INTO public.who_global_data VALUES (35432, 0, 1311, 0, 82, 150, 152);
INSERT INTO public.who_global_data VALUES (35433, 879, 20462, 10, 324, 150, 16);
INSERT INTO public.who_global_data VALUES (35434, 1, 109, 0, 1, 150, 10);
INSERT INTO public.who_global_data VALUES (35435, 32, 3158, 0, 86, 150, 201);
INSERT INTO public.who_global_data VALUES (35436, 24, 6974, 0, 124, 150, 174);
INSERT INTO public.who_global_data VALUES (35437, 83, 15435, 4, 206, 150, 119);
INSERT INTO public.who_global_data VALUES (35438, 9, 5630, 0, 176, 150, 168);
INSERT INTO public.who_global_data VALUES (35439, 100, 9559, 0, 128, 150, 99);
INSERT INTO public.who_global_data VALUES (35440, 74, 8741, 0, 29, 150, 171);
INSERT INTO public.who_global_data VALUES (35441, 12, 2882, 0, 127, 150, 87);
INSERT INTO public.who_global_data VALUES (35442, 63, 2163, 0, 14, 150, 123);
INSERT INTO public.who_global_data VALUES (35443, 0, 0, 0, 0, 150, 151);
INSERT INTO public.who_global_data VALUES (35444, 0, 758, 0, 18, 150, 213);
INSERT INTO public.who_global_data VALUES (35445, 0, 7164, 0, 160, 150, 118);
INSERT INTO public.who_global_data VALUES (35446, 1, 357, 0, 10, 150, 134);
INSERT INTO public.who_global_data VALUES (35447, 0, 3374, 0, 40, 150, 65);
INSERT INTO public.who_global_data VALUES (35448, 3486, 637509, 223, 67781, 150, 102);
INSERT INTO public.who_global_data VALUES (35449, 0, 0, 0, 0, 150, 223);
INSERT INTO public.who_global_data VALUES (35450, 3, 159, 0, 1, 150, 4);
INSERT INTO public.who_global_data VALUES (35451, 0, 310, 0, 0, 150, 146);
INSERT INTO public.who_global_data VALUES (35452, 140, 6165, 0, 114, 150, 31);
INSERT INTO public.who_global_data VALUES (35453, 0, 13, 0, 1, 150, 127);
INSERT INTO public.who_global_data VALUES (35454, 1941, 75721, 33, 1427, 150, 22);
INSERT INTO public.who_global_data VALUES (35455, 90, 4647, 1, 28, 150, 115);
INSERT INTO public.who_global_data VALUES (35456, 197, 1807, 4, 12, 150, 106);
INSERT INTO public.who_global_data VALUES (35457, 118, 8928, -2, 89, 150, 90);
INSERT INTO public.who_global_data VALUES (35458, 0, 0, 0, 0, 150, 70);
INSERT INTO public.who_global_data VALUES (35459, 902, 48138, 6, 306, 150, 46);
INSERT INTO public.who_global_data VALUES (35460, 969, 76448, 1, 6243, 150, 139);
INSERT INTO public.who_global_data VALUES (35461, 0, 26, 0, 0, 150, 42);
INSERT INTO public.who_global_data VALUES (35462, 6, 1437, 0, 24, 150, 80);
INSERT INTO public.who_global_data VALUES (35463, 104, 3877, 3, 144, 150, 203);
INSERT INTO public.who_global_data VALUES (35464, 0, 1178, 0, 69, 150, 136);
INSERT INTO public.who_global_data VALUES (35465, 296, 55456, 6, 1067, 150, 63);
INSERT INTO public.who_global_data VALUES (35466, 0, 0, 0, 0, 150, 17);
INSERT INTO public.who_global_data VALUES (35467, 0, 59, 0, 2, 150, 172);
INSERT INTO public.who_global_data VALUES (35468, 99, 15226, 8, 631, 150, 109);
INSERT INTO public.who_global_data VALUES (35469, 132, 11519, 0, 264, 150, 200);
INSERT INTO public.who_global_data VALUES (35470, 717, 35518, 9, 215, 150, 93);
INSERT INTO public.who_global_data VALUES (35471, 262, 87590, 8, 742, 150, 5);
INSERT INTO public.who_global_data VALUES (35472, 0, 741, 0, 13, 150, 214);
INSERT INTO public.who_global_data VALUES (35473, 426, 299659, 9, 6359, 150, 204);
INSERT INTO public.who_global_data VALUES (35474, 0, 0, 0, 0, 150, 198);
INSERT INTO public.who_global_data VALUES (35475, 535, 97578, 13, 2099, 150, 173);
INSERT INTO public.who_global_data VALUES (35476, 6, 503, 0, 5, 150, 229);
INSERT INTO public.who_global_data VALUES (35477, 867, 23353, 14, 449, 150, 76);
INSERT INTO public.who_global_data VALUES (35478, 1598, 691575, 138, 29976, 150, 138);
INSERT INTO public.who_global_data VALUES (35479, 3260, 241987, 26, 3916, 150, 98);
INSERT INTO public.who_global_data VALUES (35480, 0, 0, 0, 0, 150, 103);
INSERT INTO public.who_global_data VALUES (35481, 400, 71526, 12, 2136, 150, 225);
INSERT INTO public.who_global_data VALUES (35482, 388, 60895, 3, 1846, 150, 131);
INSERT INTO public.who_global_data VALUES (35483, 129, 35504, 5, 482, 150, 235);
INSERT INTO public.who_global_data VALUES (35484, 231, 120579, 0, 205, 150, 137);
INSERT INTO public.who_global_data VALUES (35485, 156, 21588, 3, 344, 150, 81);
INSERT INTO public.who_global_data VALUES (35486, 501, 40556, 13, 1087, 150, 182);
INSERT INTO public.who_global_data VALUES (35487, 69, 2346, 0, 8, 150, 145);
INSERT INTO public.who_global_data VALUES (35488, 1136, 97033, 41, 3967, 150, 26);
INSERT INTO public.who_global_data VALUES (35489, 5218, 1041007, 142, 18135, 150, 170);
INSERT INTO public.who_global_data VALUES (35490, 30, 4439, 1, 20, 150, 191);
INSERT INTO public.who_global_data VALUES (35491, 0, 5, 0, 0, 150, 221);
INSERT INTO public.who_global_data VALUES (35492, 0, 18, 0, 0, 150, 64);
INSERT INTO public.who_global_data VALUES (35493, 0, 0, 0, 0, 150, 116);
INSERT INTO public.who_global_data VALUES (35494, 0, 17, 0, 0, 150, 128);
INSERT INTO public.who_global_data VALUES (35495, 0, 26, 0, 0, 150, 6);
INSERT INTO public.who_global_data VALUES (35496, 0, 239, 0, 6, 150, 227);
INSERT INTO public.who_global_data VALUES (35497, 0, 9, 0, 0, 150, 68);
INSERT INTO public.who_global_data VALUES (35498, 1, 62, 0, 0, 150, 184);
INSERT INTO public.who_global_data VALUES (35499, 0, 0, 0, 0, 150, 82);
INSERT INTO public.who_global_data VALUES (35500, 0, 735, 0, 42, 150, 149);
INSERT INTO public.who_global_data VALUES (35501, 0, 898, 0, 15, 150, 197);
INSERT INTO public.who_global_data VALUES (35502, 781, 322237, 30, 4137, 150, 78);
INSERT INTO public.who_global_data VALUES (35503, 27, 14014, 1, 291, 150, 233);
INSERT INTO public.who_global_data VALUES (35504, 53, 31994, 2, 727, 150, 133);
INSERT INTO public.who_global_data VALUES (35505, 0, 135, 0, 0, 150, 35);
INSERT INTO public.who_global_data VALUES (35506, 9, 2064, 1, 72, 150, 114);
INSERT INTO public.who_global_data VALUES (35507, 47, 57091, 0, 27, 150, 237);
INSERT INTO public.who_global_data VALUES (35508, 4, 10, 0, 0, 150, 55);
INSERT INTO public.who_global_data VALUES (35509, 5, 516, 0, 19, 150, 176);
INSERT INTO public.who_global_data VALUES (35510, 91, 4727, 0, 37, 150, 202);
INSERT INTO public.who_global_data VALUES (35511, 79, 3313, 1, 135, 150, 155);
INSERT INTO public.who_global_data VALUES (35512, 0, 0, 0, 0, 150, 32);
INSERT INTO public.who_global_data VALUES (35513, 0, 3362, 0, 97, 150, 220);
INSERT INTO public.who_global_data VALUES (35514, 1079, 640441, 82, 15086, 150, 30);
INSERT INTO public.who_global_data VALUES (35515, 3, 2555, 0, 49, 150, 147);
INSERT INTO public.who_global_data VALUES (35516, 7176, 570805, 80, 31456, 150, 208);
INSERT INTO public.who_global_data VALUES (35517, 17, 3140, 0, 12, 150, 45);
INSERT INTO public.who_global_data VALUES (35518, 0, 13470, 0, 834, 150, 110);
INSERT INTO public.who_global_data VALUES (35519, 14, 4360, 6, 91, 150, 88);
INSERT INTO public.who_global_data VALUES (35520, 185, 85752, 1, 5841, 150, 51);
INSERT INTO public.who_global_data VALUES (35521, 387, 45556, 1, 1774, 150, 209);
INSERT INTO public.who_global_data VALUES (35522, 60, 3289, 3, 140, 150, 205);
INSERT INTO public.who_global_data VALUES (35523, 36, 8860, 0, 70, 150, 18);
INSERT INTO public.who_global_data VALUES (35524, 1, 3447, 0, 58, 150, 72);
INSERT INTO public.who_global_data VALUES (35525, 2460, 352564, 32, 41586, 150, 44);
INSERT INTO public.who_global_data VALUES (35526, 0, 27, 0, 0, 150, 15);
INSERT INTO public.who_global_data VALUES (35527, 5, 1493, 1, 33, 150, 25);
INSERT INTO public.who_global_data VALUES (35528, 0, 0, 0, 0, 150, 179);
INSERT INTO public.who_global_data VALUES (35529, 0, 0, 0, 0, 150, 34);
INSERT INTO public.who_global_data VALUES (35530, 93, 2347, 3, 38, 150, 207);
INSERT INTO public.who_global_data VALUES (35531, 465, 5882, 3, 99, 150, 166);
INSERT INTO public.who_global_data VALUES (35532, 8491, 572660, 52, 6782, 150, 126);
INSERT INTO public.who_global_data VALUES (35533, 0, 0, 0, 0, 150, 97);
INSERT INTO public.who_global_data VALUES (35534, 0, 599, 0, 5, 150, 36);
INSERT INTO public.who_global_data VALUES (35535, 0, 0, 0, 0, 150, 125);
INSERT INTO public.who_global_data VALUES (35536, 124, 3900, 2, 46, 150, 124);
INSERT INTO public.who_global_data VALUES (35537, 2551, 143030, 45, 2979, 150, 185);
INSERT INTO public.who_global_data VALUES (35538, 644, 75098, 1, 391, 150, 194);
INSERT INTO public.who_global_data VALUES (35539, 0, 509, 0, 21, 150, 144);
INSERT INTO public.who_global_data VALUES (35540, 26015, 6248989, 169, 188172, 150, 19);
INSERT INTO public.who_global_data VALUES (35541, 1, 1191, 1, 18, 150, 217);
INSERT INTO public.who_global_data VALUES (35542, 14, 1693, 0, 45, 150, 148);
INSERT INTO public.who_global_data VALUES (35543, 450, 44557, 6, 362, 150, 86);
INSERT INTO public.who_global_data VALUES (35544, 0, 0, 0, 0, 150, 13);
INSERT INTO public.who_global_data VALUES (35545, 1061, 54350, 8, 436, 150, 157);
INSERT INTO public.who_global_data VALUES (35546, 5, 1054, 0, 35, 150, 8);
INSERT INTO public.who_global_data VALUES (35547, 0, 0, 0, 0, 150, 73);
INSERT INTO public.who_global_data VALUES (35548, 5, 1998, 3, 577, 150, 101);
INSERT INTO public.who_global_data VALUES (35549, 116, 12952, 2, 297, 150, 165);
INSERT INTO public.who_global_data VALUES (35550, 272, 7388, 10, 218, 150, 14);
INSERT INTO public.who_global_data VALUES (35551, 26, 38606, 3, 1422, 151, 193);
INSERT INTO public.who_global_data VALUES (35552, 151, 10406, 3, 319, 151, 113);
INSERT INTO public.who_global_data VALUES (35553, 289, 46653, 6, 1562, 151, 143);
INSERT INTO public.who_global_data VALUES (35554, 0, 0, 0, 0, 151, 219);
INSERT INTO public.who_global_data VALUES (35555, 46, 1261, 0, 53, 151, 186);
INSERT INTO public.who_global_data VALUES (35556, 16, 2981, 3, 120, 151, 52);
INSERT INTO public.who_global_data VALUES (35557, 0, 3, 0, 0, 151, 180);
INSERT INTO public.who_global_data VALUES (35558, 0, 95, 0, 3, 151, 167);
INSERT INTO public.who_global_data VALUES (35559, 6986, 478792, 105, 9912, 151, 154);
INSERT INTO public.who_global_data VALUES (35560, 108, 44266, 3, 898, 151, 94);
INSERT INTO public.who_global_data VALUES (35561, 157, 2449, 1, 14, 151, 66);
INSERT INTO public.who_global_data VALUES (35562, 43, 26322, 9, 762, 151, 58);
INSERT INTO public.who_global_data VALUES (35563, 511, 29705, 10, 746, 151, 163);
INSERT INTO public.who_global_data VALUES (35564, 89, 37418, 3, 551, 151, 37);
INSERT INTO public.who_global_data VALUES (35565, 70, 2546, 3, 58, 151, 142);
INSERT INTO public.who_global_data VALUES (35566, 661, 56076, 1, 200, 151, 83);
INSERT INTO public.who_global_data VALUES (35567, 2202, 327359, 37, 4516, 151, 228);
INSERT INTO public.who_global_data VALUES (35568, 0, 179, 0, 7, 151, 188);
INSERT INTO public.who_global_data VALUES (35569, 172, 73031, 5, 716, 151, 62);
INSERT INTO public.who_global_data VALUES (35570, 918, 90069, 4, 9905, 151, 160);
INSERT INTO public.who_global_data VALUES (35571, 67, 1261, 0, 15, 151, 50);
INSERT INTO public.who_global_data VALUES (35572, 0, 2213, 0, 40, 151, 33);
INSERT INTO public.who_global_data VALUES (35573, 0, 175, 0, 9, 151, 183);
INSERT INTO public.who_global_data VALUES (35574, 3, 233, 0, 0, 151, 92);
INSERT INTO public.who_global_data VALUES (35575, 528, 120769, 1610, 7008, 151, 158);
INSERT INTO public.who_global_data VALUES (35576, 0, 10, 0, 0, 151, 67);
INSERT INTO public.who_global_data VALUES (35577, 100, 21656, 9, 657, 151, 57);
INSERT INTO public.who_global_data VALUES (35578, 124, 2126, 1, 9, 151, 38);
INSERT INTO public.who_global_data VALUES (35579, 14521, 4137521, 447, 126650, 151, 141);
INSERT INTO public.who_global_data VALUES (35580, 0, 63, 0, 1, 151, 178);
INSERT INTO public.who_global_data VALUES (35581, 0, 145, 0, 3, 151, 108);
INSERT INTO public.who_global_data VALUES (35582, 96, 17146, 6, 677, 151, 39);
INSERT INTO public.who_global_data VALUES (35583, 5, 1452, 0, 55, 151, 2);
INSERT INTO public.who_global_data VALUES (35584, 4, 466, 0, 1, 151, 195);
INSERT INTO public.who_global_data VALUES (35585, 28, 4358, 0, 42, 151, 107);
INSERT INTO public.who_global_data VALUES (35586, 0, 274, 0, 0, 151, 161);
INSERT INTO public.who_global_data VALUES (35587, 244, 19848, 0, 415, 151, 212);
INSERT INTO public.who_global_data VALUES (35588, 400, 131895, 2, 9145, 151, 181);
INSERT INTO public.who_global_data VALUES (35589, 0, 205, 0, 1, 151, 53);
INSERT INTO public.who_global_data VALUES (35590, 0, 4729, 0, 62, 151, 164);
INSERT INTO public.who_global_data VALUES (35591, 1, 1040, 0, 79, 151, 140);
INSERT INTO public.who_global_data VALUES (35592, 1764, 424274, 60, 11652, 151, 20);
INSERT INTO public.who_global_data VALUES (35593, 22, 90573, 2, 4739, 151, 112);
INSERT INTO public.who_global_data VALUES (35594, 8065, 666521, 256, 21412, 151, 111);
INSERT INTO public.who_global_data VALUES (35595, 0, 448, 0, 7, 151, 71);
INSERT INTO public.who_global_data VALUES (35596, 24, 4891, 0, 82, 151, 218);
INSERT INTO public.who_global_data VALUES (35597, 0, 0, 0, 0, 151, 43);
INSERT INTO public.who_global_data VALUES (35598, 1027, 47947, 13, 491, 151, 49);
INSERT INTO public.who_global_data VALUES (35599, 113, 18701, 0, 119, 151, 1);
INSERT INTO public.who_global_data VALUES (35600, 117, 12081, 3, 201, 151, 48);
INSERT INTO public.who_global_data VALUES (35601, 43, 4352, 1, 102, 151, 232);
INSERT INTO public.who_global_data VALUES (35602, 14, 92, 0, 1, 151, 175);
INSERT INTO public.who_global_data VALUES (35603, 1, 1510, 0, 21, 151, 21);
INSERT INTO public.who_global_data VALUES (35604, 560, 28716, 1, 437, 151, 156);
INSERT INTO public.who_global_data VALUES (35605, 0, 0, 0, 0, 151, 95);
INSERT INTO public.who_global_data VALUES (35606, 23, 10232, 0, 260, 151, 177);
INSERT INTO public.who_global_data VALUES (35607, 566, 18113, 1, 628, 151, 210);
INSERT INTO public.who_global_data VALUES (35608, 0, 5388, 0, 61, 151, 120);
INSERT INTO public.who_global_data VALUES (35609, 0, 22, 0, 0, 151, 135);
INSERT INTO public.who_global_data VALUES (35610, 565, 99898, 19, 1864, 151, 206);
INSERT INTO public.who_global_data VALUES (35611, 1003, 110092, 52, 10576, 151, 189);
INSERT INTO public.who_global_data VALUES (35612, 178, 100041, 11, 5541, 151, 129);
INSERT INTO public.who_global_data VALUES (35613, 105, 26413, 5, 764, 151, 121);
INSERT INTO public.who_global_data VALUES (35614, 13, 4985, 0, 83, 151, 59);
INSERT INTO public.who_global_data VALUES (35615, 0, 330, 0, 0, 151, 96);
INSERT INTO public.who_global_data VALUES (35616, 16, 2531, 0, 64, 151, 41);
INSERT INTO public.who_global_data VALUES (35617, 31, 4884, 0, 94, 151, 216);
INSERT INTO public.who_global_data VALUES (35618, 976, 59648, 15, 933, 151, 236);
INSERT INTO public.who_global_data VALUES (35619, 0, 13, 0, 0, 151, 150);
INSERT INTO public.who_global_data VALUES (35620, 0, 413, 0, 0, 151, 61);
INSERT INTO public.who_global_data VALUES (35621, 0, 31, 0, 2, 151, 7);
INSERT INTO public.who_global_data VALUES (35622, 36, 8327, 0, 336, 151, 169);
INSERT INTO public.who_global_data VALUES (35623, 4115, 311587, 25, 30572, 151, 28);
INSERT INTO public.who_global_data VALUES (35624, 33, 9355, 0, 62, 151, 85);
INSERT INTO public.who_global_data VALUES (35625, 35, 773, 0, 0, 151, 211);
INSERT INTO public.who_global_data VALUES (35626, 7, 8608, 0, 53, 151, 60);
INSERT INTO public.who_global_data VALUES (35627, 0, 3196, 0, 99, 151, 3);
INSERT INTO public.who_global_data VALUES (35628, 45, 1729, 0, 19, 151, 11);
INSERT INTO public.who_global_data VALUES (35629, 1499, 252298, 4, 9329, 151, 89);
INSERT INTO public.who_global_data VALUES (35630, 0, 44777, 0, 283, 151, 24);
INSERT INTO public.who_global_data VALUES (35631, 3, 315, 0, 0, 151, 162);
INSERT INTO public.who_global_data VALUES (35632, 139, 11663, 5, 289, 151, 100);
INSERT INTO public.who_global_data VALUES (35633, 0, 14, 0, 0, 151, 47);
INSERT INTO public.who_global_data VALUES (35634, 0, 24, 0, 0, 151, 29);
INSERT INTO public.who_global_data VALUES (35635, 0, 1363, 0, 20, 151, 40);
INSERT INTO public.who_global_data VALUES (35636, 1, 1672, 2, 18, 151, 222);
INSERT INTO public.who_global_data VALUES (35637, 145, 77828, 10, 2862, 151, 132);
INSERT INTO public.who_global_data VALUES (35638, 0, 252, 0, 13, 151, 130);
INSERT INTO public.who_global_data VALUES (35639, 18, 9816, 1, 62, 151, 234);
INSERT INTO public.who_global_data VALUES (35640, 0, 2245, 0, 38, 151, 23);
INSERT INTO public.who_global_data VALUES (35641, 9, 1468, 0, 46, 151, 192);
INSERT INTO public.who_global_data VALUES (35642, 0, 8360, 0, 214, 151, 69);
INSERT INTO public.who_global_data VALUES (35643, 0, 12, 0, 0, 151, 187);
INSERT INTO public.who_global_data VALUES (35644, 412, 64764, 1, 2007, 151, 230);
INSERT INTO public.who_global_data VALUES (35645, 576, 8963, 1, 625, 151, 77);
INSERT INTO public.who_global_data VALUES (35646, 2, 2143, 0, 10, 151, 9);
INSERT INTO public.who_global_data VALUES (35647, 75809, 4280422, 1133, 72775, 151, 74);
INSERT INTO public.who_global_data VALUES (35648, 2880, 196989, 105, 8130, 151, 224);
INSERT INTO public.who_global_data VALUES (35649, 2152, 388810, 117, 22410, 151, 199);
INSERT INTO public.who_global_data VALUES (35650, 4314, 264684, 77, 7589, 151, 190);
INSERT INTO public.who_global_data VALUES (35651, 102, 29774, 0, 1777, 151, 12);
INSERT INTO public.who_global_data VALUES (35652, 1, 337, 0, 24, 151, 104);
INSERT INTO public.who_global_data VALUES (35653, 2177, 131327, 12, 1037, 151, 153);
INSERT INTO public.who_global_data VALUES (35654, 1150, 278784, 12, 35553, 151, 91);
INSERT INTO public.who_global_data VALUES (35655, 79, 3103, 1, 33, 151, 215);
INSERT INTO public.who_global_data VALUES (35656, 378, 72234, 14, 1377, 151, 84);
INSERT INTO public.who_global_data VALUES (35657, 0, 384, 0, 32, 151, 231);
INSERT INTO public.who_global_data VALUES (35658, 67, 2546, 1, 17, 151, 196);
INSERT INTO public.who_global_data VALUES (35659, 433, 134636, 0, 1948, 151, 105);
INSERT INTO public.who_global_data VALUES (35660, 102, 35205, 2, 599, 151, 122);
INSERT INTO public.who_global_data VALUES (35661, 0, 0, 0, 0, 151, 159);
INSERT INTO public.who_global_data VALUES (35662, 85, 14161, 5, 558, 151, 75);
INSERT INTO public.who_global_data VALUES (35663, 805, 90387, 2, 546, 151, 27);
INSERT INTO public.who_global_data VALUES (35664, 68, 44526, 1, 1062, 151, 54);
INSERT INTO public.who_global_data VALUES (35665, 0, 22, 0, 0, 151, 226);
INSERT INTO public.who_global_data VALUES (35666, 1, 1429, 0, 35, 151, 79);
INSERT INTO public.who_global_data VALUES (35667, 400, 20826, 9, 200, 151, 56);
INSERT INTO public.who_global_data VALUES (35668, 16, 1164, 0, 31, 151, 117);
INSERT INTO public.who_global_data VALUES (35669, 5, 1311, 0, 82, 151, 152);
INSERT INTO public.who_global_data VALUES (35670, 749, 19583, 18, 314, 151, 16);
INSERT INTO public.who_global_data VALUES (35671, 0, 108, 0, 1, 151, 10);
INSERT INTO public.who_global_data VALUES (35672, 32, 3126, 0, 86, 151, 201);
INSERT INTO public.who_global_data VALUES (35673, 54, 6950, 0, 124, 151, 174);
INSERT INTO public.who_global_data VALUES (35674, 33, 15352, 2, 202, 151, 119);
INSERT INTO public.who_global_data VALUES (35675, 7, 5621, 1, 176, 151, 168);
INSERT INTO public.who_global_data VALUES (35676, 62, 9459, 0, 128, 151, 99);
INSERT INTO public.who_global_data VALUES (35677, 83, 8667, 0, 29, 151, 171);
INSERT INTO public.who_global_data VALUES (35678, 28, 2870, 0, 127, 151, 87);
INSERT INTO public.who_global_data VALUES (35679, 23, 2100, 0, 14, 151, 123);
INSERT INTO public.who_global_data VALUES (35680, 0, 0, 0, 0, 151, 151);
INSERT INTO public.who_global_data VALUES (35681, 0, 758, 0, 18, 151, 213);
INSERT INTO public.who_global_data VALUES (35682, 22, 7164, 0, 160, 151, 118);
INSERT INTO public.who_global_data VALUES (35683, 0, 356, 0, 10, 151, 134);
INSERT INTO public.who_global_data VALUES (35684, 0, 3374, 0, 40, 151, 65);
INSERT INTO public.who_global_data VALUES (35685, 4614, 634023, 232, 67558, 151, 102);
INSERT INTO public.who_global_data VALUES (35686, 0, 0, 0, 0, 151, 223);
INSERT INTO public.who_global_data VALUES (35687, 5, 156, 0, 1, 151, 4);
INSERT INTO public.who_global_data VALUES (35688, 0, 310, 0, 0, 151, 146);
INSERT INTO public.who_global_data VALUES (35689, 172, 6025, 5, 114, 151, 31);
INSERT INTO public.who_global_data VALUES (35690, 0, 13, 0, 1, 151, 127);
INSERT INTO public.who_global_data VALUES (35691, 1386, 73780, 33, 1394, 151, 22);
INSERT INTO public.who_global_data VALUES (35692, 113, 4557, 0, 27, 151, 115);
INSERT INTO public.who_global_data VALUES (35693, 146, 1610, 0, 8, 151, 106);
INSERT INTO public.who_global_data VALUES (35694, 125, 8810, 2, 91, 151, 90);
INSERT INTO public.who_global_data VALUES (35695, 0, 0, 0, 0, 151, 70);
INSERT INTO public.who_global_data VALUES (35696, 979, 47236, 11, 300, 151, 46);
INSERT INTO public.who_global_data VALUES (35697, 795, 75479, 0, 6242, 151, 139);
INSERT INTO public.who_global_data VALUES (35698, 0, 26, 0, 0, 151, 42);
INSERT INTO public.who_global_data VALUES (35699, 6, 1431, 0, 24, 151, 80);
INSERT INTO public.who_global_data VALUES (35700, 0, 3773, 0, 141, 151, 203);
INSERT INTO public.who_global_data VALUES (35701, 1, 1178, 0, 69, 151, 136);
INSERT INTO public.who_global_data VALUES (35702, 155, 55160, 4, 1061, 151, 63);
INSERT INTO public.who_global_data VALUES (35703, 0, 0, 0, 0, 151, 17);
INSERT INTO public.who_global_data VALUES (35704, 1, 59, 0, 2, 151, 172);
INSERT INTO public.who_global_data VALUES (35705, 37, 15127, 6, 623, 151, 109);
INSERT INTO public.who_global_data VALUES (35706, 267, 11387, 0, 264, 151, 200);
INSERT INTO public.who_global_data VALUES (35707, 789, 34801, 3, 206, 151, 93);
INSERT INTO public.who_global_data VALUES (35708, 256, 87328, 6, 734, 151, 5);
INSERT INTO public.who_global_data VALUES (35709, 0, 741, 0, 13, 151, 214);
INSERT INTO public.who_global_data VALUES (35710, 330, 299233, 5, 6350, 151, 204);
INSERT INTO public.who_global_data VALUES (35711, 0, 0, 0, 0, 151, 198);
INSERT INTO public.who_global_data VALUES (35712, 738, 97043, 11, 2086, 151, 173);
INSERT INTO public.who_global_data VALUES (35713, 0, 497, 0, 5, 151, 229);
INSERT INTO public.who_global_data VALUES (35714, 615, 22486, 23, 435, 151, 76);
INSERT INTO public.who_global_data VALUES (35715, 6275, 689977, 151, 29838, 151, 138);
INSERT INTO public.who_global_data VALUES (35716, 1362, 238727, 15, 3890, 151, 98);
INSERT INTO public.who_global_data VALUES (35717, 0, 0, 0, 0, 151, 103);
INSERT INTO public.who_global_data VALUES (35718, 302, 71126, 4, 2124, 151, 225);
INSERT INTO public.who_global_data VALUES (35719, 249, 60507, 3, 1843, 151, 131);
INSERT INTO public.who_global_data VALUES (35720, 842, 35375, 0, 477, 151, 235);
INSERT INTO public.who_global_data VALUES (35721, 253, 120348, 2, 205, 151, 137);
INSERT INTO public.who_global_data VALUES (35722, 136, 21432, 5, 341, 151, 81);
INSERT INTO public.who_global_data VALUES (35723, 258, 40055, 11, 1074, 151, 182);
INSERT INTO public.who_global_data VALUES (35724, 55, 2277, 0, 8, 151, 145);
INSERT INTO public.who_global_data VALUES (35725, 883, 95897, 33, 3926, 151, 26);
INSERT INTO public.who_global_data VALUES (35726, 5099, 1035789, 122, 17993, 151, 170);
INSERT INTO public.who_global_data VALUES (35727, 35, 4409, 0, 19, 151, 191);
INSERT INTO public.who_global_data VALUES (35728, 0, 5, 0, 0, 151, 221);
INSERT INTO public.who_global_data VALUES (35729, 0, 18, 0, 0, 151, 64);
INSERT INTO public.who_global_data VALUES (35730, 0, 0, 0, 0, 151, 116);
INSERT INTO public.who_global_data VALUES (35731, 0, 17, 0, 0, 151, 128);
INSERT INTO public.who_global_data VALUES (35732, 0, 26, 0, 0, 151, 6);
INSERT INTO public.who_global_data VALUES (35733, 0, 239, 0, 6, 151, 227);
INSERT INTO public.who_global_data VALUES (35734, 0, 9, 0, 0, 151, 68);
INSERT INTO public.who_global_data VALUES (35735, 0, 61, 0, 0, 151, 184);
INSERT INTO public.who_global_data VALUES (35736, 0, 0, 0, 0, 151, 82);
INSERT INTO public.who_global_data VALUES (35737, 0, 735, 0, 42, 151, 149);
INSERT INTO public.who_global_data VALUES (35738, 0, 898, 0, 15, 151, 197);
INSERT INTO public.who_global_data VALUES (35739, 629, 321456, 26, 4107, 151, 78);
INSERT INTO public.who_global_data VALUES (35740, 0, 13987, 0, 290, 151, 233);
INSERT INTO public.who_global_data VALUES (35741, 36, 31941, 1, 725, 151, 133);
INSERT INTO public.who_global_data VALUES (35742, 0, 135, 0, 0, 151, 35);
INSERT INTO public.who_global_data VALUES (35743, 1, 2055, 0, 71, 151, 114);
INSERT INTO public.who_global_data VALUES (35744, 22, 57044, 0, 27, 151, 237);
INSERT INTO public.who_global_data VALUES (35745, 0, 6, 0, 0, 151, 55);
INSERT INTO public.who_global_data VALUES (35746, 7, 511, 0, 19, 151, 176);
INSERT INTO public.who_global_data VALUES (35747, 22, 4636, 0, 37, 151, 202);
INSERT INTO public.who_global_data VALUES (35748, 43, 3234, 0, 134, 151, 155);
INSERT INTO public.who_global_data VALUES (35749, 0, 0, 0, 0, 151, 32);
INSERT INTO public.who_global_data VALUES (35750, 0, 3362, 0, 97, 151, 220);
INSERT INTO public.who_global_data VALUES (35751, 845, 639362, 115, 15004, 151, 30);
INSERT INTO public.who_global_data VALUES (35752, 7, 2552, 1, 49, 151, 147);
INSERT INTO public.who_global_data VALUES (35753, 5540, 563629, 62, 31376, 151, 208);
INSERT INTO public.who_global_data VALUES (35754, 0, 3123, 0, 12, 151, 45);
INSERT INTO public.who_global_data VALUES (35755, 33, 13470, 1, 834, 151, 110);
INSERT INTO public.who_global_data VALUES (35756, 26, 4346, 8, 85, 151, 88);
INSERT INTO public.who_global_data VALUES (35757, 67, 85567, 3, 5840, 151, 51);
INSERT INTO public.who_global_data VALUES (35758, 468, 45169, 1, 1773, 151, 209);
INSERT INTO public.who_global_data VALUES (35759, 58, 3229, 3, 137, 151, 205);
INSERT INTO public.who_global_data VALUES (35760, 32, 8824, 0, 70, 151, 18);
INSERT INTO public.who_global_data VALUES (35761, 1, 3446, 0, 58, 151, 72);
INSERT INTO public.who_global_data VALUES (35762, 2948, 350104, 3, 41554, 151, 44);
INSERT INTO public.who_global_data VALUES (35763, 0, 27, 0, 0, 151, 15);
INSERT INTO public.who_global_data VALUES (35764, 31, 1488, 1, 32, 151, 25);
INSERT INTO public.who_global_data VALUES (35765, 0, 0, 0, 0, 151, 179);
INSERT INTO public.who_global_data VALUES (35766, 0, 0, 0, 0, 151, 34);
INSERT INTO public.who_global_data VALUES (35767, 20, 2254, 2, 35, 151, 207);
INSERT INTO public.who_global_data VALUES (35768, 293, 5417, 2, 96, 151, 166);
INSERT INTO public.who_global_data VALUES (35769, 8433, 564169, 57, 6730, 151, 126);
INSERT INTO public.who_global_data VALUES (35770, 0, 0, 0, 0, 151, 97);
INSERT INTO public.who_global_data VALUES (35771, 1, 599, 0, 5, 151, 36);
INSERT INTO public.who_global_data VALUES (35772, 0, 0, 0, 0, 151, 125);
INSERT INTO public.who_global_data VALUES (35773, 109, 3776, 3, 44, 151, 124);
INSERT INTO public.who_global_data VALUES (35774, 2411, 140479, 57, 2934, 151, 185);
INSERT INTO public.who_global_data VALUES (35775, 470, 74454, 2, 390, 151, 194);
INSERT INTO public.who_global_data VALUES (35776, 0, 509, 0, 21, 151, 144);
INSERT INTO public.who_global_data VALUES (35777, 33486, 6222974, 462, 188003, 151, 19);
INSERT INTO public.who_global_data VALUES (35778, 9, 1190, 0, 17, 151, 217);
INSERT INTO public.who_global_data VALUES (35779, 10, 1679, 0, 45, 151, 148);
INSERT INTO public.who_global_data VALUES (35780, 332, 44107, 6, 356, 151, 86);
INSERT INTO public.who_global_data VALUES (35781, 0, 0, 0, 0, 151, 13);
INSERT INTO public.who_global_data VALUES (35782, 1124, 53289, 8, 428, 151, 157);
INSERT INTO public.who_global_data VALUES (35783, 0, 1049, 0, 35, 151, 8);
INSERT INTO public.who_global_data VALUES (35784, 0, 0, 0, 0, 151, 73);
INSERT INTO public.who_global_data VALUES (35785, 2, 1993, 1, 574, 151, 101);
INSERT INTO public.who_global_data VALUES (35786, 60, 12836, 0, 295, 151, 165);
INSERT INTO public.who_global_data VALUES (35787, 279, 7116, 2, 208, 151, 14);
INSERT INTO public.who_global_data VALUES (35788, 96, 38580, 3, 1419, 152, 193);
INSERT INTO public.who_global_data VALUES (35789, 153, 10255, 4, 316, 152, 113);
INSERT INTO public.who_global_data VALUES (35790, 293, 46364, 7, 1556, 152, 143);
INSERT INTO public.who_global_data VALUES (35791, 0, 0, 0, 0, 152, 219);
INSERT INTO public.who_global_data VALUES (35792, 0, 1215, 0, 53, 152, 186);
INSERT INTO public.who_global_data VALUES (35793, 30, 2965, 0, 117, 152, 52);
INSERT INTO public.who_global_data VALUES (35794, 0, 3, 0, 0, 152, 180);
INSERT INTO public.who_global_data VALUES (35795, 0, 95, 0, 3, 152, 167);
INSERT INTO public.who_global_data VALUES (35796, 9924, 471806, 122, 9807, 152, 154);
INSERT INTO public.who_global_data VALUES (35797, 62, 44158, 3, 895, 152, 94);
INSERT INTO public.who_global_data VALUES (35798, 0, 2292, 0, 13, 152, 66);
INSERT INTO public.who_global_data VALUES (35799, 72, 26279, 5, 753, 152, 58);
INSERT INTO public.who_global_data VALUES (35800, 220, 29194, 1, 736, 152, 163);
INSERT INTO public.who_global_data VALUES (35801, 137, 37329, 3, 548, 152, 37);
INSERT INTO public.who_global_data VALUES (35802, 0, 2476, 0, 55, 152, 142);
INSERT INTO public.who_global_data VALUES (35803, 644, 55415, 3, 199, 152, 83);
INSERT INTO public.who_global_data VALUES (35804, 1592, 325157, 32, 4479, 152, 228);
INSERT INTO public.who_global_data VALUES (35805, 1, 179, 0, 7, 152, 188);
INSERT INTO public.who_global_data VALUES (35806, 196, 72859, 6, 711, 152, 62);
INSERT INTO public.who_global_data VALUES (35807, 155, 89151, 2, 9901, 152, 160);
INSERT INTO public.who_global_data VALUES (35808, 42, 1194, 0, 15, 152, 50);
INSERT INTO public.who_global_data VALUES (35809, 0, 2213, 0, 40, 152, 33);
INSERT INTO public.who_global_data VALUES (35810, 0, 175, 0, 9, 152, 183);
INSERT INTO public.who_global_data VALUES (35811, 2, 230, 0, 0, 152, 92);
INSERT INTO public.who_global_data VALUES (35812, 661, 120241, 55, 5398, 152, 158);
INSERT INTO public.who_global_data VALUES (35813, 1, 10, 0, 0, 152, 67);
INSERT INTO public.who_global_data VALUES (35814, 122, 21556, 4, 648, 152, 57);
INSERT INTO public.who_global_data VALUES (35815, 0, 2002, 0, 8, 152, 38);
INSERT INTO public.who_global_data VALUES (35816, 30168, 4123000, 682, 126203, 152, 141);
INSERT INTO public.who_global_data VALUES (35817, 0, 63, 0, 1, 152, 178);
INSERT INTO public.who_global_data VALUES (35818, 0, 145, 0, 3, 152, 108);
INSERT INTO public.who_global_data VALUES (35819, 96, 17050, 6, 671, 152, 39);
INSERT INTO public.who_global_data VALUES (35820, 39, 1447, 0, 55, 152, 2);
INSERT INTO public.who_global_data VALUES (35821, 0, 462, 0, 1, 152, 195);
INSERT INTO public.who_global_data VALUES (35822, 55, 4330, 0, 42, 152, 107);
INSERT INTO public.who_global_data VALUES (35823, 0, 274, 0, 0, 152, 161);
INSERT INTO public.who_global_data VALUES (35824, 0, 19604, 0, 415, 152, 212);
INSERT INTO public.who_global_data VALUES (35825, 371, 131495, 2, 9143, 152, 181);
INSERT INTO public.who_global_data VALUES (35826, 0, 205, 0, 1, 152, 53);
INSERT INTO public.who_global_data VALUES (35827, 0, 4729, 0, 62, 152, 164);
INSERT INTO public.who_global_data VALUES (35828, 5, 1039, 2, 79, 152, 140);
INSERT INTO public.who_global_data VALUES (35829, 2076, 422510, 41, 11592, 152, 20);
INSERT INTO public.who_global_data VALUES (35830, 34, 90551, 2, 4737, 152, 112);
INSERT INTO public.who_global_data VALUES (35831, 8394, 658456, 268, 21156, 152, 111);
INSERT INTO public.who_global_data VALUES (35832, 0, 448, 0, 7, 152, 71);
INSERT INTO public.who_global_data VALUES (35833, 239, 4867, 0, 82, 152, 218);
INSERT INTO public.who_global_data VALUES (35834, 0, 0, 0, 0, 152, 43);
INSERT INTO public.who_global_data VALUES (35835, 1240, 46920, 9, 478, 152, 49);
INSERT INTO public.who_global_data VALUES (35836, 319, 18588, 0, 119, 152, 1);
INSERT INTO public.who_global_data VALUES (35837, 225, 11964, 1, 198, 152, 48);
INSERT INTO public.who_global_data VALUES (35838, 11, 4309, 1, 101, 152, 232);
INSERT INTO public.who_global_data VALUES (35839, 0, 78, 0, 1, 152, 175);
INSERT INTO public.who_global_data VALUES (35840, 2, 1509, 0, 21, 152, 21);
INSERT INTO public.who_global_data VALUES (35841, 404, 28156, 5, 436, 152, 156);
INSERT INTO public.who_global_data VALUES (35842, 0, 0, 0, 0, 152, 95);
INSERT INTO public.who_global_data VALUES (35843, 61, 10209, 1, 260, 152, 177);
INSERT INTO public.who_global_data VALUES (35844, 0, 17547, 0, 627, 152, 210);
INSERT INTO public.who_global_data VALUES (35845, 1, 5388, 1, 61, 152, 120);
INSERT INTO public.who_global_data VALUES (35846, 0, 22, 0, 0, 152, 135);
INSERT INTO public.who_global_data VALUES (35847, 557, 99333, 5, 1845, 152, 206);
INSERT INTO public.who_global_data VALUES (35848, -8956, 109089, 3800, 10524, 152, 189);
INSERT INTO public.who_global_data VALUES (35849, 151, 99863, 19, 5530, 152, 129);
INSERT INTO public.who_global_data VALUES (35850, 102, 26308, 7, 759, 152, 121);
INSERT INTO public.who_global_data VALUES (35851, 0, 4972, 0, 83, 152, 59);
INSERT INTO public.who_global_data VALUES (35852, 0, 330, 0, 0, 152, 96);
INSERT INTO public.who_global_data VALUES (35853, 25, 2515, 0, 64, 152, 41);
INSERT INTO public.who_global_data VALUES (35854, 34, 4853, 0, 94, 152, 216);
INSERT INTO public.who_global_data VALUES (35855, 1206, 58672, 21, 918, 152, 236);
INSERT INTO public.who_global_data VALUES (35856, 0, 13, 0, 0, 152, 150);
INSERT INTO public.who_global_data VALUES (35857, 0, 413, 0, 0, 152, 61);
INSERT INTO public.who_global_data VALUES (35858, 0, 31, 0, 2, 152, 7);
INSERT INTO public.who_global_data VALUES (35859, 30, 8291, 0, 336, 152, 169);
INSERT INTO public.who_global_data VALUES (35860, 6961, 307472, 1, 30547, 152, 28);
INSERT INTO public.who_global_data VALUES (35861, 0, 9322, 0, 62, 152, 85);
INSERT INTO public.who_global_data VALUES (35862, 18, 738, 0, 0, 152, 211);
INSERT INTO public.who_global_data VALUES (35863, 0, 8601, 0, 53, 152, 60);
INSERT INTO public.who_global_data VALUES (35864, 76, 3196, 0, 99, 152, 3);
INSERT INTO public.who_global_data VALUES (35865, 34, 1684, 0, 19, 152, 11);
INSERT INTO public.who_global_data VALUES (35866, 814, 250799, 0, 9325, 152, 89);
INSERT INTO public.who_global_data VALUES (35867, 0, 44777, 0, 283, 152, 24);
INSERT INTO public.who_global_data VALUES (35868, 7, 312, 0, 0, 152, 162);
INSERT INTO public.who_global_data VALUES (35869, 138, 11524, 4, 284, 152, 100);
INSERT INTO public.who_global_data VALUES (35870, 0, 14, 0, 0, 152, 47);
INSERT INTO public.who_global_data VALUES (35871, 0, 24, 0, 0, 152, 29);
INSERT INTO public.who_global_data VALUES (35872, 0, 1363, 0, 20, 152, 40);
INSERT INTO public.who_global_data VALUES (35873, 0, 1671, 0, 16, 152, 222);
INSERT INTO public.who_global_data VALUES (35874, 202, 77683, 7, 2852, 152, 132);
INSERT INTO public.who_global_data VALUES (35875, 0, 252, 0, 13, 152, 130);
INSERT INTO public.who_global_data VALUES (35876, 76, 9798, 0, 61, 152, 234);
INSERT INTO public.who_global_data VALUES (35877, 0, 2245, 0, 38, 152, 23);
INSERT INTO public.who_global_data VALUES (35878, 43, 1459, 2, 46, 152, 192);
INSERT INTO public.who_global_data VALUES (35879, 34, 8360, 2, 214, 152, 69);
INSERT INTO public.who_global_data VALUES (35880, 0, 12, 0, 0, 152, 187);
INSERT INTO public.who_global_data VALUES (35881, 554, 64352, 22, 2006, 152, 230);
INSERT INTO public.who_global_data VALUES (35882, 495, 8387, 0, 624, 152, 77);
INSERT INTO public.who_global_data VALUES (35883, 5, 2141, 0, 10, 152, 9);
INSERT INTO public.who_global_data VALUES (35884, 90802, 4204613, 1016, 71642, 152, 74);
INSERT INTO public.who_global_data VALUES (35885, 3444, 194109, 85, 8025, 152, 224);
INSERT INTO public.who_global_data VALUES (35886, 1992, 386658, 139, 22293, 152, 199);
INSERT INTO public.who_global_data VALUES (35887, 3651, 260370, 90, 7512, 152, 190);
INSERT INTO public.who_global_data VALUES (35888, 138, 29672, 0, 1777, 152, 12);
INSERT INTO public.who_global_data VALUES (35889, 0, 336, 0, 24, 152, 104);
INSERT INTO public.who_global_data VALUES (35890, 1505, 129150, 15, 1025, 152, 153);
INSERT INTO public.who_global_data VALUES (35891, 1296, 277634, 7, 35541, 152, 91);
INSERT INTO public.who_global_data VALUES (35892, 60, 3024, 2, 32, 152, 215);
INSERT INTO public.who_global_data VALUES (35893, 437, 71856, 6, 1363, 152, 84);
INSERT INTO public.who_global_data VALUES (35894, 0, 384, 0, 32, 152, 231);
INSERT INTO public.who_global_data VALUES (35895, 58, 2479, 0, 16, 152, 196);
INSERT INTO public.who_global_data VALUES (35896, 80, 134203, 0, 1948, 152, 105);
INSERT INTO public.who_global_data VALUES (35897, 83, 35103, 3, 597, 152, 122);
INSERT INTO public.who_global_data VALUES (35898, 0, 0, 0, 0, 152, 159);
INSERT INTO public.who_global_data VALUES (35899, 92, 14076, 7, 553, 152, 75);
INSERT INTO public.who_global_data VALUES (35900, 619, 89582, 4, 544, 152, 27);
INSERT INTO public.who_global_data VALUES (35901, 55, 44458, 0, 1061, 152, 54);
INSERT INTO public.who_global_data VALUES (35902, 0, 22, 0, 0, 152, 226);
INSERT INTO public.who_global_data VALUES (35903, 3, 1428, 0, 35, 152, 79);
INSERT INTO public.who_global_data VALUES (35904, 415, 20426, 4, 191, 152, 56);
INSERT INTO public.who_global_data VALUES (35905, 0, 1148, 0, 31, 152, 117);
INSERT INTO public.who_global_data VALUES (35906, 0, 1306, 0, 82, 152, 152);
INSERT INTO public.who_global_data VALUES (35907, 1085, 18834, 11, 296, 152, 16);
INSERT INTO public.who_global_data VALUES (35908, 0, 108, 0, 1, 152, 10);
INSERT INTO public.who_global_data VALUES (35909, 17, 3094, 0, 86, 152, 201);
INSERT INTO public.who_global_data VALUES (35910, 42, 6896, 0, 124, 152, 174);
INSERT INTO public.who_global_data VALUES (35911, 50, 15319, 1, 200, 152, 119);
INSERT INTO public.who_global_data VALUES (35912, 3, 5614, 0, 175, 152, 168);
INSERT INTO public.who_global_data VALUES (35913, 6, 9397, 0, 128, 152, 99);
INSERT INTO public.who_global_data VALUES (35914, 98, 8584, 0, 29, 152, 171);
INSERT INTO public.who_global_data VALUES (35915, 9, 2842, 1, 127, 152, 87);
INSERT INTO public.who_global_data VALUES (35916, 37, 2077, 0, 14, 152, 123);
INSERT INTO public.who_global_data VALUES (35917, 0, 0, 0, 0, 152, 151);
INSERT INTO public.who_global_data VALUES (35918, 0, 758, 0, 18, 152, 213);
INSERT INTO public.who_global_data VALUES (35919, 8, 7142, 0, 160, 152, 118);
INSERT INTO public.who_global_data VALUES (35920, 0, 356, 0, 10, 152, 134);
INSERT INTO public.who_global_data VALUES (35921, 0, 3374, 0, 40, 152, 65);
INSERT INTO public.who_global_data VALUES (35922, 6319, 629409, 475, 67326, 152, 102);
INSERT INTO public.who_global_data VALUES (35923, 0, 0, 0, 0, 152, 223);
INSERT INTO public.who_global_data VALUES (35924, 1, 151, 0, 1, 152, 4);
INSERT INTO public.who_global_data VALUES (35925, 0, 310, 0, 0, 152, 146);
INSERT INTO public.who_global_data VALUES (35926, 248, 5853, 1, 109, 152, 31);
INSERT INTO public.who_global_data VALUES (35927, 0, 13, 0, 1, 152, 127);
INSERT INTO public.who_global_data VALUES (35928, 2234, 72394, 32, 1361, 152, 22);
INSERT INTO public.who_global_data VALUES (35929, 103, 4444, 1, 27, 152, 115);
INSERT INTO public.who_global_data VALUES (35930, 145, 1464, 0, 8, 152, 106);
INSERT INTO public.who_global_data VALUES (35931, 171, 8685, 2, 89, 152, 90);
INSERT INTO public.who_global_data VALUES (35932, 0, 0, 0, 0, 152, 70);
INSERT INTO public.who_global_data VALUES (35933, 980, 46257, 9, 289, 152, 46);
INSERT INTO public.who_global_data VALUES (35934, 920, 74684, 2, 6242, 152, 139);
INSERT INTO public.who_global_data VALUES (35935, 0, 26, 0, 0, 152, 42);
INSERT INTO public.who_global_data VALUES (35936, 4, 1425, 0, 24, 152, 80);
INSERT INTO public.who_global_data VALUES (35937, 0, 3773, 0, 141, 152, 203);
INSERT INTO public.who_global_data VALUES (35938, 0, 1177, 0, 69, 152, 136);
INSERT INTO public.who_global_data VALUES (35939, 100, 55005, 3, 1057, 152, 63);
INSERT INTO public.who_global_data VALUES (35940, 0, 0, 0, 0, 152, 17);
INSERT INTO public.who_global_data VALUES (35941, 0, 58, 0, 2, 152, 172);
INSERT INTO public.who_global_data VALUES (35942, 92, 15090, 3, 617, 152, 109);
INSERT INTO public.who_global_data VALUES (35943, 0, 11120, 0, 264, 152, 200);
INSERT INTO public.who_global_data VALUES (35944, 762, 34012, 4, 203, 152, 93);
INSERT INTO public.who_global_data VALUES (35945, 692, 87072, 23, 728, 152, 5);
INSERT INTO public.who_global_data VALUES (35946, 0, 741, 0, 13, 152, 214);
INSERT INTO public.who_global_data VALUES (35947, 394, 298903, 3, 6345, 152, 204);
INSERT INTO public.who_global_data VALUES (35948, 0, 0, 0, 0, 152, 198);
INSERT INTO public.who_global_data VALUES (35949, 709, 96305, 12, 2075, 152, 173);
INSERT INTO public.who_global_data VALUES (35950, 9, 497, 0, 5, 152, 229);
INSERT INTO public.who_global_data VALUES (35951, 1217, 21871, 14, 412, 152, 76);
INSERT INTO public.who_global_data VALUES (35952, 6854, 683702, 133, 29687, 152, 138);
INSERT INTO public.who_global_data VALUES (35953, 2795, 237365, 85, 3875, 152, 98);
INSERT INTO public.who_global_data VALUES (35954, 0, 0, 0, 0, 152, 103);
INSERT INTO public.who_global_data VALUES (35955, 437, 70824, 7, 2120, 152, 225);
INSERT INTO public.who_global_data VALUES (35956, 315, 60258, 2, 1840, 152, 131);
INSERT INTO public.who_global_data VALUES (35957, 41, 34533, 13, 477, 152, 235);
INSERT INTO public.who_global_data VALUES (35958, 231, 120095, 1, 203, 152, 137);
INSERT INTO public.who_global_data VALUES (35959, 119, 21296, 2, 336, 152, 81);
INSERT INTO public.who_global_data VALUES (35960, 324, 39797, 0, 1063, 152, 182);
INSERT INTO public.who_global_data VALUES (35961, 107, 2222, 2, 8, 152, 145);
INSERT INTO public.who_global_data VALUES (35962, 1150, 95014, 43, 3893, 152, 26);
INSERT INTO public.who_global_data VALUES (35963, 5185, 1030690, 51, 17871, 152, 170);
INSERT INTO public.who_global_data VALUES (35964, 25, 4374, 1, 19, 152, 191);
INSERT INTO public.who_global_data VALUES (35965, 0, 5, 0, 0, 152, 221);
INSERT INTO public.who_global_data VALUES (35966, 0, 18, 0, 0, 152, 64);
INSERT INTO public.who_global_data VALUES (35967, 0, 0, 0, 0, 152, 116);
INSERT INTO public.who_global_data VALUES (35968, 0, 17, 0, 0, 152, 128);
INSERT INTO public.who_global_data VALUES (35969, 0, 26, 0, 0, 152, 6);
INSERT INTO public.who_global_data VALUES (35970, 0, 239, 0, 6, 152, 227);
INSERT INTO public.who_global_data VALUES (35971, 3, 9, 0, 0, 152, 68);
INSERT INTO public.who_global_data VALUES (35972, 0, 61, 0, 0, 152, 184);
INSERT INTO public.who_global_data VALUES (35973, 0, 0, 0, 0, 152, 82);
INSERT INTO public.who_global_data VALUES (35974, 0, 735, 0, 42, 152, 149);
INSERT INTO public.who_global_data VALUES (35975, 0, 898, 0, 15, 152, 197);
INSERT INTO public.who_global_data VALUES (35976, 895, 320827, 32, 4081, 152, 78);
INSERT INTO public.who_global_data VALUES (35977, 106, 13987, 1, 290, 152, 233);
INSERT INTO public.who_global_data VALUES (35978, 56, 31905, 1, 724, 152, 133);
INSERT INTO public.who_global_data VALUES (35979, 0, 135, 0, 0, 152, 35);
INSERT INTO public.who_global_data VALUES (35980, 11, 2054, 0, 71, 152, 114);
INSERT INTO public.who_global_data VALUES (35981, 40, 57022, 0, 27, 152, 237);
INSERT INTO public.who_global_data VALUES (35982, 2, 6, 0, 0, 152, 55);
INSERT INTO public.who_global_data VALUES (35983, 0, 504, 0, 19, 152, 176);
INSERT INTO public.who_global_data VALUES (35984, 88, 4614, 0, 37, 152, 202);
INSERT INTO public.who_global_data VALUES (35985, 25, 3191, 0, 134, 152, 155);
INSERT INTO public.who_global_data VALUES (35986, 0, 0, 0, 0, 152, 32);
INSERT INTO public.who_global_data VALUES (35987, 0, 3362, 0, 97, 152, 220);
INSERT INTO public.who_global_data VALUES (35988, 1633, 638517, 110, 14889, 152, 30);
INSERT INTO public.who_global_data VALUES (35989, 1, 2545, 0, 48, 152, 147);
INSERT INTO public.who_global_data VALUES (35990, 7978, 558089, 64, 31314, 152, 208);
INSERT INTO public.who_global_data VALUES (35991, 2, 3123, 0, 12, 152, 45);
INSERT INTO public.who_global_data VALUES (35992, 0, 13437, 0, 833, 152, 110);
INSERT INTO public.who_global_data VALUES (35993, 68, 4320, 2, 77, 152, 88);
INSERT INTO public.who_global_data VALUES (35994, 171, 85500, 0, 5837, 152, 51);
INSERT INTO public.who_global_data VALUES (35995, 170, 44701, 3, 1772, 152, 209);
INSERT INTO public.who_global_data VALUES (35996, 67, 3171, 4, 134, 152, 205);
INSERT INTO public.who_global_data VALUES (35997, 35, 8792, 0, 70, 152, 18);
INSERT INTO public.who_global_data VALUES (35998, 1, 3445, 0, 58, 152, 72);
INSERT INTO public.who_global_data VALUES (35999, 2988, 347156, 2, 41551, 152, 44);
INSERT INTO public.who_global_data VALUES (36000, 0, 27, 0, 0, 152, 15);
INSERT INTO public.who_global_data VALUES (36001, 14, 1457, 0, 31, 152, 25);
INSERT INTO public.who_global_data VALUES (36002, 0, 0, 0, 0, 152, 179);
INSERT INTO public.who_global_data VALUES (36003, 0, 0, 0, 0, 152, 34);
INSERT INTO public.who_global_data VALUES (36004, 92, 2234, 1, 33, 152, 207);
INSERT INTO public.who_global_data VALUES (36005, 83, 5124, 1, 94, 152, 166);
INSERT INTO public.who_global_data VALUES (36006, 8308, 555736, 53, 6673, 152, 126);
INSERT INTO public.who_global_data VALUES (36007, 0, 0, 0, 0, 152, 97);
INSERT INTO public.who_global_data VALUES (36008, 7, 598, 0, 5, 152, 36);
INSERT INTO public.who_global_data VALUES (36009, 0, 0, 0, 0, 152, 125);
INSERT INTO public.who_global_data VALUES (36010, 128, 3667, 2, 41, 152, 124);
INSERT INTO public.who_global_data VALUES (36011, 2174, 138068, 31, 2877, 152, 185);
INSERT INTO public.who_global_data VALUES (36012, 513, 73984, 0, 388, 152, 194);
INSERT INTO public.who_global_data VALUES (36013, 0, 509, 0, 21, 152, 144);
INSERT INTO public.who_global_data VALUES (36014, 45350, 6189488, 878, 187541, 152, 19);
INSERT INTO public.who_global_data VALUES (36015, 14, 1181, 1, 17, 152, 217);
INSERT INTO public.who_global_data VALUES (36016, 16, 1669, 0, 45, 152, 148);
INSERT INTO public.who_global_data VALUES (36017, 299, 43775, 7, 350, 152, 86);
INSERT INTO public.who_global_data VALUES (36018, 0, 0, 0, 0, 152, 13);
INSERT INTO public.who_global_data VALUES (36019, 1192, 52165, 8, 420, 152, 157);
INSERT INTO public.who_global_data VALUES (36020, 0, 1049, 0, 35, 152, 8);
INSERT INTO public.who_global_data VALUES (36021, 0, 0, 0, 0, 152, 73);
INSERT INTO public.who_global_data VALUES (36022, 4, 1991, 0, 573, 152, 101);
INSERT INTO public.who_global_data VALUES (36023, 67, 12776, 3, 295, 152, 165);
INSERT INTO public.who_global_data VALUES (36024, 0, 6837, 0, 206, 152, 14);
INSERT INTO public.who_global_data VALUES (36025, 94, 38484, 3, 1416, 153, 193);
INSERT INTO public.who_global_data VALUES (36026, 135, 10102, 6, 312, 153, 113);
INSERT INTO public.who_global_data VALUES (36027, 298, 46071, 10, 1549, 153, 143);
INSERT INTO public.who_global_data VALUES (36028, 0, 0, 0, 0, 153, 219);
INSERT INTO public.who_global_data VALUES (36029, 0, 1215, 0, 53, 153, 186);
INSERT INTO public.who_global_data VALUES (36030, 59, 2935, 2, 117, 153, 52);
INSERT INTO public.who_global_data VALUES (36031, 0, 3, 0, 0, 153, 180);
INSERT INTO public.who_global_data VALUES (36032, 0, 95, 0, 3, 153, 167);
INSERT INTO public.who_global_data VALUES (36033, 10684, 461882, 217, 9685, 153, 154);
INSERT INTO public.who_global_data VALUES (36034, 134, 44096, 2, 892, 153, 94);
INSERT INTO public.who_global_data VALUES (36035, 0, 2292, 0, 13, 153, 66);
INSERT INTO public.who_global_data VALUES (36036, 71, 26207, 11, 748, 153, 58);
INSERT INTO public.who_global_data VALUES (36037, 208, 28974, 0, 735, 153, 163);
INSERT INTO public.who_global_data VALUES (36038, 161, 37192, 2, 545, 153, 37);
INSERT INTO public.who_global_data VALUES (36039, 90, 2476, 5, 55, 153, 142);
INSERT INTO public.who_global_data VALUES (36040, 676, 54771, 1, 196, 153, 83);
INSERT INTO public.who_global_data VALUES (36041, 1950, 323565, 35, 4447, 153, 228);
INSERT INTO public.who_global_data VALUES (36042, 1, 178, 0, 7, 153, 188);
INSERT INTO public.who_global_data VALUES (36043, 178, 72663, 4, 705, 153, 62);
INSERT INTO public.who_global_data VALUES (36044, 322, 88996, 1, 9899, 153, 160);
INSERT INTO public.who_global_data VALUES (36045, 34, 1152, 2, 15, 153, 50);
INSERT INTO public.who_global_data VALUES (36046, 0, 2213, 0, 40, 153, 33);
INSERT INTO public.who_global_data VALUES (36047, 1, 175, 0, 9, 153, 183);
INSERT INTO public.who_global_data VALUES (36048, 0, 228, 0, 0, 153, 92);
INSERT INTO public.who_global_data VALUES (36049, 799, 119580, 55, 5343, 153, 158);
INSERT INTO public.who_global_data VALUES (36050, 0, 9, 0, 0, 153, 67);
INSERT INTO public.who_global_data VALUES (36051, 236, 21434, 12, 644, 153, 57);
INSERT INTO public.who_global_data VALUES (36052, 0, 2002, 0, 8, 153, 38);
INSERT INTO public.who_global_data VALUES (36053, 51194, 4092832, 907, 125521, 153, 141);
INSERT INTO public.who_global_data VALUES (36054, 0, 63, 0, 1, 153, 178);
INSERT INTO public.who_global_data VALUES (36055, 0, 145, 0, 3, 153, 108);
INSERT INTO public.who_global_data VALUES (36056, 179, 16954, 7, 665, 153, 39);
INSERT INTO public.who_global_data VALUES (36057, 22, 1408, 0, 55, 153, 2);
INSERT INTO public.who_global_data VALUES (36058, 2, 462, 0, 1, 153, 195);
INSERT INTO public.who_global_data VALUES (36059, 75, 4275, 1, 42, 153, 107);
INSERT INTO public.who_global_data VALUES (36060, 0, 274, 0, 0, 153, 161);
INSERT INTO public.who_global_data VALUES (36061, 0, 19604, 0, 415, 153, 212);
INSERT INTO public.who_global_data VALUES (36062, 631, 131124, 0, 9141, 153, 181);
INSERT INTO public.who_global_data VALUES (36063, 0, 205, 0, 1, 153, 53);
INSERT INTO public.who_global_data VALUES (36064, 0, 4729, 0, 62, 153, 164);
INSERT INTO public.who_global_data VALUES (36065, 11, 1034, 0, 77, 153, 140);
INSERT INTO public.who_global_data VALUES (36066, 1965, 420434, 57, 11551, 153, 20);
INSERT INTO public.who_global_data VALUES (36067, 19, 90517, 0, 4735, 153, 112);
INSERT INTO public.who_global_data VALUES (36068, 8488, 650062, 270, 20888, 153, 111);
INSERT INTO public.who_global_data VALUES (36069, 0, 448, 0, 7, 153, 71);
INSERT INTO public.who_global_data VALUES (36070, 0, 4628, 0, 82, 153, 218);
INSERT INTO public.who_global_data VALUES (36071, 0, 0, 0, 0, 153, 43);
INSERT INTO public.who_global_data VALUES (36072, 1222, 45680, 9, 469, 153, 49);
INSERT INTO public.who_global_data VALUES (36073, 61, 18269, 0, 119, 153, 1);
INSERT INTO public.who_global_data VALUES (36074, 311, 11739, 2, 197, 153, 48);
INSERT INTO public.who_global_data VALUES (36075, 32, 4298, 0, 100, 153, 232);
INSERT INTO public.who_global_data VALUES (36076, 0, 78, 0, 1, 153, 175);
INSERT INTO public.who_global_data VALUES (36077, 9, 1507, 0, 21, 153, 21);
INSERT INTO public.who_global_data VALUES (36078, 503, 27752, 2, 431, 153, 156);
INSERT INTO public.who_global_data VALUES (36079, 0, 0, 0, 0, 153, 95);
INSERT INTO public.who_global_data VALUES (36080, 0, 10148, 0, 259, 153, 177);
INSERT INTO public.who_global_data VALUES (36081, 0, 17547, 0, 627, 153, 210);
INSERT INTO public.who_global_data VALUES (36082, 0, 5387, 0, 60, 153, 120);
INSERT INTO public.who_global_data VALUES (36083, 0, 22, 0, 0, 153, 135);
INSERT INTO public.who_global_data VALUES (36084, 2147, 98776, 39, 1840, 153, 206);
INSERT INTO public.who_global_data VALUES (36085, 870, 118045, 50, 6724, 153, 189);
INSERT INTO public.who_global_data VALUES (36086, 130, 99712, 16, 5511, 153, 129);
INSERT INTO public.who_global_data VALUES (36087, 107, 26206, 8, 752, 153, 121);
INSERT INTO public.who_global_data VALUES (36088, 0, 4972, 0, 83, 153, 59);
INSERT INTO public.who_global_data VALUES (36089, 0, 330, 0, 0, 153, 96);
INSERT INTO public.who_global_data VALUES (36090, 34, 2490, 0, 64, 153, 41);
INSERT INTO public.who_global_data VALUES (36091, 39, 4819, 0, 94, 153, 216);
INSERT INTO public.who_global_data VALUES (36092, 950, 57466, 17, 897, 153, 236);
INSERT INTO public.who_global_data VALUES (36093, 0, 13, 0, 0, 153, 150);
INSERT INTO public.who_global_data VALUES (36094, 0, 413, 0, 0, 153, 61);
INSERT INTO public.who_global_data VALUES (36095, 0, 31, 0, 2, 153, 7);
INSERT INTO public.who_global_data VALUES (36096, 36, 8261, 1, 336, 153, 169);
INSERT INTO public.who_global_data VALUES (36097, 8386, 300511, 11, 30546, 153, 28);
INSERT INTO public.who_global_data VALUES (36098, 46, 9322, 0, 62, 153, 85);
INSERT INTO public.who_global_data VALUES (36099, 26, 720, 0, 0, 153, 211);
INSERT INTO public.who_global_data VALUES (36100, 0, 8601, 0, 53, 153, 60);
INSERT INTO public.who_global_data VALUES (36101, 0, 3120, 0, 99, 153, 3);
INSERT INTO public.who_global_data VALUES (36102, 29, 1650, 0, 19, 153, 11);
INSERT INTO public.who_global_data VALUES (36103, 988, 249985, 1, 9325, 153, 89);
INSERT INTO public.who_global_data VALUES (36104, 0, 44777, 0, 283, 153, 24);
INSERT INTO public.who_global_data VALUES (36105, 7, 305, 0, 0, 153, 162);
INSERT INTO public.who_global_data VALUES (36106, 186, 11386, 1, 280, 153, 100);
INSERT INTO public.who_global_data VALUES (36107, 0, 14, 0, 0, 153, 47);
INSERT INTO public.who_global_data VALUES (36108, 0, 24, 0, 0, 153, 29);
INSERT INTO public.who_global_data VALUES (36109, 0, 1363, 0, 20, 153, 40);
INSERT INTO public.who_global_data VALUES (36110, 52, 1671, 2, 16, 153, 222);
INSERT INTO public.who_global_data VALUES (36111, 441, 77481, 20, 2845, 153, 132);
INSERT INTO public.who_global_data VALUES (36112, 0, 252, 0, 13, 153, 130);
INSERT INTO public.who_global_data VALUES (36113, 73, 9722, 0, 61, 153, 234);
INSERT INTO public.who_global_data VALUES (36114, 0, 2245, 0, 38, 153, 23);
INSERT INTO public.who_global_data VALUES (36115, 15, 1416, 0, 44, 153, 192);
INSERT INTO public.who_global_data VALUES (36116, 0, 8326, 0, 212, 153, 69);
INSERT INTO public.who_global_data VALUES (36117, 0, 12, 0, 0, 153, 187);
INSERT INTO public.who_global_data VALUES (36118, 640, 63798, 30, 1984, 153, 230);
INSERT INTO public.who_global_data VALUES (36119, 510, 7892, 3, 624, 153, 77);
INSERT INTO public.who_global_data VALUES (36120, 1, 2136, 0, 10, 153, 9);
INSERT INTO public.who_global_data VALUES (36121, 90632, 4113811, 1065, 70626, 153, 74);
INSERT INTO public.who_global_data VALUES (36122, 3128, 190665, 108, 7940, 153, 224);
INSERT INTO public.who_global_data VALUES (36123, 1894, 384666, 110, 22154, 153, 199);
INSERT INTO public.who_global_data VALUES (36124, 4644, 256719, 63, 7422, 153, 190);
INSERT INTO public.who_global_data VALUES (36125, 231, 29534, 0, 1777, 153, 12);
INSERT INTO public.who_global_data VALUES (36126, 0, 336, 0, 24, 153, 104);
INSERT INTO public.who_global_data VALUES (36127, 2623, 127645, 12, 1010, 153, 153);
INSERT INTO public.who_global_data VALUES (36128, 1694, 276338, 16, 35534, 153, 91);
INSERT INTO public.who_global_data VALUES (36129, 68, 2964, 1, 30, 153, 215);
INSERT INTO public.who_global_data VALUES (36130, 543, 71419, 8, 1357, 153, 84);
INSERT INTO public.who_global_data VALUES (36131, 1, 384, 0, 32, 153, 231);
INSERT INTO public.who_global_data VALUES (36132, 52, 2421, 0, 16, 153, 196);
INSERT INTO public.who_global_data VALUES (36133, 199, 134123, 70, 1948, 153, 105);
INSERT INTO public.who_global_data VALUES (36134, 136, 35020, 5, 594, 153, 122);
INSERT INTO public.who_global_data VALUES (36135, 0, 0, 0, 0, 153, 159);
INSERT INTO public.who_global_data VALUES (36136, 117, 13984, 5, 546, 153, 75);
INSERT INTO public.who_global_data VALUES (36137, 720, 88963, 3, 540, 153, 27);
INSERT INTO public.who_global_data VALUES (36138, 87, 44403, 0, 1061, 153, 54);
INSERT INTO public.who_global_data VALUES (36139, 0, 22, 0, 0, 153, 226);
INSERT INTO public.who_global_data VALUES (36140, 9, 1425, 0, 35, 153, 79);
INSERT INTO public.who_global_data VALUES (36141, 531, 20011, 4, 187, 153, 56);
INSERT INTO public.who_global_data VALUES (36142, 0, 1148, 0, 31, 153, 117);
INSERT INTO public.who_global_data VALUES (36143, 0, 1306, 0, 82, 153, 152);
INSERT INTO public.who_global_data VALUES (36144, 655, 17749, 13, 285, 153, 16);
INSERT INTO public.who_global_data VALUES (36145, 0, 108, 0, 1, 153, 10);
INSERT INTO public.who_global_data VALUES (36146, 43, 3077, 0, 86, 153, 201);
INSERT INTO public.who_global_data VALUES (36147, 0, 6854, 0, 124, 153, 174);
INSERT INTO public.who_global_data VALUES (36148, 82, 15269, 1, 199, 153, 119);
INSERT INTO public.who_global_data VALUES (36149, 3, 5611, 0, 175, 153, 168);
INSERT INTO public.who_global_data VALUES (36150, 6, 9391, 0, 128, 153, 99);
INSERT INTO public.who_global_data VALUES (36151, 125, 8486, 0, 29, 153, 171);
INSERT INTO public.who_global_data VALUES (36152, 19, 2833, 0, 126, 153, 87);
INSERT INTO public.who_global_data VALUES (36153, 25, 2040, 1, 14, 153, 123);
INSERT INTO public.who_global_data VALUES (36154, 0, 0, 0, 0, 153, 151);
INSERT INTO public.who_global_data VALUES (36155, 4, 758, 0, 18, 153, 213);
INSERT INTO public.who_global_data VALUES (36156, 8, 7134, 0, 160, 153, 118);
INSERT INTO public.who_global_data VALUES (36157, 0, 356, 0, 10, 153, 134);
INSERT INTO public.who_global_data VALUES (36158, 0, 3374, 0, 40, 153, 65);
INSERT INTO public.who_global_data VALUES (36159, 6196, 623090, 522, 66851, 153, 102);
INSERT INTO public.who_global_data VALUES (36160, 0, 0, 0, 0, 153, 223);
INSERT INTO public.who_global_data VALUES (36161, 0, 150, 0, 1, 153, 4);
INSERT INTO public.who_global_data VALUES (36162, 0, 310, 0, 0, 153, 146);
INSERT INTO public.who_global_data VALUES (36163, 87, 5605, 1, 108, 153, 31);
INSERT INTO public.who_global_data VALUES (36164, 0, 13, 0, 1, 153, 127);
INSERT INTO public.who_global_data VALUES (36165, 1555, 70160, 37, 1329, 153, 22);
INSERT INTO public.who_global_data VALUES (36166, 76, 4341, 0, 26, 153, 115);
INSERT INTO public.who_global_data VALUES (36167, 103, 1319, 1, 8, 153, 106);
INSERT INTO public.who_global_data VALUES (36168, 191, 8514, 0, 87, 153, 90);
INSERT INTO public.who_global_data VALUES (36169, 0, 0, 0, 0, 153, 70);
INSERT INTO public.who_global_data VALUES (36170, 1041, 45277, 9, 280, 153, 46);
INSERT INTO public.who_global_data VALUES (36171, 649, 73764, 5, 6240, 153, 139);
INSERT INTO public.who_global_data VALUES (36172, 0, 26, 0, 0, 153, 42);
INSERT INTO public.who_global_data VALUES (36173, 5, 1421, 0, 24, 153, 80);
INSERT INTO public.who_global_data VALUES (36174, 0, 3773, 0, 141, 153, 203);
INSERT INTO public.who_global_data VALUES (36175, 0, 1177, 0, 69, 153, 136);
INSERT INTO public.who_global_data VALUES (36176, 162, 54905, 3, 1054, 153, 63);
INSERT INTO public.who_global_data VALUES (36177, 0, 0, 0, 0, 153, 17);
INSERT INTO public.who_global_data VALUES (36178, 1, 58, 0, 2, 153, 172);
INSERT INTO public.who_global_data VALUES (36179, 127, 14998, 5, 614, 153, 109);
INSERT INTO public.who_global_data VALUES (36180, 0, 11120, 0, 264, 153, 200);
INSERT INTO public.who_global_data VALUES (36181, 433, 33250, 7, 199, 153, 93);
INSERT INTO public.who_global_data VALUES (36182, 0, 86380, 0, 705, 153, 5);
INSERT INTO public.who_global_data VALUES (36183, 0, 741, 0, 13, 153, 214);
INSERT INTO public.who_global_data VALUES (36184, 484, 298509, 2, 6342, 153, 204);
INSERT INTO public.who_global_data VALUES (36185, 0, 0, 0, 0, 153, 198);
INSERT INTO public.who_global_data VALUES (36186, 682, 95596, 17, 2063, 153, 173);
INSERT INTO public.who_global_data VALUES (36187, 9, 488, 0, 5, 153, 229);
INSERT INTO public.who_global_data VALUES (36188, 695, 20654, 25, 398, 153, 76);
INSERT INTO public.who_global_data VALUES (36189, 6703, 676848, 149, 29554, 153, 138);
INSERT INTO public.who_global_data VALUES (36190, 2498, 234570, 53, 3790, 153, 98);
INSERT INTO public.who_global_data VALUES (36191, 0, 0, 0, 0, 153, 103);
INSERT INTO public.who_global_data VALUES (36192, 567, 70387, 13, 2113, 153, 225);
INSERT INTO public.who_global_data VALUES (36193, 486, 59943, 5, 1838, 153, 131);
INSERT INTO public.who_global_data VALUES (36194, 251, 34492, 9, 464, 153, 235);
INSERT INTO public.who_global_data VALUES (36195, 227, 119864, 1, 202, 153, 137);
INSERT INTO public.who_global_data VALUES (36196, 167, 21177, 1, 334, 153, 81);
INSERT INTO public.who_global_data VALUES (36197, 567, 39473, 16, 1063, 153, 182);
INSERT INTO public.who_global_data VALUES (36198, 113, 2115, 1, 6, 153, 145);
INSERT INTO public.who_global_data VALUES (36199, 1269, 93864, 38, 3850, 153, 26);
INSERT INTO public.who_global_data VALUES (36200, 5195, 1025505, 61, 17820, 153, 170);
INSERT INTO public.who_global_data VALUES (36201, 45, 4349, 0, 18, 153, 191);
INSERT INTO public.who_global_data VALUES (36202, 0, 5, 0, 0, 153, 221);
INSERT INTO public.who_global_data VALUES (36203, 0, 18, 0, 0, 153, 64);
INSERT INTO public.who_global_data VALUES (36204, 0, 0, 0, 0, 153, 116);
INSERT INTO public.who_global_data VALUES (36205, 0, 17, 0, 0, 153, 128);
INSERT INTO public.who_global_data VALUES (36206, 0, 26, 0, 0, 153, 6);
INSERT INTO public.who_global_data VALUES (36207, 0, 239, 0, 6, 153, 227);
INSERT INTO public.who_global_data VALUES (36208, 1, 6, 0, 0, 153, 68);
INSERT INTO public.who_global_data VALUES (36209, 0, 61, 0, 0, 153, 184);
INSERT INTO public.who_global_data VALUES (36210, 0, 0, 0, 0, 153, 82);
INSERT INTO public.who_global_data VALUES (36211, 0, 735, 0, 42, 153, 149);
INSERT INTO public.who_global_data VALUES (36212, 1, 898, 0, 15, 153, 197);
INSERT INTO public.who_global_data VALUES (36213, 791, 319932, 34, 4049, 153, 78);
INSERT INTO public.who_global_data VALUES (36214, 0, 13881, 0, 289, 153, 233);
INSERT INTO public.who_global_data VALUES (36215, 77, 31849, 2, 723, 153, 133);
INSERT INTO public.who_global_data VALUES (36216, 0, 135, 0, 0, 153, 35);
INSERT INTO public.who_global_data VALUES (36217, 2, 2043, 0, 71, 153, 114);
INSERT INTO public.who_global_data VALUES (36218, 34, 56982, 0, 27, 153, 237);
INSERT INTO public.who_global_data VALUES (36219, 0, 4, 0, 0, 153, 55);
INSERT INTO public.who_global_data VALUES (36220, 0, 504, 0, 19, 153, 176);
INSERT INTO public.who_global_data VALUES (36221, 226, 4526, 0, 37, 153, 202);
INSERT INTO public.who_global_data VALUES (36222, 43, 3166, 0, 134, 153, 155);
INSERT INTO public.who_global_data VALUES (36223, 0, 0, 0, 0, 153, 32);
INSERT INTO public.who_global_data VALUES (36224, 30, 3362, 0, 97, 153, 220);
INSERT INTO public.who_global_data VALUES (36225, 1806, 636884, 101, 14779, 153, 30);
INSERT INTO public.who_global_data VALUES (36226, 0, 2544, 0, 48, 153, 147);
INSERT INTO public.who_global_data VALUES (36227, 13380, 550111, 72, 31250, 153, 208);
INSERT INTO public.who_global_data VALUES (36228, 6, 3121, 0, 12, 153, 45);
INSERT INTO public.who_global_data VALUES (36229, 30, 13437, 1, 833, 153, 110);
INSERT INTO public.who_global_data VALUES (36230, 37, 4252, 2, 75, 153, 88);
INSERT INTO public.who_global_data VALUES (36231, 262, 85329, 0, 5837, 153, 51);
INSERT INTO public.who_global_data VALUES (36232, 294, 44531, 2, 1769, 153, 209);
INSERT INTO public.who_global_data VALUES (36233, 63, 3104, 3, 130, 153, 205);
INSERT INTO public.who_global_data VALUES (36234, 33, 8757, 1, 70, 153, 18);
INSERT INTO public.who_global_data VALUES (36235, 6, 3444, 0, 58, 153, 72);
INSERT INTO public.who_global_data VALUES (36236, 1813, 344168, 12, 41549, 153, 44);
INSERT INTO public.who_global_data VALUES (36237, 0, 27, 0, 0, 153, 15);
INSERT INTO public.who_global_data VALUES (36238, 0, 1443, 0, 31, 153, 25);
INSERT INTO public.who_global_data VALUES (36239, 0, 0, 0, 0, 153, 179);
INSERT INTO public.who_global_data VALUES (36240, 0, 0, 0, 0, 153, 34);
INSERT INTO public.who_global_data VALUES (36241, 112, 2142, 2, 32, 153, 207);
INSERT INTO public.who_global_data VALUES (36242, 265, 5041, 0, 93, 153, 166);
INSERT INTO public.who_global_data VALUES (36243, 8403, 547428, 56, 6620, 153, 126);
INSERT INTO public.who_global_data VALUES (36244, 0, 0, 0, 0, 153, 97);
INSERT INTO public.who_global_data VALUES (36245, 14, 591, 0, 5, 153, 36);
INSERT INTO public.who_global_data VALUES (36246, 0, 0, 0, 0, 153, 125);
INSERT INTO public.who_global_data VALUES (36247, 186, 3539, 4, 39, 153, 124);
INSERT INTO public.who_global_data VALUES (36248, 2107, 135894, 35, 2846, 153, 185);
INSERT INTO public.who_global_data VALUES (36249, 705, 73471, 1, 388, 153, 194);
INSERT INTO public.who_global_data VALUES (36250, 0, 509, 0, 21, 153, 144);
INSERT INTO public.who_global_data VALUES (36251, 49131, 6144138, 976, 186663, 153, 19);
INSERT INTO public.who_global_data VALUES (36252, 17, 1167, 0, 16, 153, 217);
INSERT INTO public.who_global_data VALUES (36253, 17, 1653, 1, 45, 153, 148);
INSERT INTO public.who_global_data VALUES (36254, 307, 43476, 5, 343, 153, 86);
INSERT INTO public.who_global_data VALUES (36255, 0, 0, 0, 0, 153, 13);
INSERT INTO public.who_global_data VALUES (36256, 1096, 50973, 10, 412, 153, 157);
INSERT INTO public.who_global_data VALUES (36257, 0, 1049, 0, 35, 153, 8);
INSERT INTO public.who_global_data VALUES (36258, 0, 0, 0, 0, 153, 73);
INSERT INTO public.who_global_data VALUES (36259, 0, 1987, 0, 573, 153, 101);
INSERT INTO public.who_global_data VALUES (36260, 70, 12709, 0, 292, 153, 165);
INSERT INTO public.who_global_data VALUES (36261, 0, 6837, 0, 206, 153, 14);
INSERT INTO public.who_global_data VALUES (36262, 16, 38390, 0, 1413, 154, 193);
INSERT INTO public.who_global_data VALUES (36263, 123, 9967, 5, 306, 154, 113);
INSERT INTO public.who_global_data VALUES (36264, 304, 45773, 8, 1539, 154, 143);
INSERT INTO public.who_global_data VALUES (36265, 0, 0, 0, 0, 154, 219);
INSERT INTO public.who_global_data VALUES (36266, 7, 1215, 0, 53, 154, 186);
INSERT INTO public.who_global_data VALUES (36267, 71, 2876, 2, 115, 154, 52);
INSERT INTO public.who_global_data VALUES (36268, 0, 3, 0, 0, 154, 180);
INSERT INTO public.who_global_data VALUES (36269, 0, 95, 0, 3, 154, 167);
INSERT INTO public.who_global_data VALUES (36270, 12026, 451198, 313, 9468, 154, 154);
INSERT INTO public.who_global_data VALUES (36271, 188, 43962, 4, 890, 154, 94);
INSERT INTO public.who_global_data VALUES (36272, 81, 2292, 1, 13, 154, 66);
INSERT INTO public.who_global_data VALUES (36273, 87, 26136, 59, 737, 154, 58);
INSERT INTO public.who_global_data VALUES (36274, 271, 28766, 0, 735, 154, 163);
INSERT INTO public.who_global_data VALUES (36275, 132, 37031, 2, 543, 154, 37);
INSERT INTO public.who_global_data VALUES (36276, 49, 2386, 3, 50, 154, 142);
INSERT INTO public.who_global_data VALUES (36277, 662, 54095, 5, 195, 154, 83);
INSERT INTO public.who_global_data VALUES (36278, 1929, 321615, 29, 4412, 154, 228);
INSERT INTO public.who_global_data VALUES (36279, 0, 177, 0, 7, 154, 188);
INSERT INTO public.who_global_data VALUES (36280, 183, 72485, 5, 701, 154, 62);
INSERT INTO public.who_global_data VALUES (36281, 728, 88674, 2, 9898, 154, 160);
INSERT INTO public.who_global_data VALUES (36282, 17, 1118, 0, 13, 154, 50);
INSERT INTO public.who_global_data VALUES (36283, 19, 2213, 0, 40, 154, 33);
INSERT INTO public.who_global_data VALUES (36284, 2, 174, 0, 9, 154, 183);
INSERT INTO public.who_global_data VALUES (36285, 1, 228, 0, 0, 154, 92);
INSERT INTO public.who_global_data VALUES (36286, 853, 118781, 85, 5288, 154, 158);
INSERT INTO public.who_global_data VALUES (36287, 0, 9, 0, 0, 154, 67);
INSERT INTO public.who_global_data VALUES (36288, 337, 21198, 2, 632, 154, 57);
INSERT INTO public.who_global_data VALUES (36289, 278, 2002, 2, 8, 154, 38);
INSERT INTO public.who_global_data VALUES (36290, 43773, 4041638, 834, 124614, 154, 141);
INSERT INTO public.who_global_data VALUES (36291, 16, 63, 0, 1, 154, 178);
INSERT INTO public.who_global_data VALUES (36292, 0, 145, 0, 3, 154, 108);
INSERT INTO public.who_global_data VALUES (36293, 158, 16775, 10, 658, 154, 39);
INSERT INTO public.who_global_data VALUES (36294, 8, 1386, 0, 55, 154, 2);
INSERT INTO public.who_global_data VALUES (36295, 9, 460, 0, 1, 154, 195);
INSERT INTO public.who_global_data VALUES (36296, 75, 4200, 0, 41, 154, 107);
INSERT INTO public.who_global_data VALUES (36297, 0, 274, 0, 0, 154, 161);
INSERT INTO public.who_global_data VALUES (36298, 0, 19604, 0, 415, 154, 212);
INSERT INTO public.who_global_data VALUES (36299, 570, 130493, 6, 9141, 154, 181);
INSERT INTO public.who_global_data VALUES (36300, 0, 205, 0, 1, 154, 53);
INSERT INTO public.who_global_data VALUES (36301, 0, 4729, 0, 62, 154, 164);
INSERT INTO public.who_global_data VALUES (36302, 5, 1023, 0, 77, 154, 140);
INSERT INTO public.who_global_data VALUES (36303, 1968, 418469, 72, 11494, 154, 20);
INSERT INTO public.who_global_data VALUES (36304, 23, 90498, 0, 4735, 154, 112);
INSERT INTO public.who_global_data VALUES (36305, 8235, 641574, 270, 20618, 154, 111);
INSERT INTO public.who_global_data VALUES (36306, 0, 448, 0, 7, 154, 71);
INSERT INTO public.who_global_data VALUES (36307, 0, 4628, 0, 82, 154, 218);
INSERT INTO public.who_global_data VALUES (36308, 0, 0, 0, 0, 154, 43);
INSERT INTO public.who_global_data VALUES (36309, 1153, 44458, 7, 460, 154, 49);
INSERT INTO public.who_global_data VALUES (36310, 47, 18208, 2, 119, 154, 1);
INSERT INTO public.who_global_data VALUES (36311, 334, 11428, 1, 195, 154, 48);
INSERT INTO public.who_global_data VALUES (36312, 52, 4266, 0, 100, 154, 232);
INSERT INTO public.who_global_data VALUES (36313, 3, 78, 0, 1, 154, 175);
INSERT INTO public.who_global_data VALUES (36314, 0, 1498, 0, 21, 154, 21);
INSERT INTO public.who_global_data VALUES (36315, 797, 27249, 3, 429, 154, 156);
INSERT INTO public.who_global_data VALUES (36316, 0, 0, 0, 0, 154, 95);
INSERT INTO public.who_global_data VALUES (36317, 35, 10148, 0, 259, 154, 177);
INSERT INTO public.who_global_data VALUES (36318, 173, 17547, 1, 627, 154, 210);
INSERT INTO public.who_global_data VALUES (36319, 0, 5387, 0, 60, 154, 120);
INSERT INTO public.who_global_data VALUES (36320, 2, 22, 0, 0, 154, 135);
INSERT INTO public.who_global_data VALUES (36321, 0, 96629, 0, 1801, 154, 206);
INSERT INTO public.who_global_data VALUES (36322, 815, 117175, 26, 6674, 154, 189);
INSERT INTO public.who_global_data VALUES (36323, 157, 99582, 16, 5495, 154, 129);
INSERT INTO public.who_global_data VALUES (36324, 99, 26099, 5, 744, 154, 121);
INSERT INTO public.who_global_data VALUES (36325, 7, 4972, 0, 83, 154, 59);
INSERT INTO public.who_global_data VALUES (36326, 0, 330, 0, 0, 154, 96);
INSERT INTO public.who_global_data VALUES (36327, 15, 2456, 0, 64, 154, 41);
INSERT INTO public.who_global_data VALUES (36328, 60, 4780, 0, 94, 154, 216);
INSERT INTO public.who_global_data VALUES (36329, 1303, 56516, 24, 880, 154, 236);
INSERT INTO public.who_global_data VALUES (36330, 0, 13, 0, 0, 154, 150);
INSERT INTO public.who_global_data VALUES (36331, 1, 413, 0, 0, 154, 61);
INSERT INTO public.who_global_data VALUES (36332, 0, 31, 0, 2, 154, 7);
INSERT INTO public.who_global_data VALUES (36333, 25, 8225, 0, 335, 154, 169);
INSERT INTO public.who_global_data VALUES (36334, 8860, 292125, -1, 30535, 154, 28);
INSERT INTO public.who_global_data VALUES (36335, 25, 9276, 1, 62, 154, 85);
INSERT INTO public.who_global_data VALUES (36336, 36, 694, 0, 0, 154, 211);
INSERT INTO public.who_global_data VALUES (36337, 63, 8601, 0, 53, 154, 60);
INSERT INTO public.who_global_data VALUES (36338, 19, 3120, 0, 99, 154, 3);
INSERT INTO public.who_global_data VALUES (36339, 25, 1621, 0, 19, 154, 11);
INSERT INTO public.who_global_data VALUES (36340, 1378, 248997, 2, 9324, 154, 89);
INSERT INTO public.who_global_data VALUES (36341, 64, 44777, 3, 283, 154, 24);
INSERT INTO public.who_global_data VALUES (36342, 3, 298, 0, 0, 154, 162);
INSERT INTO public.who_global_data VALUES (36343, 202, 11200, 1, 279, 154, 100);
INSERT INTO public.who_global_data VALUES (36344, 0, 14, 0, 0, 154, 47);
INSERT INTO public.who_global_data VALUES (36345, 0, 24, 0, 0, 154, 29);
INSERT INTO public.who_global_data VALUES (36346, 0, 1363, 0, 20, 154, 40);
INSERT INTO public.who_global_data VALUES (36347, 59, 1619, 1, 14, 154, 222);
INSERT INTO public.who_global_data VALUES (36348, 682, 77040, 21, 2825, 154, 132);
INSERT INTO public.who_global_data VALUES (36349, 0, 252, 0, 13, 154, 130);
INSERT INTO public.who_global_data VALUES (36350, 70, 9649, 0, 61, 154, 234);
INSERT INTO public.who_global_data VALUES (36351, 0, 2245, 0, 38, 154, 23);
INSERT INTO public.who_global_data VALUES (36352, 19, 1401, 3, 44, 154, 192);
INSERT INTO public.who_global_data VALUES (36353, 68, 8326, 6, 212, 154, 69);
INSERT INTO public.who_global_data VALUES (36354, 0, 12, 0, 0, 154, 187);
INSERT INTO public.who_global_data VALUES (36355, 632, 63158, 30, 1954, 154, 230);
INSERT INTO public.who_global_data VALUES (36356, 459, 7382, 1, 621, 154, 77);
INSERT INTO public.who_global_data VALUES (36357, 7, 2135, 0, 10, 154, 9);
INSERT INTO public.who_global_data VALUES (36358, 86432, 4023179, 1089, 69561, 154, 74);
INSERT INTO public.who_global_data VALUES (36359, 3269, 187537, 82, 7832, 154, 224);
INSERT INTO public.who_global_data VALUES (36360, 2026, 382772, 118, 22044, 154, 199);
INSERT INTO public.who_global_data VALUES (36361, 5036, 252075, 84, 7359, 154, 190);
INSERT INTO public.who_global_data VALUES (36362, 97, 29303, 0, 1777, 154, 12);
INSERT INTO public.who_global_data VALUES (36363, 0, 336, 0, 24, 154, 104);
INSERT INTO public.who_global_data VALUES (36364, 2661, 125022, 16, 998, 154, 153);
INSERT INTO public.who_global_data VALUES (36365, 1732, 274644, 11, 35518, 154, 91);
INSERT INTO public.who_global_data VALUES (36366, 73, 2896, 2, 29, 154, 215);
INSERT INTO public.who_global_data VALUES (36367, 608, 70876, 19, 1349, 154, 84);
INSERT INTO public.who_global_data VALUES (36368, 1, 383, 0, 32, 154, 231);
INSERT INTO public.who_global_data VALUES (36369, 68, 2369, 0, 16, 154, 196);
INSERT INTO public.who_global_data VALUES (36370, 499, 133924, 0, 1878, 154, 105);
INSERT INTO public.who_global_data VALUES (36371, 179, 34884, 4, 589, 154, 122);
INSERT INTO public.who_global_data VALUES (36372, 0, 0, 0, 0, 154, 159);
INSERT INTO public.who_global_data VALUES (36373, 119, 13867, 3, 541, 154, 75);
INSERT INTO public.who_global_data VALUES (36374, 865, 88243, 1, 537, 154, 27);
INSERT INTO public.who_global_data VALUES (36375, 89, 44316, 0, 1061, 154, 54);
INSERT INTO public.who_global_data VALUES (36376, 0, 22, 0, 0, 154, 226);
INSERT INTO public.who_global_data VALUES (36377, 6, 1416, 1, 35, 154, 79);
INSERT INTO public.who_global_data VALUES (36378, 527, 19480, 4, 183, 154, 56);
INSERT INTO public.who_global_data VALUES (36379, 0, 1148, 0, 31, 154, 117);
INSERT INTO public.who_global_data VALUES (36380, 0, 1306, 0, 82, 154, 152);
INSERT INTO public.who_global_data VALUES (36381, 649, 17094, 10, 272, 154, 16);
INSERT INTO public.who_global_data VALUES (36382, 0, 108, 0, 1, 154, 10);
INSERT INTO public.who_global_data VALUES (36383, 36, 3034, 0, 86, 154, 201);
INSERT INTO public.who_global_data VALUES (36384, 109, 6854, 0, 124, 154, 174);
INSERT INTO public.who_global_data VALUES (36385, 81, 15187, 1, 198, 154, 119);
INSERT INTO public.who_global_data VALUES (36386, 15, 5608, 0, 175, 154, 168);
INSERT INTO public.who_global_data VALUES (36387, 11, 9385, 0, 128, 154, 99);
INSERT INTO public.who_global_data VALUES (36388, 80, 8361, 0, 29, 154, 171);
INSERT INTO public.who_global_data VALUES (36389, 7, 2814, 0, 126, 154, 87);
INSERT INTO public.who_global_data VALUES (36390, 30, 2015, 0, 13, 154, 123);
INSERT INTO public.who_global_data VALUES (36391, 0, 0, 0, 0, 154, 151);
INSERT INTO public.who_global_data VALUES (36392, 0, 754, 0, 18, 154, 213);
INSERT INTO public.who_global_data VALUES (36393, 20, 7126, 0, 160, 154, 118);
INSERT INTO public.who_global_data VALUES (36394, 0, 356, 0, 10, 154, 134);
INSERT INTO public.who_global_data VALUES (36395, 0, 3374, 0, 40, 154, 65);
INSERT INTO public.who_global_data VALUES (36396, 5937, 616894, 513, 66329, 154, 102);
INSERT INTO public.who_global_data VALUES (36397, 0, 0, 0, 0, 154, 223);
INSERT INTO public.who_global_data VALUES (36398, 4, 150, 0, 1, 154, 4);
INSERT INTO public.who_global_data VALUES (36399, 4, 310, 0, 0, 154, 146);
INSERT INTO public.who_global_data VALUES (36400, 139, 5518, 1, 107, 154, 31);
INSERT INTO public.who_global_data VALUES (36401, 0, 13, 0, 1, 154, 127);
INSERT INTO public.who_global_data VALUES (36402, 1750, 68605, 39, 1292, 154, 22);
INSERT INTO public.who_global_data VALUES (36403, 58, 4265, 0, 26, 154, 115);
INSERT INTO public.who_global_data VALUES (36404, 83, 1216, 0, 7, 154, 106);
INSERT INTO public.who_global_data VALUES (36405, 241, 8323, 1, 87, 154, 90);
INSERT INTO public.who_global_data VALUES (36406, 0, 0, 0, 0, 154, 70);
INSERT INTO public.who_global_data VALUES (36407, 1359, 44236, 14, 271, 154, 46);
INSERT INTO public.who_global_data VALUES (36408, 743, 73115, 2, 6235, 154, 139);
INSERT INTO public.who_global_data VALUES (36409, 0, 26, 0, 0, 154, 42);
INSERT INTO public.who_global_data VALUES (36410, 3, 1416, 2, 24, 154, 80);
INSERT INTO public.who_global_data VALUES (36411, 0, 3773, 0, 141, 154, 203);
INSERT INTO public.who_global_data VALUES (36412, 0, 1177, 0, 69, 154, 136);
INSERT INTO public.who_global_data VALUES (36413, 155, 54743, 3, 1051, 154, 63);
INSERT INTO public.who_global_data VALUES (36414, 0, 0, 0, 0, 154, 17);
INSERT INTO public.who_global_data VALUES (36415, 0, 57, 0, 2, 154, 172);
INSERT INTO public.who_global_data VALUES (36416, 109, 14871, 3, 609, 154, 109);
INSERT INTO public.who_global_data VALUES (36417, 85, 11120, 0, 264, 154, 200);
INSERT INTO public.who_global_data VALUES (36418, 888, 32817, 3, 192, 154, 93);
INSERT INTO public.who_global_data VALUES (36419, 0, 86380, 0, 705, 154, 5);
INSERT INTO public.who_global_data VALUES (36420, 0, 741, 0, 13, 154, 214);
INSERT INTO public.who_global_data VALUES (36421, 513, 298025, 5, 6340, 154, 204);
INSERT INTO public.who_global_data VALUES (36422, 0, 0, 0, 0, 154, 198);
INSERT INTO public.who_global_data VALUES (36423, 830, 94914, 16, 2046, 154, 173);
INSERT INTO public.who_global_data VALUES (36424, 8, 479, 0, 5, 154, 229);
INSERT INTO public.who_global_data VALUES (36425, 821, 19959, 15, 373, 154, 76);
INSERT INTO public.who_global_data VALUES (36426, 6708, 670145, 146, 29405, 154, 138);
INSERT INTO public.who_global_data VALUES (36427, 3669, 232072, 49, 3737, 154, 98);
INSERT INTO public.who_global_data VALUES (36428, 0, 0, 0, 0, 154, 103);
INSERT INTO public.who_global_data VALUES (36429, 691, 69820, 8, 2100, 154, 225);
INSERT INTO public.who_global_data VALUES (36430, 406, 59457, 4, 1833, 154, 131);
INSERT INTO public.who_global_data VALUES (36431, 43, 34241, 7, 455, 154, 235);
INSERT INTO public.who_global_data VALUES (36432, 217, 119637, 0, 201, 154, 137);
INSERT INTO public.who_global_data VALUES (36433, 168, 21010, 2, 333, 154, 81);
INSERT INTO public.who_global_data VALUES (36434, 534, 38906, 11, 1047, 154, 182);
INSERT INTO public.who_global_data VALUES (36435, 90, 2002, 0, 5, 154, 145);
INSERT INTO public.who_global_data VALUES (36436, 1339, 92595, 47, 3812, 154, 26);
INSERT INTO public.who_global_data VALUES (36437, 5205, 1020310, 110, 17759, 154, 170);
INSERT INTO public.who_global_data VALUES (36438, 49, 4304, 0, 18, 154, 191);
INSERT INTO public.who_global_data VALUES (36439, 0, 5, 0, 0, 154, 221);
INSERT INTO public.who_global_data VALUES (36440, 0, 18, 0, 0, 154, 64);
INSERT INTO public.who_global_data VALUES (36441, 0, 0, 0, 0, 154, 116);
INSERT INTO public.who_global_data VALUES (36442, 0, 17, 0, 0, 154, 128);
INSERT INTO public.who_global_data VALUES (36443, 0, 26, 0, 0, 154, 6);
INSERT INTO public.who_global_data VALUES (36444, 0, 239, 0, 6, 154, 227);
INSERT INTO public.who_global_data VALUES (36445, 0, 5, 0, 0, 154, 68);
INSERT INTO public.who_global_data VALUES (36446, 0, 61, 0, 0, 154, 184);
INSERT INTO public.who_global_data VALUES (36447, 0, 0, 0, 0, 154, 82);
INSERT INTO public.who_global_data VALUES (36448, 0, 735, 0, 42, 154, 149);
INSERT INTO public.who_global_data VALUES (36449, 0, 897, 0, 15, 154, 197);
INSERT INTO public.who_global_data VALUES (36450, 822, 319141, 33, 4015, 154, 78);
INSERT INTO public.who_global_data VALUES (36451, 55, 13881, 2, 289, 154, 233);
INSERT INTO public.who_global_data VALUES (36452, 96, 31772, 3, 721, 154, 133);
INSERT INTO public.who_global_data VALUES (36453, 0, 135, 0, 0, 154, 35);
INSERT INTO public.who_global_data VALUES (36454, 6, 2041, 0, 71, 154, 114);
INSERT INTO public.who_global_data VALUES (36455, 40, 56948, 0, 27, 154, 237);
INSERT INTO public.who_global_data VALUES (36456, 0, 4, 0, 0, 154, 55);
INSERT INTO public.who_global_data VALUES (36457, 9, 504, 0, 19, 154, 176);
INSERT INTO public.who_global_data VALUES (36458, 137, 4300, 0, 37, 154, 202);
INSERT INTO public.who_global_data VALUES (36459, 43, 3123, 1, 134, 154, 155);
INSERT INTO public.who_global_data VALUES (36460, 0, 0, 0, 0, 154, 32);
INSERT INTO public.who_global_data VALUES (36461, 22, 3332, 0, 97, 154, 220);
INSERT INTO public.who_global_data VALUES (36462, 2063, 635078, 289, 14678, 154, 30);
INSERT INTO public.who_global_data VALUES (36463, 8, 2544, 1, 48, 154, 147);
INSERT INTO public.who_global_data VALUES (36464, 11118, 536731, 74, 31178, 154, 208);
INSERT INTO public.who_global_data VALUES (36465, 4, 3115, 0, 12, 154, 45);
INSERT INTO public.who_global_data VALUES (36466, 218, 13407, 9, 832, 154, 110);
INSERT INTO public.who_global_data VALUES (36467, 66, 4215, 1, 73, 154, 88);
INSERT INTO public.who_global_data VALUES (36468, 286, 85067, 2, 5837, 154, 51);
INSERT INTO public.who_global_data VALUES (36469, 426, 44237, 2, 1767, 154, 209);
INSERT INTO public.who_global_data VALUES (36470, 68, 3041, 3, 127, 154, 205);
INSERT INTO public.who_global_data VALUES (36471, 34, 8724, 0, 69, 154, 18);
INSERT INTO public.who_global_data VALUES (36472, 7, 3438, 0, 58, 154, 72);
INSERT INTO public.who_global_data VALUES (36473, 1940, 342355, 10, 41537, 154, 44);
INSERT INTO public.who_global_data VALUES (36474, 0, 27, 0, 0, 154, 15);
INSERT INTO public.who_global_data VALUES (36475, 0, 1443, 0, 31, 154, 25);
INSERT INTO public.who_global_data VALUES (36476, 0, 0, 0, 0, 154, 179);
INSERT INTO public.who_global_data VALUES (36477, 0, 0, 0, 0, 154, 34);
INSERT INTO public.who_global_data VALUES (36478, 89, 2030, 2, 30, 154, 207);
INSERT INTO public.who_global_data VALUES (36479, 234, 4776, 6, 93, 154, 166);
INSERT INTO public.who_global_data VALUES (36480, 8342, 539025, 53, 6564, 154, 126);
INSERT INTO public.who_global_data VALUES (36481, 0, 0, 0, 0, 154, 97);
INSERT INTO public.who_global_data VALUES (36482, 22, 577, 1, 5, 154, 36);
INSERT INTO public.who_global_data VALUES (36483, 0, 0, 0, 0, 154, 125);
INSERT INTO public.who_global_data VALUES (36484, 65, 3353, 2, 35, 154, 124);
INSERT INTO public.who_global_data VALUES (36485, 2836, 133787, 50, 2811, 154, 185);
INSERT INTO public.who_global_data VALUES (36486, 612, 72766, 0, 387, 154, 194);
INSERT INTO public.who_global_data VALUES (36487, 0, 509, 0, 21, 154, 144);
INSERT INTO public.who_global_data VALUES (36488, 44563, 6095007, 1073, 185687, 154, 19);
INSERT INTO public.who_global_data VALUES (36489, 6, 1150, 1, 16, 154, 217);
INSERT INTO public.who_global_data VALUES (36490, 10, 1636, 0, 44, 154, 148);
INSERT INTO public.who_global_data VALUES (36491, 266, 43169, 2, 338, 154, 86);
INSERT INTO public.who_global_data VALUES (36492, 0, 0, 0, 0, 154, 13);
INSERT INTO public.who_global_data VALUES (36493, 994, 49877, 4, 402, 154, 157);
INSERT INTO public.who_global_data VALUES (36494, 3, 1049, 0, 35, 154, 8);
INSERT INTO public.who_global_data VALUES (36495, 0, 0, 0, 0, 154, 73);
INSERT INTO public.who_global_data VALUES (36496, 4, 1987, 1, 573, 154, 101);
INSERT INTO public.who_global_data VALUES (36497, 116, 12639, 0, 292, 154, 165);
INSERT INTO public.who_global_data VALUES (36498, 159, 6837, 0, 206, 154, 14);
INSERT INTO public.who_global_data VALUES (36499, 0, 38374, 0, 1413, 155, 193);
INSERT INTO public.who_global_data VALUES (36500, 116, 9844, 5, 301, 155, 113);
INSERT INTO public.who_global_data VALUES (36501, 311, 45469, 6, 1531, 155, 143);
INSERT INTO public.who_global_data VALUES (36502, 0, 0, 0, 0, 155, 219);
INSERT INTO public.who_global_data VALUES (36503, 9, 1208, 0, 53, 155, 186);
INSERT INTO public.who_global_data VALUES (36504, 28, 2805, 1, 113, 155, 52);
INSERT INTO public.who_global_data VALUES (36505, 0, 3, 0, 0, 155, 180);
INSERT INTO public.who_global_data VALUES (36506, 1, 95, 0, 3, 155, 167);
INSERT INTO public.who_global_data VALUES (36507, 10933, 439172, 184, 9155, 155, 154);
INSERT INTO public.who_global_data VALUES (36508, 190, 43774, 4, 886, 155, 94);
INSERT INTO public.who_global_data VALUES (36509, 107, 2211, 2, 12, 155, 66);
INSERT INTO public.who_global_data VALUES (36510, 126, 26049, 15, 678, 155, 58);
INSERT INTO public.who_global_data VALUES (36511, 312, 28495, 1, 735, 155, 163);
INSERT INTO public.who_global_data VALUES (36512, 167, 36899, 3, 541, 155, 37);
INSERT INTO public.who_global_data VALUES (36513, 61, 2337, 1, 47, 155, 142);
INSERT INTO public.who_global_data VALUES (36514, 626, 53433, 0, 190, 155, 83);
INSERT INTO public.who_global_data VALUES (36515, 2158, 319686, 32, 4383, 155, 228);
INSERT INTO public.who_global_data VALUES (36516, 1, 177, 0, 7, 155, 188);
INSERT INTO public.who_global_data VALUES (36517, 161, 72302, 5, 696, 155, 62);
INSERT INTO public.who_global_data VALUES (36518, 677, 87946, 4, 9896, 155, 160);
INSERT INTO public.who_global_data VALUES (36519, 51, 1101, 0, 13, 155, 50);
INSERT INTO public.who_global_data VALUES (36520, 0, 2194, 0, 40, 155, 33);
INSERT INTO public.who_global_data VALUES (36521, 0, 172, 0, 9, 155, 183);
INSERT INTO public.who_global_data VALUES (36522, 0, 227, 0, 0, 155, 92);
INSERT INTO public.who_global_data VALUES (36523, 661, 117928, 102, 5203, 155, 158);
INSERT INTO public.who_global_data VALUES (36524, 0, 9, 0, 0, 155, 67);
INSERT INTO public.who_global_data VALUES (36525, 287, 20861, 9, 630, 155, 57);
INSERT INTO public.who_global_data VALUES (36526, 0, 1724, 0, 6, 155, 38);
INSERT INTO public.who_global_data VALUES (36527, 46934, 3997865, 1184, 123780, 155, 141);
INSERT INTO public.who_global_data VALUES (36528, 0, 47, 0, 1, 155, 178);
INSERT INTO public.who_global_data VALUES (36529, 1, 145, 0, 3, 155, 108);
INSERT INTO public.who_global_data VALUES (36530, 163, 16617, 6, 648, 155, 39);
INSERT INTO public.who_global_data VALUES (36531, 3, 1378, 0, 55, 155, 2);
INSERT INTO public.who_global_data VALUES (36532, 3, 451, 0, 1, 155, 195);
INSERT INTO public.who_global_data VALUES (36533, 77, 4125, 0, 41, 155, 107);
INSERT INTO public.who_global_data VALUES (36534, 0, 274, 0, 0, 155, 161);
INSERT INTO public.who_global_data VALUES (36535, 144, 19604, 0, 415, 155, 212);
INSERT INTO public.who_global_data VALUES (36536, 498, 129923, 3, 9135, 155, 181);
INSERT INTO public.who_global_data VALUES (36537, 0, 205, 0, 1, 155, 53);
INSERT INTO public.who_global_data VALUES (36538, 17, 4729, 0, 62, 155, 164);
INSERT INTO public.who_global_data VALUES (36539, 1, 1018, 0, 77, 155, 140);
INSERT INTO public.who_global_data VALUES (36540, 1762, 416501, 78, 11422, 155, 20);
INSERT INTO public.who_global_data VALUES (36541, 33, 90475, 1, 4735, 155, 112);
INSERT INTO public.who_global_data VALUES (36542, 9270, 633339, 296, 20348, 155, 111);
INSERT INTO public.who_global_data VALUES (36543, 21, 448, 0, 7, 155, 71);
INSERT INTO public.who_global_data VALUES (36544, 0, 4628, 0, 82, 155, 218);
INSERT INTO public.who_global_data VALUES (36545, 0, 0, 0, 0, 155, 43);
INSERT INTO public.who_global_data VALUES (36546, 1121, 43305, 10, 453, 155, 49);
INSERT INTO public.who_global_data VALUES (36547, 58, 18161, 0, 117, 155, 1);
INSERT INTO public.who_global_data VALUES (36548, 369, 11094, 3, 194, 155, 48);
INSERT INTO public.who_global_data VALUES (36549, 88, 4214, 2, 100, 155, 232);
INSERT INTO public.who_global_data VALUES (36550, 4, 75, 0, 1, 155, 175);
INSERT INTO public.who_global_data VALUES (36551, 3, 1498, 0, 21, 155, 21);
INSERT INTO public.who_global_data VALUES (36552, 679, 26452, 1, 426, 155, 156);
INSERT INTO public.who_global_data VALUES (36553, 0, 0, 0, 0, 155, 95);
INSERT INTO public.who_global_data VALUES (36554, 0, 10113, 0, 259, 155, 177);
INSERT INTO public.who_global_data VALUES (36555, 179, 17374, 0, 626, 155, 210);
INSERT INTO public.who_global_data VALUES (36556, 0, 5387, 0, 60, 155, 120);
INSERT INTO public.who_global_data VALUES (36557, 0, 20, 0, 0, 155, 135);
INSERT INTO public.who_global_data VALUES (36558, 1002, 96629, 36, 1801, 155, 206);
INSERT INTO public.who_global_data VALUES (36559, 903, 116360, 29, 6648, 155, 189);
INSERT INTO public.who_global_data VALUES (36560, 145, 99425, 18, 5479, 155, 129);
INSERT INTO public.who_global_data VALUES (36561, 96, 26000, 8, 739, 155, 121);
INSERT INTO public.who_global_data VALUES (36562, 0, 4965, 0, 83, 155, 59);
INSERT INTO public.who_global_data VALUES (36563, 11, 330, 0, 0, 155, 96);
INSERT INTO public.who_global_data VALUES (36564, 26, 2441, 0, 64, 155, 41);
INSERT INTO public.who_global_data VALUES (36565, 52, 4720, 0, 94, 155, 216);
INSERT INTO public.who_global_data VALUES (36566, 804, 55213, 10, 856, 155, 236);
INSERT INTO public.who_global_data VALUES (36567, 0, 13, 0, 0, 155, 150);
INSERT INTO public.who_global_data VALUES (36568, 1, 412, 0, 0, 155, 61);
INSERT INTO public.who_global_data VALUES (36569, 2, 31, 0, 2, 155, 7);
INSERT INTO public.who_global_data VALUES (36570, 39, 8200, 0, 335, 155, 169);
INSERT INTO public.who_global_data VALUES (36571, 6799, 283265, -3, 30536, 155, 28);
INSERT INTO public.who_global_data VALUES (36572, 42, 9251, 0, 61, 155, 85);
INSERT INTO public.who_global_data VALUES (36573, 36, 658, 0, 0, 155, 211);
INSERT INTO public.who_global_data VALUES (36574, 0, 8538, 0, 53, 155, 60);
INSERT INTO public.who_global_data VALUES (36575, 34, 3101, 2, 99, 155, 3);
INSERT INTO public.who_global_data VALUES (36576, 28, 1596, 0, 19, 155, 11);
INSERT INTO public.who_global_data VALUES (36577, 1453, 247619, 1, 9322, 155, 89);
INSERT INTO public.who_global_data VALUES (36578, 253, 44713, 4, 280, 155, 24);
INSERT INTO public.who_global_data VALUES (36579, 5, 295, 0, 0, 155, 162);
INSERT INTO public.who_global_data VALUES (36580, 241, 10998, 5, 278, 155, 100);
INSERT INTO public.who_global_data VALUES (36581, 0, 14, 0, 0, 155, 47);
INSERT INTO public.who_global_data VALUES (36582, 0, 24, 0, 0, 155, 29);
INSERT INTO public.who_global_data VALUES (36583, 94, 1363, 2, 20, 155, 40);
INSERT INTO public.who_global_data VALUES (36584, 74, 1560, 0, 13, 155, 222);
INSERT INTO public.who_global_data VALUES (36585, 714, 76358, 14, 2804, 155, 132);
INSERT INTO public.who_global_data VALUES (36586, 0, 252, 0, 13, 155, 130);
INSERT INTO public.who_global_data VALUES (36587, 100, 9579, 2, 61, 155, 234);
INSERT INTO public.who_global_data VALUES (36588, 96, 2245, 5, 38, 155, 23);
INSERT INTO public.who_global_data VALUES (36589, 9, 1382, 0, 41, 155, 192);
INSERT INTO public.who_global_data VALUES (36590, 0, 8258, 0, 206, 155, 69);
INSERT INTO public.who_global_data VALUES (36591, 0, 12, 0, 0, 155, 187);
INSERT INTO public.who_global_data VALUES (36592, 757, 62526, 36, 1924, 155, 230);
INSERT INTO public.who_global_data VALUES (36593, 301, 6923, 1, 620, 155, 77);
INSERT INTO public.who_global_data VALUES (36594, 7, 2128, 0, 10, 155, 9);
INSERT INTO public.who_global_data VALUES (36595, 83341, 3936747, 1096, 68472, 155, 74);
INSERT INTO public.who_global_data VALUES (36596, 3622, 184268, 134, 7750, 155, 224);
INSERT INTO public.who_global_data VALUES (36597, 1994, 380746, 129, 21926, 155, 199);
INSERT INTO public.who_global_data VALUES (36598, 4755, 247039, 74, 7275, 155, 190);
INSERT INTO public.who_global_data VALUES (36599, 92, 29206, 0, 1777, 155, 12);
INSERT INTO public.who_global_data VALUES (36600, 0, 336, 0, 24, 155, 104);
INSERT INTO public.who_global_data VALUES (36601, 3193, 122361, 14, 982, 155, 153);
INSERT INTO public.who_global_data VALUES (36602, 1397, 272912, 10, 35507, 155, 91);
INSERT INTO public.who_global_data VALUES (36603, 140, 2823, 3, 27, 155, 215);
INSERT INTO public.who_global_data VALUES (36604, 669, 70268, 11, 1330, 155, 84);
INSERT INTO public.who_global_data VALUES (36605, 3, 382, 0, 32, 155, 231);
INSERT INTO public.who_global_data VALUES (36606, 72, 2301, 1, 16, 155, 196);
INSERT INTO public.who_global_data VALUES (36607, 501, 133425, 0, 1878, 155, 105);
INSERT INTO public.who_global_data VALUES (36608, 212, 34705, 4, 585, 155, 122);
INSERT INTO public.who_global_data VALUES (36609, 0, 0, 0, 0, 155, 159);
INSERT INTO public.who_global_data VALUES (36610, 78, 13748, 9, 538, 155, 75);
INSERT INTO public.who_global_data VALUES (36611, 900, 87378, 1, 536, 155, 27);
INSERT INTO public.who_global_data VALUES (36612, 92, 44227, 1, 1061, 155, 54);
INSERT INTO public.who_global_data VALUES (36613, 0, 22, 0, 0, 155, 226);
INSERT INTO public.who_global_data VALUES (36614, 4, 1410, 0, 34, 155, 79);
INSERT INTO public.who_global_data VALUES (36615, 588, 18953, 2, 179, 155, 56);
INSERT INTO public.who_global_data VALUES (36616, 63, 1148, 0, 31, 155, 117);
INSERT INTO public.who_global_data VALUES (36617, 1, 1306, 0, 82, 155, 152);
INSERT INTO public.who_global_data VALUES (36618, 672, 16445, 8, 262, 155, 16);
INSERT INTO public.who_global_data VALUES (36619, 0, 108, 0, 1, 155, 10);
INSERT INTO public.who_global_data VALUES (36620, 26, 2998, 0, 86, 155, 201);
INSERT INTO public.who_global_data VALUES (36621, 0, 6745, 0, 124, 155, 174);
INSERT INTO public.who_global_data VALUES (36622, 83, 15106, 1, 197, 155, 119);
INSERT INTO public.who_global_data VALUES (36623, 14, 5593, 0, 175, 155, 168);
INSERT INTO public.who_global_data VALUES (36624, 14, 9374, 0, 128, 155, 99);
INSERT INTO public.who_global_data VALUES (36625, 141, 8281, 0, 29, 155, 171);
INSERT INTO public.who_global_data VALUES (36626, 5, 2807, 0, 126, 155, 87);
INSERT INTO public.who_global_data VALUES (36627, 19, 1985, 0, 13, 155, 123);
INSERT INTO public.who_global_data VALUES (36628, 0, 0, 0, 0, 155, 151);
INSERT INTO public.who_global_data VALUES (36629, 7, 754, 0, 18, 155, 213);
INSERT INTO public.who_global_data VALUES (36630, 17, 7106, 1, 160, 155, 118);
INSERT INTO public.who_global_data VALUES (36631, 0, 356, 0, 10, 155, 134);
INSERT INTO public.who_global_data VALUES (36632, 73, 3374, 0, 40, 155, 65);
INSERT INTO public.who_global_data VALUES (36633, 4921, 610957, 575, 65816, 155, 102);
INSERT INTO public.who_global_data VALUES (36634, 0, 0, 0, 0, 155, 223);
INSERT INTO public.who_global_data VALUES (36635, 1, 146, 0, 1, 155, 4);
INSERT INTO public.who_global_data VALUES (36636, 0, 306, 0, 0, 155, 146);
INSERT INTO public.who_global_data VALUES (36637, 154, 5379, 2, 106, 155, 31);
INSERT INTO public.who_global_data VALUES (36638, 0, 13, 0, 1, 155, 127);
INSERT INTO public.who_global_data VALUES (36639, 1402, 66855, 37, 1253, 155, 22);
INSERT INTO public.who_global_data VALUES (36640, 90, 4207, 1, 26, 155, 115);
INSERT INTO public.who_global_data VALUES (36641, 75, 1133, 1, 7, 155, 106);
INSERT INTO public.who_global_data VALUES (36642, 238, 8082, 4, 86, 155, 90);
INSERT INTO public.who_global_data VALUES (36643, 0, 0, 0, 0, 155, 70);
INSERT INTO public.who_global_data VALUES (36644, 1228, 42877, 6, 257, 155, 46);
INSERT INTO public.who_global_data VALUES (36645, 599, 72372, 2, 6233, 155, 139);
INSERT INTO public.who_global_data VALUES (36646, 3, 26, 0, 0, 155, 42);
INSERT INTO public.who_global_data VALUES (36647, 5, 1413, 0, 22, 155, 80);
INSERT INTO public.who_global_data VALUES (36648, 0, 3773, 0, 141, 155, 203);
INSERT INTO public.who_global_data VALUES (36649, 1, 1177, 0, 69, 155, 136);
INSERT INTO public.who_global_data VALUES (36650, 125, 54588, 21, 1048, 155, 63);
INSERT INTO public.who_global_data VALUES (36651, 0, 0, 0, 0, 155, 17);
INSERT INTO public.who_global_data VALUES (36652, 0, 57, 0, 2, 155, 172);
INSERT INTO public.who_global_data VALUES (36653, 162, 14762, 0, 606, 155, 109);
INSERT INTO public.who_global_data VALUES (36654, 164, 11035, 0, 264, 155, 200);
INSERT INTO public.who_global_data VALUES (36655, 596, 31929, 5, 189, 155, 93);
INSERT INTO public.who_global_data VALUES (36656, 452, 86380, 16, 705, 155, 5);
INSERT INTO public.who_global_data VALUES (36657, 0, 741, 0, 13, 155, 214);
INSERT INTO public.who_global_data VALUES (36658, 498, 297512, 7, 6335, 155, 204);
INSERT INTO public.who_global_data VALUES (36659, 0, 0, 0, 0, 155, 198);
INSERT INTO public.who_global_data VALUES (36660, 532, 94084, 12, 2030, 155, 173);
INSERT INTO public.who_global_data VALUES (36661, 0, 471, 0, 5, 155, 229);
INSERT INTO public.who_global_data VALUES (36662, 800, 19138, 10, 358, 155, 76);
INSERT INTO public.who_global_data VALUES (36663, 6308, 663437, 191, 29259, 155, 138);
INSERT INTO public.who_global_data VALUES (36664, 1963, 228403, 65, 3688, 155, 98);
INSERT INTO public.who_global_data VALUES (36665, 0, 0, 0, 0, 155, 103);
INSERT INTO public.who_global_data VALUES (36666, 612, 69129, 14, 2092, 155, 225);
INSERT INTO public.who_global_data VALUES (36667, 418, 59051, 2, 1829, 155, 131);
INSERT INTO public.who_global_data VALUES (36668, 195, 34198, 5, 448, 155, 235);
INSERT INTO public.who_global_data VALUES (36669, 214, 119420, 2, 201, 155, 137);
INSERT INTO public.who_global_data VALUES (36670, 198, 20842, 2, 331, 155, 81);
INSERT INTO public.who_global_data VALUES (36671, 632, 38372, 12, 1036, 155, 182);
INSERT INTO public.who_global_data VALUES (36672, 116, 1912, 0, 5, 155, 145);
INSERT INTO public.who_global_data VALUES (36673, 1365, 91256, 44, 3765, 155, 26);
INSERT INTO public.who_global_data VALUES (36674, 5110, 1015105, 121, 17649, 155, 170);
INSERT INTO public.who_global_data VALUES (36675, 37, 4255, 1, 18, 155, 191);
INSERT INTO public.who_global_data VALUES (36676, 0, 5, 0, 0, 155, 221);
INSERT INTO public.who_global_data VALUES (36677, 0, 18, 0, 0, 155, 64);
INSERT INTO public.who_global_data VALUES (36678, 0, 0, 0, 0, 155, 116);
INSERT INTO public.who_global_data VALUES (36679, 0, 17, 0, 0, 155, 128);
INSERT INTO public.who_global_data VALUES (36680, 0, 26, 0, 0, 155, 6);
INSERT INTO public.who_global_data VALUES (36681, 26, 239, 1, 6, 155, 227);
INSERT INTO public.who_global_data VALUES (36682, 0, 5, 0, 0, 155, 68);
INSERT INTO public.who_global_data VALUES (36683, 0, 61, 0, 0, 155, 184);
INSERT INTO public.who_global_data VALUES (36684, 0, 0, 0, 0, 155, 82);
INSERT INTO public.who_global_data VALUES (36685, 0, 735, 0, 42, 155, 149);
INSERT INTO public.who_global_data VALUES (36686, 1, 897, 0, 15, 155, 197);
INSERT INTO public.who_global_data VALUES (36687, 833, 318319, 26, 3982, 155, 78);
INSERT INTO public.who_global_data VALUES (36688, 83, 13826, 0, 287, 155, 233);
INSERT INTO public.who_global_data VALUES (36689, 95, 31676, 2, 718, 155, 133);
INSERT INTO public.who_global_data VALUES (36690, 0, 135, 0, 0, 155, 35);
INSERT INTO public.who_global_data VALUES (36691, 6, 2035, 0, 71, 155, 114);
INSERT INTO public.who_global_data VALUES (36692, 48, 56908, 0, 27, 155, 237);
INSERT INTO public.who_global_data VALUES (36693, 0, 4, 0, 0, 155, 55);
INSERT INTO public.who_global_data VALUES (36694, 13, 495, 0, 19, 155, 176);
INSERT INTO public.who_global_data VALUES (36695, 121, 4163, 4, 37, 155, 202);
INSERT INTO public.who_global_data VALUES (36696, 47, 3080, 0, 133, 155, 155);
INSERT INTO public.who_global_data VALUES (36697, 0, 0, 0, 0, 155, 32);
INSERT INTO public.who_global_data VALUES (36698, 0, 3310, 0, 97, 155, 220);
INSERT INTO public.who_global_data VALUES (36699, 2420, 633015, 0, 14389, 155, 30);
INSERT INTO public.who_global_data VALUES (36700, 3, 2536, 0, 47, 155, 147);
INSERT INTO public.who_global_data VALUES (36701, 10876, 525613, 80, 31104, 155, 208);
INSERT INTO public.who_global_data VALUES (36702, 9, 3111, 0, 12, 155, 45);
INSERT INTO public.who_global_data VALUES (36703, 0, 13189, 0, 823, 155, 110);
INSERT INTO public.who_global_data VALUES (36704, 60, 4149, 0, 72, 155, 88);
INSERT INTO public.who_global_data VALUES (36705, 213, 84781, 2, 5835, 155, 51);
INSERT INTO public.who_global_data VALUES (36706, 438, 43811, 1, 1765, 155, 209);
INSERT INTO public.who_global_data VALUES (36707, 75, 2973, 4, 124, 155, 205);
INSERT INTO public.who_global_data VALUES (36708, 36, 8690, 0, 69, 155, 18);
INSERT INTO public.who_global_data VALUES (36709, 4, 3431, 0, 58, 155, 72);
INSERT INTO public.who_global_data VALUES (36710, 1735, 340415, 13, 41527, 155, 44);
INSERT INTO public.who_global_data VALUES (36711, 0, 27, 0, 0, 155, 15);
INSERT INTO public.who_global_data VALUES (36712, 27, 1443, 3, 31, 155, 25);
INSERT INTO public.who_global_data VALUES (36713, 0, 0, 0, 0, 155, 179);
INSERT INTO public.who_global_data VALUES (36714, 0, 0, 0, 0, 155, 34);
INSERT INTO public.who_global_data VALUES (36715, 102, 1941, 0, 28, 155, 207);
INSERT INTO public.who_global_data VALUES (36716, 148, 4542, 3, 87, 155, 166);
INSERT INTO public.who_global_data VALUES (36717, 8372, 530683, 49, 6511, 155, 126);
INSERT INTO public.who_global_data VALUES (36718, 0, 0, 0, 0, 155, 97);
INSERT INTO public.who_global_data VALUES (36719, 17, 555, 0, 4, 155, 36);
INSERT INTO public.who_global_data VALUES (36720, 0, 0, 0, 0, 155, 125);
INSERT INTO public.who_global_data VALUES (36721, 176, 3288, 1, 33, 155, 124);
INSERT INTO public.who_global_data VALUES (36722, 2723, 130951, 51, 2761, 155, 185);
INSERT INTO public.who_global_data VALUES (36723, 614, 72154, 0, 387, 155, 194);
INSERT INTO public.who_global_data VALUES (36724, 0, 509, 0, 21, 155, 144);
INSERT INTO public.who_global_data VALUES (36725, 39402, 6050444, 1004, 184614, 155, 19);
INSERT INTO public.who_global_data VALUES (36726, 1, 1144, 0, 15, 155, 217);
INSERT INTO public.who_global_data VALUES (36727, 15, 1626, 0, 44, 155, 148);
INSERT INTO public.who_global_data VALUES (36728, 363, 42903, 7, 336, 155, 86);
INSERT INTO public.who_global_data VALUES (36729, 0, 0, 0, 0, 155, 13);
INSERT INTO public.who_global_data VALUES (36730, 1127, 48883, 7, 398, 155, 157);
INSERT INTO public.who_global_data VALUES (36731, 0, 1046, 1, 35, 155, 8);
INSERT INTO public.who_global_data VALUES (36732, 0, 0, 0, 0, 155, 73);
INSERT INTO public.who_global_data VALUES (36733, 3, 1983, 0, 572, 155, 101);
INSERT INTO public.who_global_data VALUES (36734, 108, 12523, 0, 292, 155, 165);
INSERT INTO public.who_global_data VALUES (36735, 40, 6678, 0, 206, 155, 14);
INSERT INTO public.who_global_data VALUES (36736, 45, 38374, 0, 1413, 156, 193);
INSERT INTO public.who_global_data VALUES (36737, 122, 9728, 6, 296, 156, 113);
INSERT INTO public.who_global_data VALUES (36738, 325, 45158, 7, 1525, 156, 143);
INSERT INTO public.who_global_data VALUES (36739, 0, 0, 0, 0, 156, 219);
INSERT INTO public.who_global_data VALUES (36740, 15, 1199, 0, 53, 156, 186);
INSERT INTO public.who_global_data VALUES (36741, 48, 2777, 3, 112, 156, 52);
INSERT INTO public.who_global_data VALUES (36742, 0, 3, 0, 0, 156, 180);
INSERT INTO public.who_global_data VALUES (36743, 0, 94, 0, 3, 156, 167);
INSERT INTO public.who_global_data VALUES (36744, 10504, 428239, 241, 8971, 156, 154);
INSERT INTO public.who_global_data VALUES (36745, 196, 43584, 3, 882, 156, 94);
INSERT INTO public.who_global_data VALUES (36746, 98, 2104, 0, 10, 156, 66);
INSERT INTO public.who_global_data VALUES (36747, 104, 25923, 6, 663, 156, 58);
INSERT INTO public.who_global_data VALUES (36748, 442, 28183, 0, 734, 156, 163);
INSERT INTO public.who_global_data VALUES (36749, 154, 36732, 2, 538, 156, 37);
INSERT INTO public.who_global_data VALUES (36750, 59, 2276, 2, 46, 156, 142);
INSERT INTO public.who_global_data VALUES (36751, 367, 52807, 0, 190, 156, 83);
INSERT INTO public.who_global_data VALUES (36752, 2582, 317528, 35, 4351, 156, 228);
INSERT INTO public.who_global_data VALUES (36753, 2, 176, 0, 7, 156, 188);
INSERT INTO public.who_global_data VALUES (36754, 179, 72141, 5, 691, 156, 62);
INSERT INTO public.who_global_data VALUES (36755, 574, 87269, 2, 9892, 156, 160);
INSERT INTO public.who_global_data VALUES (36756, 43, 1050, 0, 13, 156, 50);
INSERT INTO public.who_global_data VALUES (36757, 0, 2194, 0, 40, 156, 33);
INSERT INTO public.who_global_data VALUES (36758, 0, 172, 0, 9, 156, 183);
INSERT INTO public.who_global_data VALUES (36759, 0, 227, 0, 0, 156, 92);
INSERT INTO public.who_global_data VALUES (36760, 669, 117267, 74, 5101, 156, 158);
INSERT INTO public.who_global_data VALUES (36761, 0, 9, 0, 0, 156, 67);
INSERT INTO public.who_global_data VALUES (36762, 283, 20574, 7, 621, 156, 57);
INSERT INTO public.who_global_data VALUES (36763, 0, 1724, 0, 6, 156, 38);
INSERT INTO public.who_global_data VALUES (36764, 42659, 3950931, 1215, 122596, 156, 141);
INSERT INTO public.who_global_data VALUES (36765, 0, 47, 0, 1, 156, 178);
INSERT INTO public.who_global_data VALUES (36766, 0, 144, 0, 3, 156, 108);
INSERT INTO public.who_global_data VALUES (36767, 188, 16454, 13, 642, 156, 39);
INSERT INTO public.who_global_data VALUES (36768, 5, 1375, 0, 55, 156, 2);
INSERT INTO public.who_global_data VALUES (36769, 0, 448, 0, 1, 156, 195);
INSERT INTO public.who_global_data VALUES (36770, 78, 4048, 1, 41, 156, 107);
INSERT INTO public.who_global_data VALUES (36771, 0, 274, 0, 0, 156, 161);
INSERT INTO public.who_global_data VALUES (36772, 0, 19460, 0, 415, 156, 212);
INSERT INTO public.who_global_data VALUES (36773, 477, 129425, 6, 9132, 156, 181);
INSERT INTO public.who_global_data VALUES (36774, 0, 205, 0, 1, 156, 53);
INSERT INTO public.who_global_data VALUES (36775, 1, 4712, 0, 62, 156, 164);
INSERT INTO public.who_global_data VALUES (36776, 0, 1017, 0, 77, 156, 140);
INSERT INTO public.who_global_data VALUES (36777, 1594, 414739, 23, 11344, 156, 20);
INSERT INTO public.who_global_data VALUES (36778, 20, 90442, 3, 4734, 156, 112);
INSERT INTO public.who_global_data VALUES (36779, 8901, 624069, 389, 20052, 156, 111);
INSERT INTO public.who_global_data VALUES (36780, 4, 427, 0, 7, 156, 71);
INSERT INTO public.who_global_data VALUES (36781, 0, 4628, 0, 82, 156, 218);
INSERT INTO public.who_global_data VALUES (36782, 0, 0, 0, 0, 156, 43);
INSERT INTO public.who_global_data VALUES (36783, 897, 42184, 7, 443, 156, 49);
INSERT INTO public.who_global_data VALUES (36784, 0, 18103, 0, 117, 156, 1);
INSERT INTO public.who_global_data VALUES (36785, 311, 10725, 4, 191, 156, 48);
INSERT INTO public.who_global_data VALUES (36786, 61, 4126, 3, 98, 156, 232);
INSERT INTO public.who_global_data VALUES (36787, 2, 71, 0, 1, 156, 175);
INSERT INTO public.who_global_data VALUES (36788, 5, 1495, 0, 21, 156, 21);
INSERT INTO public.who_global_data VALUES (36789, 656, 25773, 0, 425, 156, 156);
INSERT INTO public.who_global_data VALUES (36790, 0, 0, 0, 0, 156, 95);
INSERT INTO public.who_global_data VALUES (36791, 10, 10113, 0, 259, 156, 177);
INSERT INTO public.who_global_data VALUES (36792, 111, 17195, 1, 626, 156, 210);
INSERT INTO public.who_global_data VALUES (36793, 0, 5387, 0, 60, 156, 120);
INSERT INTO public.who_global_data VALUES (36794, 0, 20, 0, 0, 156, 135);
INSERT INTO public.who_global_data VALUES (36795, 648, 95627, 27, 1765, 156, 206);
INSERT INTO public.who_global_data VALUES (36796, 1148, 115457, 48, 6619, 156, 189);
INSERT INTO public.who_global_data VALUES (36797, 165, 99280, 21, 5461, 156, 129);
INSERT INTO public.who_global_data VALUES (36798, 84, 25904, 7, 731, 156, 121);
INSERT INTO public.who_global_data VALUES (36799, 0, 4965, 0, 83, 156, 59);
INSERT INTO public.who_global_data VALUES (36800, 0, 319, 0, 0, 156, 96);
INSERT INTO public.who_global_data VALUES (36801, 20, 2415, 0, 64, 156, 41);
INSERT INTO public.who_global_data VALUES (36802, 50, 4668, 0, 94, 156, 216);
INSERT INTO public.who_global_data VALUES (36803, 1105, 54409, 18, 846, 156, 236);
INSERT INTO public.who_global_data VALUES (36804, 0, 13, 0, 0, 156, 150);
INSERT INTO public.who_global_data VALUES (36805, 0, 411, 0, 0, 156, 61);
INSERT INTO public.who_global_data VALUES (36806, 0, 29, 0, 2, 156, 7);
INSERT INTO public.who_global_data VALUES (36807, 19, 8161, 0, 335, 156, 169);
INSERT INTO public.who_global_data VALUES (36808, 6748, 276466, 22, 30539, 156, 28);
INSERT INTO public.who_global_data VALUES (36809, 55, 9209, 1, 61, 156, 85);
INSERT INTO public.who_global_data VALUES (36810, 26, 622, 0, 0, 156, 211);
INSERT INTO public.who_global_data VALUES (36811, 5, 8538, 0, 53, 156, 60);
INSERT INTO public.who_global_data VALUES (36812, 38, 3067, 1, 97, 156, 3);
INSERT INTO public.who_global_data VALUES (36813, 20, 1568, 0, 19, 156, 11);
INSERT INTO public.who_global_data VALUES (36814, 1311, 246166, 8, 9321, 156, 89);
INSERT INTO public.who_global_data VALUES (36815, 255, 44460, 0, 276, 156, 24);
INSERT INTO public.who_global_data VALUES (36816, 2, 290, 0, 0, 156, 162);
INSERT INTO public.who_global_data VALUES (36817, 233, 10757, 2, 273, 156, 100);
INSERT INTO public.who_global_data VALUES (36818, 0, 14, 0, 0, 156, 47);
INSERT INTO public.who_global_data VALUES (36819, 0, 24, 0, 0, 156, 29);
INSERT INTO public.who_global_data VALUES (36820, 0, 1269, 0, 18, 156, 40);
INSERT INTO public.who_global_data VALUES (36821, 47, 1486, 0, 13, 156, 222);
INSERT INTO public.who_global_data VALUES (36822, 751, 75644, 12, 2790, 156, 132);
INSERT INTO public.who_global_data VALUES (36823, 0, 252, 0, 13, 156, 130);
INSERT INTO public.who_global_data VALUES (36824, 0, 9479, 0, 59, 156, 234);
INSERT INTO public.who_global_data VALUES (36825, 0, 2149, 0, 33, 156, 23);
INSERT INTO public.who_global_data VALUES (36826, 67, 1373, 2, 41, 156, 192);
INSERT INTO public.who_global_data VALUES (36827, 34, 8258, 5, 206, 156, 69);
INSERT INTO public.who_global_data VALUES (36828, 0, 12, 0, 0, 156, 187);
INSERT INTO public.who_global_data VALUES (36829, 755, 61769, 15, 1888, 156, 230);
INSERT INTO public.who_global_data VALUES (36830, 365, 6622, 3, 619, 156, 77);
INSERT INTO public.who_global_data VALUES (36831, 5, 2121, 0, 10, 156, 9);
INSERT INTO public.who_global_data VALUES (36832, 83883, 3853406, 1043, 67376, 156, 74);
INSERT INTO public.who_global_data VALUES (36833, 3075, 180646, 111, 7616, 156, 224);
INSERT INTO public.who_global_data VALUES (36834, 1858, 378752, 125, 21797, 156, 199);
INSERT INTO public.who_global_data VALUES (36835, 3946, 242284, 78, 7201, 156, 190);
INSERT INTO public.who_global_data VALUES (36836, 89, 29114, 0, 1777, 156, 12);
INSERT INTO public.who_global_data VALUES (36837, 0, 336, 0, 24, 156, 104);
INSERT INTO public.who_global_data VALUES (36838, 2252, 119168, 15, 968, 156, 153);
INSERT INTO public.who_global_data VALUES (36839, 1326, 271515, 6, 35497, 156, 91);
INSERT INTO public.who_global_data VALUES (36840, 224, 2683, 3, 24, 156, 215);
INSERT INTO public.who_global_data VALUES (36841, 598, 69599, 12, 1319, 156, 84);
INSERT INTO public.who_global_data VALUES (36842, 0, 379, 0, 32, 156, 231);
INSERT INTO public.who_global_data VALUES (36843, 64, 2229, 0, 15, 156, 196);
INSERT INTO public.who_global_data VALUES (36844, 570, 132924, 0, 1878, 156, 105);
INSERT INTO public.who_global_data VALUES (36845, 178, 34493, 4, 581, 156, 122);
INSERT INTO public.who_global_data VALUES (36846, 0, 0, 0, 0, 156, 159);
INSERT INTO public.who_global_data VALUES (36847, 112, 13670, 6, 529, 156, 75);
INSERT INTO public.who_global_data VALUES (36848, 667, 86478, 1, 535, 156, 27);
INSERT INTO public.who_global_data VALUES (36849, 99, 44135, 0, 1060, 156, 54);
INSERT INTO public.who_global_data VALUES (36850, 0, 22, 0, 0, 156, 226);
INSERT INTO public.who_global_data VALUES (36851, 2, 1406, 0, 34, 156, 79);
INSERT INTO public.who_global_data VALUES (36852, 598, 18365, 6, 177, 156, 56);
INSERT INTO public.who_global_data VALUES (36853, 0, 1085, 0, 31, 156, 117);
INSERT INTO public.who_global_data VALUES (36854, 0, 1305, 0, 82, 156, 152);
INSERT INTO public.who_global_data VALUES (36855, 617, 15773, 4, 254, 156, 16);
INSERT INTO public.who_global_data VALUES (36856, 0, 108, 0, 1, 156, 10);
INSERT INTO public.who_global_data VALUES (36857, 20, 2972, 0, 86, 156, 201);
INSERT INTO public.who_global_data VALUES (36858, 68, 6745, 0, 124, 156, 174);
INSERT INTO public.who_global_data VALUES (36859, 66, 15023, 1, 196, 156, 119);
INSERT INTO public.who_global_data VALUES (36860, 3, 5579, 0, 175, 156, 168);
INSERT INTO public.who_global_data VALUES (36861, 6, 9360, 0, 128, 156, 99);
INSERT INTO public.who_global_data VALUES (36862, 137, 8140, 0, 29, 156, 171);
INSERT INTO public.who_global_data VALUES (36863, 25, 2802, 0, 126, 156, 87);
INSERT INTO public.who_global_data VALUES (36864, 34, 1966, 0, 13, 156, 123);
INSERT INTO public.who_global_data VALUES (36865, 0, 0, 0, 0, 156, 151);
INSERT INTO public.who_global_data VALUES (36866, 132, 747, 2, 18, 156, 213);
INSERT INTO public.who_global_data VALUES (36867, 14, 7089, 0, 159, 156, 118);
INSERT INTO public.who_global_data VALUES (36868, 0, 356, 0, 10, 156, 134);
INSERT INTO public.who_global_data VALUES (36869, 0, 3301, 0, 40, 156, 65);
INSERT INTO public.who_global_data VALUES (36870, 6476, 606036, 827, 65241, 156, 102);
INSERT INTO public.who_global_data VALUES (36871, 0, 0, 0, 0, 156, 223);
INSERT INTO public.who_global_data VALUES (36872, 2, 145, 0, 1, 156, 4);
INSERT INTO public.who_global_data VALUES (36873, 2, 306, 0, 0, 156, 146);
INSERT INTO public.who_global_data VALUES (36874, 123, 5225, 0, 104, 156, 31);
INSERT INTO public.who_global_data VALUES (36875, 0, 13, 0, 1, 156, 127);
INSERT INTO public.who_global_data VALUES (36876, 1672, 65453, 32, 1216, 156, 22);
INSERT INTO public.who_global_data VALUES (36877, 78, 4117, 2, 25, 156, 115);
INSERT INTO public.who_global_data VALUES (36878, 120, 1058, 0, 6, 156, 106);
INSERT INTO public.who_global_data VALUES (36879, 152, 7844, 1, 82, 156, 90);
INSERT INTO public.who_global_data VALUES (36880, 0, 0, 0, 0, 156, 70);
INSERT INTO public.who_global_data VALUES (36881, 1120, 41649, 12, 251, 156, 46);
INSERT INTO public.who_global_data VALUES (36882, 720, 71773, 5, 6231, 156, 139);
INSERT INTO public.who_global_data VALUES (36883, 0, 23, 0, 0, 156, 42);
INSERT INTO public.who_global_data VALUES (36884, 2, 1408, 0, 22, 156, 80);
INSERT INTO public.who_global_data VALUES (36885, 0, 3773, 0, 141, 156, 203);
INSERT INTO public.who_global_data VALUES (36886, 0, 1176, 0, 69, 156, 136);
INSERT INTO public.who_global_data VALUES (36887, 216, 54463, 4, 1027, 156, 63);
INSERT INTO public.who_global_data VALUES (36888, 0, 0, 0, 0, 156, 17);
INSERT INTO public.who_global_data VALUES (36889, 0, 57, 0, 2, 156, 172);
INSERT INTO public.who_global_data VALUES (36890, 145, 14600, 2, 606, 156, 109);
INSERT INTO public.who_global_data VALUES (36891, 88, 10871, 0, 264, 156, 200);
INSERT INTO public.who_global_data VALUES (36892, 843, 31333, 4, 184, 156, 93);
INSERT INTO public.who_global_data VALUES (36893, 0, 85928, 0, 689, 156, 5);
INSERT INTO public.who_global_data VALUES (36894, 0, 741, 0, 13, 156, 214);
INSERT INTO public.who_global_data VALUES (36895, 424, 297014, 10, 6328, 156, 204);
INSERT INTO public.who_global_data VALUES (36896, 0, 0, 0, 0, 156, 198);
INSERT INTO public.who_global_data VALUES (36897, 570, 93552, 16, 2018, 156, 173);
INSERT INTO public.who_global_data VALUES (36898, 11, 471, 0, 5, 156, 229);
INSERT INTO public.who_global_data VALUES (36899, 676, 18338, 22, 348, 156, 76);
INSERT INTO public.who_global_data VALUES (36900, 5092, 657129, 124, 29068, 156, 138);
INSERT INTO public.who_global_data VALUES (36901, 2176, 226440, 26, 3623, 156, 98);
INSERT INTO public.who_global_data VALUES (36902, 0, 0, 0, 0, 156, 103);
INSERT INTO public.who_global_data VALUES (36903, 595, 68517, 20, 2078, 156, 225);
INSERT INTO public.who_global_data VALUES (36904, 390, 58633, 3, 1827, 156, 131);
INSERT INTO public.who_global_data VALUES (36905, 582, 34003, 8, 443, 156, 235);
INSERT INTO public.who_global_data VALUES (36906, 212, 119206, 1, 199, 156, 137);
INSERT INTO public.who_global_data VALUES (36907, 195, 20644, 3, 329, 156, 81);
INSERT INTO public.who_global_data VALUES (36908, 532, 37740, 16, 1024, 156, 182);
INSERT INTO public.who_global_data VALUES (36909, 82, 1796, 0, 5, 156, 145);
INSERT INTO public.who_global_data VALUES (36910, 1298, 89891, 40, 3721, 156, 26);
INSERT INTO public.who_global_data VALUES (36911, 4995, 1009995, 114, 17528, 156, 170);
INSERT INTO public.who_global_data VALUES (36912, 76, 4218, 1, 17, 156, 191);
INSERT INTO public.who_global_data VALUES (36913, 0, 5, 0, 0, 156, 221);
INSERT INTO public.who_global_data VALUES (36914, 0, 18, 0, 0, 156, 64);
INSERT INTO public.who_global_data VALUES (36915, 0, 0, 0, 0, 156, 116);
INSERT INTO public.who_global_data VALUES (36916, 0, 17, 0, 0, 156, 128);
INSERT INTO public.who_global_data VALUES (36917, 0, 26, 0, 0, 156, 6);
INSERT INTO public.who_global_data VALUES (36918, 0, 213, 0, 5, 156, 227);
INSERT INTO public.who_global_data VALUES (36919, 0, 5, 0, 0, 156, 68);
INSERT INTO public.who_global_data VALUES (36920, 1, 61, 0, 0, 156, 184);
INSERT INTO public.who_global_data VALUES (36921, 0, 0, 0, 0, 156, 82);
INSERT INTO public.who_global_data VALUES (36922, 0, 735, 0, 42, 156, 149);
INSERT INTO public.who_global_data VALUES (36923, 0, 896, 0, 15, 156, 197);
INSERT INTO public.who_global_data VALUES (36924, 816, 317486, 27, 3956, 156, 78);
INSERT INTO public.who_global_data VALUES (36925, 88, 13743, 3, 287, 156, 233);
INSERT INTO public.who_global_data VALUES (36926, 99, 31581, 1, 716, 156, 133);
INSERT INTO public.who_global_data VALUES (36927, 0, 135, 0, 0, 156, 35);
INSERT INTO public.who_global_data VALUES (36928, 1, 2029, 0, 71, 156, 114);
INSERT INTO public.who_global_data VALUES (36929, 8, 56860, 0, 27, 156, 237);
INSERT INTO public.who_global_data VALUES (36930, 0, 4, 0, 0, 156, 55);
INSERT INTO public.who_global_data VALUES (36931, 6, 482, 2, 19, 156, 176);
INSERT INTO public.who_global_data VALUES (36932, 53, 4042, 0, 33, 156, 202);
INSERT INTO public.who_global_data VALUES (36933, 53, 3033, 0, 133, 156, 155);
INSERT INTO public.who_global_data VALUES (36934, 0, 0, 0, 0, 156, 32);
INSERT INTO public.who_global_data VALUES (36935, 0, 3310, 0, 97, 156, 220);
INSERT INTO public.who_global_data VALUES (36936, 2336, 630595, 126, 14389, 156, 30);
INSERT INTO public.who_global_data VALUES (36937, 1, 2533, 0, 47, 156, 147);
INSERT INTO public.who_global_data VALUES (36938, 10628, 514737, 68, 31024, 156, 208);
INSERT INTO public.who_global_data VALUES (36939, 10, 3102, 0, 12, 156, 45);
INSERT INTO public.who_global_data VALUES (36940, 0, 13189, 0, 823, 156, 110);
INSERT INTO public.who_global_data VALUES (36941, 55, 4089, 1, 72, 156, 88);
INSERT INTO public.who_global_data VALUES (36942, 171, 84568, 3, 5833, 156, 51);
INSERT INTO public.who_global_data VALUES (36943, 417, 43373, 3, 1764, 156, 209);
INSERT INTO public.who_global_data VALUES (36944, 68, 2898, 4, 120, 156, 205);
INSERT INTO public.who_global_data VALUES (36945, 35, 8654, 0, 69, 156, 18);
INSERT INTO public.who_global_data VALUES (36946, 2, 3427, 0, 58, 156, 72);
INSERT INTO public.who_global_data VALUES (36947, 1508, 338680, 10, 41514, 156, 44);
INSERT INTO public.who_global_data VALUES (36948, 0, 27, 0, 0, 156, 15);
INSERT INTO public.who_global_data VALUES (36949, 16, 1416, 1, 28, 156, 25);
INSERT INTO public.who_global_data VALUES (36950, 0, 0, 0, 0, 156, 179);
INSERT INTO public.who_global_data VALUES (36951, 0, 0, 0, 0, 156, 34);
INSERT INTO public.who_global_data VALUES (36952, 66, 1839, 3, 28, 156, 207);
INSERT INTO public.who_global_data VALUES (36953, 198, 4394, 3, 84, 156, 166);
INSERT INTO public.who_global_data VALUES (36954, 8326, 522311, 45, 6462, 156, 126);
INSERT INTO public.who_global_data VALUES (36955, 0, 0, 0, 0, 156, 97);
INSERT INTO public.who_global_data VALUES (36956, 30, 538, 0, 4, 156, 36);
INSERT INTO public.who_global_data VALUES (36957, 0, 0, 0, 0, 156, 125);
INSERT INTO public.who_global_data VALUES (36958, 75, 3112, 0, 32, 156, 124);
INSERT INTO public.who_global_data VALUES (36959, 2430, 128228, 54, 2710, 156, 185);
INSERT INTO public.who_global_data VALUES (36960, 735, 71540, 3, 387, 156, 194);
INSERT INTO public.who_global_data VALUES (36961, 0, 509, 0, 21, 156, 144);
INSERT INTO public.who_global_data VALUES (36962, 42662, 6011042, 1025, 183610, 156, 19);
INSERT INTO public.who_global_data VALUES (36963, 4, 1143, 0, 15, 156, 217);
INSERT INTO public.who_global_data VALUES (36964, 16, 1611, 0, 44, 156, 148);
INSERT INTO public.who_global_data VALUES (36965, 170, 42540, 3, 329, 156, 86);
INSERT INTO public.who_global_data VALUES (36966, 0, 0, 0, 0, 156, 13);
INSERT INTO public.who_global_data VALUES (36967, 1028, 47756, 5, 391, 156, 157);
INSERT INTO public.who_global_data VALUES (36968, 2, 1046, 0, 34, 156, 8);
INSERT INTO public.who_global_data VALUES (36969, 0, 0, 0, 0, 156, 73);
INSERT INTO public.who_global_data VALUES (36970, 14, 1980, 1, 572, 156, 101);
INSERT INTO public.who_global_data VALUES (36971, 34, 12415, 2, 292, 156, 165);
INSERT INTO public.who_global_data VALUES (36972, 79, 6638, 3, 206, 156, 14);
INSERT INTO public.who_global_data VALUES (36973, 47, 38329, 3, 1413, 157, 193);
INSERT INTO public.who_global_data VALUES (36974, 93, 9606, 6, 290, 157, 113);
INSERT INTO public.who_global_data VALUES (36975, 339, 44833, 8, 1518, 157, 143);
INSERT INTO public.who_global_data VALUES (36976, 0, 0, 0, 0, 157, 219);
INSERT INTO public.who_global_data VALUES (36977, 8, 1184, 0, 53, 157, 186);
INSERT INTO public.who_global_data VALUES (36978, 75, 2729, 1, 109, 157, 52);
INSERT INTO public.who_global_data VALUES (36979, 0, 3, 0, 0, 157, 180);
INSERT INTO public.who_global_data VALUES (36980, 0, 94, 0, 3, 157, 167);
INSERT INTO public.who_global_data VALUES (36981, 9309, 417735, 232, 8730, 157, 154);
INSERT INTO public.who_global_data VALUES (36982, 197, 43388, 3, 879, 157, 94);
INSERT INTO public.who_global_data VALUES (36983, 9, 2006, 0, 10, 157, 66);
INSERT INTO public.who_global_data VALUES (36984, 73, 25819, 5, 657, 157, 58);
INSERT INTO public.who_global_data VALUES (36985, 337, 27741, 1, 734, 157, 163);
INSERT INTO public.who_global_data VALUES (36986, 143, 36578, 2, 536, 157, 37);
INSERT INTO public.who_global_data VALUES (36987, 50, 2217, 1, 44, 157, 142);
INSERT INTO public.who_global_data VALUES (36988, 468, 52440, 0, 190, 157, 83);
INSERT INTO public.who_global_data VALUES (36989, 1950, 314946, 35, 4316, 157, 228);
INSERT INTO public.who_global_data VALUES (36990, 1, 174, 0, 7, 157, 188);
INSERT INTO public.who_global_data VALUES (36991, 119, 71962, 5, 686, 157, 62);
INSERT INTO public.who_global_data VALUES (36992, 565, 86695, 3, 9890, 157, 160);
INSERT INTO public.who_global_data VALUES (36993, 14, 1007, 0, 13, 157, 50);
INSERT INTO public.who_global_data VALUES (36994, 49, 2194, 0, 40, 157, 33);
INSERT INTO public.who_global_data VALUES (36995, 3, 172, 0, 9, 157, 183);
INSERT INTO public.who_global_data VALUES (36996, 2, 227, 0, 0, 157, 92);
INSERT INTO public.who_global_data VALUES (36997, 630, 116598, 61, 5027, 157, 158);
INSERT INTO public.who_global_data VALUES (36998, 2, 9, 0, 0, 157, 67);
INSERT INTO public.who_global_data VALUES (36999, 271, 20291, 11, 614, 157, 57);
INSERT INTO public.who_global_data VALUES (37000, 0, 1724, 0, 6, 157, 38);
INSERT INTO public.who_global_data VALUES (37001, 45961, 3908272, 553, 121381, 157, 141);
INSERT INTO public.who_global_data VALUES (37002, 0, 47, 0, 1, 157, 178);
INSERT INTO public.who_global_data VALUES (37003, 0, 144, 0, 3, 157, 108);
INSERT INTO public.who_global_data VALUES (37004, 0, 16266, 0, 629, 157, 39);
INSERT INTO public.who_global_data VALUES (37005, 2, 1370, 0, 55, 157, 2);
INSERT INTO public.who_global_data VALUES (37006, 3, 448, 0, 1, 157, 195);
INSERT INTO public.who_global_data VALUES (37007, 86, 3970, 0, 40, 157, 107);
INSERT INTO public.who_global_data VALUES (37008, 0, 274, 0, 0, 157, 161);
INSERT INTO public.who_global_data VALUES (37009, 51, 19460, 1, 415, 157, 212);
INSERT INTO public.who_global_data VALUES (37010, 1008, 128948, 9, 9126, 157, 181);
INSERT INTO public.who_global_data VALUES (37011, 0, 205, 0, 1, 157, 53);
INSERT INTO public.who_global_data VALUES (37012, 0, 4711, 0, 62, 157, 164);
INSERT INTO public.who_global_data VALUES (37013, 4, 1017, 0, 77, 157, 140);
INSERT INTO public.who_global_data VALUES (37014, 1419, 413145, 32, 11321, 157, 20);
INSERT INTO public.who_global_data VALUES (37015, 20, 90422, 1, 4731, 157, 112);
INSERT INTO public.who_global_data VALUES (37016, 7230, 615168, 299, 19663, 157, 111);
INSERT INTO public.who_global_data VALUES (37017, 0, 423, 0, 7, 157, 71);
INSERT INTO public.who_global_data VALUES (37018, 649, 4628, 4, 82, 157, 218);
INSERT INTO public.who_global_data VALUES (37019, 0, 0, 0, 0, 157, 43);
INSERT INTO public.who_global_data VALUES (37020, 1588, 41287, 18, 436, 157, 49);
INSERT INTO public.who_global_data VALUES (37021, 155, 18103, 2, 117, 157, 1);
INSERT INTO public.who_global_data VALUES (37022, 145, 10414, 1, 187, 157, 48);
INSERT INTO public.who_global_data VALUES (37023, 33, 4065, 1, 95, 157, 232);
INSERT INTO public.who_global_data VALUES (37024, 1, 69, 0, 1, 157, 175);
INSERT INTO public.who_global_data VALUES (37025, 2, 1490, 0, 21, 157, 21);
INSERT INTO public.who_global_data VALUES (37026, 499, 25117, 1, 425, 157, 156);
INSERT INTO public.who_global_data VALUES (37027, 0, 0, 0, 0, 157, 95);
INSERT INTO public.who_global_data VALUES (37028, 7, 10103, 1, 259, 157, 177);
INSERT INTO public.who_global_data VALUES (37029, 99, 17084, 1, 625, 157, 210);
INSERT INTO public.who_global_data VALUES (37030, 0, 5387, 0, 60, 157, 120);
INSERT INTO public.who_global_data VALUES (37031, 0, 20, 0, 0, 157, 135);
INSERT INTO public.who_global_data VALUES (37032, 264, 94979, 28, 1738, 157, 206);
INSERT INTO public.who_global_data VALUES (37033, 542, 114309, 15, 6571, 157, 189);
INSERT INTO public.who_global_data VALUES (37034, 176, 99115, 19, 5440, 157, 129);
INSERT INTO public.who_global_data VALUES (37035, 91, 25820, 7, 724, 157, 121);
INSERT INTO public.who_global_data VALUES (37036, 24, 4965, 0, 83, 157, 59);
INSERT INTO public.who_global_data VALUES (37037, 0, 319, 0, 0, 157, 96);
INSERT INTO public.who_global_data VALUES (37038, 20, 2395, 0, 64, 157, 41);
INSERT INTO public.who_global_data VALUES (37039, 41, 4618, 3, 94, 157, 216);
INSERT INTO public.who_global_data VALUES (37040, 1173, 53304, 19, 828, 157, 236);
INSERT INTO public.who_global_data VALUES (37041, 0, 13, 0, 0, 157, 150);
INSERT INTO public.who_global_data VALUES (37042, 0, 411, 0, 0, 157, 61);
INSERT INTO public.who_global_data VALUES (37043, 1, 29, 0, 2, 157, 7);
INSERT INTO public.who_global_data VALUES (37044, 56, 8142, 0, 335, 157, 169);
INSERT INTO public.who_global_data VALUES (37045, 4765, 269718, 23, 30517, 157, 28);
INSERT INTO public.who_global_data VALUES (37046, 39, 9154, 1, 60, 157, 85);
INSERT INTO public.who_global_data VALUES (37047, 23, 596, 0, 0, 157, 211);
INSERT INTO public.who_global_data VALUES (37048, 0, 8533, 0, 53, 157, 60);
INSERT INTO public.who_global_data VALUES (37049, 66, 3029, 0, 96, 157, 3);
INSERT INTO public.who_global_data VALUES (37050, 38, 1548, 0, 19, 157, 11);
INSERT INTO public.who_global_data VALUES (37051, 1256, 244855, 11, 9313, 157, 89);
INSERT INTO public.who_global_data VALUES (37052, 0, 44205, 0, 276, 157, 24);
INSERT INTO public.who_global_data VALUES (37053, 3, 288, 0, 0, 157, 162);
INSERT INTO public.who_global_data VALUES (37054, 207, 10524, 5, 271, 157, 100);
INSERT INTO public.who_global_data VALUES (37055, 0, 14, 0, 0, 157, 47);
INSERT INTO public.who_global_data VALUES (37056, 0, 24, 0, 0, 157, 29);
INSERT INTO public.who_global_data VALUES (37057, 124, 1269, 2, 18, 157, 40);
INSERT INTO public.who_global_data VALUES (37058, 52, 1439, 3, 13, 157, 222);
INSERT INTO public.who_global_data VALUES (37059, 819, 74893, 18, 2778, 157, 132);
INSERT INTO public.who_global_data VALUES (37060, 0, 252, 0, 13, 157, 130);
INSERT INTO public.who_global_data VALUES (37061, 70, 9479, 0, 59, 157, 234);
INSERT INTO public.who_global_data VALUES (37062, 0, 2149, 0, 33, 157, 23);
INSERT INTO public.who_global_data VALUES (37063, 72, 1306, 2, 39, 157, 192);
INSERT INTO public.who_global_data VALUES (37064, 0, 8224, 0, 201, 157, 69);
INSERT INTO public.who_global_data VALUES (37065, 0, 12, 0, 0, 157, 187);
INSERT INTO public.who_global_data VALUES (37066, 840, 61014, 15, 1873, 157, 230);
INSERT INTO public.who_global_data VALUES (37067, 118, 6257, 1, 616, 157, 77);
INSERT INTO public.who_global_data VALUES (37068, 9, 2116, 0, 10, 157, 9);
INSERT INTO public.who_global_data VALUES (37069, 78357, 3769523, 1045, 66333, 157, 74);
INSERT INTO public.who_global_data VALUES (37070, 2775, 177571, 88, 7505, 157, 224);
INSERT INTO public.who_global_data VALUES (37071, 1682, 376894, 101, 21672, 157, 199);
INSERT INTO public.who_global_data VALUES (37072, 3404, 238338, 81, 7123, 157, 190);
INSERT INTO public.who_global_data VALUES (37073, 214, 29025, 0, 1777, 157, 12);
INSERT INTO public.who_global_data VALUES (37074, 0, 336, 0, 24, 157, 104);
INSERT INTO public.who_global_data VALUES (37075, 2178, 116916, 23, 953, 157, 153);
INSERT INTO public.who_global_data VALUES (37076, 975, 270189, 8, 35491, 157, 91);
INSERT INTO public.who_global_data VALUES (37077, 102, 2459, 0, 21, 157, 215);
INSERT INTO public.who_global_data VALUES (37078, 609, 69001, 11, 1307, 157, 84);
INSERT INTO public.who_global_data VALUES (37079, 5, 379, 0, 32, 157, 231);
INSERT INTO public.who_global_data VALUES (37080, 63, 2165, 0, 15, 157, 196);
INSERT INTO public.who_global_data VALUES (37081, 659, 132354, 0, 1878, 157, 105);
INSERT INTO public.who_global_data VALUES (37082, 114, 34315, 0, 577, 157, 122);
INSERT INTO public.who_global_data VALUES (37083, 0, 0, 0, 0, 157, 159);
INSERT INTO public.who_global_data VALUES (37084, 147, 13558, 8, 523, 157, 75);
INSERT INTO public.who_global_data VALUES (37085, 702, 85811, 3, 534, 157, 27);
INSERT INTO public.who_global_data VALUES (37086, 78, 44036, 0, 1060, 157, 54);
INSERT INTO public.who_global_data VALUES (37087, 0, 22, 0, 0, 157, 226);
INSERT INTO public.who_global_data VALUES (37088, 8, 1404, 0, 34, 157, 79);
INSERT INTO public.who_global_data VALUES (37089, 459, 17767, 4, 171, 157, 56);
INSERT INTO public.who_global_data VALUES (37090, 0, 1085, 0, 31, 157, 117);
INSERT INTO public.who_global_data VALUES (37091, 0, 1305, 0, 82, 157, 152);
INSERT INTO public.who_global_data VALUES (37092, 532, 15156, 8, 250, 157, 16);
INSERT INTO public.who_global_data VALUES (37093, 0, 108, 0, 1, 157, 10);
INSERT INTO public.who_global_data VALUES (37094, 29, 2952, 0, 86, 157, 201);
INSERT INTO public.who_global_data VALUES (37095, 0, 6677, 0, 124, 157, 174);
INSERT INTO public.who_global_data VALUES (37096, 94, 14957, 3, 195, 157, 119);
INSERT INTO public.who_global_data VALUES (37097, 10, 5576, 0, 175, 157, 168);
INSERT INTO public.who_global_data VALUES (37098, 14, 9354, 1, 128, 157, 99);
INSERT INTO public.who_global_data VALUES (37099, 199, 8003, 1, 29, 157, 171);
INSERT INTO public.who_global_data VALUES (37100, 1, 2777, 0, 126, 157, 87);
INSERT INTO public.who_global_data VALUES (37101, 21, 1932, 1, 13, 157, 123);
INSERT INTO public.who_global_data VALUES (37102, 0, 0, 0, 0, 157, 151);
INSERT INTO public.who_global_data VALUES (37103, 19, 615, 0, 16, 157, 213);
INSERT INTO public.who_global_data VALUES (37104, 27, 7075, 0, 159, 157, 118);
INSERT INTO public.who_global_data VALUES (37105, 0, 356, 0, 10, 157, 134);
INSERT INTO public.who_global_data VALUES (37106, 0, 3301, 0, 40, 157, 65);
INSERT INTO public.who_global_data VALUES (37107, 3719, 599560, 256, 64414, 157, 102);
INSERT INTO public.who_global_data VALUES (37108, 0, 0, 0, 0, 157, 223);
INSERT INTO public.who_global_data VALUES (37109, 2, 143, 0, 1, 157, 4);
INSERT INTO public.who_global_data VALUES (37110, 3, 304, 0, 0, 157, 146);
INSERT INTO public.who_global_data VALUES (37111, 125, 5102, 2, 104, 157, 31);
INSERT INTO public.who_global_data VALUES (37112, 0, 13, 0, 1, 157, 127);
INSERT INTO public.who_global_data VALUES (37113, 1191, 63781, 43, 1184, 157, 22);
INSERT INTO public.who_global_data VALUES (37114, 123, 4039, 0, 23, 157, 115);
INSERT INTO public.who_global_data VALUES (37115, 51, 938, 0, 6, 157, 106);
INSERT INTO public.who_global_data VALUES (37116, 142, 7692, 6, 81, 157, 90);
INSERT INTO public.who_global_data VALUES (37117, 0, 0, 0, 0, 157, 70);
INSERT INTO public.who_global_data VALUES (37118, 1069, 40529, 11, 239, 157, 46);
INSERT INTO public.who_global_data VALUES (37119, 467, 71053, 6, 6226, 157, 139);
INSERT INTO public.who_global_data VALUES (37120, 0, 23, 0, 0, 157, 42);
INSERT INTO public.who_global_data VALUES (37121, 5, 1406, 0, 22, 157, 80);
INSERT INTO public.who_global_data VALUES (37122, 114, 3773, 4, 141, 157, 203);
INSERT INTO public.who_global_data VALUES (37123, 0, 1176, 0, 69, 157, 136);
INSERT INTO public.who_global_data VALUES (37124, 239, 54247, 10, 1023, 157, 63);
INSERT INTO public.who_global_data VALUES (37125, 0, 0, 0, 0, 157, 17);
INSERT INTO public.who_global_data VALUES (37126, 1, 57, 0, 2, 157, 172);
INSERT INTO public.who_global_data VALUES (37127, 114, 14455, 1, 604, 157, 109);
INSERT INTO public.who_global_data VALUES (37128, 139, 10783, 0, 264, 157, 200);
INSERT INTO public.who_global_data VALUES (37129, 552, 30490, 7, 180, 157, 93);
INSERT INTO public.who_global_data VALUES (37130, 206, 85928, 4, 689, 157, 5);
INSERT INTO public.who_global_data VALUES (37131, 0, 741, 0, 13, 157, 214);
INSERT INTO public.who_global_data VALUES (37132, 441, 296590, 20, 6318, 157, 204);
INSERT INTO public.who_global_data VALUES (37133, 0, 0, 0, 0, 157, 198);
INSERT INTO public.who_global_data VALUES (37134, 917, 92982, 7, 2002, 157, 173);
INSERT INTO public.who_global_data VALUES (37135, 1, 460, 0, 5, 157, 229);
INSERT INTO public.who_global_data VALUES (37136, 557, 17662, 18, 326, 157, 76);
INSERT INTO public.who_global_data VALUES (37137, 4871, 652037, 156, 28944, 157, 138);
INSERT INTO public.who_global_data VALUES (37138, 3445, 224264, 39, 3597, 157, 98);
INSERT INTO public.who_global_data VALUES (37139, 0, 0, 0, 0, 157, 103);
INSERT INTO public.who_global_data VALUES (37140, 550, 67922, 19, 2058, 157, 225);
INSERT INTO public.who_global_data VALUES (37141, 231, 58243, 2, 1824, 157, 131);
INSERT INTO public.who_global_data VALUES (37142, 222, 33421, 1, 435, 157, 235);
INSERT INTO public.who_global_data VALUES (37143, 216, 118994, 1, 198, 157, 137);
INSERT INTO public.who_global_data VALUES (37144, 267, 20449, 2, 326, 157, 81);
INSERT INTO public.who_global_data VALUES (37145, 288, 37208, 13, 1008, 157, 182);
INSERT INTO public.who_global_data VALUES (37146, 35, 1714, 0, 5, 157, 145);
INSERT INTO public.who_global_data VALUES (37147, 1053, 88593, 60, 3681, 157, 26);
INSERT INTO public.who_global_data VALUES (37148, 4952, 1005000, 115, 17414, 157, 170);
INSERT INTO public.who_global_data VALUES (37149, 79, 4142, 0, 16, 157, 191);
INSERT INTO public.who_global_data VALUES (37150, 0, 5, 0, 0, 157, 221);
INSERT INTO public.who_global_data VALUES (37151, 0, 18, 0, 0, 157, 64);
INSERT INTO public.who_global_data VALUES (37152, 0, 0, 0, 0, 157, 116);
INSERT INTO public.who_global_data VALUES (37153, 0, 17, 0, 0, 157, 128);
INSERT INTO public.who_global_data VALUES (37154, 0, 26, 0, 0, 157, 6);
INSERT INTO public.who_global_data VALUES (37155, 0, 213, 0, 5, 157, 227);
INSERT INTO public.who_global_data VALUES (37156, 0, 5, 0, 0, 157, 68);
INSERT INTO public.who_global_data VALUES (37157, 0, 60, 0, 0, 157, 184);
INSERT INTO public.who_global_data VALUES (37158, 0, 0, 0, 0, 157, 82);
INSERT INTO public.who_global_data VALUES (37159, 0, 735, 0, 42, 157, 149);
INSERT INTO public.who_global_data VALUES (37160, 0, 896, 0, 15, 157, 197);
INSERT INTO public.who_global_data VALUES (37161, 898, 316670, 32, 3929, 157, 78);
INSERT INTO public.who_global_data VALUES (37162, 44, 13655, 0, 284, 157, 233);
INSERT INTO public.who_global_data VALUES (37163, 76, 31482, 2, 715, 157, 133);
INSERT INTO public.who_global_data VALUES (37164, 0, 135, 0, 0, 157, 35);
INSERT INTO public.who_global_data VALUES (37165, 2, 2028, 1, 71, 157, 114);
INSERT INTO public.who_global_data VALUES (37166, 40, 56852, 0, 27, 157, 237);
INSERT INTO public.who_global_data VALUES (37167, 0, 4, 0, 0, 157, 55);
INSERT INTO public.who_global_data VALUES (37168, 13, 476, 0, 17, 157, 176);
INSERT INTO public.who_global_data VALUES (37169, 72, 3989, 0, 33, 157, 202);
INSERT INTO public.who_global_data VALUES (37170, 55, 2980, 0, 133, 157, 155);
INSERT INTO public.who_global_data VALUES (37171, 0, 0, 0, 0, 157, 32);
INSERT INTO public.who_global_data VALUES (37172, 0, 3310, 0, 97, 157, 220);
INSERT INTO public.who_global_data VALUES (37173, 1218, 628259, 114, 14263, 157, 30);
INSERT INTO public.who_global_data VALUES (37174, 5, 2532, 0, 47, 157, 147);
INSERT INTO public.who_global_data VALUES (37175, 6796, 504109, 62, 30956, 157, 208);
INSERT INTO public.who_global_data VALUES (37176, 43, 3092, 0, 12, 157, 45);
INSERT INTO public.who_global_data VALUES (37177, 0, 13189, 0, 823, 157, 110);
INSERT INTO public.who_global_data VALUES (37178, 25, 4034, 4, 71, 157, 88);
INSERT INTO public.who_global_data VALUES (37179, 162, 84397, 2, 5830, 157, 51);
INSERT INTO public.who_global_data VALUES (37180, 364, 42956, 1, 1761, 157, 209);
INSERT INTO public.who_global_data VALUES (37181, 65, 2830, 4, 116, 157, 205);
INSERT INTO public.who_global_data VALUES (37182, 36, 8619, 1, 69, 157, 18);
INSERT INTO public.who_global_data VALUES (37183, 8, 3425, 0, 58, 157, 72);
INSERT INTO public.who_global_data VALUES (37184, 1295, 337172, 3, 41504, 157, 44);
INSERT INTO public.who_global_data VALUES (37185, 0, 27, 0, 0, 157, 15);
INSERT INTO public.who_global_data VALUES (37186, 4, 1400, 0, 27, 157, 25);
INSERT INTO public.who_global_data VALUES (37187, 0, 0, 0, 0, 157, 179);
INSERT INTO public.who_global_data VALUES (37188, 0, 0, 0, 0, 157, 34);
INSERT INTO public.who_global_data VALUES (37189, 46, 1773, 3, 25, 157, 207);
INSERT INTO public.who_global_data VALUES (37190, 233, 4196, 1, 81, 157, 166);
INSERT INTO public.who_global_data VALUES (37191, 8302, 513985, 47, 6417, 157, 126);
INSERT INTO public.who_global_data VALUES (37192, 0, 0, 0, 0, 157, 97);
INSERT INTO public.who_global_data VALUES (37193, 1, 508, 1, 4, 157, 36);
INSERT INTO public.who_global_data VALUES (37194, 0, 0, 0, 0, 157, 125);
INSERT INTO public.who_global_data VALUES (37195, 65, 3037, 0, 32, 157, 124);
INSERT INTO public.who_global_data VALUES (37196, 2495, 125798, 51, 2656, 157, 185);
INSERT INTO public.who_global_data VALUES (37197, 574, 70805, 0, 384, 157, 194);
INSERT INTO public.who_global_data VALUES (37198, 0, 509, 0, 21, 157, 144);
INSERT INTO public.who_global_data VALUES (37199, 31808, 5968380, 423, 182585, 157, 19);
INSERT INTO public.who_global_data VALUES (37200, 5, 1139, 1, 15, 157, 217);
INSERT INTO public.who_global_data VALUES (37201, 10, 1595, 0, 44, 157, 148);
INSERT INTO public.who_global_data VALUES (37202, 376, 42370, 4, 326, 157, 86);
INSERT INTO public.who_global_data VALUES (37203, 0, 0, 0, 0, 157, 13);
INSERT INTO public.who_global_data VALUES (37204, 860, 46728, 5, 386, 157, 157);
INSERT INTO public.who_global_data VALUES (37205, 0, 1044, 0, 34, 157, 8);
INSERT INTO public.who_global_data VALUES (37206, 0, 0, 0, 0, 157, 73);
INSERT INTO public.who_global_data VALUES (37207, 4, 1966, 4, 571, 157, 101);
INSERT INTO public.who_global_data VALUES (37208, 284, 12381, 2, 290, 157, 165);
INSERT INTO public.who_global_data VALUES (37209, 62, 6559, 1, 203, 157, 14);
INSERT INTO public.who_global_data VALUES (37210, 34, 38282, 4, 1410, 158, 193);
INSERT INTO public.who_global_data VALUES (37211, 133, 9513, 4, 284, 158, 113);
INSERT INTO public.who_global_data VALUES (37212, 348, 44494, 9, 1510, 158, 143);
INSERT INTO public.who_global_data VALUES (37213, 0, 0, 0, 0, 158, 219);
INSERT INTO public.who_global_data VALUES (37214, 52, 1176, 0, 53, 158, 186);
INSERT INTO public.who_global_data VALUES (37215, 30, 2654, 1, 108, 158, 52);
INSERT INTO public.who_global_data VALUES (37216, 0, 3, 0, 0, 158, 180);
INSERT INTO public.who_global_data VALUES (37217, 0, 94, 0, 3, 158, 167);
INSERT INTO public.who_global_data VALUES (37218, 7187, 408426, 97, 8498, 158, 154);
INSERT INTO public.who_global_data VALUES (37219, 97, 43191, 2, 876, 158, 94);
INSERT INTO public.who_global_data VALUES (37220, 149, 1997, 2, 10, 158, 66);
INSERT INTO public.who_global_data VALUES (37221, 76, 25746, 41, 652, 158, 58);
INSERT INTO public.who_global_data VALUES (37222, 186, 27404, 0, 733, 158, 163);
INSERT INTO public.who_global_data VALUES (37223, 126, 36435, 3, 534, 158, 37);
INSERT INTO public.who_global_data VALUES (37224, 32, 2167, 0, 43, 158, 142);
INSERT INTO public.who_global_data VALUES (37225, 398, 51972, 1, 190, 158, 83);
INSERT INTO public.who_global_data VALUES (37226, 2174, 312996, 33, 4281, 158, 228);
INSERT INTO public.who_global_data VALUES (37227, 0, 173, 0, 7, 158, 188);
INSERT INTO public.who_global_data VALUES (37228, 156, 71843, 5, 681, 158, 62);
INSERT INTO public.who_global_data VALUES (37229, 634, 86130, 3, 9887, 158, 160);
INSERT INTO public.who_global_data VALUES (37230, 29, 993, 0, 13, 158, 50);
INSERT INTO public.who_global_data VALUES (37231, 0, 2145, 0, 40, 158, 33);
INSERT INTO public.who_global_data VALUES (37232, 0, 169, 0, 9, 158, 183);
INSERT INTO public.who_global_data VALUES (37233, 1, 225, 0, 0, 158, 92);
INSERT INTO public.who_global_data VALUES (37234, 614, 115968, 28, 4966, 158, 158);
INSERT INTO public.who_global_data VALUES (37235, 0, 7, 0, 0, 158, 67);
INSERT INTO public.who_global_data VALUES (37236, 231, 20020, 11, 603, 158, 57);
INSERT INTO public.who_global_data VALUES (37237, 91, 1724, 0, 6, 158, 38);
INSERT INTO public.who_global_data VALUES (37238, 16158, 3862311, 366, 120828, 158, 141);
INSERT INTO public.who_global_data VALUES (37239, 10, 47, 0, 1, 158, 178);
INSERT INTO public.who_global_data VALUES (37240, 0, 144, 0, 3, 158, 108);
INSERT INTO public.who_global_data VALUES (37241, 76, 16266, 16, 629, 158, 39);
INSERT INTO public.who_global_data VALUES (37242, 0, 1368, 0, 55, 158, 2);
INSERT INTO public.who_global_data VALUES (37243, 0, 445, 0, 1, 158, 195);
INSERT INTO public.who_global_data VALUES (37244, 32, 3884, 0, 40, 158, 107);
INSERT INTO public.who_global_data VALUES (37245, 0, 274, 0, 0, 158, 161);
INSERT INTO public.who_global_data VALUES (37246, 267, 19409, 3, 414, 158, 212);
INSERT INTO public.who_global_data VALUES (37247, 267, 127940, 4, 9117, 158, 181);
INSERT INTO public.who_global_data VALUES (37248, 0, 205, 0, 1, 158, 53);
INSERT INTO public.who_global_data VALUES (37249, 11, 4711, 1, 62, 158, 164);
INSERT INTO public.who_global_data VALUES (37250, 1, 1013, 0, 77, 158, 140);
INSERT INTO public.who_global_data VALUES (37251, 1752, 411726, 45, 11289, 158, 20);
INSERT INTO public.who_global_data VALUES (37252, 19, 90402, 1, 4730, 158, 112);
INSERT INTO public.who_global_data VALUES (37253, 8024, 607938, 300, 19364, 158, 111);
INSERT INTO public.who_global_data VALUES (37254, 0, 423, 0, 7, 158, 71);
INSERT INTO public.who_global_data VALUES (37255, 0, 3979, 0, 78, 158, 218);
INSERT INTO public.who_global_data VALUES (37256, 0, 0, 0, 0, 158, 43);
INSERT INTO public.who_global_data VALUES (37257, 0, 39699, 0, 418, 158, 49);
INSERT INTO public.who_global_data VALUES (37258, 0, 17948, 0, 115, 158, 1);
INSERT INTO public.who_global_data VALUES (37259, 146, 10269, 2, 186, 158, 48);
INSERT INTO public.who_global_data VALUES (37260, 59, 4032, 0, 94, 158, 232);
INSERT INTO public.who_global_data VALUES (37261, 13, 68, 0, 1, 158, 175);
INSERT INTO public.who_global_data VALUES (37262, 1, 1488, 0, 21, 158, 21);
INSERT INTO public.who_global_data VALUES (37263, 251, 24618, 1, 424, 158, 156);
INSERT INTO public.who_global_data VALUES (37264, 0, 0, 0, 0, 158, 95);
INSERT INTO public.who_global_data VALUES (37265, 103, 10096, 3, 258, 158, 177);
INSERT INTO public.who_global_data VALUES (37266, 285, 16985, 0, 624, 158, 210);
INSERT INTO public.who_global_data VALUES (37267, 2, 5387, 0, 60, 158, 120);
INSERT INTO public.who_global_data VALUES (37268, 0, 20, 0, 0, 158, 135);
INSERT INTO public.who_global_data VALUES (37269, 480, 94715, 29, 1710, 158, 206);
INSERT INTO public.who_global_data VALUES (37270, 119, 113767, 1, 6556, 158, 189);
INSERT INTO public.who_global_data VALUES (37271, 212, 98939, 22, 5421, 158, 129);
INSERT INTO public.who_global_data VALUES (37272, 94, 25729, 4, 717, 158, 121);
INSERT INTO public.who_global_data VALUES (37273, 0, 4941, 0, 83, 158, 59);
INSERT INTO public.who_global_data VALUES (37274, 1, 319, 0, 0, 158, 96);
INSERT INTO public.who_global_data VALUES (37275, 2, 2375, 0, 64, 158, 41);
INSERT INTO public.who_global_data VALUES (37276, 16, 4577, 0, 91, 158, 216);
INSERT INTO public.who_global_data VALUES (37277, 1009, 52131, 16, 809, 158, 236);
INSERT INTO public.who_global_data VALUES (37278, 0, 13, 0, 0, 158, 150);
INSERT INTO public.who_global_data VALUES (37279, 0, 411, 0, 0, 158, 61);
INSERT INTO public.who_global_data VALUES (37280, 0, 28, 0, 2, 158, 7);
INSERT INTO public.who_global_data VALUES (37281, 9, 8086, 0, 335, 158, 169);
INSERT INTO public.who_global_data VALUES (37282, 2998, 264953, 27, 30494, 158, 28);
INSERT INTO public.who_global_data VALUES (37283, 39, 9115, 1, 59, 158, 85);
INSERT INTO public.who_global_data VALUES (37284, 46, 573, 0, 0, 158, 211);
INSERT INTO public.who_global_data VALUES (37285, 28, 8533, 0, 53, 158, 60);
INSERT INTO public.who_global_data VALUES (37286, 166, 2963, 0, 96, 158, 3);
INSERT INTO public.who_global_data VALUES (37287, 23, 1510, 0, 19, 158, 11);
INSERT INTO public.who_global_data VALUES (37288, 1218, 243599, 4, 9302, 158, 89);
INSERT INTO public.who_global_data VALUES (37289, 0, 44205, 0, 276, 158, 24);
INSERT INTO public.who_global_data VALUES (37290, 10, 285, 0, 0, 158, 162);
INSERT INTO public.who_global_data VALUES (37291, 183, 10317, 4, 266, 158, 100);
INSERT INTO public.who_global_data VALUES (37292, 0, 14, 0, 0, 158, 47);
INSERT INTO public.who_global_data VALUES (37293, 0, 24, 0, 0, 158, 29);
INSERT INTO public.who_global_data VALUES (37294, 0, 1145, 0, 16, 158, 40);
INSERT INTO public.who_global_data VALUES (37295, 48, 1387, 0, 10, 158, 222);
INSERT INTO public.who_global_data VALUES (37296, 162, 74074, 20, 2760, 158, 132);
INSERT INTO public.who_global_data VALUES (37297, 0, 252, 0, 13, 158, 130);
INSERT INTO public.who_global_data VALUES (37298, 38, 9409, 0, 59, 158, 234);
INSERT INTO public.who_global_data VALUES (37299, 0, 2149, 0, 33, 158, 23);
INSERT INTO public.who_global_data VALUES (37300, 50, 1234, 2, 37, 158, 192);
INSERT INTO public.who_global_data VALUES (37301, 15, 8224, 0, 201, 158, 69);
INSERT INTO public.who_global_data VALUES (37302, 0, 12, 0, 0, 158, 187);
INSERT INTO public.who_global_data VALUES (37303, 529, 60174, 16, 1858, 158, 230);
INSERT INTO public.who_global_data VALUES (37304, 178, 6139, 1, 615, 158, 77);
INSERT INTO public.who_global_data VALUES (37305, 2, 2107, 0, 10, 158, 9);
INSERT INTO public.who_global_data VALUES (37306, 69921, 3691166, 819, 65288, 158, 74);
INSERT INTO public.who_global_data VALUES (37307, 2743, 174796, 74, 7417, 158, 224);
INSERT INTO public.who_global_data VALUES (37308, 1642, 375212, 109, 21571, 158, 199);
INSERT INTO public.who_global_data VALUES (37309, 3757, 234934, 83, 7042, 158, 190);
INSERT INTO public.who_global_data VALUES (37310, 51, 28811, 0, 1777, 158, 12);
INSERT INTO public.who_global_data VALUES (37311, 0, 336, 0, 24, 158, 104);
INSERT INTO public.who_global_data VALUES (37312, 1101, 114738, 14, 930, 158, 153);
INSERT INTO public.who_global_data VALUES (37313, 996, 269214, 6, 35483, 158, 91);
INSERT INTO public.who_global_data VALUES (37314, 244, 2357, 2, 21, 158, 215);
INSERT INTO public.who_global_data VALUES (37315, 527, 68392, 17, 1296, 158, 84);
INSERT INTO public.who_global_data VALUES (37316, 0, 374, 0, 32, 158, 231);
INSERT INTO public.who_global_data VALUES (37317, 68, 2102, 0, 15, 158, 196);
INSERT INTO public.who_global_data VALUES (37318, 99, 131695, 0, 1878, 158, 105);
INSERT INTO public.who_global_data VALUES (37319, 144, 34201, 3, 577, 158, 122);
INSERT INTO public.who_global_data VALUES (37320, 0, 0, 0, 0, 158, 159);
INSERT INTO public.who_global_data VALUES (37321, 120, 13411, 9, 515, 158, 75);
INSERT INTO public.who_global_data VALUES (37322, 473, 85109, 1, 531, 158, 27);
INSERT INTO public.who_global_data VALUES (37323, 60, 43958, 1, 1060, 158, 54);
INSERT INTO public.who_global_data VALUES (37324, 0, 22, 0, 0, 158, 226);
INSERT INTO public.who_global_data VALUES (37325, 3, 1396, 0, 34, 158, 79);
INSERT INTO public.who_global_data VALUES (37326, 438, 17308, 7, 167, 158, 56);
INSERT INTO public.who_global_data VALUES (37327, 19, 1085, 0, 31, 158, 117);
INSERT INTO public.who_global_data VALUES (37328, 2, 1305, 0, 82, 158, 152);
INSERT INTO public.who_global_data VALUES (37329, 658, 14624, 5, 242, 158, 16);
INSERT INTO public.who_global_data VALUES (37330, 0, 108, 0, 1, 158, 10);
INSERT INTO public.who_global_data VALUES (37331, 23, 2923, 0, 86, 158, 201);
INSERT INTO public.who_global_data VALUES (37332, 52, 6677, 0, 124, 158, 174);
INSERT INTO public.who_global_data VALUES (37333, 20, 14863, 1, 192, 158, 119);
INSERT INTO public.who_global_data VALUES (37334, 30, 5566, 1, 175, 158, 168);
INSERT INTO public.who_global_data VALUES (37335, 6, 9340, 1, 127, 158, 99);
INSERT INTO public.who_global_data VALUES (37336, 137, 7804, 0, 28, 158, 171);
INSERT INTO public.who_global_data VALUES (37337, 3, 2776, 0, 126, 158, 87);
INSERT INTO public.who_global_data VALUES (37338, 26, 1911, 0, 12, 158, 123);
INSERT INTO public.who_global_data VALUES (37339, 0, 0, 0, 0, 158, 151);
INSERT INTO public.who_global_data VALUES (37340, 0, 596, 0, 16, 158, 213);
INSERT INTO public.who_global_data VALUES (37341, 26, 7048, 0, 159, 158, 118);
INSERT INTO public.who_global_data VALUES (37342, 10, 356, 0, 10, 158, 134);
INSERT INTO public.who_global_data VALUES (37343, 0, 3301, 0, 40, 158, 65);
INSERT INTO public.who_global_data VALUES (37344, 4129, 595841, 339, 64158, 158, 102);
INSERT INTO public.who_global_data VALUES (37345, 0, 0, 0, 0, 158, 223);
INSERT INTO public.who_global_data VALUES (37346, 7, 141, 0, 1, 158, 4);
INSERT INTO public.who_global_data VALUES (37347, 0, 301, 0, 0, 158, 146);
INSERT INTO public.who_global_data VALUES (37348, 72, 4977, 2, 102, 158, 31);
INSERT INTO public.who_global_data VALUES (37349, 0, 13, 0, 1, 158, 127);
INSERT INTO public.who_global_data VALUES (37350, 1191, 62590, 30, 1141, 158, 22);
INSERT INTO public.who_global_data VALUES (37351, 95, 3916, 0, 23, 158, 115);
INSERT INTO public.who_global_data VALUES (37352, 112, 887, 0, 6, 158, 106);
INSERT INTO public.who_global_data VALUES (37353, 185, 7550, 3, 75, 158, 90);
INSERT INTO public.who_global_data VALUES (37354, 0, 0, 0, 0, 158, 70);
INSERT INTO public.who_global_data VALUES (37355, 899, 39460, 7, 228, 158, 46);
INSERT INTO public.who_global_data VALUES (37356, 526, 70586, 0, 6220, 158, 139);
INSERT INTO public.who_global_data VALUES (37357, 0, 23, 0, 0, 158, 42);
INSERT INTO public.who_global_data VALUES (37358, 14, 1401, 0, 22, 158, 80);
INSERT INTO public.who_global_data VALUES (37359, 0, 3659, 0, 137, 158, 203);
INSERT INTO public.who_global_data VALUES (37360, 1, 1176, 0, 69, 158, 136);
INSERT INTO public.who_global_data VALUES (37361, 143, 54008, 0, 1013, 158, 63);
INSERT INTO public.who_global_data VALUES (37362, 0, 0, 0, 0, 158, 17);
INSERT INTO public.who_global_data VALUES (37363, 0, 56, 0, 2, 158, 172);
INSERT INTO public.who_global_data VALUES (37364, 11, 14341, 3, 603, 158, 109);
INSERT INTO public.who_global_data VALUES (37365, 101, 10644, 0, 264, 158, 200);
INSERT INTO public.who_global_data VALUES (37366, 875, 29938, 4, 173, 158, 93);
INSERT INTO public.who_global_data VALUES (37367, 178, 85722, 8, 685, 158, 5);
INSERT INTO public.who_global_data VALUES (37368, 0, 741, 0, 13, 158, 214);
INSERT INTO public.who_global_data VALUES (37369, 300, 296149, 4, 6298, 158, 204);
INSERT INTO public.who_global_data VALUES (37370, 0, 0, 0, 0, 158, 198);
INSERT INTO public.who_global_data VALUES (37371, 728, 92065, 12, 1995, 158, 173);
INSERT INTO public.who_global_data VALUES (37372, 0, 459, 0, 5, 158, 229);
INSERT INTO public.who_global_data VALUES (37373, 631, 17105, 14, 308, 158, 76);
INSERT INTO public.who_global_data VALUES (37374, 7731, 647166, 181, 28788, 158, 138);
INSERT INTO public.who_global_data VALUES (37375, 3423, 220819, 38, 3558, 158, 98);
INSERT INTO public.who_global_data VALUES (37376, 0, 0, 0, 0, 158, 103);
INSERT INTO public.who_global_data VALUES (37377, 502, 67372, 6, 2039, 158, 225);
INSERT INTO public.who_global_data VALUES (37378, 244, 58012, 3, 1822, 158, 131);
INSERT INTO public.who_global_data VALUES (37379, 351, 33199, 0, 434, 158, 235);
INSERT INTO public.who_global_data VALUES (37380, 203, 118778, 0, 197, 158, 137);
INSERT INTO public.who_global_data VALUES (37381, 235, 20182, 0, 324, 158, 81);
INSERT INTO public.who_global_data VALUES (37382, 220, 36920, 3, 995, 158, 182);
INSERT INTO public.who_global_data VALUES (37383, 45, 1679, 1, 5, 158, 145);
INSERT INTO public.who_global_data VALUES (37384, 755, 87540, 43, 3621, 158, 26);
INSERT INTO public.who_global_data VALUES (37385, 4729, 1000048, 123, 17299, 158, 170);
INSERT INTO public.who_global_data VALUES (37386, 43, 4063, 0, 16, 158, 191);
INSERT INTO public.who_global_data VALUES (37387, 0, 5, 0, 0, 158, 221);
INSERT INTO public.who_global_data VALUES (37388, 0, 18, 0, 0, 158, 64);
INSERT INTO public.who_global_data VALUES (37389, 0, 0, 0, 0, 158, 116);
INSERT INTO public.who_global_data VALUES (37390, 0, 17, 0, 0, 158, 128);
INSERT INTO public.who_global_data VALUES (37391, 0, 26, 0, 0, 158, 6);
INSERT INTO public.who_global_data VALUES (37392, 0, 213, 0, 5, 158, 227);
INSERT INTO public.who_global_data VALUES (37393, 0, 5, 0, 0, 158, 68);
INSERT INTO public.who_global_data VALUES (37394, 0, 60, 0, 0, 158, 184);
INSERT INTO public.who_global_data VALUES (37395, 0, 0, 0, 0, 158, 82);
INSERT INTO public.who_global_data VALUES (37396, 0, 735, 0, 42, 158, 149);
INSERT INTO public.who_global_data VALUES (37397, 0, 896, 0, 15, 158, 197);
INSERT INTO public.who_global_data VALUES (37398, 951, 315772, 27, 3897, 158, 78);
INSERT INTO public.who_global_data VALUES (37399, 55, 13611, 0, 284, 158, 233);
INSERT INTO public.who_global_data VALUES (37400, 41, 31406, 2, 713, 158, 133);
INSERT INTO public.who_global_data VALUES (37401, 4, 135, 0, 0, 158, 35);
INSERT INTO public.who_global_data VALUES (37402, 4, 2026, 0, 70, 158, 114);
INSERT INTO public.who_global_data VALUES (37403, 41, 56812, 0, 27, 158, 237);
INSERT INTO public.who_global_data VALUES (37404, 0, 4, 0, 0, 158, 55);
INSERT INTO public.who_global_data VALUES (37405, 19, 463, 0, 17, 158, 176);
INSERT INTO public.who_global_data VALUES (37406, 41, 3917, 0, 33, 158, 202);
INSERT INTO public.who_global_data VALUES (37407, 41, 2925, 0, 133, 158, 155);
INSERT INTO public.who_global_data VALUES (37408, 0, 0, 0, 0, 158, 32);
INSERT INTO public.who_global_data VALUES (37409, 0, 3310, 0, 97, 158, 220);
INSERT INTO public.who_global_data VALUES (37410, 1985, 627041, 121, 14149, 158, 30);
INSERT INTO public.who_global_data VALUES (37411, 0, 2527, 0, 47, 158, 147);
INSERT INTO public.who_global_data VALUES (37412, 5232, 497313, 54, 30894, 158, 208);
INSERT INTO public.who_global_data VALUES (37413, 37, 3049, 0, 12, 158, 45);
INSERT INTO public.who_global_data VALUES (37414, 0, 13189, 0, 823, 158, 110);
INSERT INTO public.who_global_data VALUES (37415, 55, 4009, 0, 67, 158, 88);
INSERT INTO public.who_global_data VALUES (37416, 48, 84235, 3, 5828, 158, 51);
INSERT INTO public.who_global_data VALUES (37417, 347, 42592, 1, 1760, 158, 209);
INSERT INTO public.who_global_data VALUES (37418, 62, 2765, 3, 112, 158, 205);
INSERT INTO public.who_global_data VALUES (37419, 33, 8583, 0, 68, 158, 18);
INSERT INTO public.who_global_data VALUES (37420, 5, 3417, 0, 58, 158, 72);
INSERT INTO public.who_global_data VALUES (37421, 1406, 335877, 2, 41501, 158, 44);
INSERT INTO public.who_global_data VALUES (37422, 0, 27, 0, 0, 158, 15);
INSERT INTO public.who_global_data VALUES (37423, 0, 1396, 0, 27, 158, 25);
INSERT INTO public.who_global_data VALUES (37424, 0, 0, 0, 0, 158, 179);
INSERT INTO public.who_global_data VALUES (37425, 0, 0, 0, 0, 158, 34);
INSERT INTO public.who_global_data VALUES (37426, 44, 1727, 1, 22, 158, 207);
INSERT INTO public.who_global_data VALUES (37427, 160, 3963, 3, 80, 158, 166);
INSERT INTO public.who_global_data VALUES (37428, 8317, 505683, 44, 6370, 158, 126);
INSERT INTO public.who_global_data VALUES (37429, 0, 0, 0, 0, 158, 97);
INSERT INTO public.who_global_data VALUES (37430, 2, 507, 0, 3, 158, 36);
INSERT INTO public.who_global_data VALUES (37431, 0, 0, 0, 0, 158, 125);
INSERT INTO public.who_global_data VALUES (37432, 84, 2972, 2, 32, 158, 124);
INSERT INTO public.who_global_data VALUES (37433, 2088, 123303, 48, 2605, 158, 185);
INSERT INTO public.who_global_data VALUES (37434, 541, 70231, 2, 384, 158, 194);
INSERT INTO public.who_global_data VALUES (37435, 0, 509, 0, 21, 158, 144);
INSERT INTO public.who_global_data VALUES (37436, 37068, 5936572, 473, 182162, 158, 19);
INSERT INTO public.who_global_data VALUES (37437, 5, 1134, 0, 14, 158, 217);
INSERT INTO public.who_global_data VALUES (37438, 15, 1585, 0, 44, 158, 148);
INSERT INTO public.who_global_data VALUES (37439, 343, 41994, 5, 322, 158, 86);
INSERT INTO public.who_global_data VALUES (37440, 0, 0, 0, 0, 158, 13);
INSERT INTO public.who_global_data VALUES (37441, 922, 45868, 6, 381, 158, 157);
INSERT INTO public.who_global_data VALUES (37442, 4, 1044, 2, 34, 158, 8);
INSERT INTO public.who_global_data VALUES (37443, 0, 0, 0, 0, 158, 73);
INSERT INTO public.who_global_data VALUES (37444, 5, 1962, 2, 567, 158, 101);
INSERT INTO public.who_global_data VALUES (37445, 72, 12097, 1, 288, 158, 165);
INSERT INTO public.who_global_data VALUES (37446, 85, 6497, 6, 202, 158, 14);
INSERT INTO public.who_global_data VALUES (37447, 19, 38248, 0, 1406, 159, 193);
INSERT INTO public.who_global_data VALUES (37448, 101, 9380, 5, 280, 159, 113);
INSERT INTO public.who_global_data VALUES (37449, 364, 44146, 10, 1501, 159, 143);
INSERT INTO public.who_global_data VALUES (37450, 0, 0, 0, 0, 159, 219);
INSERT INTO public.who_global_data VALUES (37451, 0, 1124, 0, 53, 159, 186);
INSERT INTO public.who_global_data VALUES (37452, 73, 2624, 0, 107, 159, 52);
INSERT INTO public.who_global_data VALUES (37453, 0, 3, 0, 0, 159, 180);
INSERT INTO public.who_global_data VALUES (37454, 0, 94, 0, 3, 159, 167);
INSERT INTO public.who_global_data VALUES (37455, 9230, 401239, 96, 8401, 159, 154);
INSERT INTO public.who_global_data VALUES (37456, 31, 43094, 2, 874, 159, 94);
INSERT INTO public.who_global_data VALUES (37457, 0, 1848, 0, 8, 159, 66);
INSERT INTO public.who_global_data VALUES (37458, 123, 25670, 11, 611, 159, 58);
INSERT INTO public.who_global_data VALUES (37459, 281, 27218, 0, 733, 159, 163);
INSERT INTO public.who_global_data VALUES (37460, 135, 36309, 2, 531, 159, 37);
INSERT INTO public.who_global_data VALUES (37461, 78, 2135, 3, 43, 159, 142);
INSERT INTO public.who_global_data VALUES (37462, 183, 51574, 0, 189, 159, 83);
INSERT INTO public.who_global_data VALUES (37463, 1897, 310822, 42, 4248, 159, 228);
INSERT INTO public.who_global_data VALUES (37464, 7, 173, 0, 7, 159, 188);
INSERT INTO public.who_global_data VALUES (37465, 164, 71687, 5, 676, 159, 62);
INSERT INTO public.who_global_data VALUES (37466, 117, 85496, 1, 9884, 159, 160);
INSERT INTO public.who_global_data VALUES (37467, 94, 964, 1, 13, 159, 50);
INSERT INTO public.who_global_data VALUES (37468, 0, 2145, 0, 40, 159, 33);
INSERT INTO public.who_global_data VALUES (37469, 1, 169, 0, 9, 159, 183);
INSERT INTO public.who_global_data VALUES (37470, 29, 224, 0, 0, 159, 92);
INSERT INTO public.who_global_data VALUES (37471, 945, 115354, 92, 4938, 159, 158);
INSERT INTO public.who_global_data VALUES (37472, 1, 7, 0, 0, 159, 67);
INSERT INTO public.who_global_data VALUES (37473, 243, 19789, 4, 592, 159, 57);
INSERT INTO public.who_global_data VALUES (37474, 0, 1633, 0, 6, 159, 38);
INSERT INTO public.who_global_data VALUES (37475, 41350, 3846153, 958, 120462, 159, 141);
INSERT INTO public.who_global_data VALUES (37476, 2, 37, 0, 1, 159, 178);
INSERT INTO public.who_global_data VALUES (37477, 0, 144, 0, 3, 159, 108);
INSERT INTO public.who_global_data VALUES (37478, 26, 16190, 8, 613, 159, 39);
INSERT INTO public.who_global_data VALUES (37479, 11, 1368, 0, 55, 159, 2);
INSERT INTO public.who_global_data VALUES (37480, 0, 445, 0, 1, 159, 195);
INSERT INTO public.who_global_data VALUES (37481, 74, 3852, 1, 40, 159, 107);
INSERT INTO public.who_global_data VALUES (37482, 1, 274, 0, 0, 159, 161);
INSERT INTO public.who_global_data VALUES (37483, 0, 19142, 0, 411, 159, 212);
INSERT INTO public.who_global_data VALUES (37484, 315, 127673, 5, 9113, 159, 181);
INSERT INTO public.who_global_data VALUES (37485, 0, 205, 0, 1, 159, 53);
INSERT INTO public.who_global_data VALUES (37486, 0, 4700, 0, 61, 159, 164);
INSERT INTO public.who_global_data VALUES (37487, 4, 1012, 0, 77, 159, 140);
INSERT INTO public.who_global_data VALUES (37488, 1965, 409974, 63, 11244, 159, 20);
INSERT INTO public.who_global_data VALUES (37489, 32, 90383, 1, 4729, 159, 112);
INSERT INTO public.who_global_data VALUES (37490, 9394, 599914, 297, 19064, 159, 111);
INSERT INTO public.who_global_data VALUES (37491, 0, 423, 0, 7, 159, 71);
INSERT INTO public.who_global_data VALUES (37492, 0, 3979, 0, 78, 159, 218);
INSERT INTO public.who_global_data VALUES (37493, 0, 0, 0, 0, 159, 43);
INSERT INTO public.who_global_data VALUES (37494, 1214, 39699, 11, 418, 159, 49);
INSERT INTO public.who_global_data VALUES (37495, 55, 17948, 0, 115, 159, 1);
INSERT INTO public.who_global_data VALUES (37496, 262, 10123, 1, 184, 159, 48);
INSERT INTO public.who_global_data VALUES (37497, 48, 3973, 0, 94, 159, 232);
INSERT INTO public.who_global_data VALUES (37498, 0, 55, 0, 1, 159, 175);
INSERT INTO public.who_global_data VALUES (37499, 4, 1487, 0, 21, 159, 21);
INSERT INTO public.who_global_data VALUES (37500, 273, 24367, 2, 423, 159, 156);
INSERT INTO public.who_global_data VALUES (37501, 0, 0, 0, 0, 159, 95);
INSERT INTO public.who_global_data VALUES (37502, 0, 9993, 0, 255, 159, 177);
INSERT INTO public.who_global_data VALUES (37503, 0, 16700, 0, 624, 159, 210);
INSERT INTO public.who_global_data VALUES (37504, 0, 5385, 0, 60, 159, 120);
INSERT INTO public.who_global_data VALUES (37505, 0, 20, 0, 0, 159, 135);
INSERT INTO public.who_global_data VALUES (37506, 509, 94235, 8, 1681, 159, 206);
INSERT INTO public.who_global_data VALUES (37507, 742, 113648, 18, 6555, 159, 189);
INSERT INTO public.who_global_data VALUES (37508, 230, 98727, 23, 5399, 159, 129);
INSERT INTO public.who_global_data VALUES (37509, 98, 25635, 5, 713, 159, 121);
INSERT INTO public.who_global_data VALUES (37510, 0, 4941, 0, 83, 159, 59);
INSERT INTO public.who_global_data VALUES (37511, 0, 318, 0, 0, 159, 96);
INSERT INTO public.who_global_data VALUES (37512, 10, 2373, 0, 64, 159, 41);
INSERT INTO public.who_global_data VALUES (37513, 51, 4561, 0, 91, 159, 216);
INSERT INTO public.who_global_data VALUES (37514, 1468, 51122, 23, 793, 159, 236);
INSERT INTO public.who_global_data VALUES (37515, 0, 13, 0, 0, 159, 150);
INSERT INTO public.who_global_data VALUES (37516, 0, 411, 0, 0, 159, 61);
INSERT INTO public.who_global_data VALUES (37517, 0, 28, 0, 2, 159, 7);
INSERT INTO public.who_global_data VALUES (37518, 28, 8077, 0, 335, 159, 169);
INSERT INTO public.who_global_data VALUES (37519, 5126, 261955, 2, 30467, 159, 28);
INSERT INTO public.who_global_data VALUES (37520, 0, 9076, 0, 58, 159, 85);
INSERT INTO public.who_global_data VALUES (37521, 45, 527, 0, 0, 159, 211);
INSERT INTO public.who_global_data VALUES (37522, 0, 8505, 0, 53, 159, 60);
INSERT INTO public.who_global_data VALUES (37523, 0, 2797, 0, 96, 159, 3);
INSERT INTO public.who_global_data VALUES (37524, 18, 1487, 0, 19, 159, 11);
INSERT INTO public.who_global_data VALUES (37525, 610, 242381, 3, 9298, 159, 89);
INSERT INTO public.who_global_data VALUES (37526, 256, 44205, 6, 276, 159, 24);
INSERT INTO public.who_global_data VALUES (37527, 1, 275, 0, 0, 159, 162);
INSERT INTO public.who_global_data VALUES (37528, 157, 10134, 2, 262, 159, 100);
INSERT INTO public.who_global_data VALUES (37529, 0, 14, 0, 0, 159, 47);
INSERT INTO public.who_global_data VALUES (37530, 0, 24, 0, 0, 159, 29);
INSERT INTO public.who_global_data VALUES (37531, 210, 1145, 1, 16, 159, 40);
INSERT INTO public.who_global_data VALUES (37532, 0, 1339, 0, 10, 159, 222);
INSERT INTO public.who_global_data VALUES (37533, 233, 73912, 12, 2740, 159, 132);
INSERT INTO public.who_global_data VALUES (37534, 0, 252, 0, 13, 159, 130);
INSERT INTO public.who_global_data VALUES (37535, 120, 9371, 0, 59, 159, 234);
INSERT INTO public.who_global_data VALUES (37536, 0, 2149, 0, 33, 159, 23);
INSERT INTO public.who_global_data VALUES (37537, 4, 1184, 0, 35, 159, 192);
INSERT INTO public.who_global_data VALUES (37538, 35, 8209, 0, 201, 159, 69);
INSERT INTO public.who_global_data VALUES (37539, 0, 12, 0, 0, 159, 187);
INSERT INTO public.who_global_data VALUES (37540, 835, 59645, 15, 1842, 159, 230);
INSERT INTO public.who_global_data VALUES (37541, 292, 5961, 0, 614, 159, 77);
INSERT INTO public.who_global_data VALUES (37542, 5, 2105, 0, 10, 159, 9);
INSERT INTO public.who_global_data VALUES (37543, 78512, 3621245, 971, 64469, 159, 74);
INSERT INTO public.who_global_data VALUES (37544, 2858, 172053, 82, 7343, 159, 224);
INSERT INTO public.who_global_data VALUES (37545, 1754, 373570, 103, 21462, 159, 199);
INSERT INTO public.who_global_data VALUES (37546, 3731, 231177, 68, 6959, 159, 190);
INSERT INTO public.who_global_data VALUES (37547, 40, 28760, 0, 1777, 159, 12);
INSERT INTO public.who_global_data VALUES (37548, 0, 336, 0, 24, 159, 104);
INSERT INTO public.who_global_data VALUES (37549, 910, 113637, 5, 916, 159, 153);
INSERT INTO public.who_global_data VALUES (37550, 1365, 268218, 4, 35477, 159, 91);
INSERT INTO public.who_global_data VALUES (37551, 102, 2113, 0, 19, 159, 215);
INSERT INTO public.who_global_data VALUES (37552, 601, 67865, 15, 1279, 159, 84);
INSERT INTO public.who_global_data VALUES (37553, 0, 374, 0, 32, 159, 231);
INSERT INTO public.who_global_data VALUES (37554, 73, 2034, 0, 15, 159, 196);
INSERT INTO public.who_global_data VALUES (37555, 87, 131596, 0, 1878, 159, 105);
INSERT INTO public.who_global_data VALUES (37556, 263, 34057, 2, 574, 159, 122);
INSERT INTO public.who_global_data VALUES (37557, 0, 0, 0, 0, 159, 159);
INSERT INTO public.who_global_data VALUES (37558, 119, 13291, 8, 506, 159, 75);
INSERT INTO public.who_global_data VALUES (37559, 412, 84636, 2, 530, 159, 27);
INSERT INTO public.who_global_data VALUES (37560, 78, 43898, 0, 1059, 159, 54);
INSERT INTO public.who_global_data VALUES (37561, 0, 22, 0, 0, 159, 226);
INSERT INTO public.who_global_data VALUES (37562, 18, 1393, 0, 34, 159, 79);
INSERT INTO public.who_global_data VALUES (37563, 595, 16870, 5, 160, 159, 56);
INSERT INTO public.who_global_data VALUES (37564, 0, 1066, 0, 31, 159, 117);
INSERT INTO public.who_global_data VALUES (37565, 0, 1303, 0, 82, 159, 152);
INSERT INTO public.who_global_data VALUES (37566, 543, 13966, 5, 237, 159, 16);
INSERT INTO public.who_global_data VALUES (37567, 0, 108, 0, 1, 159, 10);
INSERT INTO public.who_global_data VALUES (37568, 32, 2900, 0, 86, 159, 201);
INSERT INTO public.who_global_data VALUES (37569, 45, 6625, 0, 124, 159, 174);
INSERT INTO public.who_global_data VALUES (37570, 52, 14843, 1, 191, 159, 119);
INSERT INTO public.who_global_data VALUES (37571, 8, 5536, 0, 174, 159, 168);
INSERT INTO public.who_global_data VALUES (37572, 17, 9334, 1, 126, 159, 99);
INSERT INTO public.who_global_data VALUES (37573, 89, 7667, 0, 28, 159, 171);
INSERT INTO public.who_global_data VALUES (37574, 16, 2773, 0, 126, 159, 87);
INSERT INTO public.who_global_data VALUES (37575, 21, 1885, 1, 12, 159, 123);
INSERT INTO public.who_global_data VALUES (37576, 0, 0, 0, 0, 159, 151);
INSERT INTO public.who_global_data VALUES (37577, 0, 596, 0, 16, 159, 213);
INSERT INTO public.who_global_data VALUES (37578, 10, 7022, 1, 159, 159, 118);
INSERT INTO public.who_global_data VALUES (37579, 0, 346, 0, 10, 159, 134);
INSERT INTO public.who_global_data VALUES (37580, 0, 3301, 0, 40, 159, 65);
INSERT INTO public.who_global_data VALUES (37581, 5974, 591712, 673, 63819, 159, 102);
INSERT INTO public.who_global_data VALUES (37582, 0, 0, 0, 0, 159, 223);
INSERT INTO public.who_global_data VALUES (37583, 1, 134, 0, 1, 159, 4);
INSERT INTO public.who_global_data VALUES (37584, 0, 301, 0, 0, 159, 146);
INSERT INTO public.who_global_data VALUES (37585, 88, 4905, 1, 100, 159, 31);
INSERT INTO public.who_global_data VALUES (37586, 0, 13, 0, 1, 159, 127);
INSERT INTO public.who_global_data VALUES (37587, 1343, 61399, 33, 1111, 159, 22);
INSERT INTO public.who_global_data VALUES (37588, 61, 3821, 1, 23, 159, 115);
INSERT INTO public.who_global_data VALUES (37589, 26, 775, 0, 6, 159, 106);
INSERT INTO public.who_global_data VALUES (37590, 249, 7365, 3, 72, 159, 90);
INSERT INTO public.who_global_data VALUES (37591, 0, 0, 0, 0, 159, 70);
INSERT INTO public.who_global_data VALUES (37592, 1221, 38561, 14, 221, 159, 46);
INSERT INTO public.who_global_data VALUES (37593, 506, 70060, 0, 6220, 159, 139);
INSERT INTO public.who_global_data VALUES (37594, 0, 23, 0, 0, 159, 42);
INSERT INTO public.who_global_data VALUES (37595, 9, 1387, 0, 22, 159, 80);
INSERT INTO public.who_global_data VALUES (37596, 0, 3659, 0, 137, 159, 203);
INSERT INTO public.who_global_data VALUES (37597, 0, 1175, 0, 69, 159, 136);
INSERT INTO public.who_global_data VALUES (37598, 138, 53865, 2, 1013, 159, 63);
INSERT INTO public.who_global_data VALUES (37599, 0, 0, 0, 0, 159, 17);
INSERT INTO public.who_global_data VALUES (37600, 0, 56, 0, 2, 159, 172);
INSERT INTO public.who_global_data VALUES (37601, 37, 14330, 4, 600, 159, 109);
INSERT INTO public.who_global_data VALUES (37602, 0, 10543, 0, 264, 159, 200);
INSERT INTO public.who_global_data VALUES (37603, 536, 29063, 5, 169, 159, 93);
INSERT INTO public.who_global_data VALUES (37604, 539, 85544, 27, 677, 159, 5);
INSERT INTO public.who_global_data VALUES (37605, 0, 741, 0, 13, 159, 214);
INSERT INTO public.who_global_data VALUES (37606, 213, 295849, 6, 6294, 159, 204);
INSERT INTO public.who_global_data VALUES (37607, 0, 0, 0, 0, 159, 198);
INSERT INTO public.who_global_data VALUES (37608, 713, 91337, 17, 1983, 159, 173);
INSERT INTO public.who_global_data VALUES (37609, 0, 459, 0, 5, 159, 229);
INSERT INTO public.who_global_data VALUES (37610, 600, 16474, 14, 294, 159, 76);
INSERT INTO public.who_global_data VALUES (37611, 9474, 639435, 136, 28607, 159, 138);
INSERT INTO public.who_global_data VALUES (37612, 4265, 217396, 101, 3520, 159, 98);
INSERT INTO public.who_global_data VALUES (37613, 0, 0, 0, 0, 159, 103);
INSERT INTO public.who_global_data VALUES (37614, 631, 66870, 1, 2033, 159, 225);
INSERT INTO public.who_global_data VALUES (37615, 320, 57768, 1, 1819, 159, 131);
INSERT INTO public.who_global_data VALUES (37616, 298, 32848, 6, 434, 159, 235);
INSERT INTO public.who_global_data VALUES (37617, 168, 118575, 1, 197, 159, 137);
INSERT INTO public.who_global_data VALUES (37618, 248, 19947, 1, 324, 159, 81);
INSERT INTO public.who_global_data VALUES (37619, 296, 36700, 2, 992, 159, 182);
INSERT INTO public.who_global_data VALUES (37620, 77, 1634, 1, 4, 159, 145);
INSERT INTO public.who_global_data VALUES (37621, 952, 86785, 39, 3578, 159, 26);
INSERT INTO public.who_global_data VALUES (37622, 4993, 995319, 83, 17176, 159, 170);
INSERT INTO public.who_global_data VALUES (37623, 177, 4020, 0, 16, 159, 191);
INSERT INTO public.who_global_data VALUES (37624, 0, 5, 0, 0, 159, 221);
INSERT INTO public.who_global_data VALUES (37625, 0, 18, 0, 0, 159, 64);
INSERT INTO public.who_global_data VALUES (37626, 0, 0, 0, 0, 159, 116);
INSERT INTO public.who_global_data VALUES (37627, 0, 17, 0, 0, 159, 128);
INSERT INTO public.who_global_data VALUES (37628, 0, 26, 0, 0, 159, 6);
INSERT INTO public.who_global_data VALUES (37629, 0, 213, 0, 5, 159, 227);
INSERT INTO public.who_global_data VALUES (37630, 0, 5, 0, 0, 159, 68);
INSERT INTO public.who_global_data VALUES (37631, 0, 60, 0, 0, 159, 184);
INSERT INTO public.who_global_data VALUES (37632, 0, 0, 0, 0, 159, 82);
INSERT INTO public.who_global_data VALUES (37633, 2, 735, 0, 42, 159, 149);
INSERT INTO public.who_global_data VALUES (37634, 1, 896, 0, 15, 159, 197);
INSERT INTO public.who_global_data VALUES (37635, 910, 314821, 30, 3870, 159, 78);
INSERT INTO public.who_global_data VALUES (37636, 100, 13556, 2, 284, 159, 233);
INSERT INTO public.who_global_data VALUES (37637, 83, 31365, 1, 711, 159, 133);
INSERT INTO public.who_global_data VALUES (37638, 0, 131, 0, 0, 159, 35);
INSERT INTO public.who_global_data VALUES (37639, 3, 2022, 0, 70, 159, 114);
INSERT INTO public.who_global_data VALUES (37640, 54, 56771, 0, 27, 159, 237);
INSERT INTO public.who_global_data VALUES (37641, 0, 4, 0, 0, 159, 55);
INSERT INTO public.who_global_data VALUES (37642, 0, 444, 0, 17, 159, 176);
INSERT INTO public.who_global_data VALUES (37643, 34, 3876, 0, 33, 159, 202);
INSERT INTO public.who_global_data VALUES (37644, 18, 2884, 0, 133, 159, 155);
INSERT INTO public.who_global_data VALUES (37645, 0, 0, 0, 0, 159, 32);
INSERT INTO public.who_global_data VALUES (37646, 0, 3310, 0, 97, 159, 220);
INSERT INTO public.who_global_data VALUES (37647, 2505, 625056, 47, 14028, 159, 30);
INSERT INTO public.who_global_data VALUES (37648, 8, 2527, 0, 47, 159, 147);
INSERT INTO public.who_global_data VALUES (37649, 6911, 492081, 49, 30840, 159, 208);
INSERT INTO public.who_global_data VALUES (37650, 17, 3012, 0, 12, 159, 45);
INSERT INTO public.who_global_data VALUES (37651, 0, 13189, 0, 823, 159, 110);
INSERT INTO public.who_global_data VALUES (37652, 106, 3954, 1, 67, 159, 88);
INSERT INTO public.who_global_data VALUES (37653, 131, 84187, 1, 5825, 159, 51);
INSERT INTO public.who_global_data VALUES (37654, 144, 42245, 1, 1759, 159, 209);
INSERT INTO public.who_global_data VALUES (37655, 75, 2703, 3, 109, 159, 205);
INSERT INTO public.who_global_data VALUES (37656, 34, 8550, 0, 68, 159, 18);
INSERT INTO public.who_global_data VALUES (37657, 1, 3412, 0, 58, 159, 72);
INSERT INTO public.who_global_data VALUES (37658, 1715, 334471, 1, 41499, 159, 44);
INSERT INTO public.who_global_data VALUES (37659, 0, 27, 0, 0, 159, 15);
INSERT INTO public.who_global_data VALUES (37660, 6, 1396, 0, 27, 159, 25);
INSERT INTO public.who_global_data VALUES (37661, 0, 0, 0, 0, 159, 179);
INSERT INTO public.who_global_data VALUES (37662, 0, 0, 0, 0, 159, 34);
INSERT INTO public.who_global_data VALUES (37663, 106, 1683, 2, 21, 159, 207);
INSERT INTO public.who_global_data VALUES (37664, 118, 3803, 1, 77, 159, 166);
INSERT INTO public.who_global_data VALUES (37665, 8212, 497366, 42, 6326, 159, 126);
INSERT INTO public.who_global_data VALUES (37666, 0, 0, 0, 0, 159, 97);
INSERT INTO public.who_global_data VALUES (37667, 15, 505, 0, 3, 159, 36);
INSERT INTO public.who_global_data VALUES (37668, 0, 0, 0, 0, 159, 125);
INSERT INTO public.who_global_data VALUES (37669, 132, 2888, 2, 30, 159, 124);
INSERT INTO public.who_global_data VALUES (37670, 2141, 121215, 30, 2557, 159, 185);
INSERT INTO public.who_global_data VALUES (37671, 362, 69690, 3, 382, 159, 194);
INSERT INTO public.who_global_data VALUES (37672, 0, 509, 0, 21, 159, 144);
INSERT INTO public.who_global_data VALUES (37673, 43983, 5899504, 1000, 181689, 159, 19);
INSERT INTO public.who_global_data VALUES (37674, 11, 1129, 0, 14, 159, 217);
INSERT INTO public.who_global_data VALUES (37675, 14, 1570, 1, 44, 159, 148);
INSERT INTO public.who_global_data VALUES (37676, 348, 41651, 6, 317, 159, 86);
INSERT INTO public.who_global_data VALUES (37677, 0, 0, 0, 0, 159, 13);
INSERT INTO public.who_global_data VALUES (37678, 1067, 44946, 17, 375, 159, 157);
INSERT INTO public.who_global_data VALUES (37679, 0, 1040, 0, 32, 159, 8);
INSERT INTO public.who_global_data VALUES (37680, 0, 0, 0, 0, 159, 73);
INSERT INTO public.who_global_data VALUES (37681, 7, 1957, 1, 565, 159, 101);
INSERT INTO public.who_global_data VALUES (37682, 123, 12025, 3, 287, 159, 165);
INSERT INTO public.who_global_data VALUES (37683, 6, 6412, 0, 196, 159, 14);
INSERT INTO public.who_global_data VALUES (37684, 0, 38229, 0, 1406, 160, 193);
INSERT INTO public.who_global_data VALUES (37685, 84, 9279, 4, 275, 160, 113);
INSERT INTO public.who_global_data VALUES (37686, 379, 43782, 8, 1491, 160, 143);
INSERT INTO public.who_global_data VALUES (37687, 0, 0, 0, 0, 160, 219);
INSERT INTO public.who_global_data VALUES (37688, 0, 1124, 0, 53, 160, 186);
INSERT INTO public.who_global_data VALUES (37689, 80, 2551, 1, 107, 160, 52);
INSERT INTO public.who_global_data VALUES (37690, 0, 3, 0, 0, 160, 180);
INSERT INTO public.who_global_data VALUES (37691, 0, 94, 0, 3, 160, 167);
INSERT INTO public.who_global_data VALUES (37692, 11717, 392009, 176, 8305, 160, 154);
INSERT INTO public.who_global_data VALUES (37693, 124, 43063, 5, 872, 160, 94);
INSERT INTO public.who_global_data VALUES (37694, 0, 1848, 0, 8, 160, 66);
INSERT INTO public.who_global_data VALUES (37695, 99, 25547, 17, 600, 160, 58);
INSERT INTO public.who_global_data VALUES (37696, 174, 26937, 0, 733, 160, 163);
INSERT INTO public.who_global_data VALUES (37697, 188, 36174, 2, 529, 160, 37);
INSERT INTO public.who_global_data VALUES (37698, 37, 2057, -10, 40, 160, 142);
INSERT INTO public.who_global_data VALUES (37699, 278, 51391, 0, 189, 160, 83);
INSERT INTO public.who_global_data VALUES (37700, 2131, 308925, 32, 4206, 160, 228);
INSERT INTO public.who_global_data VALUES (37701, 1, 166, 0, 7, 160, 188);
INSERT INTO public.who_global_data VALUES (37702, 177, 71523, 4, 671, 160, 62);
INSERT INTO public.who_global_data VALUES (37703, 195, 85379, 6, 9883, 160, 160);
INSERT INTO public.who_global_data VALUES (37704, 52, 870, 0, 12, 160, 50);
INSERT INTO public.who_global_data VALUES (37705, 0, 2145, 0, 40, 160, 33);
INSERT INTO public.who_global_data VALUES (37706, 0, 168, 0, 9, 160, 183);
INSERT INTO public.who_global_data VALUES (37707, 0, 195, 0, 0, 160, 92);
INSERT INTO public.who_global_data VALUES (37708, 1280, 114409, 55, 4846, 160, 158);
INSERT INTO public.who_global_data VALUES (37709, 0, 6, 0, 0, 160, 67);
INSERT INTO public.who_global_data VALUES (37710, 334, 19546, 3, 588, 160, 57);
INSERT INTO public.who_global_data VALUES (37711, 0, 1633, 0, 6, 160, 38);
INSERT INTO public.who_global_data VALUES (37712, 43412, 3804803, 855, 119504, 160, 141);
INSERT INTO public.who_global_data VALUES (37713, 0, 35, 0, 1, 160, 178);
INSERT INTO public.who_global_data VALUES (37714, 0, 144, 0, 3, 160, 108);
INSERT INTO public.who_global_data VALUES (37715, 99, 16164, 2, 605, 160, 39);
INSERT INTO public.who_global_data VALUES (37716, 0, 1357, 0, 55, 160, 2);
INSERT INTO public.who_global_data VALUES (37717, 6, 445, 0, 1, 160, 195);
INSERT INTO public.who_global_data VALUES (37718, 33, 3778, 1, 39, 160, 107);
INSERT INTO public.who_global_data VALUES (37719, 0, 273, 0, 0, 160, 161);
INSERT INTO public.who_global_data VALUES (37720, 0, 19142, 0, 411, 160, 212);
INSERT INTO public.who_global_data VALUES (37721, 510, 127358, 6, 9108, 160, 181);
INSERT INTO public.who_global_data VALUES (37722, 0, 205, 0, 1, 160, 53);
INSERT INTO public.who_global_data VALUES (37723, 0, 4700, 0, 61, 160, 164);
INSERT INTO public.who_global_data VALUES (37724, 0, 1008, 0, 77, 160, 140);
INSERT INTO public.who_global_data VALUES (37725, 2037, 408009, 49, 11181, 160, 20);
INSERT INTO public.who_global_data VALUES (37726, 28, 90351, 3, 4728, 160, 112);
INSERT INTO public.who_global_data VALUES (37727, 8498, 590520, 299, 18767, 160, 111);
INSERT INTO public.who_global_data VALUES (37728, 1, 423, 0, 7, 160, 71);
INSERT INTO public.who_global_data VALUES (37729, 0, 3979, 0, 78, 160, 218);
INSERT INTO public.who_global_data VALUES (37730, 0, 0, 0, 0, 160, 43);
INSERT INTO public.who_global_data VALUES (37731, 1193, 38485, 10, 407, 160, 49);
INSERT INTO public.who_global_data VALUES (37732, 191, 17893, 0, 115, 160, 1);
INSERT INTO public.who_global_data VALUES (37733, 312, 9861, 3, 183, 160, 48);
INSERT INTO public.who_global_data VALUES (37734, 59, 3925, 2, 94, 160, 232);
INSERT INTO public.who_global_data VALUES (37735, 0, 55, 0, 1, 160, 175);
INSERT INTO public.who_global_data VALUES (37736, 2, 1483, 0, 21, 160, 21);
INSERT INTO public.who_global_data VALUES (37737, 317, 24094, 2, 421, 160, 156);
INSERT INTO public.who_global_data VALUES (37738, 0, 0, 0, 0, 160, 95);
INSERT INTO public.who_global_data VALUES (37739, 0, 9993, 0, 255, 160, 177);
INSERT INTO public.who_global_data VALUES (37740, 0, 16700, 0, 624, 160, 210);
INSERT INTO public.who_global_data VALUES (37741, 2, 5385, 0, 60, 160, 120);
INSERT INTO public.who_global_data VALUES (37742, 0, 20, 0, 0, 160, 135);
INSERT INTO public.who_global_data VALUES (37743, 336, 93726, 25, 1673, 160, 206);
INSERT INTO public.who_global_data VALUES (37744, 765, 112906, 33, 6537, 160, 189);
INSERT INTO public.who_global_data VALUES (37745, 212, 98497, 14, 5376, 160, 129);
INSERT INTO public.who_global_data VALUES (37746, 122, 25537, 6, 708, 160, 121);
INSERT INTO public.who_global_data VALUES (37747, 0, 4941, 0, 83, 160, 59);
INSERT INTO public.who_global_data VALUES (37748, 3, 318, 0, 0, 160, 96);
INSERT INTO public.who_global_data VALUES (37749, 20, 2363, 0, 64, 160, 41);
INSERT INTO public.who_global_data VALUES (37750, 49, 4510, -2, 91, 160, 216);
INSERT INTO public.who_global_data VALUES (37751, 1514, 49654, 12, 770, 160, 236);
INSERT INTO public.who_global_data VALUES (37752, 0, 13, 0, 0, 160, 150);
INSERT INTO public.who_global_data VALUES (37753, 0, 411, 0, 0, 160, 61);
INSERT INTO public.who_global_data VALUES (37754, 0, 28, 0, 2, 160, 7);
INSERT INTO public.who_global_data VALUES (37755, 7, 8049, 0, 335, 160, 169);
INSERT INTO public.who_global_data VALUES (37756, 5313, 256829, 5, 30465, 160, 28);
INSERT INTO public.who_global_data VALUES (37757, 54, 9076, 0, 58, 160, 85);
INSERT INTO public.who_global_data VALUES (37758, 0, 482, 0, 0, 160, 211);
INSERT INTO public.who_global_data VALUES (37759, 37, 8505, 0, 53, 160, 60);
INSERT INTO public.who_global_data VALUES (37760, 0, 2797, 0, 96, 160, 3);
INSERT INTO public.who_global_data VALUES (37761, 7, 1469, 0, 19, 160, 11);
INSERT INTO public.who_global_data VALUES (37762, 785, 241771, 6, 9295, 160, 89);
INSERT INTO public.who_global_data VALUES (37763, 108, 43949, 0, 270, 160, 24);
INSERT INTO public.who_global_data VALUES (37764, 2, 274, 0, 0, 160, 162);
INSERT INTO public.who_global_data VALUES (37765, 177, 9977, 1, 260, 160, 100);
INSERT INTO public.who_global_data VALUES (37766, 0, 14, 0, 0, 160, 47);
INSERT INTO public.who_global_data VALUES (37767, 0, 24, 0, 0, 160, 29);
INSERT INTO public.who_global_data VALUES (37768, 0, 935, 0, 15, 160, 40);
INSERT INTO public.who_global_data VALUES (37769, 60, 1339, 0, 10, 160, 222);
INSERT INTO public.who_global_data VALUES (37770, 758, 73679, 19, 2728, 160, 132);
INSERT INTO public.who_global_data VALUES (37771, 0, 252, 0, 13, 160, 130);
INSERT INTO public.who_global_data VALUES (37772, 0, 9251, 0, 59, 160, 234);
INSERT INTO public.who_global_data VALUES (37773, 0, 2149, 0, 33, 160, 23);
INSERT INTO public.who_global_data VALUES (37774, 40, 1180, 3, 35, 160, 192);
INSERT INTO public.who_global_data VALUES (37775, 13, 8174, 0, 201, 160, 69);
INSERT INTO public.who_global_data VALUES (37776, 0, 12, 0, 0, 160, 187);
INSERT INTO public.who_global_data VALUES (37777, 1141, 58810, 24, 1827, 160, 230);
INSERT INTO public.who_global_data VALUES (37778, 158, 5669, 0, 614, 160, 77);
INSERT INTO public.who_global_data VALUES (37779, 8, 2100, 0, 10, 160, 9);
INSERT INTO public.who_global_data VALUES (37780, 78761, 3542733, 948, 63498, 160, 74);
INSERT INTO public.who_global_data VALUES (37781, 3308, 169195, 92, 7261, 160, 224);
INSERT INTO public.who_global_data VALUES (37782, 1905, 371816, 110, 21359, 160, 199);
INSERT INTO public.who_global_data VALUES (37783, 3834, 227446, 77, 6891, 160, 190);
INSERT INTO public.who_global_data VALUES (37784, 141, 28720, 0, 1777, 160, 12);
INSERT INTO public.who_global_data VALUES (37785, 0, 336, 0, 24, 160, 104);
INSERT INTO public.who_global_data VALUES (37786, 1832, 112727, 12, 911, 160, 153);
INSERT INTO public.who_global_data VALUES (37787, 1444, 266853, 1, 35473, 160, 91);
INSERT INTO public.who_global_data VALUES (37788, 141, 2011, 0, 19, 160, 215);
INSERT INTO public.who_global_data VALUES (37789, 841, 67264, 9, 1264, 160, 84);
INSERT INTO public.who_global_data VALUES (37790, 1, 374, 0, 32, 160, 231);
INSERT INTO public.who_global_data VALUES (37791, 24, 1961, 0, 15, 160, 196);
INSERT INTO public.who_global_data VALUES (37792, 167, 131509, 97, 1878, 160, 105);
INSERT INTO public.who_global_data VALUES (37793, 164, 33794, 5, 572, 160, 122);
INSERT INTO public.who_global_data VALUES (37794, 0, 0, 0, 0, 160, 159);
INSERT INTO public.who_global_data VALUES (37795, 115, 13172, 9, 498, 160, 75);
INSERT INTO public.who_global_data VALUES (37796, 646, 84224, 3, 528, 160, 27);
INSERT INTO public.who_global_data VALUES (37797, 108, 43820, 1, 1059, 160, 54);
INSERT INTO public.who_global_data VALUES (37798, 0, 22, 0, 0, 160, 226);
INSERT INTO public.who_global_data VALUES (37799, 0, 1375, 0, 34, 160, 79);
INSERT INTO public.who_global_data VALUES (37800, 662, 16275, 7, 155, 160, 56);
INSERT INTO public.who_global_data VALUES (37801, 15, 1066, 1, 31, 160, 117);
INSERT INTO public.who_global_data VALUES (37802, 13, 1303, 0, 82, 160, 152);
INSERT INTO public.who_global_data VALUES (37803, 465, 13423, 1, 232, 160, 16);
INSERT INTO public.who_global_data VALUES (37804, 1, 108, 0, 1, 160, 10);
INSERT INTO public.who_global_data VALUES (37805, 35, 2868, 0, 86, 160, 201);
INSERT INTO public.who_global_data VALUES (37806, 0, 6580, 0, 124, 160, 174);
INSERT INTO public.who_global_data VALUES (37807, 95, 14791, 3, 190, 160, 119);
INSERT INTO public.who_global_data VALUES (37808, 5, 5528, 0, 174, 160, 168);
INSERT INTO public.who_global_data VALUES (37809, 11, 9317, 0, 125, 160, 99);
INSERT INTO public.who_global_data VALUES (37810, 109, 7578, 0, 28, 160, 171);
INSERT INTO public.who_global_data VALUES (37811, 21, 2757, 0, 126, 160, 87);
INSERT INTO public.who_global_data VALUES (37812, 15, 1864, 1, 11, 160, 123);
INSERT INTO public.who_global_data VALUES (37813, 0, 0, 0, 0, 160, 151);
INSERT INTO public.who_global_data VALUES (37814, 0, 596, 0, 16, 160, 213);
INSERT INTO public.who_global_data VALUES (37815, 0, 7012, 0, 158, 160, 118);
INSERT INTO public.who_global_data VALUES (37816, 0, 346, 0, 10, 160, 134);
INSERT INTO public.who_global_data VALUES (37817, 0, 3301, 0, 40, 160, 65);
INSERT INTO public.who_global_data VALUES (37818, 5824, 585738, 552, 63146, 160, 102);
INSERT INTO public.who_global_data VALUES (37819, 0, 0, 0, 0, 160, 223);
INSERT INTO public.who_global_data VALUES (37820, 5, 133, 0, 1, 160, 4);
INSERT INTO public.who_global_data VALUES (37821, 0, 301, 0, 0, 160, 146);
INSERT INTO public.who_global_data VALUES (37822, 40, 4817, 3, 99, 160, 31);
INSERT INTO public.who_global_data VALUES (37823, 0, 13, 0, 1, 160, 127);
INSERT INTO public.who_global_data VALUES (37824, 1567, 60056, 26, 1078, 160, 22);
INSERT INTO public.who_global_data VALUES (37825, 63, 3760, 1, 22, 160, 115);
INSERT INTO public.who_global_data VALUES (37826, 93, 749, 0, 6, 160, 106);
INSERT INTO public.who_global_data VALUES (37827, 210, 7116, 4, 69, 160, 90);
INSERT INTO public.who_global_data VALUES (37828, 0, 0, 0, 0, 160, 70);
INSERT INTO public.who_global_data VALUES (37829, 884, 37340, 12, 207, 160, 46);
INSERT INTO public.who_global_data VALUES (37830, 503, 69554, 4, 6220, 160, 139);
INSERT INTO public.who_global_data VALUES (37831, 0, 23, 0, 0, 160, 42);
INSERT INTO public.who_global_data VALUES (37832, 2, 1378, 0, 22, 160, 80);
INSERT INTO public.who_global_data VALUES (37833, 0, 3659, 0, 137, 160, 203);
INSERT INTO public.who_global_data VALUES (37834, 2, 1175, 0, 69, 160, 136);
INSERT INTO public.who_global_data VALUES (37835, 250, 53727, 0, 1011, 160, 63);
INSERT INTO public.who_global_data VALUES (37836, 0, 0, 0, 0, 160, 17);
INSERT INTO public.who_global_data VALUES (37837, 2, 56, 0, 2, 160, 172);
INSERT INTO public.who_global_data VALUES (37838, 130, 14293, 6, 596, 160, 109);
INSERT INTO public.who_global_data VALUES (37839, 0, 10543, 0, 264, 160, 200);
INSERT INTO public.who_global_data VALUES (37840, 417, 28527, 2, 164, 160, 93);
INSERT INTO public.who_global_data VALUES (37841, 0, 85005, 0, 650, 160, 5);
INSERT INTO public.who_global_data VALUES (37842, 0, 741, 0, 13, 160, 214);
INSERT INTO public.who_global_data VALUES (37843, 264, 295636, 4, 6288, 160, 204);
INSERT INTO public.who_global_data VALUES (37844, 0, 0, 0, 0, 160, 198);
INSERT INTO public.who_global_data VALUES (37845, 642, 90624, 18, 1966, 160, 173);
INSERT INTO public.who_global_data VALUES (37846, 6, 459, 0, 5, 160, 229);
INSERT INTO public.who_global_data VALUES (37847, 584, 15874, 15, 280, 160, 76);
INSERT INTO public.who_global_data VALUES (37848, 7964, 629961, 194, 28471, 160, 138);
INSERT INTO public.who_global_data VALUES (37849, 3587, 213131, 94, 3419, 160, 98);
INSERT INTO public.who_global_data VALUES (37850, 0, 0, 0, 0, 160, 103);
INSERT INTO public.who_global_data VALUES (37851, 759, 66239, 14, 2032, 160, 225);
INSERT INTO public.who_global_data VALUES (37852, 374, 57448, 3, 1818, 160, 131);
INSERT INTO public.who_global_data VALUES (37853, 562, 32550, 4, 428, 160, 235);
INSERT INTO public.who_global_data VALUES (37854, 211, 118407, 0, 196, 160, 137);
INSERT INTO public.who_global_data VALUES (37855, 299, 19699, 2, 323, 160, 81);
INSERT INTO public.who_global_data VALUES (37856, 500, 36404, 9, 990, 160, 182);
INSERT INTO public.who_global_data VALUES (37857, 70, 1557, 1, 3, 160, 145);
INSERT INTO public.who_global_data VALUES (37858, 1365, 85833, 32, 3539, 160, 26);
INSERT INTO public.who_global_data VALUES (37859, 4980, 990326, 68, 17093, 160, 170);
INSERT INTO public.who_global_data VALUES (37860, 101, 3843, 0, 16, 160, 191);
INSERT INTO public.who_global_data VALUES (37861, 0, 5, 0, 0, 160, 221);
INSERT INTO public.who_global_data VALUES (37862, 1, 18, 0, 0, 160, 64);
INSERT INTO public.who_global_data VALUES (37863, 0, 0, 0, 0, 160, 116);
INSERT INTO public.who_global_data VALUES (37864, 0, 17, 0, 0, 160, 128);
INSERT INTO public.who_global_data VALUES (37865, 0, 26, 0, 0, 160, 6);
INSERT INTO public.who_global_data VALUES (37866, 15, 213, 0, 5, 160, 227);
INSERT INTO public.who_global_data VALUES (37867, 0, 5, 0, 0, 160, 68);
INSERT INTO public.who_global_data VALUES (37868, 0, 60, 0, 0, 160, 184);
INSERT INTO public.who_global_data VALUES (37869, 0, 0, 0, 0, 160, 82);
INSERT INTO public.who_global_data VALUES (37870, 0, 733, 0, 42, 160, 149);
INSERT INTO public.who_global_data VALUES (37871, 0, 895, 0, 15, 160, 197);
INSERT INTO public.who_global_data VALUES (37872, 987, 313911, 27, 3840, 160, 78);
INSERT INTO public.who_global_data VALUES (37873, 72, 13456, 3, 282, 160, 233);
INSERT INTO public.who_global_data VALUES (37874, 75, 31282, 1, 710, 160, 133);
INSERT INTO public.who_global_data VALUES (37875, 0, 131, 0, 0, 160, 35);
INSERT INTO public.who_global_data VALUES (37876, 4, 2019, 0, 70, 160, 114);
INSERT INTO public.who_global_data VALUES (37877, 51, 56717, 0, 27, 160, 237);
INSERT INTO public.who_global_data VALUES (37878, 0, 4, 0, 0, 160, 55);
INSERT INTO public.who_global_data VALUES (37879, 0, 444, 0, 17, 160, 176);
INSERT INTO public.who_global_data VALUES (37880, 114, 3842, 0, 33, 160, 202);
INSERT INTO public.who_global_data VALUES (37881, 31, 2866, 0, 133, 160, 155);
INSERT INTO public.who_global_data VALUES (37882, 0, 0, 0, 0, 160, 32);
INSERT INTO public.who_global_data VALUES (37883, 35, 3310, 2, 97, 160, 220);
INSERT INTO public.who_global_data VALUES (37884, 2419, 622551, 238, 13981, 160, 30);
INSERT INTO public.who_global_data VALUES (37885, 0, 2519, 0, 47, 160, 147);
INSERT INTO public.who_global_data VALUES (37886, 12140, 485170, 67, 30791, 160, 208);
INSERT INTO public.who_global_data VALUES (37887, 7, 2995, 0, 12, 160, 45);
INSERT INTO public.who_global_data VALUES (37888, 0, 13189, 0, 823, 160, 110);
INSERT INTO public.who_global_data VALUES (37889, 55, 3848, 0, 66, 160, 88);
INSERT INTO public.who_global_data VALUES (37890, 179, 84056, 1, 5824, 160, 51);
INSERT INTO public.who_global_data VALUES (37891, 215, 42101, 0, 1758, 160, 209);
INSERT INTO public.who_global_data VALUES (37892, 65, 2628, 3, 106, 160, 205);
INSERT INTO public.who_global_data VALUES (37893, 35, 8516, 0, 68, 160, 18);
INSERT INTO public.who_global_data VALUES (37894, 0, 3411, 0, 58, 160, 72);
INSERT INTO public.who_global_data VALUES (37895, 1108, 332756, 12, 41498, 160, 44);
INSERT INTO public.who_global_data VALUES (37896, 0, 27, 0, 0, 160, 15);
INSERT INTO public.who_global_data VALUES (37897, 49, 1390, 0, 27, 160, 25);
INSERT INTO public.who_global_data VALUES (37898, 0, 0, 0, 0, 160, 179);
INSERT INTO public.who_global_data VALUES (37899, 0, 0, 0, 0, 160, 34);
INSERT INTO public.who_global_data VALUES (37900, 65, 1577, 2, 19, 160, 207);
INSERT INTO public.who_global_data VALUES (37901, 113, 3685, 0, 76, 160, 166);
INSERT INTO public.who_global_data VALUES (37902, 8279, 489154, 39, 6284, 160, 126);
INSERT INTO public.who_global_data VALUES (37903, 0, 0, 0, 0, 160, 97);
INSERT INTO public.who_global_data VALUES (37904, 8, 490, 0, 3, 160, 36);
INSERT INTO public.who_global_data VALUES (37905, 0, 0, 0, 0, 160, 125);
INSERT INTO public.who_global_data VALUES (37906, 0, 2756, 0, 28, 160, 124);
INSERT INTO public.who_global_data VALUES (37907, 2096, 119074, 35, 2527, 160, 185);
INSERT INTO public.who_global_data VALUES (37908, 427, 69328, 0, 379, 160, 194);
INSERT INTO public.who_global_data VALUES (37909, 0, 509, 0, 21, 160, 144);
INSERT INTO public.who_global_data VALUES (37910, 44002, 5855521, 973, 180689, 160, 19);
INSERT INTO public.who_global_data VALUES (37911, 43, 1118, 0, 14, 160, 217);
INSERT INTO public.who_global_data VALUES (37912, 5, 1556, 0, 43, 160, 148);
INSERT INTO public.who_global_data VALUES (37913, 350, 41303, 6, 311, 160, 86);
INSERT INTO public.who_global_data VALUES (37914, 0, 0, 0, 0, 160, 13);
INSERT INTO public.who_global_data VALUES (37915, 981, 43879, 0, 358, 160, 157);
INSERT INTO public.who_global_data VALUES (37916, 2, 1040, 2, 32, 160, 8);
INSERT INTO public.who_global_data VALUES (37917, 0, 0, 0, 0, 160, 73);
INSERT INTO public.who_global_data VALUES (37918, 3, 1950, 0, 564, 160, 101);
INSERT INTO public.who_global_data VALUES (37919, 123, 11902, 1, 284, 160, 165);
INSERT INTO public.who_global_data VALUES (37920, 18, 6406, 1, 196, 160, 14);
INSERT INTO public.who_global_data VALUES (37921, 3, 38229, 0, 1406, 161, 193);
INSERT INTO public.who_global_data VALUES (37922, 112, 9195, 5, 271, 161, 113);
INSERT INTO public.who_global_data VALUES (37923, 387, 43403, 8, 1483, 161, 143);
INSERT INTO public.who_global_data VALUES (37924, 0, 0, 0, 0, 161, 219);
INSERT INTO public.who_global_data VALUES (37925, 13, 1124, 0, 53, 161, 186);
INSERT INTO public.who_global_data VALUES (37926, 56, 2471, 1, 106, 161, 52);
INSERT INTO public.who_global_data VALUES (37927, 0, 3, 0, 0, 161, 180);
INSERT INTO public.who_global_data VALUES (37928, 0, 94, 0, 3, 161, 167);
INSERT INTO public.who_global_data VALUES (37929, 10104, 380292, 185, 8129, 161, 154);
INSERT INTO public.who_global_data VALUES (37930, 175, 42939, 3, 867, 161, 94);
INSERT INTO public.who_global_data VALUES (37931, 88, 1848, 0, 8, 161, 66);
INSERT INTO public.who_global_data VALUES (37932, 126, 25448, 11, 583, 161, 58);
INSERT INTO public.who_global_data VALUES (37933, 382, 26763, 0, 733, 161, 163);
INSERT INTO public.who_global_data VALUES (37934, 142, 35986, 3, 527, 161, 37);
INSERT INTO public.who_global_data VALUES (37935, 97, 2020, 2, 50, 161, 142);
INSERT INTO public.who_global_data VALUES (37936, 357, 51113, 1, 189, 161, 83);
INSERT INTO public.who_global_data VALUES (37937, 2211, 306794, 47, 4174, 161, 228);
INSERT INTO public.who_global_data VALUES (37938, 0, 165, 0, 7, 161, 188);
INSERT INTO public.who_global_data VALUES (37939, 181, 71346, 5, 667, 161, 62);
INSERT INTO public.who_global_data VALUES (37940, 614, 85184, 4, 9877, 161, 160);
INSERT INTO public.who_global_data VALUES (37941, 58, 818, 1, 12, 161, 50);
INSERT INTO public.who_global_data VALUES (37942, 0, 2145, 0, 40, 161, 33);
INSERT INTO public.who_global_data VALUES (37943, 0, 168, 0, 9, 161, 183);
INSERT INTO public.who_global_data VALUES (37944, 11, 195, 0, 0, 161, 92);
INSERT INTO public.who_global_data VALUES (37945, 1035, 113129, 65, 4791, 161, 158);
INSERT INTO public.who_global_data VALUES (37946, 0, 6, 0, 0, 161, 67);
INSERT INTO public.who_global_data VALUES (37947, 294, 19212, 9, 585, 161, 57);
INSERT INTO public.who_global_data VALUES (37948, 0, 1633, 0, 6, 161, 38);
INSERT INTO public.who_global_data VALUES (37949, 44235, 3761391, 984, 118649, 161, 141);
INSERT INTO public.who_global_data VALUES (37950, 9, 35, 0, 1, 161, 178);
INSERT INTO public.who_global_data VALUES (37951, 0, 144, 0, 3, 161, 108);
INSERT INTO public.who_global_data VALUES (37952, 157, 16065, 9, 603, 161, 39);
INSERT INTO public.who_global_data VALUES (37953, 5, 1357, 0, 55, 161, 2);
INSERT INTO public.who_global_data VALUES (37954, 6, 439, 0, 1, 161, 195);
INSERT INTO public.who_global_data VALUES (37955, 46, 3745, 0, 38, 161, 107);
INSERT INTO public.who_global_data VALUES (37956, 0, 273, 0, 0, 161, 161);
INSERT INTO public.who_global_data VALUES (37957, 169, 19142, 1, 411, 161, 212);
INSERT INTO public.who_global_data VALUES (37958, 431, 126848, 8, 9102, 161, 181);
INSERT INTO public.who_global_data VALUES (37959, 0, 205, 0, 1, 161, 53);
INSERT INTO public.who_global_data VALUES (37960, 2, 4700, 0, 61, 161, 164);
INSERT INTO public.who_global_data VALUES (37961, 4, 1008, 0, 77, 161, 140);
INSERT INTO public.who_global_data VALUES (37962, 1870, 405972, 60, 11132, 161, 20);
INSERT INTO public.who_global_data VALUES (37963, 22, 90323, 3, 4725, 161, 112);
INSERT INTO public.who_global_data VALUES (37964, 9752, 582022, 284, 18468, 161, 111);
INSERT INTO public.who_global_data VALUES (37965, 5, 422, 0, 7, 161, 71);
INSERT INTO public.who_global_data VALUES (37966, 0, 3979, 0, 78, 161, 218);
INSERT INTO public.who_global_data VALUES (37967, 0, 0, 0, 0, 161, 43);
INSERT INTO public.who_global_data VALUES (37968, 985, 37292, 11, 397, 161, 49);
INSERT INTO public.who_global_data VALUES (37969, 0, 17702, 0, 115, 161, 1);
INSERT INTO public.who_global_data VALUES (37970, 357, 9549, 3, 180, 161, 48);
INSERT INTO public.who_global_data VALUES (37971, 60, 3866, 0, 92, 161, 232);
INSERT INTO public.who_global_data VALUES (37972, 2, 55, 0, 1, 161, 175);
INSERT INTO public.who_global_data VALUES (37973, 0, 1481, 0, 21, 161, 21);
INSERT INTO public.who_global_data VALUES (37974, 477, 23777, 1, 419, 161, 156);
INSERT INTO public.who_global_data VALUES (37975, 0, 0, 0, 0, 161, 95);
INSERT INTO public.who_global_data VALUES (37976, 79, 9993, 0, 255, 161, 177);
INSERT INTO public.who_global_data VALUES (37977, 73, 16700, 0, 624, 161, 210);
INSERT INTO public.who_global_data VALUES (37978, 0, 5383, 0, 60, 161, 120);
INSERT INTO public.who_global_data VALUES (37979, 0, 20, 0, 0, 161, 135);
INSERT INTO public.who_global_data VALUES (37980, 426, 93390, 18, 1648, 161, 206);
INSERT INTO public.who_global_data VALUES (37981, 922, 112141, 33, 6504, 161, 189);
INSERT INTO public.who_global_data VALUES (37982, 223, 98285, 20, 5362, 161, 129);
INSERT INTO public.who_global_data VALUES (37983, 131, 25415, 8, 702, 161, 121);
INSERT INTO public.who_global_data VALUES (37984, 13, 4941, 0, 83, 161, 59);
INSERT INTO public.who_global_data VALUES (37985, 0, 315, 0, 0, 161, 96);
INSERT INTO public.who_global_data VALUES (37986, 18, 2343, 0, 64, 161, 41);
INSERT INTO public.who_global_data VALUES (37987, 28, 4461, 4, 93, 161, 216);
INSERT INTO public.who_global_data VALUES (37988, 1733, 48140, 13, 758, 161, 236);
INSERT INTO public.who_global_data VALUES (37989, 0, 13, 0, 0, 161, 150);
INSERT INTO public.who_global_data VALUES (37990, 0, 411, 0, 0, 161, 61);
INSERT INTO public.who_global_data VALUES (37991, 0, 28, 0, 2, 161, 7);
INSERT INTO public.who_global_data VALUES (37992, 23, 8042, 0, 335, 161, 169);
INSERT INTO public.who_global_data VALUES (37993, 7262, 251516, 20, 30460, 161, 28);
INSERT INTO public.who_global_data VALUES (37994, 40, 9022, 0, 58, 161, 85);
INSERT INTO public.who_global_data VALUES (37995, 35, 482, 0, 0, 161, 211);
INSERT INTO public.who_global_data VALUES (37996, 0, 8468, 0, 53, 161, 60);
INSERT INTO public.who_global_data VALUES (37997, 54, 2797, 3, 96, 161, 3);
INSERT INTO public.who_global_data VALUES (37998, 7, 1462, 0, 19, 161, 11);
INSERT INTO public.who_global_data VALUES (37999, 1479, 240986, 1, 9289, 161, 89);
INSERT INTO public.who_global_data VALUES (38000, 0, 43841, 0, 270, 161, 24);
INSERT INTO public.who_global_data VALUES (38001, 2, 272, 0, 0, 161, 162);
INSERT INTO public.who_global_data VALUES (38002, 269, 9800, 5, 259, 161, 100);
INSERT INTO public.who_global_data VALUES (38003, 0, 14, 0, 0, 161, 47);
INSERT INTO public.who_global_data VALUES (38004, 0, 24, 0, 0, 161, 29);
INSERT INTO public.who_global_data VALUES (38005, 0, 935, 0, 15, 161, 40);
INSERT INTO public.who_global_data VALUES (38006, 55, 1279, 0, 10, 161, 222);
INSERT INTO public.who_global_data VALUES (38007, 1065, 72921, 24, 2709, 161, 132);
INSERT INTO public.who_global_data VALUES (38008, 0, 252, 0, 13, 161, 130);
INSERT INTO public.who_global_data VALUES (38009, 38, 9251, 1, 59, 161, 234);
INSERT INTO public.who_global_data VALUES (38010, 0, 2149, 0, 33, 161, 23);
INSERT INTO public.who_global_data VALUES (38011, 47, 1140, 1, 32, 161, 192);
INSERT INTO public.who_global_data VALUES (38012, 10, 8161, 1, 201, 161, 69);
INSERT INTO public.who_global_data VALUES (38013, 0, 12, 0, 0, 161, 187);
INSERT INTO public.who_global_data VALUES (38014, 1020, 57669, 56, 1803, 161, 230);
INSERT INTO public.who_global_data VALUES (38015, 132, 5511, 0, 614, 161, 77);
INSERT INTO public.who_global_data VALUES (38016, 5, 2092, 0, 10, 161, 9);
INSERT INTO public.who_global_data VALUES (38017, 76472, 3463972, 1021, 62550, 161, 74);
INSERT INTO public.who_global_data VALUES (38018, 3003, 165887, 105, 7169, 161, 224);
INSERT INTO public.who_global_data VALUES (38019, 2115, 369911, 112, 21249, 161, 199);
INSERT INTO public.who_global_data VALUES (38020, 4177, 223612, 74, 6814, 161, 190);
INSERT INTO public.who_global_data VALUES (38021, 126, 28579, 0, 1777, 161, 12);
INSERT INTO public.who_global_data VALUES (38022, 0, 336, 0, 24, 161, 104);
INSERT INTO public.who_global_data VALUES (38023, 2071, 110895, 11, 899, 161, 153);
INSERT INTO public.who_global_data VALUES (38024, 1460, 265409, 9, 35472, 161, 91);
INSERT INTO public.who_global_data VALUES (38025, 66, 1870, 0, 19, 161, 215);
INSERT INTO public.who_global_data VALUES (38026, 850, 66423, 17, 1255, 161, 84);
INSERT INTO public.who_global_data VALUES (38027, 1, 373, 0, 32, 161, 231);
INSERT INTO public.who_global_data VALUES (38028, 68, 1937, 0, 15, 161, 196);
INSERT INTO public.who_global_data VALUES (38029, 669, 131342, 0, 1781, 161, 105);
INSERT INTO public.who_global_data VALUES (38030, 241, 33630, 0, 567, 161, 122);
INSERT INTO public.who_global_data VALUES (38031, 0, 0, 0, 0, 161, 159);
INSERT INTO public.who_global_data VALUES (38032, 119, 13057, 1, 489, 161, 75);
INSERT INTO public.who_global_data VALUES (38033, 633, 83578, 3, 525, 161, 27);
INSERT INTO public.who_global_data VALUES (38034, 125, 43712, 0, 1058, 161, 54);
INSERT INTO public.who_global_data VALUES (38035, 0, 22, 0, 0, 161, 226);
INSERT INTO public.who_global_data VALUES (38036, 9, 1375, 0, 34, 161, 79);
INSERT INTO public.who_global_data VALUES (38037, 676, 15613, 2, 148, 161, 56);
INSERT INTO public.who_global_data VALUES (38038, 0, 1051, 0, 30, 161, 117);
INSERT INTO public.who_global_data VALUES (38039, 0, 1290, 0, 82, 161, 152);
INSERT INTO public.who_global_data VALUES (38040, 329, 12958, 5, 231, 161, 16);
INSERT INTO public.who_global_data VALUES (38041, 0, 107, 0, 1, 161, 10);
INSERT INTO public.who_global_data VALUES (38042, 29, 2833, 0, 86, 161, 201);
INSERT INTO public.who_global_data VALUES (38043, 37, 6580, 0, 124, 161, 174);
INSERT INTO public.who_global_data VALUES (38044, 104, 14696, 3, 187, 161, 119);
INSERT INTO public.who_global_data VALUES (38045, 27, 5523, 1, 174, 161, 168);
INSERT INTO public.who_global_data VALUES (38046, 10, 9306, 0, 125, 161, 99);
INSERT INTO public.who_global_data VALUES (38047, 140, 7469, 0, 28, 161, 171);
INSERT INTO public.who_global_data VALUES (38048, 6, 2736, 0, 126, 161, 87);
INSERT INTO public.who_global_data VALUES (38049, 28, 1849, 0, 10, 161, 123);
INSERT INTO public.who_global_data VALUES (38050, 0, 0, 0, 0, 161, 151);
INSERT INTO public.who_global_data VALUES (38051, 0, 596, 0, 16, 161, 213);
INSERT INTO public.who_global_data VALUES (38052, 35, 7012, 0, 158, 161, 118);
INSERT INTO public.who_global_data VALUES (38053, 0, 346, 0, 10, 161, 134);
INSERT INTO public.who_global_data VALUES (38054, 0, 3301, 0, 40, 161, 65);
INSERT INTO public.who_global_data VALUES (38055, 6026, 579914, 518, 62594, 161, 102);
INSERT INTO public.who_global_data VALUES (38056, 0, 0, 0, 0, 161, 223);
INSERT INTO public.who_global_data VALUES (38057, 0, 128, 0, 1, 161, 4);
INSERT INTO public.who_global_data VALUES (38058, 0, 301, 0, 0, 161, 146);
INSERT INTO public.who_global_data VALUES (38059, 89, 4777, 4, 96, 161, 31);
INSERT INTO public.who_global_data VALUES (38060, 0, 13, 0, 1, 161, 127);
INSERT INTO public.who_global_data VALUES (38061, 1404, 58489, 41, 1052, 161, 22);
INSERT INTO public.who_global_data VALUES (38062, 46, 3697, 0, 21, 161, 115);
INSERT INTO public.who_global_data VALUES (38063, 28, 656, 0, 6, 161, 106);
INSERT INTO public.who_global_data VALUES (38064, 194, 6906, 5, 65, 161, 90);
INSERT INTO public.who_global_data VALUES (38065, 0, 0, 0, 0, 161, 70);
INSERT INTO public.who_global_data VALUES (38066, 927, 36456, 12, 195, 161, 46);
INSERT INTO public.who_global_data VALUES (38067, 501, 69051, 3, 6216, 161, 139);
INSERT INTO public.who_global_data VALUES (38068, 0, 23, 0, 0, 161, 42);
INSERT INTO public.who_global_data VALUES (38069, 13, 1376, 0, 22, 161, 80);
INSERT INTO public.who_global_data VALUES (38070, 0, 3659, 0, 137, 161, 203);
INSERT INTO public.who_global_data VALUES (38071, 0, 1173, 0, 69, 161, 136);
INSERT INTO public.who_global_data VALUES (38072, 160, 53477, 0, 1011, 161, 63);
INSERT INTO public.who_global_data VALUES (38073, 0, 0, 0, 0, 161, 17);
INSERT INTO public.who_global_data VALUES (38074, 0, 54, 0, 2, 161, 172);
INSERT INTO public.who_global_data VALUES (38075, 159, 14163, 5, 590, 161, 109);
INSERT INTO public.who_global_data VALUES (38076, 38, 10543, 0, 264, 161, 200);
INSERT INTO public.who_global_data VALUES (38077, 724, 28110, 4, 162, 161, 93);
INSERT INTO public.who_global_data VALUES (38078, 0, 85005, 0, 650, 161, 5);
INSERT INTO public.who_global_data VALUES (38079, 0, 741, 0, 13, 161, 214);
INSERT INTO public.who_global_data VALUES (38080, 319, 295372, 1, 6284, 161, 204);
INSERT INTO public.who_global_data VALUES (38081, 0, 0, 0, 0, 161, 198);
INSERT INTO public.who_global_data VALUES (38082, 900, 89982, 16, 1948, 161, 173);
INSERT INTO public.who_global_data VALUES (38083, 29, 453, 1, 5, 161, 229);
INSERT INTO public.who_global_data VALUES (38084, 418, 15290, 18, 265, 161, 76);
INSERT INTO public.who_global_data VALUES (38085, 8619, 621997, 153, 28277, 161, 138);
INSERT INTO public.who_global_data VALUES (38086, 3963, 209544, 91, 3325, 161, 98);
INSERT INTO public.who_global_data VALUES (38087, 0, 0, 0, 0, 161, 103);
INSERT INTO public.who_global_data VALUES (38088, 791, 65480, 8, 2018, 161, 225);
INSERT INTO public.who_global_data VALUES (38089, 401, 57074, 6, 1815, 161, 131);
INSERT INTO public.who_global_data VALUES (38090, 605, 31988, 12, 424, 161, 235);
INSERT INTO public.who_global_data VALUES (38091, 208, 118196, 1, 196, 161, 137);
INSERT INTO public.who_global_data VALUES (38092, 323, 19400, 5, 321, 161, 81);
INSERT INTO public.who_global_data VALUES (38093, 358, 35904, 4, 981, 161, 182);
INSERT INTO public.who_global_data VALUES (38094, 77, 1487, 0, 2, 161, 145);
INSERT INTO public.who_global_data VALUES (38095, 1318, 84468, 48, 3507, 161, 26);
INSERT INTO public.who_global_data VALUES (38096, 4941, 985346, 111, 17025, 161, 170);
INSERT INTO public.who_global_data VALUES (38097, 70, 3742, 1, 16, 161, 191);
INSERT INTO public.who_global_data VALUES (38098, 0, 5, 0, 0, 161, 221);
INSERT INTO public.who_global_data VALUES (38099, 0, 17, 0, 0, 161, 64);
INSERT INTO public.who_global_data VALUES (38100, 0, 0, 0, 0, 161, 116);
INSERT INTO public.who_global_data VALUES (38101, 0, 17, 0, 0, 161, 128);
INSERT INTO public.who_global_data VALUES (38102, 0, 26, 0, 0, 161, 6);
INSERT INTO public.who_global_data VALUES (38103, 0, 198, 0, 5, 161, 227);
INSERT INTO public.who_global_data VALUES (38104, 0, 5, 0, 0, 161, 68);
INSERT INTO public.who_global_data VALUES (38105, 0, 60, 0, 0, 161, 184);
INSERT INTO public.who_global_data VALUES (38106, 0, 0, 0, 0, 161, 82);
INSERT INTO public.who_global_data VALUES (38107, 1, 733, 0, 42, 161, 149);
INSERT INTO public.who_global_data VALUES (38108, 1, 895, 0, 15, 161, 197);
INSERT INTO public.who_global_data VALUES (38109, 1069, 312924, 28, 3813, 161, 78);
INSERT INTO public.who_global_data VALUES (38110, 90, 13384, 2, 279, 161, 233);
INSERT INTO public.who_global_data VALUES (38111, 108, 31207, 2, 709, 161, 133);
INSERT INTO public.who_global_data VALUES (38112, 0, 131, 0, 0, 161, 35);
INSERT INTO public.who_global_data VALUES (38113, 2, 2015, 0, 70, 161, 114);
INSERT INTO public.who_global_data VALUES (38114, 94, 56666, 0, 27, 161, 237);
INSERT INTO public.who_global_data VALUES (38115, 0, 4, 0, 0, 161, 55);
INSERT INTO public.who_global_data VALUES (38116, 2, 444, 0, 17, 161, 176);
INSERT INTO public.who_global_data VALUES (38117, 102, 3728, 0, 33, 161, 202);
INSERT INTO public.who_global_data VALUES (38118, 37, 2835, 0, 133, 161, 155);
INSERT INTO public.who_global_data VALUES (38119, 0, 0, 0, 0, 161, 32);
INSERT INTO public.who_global_data VALUES (38120, 6, 3275, 2, 95, 161, 220);
INSERT INTO public.who_global_data VALUES (38121, 4431, 620132, 241, 13743, 161, 30);
INSERT INTO public.who_global_data VALUES (38122, 1, 2519, 0, 47, 161, 147);
INSERT INTO public.who_global_data VALUES (38123, 10522, 473030, 45, 30724, 161, 208);
INSERT INTO public.who_global_data VALUES (38124, 2, 2988, 0, 12, 161, 45);
INSERT INTO public.who_global_data VALUES (38125, 0, 13189, 0, 823, 161, 110);
INSERT INTO public.who_global_data VALUES (38126, 69, 3793, 4, 66, 161, 88);
INSERT INTO public.who_global_data VALUES (38127, 202, 83877, 1, 5823, 161, 51);
INSERT INTO public.who_global_data VALUES (38128, 377, 41886, 0, 1758, 161, 209);
INSERT INTO public.who_global_data VALUES (38129, 59, 2563, 3, 103, 161, 205);
INSERT INTO public.who_global_data VALUES (38130, 32, 8481, 0, 68, 161, 18);
INSERT INTO public.who_global_data VALUES (38131, 1, 3411, 0, 58, 161, 72);
INSERT INTO public.who_global_data VALUES (38132, 1276, 331648, 9, 41486, 161, 44);
INSERT INTO public.who_global_data VALUES (38133, 0, 27, 0, 0, 161, 15);
INSERT INTO public.who_global_data VALUES (38134, 15, 1341, 0, 27, 161, 25);
INSERT INTO public.who_global_data VALUES (38135, 0, 0, 0, 0, 161, 179);
INSERT INTO public.who_global_data VALUES (38136, 0, 0, 0, 0, 161, 34);
INSERT INTO public.who_global_data VALUES (38137, 83, 1512, 2, 17, 161, 207);
INSERT INTO public.who_global_data VALUES (38138, 111, 3572, 2, 76, 161, 166);
INSERT INTO public.who_global_data VALUES (38139, 8247, 480875, 36, 6245, 161, 126);
INSERT INTO public.who_global_data VALUES (38140, 0, 0, 0, 0, 161, 97);
INSERT INTO public.who_global_data VALUES (38141, 18, 482, 0, 3, 161, 36);
INSERT INTO public.who_global_data VALUES (38142, 0, 0, 0, 0, 161, 125);
INSERT INTO public.who_global_data VALUES (38143, 232, 2756, 2, 28, 161, 124);
INSERT INTO public.who_global_data VALUES (38144, 2481, 116978, 41, 2492, 161, 185);
INSERT INTO public.who_global_data VALUES (38145, 390, 68901, 1, 379, 161, 194);
INSERT INTO public.who_global_data VALUES (38146, 0, 509, 0, 21, 161, 144);
INSERT INTO public.who_global_data VALUES (38147, 46194, 5811519, 1155, 179716, 161, 19);
INSERT INTO public.who_global_data VALUES (38148, 23, 1075, 0, 14, 161, 217);
INSERT INTO public.who_global_data VALUES (38149, 8, 1551, 0, 43, 161, 148);
INSERT INTO public.who_global_data VALUES (38150, 340, 40953, 5, 305, 161, 86);
INSERT INTO public.who_global_data VALUES (38151, 0, 0, 0, 0, 161, 13);
INSERT INTO public.who_global_data VALUES (38152, 933, 42898, 7, 358, 161, 157);
INSERT INTO public.who_global_data VALUES (38153, 2, 1038, 0, 30, 161, 8);
INSERT INTO public.who_global_data VALUES (38154, 0, 0, 0, 0, 161, 73);
INSERT INTO public.who_global_data VALUES (38155, 10, 1947, 1, 564, 161, 101);
INSERT INTO public.who_global_data VALUES (38156, 178, 11779, 1, 283, 161, 165);
INSERT INTO public.who_global_data VALUES (38157, 96, 6388, 6, 195, 161, 14);
INSERT INTO public.who_global_data VALUES (38158, 11, 38226, 1, 1406, 162, 193);
INSERT INTO public.who_global_data VALUES (38159, 156, 9083, 3, 266, 162, 113);
INSERT INTO public.who_global_data VALUES (38160, 397, 43016, 10, 1475, 162, 143);
INSERT INTO public.who_global_data VALUES (38161, 0, 0, 0, 0, 162, 219);
INSERT INTO public.who_global_data VALUES (38162, 13, 1111, 0, 53, 162, 186);
INSERT INTO public.who_global_data VALUES (38163, 83, 2415, 2, 105, 162, 52);
INSERT INTO public.who_global_data VALUES (38164, 0, 3, 0, 0, 162, 180);
INSERT INTO public.who_global_data VALUES (38165, 0, 94, 0, 3, 162, 167);
INSERT INTO public.who_global_data VALUES (38166, 10550, 370188, 283, 7944, 162, 154);
INSERT INTO public.who_global_data VALUES (38167, 181, 42764, 5, 864, 162, 94);
INSERT INTO public.who_global_data VALUES (38168, 90, 1760, 0, 8, 162, 66);
INSERT INTO public.who_global_data VALUES (38169, 117, 25322, 23, 572, 162, 58);
INSERT INTO public.who_global_data VALUES (38170, 227, 26381, 0, 733, 162, 163);
INSERT INTO public.who_global_data VALUES (38171, 137, 35844, 2, 524, 162, 37);
INSERT INTO public.who_global_data VALUES (38172, 110, 1923, 0, 48, 162, 142);
INSERT INTO public.who_global_data VALUES (38173, 363, 50756, 2, 188, 162, 83);
INSERT INTO public.who_global_data VALUES (38174, 2436, 304583, 45, 4127, 162, 228);
INSERT INTO public.who_global_data VALUES (38175, 1, 165, 0, 7, 162, 188);
INSERT INTO public.who_global_data VALUES (38176, 191, 71165, 5, 662, 162, 62);
INSERT INTO public.who_global_data VALUES (38177, 535, 84570, 3, 9873, 162, 160);
INSERT INTO public.who_global_data VALUES (38178, 30, 760, 1, 11, 162, 50);
INSERT INTO public.who_global_data VALUES (38179, 0, 2145, 0, 40, 162, 33);
INSERT INTO public.who_global_data VALUES (38180, 0, 168, 0, 9, 162, 183);
INSERT INTO public.who_global_data VALUES (38181, 1, 184, 0, 0, 162, 92);
INSERT INTO public.who_global_data VALUES (38182, 1095, 112094, 62, 4726, 162, 158);
INSERT INTO public.who_global_data VALUES (38183, 1, 6, 0, 0, 162, 67);
INSERT INTO public.who_global_data VALUES (38184, 310, 18918, 11, 576, 162, 57);
INSERT INTO public.who_global_data VALUES (38185, 0, 1633, 0, 6, 162, 38);
INSERT INTO public.who_global_data VALUES (38186, 47161, 3717156, 1085, 117665, 162, 141);
INSERT INTO public.who_global_data VALUES (38187, 0, 26, 0, 1, 162, 178);
INSERT INTO public.who_global_data VALUES (38188, 0, 144, 0, 3, 162, 108);
INSERT INTO public.who_global_data VALUES (38189, 157, 15908, 8, 594, 162, 39);
INSERT INTO public.who_global_data VALUES (38190, 0, 1352, 0, 55, 162, 2);
INSERT INTO public.who_global_data VALUES (38191, 2, 433, 0, 1, 162, 195);
INSERT INTO public.who_global_data VALUES (38192, 69, 3699, 0, 38, 162, 107);
INSERT INTO public.who_global_data VALUES (38193, 0, 273, 0, 0, 162, 161);
INSERT INTO public.who_global_data VALUES (38194, 0, 18973, 0, 410, 162, 212);
INSERT INTO public.who_global_data VALUES (38195, 448, 126417, 4, 9094, 162, 181);
INSERT INTO public.who_global_data VALUES (38196, 0, 205, 0, 1, 162, 53);
INSERT INTO public.who_global_data VALUES (38197, 0, 4698, 0, 61, 162, 164);
INSERT INTO public.who_global_data VALUES (38198, 6, 1004, 0, 77, 162, 140);
INSERT INTO public.who_global_data VALUES (38199, 1737, 404102, 82, 11072, 162, 20);
INSERT INTO public.who_global_data VALUES (38200, 30, 90301, 2, 4722, 162, 112);
INSERT INTO public.who_global_data VALUES (38201, 10142, 572270, 295, 18184, 162, 111);
INSERT INTO public.who_global_data VALUES (38202, 0, 417, 0, 7, 162, 71);
INSERT INTO public.who_global_data VALUES (38203, 0, 3979, 0, 78, 162, 218);
INSERT INTO public.who_global_data VALUES (38204, 0, 0, 0, 0, 162, 43);
INSERT INTO public.who_global_data VALUES (38205, 1002, 36307, 10, 386, 162, 49);
INSERT INTO public.who_global_data VALUES (38206, 99, 17702, 1, 115, 162, 1);
INSERT INTO public.who_global_data VALUES (38207, 304, 9192, 2, 177, 162, 48);
INSERT INTO public.who_global_data VALUES (38208, 47, 3806, 0, 92, 162, 232);
INSERT INTO public.who_global_data VALUES (38209, 4, 53, 0, 1, 162, 175);
INSERT INTO public.who_global_data VALUES (38210, 0, 1481, 0, 21, 162, 21);
INSERT INTO public.who_global_data VALUES (38211, 349, 23300, 0, 418, 162, 156);
INSERT INTO public.who_global_data VALUES (38212, 0, 0, 0, 0, 162, 95);
INSERT INTO public.who_global_data VALUES (38213, 3, 9914, 1, 255, 162, 177);
INSERT INTO public.who_global_data VALUES (38214, 90, 16627, 1, 624, 162, 210);
INSERT INTO public.who_global_data VALUES (38215, 0, 5383, 0, 60, 162, 120);
INSERT INTO public.who_global_data VALUES (38216, 0, 20, 0, 0, 162, 135);
INSERT INTO public.who_global_data VALUES (38217, 407, 92964, 17, 1630, 162, 206);
INSERT INTO public.who_global_data VALUES (38218, 670, 111219, 61, 6471, 162, 189);
INSERT INTO public.who_global_data VALUES (38219, 237, 98062, 25, 5342, 162, 129);
INSERT INTO public.who_global_data VALUES (38220, 144, 25284, 7, 694, 162, 121);
INSERT INTO public.who_global_data VALUES (38221, 2, 4928, 0, 83, 162, 59);
INSERT INTO public.who_global_data VALUES (38222, 0, 315, 0, 0, 162, 96);
INSERT INTO public.who_global_data VALUES (38223, 14, 2325, 0, 64, 162, 41);
INSERT INTO public.who_global_data VALUES (38224, 46, 4433, 1, 89, 162, 216);
INSERT INTO public.who_global_data VALUES (38225, 1186, 46407, 20, 745, 162, 236);
INSERT INTO public.who_global_data VALUES (38226, 0, 13, 0, 0, 162, 150);
INSERT INTO public.who_global_data VALUES (38227, 0, 411, 0, 0, 162, 61);
INSERT INTO public.who_global_data VALUES (38228, 0, 28, 0, 2, 162, 7);
INSERT INTO public.who_global_data VALUES (38229, 17, 8019, 0, 335, 162, 169);
INSERT INTO public.who_global_data VALUES (38230, 5963, 244254, 29, 30440, 162, 28);
INSERT INTO public.who_global_data VALUES (38231, 46, 8982, 2, 58, 162, 85);
INSERT INTO public.who_global_data VALUES (38232, 32, 447, 0, 0, 162, 211);
INSERT INTO public.who_global_data VALUES (38233, 0, 8468, 0, 53, 162, 60);
INSERT INTO public.who_global_data VALUES (38234, 35, 2743, 0, 93, 162, 3);
INSERT INTO public.who_global_data VALUES (38235, 8, 1455, 0, 19, 162, 11);
INSERT INTO public.who_global_data VALUES (38236, 1571, 239507, 3, 9288, 162, 89);
INSERT INTO public.who_global_data VALUES (38237, 72, 43841, 0, 270, 162, 24);
INSERT INTO public.who_global_data VALUES (38238, 14, 270, 0, 0, 162, 162);
INSERT INTO public.who_global_data VALUES (38239, 251, 9531, 6, 254, 162, 100);
INSERT INTO public.who_global_data VALUES (38240, 0, 14, 0, 0, 162, 47);
INSERT INTO public.who_global_data VALUES (38241, 0, 24, 0, 0, 162, 29);
INSERT INTO public.who_global_data VALUES (38242, 0, 935, 0, 15, 162, 40);
INSERT INTO public.who_global_data VALUES (38243, 112, 1224, 1, 10, 162, 222);
INSERT INTO public.who_global_data VALUES (38244, 1142, 71856, 23, 2685, 162, 132);
INSERT INTO public.who_global_data VALUES (38245, 0, 252, 0, 13, 162, 130);
INSERT INTO public.who_global_data VALUES (38246, 46, 9213, 1, 58, 162, 234);
INSERT INTO public.who_global_data VALUES (38247, 0, 2149, 0, 33, 162, 23);
INSERT INTO public.who_global_data VALUES (38248, 33, 1093, 0, 31, 162, 192);
INSERT INTO public.who_global_data VALUES (38249, 29, 8151, 3, 200, 162, 69);
INSERT INTO public.who_global_data VALUES (38250, 0, 12, 0, 0, 162, 187);
INSERT INTO public.who_global_data VALUES (38251, 772, 56649, 44, 1747, 162, 230);
INSERT INTO public.who_global_data VALUES (38252, 91, 5379, 0, 614, 162, 77);
INSERT INTO public.who_global_data VALUES (38253, 5, 2087, 0, 10, 162, 9);
INSERT INTO public.who_global_data VALUES (38254, 77266, 3387500, 1057, 61529, 162, 74);
INSERT INTO public.who_global_data VALUES (38255, 2719, 162884, 120, 7064, 162, 224);
INSERT INTO public.who_global_data VALUES (38256, 2190, 367796, 117, 21137, 162, 199);
INSERT INTO public.who_global_data VALUES (38257, 3651, 219435, 72, 6740, 162, 190);
INSERT INTO public.who_global_data VALUES (38258, 90, 28453, 0, 1777, 162, 12);
INSERT INTO public.who_global_data VALUES (38259, 0, 336, 0, 24, 162, 104);
INSERT INTO public.who_global_data VALUES (38260, 1953, 108824, 11, 888, 162, 153);
INSERT INTO public.who_global_data VALUES (38261, 1409, 263949, 5, 35463, 162, 91);
INSERT INTO public.who_global_data VALUES (38262, 72, 1804, 0, 19, 162, 215);
INSERT INTO public.who_global_data VALUES (38263, 905, 65573, 12, 1238, 162, 84);
INSERT INTO public.who_global_data VALUES (38264, 3, 372, 0, 32, 162, 231);
INSERT INTO public.who_global_data VALUES (38265, 45, 1869, 0, 15, 162, 196);
INSERT INTO public.who_global_data VALUES (38266, 633, 130673, 0, 1781, 162, 105);
INSERT INTO public.who_global_data VALUES (38267, 373, 33389, 3, 567, 162, 122);
INSERT INTO public.who_global_data VALUES (38268, 0, 0, 0, 0, 162, 159);
INSERT INTO public.who_global_data VALUES (38269, 141, 12938, 6, 488, 162, 75);
INSERT INTO public.who_global_data VALUES (38270, 674, 82945, 1, 522, 162, 27);
INSERT INTO public.who_global_data VALUES (38271, 128, 43587, 0, 1058, 162, 54);
INSERT INTO public.who_global_data VALUES (38272, 0, 22, 0, 0, 162, 226);
INSERT INTO public.who_global_data VALUES (38273, 6, 1366, 1, 34, 162, 79);
INSERT INTO public.who_global_data VALUES (38274, 689, 14937, 7, 146, 162, 56);
INSERT INTO public.who_global_data VALUES (38275, 0, 1051, 0, 30, 162, 117);
INSERT INTO public.who_global_data VALUES (38276, 0, 1290, 0, 82, 162, 152);
INSERT INTO public.who_global_data VALUES (38277, 355, 12629, 7, 226, 162, 16);
INSERT INTO public.who_global_data VALUES (38278, 1, 107, 0, 1, 162, 10);
INSERT INTO public.who_global_data VALUES (38279, 48, 2804, 1, 86, 162, 201);
INSERT INTO public.who_global_data VALUES (38280, -1385, 6543, 0, 124, 162, 174);
INSERT INTO public.who_global_data VALUES (38281, 38, 14592, 3, 184, 162, 119);
INSERT INTO public.who_global_data VALUES (38282, 22, 5496, 0, 173, 162, 168);
INSERT INTO public.who_global_data VALUES (38283, 5, 9296, 0, 125, 162, 99);
INSERT INTO public.who_global_data VALUES (38284, 104, 7329, 0, 28, 162, 171);
INSERT INTO public.who_global_data VALUES (38285, 13, 2730, 0, 126, 162, 87);
INSERT INTO public.who_global_data VALUES (38286, 32, 1821, 0, 10, 162, 123);
INSERT INTO public.who_global_data VALUES (38287, 0, 0, 0, 0, 162, 151);
INSERT INTO public.who_global_data VALUES (38288, 0, 596, 0, 16, 162, 213);
INSERT INTO public.who_global_data VALUES (38289, 0, 6977, 0, 158, 162, 118);
INSERT INTO public.who_global_data VALUES (38290, 0, 346, 0, 10, 162, 134);
INSERT INTO public.who_global_data VALUES (38291, 64, 3301, 1, 40, 162, 65);
INSERT INTO public.who_global_data VALUES (38292, 5267, 573888, 626, 62076, 162, 102);
INSERT INTO public.who_global_data VALUES (38293, 0, 0, 0, 0, 162, 223);
INSERT INTO public.who_global_data VALUES (38294, 3, 128, 0, 1, 162, 4);
INSERT INTO public.who_global_data VALUES (38295, 1, 301, 0, 0, 162, 146);
INSERT INTO public.who_global_data VALUES (38296, 71, 4688, 2, 92, 162, 31);
INSERT INTO public.who_global_data VALUES (38297, 0, 13, 0, 1, 162, 127);
INSERT INTO public.who_global_data VALUES (38298, 1221, 57085, 27, 1011, 162, 22);
INSERT INTO public.who_global_data VALUES (38299, 61, 3651, 0, 21, 162, 115);
INSERT INTO public.who_global_data VALUES (38300, 48, 628, 0, 6, 162, 106);
INSERT INTO public.who_global_data VALUES (38301, 281, 6712, 1, 60, 162, 90);
INSERT INTO public.who_global_data VALUES (38302, 0, 0, 0, 0, 162, 70);
INSERT INTO public.who_global_data VALUES (38303, 1111, 35529, 8, 183, 162, 46);
INSERT INTO public.who_global_data VALUES (38304, 508, 68550, 3, 6213, 162, 139);
INSERT INTO public.who_global_data VALUES (38305, 0, 23, 0, 0, 162, 42);
INSERT INTO public.who_global_data VALUES (38306, 12, 1363, 0, 22, 162, 80);
INSERT INTO public.who_global_data VALUES (38307, 0, 3659, 0, 137, 162, 203);
INSERT INTO public.who_global_data VALUES (38308, 0, 1173, 0, 69, 162, 136);
INSERT INTO public.who_global_data VALUES (38309, 296, 53317, 1, 1011, 162, 63);
INSERT INTO public.who_global_data VALUES (38310, 0, 0, 0, 0, 162, 17);
INSERT INTO public.who_global_data VALUES (38311, 0, 54, 0, 2, 162, 172);
INSERT INTO public.who_global_data VALUES (38312, 90, 14004, 7, 585, 162, 109);
INSERT INTO public.who_global_data VALUES (38313, 51, 10505, 0, 264, 162, 200);
INSERT INTO public.who_global_data VALUES (38314, 622, 27386, 6, 158, 162, 93);
INSERT INTO public.who_global_data VALUES (38315, 187, 85005, 4, 650, 162, 5);
INSERT INTO public.who_global_data VALUES (38316, 0, 741, 0, 13, 162, 214);
INSERT INTO public.who_global_data VALUES (38317, 415, 295053, 9, 6283, 162, 204);
INSERT INTO public.who_global_data VALUES (38318, 0, 0, 0, 0, 162, 198);
INSERT INTO public.who_global_data VALUES (38319, 701, 89082, 13, 1932, 162, 173);
INSERT INTO public.who_global_data VALUES (38320, 5, 424, 0, 4, 162, 229);
INSERT INTO public.who_global_data VALUES (38321, 644, 14872, 16, 247, 162, 76);
INSERT INTO public.who_global_data VALUES (38322, 5996, 613378, 123, 28124, 162, 138);
INSERT INTO public.who_global_data VALUES (38323, 3220, 205581, 97, 3234, 162, 98);
INSERT INTO public.who_global_data VALUES (38324, 0, 0, 0, 0, 162, 103);
INSERT INTO public.who_global_data VALUES (38325, 887, 64689, 16, 2010, 162, 225);
INSERT INTO public.who_global_data VALUES (38326, 399, 56673, 2, 1809, 162, 131);
INSERT INTO public.who_global_data VALUES (38327, 639, 31383, 8, 412, 162, 235);
INSERT INTO public.who_global_data VALUES (38328, 246, 117988, 1, 195, 162, 137);
INSERT INTO public.who_global_data VALUES (38329, 371, 19077, 3, 316, 162, 81);
INSERT INTO public.who_global_data VALUES (38330, 564, 35546, 10, 977, 162, 182);
INSERT INTO public.who_global_data VALUES (38331, 38, 1410, 0, 2, 162, 145);
INSERT INTO public.who_global_data VALUES (38332, 1504, 83150, 38, 3459, 162, 26);
INSERT INTO public.who_global_data VALUES (38333, 4829, 980405, 110, 16914, 162, 170);
INSERT INTO public.who_global_data VALUES (38334, 47, 3672, 0, 15, 162, 191);
INSERT INTO public.who_global_data VALUES (38335, 0, 5, 0, 0, 162, 221);
INSERT INTO public.who_global_data VALUES (38336, 0, 17, 0, 0, 162, 64);
INSERT INTO public.who_global_data VALUES (38337, 0, 0, 0, 0, 162, 116);
INSERT INTO public.who_global_data VALUES (38338, 0, 17, 0, 0, 162, 128);
INSERT INTO public.who_global_data VALUES (38339, 0, 26, 0, 0, 162, 6);
INSERT INTO public.who_global_data VALUES (38340, 0, 198, 0, 5, 162, 227);
INSERT INTO public.who_global_data VALUES (38341, 0, 5, 0, 0, 162, 68);
INSERT INTO public.who_global_data VALUES (38342, 2, 60, 0, 0, 162, 184);
INSERT INTO public.who_global_data VALUES (38343, 0, 0, 0, 0, 162, 82);
INSERT INTO public.who_global_data VALUES (38344, 2, 732, 0, 42, 162, 149);
INSERT INTO public.who_global_data VALUES (38345, 2, 894, 0, 15, 162, 197);
INSERT INTO public.who_global_data VALUES (38346, 1019, 311855, 30, 3785, 162, 78);
INSERT INTO public.who_global_data VALUES (38347, 108, 13294, 2, 277, 162, 233);
INSERT INTO public.who_global_data VALUES (38348, 125, 31099, 0, 707, 162, 133);
INSERT INTO public.who_global_data VALUES (38349, 0, 131, 0, 0, 162, 35);
INSERT INTO public.who_global_data VALUES (38350, 10, 2013, 1, 70, 162, 114);
INSERT INTO public.who_global_data VALUES (38351, 77, 56572, 0, 27, 162, 237);
INSERT INTO public.who_global_data VALUES (38352, 0, 4, 0, 0, 162, 55);
INSERT INTO public.who_global_data VALUES (38353, 24, 442, 0, 17, 162, 176);
INSERT INTO public.who_global_data VALUES (38354, 90, 3626, 0, 33, 162, 202);
INSERT INTO public.who_global_data VALUES (38355, 42, 2798, 0, 133, 162, 155);
INSERT INTO public.who_global_data VALUES (38356, 0, 0, 0, 0, 162, 32);
INSERT INTO public.who_global_data VALUES (38357, 0, 3269, 0, 93, 162, 220);
INSERT INTO public.who_global_data VALUES (38358, 0, 615701, 0, 13502, 162, 30);
INSERT INTO public.who_global_data VALUES (38359, 4, 2518, 0, 47, 162, 147);
INSERT INTO public.who_global_data VALUES (38360, 10560, 462508, 48, 30679, 162, 208);
INSERT INTO public.who_global_data VALUES (38361, 2, 2986, 0, 12, 162, 45);
INSERT INTO public.who_global_data VALUES (38362, 107, 13189, 0, 823, 162, 110);
INSERT INTO public.who_global_data VALUES (38363, 26, 3724, 1, 62, 162, 88);
INSERT INTO public.who_global_data VALUES (38364, 244, 83675, 2, 5822, 162, 51);
INSERT INTO public.who_global_data VALUES (38365, 352, 41509, 2, 1758, 162, 209);
INSERT INTO public.who_global_data VALUES (38366, 64, 2504, 2, 100, 162, 205);
INSERT INTO public.who_global_data VALUES (38367, 36, 8449, 1, 68, 162, 18);
INSERT INTO public.who_global_data VALUES (38368, 6, 3410, 0, 58, 162, 72);
INSERT INTO public.who_global_data VALUES (38369, 1522, 330372, 12, 41477, 162, 44);
INSERT INTO public.who_global_data VALUES (38370, 0, 27, 0, 0, 162, 15);
INSERT INTO public.who_global_data VALUES (38371, 17, 1326, 0, 27, 162, 25);
INSERT INTO public.who_global_data VALUES (38372, 0, 0, 0, 0, 162, 179);
INSERT INTO public.who_global_data VALUES (38373, 0, 0, 0, 0, 162, 34);
INSERT INTO public.who_global_data VALUES (38374, 45, 1429, 0, 15, 162, 207);
INSERT INTO public.who_global_data VALUES (38375, 138, 3461, 1, 74, 162, 166);
INSERT INTO public.who_global_data VALUES (38376, 8221, 472628, 26, 6209, 162, 126);
INSERT INTO public.who_global_data VALUES (38377, 0, 0, 0, 0, 162, 97);
INSERT INTO public.who_global_data VALUES (38378, 33, 464, 1, 3, 162, 36);
INSERT INTO public.who_global_data VALUES (38379, 0, 0, 0, 0, 162, 125);
INSERT INTO public.who_global_data VALUES (38380, 0, 2524, 0, 26, 162, 124);
INSERT INTO public.who_global_data VALUES (38381, 2438, 114497, 48, 2451, 162, 185);
INSERT INTO public.who_global_data VALUES (38382, 491, 68511, 0, 378, 162, 194);
INSERT INTO public.who_global_data VALUES (38383, 0, 509, 0, 21, 162, 144);
INSERT INTO public.who_global_data VALUES (38384, 45484, 5765325, 1229, 178561, 162, 19);
INSERT INTO public.who_global_data VALUES (38385, 22, 1052, 0, 14, 162, 217);
INSERT INTO public.who_global_data VALUES (38386, 7, 1543, 0, 43, 162, 148);
INSERT INTO public.who_global_data VALUES (38387, 418, 40613, 5, 300, 162, 86);
INSERT INTO public.who_global_data VALUES (38388, 0, 0, 0, 0, 162, 13);
INSERT INTO public.who_global_data VALUES (38389, 807, 41965, 8, 351, 162, 157);
INSERT INTO public.who_global_data VALUES (38390, 2, 1036, 1, 30, 162, 8);
INSERT INTO public.who_global_data VALUES (38391, 0, 0, 0, 0, 162, 73);
INSERT INTO public.who_global_data VALUES (38392, 3, 1937, 2, 563, 162, 101);
INSERT INTO public.who_global_data VALUES (38393, 225, 11601, 0, 282, 162, 165);
INSERT INTO public.who_global_data VALUES (38394, 41, 6292, 10, 189, 162, 14);
INSERT INTO public.who_global_data VALUES (38395, 16, 38215, 0, 1405, 163, 193);
INSERT INTO public.who_global_data VALUES (38396, 168, 8927, 4, 263, 163, 113);
INSERT INTO public.who_global_data VALUES (38397, 391, 42619, 9, 1465, 163, 143);
INSERT INTO public.who_global_data VALUES (38398, 0, 0, 0, 0, 163, 219);
INSERT INTO public.who_global_data VALUES (38399, 38, 1098, 0, 53, 163, 186);
INSERT INTO public.who_global_data VALUES (38400, 49, 2332, 1, 103, 163, 52);
INSERT INTO public.who_global_data VALUES (38401, 0, 3, 0, 0, 163, 180);
INSERT INTO public.who_global_data VALUES (38402, 0, 94, 0, 3, 163, 167);
INSERT INTO public.who_global_data VALUES (38403, 8771, 359638, 259, 7661, 163, 154);
INSERT INTO public.who_global_data VALUES (38404, 203, 42583, 3, 859, 163, 94);
INSERT INTO public.who_global_data VALUES (38405, 42, 1670, 1, 8, 163, 66);
INSERT INTO public.who_global_data VALUES (38406, 152, 25205, 24, 549, 163, 58);
INSERT INTO public.who_global_data VALUES (38407, 316, 26154, 0, 733, 163, 163);
INSERT INTO public.who_global_data VALUES (38408, 148, 35707, 1, 522, 163, 37);
INSERT INTO public.who_global_data VALUES (38409, 15, 1813, 2, 48, 163, 142);
INSERT INTO public.who_global_data VALUES (38410, 317, 50393, 0, 186, 163, 83);
INSERT INTO public.who_global_data VALUES (38411, 2519, 302147, 54, 4082, 163, 228);
INSERT INTO public.who_global_data VALUES (38412, 3, 164, 0, 7, 163, 188);
INSERT INTO public.who_global_data VALUES (38413, 247, 70974, 5, 657, 163, 62);
INSERT INTO public.who_global_data VALUES (38414, 526, 84035, 4, 9870, 163, 160);
INSERT INTO public.who_global_data VALUES (38415, 17, 730, 0, 10, 163, 50);
INSERT INTO public.who_global_data VALUES (38416, 0, 2145, 0, 40, 163, 33);
INSERT INTO public.who_global_data VALUES (38417, 0, 168, 0, 9, 163, 183);
INSERT INTO public.who_global_data VALUES (38418, 10, 183, 0, 0, 163, 92);
INSERT INTO public.who_global_data VALUES (38419, 851, 110999, 86, 4664, 163, 158);
INSERT INTO public.who_global_data VALUES (38420, 0, 5, 0, 0, 163, 67);
INSERT INTO public.who_global_data VALUES (38421, 284, 18608, 11, 565, 163, 57);
INSERT INTO public.who_global_data VALUES (38422, 71, 1633, 3, 6, 163, 38);
INSERT INTO public.who_global_data VALUES (38423, 47134, 3669995, 1271, 116580, 163, 141);
INSERT INTO public.who_global_data VALUES (38424, 0, 26, 0, 1, 163, 178);
INSERT INTO public.who_global_data VALUES (38425, 0, 144, 0, 3, 163, 108);
INSERT INTO public.who_global_data VALUES (38426, 162, 15751, 14, 586, 163, 39);
INSERT INTO public.who_global_data VALUES (38427, 14, 1352, 0, 55, 163, 2);
INSERT INTO public.who_global_data VALUES (38428, 1, 431, 0, 1, 163, 195);
INSERT INTO public.who_global_data VALUES (38429, 62, 3630, 1, 38, 163, 107);
INSERT INTO public.who_global_data VALUES (38430, 0, 273, 0, 0, 163, 161);
INSERT INTO public.who_global_data VALUES (38431, 0, 18973, 0, 410, 163, 212);
INSERT INTO public.who_global_data VALUES (38432, 322, 125969, 7, 9090, 163, 181);
INSERT INTO public.who_global_data VALUES (38433, 0, 205, 0, 1, 163, 53);
INSERT INTO public.who_global_data VALUES (38434, 7, 4698, 0, 61, 163, 164);
INSERT INTO public.who_global_data VALUES (38435, 3, 998, 0, 77, 163, 140);
INSERT INTO public.who_global_data VALUES (38436, 1380, 402365, 32, 10990, 163, 20);
INSERT INTO public.who_global_data VALUES (38437, 32, 90271, 1, 4720, 163, 112);
INSERT INTO public.who_global_data VALUES (38438, 10432, 562128, 277, 17889, 163, 111);
INSERT INTO public.who_global_data VALUES (38439, 0, 417, 0, 7, 163, 71);
INSERT INTO public.who_global_data VALUES (38440, 0, 3979, 0, 78, 163, 218);
INSERT INTO public.who_global_data VALUES (38441, 0, 0, 0, 0, 163, 43);
INSERT INTO public.who_global_data VALUES (38442, 842, 35305, 14, 376, 163, 49);
INSERT INTO public.who_global_data VALUES (38443, 41, 17603, 0, 114, 163, 1);
INSERT INTO public.who_global_data VALUES (38444, 358, 8888, 0, 175, 163, 48);
INSERT INTO public.who_global_data VALUES (38445, 15, 3759, 1, 92, 163, 232);
INSERT INTO public.who_global_data VALUES (38446, 2, 49, 0, 1, 163, 175);
INSERT INTO public.who_global_data VALUES (38447, 7, 1481, 0, 21, 163, 21);
INSERT INTO public.who_global_data VALUES (38448, 403, 22951, 2, 418, 163, 156);
INSERT INTO public.who_global_data VALUES (38449, 0, 0, 0, 0, 163, 95);
INSERT INTO public.who_global_data VALUES (38450, 21, 9911, 3, 254, 163, 177);
INSERT INTO public.who_global_data VALUES (38451, 57, 16537, 0, 623, 163, 210);
INSERT INTO public.who_global_data VALUES (38452, 0, 5383, 0, 60, 163, 120);
INSERT INTO public.who_global_data VALUES (38453, 0, 20, 0, 0, 163, 135);
INSERT INTO public.who_global_data VALUES (38454, 340, 92557, 28, 1613, 163, 206);
INSERT INTO public.who_global_data VALUES (38455, 1519, 110549, 42, 6410, 163, 189);
INSERT INTO public.who_global_data VALUES (38456, 206, 97825, 19, 5317, 163, 129);
INSERT INTO public.who_global_data VALUES (38457, 154, 25140, 9, 687, 163, 121);
INSERT INTO public.who_global_data VALUES (38458, 0, 4926, 0, 83, 163, 59);
INSERT INTO public.who_global_data VALUES (38459, 0, 315, 0, 0, 163, 96);
INSERT INTO public.who_global_data VALUES (38460, 17, 2311, 0, 64, 163, 41);
INSERT INTO public.who_global_data VALUES (38461, 60, 4387, 2, 88, 163, 216);
INSERT INTO public.who_global_data VALUES (38462, 1533, 45221, 16, 725, 163, 236);
INSERT INTO public.who_global_data VALUES (38463, 0, 13, 0, 0, 163, 150);
INSERT INTO public.who_global_data VALUES (38464, 0, 411, 0, 0, 163, 61);
INSERT INTO public.who_global_data VALUES (38465, 0, 28, 0, 2, 163, 7);
INSERT INTO public.who_global_data VALUES (38466, 21, 8002, 0, 335, 163, 169);
INSERT INTO public.who_global_data VALUES (38467, 4998, 238291, 0, 30411, 163, 28);
INSERT INTO public.who_global_data VALUES (38468, 32, 8936, 0, 56, 163, 85);
INSERT INTO public.who_global_data VALUES (38469, 18, 415, 0, 0, 163, 211);
INSERT INTO public.who_global_data VALUES (38470, 59, 8468, 0, 53, 163, 60);
INSERT INTO public.who_global_data VALUES (38471, 22, 2708, 3, 93, 163, 3);
INSERT INTO public.who_global_data VALUES (38472, 11, 1447, 0, 19, 163, 11);
INSERT INTO public.who_global_data VALUES (38473, 1507, 237936, 5, 9285, 163, 89);
INSERT INTO public.who_global_data VALUES (38474, 52, 43769, 0, 270, 163, 24);
INSERT INTO public.who_global_data VALUES (38475, 8, 256, 0, 0, 163, 162);
INSERT INTO public.who_global_data VALUES (38476, 293, 9280, 5, 248, 163, 100);
INSERT INTO public.who_global_data VALUES (38477, 0, 14, 0, 0, 163, 47);
INSERT INTO public.who_global_data VALUES (38478, 0, 24, 0, 0, 163, 29);
INSERT INTO public.who_global_data VALUES (38479, 164, 935, 0, 15, 163, 40);
INSERT INTO public.who_global_data VALUES (38480, 136, 1112, 2, 9, 163, 222);
INSERT INTO public.who_global_data VALUES (38481, 1063, 70714, 32, 2662, 163, 132);
INSERT INTO public.who_global_data VALUES (38482, 0, 252, 0, 13, 163, 130);
INSERT INTO public.who_global_data VALUES (38483, 39, 9167, 0, 57, 163, 234);
INSERT INTO public.who_global_data VALUES (38484, 0, 2149, 0, 33, 163, 23);
INSERT INTO public.who_global_data VALUES (38485, 31, 1060, 0, 31, 163, 192);
INSERT INTO public.who_global_data VALUES (38486, 10, 8122, 1, 197, 163, 69);
INSERT INTO public.who_global_data VALUES (38487, 0, 12, 0, 0, 163, 187);
INSERT INTO public.who_global_data VALUES (38488, 398, 55877, 20, 1703, 163, 230);
INSERT INTO public.who_global_data VALUES (38489, 73, 5288, 0, 614, 163, 77);
INSERT INTO public.who_global_data VALUES (38490, 5, 2082, 0, 10, 163, 9);
INSERT INTO public.who_global_data VALUES (38491, 75760, 3310234, 1023, 60472, 163, 74);
INSERT INTO public.who_global_data VALUES (38492, 2306, 160165, 86, 6944, 163, 224);
INSERT INTO public.who_global_data VALUES (38493, 2243, 365606, 119, 21020, 163, 199);
INSERT INTO public.who_global_data VALUES (38494, 3837, 215784, 72, 6668, 163, 190);
INSERT INTO public.who_global_data VALUES (38495, 162, 28363, 0, 1777, 163, 12);
INSERT INTO public.who_global_data VALUES (38496, 0, 336, 0, 24, 163, 104);
INSERT INTO public.who_global_data VALUES (38497, 1956, 106871, 19, 877, 163, 153);
INSERT INTO public.who_global_data VALUES (38498, 1366, 262540, 13, 35458, 163, 91);
INSERT INTO public.who_global_data VALUES (38499, 120, 1732, 3, 19, 163, 215);
INSERT INTO public.who_global_data VALUES (38500, 846, 64668, 17, 1226, 163, 84);
INSERT INTO public.who_global_data VALUES (38501, 2, 369, 0, 32, 163, 231);
INSERT INTO public.who_global_data VALUES (38502, 40, 1824, 1, 15, 163, 196);
INSERT INTO public.who_global_data VALUES (38503, 696, 130040, 0, 1781, 163, 105);
INSERT INTO public.who_global_data VALUES (38504, 213, 33016, 4, 564, 163, 122);
INSERT INTO public.who_global_data VALUES (38505, 0, 0, 0, 0, 163, 159);
INSERT INTO public.who_global_data VALUES (38506, 157, 12797, 4, 482, 163, 75);
INSERT INTO public.who_global_data VALUES (38507, 698, 82271, 2, 521, 163, 27);
INSERT INTO public.who_global_data VALUES (38508, 101, 43459, 0, 1058, 163, 54);
INSERT INTO public.who_global_data VALUES (38509, 0, 22, 0, 0, 163, 226);
INSERT INTO public.who_global_data VALUES (38510, 18, 1360, 0, 33, 163, 79);
INSERT INTO public.who_global_data VALUES (38511, 561, 14248, 1, 139, 163, 56);
INSERT INTO public.who_global_data VALUES (38512, 2, 1051, 0, 30, 163, 117);
INSERT INTO public.who_global_data VALUES (38513, 0, 1290, 0, 82, 163, 152);
INSERT INTO public.who_global_data VALUES (38514, 440, 12274, 9, 219, 163, 16);
INSERT INTO public.who_global_data VALUES (38515, 1, 106, 0, 1, 163, 10);
INSERT INTO public.who_global_data VALUES (38516, 36, 2756, 0, 85, 163, 201);
INSERT INTO public.who_global_data VALUES (38517, 90, 7928, 0, 124, 163, 174);
INSERT INTO public.who_global_data VALUES (38518, 79, 14554, 3, 181, 163, 119);
INSERT INTO public.who_global_data VALUES (38519, 51, 5474, 3, 173, 163, 168);
INSERT INTO public.who_global_data VALUES (38520, 6, 9291, 0, 125, 163, 99);
INSERT INTO public.who_global_data VALUES (38521, 178, 7225, 0, 28, 163, 171);
INSERT INTO public.who_global_data VALUES (38522, 9, 2717, 1, 126, 163, 87);
INSERT INTO public.who_global_data VALUES (38523, 37, 1789, 0, 10, 163, 123);
INSERT INTO public.who_global_data VALUES (38524, 0, 0, 0, 0, 163, 151);
INSERT INTO public.who_global_data VALUES (38525, 132, 596, 0, 16, 163, 213);
INSERT INTO public.who_global_data VALUES (38526, 17, 6977, 0, 158, 163, 118);
INSERT INTO public.who_global_data VALUES (38527, 0, 346, 0, 10, 163, 134);
INSERT INTO public.who_global_data VALUES (38528, 0, 3237, 0, 39, 163, 65);
INSERT INTO public.who_global_data VALUES (38529, 4916, 568621, 650, 61450, 163, 102);
INSERT INTO public.who_global_data VALUES (38530, 0, 0, 0, 0, 163, 223);
INSERT INTO public.who_global_data VALUES (38531, 1, 125, 0, 1, 163, 4);
INSERT INTO public.who_global_data VALUES (38532, 2, 300, 0, 0, 163, 146);
INSERT INTO public.who_global_data VALUES (38533, 94, 4617, 2, 90, 163, 31);
INSERT INTO public.who_global_data VALUES (38534, 0, 13, 0, 1, 163, 127);
INSERT INTO public.who_global_data VALUES (38535, 1336, 55864, 29, 984, 163, 22);
INSERT INTO public.who_global_data VALUES (38536, 82, 3590, 0, 21, 163, 115);
INSERT INTO public.who_global_data VALUES (38537, 76, 580, 0, 6, 163, 106);
INSERT INTO public.who_global_data VALUES (38538, 271, 6431, 2, 59, 163, 90);
INSERT INTO public.who_global_data VALUES (38539, 0, 0, 0, 0, 163, 70);
INSERT INTO public.who_global_data VALUES (38540, 885, 34418, 11, 175, 163, 46);
INSERT INTO public.who_global_data VALUES (38541, 572, 68042, 8, 6210, 163, 139);
INSERT INTO public.who_global_data VALUES (38542, 0, 23, 0, 0, 163, 42);
INSERT INTO public.who_global_data VALUES (38543, 7, 1351, 0, 22, 163, 80);
INSERT INTO public.who_global_data VALUES (38544, 0, 3659, 0, 137, 163, 203);
INSERT INTO public.who_global_data VALUES (38545, 0, 1173, 0, 69, 163, 136);
INSERT INTO public.who_global_data VALUES (38546, 221, 53021, 3, 1010, 163, 63);
INSERT INTO public.who_global_data VALUES (38547, 0, 0, 0, 0, 163, 17);
INSERT INTO public.who_global_data VALUES (38548, 0, 54, 0, 2, 163, 172);
INSERT INTO public.who_global_data VALUES (38549, 115, 13914, 5, 578, 163, 109);
INSERT INTO public.who_global_data VALUES (38550, 59, 10454, 0, 264, 163, 200);
INSERT INTO public.who_global_data VALUES (38551, 602, 26764, 2, 152, 163, 93);
INSERT INTO public.who_global_data VALUES (38552, 166, 84818, 4, 646, 163, 5);
INSERT INTO public.who_global_data VALUES (38553, 0, 741, 0, 13, 163, 214);
INSERT INTO public.who_global_data VALUES (38554, 445, 294638, 7, 6274, 163, 204);
INSERT INTO public.who_global_data VALUES (38555, 0, 0, 0, 0, 163, 198);
INSERT INTO public.who_global_data VALUES (38556, 896, 88381, 13, 1919, 163, 173);
INSERT INTO public.who_global_data VALUES (38557, 0, 419, 0, 4, 163, 229);
INSERT INTO public.who_global_data VALUES (38558, 626, 14228, 12, 231, 163, 76);
INSERT INTO public.who_global_data VALUES (38559, 6944, 607382, 188, 28001, 163, 138);
INSERT INTO public.who_global_data VALUES (38560, 5197, 202361, 99, 3137, 163, 98);
INSERT INTO public.who_global_data VALUES (38561, 0, 0, 0, 0, 163, 103);
INSERT INTO public.who_global_data VALUES (38562, 729, 63802, 17, 1994, 163, 225);
INSERT INTO public.who_global_data VALUES (38563, 362, 56274, 2, 1807, 163, 131);
INSERT INTO public.who_global_data VALUES (38564, 24, 30744, 9, 404, 163, 235);
INSERT INTO public.who_global_data VALUES (38565, 244, 117742, 0, 194, 163, 137);
INSERT INTO public.who_global_data VALUES (38566, 441, 18706, 1, 313, 163, 81);
INSERT INTO public.who_global_data VALUES (38567, 624, 34982, 7, 967, 163, 182);
INSERT INTO public.who_global_data VALUES (38568, 80, 1372, 0, 2, 163, 145);
INSERT INTO public.who_global_data VALUES (38569, 1256, 81646, 54, 3421, 163, 26);
INSERT INTO public.who_global_data VALUES (38570, 4711, 975576, 121, 16804, 163, 170);
INSERT INTO public.who_global_data VALUES (38571, 88, 3625, 0, 15, 163, 191);
INSERT INTO public.who_global_data VALUES (38572, 0, 5, 0, 0, 163, 221);
INSERT INTO public.who_global_data VALUES (38573, 1, 17, 0, 0, 163, 64);
INSERT INTO public.who_global_data VALUES (38574, 0, 0, 0, 0, 163, 116);
INSERT INTO public.who_global_data VALUES (38575, 0, 17, 0, 0, 163, 128);
INSERT INTO public.who_global_data VALUES (38576, 0, 26, 0, 0, 163, 6);
INSERT INTO public.who_global_data VALUES (38577, 22, 198, 0, 5, 163, 227);
INSERT INTO public.who_global_data VALUES (38578, 0, 5, 0, 0, 163, 68);
INSERT INTO public.who_global_data VALUES (38579, 0, 58, 0, 0, 163, 184);
INSERT INTO public.who_global_data VALUES (38580, 0, 0, 0, 0, 163, 82);
INSERT INTO public.who_global_data VALUES (38581, 0, 730, 0, 42, 163, 149);
INSERT INTO public.who_global_data VALUES (38582, 0, 892, 0, 15, 163, 197);
INSERT INTO public.who_global_data VALUES (38583, 1068, 310836, 33, 3755, 163, 78);
INSERT INTO public.who_global_data VALUES (38584, 130, 13186, 1, 275, 163, 233);
INSERT INTO public.who_global_data VALUES (38585, 154, 30974, 2, 707, 163, 133);
INSERT INTO public.who_global_data VALUES (38586, 0, 131, 0, 0, 163, 35);
INSERT INTO public.who_global_data VALUES (38587, 2, 2003, 0, 69, 163, 114);
INSERT INTO public.who_global_data VALUES (38588, 60, 56495, 0, 27, 163, 237);
INSERT INTO public.who_global_data VALUES (38589, 1, 4, 0, 0, 163, 55);
INSERT INTO public.who_global_data VALUES (38590, 10, 418, 0, 17, 163, 176);
INSERT INTO public.who_global_data VALUES (38591, 84, 3536, 0, 33, 163, 202);
INSERT INTO public.who_global_data VALUES (38592, 33, 2756, 0, 133, 163, 155);
INSERT INTO public.who_global_data VALUES (38593, 0, 0, 0, 0, 163, 32);
INSERT INTO public.who_global_data VALUES (38594, 0, 3269, 0, 93, 163, 220);
INSERT INTO public.who_global_data VALUES (38595, 2684, 615701, 194, 13502, 163, 30);
INSERT INTO public.who_global_data VALUES (38596, 4, 2514, 0, 47, 163, 147);
INSERT INTO public.who_global_data VALUES (38597, 10518, 451948, 40, 30631, 163, 208);
INSERT INTO public.who_global_data VALUES (38598, 25, 2984, 0, 12, 163, 45);
INSERT INTO public.who_global_data VALUES (38599, 37, 13082, 0, 823, 163, 110);
INSERT INTO public.who_global_data VALUES (38600, 66, 3698, 1, 61, 163, 88);
INSERT INTO public.who_global_data VALUES (38601, 222, 83431, 1, 5820, 163, 51);
INSERT INTO public.who_global_data VALUES (38602, 362, 41157, 0, 1756, 163, 209);
INSERT INTO public.who_global_data VALUES (38603, 75, 2440, 3, 98, 163, 205);
INSERT INTO public.who_global_data VALUES (38604, 34, 8413, 0, 67, 163, 18);
INSERT INTO public.who_global_data VALUES (38605, 2, 3404, 0, 58, 163, 72);
INSERT INTO public.who_global_data VALUES (38606, 1048, 328850, 16, 41465, 163, 44);
INSERT INTO public.who_global_data VALUES (38607, 1, 27, 0, 0, 163, 15);
INSERT INTO public.who_global_data VALUES (38608, 0, 1309, 0, 27, 163, 25);
INSERT INTO public.who_global_data VALUES (38609, 0, 0, 0, 0, 163, 179);
INSERT INTO public.who_global_data VALUES (38610, 0, 0, 0, 0, 163, 34);
INSERT INTO public.who_global_data VALUES (38611, 200, 1384, 0, 15, 163, 207);
INSERT INTO public.who_global_data VALUES (38612, 117, 3323, 2, 73, 163, 166);
INSERT INTO public.who_global_data VALUES (38613, 8043, 464407, 20, 6183, 163, 126);
INSERT INTO public.who_global_data VALUES (38614, 0, 0, 0, 0, 163, 97);
INSERT INTO public.who_global_data VALUES (38615, 48, 431, 0, 2, 163, 36);
INSERT INTO public.who_global_data VALUES (38616, 0, 0, 0, 0, 163, 125);
INSERT INTO public.who_global_data VALUES (38617, 98, 2524, 1, 26, 163, 124);
INSERT INTO public.who_global_data VALUES (38618, 1974, 112059, 49, 2403, 163, 185);
INSERT INTO public.who_global_data VALUES (38619, 399, 68020, 1, 378, 163, 194);
INSERT INTO public.who_global_data VALUES (38620, 0, 509, 0, 21, 163, 144);
INSERT INTO public.who_global_data VALUES (38621, 37030, 5719841, 1131, 177332, 163, 19);
INSERT INTO public.who_global_data VALUES (38622, 32, 1030, 2, 14, 163, 217);
INSERT INTO public.who_global_data VALUES (38623, 3, 1536, 1, 43, 163, 148);
INSERT INTO public.who_global_data VALUES (38624, 405, 40195, 6, 295, 163, 86);
INSERT INTO public.who_global_data VALUES (38625, 0, 0, 0, 0, 163, 13);
INSERT INTO public.who_global_data VALUES (38626, 820, 41158, 6, 343, 163, 157);
INSERT INTO public.who_global_data VALUES (38627, 5, 1034, 2, 29, 163, 8);
INSERT INTO public.who_global_data VALUES (38628, 0, 0, 0, 0, 163, 73);
INSERT INTO public.who_global_data VALUES (38629, 6, 1934, 3, 561, 163, 101);
INSERT INTO public.who_global_data VALUES (38630, 228, 11376, 2, 282, 163, 165);
INSERT INTO public.who_global_data VALUES (38631, 55, 6251, 13, 179, 163, 14);
INSERT INTO public.who_global_data VALUES (38632, 43, 38199, 4, 1405, 164, 193);
INSERT INTO public.who_global_data VALUES (38633, 154, 8759, 5, 259, 164, 113);
INSERT INTO public.who_global_data VALUES (38634, 370, 42228, 10, 1456, 164, 143);
INSERT INTO public.who_global_data VALUES (38635, 0, 0, 0, 0, 164, 219);
INSERT INTO public.who_global_data VALUES (38636, 0, 1060, 0, 53, 164, 186);
INSERT INTO public.who_global_data VALUES (38637, 61, 2283, 2, 102, 164, 52);
INSERT INTO public.who_global_data VALUES (38638, 0, 3, 0, 0, 164, 180);
INSERT INTO public.who_global_data VALUES (38639, 0, 94, 0, 3, 164, 167);
INSERT INTO public.who_global_data VALUES (38640, 8713, 350867, 323, 7402, 164, 154);
INSERT INTO public.who_global_data VALUES (38641, 131, 42380, 3, 856, 164, 94);
INSERT INTO public.who_global_data VALUES (38642, 60, 1628, 0, 7, 164, 66);
INSERT INTO public.who_global_data VALUES (38643, 137, 25053, 8, 525, 164, 58);
INSERT INTO public.who_global_data VALUES (38644, 291, 25838, 0, 733, 164, 163);
INSERT INTO public.who_global_data VALUES (38645, 133, 35559, 2, 521, 164, 37);
INSERT INTO public.who_global_data VALUES (38646, 33, 1798, 17, 46, 164, 142);
INSERT INTO public.who_global_data VALUES (38647, 357, 50076, 1, 186, 164, 83);
INSERT INTO public.who_global_data VALUES (38648, 2545, 299628, 45, 4028, 164, 228);
INSERT INTO public.who_global_data VALUES (38649, 0, 161, 0, 7, 164, 188);
INSERT INTO public.who_global_data VALUES (38650, 82, 70727, 6, 652, 164, 62);
INSERT INTO public.who_global_data VALUES (38651, 527, 83509, 5, 9866, 164, 160);
INSERT INTO public.who_global_data VALUES (38652, 27, 713, 4, 10, 164, 50);
INSERT INTO public.who_global_data VALUES (38653, 30, 2145, 1, 40, 164, 33);
INSERT INTO public.who_global_data VALUES (38654, 1, 168, 0, 9, 164, 183);
INSERT INTO public.who_global_data VALUES (38655, 17, 173, 0, 0, 164, 92);
INSERT INTO public.who_global_data VALUES (38656, 999, 110148, 69, 4578, 164, 158);
INSERT INTO public.who_global_data VALUES (38657, 0, 5, 0, 0, 164, 67);
INSERT INTO public.who_global_data VALUES (38658, 297, 18324, 14, 554, 164, 57);
INSERT INTO public.who_global_data VALUES (38659, 0, 1562, 0, 3, 164, 38);
INSERT INTO public.who_global_data VALUES (38660, 17078, 3622861, 565, 115309, 164, 141);
INSERT INTO public.who_global_data VALUES (38661, 5, 26, 0, 1, 164, 178);
INSERT INTO public.who_global_data VALUES (38662, 1, 144, 0, 3, 164, 108);
INSERT INTO public.who_global_data VALUES (38663, 203, 15589, 9, 572, 164, 39);
INSERT INTO public.who_global_data VALUES (38664, 10, 1338, 0, 55, 164, 2);
INSERT INTO public.who_global_data VALUES (38665, 0, 430, 0, 1, 164, 195);
INSERT INTO public.who_global_data VALUES (38666, 36, 3568, 0, 37, 164, 107);
INSERT INTO public.who_global_data VALUES (38667, 0, 273, 0, 0, 164, 161);
INSERT INTO public.who_global_data VALUES (38668, 0, 18973, 0, 410, 164, 212);
INSERT INTO public.who_global_data VALUES (38669, 751, 125647, 10, 9083, 164, 181);
INSERT INTO public.who_global_data VALUES (38670, 0, 205, 0, 1, 164, 53);
INSERT INTO public.who_global_data VALUES (38671, 12, 4691, 0, 61, 164, 164);
INSERT INTO public.who_global_data VALUES (38672, 8, 995, 1, 77, 164, 140);
INSERT INTO public.who_global_data VALUES (38673, 1417, 400985, 42, 10958, 164, 20);
INSERT INTO public.who_global_data VALUES (38674, 34, 90239, 1, 4719, 164, 112);
INSERT INTO public.who_global_data VALUES (38675, 10549, 551696, 296, 17612, 164, 111);
INSERT INTO public.who_global_data VALUES (38676, 0, 417, 0, 7, 164, 71);
INSERT INTO public.who_global_data VALUES (38677, 0, 3979, 0, 78, 164, 218);
INSERT INTO public.who_global_data VALUES (38678, 0, 0, 0, 0, 164, 43);
INSERT INTO public.who_global_data VALUES (38679, 643, 34463, 7, 362, 164, 49);
INSERT INTO public.who_global_data VALUES (38680, 56, 17562, 0, 114, 164, 1);
INSERT INTO public.who_global_data VALUES (38681, 219, 8530, 2, 175, 164, 48);
INSERT INTO public.who_global_data VALUES (38682, 27, 3744, 0, 91, 164, 232);
INSERT INTO public.who_global_data VALUES (38683, 8, 47, 0, 1, 164, 175);
INSERT INTO public.who_global_data VALUES (38684, 23, 1474, 0, 21, 164, 21);
INSERT INTO public.who_global_data VALUES (38685, 367, 22548, 1, 416, 164, 156);
INSERT INTO public.who_global_data VALUES (38686, 0, 0, 0, 0, 164, 95);
INSERT INTO public.who_global_data VALUES (38687, 49, 9890, 0, 251, 164, 177);
INSERT INTO public.who_global_data VALUES (38688, 83, 16480, 0, 623, 164, 210);
INSERT INTO public.who_global_data VALUES (38689, 0, 5383, 0, 60, 164, 120);
INSERT INTO public.who_global_data VALUES (38690, 0, 20, 0, 0, 164, 135);
INSERT INTO public.who_global_data VALUES (38691, 609, 92217, 12, 1585, 164, 206);
INSERT INTO public.who_global_data VALUES (38692, 741, 109030, 46, 6368, 164, 189);
INSERT INTO public.who_global_data VALUES (38693, 141, 97619, 18, 5298, 164, 129);
INSERT INTO public.who_global_data VALUES (38694, 175, 24986, 9, 678, 164, 121);
INSERT INTO public.who_global_data VALUES (38695, 0, 4926, 0, 83, 164, 59);
INSERT INTO public.who_global_data VALUES (38696, 9, 315, 0, 0, 164, 96);
INSERT INTO public.who_global_data VALUES (38697, 19, 2294, 0, 64, 164, 41);
INSERT INTO public.who_global_data VALUES (38698, 23, 4327, 1, 86, 164, 216);
INSERT INTO public.who_global_data VALUES (38699, 1545, 43688, 17, 709, 164, 236);
INSERT INTO public.who_global_data VALUES (38700, 0, 13, 0, 0, 164, 150);
INSERT INTO public.who_global_data VALUES (38701, 1, 411, 0, 0, 164, 61);
INSERT INTO public.who_global_data VALUES (38702, 0, 28, 1, 2, 164, 7);
INSERT INTO public.who_global_data VALUES (38703, 43, 7981, 0, 335, 164, 169);
INSERT INTO public.who_global_data VALUES (38704, 3227, 233293, 16, 30411, 164, 28);
INSERT INTO public.who_global_data VALUES (38705, 29, 8904, 0, 56, 164, 85);
INSERT INTO public.who_global_data VALUES (38706, 25, 397, 0, 0, 164, 211);
INSERT INTO public.who_global_data VALUES (38707, 0, 8409, 0, 53, 164, 60);
INSERT INTO public.who_global_data VALUES (38708, 101, 2686, 3, 90, 164, 3);
INSERT INTO public.who_global_data VALUES (38709, 7, 1436, 0, 19, 164, 11);
INSERT INTO public.who_global_data VALUES (38710, 1576, 236429, 3, 9280, 164, 89);
INSERT INTO public.who_global_data VALUES (38711, 95, 43717, 7, 270, 164, 24);
INSERT INTO public.who_global_data VALUES (38712, 2, 248, 0, 0, 164, 162);
INSERT INTO public.who_global_data VALUES (38713, 168, 8987, 1, 243, 164, 100);
INSERT INTO public.who_global_data VALUES (38714, 0, 14, 0, 0, 164, 47);
INSERT INTO public.who_global_data VALUES (38715, 0, 24, 0, 0, 164, 29);
INSERT INTO public.who_global_data VALUES (38716, 0, 771, 0, 15, 164, 40);
INSERT INTO public.who_global_data VALUES (38717, 77, 976, 0, 7, 164, 222);
INSERT INTO public.who_global_data VALUES (38718, 1118, 69651, 19, 2630, 164, 132);
INSERT INTO public.who_global_data VALUES (38719, 0, 252, 0, 13, 164, 130);
INSERT INTO public.who_global_data VALUES (38720, 52, 9128, 2, 57, 164, 234);
INSERT INTO public.who_global_data VALUES (38721, 0, 2149, 0, 33, 164, 23);
INSERT INTO public.who_global_data VALUES (38722, 74, 1029, 0, 31, 164, 192);
INSERT INTO public.who_global_data VALUES (38723, 2, 8112, 0, 196, 164, 69);
INSERT INTO public.who_global_data VALUES (38724, 0, 12, 0, 0, 164, 187);
INSERT INTO public.who_global_data VALUES (38725, 968, 55479, 29, 1683, 164, 230);
INSERT INTO public.who_global_data VALUES (38726, 24, 5215, 1, 614, 164, 77);
INSERT INTO public.who_global_data VALUES (38727, 4, 2077, 0, 10, 164, 9);
INSERT INTO public.who_global_data VALUES (38728, 67151, 3234474, 1059, 59449, 164, 74);
INSERT INTO public.who_global_data VALUES (38729, 2447, 157859, 99, 6858, 164, 224);
INSERT INTO public.who_global_data VALUES (38730, 2213, 363363, 125, 20901, 164, 199);
INSERT INTO public.who_global_data VALUES (38731, 3962, 211947, 77, 6596, 164, 190);
INSERT INTO public.who_global_data VALUES (38732, 85, 28201, 0, 1777, 164, 12);
INSERT INTO public.who_global_data VALUES (38733, 0, 336, 0, 24, 164, 104);
INSERT INTO public.who_global_data VALUES (38734, 1900, 104915, 16, 858, 164, 153);
INSERT INTO public.who_global_data VALUES (38735, 876, 261174, 4, 35445, 164, 91);
INSERT INTO public.who_global_data VALUES (38736, 83, 1612, 0, 16, 164, 215);
INSERT INTO public.who_global_data VALUES (38737, 701, 63822, 13, 1209, 164, 84);
INSERT INTO public.who_global_data VALUES (38738, 3, 367, 0, 32, 164, 231);
INSERT INTO public.who_global_data VALUES (38739, 77, 1784, 0, 14, 164, 196);
INSERT INTO public.who_global_data VALUES (38740, 726, 129344, 0, 1781, 164, 105);
INSERT INTO public.who_global_data VALUES (38741, 246, 32803, 6, 560, 164, 122);
INSERT INTO public.who_global_data VALUES (38742, 0, 0, 0, 0, 164, 159);
INSERT INTO public.who_global_data VALUES (38743, 136, 12640, 8, 478, 164, 75);
INSERT INTO public.who_global_data VALUES (38744, 613, 81573, 1, 519, 164, 27);
INSERT INTO public.who_global_data VALUES (38745, 113, 43358, 1, 1058, 164, 54);
INSERT INTO public.who_global_data VALUES (38746, 0, 22, 0, 0, 164, 226);
INSERT INTO public.who_global_data VALUES (38747, 5, 1342, 0, 33, 164, 79);
INSERT INTO public.who_global_data VALUES (38748, 532, 13687, 12, 138, 164, 56);
INSERT INTO public.who_global_data VALUES (38749, 0, 1049, 0, 30, 164, 117);
INSERT INTO public.who_global_data VALUES (38750, 4, 1290, 0, 82, 164, 152);
INSERT INTO public.who_global_data VALUES (38751, 553, 11834, 7, 210, 164, 16);
INSERT INTO public.who_global_data VALUES (38752, 2, 105, 0, 1, 164, 10);
INSERT INTO public.who_global_data VALUES (38753, 32, 2720, 0, 85, 164, 201);
INSERT INTO public.who_global_data VALUES (38754, 44, 7838, 0, 124, 164, 174);
INSERT INTO public.who_global_data VALUES (38755, 73, 14475, 0, 178, 164, 119);
INSERT INTO public.who_global_data VALUES (38756, 4, 5423, 1, 170, 164, 168);
INSERT INTO public.who_global_data VALUES (38757, 11, 9285, 0, 125, 164, 99);
INSERT INTO public.who_global_data VALUES (38758, 135, 7047, 1, 28, 164, 171);
INSERT INTO public.who_global_data VALUES (38759, 0, 2708, 0, 125, 164, 87);
INSERT INTO public.who_global_data VALUES (38760, 46, 1752, 0, 10, 164, 123);
INSERT INTO public.who_global_data VALUES (38761, 0, 0, 0, 0, 164, 151);
INSERT INTO public.who_global_data VALUES (38762, 0, 464, 0, 16, 164, 213);
INSERT INTO public.who_global_data VALUES (38763, 32, 6960, 0, 158, 164, 118);
INSERT INTO public.who_global_data VALUES (38764, 0, 346, 0, 10, 164, 134);
INSERT INTO public.who_global_data VALUES (38765, 0, 3237, 0, 39, 164, 65);
INSERT INTO public.who_global_data VALUES (38766, 3541, 563705, 320, 60800, 164, 102);
INSERT INTO public.who_global_data VALUES (38767, 0, 0, 0, 0, 164, 223);
INSERT INTO public.who_global_data VALUES (38768, 6, 124, 0, 1, 164, 4);
INSERT INTO public.who_global_data VALUES (38769, 0, 298, 0, 0, 164, 146);
INSERT INTO public.who_global_data VALUES (38770, 59, 4523, 0, 88, 164, 31);
INSERT INTO public.who_global_data VALUES (38771, 0, 13, 0, 1, 164, 127);
INSERT INTO public.who_global_data VALUES (38772, 1276, 54528, 35, 955, 164, 22);
INSERT INTO public.who_global_data VALUES (38773, 68, 3508, 0, 21, 164, 115);
INSERT INTO public.who_global_data VALUES (38774, 30, 504, 0, 6, 164, 106);
INSERT INTO public.who_global_data VALUES (38775, 130, 6160, 1, 57, 164, 90);
INSERT INTO public.who_global_data VALUES (38776, 0, 0, 0, 0, 164, 70);
INSERT INTO public.who_global_data VALUES (38777, 855, 33533, 7, 164, 164, 46);
INSERT INTO public.who_global_data VALUES (38778, 416, 67470, 5, 6202, 164, 139);
INSERT INTO public.who_global_data VALUES (38779, 0, 23, 0, 0, 164, 42);
INSERT INTO public.who_global_data VALUES (38780, 5, 1344, 0, 22, 164, 80);
INSERT INTO public.who_global_data VALUES (38781, 119, 3659, 4, 137, 164, 203);
INSERT INTO public.who_global_data VALUES (38782, 1, 1173, 0, 69, 164, 136);
INSERT INTO public.who_global_data VALUES (38783, 252, 52800, 3, 1007, 164, 63);
INSERT INTO public.who_global_data VALUES (38784, 0, 0, 0, 0, 164, 17);
INSERT INTO public.who_global_data VALUES (38785, 0, 54, 0, 2, 164, 172);
INSERT INTO public.who_global_data VALUES (38786, 126, 13799, 5, 573, 164, 109);
INSERT INTO public.who_global_data VALUES (38787, 72, 10395, 0, 264, 164, 200);
INSERT INTO public.who_global_data VALUES (38788, 585, 26162, 0, 150, 164, 93);
INSERT INTO public.who_global_data VALUES (38789, 143, 84652, 5, 642, 164, 5);
INSERT INTO public.who_global_data VALUES (38790, 0, 741, 0, 13, 164, 214);
INSERT INTO public.who_global_data VALUES (38791, 482, 294193, 12, 6267, 164, 204);
INSERT INTO public.who_global_data VALUES (38792, 0, 0, 0, 0, 164, 198);
INSERT INTO public.who_global_data VALUES (38793, 585, 87485, 14, 1906, 164, 173);
INSERT INTO public.who_global_data VALUES (38794, 18, 419, 0, 4, 164, 229);
INSERT INTO public.who_global_data VALUES (38795, 369, 13602, 14, 219, 164, 76);
INSERT INTO public.who_global_data VALUES (38796, 6112, 600438, 150, 27813, 164, 138);
INSERT INTO public.who_global_data VALUES (38797, 2912, 197164, 28, 3038, 164, 98);
INSERT INTO public.who_global_data VALUES (38798, 0, 0, 0, 0, 164, 103);
INSERT INTO public.who_global_data VALUES (38799, 763, 63073, 17, 1977, 164, 225);
INSERT INTO public.who_global_data VALUES (38800, 192, 55912, 4, 1805, 164, 131);
INSERT INTO public.who_global_data VALUES (38801, 102, 30720, 5, 395, 164, 235);
INSERT INTO public.who_global_data VALUES (38802, 232, 117498, 0, 194, 164, 137);
INSERT INTO public.who_global_data VALUES (38803, 320, 18265, 2, 312, 164, 81);
INSERT INTO public.who_global_data VALUES (38804, 530, 34358, 15, 960, 164, 182);
INSERT INTO public.who_global_data VALUES (38805, 48, 1292, 0, 2, 164, 145);
INSERT INTO public.who_global_data VALUES (38806, 1060, 80390, 58, 3367, 164, 26);
INSERT INTO public.who_global_data VALUES (38807, 4676, 970865, 115, 16683, 164, 170);
INSERT INTO public.who_global_data VALUES (38808, 231, 3537, 1, 15, 164, 191);
INSERT INTO public.who_global_data VALUES (38809, 0, 5, 0, 0, 164, 221);
INSERT INTO public.who_global_data VALUES (38810, 0, 16, 0, 0, 164, 64);
INSERT INTO public.who_global_data VALUES (38811, 0, 0, 0, 0, 164, 116);
INSERT INTO public.who_global_data VALUES (38812, 0, 17, 0, 0, 164, 128);
INSERT INTO public.who_global_data VALUES (38813, 0, 26, 0, 0, 164, 6);
INSERT INTO public.who_global_data VALUES (38814, 0, 176, 0, 5, 164, 227);
INSERT INTO public.who_global_data VALUES (38815, 0, 5, 0, 0, 164, 68);
INSERT INTO public.who_global_data VALUES (38816, 0, 58, 0, 0, 164, 184);
INSERT INTO public.who_global_data VALUES (38817, 0, 0, 0, 0, 164, 82);
INSERT INTO public.who_global_data VALUES (38818, 4, 730, 0, 42, 164, 149);
INSERT INTO public.who_global_data VALUES (38819, 0, 892, 0, 15, 164, 197);
INSERT INTO public.who_global_data VALUES (38820, 1114, 309768, 31, 3722, 164, 78);
INSERT INTO public.who_global_data VALUES (38821, 43, 13056, 2, 274, 164, 233);
INSERT INTO public.who_global_data VALUES (38822, 106, 30820, 4, 705, 164, 133);
INSERT INTO public.who_global_data VALUES (38823, 0, 131, 0, 0, 164, 35);
INSERT INTO public.who_global_data VALUES (38824, 4, 2001, 0, 69, 164, 114);
INSERT INTO public.who_global_data VALUES (38825, 31, 56435, 0, 27, 164, 237);
INSERT INTO public.who_global_data VALUES (38826, 0, 3, 0, 0, 164, 55);
INSERT INTO public.who_global_data VALUES (38827, 12, 408, 0, 17, 164, 176);
INSERT INTO public.who_global_data VALUES (38828, 28, 3452, 0, 33, 164, 202);
INSERT INTO public.who_global_data VALUES (38829, 36, 2723, 0, 133, 164, 155);
INSERT INTO public.who_global_data VALUES (38830, 0, 0, 0, 0, 164, 32);
INSERT INTO public.who_global_data VALUES (38831, 0, 3269, 0, 93, 164, 220);
INSERT INTO public.who_global_data VALUES (38832, 1567, 613017, 149, 13308, 164, 30);
INSERT INTO public.who_global_data VALUES (38833, 3, 2510, 0, 47, 164, 147);
INSERT INTO public.who_global_data VALUES (38834, 6160, 441430, 53, 30591, 164, 208);
INSERT INTO public.who_global_data VALUES (38835, 0, 2959, 0, 12, 164, 45);
INSERT INTO public.who_global_data VALUES (38836, 71, 13045, 4, 823, 164, 110);
INSERT INTO public.who_global_data VALUES (38837, 25, 3632, 2, 60, 164, 88);
INSERT INTO public.who_global_data VALUES (38838, 174, 83209, 1, 5819, 164, 51);
INSERT INTO public.who_global_data VALUES (38839, 338, 40795, 0, 1756, 164, 209);
INSERT INTO public.who_global_data VALUES (38840, 72, 2365, 3, 95, 164, 205);
INSERT INTO public.who_global_data VALUES (38841, 33, 8379, 0, 67, 164, 18);
INSERT INTO public.who_global_data VALUES (38842, 0, 3402, 0, 58, 164, 72);
INSERT INTO public.who_global_data VALUES (38843, 1184, 327802, 16, 41449, 164, 44);
INSERT INTO public.who_global_data VALUES (38844, 0, 26, 0, 0, 164, 15);
INSERT INTO public.who_global_data VALUES (38845, 14, 1309, 0, 27, 164, 25);
INSERT INTO public.who_global_data VALUES (38846, 0, 0, 0, 0, 164, 179);
INSERT INTO public.who_global_data VALUES (38847, 0, 0, 0, 0, 164, 34);
INSERT INTO public.who_global_data VALUES (38848, 153, 1184, 0, 15, 164, 207);
INSERT INTO public.who_global_data VALUES (38849, 137, 3206, 0, 71, 164, 166);
INSERT INTO public.who_global_data VALUES (38850, 8232, 456364, 24, 6163, 164, 126);
INSERT INTO public.who_global_data VALUES (38851, 0, 0, 0, 0, 164, 97);
INSERT INTO public.who_global_data VALUES (38852, 0, 383, 0, 2, 164, 36);
INSERT INTO public.who_global_data VALUES (38853, 0, 0, 0, 0, 164, 125);
INSERT INTO public.who_global_data VALUES (38854, 64, 2426, 3, 25, 164, 124);
INSERT INTO public.who_global_data VALUES (38855, 1670, 110085, 36, 2354, 164, 185);
INSERT INTO public.who_global_data VALUES (38856, 339, 67621, 1, 377, 164, 194);
INSERT INTO public.who_global_data VALUES (38857, 0, 509, 0, 21, 164, 144);
INSERT INTO public.who_global_data VALUES (38858, 32883, 5682811, 388, 176201, 164, 19);
INSERT INTO public.who_global_data VALUES (38859, 14, 998, 1, 12, 164, 217);
INSERT INTO public.who_global_data VALUES (38860, 6, 1533, 0, 42, 164, 148);
INSERT INTO public.who_global_data VALUES (38861, 284, 39790, 7, 289, 164, 86);
INSERT INTO public.who_global_data VALUES (38862, 0, 0, 0, 0, 164, 13);
INSERT INTO public.who_global_data VALUES (38863, 774, 40338, 8, 337, 164, 157);
INSERT INTO public.who_global_data VALUES (38864, 7, 1029, 0, 27, 164, 8);
INSERT INTO public.who_global_data VALUES (38865, 0, 0, 0, 0, 164, 73);
INSERT INTO public.who_global_data VALUES (38866, 8, 1928, 2, 558, 164, 101);
INSERT INTO public.who_global_data VALUES (38867, 0, 11148, 0, 280, 164, 165);
INSERT INTO public.who_global_data VALUES (38868, 126, 6196, 11, 166, 164, 14);
INSERT INTO public.who_global_data VALUES (38869, 71, 38156, 10, 1401, 165, 193);
INSERT INTO public.who_global_data VALUES (38870, 178, 8605, 4, 254, 165, 113);
INSERT INTO public.who_global_data VALUES (38871, 398, 41858, 21, 1446, 165, 143);
INSERT INTO public.who_global_data VALUES (38872, 0, 0, 0, 0, 165, 219);
INSERT INTO public.who_global_data VALUES (38873, 13, 1060, 0, 53, 165, 186);
INSERT INTO public.who_global_data VALUES (38874, 51, 2222, 4, 100, 165, 52);
INSERT INTO public.who_global_data VALUES (38875, 0, 3, 0, 0, 165, 180);
INSERT INTO public.who_global_data VALUES (38876, 0, 94, 0, 3, 165, 167);
INSERT INTO public.who_global_data VALUES (38877, 5352, 342154, 132, 7079, 165, 154);
INSERT INTO public.who_global_data VALUES (38878, 111, 42249, 4, 853, 165, 94);
INSERT INTO public.who_global_data VALUES (38879, 181, 1568, 1, 7, 165, 66);
INSERT INTO public.who_global_data VALUES (38880, 104, 24916, 15, 517, 165, 58);
INSERT INTO public.who_global_data VALUES (38881, 308, 25547, 1, 733, 165, 163);
INSERT INTO public.who_global_data VALUES (38882, 152, 35426, 1, 519, 165, 37);
INSERT INTO public.who_global_data VALUES (38883, 0, 1765, 0, 29, 165, 142);
INSERT INTO public.who_global_data VALUES (38884, 389, 49719, 1, 185, 165, 83);
INSERT INTO public.who_global_data VALUES (38885, 2485, 297083, 42, 3983, 165, 228);
INSERT INTO public.who_global_data VALUES (38886, 0, 161, 0, 7, 165, 188);
INSERT INTO public.who_global_data VALUES (38887, 177, 70645, 4, 646, 165, 62);
INSERT INTO public.who_global_data VALUES (38888, 607, 82982, 5, 9861, 165, 160);
INSERT INTO public.who_global_data VALUES (38889, 18, 686, 0, 6, 165, 50);
INSERT INTO public.who_global_data VALUES (38890, 0, 2115, 0, 39, 165, 33);
INSERT INTO public.who_global_data VALUES (38891, 0, 167, 0, 9, 165, 183);
INSERT INTO public.who_global_data VALUES (38892, 1, 156, 0, 0, 165, 92);
INSERT INTO public.who_global_data VALUES (38893, 722, 109149, 67, 4509, 165, 158);
INSERT INTO public.who_global_data VALUES (38894, 0, 5, 0, 0, 165, 67);
INSERT INTO public.who_global_data VALUES (38895, 127, 18027, 11, 540, 165, 57);
INSERT INTO public.who_global_data VALUES (38896, 254, 1562, 0, 3, 165, 38);
INSERT INTO public.who_global_data VALUES (38897, 23421, 3605783, 494, 114744, 165, 141);
INSERT INTO public.who_global_data VALUES (38898, 0, 21, 0, 1, 165, 178);
INSERT INTO public.who_global_data VALUES (38899, 0, 143, 0, 3, 165, 108);
INSERT INTO public.who_global_data VALUES (38900, 99, 15386, 18, 563, 165, 39);
INSERT INTO public.who_global_data VALUES (38901, 0, 1328, 0, 55, 165, 2);
INSERT INTO public.who_global_data VALUES (38902, 0, 430, 0, 1, 165, 195);
INSERT INTO public.who_global_data VALUES (38903, 23, 3532, 0, 37, 165, 107);
INSERT INTO public.who_global_data VALUES (38904, 0, 273, 0, 0, 165, 161);
INSERT INTO public.who_global_data VALUES (38905, 211, 18973, 2, 410, 165, 212);
INSERT INTO public.who_global_data VALUES (38906, 267, 124896, 2, 9073, 165, 181);
INSERT INTO public.who_global_data VALUES (38907, 0, 205, 0, 1, 165, 53);
INSERT INTO public.who_global_data VALUES (38908, 0, 4679, 0, 61, 165, 164);
INSERT INTO public.who_global_data VALUES (38909, 1, 987, 0, 76, 165, 140);
INSERT INTO public.who_global_data VALUES (38910, 1903, 399568, 64, 10916, 165, 20);
INSERT INTO public.who_global_data VALUES (38911, 23, 90205, 0, 4718, 165, 112);
INSERT INTO public.who_global_data VALUES (38912, 8044, 541147, 348, 17316, 165, 111);
INSERT INTO public.who_global_data VALUES (38913, 0, 417, 0, 7, 165, 71);
INSERT INTO public.who_global_data VALUES (38914, 129, 3979, 1, 78, 165, 218);
INSERT INTO public.who_global_data VALUES (38915, 0, 0, 0, 0, 165, 43);
INSERT INTO public.who_global_data VALUES (38916, 736, 33820, 7, 355, 165, 49);
INSERT INTO public.who_global_data VALUES (38917, 35, 17506, 1, 114, 165, 1);
INSERT INTO public.who_global_data VALUES (38918, 136, 8311, 2, 173, 165, 48);
INSERT INTO public.who_global_data VALUES (38919, 35, 3717, 0, 91, 165, 232);
INSERT INTO public.who_global_data VALUES (38920, 2, 39, 0, 1, 165, 175);
INSERT INTO public.who_global_data VALUES (38921, 30, 1451, 0, 21, 165, 21);
INSERT INTO public.who_global_data VALUES (38922, 258, 22181, 3, 415, 165, 156);
INSERT INTO public.who_global_data VALUES (38923, 0, 0, 0, 0, 165, 95);
INSERT INTO public.who_global_data VALUES (38924, 12, 9841, 0, 251, 165, 177);
INSERT INTO public.who_global_data VALUES (38925, 270, 16397, 2, 623, 165, 210);
INSERT INTO public.who_global_data VALUES (38926, 1, 5383, 0, 60, 165, 120);
INSERT INTO public.who_global_data VALUES (38927, 1, 20, 0, 0, 165, 135);
INSERT INTO public.who_global_data VALUES (38928, 447, 91608, 6, 1573, 165, 206);
INSERT INTO public.who_global_data VALUES (38929, 520, 108289, 12, 6322, 165, 189);
INSERT INTO public.who_global_data VALUES (38930, 138, 97478, 18, 5280, 165, 129);
INSERT INTO public.who_global_data VALUES (38931, 189, 24811, 8, 669, 165, 121);
INSERT INTO public.who_global_data VALUES (38932, 0, 4926, 0, 83, 165, 59);
INSERT INTO public.who_global_data VALUES (38933, 0, 306, 0, 0, 165, 96);
INSERT INTO public.who_global_data VALUES (38934, 3, 2275, 1, 64, 165, 41);
INSERT INTO public.who_global_data VALUES (38935, 79, 4304, 0, 85, 165, 216);
INSERT INTO public.who_global_data VALUES (38936, 1472, 42143, 14, 692, 165, 236);
INSERT INTO public.who_global_data VALUES (38937, 0, 13, 0, 0, 165, 150);
INSERT INTO public.who_global_data VALUES (38938, 26, 410, 0, 0, 165, 61);
INSERT INTO public.who_global_data VALUES (38939, 0, 28, 0, 1, 165, 7);
INSERT INTO public.who_global_data VALUES (38940, 18, 7938, 1, 335, 165, 169);
INSERT INTO public.who_global_data VALUES (38941, 1842, 230066, 18, 30395, 165, 28);
INSERT INTO public.who_global_data VALUES (38942, 78, 8875, 1, 56, 165, 85);
INSERT INTO public.who_global_data VALUES (38943, 23, 372, 0, 0, 165, 211);
INSERT INTO public.who_global_data VALUES (38944, 21, 8409, 0, 53, 165, 60);
INSERT INTO public.who_global_data VALUES (38945, 0, 2585, 0, 87, 165, 3);
INSERT INTO public.who_global_data VALUES (38946, 8, 1429, 2, 19, 165, 11);
INSERT INTO public.who_global_data VALUES (38947, 1278, 234853, 5, 9277, 165, 89);
INSERT INTO public.who_global_data VALUES (38948, 117, 43622, 2, 263, 165, 24);
INSERT INTO public.who_global_data VALUES (38949, 7, 246, 0, 0, 165, 162);
INSERT INTO public.who_global_data VALUES (38950, 155, 8819, 0, 242, 165, 100);
INSERT INTO public.who_global_data VALUES (38951, 0, 14, 0, 0, 165, 47);
INSERT INTO public.who_global_data VALUES (38952, 0, 24, 0, 0, 165, 29);
INSERT INTO public.who_global_data VALUES (38953, 0, 771, 0, 15, 165, 40);
INSERT INTO public.who_global_data VALUES (38954, 87, 899, 0, 7, 165, 222);
INSERT INTO public.who_global_data VALUES (38955, 345, 68533, 17, 2611, 165, 132);
INSERT INTO public.who_global_data VALUES (38956, 0, 252, 0, 13, 165, 130);
INSERT INTO public.who_global_data VALUES (38957, 109, 9076, 2, 55, 165, 234);
INSERT INTO public.who_global_data VALUES (38958, 0, 2149, 0, 33, 165, 23);
INSERT INTO public.who_global_data VALUES (38959, 30, 955, 0, 31, 165, 192);
INSERT INTO public.who_global_data VALUES (38960, 28, 8110, 0, 196, 165, 69);
INSERT INTO public.who_global_data VALUES (38961, 0, 12, 0, 0, 165, 187);
INSERT INTO public.who_global_data VALUES (38962, 528, 54511, 11, 1654, 165, 230);
INSERT INTO public.who_global_data VALUES (38963, 36, 5191, 0, 613, 165, 77);
INSERT INTO public.who_global_data VALUES (38964, 9, 2073, 0, 10, 165, 9);
INSERT INTO public.who_global_data VALUES (38965, 60975, 3167323, 848, 58390, 165, 74);
INSERT INTO public.who_global_data VALUES (38966, 0, 155412, 0, 6759, 165, 224);
INSERT INTO public.who_global_data VALUES (38967, 2245, 361150, 133, 20776, 165, 199);
INSERT INTO public.who_global_data VALUES (38968, 3644, 207985, 91, 6519, 165, 190);
INSERT INTO public.who_global_data VALUES (38969, 147, 28116, 0, 1777, 165, 12);
INSERT INTO public.who_global_data VALUES (38970, 0, 336, 0, 24, 165, 104);
INSERT INTO public.who_global_data VALUES (38971, 965, 103015, 13, 842, 165, 153);
INSERT INTO public.who_global_data VALUES (38972, 953, 260298, 4, 35441, 165, 91);
INSERT INTO public.who_global_data VALUES (38973, 116, 1529, 0, 16, 165, 215);
INSERT INTO public.who_global_data VALUES (38974, 614, 63121, 15, 1196, 165, 84);
INSERT INTO public.who_global_data VALUES (38975, 0, 364, 0, 32, 165, 231);
INSERT INTO public.who_global_data VALUES (38976, 30, 1707, 2, 14, 165, 196);
INSERT INTO public.who_global_data VALUES (38977, 954, 128618, 0, 1781, 165, 105);
INSERT INTO public.who_global_data VALUES (38978, 193, 32557, 6, 554, 165, 122);
INSERT INTO public.who_global_data VALUES (38979, 0, 0, 0, 0, 165, 159);
INSERT INTO public.who_global_data VALUES (38980, 99, 12504, 13, 470, 165, 75);
INSERT INTO public.who_global_data VALUES (38981, 432, 80960, 3, 518, 165, 27);
INSERT INTO public.who_global_data VALUES (38982, 119, 43245, 0, 1057, 165, 54);
INSERT INTO public.who_global_data VALUES (38983, 0, 22, 0, 0, 165, 226);
INSERT INTO public.who_global_data VALUES (38984, 0, 1337, 0, 33, 165, 79);
INSERT INTO public.who_global_data VALUES (38985, 457, 13155, 3, 126, 165, 56);
INSERT INTO public.who_global_data VALUES (38986, 34, 1049, 0, 30, 165, 117);
INSERT INTO public.who_global_data VALUES (38987, 0, 1286, 0, 82, 165, 152);
INSERT INTO public.who_global_data VALUES (38988, 272, 11281, 4, 203, 165, 16);
INSERT INTO public.who_global_data VALUES (38989, 2, 103, 0, 1, 165, 10);
INSERT INTO public.who_global_data VALUES (38990, 21, 2688, 0, 85, 165, 201);
INSERT INTO public.who_global_data VALUES (38991, 90, 7794, 0, 124, 165, 174);
INSERT INTO public.who_global_data VALUES (38992, 75, 14402, 0, 178, 165, 119);
INSERT INTO public.who_global_data VALUES (38993, 5, 5419, 1, 169, 165, 168);
INSERT INTO public.who_global_data VALUES (38994, 7, 9274, 0, 125, 165, 99);
INSERT INTO public.who_global_data VALUES (38995, 133, 6912, 1, 27, 165, 171);
INSERT INTO public.who_global_data VALUES (38996, 3, 2708, 0, 125, 165, 87);
INSERT INTO public.who_global_data VALUES (38997, 38, 1706, 0, 10, 165, 123);
INSERT INTO public.who_global_data VALUES (38998, 0, 0, 0, 0, 165, 151);
INSERT INTO public.who_global_data VALUES (38999, 0, 464, 0, 16, 165, 213);
INSERT INTO public.who_global_data VALUES (39000, 23, 6928, 0, 158, 165, 118);
INSERT INTO public.who_global_data VALUES (39001, 0, 346, 0, 10, 165, 134);
INSERT INTO public.who_global_data VALUES (39002, 0, 3237, 0, 39, 165, 65);
INSERT INTO public.who_global_data VALUES (39003, 3948, 560164, 226, 60480, 165, 102);
INSERT INTO public.who_global_data VALUES (39004, 0, 0, 0, 0, 165, 223);
INSERT INTO public.who_global_data VALUES (39005, 4, 118, 0, 1, 165, 4);
INSERT INTO public.who_global_data VALUES (39006, 0, 298, 0, 0, 165, 146);
INSERT INTO public.who_global_data VALUES (39007, 75, 4464, 3, 88, 165, 31);
INSERT INTO public.who_global_data VALUES (39008, 0, 13, 0, 1, 165, 127);
INSERT INTO public.who_global_data VALUES (39009, 903, 53252, 32, 920, 165, 22);
INSERT INTO public.who_global_data VALUES (39010, 45, 3440, 1, 21, 165, 115);
INSERT INTO public.who_global_data VALUES (39011, 11, 474, 0, 6, 165, 106);
INSERT INTO public.who_global_data VALUES (39012, 176, 6030, 4, 56, 165, 90);
INSERT INTO public.who_global_data VALUES (39013, 0, 0, 0, 0, 165, 70);
INSERT INTO public.who_global_data VALUES (39014, 743, 32678, 8, 157, 165, 46);
INSERT INTO public.who_global_data VALUES (39015, 573, 67054, 2, 6197, 165, 139);
INSERT INTO public.who_global_data VALUES (39016, 0, 23, 0, 0, 165, 42);
INSERT INTO public.who_global_data VALUES (39017, 7, 1339, 0, 22, 165, 80);
INSERT INTO public.who_global_data VALUES (39018, 0, 3540, 0, 133, 165, 203);
INSERT INTO public.who_global_data VALUES (39019, 0, 1172, 0, 69, 165, 136);
INSERT INTO public.who_global_data VALUES (39020, 321, 52548, 2, 1004, 165, 63);
INSERT INTO public.who_global_data VALUES (39021, 0, 0, 0, 0, 165, 17);
INSERT INTO public.who_global_data VALUES (39022, 0, 54, 0, 2, 165, 172);
INSERT INTO public.who_global_data VALUES (39023, 78, 13673, 4, 568, 165, 109);
INSERT INTO public.who_global_data VALUES (39024, 126, 10323, 0, 264, 165, 200);
INSERT INTO public.who_global_data VALUES (39025, 553, 25577, 7, 150, 165, 93);
INSERT INTO public.who_global_data VALUES (39026, 740, 84509, 28, 637, 165, 5);
INSERT INTO public.who_global_data VALUES (39027, 0, 741, 0, 13, 165, 214);
INSERT INTO public.who_global_data VALUES (39028, 450, 293711, 11, 6255, 165, 204);
INSERT INTO public.who_global_data VALUES (39029, 0, 0, 0, 0, 165, 198);
INSERT INTO public.who_global_data VALUES (39030, 1420, 86900, 14, 1892, 165, 173);
INSERT INTO public.who_global_data VALUES (39031, 0, 401, 0, 4, 165, 229);
INSERT INTO public.who_global_data VALUES (39032, 259, 13233, 13, 205, 165, 76);
INSERT INTO public.who_global_data VALUES (39033, 9090, 594326, 210, 27663, 165, 138);
INSERT INTO public.who_global_data VALUES (39034, 4651, 194252, 12, 3010, 165, 98);
INSERT INTO public.who_global_data VALUES (39035, 0, 0, 0, 0, 165, 103);
INSERT INTO public.who_global_data VALUES (39036, 548, 62310, 5, 1960, 165, 225);
INSERT INTO public.who_global_data VALUES (39037, 123, 55720, 5, 1801, 165, 131);
INSERT INTO public.who_global_data VALUES (39038, 722, 30618, 0, 390, 165, 235);
INSERT INTO public.who_global_data VALUES (39039, 258, 117266, 1, 194, 165, 137);
INSERT INTO public.who_global_data VALUES (39040, 280, 17945, 1, 310, 165, 81);
INSERT INTO public.who_global_data VALUES (39041, 350, 33828, 5, 945, 165, 182);
INSERT INTO public.who_global_data VALUES (39042, 35, 1244, -4, 2, 165, 145);
INSERT INTO public.who_global_data VALUES (39043, 805, 79330, 37, 3309, 165, 26);
INSERT INTO public.who_global_data VALUES (39044, 4696, 966189, 120, 16568, 165, 170);
INSERT INTO public.who_global_data VALUES (39045, 217, 3306, 2, 14, 165, 191);
INSERT INTO public.who_global_data VALUES (39046, 0, 5, 0, 0, 165, 221);
INSERT INTO public.who_global_data VALUES (39047, 0, 16, 0, 0, 165, 64);
INSERT INTO public.who_global_data VALUES (39048, 0, 0, 0, 0, 165, 116);
INSERT INTO public.who_global_data VALUES (39049, 0, 17, 0, 0, 165, 128);
INSERT INTO public.who_global_data VALUES (39050, 0, 26, 0, 0, 165, 6);
INSERT INTO public.who_global_data VALUES (39051, 0, 176, 0, 5, 165, 227);
INSERT INTO public.who_global_data VALUES (39052, 0, 5, 0, 0, 165, 68);
INSERT INTO public.who_global_data VALUES (39053, 0, 58, 0, 0, 165, 184);
INSERT INTO public.who_global_data VALUES (39054, 0, 0, 0, 0, 165, 82);
INSERT INTO public.who_global_data VALUES (39055, 0, 726, 0, 42, 165, 149);
INSERT INTO public.who_global_data VALUES (39056, 0, 892, 0, 15, 165, 197);
INSERT INTO public.who_global_data VALUES (39057, 1175, 308654, 42, 3691, 165, 78);
INSERT INTO public.who_global_data VALUES (39058, 64, 13013, 3, 272, 165, 233);
INSERT INTO public.who_global_data VALUES (39059, 57, 30714, 3, 701, 165, 133);
INSERT INTO public.who_global_data VALUES (39060, 4, 131, 0, 0, 165, 35);
INSERT INTO public.who_global_data VALUES (39061, 5, 1997, 0, 69, 165, 114);
INSERT INTO public.who_global_data VALUES (39062, 51, 56404, 0, 27, 165, 237);
INSERT INTO public.who_global_data VALUES (39063, 0, 3, 0, 0, 165, 55);
INSERT INTO public.who_global_data VALUES (39064, 43, 396, 0, 17, 165, 176);
INSERT INTO public.who_global_data VALUES (39065, 68, 3424, 0, 33, 165, 202);
INSERT INTO public.who_global_data VALUES (39066, 21, 2687, 0, 133, 165, 155);
INSERT INTO public.who_global_data VALUES (39067, 0, 0, 0, 0, 165, 32);
INSERT INTO public.who_global_data VALUES (39068, 0, 3269, 0, 93, 165, 220);
INSERT INTO public.who_global_data VALUES (39069, 1677, 611450, 100, 13159, 165, 30);
INSERT INTO public.who_global_data VALUES (39070, 3, 2507, 0, 47, 165, 147);
INSERT INTO public.who_global_data VALUES (39071, 4347, 435270, 52, 30538, 165, 208);
INSERT INTO public.who_global_data VALUES (39072, 6, 2959, 0, 12, 165, 45);
INSERT INTO public.who_global_data VALUES (39073, 0, 12974, 0, 819, 165, 110);
INSERT INTO public.who_global_data VALUES (39074, 38, 3607, 1, 58, 165, 88);
INSERT INTO public.who_global_data VALUES (39075, 57, 83035, 3, 5818, 165, 51);
INSERT INTO public.who_global_data VALUES (39076, 304, 40457, 1, 1756, 165, 209);
INSERT INTO public.who_global_data VALUES (39077, 76, 2293, 3, 92, 165, 205);
INSERT INTO public.who_global_data VALUES (39078, 35, 8346, 1, 67, 165, 18);
INSERT INTO public.who_global_data VALUES (39079, 5, 3402, 0, 58, 165, 72);
INSERT INTO public.who_global_data VALUES (39080, 972, 326618, 4, 41433, 165, 44);
INSERT INTO public.who_global_data VALUES (39081, 0, 26, 0, 0, 165, 15);
INSERT INTO public.who_global_data VALUES (39082, 18, 1295, 0, 27, 165, 25);
INSERT INTO public.who_global_data VALUES (39083, 0, 0, 0, 0, 165, 179);
INSERT INTO public.who_global_data VALUES (39084, 0, 0, 0, 0, 165, 34);
INSERT INTO public.who_global_data VALUES (39085, 68, 1031, 1, 15, 165, 207);
INSERT INTO public.who_global_data VALUES (39086, 176, 3069, 0, 71, 165, 166);
INSERT INTO public.who_global_data VALUES (39087, 8173, 448132, 18, 6139, 165, 126);
INSERT INTO public.who_global_data VALUES (39088, 0, 0, 0, 0, 165, 97);
INSERT INTO public.who_global_data VALUES (39089, 0, 383, 0, 2, 165, 36);
INSERT INTO public.who_global_data VALUES (39090, 0, 0, 0, 0, 165, 125);
INSERT INTO public.who_global_data VALUES (39091, 99, 2362, 2, 22, 165, 124);
INSERT INTO public.who_global_data VALUES (39092, 1658, 108415, 25, 2318, 165, 185);
INSERT INTO public.who_global_data VALUES (39093, 275, 67282, 1, 376, 165, 194);
INSERT INTO public.who_global_data VALUES (39094, 0, 509, 0, 21, 165, 144);
INSERT INTO public.who_global_data VALUES (39095, 37765, 5649928, 570, 175813, 165, 19);
INSERT INTO public.who_global_data VALUES (39096, 24, 984, 1, 11, 165, 217);
INSERT INTO public.who_global_data VALUES (39097, 6, 1527, 0, 42, 165, 148);
INSERT INTO public.who_global_data VALUES (39098, 441, 39506, 7, 282, 165, 86);
INSERT INTO public.who_global_data VALUES (39099, 0, 0, 0, 0, 165, 13);
INSERT INTO public.who_global_data VALUES (39100, 607, 39564, 6, 329, 165, 157);
INSERT INTO public.who_global_data VALUES (39101, 6, 1022, 0, 27, 165, 8);
INSERT INTO public.who_global_data VALUES (39102, 0, 0, 0, 0, 165, 73);
INSERT INTO public.who_global_data VALUES (39103, 5, 1920, 2, 556, 165, 101);
INSERT INTO public.who_global_data VALUES (39104, 66, 11148, 0, 280, 165, 165);
INSERT INTO public.who_global_data VALUES (39105, 140, 6070, 0, 155, 165, 14);
INSERT INTO public.who_global_data VALUES (39106, 46, 38085, 2, 1391, 166, 193);
INSERT INTO public.who_global_data VALUES (39107, 152, 8427, 5, 250, 166, 113);
INSERT INTO public.who_global_data VALUES (39108, 392, 41460, 1, 1425, 166, 143);
INSERT INTO public.who_global_data VALUES (39109, 0, 0, 0, 0, 166, 219);
INSERT INTO public.who_global_data VALUES (39110, 0, 1047, 0, 53, 166, 186);
INSERT INTO public.who_global_data VALUES (39111, 37, 2171, 2, 96, 166, 52);
INSERT INTO public.who_global_data VALUES (39112, 0, 3, 0, 0, 166, 180);
INSERT INTO public.who_global_data VALUES (39113, 0, 94, 0, 3, 166, 167);
INSERT INTO public.who_global_data VALUES (39114, 7759, 336802, 152, 6947, 166, 154);
INSERT INTO public.who_global_data VALUES (39115, 33, 42138, 2, 849, 166, 94);
INSERT INTO public.who_global_data VALUES (39116, 0, 1387, 0, 6, 166, 66);
INSERT INTO public.who_global_data VALUES (39117, 210, 24812, 17, 502, 166, 58);
INSERT INTO public.who_global_data VALUES (39118, 140, 25239, 0, 732, 166, 163);
INSERT INTO public.who_global_data VALUES (39119, 169, 35274, 3, 518, 166, 37);
INSERT INTO public.who_global_data VALUES (39120, 62, 1765, 2, 29, 166, 142);
INSERT INTO public.who_global_data VALUES (39121, 292, 49330, 1, 184, 166, 83);
INSERT INTO public.who_global_data VALUES (39122, 1973, 294598, 34, 3941, 166, 228);
INSERT INTO public.who_global_data VALUES (39123, 4, 161, 0, 7, 166, 188);
INSERT INTO public.who_global_data VALUES (39124, 183, 70468, 5, 642, 166, 62);
INSERT INTO public.who_global_data VALUES (39125, 115, 82375, 3, 9856, 166, 160);
INSERT INTO public.who_global_data VALUES (39126, 20, 668, 1, 6, 166, 50);
INSERT INTO public.who_global_data VALUES (39127, 0, 2115, 0, 39, 166, 33);
INSERT INTO public.who_global_data VALUES (39128, 0, 167, 0, 9, 166, 183);
INSERT INTO public.who_global_data VALUES (39129, 0, 155, 0, 0, 166, 92);
INSERT INTO public.who_global_data VALUES (39130, 992, 108427, 76, 4442, 166, 158);
INSERT INTO public.who_global_data VALUES (39131, 0, 5, 0, 0, 166, 67);
INSERT INTO public.who_global_data VALUES (39132, 188, 17900, 3, 529, 166, 57);
INSERT INTO public.who_global_data VALUES (39133, 0, 1308, 0, 3, 166, 38);
INSERT INTO public.who_global_data VALUES (39134, 50032, 3582362, 892, 114250, 166, 141);
INSERT INTO public.who_global_data VALUES (39135, 0, 21, 0, 1, 166, 178);
INSERT INTO public.who_global_data VALUES (39136, 0, 143, 0, 3, 166, 108);
INSERT INTO public.who_global_data VALUES (39137, 60, 15287, 0, 545, 166, 39);
INSERT INTO public.who_global_data VALUES (39138, 31, 1328, 0, 55, 166, 2);
INSERT INTO public.who_global_data VALUES (39139, 0, 430, 0, 1, 166, 195);
INSERT INTO public.who_global_data VALUES (39140, 54, 3509, 0, 37, 166, 107);
INSERT INTO public.who_global_data VALUES (39141, 0, 273, 0, 0, 166, 161);
INSERT INTO public.who_global_data VALUES (39142, 0, 18762, 0, 408, 166, 212);
INSERT INTO public.who_global_data VALUES (39143, 257, 124629, 7, 9071, 166, 181);
INSERT INTO public.who_global_data VALUES (39144, 0, 205, 0, 1, 166, 53);
INSERT INTO public.who_global_data VALUES (39145, 0, 4679, 0, 61, 166, 164);
INSERT INTO public.who_global_data VALUES (39146, 4, 986, 0, 76, 166, 140);
INSERT INTO public.who_global_data VALUES (39147, 1957, 397665, 60, 10852, 166, 20);
INSERT INTO public.who_global_data VALUES (39148, 41, 90182, 1, 4718, 166, 112);
INSERT INTO public.who_global_data VALUES (39149, 10965, 533103, 400, 16968, 166, 111);
INSERT INTO public.who_global_data VALUES (39150, 0, 417, 0, 7, 166, 71);
INSERT INTO public.who_global_data VALUES (39151, 0, 3850, 0, 77, 166, 218);
INSERT INTO public.who_global_data VALUES (39152, 0, 0, 0, 0, 166, 43);
INSERT INTO public.who_global_data VALUES (39153, 950, 33084, 8, 348, 166, 49);
INSERT INTO public.who_global_data VALUES (39154, 97, 17471, 0, 113, 166, 1);
INSERT INTO public.who_global_data VALUES (39155, 275, 8175, 1, 171, 166, 48);
INSERT INTO public.who_global_data VALUES (39156, 65, 3682, 2, 91, 166, 232);
INSERT INTO public.who_global_data VALUES (39157, 0, 37, 0, 1, 166, 175);
INSERT INTO public.who_global_data VALUES (39158, 4, 1421, 0, 21, 166, 21);
INSERT INTO public.who_global_data VALUES (39159, 133, 21923, 1, 412, 166, 156);
INSERT INTO public.who_global_data VALUES (39160, 0, 0, 0, 0, 166, 95);
INSERT INTO public.who_global_data VALUES (39161, 19, 9829, 0, 251, 166, 177);
INSERT INTO public.who_global_data VALUES (39162, 0, 16127, 0, 621, 166, 210);
INSERT INTO public.who_global_data VALUES (39163, 0, 5382, 0, 60, 166, 120);
INSERT INTO public.who_global_data VALUES (39164, 0, 19, 0, 0, 166, 135);
INSERT INTO public.who_global_data VALUES (39165, 600, 91161, 13, 1567, 166, 206);
INSERT INTO public.who_global_data VALUES (39166, 680, 107769, 33, 6310, 166, 189);
INSERT INTO public.who_global_data VALUES (39167, 103, 97340, 19, 5262, 166, 129);
INSERT INTO public.who_global_data VALUES (39168, 202, 24622, 7, 661, 166, 121);
INSERT INTO public.who_global_data VALUES (39169, 0, 4926, 0, 83, 166, 59);
INSERT INTO public.who_global_data VALUES (39170, 0, 306, 0, 0, 166, 96);
INSERT INTO public.who_global_data VALUES (39171, 7, 2272, 0, 63, 166, 41);
INSERT INTO public.who_global_data VALUES (39172, 36, 4225, 2, 85, 166, 216);
INSERT INTO public.who_global_data VALUES (39173, 1638, 40671, 16, 678, 166, 236);
INSERT INTO public.who_global_data VALUES (39174, 0, 13, 0, 0, 166, 150);
INSERT INTO public.who_global_data VALUES (39175, 0, 384, 0, 0, 166, 61);
INSERT INTO public.who_global_data VALUES (39176, 0, 28, 0, 1, 166, 7);
INSERT INTO public.who_global_data VALUES (39177, 14, 7920, 0, 334, 166, 169);
INSERT INTO public.who_global_data VALUES (39178, 4805, 228224, 1, 30377, 166, 28);
INSERT INTO public.who_global_data VALUES (39179, 0, 8797, 0, 55, 166, 85);
INSERT INTO public.who_global_data VALUES (39180, 51, 349, 0, 0, 166, 211);
INSERT INTO public.who_global_data VALUES (39181, 0, 8388, 0, 53, 166, 60);
INSERT INTO public.who_global_data VALUES (39182, 148, 2585, 3, 87, 166, 3);
INSERT INTO public.who_global_data VALUES (39183, 10, 1421, 0, 17, 166, 11);
INSERT INTO public.who_global_data VALUES (39184, 711, 233575, 3, 9272, 166, 89);
INSERT INTO public.who_global_data VALUES (39185, 180, 43505, 0, 261, 166, 24);
INSERT INTO public.who_global_data VALUES (39186, 10, 239, 0, 0, 166, 162);
INSERT INTO public.who_global_data VALUES (39187, 283, 8664, 2, 242, 166, 100);
INSERT INTO public.who_global_data VALUES (39188, 0, 14, 0, 0, 166, 47);
INSERT INTO public.who_global_data VALUES (39189, 0, 24, 0, 0, 166, 29);
INSERT INTO public.who_global_data VALUES (39190, 0, 771, 0, 15, 166, 40);
INSERT INTO public.who_global_data VALUES (39191, 0, 812, 0, 7, 166, 222);
INSERT INTO public.who_global_data VALUES (39192, 332, 68188, 14, 2594, 166, 132);
INSERT INTO public.who_global_data VALUES (39193, 0, 252, 0, 13, 166, 130);
INSERT INTO public.who_global_data VALUES (39194, 0, 8967, 0, 53, 166, 234);
INSERT INTO public.who_global_data VALUES (39195, 0, 2149, 0, 33, 166, 23);
INSERT INTO public.who_global_data VALUES (39196, 44, 925, 1, 31, 166, 192);
INSERT INTO public.who_global_data VALUES (39197, 32, 8082, 0, 196, 166, 69);
INSERT INTO public.who_global_data VALUES (39198, 0, 12, 0, 0, 166, 187);
INSERT INTO public.who_global_data VALUES (39199, 602, 53983, 11, 1643, 166, 230);
INSERT INTO public.who_global_data VALUES (39200, 22, 5155, 2, 613, 166, 77);
INSERT INTO public.who_global_data VALUES (39201, 6, 2064, 0, 10, 166, 9);
INSERT INTO public.who_global_data VALUES (39202, 61408, 3106348, 836, 57542, 166, 74);
INSERT INTO public.who_global_data VALUES (39203, 3914, 155412, 165, 6759, 166, 224);
INSERT INTO public.who_global_data VALUES (39204, 2113, 358905, 141, 20643, 166, 199);
INSERT INTO public.who_global_data VALUES (39205, 3291, 204341, 75, 6428, 166, 190);
INSERT INTO public.who_global_data VALUES (39206, 61, 27969, 0, 1777, 166, 12);
INSERT INTO public.who_global_data VALUES (39207, 0, 336, 0, 24, 166, 104);
INSERT INTO public.who_global_data VALUES (39208, 711, 102050, 10, 829, 166, 153);
INSERT INTO public.who_global_data VALUES (39209, 1209, 259345, 7, 35437, 166, 91);
INSERT INTO public.who_global_data VALUES (39210, 67, 1413, 0, 16, 166, 215);
INSERT INTO public.who_global_data VALUES (39211, 760, 62507, 5, 1181, 166, 84);
INSERT INTO public.who_global_data VALUES (39212, 1, 364, 0, 32, 166, 231);
INSERT INTO public.who_global_data VALUES (39213, 33, 1677, 1, 12, 166, 196);
INSERT INTO public.who_global_data VALUES (39214, 202, 127664, 0, 1781, 166, 105);
INSERT INTO public.who_global_data VALUES (39215, 246, 32364, 6, 548, 166, 122);
INSERT INTO public.who_global_data VALUES (39216, 0, 0, 0, 0, 166, 159);
INSERT INTO public.who_global_data VALUES (39217, 111, 12405, 10, 457, 166, 75);
INSERT INTO public.who_global_data VALUES (39218, 571, 80528, 2, 515, 166, 27);
INSERT INTO public.who_global_data VALUES (39219, 103, 43126, 1, 1057, 166, 54);
INSERT INTO public.who_global_data VALUES (39220, 0, 22, 0, 0, 166, 226);
INSERT INTO public.who_global_data VALUES (39221, 4, 1337, 0, 33, 166, 79);
INSERT INTO public.who_global_data VALUES (39222, 507, 12698, 2, 123, 166, 56);
INSERT INTO public.who_global_data VALUES (39223, 0, 1015, 0, 30, 166, 117);
INSERT INTO public.who_global_data VALUES (39224, 1, 1286, 0, 82, 166, 152);
INSERT INTO public.who_global_data VALUES (39225, 572, 11009, 11, 199, 166, 16);
INSERT INTO public.who_global_data VALUES (39226, 0, 101, 0, 1, 166, 10);
INSERT INTO public.who_global_data VALUES (39227, 38, 2667, 1, 85, 166, 201);
INSERT INTO public.who_global_data VALUES (39228, 0, 7704, 0, 124, 166, 174);
INSERT INTO public.who_global_data VALUES (39229, 50, 14327, 0, 178, 166, 119);
INSERT INTO public.who_global_data VALUES (39230, 32, 5414, 0, 168, 166, 168);
INSERT INTO public.who_global_data VALUES (39231, 10, 9267, 0, 125, 166, 99);
INSERT INTO public.who_global_data VALUES (39232, 119, 6779, 0, 26, 166, 171);
INSERT INTO public.who_global_data VALUES (39233, 6, 2705, 0, 125, 166, 87);
INSERT INTO public.who_global_data VALUES (39234, 57, 1668, 0, 10, 166, 123);
INSERT INTO public.who_global_data VALUES (39235, 0, 0, 0, 0, 166, 151);
INSERT INTO public.who_global_data VALUES (39236, 0, 464, 0, 16, 166, 213);
INSERT INTO public.who_global_data VALUES (39237, 11, 6905, 0, 158, 166, 118);
INSERT INTO public.who_global_data VALUES (39238, 0, 346, 0, 10, 166, 134);
INSERT INTO public.who_global_data VALUES (39239, 0, 3237, 0, 39, 166, 65);
INSERT INTO public.who_global_data VALUES (39240, 6482, 556216, 644, 60254, 166, 102);
INSERT INTO public.who_global_data VALUES (39241, 0, 0, 0, 0, 166, 223);
INSERT INTO public.who_global_data VALUES (39242, 3, 114, 0, 1, 166, 4);
INSERT INTO public.who_global_data VALUES (39243, 0, 298, 0, 0, 166, 146);
INSERT INTO public.who_global_data VALUES (39244, 33, 4389, 1, 85, 166, 31);
INSERT INTO public.who_global_data VALUES (39245, 0, 13, 0, 1, 166, 127);
INSERT INTO public.who_global_data VALUES (39246, 1537, 52349, 30, 888, 166, 22);
INSERT INTO public.who_global_data VALUES (39247, 91, 3395, 0, 20, 166, 115);
INSERT INTO public.who_global_data VALUES (39248, 19, 463, 0, 6, 166, 106);
INSERT INTO public.who_global_data VALUES (39249, 316, 5854, 6, 52, 166, 90);
INSERT INTO public.who_global_data VALUES (39250, 0, 0, 0, 0, 166, 70);
INSERT INTO public.who_global_data VALUES (39251, 818, 31935, 3, 149, 166, 46);
INSERT INTO public.who_global_data VALUES (39252, 455, 66481, 0, 6195, 166, 139);
INSERT INTO public.who_global_data VALUES (39253, 0, 23, 0, 0, 166, 42);
INSERT INTO public.who_global_data VALUES (39254, 8, 1332, 0, 22, 166, 80);
INSERT INTO public.who_global_data VALUES (39255, 0, 3540, 0, 133, 166, 203);
INSERT INTO public.who_global_data VALUES (39256, 0, 1172, 0, 69, 166, 136);
INSERT INTO public.who_global_data VALUES (39257, 322, 52227, 5, 1002, 166, 63);
INSERT INTO public.who_global_data VALUES (39258, 0, 0, 0, 0, 166, 17);
INSERT INTO public.who_global_data VALUES (39259, 0, 54, 0, 2, 166, 172);
INSERT INTO public.who_global_data VALUES (39260, 287, 13595, 7, 564, 166, 109);
INSERT INTO public.who_global_data VALUES (39261, 0, 10197, 0, 264, 166, 200);
INSERT INTO public.who_global_data VALUES (39262, 326, 25024, 5, 143, 166, 93);
INSERT INTO public.who_global_data VALUES (39263, 0, 83769, 0, 609, 166, 5);
INSERT INTO public.who_global_data VALUES (39264, 0, 741, 0, 13, 166, 214);
INSERT INTO public.who_global_data VALUES (39265, 496, 293261, 9, 6244, 166, 204);
INSERT INTO public.who_global_data VALUES (39266, 0, 0, 0, 0, 166, 198);
INSERT INTO public.who_global_data VALUES (39267, 1088, 85480, 19, 1878, 166, 173);
INSERT INTO public.who_global_data VALUES (39268, 40, 401, 0, 4, 166, 229);
INSERT INTO public.who_global_data VALUES (39269, 438, 12974, 10, 192, 166, 76);
INSERT INTO public.who_global_data VALUES (39270, 9169, 585236, 208, 27453, 166, 138);
INSERT INTO public.who_global_data VALUES (39271, 2352, 189601, 32, 2998, 166, 98);
INSERT INTO public.who_global_data VALUES (39272, 0, 0, 0, 0, 166, 103);
INSERT INTO public.who_global_data VALUES (39273, 581, 61762, 4, 1955, 166, 225);
INSERT INTO public.who_global_data VALUES (39274, 145, 55597, 2, 1796, 166, 131);
INSERT INTO public.who_global_data VALUES (39275, 319, 29896, 9, 390, 166, 235);
INSERT INTO public.who_global_data VALUES (39276, 243, 117008, 0, 193, 166, 137);
INSERT INTO public.who_global_data VALUES (39277, 266, 17665, 0, 309, 166, 81);
INSERT INTO public.who_global_data VALUES (39278, 406, 33478, 5, 940, 166, 182);
INSERT INTO public.who_global_data VALUES (39279, 92, 1209, 0, 6, 166, 145);
INSERT INTO public.who_global_data VALUES (39280, 981, 78525, 39, 3272, 166, 26);
INSERT INTO public.who_global_data VALUES (39281, 4744, 961493, 65, 16448, 166, 170);
INSERT INTO public.who_global_data VALUES (39282, 200, 3089, 1, 12, 166, 191);
INSERT INTO public.who_global_data VALUES (39283, 0, 5, 0, 0, 166, 221);
INSERT INTO public.who_global_data VALUES (39284, 0, 16, 0, 0, 166, 64);
INSERT INTO public.who_global_data VALUES (39285, 0, 0, 0, 0, 166, 116);
INSERT INTO public.who_global_data VALUES (39286, 0, 17, 0, 0, 166, 128);
INSERT INTO public.who_global_data VALUES (39287, 0, 26, 0, 0, 166, 6);
INSERT INTO public.who_global_data VALUES (39288, 0, 176, 0, 5, 166, 227);
INSERT INTO public.who_global_data VALUES (39289, 0, 5, 0, 0, 166, 68);
INSERT INTO public.who_global_data VALUES (39290, 0, 58, 0, 0, 166, 184);
INSERT INTO public.who_global_data VALUES (39291, 0, 0, 0, 0, 166, 82);
INSERT INTO public.who_global_data VALUES (39292, 0, 726, 0, 42, 166, 149);
INSERT INTO public.who_global_data VALUES (39293, 0, 892, 0, 15, 166, 197);
INSERT INTO public.who_global_data VALUES (39294, 1109, 307479, 30, 3649, 166, 78);
INSERT INTO public.who_global_data VALUES (39295, 99, 12949, 3, 269, 166, 233);
INSERT INTO public.who_global_data VALUES (39296, 109, 30657, 3, 698, 166, 133);
INSERT INTO public.who_global_data VALUES (39297, 0, 127, 0, 0, 166, 35);
INSERT INTO public.who_global_data VALUES (39298, 12, 1992, 0, 69, 166, 114);
INSERT INTO public.who_global_data VALUES (39299, 87, 56353, 0, 27, 166, 237);
INSERT INTO public.who_global_data VALUES (39300, 0, 3, 0, 0, 166, 55);
INSERT INTO public.who_global_data VALUES (39301, 0, 353, 0, 17, 166, 176);
INSERT INTO public.who_global_data VALUES (39302, 40, 3356, 0, 33, 166, 202);
INSERT INTO public.who_global_data VALUES (39303, 14, 2666, 1, 133, 166, 155);
INSERT INTO public.who_global_data VALUES (39304, 0, 0, 0, 0, 166, 32);
INSERT INTO public.who_global_data VALUES (39305, 0, 3269, 0, 93, 166, 220);
INSERT INTO public.who_global_data VALUES (39306, 2728, 609773, 72, 13059, 166, 30);
INSERT INTO public.who_global_data VALUES (39307, 5, 2504, 0, 47, 166, 147);
INSERT INTO public.who_global_data VALUES (39308, 6099, 430923, 42, 30486, 166, 208);
INSERT INTO public.who_global_data VALUES (39309, 6, 2953, 0, 12, 166, 45);
INSERT INTO public.who_global_data VALUES (39310, 71, 12974, 1, 819, 166, 110);
INSERT INTO public.who_global_data VALUES (39311, 109, 3569, 1, 57, 166, 88);
INSERT INTO public.who_global_data VALUES (39312, 160, 82978, 1, 5815, 166, 51);
INSERT INTO public.who_global_data VALUES (39313, 136, 40153, 2, 1755, 166, 209);
INSERT INTO public.who_global_data VALUES (39314, 74, 2217, 4, 89, 166, 205);
INSERT INTO public.who_global_data VALUES (39315, 34, 8311, 0, 66, 166, 18);
INSERT INTO public.who_global_data VALUES (39316, 2, 3397, 0, 58, 166, 72);
INSERT INTO public.who_global_data VALUES (39317, 1041, 325646, 6, 41429, 166, 44);
INSERT INTO public.who_global_data VALUES (39318, 0, 26, 0, 0, 166, 15);
INSERT INTO public.who_global_data VALUES (39319, 65, 1277, 0, 27, 166, 25);
INSERT INTO public.who_global_data VALUES (39320, 0, 0, 0, 0, 166, 179);
INSERT INTO public.who_global_data VALUES (39321, 0, 0, 0, 0, 166, 34);
INSERT INTO public.who_global_data VALUES (39322, 64, 963, 1, 14, 166, 207);
INSERT INTO public.who_global_data VALUES (39323, 75, 2893, 0, 71, 166, 166);
INSERT INTO public.who_global_data VALUES (39324, 7947, 439959, 19, 6121, 166, 126);
INSERT INTO public.who_global_data VALUES (39325, 0, 0, 0, 0, 166, 97);
INSERT INTO public.who_global_data VALUES (39326, 36, 383, 0, 2, 166, 36);
INSERT INTO public.who_global_data VALUES (39327, 0, 0, 0, 0, 166, 125);
INSERT INTO public.who_global_data VALUES (39328, 97, 2263, 0, 20, 166, 124);
INSERT INTO public.who_global_data VALUES (39329, 1799, 106757, 22, 2293, 166, 185);
INSERT INTO public.who_global_data VALUES (39330, 390, 67007, 3, 375, 166, 194);
INSERT INTO public.who_global_data VALUES (39331, 0, 509, 0, 21, 166, 144);
INSERT INTO public.who_global_data VALUES (39332, 44946, 5612163, 997, 175243, 166, 19);
INSERT INTO public.who_global_data VALUES (39333, 28, 960, 0, 10, 166, 217);
INSERT INTO public.who_global_data VALUES (39334, 5, 1521, 0, 42, 166, 148);
INSERT INTO public.who_global_data VALUES (39335, 367, 39065, 6, 275, 166, 86);
INSERT INTO public.who_global_data VALUES (39336, 0, 0, 0, 0, 166, 13);
INSERT INTO public.who_global_data VALUES (39337, 769, 38957, 6, 323, 166, 157);
INSERT INTO public.who_global_data VALUES (39338, 2, 1016, 1, 27, 166, 8);
INSERT INTO public.who_global_data VALUES (39339, 0, 0, 0, 0, 166, 73);
INSERT INTO public.who_global_data VALUES (39340, 4, 1915, 7, 554, 166, 101);
INSERT INTO public.who_global_data VALUES (39341, 455, 11082, 3, 280, 166, 165);
INSERT INTO public.who_global_data VALUES (39342, 37, 5930, 2, 155, 166, 14);
INSERT INTO public.who_global_data VALUES (39343, 59, 38039, 0, 1389, 167, 193);
INSERT INTO public.who_global_data VALUES (39344, 156, 8275, 5, 245, 167, 113);
INSERT INTO public.who_global_data VALUES (39345, 810, 41068, 13, 1424, 167, 143);
INSERT INTO public.who_global_data VALUES (39346, 0, 0, 0, 0, 167, 219);
INSERT INTO public.who_global_data VALUES (39347, 0, 1047, 0, 53, 167, 186);
INSERT INTO public.who_global_data VALUES (39348, 66, 2134, 0, 94, 167, 52);
INSERT INTO public.who_global_data VALUES (39349, 0, 3, 0, 0, 167, 180);
INSERT INTO public.who_global_data VALUES (39350, 0, 94, 0, 3, 167, 167);
INSERT INTO public.who_global_data VALUES (39351, 8159, 329043, 228, 6795, 167, 154);
INSERT INTO public.who_global_data VALUES (39352, 176, 42105, 2, 847, 167, 94);
INSERT INTO public.who_global_data VALUES (39353, 0, 1387, 0, 6, 167, 66);
INSERT INTO public.who_global_data VALUES (39354, 195, 24602, 13, 485, 167, 58);
INSERT INTO public.who_global_data VALUES (39355, 216, 25099, 2, 732, 167, 163);
INSERT INTO public.who_global_data VALUES (39356, 184, 35105, 3, 515, 167, 37);
INSERT INTO public.who_global_data VALUES (39357, 93, 1703, 4, 27, 167, 142);
INSERT INTO public.who_global_data VALUES (39358, 377, 49038, 2, 183, 167, 83);
INSERT INTO public.who_global_data VALUES (39359, 2265, 292625, 46, 3907, 167, 228);
INSERT INTO public.who_global_data VALUES (39360, 0, 157, 0, 7, 167, 188);
INSERT INTO public.who_global_data VALUES (39361, 174, 70285, 5, 637, 167, 62);
INSERT INTO public.who_global_data VALUES (39362, 203, 82260, 5, 9853, 167, 160);
INSERT INTO public.who_global_data VALUES (39363, 43, 648, 0, 5, 167, 50);
INSERT INTO public.who_global_data VALUES (39364, 0, 2115, 0, 39, 167, 33);
INSERT INTO public.who_global_data VALUES (39365, 1, 167, 0, 9, 167, 183);
INSERT INTO public.who_global_data VALUES (39366, 1, 155, 0, 0, 167, 92);
INSERT INTO public.who_global_data VALUES (39367, 1370, 107435, 61, 4366, 167, 158);
INSERT INTO public.who_global_data VALUES (39368, 0, 5, 0, 0, 167, 67);
INSERT INTO public.who_global_data VALUES (39369, 320, 17712, 6, 526, 167, 57);
INSERT INTO public.who_global_data VALUES (39370, 0, 1308, 0, 3, 167, 38);
INSERT INTO public.who_global_data VALUES (39371, 30355, 3532330, 1054, 113358, 167, 141);
INSERT INTO public.who_global_data VALUES (39372, 9, 21, 0, 1, 167, 178);
INSERT INTO public.who_global_data VALUES (39373, 0, 143, 0, 3, 167, 108);
INSERT INTO public.who_global_data VALUES (39374, 96, 15227, 6, 545, 167, 39);
INSERT INTO public.who_global_data VALUES (39375, 0, 1297, 0, 55, 167, 2);
INSERT INTO public.who_global_data VALUES (39376, 1, 430, 0, 1, 167, 195);
INSERT INTO public.who_global_data VALUES (39377, 43, 3455, 0, 37, 167, 107);
INSERT INTO public.who_global_data VALUES (39378, 0, 273, 0, 0, 167, 161);
INSERT INTO public.who_global_data VALUES (39379, 0, 18762, 0, 408, 167, 212);
INSERT INTO public.who_global_data VALUES (39380, 499, 124372, 10, 9064, 167, 181);
INSERT INTO public.who_global_data VALUES (39381, 0, 205, 0, 1, 167, 53);
INSERT INTO public.who_global_data VALUES (39382, 0, 4679, 0, 61, 167, 164);
INSERT INTO public.who_global_data VALUES (39383, 1, 982, 0, 76, 167, 140);
INSERT INTO public.who_global_data VALUES (39384, 1939, 395708, 69, 10792, 167, 20);
INSERT INTO public.who_global_data VALUES (39385, 38, 90141, 1, 4717, 167, 112);
INSERT INTO public.who_global_data VALUES (39386, 8419, 522138, 385, 16568, 167, 111);
INSERT INTO public.who_global_data VALUES (39387, 11, 417, 0, 7, 167, 71);
INSERT INTO public.who_global_data VALUES (39388, 0, 3850, 0, 77, 167, 218);
INSERT INTO public.who_global_data VALUES (39389, 0, 0, 0, 0, 167, 43);
INSERT INTO public.who_global_data VALUES (39390, 1059, 32134, 7, 340, 167, 49);
INSERT INTO public.who_global_data VALUES (39391, 64, 17374, 1, 113, 167, 1);
INSERT INTO public.who_global_data VALUES (39392, 306, 7900, 1, 170, 167, 48);
INSERT INTO public.who_global_data VALUES (39393, 35, 3617, 0, 89, 167, 232);
INSERT INTO public.who_global_data VALUES (39394, 0, 37, 0, 1, 167, 175);
INSERT INTO public.who_global_data VALUES (39395, 11, 1417, 0, 21, 167, 21);
INSERT INTO public.who_global_data VALUES (39396, 239, 21790, 0, 411, 167, 156);
INSERT INTO public.who_global_data VALUES (39397, 0, 0, 0, 0, 167, 95);
INSERT INTO public.who_global_data VALUES (39398, 9, 9810, 3, 251, 167, 177);
INSERT INTO public.who_global_data VALUES (39399, 0, 16127, 0, 621, 167, 210);
INSERT INTO public.who_global_data VALUES (39400, 0, 5382, 0, 60, 167, 120);
INSERT INTO public.who_global_data VALUES (39401, 0, 19, 0, 0, 167, 135);
INSERT INTO public.who_global_data VALUES (39402, 694, 90561, 21, 1554, 167, 206);
INSERT INTO public.who_global_data VALUES (39403, 608, 107089, 29, 6277, 167, 189);
INSERT INTO public.who_global_data VALUES (39404, 89, 97237, 12, 5243, 167, 129);
INSERT INTO public.who_global_data VALUES (39405, 220, 24420, 8, 654, 167, 121);
INSERT INTO public.who_global_data VALUES (39406, 105, 4926, 0, 83, 167, 59);
INSERT INTO public.who_global_data VALUES (39407, 0, 306, 0, 0, 167, 96);
INSERT INTO public.who_global_data VALUES (39408, 21, 2265, 0, 63, 167, 41);
INSERT INTO public.who_global_data VALUES (39409, 61, 4189, 2, 83, 167, 216);
INSERT INTO public.who_global_data VALUES (39410, 1368, 39033, 25, 662, 167, 236);
INSERT INTO public.who_global_data VALUES (39411, 0, 13, 0, 0, 167, 150);
INSERT INTO public.who_global_data VALUES (39412, 0, 384, 0, 0, 167, 61);
INSERT INTO public.who_global_data VALUES (39413, 0, 28, 0, 1, 167, 7);
INSERT INTO public.who_global_data VALUES (39414, 35, 7906, 0, 334, 167, 169);
INSERT INTO public.who_global_data VALUES (39415, 3110, 223419, 8, 30376, 167, 28);
INSERT INTO public.who_global_data VALUES (39416, 20, 8797, 0, 55, 167, 85);
INSERT INTO public.who_global_data VALUES (39417, 0, 298, 0, 0, 167, 211);
INSERT INTO public.who_global_data VALUES (39418, 0, 8388, 0, 53, 167, 60);
INSERT INTO public.who_global_data VALUES (39419, 0, 2437, 0, 84, 167, 3);
INSERT INTO public.who_global_data VALUES (39420, 17, 1411, 0, 17, 167, 11);
INSERT INTO public.who_global_data VALUES (39421, 782, 232864, 2, 9269, 167, 89);
INSERT INTO public.who_global_data VALUES (39422, 0, 43325, 0, 261, 167, 24);
INSERT INTO public.who_global_data VALUES (39423, 0, 229, 0, 0, 167, 162);
INSERT INTO public.who_global_data VALUES (39424, 243, 8381, 2, 240, 167, 100);
INSERT INTO public.who_global_data VALUES (39425, 0, 14, 0, 0, 167, 47);
INSERT INTO public.who_global_data VALUES (39426, 0, 24, 0, 0, 167, 29);
INSERT INTO public.who_global_data VALUES (39427, 261, 771, 0, 15, 167, 40);
INSERT INTO public.who_global_data VALUES (39428, 53, 812, 0, 7, 167, 222);
INSERT INTO public.who_global_data VALUES (39429, 915, 67856, 48, 2580, 167, 132);
INSERT INTO public.who_global_data VALUES (39430, 0, 252, 0, 13, 167, 130);
INSERT INTO public.who_global_data VALUES (39431, 35, 8967, 0, 53, 167, 234);
INSERT INTO public.who_global_data VALUES (39432, 0, 2149, 0, 33, 167, 23);
INSERT INTO public.who_global_data VALUES (39433, 35, 881, 1, 30, 167, 192);
INSERT INTO public.who_global_data VALUES (39434, 34, 8050, 0, 196, 167, 69);
INSERT INTO public.who_global_data VALUES (39435, 0, 12, 0, 0, 167, 187);
INSERT INTO public.who_global_data VALUES (39436, 562, 53381, 13, 1632, 167, 230);
INSERT INTO public.who_global_data VALUES (39437, 35, 5133, 0, 611, 167, 77);
INSERT INTO public.who_global_data VALUES (39438, 8, 2058, 0, 10, 167, 9);
INSERT INTO public.who_global_data VALUES (39439, 69239, 3044940, 912, 56706, 167, 74);
INSERT INTO public.who_global_data VALUES (39440, 2090, 151498, 94, 6594, 167, 224);
INSERT INTO public.who_global_data VALUES (39441, 2028, 356792, 126, 20502, 167, 199);
INSERT INTO public.who_global_data VALUES (39442, 3965, 201050, 70, 6353, 167, 190);
INSERT INTO public.who_global_data VALUES (39443, 153, 27908, 1, 1777, 167, 12);
INSERT INTO public.who_global_data VALUES (39444, 0, 336, 0, 24, 167, 104);
INSERT INTO public.who_global_data VALUES (39445, 1493, 101339, 13, 819, 167, 153);
INSERT INTO public.who_global_data VALUES (39446, 1071, 258136, 3, 35430, 167, 91);
INSERT INTO public.who_global_data VALUES (39447, 56, 1346, 1, 16, 167, 215);
INSERT INTO public.who_global_data VALUES (39448, 1014, 61747, 7, 1176, 167, 84);
INSERT INTO public.who_global_data VALUES (39449, 0, 363, 0, 32, 167, 231);
INSERT INTO public.who_global_data VALUES (39450, 44, 1644, 0, 11, 167, 196);
INSERT INTO public.who_global_data VALUES (39451, 259, 127462, 148, 1781, 167, 105);
INSERT INTO public.who_global_data VALUES (39452, 355, 32118, 10, 542, 167, 122);
INSERT INTO public.who_global_data VALUES (39453, 0, 0, 0, 0, 167, 159);
INSERT INTO public.who_global_data VALUES (39454, 169, 12294, 9, 447, 167, 75);
INSERT INTO public.who_global_data VALUES (39455, 688, 79957, 2, 513, 167, 27);
INSERT INTO public.who_global_data VALUES (39456, 134, 43023, 1, 1056, 167, 54);
INSERT INTO public.who_global_data VALUES (39457, 0, 22, 0, 0, 167, 226);
INSERT INTO public.who_global_data VALUES (39458, 3, 1333, 0, 33, 167, 79);
INSERT INTO public.who_global_data VALUES (39459, 611, 12191, 5, 121, 167, 56);
INSERT INTO public.who_global_data VALUES (39460, 0, 1015, 0, 30, 167, 117);
INSERT INTO public.who_global_data VALUES (39461, 0, 1285, 0, 82, 167, 152);
INSERT INTO public.who_global_data VALUES (39462, 316, 10437, 8, 188, 167, 16);
INSERT INTO public.who_global_data VALUES (39463, 1, 101, 0, 1, 167, 10);
INSERT INTO public.who_global_data VALUES (39464, 41, 2629, 0, 84, 167, 201);
INSERT INTO public.who_global_data VALUES (39465, 0, 7704, 0, 124, 167, 174);
INSERT INTO public.who_global_data VALUES (39466, 59, 14277, 0, 178, 167, 119);
INSERT INTO public.who_global_data VALUES (39467, 60, 5382, 2, 168, 167, 168);
INSERT INTO public.who_global_data VALUES (39468, 8, 9257, 0, 125, 167, 99);
INSERT INTO public.who_global_data VALUES (39469, 96, 6660, 1, 26, 167, 171);
INSERT INTO public.who_global_data VALUES (39470, 11, 2699, 0, 125, 167, 87);
INSERT INTO public.who_global_data VALUES (39471, 35, 1611, 0, 10, 167, 123);
INSERT INTO public.who_global_data VALUES (39472, 0, 0, 0, 0, 167, 151);
INSERT INTO public.who_global_data VALUES (39473, 114, 464, 0, 16, 167, 213);
INSERT INTO public.who_global_data VALUES (39474, 9, 6894, 0, 158, 167, 118);
INSERT INTO public.who_global_data VALUES (39475, 0, 346, 0, 10, 167, 134);
INSERT INTO public.who_global_data VALUES (39476, 0, 3237, 0, 39, 167, 65);
INSERT INTO public.who_global_data VALUES (39477, 5928, 549734, 504, 59610, 167, 102);
INSERT INTO public.who_global_data VALUES (39478, 0, 0, 0, 0, 167, 223);
INSERT INTO public.who_global_data VALUES (39479, 2, 111, 0, 1, 167, 4);
INSERT INTO public.who_global_data VALUES (39480, 0, 298, 0, 0, 167, 146);
INSERT INTO public.who_global_data VALUES (39481, 43, 4356, 0, 84, 167, 31);
INSERT INTO public.who_global_data VALUES (39482, 0, 13, 0, 1, 167, 127);
INSERT INTO public.who_global_data VALUES (39483, 1565, 50812, 41, 858, 167, 22);
INSERT INTO public.who_global_data VALUES (39484, 109, 3304, 0, 20, 167, 115);
INSERT INTO public.who_global_data VALUES (39485, 9, 444, 0, 6, 167, 106);
INSERT INTO public.who_global_data VALUES (39486, 311, 5538, 3, 46, 167, 90);
INSERT INTO public.who_global_data VALUES (39487, 0, 0, 0, 0, 167, 70);
INSERT INTO public.who_global_data VALUES (39488, 634, 31117, 9, 146, 167, 46);
INSERT INTO public.who_global_data VALUES (39489, 507, 66026, 5, 6195, 167, 139);
INSERT INTO public.who_global_data VALUES (39490, 0, 23, 0, 0, 167, 42);
INSERT INTO public.who_global_data VALUES (39491, 3, 1324, 0, 22, 167, 80);
INSERT INTO public.who_global_data VALUES (39492, 0, 3540, 0, 133, 167, 203);
INSERT INTO public.who_global_data VALUES (39493, 0, 1172, 0, 69, 167, 136);
INSERT INTO public.who_global_data VALUES (39494, 601, 51905, 1, 997, 167, 63);
INSERT INTO public.who_global_data VALUES (39495, 0, 0, 0, 0, 167, 17);
INSERT INTO public.who_global_data VALUES (39496, 0, 54, 0, 2, 167, 172);
INSERT INTO public.who_global_data VALUES (39497, 0, 13308, 0, 557, 167, 109);
INSERT INTO public.who_global_data VALUES (39498, 0, 10197, 0, 264, 167, 200);
INSERT INTO public.who_global_data VALUES (39499, 311, 24698, 3, 138, 167, 93);
INSERT INTO public.who_global_data VALUES (39500, 0, 83769, 0, 609, 167, 5);
INSERT INTO public.who_global_data VALUES (39501, 0, 741, 0, 13, 167, 214);
INSERT INTO public.who_global_data VALUES (39502, 591, 292765, 4, 6235, 167, 204);
INSERT INTO public.who_global_data VALUES (39503, 0, 0, 0, 0, 167, 198);
INSERT INTO public.who_global_data VALUES (39504, 537, 84392, 15, 1859, 167, 173);
INSERT INTO public.who_global_data VALUES (39505, 0, 361, 0, 4, 167, 229);
INSERT INTO public.who_global_data VALUES (39506, 719, 12536, 12, 182, 167, 76);
INSERT INTO public.who_global_data VALUES (39507, 9008, 576067, 211, 27245, 167, 138);
INSERT INTO public.who_global_data VALUES (39508, 4884, 187249, 26, 2966, 167, 98);
INSERT INTO public.who_global_data VALUES (39509, 0, 0, 0, 0, 167, 103);
INSERT INTO public.who_global_data VALUES (39510, 900, 61181, 13, 1951, 167, 225);
INSERT INTO public.who_global_data VALUES (39511, 241, 55452, 2, 1794, 167, 131);
INSERT INTO public.who_global_data VALUES (39512, 731, 29577, 7, 381, 167, 235);
INSERT INTO public.who_global_data VALUES (39513, 284, 116765, 0, 193, 167, 137);
INSERT INTO public.who_global_data VALUES (39514, 397, 17399, 0, 309, 167, 81);
INSERT INTO public.who_global_data VALUES (39515, 588, 33072, 6, 935, 167, 182);
INSERT INTO public.who_global_data VALUES (39516, 42, 1117, 1, 6, 167, 145);
INSERT INTO public.who_global_data VALUES (39517, 1189, 77544, 37, 3233, 167, 26);
INSERT INTO public.who_global_data VALUES (39518, 4852, 956749, 73, 16383, 167, 170);
INSERT INTO public.who_global_data VALUES (39519, 109, 2889, 0, 11, 167, 191);
INSERT INTO public.who_global_data VALUES (39520, 0, 5, 0, 0, 167, 221);
INSERT INTO public.who_global_data VALUES (39521, 0, 16, 0, 0, 167, 64);
INSERT INTO public.who_global_data VALUES (39522, 0, 0, 0, 0, 167, 116);
INSERT INTO public.who_global_data VALUES (39523, 0, 17, 0, 0, 167, 128);
INSERT INTO public.who_global_data VALUES (39524, 0, 26, 0, 0, 167, 6);
INSERT INTO public.who_global_data VALUES (39525, 55, 176, 0, 5, 167, 227);
INSERT INTO public.who_global_data VALUES (39526, 0, 5, 0, 0, 167, 68);
INSERT INTO public.who_global_data VALUES (39527, 0, 58, 0, 0, 167, 184);
INSERT INTO public.who_global_data VALUES (39528, 0, 0, 0, 0, 167, 82);
INSERT INTO public.who_global_data VALUES (39529, 0, 726, 0, 42, 167, 149);
INSERT INTO public.who_global_data VALUES (39530, 1, 892, 0, 15, 167, 197);
INSERT INTO public.who_global_data VALUES (39531, 1184, 306370, 39, 3619, 167, 78);
INSERT INTO public.who_global_data VALUES (39532, 161, 12850, 4, 266, 167, 233);
INSERT INTO public.who_global_data VALUES (39533, 170, 30548, 3, 695, 167, 133);
INSERT INTO public.who_global_data VALUES (39534, 0, 127, 0, 0, 167, 35);
INSERT INTO public.who_global_data VALUES (39535, 8, 1980, 0, 69, 167, 114);
INSERT INTO public.who_global_data VALUES (39536, 50, 56266, 0, 27, 167, 237);
INSERT INTO public.who_global_data VALUES (39537, 0, 3, 0, 0, 167, 55);
INSERT INTO public.who_global_data VALUES (39538, 0, 353, 0, 17, 167, 176);
INSERT INTO public.who_global_data VALUES (39539, 91, 3316, 0, 33, 167, 202);
INSERT INTO public.who_global_data VALUES (39540, 34, 2652, 0, 132, 167, 155);
INSERT INTO public.who_global_data VALUES (39541, 0, 0, 0, 0, 167, 32);
INSERT INTO public.who_global_data VALUES (39542, 4, 3269, 0, 93, 167, 220);
INSERT INTO public.who_global_data VALUES (39543, 3707, 607045, 144, 12987, 167, 30);
INSERT INTO public.who_global_data VALUES (39544, 2, 2499, 0, 47, 167, 147);
INSERT INTO public.who_global_data VALUES (39545, 10663, 424824, 42, 30444, 167, 208);
INSERT INTO public.who_global_data VALUES (39546, 29, 2947, 1, 12, 167, 45);
INSERT INTO public.who_global_data VALUES (39547, 67, 12903, 3, 818, 167, 110);
INSERT INTO public.who_global_data VALUES (39548, 94, 3460, 1, 56, 167, 88);
INSERT INTO public.who_global_data VALUES (39549, 298, 82818, 5, 5814, 167, 51);
INSERT INTO public.who_global_data VALUES (39550, 192, 40017, 1, 1753, 167, 209);
INSERT INTO public.who_global_data VALUES (39551, 70, 2143, 2, 85, 167, 205);
INSERT INTO public.who_global_data VALUES (39552, 36, 8277, 0, 66, 167, 18);
INSERT INTO public.who_global_data VALUES (39553, 5, 3395, 0, 58, 167, 72);
INSERT INTO public.who_global_data VALUES (39554, 1288, 324605, 18, 41423, 167, 44);
INSERT INTO public.who_global_data VALUES (39555, 0, 26, 0, 0, 167, 15);
INSERT INTO public.who_global_data VALUES (39556, 0, 1212, 0, 27, 167, 25);
INSERT INTO public.who_global_data VALUES (39557, 0, 0, 0, 0, 167, 179);
INSERT INTO public.who_global_data VALUES (39558, 0, 0, 0, 0, 167, 34);
INSERT INTO public.who_global_data VALUES (39559, 93, 899, 1, 13, 167, 207);
INSERT INTO public.who_global_data VALUES (39560, 80, 2818, 3, 71, 167, 166);
INSERT INTO public.who_global_data VALUES (39561, 8039, 432012, 22, 6102, 167, 126);
INSERT INTO public.who_global_data VALUES (39562, 0, 0, 0, 0, 167, 97);
INSERT INTO public.who_global_data VALUES (39563, 13, 347, 0, 2, 167, 36);
INSERT INTO public.who_global_data VALUES (39564, 0, 0, 0, 0, 167, 125);
INSERT INTO public.who_global_data VALUES (39565, 416, 2166, 1, 20, 167, 124);
INSERT INTO public.who_global_data VALUES (39566, 1987, 104958, 27, 2271, 167, 185);
INSERT INTO public.who_global_data VALUES (39567, 424, 66617, 2, 372, 167, 194);
INSERT INTO public.who_global_data VALUES (39568, 0, 509, 0, 21, 167, 144);
INSERT INTO public.who_global_data VALUES (39569, 45960, 5567217, 1148, 174246, 167, 19);
INSERT INTO public.who_global_data VALUES (39570, 0, 932, 0, 10, 167, 217);
INSERT INTO public.who_global_data VALUES (39571, 10, 1516, 1, 42, 167, 148);
INSERT INTO public.who_global_data VALUES (39572, 467, 38698, 7, 269, 167, 86);
INSERT INTO public.who_global_data VALUES (39573, 0, 0, 0, 0, 167, 13);
INSERT INTO public.who_global_data VALUES (39574, 621, 38188, 6, 317, 167, 157);
INSERT INTO public.who_global_data VALUES (39575, 5, 1014, 1, 26, 167, 8);
INSERT INTO public.who_global_data VALUES (39576, 0, 0, 0, 0, 167, 73);
INSERT INTO public.who_global_data VALUES (39577, 1, 1911, 4, 547, 167, 101);
INSERT INTO public.who_global_data VALUES (39578, 0, 10627, 0, 277, 167, 165);
INSERT INTO public.who_global_data VALUES (39579, 78, 5893, 1, 153, 167, 14);
INSERT INTO public.who_global_data VALUES (39580, 38, 37980, 0, 1389, 168, 193);
INSERT INTO public.who_global_data VALUES (39581, 152, 8119, 2, 240, 168, 113);
INSERT INTO public.who_global_data VALUES (39582, 0, 40258, 0, 1411, 168, 143);
INSERT INTO public.who_global_data VALUES (39583, 0, 0, 0, 0, 168, 219);
INSERT INTO public.who_global_data VALUES (39584, 11, 1047, 0, 53, 168, 186);
INSERT INTO public.who_global_data VALUES (39585, 24, 2068, 1, 94, 168, 52);
INSERT INTO public.who_global_data VALUES (39586, 0, 3, 0, 0, 168, 180);
INSERT INTO public.who_global_data VALUES (39587, 0, 94, 0, 3, 168, 167);
INSERT INTO public.who_global_data VALUES (39588, 8225, 320884, 161, 6567, 168, 154);
INSERT INTO public.who_global_data VALUES (39589, 139, 41929, 8, 845, 168, 94);
INSERT INTO public.who_global_data VALUES (39590, 91, 1387, 1, 6, 168, 66);
INSERT INTO public.who_global_data VALUES (39591, 171, 24407, 9, 472, 168, 58);
INSERT INTO public.who_global_data VALUES (39592, 275, 24883, 1, 730, 168, 163);
INSERT INTO public.who_global_data VALUES (39593, 162, 34921, 2, 512, 168, 37);
INSERT INTO public.who_global_data VALUES (39594, 79, 1610, 1, 23, 168, 142);
INSERT INTO public.who_global_data VALUES (39595, 358, 48661, 2, 181, 168, 83);
INSERT INTO public.who_global_data VALUES (39596, 2401, 290360, 39, 3861, 168, 228);
INSERT INTO public.who_global_data VALUES (39597, 2, 157, 0, 7, 168, 188);
INSERT INTO public.who_global_data VALUES (39598, 161, 70111, 5, 632, 168, 62);
INSERT INTO public.who_global_data VALUES (39599, 510, 82057, 3, 9848, 168, 160);
INSERT INTO public.who_global_data VALUES (39600, 52, 605, 0, 5, 168, 50);
INSERT INTO public.who_global_data VALUES (39601, 20, 2115, 0, 39, 168, 33);
INSERT INTO public.who_global_data VALUES (39602, 0, 166, 0, 9, 168, 183);
INSERT INTO public.who_global_data VALUES (39603, 1, 154, 0, 0, 168, 92);
INSERT INTO public.who_global_data VALUES (39604, 1015, 106065, 72, 4305, 168, 158);
INSERT INTO public.who_global_data VALUES (39605, 0, 5, 0, 0, 168, 67);
INSERT INTO public.who_global_data VALUES (39606, 366, 17392, 10, 520, 168, 57);
INSERT INTO public.who_global_data VALUES (39607, 0, 1308, 0, 3, 168, 38);
INSERT INTO public.who_global_data VALUES (39608, 45323, 3501975, 1204, 112304, 168, 141);
INSERT INTO public.who_global_data VALUES (39609, 0, 12, 0, 1, 168, 178);
INSERT INTO public.who_global_data VALUES (39610, 0, 143, 0, 3, 168, 108);
INSERT INTO public.who_global_data VALUES (39611, 169, 15131, 7, 539, 168, 39);
INSERT INTO public.who_global_data VALUES (39612, 5, 1297, 0, 55, 168, 2);
INSERT INTO public.who_global_data VALUES (39613, 3, 429, 0, 1, 168, 195);
INSERT INTO public.who_global_data VALUES (39614, 44, 3412, 0, 37, 168, 107);
INSERT INTO public.who_global_data VALUES (39615, 0, 273, 0, 0, 168, 161);
INSERT INTO public.who_global_data VALUES (39616, 0, 18762, 0, 408, 168, 212);
INSERT INTO public.who_global_data VALUES (39617, 383, 123873, 5, 9054, 168, 181);
INSERT INTO public.who_global_data VALUES (39618, 0, 205, 0, 1, 168, 53);
INSERT INTO public.who_global_data VALUES (39619, 0, 4679, 0, 61, 168, 164);
INSERT INTO public.who_global_data VALUES (39620, 9, 981, 0, 76, 168, 140);
INSERT INTO public.who_global_data VALUES (39621, 1920, 393769, 52, 10723, 168, 20);
INSERT INTO public.who_global_data VALUES (39622, 50, 90103, 0, 4716, 168, 112);
INSERT INTO public.who_global_data VALUES (39623, 11541, 513719, 204, 16183, 168, 111);
INSERT INTO public.who_global_data VALUES (39624, 0, 406, 0, 7, 168, 71);
INSERT INTO public.who_global_data VALUES (39625, 0, 3850, 0, 77, 168, 218);
INSERT INTO public.who_global_data VALUES (39626, 0, 0, 0, 0, 168, 43);
INSERT INTO public.who_global_data VALUES (39627, 666, 31075, 12, 333, 168, 49);
INSERT INTO public.who_global_data VALUES (39628, 61, 17310, 0, 112, 168, 1);
INSERT INTO public.who_global_data VALUES (39629, 265, 7594, 1, 169, 168, 48);
INSERT INTO public.who_global_data VALUES (39630, 17, 3582, 1, 89, 168, 232);
INSERT INTO public.who_global_data VALUES (39631, 2, 37, 0, 1, 168, 175);
INSERT INTO public.who_global_data VALUES (39632, 11, 1406, 0, 21, 168, 21);
INSERT INTO public.who_global_data VALUES (39633, 506, 21551, 5, 411, 168, 156);
INSERT INTO public.who_global_data VALUES (39634, 0, 0, 0, 0, 168, 95);
INSERT INTO public.who_global_data VALUES (39635, 45, 9801, 1, 248, 168, 177);
INSERT INTO public.who_global_data VALUES (39636, 71, 16127, 0, 621, 168, 210);
INSERT INTO public.who_global_data VALUES (39637, 8, 5382, 1, 60, 168, 120);
INSERT INTO public.who_global_data VALUES (39638, 1, 19, 0, 0, 168, 135);
INSERT INTO public.who_global_data VALUES (39639, 1740, 89867, 32, 1533, 168, 206);
INSERT INTO public.who_global_data VALUES (39640, 973, 106481, 48, 6248, 168, 189);
INSERT INTO public.who_global_data VALUES (39641, 123, 97148, 19, 5231, 168, 129);
INSERT INTO public.who_global_data VALUES (39642, 236, 24200, 6, 646, 168, 121);
INSERT INTO public.who_global_data VALUES (39643, 0, 4821, 0, 83, 168, 59);
INSERT INTO public.who_global_data VALUES (39644, 0, 306, 0, 0, 168, 96);
INSERT INTO public.who_global_data VALUES (39645, 17, 2244, 0, 63, 168, 41);
INSERT INTO public.who_global_data VALUES (39646, 18, 4128, 0, 81, 168, 216);
INSERT INTO public.who_global_data VALUES (39647, 1829, 37665, 17, 637, 168, 236);
INSERT INTO public.who_global_data VALUES (39648, 0, 13, 0, 0, 168, 150);
INSERT INTO public.who_global_data VALUES (39649, 1, 384, 0, 0, 168, 61);
INSERT INTO public.who_global_data VALUES (39650, 0, 28, 0, 1, 168, 7);
INSERT INTO public.who_global_data VALUES (39651, 29, 7871, 0, 334, 168, 169);
INSERT INTO public.who_global_data VALUES (39652, 4396, 220309, 22, 30368, 168, 28);
INSERT INTO public.who_global_data VALUES (39653, 34, 8777, 1, 55, 168, 85);
INSERT INTO public.who_global_data VALUES (39654, 46, 298, 0, 0, 168, 211);
INSERT INTO public.who_global_data VALUES (39655, 69, 8388, 0, 53, 168, 60);
INSERT INTO public.who_global_data VALUES (39656, 36, 2437, 3, 84, 168, 3);
INSERT INTO public.who_global_data VALUES (39657, 9, 1394, 0, 17, 168, 11);
INSERT INTO public.who_global_data VALUES (39658, 2034, 232082, 7, 9267, 168, 89);
INSERT INTO public.who_global_data VALUES (39659, 65, 43325, 0, 261, 168, 24);
INSERT INTO public.who_global_data VALUES (39660, 6, 229, 0, 0, 168, 162);
INSERT INTO public.who_global_data VALUES (39661, 204, 8138, 3, 238, 168, 100);
INSERT INTO public.who_global_data VALUES (39662, 0, 14, 0, 0, 168, 47);
INSERT INTO public.who_global_data VALUES (39663, 0, 24, 0, 0, 168, 29);
INSERT INTO public.who_global_data VALUES (39664, 0, 510, 0, 15, 168, 40);
INSERT INTO public.who_global_data VALUES (39665, 63, 759, 1, 7, 168, 222);
INSERT INTO public.who_global_data VALUES (39666, 958, 66941, 26, 2532, 168, 132);
INSERT INTO public.who_global_data VALUES (39667, 0, 252, 0, 13, 168, 130);
INSERT INTO public.who_global_data VALUES (39668, 56, 8932, 0, 53, 168, 234);
INSERT INTO public.who_global_data VALUES (39669, 0, 2149, 0, 33, 168, 23);
INSERT INTO public.who_global_data VALUES (39670, 70, 846, 0, 29, 168, 192);
INSERT INTO public.who_global_data VALUES (39671, 19, 8016, 0, 196, 168, 69);
INSERT INTO public.who_global_data VALUES (39672, 0, 12, 0, 0, 168, 187);
INSERT INTO public.who_global_data VALUES (39673, 523, 52819, 11, 1619, 168, 230);
INSERT INTO public.who_global_data VALUES (39674, 52, 5098, 2, 611, 168, 77);
INSERT INTO public.who_global_data VALUES (39675, 10, 2050, 0, 10, 168, 9);
INSERT INTO public.who_global_data VALUES (39676, 69878, 2975701, 945, 55794, 168, 74);
INSERT INTO public.who_global_data VALUES (39677, 2197, 149408, 82, 6500, 168, 224);
INSERT INTO public.who_global_data VALUES (39678, 2206, 354764, 112, 20376, 168, 199);
INSERT INTO public.who_global_data VALUES (39679, 4288, 197085, 75, 6283, 168, 190);
INSERT INTO public.who_global_data VALUES (39680, 79, 27755, 0, 1776, 168, 12);
INSERT INTO public.who_global_data VALUES (39681, 0, 336, 0, 24, 168, 104);
INSERT INTO public.who_global_data VALUES (39682, 1487, 99846, 12, 806, 168, 153);
INSERT INTO public.who_global_data VALUES (39683, 947, 257065, 9, 35427, 168, 91);
INSERT INTO public.who_global_data VALUES (39684, 98, 1290, 1, 15, 168, 215);
INSERT INTO public.who_global_data VALUES (39685, 1012, 60733, 14, 1169, 168, 84);
INSERT INTO public.who_global_data VALUES (39686, 1, 363, 0, 32, 168, 231);
INSERT INTO public.who_global_data VALUES (39687, 34, 1600, 0, 11, 168, 196);
INSERT INTO public.who_global_data VALUES (39688, 960, 127203, 0, 1633, 168, 105);
INSERT INTO public.who_global_data VALUES (39689, 322, 31763, 16, 532, 168, 122);
INSERT INTO public.who_global_data VALUES (39690, 0, 0, 0, 0, 168, 159);
INSERT INTO public.who_global_data VALUES (39691, 162, 12125, 10, 438, 168, 75);
INSERT INTO public.who_global_data VALUES (39692, 502, 79269, 2, 511, 168, 27);
INSERT INTO public.who_global_data VALUES (39693, 186, 42889, 0, 1055, 168, 54);
INSERT INTO public.who_global_data VALUES (39694, 0, 22, 0, 0, 168, 226);
INSERT INTO public.who_global_data VALUES (39695, 3, 1330, 0, 33, 168, 79);
INSERT INTO public.who_global_data VALUES (39696, 628, 11580, 3, 116, 168, 56);
INSERT INTO public.who_global_data VALUES (39697, 19, 1015, 0, 30, 168, 117);
INSERT INTO public.who_global_data VALUES (39698, 1, 1285, 0, 82, 168, 152);
INSERT INTO public.who_global_data VALUES (39699, 414, 10121, 7, 180, 168, 16);
INSERT INTO public.who_global_data VALUES (39700, 0, 100, 0, 1, 168, 10);
INSERT INTO public.who_global_data VALUES (39701, 30, 2588, 2, 84, 168, 201);
INSERT INTO public.who_global_data VALUES (39702, 67, 7704, 0, 124, 168, 174);
INSERT INTO public.who_global_data VALUES (39703, 64, 14218, 1, 178, 168, 119);
INSERT INTO public.who_global_data VALUES (39704, 40, 5322, 1, 166, 168, 168);
INSERT INTO public.who_global_data VALUES (39705, 9, 9249, 0, 125, 168, 99);
INSERT INTO public.who_global_data VALUES (39706, 194, 6564, 1, 25, 168, 171);
INSERT INTO public.who_global_data VALUES (39707, 21, 2688, 0, 125, 168, 87);
INSERT INTO public.who_global_data VALUES (39708, 31, 1576, 1, 10, 168, 123);
INSERT INTO public.who_global_data VALUES (39709, 0, 0, 0, 0, 168, 151);
INSERT INTO public.who_global_data VALUES (39710, 0, 350, 0, 16, 168, 213);
INSERT INTO public.who_global_data VALUES (39711, 37, 6885, 0, 158, 168, 118);
INSERT INTO public.who_global_data VALUES (39712, 0, 346, 0, 10, 168, 134);
INSERT INTO public.who_global_data VALUES (39713, 77, 3237, 0, 39, 168, 65);
INSERT INTO public.who_global_data VALUES (39714, 6775, 543806, 625, 59106, 168, 102);
INSERT INTO public.who_global_data VALUES (39715, 0, 0, 0, 0, 168, 223);
INSERT INTO public.who_global_data VALUES (39716, 4, 109, 0, 1, 168, 4);
INSERT INTO public.who_global_data VALUES (39717, 0, 298, 0, 0, 168, 146);
INSERT INTO public.who_global_data VALUES (39718, 25, 4313, 2, 84, 168, 31);
INSERT INTO public.who_global_data VALUES (39719, 0, 13, 0, 1, 168, 127);
INSERT INTO public.who_global_data VALUES (39720, 1609, 49247, 42, 817, 168, 22);
INSERT INTO public.who_global_data VALUES (39721, 80, 3195, 0, 20, 168, 115);
INSERT INTO public.who_global_data VALUES (39722, 26, 435, 0, 6, 168, 106);
INSERT INTO public.who_global_data VALUES (39723, 315, 5227, 1, 43, 168, 90);
INSERT INTO public.who_global_data VALUES (39724, 0, 0, 0, 0, 168, 70);
INSERT INTO public.who_global_data VALUES (39725, 838, 30483, 11, 137, 168, 46);
INSERT INTO public.who_global_data VALUES (39726, 533, 65519, 1, 6190, 168, 139);
INSERT INTO public.who_global_data VALUES (39727, 0, 23, 0, 0, 168, 42);
INSERT INTO public.who_global_data VALUES (39728, 6, 1321, 0, 22, 168, 80);
INSERT INTO public.who_global_data VALUES (39729, 0, 3540, 0, 133, 168, 203);
INSERT INTO public.who_global_data VALUES (39730, 3, 1172, 0, 69, 168, 136);
INSERT INTO public.who_global_data VALUES (39731, 340, 51304, 4, 996, 168, 63);
INSERT INTO public.who_global_data VALUES (39732, 0, 0, 0, 0, 168, 17);
INSERT INTO public.who_global_data VALUES (39733, 0, 54, 0, 2, 168, 172);
INSERT INTO public.who_global_data VALUES (39734, 114, 13308, 3, 557, 168, 109);
INSERT INTO public.who_global_data VALUES (39735, 35, 10197, 0, 264, 168, 200);
INSERT INTO public.who_global_data VALUES (39736, 457, 24387, 4, 135, 168, 93);
INSERT INTO public.who_global_data VALUES (39737, 0, 83769, 0, 609, 168, 5);
INSERT INTO public.who_global_data VALUES (39738, 0, 741, 0, 13, 168, 214);
INSERT INTO public.who_global_data VALUES (39739, 586, 292174, 12, 6231, 168, 204);
INSERT INTO public.who_global_data VALUES (39740, 0, 0, 0, 0, 168, 198);
INSERT INTO public.who_global_data VALUES (39741, 101, 83855, 17, 1844, 168, 173);
INSERT INTO public.who_global_data VALUES (39742, 0, 361, 0, 4, 168, 229);
INSERT INTO public.who_global_data VALUES (39743, 684, 11817, 5, 170, 168, 76);
INSERT INTO public.who_global_data VALUES (39744, 8639, 567059, 200, 27034, 168, 138);
INSERT INTO public.who_global_data VALUES (39745, 4343, 182365, 57, 2940, 168, 98);
INSERT INTO public.who_global_data VALUES (39746, 0, 0, 0, 0, 168, 103);
INSERT INTO public.who_global_data VALUES (39747, 903, 60281, 13, 1938, 168, 225);
INSERT INTO public.who_global_data VALUES (39748, 219, 55211, 4, 1792, 168, 131);
INSERT INTO public.who_global_data VALUES (39749, 703, 28846, 7, 374, 168, 235);
INSERT INTO public.who_global_data VALUES (39750, 257, 116481, 0, 193, 168, 137);
INSERT INTO public.who_global_data VALUES (39751, 332, 17002, 0, 309, 168, 81);
INSERT INTO public.who_global_data VALUES (39752, 547, 32484, 8, 929, 168, 182);
INSERT INTO public.who_global_data VALUES (39753, 79, 1075, 0, 5, 168, 145);
INSERT INTO public.who_global_data VALUES (39754, 1392, 76355, 42, 3196, 168, 26);
INSERT INTO public.who_global_data VALUES (39755, 4921, 951897, 121, 16310, 168, 170);
INSERT INTO public.who_global_data VALUES (39756, 63, 2780, 0, 11, 168, 191);
INSERT INTO public.who_global_data VALUES (39757, 0, 5, 0, 0, 168, 221);
INSERT INTO public.who_global_data VALUES (39758, 0, 16, 0, 0, 168, 64);
INSERT INTO public.who_global_data VALUES (39759, 0, 0, 0, 0, 168, 116);
INSERT INTO public.who_global_data VALUES (39760, 0, 17, 0, 0, 168, 128);
INSERT INTO public.who_global_data VALUES (39761, 0, 26, 0, 0, 168, 6);
INSERT INTO public.who_global_data VALUES (39762, 0, 121, 0, 5, 168, 227);
INSERT INTO public.who_global_data VALUES (39763, 0, 5, 0, 0, 168, 68);
INSERT INTO public.who_global_data VALUES (39764, 0, 58, 0, 0, 168, 184);
INSERT INTO public.who_global_data VALUES (39765, 0, 0, 0, 0, 168, 82);
INSERT INTO public.who_global_data VALUES (39766, 0, 726, 0, 42, 168, 149);
INSERT INTO public.who_global_data VALUES (39767, 3, 891, 0, 15, 168, 197);
INSERT INTO public.who_global_data VALUES (39768, 1213, 305186, 32, 3580, 168, 78);
INSERT INTO public.who_global_data VALUES (39769, 130, 12689, 1, 262, 168, 233);
INSERT INTO public.who_global_data VALUES (39770, 169, 30378, 3, 692, 168, 133);
INSERT INTO public.who_global_data VALUES (39771, 0, 127, 0, 0, 168, 35);
INSERT INTO public.who_global_data VALUES (39772, 3, 1972, 0, 69, 168, 114);
INSERT INTO public.who_global_data VALUES (39773, 117, 56216, 0, 27, 168, 237);
INSERT INTO public.who_global_data VALUES (39774, 0, 3, 0, 0, 168, 55);
INSERT INTO public.who_global_data VALUES (39775, 5, 353, 0, 17, 168, 176);
INSERT INTO public.who_global_data VALUES (39776, 123, 3225, 0, 33, 168, 202);
INSERT INTO public.who_global_data VALUES (39777, 43, 2618, 0, 132, 168, 155);
INSERT INTO public.who_global_data VALUES (39778, 0, 0, 0, 0, 168, 32);
INSERT INTO public.who_global_data VALUES (39779, 0, 3265, 0, 93, 168, 220);
INSERT INTO public.who_global_data VALUES (39780, 3398, 603338, 225, 12843, 168, 30);
INSERT INTO public.who_global_data VALUES (39781, 0, 2497, 0, 47, 168, 147);
INSERT INTO public.who_global_data VALUES (39782, 9205, 414161, 37, 30402, 168, 208);
INSERT INTO public.who_global_data VALUES (39783, 0, 2918, 0, 11, 168, 45);
INSERT INTO public.who_global_data VALUES (39784, 154, 12836, 0, 815, 168, 110);
INSERT INTO public.who_global_data VALUES (39785, 71, 3366, 1, 55, 168, 88);
INSERT INTO public.who_global_data VALUES (39786, 333, 82520, 2, 5809, 168, 51);
INSERT INTO public.who_global_data VALUES (39787, 314, 39825, 1, 1752, 168, 209);
INSERT INTO public.who_global_data VALUES (39788, 65, 2073, 1, 83, 168, 205);
INSERT INTO public.who_global_data VALUES (39789, 38, 8241, 0, 66, 168, 18);
INSERT INTO public.who_global_data VALUES (39790, 0, 3390, 0, 58, 168, 72);
INSERT INTO public.who_global_data VALUES (39791, 1033, 323317, 2, 41405, 168, 44);
INSERT INTO public.who_global_data VALUES (39792, 0, 26, 0, 0, 168, 15);
INSERT INTO public.who_global_data VALUES (39793, 22, 1212, 0, 27, 168, 25);
INSERT INTO public.who_global_data VALUES (39794, 0, 0, 0, 0, 168, 179);
INSERT INTO public.who_global_data VALUES (39795, 0, 0, 0, 0, 168, 34);
INSERT INTO public.who_global_data VALUES (39796, 76, 806, 0, 12, 168, 207);
INSERT INTO public.who_global_data VALUES (39797, 131, 2738, 5, 68, 168, 166);
INSERT INTO public.who_global_data VALUES (39798, 7933, 423973, 22, 6080, 168, 126);
INSERT INTO public.who_global_data VALUES (39799, 0, 0, 0, 0, 168, 97);
INSERT INTO public.who_global_data VALUES (39800, 7, 334, 0, 2, 168, 36);
INSERT INTO public.who_global_data VALUES (39801, 0, 0, 0, 0, 168, 125);
INSERT INTO public.who_global_data VALUES (39802, 0, 1750, 0, 19, 168, 124);
INSERT INTO public.who_global_data VALUES (39803, 2328, 102971, 37, 2244, 168, 185);
INSERT INTO public.who_global_data VALUES (39804, 391, 66193, 1, 370, 168, 194);
INSERT INTO public.who_global_data VALUES (39805, 0, 509, 0, 21, 168, 144);
INSERT INTO public.who_global_data VALUES (39806, 43952, 5521257, 1065, 173098, 168, 19);
INSERT INTO public.who_global_data VALUES (39807, 63, 932, 0, 10, 168, 217);
INSERT INTO public.who_global_data VALUES (39808, 13, 1506, 1, 41, 168, 148);
INSERT INTO public.who_global_data VALUES (39809, 406, 38231, 6, 262, 168, 86);
INSERT INTO public.who_global_data VALUES (39810, 0, 0, 0, 0, 168, 13);
INSERT INTO public.who_global_data VALUES (39811, 699, 37567, 8, 311, 168, 157);
INSERT INTO public.who_global_data VALUES (39812, 2, 1009, 0, 25, 168, 8);
INSERT INTO public.who_global_data VALUES (39813, 0, 0, 0, 0, 168, 73);
INSERT INTO public.who_global_data VALUES (39814, 7, 1910, 1, 543, 168, 101);
INSERT INTO public.who_global_data VALUES (39815, 255, 10627, 3, 277, 168, 165);
INSERT INTO public.who_global_data VALUES (39816, 70, 5815, 1, 152, 168, 14);
INSERT INTO public.who_global_data VALUES (39817, 97, 37942, 2, 1389, 169, 193);
INSERT INTO public.who_global_data VALUES (39818, 155, 7967, 4, 238, 169, 113);
INSERT INTO public.who_global_data VALUES (39819, 411, 40258, 9, 1411, 169, 143);
INSERT INTO public.who_global_data VALUES (39820, 0, 0, 0, 0, 169, 219);
INSERT INTO public.who_global_data VALUES (39821, 12, 1036, 0, 53, 169, 186);
INSERT INTO public.who_global_data VALUES (39822, 29, 2044, 1, 93, 169, 52);
INSERT INTO public.who_global_data VALUES (39823, 0, 3, 0, 0, 169, 180);
INSERT INTO public.who_global_data VALUES (39824, 0, 94, 0, 3, 169, 167);
INSERT INTO public.who_global_data VALUES (39825, 6693, 312659, 292, 6406, 169, 154);
INSERT INTO public.who_global_data VALUES (39826, 158, 41790, 6, 837, 169, 94);
INSERT INTO public.who_global_data VALUES (39827, 91, 1296, 1, 5, 169, 66);
INSERT INTO public.who_global_data VALUES (39828, 243, 24236, 13, 463, 169, 58);
INSERT INTO public.who_global_data VALUES (39829, 308, 24608, 0, 729, 169, 163);
INSERT INTO public.who_global_data VALUES (39830, 139, 34759, 0, 510, 169, 37);
INSERT INTO public.who_global_data VALUES (39831, 107, 1531, 2, 22, 169, 142);
INSERT INTO public.who_global_data VALUES (39832, 353, 48303, 1, 179, 169, 83);
INSERT INTO public.who_global_data VALUES (39833, 2868, 287959, 41, 3822, 169, 228);
INSERT INTO public.who_global_data VALUES (39834, 0, 155, 0, 7, 169, 188);
INSERT INTO public.who_global_data VALUES (39835, 149, 69950, 5, 627, 169, 62);
INSERT INTO public.who_global_data VALUES (39836, 581, 81547, 4, 9845, 169, 160);
INSERT INTO public.who_global_data VALUES (39837, 0, 553, 1, 5, 169, 50);
INSERT INTO public.who_global_data VALUES (39838, 0, 2095, 0, 39, 169, 33);
INSERT INTO public.who_global_data VALUES (39839, 0, 166, 0, 9, 169, 183);
INSERT INTO public.who_global_data VALUES (39840, 3, 153, 0, 0, 169, 92);
INSERT INTO public.who_global_data VALUES (39841, 2031, 105050, 61, 4233, 169, 158);
INSERT INTO public.who_global_data VALUES (39842, 0, 5, 0, 0, 169, 67);
INSERT INTO public.who_global_data VALUES (39843, 335, 17026, 8, 510, 169, 57);
INSERT INTO public.who_global_data VALUES (39844, 0, 1308, 0, 3, 169, 38);
INSERT INTO public.who_global_data VALUES (39845, 49298, 3456652, 1212, 111100, 169, 141);
INSERT INTO public.who_global_data VALUES (39846, 1, 12, 0, 1, 169, 178);
INSERT INTO public.who_global_data VALUES (39847, 0, 143, 0, 3, 169, 108);
INSERT INTO public.who_global_data VALUES (39848, 142, 14962, 5, 532, 169, 39);
INSERT INTO public.who_global_data VALUES (39849, 7, 1292, 0, 55, 169, 2);
INSERT INTO public.who_global_data VALUES (39850, 4, 426, 0, 1, 169, 195);
INSERT INTO public.who_global_data VALUES (39851, 47, 3368, 1, 37, 169, 107);
INSERT INTO public.who_global_data VALUES (39852, 0, 273, 0, 0, 169, 161);
INSERT INTO public.who_global_data VALUES (39853, 0, 18762, 0, 408, 169, 212);
INSERT INTO public.who_global_data VALUES (39854, 336, 123490, 4, 9049, 169, 181);
INSERT INTO public.who_global_data VALUES (39855, 2, 205, 0, 1, 169, 53);
INSERT INTO public.who_global_data VALUES (39856, 0, 4679, 0, 61, 169, 164);
INSERT INTO public.who_global_data VALUES (39857, 1, 972, 0, 76, 169, 140);
INSERT INTO public.who_global_data VALUES (39858, 1812, 391849, 93, 10671, 169, 20);
INSERT INTO public.who_global_data VALUES (39859, 40, 90053, 3, 4716, 169, 112);
INSERT INTO public.who_global_data VALUES (39860, 13056, 502178, 360, 15979, 169, 111);
INSERT INTO public.who_global_data VALUES (39861, 0, 406, 0, 7, 169, 71);
INSERT INTO public.who_global_data VALUES (39862, 0, 3850, 0, 77, 169, 218);
INSERT INTO public.who_global_data VALUES (39863, 0, 0, 0, 0, 169, 43);
INSERT INTO public.who_global_data VALUES (39864, 766, 30409, 7, 321, 169, 49);
INSERT INTO public.who_global_data VALUES (39865, 17, 17249, 1, 112, 169, 1);
INSERT INTO public.who_global_data VALUES (39866, 255, 7329, 0, 168, 169, 48);
INSERT INTO public.who_global_data VALUES (39867, 83, 3565, 0, 88, 169, 232);
INSERT INTO public.who_global_data VALUES (39868, 0, 35, 0, 1, 169, 175);
INSERT INTO public.who_global_data VALUES (39869, 10, 1395, 0, 21, 169, 21);
INSERT INTO public.who_global_data VALUES (39870, 247, 21045, 2, 406, 169, 156);
INSERT INTO public.who_global_data VALUES (39871, 0, 0, 0, 0, 169, 95);
INSERT INTO public.who_global_data VALUES (39872, 16, 9756, 1, 247, 169, 177);
INSERT INTO public.who_global_data VALUES (39873, 116, 16056, 0, 621, 169, 210);
INSERT INTO public.who_global_data VALUES (39874, 0, 5374, 0, 59, 169, 120);
INSERT INTO public.who_global_data VALUES (39875, 0, 18, 0, 0, 169, 135);
INSERT INTO public.who_global_data VALUES (39876, 0, 88127, 0, 1501, 169, 206);
INSERT INTO public.who_global_data VALUES (39877, 1033, 105508, 54, 6200, 169, 189);
INSERT INTO public.who_global_data VALUES (39878, 111, 97025, 15, 5212, 169, 129);
INSERT INTO public.who_global_data VALUES (39879, 247, 23964, 7, 640, 169, 121);
INSERT INTO public.who_global_data VALUES (39880, 0, 4821, 0, 83, 169, 59);
INSERT INTO public.who_global_data VALUES (39881, 2, 306, 0, 0, 169, 96);
INSERT INTO public.who_global_data VALUES (39882, 20, 2227, 0, 63, 169, 41);
INSERT INTO public.who_global_data VALUES (39883, 52, 4110, 2, 81, 169, 216);
INSERT INTO public.who_global_data VALUES (39884, 1778, 35836, 20, 620, 169, 236);
INSERT INTO public.who_global_data VALUES (39885, 0, 13, 0, 0, 169, 150);
INSERT INTO public.who_global_data VALUES (39886, 1, 383, 0, 0, 169, 61);
INSERT INTO public.who_global_data VALUES (39887, 0, 28, 0, 1, 169, 7);
INSERT INTO public.who_global_data VALUES (39888, 37, 7842, 0, 334, 169, 169);
INSERT INTO public.who_global_data VALUES (39889, 4688, 215913, 12, 30346, 169, 28);
INSERT INTO public.who_global_data VALUES (39890, 32, 8743, 0, 54, 169, 85);
INSERT INTO public.who_global_data VALUES (39891, 20, 252, 0, 0, 169, 211);
INSERT INTO public.who_global_data VALUES (39892, 0, 8319, 0, 53, 169, 60);
INSERT INTO public.who_global_data VALUES (39893, 113, 2401, 4, 81, 169, 3);
INSERT INTO public.who_global_data VALUES (39894, 15, 1385, 0, 17, 169, 11);
INSERT INTO public.who_global_data VALUES (39895, 1427, 230048, 7, 9260, 169, 89);
INSERT INTO public.who_global_data VALUES (39896, 166, 43260, 5, 261, 169, 24);
INSERT INTO public.who_global_data VALUES (39897, 1, 223, 0, 0, 169, 162);
INSERT INTO public.who_global_data VALUES (39898, 250, 7934, 0, 235, 169, 100);
INSERT INTO public.who_global_data VALUES (39899, 0, 14, 0, 0, 169, 47);
INSERT INTO public.who_global_data VALUES (39900, 0, 24, 0, 0, 169, 29);
INSERT INTO public.who_global_data VALUES (39901, 0, 510, 0, 15, 169, 40);
INSERT INTO public.who_global_data VALUES (39902, 105, 696, 1, 6, 169, 222);
INSERT INTO public.who_global_data VALUES (39903, 1102, 65983, 39, 2506, 169, 132);
INSERT INTO public.who_global_data VALUES (39904, 0, 252, 0, 13, 169, 130);
INSERT INTO public.who_global_data VALUES (39905, 84, 8876, 0, 53, 169, 234);
INSERT INTO public.who_global_data VALUES (39906, 0, 2149, 0, 33, 169, 23);
INSERT INTO public.who_global_data VALUES (39907, 39, 776, 3, 29, 169, 192);
INSERT INTO public.who_global_data VALUES (39908, 48, 7997, 0, 196, 169, 69);
INSERT INTO public.who_global_data VALUES (39909, 0, 12, 0, 0, 169, 187);
INSERT INTO public.who_global_data VALUES (39910, 626, 52296, 15, 1608, 169, 230);
INSERT INTO public.who_global_data VALUES (39911, 44, 5046, 0, 609, 169, 77);
INSERT INTO public.who_global_data VALUES (39912, 5, 2040, 0, 10, 169, 9);
INSERT INTO public.who_global_data VALUES (39913, 68898, 2905823, 983, 54849, 169, 74);
INSERT INTO public.who_global_data VALUES (39914, 2266, 147211, 72, 6418, 169, 224);
INSERT INTO public.who_global_data VALUES (39915, 2279, 352558, 139, 20264, 169, 199);
INSERT INTO public.who_global_data VALUES (39916, 3995, 192797, 87, 6208, 169, 190);
INSERT INTO public.who_global_data VALUES (39917, 129, 27676, 1, 1776, 169, 12);
INSERT INTO public.who_global_data VALUES (39918, 0, 336, 0, 24, 169, 104);
INSERT INTO public.who_global_data VALUES (39919, 1640, 98359, 12, 794, 169, 153);
INSERT INTO public.who_global_data VALUES (39920, 840, 256118, 6, 35418, 169, 91);
INSERT INTO public.who_global_data VALUES (39921, 46, 1192, 0, 14, 169, 215);
INSERT INTO public.who_global_data VALUES (39922, 1220, 59721, 11, 1155, 169, 84);
INSERT INTO public.who_global_data VALUES (39923, 3, 362, 0, 32, 169, 231);
INSERT INTO public.who_global_data VALUES (39924, 16, 1566, 0, 11, 169, 196);
INSERT INTO public.who_global_data VALUES (39925, 908, 126243, 0, 1633, 169, 105);
INSERT INTO public.who_global_data VALUES (39926, 426, 31441, 10, 516, 169, 122);
INSERT INTO public.who_global_data VALUES (39927, 0, 0, 0, 0, 169, 159);
INSERT INTO public.who_global_data VALUES (39928, 158, 11963, 13, 428, 169, 75);
INSERT INTO public.who_global_data VALUES (39929, 622, 78767, 2, 509, 169, 27);
INSERT INTO public.who_global_data VALUES (39930, 196, 42703, 1, 1055, 169, 54);
INSERT INTO public.who_global_data VALUES (39931, 0, 22, 0, 0, 169, 226);
INSERT INTO public.who_global_data VALUES (39932, 1, 1327, 0, 33, 169, 79);
INSERT INTO public.who_global_data VALUES (39933, 605, 10952, 4, 113, 169, 56);
INSERT INTO public.who_global_data VALUES (39934, 0, 996, 0, 30, 169, 117);
INSERT INTO public.who_global_data VALUES (39935, 2, 1284, 0, 82, 169, 152);
INSERT INTO public.who_global_data VALUES (39936, 244, 9707, 4, 173, 169, 16);
INSERT INTO public.who_global_data VALUES (39937, 1, 100, 0, 1, 169, 10);
INSERT INTO public.who_global_data VALUES (39938, 37, 2558, 0, 82, 169, 201);
INSERT INTO public.who_global_data VALUES (39939, 71, 7637, 0, 124, 169, 174);
INSERT INTO public.who_global_data VALUES (39940, 80, 14154, 4, 177, 169, 119);
INSERT INTO public.who_global_data VALUES (39941, 42, 5282, 1, 165, 169, 168);
INSERT INTO public.who_global_data VALUES (39942, 5, 9240, 0, 125, 169, 99);
INSERT INTO public.who_global_data VALUES (39943, 145, 6370, 0, 24, 169, 171);
INSERT INTO public.who_global_data VALUES (39944, 0, 2667, 0, 125, 169, 87);
INSERT INTO public.who_global_data VALUES (39945, 36, 1545, 0, 9, 169, 123);
INSERT INTO public.who_global_data VALUES (39946, 0, 0, 0, 0, 169, 151);
INSERT INTO public.who_global_data VALUES (39947, 0, 350, 0, 16, 169, 213);
INSERT INTO public.who_global_data VALUES (39948, 19, 6848, 0, 158, 169, 118);
INSERT INTO public.who_global_data VALUES (39949, 0, 346, 0, 10, 169, 134);
INSERT INTO public.who_global_data VALUES (39950, 0, 3160, 0, 39, 169, 65);
INSERT INTO public.who_global_data VALUES (39951, 5792, 537031, 707, 58481, 169, 102);
INSERT INTO public.who_global_data VALUES (39952, 0, 0, 0, 0, 169, 223);
INSERT INTO public.who_global_data VALUES (39953, 2, 105, 0, 1, 169, 4);
INSERT INTO public.who_global_data VALUES (39954, 0, 298, 0, 0, 169, 146);
INSERT INTO public.who_global_data VALUES (39955, 41, 4288, 1, 82, 169, 31);
INSERT INTO public.who_global_data VALUES (39956, 0, 13, 0, 1, 169, 127);
INSERT INTO public.who_global_data VALUES (39957, 1325, 47638, 32, 775, 169, 22);
INSERT INTO public.who_global_data VALUES (39958, 70, 3115, 1, 20, 169, 115);
INSERT INTO public.who_global_data VALUES (39959, 13, 409, 0, 6, 169, 106);
INSERT INTO public.who_global_data VALUES (39960, 247, 4912, 3, 42, 169, 90);
INSERT INTO public.who_global_data VALUES (39961, 0, 0, 0, 0, 169, 70);
INSERT INTO public.who_global_data VALUES (39962, 707, 29645, 6, 126, 169, 46);
INSERT INTO public.who_global_data VALUES (39963, 532, 64986, 9, 6189, 169, 139);
INSERT INTO public.who_global_data VALUES (39964, 0, 23, 0, 0, 169, 42);
INSERT INTO public.who_global_data VALUES (39965, 11, 1315, 0, 22, 169, 80);
INSERT INTO public.who_global_data VALUES (39966, 0, 3540, 0, 133, 169, 203);
INSERT INTO public.who_global_data VALUES (39967, 2, 1169, 0, 69, 169, 136);
INSERT INTO public.who_global_data VALUES (39968, 476, 50964, 7, 992, 169, 63);
INSERT INTO public.who_global_data VALUES (39969, 0, 0, 0, 0, 169, 17);
INSERT INTO public.who_global_data VALUES (39970, 0, 54, 0, 2, 169, 172);
INSERT INTO public.who_global_data VALUES (39971, 118, 13194, 3, 554, 169, 109);
INSERT INTO public.who_global_data VALUES (39972, 51, 10162, 2, 264, 169, 200);
INSERT INTO public.who_global_data VALUES (39973, 503, 23930, 4, 131, 169, 93);
INSERT INTO public.who_global_data VALUES (39974, 163, 83769, 6, 609, 169, 5);
INSERT INTO public.who_global_data VALUES (39975, 0, 741, 0, 13, 169, 214);
INSERT INTO public.who_global_data VALUES (39976, 630, 291588, 10, 6219, 169, 204);
INSERT INTO public.who_global_data VALUES (39977, 0, 0, 0, 0, 169, 198);
INSERT INTO public.who_global_data VALUES (39978, 964, 83754, 18, 1827, 169, 173);
INSERT INTO public.who_global_data VALUES (39979, 2, 361, 1, 4, 169, 229);
INSERT INTO public.who_global_data VALUES (39980, 527, 11133, 4, 165, 169, 76);
INSERT INTO public.who_global_data VALUES (39981, 9099, 558420, 176, 26834, 169, 138);
INSERT INTO public.who_global_data VALUES (39982, 4248, 178022, 88, 2883, 169, 98);
INSERT INTO public.who_global_data VALUES (39983, 0, 0, 0, 0, 169, 103);
INSERT INTO public.who_global_data VALUES (39984, 767, 59378, 12, 1925, 169, 225);
INSERT INTO public.who_global_data VALUES (39985, 291, 54992, 2, 1788, 169, 131);
INSERT INTO public.who_global_data VALUES (39986, 209, 28143, 11, 367, 169, 235);
INSERT INTO public.who_global_data VALUES (39987, 268, 116224, 0, 193, 169, 137);
INSERT INTO public.who_global_data VALUES (39988, 324, 16670, 2, 309, 169, 81);
INSERT INTO public.who_global_data VALUES (39989, 522, 31937, 7, 921, 169, 182);
INSERT INTO public.who_global_data VALUES (39990, 51, 996, 0, 5, 169, 145);
INSERT INTO public.who_global_data VALUES (39991, 1346, 74963, 48, 3154, 169, 26);
INSERT INTO public.who_global_data VALUES (39992, 4870, 946976, 90, 16189, 169, 170);
INSERT INTO public.who_global_data VALUES (39993, 73, 2717, 1, 11, 169, 191);
INSERT INTO public.who_global_data VALUES (39994, 0, 5, 0, 0, 169, 221);
INSERT INTO public.who_global_data VALUES (39995, 0, 16, 0, 0, 169, 64);
INSERT INTO public.who_global_data VALUES (39996, 0, 0, 0, 0, 169, 116);
INSERT INTO public.who_global_data VALUES (39997, 0, 17, 0, 0, 169, 128);
INSERT INTO public.who_global_data VALUES (39998, 0, 26, 0, 0, 169, 6);
INSERT INTO public.who_global_data VALUES (39999, 0, 121, 0, 5, 169, 227);
INSERT INTO public.who_global_data VALUES (40000, 0, 5, 0, 0, 169, 68);
INSERT INTO public.who_global_data VALUES (40001, 0, 58, 0, 0, 169, 184);
INSERT INTO public.who_global_data VALUES (40002, 0, 0, 0, 0, 169, 82);
INSERT INTO public.who_global_data VALUES (40003, 7, 726, 0, 42, 169, 149);
INSERT INTO public.who_global_data VALUES (40004, 3, 888, 0, 15, 169, 197);
INSERT INTO public.who_global_data VALUES (40005, 1287, 303973, 42, 3548, 169, 78);
INSERT INTO public.who_global_data VALUES (40006, 113, 12559, 3, 261, 169, 233);
INSERT INTO public.who_global_data VALUES (40007, 161, 30209, 5, 689, 169, 133);
INSERT INTO public.who_global_data VALUES (40008, 0, 127, 0, 0, 169, 35);
INSERT INTO public.who_global_data VALUES (40009, 8, 1969, 0, 69, 169, 114);
INSERT INTO public.who_global_data VALUES (40010, 68, 56099, 0, 27, 169, 237);
INSERT INTO public.who_global_data VALUES (40011, 0, 3, 0, 0, 169, 55);
INSERT INTO public.who_global_data VALUES (40012, 15, 348, 0, 17, 169, 176);
INSERT INTO public.who_global_data VALUES (40013, 80, 3102, 0, 33, 169, 202);
INSERT INTO public.who_global_data VALUES (40014, 38, 2575, 1, 132, 169, 155);
INSERT INTO public.who_global_data VALUES (40015, 0, 0, 0, 0, 169, 32);
INSERT INTO public.who_global_data VALUES (40016, 0, 3265, 0, 93, 169, 220);
INSERT INTO public.who_global_data VALUES (40017, 3880, 599940, 195, 12618, 169, 30);
INSERT INTO public.who_global_data VALUES (40018, 3, 2497, 0, 47, 169, 147);
INSERT INTO public.who_global_data VALUES (40019, 8780, 404956, 45, 30365, 169, 208);
INSERT INTO public.who_global_data VALUES (40020, 16, 2918, 0, 11, 169, 45);
INSERT INTO public.who_global_data VALUES (40021, 59, 12682, 3, 815, 169, 110);
INSERT INTO public.who_global_data VALUES (40022, 79, 3295, 0, 54, 169, 88);
INSERT INTO public.who_global_data VALUES (40023, 351, 82187, 1, 5807, 169, 51);
INSERT INTO public.who_global_data VALUES (40024, 349, 39511, 0, 1751, 169, 209);
INSERT INTO public.who_global_data VALUES (40025, 81, 2008, 4, 82, 169, 205);
INSERT INTO public.who_global_data VALUES (40026, 37, 8203, 1, 66, 169, 18);
INSERT INTO public.who_global_data VALUES (40027, 1, 3390, 0, 58, 169, 72);
INSERT INTO public.who_global_data VALUES (40028, 1182, 322284, 6, 41403, 169, 44);
INSERT INTO public.who_global_data VALUES (40029, 0, 26, 0, 0, 169, 15);
INSERT INTO public.who_global_data VALUES (40030, 17, 1190, 0, 27, 169, 25);
INSERT INTO public.who_global_data VALUES (40031, 0, 0, 0, 0, 169, 179);
INSERT INTO public.who_global_data VALUES (40032, 0, 0, 0, 0, 169, 34);
INSERT INTO public.who_global_data VALUES (40033, 80, 730, 0, 12, 169, 207);
INSERT INTO public.who_global_data VALUES (40034, 64, 2607, 0, 63, 169, 166);
INSERT INTO public.who_global_data VALUES (40035, 8142, 416040, 19, 6058, 169, 126);
INSERT INTO public.who_global_data VALUES (40036, 0, 0, 0, 0, 169, 97);
INSERT INTO public.who_global_data VALUES (40037, 12, 327, 0, 2, 169, 36);
INSERT INTO public.who_global_data VALUES (40038, 0, 0, 0, 0, 169, 125);
INSERT INTO public.who_global_data VALUES (40039, 94, 1750, 3, 19, 169, 124);
INSERT INTO public.who_global_data VALUES (40040, 2106, 100643, 23, 2207, 169, 185);
INSERT INTO public.who_global_data VALUES (40041, 461, 65802, 2, 369, 169, 194);
INSERT INTO public.who_global_data VALUES (40042, 0, 509, 0, 21, 169, 144);
INSERT INTO public.who_global_data VALUES (40043, 46259, 5477305, 1393, 172033, 169, 19);
INSERT INTO public.who_global_data VALUES (40044, 41, 869, 1, 10, 169, 217);
INSERT INTO public.who_global_data VALUES (40045, 8, 1493, 0, 40, 169, 148);
INSERT INTO public.who_global_data VALUES (40046, 459, 37825, 6, 256, 169, 86);
INSERT INTO public.who_global_data VALUES (40047, 0, 0, 0, 0, 169, 13);
INSERT INTO public.who_global_data VALUES (40048, 1171, 36868, 6, 303, 169, 157);
INSERT INTO public.who_global_data VALUES (40049, 14, 1007, 0, 25, 169, 8);
INSERT INTO public.who_global_data VALUES (40050, 0, 0, 0, 0, 169, 73);
INSERT INTO public.who_global_data VALUES (40051, 7, 1903, 2, 542, 169, 101);
INSERT INTO public.who_global_data VALUES (40052, 154, 10372, 5, 274, 169, 165);
INSERT INTO public.who_global_data VALUES (40053, 102, 5745, 1, 151, 169, 14);
INSERT INTO public.who_global_data VALUES (40054, 160, 37845, 8, 1387, 170, 193);
INSERT INTO public.who_global_data VALUES (40055, 158, 7812, 2, 234, 170, 113);
INSERT INTO public.who_global_data VALUES (40056, 822, 39847, 23, 1402, 170, 143);
INSERT INTO public.who_global_data VALUES (40057, 0, 0, 0, 0, 170, 219);
INSERT INTO public.who_global_data VALUES (40058, 12, 1024, 0, 53, 170, 186);
INSERT INTO public.who_global_data VALUES (40059, 49, 2015, 2, 92, 170, 52);
INSERT INTO public.who_global_data VALUES (40060, 0, 3, 0, 0, 170, 180);
INSERT INTO public.who_global_data VALUES (40061, 1, 94, 0, 3, 170, 167);
INSERT INTO public.who_global_data VALUES (40062, 6840, 305966, 237, 6114, 170, 154);
INSERT INTO public.who_global_data VALUES (40063, 263, 41632, 3, 831, 170, 94);
INSERT INTO public.who_global_data VALUES (40064, 84, 1205, 0, 4, 170, 66);
INSERT INTO public.who_global_data VALUES (40065, 220, 23993, 12, 450, 170, 58);
INSERT INTO public.who_global_data VALUES (40066, 425, 24300, 0, 729, 170, 163);
INSERT INTO public.who_global_data VALUES (40067, 146, 34620, 1, 510, 170, 37);
INSERT INTO public.who_global_data VALUES (40068, 95, 1424, 1, 20, 170, 142);
INSERT INTO public.who_global_data VALUES (40069, 369, 47950, 3, 178, 170, 83);
INSERT INTO public.who_global_data VALUES (40070, 2747, 285091, 41, 3781, 170, 228);
INSERT INTO public.who_global_data VALUES (40071, 3, 155, 0, 7, 170, 188);
INSERT INTO public.who_global_data VALUES (40072, 128, 69801, 5, 622, 170, 62);
INSERT INTO public.who_global_data VALUES (40073, 612, 80966, 9, 9841, 170, 160);
INSERT INTO public.who_global_data VALUES (40074, 78, 553, 0, 4, 170, 50);
INSERT INTO public.who_global_data VALUES (40075, 0, 2095, 0, 39, 170, 33);
INSERT INTO public.who_global_data VALUES (40076, 0, 166, 0, 9, 170, 183);
INSERT INTO public.who_global_data VALUES (40077, 3, 150, 0, 0, 170, 92);
INSERT INTO public.who_global_data VALUES (40078, 1796, 103019, 49, 4172, 170, 158);
INSERT INTO public.who_global_data VALUES (40079, 0, 5, 0, 0, 170, 67);
INSERT INTO public.who_global_data VALUES (40080, 344, 16691, 12, 502, 170, 57);
INSERT INTO public.who_global_data VALUES (40081, 0, 1308, 0, 3, 170, 38);
INSERT INTO public.who_global_data VALUES (40082, 47784, 3407354, 1352, 109888, 170, 141);
INSERT INTO public.who_global_data VALUES (40083, 0, 11, 0, 1, 170, 178);
INSERT INTO public.who_global_data VALUES (40084, 1, 143, 0, 3, 170, 108);
INSERT INTO public.who_global_data VALUES (40085, 151, 14820, 8, 527, 170, 39);
INSERT INTO public.who_global_data VALUES (40086, 5, 1285, 0, 55, 170, 2);
INSERT INTO public.who_global_data VALUES (40087, 0, 422, 0, 1, 170, 195);
INSERT INTO public.who_global_data VALUES (40088, 68, 3321, 0, 36, 170, 107);
INSERT INTO public.who_global_data VALUES (40089, 0, 273, 0, 0, 170, 161);
INSERT INTO public.who_global_data VALUES (40090, 138, 18762, 2, 408, 170, 212);
INSERT INTO public.who_global_data VALUES (40091, 282, 123154, 13, 9045, 170, 181);
INSERT INTO public.who_global_data VALUES (40092, 0, 203, 0, 1, 170, 53);
INSERT INTO public.who_global_data VALUES (40093, 0, 4679, 0, 61, 170, 164);
INSERT INTO public.who_global_data VALUES (40094, 1, 971, 0, 76, 170, 140);
INSERT INTO public.who_global_data VALUES (40095, 1182, 390037, 32, 10578, 170, 20);
INSERT INTO public.who_global_data VALUES (40096, 33, 90013, 1, 4713, 170, 112);
INSERT INTO public.who_global_data VALUES (40097, 12462, 489122, 247, 15619, 170, 111);
INSERT INTO public.who_global_data VALUES (40098, 1, 406, 0, 7, 170, 71);
INSERT INTO public.who_global_data VALUES (40099, 0, 3850, 0, 77, 170, 218);
INSERT INTO public.who_global_data VALUES (40100, 0, 0, 0, 0, 170, 43);
INSERT INTO public.who_global_data VALUES (40101, 559, 29643, 10, 314, 170, 49);
INSERT INTO public.who_global_data VALUES (40102, 82, 17232, 1, 111, 170, 1);
INSERT INTO public.who_global_data VALUES (40103, 219, 7074, 2, 168, 170, 48);
INSERT INTO public.who_global_data VALUES (40104, 74, 3482, 0, 88, 170, 232);
INSERT INTO public.who_global_data VALUES (40105, 0, 35, 0, 1, 170, 175);
INSERT INTO public.who_global_data VALUES (40106, 26, 1385, 1, 21, 170, 21);
INSERT INTO public.who_global_data VALUES (40107, 315, 20798, 3, 404, 170, 156);
INSERT INTO public.who_global_data VALUES (40108, 0, 0, 0, 0, 170, 95);
INSERT INTO public.who_global_data VALUES (40109, 20, 9740, 3, 246, 170, 177);
INSERT INTO public.who_global_data VALUES (40110, 85, 15940, 0, 621, 170, 210);
INSERT INTO public.who_global_data VALUES (40111, 0, 5374, 0, 59, 170, 120);
INSERT INTO public.who_global_data VALUES (40112, 0, 18, 0, 0, 170, 135);
INSERT INTO public.who_global_data VALUES (40113, 1004, 88127, 12, 1501, 170, 206);
INSERT INTO public.who_global_data VALUES (40114, 1534, 104475, 41, 6146, 170, 189);
INSERT INTO public.who_global_data VALUES (40115, 161, 96914, 13, 5197, 170, 129);
INSERT INTO public.who_global_data VALUES (40116, 255, 23717, 8, 633, 170, 121);
INSERT INTO public.who_global_data VALUES (40117, 0, 4821, 0, 83, 170, 59);
INSERT INTO public.who_global_data VALUES (40118, 0, 304, 0, 0, 170, 96);
INSERT INTO public.who_global_data VALUES (40119, 7, 2207, 0, 63, 170, 41);
INSERT INTO public.who_global_data VALUES (40120, 69, 4058, 3, 79, 170, 216);
INSERT INTO public.who_global_data VALUES (40121, 1336, 34058, 28, 600, 170, 236);
INSERT INTO public.who_global_data VALUES (40122, 0, 13, 0, 0, 170, 150);
INSERT INTO public.who_global_data VALUES (40123, 9, 382, 0, 0, 170, 61);
INSERT INTO public.who_global_data VALUES (40124, 0, 28, 0, 1, 170, 7);
INSERT INTO public.who_global_data VALUES (40125, 29, 7805, 0, 334, 170, 169);
INSERT INTO public.who_global_data VALUES (40126, 3680, 211225, 16, 30334, 170, 28);
INSERT INTO public.who_global_data VALUES (40127, 54, 8711, 1, 54, 170, 85);
INSERT INTO public.who_global_data VALUES (40128, 21, 232, 0, 0, 170, 211);
INSERT INTO public.who_global_data VALUES (40129, 49, 8319, 0, 53, 170, 60);
INSERT INTO public.who_global_data VALUES (40130, 172, 2288, 14, 77, 170, 3);
INSERT INTO public.who_global_data VALUES (40131, 9, 1370, 0, 17, 170, 11);
INSERT INTO public.who_global_data VALUES (40132, 1707, 228621, 10, 9253, 170, 89);
INSERT INTO public.who_global_data VALUES (40133, 101, 43094, 8, 256, 170, 24);
INSERT INTO public.who_global_data VALUES (40134, 5, 222, 0, 0, 170, 162);
INSERT INTO public.who_global_data VALUES (40135, 212, 7684, 3, 235, 170, 100);
INSERT INTO public.who_global_data VALUES (40136, 0, 14, 0, 0, 170, 47);
INSERT INTO public.who_global_data VALUES (40137, 0, 24, 0, 0, 170, 29);
INSERT INTO public.who_global_data VALUES (40138, 0, 510, 0, 15, 170, 40);
INSERT INTO public.who_global_data VALUES (40139, 22, 591, 0, 5, 170, 222);
INSERT INTO public.who_global_data VALUES (40140, 1034, 64881, 48, 2467, 170, 132);
INSERT INTO public.who_global_data VALUES (40141, 0, 252, 0, 13, 170, 130);
INSERT INTO public.who_global_data VALUES (40142, 77, 8792, 1, 53, 170, 234);
INSERT INTO public.who_global_data VALUES (40143, 32, 2149, 0, 33, 170, 23);
INSERT INTO public.who_global_data VALUES (40144, 28, 737, 3, 26, 170, 192);
INSERT INTO public.who_global_data VALUES (40145, 28, 7949, 0, 196, 170, 69);
INSERT INTO public.who_global_data VALUES (40146, 0, 12, 0, 0, 170, 187);
INSERT INTO public.who_global_data VALUES (40147, 675, 51670, 10, 1593, 170, 230);
INSERT INTO public.who_global_data VALUES (40148, 32, 5002, 0, 609, 170, 77);
INSERT INTO public.who_global_data VALUES (40149, 8, 2035, 0, 10, 170, 9);
INSERT INTO public.who_global_data VALUES (40150, 69652, 2836925, 977, 53866, 170, 74);
INSERT INTO public.who_global_data VALUES (40151, 1902, 144945, 69, 6346, 170, 224);
INSERT INTO public.who_global_data VALUES (40152, 2444, 350279, 153, 20125, 170, 199);
INSERT INTO public.who_global_data VALUES (40153, 4093, 188802, 85, 6121, 170, 190);
INSERT INTO public.who_global_data VALUES (40154, 48, 27547, 0, 1775, 170, 12);
INSERT INTO public.who_global_data VALUES (40155, 0, 336, 0, 24, 170, 104);
INSERT INTO public.who_global_data VALUES (40156, 1649, 96719, 14, 782, 170, 153);
INSERT INTO public.who_global_data VALUES (40157, 642, 255278, 7, 35412, 170, 91);
INSERT INTO public.who_global_data VALUES (40158, 17, 1146, 0, 14, 170, 215);
INSERT INTO public.who_global_data VALUES (40159, 951, 58501, 16, 1144, 170, 84);
INSERT INTO public.who_global_data VALUES (40160, 2, 359, 0, 32, 170, 231);
INSERT INTO public.who_global_data VALUES (40161, 44, 1550, 0, 11, 170, 196);
INSERT INTO public.who_global_data VALUES (40162, 979, 125335, 0, 1633, 170, 105);
INSERT INTO public.who_global_data VALUES (40163, 379, 31015, 19, 506, 170, 122);
INSERT INTO public.who_global_data VALUES (40164, 0, 0, 0, 0, 170, 159);
INSERT INTO public.who_global_data VALUES (40165, 162, 11805, 9, 415, 170, 75);
INSERT INTO public.who_global_data VALUES (40166, 675, 78145, 2, 507, 170, 27);
INSERT INTO public.who_global_data VALUES (40167, 182, 42507, 0, 1054, 170, 54);
INSERT INTO public.who_global_data VALUES (40168, 0, 22, 0, 0, 170, 226);
INSERT INTO public.who_global_data VALUES (40169, 3, 1326, 0, 33, 170, 79);
INSERT INTO public.who_global_data VALUES (40170, 589, 10347, 2, 109, 170, 56);
INSERT INTO public.who_global_data VALUES (40171, 50, 996, 0, 30, 170, 117);
INSERT INTO public.who_global_data VALUES (40172, 5, 1282, 0, 82, 170, 152);
INSERT INTO public.who_global_data VALUES (40173, 395, 9463, 5, 169, 170, 16);
INSERT INTO public.who_global_data VALUES (40174, 0, 99, 0, 1, 170, 10);
INSERT INTO public.who_global_data VALUES (40175, 32, 2521, 1, 82, 170, 201);
INSERT INTO public.who_global_data VALUES (40176, 67, 7566, 0, 124, 170, 174);
INSERT INTO public.who_global_data VALUES (40177, 65, 14074, 0, 173, 170, 119);
INSERT INTO public.who_global_data VALUES (40178, 47, 5240, 1, 164, 170, 168);
INSERT INTO public.who_global_data VALUES (40179, 16, 9235, 0, 125, 170, 99);
INSERT INTO public.who_global_data VALUES (40180, 146, 6225, 0, 24, 170, 171);
INSERT INTO public.who_global_data VALUES (40181, 1, 2667, 0, 125, 170, 87);
INSERT INTO public.who_global_data VALUES (40182, 40, 1509, 0, 9, 170, 123);
INSERT INTO public.who_global_data VALUES (40183, 0, 0, 0, 0, 170, 151);
INSERT INTO public.who_global_data VALUES (40184, 0, 350, 0, 16, 170, 213);
INSERT INTO public.who_global_data VALUES (40185, 40, 6829, 1, 158, 170, 118);
INSERT INTO public.who_global_data VALUES (40186, 0, 346, 0, 10, 170, 134);
INSERT INTO public.who_global_data VALUES (40187, 0, 3160, 0, 39, 170, 65);
INSERT INTO public.who_global_data VALUES (40188, 5506, 531239, 751, 57774, 170, 102);
INSERT INTO public.who_global_data VALUES (40189, 0, 0, 0, 0, 170, 223);
INSERT INTO public.who_global_data VALUES (40190, 0, 103, 0, 1, 170, 4);
INSERT INTO public.who_global_data VALUES (40191, 0, 298, 0, 0, 170, 146);
INSERT INTO public.who_global_data VALUES (40192, 38, 4247, 0, 81, 170, 31);
INSERT INTO public.who_global_data VALUES (40193, 0, 13, 0, 1, 170, 127);
INSERT INTO public.who_global_data VALUES (40194, 1510, 46313, 29, 743, 170, 22);
INSERT INTO public.who_global_data VALUES (40195, 54, 3045, 0, 19, 170, 115);
INSERT INTO public.who_global_data VALUES (40196, 17, 396, 0, 6, 170, 106);
INSERT INTO public.who_global_data VALUES (40197, 201, 4665, 2, 39, 170, 90);
INSERT INTO public.who_global_data VALUES (40198, 0, 0, 0, 0, 170, 70);
INSERT INTO public.who_global_data VALUES (40199, 681, 28938, 6, 120, 170, 46);
INSERT INTO public.who_global_data VALUES (40200, 553, 64454, 6, 6180, 170, 139);
INSERT INTO public.who_global_data VALUES (40201, 0, 23, 0, 0, 170, 42);
INSERT INTO public.who_global_data VALUES (40202, 5, 1304, 0, 22, 170, 80);
INSERT INTO public.who_global_data VALUES (40203, 0, 3540, 0, 133, 170, 203);
INSERT INTO public.who_global_data VALUES (40204, 0, 1167, 0, 69, 170, 136);
INSERT INTO public.who_global_data VALUES (40205, 593, 50488, 4, 985, 170, 63);
INSERT INTO public.who_global_data VALUES (40206, 0, 0, 0, 0, 170, 17);
INSERT INTO public.who_global_data VALUES (40207, 0, 54, 0, 2, 170, 172);
INSERT INTO public.who_global_data VALUES (40208, 106, 13076, 2, 551, 170, 109);
INSERT INTO public.who_global_data VALUES (40209, 51, 10111, 0, 262, 170, 200);
INSERT INTO public.who_global_data VALUES (40210, 424, 23427, 3, 127, 170, 93);
INSERT INTO public.who_global_data VALUES (40211, 188, 83606, 6, 603, 170, 5);
INSERT INTO public.who_global_data VALUES (40212, 0, 741, 0, 13, 170, 214);
INSERT INTO public.who_global_data VALUES (40213, 513, 290958, 8, 6209, 170, 204);
INSERT INTO public.who_global_data VALUES (40214, 0, 0, 0, 0, 170, 198);
INSERT INTO public.who_global_data VALUES (40215, 247, 82790, 21, 1809, 170, 173);
INSERT INTO public.who_global_data VALUES (40216, 12, 359, 0, 3, 170, 229);
INSERT INTO public.who_global_data VALUES (40217, 471, 10606, 16, 161, 170, 76);
INSERT INTO public.who_global_data VALUES (40218, 7828, 549321, 177, 26658, 170, 138);
INSERT INTO public.who_global_data VALUES (40219, 4561, 173774, 108, 2795, 170, 98);
INSERT INTO public.who_global_data VALUES (40220, 0, 0, 0, 0, 170, 103);
INSERT INTO public.who_global_data VALUES (40221, 735, 58611, 17, 1913, 170, 225);
INSERT INTO public.who_global_data VALUES (40222, 253, 54701, 2, 1786, 170, 131);
INSERT INTO public.who_global_data VALUES (40223, 221, 27934, 10, 356, 170, 235);
INSERT INTO public.who_global_data VALUES (40224, 295, 115956, 0, 193, 170, 137);
INSERT INTO public.who_global_data VALUES (40225, 288, 16346, 1, 307, 170, 81);
INSERT INTO public.who_global_data VALUES (40226, 626, 31415, 6, 914, 170, 182);
INSERT INTO public.who_global_data VALUES (40227, 42, 945, 0, 5, 170, 145);
INSERT INTO public.who_global_data VALUES (40228, 1409, 73617, 32, 3106, 170, 26);
INSERT INTO public.who_global_data VALUES (40229, 4785, 942106, 110, 16099, 170, 170);
INSERT INTO public.who_global_data VALUES (40230, 67, 2644, 0, 10, 170, 191);
INSERT INTO public.who_global_data VALUES (40231, 0, 5, 0, 0, 170, 221);
INSERT INTO public.who_global_data VALUES (40232, 0, 16, 0, 0, 170, 64);
INSERT INTO public.who_global_data VALUES (40233, 0, 0, 0, 0, 170, 116);
INSERT INTO public.who_global_data VALUES (40234, 0, 17, 0, 0, 170, 128);
INSERT INTO public.who_global_data VALUES (40235, 0, 26, 0, 0, 170, 6);
INSERT INTO public.who_global_data VALUES (40236, 0, 121, 0, 5, 170, 227);
INSERT INTO public.who_global_data VALUES (40237, 0, 5, 0, 0, 170, 68);
INSERT INTO public.who_global_data VALUES (40238, 0, 58, 0, 0, 170, 184);
INSERT INTO public.who_global_data VALUES (40239, 0, 0, 0, 0, 170, 82);
INSERT INTO public.who_global_data VALUES (40240, 0, 719, 0, 42, 170, 149);
INSERT INTO public.who_global_data VALUES (40241, 0, 885, 0, 15, 170, 197);
INSERT INTO public.who_global_data VALUES (40242, 1363, 302686, 36, 3506, 170, 78);
INSERT INTO public.who_global_data VALUES (40243, 141, 12446, 2, 258, 170, 233);
INSERT INTO public.who_global_data VALUES (40244, 158, 30048, 3, 684, 170, 133);
INSERT INTO public.who_global_data VALUES (40245, 0, 127, 0, 0, 170, 35);
INSERT INTO public.who_global_data VALUES (40246, 2, 1961, 0, 69, 170, 114);
INSERT INTO public.who_global_data VALUES (40247, 93, 56031, 0, 27, 170, 237);
INSERT INTO public.who_global_data VALUES (40248, 0, 3, 0, 0, 170, 55);
INSERT INTO public.who_global_data VALUES (40249, 7, 333, 0, 17, 170, 176);
INSERT INTO public.who_global_data VALUES (40250, 100, 3022, 2, 33, 170, 202);
INSERT INTO public.who_global_data VALUES (40251, 43, 2537, 0, 131, 170, 155);
INSERT INTO public.who_global_data VALUES (40252, 0, 0, 0, 0, 170, 32);
INSERT INTO public.who_global_data VALUES (40253, 8, 3265, 0, 93, 170, 220);
INSERT INTO public.who_global_data VALUES (40254, 3916, 596060, 159, 12423, 170, 30);
INSERT INTO public.who_global_data VALUES (40255, 0, 2494, 0, 47, 170, 147);
INSERT INTO public.who_global_data VALUES (40256, 8620, 396176, 40, 30320, 170, 208);
INSERT INTO public.who_global_data VALUES (40257, 0, 2902, 0, 11, 170, 45);
INSERT INTO public.who_global_data VALUES (40258, 41, 12623, 0, 812, 170, 110);
INSERT INTO public.who_global_data VALUES (40259, 139, 3216, 6, 54, 170, 88);
INSERT INTO public.who_global_data VALUES (40260, 314, 81836, 4, 5806, 170, 51);
INSERT INTO public.who_global_data VALUES (40261, 285, 39162, 0, 1751, 170, 209);
INSERT INTO public.who_global_data VALUES (40262, 83, 1927, 5, 78, 170, 205);
INSERT INTO public.who_global_data VALUES (40263, 35, 8166, 0, 65, 170, 18);
INSERT INTO public.who_global_data VALUES (40264, 7, 3389, 0, 58, 170, 72);
INSERT INTO public.who_global_data VALUES (40265, 812, 321102, 16, 41397, 170, 44);
INSERT INTO public.who_global_data VALUES (40266, 1, 26, 0, 0, 170, 15);
INSERT INTO public.who_global_data VALUES (40267, 19, 1173, 0, 27, 170, 25);
INSERT INTO public.who_global_data VALUES (40268, 0, 0, 0, 0, 170, 179);
INSERT INTO public.who_global_data VALUES (40269, 0, 0, 0, 0, 170, 34);
INSERT INTO public.who_global_data VALUES (40270, 50, 650, 0, 12, 170, 207);
INSERT INTO public.who_global_data VALUES (40271, 116, 2543, 3, 63, 170, 166);
INSERT INTO public.who_global_data VALUES (40272, 8033, 407898, 23, 6039, 170, 126);
INSERT INTO public.who_global_data VALUES (40273, 0, 0, 0, 0, 170, 97);
INSERT INTO public.who_global_data VALUES (40274, 17, 315, 0, 2, 170, 36);
INSERT INTO public.who_global_data VALUES (40275, 0, 0, 0, 0, 170, 125);
INSERT INTO public.who_global_data VALUES (40276, 53, 1656, 1, 16, 170, 124);
INSERT INTO public.who_global_data VALUES (40277, 2134, 98537, 40, 2184, 170, 185);
INSERT INTO public.who_global_data VALUES (40278, 435, 65341, 1, 367, 170, 194);
INSERT INTO public.who_global_data VALUES (40279, 0, 509, 0, 21, 170, 144);
INSERT INTO public.who_global_data VALUES (40280, 37908, 5431046, 1132, 170640, 170, 19);
INSERT INTO public.who_global_data VALUES (40281, 32, 828, 0, 9, 170, 217);
INSERT INTO public.who_global_data VALUES (40282, 28, 1485, 0, 40, 170, 148);
INSERT INTO public.who_global_data VALUES (40283, 606, 37366, 5, 250, 170, 86);
INSERT INTO public.who_global_data VALUES (40284, 0, 0, 0, 0, 170, 13);
INSERT INTO public.who_global_data VALUES (40285, 895, 35697, 9, 297, 170, 157);
INSERT INTO public.who_global_data VALUES (40286, 4, 993, 0, 25, 170, 8);
INSERT INTO public.who_global_data VALUES (40287, 0, 0, 0, 0, 170, 73);
INSERT INTO public.who_global_data VALUES (40288, 3, 1896, 2, 540, 170, 101);
INSERT INTO public.who_global_data VALUES (40289, 237, 10218, 5, 269, 170, 165);
INSERT INTO public.who_global_data VALUES (40290, 265, 5643, 9, 150, 170, 14);
INSERT INTO public.who_global_data VALUES (40291, 0, 37685, 0, 1379, 171, 193);
INSERT INTO public.who_global_data VALUES (40292, 155, 7654, 2, 232, 171, 113);
INSERT INTO public.who_global_data VALUES (40293, 0, 39025, 0, 1379, 171, 143);
INSERT INTO public.who_global_data VALUES (40294, 0, 0, 0, 0, 171, 219);
INSERT INTO public.who_global_data VALUES (40295, 7, 1012, 0, 53, 171, 186);
INSERT INTO public.who_global_data VALUES (40296, 31, 1966, 2, 90, 171, 52);
INSERT INTO public.who_global_data VALUES (40297, 0, 3, 0, 0, 171, 180);
INSERT INTO public.who_global_data VALUES (40298, 0, 93, 0, 3, 171, 167);
INSERT INTO public.who_global_data VALUES (40299, 4557, 299126, 127, 5877, 171, 154);
INSERT INTO public.who_global_data VALUES (40300, 210, 41369, 1, 828, 171, 94);
INSERT INTO public.who_global_data VALUES (40301, 19, 1121, 0, 4, 171, 66);
INSERT INTO public.who_global_data VALUES (40302, 214, 23773, 17, 438, 171, 58);
INSERT INTO public.who_global_data VALUES (40303, 158, 23875, 0, 729, 171, 163);
INSERT INTO public.who_global_data VALUES (40304, 131, 34474, 1, 509, 171, 37);
INSERT INTO public.who_global_data VALUES (40305, 14, 1329, 1, 19, 171, 142);
INSERT INTO public.who_global_data VALUES (40306, 396, 47581, 2, 175, 171, 83);
INSERT INTO public.who_global_data VALUES (40307, 3200, 282344, 46, 3740, 171, 228);
INSERT INTO public.who_global_data VALUES (40308, 0, 152, 0, 7, 171, 188);
INSERT INTO public.who_global_data VALUES (40309, 84, 69673, 4, 617, 171, 62);
INSERT INTO public.who_global_data VALUES (40310, 725, 80354, 11, 9832, 171, 160);
INSERT INTO public.who_global_data VALUES (40311, 23, 475, 1, 4, 171, 50);
INSERT INTO public.who_global_data VALUES (40312, 32, 2095, 0, 39, 171, 33);
INSERT INTO public.who_global_data VALUES (40313, 4, 166, 0, 9, 171, 183);
INSERT INTO public.who_global_data VALUES (40314, 1, 147, 0, 0, 171, 92);
INSERT INTO public.who_global_data VALUES (40315, 879, 101223, 75, 4123, 171, 158);
INSERT INTO public.who_global_data VALUES (40316, 0, 5, 0, 0, 171, 67);
INSERT INTO public.who_global_data VALUES (40317, 210, 16347, 9, 490, 171, 57);
INSERT INTO public.who_global_data VALUES (40318, 0, 1308, 0, 3, 171, 38);
INSERT INTO public.who_global_data VALUES (40319, 19373, 3359570, 684, 108536, 171, 141);
INSERT INTO public.who_global_data VALUES (40320, 2, 11, 0, 1, 171, 178);
INSERT INTO public.who_global_data VALUES (40321, 0, 142, 0, 3, 171, 108);
INSERT INTO public.who_global_data VALUES (40322, 169, 14669, 7, 519, 171, 39);
INSERT INTO public.who_global_data VALUES (40323, 13, 1280, 0, 55, 171, 2);
INSERT INTO public.who_global_data VALUES (40324, 6, 422, 0, 1, 171, 195);
INSERT INTO public.who_global_data VALUES (40325, 50, 3253, 0, 36, 171, 107);
INSERT INTO public.who_global_data VALUES (40326, 0, 273, 0, 0, 171, 161);
INSERT INTO public.who_global_data VALUES (40327, 25, 18624, 0, 406, 171, 212);
INSERT INTO public.who_global_data VALUES (40328, 785, 122872, 6, 9032, 171, 181);
INSERT INTO public.who_global_data VALUES (40329, 0, 203, 0, 1, 171, 53);
INSERT INTO public.who_global_data VALUES (40330, 12, 4679, 0, 61, 171, 164);
INSERT INTO public.who_global_data VALUES (40331, 11, 970, 0, 76, 171, 140);
INSERT INTO public.who_global_data VALUES (40332, 1353, 388855, 33, 10546, 171, 20);
INSERT INTO public.who_global_data VALUES (40333, 54, 89980, 2, 4712, 171, 112);
INSERT INTO public.who_global_data VALUES (40334, 8328, 476660, 275, 15372, 171, 111);
INSERT INTO public.who_global_data VALUES (40335, 0, 405, 0, 7, 171, 71);
INSERT INTO public.who_global_data VALUES (40336, 19, 3850, 1, 77, 171, 218);
INSERT INTO public.who_global_data VALUES (40337, 0, 0, 0, 0, 171, 43);
INSERT INTO public.who_global_data VALUES (40338, 619, 29084, 10, 304, 171, 49);
INSERT INTO public.who_global_data VALUES (40339, 124, 17150, 0, 110, 171, 1);
INSERT INTO public.who_global_data VALUES (40340, 199, 6855, 0, 166, 171, 48);
INSERT INTO public.who_global_data VALUES (40341, 44, 3408, 0, 88, 171, 232);
INSERT INTO public.who_global_data VALUES (40342, 2, 35, 0, 1, 171, 175);
INSERT INTO public.who_global_data VALUES (40343, 8, 1359, 0, 20, 171, 21);
INSERT INTO public.who_global_data VALUES (40344, 281, 20483, 2, 401, 171, 156);
INSERT INTO public.who_global_data VALUES (40345, 0, 0, 0, 0, 171, 95);
INSERT INTO public.who_global_data VALUES (40346, 15, 9720, 0, 243, 171, 177);
INSERT INTO public.who_global_data VALUES (40347, 115, 15855, 0, 621, 171, 210);
INSERT INTO public.who_global_data VALUES (40348, 2, 5374, 0, 59, 171, 120);
INSERT INTO public.who_global_data VALUES (40349, 0, 18, 0, 0, 171, 135);
INSERT INTO public.who_global_data VALUES (40350, 386, 87123, 8, 1489, 171, 206);
INSERT INTO public.who_global_data VALUES (40351, 1190, 102941, 22, 6105, 171, 189);
INSERT INTO public.who_global_data VALUES (40352, 163, 96753, 11, 5184, 171, 129);
INSERT INTO public.who_global_data VALUES (40353, 269, 23462, 7, 625, 171, 121);
INSERT INTO public.who_global_data VALUES (40354, 0, 4821, 0, 83, 171, 59);
INSERT INTO public.who_global_data VALUES (40355, 19, 304, 0, 0, 171, 96);
INSERT INTO public.who_global_data VALUES (40356, 8, 2200, 0, 63, 171, 41);
INSERT INTO public.who_global_data VALUES (40357, 95, 3989, 3, 76, 171, 216);
INSERT INTO public.who_global_data VALUES (40358, 1386, 32722, 28, 572, 171, 236);
INSERT INTO public.who_global_data VALUES (40359, 0, 13, 0, 0, 171, 150);
INSERT INTO public.who_global_data VALUES (40360, 0, 373, 0, 0, 171, 61);
INSERT INTO public.who_global_data VALUES (40361, 0, 28, 0, 1, 171, 7);
INSERT INTO public.who_global_data VALUES (40362, 24, 7776, 0, 334, 171, 169);
INSERT INTO public.who_global_data VALUES (40363, 2165, 207545, 22, 30318, 171, 28);
INSERT INTO public.who_global_data VALUES (40364, 35, 8657, 0, 53, 171, 85);
INSERT INTO public.who_global_data VALUES (40365, 0, 211, 0, 0, 171, 211);
INSERT INTO public.who_global_data VALUES (40366, 0, 8270, 0, 53, 171, 60);
INSERT INTO public.who_global_data VALUES (40367, 244, 2116, 0, 63, 171, 3);
INSERT INTO public.who_global_data VALUES (40368, 10, 1361, 0, 17, 171, 11);
INSERT INTO public.who_global_data VALUES (40369, 1510, 226914, 7, 9243, 171, 89);
INSERT INTO public.who_global_data VALUES (40370, 340, 42993, 9, 248, 171, 24);
INSERT INTO public.who_global_data VALUES (40371, 8, 217, 0, 0, 171, 162);
INSERT INTO public.who_global_data VALUES (40372, 250, 7472, 2, 232, 171, 100);
INSERT INTO public.who_global_data VALUES (40373, 0, 14, 0, 0, 171, 47);
INSERT INTO public.who_global_data VALUES (40374, 0, 24, 0, 0, 171, 29);
INSERT INTO public.who_global_data VALUES (40375, 0, 510, 0, 15, 171, 40);
INSERT INTO public.who_global_data VALUES (40376, 19, 569, 0, 5, 171, 222);
INSERT INTO public.who_global_data VALUES (40377, 903, 63847, 30, 2419, 171, 132);
INSERT INTO public.who_global_data VALUES (40378, 0, 252, 0, 13, 171, 130);
INSERT INTO public.who_global_data VALUES (40379, 95, 8715, 1, 52, 171, 234);
INSERT INTO public.who_global_data VALUES (40380, 0, 2117, 0, 33, 171, 23);
INSERT INTO public.who_global_data VALUES (40381, 0, 709, 0, 23, 171, 192);
INSERT INTO public.who_global_data VALUES (40382, 24, 7921, 0, 196, 171, 69);
INSERT INTO public.who_global_data VALUES (40383, 0, 12, 0, 0, 171, 187);
INSERT INTO public.who_global_data VALUES (40384, 493, 50995, 8, 1583, 171, 230);
INSERT INTO public.who_global_data VALUES (40385, 0, 4970, 0, 609, 171, 77);
INSERT INTO public.who_global_data VALUES (40386, 13, 2027, 0, 10, 171, 9);
INSERT INTO public.who_global_data VALUES (40387, 64531, 2767273, 1092, 52889, 171, 74);
INSERT INTO public.who_global_data VALUES (40388, 1673, 143043, 70, 6277, 171, 224);
INSERT INTO public.who_global_data VALUES (40389, 2385, 347835, 168, 19972, 171, 199);
INSERT INTO public.who_global_data VALUES (40390, 4576, 184709, 82, 6036, 171, 190);
INSERT INTO public.who_global_data VALUES (40391, 186, 27499, 1, 1775, 171, 12);
INSERT INTO public.who_global_data VALUES (40392, 0, 336, 0, 24, 171, 104);
INSERT INTO public.who_global_data VALUES (40393, 1650, 95070, 4, 768, 171, 153);
INSERT INTO public.who_global_data VALUES (40394, 401, 254636, 5, 35405, 171, 91);
INSERT INTO public.who_global_data VALUES (40395, 16, 1129, 0, 14, 171, 215);
INSERT INTO public.who_global_data VALUES (40396, 865, 57550, 13, 1128, 171, 84);
INSERT INTO public.who_global_data VALUES (40397, 1, 357, 1, 32, 171, 231);
INSERT INTO public.who_global_data VALUES (40398, 40, 1506, 0, 11, 171, 196);
INSERT INTO public.who_global_data VALUES (40399, 1031, 124356, 0, 1633, 171, 105);
INSERT INTO public.who_global_data VALUES (40400, 271, 30636, 5, 487, 171, 122);
INSERT INTO public.who_global_data VALUES (40401, 0, 0, 0, 0, 171, 159);
INSERT INTO public.who_global_data VALUES (40402, 141, 11643, 6, 406, 171, 75);
INSERT INTO public.who_global_data VALUES (40403, 643, 77470, 3, 505, 171, 27);
INSERT INTO public.who_global_data VALUES (40404, 179, 42325, 1, 1054, 171, 54);
INSERT INTO public.who_global_data VALUES (40405, 0, 22, 0, 0, 171, 226);
INSERT INTO public.who_global_data VALUES (40406, 0, 1323, 1, 33, 171, 79);
INSERT INTO public.who_global_data VALUES (40407, 421, 9758, 2, 107, 171, 56);
INSERT INTO public.who_global_data VALUES (40408, 0, 946, 0, 30, 171, 117);
INSERT INTO public.who_global_data VALUES (40409, 0, 1277, 0, 82, 171, 152);
INSERT INTO public.who_global_data VALUES (40410, 489, 9068, 7, 164, 171, 16);
INSERT INTO public.who_global_data VALUES (40411, 1, 99, 0, 1, 171, 10);
INSERT INTO public.who_global_data VALUES (40412, 22, 2489, 0, 81, 171, 201);
INSERT INTO public.who_global_data VALUES (40413, 30, 7499, 0, 124, 171, 174);
INSERT INTO public.who_global_data VALUES (40414, 123, 14009, 2, 173, 171, 119);
INSERT INTO public.who_global_data VALUES (40415, 68, 5193, 1, 163, 171, 168);
INSERT INTO public.who_global_data VALUES (40416, 7, 9219, 0, 125, 171, 99);
INSERT INTO public.who_global_data VALUES (40417, 170, 6079, 1, 24, 171, 171);
INSERT INTO public.who_global_data VALUES (40418, 26, 2666, 0, 125, 171, 87);
INSERT INTO public.who_global_data VALUES (40419, 47, 1469, 0, 9, 171, 123);
INSERT INTO public.who_global_data VALUES (40420, 0, 0, 0, 0, 171, 151);
INSERT INTO public.who_global_data VALUES (40421, 0, 350, 0, 16, 171, 213);
INSERT INTO public.who_global_data VALUES (40422, 27, 6789, 0, 157, 171, 118);
INSERT INTO public.who_global_data VALUES (40423, 0, 346, 0, 10, 171, 134);
INSERT INTO public.who_global_data VALUES (40424, 0, 3160, 0, 39, 171, 65);
INSERT INTO public.who_global_data VALUES (40425, 3571, 525733, 266, 57023, 171, 102);
INSERT INTO public.who_global_data VALUES (40426, 0, 0, 0, 0, 171, 223);
INSERT INTO public.who_global_data VALUES (40427, 0, 103, 0, 1, 171, 4);
INSERT INTO public.who_global_data VALUES (40428, 0, 298, 0, 0, 171, 146);
INSERT INTO public.who_global_data VALUES (40429, 58, 4209, 1, 81, 171, 31);
INSERT INTO public.who_global_data VALUES (40430, 0, 13, 0, 1, 171, 127);
INSERT INTO public.who_global_data VALUES (40431, 1245, 44803, 33, 714, 171, 22);
INSERT INTO public.who_global_data VALUES (40432, 77, 2991, 0, 19, 171, 115);
INSERT INTO public.who_global_data VALUES (40433, 4, 379, 0, 6, 171, 106);
INSERT INTO public.who_global_data VALUES (40434, 120, 4464, 1, 37, 171, 90);
INSERT INTO public.who_global_data VALUES (40435, 0, 0, 0, 0, 171, 70);
INSERT INTO public.who_global_data VALUES (40436, 1016, 28257, 7, 114, 171, 46);
INSERT INTO public.who_global_data VALUES (40437, 493, 63901, 3, 6174, 171, 139);
INSERT INTO public.who_global_data VALUES (40438, 0, 23, 0, 0, 171, 42);
INSERT INTO public.who_global_data VALUES (40439, 6, 1299, 0, 22, 171, 80);
INSERT INTO public.who_global_data VALUES (40440, 127, 3540, 5, 133, 171, 203);
INSERT INTO public.who_global_data VALUES (40441, 0, 1167, 0, 69, 171, 136);
INSERT INTO public.who_global_data VALUES (40442, 410, 49895, 4, 981, 171, 63);
INSERT INTO public.who_global_data VALUES (40443, 0, 0, 0, 0, 171, 17);
INSERT INTO public.who_global_data VALUES (40444, 0, 54, 0, 2, 171, 172);
INSERT INTO public.who_global_data VALUES (40445, 130, 12970, 2, 549, 171, 109);
INSERT INTO public.who_global_data VALUES (40446, 56, 10060, 1, 262, 171, 200);
INSERT INTO public.who_global_data VALUES (40447, 612, 23003, 1, 124, 171, 93);
INSERT INTO public.who_global_data VALUES (40448, 192, 83418, 9, 597, 171, 5);
INSERT INTO public.who_global_data VALUES (40449, 0, 741, 0, 13, 171, 214);
INSERT INTO public.who_global_data VALUES (40450, 613, 290445, 11, 6201, 171, 204);
INSERT INTO public.who_global_data VALUES (40451, 0, 0, 0, 0, 171, 198);
INSERT INTO public.who_global_data VALUES (40452, 603, 82543, 21, 1788, 171, 173);
INSERT INTO public.who_global_data VALUES (40453, 14, 347, 0, 3, 171, 229);
INSERT INTO public.who_global_data VALUES (40454, 344, 10135, 7, 145, 171, 76);
INSERT INTO public.who_global_data VALUES (40455, 5547, 541493, 200, 26481, 171, 138);
INSERT INTO public.who_global_data VALUES (40456, 4739, 169213, 6, 2687, 171, 98);
INSERT INTO public.who_global_data VALUES (40457, 0, 0, 0, 0, 171, 103);
INSERT INTO public.who_global_data VALUES (40458, 597, 57876, 11, 1896, 171, 225);
INSERT INTO public.who_global_data VALUES (40459, 214, 54448, 5, 1784, 171, 131);
INSERT INTO public.who_global_data VALUES (40460, 953, 27713, 11, 346, 171, 235);
INSERT INTO public.who_global_data VALUES (40461, 293, 115661, 0, 193, 171, 137);
INSERT INTO public.who_global_data VALUES (40462, 297, 16058, 0, 306, 171, 81);
INSERT INTO public.who_global_data VALUES (40463, 412, 30789, 0, 908, 171, 182);
INSERT INTO public.who_global_data VALUES (40464, 23, 903, 0, 5, 171, 145);
INSERT INTO public.who_global_data VALUES (40465, 1014, 72208, 45, 3074, 171, 26);
INSERT INTO public.who_global_data VALUES (40466, 4828, 937321, 117, 15989, 171, 170);
INSERT INTO public.who_global_data VALUES (40467, 37, 2577, 2, 10, 171, 191);
INSERT INTO public.who_global_data VALUES (40468, 0, 5, 0, 0, 171, 221);
INSERT INTO public.who_global_data VALUES (40469, 3, 16, 0, 0, 171, 64);
INSERT INTO public.who_global_data VALUES (40470, 0, 0, 0, 0, 171, 116);
INSERT INTO public.who_global_data VALUES (40471, 0, 17, 0, 0, 171, 128);
INSERT INTO public.who_global_data VALUES (40472, 1, 26, 0, 0, 171, 6);
INSERT INTO public.who_global_data VALUES (40473, 12, 121, 0, 5, 171, 227);
INSERT INTO public.who_global_data VALUES (40474, 0, 5, 0, 0, 171, 68);
INSERT INTO public.who_global_data VALUES (40475, 1, 58, 0, 0, 171, 184);
INSERT INTO public.who_global_data VALUES (40476, 0, 0, 0, 0, 171, 82);
INSERT INTO public.who_global_data VALUES (40477, 0, 719, 0, 42, 171, 149);
INSERT INTO public.who_global_data VALUES (40478, 0, 885, 0, 15, 171, 197);
INSERT INTO public.who_global_data VALUES (40479, 1409, 301323, 34, 3470, 171, 78);
INSERT INTO public.who_global_data VALUES (40480, 68, 12305, 0, 256, 171, 233);
INSERT INTO public.who_global_data VALUES (40481, 108, 29890, 4, 681, 171, 133);
INSERT INTO public.who_global_data VALUES (40482, 0, 127, 0, 0, 171, 35);
INSERT INTO public.who_global_data VALUES (40483, 3, 1959, 0, 69, 171, 114);
INSERT INTO public.who_global_data VALUES (40484, 100, 55938, 0, 27, 171, 237);
INSERT INTO public.who_global_data VALUES (40485, 0, 3, 0, 0, 171, 55);
INSERT INTO public.who_global_data VALUES (40486, 9, 326, 0, 17, 171, 176);
INSERT INTO public.who_global_data VALUES (40487, 15, 2922, 0, 31, 171, 202);
INSERT INTO public.who_global_data VALUES (40488, 37, 2494, 0, 131, 171, 155);
INSERT INTO public.who_global_data VALUES (40489, 0, 0, 0, 0, 171, 32);
INSERT INTO public.who_global_data VALUES (40490, 0, 3257, 0, 93, 171, 220);
INSERT INTO public.who_global_data VALUES (40491, 2258, 592144, 282, 12264, 171, 30);
INSERT INTO public.who_global_data VALUES (40492, 4, 2494, 0, 47, 171, 147);
INSERT INTO public.who_global_data VALUES (40493, 5095, 387556, 30, 30280, 171, 208);
INSERT INTO public.who_global_data VALUES (40494, 2, 2902, 0, 11, 171, 45);
INSERT INTO public.who_global_data VALUES (40495, 36, 12582, 4, 812, 171, 110);
INSERT INTO public.who_global_data VALUES (40496, 61, 3077, 1, 48, 171, 88);
INSERT INTO public.who_global_data VALUES (40497, 174, 81522, 3, 5802, 171, 51);
INSERT INTO public.who_global_data VALUES (40498, 294, 38877, 0, 1751, 171, 209);
INSERT INTO public.who_global_data VALUES (40499, 80, 1844, 5, 73, 171, 205);
INSERT INTO public.who_global_data VALUES (40500, 32, 8131, 1, 65, 171, 18);
INSERT INTO public.who_global_data VALUES (40501, 1, 3382, 0, 58, 171, 72);
INSERT INTO public.who_global_data VALUES (40502, 1089, 320290, 12, 41381, 171, 44);
INSERT INTO public.who_global_data VALUES (40503, 0, 25, 0, 0, 171, 15);
INSERT INTO public.who_global_data VALUES (40504, 7, 1154, 0, 27, 171, 25);
INSERT INTO public.who_global_data VALUES (40505, 0, 0, 0, 0, 171, 179);
INSERT INTO public.who_global_data VALUES (40506, 0, 0, 0, 0, 171, 34);
INSERT INTO public.who_global_data VALUES (40507, 35, 600, 0, 12, 171, 207);
INSERT INTO public.who_global_data VALUES (40508, 113, 2427, 3, 60, 171, 166);
INSERT INTO public.who_global_data VALUES (40509, 7993, 399865, 20, 6016, 171, 126);
INSERT INTO public.who_global_data VALUES (40510, 0, 0, 0, 0, 171, 97);
INSERT INTO public.who_global_data VALUES (40511, 0, 298, 0, 2, 171, 36);
INSERT INTO public.who_global_data VALUES (40512, 0, 0, 0, 0, 171, 125);
INSERT INTO public.who_global_data VALUES (40513, 43, 1603, 0, 15, 171, 124);
INSERT INTO public.who_global_data VALUES (40514, 1967, 96403, 28, 2144, 171, 185);
INSERT INTO public.who_global_data VALUES (40515, 365, 64906, 2, 366, 171, 194);
INSERT INTO public.who_global_data VALUES (40516, 0, 509, 0, 21, 171, 144);
INSERT INTO public.who_global_data VALUES (40517, 39125, 5393138, 509, 169508, 171, 19);
INSERT INTO public.who_global_data VALUES (40518, 36, 796, 0, 9, 171, 217);
INSERT INTO public.who_global_data VALUES (40519, 17, 1457, 2, 40, 171, 148);
INSERT INTO public.who_global_data VALUES (40520, 660, 36760, 5, 245, 171, 86);
INSERT INTO public.who_global_data VALUES (40521, 0, 0, 0, 0, 171, 13);
INSERT INTO public.who_global_data VALUES (40522, 1047, 34802, 7, 288, 171, 157);
INSERT INTO public.who_global_data VALUES (40523, 6, 989, 0, 25, 171, 8);
INSERT INTO public.who_global_data VALUES (40524, 0, 0, 0, 0, 171, 73);
INSERT INTO public.who_global_data VALUES (40525, 7, 1893, 2, 538, 171, 101);
INSERT INTO public.who_global_data VALUES (40526, 145, 9981, 0, 264, 171, 165);
INSERT INTO public.who_global_data VALUES (40527, 70, 5378, 6, 141, 171, 14);
INSERT INTO public.who_global_data VALUES (40528, 3, 37685, 0, 1379, 172, 193);
INSERT INTO public.who_global_data VALUES (40529, 119, 7499, 2, 230, 172, 113);
INSERT INTO public.who_global_data VALUES (40530, 442, 39025, 9, 1379, 172, 143);
INSERT INTO public.who_global_data VALUES (40531, 0, 0, 0, 0, 172, 219);
INSERT INTO public.who_global_data VALUES (40532, 8, 1005, 0, 53, 172, 186);
INSERT INTO public.who_global_data VALUES (40533, 29, 1935, 0, 88, 172, 52);
INSERT INTO public.who_global_data VALUES (40534, 0, 3, 0, 0, 172, 180);
INSERT INTO public.who_global_data VALUES (40535, 0, 93, 0, 3, 172, 167);
INSERT INTO public.who_global_data VALUES (40536, 5469, 294569, 93, 5750, 172, 154);
INSERT INTO public.who_global_data VALUES (40537, 145, 41159, 8, 827, 172, 94);
INSERT INTO public.who_global_data VALUES (40538, 208, 1102, 0, 4, 172, 66);
INSERT INTO public.who_global_data VALUES (40539, 271, 23559, 25, 421, 172, 58);
INSERT INTO public.who_global_data VALUES (40540, 344, 23717, 1, 729, 172, 163);
INSERT INTO public.who_global_data VALUES (40541, 124, 34343, 2, 508, 172, 37);
INSERT INTO public.who_global_data VALUES (40542, 63, 1315, 1, 18, 172, 142);
INSERT INTO public.who_global_data VALUES (40543, 350, 47185, 3, 173, 172, 83);
INSERT INTO public.who_global_data VALUES (40544, 2595, 279144, 37, 3694, 172, 228);
INSERT INTO public.who_global_data VALUES (40545, 1, 152, 0, 7, 172, 188);
INSERT INTO public.who_global_data VALUES (40546, 73, 69589, 3, 613, 172, 62);
INSERT INTO public.who_global_data VALUES (40547, 707, 79629, 7, 9821, 172, 160);
INSERT INTO public.who_global_data VALUES (40548, 0, 452, 0, 3, 172, 50);
INSERT INTO public.who_global_data VALUES (40549, 0, 2063, 0, 39, 172, 33);
INSERT INTO public.who_global_data VALUES (40550, 0, 162, 0, 9, 172, 183);
INSERT INTO public.who_global_data VALUES (40551, 5, 146, 0, 0, 172, 92);
INSERT INTO public.who_global_data VALUES (40552, 1198, 100344, 45, 4048, 172, 158);
INSERT INTO public.who_global_data VALUES (40553, 0, 5, 0, 0, 172, 67);
INSERT INTO public.who_global_data VALUES (40554, 102, 16137, 6, 481, 172, 57);
INSERT INTO public.who_global_data VALUES (40555, 94, 1308, 0, 3, 172, 38);
INSERT INTO public.who_global_data VALUES (40556, 23101, 3340197, 620, 107852, 172, 141);
INSERT INTO public.who_global_data VALUES (40557, 0, 9, 0, 1, 172, 178);
INSERT INTO public.who_global_data VALUES (40558, 0, 142, 0, 3, 172, 108);
INSERT INTO public.who_global_data VALUES (40559, 135, 14500, 14, 512, 172, 39);
INSERT INTO public.who_global_data VALUES (40560, 18, 1267, 1, 55, 172, 2);
INSERT INTO public.who_global_data VALUES (40561, 3, 416, 0, 1, 172, 195);
INSERT INTO public.who_global_data VALUES (40562, 24, 3203, 1, 36, 172, 107);
INSERT INTO public.who_global_data VALUES (40563, 0, 273, 0, 0, 172, 161);
INSERT INTO public.who_global_data VALUES (40564, 17, 18599, 3, 406, 172, 212);
INSERT INTO public.who_global_data VALUES (40565, 198, 122087, 2, 9026, 172, 181);
INSERT INTO public.who_global_data VALUES (40566, 0, 203, 0, 1, 172, 53);
INSERT INTO public.who_global_data VALUES (40567, 15, 4667, 0, 61, 172, 164);
INSERT INTO public.who_global_data VALUES (40568, 3, 959, 0, 76, 172, 140);
INSERT INTO public.who_global_data VALUES (40569, 1556, 387502, 61, 10513, 172, 20);
INSERT INTO public.who_global_data VALUES (40570, 67, 89926, 0, 4710, 172, 112);
INSERT INTO public.who_global_data VALUES (40571, 11643, 468332, 287, 15097, 172, 111);
INSERT INTO public.who_global_data VALUES (40572, 0, 405, 0, 7, 172, 71);
INSERT INTO public.who_global_data VALUES (40573, 0, 3831, 0, 76, 172, 218);
INSERT INTO public.who_global_data VALUES (40574, 0, 0, 0, 0, 172, 43);
INSERT INTO public.who_global_data VALUES (40575, 728, 28465, 3, 294, 172, 49);
INSERT INTO public.who_global_data VALUES (40576, 0, 17026, 0, 110, 172, 1);
INSERT INTO public.who_global_data VALUES (40577, 85, 6656, 0, 166, 172, 48);
INSERT INTO public.who_global_data VALUES (40578, 48, 3364, 0, 88, 172, 232);
INSERT INTO public.who_global_data VALUES (40579, 1, 33, 0, 1, 172, 175);
INSERT INTO public.who_global_data VALUES (40580, 19, 1351, 0, 20, 172, 21);
INSERT INTO public.who_global_data VALUES (40581, 190, 20202, 2, 399, 172, 156);
INSERT INTO public.who_global_data VALUES (40582, 0, 0, 0, 0, 172, 95);
INSERT INTO public.who_global_data VALUES (40583, 30, 9705, 3, 243, 172, 177);
INSERT INTO public.who_global_data VALUES (40584, 123, 15740, 0, 621, 172, 210);
INSERT INTO public.who_global_data VALUES (40585, 3, 5372, 0, 59, 172, 120);
INSERT INTO public.who_global_data VALUES (40586, 0, 18, 0, 0, 172, 135);
INSERT INTO public.who_global_data VALUES (40587, 428, 86737, 28, 1481, 172, 206);
INSERT INTO public.who_global_data VALUES (40588, 209, 101751, 13, 6083, 172, 189);
INSERT INTO public.who_global_data VALUES (40589, 115, 96590, 13, 5173, 172, 129);
INSERT INTO public.who_global_data VALUES (40590, 281, 23193, 6, 618, 172, 121);
INSERT INTO public.who_global_data VALUES (40591, 0, 4821, 0, 83, 172, 59);
INSERT INTO public.who_global_data VALUES (40592, 0, 285, 0, 0, 172, 96);
INSERT INTO public.who_global_data VALUES (40593, 2, 2192, 0, 63, 172, 41);
INSERT INTO public.who_global_data VALUES (40594, 55, 3894, 3, 73, 172, 216);
INSERT INTO public.who_global_data VALUES (40595, 1460, 31336, 16, 544, 172, 236);
INSERT INTO public.who_global_data VALUES (40596, 0, 13, 0, 0, 172, 150);
INSERT INTO public.who_global_data VALUES (40597, 1, 373, 0, 0, 172, 61);
INSERT INTO public.who_global_data VALUES (40598, 0, 28, 0, 1, 172, 7);
INSERT INTO public.who_global_data VALUES (40599, 21, 7752, 1, 334, 172, 169);
INSERT INTO public.who_global_data VALUES (40600, 315, 205380, 18, 30296, 172, 28);
INSERT INTO public.who_global_data VALUES (40601, 34, 8622, 0, 53, 172, 85);
INSERT INTO public.who_global_data VALUES (40602, 45, 211, 0, 0, 172, 211);
INSERT INTO public.who_global_data VALUES (40603, 45, 8270, 2, 53, 172, 60);
INSERT INTO public.who_global_data VALUES (40604, 0, 1872, 0, 63, 172, 3);
INSERT INTO public.who_global_data VALUES (40605, 10, 1351, 0, 17, 172, 11);
INSERT INTO public.who_global_data VALUES (40606, 1390, 225404, 4, 9236, 172, 89);
INSERT INTO public.who_global_data VALUES (40607, 121, 42653, 8, 239, 172, 24);
INSERT INTO public.who_global_data VALUES (40608, 0, 209, 0, 0, 172, 162);
INSERT INTO public.who_global_data VALUES (40609, 147, 7222, 2, 230, 172, 100);
INSERT INTO public.who_global_data VALUES (40610, 0, 14, 0, 0, 172, 47);
INSERT INTO public.who_global_data VALUES (40611, 0, 24, 0, 0, 172, 29);
INSERT INTO public.who_global_data VALUES (40612, 64, 510, 1, 15, 172, 40);
INSERT INTO public.who_global_data VALUES (40613, 42, 550, 0, 5, 172, 222);
INSERT INTO public.who_global_data VALUES (40614, 382, 62944, 10, 2389, 172, 132);
INSERT INTO public.who_global_data VALUES (40615, 0, 252, 0, 13, 172, 130);
INSERT INTO public.who_global_data VALUES (40616, 138, 8620, 0, 51, 172, 234);
INSERT INTO public.who_global_data VALUES (40617, 0, 2117, 0, 33, 172, 23);
INSERT INTO public.who_global_data VALUES (40618, 35, 709, 1, 23, 172, 192);
INSERT INTO public.who_global_data VALUES (40619, 18, 7897, 0, 196, 172, 69);
INSERT INTO public.who_global_data VALUES (40620, 0, 12, 0, 0, 172, 187);
INSERT INTO public.who_global_data VALUES (40621, 523, 50502, 8, 1575, 172, 230);
INSERT INTO public.who_global_data VALUES (40622, 54, 4970, 1, 609, 172, 77);
INSERT INTO public.who_global_data VALUES (40623, 3, 2014, 0, 10, 172, 9);
INSERT INTO public.who_global_data VALUES (40624, 55079, 2702742, 876, 51797, 172, 74);
INSERT INTO public.who_global_data VALUES (40625, 1821, 141370, 57, 6207, 172, 224);
INSERT INTO public.who_global_data VALUES (40626, 2247, 345450, 165, 19804, 172, 199);
INSERT INTO public.who_global_data VALUES (40627, 3202, 180133, 94, 5954, 172, 190);
INSERT INTO public.who_global_data VALUES (40628, 56, 27313, 0, 1774, 172, 12);
INSERT INTO public.who_global_data VALUES (40629, 0, 336, 0, 24, 172, 104);
INSERT INTO public.who_global_data VALUES (40630, 1068, 93420, 19, 764, 172, 153);
INSERT INTO public.who_global_data VALUES (40631, 320, 254235, 4, 35400, 172, 91);
INSERT INTO public.who_global_data VALUES (40632, 7, 1113, 0, 14, 172, 215);
INSERT INTO public.who_global_data VALUES (40633, 1018, 56685, 16, 1115, 172, 84);
INSERT INTO public.who_global_data VALUES (40634, 0, 356, 0, 31, 172, 231);
INSERT INTO public.who_global_data VALUES (40635, 20, 1466, 0, 11, 172, 196);
INSERT INTO public.who_global_data VALUES (40636, 1352, 123325, 0, 1633, 172, 105);
INSERT INTO public.who_global_data VALUES (40637, 245, 30365, 8, 482, 172, 122);
INSERT INTO public.who_global_data VALUES (40638, 0, 0, 0, 0, 172, 159);
INSERT INTO public.who_global_data VALUES (40639, 129, 11502, 9, 400, 172, 75);
INSERT INTO public.who_global_data VALUES (40640, 622, 76827, 1, 502, 172, 27);
INSERT INTO public.who_global_data VALUES (40641, 155, 42146, 2, 1053, 172, 54);
INSERT INTO public.who_global_data VALUES (40642, 0, 22, 0, 0, 172, 226);
INSERT INTO public.who_global_data VALUES (40643, 1, 1323, 0, 32, 172, 79);
INSERT INTO public.who_global_data VALUES (40644, 456, 9337, 2, 105, 172, 56);
INSERT INTO public.who_global_data VALUES (40645, 0, 946, 0, 30, 172, 117);
INSERT INTO public.who_global_data VALUES (40646, 20, 1277, 0, 82, 172, 152);
INSERT INTO public.who_global_data VALUES (40647, 407, 8579, 4, 157, 172, 16);
INSERT INTO public.who_global_data VALUES (40648, 1, 98, 0, 1, 172, 10);
INSERT INTO public.who_global_data VALUES (40649, 37, 2467, 0, 81, 172, 201);
INSERT INTO public.who_global_data VALUES (40650, 30, 7469, 1, 124, 172, 174);
INSERT INTO public.who_global_data VALUES (40651, 59, 13886, 1, 171, 172, 119);
INSERT INTO public.who_global_data VALUES (40652, 53, 5125, 1, 162, 172, 168);
INSERT INTO public.who_global_data VALUES (40653, 12, 9212, 0, 125, 172, 99);
INSERT INTO public.who_global_data VALUES (40654, 124, 5909, 1, 23, 172, 171);
INSERT INTO public.who_global_data VALUES (40655, 0, 2640, 0, 125, 172, 87);
INSERT INTO public.who_global_data VALUES (40656, 49, 1422, 0, 9, 172, 123);
INSERT INTO public.who_global_data VALUES (40657, 0, 0, 0, 0, 172, 151);
INSERT INTO public.who_global_data VALUES (40658, 14, 350, 0, 16, 172, 213);
INSERT INTO public.who_global_data VALUES (40659, 61, 6762, 0, 157, 172, 118);
INSERT INTO public.who_global_data VALUES (40660, 0, 346, 0, 10, 172, 134);
INSERT INTO public.who_global_data VALUES (40661, 41, 3160, 0, 39, 172, 65);
INSERT INTO public.who_global_data VALUES (40662, 4448, 522162, 214, 56757, 172, 102);
INSERT INTO public.who_global_data VALUES (40663, 0, 0, 0, 0, 172, 223);
INSERT INTO public.who_global_data VALUES (40664, 1, 103, 0, 1, 172, 4);
INSERT INTO public.who_global_data VALUES (40665, 0, 298, 0, 0, 172, 146);
INSERT INTO public.who_global_data VALUES (40666, 51, 4151, 0, 80, 172, 31);
INSERT INTO public.who_global_data VALUES (40667, 0, 13, 0, 1, 172, 127);
INSERT INTO public.who_global_data VALUES (40668, 1069, 43558, 23, 681, 172, 22);
INSERT INTO public.who_global_data VALUES (40669, 59, 2914, 0, 19, 172, 115);
INSERT INTO public.who_global_data VALUES (40670, 0, 375, 0, 6, 172, 106);
INSERT INTO public.who_global_data VALUES (40671, 190, 4344, 1, 36, 172, 90);
INSERT INTO public.who_global_data VALUES (40672, 0, 0, 0, 0, 172, 70);
INSERT INTO public.who_global_data VALUES (40673, 581, 27241, 3, 107, 172, 46);
INSERT INTO public.who_global_data VALUES (40674, 487, 63408, 0, 6171, 172, 139);
INSERT INTO public.who_global_data VALUES (40675, 0, 23, 0, 0, 172, 42);
INSERT INTO public.who_global_data VALUES (40676, 13, 1293, 0, 22, 172, 80);
INSERT INTO public.who_global_data VALUES (40677, 0, 3413, 0, 128, 172, 203);
INSERT INTO public.who_global_data VALUES (40678, 0, 1167, 0, 69, 172, 136);
INSERT INTO public.who_global_data VALUES (40679, 417, 49485, 2, 977, 172, 63);
INSERT INTO public.who_global_data VALUES (40680, 0, 0, 0, 0, 172, 17);
INSERT INTO public.who_global_data VALUES (40681, 4, 54, 0, 2, 172, 172);
INSERT INTO public.who_global_data VALUES (40682, 101, 12840, 3, 547, 172, 109);
INSERT INTO public.who_global_data VALUES (40683, 154, 10004, 0, 261, 172, 200);
INSERT INTO public.who_global_data VALUES (40684, 456, 22391, 2, 123, 172, 93);
INSERT INTO public.who_global_data VALUES (40685, 140, 83226, 16, 588, 172, 5);
INSERT INTO public.who_global_data VALUES (40686, 0, 741, 0, 13, 172, 214);
INSERT INTO public.who_global_data VALUES (40687, 617, 289832, 15, 6190, 172, 204);
INSERT INTO public.who_global_data VALUES (40688, 0, 0, 0, 0, 172, 198);
INSERT INTO public.who_global_data VALUES (40689, 1275, 81940, 21, 1767, 172, 173);
INSERT INTO public.who_global_data VALUES (40690, 10, 333, 0, 3, 172, 229);
INSERT INTO public.who_global_data VALUES (40691, 410, 9791, 11, 138, 172, 76);
INSERT INTO public.who_global_data VALUES (40692, 10143, 535946, 206, 26281, 172, 138);
INSERT INTO public.who_global_data VALUES (40693, 3221, 164474, 16, 2681, 172, 98);
INSERT INTO public.who_global_data VALUES (40694, 0, 0, 0, 0, 172, 103);
INSERT INTO public.who_global_data VALUES (40695, 595, 57279, 8, 1885, 172, 225);
INSERT INTO public.who_global_data VALUES (40696, 132, 54234, 1, 1779, 172, 131);
INSERT INTO public.who_global_data VALUES (40697, 754, 26760, 0, 335, 172, 235);
INSERT INTO public.who_global_data VALUES (40698, 288, 115368, 0, 193, 172, 137);
INSERT INTO public.who_global_data VALUES (40699, 246, 15761, 1, 306, 172, 81);
INSERT INTO public.who_global_data VALUES (40700, 194, 30377, 12, 908, 172, 182);
INSERT INTO public.who_global_data VALUES (40701, 25, 880, 0, 5, 172, 145);
INSERT INTO public.who_global_data VALUES (40702, 733, 71194, 38, 3029, 172, 26);
INSERT INTO public.who_global_data VALUES (40703, 4748, 932493, 132, 15872, 172, 170);
INSERT INTO public.who_global_data VALUES (40704, 87, 2540, 0, 8, 172, 191);
INSERT INTO public.who_global_data VALUES (40705, 0, 5, 0, 0, 172, 221);
INSERT INTO public.who_global_data VALUES (40706, 0, 13, 0, 0, 172, 64);
INSERT INTO public.who_global_data VALUES (40707, 0, 0, 0, 0, 172, 116);
INSERT INTO public.who_global_data VALUES (40708, 0, 17, 0, 0, 172, 128);
INSERT INTO public.who_global_data VALUES (40709, 0, 25, 0, 0, 172, 6);
INSERT INTO public.who_global_data VALUES (40710, 0, 109, 0, 5, 172, 227);
INSERT INTO public.who_global_data VALUES (40711, 0, 5, 0, 0, 172, 68);
INSERT INTO public.who_global_data VALUES (40712, 0, 57, 0, 0, 172, 184);
INSERT INTO public.who_global_data VALUES (40713, 0, 0, 0, 0, 172, 82);
INSERT INTO public.who_global_data VALUES (40714, 0, 719, 0, 42, 172, 149);
INSERT INTO public.who_global_data VALUES (40715, 0, 885, 0, 15, 172, 197);
INSERT INTO public.who_global_data VALUES (40716, 1372, 299914, 28, 3436, 172, 78);
INSERT INTO public.who_global_data VALUES (40717, 75, 12237, 3, 256, 172, 233);
INSERT INTO public.who_global_data VALUES (40718, 100, 29782, 3, 677, 172, 133);
INSERT INTO public.who_global_data VALUES (40719, 0, 127, 0, 0, 172, 35);
INSERT INTO public.who_global_data VALUES (40720, 0, 1956, 0, 69, 172, 114);
INSERT INTO public.who_global_data VALUES (40721, 91, 55838, 0, 27, 172, 237);
INSERT INTO public.who_global_data VALUES (40722, 0, 3, 0, 0, 172, 55);
INSERT INTO public.who_global_data VALUES (40723, 54, 317, 0, 17, 172, 176);
INSERT INTO public.who_global_data VALUES (40724, 5, 2907, 0, 31, 172, 202);
INSERT INTO public.who_global_data VALUES (40725, 27, 2457, 0, 131, 172, 155);
INSERT INTO public.who_global_data VALUES (40726, 0, 0, 0, 0, 172, 32);
INSERT INTO public.who_global_data VALUES (40727, 1, 3257, 0, 93, 172, 220);
INSERT INTO public.who_global_data VALUES (40728, 2541, 589886, 143, 11982, 172, 30);
INSERT INTO public.who_global_data VALUES (40729, 0, 2490, 0, 47, 172, 147);
INSERT INTO public.who_global_data VALUES (40730, 3341, 382461, 22, 30250, 172, 208);
INSERT INTO public.who_global_data VALUES (40731, 7, 2900, 0, 11, 172, 45);
INSERT INTO public.who_global_data VALUES (40732, 61, 12546, 3, 808, 172, 110);
INSERT INTO public.who_global_data VALUES (40733, 55, 3016, 5, 47, 172, 88);
INSERT INTO public.who_global_data VALUES (40734, 63, 81348, 0, 5799, 172, 51);
INSERT INTO public.who_global_data VALUES (40735, 285, 38583, 1, 1751, 172, 209);
INSERT INTO public.who_global_data VALUES (40736, 87, 1764, 4, 68, 172, 205);
INSERT INTO public.who_global_data VALUES (40737, 34, 8099, 0, 64, 172, 18);
INSERT INTO public.who_global_data VALUES (40738, 3, 3381, 0, 58, 172, 72);
INSERT INTO public.who_global_data VALUES (40739, 713, 319201, 3, 41369, 172, 44);
INSERT INTO public.who_global_data VALUES (40740, 0, 25, 0, 0, 172, 15);
INSERT INTO public.who_global_data VALUES (40741, 0, 1147, 0, 27, 172, 25);
INSERT INTO public.who_global_data VALUES (40742, 0, 0, 0, 0, 172, 179);
INSERT INTO public.who_global_data VALUES (40743, 0, 0, 0, 0, 172, 34);
INSERT INTO public.who_global_data VALUES (40744, 46, 565, 1, 12, 172, 207);
INSERT INTO public.who_global_data VALUES (40745, 129, 2314, 1, 57, 172, 166);
INSERT INTO public.who_global_data VALUES (40746, 7963, 391872, 22, 5996, 172, 126);
INSERT INTO public.who_global_data VALUES (40747, 0, 0, 0, 0, 172, 97);
INSERT INTO public.who_global_data VALUES (40748, 0, 298, 0, 2, 172, 36);
INSERT INTO public.who_global_data VALUES (40749, 0, 0, 0, 0, 172, 125);
INSERT INTO public.who_global_data VALUES (40750, 60, 1560, 2, 15, 172, 124);
INSERT INTO public.who_global_data VALUES (40751, 1616, 94436, 27, 2116, 172, 185);
INSERT INTO public.who_global_data VALUES (40752, 229, 64541, 0, 364, 172, 194);
INSERT INTO public.who_global_data VALUES (40753, 0, 509, 0, 21, 172, 144);
INSERT INTO public.who_global_data VALUES (40754, 41073, 5354013, 654, 168999, 172, 19);
INSERT INTO public.who_global_data VALUES (40755, 19, 760, 0, 9, 172, 217);
INSERT INTO public.who_global_data VALUES (40756, 6, 1440, 0, 38, 172, 148);
INSERT INTO public.who_global_data VALUES (40757, 587, 36100, 6, 240, 172, 86);
INSERT INTO public.who_global_data VALUES (40758, 0, 0, 0, 0, 172, 13);
INSERT INTO public.who_global_data VALUES (40759, 1148, 33755, 5, 281, 172, 157);
INSERT INTO public.who_global_data VALUES (40760, 19, 983, 1, 25, 172, 8);
INSERT INTO public.who_global_data VALUES (40761, 0, 0, 0, 0, 172, 73);
INSERT INTO public.who_global_data VALUES (40762, 13, 1886, 5, 536, 172, 101);
INSERT INTO public.who_global_data VALUES (40763, 493, 9836, 4, 264, 172, 165);
INSERT INTO public.who_global_data VALUES (40764, 47, 5308, 3, 135, 172, 14);
INSERT INTO public.who_global_data VALUES (40765, 0, 37682, 0, 1379, 173, 193);
INSERT INTO public.who_global_data VALUES (40766, 120, 7380, 3, 228, 173, 113);
INSERT INTO public.who_global_data VALUES (40767, 450, 38583, 10, 1370, 173, 143);
INSERT INTO public.who_global_data VALUES (40768, 0, 0, 0, 0, 173, 219);
INSERT INTO public.who_global_data VALUES (40769, 0, 997, 0, 53, 173, 186);
INSERT INTO public.who_global_data VALUES (40770, 27, 1906, 2, 88, 173, 52);
INSERT INTO public.who_global_data VALUES (40771, 0, 3, 0, 0, 173, 180);
INSERT INTO public.who_global_data VALUES (40772, 0, 93, 0, 3, 173, 167);
INSERT INTO public.who_global_data VALUES (40773, 6663, 289100, 92, 5657, 173, 154);
INSERT INTO public.who_global_data VALUES (40774, 38, 41014, 6, 819, 173, 94);
INSERT INTO public.who_global_data VALUES (40775, 0, 894, 0, 4, 173, 66);
INSERT INTO public.who_global_data VALUES (40776, 253, 23288, 17, 396, 173, 58);
INSERT INTO public.who_global_data VALUES (40777, 162, 23373, 0, 728, 173, 163);
INSERT INTO public.who_global_data VALUES (40778, 112, 34219, 0, 506, 173, 37);
INSERT INTO public.who_global_data VALUES (40779, 133, 1252, 0, 17, 173, 142);
INSERT INTO public.who_global_data VALUES (40780, 405, 46835, 0, 170, 173, 83);
INSERT INTO public.who_global_data VALUES (40781, 2024, 276549, 32, 3657, 173, 228);
INSERT INTO public.who_global_data VALUES (40782, 3, 151, 0, 7, 173, 188);
INSERT INTO public.who_global_data VALUES (40783, 92, 69516, 3, 610, 173, 62);
INSERT INTO public.who_global_data VALUES (40784, 132, 78922, 7, 9814, 173, 160);
INSERT INTO public.who_global_data VALUES (40785, 64, 452, 0, 3, 173, 50);
INSERT INTO public.who_global_data VALUES (40786, 0, 2063, 0, 39, 173, 33);
INSERT INTO public.who_global_data VALUES (40787, 3, 162, 0, 9, 173, 183);
INSERT INTO public.who_global_data VALUES (40788, 8, 141, 0, 0, 173, 92);
INSERT INTO public.who_global_data VALUES (40789, 1196, 99146, 64, 4003, 173, 158);
INSERT INTO public.who_global_data VALUES (40790, 0, 5, 0, 0, 173, 67);
INSERT INTO public.who_global_data VALUES (40791, 233, 16035, 9, 475, 173, 57);
INSERT INTO public.who_global_data VALUES (40792, 0, 1214, 0, 3, 173, 38);
INSERT INTO public.who_global_data VALUES (40793, 41576, 3317096, 709, 107232, 173, 141);
INSERT INTO public.who_global_data VALUES (40794, 0, 9, 0, 1, 173, 178);
INSERT INTO public.who_global_data VALUES (40795, 0, 142, 0, 3, 173, 108);
INSERT INTO public.who_global_data VALUES (40796, 32, 14365, 3, 498, 173, 39);
INSERT INTO public.who_global_data VALUES (40797, 9, 1249, 0, 54, 173, 2);
INSERT INTO public.who_global_data VALUES (40798, 0, 413, 0, 1, 173, 195);
INSERT INTO public.who_global_data VALUES (40799, 16, 3179, 1, 35, 173, 107);
INSERT INTO public.who_global_data VALUES (40800, 0, 273, 0, 0, 173, 161);
INSERT INTO public.who_global_data VALUES (40801, 113, 18582, 2, 403, 173, 212);
INSERT INTO public.who_global_data VALUES (40802, 237, 121889, 4, 9024, 173, 181);
INSERT INTO public.who_global_data VALUES (40803, 0, 203, 0, 1, 173, 53);
INSERT INTO public.who_global_data VALUES (40804, 0, 4652, 0, 61, 173, 164);
INSERT INTO public.who_global_data VALUES (40805, 4, 956, 0, 76, 173, 140);
INSERT INTO public.who_global_data VALUES (40806, 2044, 385946, 57, 10452, 173, 20);
INSERT INTO public.who_global_data VALUES (40807, 98, 89859, 0, 4710, 173, 112);
INSERT INTO public.who_global_data VALUES (40808, 11578, 456689, 318, 14810, 173, 111);
INSERT INTO public.who_global_data VALUES (40809, 0, 405, 0, 7, 173, 71);
INSERT INTO public.who_global_data VALUES (40810, 0, 3831, 0, 76, 173, 218);
INSERT INTO public.who_global_data VALUES (40811, 0, 0, 0, 0, 173, 43);
INSERT INTO public.who_global_data VALUES (40812, 806, 27737, 10, 291, 173, 49);
INSERT INTO public.who_global_data VALUES (40813, 33, 17026, 2, 110, 173, 1);
INSERT INTO public.who_global_data VALUES (40814, 151, 6571, 1, 166, 173, 48);
INSERT INTO public.who_global_data VALUES (40815, 24, 3316, 0, 88, 173, 232);
INSERT INTO public.who_global_data VALUES (40816, 0, 32, 0, 1, 173, 175);
INSERT INTO public.who_global_data VALUES (40817, 0, 1332, 0, 20, 173, 21);
INSERT INTO public.who_global_data VALUES (40818, 121, 20012, 2, 397, 173, 156);
INSERT INTO public.who_global_data VALUES (40819, 0, 0, 0, 0, 173, 95);
INSERT INTO public.who_global_data VALUES (40820, 38, 9675, 1, 240, 173, 177);
INSERT INTO public.who_global_data VALUES (40821, 134, 15617, 0, 621, 173, 210);
INSERT INTO public.who_global_data VALUES (40822, 2, 5369, 0, 59, 173, 120);
INSERT INTO public.who_global_data VALUES (40823, 0, 18, 0, 0, 173, 135);
INSERT INTO public.who_global_data VALUES (40824, 764, 86309, 15, 1453, 173, 206);
INSERT INTO public.who_global_data VALUES (40825, 854, 101542, 5, 6070, 173, 189);
INSERT INTO public.who_global_data VALUES (40826, 139, 96475, 19, 5160, 173, 129);
INSERT INTO public.who_global_data VALUES (40827, 293, 22912, 9, 612, 173, 121);
INSERT INTO public.who_global_data VALUES (40828, 0, 4821, 0, 83, 173, 59);
INSERT INTO public.who_global_data VALUES (40829, 0, 285, 0, 0, 173, 96);
INSERT INTO public.who_global_data VALUES (40830, 6, 2190, 0, 63, 173, 41);
INSERT INTO public.who_global_data VALUES (40831, 94, 3839, 1, 70, 173, 216);
INSERT INTO public.who_global_data VALUES (40832, 982, 29876, 19, 528, 173, 236);
INSERT INTO public.who_global_data VALUES (40833, 0, 13, 0, 0, 173, 150);
INSERT INTO public.who_global_data VALUES (40834, 2, 372, 0, 0, 173, 61);
INSERT INTO public.who_global_data VALUES (40835, 0, 28, 0, 1, 173, 7);
INSERT INTO public.who_global_data VALUES (40836, 11, 7731, 0, 333, 173, 169);
INSERT INTO public.who_global_data VALUES (40837, 2947, 205065, 1, 30278, 173, 28);
INSERT INTO public.who_global_data VALUES (40838, 0, 8588, 0, 53, 173, 85);
INSERT INTO public.who_global_data VALUES (40839, 0, 166, 0, 0, 173, 211);
INSERT INTO public.who_global_data VALUES (40840, 0, 8225, 0, 51, 173, 60);
INSERT INTO public.who_global_data VALUES (40841, 183, 1872, 9, 63, 173, 3);
INSERT INTO public.who_global_data VALUES (40842, 5, 1341, 0, 17, 173, 11);
INSERT INTO public.who_global_data VALUES (40843, 561, 224014, 1, 9232, 173, 89);
INSERT INTO public.who_global_data VALUES (40844, 322, 42532, 0, 231, 173, 24);
INSERT INTO public.who_global_data VALUES (40845, 3, 209, 0, 0, 173, 162);
INSERT INTO public.who_global_data VALUES (40846, 217, 7075, 2, 228, 173, 100);
INSERT INTO public.who_global_data VALUES (40847, 0, 14, 0, 0, 173, 47);
INSERT INTO public.who_global_data VALUES (40848, 0, 24, 0, 0, 173, 29);
INSERT INTO public.who_global_data VALUES (40849, 0, 446, 0, 14, 173, 40);
INSERT INTO public.who_global_data VALUES (40850, 0, 508, 0, 5, 173, 222);
INSERT INTO public.who_global_data VALUES (40851, 249, 62562, 24, 2379, 173, 132);
INSERT INTO public.who_global_data VALUES (40852, 0, 252, 0, 13, 173, 130);
INSERT INTO public.who_global_data VALUES (40853, 139, 8482, 1, 51, 173, 234);
INSERT INTO public.who_global_data VALUES (40854, 0, 2117, 0, 33, 173, 23);
INSERT INTO public.who_global_data VALUES (40855, 25, 674, 0, 22, 173, 192);
INSERT INTO public.who_global_data VALUES (40856, 48, 7879, 0, 196, 173, 69);
INSERT INTO public.who_global_data VALUES (40857, 0, 12, 0, 0, 173, 187);
INSERT INTO public.who_global_data VALUES (40858, 512, 49979, 19, 1567, 173, 230);
INSERT INTO public.who_global_data VALUES (40859, 39, 4916, 1, 608, 173, 77);
INSERT INTO public.who_global_data VALUES (40860, 12, 2011, 0, 10, 173, 9);
INSERT INTO public.who_global_data VALUES (40861, 57981, 2647663, 941, 50921, 173, 74);
INSERT INTO public.who_global_data VALUES (40862, 2081, 139549, 79, 6150, 173, 224);
INSERT INTO public.who_global_data VALUES (40863, 2133, 343203, 147, 19639, 173, 199);
INSERT INTO public.who_global_data VALUES (40864, 4348, 176931, 75, 5860, 173, 190);
INSERT INTO public.who_global_data VALUES (40865, 66, 27257, 0, 1774, 173, 12);
INSERT INTO public.who_global_data VALUES (40866, 0, 336, 0, 24, 173, 104);
INSERT INTO public.who_global_data VALUES (40867, 757, 92352, 10, 745, 173, 153);
INSERT INTO public.who_global_data VALUES (40868, 477, 253915, 4, 35396, 173, 91);
INSERT INTO public.who_global_data VALUES (40869, 24, 1106, 0, 14, 173, 215);
INSERT INTO public.who_global_data VALUES (40870, 953, 55667, 11, 1099, 173, 84);
INSERT INTO public.who_global_data VALUES (40871, 0, 356, 0, 31, 173, 231);
INSERT INTO public.who_global_data VALUES (40872, 39, 1446, 0, 11, 173, 196);
INSERT INTO public.who_global_data VALUES (40873, 334, 121973, 0, 1633, 173, 105);
INSERT INTO public.who_global_data VALUES (40874, 271, 30120, 2, 474, 173, 122);
INSERT INTO public.who_global_data VALUES (40875, 0, 0, 0, 0, 173, 159);
INSERT INTO public.who_global_data VALUES (40876, 141, 11373, 11, 391, 173, 75);
INSERT INTO public.who_global_data VALUES (40877, 508, 76205, 3, 501, 173, 27);
INSERT INTO public.who_global_data VALUES (40878, 135, 41991, 1, 1051, 173, 54);
INSERT INTO public.who_global_data VALUES (40879, 0, 22, 0, 0, 173, 226);
INSERT INTO public.who_global_data VALUES (40880, 7, 1322, 0, 32, 173, 79);
INSERT INTO public.who_global_data VALUES (40881, 439, 8881, 6, 103, 173, 56);
INSERT INTO public.who_global_data VALUES (40882, 43, 946, 5, 30, 173, 117);
INSERT INTO public.who_global_data VALUES (40883, 0, 1257, 0, 82, 173, 152);
INSERT INTO public.who_global_data VALUES (40884, 434, 8172, 8, 153, 173, 16);
INSERT INTO public.who_global_data VALUES (40885, 3, 97, 0, 1, 173, 10);
INSERT INTO public.who_global_data VALUES (40886, 21, 2430, 0, 81, 173, 201);
INSERT INTO public.who_global_data VALUES (40887, 0, 7439, 0, 123, 173, 174);
INSERT INTO public.who_global_data VALUES (40888, 103, 13827, 4, 170, 173, 119);
INSERT INTO public.who_global_data VALUES (40889, 46, 5072, 4, 161, 173, 168);
INSERT INTO public.who_global_data VALUES (40890, 25, 9200, 0, 125, 173, 99);
INSERT INTO public.who_global_data VALUES (40891, 106, 5785, 0, 22, 173, 171);
INSERT INTO public.who_global_data VALUES (40892, 26, 2640, 0, 125, 173, 87);
INSERT INTO public.who_global_data VALUES (40893, 68, 1373, 0, 9, 173, 123);
INSERT INTO public.who_global_data VALUES (40894, 0, 0, 0, 0, 173, 151);
INSERT INTO public.who_global_data VALUES (40895, 0, 336, 0, 16, 173, 213);
INSERT INTO public.who_global_data VALUES (40896, 8, 6701, 0, 157, 173, 118);
INSERT INTO public.who_global_data VALUES (40897, 0, 346, 0, 10, 173, 134);
INSERT INTO public.who_global_data VALUES (40898, 0, 3119, 0, 39, 173, 65);
INSERT INTO public.who_global_data VALUES (40899, 6345, 517714, 635, 56543, 173, 102);
INSERT INTO public.who_global_data VALUES (40900, 0, 0, 0, 0, 173, 223);
INSERT INTO public.who_global_data VALUES (40901, 0, 102, 0, 1, 173, 4);
INSERT INTO public.who_global_data VALUES (40902, 0, 298, 0, 0, 173, 146);
INSERT INTO public.who_global_data VALUES (40903, 44, 4100, 2, 80, 173, 31);
INSERT INTO public.who_global_data VALUES (40904, 0, 13, 0, 1, 173, 127);
INSERT INTO public.who_global_data VALUES (40905, 1472, 42489, 26, 658, 173, 22);
INSERT INTO public.who_global_data VALUES (40906, 64, 2855, 0, 19, 173, 115);
INSERT INTO public.who_global_data VALUES (40907, 1, 375, 0, 6, 173, 106);
INSERT INTO public.who_global_data VALUES (40908, 247, 4154, 0, 35, 173, 90);
INSERT INTO public.who_global_data VALUES (40909, 0, 0, 0, 0, 173, 70);
INSERT INTO public.who_global_data VALUES (40910, 641, 26660, 2, 104, 173, 46);
INSERT INTO public.who_global_data VALUES (40911, 499, 62921, 3, 6171, 173, 139);
INSERT INTO public.who_global_data VALUES (40912, 0, 23, 0, 0, 173, 42);
INSERT INTO public.who_global_data VALUES (40913, 9, 1280, 0, 22, 173, 80);
INSERT INTO public.who_global_data VALUES (40914, 0, 3413, 0, 128, 173, 203);
INSERT INTO public.who_global_data VALUES (40915, 2, 1167, 0, 69, 173, 136);
INSERT INTO public.who_global_data VALUES (40916, 298, 49068, 1, 975, 173, 63);
INSERT INTO public.who_global_data VALUES (40917, 0, 0, 0, 0, 173, 17);
INSERT INTO public.who_global_data VALUES (40918, 0, 50, 0, 2, 173, 172);
INSERT INTO public.who_global_data VALUES (40919, 193, 12739, 9, 544, 173, 109);
INSERT INTO public.who_global_data VALUES (40920, 0, 9850, 0, 261, 173, 200);
INSERT INTO public.who_global_data VALUES (40921, 381, 21935, 2, 121, 173, 93);
INSERT INTO public.who_global_data VALUES (40922, 162, 83086, 10, 572, 173, 5);
INSERT INTO public.who_global_data VALUES (40923, 0, 741, 0, 13, 173, 214);
INSERT INTO public.who_global_data VALUES (40924, 498, 289215, 7, 6175, 173, 204);
INSERT INTO public.who_global_data VALUES (40925, 0, 0, 0, 0, 173, 198);
INSERT INTO public.who_global_data VALUES (40926, 1263, 80665, 12, 1746, 173, 173);
INSERT INTO public.who_global_data VALUES (40927, 48, 323, 0, 3, 173, 229);
INSERT INTO public.who_global_data VALUES (40928, 359, 9381, 19, 127, 173, 76);
INSERT INTO public.who_global_data VALUES (40929, 9507, 525803, 219, 26075, 173, 138);
INSERT INTO public.who_global_data VALUES (40930, 3335, 161253, 65, 2665, 173, 98);
INSERT INTO public.who_global_data VALUES (40931, 0, 0, 0, 0, 173, 103);
INSERT INTO public.who_global_data VALUES (40932, 594, 56684, 8, 1877, 173, 225);
INSERT INTO public.who_global_data VALUES (40933, 121, 54102, 3, 1778, 173, 131);
INSERT INTO public.who_global_data VALUES (40934, 311, 26006, 6, 335, 173, 235);
INSERT INTO public.who_global_data VALUES (40935, 271, 115080, 1, 193, 173, 137);
INSERT INTO public.who_global_data VALUES (40936, 197, 15515, 0, 305, 173, 81);
INSERT INTO public.who_global_data VALUES (40937, 278, 30183, 1, 896, 173, 182);
INSERT INTO public.who_global_data VALUES (40938, 67, 855, 0, 5, 173, 145);
INSERT INTO public.who_global_data VALUES (40939, 1087, 70461, 37, 2991, 173, 26);
INSERT INTO public.who_global_data VALUES (40940, 4892, 927745, 55, 15740, 173, 170);
INSERT INTO public.who_global_data VALUES (40941, 101, 2453, 0, 8, 173, 191);
INSERT INTO public.who_global_data VALUES (40942, 0, 5, 0, 0, 173, 221);
INSERT INTO public.who_global_data VALUES (40943, 0, 13, 0, 0, 173, 64);
INSERT INTO public.who_global_data VALUES (40944, 0, 0, 0, 0, 173, 116);
INSERT INTO public.who_global_data VALUES (40945, 0, 17, 0, 0, 173, 128);
INSERT INTO public.who_global_data VALUES (40946, 0, 25, 0, 0, 173, 6);
INSERT INTO public.who_global_data VALUES (40947, 0, 109, 0, 5, 173, 227);
INSERT INTO public.who_global_data VALUES (40948, 1, 5, 0, 0, 173, 68);
INSERT INTO public.who_global_data VALUES (40949, 0, 57, 0, 0, 173, 184);
INSERT INTO public.who_global_data VALUES (40950, 0, 0, 0, 0, 173, 82);
INSERT INTO public.who_global_data VALUES (40951, 0, 719, 0, 42, 173, 149);
INSERT INTO public.who_global_data VALUES (40952, 0, 885, 0, 15, 173, 197);
INSERT INTO public.who_global_data VALUES (40953, 1227, 298542, 39, 3408, 173, 78);
INSERT INTO public.who_global_data VALUES (40954, 130, 12162, 2, 253, 173, 233);
INSERT INTO public.who_global_data VALUES (40955, 211, 29682, 4, 674, 173, 133);
INSERT INTO public.who_global_data VALUES (40956, 0, 127, 0, 0, 173, 35);
INSERT INTO public.who_global_data VALUES (40957, 2, 1956, 0, 69, 173, 114);
INSERT INTO public.who_global_data VALUES (40958, 86, 55747, 0, 27, 173, 237);
INSERT INTO public.who_global_data VALUES (40959, 0, 3, 0, 0, 173, 55);
INSERT INTO public.who_global_data VALUES (40960, 0, 263, 0, 17, 173, 176);
INSERT INTO public.who_global_data VALUES (40961, 47, 2902, 0, 31, 173, 202);
INSERT INTO public.who_global_data VALUES (40962, 13, 2430, 0, 131, 173, 155);
INSERT INTO public.who_global_data VALUES (40963, 0, 0, 0, 0, 173, 32);
INSERT INTO public.who_global_data VALUES (40964, 0, 3256, 0, 93, 173, 220);
INSERT INTO public.who_global_data VALUES (40965, 3692, 587345, 162, 11839, 173, 30);
INSERT INTO public.who_global_data VALUES (40966, 1, 2490, 0, 47, 173, 147);
INSERT INTO public.who_global_data VALUES (40967, 4882, 379120, 29, 30228, 173, 208);
INSERT INTO public.who_global_data VALUES (40968, 7, 2893, 0, 11, 173, 45);
INSERT INTO public.who_global_data VALUES (40969, 75, 12485, 2, 805, 173, 110);
INSERT INTO public.who_global_data VALUES (40970, 123, 2961, 1, 42, 173, 88);
INSERT INTO public.who_global_data VALUES (40971, 226, 81285, 1, 5799, 173, 51);
INSERT INTO public.who_global_data VALUES (40972, 137, 38298, 0, 1750, 173, 209);
INSERT INTO public.who_global_data VALUES (40973, 84, 1677, 4, 64, 173, 205);
INSERT INTO public.who_global_data VALUES (40974, 36, 8065, 0, 64, 173, 18);
INSERT INTO public.who_global_data VALUES (40975, 1, 3378, 0, 58, 173, 72);
INSERT INTO public.who_global_data VALUES (40976, 1040, 318488, 5, 41366, 173, 44);
INSERT INTO public.who_global_data VALUES (40977, 0, 25, 0, 0, 173, 15);
INSERT INTO public.who_global_data VALUES (40978, 55, 1147, 1, 27, 173, 25);
INSERT INTO public.who_global_data VALUES (40979, 0, 0, 0, 0, 173, 179);
INSERT INTO public.who_global_data VALUES (40980, 0, 0, 0, 0, 173, 34);
INSERT INTO public.who_global_data VALUES (40981, 45, 519, 1, 11, 173, 207);
INSERT INTO public.who_global_data VALUES (40982, 78, 2185, 2, 56, 173, 166);
INSERT INTO public.who_global_data VALUES (40983, 7922, 383909, 19, 5974, 173, 126);
INSERT INTO public.who_global_data VALUES (40984, 0, 0, 0, 0, 173, 97);
INSERT INTO public.who_global_data VALUES (40985, 24, 298, 0, 2, 173, 36);
INSERT INTO public.who_global_data VALUES (40986, 0, 0, 0, 0, 173, 125);
INSERT INTO public.who_global_data VALUES (40987, 66, 1500, 1, 13, 173, 124);
INSERT INTO public.who_global_data VALUES (40988, 1464, 92820, 19, 2089, 173, 185);
INSERT INTO public.who_global_data VALUES (40989, 210, 64312, 3, 364, 173, 194);
INSERT INTO public.who_global_data VALUES (40990, 0, 509, 0, 21, 173, 144);
INSERT INTO public.who_global_data VALUES (40991, 54375, 5312940, 1144, 168345, 173, 19);
INSERT INTO public.who_global_data VALUES (40992, 7, 741, 0, 9, 173, 217);
INSERT INTO public.who_global_data VALUES (40993, 13, 1434, 0, 38, 173, 148);
INSERT INTO public.who_global_data VALUES (40994, 569, 35513, 6, 234, 173, 86);
INSERT INTO public.who_global_data VALUES (40995, 0, 0, 0, 0, 173, 13);
INSERT INTO public.who_global_data VALUES (40996, 1226, 32607, 10, 276, 173, 157);
INSERT INTO public.who_global_data VALUES (40997, 13, 964, 1, 24, 173, 8);
INSERT INTO public.who_global_data VALUES (40998, 0, 0, 0, 0, 173, 73);
INSERT INTO public.who_global_data VALUES (40999, 11, 1873, 2, 531, 173, 101);
INSERT INTO public.who_global_data VALUES (41000, 157, 9343, 0, 260, 173, 165);
INSERT INTO public.who_global_data VALUES (41001, 85, 5261, 2, 132, 173, 14);
INSERT INTO public.who_global_data VALUES (41002, 45, 37682, 5, 1379, 174, 193);
INSERT INTO public.who_global_data VALUES (41003, 143, 7260, 6, 225, 174, 113);
INSERT INTO public.who_global_data VALUES (41004, 469, 38133, 9, 1360, 174, 143);
INSERT INTO public.who_global_data VALUES (41005, 0, 0, 0, 0, 174, 219);
INSERT INTO public.who_global_data VALUES (41006, 8, 997, 0, 53, 174, 186);
INSERT INTO public.who_global_data VALUES (41007, 27, 1879, 0, 86, 174, 52);
INSERT INTO public.who_global_data VALUES (41008, 0, 3, 0, 0, 174, 180);
INSERT INTO public.who_global_data VALUES (41009, 0, 93, 0, 3, 174, 167);
INSERT INTO public.who_global_data VALUES (41010, 6365, 282437, 137, 5565, 174, 154);
INSERT INTO public.who_global_data VALUES (41011, 168, 40976, 1, 813, 174, 94);
INSERT INTO public.who_global_data VALUES (41012, 0, 894, 0, 4, 174, 66);
INSERT INTO public.who_global_data VALUES (41013, 292, 23035, 4, 379, 174, 58);
INSERT INTO public.who_global_data VALUES (41014, 260, 23211, 3, 728, 174, 163);
INSERT INTO public.who_global_data VALUES (41015, 89, 34107, 2, 506, 174, 37);
INSERT INTO public.who_global_data VALUES (41016, 30, 1119, 2, 17, 174, 142);
INSERT INTO public.who_global_data VALUES (41017, 378, 46430, 2, 170, 174, 83);
INSERT INTO public.who_global_data VALUES (41018, 2644, 274525, 34, 3625, 174, 228);
INSERT INTO public.who_global_data VALUES (41019, 4, 148, 0, 7, 174, 188);
INSERT INTO public.who_global_data VALUES (41020, 116, 69424, 4, 607, 174, 62);
INSERT INTO public.who_global_data VALUES (41021, 163, 78790, 9, 9807, 174, 160);
INSERT INTO public.who_global_data VALUES (41022, 32, 388, 1, 3, 174, 50);
INSERT INTO public.who_global_data VALUES (41023, 49, 2063, 1, 39, 174, 33);
INSERT INTO public.who_global_data VALUES (41024, 0, 159, 0, 9, 174, 183);
INSERT INTO public.who_global_data VALUES (41025, 0, 133, 0, 0, 174, 92);
INSERT INTO public.who_global_data VALUES (41026, 1491, 97950, 55, 3939, 174, 158);
INSERT INTO public.who_global_data VALUES (41027, 0, 5, 0, 0, 174, 67);
INSERT INTO public.who_global_data VALUES (41028, 268, 15802, 2, 466, 174, 57);
INSERT INTO public.who_global_data VALUES (41029, 0, 1214, 0, 3, 174, 38);
INSERT INTO public.who_global_data VALUES (41030, 50644, 3275520, 1060, 106523, 174, 141);
INSERT INTO public.who_global_data VALUES (41031, 0, 9, 0, 1, 174, 178);
INSERT INTO public.who_global_data VALUES (41032, 0, 142, 0, 3, 174, 108);
INSERT INTO public.who_global_data VALUES (41033, 90, 14333, 3, 495, 174, 39);
INSERT INTO public.who_global_data VALUES (41034, 2, 1240, 0, 54, 174, 2);
INSERT INTO public.who_global_data VALUES (41035, 1, 413, 0, 1, 174, 195);
INSERT INTO public.who_global_data VALUES (41036, 27, 3163, 1, 34, 174, 107);
INSERT INTO public.who_global_data VALUES (41037, 0, 273, 0, 0, 174, 161);
INSERT INTO public.who_global_data VALUES (41038, 0, 18469, 0, 401, 174, 212);
INSERT INTO public.who_global_data VALUES (41039, 418, 121652, 5, 9020, 174, 181);
INSERT INTO public.who_global_data VALUES (41040, 0, 203, 0, 1, 174, 53);
INSERT INTO public.who_global_data VALUES (41041, 0, 4652, 0, 61, 174, 164);
INSERT INTO public.who_global_data VALUES (41042, 1, 952, 0, 76, 174, 140);
INSERT INTO public.who_global_data VALUES (41043, 1791, 383902, 55, 10395, 174, 20);
INSERT INTO public.who_global_data VALUES (41044, 66, 89761, 2, 4710, 174, 112);
INSERT INTO public.who_global_data VALUES (41045, 11306, 445111, 347, 14492, 174, 111);
INSERT INTO public.who_global_data VALUES (41046, 2, 405, 0, 7, 174, 71);
INSERT INTO public.who_global_data VALUES (41047, 86, 3831, 16, 76, 174, 218);
INSERT INTO public.who_global_data VALUES (41048, 0, 0, 0, 0, 174, 43);
INSERT INTO public.who_global_data VALUES (41049, 802, 26931, 9, 281, 174, 49);
INSERT INTO public.who_global_data VALUES (41050, 58, 16993, 0, 108, 174, 1);
INSERT INTO public.who_global_data VALUES (41051, 162, 6420, 2, 165, 174, 48);
INSERT INTO public.who_global_data VALUES (41052, 63, 3292, 0, 88, 174, 232);
INSERT INTO public.who_global_data VALUES (41053, 0, 32, 0, 1, 174, 175);
INSERT INTO public.who_global_data VALUES (41054, 14, 1332, 0, 20, 174, 21);
INSERT INTO public.who_global_data VALUES (41055, 198, 19891, 1, 395, 174, 156);
INSERT INTO public.who_global_data VALUES (41056, 0, 0, 0, 0, 174, 95);
INSERT INTO public.who_global_data VALUES (41057, 33, 9637, 1, 239, 174, 177);
INSERT INTO public.who_global_data VALUES (41058, 104, 15483, 0, 621, 174, 210);
INSERT INTO public.who_global_data VALUES (41059, 0, 5367, 0, 59, 174, 120);
INSERT INTO public.who_global_data VALUES (41060, 0, 18, 0, 0, 174, 135);
INSERT INTO public.who_global_data VALUES (41061, 1057, 85545, 29, 1438, 174, 206);
INSERT INTO public.who_global_data VALUES (41062, 1279, 100688, 35, 6065, 174, 189);
INSERT INTO public.who_global_data VALUES (41063, 116, 96336, 17, 5141, 174, 129);
INSERT INTO public.who_global_data VALUES (41064, 305, 22619, 8, 603, 174, 121);
INSERT INTO public.who_global_data VALUES (41065, 0, 4821, 0, 83, 174, 59);
INSERT INTO public.who_global_data VALUES (41066, 0, 285, 0, 0, 174, 96);
INSERT INTO public.who_global_data VALUES (41067, 7, 2184, 0, 63, 174, 41);
INSERT INTO public.who_global_data VALUES (41068, 75, 3745, 1, 69, 174, 216);
INSERT INTO public.who_global_data VALUES (41069, 1652, 28894, 17, 509, 174, 236);
INSERT INTO public.who_global_data VALUES (41070, 0, 13, 0, 0, 174, 150);
INSERT INTO public.who_global_data VALUES (41071, 8, 370, 0, 0, 174, 61);
INSERT INTO public.who_global_data VALUES (41072, 0, 28, 0, 1, 174, 7);
INSERT INTO public.who_global_data VALUES (41073, 20, 7720, 0, 333, 174, 169);
INSERT INTO public.who_global_data VALUES (41074, 3242, 202118, 2, 30277, 174, 28);
INSERT INTO public.who_global_data VALUES (41075, 39, 8588, 0, 53, 174, 85);
INSERT INTO public.who_global_data VALUES (41076, 0, 166, 0, 0, 174, 211);
INSERT INTO public.who_global_data VALUES (41077, 0, 8225, 0, 51, 174, 60);
INSERT INTO public.who_global_data VALUES (41078, 0, 1689, 0, 54, 174, 3);
INSERT INTO public.who_global_data VALUES (41079, 15, 1336, 0, 17, 174, 11);
INSERT INTO public.who_global_data VALUES (41080, 625, 223453, 0, 9231, 174, 89);
INSERT INTO public.who_global_data VALUES (41081, 147, 42210, 0, 231, 174, 24);
INSERT INTO public.who_global_data VALUES (41082, 1, 206, 0, 0, 174, 162);
INSERT INTO public.who_global_data VALUES (41083, 226, 6858, 3, 226, 174, 100);
INSERT INTO public.who_global_data VALUES (41084, 0, 14, 0, 0, 174, 47);
INSERT INTO public.who_global_data VALUES (41085, 0, 24, 0, 0, 174, 29);
INSERT INTO public.who_global_data VALUES (41086, 0, 446, 0, 14, 174, 40);
INSERT INTO public.who_global_data VALUES (41087, 14, 508, 0, 5, 174, 222);
INSERT INTO public.who_global_data VALUES (41088, 885, 62313, 14, 2355, 174, 132);
INSERT INTO public.who_global_data VALUES (41089, 0, 252, 0, 13, 174, 130);
INSERT INTO public.who_global_data VALUES (41090, 83, 8343, 0, 50, 174, 234);
INSERT INTO public.who_global_data VALUES (41091, 0, 2117, 0, 33, 174, 23);
INSERT INTO public.who_global_data VALUES (41092, 18, 649, 0, 22, 174, 192);
INSERT INTO public.who_global_data VALUES (41093, 21, 7831, 4, 196, 174, 69);
INSERT INTO public.who_global_data VALUES (41094, 0, 12, 0, 0, 174, 187);
INSERT INTO public.who_global_data VALUES (41095, 425, 49467, 6, 1548, 174, 230);
INSERT INTO public.who_global_data VALUES (41096, 24, 4877, 0, 607, 174, 77);
INSERT INTO public.who_global_data VALUES (41097, 16, 1999, 0, 10, 174, 9);
INSERT INTO public.who_global_data VALUES (41098, 63490, 2589682, 944, 49980, 174, 74);
INSERT INTO public.who_global_data VALUES (41099, 2345, 137468, 50, 6071, 174, 224);
INSERT INTO public.who_global_data VALUES (41100, 2245, 341070, 161, 19492, 174, 199);
INSERT INTO public.who_global_data VALUES (41101, 4293, 172583, 76, 5785, 174, 190);
INSERT INTO public.who_global_data VALUES (41102, 196, 27191, 0, 1774, 174, 12);
INSERT INTO public.who_global_data VALUES (41103, 0, 336, 0, 24, 174, 104);
INSERT INTO public.who_global_data VALUES (41104, 1388, 91595, 12, 735, 174, 153);
INSERT INTO public.who_global_data VALUES (41105, 629, 253438, 158, 35392, 174, 91);
INSERT INTO public.who_global_data VALUES (41106, 11, 1082, 0, 14, 174, 215);
INSERT INTO public.who_global_data VALUES (41107, 1137, 54714, 3, 1088, 174, 84);
INSERT INTO public.who_global_data VALUES (41108, 0, 356, 0, 31, 174, 231);
INSERT INTO public.who_global_data VALUES (41109, 10, 1407, 0, 11, 174, 196);
INSERT INTO public.who_global_data VALUES (41110, 478, 121639, 200, 1633, 174, 105);
INSERT INTO public.who_global_data VALUES (41111, 515, 29849, 7, 472, 174, 122);
INSERT INTO public.who_global_data VALUES (41112, 0, 0, 0, 0, 174, 159);
INSERT INTO public.who_global_data VALUES (41113, 145, 11232, 9, 380, 174, 75);
INSERT INTO public.who_global_data VALUES (41114, 512, 75697, 4, 498, 174, 27);
INSERT INTO public.who_global_data VALUES (41115, 211, 41856, 2, 1050, 174, 54);
INSERT INTO public.who_global_data VALUES (41116, 2, 22, 0, 0, 174, 226);
INSERT INTO public.who_global_data VALUES (41117, 7, 1315, 0, 32, 174, 79);
INSERT INTO public.who_global_data VALUES (41118, 397, 8442, 3, 97, 174, 56);
INSERT INTO public.who_global_data VALUES (41119, 0, 903, 0, 25, 174, 117);
INSERT INTO public.who_global_data VALUES (41120, 3, 1257, 0, 82, 174, 152);
INSERT INTO public.who_global_data VALUES (41121, 411, 7738, 6, 145, 174, 16);
INSERT INTO public.who_global_data VALUES (41122, 0, 94, 0, 1, 174, 10);
INSERT INTO public.who_global_data VALUES (41123, 30, 2409, 0, 81, 174, 201);
INSERT INTO public.who_global_data VALUES (41124, 34, 7439, 1, 123, 174, 174);
INSERT INTO public.who_global_data VALUES (41125, 81, 13724, 2, 166, 174, 119);
INSERT INTO public.who_global_data VALUES (41126, 38, 5026, 1, 157, 174, 168);
INSERT INTO public.who_global_data VALUES (41127, 26, 9175, 0, 125, 174, 99);
INSERT INTO public.who_global_data VALUES (41128, 107, 5679, 0, 22, 174, 171);
INSERT INTO public.who_global_data VALUES (41129, 9, 2614, 0, 125, 174, 87);
INSERT INTO public.who_global_data VALUES (41130, 63, 1305, 0, 9, 174, 123);
INSERT INTO public.who_global_data VALUES (41131, 0, 0, 0, 0, 174, 151);
INSERT INTO public.who_global_data VALUES (41132, 0, 336, 0, 16, 174, 213);
INSERT INTO public.who_global_data VALUES (41133, 40, 6693, 0, 157, 174, 118);
INSERT INTO public.who_global_data VALUES (41134, 2, 346, 0, 10, 174, 134);
INSERT INTO public.who_global_data VALUES (41135, 0, 3119, 0, 39, 174, 65);
INSERT INTO public.who_global_data VALUES (41136, 5618, 511369, 615, 55908, 174, 102);
INSERT INTO public.who_global_data VALUES (41137, 0, 0, 0, 0, 174, 223);
INSERT INTO public.who_global_data VALUES (41138, 0, 102, 0, 1, 174, 4);
INSERT INTO public.who_global_data VALUES (41139, 1, 298, 0, 0, 174, 146);
INSERT INTO public.who_global_data VALUES (41140, 45, 4056, 3, 78, 174, 31);
INSERT INTO public.who_global_data VALUES (41141, 0, 13, 0, 1, 174, 127);
INSERT INTO public.who_global_data VALUES (41142, 1776, 41017, 21, 632, 174, 22);
INSERT INTO public.who_global_data VALUES (41143, 83, 2791, 0, 19, 174, 115);
INSERT INTO public.who_global_data VALUES (41144, 5, 374, 0, 6, 174, 106);
INSERT INTO public.who_global_data VALUES (41145, 181, 3907, 4, 35, 174, 90);
INSERT INTO public.who_global_data VALUES (41146, 0, 0, 0, 0, 174, 70);
INSERT INTO public.who_global_data VALUES (41147, 468, 26019, 3, 102, 174, 46);
INSERT INTO public.who_global_data VALUES (41148, 656, 62422, 2, 6168, 174, 139);
INSERT INTO public.who_global_data VALUES (41149, 0, 23, 0, 0, 174, 42);
INSERT INTO public.who_global_data VALUES (41150, 13, 1271, 0, 22, 174, 80);
INSERT INTO public.who_global_data VALUES (41151, 0, 3413, 0, 128, 174, 203);
INSERT INTO public.who_global_data VALUES (41152, 0, 1165, 0, 69, 174, 136);
INSERT INTO public.who_global_data VALUES (41153, 325, 48770, 1, 974, 174, 63);
INSERT INTO public.who_global_data VALUES (41154, 0, 0, 0, 0, 174, 17);
INSERT INTO public.who_global_data VALUES (41155, 0, 50, 0, 2, 174, 172);
INSERT INTO public.who_global_data VALUES (41156, 160, 12546, 3, 535, 174, 109);
INSERT INTO public.who_global_data VALUES (41157, 0, 9850, 0, 261, 174, 200);
INSERT INTO public.who_global_data VALUES (41158, 498, 21554, 3, 119, 174, 93);
INSERT INTO public.who_global_data VALUES (41159, 181, 82924, 5, 562, 174, 5);
INSERT INTO public.who_global_data VALUES (41160, 0, 741, 0, 13, 174, 214);
INSERT INTO public.who_global_data VALUES (41161, 670, 288717, 6, 6168, 174, 204);
INSERT INTO public.who_global_data VALUES (41162, 0, 0, 0, 0, 174, 198);
INSERT INTO public.who_global_data VALUES (41163, 956, 79402, 12, 1734, 174, 173);
INSERT INTO public.who_global_data VALUES (41164, 0, 275, 0, 3, 174, 229);
INSERT INTO public.who_global_data VALUES (41165, 633, 9022, 11, 108, 174, 76);
INSERT INTO public.who_global_data VALUES (41166, 8300, 516296, 208, 25856, 174, 138);
INSERT INTO public.who_global_data VALUES (41167, 4258, 157918, 158, 2600, 174, 98);
INSERT INTO public.who_global_data VALUES (41168, 0, 0, 0, 0, 174, 103);
INSERT INTO public.who_global_data VALUES (41169, 771, 56090, 11, 1869, 174, 225);
INSERT INTO public.who_global_data VALUES (41170, 198, 53981, 3, 1775, 174, 131);
INSERT INTO public.who_global_data VALUES (41171, 567, 25695, 12, 329, 174, 235);
INSERT INTO public.who_global_data VALUES (41172, 277, 114809, 2, 192, 174, 137);
INSERT INTO public.who_global_data VALUES (41173, 279, 15318, 0, 305, 174, 81);
INSERT INTO public.who_global_data VALUES (41174, 422, 29905, 11, 895, 174, 182);
INSERT INTO public.who_global_data VALUES (41175, 12, 788, 0, 5, 174, 145);
INSERT INTO public.who_global_data VALUES (41176, 1328, 69374, 50, 2954, 174, 26);
INSERT INTO public.who_global_data VALUES (41177, 4969, 922853, 68, 15685, 174, 170);
INSERT INTO public.who_global_data VALUES (41178, 152, 2352, 0, 8, 174, 191);
INSERT INTO public.who_global_data VALUES (41179, 0, 5, 0, 0, 174, 221);
INSERT INTO public.who_global_data VALUES (41180, 0, 13, 0, 0, 174, 64);
INSERT INTO public.who_global_data VALUES (41181, 0, 0, 0, 0, 174, 116);
INSERT INTO public.who_global_data VALUES (41182, 0, 17, 0, 0, 174, 128);
INSERT INTO public.who_global_data VALUES (41183, 0, 25, 0, 0, 174, 6);
INSERT INTO public.who_global_data VALUES (41184, 17, 109, 1, 5, 174, 227);
INSERT INTO public.who_global_data VALUES (41185, 0, 4, 0, 0, 174, 68);
INSERT INTO public.who_global_data VALUES (41186, 0, 57, 0, 0, 174, 184);
INSERT INTO public.who_global_data VALUES (41187, 0, 0, 0, 0, 174, 82);
INSERT INTO public.who_global_data VALUES (41188, 0, 719, 0, 42, 174, 149);
INSERT INTO public.who_global_data VALUES (41189, 0, 885, 0, 15, 174, 197);
INSERT INTO public.who_global_data VALUES (41190, 1413, 297315, 31, 3369, 174, 78);
INSERT INTO public.who_global_data VALUES (41191, 160, 12032, 2, 251, 174, 233);
INSERT INTO public.who_global_data VALUES (41192, 238, 29471, 5, 670, 174, 133);
INSERT INTO public.who_global_data VALUES (41193, 0, 127, 0, 0, 174, 35);
INSERT INTO public.who_global_data VALUES (41194, 7, 1954, 0, 69, 174, 114);
INSERT INTO public.who_global_data VALUES (41195, 81, 55661, 0, 27, 174, 237);
INSERT INTO public.who_global_data VALUES (41196, 0, 3, 0, 0, 174, 55);
INSERT INTO public.who_global_data VALUES (41197, 0, 263, 0, 17, 174, 176);
INSERT INTO public.who_global_data VALUES (41198, 54, 2855, 0, 31, 174, 202);
INSERT INTO public.who_global_data VALUES (41199, 15, 2417, 0, 131, 174, 155);
INSERT INTO public.who_global_data VALUES (41200, 0, 0, 0, 0, 174, 32);
INSERT INTO public.who_global_data VALUES (41201, 6, 3256, 0, 93, 174, 220);
INSERT INTO public.who_global_data VALUES (41202, 4513, 583653, 121, 11677, 174, 30);
INSERT INTO public.who_global_data VALUES (41203, 1, 2489, 0, 47, 174, 147);
INSERT INTO public.who_global_data VALUES (41204, 8475, 374238, 34, 30199, 174, 208);
INSERT INTO public.who_global_data VALUES (41205, 4, 2886, 0, 11, 174, 45);
INSERT INTO public.who_global_data VALUES (41206, 96, 12410, 5, 803, 174, 110);
INSERT INTO public.who_global_data VALUES (41207, 77, 2838, 1, 41, 174, 88);
INSERT INTO public.who_global_data VALUES (41208, 344, 81059, 1, 5798, 174, 51);
INSERT INTO public.who_global_data VALUES (41209, 149, 38161, 3, 1750, 174, 209);
INSERT INTO public.who_global_data VALUES (41210, 78, 1593, 2, 60, 174, 205);
INSERT INTO public.who_global_data VALUES (41211, 40, 8029, 1, 64, 174, 18);
INSERT INTO public.who_global_data VALUES (41212, 1, 3377, 0, 58, 174, 72);
INSERT INTO public.who_global_data VALUES (41213, 1077, 317448, 3, 41361, 174, 44);
INSERT INTO public.who_global_data VALUES (41214, 0, 25, 0, 0, 174, 15);
INSERT INTO public.who_global_data VALUES (41215, 0, 1092, 0, 26, 174, 25);
INSERT INTO public.who_global_data VALUES (41216, 0, 0, 0, 0, 174, 179);
INSERT INTO public.who_global_data VALUES (41217, 0, 0, 0, 0, 174, 34);
INSERT INTO public.who_global_data VALUES (41218, 62, 474, 2, 10, 174, 207);
INSERT INTO public.who_global_data VALUES (41219, 84, 2107, 0, 54, 174, 166);
INSERT INTO public.who_global_data VALUES (41220, 7986, 375987, 21, 5955, 174, 126);
INSERT INTO public.who_global_data VALUES (41221, 0, 0, 0, 0, 174, 97);
INSERT INTO public.who_global_data VALUES (41222, 16, 274, 0, 2, 174, 36);
INSERT INTO public.who_global_data VALUES (41223, 0, 0, 0, 0, 174, 125);
INSERT INTO public.who_global_data VALUES (41224, 49, 1434, 0, 12, 174, 124);
INSERT INTO public.who_global_data VALUES (41225, 1637, 91356, 26, 2070, 174, 185);
INSERT INTO public.who_global_data VALUES (41226, 283, 64102, 2, 361, 174, 194);
INSERT INTO public.who_global_data VALUES (41227, 0, 509, 0, 21, 174, 144);
INSERT INTO public.who_global_data VALUES (41228, 55359, 5258565, 1206, 167201, 174, 19);
INSERT INTO public.who_global_data VALUES (41229, 30, 734, 0, 9, 174, 217);
INSERT INTO public.who_global_data VALUES (41230, 12, 1421, 1, 38, 174, 148);
INSERT INTO public.who_global_data VALUES (41231, 693, 34944, 5, 228, 174, 86);
INSERT INTO public.who_global_data VALUES (41232, 0, 0, 0, 0, 174, 13);
INSERT INTO public.who_global_data VALUES (41233, 1012, 31381, 7, 266, 174, 157);
INSERT INTO public.who_global_data VALUES (41234, 21, 951, 1, 23, 174, 8);
INSERT INTO public.who_global_data VALUES (41235, 0, 0, 0, 0, 174, 73);
INSERT INTO public.who_global_data VALUES (41236, 0, 1862, 0, 529, 174, 101);
INSERT INTO public.who_global_data VALUES (41237, 165, 9186, 4, 260, 174, 165);
INSERT INTO public.who_global_data VALUES (41238, 104, 5176, 2, 130, 174, 14);
INSERT INTO public.who_global_data VALUES (41239, 120, 37637, 7, 1374, 175, 193);
INSERT INTO public.who_global_data VALUES (41240, 146, 7117, 6, 219, 175, 113);
INSERT INTO public.who_global_data VALUES (41241, 477, 37664, 10, 1351, 175, 143);
INSERT INTO public.who_global_data VALUES (41242, 0, 0, 0, 0, 175, 219);
INSERT INTO public.who_global_data VALUES (41243, 8, 989, 0, 53, 175, 186);
INSERT INTO public.who_global_data VALUES (41244, 37, 1852, 3, 86, 175, 52);
INSERT INTO public.who_global_data VALUES (41245, 0, 3, 0, 0, 175, 180);
INSERT INTO public.who_global_data VALUES (41246, 1, 93, 0, 3, 175, 167);
INSERT INTO public.who_global_data VALUES (41247, 7498, 276072, 182, 5428, 175, 154);
INSERT INTO public.who_global_data VALUES (41248, 196, 40808, 3, 812, 175, 94);
INSERT INTO public.who_global_data VALUES (41249, 96, 894, 1, 4, 175, 66);
INSERT INTO public.who_global_data VALUES (41250, 385, 22743, 14, 375, 175, 58);
INSERT INTO public.who_global_data VALUES (41251, 221, 22951, 0, 725, 175, 163);
INSERT INTO public.who_global_data VALUES (41252, 103, 34018, 4, 504, 175, 37);
INSERT INTO public.who_global_data VALUES (41253, 53, 1089, 0, 15, 175, 142);
INSERT INTO public.who_global_data VALUES (41254, 326, 46052, 1, 168, 175, 83);
INSERT INTO public.who_global_data VALUES (41255, 2766, 271881, 34, 3591, 175, 228);
INSERT INTO public.who_global_data VALUES (41256, 0, 144, 0, 7, 175, 188);
INSERT INTO public.who_global_data VALUES (41257, 105, 69308, 4, 603, 175, 62);
INSERT INTO public.who_global_data VALUES (41258, 587, 78627, 12, 9798, 175, 160);
INSERT INTO public.who_global_data VALUES (41259, 60, 356, 0, 2, 175, 50);
INSERT INTO public.who_global_data VALUES (41260, 0, 2014, 0, 38, 175, 33);
INSERT INTO public.who_global_data VALUES (41261, 0, 159, 0, 9, 175, 183);
INSERT INTO public.who_global_data VALUES (41262, 2, 133, 0, 0, 175, 92);
INSERT INTO public.who_global_data VALUES (41263, 1388, 96459, 57, 3884, 175, 158);
INSERT INTO public.who_global_data VALUES (41264, 0, 5, 0, 0, 175, 67);
INSERT INTO public.who_global_data VALUES (41265, 347, 15534, 11, 464, 175, 57);
INSERT INTO public.who_global_data VALUES (41266, 0, 1214, 0, 3, 175, 38);
INSERT INTO public.who_global_data VALUES (41267, 60091, 3224876, 1262, 105463, 175, 141);
INSERT INTO public.who_global_data VALUES (41268, 0, 9, 0, 1, 175, 178);
INSERT INTO public.who_global_data VALUES (41269, 0, 142, 0, 3, 175, 108);
INSERT INTO public.who_global_data VALUES (41270, 174, 14243, 8, 492, 175, 39);
INSERT INTO public.who_global_data VALUES (41271, 10, 1238, 0, 54, 175, 2);
INSERT INTO public.who_global_data VALUES (41272, 0, 412, 0, 1, 175, 195);
INSERT INTO public.who_global_data VALUES (41273, 63, 3136, 0, 33, 175, 107);
INSERT INTO public.who_global_data VALUES (41274, 0, 273, 0, 0, 175, 161);
INSERT INTO public.who_global_data VALUES (41275, 0, 18469, 0, 401, 175, 212);
INSERT INTO public.who_global_data VALUES (41276, 390, 121234, 9, 9015, 175, 181);
INSERT INTO public.who_global_data VALUES (41277, 0, 203, 0, 1, 175, 53);
INSERT INTO public.who_global_data VALUES (41278, 0, 4652, 0, 61, 175, 164);
INSERT INTO public.who_global_data VALUES (41279, 2, 951, 0, 76, 175, 140);
INSERT INTO public.who_global_data VALUES (41280, 2077, 382111, 41, 10340, 175, 20);
INSERT INTO public.who_global_data VALUES (41281, 70, 89695, 1, 4708, 175, 112);
INSERT INTO public.who_global_data VALUES (41282, 11286, 433805, 308, 14145, 175, 111);
INSERT INTO public.who_global_data VALUES (41283, 0, 403, 0, 7, 175, 71);
INSERT INTO public.who_global_data VALUES (41284, 0, 3745, 0, 60, 175, 218);
INSERT INTO public.who_global_data VALUES (41285, 0, 0, 0, 0, 175, 43);
INSERT INTO public.who_global_data VALUES (41286, 1072, 26129, 9, 272, 175, 49);
INSERT INTO public.who_global_data VALUES (41287, 88, 16935, 3, 108, 175, 1);
INSERT INTO public.who_global_data VALUES (41288, 208, 6258, 2, 163, 175, 48);
INSERT INTO public.who_global_data VALUES (41289, 55, 3229, -1, 88, 175, 232);
INSERT INTO public.who_global_data VALUES (41290, 0, 32, 0, 1, 175, 175);
INSERT INTO public.who_global_data VALUES (41291, 13, 1318, 0, 20, 175, 21);
INSERT INTO public.who_global_data VALUES (41292, 292, 19693, 3, 394, 175, 156);
INSERT INTO public.who_global_data VALUES (41293, 0, 0, 0, 0, 175, 95);
INSERT INTO public.who_global_data VALUES (41294, 16, 9604, 4, 238, 175, 177);
INSERT INTO public.who_global_data VALUES (41295, 165, 15379, 0, 621, 175, 210);
INSERT INTO public.who_global_data VALUES (41296, 9, 5367, 0, 59, 175, 120);
INSERT INTO public.who_global_data VALUES (41297, 0, 18, 0, 0, 175, 135);
INSERT INTO public.who_global_data VALUES (41298, 1354, 84488, 16, 1409, 175, 206);
INSERT INTO public.who_global_data VALUES (41299, 1066, 99409, 20, 6030, 175, 189);
INSERT INTO public.who_global_data VALUES (41300, 112, 96220, 17, 5124, 175, 129);
INSERT INTO public.who_global_data VALUES (41301, 321, 22314, 11, 595, 175, 121);
INSERT INTO public.who_global_data VALUES (41302, 0, 4821, 0, 83, 175, 59);
INSERT INTO public.who_global_data VALUES (41303, 0, 285, 0, 0, 175, 96);
INSERT INTO public.who_global_data VALUES (41304, 3, 2177, 0, 63, 175, 41);
INSERT INTO public.who_global_data VALUES (41305, 71, 3670, 3, 68, 175, 216);
INSERT INTO public.who_global_data VALUES (41306, 1038, 27242, 13, 492, 175, 236);
INSERT INTO public.who_global_data VALUES (41307, 0, 13, 0, 0, 175, 150);
INSERT INTO public.who_global_data VALUES (41308, 0, 362, 0, 0, 175, 61);
INSERT INTO public.who_global_data VALUES (41309, 0, 28, 0, 1, 175, 7);
INSERT INTO public.who_global_data VALUES (41310, 17, 7700, 0, 333, 175, 169);
INSERT INTO public.who_global_data VALUES (41311, 2667, 198876, 16, 30275, 175, 28);
INSERT INTO public.who_global_data VALUES (41312, 78, 8549, 2, 53, 175, 85);
INSERT INTO public.who_global_data VALUES (41313, 27, 166, 0, 0, 175, 211);
INSERT INTO public.who_global_data VALUES (41314, 148, 8225, 0, 51, 175, 60);
INSERT INTO public.who_global_data VALUES (41315, 133, 1689, 11, 54, 175, 3);
INSERT INTO public.who_global_data VALUES (41316, 15, 1321, 0, 17, 175, 11);
INSERT INTO public.who_global_data VALUES (41317, 1415, 222828, 6, 9231, 175, 89);
INSERT INTO public.who_global_data VALUES (41318, 216, 42063, 8, 231, 175, 24);
INSERT INTO public.who_global_data VALUES (41319, 2, 205, 0, 0, 175, 162);
INSERT INTO public.who_global_data VALUES (41320, 251, 6632, 2, 223, 175, 100);
INSERT INTO public.who_global_data VALUES (41321, 0, 14, 0, 0, 175, 47);
INSERT INTO public.who_global_data VALUES (41322, 0, 24, 0, 0, 175, 29);
INSERT INTO public.who_global_data VALUES (41323, 79, 446, 0, 14, 175, 40);
INSERT INTO public.who_global_data VALUES (41324, 25, 494, 0, 5, 175, 222);
INSERT INTO public.who_global_data VALUES (41325, 1144, 61428, 45, 2341, 175, 132);
INSERT INTO public.who_global_data VALUES (41326, 0, 252, 0, 13, 175, 130);
INSERT INTO public.who_global_data VALUES (41327, 62, 8260, 0, 50, 175, 234);
INSERT INTO public.who_global_data VALUES (41328, 65, 2117, 4, 33, 175, 23);
INSERT INTO public.who_global_data VALUES (41329, 8, 631, 0, 22, 175, 192);
INSERT INTO public.who_global_data VALUES (41330, 29, 7810, 0, 192, 175, 69);
INSERT INTO public.who_global_data VALUES (41331, 0, 12, 0, 0, 175, 187);
INSERT INTO public.who_global_data VALUES (41332, 385, 49042, 9, 1542, 175, 230);
INSERT INTO public.who_global_data VALUES (41333, 40, 4853, 0, 607, 175, 77);
INSERT INTO public.who_global_data VALUES (41334, 7, 1983, 0, 10, 175, 9);
INSERT INTO public.who_global_data VALUES (41335, 65002, 2526192, 996, 49036, 175, 74);
INSERT INTO public.who_global_data VALUES (41336, 2307, 135123, 53, 6021, 175, 224);
INSERT INTO public.who_global_data VALUES (41337, 2501, 338825, 169, 19331, 175, 199);
INSERT INTO public.who_global_data VALUES (41338, 4013, 168290, 68, 5709, 175, 190);
INSERT INTO public.who_global_data VALUES (41339, 66, 26995, 0, 1774, 175, 12);
INSERT INTO public.who_global_data VALUES (41340, 0, 336, 0, 24, 175, 104);
INSERT INTO public.who_global_data VALUES (41341, 1643, 90207, 16, 723, 175, 153);
INSERT INTO public.who_global_data VALUES (41342, 574, 252809, 3, 35234, 175, 91);
INSERT INTO public.who_global_data VALUES (41343, 6, 1071, 0, 14, 175, 215);
INSERT INTO public.who_global_data VALUES (41344, 1360, 53577, 12, 1085, 175, 84);
INSERT INTO public.who_global_data VALUES (41345, 4, 356, 0, 31, 175, 231);
INSERT INTO public.who_global_data VALUES (41346, 9, 1397, 0, 11, 175, 196);
INSERT INTO public.who_global_data VALUES (41347, 1380, 121161, 0, 1433, 175, 105);
INSERT INTO public.who_global_data VALUES (41348, 580, 29334, 5, 465, 175, 122);
INSERT INTO public.who_global_data VALUES (41349, 0, 0, 0, 0, 175, 159);
INSERT INTO public.who_global_data VALUES (41350, 142, 11087, 8, 371, 175, 75);
INSERT INTO public.who_global_data VALUES (41351, 699, 75185, 5, 494, 175, 27);
INSERT INTO public.who_global_data VALUES (41352, 272, 41645, 2, 1048, 175, 54);
INSERT INTO public.who_global_data VALUES (41353, 0, 20, 0, 0, 175, 226);
INSERT INTO public.who_global_data VALUES (41354, 1, 1308, 0, 32, 175, 79);
INSERT INTO public.who_global_data VALUES (41355, 334, 8045, 2, 94, 175, 56);
INSERT INTO public.who_global_data VALUES (41356, 19, 903, 0, 25, 175, 117);
INSERT INTO public.who_global_data VALUES (41357, 2, 1254, 0, 82, 175, 152);
INSERT INTO public.who_global_data VALUES (41358, 277, 7327, 4, 139, 175, 16);
INSERT INTO public.who_global_data VALUES (41359, 1, 94, 0, 1, 175, 10);
INSERT INTO public.who_global_data VALUES (41360, 33, 2379, 0, 81, 175, 201);
INSERT INTO public.who_global_data VALUES (41361, 37, 7405, 0, 122, 175, 174);
INSERT INTO public.who_global_data VALUES (41362, 121, 13643, 2, 164, 175, 119);
INSERT INTO public.who_global_data VALUES (41363, 76, 4988, 3, 156, 175, 168);
INSERT INTO public.who_global_data VALUES (41364, 20, 9149, 0, 125, 175, 99);
INSERT INTO public.who_global_data VALUES (41365, 78, 5572, 1, 22, 175, 171);
INSERT INTO public.who_global_data VALUES (41366, 8, 2605, 0, 125, 175, 87);
INSERT INTO public.who_global_data VALUES (41367, 72, 1242, 0, 9, 175, 123);
INSERT INTO public.who_global_data VALUES (41368, 0, 0, 0, 0, 175, 151);
INSERT INTO public.who_global_data VALUES (41369, 0, 336, 0, 16, 175, 213);
INSERT INTO public.who_global_data VALUES (41370, 31, 6653, 0, 157, 175, 118);
INSERT INTO public.who_global_data VALUES (41371, 0, 344, 0, 10, 175, 134);
INSERT INTO public.who_global_data VALUES (41372, 0, 3119, 0, 39, 175, 65);
INSERT INTO public.who_global_data VALUES (41373, 7371, 505751, 627, 55293, 175, 102);
INSERT INTO public.who_global_data VALUES (41374, 0, 0, 0, 0, 175, 223);
INSERT INTO public.who_global_data VALUES (41375, 0, 102, 0, 1, 175, 4);
INSERT INTO public.who_global_data VALUES (41376, 0, 297, 0, 0, 175, 146);
INSERT INTO public.who_global_data VALUES (41377, 53, 4011, 2, 75, 175, 31);
INSERT INTO public.who_global_data VALUES (41378, 0, 13, 0, 1, 175, 127);
INSERT INTO public.who_global_data VALUES (41379, 1306, 39241, 27, 611, 175, 22);
INSERT INTO public.who_global_data VALUES (41380, 70, 2708, 0, 19, 175, 115);
INSERT INTO public.who_global_data VALUES (41381, 8, 369, 0, 6, 175, 106);
INSERT INTO public.who_global_data VALUES (41382, 182, 3726, 4, 31, 175, 90);
INSERT INTO public.who_global_data VALUES (41383, 0, 0, 0, 0, 175, 70);
INSERT INTO public.who_global_data VALUES (41384, 594, 25551, 4, 99, 175, 46);
INSERT INTO public.who_global_data VALUES (41385, 627, 61766, 2, 6166, 175, 139);
INSERT INTO public.who_global_data VALUES (41386, 0, 23, 0, 0, 175, 42);
INSERT INTO public.who_global_data VALUES (41387, 7, 1258, 0, 22, 175, 80);
INSERT INTO public.who_global_data VALUES (41388, 0, 3413, 0, 128, 175, 203);
INSERT INTO public.who_global_data VALUES (41389, 4, 1165, 0, 69, 175, 136);
INSERT INTO public.who_global_data VALUES (41390, 329, 48445, 7, 973, 175, 63);
INSERT INTO public.who_global_data VALUES (41391, 0, 0, 0, 0, 175, 17);
INSERT INTO public.who_global_data VALUES (41392, 1, 50, 0, 2, 175, 172);
INSERT INTO public.who_global_data VALUES (41393, 0, 12386, 0, 532, 175, 109);
INSERT INTO public.who_global_data VALUES (41394, 67, 9850, 4, 261, 175, 200);
INSERT INTO public.who_global_data VALUES (41395, 531, 21056, 0, 116, 175, 93);
INSERT INTO public.who_global_data VALUES (41396, 212, 82743, 6, 557, 175, 5);
INSERT INTO public.who_global_data VALUES (41397, 0, 741, 0, 13, 175, 214);
INSERT INTO public.who_global_data VALUES (41398, 747, 288047, 9, 6162, 175, 204);
INSERT INTO public.who_global_data VALUES (41399, 0, 0, 0, 0, 175, 198);
INSERT INTO public.who_global_data VALUES (41400, 1069, 78446, 19, 1722, 175, 173);
INSERT INTO public.who_global_data VALUES (41401, 4, 275, 0, 3, 175, 229);
INSERT INTO public.who_global_data VALUES (41402, 371, 8389, 4, 97, 175, 76);
INSERT INTO public.who_global_data VALUES (41403, 9441, 507996, 3935, 25648, 175, 138);
INSERT INTO public.who_global_data VALUES (41404, 6134, 153660, 16, 2442, 175, 98);
INSERT INTO public.who_global_data VALUES (41405, 0, 0, 0, 0, 175, 103);
INSERT INTO public.who_global_data VALUES (41406, 832, 55319, 14, 1858, 175, 225);
INSERT INTO public.who_global_data VALUES (41407, 235, 53783, 2, 1772, 175, 131);
INSERT INTO public.who_global_data VALUES (41408, 682, 25128, 11, 317, 175, 235);
INSERT INTO public.who_global_data VALUES (41409, 251, 114532, 0, 190, 175, 137);
INSERT INTO public.who_global_data VALUES (41410, 166, 15039, 0, 305, 175, 81);
INSERT INTO public.who_global_data VALUES (41411, 396, 29483, 6, 884, 175, 182);
INSERT INTO public.who_global_data VALUES (41412, 22, 776, 0, 5, 175, 145);
INSERT INTO public.who_global_data VALUES (41413, 1415, 68046, 44, 2904, 175, 26);
INSERT INTO public.who_global_data VALUES (41414, 5061, 917884, 119, 15617, 175, 170);
INSERT INTO public.who_global_data VALUES (41415, 0, 2200, 0, 8, 175, 191);
INSERT INTO public.who_global_data VALUES (41416, 0, 5, 0, 0, 175, 221);
INSERT INTO public.who_global_data VALUES (41417, 0, 13, 0, 0, 175, 64);
INSERT INTO public.who_global_data VALUES (41418, 0, 0, 0, 0, 175, 116);
INSERT INTO public.who_global_data VALUES (41419, 0, 17, 0, 0, 175, 128);
INSERT INTO public.who_global_data VALUES (41420, 0, 25, 0, 0, 175, 6);
INSERT INTO public.who_global_data VALUES (41421, 0, 92, 0, 4, 175, 227);
INSERT INTO public.who_global_data VALUES (41422, 0, 4, 0, 0, 175, 68);
INSERT INTO public.who_global_data VALUES (41423, 0, 57, 0, 0, 175, 184);
INSERT INTO public.who_global_data VALUES (41424, 0, 0, 0, 0, 175, 82);
INSERT INTO public.who_global_data VALUES (41425, 0, 719, 0, 42, 175, 149);
INSERT INTO public.who_global_data VALUES (41426, 2, 885, 0, 15, 175, 197);
INSERT INTO public.who_global_data VALUES (41427, 1383, 295902, 35, 3338, 175, 78);
INSERT INTO public.who_global_data VALUES (41428, 132, 11872, 5, 249, 175, 233);
INSERT INTO public.who_global_data VALUES (41429, 235, 29233, 4, 665, 175, 133);
INSERT INTO public.who_global_data VALUES (41430, 1, 127, 0, 0, 175, 35);
INSERT INTO public.who_global_data VALUES (41431, 7, 1947, 0, 69, 175, 114);
INSERT INTO public.who_global_data VALUES (41432, 83, 55580, 0, 27, 175, 237);
INSERT INTO public.who_global_data VALUES (41433, 0, 3, 0, 0, 175, 55);
INSERT INTO public.who_global_data VALUES (41434, 15, 263, 0, 17, 175, 176);
INSERT INTO public.who_global_data VALUES (41435, 62, 2801, 0, 31, 175, 202);
INSERT INTO public.who_global_data VALUES (41436, 32, 2402, 0, 131, 175, 155);
INSERT INTO public.who_global_data VALUES (41437, 0, 0, 0, 0, 175, 32);
INSERT INTO public.who_global_data VALUES (41438, 23, 3250, 0, 93, 175, 220);
INSERT INTO public.who_global_data VALUES (41439, 6275, 579140, 286, 11556, 175, 30);
INSERT INTO public.who_global_data VALUES (41440, 6, 2488, 0, 47, 175, 147);
INSERT INTO public.who_global_data VALUES (41441, 7171, 365763, 23, 30165, 175, 208);
INSERT INTO public.who_global_data VALUES (41442, 0, 2882, 0, 11, 175, 45);
INSERT INTO public.who_global_data VALUES (41443, 103, 12314, 2, 798, 175, 110);
INSERT INTO public.who_global_data VALUES (41444, 108, 2761, 1, 40, 175, 88);
INSERT INTO public.who_global_data VALUES (41445, 363, 80715, 5, 5797, 175, 51);
INSERT INTO public.who_global_data VALUES (41446, 233, 38012, 0, 1747, 175, 209);
INSERT INTO public.who_global_data VALUES (41447, 83, 1515, 3, 58, 175, 205);
INSERT INTO public.who_global_data VALUES (41448, 39, 7989, 0, 63, 175, 18);
INSERT INTO public.who_global_data VALUES (41449, 0, 3376, 0, 58, 175, 72);
INSERT INTO public.who_global_data VALUES (41450, 1440, 316371, 11, 41358, 175, 44);
INSERT INTO public.who_global_data VALUES (41451, 0, 25, 0, 0, 175, 15);
INSERT INTO public.who_global_data VALUES (41452, 0, 1092, 0, 26, 175, 25);
INSERT INTO public.who_global_data VALUES (41453, 0, 0, 0, 0, 175, 179);
INSERT INTO public.who_global_data VALUES (41454, 0, 0, 0, 0, 175, 34);
INSERT INTO public.who_global_data VALUES (41455, 43, 412, 0, 8, 175, 207);
INSERT INTO public.who_global_data VALUES (41456, 120, 2023, 1, 54, 175, 166);
INSERT INTO public.who_global_data VALUES (41457, 7956, 368001, 22, 5934, 175, 126);
INSERT INTO public.who_global_data VALUES (41458, 0, 0, 0, 0, 175, 97);
INSERT INTO public.who_global_data VALUES (41459, 17, 258, 0, 2, 175, 36);
INSERT INTO public.who_global_data VALUES (41460, 0, 0, 0, 0, 175, 125);
INSERT INTO public.who_global_data VALUES (41461, 32, 1385, 1, 12, 175, 124);
INSERT INTO public.who_global_data VALUES (41462, 1847, 89719, 33, 2044, 175, 185);
INSERT INTO public.who_global_data VALUES (41463, 330, 63819, 1, 359, 175, 194);
INSERT INTO public.who_global_data VALUES (41464, 0, 509, 0, 21, 175, 144);
INSERT INTO public.who_global_data VALUES (41465, 52799, 5203206, 1169, 165995, 175, 19);
INSERT INTO public.who_global_data VALUES (41466, 22, 704, 0, 9, 175, 217);
INSERT INTO public.who_global_data VALUES (41467, 16, 1409, 0, 37, 175, 148);
INSERT INTO public.who_global_data VALUES (41468, 690, 34251, 5, 223, 175, 86);
INSERT INTO public.who_global_data VALUES (41469, 0, 0, 0, 0, 175, 13);
INSERT INTO public.who_global_data VALUES (41470, 1281, 30369, 12, 259, 175, 157);
INSERT INTO public.who_global_data VALUES (41471, 19, 930, 1, 22, 175, 8);
INSERT INTO public.who_global_data VALUES (41472, 0, 0, 0, 0, 175, 73);
INSERT INTO public.who_global_data VALUES (41473, 11, 1862, 0, 529, 175, 101);
INSERT INTO public.who_global_data VALUES (41474, 358, 9021, 10, 256, 175, 165);
INSERT INTO public.who_global_data VALUES (41475, 82, 5072, 0, 128, 175, 14);
INSERT INTO public.who_global_data VALUES (41476, 7, 37517, 0, 1367, 176, 193);
INSERT INTO public.who_global_data VALUES (41477, 154, 6971, 5, 213, 176, 113);
INSERT INTO public.who_global_data VALUES (41478, 488, 37187, 8, 1341, 176, 143);
INSERT INTO public.who_global_data VALUES (41479, 0, 0, 0, 0, 176, 219);
INSERT INTO public.who_global_data VALUES (41480, 4, 981, 0, 53, 176, 186);
INSERT INTO public.who_global_data VALUES (41481, 53, 1815, 3, 83, 176, 52);
INSERT INTO public.who_global_data VALUES (41482, 0, 3, 0, 0, 176, 180);
INSERT INTO public.who_global_data VALUES (41483, 0, 92, 0, 3, 176, 167);
INSERT INTO public.who_global_data VALUES (41484, 7663, 268574, 158, 5246, 176, 154);
INSERT INTO public.who_global_data VALUES (41485, 276, 40612, 5, 809, 176, 94);
INSERT INTO public.who_global_data VALUES (41486, 81, 798, 0, 3, 176, 66);
INSERT INTO public.who_global_data VALUES (41487, 231, 22358, 9, 361, 176, 58);
INSERT INTO public.who_global_data VALUES (41488, 229, 22730, 1, 725, 176, 163);
INSERT INTO public.who_global_data VALUES (41489, 91, 33915, 3, 500, 176, 37);
INSERT INTO public.who_global_data VALUES (41490, 47, 1036, 0, 15, 176, 142);
INSERT INTO public.who_global_data VALUES (41491, 462, 45726, 1, 167, 176, 83);
INSERT INTO public.who_global_data VALUES (41492, 2617, 269115, 44, 3557, 176, 228);
INSERT INTO public.who_global_data VALUES (41493, 1, 144, 0, 7, 176, 188);
INSERT INTO public.who_global_data VALUES (41494, 101, 69203, 4, 599, 176, 62);
INSERT INTO public.who_global_data VALUES (41495, 669, 78040, 12, 9786, 176, 160);
INSERT INTO public.who_global_data VALUES (41496, 86, 296, 0, 2, 176, 50);
INSERT INTO public.who_global_data VALUES (41497, 0, 2014, 0, 38, 176, 33);
INSERT INTO public.who_global_data VALUES (41498, 0, 159, 0, 9, 176, 183);
INSERT INTO public.who_global_data VALUES (41499, 3, 131, 0, 0, 176, 92);
INSERT INTO public.who_global_data VALUES (41500, 1743, 95071, 66, 3827, 176, 158);
INSERT INTO public.who_global_data VALUES (41501, 0, 5, 0, 0, 176, 67);
INSERT INTO public.who_global_data VALUES (41502, 227, 15187, 5, 453, 176, 57);
INSERT INTO public.who_global_data VALUES (41503, 148, 1214, 1, 3, 176, 38);
INSERT INTO public.who_global_data VALUES (41504, 55155, 3164785, 1175, 104201, 176, 141);
INSERT INTO public.who_global_data VALUES (41505, 0, 9, 0, 1, 176, 178);
INSERT INTO public.who_global_data VALUES (41506, 0, 142, 0, 3, 176, 108);
INSERT INTO public.who_global_data VALUES (41507, 176, 14069, 2, 484, 176, 39);
INSERT INTO public.who_global_data VALUES (41508, 15, 1228, 0, 54, 176, 2);
INSERT INTO public.who_global_data VALUES (41509, 2, 412, 0, 1, 176, 195);
INSERT INTO public.who_global_data VALUES (41510, 73, 3073, 0, 33, 176, 107);
INSERT INTO public.who_global_data VALUES (41511, 1, 273, 0, 0, 176, 161);
INSERT INTO public.who_global_data VALUES (41512, 161, 18469, 0, 401, 176, 212);
INSERT INTO public.who_global_data VALUES (41513, 423, 120844, 15, 9006, 176, 181);
INSERT INTO public.who_global_data VALUES (41514, 0, 203, 0, 1, 176, 53);
INSERT INTO public.who_global_data VALUES (41515, 0, 4652, 0, 61, 176, 164);
INSERT INTO public.who_global_data VALUES (41516, 0, 949, 0, 76, 176, 140);
INSERT INTO public.who_global_data VALUES (41517, 1866, 380034, 94, 10299, 176, 20);
INSERT INTO public.who_global_data VALUES (41518, 99, 89625, 3, 4707, 176, 112);
INSERT INTO public.who_global_data VALUES (41519, 12066, 422519, 362, 13837, 176, 111);
INSERT INTO public.who_global_data VALUES (41520, 4, 403, 0, 7, 176, 71);
INSERT INTO public.who_global_data VALUES (41521, 0, 3745, 0, 60, 176, 218);
INSERT INTO public.who_global_data VALUES (41522, 0, 0, 0, 0, 176, 43);
INSERT INTO public.who_global_data VALUES (41523, 549, 25057, 8, 263, 176, 49);
INSERT INTO public.who_global_data VALUES (41524, 0, 16847, 0, 105, 176, 1);
INSERT INTO public.who_global_data VALUES (41525, 180, 6050, 1, 161, 176, 48);
INSERT INTO public.who_global_data VALUES (41526, 46, 3174, 1, 89, 176, 232);
INSERT INTO public.who_global_data VALUES (41527, 0, 32, 0, 1, 176, 175);
INSERT INTO public.who_global_data VALUES (41528, 14, 1305, 0, 20, 176, 21);
INSERT INTO public.who_global_data VALUES (41529, 326, 19401, 0, 391, 176, 156);
INSERT INTO public.who_global_data VALUES (41530, 0, 0, 0, 0, 176, 95);
INSERT INTO public.who_global_data VALUES (41531, 51, 9588, 9, 234, 176, 177);
INSERT INTO public.who_global_data VALUES (41532, 144, 15214, 0, 621, 176, 210);
INSERT INTO public.who_global_data VALUES (41533, 0, 5358, 0, 59, 176, 120);
INSERT INTO public.who_global_data VALUES (41534, 0, 18, 0, 0, 176, 135);
INSERT INTO public.who_global_data VALUES (41535, 910, 83134, 22, 1393, 176, 206);
INSERT INTO public.who_global_data VALUES (41536, 1233, 98343, 26, 6010, 176, 189);
INSERT INTO public.who_global_data VALUES (41537, 145, 96108, 22, 5107, 176, 129);
INSERT INTO public.who_global_data VALUES (41538, 349, 21993, 7, 584, 176, 121);
INSERT INTO public.who_global_data VALUES (41539, 0, 4821, 0, 83, 176, 59);
INSERT INTO public.who_global_data VALUES (41540, 0, 285, 0, 0, 176, 96);
INSERT INTO public.who_global_data VALUES (41541, 0, 2174, 0, 63, 176, 41);
INSERT INTO public.who_global_data VALUES (41542, 74, 3599, 2, 65, 176, 216);
INSERT INTO public.who_global_data VALUES (41543, 1068, 26204, 16, 479, 176, 236);
INSERT INTO public.who_global_data VALUES (41544, 0, 13, 0, 0, 176, 150);
INSERT INTO public.who_global_data VALUES (41545, 23, 362, 0, 0, 176, 61);
INSERT INTO public.who_global_data VALUES (41546, 1, 28, 0, 1, 176, 7);
INSERT INTO public.who_global_data VALUES (41547, 41, 7683, 0, 333, 176, 169);
INSERT INTO public.who_global_data VALUES (41548, 2515, 196209, 16, 30259, 176, 28);
INSERT INTO public.who_global_data VALUES (41549, 48, 8471, 1, 51, 176, 85);
INSERT INTO public.who_global_data VALUES (41550, 0, 139, 0, 0, 176, 211);
INSERT INTO public.who_global_data VALUES (41551, 0, 8077, 0, 51, 176, 60);
INSERT INTO public.who_global_data VALUES (41552, 79, 1556, 10, 43, 176, 3);
INSERT INTO public.who_global_data VALUES (41553, 23, 1306, 0, 17, 176, 11);
INSERT INTO public.who_global_data VALUES (41554, 1449, 221413, 14, 9225, 176, 89);
INSERT INTO public.who_global_data VALUES (41555, 275, 41847, 0, 223, 176, 24);
INSERT INTO public.who_global_data VALUES (41556, 1, 203, 0, 0, 176, 162);
INSERT INTO public.who_global_data VALUES (41557, 204, 6381, 5, 221, 176, 100);
INSERT INTO public.who_global_data VALUES (41558, 0, 14, 0, 0, 176, 47);
INSERT INTO public.who_global_data VALUES (41559, 0, 24, 0, 0, 176, 29);
INSERT INTO public.who_global_data VALUES (41560, 50, 367, 0, 14, 176, 40);
INSERT INTO public.who_global_data VALUES (41561, 28, 469, 0, 5, 176, 222);
INSERT INTO public.who_global_data VALUES (41562, 1195, 60284, 29, 2296, 176, 132);
INSERT INTO public.who_global_data VALUES (41563, 0, 252, 0, 13, 176, 130);
INSERT INTO public.who_global_data VALUES (41564, 82, 8198, 0, 50, 176, 234);
INSERT INTO public.who_global_data VALUES (41565, 0, 2052, 0, 29, 176, 23);
INSERT INTO public.who_global_data VALUES (41566, 21, 623, 0, 22, 176, 192);
INSERT INTO public.who_global_data VALUES (41567, 38, 7781, 5, 192, 176, 69);
INSERT INTO public.who_global_data VALUES (41568, 0, 12, 0, 0, 176, 187);
INSERT INTO public.who_global_data VALUES (41569, 254, 48657, 18, 1533, 176, 230);
INSERT INTO public.who_global_data VALUES (41570, 45, 4813, 2, 607, 176, 77);
INSERT INTO public.who_global_data VALUES (41571, 4, 1976, 0, 10, 176, 9);
INSERT INTO public.who_global_data VALUES (41572, 64553, 2461190, 1007, 48040, 176, 74);
INSERT INTO public.who_global_data VALUES (41573, 2098, 132816, 65, 5968, 176, 224);
INSERT INTO public.who_global_data VALUES (41574, 2625, 336324, 174, 19162, 176, 199);
INSERT INTO public.who_global_data VALUES (41575, 3841, 164277, 53, 5641, 176, 190);
INSERT INTO public.who_global_data VALUES (41576, 91, 26929, 0, 1774, 176, 12);
INSERT INTO public.who_global_data VALUES (41577, 0, 336, 0, 24, 176, 104);
INSERT INTO public.who_global_data VALUES (41578, 1622, 88564, 15, 707, 176, 153);
INSERT INTO public.who_global_data VALUES (41579, 522, 252235, 6, 35231, 176, 91);
INSERT INTO public.who_global_data VALUES (41580, 18, 1065, 0, 14, 176, 215);
INSERT INTO public.who_global_data VALUES (41581, 1070, 52217, 10, 1073, 176, 84);
INSERT INTO public.who_global_data VALUES (41582, 4, 352, 0, 31, 176, 231);
INSERT INTO public.who_global_data VALUES (41583, 17, 1388, 0, 11, 176, 196);
INSERT INTO public.who_global_data VALUES (41584, 1267, 119781, 0, 1433, 176, 105);
INSERT INTO public.who_global_data VALUES (41585, 650, 28754, 4, 460, 176, 122);
INSERT INTO public.who_global_data VALUES (41586, 0, 0, 0, 0, 176, 159);
INSERT INTO public.who_global_data VALUES (41587, 193, 10945, 8, 363, 176, 75);
INSERT INTO public.who_global_data VALUES (41588, 701, 74486, 0, 489, 176, 27);
INSERT INTO public.who_global_data VALUES (41589, 304, 41373, 4, 1046, 176, 54);
INSERT INTO public.who_global_data VALUES (41590, 0, 20, 0, 0, 176, 226);
INSERT INTO public.who_global_data VALUES (41591, 4, 1307, 0, 32, 176, 79);
INSERT INTO public.who_global_data VALUES (41592, 298, 7711, 3, 92, 176, 56);
INSERT INTO public.who_global_data VALUES (41593, 69, 884, 1, 25, 176, 117);
INSERT INTO public.who_global_data VALUES (41594, 0, 1252, 0, 82, 176, 152);
INSERT INTO public.who_global_data VALUES (41595, 439, 7050, 3, 135, 176, 16);
INSERT INTO public.who_global_data VALUES (41596, 1, 93, 0, 1, 176, 10);
INSERT INTO public.who_global_data VALUES (41597, 22, 2346, 0, 81, 176, 201);
INSERT INTO public.who_global_data VALUES (41598, 68, 7368, 0, 122, 176, 174);
INSERT INTO public.who_global_data VALUES (41599, 125, 13522, 6, 162, 176, 119);
INSERT INTO public.who_global_data VALUES (41600, 160, 4912, 1, 153, 176, 168);
INSERT INTO public.who_global_data VALUES (41601, 15, 9129, 0, 125, 176, 99);
INSERT INTO public.who_global_data VALUES (41602, 128, 5494, 0, 21, 176, 171);
INSERT INTO public.who_global_data VALUES (41603, 15, 2597, 0, 125, 176, 87);
INSERT INTO public.who_global_data VALUES (41604, 31, 1170, 0, 9, 176, 123);
INSERT INTO public.who_global_data VALUES (41605, 0, 0, 0, 0, 176, 151);
INSERT INTO public.who_global_data VALUES (41606, 0, 336, 0, 16, 176, 213);
INSERT INTO public.who_global_data VALUES (41607, 0, 6622, 0, 157, 176, 118);
INSERT INTO public.who_global_data VALUES (41608, 0, 344, 0, 10, 176, 134);
INSERT INTO public.who_global_data VALUES (41609, 28, 3119, 0, 39, 176, 65);
INSERT INTO public.who_global_data VALUES (41610, 5858, 498380, 737, 54666, 176, 102);
INSERT INTO public.who_global_data VALUES (41611, 0, 0, 0, 0, 176, 223);
INSERT INTO public.who_global_data VALUES (41612, 2, 102, 0, 1, 176, 4);
INSERT INTO public.who_global_data VALUES (41613, 4, 297, 0, 0, 176, 146);
INSERT INTO public.who_global_data VALUES (41614, 80, 3958, 0, 73, 176, 31);
INSERT INTO public.who_global_data VALUES (41615, 0, 13, 0, 1, 176, 127);
INSERT INTO public.who_global_data VALUES (41616, 1241, 37935, 28, 584, 176, 22);
INSERT INTO public.who_global_data VALUES (41617, 79, 2638, 0, 19, 176, 115);
INSERT INTO public.who_global_data VALUES (41618, 0, 361, 0, 6, 176, 106);
INSERT INTO public.who_global_data VALUES (41619, 138, 3544, 5, 27, 176, 90);
INSERT INTO public.who_global_data VALUES (41620, 0, 0, 0, 0, 176, 70);
INSERT INTO public.who_global_data VALUES (41621, 525, 24957, 4, 95, 176, 46);
INSERT INTO public.who_global_data VALUES (41622, 576, 61139, 4, 6164, 176, 139);
INSERT INTO public.who_global_data VALUES (41623, 0, 23, 0, 0, 176, 42);
INSERT INTO public.who_global_data VALUES (41624, 13, 1251, 0, 22, 176, 80);
INSERT INTO public.who_global_data VALUES (41625, 0, 3413, 0, 128, 176, 203);
INSERT INTO public.who_global_data VALUES (41626, 0, 1161, 0, 69, 176, 136);
INSERT INTO public.who_global_data VALUES (41627, 373, 48116, 10, 966, 176, 63);
INSERT INTO public.who_global_data VALUES (41628, 0, 0, 0, 0, 176, 17);
INSERT INTO public.who_global_data VALUES (41629, 0, 49, 0, 2, 176, 172);
INSERT INTO public.who_global_data VALUES (41630, 141, 12386, 2, 532, 176, 109);
INSERT INTO public.who_global_data VALUES (41631, 33, 9783, 1, 257, 176, 200);
INSERT INTO public.who_global_data VALUES (41632, 432, 20525, 1, 116, 176, 93);
INSERT INTO public.who_global_data VALUES (41633, 232, 82531, 12, 551, 176, 5);
INSERT INTO public.who_global_data VALUES (41634, 0, 741, 0, 13, 176, 214);
INSERT INTO public.who_global_data VALUES (41635, 626, 287300, 14, 6153, 176, 204);
INSERT INTO public.who_global_data VALUES (41636, 0, 0, 0, 0, 176, 198);
INSERT INTO public.who_global_data VALUES (41637, 913, 77377, 23, 1703, 176, 173);
INSERT INTO public.who_global_data VALUES (41638, 2, 271, 0, 3, 176, 229);
INSERT INTO public.who_global_data VALUES (41639, 499, 8018, 7, 93, 176, 76);
INSERT INTO public.who_global_data VALUES (41640, 8875, 498555, 212, 21713, 176, 138);
INSERT INTO public.who_global_data VALUES (41641, 3777, 147526, 22, 2426, 176, 98);
INSERT INTO public.who_global_data VALUES (41642, 0, 0, 0, 0, 176, 103);
INSERT INTO public.who_global_data VALUES (41643, 811, 54487, 14, 1844, 176, 225);
INSERT INTO public.who_global_data VALUES (41644, 325, 53548, 6, 1770, 176, 131);
INSERT INTO public.who_global_data VALUES (41645, 372, 24446, 11, 306, 176, 235);
INSERT INTO public.who_global_data VALUES (41646, 343, 114281, 0, 190, 176, 137);
INSERT INTO public.who_global_data VALUES (41647, 103, 14873, 0, 305, 176, 81);
INSERT INTO public.who_global_data VALUES (41648, 390, 29087, 15, 878, 176, 182);
INSERT INTO public.who_global_data VALUES (41649, 20, 754, 0, 5, 176, 145);
INSERT INTO public.who_global_data VALUES (41650, 1454, 66631, 53, 2860, 176, 26);
INSERT INTO public.who_global_data VALUES (41651, 5065, 912823, 114, 15498, 176, 170);
INSERT INTO public.who_global_data VALUES (41652, 11, 2200, 0, 8, 176, 191);
INSERT INTO public.who_global_data VALUES (41653, 0, 5, 0, 0, 176, 221);
INSERT INTO public.who_global_data VALUES (41654, 0, 13, 0, 0, 176, 64);
INSERT INTO public.who_global_data VALUES (41655, 0, 0, 0, 0, 176, 116);
INSERT INTO public.who_global_data VALUES (41656, 0, 17, 0, 0, 176, 128);
INSERT INTO public.who_global_data VALUES (41657, 0, 25, 0, 0, 176, 6);
INSERT INTO public.who_global_data VALUES (41658, 8, 92, 0, 4, 176, 227);
INSERT INTO public.who_global_data VALUES (41659, 0, 4, 0, 0, 176, 68);
INSERT INTO public.who_global_data VALUES (41660, 0, 57, 0, 0, 176, 184);
INSERT INTO public.who_global_data VALUES (41661, 0, 0, 0, 0, 176, 82);
INSERT INTO public.who_global_data VALUES (41662, 0, 719, 0, 42, 176, 149);
INSERT INTO public.who_global_data VALUES (41663, 1, 883, 0, 15, 176, 197);
INSERT INTO public.who_global_data VALUES (41664, 1482, 294519, 34, 3303, 176, 78);
INSERT INTO public.who_global_data VALUES (41665, 153, 11740, 2, 244, 176, 233);
INSERT INTO public.who_global_data VALUES (41666, 247, 28998, 3, 661, 176, 133);
INSERT INTO public.who_global_data VALUES (41667, 0, 126, 0, 0, 176, 35);
INSERT INTO public.who_global_data VALUES (41668, 3, 1940, 0, 69, 176, 114);
INSERT INTO public.who_global_data VALUES (41669, 102, 55497, 0, 27, 176, 237);
INSERT INTO public.who_global_data VALUES (41670, 0, 3, 0, 0, 176, 55);
INSERT INTO public.who_global_data VALUES (41671, 29, 248, 0, 17, 176, 176);
INSERT INTO public.who_global_data VALUES (41672, 49, 2739, 0, 31, 176, 202);
INSERT INTO public.who_global_data VALUES (41673, 37, 2370, 0, 131, 176, 155);
INSERT INTO public.who_global_data VALUES (41674, 0, 0, 0, 0, 176, 32);
INSERT INTO public.who_global_data VALUES (41675, 0, 3227, 0, 93, 176, 220);
INSERT INTO public.who_global_data VALUES (41676, 3946, 572865, 260, 11270, 176, 30);
INSERT INTO public.who_global_data VALUES (41677, 4, 2482, 0, 47, 176, 147);
INSERT INTO public.who_global_data VALUES (41678, 6549, 358592, 25, 30142, 176, 208);
INSERT INTO public.who_global_data VALUES (41679, 2, 2882, 0, 11, 176, 45);
INSERT INTO public.who_global_data VALUES (41680, 49, 12211, 3, 796, 176, 110);
INSERT INTO public.who_global_data VALUES (41681, 94, 2653, 0, 39, 176, 88);
INSERT INTO public.who_global_data VALUES (41682, 443, 80352, 3, 5792, 176, 51);
INSERT INTO public.who_global_data VALUES (41683, 273, 37779, 1, 1747, 176, 209);
INSERT INTO public.who_global_data VALUES (41684, 30, 1432, 2, 55, 176, 205);
INSERT INTO public.who_global_data VALUES (41685, 38, 7950, 0, 63, 176, 18);
INSERT INTO public.who_global_data VALUES (41686, 17, 3376, 0, 58, 176, 72);
INSERT INTO public.who_global_data VALUES (41687, 1129, 314931, 18, 41347, 176, 44);
INSERT INTO public.who_global_data VALUES (41688, 0, 25, 0, 0, 176, 15);
INSERT INTO public.who_global_data VALUES (41689, 25, 1092, 1, 26, 176, 25);
INSERT INTO public.who_global_data VALUES (41690, 0, 0, 0, 0, 176, 179);
INSERT INTO public.who_global_data VALUES (41691, 0, 0, 0, 0, 176, 34);
INSERT INTO public.who_global_data VALUES (41692, 61, 369, 0, 8, 176, 207);
INSERT INTO public.who_global_data VALUES (41693, 56, 1903, 0, 53, 176, 166);
INSERT INTO public.who_global_data VALUES (41694, 7973, 360045, 21, 5912, 176, 126);
INSERT INTO public.who_global_data VALUES (41695, 0, 0, 0, 0, 176, 97);
INSERT INTO public.who_global_data VALUES (41696, 17, 241, 0, 2, 176, 36);
INSERT INTO public.who_global_data VALUES (41697, 0, 0, 0, 0, 176, 125);
INSERT INTO public.who_global_data VALUES (41698, 21, 1353, 2, 11, 176, 124);
INSERT INTO public.who_global_data VALUES (41699, 1732, 87872, 19, 2011, 176, 185);
INSERT INTO public.who_global_data VALUES (41700, 277, 63489, 0, 358, 176, 194);
INSERT INTO public.who_global_data VALUES (41701, 0, 509, 0, 21, 176, 144);
INSERT INTO public.who_global_data VALUES (41702, 55907, 5150407, 1486, 164826, 176, 19);
INSERT INTO public.who_global_data VALUES (41703, 43, 682, 0, 9, 176, 217);
INSERT INTO public.who_global_data VALUES (41704, 8, 1393, 0, 37, 176, 148);
INSERT INTO public.who_global_data VALUES (41705, 724, 33561, 5, 218, 176, 86);
INSERT INTO public.who_global_data VALUES (41706, 0, 0, 0, 0, 176, 13);
INSERT INTO public.who_global_data VALUES (41707, 1150, 29088, 9, 247, 176, 157);
INSERT INTO public.who_global_data VALUES (41708, 28, 911, 3, 21, 176, 8);
INSERT INTO public.who_global_data VALUES (41709, 0, 0, 0, 0, 176, 73);
INSERT INTO public.who_global_data VALUES (41710, 6, 1851, 0, 529, 176, 101);
INSERT INTO public.who_global_data VALUES (41711, 162, 8663, 0, 246, 176, 165);
INSERT INTO public.who_global_data VALUES (41712, 97, 4990, 6, 128, 176, 14);
INSERT INTO public.who_global_data VALUES (41713, 79, 37510, 9, 1367, 177, 193);
INSERT INTO public.who_global_data VALUES (41714, 141, 6817, 3, 208, 177, 113);
INSERT INTO public.who_global_data VALUES (41715, 495, 36699, 11, 1333, 177, 143);
INSERT INTO public.who_global_data VALUES (41716, 0, 0, 0, 0, 177, 219);
INSERT INTO public.who_global_data VALUES (41717, 4, 977, 1, 53, 177, 186);
INSERT INTO public.who_global_data VALUES (41718, 27, 1762, 0, 80, 177, 52);
INSERT INTO public.who_global_data VALUES (41719, 0, 3, 0, 0, 177, 180);
INSERT INTO public.who_global_data VALUES (41720, 0, 92, 0, 3, 177, 167);
INSERT INTO public.who_global_data VALUES (41721, 7043, 260911, 303, 5088, 177, 154);
INSERT INTO public.who_global_data VALUES (41722, 229, 40336, 3, 804, 177, 94);
INSERT INTO public.who_global_data VALUES (41723, 87, 717, 0, 3, 177, 66);
INSERT INTO public.who_global_data VALUES (41724, 414, 22127, 21, 352, 177, 58);
INSERT INTO public.who_global_data VALUES (41725, 241, 22501, 1, 724, 177, 163);
INSERT INTO public.who_global_data VALUES (41726, 93, 33824, 2, 497, 177, 37);
INSERT INTO public.who_global_data VALUES (41727, 44, 989, 0, 15, 177, 142);
INSERT INTO public.who_global_data VALUES (41728, 460, 45264, 1, 166, 177, 83);
INSERT INTO public.who_global_data VALUES (41729, 2995, 266498, 42, 3513, 177, 228);
INSERT INTO public.who_global_data VALUES (41730, 0, 143, 0, 7, 177, 188);
INSERT INTO public.who_global_data VALUES (41731, 97, 69102, 3, 595, 177, 62);
INSERT INTO public.who_global_data VALUES (41732, 609, 77371, 11, 9774, 177, 160);
INSERT INTO public.who_global_data VALUES (41733, 33, 210, 0, 2, 177, 50);
INSERT INTO public.who_global_data VALUES (41734, 0, 2014, 0, 38, 177, 33);
INSERT INTO public.who_global_data VALUES (41735, 0, 159, 0, 9, 177, 183);
INSERT INTO public.who_global_data VALUES (41736, 15, 128, 0, 0, 177, 92);
INSERT INTO public.who_global_data VALUES (41737, 1693, 93328, 49, 3761, 177, 158);
INSERT INTO public.who_global_data VALUES (41738, 0, 5, 0, 0, 177, 67);
INSERT INTO public.who_global_data VALUES (41739, 254, 14960, 6, 448, 177, 57);
INSERT INTO public.who_global_data VALUES (41740, 0, 1066, 0, 2, 177, 38);
INSERT INTO public.who_global_data VALUES (41741, 52160, 3109630, 1274, 103026, 177, 141);
INSERT INTO public.who_global_data VALUES (41742, 0, 9, 0, 1, 177, 178);
INSERT INTO public.who_global_data VALUES (41743, 0, 142, 0, 3, 177, 108);
INSERT INTO public.who_global_data VALUES (41744, 171, 13893, 11, 482, 177, 39);
INSERT INTO public.who_global_data VALUES (41745, 2, 1213, 0, 54, 177, 2);
INSERT INTO public.who_global_data VALUES (41746, 1, 410, 0, 1, 177, 195);
INSERT INTO public.who_global_data VALUES (41747, 80, 3000, 0, 33, 177, 107);
INSERT INTO public.who_global_data VALUES (41748, 4, 272, 0, 0, 177, 161);
INSERT INTO public.who_global_data VALUES (41749, 45, 18308, 0, 401, 177, 212);
INSERT INTO public.who_global_data VALUES (41750, 289, 120421, 4, 8991, 177, 181);
INSERT INTO public.who_global_data VALUES (41751, 0, 203, 0, 1, 177, 53);
INSERT INTO public.who_global_data VALUES (41752, 5, 4652, 0, 61, 177, 164);
INSERT INTO public.who_global_data VALUES (41753, 3, 949, 0, 76, 177, 140);
INSERT INTO public.who_global_data VALUES (41754, 1552, 378168, 27, 10205, 177, 20);
INSERT INTO public.who_global_data VALUES (41755, 82, 89526, 5, 4704, 177, 112);
INSERT INTO public.who_global_data VALUES (41756, 12830, 410453, 321, 13475, 177, 111);
INSERT INTO public.who_global_data VALUES (41757, 0, 399, 0, 7, 177, 71);
INSERT INTO public.who_global_data VALUES (41758, 0, 3745, 0, 60, 177, 218);
INSERT INTO public.who_global_data VALUES (41759, 0, 0, 0, 0, 177, 43);
INSERT INTO public.who_global_data VALUES (41760, 636, 24508, 11, 255, 177, 49);
INSERT INTO public.who_global_data VALUES (41761, 0, 16847, 0, 105, 177, 1);
INSERT INTO public.who_global_data VALUES (41762, 130, 5870, 0, 160, 177, 48);
INSERT INTO public.who_global_data VALUES (41763, 35, 3128, 0, 88, 177, 232);
INSERT INTO public.who_global_data VALUES (41764, 0, 32, 0, 1, 177, 175);
INSERT INTO public.who_global_data VALUES (41765, 14, 1291, 0, 20, 177, 21);
INSERT INTO public.who_global_data VALUES (41766, 292, 19075, 0, 391, 177, 156);
INSERT INTO public.who_global_data VALUES (41767, 0, 0, 0, 0, 177, 95);
INSERT INTO public.who_global_data VALUES (41768, 39, 9537, 0, 225, 177, 177);
INSERT INTO public.who_global_data VALUES (41769, 111, 15070, 0, 621, 177, 210);
INSERT INTO public.who_global_data VALUES (41770, 10, 5358, 0, 59, 177, 120);
INSERT INTO public.who_global_data VALUES (41771, 0, 18, 0, 0, 177, 135);
INSERT INTO public.who_global_data VALUES (41772, 1130, 82224, 25, 1371, 177, 206);
INSERT INTO public.who_global_data VALUES (41773, 1547, 97110, 33, 5984, 177, 189);
INSERT INTO public.who_global_data VALUES (41774, 129, 95963, 26, 5085, 177, 129);
INSERT INTO public.who_global_data VALUES (41775, 375, 21644, 7, 577, 177, 121);
INSERT INTO public.who_global_data VALUES (41776, 0, 4821, 0, 83, 177, 59);
INSERT INTO public.who_global_data VALUES (41777, 0, 285, 0, 0, 177, 96);
INSERT INTO public.who_global_data VALUES (41778, 7, 2174, 0, 63, 177, 41);
INSERT INTO public.who_global_data VALUES (41779, 115, 3525, 0, 63, 177, 216);
INSERT INTO public.who_global_data VALUES (41780, 961, 25136, 23, 463, 177, 236);
INSERT INTO public.who_global_data VALUES (41781, 0, 13, 0, 0, 177, 150);
INSERT INTO public.who_global_data VALUES (41782, 15, 339, 0, 0, 177, 61);
INSERT INTO public.who_global_data VALUES (41783, 0, 27, 0, 1, 177, 7);
INSERT INTO public.who_global_data VALUES (41784, 19, 7642, 0, 333, 177, 169);
INSERT INTO public.who_global_data VALUES (41785, 2429, 193694, 16, 30243, 177, 28);
INSERT INTO public.who_global_data VALUES (41786, 63, 8423, 1, 50, 177, 85);
INSERT INTO public.who_global_data VALUES (41787, 27, 139, 0, 0, 177, 211);
INSERT INTO public.who_global_data VALUES (41788, 71, 8077, 0, 51, 177, 60);
INSERT INTO public.who_global_data VALUES (41789, 0, 1477, 0, 33, 177, 3);
INSERT INTO public.who_global_data VALUES (41790, 5, 1283, 0, 17, 177, 11);
INSERT INTO public.who_global_data VALUES (41791, 1445, 219964, 4, 9211, 177, 89);
INSERT INTO public.who_global_data VALUES (41792, 168, 41572, 8, 223, 177, 24);
INSERT INTO public.who_global_data VALUES (41793, 1, 202, 0, 0, 177, 162);
INSERT INTO public.who_global_data VALUES (41794, 235, 6177, 2, 216, 177, 100);
INSERT INTO public.who_global_data VALUES (41795, 0, 14, 0, 0, 177, 47);
INSERT INTO public.who_global_data VALUES (41796, 0, 24, 0, 0, 177, 29);
INSERT INTO public.who_global_data VALUES (41797, 0, 317, 0, 14, 177, 40);
INSERT INTO public.who_global_data VALUES (41798, 15, 441, 0, 5, 177, 222);
INSERT INTO public.who_global_data VALUES (41799, 1123, 59089, 34, 2267, 177, 132);
INSERT INTO public.who_global_data VALUES (41800, 0, 252, 0, 13, 177, 130);
INSERT INTO public.who_global_data VALUES (41801, 98, 8116, 0, 50, 177, 234);
INSERT INTO public.who_global_data VALUES (41802, 0, 2052, 0, 29, 177, 23);
INSERT INTO public.who_global_data VALUES (41803, 34, 602, 0, 22, 177, 192);
INSERT INTO public.who_global_data VALUES (41804, 94, 7743, 4, 187, 177, 69);
INSERT INTO public.who_global_data VALUES (41805, 0, 12, 0, 0, 177, 187);
INSERT INTO public.who_global_data VALUES (41806, 531, 48403, 9, 1515, 177, 230);
INSERT INTO public.who_global_data VALUES (41807, 22, 4768, 0, 605, 177, 77);
INSERT INTO public.who_global_data VALUES (41808, 4, 1972, 0, 10, 177, 9);
INSERT INTO public.who_global_data VALUES (41809, 66999, 2396637, 942, 47033, 177, 74);
INSERT INTO public.who_global_data VALUES (41810, 1942, 130718, 79, 5903, 177, 224);
INSERT INTO public.who_global_data VALUES (41811, 2510, 333699, 188, 18988, 177, 199);
INSERT INTO public.who_global_data VALUES (41812, 3441, 160436, 57, 5588, 177, 190);
INSERT INTO public.who_global_data VALUES (41813, 37, 26838, 1, 1774, 177, 12);
INSERT INTO public.who_global_data VALUES (41814, 0, 336, 0, 24, 177, 104);
INSERT INTO public.who_global_data VALUES (41815, 1823, 86942, 11, 692, 177, 153);
INSERT INTO public.who_global_data VALUES (41816, 476, 251713, 10, 35225, 177, 91);
INSERT INTO public.who_global_data VALUES (41817, 16, 1047, 0, 14, 177, 215);
INSERT INTO public.who_global_data VALUES (41818, 937, 51147, 4, 1063, 177, 84);
INSERT INTO public.who_global_data VALUES (41819, 0, 348, 0, 31, 177, 231);
INSERT INTO public.who_global_data VALUES (41820, 20, 1371, 0, 11, 177, 196);
INSERT INTO public.who_global_data VALUES (41821, 1410, 118514, 0, 1433, 177, 105);
INSERT INTO public.who_global_data VALUES (41822, 679, 28104, 18, 456, 177, 122);
INSERT INTO public.who_global_data VALUES (41823, 0, 0, 0, 0, 177, 159);
INSERT INTO public.who_global_data VALUES (41824, 205, 10752, 11, 355, 177, 75);
INSERT INTO public.who_global_data VALUES (41825, 717, 73785, 3, 489, 177, 27);
INSERT INTO public.who_global_data VALUES (41826, 310, 41069, 3, 1042, 177, 54);
INSERT INTO public.who_global_data VALUES (41827, 0, 20, 0, 0, 177, 226);
INSERT INTO public.who_global_data VALUES (41828, 0, 1303, 0, 32, 177, 79);
INSERT INTO public.who_global_data VALUES (41829, 292, 7413, 2, 89, 177, 56);
INSERT INTO public.who_global_data VALUES (41830, 17, 815, 0, 24, 177, 117);
INSERT INTO public.who_global_data VALUES (41831, 12, 1252, 3, 82, 177, 152);
INSERT INTO public.who_global_data VALUES (41832, 309, 6611, 0, 132, 177, 16);
INSERT INTO public.who_global_data VALUES (41833, 1, 92, 0, 1, 177, 10);
INSERT INTO public.who_global_data VALUES (41834, 21, 2324, 0, 81, 177, 201);
INSERT INTO public.who_global_data VALUES (41835, 58, 7300, 0, 122, 177, 174);
INSERT INTO public.who_global_data VALUES (41836, 80, 13397, 4, 156, 177, 119);
INSERT INTO public.who_global_data VALUES (41837, 38, 4752, 0, 152, 177, 168);
INSERT INTO public.who_global_data VALUES (41838, 11, 9114, 0, 125, 177, 99);
INSERT INTO public.who_global_data VALUES (41839, 143, 5366, 1, 21, 177, 171);
INSERT INTO public.who_global_data VALUES (41840, 5, 2582, 0, 125, 177, 87);
INSERT INTO public.who_global_data VALUES (41841, 55, 1139, 0, 9, 177, 123);
INSERT INTO public.who_global_data VALUES (41842, 0, 0, 0, 0, 177, 151);
INSERT INTO public.who_global_data VALUES (41843, 0, 336, 0, 16, 177, 213);
INSERT INTO public.who_global_data VALUES (41844, 24, 6622, 0, 157, 177, 118);
INSERT INTO public.who_global_data VALUES (41845, 0, 344, 0, 10, 177, 134);
INSERT INTO public.who_global_data VALUES (41846, 0, 3091, 0, 39, 177, 65);
INSERT INTO public.who_global_data VALUES (41847, 6686, 492522, 926, 53929, 177, 102);
INSERT INTO public.who_global_data VALUES (41848, 0, 0, 0, 0, 177, 223);
INSERT INTO public.who_global_data VALUES (41849, 2, 100, 0, 1, 177, 4);
INSERT INTO public.who_global_data VALUES (41850, 0, 293, 0, 0, 177, 146);
INSERT INTO public.who_global_data VALUES (41851, 46, 3878, 0, 73, 177, 31);
INSERT INTO public.who_global_data VALUES (41852, 0, 13, 0, 1, 177, 127);
INSERT INTO public.who_global_data VALUES (41853, 1499, 36694, 23, 556, 177, 22);
INSERT INTO public.who_global_data VALUES (41854, 78, 2559, 2, 19, 177, 115);
INSERT INTO public.who_global_data VALUES (41855, 1, 361, 0, 6, 177, 106);
INSERT INTO public.who_global_data VALUES (41856, 177, 3406, 3, 22, 177, 90);
INSERT INTO public.who_global_data VALUES (41857, 0, 0, 0, 0, 177, 70);
INSERT INTO public.who_global_data VALUES (41858, 484, 24432, 8, 91, 177, 46);
INSERT INTO public.who_global_data VALUES (41859, 651, 60563, 2, 6160, 177, 139);
INSERT INTO public.who_global_data VALUES (41860, 0, 23, 0, 0, 177, 42);
INSERT INTO public.who_global_data VALUES (41861, 14, 1238, 0, 22, 177, 80);
INSERT INTO public.who_global_data VALUES (41862, 0, 3413, 0, 128, 177, 203);
INSERT INTO public.who_global_data VALUES (41863, 3, 1161, 0, 69, 177, 136);
INSERT INTO public.who_global_data VALUES (41864, 453, 47743, 0, 956, 177, 63);
INSERT INTO public.who_global_data VALUES (41865, 0, 0, 0, 0, 177, 17);
INSERT INTO public.who_global_data VALUES (41866, 0, 49, 0, 2, 177, 172);
INSERT INTO public.who_global_data VALUES (41867, 139, 12245, 1, 530, 177, 109);
INSERT INTO public.who_global_data VALUES (41868, 66, 9750, 0, 256, 177, 200);
INSERT INTO public.who_global_data VALUES (41869, 499, 20093, 1, 115, 177, 93);
INSERT INTO public.who_global_data VALUES (41870, 249, 82299, 6, 539, 177, 5);
INSERT INTO public.who_global_data VALUES (41871, 0, 741, 0, 13, 177, 214);
INSERT INTO public.who_global_data VALUES (41872, 753, 286674, 10, 6139, 177, 204);
INSERT INTO public.who_global_data VALUES (41873, 0, 0, 0, 0, 177, 198);
INSERT INTO public.who_global_data VALUES (41874, 1070, 76464, 16, 1680, 177, 173);
INSERT INTO public.who_global_data VALUES (41875, 55, 269, 0, 3, 177, 229);
INSERT INTO public.who_global_data VALUES (41876, 285, 7519, 4, 86, 177, 76);
INSERT INTO public.who_global_data VALUES (41877, 6547, 489680, 225, 21501, 177, 138);
INSERT INTO public.who_global_data VALUES (41878, 4211, 143749, 92, 2404, 177, 98);
INSERT INTO public.who_global_data VALUES (41879, 0, 0, 0, 0, 177, 103);
INSERT INTO public.who_global_data VALUES (41880, 715, 53676, 9, 1830, 177, 225);
INSERT INTO public.who_global_data VALUES (41881, 278, 53223, 3, 1764, 177, 131);
INSERT INTO public.who_global_data VALUES (41882, 671, 24074, 8, 295, 177, 235);
INSERT INTO public.who_global_data VALUES (41883, 292, 113938, 2, 190, 177, 137);
INSERT INTO public.who_global_data VALUES (41884, 56, 14770, 0, 305, 177, 81);
INSERT INTO public.who_global_data VALUES (41885, 474, 28697, 6, 863, 177, 182);
INSERT INTO public.who_global_data VALUES (41886, 32, 734, 0, 5, 177, 145);
INSERT INTO public.who_global_data VALUES (41887, 1415, 65177, 43, 2807, 177, 26);
INSERT INTO public.who_global_data VALUES (41888, 5057, 907758, 124, 15384, 177, 170);
INSERT INTO public.who_global_data VALUES (41889, 18, 2189, 1, 8, 177, 191);
INSERT INTO public.who_global_data VALUES (41890, 0, 5, 0, 0, 177, 221);
INSERT INTO public.who_global_data VALUES (41891, 0, 13, 0, 0, 177, 64);
INSERT INTO public.who_global_data VALUES (41892, 0, 0, 0, 0, 177, 116);
INSERT INTO public.who_global_data VALUES (41893, 0, 17, 0, 0, 177, 128);
INSERT INTO public.who_global_data VALUES (41894, 0, 25, 0, 0, 177, 6);
INSERT INTO public.who_global_data VALUES (41895, 0, 84, 0, 4, 177, 227);
INSERT INTO public.who_global_data VALUES (41896, 0, 4, 0, 0, 177, 68);
INSERT INTO public.who_global_data VALUES (41897, 0, 57, 0, 0, 177, 184);
INSERT INTO public.who_global_data VALUES (41898, 0, 0, 0, 0, 177, 82);
INSERT INTO public.who_global_data VALUES (41899, 0, 719, 0, 42, 177, 149);
INSERT INTO public.who_global_data VALUES (41900, 1, 882, 0, 15, 177, 197);
INSERT INTO public.who_global_data VALUES (41901, 1569, 293037, 36, 3269, 177, 78);
INSERT INTO public.who_global_data VALUES (41902, 207, 11587, 4, 242, 177, 233);
INSERT INTO public.who_global_data VALUES (41903, 254, 28751, 6, 658, 177, 133);
INSERT INTO public.who_global_data VALUES (41904, 0, 126, 0, 0, 177, 35);
INSERT INTO public.who_global_data VALUES (41905, 5, 1937, 0, 69, 177, 114);
INSERT INTO public.who_global_data VALUES (41906, 42, 55395, 0, 27, 177, 237);
INSERT INTO public.who_global_data VALUES (41907, 0, 3, 0, 0, 177, 55);
INSERT INTO public.who_global_data VALUES (41908, 27, 219, 0, 17, 177, 176);
INSERT INTO public.who_global_data VALUES (41909, 75, 2690, 0, 31, 177, 202);
INSERT INTO public.who_global_data VALUES (41910, 29, 2333, 0, 131, 177, 155);
INSERT INTO public.who_global_data VALUES (41911, 0, 0, 0, 0, 177, 32);
INSERT INTO public.who_global_data VALUES (41912, 0, 3227, 0, 93, 177, 220);
INSERT INTO public.who_global_data VALUES (41913, 2810, 568919, 259, 11010, 177, 30);
INSERT INTO public.who_global_data VALUES (41914, 1, 2478, 0, 47, 177, 147);
INSERT INTO public.who_global_data VALUES (41915, 6154, 352043, 27, 30117, 177, 208);
INSERT INTO public.who_global_data VALUES (41916, 0, 2880, 0, 11, 177, 45);
INSERT INTO public.who_global_data VALUES (41917, 47, 12162, 1, 793, 177, 110);
INSERT INTO public.who_global_data VALUES (41918, 70, 2559, 9, 39, 177, 88);
INSERT INTO public.who_global_data VALUES (41919, 417, 79909, 4, 5789, 177, 51);
INSERT INTO public.who_global_data VALUES (41920, 246, 37506, 0, 1746, 177, 209);
INSERT INTO public.who_global_data VALUES (41921, 75, 1402, 0, 53, 177, 205);
INSERT INTO public.who_global_data VALUES (41922, 41, 7912, 0, 63, 177, 18);
INSERT INTO public.who_global_data VALUES (41923, 3, 3359, 0, 58, 177, 72);
INSERT INTO public.who_global_data VALUES (41924, 1009, 313802, 20, 41329, 177, 44);
INSERT INTO public.who_global_data VALUES (41925, 0, 25, 0, 0, 177, 15);
INSERT INTO public.who_global_data VALUES (41926, 0, 1067, 0, 25, 177, 25);
INSERT INTO public.who_global_data VALUES (41927, 0, 0, 0, 0, 177, 179);
INSERT INTO public.who_global_data VALUES (41928, 0, 0, 0, 0, 177, 34);
INSERT INTO public.who_global_data VALUES (41929, 13, 308, 0, 8, 177, 207);
INSERT INTO public.who_global_data VALUES (41930, 67, 1847, 1, 53, 177, 166);
INSERT INTO public.who_global_data VALUES (41931, 7942, 352072, 18, 5891, 177, 126);
INSERT INTO public.who_global_data VALUES (41932, 0, 0, 0, 0, 177, 97);
INSERT INTO public.who_global_data VALUES (41933, 8, 224, 0, 2, 177, 36);
INSERT INTO public.who_global_data VALUES (41934, 0, 0, 0, 0, 177, 125);
INSERT INTO public.who_global_data VALUES (41935, 19, 1332, 0, 9, 177, 124);
INSERT INTO public.who_global_data VALUES (41936, 1592, 86140, 22, 1992, 177, 185);
INSERT INTO public.who_global_data VALUES (41937, 246, 63212, 0, 358, 177, 194);
INSERT INTO public.who_global_data VALUES (41938, 0, 509, 0, 21, 177, 144);
INSERT INTO public.who_global_data VALUES (41939, 54791, 5094500, 1236, 163340, 177, 19);
INSERT INTO public.who_global_data VALUES (41940, 63, 639, 0, 9, 177, 217);
INSERT INTO public.who_global_data VALUES (41941, 21, 1385, 0, 37, 177, 148);
INSERT INTO public.who_global_data VALUES (41942, 622, 32837, 5, 213, 177, 86);
INSERT INTO public.who_global_data VALUES (41943, 0, 0, 0, 0, 177, 13);
INSERT INTO public.who_global_data VALUES (41944, 1138, 27938, 9, 238, 177, 157);
INSERT INTO public.who_global_data VALUES (41945, 17, 883, 1, 18, 177, 8);
INSERT INTO public.who_global_data VALUES (41946, 0, 0, 0, 0, 177, 73);
INSERT INTO public.who_global_data VALUES (41947, 10, 1845, 5, 529, 177, 101);
INSERT INTO public.who_global_data VALUES (41948, 226, 8501, 5, 246, 177, 165);
INSERT INTO public.who_global_data VALUES (41949, 75, 4893, 18, 122, 177, 14);
INSERT INTO public.who_global_data VALUES (41950, 76, 37431, 10, 1358, 178, 193);
INSERT INTO public.who_global_data VALUES (41951, 140, 6676, 5, 205, 178, 113);
INSERT INTO public.who_global_data VALUES (41952, 492, 36204, 10, 1322, 178, 143);
INSERT INTO public.who_global_data VALUES (41953, 0, 0, 0, 0, 178, 219);
INSERT INTO public.who_global_data VALUES (41954, 10, 973, 0, 52, 178, 186);
INSERT INTO public.who_global_data VALUES (41955, 56, 1735, 2, 80, 178, 52);
INSERT INTO public.who_global_data VALUES (41956, 0, 3, 0, 0, 178, 180);
INSERT INTO public.who_global_data VALUES (41957, 0, 92, 0, 3, 178, 167);
INSERT INTO public.who_global_data VALUES (41958, 7369, 253868, 151, 4785, 178, 154);
INSERT INTO public.who_global_data VALUES (41959, 201, 40107, 3, 801, 178, 94);
INSERT INTO public.who_global_data VALUES (41960, 67, 630, 0, 3, 178, 66);
INSERT INTO public.who_global_data VALUES (41961, 316, 21713, 18, 331, 178, 58);
INSERT INTO public.who_global_data VALUES (41962, 138, 22260, 0, 723, 178, 163);
INSERT INTO public.who_global_data VALUES (41963, 84, 33731, 3, 495, 178, 37);
INSERT INTO public.who_global_data VALUES (41964, 47, 945, 0, 15, 178, 142);
INSERT INTO public.who_global_data VALUES (41965, 407, 44804, 2, 165, 178, 83);
INSERT INTO public.who_global_data VALUES (41966, 2996, 263503, 33, 3471, 178, 228);
INSERT INTO public.who_global_data VALUES (41967, 1, 143, 0, 7, 178, 188);
INSERT INTO public.who_global_data VALUES (41968, 58, 69005, 3, 592, 178, 62);
INSERT INTO public.who_global_data VALUES (41969, 718, 76762, 13, 9763, 178, 160);
INSERT INTO public.who_global_data VALUES (41970, 23, 177, 0, 2, 178, 50);
INSERT INTO public.who_global_data VALUES (41971, 13, 2014, 0, 38, 178, 33);
INSERT INTO public.who_global_data VALUES (41972, 1, 159, 0, 9, 178, 183);
INSERT INTO public.who_global_data VALUES (41973, 0, 113, 0, 0, 178, 92);
INSERT INTO public.who_global_data VALUES (41974, 1636, 91635, 72, 3712, 178, 158);
INSERT INTO public.who_global_data VALUES (41975, 0, 5, 0, 0, 178, 67);
INSERT INTO public.who_global_data VALUES (41976, 208, 14706, 22, 442, 178, 57);
INSERT INTO public.who_global_data VALUES (41977, 262, 1066, 0, 2, 178, 38);
INSERT INTO public.who_global_data VALUES (41978, 22048, 3057470, 703, 101752, 178, 141);
INSERT INTO public.who_global_data VALUES (41979, 0, 9, 0, 1, 178, 178);
INSERT INTO public.who_global_data VALUES (41980, 0, 142, 0, 3, 178, 108);
INSERT INTO public.who_global_data VALUES (41981, 210, 13722, 12, 471, 178, 39);
INSERT INTO public.who_global_data VALUES (41982, 7, 1211, 0, 54, 178, 2);
INSERT INTO public.who_global_data VALUES (41983, 1, 409, 0, 1, 178, 195);
INSERT INTO public.who_global_data VALUES (41984, 37, 2920, 1, 33, 178, 107);
INSERT INTO public.who_global_data VALUES (41985, 2, 268, 0, 0, 178, 161);
INSERT INTO public.who_global_data VALUES (41986, 50, 18263, 3, 401, 178, 212);
INSERT INTO public.who_global_data VALUES (41987, 681, 120132, 6, 8987, 178, 181);
INSERT INTO public.who_global_data VALUES (41988, 0, 203, 0, 1, 178, 53);
INSERT INTO public.who_global_data VALUES (41989, 6, 4647, 1, 61, 178, 164);
INSERT INTO public.who_global_data VALUES (41990, 1, 946, 0, 76, 178, 140);
INSERT INTO public.who_global_data VALUES (41991, 1572, 376616, 39, 10178, 178, 20);
INSERT INTO public.who_global_data VALUES (41992, 61, 89444, 3, 4699, 178, 112);
INSERT INTO public.who_global_data VALUES (41993, 10142, 397623, 312, 13154, 178, 111);
INSERT INTO public.who_global_data VALUES (41994, 0, 399, 0, 7, 178, 71);
INSERT INTO public.who_global_data VALUES (41995, 0, 3745, 0, 60, 178, 218);
INSERT INTO public.who_global_data VALUES (41996, 0, 0, 0, 0, 178, 43);
INSERT INTO public.who_global_data VALUES (41997, 586, 23872, 9, 244, 178, 49);
INSERT INTO public.who_global_data VALUES (41998, 49, 16847, 0, 105, 178, 1);
INSERT INTO public.who_global_data VALUES (41999, 91, 5740, 2, 160, 178, 48);
INSERT INTO public.who_global_data VALUES (42000, 47, 3093, 0, 88, 178, 232);
INSERT INTO public.who_global_data VALUES (42001, 0, 32, 0, 1, 178, 175);
INSERT INTO public.who_global_data VALUES (42002, 25, 1277, 1, 20, 178, 21);
INSERT INTO public.who_global_data VALUES (42003, 289, 18783, 2, 391, 178, 156);
INSERT INTO public.who_global_data VALUES (42004, 0, 0, 0, 0, 178, 95);
INSERT INTO public.who_global_data VALUES (42005, 10, 9498, 1, 225, 178, 177);
INSERT INTO public.who_global_data VALUES (42006, 144, 14959, 1, 621, 178, 210);
INSERT INTO public.who_global_data VALUES (42007, 1, 5348, 0, 59, 178, 120);
INSERT INTO public.who_global_data VALUES (42008, 0, 18, 0, 0, 178, 135);
INSERT INTO public.who_global_data VALUES (42009, 595, 81094, 18, 1346, 178, 206);
INSERT INTO public.who_global_data VALUES (42010, 862, 95563, 19, 5951, 178, 189);
INSERT INTO public.who_global_data VALUES (42011, 168, 95834, 24, 5059, 178, 129);
INSERT INTO public.who_global_data VALUES (42012, 397, 21269, 7, 570, 178, 121);
INSERT INTO public.who_global_data VALUES (42013, 0, 4821, 0, 83, 178, 59);
INSERT INTO public.who_global_data VALUES (42014, 0, 285, 0, 0, 178, 96);
INSERT INTO public.who_global_data VALUES (42015, 9, 2167, 0, 63, 178, 41);
INSERT INTO public.who_global_data VALUES (42016, 101, 3410, 2, 63, 178, 216);
INSERT INTO public.who_global_data VALUES (42017, 584, 24175, 20, 440, 178, 236);
INSERT INTO public.who_global_data VALUES (42018, 0, 13, 0, 0, 178, 150);
INSERT INTO public.who_global_data VALUES (42019, 11, 324, 0, 0, 178, 61);
INSERT INTO public.who_global_data VALUES (42020, 0, 27, 0, 1, 178, 7);
INSERT INTO public.who_global_data VALUES (42021, 22, 7623, 0, 333, 178, 169);
INSERT INTO public.who_global_data VALUES (42022, 1293, 191265, 13, 30227, 178, 28);
INSERT INTO public.who_global_data VALUES (42023, 36, 8360, 0, 49, 178, 85);
INSERT INTO public.who_global_data VALUES (42024, 43, 112, 0, 0, 178, 211);
INSERT INTO public.who_global_data VALUES (42025, 0, 8006, 0, 51, 178, 60);
INSERT INTO public.who_global_data VALUES (42026, 242, 1477, 10, 33, 178, 3);
INSERT INTO public.who_global_data VALUES (42027, 14, 1278, 0, 17, 178, 11);
INSERT INTO public.who_global_data VALUES (42028, 1226, 218519, 6, 9207, 178, 89);
INSERT INTO public.who_global_data VALUES (42029, 192, 41404, 0, 215, 178, 24);
INSERT INTO public.who_global_data VALUES (42030, 4, 201, 0, 0, 178, 162);
INSERT INTO public.who_global_data VALUES (42031, 193, 5942, 1, 214, 178, 100);
INSERT INTO public.who_global_data VALUES (42032, 0, 14, 0, 0, 178, 47);
INSERT INTO public.who_global_data VALUES (42033, 0, 24, 0, 0, 178, 29);
INSERT INTO public.who_global_data VALUES (42034, 27, 317, 0, 14, 178, 40);
INSERT INTO public.who_global_data VALUES (42035, 16, 426, 0, 5, 178, 222);
INSERT INTO public.who_global_data VALUES (42036, 979, 57966, 11, 2233, 178, 132);
INSERT INTO public.who_global_data VALUES (42037, 0, 252, 0, 13, 178, 130);
INSERT INTO public.who_global_data VALUES (42038, 66, 8018, 0, 50, 178, 234);
INSERT INTO public.who_global_data VALUES (42039, 0, 2052, 0, 29, 178, 23);
INSERT INTO public.who_global_data VALUES (42040, 0, 568, 0, 22, 178, 192);
INSERT INTO public.who_global_data VALUES (42041, 15, 7649, 0, 183, 178, 69);
INSERT INTO public.who_global_data VALUES (42042, 0, 12, 0, 0, 178, 187);
INSERT INTO public.who_global_data VALUES (42043, 418, 47872, 11, 1506, 178, 230);
INSERT INTO public.who_global_data VALUES (42044, 15, 4746, 0, 605, 178, 77);
INSERT INTO public.who_global_data VALUES (42045, 6, 1968, 0, 10, 178, 9);
INSERT INTO public.who_global_data VALUES (42046, 60963, 2329638, 834, 46091, 178, 74);
INSERT INTO public.who_global_data VALUES (42047, 1693, 128776, 59, 5824, 178, 224);
INSERT INTO public.who_global_data VALUES (42048, 2345, 331189, 184, 18800, 178, 199);
INSERT INTO public.who_global_data VALUES (42049, 3396, 156995, 67, 5531, 178, 190);
INSERT INTO public.who_global_data VALUES (42050, 33, 26801, 1, 1773, 178, 12);
INSERT INTO public.who_global_data VALUES (42051, 0, 336, 0, 24, 178, 104);
INSERT INTO public.who_global_data VALUES (42052, 1704, 85119, 15, 681, 178, 153);
INSERT INTO public.who_global_data VALUES (42053, 412, 251237, 6, 35215, 178, 91);
INSERT INTO public.who_global_data VALUES (42054, 8, 1031, 0, 14, 178, 215);
INSERT INTO public.who_global_data VALUES (42055, 1282, 50210, 7, 1059, 178, 84);
INSERT INTO public.who_global_data VALUES (42056, 3, 348, 0, 31, 178, 231);
INSERT INTO public.who_global_data VALUES (42057, 15, 1351, 0, 11, 178, 196);
INSERT INTO public.who_global_data VALUES (42058, 1489, 117104, 0, 1433, 178, 105);
INSERT INTO public.who_global_data VALUES (42059, 497, 27425, 15, 438, 178, 122);
INSERT INTO public.who_global_data VALUES (42060, 0, 0, 0, 0, 178, 159);
INSERT INTO public.who_global_data VALUES (42061, 171, 10547, 13, 344, 178, 75);
INSERT INTO public.who_global_data VALUES (42062, 668, 73068, 4, 486, 178, 27);
INSERT INTO public.who_global_data VALUES (42063, 304, 40759, 6, 1039, 178, 54);
INSERT INTO public.who_global_data VALUES (42064, 0, 20, 0, 0, 178, 226);
INSERT INTO public.who_global_data VALUES (42065, 10, 1303, 0, 32, 178, 79);
INSERT INTO public.who_global_data VALUES (42066, 309, 7121, 7, 87, 178, 56);
INSERT INTO public.who_global_data VALUES (42067, 17, 798, 0, 24, 178, 117);
INSERT INTO public.who_global_data VALUES (42068, 0, 1240, 0, 79, 178, 152);
INSERT INTO public.who_global_data VALUES (42069, 373, 6302, 7, 132, 178, 16);
INSERT INTO public.who_global_data VALUES (42070, 1, 91, 0, 1, 178, 10);
INSERT INTO public.who_global_data VALUES (42071, 26, 2303, 0, 81, 178, 201);
INSERT INTO public.who_global_data VALUES (42072, 26, 7242, 1, 122, 178, 174);
INSERT INTO public.who_global_data VALUES (42073, 115, 13317, 1, 152, 178, 119);
INSERT INTO public.who_global_data VALUES (42074, 40, 4714, 6, 152, 178, 168);
INSERT INTO public.who_global_data VALUES (42075, 9, 9103, 0, 125, 178, 99);
INSERT INTO public.who_global_data VALUES (42076, 66, 5223, 1, 20, 178, 171);
INSERT INTO public.who_global_data VALUES (42077, 4, 2577, 0, 125, 178, 87);
INSERT INTO public.who_global_data VALUES (42078, 49, 1084, 0, 9, 178, 123);
INSERT INTO public.who_global_data VALUES (42079, 0, 0, 0, 0, 178, 151);
INSERT INTO public.who_global_data VALUES (42080, 0, 336, 0, 16, 178, 213);
INSERT INTO public.who_global_data VALUES (42081, 48, 6598, 0, 157, 178, 118);
INSERT INTO public.who_global_data VALUES (42082, 0, 344, 0, 10, 178, 134);
INSERT INTO public.who_global_data VALUES (42083, 23, 3091, 0, 39, 178, 65);
INSERT INTO public.who_global_data VALUES (42084, 5558, 485836, 705, 53003, 178, 102);
INSERT INTO public.who_global_data VALUES (42085, 0, 0, 0, 0, 178, 223);
INSERT INTO public.who_global_data VALUES (42086, 1, 98, 0, 1, 178, 4);
INSERT INTO public.who_global_data VALUES (42087, 0, 293, 0, 0, 178, 146);
INSERT INTO public.who_global_data VALUES (42088, 59, 3832, 0, 73, 178, 31);
INSERT INTO public.who_global_data VALUES (42089, 0, 13, 0, 1, 178, 127);
INSERT INTO public.who_global_data VALUES (42090, 1132, 35195, 17, 533, 178, 22);
INSERT INTO public.who_global_data VALUES (42091, 70, 2481, 1, 17, 178, 115);
INSERT INTO public.who_global_data VALUES (42092, 0, 360, 0, 6, 178, 106);
INSERT INTO public.who_global_data VALUES (42093, 128, 3229, 0, 19, 178, 90);
INSERT INTO public.who_global_data VALUES (42094, 0, 0, 0, 0, 178, 70);
INSERT INTO public.who_global_data VALUES (42095, 638, 23948, 4, 83, 178, 46);
INSERT INTO public.who_global_data VALUES (42096, 620, 59912, 2, 6158, 178, 139);
INSERT INTO public.who_global_data VALUES (42097, 0, 23, 0, 0, 178, 42);
INSERT INTO public.who_global_data VALUES (42098, 4, 1224, 0, 22, 178, 80);
INSERT INTO public.who_global_data VALUES (42099, 147, 3413, 5, 128, 178, 203);
INSERT INTO public.who_global_data VALUES (42100, 0, 1158, 0, 69, 178, 136);
INSERT INTO public.who_global_data VALUES (42101, 423, 47290, 6, 956, 178, 63);
INSERT INTO public.who_global_data VALUES (42102, 0, 0, 0, 0, 178, 17);
INSERT INTO public.who_global_data VALUES (42103, 0, 49, 0, 2, 178, 172);
INSERT INTO public.who_global_data VALUES (42104, 141, 12106, 1, 529, 178, 109);
INSERT INTO public.who_global_data VALUES (42105, 46, 9684, 0, 256, 178, 200);
INSERT INTO public.who_global_data VALUES (42106, 473, 19594, 4, 114, 178, 93);
INSERT INTO public.who_global_data VALUES (42107, 263, 82050, 12, 533, 178, 5);
INSERT INTO public.who_global_data VALUES (42108, 0, 741, 0, 13, 178, 214);
INSERT INTO public.who_global_data VALUES (42109, 730, 285921, 17, 6129, 178, 204);
INSERT INTO public.who_global_data VALUES (42110, 0, 0, 0, 0, 178, 198);
INSERT INTO public.who_global_data VALUES (42111, 902, 75394, 25, 1664, 178, 173);
INSERT INTO public.who_global_data VALUES (42112, 0, 214, 0, 3, 178, 229);
INSERT INTO public.who_global_data VALUES (42113, 327, 7234, 7, 82, 178, 76);
INSERT INTO public.who_global_data VALUES (42114, 5109, 483133, 204, 21276, 178, 138);
INSERT INTO public.who_global_data VALUES (42115, 2900, 139538, 19, 2312, 178, 98);
INSERT INTO public.who_global_data VALUES (42116, 0, 0, 0, 0, 178, 103);
INSERT INTO public.who_global_data VALUES (42117, 551, 52961, 12, 1821, 178, 225);
INSERT INTO public.who_global_data VALUES (42118, 120, 52945, 2, 1761, 178, 131);
INSERT INTO public.who_global_data VALUES (42119, 582, 23403, 8, 287, 178, 235);
INSERT INTO public.who_global_data VALUES (42120, 384, 113646, 0, 188, 178, 137);
INSERT INTO public.who_global_data VALUES (42121, 54, 14714, 0, 305, 178, 81);
INSERT INTO public.who_global_data VALUES (42122, 382, 28223, 7, 857, 178, 182);
INSERT INTO public.who_global_data VALUES (42123, 12, 702, 0, 5, 178, 145);
INSERT INTO public.who_global_data VALUES (42124, 1215, 63762, 35, 2764, 178, 26);
INSERT INTO public.who_global_data VALUES (42125, 5102, 902701, 129, 15260, 178, 170);
INSERT INTO public.who_global_data VALUES (42126, 19, 2171, 0, 7, 178, 191);
INSERT INTO public.who_global_data VALUES (42127, 0, 5, 0, 0, 178, 221);
INSERT INTO public.who_global_data VALUES (42128, 0, 13, 0, 0, 178, 64);
INSERT INTO public.who_global_data VALUES (42129, 0, 0, 0, 0, 178, 116);
INSERT INTO public.who_global_data VALUES (42130, 0, 17, 0, 0, 178, 128);
INSERT INTO public.who_global_data VALUES (42131, 0, 25, 0, 0, 178, 6);
INSERT INTO public.who_global_data VALUES (42132, 6, 84, 1, 4, 178, 227);
INSERT INTO public.who_global_data VALUES (42133, 0, 4, 0, 0, 178, 68);
INSERT INTO public.who_global_data VALUES (42134, 0, 57, 0, 0, 178, 184);
INSERT INTO public.who_global_data VALUES (42135, 0, 0, 0, 0, 178, 82);
INSERT INTO public.who_global_data VALUES (42136, 2, 719, 0, 42, 178, 149);
INSERT INTO public.who_global_data VALUES (42137, 3, 881, 0, 15, 178, 197);
INSERT INTO public.who_global_data VALUES (42138, 1521, 291468, 34, 3233, 178, 78);
INSERT INTO public.who_global_data VALUES (42139, 68, 11380, 2, 238, 178, 233);
INSERT INTO public.who_global_data VALUES (42140, 235, 28497, 6, 652, 178, 133);
INSERT INTO public.who_global_data VALUES (42141, 0, 126, 0, 0, 178, 35);
INSERT INTO public.who_global_data VALUES (42142, 15, 1932, 0, 69, 178, 114);
INSERT INTO public.who_global_data VALUES (42143, 61, 55353, 0, 27, 178, 237);
INSERT INTO public.who_global_data VALUES (42144, 0, 3, 0, 0, 178, 55);
INSERT INTO public.who_global_data VALUES (42145, 0, 192, 0, 17, 178, 176);
INSERT INTO public.who_global_data VALUES (42146, 16, 2615, 0, 31, 178, 202);
INSERT INTO public.who_global_data VALUES (42147, 31, 2304, 0, 131, 178, 155);
INSERT INTO public.who_global_data VALUES (42148, 0, 0, 0, 0, 178, 32);
INSERT INTO public.who_global_data VALUES (42149, 0, 3227, 0, 93, 178, 220);
INSERT INTO public.who_global_data VALUES (42150, 2511, 566109, 130, 10751, 178, 30);
INSERT INTO public.who_global_data VALUES (42151, 5, 2477, 0, 47, 178, 147);
INSERT INTO public.who_global_data VALUES (42152, 3969, 345889, 27, 30090, 178, 208);
INSERT INTO public.who_global_data VALUES (42153, 9, 2880, 0, 11, 178, 45);
INSERT INTO public.who_global_data VALUES (42154, 82, 12115, 6, 792, 178, 110);
INSERT INTO public.who_global_data VALUES (42155, 98, 2489, 1, 30, 178, 88);
INSERT INTO public.who_global_data VALUES (42156, 196, 79492, 2, 5785, 178, 51);
INSERT INTO public.who_global_data VALUES (42157, 255, 37260, 0, 1746, 178, 209);
INSERT INTO public.who_global_data VALUES (42158, 72, 1327, 1, 53, 178, 205);
INSERT INTO public.who_global_data VALUES (42159, 44, 7871, 1, 63, 178, 18);
INSERT INTO public.who_global_data VALUES (42160, 5, 3356, 0, 58, 178, 72);
INSERT INTO public.who_global_data VALUES (42161, 1148, 312793, 13, 41309, 178, 44);
INSERT INTO public.who_global_data VALUES (42162, 0, 25, 0, 0, 178, 15);
INSERT INTO public.who_global_data VALUES (42163, 7, 1067, 2, 25, 178, 25);
INSERT INTO public.who_global_data VALUES (42164, 0, 0, 0, 0, 178, 179);
INSERT INTO public.who_global_data VALUES (42165, 0, 0, 0, 0, 178, 34);
INSERT INTO public.who_global_data VALUES (42166, 15, 295, 0, 8, 178, 207);
INSERT INTO public.who_global_data VALUES (42167, 42, 1780, 0, 52, 178, 166);
INSERT INTO public.who_global_data VALUES (42168, 7913, 344130, 15, 5873, 178, 126);
INSERT INTO public.who_global_data VALUES (42169, 0, 0, 0, 0, 178, 97);
INSERT INTO public.who_global_data VALUES (42170, 0, 216, 0, 2, 178, 36);
INSERT INTO public.who_global_data VALUES (42171, 0, 0, 0, 0, 178, 125);
INSERT INTO public.who_global_data VALUES (42172, 16, 1313, 0, 9, 178, 124);
INSERT INTO public.who_global_data VALUES (42173, 1433, 84548, 19, 1970, 178, 185);
INSERT INTO public.who_global_data VALUES (42174, 262, 62966, 1, 358, 178, 194);
INSERT INTO public.who_global_data VALUES (42175, 0, 509, 0, 21, 178, 144);
INSERT INTO public.who_global_data VALUES (42176, 39894, 5039709, 557, 162104, 178, 19);
INSERT INTO public.who_global_data VALUES (42177, 29, 576, 0, 9, 178, 217);
INSERT INTO public.who_global_data VALUES (42178, 11, 1364, 0, 37, 178, 148);
INSERT INTO public.who_global_data VALUES (42179, 670, 32215, 6, 208, 178, 86);
INSERT INTO public.who_global_data VALUES (42180, 0, 0, 0, 0, 178, 13);
INSERT INTO public.who_global_data VALUES (42181, 995, 26800, 6, 229, 178, 157);
INSERT INTO public.who_global_data VALUES (42182, 19, 866, 2, 17, 178, 8);
INSERT INTO public.who_global_data VALUES (42183, 0, 0, 0, 0, 178, 73);
INSERT INTO public.who_global_data VALUES (42184, 5, 1835, 5, 524, 178, 101);
INSERT INTO public.who_global_data VALUES (42185, 65, 8275, 0, 241, 178, 165);
INSERT INTO public.who_global_data VALUES (42186, 70, 4818, 0, 104, 178, 14);
INSERT INTO public.who_global_data VALUES (42187, 215, 37355, 32, 1348, 179, 193);
INSERT INTO public.who_global_data VALUES (42188, 125, 6536, 1, 200, 179, 113);
INSERT INTO public.who_global_data VALUES (42189, 498, 35712, 10, 1312, 179, 143);
INSERT INTO public.who_global_data VALUES (42190, 0, 0, 0, 0, 179, 219);
INSERT INTO public.who_global_data VALUES (42191, 7, 963, 0, 52, 179, 186);
INSERT INTO public.who_global_data VALUES (42192, 7, 1679, 3, 78, 179, 52);
INSERT INTO public.who_global_data VALUES (42193, 0, 3, 0, 0, 179, 180);
INSERT INTO public.who_global_data VALUES (42194, 0, 92, 0, 3, 179, 167);
INSERT INTO public.who_global_data VALUES (42195, 4688, 246499, 78, 4634, 179, 154);
INSERT INTO public.who_global_data VALUES (42196, 160, 39906, 7, 798, 179, 94);
INSERT INTO public.who_global_data VALUES (42197, 300, 563, 0, 3, 179, 66);
INSERT INTO public.who_global_data VALUES (42198, 313, 21397, 18, 313, 179, 58);
INSERT INTO public.who_global_data VALUES (42199, 111, 22122, 2, 723, 179, 163);
INSERT INTO public.who_global_data VALUES (42200, 79, 33647, 2, 492, 179, 37);
INSERT INTO public.who_global_data VALUES (42201, 20, 898, 1, 15, 179, 142);
INSERT INTO public.who_global_data VALUES (42202, 386, 44397, 1, 163, 179, 83);
INSERT INTO public.who_global_data VALUES (42203, 2907, 260507, 39, 3438, 179, 228);
INSERT INTO public.who_global_data VALUES (42204, 0, 142, 0, 7, 179, 188);
INSERT INTO public.who_global_data VALUES (42205, 97, 68947, 2, 589, 179, 62);
INSERT INTO public.who_global_data VALUES (42206, 873, 76044, 11, 9750, 179, 160);
INSERT INTO public.who_global_data VALUES (42207, 1, 154, 0, 2, 179, 50);
INSERT INTO public.who_global_data VALUES (42208, 65, 2001, 0, 38, 179, 33);
INSERT INTO public.who_global_data VALUES (42209, 0, 158, 0, 9, 179, 183);
INSERT INTO public.who_global_data VALUES (42210, 3, 113, 0, 0, 179, 92);
INSERT INTO public.who_global_data VALUES (42211, 944, 89999, 53, 3640, 179, 158);
INSERT INTO public.who_global_data VALUES (42212, 0, 5, 0, 0, 179, 67);
INSERT INTO public.who_global_data VALUES (42213, 173, 14498, 18, 420, 179, 57);
INSERT INTO public.who_global_data VALUES (42214, 0, 804, 0, 2, 179, 38);
INSERT INTO public.who_global_data VALUES (42215, 23010, 3035422, 572, 101049, 179, 141);
INSERT INTO public.who_global_data VALUES (42216, 0, 9, 0, 1, 179, 178);
INSERT INTO public.who_global_data VALUES (42217, 0, 142, 0, 3, 179, 108);
INSERT INTO public.who_global_data VALUES (42218, 116, 13512, 12, 459, 179, 39);
INSERT INTO public.who_global_data VALUES (42219, 24, 1204, 0, 54, 179, 2);
INSERT INTO public.who_global_data VALUES (42220, 0, 408, 0, 1, 179, 195);
INSERT INTO public.who_global_data VALUES (42221, 25, 2883, 0, 32, 179, 107);
INSERT INTO public.who_global_data VALUES (42222, 15, 266, 0, 0, 179, 161);
INSERT INTO public.who_global_data VALUES (42223, 171, 18213, 3, 398, 179, 212);
INSERT INTO public.who_global_data VALUES (42224, 230, 119451, 5, 8981, 179, 181);
INSERT INTO public.who_global_data VALUES (42225, 0, 203, 0, 1, 179, 53);
INSERT INTO public.who_global_data VALUES (42226, 0, 4641, 0, 60, 179, 164);
INSERT INTO public.who_global_data VALUES (42227, 1, 945, 0, 76, 179, 140);
INSERT INTO public.who_global_data VALUES (42228, 1988, 375044, 62, 10139, 179, 20);
INSERT INTO public.who_global_data VALUES (42229, 113, 89383, 3, 4696, 179, 112);
INSERT INTO public.who_global_data VALUES (42230, 10611, 387481, 302, 12842, 179, 111);
INSERT INTO public.who_global_data VALUES (42231, 0, 399, 0, 7, 179, 71);
INSERT INTO public.who_global_data VALUES (42232, 81, 3745, 2, 60, 179, 218);
INSERT INTO public.who_global_data VALUES (42233, 0, 0, 0, 0, 179, 43);
INSERT INTO public.who_global_data VALUES (42234, 484, 23286, 7, 235, 179, 49);
INSERT INTO public.who_global_data VALUES (42235, 83, 16798, 0, 105, 179, 1);
INSERT INTO public.who_global_data VALUES (42236, 45, 5649, 1, 158, 179, 48);
INSERT INTO public.who_global_data VALUES (42237, 93, 3046, 0, 88, 179, 232);
INSERT INTO public.who_global_data VALUES (42238, 1, 32, 0, 1, 179, 175);
INSERT INTO public.who_global_data VALUES (42239, 10, 1252, 0, 19, 179, 21);
INSERT INTO public.who_global_data VALUES (42240, 139, 18494, 0, 389, 179, 156);
INSERT INTO public.who_global_data VALUES (42241, 0, 0, 0, 0, 179, 95);
INSERT INTO public.who_global_data VALUES (42242, 35, 9488, 0, 224, 179, 177);
INSERT INTO public.who_global_data VALUES (42243, 373, 14815, 3, 620, 179, 210);
INSERT INTO public.who_global_data VALUES (42244, 3, 5347, 0, 59, 179, 120);
INSERT INTO public.who_global_data VALUES (42245, 0, 18, 0, 0, 179, 135);
INSERT INTO public.who_global_data VALUES (42246, 767, 80499, 19, 1328, 179, 206);
INSERT INTO public.who_global_data VALUES (42247, 242, 94701, 10, 5932, 179, 189);
INSERT INTO public.who_global_data VALUES (42248, 174, 95666, 26, 5035, 179, 129);
INSERT INTO public.who_global_data VALUES (42249, 449, 20872, 14, 563, 179, 121);
INSERT INTO public.who_global_data VALUES (42250, 0, 4821, 0, 83, 179, 59);
INSERT INTO public.who_global_data VALUES (42251, 0, 285, 0, 0, 179, 96);
INSERT INTO public.who_global_data VALUES (42252, 6, 2158, 0, 63, 179, 41);
INSERT INTO public.who_global_data VALUES (42253, 73, 3309, 3, 61, 179, 216);
INSERT INTO public.who_global_data VALUES (42254, 773, 23591, 13, 420, 179, 236);
INSERT INTO public.who_global_data VALUES (42255, 0, 13, 0, 0, 179, 150);
INSERT INTO public.who_global_data VALUES (42256, 22, 313, 0, 0, 179, 61);
INSERT INTO public.who_global_data VALUES (42257, 0, 27, 0, 1, 179, 7);
INSERT INTO public.who_global_data VALUES (42258, 17, 7601, 2, 333, 179, 169);
INSERT INTO public.who_global_data VALUES (42259, 4619, 189972, 13, 30214, 179, 28);
INSERT INTO public.who_global_data VALUES (42260, 57, 8324, 1, 49, 179, 85);
INSERT INTO public.who_global_data VALUES (42261, 0, 69, 0, 0, 179, 211);
INSERT INTO public.who_global_data VALUES (42262, 83, 8006, 0, 51, 179, 60);
INSERT INTO public.who_global_data VALUES (42263, 0, 1235, 0, 23, 179, 3);
INSERT INTO public.who_global_data VALUES (42264, 14, 1264, 0, 17, 179, 11);
INSERT INTO public.who_global_data VALUES (42265, 966, 217293, 4, 9201, 179, 89);
INSERT INTO public.who_global_data VALUES (42266, 209, 41212, 0, 215, 179, 24);
INSERT INTO public.who_global_data VALUES (42267, 0, 197, 0, 0, 179, 162);
INSERT INTO public.who_global_data VALUES (42268, 126, 5749, 1, 213, 179, 100);
INSERT INTO public.who_global_data VALUES (42269, 0, 14, 0, 0, 179, 47);
INSERT INTO public.who_global_data VALUES (42270, 0, 24, 0, 0, 179, 29);
INSERT INTO public.who_global_data VALUES (42271, 0, 290, 0, 14, 179, 40);
INSERT INTO public.who_global_data VALUES (42272, 6, 410, 0, 5, 179, 222);
INSERT INTO public.who_global_data VALUES (42273, 382, 56987, 11, 2222, 179, 132);
INSERT INTO public.who_global_data VALUES (42274, 0, 252, 0, 13, 179, 130);
INSERT INTO public.who_global_data VALUES (42275, 22, 7952, 0, 50, 179, 234);
INSERT INTO public.who_global_data VALUES (42276, 0, 2052, 0, 29, 179, 23);
INSERT INTO public.who_global_data VALUES (42277, 14, 568, 0, 22, 179, 192);
INSERT INTO public.who_global_data VALUES (42278, 23, 7634, 1, 183, 179, 69);
INSERT INTO public.who_global_data VALUES (42279, 0, 12, 0, 0, 179, 187);
INSERT INTO public.who_global_data VALUES (42280, 481, 47454, 19, 1495, 179, 230);
INSERT INTO public.who_global_data VALUES (42281, 35, 4731, 3, 605, 179, 77);
INSERT INTO public.who_global_data VALUES (42282, 4, 1962, 0, 10, 179, 9);
INSERT INTO public.who_global_data VALUES (42283, 53601, 2268675, 871, 45257, 179, 74);
INSERT INTO public.who_global_data VALUES (42284, 1687, 127083, 42, 5765, 179, 224);
INSERT INTO public.who_global_data VALUES (42285, 2132, 328844, 189, 18616, 179, 199);
INSERT INTO public.who_global_data VALUES (42286, 3484, 153599, 72, 5464, 179, 190);
INSERT INTO public.who_global_data VALUES (42287, 56, 26768, 0, 1772, 179, 12);
INSERT INTO public.who_global_data VALUES (42288, 0, 336, 0, 24, 179, 104);
INSERT INTO public.who_global_data VALUES (42289, 924, 83415, 7, 666, 179, 153);
INSERT INTO public.who_global_data VALUES (42290, 259, 250825, 4, 35209, 179, 91);
INSERT INTO public.who_global_data VALUES (42291, 20, 1023, 2, 14, 179, 215);
INSERT INTO public.who_global_data VALUES (42292, 938, 48928, 5, 1052, 179, 84);
INSERT INTO public.who_global_data VALUES (42293, 0, 345, 0, 31, 179, 231);
INSERT INTO public.who_global_data VALUES (42294, 16, 1336, 0, 11, 179, 196);
INSERT INTO public.who_global_data VALUES (42295, 2114, 115615, 0, 1433, 179, 105);
INSERT INTO public.who_global_data VALUES (42296, 492, 26928, 3, 423, 179, 122);
INSERT INTO public.who_global_data VALUES (42297, 0, 0, 0, 0, 179, 159);
INSERT INTO public.who_global_data VALUES (42298, 172, 10376, 14, 331, 179, 75);
INSERT INTO public.who_global_data VALUES (42299, 687, 72400, 4, 482, 179, 27);
INSERT INTO public.who_global_data VALUES (42300, 278, 40455, 4, 1033, 179, 54);
INSERT INTO public.who_global_data VALUES (42301, 0, 20, 0, 0, 179, 226);
INSERT INTO public.who_global_data VALUES (42302, 3, 1293, 0, 32, 179, 79);
INSERT INTO public.who_global_data VALUES (42303, 295, 6812, 4, 80, 179, 56);
INSERT INTO public.who_global_data VALUES (42304, 0, 781, 0, 24, 179, 117);
INSERT INTO public.who_global_data VALUES (42305, 3, 1240, 0, 79, 179, 152);
INSERT INTO public.who_global_data VALUES (42306, 388, 5929, 5, 125, 179, 16);
INSERT INTO public.who_global_data VALUES (42307, 1, 90, 0, 1, 179, 10);
INSERT INTO public.who_global_data VALUES (42308, 18, 2277, 0, 81, 179, 201);
INSERT INTO public.who_global_data VALUES (42309, 103, 7216, 2, 121, 179, 174);
INSERT INTO public.who_global_data VALUES (42310, 116, 13202, 3, 151, 179, 119);
INSERT INTO public.who_global_data VALUES (42311, 16, 4674, 0, 146, 179, 168);
INSERT INTO public.who_global_data VALUES (42312, 11, 9094, 0, 125, 179, 99);
INSERT INTO public.who_global_data VALUES (42313, 116, 5157, 0, 19, 179, 171);
INSERT INTO public.who_global_data VALUES (42314, 6, 2573, 0, 125, 179, 87);
INSERT INTO public.who_global_data VALUES (42315, 29, 1035, 0, 9, 179, 123);
INSERT INTO public.who_global_data VALUES (42316, 0, 0, 0, 0, 179, 151);
INSERT INTO public.who_global_data VALUES (42317, 0, 336, 0, 16, 179, 213);
INSERT INTO public.who_global_data VALUES (42318, 40, 6550, 0, 157, 179, 118);
INSERT INTO public.who_global_data VALUES (42319, 0, 344, 0, 10, 179, 134);
INSERT INTO public.who_global_data VALUES (42320, 0, 3068, 0, 39, 179, 65);
INSERT INTO public.who_global_data VALUES (42321, 4376, 480278, 292, 52298, 179, 102);
INSERT INTO public.who_global_data VALUES (42322, 0, 0, 0, 0, 179, 223);
INSERT INTO public.who_global_data VALUES (42323, 0, 97, 0, 1, 179, 4);
INSERT INTO public.who_global_data VALUES (42324, 0, 293, 0, 0, 179, 146);
INSERT INTO public.who_global_data VALUES (42325, 62, 3773, 3, 73, 179, 31);
INSERT INTO public.who_global_data VALUES (42326, 0, 13, 0, 1, 179, 127);
INSERT INTO public.who_global_data VALUES (42327, 826, 34063, 18, 516, 179, 22);
INSERT INTO public.who_global_data VALUES (42328, 142, 2411, 0, 16, 179, 115);
INSERT INTO public.who_global_data VALUES (42329, 0, 360, 0, 6, 179, 106);
INSERT INTO public.who_global_data VALUES (42330, 152, 3101, 0, 19, 179, 90);
INSERT INTO public.who_global_data VALUES (42331, 0, 0, 0, 0, 179, 70);
INSERT INTO public.who_global_data VALUES (42332, 338, 23310, 4, 79, 179, 46);
INSERT INTO public.who_global_data VALUES (42333, 787, 59292, 0, 6156, 179, 139);
INSERT INTO public.who_global_data VALUES (42334, 0, 23, 0, 0, 179, 42);
INSERT INTO public.who_global_data VALUES (42335, 1, 1220, 0, 22, 179, 80);
INSERT INTO public.who_global_data VALUES (42336, 0, 3266, 0, 123, 179, 203);
INSERT INTO public.who_global_data VALUES (42337, 0, 1158, 0, 69, 179, 136);
INSERT INTO public.who_global_data VALUES (42338, 290, 46867, 5, 950, 179, 63);
INSERT INTO public.who_global_data VALUES (42339, 0, 0, 0, 0, 179, 17);
INSERT INTO public.who_global_data VALUES (42340, 1, 49, 0, 2, 179, 172);
INSERT INTO public.who_global_data VALUES (42341, 109, 11965, 1, 528, 179, 109);
INSERT INTO public.who_global_data VALUES (42342, 170, 9638, 0, 256, 179, 200);
INSERT INTO public.who_global_data VALUES (42343, 470, 19121, 7, 110, 179, 93);
INSERT INTO public.who_global_data VALUES (42344, 207, 81787, 8, 521, 179, 5);
INSERT INTO public.who_global_data VALUES (42345, 0, 741, 0, 13, 179, 214);
INSERT INTO public.who_global_data VALUES (42346, 531, 285191, 15, 6112, 179, 204);
INSERT INTO public.who_global_data VALUES (42347, 0, 0, 0, 0, 179, 198);
INSERT INTO public.who_global_data VALUES (42348, 841, 74492, 30, 1639, 179, 173);
INSERT INTO public.who_global_data VALUES (42349, 0, 214, 0, 3, 179, 229);
INSERT INTO public.who_global_data VALUES (42350, 202, 6907, 3, 75, 179, 76);
INSERT INTO public.who_global_data VALUES (42351, 7012, 478024, 228, 21072, 179, 138);
INSERT INTO public.who_global_data VALUES (42352, 6725, 136638, 23, 2293, 179, 98);
INSERT INTO public.who_global_data VALUES (42353, 0, 0, 0, 0, 179, 103);
INSERT INTO public.who_global_data VALUES (42354, 619, 52410, 2, 1809, 179, 225);
INSERT INTO public.who_global_data VALUES (42355, 157, 52825, 3, 1759, 179, 131);
INSERT INTO public.who_global_data VALUES (42356, 700, 22821, 0, 279, 179, 235);
INSERT INTO public.who_global_data VALUES (42357, 315, 113262, 4, 188, 179, 137);
INSERT INTO public.who_global_data VALUES (42358, 34, 14660, 0, 305, 179, 81);
INSERT INTO public.who_global_data VALUES (42359, 181, 27841, 5, 850, 179, 182);
INSERT INTO public.who_global_data VALUES (42360, 3, 690, 0, 5, 179, 145);
INSERT INTO public.who_global_data VALUES (42361, 779, 62547, 29, 2729, 179, 26);
INSERT INTO public.who_global_data VALUES (42362, 4945, 897599, 130, 15131, 179, 170);
INSERT INTO public.who_global_data VALUES (42363, 12, 2152, 0, 7, 179, 191);
INSERT INTO public.who_global_data VALUES (42364, 0, 5, 0, 0, 179, 221);
INSERT INTO public.who_global_data VALUES (42365, 0, 13, 0, 0, 179, 64);
INSERT INTO public.who_global_data VALUES (42366, 0, 0, 0, 0, 179, 116);
INSERT INTO public.who_global_data VALUES (42367, 0, 17, 0, 0, 179, 128);
INSERT INTO public.who_global_data VALUES (42368, 0, 25, 0, 0, 179, 6);
INSERT INTO public.who_global_data VALUES (42369, 0, 78, 0, 3, 179, 227);
INSERT INTO public.who_global_data VALUES (42370, 0, 4, 0, 0, 179, 68);
INSERT INTO public.who_global_data VALUES (42371, 1, 57, 0, 0, 179, 184);
INSERT INTO public.who_global_data VALUES (42372, 0, 0, 0, 0, 179, 82);
INSERT INTO public.who_global_data VALUES (42373, 0, 717, 0, 42, 179, 149);
INSERT INTO public.who_global_data VALUES (42374, 0, 878, 0, 15, 179, 197);
INSERT INTO public.who_global_data VALUES (42375, 1257, 289947, 32, 3199, 179, 78);
INSERT INTO public.who_global_data VALUES (42376, 137, 11312, 4, 236, 179, 233);
INSERT INTO public.who_global_data VALUES (42377, 163, 28262, 5, 646, 179, 133);
INSERT INTO public.who_global_data VALUES (42378, 0, 126, 0, 0, 179, 35);
INSERT INTO public.who_global_data VALUES (42379, 1, 1917, 1, 69, 179, 114);
INSERT INTO public.who_global_data VALUES (42380, 188, 55292, 0, 27, 179, 237);
INSERT INTO public.who_global_data VALUES (42381, 0, 3, 0, 0, 179, 55);
INSERT INTO public.who_global_data VALUES (42382, 16, 192, 1, 17, 179, 176);
INSERT INTO public.who_global_data VALUES (42383, 3, 2599, 0, 31, 179, 202);
INSERT INTO public.who_global_data VALUES (42384, 17, 2273, 1, 131, 179, 155);
INSERT INTO public.who_global_data VALUES (42385, 0, 0, 0, 0, 179, 32);
INSERT INTO public.who_global_data VALUES (42386, 0, 3227, 0, 93, 179, 220);
INSERT INTO public.who_global_data VALUES (42387, 3739, 563598, 213, 10621, 179, 30);
INSERT INTO public.who_global_data VALUES (42388, 2, 2472, 0, 47, 179, 147);
INSERT INTO public.who_global_data VALUES (42389, 2660, 341920, 16, 30063, 179, 208);
INSERT INTO public.who_global_data VALUES (42390, 27, 2871, 0, 11, 179, 45);
INSERT INTO public.who_global_data VALUES (42391, 0, 12033, 0, 786, 179, 110);
INSERT INTO public.who_global_data VALUES (42392, 85, 2391, 0, 29, 179, 88);
INSERT INTO public.who_global_data VALUES (42393, 73, 79296, 4, 5783, 179, 51);
INSERT INTO public.who_global_data VALUES (42394, 281, 37005, 1, 1746, 179, 209);
INSERT INTO public.who_global_data VALUES (42395, 67, 1255, 0, 52, 179, 205);
INSERT INTO public.who_global_data VALUES (42396, 42, 7827, 0, 62, 179, 18);
INSERT INTO public.who_global_data VALUES (42397, 0, 3351, 0, 58, 179, 72);
INSERT INTO public.who_global_data VALUES (42398, 816, 311645, 18, 41296, 179, 44);
INSERT INTO public.who_global_data VALUES (42399, 0, 25, 0, 0, 179, 15);
INSERT INTO public.who_global_data VALUES (42400, 14, 1060, 1, 23, 179, 25);
INSERT INTO public.who_global_data VALUES (42401, 0, 0, 0, 0, 179, 179);
INSERT INTO public.who_global_data VALUES (42402, 0, 0, 0, 0, 179, 34);
INSERT INTO public.who_global_data VALUES (42403, 1, 280, 0, 8, 179, 207);
INSERT INTO public.who_global_data VALUES (42404, 21, 1738, 1, 52, 179, 166);
INSERT INTO public.who_global_data VALUES (42405, 7923, 336217, 14, 5858, 179, 126);
INSERT INTO public.who_global_data VALUES (42406, 0, 0, 0, 0, 179, 97);
INSERT INTO public.who_global_data VALUES (42407, 19, 216, 0, 2, 179, 36);
INSERT INTO public.who_global_data VALUES (42408, 0, 0, 0, 0, 179, 125);
INSERT INTO public.who_global_data VALUES (42409, 14, 1297, 2, 9, 179, 124);
INSERT INTO public.who_global_data VALUES (42410, 1158, 83115, 29, 1951, 179, 185);
INSERT INTO public.who_global_data VALUES (42411, 179, 62704, 0, 357, 179, 194);
INSERT INTO public.who_global_data VALUES (42412, 0, 509, 0, 21, 179, 144);
INSERT INTO public.who_global_data VALUES (42413, 47964, 4999815, 558, 161547, 179, 19);
INSERT INTO public.who_global_data VALUES (42414, 19, 547, 0, 9, 179, 217);
INSERT INTO public.who_global_data VALUES (42415, 18, 1353, 0, 37, 179, 148);
INSERT INTO public.who_global_data VALUES (42416, 725, 31545, 6, 202, 179, 86);
INSERT INTO public.who_global_data VALUES (42417, 0, 0, 0, 0, 179, 13);
INSERT INTO public.who_global_data VALUES (42418, 844, 25805, 8, 223, 179, 157);
INSERT INTO public.who_global_data VALUES (42419, 6, 847, 2, 15, 179, 8);
INSERT INTO public.who_global_data VALUES (42420, 0, 0, 0, 0, 179, 73);
INSERT INTO public.who_global_data VALUES (42421, 22, 1830, 3, 519, 179, 101);
INSERT INTO public.who_global_data VALUES (42422, 125, 8210, 6, 241, 179, 165);
INSERT INTO public.who_global_data VALUES (42423, 99, 4748, 0, 104, 179, 14);
INSERT INTO public.who_global_data VALUES (42424, 0, 37140, 0, 1316, 180, 193);
INSERT INTO public.who_global_data VALUES (42425, 136, 6411, 6, 199, 180, 113);
INSERT INTO public.who_global_data VALUES (42426, 521, 35214, 9, 1302, 180, 143);
INSERT INTO public.who_global_data VALUES (42427, 0, 0, 0, 0, 180, 219);
INSERT INTO public.who_global_data VALUES (42428, 0, 956, 0, 52, 180, 186);
INSERT INTO public.who_global_data VALUES (42429, 100, 1672, 5, 75, 180, 52);
INSERT INTO public.who_global_data VALUES (42430, 0, 3, 0, 0, 180, 180);
INSERT INTO public.who_global_data VALUES (42431, 0, 92, 0, 3, 180, 167);
INSERT INTO public.who_global_data VALUES (42432, 6134, 241811, 106, 4556, 180, 154);
INSERT INTO public.who_global_data VALUES (42433, 23, 39746, 5, 791, 180, 94);
INSERT INTO public.who_global_data VALUES (42434, 0, 263, 0, 3, 180, 66);
INSERT INTO public.who_global_data VALUES (42435, 386, 21084, 17, 295, 180, 58);
INSERT INTO public.who_global_data VALUES (42436, 76, 22011, 0, 721, 180, 163);
INSERT INTO public.who_global_data VALUES (42437, 87, 33568, 2, 490, 180, 37);
INSERT INTO public.who_global_data VALUES (42438, 48, 878, 0, 14, 180, 142);
INSERT INTO public.who_global_data VALUES (42439, 382, 44011, 1, 162, 180, 83);
INSERT INTO public.who_global_data VALUES (42440, 2487, 257600, 34, 3399, 180, 228);
INSERT INTO public.who_global_data VALUES (42441, 4, 142, 0, 7, 180, 188);
INSERT INTO public.who_global_data VALUES (42442, 112, 68850, 2, 587, 180, 62);
INSERT INTO public.who_global_data VALUES (42443, 122, 75171, 5, 9739, 180, 160);
INSERT INTO public.who_global_data VALUES (42444, 7, 153, 0, 2, 180, 50);
INSERT INTO public.who_global_data VALUES (42445, 0, 1936, 0, 38, 180, 33);
INSERT INTO public.who_global_data VALUES (42446, 0, 158, 0, 9, 180, 183);
INSERT INTO public.who_global_data VALUES (42447, 2, 110, 0, 0, 180, 92);
INSERT INTO public.who_global_data VALUES (42448, 1164, 89055, 63, 3587, 180, 158);
INSERT INTO public.who_global_data VALUES (42449, 0, 5, 0, 0, 180, 67);
INSERT INTO public.who_global_data VALUES (42450, 236, 14325, 6, 402, 180, 57);
INSERT INTO public.who_global_data VALUES (42451, 0, 804, 0, 2, 180, 38);
INSERT INTO public.who_global_data VALUES (42452, 49970, 3012412, 905, 100477, 180, 141);
INSERT INTO public.who_global_data VALUES (42453, 0, 9, 0, 1, 180, 178);
INSERT INTO public.who_global_data VALUES (42454, 0, 142, 0, 3, 180, 108);
INSERT INTO public.who_global_data VALUES (42455, 53, 13396, 2, 447, 180, 39);
INSERT INTO public.who_global_data VALUES (42456, 5, 1180, 0, 54, 180, 2);
INSERT INTO public.who_global_data VALUES (42457, 3, 408, 0, 1, 180, 195);
INSERT INTO public.who_global_data VALUES (42458, 23, 2858, 0, 32, 180, 107);
INSERT INTO public.who_global_data VALUES (42459, 3, 251, 0, 0, 180, 161);
INSERT INTO public.who_global_data VALUES (42460, 0, 18042, 0, 395, 180, 212);
INSERT INTO public.who_global_data VALUES (42461, 236, 119221, 6, 8976, 180, 181);
INSERT INTO public.who_global_data VALUES (42462, 0, 203, 0, 1, 180, 53);
INSERT INTO public.who_global_data VALUES (42463, 0, 4641, 1, 60, 180, 164);
INSERT INTO public.who_global_data VALUES (42464, 2, 944, 0, 76, 180, 140);
INSERT INTO public.who_global_data VALUES (42465, 2033, 373056, 66, 10077, 180, 20);
INSERT INTO public.who_global_data VALUES (42466, 121, 89270, 5, 4693, 180, 112);
INSERT INTO public.who_global_data VALUES (42467, 9674, 376870, 290, 12540, 180, 111);
INSERT INTO public.who_global_data VALUES (42468, 0, 399, 0, 7, 180, 71);
INSERT INTO public.who_global_data VALUES (42469, 0, 3664, 0, 58, 180, 218);
INSERT INTO public.who_global_data VALUES (42470, 0, 0, 0, 0, 180, 43);
INSERT INTO public.who_global_data VALUES (42471, 721, 22802, 10, 228, 180, 49);
INSERT INTO public.who_global_data VALUES (42472, 95, 16715, 1, 105, 180, 1);
INSERT INTO public.who_global_data VALUES (42473, 61, 5604, 0, 157, 180, 48);
INSERT INTO public.who_global_data VALUES (42474, 65, 2953, 0, 88, 180, 232);
INSERT INTO public.who_global_data VALUES (42475, 0, 31, 0, 1, 180, 175);
INSERT INTO public.who_global_data VALUES (42476, 9, 1242, 0, 19, 180, 21);
INSERT INTO public.who_global_data VALUES (42477, 120, 18355, 0, 389, 180, 156);
INSERT INTO public.who_global_data VALUES (42478, 0, 0, 0, 0, 180, 95);
INSERT INTO public.who_global_data VALUES (42479, 18, 9453, 6, 224, 180, 177);
INSERT INTO public.who_global_data VALUES (42480, 0, 14442, 0, 617, 180, 210);
INSERT INTO public.who_global_data VALUES (42481, 6, 5344, 0, 59, 180, 120);
INSERT INTO public.who_global_data VALUES (42482, 0, 18, 0, 0, 180, 135);
INSERT INTO public.who_global_data VALUES (42483, 954, 79732, 20, 1309, 180, 206);
INSERT INTO public.who_global_data VALUES (42484, 887, 94459, 6, 5922, 180, 189);
INSERT INTO public.who_global_data VALUES (42485, 178, 95492, 17, 5009, 180, 129);
INSERT INTO public.who_global_data VALUES (42486, 445, 20423, 13, 549, 180, 121);
INSERT INTO public.who_global_data VALUES (42487, 0, 4821, 0, 83, 180, 59);
INSERT INTO public.who_global_data VALUES (42488, 0, 285, 0, 0, 180, 96);
INSERT INTO public.who_global_data VALUES (42489, 5, 2152, 0, 63, 180, 41);
INSERT INTO public.who_global_data VALUES (42490, 108, 3236, 2, 58, 180, 216);
INSERT INTO public.who_global_data VALUES (42491, 565, 22818, 17, 407, 180, 236);
INSERT INTO public.who_global_data VALUES (42492, 0, 13, 0, 0, 180, 150);
INSERT INTO public.who_global_data VALUES (42493, 0, 291, 0, 0, 180, 61);
INSERT INTO public.who_global_data VALUES (42494, 0, 27, 0, 1, 180, 7);
INSERT INTO public.who_global_data VALUES (42495, 16, 7584, 0, 331, 180, 169);
INSERT INTO public.who_global_data VALUES (42496, 0, 185353, 0, 30201, 180, 28);
INSERT INTO public.who_global_data VALUES (42497, 0, 8267, 0, 48, 180, 85);
INSERT INTO public.who_global_data VALUES (42498, 0, 69, 0, 0, 180, 211);
INSERT INTO public.who_global_data VALUES (42499, 0, 7923, 0, 51, 180, 60);
INSERT INTO public.who_global_data VALUES (42500, 145, 1235, 4, 23, 180, 3);
INSERT INTO public.who_global_data VALUES (42501, 25, 1250, 0, 17, 180, 11);
INSERT INTO public.who_global_data VALUES (42502, 436, 216327, 1, 9197, 180, 89);
INSERT INTO public.who_global_data VALUES (42503, 470, 41003, 9, 215, 180, 24);
INSERT INTO public.who_global_data VALUES (42504, 4, 197, 0, 0, 180, 162);
INSERT INTO public.who_global_data VALUES (42505, 202, 5623, 1, 212, 180, 100);
INSERT INTO public.who_global_data VALUES (42506, 0, 14, 0, 0, 180, 47);
INSERT INTO public.who_global_data VALUES (42507, 0, 24, 0, 0, 180, 29);
INSERT INTO public.who_global_data VALUES (42508, 0, 290, 0, 14, 180, 40);
INSERT INTO public.who_global_data VALUES (42509, 0, 404, 0, 5, 180, 222);
INSERT INTO public.who_global_data VALUES (42510, 416, 56605, 14, 2211, 180, 132);
INSERT INTO public.who_global_data VALUES (42511, 0, 252, 0, 13, 180, 130);
INSERT INTO public.who_global_data VALUES (42512, 55, 7930, 0, 50, 180, 234);
INSERT INTO public.who_global_data VALUES (42513, 0, 2052, 0, 29, 180, 23);
INSERT INTO public.who_global_data VALUES (42514, 16, 554, 0, 22, 180, 192);
INSERT INTO public.who_global_data VALUES (42515, 12, 7611, 5, 182, 180, 69);
INSERT INTO public.who_global_data VALUES (42516, 0, 12, 0, 0, 180, 187);
INSERT INTO public.who_global_data VALUES (42517, 338, 46973, 11, 1476, 180, 230);
INSERT INTO public.who_global_data VALUES (42518, 43, 4696, 0, 602, 180, 77);
INSERT INTO public.who_global_data VALUES (42519, 3, 1958, 0, 10, 180, 9);
INSERT INTO public.who_global_data VALUES (42520, 62064, 2215074, 1007, 44386, 180, 74);
INSERT INTO public.who_global_data VALUES (42521, 1893, 125396, 65, 5723, 180, 224);
INSERT INTO public.who_global_data VALUES (42522, 2020, 326712, 163, 18427, 180, 199);
INSERT INTO public.who_global_data VALUES (42523, 2726, 150115, 82, 5392, 180, 190);
INSERT INTO public.who_global_data VALUES (42524, 68, 26712, 0, 1772, 180, 12);
INSERT INTO public.who_global_data VALUES (42525, 0, 336, 0, 24, 180, 104);
INSERT INTO public.who_global_data VALUES (42526, 754, 82491, 13, 659, 180, 153);
INSERT INTO public.who_global_data VALUES (42527, 463, 250566, 2, 35205, 180, 91);
INSERT INTO public.who_global_data VALUES (42528, 16, 1003, 0, 12, 180, 215);
INSERT INTO public.who_global_data VALUES (42529, 1207, 47990, 7, 1047, 180, 84);
INSERT INTO public.who_global_data VALUES (42530, 0, 345, 0, 31, 180, 231);
INSERT INTO public.who_global_data VALUES (42531, 6, 1320, 0, 11, 180, 196);
INSERT INTO public.who_global_data VALUES (42532, 779, 113501, 0, 1433, 180, 105);
INSERT INTO public.who_global_data VALUES (42533, 599, 26436, 2, 420, 180, 122);
INSERT INTO public.who_global_data VALUES (42534, 0, 0, 0, 0, 180, 159);
INSERT INTO public.who_global_data VALUES (42535, 188, 10204, 12, 317, 180, 75);
INSERT INTO public.who_global_data VALUES (42536, 514, 71713, 4, 478, 180, 27);
INSERT INTO public.who_global_data VALUES (42537, 258, 40177, 6, 1029, 180, 54);
INSERT INTO public.who_global_data VALUES (42538, 0, 20, 0, 0, 180, 226);
INSERT INTO public.who_global_data VALUES (42539, 2, 1290, 0, 32, 180, 79);
INSERT INTO public.who_global_data VALUES (42540, 294, 6517, 2, 76, 180, 56);
INSERT INTO public.who_global_data VALUES (42541, 39, 781, 1, 24, 180, 117);
INSERT INTO public.who_global_data VALUES (42542, 3, 1237, 0, 79, 180, 152);
INSERT INTO public.who_global_data VALUES (42543, 309, 5541, 7, 120, 180, 16);
INSERT INTO public.who_global_data VALUES (42544, 0, 89, 0, 1, 180, 10);
INSERT INTO public.who_global_data VALUES (42545, 12, 2259, 0, 81, 180, 201);
INSERT INTO public.who_global_data VALUES (42546, 0, 7113, 0, 119, 180, 174);
INSERT INTO public.who_global_data VALUES (42547, 164, 13086, 7, 148, 180, 119);
INSERT INTO public.who_global_data VALUES (42548, 34, 4658, 3, 146, 180, 168);
INSERT INTO public.who_global_data VALUES (42549, 13, 9083, 0, 125, 180, 99);
INSERT INTO public.who_global_data VALUES (42550, 143, 5041, 0, 19, 180, 171);
INSERT INTO public.who_global_data VALUES (42551, 2, 2567, 0, 125, 180, 87);
INSERT INTO public.who_global_data VALUES (42552, 23, 1006, 0, 9, 180, 123);
INSERT INTO public.who_global_data VALUES (42553, 0, 0, 0, 0, 180, 151);
INSERT INTO public.who_global_data VALUES (42554, 0, 336, 0, 16, 180, 213);
INSERT INTO public.who_global_data VALUES (42555, 12, 6510, 0, 157, 180, 118);
INSERT INTO public.who_global_data VALUES (42556, 0, 344, 0, 10, 180, 134);
INSERT INTO public.who_global_data VALUES (42557, 0, 3068, 0, 39, 180, 65);
INSERT INTO public.who_global_data VALUES (42558, 6495, 475902, 695, 52006, 180, 102);
INSERT INTO public.who_global_data VALUES (42559, 0, 0, 0, 0, 180, 223);
INSERT INTO public.who_global_data VALUES (42560, 0, 97, 0, 1, 180, 4);
INSERT INTO public.who_global_data VALUES (42561, 0, 293, 0, 0, 180, 146);
INSERT INTO public.who_global_data VALUES (42562, 49, 3711, 3, 70, 180, 31);
INSERT INTO public.who_global_data VALUES (42563, 0, 13, 0, 1, 180, 127);
INSERT INTO public.who_global_data VALUES (42564, 1230, 33237, 18, 498, 180, 22);
INSERT INTO public.who_global_data VALUES (42565, 28, 2269, 0, 16, 180, 115);
INSERT INTO public.who_global_data VALUES (42566, 1, 360, 0, 6, 180, 106);
INSERT INTO public.who_global_data VALUES (42567, 97, 2949, 3, 19, 180, 90);
INSERT INTO public.who_global_data VALUES (42568, 0, 0, 0, 0, 180, 70);
INSERT INTO public.who_global_data VALUES (42569, 380, 22972, 2, 75, 180, 46);
INSERT INTO public.who_global_data VALUES (42570, 577, 58505, 0, 6156, 180, 139);
INSERT INTO public.who_global_data VALUES (42571, 0, 23, 0, 0, 180, 42);
INSERT INTO public.who_global_data VALUES (42572, 0, 1219, 0, 22, 180, 80);
INSERT INTO public.who_global_data VALUES (42573, 0, 3266, 0, 123, 180, 203);
INSERT INTO public.who_global_data VALUES (42574, 1, 1158, 0, 69, 180, 136);
INSERT INTO public.who_global_data VALUES (42575, 437, 46577, 3, 945, 180, 63);
INSERT INTO public.who_global_data VALUES (42576, 0, 0, 0, 0, 180, 17);
INSERT INTO public.who_global_data VALUES (42577, 0, 48, 0, 2, 180, 172);
INSERT INTO public.who_global_data VALUES (42578, 85, 11856, 4, 527, 180, 109);
INSERT INTO public.who_global_data VALUES (42579, 0, 9468, 0, 256, 180, 200);
INSERT INTO public.who_global_data VALUES (42580, 277, 18651, 0, 103, 180, 93);
INSERT INTO public.who_global_data VALUES (42581, 223, 81580, 4, 513, 180, 5);
INSERT INTO public.who_global_data VALUES (42582, 0, 741, 0, 13, 180, 214);
INSERT INTO public.who_global_data VALUES (42583, 539, 284660, 15, 6097, 180, 204);
INSERT INTO public.who_global_data VALUES (42584, 0, 0, 0, 0, 180, 198);
INSERT INTO public.who_global_data VALUES (42585, 1091, 73651, 18, 1609, 180, 173);
INSERT INTO public.who_global_data VALUES (42586, 26, 214, 0, 3, 180, 229);
INSERT INTO public.who_global_data VALUES (42587, 197, 6705, 3, 72, 180, 76);
INSERT INTO public.who_global_data VALUES (42588, 7137, 471012, 195, 20844, 180, 138);
INSERT INTO public.who_global_data VALUES (42589, 3028, 129913, 61, 2270, 180, 98);
INSERT INTO public.who_global_data VALUES (42590, 0, 0, 0, 0, 180, 103);
INSERT INTO public.who_global_data VALUES (42591, 624, 51791, 7, 1807, 180, 225);
INSERT INTO public.who_global_data VALUES (42592, 131, 52668, 6, 1756, 180, 131);
INSERT INTO public.who_global_data VALUES (42593, 697, 22121, 5, 279, 180, 235);
INSERT INTO public.who_global_data VALUES (42594, 297, 112947, 2, 184, 180, 137);
INSERT INTO public.who_global_data VALUES (42595, 28, 14626, 0, 305, 180, 81);
INSERT INTO public.who_global_data VALUES (42596, 217, 27660, 4, 845, 180, 182);
INSERT INTO public.who_global_data VALUES (42597, 6, 687, 0, 5, 180, 145);
INSERT INTO public.who_global_data VALUES (42598, 1145, 61768, 41, 2700, 180, 26);
INSERT INTO public.who_global_data VALUES (42599, 5118, 892654, 70, 15001, 180, 170);
INSERT INTO public.who_global_data VALUES (42600, 6, 2140, 1, 7, 180, 191);
INSERT INTO public.who_global_data VALUES (42601, 0, 5, 0, 0, 180, 221);
INSERT INTO public.who_global_data VALUES (42602, 4, 13, 0, 0, 180, 64);
INSERT INTO public.who_global_data VALUES (42603, 0, 0, 0, 0, 180, 116);
INSERT INTO public.who_global_data VALUES (42604, 0, 17, 0, 0, 180, 128);
INSERT INTO public.who_global_data VALUES (42605, 0, 25, 0, 0, 180, 6);
INSERT INTO public.who_global_data VALUES (42606, 25, 78, 0, 3, 180, 227);
INSERT INTO public.who_global_data VALUES (42607, 0, 4, 0, 0, 180, 68);
INSERT INTO public.who_global_data VALUES (42608, 0, 56, 0, 0, 180, 184);
INSERT INTO public.who_global_data VALUES (42609, 0, 0, 0, 0, 180, 82);
INSERT INTO public.who_global_data VALUES (42610, 0, 717, 0, 42, 180, 149);
INSERT INTO public.who_global_data VALUES (42611, 0, 878, 0, 15, 180, 197);
INSERT INTO public.who_global_data VALUES (42612, 1428, 288690, 37, 3167, 180, 78);
INSERT INTO public.who_global_data VALUES (42613, 172, 11175, 3, 232, 180, 233);
INSERT INTO public.who_global_data VALUES (42614, 236, 28099, 9, 641, 180, 133);
INSERT INTO public.who_global_data VALUES (42615, 0, 126, 0, 0, 180, 35);
INSERT INTO public.who_global_data VALUES (42616, 21, 1916, 0, 68, 180, 114);
INSERT INTO public.who_global_data VALUES (42617, 175, 55104, 0, 27, 180, 237);
INSERT INTO public.who_global_data VALUES (42618, 0, 3, 0, 0, 180, 55);
INSERT INTO public.who_global_data VALUES (42619, 0, 176, 0, 16, 180, 176);
INSERT INTO public.who_global_data VALUES (42620, 30, 2596, 0, 31, 180, 202);
INSERT INTO public.who_global_data VALUES (42621, 6, 2256, 1, 130, 180, 155);
INSERT INTO public.who_global_data VALUES (42622, 0, 0, 0, 0, 180, 32);
INSERT INTO public.who_global_data VALUES (42623, 0, 3227, 0, 93, 180, 220);
INSERT INTO public.who_global_data VALUES (42624, 6671, 559859, 198, 10408, 180, 30);
INSERT INTO public.who_global_data VALUES (42625, 0, 2470, 0, 47, 180, 147);
INSERT INTO public.who_global_data VALUES (42626, 3599, 339260, 30, 30047, 180, 208);
INSERT INTO public.who_global_data VALUES (42627, 3, 2844, 0, 11, 180, 45);
INSERT INTO public.who_global_data VALUES (42628, 77, 12033, 5, 786, 180, 110);
INSERT INTO public.who_global_data VALUES (42629, 103, 2306, 0, 29, 180, 88);
INSERT INTO public.who_global_data VALUES (42630, 260, 79223, 1, 5779, 180, 51);
INSERT INTO public.who_global_data VALUES (42631, 100, 36724, 0, 1745, 180, 209);
INSERT INTO public.who_global_data VALUES (42632, 63, 1188, 2, 52, 180, 205);
INSERT INTO public.who_global_data VALUES (42633, 40, 7785, 0, 62, 180, 18);
INSERT INTO public.who_global_data VALUES (42634, 0, 3351, 0, 58, 180, 72);
INSERT INTO public.who_global_data VALUES (42635, 1062, 310829, 5, 41278, 180, 44);
INSERT INTO public.who_global_data VALUES (42636, 0, 25, 0, 0, 180, 15);
INSERT INTO public.who_global_data VALUES (42637, 34, 1046, 0, 22, 180, 25);
INSERT INTO public.who_global_data VALUES (42638, 0, 0, 0, 0, 180, 179);
INSERT INTO public.who_global_data VALUES (42639, 0, 0, 0, 0, 180, 34);
INSERT INTO public.who_global_data VALUES (42640, 54, 279, 0, 8, 180, 207);
INSERT INTO public.who_global_data VALUES (42641, 20, 1717, 0, 51, 180, 166);
INSERT INTO public.who_global_data VALUES (42642, 7912, 328294, 15, 5844, 180, 126);
INSERT INTO public.who_global_data VALUES (42643, 0, 0, 0, 0, 180, 97);
INSERT INTO public.who_global_data VALUES (42644, 27, 197, 0, 2, 180, 36);
INSERT INTO public.who_global_data VALUES (42645, 0, 0, 0, 0, 180, 125);
INSERT INTO public.who_global_data VALUES (42646, 14, 1283, 1, 7, 180, 124);
INSERT INTO public.who_global_data VALUES (42647, 1008, 81957, 25, 1922, 180, 185);
INSERT INTO public.who_global_data VALUES (42648, 225, 62525, 1, 357, 180, 194);
INSERT INTO public.who_global_data VALUES (42649, 0, 509, 0, 21, 180, 144);
INSERT INTO public.who_global_data VALUES (42650, 53893, 4951851, 1059, 160989, 180, 19);
INSERT INTO public.who_global_data VALUES (42651, 0, 528, 0, 9, 180, 217);
INSERT INTO public.who_global_data VALUES (42652, 10, 1335, 0, 37, 180, 148);
INSERT INTO public.who_global_data VALUES (42653, 623, 30820, 6, 196, 180, 86);
INSERT INTO public.who_global_data VALUES (42654, 0, 0, 0, 0, 180, 13);
INSERT INTO public.who_global_data VALUES (42655, 795, 24961, 7, 215, 180, 157);
INSERT INTO public.who_global_data VALUES (42656, 29, 841, 3, 13, 180, 8);
INSERT INTO public.who_global_data VALUES (42657, 0, 0, 0, 0, 180, 73);
INSERT INTO public.who_global_data VALUES (42658, 7, 1808, 3, 516, 180, 101);
INSERT INTO public.who_global_data VALUES (42659, 182, 8085, 32, 235, 180, 165);
INSERT INTO public.who_global_data VALUES (42660, 74, 4649, 2, 104, 180, 14);
INSERT INTO public.who_global_data VALUES (42661, 39, 37140, 5, 1316, 181, 193);
INSERT INTO public.who_global_data VALUES (42662, 124, 6275, 4, 193, 181, 113);
INSERT INTO public.who_global_data VALUES (42663, 538, 34693, 11, 1293, 181, 143);
INSERT INTO public.who_global_data VALUES (42664, 0, 0, 0, 0, 181, 219);
INSERT INTO public.who_global_data VALUES (42665, 0, 956, 0, 52, 181, 186);
INSERT INTO public.who_global_data VALUES (42666, 34, 1572, 3, 70, 181, 52);
INSERT INTO public.who_global_data VALUES (42667, 0, 3, 0, 0, 181, 180);
INSERT INTO public.who_global_data VALUES (42668, 0, 92, 0, 3, 181, 167);
INSERT INTO public.who_global_data VALUES (42669, 7482, 235677, 159, 4450, 181, 154);
INSERT INTO public.who_global_data VALUES (42670, 225, 39723, 6, 786, 181, 94);
INSERT INTO public.who_global_data VALUES (42671, 0, 263, 0, 3, 181, 66);
INSERT INTO public.who_global_data VALUES (42672, 426, 20698, 12, 278, 181, 58);
INSERT INTO public.who_global_data VALUES (42673, 116, 21935, 1, 721, 181, 163);
INSERT INTO public.who_global_data VALUES (42674, 105, 33481, 5, 488, 181, 37);
INSERT INTO public.who_global_data VALUES (42675, 69, 830, 0, 14, 181, 142);
INSERT INTO public.who_global_data VALUES (42676, 322, 43629, 2, 161, 181, 83);
INSERT INTO public.who_global_data VALUES (42677, 2611, 255113, 32, 3365, 181, 228);
INSERT INTO public.who_global_data VALUES (42678, 5, 138, 0, 7, 181, 188);
INSERT INTO public.who_global_data VALUES (42679, 124, 68738, 2, 585, 181, 62);
INSERT INTO public.who_global_data VALUES (42680, 304, 75049, 2, 9734, 181, 160);
INSERT INTO public.who_global_data VALUES (42681, 32, 146, 0, 2, 181, 50);
INSERT INTO public.who_global_data VALUES (42682, 0, 1936, 0, 38, 181, 33);
INSERT INTO public.who_global_data VALUES (42683, 1, 158, 0, 9, 181, 183);
INSERT INTO public.who_global_data VALUES (42684, 0, 108, 0, 0, 181, 92);
INSERT INTO public.who_global_data VALUES (42685, 1468, 87891, 59, 3524, 181, 158);
INSERT INTO public.who_global_data VALUES (42686, 0, 5, 0, 0, 181, 67);
INSERT INTO public.who_global_data VALUES (42687, 405, 14089, 8, 396, 181, 57);
INSERT INTO public.who_global_data VALUES (42688, 0, 804, 0, 2, 181, 38);
INSERT INTO public.who_global_data VALUES (42689, 50230, 2962442, 1079, 99572, 181, 141);
INSERT INTO public.who_global_data VALUES (42690, 0, 9, 0, 1, 181, 178);
INSERT INTO public.who_global_data VALUES (42691, 0, 142, 0, 3, 181, 108);
INSERT INTO public.who_global_data VALUES (42692, 329, 13343, 10, 445, 181, 39);
INSERT INTO public.who_global_data VALUES (42693, 13, 1175, 0, 54, 181, 2);
INSERT INTO public.who_global_data VALUES (42694, 4, 405, 0, 1, 181, 195);
INSERT INTO public.who_global_data VALUES (42695, 55, 2835, 3, 32, 181, 107);
INSERT INTO public.who_global_data VALUES (42696, 2, 248, 0, 0, 181, 161);
INSERT INTO public.who_global_data VALUES (42697, 0, 18042, 0, 395, 181, 212);
INSERT INTO public.who_global_data VALUES (42698, 424, 118985, 4, 8970, 181, 181);
INSERT INTO public.who_global_data VALUES (42699, 0, 203, 0, 1, 181, 53);
INSERT INTO public.who_global_data VALUES (42700, 0, 4641, 0, 59, 181, 164);
INSERT INTO public.who_global_data VALUES (42701, 0, 942, 0, 76, 181, 140);
INSERT INTO public.who_global_data VALUES (42702, 2198, 371023, 53, 10011, 181, 20);
INSERT INTO public.who_global_data VALUES (42703, 92, 89149, 0, 4688, 181, 112);
INSERT INTO public.who_global_data VALUES (42704, 9486, 367196, 311, 12250, 181, 111);
INSERT INTO public.who_global_data VALUES (42705, 3, 399, 0, 7, 181, 71);
INSERT INTO public.who_global_data VALUES (42706, 0, 3664, 0, 58, 181, 218);
INSERT INTO public.who_global_data VALUES (42707, 0, 0, 0, 0, 181, 43);
INSERT INTO public.who_global_data VALUES (42708, 1011, 22081, 18, 218, 181, 49);
INSERT INTO public.who_global_data VALUES (42709, 96, 16620, 0, 104, 181, 1);
INSERT INTO public.who_global_data VALUES (42710, 77, 5543, 2, 157, 181, 48);
INSERT INTO public.who_global_data VALUES (42711, 59, 2888, 0, 88, 181, 232);
INSERT INTO public.who_global_data VALUES (42712, 0, 31, 0, 1, 181, 175);
INSERT INTO public.who_global_data VALUES (42713, 11, 1233, 0, 19, 181, 21);
INSERT INTO public.who_global_data VALUES (42714, 175, 18235, 0, 389, 181, 156);
INSERT INTO public.who_global_data VALUES (42715, 0, 0, 0, 0, 181, 95);
INSERT INTO public.who_global_data VALUES (42716, 81, 9435, 0, 218, 181, 177);
INSERT INTO public.who_global_data VALUES (42717, 0, 14442, 0, 617, 181, 210);
INSERT INTO public.who_global_data VALUES (42718, 0, 5338, 0, 59, 181, 120);
INSERT INTO public.who_global_data VALUES (42719, 0, 18, 0, 0, 181, 135);
INSERT INTO public.who_global_data VALUES (42720, 1069, 78778, 30, 1289, 181, 206);
INSERT INTO public.who_global_data VALUES (42721, 1603, 93572, 19, 5916, 181, 189);
INSERT INTO public.who_global_data VALUES (42722, 167, 95314, 21, 4992, 181, 129);
INSERT INTO public.who_global_data VALUES (42723, 434, 19978, 16, 536, 181, 121);
INSERT INTO public.who_global_data VALUES (42724, 0, 4821, 0, 83, 181, 59);
INSERT INTO public.who_global_data VALUES (42725, 0, 285, 0, 0, 181, 96);
INSERT INTO public.who_global_data VALUES (42726, 14, 2147, 0, 63, 181, 41);
INSERT INTO public.who_global_data VALUES (42727, 92, 3128, 0, 56, 181, 216);
INSERT INTO public.who_global_data VALUES (42728, 801, 22253, 10, 390, 181, 236);
INSERT INTO public.who_global_data VALUES (42729, 0, 13, 0, 0, 181, 150);
INSERT INTO public.who_global_data VALUES (42730, 0, 291, 0, 0, 181, 61);
INSERT INTO public.who_global_data VALUES (42731, 0, 27, 0, 1, 181, 7);
INSERT INTO public.who_global_data VALUES (42732, 14, 7568, 0, 331, 181, 169);
INSERT INTO public.who_global_data VALUES (42733, 0, 185353, 0, 30201, 181, 28);
INSERT INTO public.who_global_data VALUES (42734, 63, 8267, 1, 48, 181, 85);
INSERT INTO public.who_global_data VALUES (42735, 0, 69, 0, 0, 181, 211);
INSERT INTO public.who_global_data VALUES (42736, 0, 7923, 0, 51, 181, 60);
INSERT INTO public.who_global_data VALUES (42737, 0, 1090, 0, 19, 181, 3);
INSERT INTO public.who_global_data VALUES (42738, 9, 1225, 0, 17, 181, 11);
INSERT INTO public.who_global_data VALUES (42739, 555, 215891, 1, 9196, 181, 89);
INSERT INTO public.who_global_data VALUES (42740, 436, 40533, 0, 206, 181, 24);
INSERT INTO public.who_global_data VALUES (42741, 3, 193, 0, 0, 181, 162);
INSERT INTO public.who_global_data VALUES (42742, 151, 5421, 1, 211, 181, 100);
INSERT INTO public.who_global_data VALUES (42743, 0, 14, 0, 0, 181, 47);
INSERT INTO public.who_global_data VALUES (42744, 0, 24, 0, 0, 181, 29);
INSERT INTO public.who_global_data VALUES (42745, 11, 290, 0, 14, 181, 40);
INSERT INTO public.who_global_data VALUES (42746, 1, 404, 0, 5, 181, 222);
INSERT INTO public.who_global_data VALUES (42747, 919, 56189, 29, 2197, 181, 132);
INSERT INTO public.who_global_data VALUES (42748, 0, 252, 0, 13, 181, 130);
INSERT INTO public.who_global_data VALUES (42749, 98, 7875, 0, 50, 181, 234);
INSERT INTO public.who_global_data VALUES (42750, 0, 2052, 0, 29, 181, 23);
INSERT INTO public.who_global_data VALUES (42751, 0, 538, 0, 22, 181, 192);
INSERT INTO public.who_global_data VALUES (42752, 17, 7599, 6, 177, 181, 69);
INSERT INTO public.who_global_data VALUES (42753, 0, 12, 0, 0, 181, 187);
INSERT INTO public.who_global_data VALUES (42754, 880, 46635, 19, 1465, 181, 230);
INSERT INTO public.who_global_data VALUES (42755, 32, 4653, 0, 602, 181, 77);
INSERT INTO public.who_global_data VALUES (42756, 3, 1955, 0, 10, 181, 9);
INSERT INTO public.who_global_data VALUES (42757, 64399, 2153010, 861, 43379, 181, 74);
INSERT INTO public.who_global_data VALUES (42758, 2277, 123503, 65, 5658, 181, 224);
INSERT INTO public.who_global_data VALUES (42759, 2125, 324692, 132, 18264, 181, 199);
INSERT INTO public.who_global_data VALUES (42760, 3325, 147389, 74, 5310, 181, 190);
INSERT INTO public.who_global_data VALUES (42761, 174, 26644, 0, 1772, 181, 12);
INSERT INTO public.who_global_data VALUES (42762, 0, 336, 0, 24, 181, 104);
INSERT INTO public.who_global_data VALUES (42763, 1764, 81737, 12, 646, 181, 153);
INSERT INTO public.who_global_data VALUES (42764, 347, 250103, 13, 35203, 181, 91);
INSERT INTO public.who_global_data VALUES (42765, 29, 987, 0, 12, 181, 215);
INSERT INTO public.who_global_data VALUES (42766, 1344, 46783, 1, 1040, 181, 84);
INSERT INTO public.who_global_data VALUES (42767, 0, 345, 0, 31, 181, 231);
INSERT INTO public.who_global_data VALUES (42768, 9, 1314, 0, 11, 181, 196);
INSERT INTO public.who_global_data VALUES (42769, 900, 112722, 324, 1433, 181, 105);
INSERT INTO public.who_global_data VALUES (42770, 699, 25837, 5, 418, 181, 122);
INSERT INTO public.who_global_data VALUES (42771, 0, 0, 0, 0, 181, 159);
INSERT INTO public.who_global_data VALUES (42772, 190, 10016, 12, 305, 181, 75);
INSERT INTO public.who_global_data VALUES (42773, 472, 71199, 3, 474, 181, 27);
INSERT INTO public.who_global_data VALUES (42774, 332, 39919, 8, 1023, 181, 54);
INSERT INTO public.who_global_data VALUES (42775, 0, 20, 0, 0, 181, 226);
INSERT INTO public.who_global_data VALUES (42776, 7, 1288, 0, 32, 181, 79);
INSERT INTO public.who_global_data VALUES (42777, 272, 6223, 4, 74, 181, 56);
INSERT INTO public.who_global_data VALUES (42778, 0, 742, 0, 23, 181, 117);
INSERT INTO public.who_global_data VALUES (42779, 4, 1234, 1, 79, 181, 152);
INSERT INTO public.who_global_data VALUES (42780, 154, 5232, 5, 113, 181, 16);
INSERT INTO public.who_global_data VALUES (42781, 0, 89, 0, 1, 181, 10);
INSERT INTO public.who_global_data VALUES (42782, 22, 2247, 0, 81, 181, 201);
INSERT INTO public.who_global_data VALUES (42783, 0, 7113, 0, 119, 181, 174);
INSERT INTO public.who_global_data VALUES (42784, 214, 12922, 6, 141, 181, 119);
INSERT INTO public.who_global_data VALUES (42785, 49, 4624, 6, 143, 181, 168);
INSERT INTO public.who_global_data VALUES (42786, 7, 9070, 0, 125, 181, 99);
INSERT INTO public.who_global_data VALUES (42787, 129, 4898, 0, 19, 181, 171);
INSERT INTO public.who_global_data VALUES (42788, 4, 2565, 0, 125, 181, 87);
INSERT INTO public.who_global_data VALUES (42789, 54, 983, 0, 9, 181, 123);
INSERT INTO public.who_global_data VALUES (42790, 0, 0, 0, 0, 181, 151);
INSERT INTO public.who_global_data VALUES (42791, 60, 336, 1, 16, 181, 213);
INSERT INTO public.who_global_data VALUES (42792, 0, 6498, 0, 157, 181, 118);
INSERT INTO public.who_global_data VALUES (42793, 0, 344, 0, 10, 181, 134);
INSERT INTO public.who_global_data VALUES (42794, 0, 3068, 0, 39, 181, 65);
INSERT INTO public.who_global_data VALUES (42795, 6717, 469407, 794, 51311, 181, 102);
INSERT INTO public.who_global_data VALUES (42796, 0, 0, 0, 0, 181, 223);
INSERT INTO public.who_global_data VALUES (42797, 1, 97, 0, 1, 181, 4);
INSERT INTO public.who_global_data VALUES (42798, 0, 293, 0, 0, 181, 146);
INSERT INTO public.who_global_data VALUES (42799, 55, 3662, 5, 67, 181, 31);
INSERT INTO public.who_global_data VALUES (42800, 0, 13, 0, 1, 181, 127);
INSERT INTO public.who_global_data VALUES (42801, 1345, 32007, 19, 480, 181, 22);
INSERT INTO public.who_global_data VALUES (42802, 28, 2241, 1, 16, 181, 115);
INSERT INTO public.who_global_data VALUES (42803, 0, 359, 0, 6, 181, 106);
INSERT INTO public.who_global_data VALUES (42804, 50, 2852, 0, 16, 181, 90);
INSERT INTO public.who_global_data VALUES (42805, 0, 0, 0, 0, 181, 70);
INSERT INTO public.who_global_data VALUES (42806, 378, 22592, 3, 73, 181, 46);
INSERT INTO public.who_global_data VALUES (42807, 484, 57928, 3, 6156, 181, 139);
INSERT INTO public.who_global_data VALUES (42808, 0, 23, 0, 0, 181, 42);
INSERT INTO public.who_global_data VALUES (42809, 0, 1219, 0, 22, 181, 80);
INSERT INTO public.who_global_data VALUES (42810, 0, 3266, 0, 123, 181, 203);
INSERT INTO public.who_global_data VALUES (42811, 4, 1157, 0, 69, 181, 136);
INSERT INTO public.who_global_data VALUES (42812, 453, 46140, 6, 942, 181, 63);
INSERT INTO public.who_global_data VALUES (42813, 0, 0, 0, 0, 181, 17);
INSERT INTO public.who_global_data VALUES (42814, 1, 48, 0, 2, 181, 172);
INSERT INTO public.who_global_data VALUES (42815, 200, 11771, 4, 523, 181, 109);
INSERT INTO public.who_global_data VALUES (42816, 0, 9468, 0, 256, 181, 200);
INSERT INTO public.who_global_data VALUES (42817, 426, 18374, 6, 103, 181, 93);
INSERT INTO public.who_global_data VALUES (42818, 290, 81357, 7, 509, 181, 5);
INSERT INTO public.who_global_data VALUES (42819, 0, 741, 0, 13, 181, 214);
INSERT INTO public.who_global_data VALUES (42820, 634, 284121, 8, 6082, 181, 204);
INSERT INTO public.who_global_data VALUES (42821, 0, 0, 0, 0, 181, 198);
INSERT INTO public.who_global_data VALUES (42822, 1142, 72560, 17, 1591, 181, 173);
INSERT INTO public.who_global_data VALUES (42823, 0, 188, 0, 3, 181, 229);
INSERT INTO public.who_global_data VALUES (42824, 133, 6508, 3, 69, 181, 76);
INSERT INTO public.who_global_data VALUES (42825, 8466, 463875, 225, 20649, 181, 138);
INSERT INTO public.who_global_data VALUES (42826, 4131, 126885, 41, 2209, 181, 98);
INSERT INTO public.who_global_data VALUES (42827, 0, 0, 0, 0, 181, 103);
INSERT INTO public.who_global_data VALUES (42828, 843, 51167, 13, 1800, 181, 225);
INSERT INTO public.who_global_data VALUES (42829, 186, 52537, 4, 1750, 181, 131);
INSERT INTO public.who_global_data VALUES (42830, 738, 21424, 9, 274, 181, 235);
INSERT INTO public.who_global_data VALUES (42831, 267, 112650, 2, 182, 181, 137);
INSERT INTO public.who_global_data VALUES (42832, 36, 14598, 1, 305, 181, 81);
INSERT INTO public.who_global_data VALUES (42833, 453, 27443, 6, 841, 181, 182);
INSERT INTO public.who_global_data VALUES (42834, 6, 681, 0, 5, 181, 145);
INSERT INTO public.who_global_data VALUES (42835, 1350, 60623, 43, 2659, 181, 26);
INSERT INTO public.who_global_data VALUES (42836, 5189, 887536, 77, 14931, 181, 170);
INSERT INTO public.who_global_data VALUES (42837, 6, 2134, 1, 6, 181, 191);
INSERT INTO public.who_global_data VALUES (42838, 0, 5, 0, 0, 181, 221);
INSERT INTO public.who_global_data VALUES (42839, 0, 9, 0, 0, 181, 64);
INSERT INTO public.who_global_data VALUES (42840, 0, 0, 0, 0, 181, 116);
INSERT INTO public.who_global_data VALUES (42841, 0, 17, 0, 0, 181, 128);
INSERT INTO public.who_global_data VALUES (42842, 0, 25, 0, 0, 181, 6);
INSERT INTO public.who_global_data VALUES (42843, 0, 53, 0, 3, 181, 227);
INSERT INTO public.who_global_data VALUES (42844, 0, 4, 0, 0, 181, 68);
INSERT INTO public.who_global_data VALUES (42845, 0, 56, 0, 0, 181, 184);
INSERT INTO public.who_global_data VALUES (42846, 0, 0, 0, 0, 181, 82);
INSERT INTO public.who_global_data VALUES (42847, 0, 717, 0, 42, 181, 149);
INSERT INTO public.who_global_data VALUES (42848, 0, 878, 0, 15, 181, 197);
INSERT INTO public.who_global_data VALUES (42849, 1469, 287262, 37, 3130, 181, 78);
INSERT INTO public.who_global_data VALUES (42850, 116, 11003, 4, 229, 181, 233);
INSERT INTO public.who_global_data VALUES (42851, 255, 27863, 6, 632, 181, 133);
INSERT INTO public.who_global_data VALUES (42852, 0, 126, 0, 0, 181, 35);
INSERT INTO public.who_global_data VALUES (42853, 8, 1895, 0, 68, 181, 114);
INSERT INTO public.who_global_data VALUES (42854, 132, 54929, 0, 27, 181, 237);
INSERT INTO public.who_global_data VALUES (42855, 0, 3, 0, 0, 181, 55);
INSERT INTO public.who_global_data VALUES (42856, 0, 176, 0, 16, 181, 176);
INSERT INTO public.who_global_data VALUES (42857, 43, 2566, 0, 31, 181, 202);
INSERT INTO public.who_global_data VALUES (42858, 2, 2250, 2, 129, 181, 155);
INSERT INTO public.who_global_data VALUES (42859, 0, 0, 0, 0, 181, 32);
INSERT INTO public.who_global_data VALUES (42860, 0, 3227, 0, 93, 181, 220);
INSERT INTO public.who_global_data VALUES (42861, 7712, 553188, 301, 10210, 181, 30);
INSERT INTO public.who_global_data VALUES (42862, 7, 2470, 0, 47, 181, 147);
INSERT INTO public.who_global_data VALUES (42863, 5803, 335661, 19, 30017, 181, 208);
INSERT INTO public.who_global_data VALUES (42864, 2, 2841, 0, 11, 181, 45);
INSERT INTO public.who_global_data VALUES (42865, 62, 11956, 8, 781, 181, 110);
INSERT INTO public.who_global_data VALUES (42866, 107, 2203, 0, 29, 181, 88);
INSERT INTO public.who_global_data VALUES (42867, 380, 78963, 2, 5778, 181, 51);
INSERT INTO public.who_global_data VALUES (42868, 130, 36624, 1, 1745, 181, 209);
INSERT INTO public.who_global_data VALUES (42869, 65, 1125, 2, 50, 181, 205);
INSERT INTO public.who_global_data VALUES (42870, 39, 7745, 0, 62, 181, 18);
INSERT INTO public.who_global_data VALUES (42871, 3, 3351, 0, 58, 181, 72);
INSERT INTO public.who_global_data VALUES (42872, 758, 309767, 3, 41273, 181, 44);
INSERT INTO public.who_global_data VALUES (42873, 0, 25, 0, 0, 181, 15);
INSERT INTO public.who_global_data VALUES (42874, 0, 1012, 0, 22, 181, 25);
INSERT INTO public.who_global_data VALUES (42875, 0, 0, 0, 0, 181, 179);
INSERT INTO public.who_global_data VALUES (42876, 0, 0, 0, 0, 181, 34);
INSERT INTO public.who_global_data VALUES (42877, 8, 225, 0, 8, 181, 207);
INSERT INTO public.who_global_data VALUES (42878, 19, 1697, 0, 51, 181, 166);
INSERT INTO public.who_global_data VALUES (42879, 7902, 320382, 16, 5829, 181, 126);
INSERT INTO public.who_global_data VALUES (42880, 0, 0, 0, 0, 181, 97);
INSERT INTO public.who_global_data VALUES (42881, 29, 170, 0, 2, 181, 36);
INSERT INTO public.who_global_data VALUES (42882, 0, 0, 0, 0, 181, 125);
INSERT INTO public.who_global_data VALUES (42883, 15, 1269, 0, 6, 181, 124);
INSERT INTO public.who_global_data VALUES (42884, 1199, 80949, 18, 1897, 181, 185);
INSERT INTO public.who_global_data VALUES (42885, 239, 62300, 0, 356, 181, 194);
INSERT INTO public.who_global_data VALUES (42886, 0, 509, 0, 21, 181, 144);
INSERT INTO public.who_global_data VALUES (42887, 61028, 4897958, 1324, 159930, 181, 19);
INSERT INTO public.who_global_data VALUES (42888, 6, 528, 0, 9, 181, 217);
INSERT INTO public.who_global_data VALUES (42889, 7, 1325, 0, 37, 181, 148);
INSERT INTO public.who_global_data VALUES (42890, 738, 30197, 5, 190, 181, 86);
INSERT INTO public.who_global_data VALUES (42891, 0, 0, 0, 0, 181, 13);
INSERT INTO public.who_global_data VALUES (42892, 886, 24166, 6, 208, 181, 157);
INSERT INTO public.who_global_data VALUES (42893, 23, 812, 0, 10, 181, 8);
INSERT INTO public.who_global_data VALUES (42894, 0, 0, 0, 0, 181, 73);
INSERT INTO public.who_global_data VALUES (42895, 1, 1801, 0, 513, 181, 101);
INSERT INTO public.who_global_data VALUES (42896, 739, 7903, 4, 203, 181, 165);
INSERT INTO public.who_global_data VALUES (42897, 124, 4575, 0, 102, 181, 14);
INSERT INTO public.who_global_data VALUES (42898, 78, 37101, 9, 1311, 182, 193);
INSERT INTO public.who_global_data VALUES (42899, 135, 6151, 1, 189, 182, 113);
INSERT INTO public.who_global_data VALUES (42900, 529, 34155, 9, 1282, 182, 143);
INSERT INTO public.who_global_data VALUES (42901, 0, 0, 0, 0, 182, 219);
INSERT INTO public.who_global_data VALUES (42902, 11, 956, 0, 52, 182, 186);
INSERT INTO public.who_global_data VALUES (42903, 55, 1538, 3, 67, 182, 52);
INSERT INTO public.who_global_data VALUES (42904, 0, 3, 0, 0, 182, 180);
INSERT INTO public.who_global_data VALUES (42905, 0, 92, 0, 3, 182, 167);
INSERT INTO public.who_global_data VALUES (42906, 7513, 228195, 156, 4291, 182, 154);
INSERT INTO public.who_global_data VALUES (42907, 200, 39498, 8, 780, 182, 94);
INSERT INTO public.who_global_data VALUES (42908, 92, 263, 0, 3, 182, 66);
INSERT INTO public.who_global_data VALUES (42909, 410, 20272, 11, 266, 182, 58);
INSERT INTO public.who_global_data VALUES (42910, 130, 21819, 1, 720, 182, 163);
INSERT INTO public.who_global_data VALUES (42911, 129, 33376, 4, 483, 182, 37);
INSERT INTO public.who_global_data VALUES (42912, 10, 761, 0, 14, 182, 142);
INSERT INTO public.who_global_data VALUES (42913, 418, 43307, 3, 159, 182, 83);
INSERT INTO public.who_global_data VALUES (42914, 2851, 252502, 27, 3333, 182, 228);
INSERT INTO public.who_global_data VALUES (42915, 0, 133, 0, 7, 182, 188);
INSERT INTO public.who_global_data VALUES (42916, 111, 68614, 3, 583, 182, 62);
INSERT INTO public.who_global_data VALUES (42917, 771, 74745, 6, 9732, 182, 160);
INSERT INTO public.who_global_data VALUES (42918, 28, 114, 0, 2, 182, 50);
INSERT INTO public.who_global_data VALUES (42919, 0, 1936, 0, 38, 182, 33);
INSERT INTO public.who_global_data VALUES (42920, 0, 157, 0, 9, 182, 183);
INSERT INTO public.who_global_data VALUES (42921, 0, 108, 0, 0, 182, 92);
INSERT INTO public.who_global_data VALUES (42922, 1282, 86423, 80, 3465, 182, 158);
INSERT INTO public.who_global_data VALUES (42923, 0, 5, 0, 0, 182, 67);
INSERT INTO public.who_global_data VALUES (42924, 287, 13684, 9, 388, 182, 57);
INSERT INTO public.who_global_data VALUES (42925, 0, 804, 0, 2, 182, 38);
INSERT INTO public.who_global_data VALUES (42926, 53139, 2912212, 1237, 98493, 182, 141);
INSERT INTO public.who_global_data VALUES (42927, 0, 9, 0, 1, 182, 178);
INSERT INTO public.who_global_data VALUES (42928, 1, 142, 0, 3, 182, 108);
INSERT INTO public.who_global_data VALUES (42929, 297, 13014, 11, 435, 182, 39);
INSERT INTO public.who_global_data VALUES (42930, 4, 1162, 0, 54, 182, 2);
INSERT INTO public.who_global_data VALUES (42931, 0, 401, 0, 1, 182, 195);
INSERT INTO public.who_global_data VALUES (42932, 46, 2780, 2, 29, 182, 107);
INSERT INTO public.who_global_data VALUES (42933, 3, 246, 0, 0, 182, 161);
INSERT INTO public.who_global_data VALUES (42934, 324, 18042, 4, 395, 182, 212);
INSERT INTO public.who_global_data VALUES (42935, 374, 118561, 4, 8966, 182, 181);
INSERT INTO public.who_global_data VALUES (42936, 0, 203, 0, 1, 182, 53);
INSERT INTO public.who_global_data VALUES (42937, 21, 4641, 0, 59, 182, 164);
INSERT INTO public.who_global_data VALUES (42938, 0, 942, 0, 76, 182, 140);
INSERT INTO public.who_global_data VALUES (42939, 2154, 368825, 69, 9958, 182, 20);
INSERT INTO public.who_global_data VALUES (42940, 120, 89057, 1, 4688, 182, 112);
INSERT INTO public.who_global_data VALUES (42941, 11996, 357710, 315, 11939, 182, 111);
INSERT INTO public.who_global_data VALUES (42942, 0, 396, 0, 7, 182, 71);
INSERT INTO public.who_global_data VALUES (42943, 27, 3664, 0, 58, 182, 218);
INSERT INTO public.who_global_data VALUES (42944, 0, 0, 0, 0, 182, 43);
INSERT INTO public.who_global_data VALUES (42945, 653, 21070, 9, 200, 182, 49);
INSERT INTO public.who_global_data VALUES (42946, 77, 16524, 1, 104, 182, 1);
INSERT INTO public.who_global_data VALUES (42947, 62, 5466, 0, 155, 182, 48);
INSERT INTO public.who_global_data VALUES (42948, 54, 2829, 0, 88, 182, 232);
INSERT INTO public.who_global_data VALUES (42949, 0, 31, 0, 1, 182, 175);
INSERT INTO public.who_global_data VALUES (42950, 14, 1222, 0, 19, 182, 21);
INSERT INTO public.who_global_data VALUES (42951, 320, 18060, 0, 389, 182, 156);
INSERT INTO public.who_global_data VALUES (42952, 0, 0, 0, 0, 182, 95);
INSERT INTO public.who_global_data VALUES (42953, 46, 9354, 4, 218, 182, 177);
INSERT INTO public.who_global_data VALUES (42954, 136, 14442, 0, 617, 182, 210);
INSERT INTO public.who_global_data VALUES (42955, 4, 5338, 0, 59, 182, 120);
INSERT INTO public.who_global_data VALUES (42956, 0, 18, 0, 0, 182, 135);
INSERT INTO public.who_global_data VALUES (42957, 1173, 77709, 13, 1259, 182, 206);
INSERT INTO public.who_global_data VALUES (42958, 1432, 91969, 20, 5897, 182, 189);
INSERT INTO public.who_global_data VALUES (42959, 141, 95147, 20, 4971, 182, 129);
INSERT INTO public.who_global_data VALUES (42960, 418, 19544, 7, 520, 182, 121);
INSERT INTO public.who_global_data VALUES (42961, 0, 4821, 0, 83, 182, 59);
INSERT INTO public.who_global_data VALUES (42962, 3, 285, 0, 0, 182, 96);
INSERT INTO public.who_global_data VALUES (42963, 9, 2133, 0, 63, 182, 41);
INSERT INTO public.who_global_data VALUES (42964, 68, 3036, 1, 56, 182, 216);
INSERT INTO public.who_global_data VALUES (42965, 552, 21452, 15, 380, 182, 236);
INSERT INTO public.who_global_data VALUES (42966, 0, 13, 0, 0, 182, 150);
INSERT INTO public.who_global_data VALUES (42967, 50, 291, 0, 0, 182, 61);
INSERT INTO public.who_global_data VALUES (42968, 0, 27, 0, 1, 182, 7);
INSERT INTO public.who_global_data VALUES (42969, 22, 7554, 0, 331, 182, 169);
INSERT INTO public.who_global_data VALUES (42970, 2181, 185353, 12, 30201, 182, 28);
INSERT INTO public.who_global_data VALUES (42971, 77, 8204, 0, 47, 182, 85);
INSERT INTO public.who_global_data VALUES (42972, 5, 69, 0, 0, 182, 211);
INSERT INTO public.who_global_data VALUES (42973, 136, 7923, 0, 51, 182, 60);
INSERT INTO public.who_global_data VALUES (42974, 155, 1090, 3, 19, 182, 3);
INSERT INTO public.who_global_data VALUES (42975, 3, 1216, 0, 17, 182, 11);
INSERT INTO public.who_global_data VALUES (42976, 1122, 215336, 12, 9195, 182, 89);
INSERT INTO public.who_global_data VALUES (42977, 455, 40097, 7, 206, 182, 24);
INSERT INTO public.who_global_data VALUES (42978, 1, 190, 0, 0, 182, 162);
INSERT INTO public.who_global_data VALUES (42979, 147, 5270, 0, 210, 182, 100);
INSERT INTO public.who_global_data VALUES (42980, 0, 14, 0, 0, 182, 47);
INSERT INTO public.who_global_data VALUES (42981, 0, 24, 0, 0, 182, 29);
INSERT INTO public.who_global_data VALUES (42982, 0, 279, 0, 14, 182, 40);
INSERT INTO public.who_global_data VALUES (42983, 14, 403, 0, 5, 182, 222);
INSERT INTO public.who_global_data VALUES (42984, 931, 55270, 49, 2168, 182, 132);
INSERT INTO public.who_global_data VALUES (42985, 0, 252, 0, 13, 182, 130);
INSERT INTO public.who_global_data VALUES (42986, 113, 7777, 1, 50, 182, 234);
INSERT INTO public.who_global_data VALUES (42987, 20, 2052, 2, 29, 182, 23);
INSERT INTO public.who_global_data VALUES (42988, 29, 538, 0, 22, 182, 192);
INSERT INTO public.who_global_data VALUES (42989, 38, 7582, 0, 171, 182, 69);
INSERT INTO public.who_global_data VALUES (42990, 0, 12, 0, 0, 182, 187);
INSERT INTO public.who_global_data VALUES (42991, 657, 45755, 23, 1446, 182, 230);
INSERT INTO public.who_global_data VALUES (42992, 24, 4621, 2, 602, 182, 77);
INSERT INTO public.who_global_data VALUES (42993, 20, 1952, 0, 10, 182, 9);
INSERT INTO public.who_global_data VALUES (42994, 61537, 2088611, 933, 42518, 182, 74);
INSERT INTO public.who_global_data VALUES (42995, 2473, 121226, 72, 5593, 182, 224);
INSERT INTO public.who_global_data VALUES (42996, 2450, 322567, 156, 18132, 182, 199);
INSERT INTO public.who_global_data VALUES (42997, 3461, 144064, 75, 5236, 182, 190);
INSERT INTO public.who_global_data VALUES (42998, 98, 26470, 4, 1772, 182, 12);
INSERT INTO public.who_global_data VALUES (42999, 0, 336, 0, 24, 182, 104);
INSERT INTO public.who_global_data VALUES (43000, 1677, 79973, 9, 634, 182, 153);
INSERT INTO public.who_global_data VALUES (43001, 552, 249756, 3, 35190, 182, 91);
INSERT INTO public.who_global_data VALUES (43002, 30, 958, 0, 12, 182, 215);
INSERT INTO public.who_global_data VALUES (43003, 1624, 45439, 6, 1039, 182, 84);
INSERT INTO public.who_global_data VALUES (43004, 1, 345, 0, 31, 182, 231);
INSERT INTO public.who_global_data VALUES (43005, 5, 1305, 0, 11, 182, 196);
INSERT INTO public.who_global_data VALUES (43006, 1883, 111822, 0, 1109, 182, 105);
INSERT INTO public.who_global_data VALUES (43007, 727, 25138, 14, 413, 182, 122);
INSERT INTO public.who_global_data VALUES (43008, 0, 0, 0, 0, 182, 159);
INSERT INTO public.who_global_data VALUES (43009, 181, 9826, 3, 293, 182, 75);
INSERT INTO public.who_global_data VALUES (43010, 682, 70727, 2, 471, 182, 27);
INSERT INTO public.who_global_data VALUES (43011, 425, 39587, 9, 1015, 182, 54);
INSERT INTO public.who_global_data VALUES (43012, 0, 20, 0, 0, 182, 226);
INSERT INTO public.who_global_data VALUES (43013, 6, 1281, 0, 32, 182, 79);
INSERT INTO public.who_global_data VALUES (43014, 279, 5951, 0, 70, 182, 56);
INSERT INTO public.who_global_data VALUES (43015, 0, 742, 0, 23, 182, 117);
INSERT INTO public.who_global_data VALUES (43016, 6, 1230, 0, 78, 182, 152);
INSERT INTO public.who_global_data VALUES (43017, 199, 5078, 1, 108, 182, 16);
INSERT INTO public.who_global_data VALUES (43018, 0, 89, 0, 1, 182, 10);
INSERT INTO public.who_global_data VALUES (43019, 36, 2225, 0, 81, 182, 201);
INSERT INTO public.who_global_data VALUES (43020, 40, 7113, 0, 119, 182, 174);
INSERT INTO public.who_global_data VALUES (43021, 182, 12708, 1, 135, 182, 119);
INSERT INTO public.who_global_data VALUES (43022, 84, 4575, 0, 137, 182, 168);
INSERT INTO public.who_global_data VALUES (43023, 25, 9063, 0, 125, 182, 99);
INSERT INTO public.who_global_data VALUES (43024, 89, 4769, 0, 19, 182, 171);
INSERT INTO public.who_global_data VALUES (43025, 9, 2561, 1, 125, 182, 87);
INSERT INTO public.who_global_data VALUES (43026, 40, 929, 0, 9, 182, 123);
INSERT INTO public.who_global_data VALUES (43027, 0, 0, 0, 0, 182, 151);
INSERT INTO public.who_global_data VALUES (43028, 0, 276, 0, 15, 182, 213);
INSERT INTO public.who_global_data VALUES (43029, 25, 6498, 0, 157, 182, 118);
INSERT INTO public.who_global_data VALUES (43030, 0, 344, 0, 10, 182, 134);
INSERT INTO public.who_global_data VALUES (43031, 26, 3068, 0, 39, 182, 65);
INSERT INTO public.who_global_data VALUES (43032, 6590, 462690, 819, 50517, 182, 102);
INSERT INTO public.who_global_data VALUES (43033, 0, 0, 0, 0, 182, 223);
INSERT INTO public.who_global_data VALUES (43034, 2, 96, 0, 1, 182, 4);
INSERT INTO public.who_global_data VALUES (43035, 0, 293, 0, 0, 182, 146);
INSERT INTO public.who_global_data VALUES (43036, 41, 3607, 1, 62, 182, 31);
INSERT INTO public.who_global_data VALUES (43037, 0, 13, 0, 1, 182, 127);
INSERT INTO public.who_global_data VALUES (43038, 1018, 30662, 12, 461, 182, 22);
INSERT INTO public.who_global_data VALUES (43039, 93, 2213, 0, 15, 182, 115);
INSERT INTO public.who_global_data VALUES (43040, 0, 359, 0, 6, 182, 106);
INSERT INTO public.who_global_data VALUES (43041, 150, 2802, 1, 16, 182, 90);
INSERT INTO public.who_global_data VALUES (43042, 0, 0, 0, 0, 182, 70);
INSERT INTO public.who_global_data VALUES (43043, 464, 22214, 5, 70, 182, 46);
INSERT INTO public.who_global_data VALUES (43044, 517, 57444, 1, 6153, 182, 139);
INSERT INTO public.who_global_data VALUES (43045, 1, 23, 0, 0, 182, 42);
INSERT INTO public.who_global_data VALUES (43046, 0, 1219, 0, 22, 182, 80);
INSERT INTO public.who_global_data VALUES (43047, 0, 3266, 0, 123, 182, 203);
INSERT INTO public.who_global_data VALUES (43048, 0, 1153, 0, 69, 182, 136);
INSERT INTO public.who_global_data VALUES (43049, 443, 45687, 6, 936, 182, 63);
INSERT INTO public.who_global_data VALUES (43050, 0, 0, 0, 0, 182, 17);
INSERT INTO public.who_global_data VALUES (43051, 0, 47, 0, 2, 182, 172);
INSERT INTO public.who_global_data VALUES (43052, 172, 11571, 2, 519, 182, 109);
INSERT INTO public.who_global_data VALUES (43053, 59, 9468, 0, 256, 182, 200);
INSERT INTO public.who_global_data VALUES (43054, 514, 17948, 2, 97, 182, 93);
INSERT INTO public.who_global_data VALUES (43055, 354, 81067, 10, 502, 182, 5);
INSERT INTO public.who_global_data VALUES (43056, 0, 741, 0, 13, 182, 214);
INSERT INTO public.who_global_data VALUES (43057, 842, 283487, 20, 6074, 182, 204);
INSERT INTO public.who_global_data VALUES (43058, 0, 0, 0, 0, 182, 198);
INSERT INTO public.who_global_data VALUES (43059, 1187, 71418, 21, 1574, 182, 173);
INSERT INTO public.who_global_data VALUES (43060, 25, 188, 0, 3, 182, 229);
INSERT INTO public.who_global_data VALUES (43061, 315, 6375, 5, 66, 182, 76);
INSERT INTO public.who_global_data VALUES (43062, 7785, 455409, 196, 20424, 182, 138);
INSERT INTO public.who_global_data VALUES (43063, 3294, 122754, 18, 2168, 182, 98);
INSERT INTO public.who_global_data VALUES (43064, 0, 0, 0, 0, 182, 103);
INSERT INTO public.who_global_data VALUES (43065, 809, 50324, 13, 1787, 182, 225);
INSERT INTO public.who_global_data VALUES (43066, 290, 52351, 3, 1746, 182, 131);
INSERT INTO public.who_global_data VALUES (43067, 752, 20686, 7, 265, 182, 235);
INSERT INTO public.who_global_data VALUES (43068, 291, 112383, 2, 180, 182, 137);
INSERT INTO public.who_global_data VALUES (43069, 43, 14562, 1, 304, 182, 81);
INSERT INTO public.who_global_data VALUES (43070, 362, 26990, 7, 835, 182, 182);
INSERT INTO public.who_global_data VALUES (43071, 4, 675, 0, 5, 182, 145);
INSERT INTO public.who_global_data VALUES (43072, 1378, 59273, 50, 2616, 182, 26);
INSERT INTO public.who_global_data VALUES (43073, 5212, 882347, 129, 14854, 182, 170);
INSERT INTO public.who_global_data VALUES (43074, 17, 2128, 0, 5, 182, 191);
INSERT INTO public.who_global_data VALUES (43075, 0, 5, 0, 0, 182, 221);
INSERT INTO public.who_global_data VALUES (43076, 0, 9, 0, 0, 182, 64);
INSERT INTO public.who_global_data VALUES (43077, 0, 0, 0, 0, 182, 116);
INSERT INTO public.who_global_data VALUES (43078, 0, 17, 0, 0, 182, 128);
INSERT INTO public.who_global_data VALUES (43079, 0, 25, 0, 0, 182, 6);
INSERT INTO public.who_global_data VALUES (43080, 0, 53, 0, 3, 182, 227);
INSERT INTO public.who_global_data VALUES (43081, 0, 4, 0, 0, 182, 68);
INSERT INTO public.who_global_data VALUES (43082, 0, 56, 0, 0, 182, 184);
INSERT INTO public.who_global_data VALUES (43083, 0, 0, 0, 0, 182, 82);
INSERT INTO public.who_global_data VALUES (43084, 0, 717, 0, 42, 182, 149);
INSERT INTO public.who_global_data VALUES (43085, 0, 878, 0, 15, 182, 197);
INSERT INTO public.who_global_data VALUES (43086, 1567, 285793, 38, 3093, 182, 78);
INSERT INTO public.who_global_data VALUES (43087, 172, 10887, 2, 225, 182, 233);
INSERT INTO public.who_global_data VALUES (43088, 276, 27608, 5, 626, 182, 133);
INSERT INTO public.who_global_data VALUES (43089, 12, 126, 0, 0, 182, 35);
INSERT INTO public.who_global_data VALUES (43090, 10, 1887, 0, 68, 182, 114);
INSERT INTO public.who_global_data VALUES (43091, 242, 54797, 0, 27, 182, 237);
INSERT INTO public.who_global_data VALUES (43092, 0, 3, 0, 0, 182, 55);
INSERT INTO public.who_global_data VALUES (43093, 16, 176, 0, 16, 182, 176);
INSERT INTO public.who_global_data VALUES (43094, 43, 2523, 2, 31, 182, 202);
INSERT INTO public.who_global_data VALUES (43095, 14, 2248, 1, 127, 182, 155);
INSERT INTO public.who_global_data VALUES (43096, 0, 0, 0, 0, 182, 32);
INSERT INTO public.who_global_data VALUES (43097, 0, 3227, 0, 93, 182, 220);
INSERT INTO public.who_global_data VALUES (43098, 7292, 545476, 305, 9909, 182, 30);
INSERT INTO public.who_global_data VALUES (43099, 13, 2463, 0, 47, 182, 147);
INSERT INTO public.who_global_data VALUES (43100, 4957, 329858, 27, 29998, 182, 208);
INSERT INTO public.who_global_data VALUES (43101, 0, 2839, 0, 11, 182, 45);
INSERT INTO public.who_global_data VALUES (43102, 0, 11894, 0, 773, 182, 110);
INSERT INTO public.who_global_data VALUES (43103, 46, 2096, 2, 29, 182, 88);
INSERT INTO public.who_global_data VALUES (43104, 378, 78583, 4, 5776, 182, 51);
INSERT INTO public.who_global_data VALUES (43105, 185, 36494, 1, 1744, 182, 209);
INSERT INTO public.who_global_data VALUES (43106, 61, 1060, 0, 48, 182, 205);
INSERT INTO public.who_global_data VALUES (43107, 41, 7706, 0, 62, 182, 18);
INSERT INTO public.who_global_data VALUES (43108, 3, 3348, 0, 58, 182, 72);
INSERT INTO public.who_global_data VALUES (43109, 871, 309009, 12, 41270, 182, 44);
INSERT INTO public.who_global_data VALUES (43110, 0, 25, 0, 0, 182, 15);
INSERT INTO public.who_global_data VALUES (43111, 11, 1012, 1, 22, 182, 25);
INSERT INTO public.who_global_data VALUES (43112, 0, 0, 0, 0, 182, 179);
INSERT INTO public.who_global_data VALUES (43113, 0, 0, 0, 0, 182, 34);
INSERT INTO public.who_global_data VALUES (43114, 10, 217, 0, 8, 182, 207);
INSERT INTO public.who_global_data VALUES (43115, 22, 1678, 0, 51, 182, 166);
INSERT INTO public.who_global_data VALUES (43116, 7915, 312480, 15, 5813, 182, 126);
INSERT INTO public.who_global_data VALUES (43117, 0, 0, 0, 0, 182, 97);
INSERT INTO public.who_global_data VALUES (43118, 12, 141, 0, 2, 182, 36);
INSERT INTO public.who_global_data VALUES (43119, 0, 0, 0, 0, 182, 125);
INSERT INTO public.who_global_data VALUES (43120, 31, 1254, 1, 6, 182, 124);
INSERT INTO public.who_global_data VALUES (43121, 1489, 79750, 27, 1879, 182, 185);
INSERT INTO public.who_global_data VALUES (43122, 216, 62061, 2, 356, 182, 194);
INSERT INTO public.who_global_data VALUES (43123, 0, 509, 0, 21, 182, 144);
INSERT INTO public.who_global_data VALUES (43124, 55318, 4836930, 1249, 158606, 182, 19);
INSERT INTO public.who_global_data VALUES (43125, 21, 522, 0, 9, 182, 217);
INSERT INTO public.who_global_data VALUES (43126, 9, 1318, 0, 37, 182, 148);
INSERT INTO public.who_global_data VALUES (43127, 650, 29459, 6, 185, 182, 86);
INSERT INTO public.who_global_data VALUES (43128, 0, 0, 0, 0, 182, 13);
INSERT INTO public.who_global_data VALUES (43129, 981, 23280, 7, 202, 182, 157);
INSERT INTO public.who_global_data VALUES (43130, 39, 789, 0, 10, 182, 8);
INSERT INTO public.who_global_data VALUES (43131, 0, 0, 0, 0, 182, 73);
INSERT INTO public.who_global_data VALUES (43132, 28, 1800, 4, 513, 182, 101);
INSERT INTO public.who_global_data VALUES (43133, 0, 7164, 0, 199, 182, 165);
INSERT INTO public.who_global_data VALUES (43134, 56, 4451, 5, 102, 182, 14);
INSERT INTO public.who_global_data VALUES (43135, 41, 37023, 0, 1302, 183, 193);
INSERT INTO public.who_global_data VALUES (43136, 127, 6016, 6, 188, 183, 113);
INSERT INTO public.who_global_data VALUES (43137, 571, 33626, 12, 1273, 183, 143);
INSERT INTO public.who_global_data VALUES (43138, 0, 0, 0, 0, 183, 219);
INSERT INTO public.who_global_data VALUES (43139, 6, 945, 0, 52, 183, 186);
INSERT INTO public.who_global_data VALUES (43140, 88, 1483, 2, 64, 183, 52);
INSERT INTO public.who_global_data VALUES (43141, 0, 3, 0, 0, 183, 180);
INSERT INTO public.who_global_data VALUES (43142, 0, 92, 0, 3, 183, 167);
INSERT INTO public.who_global_data VALUES (43143, 7147, 220682, 126, 4135, 183, 154);
INSERT INTO public.who_global_data VALUES (43144, 166, 39298, 5, 772, 183, 94);
INSERT INTO public.who_global_data VALUES (43145, 39, 171, 0, 3, 183, 66);
INSERT INTO public.who_global_data VALUES (43146, 418, 19862, 8, 255, 183, 58);
INSERT INTO public.who_global_data VALUES (43147, 114, 21689, 0, 719, 183, 163);
INSERT INTO public.who_global_data VALUES (43148, 144, 33247, 3, 479, 183, 37);
INSERT INTO public.who_global_data VALUES (43149, 36, 751, 0, 14, 183, 142);
INSERT INTO public.who_global_data VALUES (43150, 375, 42889, 0, 156, 183, 83);
INSERT INTO public.who_global_data VALUES (43151, 2977, 249651, 39, 3306, 183, 228);
INSERT INTO public.who_global_data VALUES (43152, 0, 133, 0, 7, 183, 188);
INSERT INTO public.who_global_data VALUES (43153, 127, 68503, 3, 580, 183, 62);
INSERT INTO public.who_global_data VALUES (43154, 769, 73974, 4, 9726, 183, 160);
INSERT INTO public.who_global_data VALUES (43155, 19, 86, 0, 2, 183, 50);
INSERT INTO public.who_global_data VALUES (43156, 0, 1936, 0, 38, 183, 33);
INSERT INTO public.who_global_data VALUES (43157, 0, 157, 0, 9, 183, 183);
INSERT INTO public.who_global_data VALUES (43158, 3, 108, 0, 0, 183, 92);
INSERT INTO public.who_global_data VALUES (43159, 1780, 85141, 65, 3385, 183, 158);
INSERT INTO public.who_global_data VALUES (43160, 0, 5, 0, 0, 183, 67);
INSERT INTO public.who_global_data VALUES (43161, 251, 13397, 5, 379, 183, 57);
INSERT INTO public.who_global_data VALUES (43162, 0, 804, 0, 2, 183, 38);
INSERT INTO public.who_global_data VALUES (43163, 57152, 2859073, 1437, 97256, 183, 141);
INSERT INTO public.who_global_data VALUES (43164, 0, 9, 0, 1, 183, 178);
INSERT INTO public.who_global_data VALUES (43165, 0, 141, 0, 3, 183, 108);
INSERT INTO public.who_global_data VALUES (43166, 303, 12717, 9, 424, 183, 39);
INSERT INTO public.who_global_data VALUES (43167, 2, 1158, 0, 54, 183, 2);
INSERT INTO public.who_global_data VALUES (43168, 1, 401, 0, 1, 183, 195);
INSERT INTO public.who_global_data VALUES (43169, 45, 2734, 0, 27, 183, 107);
INSERT INTO public.who_global_data VALUES (43170, 0, 243, 0, 0, 183, 161);
INSERT INTO public.who_global_data VALUES (43171, 0, 17718, 0, 391, 183, 212);
INSERT INTO public.who_global_data VALUES (43172, 395, 118187, 4, 8962, 183, 181);
INSERT INTO public.who_global_data VALUES (43173, 0, 203, 0, 1, 183, 53);
INSERT INTO public.who_global_data VALUES (43174, 2, 4620, 0, 59, 183, 164);
INSERT INTO public.who_global_data VALUES (43175, 3, 942, 1, 76, 183, 140);
INSERT INTO public.who_global_data VALUES (43176, 1948, 366671, 97, 9889, 183, 20);
INSERT INTO public.who_global_data VALUES (43177, 133, 88937, 3, 4687, 183, 112);
INSERT INTO public.who_global_data VALUES (43178, 10735, 345714, 309, 11624, 183, 111);
INSERT INTO public.who_global_data VALUES (43179, 8, 396, 0, 7, 183, 71);
INSERT INTO public.who_global_data VALUES (43180, 91, 3637, 0, 58, 183, 218);
INSERT INTO public.who_global_data VALUES (43181, 0, 0, 0, 0, 183, 43);
INSERT INTO public.who_global_data VALUES (43182, 580, 20417, 10, 191, 183, 49);
INSERT INTO public.who_global_data VALUES (43183, 98, 16447, 0, 103, 183, 1);
INSERT INTO public.who_global_data VALUES (43184, 28, 5404, 1, 155, 183, 48);
INSERT INTO public.who_global_data VALUES (43185, 49, 2775, 0, 88, 183, 232);
INSERT INTO public.who_global_data VALUES (43186, 2, 31, 0, 1, 183, 175);
INSERT INTO public.who_global_data VALUES (43187, 13, 1208, 0, 19, 183, 21);
INSERT INTO public.who_global_data VALUES (43188, 211, 17740, 1, 389, 183, 156);
INSERT INTO public.who_global_data VALUES (43189, 0, 0, 0, 0, 183, 95);
INSERT INTO public.who_global_data VALUES (43190, 56, 9308, 0, 214, 183, 177);
INSERT INTO public.who_global_data VALUES (43191, 121, 14306, 1, 617, 183, 210);
INSERT INTO public.who_global_data VALUES (43192, 4, 5334, 0, 59, 183, 120);
INSERT INTO public.who_global_data VALUES (43193, 0, 18, 0, 0, 183, 135);
INSERT INTO public.who_global_data VALUES (43194, 876, 76536, 24, 1246, 183, 206);
INSERT INTO public.who_global_data VALUES (43195, 1671, 90537, 30, 5877, 183, 189);
INSERT INTO public.who_global_data VALUES (43196, 131, 95006, 21, 4951, 183, 129);
INSERT INTO public.who_global_data VALUES (43197, 425, 19126, 15, 513, 183, 121);
INSERT INTO public.who_global_data VALUES (43198, 0, 4821, 0, 83, 183, 59);
INSERT INTO public.who_global_data VALUES (43199, 0, 282, 0, 0, 183, 96);
INSERT INTO public.who_global_data VALUES (43200, 11, 2124, 0, 63, 183, 41);
INSERT INTO public.who_global_data VALUES (43201, 59, 2968, 2, 55, 183, 216);
INSERT INTO public.who_global_data VALUES (43202, 564, 20900, 9, 365, 183, 236);
INSERT INTO public.who_global_data VALUES (43203, 0, 13, 0, 0, 183, 150);
INSERT INTO public.who_global_data VALUES (43204, 0, 241, 0, 0, 183, 61);
INSERT INTO public.who_global_data VALUES (43205, 0, 27, 0, 1, 183, 7);
INSERT INTO public.who_global_data VALUES (43206, 20, 7532, 0, 331, 183, 169);
INSERT INTO public.who_global_data VALUES (43207, 1520, 183172, 7, 30189, 183, 28);
INSERT INTO public.who_global_data VALUES (43208, 58, 8127, 0, 47, 183, 85);
INSERT INTO public.who_global_data VALUES (43209, 0, 64, 0, 0, 183, 211);
INSERT INTO public.who_global_data VALUES (43210, 0, 7787, 0, 51, 183, 60);
INSERT INTO public.who_global_data VALUES (43211, 0, 935, 0, 16, 183, 3);
INSERT INTO public.who_global_data VALUES (43212, 7, 1213, 0, 17, 183, 11);
INSERT INTO public.who_global_data VALUES (43213, 1147, 214214, 8, 9183, 183, 89);
INSERT INTO public.who_global_data VALUES (43214, 567, 39642, 0, 199, 183, 24);
INSERT INTO public.who_global_data VALUES (43215, 0, 189, 0, 0, 183, 162);
INSERT INTO public.who_global_data VALUES (43216, 150, 5123, 0, 210, 183, 100);
INSERT INTO public.who_global_data VALUES (43217, 0, 14, 0, 0, 183, 47);
INSERT INTO public.who_global_data VALUES (43218, 0, 24, 0, 0, 183, 29);
INSERT INTO public.who_global_data VALUES (43219, 7, 279, 0, 14, 183, 40);
INSERT INTO public.who_global_data VALUES (43220, 8, 389, 0, 5, 183, 222);
INSERT INTO public.who_global_data VALUES (43221, 830, 54339, 47, 2119, 183, 132);
INSERT INTO public.who_global_data VALUES (43222, 0, 252, 0, 13, 183, 130);
INSERT INTO public.who_global_data VALUES (43223, 89, 7664, 0, 49, 183, 234);
INSERT INTO public.who_global_data VALUES (43224, 0, 2032, 0, 27, 183, 23);
INSERT INTO public.who_global_data VALUES (43225, 12, 509, 0, 22, 183, 192);
INSERT INTO public.who_global_data VALUES (43226, 12, 7544, 0, 171, 183, 69);
INSERT INTO public.who_global_data VALUES (43227, 0, 12, 0, 0, 183, 187);
INSERT INTO public.who_global_data VALUES (43228, 799, 45098, 23, 1423, 183, 230);
INSERT INTO public.who_global_data VALUES (43229, 33, 4597, 1, 600, 183, 77);
INSERT INTO public.who_global_data VALUES (43230, 6, 1932, 0, 10, 183, 9);
INSERT INTO public.who_global_data VALUES (43231, 62538, 2027074, 886, 41585, 183, 74);
INSERT INTO public.who_global_data VALUES (43232, 1882, 118753, 69, 5521, 183, 224);
INSERT INTO public.who_global_data VALUES (43233, 2634, 320117, 174, 17976, 183, 199);
INSERT INTO public.who_global_data VALUES (43234, 3047, 140603, 67, 5161, 183, 190);
INSERT INTO public.who_global_data VALUES (43235, 69, 26372, 5, 1768, 183, 12);
INSERT INTO public.who_global_data VALUES (43236, 0, 336, 0, 24, 183, 104);
INSERT INTO public.who_global_data VALUES (43237, 1690, 78296, 10, 625, 183, 153);
INSERT INTO public.who_global_data VALUES (43238, 401, 249204, 6, 35187, 183, 91);
INSERT INTO public.who_global_data VALUES (43239, 8, 928, 0, 12, 183, 215);
INSERT INTO public.who_global_data VALUES (43240, 1552, 43815, 7, 1033, 183, 84);
INSERT INTO public.who_global_data VALUES (43241, 1, 344, 0, 31, 183, 231);
INSERT INTO public.who_global_data VALUES (43242, 1, 1300, 0, 11, 183, 196);
INSERT INTO public.who_global_data VALUES (43243, 2009, 109939, 0, 1109, 183, 105);
INSERT INTO public.who_global_data VALUES (43244, 538, 24411, 8, 399, 183, 122);
INSERT INTO public.who_global_data VALUES (43245, 0, 0, 0, 0, 183, 159);
INSERT INTO public.who_global_data VALUES (43246, 196, 9645, 26, 290, 183, 75);
INSERT INTO public.who_global_data VALUES (43247, 620, 70045, 1, 469, 183, 27);
INSERT INTO public.who_global_data VALUES (43248, 503, 39162, 4, 1006, 183, 54);
INSERT INTO public.who_global_data VALUES (43249, 0, 20, 0, 0, 183, 226);
INSERT INTO public.who_global_data VALUES (43250, 18, 1275, 0, 32, 183, 79);
INSERT INTO public.who_global_data VALUES (43251, 255, 5672, 2, 70, 183, 56);
INSERT INTO public.who_global_data VALUES (43252, 16, 742, 2, 23, 183, 117);
INSERT INTO public.who_global_data VALUES (43253, 3, 1224, 0, 78, 183, 152);
INSERT INTO public.who_global_data VALUES (43254, 404, 4879, 8, 107, 183, 16);
INSERT INTO public.who_global_data VALUES (43255, 0, 89, 0, 1, 183, 10);
INSERT INTO public.who_global_data VALUES (43256, 24, 2189, 0, 81, 183, 201);
INSERT INTO public.who_global_data VALUES (43257, 66, 7073, 1, 119, 183, 174);
INSERT INTO public.who_global_data VALUES (43258, 304, 12526, 7, 134, 183, 119);
INSERT INTO public.who_global_data VALUES (43259, 65, 4491, 1, 137, 183, 168);
INSERT INTO public.who_global_data VALUES (43260, 15, 9038, 0, 125, 183, 99);
INSERT INTO public.who_global_data VALUES (43261, 86, 4680, 0, 19, 183, 171);
INSERT INTO public.who_global_data VALUES (43262, 6, 2552, 0, 124, 183, 87);
INSERT INTO public.who_global_data VALUES (43263, 50, 889, 0, 9, 183, 123);
INSERT INTO public.who_global_data VALUES (43264, 0, 0, 0, 0, 183, 151);
INSERT INTO public.who_global_data VALUES (43265, 7, 276, 0, 15, 183, 213);
INSERT INTO public.who_global_data VALUES (43266, 29, 6473, 0, 157, 183, 118);
INSERT INTO public.who_global_data VALUES (43267, 0, 344, 0, 10, 183, 134);
INSERT INTO public.who_global_data VALUES (43268, 11, 3042, 0, 39, 183, 65);
INSERT INTO public.who_global_data VALUES (43269, 6139, 456100, 829, 49698, 183, 102);
INSERT INTO public.who_global_data VALUES (43270, 0, 0, 0, 0, 183, 223);
INSERT INTO public.who_global_data VALUES (43271, 1, 94, 0, 1, 183, 4);
INSERT INTO public.who_global_data VALUES (43272, 0, 293, 0, 0, 183, 146);
INSERT INTO public.who_global_data VALUES (43273, 48, 3566, 1, 61, 183, 31);
INSERT INTO public.who_global_data VALUES (43274, 0, 13, 0, 1, 183, 127);
INSERT INTO public.who_global_data VALUES (43275, 1144, 29644, 14, 449, 183, 22);
INSERT INTO public.who_global_data VALUES (43276, 41, 2120, 0, 15, 183, 115);
INSERT INTO public.who_global_data VALUES (43277, 2, 359, 0, 6, 183, 106);
INSERT INTO public.who_global_data VALUES (43278, 112, 2652, 3, 15, 183, 90);
INSERT INTO public.who_global_data VALUES (43279, 0, 0, 0, 0, 183, 70);
INSERT INTO public.who_global_data VALUES (43280, 360, 21750, 5, 65, 183, 46);
INSERT INTO public.who_global_data VALUES (43281, 605, 56927, 0, 6152, 183, 139);
INSERT INTO public.who_global_data VALUES (43282, 0, 22, 0, 0, 183, 42);
INSERT INTO public.who_global_data VALUES (43283, 0, 1219, 0, 22, 183, 80);
INSERT INTO public.who_global_data VALUES (43284, 0, 3266, 0, 123, 183, 203);
INSERT INTO public.who_global_data VALUES (43285, 1, 1153, 0, 69, 183, 136);
INSERT INTO public.who_global_data VALUES (43286, 354, 45244, 3, 930, 183, 63);
INSERT INTO public.who_global_data VALUES (43287, 0, 0, 0, 0, 183, 17);
INSERT INTO public.who_global_data VALUES (43288, 1, 47, 0, 2, 183, 172);
INSERT INTO public.who_global_data VALUES (43289, 110, 11399, 6, 517, 183, 109);
INSERT INTO public.who_global_data VALUES (43290, 47, 9409, 0, 256, 183, 200);
INSERT INTO public.who_global_data VALUES (43291, 453, 17434, 3, 95, 183, 93);
INSERT INTO public.who_global_data VALUES (43292, 427, 80713, 4, 492, 183, 5);
INSERT INTO public.who_global_data VALUES (43293, 0, 741, 0, 13, 183, 214);
INSERT INTO public.who_global_data VALUES (43294, 782, 282645, 19, 6054, 183, 204);
INSERT INTO public.who_global_data VALUES (43295, 0, 0, 0, 0, 183, 198);
INSERT INTO public.who_global_data VALUES (43296, 807, 70231, 31, 1553, 183, 173);
INSERT INTO public.who_global_data VALUES (43297, 10, 163, 1, 3, 183, 229);
INSERT INTO public.who_global_data VALUES (43298, 208, 6060, 2, 61, 183, 76);
INSERT INTO public.who_global_data VALUES (43299, 7734, 447624, 221, 20228, 183, 138);
INSERT INTO public.who_global_data VALUES (43300, 3480, 119460, 27, 2150, 183, 98);
INSERT INTO public.who_global_data VALUES (43301, 0, 0, 0, 0, 183, 103);
INSERT INTO public.who_global_data VALUES (43302, 726, 49515, 18, 1774, 183, 225);
INSERT INTO public.who_global_data VALUES (43303, 213, 52061, 3, 1743, 183, 131);
INSERT INTO public.who_global_data VALUES (43304, 283, 19934, 12, 258, 183, 235);
INSERT INTO public.who_global_data VALUES (43305, 287, 112092, 0, 178, 183, 137);
INSERT INTO public.who_global_data VALUES (43306, 20, 14519, 1, 303, 183, 81);
INSERT INTO public.who_global_data VALUES (43307, 406, 26628, 5, 828, 183, 182);
INSERT INTO public.who_global_data VALUES (43308, 1, 671, 0, 5, 183, 145);
INSERT INTO public.who_global_data VALUES (43309, 1345, 57895, 45, 2566, 183, 26);
INSERT INTO public.who_global_data VALUES (43310, 5241, 877135, 119, 14725, 183, 170);
INSERT INTO public.who_global_data VALUES (43311, 7, 2111, 0, 5, 183, 191);
INSERT INTO public.who_global_data VALUES (43312, 0, 5, 0, 0, 183, 221);
INSERT INTO public.who_global_data VALUES (43313, 0, 9, 0, 0, 183, 64);
INSERT INTO public.who_global_data VALUES (43314, 0, 0, 0, 0, 183, 116);
INSERT INTO public.who_global_data VALUES (43315, 0, 17, 0, 0, 183, 128);
INSERT INTO public.who_global_data VALUES (43316, 0, 25, 0, 0, 183, 6);
INSERT INTO public.who_global_data VALUES (43317, 0, 53, 0, 3, 183, 227);
INSERT INTO public.who_global_data VALUES (43318, 0, 4, 0, 0, 183, 68);
INSERT INTO public.who_global_data VALUES (43319, 1, 56, 0, 0, 183, 184);
INSERT INTO public.who_global_data VALUES (43320, 0, 0, 0, 0, 183, 82);
INSERT INTO public.who_global_data VALUES (43321, 1, 717, 0, 42, 183, 149);
INSERT INTO public.who_global_data VALUES (43322, 0, 878, 0, 15, 183, 197);
INSERT INTO public.who_global_data VALUES (43323, 1402, 284226, 35, 3055, 183, 78);
INSERT INTO public.who_global_data VALUES (43324, 177, 10715, 5, 223, 183, 233);
INSERT INTO public.who_global_data VALUES (43325, 299, 27332, 7, 621, 183, 133);
INSERT INTO public.who_global_data VALUES (43326, 0, 114, 0, 0, 183, 35);
INSERT INTO public.who_global_data VALUES (43327, 17, 1877, 1, 68, 183, 114);
INSERT INTO public.who_global_data VALUES (43328, 301, 54555, 0, 27, 183, 237);
INSERT INTO public.who_global_data VALUES (43329, 0, 3, 0, 0, 183, 55);
INSERT INTO public.who_global_data VALUES (43330, 4, 160, 0, 16, 183, 176);
INSERT INTO public.who_global_data VALUES (43331, 63, 2480, 0, 29, 183, 202);
INSERT INTO public.who_global_data VALUES (43332, 10, 2234, 0, 126, 183, 155);
INSERT INTO public.who_global_data VALUES (43333, 0, 0, 0, 0, 183, 32);
INSERT INTO public.who_global_data VALUES (43334, 0, 3227, 0, 93, 183, 220);
INSERT INTO public.who_global_data VALUES (43335, 8307, 538184, 306, 9604, 183, 30);
INSERT INTO public.who_global_data VALUES (43336, 0, 2450, 0, 47, 183, 147);
INSERT INTO public.who_global_data VALUES (43337, 4418, 324901, 11, 29971, 183, 208);
INSERT INTO public.who_global_data VALUES (43338, 0, 2839, 0, 11, 183, 45);
INSERT INTO public.who_global_data VALUES (43339, 44, 11894, 4, 773, 183, 110);
INSERT INTO public.who_global_data VALUES (43340, 69, 2050, 0, 27, 183, 88);
INSERT INTO public.who_global_data VALUES (43341, 425, 78205, 1, 5772, 183, 51);
INSERT INTO public.who_global_data VALUES (43342, 156, 36309, 1, 1743, 183, 209);
INSERT INTO public.who_global_data VALUES (43343, 55, 999, 0, 48, 183, 205);
INSERT INTO public.who_global_data VALUES (43344, 40, 7665, 1, 62, 183, 18);
INSERT INTO public.who_global_data VALUES (43345, 15, 3345, 0, 58, 183, 72);
INSERT INTO public.who_global_data VALUES (43346, 950, 308138, 18, 41258, 183, 44);
INSERT INTO public.who_global_data VALUES (43347, 0, 25, 0, 0, 183, 15);
INSERT INTO public.who_global_data VALUES (43348, 13, 1001, 2, 21, 183, 25);
INSERT INTO public.who_global_data VALUES (43349, 0, 0, 0, 0, 183, 179);
INSERT INTO public.who_global_data VALUES (43350, 0, 0, 0, 0, 183, 34);
INSERT INTO public.who_global_data VALUES (43351, 10, 207, 0, 8, 183, 207);
INSERT INTO public.who_global_data VALUES (43352, 14, 1656, 0, 51, 183, 166);
INSERT INTO public.who_global_data VALUES (43353, 7883, 304565, 14, 5798, 183, 126);
INSERT INTO public.who_global_data VALUES (43354, 0, 0, 0, 0, 183, 97);
INSERT INTO public.who_global_data VALUES (43355, 13, 129, 0, 2, 183, 36);
INSERT INTO public.who_global_data VALUES (43356, 0, 0, 0, 0, 183, 125);
INSERT INTO public.who_global_data VALUES (43357, 10, 1223, 0, 5, 183, 124);
INSERT INTO public.who_global_data VALUES (43358, 1453, 78261, 33, 1852, 183, 185);
INSERT INTO public.who_global_data VALUES (43359, 239, 61845, 1, 354, 183, 194);
INSERT INTO public.who_global_data VALUES (43360, 0, 509, 0, 21, 183, 144);
INSERT INTO public.who_global_data VALUES (43361, 53373, 4781612, 1307, 157357, 183, 19);
INSERT INTO public.who_global_data VALUES (43362, 20, 501, 1, 9, 183, 217);
INSERT INTO public.who_global_data VALUES (43363, 9, 1309, 0, 37, 183, 148);
INSERT INTO public.who_global_data VALUES (43364, 740, 28809, 6, 179, 183, 86);
INSERT INTO public.who_global_data VALUES (43365, 0, 0, 0, 0, 183, 13);
INSERT INTO public.who_global_data VALUES (43366, 861, 22299, 8, 195, 183, 157);
INSERT INTO public.who_global_data VALUES (43367, 33, 750, 2, 10, 183, 8);
INSERT INTO public.who_global_data VALUES (43368, 0, 0, 0, 0, 183, 73);
INSERT INTO public.who_global_data VALUES (43369, 5, 1772, 0, 509, 183, 101);
INSERT INTO public.who_global_data VALUES (43370, 142, 7164, 23, 199, 183, 165);
INSERT INTO public.who_global_data VALUES (43371, 56, 4395, 13, 97, 183, 14);
INSERT INTO public.who_global_data VALUES (43372, 67, 36982, 4, 1302, 184, 193);
INSERT INTO public.who_global_data VALUES (43373, 139, 5889, 6, 182, 184, 113);
INSERT INTO public.who_global_data VALUES (43374, 551, 33055, 13, 1261, 184, 143);
INSERT INTO public.who_global_data VALUES (43375, 0, 0, 0, 0, 184, 219);
INSERT INTO public.who_global_data VALUES (43376, 0, 939, 0, 52, 184, 186);
INSERT INTO public.who_global_data VALUES (43377, 51, 1395, 3, 62, 184, 52);
INSERT INTO public.who_global_data VALUES (43378, 0, 3, 0, 0, 184, 180);
INSERT INTO public.who_global_data VALUES (43379, 0, 92, 0, 3, 184, 167);
INSERT INTO public.who_global_data VALUES (43380, 6792, 213535, 146, 4009, 184, 154);
INSERT INTO public.who_global_data VALUES (43381, 233, 39132, 2, 767, 184, 94);
INSERT INTO public.who_global_data VALUES (43382, 8, 132, 0, 3, 184, 66);
INSERT INTO public.who_global_data VALUES (43383, 715, 19444, 15, 247, 184, 58);
INSERT INTO public.who_global_data VALUES (43384, 103, 21575, 0, 719, 184, 163);
INSERT INTO public.who_global_data VALUES (43385, 193, 33103, 3, 476, 184, 37);
INSERT INTO public.who_global_data VALUES (43386, 36, 715, 0, 14, 184, 142);
INSERT INTO public.who_global_data VALUES (43387, 382, 42514, 4, 156, 184, 83);
INSERT INTO public.who_global_data VALUES (43388, 2654, 246674, 33, 3267, 184, 228);
INSERT INTO public.who_global_data VALUES (43389, 1, 133, 0, 7, 184, 188);
INSERT INTO public.who_global_data VALUES (43390, 126, 68376, 3, 577, 184, 62);
INSERT INTO public.who_global_data VALUES (43391, 767, 73205, 5, 9722, 184, 160);
INSERT INTO public.who_global_data VALUES (43392, 10, 67, 0, 2, 184, 50);
INSERT INTO public.who_global_data VALUES (43393, 0, 1936, 0, 38, 184, 33);
INSERT INTO public.who_global_data VALUES (43394, 0, 157, 0, 9, 184, 183);
INSERT INTO public.who_global_data VALUES (43395, 0, 105, 0, 0, 184, 92);
INSERT INTO public.who_global_data VALUES (43396, 1515, 83361, 92, 3320, 184, 158);
INSERT INTO public.who_global_data VALUES (43397, 0, 5, 0, 0, 184, 67);
INSERT INTO public.who_global_data VALUES (43398, 288, 13146, 6, 374, 184, 57);
INSERT INTO public.who_global_data VALUES (43399, 0, 804, 0, 2, 184, 38);
INSERT INTO public.who_global_data VALUES (43400, 51603, 2801921, 1154, 95819, 184, 141);
INSERT INTO public.who_global_data VALUES (43401, 0, 9, 0, 1, 184, 178);
INSERT INTO public.who_global_data VALUES (43402, 0, 141, 0, 3, 184, 108);
INSERT INTO public.who_global_data VALUES (43403, 255, 12414, 11, 415, 184, 39);
INSERT INTO public.who_global_data VALUES (43404, 3, 1156, 0, 54, 184, 2);
INSERT INTO public.who_global_data VALUES (43405, 5, 400, 0, 1, 184, 195);
INSERT INTO public.who_global_data VALUES (43406, 58, 2689, 1, 27, 184, 107);
INSERT INTO public.who_global_data VALUES (43407, 0, 243, 0, 0, 184, 161);
INSERT INTO public.who_global_data VALUES (43408, 0, 17718, 0, 391, 184, 212);
INSERT INTO public.who_global_data VALUES (43409, 761, 117792, 11, 8958, 184, 181);
INSERT INTO public.who_global_data VALUES (43410, 0, 203, 0, 1, 184, 53);
INSERT INTO public.who_global_data VALUES (43411, 0, 4618, 0, 59, 184, 164);
INSERT INTO public.who_global_data VALUES (43412, 1, 939, 0, 75, 184, 140);
INSERT INTO public.who_global_data VALUES (43413, 1761, 364723, 47, 9792, 184, 20);
INSERT INTO public.who_global_data VALUES (43414, 122, 88804, 1, 4684, 184, 112);
INSERT INTO public.who_global_data VALUES (43415, 7129, 334979, 298, 11315, 184, 111);
INSERT INTO public.who_global_data VALUES (43416, 0, 388, 0, 7, 184, 71);
INSERT INTO public.who_global_data VALUES (43417, 0, 3546, 0, 58, 184, 218);
INSERT INTO public.who_global_data VALUES (43418, 0, 0, 0, 0, 184, 43);
INSERT INTO public.who_global_data VALUES (43419, 435, 19837, 10, 181, 184, 49);
INSERT INTO public.who_global_data VALUES (43420, 56, 16349, 0, 103, 184, 1);
INSERT INTO public.who_global_data VALUES (43421, 58, 5376, 0, 154, 184, 48);
INSERT INTO public.who_global_data VALUES (43422, 25, 2726, 0, 88, 184, 232);
INSERT INTO public.who_global_data VALUES (43423, 0, 29, 0, 1, 184, 175);
INSERT INTO public.who_global_data VALUES (43424, 15, 1195, 0, 19, 184, 21);
INSERT INTO public.who_global_data VALUES (43425, 243, 17529, 5, 388, 184, 156);
INSERT INTO public.who_global_data VALUES (43426, 0, 0, 0, 0, 184, 95);
INSERT INTO public.who_global_data VALUES (43427, 75, 9252, 0, 214, 184, 177);
INSERT INTO public.who_global_data VALUES (43428, 112, 14185, 0, 616, 184, 210);
INSERT INTO public.who_global_data VALUES (43429, 82, 5330, 0, 59, 184, 120);
INSERT INTO public.who_global_data VALUES (43430, 0, 18, 0, 0, 184, 135);
INSERT INTO public.who_global_data VALUES (43431, 1365, 75660, 9, 1222, 184, 206);
INSERT INTO public.who_global_data VALUES (43432, 903, 88866, 39, 5847, 184, 189);
INSERT INTO public.who_global_data VALUES (43433, 123, 94875, 18, 4930, 184, 129);
INSERT INTO public.who_global_data VALUES (43434, 439, 18701, 12, 498, 184, 121);
INSERT INTO public.who_global_data VALUES (43435, 0, 4821, 0, 83, 184, 59);
INSERT INTO public.who_global_data VALUES (43436, 0, 282, 0, 0, 184, 96);
INSERT INTO public.who_global_data VALUES (43437, 22, 2113, 0, 63, 184, 41);
INSERT INTO public.who_global_data VALUES (43438, 53, 2909, 4, 53, 184, 216);
INSERT INTO public.who_global_data VALUES (43439, 461, 20336, 13, 356, 184, 236);
INSERT INTO public.who_global_data VALUES (43440, 0, 13, 0, 0, 184, 150);
INSERT INTO public.who_global_data VALUES (43441, 14, 241, 0, 0, 184, 61);
INSERT INTO public.who_global_data VALUES (43442, 0, 27, 0, 1, 184, 7);
INSERT INTO public.who_global_data VALUES (43443, 29, 7512, 0, 331, 184, 169);
INSERT INTO public.who_global_data VALUES (43444, 1615, 181652, 6, 30182, 184, 28);
INSERT INTO public.who_global_data VALUES (43445, 71, 8069, 2, 47, 184, 85);
INSERT INTO public.who_global_data VALUES (43446, 0, 64, 0, 0, 184, 211);
INSERT INTO public.who_global_data VALUES (43447, 141, 7787, 0, 51, 184, 60);
INSERT INTO public.who_global_data VALUES (43448, 136, 935, 0, 16, 184, 3);
INSERT INTO public.who_global_data VALUES (43449, 9, 1206, 0, 17, 184, 11);
INSERT INTO public.who_global_data VALUES (43450, 1045, 213067, 7, 9175, 184, 89);
INSERT INTO public.who_global_data VALUES (43451, 1263, 39075, 8, 199, 184, 24);
INSERT INTO public.who_global_data VALUES (43452, 1, 189, 0, 0, 184, 162);
INSERT INTO public.who_global_data VALUES (43453, 118, 4973, 1, 210, 184, 100);
INSERT INTO public.who_global_data VALUES (43454, 0, 14, 0, 0, 184, 47);
INSERT INTO public.who_global_data VALUES (43455, 0, 24, 0, 0, 184, 29);
INSERT INTO public.who_global_data VALUES (43456, 0, 272, 0, 14, 184, 40);
INSERT INTO public.who_global_data VALUES (43457, 14, 381, 0, 5, 184, 222);
INSERT INTO public.who_global_data VALUES (43458, 1144, 53509, 35, 2072, 184, 132);
INSERT INTO public.who_global_data VALUES (43459, 0, 252, 0, 13, 184, 130);
INSERT INTO public.who_global_data VALUES (43460, 86, 7575, 1, 49, 184, 234);
INSERT INTO public.who_global_data VALUES (43461, 10, 2032, 0, 27, 184, 23);
INSERT INTO public.who_global_data VALUES (43462, 23, 497, 1, 22, 184, 192);
INSERT INTO public.who_global_data VALUES (43463, 21, 7532, 5, 171, 184, 69);
INSERT INTO public.who_global_data VALUES (43464, 0, 12, 0, 0, 184, 187);
INSERT INTO public.who_global_data VALUES (43465, 505, 44299, 16, 1400, 184, 230);
INSERT INTO public.who_global_data VALUES (43466, 11, 4564, 1, 599, 184, 77);
INSERT INTO public.who_global_data VALUES (43467, 8, 1926, 0, 10, 184, 9);
INSERT INTO public.who_global_data VALUES (43468, 56282, 1964536, 904, 40699, 184, 74);
INSERT INTO public.who_global_data VALUES (43469, 1815, 116871, 64, 5452, 184, 224);
INSERT INTO public.who_global_data VALUES (43470, 2697, 317483, 185, 17802, 184, 199);
INSERT INTO public.who_global_data VALUES (43471, 2834, 137556, 77, 5094, 184, 190);
INSERT INTO public.who_global_data VALUES (43472, 50, 26303, 0, 1763, 184, 12);
INSERT INTO public.who_global_data VALUES (43473, 0, 336, 0, 24, 184, 104);
INSERT INTO public.who_global_data VALUES (43474, 1729, 76606, 11, 615, 184, 153);
INSERT INTO public.who_global_data VALUES (43475, 384, 248803, 10, 35181, 184, 91);
INSERT INTO public.who_global_data VALUES (43476, 15, 920, 0, 12, 184, 215);
INSERT INTO public.who_global_data VALUES (43477, 1134, 42263, 4, 1026, 184, 84);
INSERT INTO public.who_global_data VALUES (43478, 4, 343, 0, 31, 184, 231);
INSERT INTO public.who_global_data VALUES (43479, 7, 1299, 0, 11, 184, 196);
INSERT INTO public.who_global_data VALUES (43480, 2404, 107930, 0, 1109, 184, 105);
INSERT INTO public.who_global_data VALUES (43481, 671, 23873, 3, 391, 184, 122);
INSERT INTO public.who_global_data VALUES (43482, 0, 0, 0, 0, 184, 159);
INSERT INTO public.who_global_data VALUES (43483, 218, 9449, 5, 264, 184, 75);
INSERT INTO public.who_global_data VALUES (43484, 651, 69425, 3, 468, 184, 27);
INSERT INTO public.who_global_data VALUES (43485, 549, 38659, 9, 1002, 184, 54);
INSERT INTO public.who_global_data VALUES (43486, 0, 20, 0, 0, 184, 226);
INSERT INTO public.who_global_data VALUES (43487, 8, 1257, 0, 32, 184, 79);
INSERT INTO public.who_global_data VALUES (43488, 146, 5417, 2, 68, 184, 56);
INSERT INTO public.who_global_data VALUES (43489, 0, 726, 0, 21, 184, 117);
INSERT INTO public.who_global_data VALUES (43490, 5, 1221, 0, 78, 184, 152);
INSERT INTO public.who_global_data VALUES (43491, 251, 4475, 3, 99, 184, 16);
INSERT INTO public.who_global_data VALUES (43492, 0, 89, 0, 1, 184, 10);
INSERT INTO public.who_global_data VALUES (43493, 24, 2165, 1, 81, 184, 201);
INSERT INTO public.who_global_data VALUES (43494, 90, 7007, 0, 118, 184, 174);
INSERT INTO public.who_global_data VALUES (43495, 327, 12222, 4, 127, 184, 119);
INSERT INTO public.who_global_data VALUES (43496, 65, 4426, 8, 136, 184, 168);
INSERT INTO public.who_global_data VALUES (43497, 21, 9023, 0, 125, 184, 99);
INSERT INTO public.who_global_data VALUES (43498, 148, 4594, 0, 19, 184, 171);
INSERT INTO public.who_global_data VALUES (43499, 3, 2546, 0, 124, 184, 87);
INSERT INTO public.who_global_data VALUES (43500, 19, 839, 0, 9, 184, 123);
INSERT INTO public.who_global_data VALUES (43501, 0, 0, 0, 0, 184, 151);
INSERT INTO public.who_global_data VALUES (43502, 0, 269, 0, 15, 184, 213);
INSERT INTO public.who_global_data VALUES (43503, 26, 6444, 0, 157, 184, 118);
INSERT INTO public.who_global_data VALUES (43504, 0, 344, 0, 10, 184, 134);
INSERT INTO public.who_global_data VALUES (43505, 8, 3031, 0, 39, 184, 65);
INSERT INTO public.who_global_data VALUES (43506, 6148, 449961, 857, 48869, 184, 102);
INSERT INTO public.who_global_data VALUES (43507, 0, 0, 0, 0, 184, 223);
INSERT INTO public.who_global_data VALUES (43508, 3, 93, 0, 1, 184, 4);
INSERT INTO public.who_global_data VALUES (43509, 0, 293, 0, 0, 184, 146);
INSERT INTO public.who_global_data VALUES (43510, 80, 3518, 3, 60, 184, 31);
INSERT INTO public.who_global_data VALUES (43511, 0, 13, 0, 1, 184, 127);
INSERT INTO public.who_global_data VALUES (43512, 1283, 28500, 18, 435, 184, 22);
INSERT INTO public.who_global_data VALUES (43513, 50, 2079, 0, 15, 184, 115);
INSERT INTO public.who_global_data VALUES (43514, 1, 357, 0, 6, 184, 106);
INSERT INTO public.who_global_data VALUES (43515, 70, 2540, 0, 12, 184, 90);
INSERT INTO public.who_global_data VALUES (43516, 0, 0, 0, 0, 184, 70);
INSERT INTO public.who_global_data VALUES (43517, 381, 21390, 2, 60, 184, 46);
INSERT INTO public.who_global_data VALUES (43518, 428, 56322, 3, 6152, 184, 139);
INSERT INTO public.who_global_data VALUES (43519, 0, 22, 0, 0, 184, 42);
INSERT INTO public.who_global_data VALUES (43520, 0, 1219, 0, 22, 184, 80);
INSERT INTO public.who_global_data VALUES (43521, 0, 3266, 0, 123, 184, 203);
INSERT INTO public.who_global_data VALUES (43522, 0, 1152, 0, 69, 184, 136);
INSERT INTO public.who_global_data VALUES (43523, 457, 44890, 17, 927, 184, 63);
INSERT INTO public.who_global_data VALUES (43524, 0, 0, 0, 0, 184, 17);
INSERT INTO public.who_global_data VALUES (43525, 0, 46, 0, 2, 184, 172);
INSERT INTO public.who_global_data VALUES (43526, 88, 11289, 6, 511, 184, 109);
INSERT INTO public.who_global_data VALUES (43527, 29, 9362, 0, 256, 184, 200);
INSERT INTO public.who_global_data VALUES (43528, 353, 16981, 3, 92, 184, 93);
INSERT INTO public.who_global_data VALUES (43529, 585, 80286, 5, 488, 184, 5);
INSERT INTO public.who_global_data VALUES (43530, 0, 741, 0, 13, 184, 214);
INSERT INTO public.who_global_data VALUES (43531, 727, 281863, 21, 6035, 184, 204);
INSERT INTO public.who_global_data VALUES (43532, 0, 0, 0, 0, 184, 198);
INSERT INTO public.who_global_data VALUES (43533, 968, 69424, 25, 1522, 184, 173);
INSERT INTO public.who_global_data VALUES (43534, 39, 153, 0, 2, 184, 229);
INSERT INTO public.who_global_data VALUES (43535, 128, 5852, 4, 59, 184, 76);
INSERT INTO public.who_global_data VALUES (43536, 6790, 439890, 196, 20007, 184, 138);
INSERT INTO public.who_global_data VALUES (43537, 3387, 115980, 8, 2123, 184, 98);
INSERT INTO public.who_global_data VALUES (43538, 0, 0, 0, 0, 184, 103);
INSERT INTO public.who_global_data VALUES (43539, 640, 48789, 18, 1756, 184, 225);
INSERT INTO public.who_global_data VALUES (43540, 167, 51848, 1, 1740, 184, 131);
INSERT INTO public.who_global_data VALUES (43541, 327, 19651, 9, 246, 184, 235);
INSERT INTO public.who_global_data VALUES (43542, 267, 111805, 1, 178, 184, 137);
INSERT INTO public.who_global_data VALUES (43543, 43, 14499, 0, 302, 184, 81);
INSERT INTO public.who_global_data VALUES (43544, 408, 26222, 13, 823, 184, 182);
INSERT INTO public.who_global_data VALUES (43545, 1, 670, 1, 5, 184, 145);
INSERT INTO public.who_global_data VALUES (43546, 1309, 56550, 41, 2521, 184, 26);
INSERT INTO public.who_global_data VALUES (43547, 5267, 871894, 116, 14606, 184, 170);
INSERT INTO public.who_global_data VALUES (43548, 5, 2104, 0, 5, 184, 191);
INSERT INTO public.who_global_data VALUES (43549, 0, 5, 0, 0, 184, 221);
INSERT INTO public.who_global_data VALUES (43550, 0, 9, 0, 0, 184, 64);
INSERT INTO public.who_global_data VALUES (43551, 0, 0, 0, 0, 184, 116);
INSERT INTO public.who_global_data VALUES (43552, 0, 17, 0, 0, 184, 128);
INSERT INTO public.who_global_data VALUES (43553, 0, 25, 0, 0, 184, 6);
INSERT INTO public.who_global_data VALUES (43554, 0, 53, 0, 3, 184, 227);
INSERT INTO public.who_global_data VALUES (43555, 0, 4, 0, 0, 184, 68);
INSERT INTO public.who_global_data VALUES (43556, 0, 55, 0, 0, 184, 184);
INSERT INTO public.who_global_data VALUES (43557, 0, 0, 0, 0, 184, 82);
INSERT INTO public.who_global_data VALUES (43558, 0, 716, 0, 42, 184, 149);
INSERT INTO public.who_global_data VALUES (43559, 3, 878, 0, 15, 184, 197);
INSERT INTO public.who_global_data VALUES (43560, 1389, 282824, 36, 3020, 184, 78);
INSERT INTO public.who_global_data VALUES (43561, 106, 10538, 4, 218, 184, 233);
INSERT INTO public.who_global_data VALUES (43562, 295, 27033, 9, 614, 184, 133);
INSERT INTO public.who_global_data VALUES (43563, 0, 114, 0, 0, 184, 35);
INSERT INTO public.who_global_data VALUES (43564, 5, 1860, 0, 67, 184, 114);
INSERT INTO public.who_global_data VALUES (43565, 908, 54254, 0, 27, 184, 237);
INSERT INTO public.who_global_data VALUES (43566, 0, 3, 0, 0, 184, 55);
INSERT INTO public.who_global_data VALUES (43567, 6, 156, 0, 16, 184, 176);
INSERT INTO public.who_global_data VALUES (43568, 49, 2417, 0, 29, 184, 202);
INSERT INTO public.who_global_data VALUES (43569, 15, 2224, 0, 126, 184, 155);
INSERT INTO public.who_global_data VALUES (43570, 0, 0, 0, 0, 184, 32);
INSERT INTO public.who_global_data VALUES (43571, 7, 3227, 0, 93, 184, 220);
INSERT INTO public.who_global_data VALUES (43572, 8559, 529877, 414, 9298, 184, 30);
INSERT INTO public.who_global_data VALUES (43573, 13, 2450, 0, 47, 184, 147);
INSERT INTO public.who_global_data VALUES (43574, 4557, 320483, 15, 29960, 184, 208);
INSERT INTO public.who_global_data VALUES (43575, 5, 2839, 0, 11, 184, 45);
INSERT INTO public.who_global_data VALUES (43576, 70, 11850, 6, 769, 184, 110);
INSERT INTO public.who_global_data VALUES (43577, 88, 1981, 0, 27, 184, 88);
INSERT INTO public.who_global_data VALUES (43578, 333, 77780, 2, 5771, 184, 51);
INSERT INTO public.who_global_data VALUES (43579, 152, 36153, 1, 1742, 184, 209);
INSERT INTO public.who_global_data VALUES (43580, 52, 944, 2, 48, 184, 205);
INSERT INTO public.who_global_data VALUES (43581, 42, 7625, 0, 61, 184, 18);
INSERT INTO public.who_global_data VALUES (43582, 2, 3330, 0, 58, 184, 72);
INSERT INTO public.who_global_data VALUES (43583, 891, 307188, 14, 41240, 184, 44);
INSERT INTO public.who_global_data VALUES (43584, 0, 25, 0, 0, 184, 15);
INSERT INTO public.who_global_data VALUES (43585, 12, 988, 0, 19, 184, 25);
INSERT INTO public.who_global_data VALUES (43586, 0, 0, 0, 0, 184, 179);
INSERT INTO public.who_global_data VALUES (43587, 0, 0, 0, 0, 184, 34);
INSERT INTO public.who_global_data VALUES (43588, 5, 197, 0, 8, 184, 207);
INSERT INTO public.who_global_data VALUES (43589, 41, 1642, 0, 51, 184, 166);
INSERT INTO public.who_global_data VALUES (43590, 7908, 296682, 19, 5784, 184, 126);
INSERT INTO public.who_global_data VALUES (43591, 0, 0, 0, 0, 184, 97);
INSERT INTO public.who_global_data VALUES (43592, 0, 116, 0, 2, 184, 36);
INSERT INTO public.who_global_data VALUES (43593, 0, 0, 0, 0, 184, 125);
INSERT INTO public.who_global_data VALUES (43594, 10, 1213, 0, 5, 184, 124);
INSERT INTO public.who_global_data VALUES (43595, 1318, 76808, 31, 1819, 184, 185);
INSERT INTO public.who_global_data VALUES (43596, 254, 61606, 2, 353, 184, 194);
INSERT INTO public.who_global_data VALUES (43597, 0, 509, 0, 21, 184, 144);
INSERT INTO public.who_global_data VALUES (43598, 49629, 4728239, 1098, 156050, 184, 19);
INSERT INTO public.who_global_data VALUES (43599, 18, 481, 0, 8, 184, 217);
INSERT INTO public.who_global_data VALUES (43600, 9, 1300, 1, 37, 184, 148);
INSERT INTO public.who_global_data VALUES (43601, 755, 28069, 6, 173, 184, 86);
INSERT INTO public.who_global_data VALUES (43602, 0, 0, 0, 0, 184, 13);
INSERT INTO public.who_global_data VALUES (43603, 684, 21438, 7, 187, 184, 157);
INSERT INTO public.who_global_data VALUES (43604, 45, 717, 0, 8, 184, 8);
INSERT INTO public.who_global_data VALUES (43605, 0, 0, 0, 0, 184, 73);
INSERT INTO public.who_global_data VALUES (43606, 3, 1767, 2, 509, 184, 101);
INSERT INTO public.who_global_data VALUES (43607, 442, 7022, 5, 176, 184, 165);
INSERT INTO public.who_global_data VALUES (43608, 118, 4339, 3, 84, 184, 14);
INSERT INTO public.who_global_data VALUES (43609, 82, 36915, 6, 1298, 185, 193);
INSERT INTO public.who_global_data VALUES (43610, 130, 5750, 4, 176, 185, 113);
INSERT INTO public.who_global_data VALUES (43611, 532, 32504, 19, 1248, 185, 143);
INSERT INTO public.who_global_data VALUES (43612, 0, 0, 0, 0, 185, 219);
INSERT INTO public.who_global_data VALUES (43613, 2, 939, 0, 52, 185, 186);
INSERT INTO public.who_global_data VALUES (43614, 64, 1344, 1, 59, 185, 52);
INSERT INTO public.who_global_data VALUES (43615, 0, 3, 0, 0, 185, 180);
INSERT INTO public.who_global_data VALUES (43616, 1, 92, 0, 3, 185, 167);
INSERT INTO public.who_global_data VALUES (43617, 4824, 206743, 196, 3863, 185, 154);
INSERT INTO public.who_global_data VALUES (43618, 288, 38899, 2, 765, 185, 94);
INSERT INTO public.who_global_data VALUES (43619, 2, 124, 0, 3, 185, 66);
INSERT INTO public.who_global_data VALUES (43620, 411, 18729, 11, 232, 185, 58);
INSERT INTO public.who_global_data VALUES (43621, 131, 21472, 1, 719, 185, 163);
INSERT INTO public.who_global_data VALUES (43622, 226, 32910, 5, 473, 185, 37);
INSERT INTO public.who_global_data VALUES (43623, 31, 679, 0, 14, 185, 142);
INSERT INTO public.who_global_data VALUES (43624, 297, 42132, 2, 152, 185, 83);
INSERT INTO public.who_global_data VALUES (43625, 1918, 244020, 50, 3234, 185, 228);
INSERT INTO public.who_global_data VALUES (43626, 0, 132, 0, 7, 185, 188);
INSERT INTO public.who_global_data VALUES (43627, 84, 68250, 3, 574, 185, 62);
INSERT INTO public.who_global_data VALUES (43628, 813, 72438, 5, 9717, 185, 160);
INSERT INTO public.who_global_data VALUES (43629, 0, 57, 0, 2, 185, 50);
INSERT INTO public.who_global_data VALUES (43630, 22, 1936, 0, 38, 185, 33);
INSERT INTO public.who_global_data VALUES (43631, 0, 157, 0, 9, 185, 183);
INSERT INTO public.who_global_data VALUES (43632, 2, 105, 0, 0, 185, 92);
INSERT INTO public.who_global_data VALUES (43633, 1693, 81846, 75, 3228, 185, 158);
INSERT INTO public.who_global_data VALUES (43634, 0, 5, 0, 0, 185, 67);
INSERT INTO public.who_global_data VALUES (43635, 381, 12858, 10, 368, 185, 57);
INSERT INTO public.who_global_data VALUES (43636, 0, 804, 0, 2, 185, 38);
INSERT INTO public.who_global_data VALUES (43637, 16641, 2750318, 561, 94665, 185, 141);
INSERT INTO public.who_global_data VALUES (43638, 1, 9, 0, 1, 185, 178);
INSERT INTO public.who_global_data VALUES (43639, 0, 141, 0, 3, 185, 108);
INSERT INTO public.who_global_data VALUES (43640, 204, 12159, 16, 404, 185, 39);
INSERT INTO public.who_global_data VALUES (43641, 3, 1153, 1, 54, 185, 2);
INSERT INTO public.who_global_data VALUES (43642, 0, 395, 0, 1, 185, 195);
INSERT INTO public.who_global_data VALUES (43643, 48, 2631, 1, 26, 185, 107);
INSERT INTO public.who_global_data VALUES (43644, 2, 243, 0, 0, 185, 161);
INSERT INTO public.who_global_data VALUES (43645, 0, 17718, 0, 391, 185, 212);
INSERT INTO public.who_global_data VALUES (43646, 147, 117031, 2, 8947, 185, 181);
INSERT INTO public.who_global_data VALUES (43647, 0, 203, 0, 1, 185, 53);
INSERT INTO public.who_global_data VALUES (43648, 4, 4618, 0, 59, 185, 164);
INSERT INTO public.who_global_data VALUES (43649, 2, 938, 0, 75, 185, 140);
INSERT INTO public.who_global_data VALUES (43650, 1469, 362962, 38, 9745, 185, 20);
INSERT INTO public.who_global_data VALUES (43651, 109, 88682, 4, 4683, 185, 112);
INSERT INTO public.who_global_data VALUES (43652, 10199, 327850, 367, 11017, 185, 111);
INSERT INTO public.who_global_data VALUES (43653, 2, 388, 0, 7, 185, 71);
INSERT INTO public.who_global_data VALUES (43654, 159, 3546, 1, 58, 185, 218);
INSERT INTO public.who_global_data VALUES (43655, 0, 0, 0, 0, 185, 43);
INSERT INTO public.who_global_data VALUES (43656, 427, 19402, 9, 171, 185, 49);
INSERT INTO public.who_global_data VALUES (43657, 73, 16293, 1, 103, 185, 1);
INSERT INTO public.who_global_data VALUES (43658, 22, 5318, 1, 154, 185, 48);
INSERT INTO public.who_global_data VALUES (43659, 31, 2701, 1, 88, 185, 232);
INSERT INTO public.who_global_data VALUES (43660, 0, 29, 0, 1, 185, 175);
INSERT INTO public.who_global_data VALUES (43661, 25, 1180, 0, 19, 185, 21);
INSERT INTO public.who_global_data VALUES (43662, 278, 17286, 0, 383, 185, 156);
INSERT INTO public.who_global_data VALUES (43663, 0, 0, 0, 0, 185, 95);
INSERT INTO public.who_global_data VALUES (43664, 45, 9177, 0, 214, 185, 177);
INSERT INTO public.who_global_data VALUES (43665, 77, 14073, 0, 616, 185, 210);
INSERT INTO public.who_global_data VALUES (43666, 8, 5248, 0, 59, 185, 120);
INSERT INTO public.who_global_data VALUES (43667, 0, 18, 0, 0, 185, 135);
INSERT INTO public.who_global_data VALUES (43668, 1178, 74295, 30, 1213, 185, 206);
INSERT INTO public.who_global_data VALUES (43669, 922, 87963, 41, 5808, 185, 189);
INSERT INTO public.who_global_data VALUES (43670, 112, 94752, 24, 4912, 185, 129);
INSERT INTO public.who_global_data VALUES (43671, 419, 18262, 9, 486, 185, 121);
INSERT INTO public.who_global_data VALUES (43672, 0, 4821, 0, 83, 185, 59);
INSERT INTO public.who_global_data VALUES (43673, 0, 282, 0, 0, 185, 96);
INSERT INTO public.who_global_data VALUES (43674, 11, 2091, 0, 63, 185, 41);
INSERT INTO public.who_global_data VALUES (43675, 18, 2856, 7, 49, 185, 216);
INSERT INTO public.who_global_data VALUES (43676, 586, 19875, 7, 343, 185, 236);
INSERT INTO public.who_global_data VALUES (43677, 0, 13, 0, 0, 185, 150);
INSERT INTO public.who_global_data VALUES (43678, 2, 227, 0, 0, 185, 61);
INSERT INTO public.who_global_data VALUES (43679, 0, 27, 0, 1, 185, 7);
INSERT INTO public.who_global_data VALUES (43680, 17, 7483, 2, 331, 185, 169);
INSERT INTO public.who_global_data VALUES (43681, 965, 180037, 1, 30176, 185, 28);
INSERT INTO public.who_global_data VALUES (43682, 50, 7998, 1, 45, 185, 85);
INSERT INTO public.who_global_data VALUES (43683, 2, 64, 0, 0, 185, 211);
INSERT INTO public.who_global_data VALUES (43684, 0, 7646, 0, 51, 185, 60);
INSERT INTO public.who_global_data VALUES (43685, 301, 799, 7, 16, 185, 3);
INSERT INTO public.who_global_data VALUES (43686, 15, 1197, 0, 17, 185, 11);
INSERT INTO public.who_global_data VALUES (43687, 741, 212022, 12, 9168, 185, 89);
INSERT INTO public.who_global_data VALUES (43688, 798, 37812, 9, 191, 185, 24);
INSERT INTO public.who_global_data VALUES (43689, 0, 188, 0, 0, 185, 162);
INSERT INTO public.who_global_data VALUES (43690, 118, 4855, 0, 209, 185, 100);
INSERT INTO public.who_global_data VALUES (43691, 0, 14, 0, 0, 185, 47);
INSERT INTO public.who_global_data VALUES (43692, 0, 24, 0, 0, 185, 29);
INSERT INTO public.who_global_data VALUES (43693, 7, 272, 0, 14, 185, 40);
INSERT INTO public.who_global_data VALUES (43694, 0, 367, 0, 5, 185, 222);
INSERT INTO public.who_global_data VALUES (43695, 823, 52365, 24, 2037, 185, 132);
INSERT INTO public.who_global_data VALUES (43696, 0, 252, 0, 13, 185, 130);
INSERT INTO public.who_global_data VALUES (43697, 71, 7489, 2, 48, 185, 234);
INSERT INTO public.who_global_data VALUES (43698, 41, 2022, 0, 27, 185, 23);
INSERT INTO public.who_global_data VALUES (43699, 0, 474, 0, 21, 185, 192);
INSERT INTO public.who_global_data VALUES (43700, 35, 7511, 1, 166, 185, 69);
INSERT INTO public.who_global_data VALUES (43701, 0, 12, 0, 0, 185, 187);
INSERT INTO public.who_global_data VALUES (43702, 597, 43794, 7, 1384, 185, 230);
INSERT INTO public.who_global_data VALUES (43703, 9, 4553, 1, 598, 185, 77);
INSERT INTO public.who_global_data VALUES (43704, 3, 1918, 0, 10, 185, 9);
INSERT INTO public.who_global_data VALUES (43705, 52509, 1908254, 857, 39795, 185, 74);
INSERT INTO public.who_global_data VALUES (43706, 1922, 115056, 86, 5388, 185, 224);
INSERT INTO public.who_global_data VALUES (43707, 2751, 314786, 212, 17617, 185, 199);
INSERT INTO public.who_global_data VALUES (43708, 2836, 134722, 83, 5017, 185, 190);
INSERT INTO public.who_global_data VALUES (43709, 45, 26253, 0, 1763, 185, 12);
INSERT INTO public.who_global_data VALUES (43710, 0, 336, 0, 24, 185, 104);
INSERT INTO public.who_global_data VALUES (43711, 1800, 74877, 15, 604, 185, 153);
INSERT INTO public.who_global_data VALUES (43712, 190, 248419, 5, 35171, 185, 91);
INSERT INTO public.who_global_data VALUES (43713, 11, 905, 0, 12, 185, 215);
INSERT INTO public.who_global_data VALUES (43714, 1271, 41129, 6, 1022, 185, 84);
INSERT INTO public.who_global_data VALUES (43715, 4, 339, 0, 31, 185, 231);
INSERT INTO public.who_global_data VALUES (43716, 6, 1292, 0, 11, 185, 196);
INSERT INTO public.who_global_data VALUES (43717, 2590, 105526, 0, 1109, 185, 105);
INSERT INTO public.who_global_data VALUES (43718, 605, 23202, 6, 388, 185, 122);
INSERT INTO public.who_global_data VALUES (43719, 0, 0, 0, 0, 185, 159);
INSERT INTO public.who_global_data VALUES (43720, 225, 9231, 13, 259, 185, 75);
INSERT INTO public.who_global_data VALUES (43721, 475, 68774, 4, 465, 185, 27);
INSERT INTO public.who_global_data VALUES (43722, 569, 38110, 11, 993, 185, 54);
INSERT INTO public.who_global_data VALUES (43723, 0, 20, 0, 0, 185, 226);
INSERT INTO public.who_global_data VALUES (43724, 3, 1249, 0, 32, 185, 79);
INSERT INTO public.who_global_data VALUES (43725, 209, 5271, 1, 66, 185, 56);
INSERT INTO public.who_global_data VALUES (43726, 8, 726, 2, 21, 185, 117);
INSERT INTO public.who_global_data VALUES (43727, 2, 1216, 0, 78, 185, 152);
INSERT INTO public.who_global_data VALUES (43728, 161, 4224, 3, 96, 185, 16);
INSERT INTO public.who_global_data VALUES (43729, 0, 89, 0, 1, 185, 10);
INSERT INTO public.who_global_data VALUES (43730, 10, 2141, 0, 80, 185, 201);
INSERT INTO public.who_global_data VALUES (43731, 53, 6917, 0, 118, 185, 174);
INSERT INTO public.who_global_data VALUES (43732, 235, 11895, 5, 123, 185, 119);
INSERT INTO public.who_global_data VALUES (43733, 88, 4361, 5, 128, 185, 168);
INSERT INTO public.who_global_data VALUES (43734, 1, 9002, 0, 125, 185, 99);
INSERT INTO public.who_global_data VALUES (43735, 153, 4446, 1, 19, 185, 171);
INSERT INTO public.who_global_data VALUES (43736, 0, 2543, 0, 124, 185, 87);
INSERT INTO public.who_global_data VALUES (43737, 21, 820, 0, 9, 185, 123);
INSERT INTO public.who_global_data VALUES (43738, 0, 0, 0, 0, 185, 151);
INSERT INTO public.who_global_data VALUES (43739, 0, 269, 0, 15, 185, 213);
INSERT INTO public.who_global_data VALUES (43740, 36, 6418, 0, 157, 185, 118);
INSERT INTO public.who_global_data VALUES (43741, 0, 344, 0, 10, 185, 134);
INSERT INTO public.who_global_data VALUES (43742, 15, 3023, 0, 39, 185, 65);
INSERT INTO public.who_global_data VALUES (43743, 4767, 443813, 266, 48012, 185, 102);
INSERT INTO public.who_global_data VALUES (43744, 0, 0, 0, 0, 185, 223);
INSERT INTO public.who_global_data VALUES (43745, 2, 90, 0, 1, 185, 4);
INSERT INTO public.who_global_data VALUES (43746, 0, 293, 0, 0, 185, 146);
INSERT INTO public.who_global_data VALUES (43747, 54, 3438, 3, 57, 185, 31);
INSERT INTO public.who_global_data VALUES (43748, 0, 13, 0, 1, 185, 127);
INSERT INTO public.who_global_data VALUES (43749, 1021, 27217, 16, 417, 185, 22);
INSERT INTO public.who_global_data VALUES (43750, 56, 2029, 1, 15, 185, 115);
INSERT INTO public.who_global_data VALUES (43751, 1, 356, 0, 6, 185, 106);
INSERT INTO public.who_global_data VALUES (43752, 64, 2470, 0, 12, 185, 90);
INSERT INTO public.who_global_data VALUES (43753, 0, 0, 0, 0, 185, 70);
INSERT INTO public.who_global_data VALUES (43754, 259, 21009, 1, 58, 185, 46);
INSERT INTO public.who_global_data VALUES (43755, 487, 55894, 2, 6149, 185, 139);
INSERT INTO public.who_global_data VALUES (43756, 0, 22, 0, 0, 185, 42);
INSERT INTO public.who_global_data VALUES (43757, 2, 1219, 0, 22, 185, 80);
INSERT INTO public.who_global_data VALUES (43758, 186, 3266, 7, 123, 185, 203);
INSERT INTO public.who_global_data VALUES (43759, 5, 1152, 0, 69, 185, 136);
INSERT INTO public.who_global_data VALUES (43760, 304, 44433, 14, 910, 185, 63);
INSERT INTO public.who_global_data VALUES (43761, 0, 0, 0, 0, 185, 17);
INSERT INTO public.who_global_data VALUES (43762, 0, 46, 0, 2, 185, 172);
INSERT INTO public.who_global_data VALUES (43763, 61, 11201, 5, 505, 185, 109);
INSERT INTO public.who_global_data VALUES (43764, 65, 9333, 0, 256, 185, 200);
INSERT INTO public.who_global_data VALUES (43765, 604, 16628, 2, 89, 185, 93);
INSERT INTO public.who_global_data VALUES (43766, 0, 79701, 0, 483, 185, 5);
INSERT INTO public.who_global_data VALUES (43767, 0, 741, 0, 13, 185, 214);
INSERT INTO public.who_global_data VALUES (43768, 675, 281136, 15, 6014, 185, 204);
INSERT INTO public.who_global_data VALUES (43769, 0, 0, 0, 0, 185, 198);
INSERT INTO public.who_global_data VALUES (43770, 1003, 68456, 26, 1497, 185, 173);
INSERT INTO public.who_global_data VALUES (43771, 3, 114, 0, 2, 185, 229);
INSERT INTO public.who_global_data VALUES (43772, 80, 5724, 3, 55, 185, 76);
INSERT INTO public.who_global_data VALUES (43773, 4250, 433100, 197, 19811, 185, 138);
INSERT INTO public.who_global_data VALUES (43774, 6263, 112593, 11, 2115, 185, 98);
INSERT INTO public.who_global_data VALUES (43775, 0, 0, 0, 0, 185, 103);
INSERT INTO public.who_global_data VALUES (43776, 680, 48149, 6, 1738, 185, 225);
INSERT INTO public.who_global_data VALUES (43777, 112, 51681, 1, 1739, 185, 131);
INSERT INTO public.who_global_data VALUES (43778, 533, 19324, 7, 237, 185, 235);
INSERT INTO public.who_global_data VALUES (43779, 216, 111538, 0, 177, 185, 137);
INSERT INTO public.who_global_data VALUES (43780, 33, 14456, 1, 302, 185, 81);
INSERT INTO public.who_global_data VALUES (43781, 332, 25814, 10, 810, 185, 182);
INSERT INTO public.who_global_data VALUES (43782, 2, 669, 0, 4, 185, 145);
INSERT INTO public.who_global_data VALUES (43783, 1232, 55241, 48, 2480, 185, 26);
INSERT INTO public.who_global_data VALUES (43784, 5204, 866627, 139, 14490, 185, 170);
INSERT INTO public.who_global_data VALUES (43785, 7, 2099, 0, 5, 185, 191);
INSERT INTO public.who_global_data VALUES (43786, 0, 5, 0, 0, 185, 221);
INSERT INTO public.who_global_data VALUES (43787, 0, 9, 0, 0, 185, 64);
INSERT INTO public.who_global_data VALUES (43788, 0, 0, 0, 0, 185, 116);
INSERT INTO public.who_global_data VALUES (43789, 0, 17, 0, 0, 185, 128);
INSERT INTO public.who_global_data VALUES (43790, 0, 25, 0, 0, 185, 6);
INSERT INTO public.who_global_data VALUES (43791, 0, 53, 0, 3, 185, 227);
INSERT INTO public.who_global_data VALUES (43792, 0, 4, 0, 0, 185, 68);
INSERT INTO public.who_global_data VALUES (43793, 0, 55, 0, 0, 185, 184);
INSERT INTO public.who_global_data VALUES (43794, 0, 0, 0, 0, 185, 82);
INSERT INTO public.who_global_data VALUES (43795, 0, 716, 0, 42, 185, 149);
INSERT INTO public.who_global_data VALUES (43796, 1, 875, 0, 15, 185, 197);
INSERT INTO public.who_global_data VALUES (43797, 1342, 281435, 35, 2984, 185, 78);
INSERT INTO public.who_global_data VALUES (43798, 46, 10432, 3, 214, 185, 233);
INSERT INTO public.who_global_data VALUES (43799, 287, 26738, 7, 605, 185, 133);
INSERT INTO public.who_global_data VALUES (43800, 0, 114, 0, 0, 185, 35);
INSERT INTO public.who_global_data VALUES (43801, 7, 1855, 0, 67, 185, 114);
INSERT INTO public.who_global_data VALUES (43802, 295, 53346, 0, 27, 185, 237);
INSERT INTO public.who_global_data VALUES (43803, 0, 3, 0, 0, 185, 55);
INSERT INTO public.who_global_data VALUES (43804, 4, 150, 0, 16, 185, 176);
INSERT INTO public.who_global_data VALUES (43805, 14, 2368, 0, 29, 185, 202);
INSERT INTO public.who_global_data VALUES (43806, 18, 2209, 1, 126, 185, 155);
INSERT INTO public.who_global_data VALUES (43807, 0, 0, 0, 0, 185, 32);
INSERT INTO public.who_global_data VALUES (43808, 0, 3220, 0, 93, 185, 220);
INSERT INTO public.who_global_data VALUES (43809, 4456, 521318, 518, 8884, 185, 30);
INSERT INTO public.who_global_data VALUES (43810, 0, 2437, 0, 47, 185, 147);
INSERT INTO public.who_global_data VALUES (43811, 2793, 315926, 12, 29945, 185, 208);
INSERT INTO public.who_global_data VALUES (43812, 6, 2834, 0, 11, 185, 45);
INSERT INTO public.who_global_data VALUES (43813, 0, 11780, 0, 763, 185, 110);
INSERT INTO public.who_global_data VALUES (43814, 44, 1893, 0, 27, 185, 88);
INSERT INTO public.who_global_data VALUES (43815, 165, 77447, 4, 5769, 185, 51);
INSERT INTO public.who_global_data VALUES (43816, 181, 36001, 1, 1741, 185, 209);
INSERT INTO public.who_global_data VALUES (43817, 45, 892, 0, 46, 185, 205);
INSERT INTO public.who_global_data VALUES (43818, 45, 7583, 0, 61, 185, 18);
INSERT INTO public.who_global_data VALUES (43819, 7, 3328, 0, 58, 185, 72);
INSERT INTO public.who_global_data VALUES (43820, 670, 306297, 18, 41226, 185, 44);
INSERT INTO public.who_global_data VALUES (43821, 0, 25, 0, 0, 185, 15);
INSERT INTO public.who_global_data VALUES (43822, 15, 976, 0, 19, 185, 25);
INSERT INTO public.who_global_data VALUES (43823, 0, 0, 0, 0, 185, 179);
INSERT INTO public.who_global_data VALUES (43824, 0, 0, 0, 0, 185, 34);
INSERT INTO public.who_global_data VALUES (43825, 10, 192, 0, 8, 185, 207);
INSERT INTO public.who_global_data VALUES (43826, 17, 1601, 0, 51, 185, 166);
INSERT INTO public.who_global_data VALUES (43827, 7813, 288774, 18, 5765, 185, 126);
INSERT INTO public.who_global_data VALUES (43828, 0, 0, 0, 0, 185, 97);
INSERT INTO public.who_global_data VALUES (43829, 2, 116, 0, 2, 185, 36);
INSERT INTO public.who_global_data VALUES (43830, 0, 0, 0, 0, 185, 125);
INSERT INTO public.who_global_data VALUES (43831, 8, 1203, 0, 5, 185, 124);
INSERT INTO public.who_global_data VALUES (43832, 1271, 75490, 24, 1788, 185, 185);
INSERT INTO public.who_global_data VALUES (43833, 189, 61352, 0, 351, 185, 194);
INSERT INTO public.who_global_data VALUES (43834, 0, 509, 0, 21, 185, 144);
INSERT INTO public.who_global_data VALUES (43835, 49151, 4678610, 726, 154952, 185, 19);
INSERT INTO public.who_global_data VALUES (43836, 24, 463, 0, 8, 185, 217);
INSERT INTO public.who_global_data VALUES (43837, 5, 1291, 0, 36, 185, 148);
INSERT INTO public.who_global_data VALUES (43838, 764, 27314, 6, 167, 185, 86);
INSERT INTO public.who_global_data VALUES (43839, 0, 0, 0, 0, 185, 13);
INSERT INTO public.who_global_data VALUES (43840, 548, 20754, 6, 180, 185, 157);
INSERT INTO public.who_global_data VALUES (43841, 20, 672, 2, 8, 185, 8);
INSERT INTO public.who_global_data VALUES (43842, 0, 0, 0, 0, 185, 73);
INSERT INTO public.who_global_data VALUES (43843, 26, 1764, 7, 507, 185, 101);
INSERT INTO public.who_global_data VALUES (43844, 0, 6580, 0, 171, 185, 165);
INSERT INTO public.who_global_data VALUES (43845, 146, 4221, 1, 81, 185, 14);
INSERT INTO public.who_global_data VALUES (43846, 37, 36833, 5, 1292, 186, 193);
INSERT INTO public.who_global_data VALUES (43847, 101, 5620, 6, 172, 186, 113);
INSERT INTO public.who_global_data VALUES (43848, 507, 31972, -2, 1229, 186, 143);
INSERT INTO public.who_global_data VALUES (43849, 0, 0, 0, 0, 186, 219);
INSERT INTO public.who_global_data VALUES (43850, 1, 937, 0, 52, 186, 186);
INSERT INTO public.who_global_data VALUES (43851, 116, 1280, 4, 58, 186, 52);
INSERT INTO public.who_global_data VALUES (43852, 0, 3, 0, 0, 186, 180);
INSERT INTO public.who_global_data VALUES (43853, 0, 91, 0, 3, 186, 167);
INSERT INTO public.who_global_data VALUES (43854, 5376, 201919, 55, 3667, 186, 154);
INSERT INTO public.who_global_data VALUES (43855, 196, 38611, 6, 763, 186, 94);
INSERT INTO public.who_global_data VALUES (43856, 2, 122, 0, 3, 186, 66);
INSERT INTO public.who_global_data VALUES (43857, 395, 18318, 13, 221, 186, 58);
INSERT INTO public.who_global_data VALUES (43858, 32, 21341, 0, 718, 186, 163);
INSERT INTO public.who_global_data VALUES (43859, 241, 32684, 6, 468, 186, 37);
INSERT INTO public.who_global_data VALUES (43860, 74, 648, 0, 14, 186, 142);
INSERT INTO public.who_global_data VALUES (43861, 299, 41835, 3, 150, 186, 83);
INSERT INTO public.who_global_data VALUES (43862, 1356, 242102, 30, 3184, 186, 228);
INSERT INTO public.who_global_data VALUES (43863, 10, 132, 0, 7, 186, 188);
INSERT INTO public.who_global_data VALUES (43864, 99, 68166, 4, 571, 186, 62);
INSERT INTO public.who_global_data VALUES (43865, 794, 71625, 3, 9712, 186, 160);
INSERT INTO public.who_global_data VALUES (43866, 1, 57, 0, 2, 186, 50);
INSERT INTO public.who_global_data VALUES (43867, 109, 1914, 2, 38, 186, 33);
INSERT INTO public.who_global_data VALUES (43868, 1, 157, 0, 9, 186, 183);
INSERT INTO public.who_global_data VALUES (43869, 0, 103, 0, 0, 186, 92);
INSERT INTO public.who_global_data VALUES (43870, 1360, 80153, 89, 3153, 186, 158);
INSERT INTO public.who_global_data VALUES (43871, 0, 5, 0, 0, 186, 67);
INSERT INTO public.who_global_data VALUES (43872, 181, 12477, 11, 358, 186, 57);
INSERT INTO public.who_global_data VALUES (43873, 0, 804, 0, 2, 186, 38);
INSERT INTO public.who_global_data VALUES (43874, 25800, 2733677, 541, 94104, 186, 141);
INSERT INTO public.who_global_data VALUES (43875, 0, 8, 0, 1, 186, 178);
INSERT INTO public.who_global_data VALUES (43876, 0, 141, 0, 3, 186, 108);
INSERT INTO public.who_global_data VALUES (43877, 0, 11955, 0, 388, 186, 39);
INSERT INTO public.who_global_data VALUES (43878, 1, 1150, 0, 53, 186, 2);
INSERT INTO public.who_global_data VALUES (43879, 0, 395, 0, 1, 186, 195);
INSERT INTO public.who_global_data VALUES (43880, 36, 2583, 1, 25, 186, 107);
INSERT INTO public.who_global_data VALUES (43881, 1, 241, 0, 0, 186, 161);
INSERT INTO public.who_global_data VALUES (43882, 463, 17718, 0, 391, 186, 212);
INSERT INTO public.who_global_data VALUES (43883, 285, 116884, 4, 8945, 186, 181);
INSERT INTO public.who_global_data VALUES (43884, 0, 203, 0, 1, 186, 53);
INSERT INTO public.who_global_data VALUES (43885, 0, 4614, 0, 59, 186, 164);
INSERT INTO public.who_global_data VALUES (43886, 0, 936, 0, 75, 186, 140);
INSERT INTO public.who_global_data VALUES (43887, 1762, 361493, 99, 9707, 186, 20);
INSERT INTO public.who_global_data VALUES (43888, 114, 88573, 3, 4679, 186, 112);
INSERT INTO public.who_global_data VALUES (43889, 11470, 317651, 320, 10650, 186, 111);
INSERT INTO public.who_global_data VALUES (43890, 0, 386, 0, 7, 186, 71);
INSERT INTO public.who_global_data VALUES (43891, 0, 3387, 1, 57, 186, 218);
INSERT INTO public.who_global_data VALUES (43892, 0, 0, 0, 0, 186, 43);
INSERT INTO public.who_global_data VALUES (43893, 788, 18975, 8, 162, 186, 49);
INSERT INTO public.who_global_data VALUES (43894, 38, 16220, 0, 102, 186, 1);
INSERT INTO public.who_global_data VALUES (43895, 36, 5296, 4, 153, 186, 48);
INSERT INTO public.who_global_data VALUES (43896, 24, 2670, 0, 87, 186, 232);
INSERT INTO public.who_global_data VALUES (43897, 0, 29, 0, 1, 186, 175);
INSERT INTO public.who_global_data VALUES (43898, 5, 1155, 0, 19, 186, 21);
INSERT INTO public.who_global_data VALUES (43899, 208, 17008, 0, 383, 186, 156);
INSERT INTO public.who_global_data VALUES (43900, 0, 0, 0, 0, 186, 95);
INSERT INTO public.who_global_data VALUES (43901, 18, 9132, 0, 214, 186, 177);
INSERT INTO public.who_global_data VALUES (43902, 207, 13996, 1, 616, 186, 210);
INSERT INTO public.who_global_data VALUES (43903, 79, 5240, 0, 59, 186, 120);
INSERT INTO public.who_global_data VALUES (43904, 0, 18, 0, 0, 186, 135);
INSERT INTO public.who_global_data VALUES (43905, 874, 73117, 5, 1183, 186, 206);
INSERT INTO public.who_global_data VALUES (43906, 809, 87041, 31, 5767, 186, 189);
INSERT INTO public.who_global_data VALUES (43907, 157, 94640, 23, 4888, 186, 129);
INSERT INTO public.who_global_data VALUES (43908, 395, 17843, 10, 477, 186, 121);
INSERT INTO public.who_global_data VALUES (43909, 0, 4821, 0, 83, 186, 59);
INSERT INTO public.who_global_data VALUES (43910, 3, 282, 0, 0, 186, 96);
INSERT INTO public.who_global_data VALUES (43911, 1, 2080, 0, 63, 186, 41);
INSERT INTO public.who_global_data VALUES (43912, 63, 2838, 0, 42, 186, 216);
INSERT INTO public.who_global_data VALUES (43913, 583, 19289, 26, 336, 186, 236);
INSERT INTO public.who_global_data VALUES (43914, 0, 13, 0, 0, 186, 150);
INSERT INTO public.who_global_data VALUES (43915, 0, 225, 0, 0, 186, 61);
INSERT INTO public.who_global_data VALUES (43916, 0, 27, 0, 1, 186, 7);
INSERT INTO public.who_global_data VALUES (43917, 13, 7466, 0, 329, 186, 169);
INSERT INTO public.who_global_data VALUES (43918, 3152, 179072, 28, 30175, 186, 28);
INSERT INTO public.who_global_data VALUES (43919, 91, 7948, 1, 44, 186, 85);
INSERT INTO public.who_global_data VALUES (43920, 0, 62, 0, 0, 186, 211);
INSERT INTO public.who_global_data VALUES (43921, 115, 7646, 1, 51, 186, 60);
INSERT INTO public.who_global_data VALUES (43922, 0, 498, 0, 9, 186, 3);
INSERT INTO public.who_global_data VALUES (43923, 3, 1182, 0, 17, 186, 11);
INSERT INTO public.who_global_data VALUES (43924, 879, 211281, 8, 9156, 186, 89);
INSERT INTO public.who_global_data VALUES (43925, 0, 37014, 0, 182, 186, 24);
INSERT INTO public.who_global_data VALUES (43926, 0, 188, 0, 0, 186, 162);
INSERT INTO public.who_global_data VALUES (43927, 75, 4737, 1, 209, 186, 100);
INSERT INTO public.who_global_data VALUES (43928, 0, 14, 0, 0, 186, 47);
INSERT INTO public.who_global_data VALUES (43929, 0, 24, 0, 0, 186, 29);
INSERT INTO public.who_global_data VALUES (43930, 0, 265, 0, 14, 186, 40);
INSERT INTO public.who_global_data VALUES (43931, 16, 367, 0, 5, 186, 222);
INSERT INTO public.who_global_data VALUES (43932, 236, 51542, 18, 2013, 186, 132);
INSERT INTO public.who_global_data VALUES (43933, 0, 252, 0, 13, 186, 130);
INSERT INTO public.who_global_data VALUES (43934, 54, 7418, 0, 46, 186, 234);
INSERT INTO public.who_global_data VALUES (43935, 0, 1981, 0, 27, 186, 23);
INSERT INTO public.who_global_data VALUES (43936, 44, 474, 1, 21, 186, 192);
INSERT INTO public.who_global_data VALUES (43937, 8, 7476, 0, 165, 186, 69);
INSERT INTO public.who_global_data VALUES (43938, 0, 12, 0, 0, 186, 187);
INSERT INTO public.who_global_data VALUES (43939, 512, 43197, 9, 1377, 186, 230);
INSERT INTO public.who_global_data VALUES (43940, 9, 4544, 0, 597, 186, 77);
INSERT INTO public.who_global_data VALUES (43941, 8, 1915, 0, 10, 186, 9);
INSERT INTO public.who_global_data VALUES (43942, 52050, 1855745, 803, 38938, 186, 74);
INSERT INTO public.who_global_data VALUES (43943, 1679, 113134, 66, 5302, 186, 224);
INSERT INTO public.who_global_data VALUES (43944, 2598, 312035, 215, 17405, 186, 199);
INSERT INTO public.who_global_data VALUES (43945, 2735, 131886, 66, 4934, 186, 190);
INSERT INTO public.who_global_data VALUES (43946, 46, 26208, 0, 1763, 186, 12);
INSERT INTO public.who_global_data VALUES (43947, 0, 336, 0, 24, 186, 104);
INSERT INTO public.who_global_data VALUES (43948, 708, 73077, 11, 589, 186, 153);
INSERT INTO public.who_global_data VALUES (43949, 159, 248229, 12, 35166, 186, 91);
INSERT INTO public.who_global_data VALUES (43950, 11, 894, 2, 12, 186, 215);
INSERT INTO public.who_global_data VALUES (43951, 1171, 39858, 4, 1016, 186, 84);
INSERT INTO public.who_global_data VALUES (43952, 0, 335, 0, 31, 186, 231);
INSERT INTO public.who_global_data VALUES (43953, 5, 1286, 0, 11, 186, 196);
INSERT INTO public.who_global_data VALUES (43954, 2861, 102936, 0, 1109, 186, 105);
INSERT INTO public.who_global_data VALUES (43955, 544, 22597, 13, 382, 186, 122);
INSERT INTO public.who_global_data VALUES (43956, 0, 0, 0, 0, 186, 159);
INSERT INTO public.who_global_data VALUES (43957, 250, 9006, 7, 246, 186, 75);
INSERT INTO public.who_global_data VALUES (43958, 388, 68299, 4, 461, 186, 27);
INSERT INTO public.who_global_data VALUES (43959, 412, 37541, 7, 982, 186, 54);
INSERT INTO public.who_global_data VALUES (43960, 0, 20, 0, 0, 186, 226);
INSERT INTO public.who_global_data VALUES (43961, 3, 1246, 0, 32, 186, 79);
INSERT INTO public.who_global_data VALUES (43962, 177, 5062, 3, 65, 186, 56);
INSERT INTO public.who_global_data VALUES (43963, 0, 718, 0, 19, 186, 117);
INSERT INTO public.who_global_data VALUES (43964, 7, 1214, 1, 78, 186, 152);
INSERT INTO public.who_global_data VALUES (43965, 226, 4063, 10, 93, 186, 16);
INSERT INTO public.who_global_data VALUES (43966, 0, 89, 0, 1, 186, 10);
INSERT INTO public.who_global_data VALUES (43967, 17, 2131, 0, 80, 186, 201);
INSERT INTO public.who_global_data VALUES (43968, 169, 6864, 1, 118, 186, 174);
INSERT INTO public.who_global_data VALUES (43969, 132, 11660, 4, 118, 186, 119);
INSERT INTO public.who_global_data VALUES (43970, 42, 4273, 0, 123, 186, 168);
INSERT INTO public.who_global_data VALUES (43971, 2, 9001, 0, 125, 186, 99);
INSERT INTO public.who_global_data VALUES (43972, 129, 4293, 0, 18, 186, 171);
INSERT INTO public.who_global_data VALUES (43973, 8, 2543, 0, 124, 186, 87);
INSERT INTO public.who_global_data VALUES (43974, 16, 799, 0, 9, 186, 123);
INSERT INTO public.who_global_data VALUES (43975, 0, 0, 0, 0, 186, 151);
INSERT INTO public.who_global_data VALUES (43976, 0, 269, 0, 15, 186, 213);
INSERT INTO public.who_global_data VALUES (43977, 59, 6382, 0, 157, 186, 118);
INSERT INTO public.who_global_data VALUES (43978, 0, 344, 0, 10, 186, 134);
INSERT INTO public.who_global_data VALUES (43979, 46, 3008, 0, 39, 186, 65);
INSERT INTO public.who_global_data VALUES (43980, 4853, 439046, 274, 47746, 186, 102);
INSERT INTO public.who_global_data VALUES (43981, 0, 0, 0, 0, 186, 223);
INSERT INTO public.who_global_data VALUES (43982, 1, 88, 0, 1, 186, 4);
INSERT INTO public.who_global_data VALUES (43983, 0, 293, 0, 0, 186, 146);
INSERT INTO public.who_global_data VALUES (43984, 60, 3384, 1, 54, 186, 31);
INSERT INTO public.who_global_data VALUES (43985, 0, 13, 0, 1, 186, 127);
INSERT INTO public.who_global_data VALUES (43986, 659, 26196, 19, 401, 186, 22);
INSERT INTO public.who_global_data VALUES (43987, 27, 1973, 1, 14, 186, 115);
INSERT INTO public.who_global_data VALUES (43988, 2, 355, 0, 6, 186, 106);
INSERT INTO public.who_global_data VALUES (43989, 112, 2406, 1, 12, 186, 90);
INSERT INTO public.who_global_data VALUES (43990, 0, 0, 0, 0, 186, 70);
INSERT INTO public.who_global_data VALUES (43991, 418, 20750, 0, 57, 186, 46);
INSERT INTO public.who_global_data VALUES (43992, 372, 55407, 0, 6147, 186, 139);
INSERT INTO public.who_global_data VALUES (43993, 0, 22, 0, 0, 186, 42);
INSERT INTO public.who_global_data VALUES (43994, 0, 1217, 0, 22, 186, 80);
INSERT INTO public.who_global_data VALUES (43995, 0, 3080, 0, 116, 186, 203);
INSERT INTO public.who_global_data VALUES (43996, 9, 1147, 0, 69, 186, 136);
INSERT INTO public.who_global_data VALUES (43997, 288, 44129, 8, 896, 186, 63);
INSERT INTO public.who_global_data VALUES (43998, 0, 0, 0, 0, 186, 17);
INSERT INTO public.who_global_data VALUES (43999, 1, 46, 0, 2, 186, 172);
INSERT INTO public.who_global_data VALUES (44000, 74, 11140, 3, 500, 186, 109);
INSERT INTO public.who_global_data VALUES (44001, 60, 9268, 1, 256, 186, 200);
INSERT INTO public.who_global_data VALUES (44002, 244, 16024, 0, 87, 186, 93);
INSERT INTO public.who_global_data VALUES (44003, 542, 79701, 62, 483, 186, 5);
INSERT INTO public.who_global_data VALUES (44004, 0, 741, 0, 13, 186, 214);
INSERT INTO public.who_global_data VALUES (44005, 432, 280461, 15, 5999, 186, 204);
INSERT INTO public.who_global_data VALUES (44006, 0, 0, 0, 0, 186, 198);
INSERT INTO public.who_global_data VALUES (44007, 1070, 67453, 22, 1471, 186, 173);
INSERT INTO public.who_global_data VALUES (44008, 1, 111, 0, 2, 186, 229);
INSERT INTO public.who_global_data VALUES (44009, 159, 5644, 0, 52, 186, 76);
INSERT INTO public.who_global_data VALUES (44010, 6667, 428850, 206, 19614, 186, 138);
INSERT INTO public.who_global_data VALUES (44011, 3145, 106330, 45, 2104, 186, 98);
INSERT INTO public.who_global_data VALUES (44012, 0, 0, 0, 0, 186, 103);
INSERT INTO public.who_global_data VALUES (44013, 575, 47469, 1, 1732, 186, 225);
INSERT INTO public.who_global_data VALUES (44014, 106, 51569, 0, 1738, 186, 131);
INSERT INTO public.who_global_data VALUES (44015, 380, 18791, 0, 230, 186, 235);
INSERT INTO public.who_global_data VALUES (44016, 215, 111322, 0, 177, 186, 137);
INSERT INTO public.who_global_data VALUES (44017, 34, 14423, 0, 301, 186, 81);
INSERT INTO public.who_global_data VALUES (44018, 120, 25482, 8, 800, 186, 182);
INSERT INTO public.who_global_data VALUES (44019, 0, 667, 0, 4, 186, 145);
INSERT INTO public.who_global_data VALUES (44020, 823, 54009, 19, 2432, 186, 26);
INSERT INTO public.who_global_data VALUES (44021, 5159, 861423, 144, 14351, 186, 170);
INSERT INTO public.who_global_data VALUES (44022, 30, 2092, 0, 5, 186, 191);
INSERT INTO public.who_global_data VALUES (44023, 0, 5, 0, 0, 186, 221);
INSERT INTO public.who_global_data VALUES (44024, 0, 9, 0, 0, 186, 64);
INSERT INTO public.who_global_data VALUES (44025, 0, 0, 0, 0, 186, 116);
INSERT INTO public.who_global_data VALUES (44026, 0, 17, 0, 0, 186, 128);
INSERT INTO public.who_global_data VALUES (44027, 0, 25, 0, 0, 186, 6);
INSERT INTO public.who_global_data VALUES (44028, 0, 53, 0, 3, 186, 227);
INSERT INTO public.who_global_data VALUES (44029, 0, 4, 0, 0, 186, 68);
INSERT INTO public.who_global_data VALUES (44030, 1, 55, 0, 0, 186, 184);
INSERT INTO public.who_global_data VALUES (44031, 0, 0, 0, 0, 186, 82);
INSERT INTO public.who_global_data VALUES (44032, 0, 716, 0, 42, 186, 149);
INSERT INTO public.who_global_data VALUES (44033, 0, 874, 0, 15, 186, 197);
INSERT INTO public.who_global_data VALUES (44034, 1258, 280093, 32, 2949, 186, 78);
INSERT INTO public.who_global_data VALUES (44035, 42, 10386, 2, 211, 186, 233);
INSERT INTO public.who_global_data VALUES (44036, 258, 26451, 8, 598, 186, 133);
INSERT INTO public.who_global_data VALUES (44037, 0, 114, 0, 0, 186, 35);
INSERT INTO public.who_global_data VALUES (44038, 5, 1848, 0, 67, 186, 114);
INSERT INTO public.who_global_data VALUES (44039, 226, 53051, 0, 27, 186, 237);
INSERT INTO public.who_global_data VALUES (44040, 0, 3, 0, 0, 186, 55);
INSERT INTO public.who_global_data VALUES (44041, 18, 146, 1, 16, 186, 176);
INSERT INTO public.who_global_data VALUES (44042, 10, 2354, 0, 29, 186, 202);
INSERT INTO public.who_global_data VALUES (44043, 9, 2191, 1, 125, 186, 155);
INSERT INTO public.who_global_data VALUES (44044, 0, 0, 0, 0, 186, 32);
INSERT INTO public.who_global_data VALUES (44045, 0, 3220, 0, 93, 186, 220);
INSERT INTO public.who_global_data VALUES (44046, 5377, 516862, 0, 8366, 186, 30);
INSERT INTO public.who_global_data VALUES (44047, 8, 2437, 1, 47, 186, 147);
INSERT INTO public.who_global_data VALUES (44048, 1888, 313133, 14, 29933, 186, 208);
INSERT INTO public.who_global_data VALUES (44049, 5, 2828, 0, 11, 186, 45);
INSERT INTO public.who_global_data VALUES (44050, 42, 11780, 11, 763, 186, 110);
INSERT INTO public.who_global_data VALUES (44051, 89, 1849, 1, 27, 186, 88);
INSERT INTO public.who_global_data VALUES (44052, 38, 77282, 3, 5765, 186, 51);
INSERT INTO public.who_global_data VALUES (44053, 196, 35820, 0, 1740, 186, 209);
INSERT INTO public.who_global_data VALUES (44054, 38, 847, 2, 46, 186, 205);
INSERT INTO public.who_global_data VALUES (44055, 43, 7538, 0, 61, 186, 18);
INSERT INTO public.who_global_data VALUES (44056, 1, 3321, 0, 58, 186, 72);
INSERT INTO public.who_global_data VALUES (44057, 928, 305627, 1, 41208, 186, 44);
INSERT INTO public.who_global_data VALUES (44058, 1, 25, 0, 0, 186, 15);
INSERT INTO public.who_global_data VALUES (44059, 34, 961, 1, 19, 186, 25);
INSERT INTO public.who_global_data VALUES (44060, 0, 0, 0, 0, 186, 179);
INSERT INTO public.who_global_data VALUES (44061, 0, 0, 0, 0, 186, 34);
INSERT INTO public.who_global_data VALUES (44062, 2, 182, 0, 8, 186, 207);
INSERT INTO public.who_global_data VALUES (44063, 19, 1584, 0, 51, 186, 166);
INSERT INTO public.who_global_data VALUES (44064, 7725, 280961, 19, 5747, 186, 126);
INSERT INTO public.who_global_data VALUES (44065, 0, 0, 0, 0, 186, 97);
INSERT INTO public.who_global_data VALUES (44066, 0, 114, 0, 2, 186, 36);
INSERT INTO public.who_global_data VALUES (44067, 0, 0, 0, 0, 186, 125);
INSERT INTO public.who_global_data VALUES (44068, 13, 1195, 1, 5, 186, 124);
INSERT INTO public.who_global_data VALUES (44069, 1061, 74219, 26, 1764, 186, 185);
INSERT INTO public.who_global_data VALUES (44070, 164, 61163, 0, 351, 186, 194);
INSERT INTO public.who_global_data VALUES (44071, 0, 509, 0, 21, 186, 144);
INSERT INTO public.who_global_data VALUES (44072, 47183, 4629459, 469, 154226, 186, 19);
INSERT INTO public.who_global_data VALUES (44073, 1, 439, 0, 8, 186, 217);
INSERT INTO public.who_global_data VALUES (44074, 8, 1286, 1, 36, 186, 148);
INSERT INTO public.who_global_data VALUES (44075, 722, 26550, 6, 161, 186, 86);
INSERT INTO public.who_global_data VALUES (44076, 0, 0, 0, 0, 186, 13);
INSERT INTO public.who_global_data VALUES (44077, 763, 20206, 5, 174, 186, 157);
INSERT INTO public.who_global_data VALUES (44078, 31, 652, 0, 6, 186, 8);
INSERT INTO public.who_global_data VALUES (44079, 0, 0, 0, 0, 186, 73);
INSERT INTO public.who_global_data VALUES (44080, 0, 1738, 2, 500, 186, 101);
INSERT INTO public.who_global_data VALUES (44081, 233, 6580, 1, 171, 186, 165);
INSERT INTO public.who_global_data VALUES (44082, 154, 4075, 10, 80, 186, 14);
INSERT INTO public.who_global_data VALUES (44083, 0, 36796, 0, 1287, 187, 193);
INSERT INTO public.who_global_data VALUES (44084, 123, 5519, 5, 166, 187, 113);
INSERT INTO public.who_global_data VALUES (44085, 515, 31465, 8, 1231, 187, 143);
INSERT INTO public.who_global_data VALUES (44086, 0, 0, 0, 0, 187, 219);
INSERT INTO public.who_global_data VALUES (44087, 6, 936, 0, 52, 187, 186);
INSERT INTO public.who_global_data VALUES (44088, 16, 1164, 2, 54, 187, 52);
INSERT INTO public.who_global_data VALUES (44089, 0, 3, 0, 0, 187, 180);
INSERT INTO public.who_global_data VALUES (44090, 0, 91, 0, 3, 187, 167);
INSERT INTO public.who_global_data VALUES (44091, 5241, 196543, 69, 3612, 187, 154);
INSERT INTO public.who_global_data VALUES (44092, 52, 38415, 8, 757, 187, 94);
INSERT INTO public.who_global_data VALUES (44093, 0, 120, 0, 3, 187, 66);
INSERT INTO public.who_global_data VALUES (44094, 641, 17923, 8, 208, 187, 58);
INSERT INTO public.who_global_data VALUES (44095, 85, 21309, 0, 718, 187, 163);
INSERT INTO public.who_global_data VALUES (44096, 286, 32443, 8, 462, 187, 37);
INSERT INTO public.who_global_data VALUES (44097, 66, 574, 0, 14, 187, 142);
INSERT INTO public.who_global_data VALUES (44098, 346, 41536, 0, 147, 187, 83);
INSERT INTO public.who_global_data VALUES (44099, 886, 240746, 22, 3154, 187, 228);
INSERT INTO public.who_global_data VALUES (44100, 12, 122, 0, 7, 187, 188);
INSERT INTO public.who_global_data VALUES (44101, 121, 68067, 4, 567, 187, 62);
INSERT INTO public.who_global_data VALUES (44102, 148, 70831, 5, 9709, 187, 160);
INSERT INTO public.who_global_data VALUES (44103, 8, 56, 0, 2, 187, 50);
INSERT INTO public.who_global_data VALUES (44104, 0, 1805, 0, 36, 187, 33);
INSERT INTO public.who_global_data VALUES (44105, 0, 156, 0, 9, 187, 183);
INSERT INTO public.who_global_data VALUES (44106, 1, 103, 0, 0, 187, 92);
INSERT INTO public.who_global_data VALUES (44107, 2004, 78793, 87, 3064, 187, 158);
INSERT INTO public.who_global_data VALUES (44108, 0, 5, 0, 0, 187, 67);
INSERT INTO public.who_global_data VALUES (44109, 188, 12296, 4, 347, 187, 57);
INSERT INTO public.who_global_data VALUES (44110, 0, 804, 0, 2, 187, 38);
INSERT INTO public.who_global_data VALUES (44111, 45392, 2707877, 1088, 93563, 187, 141);
INSERT INTO public.who_global_data VALUES (44112, 0, 8, 0, 1, 187, 178);
INSERT INTO public.who_global_data VALUES (44113, 0, 141, 0, 3, 187, 108);
INSERT INTO public.who_global_data VALUES (44114, 119, 11955, 3, 388, 187, 39);
INSERT INTO public.who_global_data VALUES (44115, 6, 1149, 0, 53, 187, 2);
INSERT INTO public.who_global_data VALUES (44116, 8, 395, 0, 1, 187, 195);
INSERT INTO public.who_global_data VALUES (44117, 67, 2547, 0, 24, 187, 107);
INSERT INTO public.who_global_data VALUES (44118, 0, 240, 0, 0, 187, 161);
INSERT INTO public.who_global_data VALUES (44119, 0, 17255, 0, 391, 187, 212);
INSERT INTO public.who_global_data VALUES (44120, 287, 116599, 6, 8941, 187, 181);
INSERT INTO public.who_global_data VALUES (44121, 0, 203, 0, 1, 187, 53);
INSERT INTO public.who_global_data VALUES (44122, 0, 4614, 0, 59, 187, 164);
INSERT INTO public.who_global_data VALUES (44123, 0, 936, 0, 75, 187, 140);
INSERT INTO public.who_global_data VALUES (44124, 2073, 359731, 75, 9608, 187, 20);
INSERT INTO public.who_global_data VALUES (44125, 157, 88459, 2, 4676, 187, 112);
INSERT INTO public.who_global_data VALUES (44126, 10673, 306181, 225, 10330, 187, 111);
INSERT INTO public.who_global_data VALUES (44127, 4, 386, 0, 7, 187, 71);
INSERT INTO public.who_global_data VALUES (44128, 0, 3387, 0, 56, 187, 218);
INSERT INTO public.who_global_data VALUES (44129, 0, 0, 0, 0, 187, 43);
INSERT INTO public.who_global_data VALUES (44130, 367, 18187, 4, 154, 187, 49);
INSERT INTO public.who_global_data VALUES (44131, 73, 16182, 0, 102, 187, 1);
INSERT INTO public.who_global_data VALUES (44132, 36, 5260, 4, 149, 187, 48);
INSERT INTO public.who_global_data VALUES (44133, 13, 2646, 0, 87, 187, 232);
INSERT INTO public.who_global_data VALUES (44134, 0, 29, 0, 1, 187, 175);
INSERT INTO public.who_global_data VALUES (44135, 26, 1150, 0, 19, 187, 21);
INSERT INTO public.who_global_data VALUES (44136, 101, 16800, 0, 383, 187, 156);
INSERT INTO public.who_global_data VALUES (44137, 0, 0, 0, 0, 187, 95);
INSERT INTO public.who_global_data VALUES (44138, 45, 9114, 0, 214, 187, 177);
INSERT INTO public.who_global_data VALUES (44139, 0, 13789, 0, 615, 187, 210);
INSERT INTO public.who_global_data VALUES (44140, 80, 5161, 1, 59, 187, 120);
INSERT INTO public.who_global_data VALUES (44141, 0, 18, 0, 0, 187, 135);
INSERT INTO public.who_global_data VALUES (44142, 828, 72243, 8, 1178, 187, 206);
INSERT INTO public.who_global_data VALUES (44143, 0, 86232, 0, 5736, 187, 189);
INSERT INTO public.who_global_data VALUES (44144, 167, 94483, 31, 4865, 187, 129);
INSERT INTO public.who_global_data VALUES (44145, 398, 17448, 8, 467, 187, 121);
INSERT INTO public.who_global_data VALUES (44146, 0, 4821, 0, 83, 187, 59);
INSERT INTO public.who_global_data VALUES (44147, 0, 279, 0, 0, 187, 96);
INSERT INTO public.who_global_data VALUES (44148, 7, 2079, 0, 63, 187, 41);
INSERT INTO public.who_global_data VALUES (44149, 69, 2775, 0, 42, 187, 216);
INSERT INTO public.who_global_data VALUES (44150, 707, 18706, 26, 310, 187, 236);
INSERT INTO public.who_global_data VALUES (44151, 0, 13, 0, 0, 187, 150);
INSERT INTO public.who_global_data VALUES (44152, 0, 225, 0, 0, 187, 61);
INSERT INTO public.who_global_data VALUES (44153, 0, 27, 0, 1, 187, 7);
INSERT INTO public.who_global_data VALUES (44154, 10, 7453, 0, 329, 187, 169);
INSERT INTO public.who_global_data VALUES (44155, 0, 175920, 0, 30147, 187, 28);
INSERT INTO public.who_global_data VALUES (44156, 0, 7857, 0, 43, 187, 85);
INSERT INTO public.who_global_data VALUES (44157, 0, 62, 0, 0, 187, 211);
INSERT INTO public.who_global_data VALUES (44158, 0, 7531, 0, 50, 187, 60);
INSERT INTO public.who_global_data VALUES (44159, 0, 498, 0, 9, 187, 3);
INSERT INTO public.who_global_data VALUES (44160, 2, 1179, 0, 17, 187, 11);
INSERT INTO public.who_global_data VALUES (44161, 509, 210402, 7, 9148, 187, 89);
INSERT INTO public.who_global_data VALUES (44162, 1513, 37014, 0, 182, 187, 24);
INSERT INTO public.who_global_data VALUES (44163, 1, 188, 0, 0, 187, 162);
INSERT INTO public.who_global_data VALUES (44164, 75, 4662, 2, 208, 187, 100);
INSERT INTO public.who_global_data VALUES (44165, 0, 14, 0, 0, 187, 47);
INSERT INTO public.who_global_data VALUES (44166, 0, 24, 0, 0, 187, 29);
INSERT INTO public.who_global_data VALUES (44167, 0, 265, 0, 14, 187, 40);
INSERT INTO public.who_global_data VALUES (44168, 0, 351, 0, 5, 187, 222);
INSERT INTO public.who_global_data VALUES (44169, 327, 51306, 38, 1995, 187, 132);
INSERT INTO public.who_global_data VALUES (44170, 0, 252, 0, 13, 187, 130);
INSERT INTO public.who_global_data VALUES (44171, 56, 7364, 0, 46, 187, 234);
INSERT INTO public.who_global_data VALUES (44172, 0, 1981, 0, 27, 187, 23);
INSERT INTO public.who_global_data VALUES (44173, 17, 430, 0, 20, 187, 192);
INSERT INTO public.who_global_data VALUES (44174, 44, 7468, 4, 165, 187, 69);
INSERT INTO public.who_global_data VALUES (44175, 0, 12, 0, 0, 187, 187);
INSERT INTO public.who_global_data VALUES (44176, 671, 42685, 31, 1368, 187, 230);
INSERT INTO public.who_global_data VALUES (44177, 9, 4535, 0, 597, 187, 77);
INSERT INTO public.who_global_data VALUES (44178, 14, 1907, 0, 10, 187, 9);
INSERT INTO public.who_global_data VALUES (44179, 52972, 1803695, 771, 38135, 187, 74);
INSERT INTO public.who_global_data VALUES (44180, 1519, 111455, 43, 5236, 187, 224);
INSERT INTO public.who_global_data VALUES (44181, 2685, 309437, 208, 17190, 187, 199);
INSERT INTO public.who_global_data VALUES (44182, 2447, 129151, 63, 4868, 187, 190);
INSERT INTO public.who_global_data VALUES (44183, 53, 26162, 0, 1763, 187, 12);
INSERT INTO public.who_global_data VALUES (44184, 0, 336, 0, 24, 187, 104);
INSERT INTO public.who_global_data VALUES (44185, 625, 72369, 14, 578, 187, 153);
INSERT INTO public.who_global_data VALUES (44186, 238, 248070, 8, 35154, 187, 91);
INSERT INTO public.who_global_data VALUES (44187, 5, 883, 0, 10, 187, 215);
INSERT INTO public.who_global_data VALUES (44188, 1998, 38687, 1, 1012, 187, 84);
INSERT INTO public.who_global_data VALUES (44189, 0, 335, 0, 31, 187, 231);
INSERT INTO public.who_global_data VALUES (44190, 5, 1281, 0, 11, 187, 196);
INSERT INTO public.who_global_data VALUES (44191, 1434, 100075, 0, 1109, 187, 105);
INSERT INTO public.who_global_data VALUES (44192, 690, 22053, 5, 369, 187, 122);
INSERT INTO public.who_global_data VALUES (44193, 0, 0, 0, 0, 187, 159);
INSERT INTO public.who_global_data VALUES (44194, 245, 8756, 12, 239, 187, 75);
INSERT INTO public.who_global_data VALUES (44195, 463, 67911, 4, 457, 187, 27);
INSERT INTO public.who_global_data VALUES (44196, 410, 37129, 11, 975, 187, 54);
INSERT INTO public.who_global_data VALUES (44197, 0, 20, 0, 0, 187, 226);
INSERT INTO public.who_global_data VALUES (44198, 5, 1243, 0, 32, 187, 79);
INSERT INTO public.who_global_data VALUES (44199, 155, 4885, 1, 62, 187, 56);
INSERT INTO public.who_global_data VALUES (44200, 16, 718, 5, 19, 187, 117);
INSERT INTO public.who_global_data VALUES (44201, 18, 1207, 2, 77, 187, 152);
INSERT INTO public.who_global_data VALUES (44202, 146, 3837, 3, 83, 187, 16);
INSERT INTO public.who_global_data VALUES (44203, 0, 89, 0, 1, 187, 10);
INSERT INTO public.who_global_data VALUES (44204, 10, 2114, 0, 80, 187, 201);
INSERT INTO public.who_global_data VALUES (44205, 0, 6695, 3, 117, 187, 174);
INSERT INTO public.who_global_data VALUES (44206, 255, 11528, 7, 114, 187, 119);
INSERT INTO public.who_global_data VALUES (44207, 45, 4231, 3, 123, 187, 168);
INSERT INTO public.who_global_data VALUES (44208, 14, 8999, 0, 125, 187, 99);
INSERT INTO public.who_global_data VALUES (44209, 215, 4164, 1, 18, 187, 171);
INSERT INTO public.who_global_data VALUES (44210, 0, 2535, 0, 124, 187, 87);
INSERT INTO public.who_global_data VALUES (44211, 14, 783, 0, 9, 187, 123);
INSERT INTO public.who_global_data VALUES (44212, 0, 0, 0, 0, 187, 151);
INSERT INTO public.who_global_data VALUES (44213, 0, 269, 0, 15, 187, 213);
INSERT INTO public.who_global_data VALUES (44214, 13, 6323, 0, 157, 187, 118);
INSERT INTO public.who_global_data VALUES (44215, 0, 344, 0, 10, 187, 134);
INSERT INTO public.who_global_data VALUES (44216, 0, 2962, 0, 39, 187, 65);
INSERT INTO public.who_global_data VALUES (44217, 9556, 434193, 784, 47472, 187, 102);
INSERT INTO public.who_global_data VALUES (44218, 0, 0, 0, 0, 187, 223);
INSERT INTO public.who_global_data VALUES (44219, 0, 87, 0, 1, 187, 4);
INSERT INTO public.who_global_data VALUES (44220, 2, 293, 0, 0, 187, 146);
INSERT INTO public.who_global_data VALUES (44221, 46, 3324, 2, 53, 187, 31);
INSERT INTO public.who_global_data VALUES (44222, 0, 13, 0, 1, 187, 127);
INSERT INTO public.who_global_data VALUES (44223, 486, 25537, 15, 382, 187, 22);
INSERT INTO public.who_global_data VALUES (44224, 39, 1946, 1, 13, 187, 115);
INSERT INTO public.who_global_data VALUES (44225, 0, 353, 0, 6, 187, 106);
INSERT INTO public.who_global_data VALUES (44226, 70, 2294, 0, 11, 187, 90);
INSERT INTO public.who_global_data VALUES (44227, 0, 0, 0, 0, 187, 70);
INSERT INTO public.who_global_data VALUES (44228, 246, 20332, 1, 57, 187, 46);
INSERT INTO public.who_global_data VALUES (44229, 361, 55035, 1, 6147, 187, 139);
INSERT INTO public.who_global_data VALUES (44230, 0, 22, 0, 0, 187, 42);
INSERT INTO public.who_global_data VALUES (44231, 2, 1217, 0, 22, 187, 80);
INSERT INTO public.who_global_data VALUES (44232, 0, 3080, 0, 116, 187, 203);
INSERT INTO public.who_global_data VALUES (44233, 2, 1138, 0, 69, 187, 136);
INSERT INTO public.who_global_data VALUES (44234, 304, 43841, 5, 888, 187, 63);
INSERT INTO public.who_global_data VALUES (44235, 0, 0, 0, 0, 187, 17);
INSERT INTO public.who_global_data VALUES (44236, 1, 45, 0, 2, 187, 172);
INSERT INTO public.who_global_data VALUES (44237, 166, 11066, 4, 497, 187, 109);
INSERT INTO public.who_global_data VALUES (44238, 0, 9208, 0, 255, 187, 200);
INSERT INTO public.who_global_data VALUES (44239, 225, 15780, 1, 87, 187, 93);
INSERT INTO public.who_global_data VALUES (44240, 0, 79159, 0, 421, 187, 5);
INSERT INTO public.who_global_data VALUES (44241, 0, 741, 0, 13, 187, 214);
INSERT INTO public.who_global_data VALUES (44242, 330, 280029, 8, 5984, 187, 204);
INSERT INTO public.who_global_data VALUES (44243, 0, 0, 0, 0, 187, 198);
INSERT INTO public.who_global_data VALUES (44244, 1127, 66383, 28, 1449, 187, 173);
INSERT INTO public.who_global_data VALUES (44245, 19, 110, 0, 2, 187, 229);
INSERT INTO public.who_global_data VALUES (44246, 147, 5485, 3, 52, 187, 76);
INSERT INTO public.who_global_data VALUES (44247, 14691, 422183, 387, 19408, 187, 138);
INSERT INTO public.who_global_data VALUES (44248, 4953, 103185, 20, 2059, 187, 98);
INSERT INTO public.who_global_data VALUES (44249, 0, 0, 0, 0, 187, 103);
INSERT INTO public.who_global_data VALUES (44250, 548, 46894, 10, 1731, 187, 225);
INSERT INTO public.who_global_data VALUES (44251, 153, 51463, 1, 1738, 187, 131);
INSERT INTO public.who_global_data VALUES (44252, 539, 18411, 5, 230, 187, 235);
INSERT INTO public.who_global_data VALUES (44253, 196, 111107, 3, 177, 187, 137);
INSERT INTO public.who_global_data VALUES (44254, 23, 14389, 0, 301, 187, 81);
INSERT INTO public.who_global_data VALUES (44255, 249, 25362, 3, 792, 187, 182);
INSERT INTO public.who_global_data VALUES (44256, 3, 667, 0, 4, 187, 145);
INSERT INTO public.who_global_data VALUES (44257, 1075, 53186, 34, 2413, 187, 26);
INSERT INTO public.who_global_data VALUES (44258, 5394, 856264, 79, 14207, 187, 170);
INSERT INTO public.who_global_data VALUES (44259, 20, 2062, 0, 5, 187, 191);
INSERT INTO public.who_global_data VALUES (44260, 2, 5, 0, 0, 187, 221);
INSERT INTO public.who_global_data VALUES (44261, 1, 9, 0, 0, 187, 64);
INSERT INTO public.who_global_data VALUES (44262, 0, 0, 0, 0, 187, 116);
INSERT INTO public.who_global_data VALUES (44263, 0, 17, 0, 0, 187, 128);
INSERT INTO public.who_global_data VALUES (44264, 0, 25, 0, 0, 187, 6);
INSERT INTO public.who_global_data VALUES (44265, 0, 53, 0, 3, 187, 227);
INSERT INTO public.who_global_data VALUES (44266, 0, 4, 0, 0, 187, 68);
INSERT INTO public.who_global_data VALUES (44267, 0, 54, 0, 0, 187, 184);
INSERT INTO public.who_global_data VALUES (44268, 0, 0, 0, 0, 187, 82);
INSERT INTO public.who_global_data VALUES (44269, 0, 716, 0, 42, 187, 149);
INSERT INTO public.who_global_data VALUES (44270, 0, 874, 0, 15, 187, 197);
INSERT INTO public.who_global_data VALUES (44271, 1357, 278835, 30, 2917, 187, 78);
INSERT INTO public.who_global_data VALUES (44272, 60, 10344, 0, 209, 187, 233);
INSERT INTO public.who_global_data VALUES (44273, 311, 26193, 8, 590, 187, 133);
INSERT INTO public.who_global_data VALUES (44274, 0, 114, 0, 0, 187, 35);
INSERT INTO public.who_global_data VALUES (44275, 8, 1843, 0, 67, 187, 114);
INSERT INTO public.who_global_data VALUES (44276, 313, 52825, 0, 27, 187, 237);
INSERT INTO public.who_global_data VALUES (44277, 0, 3, 0, 0, 187, 55);
INSERT INTO public.who_global_data VALUES (44278, 0, 128, 0, 15, 187, 176);
INSERT INTO public.who_global_data VALUES (44279, 7, 2344, 0, 29, 187, 202);
INSERT INTO public.who_global_data VALUES (44280, 1, 2182, 2, 124, 187, 155);
INSERT INTO public.who_global_data VALUES (44281, 0, 0, 0, 0, 187, 32);
INSERT INTO public.who_global_data VALUES (44282, 8, 3220, 0, 93, 187, 220);
INSERT INTO public.who_global_data VALUES (44283, 8195, 511485, 213, 8366, 187, 30);
INSERT INTO public.who_global_data VALUES (44284, 0, 2429, 0, 46, 187, 147);
INSERT INTO public.who_global_data VALUES (44285, 3108, 311245, 9, 29919, 187, 208);
INSERT INTO public.who_global_data VALUES (44286, 8, 2823, 0, 11, 187, 45);
INSERT INTO public.who_global_data VALUES (44287, 0, 11738, 0, 752, 187, 110);
INSERT INTO public.who_global_data VALUES (44288, 54, 1760, 0, 26, 187, 88);
INSERT INTO public.who_global_data VALUES (44289, 303, 77244, 2, 5762, 187, 51);
INSERT INTO public.who_global_data VALUES (44290, 80, 35624, 0, 1740, 187, 209);
INSERT INTO public.who_global_data VALUES (44291, 29, 809, 1, 44, 187, 205);
INSERT INTO public.who_global_data VALUES (44292, 44, 7495, 1, 61, 187, 18);
INSERT INTO public.who_global_data VALUES (44293, 3, 3320, 0, 58, 187, 72);
INSERT INTO public.who_global_data VALUES (44294, 743, 304699, 5, 41207, 187, 44);
INSERT INTO public.who_global_data VALUES (44295, 0, 24, 0, 0, 187, 15);
INSERT INTO public.who_global_data VALUES (44296, 0, 927, 0, 18, 187, 25);
INSERT INTO public.who_global_data VALUES (44297, 0, 0, 0, 0, 187, 179);
INSERT INTO public.who_global_data VALUES (44298, 0, 0, 0, 0, 187, 34);
INSERT INTO public.who_global_data VALUES (44299, 7, 180, 0, 8, 187, 207);
INSERT INTO public.who_global_data VALUES (44300, 4, 1565, 0, 51, 187, 166);
INSERT INTO public.who_global_data VALUES (44301, 7717, 273236, 18, 5728, 187, 126);
INSERT INTO public.who_global_data VALUES (44302, 0, 0, 0, 0, 187, 97);
INSERT INTO public.who_global_data VALUES (44303, 0, 114, 0, 2, 187, 36);
INSERT INTO public.who_global_data VALUES (44304, 0, 0, 0, 0, 187, 125);
INSERT INTO public.who_global_data VALUES (44305, 6, 1182, 0, 4, 187, 124);
INSERT INTO public.who_global_data VALUES (44306, 990, 73158, 13, 1738, 187, 185);
INSERT INTO public.who_global_data VALUES (44307, 239, 60999, 0, 351, 187, 194);
INSERT INTO public.who_global_data VALUES (44308, 0, 509, 0, 21, 187, 144);
INSERT INTO public.who_global_data VALUES (44309, 58388, 4582276, 1127, 153757, 187, 19);
INSERT INTO public.who_global_data VALUES (44310, 17, 438, 0, 8, 187, 217);
INSERT INTO public.who_global_data VALUES (44311, 13, 1278, 0, 35, 187, 148);
INSERT INTO public.who_global_data VALUES (44312, 788, 25828, 6, 155, 187, 86);
INSERT INTO public.who_global_data VALUES (44313, 0, 0, 0, 0, 187, 13);
INSERT INTO public.who_global_data VALUES (44314, 869, 19443, 5, 169, 187, 157);
INSERT INTO public.who_global_data VALUES (44315, 31, 621, 3, 6, 187, 8);
INSERT INTO public.who_global_data VALUES (44316, 0, 0, 0, 0, 187, 73);
INSERT INTO public.who_global_data VALUES (44317, 4, 1738, 3, 498, 187, 101);
INSERT INTO public.who_global_data VALUES (44318, 119, 6347, 5, 170, 187, 165);
INSERT INTO public.who_global_data VALUES (44319, 262, 3921, 1, 70, 187, 14);
INSERT INTO public.who_global_data VALUES (44320, 0, 36796, 0, 1287, 188, 193);
INSERT INTO public.who_global_data VALUES (44321, 120, 5396, 4, 161, 188, 113);
INSERT INTO public.who_global_data VALUES (44322, 556, 30950, 13, 1223, 188, 143);
INSERT INTO public.who_global_data VALUES (44323, 0, 0, 0, 0, 188, 219);
INSERT INTO public.who_global_data VALUES (44324, 5, 930, 0, 52, 188, 186);
INSERT INTO public.who_global_data VALUES (44325, 39, 1148, 1, 52, 188, 52);
INSERT INTO public.who_global_data VALUES (44326, 0, 3, 0, 0, 188, 180);
INSERT INTO public.who_global_data VALUES (44327, 0, 91, 0, 3, 188, 167);
INSERT INTO public.who_global_data VALUES (44328, 5929, 191302, 77, 3543, 188, 154);
INSERT INTO public.who_global_data VALUES (44329, 209, 38363, 5, 749, 188, 94);
INSERT INTO public.who_global_data VALUES (44330, 0, 120, 0, 3, 188, 66);
INSERT INTO public.who_global_data VALUES (44331, 377, 17282, 4, 200, 188, 58);
INSERT INTO public.who_global_data VALUES (44332, 126, 21224, 0, 718, 188, 163);
INSERT INTO public.who_global_data VALUES (44333, 279, 32157, 6, 454, 188, 37);
INSERT INTO public.who_global_data VALUES (44334, 0, 508, 0, 14, 188, 142);
INSERT INTO public.who_global_data VALUES (44335, 208, 41190, 0, 147, 188, 83);
INSERT INTO public.who_global_data VALUES (44336, 2199, 239860, 21, 3132, 188, 228);
INSERT INTO public.who_global_data VALUES (44337, 0, 110, 0, 7, 188, 188);
INSERT INTO public.who_global_data VALUES (44338, 138, 67946, 4, 563, 188, 62);
INSERT INTO public.who_global_data VALUES (44339, 309, 70683, 2, 9704, 188, 160);
INSERT INTO public.who_global_data VALUES (44340, 0, 48, 0, 2, 188, 50);
INSERT INTO public.who_global_data VALUES (44341, 0, 1805, 0, 36, 188, 33);
INSERT INTO public.who_global_data VALUES (44342, 0, 156, 0, 9, 188, 183);
INSERT INTO public.who_global_data VALUES (44343, 1, 102, 0, 0, 188, 92);
INSERT INTO public.who_global_data VALUES (44344, 1555, 76789, 83, 2977, 188, 158);
INSERT INTO public.who_global_data VALUES (44345, 0, 5, 0, 0, 188, 67);
INSERT INTO public.who_global_data VALUES (44346, 666, 12108, 19, 343, 188, 57);
INSERT INTO public.who_global_data VALUES (44347, 0, 804, 0, 2, 188, 38);
INSERT INTO public.who_global_data VALUES (44348, 52383, 2662485, 1212, 92475, 188, 141);
INSERT INTO public.who_global_data VALUES (44349, 0, 8, 0, 1, 188, 178);
INSERT INTO public.who_global_data VALUES (44350, 0, 141, 0, 3, 188, 108);
INSERT INTO public.who_global_data VALUES (44351, 146, 11836, 2, 385, 188, 39);
INSERT INTO public.who_global_data VALUES (44352, 5, 1143, 0, 53, 188, 2);
INSERT INTO public.who_global_data VALUES (44353, 0, 387, 0, 1, 188, 195);
INSERT INTO public.who_global_data VALUES (44354, 29, 2480, 1, 24, 188, 107);
INSERT INTO public.who_global_data VALUES (44355, 1, 240, 0, 0, 188, 161);
INSERT INTO public.who_global_data VALUES (44356, 0, 17255, 0, 391, 188, 212);
INSERT INTO public.who_global_data VALUES (44357, 513, 116312, 6, 8935, 188, 181);
INSERT INTO public.who_global_data VALUES (44358, 0, 203, 0, 1, 188, 53);
INSERT INTO public.who_global_data VALUES (44359, 6, 4614, 0, 59, 188, 164);
INSERT INTO public.who_global_data VALUES (44360, 0, 936, 0, 75, 188, 140);
INSERT INTO public.who_global_data VALUES (44361, 1991, 357658, 76, 9533, 188, 20);
INSERT INTO public.who_global_data VALUES (44362, 180, 88302, 6, 4674, 188, 112);
INSERT INTO public.who_global_data VALUES (44363, 9488, 295508, 295, 10105, 188, 111);
INSERT INTO public.who_global_data VALUES (44364, 0, 382, 0, 7, 188, 71);
INSERT INTO public.who_global_data VALUES (44365, 11, 3387, 0, 56, 188, 218);
INSERT INTO public.who_global_data VALUES (44366, 0, 0, 0, 0, 188, 43);
INSERT INTO public.who_global_data VALUES (44367, 530, 17820, 10, 150, 188, 49);
INSERT INTO public.who_global_data VALUES (44368, 62, 16109, 0, 102, 188, 1);
INSERT INTO public.who_global_data VALUES (44369, 86, 5224, 0, 145, 188, 48);
INSERT INTO public.who_global_data VALUES (44370, 25, 2633, 0, 87, 188, 232);
INSERT INTO public.who_global_data VALUES (44371, 0, 29, 0, 1, 188, 175);
INSERT INTO public.who_global_data VALUES (44372, 10, 1124, 0, 19, 188, 21);
INSERT INTO public.who_global_data VALUES (44373, 125, 16699, 1, 383, 188, 156);
INSERT INTO public.who_global_data VALUES (44374, 0, 0, 0, 0, 188, 95);
INSERT INTO public.who_global_data VALUES (44375, 0, 9069, 0, 214, 188, 177);
INSERT INTO public.who_global_data VALUES (44376, 0, 13789, 0, 615, 188, 210);
INSERT INTO public.who_global_data VALUES (44377, 0, 5081, 0, 58, 188, 120);
INSERT INTO public.who_global_data VALUES (44378, 0, 18, 0, 0, 188, 135);
INSERT INTO public.who_global_data VALUES (44379, 1766, 71415, 10, 1170, 188, 206);
INSERT INTO public.who_global_data VALUES (44380, 877, 86232, 34, 5736, 188, 189);
INSERT INTO public.who_global_data VALUES (44381, 238, 94316, 29, 4834, 188, 129);
INSERT INTO public.who_global_data VALUES (44382, 418, 17050, 11, 459, 188, 121);
INSERT INTO public.who_global_data VALUES (44383, 0, 4821, 0, 83, 188, 59);
INSERT INTO public.who_global_data VALUES (44384, 0, 279, 0, 0, 188, 96);
INSERT INTO public.who_global_data VALUES (44385, 8, 2072, 0, 63, 188, 41);
INSERT INTO public.who_global_data VALUES (44386, 58, 2706, 2, 42, 188, 216);
INSERT INTO public.who_global_data VALUES (44387, 469, 17999, 10, 284, 188, 236);
INSERT INTO public.who_global_data VALUES (44388, 0, 13, 0, 0, 188, 150);
INSERT INTO public.who_global_data VALUES (44389, 0, 225, 0, 0, 188, 61);
INSERT INTO public.who_global_data VALUES (44390, 0, 27, 0, 1, 188, 7);
INSERT INTO public.who_global_data VALUES (44391, 11, 7443, 0, 329, 188, 169);
INSERT INTO public.who_global_data VALUES (44392, 0, 175920, 0, 30147, 188, 28);
INSERT INTO public.who_global_data VALUES (44393, 58, 7857, 0, 43, 188, 85);
INSERT INTO public.who_global_data VALUES (44394, 0, 62, 0, 0, 188, 211);
INSERT INTO public.who_global_data VALUES (44395, 179, 7531, 1, 50, 188, 60);
INSERT INTO public.who_global_data VALUES (44396, 0, 498, 0, 9, 188, 3);
INSERT INTO public.who_global_data VALUES (44397, 6, 1177, 0, 17, 188, 11);
INSERT INTO public.who_global_data VALUES (44398, 240, 209893, 0, 9141, 188, 89);
INSERT INTO public.who_global_data VALUES (44399, 0, 35501, 0, 182, 188, 24);
INSERT INTO public.who_global_data VALUES (44400, 0, 187, 0, 0, 188, 162);
INSERT INTO public.who_global_data VALUES (44401, 110, 4587, 0, 206, 188, 100);
INSERT INTO public.who_global_data VALUES (44402, 0, 14, 0, 0, 188, 47);
INSERT INTO public.who_global_data VALUES (44403, 0, 24, 0, 0, 188, 29);
INSERT INTO public.who_global_data VALUES (44404, 21, 265, 0, 14, 188, 40);
INSERT INTO public.who_global_data VALUES (44405, 0, 351, 0, 5, 188, 222);
INSERT INTO public.who_global_data VALUES (44406, 1190, 50979, 33, 1957, 188, 132);
INSERT INTO public.who_global_data VALUES (44407, 0, 252, 0, 13, 188, 130);
INSERT INTO public.who_global_data VALUES (44408, 0, 7308, 0, 46, 188, 234);
INSERT INTO public.who_global_data VALUES (44409, 0, 1981, 0, 27, 188, 23);
INSERT INTO public.who_global_data VALUES (44410, 12, 413, 0, 20, 188, 192);
INSERT INTO public.who_global_data VALUES (44411, 12, 7424, 0, 161, 188, 69);
INSERT INTO public.who_global_data VALUES (44412, 0, 12, 0, 0, 188, 187);
INSERT INTO public.who_global_data VALUES (44413, 588, 42014, 25, 1337, 188, 230);
INSERT INTO public.who_global_data VALUES (44414, 21, 4526, 1, 597, 188, 77);
INSERT INTO public.who_global_data VALUES (44415, 8, 1893, 0, 10, 188, 9);
INSERT INTO public.who_global_data VALUES (44416, 54735, 1750723, 853, 37364, 188, 74);
INSERT INTO public.who_global_data VALUES (44417, 1560, 109936, 62, 5193, 188, 224);
INSERT INTO public.who_global_data VALUES (44418, 2548, 306752, 216, 16982, 188, 199);
INSERT INTO public.who_global_data VALUES (44419, 2095, 126704, 64, 4805, 188, 190);
INSERT INTO public.who_global_data VALUES (44420, 44, 26109, 0, 1763, 188, 12);
INSERT INTO public.who_global_data VALUES (44421, 0, 336, 0, 24, 188, 104);
INSERT INTO public.who_global_data VALUES (44422, 1362, 71744, 14, 564, 188, 153);
INSERT INTO public.who_global_data VALUES (44423, 295, 247832, 5, 35146, 188, 91);
INSERT INTO public.who_global_data VALUES (44424, 14, 878, 0, 10, 188, 215);
INSERT INTO public.who_global_data VALUES (44425, 853, 36689, 0, 1011, 188, 84);
INSERT INTO public.who_global_data VALUES (44426, 0, 335, 0, 31, 188, 231);
INSERT INTO public.who_global_data VALUES (44427, 15, 1276, 0, 11, 188, 196);
INSERT INTO public.who_global_data VALUES (44428, 1867, 98641, 286, 1109, 188, 105);
INSERT INTO public.who_global_data VALUES (44429, 727, 21363, 23, 364, 188, 122);
INSERT INTO public.who_global_data VALUES (44430, 0, 0, 0, 0, 188, 159);
INSERT INTO public.who_global_data VALUES (44431, 224, 8511, 10, 227, 188, 75);
INSERT INTO public.who_global_data VALUES (44432, 491, 67448, 6, 453, 188, 27);
INSERT INTO public.who_global_data VALUES (44433, 420, 36719, 12, 964, 188, 54);
INSERT INTO public.who_global_data VALUES (44434, 0, 20, 0, 0, 188, 226);
INSERT INTO public.who_global_data VALUES (44435, 7, 1238, 0, 32, 188, 79);
INSERT INTO public.who_global_data VALUES (44436, 175, 4730, 2, 61, 188, 56);
INSERT INTO public.who_global_data VALUES (44437, 98, 702, 1, 14, 188, 117);
INSERT INTO public.who_global_data VALUES (44438, 3, 1189, 0, 75, 188, 152);
INSERT INTO public.who_global_data VALUES (44439, 70, 3691, 6, 80, 188, 16);
INSERT INTO public.who_global_data VALUES (44440, 0, 89, 0, 1, 188, 10);
INSERT INTO public.who_global_data VALUES (44441, 17, 2104, 0, 80, 188, 201);
INSERT INTO public.who_global_data VALUES (44442, 0, 6695, 0, 114, 188, 174);
INSERT INTO public.who_global_data VALUES (44443, 405, 11273, 1, 107, 188, 119);
INSERT INTO public.who_global_data VALUES (44444, 108, 4186, 6, 120, 188, 168);
INSERT INTO public.who_global_data VALUES (44445, 9, 8985, 0, 125, 188, 99);
INSERT INTO public.who_global_data VALUES (44446, 156, 3949, 1, 17, 188, 171);
INSERT INTO public.who_global_data VALUES (44447, 13, 2535, 0, 124, 188, 87);
INSERT INTO public.who_global_data VALUES (44448, 15, 769, 0, 9, 188, 123);
INSERT INTO public.who_global_data VALUES (44449, 0, 0, 0, 0, 188, 151);
INSERT INTO public.who_global_data VALUES (44450, 0, 269, 0, 15, 188, 213);
INSERT INTO public.who_global_data VALUES (44451, 0, 6310, 0, 157, 188, 118);
INSERT INTO public.who_global_data VALUES (44452, 0, 344, 0, 10, 188, 134);
INSERT INTO public.who_global_data VALUES (44453, 0, 2962, 0, 39, 188, 65);
INSERT INTO public.who_global_data VALUES (44454, 8458, 424637, 688, 46688, 188, 102);
INSERT INTO public.who_global_data VALUES (44455, 0, 0, 0, 0, 188, 223);
INSERT INTO public.who_global_data VALUES (44456, 0, 87, 0, 1, 188, 4);
INSERT INTO public.who_global_data VALUES (44457, 0, 291, 0, 0, 188, 146);
INSERT INTO public.who_global_data VALUES (44458, 27, 3278, 0, 51, 188, 31);
INSERT INTO public.who_global_data VALUES (44459, 0, 13, 0, 1, 188, 127);
INSERT INTO public.who_global_data VALUES (44460, 729, 25051, 14, 367, 188, 22);
INSERT INTO public.who_global_data VALUES (44461, 43, 1907, 1, 12, 188, 115);
INSERT INTO public.who_global_data VALUES (44462, 0, 353, 0, 6, 188, 106);
INSERT INTO public.who_global_data VALUES (44463, 95, 2224, 1, 11, 188, 90);
INSERT INTO public.who_global_data VALUES (44464, 0, 0, 0, 0, 188, 70);
INSERT INTO public.who_global_data VALUES (44465, 315, 20086, 0, 56, 188, 46);
INSERT INTO public.who_global_data VALUES (44466, 431, 54674, 1, 6146, 188, 139);
INSERT INTO public.who_global_data VALUES (44467, 0, 22, 0, 0, 188, 42);
INSERT INTO public.who_global_data VALUES (44468, 3, 1215, 0, 22, 188, 80);
INSERT INTO public.who_global_data VALUES (44469, 0, 3080, 0, 116, 188, 203);
INSERT INTO public.who_global_data VALUES (44470, 0, 1136, 0, 69, 188, 136);
INSERT INTO public.who_global_data VALUES (44471, 386, 43537, 4, 883, 188, 63);
INSERT INTO public.who_global_data VALUES (44472, 0, 0, 0, 0, 188, 17);
INSERT INTO public.who_global_data VALUES (44473, 2, 44, 0, 2, 188, 172);
INSERT INTO public.who_global_data VALUES (44474, 138, 10900, 7, 493, 188, 109);
INSERT INTO public.who_global_data VALUES (44475, 0, 9208, 0, 255, 188, 200);
INSERT INTO public.who_global_data VALUES (44476, 323, 15555, 1, 86, 188, 93);
INSERT INTO public.who_global_data VALUES (44477, 0, 79159, 0, 421, 188, 5);
INSERT INTO public.who_global_data VALUES (44478, 0, 741, 0, 13, 188, 214);
INSERT INTO public.who_global_data VALUES (44479, 553, 279699, 6, 5976, 188, 204);
INSERT INTO public.who_global_data VALUES (44480, 0, 0, 0, 0, 188, 198);
INSERT INTO public.who_global_data VALUES (44481, 1065, 65256, 24, 1421, 188, 173);
INSERT INTO public.who_global_data VALUES (44482, 19, 91, 0, 2, 188, 229);
INSERT INTO public.who_global_data VALUES (44483, 131, 5338, 2, 49, 188, 76);
INSERT INTO public.who_global_data VALUES (44484, 0, 407492, 0, 19021, 188, 138);
INSERT INTO public.who_global_data VALUES (44485, 4878, 98232, 16, 2039, 188, 98);
INSERT INTO public.who_global_data VALUES (44486, 0, 0, 0, 0, 188, 103);
INSERT INTO public.who_global_data VALUES (44487, 658, 46346, 5, 1721, 188, 225);
INSERT INTO public.who_global_data VALUES (44488, 238, 51310, 2, 1737, 188, 131);
INSERT INTO public.who_global_data VALUES (44489, 1091, 17872, 6, 225, 188, 235);
INSERT INTO public.who_global_data VALUES (44490, 216, 110911, 0, 174, 188, 137);
INSERT INTO public.who_global_data VALUES (44491, 30, 14366, 0, 301, 188, 81);
INSERT INTO public.who_global_data VALUES (44492, 380, 25113, 11, 789, 188, 182);
INSERT INTO public.who_global_data VALUES (44493, 4, 664, 0, 4, 188, 145);
INSERT INTO public.who_global_data VALUES (44494, 1225, 52111, 36, 2379, 188, 26);
INSERT INTO public.who_global_data VALUES (44495, 5427, 850870, 70, 14128, 188, 170);
INSERT INTO public.who_global_data VALUES (44496, 20, 2042, 0, 5, 188, 191);
INSERT INTO public.who_global_data VALUES (44497, 0, 3, 0, 0, 188, 221);
INSERT INTO public.who_global_data VALUES (44498, 0, 8, 0, 0, 188, 64);
INSERT INTO public.who_global_data VALUES (44499, 0, 0, 0, 0, 188, 116);
INSERT INTO public.who_global_data VALUES (44500, 0, 17, 0, 0, 188, 128);
INSERT INTO public.who_global_data VALUES (44501, 0, 25, 0, 0, 188, 6);
INSERT INTO public.who_global_data VALUES (44502, 0, 53, 0, 3, 188, 227);
INSERT INTO public.who_global_data VALUES (44503, 0, 4, 0, 0, 188, 68);
INSERT INTO public.who_global_data VALUES (44504, 0, 54, 0, 0, 188, 184);
INSERT INTO public.who_global_data VALUES (44505, 0, 0, 0, 0, 188, 82);
INSERT INTO public.who_global_data VALUES (44506, 0, 716, 0, 42, 188, 149);
INSERT INTO public.who_global_data VALUES (44507, 3, 874, 0, 15, 188, 197);
INSERT INTO public.who_global_data VALUES (44508, 1573, 277478, 21, 2887, 188, 78);
INSERT INTO public.who_global_data VALUES (44509, 52, 10284, 4, 209, 188, 233);
INSERT INTO public.who_global_data VALUES (44510, 330, 25882, 9, 582, 188, 133);
INSERT INTO public.who_global_data VALUES (44511, 0, 114, 0, 0, 188, 35);
INSERT INTO public.who_global_data VALUES (44512, 12, 1835, 0, 67, 188, 114);
INSERT INTO public.who_global_data VALUES (44513, 307, 52512, 0, 27, 188, 237);
INSERT INTO public.who_global_data VALUES (44514, 0, 3, 0, 0, 188, 55);
INSERT INTO public.who_global_data VALUES (44515, 0, 128, 0, 15, 188, 176);
INSERT INTO public.who_global_data VALUES (44516, 45, 2337, 0, 29, 188, 202);
INSERT INTO public.who_global_data VALUES (44517, 9, 2181, 1, 122, 188, 155);
INSERT INTO public.who_global_data VALUES (44518, 0, 0, 0, 0, 188, 32);
INSERT INTO public.who_global_data VALUES (44519, 0, 3212, 0, 93, 188, 220);
INSERT INTO public.who_global_data VALUES (44520, 10107, 503290, 148, 8153, 188, 30);
INSERT INTO public.who_global_data VALUES (44521, 77, 2429, 0, 46, 188, 147);
INSERT INTO public.who_global_data VALUES (44522, 4017, 308137, 15, 29910, 188, 208);
INSERT INTO public.who_global_data VALUES (44523, 0, 2815, 0, 11, 188, 45);
INSERT INTO public.who_global_data VALUES (44524, 94, 11738, 6, 752, 188, 110);
INSERT INTO public.who_global_data VALUES (44525, 56, 1706, 0, 26, 188, 88);
INSERT INTO public.who_global_data VALUES (44526, 258, 76941, 2, 5760, 188, 51);
INSERT INTO public.who_global_data VALUES (44527, 97, 35544, 1, 1740, 188, 209);
INSERT INTO public.who_global_data VALUES (44528, 23, 780, 0, 43, 188, 205);
INSERT INTO public.who_global_data VALUES (44529, 42, 7451, 0, 60, 188, 18);
INSERT INTO public.who_global_data VALUES (44530, 5, 3317, 0, 58, 188, 72);
INSERT INTO public.who_global_data VALUES (44531, 771, 303956, 13, 41202, 188, 44);
INSERT INTO public.who_global_data VALUES (44532, 0, 24, 0, 0, 188, 15);
INSERT INTO public.who_global_data VALUES (44533, 0, 927, 0, 18, 188, 25);
INSERT INTO public.who_global_data VALUES (44534, 0, 0, 0, 0, 188, 179);
INSERT INTO public.who_global_data VALUES (44535, 0, 0, 0, 0, 188, 34);
INSERT INTO public.who_global_data VALUES (44536, 4, 173, 0, 8, 188, 207);
INSERT INTO public.who_global_data VALUES (44537, 9, 1561, 0, 51, 188, 166);
INSERT INTO public.who_global_data VALUES (44538, 7726, 265519, 19, 5710, 188, 126);
INSERT INTO public.who_global_data VALUES (44539, 0, 0, 0, 0, 188, 97);
INSERT INTO public.who_global_data VALUES (44540, 7, 114, 0, 2, 188, 36);
INSERT INTO public.who_global_data VALUES (44541, 0, 0, 0, 0, 188, 125);
INSERT INTO public.who_global_data VALUES (44542, 22, 1176, 1, 4, 188, 124);
INSERT INTO public.who_global_data VALUES (44543, 1112, 72168, 16, 1725, 188, 185);
INSERT INTO public.who_global_data VALUES (44544, 254, 60760, 0, 351, 188, 194);
INSERT INTO public.who_global_data VALUES (44545, 0, 509, 0, 21, 188, 144);
INSERT INTO public.who_global_data VALUES (44546, 67499, 4523888, 1365, 152630, 188, 19);
INSERT INTO public.who_global_data VALUES (44547, 15, 421, 0, 8, 188, 217);
INSERT INTO public.who_global_data VALUES (44548, 22, 1265, 0, 35, 188, 148);
INSERT INTO public.who_global_data VALUES (44549, 736, 25040, 6, 149, 188, 86);
INSERT INTO public.who_global_data VALUES (44550, 0, 0, 0, 0, 188, 13);
INSERT INTO public.who_global_data VALUES (44551, 715, 18574, 6, 164, 188, 157);
INSERT INTO public.who_global_data VALUES (44552, 32, 590, 1, 3, 188, 8);
INSERT INTO public.who_global_data VALUES (44553, 0, 0, 0, 0, 188, 73);
INSERT INTO public.who_global_data VALUES (44554, 2, 1734, 1, 495, 188, 101);
INSERT INTO public.who_global_data VALUES (44555, 265, 6228, 14, 165, 188, 165);
INSERT INTO public.who_global_data VALUES (44556, 490, 3659, 2, 69, 188, 14);
INSERT INTO public.who_global_data VALUES (44557, 168, 36796, 12, 1287, 189, 193);
INSERT INTO public.who_global_data VALUES (44558, 79, 5276, 3, 157, 189, 113);
INSERT INTO public.who_global_data VALUES (44559, 563, 30394, 10, 1210, 189, 143);
INSERT INTO public.who_global_data VALUES (44560, 0, 0, 0, 0, 189, 219);
INSERT INTO public.who_global_data VALUES (44561, 3, 925, 0, 52, 189, 186);
INSERT INTO public.who_global_data VALUES (44562, 0, 1109, 0, 51, 189, 52);
INSERT INTO public.who_global_data VALUES (44563, 0, 3, 0, 0, 189, 180);
INSERT INTO public.who_global_data VALUES (44564, 0, 91, 0, 3, 189, 167);
INSERT INTO public.who_global_data VALUES (44565, 6377, 185373, 155, 3466, 189, 154);
INSERT INTO public.who_global_data VALUES (44566, 291, 38154, 11, 744, 189, 94);
INSERT INTO public.who_global_data VALUES (44567, 1, 120, 0, 3, 189, 66);
INSERT INTO public.who_global_data VALUES (44568, 602, 16905, 7, 196, 189, 58);
INSERT INTO public.who_global_data VALUES (44569, 89, 21098, 0, 718, 189, 163);
INSERT INTO public.who_global_data VALUES (44570, 318, 31878, 7, 448, 189, 37);
INSERT INTO public.who_global_data VALUES (44571, 24, 508, 3, 14, 189, 142);
INSERT INTO public.who_global_data VALUES (44572, 227, 40982, 1, 147, 189, 83);
INSERT INTO public.who_global_data VALUES (44573, 2772, 237661, 28, 3111, 189, 228);
INSERT INTO public.who_global_data VALUES (44574, 0, 110, 0, 7, 189, 188);
INSERT INTO public.who_global_data VALUES (44575, 0, 67808, 0, 559, 189, 62);
INSERT INTO public.who_global_data VALUES (44576, 684, 70374, 3, 9702, 189, 160);
INSERT INTO public.who_global_data VALUES (44577, 0, 48, 0, 2, 189, 50);
INSERT INTO public.who_global_data VALUES (44578, 0, 1805, 0, 36, 189, 33);
INSERT INTO public.who_global_data VALUES (44579, 0, 156, 0, 9, 189, 183);
INSERT INTO public.who_global_data VALUES (44580, 0, 101, 0, 0, 189, 92);
INSERT INTO public.who_global_data VALUES (44581, 1700, 75234, 86, 2894, 189, 158);
INSERT INTO public.who_global_data VALUES (44582, 0, 5, 0, 0, 189, 67);
INSERT INTO public.who_global_data VALUES (44583, 0, 11442, 0, 324, 189, 57);
INSERT INTO public.who_global_data VALUES (44584, 0, 804, 0, 2, 189, 38);
INSERT INTO public.who_global_data VALUES (44585, 57837, 2610102, 1129, 91263, 189, 141);
INSERT INTO public.who_global_data VALUES (44586, 0, 8, 0, 1, 189, 178);
INSERT INTO public.who_global_data VALUES (44587, 0, 141, 0, 3, 189, 108);
INSERT INTO public.who_global_data VALUES (44588, 270, 11690, 9, 383, 189, 39);
INSERT INTO public.who_global_data VALUES (44589, 21, 1138, 0, 53, 189, 2);
INSERT INTO public.who_global_data VALUES (44590, 0, 387, 0, 1, 189, 195);
INSERT INTO public.who_global_data VALUES (44591, 33, 2451, 0, 23, 189, 107);
INSERT INTO public.who_global_data VALUES (44592, 5, 239, 0, 0, 189, 161);
INSERT INTO public.who_global_data VALUES (44593, 0, 17255, 0, 391, 189, 212);
INSERT INTO public.who_global_data VALUES (44594, 329, 115799, 12, 8929, 189, 181);
INSERT INTO public.who_global_data VALUES (44595, 0, 203, 0, 1, 189, 53);
INSERT INTO public.who_global_data VALUES (44596, 3, 4608, 0, 59, 189, 164);
INSERT INTO public.who_global_data VALUES (44597, 1, 936, 0, 75, 189, 140);
INSERT INTO public.who_global_data VALUES (44598, 2131, 355667, 80, 9457, 189, 20);
INSERT INTO public.who_global_data VALUES (44599, 166, 88122, 2, 4668, 189, 112);
INSERT INTO public.who_global_data VALUES (44600, 9965, 286020, 356, 9810, 189, 111);
INSERT INTO public.who_global_data VALUES (44601, 0, 382, 0, 7, 189, 71);
INSERT INTO public.who_global_data VALUES (44602, 0, 3376, 0, 56, 189, 218);
INSERT INTO public.who_global_data VALUES (44603, 0, 0, 0, 0, 189, 43);
INSERT INTO public.who_global_data VALUES (44604, 490, 17290, 7, 140, 189, 49);
INSERT INTO public.who_global_data VALUES (44605, 69, 16047, 2, 102, 189, 1);
INSERT INTO public.who_global_data VALUES (44606, 67, 5138, 1, 145, 189, 48);
INSERT INTO public.who_global_data VALUES (44607, 11, 2608, 0, 87, 189, 232);
INSERT INTO public.who_global_data VALUES (44608, 0, 29, 0, 1, 189, 175);
INSERT INTO public.who_global_data VALUES (44609, 30, 1114, 0, 19, 189, 21);
INSERT INTO public.who_global_data VALUES (44610, 232, 16574, 3, 382, 189, 156);
INSERT INTO public.who_global_data VALUES (44611, 0, 0, 0, 0, 189, 95);
INSERT INTO public.who_global_data VALUES (44612, 60, 9069, 0, 214, 189, 177);
INSERT INTO public.who_global_data VALUES (44613, 64, 13789, 0, 615, 189, 210);
INSERT INTO public.who_global_data VALUES (44614, 0, 5081, 0, 58, 189, 120);
INSERT INTO public.who_global_data VALUES (44615, 0, 18, 0, 0, 189, 135);
INSERT INTO public.who_global_data VALUES (44616, 1734, 69649, 14, 1160, 189, 206);
INSERT INTO public.who_global_data VALUES (44617, 985, 85355, 45, 5702, 189, 189);
INSERT INTO public.who_global_data VALUES (44618, 321, 94078, 31, 4805, 189, 129);
INSERT INTO public.who_global_data VALUES (44619, 402, 16632, 9, 448, 189, 121);
INSERT INTO public.who_global_data VALUES (44620, 2471, 4821, 42, 83, 189, 59);
INSERT INTO public.who_global_data VALUES (44621, 0, 279, 0, 0, 189, 96);
INSERT INTO public.who_global_data VALUES (44622, 13, 2064, 0, 63, 189, 41);
INSERT INTO public.who_global_data VALUES (44623, 71, 2648, 0, 40, 189, 216);
INSERT INTO public.who_global_data VALUES (44624, 915, 17530, 11, 274, 189, 236);
INSERT INTO public.who_global_data VALUES (44625, 0, 13, 0, 0, 189, 150);
INSERT INTO public.who_global_data VALUES (44626, 5, 225, 0, 0, 189, 61);
INSERT INTO public.who_global_data VALUES (44627, 0, 27, 1, 1, 189, 7);
INSERT INTO public.who_global_data VALUES (44628, 9, 7432, 0, 329, 189, 169);
INSERT INTO public.who_global_data VALUES (44629, 1272, 175920, 11, 30147, 189, 28);
INSERT INTO public.who_global_data VALUES (44630, 71, 7799, 0, 43, 189, 85);
INSERT INTO public.who_global_data VALUES (44631, 0, 62, 0, 0, 189, 211);
INSERT INTO public.who_global_data VALUES (44632, 0, 7352, 0, 49, 189, 60);
INSERT INTO public.who_global_data VALUES (44633, 95, 498, 1, 9, 189, 3);
INSERT INTO public.who_global_data VALUES (44634, 3, 1171, 0, 17, 189, 11);
INSERT INTO public.who_global_data VALUES (44635, 955, 209653, 0, 9141, 189, 89);
INSERT INTO public.who_global_data VALUES (44636, 359, 35501, 7, 182, 189, 24);
INSERT INTO public.who_global_data VALUES (44637, 1, 187, 0, 0, 189, 162);
INSERT INTO public.who_global_data VALUES (44638, 76, 4477, 3, 206, 189, 100);
INSERT INTO public.who_global_data VALUES (44639, 0, 14, 0, 0, 189, 47);
INSERT INTO public.who_global_data VALUES (44640, 0, 24, 0, 0, 189, 29);
INSERT INTO public.who_global_data VALUES (44641, 0, 244, 0, 14, 189, 40);
INSERT INTO public.who_global_data VALUES (44642, 3, 351, 0, 5, 189, 222);
INSERT INTO public.who_global_data VALUES (44643, 963, 49789, 57, 1924, 189, 132);
INSERT INTO public.who_global_data VALUES (44644, 0, 252, 0, 13, 189, 130);
INSERT INTO public.who_global_data VALUES (44645, 66, 7308, 0, 46, 189, 234);
INSERT INTO public.who_global_data VALUES (44646, 0, 1981, 1, 27, 189, 23);
INSERT INTO public.who_global_data VALUES (44647, 3, 401, 0, 20, 189, 192);
INSERT INTO public.who_global_data VALUES (44648, 34, 7412, 2, 161, 189, 69);
INSERT INTO public.who_global_data VALUES (44649, 0, 12, 0, 0, 189, 187);
INSERT INTO public.who_global_data VALUES (44650, 482, 41426, 53, 1312, 189, 230);
INSERT INTO public.who_global_data VALUES (44651, 0, 4505, 0, 596, 189, 77);
INSERT INTO public.who_global_data VALUES (44652, 13, 1885, 0, 10, 189, 9);
INSERT INTO public.who_global_data VALUES (44653, 57118, 1695988, 764, 36511, 189, 74);
INSERT INTO public.who_global_data VALUES (44654, 2040, 108376, 73, 5131, 189, 224);
INSERT INTO public.who_global_data VALUES (44655, 2674, 304204, 197, 16766, 189, 199);
INSERT INTO public.who_global_data VALUES (44656, 3346, 124609, 70, 4741, 189, 190);
INSERT INTO public.who_global_data VALUES (44657, 38, 26065, 0, 1763, 189, 12);
INSERT INTO public.who_global_data VALUES (44658, 0, 336, 0, 24, 189, 104);
INSERT INTO public.who_global_data VALUES (44659, 1787, 70382, 15, 550, 189, 153);
INSERT INTO public.who_global_data VALUES (44660, 379, 247537, 9, 35141, 189, 91);
INSERT INTO public.who_global_data VALUES (44661, 8, 864, 0, 10, 189, 215);
INSERT INTO public.who_global_data VALUES (44662, 1464, 35836, 5, 1011, 189, 84);
INSERT INTO public.who_global_data VALUES (44663, 0, 335, 0, 31, 189, 231);
INSERT INTO public.who_global_data VALUES (44664, 2, 1261, 0, 11, 189, 196);
INSERT INTO public.who_global_data VALUES (44665, 6407, 96774, 30, 823, 189, 105);
INSERT INTO public.who_global_data VALUES (44666, 723, 20636, 16, 341, 189, 122);
INSERT INTO public.who_global_data VALUES (44667, 0, 0, 0, 0, 189, 159);
INSERT INTO public.who_global_data VALUES (44668, 226, 8287, 15, 217, 189, 75);
INSERT INTO public.who_global_data VALUES (44669, 428, 66957, 2, 447, 189, 27);
INSERT INTO public.who_global_data VALUES (44670, 494, 36299, 19, 952, 189, 54);
INSERT INTO public.who_global_data VALUES (44671, 0, 20, 0, 0, 189, 226);
INSERT INTO public.who_global_data VALUES (44672, 3, 1231, 1, 32, 189, 79);
INSERT INTO public.who_global_data VALUES (44673, 221, 4555, 2, 59, 189, 56);
INSERT INTO public.who_global_data VALUES (44674, 0, 604, 0, 13, 189, 117);
INSERT INTO public.who_global_data VALUES (44675, 5, 1186, 2, 75, 189, 152);
INSERT INTO public.who_global_data VALUES (44676, 183, 3621, 1, 74, 189, 16);
INSERT INTO public.who_global_data VALUES (44677, 0, 89, 0, 1, 189, 10);
INSERT INTO public.who_global_data VALUES (44678, 18, 2087, 0, 80, 189, 201);
INSERT INTO public.who_global_data VALUES (44679, 79, 6695, 0, 114, 189, 174);
INSERT INTO public.who_global_data VALUES (44680, 120, 10868, 1, 106, 189, 119);
INSERT INTO public.who_global_data VALUES (44681, 97, 4078, 5, 114, 189, 168);
INSERT INTO public.who_global_data VALUES (44682, 12, 8976, 1, 125, 189, 99);
INSERT INTO public.who_global_data VALUES (44683, 74, 3793, 0, 16, 189, 171);
INSERT INTO public.who_global_data VALUES (44684, 0, 2522, 0, 124, 189, 87);
INSERT INTO public.who_global_data VALUES (44685, 18, 754, 0, 9, 189, 123);
INSERT INTO public.who_global_data VALUES (44686, 0, 0, 0, 0, 189, 151);
INSERT INTO public.who_global_data VALUES (44687, 0, 269, 0, 15, 189, 213);
INSERT INTO public.who_global_data VALUES (44688, 40, 6310, 1, 157, 189, 118);
INSERT INTO public.who_global_data VALUES (44689, 0, 344, 0, 10, 189, 134);
INSERT INTO public.who_global_data VALUES (44690, 0, 2962, 0, 39, 189, 65);
INSERT INTO public.who_global_data VALUES (44691, 7730, 416179, 639, 46000, 189, 102);
INSERT INTO public.who_global_data VALUES (44692, 0, 0, 0, 0, 189, 223);
INSERT INTO public.who_global_data VALUES (44693, 0, 87, 0, 1, 189, 4);
INSERT INTO public.who_global_data VALUES (44694, 0, 291, 0, 0, 189, 146);
INSERT INTO public.who_global_data VALUES (44695, 69, 3251, 2, 51, 189, 31);
INSERT INTO public.who_global_data VALUES (44696, 0, 13, 0, 1, 189, 127);
INSERT INTO public.who_global_data VALUES (44697, 1063, 24322, 7, 353, 189, 22);
INSERT INTO public.who_global_data VALUES (44698, 56, 1864, 0, 11, 189, 115);
INSERT INTO public.who_global_data VALUES (44699, 0, 353, 0, 6, 189, 106);
INSERT INTO public.who_global_data VALUES (44700, 77, 2129, 0, 10, 189, 90);
INSERT INTO public.who_global_data VALUES (44701, 0, 0, 0, 0, 189, 70);
INSERT INTO public.who_global_data VALUES (44702, 224, 19771, 4, 56, 189, 46);
INSERT INTO public.who_global_data VALUES (44703, 341, 54243, 0, 6145, 189, 139);
INSERT INTO public.who_global_data VALUES (44704, 0, 22, 0, 0, 189, 42);
INSERT INTO public.who_global_data VALUES (44705, 2, 1212, 0, 22, 189, 80);
INSERT INTO public.who_global_data VALUES (44706, 0, 3080, 0, 116, 189, 203);
INSERT INTO public.who_global_data VALUES (44707, 2, 1136, 0, 69, 189, 136);
INSERT INTO public.who_global_data VALUES (44708, 462, 43151, 1, 879, 189, 63);
INSERT INTO public.who_global_data VALUES (44709, 0, 0, 0, 0, 189, 17);
INSERT INTO public.who_global_data VALUES (44710, 0, 42, 0, 2, 189, 172);
INSERT INTO public.who_global_data VALUES (44711, 145, 10762, 6, 486, 189, 109);
INSERT INTO public.who_global_data VALUES (44712, 36, 9208, 0, 255, 189, 200);
INSERT INTO public.who_global_data VALUES (44713, 394, 15232, 1, 85, 189, 93);
INSERT INTO public.who_global_data VALUES (44714, 0, 79159, 0, 421, 189, 5);
INSERT INTO public.who_global_data VALUES (44715, 0, 741, 0, 13, 189, 214);
INSERT INTO public.who_global_data VALUES (44716, 841, 279146, 19, 5970, 189, 204);
INSERT INTO public.who_global_data VALUES (44717, 0, 0, 0, 0, 189, 198);
INSERT INTO public.who_global_data VALUES (44718, 922, 64191, 23, 1397, 189, 173);
INSERT INTO public.who_global_data VALUES (44719, 9, 72, 0, 2, 189, 229);
INSERT INTO public.who_global_data VALUES (44720, 341, 5207, 1, 47, 189, 76);
INSERT INTO public.who_global_data VALUES (44721, 6809, 407492, 205, 19021, 189, 138);
INSERT INTO public.who_global_data VALUES (44722, 3980, 93354, 40, 2023, 189, 98);
INSERT INTO public.who_global_data VALUES (44723, 0, 0, 0, 0, 189, 103);
INSERT INTO public.who_global_data VALUES (44724, 657, 45688, 7, 1716, 189, 225);
INSERT INTO public.who_global_data VALUES (44725, 204, 51072, 8, 1735, 189, 131);
INSERT INTO public.who_global_data VALUES (44726, 209, 16781, 5, 219, 189, 235);
INSERT INTO public.who_global_data VALUES (44727, 235, 110695, 3, 174, 189, 137);
INSERT INTO public.who_global_data VALUES (44728, 31, 14336, 0, 301, 189, 81);
INSERT INTO public.who_global_data VALUES (44729, 390, 24733, 7, 778, 189, 182);
INSERT INTO public.who_global_data VALUES (44730, 3, 660, 0, 4, 189, 145);
INSERT INTO public.who_global_data VALUES (44731, 1295, 50886, 39, 2343, 189, 26);
INSERT INTO public.who_global_data VALUES (44732, 5462, 845443, 95, 14058, 189, 170);
INSERT INTO public.who_global_data VALUES (44733, 28, 2022, 0, 5, 189, 191);
INSERT INTO public.who_global_data VALUES (44734, 0, 3, 0, 0, 189, 221);
INSERT INTO public.who_global_data VALUES (44735, 0, 8, 0, 0, 189, 64);
INSERT INTO public.who_global_data VALUES (44736, 0, 0, 0, 0, 189, 116);
INSERT INTO public.who_global_data VALUES (44737, 0, 17, 0, 0, 189, 128);
INSERT INTO public.who_global_data VALUES (44738, 0, 25, 0, 0, 189, 6);
INSERT INTO public.who_global_data VALUES (44739, 0, 53, 0, 3, 189, 227);
INSERT INTO public.who_global_data VALUES (44740, 0, 4, 0, 0, 189, 68);
INSERT INTO public.who_global_data VALUES (44741, 2, 54, 0, 0, 189, 184);
INSERT INTO public.who_global_data VALUES (44742, 0, 0, 0, 0, 189, 82);
INSERT INTO public.who_global_data VALUES (44743, 0, 716, 0, 42, 189, 149);
INSERT INTO public.who_global_data VALUES (44744, 1, 871, 0, 15, 189, 197);
INSERT INTO public.who_global_data VALUES (44745, 1686, 275905, 24, 2866, 189, 78);
INSERT INTO public.who_global_data VALUES (44746, 126, 10232, 1, 205, 189, 233);
INSERT INTO public.who_global_data VALUES (44747, 339, 25552, 8, 573, 189, 133);
INSERT INTO public.who_global_data VALUES (44748, 0, 114, 0, 0, 189, 35);
INSERT INTO public.who_global_data VALUES (44749, 5, 1823, 0, 67, 189, 114);
INSERT INTO public.who_global_data VALUES (44750, 396, 52205, 0, 27, 189, 237);
INSERT INTO public.who_global_data VALUES (44751, 0, 3, 0, 0, 189, 55);
INSERT INTO public.who_global_data VALUES (44752, 2, 128, 0, 15, 189, 176);
INSERT INTO public.who_global_data VALUES (44753, 27, 2292, 1, 29, 189, 202);
INSERT INTO public.who_global_data VALUES (44754, 15, 2172, 0, 121, 189, 155);
INSERT INTO public.who_global_data VALUES (44755, 0, 0, 0, 0, 189, 32);
INSERT INTO public.who_global_data VALUES (44756, 0, 3212, 0, 93, 189, 220);
INSERT INTO public.who_global_data VALUES (44757, 11014, 493183, 193, 8005, 189, 30);
INSERT INTO public.who_global_data VALUES (44758, 30, 2352, 0, 46, 189, 147);
INSERT INTO public.who_global_data VALUES (44759, 3562, 304120, 11, 29895, 189, 208);
INSERT INTO public.who_global_data VALUES (44760, 1, 2815, 0, 11, 189, 45);
INSERT INTO public.who_global_data VALUES (44761, 65, 11644, 15, 746, 189, 110);
INSERT INTO public.who_global_data VALUES (44762, 43, 1650, 0, 26, 189, 88);
INSERT INTO public.who_global_data VALUES (44763, 302, 76683, 0, 5758, 189, 51);
INSERT INTO public.who_global_data VALUES (44764, 164, 35447, 2, 1739, 189, 209);
INSERT INTO public.who_global_data VALUES (44765, 19, 757, 2, 43, 189, 205);
INSERT INTO public.who_global_data VALUES (44766, 43, 7409, 0, 60, 189, 18);
INSERT INTO public.who_global_data VALUES (44767, 2, 3312, 0, 58, 189, 72);
INSERT INTO public.who_global_data VALUES (44768, 880, 303185, 20, 41189, 189, 44);
INSERT INTO public.who_global_data VALUES (44769, 0, 24, 0, 0, 189, 15);
INSERT INTO public.who_global_data VALUES (44770, 19, 927, 0, 18, 189, 25);
INSERT INTO public.who_global_data VALUES (44771, 0, 0, 0, 0, 189, 179);
INSERT INTO public.who_global_data VALUES (44772, 0, 0, 0, 0, 189, 34);
INSERT INTO public.who_global_data VALUES (44773, 12, 169, 0, 8, 189, 207);
INSERT INTO public.who_global_data VALUES (44774, 17, 1552, 1, 51, 189, 166);
INSERT INTO public.who_global_data VALUES (44775, 7712, 257793, 17, 5691, 189, 126);
INSERT INTO public.who_global_data VALUES (44776, 0, 0, 0, 0, 189, 97);
INSERT INTO public.who_global_data VALUES (44777, 3, 107, 0, 2, 189, 36);
INSERT INTO public.who_global_data VALUES (44778, 0, 0, 0, 0, 189, 125);
INSERT INTO public.who_global_data VALUES (44779, 7, 1154, 1, 3, 189, 124);
INSERT INTO public.who_global_data VALUES (44780, 1172, 71056, 16, 1709, 189, 185);
INSERT INTO public.who_global_data VALUES (44781, 283, 60506, 2, 351, 189, 194);
INSERT INTO public.who_global_data VALUES (44782, 0, 509, 0, 21, 189, 144);
INSERT INTO public.who_global_data VALUES (44783, 67823, 4456389, 1211, 151265, 189, 19);
INSERT INTO public.who_global_data VALUES (44784, 8, 406, 0, 8, 189, 217);
INSERT INTO public.who_global_data VALUES (44785, 6, 1243, 0, 35, 189, 148);
INSERT INTO public.who_global_data VALUES (44786, 746, 24304, 6, 143, 189, 86);
INSERT INTO public.who_global_data VALUES (44787, 0, 0, 0, 0, 189, 13);
INSERT INTO public.who_global_data VALUES (44788, 700, 17859, 4, 158, 189, 157);
INSERT INTO public.who_global_data VALUES (44789, 49, 558, 2, 2, 189, 8);
INSERT INTO public.who_global_data VALUES (44790, 0, 0, 0, 0, 189, 73);
INSERT INTO public.who_global_data VALUES (44791, 2, 1732, 6, 494, 189, 101);
INSERT INTO public.who_global_data VALUES (44792, 408, 5963, 2, 151, 189, 165);
INSERT INTO public.who_global_data VALUES (44793, 77, 3169, 14, 67, 189, 14);
INSERT INTO public.who_global_data VALUES (44794, 0, 36628, 0, 1275, 190, 193);
INSERT INTO public.who_global_data VALUES (44795, 92, 5197, 4, 154, 190, 113);
INSERT INTO public.who_global_data VALUES (44796, 602, 29831, 14, 1200, 190, 143);
INSERT INTO public.who_global_data VALUES (44797, 0, 0, 0, 0, 190, 219);
INSERT INTO public.who_global_data VALUES (44798, 4, 922, 0, 52, 190, 186);
INSERT INTO public.who_global_data VALUES (44799, 31, 1109, 3, 51, 190, 52);
INSERT INTO public.who_global_data VALUES (44800, 0, 3, 0, 0, 190, 180);
INSERT INTO public.who_global_data VALUES (44801, 5, 91, 0, 3, 190, 167);
INSERT INTO public.who_global_data VALUES (44802, 5641, 178996, 111, 3311, 190, 154);
INSERT INTO public.who_global_data VALUES (44803, 354, 37863, 10, 733, 190, 94);
INSERT INTO public.who_global_data VALUES (44804, 0, 119, 0, 3, 190, 66);
INSERT INTO public.who_global_data VALUES (44805, 721, 16303, 13, 189, 190, 58);
INSERT INTO public.who_global_data VALUES (44806, 163, 21009, 2, 718, 190, 163);
INSERT INTO public.who_global_data VALUES (44807, 339, 31560, 3, 441, 190, 37);
INSERT INTO public.who_global_data VALUES (44808, 37, 484, 0, 11, 190, 142);
INSERT INTO public.who_global_data VALUES (44809, 444, 40755, 2, 146, 190, 83);
INSERT INTO public.who_global_data VALUES (44810, 2695, 234889, 48, 3083, 190, 228);
INSERT INTO public.who_global_data VALUES (44811, 0, 110, 0, 7, 190, 188);
INSERT INTO public.who_global_data VALUES (44812, 143, 67808, 6, 559, 190, 62);
INSERT INTO public.who_global_data VALUES (44813, 635, 69690, 2, 9699, 190, 160);
INSERT INTO public.who_global_data VALUES (44814, 0, 48, 0, 2, 190, 50);
INSERT INTO public.who_global_data VALUES (44815, 0, 1805, 0, 36, 190, 33);
INSERT INTO public.who_global_data VALUES (44816, 0, 156, 0, 9, 190, 183);
INSERT INTO public.who_global_data VALUES (44817, 0, 101, 0, 0, 190, 92);
INSERT INTO public.who_global_data VALUES (44818, 1207, 73534, 88, 2808, 190, 158);
INSERT INTO public.who_global_data VALUES (44819, 0, 5, 0, 0, 190, 67);
INSERT INTO public.who_global_data VALUES (44820, 313, 11442, 12, 324, 190, 57);
INSERT INTO public.who_global_data VALUES (44821, 0, 804, 0, 2, 190, 38);
INSERT INTO public.who_global_data VALUES (44822, 69074, 2552265, 1595, 90134, 190, 141);
INSERT INTO public.who_global_data VALUES (44823, 0, 8, 0, 1, 190, 178);
INSERT INTO public.who_global_data VALUES (44824, 0, 141, 0, 3, 190, 108);
INSERT INTO public.who_global_data VALUES (44825, 265, 11420, 6, 374, 190, 39);
INSERT INTO public.who_global_data VALUES (44826, 11, 1117, 0, 53, 190, 2);
INSERT INTO public.who_global_data VALUES (44827, 9, 387, 0, 1, 190, 195);
INSERT INTO public.who_global_data VALUES (44828, 45, 2418, 0, 23, 190, 107);
INSERT INTO public.who_global_data VALUES (44829, 0, 234, 0, 0, 190, 161);
INSERT INTO public.who_global_data VALUES (44830, 0, 17255, 0, 391, 190, 212);
INSERT INTO public.who_global_data VALUES (44831, 476, 115470, 5, 8917, 190, 181);
INSERT INTO public.who_global_data VALUES (44832, 0, 203, 0, 1, 190, 53);
INSERT INTO public.who_global_data VALUES (44833, 0, 4605, 0, 59, 190, 164);
INSERT INTO public.who_global_data VALUES (44834, 9, 935, 0, 75, 190, 140);
INSERT INTO public.who_global_data VALUES (44835, 1961, 353536, 99, 9377, 190, 20);
INSERT INTO public.who_global_data VALUES (44836, 276, 87956, 1, 4666, 190, 112);
INSERT INTO public.who_global_data VALUES (44837, 8670, 276055, 380, 9454, 190, 111);
INSERT INTO public.who_global_data VALUES (44838, 4, 382, 0, 7, 190, 71);
INSERT INTO public.who_global_data VALUES (44839, 176, 3376, 2, 56, 190, 218);
INSERT INTO public.who_global_data VALUES (44840, 0, 0, 0, 0, 190, 43);
INSERT INTO public.who_global_data VALUES (44841, 456, 16800, 8, 133, 190, 49);
INSERT INTO public.who_global_data VALUES (44842, 265, 15978, 2, 100, 190, 1);
INSERT INTO public.who_global_data VALUES (44843, 78, 5071, 3, 144, 190, 48);
INSERT INTO public.who_global_data VALUES (44844, 9, 2597, 0, 87, 190, 232);
INSERT INTO public.who_global_data VALUES (44845, 0, 29, 0, 1, 190, 175);
INSERT INTO public.who_global_data VALUES (44846, 4, 1084, 0, 19, 190, 21);
INSERT INTO public.who_global_data VALUES (44847, 249, 16342, 5, 379, 190, 156);
INSERT INTO public.who_global_data VALUES (44848, 0, 0, 0, 0, 190, 95);
INSERT INTO public.who_global_data VALUES (44849, 79, 9009, 2, 214, 190, 177);
INSERT INTO public.who_global_data VALUES (44850, 91, 13725, 1, 615, 190, 210);
INSERT INTO public.who_global_data VALUES (44851, 0, 5081, 0, 58, 190, 120);
INSERT INTO public.who_global_data VALUES (44852, 0, 18, 0, 0, 190, 135);
INSERT INTO public.who_global_data VALUES (44853, 1733, 67915, 23, 1146, 190, 206);
INSERT INTO public.who_global_data VALUES (44854, 1177, 84370, 34, 5657, 190, 189);
INSERT INTO public.who_global_data VALUES (44855, 401, 93757, 46, 4774, 190, 129);
INSERT INTO public.who_global_data VALUES (44856, 389, 16230, 9, 439, 190, 121);
INSERT INTO public.who_global_data VALUES (44857, 0, 2350, 0, 41, 190, 59);
INSERT INTO public.who_global_data VALUES (44858, 14, 279, 0, 0, 190, 96);
INSERT INTO public.who_global_data VALUES (44859, 9, 2051, 0, 63, 190, 41);
INSERT INTO public.who_global_data VALUES (44860, 26, 2577, 0, 40, 190, 216);
INSERT INTO public.who_global_data VALUES (44861, 805, 16615, 10, 263, 190, 236);
INSERT INTO public.who_global_data VALUES (44862, 0, 13, 0, 0, 190, 150);
INSERT INTO public.who_global_data VALUES (44863, 0, 220, 0, 0, 190, 61);
INSERT INTO public.who_global_data VALUES (44864, 0, 27, 0, 0, 190, 7);
INSERT INTO public.who_global_data VALUES (44865, 9, 7423, 0, 329, 190, 169);
INSERT INTO public.who_global_data VALUES (44866, 1239, 174648, 16, 30136, 190, 28);
INSERT INTO public.who_global_data VALUES (44867, 81, 7728, 0, 43, 190, 85);
INSERT INTO public.who_global_data VALUES (44868, 0, 62, 0, 0, 190, 211);
INSERT INTO public.who_global_data VALUES (44869, 0, 7352, 0, 49, 190, 60);
INSERT INTO public.who_global_data VALUES (44870, 77, 403, 0, 8, 190, 3);
INSERT INTO public.who_global_data VALUES (44871, 8, 1168, 0, 17, 190, 11);
INSERT INTO public.who_global_data VALUES (44872, 870, 208698, 7, 9141, 190, 89);
INSERT INTO public.who_global_data VALUES (44873, 0, 35142, 0, 175, 190, 24);
INSERT INTO public.who_global_data VALUES (44874, 0, 186, 0, 0, 190, 162);
INSERT INTO public.who_global_data VALUES (44875, 65, 4401, 0, 203, 190, 100);
INSERT INTO public.who_global_data VALUES (44876, 0, 14, 0, 0, 190, 47);
INSERT INTO public.who_global_data VALUES (44877, 1, 24, 0, 0, 190, 29);
INSERT INTO public.who_global_data VALUES (44878, 0, 244, 0, 14, 190, 40);
INSERT INTO public.who_global_data VALUES (44879, 2, 348, 0, 5, 190, 222);
INSERT INTO public.who_global_data VALUES (44880, 1221, 48826, 32, 1867, 190, 132);
INSERT INTO public.who_global_data VALUES (44881, 0, 252, 0, 13, 190, 130);
INSERT INTO public.who_global_data VALUES (44882, 59, 7242, 0, 46, 190, 234);
INSERT INTO public.who_global_data VALUES (44883, 0, 1981, 0, 26, 190, 23);
INSERT INTO public.who_global_data VALUES (44884, 2, 398, 0, 20, 190, 192);
INSERT INTO public.who_global_data VALUES (44885, 7, 7378, 1, 159, 190, 69);
INSERT INTO public.who_global_data VALUES (44886, 0, 12, 0, 0, 190, 187);
INSERT INTO public.who_global_data VALUES (44887, 484, 40944, 45, 1259, 190, 230);
INSERT INTO public.who_global_data VALUES (44888, 21, 4505, 0, 596, 190, 77);
INSERT INTO public.who_global_data VALUES (44889, 11, 1872, 0, 10, 190, 9);
INSERT INTO public.who_global_data VALUES (44890, 55078, 1638870, 779, 35747, 190, 74);
INSERT INTO public.who_global_data VALUES (44891, 1904, 106336, 83, 5058, 190, 224);
INSERT INTO public.who_global_data VALUES (44892, 2621, 301530, 226, 16569, 190, 199);
INSERT INTO public.who_global_data VALUES (44893, 2963, 121263, 68, 4671, 190, 190);
INSERT INTO public.who_global_data VALUES (44894, 85, 26027, 0, 1763, 190, 12);
INSERT INTO public.who_global_data VALUES (44895, 0, 336, 0, 24, 190, 104);
INSERT INTO public.who_global_data VALUES (44896, 1954, 68595, 15, 535, 190, 153);
INSERT INTO public.who_global_data VALUES (44897, 382, 247158, 3, 35132, 190, 91);
INSERT INTO public.who_global_data VALUES (44898, 1, 856, 0, 10, 190, 215);
INSERT INTO public.who_global_data VALUES (44899, 1323, 34372, 2, 1006, 190, 84);
INSERT INTO public.who_global_data VALUES (44900, 0, 335, 0, 31, 190, 231);
INSERT INTO public.who_global_data VALUES (44901, 4, 1259, 0, 11, 190, 196);
INSERT INTO public.who_global_data VALUES (44902, 1289, 90367, 0, 793, 190, 105);
INSERT INTO public.who_global_data VALUES (44903, 788, 19913, 14, 325, 190, 122);
INSERT INTO public.who_global_data VALUES (44904, 0, 0, 0, 0, 190, 159);
INSERT INTO public.who_global_data VALUES (44905, 258, 8061, 16, 202, 190, 75);
INSERT INTO public.who_global_data VALUES (44906, 626, 66529, 1, 445, 190, 27);
INSERT INTO public.who_global_data VALUES (44907, 662, 35805, 14, 933, 190, 54);
INSERT INTO public.who_global_data VALUES (44908, 0, 20, 0, 0, 190, 226);
INSERT INTO public.who_global_data VALUES (44909, 4, 1228, 0, 31, 190, 79);
INSERT INTO public.who_global_data VALUES (44910, 129, 4334, 2, 57, 190, 56);
INSERT INTO public.who_global_data VALUES (44911, 28, 604, 0, 13, 190, 117);
INSERT INTO public.who_global_data VALUES (44912, 2, 1181, 1, 73, 190, 152);
INSERT INTO public.who_global_data VALUES (44913, 216, 3438, 2, 73, 190, 16);
INSERT INTO public.who_global_data VALUES (44914, 0, 89, 0, 1, 190, 10);
INSERT INTO public.who_global_data VALUES (44915, 13, 2069, 0, 80, 190, 201);
INSERT INTO public.who_global_data VALUES (44916, 83, 6616, 0, 114, 190, 174);
INSERT INTO public.who_global_data VALUES (44917, 431, 10748, 6, 105, 190, 119);
INSERT INTO public.who_global_data VALUES (44918, 123, 3981, 2, 109, 190, 168);
INSERT INTO public.who_global_data VALUES (44919, 8, 8964, 0, 124, 190, 99);
INSERT INTO public.who_global_data VALUES (44920, 152, 3719, 1, 16, 190, 171);
INSERT INTO public.who_global_data VALUES (44921, 1, 2522, 0, 124, 190, 87);
INSERT INTO public.who_global_data VALUES (44922, 9, 736, 0, 9, 190, 123);
INSERT INTO public.who_global_data VALUES (44923, 0, 0, 0, 0, 190, 151);
INSERT INTO public.who_global_data VALUES (44924, 0, 269, 0, 15, 190, 213);
INSERT INTO public.who_global_data VALUES (44925, 0, 6270, 0, 156, 190, 118);
INSERT INTO public.who_global_data VALUES (44926, 0, 344, 0, 10, 190, 134);
INSERT INTO public.who_global_data VALUES (44927, 57, 2962, 0, 39, 190, 65);
INSERT INTO public.who_global_data VALUES (44928, 5752, 408449, 485, 45361, 190, 102);
INSERT INTO public.who_global_data VALUES (44929, 0, 0, 0, 0, 190, 223);
INSERT INTO public.who_global_data VALUES (44930, 0, 87, 0, 1, 190, 4);
INSERT INTO public.who_global_data VALUES (44931, 0, 291, 0, 0, 190, 146);
INSERT INTO public.who_global_data VALUES (44932, 73, 3182, 1, 49, 190, 31);
INSERT INTO public.who_global_data VALUES (44933, 0, 13, 0, 1, 190, 127);
INSERT INTO public.who_global_data VALUES (44934, 1046, 23259, 12, 346, 190, 22);
INSERT INTO public.who_global_data VALUES (44935, 60, 1808, 0, 11, 190, 115);
INSERT INTO public.who_global_data VALUES (44936, 0, 353, 0, 6, 190, 106);
INSERT INTO public.who_global_data VALUES (44937, 66, 2052, 1, 10, 190, 90);
INSERT INTO public.who_global_data VALUES (44938, 0, 0, 0, 0, 190, 70);
INSERT INTO public.who_global_data VALUES (44939, 274, 19547, 3, 52, 190, 46);
INSERT INTO public.who_global_data VALUES (44940, 341, 53902, 0, 6145, 190, 139);
INSERT INTO public.who_global_data VALUES (44941, 0, 22, 0, 0, 190, 42);
INSERT INTO public.who_global_data VALUES (44942, 0, 1210, 0, 22, 190, 80);
INSERT INTO public.who_global_data VALUES (44943, 0, 3080, 0, 116, 190, 203);
INSERT INTO public.who_global_data VALUES (44944, 0, 1134, 0, 69, 190, 136);
INSERT INTO public.who_global_data VALUES (44945, 481, 42689, 5, 878, 190, 63);
INSERT INTO public.who_global_data VALUES (44946, 0, 0, 0, 0, 190, 17);
INSERT INTO public.who_global_data VALUES (44947, 2, 42, 0, 2, 190, 172);
INSERT INTO public.who_global_data VALUES (44948, 117, 10617, 4, 480, 190, 109);
INSERT INTO public.who_global_data VALUES (44949, 22, 9172, 0, 255, 190, 200);
INSERT INTO public.who_global_data VALUES (44950, 380, 14838, 1, 84, 190, 93);
INSERT INTO public.who_global_data VALUES (44951, 590, 79159, 9, 421, 190, 5);
INSERT INTO public.who_global_data VALUES (44952, 0, 741, 0, 13, 190, 214);
INSERT INTO public.who_global_data VALUES (44953, 903, 278305, 27, 5951, 190, 204);
INSERT INTO public.who_global_data VALUES (44954, 0, 0, 0, 0, 190, 198);
INSERT INTO public.who_global_data VALUES (44955, 1046, 63269, 25, 1374, 190, 173);
INSERT INTO public.who_global_data VALUES (44956, 0, 63, 1, 2, 190, 229);
INSERT INTO public.who_global_data VALUES (44957, 192, 4866, 1, 46, 190, 76);
INSERT INTO public.who_global_data VALUES (44958, 5678, 400683, 204, 18816, 190, 138);
INSERT INTO public.who_global_data VALUES (44959, 3888, 89374, 21, 1983, 190, 98);
INSERT INTO public.who_global_data VALUES (44960, 0, 0, 0, 0, 190, 103);
INSERT INTO public.who_global_data VALUES (44961, 615, 45031, 15, 1709, 190, 225);
INSERT INTO public.who_global_data VALUES (44962, 255, 50868, 2, 1727, 190, 131);
INSERT INTO public.who_global_data VALUES (44963, 511, 16572, 3, 214, 190, 235);
INSERT INTO public.who_global_data VALUES (44964, 307, 110460, 2, 171, 190, 137);
INSERT INTO public.who_global_data VALUES (44965, 36, 14305, 1, 301, 190, 81);
INSERT INTO public.who_global_data VALUES (44966, 396, 24343, 9, 771, 190, 182);
INSERT INTO public.who_global_data VALUES (44967, 0, 657, 0, 4, 190, 145);
INSERT INTO public.who_global_data VALUES (44968, 1356, 49591, 35, 2304, 190, 26);
INSERT INTO public.who_global_data VALUES (44969, 5482, 839981, 161, 13963, 190, 170);
INSERT INTO public.who_global_data VALUES (44970, 31, 1994, 0, 5, 190, 191);
INSERT INTO public.who_global_data VALUES (44971, 0, 3, 0, 0, 190, 221);
INSERT INTO public.who_global_data VALUES (44972, 0, 8, 0, 0, 190, 64);
INSERT INTO public.who_global_data VALUES (44973, 0, 0, 0, 0, 190, 116);
INSERT INTO public.who_global_data VALUES (44974, 0, 17, 0, 0, 190, 128);
INSERT INTO public.who_global_data VALUES (44975, 1, 25, 0, 0, 190, 6);
INSERT INTO public.who_global_data VALUES (44976, 0, 53, 0, 3, 190, 227);
INSERT INTO public.who_global_data VALUES (44977, 0, 4, 0, 0, 190, 68);
INSERT INTO public.who_global_data VALUES (44978, 0, 52, 0, 0, 190, 184);
INSERT INTO public.who_global_data VALUES (44979, 0, 0, 0, 0, 190, 82);
INSERT INTO public.who_global_data VALUES (44980, 0, 716, 0, 42, 190, 149);
INSERT INTO public.who_global_data VALUES (44981, 2, 870, 0, 15, 190, 197);
INSERT INTO public.who_global_data VALUES (44982, 1629, 274219, 26, 2842, 190, 78);
INSERT INTO public.who_global_data VALUES (44983, 145, 10106, 4, 204, 190, 233);
INSERT INTO public.who_global_data VALUES (44984, 321, 25213, 7, 565, 190, 133);
INSERT INTO public.who_global_data VALUES (44985, 0, 114, 0, 0, 190, 35);
INSERT INTO public.who_global_data VALUES (44986, 15, 1818, 0, 67, 190, 114);
INSERT INTO public.who_global_data VALUES (44987, 278, 51809, 0, 27, 190, 237);
INSERT INTO public.who_global_data VALUES (44988, 0, 3, 0, 0, 190, 55);
INSERT INTO public.who_global_data VALUES (44989, 5, 126, 0, 15, 190, 176);
INSERT INTO public.who_global_data VALUES (44990, 20, 2265, 0, 28, 190, 202);
INSERT INTO public.who_global_data VALUES (44991, 17, 2157, 1, 121, 190, 155);
INSERT INTO public.who_global_data VALUES (44992, 0, 0, 0, 0, 190, 32);
INSERT INTO public.who_global_data VALUES (44993, 0, 3212, 0, 93, 190, 220);
INSERT INTO public.who_global_data VALUES (44994, 11046, 482169, 315, 7812, 190, 30);
INSERT INTO public.who_global_data VALUES (44995, 0, 2322, 0, 46, 190, 147);
INSERT INTO public.who_global_data VALUES (44996, 3352, 300558, 8, 29884, 190, 208);
INSERT INTO public.who_global_data VALUES (44997, 4, 2814, 0, 11, 190, 45);
INSERT INTO public.who_global_data VALUES (44998, 0, 11579, 0, 731, 190, 110);
INSERT INTO public.who_global_data VALUES (44999, 97, 1607, 2, 26, 190, 88);
INSERT INTO public.who_global_data VALUES (45000, 301, 76381, 1, 5758, 190, 51);
INSERT INTO public.who_global_data VALUES (45001, 212, 35283, 0, 1737, 190, 209);
INSERT INTO public.who_global_data VALUES (45002, 21, 738, 1, 41, 190, 205);
INSERT INTO public.who_global_data VALUES (45003, 46, 7366, 0, 60, 190, 18);
INSERT INTO public.who_global_data VALUES (45004, 6, 3310, 0, 58, 190, 72);
INSERT INTO public.who_global_data VALUES (45005, 846, 302305, 0, 41169, 190, 44);
INSERT INTO public.who_global_data VALUES (45006, 0, 24, 0, 0, 190, 15);
INSERT INTO public.who_global_data VALUES (45007, 12, 908, 0, 18, 190, 25);
INSERT INTO public.who_global_data VALUES (45008, 0, 0, 0, 0, 190, 179);
INSERT INTO public.who_global_data VALUES (45009, 0, 0, 0, 0, 190, 34);
INSERT INTO public.who_global_data VALUES (45010, 1, 157, 0, 8, 190, 207);
INSERT INTO public.who_global_data VALUES (45011, 21, 1535, 0, 50, 190, 166);
INSERT INTO public.who_global_data VALUES (45012, 7697, 250081, 15, 5674, 190, 126);
INSERT INTO public.who_global_data VALUES (45013, 0, 0, 0, 0, 190, 97);
INSERT INTO public.who_global_data VALUES (45014, 5, 104, 0, 2, 190, 36);
INSERT INTO public.who_global_data VALUES (45015, 0, 0, 0, 0, 190, 125);
INSERT INTO public.who_global_data VALUES (45016, 12, 1147, 0, 2, 190, 124);
INSERT INTO public.who_global_data VALUES (45017, 1090, 69884, 20, 1693, 190, 185);
INSERT INTO public.who_global_data VALUES (45018, 302, 60223, 2, 349, 190, 194);
INSERT INTO public.who_global_data VALUES (45019, 0, 509, 0, 21, 190, 144);
INSERT INTO public.who_global_data VALUES (45020, 65406, 4388566, 1414, 150054, 190, 19);
INSERT INTO public.who_global_data VALUES (45021, 13, 398, 0, 8, 190, 217);
INSERT INTO public.who_global_data VALUES (45022, 19, 1237, 0, 35, 190, 148);
INSERT INTO public.who_global_data VALUES (45023, 686, 23558, 5, 137, 190, 86);
INSERT INTO public.who_global_data VALUES (45024, 0, 0, 0, 0, 190, 13);
INSERT INTO public.who_global_data VALUES (45025, 588, 17159, 3, 154, 190, 157);
INSERT INTO public.who_global_data VALUES (45026, 50, 509, 0, 0, 190, 8);
INSERT INTO public.who_global_data VALUES (45027, 0, 0, 0, 0, 190, 73);
INSERT INTO public.who_global_data VALUES (45028, 15, 1730, 2, 488, 190, 101);
INSERT INTO public.who_global_data VALUES (45029, 306, 5555, 3, 149, 190, 165);
INSERT INTO public.who_global_data VALUES (45030, 213, 3092, 12, 53, 190, 14);
INSERT INTO public.who_global_data VALUES (45031, 71, 36628, 0, 1275, 191, 193);
INSERT INTO public.who_global_data VALUES (45032, 108, 5105, 2, 150, 191, 113);
INSERT INTO public.who_global_data VALUES (45033, 614, 29229, 12, 1186, 191, 143);
INSERT INTO public.who_global_data VALUES (45034, 0, 0, 0, 0, 191, 219);
INSERT INTO public.who_global_data VALUES (45035, 7, 918, 0, 52, 191, 186);
INSERT INTO public.who_global_data VALUES (45036, 78, 1078, 1, 48, 191, 52);
INSERT INTO public.who_global_data VALUES (45037, 0, 3, 0, 0, 191, 180);
INSERT INTO public.who_global_data VALUES (45038, 0, 86, 0, 3, 191, 167);
INSERT INTO public.who_global_data VALUES (45039, 5939, 173355, 118, 3200, 191, 154);
INSERT INTO public.who_global_data VALUES (45040, 259, 37509, 5, 723, 191, 94);
INSERT INTO public.who_global_data VALUES (45041, 0, 119, 0, 3, 191, 66);
INSERT INTO public.who_global_data VALUES (45042, 278, 15582, 9, 176, 191, 58);
INSERT INTO public.who_global_data VALUES (45043, 164, 20846, 3, 716, 191, 163);
INSERT INTO public.who_global_data VALUES (45044, 363, 31221, 8, 438, 191, 37);
INSERT INTO public.who_global_data VALUES (45045, 65, 447, 0, 11, 191, 142);
INSERT INTO public.who_global_data VALUES (45046, 390, 40311, 3, 144, 191, 83);
INSERT INTO public.who_global_data VALUES (45047, 3009, 232194, 35, 3035, 191, 228);
INSERT INTO public.who_global_data VALUES (45048, 0, 110, 0, 7, 191, 188);
INSERT INTO public.who_global_data VALUES (45049, 147, 67665, 5, 553, 191, 62);
INSERT INTO public.who_global_data VALUES (45050, 703, 69055, 3, 9697, 191, 160);
INSERT INTO public.who_global_data VALUES (45051, 0, 48, 0, 2, 191, 50);
INSERT INTO public.who_global_data VALUES (45052, 0, 1805, 0, 36, 191, 33);
INSERT INTO public.who_global_data VALUES (45053, 2, 156, 0, 9, 191, 183);
INSERT INTO public.who_global_data VALUES (45054, 2, 101, 0, 0, 191, 92);
INSERT INTO public.who_global_data VALUES (45055, 1146, 72327, 73, 2720, 191, 158);
INSERT INTO public.who_global_data VALUES (45056, 0, 5, 0, 0, 191, 67);
INSERT INTO public.who_global_data VALUES (45057, 382, 11129, 17, 312, 191, 57);
INSERT INTO public.who_global_data VALUES (45058, 65, 804, 0, 2, 191, 38);
INSERT INTO public.who_global_data VALUES (45059, 40816, 2483191, 921, 88539, 191, 141);
INSERT INTO public.who_global_data VALUES (45060, 0, 8, 0, 1, 191, 178);
INSERT INTO public.who_global_data VALUES (45061, 0, 141, 0, 3, 191, 108);
INSERT INTO public.who_global_data VALUES (45062, 284, 11155, 13, 368, 191, 39);
INSERT INTO public.who_global_data VALUES (45063, 1, 1106, 0, 53, 191, 2);
INSERT INTO public.who_global_data VALUES (45064, 0, 378, 0, 1, 191, 195);
INSERT INTO public.who_global_data VALUES (45065, 19, 2373, 1, 23, 191, 107);
INSERT INTO public.who_global_data VALUES (45066, 8, 234, 0, 0, 191, 161);
INSERT INTO public.who_global_data VALUES (45067, 76, 17255, 0, 391, 191, 212);
INSERT INTO public.who_global_data VALUES (45068, 397, 114994, 11, 8912, 191, 181);
INSERT INTO public.who_global_data VALUES (45069, 0, 203, 0, 1, 191, 53);
INSERT INTO public.who_global_data VALUES (45070, 6, 4605, 0, 59, 191, 164);
INSERT INTO public.who_global_data VALUES (45071, 0, 926, 0, 75, 191, 140);
INSERT INTO public.who_global_data VALUES (45072, 1775, 351575, 38, 9278, 191, 20);
INSERT INTO public.who_global_data VALUES (45073, 223, 87680, 1, 4665, 191, 112);
INSERT INTO public.who_global_data VALUES (45074, 10284, 267385, 297, 9074, 191, 111);
INSERT INTO public.who_global_data VALUES (45075, 0, 378, 0, 7, 191, 71);
INSERT INTO public.who_global_data VALUES (45076, 0, 3200, 0, 54, 191, 218);
INSERT INTO public.who_global_data VALUES (45077, 0, 0, 0, 0, 191, 43);
INSERT INTO public.who_global_data VALUES (45078, 503, 16344, 10, 125, 191, 49);
INSERT INTO public.who_global_data VALUES (45079, 0, 15713, 0, 98, 191, 1);
INSERT INTO public.who_global_data VALUES (45080, 70, 4993, 1, 141, 191, 48);
INSERT INTO public.who_global_data VALUES (45081, 33, 2588, 0, 87, 191, 232);
INSERT INTO public.who_global_data VALUES (45082, 0, 29, 0, 1, 191, 175);
INSERT INTO public.who_global_data VALUES (45083, 13, 1080, 0, 19, 191, 21);
INSERT INTO public.who_global_data VALUES (45084, 294, 16093, 1, 374, 191, 156);
INSERT INTO public.who_global_data VALUES (45085, 0, 0, 0, 0, 191, 95);
INSERT INTO public.who_global_data VALUES (45086, 58, 8930, 5, 212, 191, 177);
INSERT INTO public.who_global_data VALUES (45087, 57, 13634, 1, 614, 191, 210);
INSERT INTO public.who_global_data VALUES (45088, 13, 5081, 0, 58, 191, 120);
INSERT INTO public.who_global_data VALUES (45089, 0, 18, 0, 0, 191, 135);
INSERT INTO public.who_global_data VALUES (45090, 1492, 66182, 22, 1123, 191, 206);
INSERT INTO public.who_global_data VALUES (45091, 914, 83193, 39, 5623, 191, 189);
INSERT INTO public.who_global_data VALUES (45092, 409, 93356, 37, 4728, 191, 129);
INSERT INTO public.who_global_data VALUES (45093, 395, 15841, 13, 430, 191, 121);
INSERT INTO public.who_global_data VALUES (45094, 0, 2350, 0, 41, 191, 59);
INSERT INTO public.who_global_data VALUES (45095, 0, 265, 0, 0, 191, 96);
INSERT INTO public.who_global_data VALUES (45096, 4, 2042, 0, 63, 191, 41);
INSERT INTO public.who_global_data VALUES (45097, 147, 2551, 1, 40, 191, 216);
INSERT INTO public.who_global_data VALUES (45098, 610, 15810, 14, 253, 191, 236);
INSERT INTO public.who_global_data VALUES (45099, 0, 13, 0, 0, 191, 150);
INSERT INTO public.who_global_data VALUES (45100, 0, 220, 0, 0, 191, 61);
INSERT INTO public.who_global_data VALUES (45101, 0, 27, 0, 0, 191, 7);
INSERT INTO public.who_global_data VALUES (45102, 10, 7414, 0, 329, 191, 169);
INSERT INTO public.who_global_data VALUES (45103, 1261, 173409, 15, 30120, 191, 28);
INSERT INTO public.who_global_data VALUES (45104, 85, 7647, 0, 43, 191, 85);
INSERT INTO public.who_global_data VALUES (45105, 0, 62, 0, 0, 191, 211);
INSERT INTO public.who_global_data VALUES (45106, 163, 7352, 0, 49, 191, 60);
INSERT INTO public.who_global_data VALUES (45107, 0, 326, 0, 8, 191, 3);
INSERT INTO public.who_global_data VALUES (45108, 5, 1160, 1, 17, 191, 11);
INSERT INTO public.who_global_data VALUES (45109, 902, 207828, 6, 9134, 191, 89);
INSERT INTO public.who_global_data VALUES (45110, 736, 35142, 7, 175, 191, 24);
INSERT INTO public.who_global_data VALUES (45111, 1, 186, 0, 0, 191, 162);
INSERT INTO public.who_global_data VALUES (45112, 57, 4336, 0, 203, 191, 100);
INSERT INTO public.who_global_data VALUES (45113, 0, 14, 0, 0, 191, 47);
INSERT INTO public.who_global_data VALUES (45114, 0, 23, 0, 0, 191, 29);
INSERT INTO public.who_global_data VALUES (45115, 41, 244, 0, 14, 191, 40);
INSERT INTO public.who_global_data VALUES (45116, 3, 346, 0, 5, 191, 222);
INSERT INTO public.who_global_data VALUES (45117, 1154, 47605, 53, 1835, 191, 132);
INSERT INTO public.who_global_data VALUES (45118, 0, 252, 0, 13, 191, 130);
INSERT INTO public.who_global_data VALUES (45119, 57, 7183, 0, 46, 191, 234);
INSERT INTO public.who_global_data VALUES (45120, 27, 1981, 0, 26, 191, 23);
INSERT INTO public.who_global_data VALUES (45121, 7, 396, 0, 20, 191, 192);
INSERT INTO public.who_global_data VALUES (45122, 31, 7371, 0, 158, 191, 69);
INSERT INTO public.who_global_data VALUES (45123, 0, 12, 0, 0, 191, 187);
INSERT INTO public.who_global_data VALUES (45124, 719, 40460, 48, 1214, 191, 230);
INSERT INTO public.who_global_data VALUES (45125, 19, 4484, 0, 596, 191, 77);
INSERT INTO public.who_global_data VALUES (45126, 4, 1861, 0, 10, 191, 9);
INSERT INTO public.who_global_data VALUES (45127, 52123, 1583792, 775, 34968, 191, 74);
INSERT INTO public.who_global_data VALUES (45128, 2381, 104432, 74, 4975, 191, 224);
INSERT INTO public.who_global_data VALUES (45129, 2636, 298909, 196, 16343, 191, 199);
INSERT INTO public.who_global_data VALUES (45130, 2968, 118300, 68, 4603, 191, 190);
INSERT INTO public.who_global_data VALUES (45131, 13, 25942, 0, 1763, 191, 12);
INSERT INTO public.who_global_data VALUES (45132, 0, 336, 0, 24, 191, 104);
INSERT INTO public.who_global_data VALUES (45133, 2125, 66641, 8, 520, 191, 153);
INSERT INTO public.who_global_data VALUES (45134, 288, 246776, 6, 35129, 191, 91);
INSERT INTO public.who_global_data VALUES (45135, 2, 855, 0, 10, 191, 215);
INSERT INTO public.who_global_data VALUES (45136, 1148, 33049, 3, 1004, 191, 84);
INSERT INTO public.who_global_data VALUES (45137, 1, 335, 0, 31, 191, 231);
INSERT INTO public.who_global_data VALUES (45138, 5, 1255, 0, 11, 191, 196);
INSERT INTO public.who_global_data VALUES (45139, 1414, 89078, 0, 793, 191, 105);
INSERT INTO public.who_global_data VALUES (45140, 544, 19125, 12, 311, 191, 122);
INSERT INTO public.who_global_data VALUES (45141, 0, 0, 0, 0, 191, 159);
INSERT INTO public.who_global_data VALUES (45142, 194, 7803, 4, 186, 191, 75);
INSERT INTO public.who_global_data VALUES (45143, 754, 65903, 2, 444, 191, 27);
INSERT INTO public.who_global_data VALUES (45144, 631, 35143, 17, 919, 191, 54);
INSERT INTO public.who_global_data VALUES (45145, 0, 20, 0, 0, 191, 226);
INSERT INTO public.who_global_data VALUES (45146, 4, 1224, 0, 31, 191, 79);
INSERT INTO public.who_global_data VALUES (45147, 182, 4205, 1, 55, 191, 56);
INSERT INTO public.who_global_data VALUES (45148, 71, 576, 1, 13, 191, 117);
INSERT INTO public.who_global_data VALUES (45149, 12, 1179, 0, 72, 191, 152);
INSERT INTO public.who_global_data VALUES (45150, 205, 3222, 4, 71, 191, 16);
INSERT INTO public.who_global_data VALUES (45151, 0, 89, 0, 1, 191, 10);
INSERT INTO public.who_global_data VALUES (45152, 19, 2056, 0, 80, 191, 201);
INSERT INTO public.who_global_data VALUES (45153, 158, 6533, 1, 114, 191, 174);
INSERT INTO public.who_global_data VALUES (45154, 213, 10317, 6, 99, 191, 119);
INSERT INTO public.who_global_data VALUES (45155, 120, 3858, 4, 107, 191, 168);
INSERT INTO public.who_global_data VALUES (45156, 13, 8956, 0, 124, 191, 99);
INSERT INTO public.who_global_data VALUES (45157, 61, 3567, 0, 15, 191, 171);
INSERT INTO public.who_global_data VALUES (45158, 1, 2521, 0, 124, 191, 87);
INSERT INTO public.who_global_data VALUES (45159, 9, 727, 0, 9, 191, 123);
INSERT INTO public.who_global_data VALUES (45160, 0, 0, 0, 0, 191, 151);
INSERT INTO public.who_global_data VALUES (45161, 0, 269, 0, 15, 191, 213);
INSERT INTO public.who_global_data VALUES (45162, 21, 6270, 0, 156, 191, 118);
INSERT INTO public.who_global_data VALUES (45163, 0, 344, 0, 10, 191, 134);
INSERT INTO public.who_global_data VALUES (45164, 0, 2905, 0, 39, 191, 65);
INSERT INTO public.who_global_data VALUES (45165, 7208, 402697, 854, 44876, 191, 102);
INSERT INTO public.who_global_data VALUES (45166, 0, 0, 0, 0, 191, 223);
INSERT INTO public.who_global_data VALUES (45167, 2, 87, 0, 1, 191, 4);
INSERT INTO public.who_global_data VALUES (45168, 2, 291, 0, 0, 191, 146);
INSERT INTO public.who_global_data VALUES (45169, 46, 3109, 1, 48, 191, 31);
INSERT INTO public.who_global_data VALUES (45170, 0, 13, 0, 1, 191, 127);
INSERT INTO public.who_global_data VALUES (45171, 826, 22213, 7, 334, 191, 22);
INSERT INTO public.who_global_data VALUES (45172, 28, 1748, 0, 11, 191, 115);
INSERT INTO public.who_global_data VALUES (45173, 2, 353, 0, 6, 191, 106);
INSERT INTO public.who_global_data VALUES (45174, 69, 1986, 1, 9, 191, 90);
INSERT INTO public.who_global_data VALUES (45175, 0, 0, 0, 0, 191, 70);
INSERT INTO public.who_global_data VALUES (45176, 210, 19273, 0, 49, 191, 46);
INSERT INTO public.who_global_data VALUES (45177, 248, 53561, 2, 6145, 191, 139);
INSERT INTO public.who_global_data VALUES (45178, 0, 22, 0, 0, 191, 42);
INSERT INTO public.who_global_data VALUES (45179, 2, 1210, 0, 22, 191, 80);
INSERT INTO public.who_global_data VALUES (45180, 0, 3080, 0, 116, 191, 203);
INSERT INTO public.who_global_data VALUES (45181, 2, 1134, 0, 69, 191, 136);
INSERT INTO public.who_global_data VALUES (45182, 404, 42208, 5, 873, 191, 63);
INSERT INTO public.who_global_data VALUES (45183, 0, 0, 0, 0, 191, 17);
INSERT INTO public.who_global_data VALUES (45184, 0, 40, 0, 2, 191, 172);
INSERT INTO public.who_global_data VALUES (45185, 185, 10500, 5, 476, 191, 109);
INSERT INTO public.who_global_data VALUES (45186, 18, 9150, 0, 255, 191, 200);
INSERT INTO public.who_global_data VALUES (45187, 520, 14458, 2, 83, 191, 93);
INSERT INTO public.who_global_data VALUES (45188, 665, 78569, 10, 412, 191, 5);
INSERT INTO public.who_global_data VALUES (45189, 0, 741, 0, 13, 191, 214);
INSERT INTO public.who_global_data VALUES (45190, 1114, 277402, 32, 5924, 191, 204);
INSERT INTO public.who_global_data VALUES (45191, 0, 0, 0, 0, 191, 198);
INSERT INTO public.who_global_data VALUES (45192, 781, 62223, 27, 1349, 191, 173);
INSERT INTO public.who_global_data VALUES (45193, 0, 63, 1, 1, 191, 229);
INSERT INTO public.who_global_data VALUES (45194, 126, 4674, 2, 45, 191, 76);
INSERT INTO public.who_global_data VALUES (45195, 5288, 395005, 194, 18612, 191, 138);
INSERT INTO public.who_global_data VALUES (45196, 1813, 85486, 15, 1962, 191, 98);
INSERT INTO public.who_global_data VALUES (45197, 0, 0, 0, 0, 191, 103);
INSERT INTO public.who_global_data VALUES (45198, 512, 44416, 12, 1694, 191, 225);
INSERT INTO public.who_global_data VALUES (45199, 203, 50613, 3, 1725, 191, 131);
INSERT INTO public.who_global_data VALUES (45200, 221, 16061, 2, 211, 191, 235);
INSERT INTO public.who_global_data VALUES (45201, 273, 110153, 2, 169, 191, 137);
INSERT INTO public.who_global_data VALUES (45202, 18, 14269, 0, 300, 191, 81);
INSERT INTO public.who_global_data VALUES (45203, 426, 23947, 5, 762, 191, 182);
INSERT INTO public.who_global_data VALUES (45204, 0, 657, 0, 4, 191, 145);
INSERT INTO public.who_global_data VALUES (45205, 1182, 48235, 30, 2269, 191, 26);
INSERT INTO public.who_global_data VALUES (45206, 5509, 834499, 129, 13802, 191, 170);
INSERT INTO public.who_global_data VALUES (45207, 37, 1963, 0, 5, 191, 191);
INSERT INTO public.who_global_data VALUES (45208, 0, 3, 0, 0, 191, 221);
INSERT INTO public.who_global_data VALUES (45209, 1, 8, 0, 0, 191, 64);
INSERT INTO public.who_global_data VALUES (45210, 0, 0, 0, 0, 191, 116);
INSERT INTO public.who_global_data VALUES (45211, 0, 17, 0, 0, 191, 128);
INSERT INTO public.who_global_data VALUES (45212, 0, 24, 0, 0, 191, 6);
INSERT INTO public.who_global_data VALUES (45213, 4, 53, 0, 3, 191, 227);
INSERT INTO public.who_global_data VALUES (45214, 0, 4, 0, 0, 191, 68);
INSERT INTO public.who_global_data VALUES (45215, 0, 52, 0, 0, 191, 184);
INSERT INTO public.who_global_data VALUES (45216, 0, 0, 0, 0, 191, 82);
INSERT INTO public.who_global_data VALUES (45217, 0, 716, 0, 42, 191, 149);
INSERT INTO public.who_global_data VALUES (45218, 1, 868, 1, 15, 191, 197);
INSERT INTO public.who_global_data VALUES (45219, 1759, 272590, 27, 2816, 191, 78);
INSERT INTO public.who_global_data VALUES (45220, 156, 9961, 2, 200, 191, 233);
INSERT INTO public.who_global_data VALUES (45221, 372, 24892, 7, 558, 191, 133);
INSERT INTO public.who_global_data VALUES (45222, 0, 114, 0, 0, 191, 35);
INSERT INTO public.who_global_data VALUES (45223, 17, 1803, 1, 67, 191, 114);
INSERT INTO public.who_global_data VALUES (45224, 334, 51531, 0, 27, 191, 237);
INSERT INTO public.who_global_data VALUES (45225, 0, 3, 0, 0, 191, 55);
INSERT INTO public.who_global_data VALUES (45226, 6, 121, 0, 15, 191, 176);
INSERT INTO public.who_global_data VALUES (45227, 41, 2245, 0, 28, 191, 202);
INSERT INTO public.who_global_data VALUES (45228, 24, 2140, 0, 120, 191, 155);
INSERT INTO public.who_global_data VALUES (45229, 0, 0, 0, 0, 191, 32);
INSERT INTO public.who_global_data VALUES (45230, 0, 3212, 0, 93, 191, 220);
INSERT INTO public.who_global_data VALUES (45231, 11362, 471123, 240, 7497, 191, 30);
INSERT INTO public.who_global_data VALUES (45232, 0, 2322, 0, 46, 191, 147);
INSERT INTO public.who_global_data VALUES (45233, 3091, 297206, 12, 29876, 191, 208);
INSERT INTO public.who_global_data VALUES (45234, 0, 2810, 0, 11, 191, 45);
INSERT INTO public.who_global_data VALUES (45235, 0, 11579, 0, 731, 191, 110);
INSERT INTO public.who_global_data VALUES (45236, 27, 1510, 0, 24, 191, 88);
INSERT INTO public.who_global_data VALUES (45237, 283, 76080, 4, 5757, 191, 51);
INSERT INTO public.who_global_data VALUES (45238, 220, 35071, 0, 1737, 191, 209);
INSERT INTO public.who_global_data VALUES (45239, 23, 717, 0, 40, 191, 205);
INSERT INTO public.who_global_data VALUES (45240, 44, 7320, 0, 60, 191, 18);
INSERT INTO public.who_global_data VALUES (45241, 6, 3304, 0, 58, 191, 72);
INSERT INTO public.who_global_data VALUES (45242, 763, 301459, 34, 41169, 191, 44);
INSERT INTO public.who_global_data VALUES (45243, 0, 24, 0, 0, 191, 15);
INSERT INTO public.who_global_data VALUES (45244, 22, 896, 0, 18, 191, 25);
INSERT INTO public.who_global_data VALUES (45245, 0, 0, 0, 0, 191, 179);
INSERT INTO public.who_global_data VALUES (45246, 0, 0, 0, 0, 191, 34);
INSERT INTO public.who_global_data VALUES (45247, 3, 156, 0, 8, 191, 207);
INSERT INTO public.who_global_data VALUES (45248, 26, 1514, 0, 50, 191, 166);
INSERT INTO public.who_global_data VALUES (45249, 7672, 242384, 14, 5659, 191, 126);
INSERT INTO public.who_global_data VALUES (45250, 0, 0, 0, 0, 191, 97);
INSERT INTO public.who_global_data VALUES (45251, 0, 99, 0, 2, 191, 36);
INSERT INTO public.who_global_data VALUES (45252, 0, 0, 0, 0, 191, 125);
INSERT INTO public.who_global_data VALUES (45253, 0, 1135, 0, 2, 191, 124);
INSERT INTO public.who_global_data VALUES (45254, 1197, 68794, 23, 1673, 191, 185);
INSERT INTO public.who_global_data VALUES (45255, 375, 59921, 0, 347, 191, 194);
INSERT INTO public.who_global_data VALUES (45256, 0, 509, 0, 21, 191, 144);
INSERT INTO public.who_global_data VALUES (45257, 59629, 4323160, 1191, 148640, 191, 19);
INSERT INTO public.who_global_data VALUES (45258, 10, 385, 1, 8, 191, 217);
INSERT INTO public.who_global_data VALUES (45259, 16, 1218, 0, 35, 191, 148);
INSERT INTO public.who_global_data VALUES (45260, 703, 22872, 3, 132, 191, 86);
INSERT INTO public.who_global_data VALUES (45261, 0, 0, 0, 0, 191, 13);
INSERT INTO public.who_global_data VALUES (45262, 583, 16571, 5, 151, 191, 157);
INSERT INTO public.who_global_data VALUES (45263, 13, 459, 0, 0, 191, 8);
INSERT INTO public.who_global_data VALUES (45264, 0, 0, 0, 0, 191, 73);
INSERT INTO public.who_global_data VALUES (45265, 8, 1715, 1, 486, 191, 101);
INSERT INTO public.who_global_data VALUES (45266, 247, 5249, 4, 146, 191, 165);
INSERT INTO public.who_global_data VALUES (45267, 62, 2879, 1, 41, 191, 14);
INSERT INTO public.who_global_data VALUES (45268, 103, 36557, 1, 1275, 192, 193);
INSERT INTO public.who_global_data VALUES (45269, 117, 4997, 4, 148, 192, 113);
INSERT INTO public.who_global_data VALUES (45270, 642, 28615, 11, 1174, 192, 143);
INSERT INTO public.who_global_data VALUES (45271, 0, 0, 0, 0, 192, 219);
INSERT INTO public.who_global_data VALUES (45272, 4, 911, 0, 52, 192, 186);
INSERT INTO public.who_global_data VALUES (45273, 50, 1000, 6, 47, 192, 52);
INSERT INTO public.who_global_data VALUES (45274, 0, 3, 0, 0, 192, 180);
INSERT INTO public.who_global_data VALUES (45275, 4, 86, 0, 3, 192, 167);
INSERT INTO public.who_global_data VALUES (45276, 4890, 167416, 126, 3082, 192, 154);
INSERT INTO public.who_global_data VALUES (45277, 308, 37250, 4, 718, 192, 94);
INSERT INTO public.who_global_data VALUES (45278, 0, 119, 0, 3, 192, 66);
INSERT INTO public.who_global_data VALUES (45279, 369, 15304, 6, 167, 192, 58);
INSERT INTO public.who_global_data VALUES (45280, 132, 20682, 0, 713, 192, 163);
INSERT INTO public.who_global_data VALUES (45281, 412, 30858, 7, 430, 192, 37);
INSERT INTO public.who_global_data VALUES (45282, 40, 382, 0, 11, 192, 142);
INSERT INTO public.who_global_data VALUES (45283, 439, 39921, 0, 141, 192, 83);
INSERT INTO public.who_global_data VALUES (45284, 2960, 229185, 35, 3000, 192, 228);
INSERT INTO public.who_global_data VALUES (45285, 0, 110, 0, 7, 192, 188);
INSERT INTO public.who_global_data VALUES (45286, 152, 67518, 5, 548, 192, 62);
INSERT INTO public.who_global_data VALUES (45287, 685, 68352, 1, 9694, 192, 160);
INSERT INTO public.who_global_data VALUES (45288, 0, 48, 0, 2, 192, 50);
INSERT INTO public.who_global_data VALUES (45289, 35, 1805, 1, 36, 192, 33);
INSERT INTO public.who_global_data VALUES (45290, 0, 154, 0, 9, 192, 183);
INSERT INTO public.who_global_data VALUES (45291, 0, 99, 0, 0, 192, 92);
INSERT INTO public.who_global_data VALUES (45292, 1752, 71181, 64, 2647, 192, 158);
INSERT INTO public.who_global_data VALUES (45293, 0, 5, 0, 0, 192, 67);
INSERT INTO public.who_global_data VALUES (45294, 232, 10747, 3, 295, 192, 57);
INSERT INTO public.who_global_data VALUES (45295, 0, 739, 0, 2, 192, 38);
INSERT INTO public.who_global_data VALUES (45296, 23284, 2442375, 614, 87618, 192, 141);
INSERT INTO public.who_global_data VALUES (45297, 0, 8, 0, 1, 192, 178);
INSERT INTO public.who_global_data VALUES (45298, 0, 141, 0, 3, 192, 108);
INSERT INTO public.who_global_data VALUES (45299, 250, 10871, 8, 355, 192, 39);
INSERT INTO public.who_global_data VALUES (45300, 5, 1105, 0, 53, 192, 2);
INSERT INTO public.who_global_data VALUES (45301, 0, 378, 0, 1, 192, 195);
INSERT INTO public.who_global_data VALUES (45302, 26, 2354, 0, 22, 192, 107);
INSERT INTO public.who_global_data VALUES (45303, 0, 226, 0, 0, 192, 161);
INSERT INTO public.who_global_data VALUES (45304, 0, 17179, 0, 391, 192, 212);
INSERT INTO public.who_global_data VALUES (45305, 686, 114597, 11, 8901, 192, 181);
INSERT INTO public.who_global_data VALUES (45306, 0, 203, 0, 1, 192, 53);
INSERT INTO public.who_global_data VALUES (45307, 0, 4599, 0, 59, 192, 164);
INSERT INTO public.who_global_data VALUES (45308, 4, 926, 0, 75, 192, 140);
INSERT INTO public.who_global_data VALUES (45309, 1877, 349800, 53, 9240, 192, 20);
INSERT INTO public.who_global_data VALUES (45310, 212, 87457, 1, 4664, 192, 112);
INSERT INTO public.who_global_data VALUES (45311, 8125, 257101, 252, 8777, 192, 111);
INSERT INTO public.who_global_data VALUES (45312, 24, 378, 0, 7, 192, 71);
INSERT INTO public.who_global_data VALUES (45313, 41, 3200, 0, 54, 192, 218);
INSERT INTO public.who_global_data VALUES (45314, 0, 0, 0, 0, 192, 43);
INSERT INTO public.who_global_data VALUES (45315, 612, 15841, 11, 115, 192, 49);
INSERT INTO public.who_global_data VALUES (45316, 58, 15713, 2, 98, 192, 1);
INSERT INTO public.who_global_data VALUES (45317, 42, 4923, 1, 140, 192, 48);
INSERT INTO public.who_global_data VALUES (45318, 23, 2555, 0, 87, 192, 232);
INSERT INTO public.who_global_data VALUES (45319, 0, 29, 0, 1, 192, 175);
INSERT INTO public.who_global_data VALUES (45320, 7, 1067, 0, 19, 192, 21);
INSERT INTO public.who_global_data VALUES (45321, 283, 15799, 0, 373, 192, 156);
INSERT INTO public.who_global_data VALUES (45322, 0, 0, 0, 0, 192, 95);
INSERT INTO public.who_global_data VALUES (45323, 29, 8872, 0, 207, 192, 177);
INSERT INTO public.who_global_data VALUES (45324, 30, 13577, 0, 613, 192, 210);
INSERT INTO public.who_global_data VALUES (45325, 9, 5068, 0, 58, 192, 120);
INSERT INTO public.who_global_data VALUES (45326, 0, 18, 0, 0, 192, 135);
INSERT INTO public.who_global_data VALUES (45327, 534, 64690, 18, 1101, 192, 206);
INSERT INTO public.who_global_data VALUES (45328, 1118, 82279, 52, 5584, 192, 189);
INSERT INTO public.who_global_data VALUES (45329, 465, 92947, 39, 4691, 192, 129);
INSERT INTO public.who_global_data VALUES (45330, 411, 15446, 9, 417, 192, 121);
INSERT INTO public.who_global_data VALUES (45331, 0, 2350, 0, 41, 192, 59);
INSERT INTO public.who_global_data VALUES (45332, 0, 265, 0, 0, 192, 96);
INSERT INTO public.who_global_data VALUES (45333, 0, 2038, 0, 63, 192, 41);
INSERT INTO public.who_global_data VALUES (45334, 88, 2404, 5, 39, 192, 216);
INSERT INTO public.who_global_data VALUES (45335, 653, 15200, 11, 239, 192, 236);
INSERT INTO public.who_global_data VALUES (45336, 0, 13, 0, 0, 192, 150);
INSERT INTO public.who_global_data VALUES (45337, 6, 220, 0, 0, 192, 61);
INSERT INTO public.who_global_data VALUES (45338, 0, 27, 0, 0, 192, 7);
INSERT INTO public.who_global_data VALUES (45339, 6, 7404, 0, 329, 192, 169);
INSERT INTO public.who_global_data VALUES (45340, 672, 172148, 12, 30105, 192, 28);
INSERT INTO public.who_global_data VALUES (45341, 48, 7562, 1, 43, 192, 85);
INSERT INTO public.who_global_data VALUES (45342, 0, 62, 0, 0, 192, 211);
INSERT INTO public.who_global_data VALUES (45343, 0, 7189, 0, 49, 192, 60);
INSERT INTO public.who_global_data VALUES (45344, 0, 326, 0, 8, 192, 3);
INSERT INTO public.who_global_data VALUES (45345, 10, 1155, 0, 16, 192, 11);
INSERT INTO public.who_global_data VALUES (45346, 684, 206926, 6, 9128, 192, 89);
INSERT INTO public.who_global_data VALUES (45347, 782, 34406, 0, 168, 192, 24);
INSERT INTO public.who_global_data VALUES (45348, 0, 185, 0, 0, 192, 162);
INSERT INTO public.who_global_data VALUES (45349, 52, 4279, 1, 203, 192, 100);
INSERT INTO public.who_global_data VALUES (45350, 1, 14, 0, 0, 192, 47);
INSERT INTO public.who_global_data VALUES (45351, 0, 23, 0, 0, 192, 29);
INSERT INTO public.who_global_data VALUES (45352, 0, 203, 0, 14, 192, 40);
INSERT INTO public.who_global_data VALUES (45353, 2, 343, 0, 5, 192, 222);
INSERT INTO public.who_global_data VALUES (45354, 1392, 46451, 21, 1782, 192, 132);
INSERT INTO public.who_global_data VALUES (45355, 0, 252, 0, 13, 192, 130);
INSERT INTO public.who_global_data VALUES (45356, 71, 7126, 1, 46, 192, 234);
INSERT INTO public.who_global_data VALUES (45357, 0, 1954, 0, 26, 192, 23);
INSERT INTO public.who_global_data VALUES (45358, 19, 389, 0, 20, 192, 192);
INSERT INTO public.who_global_data VALUES (45359, 25, 7340, 1, 158, 192, 69);
INSERT INTO public.who_global_data VALUES (45360, 0, 12, 0, 0, 192, 187);
INSERT INTO public.who_global_data VALUES (45361, 465, 39741, 50, 1166, 192, 230);
INSERT INTO public.who_global_data VALUES (45362, 9, 4465, 0, 596, 192, 77);
INSERT INTO public.who_global_data VALUES (45363, 3, 1857, 0, 10, 192, 9);
INSERT INTO public.who_global_data VALUES (45364, 48513, 1531669, 768, 34193, 192, 74);
INSERT INTO public.who_global_data VALUES (45365, 1748, 102051, 63, 4901, 192, 224);
INSERT INTO public.who_global_data VALUES (45366, 2667, 296273, 235, 16147, 192, 199);
INSERT INTO public.who_global_data VALUES (45367, 2747, 115332, 77, 4535, 192, 190);
INSERT INTO public.who_global_data VALUES (45368, 37, 25929, 0, 1763, 192, 12);
INSERT INTO public.who_global_data VALUES (45369, 0, 336, 0, 24, 192, 104);
INSERT INTO public.who_global_data VALUES (45370, 2048, 64516, 7, 512, 192, 153);
INSERT INTO public.who_global_data VALUES (45371, 202, 246488, 11, 35123, 192, 91);
INSERT INTO public.who_global_data VALUES (45372, 11, 853, 0, 10, 192, 215);
INSERT INTO public.who_global_data VALUES (45373, 940, 31901, 3, 1001, 192, 84);
INSERT INTO public.who_global_data VALUES (45374, 2, 334, 0, 31, 192, 231);
INSERT INTO public.who_global_data VALUES (45375, 6, 1250, 0, 11, 192, 196);
INSERT INTO public.who_global_data VALUES (45376, 1472, 87664, 0, 793, 192, 105);
INSERT INTO public.who_global_data VALUES (45377, 606, 18581, 14, 299, 192, 122);
INSERT INTO public.who_global_data VALUES (45378, 0, 0, 0, 0, 192, 159);
INSERT INTO public.who_global_data VALUES (45379, 239, 7609, 7, 182, 192, 75);
INSERT INTO public.who_global_data VALUES (45380, 770, 65149, 4, 442, 192, 27);
INSERT INTO public.who_global_data VALUES (45381, 668, 34512, 18, 902, 192, 54);
INSERT INTO public.who_global_data VALUES (45382, 0, 20, 0, 0, 192, 226);
INSERT INTO public.who_global_data VALUES (45383, 0, 1220, 0, 31, 192, 79);
INSERT INTO public.who_global_data VALUES (45384, 141, 4023, 3, 54, 192, 56);
INSERT INTO public.who_global_data VALUES (45385, 0, 505, 0, 12, 192, 117);
INSERT INTO public.who_global_data VALUES (45386, 0, 1167, 0, 72, 192, 152);
INSERT INTO public.who_global_data VALUES (45387, 190, 3017, 3, 67, 192, 16);
INSERT INTO public.who_global_data VALUES (45388, 1, 89, 0, 1, 192, 10);
INSERT INTO public.who_global_data VALUES (45389, 15, 2037, 0, 80, 192, 201);
INSERT INTO public.who_global_data VALUES (45390, 54, 6375, 1, 113, 192, 174);
INSERT INTO public.who_global_data VALUES (45391, 414, 10104, 2, 93, 192, 119);
INSERT INTO public.who_global_data VALUES (45392, 29, 3738, 0, 103, 192, 168);
INSERT INTO public.who_global_data VALUES (45393, 39, 8943, 0, 124, 192, 99);
INSERT INTO public.who_global_data VALUES (45394, 137, 3506, 0, 15, 192, 171);
INSERT INTO public.who_global_data VALUES (45395, 7, 2520, 0, 124, 192, 87);
INSERT INTO public.who_global_data VALUES (45396, 13, 718, 0, 9, 192, 123);
INSERT INTO public.who_global_data VALUES (45397, 0, 0, 0, 0, 192, 151);
INSERT INTO public.who_global_data VALUES (45398, 0, 269, 0, 15, 192, 213);
INSERT INTO public.who_global_data VALUES (45399, 41, 6249, 0, 156, 192, 118);
INSERT INTO public.who_global_data VALUES (45400, 0, 344, 0, 10, 192, 134);
INSERT INTO public.who_global_data VALUES (45401, 5, 2905, 1, 39, 192, 65);
INSERT INTO public.who_global_data VALUES (45402, 4973, 395489, 342, 44022, 192, 102);
INSERT INTO public.who_global_data VALUES (45403, 0, 0, 0, 0, 192, 223);
INSERT INTO public.who_global_data VALUES (45404, 1, 85, 0, 1, 192, 4);
INSERT INTO public.who_global_data VALUES (45405, 1, 289, 0, 0, 192, 146);
INSERT INTO public.who_global_data VALUES (45406, 66, 3063, 2, 47, 192, 31);
INSERT INTO public.who_global_data VALUES (45407, 0, 13, 0, 1, 192, 127);
INSERT INTO public.who_global_data VALUES (45408, 500, 21387, 11, 327, 192, 22);
INSERT INTO public.who_global_data VALUES (45409, 19, 1720, 0, 11, 192, 115);
INSERT INTO public.who_global_data VALUES (45410, 1, 351, 0, 6, 192, 106);
INSERT INTO public.who_global_data VALUES (45411, 75, 1917, 0, 8, 192, 90);
INSERT INTO public.who_global_data VALUES (45412, 0, 0, 0, 0, 192, 70);
INSERT INTO public.who_global_data VALUES (45413, 311, 19063, 1, 49, 192, 46);
INSERT INTO public.who_global_data VALUES (45414, 224, 53313, 4, 6143, 192, 139);
INSERT INTO public.who_global_data VALUES (45415, 0, 22, 0, 0, 192, 42);
INSERT INTO public.who_global_data VALUES (45416, 1, 1208, 0, 22, 192, 80);
INSERT INTO public.who_global_data VALUES (45417, 76, 3080, 8, 116, 192, 203);
INSERT INTO public.who_global_data VALUES (45418, 0, 1132, 0, 69, 192, 136);
INSERT INTO public.who_global_data VALUES (45419, 624, 41804, 8, 868, 192, 63);
INSERT INTO public.who_global_data VALUES (45420, 0, 0, 0, 0, 192, 17);
INSERT INTO public.who_global_data VALUES (45421, 0, 40, 0, 2, 192, 172);
INSERT INTO public.who_global_data VALUES (45422, 102, 10315, 5, 471, 192, 109);
INSERT INTO public.who_global_data VALUES (45423, 15, 9132, 0, 255, 192, 200);
INSERT INTO public.who_global_data VALUES (45424, 481, 13938, 0, 81, 192, 93);
INSERT INTO public.who_global_data VALUES (45425, 846, 77904, 9, 402, 192, 5);
INSERT INTO public.who_global_data VALUES (45426, 0, 741, 0, 13, 192, 214);
INSERT INTO public.who_global_data VALUES (45427, 1063, 276288, 27, 5892, 192, 204);
INSERT INTO public.who_global_data VALUES (45428, 0, 0, 0, 0, 192, 198);
INSERT INTO public.who_global_data VALUES (45429, 1146, 61442, 28, 1322, 192, 173);
INSERT INTO public.who_global_data VALUES (45430, 1, 63, 0, 0, 192, 229);
INSERT INTO public.who_global_data VALUES (45431, 104, 4548, 2, 43, 192, 76);
INSERT INTO public.who_global_data VALUES (45432, 4920, 389717, 189, 18418, 192, 138);
INSERT INTO public.who_global_data VALUES (45433, 1633, 83673, 2, 1947, 192, 98);
INSERT INTO public.who_global_data VALUES (45434, 0, 0, 0, 0, 192, 103);
INSERT INTO public.who_global_data VALUES (45435, 502, 43904, 6, 1682, 192, 225);
INSERT INTO public.who_global_data VALUES (45436, 111, 50410, 3, 1722, 192, 131);
INSERT INTO public.who_global_data VALUES (45437, 409, 15840, 8, 209, 192, 235);
INSERT INTO public.who_global_data VALUES (45438, 283, 109880, 2, 167, 192, 137);
INSERT INTO public.who_global_data VALUES (45439, 48, 14251, 0, 300, 192, 81);
INSERT INTO public.who_global_data VALUES (45440, 367, 23521, 6, 757, 192, 182);
INSERT INTO public.who_global_data VALUES (45441, 0, 657, 0, 4, 192, 145);
INSERT INTO public.who_global_data VALUES (45442, 1151, 47053, 33, 2239, 192, 26);
INSERT INTO public.who_global_data VALUES (45443, 5475, 828990, 169, 13673, 192, 170);
INSERT INTO public.who_global_data VALUES (45444, 47, 1926, 0, 5, 192, 191);
INSERT INTO public.who_global_data VALUES (45445, 0, 3, 0, 0, 192, 221);
INSERT INTO public.who_global_data VALUES (45446, 0, 7, 0, 0, 192, 64);
INSERT INTO public.who_global_data VALUES (45447, 0, 0, 0, 0, 192, 116);
INSERT INTO public.who_global_data VALUES (45448, 0, 17, 0, 0, 192, 128);
INSERT INTO public.who_global_data VALUES (45449, 0, 24, 0, 0, 192, 6);
INSERT INTO public.who_global_data VALUES (45450, 0, 49, 0, 3, 192, 227);
INSERT INTO public.who_global_data VALUES (45451, 0, 4, 0, 0, 192, 68);
INSERT INTO public.who_global_data VALUES (45452, 0, 52, 0, 0, 192, 184);
INSERT INTO public.who_global_data VALUES (45453, 0, 0, 0, 0, 192, 82);
INSERT INTO public.who_global_data VALUES (45454, 0, 716, 0, 42, 192, 149);
INSERT INTO public.who_global_data VALUES (45455, 2, 867, 0, 14, 192, 197);
INSERT INTO public.who_global_data VALUES (45456, 1897, 270831, 29, 2789, 192, 78);
INSERT INTO public.who_global_data VALUES (45457, 41, 9805, 4, 198, 192, 233);
INSERT INTO public.who_global_data VALUES (45458, 379, 24520, 8, 551, 192, 133);
INSERT INTO public.who_global_data VALUES (45459, 0, 114, 0, 0, 192, 35);
INSERT INTO public.who_global_data VALUES (45460, 3, 1786, 0, 66, 192, 114);
INSERT INTO public.who_global_data VALUES (45461, 359, 51197, 0, 27, 192, 237);
INSERT INTO public.who_global_data VALUES (45462, 0, 3, 0, 0, 192, 55);
INSERT INTO public.who_global_data VALUES (45463, 1, 115, 0, 15, 192, 176);
INSERT INTO public.who_global_data VALUES (45464, 23, 2204, 0, 28, 192, 202);
INSERT INTO public.who_global_data VALUES (45465, 14, 2116, 1, 120, 192, 155);
INSERT INTO public.who_global_data VALUES (45466, 0, 0, 0, 0, 192, 32);
INSERT INTO public.who_global_data VALUES (45467, 16, 3212, 0, 93, 192, 220);
INSERT INTO public.who_global_data VALUES (45468, 7231, 459761, 190, 7257, 192, 30);
INSERT INTO public.who_global_data VALUES (45469, 17, 2322, 0, 46, 192, 147);
INSERT INTO public.who_global_data VALUES (45470, 2158, 294115, 8, 29864, 192, 208);
INSERT INTO public.who_global_data VALUES (45471, 5, 2810, 0, 11, 192, 45);
INSERT INTO public.who_global_data VALUES (45472, 83, 11579, 6, 731, 192, 110);
INSERT INTO public.who_global_data VALUES (45473, 44, 1483, 1, 24, 192, 88);
INSERT INTO public.who_global_data VALUES (45474, 71, 75797, 6, 5753, 192, 51);
INSERT INTO public.who_global_data VALUES (45475, 189, 34851, 1, 1737, 192, 209);
INSERT INTO public.who_global_data VALUES (45476, 20, 694, 0, 40, 192, 205);
INSERT INTO public.who_global_data VALUES (45477, 41, 7276, 0, 60, 192, 18);
INSERT INTO public.who_global_data VALUES (45478, 1, 3298, 0, 58, 192, 72);
INSERT INTO public.who_global_data VALUES (45479, 70, 300696, 21, 41135, 192, 44);
INSERT INTO public.who_global_data VALUES (45480, 0, 24, 0, 0, 192, 15);
INSERT INTO public.who_global_data VALUES (45481, 0, 874, 0, 18, 192, 25);
INSERT INTO public.who_global_data VALUES (45482, 0, 0, 0, 0, 192, 179);
INSERT INTO public.who_global_data VALUES (45483, 0, 0, 0, 0, 192, 34);
INSERT INTO public.who_global_data VALUES (45484, 5, 153, 0, 8, 192, 207);
INSERT INTO public.who_global_data VALUES (45485, 20, 1488, 0, 50, 192, 166);
INSERT INTO public.who_global_data VALUES (45486, 7693, 234712, 15, 5645, 192, 126);
INSERT INTO public.who_global_data VALUES (45487, 0, 0, 0, 0, 192, 97);
INSERT INTO public.who_global_data VALUES (45488, 0, 99, 0, 2, 192, 36);
INSERT INTO public.who_global_data VALUES (45489, 0, 0, 0, 0, 192, 125);
INSERT INTO public.who_global_data VALUES (45490, 7, 1135, 0, 2, 192, 124);
INSERT INTO public.who_global_data VALUES (45491, 1022, 67597, 21, 1650, 192, 185);
INSERT INTO public.who_global_data VALUES (45492, 369, 59546, 2, 347, 192, 194);
INSERT INTO public.who_global_data VALUES (45493, 0, 509, 0, 21, 192, 144);
INSERT INTO public.who_global_data VALUES (45494, 54022, 4263531, 1118, 147449, 192, 19);
INSERT INTO public.who_global_data VALUES (45495, 11, 375, 0, 7, 192, 217);
INSERT INTO public.who_global_data VALUES (45496, 10, 1202, 1, 35, 192, 148);
INSERT INTO public.who_global_data VALUES (45497, 663, 22169, 10, 129, 192, 86);
INSERT INTO public.who_global_data VALUES (45498, 0, 0, 0, 0, 192, 13);
INSERT INTO public.who_global_data VALUES (45499, 525, 15988, 4, 146, 192, 157);
INSERT INTO public.who_global_data VALUES (45500, 15, 446, 0, 0, 192, 8);
INSERT INTO public.who_global_data VALUES (45501, 0, 0, 0, 0, 192, 73);
INSERT INTO public.who_global_data VALUES (45502, 12, 1707, 1, 485, 192, 101);
INSERT INTO public.who_global_data VALUES (45503, 450, 5002, 2, 142, 192, 165);
INSERT INTO public.who_global_data VALUES (45504, 113, 2817, 4, 40, 192, 14);
INSERT INTO public.who_global_data VALUES (45505, 105, 36454, 1, 1274, 193, 193);
INSERT INTO public.who_global_data VALUES (45506, 117, 4880, 6, 144, 193, 113);
INSERT INTO public.who_global_data VALUES (45507, 616, 27973, 8, 1163, 193, 143);
INSERT INTO public.who_global_data VALUES (45508, 0, 0, 0, 0, 193, 219);
INSERT INTO public.who_global_data VALUES (45509, 3, 907, 0, 52, 193, 186);
INSERT INTO public.who_global_data VALUES (45510, 18, 950, 1, 41, 193, 52);
INSERT INTO public.who_global_data VALUES (45511, 0, 3, 0, 0, 193, 180);
INSERT INTO public.who_global_data VALUES (45512, 0, 82, 0, 3, 193, 167);
INSERT INTO public.who_global_data VALUES (45513, 4205, 162526, 43, 2956, 193, 154);
INSERT INTO public.who_global_data VALUES (45514, 239, 36942, 8, 714, 193, 94);
INSERT INTO public.who_global_data VALUES (45515, 2, 119, 0, 3, 193, 66);
INSERT INTO public.who_global_data VALUES (45516, 532, 14935, 6, 161, 193, 58);
INSERT INTO public.who_global_data VALUES (45517, 64, 20550, 1, 713, 193, 163);
INSERT INTO public.who_global_data VALUES (45518, 396, 30446, 6, 423, 193, 37);
INSERT INTO public.who_global_data VALUES (45519, 16, 342, 0, 11, 193, 142);
INSERT INTO public.who_global_data VALUES (45520, 351, 39482, 0, 141, 193, 83);
INSERT INTO public.who_global_data VALUES (45521, 2772, 226225, 37, 2965, 193, 228);
INSERT INTO public.who_global_data VALUES (45522, 2, 110, 0, 7, 193, 188);
INSERT INTO public.who_global_data VALUES (45523, 234, 67366, 9, 543, 193, 62);
INSERT INTO public.who_global_data VALUES (45524, 595, 67667, 4, 9693, 193, 160);
INSERT INTO public.who_global_data VALUES (45525, 0, 48, 0, 2, 193, 50);
INSERT INTO public.who_global_data VALUES (45526, 0, 1770, 0, 35, 193, 33);
INSERT INTO public.who_global_data VALUES (45527, 0, 154, 0, 9, 193, 183);
INSERT INTO public.who_global_data VALUES (45528, 4, 99, 0, 0, 193, 92);
INSERT INTO public.who_global_data VALUES (45529, 1148, 69429, 48, 2583, 193, 158);
INSERT INTO public.who_global_data VALUES (45530, 0, 5, 0, 0, 193, 67);
INSERT INTO public.who_global_data VALUES (45531, 183, 10515, 7, 292, 193, 57);
INSERT INTO public.who_global_data VALUES (45532, 53, 739, 1, 2, 193, 38);
INSERT INTO public.who_global_data VALUES (45533, 24578, 2419091, 555, 87004, 193, 141);
INSERT INTO public.who_global_data VALUES (45534, 0, 8, 0, 1, 193, 178);
INSERT INTO public.who_global_data VALUES (45535, 0, 141, 0, 3, 193, 108);
INSERT INTO public.who_global_data VALUES (45536, 194, 10621, 7, 347, 193, 39);
INSERT INTO public.who_global_data VALUES (45537, 14, 1100, 0, 53, 193, 2);
INSERT INTO public.who_global_data VALUES (45538, 17, 378, 0, 1, 193, 195);
INSERT INTO public.who_global_data VALUES (45539, 21, 2328, 0, 22, 193, 107);
INSERT INTO public.who_global_data VALUES (45540, 1, 226, 0, 0, 193, 161);
INSERT INTO public.who_global_data VALUES (45541, 69, 17179, 0, 391, 193, 212);
INSERT INTO public.who_global_data VALUES (45542, 355, 113911, 5, 8890, 193, 181);
INSERT INTO public.who_global_data VALUES (45543, 0, 203, 0, 1, 193, 53);
INSERT INTO public.who_global_data VALUES (45544, 1, 4599, 0, 59, 193, 164);
INSERT INTO public.who_global_data VALUES (45545, 7, 922, 0, 75, 193, 140);
INSERT INTO public.who_global_data VALUES (45546, 2133, 347923, 75, 9187, 193, 20);
INSERT INTO public.who_global_data VALUES (45547, 217, 87245, 4, 4663, 193, 112);
INSERT INTO public.who_global_data VALUES (45548, 8181, 248976, 256, 8525, 193, 111);
INSERT INTO public.who_global_data VALUES (45549, 0, 354, 0, 7, 193, 71);
INSERT INTO public.who_global_data VALUES (45550, 0, 3159, 0, 54, 193, 218);
INSERT INTO public.who_global_data VALUES (45551, 0, 0, 0, 0, 193, 43);
INSERT INTO public.who_global_data VALUES (45552, 629, 15229, 6, 104, 193, 49);
INSERT INTO public.who_global_data VALUES (45553, 59, 15655, 0, 96, 193, 1);
INSERT INTO public.who_global_data VALUES (45554, 24, 4881, 3, 139, 193, 48);
INSERT INTO public.who_global_data VALUES (45555, 37, 2532, 0, 87, 193, 232);
INSERT INTO public.who_global_data VALUES (45556, 0, 29, 0, 1, 193, 175);
INSERT INTO public.who_global_data VALUES (45557, 3, 1060, 0, 19, 193, 21);
INSERT INTO public.who_global_data VALUES (45558, 192, 15516, 2, 373, 193, 156);
INSERT INTO public.who_global_data VALUES (45559, 0, 0, 0, 0, 193, 95);
INSERT INTO public.who_global_data VALUES (45560, 13, 8843, 4, 207, 193, 177);
INSERT INTO public.who_global_data VALUES (45561, 109, 13547, 0, 613, 193, 210);
INSERT INTO public.who_global_data VALUES (45562, 9, 5059, 0, 58, 193, 120);
INSERT INTO public.who_global_data VALUES (45563, 0, 18, 0, 0, 193, 135);
INSERT INTO public.who_global_data VALUES (45564, 1248, 64156, 20, 1083, 193, 206);
INSERT INTO public.who_global_data VALUES (45565, 467, 81161, 17, 5532, 193, 189);
INSERT INTO public.who_global_data VALUES (45566, 420, 92482, 46, 4652, 193, 129);
INSERT INTO public.who_global_data VALUES (45567, 405, 15035, 8, 408, 193, 121);
INSERT INTO public.who_global_data VALUES (45568, 0, 2350, 0, 41, 193, 59);
INSERT INTO public.who_global_data VALUES (45569, 2, 265, 0, 0, 193, 96);
INSERT INTO public.who_global_data VALUES (45570, 4, 2038, 0, 63, 193, 41);
INSERT INTO public.who_global_data VALUES (45571, 109, 2316, 2, 34, 193, 216);
INSERT INTO public.who_global_data VALUES (45572, 579, 14547, 5, 228, 193, 236);
INSERT INTO public.who_global_data VALUES (45573, 0, 13, 0, 0, 193, 150);
INSERT INTO public.who_global_data VALUES (45574, 23, 214, 0, 0, 193, 61);
INSERT INTO public.who_global_data VALUES (45575, 0, 27, 0, 0, 193, 7);
INSERT INTO public.who_global_data VALUES (45576, 5, 7398, 0, 329, 193, 169);
INSERT INTO public.who_global_data VALUES (45577, 2254, 171476, 15, 30093, 193, 28);
INSERT INTO public.who_global_data VALUES (45578, 182, 7514, 1, 42, 193, 85);
INSERT INTO public.who_global_data VALUES (45579, 0, 62, 0, 0, 193, 211);
INSERT INTO public.who_global_data VALUES (45580, 205, 7189, 0, 49, 193, 60);
INSERT INTO public.who_global_data VALUES (45581, 49, 326, 2, 8, 193, 3);
INSERT INTO public.who_global_data VALUES (45582, 8, 1145, 0, 16, 193, 11);
INSERT INTO public.who_global_data VALUES (45583, 633, 206242, 4, 9122, 193, 89);
INSERT INTO public.who_global_data VALUES (45584, 1187, 33624, 7, 168, 193, 24);
INSERT INTO public.who_global_data VALUES (45585, 0, 185, 0, 0, 193, 162);
INSERT INTO public.who_global_data VALUES (45586, 34, 4227, 0, 202, 193, 100);
INSERT INTO public.who_global_data VALUES (45587, 0, 13, 0, 0, 193, 47);
INSERT INTO public.who_global_data VALUES (45588, 0, 23, 0, 0, 193, 29);
INSERT INTO public.who_global_data VALUES (45589, 0, 203, 0, 14, 193, 40);
INSERT INTO public.who_global_data VALUES (45590, 12, 341, 0, 5, 193, 222);
INSERT INTO public.who_global_data VALUES (45591, 6, 45059, 27, 1761, 193, 132);
INSERT INTO public.who_global_data VALUES (45592, 0, 252, 0, 13, 193, 130);
INSERT INTO public.who_global_data VALUES (45593, 47, 7055, 2, 45, 193, 234);
INSERT INTO public.who_global_data VALUES (45594, 0, 1954, 0, 26, 193, 23);
INSERT INTO public.who_global_data VALUES (45595, 10, 370, 0, 20, 193, 192);
INSERT INTO public.who_global_data VALUES (45596, 18, 7315, 0, 157, 193, 69);
INSERT INTO public.who_global_data VALUES (45597, 0, 12, 0, 0, 193, 187);
INSERT INTO public.who_global_data VALUES (45598, 838, 39276, 18, 1116, 193, 230);
INSERT INTO public.who_global_data VALUES (45599, 8, 4456, 0, 596, 193, 77);
INSERT INTO public.who_global_data VALUES (45600, 7, 1854, 0, 10, 193, 9);
INSERT INTO public.who_global_data VALUES (45601, 47703, 1483156, 654, 33425, 193, 74);
INSERT INTO public.who_global_data VALUES (45602, 1525, 100303, 57, 4838, 193, 224);
INSERT INTO public.who_global_data VALUES (45603, 2434, 293606, 212, 15912, 193, 199);
INSERT INTO public.who_global_data VALUES (45604, 2553, 112585, 96, 4458, 193, 190);
INSERT INTO public.who_global_data VALUES (45605, 11, 25892, 0, 1763, 193, 12);
INSERT INTO public.who_global_data VALUES (45606, 0, 336, 0, 24, 193, 104);
INSERT INTO public.who_global_data VALUES (45607, 1042, 62468, 11, 505, 193, 153);
INSERT INTO public.who_global_data VALUES (45608, 168, 246286, 5, 35112, 193, 91);
INSERT INTO public.who_global_data VALUES (45609, 5, 842, 0, 10, 193, 215);
INSERT INTO public.who_global_data VALUES (45610, 972, 30961, 2, 998, 193, 84);
INSERT INTO public.who_global_data VALUES (45611, 0, 332, 0, 31, 193, 231);
INSERT INTO public.who_global_data VALUES (45612, 8, 1244, 0, 11, 193, 196);
INSERT INTO public.who_global_data VALUES (45613, 1544, 86192, 208, 793, 193, 105);
INSERT INTO public.who_global_data VALUES (45614, 1332, 17975, 7, 285, 193, 122);
INSERT INTO public.who_global_data VALUES (45615, 0, 0, 0, 0, 193, 159);
INSERT INTO public.who_global_data VALUES (45616, 276, 7370, 8, 175, 193, 75);
INSERT INTO public.who_global_data VALUES (45617, 606, 64379, 5, 438, 193, 27);
INSERT INTO public.who_global_data VALUES (45618, 548, 33844, 28, 884, 193, 54);
INSERT INTO public.who_global_data VALUES (45619, 0, 20, 0, 0, 193, 226);
INSERT INTO public.who_global_data VALUES (45620, 1, 1220, 0, 31, 193, 79);
INSERT INTO public.who_global_data VALUES (45621, 132, 3882, 0, 51, 193, 56);
INSERT INTO public.who_global_data VALUES (45622, 0, 505, 0, 12, 193, 117);
INSERT INTO public.who_global_data VALUES (45623, 5, 1167, 0, 72, 193, 152);
INSERT INTO public.who_global_data VALUES (45624, 158, 2827, 4, 64, 193, 16);
INSERT INTO public.who_global_data VALUES (45625, 1, 88, 0, 1, 193, 10);
INSERT INTO public.who_global_data VALUES (45626, 8, 2022, 0, 80, 193, 201);
INSERT INTO public.who_global_data VALUES (45627, 49, 6321, 0, 112, 193, 174);
INSERT INTO public.who_global_data VALUES (45628, 395, 9690, 6, 91, 193, 119);
INSERT INTO public.who_global_data VALUES (45629, 45, 3709, 4, 103, 193, 168);
INSERT INTO public.who_global_data VALUES (45630, 7, 8904, 0, 124, 193, 99);
INSERT INTO public.who_global_data VALUES (45631, 67, 3369, 0, 15, 193, 171);
INSERT INTO public.who_global_data VALUES (45632, 3, 2513, 1, 124, 193, 87);
INSERT INTO public.who_global_data VALUES (45633, 6, 705, 0, 9, 193, 123);
INSERT INTO public.who_global_data VALUES (45634, 0, 0, 0, 0, 193, 151);
INSERT INTO public.who_global_data VALUES (45635, 0, 269, 0, 15, 193, 213);
INSERT INTO public.who_global_data VALUES (45636, 37, 6208, 0, 156, 193, 118);
INSERT INTO public.who_global_data VALUES (45637, 0, 344, 0, 10, 193, 134);
INSERT INTO public.who_global_data VALUES (45638, 27, 2900, 0, 38, 193, 65);
INSERT INTO public.who_global_data VALUES (45639, 5480, 390516, 306, 43680, 193, 102);
INSERT INTO public.who_global_data VALUES (45640, 0, 0, 0, 0, 193, 223);
INSERT INTO public.who_global_data VALUES (45641, 0, 84, 0, 1, 193, 4);
INSERT INTO public.who_global_data VALUES (45642, 0, 288, 0, 0, 193, 146);
INSERT INTO public.who_global_data VALUES (45643, 63, 2997, 0, 45, 193, 31);
INSERT INTO public.who_global_data VALUES (45644, 0, 13, 0, 1, 193, 127);
INSERT INTO public.who_global_data VALUES (45645, 609, 20887, 3, 316, 193, 22);
INSERT INTO public.who_global_data VALUES (45646, 32, 1701, 0, 11, 193, 115);
INSERT INTO public.who_global_data VALUES (45647, 0, 350, 0, 6, 193, 106);
INSERT INTO public.who_global_data VALUES (45648, 68, 1842, 0, 8, 193, 90);
INSERT INTO public.who_global_data VALUES (45649, 0, 0, 0, 0, 193, 70);
INSERT INTO public.who_global_data VALUES (45650, 139, 18752, 3, 48, 193, 46);
INSERT INTO public.who_global_data VALUES (45651, 209, 53089, 1, 6139, 193, 139);
INSERT INTO public.who_global_data VALUES (45652, 0, 22, 0, 0, 193, 42);
INSERT INTO public.who_global_data VALUES (45653, 1, 1207, 0, 22, 193, 80);
INSERT INTO public.who_global_data VALUES (45654, 0, 3004, 0, 108, 193, 203);
INSERT INTO public.who_global_data VALUES (45655, 0, 1132, 0, 69, 193, 136);
INSERT INTO public.who_global_data VALUES (45656, 648, 41180, 2, 860, 193, 63);
INSERT INTO public.who_global_data VALUES (45657, 0, 0, 0, 0, 193, 17);
INSERT INTO public.who_global_data VALUES (45658, 0, 40, 0, 2, 193, 172);
INSERT INTO public.who_global_data VALUES (45659, 127, 10213, 6, 466, 193, 109);
INSERT INTO public.who_global_data VALUES (45660, 32, 9117, 0, 255, 193, 200);
INSERT INTO public.who_global_data VALUES (45661, 332, 13457, 2, 81, 193, 93);
INSERT INTO public.who_global_data VALUES (45662, 1053, 77058, 9, 393, 193, 5);
INSERT INTO public.who_global_data VALUES (45663, 0, 741, 0, 13, 193, 214);
INSERT INTO public.who_global_data VALUES (45664, 936, 275225, 23, 5865, 193, 204);
INSERT INTO public.who_global_data VALUES (45665, 0, 0, 0, 0, 193, 198);
INSERT INTO public.who_global_data VALUES (45666, 1432, 60296, 19, 1294, 193, 173);
INSERT INTO public.who_global_data VALUES (45667, 0, 62, 0, 0, 193, 229);
INSERT INTO public.who_global_data VALUES (45668, 116, 4444, 1, 41, 193, 76);
INSERT INTO public.who_global_data VALUES (45669, 4913, 384797, 199, 18229, 193, 138);
INSERT INTO public.who_global_data VALUES (45670, 1592, 82040, 13, 1945, 193, 98);
INSERT INTO public.who_global_data VALUES (45671, 0, 0, 0, 0, 193, 103);
INSERT INTO public.who_global_data VALUES (45672, 337, 43402, 5, 1676, 193, 225);
INSERT INTO public.who_global_data VALUES (45673, 135, 50299, 2, 1719, 193, 131);
INSERT INTO public.who_global_data VALUES (45674, 288, 15431, 0, 201, 193, 235);
INSERT INTO public.who_global_data VALUES (45675, 292, 109597, 0, 165, 193, 137);
INSERT INTO public.who_global_data VALUES (45676, 28, 14203, 1, 300, 193, 81);
INSERT INTO public.who_global_data VALUES (45677, 120, 23154, 11, 751, 193, 182);
INSERT INTO public.who_global_data VALUES (45678, 0, 657, 1, 4, 193, 145);
INSERT INTO public.who_global_data VALUES (45679, 1104, 45902, 19, 2206, 193, 26);
INSERT INTO public.who_global_data VALUES (45680, 5395, 823515, 150, 13504, 193, 170);
INSERT INTO public.who_global_data VALUES (45681, 56, 1879, 0, 5, 193, 191);
INSERT INTO public.who_global_data VALUES (45682, 0, 3, 0, 0, 193, 221);
INSERT INTO public.who_global_data VALUES (45683, 0, 7, 0, 0, 193, 64);
INSERT INTO public.who_global_data VALUES (45684, 0, 0, 0, 0, 193, 116);
INSERT INTO public.who_global_data VALUES (45685, 0, 17, 0, 0, 193, 128);
INSERT INTO public.who_global_data VALUES (45686, 0, 24, 0, 0, 193, 6);
INSERT INTO public.who_global_data VALUES (45687, 0, 49, 0, 3, 193, 227);
INSERT INTO public.who_global_data VALUES (45688, 0, 4, 0, 0, 193, 68);
INSERT INTO public.who_global_data VALUES (45689, 0, 52, 0, 0, 193, 184);
INSERT INTO public.who_global_data VALUES (45690, 0, 0, 0, 0, 193, 82);
INSERT INTO public.who_global_data VALUES (45691, 0, 716, 0, 42, 193, 149);
INSERT INTO public.who_global_data VALUES (45692, 2, 865, 0, 14, 193, 197);
INSERT INTO public.who_global_data VALUES (45693, 1993, 268934, 27, 2760, 193, 78);
INSERT INTO public.who_global_data VALUES (45694, 83, 9764, 3, 194, 193, 233);
INSERT INTO public.who_global_data VALUES (45695, 411, 24141, 9, 543, 193, 133);
INSERT INTO public.who_global_data VALUES (45696, 7, 114, 0, 0, 193, 35);
INSERT INTO public.who_global_data VALUES (45697, 0, 1783, 0, 66, 193, 114);
INSERT INTO public.who_global_data VALUES (45698, 469, 50838, 0, 27, 193, 237);
INSERT INTO public.who_global_data VALUES (45699, 0, 3, 0, 0, 193, 55);
INSERT INTO public.who_global_data VALUES (45700, 20, 114, 0, 15, 193, 176);
INSERT INTO public.who_global_data VALUES (45701, 2, 2181, 0, 28, 193, 202);
INSERT INTO public.who_global_data VALUES (45702, 14, 2102, 0, 119, 193, 155);
INSERT INTO public.who_global_data VALUES (45703, 0, 0, 0, 0, 193, 32);
INSERT INTO public.who_global_data VALUES (45704, 18, 3196, 0, 93, 193, 220);
INSERT INTO public.who_global_data VALUES (45705, 7097, 452530, 298, 7067, 193, 30);
INSERT INTO public.who_global_data VALUES (45706, 0, 2305, 0, 46, 193, 147);
INSERT INTO public.who_global_data VALUES (45707, 1462, 291957, 7, 29856, 193, 208);
INSERT INTO public.who_global_data VALUES (45708, 23, 2805, 0, 11, 193, 45);
INSERT INTO public.who_global_data VALUES (45709, 72, 11496, 5, 725, 193, 110);
INSERT INTO public.who_global_data VALUES (45710, 58, 1439, 0, 23, 193, 88);
INSERT INTO public.who_global_data VALUES (45711, 42, 75726, 2, 5747, 193, 51);
INSERT INTO public.who_global_data VALUES (45712, 193, 34662, 1, 1736, 193, 209);
INSERT INTO public.who_global_data VALUES (45713, 24, 674, 2, 40, 193, 205);
INSERT INTO public.who_global_data VALUES (45714, 43, 7235, 1, 60, 193, 18);
INSERT INTO public.who_global_data VALUES (45715, 2, 3297, 0, 58, 193, 72);
INSERT INTO public.who_global_data VALUES (45716, 371, 300626, 3, 41114, 193, 44);
INSERT INTO public.who_global_data VALUES (45717, 0, 24, 0, 0, 193, 15);
INSERT INTO public.who_global_data VALUES (45718, 6, 874, 0, 18, 193, 25);
INSERT INTO public.who_global_data VALUES (45719, 0, 0, 0, 0, 193, 179);
INSERT INTO public.who_global_data VALUES (45720, 0, 0, 0, 0, 193, 34);
INSERT INTO public.who_global_data VALUES (45721, 1, 148, 0, 8, 193, 207);
INSERT INTO public.who_global_data VALUES (45722, 13, 1468, 0, 50, 193, 166);
INSERT INTO public.who_global_data VALUES (45723, 919, 227019, 17, 5630, 193, 126);
INSERT INTO public.who_global_data VALUES (45724, 0, 0, 0, 0, 193, 97);
INSERT INTO public.who_global_data VALUES (45725, 2, 99, 0, 2, 193, 36);
INSERT INTO public.who_global_data VALUES (45726, 0, 0, 0, 0, 193, 125);
INSERT INTO public.who_global_data VALUES (45727, 13, 1128, 0, 2, 193, 124);
INSERT INTO public.who_global_data VALUES (45728, 919, 66575, 13, 1629, 193, 185);
INSERT INTO public.who_global_data VALUES (45729, 264, 59177, 1, 345, 193, 194);
INSERT INTO public.who_global_data VALUES (45730, 0, 509, 0, 21, 193, 144);
INSERT INTO public.who_global_data VALUES (45731, 61498, 4209509, 604, 146331, 193, 19);
INSERT INTO public.who_global_data VALUES (45732, 3, 364, 0, 7, 193, 217);
INSERT INTO public.who_global_data VALUES (45733, 18, 1192, 0, 34, 193, 148);
INSERT INTO public.who_global_data VALUES (45734, 686, 21506, 2, 119, 193, 86);
INSERT INTO public.who_global_data VALUES (45735, 0, 0, 0, 0, 193, 13);
INSERT INTO public.who_global_data VALUES (45736, 534, 15463, 4, 142, 193, 157);
INSERT INTO public.who_global_data VALUES (45737, 11, 431, 0, 0, 193, 8);
INSERT INTO public.who_global_data VALUES (45738, 0, 0, 0, 0, 193, 73);
INSERT INTO public.who_global_data VALUES (45739, 10, 1695, 4, 484, 193, 101);
INSERT INTO public.who_global_data VALUES (45740, 71, 4552, 1, 140, 193, 165);
INSERT INTO public.who_global_data VALUES (45741, 192, 2704, 2, 36, 193, 14);
INSERT INTO public.who_global_data VALUES (45742, 106, 36349, 10, 1273, 194, 193);
INSERT INTO public.who_global_data VALUES (45743, 126, 4763, 4, 138, 194, 113);
INSERT INTO public.who_global_data VALUES (45744, 1198, 27357, 19, 1155, 194, 143);
INSERT INTO public.who_global_data VALUES (45745, 0, 0, 0, 0, 194, 219);
INSERT INTO public.who_global_data VALUES (45746, 7, 904, 0, 52, 194, 186);
INSERT INTO public.who_global_data VALUES (45747, 16, 932, 1, 40, 194, 52);
INSERT INTO public.who_global_data VALUES (45748, 0, 3, 0, 0, 194, 180);
INSERT INTO public.who_global_data VALUES (45749, 0, 82, 0, 3, 194, 167);
INSERT INTO public.who_global_data VALUES (45750, 4801, 158321, 66, 2913, 194, 154);
INSERT INTO public.who_global_data VALUES (45751, 73, 36703, 6, 706, 194, 94);
INSERT INTO public.who_global_data VALUES (45752, 0, 117, 0, 3, 194, 66);
INSERT INTO public.who_global_data VALUES (45753, 453, 14403, 10, 155, 194, 58);
INSERT INTO public.who_global_data VALUES (45754, 137, 20486, 0, 712, 194, 163);
INSERT INTO public.who_global_data VALUES (45755, 417, 30050, 9, 417, 194, 37);
INSERT INTO public.who_global_data VALUES (45756, 10, 326, 0, 11, 194, 142);
INSERT INTO public.who_global_data VALUES (45757, 384, 39131, 4, 141, 194, 83);
INSERT INTO public.who_global_data VALUES (45758, 2275, 223453, 54, 2928, 194, 228);
INSERT INTO public.who_global_data VALUES (45759, 0, 108, 0, 7, 194, 188);
INSERT INTO public.who_global_data VALUES (45760, 130, 67132, 4, 534, 194, 62);
INSERT INTO public.who_global_data VALUES (45761, 184, 67072, 2, 9689, 194, 160);
INSERT INTO public.who_global_data VALUES (45762, 0, 48, 0, 2, 194, 50);
INSERT INTO public.who_global_data VALUES (45763, 76, 1770, 1, 35, 194, 33);
INSERT INTO public.who_global_data VALUES (45764, 1, 154, 0, 9, 194, 183);
INSERT INTO public.who_global_data VALUES (45765, 2, 95, 0, 0, 194, 92);
INSERT INTO public.who_global_data VALUES (45766, 1825, 68281, 62, 2535, 194, 158);
INSERT INTO public.who_global_data VALUES (45767, 0, 5, 0, 0, 194, 67);
INSERT INTO public.who_global_data VALUES (45768, 263, 10332, 2, 285, 194, 57);
INSERT INTO public.who_global_data VALUES (45769, 0, 686, 0, 1, 194, 38);
INSERT INTO public.who_global_data VALUES (45770, 51147, 2394513, 1211, 86449, 194, 141);
INSERT INTO public.who_global_data VALUES (45771, 0, 8, 0, 1, 194, 178);
INSERT INTO public.who_global_data VALUES (45772, 0, 141, 0, 3, 194, 108);
INSERT INTO public.who_global_data VALUES (45773, 115, 10427, 2, 340, 194, 39);
INSERT INTO public.who_global_data VALUES (45774, 5, 1086, 0, 53, 194, 2);
INSERT INTO public.who_global_data VALUES (45775, 16, 361, 0, 1, 194, 195);
INSERT INTO public.who_global_data VALUES (45776, 49, 2307, 0, 22, 194, 107);
INSERT INTO public.who_global_data VALUES (45777, 0, 225, 0, 0, 194, 161);
INSERT INTO public.who_global_data VALUES (45778, 402, 17110, 6, 391, 194, 212);
INSERT INTO public.who_global_data VALUES (45779, 350, 113556, 4, 8885, 194, 181);
INSERT INTO public.who_global_data VALUES (45780, 0, 203, 0, 1, 194, 53);
INSERT INTO public.who_global_data VALUES (45781, 0, 4598, 0, 59, 194, 164);
INSERT INTO public.who_global_data VALUES (45782, 0, 915, 0, 75, 194, 140);
INSERT INTO public.who_global_data VALUES (45783, 2198, 345790, 92, 9112, 194, 20);
INSERT INTO public.who_global_data VALUES (45784, 189, 87028, 0, 4659, 194, 112);
INSERT INTO public.who_global_data VALUES (45785, 7254, 240795, 294, 8269, 194, 111);
INSERT INTO public.who_global_data VALUES (45786, 14, 354, 0, 7, 194, 71);
INSERT INTO public.who_global_data VALUES (45787, 121, 3159, 3, 54, 194, 218);
INSERT INTO public.who_global_data VALUES (45788, 0, 0, 0, 0, 194, 43);
INSERT INTO public.who_global_data VALUES (45789, 931, 14600, 11, 98, 194, 49);
INSERT INTO public.who_global_data VALUES (45790, 102, 15596, 2, 96, 194, 1);
INSERT INTO public.who_global_data VALUES (45791, 65, 4857, 3, 136, 194, 48);
INSERT INTO public.who_global_data VALUES (45792, 17, 2495, 0, 87, 194, 232);
INSERT INTO public.who_global_data VALUES (45793, 0, 29, 0, 1, 194, 175);
INSERT INTO public.who_global_data VALUES (45794, 4, 1057, 0, 19, 194, 21);
INSERT INTO public.who_global_data VALUES (45795, 112, 15324, 3, 371, 194, 156);
INSERT INTO public.who_global_data VALUES (45796, 0, 0, 0, 0, 194, 95);
INSERT INTO public.who_global_data VALUES (45797, 64, 8830, 3, 203, 194, 177);
INSERT INTO public.who_global_data VALUES (45798, 0, 13438, 0, 613, 194, 210);
INSERT INTO public.who_global_data VALUES (45799, 11, 5050, 0, 58, 194, 120);
INSERT INTO public.who_global_data VALUES (45800, 0, 18, 0, 0, 194, 135);
INSERT INTO public.who_global_data VALUES (45801, 2012, 62908, 8, 1063, 194, 206);
INSERT INTO public.who_global_data VALUES (45802, 658, 80694, 8, 5515, 194, 189);
INSERT INTO public.who_global_data VALUES (45803, 479, 92062, 48, 4606, 194, 129);
INSERT INTO public.who_global_data VALUES (45804, 409, 14630, 10, 400, 194, 121);
INSERT INTO public.who_global_data VALUES (45805, 0, 2350, 0, 41, 194, 59);
INSERT INTO public.who_global_data VALUES (45806, 0, 263, 0, 0, 194, 96);
INSERT INTO public.who_global_data VALUES (45807, 1, 2034, 0, 63, 194, 41);
INSERT INTO public.who_global_data VALUES (45808, 65, 2207, 4, 32, 194, 216);
INSERT INTO public.who_global_data VALUES (45809, 720, 13968, 14, 223, 194, 236);
INSERT INTO public.who_global_data VALUES (45810, 0, 13, 0, 0, 194, 150);
INSERT INTO public.who_global_data VALUES (45811, 0, 191, 0, 0, 194, 61);
INSERT INTO public.who_global_data VALUES (45812, 0, 27, 0, 0, 194, 7);
INSERT INTO public.who_global_data VALUES (45813, 5, 7393, 0, 329, 194, 169);
INSERT INTO public.who_global_data VALUES (45814, 0, 169222, 0, 30078, 194, 28);
INSERT INTO public.who_global_data VALUES (45815, 0, 7332, 0, 41, 194, 85);
INSERT INTO public.who_global_data VALUES (45816, 0, 62, 0, 0, 194, 211);
INSERT INTO public.who_global_data VALUES (45817, 0, 6984, 0, 49, 194, 60);
INSERT INTO public.who_global_data VALUES (45818, 61, 277, 0, 6, 194, 3);
INSERT INTO public.who_global_data VALUES (45819, 6, 1137, 0, 16, 194, 11);
INSERT INTO public.who_global_data VALUES (45820, 340, 205609, 0, 9118, 194, 89);
INSERT INTO public.who_global_data VALUES (45821, 586, 32437, 0, 161, 194, 24);
INSERT INTO public.who_global_data VALUES (45822, 0, 185, 0, 0, 194, 162);
INSERT INTO public.who_global_data VALUES (45823, 27, 4193, 1, 202, 194, 100);
INSERT INTO public.who_global_data VALUES (45824, 0, 13, 0, 0, 194, 47);
INSERT INTO public.who_global_data VALUES (45825, 0, 23, 0, 0, 194, 29);
INSERT INTO public.who_global_data VALUES (45826, 0, 203, 0, 14, 194, 40);
INSERT INTO public.who_global_data VALUES (45827, 0, 329, 0, 5, 194, 222);
INSERT INTO public.who_global_data VALUES (45828, 561, 45053, 35, 1734, 194, 132);
INSERT INTO public.who_global_data VALUES (45829, 0, 252, 0, 13, 194, 130);
INSERT INTO public.who_global_data VALUES (45830, 81, 7008, 1, 43, 194, 234);
INSERT INTO public.who_global_data VALUES (45831, 0, 1954, 0, 26, 194, 23);
INSERT INTO public.who_global_data VALUES (45832, 8, 360, 0, 20, 194, 192);
INSERT INTO public.who_global_data VALUES (45833, 37, 7297, 1, 157, 194, 69);
INSERT INTO public.who_global_data VALUES (45834, 0, 12, 0, 0, 194, 187);
INSERT INTO public.who_global_data VALUES (45835, 879, 38438, 37, 1098, 194, 230);
INSERT INTO public.who_global_data VALUES (45836, 13, 4448, 0, 596, 194, 77);
INSERT INTO public.who_global_data VALUES (45837, 4, 1847, 0, 10, 194, 9);
INSERT INTO public.who_global_data VALUES (45838, 49931, 1435453, 708, 32771, 194, 74);
INSERT INTO public.who_global_data VALUES (45839, 1492, 98778, 67, 4781, 194, 224);
INSERT INTO public.who_global_data VALUES (45840, 2333, 291172, 216, 15700, 194, 199);
INSERT INTO public.who_global_data VALUES (45841, 2459, 110032, 78, 4362, 194, 190);
INSERT INTO public.who_global_data VALUES (45842, 12, 25881, 0, 1763, 194, 12);
INSERT INTO public.who_global_data VALUES (45843, 0, 336, 0, 24, 194, 104);
INSERT INTO public.who_global_data VALUES (45844, 1112, 61426, 7, 494, 194, 153);
INSERT INTO public.who_global_data VALUES (45845, 254, 246118, 5, 35107, 194, 91);
INSERT INTO public.who_global_data VALUES (45846, 6, 837, 0, 10, 194, 215);
INSERT INTO public.who_global_data VALUES (45847, 607, 29989, 0, 996, 194, 84);
INSERT INTO public.who_global_data VALUES (45848, 0, 332, 0, 31, 194, 231);
INSERT INTO public.who_global_data VALUES (45849, 14, 1236, 0, 11, 194, 196);
INSERT INTO public.who_global_data VALUES (45850, 1526, 84648, 0, 585, 194, 105);
INSERT INTO public.who_global_data VALUES (45851, 0, 16643, 0, 278, 194, 122);
INSERT INTO public.who_global_data VALUES (45852, 0, 0, 0, 0, 194, 159);
INSERT INTO public.who_global_data VALUES (45853, 220, 7094, 8, 167, 194, 75);
INSERT INTO public.who_global_data VALUES (45854, 464, 63773, 4, 433, 194, 27);
INSERT INTO public.who_global_data VALUES (45855, 483, 33296, 24, 856, 194, 54);
INSERT INTO public.who_global_data VALUES (45856, 0, 20, 0, 0, 194, 226);
INSERT INTO public.who_global_data VALUES (45857, 13, 1219, 0, 31, 194, 79);
INSERT INTO public.who_global_data VALUES (45858, 168, 3750, 4, 51, 194, 56);
INSERT INTO public.who_global_data VALUES (45859, 59, 505, 1, 12, 194, 117);
INSERT INTO public.who_global_data VALUES (45860, 27, 1162, 1, 72, 194, 152);
INSERT INTO public.who_global_data VALUES (45861, 122, 2669, 2, 60, 194, 16);
INSERT INTO public.who_global_data VALUES (45862, 0, 87, 0, 1, 194, 10);
INSERT INTO public.who_global_data VALUES (45863, 11, 2014, 0, 80, 194, 201);
INSERT INTO public.who_global_data VALUES (45864, 83, 6272, 0, 112, 194, 174);
INSERT INTO public.who_global_data VALUES (45865, 429, 9295, 7, 85, 194, 119);
INSERT INTO public.who_global_data VALUES (45866, 107, 3664, 5, 99, 194, 168);
INSERT INTO public.who_global_data VALUES (45867, 13, 8897, 1, 124, 194, 99);
INSERT INTO public.who_global_data VALUES (45868, 50, 3302, 0, 15, 194, 171);
INSERT INTO public.who_global_data VALUES (45869, 7, 2510, 0, 123, 194, 87);
INSERT INTO public.who_global_data VALUES (45870, 1, 699, 0, 9, 194, 123);
INSERT INTO public.who_global_data VALUES (45871, 0, 0, 0, 0, 194, 151);
INSERT INTO public.who_global_data VALUES (45872, 0, 269, 0, 15, 194, 213);
INSERT INTO public.who_global_data VALUES (45873, 55, 6171, 0, 156, 194, 118);
INSERT INTO public.who_global_data VALUES (45874, 0, 344, 0, 10, 194, 134);
INSERT INTO public.who_global_data VALUES (45875, 0, 2873, 0, 38, 194, 65);
INSERT INTO public.who_global_data VALUES (45876, 6751, 385036, 729, 43374, 194, 102);
INSERT INTO public.who_global_data VALUES (45877, 0, 0, 0, 0, 194, 223);
INSERT INTO public.who_global_data VALUES (45878, 0, 84, 0, 1, 194, 4);
INSERT INTO public.who_global_data VALUES (45879, 0, 288, 0, 0, 194, 146);
INSERT INTO public.who_global_data VALUES (45880, 85, 2934, 2, 45, 194, 31);
INSERT INTO public.who_global_data VALUES (45881, 1, 13, 0, 1, 194, 127);
INSERT INTO public.who_global_data VALUES (45882, 633, 20278, 8, 313, 194, 22);
INSERT INTO public.who_global_data VALUES (45883, 53, 1669, 0, 11, 194, 115);
INSERT INTO public.who_global_data VALUES (45884, 1, 350, 0, 6, 194, 106);
INSERT INTO public.who_global_data VALUES (45885, 87, 1774, 1, 8, 194, 90);
INSERT INTO public.who_global_data VALUES (45886, 0, 0, 0, 0, 194, 70);
INSERT INTO public.who_global_data VALUES (45887, 130, 18613, 0, 45, 194, 46);
INSERT INTO public.who_global_data VALUES (45888, 213, 52880, 0, 6138, 194, 139);
INSERT INTO public.who_global_data VALUES (45889, 0, 22, 0, 0, 194, 42);
INSERT INTO public.who_global_data VALUES (45890, 0, 1206, 0, 22, 194, 80);
INSERT INTO public.who_global_data VALUES (45891, 0, 3004, 0, 108, 194, 203);
INSERT INTO public.who_global_data VALUES (45892, 8, 1132, 0, 69, 194, 136);
INSERT INTO public.who_global_data VALUES (45893, 555, 40532, 2, 858, 194, 63);
INSERT INTO public.who_global_data VALUES (45894, 0, 0, 0, 0, 194, 17);
INSERT INTO public.who_global_data VALUES (45895, 1, 40, 0, 2, 194, 172);
INSERT INTO public.who_global_data VALUES (45896, 152, 10086, 0, 460, 194, 109);
INSERT INTO public.who_global_data VALUES (45897, 0, 9085, 0, 255, 194, 200);
INSERT INTO public.who_global_data VALUES (45898, 330, 13125, 1, 79, 194, 93);
INSERT INTO public.who_global_data VALUES (45899, 1147, 76005, 13, 384, 194, 5);
INSERT INTO public.who_global_data VALUES (45900, 0, 741, 0, 13, 194, 214);
INSERT INTO public.who_global_data VALUES (45901, 1176, 274289, 20, 5842, 194, 204);
INSERT INTO public.who_global_data VALUES (45902, 0, 0, 0, 0, 194, 198);
INSERT INTO public.who_global_data VALUES (45903, 871, 58864, 25, 1275, 194, 173);
INSERT INTO public.who_global_data VALUES (45904, 23, 62, 0, 0, 194, 229);
INSERT INTO public.who_global_data VALUES (45905, 104, 4328, 2, 40, 194, 76);
INSERT INTO public.who_global_data VALUES (45906, 3923, 379884, 187, 18030, 194, 138);
INSERT INTO public.who_global_data VALUES (45907, 2036, 80448, 35, 1932, 194, 98);
INSERT INTO public.who_global_data VALUES (45908, 0, 0, 0, 0, 194, 103);
INSERT INTO public.who_global_data VALUES (45909, 443, 43065, 7, 1671, 194, 225);
INSERT INTO public.who_global_data VALUES (45910, 209, 50164, 1, 1717, 194, 131);
INSERT INTO public.who_global_data VALUES (45911, 603, 15143, 0, 201, 194, 235);
INSERT INTO public.who_global_data VALUES (45912, 269, 109305, 1, 165, 194, 137);
INSERT INTO public.who_global_data VALUES (45913, 25, 14175, 1, 299, 194, 81);
INSERT INTO public.who_global_data VALUES (45914, 206, 23034, 7, 740, 194, 182);
INSERT INTO public.who_global_data VALUES (45915, 0, 657, 0, 3, 194, 145);
INSERT INTO public.who_global_data VALUES (45916, 1120, 44798, 22, 2187, 194, 26);
INSERT INTO public.who_global_data VALUES (45917, 5635, 818120, 85, 13354, 194, 170);
INSERT INTO public.who_global_data VALUES (45918, 71, 1823, 0, 5, 194, 191);
INSERT INTO public.who_global_data VALUES (45919, 0, 3, 0, 0, 194, 221);
INSERT INTO public.who_global_data VALUES (45920, 0, 7, 0, 0, 194, 64);
INSERT INTO public.who_global_data VALUES (45921, 0, 0, 0, 0, 194, 116);
INSERT INTO public.who_global_data VALUES (45922, 0, 17, 0, 0, 194, 128);
INSERT INTO public.who_global_data VALUES (45923, 0, 24, 0, 0, 194, 6);
INSERT INTO public.who_global_data VALUES (45924, 0, 49, 0, 3, 194, 227);
INSERT INTO public.who_global_data VALUES (45925, 0, 4, 0, 0, 194, 68);
INSERT INTO public.who_global_data VALUES (45926, 0, 52, 0, 0, 194, 184);
INSERT INTO public.who_global_data VALUES (45927, 0, 0, 0, 0, 194, 82);
INSERT INTO public.who_global_data VALUES (45928, 0, 716, 0, 42, 194, 149);
INSERT INTO public.who_global_data VALUES (45929, 1, 863, 0, 14, 194, 197);
INSERT INTO public.who_global_data VALUES (45930, 1968, 266941, 30, 2733, 194, 78);
INSERT INTO public.who_global_data VALUES (45931, 129, 9681, 4, 191, 194, 233);
INSERT INTO public.who_global_data VALUES (45932, 467, 23730, 8, 534, 194, 133);
INSERT INTO public.who_global_data VALUES (45933, 0, 107, 0, 0, 194, 35);
INSERT INTO public.who_global_data VALUES (45934, 15, 1783, 0, 66, 194, 114);
INSERT INTO public.who_global_data VALUES (45935, 481, 50369, 0, 27, 194, 237);
INSERT INTO public.who_global_data VALUES (45936, 0, 3, 0, 0, 194, 55);
INSERT INTO public.who_global_data VALUES (45937, 0, 94, 0, 15, 194, 176);
INSERT INTO public.who_global_data VALUES (45938, 38, 2179, 0, 28, 194, 202);
INSERT INTO public.who_global_data VALUES (45939, 5, 2088, 1, 119, 194, 155);
INSERT INTO public.who_global_data VALUES (45940, 0, 0, 0, 0, 194, 32);
INSERT INTO public.who_global_data VALUES (45941, 0, 3178, 0, 93, 194, 220);
INSERT INTO public.who_global_data VALUES (45942, 11233, 445433, 114, 6769, 194, 30);
INSERT INTO public.who_global_data VALUES (45943, 43, 2305, 1, 46, 194, 147);
INSERT INTO public.who_global_data VALUES (45944, 1808, 290495, 9, 29849, 194, 208);
INSERT INTO public.who_global_data VALUES (45945, 12, 2782, 0, 11, 194, 45);
INSERT INTO public.who_global_data VALUES (45946, 39, 11424, 3, 720, 194, 110);
INSERT INTO public.who_global_data VALUES (45947, 76, 1381, 0, 23, 194, 88);
INSERT INTO public.who_global_data VALUES (45948, 138, 75684, 1, 5745, 194, 51);
INSERT INTO public.who_global_data VALUES (45949, 57, 34469, 0, 1735, 194, 209);
INSERT INTO public.who_global_data VALUES (45950, 23, 650, 2, 38, 194, 205);
INSERT INTO public.who_global_data VALUES (45951, 42, 7192, 0, 59, 194, 18);
INSERT INTO public.who_global_data VALUES (45952, 4, 3295, 0, 58, 194, 72);
INSERT INTO public.who_global_data VALUES (45953, 421, 300255, 8, 41111, 194, 44);
INSERT INTO public.who_global_data VALUES (45954, 0, 24, 0, 0, 194, 15);
INSERT INTO public.who_global_data VALUES (45955, 15, 868, 1, 18, 194, 25);
INSERT INTO public.who_global_data VALUES (45956, 0, 0, 0, 0, 194, 179);
INSERT INTO public.who_global_data VALUES (45957, 0, 0, 0, 0, 194, 34);
INSERT INTO public.who_global_data VALUES (45958, 0, 147, 0, 8, 194, 207);
INSERT INTO public.who_global_data VALUES (45959, 3, 1455, 0, 50, 194, 166);
INSERT INTO public.who_global_data VALUES (45960, 927, 226100, 17, 5613, 194, 126);
INSERT INTO public.who_global_data VALUES (45961, 0, 0, 0, 0, 194, 97);
INSERT INTO public.who_global_data VALUES (45962, 5, 97, 0, 2, 194, 36);
INSERT INTO public.who_global_data VALUES (45963, 0, 0, 0, 0, 194, 125);
INSERT INTO public.who_global_data VALUES (45964, 12, 1115, 1, 2, 194, 124);
INSERT INTO public.who_global_data VALUES (45965, 807, 65656, 11, 1616, 194, 185);
INSERT INTO public.who_global_data VALUES (45966, 351, 58913, 1, 344, 194, 194);
INSERT INTO public.who_global_data VALUES (45967, 0, 509, 0, 21, 194, 144);
INSERT INTO public.who_global_data VALUES (45968, 63968, 4148011, 929, 145727, 194, 19);
INSERT INTO public.who_global_data VALUES (45969, 9, 361, 0, 7, 194, 217);
INSERT INTO public.who_global_data VALUES (45970, 8, 1174, 0, 34, 194, 148);
INSERT INTO public.who_global_data VALUES (45971, 594, 20820, 5, 117, 194, 86);
INSERT INTO public.who_global_data VALUES (45972, 0, 0, 0, 0, 194, 13);
INSERT INTO public.who_global_data VALUES (45973, 666, 14929, 4, 138, 194, 157);
INSERT INTO public.who_global_data VALUES (45974, 2, 420, 0, 0, 194, 8);
INSERT INTO public.who_global_data VALUES (45975, 0, 0, 0, 0, 194, 73);
INSERT INTO public.who_global_data VALUES (45976, 7, 1685, 5, 480, 194, 101);
INSERT INTO public.who_global_data VALUES (45977, 153, 4481, 0, 139, 194, 165);
INSERT INTO public.who_global_data VALUES (45978, 78, 2512, 0, 34, 194, 14);
INSERT INTO public.who_global_data VALUES (45979, 121, 36243, 13, 1263, 195, 193);
INSERT INTO public.who_global_data VALUES (45980, 67, 4637, 6, 134, 195, 113);
INSERT INTO public.who_global_data VALUES (45981, 0, 26159, 0, 1136, 195, 143);
INSERT INTO public.who_global_data VALUES (45982, 0, 0, 0, 0, 195, 219);
INSERT INTO public.who_global_data VALUES (45983, 0, 897, 0, 52, 195, 186);
INSERT INTO public.who_global_data VALUES (45984, 36, 916, 4, 39, 195, 52);
INSERT INTO public.who_global_data VALUES (45985, 0, 3, 0, 0, 195, 180);
INSERT INTO public.who_global_data VALUES (45986, 6, 82, 0, 3, 195, 167);
INSERT INTO public.who_global_data VALUES (45987, 5493, 153520, 125, 2847, 195, 154);
INSERT INTO public.who_global_data VALUES (45988, 321, 36630, 5, 700, 195, 94);
INSERT INTO public.who_global_data VALUES (45989, 0, 117, 0, 3, 195, 66);
INSERT INTO public.who_global_data VALUES (45990, 355, 13950, 6, 145, 195, 58);
INSERT INTO public.who_global_data VALUES (45991, 120, 20349, 1, 712, 195, 163);
INSERT INTO public.who_global_data VALUES (45992, 321, 29633, 8, 408, 195, 37);
INSERT INTO public.who_global_data VALUES (45993, 42, 316, 0, 11, 195, 142);
INSERT INTO public.who_global_data VALUES (45994, 289, 38747, 1, 137, 195, 83);
INSERT INTO public.who_global_data VALUES (45995, 2520, 221178, 38, 2874, 195, 228);
INSERT INTO public.who_global_data VALUES (45996, 2, 108, 0, 7, 195, 188);
INSERT INTO public.who_global_data VALUES (45997, 156, 67002, 6, 530, 195, 62);
INSERT INTO public.who_global_data VALUES (45998, 229, 66888, 1, 9687, 195, 160);
INSERT INTO public.who_global_data VALUES (45999, 1, 48, 0, 2, 195, 50);
INSERT INTO public.who_global_data VALUES (46000, 0, 1694, 0, 34, 195, 33);
INSERT INTO public.who_global_data VALUES (46001, 0, 153, 0, 9, 195, 183);
INSERT INTO public.who_global_data VALUES (46002, 1, 93, 0, 0, 195, 92);
INSERT INTO public.who_global_data VALUES (46003, 1204, 66456, 66, 2473, 195, 158);
INSERT INTO public.who_global_data VALUES (46004, 0, 5, 0, 0, 195, 67);
INSERT INTO public.who_global_data VALUES (46005, 305, 10069, 5, 283, 195, 57);
INSERT INTO public.who_global_data VALUES (46006, 0, 686, 0, 1, 195, 38);
INSERT INTO public.who_global_data VALUES (46007, 55891, 2343366, 1156, 85238, 195, 141);
INSERT INTO public.who_global_data VALUES (46008, 0, 8, 0, 1, 195, 178);
INSERT INTO public.who_global_data VALUES (46009, 0, 141, 0, 3, 195, 108);
INSERT INTO public.who_global_data VALUES (46010, 189, 10312, 1, 338, 195, 39);
INSERT INTO public.who_global_data VALUES (46011, 6, 1081, 0, 53, 195, 2);
INSERT INTO public.who_global_data VALUES (46012, 0, 345, 0, 1, 195, 195);
INSERT INTO public.who_global_data VALUES (46013, 38, 2258, 0, 22, 195, 107);
INSERT INTO public.who_global_data VALUES (46014, 23, 225, 0, 0, 195, 161);
INSERT INTO public.who_global_data VALUES (46015, 0, 16708, 0, 385, 195, 212);
INSERT INTO public.who_global_data VALUES (46016, 534, 113206, 7, 8881, 195, 181);
INSERT INTO public.who_global_data VALUES (46017, 0, 203, 0, 1, 195, 53);
INSERT INTO public.who_global_data VALUES (46018, 5, 4598, 0, 59, 195, 164);
INSERT INTO public.who_global_data VALUES (46019, 0, 915, 0, 75, 195, 140);
INSERT INTO public.who_global_data VALUES (46020, 2288, 343592, 106, 9020, 195, 20);
INSERT INTO public.who_global_data VALUES (46021, 179, 86839, 2, 4659, 195, 112);
INSERT INTO public.who_global_data VALUES (46022, 7168, 233541, 287, 7975, 195, 111);
INSERT INTO public.who_global_data VALUES (46023, 0, 340, 0, 7, 195, 71);
INSERT INTO public.who_global_data VALUES (46024, 0, 3038, 0, 51, 195, 218);
INSERT INTO public.who_global_data VALUES (46025, 0, 0, 0, 0, 195, 43);
INSERT INTO public.who_global_data VALUES (46026, 540, 13669, 7, 87, 195, 49);
INSERT INTO public.who_global_data VALUES (46027, 241, 15494, 0, 94, 195, 1);
INSERT INTO public.who_global_data VALUES (46028, 77, 4792, 5, 133, 195, 48);
INSERT INTO public.who_global_data VALUES (46029, 9, 2478, 0, 87, 195, 232);
INSERT INTO public.who_global_data VALUES (46030, 0, 29, 0, 1, 195, 175);
INSERT INTO public.who_global_data VALUES (46031, 6, 1053, 0, 19, 195, 21);
INSERT INTO public.who_global_data VALUES (46032, 131, 15212, 0, 368, 195, 156);
INSERT INTO public.who_global_data VALUES (46033, 0, 0, 0, 0, 195, 95);
INSERT INTO public.who_global_data VALUES (46034, 141, 8766, 4, 200, 195, 177);
INSERT INTO public.who_global_data VALUES (46035, 0, 13438, 0, 613, 195, 210);
INSERT INTO public.who_global_data VALUES (46036, 0, 5039, 0, 58, 195, 120);
INSERT INTO public.who_global_data VALUES (46037, 0, 18, 0, 0, 195, 135);
INSERT INTO public.who_global_data VALUES (46038, 1819, 60896, 19, 1055, 195, 206);
INSERT INTO public.who_global_data VALUES (46039, 987, 80036, 39, 5507, 195, 189);
INSERT INTO public.who_global_data VALUES (46040, 511, 91583, 40, 4558, 195, 129);
INSERT INTO public.who_global_data VALUES (46041, 429, 14221, 11, 390, 195, 121);
INSERT INTO public.who_global_data VALUES (46042, 0, 2350, 0, 41, 195, 59);
INSERT INTO public.who_global_data VALUES (46043, 2, 263, 0, 0, 195, 96);
INSERT INTO public.who_global_data VALUES (46044, 5, 2033, 0, 63, 195, 41);
INSERT INTO public.who_global_data VALUES (46045, 69, 2142, 0, 28, 195, 216);
INSERT INTO public.who_global_data VALUES (46046, 555, 13248, 9, 209, 195, 236);
INSERT INTO public.who_global_data VALUES (46047, 0, 13, 0, 0, 195, 150);
INSERT INTO public.who_global_data VALUES (46048, 0, 191, 0, 0, 195, 61);
INSERT INTO public.who_global_data VALUES (46049, 0, 27, 0, 0, 195, 7);
INSERT INTO public.who_global_data VALUES (46050, 8, 7388, 0, 329, 195, 169);
INSERT INTO public.who_global_data VALUES (46051, 0, 169222, 0, 30078, 195, 28);
INSERT INTO public.who_global_data VALUES (46052, 81, 7332, 0, 41, 195, 85);
INSERT INTO public.who_global_data VALUES (46053, 0, 62, 0, 0, 195, 211);
INSERT INTO public.who_global_data VALUES (46054, 0, 6984, 0, 49, 195, 60);
INSERT INTO public.who_global_data VALUES (46055, 46, 216, 1, 6, 195, 3);
INSERT INTO public.who_global_data VALUES (46056, 14, 1131, 0, 16, 195, 11);
INSERT INTO public.who_global_data VALUES (46057, 305, 205269, 0, 9118, 195, 89);
INSERT INTO public.who_global_data VALUES (46058, 794, 31851, 0, 161, 195, 24);
INSERT INTO public.who_global_data VALUES (46059, 1, 185, 0, 0, 195, 162);
INSERT INTO public.who_global_data VALUES (46060, 31, 4166, 0, 201, 195, 100);
INSERT INTO public.who_global_data VALUES (46061, 0, 13, 0, 0, 195, 47);
INSERT INTO public.who_global_data VALUES (46062, 0, 23, 0, 0, 195, 29);
INSERT INTO public.who_global_data VALUES (46063, 0, 203, 0, 14, 195, 40);
INSERT INTO public.who_global_data VALUES (46064, 0, 329, 0, 5, 195, 222);
INSERT INTO public.who_global_data VALUES (46065, 1209, 44492, 30, 1699, 195, 132);
INSERT INTO public.who_global_data VALUES (46066, 0, 252, 0, 13, 195, 130);
INSERT INTO public.who_global_data VALUES (46067, 60, 6927, 0, 42, 195, 234);
INSERT INTO public.who_global_data VALUES (46068, 0, 1954, 0, 26, 195, 23);
INSERT INTO public.who_global_data VALUES (46069, 1, 352, 1, 20, 195, 192);
INSERT INTO public.who_global_data VALUES (46070, 63, 7260, 2, 156, 195, 69);
INSERT INTO public.who_global_data VALUES (46071, 0, 12, 0, 0, 195, 187);
INSERT INTO public.who_global_data VALUES (46072, 657, 37559, 50, 1061, 195, 230);
INSERT INTO public.who_global_data VALUES (46073, 11, 4435, 0, 596, 195, 77);
INSERT INTO public.who_global_data VALUES (46074, 0, 1843, 0, 10, 195, 9);
INSERT INTO public.who_global_data VALUES (46075, 48661, 1385522, 705, 32063, 195, 74);
INSERT INTO public.who_global_data VALUES (46076, 1868, 97286, 49, 4714, 195, 224);
INSERT INTO public.who_global_data VALUES (46077, 2316, 288839, 195, 15484, 195, 199);
INSERT INTO public.who_global_data VALUES (46078, 2862, 107573, 72, 4284, 195, 190);
INSERT INTO public.who_global_data VALUES (46079, 24, 25869, 0, 1763, 195, 12);
INSERT INTO public.who_global_data VALUES (46080, 0, 336, 0, 24, 195, 104);
INSERT INTO public.who_global_data VALUES (46081, 1830, 60314, 8, 487, 195, 153);
INSERT INTO public.who_global_data VALUES (46082, 274, 245864, 5, 35102, 195, 91);
INSERT INTO public.who_global_data VALUES (46083, 10, 831, 0, 10, 195, 215);
INSERT INTO public.who_global_data VALUES (46084, 596, 29382, 3, 996, 195, 84);
INSERT INTO public.who_global_data VALUES (46085, 1, 332, 0, 31, 195, 231);
INSERT INTO public.who_global_data VALUES (46086, 8, 1222, 0, 11, 195, 196);
INSERT INTO public.who_global_data VALUES (46087, 1402, 83122, 0, 585, 195, 105);
INSERT INTO public.who_global_data VALUES (46088, 375, 16643, 4, 278, 195, 122);
INSERT INTO public.who_global_data VALUES (46089, 0, 0, 0, 0, 195, 159);
INSERT INTO public.who_global_data VALUES (46090, 237, 6874, 5, 159, 195, 75);
INSERT INTO public.who_global_data VALUES (46091, 684, 63309, 4, 429, 195, 27);
INSERT INTO public.who_global_data VALUES (46092, 1566, 32813, 28, 832, 195, 54);
INSERT INTO public.who_global_data VALUES (46093, 0, 20, 0, 0, 195, 226);
INSERT INTO public.who_global_data VALUES (46094, 1, 1206, 0, 31, 195, 79);
INSERT INTO public.who_global_data VALUES (46095, 175, 3582, 1, 47, 195, 56);
INSERT INTO public.who_global_data VALUES (46096, 27, 446, 2, 11, 195, 117);
INSERT INTO public.who_global_data VALUES (46097, 0, 1135, 0, 71, 195, 152);
INSERT INTO public.who_global_data VALUES (46098, 122, 2547, 1, 58, 195, 16);
INSERT INTO public.who_global_data VALUES (46099, 0, 87, 0, 1, 195, 10);
INSERT INTO public.who_global_data VALUES (46100, 7, 2003, 0, 80, 195, 201);
INSERT INTO public.who_global_data VALUES (46101, 133, 6189, 0, 112, 195, 174);
INSERT INTO public.who_global_data VALUES (46102, 125, 8866, 2, 78, 195, 119);
INSERT INTO public.who_global_data VALUES (46103, 103, 3557, 7, 94, 195, 168);
INSERT INTO public.who_global_data VALUES (46104, 23, 8884, 0, 123, 195, 99);
INSERT INTO public.who_global_data VALUES (46105, 77, 3252, 0, 15, 195, 171);
INSERT INTO public.who_global_data VALUES (46106, 0, 2503, 0, 123, 195, 87);
INSERT INTO public.who_global_data VALUES (46107, 14, 698, 0, 9, 195, 123);
INSERT INTO public.who_global_data VALUES (46108, 0, 0, 0, 0, 195, 151);
INSERT INTO public.who_global_data VALUES (46109, 0, 269, 0, 15, 195, 213);
INSERT INTO public.who_global_data VALUES (46110, 0, 6116, 0, 156, 195, 118);
INSERT INTO public.who_global_data VALUES (46111, 0, 344, 0, 10, 195, 134);
INSERT INTO public.who_global_data VALUES (46112, 0, 2873, 0, 38, 195, 65);
INSERT INTO public.who_global_data VALUES (46113, 7573, 378285, 737, 42645, 195, 102);
INSERT INTO public.who_global_data VALUES (46114, 0, 0, 0, 0, 195, 223);
INSERT INTO public.who_global_data VALUES (46115, 0, 84, 0, 1, 195, 4);
INSERT INTO public.who_global_data VALUES (46116, 0, 288, 0, 0, 195, 146);
INSERT INTO public.who_global_data VALUES (46117, 55, 2849, 0, 43, 195, 31);
INSERT INTO public.who_global_data VALUES (46118, 0, 12, 0, 1, 195, 127);
INSERT INTO public.who_global_data VALUES (46119, 811, 19645, 6, 305, 195, 22);
INSERT INTO public.who_global_data VALUES (46120, 26, 1616, 0, 11, 195, 115);
INSERT INTO public.who_global_data VALUES (46121, 3, 349, 0, 6, 195, 106);
INSERT INTO public.who_global_data VALUES (46122, 148, 1687, 0, 7, 195, 90);
INSERT INTO public.who_global_data VALUES (46123, 0, 0, 0, 0, 195, 70);
INSERT INTO public.who_global_data VALUES (46124, 109, 18483, 1, 45, 195, 46);
INSERT INTO public.who_global_data VALUES (46125, 184, 52667, 1, 6138, 195, 139);
INSERT INTO public.who_global_data VALUES (46126, 0, 22, 0, 0, 195, 42);
INSERT INTO public.who_global_data VALUES (46127, 0, 1206, 0, 22, 195, 80);
INSERT INTO public.who_global_data VALUES (46128, 0, 3004, 0, 108, 195, 203);
INSERT INTO public.who_global_data VALUES (46129, 0, 1124, 0, 69, 195, 136);
INSERT INTO public.who_global_data VALUES (46130, 438, 39977, 11, 856, 195, 63);
INSERT INTO public.who_global_data VALUES (46131, 0, 0, 0, 0, 195, 17);
INSERT INTO public.who_global_data VALUES (46132, 1, 39, 0, 2, 195, 172);
INSERT INTO public.who_global_data VALUES (46133, 137, 9934, 9, 460, 195, 109);
INSERT INTO public.who_global_data VALUES (46134, 0, 9085, 0, 255, 195, 200);
INSERT INTO public.who_global_data VALUES (46135, 383, 12795, 5, 78, 195, 93);
INSERT INTO public.who_global_data VALUES (46136, 1067, 74858, 12, 371, 195, 5);
INSERT INTO public.who_global_data VALUES (46137, 0, 741, 0, 13, 195, 214);
INSERT INTO public.who_global_data VALUES (46138, 1226, 273113, 35, 5822, 195, 204);
INSERT INTO public.who_global_data VALUES (46139, 0, 0, 0, 0, 195, 198);
INSERT INTO public.who_global_data VALUES (46140, 1176, 57993, 41, 1250, 195, 173);
INSERT INTO public.who_global_data VALUES (46141, 7, 39, 0, 0, 195, 229);
INSERT INTO public.who_global_data VALUES (46142, 111, 4224, 2, 38, 195, 76);
INSERT INTO public.who_global_data VALUES (46143, 4865, 375961, 189, 17843, 195, 138);
INSERT INTO public.who_global_data VALUES (46144, 1968, 78412, 18, 1897, 195, 98);
INSERT INTO public.who_global_data VALUES (46145, 0, 0, 0, 0, 195, 103);
INSERT INTO public.who_global_data VALUES (46146, 584, 42622, 9, 1664, 195, 225);
INSERT INTO public.who_global_data VALUES (46147, 263, 49955, 4, 1716, 195, 131);
INSERT INTO public.who_global_data VALUES (46148, 573, 14540, 10, 201, 195, 235);
INSERT INTO public.who_global_data VALUES (46149, 398, 109036, 0, 164, 195, 137);
INSERT INTO public.who_global_data VALUES (46150, 58, 14150, 0, 298, 195, 81);
INSERT INTO public.who_global_data VALUES (46151, 345, 22828, 7, 733, 195, 182);
INSERT INTO public.who_global_data VALUES (46152, 3, 657, 0, 3, 195, 145);
INSERT INTO public.who_global_data VALUES (46153, 1284, 43678, 15, 2165, 195, 26);
INSERT INTO public.who_global_data VALUES (46154, 5765, 812485, 77, 13269, 195, 170);
INSERT INTO public.who_global_data VALUES (46155, 23, 1752, 0, 5, 195, 191);
INSERT INTO public.who_global_data VALUES (46156, 0, 3, 0, 0, 195, 221);
INSERT INTO public.who_global_data VALUES (46157, 1, 7, 0, 0, 195, 64);
INSERT INTO public.who_global_data VALUES (46158, 0, 0, 0, 0, 195, 116);
INSERT INTO public.who_global_data VALUES (46159, 0, 17, 0, 0, 195, 128);
INSERT INTO public.who_global_data VALUES (46160, 0, 24, 0, 0, 195, 6);
INSERT INTO public.who_global_data VALUES (46161, 3, 49, 0, 3, 195, 227);
INSERT INTO public.who_global_data VALUES (46162, 0, 4, 0, 0, 195, 68);
INSERT INTO public.who_global_data VALUES (46163, 0, 52, 0, 0, 195, 184);
INSERT INTO public.who_global_data VALUES (46164, 0, 0, 0, 0, 195, 82);
INSERT INTO public.who_global_data VALUES (46165, 0, 716, 0, 42, 195, 149);
INSERT INTO public.who_global_data VALUES (46166, 2, 862, 0, 14, 195, 197);
INSERT INTO public.who_global_data VALUES (46167, 2201, 264973, 31, 2703, 195, 78);
INSERT INTO public.who_global_data VALUES (46168, 130, 9552, 5, 187, 195, 233);
INSERT INTO public.who_global_data VALUES (46169, 411, 23263, 8, 526, 195, 133);
INSERT INTO public.who_global_data VALUES (46170, 0, 107, 0, 0, 195, 35);
INSERT INTO public.who_global_data VALUES (46171, 3, 1768, 0, 66, 195, 114);
INSERT INTO public.who_global_data VALUES (46172, 513, 49888, 0, 27, 195, 237);
INSERT INTO public.who_global_data VALUES (46173, 0, 3, 0, 0, 195, 55);
INSERT INTO public.who_global_data VALUES (46174, 0, 94, 0, 15, 195, 176);
INSERT INTO public.who_global_data VALUES (46175, 23, 2141, 0, 28, 195, 202);
INSERT INTO public.who_global_data VALUES (46176, 16, 2083, 0, 118, 195, 155);
INSERT INTO public.who_global_data VALUES (46177, 0, 0, 0, 0, 195, 32);
INSERT INTO public.who_global_data VALUES (46178, 7, 3178, 0, 93, 195, 220);
INSERT INTO public.who_global_data VALUES (46179, 12204, 434200, 312, 6655, 195, 30);
INSERT INTO public.who_global_data VALUES (46180, 4, 2262, 0, 45, 195, 147);
INSERT INTO public.who_global_data VALUES (46181, 3013, 288687, 7, 29840, 195, 208);
INSERT INTO public.who_global_data VALUES (46182, 6, 2770, 0, 11, 195, 45);
INSERT INTO public.who_global_data VALUES (46183, 83, 11385, 2, 717, 195, 110);
INSERT INTO public.who_global_data VALUES (46184, 71, 1305, 0, 23, 195, 88);
INSERT INTO public.who_global_data VALUES (46185, 262, 75546, 3, 5744, 195, 51);
INSERT INTO public.who_global_data VALUES (46186, 95, 34412, 1, 1735, 195, 209);
INSERT INTO public.who_global_data VALUES (46187, 19, 627, 1, 36, 195, 205);
INSERT INTO public.who_global_data VALUES (46188, 46, 7150, 1, 59, 195, 18);
INSERT INTO public.who_global_data VALUES (46189, 9, 3291, 0, 58, 195, 72);
INSERT INTO public.who_global_data VALUES (46190, 667, 299834, 15, 41103, 195, 44);
INSERT INTO public.who_global_data VALUES (46191, 0, 24, 0, 0, 195, 15);
INSERT INTO public.who_global_data VALUES (46192, 14, 853, 0, 17, 195, 25);
INSERT INTO public.who_global_data VALUES (46193, 0, 0, 0, 0, 195, 179);
INSERT INTO public.who_global_data VALUES (46194, 0, 0, 0, 0, 195, 34);
INSERT INTO public.who_global_data VALUES (46195, 5, 147, 0, 8, 195, 207);
INSERT INTO public.who_global_data VALUES (46196, 9, 1452, 0, 50, 195, 166);
INSERT INTO public.who_global_data VALUES (46197, 921, 225173, 16, 5596, 195, 126);
INSERT INTO public.who_global_data VALUES (46198, 0, 0, 0, 0, 195, 97);
INSERT INTO public.who_global_data VALUES (46199, 2, 92, 0, 2, 195, 36);
INSERT INTO public.who_global_data VALUES (46200, 0, 0, 0, 0, 195, 125);
INSERT INTO public.who_global_data VALUES (46201, 14, 1103, 0, 1, 195, 124);
INSERT INTO public.who_global_data VALUES (46202, 920, 64849, 15, 1605, 195, 185);
INSERT INTO public.who_global_data VALUES (46203, 313, 58562, 0, 343, 195, 194);
INSERT INTO public.who_global_data VALUES (46204, 0, 509, 0, 21, 195, 144);
INSERT INTO public.who_global_data VALUES (46205, 74235, 4084043, 1135, 144798, 195, 19);
INSERT INTO public.who_global_data VALUES (46206, 10, 352, 0, 7, 195, 217);
INSERT INTO public.who_global_data VALUES (46207, 25, 1166, 0, 34, 195, 148);
INSERT INTO public.who_global_data VALUES (46208, 573, 20226, 8, 112, 195, 86);
INSERT INTO public.who_global_data VALUES (46209, 0, 0, 0, 0, 195, 13);
INSERT INTO public.who_global_data VALUES (46210, 650, 14263, 5, 134, 195, 157);
INSERT INTO public.who_global_data VALUES (46211, 3, 418, 0, 0, 195, 8);
INSERT INTO public.who_global_data VALUES (46212, 0, 0, 0, 0, 195, 73);
INSERT INTO public.who_global_data VALUES (46213, 0, 1678, 5, 475, 195, 101);
INSERT INTO public.who_global_data VALUES (46214, 475, 4328, 5, 139, 195, 165);
INSERT INTO public.who_global_data VALUES (46215, 138, 2434, 2, 34, 195, 14);
INSERT INTO public.who_global_data VALUES (46216, 55, 36122, 21, 1250, 196, 193);
INSERT INTO public.who_global_data VALUES (46217, 104, 4570, 5, 128, 196, 113);
INSERT INTO public.who_global_data VALUES (46218, 675, 26159, 12, 1136, 196, 143);
INSERT INTO public.who_global_data VALUES (46219, 0, 0, 0, 0, 196, 219);
INSERT INTO public.who_global_data VALUES (46220, 8, 897, 0, 52, 196, 186);
INSERT INTO public.who_global_data VALUES (46221, 29, 880, 2, 35, 196, 52);
INSERT INTO public.who_global_data VALUES (46222, 0, 3, 0, 0, 196, 180);
INSERT INTO public.who_global_data VALUES (46223, 0, 76, 0, 3, 196, 167);
INSERT INTO public.who_global_data VALUES (46224, 6127, 148027, 105, 2722, 196, 154);
INSERT INTO public.who_global_data VALUES (46225, 383, 36309, 8, 695, 196, 94);
INSERT INTO public.who_global_data VALUES (46226, 0, 117, 0, 3, 196, 66);
INSERT INTO public.who_global_data VALUES (46227, 289, 13595, 6, 139, 196, 58);
INSERT INTO public.who_global_data VALUES (46228, 107, 20229, 0, 711, 196, 163);
INSERT INTO public.who_global_data VALUES (46229, 332, 29312, 9, 400, 196, 37);
INSERT INTO public.who_global_data VALUES (46230, 55, 274, 0, 11, 196, 142);
INSERT INTO public.who_global_data VALUES (46231, 462, 38458, 2, 136, 196, 83);
INSERT INTO public.who_global_data VALUES (46232, 2548, 218658, 35, 2836, 196, 228);
INSERT INTO public.who_global_data VALUES (46233, 0, 106, 0, 7, 196, 188);
INSERT INTO public.who_global_data VALUES (46234, 158, 66846, 5, 524, 196, 62);
INSERT INTO public.who_global_data VALUES (46235, 496, 66659, 5, 9686, 196, 160);
INSERT INTO public.who_global_data VALUES (46236, 4, 47, 0, 2, 196, 50);
INSERT INTO public.who_global_data VALUES (46237, 0, 1694, 0, 34, 196, 33);
INSERT INTO public.who_global_data VALUES (46238, 0, 153, 0, 9, 196, 183);
INSERT INTO public.who_global_data VALUES (46239, 0, 92, 0, 0, 196, 92);
INSERT INTO public.who_global_data VALUES (46240, 1117, 65252, 79, 2407, 196, 158);
INSERT INTO public.who_global_data VALUES (46241, 0, 5, 0, 0, 196, 67);
INSERT INTO public.who_global_data VALUES (46242, 304, 9764, 6, 278, 196, 57);
INSERT INTO public.who_global_data VALUES (46243, 64, 686, 0, 1, 196, 38);
INSERT INTO public.who_global_data VALUES (46244, 59961, 2287475, 1311, 84082, 196, 141);
INSERT INTO public.who_global_data VALUES (46245, 0, 8, 0, 1, 196, 178);
INSERT INTO public.who_global_data VALUES (46246, 0, 141, 0, 3, 196, 108);
INSERT INTO public.who_global_data VALUES (46247, 270, 10123, 8, 337, 196, 39);
INSERT INTO public.who_global_data VALUES (46248, 5, 1075, 0, 53, 196, 2);
INSERT INTO public.who_global_data VALUES (46249, 0, 345, 0, 1, 196, 195);
INSERT INTO public.who_global_data VALUES (46250, 30, 2220, 1, 22, 196, 107);
INSERT INTO public.who_global_data VALUES (46251, 0, 202, 0, 0, 196, 161);
INSERT INTO public.who_global_data VALUES (46252, 186, 16708, 3, 385, 196, 212);
INSERT INTO public.who_global_data VALUES (46253, 432, 112672, 4, 8874, 196, 181);
INSERT INTO public.who_global_data VALUES (46254, 0, 203, 0, 1, 196, 53);
INSERT INTO public.who_global_data VALUES (46255, 3, 4593, 1, 59, 196, 164);
INSERT INTO public.who_global_data VALUES (46256, 0, 915, 0, 75, 196, 140);
INSERT INTO public.who_global_data VALUES (46257, 2545, 341304, 76, 8914, 196, 20);
INSERT INTO public.who_global_data VALUES (46258, 160, 86660, 1, 4657, 196, 112);
INSERT INTO public.who_global_data VALUES (46259, 7945, 226373, 315, 7688, 196, 111);
INSERT INTO public.who_global_data VALUES (46260, 0, 340, 0, 7, 196, 71);
INSERT INTO public.who_global_data VALUES (46261, 104, 3038, 0, 51, 196, 218);
INSERT INTO public.who_global_data VALUES (46262, 0, 0, 0, 0, 196, 43);
INSERT INTO public.who_global_data VALUES (46263, 768, 13129, 9, 80, 196, 49);
INSERT INTO public.who_global_data VALUES (46264, 252, 15253, 1, 94, 196, 1);
INSERT INTO public.who_global_data VALUES (46265, 81, 4715, 0, 128, 196, 48);
INSERT INTO public.who_global_data VALUES (46266, 3, 2469, 0, 87, 196, 232);
INSERT INTO public.who_global_data VALUES (46267, 1, 29, 0, 1, 196, 175);
INSERT INTO public.who_global_data VALUES (46268, 2, 1047, 0, 19, 196, 21);
INSERT INTO public.who_global_data VALUES (46269, 281, 15081, 3, 368, 196, 156);
INSERT INTO public.who_global_data VALUES (46270, 0, 0, 0, 0, 196, 95);
INSERT INTO public.who_global_data VALUES (46271, 0, 8625, 0, 196, 196, 177);
INSERT INTO public.who_global_data VALUES (46272, 48, 13438, 1, 613, 196, 210);
INSERT INTO public.who_global_data VALUES (46273, 8, 5039, 0, 58, 196, 120);
INSERT INTO public.who_global_data VALUES (46274, 0, 18, 0, 0, 196, 135);
INSERT INTO public.who_global_data VALUES (46275, 1462, 59077, 30, 1036, 196, 206);
INSERT INTO public.who_global_data VALUES (46276, 901, 79049, 29, 5468, 196, 189);
INSERT INTO public.who_global_data VALUES (46277, 659, 91072, 38, 4518, 196, 129);
INSERT INTO public.who_global_data VALUES (46278, 415, 13792, 7, 379, 196, 121);
INSERT INTO public.who_global_data VALUES (46279, 0, 2350, 0, 41, 196, 59);
INSERT INTO public.who_global_data VALUES (46280, 0, 261, 0, 0, 196, 96);
INSERT INTO public.who_global_data VALUES (46281, 1, 2028, 0, 63, 196, 41);
INSERT INTO public.who_global_data VALUES (46282, 52, 2073, 0, 28, 196, 216);
INSERT INTO public.who_global_data VALUES (46283, 760, 12693, 3, 200, 196, 236);
INSERT INTO public.who_global_data VALUES (46284, 0, 13, 0, 0, 196, 150);
INSERT INTO public.who_global_data VALUES (46285, 0, 191, 0, 0, 196, 61);
INSERT INTO public.who_global_data VALUES (46286, 0, 27, 0, 0, 196, 7);
INSERT INTO public.who_global_data VALUES (46287, 8, 7380, 1, 329, 196, 169);
INSERT INTO public.who_global_data VALUES (46288, 931, 169222, 9, 30078, 196, 28);
INSERT INTO public.who_global_data VALUES (46289, 165, 7251, 1, 41, 196, 85);
INSERT INTO public.who_global_data VALUES (46290, 0, 62, 0, 0, 196, 211);
INSERT INTO public.who_global_data VALUES (46291, 396, 6984, 2, 49, 196, 60);
INSERT INTO public.who_global_data VALUES (46292, 0, 170, 0, 5, 196, 3);
INSERT INTO public.who_global_data VALUES (46293, 13, 1117, 0, 16, 196, 11);
INSERT INTO public.who_global_data VALUES (46294, 781, 204964, 7, 9118, 196, 89);
INSERT INTO public.who_global_data VALUES (46295, 1385, 31057, 8, 161, 196, 24);
INSERT INTO public.who_global_data VALUES (46296, 2, 184, 0, 0, 196, 162);
INSERT INTO public.who_global_data VALUES (46297, 25, 4135, 0, 201, 196, 100);
INSERT INTO public.who_global_data VALUES (46298, 0, 13, 0, 0, 196, 47);
INSERT INTO public.who_global_data VALUES (46299, 0, 23, 0, 0, 196, 29);
INSERT INTO public.who_global_data VALUES (46300, 8, 203, 0, 14, 196, 40);
INSERT INTO public.who_global_data VALUES (46301, 0, 329, 0, 5, 196, 222);
INSERT INTO public.who_global_data VALUES (46302, 1091, 43283, 37, 1669, 196, 132);
INSERT INTO public.who_global_data VALUES (46303, 0, 252, 0, 13, 196, 130);
INSERT INTO public.who_global_data VALUES (46304, 61, 6867, 0, 42, 196, 234);
INSERT INTO public.who_global_data VALUES (46305, 0, 1954, 0, 26, 196, 23);
INSERT INTO public.who_global_data VALUES (46306, 1, 351, 0, 19, 196, 192);
INSERT INTO public.who_global_data VALUES (46307, 30, 7197, 0, 154, 196, 69);
INSERT INTO public.who_global_data VALUES (46308, 0, 12, 0, 0, 196, 187);
INSERT INTO public.who_global_data VALUES (46309, 800, 36902, 5, 1011, 196, 230);
INSERT INTO public.who_global_data VALUES (46310, 26, 4424, 0, 596, 196, 77);
INSERT INTO public.who_global_data VALUES (46311, 2, 1843, 0, 10, 196, 9);
INSERT INTO public.who_global_data VALUES (46312, 48916, 1336861, 757, 31358, 196, 74);
INSERT INTO public.who_global_data VALUES (46313, 1761, 95418, 89, 4665, 196, 224);
INSERT INTO public.who_global_data VALUES (46314, 2489, 286523, 215, 15289, 196, 199);
INSERT INTO public.who_global_data VALUES (46315, 2485, 104711, 90, 4212, 196, 190);
INSERT INTO public.who_global_data VALUES (46316, 19, 25845, 0, 1763, 196, 12);
INSERT INTO public.who_global_data VALUES (46317, 0, 336, 0, 24, 196, 104);
INSERT INTO public.who_global_data VALUES (46318, 1990, 58484, 16, 479, 196, 153);
INSERT INTO public.who_global_data VALUES (46319, 252, 245590, 5, 35097, 196, 91);
INSERT INTO public.who_global_data VALUES (46320, 5, 821, 0, 10, 196, 215);
INSERT INTO public.who_global_data VALUES (46321, 830, 28786, 1, 993, 196, 84);
INSERT INTO public.who_global_data VALUES (46322, 0, 331, 0, 31, 196, 231);
INSERT INTO public.who_global_data VALUES (46323, 15, 1214, 0, 11, 196, 196);
INSERT INTO public.who_global_data VALUES (46324, 1494, 81720, 0, 585, 196, 105);
INSERT INTO public.who_global_data VALUES (46325, 667, 16268, 11, 274, 196, 122);
INSERT INTO public.who_global_data VALUES (46326, 0, 0, 0, 0, 196, 159);
INSERT INTO public.who_global_data VALUES (46327, 213, 6637, 6, 154, 196, 75);
INSERT INTO public.who_global_data VALUES (46328, 753, 62625, 4, 425, 196, 27);
INSERT INTO public.who_global_data VALUES (46329, 0, 31247, 38, 804, 196, 54);
INSERT INTO public.who_global_data VALUES (46330, 1, 20, 0, 0, 196, 226);
INSERT INTO public.who_global_data VALUES (46331, 2, 1205, 0, 31, 196, 79);
INSERT INTO public.who_global_data VALUES (46332, 147, 3407, 3, 46, 196, 56);
INSERT INTO public.who_global_data VALUES (46333, 60, 419, 3, 9, 196, 117);
INSERT INTO public.who_global_data VALUES (46334, 18, 1135, 0, 71, 196, 152);
INSERT INTO public.who_global_data VALUES (46335, 111, 2425, 1, 57, 196, 16);
INSERT INTO public.who_global_data VALUES (46336, 0, 87, 0, 1, 196, 10);
INSERT INTO public.who_global_data VALUES (46337, 14, 1996, 0, 80, 196, 201);
INSERT INTO public.who_global_data VALUES (46338, 104, 6056, 0, 112, 196, 174);
INSERT INTO public.who_global_data VALUES (46339, 360, 8741, 6, 76, 196, 119);
INSERT INTO public.who_global_data VALUES (46340, 68, 3454, 8, 87, 196, 168);
INSERT INTO public.who_global_data VALUES (46341, 21, 8861, 0, 123, 196, 99);
INSERT INTO public.who_global_data VALUES (46342, 55, 3175, 0, 15, 196, 171);
INSERT INTO public.who_global_data VALUES (46343, 9, 2503, 0, 123, 196, 87);
INSERT INTO public.who_global_data VALUES (46344, 4, 684, 0, 9, 196, 123);
INSERT INTO public.who_global_data VALUES (46345, 0, 0, 0, 0, 196, 151);
INSERT INTO public.who_global_data VALUES (46346, 7, 269, 0, 15, 196, 213);
INSERT INTO public.who_global_data VALUES (46347, 89, 6116, 1, 156, 196, 118);
INSERT INTO public.who_global_data VALUES (46348, 1, 344, 0, 10, 196, 134);
INSERT INTO public.who_global_data VALUES (46349, 11, 2873, 0, 38, 196, 65);
INSERT INTO public.who_global_data VALUES (46350, 8438, 370712, 718, 41908, 196, 102);
INSERT INTO public.who_global_data VALUES (46351, 0, 0, 0, 0, 196, 223);
INSERT INTO public.who_global_data VALUES (46352, 1, 84, 0, 1, 196, 4);
INSERT INTO public.who_global_data VALUES (46353, 1, 288, 0, 0, 196, 146);
INSERT INTO public.who_global_data VALUES (46354, 69, 2794, 0, 43, 196, 31);
INSERT INTO public.who_global_data VALUES (46355, 0, 12, 0, 1, 196, 127);
INSERT INTO public.who_global_data VALUES (46356, 570, 18834, 7, 299, 196, 22);
INSERT INTO public.who_global_data VALUES (46357, 8, 1590, 0, 11, 196, 115);
INSERT INTO public.who_global_data VALUES (46358, 3, 346, 0, 6, 196, 106);
INSERT INTO public.who_global_data VALUES (46359, 17, 1539, 0, 7, 196, 90);
INSERT INTO public.who_global_data VALUES (46360, 0, 0, 0, 0, 196, 70);
INSERT INTO public.who_global_data VALUES (46361, 133, 18374, 1, 44, 196, 46);
INSERT INTO public.who_global_data VALUES (46362, 155, 52483, 0, 6137, 196, 139);
INSERT INTO public.who_global_data VALUES (46363, 0, 22, 0, 0, 196, 42);
INSERT INTO public.who_global_data VALUES (46364, 0, 1206, 0, 22, 196, 80);
INSERT INTO public.who_global_data VALUES (46365, 0, 3004, 0, 108, 196, 203);
INSERT INTO public.who_global_data VALUES (46366, 0, 1124, 0, 69, 196, 136);
INSERT INTO public.who_global_data VALUES (46367, 591, 39539, 12, 845, 196, 63);
INSERT INTO public.who_global_data VALUES (46368, 0, 0, 0, 0, 196, 17);
INSERT INTO public.who_global_data VALUES (46369, 0, 38, 0, 2, 196, 172);
INSERT INTO public.who_global_data VALUES (46370, 129, 9797, 6, 451, 196, 109);
INSERT INTO public.who_global_data VALUES (46371, 23, 9085, 0, 255, 196, 200);
INSERT INTO public.who_global_data VALUES (46372, 537, 12412, 3, 73, 196, 93);
INSERT INTO public.who_global_data VALUES (46373, 1145, 73791, 4, 359, 196, 5);
INSERT INTO public.who_global_data VALUES (46374, 0, 741, 0, 13, 196, 214);
INSERT INTO public.who_global_data VALUES (46375, 1487, 271887, 24, 5787, 196, 204);
INSERT INTO public.who_global_data VALUES (46376, 0, 0, 0, 0, 196, 198);
INSERT INTO public.who_global_data VALUES (46377, 911, 56817, 29, 1209, 196, 173);
INSERT INTO public.who_global_data VALUES (46378, 1, 32, 0, 0, 196, 229);
INSERT INTO public.who_global_data VALUES (46379, 113, 4113, 0, 36, 196, 76);
INSERT INTO public.who_global_data VALUES (46380, 4546, 371096, 199, 17654, 196, 138);
INSERT INTO public.who_global_data VALUES (46381, 2054, 76444, 8, 1879, 196, 98);
INSERT INTO public.who_global_data VALUES (46382, 0, 0, 0, 0, 196, 103);
INSERT INTO public.who_global_data VALUES (46383, 458, 42038, 4, 1655, 196, 225);
INSERT INTO public.who_global_data VALUES (46384, 313, 49692, 7, 1712, 196, 131);
INSERT INTO public.who_global_data VALUES (46385, 494, 13967, 3, 191, 196, 235);
INSERT INTO public.who_global_data VALUES (46386, 394, 108638, 0, 164, 196, 137);
INSERT INTO public.who_global_data VALUES (46387, 113, 14092, 0, 298, 196, 81);
INSERT INTO public.who_global_data VALUES (46388, 378, 22483, 5, 726, 196, 182);
INSERT INTO public.who_global_data VALUES (46389, 8, 654, 0, 3, 196, 145);
INSERT INTO public.who_global_data VALUES (46390, 1119, 42394, 24, 2150, 196, 26);
INSERT INTO public.who_global_data VALUES (46391, 5871, 806720, 146, 13192, 196, 170);
INSERT INTO public.who_global_data VALUES (46392, 19, 1729, 0, 5, 196, 191);
INSERT INTO public.who_global_data VALUES (46393, 0, 3, 0, 0, 196, 221);
INSERT INTO public.who_global_data VALUES (46394, 0, 6, 0, 0, 196, 64);
INSERT INTO public.who_global_data VALUES (46395, 0, 0, 0, 0, 196, 116);
INSERT INTO public.who_global_data VALUES (46396, 0, 17, 0, 0, 196, 128);
INSERT INTO public.who_global_data VALUES (46397, 0, 24, 0, 0, 196, 6);
INSERT INTO public.who_global_data VALUES (46398, 0, 46, 0, 3, 196, 227);
INSERT INTO public.who_global_data VALUES (46399, 0, 4, 0, 0, 196, 68);
INSERT INTO public.who_global_data VALUES (46400, 0, 52, 0, 0, 196, 184);
INSERT INTO public.who_global_data VALUES (46401, 0, 0, 0, 0, 196, 82);
INSERT INTO public.who_global_data VALUES (46402, 0, 716, 0, 42, 196, 149);
INSERT INTO public.who_global_data VALUES (46403, 111, 860, 0, 14, 196, 197);
INSERT INTO public.who_global_data VALUES (46404, 2378, 262772, 37, 2672, 196, 78);
INSERT INTO public.who_global_data VALUES (46405, 156, 9422, 4, 182, 196, 233);
INSERT INTO public.who_global_data VALUES (46406, 409, 22852, 10, 518, 196, 133);
INSERT INTO public.who_global_data VALUES (46407, 0, 107, 0, 0, 196, 35);
INSERT INTO public.who_global_data VALUES (46408, 13, 1765, 0, 66, 196, 114);
INSERT INTO public.who_global_data VALUES (46409, 277, 49375, 0, 27, 196, 237);
INSERT INTO public.who_global_data VALUES (46410, 0, 3, 0, 0, 196, 55);
INSERT INTO public.who_global_data VALUES (46411, 10, 94, 0, 15, 196, 176);
INSERT INTO public.who_global_data VALUES (46412, 29, 2118, 0, 28, 196, 202);
INSERT INTO public.who_global_data VALUES (46413, 14, 2067, 1, 118, 196, 155);
INSERT INTO public.who_global_data VALUES (46414, 0, 0, 0, 0, 196, 32);
INSERT INTO public.who_global_data VALUES (46415, 0, 3171, 0, 93, 196, 220);
INSERT INTO public.who_global_data VALUES (46416, 13944, 421996, 250, 6343, 196, 30);
INSERT INTO public.who_global_data VALUES (46417, 0, 2258, 0, 45, 196, 147);
INSERT INTO public.who_global_data VALUES (46418, 2525, 285674, 3, 29833, 196, 208);
INSERT INTO public.who_global_data VALUES (46419, 11, 2764, 0, 11, 196, 45);
INSERT INTO public.who_global_data VALUES (46420, 0, 11302, 0, 715, 196, 110);
INSERT INTO public.who_global_data VALUES (46421, 58, 1234, 2, 23, 196, 88);
INSERT INTO public.who_global_data VALUES (46422, 220, 75284, 5, 5741, 196, 51);
INSERT INTO public.who_global_data VALUES (46423, 148, 34317, 1, 1734, 196, 209);
INSERT INTO public.who_global_data VALUES (46424, 24, 608, 0, 35, 196, 205);
INSERT INTO public.who_global_data VALUES (46425, 44, 7104, 0, 58, 196, 18);
INSERT INTO public.who_global_data VALUES (46426, 3, 3282, 0, 58, 196, 72);
INSERT INTO public.who_global_data VALUES (46427, 731, 299167, 32, 41088, 196, 44);
INSERT INTO public.who_global_data VALUES (46428, 0, 24, 0, 0, 196, 15);
INSERT INTO public.who_global_data VALUES (46429, 11, 839, 1, 17, 196, 25);
INSERT INTO public.who_global_data VALUES (46430, 0, 0, 0, 0, 196, 179);
INSERT INTO public.who_global_data VALUES (46431, 0, 0, 0, 0, 196, 34);
INSERT INTO public.who_global_data VALUES (46432, 1, 142, 0, 8, 196, 207);
INSERT INTO public.who_global_data VALUES (46433, 18, 1443, 0, 50, 196, 166);
INSERT INTO public.who_global_data VALUES (46434, 937, 224252, 17, 5580, 196, 126);
INSERT INTO public.who_global_data VALUES (46435, 0, 0, 0, 0, 196, 97);
INSERT INTO public.who_global_data VALUES (46436, 4, 90, 0, 2, 196, 36);
INSERT INTO public.who_global_data VALUES (46437, 0, 0, 0, 0, 196, 125);
INSERT INTO public.who_global_data VALUES (46438, 9, 1089, 0, 1, 196, 124);
INSERT INTO public.who_global_data VALUES (46439, 1106, 63929, 19, 1590, 196, 185);
INSERT INTO public.who_global_data VALUES (46440, 261, 58249, 1, 343, 196, 194);
INSERT INTO public.who_global_data VALUES (46441, 0, 509, 0, 21, 196, 144);
INSERT INTO public.who_global_data VALUES (46442, 71714, 4009808, 1110, 143663, 196, 19);
INSERT INTO public.who_global_data VALUES (46443, 6, 342, 0, 7, 196, 217);
INSERT INTO public.who_global_data VALUES (46444, 24, 1141, 0, 34, 196, 148);
INSERT INTO public.who_global_data VALUES (46445, 667, 19653, 1, 104, 196, 86);
INSERT INTO public.who_global_data VALUES (46446, 0, 0, 0, 0, 196, 13);
INSERT INTO public.who_global_data VALUES (46447, 449, 13613, 5, 129, 196, 157);
INSERT INTO public.who_global_data VALUES (46448, 3, 415, 0, 0, 196, 8);
INSERT INTO public.who_global_data VALUES (46449, 0, 0, 0, 0, 196, 73);
INSERT INTO public.who_global_data VALUES (46450, 20, 1678, 8, 470, 196, 101);
INSERT INTO public.who_global_data VALUES (46451, 270, 3853, 6, 134, 196, 165);
INSERT INTO public.who_global_data VALUES (46452, 172, 2296, 4, 32, 196, 14);
INSERT INTO public.who_global_data VALUES (46453, 66, 36067, 14, 1229, 197, 193);
INSERT INTO public.who_global_data VALUES (46454, 108, 4466, 3, 123, 197, 113);
INSERT INTO public.who_global_data VALUES (46455, 612, 25484, 13, 1124, 197, 143);
INSERT INTO public.who_global_data VALUES (46456, 0, 0, 0, 0, 197, 219);
INSERT INTO public.who_global_data VALUES (46457, 0, 889, 0, 52, 197, 186);
INSERT INTO public.who_global_data VALUES (46458, 39, 851, 0, 33, 197, 52);
INSERT INTO public.who_global_data VALUES (46459, 0, 3, 0, 0, 197, 180);
INSERT INTO public.who_global_data VALUES (46460, 0, 76, 0, 3, 197, 167);
INSERT INTO public.who_global_data VALUES (46461, 5782, 141900, 111, 2617, 197, 154);
INSERT INTO public.who_global_data VALUES (46462, 451, 35926, 4, 687, 197, 94);
INSERT INTO public.who_global_data VALUES (46463, 0, 117, 0, 3, 197, 66);
INSERT INTO public.who_global_data VALUES (46464, 410, 13306, 5, 133, 197, 58);
INSERT INTO public.who_global_data VALUES (46465, 164, 20122, 0, 711, 197, 163);
INSERT INTO public.who_global_data VALUES (46466, 347, 28980, 6, 391, 197, 37);
INSERT INTO public.who_global_data VALUES (46467, 25, 219, 0, 11, 197, 142);
INSERT INTO public.who_global_data VALUES (46468, 359, 37996, 4, 134, 197, 83);
INSERT INTO public.who_global_data VALUES (46469, 2856, 216110, 50, 2801, 197, 228);
INSERT INTO public.who_global_data VALUES (46470, 0, 106, 0, 7, 197, 188);
INSERT INTO public.who_global_data VALUES (46471, 167, 66688, 6, 519, 197, 62);
INSERT INTO public.who_global_data VALUES (46472, 439, 66163, 2, 9681, 197, 160);
INSERT INTO public.who_global_data VALUES (46473, 0, 43, 0, 2, 197, 50);
INSERT INTO public.who_global_data VALUES (46474, 4, 1694, 0, 34, 197, 33);
INSERT INTO public.who_global_data VALUES (46475, 0, 153, 0, 9, 197, 183);
INSERT INTO public.who_global_data VALUES (46476, 0, 92, 0, 0, 197, 92);
INSERT INTO public.who_global_data VALUES (46477, 1778, 64135, 55, 2328, 197, 158);
INSERT INTO public.who_global_data VALUES (46478, 0, 5, 0, 0, 197, 67);
INSERT INTO public.who_global_data VALUES (46479, 344, 9460, 5, 272, 197, 57);
INSERT INTO public.who_global_data VALUES (46480, 0, 622, 0, 1, 197, 38);
INSERT INTO public.who_global_data VALUES (46481, 67860, 2227514, 1284, 82771, 197, 141);
INSERT INTO public.who_global_data VALUES (46482, 0, 8, 0, 1, 197, 178);
INSERT INTO public.who_global_data VALUES (46483, 0, 141, 0, 3, 197, 108);
INSERT INTO public.who_global_data VALUES (46484, 269, 9853, 8, 329, 197, 39);
INSERT INTO public.who_global_data VALUES (46485, 4, 1070, 0, 53, 197, 2);
INSERT INTO public.who_global_data VALUES (46486, 7, 345, 0, 1, 197, 195);
INSERT INTO public.who_global_data VALUES (46487, 36, 2190, 0, 21, 197, 107);
INSERT INTO public.who_global_data VALUES (46488, 4, 202, 0, 0, 197, 161);
INSERT INTO public.who_global_data VALUES (46489, 0, 16522, 0, 382, 197, 212);
INSERT INTO public.who_global_data VALUES (46490, 543, 112240, 8, 8870, 197, 181);
INSERT INTO public.who_global_data VALUES (46491, 0, 203, 0, 1, 197, 53);
INSERT INTO public.who_global_data VALUES (46492, 16, 4590, 1, 58, 197, 164);
INSERT INTO public.who_global_data VALUES (46493, 26, 915, 0, 75, 197, 140);
INSERT INTO public.who_global_data VALUES (46494, 2357, 338759, 116, 8838, 197, 20);
INSERT INTO public.who_global_data VALUES (46495, 139, 86500, 1, 4656, 197, 112);
INSERT INTO public.who_global_data VALUES (46496, 7390, 218428, 207, 7373, 197, 111);
INSERT INTO public.who_global_data VALUES (46497, 3, 340, 0, 7, 197, 71);
INSERT INTO public.who_global_data VALUES (46498, 0, 2934, 0, 51, 197, 218);
INSERT INTO public.who_global_data VALUES (46499, 0, 0, 0, 0, 197, 43);
INSERT INTO public.who_global_data VALUES (46500, 550, 12361, 3, 71, 197, 49);
INSERT INTO public.who_global_data VALUES (46501, 268, 15001, 0, 93, 197, 1);
INSERT INTO public.who_global_data VALUES (46502, 104, 4634, 3, 128, 197, 48);
INSERT INTO public.who_global_data VALUES (46503, 4, 2466, 0, 87, 197, 232);
INSERT INTO public.who_global_data VALUES (46504, 0, 28, 0, 1, 197, 175);
INSERT INTO public.who_global_data VALUES (46505, 5, 1045, 0, 19, 197, 21);
INSERT INTO public.who_global_data VALUES (46506, 230, 14800, 1, 365, 197, 156);
INSERT INTO public.who_global_data VALUES (46507, 0, 0, 0, 0, 197, 95);
INSERT INTO public.who_global_data VALUES (46508, 0, 8625, 0, 196, 197, 177);
INSERT INTO public.who_global_data VALUES (46509, 40, 13390, 1, 612, 197, 210);
INSERT INTO public.who_global_data VALUES (46510, 1, 5031, 0, 58, 197, 120);
INSERT INTO public.who_global_data VALUES (46511, 0, 18, 0, 0, 197, 135);
INSERT INTO public.who_global_data VALUES (46512, 1572, 57615, 1, 1006, 197, 206);
INSERT INTO public.who_global_data VALUES (46513, 891, 78148, 21, 5439, 197, 189);
INSERT INTO public.who_global_data VALUES (46514, 668, 90413, 40, 4480, 197, 129);
INSERT INTO public.who_global_data VALUES (46515, 402, 13377, 9, 372, 197, 121);
INSERT INTO public.who_global_data VALUES (46516, 0, 2350, 0, 41, 197, 59);
INSERT INTO public.who_global_data VALUES (46517, 10, 261, 0, 0, 197, 96);
INSERT INTO public.who_global_data VALUES (46518, 2, 2027, 0, 63, 197, 41);
INSERT INTO public.who_global_data VALUES (46519, 83, 2021, 3, 28, 197, 216);
INSERT INTO public.who_global_data VALUES (46520, 409, 11933, 9, 197, 197, 236);
INSERT INTO public.who_global_data VALUES (46521, 0, 13, 0, 0, 197, 150);
INSERT INTO public.who_global_data VALUES (46522, 0, 191, 0, 0, 197, 61);
INSERT INTO public.who_global_data VALUES (46523, 0, 27, 0, 0, 197, 7);
INSERT INTO public.who_global_data VALUES (46524, 10, 7372, 0, 328, 197, 169);
INSERT INTO public.who_global_data VALUES (46525, 835, 168291, 9, 30069, 197, 28);
INSERT INTO public.who_global_data VALUES (46526, 203, 7086, 1, 40, 197, 85);
INSERT INTO public.who_global_data VALUES (46527, 0, 62, 0, 0, 197, 211);
INSERT INTO public.who_global_data VALUES (46528, 0, 6588, 0, 47, 197, 60);
INSERT INTO public.who_global_data VALUES (46529, 38, 170, 0, 5, 197, 3);
INSERT INTO public.who_global_data VALUES (46530, 19, 1104, 0, 16, 197, 11);
INSERT INTO public.who_global_data VALUES (46531, 815, 204183, 10, 9111, 197, 89);
INSERT INTO public.who_global_data VALUES (46532, 0, 29672, 0, 153, 197, 24);
INSERT INTO public.who_global_data VALUES (46533, 2, 182, 0, 0, 197, 162);
INSERT INTO public.who_global_data VALUES (46534, 33, 4110, 1, 201, 197, 100);
INSERT INTO public.who_global_data VALUES (46535, 0, 13, 0, 0, 197, 47);
INSERT INTO public.who_global_data VALUES (46536, 0, 23, 0, 0, 197, 29);
INSERT INTO public.who_global_data VALUES (46537, 0, 195, 0, 14, 197, 40);
INSERT INTO public.who_global_data VALUES (46538, 5, 329, 0, 5, 197, 222);
INSERT INTO public.who_global_data VALUES (46539, 1057, 42192, 59, 1632, 197, 132);
INSERT INTO public.who_global_data VALUES (46540, 0, 252, 0, 13, 197, 130);
INSERT INTO public.who_global_data VALUES (46541, 59, 6806, 1, 42, 197, 234);
INSERT INTO public.who_global_data VALUES (46542, 0, 1954, 0, 26, 197, 23);
INSERT INTO public.who_global_data VALUES (46543, 11, 350, 0, 19, 197, 192);
INSERT INTO public.who_global_data VALUES (46544, 21, 7167, 0, 154, 197, 69);
INSERT INTO public.who_global_data VALUES (46545, 0, 12, 0, 0, 197, 187);
INSERT INTO public.who_global_data VALUES (46546, 757, 36102, 18, 1006, 197, 230);
INSERT INTO public.who_global_data VALUES (46547, 18, 4398, 0, 596, 197, 77);
INSERT INTO public.who_global_data VALUES (46548, 1, 1841, 0, 10, 197, 9);
INSERT INTO public.who_global_data VALUES (46549, 49310, 1287945, 740, 30601, 197, 74);
INSERT INTO public.who_global_data VALUES (46550, 1906, 93657, 117, 4576, 197, 224);
INSERT INTO public.who_global_data VALUES (46551, 2621, 284034, 221, 15074, 197, 199);
INSERT INTO public.who_global_data VALUES (46552, 2361, 102226, 80, 4122, 197, 190);
INSERT INTO public.who_global_data VALUES (46553, 7, 25826, 9, 1763, 197, 12);
INSERT INTO public.who_global_data VALUES (46554, 0, 336, 0, 24, 197, 104);
INSERT INTO public.who_global_data VALUES (46555, 2044, 56494, 6, 463, 197, 153);
INSERT INTO public.who_global_data VALUES (46556, 306, 245338, 10, 35092, 197, 91);
INSERT INTO public.who_global_data VALUES (46557, 6, 816, 0, 10, 197, 215);
INSERT INTO public.who_global_data VALUES (46558, 927, 27956, 2, 992, 197, 84);
INSERT INTO public.who_global_data VALUES (46559, 0, 331, 0, 31, 197, 231);
INSERT INTO public.who_global_data VALUES (46560, 11, 1199, 0, 11, 197, 196);
INSERT INTO public.who_global_data VALUES (46561, 1740, 80226, 0, 585, 197, 105);
INSERT INTO public.who_global_data VALUES (46562, 796, 15601, 3, 263, 197, 122);
INSERT INTO public.who_global_data VALUES (46563, 0, 0, 0, 0, 197, 159);
INSERT INTO public.who_global_data VALUES (46564, 282, 6424, 8, 148, 197, 75);
INSERT INTO public.who_global_data VALUES (46565, 687, 61872, 4, 421, 197, 27);
INSERT INTO public.who_global_data VALUES (46566, 921, 31247, 42, 766, 197, 54);
INSERT INTO public.who_global_data VALUES (46567, 0, 19, 0, 0, 197, 226);
INSERT INTO public.who_global_data VALUES (46568, 6, 1203, 0, 31, 197, 79);
INSERT INTO public.who_global_data VALUES (46569, 156, 3260, 0, 43, 197, 56);
INSERT INTO public.who_global_data VALUES (46570, 0, 359, 0, 6, 197, 117);
INSERT INTO public.who_global_data VALUES (46571, 3, 1117, 1, 71, 197, 152);
INSERT INTO public.who_global_data VALUES (46572, 138, 2314, 3, 56, 197, 16);
INSERT INTO public.who_global_data VALUES (46573, 0, 87, 0, 1, 197, 10);
INSERT INTO public.who_global_data VALUES (46574, 26, 1982, 0, 80, 197, 201);
INSERT INTO public.who_global_data VALUES (46575, 98, 5952, 1, 112, 197, 174);
INSERT INTO public.who_global_data VALUES (46576, 219, 8381, 1, 70, 197, 119);
INSERT INTO public.who_global_data VALUES (46577, 84, 3386, 3, 79, 197, 168);
INSERT INTO public.who_global_data VALUES (46578, 9, 8840, 0, 123, 197, 99);
INSERT INTO public.who_global_data VALUES (46579, 17, 3120, 0, 15, 197, 171);
INSERT INTO public.who_global_data VALUES (46580, 0, 2494, 0, 123, 197, 87);
INSERT INTO public.who_global_data VALUES (46581, 2, 680, 0, 9, 197, 123);
INSERT INTO public.who_global_data VALUES (46582, 0, 0, 0, 0, 197, 151);
INSERT INTO public.who_global_data VALUES (46583, 0, 262, 0, 15, 197, 213);
INSERT INTO public.who_global_data VALUES (46584, 42, 6027, 0, 155, 197, 118);
INSERT INTO public.who_global_data VALUES (46585, 0, 343, 0, 10, 197, 134);
INSERT INTO public.who_global_data VALUES (46586, 23, 2862, 0, 38, 197, 65);
INSERT INTO public.who_global_data VALUES (46587, 6019, 362274, 790, 41190, 197, 102);
INSERT INTO public.who_global_data VALUES (46588, 0, 0, 0, 0, 197, 223);
INSERT INTO public.who_global_data VALUES (46589, 1, 83, 0, 1, 197, 4);
INSERT INTO public.who_global_data VALUES (46590, 0, 287, 0, 0, 197, 146);
INSERT INTO public.who_global_data VALUES (46591, 86, 2725, 3, 43, 197, 31);
INSERT INTO public.who_global_data VALUES (46592, 0, 12, 0, 1, 197, 127);
INSERT INTO public.who_global_data VALUES (46593, 302, 18264, 7, 292, 197, 22);
INSERT INTO public.who_global_data VALUES (46594, 25, 1582, 0, 11, 197, 115);
INSERT INTO public.who_global_data VALUES (46595, 0, 343, 0, 6, 197, 106);
INSERT INTO public.who_global_data VALUES (46596, 120, 1522, 0, 7, 197, 90);
INSERT INTO public.who_global_data VALUES (46597, 0, 0, 0, 0, 197, 70);
INSERT INTO public.who_global_data VALUES (46598, 147, 18241, 1, 43, 197, 46);
INSERT INTO public.who_global_data VALUES (46599, 164, 52328, 1, 6137, 197, 139);
INSERT INTO public.who_global_data VALUES (46600, 0, 22, 0, 0, 197, 42);
INSERT INTO public.who_global_data VALUES (46601, 1, 1206, 0, 22, 197, 80);
INSERT INTO public.who_global_data VALUES (46602, 0, 3004, 0, 108, 197, 203);
INSERT INTO public.who_global_data VALUES (46603, 2, 1124, 0, 69, 197, 136);
INSERT INTO public.who_global_data VALUES (46604, 604, 38948, 20, 833, 197, 63);
INSERT INTO public.who_global_data VALUES (46605, 0, 0, 0, 0, 197, 17);
INSERT INTO public.who_global_data VALUES (46606, 0, 38, 0, 2, 197, 172);
INSERT INTO public.who_global_data VALUES (46607, 121, 9668, 3, 445, 197, 109);
INSERT INTO public.who_global_data VALUES (46608, 9, 9062, 0, 255, 197, 200);
INSERT INTO public.who_global_data VALUES (46609, 596, 11875, 1, 70, 197, 93);
INSERT INTO public.who_global_data VALUES (46610, 1099, 72646, 6, 355, 197, 5);
INSERT INTO public.who_global_data VALUES (46611, 0, 741, 0, 13, 197, 214);
INSERT INTO public.who_global_data VALUES (46612, 1209, 270400, 54, 5763, 197, 204);
INSERT INTO public.who_global_data VALUES (46613, 0, 0, 0, 0, 197, 198);
INSERT INTO public.who_global_data VALUES (46614, 753, 55906, 21, 1180, 197, 173);
INSERT INTO public.who_global_data VALUES (46615, 1, 31, 0, 0, 197, 229);
INSERT INTO public.who_global_data VALUES (46616, 183, 4000, 1, 36, 197, 76);
INSERT INTO public.who_global_data VALUES (46617, 4463, 366550, 3876, 17455, 197, 138);
INSERT INTO public.who_global_data VALUES (46618, 2121, 74390, 28, 1871, 197, 98);
INSERT INTO public.who_global_data VALUES (46619, 0, 0, 0, 0, 197, 103);
INSERT INTO public.who_global_data VALUES (46620, 418, 41580, 9, 1651, 197, 225);
INSERT INTO public.who_global_data VALUES (46621, 229, 49379, 3, 1705, 197, 131);
INSERT INTO public.who_global_data VALUES (46622, 435, 13473, 3, 188, 197, 235);
INSERT INTO public.who_global_data VALUES (46623, 373, 108244, 1, 164, 197, 137);
INSERT INTO public.who_global_data VALUES (46624, 41, 13979, 1, 298, 197, 81);
INSERT INTO public.who_global_data VALUES (46625, 307, 22105, 8, 721, 197, 182);
INSERT INTO public.who_global_data VALUES (46626, 1, 646, 0, 3, 197, 145);
INSERT INTO public.who_global_data VALUES (46627, 1112, 41275, 25, 2126, 197, 26);
INSERT INTO public.who_global_data VALUES (46628, 5811, 800849, 154, 13046, 197, 170);
INSERT INTO public.who_global_data VALUES (46629, 21, 1710, 0, 5, 197, 191);
INSERT INTO public.who_global_data VALUES (46630, 0, 3, 0, 0, 197, 221);
INSERT INTO public.who_global_data VALUES (46631, 0, 6, 0, 0, 197, 64);
INSERT INTO public.who_global_data VALUES (46632, 0, 0, 0, 0, 197, 116);
INSERT INTO public.who_global_data VALUES (46633, 0, 17, 0, 0, 197, 128);
INSERT INTO public.who_global_data VALUES (46634, 1, 24, 0, 0, 197, 6);
INSERT INTO public.who_global_data VALUES (46635, 0, 46, 0, 3, 197, 227);
INSERT INTO public.who_global_data VALUES (46636, 0, 4, 0, 0, 197, 68);
INSERT INTO public.who_global_data VALUES (46637, 2, 52, 0, 0, 197, 184);
INSERT INTO public.who_global_data VALUES (46638, 0, 0, 0, 0, 197, 82);
INSERT INTO public.who_global_data VALUES (46639, 0, 716, 0, 42, 197, 149);
INSERT INTO public.who_global_data VALUES (46640, 2, 749, 0, 14, 197, 197);
INSERT INTO public.who_global_data VALUES (46641, 2238, 260394, 34, 2635, 197, 78);
INSERT INTO public.who_global_data VALUES (46642, 145, 9266, 1, 178, 197, 233);
INSERT INTO public.who_global_data VALUES (46643, 412, 22443, 9, 508, 197, 133);
INSERT INTO public.who_global_data VALUES (46644, 0, 107, 0, 0, 197, 35);
INSERT INTO public.who_global_data VALUES (46645, 21, 1752, 0, 66, 197, 114);
INSERT INTO public.who_global_data VALUES (46646, 354, 49098, 0, 27, 197, 237);
INSERT INTO public.who_global_data VALUES (46647, 0, 3, 0, 0, 197, 55);
INSERT INTO public.who_global_data VALUES (46648, 3, 84, 0, 15, 197, 176);
INSERT INTO public.who_global_data VALUES (46649, 31, 2089, 0, 28, 197, 202);
INSERT INTO public.who_global_data VALUES (46650, 19, 2053, 0, 117, 197, 155);
INSERT INTO public.who_global_data VALUES (46651, 0, 0, 0, 0, 197, 32);
INSERT INTO public.who_global_data VALUES (46652, 10, 3171, 0, 93, 197, 220);
INSERT INTO public.who_global_data VALUES (46653, 13104, 408052, 153, 6093, 197, 30);
INSERT INTO public.who_global_data VALUES (46654, 19, 2258, 0, 45, 197, 147);
INSERT INTO public.who_global_data VALUES (46655, 2505, 283149, 3, 29830, 197, 208);
INSERT INTO public.who_global_data VALUES (46656, 1, 2753, 0, 11, 197, 45);
INSERT INTO public.who_global_data VALUES (46657, 65, 11302, 7, 715, 197, 110);
INSERT INTO public.who_global_data VALUES (46658, 45, 1176, 0, 21, 197, 88);
INSERT INTO public.who_global_data VALUES (46659, 297, 75064, 6, 5736, 197, 51);
INSERT INTO public.who_global_data VALUES (46660, 143, 34169, 0, 1733, 197, 209);
INSERT INTO public.who_global_data VALUES (46661, 23, 584, 3, 35, 197, 205);
INSERT INTO public.who_global_data VALUES (46662, 45, 7060, 0, 58, 197, 18);
INSERT INTO public.who_global_data VALUES (46663, 10, 3279, 0, 58, 197, 72);
INSERT INTO public.who_global_data VALUES (46664, 773, 298436, 9, 41056, 197, 44);
INSERT INTO public.who_global_data VALUES (46665, 0, 24, 0, 0, 197, 15);
INSERT INTO public.who_global_data VALUES (46666, 22, 828, 0, 16, 197, 25);
INSERT INTO public.who_global_data VALUES (46667, 0, 0, 0, 0, 197, 179);
INSERT INTO public.who_global_data VALUES (46668, 0, 0, 0, 0, 197, 34);
INSERT INTO public.who_global_data VALUES (46669, 1, 141, 0, 8, 197, 207);
INSERT INTO public.who_global_data VALUES (46670, 19, 1425, 0, 50, 197, 166);
INSERT INTO public.who_global_data VALUES (46671, 913, 223315, 18, 5563, 197, 126);
INSERT INTO public.who_global_data VALUES (46672, 0, 0, 0, 0, 197, 97);
INSERT INTO public.who_global_data VALUES (46673, 4, 86, 0, 2, 197, 36);
INSERT INTO public.who_global_data VALUES (46674, 0, 0, 0, 0, 197, 125);
INSERT INTO public.who_global_data VALUES (46675, 5, 1080, 1, 1, 197, 124);
INSERT INTO public.who_global_data VALUES (46676, 972, 62823, 20, 1571, 197, 185);
INSERT INTO public.who_global_data VALUES (46677, 254, 57988, 0, 342, 197, 194);
INSERT INTO public.who_global_data VALUES (46678, 0, 509, 0, 21, 197, 144);
INSERT INTO public.who_global_data VALUES (46679, 69641, 3938094, 1074, 142553, 197, 19);
INSERT INTO public.who_global_data VALUES (46680, 16, 336, 0, 7, 197, 217);
INSERT INTO public.who_global_data VALUES (46681, 21, 1117, 1, 34, 197, 148);
INSERT INTO public.who_global_data VALUES (46682, 455, 18986, 4, 103, 197, 86);
INSERT INTO public.who_global_data VALUES (46683, 0, 0, 0, 0, 197, 13);
INSERT INTO public.who_global_data VALUES (46684, 390, 13164, 4, 124, 197, 157);
INSERT INTO public.who_global_data VALUES (46685, 4, 412, 0, 0, 197, 8);
INSERT INTO public.who_global_data VALUES (46686, 0, 0, 0, 0, 197, 73);
INSERT INTO public.who_global_data VALUES (46687, 14, 1658, 3, 462, 197, 101);
INSERT INTO public.who_global_data VALUES (46688, 0, 3583, 0, 128, 197, 165);
INSERT INTO public.who_global_data VALUES (46689, 90, 2124, 2, 28, 197, 14);
INSERT INTO public.who_global_data VALUES (46690, 188, 36001, 21, 1215, 198, 193);
INSERT INTO public.who_global_data VALUES (46691, 68, 4358, 3, 120, 198, 113);
INSERT INTO public.who_global_data VALUES (46692, 594, 24872, 11, 1111, 198, 143);
INSERT INTO public.who_global_data VALUES (46693, 0, 0, 0, 0, 198, 219);
INSERT INTO public.who_global_data VALUES (46694, 5, 889, 0, 52, 198, 186);
INSERT INTO public.who_global_data VALUES (46695, 33, 812, 3, 33, 198, 52);
INSERT INTO public.who_global_data VALUES (46696, 0, 3, 0, 0, 198, 180);
INSERT INTO public.who_global_data VALUES (46697, 0, 76, 0, 3, 198, 167);
INSERT INTO public.who_global_data VALUES (46698, 5344, 136118, 80, 2506, 198, 154);
INSERT INTO public.who_global_data VALUES (46699, 469, 35475, 10, 683, 198, 94);
INSERT INTO public.who_global_data VALUES (46700, 2, 117, 0, 3, 198, 66);
INSERT INTO public.who_global_data VALUES (46701, 468, 12896, 2, 128, 198, 58);
INSERT INTO public.who_global_data VALUES (46702, 140, 19958, 1, 711, 198, 163);
INSERT INTO public.who_global_data VALUES (46703, 391, 28633, 9, 385, 198, 37);
INSERT INTO public.who_global_data VALUES (46704, 20, 194, 0, 11, 198, 142);
INSERT INTO public.who_global_data VALUES (46705, 321, 37637, 1, 130, 198, 83);
INSERT INTO public.who_global_data VALUES (46706, 2744, 213254, 42, 2751, 198, 228);
INSERT INTO public.who_global_data VALUES (46707, 0, 106, 0, 7, 198, 188);
INSERT INTO public.who_global_data VALUES (46708, 173, 66521, 6, 513, 198, 62);
INSERT INTO public.who_global_data VALUES (46709, 553, 65724, 2, 9679, 198, 160);
INSERT INTO public.who_global_data VALUES (46710, 1, 43, 0, 2, 198, 50);
INSERT INTO public.who_global_data VALUES (46711, 0, 1690, 0, 34, 198, 33);
INSERT INTO public.who_global_data VALUES (46712, 0, 153, 0, 9, 198, 183);
INSERT INTO public.who_global_data VALUES (46713, 0, 92, 0, 0, 198, 92);
INSERT INTO public.who_global_data VALUES (46714, 1366, 62357, 55, 2273, 198, 158);
INSERT INTO public.who_global_data VALUES (46715, 0, 5, 0, 0, 198, 67);
INSERT INTO public.who_global_data VALUES (46716, 330, 9116, 6, 267, 198, 57);
INSERT INTO public.who_global_data VALUES (46717, 100, 622, 0, 1, 198, 38);
INSERT INTO public.who_global_data VALUES (46718, 41008, 2159654, 1367, 81487, 198, 141);
INSERT INTO public.who_global_data VALUES (46719, 0, 8, 0, 1, 198, 178);
INSERT INTO public.who_global_data VALUES (46720, 0, 141, 0, 3, 198, 108);
INSERT INTO public.who_global_data VALUES (46721, 330, 9584, 8, 321, 198, 39);
INSERT INTO public.who_global_data VALUES (46722, 1, 1066, 0, 53, 198, 2);
INSERT INTO public.who_global_data VALUES (46723, 10, 338, 0, 1, 198, 195);
INSERT INTO public.who_global_data VALUES (46724, 47, 2154, 0, 21, 198, 107);
INSERT INTO public.who_global_data VALUES (46725, 1, 198, 0, 0, 198, 161);
INSERT INTO public.who_global_data VALUES (46726, 0, 16522, 0, 382, 198, 212);
INSERT INTO public.who_global_data VALUES (46727, 573, 111697, 4, 8862, 198, 181);
INSERT INTO public.who_global_data VALUES (46728, 0, 203, 0, 1, 198, 53);
INSERT INTO public.who_global_data VALUES (46729, 13, 4574, 2, 57, 198, 164);
INSERT INTO public.who_global_data VALUES (46730, 0, 889, 0, 75, 198, 140);
INSERT INTO public.who_global_data VALUES (46731, 1719, 336402, 45, 8722, 198, 20);
INSERT INTO public.who_global_data VALUES (46732, 135, 86361, 0, 4655, 198, 112);
INSERT INTO public.who_global_data VALUES (46733, 7033, 211038, 237, 7166, 198, 111);
INSERT INTO public.who_global_data VALUES (46734, 0, 337, 0, 7, 198, 71);
INSERT INTO public.who_global_data VALUES (46735, 83, 2934, 1, 51, 198, 218);
INSERT INTO public.who_global_data VALUES (46736, 0, 0, 0, 0, 198, 43);
INSERT INTO public.who_global_data VALUES (46737, 277, 11811, 2, 68, 198, 49);
INSERT INTO public.who_global_data VALUES (46738, 202, 14733, 0, 93, 198, 1);
INSERT INTO public.who_global_data VALUES (46739, 108, 4530, 3, 125, 198, 48);
INSERT INTO public.who_global_data VALUES (46740, 13, 2462, 0, 87, 198, 232);
INSERT INTO public.who_global_data VALUES (46741, 0, 28, 0, 1, 198, 175);
INSERT INTO public.who_global_data VALUES (46742, 0, 1040, 0, 19, 198, 21);
INSERT INTO public.who_global_data VALUES (46743, 246, 14570, 4, 364, 198, 156);
INSERT INTO public.who_global_data VALUES (46744, 0, 0, 0, 0, 198, 95);
INSERT INTO public.who_global_data VALUES (46745, 92, 8625, 1, 196, 198, 177);
INSERT INTO public.who_global_data VALUES (46746, 48, 13350, 0, 611, 198, 210);
INSERT INTO public.who_global_data VALUES (46747, 3, 5030, 2, 58, 198, 120);
INSERT INTO public.who_global_data VALUES (46748, 0, 18, 0, 0, 198, 135);
INSERT INTO public.who_global_data VALUES (46749, 1246, 56043, 6, 1005, 198, 206);
INSERT INTO public.who_global_data VALUES (46750, 1040, 77257, 52, 5418, 198, 189);
INSERT INTO public.who_global_data VALUES (46751, 667, 89745, 41, 4440, 198, 129);
INSERT INTO public.who_global_data VALUES (46752, 393, 12975, 11, 363, 198, 121);
INSERT INTO public.who_global_data VALUES (46753, 0, 2350, 0, 41, 198, 59);
INSERT INTO public.who_global_data VALUES (46754, 0, 251, 0, 0, 198, 96);
INSERT INTO public.who_global_data VALUES (46755, 3, 2025, 0, 63, 198, 41);
INSERT INTO public.who_global_data VALUES (46756, 44, 1938, 1, 25, 198, 216);
INSERT INTO public.who_global_data VALUES (46757, 452, 11524, 8, 188, 198, 236);
INSERT INTO public.who_global_data VALUES (46758, 0, 13, 0, 0, 198, 150);
INSERT INTO public.who_global_data VALUES (46759, 0, 191, 0, 0, 198, 61);
INSERT INTO public.who_global_data VALUES (46760, 0, 27, 0, 0, 198, 7);
INSERT INTO public.who_global_data VALUES (46761, 11, 7362, 0, 328, 198, 169);
INSERT INTO public.who_global_data VALUES (46762, 945, 167456, 7, 30060, 198, 28);
INSERT INTO public.who_global_data VALUES (46763, 32, 6883, 0, 39, 198, 85);
INSERT INTO public.who_global_data VALUES (46764, 0, 62, 0, 0, 198, 211);
INSERT INTO public.who_global_data VALUES (46765, 155, 6588, 1, 47, 198, 60);
INSERT INTO public.who_global_data VALUES (46766, 0, 132, 0, 5, 198, 3);
INSERT INTO public.who_global_data VALUES (46767, 12, 1085, 0, 16, 198, 11);
INSERT INTO public.who_global_data VALUES (46768, 569, 203368, 6, 9101, 198, 89);
INSERT INTO public.who_global_data VALUES (46769, 683, 29672, 0, 153, 198, 24);
INSERT INTO public.who_global_data VALUES (46770, 0, 180, 0, 0, 198, 162);
INSERT INTO public.who_global_data VALUES (46771, 29, 4077, 3, 200, 198, 100);
INSERT INTO public.who_global_data VALUES (46772, 0, 13, 0, 0, 198, 47);
INSERT INTO public.who_global_data VALUES (46773, 0, 23, 0, 0, 198, 29);
INSERT INTO public.who_global_data VALUES (46774, 0, 195, 0, 14, 198, 40);
INSERT INTO public.who_global_data VALUES (46775, 5, 324, 0, 5, 198, 222);
INSERT INTO public.who_global_data VALUES (46776, 906, 41135, 42, 1573, 198, 132);
INSERT INTO public.who_global_data VALUES (46777, 0, 252, 0, 13, 198, 130);
INSERT INTO public.who_global_data VALUES (46778, 122, 6747, 0, 41, 198, 234);
INSERT INTO public.who_global_data VALUES (46779, 0, 1954, 0, 26, 198, 23);
INSERT INTO public.who_global_data VALUES (46780, 2, 339, 0, 19, 198, 192);
INSERT INTO public.who_global_data VALUES (46781, 46, 7146, 3, 154, 198, 69);
INSERT INTO public.who_global_data VALUES (46782, 0, 12, 0, 0, 198, 187);
INSERT INTO public.who_global_data VALUES (46783, 734, 35345, 53, 988, 198, 230);
INSERT INTO public.who_global_data VALUES (46784, 14, 4380, 0, 596, 198, 77);
INSERT INTO public.who_global_data VALUES (46785, 1, 1840, 0, 10, 198, 9);
INSERT INTO public.who_global_data VALUES (46786, 45720, 1238635, 1129, 29861, 198, 74);
INSERT INTO public.who_global_data VALUES (46787, 1882, 91751, 139, 4459, 198, 224);
INSERT INTO public.who_global_data VALUES (46788, 2586, 281413, 219, 14853, 198, 199);
INSERT INTO public.who_global_data VALUES (46789, 2706, 99865, 92, 4042, 198, 190);
INSERT INTO public.who_global_data VALUES (46790, 17, 25819, 1, 1754, 198, 12);
INSERT INTO public.who_global_data VALUES (46791, 0, 336, 0, 24, 198, 104);
INSERT INTO public.who_global_data VALUES (46792, 2006, 54450, 9, 457, 198, 153);
INSERT INTO public.who_global_data VALUES (46793, 280, 245032, 9, 35082, 198, 91);
INSERT INTO public.who_global_data VALUES (46794, 1, 810, 0, 10, 198, 215);
INSERT INTO public.who_global_data VALUES (46795, 726, 27029, 1, 990, 198, 84);
INSERT INTO public.who_global_data VALUES (46796, 0, 331, 0, 31, 198, 231);
INSERT INTO public.who_global_data VALUES (46797, 7, 1188, 0, 11, 198, 196);
INSERT INTO public.who_global_data VALUES (46798, 1687, 78486, 0, 585, 198, 105);
INSERT INTO public.who_global_data VALUES (46799, 637, 14805, 10, 260, 198, 122);
INSERT INTO public.who_global_data VALUES (46800, 0, 0, 0, 0, 198, 159);
INSERT INTO public.who_global_data VALUES (46801, 140, 6142, 6, 140, 198, 75);
INSERT INTO public.who_global_data VALUES (46802, 751, 61185, 5, 417, 198, 27);
INSERT INTO public.who_global_data VALUES (46803, 967, 30326, 46, 724, 198, 54);
INSERT INTO public.who_global_data VALUES (46804, 0, 19, 0, 0, 198, 226);
INSERT INTO public.who_global_data VALUES (46805, 4, 1197, 0, 31, 198, 79);
INSERT INTO public.who_global_data VALUES (46806, 124, 3104, 2, 43, 198, 56);
INSERT INTO public.who_global_data VALUES (46807, 0, 359, 0, 6, 198, 117);
INSERT INTO public.who_global_data VALUES (46808, 6, 1114, 0, 70, 198, 152);
INSERT INTO public.who_global_data VALUES (46809, 88, 2176, 3, 53, 198, 16);
INSERT INTO public.who_global_data VALUES (46810, 0, 87, 0, 1, 198, 10);
INSERT INTO public.who_global_data VALUES (46811, 10, 1956, 0, 80, 198, 201);
INSERT INTO public.who_global_data VALUES (46812, 129, 5854, 0, 111, 198, 174);
INSERT INTO public.who_global_data VALUES (46813, 614, 8162, 4, 69, 198, 119);
INSERT INTO public.who_global_data VALUES (46814, 153, 3302, 5, 76, 198, 168);
INSERT INTO public.who_global_data VALUES (46815, 16, 8831, 0, 123, 198, 99);
INSERT INTO public.who_global_data VALUES (46816, 59, 3103, 0, 15, 198, 171);
INSERT INTO public.who_global_data VALUES (46817, 17, 2494, 1, 123, 198, 87);
INSERT INTO public.who_global_data VALUES (46818, 1, 678, 0, 9, 198, 123);
INSERT INTO public.who_global_data VALUES (46819, 0, 0, 0, 0, 198, 151);
INSERT INTO public.who_global_data VALUES (46820, 0, 262, 0, 15, 198, 213);
INSERT INTO public.who_global_data VALUES (46821, 0, 5985, 0, 155, 198, 118);
INSERT INTO public.who_global_data VALUES (46822, 0, 343, 0, 10, 198, 134);
INSERT INTO public.who_global_data VALUES (46823, 15, 2839, 0, 38, 198, 65);
INSERT INTO public.who_global_data VALUES (46824, 6859, 356255, 915, 40400, 198, 102);
INSERT INTO public.who_global_data VALUES (46825, 0, 0, 0, 0, 198, 223);
INSERT INTO public.who_global_data VALUES (46826, 1, 82, 0, 1, 198, 4);
INSERT INTO public.who_global_data VALUES (46827, 0, 287, 0, 0, 198, 146);
INSERT INTO public.who_global_data VALUES (46828, 72, 2639, 1, 40, 198, 31);
INSERT INTO public.who_global_data VALUES (46829, 0, 12, 0, 1, 198, 127);
INSERT INTO public.who_global_data VALUES (46830, 220, 17962, 5, 285, 198, 22);
INSERT INTO public.who_global_data VALUES (46831, 21, 1557, 0, 11, 198, 115);
INSERT INTO public.who_global_data VALUES (46832, 2, 343, 0, 6, 198, 106);
INSERT INTO public.who_global_data VALUES (46833, 36, 1402, 0, 7, 198, 90);
INSERT INTO public.who_global_data VALUES (46834, 0, 0, 0, 0, 198, 70);
INSERT INTO public.who_global_data VALUES (46835, 100, 18094, 2, 42, 198, 46);
INSERT INTO public.who_global_data VALUES (46836, 170, 52164, 2, 6136, 198, 139);
INSERT INTO public.who_global_data VALUES (46837, 0, 22, 0, 0, 198, 42);
INSERT INTO public.who_global_data VALUES (46838, 0, 1205, 0, 22, 198, 80);
INSERT INTO public.who_global_data VALUES (46839, 0, 3004, 0, 108, 198, 203);
INSERT INTO public.who_global_data VALUES (46840, 14, 1122, 0, 69, 198, 136);
INSERT INTO public.who_global_data VALUES (46841, 543, 38344, 8, 813, 198, 63);
INSERT INTO public.who_global_data VALUES (46842, 0, 0, 0, 0, 198, 17);
INSERT INTO public.who_global_data VALUES (46843, 0, 38, 0, 2, 198, 172);
INSERT INTO public.who_global_data VALUES (46844, 135, 9547, 10, 442, 198, 109);
INSERT INTO public.who_global_data VALUES (46845, 15, 9053, 0, 255, 198, 200);
INSERT INTO public.who_global_data VALUES (46846, 356, 11279, 2, 69, 198, 93);
INSERT INTO public.who_global_data VALUES (46847, 1660, 71547, 12, 349, 198, 5);
INSERT INTO public.who_global_data VALUES (46848, 0, 741, 0, 13, 198, 214);
INSERT INTO public.who_global_data VALUES (46849, 1763, 269191, 32, 5709, 198, 204);
INSERT INTO public.who_global_data VALUES (46850, 0, 0, 0, 0, 198, 198);
INSERT INTO public.who_global_data VALUES (46851, 727, 55153, 32, 1159, 198, 173);
INSERT INTO public.who_global_data VALUES (46852, 3, 30, 0, 0, 198, 229);
INSERT INTO public.who_global_data VALUES (46853, 69, 3817, 2, 35, 198, 76);
INSERT INTO public.who_global_data VALUES (46854, 4406, 362087, 195, 13579, 198, 138);
INSERT INTO public.who_global_data VALUES (46855, 1505, 72269, 6, 1843, 198, 98);
INSERT INTO public.who_global_data VALUES (46856, 0, 0, 0, 0, 198, 103);
INSERT INTO public.who_global_data VALUES (46857, 380, 41162, 6, 1642, 198, 225);
INSERT INTO public.who_global_data VALUES (46858, 252, 49150, 5, 1702, 198, 131);
INSERT INTO public.who_global_data VALUES (46859, 98, 13038, 5, 185, 198, 235);
INSERT INTO public.who_global_data VALUES (46860, 441, 107871, 3, 163, 198, 137);
INSERT INTO public.who_global_data VALUES (46861, 59, 13938, 0, 297, 198, 81);
INSERT INTO public.who_global_data VALUES (46862, 356, 21798, 5, 713, 198, 182);
INSERT INTO public.who_global_data VALUES (46863, 6, 645, 0, 3, 198, 145);
INSERT INTO public.who_global_data VALUES (46864, 1030, 40163, 27, 2101, 198, 26);
INSERT INTO public.who_global_data VALUES (46865, 5848, 795038, 147, 12892, 198, 170);
INSERT INTO public.who_global_data VALUES (46866, 34, 1689, 0, 5, 198, 191);
INSERT INTO public.who_global_data VALUES (46867, 0, 3, 0, 0, 198, 221);
INSERT INTO public.who_global_data VALUES (46868, 0, 6, 0, 0, 198, 64);
INSERT INTO public.who_global_data VALUES (46869, 0, 0, 0, 0, 198, 116);
INSERT INTO public.who_global_data VALUES (46870, 0, 17, 0, 0, 198, 128);
INSERT INTO public.who_global_data VALUES (46871, 0, 23, 0, 0, 198, 6);
INSERT INTO public.who_global_data VALUES (46872, 0, 46, 0, 3, 198, 227);
INSERT INTO public.who_global_data VALUES (46873, 0, 4, 0, 0, 198, 68);
INSERT INTO public.who_global_data VALUES (46874, 0, 50, 0, 0, 198, 184);
INSERT INTO public.who_global_data VALUES (46875, 0, 0, 0, 0, 198, 82);
INSERT INTO public.who_global_data VALUES (46876, 0, 716, 0, 42, 198, 149);
INSERT INTO public.who_global_data VALUES (46877, 1, 747, 0, 14, 198, 197);
INSERT INTO public.who_global_data VALUES (46878, 2331, 258156, 44, 2601, 198, 78);
INSERT INTO public.who_global_data VALUES (46879, 136, 9121, 3, 177, 198, 233);
INSERT INTO public.who_global_data VALUES (46880, 426, 22031, 8, 499, 198, 133);
INSERT INTO public.who_global_data VALUES (46881, -1, 107, 0, 0, 198, 35);
INSERT INTO public.who_global_data VALUES (46882, 4, 1731, 0, 66, 198, 114);
INSERT INTO public.who_global_data VALUES (46883, 310, 48744, 0, 27, 198, 237);
INSERT INTO public.who_global_data VALUES (46884, 1, 3, 0, 0, 198, 55);
INSERT INTO public.who_global_data VALUES (46885, 2, 81, 0, 15, 198, 176);
INSERT INTO public.who_global_data VALUES (46886, 37, 2058, 0, 28, 198, 202);
INSERT INTO public.who_global_data VALUES (46887, 27, 2034, 0, 117, 198, 155);
INSERT INTO public.who_global_data VALUES (46888, 0, 0, 0, 0, 198, 32);
INSERT INTO public.who_global_data VALUES (46889, 26, 3161, 0, 93, 198, 220);
INSERT INTO public.who_global_data VALUES (46890, 13150, 394948, 572, 5940, 198, 30);
INSERT INTO public.who_global_data VALUES (46891, 28, 2239, 0, 45, 198, 147);
INSERT INTO public.who_global_data VALUES (46892, 2484, 280644, 7, 29827, 198, 208);
INSERT INTO public.who_global_data VALUES (46893, 22, 2752, 0, 11, 198, 45);
INSERT INTO public.who_global_data VALUES (46894, 110, 11237, 2, 708, 198, 110);
INSERT INTO public.who_global_data VALUES (46895, 52, 1131, 0, 21, 198, 88);
INSERT INTO public.who_global_data VALUES (46896, 226, 74767, 7, 5730, 198, 51);
INSERT INTO public.who_global_data VALUES (46897, 118, 34026, 0, 1733, 198, 209);
INSERT INTO public.who_global_data VALUES (46898, 21, 561, 1, 32, 198, 205);
INSERT INTO public.who_global_data VALUES (46899, 48, 7015, 1, 58, 198, 18);
INSERT INTO public.who_global_data VALUES (46900, 8, 3269, 0, 58, 198, 72);
INSERT INTO public.who_global_data VALUES (46901, 751, 297663, 17, 41047, 198, 44);
INSERT INTO public.who_global_data VALUES (46902, 0, 24, 0, 0, 198, 15);
INSERT INTO public.who_global_data VALUES (46903, 16, 806, 1, 16, 198, 25);
INSERT INTO public.who_global_data VALUES (46904, 0, 0, 0, 0, 198, 179);
INSERT INTO public.who_global_data VALUES (46905, 0, 0, 0, 0, 198, 34);
INSERT INTO public.who_global_data VALUES (46906, 3, 140, 0, 8, 198, 207);
INSERT INTO public.who_global_data VALUES (46907, 12, 1406, 0, 50, 198, 166);
INSERT INTO public.who_global_data VALUES (46908, 902, 222402, 19, 5545, 198, 126);
INSERT INTO public.who_global_data VALUES (46909, 0, 0, 0, 0, 198, 97);
INSERT INTO public.who_global_data VALUES (46910, 1, 82, 0, 2, 198, 36);
INSERT INTO public.who_global_data VALUES (46911, 0, 0, 0, 0, 198, 125);
INSERT INTO public.who_global_data VALUES (46912, 3, 1075, 0, 0, 198, 124);
INSERT INTO public.who_global_data VALUES (46913, 856, 61851, 17, 1551, 198, 185);
INSERT INTO public.who_global_data VALUES (46914, 236, 57734, 1, 342, 198, 194);
INSERT INTO public.who_global_data VALUES (46915, 0, 509, 0, 21, 198, 144);
INSERT INTO public.who_global_data VALUES (46916, 62929, 3868453, 1042, 141479, 198, 19);
INSERT INTO public.who_global_data VALUES (46917, 12, 320, 1, 7, 198, 217);
INSERT INTO public.who_global_data VALUES (46918, 32, 1096, 0, 33, 198, 148);
INSERT INTO public.who_global_data VALUES (46919, 360, 18531, 3, 99, 198, 86);
INSERT INTO public.who_global_data VALUES (46920, 0, 0, 0, 0, 198, 13);
INSERT INTO public.who_global_data VALUES (46921, 440, 12774, 4, 120, 198, 157);
INSERT INTO public.who_global_data VALUES (46922, 7, 408, 0, 0, 198, 8);
INSERT INTO public.who_global_data VALUES (46923, 0, 0, 0, 0, 198, 73);
INSERT INTO public.who_global_data VALUES (46924, 11, 1644, 2, 459, 198, 101);
INSERT INTO public.who_global_data VALUES (46925, 257, 3583, 0, 128, 198, 165);
INSERT INTO public.who_global_data VALUES (46926, 214, 2034, 0, 26, 198, 14);
INSERT INTO public.who_global_data VALUES (46927, 112, 35813, 6, 1194, 199, 193);
INSERT INTO public.who_global_data VALUES (46928, 119, 4290, 4, 117, 199, 113);
INSERT INTO public.who_global_data VALUES (46929, 587, 24278, 13, 1100, 199, 143);
INSERT INTO public.who_global_data VALUES (46930, 0, 0, 0, 0, 199, 219);
INSERT INTO public.who_global_data VALUES (46931, 0, 884, 0, 52, 199, 186);
INSERT INTO public.who_global_data VALUES (46932, 30, 779, 1, 30, 199, 52);
INSERT INTO public.who_global_data VALUES (46933, 0, 3, 0, 0, 199, 180);
INSERT INTO public.who_global_data VALUES (46934, 0, 76, 0, 3, 199, 167);
INSERT INTO public.who_global_data VALUES (46935, 4019, 130774, 145, 2426, 199, 154);
INSERT INTO public.who_global_data VALUES (46936, 439, 35006, 16, 673, 199, 94);
INSERT INTO public.who_global_data VALUES (46937, 2, 115, 0, 3, 199, 66);
INSERT INTO public.who_global_data VALUES (46938, 359, 12428, 3, 126, 199, 58);
INSERT INTO public.who_global_data VALUES (46939, 139, 19818, 0, 710, 199, 163);
INSERT INTO public.who_global_data VALUES (46940, 352, 28242, 13, 376, 199, 37);
INSERT INTO public.who_global_data VALUES (46941, 21, 174, 0, 11, 199, 142);
INSERT INTO public.who_global_data VALUES (46942, 380, 37316, 1, 129, 199, 83);
INSERT INTO public.who_global_data VALUES (46943, 3057, 210510, 41, 2709, 199, 228);
INSERT INTO public.who_global_data VALUES (46944, 1, 106, 0, 7, 199, 188);
INSERT INTO public.who_global_data VALUES (46945, 135, 66348, 4, 507, 199, 62);
INSERT INTO public.who_global_data VALUES (46946, 145, 65171, 1, 9677, 199, 160);
INSERT INTO public.who_global_data VALUES (46947, 2, 42, 0, 2, 199, 50);
INSERT INTO public.who_global_data VALUES (46948, 88, 1690, 3, 34, 199, 33);
INSERT INTO public.who_global_data VALUES (46949, 0, 153, 0, 9, 199, 183);
INSERT INTO public.who_global_data VALUES (46950, 2, 92, 0, 0, 199, 92);
INSERT INTO public.who_global_data VALUES (46951, 1409, 60991, 67, 2218, 199, 158);
INSERT INTO public.who_global_data VALUES (46952, 0, 5, 0, 0, 199, 67);
INSERT INTO public.who_global_data VALUES (46953, 195, 8786, 5, 261, 199, 57);
INSERT INTO public.who_global_data VALUES (46954, 0, 522, 0, 1, 199, 38);
INSERT INTO public.who_global_data VALUES (46955, 20257, 2118646, 632, 80120, 199, 141);
INSERT INTO public.who_global_data VALUES (46956, 0, 8, 0, 1, 199, 178);
INSERT INTO public.who_global_data VALUES (46957, 0, 141, 0, 3, 199, 108);
INSERT INTO public.who_global_data VALUES (46958, 325, 9254, 5, 313, 199, 39);
INSERT INTO public.who_global_data VALUES (46959, 0, 1065, 0, 53, 199, 2);
INSERT INTO public.who_global_data VALUES (46960, 0, 328, 0, 1, 199, 195);
INSERT INTO public.who_global_data VALUES (46961, 36, 2107, 0, 21, 199, 107);
INSERT INTO public.who_global_data VALUES (46962, 26, 197, 0, 0, 199, 161);
INSERT INTO public.who_global_data VALUES (46963, 0, 16522, 0, 382, 199, 212);
INSERT INTO public.who_global_data VALUES (46964, 786, 111124, 6, 8858, 199, 181);
INSERT INTO public.who_global_data VALUES (46965, 0, 203, 0, 1, 199, 53);
INSERT INTO public.who_global_data VALUES (46966, 76, 4561, 0, 55, 199, 164);
INSERT INTO public.who_global_data VALUES (46967, 0, 889, 0, 75, 199, 140);
INSERT INTO public.who_global_data VALUES (46968, 1654, 334683, 44, 8677, 199, 20);
INSERT INTO public.who_global_data VALUES (46969, 74, 86226, 2, 4655, 199, 112);
INSERT INTO public.who_global_data VALUES (46970, 6727, 204005, 193, 6929, 199, 111);
INSERT INTO public.who_global_data VALUES (46971, 3, 337, 0, 7, 199, 71);
INSERT INTO public.who_global_data VALUES (46972, 0, 2851, 0, 50, 199, 218);
INSERT INTO public.who_global_data VALUES (46973, 0, 0, 0, 0, 199, 43);
INSERT INTO public.who_global_data VALUES (46974, 420, 11534, 4, 66, 199, 49);
INSERT INTO public.who_global_data VALUES (46975, 219, 14531, 1, 93, 199, 1);
INSERT INTO public.who_global_data VALUES (46976, 52, 4422, 0, 122, 199, 48);
INSERT INTO public.who_global_data VALUES (46977, 3, 2449, 0, 87, 199, 232);
INSERT INTO public.who_global_data VALUES (46978, 0, 28, 0, 1, 199, 175);
INSERT INTO public.who_global_data VALUES (46979, 2, 1040, 0, 19, 199, 21);
INSERT INTO public.who_global_data VALUES (46980, 226, 14324, 1, 360, 199, 156);
INSERT INTO public.who_global_data VALUES (46981, 0, 0, 0, 0, 199, 95);
INSERT INTO public.who_global_data VALUES (46982, 91, 8533, 2, 195, 199, 177);
INSERT INTO public.who_global_data VALUES (46983, 40, 13302, 0, 611, 199, 210);
INSERT INTO public.who_global_data VALUES (46984, 7, 5027, 0, 56, 199, 120);
INSERT INTO public.who_global_data VALUES (46985, 0, 18, 0, 0, 199, 135);
INSERT INTO public.who_global_data VALUES (46986, 841, 54797, 6, 999, 199, 206);
INSERT INTO public.who_global_data VALUES (46987, 1597, 76217, 48, 5366, 199, 189);
INSERT INTO public.who_global_data VALUES (46988, 676, 89078, 47, 4399, 199, 129);
INSERT INTO public.who_global_data VALUES (46989, 375, 12582, 8, 352, 199, 121);
INSERT INTO public.who_global_data VALUES (46990, 0, 2350, 0, 41, 199, 59);
INSERT INTO public.who_global_data VALUES (46991, 0, 251, 0, 0, 199, 96);
INSERT INTO public.who_global_data VALUES (46992, 1, 2022, 0, 63, 199, 41);
INSERT INTO public.who_global_data VALUES (46993, 68, 1894, 1, 24, 199, 216);
INSERT INTO public.who_global_data VALUES (46994, 561, 11072, 7, 180, 199, 236);
INSERT INTO public.who_global_data VALUES (46995, 0, 13, 0, 0, 199, 150);
INSERT INTO public.who_global_data VALUES (46996, 0, 191, 0, 0, 199, 61);
INSERT INTO public.who_global_data VALUES (46997, 0, 27, 0, 0, 199, 7);
INSERT INTO public.who_global_data VALUES (46998, 11, 7351, 0, 328, 199, 169);
INSERT INTO public.who_global_data VALUES (46999, 454, 166511, -1, 30053, 199, 28);
INSERT INTO public.who_global_data VALUES (47000, 106, 6851, 1, 39, 199, 85);
INSERT INTO public.who_global_data VALUES (47001, 0, 62, 0, 0, 199, 211);
INSERT INTO public.who_global_data VALUES (47002, 312, 6433, 0, 46, 199, 60);
INSERT INTO public.who_global_data VALUES (47003, 20, 132, 1, 5, 199, 3);
INSERT INTO public.who_global_data VALUES (47004, 24, 1073, 0, 16, 199, 11);
INSERT INTO public.who_global_data VALUES (47005, 454, 202799, 5, 9095, 199, 89);
INSERT INTO public.who_global_data VALUES (47006, 559, 28989, 0, 153, 199, 24);
INSERT INTO public.who_global_data VALUES (47007, 0, 180, 0, 0, 199, 162);
INSERT INTO public.who_global_data VALUES (47008, 36, 4048, 2, 197, 199, 100);
INSERT INTO public.who_global_data VALUES (47009, 0, 13, 0, 0, 199, 47);
INSERT INTO public.who_global_data VALUES (47010, 0, 23, 0, 0, 199, 29);
INSERT INTO public.who_global_data VALUES (47011, 0, 195, 0, 14, 199, 40);
INSERT INTO public.who_global_data VALUES (47012, 8, 319, 0, 5, 199, 222);
INSERT INTO public.who_global_data VALUES (47013, 1190, 40229, 29, 1531, 199, 132);
INSERT INTO public.who_global_data VALUES (47014, 0, 252, 0, 13, 199, 130);
INSERT INTO public.who_global_data VALUES (47015, 35, 6625, 1, 41, 199, 234);
INSERT INTO public.who_global_data VALUES (47016, 0, 1954, 0, 26, 199, 23);
INSERT INTO public.who_global_data VALUES (47017, 1, 337, 0, 19, 199, 192);
INSERT INTO public.who_global_data VALUES (47018, 37, 7100, 5, 151, 199, 69);
INSERT INTO public.who_global_data VALUES (47019, 0, 12, 0, 0, 199, 187);
INSERT INTO public.who_global_data VALUES (47020, 776, 34611, 35, 935, 199, 230);
INSERT INTO public.who_global_data VALUES (47021, 19, 4366, 0, 596, 199, 77);
INSERT INTO public.who_global_data VALUES (47022, 0, 1839, 0, 10, 199, 9);
INSERT INTO public.who_global_data VALUES (47023, 37724, 1192915, 648, 28732, 199, 74);
INSERT INTO public.who_global_data VALUES (47024, 1655, 89869, 81, 4320, 199, 224);
INSERT INTO public.who_global_data VALUES (47025, 2625, 278827, 229, 14634, 199, 199);
INSERT INTO public.who_global_data VALUES (47026, 2466, 97159, 81, 3950, 199, 190);
INSERT INTO public.who_global_data VALUES (47027, 36, 25802, 0, 1753, 199, 12);
INSERT INTO public.who_global_data VALUES (47028, 0, 336, 0, 24, 199, 104);
INSERT INTO public.who_global_data VALUES (47029, 1887, 52444, 12, 448, 199, 153);
INSERT INTO public.who_global_data VALUES (47030, 128, 244752, 15, 35073, 199, 91);
INSERT INTO public.who_global_data VALUES (47031, 19, 809, 0, 10, 199, 215);
INSERT INTO public.who_global_data VALUES (47032, 567, 26303, 1, 989, 199, 84);
INSERT INTO public.who_global_data VALUES (47033, 0, 331, 0, 31, 199, 231);
INSERT INTO public.who_global_data VALUES (47034, 46, 1181, 0, 11, 199, 196);
INSERT INTO public.who_global_data VALUES (47035, 1646, 76799, 0, 585, 199, 105);
INSERT INTO public.who_global_data VALUES (47036, 397, 14168, 12, 250, 199, 122);
INSERT INTO public.who_global_data VALUES (47037, 0, 0, 0, 0, 199, 159);
INSERT INTO public.who_global_data VALUES (47038, 168, 6002, 5, 134, 199, 75);
INSERT INTO public.who_global_data VALUES (47039, 671, 60434, 4, 412, 199, 27);
INSERT INTO public.who_global_data VALUES (47040, 1108, 29359, 44, 678, 199, 54);
INSERT INTO public.who_global_data VALUES (47041, 0, 19, 0, 0, 199, 226);
INSERT INTO public.who_global_data VALUES (47042, 1, 1193, 0, 31, 199, 79);
INSERT INTO public.who_global_data VALUES (47043, 75, 2980, 0, 41, 199, 56);
INSERT INTO public.who_global_data VALUES (47044, 0, 359, 0, 6, 199, 117);
INSERT INTO public.who_global_data VALUES (47045, 1, 1108, 0, 70, 199, 152);
INSERT INTO public.who_global_data VALUES (47046, 108, 2088, 1, 50, 199, 16);
INSERT INTO public.who_global_data VALUES (47047, 0, 87, 0, 1, 199, 10);
INSERT INTO public.who_global_data VALUES (47048, 2, 1946, 0, 80, 199, 201);
INSERT INTO public.who_global_data VALUES (47049, 120, 5725, 0, 111, 199, 174);
INSERT INTO public.who_global_data VALUES (47050, 395, 7548, 3, 65, 199, 119);
INSERT INTO public.who_global_data VALUES (47051, 104, 3149, 7, 71, 199, 168);
INSERT INTO public.who_global_data VALUES (47052, 15, 8815, 0, 123, 199, 99);
INSERT INTO public.who_global_data VALUES (47053, 45, 3044, 0, 15, 199, 171);
INSERT INTO public.who_global_data VALUES (47054, 2, 2477, 1, 122, 199, 87);
INSERT INTO public.who_global_data VALUES (47055, 2, 677, 0, 9, 199, 123);
INSERT INTO public.who_global_data VALUES (47056, 0, 0, 0, 0, 199, 151);
INSERT INTO public.who_global_data VALUES (47057, 0, 262, 0, 15, 199, 213);
INSERT INTO public.who_global_data VALUES (47058, 62, 5985, 0, 155, 199, 118);
INSERT INTO public.who_global_data VALUES (47059, 0, 343, 0, 10, 199, 134);
INSERT INTO public.who_global_data VALUES (47060, 16, 2824, 0, 38, 199, 65);
INSERT INTO public.who_global_data VALUES (47061, 5172, 349396, 301, 39485, 199, 102);
INSERT INTO public.who_global_data VALUES (47062, 0, 0, 0, 0, 199, 223);
INSERT INTO public.who_global_data VALUES (47063, 2, 81, 0, 1, 199, 4);
INSERT INTO public.who_global_data VALUES (47064, 0, 287, 0, 0, 199, 146);
INSERT INTO public.who_global_data VALUES (47065, 97, 2567, 4, 39, 199, 31);
INSERT INTO public.who_global_data VALUES (47066, 0, 12, 0, 1, 199, 127);
INSERT INTO public.who_global_data VALUES (47067, 180, 17742, 4, 280, 199, 22);
INSERT INTO public.who_global_data VALUES (47068, 29, 1536, 0, 11, 199, 115);
INSERT INTO public.who_global_data VALUES (47069, 0, 341, 0, 6, 199, 106);
INSERT INTO public.who_global_data VALUES (47070, 22, 1366, 3, 7, 199, 90);
INSERT INTO public.who_global_data VALUES (47071, 0, 0, 0, 0, 199, 70);
INSERT INTO public.who_global_data VALUES (47072, 150, 17994, 0, 40, 199, 46);
INSERT INTO public.who_global_data VALUES (47073, 169, 51994, 1, 6134, 199, 139);
INSERT INTO public.who_global_data VALUES (47074, 0, 22, 0, 0, 199, 42);
INSERT INTO public.who_global_data VALUES (47075, 0, 1205, 0, 22, 199, 80);
INSERT INTO public.who_global_data VALUES (47076, 292, 3004, 9, 108, 199, 203);
INSERT INTO public.who_global_data VALUES (47077, 3, 1108, 0, 69, 199, 136);
INSERT INTO public.who_global_data VALUES (47078, 576, 37801, 4, 805, 199, 63);
INSERT INTO public.who_global_data VALUES (47079, 0, 0, 0, 0, 199, 17);
INSERT INTO public.who_global_data VALUES (47080, 1, 38, 0, 2, 199, 172);
INSERT INTO public.who_global_data VALUES (47081, 163, 9412, 0, 432, 199, 109);
INSERT INTO public.who_global_data VALUES (47082, 10, 9038, 0, 255, 199, 200);
INSERT INTO public.who_global_data VALUES (47083, 403, 10923, 1, 67, 199, 93);
INSERT INTO public.who_global_data VALUES (47084, 1487, 69887, 11, 337, 199, 5);
INSERT INTO public.who_global_data VALUES (47085, 0, 741, 0, 13, 199, 214);
INSERT INTO public.who_global_data VALUES (47086, 1332, 267428, 38, 5677, 199, 204);
INSERT INTO public.who_global_data VALUES (47087, 0, 0, 0, 0, 199, 198);
INSERT INTO public.who_global_data VALUES (47088, 958, 54426, 31, 1127, 199, 173);
INSERT INTO public.who_global_data VALUES (47089, 10, 27, 0, 0, 199, 229);
INSERT INTO public.who_global_data VALUES (47090, 27, 3748, 2, 33, 199, 76);
INSERT INTO public.who_global_data VALUES (47091, 4091, 357681, 197, 13384, 199, 138);
INSERT INTO public.who_global_data VALUES (47092, 1866, 70764, 2, 1837, 199, 98);
INSERT INTO public.who_global_data VALUES (47093, 0, 0, 0, 0, 199, 103);
INSERT INTO public.who_global_data VALUES (47094, 399, 40782, 9, 1636, 199, 225);
INSERT INTO public.who_global_data VALUES (47095, 127, 48898, 6, 1697, 199, 131);
INSERT INTO public.who_global_data VALUES (47096, 479, 12940, 0, 180, 199, 235);
INSERT INTO public.who_global_data VALUES (47097, 393, 107430, 1, 160, 199, 137);
INSERT INTO public.who_global_data VALUES (47098, 63, 13879, 1, 297, 199, 81);
INSERT INTO public.who_global_data VALUES (47099, 327, 21442, 11, 708, 199, 182);
INSERT INTO public.who_global_data VALUES (47100, 8, 639, 0, 3, 199, 145);
INSERT INTO public.who_global_data VALUES (47101, 994, 39133, 36, 2074, 199, 26);
INSERT INTO public.who_global_data VALUES (47102, 5862, 789190, 165, 12745, 199, 170);
INSERT INTO public.who_global_data VALUES (47103, 26, 1655, 0, 5, 199, 191);
INSERT INTO public.who_global_data VALUES (47104, 0, 3, 0, 0, 199, 221);
INSERT INTO public.who_global_data VALUES (47105, 0, 6, 0, 0, 199, 64);
INSERT INTO public.who_global_data VALUES (47106, 0, 0, 0, 0, 199, 116);
INSERT INTO public.who_global_data VALUES (47107, 0, 17, 0, 0, 199, 128);
INSERT INTO public.who_global_data VALUES (47108, 0, 23, 0, 0, 199, 6);
INSERT INTO public.who_global_data VALUES (47109, 0, 46, 0, 3, 199, 227);
INSERT INTO public.who_global_data VALUES (47110, 0, 4, 0, 0, 199, 68);
INSERT INTO public.who_global_data VALUES (47111, 0, 50, 0, 0, 199, 184);
INSERT INTO public.who_global_data VALUES (47112, 0, 0, 0, 0, 199, 82);
INSERT INTO public.who_global_data VALUES (47113, 0, 716, 0, 42, 199, 149);
INSERT INTO public.who_global_data VALUES (47114, 0, 746, 0, 14, 199, 197);
INSERT INTO public.who_global_data VALUES (47115, 2476, 255825, 34, 2557, 199, 78);
INSERT INTO public.who_global_data VALUES (47116, 37, 8985, 4, 174, 199, 233);
INSERT INTO public.who_global_data VALUES (47117, 352, 21605, 9, 491, 199, 133);
INSERT INTO public.who_global_data VALUES (47118, 0, 108, 0, 0, 199, 35);
INSERT INTO public.who_global_data VALUES (47119, 16, 1727, 0, 66, 199, 114);
INSERT INTO public.who_global_data VALUES (47120, 398, 48434, 0, 27, 199, 237);
INSERT INTO public.who_global_data VALUES (47121, 0, 2, 0, 0, 199, 55);
INSERT INTO public.who_global_data VALUES (47122, 0, 79, 0, 15, 199, 176);
INSERT INTO public.who_global_data VALUES (47123, 41, 2021, 0, 28, 199, 202);
INSERT INTO public.who_global_data VALUES (47124, 29, 2007, 1, 117, 199, 155);
INSERT INTO public.who_global_data VALUES (47125, 0, 0, 0, 0, 199, 32);
INSERT INTO public.who_global_data VALUES (47126, 5, 3135, 0, 93, 199, 220);
INSERT INTO public.who_global_data VALUES (47127, 8170, 381798, 195, 5368, 199, 30);
INSERT INTO public.who_global_data VALUES (47128, 0, 2211, 0, 45, 199, 147);
INSERT INTO public.who_global_data VALUES (47129, 1726, 278160, 7, 29820, 199, 208);
INSERT INTO public.who_global_data VALUES (47130, 0, 2730, 0, 11, 199, 45);
INSERT INTO public.who_global_data VALUES (47131, 135, 11127, 13, 706, 199, 110);
INSERT INTO public.who_global_data VALUES (47132, 50, 1079, 0, 21, 199, 88);
INSERT INTO public.who_global_data VALUES (47133, 131, 74541, 6, 5723, 199, 51);
INSERT INTO public.who_global_data VALUES (47134, 138, 33908, 1, 1733, 199, 209);
INSERT INTO public.who_global_data VALUES (47135, 18, 540, 2, 31, 199, 205);
INSERT INTO public.who_global_data VALUES (47136, 46, 6967, 0, 57, 199, 18);
INSERT INTO public.who_global_data VALUES (47137, 6, 3261, 0, 58, 199, 72);
INSERT INTO public.who_global_data VALUES (47138, 793, 296912, 25, 41030, 199, 44);
INSERT INTO public.who_global_data VALUES (47139, 0, 24, 0, 0, 199, 15);
INSERT INTO public.who_global_data VALUES (47140, 7, 790, 0, 15, 199, 25);
INSERT INTO public.who_global_data VALUES (47141, 0, 0, 0, 0, 199, 179);
INSERT INTO public.who_global_data VALUES (47142, 0, 0, 0, 0, 199, 34);
INSERT INTO public.who_global_data VALUES (47143, 0, 137, 0, 8, 199, 207);
INSERT INTO public.who_global_data VALUES (47144, 5, 1394, 0, 50, 199, 166);
INSERT INTO public.who_global_data VALUES (47145, 928, 221500, 18, 5526, 199, 126);
INSERT INTO public.who_global_data VALUES (47146, 0, 0, 0, 0, 199, 97);
INSERT INTO public.who_global_data VALUES (47147, 0, 81, 0, 2, 199, 36);
INSERT INTO public.who_global_data VALUES (47148, 0, 0, 0, 0, 199, 125);
INSERT INTO public.who_global_data VALUES (47149, 3, 1072, 0, 0, 199, 124);
INSERT INTO public.who_global_data VALUES (47150, 829, 60995, 16, 1534, 199, 185);
INSERT INTO public.who_global_data VALUES (47151, 305, 57498, 1, 341, 199, 194);
INSERT INTO public.who_global_data VALUES (47152, 0, 509, 0, 21, 199, 144);
INSERT INTO public.who_global_data VALUES (47153, 57276, 3805524, 473, 140437, 199, 19);
INSERT INTO public.who_global_data VALUES (47154, 11, 308, 0, 6, 199, 217);
INSERT INTO public.who_global_data VALUES (47155, 10, 1064, 0, 33, 199, 148);
INSERT INTO public.who_global_data VALUES (47156, 581, 18171, 4, 96, 199, 86);
INSERT INTO public.who_global_data VALUES (47157, 0, 0, 0, 0, 199, 13);
INSERT INTO public.who_global_data VALUES (47158, 443, 12334, 4, 116, 199, 157);
INSERT INTO public.who_global_data VALUES (47159, 17, 401, 0, 0, 199, 8);
INSERT INTO public.who_global_data VALUES (47160, 0, 0, 0, 0, 199, 73);
INSERT INTO public.who_global_data VALUES (47161, 10, 1633, 9, 457, 199, 101);
INSERT INTO public.who_global_data VALUES (47162, 0, 3326, 0, 128, 199, 165);
INSERT INTO public.who_global_data VALUES (47163, 107, 1820, 0, 26, 199, 14);
INSERT INTO public.who_global_data VALUES (47164, 106, 35701, 1, 1188, 200, 193);
INSERT INTO public.who_global_data VALUES (47165, 81, 4171, 1, 113, 200, 113);
INSERT INTO public.who_global_data VALUES (47166, 607, 23691, 9, 1087, 200, 143);
INSERT INTO public.who_global_data VALUES (47167, 0, 0, 0, 0, 200, 219);
INSERT INTO public.who_global_data VALUES (47168, 4, 884, 0, 52, 200, 186);
INSERT INTO public.who_global_data VALUES (47169, 44, 749, 0, 29, 200, 52);
INSERT INTO public.who_global_data VALUES (47170, 0, 3, 0, 0, 200, 180);
INSERT INTO public.who_global_data VALUES (47171, 0, 76, 0, 3, 200, 167);
INSERT INTO public.who_global_data VALUES (47172, 4231, 126755, 35, 2281, 200, 154);
INSERT INTO public.who_global_data VALUES (47173, 273, 34567, 12, 657, 200, 94);
INSERT INTO public.who_global_data VALUES (47174, 5, 113, 0, 3, 200, 66);
INSERT INTO public.who_global_data VALUES (47175, 267, 12069, 1, 123, 200, 58);
INSERT INTO public.who_global_data VALUES (47176, 108, 19679, 0, 710, 200, 163);
INSERT INTO public.who_global_data VALUES (47177, 369, 27890, 9, 363, 200, 37);
INSERT INTO public.who_global_data VALUES (47178, 15, 153, 0, 11, 200, 142);
INSERT INTO public.who_global_data VALUES (47179, 514, 36936, 2, 128, 200, 83);
INSERT INTO public.who_global_data VALUES (47180, 2928, 207453, 50, 2668, 200, 228);
INSERT INTO public.who_global_data VALUES (47181, 0, 105, 0, 7, 200, 188);
INSERT INTO public.who_global_data VALUES (47182, 118, 66213, 4, 503, 200, 62);
INSERT INTO public.who_global_data VALUES (47183, 443, 65026, 2, 9676, 200, 160);
INSERT INTO public.who_global_data VALUES (47184, 0, 40, 0, 2, 200, 50);
INSERT INTO public.who_global_data VALUES (47185, 0, 1602, 0, 31, 200, 33);
INSERT INTO public.who_global_data VALUES (47186, 0, 153, 0, 9, 200, 183);
INSERT INTO public.who_global_data VALUES (47187, 1, 90, 0, 0, 200, 92);
INSERT INTO public.who_global_data VALUES (47188, 1444, 59582, 45, 2151, 200, 158);
INSERT INTO public.who_global_data VALUES (47189, 0, 5, 0, 0, 200, 67);
INSERT INTO public.who_global_data VALUES (47190, 139, 8591, 6, 256, 200, 57);
INSERT INTO public.who_global_data VALUES (47191, 0, 522, 0, 1, 200, 38);
INSERT INTO public.who_global_data VALUES (47192, 23529, 2098389, 716, 79488, 200, 141);
INSERT INTO public.who_global_data VALUES (47193, 0, 8, 0, 1, 200, 178);
INSERT INTO public.who_global_data VALUES (47194, 0, 141, 0, 3, 200, 108);
INSERT INTO public.who_global_data VALUES (47195, 196, 8929, 8, 308, 200, 39);
INSERT INTO public.who_global_data VALUES (47196, 0, 1065, 0, 53, 200, 2);
INSERT INTO public.who_global_data VALUES (47197, 6, 328, 0, 1, 200, 195);
INSERT INTO public.who_global_data VALUES (47198, 28, 2071, 0, 21, 200, 107);
INSERT INTO public.who_global_data VALUES (47199, 0, 171, 0, 0, 200, 161);
INSERT INTO public.who_global_data VALUES (47200, 365, 16522, 9, 382, 200, 212);
INSERT INTO public.who_global_data VALUES (47201, 339, 110338, 4, 8852, 200, 181);
INSERT INTO public.who_global_data VALUES (47202, 0, 203, 0, 1, 200, 53);
INSERT INTO public.who_global_data VALUES (47203, 0, 4485, 0, 55, 200, 164);
INSERT INTO public.who_global_data VALUES (47204, 0, 889, 0, 75, 200, 140);
INSERT INTO public.who_global_data VALUES (47205, 2099, 333029, 130, 8633, 200, 20);
INSERT INTO public.who_global_data VALUES (47206, 84, 86152, 0, 4653, 200, 112);
INSERT INTO public.who_global_data VALUES (47207, 6578, 197278, 220, 6736, 200, 111);
INSERT INTO public.who_global_data VALUES (47208, 0, 334, 0, 7, 200, 71);
INSERT INTO public.who_global_data VALUES (47209, 218, 2851, 1, 50, 200, 218);
INSERT INTO public.who_global_data VALUES (47210, 0, 0, 0, 0, 200, 43);
INSERT INTO public.who_global_data VALUES (47211, 563, 11114, 8, 62, 200, 49);
INSERT INTO public.who_global_data VALUES (47212, 193, 14312, 0, 92, 200, 1);
INSERT INTO public.who_global_data VALUES (47213, 16, 4370, 2, 122, 200, 48);
INSERT INTO public.who_global_data VALUES (47214, 0, 2446, 0, 87, 200, 232);
INSERT INTO public.who_global_data VALUES (47215, 0, 28, 0, 1, 200, 175);
INSERT INTO public.who_global_data VALUES (47216, 0, 1038, 0, 19, 200, 21);
INSERT INTO public.who_global_data VALUES (47217, 153, 14098, 0, 359, 200, 156);
INSERT INTO public.who_global_data VALUES (47218, 0, 0, 0, 0, 200, 95);
INSERT INTO public.who_global_data VALUES (47219, 40, 8442, 0, 193, 200, 177);
INSERT INTO public.who_global_data VALUES (47220, 89, 13262, 0, 611, 200, 210);
INSERT INTO public.who_global_data VALUES (47221, 9, 5020, 0, 56, 200, 120);
INSERT INTO public.who_global_data VALUES (47222, 0, 18, 0, 0, 200, 135);
INSERT INTO public.who_global_data VALUES (47223, 1101, 53956, 12, 993, 200, 206);
INSERT INTO public.who_global_data VALUES (47224, 607, 74620, 5, 5318, 200, 189);
INSERT INTO public.who_global_data VALUES (47225, 627, 88402, 50, 4352, 200, 129);
INSERT INTO public.who_global_data VALUES (47226, 361, 12207, 9, 344, 200, 121);
INSERT INTO public.who_global_data VALUES (47227, 0, 2350, 0, 41, 200, 59);
INSERT INTO public.who_global_data VALUES (47228, 0, 251, 0, 0, 200, 96);
INSERT INTO public.who_global_data VALUES (47229, 0, 2021, 0, 63, 200, 41);
INSERT INTO public.who_global_data VALUES (47230, 33, 1826, 2, 23, 200, 216);
INSERT INTO public.who_global_data VALUES (47231, 304, 10511, 3, 173, 200, 236);
INSERT INTO public.who_global_data VALUES (47232, 0, 13, 0, 0, 200, 150);
INSERT INTO public.who_global_data VALUES (47233, 0, 191, 0, 0, 200, 61);
INSERT INTO public.who_global_data VALUES (47234, 1, 27, 0, 0, 200, 7);
INSERT INTO public.who_global_data VALUES (47235, 2, 7340, 0, 328, 200, 169);
INSERT INTO public.who_global_data VALUES (47236, 1810, 166057, 8, 30054, 200, 28);
INSERT INTO public.who_global_data VALUES (47237, 90, 6745, 1, 38, 200, 85);
INSERT INTO public.who_global_data VALUES (47238, 0, 62, 0, 0, 200, 211);
INSERT INTO public.who_global_data VALUES (47239, 0, 6121, 0, 46, 200, 60);
INSERT INTO public.who_global_data VALUES (47240, 19, 112, 0, 4, 200, 3);
INSERT INTO public.who_global_data VALUES (47241, 10, 1049, 1, 16, 200, 11);
INSERT INTO public.who_global_data VALUES (47242, 522, 202345, 4, 9090, 200, 89);
INSERT INTO public.who_global_data VALUES (47243, 763, 28430, 5, 153, 200, 24);
INSERT INTO public.who_global_data VALUES (47244, 0, 180, 0, 0, 200, 162);
INSERT INTO public.who_global_data VALUES (47245, 5, 4012, 1, 195, 200, 100);
INSERT INTO public.who_global_data VALUES (47246, 0, 13, 0, 0, 200, 47);
INSERT INTO public.who_global_data VALUES (47247, 0, 23, 0, 0, 200, 29);
INSERT INTO public.who_global_data VALUES (47248, 0, 195, 0, 14, 200, 40);
INSERT INTO public.who_global_data VALUES (47249, 0, 311, 0, 5, 200, 222);
INSERT INTO public.who_global_data VALUES (47250, 997, 39039, 53, 1502, 200, 132);
INSERT INTO public.who_global_data VALUES (47251, 0, 252, 0, 13, 200, 130);
INSERT INTO public.who_global_data VALUES (47252, 46, 6590, 1, 40, 200, 234);
INSERT INTO public.who_global_data VALUES (47253, 4, 1954, 0, 26, 200, 23);
INSERT INTO public.who_global_data VALUES (47254, 9, 336, 0, 19, 200, 192);
INSERT INTO public.who_global_data VALUES (47255, 10, 7063, 0, 146, 200, 69);
INSERT INTO public.who_global_data VALUES (47256, 0, 12, 0, 0, 200, 187);
INSERT INTO public.who_global_data VALUES (47257, 1042, 33835, 9, 900, 200, 230);
INSERT INTO public.who_global_data VALUES (47258, 14, 4347, 0, 596, 200, 77);
INSERT INTO public.who_global_data VALUES (47259, 0, 1839, 0, 10, 200, 9);
INSERT INTO public.who_global_data VALUES (47260, 37148, 1155191, 587, 28084, 200, 74);
INSERT INTO public.who_global_data VALUES (47261, 1693, 88214, 96, 4239, 200, 224);
INSERT INTO public.who_global_data VALUES (47262, 2414, 276202, 217, 14405, 200, 199);
INSERT INTO public.who_global_data VALUES (47263, 2163, 94693, 88, 3869, 200, 190);
INSERT INTO public.who_global_data VALUES (47264, 6, 25766, 0, 1753, 200, 12);
INSERT INTO public.who_global_data VALUES (47265, 0, 336, 0, 24, 200, 104);
INSERT INTO public.who_global_data VALUES (47266, 1016, 50557, 10, 436, 200, 153);
INSERT INTO public.who_global_data VALUES (47267, 190, 244624, 13, 35058, 200, 91);
INSERT INTO public.who_global_data VALUES (47268, 16, 790, 0, 10, 200, 215);
INSERT INTO public.who_global_data VALUES (47269, 640, 25736, 3, 988, 200, 84);
INSERT INTO public.who_global_data VALUES (47270, 0, 331, 0, 31, 200, 231);
INSERT INTO public.who_global_data VALUES (47271, 5, 1135, 0, 11, 200, 196);
INSERT INTO public.who_global_data VALUES (47272, 1685, 75153, 0, 585, 200, 105);
INSERT INTO public.who_global_data VALUES (47273, 418, 13771, 4, 238, 200, 122);
INSERT INTO public.who_global_data VALUES (47274, 0, 0, 0, 0, 200, 159);
INSERT INTO public.who_global_data VALUES (47275, 142, 5834, 4, 129, 200, 75);
INSERT INTO public.who_global_data VALUES (47276, 559, 59763, 0, 408, 200, 27);
INSERT INTO public.who_global_data VALUES (47277, 1108, 28251, 42, 634, 200, 54);
INSERT INTO public.who_global_data VALUES (47278, 0, 19, 0, 0, 200, 226);
INSERT INTO public.who_global_data VALUES (47279, 0, 1192, 0, 31, 200, 79);
INSERT INTO public.who_global_data VALUES (47280, 46, 2905, 1, 41, 200, 56);
INSERT INTO public.who_global_data VALUES (47281, 0, 359, 0, 6, 200, 117);
INSERT INTO public.who_global_data VALUES (47282, 16, 1107, 0, 70, 200, 152);
INSERT INTO public.who_global_data VALUES (47283, 114, 1980, 1, 49, 200, 16);
INSERT INTO public.who_global_data VALUES (47284, 0, 87, 0, 1, 200, 10);
INSERT INTO public.who_global_data VALUES (47285, 2, 1944, 0, 80, 200, 201);
INSERT INTO public.who_global_data VALUES (47286, 122, 5605, 0, 111, 200, 174);
INSERT INTO public.who_global_data VALUES (47287, 104, 7153, 3, 62, 200, 119);
INSERT INTO public.who_global_data VALUES (47288, 53, 3045, 2, 64, 200, 168);
INSERT INTO public.who_global_data VALUES (47289, 21, 8800, 0, 123, 200, 99);
INSERT INTO public.who_global_data VALUES (47290, 33, 2999, 0, 15, 200, 171);
INSERT INTO public.who_global_data VALUES (47291, 0, 2475, 0, 121, 200, 87);
INSERT INTO public.who_global_data VALUES (47292, 0, 675, 0, 9, 200, 123);
INSERT INTO public.who_global_data VALUES (47293, 0, 0, 0, 0, 200, 151);
INSERT INTO public.who_global_data VALUES (47294, 0, 262, 0, 15, 200, 213);
INSERT INTO public.who_global_data VALUES (47295, 50, 5923, 0, 155, 200, 118);
INSERT INTO public.who_global_data VALUES (47296, 0, 343, 0, 10, 200, 134);
INSERT INTO public.who_global_data VALUES (47297, 26, 2808, 1, 38, 200, 65);
INSERT INTO public.who_global_data VALUES (47298, 5311, 344224, 296, 39184, 200, 102);
INSERT INTO public.who_global_data VALUES (47299, 0, 0, 0, 0, 200, 223);
INSERT INTO public.who_global_data VALUES (47300, 0, 79, 0, 1, 200, 4);
INSERT INTO public.who_global_data VALUES (47301, 0, 287, 0, 0, 200, 146);
INSERT INTO public.who_global_data VALUES (47302, 91, 2470, 0, 35, 200, 31);
INSERT INTO public.who_global_data VALUES (47303, 0, 12, 0, 1, 200, 127);
INSERT INTO public.who_global_data VALUES (47304, 326, 17562, 3, 276, 200, 22);
INSERT INTO public.who_global_data VALUES (47305, 16, 1507, 1, 11, 200, 115);
INSERT INTO public.who_global_data VALUES (47306, 0, 341, 0, 6, 200, 106);
INSERT INTO public.who_global_data VALUES (47307, 97, 1344, 1, 4, 200, 90);
INSERT INTO public.who_global_data VALUES (47308, 0, 0, 0, 0, 200, 70);
INSERT INTO public.who_global_data VALUES (47309, 186, 17844, 0, 40, 200, 46);
INSERT INTO public.who_global_data VALUES (47310, 183, 51825, 0, 6133, 200, 139);
INSERT INTO public.who_global_data VALUES (47311, 0, 22, 0, 0, 200, 42);
INSERT INTO public.who_global_data VALUES (47312, 1, 1205, 0, 22, 200, 80);
INSERT INTO public.who_global_data VALUES (47313, 0, 2712, 0, 99, 200, 203);
INSERT INTO public.who_global_data VALUES (47314, 1, 1105, 0, 69, 200, 136);
INSERT INTO public.who_global_data VALUES (47315, 562, 37225, 12, 801, 200, 63);
INSERT INTO public.who_global_data VALUES (47316, 0, 0, 0, 0, 200, 17);
INSERT INTO public.who_global_data VALUES (47317, 0, 37, 0, 2, 200, 172);
INSERT INTO public.who_global_data VALUES (47318, 96, 9249, 10, 432, 200, 109);
INSERT INTO public.who_global_data VALUES (47319, 13, 9028, 0, 255, 200, 200);
INSERT INTO public.who_global_data VALUES (47320, 468, 10520, 1, 66, 200, 93);
INSERT INTO public.who_global_data VALUES (47321, 1739, 68400, 8, 326, 200, 5);
INSERT INTO public.who_global_data VALUES (47322, 0, 741, 0, 13, 200, 214);
INSERT INTO public.who_global_data VALUES (47323, 1013, 266096, 40, 5639, 200, 204);
INSERT INTO public.who_global_data VALUES (47324, 0, 0, 0, 0, 200, 198);
INSERT INTO public.who_global_data VALUES (47325, 1207, 53468, 25, 1096, 200, 173);
INSERT INTO public.who_global_data VALUES (47326, 0, 17, 0, 0, 200, 229);
INSERT INTO public.who_global_data VALUES (47327, 92, 3721, 2, 31, 200, 76);
INSERT INTO public.who_global_data VALUES (47328, 4090, 353590, 189, 13187, 200, 138);
INSERT INTO public.who_global_data VALUES (47329, 1442, 68898, 4, 1835, 200, 98);
INSERT INTO public.who_global_data VALUES (47330, 0, 0, 0, 0, 200, 103);
INSERT INTO public.who_global_data VALUES (47331, 279, 40383, 3, 1627, 200, 225);
INSERT INTO public.who_global_data VALUES (47332, 135, 48771, 2, 1691, 200, 131);
INSERT INTO public.who_global_data VALUES (47333, 398, 12461, 2, 180, 200, 235);
INSERT INTO public.who_global_data VALUES (47334, 389, 107037, 2, 159, 200, 137);
INSERT INTO public.who_global_data VALUES (47335, 45, 13816, 0, 296, 200, 81);
INSERT INTO public.who_global_data VALUES (47336, 135, 21115, 9, 697, 200, 182);
INSERT INTO public.who_global_data VALUES (47337, 3, 631, 0, 3, 200, 145);
INSERT INTO public.who_global_data VALUES (47338, 681, 38139, 12, 2038, 200, 26);
INSERT INTO public.who_global_data VALUES (47339, 5842, 783328, 153, 12580, 200, 170);
INSERT INTO public.who_global_data VALUES (47340, 47, 1629, 0, 5, 200, 191);
INSERT INTO public.who_global_data VALUES (47341, 0, 3, 0, 0, 200, 221);
INSERT INTO public.who_global_data VALUES (47342, 0, 6, 0, 0, 200, 64);
INSERT INTO public.who_global_data VALUES (47343, 0, 0, 0, 0, 200, 116);
INSERT INTO public.who_global_data VALUES (47344, 0, 17, 0, 0, 200, 128);
INSERT INTO public.who_global_data VALUES (47345, 0, 23, 0, 0, 200, 6);
INSERT INTO public.who_global_data VALUES (47346, 0, 46, 0, 3, 200, 227);
INSERT INTO public.who_global_data VALUES (47347, 0, 4, 0, 0, 200, 68);
INSERT INTO public.who_global_data VALUES (47348, 12, 50, 0, 0, 200, 184);
INSERT INTO public.who_global_data VALUES (47349, 0, 0, 0, 0, 200, 82);
INSERT INTO public.who_global_data VALUES (47350, 0, 716, 0, 42, 200, 149);
INSERT INTO public.who_global_data VALUES (47351, 0, 746, 0, 14, 200, 197);
INSERT INTO public.who_global_data VALUES (47352, 2429, 253349, 37, 2523, 200, 78);
INSERT INTO public.who_global_data VALUES (47353, 138, 8948, 3, 170, 200, 233);
INSERT INTO public.who_global_data VALUES (47354, 359, 21253, 10, 482, 200, 133);
INSERT INTO public.who_global_data VALUES (47355, 0, 108, 0, 0, 200, 35);
INSERT INTO public.who_global_data VALUES (47356, 0, 1711, 1, 66, 200, 114);
INSERT INTO public.who_global_data VALUES (47357, 123, 48036, 0, 27, 200, 237);
INSERT INTO public.who_global_data VALUES (47358, 0, 2, 0, 0, 200, 55);
INSERT INTO public.who_global_data VALUES (47359, 0, 79, 0, 15, 200, 176);
INSERT INTO public.who_global_data VALUES (47360, 1, 1980, 0, 28, 200, 202);
INSERT INTO public.who_global_data VALUES (47361, 24, 1978, 1, 116, 200, 155);
INSERT INTO public.who_global_data VALUES (47362, 0, 0, 0, 0, 200, 32);
INSERT INTO public.who_global_data VALUES (47363, 11, 3130, 0, 93, 200, 220);
INSERT INTO public.who_global_data VALUES (47364, 9300, 373628, 140, 5173, 200, 30);
INSERT INTO public.who_global_data VALUES (47365, 0, 2211, 0, 45, 200, 147);
INSERT INTO public.who_global_data VALUES (47366, 1235, 276434, 5, 29813, 200, 208);
INSERT INTO public.who_global_data VALUES (47367, 6, 2730, 0, 11, 200, 45);
INSERT INTO public.who_global_data VALUES (47368, 0, 10992, 0, 693, 200, 110);
INSERT INTO public.who_global_data VALUES (47369, 28, 1029, 1, 21, 200, 88);
INSERT INTO public.who_global_data VALUES (47370, 110, 74410, 7, 5717, 200, 51);
INSERT INTO public.who_global_data VALUES (47371, 127, 33770, 2, 1732, 200, 209);
INSERT INTO public.who_global_data VALUES (47372, 26, 522, 4, 29, 200, 205);
INSERT INTO public.who_global_data VALUES (47373, 43, 6921, 0, 57, 200, 18);
INSERT INTO public.who_global_data VALUES (47374, 5, 3255, 0, 58, 200, 72);
INSERT INTO public.who_global_data VALUES (47375, 413, 296119, 10, 41005, 200, 44);
INSERT INTO public.who_global_data VALUES (47376, 0, 24, 0, 0, 200, 15);
INSERT INTO public.who_global_data VALUES (47377, 9, 783, 0, 15, 200, 25);
INSERT INTO public.who_global_data VALUES (47378, 0, 0, 0, 0, 200, 179);
INSERT INTO public.who_global_data VALUES (47379, 0, 0, 0, 0, 200, 34);
INSERT INTO public.who_global_data VALUES (47380, 0, 137, 0, 8, 200, 207);
INSERT INTO public.who_global_data VALUES (47381, 8, 1389, 0, 50, 200, 166);
INSERT INTO public.who_global_data VALUES (47382, 931, 220572, 17, 5508, 200, 126);
INSERT INTO public.who_global_data VALUES (47383, 0, 0, 0, 0, 200, 97);
INSERT INTO public.who_global_data VALUES (47384, 6, 81, 0, 2, 200, 36);
INSERT INTO public.who_global_data VALUES (47385, 0, 0, 0, 0, 200, 125);
INSERT INTO public.who_global_data VALUES (47386, 4, 1069, 0, 0, 200, 124);
INSERT INTO public.who_global_data VALUES (47387, 673, 60166, 20, 1518, 200, 185);
INSERT INTO public.who_global_data VALUES (47388, 271, 57193, 1, 340, 200, 194);
INSERT INTO public.who_global_data VALUES (47389, 0, 509, 0, 21, 200, 144);
INSERT INTO public.who_global_data VALUES (47390, 62788, 3748248, 496, 139964, 200, 19);
INSERT INTO public.who_global_data VALUES (47391, 14, 297, 0, 6, 200, 217);
INSERT INTO public.who_global_data VALUES (47392, 10, 1054, 0, 33, 200, 148);
INSERT INTO public.who_global_data VALUES (47393, 624, 17590, 4, 92, 200, 86);
INSERT INTO public.who_global_data VALUES (47394, 0, 0, 0, 0, 200, 13);
INSERT INTO public.who_global_data VALUES (47395, 408, 11891, 2, 112, 200, 157);
INSERT INTO public.who_global_data VALUES (47396, 1, 384, 0, 0, 200, 8);
INSERT INTO public.who_global_data VALUES (47397, 0, 0, 0, 0, 200, 73);
INSERT INTO public.who_global_data VALUES (47398, 13, 1623, 2, 448, 200, 101);
INSERT INTO public.who_global_data VALUES (47399, 346, 3326, 8, 128, 200, 165);
INSERT INTO public.who_global_data VALUES (47400, 102, 1713, 1, 26, 200, 14);
INSERT INTO public.who_global_data VALUES (47401, 34, 35595, 2, 1187, 201, 193);
INSERT INTO public.who_global_data VALUES (47402, 82, 4090, 1, 112, 201, 113);
INSERT INTO public.who_global_data VALUES (47403, 535, 23084, 10, 1078, 201, 143);
INSERT INTO public.who_global_data VALUES (47404, 0, 0, 0, 0, 201, 219);
INSERT INTO public.who_global_data VALUES (47405, 0, 880, 0, 52, 201, 186);
INSERT INTO public.who_global_data VALUES (47406, 18, 705, 0, 29, 201, 52);
INSERT INTO public.who_global_data VALUES (47407, 0, 3, 0, 0, 201, 180);
INSERT INTO public.who_global_data VALUES (47408, 0, 76, 0, 3, 201, 167);
INSERT INTO public.who_global_data VALUES (47409, 3223, 122524, 42, 2246, 201, 154);
INSERT INTO public.who_global_data VALUES (47410, 104, 34294, 9, 645, 201, 94);
INSERT INTO public.who_global_data VALUES (47411, 0, 108, 0, 3, 201, 66);
INSERT INTO public.who_global_data VALUES (47412, 361, 11802, 4, 122, 201, 58);
INSERT INTO public.who_global_data VALUES (47413, 63, 19571, 0, 710, 201, 163);
INSERT INTO public.who_global_data VALUES (47414, 388, 27521, 5, 354, 201, 37);
INSERT INTO public.who_global_data VALUES (47415, 9, 138, 0, 11, 201, 142);
INSERT INTO public.who_global_data VALUES (47416, 418, 36422, 2, 126, 201, 83);
INSERT INTO public.who_global_data VALUES (47417, 2459, 204525, 37, 2618, 201, 228);
INSERT INTO public.who_global_data VALUES (47418, 1, 105, 0, 7, 201, 188);
INSERT INTO public.who_global_data VALUES (47419, 142, 66095, 4, 499, 201, 62);
INSERT INTO public.who_global_data VALUES (47420, 64, 64583, 1, 9674, 201, 160);
INSERT INTO public.who_global_data VALUES (47421, 0, 40, 0, 2, 201, 50);
INSERT INTO public.who_global_data VALUES (47422, 0, 1602, 0, 31, 201, 33);
INSERT INTO public.who_global_data VALUES (47423, 1, 153, 0, 9, 201, 183);
INSERT INTO public.who_global_data VALUES (47424, 2, 89, 0, 0, 201, 92);
INSERT INTO public.who_global_data VALUES (47425, 2036, 58138, 57, 2106, 201, 158);
INSERT INTO public.who_global_data VALUES (47426, 0, 5, 0, 0, 201, 67);
INSERT INTO public.who_global_data VALUES (47427, 288, 8452, 5, 250, 201, 57);
INSERT INTO public.who_global_data VALUES (47428, 0, 522, 0, 1, 201, 38);
INSERT INTO public.who_global_data VALUES (47429, 28532, 2074860, 921, 78772, 201, 141);
INSERT INTO public.who_global_data VALUES (47430, 0, 8, 0, 1, 201, 178);
INSERT INTO public.who_global_data VALUES (47431, 0, 141, 0, 3, 201, 108);
INSERT INTO public.who_global_data VALUES (47432, 95, 8733, 1, 300, 201, 39);
INSERT INTO public.who_global_data VALUES (47433, 18, 1065, 0, 53, 201, 2);
INSERT INTO public.who_global_data VALUES (47434, 12, 322, 0, 1, 201, 195);
INSERT INTO public.who_global_data VALUES (47435, 29, 2043, 0, 21, 201, 107);
INSERT INTO public.who_global_data VALUES (47436, 0, 171, 0, 0, 201, 161);
INSERT INTO public.who_global_data VALUES (47437, 0, 16157, 0, 373, 201, 212);
INSERT INTO public.who_global_data VALUES (47438, 330, 109999, 9, 8848, 201, 181);
INSERT INTO public.who_global_data VALUES (47439, 0, 203, 0, 1, 201, 53);
INSERT INTO public.who_global_data VALUES (47440, 0, 4485, 0, 55, 201, 164);
INSERT INTO public.who_global_data VALUES (47441, 0, 889, 0, 75, 201, 140);
INSERT INTO public.who_global_data VALUES (47442, 2084, 330930, 58, 8503, 201, 20);
INSERT INTO public.who_global_data VALUES (47443, 131, 86068, 0, 4653, 201, 112);
INSERT INTO public.who_global_data VALUES (47444, 8560, 190700, 228, 6516, 201, 111);
INSERT INTO public.who_global_data VALUES (47445, 6, 334, 0, 7, 201, 71);
INSERT INTO public.who_global_data VALUES (47446, 0, 2633, 0, 49, 201, 218);
INSERT INTO public.who_global_data VALUES (47447, 0, 0, 0, 0, 201, 43);
INSERT INTO public.who_global_data VALUES (47448, 582, 10551, 7, 54, 201, 49);
INSERT INTO public.who_global_data VALUES (47449, 423, 14119, 5, 92, 201, 1);
INSERT INTO public.who_global_data VALUES (47450, 119, 4354, 0, 120, 201, 48);
INSERT INTO public.who_global_data VALUES (47451, 1, 2446, 0, 87, 201, 232);
INSERT INTO public.who_global_data VALUES (47452, 0, 28, 0, 1, 201, 175);
INSERT INTO public.who_global_data VALUES (47453, 1, 1038, 0, 19, 201, 21);
INSERT INTO public.who_global_data VALUES (47454, 90, 13945, 1, 359, 201, 156);
INSERT INTO public.who_global_data VALUES (47455, 0, 0, 0, 0, 201, 95);
INSERT INTO public.who_global_data VALUES (47456, 153, 8402, 1, 193, 201, 177);
INSERT INTO public.who_global_data VALUES (47457, 0, 13173, 0, 611, 201, 210);
INSERT INTO public.who_global_data VALUES (47458, 8, 5011, 0, 56, 201, 120);
INSERT INTO public.who_global_data VALUES (47459, 0, 18, 0, 0, 201, 135);
INSERT INTO public.who_global_data VALUES (47460, 1336, 52855, 10, 981, 201, 206);
INSERT INTO public.who_global_data VALUES (47461, 631, 74013, 31, 5313, 201, 189);
INSERT INTO public.who_global_data VALUES (47462, 603, 87775, 51, 4302, 201, 129);
INSERT INTO public.who_global_data VALUES (47463, 338, 11846, 11, 335, 201, 121);
INSERT INTO public.who_global_data VALUES (47464, 0, 2350, 0, 41, 201, 59);
INSERT INTO public.who_global_data VALUES (47465, 0, 251, 0, 0, 201, 96);
INSERT INTO public.who_global_data VALUES (47466, 0, 2021, 0, 63, 201, 41);
INSERT INTO public.who_global_data VALUES (47467, 64, 1793, 0, 21, 201, 216);
INSERT INTO public.who_global_data VALUES (47468, 704, 10207, 3, 170, 201, 236);
INSERT INTO public.who_global_data VALUES (47469, 0, 13, 0, 0, 201, 150);
INSERT INTO public.who_global_data VALUES (47470, 3, 191, 0, 0, 201, 61);
INSERT INTO public.who_global_data VALUES (47471, 0, 26, 0, 0, 201, 7);
INSERT INTO public.who_global_data VALUES (47472, 20, 7338, 0, 328, 201, 169);
INSERT INTO public.who_global_data VALUES (47473, 0, 164247, 0, 30046, 201, 28);
INSERT INTO public.who_global_data VALUES (47474, 0, 6655, 0, 37, 201, 85);
INSERT INTO public.who_global_data VALUES (47475, 0, 62, 0, 0, 201, 211);
INSERT INTO public.who_global_data VALUES (47476, 0, 6121, 0, 46, 201, 60);
INSERT INTO public.who_global_data VALUES (47477, 0, 93, 0, 4, 201, 3);
INSERT INTO public.who_global_data VALUES (47478, 11, 1039, 0, 15, 201, 11);
INSERT INTO public.who_global_data VALUES (47479, 249, 201823, 2, 9086, 201, 89);
INSERT INTO public.who_global_data VALUES (47480, 607, 27667, 3, 148, 201, 24);
INSERT INTO public.who_global_data VALUES (47481, 0, 180, 0, 0, 201, 162);
INSERT INTO public.who_global_data VALUES (47482, 24, 4007, 0, 194, 201, 100);
INSERT INTO public.who_global_data VALUES (47483, 0, 13, 0, 0, 201, 47);
INSERT INTO public.who_global_data VALUES (47484, 0, 23, 0, 0, 201, 29);
INSERT INTO public.who_global_data VALUES (47485, 0, 195, 0, 14, 201, 40);
INSERT INTO public.who_global_data VALUES (47486, 4, 311, 0, 5, 201, 222);
INSERT INTO public.who_global_data VALUES (47487, 4233, 38042, 6, 1449, 201, 132);
INSERT INTO public.who_global_data VALUES (47488, 0, 252, 0, 13, 201, 130);
INSERT INTO public.who_global_data VALUES (47489, 53, 6544, 0, 39, 201, 234);
INSERT INTO public.who_global_data VALUES (47490, 0, 1950, 0, 26, 201, 23);
INSERT INTO public.who_global_data VALUES (47491, 7, 327, 0, 19, 201, 192);
INSERT INTO public.who_global_data VALUES (47492, 78, 7053, 0, 146, 201, 69);
INSERT INTO public.who_global_data VALUES (47493, 0, 12, 0, 0, 201, 187);
INSERT INTO public.who_global_data VALUES (47494, 1048, 32793, 34, 891, 201, 230);
INSERT INTO public.who_global_data VALUES (47495, 18, 4333, 0, 596, 201, 77);
INSERT INTO public.who_global_data VALUES (47496, 1, 1839, 0, 10, 201, 9);
INSERT INTO public.who_global_data VALUES (47497, 40425, 1118043, 681, 27497, 201, 74);
INSERT INTO public.who_global_data VALUES (47498, 1639, 86521, 127, 4143, 201, 224);
INSERT INTO public.who_global_data VALUES (47499, 2182, 273788, 209, 14188, 201, 199);
INSERT INTO public.who_global_data VALUES (47500, 2310, 92530, 90, 3781, 201, 190);
INSERT INTO public.who_global_data VALUES (47501, 10, 25760, 0, 1753, 201, 12);
INSERT INTO public.who_global_data VALUES (47502, 0, 336, 0, 24, 201, 104);
INSERT INTO public.who_global_data VALUES (47503, 1448, 49541, 8, 426, 201, 153);
INSERT INTO public.who_global_data VALUES (47504, 218, 244434, 3, 35045, 201, 91);
INSERT INTO public.who_global_data VALUES (47505, 6, 774, 0, 10, 201, 215);
INSERT INTO public.who_global_data VALUES (47506, 454, 25096, 0, 985, 201, 84);
INSERT INTO public.who_global_data VALUES (47507, 0, 331, 0, 31, 201, 231);
INSERT INTO public.who_global_data VALUES (47508, 4, 1130, 0, 11, 201, 196);
INSERT INTO public.who_global_data VALUES (47509, 1630, 73468, 0, 585, 201, 105);
INSERT INTO public.who_global_data VALUES (47510, 603, 13353, 9, 234, 201, 122);
INSERT INTO public.who_global_data VALUES (47511, 0, 0, 0, 0, 201, 159);
INSERT INTO public.who_global_data VALUES (47512, 118, 5692, 5, 125, 201, 75);
INSERT INTO public.who_global_data VALUES (47513, 300, 59204, 1, 408, 201, 27);
INSERT INTO public.who_global_data VALUES (47514, 611, 27143, 34, 592, 201, 54);
INSERT INTO public.who_global_data VALUES (47515, 0, 19, 0, 0, 201, 226);
INSERT INTO public.who_global_data VALUES (47516, 3, 1192, 0, 31, 201, 79);
INSERT INTO public.who_global_data VALUES (47517, 84, 2859, 0, 40, 201, 56);
INSERT INTO public.who_global_data VALUES (47518, 0, 359, 0, 6, 201, 117);
INSERT INTO public.who_global_data VALUES (47519, 3, 1091, 0, 70, 201, 152);
INSERT INTO public.who_global_data VALUES (47520, 75, 1866, 0, 48, 201, 16);
INSERT INTO public.who_global_data VALUES (47521, 0, 87, 0, 1, 201, 10);
INSERT INTO public.who_global_data VALUES (47522, 14, 1942, 0, 80, 201, 201);
INSERT INTO public.who_global_data VALUES (47523, 74, 5483, 0, 111, 201, 174);
INSERT INTO public.who_global_data VALUES (47524, 200, 7049, 4, 59, 201, 119);
INSERT INTO public.who_global_data VALUES (47525, 85, 2992, 3, 62, 201, 168);
INSERT INTO public.who_global_data VALUES (47526, 15, 8779, 1, 123, 201, 99);
INSERT INTO public.who_global_data VALUES (47527, 36, 2966, 0, 15, 201, 171);
INSERT INTO public.who_global_data VALUES (47528, 3, 2475, 0, 121, 201, 87);
INSERT INTO public.who_global_data VALUES (47529, 1, 675, 0, 9, 201, 123);
INSERT INTO public.who_global_data VALUES (47530, 0, 0, 0, 0, 201, 151);
INSERT INTO public.who_global_data VALUES (47531, 0, 262, 0, 15, 201, 213);
INSERT INTO public.who_global_data VALUES (47532, 163, 5873, 4, 155, 201, 118);
INSERT INTO public.who_global_data VALUES (47533, 0, 343, 0, 10, 201, 134);
INSERT INTO public.who_global_data VALUES (47534, 0, 2782, 0, 37, 201, 65);
INSERT INTO public.who_global_data VALUES (47535, 7615, 338913, 578, 38888, 201, 102);
INSERT INTO public.who_global_data VALUES (47536, 0, 0, 0, 0, 201, 223);
INSERT INTO public.who_global_data VALUES (47537, 0, 79, 0, 1, 201, 4);
INSERT INTO public.who_global_data VALUES (47538, 0, 287, 0, 0, 201, 146);
INSERT INTO public.who_global_data VALUES (47539, 111, 2379, 2, 35, 201, 31);
INSERT INTO public.who_global_data VALUES (47540, 0, 12, 0, 1, 201, 127);
INSERT INTO public.who_global_data VALUES (47541, 221, 17236, 4, 273, 201, 22);
INSERT INTO public.who_global_data VALUES (47542, 56, 1491, 0, 10, 201, 115);
INSERT INTO public.who_global_data VALUES (47543, 0, 341, 0, 6, 201, 106);
INSERT INTO public.who_global_data VALUES (47544, 44, 1247, 1, 3, 201, 90);
INSERT INTO public.who_global_data VALUES (47545, 0, 0, 0, 0, 201, 70);
INSERT INTO public.who_global_data VALUES (47546, 156, 17658, 0, 40, 201, 46);
INSERT INTO public.who_global_data VALUES (47547, 145, 51642, 0, 6133, 201, 139);
INSERT INTO public.who_global_data VALUES (47548, 0, 22, 0, 0, 201, 42);
INSERT INTO public.who_global_data VALUES (47549, 1, 1204, 0, 22, 201, 80);
INSERT INTO public.who_global_data VALUES (47550, 0, 2712, 0, 99, 201, 203);
INSERT INTO public.who_global_data VALUES (47551, 0, 1104, 0, 69, 201, 136);
INSERT INTO public.who_global_data VALUES (47552, 556, 36663, 11, 789, 201, 63);
INSERT INTO public.who_global_data VALUES (47553, 0, 0, 0, 0, 201, 17);
INSERT INTO public.who_global_data VALUES (47554, 0, 37, 0, 2, 201, 172);
INSERT INTO public.who_global_data VALUES (47555, 127, 9153, 8, 422, 201, 109);
INSERT INTO public.who_global_data VALUES (47556, 0, 9015, 0, 255, 201, 200);
INSERT INTO public.who_global_data VALUES (47557, 465, 10052, 3, 65, 201, 93);
INSERT INTO public.who_global_data VALUES (47558, 1157, 66661, 10, 318, 201, 5);
INSERT INTO public.who_global_data VALUES (47559, 0, 741, 0, 13, 201, 214);
INSERT INTO public.who_global_data VALUES (47560, 1587, 265083, 31, 5599, 201, 204);
INSERT INTO public.who_global_data VALUES (47561, 0, 0, 0, 0, 201, 198);
INSERT INTO public.who_global_data VALUES (47562, 853, 52261, 33, 1071, 201, 173);
INSERT INTO public.who_global_data VALUES (47563, 2, 17, 0, 0, 201, 229);
INSERT INTO public.who_global_data VALUES (47564, 172, 3629, 1, 29, 201, 76);
INSERT INTO public.who_global_data VALUES (47565, 3963, 349500, 199, 12998, 201, 138);
INSERT INTO public.who_global_data VALUES (47566, 2152, 67456, 58, 1831, 201, 98);
INSERT INTO public.who_global_data VALUES (47567, 0, 0, 0, 0, 201, 103);
INSERT INTO public.who_global_data VALUES (47568, 358, 40104, 6, 1624, 201, 225);
INSERT INTO public.who_global_data VALUES (47569, 246, 48636, 5, 1689, 201, 131);
INSERT INTO public.who_global_data VALUES (47570, 610, 12063, 0, 178, 201, 235);
INSERT INTO public.who_global_data VALUES (47571, 340, 106648, 3, 157, 201, 137);
INSERT INTO public.who_global_data VALUES (47572, 26, 13771, 1, 296, 201, 81);
INSERT INTO public.who_global_data VALUES (47573, 186, 20980, 8, 688, 201, 182);
INSERT INTO public.who_global_data VALUES (47574, 4, 628, 0, 3, 201, 145);
INSERT INTO public.who_global_data VALUES (47575, 767, 37458, 17, 2026, 201, 26);
INSERT INTO public.who_global_data VALUES (47576, 5940, 777486, 85, 12427, 201, 170);
INSERT INTO public.who_global_data VALUES (47577, 43, 1582, 0, 5, 201, 191);
INSERT INTO public.who_global_data VALUES (47578, 0, 3, 0, 0, 201, 221);
INSERT INTO public.who_global_data VALUES (47579, 0, 6, 0, 0, 201, 64);
INSERT INTO public.who_global_data VALUES (47580, 0, 0, 0, 0, 201, 116);
INSERT INTO public.who_global_data VALUES (47581, 0, 17, 0, 0, 201, 128);
INSERT INTO public.who_global_data VALUES (47582, 0, 23, 0, 0, 201, 6);
INSERT INTO public.who_global_data VALUES (47583, 0, 46, 0, 3, 201, 227);
INSERT INTO public.who_global_data VALUES (47584, 0, 4, 0, 0, 201, 68);
INSERT INTO public.who_global_data VALUES (47585, 3, 38, 0, 0, 201, 184);
INSERT INTO public.who_global_data VALUES (47586, 0, 0, 0, 0, 201, 82);
INSERT INTO public.who_global_data VALUES (47587, 0, 716, 0, 42, 201, 149);
INSERT INTO public.who_global_data VALUES (47588, 3, 746, 0, 14, 201, 197);
INSERT INTO public.who_global_data VALUES (47589, 2504, 250920, 39, 2486, 201, 78);
INSERT INTO public.who_global_data VALUES (47590, 141, 8810, 4, 167, 201, 233);
INSERT INTO public.who_global_data VALUES (47591, 396, 20894, 11, 472, 201, 133);
INSERT INTO public.who_global_data VALUES (47592, 0, 108, 0, 0, 201, 35);
INSERT INTO public.who_global_data VALUES (47593, 10, 1711, 0, 65, 201, 114);
INSERT INTO public.who_global_data VALUES (47594, 257, 47913, 0, 27, 201, 237);
INSERT INTO public.who_global_data VALUES (47595, 0, 2, 0, 0, 201, 55);
INSERT INTO public.who_global_data VALUES (47596, 0, 79, 0, 15, 201, 176);
INSERT INTO public.who_global_data VALUES (47597, 3, 1979, 0, 28, 201, 202);
INSERT INTO public.who_global_data VALUES (47598, 7, 1954, 1, 115, 201, 155);
INSERT INTO public.who_global_data VALUES (47599, 0, 0, 0, 0, 201, 32);
INSERT INTO public.who_global_data VALUES (47600, 8, 3119, 0, 93, 201, 220);
INSERT INTO public.who_global_data VALUES (47601, 13449, 364328, 85, 5033, 201, 30);
INSERT INTO public.who_global_data VALUES (47602, 11, 2211, 2, 45, 201, 147);
INSERT INTO public.who_global_data VALUES (47603, 1609, 275199, 3, 29808, 201, 208);
INSERT INTO public.who_global_data VALUES (47604, 16, 2724, 0, 11, 201, 45);
INSERT INTO public.who_global_data VALUES (47605, 230, 10992, 13, 693, 201, 110);
INSERT INTO public.who_global_data VALUES (47606, 58, 1001, 1, 20, 201, 88);
INSERT INTO public.who_global_data VALUES (47607, 191, 74300, 11, 5710, 201, 51);
INSERT INTO public.who_global_data VALUES (47608, 42, 33643, 0, 1730, 201, 209);
INSERT INTO public.who_global_data VALUES (47609, 0, 496, 0, 25, 201, 205);
INSERT INTO public.who_global_data VALUES (47610, 44, 6878, 0, 57, 201, 18);
INSERT INTO public.who_global_data VALUES (47611, 1, 3250, 0, 58, 201, 72);
INSERT INTO public.who_global_data VALUES (47612, 493, 295706, 11, 40995, 201, 44);
INSERT INTO public.who_global_data VALUES (47613, 0, 24, 0, 0, 201, 15);
INSERT INTO public.who_global_data VALUES (47614, 0, 774, 0, 15, 201, 25);
INSERT INTO public.who_global_data VALUES (47615, 0, 0, 0, 0, 201, 179);
INSERT INTO public.who_global_data VALUES (47616, 0, 0, 0, 0, 201, 34);
INSERT INTO public.who_global_data VALUES (47617, 1, 137, 0, 8, 201, 207);
INSERT INTO public.who_global_data VALUES (47618, 7, 1381, 0, 50, 201, 166);
INSERT INTO public.who_global_data VALUES (47619, 924, 219641, 16, 5491, 201, 126);
INSERT INTO public.who_global_data VALUES (47620, 0, 0, 0, 0, 201, 97);
INSERT INTO public.who_global_data VALUES (47621, 0, 75, 0, 2, 201, 36);
INSERT INTO public.who_global_data VALUES (47622, 0, 0, 0, 0, 201, 125);
INSERT INTO public.who_global_data VALUES (47623, 3, 1065, 0, 0, 201, 124);
INSERT INTO public.who_global_data VALUES (47624, 651, 59493, 13, 1498, 201, 185);
INSERT INTO public.who_global_data VALUES (47625, 211, 56922, 1, 339, 201, 194);
INSERT INTO public.who_global_data VALUES (47626, 0, 509, 0, 21, 201, 144);
INSERT INTO public.who_global_data VALUES (47627, 66963, 3685460, 877, 139468, 201, 19);
INSERT INTO public.who_global_data VALUES (47628, 0, 283, 0, 6, 201, 217);
INSERT INTO public.who_global_data VALUES (47629, 7, 1044, 1, 33, 201, 148);
INSERT INTO public.who_global_data VALUES (47630, 537, 16966, 4, 88, 201, 86);
INSERT INTO public.who_global_data VALUES (47631, 0, 0, 0, 0, 201, 13);
INSERT INTO public.who_global_data VALUES (47632, 292, 11483, 3, 110, 201, 157);
INSERT INTO public.who_global_data VALUES (47633, 1, 383, 0, 0, 201, 8);
INSERT INTO public.who_global_data VALUES (47634, 0, 0, 0, 0, 201, 73);
INSERT INTO public.who_global_data VALUES (47635, 25, 1610, 2, 446, 201, 101);
INSERT INTO public.who_global_data VALUES (47636, 0, 2980, 0, 120, 201, 165);
INSERT INTO public.who_global_data VALUES (47637, 133, 1611, 0, 25, 201, 14);
INSERT INTO public.who_global_data VALUES (47638, 186, 35561, 34, 1185, 202, 193);
INSERT INTO public.who_global_data VALUES (47639, 102, 4008, 4, 111, 202, 113);
INSERT INTO public.who_global_data VALUES (47640, 601, 22549, 11, 1068, 202, 143);
INSERT INTO public.who_global_data VALUES (47641, 0, 0, 0, 0, 202, 219);
INSERT INTO public.who_global_data VALUES (47642, 0, 880, 0, 52, 202, 186);
INSERT INTO public.who_global_data VALUES (47643, 49, 687, 0, 29, 202, 52);
INSERT INTO public.who_global_data VALUES (47644, 0, 3, 0, 0, 202, 180);
INSERT INTO public.who_global_data VALUES (47645, 2, 76, 0, 3, 202, 167);
INSERT INTO public.who_global_data VALUES (47646, 4518, 119301, 71, 2204, 202, 154);
INSERT INTO public.who_global_data VALUES (47647, 415, 34190, 10, 636, 202, 94);
INSERT INTO public.who_global_data VALUES (47648, 0, 108, 0, 3, 202, 66);
INSERT INTO public.who_global_data VALUES (47649, 206, 11441, 2, 118, 202, 58);
INSERT INTO public.who_global_data VALUES (47650, 102, 19508, 0, 710, 202, 163);
INSERT INTO public.who_global_data VALUES (47651, 497, 27133, 8, 349, 202, 37);
INSERT INTO public.who_global_data VALUES (47652, 5, 129, 0, 11, 202, 142);
INSERT INTO public.who_global_data VALUES (47653, 531, 36004, 0, 124, 202, 83);
INSERT INTO public.who_global_data VALUES (47654, 2709, 202066, 34, 2581, 202, 228);
INSERT INTO public.who_global_data VALUES (47655, 0, 104, 0, 7, 202, 188);
INSERT INTO public.who_global_data VALUES (47656, 171, 65953, 4, 495, 202, 62);
INSERT INTO public.who_global_data VALUES (47657, 130, 64519, 3, 9673, 202, 160);
INSERT INTO public.who_global_data VALUES (47658, 0, 40, 0, 2, 202, 50);
INSERT INTO public.who_global_data VALUES (47659, 0, 1602, 0, 31, 202, 33);
INSERT INTO public.who_global_data VALUES (47660, 0, 152, 0, 9, 202, 183);
INSERT INTO public.who_global_data VALUES (47661, 0, 87, 0, 0, 202, 92);
INSERT INTO public.who_global_data VALUES (47662, 1946, 56102, 65, 2049, 202, 158);
INSERT INTO public.who_global_data VALUES (47663, 0, 5, 0, 0, 202, 67);
INSERT INTO public.who_global_data VALUES (47664, 256, 8164, 2, 245, 202, 57);
INSERT INTO public.who_global_data VALUES (47665, 0, 522, 0, 1, 202, 38);
INSERT INTO public.who_global_data VALUES (47666, 34177, 2046328, 1163, 77851, 202, 141);
INSERT INTO public.who_global_data VALUES (47667, 0, 8, 0, 1, 202, 178);
INSERT INTO public.who_global_data VALUES (47668, 0, 141, 0, 3, 202, 108);
INSERT INTO public.who_global_data VALUES (47669, 196, 8638, 2, 299, 202, 39);
INSERT INTO public.who_global_data VALUES (47670, 2, 1047, 0, 53, 202, 2);
INSERT INTO public.who_global_data VALUES (47671, 0, 310, 0, 1, 202, 195);
INSERT INTO public.who_global_data VALUES (47672, 75, 2014, 1, 21, 202, 107);
INSERT INTO public.who_global_data VALUES (47673, 0, 171, 0, 0, 202, 161);
INSERT INTO public.who_global_data VALUES (47674, 0, 16157, 0, 373, 202, 212);
INSERT INTO public.who_global_data VALUES (47675, 405, 109669, 12, 8839, 202, 181);
INSERT INTO public.who_global_data VALUES (47676, 0, 203, 0, 1, 202, 53);
INSERT INTO public.who_global_data VALUES (47677, 96, 4485, 2, 55, 202, 164);
INSERT INTO public.who_global_data VALUES (47678, 2, 889, 0, 75, 202, 140);
INSERT INTO public.who_global_data VALUES (47679, 2307, 328846, 98, 8445, 202, 20);
INSERT INTO public.who_global_data VALUES (47680, 80, 85937, 1, 4653, 202, 112);
INSERT INTO public.who_global_data VALUES (47681, 8934, 182140, 259, 6288, 202, 111);
INSERT INTO public.who_global_data VALUES (47682, 0, 328, 0, 7, 202, 71);
INSERT INTO public.who_global_data VALUES (47683, 0, 2633, 0, 49, 202, 218);
INSERT INTO public.who_global_data VALUES (47684, 0, 0, 0, 0, 202, 43);
INSERT INTO public.who_global_data VALUES (47685, 423, 9969, 5, 47, 202, 49);
INSERT INTO public.who_global_data VALUES (47686, 0, 13696, 0, 87, 202, 1);
INSERT INTO public.who_global_data VALUES (47687, 98, 4235, 0, 120, 202, 48);
INSERT INTO public.who_global_data VALUES (47688, 1, 2445, 0, 87, 202, 232);
INSERT INTO public.who_global_data VALUES (47689, 0, 28, 0, 1, 202, 175);
INSERT INTO public.who_global_data VALUES (47690, 6, 1037, 0, 19, 202, 21);
INSERT INTO public.who_global_data VALUES (47691, 113, 13855, 0, 358, 202, 156);
INSERT INTO public.who_global_data VALUES (47692, 0, 0, 0, 0, 202, 95);
INSERT INTO public.who_global_data VALUES (47693, 1, 8249, 0, 192, 202, 177);
INSERT INTO public.who_global_data VALUES (47694, 0, 13173, 0, 611, 202, 210);
INSERT INTO public.who_global_data VALUES (47695, 0, 5003, 0, 56, 202, 120);
INSERT INTO public.who_global_data VALUES (47696, 0, 18, 0, 0, 202, 135);
INSERT INTO public.who_global_data VALUES (47697, 1406, 51519, 29, 971, 202, 206);
INSERT INTO public.who_global_data VALUES (47698, 938, 73382, 32, 5282, 202, 189);
INSERT INTO public.who_global_data VALUES (47699, 698, 87172, 63, 4251, 202, 129);
INSERT INTO public.who_global_data VALUES (47700, 301, 11508, 15, 324, 202, 121);
INSERT INTO public.who_global_data VALUES (47701, 0, 2350, 0, 41, 202, 59);
INSERT INTO public.who_global_data VALUES (47702, 0, 251, 0, 0, 202, 96);
INSERT INTO public.who_global_data VALUES (47703, 1, 2021, 0, 63, 202, 41);
INSERT INTO public.who_global_data VALUES (47704, 110, 1729, 0, 21, 202, 216);
INSERT INTO public.who_global_data VALUES (47705, 356, 9503, 4, 167, 202, 236);
INSERT INTO public.who_global_data VALUES (47706, 0, 13, 0, 0, 202, 150);
INSERT INTO public.who_global_data VALUES (47707, 0, 188, 0, 0, 202, 61);
INSERT INTO public.who_global_data VALUES (47708, 0, 26, 0, 0, 202, 7);
INSERT INTO public.who_global_data VALUES (47709, 17, 7318, 0, 328, 202, 169);
INSERT INTO public.who_global_data VALUES (47710, 0, 164247, 0, 30046, 202, 28);
INSERT INTO public.who_global_data VALUES (47711, 146, 6655, 3, 37, 202, 85);
INSERT INTO public.who_global_data VALUES (47712, 0, 62, 0, 0, 202, 211);
INSERT INTO public.who_global_data VALUES (47713, 0, 6121, 0, 46, 202, 60);
INSERT INTO public.who_global_data VALUES (47714, 0, 93, 0, 4, 202, 3);
INSERT INTO public.who_global_data VALUES (47715, 10, 1028, 0, 15, 202, 11);
INSERT INTO public.who_global_data VALUES (47716, 202, 201574, 1, 9084, 202, 89);
INSERT INTO public.who_global_data VALUES (47717, 488, 27060, 1, 145, 202, 24);
INSERT INTO public.who_global_data VALUES (47718, 0, 180, 0, 0, 202, 162);
INSERT INTO public.who_global_data VALUES (47719, 19, 3983, 0, 194, 202, 100);
INSERT INTO public.who_global_data VALUES (47720, 0, 13, 0, 0, 202, 47);
INSERT INTO public.who_global_data VALUES (47721, 0, 23, 0, 0, 202, 29);
INSERT INTO public.who_global_data VALUES (47722, 0, 195, 0, 14, 202, 40);
INSERT INTO public.who_global_data VALUES (47723, 1, 307, 0, 5, 202, 222);
INSERT INTO public.who_global_data VALUES (47724, 870, 33809, 39, 1443, 202, 132);
INSERT INTO public.who_global_data VALUES (47725, 0, 252, 0, 13, 202, 130);
INSERT INTO public.who_global_data VALUES (47726, 61, 6491, 0, 39, 202, 234);
INSERT INTO public.who_global_data VALUES (47727, 0, 1950, 0, 26, 202, 23);
INSERT INTO public.who_global_data VALUES (47728, 5, 320, 0, 19, 202, 192);
INSERT INTO public.who_global_data VALUES (47729, 27, 6975, 1, 146, 202, 69);
INSERT INTO public.who_global_data VALUES (47730, 0, 12, 0, 0, 202, 187);
INSERT INTO public.who_global_data VALUES (47731, 878, 31745, 22, 857, 202, 230);
INSERT INTO public.who_global_data VALUES (47732, 22, 4315, 1, 596, 202, 77);
INSERT INTO public.who_global_data VALUES (47733, 2, 1838, 0, 10, 202, 9);
INSERT INTO public.who_global_data VALUES (47734, 38902, 1077618, 543, 26816, 202, 74);
INSERT INTO public.who_global_data VALUES (47735, 1752, 84882, 59, 4016, 202, 224);
INSERT INTO public.who_global_data VALUES (47736, 2166, 271606, 188, 13979, 202, 199);
INSERT INTO public.who_global_data VALUES (47737, 2049, 90220, 75, 3691, 202, 190);
INSERT INTO public.who_global_data VALUES (47738, 20, 25750, 1, 1753, 202, 12);
INSERT INTO public.who_global_data VALUES (47739, 0, 336, 0, 24, 202, 104);
INSERT INTO public.who_global_data VALUES (47740, 1605, 48093, 12, 418, 202, 153);
INSERT INTO public.who_global_data VALUES (47741, 249, 244216, 14, 35042, 202, 91);
INSERT INTO public.who_global_data VALUES (47742, 3, 768, 0, 10, 202, 215);
INSERT INTO public.who_global_data VALUES (47743, 510, 24642, 0, 985, 202, 84);
INSERT INTO public.who_global_data VALUES (47744, 0, 331, 0, 31, 202, 231);
INSERT INTO public.who_global_data VALUES (47745, 5, 1126, 1, 11, 202, 196);
INSERT INTO public.who_global_data VALUES (47746, 1499, 71838, 210, 585, 202, 105);
INSERT INTO public.who_global_data VALUES (47747, 688, 12750, 3, 225, 202, 122);
INSERT INTO public.who_global_data VALUES (47748, 0, 0, 0, 0, 202, 159);
INSERT INTO public.who_global_data VALUES (47749, 164, 5574, 6, 120, 202, 75);
INSERT INTO public.who_global_data VALUES (47750, 683, 58904, 3, 407, 202, 27);
INSERT INTO public.who_global_data VALUES (47751, 1548, 26532, 80, 558, 202, 54);
INSERT INTO public.who_global_data VALUES (47752, 0, 19, 0, 0, 202, 226);
INSERT INTO public.who_global_data VALUES (47753, 4, 1189, 0, 31, 202, 79);
INSERT INTO public.who_global_data VALUES (47754, 75, 2775, 0, 40, 202, 56);
INSERT INTO public.who_global_data VALUES (47755, 0, 359, 0, 6, 202, 117);
INSERT INTO public.who_global_data VALUES (47756, 18, 1088, 2, 70, 202, 152);
INSERT INTO public.who_global_data VALUES (47757, 87, 1791, 1, 48, 202, 16);
INSERT INTO public.who_global_data VALUES (47758, 0, 87, 0, 1, 202, 10);
INSERT INTO public.who_global_data VALUES (47759, 18, 1928, 0, 80, 202, 201);
INSERT INTO public.who_global_data VALUES (47760, 124, 5409, 0, 111, 202, 174);
INSERT INTO public.who_global_data VALUES (47761, 382, 6849, 1, 55, 202, 119);
INSERT INTO public.who_global_data VALUES (47762, 97, 2907, 4, 59, 202, 168);
INSERT INTO public.who_global_data VALUES (47763, 9, 8764, 0, 122, 202, 99);
INSERT INTO public.who_global_data VALUES (47764, 17, 2930, 0, 15, 202, 171);
INSERT INTO public.who_global_data VALUES (47765, 5, 2472, 0, 121, 202, 87);
INSERT INTO public.who_global_data VALUES (47766, 0, 674, 0, 9, 202, 123);
INSERT INTO public.who_global_data VALUES (47767, 0, 0, 0, 0, 202, 151);
INSERT INTO public.who_global_data VALUES (47768, 1, 262, 0, 15, 202, 213);
INSERT INTO public.who_global_data VALUES (47769, 51, 5710, 1, 151, 202, 118);
INSERT INTO public.who_global_data VALUES (47770, 0, 343, 0, 10, 202, 134);
INSERT INTO public.who_global_data VALUES (47771, 0, 2782, 0, 37, 202, 65);
INSERT INTO public.who_global_data VALUES (47772, 7257, 331298, 736, 38310, 202, 102);
INSERT INTO public.who_global_data VALUES (47773, 0, 0, 0, 0, 202, 223);
INSERT INTO public.who_global_data VALUES (47774, 0, 79, 0, 1, 202, 4);
INSERT INTO public.who_global_data VALUES (47775, 25, 287, 0, 0, 202, 146);
INSERT INTO public.who_global_data VALUES (47776, 134, 2268, 2, 33, 202, 31);
INSERT INTO public.who_global_data VALUES (47777, 0, 12, 0, 1, 202, 127);
INSERT INTO public.who_global_data VALUES (47778, 289, 17015, 5, 269, 202, 22);
INSERT INTO public.who_global_data VALUES (47779, 33, 1435, 1, 10, 202, 115);
INSERT INTO public.who_global_data VALUES (47780, 2, 341, 0, 6, 202, 106);
INSERT INTO public.who_global_data VALUES (47781, 125, 1203, 0, 2, 202, 90);
INSERT INTO public.who_global_data VALUES (47782, 0, 0, 0, 0, 202, 70);
INSERT INTO public.who_global_data VALUES (47783, 57, 17502, 0, 40, 202, 46);
INSERT INTO public.who_global_data VALUES (47784, 145, 51497, 1, 6133, 202, 139);
INSERT INTO public.who_global_data VALUES (47785, 0, 22, 0, 0, 202, 42);
INSERT INTO public.who_global_data VALUES (47786, 3, 1203, 0, 22, 202, 80);
INSERT INTO public.who_global_data VALUES (47787, 0, 2712, 0, 99, 202, 203);
INSERT INTO public.who_global_data VALUES (47788, 2, 1104, 0, 69, 202, 136);
INSERT INTO public.who_global_data VALUES (47789, 653, 36107, 6, 778, 202, 63);
INSERT INTO public.who_global_data VALUES (47790, 0, 0, 0, 0, 202, 17);
INSERT INTO public.who_global_data VALUES (47791, 0, 37, 0, 2, 202, 172);
INSERT INTO public.who_global_data VALUES (47792, 240, 9026, 8, 414, 202, 109);
INSERT INTO public.who_global_data VALUES (47793, 0, 9015, 0, 255, 202, 200);
INSERT INTO public.who_global_data VALUES (47794, 532, 9587, 5, 62, 202, 93);
INSERT INTO public.who_global_data VALUES (47795, 1311, 65504, 10, 308, 202, 5);
INSERT INTO public.who_global_data VALUES (47796, 0, 741, 0, 13, 202, 214);
INSERT INTO public.who_global_data VALUES (47797, 1579, 263496, 46, 5568, 202, 204);
INSERT INTO public.who_global_data VALUES (47798, 0, 0, 0, 0, 202, 198);
INSERT INTO public.who_global_data VALUES (47799, 1035, 51408, 38, 1038, 202, 173);
INSERT INTO public.who_global_data VALUES (47800, 0, 15, 0, 0, 202, 229);
INSERT INTO public.who_global_data VALUES (47801, 115, 3457, 1, 28, 202, 76);
INSERT INTO public.who_global_data VALUES (47802, 3951, 345537, 184, 12799, 202, 138);
INSERT INTO public.who_global_data VALUES (47803, 2303, 65304, 113, 1773, 202, 98);
INSERT INTO public.who_global_data VALUES (47804, 0, 0, 0, 0, 202, 103);
INSERT INTO public.who_global_data VALUES (47805, 339, 39746, 6, 1618, 202, 225);
INSERT INTO public.who_global_data VALUES (47806, 313, 48390, 2, 1684, 202, 131);
INSERT INTO public.who_global_data VALUES (47807, 333, 11453, 1, 178, 202, 235);
INSERT INTO public.who_global_data VALUES (47808, 410, 106308, 1, 154, 202, 137);
INSERT INTO public.who_global_data VALUES (47809, 34, 13745, 1, 295, 202, 81);
INSERT INTO public.who_global_data VALUES (47810, 300, 20794, 5, 680, 202, 182);
INSERT INTO public.who_global_data VALUES (47811, 0, 624, 0, 3, 202, 145);
INSERT INTO public.who_global_data VALUES (47812, 889, 36691, 21, 2009, 202, 26);
INSERT INTO public.who_global_data VALUES (47813, 6109, 771546, 95, 12342, 202, 170);
INSERT INTO public.who_global_data VALUES (47814, 54, 1539, 1, 5, 202, 191);
INSERT INTO public.who_global_data VALUES (47815, 0, 3, 0, 0, 202, 221);
INSERT INTO public.who_global_data VALUES (47816, 0, 6, 0, 0, 202, 64);
INSERT INTO public.who_global_data VALUES (47817, 0, 0, 0, 0, 202, 116);
INSERT INTO public.who_global_data VALUES (47818, 0, 17, 0, 0, 202, 128);
INSERT INTO public.who_global_data VALUES (47819, 0, 23, 0, 0, 202, 6);
INSERT INTO public.who_global_data VALUES (47820, 0, 46, 0, 3, 202, 227);
INSERT INTO public.who_global_data VALUES (47821, 0, 4, 0, 0, 202, 68);
INSERT INTO public.who_global_data VALUES (47822, 0, 35, 0, 0, 202, 184);
INSERT INTO public.who_global_data VALUES (47823, 0, 0, 0, 0, 202, 82);
INSERT INTO public.who_global_data VALUES (47824, 0, 716, 0, 42, 202, 149);
INSERT INTO public.who_global_data VALUES (47825, 2, 743, 0, 14, 202, 197);
INSERT INTO public.who_global_data VALUES (47826, 2565, 248416, 40, 2447, 202, 78);
INSERT INTO public.who_global_data VALUES (47827, 125, 8669, 3, 163, 202, 233);
INSERT INTO public.who_global_data VALUES (47828, 389, 20498, 9, 461, 202, 133);
INSERT INTO public.who_global_data VALUES (47829, 0, 108, 0, 0, 202, 35);
INSERT INTO public.who_global_data VALUES (47830, 13, 1701, 0, 65, 202, 114);
INSERT INTO public.who_global_data VALUES (47831, 202, 47656, 0, 27, 202, 237);
INSERT INTO public.who_global_data VALUES (47832, 0, 2, 0, 0, 202, 55);
INSERT INTO public.who_global_data VALUES (47833, 0, 79, 0, 15, 202, 176);
INSERT INTO public.who_global_data VALUES (47834, 11, 1976, 0, 28, 202, 202);
INSERT INTO public.who_global_data VALUES (47835, 6, 1947, 0, 114, 202, 155);
INSERT INTO public.who_global_data VALUES (47836, 0, 0, 0, 0, 202, 32);
INSERT INTO public.who_global_data VALUES (47837, 5, 3111, 0, 93, 202, 220);
INSERT INTO public.who_global_data VALUES (47838, 13285, 350879, 144, 4948, 202, 30);
INSERT INTO public.who_global_data VALUES (47839, 9, 2200, 0, 43, 202, 147);
INSERT INTO public.who_global_data VALUES (47840, 2233, 273590, 2, 29805, 202, 208);
INSERT INTO public.who_global_data VALUES (47841, 11, 2708, 0, 11, 202, 45);
INSERT INTO public.who_global_data VALUES (47842, 235, 10762, 12, 680, 202, 110);
INSERT INTO public.who_global_data VALUES (47843, 24, 943, 0, 19, 202, 88);
INSERT INTO public.who_global_data VALUES (47844, 284, 74109, 7, 5699, 202, 51);
INSERT INTO public.who_global_data VALUES (47845, 80, 33601, 0, 1730, 202, 209);
INSERT INTO public.who_global_data VALUES (47846, 0, 496, 0, 25, 202, 205);
INSERT INTO public.who_global_data VALUES (47847, 48, 6834, 1, 57, 202, 18);
INSERT INTO public.who_global_data VALUES (47848, 3, 3249, 0, 58, 202, 72);
INSERT INTO public.who_global_data VALUES (47849, 569, 295213, 9, 40984, 202, 44);
INSERT INTO public.who_global_data VALUES (47850, 0, 24, 0, 0, 202, 15);
INSERT INTO public.who_global_data VALUES (47851, 8, 774, 0, 15, 202, 25);
INSERT INTO public.who_global_data VALUES (47852, 0, 0, 0, 0, 202, 179);
INSERT INTO public.who_global_data VALUES (47853, 0, 0, 0, 0, 202, 34);
INSERT INTO public.who_global_data VALUES (47854, 0, 136, 0, 8, 202, 207);
INSERT INTO public.who_global_data VALUES (47855, 26, 1374, 0, 50, 202, 166);
INSERT INTO public.who_global_data VALUES (47856, 918, 218717, 17, 5475, 202, 126);
INSERT INTO public.who_global_data VALUES (47857, 0, 0, 0, 0, 202, 97);
INSERT INTO public.who_global_data VALUES (47858, 1, 75, 0, 2, 202, 36);
INSERT INTO public.who_global_data VALUES (47859, 0, 0, 0, 0, 202, 125);
INSERT INTO public.who_global_data VALUES (47860, 6, 1062, 0, 0, 202, 124);
INSERT INTO public.who_global_data VALUES (47861, 731, 58842, 8, 1485, 202, 185);
INSERT INTO public.who_global_data VALUES (47862, 289, 56711, 1, 338, 202, 194);
INSERT INTO public.who_global_data VALUES (47863, 0, 509, 0, 21, 202, 144);
INSERT INTO public.who_global_data VALUES (47864, 74354, 3618497, 917, 138591, 202, 19);
INSERT INTO public.who_global_data VALUES (47865, 20, 283, 0, 6, 202, 217);
INSERT INTO public.who_global_data VALUES (47866, 11, 1037, 0, 32, 202, 148);
INSERT INTO public.who_global_data VALUES (47867, 533, 16429, 4, 84, 202, 86);
INSERT INTO public.who_global_data VALUES (47868, 0, 0, 0, 0, 202, 13);
INSERT INTO public.who_global_data VALUES (47869, 337, 11191, 3, 107, 202, 157);
INSERT INTO public.who_global_data VALUES (47870, 0, 382, 0, 0, 202, 8);
INSERT INTO public.who_global_data VALUES (47871, 0, 0, 0, 0, 202, 73);
INSERT INTO public.who_global_data VALUES (47872, 5, 1585, 3, 444, 202, 101);
INSERT INTO public.who_global_data VALUES (47873, 170, 2980, 11, 120, 202, 165);
INSERT INTO public.who_global_data VALUES (47874, 58, 1478, 1, 25, 202, 14);
INSERT INTO public.who_global_data VALUES (47875, 60, 35375, 0, 1151, 203, 193);
INSERT INTO public.who_global_data VALUES (47876, 0, 3906, 0, 107, 203, 113);
INSERT INTO public.who_global_data VALUES (47877, 593, 21948, 5, 1057, 203, 143);
INSERT INTO public.who_global_data VALUES (47878, 0, 0, 0, 0, 203, 219);
INSERT INTO public.who_global_data VALUES (47879, 3, 880, 0, 52, 203, 186);
INSERT INTO public.who_global_data VALUES (47880, 31, 638, 1, 29, 203, 52);
INSERT INTO public.who_global_data VALUES (47881, 0, 3, 0, 0, 203, 180);
INSERT INTO public.who_global_data VALUES (47882, 0, 74, 0, 3, 203, 167);
INSERT INTO public.who_global_data VALUES (47883, 3623, 114783, 61, 2133, 203, 154);
INSERT INTO public.who_global_data VALUES (47884, 461, 33775, 11, 626, 203, 94);
INSERT INTO public.who_global_data VALUES (47885, 2, 108, 0, 3, 203, 66);
INSERT INTO public.who_global_data VALUES (47886, 425, 11235, 3, 116, 203, 58);
INSERT INTO public.who_global_data VALUES (47887, 138, 19406, 0, 710, 203, 163);
INSERT INTO public.who_global_data VALUES (47888, 471, 26636, 7, 341, 203, 37);
INSERT INTO public.who_global_data VALUES (47889, 5, 124, 0, 11, 203, 142);
INSERT INTO public.who_global_data VALUES (47890, 389, 35473, 3, 124, 203, 83);
INSERT INTO public.who_global_data VALUES (47891, 3034, 199357, 51, 2547, 203, 228);
INSERT INTO public.who_global_data VALUES (47892, 0, 104, 0, 7, 203, 188);
INSERT INTO public.who_global_data VALUES (47893, 159, 65782, 6, 491, 203, 62);
INSERT INTO public.who_global_data VALUES (47894, 274, 64389, 2, 9670, 203, 160);
INSERT INTO public.who_global_data VALUES (47895, 1, 40, 0, 2, 203, 50);
INSERT INTO public.who_global_data VALUES (47896, 139, 1602, 3, 31, 203, 33);
INSERT INTO public.who_global_data VALUES (47897, 2, 152, 0, 9, 203, 183);
INSERT INTO public.who_global_data VALUES (47898, 1, 87, 0, 0, 203, 92);
INSERT INTO public.who_global_data VALUES (47899, 1938, 54156, 42, 1984, 203, 158);
INSERT INTO public.who_global_data VALUES (47900, 0, 5, 0, 0, 203, 67);
INSERT INTO public.who_global_data VALUES (47901, 227, 7908, 4, 243, 203, 57);
INSERT INTO public.who_global_data VALUES (47902, 0, 522, 0, 1, 203, 38);
INSERT INTO public.who_global_data VALUES (47903, 45403, 2012151, 1322, 76688, 203, 141);
INSERT INTO public.who_global_data VALUES (47904, 0, 8, 0, 1, 203, 178);
INSERT INTO public.who_global_data VALUES (47905, 0, 141, 0, 3, 203, 108);
INSERT INTO public.who_global_data VALUES (47906, 298, 8442, 4, 297, 203, 39);
INSERT INTO public.who_global_data VALUES (47907, 7, 1045, 0, 53, 203, 2);
INSERT INTO public.who_global_data VALUES (47908, 0, 310, 0, 1, 203, 195);
INSERT INTO public.who_global_data VALUES (47909, 45, 1939, 1, 20, 203, 107);
INSERT INTO public.who_global_data VALUES (47910, 5, 171, 0, 0, 203, 161);
INSERT INTO public.who_global_data VALUES (47911, 100, 16157, 4, 373, 203, 212);
INSERT INTO public.who_global_data VALUES (47912, 435, 109264, 17, 8827, 203, 181);
INSERT INTO public.who_global_data VALUES (47913, 0, 203, 0, 1, 203, 53);
INSERT INTO public.who_global_data VALUES (47914, 16, 4389, 0, 53, 203, 164);
INSERT INTO public.who_global_data VALUES (47915, 1, 887, 0, 75, 203, 140);
INSERT INTO public.who_global_data VALUES (47916, 2841, 326539, 1057, 8347, 203, 20);
INSERT INTO public.who_global_data VALUES (47917, 82, 85857, 1, 4652, 203, 112);
INSERT INTO public.who_global_data VALUES (47918, 8037, 173206, 215, 6029, 203, 111);
INSERT INTO public.who_global_data VALUES (47919, 0, 328, 0, 7, 203, 71);
INSERT INTO public.who_global_data VALUES (47920, 275, 2633, 1, 49, 203, 218);
INSERT INTO public.who_global_data VALUES (47921, 0, 0, 0, 0, 203, 43);
INSERT INTO public.who_global_data VALUES (47922, 560, 9546, 2, 42, 203, 49);
INSERT INTO public.who_global_data VALUES (47923, 293, 13696, 0, 87, 203, 1);
INSERT INTO public.who_global_data VALUES (47924, 98, 4137, 1, 120, 203, 48);
INSERT INTO public.who_global_data VALUES (47925, 4, 2444, 0, 87, 203, 232);
INSERT INTO public.who_global_data VALUES (47926, 2, 28, 0, 1, 203, 175);
INSERT INTO public.who_global_data VALUES (47927, 0, 1031, 0, 19, 203, 21);
INSERT INTO public.who_global_data VALUES (47928, 130, 13742, 3, 358, 203, 156);
INSERT INTO public.who_global_data VALUES (47929, 0, 0, 0, 0, 203, 95);
INSERT INTO public.who_global_data VALUES (47930, 50, 8248, 0, 192, 203, 177);
INSERT INTO public.who_global_data VALUES (47931, 49, 13173, 1, 611, 203, 210);
INSERT INTO public.who_global_data VALUES (47932, 10, 5003, 0, 56, 203, 120);
INSERT INTO public.who_global_data VALUES (47933, 0, 18, 0, 0, 203, 135);
INSERT INTO public.who_global_data VALUES (47934, 1370, 50113, 1, 942, 203, 206);
INSERT INTO public.who_global_data VALUES (47935, 1079, 72444, 43, 5250, 203, 189);
INSERT INTO public.who_global_data VALUES (47936, 703, 86474, 68, 4188, 203, 129);
INSERT INTO public.who_global_data VALUES (47937, 250, 11207, 11, 309, 203, 121);
INSERT INTO public.who_global_data VALUES (47938, 0, 2350, 0, 41, 203, 59);
INSERT INTO public.who_global_data VALUES (47939, 0, 251, 0, 0, 203, 96);
INSERT INTO public.who_global_data VALUES (47940, 4, 2020, 0, 63, 203, 41);
INSERT INTO public.who_global_data VALUES (47941, 67, 1619, 0, 21, 203, 216);
INSERT INTO public.who_global_data VALUES (47942, 344, 9147, 13, 163, 203, 236);
INSERT INTO public.who_global_data VALUES (47943, 0, 13, 0, 0, 203, 150);
INSERT INTO public.who_global_data VALUES (47944, 0, 188, 0, 0, 203, 61);
INSERT INTO public.who_global_data VALUES (47945, 0, 26, 0, 0, 203, 7);
INSERT INTO public.who_global_data VALUES (47946, 8, 7301, 0, 328, 203, 169);
INSERT INTO public.who_global_data VALUES (47947, 697, 164247, 14, 30046, 203, 28);
INSERT INTO public.who_global_data VALUES (47948, 116, 6509, 0, 34, 203, 85);
INSERT INTO public.who_global_data VALUES (47949, 0, 62, 0, 0, 203, 211);
INSERT INTO public.who_global_data VALUES (47950, 0, 6121, 0, 46, 203, 60);
INSERT INTO public.who_global_data VALUES (47951, 15, 93, 1, 4, 203, 3);
INSERT INTO public.who_global_data VALUES (47952, 8, 1018, 0, 15, 203, 11);
INSERT INTO public.who_global_data VALUES (47953, 529, 201372, 1, 9083, 203, 89);
INSERT INTO public.who_global_data VALUES (47954, 447, 26572, 5, 144, 203, 24);
INSERT INTO public.who_global_data VALUES (47955, 0, 180, 0, 0, 203, 162);
INSERT INTO public.who_global_data VALUES (47956, 25, 3964, 1, 194, 203, 100);
INSERT INTO public.who_global_data VALUES (47957, 0, 13, 0, 0, 203, 47);
INSERT INTO public.who_global_data VALUES (47958, 0, 23, 0, 0, 203, 29);
INSERT INTO public.who_global_data VALUES (47959, 5, 195, 0, 14, 203, 40);
INSERT INTO public.who_global_data VALUES (47960, 0, 306, 0, 5, 203, 222);
INSERT INTO public.who_global_data VALUES (47961, 865, 32939, 54, 1404, 203, 132);
INSERT INTO public.who_global_data VALUES (47962, 0, 252, 0, 13, 203, 130);
INSERT INTO public.who_global_data VALUES (47963, 71, 6430, 0, 39, 203, 234);
INSERT INTO public.who_global_data VALUES (47964, 23, 1950, 0, 26, 203, 23);
INSERT INTO public.who_global_data VALUES (47965, 2, 315, 0, 19, 203, 192);
INSERT INTO public.who_global_data VALUES (47966, 46, 6948, 0, 145, 203, 69);
INSERT INTO public.who_global_data VALUES (47967, 0, 12, 0, 0, 203, 187);
INSERT INTO public.who_global_data VALUES (47968, 831, 30867, 10, 835, 203, 230);
INSERT INTO public.who_global_data VALUES (47969, 14, 4293, 0, 595, 203, 77);
INSERT INTO public.who_global_data VALUES (47970, 0, 1836, 0, 10, 203, 9);
INSERT INTO public.who_global_data VALUES (47971, 34884, 1038716, 671, 26273, 203, 74);
INSERT INTO public.who_global_data VALUES (47972, 1462, 83130, 84, 3957, 203, 224);
INSERT INTO public.who_global_data VALUES (47973, 2379, 269440, 183, 13791, 203, 199);
INSERT INTO public.who_global_data VALUES (47974, 2023, 88171, 94, 3616, 203, 190);
INSERT INTO public.who_global_data VALUES (47975, 32, 25730, 3, 1752, 203, 12);
INSERT INTO public.who_global_data VALUES (47976, 0, 336, 0, 24, 203, 104);
INSERT INTO public.who_global_data VALUES (47977, 1938, 46488, 9, 406, 203, 153);
INSERT INTO public.who_global_data VALUES (47978, 231, 243967, 11, 35028, 203, 91);
INSERT INTO public.who_global_data VALUES (47979, 2, 765, 0, 10, 203, 215);
INSERT INTO public.who_global_data VALUES (47980, 659, 24132, 0, 985, 203, 84);
INSERT INTO public.who_global_data VALUES (47981, 2, 331, 0, 31, 203, 231);
INSERT INTO public.who_global_data VALUES (47982, 3, 1121, 0, 10, 203, 196);
INSERT INTO public.who_global_data VALUES (47983, 1636, 70339, 0, 375, 203, 105);
INSERT INTO public.who_global_data VALUES (47984, 389, 12062, 5, 222, 203, 122);
INSERT INTO public.who_global_data VALUES (47985, 0, 0, 0, 0, 203, 159);
INSERT INTO public.who_global_data VALUES (47986, 81, 5410, 6, 114, 203, 75);
INSERT INTO public.who_global_data VALUES (47987, 553, 58221, 2, 404, 203, 27);
INSERT INTO public.who_global_data VALUES (47988, 11883, 24984, 306, 478, 203, 54);
INSERT INTO public.who_global_data VALUES (47989, 0, 19, 0, 0, 203, 226);
INSERT INTO public.who_global_data VALUES (47990, 6, 1185, 0, 31, 203, 79);
INSERT INTO public.who_global_data VALUES (47991, 101, 2700, 0, 40, 203, 56);
INSERT INTO public.who_global_data VALUES (47992, 103, 359, 3, 6, 203, 117);
INSERT INTO public.who_global_data VALUES (47993, 0, 1070, 0, 68, 203, 152);
INSERT INTO public.who_global_data VALUES (47994, 52, 1704, 1, 47, 203, 16);
INSERT INTO public.who_global_data VALUES (47995, 1, 87, 0, 1, 203, 10);
INSERT INTO public.who_global_data VALUES (47996, 7, 1910, 1, 80, 203, 201);
INSERT INTO public.who_global_data VALUES (47997, 163, 5285, 0, 111, 203, 174);
INSERT INTO public.who_global_data VALUES (47998, 378, 6467, 1, 54, 203, 119);
INSERT INTO public.who_global_data VALUES (47999, 94, 2810, 4, 55, 203, 168);
INSERT INTO public.who_global_data VALUES (48000, 18, 8755, 0, 122, 203, 99);
INSERT INTO public.who_global_data VALUES (48001, 14, 2913, 0, 15, 203, 171);
INSERT INTO public.who_global_data VALUES (48002, 27, 2467, 0, 121, 203, 87);
INSERT INTO public.who_global_data VALUES (48003, 1, 674, 0, 9, 203, 123);
INSERT INTO public.who_global_data VALUES (48004, 0, 0, 0, 0, 203, 151);
INSERT INTO public.who_global_data VALUES (48005, 6, 261, 0, 15, 203, 213);
INSERT INTO public.who_global_data VALUES (48006, 95, 5659, 1, 150, 203, 118);
INSERT INTO public.who_global_data VALUES (48007, 0, 343, 0, 10, 203, 134);
INSERT INTO public.who_global_data VALUES (48008, 0, 2782, 0, 37, 203, 65);
INSERT INTO public.who_global_data VALUES (48009, 6406, 324041, 668, 37574, 203, 102);
INSERT INTO public.who_global_data VALUES (48010, 0, 0, 0, 0, 203, 223);
INSERT INTO public.who_global_data VALUES (48011, 0, 79, 0, 1, 203, 4);
INSERT INTO public.who_global_data VALUES (48012, 1, 262, 0, 0, 203, 146);
INSERT INTO public.who_global_data VALUES (48013, 97, 2134, 3, 31, 203, 31);
INSERT INTO public.who_global_data VALUES (48014, 0, 12, 0, 1, 203, 127);
INSERT INTO public.who_global_data VALUES (48015, 181, 16726, 1, 264, 203, 22);
INSERT INTO public.who_global_data VALUES (48016, 19, 1402, 0, 9, 203, 115);
INSERT INTO public.who_global_data VALUES (48017, 0, 339, 0, 6, 203, 106);
INSERT INTO public.who_global_data VALUES (48018, 46, 1078, 0, 2, 203, 90);
INSERT INTO public.who_global_data VALUES (48019, 0, 0, 0, 0, 203, 70);
INSERT INTO public.who_global_data VALUES (48020, 101, 17445, 1, 40, 203, 46);
INSERT INTO public.who_global_data VALUES (48021, 109, 51352, 2, 6132, 203, 139);
INSERT INTO public.who_global_data VALUES (48022, 0, 22, 0, 0, 203, 42);
INSERT INTO public.who_global_data VALUES (48023, 1, 1200, 0, 22, 203, 80);
INSERT INTO public.who_global_data VALUES (48024, 0, 2712, 0, 99, 203, 203);
INSERT INTO public.who_global_data VALUES (48025, 0, 1102, 0, 69, 203, 136);
INSERT INTO public.who_global_data VALUES (48026, 600, 35454, 3, 772, 203, 63);
INSERT INTO public.who_global_data VALUES (48027, 0, 0, 0, 0, 203, 17);
INSERT INTO public.who_global_data VALUES (48028, 0, 37, 0, 2, 203, 172);
INSERT INTO public.who_global_data VALUES (48029, 174, 8786, 5, 406, 203, 109);
INSERT INTO public.who_global_data VALUES (48030, 4, 9015, 1, 255, 203, 200);
INSERT INTO public.who_global_data VALUES (48031, 439, 9055, 5, 57, 203, 93);
INSERT INTO public.who_global_data VALUES (48032, 1619, 64193, 8, 298, 203, 5);
INSERT INTO public.who_global_data VALUES (48033, 0, 741, 0, 13, 203, 214);
INSERT INTO public.who_global_data VALUES (48034, 1918, 261917, 47, 5522, 203, 204);
INSERT INTO public.who_global_data VALUES (48035, 0, 0, 0, 0, 203, 198);
INSERT INTO public.who_global_data VALUES (48036, 1130, 50373, 18, 1000, 203, 173);
INSERT INTO public.who_global_data VALUES (48037, 0, 15, 0, 0, 203, 229);
INSERT INTO public.who_global_data VALUES (48038, 144, 3342, 2, 27, 203, 76);
INSERT INTO public.who_global_data VALUES (48039, 3862, 341586, 198, 12615, 203, 138);
INSERT INTO public.who_global_data VALUES (48040, 1735, 63001, 17, 1660, 203, 98);
INSERT INTO public.who_global_data VALUES (48041, 0, 0, 0, 0, 203, 103);
INSERT INTO public.who_global_data VALUES (48042, 353, 39407, 7, 1612, 203, 225);
INSERT INTO public.who_global_data VALUES (48043, 312, 48077, 3, 1682, 203, 131);
INSERT INTO public.who_global_data VALUES (48044, 546, 11120, 5, 177, 203, 235);
INSERT INTO public.who_global_data VALUES (48045, 421, 105898, 1, 153, 203, 137);
INSERT INTO public.who_global_data VALUES (48046, 39, 13711, 1, 294, 203, 81);
INSERT INTO public.who_global_data VALUES (48047, 230, 20494, 9, 675, 203, 182);
INSERT INTO public.who_global_data VALUES (48048, 10, 624, 0, 3, 203, 145);
INSERT INTO public.who_global_data VALUES (48049, 799, 35802, 17, 1988, 203, 26);
INSERT INTO public.who_global_data VALUES (48050, 6234, 765437, 124, 12247, 203, 170);
INSERT INTO public.who_global_data VALUES (48051, 12, 1485, 0, 4, 203, 191);
INSERT INTO public.who_global_data VALUES (48052, 0, 3, 0, 0, 203, 221);
INSERT INTO public.who_global_data VALUES (48053, 0, 6, 0, 0, 203, 64);
INSERT INTO public.who_global_data VALUES (48054, 0, 0, 0, 0, 203, 116);
INSERT INTO public.who_global_data VALUES (48055, 0, 17, 0, 0, 203, 128);
INSERT INTO public.who_global_data VALUES (48056, 0, 23, 0, 0, 203, 6);
INSERT INTO public.who_global_data VALUES (48057, 2, 46, 0, 3, 203, 227);
INSERT INTO public.who_global_data VALUES (48058, 0, 4, 0, 0, 203, 68);
INSERT INTO public.who_global_data VALUES (48059, 0, 35, 0, 0, 203, 184);
INSERT INTO public.who_global_data VALUES (48060, 0, 0, 0, 0, 203, 82);
INSERT INTO public.who_global_data VALUES (48061, 0, 716, 0, 42, 203, 149);
INSERT INTO public.who_global_data VALUES (48062, 1, 741, 0, 14, 203, 197);
INSERT INTO public.who_global_data VALUES (48063, 2613, 245851, 37, 2407, 203, 78);
INSERT INTO public.who_global_data VALUES (48064, 63, 8544, 4, 160, 203, 233);
INSERT INTO public.who_global_data VALUES (48065, 392, 20109, 10, 452, 203, 133);
INSERT INTO public.who_global_data VALUES (48066, 0, 108, 0, 0, 203, 35);
INSERT INTO public.who_global_data VALUES (48067, 10, 1688, 1, 65, 203, 114);
INSERT INTO public.who_global_data VALUES (48068, 327, 47454, 0, 27, 203, 237);
INSERT INTO public.who_global_data VALUES (48069, 0, 2, 0, 0, 203, 55);
INSERT INTO public.who_global_data VALUES (48070, 0, 79, 0, 15, 203, 176);
INSERT INTO public.who_global_data VALUES (48071, 14, 1965, 0, 28, 203, 202);
INSERT INTO public.who_global_data VALUES (48072, 24, 1941, 0, 114, 203, 155);
INSERT INTO public.who_global_data VALUES (48073, 0, 0, 0, 0, 203, 32);
INSERT INTO public.who_global_data VALUES (48074, 0, 3106, 0, 93, 203, 220);
INSERT INTO public.who_global_data VALUES (48075, 13373, 337594, 135, 4804, 203, 30);
INSERT INTO public.who_global_data VALUES (48076, 0, 2191, 0, 43, 203, 147);
INSERT INTO public.who_global_data VALUES (48077, 1729, 271357, 2, 29803, 203, 208);
INSERT INTO public.who_global_data VALUES (48078, 10, 2697, 0, 11, 203, 45);
INSERT INTO public.who_global_data VALUES (48079, 0, 10527, 0, 668, 203, 110);
INSERT INTO public.who_global_data VALUES (48080, 70, 919, 1, 19, 203, 88);
INSERT INTO public.who_global_data VALUES (48081, 268, 73825, 6, 5692, 203, 51);
INSERT INTO public.who_global_data VALUES (48082, 115, 33521, 1, 1730, 203, 209);
INSERT INTO public.who_global_data VALUES (48083, 19, 496, 3, 25, 203, 205);
INSERT INTO public.who_global_data VALUES (48084, 45, 6786, 0, 56, 203, 18);
INSERT INTO public.who_global_data VALUES (48085, 7, 3246, 0, 58, 203, 72);
INSERT INTO public.who_global_data VALUES (48086, 704, 294644, 26, 40975, 203, 44);
INSERT INTO public.who_global_data VALUES (48087, 0, 24, 0, 0, 203, 15);
INSERT INTO public.who_global_data VALUES (48088, 17, 766, 0, 15, 203, 25);
INSERT INTO public.who_global_data VALUES (48089, 0, 0, 0, 0, 203, 179);
INSERT INTO public.who_global_data VALUES (48090, 0, 0, 0, 0, 203, 34);
INSERT INTO public.who_global_data VALUES (48091, 3, 136, 0, 8, 203, 207);
INSERT INTO public.who_global_data VALUES (48092, 12, 1348, 0, 50, 203, 166);
INSERT INTO public.who_global_data VALUES (48093, 926, 217799, 18, 5458, 203, 126);
INSERT INTO public.who_global_data VALUES (48094, 0, 0, 0, 0, 203, 97);
INSERT INTO public.who_global_data VALUES (48095, 2, 74, 0, 2, 203, 36);
INSERT INTO public.who_global_data VALUES (48096, 0, 0, 0, 0, 203, 125);
INSERT INTO public.who_global_data VALUES (48097, 5, 1056, 0, 0, 203, 124);
INSERT INTO public.who_global_data VALUES (48098, 847, 58111, 21, 1477, 203, 185);
INSERT INTO public.who_global_data VALUES (48099, 293, 56422, 2, 337, 203, 194);
INSERT INTO public.who_global_data VALUES (48100, 0, 509, 0, 21, 203, 144);
INSERT INTO public.who_global_data VALUES (48101, 71484, 3544143, 921, 137674, 203, 19);
INSERT INTO public.who_global_data VALUES (48102, 14, 263, 0, 6, 203, 217);
INSERT INTO public.who_global_data VALUES (48103, 17, 1026, 1, 32, 203, 148);
INSERT INTO public.who_global_data VALUES (48104, 547, 15896, 4, 80, 203, 86);
INSERT INTO public.who_global_data VALUES (48105, 0, 0, 0, 0, 203, 13);
INSERT INTO public.who_global_data VALUES (48106, 426, 10854, 4, 104, 203, 157);
INSERT INTO public.who_global_data VALUES (48107, 1, 382, 0, 0, 203, 8);
INSERT INTO public.who_global_data VALUES (48108, 0, 0, 0, 0, 203, 73);
INSERT INTO public.who_global_data VALUES (48109, 24, 1580, 2, 441, 203, 101);
INSERT INTO public.who_global_data VALUES (48110, 527, 2810, 27, 109, 203, 165);
INSERT INTO public.who_global_data VALUES (48111, 58, 1420, 1, 24, 203, 14);
INSERT INTO public.who_global_data VALUES (48112, 159, 35315, 34, 1151, 204, 193);
INSERT INTO public.who_global_data VALUES (48113, 55, 3906, 3, 107, 204, 113);
INSERT INTO public.who_global_data VALUES (48114, 585, 21355, 12, 1052, 204, 143);
INSERT INTO public.who_global_data VALUES (48115, 0, 0, 0, 0, 204, 219);
INSERT INTO public.who_global_data VALUES (48116, 15, 877, 0, 52, 204, 186);
INSERT INTO public.who_global_data VALUES (48117, 31, 607, 1, 28, 204, 52);
INSERT INTO public.who_global_data VALUES (48118, 0, 3, 0, 0, 204, 180);
INSERT INTO public.who_global_data VALUES (48119, 0, 74, 0, 3, 204, 167);
INSERT INTO public.who_global_data VALUES (48120, 4250, 111160, 85, 2072, 204, 154);
INSERT INTO public.who_global_data VALUES (48121, 442, 33314, 13, 615, 204, 94);
INSERT INTO public.who_global_data VALUES (48122, 0, 106, 0, 3, 204, 66);
INSERT INTO public.who_global_data VALUES (48123, 315, 10810, 2, 113, 204, 58);
INSERT INTO public.who_global_data VALUES (48124, 153, 19268, 0, 710, 204, 163);
INSERT INTO public.who_global_data VALUES (48125, 493, 26165, 8, 334, 204, 37);
INSERT INTO public.who_global_data VALUES (48126, 3, 119, 0, 11, 204, 142);
INSERT INTO public.who_global_data VALUES (48127, 524, 35084, 4, 121, 204, 83);
INSERT INTO public.who_global_data VALUES (48128, 2733, 196323, 39, 2496, 204, 228);
INSERT INTO public.who_global_data VALUES (48129, 1, 104, 0, 7, 204, 188);
INSERT INTO public.who_global_data VALUES (48130, 180, 65623, 5, 485, 204, 62);
INSERT INTO public.who_global_data VALUES (48131, 226, 64115, 5, 9668, 204, 160);
INSERT INTO public.who_global_data VALUES (48132, 0, 39, 0, 2, 204, 50);
INSERT INTO public.who_global_data VALUES (48133, 0, 1463, 0, 28, 204, 33);
INSERT INTO public.who_global_data VALUES (48134, 0, 150, 0, 9, 204, 183);
INSERT INTO public.who_global_data VALUES (48135, 2, 86, 0, 0, 204, 92);
INSERT INTO public.who_global_data VALUES (48136, 1351, 52218, 44, 1942, 204, 158);
INSERT INTO public.who_global_data VALUES (48137, 0, 5, 0, 0, 204, 67);
INSERT INTO public.who_global_data VALUES (48138, 274, 7681, 6, 239, 204, 57);
INSERT INTO public.who_global_data VALUES (48139, 123, 522, 0, 1, 204, 38);
INSERT INTO public.who_global_data VALUES (48140, 39924, 1966748, 1233, 75366, 204, 141);
INSERT INTO public.who_global_data VALUES (48141, 0, 8, 0, 1, 204, 178);
INSERT INTO public.who_global_data VALUES (48142, 0, 141, 0, 3, 204, 108);
INSERT INTO public.who_global_data VALUES (48143, 267, 8144, 4, 293, 204, 39);
INSERT INTO public.who_global_data VALUES (48144, 0, 1038, 0, 53, 204, 2);
INSERT INTO public.who_global_data VALUES (48145, 7, 310, 0, 1, 204, 195);
INSERT INTO public.who_global_data VALUES (48146, 57, 1894, 0, 19, 204, 107);
INSERT INTO public.who_global_data VALUES (48147, 0, 166, 0, 0, 204, 161);
INSERT INTO public.who_global_data VALUES (48148, 0, 16057, 0, 369, 204, 212);
INSERT INTO public.who_global_data VALUES (48149, 343, 108829, 12, 8810, 204, 181);
INSERT INTO public.who_global_data VALUES (48150, 0, 203, 0, 1, 204, 53);
INSERT INTO public.who_global_data VALUES (48151, 11, 4373, 0, 53, 204, 164);
INSERT INTO public.who_global_data VALUES (48152, 1, 886, 0, 75, 204, 140);
INSERT INTO public.who_global_data VALUES (48153, 2493, 323698, 104, 7290, 204, 20);
INSERT INTO public.who_global_data VALUES (48154, 78, 85775, 0, 4651, 204, 112);
INSERT INTO public.who_global_data VALUES (48155, 5271, 165169, 189, 5814, 204, 111);
INSERT INTO public.who_global_data VALUES (48156, 7, 328, 0, 7, 204, 71);
INSERT INTO public.who_global_data VALUES (48157, 0, 2358, 0, 48, 204, 218);
INSERT INTO public.who_global_data VALUES (48158, 0, 0, 0, 0, 204, 43);
INSERT INTO public.who_global_data VALUES (48159, 504, 8986, 4, 40, 204, 49);
INSERT INTO public.who_global_data VALUES (48160, 366, 13403, 0, 87, 204, 1);
INSERT INTO public.who_global_data VALUES (48161, 86, 4039, 0, 119, 204, 48);
INSERT INTO public.who_global_data VALUES (48162, 2, 2440, 0, 87, 204, 232);
INSERT INTO public.who_global_data VALUES (48163, 0, 26, 0, 1, 204, 175);
INSERT INTO public.who_global_data VALUES (48164, 8, 1031, 0, 19, 204, 21);
INSERT INTO public.who_global_data VALUES (48165, 137, 13612, 0, 355, 204, 156);
INSERT INTO public.who_global_data VALUES (48166, 0, 0, 0, 0, 204, 95);
INSERT INTO public.who_global_data VALUES (48167, 36, 8198, 1, 192, 204, 177);
INSERT INTO public.who_global_data VALUES (48168, 32, 13124, 0, 610, 204, 210);
INSERT INTO public.who_global_data VALUES (48169, 8, 4993, 0, 56, 204, 120);
INSERT INTO public.who_global_data VALUES (48170, 0, 18, 0, 0, 204, 135);
INSERT INTO public.who_global_data VALUES (48171, 1072, 48743, 12, 941, 204, 206);
INSERT INTO public.who_global_data VALUES (48172, 1036, 71365, 49, 5207, 204, 189);
INSERT INTO public.who_global_data VALUES (48173, 928, 85771, 53, 4120, 204, 129);
INSERT INTO public.who_global_data VALUES (48174, 312, 10957, 12, 298, 204, 121);
INSERT INTO public.who_global_data VALUES (48175, 1307, 2350, 29, 41, 204, 59);
INSERT INTO public.who_global_data VALUES (48176, 19, 251, 0, 0, 204, 96);
INSERT INTO public.who_global_data VALUES (48177, 0, 2016, 0, 63, 204, 41);
INSERT INTO public.who_global_data VALUES (48178, 63, 1552, 1, 21, 204, 216);
INSERT INTO public.who_global_data VALUES (48179, 328, 8803, 2, 150, 204, 236);
INSERT INTO public.who_global_data VALUES (48180, 0, 13, 0, 0, 204, 150);
INSERT INTO public.who_global_data VALUES (48181, 0, 188, 0, 0, 204, 61);
INSERT INTO public.who_global_data VALUES (48182, 0, 26, 0, 0, 204, 7);
INSERT INTO public.who_global_data VALUES (48183, 0, 7293, 0, 328, 204, 169);
INSERT INTO public.who_global_data VALUES (48184, 393, 163550, 17, 30032, 204, 28);
INSERT INTO public.who_global_data VALUES (48185, 94, 6393, 1, 34, 204, 85);
INSERT INTO public.who_global_data VALUES (48186, 0, 62, 0, 0, 204, 211);
INSERT INTO public.who_global_data VALUES (48187, 179, 6121, 0, 46, 204, 60);
INSERT INTO public.who_global_data VALUES (48188, 14, 78, 0, 3, 204, 3);
INSERT INTO public.who_global_data VALUES (48189, 4, 1010, 0, 15, 204, 11);
INSERT INTO public.who_global_data VALUES (48190, 583, 200843, 4, 9082, 204, 89);
INSERT INTO public.who_global_data VALUES (48191, 695, 26125, 0, 139, 204, 24);
INSERT INTO public.who_global_data VALUES (48192, 0, 180, 0, 0, 204, 162);
INSERT INTO public.who_global_data VALUES (48193, 29, 3939, 0, 193, 204, 100);
INSERT INTO public.who_global_data VALUES (48194, 0, 13, 0, 0, 204, 47);
INSERT INTO public.who_global_data VALUES (48195, 0, 23, 0, 0, 204, 29);
INSERT INTO public.who_global_data VALUES (48196, 0, 190, 0, 14, 204, 40);
INSERT INTO public.who_global_data VALUES (48197, 0, 306, 0, 5, 204, 222);
INSERT INTO public.who_global_data VALUES (48198, 1202, 32074, 48, 1350, 204, 132);
INSERT INTO public.who_global_data VALUES (48199, 0, 252, 0, 13, 204, 130);
INSERT INTO public.who_global_data VALUES (48200, 83, 6359, 1, 39, 204, 234);
INSERT INTO public.who_global_data VALUES (48201, 0, 1927, 0, 26, 204, 23);
INSERT INTO public.who_global_data VALUES (48202, 5, 313, 1, 19, 204, 192);
INSERT INTO public.who_global_data VALUES (48203, 71, 6902, 2, 145, 204, 69);
INSERT INTO public.who_global_data VALUES (48204, 0, 12, 0, 0, 204, 187);
INSERT INTO public.who_global_data VALUES (48205, 930, 30036, 18, 825, 204, 230);
INSERT INTO public.who_global_data VALUES (48206, 16, 4279, 0, 595, 204, 77);
INSERT INTO public.who_global_data VALUES (48207, 1, 1836, 0, 10, 204, 9);
INSERT INTO public.who_global_data VALUES (48208, 34956, 1003832, 687, 25602, 204, 74);
INSERT INTO public.who_global_data VALUES (48209, 1574, 81668, 76, 3873, 204, 224);
INSERT INTO public.who_global_data VALUES (48210, 2500, 267061, 198, 13608, 204, 199);
INSERT INTO public.who_global_data VALUES (48211, 2281, 86148, 90, 3522, 204, 190);
INSERT INTO public.who_global_data VALUES (48212, 15, 25698, 1, 1749, 204, 12);
INSERT INTO public.who_global_data VALUES (48213, 0, 336, 0, 24, 204, 104);
INSERT INTO public.who_global_data VALUES (48214, 1877, 44550, 6, 397, 204, 153);
INSERT INTO public.who_global_data VALUES (48215, 230, 243736, 20, 35017, 204, 91);
INSERT INTO public.who_global_data VALUES (48216, 1, 763, 0, 10, 204, 215);
INSERT INTO public.who_global_data VALUES (48217, 583, 23473, 0, 985, 204, 84);
INSERT INTO public.who_global_data VALUES (48218, 0, 329, 0, 31, 204, 231);
INSERT INTO public.who_global_data VALUES (48219, 5, 1118, 0, 10, 204, 196);
INSERT INTO public.who_global_data VALUES (48220, 1808, 68703, 0, 375, 204, 105);
INSERT INTO public.who_global_data VALUES (48221, 421, 11673, 8, 217, 204, 122);
INSERT INTO public.who_global_data VALUES (48222, 0, 0, 0, 0, 204, 159);
INSERT INTO public.who_global_data VALUES (48223, 135, 5329, 6, 108, 204, 75);
INSERT INTO public.who_global_data VALUES (48224, 791, 57668, 3, 402, 204, 27);
INSERT INTO public.who_global_data VALUES (48225, 603, 13101, 5, 172, 204, 54);
INSERT INTO public.who_global_data VALUES (48226, 0, 19, 0, 0, 204, 226);
INSERT INTO public.who_global_data VALUES (48227, 1, 1179, 0, 31, 204, 79);
INSERT INTO public.who_global_data VALUES (48228, 57, 2599, 2, 40, 204, 56);
INSERT INTO public.who_global_data VALUES (48229, 0, 256, 0, 3, 204, 117);
INSERT INTO public.who_global_data VALUES (48230, 14, 1070, 2, 68, 204, 152);
INSERT INTO public.who_global_data VALUES (48231, 63, 1652, 3, 46, 204, 16);
INSERT INTO public.who_global_data VALUES (48232, 1, 86, 0, 1, 204, 10);
INSERT INTO public.who_global_data VALUES (48233, 6, 1903, 0, 79, 204, 201);
INSERT INTO public.who_global_data VALUES (48234, 66, 5122, 0, 111, 204, 174);
INSERT INTO public.who_global_data VALUES (48235, 484, 6089, 10, 53, 204, 119);
INSERT INTO public.who_global_data VALUES (48236, 102, 2716, 8, 51, 204, 168);
INSERT INTO public.who_global_data VALUES (48237, 3, 8737, 0, 122, 204, 99);
INSERT INTO public.who_global_data VALUES (48238, 68, 2899, 1, 15, 204, 171);
INSERT INTO public.who_global_data VALUES (48239, 7, 2440, 0, 121, 204, 87);
INSERT INTO public.who_global_data VALUES (48240, 0, 673, 0, 9, 204, 123);
INSERT INTO public.who_global_data VALUES (48241, 0, 0, 0, 0, 204, 151);
INSERT INTO public.who_global_data VALUES (48242, 0, 255, 0, 15, 204, 213);
INSERT INTO public.who_global_data VALUES (48243, 46, 5564, 0, 149, 204, 118);
INSERT INTO public.who_global_data VALUES (48244, 0, 343, 0, 10, 204, 134);
INSERT INTO public.who_global_data VALUES (48245, 39, 2782, 0, 37, 204, 65);
INSERT INTO public.who_global_data VALUES (48246, 6149, 317635, 579, 36906, 204, 102);
INSERT INTO public.who_global_data VALUES (48247, 0, 0, 0, 0, 204, 223);
INSERT INTO public.who_global_data VALUES (48248, 0, 79, 0, 1, 204, 4);
INSERT INTO public.who_global_data VALUES (48249, 0, 261, 0, 0, 204, 146);
INSERT INTO public.who_global_data VALUES (48250, 40, 2037, 2, 28, 204, 31);
INSERT INTO public.who_global_data VALUES (48251, 0, 12, 0, 1, 204, 127);
INSERT INTO public.who_global_data VALUES (48252, 283, 16545, 4, 263, 204, 22);
INSERT INTO public.who_global_data VALUES (48253, 53, 1383, 0, 9, 204, 115);
INSERT INTO public.who_global_data VALUES (48254, 2, 339, 0, 6, 204, 106);
INSERT INTO public.who_global_data VALUES (48255, 72, 1032, 0, 2, 204, 90);
INSERT INTO public.who_global_data VALUES (48256, 0, 0, 0, 0, 204, 70);
INSERT INTO public.who_global_data VALUES (48257, 167, 17344, 0, 39, 204, 46);
INSERT INTO public.who_global_data VALUES (48258, 119, 51243, 2, 6130, 204, 139);
INSERT INTO public.who_global_data VALUES (48259, 0, 22, 0, 0, 204, 42);
INSERT INTO public.who_global_data VALUES (48260, 1, 1199, 0, 22, 204, 80);
INSERT INTO public.who_global_data VALUES (48261, 0, 2712, 0, 99, 204, 203);
INSERT INTO public.who_global_data VALUES (48262, 3, 1102, 1, 69, 204, 136);
INSERT INTO public.who_global_data VALUES (48263, 595, 34854, 9, 769, 204, 63);
INSERT INTO public.who_global_data VALUES (48264, 0, 0, 0, 0, 204, 17);
INSERT INTO public.who_global_data VALUES (48265, 1, 37, 0, 2, 204, 172);
INSERT INTO public.who_global_data VALUES (48266, 90, 8612, 8, 401, 204, 109);
INSERT INTO public.who_global_data VALUES (48267, 10, 9011, 1, 254, 204, 200);
INSERT INTO public.who_global_data VALUES (48268, 463, 8616, 5, 52, 204, 93);
INSERT INTO public.who_global_data VALUES (48269, 1327, 62574, 9, 290, 204, 5);
INSERT INTO public.who_global_data VALUES (48270, 0, 741, 0, 13, 204, 214);
INSERT INTO public.who_global_data VALUES (48271, 2085, 259999, 49, 5475, 204, 204);
INSERT INTO public.who_global_data VALUES (48272, 0, 0, 0, 0, 204, 198);
INSERT INTO public.who_global_data VALUES (48273, 1147, 49243, 22, 982, 204, 173);
INSERT INTO public.who_global_data VALUES (48274, 4, 15, 0, 0, 204, 229);
INSERT INTO public.who_global_data VALUES (48275, 124, 3198, 0, 25, 204, 76);
INSERT INTO public.who_global_data VALUES (48276, 3857, 337724, 188, 12417, 204, 138);
INSERT INTO public.who_global_data VALUES (48277, 2416, 61266, 29, 1643, 204, 98);
INSERT INTO public.who_global_data VALUES (48278, 0, 0, 0, 0, 204, 103);
INSERT INTO public.who_global_data VALUES (48279, 274, 39054, 11, 1605, 204, 225);
INSERT INTO public.who_global_data VALUES (48280, 339, 47765, 3, 1679, 204, 131);
INSERT INTO public.who_global_data VALUES (48281, 195, 10574, 1, 172, 204, 235);
INSERT INTO public.who_global_data VALUES (48282, 494, 105477, 1, 152, 204, 137);
INSERT INTO public.who_global_data VALUES (48283, 60, 13672, 2, 293, 204, 81);
INSERT INTO public.who_global_data VALUES (48284, 224, 20264, 4, 666, 204, 182);
INSERT INTO public.who_global_data VALUES (48285, 6, 614, 0, 3, 204, 145);
INSERT INTO public.who_global_data VALUES (48286, 777, 35003, 19, 1971, 204, 26);
INSERT INTO public.who_global_data VALUES (48287, 6406, 759203, 186, 12123, 204, 170);
INSERT INTO public.who_global_data VALUES (48288, 38, 1473, 0, 4, 204, 191);
INSERT INTO public.who_global_data VALUES (48289, 0, 3, 0, 0, 204, 221);
INSERT INTO public.who_global_data VALUES (48290, 0, 6, 0, 0, 204, 64);
INSERT INTO public.who_global_data VALUES (48291, 0, 0, 0, 0, 204, 116);
INSERT INTO public.who_global_data VALUES (48292, 0, 17, 0, 0, 204, 128);
INSERT INTO public.who_global_data VALUES (48293, 0, 23, 0, 0, 204, 6);
INSERT INTO public.who_global_data VALUES (48294, 0, 44, 0, 3, 204, 227);
INSERT INTO public.who_global_data VALUES (48295, 2, 4, 0, 0, 204, 68);
INSERT INTO public.who_global_data VALUES (48296, 0, 35, 0, 0, 204, 184);
INSERT INTO public.who_global_data VALUES (48297, 0, 0, 0, 0, 204, 82);
INSERT INTO public.who_global_data VALUES (48298, 0, 716, 0, 42, 204, 149);
INSERT INTO public.who_global_data VALUES (48299, 323, 740, 2, 14, 204, 197);
INSERT INTO public.who_global_data VALUES (48300, 2764, 243238, 45, 2370, 204, 78);
INSERT INTO public.who_global_data VALUES (48301, 112, 8481, 3, 156, 204, 233);
INSERT INTO public.who_global_data VALUES (48302, 383, 19717, 13, 442, 204, 133);
INSERT INTO public.who_global_data VALUES (48303, 0, 108, 0, 0, 204, 35);
INSERT INTO public.who_global_data VALUES (48304, 10, 1678, 0, 64, 204, 114);
INSERT INTO public.who_global_data VALUES (48305, 248, 47127, 0, 27, 204, 237);
INSERT INTO public.who_global_data VALUES (48306, 0, 2, 0, 0, 204, 55);
INSERT INTO public.who_global_data VALUES (48307, 0, 79, 0, 15, 204, 176);
INSERT INTO public.who_global_data VALUES (48308, 24, 1951, 0, 28, 204, 202);
INSERT INTO public.who_global_data VALUES (48309, 19, 1917, 0, 114, 204, 155);
INSERT INTO public.who_global_data VALUES (48310, 0, 0, 0, 0, 204, 32);
INSERT INTO public.who_global_data VALUES (48311, 23, 3106, 0, 93, 204, 220);
INSERT INTO public.who_global_data VALUES (48312, 13172, 324221, 216, 4669, 204, 30);
INSERT INTO public.who_global_data VALUES (48313, 20, 2191, 2, 43, 204, 147);
INSERT INTO public.who_global_data VALUES (48314, 1670, 269628, 5, 29801, 204, 208);
INSERT INTO public.who_global_data VALUES (48315, 13, 2687, 0, 11, 204, 45);
INSERT INTO public.who_global_data VALUES (48316, 0, 10527, 0, 668, 204, 110);
INSERT INTO public.who_global_data VALUES (48317, 48, 849, 0, 18, 204, 88);
INSERT INTO public.who_global_data VALUES (48318, 287, 73557, 6, 5686, 204, 51);
INSERT INTO public.who_global_data VALUES (48319, 106, 33406, 1, 1729, 204, 209);
INSERT INTO public.who_global_data VALUES (48320, 19, 477, 0, 22, 204, 205);
INSERT INTO public.who_global_data VALUES (48321, 46, 6741, 0, 56, 204, 18);
INSERT INTO public.who_global_data VALUES (48322, 3, 3239, 0, 58, 204, 72);
INSERT INTO public.who_global_data VALUES (48323, 772, 293940, 24, 40949, 204, 44);
INSERT INTO public.who_global_data VALUES (48324, 0, 24, 0, 0, 204, 15);
INSERT INTO public.who_global_data VALUES (48325, 9, 749, 0, 15, 204, 25);
INSERT INTO public.who_global_data VALUES (48326, 0, 0, 0, 0, 204, 179);
INSERT INTO public.who_global_data VALUES (48327, 0, 0, 0, 0, 204, 34);
INSERT INTO public.who_global_data VALUES (48328, 0, 133, 0, 8, 204, 207);
INSERT INTO public.who_global_data VALUES (48329, 9, 1336, 0, 50, 204, 166);
INSERT INTO public.who_global_data VALUES (48330, 933, 216873, 21, 5440, 204, 126);
INSERT INTO public.who_global_data VALUES (48331, 0, 0, 0, 0, 204, 97);
INSERT INTO public.who_global_data VALUES (48332, 0, 72, 0, 2, 204, 36);
INSERT INTO public.who_global_data VALUES (48333, 0, 0, 0, 0, 204, 125);
INSERT INTO public.who_global_data VALUES (48334, 8, 1051, 0, 0, 204, 124);
INSERT INTO public.who_global_data VALUES (48335, 809, 57264, 11, 1456, 204, 185);
INSERT INTO public.who_global_data VALUES (48336, 281, 56129, 0, 335, 204, 194);
INSERT INTO public.who_global_data VALUES (48337, 0, 509, 0, 21, 204, 144);
INSERT INTO public.who_global_data VALUES (48338, 67165, 3472659, 946, 136753, 204, 19);
INSERT INTO public.who_global_data VALUES (48339, 6, 249, 0, 6, 204, 217);
INSERT INTO public.who_global_data VALUES (48340, 12, 1009, 0, 31, 204, 148);
INSERT INTO public.who_global_data VALUES (48341, 562, 15349, 4, 76, 204, 86);
INSERT INTO public.who_global_data VALUES (48342, 0, 0, 0, 0, 204, 13);
INSERT INTO public.who_global_data VALUES (48343, 418, 10428, 4, 100, 204, 157);
INSERT INTO public.who_global_data VALUES (48344, 0, 381, 0, 0, 204, 8);
INSERT INTO public.who_global_data VALUES (48345, 0, 0, 0, 0, 204, 73);
INSERT INTO public.who_global_data VALUES (48346, 26, 1556, 5, 439, 204, 101);
INSERT INTO public.who_global_data VALUES (48347, 0, 2283, 0, 82, 204, 165);
INSERT INTO public.who_global_data VALUES (48348, 273, 1362, 3, 23, 204, 14);
INSERT INTO public.who_global_data VALUES (48349, 130, 35156, 19, 1117, 205, 193);
INSERT INTO public.who_global_data VALUES (48350, 99, 3851, 3, 104, 205, 113);
INSERT INTO public.who_global_data VALUES (48351, 554, 20770, 12, 1040, 205, 143);
INSERT INTO public.who_global_data VALUES (48352, 0, 0, 0, 0, 205, 219);
INSERT INTO public.who_global_data VALUES (48353, 1, 862, 0, 52, 205, 186);
INSERT INTO public.who_global_data VALUES (48354, 35, 576, 1, 27, 205, 52);
INSERT INTO public.who_global_data VALUES (48355, 0, 3, 0, 0, 205, 180);
INSERT INTO public.who_global_data VALUES (48356, 0, 74, 0, 3, 205, 167);
INSERT INTO public.who_global_data VALUES (48357, 3645, 106910, 61, 1987, 205, 154);
INSERT INTO public.who_global_data VALUES (48358, 554, 32872, 15, 602, 205, 94);
INSERT INTO public.who_global_data VALUES (48359, 1, 106, 0, 3, 205, 66);
INSERT INTO public.who_global_data VALUES (48360, 244, 10495, 3, 111, 205, 58);
INSERT INTO public.who_global_data VALUES (48361, 55, 19115, 1, 710, 205, 163);
INSERT INTO public.who_global_data VALUES (48362, 559, 25672, 7, 326, 205, 37);
INSERT INTO public.who_global_data VALUES (48363, 3, 116, 0, 11, 205, 142);
INSERT INTO public.who_global_data VALUES (48364, 482, 34560, 6, 117, 205, 83);
INSERT INTO public.who_global_data VALUES (48365, 3533, 193590, 33, 2457, 205, 228);
INSERT INTO public.who_global_data VALUES (48366, 0, 103, 0, 7, 205, 188);
INSERT INTO public.who_global_data VALUES (48367, 174, 65443, 6, 480, 205, 62);
INSERT INTO public.who_global_data VALUES (48368, 260, 63889, 5, 9663, 205, 160);
INSERT INTO public.who_global_data VALUES (48369, 2, 39, 0, 2, 205, 50);
INSERT INTO public.who_global_data VALUES (48370, 0, 1463, 0, 28, 205, 33);
INSERT INTO public.who_global_data VALUES (48371, 0, 150, 0, 9, 205, 183);
INSERT INTO public.who_global_data VALUES (48372, 0, 84, 0, 0, 205, 92);
INSERT INTO public.who_global_data VALUES (48373, 1617, 50867, 32, 1898, 205, 158);
INSERT INTO public.who_global_data VALUES (48374, 1, 5, 0, 0, 205, 67);
INSERT INTO public.who_global_data VALUES (48375, 231, 7407, 4, 233, 205, 57);
INSERT INTO public.who_global_data VALUES (48376, 0, 399, 0, 1, 205, 38);
INSERT INTO public.who_global_data VALUES (48377, 41857, 1926824, 1300, 74133, 205, 141);
INSERT INTO public.who_global_data VALUES (48378, 0, 8, 0, 1, 205, 178);
INSERT INTO public.who_global_data VALUES (48379, 0, 141, 0, 3, 205, 108);
INSERT INTO public.who_global_data VALUES (48380, 232, 7877, 6, 289, 205, 39);
INSERT INTO public.who_global_data VALUES (48381, 1, 1038, 0, 53, 205, 2);
INSERT INTO public.who_global_data VALUES (48382, 34, 303, 0, 1, 205, 195);
INSERT INTO public.who_global_data VALUES (48383, 57, 1837, 0, 19, 205, 107);
INSERT INTO public.who_global_data VALUES (48384, 1, 166, 0, 0, 205, 161);
INSERT INTO public.who_global_data VALUES (48385, 884, 16057, 10, 369, 205, 212);
INSERT INTO public.who_global_data VALUES (48386, 331, 108486, 8, 8798, 205, 181);
INSERT INTO public.who_global_data VALUES (48387, 0, 203, 0, 1, 205, 53);
INSERT INTO public.who_global_data VALUES (48388, 41, 4362, 0, 53, 205, 164);
INSERT INTO public.who_global_data VALUES (48389, 1, 885, 0, 75, 205, 140);
INSERT INTO public.who_global_data VALUES (48390, 1712, 321205, 117, 7186, 205, 20);
INSERT INTO public.who_global_data VALUES (48391, 20, 85697, 2, 4651, 205, 112);
INSERT INTO public.who_global_data VALUES (48392, 5621, 159898, 170, 5625, 205, 111);
INSERT INTO public.who_global_data VALUES (48393, 0, 321, 0, 7, 205, 71);
INSERT INTO public.who_global_data VALUES (48394, 0, 2358, 0, 48, 205, 218);
INSERT INTO public.who_global_data VALUES (48395, 0, 0, 0, 0, 205, 43);
INSERT INTO public.who_global_data VALUES (48396, 446, 8482, 5, 36, 205, 49);
INSERT INTO public.who_global_data VALUES (48397, 0, 13037, 0, 87, 205, 1);
INSERT INTO public.who_global_data VALUES (48398, 126, 3953, 0, 119, 205, 48);
INSERT INTO public.who_global_data VALUES (48399, 6, 2438, 0, 87, 205, 232);
INSERT INTO public.who_global_data VALUES (48400, 0, 26, 0, 1, 205, 175);
INSERT INTO public.who_global_data VALUES (48401, 1, 1023, 0, 19, 205, 21);
INSERT INTO public.who_global_data VALUES (48402, 134, 13475, 0, 355, 205, 156);
INSERT INTO public.who_global_data VALUES (48403, 0, 0, 0, 0, 205, 95);
INSERT INTO public.who_global_data VALUES (48404, 28, 8162, 2, 191, 205, 177);
INSERT INTO public.who_global_data VALUES (48405, 31, 13092, 0, 610, 205, 210);
INSERT INTO public.who_global_data VALUES (48406, 6, 4985, 0, 56, 205, 120);
INSERT INTO public.who_global_data VALUES (48407, 0, 18, 0, 0, 205, 135);
INSERT INTO public.who_global_data VALUES (48408, 1366, 47671, 19, 929, 205, 206);
INSERT INTO public.who_global_data VALUES (48409, 759, 70329, 28, 5158, 205, 189);
INSERT INTO public.who_global_data VALUES (48410, 913, 84843, 59, 4067, 205, 129);
INSERT INTO public.who_global_data VALUES (48411, 342, 10645, 8, 286, 205, 121);
INSERT INTO public.who_global_data VALUES (48412, 0, 1043, 0, 12, 205, 59);
INSERT INTO public.who_global_data VALUES (48413, 0, 232, 0, 0, 205, 96);
INSERT INTO public.who_global_data VALUES (48414, 1, 2016, 0, 63, 205, 41);
INSERT INTO public.who_global_data VALUES (48415, 55, 1489, 0, 20, 205, 216);
INSERT INTO public.who_global_data VALUES (48416, 294, 8475, 2, 148, 205, 236);
INSERT INTO public.who_global_data VALUES (48417, 0, 13, 0, 0, 205, 150);
INSERT INTO public.who_global_data VALUES (48418, 0, 188, 0, 0, 205, 61);
INSERT INTO public.who_global_data VALUES (48419, 0, 26, 0, 0, 205, 7);
INSERT INTO public.who_global_data VALUES (48420, 0, 7293, 0, 328, 205, 169);
INSERT INTO public.who_global_data VALUES (48421, 767, 163157, 87, 30015, 205, 28);
INSERT INTO public.who_global_data VALUES (48422, 70, 6299, 2, 33, 205, 85);
INSERT INTO public.who_global_data VALUES (48423, 0, 62, 0, 0, 205, 211);
INSERT INTO public.who_global_data VALUES (48424, 0, 5942, 0, 46, 205, 60);
INSERT INTO public.who_global_data VALUES (48425, 0, 64, 0, 3, 205, 3);
INSERT INTO public.who_global_data VALUES (48426, 3, 1006, 0, 15, 205, 11);
INSERT INTO public.who_global_data VALUES (48427, 534, 200260, 7, 9078, 205, 89);
INSERT INTO public.who_global_data VALUES (48428, 442, 25430, 0, 139, 205, 24);
INSERT INTO public.who_global_data VALUES (48429, 0, 180, 0, 0, 205, 162);
INSERT INTO public.who_global_data VALUES (48430, 27, 3910, 0, 193, 205, 100);
INSERT INTO public.who_global_data VALUES (48431, 0, 13, 0, 0, 205, 47);
INSERT INTO public.who_global_data VALUES (48432, 0, 23, 0, 0, 205, 29);
INSERT INTO public.who_global_data VALUES (48433, 0, 190, 0, 14, 205, 40);
INSERT INTO public.who_global_data VALUES (48434, 1, 306, 0, 5, 205, 222);
INSERT INTO public.who_global_data VALUES (48435, 1130, 30872, 58, 1302, 205, 132);
INSERT INTO public.who_global_data VALUES (48436, 0, 252, 0, 13, 205, 130);
INSERT INTO public.who_global_data VALUES (48437, 76, 6276, 0, 38, 205, 234);
INSERT INTO public.who_global_data VALUES (48438, 25, 1927, 0, 26, 205, 23);
INSERT INTO public.who_global_data VALUES (48439, 8, 308, 1, 18, 205, 192);
INSERT INTO public.who_global_data VALUES (48440, 104, 6831, 2, 143, 205, 69);
INSERT INTO public.who_global_data VALUES (48441, 0, 12, 0, 0, 205, 187);
INSERT INTO public.who_global_data VALUES (48442, 527, 29106, 18, 807, 205, 230);
INSERT INTO public.who_global_data VALUES (48443, 0, 4263, 0, 595, 205, 77);
INSERT INTO public.who_global_data VALUES (48444, 0, 1835, 0, 10, 205, 9);
INSERT INTO public.who_global_data VALUES (48445, 32695, 968876, 606, 24915, 205, 74);
INSERT INTO public.who_global_data VALUES (48446, 1522, 80094, 87, 3797, 205, 224);
INSERT INTO public.who_global_data VALUES (48447, 2388, 264561, 199, 13410, 205, 199);
INSERT INTO public.who_global_data VALUES (48448, 2110, 83867, 87, 3432, 205, 190);
INSERT INTO public.who_global_data VALUES (48449, 13, 25683, 2, 1748, 205, 12);
INSERT INTO public.who_global_data VALUES (48450, 0, 336, 0, 24, 205, 104);
INSERT INTO public.who_global_data VALUES (48451, 1604, 42673, 7, 391, 205, 153);
INSERT INTO public.who_global_data VALUES (48452, 162, 243506, 13, 34997, 205, 91);
INSERT INTO public.who_global_data VALUES (48453, 3, 762, 0, 10, 205, 215);
INSERT INTO public.who_global_data VALUES (48454, 382, 22890, 1, 985, 205, 84);
INSERT INTO public.who_global_data VALUES (48455, 0, 329, 0, 31, 205, 231);
INSERT INTO public.who_global_data VALUES (48456, 3, 1113, 0, 10, 205, 196);
INSERT INTO public.who_global_data VALUES (48457, 1707, 66895, 0, 375, 205, 105);
INSERT INTO public.who_global_data VALUES (48458, 461, 11252, 7, 209, 205, 122);
INSERT INTO public.who_global_data VALUES (48459, 0, 0, 0, 0, 205, 159);
INSERT INTO public.who_global_data VALUES (48460, 119, 5194, 4, 102, 205, 75);
INSERT INTO public.who_global_data VALUES (48461, 703, 56877, 3, 399, 205, 27);
INSERT INTO public.who_global_data VALUES (48462, 521, 12498, 7, 167, 205, 54);
INSERT INTO public.who_global_data VALUES (48463, 0, 19, 0, 0, 205, 226);
INSERT INTO public.who_global_data VALUES (48464, 0, 1178, 0, 31, 205, 79);
INSERT INTO public.who_global_data VALUES (48465, 91, 2542, 1, 38, 205, 56);
INSERT INTO public.who_global_data VALUES (48466, 0, 256, 0, 3, 205, 117);
INSERT INTO public.who_global_data VALUES (48467, 18, 1056, 15, 66, 205, 152);
INSERT INTO public.who_global_data VALUES (48468, 26, 1589, 1, 43, 205, 16);
INSERT INTO public.who_global_data VALUES (48469, 0, 85, 0, 1, 205, 10);
INSERT INTO public.who_global_data VALUES (48470, 6, 1897, 0, 79, 205, 201);
INSERT INTO public.who_global_data VALUES (48471, 0, 5056, 0, 111, 205, 174);
INSERT INTO public.who_global_data VALUES (48472, 262, 5605, 4, 43, 205, 119);
INSERT INTO public.who_global_data VALUES (48473, 117, 2614, 3, 43, 205, 168);
INSERT INTO public.who_global_data VALUES (48474, 5, 8734, 0, 122, 205, 99);
INSERT INTO public.who_global_data VALUES (48475, 30, 2831, 0, 14, 205, 171);
INSERT INTO public.who_global_data VALUES (48476, 10, 2433, 0, 121, 205, 87);
INSERT INTO public.who_global_data VALUES (48477, 0, 673, 0, 9, 205, 123);
INSERT INTO public.who_global_data VALUES (48478, 0, 0, 0, 0, 205, 151);
INSERT INTO public.who_global_data VALUES (48479, 0, 255, 0, 15, 205, 213);
INSERT INTO public.who_global_data VALUES (48480, 72, 5518, 0, 149, 205, 118);
INSERT INTO public.who_global_data VALUES (48481, 0, 343, 0, 10, 205, 134);
INSERT INTO public.who_global_data VALUES (48482, 19, 2743, 0, 37, 205, 65);
INSERT INTO public.who_global_data VALUES (48483, 7051, 311486, 836, 36327, 205, 102);
INSERT INTO public.who_global_data VALUES (48484, 0, 0, 0, 0, 205, 223);
INSERT INTO public.who_global_data VALUES (48485, 0, 79, 0, 1, 205, 4);
INSERT INTO public.who_global_data VALUES (48486, 18, 261, 0, 0, 205, 146);
INSERT INTO public.who_global_data VALUES (48487, 59, 1997, 1, 26, 205, 31);
INSERT INTO public.who_global_data VALUES (48488, 0, 12, 0, 1, 205, 127);
INSERT INTO public.who_global_data VALUES (48489, 165, 16262, 2, 259, 205, 22);
INSERT INTO public.who_global_data VALUES (48490, 62, 1330, 0, 9, 205, 115);
INSERT INTO public.who_global_data VALUES (48491, 0, 337, 0, 6, 205, 106);
INSERT INTO public.who_global_data VALUES (48492, 96, 960, 0, 2, 205, 90);
INSERT INTO public.who_global_data VALUES (48493, 0, 0, 0, 0, 205, 70);
INSERT INTO public.who_global_data VALUES (48494, 116, 17177, 1, 39, 205, 46);
INSERT INTO public.who_global_data VALUES (48495, 109, 51124, 2, 6128, 205, 139);
INSERT INTO public.who_global_data VALUES (48496, 0, 22, 0, 0, 205, 42);
INSERT INTO public.who_global_data VALUES (48497, 1, 1198, 0, 22, 205, 80);
INSERT INTO public.who_global_data VALUES (48498, 0, 2712, 0, 99, 205, 203);
INSERT INTO public.who_global_data VALUES (48499, 0, 1099, 0, 68, 205, 136);
INSERT INTO public.who_global_data VALUES (48500, 643, 34259, 6, 760, 205, 63);
INSERT INTO public.who_global_data VALUES (48501, 0, 0, 0, 0, 205, 17);
INSERT INTO public.who_global_data VALUES (48502, 0, 36, 0, 2, 205, 172);
INSERT INTO public.who_global_data VALUES (48503, 191, 8522, 4, 393, 205, 109);
INSERT INTO public.who_global_data VALUES (48504, 17, 9001, 0, 253, 205, 200);
INSERT INTO public.who_global_data VALUES (48505, 419, 8153, 0, 47, 205, 93);
INSERT INTO public.who_global_data VALUES (48506, 1679, 61247, 8, 281, 205, 5);
INSERT INTO public.who_global_data VALUES (48507, 0, 741, 0, 13, 205, 214);
INSERT INTO public.who_global_data VALUES (48508, 2145, 257914, 40, 5426, 205, 204);
INSERT INTO public.who_global_data VALUES (48509, 0, 0, 0, 0, 205, 198);
INSERT INTO public.who_global_data VALUES (48510, 923, 48096, 28, 960, 205, 173);
INSERT INTO public.who_global_data VALUES (48511, 0, 11, 0, 0, 205, 229);
INSERT INTO public.who_global_data VALUES (48512, 94, 3074, 0, 25, 205, 76);
INSERT INTO public.who_global_data VALUES (48513, 3744, 333867, 175, 12229, 205, 138);
INSERT INTO public.who_global_data VALUES (48514, 1305, 58850, 11, 1614, 205, 98);
INSERT INTO public.who_global_data VALUES (48515, 0, 0, 0, 0, 205, 103);
INSERT INTO public.who_global_data VALUES (48516, 323, 38780, 6, 1594, 205, 225);
INSERT INTO public.who_global_data VALUES (48517, 375, 47426, 8, 1676, 205, 131);
INSERT INTO public.who_global_data VALUES (48518, 256, 10379, 2, 171, 205, 235);
INSERT INTO public.who_global_data VALUES (48519, 450, 104983, 1, 151, 205, 137);
INSERT INTO public.who_global_data VALUES (48520, 61, 13612, 2, 291, 205, 81);
INSERT INTO public.who_global_data VALUES (48521, 332, 20040, 4, 662, 205, 182);
INSERT INTO public.who_global_data VALUES (48522, 9, 608, 0, 3, 205, 145);
INSERT INTO public.who_global_data VALUES (48523, 641, 34226, 21, 1952, 205, 26);
INSERT INTO public.who_global_data VALUES (48524, 6428, 752797, 167, 11937, 205, 170);
INSERT INTO public.who_global_data VALUES (48525, 19, 1435, 0, 4, 205, 191);
INSERT INTO public.who_global_data VALUES (48526, 0, 3, 0, 0, 205, 221);
INSERT INTO public.who_global_data VALUES (48527, 0, 6, 0, 0, 205, 64);
INSERT INTO public.who_global_data VALUES (48528, 0, 0, 0, 0, 205, 116);
INSERT INTO public.who_global_data VALUES (48529, 0, 17, 0, 0, 205, 128);
INSERT INTO public.who_global_data VALUES (48530, 1, 23, 0, 0, 205, 6);
INSERT INTO public.who_global_data VALUES (48531, 0, 44, 0, 3, 205, 227);
INSERT INTO public.who_global_data VALUES (48532, 0, 2, 0, 0, 205, 68);
INSERT INTO public.who_global_data VALUES (48533, 0, 35, 0, 0, 205, 184);
INSERT INTO public.who_global_data VALUES (48534, 0, 0, 0, 0, 205, 82);
INSERT INTO public.who_global_data VALUES (48535, 0, 716, 0, 42, 205, 149);
INSERT INTO public.who_global_data VALUES (48536, 1, 417, 0, 12, 205, 197);
INSERT INTO public.who_global_data VALUES (48537, 2671, 240474, 42, 2325, 205, 78);
INSERT INTO public.who_global_data VALUES (48538, 126, 8369, 3, 153, 205, 233);
INSERT INTO public.who_global_data VALUES (48539, 351, 19334, 11, 429, 205, 133);
INSERT INTO public.who_global_data VALUES (48540, 8, 108, 0, 0, 205, 35);
INSERT INTO public.who_global_data VALUES (48541, 17, 1668, 0, 64, 205, 114);
INSERT INTO public.who_global_data VALUES (48542, 249, 46879, 0, 27, 205, 237);
INSERT INTO public.who_global_data VALUES (48543, 0, 2, 0, 0, 205, 55);
INSERT INTO public.who_global_data VALUES (48544, 1, 79, 0, 15, 205, 176);
INSERT INTO public.who_global_data VALUES (48545, 19, 1927, 0, 28, 205, 202);
INSERT INTO public.who_global_data VALUES (48546, 19, 1898, 0, 114, 205, 155);
INSERT INTO public.who_global_data VALUES (48547, 0, 0, 0, 0, 205, 32);
INSERT INTO public.who_global_data VALUES (48548, 7, 3083, 0, 93, 205, 220);
INSERT INTO public.who_global_data VALUES (48549, 12757, 311049, 107, 4453, 205, 30);
INSERT INTO public.who_global_data VALUES (48550, 18, 2171, 0, 41, 205, 147);
INSERT INTO public.who_global_data VALUES (48551, 1346, 267958, 2, 29796, 205, 208);
INSERT INTO public.who_global_data VALUES (48552, 9, 2674, 0, 11, 205, 45);
INSERT INTO public.who_global_data VALUES (48553, 110, 10527, 9, 668, 205, 110);
INSERT INTO public.who_global_data VALUES (48554, 21, 801, 0, 18, 205, 88);
INSERT INTO public.who_global_data VALUES (48555, 312, 73270, 8, 5680, 205, 51);
INSERT INTO public.who_global_data VALUES (48556, 123, 33300, 1, 1728, 205, 209);
INSERT INTO public.who_global_data VALUES (48557, 19, 458, 1, 22, 205, 205);
INSERT INTO public.who_global_data VALUES (48558, 52, 6695, 0, 56, 205, 18);
INSERT INTO public.who_global_data VALUES (48559, 4, 3236, 0, 58, 205, 72);
INSERT INTO public.who_global_data VALUES (48560, 685, 293168, 26, 40925, 205, 44);
INSERT INTO public.who_global_data VALUES (48561, 0, 24, 0, 0, 205, 15);
INSERT INTO public.who_global_data VALUES (48562, 9, 740, 0, 15, 205, 25);
INSERT INTO public.who_global_data VALUES (48563, 0, 0, 0, 0, 205, 179);
INSERT INTO public.who_global_data VALUES (48564, 0, 0, 0, 0, 205, 34);
INSERT INTO public.who_global_data VALUES (48565, 0, 133, 0, 8, 205, 207);
INSERT INTO public.who_global_data VALUES (48566, 8, 1327, 0, 50, 205, 166);
INSERT INTO public.who_global_data VALUES (48567, 947, 215940, 17, 5419, 205, 126);
INSERT INTO public.who_global_data VALUES (48568, 0, 0, 0, 0, 205, 97);
INSERT INTO public.who_global_data VALUES (48569, 0, 72, 0, 2, 205, 36);
INSERT INTO public.who_global_data VALUES (48570, 0, 0, 0, 0, 205, 125);
INSERT INTO public.who_global_data VALUES (48571, 3, 1043, 0, 0, 205, 124);
INSERT INTO public.who_global_data VALUES (48572, 848, 56455, 18, 1445, 205, 185);
INSERT INTO public.who_global_data VALUES (48573, 275, 55848, 0, 335, 205, 194);
INSERT INTO public.who_global_data VALUES (48574, 0, 509, 0, 21, 205, 144);
INSERT INTO public.who_global_data VALUES (48575, 60711, 3405494, 754, 135807, 205, 19);
INSERT INTO public.who_global_data VALUES (48576, 37, 243, 0, 6, 205, 217);
INSERT INTO public.who_global_data VALUES (48577, 8, 997, 0, 31, 205, 148);
INSERT INTO public.who_global_data VALUES (48578, 494, 14787, 4, 72, 205, 86);
INSERT INTO public.who_global_data VALUES (48579, 0, 0, 0, 0, 205, 13);
INSERT INTO public.who_global_data VALUES (48580, 303, 10010, 3, 96, 205, 157);
INSERT INTO public.who_global_data VALUES (48581, 8, 381, 0, 0, 205, 8);
INSERT INTO public.who_global_data VALUES (48582, 0, 0, 0, 0, 205, 73);
INSERT INTO public.who_global_data VALUES (48583, 10, 1530, 4, 434, 205, 101);
INSERT INTO public.who_global_data VALUES (48584, 0, 2283, 0, 82, 205, 165);
INSERT INTO public.who_global_data VALUES (48585, 25, 1089, 0, 20, 205, 14);
INSERT INTO public.who_global_data VALUES (48586, 200, 35026, 49, 1098, 206, 193);
INSERT INTO public.who_global_data VALUES (48587, 85, 3752, 4, 101, 206, 113);
INSERT INTO public.who_global_data VALUES (48588, 527, 20216, 10, 1028, 206, 143);
INSERT INTO public.who_global_data VALUES (48589, 0, 0, 0, 0, 206, 219);
INSERT INTO public.who_global_data VALUES (48590, 3, 861, 0, 52, 206, 186);
INSERT INTO public.who_global_data VALUES (48591, 16, 541, 0, 26, 206, 52);
INSERT INTO public.who_global_data VALUES (48592, 0, 3, 0, 0, 206, 180);
INSERT INTO public.who_global_data VALUES (48593, 0, 74, 0, 3, 206, 167);
INSERT INTO public.who_global_data VALUES (48594, 3099, 103265, 67, 1926, 206, 154);
INSERT INTO public.who_global_data VALUES (48595, 515, 32318, 11, 587, 206, 94);
INSERT INTO public.who_global_data VALUES (48596, 0, 105, 0, 3, 206, 66);
INSERT INTO public.who_global_data VALUES (48597, 271, 10251, 0, 108, 206, 58);
INSERT INTO public.who_global_data VALUES (48598, 201, 19060, 1, 709, 206, 163);
INSERT INTO public.who_global_data VALUES (48599, 543, 25113, 6, 319, 206, 37);
INSERT INTO public.who_global_data VALUES (48600, 2, 113, 0, 11, 206, 142);
INSERT INTO public.who_global_data VALUES (48601, 602, 34078, 2, 111, 206, 83);
INSERT INTO public.who_global_data VALUES (48602, 3163, 190057, 33, 2424, 206, 228);
INSERT INTO public.who_global_data VALUES (48603, 0, 103, 0, 7, 206, 188);
INSERT INTO public.who_global_data VALUES (48604, 155, 65269, 6, 474, 206, 62);
INSERT INTO public.who_global_data VALUES (48605, 207, 63629, 3, 9658, 206, 160);
INSERT INTO public.who_global_data VALUES (48606, 0, 37, 0, 2, 206, 50);
INSERT INTO public.who_global_data VALUES (48607, 85, 1463, 2, 28, 206, 33);
INSERT INTO public.who_global_data VALUES (48608, 0, 150, 0, 9, 206, 183);
INSERT INTO public.who_global_data VALUES (48609, 0, 84, 0, 0, 206, 92);
INSERT INTO public.who_global_data VALUES (48610, 1063, 49250, 59, 1866, 206, 158);
INSERT INTO public.who_global_data VALUES (48611, 0, 4, 0, 0, 206, 67);
INSERT INTO public.who_global_data VALUES (48612, 197, 7176, 5, 229, 206, 57);
INSERT INTO public.who_global_data VALUES (48613, 0, 399, 0, 1, 206, 38);
INSERT INTO public.who_global_data VALUES (48614, 20286, 1884967, 733, 72833, 206, 141);
INSERT INTO public.who_global_data VALUES (48615, 0, 8, 0, 1, 206, 178);
INSERT INTO public.who_global_data VALUES (48616, 0, 141, 0, 3, 206, 108);
INSERT INTO public.who_global_data VALUES (48617, 234, 7645, 7, 283, 206, 39);
INSERT INTO public.who_global_data VALUES (48618, 1, 1037, 0, 53, 206, 2);
INSERT INTO public.who_global_data VALUES (48619, 0, 269, 0, 1, 206, 195);
INSERT INTO public.who_global_data VALUES (48620, 58, 1780, 0, 19, 206, 107);
INSERT INTO public.who_global_data VALUES (48621, 0, 165, 0, 0, 206, 161);
INSERT INTO public.who_global_data VALUES (48622, 0, 15173, 0, 359, 206, 212);
INSERT INTO public.who_global_data VALUES (48623, 565, 108155, 7, 8790, 206, 181);
INSERT INTO public.who_global_data VALUES (48624, 2, 203, 0, 1, 206, 53);
INSERT INTO public.who_global_data VALUES (48625, 0, 4321, 0, 53, 206, 164);
INSERT INTO public.who_global_data VALUES (48626, 4, 884, 0, 75, 206, 140);
INSERT INTO public.who_global_data VALUES (48627, 1836, 319493, 45, 7069, 206, 20);
INSERT INTO public.who_global_data VALUES (48628, 54, 85677, 0, 4649, 206, 112);
INSERT INTO public.who_global_data VALUES (48629, 3832, 154277, 148, 5455, 206, 111);
INSERT INTO public.who_global_data VALUES (48630, 4, 321, 0, 7, 206, 71);
INSERT INTO public.who_global_data VALUES (48631, 136, 2358, 1, 48, 206, 218);
INSERT INTO public.who_global_data VALUES (48632, 0, 0, 0, 0, 206, 43);
INSERT INTO public.who_global_data VALUES (48633, 440, 8036, 1, 31, 206, 49);
INSERT INTO public.who_global_data VALUES (48634, 165, 13037, 3, 87, 206, 1);
INSERT INTO public.who_global_data VALUES (48635, 52, 3827, 0, 119, 206, 48);
INSERT INTO public.who_global_data VALUES (48636, 4, 2432, 0, 87, 206, 232);
INSERT INTO public.who_global_data VALUES (48637, 0, 26, 0, 1, 206, 175);
INSERT INTO public.who_global_data VALUES (48638, 0, 1022, 0, 19, 206, 21);
INSERT INTO public.who_global_data VALUES (48639, 103, 13341, 2, 355, 206, 156);
INSERT INTO public.who_global_data VALUES (48640, 0, 0, 0, 0, 206, 95);
INSERT INTO public.who_global_data VALUES (48641, 60, 8134, 0, 189, 206, 177);
INSERT INTO public.who_global_data VALUES (48642, 24, 13061, 0, 610, 206, 210);
INSERT INTO public.who_global_data VALUES (48643, 2, 4979, 0, 56, 206, 120);
INSERT INTO public.who_global_data VALUES (48644, 0, 18, 0, 0, 206, 135);
INSERT INTO public.who_global_data VALUES (48645, 799, 46305, 7, 910, 206, 206);
INSERT INTO public.who_global_data VALUES (48646, 1111, 69570, 67, 5130, 206, 189);
INSERT INTO public.who_global_data VALUES (48647, 929, 83930, 73, 4008, 206, 129);
INSERT INTO public.who_global_data VALUES (48648, 325, 10303, 11, 278, 206, 121);
INSERT INTO public.who_global_data VALUES (48649, 0, 1043, 0, 12, 206, 59);
INSERT INTO public.who_global_data VALUES (48650, 0, 232, 0, 0, 206, 96);
INSERT INTO public.who_global_data VALUES (48651, 1, 2015, 0, 63, 206, 41);
INSERT INTO public.who_global_data VALUES (48652, 45, 1434, 0, 20, 206, 216);
INSERT INTO public.who_global_data VALUES (48653, 212, 8181, 7, 146, 206, 236);
INSERT INTO public.who_global_data VALUES (48654, 0, 13, 0, 0, 206, 150);
INSERT INTO public.who_global_data VALUES (48655, 0, 188, 0, 0, 206, 61);
INSERT INTO public.who_global_data VALUES (48656, 0, 26, 0, 0, 206, 7);
INSERT INTO public.who_global_data VALUES (48657, 0, 7293, 0, 328, 206, 169);
INSERT INTO public.who_global_data VALUES (48658, 0, 162390, 0, 29928, 206, 28);
INSERT INTO public.who_global_data VALUES (48659, 59, 6229, 2, 31, 206, 85);
INSERT INTO public.who_global_data VALUES (48660, 0, 62, 0, 0, 206, 211);
INSERT INTO public.who_global_data VALUES (48661, 0, 5942, 0, 46, 206, 60);
INSERT INTO public.who_global_data VALUES (48662, 0, 64, 0, 3, 206, 3);
INSERT INTO public.who_global_data VALUES (48663, 4, 1003, 0, 15, 206, 11);
INSERT INTO public.who_global_data VALUES (48664, 351, 199726, 3, 9071, 206, 89);
INSERT INTO public.who_global_data VALUES (48665, 0, 24988, 0, 139, 206, 24);
INSERT INTO public.who_global_data VALUES (48666, 0, 180, 0, 0, 206, 162);
INSERT INTO public.who_global_data VALUES (48667, 57, 3883, 0, 193, 206, 100);
INSERT INTO public.who_global_data VALUES (48668, 0, 13, 0, 0, 206, 47);
INSERT INTO public.who_global_data VALUES (48669, 0, 23, 0, 0, 206, 29);
INSERT INTO public.who_global_data VALUES (48670, 0, 190, 0, 14, 206, 40);
INSERT INTO public.who_global_data VALUES (48671, 1, 305, 0, 5, 206, 222);
INSERT INTO public.who_global_data VALUES (48672, 387, 29742, 25, 1244, 206, 132);
INSERT INTO public.who_global_data VALUES (48673, 0, 252, 0, 13, 206, 130);
INSERT INTO public.who_global_data VALUES (48674, 30, 6200, 0, 38, 206, 234);
INSERT INTO public.who_global_data VALUES (48675, 0, 1902, 0, 26, 206, 23);
INSERT INTO public.who_global_data VALUES (48676, 3, 300, 0, 17, 206, 192);
INSERT INTO public.who_global_data VALUES (48677, 0, 6727, 2, 141, 206, 69);
INSERT INTO public.who_global_data VALUES (48678, 0, 12, 0, 0, 206, 187);
INSERT INTO public.who_global_data VALUES (48679, 489, 28579, 15, 789, 206, 230);
INSERT INTO public.who_global_data VALUES (48680, 16, 4263, 0, 595, 206, 77);
INSERT INTO public.who_global_data VALUES (48681, 2, 1835, 0, 10, 206, 9);
INSERT INTO public.who_global_data VALUES (48682, 29429, 936181, 582, 24309, 206, 74);
INSERT INTO public.who_global_data VALUES (48683, 1591, 78572, 54, 3710, 206, 224);
INSERT INTO public.who_global_data VALUES (48684, 2521, 262173, 179, 13211, 206, 199);
INSERT INTO public.who_global_data VALUES (48685, 2022, 81757, 95, 3345, 206, 190);
INSERT INTO public.who_global_data VALUES (48686, 32, 25670, 0, 1746, 206, 12);
INSERT INTO public.who_global_data VALUES (48687, 0, 336, 0, 24, 206, 104);
INSERT INTO public.who_global_data VALUES (48688, 1720, 41069, 4, 384, 206, 153);
INSERT INTO public.who_global_data VALUES (48689, 114, 243344, 17, 34984, 206, 91);
INSERT INTO public.who_global_data VALUES (48690, 1, 759, 0, 10, 206, 215);
INSERT INTO public.who_global_data VALUES (48691, 288, 22508, 2, 984, 206, 84);
INSERT INTO public.who_global_data VALUES (48692, 0, 329, 0, 31, 206, 231);
INSERT INTO public.who_global_data VALUES (48693, 15, 1110, 0, 10, 206, 196);
INSERT INTO public.who_global_data VALUES (48694, 1674, 65188, 0, 375, 206, 105);
INSERT INTO public.who_global_data VALUES (48695, 497, 10791, 5, 202, 206, 122);
INSERT INTO public.who_global_data VALUES (48696, 0, 0, 0, 0, 206, 159);
INSERT INTO public.who_global_data VALUES (48697, 0, 5075, 0, 98, 206, 75);
INSERT INTO public.who_global_data VALUES (48698, 666, 56174, 3, 396, 206, 27);
INSERT INTO public.who_global_data VALUES (48699, 439, 11977, 11, 160, 206, 54);
INSERT INTO public.who_global_data VALUES (48700, 0, 19, 0, 0, 206, 226);
INSERT INTO public.who_global_data VALUES (48701, 4, 1178, 0, 31, 206, 79);
INSERT INTO public.who_global_data VALUES (48702, 32, 2451, 1, 37, 206, 56);
INSERT INTO public.who_global_data VALUES (48703, 11, 256, 0, 3, 206, 117);
INSERT INTO public.who_global_data VALUES (48704, 14, 1038, 0, 51, 206, 152);
INSERT INTO public.who_global_data VALUES (48705, 51, 1563, 2, 42, 206, 16);
INSERT INTO public.who_global_data VALUES (48706, 0, 85, 0, 1, 206, 10);
INSERT INTO public.who_global_data VALUES (48707, 21, 1891, 0, 79, 206, 201);
INSERT INTO public.who_global_data VALUES (48708, 100, 5056, 0, 111, 206, 174);
INSERT INTO public.who_global_data VALUES (48709, 263, 5343, 2, 39, 206, 119);
INSERT INTO public.who_global_data VALUES (48710, 67, 2497, 1, 40, 206, 168);
INSERT INTO public.who_global_data VALUES (48711, 4, 8729, 0, 122, 206, 99);
INSERT INTO public.who_global_data VALUES (48712, 39, 2801, 1, 14, 206, 171);
INSERT INTO public.who_global_data VALUES (48713, 11, 2423, 0, 121, 206, 87);
INSERT INTO public.who_global_data VALUES (48714, 0, 673, 0, 9, 206, 123);
INSERT INTO public.who_global_data VALUES (48715, 0, 0, 0, 0, 206, 151);
INSERT INTO public.who_global_data VALUES (48716, 0, 255, 0, 15, 206, 213);
INSERT INTO public.who_global_data VALUES (48717, 91, 5446, 2, 149, 206, 118);
INSERT INTO public.who_global_data VALUES (48718, 0, 343, 0, 10, 206, 134);
INSERT INTO public.who_global_data VALUES (48719, 0, 2724, 0, 37, 206, 65);
INSERT INTO public.who_global_data VALUES (48720, 4685, 304435, 485, 35491, 206, 102);
INSERT INTO public.who_global_data VALUES (48721, 0, 0, 0, 0, 206, 223);
INSERT INTO public.who_global_data VALUES (48722, 0, 79, 0, 1, 206, 4);
INSERT INTO public.who_global_data VALUES (48723, 13, 243, 0, 0, 206, 146);
INSERT INTO public.who_global_data VALUES (48724, 70, 1938, 0, 25, 206, 31);
INSERT INTO public.who_global_data VALUES (48725, 0, 12, 0, 1, 206, 127);
INSERT INTO public.who_global_data VALUES (48726, 161, 16097, 2, 257, 206, 22);
INSERT INTO public.who_global_data VALUES (48727, 49, 1268, 0, 9, 206, 115);
INSERT INTO public.who_global_data VALUES (48728, 1, 337, 0, 6, 206, 106);
INSERT INTO public.who_global_data VALUES (48729, 3, 864, 1, 2, 206, 90);
INSERT INTO public.who_global_data VALUES (48730, 0, 0, 0, 0, 206, 70);
INSERT INTO public.who_global_data VALUES (48731, 116, 17061, 0, 38, 206, 46);
INSERT INTO public.who_global_data VALUES (48732, 98, 51015, 10, 6126, 206, 139);
INSERT INTO public.who_global_data VALUES (48733, 1, 22, 0, 0, 206, 42);
INSERT INTO public.who_global_data VALUES (48734, 2, 1197, 0, 22, 206, 80);
INSERT INTO public.who_global_data VALUES (48735, 301, 2712, 8, 99, 206, 203);
INSERT INTO public.who_global_data VALUES (48736, 0, 1099, 0, 68, 206, 136);
INSERT INTO public.who_global_data VALUES (48737, 463, 33616, 10, 754, 206, 63);
INSERT INTO public.who_global_data VALUES (48738, 0, 0, 0, 0, 206, 17);
INSERT INTO public.who_global_data VALUES (48739, 3, 36, 0, 2, 206, 172);
INSERT INTO public.who_global_data VALUES (48740, 134, 8331, 4, 389, 206, 109);
INSERT INTO public.who_global_data VALUES (48741, 3, 8984, 0, 253, 206, 200);
INSERT INTO public.who_global_data VALUES (48742, 293, 7734, 6, 47, 206, 93);
INSERT INTO public.who_global_data VALUES (48743, 1389, 59568, 14, 273, 206, 5);
INSERT INTO public.who_global_data VALUES (48744, 0, 741, 0, 13, 206, 214);
INSERT INTO public.who_global_data VALUES (48745, 2165, 255769, 67, 5386, 206, 204);
INSERT INTO public.who_global_data VALUES (48746, 0, 0, 0, 0, 206, 198);
INSERT INTO public.who_global_data VALUES (48747, 1540, 47173, 23, 932, 206, 173);
INSERT INTO public.who_global_data VALUES (48748, 0, 11, 0, 0, 206, 229);
INSERT INTO public.who_global_data VALUES (48749, 0, 2980, 0, 25, 206, 76);
INSERT INTO public.who_global_data VALUES (48750, 3797, 330123, 184, 12054, 206, 138);
INSERT INTO public.who_global_data VALUES (48751, 539, 57545, 4, 1603, 206, 98);
INSERT INTO public.who_global_data VALUES (48752, 0, 0, 0, 0, 206, 103);
INSERT INTO public.who_global_data VALUES (48753, 267, 38457, 12, 1588, 206, 225);
INSERT INTO public.who_global_data VALUES (48754, 233, 47051, 6, 1668, 206, 131);
INSERT INTO public.who_global_data VALUES (48755, 113, 10123, 2, 169, 206, 235);
INSERT INTO public.who_global_data VALUES (48756, 517, 104533, 1, 150, 206, 137);
INSERT INTO public.who_global_data VALUES (48757, 39, 13551, 0, 289, 206, 81);
INSERT INTO public.who_global_data VALUES (48758, 269, 19708, 6, 658, 206, 182);
INSERT INTO public.who_global_data VALUES (48759, 3, 599, 0, 3, 206, 145);
INSERT INTO public.who_global_data VALUES (48760, 637, 33585, 30, 1931, 206, 26);
INSERT INTO public.who_global_data VALUES (48761, 6422, 746369, 156, 11770, 206, 170);
INSERT INTO public.who_global_data VALUES (48762, 38, 1416, 0, 4, 206, 191);
INSERT INTO public.who_global_data VALUES (48763, 0, 3, 0, 0, 206, 221);
INSERT INTO public.who_global_data VALUES (48764, 0, 6, 0, 0, 206, 64);
INSERT INTO public.who_global_data VALUES (48765, 0, 0, 0, 0, 206, 116);
INSERT INTO public.who_global_data VALUES (48766, 0, 17, 0, 0, 206, 128);
INSERT INTO public.who_global_data VALUES (48767, 0, 22, 0, 0, 206, 6);
INSERT INTO public.who_global_data VALUES (48768, 0, 44, 0, 3, 206, 227);
INSERT INTO public.who_global_data VALUES (48769, 0, 2, 0, 0, 206, 68);
INSERT INTO public.who_global_data VALUES (48770, 0, 35, 0, 0, 206, 184);
INSERT INTO public.who_global_data VALUES (48771, 0, 0, 0, 0, 206, 82);
INSERT INTO public.who_global_data VALUES (48772, 0, 716, 0, 42, 206, 149);
INSERT INTO public.who_global_data VALUES (48773, 4, 416, 0, 12, 206, 197);
INSERT INTO public.who_global_data VALUES (48774, 2692, 237803, 40, 2283, 206, 78);
INSERT INTO public.who_global_data VALUES (48775, 45, 8243, 0, 150, 206, 233);
INSERT INTO public.who_global_data VALUES (48776, 344, 18983, 13, 418, 206, 133);
INSERT INTO public.who_global_data VALUES (48777, 0, 100, 0, 0, 206, 35);
INSERT INTO public.who_global_data VALUES (48778, 9, 1651, 1, 64, 206, 114);
INSERT INTO public.who_global_data VALUES (48779, 347, 46630, 1, 27, 206, 237);
INSERT INTO public.who_global_data VALUES (48780, 0, 2, 0, 0, 206, 55);
INSERT INTO public.who_global_data VALUES (48781, 0, 78, 0, 15, 206, 176);
INSERT INTO public.who_global_data VALUES (48782, 6, 1908, 0, 28, 206, 202);
INSERT INTO public.who_global_data VALUES (48783, 19, 1879, 0, 114, 206, 155);
INSERT INTO public.who_global_data VALUES (48784, 0, 0, 0, 0, 206, 32);
INSERT INTO public.who_global_data VALUES (48785, 4, 3076, 0, 93, 206, 220);
INSERT INTO public.who_global_data VALUES (48786, 10496, 298292, 174, 4346, 206, 30);
INSERT INTO public.who_global_data VALUES (48787, 5, 2153, 0, 41, 206, 147);
INSERT INTO public.who_global_data VALUES (48788, 931, 266612, 1, 29794, 206, 208);
INSERT INTO public.who_global_data VALUES (48789, 19, 2665, 0, 11, 206, 45);
INSERT INTO public.who_global_data VALUES (48790, 101, 10417, 2, 659, 206, 110);
INSERT INTO public.who_global_data VALUES (48791, 18, 780, 0, 18, 206, 88);
INSERT INTO public.who_global_data VALUES (48792, 170, 72958, 12, 5672, 206, 51);
INSERT INTO public.who_global_data VALUES (48793, 129, 33177, 0, 1727, 206, 209);
INSERT INTO public.who_global_data VALUES (48794, 22, 439, 2, 21, 206, 205);
INSERT INTO public.who_global_data VALUES (48795, 48, 6643, 1, 56, 206, 18);
INSERT INTO public.who_global_data VALUES (48796, 5, 3232, 0, 58, 206, 72);
INSERT INTO public.who_global_data VALUES (48797, 726, 292483, 44, 40899, 206, 44);
INSERT INTO public.who_global_data VALUES (48798, 0, 24, 0, 0, 206, 15);
INSERT INTO public.who_global_data VALUES (48799, 11, 731, 0, 15, 206, 25);
INSERT INTO public.who_global_data VALUES (48800, 0, 0, 0, 0, 206, 179);
INSERT INTO public.who_global_data VALUES (48801, 0, 0, 0, 0, 206, 34);
INSERT INTO public.who_global_data VALUES (48802, 0, 133, 0, 8, 206, 207);
INSERT INTO public.who_global_data VALUES (48803, 13, 1319, 0, 50, 206, 166);
INSERT INTO public.who_global_data VALUES (48804, 992, 214993, 20, 5402, 206, 126);
INSERT INTO public.who_global_data VALUES (48805, 0, 0, 0, 0, 206, 97);
INSERT INTO public.who_global_data VALUES (48806, 0, 72, 0, 2, 206, 36);
INSERT INTO public.who_global_data VALUES (48807, 0, 0, 0, 0, 206, 125);
INSERT INTO public.who_global_data VALUES (48808, 11, 1040, 0, 0, 206, 124);
INSERT INTO public.who_global_data VALUES (48809, 836, 55607, 15, 1427, 206, 185);
INSERT INTO public.who_global_data VALUES (48810, 375, 55573, 1, 335, 206, 194);
INSERT INTO public.who_global_data VALUES (48811, 0, 509, 0, 21, 206, 144);
INSERT INTO public.who_global_data VALUES (48812, 58720, 3344783, 349, 135053, 206, 19);
INSERT INTO public.who_global_data VALUES (48813, 0, 206, 0, 6, 206, 217);
INSERT INTO public.who_global_data VALUES (48814, 2, 989, 0, 31, 206, 148);
INSERT INTO public.who_global_data VALUES (48815, 421, 14293, 4, 68, 206, 86);
INSERT INTO public.who_global_data VALUES (48816, 0, 0, 0, 0, 206, 13);
INSERT INTO public.who_global_data VALUES (48817, 242, 9707, 4, 93, 206, 157);
INSERT INTO public.who_global_data VALUES (48818, 1, 373, 0, 0, 206, 8);
INSERT INTO public.who_global_data VALUES (48819, 0, 0, 0, 0, 206, 73);
INSERT INTO public.who_global_data VALUES (48820, 18, 1520, 5, 430, 206, 101);
INSERT INTO public.who_global_data VALUES (48821, 0, 2283, 0, 82, 206, 165);
INSERT INTO public.who_global_data VALUES (48822, 30, 1064, 1, 20, 206, 14);
INSERT INTO public.who_global_data VALUES (48823, 285, 34826, 33, 1049, 207, 193);
INSERT INTO public.who_global_data VALUES (48824, 96, 3667, 2, 97, 207, 113);
INSERT INTO public.who_global_data VALUES (48825, 494, 19689, 7, 1018, 207, 143);
INSERT INTO public.who_global_data VALUES (48826, 0, 0, 0, 0, 207, 219);
INSERT INTO public.who_global_data VALUES (48827, 3, 858, 0, 52, 207, 186);
INSERT INTO public.who_global_data VALUES (48828, 19, 525, 0, 26, 207, 52);
INSERT INTO public.who_global_data VALUES (48829, 0, 3, 0, 0, 207, 180);
INSERT INTO public.who_global_data VALUES (48830, 0, 74, 0, 3, 207, 167);
INSERT INTO public.who_global_data VALUES (48831, 2657, 100166, 41, 1859, 207, 154);
INSERT INTO public.who_global_data VALUES (48832, 339, 31803, 8, 576, 207, 94);
INSERT INTO public.who_global_data VALUES (48833, 0, 105, 0, 3, 207, 66);
INSERT INTO public.who_global_data VALUES (48834, 183, 9980, 0, 108, 207, 58);
INSERT INTO public.who_global_data VALUES (48835, 12, 18859, 0, 708, 207, 163);
INSERT INTO public.who_global_data VALUES (48836, 529, 24570, 7, 313, 207, 37);
INSERT INTO public.who_global_data VALUES (48837, 0, 111, 0, 11, 207, 142);
INSERT INTO public.who_global_data VALUES (48838, 535, 33476, 1, 109, 207, 83);
INSERT INTO public.who_global_data VALUES (48839, 3099, 186894, 39, 2391, 207, 228);
INSERT INTO public.who_global_data VALUES (48840, 0, 103, 0, 7, 207, 188);
INSERT INTO public.who_global_data VALUES (48841, 182, 65114, 4, 468, 207, 62);
INSERT INTO public.who_global_data VALUES (48842, 224, 63422, 0, 9655, 207, 160);
INSERT INTO public.who_global_data VALUES (48843, 0, 37, 0, 2, 207, 50);
INSERT INTO public.who_global_data VALUES (48844, 0, 1378, 0, 26, 207, 33);
INSERT INTO public.who_global_data VALUES (48845, 0, 150, 0, 9, 207, 183);
INSERT INTO public.who_global_data VALUES (48846, 0, 84, 0, 0, 207, 92);
INSERT INTO public.who_global_data VALUES (48847, 987, 48187, 53, 1807, 207, 158);
INSERT INTO public.who_global_data VALUES (48848, 2, 4, 0, 0, 207, 67);
INSERT INTO public.who_global_data VALUES (48849, 95, 6979, 4, 224, 207, 57);
INSERT INTO public.who_global_data VALUES (48850, 0, 399, 0, 1, 207, 38);
INSERT INTO public.who_global_data VALUES (48851, 24831, 1864681, 631, 72100, 207, 141);
INSERT INTO public.who_global_data VALUES (48852, 0, 8, 0, 1, 207, 178);
INSERT INTO public.who_global_data VALUES (48853, 0, 141, 0, 3, 207, 108);
INSERT INTO public.who_global_data VALUES (48854, 159, 7411, 8, 276, 207, 39);
INSERT INTO public.who_global_data VALUES (48855, 3, 1036, 0, 53, 207, 2);
INSERT INTO public.who_global_data VALUES (48856, 11, 269, 0, 1, 207, 195);
INSERT INTO public.who_global_data VALUES (48857, 24, 1722, 0, 19, 207, 107);
INSERT INTO public.who_global_data VALUES (48858, 9, 165, 0, 0, 207, 161);
INSERT INTO public.who_global_data VALUES (48859, 0, 15173, 0, 359, 207, 212);
INSERT INTO public.who_global_data VALUES (48860, 243, 107590, 10, 8783, 207, 181);
INSERT INTO public.who_global_data VALUES (48861, 0, 201, 0, 1, 207, 53);
INSERT INTO public.who_global_data VALUES (48862, 33, 4321, 0, 53, 207, 164);
INSERT INTO public.who_global_data VALUES (48863, 0, 880, 0, 75, 207, 140);
INSERT INTO public.who_global_data VALUES (48864, 2616, 317657, 45, 7024, 207, 20);
INSERT INTO public.who_global_data VALUES (48865, 55, 85623, 1, 4649, 207, 112);
INSERT INTO public.who_global_data VALUES (48866, 5083, 150445, 188, 5307, 207, 111);
INSERT INTO public.who_global_data VALUES (48867, 0, 317, 0, 7, 207, 71);
INSERT INTO public.who_global_data VALUES (48868, 119, 2222, 0, 47, 207, 218);
INSERT INTO public.who_global_data VALUES (48869, 0, 0, 0, 0, 207, 43);
INSERT INTO public.who_global_data VALUES (48870, 365, 7596, 2, 30, 207, 49);
INSERT INTO public.who_global_data VALUES (48871, 106, 12872, 0, 84, 207, 1);
INSERT INTO public.who_global_data VALUES (48872, 53, 3775, 0, 119, 207, 48);
INSERT INTO public.who_global_data VALUES (48873, 2, 2428, 0, 87, 207, 232);
INSERT INTO public.who_global_data VALUES (48874, 1, 26, 0, 1, 207, 175);
INSERT INTO public.who_global_data VALUES (48875, 1, 1022, 0, 19, 207, 21);
INSERT INTO public.who_global_data VALUES (48876, 64, 13238, 1, 353, 207, 156);
INSERT INTO public.who_global_data VALUES (48877, 0, 0, 0, 0, 207, 95);
INSERT INTO public.who_global_data VALUES (48878, 42, 8074, 1, 189, 207, 177);
INSERT INTO public.who_global_data VALUES (48879, 91, 13037, 1, 610, 207, 210);
INSERT INTO public.who_global_data VALUES (48880, 5, 4977, 0, 56, 207, 120);
INSERT INTO public.who_global_data VALUES (48881, 0, 18, 0, 0, 207, 135);
INSERT INTO public.who_global_data VALUES (48882, 974, 45506, 6, 903, 207, 206);
INSERT INTO public.who_global_data VALUES (48883, 589, 68459, 16, 5063, 207, 189);
INSERT INTO public.who_global_data VALUES (48884, 931, 83001, 77, 3935, 207, 129);
INSERT INTO public.who_global_data VALUES (48885, 304, 9978, 7, 267, 207, 121);
INSERT INTO public.who_global_data VALUES (48886, 0, 1043, 0, 12, 207, 59);
INSERT INTO public.who_global_data VALUES (48887, 0, 232, 0, 0, 207, 96);
INSERT INTO public.who_global_data VALUES (48888, 0, 2014, 0, 63, 207, 41);
INSERT INTO public.who_global_data VALUES (48889, 38, 1389, 0, 20, 207, 216);
INSERT INTO public.who_global_data VALUES (48890, 203, 7969, 11, 139, 207, 236);
INSERT INTO public.who_global_data VALUES (48891, 0, 13, 0, 0, 207, 150);
INSERT INTO public.who_global_data VALUES (48892, 0, 188, 0, 0, 207, 61);
INSERT INTO public.who_global_data VALUES (48893, 0, 26, 0, 0, 207, 7);
INSERT INTO public.who_global_data VALUES (48894, 1, 7293, 0, 328, 207, 169);
INSERT INTO public.who_global_data VALUES (48895, 1115, 162390, 18, 29928, 207, 28);
INSERT INTO public.who_global_data VALUES (48896, 221, 6170, 3, 29, 207, 85);
INSERT INTO public.who_global_data VALUES (48897, 0, 62, 0, 0, 207, 211);
INSERT INTO public.who_global_data VALUES (48898, 0, 5942, 0, 46, 207, 60);
INSERT INTO public.who_global_data VALUES (48899, 0, 64, 0, 3, 207, 3);
INSERT INTO public.who_global_data VALUES (48900, 4, 999, 0, 15, 207, 11);
INSERT INTO public.who_global_data VALUES (48901, 412, 199375, 4, 9068, 207, 89);
INSERT INTO public.who_global_data VALUES (48902, 470, 24988, 0, 139, 207, 24);
INSERT INTO public.who_global_data VALUES (48903, 0, 180, 0, 0, 207, 162);
INSERT INTO public.who_global_data VALUES (48904, 23, 3826, 0, 193, 207, 100);
INSERT INTO public.who_global_data VALUES (48905, 0, 13, 0, 0, 207, 47);
INSERT INTO public.who_global_data VALUES (48906, 0, 23, 0, 0, 207, 29);
INSERT INTO public.who_global_data VALUES (48907, 0, 190, 0, 14, 207, 40);
INSERT INTO public.who_global_data VALUES (48908, 0, 304, 0, 5, 207, 222);
INSERT INTO public.who_global_data VALUES (48909, 757, 29355, 47, 1219, 207, 132);
INSERT INTO public.who_global_data VALUES (48910, 0, 252, 0, 13, 207, 130);
INSERT INTO public.who_global_data VALUES (48911, 29, 6170, 1, 38, 207, 234);
INSERT INTO public.who_global_data VALUES (48912, 60, 1902, 1, 26, 207, 23);
INSERT INTO public.who_global_data VALUES (48913, 6, 297, 0, 17, 207, 192);
INSERT INTO public.who_global_data VALUES (48914, 37, 6727, 0, 139, 207, 69);
INSERT INTO public.who_global_data VALUES (48915, 0, 12, 0, 0, 207, 187);
INSERT INTO public.who_global_data VALUES (48916, 507, 28090, 3, 774, 207, 230);
INSERT INTO public.who_global_data VALUES (48917, 13, 4247, 0, 595, 207, 77);
INSERT INTO public.who_global_data VALUES (48918, 0, 1833, 0, 10, 207, 9);
INSERT INTO public.who_global_data VALUES (48919, 28498, 906752, 553, 23727, 207, 74);
INSERT INTO public.who_global_data VALUES (48920, 1282, 76981, 50, 3656, 207, 224);
INSERT INTO public.who_global_data VALUES (48921, 2349, 259652, 203, 13032, 207, 199);
INSERT INTO public.who_global_data VALUES (48922, 2229, 79735, 100, 3250, 207, 190);
INSERT INTO public.who_global_data VALUES (48923, 10, 25638, 0, 1746, 207, 12);
INSERT INTO public.who_global_data VALUES (48924, 0, 336, 0, 24, 207, 104);
INSERT INTO public.who_global_data VALUES (48925, 1239, 39349, 7, 380, 207, 153);
INSERT INTO public.who_global_data VALUES (48926, 169, 243230, 13, 34967, 207, 91);
INSERT INTO public.who_global_data VALUES (48927, 0, 758, 0, 10, 207, 215);
INSERT INTO public.who_global_data VALUES (48928, 352, 22220, 0, 982, 207, 84);
INSERT INTO public.who_global_data VALUES (48929, 4, 329, 0, 31, 207, 231);
INSERT INTO public.who_global_data VALUES (48930, 3, 1095, 0, 10, 207, 196);
INSERT INTO public.who_global_data VALUES (48931, 1759, 63514, 0, 375, 207, 105);
INSERT INTO public.who_global_data VALUES (48932, 189, 10294, 12, 197, 207, 122);
INSERT INTO public.who_global_data VALUES (48933, 0, 0, 0, 0, 207, 159);
INSERT INTO public.who_global_data VALUES (48934, 187, 5075, 6, 98, 207, 75);
INSERT INTO public.who_global_data VALUES (48935, 614, 55508, 3, 393, 207, 27);
INSERT INTO public.who_global_data VALUES (48936, 421, 11538, 2, 149, 207, 54);
INSERT INTO public.who_global_data VALUES (48937, 0, 19, 0, 0, 207, 226);
INSERT INTO public.who_global_data VALUES (48938, 1, 1174, 1, 31, 207, 79);
INSERT INTO public.who_global_data VALUES (48939, 85, 2419, 0, 36, 207, 56);
INSERT INTO public.who_global_data VALUES (48940, 12, 245, 1, 3, 207, 117);
INSERT INTO public.who_global_data VALUES (48941, 14, 1024, 0, 51, 207, 152);
INSERT INTO public.who_global_data VALUES (48942, 79, 1512, 1, 40, 207, 16);
INSERT INTO public.who_global_data VALUES (48943, 0, 85, 0, 1, 207, 10);
INSERT INTO public.who_global_data VALUES (48944, 1, 1870, 0, 79, 207, 201);
INSERT INTO public.who_global_data VALUES (48945, 31, 4956, 0, 111, 207, 174);
INSERT INTO public.who_global_data VALUES (48946, 213, 5080, 2, 37, 207, 119);
INSERT INTO public.who_global_data VALUES (48947, 66, 2430, 1, 39, 207, 168);
INSERT INTO public.who_global_data VALUES (48948, 7, 8725, 0, 122, 207, 99);
INSERT INTO public.who_global_data VALUES (48949, 31, 2762, 0, 13, 207, 171);
INSERT INTO public.who_global_data VALUES (48950, 1, 2412, 0, 121, 207, 87);
INSERT INTO public.who_global_data VALUES (48951, 0, 673, 0, 9, 207, 123);
INSERT INTO public.who_global_data VALUES (48952, 0, 0, 0, 0, 207, 151);
INSERT INTO public.who_global_data VALUES (48953, 0, 255, 0, 15, 207, 213);
INSERT INTO public.who_global_data VALUES (48954, 80, 5355, 0, 147, 207, 118);
INSERT INTO public.who_global_data VALUES (48955, 1, 343, 0, 10, 207, 134);
INSERT INTO public.who_global_data VALUES (48956, 13, 2724, 0, 37, 207, 65);
INSERT INTO public.who_global_data VALUES (48957, 4482, 299750, 276, 35006, 207, 102);
INSERT INTO public.who_global_data VALUES (48958, 0, 0, 0, 0, 207, 223);
INSERT INTO public.who_global_data VALUES (48959, 0, 79, 0, 1, 207, 4);
INSERT INTO public.who_global_data VALUES (48960, 0, 230, 0, 0, 207, 146);
INSERT INTO public.who_global_data VALUES (48961, 105, 1868, 0, 25, 207, 31);
INSERT INTO public.who_global_data VALUES (48962, 0, 12, 0, 1, 207, 127);
INSERT INTO public.who_global_data VALUES (48963, 191, 15936, 5, 255, 207, 22);
INSERT INTO public.who_global_data VALUES (48964, 62, 1219, 0, 9, 207, 115);
INSERT INTO public.who_global_data VALUES (48965, 5, 336, 0, 6, 207, 106);
INSERT INTO public.who_global_data VALUES (48966, 76, 861, 0, 1, 207, 90);
INSERT INTO public.who_global_data VALUES (48967, 0, 0, 0, 0, 207, 70);
INSERT INTO public.who_global_data VALUES (48968, 144, 16945, 0, 38, 207, 46);
INSERT INTO public.who_global_data VALUES (48969, 72, 50917, 0, 6116, 207, 139);
INSERT INTO public.who_global_data VALUES (48970, 0, 21, 0, 0, 207, 42);
INSERT INTO public.who_global_data VALUES (48971, 1, 1195, 0, 22, 207, 80);
INSERT INTO public.who_global_data VALUES (48972, 0, 2411, 0, 91, 207, 203);
INSERT INTO public.who_global_data VALUES (48973, 0, 1099, 0, 68, 207, 136);
INSERT INTO public.who_global_data VALUES (48974, 595, 33153, 4, 744, 207, 63);
INSERT INTO public.who_global_data VALUES (48975, 0, 0, 0, 0, 207, 17);
INSERT INTO public.who_global_data VALUES (48976, 0, 33, 0, 2, 207, 172);
INSERT INTO public.who_global_data VALUES (48977, 86, 8197, 3, 385, 207, 109);
INSERT INTO public.who_global_data VALUES (48978, 16, 8981, 1, 253, 207, 200);
INSERT INTO public.who_global_data VALUES (48979, 404, 7441, 2, 41, 207, 93);
INSERT INTO public.who_global_data VALUES (48980, 2164, 58179, 2, 259, 207, 5);
INSERT INTO public.who_global_data VALUES (48981, 0, 741, 0, 13, 207, 214);
INSERT INTO public.who_global_data VALUES (48982, 1979, 253604, 49, 5319, 207, 204);
INSERT INTO public.who_global_data VALUES (48983, 0, 0, 0, 0, 207, 198);
INSERT INTO public.who_global_data VALUES (48984, 1301, 45633, 16, 909, 207, 173);
INSERT INTO public.who_global_data VALUES (48985, 0, 11, 0, 0, 207, 229);
INSERT INTO public.who_global_data VALUES (48986, 160, 2980, 4, 25, 207, 76);
INSERT INTO public.who_global_data VALUES (48987, 3616, 326326, 188, 11870, 207, 138);
INSERT INTO public.who_global_data VALUES (48988, 747, 57006, 65, 1599, 207, 98);
INSERT INTO public.who_global_data VALUES (48989, 0, 0, 0, 0, 207, 103);
INSERT INTO public.who_global_data VALUES (48990, 299, 38190, 5, 1576, 207, 225);
INSERT INTO public.who_global_data VALUES (48991, 306, 46818, 2, 1662, 207, 131);
INSERT INTO public.who_global_data VALUES (48992, 356, 10010, 0, 167, 207, 235);
INSERT INTO public.who_global_data VALUES (48993, 418, 104016, 2, 149, 207, 137);
INSERT INTO public.who_global_data VALUES (48994, 33, 13512, 0, 289, 207, 81);
INSERT INTO public.who_global_data VALUES (48995, 57, 19439, 10, 652, 207, 182);
INSERT INTO public.who_global_data VALUES (48996, 3, 596, 0, 3, 207, 145);
INSERT INTO public.who_global_data VALUES (48997, 413, 32948, 17, 1901, 207, 26);
INSERT INTO public.who_global_data VALUES (48998, 6248, 739947, 175, 11614, 207, 170);
INSERT INTO public.who_global_data VALUES (48999, 41, 1378, 0, 4, 207, 191);
INSERT INTO public.who_global_data VALUES (49000, 0, 3, 0, 0, 207, 221);
INSERT INTO public.who_global_data VALUES (49001, 0, 6, 0, 0, 207, 64);
INSERT INTO public.who_global_data VALUES (49002, 0, 0, 0, 0, 207, 116);
INSERT INTO public.who_global_data VALUES (49003, 0, 17, 0, 0, 207, 128);
INSERT INTO public.who_global_data VALUES (49004, 0, 22, 0, 0, 207, 6);
INSERT INTO public.who_global_data VALUES (49005, 0, 44, 0, 3, 207, 227);
INSERT INTO public.who_global_data VALUES (49006, 0, 2, 0, 0, 207, 68);
INSERT INTO public.who_global_data VALUES (49007, 6, 35, 0, 0, 207, 184);
INSERT INTO public.who_global_data VALUES (49008, 0, 0, 0, 0, 207, 82);
INSERT INTO public.who_global_data VALUES (49009, 0, 716, 0, 42, 207, 149);
INSERT INTO public.who_global_data VALUES (49010, 3, 412, 0, 12, 207, 197);
INSERT INTO public.who_global_data VALUES (49011, 2852, 235111, 20, 2243, 207, 78);
INSERT INTO public.who_global_data VALUES (49012, 63, 8198, 2, 150, 207, 233);
INSERT INTO public.who_global_data VALUES (49013, 279, 18639, 12, 405, 207, 133);
INSERT INTO public.who_global_data VALUES (49014, 0, 100, 0, 0, 207, 35);
INSERT INTO public.who_global_data VALUES (49015, 7, 1642, 0, 63, 207, 114);
INSERT INTO public.who_global_data VALUES (49016, 322, 46283, 0, 26, 207, 237);
INSERT INTO public.who_global_data VALUES (49017, 0, 2, 0, 0, 207, 55);
INSERT INTO public.who_global_data VALUES (49018, 0, 78, 0, 15, 207, 176);
INSERT INTO public.who_global_data VALUES (49019, 1, 1902, 0, 28, 207, 202);
INSERT INTO public.who_global_data VALUES (49020, 10, 1860, 0, 114, 207, 155);
INSERT INTO public.who_global_data VALUES (49021, 0, 0, 0, 0, 207, 32);
INSERT INTO public.who_global_data VALUES (49022, 13, 3072, 0, 93, 207, 220);
INSERT INTO public.who_global_data VALUES (49023, 11554, 287796, 93, 4172, 207, 30);
INSERT INTO public.who_global_data VALUES (49024, 0, 2148, 0, 41, 207, 147);
INSERT INTO public.who_global_data VALUES (49025, 414, 265681, 3, 29793, 207, 208);
INSERT INTO public.who_global_data VALUES (49026, 29, 2646, 0, 11, 207, 45);
INSERT INTO public.who_global_data VALUES (49027, 66, 10316, 7, 657, 207, 110);
INSERT INTO public.who_global_data VALUES (49028, 21, 762, 0, 18, 207, 88);
INSERT INTO public.who_global_data VALUES (49029, 106, 72788, 8, 5660, 207, 51);
INSERT INTO public.who_global_data VALUES (49030, 120, 33048, 1, 1727, 207, 209);
INSERT INTO public.who_global_data VALUES (49031, 23, 417, 3, 19, 207, 205);
INSERT INTO public.who_global_data VALUES (49032, 44, 6595, 0, 55, 207, 18);
INSERT INTO public.who_global_data VALUES (49033, 7, 3227, 0, 58, 207, 72);
INSERT INTO public.who_global_data VALUES (49034, 361, 291757, 10, 40855, 207, 44);
INSERT INTO public.who_global_data VALUES (49035, 0, 24, 0, 0, 207, 15);
INSERT INTO public.who_global_data VALUES (49036, 0, 720, 0, 15, 207, 25);
INSERT INTO public.who_global_data VALUES (49037, 0, 0, 0, 0, 207, 179);
INSERT INTO public.who_global_data VALUES (49038, 0, 0, 0, 0, 207, 34);
INSERT INTO public.who_global_data VALUES (49039, 0, 133, 0, 8, 207, 207);
INSERT INTO public.who_global_data VALUES (49040, 4, 1306, 0, 50, 207, 166);
INSERT INTO public.who_global_data VALUES (49041, 1008, 214001, 19, 5382, 207, 126);
INSERT INTO public.who_global_data VALUES (49042, 0, 0, 0, 0, 207, 97);
INSERT INTO public.who_global_data VALUES (49043, 1, 72, 0, 2, 207, 36);
INSERT INTO public.who_global_data VALUES (49044, 0, 0, 0, 0, 207, 125);
INSERT INTO public.who_global_data VALUES (49045, 4, 1029, 0, 0, 207, 124);
INSERT INTO public.who_global_data VALUES (49046, 638, 54771, 14, 1412, 207, 185);
INSERT INTO public.who_global_data VALUES (49047, 344, 55198, 1, 334, 207, 194);
INSERT INTO public.who_global_data VALUES (49048, 0, 509, 0, 21, 207, 144);
INSERT INTO public.who_global_data VALUES (49049, 60113, 3286063, 312, 134704, 207, 19);
INSERT INTO public.who_global_data VALUES (49050, 25, 206, 0, 6, 207, 217);
INSERT INTO public.who_global_data VALUES (49051, 1, 987, 1, 31, 207, 148);
INSERT INTO public.who_global_data VALUES (49052, 679, 13872, 3, 64, 207, 86);
INSERT INTO public.who_global_data VALUES (49053, 0, 0, 0, 0, 207, 13);
INSERT INTO public.who_global_data VALUES (49054, 287, 9465, 4, 89, 207, 157);
INSERT INTO public.who_global_data VALUES (49055, 0, 372, 0, 0, 207, 8);
INSERT INTO public.who_global_data VALUES (49056, 0, 0, 0, 0, 207, 73);
INSERT INTO public.who_global_data VALUES (49057, 33, 1502, 7, 425, 207, 101);
INSERT INTO public.who_global_data VALUES (49058, 388, 2283, 40, 82, 207, 165);
INSERT INTO public.who_global_data VALUES (49059, 49, 1034, 1, 19, 207, 14);
INSERT INTO public.who_global_data VALUES (49060, 4, 34541, 2, 1016, 208, 193);
INSERT INTO public.who_global_data VALUES (49061, 117, 3571, 2, 95, 208, 113);
INSERT INTO public.who_global_data VALUES (49062, 483, 19195, 7, 1011, 208, 143);
INSERT INTO public.who_global_data VALUES (49063, 0, 0, 0, 0, 208, 219);
INSERT INTO public.who_global_data VALUES (49064, 0, 855, 0, 52, 208, 186);
INSERT INTO public.who_global_data VALUES (49065, 23, 506, 1, 26, 208, 52);
INSERT INTO public.who_global_data VALUES (49066, 0, 3, 0, 0, 208, 180);
INSERT INTO public.who_global_data VALUES (49067, 0, 74, 0, 3, 208, 167);
INSERT INTO public.who_global_data VALUES (49068, 3449, 97509, 31, 1818, 208, 154);
INSERT INTO public.who_global_data VALUES (49069, 182, 31464, 8, 568, 208, 94);
INSERT INTO public.who_global_data VALUES (49070, 0, 105, 0, 3, 208, 66);
INSERT INTO public.who_global_data VALUES (49071, 244, 9797, 1, 108, 208, 58);
INSERT INTO public.who_global_data VALUES (49072, 52, 18847, 2, 708, 208, 163);
INSERT INTO public.who_global_data VALUES (49073, 520, 24041, 8, 306, 208, 37);
INSERT INTO public.who_global_data VALUES (49074, 3, 111, 0, 11, 208, 142);
INSERT INTO public.who_global_data VALUES (49075, 471, 32941, 4, 108, 208, 83);
INSERT INTO public.who_global_data VALUES (49076, 2666, 183795, 47, 2352, 208, 228);
INSERT INTO public.who_global_data VALUES (49077, 5, 103, 0, 7, 208, 188);
INSERT INTO public.who_global_data VALUES (49078, 168, 64932, 5, 464, 208, 62);
INSERT INTO public.who_global_data VALUES (49079, 43, 63198, 4, 9655, 208, 160);
INSERT INTO public.who_global_data VALUES (49080, 0, 37, 0, 2, 208, 50);
INSERT INTO public.who_global_data VALUES (49081, 0, 1378, 0, 26, 208, 33);
INSERT INTO public.who_global_data VALUES (49082, 0, 150, 0, 9, 208, 183);
INSERT INTO public.who_global_data VALUES (49083, 2, 84, 0, 0, 208, 92);
INSERT INTO public.who_global_data VALUES (49084, 1635, 47200, 52, 1754, 208, 158);
INSERT INTO public.who_global_data VALUES (49085, 0, 2, 0, 0, 208, 67);
INSERT INTO public.who_global_data VALUES (49086, 164, 6884, 2, 220, 208, 57);
INSERT INTO public.who_global_data VALUES (49087, 85, 399, 0, 1, 208, 38);
INSERT INTO public.who_global_data VALUES (49088, 39023, 1839850, 1071, 71469, 208, 141);
INSERT INTO public.who_global_data VALUES (49089, 0, 8, 0, 1, 208, 178);
INSERT INTO public.who_global_data VALUES (49090, 0, 141, 0, 3, 208, 108);
INSERT INTO public.who_global_data VALUES (49091, 77, 7252, 6, 268, 208, 39);
INSERT INTO public.who_global_data VALUES (49092, 13, 1033, -1, 53, 208, 2);
INSERT INTO public.who_global_data VALUES (49093, 8, 258, 0, 1, 208, 195);
INSERT INTO public.who_global_data VALUES (49094, 75, 1698, 0, 19, 208, 107);
INSERT INTO public.who_global_data VALUES (49095, 0, 156, 0, 0, 208, 161);
INSERT INTO public.who_global_data VALUES (49096, 257, 15173, 0, 359, 208, 212);
INSERT INTO public.who_global_data VALUES (49097, 221, 107347, 14, 8773, 208, 181);
INSERT INTO public.who_global_data VALUES (49098, 0, 201, 0, 1, 208, 53);
INSERT INTO public.who_global_data VALUES (49099, 0, 4288, 0, 53, 208, 164);
INSERT INTO public.who_global_data VALUES (49100, 6, 880, 1, 75, 208, 140);
INSERT INTO public.who_global_data VALUES (49101, 3012, 315041, 98, 6979, 208, 20);
INSERT INTO public.who_global_data VALUES (49102, 46, 85568, 0, 4648, 208, 112);
INSERT INTO public.who_global_data VALUES (49103, 4586, 145362, 194, 5119, 208, 111);
INSERT INTO public.who_global_data VALUES (49104, 3, 317, 0, 7, 208, 71);
INSERT INTO public.who_global_data VALUES (49105, 0, 2103, 0, 47, 208, 218);
INSERT INTO public.who_global_data VALUES (49106, 0, 0, 0, 0, 208, 43);
INSERT INTO public.who_global_data VALUES (49107, 386, 7231, 1, 28, 208, 49);
INSERT INTO public.who_global_data VALUES (49108, 714, 12766, 3, 84, 208, 1);
INSERT INTO public.who_global_data VALUES (49109, 50, 3722, 1, 119, 208, 48);
INSERT INTO public.who_global_data VALUES (49110, 6, 2426, 0, 87, 208, 232);
INSERT INTO public.who_global_data VALUES (49111, 0, 25, 0, 1, 208, 175);
INSERT INTO public.who_global_data VALUES (49112, 7, 1021, 0, 19, 208, 21);
INSERT INTO public.who_global_data VALUES (49113, 59, 13174, 0, 352, 208, 156);
INSERT INTO public.who_global_data VALUES (49114, 0, 0, 0, 0, 208, 95);
INSERT INTO public.who_global_data VALUES (49115, 62, 8032, 0, 188, 208, 177);
INSERT INTO public.who_global_data VALUES (49116, 0, 12946, 0, 609, 208, 210);
INSERT INTO public.who_global_data VALUES (49117, 4, 4972, 0, 56, 208, 120);
INSERT INTO public.who_global_data VALUES (49118, 0, 18, 0, 0, 208, 135);
INSERT INTO public.who_global_data VALUES (49119, 1418, 44532, 17, 897, 208, 206);
INSERT INTO public.who_global_data VALUES (49120, 661, 67870, 16, 5047, 208, 189);
INSERT INTO public.who_global_data VALUES (49121, 912, 82070, 89, 3858, 208, 129);
INSERT INTO public.who_global_data VALUES (49122, 283, 9674, 6, 260, 208, 121);
INSERT INTO public.who_global_data VALUES (49123, 0, 1043, 0, 12, 208, 59);
INSERT INTO public.who_global_data VALUES (49124, 0, 232, 0, 0, 208, 96);
INSERT INTO public.who_global_data VALUES (49125, 0, 2014, 0, 63, 208, 41);
INSERT INTO public.who_global_data VALUES (49126, 40, 1351, 2, 20, 208, 216);
INSERT INTO public.who_global_data VALUES (49127, 206, 7766, 1, 128, 208, 236);
INSERT INTO public.who_global_data VALUES (49128, 0, 13, 0, 0, 208, 150);
INSERT INTO public.who_global_data VALUES (49129, 0, 188, 0, 0, 208, 61);
INSERT INTO public.who_global_data VALUES (49130, 0, 26, 0, 0, 208, 7);
INSERT INTO public.who_global_data VALUES (49131, 2, 7292, 0, 328, 208, 169);
INSERT INTO public.who_global_data VALUES (49132, 0, 161275, 0, 29910, 208, 28);
INSERT INTO public.who_global_data VALUES (49133, 0, 5949, 0, 26, 208, 85);
INSERT INTO public.who_global_data VALUES (49134, 0, 62, 0, 0, 208, 211);
INSERT INTO public.who_global_data VALUES (49135, 0, 5942, 0, 46, 208, 60);
INSERT INTO public.who_global_data VALUES (49136, 0, 64, 0, 3, 208, 3);
INSERT INTO public.who_global_data VALUES (49137, 9, 995, 0, 15, 208, 11);
INSERT INTO public.who_global_data VALUES (49138, 159, 198963, 1, 9064, 208, 89);
INSERT INTO public.who_global_data VALUES (49139, 270, 24518, 4, 139, 208, 24);
INSERT INTO public.who_global_data VALUES (49140, 0, 180, 0, 0, 208, 162);
INSERT INTO public.who_global_data VALUES (49141, 31, 3803, 0, 193, 208, 100);
INSERT INTO public.who_global_data VALUES (49142, 0, 13, 0, 0, 208, 47);
INSERT INTO public.who_global_data VALUES (49143, 0, 23, 0, 0, 208, 29);
INSERT INTO public.who_global_data VALUES (49144, 0, 190, 0, 14, 208, 40);
INSERT INTO public.who_global_data VALUES (49145, 0, 304, 0, 5, 208, 222);
INSERT INTO public.who_global_data VALUES (49146, 979, 28598, 33, 1172, 208, 132);
INSERT INTO public.who_global_data VALUES (49147, 0, 252, 0, 13, 208, 130);
INSERT INTO public.who_global_data VALUES (49148, 97, 6141, 0, 37, 208, 234);
INSERT INTO public.who_global_data VALUES (49149, 0, 1842, 0, 25, 208, 23);
INSERT INTO public.who_global_data VALUES (49150, 1, 291, 1, 17, 208, 192);
INSERT INTO public.who_global_data VALUES (49151, 73, 6690, 4, 139, 208, 69);
INSERT INTO public.who_global_data VALUES (49152, 0, 12, 0, 0, 208, 187);
INSERT INTO public.who_global_data VALUES (49153, 530, 27583, 21, 771, 208, 230);
INSERT INTO public.who_global_data VALUES (49154, 5, 4234, 0, 595, 208, 77);
INSERT INTO public.who_global_data VALUES (49155, 0, 1833, 0, 10, 208, 9);
INSERT INTO public.who_global_data VALUES (49156, 28701, 878254, 500, 23174, 208, 74);
INSERT INTO public.who_global_data VALUES (49157, 1681, 75699, 71, 3606, 208, 224);
INSERT INTO public.who_global_data VALUES (49158, 2186, 257303, 194, 12829, 208, 199);
INSERT INTO public.who_global_data VALUES (49159, 2312, 77506, 95, 3150, 208, 190);
INSERT INTO public.who_global_data VALUES (49160, 17, 25628, 0, 1746, 208, 12);
INSERT INTO public.who_global_data VALUES (49161, 0, 336, 0, 24, 208, 104);
INSERT INTO public.who_global_data VALUES (49162, 1168, 38110, 5, 373, 208, 153);
INSERT INTO public.who_global_data VALUES (49163, 234, 243061, 9, 34954, 208, 91);
INSERT INTO public.who_global_data VALUES (49164, 5, 758, 0, 10, 208, 215);
INSERT INTO public.who_global_data VALUES (49165, 366, 21868, 0, 982, 208, 84);
INSERT INTO public.who_global_data VALUES (49166, 0, 325, 0, 31, 208, 231);
INSERT INTO public.who_global_data VALUES (49167, 3, 1092, 0, 10, 208, 196);
INSERT INTO public.who_global_data VALUES (49168, 1856, 61755, 0, 375, 208, 105);
INSERT INTO public.who_global_data VALUES (49169, 379, 10105, 1, 185, 208, 122);
INSERT INTO public.who_global_data VALUES (49170, 0, 0, 0, 0, 208, 159);
INSERT INTO public.who_global_data VALUES (49171, 216, 4888, 1, 92, 208, 75);
INSERT INTO public.who_global_data VALUES (49172, 836, 54894, 4, 390, 208, 27);
INSERT INTO public.who_global_data VALUES (49173, 488, 11117, 15, 147, 208, 54);
INSERT INTO public.who_global_data VALUES (49174, 0, 19, 0, 0, 208, 226);
INSERT INTO public.who_global_data VALUES (49175, 0, 1173, 0, 30, 208, 79);
INSERT INTO public.who_global_data VALUES (49176, 166, 2334, 0, 36, 208, 56);
INSERT INTO public.who_global_data VALUES (49177, 49, 233, 1, 2, 208, 117);
INSERT INTO public.who_global_data VALUES (49178, 12, 1010, 4, 51, 208, 152);
INSERT INTO public.who_global_data VALUES (49179, 44, 1433, 1, 39, 208, 16);
INSERT INTO public.who_global_data VALUES (49180, 0, 85, 0, 1, 208, 10);
INSERT INTO public.who_global_data VALUES (49181, 5, 1869, 0, 79, 208, 201);
INSERT INTO public.who_global_data VALUES (49182, 83, 4925, 1, 111, 208, 174);
INSERT INTO public.who_global_data VALUES (49183, 289, 4867, 1, 35, 208, 119);
INSERT INTO public.who_global_data VALUES (49184, 103, 2364, 5, 38, 208, 168);
INSERT INTO public.who_global_data VALUES (49185, 14, 8718, 0, 122, 208, 99);
INSERT INTO public.who_global_data VALUES (49186, 67, 2731, 0, 13, 208, 171);
INSERT INTO public.who_global_data VALUES (49187, 5, 2411, 0, 121, 208, 87);
INSERT INTO public.who_global_data VALUES (49188, 0, 673, 0, 9, 208, 123);
INSERT INTO public.who_global_data VALUES (49189, 0, 0, 0, 0, 208, 151);
INSERT INTO public.who_global_data VALUES (49190, 0, 255, 0, 15, 208, 213);
INSERT INTO public.who_global_data VALUES (49191, 149, 5275, 3, 147, 208, 118);
INSERT INTO public.who_global_data VALUES (49192, 0, 342, 0, 10, 208, 134);
INSERT INTO public.who_global_data VALUES (49193, 0, 2711, 0, 37, 208, 65);
INSERT INTO public.who_global_data VALUES (49194, 6094, 295268, 539, 34730, 208, 102);
INSERT INTO public.who_global_data VALUES (49195, 0, 0, 0, 0, 208, 223);
INSERT INTO public.who_global_data VALUES (49196, 0, 79, 0, 1, 208, 4);
INSERT INTO public.who_global_data VALUES (49197, 3, 230, 0, 0, 208, 146);
INSERT INTO public.who_global_data VALUES (49198, 37, 1763, 0, 25, 208, 31);
INSERT INTO public.who_global_data VALUES (49199, 0, 12, 0, 1, 208, 127);
INSERT INTO public.who_global_data VALUES (49200, 203, 15745, 5, 250, 208, 22);
INSERT INTO public.who_global_data VALUES (49201, 22, 1157, 0, 9, 208, 115);
INSERT INTO public.who_global_data VALUES (49202, 1, 331, 0, 6, 208, 106);
INSERT INTO public.who_global_data VALUES (49203, 72, 785, 0, 1, 208, 90);
INSERT INTO public.who_global_data VALUES (49204, 0, 0, 0, 0, 208, 70);
INSERT INTO public.who_global_data VALUES (49205, 82, 16801, 0, 38, 208, 46);
INSERT INTO public.who_global_data VALUES (49206, 95, 50845, 0, 6116, 208, 139);
INSERT INTO public.who_global_data VALUES (49207, 0, 21, 0, 0, 208, 42);
INSERT INTO public.who_global_data VALUES (49208, 0, 1194, 0, 22, 208, 80);
INSERT INTO public.who_global_data VALUES (49209, 0, 2411, 0, 91, 208, 203);
INSERT INTO public.who_global_data VALUES (49210, 0, 1099, 0, 68, 208, 136);
INSERT INTO public.who_global_data VALUES (49211, 571, 32558, 16, 740, 208, 63);
INSERT INTO public.who_global_data VALUES (49212, 0, 0, 0, 0, 208, 17);
INSERT INTO public.who_global_data VALUES (49213, 0, 33, 0, 2, 208, 172);
INSERT INTO public.who_global_data VALUES (49214, 144, 8111, 7, 382, 208, 109);
INSERT INTO public.who_global_data VALUES (49215, 0, 8965, 0, 252, 208, 200);
INSERT INTO public.who_global_data VALUES (49216, 349, 7037, 7, 39, 208, 93);
INSERT INTO public.who_global_data VALUES (49217, 1318, 56015, 9, 257, 208, 5);
INSERT INTO public.who_global_data VALUES (49218, 0, 741, 0, 13, 208, 214);
INSERT INTO public.who_global_data VALUES (49219, 2753, 251625, 73, 5270, 208, 204);
INSERT INTO public.who_global_data VALUES (49220, 0, 0, 0, 0, 208, 198);
INSERT INTO public.who_global_data VALUES (49221, 1075, 44332, 30, 893, 208, 173);
INSERT INTO public.who_global_data VALUES (49222, 0, 11, 0, 0, 208, 229);
INSERT INTO public.who_global_data VALUES (49223, 84, 2820, 1, 21, 208, 76);
INSERT INTO public.who_global_data VALUES (49224, 3064, 322710, 182, 11682, 208, 138);
INSERT INTO public.who_global_data VALUES (49225, 2037, 56259, 162, 1534, 208, 98);
INSERT INTO public.who_global_data VALUES (49226, 0, 0, 0, 0, 208, 103);
INSERT INTO public.who_global_data VALUES (49227, 370, 37891, 3, 1571, 208, 225);
INSERT INTO public.who_global_data VALUES (49228, 291, 46512, 6, 1660, 208, 131);
INSERT INTO public.who_global_data VALUES (49229, 288, 9654, 0, 167, 208, 235);
INSERT INTO public.who_global_data VALUES (49230, 470, 103598, 1, 147, 208, 137);
INSERT INTO public.who_global_data VALUES (49231, 62, 13479, 0, 289, 208, 81);
INSERT INTO public.who_global_data VALUES (49232, 174, 19382, 2, 642, 208, 182);
INSERT INTO public.who_global_data VALUES (49233, 16, 593, 0, 3, 208, 145);
INSERT INTO public.who_global_data VALUES (49234, 456, 32535, 13, 1884, 208, 26);
INSERT INTO public.who_global_data VALUES (49235, 6537, 733699, 104, 11439, 208, 170);
INSERT INTO public.who_global_data VALUES (49236, 38, 1337, 1, 4, 208, 191);
INSERT INTO public.who_global_data VALUES (49237, 0, 3, 0, 0, 208, 221);
INSERT INTO public.who_global_data VALUES (49238, 0, 6, 0, 0, 208, 64);
INSERT INTO public.who_global_data VALUES (49239, 0, 0, 0, 0, 208, 116);
INSERT INTO public.who_global_data VALUES (49240, 0, 17, 0, 0, 208, 128);
INSERT INTO public.who_global_data VALUES (49241, 0, 22, 0, 0, 208, 6);
INSERT INTO public.who_global_data VALUES (49242, 0, 44, 0, 3, 208, 227);
INSERT INTO public.who_global_data VALUES (49243, 0, 2, 0, 0, 208, 68);
INSERT INTO public.who_global_data VALUES (49244, 0, 29, 0, 0, 208, 184);
INSERT INTO public.who_global_data VALUES (49245, 0, 0, 0, 0, 208, 82);
INSERT INTO public.who_global_data VALUES (49246, 0, 716, 0, 42, 208, 149);
INSERT INTO public.who_global_data VALUES (49247, 2, 409, 0, 12, 208, 197);
INSERT INTO public.who_global_data VALUES (49248, 2779, 232259, 42, 2223, 208, 78);
INSERT INTO public.who_global_data VALUES (49249, 121, 8135, 3, 148, 208, 233);
INSERT INTO public.who_global_data VALUES (49250, 287, 18360, 11, 393, 208, 133);
INSERT INTO public.who_global_data VALUES (49251, 0, 100, 0, 0, 208, 35);
INSERT INTO public.who_global_data VALUES (49252, 17, 1635, 0, 63, 208, 114);
INSERT INTO public.who_global_data VALUES (49253, 178, 45961, 0, 26, 208, 237);
INSERT INTO public.who_global_data VALUES (49254, 0, 2, 0, 0, 208, 55);
INSERT INTO public.who_global_data VALUES (49255, 0, 78, 0, 15, 208, 176);
INSERT INTO public.who_global_data VALUES (49256, 8, 1901, 0, 28, 208, 202);
INSERT INTO public.who_global_data VALUES (49257, 8, 1850, 0, 114, 208, 155);
INSERT INTO public.who_global_data VALUES (49258, 0, 0, 0, 0, 208, 32);
INSERT INTO public.who_global_data VALUES (49259, 8, 3059, 1, 93, 208, 220);
INSERT INTO public.who_global_data VALUES (49260, 12058, 276242, 108, 4079, 208, 30);
INSERT INTO public.who_global_data VALUES (49261, 9, 2148, 0, 41, 208, 147);
INSERT INTO public.who_global_data VALUES (49262, 653, 265267, 4, 29790, 208, 208);
INSERT INTO public.who_global_data VALUES (49263, 106, 2617, 0, 11, 208, 45);
INSERT INTO public.who_global_data VALUES (49264, 0, 10250, 0, 650, 208, 110);
INSERT INTO public.who_global_data VALUES (49265, 12, 741, 0, 18, 208, 88);
INSERT INTO public.who_global_data VALUES (49266, 308, 72682, 10, 5652, 208, 51);
INSERT INTO public.who_global_data VALUES (49267, 46, 32928, 0, 1726, 208, 209);
INSERT INTO public.who_global_data VALUES (49268, 0, 394, 0, 16, 208, 205);
INSERT INTO public.who_global_data VALUES (49269, 46, 6551, 0, 55, 208, 18);
INSERT INTO public.who_global_data VALUES (49270, 3, 3220, 0, 58, 208, 72);
INSERT INTO public.who_global_data VALUES (49271, 442, 291396, 9, 40845, 208, 44);
INSERT INTO public.who_global_data VALUES (49272, 0, 24, 0, 0, 208, 15);
INSERT INTO public.who_global_data VALUES (49273, 10, 720, 0, 15, 208, 25);
INSERT INTO public.who_global_data VALUES (49274, 0, 0, 0, 0, 208, 179);
INSERT INTO public.who_global_data VALUES (49275, 0, 0, 0, 0, 208, 34);
INSERT INTO public.who_global_data VALUES (49276, 0, 133, 0, 8, 208, 207);
INSERT INTO public.who_global_data VALUES (49277, 39, 1302, 0, 50, 208, 166);
INSERT INTO public.who_global_data VALUES (49278, 1012, 212993, 19, 5363, 208, 126);
INSERT INTO public.who_global_data VALUES (49279, 0, 0, 0, 0, 208, 97);
INSERT INTO public.who_global_data VALUES (49280, 5, 71, 0, 2, 208, 36);
INSERT INTO public.who_global_data VALUES (49281, 0, 0, 0, 0, 208, 125);
INSERT INTO public.who_global_data VALUES (49282, 12, 1025, 0, 0, 208, 124);
INSERT INTO public.who_global_data VALUES (49283, 612, 54133, 15, 1398, 208, 185);
INSERT INTO public.who_global_data VALUES (49284, 401, 54854, 2, 333, 208, 194);
INSERT INTO public.who_global_data VALUES (49285, 0, 509, 0, 21, 208, 144);
INSERT INTO public.who_global_data VALUES (49286, 62369, 3225950, 906, 134392, 208, 19);
INSERT INTO public.who_global_data VALUES (49287, 14, 181, 0, 6, 208, 217);
INSERT INTO public.who_global_data VALUES (49288, 1, 986, 1, 30, 208, 148);
INSERT INTO public.who_global_data VALUES (49289, 487, 13193, 3, 61, 208, 86);
INSERT INTO public.who_global_data VALUES (49290, 0, 0, 0, 0, 208, 13);
INSERT INTO public.who_global_data VALUES (49291, 375, 9178, 2, 85, 208, 157);
INSERT INTO public.who_global_data VALUES (49292, 2, 372, 0, 0, 208, 8);
INSERT INTO public.who_global_data VALUES (49293, 0, 0, 0, 0, 208, 73);
INSERT INTO public.who_global_data VALUES (49294, 80, 1469, 53, 418, 208, 101);
INSERT INTO public.who_global_data VALUES (49295, 0, 1895, 0, 42, 208, 165);
INSERT INTO public.who_global_data VALUES (49296, 3, 985, 0, 18, 208, 14);
INSERT INTO public.who_global_data VALUES (49297, 100, 34537, 35, 1014, 209, 193);
INSERT INTO public.who_global_data VALUES (49298, 83, 3454, 4, 93, 209, 113);
INSERT INTO public.who_global_data VALUES (49299, 470, 18712, 8, 1004, 209, 143);
INSERT INTO public.who_global_data VALUES (49300, 0, 0, 0, 0, 209, 219);
INSERT INTO public.who_global_data VALUES (49301, 0, 855, 0, 52, 209, 186);
INSERT INTO public.who_global_data VALUES (49302, 21, 483, 2, 25, 209, 52);
INSERT INTO public.who_global_data VALUES (49303, 0, 3, 0, 0, 209, 180);
INSERT INTO public.who_global_data VALUES (49304, 1, 74, 0, 3, 209, 167);
INSERT INTO public.who_global_data VALUES (49305, 3367, 94060, 38, 1787, 209, 154);
INSERT INTO public.who_global_data VALUES (49306, 577, 31282, 6, 560, 209, 94);
INSERT INTO public.who_global_data VALUES (49307, 0, 105, 0, 3, 209, 66);
INSERT INTO public.who_global_data VALUES (49308, 194, 9553, 1, 107, 209, 58);
INSERT INTO public.who_global_data VALUES (49309, 108, 18795, 0, 706, 209, 163);
INSERT INTO public.who_global_data VALUES (49310, 531, 23521, 6, 298, 209, 37);
INSERT INTO public.who_global_data VALUES (49311, 1, 108, 0, 11, 209, 142);
INSERT INTO public.who_global_data VALUES (49312, 431, 32470, 0, 104, 209, 83);
INSERT INTO public.who_global_data VALUES (49313, 2686, 181129, 30, 2305, 209, 228);
INSERT INTO public.who_global_data VALUES (49314, 0, 98, 0, 7, 209, 188);
INSERT INTO public.who_global_data VALUES (49315, 160, 64764, 5, 459, 209, 62);
INSERT INTO public.who_global_data VALUES (49316, 62, 63155, 2, 9651, 209, 160);
INSERT INTO public.who_global_data VALUES (49317, 4, 37, 0, 2, 209, 50);
INSERT INTO public.who_global_data VALUES (49318, 93, 1378, 3, 26, 209, 33);
INSERT INTO public.who_global_data VALUES (49319, 1, 150, 0, 9, 209, 183);
INSERT INTO public.who_global_data VALUES (49320, 0, 82, 0, 0, 209, 92);
INSERT INTO public.who_global_data VALUES (49321, 1452, 45565, 64, 1702, 209, 158);
INSERT INTO public.who_global_data VALUES (49322, 0, 2, 0, 0, 209, 67);
INSERT INTO public.who_global_data VALUES (49323, 318, 6720, 3, 218, 209, 57);
INSERT INTO public.who_global_data VALUES (49324, 0, 314, 0, 1, 209, 38);
INSERT INTO public.who_global_data VALUES (49325, 45048, 1800827, 1214, 70398, 209, 141);
INSERT INTO public.who_global_data VALUES (49326, 0, 8, 0, 1, 209, 178);
INSERT INTO public.who_global_data VALUES (49327, 0, 141, 0, 3, 209, 108);
INSERT INTO public.who_global_data VALUES (49328, 211, 7175, 0, 262, 209, 39);
INSERT INTO public.who_global_data VALUES (49329, 0, 1020, 0, 54, 209, 2);
INSERT INTO public.who_global_data VALUES (49330, 0, 250, 0, 1, 209, 195);
INSERT INTO public.who_global_data VALUES (49331, 32, 1623, 0, 19, 209, 107);
INSERT INTO public.who_global_data VALUES (49332, 15, 156, 0, 0, 209, 161);
INSERT INTO public.who_global_data VALUES (49333, 0, 14916, 0, 359, 209, 212);
INSERT INTO public.who_global_data VALUES (49334, 321, 107126, 10, 8759, 209, 181);
INSERT INTO public.who_global_data VALUES (49335, 0, 201, 0, 1, 209, 53);
INSERT INTO public.who_global_data VALUES (49336, 88, 4288, 1, 53, 209, 164);
INSERT INTO public.who_global_data VALUES (49337, 0, 874, 0, 74, 209, 140);
INSERT INTO public.who_global_data VALUES (49338, 2755, 312029, 100, 6881, 209, 20);
INSERT INTO public.who_global_data VALUES (49339, 35, 85522, 0, 4648, 209, 112);
INSERT INTO public.who_global_data VALUES (49340, 6803, 140776, 211, 4925, 209, 111);
INSERT INTO public.who_global_data VALUES (49341, 0, 314, 0, 7, 209, 71);
INSERT INTO public.who_global_data VALUES (49342, 75, 2103, 0, 47, 209, 218);
INSERT INTO public.who_global_data VALUES (49343, 0, 0, 0, 0, 209, 43);
INSERT INTO public.who_global_data VALUES (49344, 360, 6845, 1, 27, 209, 49);
INSERT INTO public.who_global_data VALUES (49345, 548, 12052, 3, 81, 209, 1);
INSERT INTO public.who_global_data VALUES (49346, 140, 3672, 1, 118, 209, 48);
INSERT INTO public.who_global_data VALUES (49347, 7, 2420, 1, 87, 209, 232);
INSERT INTO public.who_global_data VALUES (49348, 0, 25, 0, 1, 209, 175);
INSERT INTO public.who_global_data VALUES (49349, 1, 1014, 0, 19, 209, 21);
INSERT INTO public.who_global_data VALUES (49350, 53, 13115, 0, 352, 209, 156);
INSERT INTO public.who_global_data VALUES (49351, 0, 0, 0, 0, 209, 95);
INSERT INTO public.who_global_data VALUES (49352, 66, 7970, 0, 188, 209, 177);
INSERT INTO public.who_global_data VALUES (49353, 0, 12946, 0, 609, 209, 210);
INSERT INTO public.who_global_data VALUES (49354, 0, 4968, 0, 56, 209, 120);
INSERT INTO public.who_global_data VALUES (49355, 0, 18, 0, 0, 209, 135);
INSERT INTO public.who_global_data VALUES (49356, 1199, 43114, 16, 880, 209, 206);
INSERT INTO public.who_global_data VALUES (49357, 1408, 67209, 48, 5031, 209, 189);
INSERT INTO public.who_global_data VALUES (49358, 923, 81158, 67, 3769, 209, 129);
INSERT INTO public.who_global_data VALUES (49359, 249, 9391, 5, 254, 209, 121);
INSERT INTO public.who_global_data VALUES (49360, 0, 1043, 0, 12, 209, 59);
INSERT INTO public.who_global_data VALUES (49361, 0, 232, 0, 0, 209, 96);
INSERT INTO public.who_global_data VALUES (49362, 1, 2014, 0, 63, 209, 41);
INSERT INTO public.who_global_data VALUES (49363, 54, 1311, 0, 18, 209, 216);
INSERT INTO public.who_global_data VALUES (49364, 158, 7560, 3, 127, 209, 236);
INSERT INTO public.who_global_data VALUES (49365, 0, 13, 0, 0, 209, 150);
INSERT INTO public.who_global_data VALUES (49366, 0, 188, 0, 0, 209, 61);
INSERT INTO public.who_global_data VALUES (49367, 5, 26, 0, 0, 209, 7);
INSERT INTO public.who_global_data VALUES (49368, 0, 7290, 0, 328, 209, 169);
INSERT INTO public.who_global_data VALUES (49369, 0, 161275, 0, 29910, 209, 28);
INSERT INTO public.who_global_data VALUES (49370, 245, 5949, 3, 26, 209, 85);
INSERT INTO public.who_global_data VALUES (49371, 0, 62, 0, 0, 209, 211);
INSERT INTO public.who_global_data VALUES (49372, 0, 5942, 0, 46, 209, 60);
INSERT INTO public.who_global_data VALUES (49373, 0, 64, 0, 3, 209, 3);
INSERT INTO public.who_global_data VALUES (49374, 5, 986, 0, 15, 209, 11);
INSERT INTO public.who_global_data VALUES (49375, 248, 198804, 3, 9063, 209, 89);
INSERT INTO public.who_global_data VALUES (49376, 785, 24248, 6, 135, 209, 24);
INSERT INTO public.who_global_data VALUES (49377, 0, 180, 0, 0, 209, 162);
INSERT INTO public.who_global_data VALUES (49378, 40, 3772, 0, 193, 209, 100);
INSERT INTO public.who_global_data VALUES (49379, 0, 13, 0, 0, 209, 47);
INSERT INTO public.who_global_data VALUES (49380, 0, 23, 0, 0, 209, 29);
INSERT INTO public.who_global_data VALUES (49381, 0, 190, 0, 14, 209, 40);
INSERT INTO public.who_global_data VALUES (49382, 2, 304, 0, 5, 209, 222);
INSERT INTO public.who_global_data VALUES (49383, 961, 27619, 47, 1139, 209, 132);
INSERT INTO public.who_global_data VALUES (49384, 0, 252, 0, 13, 209, 130);
INSERT INTO public.who_global_data VALUES (49385, 75, 6044, 0, 37, 209, 234);
INSERT INTO public.who_global_data VALUES (49386, 0, 1842, 0, 25, 209, 23);
INSERT INTO public.who_global_data VALUES (49387, 4, 290, 0, 16, 209, 192);
INSERT INTO public.who_global_data VALUES (49388, 35, 6617, 5, 135, 209, 69);
INSERT INTO public.who_global_data VALUES (49389, 0, 12, 0, 0, 209, 187);
INSERT INTO public.who_global_data VALUES (49390, 669, 27053, 46, 750, 209, 230);
INSERT INTO public.who_global_data VALUES (49391, 6, 4229, 2, 595, 209, 77);
INSERT INTO public.who_global_data VALUES (49392, 0, 1833, 0, 10, 209, 9);
INSERT INTO public.who_global_data VALUES (49393, 28637, 849553, 551, 22674, 209, 74);
INSERT INTO public.who_global_data VALUES (49394, 1671, 74018, 66, 3535, 209, 224);
INSERT INTO public.who_global_data VALUES (49395, 2397, 255117, 188, 12635, 209, 199);
INSERT INTO public.who_global_data VALUES (49396, 2734, 75194, 95, 3055, 209, 190);
INSERT INTO public.who_global_data VALUES (49397, 22, 25611, 2, 1746, 209, 12);
INSERT INTO public.who_global_data VALUES (49398, 0, 336, 0, 24, 209, 104);
INSERT INTO public.who_global_data VALUES (49399, 1409, 36942, 4, 368, 209, 153);
INSERT INTO public.who_global_data VALUES (49400, 188, 242827, 7, 34945, 209, 91);
INSERT INTO public.who_global_data VALUES (49401, 0, 753, 0, 10, 209, 215);
INSERT INTO public.who_global_data VALUES (49402, 373, 21502, 0, 982, 209, 84);
INSERT INTO public.who_global_data VALUES (49403, 0, 325, 0, 31, 209, 231);
INSERT INTO public.who_global_data VALUES (49404, 1, 1089, 0, 10, 209, 196);
INSERT INTO public.who_global_data VALUES (49405, 1646, 59899, 23, 375, 209, 105);
INSERT INTO public.who_global_data VALUES (49406, 278, 9726, 3, 184, 209, 122);
INSERT INTO public.who_global_data VALUES (49407, 0, 0, 0, 0, 209, 159);
INSERT INTO public.who_global_data VALUES (49408, 203, 4672, 4, 91, 209, 75);
INSERT INTO public.who_global_data VALUES (49409, 478, 54058, 3, 386, 209, 27);
INSERT INTO public.who_global_data VALUES (49410, 719, 10629, 7, 132, 209, 54);
INSERT INTO public.who_global_data VALUES (49411, 0, 19, 0, 0, 209, 226);
INSERT INTO public.who_global_data VALUES (49412, 19, 1173, 0, 30, 209, 79);
INSERT INTO public.who_global_data VALUES (49413, 86, 2168, 0, 36, 209, 56);
INSERT INTO public.who_global_data VALUES (49414, 0, 184, 0, 1, 209, 117);
INSERT INTO public.who_global_data VALUES (49415, 35, 998, 0, 47, 209, 152);
INSERT INTO public.who_global_data VALUES (49416, 47, 1389, 0, 38, 209, 16);
INSERT INTO public.who_global_data VALUES (49417, 0, 85, 0, 1, 209, 10);
INSERT INTO public.who_global_data VALUES (49418, 4, 1864, 0, 79, 209, 201);
INSERT INTO public.who_global_data VALUES (49419, 65, 4842, 0, 110, 209, 174);
INSERT INTO public.who_global_data VALUES (49420, 435, 4578, 0, 34, 209, 119);
INSERT INTO public.who_global_data VALUES (49421, 192, 2261, 2, 33, 209, 168);
INSERT INTO public.who_global_data VALUES (49422, 8, 8704, 1, 122, 209, 99);
INSERT INTO public.who_global_data VALUES (49423, 47, 2664, 0, 13, 209, 171);
INSERT INTO public.who_global_data VALUES (49424, 2, 2406, 0, 121, 209, 87);
INSERT INTO public.who_global_data VALUES (49425, 0, 673, 0, 9, 209, 123);
INSERT INTO public.who_global_data VALUES (49426, 0, 0, 0, 0, 209, 151);
INSERT INTO public.who_global_data VALUES (49427, 6, 255, 1, 15, 209, 213);
INSERT INTO public.who_global_data VALUES (49428, 0, 5126, 0, 144, 209, 118);
INSERT INTO public.who_global_data VALUES (49429, 0, 342, 0, 10, 209, 134);
INSERT INTO public.who_global_data VALUES (49430, 0, 2711, 0, 37, 209, 65);
INSERT INTO public.who_global_data VALUES (49431, 6891, 289174, 665, 34191, 209, 102);
INSERT INTO public.who_global_data VALUES (49432, 0, 0, 0, 0, 209, 223);
INSERT INTO public.who_global_data VALUES (49433, 1, 79, 0, 1, 209, 4);
INSERT INTO public.who_global_data VALUES (49434, 0, 227, 0, 0, 209, 146);
INSERT INTO public.who_global_data VALUES (49435, 51, 1726, 0, 25, 209, 31);
INSERT INTO public.who_global_data VALUES (49436, 0, 12, 0, 1, 209, 127);
INSERT INTO public.who_global_data VALUES (49437, 214, 15542, 2, 245, 209, 22);
INSERT INTO public.who_global_data VALUES (49438, 24, 1135, 0, 9, 209, 115);
INSERT INTO public.who_global_data VALUES (49439, 4, 330, 0, 6, 209, 106);
INSERT INTO public.who_global_data VALUES (49440, 45, 713, 0, 1, 209, 90);
INSERT INTO public.who_global_data VALUES (49441, 0, 0, 0, 0, 209, 70);
INSERT INTO public.who_global_data VALUES (49442, 70, 16719, 3, 38, 209, 46);
INSERT INTO public.who_global_data VALUES (49443, 84, 50750, 5, 6116, 209, 139);
INSERT INTO public.who_global_data VALUES (49444, 0, 21, 0, 0, 209, 42);
INSERT INTO public.who_global_data VALUES (49445, 1, 1194, 0, 22, 209, 80);
INSERT INTO public.who_global_data VALUES (49446, 0, 2411, 0, 91, 209, 203);
INSERT INTO public.who_global_data VALUES (49447, 0, 1099, 0, 68, 209, 136);
INSERT INTO public.who_global_data VALUES (49448, 664, 31987, 15, 724, 209, 63);
INSERT INTO public.who_global_data VALUES (49449, 0, 0, 0, 0, 209, 17);
INSERT INTO public.who_global_data VALUES (49450, 2, 33, 0, 2, 209, 172);
INSERT INTO public.who_global_data VALUES (49451, 197, 7967, 8, 375, 209, 109);
INSERT INTO public.who_global_data VALUES (49452, 0, 8965, 0, 252, 209, 200);
INSERT INTO public.who_global_data VALUES (49453, 463, 6688, 2, 32, 209, 93);
INSERT INTO public.who_global_data VALUES (49454, 1083, 54697, 4, 248, 209, 5);
INSERT INTO public.who_global_data VALUES (49455, 0, 741, 0, 13, 209, 214);
INSERT INTO public.who_global_data VALUES (49456, 2521, 248872, 74, 5197, 209, 204);
INSERT INTO public.who_global_data VALUES (49457, 0, 0, 0, 0, 209, 198);
INSERT INTO public.who_global_data VALUES (49458, 1041, 43257, 24, 863, 209, 173);
INSERT INTO public.who_global_data VALUES (49459, 0, 11, 0, 0, 209, 229);
INSERT INTO public.who_global_data VALUES (49460, 0, 2736, 0, 20, 209, 76);
INSERT INTO public.who_global_data VALUES (49461, 3198, 319646, 186, 11500, 209, 138);
INSERT INTO public.who_global_data VALUES (49462, 1308, 54222, 12, 1372, 209, 98);
INSERT INTO public.who_global_data VALUES (49463, 0, 0, 0, 0, 209, 103);
INSERT INTO public.who_global_data VALUES (49464, 305, 37521, 6, 1568, 209, 225);
INSERT INTO public.who_global_data VALUES (49465, 542, 46221, 8, 1654, 209, 131);
INSERT INTO public.who_global_data VALUES (49466, 229, 9366, 8, 167, 209, 235);
INSERT INTO public.who_global_data VALUES (49467, 498, 103128, 0, 146, 209, 137);
INSERT INTO public.who_global_data VALUES (49468, 44, 13417, 1, 289, 209, 81);
INSERT INTO public.who_global_data VALUES (49469, 284, 19208, 5, 640, 209, 182);
INSERT INTO public.who_global_data VALUES (49470, 6, 577, 0, 3, 209, 145);
INSERT INTO public.who_global_data VALUES (49471, 698, 32079, 24, 1871, 209, 26);
INSERT INTO public.who_global_data VALUES (49472, 6615, 727162, 130, 11335, 209, 170);
INSERT INTO public.who_global_data VALUES (49473, 47, 1299, 0, 3, 209, 191);
INSERT INTO public.who_global_data VALUES (49474, 0, 3, 0, 0, 209, 221);
INSERT INTO public.who_global_data VALUES (49475, 0, 6, 0, 0, 209, 64);
INSERT INTO public.who_global_data VALUES (49476, 0, 0, 0, 0, 209, 116);
INSERT INTO public.who_global_data VALUES (49477, 0, 17, 0, 0, 209, 128);
INSERT INTO public.who_global_data VALUES (49478, 0, 22, 0, 0, 209, 6);
INSERT INTO public.who_global_data VALUES (49479, 0, 44, 0, 3, 209, 227);
INSERT INTO public.who_global_data VALUES (49480, 0, 2, 0, 0, 209, 68);
INSERT INTO public.who_global_data VALUES (49481, 0, 29, 0, 0, 209, 184);
INSERT INTO public.who_global_data VALUES (49482, 0, 0, 0, 0, 209, 82);
INSERT INTO public.who_global_data VALUES (49483, 0, 716, 0, 42, 209, 149);
INSERT INTO public.who_global_data VALUES (49484, 0, 407, 0, 12, 209, 197);
INSERT INTO public.who_global_data VALUES (49485, 2994, 229480, 30, 2181, 209, 78);
INSERT INTO public.who_global_data VALUES (49486, 132, 8014, 0, 145, 209, 233);
INSERT INTO public.who_global_data VALUES (49487, 345, 18073, 12, 382, 209, 133);
INSERT INTO public.who_global_data VALUES (49488, 0, 100, 0, 0, 209, 35);
INSERT INTO public.who_global_data VALUES (49489, 5, 1618, 0, 63, 209, 114);
INSERT INTO public.who_global_data VALUES (49490, 169, 45783, 0, 26, 209, 237);
INSERT INTO public.who_global_data VALUES (49491, 0, 2, 0, 0, 209, 55);
INSERT INTO public.who_global_data VALUES (49492, 0, 78, 0, 15, 209, 176);
INSERT INTO public.who_global_data VALUES (49493, 23, 1893, 0, 28, 209, 202);
INSERT INTO public.who_global_data VALUES (49494, 15, 1842, 0, 114, 209, 155);
INSERT INTO public.who_global_data VALUES (49495, 0, 0, 0, 0, 209, 32);
INSERT INTO public.who_global_data VALUES (49496, 13, 3051, 0, 92, 209, 220);
INSERT INTO public.who_global_data VALUES (49497, 13497, 264184, 111, 3971, 209, 30);
INSERT INTO public.who_global_data VALUES (49498, 10, 2139, 0, 41, 209, 147);
INSERT INTO public.who_global_data VALUES (49499, 1255, 264614, 4, 29786, 209, 208);
INSERT INTO public.who_global_data VALUES (49500, 57, 2511, 0, 11, 209, 45);
INSERT INTO public.who_global_data VALUES (49501, 46, 10250, 1, 650, 209, 110);
INSERT INTO public.who_global_data VALUES (49502, 3, 729, 1, 18, 209, 88);
INSERT INTO public.who_global_data VALUES (49503, 369, 72374, 14, 5642, 209, 51);
INSERT INTO public.who_global_data VALUES (49504, 71, 32882, 0, 1726, 209, 209);
INSERT INTO public.who_global_data VALUES (49505, 0, 394, 0, 16, 209, 205);
INSERT INTO public.who_global_data VALUES (49506, 49, 6505, 0, 55, 209, 18);
INSERT INTO public.who_global_data VALUES (49507, 1, 3217, 0, 58, 209, 72);
INSERT INTO public.who_global_data VALUES (49508, 565, 290954, 17, 40836, 209, 44);
INSERT INTO public.who_global_data VALUES (49509, 0, 24, 0, 0, 209, 15);
INSERT INTO public.who_global_data VALUES (49510, 0, 710, 0, 15, 209, 25);
INSERT INTO public.who_global_data VALUES (49511, 0, 0, 0, 0, 209, 179);
INSERT INTO public.who_global_data VALUES (49512, 0, 0, 0, 0, 209, 34);
INSERT INTO public.who_global_data VALUES (49513, 0, 133, 0, 8, 209, 207);
INSERT INTO public.who_global_data VALUES (49514, 18, 1263, 0, 50, 209, 166);
INSERT INTO public.who_global_data VALUES (49515, 1016, 211981, 21, 5344, 209, 126);
INSERT INTO public.who_global_data VALUES (49516, 0, 0, 0, 0, 209, 97);
INSERT INTO public.who_global_data VALUES (49517, 0, 66, 0, 2, 209, 36);
INSERT INTO public.who_global_data VALUES (49518, 0, 0, 0, 0, 209, 125);
INSERT INTO public.who_global_data VALUES (49519, 7, 1013, 0, 0, 209, 124);
INSERT INTO public.who_global_data VALUES (49520, 678, 53521, 11, 1383, 209, 185);
INSERT INTO public.who_global_data VALUES (49521, 403, 54453, 1, 331, 209, 194);
INSERT INTO public.who_global_data VALUES (49522, 0, 509, 0, 21, 209, 144);
INSERT INTO public.who_global_data VALUES (49523, 66281, 3163581, 803, 133486, 209, 19);
INSERT INTO public.who_global_data VALUES (49524, 14, 167, 0, 6, 209, 217);
INSERT INTO public.who_global_data VALUES (49525, 8, 985, 0, 29, 209, 148);
INSERT INTO public.who_global_data VALUES (49526, 500, 12706, 3, 58, 209, 86);
INSERT INTO public.who_global_data VALUES (49527, 0, 0, 0, 0, 209, 13);
INSERT INTO public.who_global_data VALUES (49528, 431, 8803, 3, 83, 209, 157);
INSERT INTO public.who_global_data VALUES (49529, 0, 370, 0, 0, 209, 8);
INSERT INTO public.who_global_data VALUES (49530, 0, 0, 0, 0, 209, 73);
INSERT INTO public.who_global_data VALUES (49531, 9, 1389, 1, 365, 209, 101);
INSERT INTO public.who_global_data VALUES (49532, 0, 1895, 0, 42, 209, 165);
INSERT INTO public.who_global_data VALUES (49533, 40, 982, 5, 18, 209, 14);
INSERT INTO public.who_global_data VALUES (49534, 157, 34437, 4, 979, 210, 193);
INSERT INTO public.who_global_data VALUES (49535, 93, 3371, 4, 89, 210, 113);
INSERT INTO public.who_global_data VALUES (49536, 434, 18242, 8, 996, 210, 143);
INSERT INTO public.who_global_data VALUES (49537, 0, 0, 0, 0, 210, 219);
INSERT INTO public.who_global_data VALUES (49538, 0, 855, 0, 52, 210, 186);
INSERT INTO public.who_global_data VALUES (49539, 4, 462, 0, 23, 210, 52);
INSERT INTO public.who_global_data VALUES (49540, 0, 3, 0, 0, 210, 180);
INSERT INTO public.who_global_data VALUES (49541, 0, 73, 0, 3, 210, 167);
INSERT INTO public.who_global_data VALUES (49542, 3663, 90693, 42, 1749, 210, 154);
INSERT INTO public.who_global_data VALUES (49543, 489, 30705, 13, 554, 210, 94);
INSERT INTO public.who_global_data VALUES (49544, 0, 105, 0, 3, 210, 66);
INSERT INTO public.who_global_data VALUES (49545, 300, 9359, 0, 106, 210, 58);
INSERT INTO public.who_global_data VALUES (49546, 74, 18687, 0, 706, 210, 163);
INSERT INTO public.who_global_data VALUES (49547, 526, 22990, 8, 292, 210, 37);
INSERT INTO public.who_global_data VALUES (49548, 1, 107, 0, 11, 210, 142);
INSERT INTO public.who_global_data VALUES (49549, 511, 32039, 1, 104, 210, 83);
INSERT INTO public.who_global_data VALUES (49550, 2949, 178443, 37, 2275, 210, 228);
INSERT INTO public.who_global_data VALUES (49551, 0, 98, 0, 7, 210, 188);
INSERT INTO public.who_global_data VALUES (49552, 193, 64604, 5, 454, 210, 62);
INSERT INTO public.who_global_data VALUES (49553, 127, 63093, 0, 9649, 210, 160);
INSERT INTO public.who_global_data VALUES (49554, 3, 33, 0, 2, 210, 50);
INSERT INTO public.who_global_data VALUES (49555, 0, 1285, 0, 23, 210, 33);
INSERT INTO public.who_global_data VALUES (49556, 0, 149, 0, 9, 210, 183);
INSERT INTO public.who_global_data VALUES (49557, 2, 82, 0, 0, 210, 92);
INSERT INTO public.who_global_data VALUES (49558, 1129, 44113, 61, 1638, 210, 158);
INSERT INTO public.who_global_data VALUES (49559, 0, 2, 0, 0, 210, 67);
INSERT INTO public.who_global_data VALUES (49560, 315, 6402, 2, 215, 210, 57);
INSERT INTO public.who_global_data VALUES (49561, 0, 314, 0, 1, 210, 38);
INSERT INTO public.who_global_data VALUES (49562, 42619, 1755779, 1220, 69184, 210, 141);
INSERT INTO public.who_global_data VALUES (49563, 0, 8, 0, 1, 210, 178);
INSERT INTO public.who_global_data VALUES (49564, 0, 141, 0, 3, 210, 108);
INSERT INTO public.who_global_data VALUES (49565, 292, 6964, 0, 262, 210, 39);
INSERT INTO public.who_global_data VALUES (49566, 15, 1020, 1, 54, 210, 2);
INSERT INTO public.who_global_data VALUES (49567, 31, 250, 0, 1, 210, 195);
INSERT INTO public.who_global_data VALUES (49568, 38, 1591, 0, 19, 210, 107);
INSERT INTO public.who_global_data VALUES (49569, 0, 141, 0, 0, 210, 161);
INSERT INTO public.who_global_data VALUES (49570, 0, 14916, 0, 359, 210, 212);
INSERT INTO public.who_global_data VALUES (49571, 371, 106805, 12, 8749, 210, 181);
INSERT INTO public.who_global_data VALUES (49572, 0, 201, 0, 1, 210, 53);
INSERT INTO public.who_global_data VALUES (49573, 0, 4200, 0, 52, 210, 164);
INSERT INTO public.who_global_data VALUES (49574, 1, 874, 0, 74, 210, 140);
INSERT INTO public.who_global_data VALUES (49575, 3058, 309274, 99, 6781, 210, 20);
INSERT INTO public.who_global_data VALUES (49576, 42, 85487, 0, 4648, 210, 112);
INSERT INTO public.who_global_data VALUES (49577, 5335, 133973, 187, 4714, 210, 111);
INSERT INTO public.who_global_data VALUES (49578, 1, 314, 0, 7, 210, 71);
INSERT INTO public.who_global_data VALUES (49579, 0, 2028, 0, 47, 210, 218);
INSERT INTO public.who_global_data VALUES (49580, 0, 0, 0, 0, 210, 43);
INSERT INTO public.who_global_data VALUES (49581, 649, 6485, 2, 26, 210, 49);
INSERT INTO public.who_global_data VALUES (49582, 0, 11504, 0, 78, 210, 1);
INSERT INTO public.who_global_data VALUES (49583, 116, 3532, 2, 117, 210, 48);
INSERT INTO public.who_global_data VALUES (49584, 10, 2413, 0, 86, 210, 232);
INSERT INTO public.who_global_data VALUES (49585, 0, 25, 0, 1, 210, 175);
INSERT INTO public.who_global_data VALUES (49586, 3, 1013, 0, 19, 210, 21);
INSERT INTO public.who_global_data VALUES (49587, 143, 13062, 0, 352, 210, 156);
INSERT INTO public.who_global_data VALUES (49588, 0, 0, 0, 0, 210, 95);
INSERT INTO public.who_global_data VALUES (49589, 59, 7904, 0, 188, 210, 177);
INSERT INTO public.who_global_data VALUES (49590, 30, 12946, 0, 609, 210, 210);
INSERT INTO public.who_global_data VALUES (49591, 13, 4968, 0, 56, 210, 120);
INSERT INTO public.who_global_data VALUES (49592, 0, 18, 0, 0, 210, 135);
INSERT INTO public.who_global_data VALUES (49593, 1125, 41915, 22, 864, 210, 206);
INSERT INTO public.who_global_data VALUES (49594, 783, 65801, 44, 4983, 210, 189);
INSERT INTO public.who_global_data VALUES (49595, 981, 80235, 85, 3702, 210, 129);
INSERT INTO public.who_global_data VALUES (49596, 298, 9142, 6, 249, 210, 121);
INSERT INTO public.who_global_data VALUES (49597, 0, 1043, 0, 12, 210, 59);
INSERT INTO public.who_global_data VALUES (49598, 0, 232, 0, 0, 210, 96);
INSERT INTO public.who_global_data VALUES (49599, 2, 2013, 0, 63, 210, 41);
INSERT INTO public.who_global_data VALUES (49600, 44, 1257, 1, 18, 210, 216);
INSERT INTO public.who_global_data VALUES (49601, 282, 7402, 0, 124, 210, 236);
INSERT INTO public.who_global_data VALUES (49602, 0, 13, 0, 0, 210, 150);
INSERT INTO public.who_global_data VALUES (49603, 0, 188, 0, 0, 210, 61);
INSERT INTO public.who_global_data VALUES (49604, 0, 21, 0, 0, 210, 7);
INSERT INTO public.who_global_data VALUES (49605, 3, 7290, 0, 328, 210, 169);
INSERT INTO public.who_global_data VALUES (49606, 492, 161275, 24, 29910, 210, 28);
INSERT INTO public.who_global_data VALUES (49607, 146, 5704, 1, 23, 210, 85);
INSERT INTO public.who_global_data VALUES (49608, 0, 62, 0, 0, 210, 211);
INSERT INTO public.who_global_data VALUES (49609, 71, 5942, 0, 46, 210, 60);
INSERT INTO public.who_global_data VALUES (49610, 0, 64, 0, 3, 210, 3);
INSERT INTO public.who_global_data VALUES (49611, 8, 981, 0, 15, 210, 11);
INSERT INTO public.who_global_data VALUES (49612, 378, 198556, 6, 9060, 210, 89);
INSERT INTO public.who_global_data VALUES (49613, 0, 23463, 0, 129, 210, 24);
INSERT INTO public.who_global_data VALUES (49614, 1, 180, 0, 0, 210, 162);
INSERT INTO public.who_global_data VALUES (49615, 60, 3732, 0, 193, 210, 100);
INSERT INTO public.who_global_data VALUES (49616, 0, 13, 0, 0, 210, 47);
INSERT INTO public.who_global_data VALUES (49617, 0, 23, 0, 0, 210, 29);
INSERT INTO public.who_global_data VALUES (49618, 6, 190, 0, 14, 210, 40);
INSERT INTO public.who_global_data VALUES (49619, 0, 302, 0, 5, 210, 222);
INSERT INTO public.who_global_data VALUES (49620, 1247, 26658, 39, 1092, 210, 132);
INSERT INTO public.who_global_data VALUES (49621, 0, 252, 0, 13, 210, 130);
INSERT INTO public.who_global_data VALUES (49622, 88, 5969, 1, 37, 210, 234);
INSERT INTO public.who_global_data VALUES (49623, 52, 1842, 0, 25, 210, 23);
INSERT INTO public.who_global_data VALUES (49624, 1, 286, 0, 16, 210, 192);
INSERT INTO public.who_global_data VALUES (49625, 96, 6582, 7, 130, 210, 69);
INSERT INTO public.who_global_data VALUES (49626, 0, 12, 0, 0, 210, 187);
INSERT INTO public.who_global_data VALUES (49627, 406, 26384, 10, 704, 210, 230);
INSERT INTO public.who_global_data VALUES (49628, 3, 4223, 2, 593, 210, 77);
INSERT INTO public.who_global_data VALUES (49629, 0, 1833, 0, 10, 210, 9);
INSERT INTO public.who_global_data VALUES (49630, 27114, 820916, 519, 22123, 210, 74);
INSERT INTO public.who_global_data VALUES (49631, 1611, 72347, 52, 3469, 210, 224);
INSERT INTO public.who_global_data VALUES (49632, 2262, 252720, 142, 12447, 210, 199);
INSERT INTO public.who_global_data VALUES (49633, 2848, 72460, 78, 2960, 210, 190);
INSERT INTO public.who_global_data VALUES (49634, 24, 25589, 1, 1744, 210, 12);
INSERT INTO public.who_global_data VALUES (49635, 0, 336, 0, 24, 210, 104);
INSERT INTO public.who_global_data VALUES (49636, 1525, 35533, 5, 364, 210, 153);
INSERT INTO public.who_global_data VALUES (49637, 276, 242639, 12, 34938, 210, 91);
INSERT INTO public.who_global_data VALUES (49638, 2, 753, 0, 10, 210, 215);
INSERT INTO public.who_global_data VALUES (49639, 410, 21129, 0, 982, 210, 84);
INSERT INTO public.who_global_data VALUES (49640, 0, 325, 0, 31, 210, 231);
INSERT INTO public.who_global_data VALUES (49641, 0, 1088, 0, 10, 210, 196);
INSERT INTO public.who_global_data VALUES (49642, 1798, 58253, 20, 352, 210, 105);
INSERT INTO public.who_global_data VALUES (49643, 473, 9448, 8, 181, 210, 122);
INSERT INTO public.who_global_data VALUES (49644, 0, 0, 0, 0, 210, 159);
INSERT INTO public.who_global_data VALUES (49645, 205, 4469, 3, 87, 210, 75);
INSERT INTO public.who_global_data VALUES (49646, 740, 53580, 1, 383, 210, 27);
INSERT INTO public.who_global_data VALUES (49647, 552, 9910, 3, 125, 210, 54);
INSERT INTO public.who_global_data VALUES (49648, 0, 19, 0, 0, 210, 226);
INSERT INTO public.who_global_data VALUES (49649, 0, 1154, 0, 30, 210, 79);
INSERT INTO public.who_global_data VALUES (49650, 71, 2082, 0, 36, 210, 56);
INSERT INTO public.who_global_data VALUES (49651, 50, 184, 0, 1, 210, 117);
INSERT INTO public.who_global_data VALUES (49652, 6, 963, 5, 47, 210, 152);
INSERT INTO public.who_global_data VALUES (49653, 0, 1342, 0, 38, 210, 16);
INSERT INTO public.who_global_data VALUES (49654, 0, 85, 0, 1, 210, 10);
INSERT INTO public.who_global_data VALUES (49655, 4, 1860, 0, 79, 210, 201);
INSERT INTO public.who_global_data VALUES (49656, 58, 4777, 0, 110, 210, 174);
INSERT INTO public.who_global_data VALUES (49657, 361, 4143, 1, 34, 210, 119);
INSERT INTO public.who_global_data VALUES (49658, 83, 2069, 2, 31, 210, 168);
INSERT INTO public.who_global_data VALUES (49659, 13, 8696, 0, 121, 210, 99);
INSERT INTO public.who_global_data VALUES (49660, 64, 2617, 0, 13, 210, 171);
INSERT INTO public.who_global_data VALUES (49661, 34, 2404, 1, 121, 210, 87);
INSERT INTO public.who_global_data VALUES (49662, 0, 673, 0, 9, 210, 123);
INSERT INTO public.who_global_data VALUES (49663, 0, 0, 0, 0, 210, 151);
INSERT INTO public.who_global_data VALUES (49664, 0, 249, 0, 14, 210, 213);
INSERT INTO public.who_global_data VALUES (49665, 39, 5126, 5, 144, 210, 118);
INSERT INTO public.who_global_data VALUES (49666, 0, 342, 0, 10, 210, 134);
INSERT INTO public.who_global_data VALUES (49667, 9, 2711, 0, 37, 210, 65);
INSERT INTO public.who_global_data VALUES (49668, 7280, 282283, 730, 33526, 210, 102);
INSERT INTO public.who_global_data VALUES (49669, 0, 0, 0, 0, 210, 223);
INSERT INTO public.who_global_data VALUES (49670, 0, 78, 0, 1, 210, 4);
INSERT INTO public.who_global_data VALUES (49671, 0, 227, 0, 0, 210, 146);
INSERT INTO public.who_global_data VALUES (49672, 52, 1675, 4, 25, 210, 31);
INSERT INTO public.who_global_data VALUES (49673, 1, 12, 0, 1, 210, 127);
INSERT INTO public.who_global_data VALUES (49674, 249, 15328, 1, 243, 210, 22);
INSERT INTO public.who_global_data VALUES (49675, 19, 1111, 0, 9, 210, 115);
INSERT INTO public.who_global_data VALUES (49676, 5, 326, 0, 6, 210, 106);
INSERT INTO public.who_global_data VALUES (49677, 53, 668, 1, 1, 210, 90);
INSERT INTO public.who_global_data VALUES (49678, 0, 0, 0, 0, 210, 70);
INSERT INTO public.who_global_data VALUES (49679, 118, 16649, 0, 35, 210, 46);
INSERT INTO public.who_global_data VALUES (49680, 65, 50666, 0, 6111, 210, 139);
INSERT INTO public.who_global_data VALUES (49681, 0, 21, 0, 0, 210, 42);
INSERT INTO public.who_global_data VALUES (49682, 1, 1193, 0, 22, 210, 80);
INSERT INTO public.who_global_data VALUES (49683, 0, 2411, 0, 91, 210, 203);
INSERT INTO public.who_global_data VALUES (49684, 2, 1099, 0, 68, 210, 136);
INSERT INTO public.who_global_data VALUES (49685, 575, 31323, 20, 709, 210, 63);
INSERT INTO public.who_global_data VALUES (49686, 0, 0, 0, 0, 210, 17);
INSERT INTO public.who_global_data VALUES (49687, 0, 31, 0, 2, 210, 172);
INSERT INTO public.who_global_data VALUES (49688, 198, 7770, 5, 367, 210, 109);
INSERT INTO public.who_global_data VALUES (49689, 11, 8965, 0, 252, 210, 200);
INSERT INTO public.who_global_data VALUES (49690, 396, 6225, 3, 30, 210, 93);
INSERT INTO public.who_global_data VALUES (49691, 1889, 53614, 8, 244, 210, 5);
INSERT INTO public.who_global_data VALUES (49692, 0, 741, 0, 13, 210, 214);
INSERT INTO public.who_global_data VALUES (49693, 2755, 246351, 65, 5123, 210, 204);
INSERT INTO public.who_global_data VALUES (49694, 0, 0, 0, 0, 210, 198);
INSERT INTO public.who_global_data VALUES (49695, 965, 42216, 20, 839, 210, 173);
INSERT INTO public.who_global_data VALUES (49696, 0, 11, 0, 0, 210, 229);
INSERT INTO public.who_global_data VALUES (49697, 98, 2736, 0, 20, 210, 76);
INSERT INTO public.who_global_data VALUES (49698, 3537, 316448, 181, 11314, 210, 138);
INSERT INTO public.who_global_data VALUES (49699, 1160, 52914, 42, 1360, 210, 98);
INSERT INTO public.who_global_data VALUES (49700, 0, 0, 0, 0, 210, 103);
INSERT INTO public.who_global_data VALUES (49701, 265, 37216, 11, 1562, 210, 225);
INSERT INTO public.who_global_data VALUES (49702, 402, 45679, 2, 1646, 210, 131);
INSERT INTO public.who_global_data VALUES (49703, 275, 9137, 0, 159, 210, 235);
INSERT INTO public.who_global_data VALUES (49704, 520, 102630, 4, 146, 210, 137);
INSERT INTO public.who_global_data VALUES (49705, 35, 13373, 0, 288, 210, 81);
INSERT INTO public.who_global_data VALUES (49706, 258, 18924, 8, 635, 210, 182);
INSERT INTO public.who_global_data VALUES (49707, 5, 571, 0, 3, 210, 145);
INSERT INTO public.who_global_data VALUES (49708, 592, 31381, 13, 1847, 210, 26);
INSERT INTO public.who_global_data VALUES (49709, 6611, 720547, 188, 11205, 210, 170);
INSERT INTO public.who_global_data VALUES (49710, 42, 1252, 0, 3, 210, 191);
INSERT INTO public.who_global_data VALUES (49711, 0, 3, 0, 0, 210, 221);
INSERT INTO public.who_global_data VALUES (49712, 0, 6, 0, 0, 210, 64);
INSERT INTO public.who_global_data VALUES (49713, 0, 0, 0, 0, 210, 116);
INSERT INTO public.who_global_data VALUES (49714, 1, 17, 0, 0, 210, 128);
INSERT INTO public.who_global_data VALUES (49715, 0, 22, 0, 0, 210, 6);
INSERT INTO public.who_global_data VALUES (49716, 0, 44, 0, 3, 210, 227);
INSERT INTO public.who_global_data VALUES (49717, 0, 2, 0, 0, 210, 68);
INSERT INTO public.who_global_data VALUES (49718, 0, 29, 0, 0, 210, 184);
INSERT INTO public.who_global_data VALUES (49719, 0, 0, 0, 0, 210, 82);
INSERT INTO public.who_global_data VALUES (49720, 0, 716, 0, 42, 210, 149);
INSERT INTO public.who_global_data VALUES (49721, 1, 407, 0, 12, 210, 197);
INSERT INTO public.who_global_data VALUES (49722, 3159, 226486, 51, 2151, 210, 78);
INSERT INTO public.who_global_data VALUES (49723, 98, 7882, 2, 145, 210, 233);
INSERT INTO public.who_global_data VALUES (49724, 386, 17728, 18, 370, 210, 133);
INSERT INTO public.who_global_data VALUES (49725, 0, 100, 0, 0, 210, 35);
INSERT INTO public.who_global_data VALUES (49726, 15, 1613, 0, 63, 210, 114);
INSERT INTO public.who_global_data VALUES (49727, 191, 45614, 0, 26, 210, 237);
INSERT INTO public.who_global_data VALUES (49728, 0, 2, 0, 0, 210, 55);
INSERT INTO public.who_global_data VALUES (49729, 0, 78, 0, 15, 210, 176);
INSERT INTO public.who_global_data VALUES (49730, 19, 1870, 0, 28, 210, 202);
INSERT INTO public.who_global_data VALUES (49731, 34, 1827, 0, 114, 210, 155);
INSERT INTO public.who_global_data VALUES (49732, 0, 0, 0, 0, 210, 32);
INSERT INTO public.who_global_data VALUES (49733, 0, 3038, 0, 92, 210, 220);
INSERT INTO public.who_global_data VALUES (49734, 12348, 250687, 140, 3860, 210, 30);
INSERT INTO public.who_global_data VALUES (49735, 0, 2129, 0, 41, 210, 147);
INSERT INTO public.who_global_data VALUES (49736, 925, 263359, 2, 29782, 210, 208);
INSERT INTO public.who_global_data VALUES (49737, 104, 2454, 0, 11, 210, 45);
INSERT INTO public.who_global_data VALUES (49738, 0, 10204, 0, 649, 210, 110);
INSERT INTO public.who_global_data VALUES (49739, 55, 726, 0, 17, 210, 88);
INSERT INTO public.who_global_data VALUES (49740, 334, 72005, 15, 5628, 210, 51);
INSERT INTO public.who_global_data VALUES (49741, 111, 32811, 0, 1726, 210, 209);
INSERT INTO public.who_global_data VALUES (49742, 22, 394, 2, 16, 210, 205);
INSERT INTO public.who_global_data VALUES (49743, 47, 6456, 1, 55, 210, 18);
INSERT INTO public.who_global_data VALUES (49744, 14, 3216, 0, 58, 210, 72);
INSERT INTO public.who_global_data VALUES (49745, 715, 290389, 34, 40819, 210, 44);
INSERT INTO public.who_global_data VALUES (49746, 0, 24, 0, 0, 210, 15);
INSERT INTO public.who_global_data VALUES (49747, 6, 710, 0, 15, 210, 25);
INSERT INTO public.who_global_data VALUES (49748, 0, 0, 0, 0, 210, 179);
INSERT INTO public.who_global_data VALUES (49749, 0, 0, 0, 0, 210, 34);
INSERT INTO public.who_global_data VALUES (49750, 0, 133, 0, 8, 210, 207);
INSERT INTO public.who_global_data VALUES (49751, 5, 1245, 0, 50, 210, 166);
INSERT INTO public.who_global_data VALUES (49752, 1003, 210965, 23, 5323, 210, 126);
INSERT INTO public.who_global_data VALUES (49753, 0, 0, 0, 0, 210, 97);
INSERT INTO public.who_global_data VALUES (49754, 11, 66, 0, 2, 210, 36);
INSERT INTO public.who_global_data VALUES (49755, 0, 0, 0, 0, 210, 125);
INSERT INTO public.who_global_data VALUES (49756, 6, 1006, 0, 0, 210, 124);
INSERT INTO public.who_global_data VALUES (49757, 800, 52843, 27, 1372, 210, 185);
INSERT INTO public.who_global_data VALUES (49758, 473, 54050, 2, 330, 210, 194);
INSERT INTO public.who_global_data VALUES (49759, 0, 509, 0, 21, 210, 144);
INSERT INTO public.who_global_data VALUES (49760, 58975, 3097300, 799, 132683, 210, 19);
INSERT INTO public.who_global_data VALUES (49761, 9, 153, 0, 6, 210, 217);
INSERT INTO public.who_global_data VALUES (49762, 3, 977, 0, 29, 210, 148);
INSERT INTO public.who_global_data VALUES (49763, 483, 12206, 3, 55, 210, 86);
INSERT INTO public.who_global_data VALUES (49764, 0, 0, 0, 0, 210, 13);
INSERT INTO public.who_global_data VALUES (49765, 362, 8372, 5, 80, 210, 157);
INSERT INTO public.who_global_data VALUES (49766, 1, 370, 0, 0, 210, 8);
INSERT INTO public.who_global_data VALUES (49767, 0, 0, 0, 0, 210, 73);
INSERT INTO public.who_global_data VALUES (49768, 24, 1380, 3, 364, 210, 101);
INSERT INTO public.who_global_data VALUES (49769, 0, 1895, 0, 42, 210, 165);
INSERT INTO public.who_global_data VALUES (49770, 16, 942, 1, 13, 210, 14);
INSERT INTO public.who_global_data VALUES (49771, 541, 34280, 34, 975, 211, 193);
INSERT INTO public.who_global_data VALUES (49772, 90, 3278, 2, 85, 211, 113);
INSERT INTO public.who_global_data VALUES (49773, 460, 17808, 10, 988, 211, 143);
INSERT INTO public.who_global_data VALUES (49774, 0, 0, 0, 0, 211, 219);
INSERT INTO public.who_global_data VALUES (49775, 0, 855, 0, 52, 211, 186);
INSERT INTO public.who_global_data VALUES (49776, 62, 458, 1, 23, 211, 52);
INSERT INTO public.who_global_data VALUES (49777, 0, 3, 0, 0, 211, 180);
INSERT INTO public.who_global_data VALUES (49778, 3, 73, 0, 3, 211, 167);
INSERT INTO public.who_global_data VALUES (49779, 3604, 87030, 53, 1707, 211, 154);
INSERT INTO public.who_global_data VALUES (49780, 557, 30216, 11, 541, 211, 94);
INSERT INTO public.who_global_data VALUES (49781, 0, 105, 0, 3, 211, 66);
INSERT INTO public.who_global_data VALUES (49782, 173, 9059, 0, 106, 211, 58);
INSERT INTO public.who_global_data VALUES (49783, 97, 18613, 0, 706, 211, 163);
INSERT INTO public.who_global_data VALUES (49784, 548, 22464, 10, 284, 211, 37);
INSERT INTO public.who_global_data VALUES (49785, 2, 106, 0, 11, 211, 142);
INSERT INTO public.who_global_data VALUES (49786, 597, 31528, 5, 103, 211, 83);
INSERT INTO public.who_global_data VALUES (49787, 3360, 175494, 41, 2238, 211, 228);
INSERT INTO public.who_global_data VALUES (49788, 0, 98, 0, 7, 211, 188);
INSERT INTO public.who_global_data VALUES (49789, 187, 64411, 6, 449, 211, 62);
INSERT INTO public.who_global_data VALUES (49790, 124, 62966, 2, 9649, 211, 160);
INSERT INTO public.who_global_data VALUES (49791, 0, 30, 0, 2, 211, 50);
INSERT INTO public.who_global_data VALUES (49792, 0, 1285, 0, 23, 211, 33);
INSERT INTO public.who_global_data VALUES (49793, 0, 149, 0, 9, 211, 183);
INSERT INTO public.who_global_data VALUES (49794, 0, 80, 0, 0, 211, 92);
INSERT INTO public.who_global_data VALUES (49795, 1439, 42984, 47, 1577, 211, 158);
INSERT INTO public.who_global_data VALUES (49796, 0, 2, 0, 0, 211, 67);
INSERT INTO public.who_global_data VALUES (49797, 219, 6087, 6, 213, 211, 57);
INSERT INTO public.who_global_data VALUES (49798, 0, 314, 0, 1, 211, 38);
INSERT INTO public.who_global_data VALUES (49799, 44571, 1713160, 1223, 67964, 211, 141);
INSERT INTO public.who_global_data VALUES (49800, 0, 8, 0, 1, 211, 178);
INSERT INTO public.who_global_data VALUES (49801, 0, 141, 0, 3, 211, 108);
INSERT INTO public.who_global_data VALUES (49802, 330, 6672, 3, 262, 211, 39);
INSERT INTO public.who_global_data VALUES (49803, 2, 1005, 0, 53, 211, 2);
INSERT INTO public.who_global_data VALUES (49804, 0, 219, 0, 1, 211, 195);
INSERT INTO public.who_global_data VALUES (49805, 11, 1553, 1, 19, 211, 107);
INSERT INTO public.who_global_data VALUES (49806, 0, 141, 0, 0, 211, 161);
INSERT INTO public.who_global_data VALUES (49807, 0, 14916, 0, 359, 211, 212);
INSERT INTO public.who_global_data VALUES (49808, 267, 106434, 26, 8737, 211, 181);
INSERT INTO public.who_global_data VALUES (49809, 0, 201, 0, 1, 211, 53);
INSERT INTO public.who_global_data VALUES (49810, 91, 4200, 0, 52, 211, 164);
INSERT INTO public.who_global_data VALUES (49811, 0, 873, 0, 74, 211, 140);
INSERT INTO public.who_global_data VALUES (49812, 3133, 306216, 109, 6682, 211, 20);
INSERT INTO public.who_global_data VALUES (49813, 46, 85445, 0, 4648, 211, 112);
INSERT INTO public.who_global_data VALUES (49814, 4144, 128638, 168, 4527, 211, 111);
INSERT INTO public.who_global_data VALUES (49815, 0, 313, 0, 7, 211, 71);
INSERT INTO public.who_global_data VALUES (49816, 207, 2028, 0, 47, 211, 218);
INSERT INTO public.who_global_data VALUES (49817, 0, 0, 0, 0, 211, 43);
INSERT INTO public.who_global_data VALUES (49818, 350, 5836, 1, 24, 211, 49);
INSERT INTO public.who_global_data VALUES (49819, 0, 11504, 0, 78, 211, 1);
INSERT INTO public.who_global_data VALUES (49820, 91, 3416, 1, 115, 211, 48);
INSERT INTO public.who_global_data VALUES (49821, 4, 2403, 0, 86, 211, 232);
INSERT INTO public.who_global_data VALUES (49822, 0, 25, 0, 1, 211, 175);
INSERT INTO public.who_global_data VALUES (49823, 2, 1010, 0, 19, 211, 21);
INSERT INTO public.who_global_data VALUES (49824, 105, 12919, 1, 352, 211, 156);
INSERT INTO public.who_global_data VALUES (49825, 0, 0, 0, 0, 211, 95);
INSERT INTO public.who_global_data VALUES (49826, 109, 7845, 5, 188, 211, 177);
INSERT INTO public.who_global_data VALUES (49827, 16, 12916, 0, 609, 211, 210);
INSERT INTO public.who_global_data VALUES (49828, 66, 4955, 1, 56, 211, 120);
INSERT INTO public.who_global_data VALUES (49829, 0, 18, 0, 0, 211, 135);
INSERT INTO public.who_global_data VALUES (49830, 1202, 40790, 13, 842, 211, 206);
INSERT INTO public.who_global_data VALUES (49831, 1773, 65018, 66, 4939, 211, 189);
INSERT INTO public.who_global_data VALUES (49832, 950, 79254, 53, 3617, 211, 129);
INSERT INTO public.who_global_data VALUES (49833, 278, 8844, 8, 243, 211, 121);
INSERT INTO public.who_global_data VALUES (49834, 0, 1043, 0, 12, 211, 59);
INSERT INTO public.who_global_data VALUES (49835, 17, 232, 0, 0, 211, 96);
INSERT INTO public.who_global_data VALUES (49836, 8, 2011, 0, 63, 211, 41);
INSERT INTO public.who_global_data VALUES (49837, 75, 1213, 3, 17, 211, 216);
INSERT INTO public.who_global_data VALUES (49838, 147, 7120, 4, 124, 211, 236);
INSERT INTO public.who_global_data VALUES (49839, 0, 13, 0, 0, 211, 150);
INSERT INTO public.who_global_data VALUES (49840, 0, 188, 0, 0, 211, 61);
INSERT INTO public.who_global_data VALUES (49841, 0, 21, 0, 0, 211, 7);
INSERT INTO public.who_global_data VALUES (49842, 4, 7287, 0, 328, 211, 169);
INSERT INTO public.who_global_data VALUES (49843, 504, 160783, 13, 29886, 211, 28);
INSERT INTO public.who_global_data VALUES (49844, 99, 5558, 0, 22, 211, 85);
INSERT INTO public.who_global_data VALUES (49845, 0, 62, 0, 0, 211, 211);
INSERT INTO public.who_global_data VALUES (49846, 0, 5871, 0, 46, 211, 60);
INSERT INTO public.who_global_data VALUES (49847, 1, 64, 0, 3, 211, 3);
INSERT INTO public.who_global_data VALUES (49848, 5, 973, 0, 15, 211, 11);
INSERT INTO public.who_global_data VALUES (49849, 395, 198178, 6, 9054, 211, 89);
INSERT INTO public.who_global_data VALUES (49850, 641, 23463, 0, 129, 211, 24);
INSERT INTO public.who_global_data VALUES (49851, 0, 179, 0, 0, 211, 162);
INSERT INTO public.who_global_data VALUES (49852, 50, 3672, 0, 193, 211, 100);
INSERT INTO public.who_global_data VALUES (49853, 0, 13, 0, 0, 211, 47);
INSERT INTO public.who_global_data VALUES (49854, 0, 23, 0, 0, 211, 29);
INSERT INTO public.who_global_data VALUES (49855, 0, 184, 0, 14, 211, 40);
INSERT INTO public.who_global_data VALUES (49856, 3, 302, 0, 5, 211, 222);
INSERT INTO public.who_global_data VALUES (49857, 624, 25411, 49, 1053, 211, 132);
INSERT INTO public.who_global_data VALUES (49858, 0, 252, 0, 13, 211, 130);
INSERT INTO public.who_global_data VALUES (49859, 184, 5881, 2, 36, 211, 234);
INSERT INTO public.who_global_data VALUES (49860, 0, 1790, 0, 25, 211, 23);
INSERT INTO public.who_global_data VALUES (49861, 1, 285, 0, 16, 211, 192);
INSERT INTO public.who_global_data VALUES (49862, 54, 6486, 6, 123, 211, 69);
INSERT INTO public.who_global_data VALUES (49863, 0, 12, 0, 0, 211, 187);
INSERT INTO public.who_global_data VALUES (49864, 550, 25978, 17, 694, 211, 230);
INSERT INTO public.who_global_data VALUES (49865, 10, 4220, 2, 591, 211, 77);
INSERT INTO public.who_global_data VALUES (49866, 0, 1833, 0, 10, 211, 9);
INSERT INTO public.who_global_data VALUES (49867, 26506, 793802, 475, 21604, 211, 74);
INSERT INTO public.who_global_data VALUES (49868, 2657, 70736, 58, 3417, 211, 224);
INSERT INTO public.who_global_data VALUES (49869, 2079, 250458, 221, 12305, 211, 199);
INSERT INTO public.who_global_data VALUES (49870, 2170, 69612, 103, 2882, 211, 190);
INSERT INTO public.who_global_data VALUES (49871, 23, 25565, 0, 1743, 211, 12);
INSERT INTO public.who_global_data VALUES (49872, 0, 336, 0, 24, 211, 104);
INSERT INTO public.who_global_data VALUES (49873, 1327, 34008, 5, 359, 211, 153);
INSERT INTO public.who_global_data VALUES (49874, 214, 242363, 12, 34926, 211, 91);
INSERT INTO public.who_global_data VALUES (49875, 6, 751, 0, 10, 211, 215);
INSERT INTO public.who_global_data VALUES (49876, 348, 20719, 1, 982, 211, 84);
INSERT INTO public.who_global_data VALUES (49877, 0, 325, 0, 31, 211, 231);
INSERT INTO public.who_global_data VALUES (49878, 0, 1088, 0, 10, 211, 196);
INSERT INTO public.who_global_data VALUES (49879, 1708, 56455, 19, 332, 211, 105);
INSERT INTO public.who_global_data VALUES (49880, 447, 8975, 4, 173, 211, 122);
INSERT INTO public.who_global_data VALUES (49881, 0, 0, 0, 0, 211, 159);
INSERT INTO public.who_global_data VALUES (49882, 207, 4264, 8, 84, 211, 75);
INSERT INTO public.who_global_data VALUES (49883, 833, 52840, 3, 382, 211, 27);
INSERT INTO public.who_global_data VALUES (49884, 511, 9358, 6, 122, 211, 54);
INSERT INTO public.who_global_data VALUES (49885, 0, 19, 0, 0, 211, 226);
INSERT INTO public.who_global_data VALUES (49886, 13, 1154, 0, 30, 211, 79);
INSERT INTO public.who_global_data VALUES (49887, 66, 2011, 0, 36, 211, 56);
INSERT INTO public.who_global_data VALUES (49888, 0, 134, 0, 1, 211, 117);
INSERT INTO public.who_global_data VALUES (49889, 31, 957, 1, 42, 211, 152);
INSERT INTO public.who_global_data VALUES (49890, 74, 1342, 2, 38, 211, 16);
INSERT INTO public.who_global_data VALUES (49891, 0, 85, 0, 1, 211, 10);
INSERT INTO public.who_global_data VALUES (49892, 4, 1856, 0, 79, 211, 201);
INSERT INTO public.who_global_data VALUES (49893, 69, 4719, 0, 110, 211, 174);
INSERT INTO public.who_global_data VALUES (49894, 209, 3782, 0, 33, 211, 119);
INSERT INTO public.who_global_data VALUES (49895, 44, 1986, 4, 29, 211, 168);
INSERT INTO public.who_global_data VALUES (49896, 6, 8683, 0, 121, 211, 99);
INSERT INTO public.who_global_data VALUES (49897, 36, 2553, 0, 13, 211, 171);
INSERT INTO public.who_global_data VALUES (49898, 12, 2370, 0, 120, 211, 87);
INSERT INTO public.who_global_data VALUES (49899, 0, 673, 0, 9, 211, 123);
INSERT INTO public.who_global_data VALUES (49900, 0, 0, 0, 0, 211, 151);
INSERT INTO public.who_global_data VALUES (49901, 0, 249, 0, 14, 211, 213);
INSERT INTO public.who_global_data VALUES (49902, 63, 5087, 4, 139, 211, 118);
INSERT INTO public.who_global_data VALUES (49903, 0, 342, 0, 10, 211, 134);
INSERT INTO public.who_global_data VALUES (49904, 14, 2702, 1, 37, 211, 65);
INSERT INTO public.who_global_data VALUES (49905, 6995, 275003, 782, 32796, 211, 102);
INSERT INTO public.who_global_data VALUES (49906, 0, 0, 0, 0, 211, 223);
INSERT INTO public.who_global_data VALUES (49907, 0, 78, 0, 1, 211, 4);
INSERT INTO public.who_global_data VALUES (49908, 0, 227, 0, 0, 211, 146);
INSERT INTO public.who_global_data VALUES (49909, 108, 1623, 1, 21, 211, 31);
INSERT INTO public.who_global_data VALUES (49910, 0, 11, 0, 1, 211, 127);
INSERT INTO public.who_global_data VALUES (49911, 308, 15079, 0, 242, 211, 22);
INSERT INTO public.who_global_data VALUES (49912, 21, 1092, 1, 9, 211, 115);
INSERT INTO public.who_global_data VALUES (49913, 3, 321, 0, 6, 211, 106);
INSERT INTO public.who_global_data VALUES (49914, 22, 615, 0, 0, 211, 90);
INSERT INTO public.who_global_data VALUES (49915, 0, 0, 0, 0, 211, 70);
INSERT INTO public.who_global_data VALUES (49916, 108, 16531, 0, 35, 211, 46);
INSERT INTO public.who_global_data VALUES (49917, 60, 50601, 2, 6111, 211, 139);
INSERT INTO public.who_global_data VALUES (49918, 0, 21, 0, 0, 211, 42);
INSERT INTO public.who_global_data VALUES (49919, 2, 1192, 0, 22, 211, 80);
INSERT INTO public.who_global_data VALUES (49920, 0, 2411, 0, 91, 211, 203);
INSERT INTO public.who_global_data VALUES (49921, 0, 1097, 0, 68, 211, 136);
INSERT INTO public.who_global_data VALUES (49922, 499, 30748, 5, 689, 211, 63);
INSERT INTO public.who_global_data VALUES (49923, 0, 0, 0, 0, 211, 17);
INSERT INTO public.who_global_data VALUES (49924, 0, 31, 0, 2, 211, 172);
INSERT INTO public.who_global_data VALUES (49925, 167, 7572, 3, 362, 211, 109);
INSERT INTO public.who_global_data VALUES (49926, 7, 8954, 1, 252, 211, 200);
INSERT INTO public.who_global_data VALUES (49927, 262, 5829, 3, 27, 211, 93);
INSERT INTO public.who_global_data VALUES (49928, 1518, 51725, 3, 236, 211, 5);
INSERT INTO public.who_global_data VALUES (49929, 0, 741, 0, 13, 211, 214);
INSERT INTO public.who_global_data VALUES (49930, 2748, 243596, 75, 5058, 211, 204);
INSERT INTO public.who_global_data VALUES (49931, 0, 0, 0, 0, 211, 198);
INSERT INTO public.who_global_data VALUES (49932, 960, 41251, 20, 819, 211, 173);
INSERT INTO public.who_global_data VALUES (49933, 0, 11, 0, 0, 211, 229);
INSERT INTO public.who_global_data VALUES (49934, 84, 2638, 0, 20, 211, 76);
INSERT INTO public.who_global_data VALUES (49935, 3633, 312911, 181, 11133, 211, 138);
INSERT INTO public.who_global_data VALUES (49936, 1395, 51754, 4, 1318, 211, 98);
INSERT INTO public.who_global_data VALUES (49937, 0, 0, 0, 0, 211, 103);
INSERT INTO public.who_global_data VALUES (49938, 262, 36951, 9, 1551, 211, 225);
INSERT INTO public.who_global_data VALUES (49939, 418, 45277, 13, 1644, 211, 131);
INSERT INTO public.who_global_data VALUES (49940, 117, 8862, 0, 159, 211, 235);
INSERT INTO public.who_global_data VALUES (49941, 557, 102110, 4, 142, 211, 137);
INSERT INTO public.who_global_data VALUES (49942, 45, 13338, 1, 288, 211, 81);
INSERT INTO public.who_global_data VALUES (49943, 195, 18666, 13, 627, 211, 182);
INSERT INTO public.who_global_data VALUES (49944, 3, 566, 0, 3, 211, 145);
INSERT INTO public.who_global_data VALUES (49945, 614, 30789, 17, 1834, 211, 26);
INSERT INTO public.who_global_data VALUES (49946, 6635, 713936, 174, 11017, 211, 170);
INSERT INTO public.who_global_data VALUES (49947, 16, 1210, 0, 3, 211, 191);
INSERT INTO public.who_global_data VALUES (49948, 0, 3, 0, 0, 211, 221);
INSERT INTO public.who_global_data VALUES (49949, 0, 6, 0, 0, 211, 64);
INSERT INTO public.who_global_data VALUES (49950, 0, 0, 0, 0, 211, 116);
INSERT INTO public.who_global_data VALUES (49951, 0, 16, 0, 0, 211, 128);
INSERT INTO public.who_global_data VALUES (49952, 0, 22, 0, 0, 211, 6);
INSERT INTO public.who_global_data VALUES (49953, 0, 44, 0, 3, 211, 227);
INSERT INTO public.who_global_data VALUES (49954, 1, 2, 0, 0, 211, 68);
INSERT INTO public.who_global_data VALUES (49955, 0, 29, 0, 0, 211, 184);
INSERT INTO public.who_global_data VALUES (49956, 0, 0, 0, 0, 211, 82);
INSERT INTO public.who_global_data VALUES (49957, 3, 716, 0, 42, 211, 149);
INSERT INTO public.who_global_data VALUES (49958, 2, 406, 1, 12, 211, 197);
INSERT INTO public.who_global_data VALUES (49959, 3183, 223327, 41, 2100, 211, 78);
INSERT INTO public.who_global_data VALUES (49960, 127, 7784, 2, 143, 211, 233);
INSERT INTO public.who_global_data VALUES (49961, 266, 17342, 11, 352, 211, 133);
INSERT INTO public.who_global_data VALUES (49962, 6, 100, 0, 0, 211, 35);
INSERT INTO public.who_global_data VALUES (49963, 14, 1598, 0, 63, 211, 114);
INSERT INTO public.who_global_data VALUES (49964, 125, 45423, 0, 26, 211, 237);
INSERT INTO public.who_global_data VALUES (49965, 0, 2, 0, 0, 211, 55);
INSERT INTO public.who_global_data VALUES (49966, 0, 78, 0, 15, 211, 176);
INSERT INTO public.who_global_data VALUES (49967, 53, 1851, 0, 28, 211, 202);
INSERT INTO public.who_global_data VALUES (49968, 17, 1793, 0, 114, 211, 155);
INSERT INTO public.who_global_data VALUES (49969, 0, 0, 0, 0, 211, 32);
INSERT INTO public.who_global_data VALUES (49970, 10, 3038, 0, 92, 211, 220);
INSERT INTO public.who_global_data VALUES (49971, 13674, 238339, 118, 3720, 211, 30);
INSERT INTO public.who_global_data VALUES (49972, 23, 2129, 1, 41, 211, 147);
INSERT INTO public.who_global_data VALUES (49973, 804, 262434, 4, 29780, 211, 208);
INSERT INTO public.who_global_data VALUES (49974, 256, 2350, 0, 11, 211, 45);
INSERT INTO public.who_global_data VALUES (49975, 120, 10204, 13, 649, 211, 110);
INSERT INTO public.who_global_data VALUES (49976, 36, 671, 0, 17, 211, 88);
INSERT INTO public.who_global_data VALUES (49977, 533, 71671, 10, 5613, 211, 51);
INSERT INTO public.who_global_data VALUES (49978, 97, 32700, 0, 1726, 211, 209);
INSERT INTO public.who_global_data VALUES (49979, 0, 372, 0, 14, 211, 205);
INSERT INTO public.who_global_data VALUES (49980, 46, 6409, 0, 54, 211, 18);
INSERT INTO public.who_global_data VALUES (49981, 0, 3202, 0, 58, 211, 72);
INSERT INTO public.who_global_data VALUES (49982, 693, 289674, 31, 40785, 211, 44);
INSERT INTO public.who_global_data VALUES (49983, 0, 24, 0, 0, 211, 15);
INSERT INTO public.who_global_data VALUES (49984, 9, 704, 0, 15, 211, 25);
INSERT INTO public.who_global_data VALUES (49985, 0, 0, 0, 0, 211, 179);
INSERT INTO public.who_global_data VALUES (49986, 0, 0, 0, 0, 211, 34);
INSERT INTO public.who_global_data VALUES (49987, 0, 133, 0, 8, 211, 207);
INSERT INTO public.who_global_data VALUES (49988, 9, 1240, 0, 50, 211, 166);
INSERT INTO public.who_global_data VALUES (49989, 1024, 209962, 18, 5300, 211, 126);
INSERT INTO public.who_global_data VALUES (49990, 0, 0, 0, 0, 211, 97);
INSERT INTO public.who_global_data VALUES (49991, 0, 55, 0, 2, 211, 36);
INSERT INTO public.who_global_data VALUES (49992, 0, 0, 0, 0, 211, 125);
INSERT INTO public.who_global_data VALUES (49993, 23, 1000, 0, 0, 211, 124);
INSERT INTO public.who_global_data VALUES (49994, 819, 52043, 18, 1345, 211, 185);
INSERT INTO public.who_global_data VALUES (49995, 532, 53577, 1, 328, 211, 194);
INSERT INTO public.who_global_data VALUES (49996, 0, 509, 0, 21, 211, 144);
INSERT INTO public.who_global_data VALUES (49997, 64630, 3038325, 991, 131884, 211, 19);
INSERT INTO public.who_global_data VALUES (49998, 22, 144, 0, 6, 211, 217);
INSERT INTO public.who_global_data VALUES (49999, 9, 974, 0, 29, 211, 148);
INSERT INTO public.who_global_data VALUES (50000, 464, 11723, 5, 52, 211, 86);
INSERT INTO public.who_global_data VALUES (50001, 0, 0, 0, 0, 211, 13);
INSERT INTO public.who_global_data VALUES (50002, 317, 8010, 4, 75, 211, 157);
INSERT INTO public.who_global_data VALUES (50003, 0, 369, 0, 0, 211, 8);
INSERT INTO public.who_global_data VALUES (50004, 0, 0, 0, 0, 211, 73);
INSERT INTO public.who_global_data VALUES (50005, 38, 1356, 10, 361, 211, 101);
INSERT INTO public.who_global_data VALUES (50006, 0, 1895, 0, 42, 211, 165);
INSERT INTO public.who_global_data VALUES (50007, 41, 926, 3, 12, 211, 14);
INSERT INTO public.who_global_data VALUES (50008, 59, 33739, 1, 941, 212, 193);
INSERT INTO public.who_global_data VALUES (50009, 82, 3188, 0, 83, 212, 113);
INSERT INTO public.who_global_data VALUES (50010, 469, 17348, 10, 978, 212, 143);
INSERT INTO public.who_global_data VALUES (50011, 0, 0, 0, 0, 212, 219);
INSERT INTO public.who_global_data VALUES (50012, 0, 855, 0, 52, 212, 186);
INSERT INTO public.who_global_data VALUES (50013, 10, 396, 1, 22, 212, 52);
INSERT INTO public.who_global_data VALUES (50014, 0, 3, 0, 0, 212, 180);
INSERT INTO public.who_global_data VALUES (50015, 0, 70, 0, 3, 212, 167);
INSERT INTO public.who_global_data VALUES (50016, 2979, 83426, 52, 1654, 212, 154);
INSERT INTO public.who_global_data VALUES (50017, 526, 29659, 14, 530, 212, 94);
INSERT INTO public.who_global_data VALUES (50018, 0, 105, 0, 3, 212, 66);
INSERT INTO public.who_global_data VALUES (50019, 131, 8886, 0, 106, 212, 58);
INSERT INTO public.who_global_data VALUES (50020, 101, 18516, 0, 706, 212, 163);
INSERT INTO public.who_global_data VALUES (50021, 542, 21916, 9, 274, 212, 37);
INSERT INTO public.who_global_data VALUES (50022, 0, 104, 0, 11, 212, 142);
INSERT INTO public.who_global_data VALUES (50023, 610, 30931, 0, 98, 212, 83);
INSERT INTO public.who_global_data VALUES (50024, 3489, 172134, 46, 2197, 212, 228);
INSERT INTO public.who_global_data VALUES (50025, 0, 98, 0, 7, 212, 188);
INSERT INTO public.who_global_data VALUES (50026, 221, 64224, 7, 443, 212, 62);
INSERT INTO public.who_global_data VALUES (50027, 137, 62842, 1, 9647, 212, 160);
INSERT INTO public.who_global_data VALUES (50028, 0, 30, 0, 2, 212, 50);
INSERT INTO public.who_global_data VALUES (50029, 0, 1285, 0, 23, 212, 33);
INSERT INTO public.who_global_data VALUES (50030, 3, 149, 0, 9, 212, 183);
INSERT INTO public.who_global_data VALUES (50031, 0, 80, 0, 0, 212, 92);
INSERT INTO public.who_global_data VALUES (50032, 1036, 41545, 54, 1530, 212, 158);
INSERT INTO public.who_global_data VALUES (50033, 0, 2, 0, 0, 212, 67);
INSERT INTO public.who_global_data VALUES (50034, 250, 5868, 1, 207, 212, 57);
INSERT INTO public.who_global_data VALUES (50035, 0, 314, 0, 1, 212, 38);
INSERT INTO public.who_global_data VALUES (50036, 45305, 1668589, 1254, 66741, 212, 141);
INSERT INTO public.who_global_data VALUES (50037, 0, 8, 0, 1, 212, 178);
INSERT INTO public.who_global_data VALUES (50038, 0, 141, 0, 3, 212, 108);
INSERT INTO public.who_global_data VALUES (50039, 240, 6342, 5, 259, 212, 39);
INSERT INTO public.who_global_data VALUES (50040, 0, 1003, 0, 53, 212, 2);
INSERT INTO public.who_global_data VALUES (50041, 28, 219, 0, 1, 212, 195);
INSERT INTO public.who_global_data VALUES (50042, 43, 1542, 0, 18, 212, 107);
INSERT INTO public.who_global_data VALUES (50043, 0, 141, 0, 0, 212, 161);
INSERT INTO public.who_global_data VALUES (50044, 0, 14916, 0, 359, 212, 212);
INSERT INTO public.who_global_data VALUES (50045, 232, 106167, 18, 8711, 212, 181);
INSERT INTO public.who_global_data VALUES (50046, 0, 201, 0, 1, 212, 53);
INSERT INTO public.who_global_data VALUES (50047, 38, 4109, 0, 52, 212, 164);
INSERT INTO public.who_global_data VALUES (50048, 0, 873, 0, 74, 212, 140);
INSERT INTO public.who_global_data VALUES (50049, 2064, 303083, 139, 6573, 212, 20);
INSERT INTO public.who_global_data VALUES (50050, 33, 85399, 0, 4648, 212, 112);
INSERT INTO public.who_global_data VALUES (50051, 4213, 124494, 149, 4359, 212, 111);
INSERT INTO public.who_global_data VALUES (50052, 0, 313, 0, 7, 212, 71);
INSERT INTO public.who_global_data VALUES (50053, 64, 1821, 3, 47, 212, 218);
INSERT INTO public.who_global_data VALUES (50054, 0, 0, 0, 0, 212, 43);
INSERT INTO public.who_global_data VALUES (50055, 245, 5486, 0, 23, 212, 49);
INSERT INTO public.who_global_data VALUES (50056, 538, 11504, 3, 78, 212, 1);
INSERT INTO public.who_global_data VALUES (50057, 53, 3325, 1, 114, 212, 48);
INSERT INTO public.who_global_data VALUES (50058, 4, 2399, 0, 86, 212, 232);
INSERT INTO public.who_global_data VALUES (50059, 0, 25, 0, 1, 212, 175);
INSERT INTO public.who_global_data VALUES (50060, 3, 1008, 0, 19, 212, 21);
INSERT INTO public.who_global_data VALUES (50061, 129, 12814, 0, 351, 212, 156);
INSERT INTO public.who_global_data VALUES (50062, 0, 0, 0, 0, 212, 95);
INSERT INTO public.who_global_data VALUES (50063, 77, 7736, 1, 183, 212, 177);
INSERT INTO public.who_global_data VALUES (50064, 12, 12900, 0, 609, 212, 210);
INSERT INTO public.who_global_data VALUES (50065, 11, 4889, 0, 55, 212, 120);
INSERT INTO public.who_global_data VALUES (50066, 0, 18, 0, 0, 212, 135);
INSERT INTO public.who_global_data VALUES (50067, 1158, 39588, 8, 829, 212, 206);
INSERT INTO public.who_global_data VALUES (50068, 0, 63245, 0, 4873, 212, 189);
INSERT INTO public.who_global_data VALUES (50069, 1025, 78304, 75, 3564, 212, 129);
INSERT INTO public.who_global_data VALUES (50070, 259, 8566, 6, 235, 212, 121);
INSERT INTO public.who_global_data VALUES (50071, 0, 1043, 0, 12, 212, 59);
INSERT INTO public.who_global_data VALUES (50072, 0, 215, 0, 0, 212, 96);
INSERT INTO public.who_global_data VALUES (50073, 8, 2003, 0, 63, 212, 41);
INSERT INTO public.who_global_data VALUES (50074, 82, 1138, 0, 14, 212, 216);
INSERT INTO public.who_global_data VALUES (50075, 199, 6973, 0, 120, 212, 236);
INSERT INTO public.who_global_data VALUES (50076, 0, 13, 0, 0, 212, 150);
INSERT INTO public.who_global_data VALUES (50077, 0, 188, 0, 0, 212, 61);
INSERT INTO public.who_global_data VALUES (50078, 0, 21, 0, 0, 212, 7);
INSERT INTO public.who_global_data VALUES (50079, 7, 7283, 0, 328, 212, 169);
INSERT INTO public.who_global_data VALUES (50080, 370, 160279, 31, 29873, 212, 28);
INSERT INTO public.who_global_data VALUES (50081, 281, 5459, 1, 22, 212, 85);
INSERT INTO public.who_global_data VALUES (50082, 0, 62, 0, 0, 212, 211);
INSERT INTO public.who_global_data VALUES (50083, 128, 5871, 0, 46, 212, 60);
INSERT INTO public.who_global_data VALUES (50084, 2, 63, 0, 3, 212, 3);
INSERT INTO public.who_global_data VALUES (50085, 5, 968, 0, 15, 212, 11);
INSERT INTO public.who_global_data VALUES (50086, 442, 197783, 12, 9048, 212, 89);
INSERT INTO public.who_global_data VALUES (50087, 854, 22822, 0, 129, 212, 24);
INSERT INTO public.who_global_data VALUES (50088, 0, 179, 0, 0, 212, 162);
INSERT INTO public.who_global_data VALUES (50089, 33, 3622, 0, 193, 212, 100);
INSERT INTO public.who_global_data VALUES (50090, 0, 13, 0, 0, 212, 47);
INSERT INTO public.who_global_data VALUES (50091, 0, 23, 0, 0, 212, 29);
INSERT INTO public.who_global_data VALUES (50092, 0, 184, 0, 14, 212, 40);
INSERT INTO public.who_global_data VALUES (50093, 4, 299, 0, 5, 212, 222);
INSERT INTO public.who_global_data VALUES (50094, 815, 24787, 23, 1004, 212, 132);
INSERT INTO public.who_global_data VALUES (50095, 0, 252, 0, 13, 212, 130);
INSERT INTO public.who_global_data VALUES (50096, 61, 5697, 0, 34, 212, 234);
INSERT INTO public.who_global_data VALUES (50097, 0, 1790, 0, 25, 212, 23);
INSERT INTO public.who_global_data VALUES (50098, 6, 284, 0, 16, 212, 192);
INSERT INTO public.who_global_data VALUES (50099, 61, 6432, 4, 117, 212, 69);
INSERT INTO public.who_global_data VALUES (50100, 0, 12, 0, 0, 212, 187);
INSERT INTO public.who_global_data VALUES (50101, 763, 25428, 21, 677, 212, 230);
INSERT INTO public.who_global_data VALUES (50102, 5, 4210, 0, 589, 212, 77);
INSERT INTO public.who_global_data VALUES (50103, 0, 1833, 0, 10, 212, 9);
INSERT INTO public.who_global_data VALUES (50104, 24879, 767296, 487, 21129, 212, 74);
INSERT INTO public.who_global_data VALUES (50105, 1853, 68079, 50, 3359, 212, 224);
INSERT INTO public.who_global_data VALUES (50106, 2691, 248379, 153, 12084, 212, 199);
INSERT INTO public.who_global_data VALUES (50107, 2741, 67442, 94, 2779, 212, 190);
INSERT INTO public.who_global_data VALUES (50108, 4, 25542, 0, 1743, 212, 12);
INSERT INTO public.who_global_data VALUES (50109, 0, 336, 0, 24, 212, 104);
INSERT INTO public.who_global_data VALUES (50110, 1390, 32681, 5, 354, 212, 153);
INSERT INTO public.who_global_data VALUES (50111, 193, 242149, 15, 34914, 212, 91);
INSERT INTO public.who_global_data VALUES (50112, 8, 745, 0, 10, 212, 215);
INSERT INTO public.who_global_data VALUES (50113, 197, 20371, 1, 981, 212, 84);
INSERT INTO public.who_global_data VALUES (50114, 0, 325, 0, 31, 212, 231);
INSERT INTO public.who_global_data VALUES (50115, 0, 1088, 0, 10, 212, 196);
INSERT INTO public.who_global_data VALUES (50116, 1726, 54747, 17, 313, 212, 105);
INSERT INTO public.who_global_data VALUES (50117, 278, 8528, 2, 169, 212, 122);
INSERT INTO public.who_global_data VALUES (50118, 0, 0, 0, 0, 212, 159);
INSERT INTO public.who_global_data VALUES (50119, 214, 4057, 4, 76, 212, 75);
INSERT INTO public.who_global_data VALUES (50120, 762, 52007, 2, 379, 212, 27);
INSERT INTO public.who_global_data VALUES (50121, 361, 8847, 4, 116, 212, 54);
INSERT INTO public.who_global_data VALUES (50122, 0, 19, 0, 0, 212, 226);
INSERT INTO public.who_global_data VALUES (50123, 7, 1141, 0, 30, 212, 79);
INSERT INTO public.who_global_data VALUES (50124, 38, 1945, 0, 36, 212, 56);
INSERT INTO public.who_global_data VALUES (50125, 43, 134, 1, 1, 212, 117);
INSERT INTO public.who_global_data VALUES (50126, 9, 926, 0, 41, 212, 152);
INSERT INTO public.who_global_data VALUES (50127, 86, 1268, 1, 36, 212, 16);
INSERT INTO public.who_global_data VALUES (50128, 0, 85, 0, 1, 212, 10);
INSERT INTO public.who_global_data VALUES (50129, 3, 1852, 0, 79, 212, 201);
INSERT INTO public.who_global_data VALUES (50130, 47, 4650, 0, 110, 212, 174);
INSERT INTO public.who_global_data VALUES (50131, 101, 3573, 0, 33, 212, 119);
INSERT INTO public.who_global_data VALUES (50132, 65, 1942, 1, 25, 212, 168);
INSERT INTO public.who_global_data VALUES (50133, 3, 8677, 0, 121, 212, 99);
INSERT INTO public.who_global_data VALUES (50134, 16, 2517, 1, 13, 212, 171);
INSERT INTO public.who_global_data VALUES (50135, 10, 2358, 1, 120, 212, 87);
INSERT INTO public.who_global_data VALUES (50136, 1, 673, 0, 9, 212, 123);
INSERT INTO public.who_global_data VALUES (50137, 0, 0, 0, 0, 212, 151);
INSERT INTO public.who_global_data VALUES (50138, 0, 249, 0, 14, 212, 213);
INSERT INTO public.who_global_data VALUES (50139, 76, 5024, 2, 135, 212, 118);
INSERT INTO public.who_global_data VALUES (50140, 0, 342, 0, 10, 212, 134);
INSERT INTO public.who_global_data VALUES (50141, 0, 2688, 0, 36, 212, 65);
INSERT INTO public.who_global_data VALUES (50142, 6258, 268008, 895, 32014, 212, 102);
INSERT INTO public.who_global_data VALUES (50143, 0, 0, 0, 0, 212, 223);
INSERT INTO public.who_global_data VALUES (50144, 0, 78, 0, 1, 212, 4);
INSERT INTO public.who_global_data VALUES (50145, 2, 227, 0, 0, 212, 146);
INSERT INTO public.who_global_data VALUES (50146, 134, 1515, 2, 20, 212, 31);
INSERT INTO public.who_global_data VALUES (50147, 0, 11, 0, 1, 212, 127);
INSERT INTO public.who_global_data VALUES (50148, 164, 14771, 2, 242, 212, 22);
INSERT INTO public.who_global_data VALUES (50149, 31, 1071, 0, 8, 212, 115);
INSERT INTO public.who_global_data VALUES (50150, 2, 318, 0, 6, 212, 106);
INSERT INTO public.who_global_data VALUES (50151, 54, 593, 0, 0, 212, 90);
INSERT INTO public.who_global_data VALUES (50152, 0, 0, 0, 0, 212, 70);
INSERT INTO public.who_global_data VALUES (50153, 255, 16423, 0, 35, 212, 46);
INSERT INTO public.who_global_data VALUES (50154, 57, 50541, 4, 6109, 212, 139);
INSERT INTO public.who_global_data VALUES (50155, 0, 21, 0, 0, 212, 42);
INSERT INTO public.who_global_data VALUES (50156, 3, 1190, 0, 22, 212, 80);
INSERT INTO public.who_global_data VALUES (50157, 229, 2411, 8, 91, 212, 203);
INSERT INTO public.who_global_data VALUES (50158, 3, 1097, 0, 68, 212, 136);
INSERT INTO public.who_global_data VALUES (50159, 460, 30249, 15, 684, 212, 63);
INSERT INTO public.who_global_data VALUES (50160, 0, 0, 0, 0, 212, 17);
INSERT INTO public.who_global_data VALUES (50161, 0, 31, 0, 2, 212, 172);
INSERT INTO public.who_global_data VALUES (50162, 162, 7405, 8, 359, 212, 109);
INSERT INTO public.who_global_data VALUES (50163, 11, 8947, 0, 251, 212, 200);
INSERT INTO public.who_global_data VALUES (50164, 475, 5567, 2, 24, 212, 93);
INSERT INTO public.who_global_data VALUES (50165, 1210, 50207, 9, 233, 212, 5);
INSERT INTO public.who_global_data VALUES (50166, 0, 741, 0, 13, 212, 214);
INSERT INTO public.who_global_data VALUES (50167, 3359, 240848, 61, 4983, 212, 204);
INSERT INTO public.who_global_data VALUES (50168, 0, 0, 0, 0, 212, 198);
INSERT INTO public.who_global_data VALUES (50169, 957, 40291, 29, 799, 212, 173);
INSERT INTO public.who_global_data VALUES (50170, 0, 11, 0, 0, 212, 229);
INSERT INTO public.who_global_data VALUES (50171, 52, 2554, 0, 20, 212, 76);
INSERT INTO public.who_global_data VALUES (50172, 3575, 309278, 180, 10952, 212, 138);
INSERT INTO public.who_global_data VALUES (50173, 2486, 50359, 5, 1314, 212, 98);
INSERT INTO public.who_global_data VALUES (50174, 0, 0, 0, 0, 212, 103);
INSERT INTO public.who_global_data VALUES (50175, 277, 36689, 14, 1542, 212, 225);
INSERT INTO public.who_global_data VALUES (50176, 443, 44859, 2, 1631, 212, 131);
INSERT INTO public.who_global_data VALUES (50177, 31, 8745, 2, 159, 212, 235);
INSERT INTO public.who_global_data VALUES (50178, 608, 101553, 4, 138, 212, 137);
INSERT INTO public.who_global_data VALUES (50179, 50, 13293, 2, 287, 212, 81);
INSERT INTO public.who_global_data VALUES (50180, 330, 18471, 10, 614, 212, 182);
INSERT INTO public.who_global_data VALUES (50181, 12, 563, 0, 3, 212, 145);
INSERT INTO public.who_global_data VALUES (50182, 555, 30175, 18, 1817, 212, 26);
INSERT INTO public.who_global_data VALUES (50183, 6509, 707301, 176, 10843, 212, 170);
INSERT INTO public.who_global_data VALUES (50184, 22, 1194, 0, 3, 212, 191);
INSERT INTO public.who_global_data VALUES (50185, 0, 3, 0, 0, 212, 221);
INSERT INTO public.who_global_data VALUES (50186, 0, 6, 0, 0, 212, 64);
INSERT INTO public.who_global_data VALUES (50187, 0, 0, 0, 0, 212, 116);
INSERT INTO public.who_global_data VALUES (50188, 0, 16, 0, 0, 212, 128);
INSERT INTO public.who_global_data VALUES (50189, 0, 22, 0, 0, 212, 6);
INSERT INTO public.who_global_data VALUES (50190, 0, 44, 0, 3, 212, 227);
INSERT INTO public.who_global_data VALUES (50191, 0, 1, 0, 0, 212, 68);
INSERT INTO public.who_global_data VALUES (50192, 0, 29, 0, 0, 212, 184);
INSERT INTO public.who_global_data VALUES (50193, 0, 0, 0, 0, 212, 82);
INSERT INTO public.who_global_data VALUES (50194, 0, 713, 0, 42, 212, 149);
INSERT INTO public.who_global_data VALUES (50195, 0, 404, 0, 11, 212, 197);
INSERT INTO public.who_global_data VALUES (50196, 3036, 220144, 42, 2059, 212, 78);
INSERT INTO public.who_global_data VALUES (50197, 110, 7657, 4, 141, 212, 233);
INSERT INTO public.who_global_data VALUES (50198, 357, 17076, 11, 341, 212, 133);
INSERT INTO public.who_global_data VALUES (50199, 3, 94, 0, 0, 212, 35);
INSERT INTO public.who_global_data VALUES (50200, 12, 1584, 0, 63, 212, 114);
INSERT INTO public.who_global_data VALUES (50201, 158, 45298, 0, 26, 212, 237);
INSERT INTO public.who_global_data VALUES (50202, 0, 2, 0, 0, 212, 55);
INSERT INTO public.who_global_data VALUES (50203, 0, 78, 0, 15, 212, 176);
INSERT INTO public.who_global_data VALUES (50204, 31, 1798, 0, 28, 212, 202);
INSERT INTO public.who_global_data VALUES (50205, 13, 1776, 0, 114, 212, 155);
INSERT INTO public.who_global_data VALUES (50206, 0, 0, 0, 0, 212, 32);
INSERT INTO public.who_global_data VALUES (50207, 13, 3028, 0, 92, 212, 220);
INSERT INTO public.who_global_data VALUES (50208, 8810, 224665, 100, 3602, 212, 30);
INSERT INTO public.who_global_data VALUES (50209, 0, 2106, 0, 40, 212, 147);
INSERT INTO public.who_global_data VALUES (50210, 752, 261630, 4, 29776, 212, 208);
INSERT INTO public.who_global_data VALUES (50211, 13, 2094, 0, 11, 212, 45);
INSERT INTO public.who_global_data VALUES (50212, 87, 10084, 14, 636, 212, 110);
INSERT INTO public.who_global_data VALUES (50213, 21, 635, 2, 17, 212, 88);
INSERT INTO public.who_global_data VALUES (50214, 278, 71138, 12, 5603, 212, 51);
INSERT INTO public.who_global_data VALUES (50215, 97, 32603, 2, 1726, 212, 209);
INSERT INTO public.who_global_data VALUES (50216, 0, 372, 0, 14, 212, 205);
INSERT INTO public.who_global_data VALUES (50217, 48, 6363, 1, 54, 212, 18);
INSERT INTO public.who_global_data VALUES (50218, 5, 3202, 0, 58, 212, 72);
INSERT INTO public.who_global_data VALUES (50219, 597, 288981, 57, 40754, 212, 44);
INSERT INTO public.who_global_data VALUES (50220, 0, 24, 0, 0, 212, 15);
INSERT INTO public.who_global_data VALUES (50221, 6, 695, 0, 15, 212, 25);
INSERT INTO public.who_global_data VALUES (50222, 0, 0, 0, 0, 212, 179);
INSERT INTO public.who_global_data VALUES (50223, 0, 0, 0, 0, 212, 34);
INSERT INTO public.who_global_data VALUES (50224, 0, 133, 0, 8, 212, 207);
INSERT INTO public.who_global_data VALUES (50225, 10, 1231, 0, 50, 212, 166);
INSERT INTO public.who_global_data VALUES (50226, 1041, 208938, 22, 5282, 212, 126);
INSERT INTO public.who_global_data VALUES (50227, 0, 0, 0, 0, 212, 97);
INSERT INTO public.who_global_data VALUES (50228, 6, 55, 0, 2, 212, 36);
INSERT INTO public.who_global_data VALUES (50229, 0, 0, 0, 0, 212, 125);
INSERT INTO public.who_global_data VALUES (50230, 6, 977, 0, 0, 212, 124);
INSERT INTO public.who_global_data VALUES (50231, 810, 51224, 20, 1327, 212, 185);
INSERT INTO public.who_global_data VALUES (50232, 445, 53045, 1, 327, 212, 194);
INSERT INTO public.who_global_data VALUES (50233, 0, 509, 0, 21, 212, 144);
INSERT INTO public.who_global_data VALUES (50234, 50263, 2973695, 930, 130893, 212, 19);
INSERT INTO public.who_global_data VALUES (50235, 6, 122, 0, 6, 212, 217);
INSERT INTO public.who_global_data VALUES (50236, 5, 965, 0, 29, 212, 148);
INSERT INTO public.who_global_data VALUES (50237, 421, 11259, 6, 47, 212, 86);
INSERT INTO public.who_global_data VALUES (50238, 0, 0, 0, 0, 212, 13);
INSERT INTO public.who_global_data VALUES (50239, 282, 7693, 3, 71, 212, 157);
INSERT INTO public.who_global_data VALUES (50240, 0, 369, 0, 0, 212, 8);
INSERT INTO public.who_global_data VALUES (50241, 0, 0, 0, 0, 212, 73);
INSERT INTO public.who_global_data VALUES (50242, 21, 1318, 3, 351, 212, 101);
INSERT INTO public.who_global_data VALUES (50243, 0, 1895, 0, 42, 212, 165);
INSERT INTO public.who_global_data VALUES (50244, 98, 885, 0, 9, 212, 14);
INSERT INTO public.who_global_data VALUES (50245, 210, 33680, 16, 940, 213, 193);
INSERT INTO public.who_global_data VALUES (50246, 68, 3106, 2, 83, 213, 113);
INSERT INTO public.who_global_data VALUES (50247, 475, 16879, 9, 968, 213, 143);
INSERT INTO public.who_global_data VALUES (50248, 0, 0, 0, 0, 213, 219);
INSERT INTO public.who_global_data VALUES (50249, 0, 855, 0, 52, 213, 186);
INSERT INTO public.who_global_data VALUES (50250, 33, 386, 2, 21, 213, 52);
INSERT INTO public.who_global_data VALUES (50251, 0, 3, 0, 0, 213, 180);
INSERT INTO public.who_global_data VALUES (50252, 2, 70, 0, 3, 213, 167);
INSERT INTO public.who_global_data VALUES (50253, 2632, 80447, 79, 1602, 213, 154);
INSERT INTO public.who_global_data VALUES (50254, 535, 29133, 18, 516, 213, 94);
INSERT INTO public.who_global_data VALUES (50255, 0, 105, 0, 3, 213, 66);
INSERT INTO public.who_global_data VALUES (50256, 169, 8755, 0, 106, 213, 58);
INSERT INTO public.who_global_data VALUES (50257, 89, 18415, 0, 706, 213, 163);
INSERT INTO public.who_global_data VALUES (50258, 537, 21374, 7, 265, 213, 37);
INSERT INTO public.who_global_data VALUES (50259, 0, 104, 0, 11, 213, 142);
INSERT INTO public.who_global_data VALUES (50260, 500, 30321, 0, 98, 213, 83);
INSERT INTO public.who_global_data VALUES (50261, 3027, 168645, 55, 2151, 213, 228);
INSERT INTO public.who_global_data VALUES (50262, 0, 98, 0, 7, 213, 188);
INSERT INTO public.who_global_data VALUES (50263, 199, 64003, 7, 436, 213, 62);
INSERT INTO public.who_global_data VALUES (50264, 99, 62705, 3, 9646, 213, 160);
INSERT INTO public.who_global_data VALUES (50265, 0, 30, 0, 2, 213, 50);
INSERT INTO public.who_global_data VALUES (50266, 86, 1285, 2, 23, 213, 33);
INSERT INTO public.who_global_data VALUES (50267, 0, 146, 0, 9, 213, 183);
INSERT INTO public.who_global_data VALUES (50268, 0, 80, 0, 0, 213, 92);
INSERT INTO public.who_global_data VALUES (50269, 1212, 40509, 42, 1476, 213, 158);
INSERT INTO public.who_global_data VALUES (50270, 0, 2, 0, 0, 213, 67);
INSERT INTO public.who_global_data VALUES (50271, 161, 5618, 10, 206, 213, 57);
INSERT INTO public.who_global_data VALUES (50272, 0, 314, 0, 1, 213, 38);
INSERT INTO public.who_global_data VALUES (50273, 20229, 1623284, 620, 65487, 213, 141);
INSERT INTO public.who_global_data VALUES (50274, 0, 8, 0, 1, 213, 178);
INSERT INTO public.who_global_data VALUES (50275, 0, 141, 0, 3, 213, 108);
INSERT INTO public.who_global_data VALUES (50276, 188, 6102, 4, 254, 213, 39);
INSERT INTO public.who_global_data VALUES (50277, 3, 1003, 0, 53, 213, 2);
INSERT INTO public.who_global_data VALUES (50278, 0, 191, 0, 1, 213, 195);
INSERT INTO public.who_global_data VALUES (50279, 36, 1499, 1, 18, 213, 107);
INSERT INTO public.who_global_data VALUES (50280, 0, 141, 0, 0, 213, 161);
INSERT INTO public.who_global_data VALUES (50281, 392, 14916, 17, 359, 213, 212);
INSERT INTO public.who_global_data VALUES (50282, 399, 105935, 9, 8693, 213, 181);
INSERT INTO public.who_global_data VALUES (50283, 0, 201, 0, 1, 213, 53);
INSERT INTO public.who_global_data VALUES (50284, 38, 4071, 0, 52, 213, 164);
INSERT INTO public.who_global_data VALUES (50285, 1, 873, 0, 74, 213, 140);
INSERT INTO public.who_global_data VALUES (50286, 2462, 301019, 50, 6434, 213, 20);
INSERT INTO public.who_global_data VALUES (50287, 21, 85366, 0, 4648, 213, 112);
INSERT INTO public.who_global_data VALUES (50288, 3171, 120281, 146, 4210, 213, 111);
INSERT INTO public.who_global_data VALUES (50289, 2, 313, 0, 7, 213, 71);
INSERT INTO public.who_global_data VALUES (50290, 200, 1757, 0, 44, 213, 218);
INSERT INTO public.who_global_data VALUES (50291, 0, 0, 0, 0, 213, 43);
INSERT INTO public.who_global_data VALUES (50292, 245, 5241, 4, 23, 213, 49);
INSERT INTO public.who_global_data VALUES (50293, 0, 10966, 0, 75, 213, 1);
INSERT INTO public.who_global_data VALUES (50294, 52, 3272, 0, 113, 213, 48);
INSERT INTO public.who_global_data VALUES (50295, 15, 2395, 0, 86, 213, 232);
INSERT INTO public.who_global_data VALUES (50296, 0, 25, 0, 1, 213, 175);
INSERT INTO public.who_global_data VALUES (50297, 1, 1005, 0, 19, 213, 21);
INSERT INTO public.who_global_data VALUES (50298, 119, 12685, 1, 351, 213, 156);
INSERT INTO public.who_global_data VALUES (50299, 0, 0, 0, 0, 213, 95);
INSERT INTO public.who_global_data VALUES (50300, 228, 7659, 1, 182, 213, 177);
INSERT INTO public.who_global_data VALUES (50301, 10, 12888, 2, 609, 213, 210);
INSERT INTO public.who_global_data VALUES (50302, 56, 4878, 0, 55, 213, 120);
INSERT INTO public.who_global_data VALUES (50303, 0, 18, 0, 0, 213, 135);
INSERT INTO public.who_global_data VALUES (50304, 302, 38430, 17, 821, 213, 206);
INSERT INTO public.who_global_data VALUES (50305, 865, 63245, 52, 4873, 213, 189);
INSERT INTO public.who_global_data VALUES (50306, 1057, 77279, 67, 3489, 213, 129);
INSERT INTO public.who_global_data VALUES (50307, 280, 8307, 6, 229, 213, 121);
INSERT INTO public.who_global_data VALUES (50308, 0, 1043, 0, 12, 213, 59);
INSERT INTO public.who_global_data VALUES (50309, 0, 215, 0, 0, 213, 96);
INSERT INTO public.who_global_data VALUES (50310, 1, 1995, 0, 63, 213, 41);
INSERT INTO public.who_global_data VALUES (50311, 45, 1056, 1, 14, 213, 216);
INSERT INTO public.who_global_data VALUES (50312, 108, 6774, 1, 120, 213, 236);
INSERT INTO public.who_global_data VALUES (50313, 0, 13, 0, 0, 213, 150);
INSERT INTO public.who_global_data VALUES (50314, 1, 188, 0, 0, 213, 61);
INSERT INTO public.who_global_data VALUES (50315, 2, 21, 0, 0, 213, 7);
INSERT INTO public.who_global_data VALUES (50316, 1, 7276, 0, 328, 213, 169);
INSERT INTO public.who_global_data VALUES (50317, 341, 159909, 11, 29842, 213, 28);
INSERT INTO public.who_global_data VALUES (50318, 124, 5178, 1, 21, 213, 85);
INSERT INTO public.who_global_data VALUES (50319, 0, 62, 0, 0, 213, 211);
INSERT INTO public.who_global_data VALUES (50320, 0, 5743, 0, 46, 213, 60);
INSERT INTO public.who_global_data VALUES (50321, 0, 61, 0, 3, 213, 3);
INSERT INTO public.who_global_data VALUES (50322, 5, 963, 0, 15, 213, 11);
INSERT INTO public.who_global_data VALUES (50323, 397, 197341, 12, 9036, 213, 89);
INSERT INTO public.who_global_data VALUES (50324, 1883, 21968, 7, 129, 213, 24);
INSERT INTO public.who_global_data VALUES (50325, 0, 179, 0, 0, 213, 162);
INSERT INTO public.who_global_data VALUES (50326, 27, 3589, 1, 193, 213, 100);
INSERT INTO public.who_global_data VALUES (50327, 0, 13, 0, 0, 213, 47);
INSERT INTO public.who_global_data VALUES (50328, 0, 23, 0, 0, 213, 29);
INSERT INTO public.who_global_data VALUES (50329, 0, 184, 0, 14, 213, 40);
INSERT INTO public.who_global_data VALUES (50330, 2, 295, 0, 5, 213, 222);
INSERT INTO public.who_global_data VALUES (50331, 724, 23972, 34, 981, 213, 132);
INSERT INTO public.who_global_data VALUES (50332, 0, 252, 0, 13, 213, 130);
INSERT INTO public.who_global_data VALUES (50333, 26, 5636, 0, 34, 213, 234);
INSERT INTO public.who_global_data VALUES (50334, 0, 1790, 0, 25, 213, 23);
INSERT INTO public.who_global_data VALUES (50335, 5, 278, 1, 16, 213, 192);
INSERT INTO public.who_global_data VALUES (50336, 38, 6371, 0, 113, 213, 69);
INSERT INTO public.who_global_data VALUES (50337, 0, 12, 0, 0, 213, 187);
INSERT INTO public.who_global_data VALUES (50338, 722, 24665, 17, 656, 213, 230);
INSERT INTO public.who_global_data VALUES (50339, 16, 4205, 0, 589, 213, 77);
INSERT INTO public.who_global_data VALUES (50340, 1, 1833, 0, 10, 213, 9);
INSERT INTO public.who_global_data VALUES (50341, 22752, 742417, 482, 20642, 213, 74);
INSERT INTO public.who_global_data VALUES (50342, 1268, 66226, 68, 3309, 213, 224);
INSERT INTO public.who_global_data VALUES (50343, 2637, 245688, 200, 11931, 213, 199);
INSERT INTO public.who_global_data VALUES (50344, 2426, 64701, 118, 2685, 213, 190);
INSERT INTO public.who_global_data VALUES (50345, 7, 25538, 2, 1743, 213, 12);
INSERT INTO public.who_global_data VALUES (50346, 0, 336, 0, 24, 213, 104);
INSERT INTO public.who_global_data VALUES (50347, 1134, 31291, 8, 349, 213, 153);
INSERT INTO public.who_global_data VALUES (50348, 137, 241956, 30, 34899, 213, 91);
INSERT INTO public.who_global_data VALUES (50349, 5, 737, 0, 10, 213, 215);
INSERT INTO public.who_global_data VALUES (50350, 193, 20174, 2, 980, 213, 84);
INSERT INTO public.who_global_data VALUES (50351, 5, 325, 0, 31, 213, 231);
INSERT INTO public.who_global_data VALUES (50352, 2, 1088, 0, 10, 213, 196);
INSERT INTO public.who_global_data VALUES (50353, 1962, 53021, 32, 296, 213, 105);
INSERT INTO public.who_global_data VALUES (50354, 183, 8250, 3, 167, 213, 122);
INSERT INTO public.who_global_data VALUES (50355, 0, 0, 0, 0, 213, 159);
INSERT INTO public.who_global_data VALUES (50356, 183, 3843, 3, 72, 213, 75);
INSERT INTO public.who_global_data VALUES (50357, 601, 51245, 4, 377, 213, 27);
INSERT INTO public.who_global_data VALUES (50358, 345, 8486, 13, 112, 213, 54);
INSERT INTO public.who_global_data VALUES (50359, 0, 19, 0, 0, 213, 226);
INSERT INTO public.who_global_data VALUES (50360, 7, 1134, 0, 30, 213, 79);
INSERT INTO public.who_global_data VALUES (50361, 22, 1907, 0, 36, 213, 56);
INSERT INTO public.who_global_data VALUES (50362, 0, 91, 0, 0, 213, 117);
INSERT INTO public.who_global_data VALUES (50363, 26, 917, 2, 41, 213, 152);
INSERT INTO public.who_global_data VALUES (50364, 65, 1182, 1, 35, 213, 16);
INSERT INTO public.who_global_data VALUES (50365, 0, 85, 0, 1, 213, 10);
INSERT INTO public.who_global_data VALUES (50366, 10, 1849, 0, 79, 213, 201);
INSERT INTO public.who_global_data VALUES (50367, 61, 4603, 0, 110, 213, 174);
INSERT INTO public.who_global_data VALUES (50368, 222, 3472, 0, 33, 213, 119);
INSERT INTO public.who_global_data VALUES (50369, 59, 1877, 5, 24, 213, 168);
INSERT INTO public.who_global_data VALUES (50370, 6, 8674, 0, 121, 213, 99);
INSERT INTO public.who_global_data VALUES (50371, 10, 2501, 0, 12, 213, 171);
INSERT INTO public.who_global_data VALUES (50372, 17, 2348, 0, 119, 213, 87);
INSERT INTO public.who_global_data VALUES (50373, 0, 672, 0, 9, 213, 123);
INSERT INTO public.who_global_data VALUES (50374, 0, 0, 0, 0, 213, 151);
INSERT INTO public.who_global_data VALUES (50375, 0, 249, 0, 14, 213, 213);
INSERT INTO public.who_global_data VALUES (50376, 69, 4948, 3, 133, 213, 118);
INSERT INTO public.who_global_data VALUES (50377, 0, 342, 0, 10, 213, 134);
INSERT INTO public.who_global_data VALUES (50378, 9, 2688, 0, 36, 213, 65);
INSERT INTO public.who_global_data VALUES (50379, 4902, 261750, 480, 31119, 213, 102);
INSERT INTO public.who_global_data VALUES (50380, 0, 0, 0, 0, 213, 223);
INSERT INTO public.who_global_data VALUES (50381, 0, 78, 0, 1, 213, 4);
INSERT INTO public.who_global_data VALUES (50382, 5, 225, 0, 0, 213, 146);
INSERT INTO public.who_global_data VALUES (50383, 184, 1381, 0, 18, 213, 31);
INSERT INTO public.who_global_data VALUES (50384, 0, 11, 0, 1, 213, 127);
INSERT INTO public.who_global_data VALUES (50385, 228, 14607, 3, 240, 213, 22);
INSERT INTO public.who_global_data VALUES (50386, 28, 1040, 0, 8, 213, 115);
INSERT INTO public.who_global_data VALUES (50387, 0, 316, 0, 6, 213, 106);
INSERT INTO public.who_global_data VALUES (50388, 54, 539, 0, 0, 213, 90);
INSERT INTO public.who_global_data VALUES (50389, 0, 0, 0, 0, 213, 70);
INSERT INTO public.who_global_data VALUES (50390, 204, 16168, 0, 35, 213, 46);
INSERT INTO public.who_global_data VALUES (50391, 34, 50484, 4, 6105, 213, 139);
INSERT INTO public.who_global_data VALUES (50392, 0, 21, 0, 0, 213, 42);
INSERT INTO public.who_global_data VALUES (50393, 1, 1187, 0, 22, 213, 80);
INSERT INTO public.who_global_data VALUES (50394, 0, 2182, 0, 83, 213, 203);
INSERT INTO public.who_global_data VALUES (50395, 1, 1094, 0, 68, 213, 136);
INSERT INTO public.who_global_data VALUES (50396, 503, 29789, 15, 669, 213, 63);
INSERT INTO public.who_global_data VALUES (50397, 0, 0, 0, 0, 213, 17);
INSERT INTO public.who_global_data VALUES (50398, 0, 31, 0, 2, 213, 172);
INSERT INTO public.who_global_data VALUES (50399, 119, 7243, 5, 351, 213, 109);
INSERT INTO public.who_global_data VALUES (50400, 6, 8936, 0, 251, 213, 200);
INSERT INTO public.who_global_data VALUES (50401, 306, 5092, 1, 22, 213, 93);
INSERT INTO public.who_global_data VALUES (50402, 1262, 48997, 6, 224, 213, 5);
INSERT INTO public.who_global_data VALUES (50403, 0, 741, 0, 13, 213, 214);
INSERT INTO public.who_global_data VALUES (50404, 2980, 237489, 83, 4922, 213, 204);
INSERT INTO public.who_global_data VALUES (50405, 0, 0, 0, 0, 213, 198);
INSERT INTO public.who_global_data VALUES (50406, 1185, 39334, 23, 770, 213, 173);
INSERT INTO public.who_global_data VALUES (50407, 0, 11, 0, 0, 213, 229);
INSERT INTO public.who_global_data VALUES (50408, 46, 2502, 0, 20, 213, 76);
INSERT INTO public.who_global_data VALUES (50409, 2985, 305703, 183, 10772, 213, 138);
INSERT INTO public.who_global_data VALUES (50410, 1540, 47873, 6, 1309, 213, 98);
INSERT INTO public.who_global_data VALUES (50411, 0, 0, 0, 0, 213, 103);
INSERT INTO public.who_global_data VALUES (50412, 257, 36412, 7, 1528, 213, 225);
INSERT INTO public.who_global_data VALUES (50413, 287, 44416, 9, 1629, 213, 131);
INSERT INTO public.who_global_data VALUES (50414, 129, 8714, 2, 157, 213, 235);
INSERT INTO public.who_global_data VALUES (50415, 600, 100945, 1, 134, 213, 137);
INSERT INTO public.who_global_data VALUES (50416, 62, 13243, 0, 285, 213, 81);
INSERT INTO public.who_global_data VALUES (50417, 235, 18141, 6, 604, 213, 182);
INSERT INTO public.who_global_data VALUES (50418, 1, 551, 1, 3, 213, 145);
INSERT INTO public.who_global_data VALUES (50419, 397, 29620, 31, 1799, 213, 26);
INSERT INTO public.who_global_data VALUES (50420, 6562, 700792, 173, 10667, 213, 170);
INSERT INTO public.who_global_data VALUES (50421, 59, 1172, 0, 3, 213, 191);
INSERT INTO public.who_global_data VALUES (50422, 0, 3, 0, 0, 213, 221);
INSERT INTO public.who_global_data VALUES (50423, 0, 6, 0, 0, 213, 64);
INSERT INTO public.who_global_data VALUES (50424, 0, 0, 0, 0, 213, 116);
INSERT INTO public.who_global_data VALUES (50425, 0, 16, 0, 0, 213, 128);
INSERT INTO public.who_global_data VALUES (50426, 0, 22, 0, 0, 213, 6);
INSERT INTO public.who_global_data VALUES (50427, 0, 44, 0, 3, 213, 227);
INSERT INTO public.who_global_data VALUES (50428, 0, 1, 0, 0, 213, 68);
INSERT INTO public.who_global_data VALUES (50429, 0, 29, 0, 0, 213, 184);
INSERT INTO public.who_global_data VALUES (50430, 0, 0, 0, 0, 213, 82);
INSERT INTO public.who_global_data VALUES (50431, 0, 713, 0, 42, 213, 149);
INSERT INTO public.who_global_data VALUES (50432, 3, 404, 0, 11, 213, 197);
INSERT INTO public.who_global_data VALUES (50433, 3392, 217108, 49, 2017, 213, 78);
INSERT INTO public.who_global_data VALUES (50434, 69, 7547, 1, 137, 213, 233);
INSERT INTO public.who_global_data VALUES (50435, 299, 16719, 13, 330, 213, 133);
INSERT INTO public.who_global_data VALUES (50436, 10, 91, 0, 0, 213, 35);
INSERT INTO public.who_global_data VALUES (50437, 25, 1572, 1, 63, 213, 114);
INSERT INTO public.who_global_data VALUES (50438, 157, 45140, 0, 26, 213, 237);
INSERT INTO public.who_global_data VALUES (50439, 0, 2, 0, 0, 213, 55);
INSERT INTO public.who_global_data VALUES (50440, 0, 78, 0, 15, 213, 176);
INSERT INTO public.who_global_data VALUES (50441, 2, 1767, 0, 28, 213, 202);
INSERT INTO public.who_global_data VALUES (50442, 24, 1763, 0, 114, 213, 155);
INSERT INTO public.who_global_data VALUES (50443, 0, 0, 0, 0, 213, 32);
INSERT INTO public.who_global_data VALUES (50444, 9, 3015, 0, 92, 213, 220);
INSERT INTO public.who_global_data VALUES (50445, 10134, 215855, 192, 3502, 213, 30);
INSERT INTO public.who_global_data VALUES (50446, 8, 2106, 0, 40, 213, 147);
INSERT INTO public.who_global_data VALUES (50447, 367, 260878, 5, 29772, 213, 208);
INSERT INTO public.who_global_data VALUES (50448, 3, 2081, 0, 11, 213, 45);
INSERT INTO public.who_global_data VALUES (50449, 103, 9997, 6, 622, 213, 110);
INSERT INTO public.who_global_data VALUES (50450, 10, 614, 1, 15, 213, 88);
INSERT INTO public.who_global_data VALUES (50451, 251, 70860, 15, 5591, 213, 51);
INSERT INTO public.who_global_data VALUES (50452, 107, 32506, 0, 1724, 213, 209);
INSERT INTO public.who_global_data VALUES (50453, 0, 372, 0, 14, 213, 205);
INSERT INTO public.who_global_data VALUES (50454, 53, 6315, 0, 53, 213, 18);
INSERT INTO public.who_global_data VALUES (50455, 2, 3197, 0, 58, 213, 72);
INSERT INTO public.who_global_data VALUES (50456, 704, 288384, 54, 40697, 213, 44);
INSERT INTO public.who_global_data VALUES (50457, 0, 24, 0, 0, 213, 15);
INSERT INTO public.who_global_data VALUES (50458, 9, 689, 0, 15, 213, 25);
INSERT INTO public.who_global_data VALUES (50459, 0, 0, 0, 0, 213, 179);
INSERT INTO public.who_global_data VALUES (50460, 0, 0, 0, 0, 213, 34);
INSERT INTO public.who_global_data VALUES (50461, 0, 133, 0, 8, 213, 207);
INSERT INTO public.who_global_data VALUES (50462, 16, 1221, 0, 50, 213, 166);
INSERT INTO public.who_global_data VALUES (50463, 1053, 207897, 19, 5260, 213, 126);
INSERT INTO public.who_global_data VALUES (50464, 0, 0, 0, 0, 213, 97);
INSERT INTO public.who_global_data VALUES (50465, 1, 49, 0, 2, 213, 36);
INSERT INTO public.who_global_data VALUES (50466, 0, 0, 0, 0, 213, 125);
INSERT INTO public.who_global_data VALUES (50467, 18, 971, 0, 0, 213, 124);
INSERT INTO public.who_global_data VALUES (50468, 807, 50414, 24, 1307, 213, 185);
INSERT INTO public.who_global_data VALUES (50469, 532, 52600, 2, 326, 213, 194);
INSERT INTO public.who_global_data VALUES (50470, 0, 509, 0, 21, 213, 144);
INSERT INTO public.who_global_data VALUES (50471, 46194, 2923432, 320, 129963, 213, 19);
INSERT INTO public.who_global_data VALUES (50472, 4, 116, 0, 6, 213, 217);
INSERT INTO public.who_global_data VALUES (50473, 4, 960, 1, 29, 213, 148);
INSERT INTO public.who_global_data VALUES (50474, 379, 10838, 3, 41, 213, 86);
INSERT INTO public.who_global_data VALUES (50475, 0, 0, 0, 0, 213, 13);
INSERT INTO public.who_global_data VALUES (50476, 242, 7411, 4, 68, 213, 157);
INSERT INTO public.who_global_data VALUES (50477, 0, 369, 0, 0, 213, 8);
INSERT INTO public.who_global_data VALUES (50478, 0, 0, 0, 0, 213, 73);
INSERT INTO public.who_global_data VALUES (50479, 13, 1297, 3, 348, 213, 101);
INSERT INTO public.who_global_data VALUES (50480, 263, 1895, 12, 42, 213, 165);
INSERT INTO public.who_global_data VALUES (50481, 53, 787, 0, 9, 213, 14);
INSERT INTO public.who_global_data VALUES (50482, 320, 33470, 33, 924, 214, 193);
INSERT INTO public.who_global_data VALUES (50483, 74, 3038, 2, 81, 214, 113);
INSERT INTO public.who_global_data VALUES (50484, 463, 16404, 7, 959, 214, 143);
INSERT INTO public.who_global_data VALUES (50485, 0, 0, 0, 0, 214, 219);
INSERT INTO public.who_global_data VALUES (50486, 0, 855, 0, 52, 214, 186);
INSERT INTO public.who_global_data VALUES (50487, 0, 353, 0, 19, 214, 52);
INSERT INTO public.who_global_data VALUES (50488, 0, 3, 0, 0, 214, 180);
INSERT INTO public.who_global_data VALUES (50489, 0, 68, 0, 3, 214, 167);
INSERT INTO public.who_global_data VALUES (50490, 2439, 77815, 33, 1523, 214, 154);
INSERT INTO public.who_global_data VALUES (50491, 349, 28598, 12, 498, 214, 94);
INSERT INTO public.who_global_data VALUES (50492, 1, 105, 0, 3, 214, 66);
INSERT INTO public.who_global_data VALUES (50493, 137, 8586, 2, 106, 214, 58);
INSERT INTO public.who_global_data VALUES (50494, 57, 18326, 0, 706, 214, 163);
INSERT INTO public.who_global_data VALUES (50495, 513, 20837, 8, 258, 214, 37);
INSERT INTO public.who_global_data VALUES (50496, 0, 104, 0, 11, 214, 142);
INSERT INTO public.who_global_data VALUES (50497, 454, 29821, 1, 98, 214, 83);
INSERT INTO public.who_global_data VALUES (50498, 3201, 165618, 44, 2096, 214, 228);
INSERT INTO public.who_global_data VALUES (50499, 1, 98, 0, 7, 214, 188);
INSERT INTO public.who_global_data VALUES (50500, 250, 63804, 6, 429, 214, 62);
INSERT INTO public.who_global_data VALUES (50501, 112, 62606, 1, 9643, 214, 160);
INSERT INTO public.who_global_data VALUES (50502, 0, 30, 0, 2, 214, 50);
INSERT INTO public.who_global_data VALUES (50503, 0, 1199, 0, 21, 214, 33);
INSERT INTO public.who_global_data VALUES (50504, 0, 146, 0, 9, 214, 183);
INSERT INTO public.who_global_data VALUES (50505, 0, 80, 0, 0, 214, 92);
INSERT INTO public.who_global_data VALUES (50506, 1226, 39297, 56, 1434, 214, 158);
INSERT INTO public.who_global_data VALUES (50507, 0, 2, 0, 0, 214, 67);
INSERT INTO public.who_global_data VALUES (50508, 64, 5457, 3, 196, 214, 57);
INSERT INTO public.who_global_data VALUES (50509, 39, 314, 0, 1, 214, 38);
INSERT INTO public.who_global_data VALUES (50510, 26051, 1603055, 602, 64867, 214, 141);
INSERT INTO public.who_global_data VALUES (50511, 0, 8, 0, 1, 214, 178);
INSERT INTO public.who_global_data VALUES (50512, 0, 141, 0, 3, 214, 108);
INSERT INTO public.who_global_data VALUES (50513, 174, 5914, 4, 250, 214, 39);
INSERT INTO public.who_global_data VALUES (50514, 0, 1000, 0, 53, 214, 2);
INSERT INTO public.who_global_data VALUES (50515, 0, 191, 0, 1, 214, 195);
INSERT INTO public.who_global_data VALUES (50516, 12, 1463, 0, 17, 214, 107);
INSERT INTO public.who_global_data VALUES (50517, 0, 141, 0, 0, 214, 161);
INSERT INTO public.who_global_data VALUES (50518, 487, 14524, 12, 342, 214, 212);
INSERT INTO public.who_global_data VALUES (50519, 219, 105536, 10, 8684, 214, 181);
INSERT INTO public.who_global_data VALUES (50520, 0, 201, 0, 1, 214, 53);
INSERT INTO public.who_global_data VALUES (50521, 64, 4033, 4, 52, 214, 164);
INSERT INTO public.who_global_data VALUES (50522, 0, 872, 0, 74, 214, 140);
INSERT INTO public.who_global_data VALUES (50523, 3025, 298557, 76, 6384, 214, 20);
INSERT INTO public.who_global_data VALUES (50524, 25, 85345, 0, 4648, 214, 112);
INSERT INTO public.who_global_data VALUES (50525, 3721, 117110, 122, 4064, 214, 111);
INSERT INTO public.who_global_data VALUES (50526, 0, 311, 0, 7, 214, 71);
INSERT INTO public.who_global_data VALUES (50527, 0, 1557, 0, 44, 214, 218);
INSERT INTO public.who_global_data VALUES (50528, 0, 0, 0, 0, 214, 43);
INSERT INTO public.who_global_data VALUES (50529, 375, 4996, 1, 19, 214, 49);
INSERT INTO public.who_global_data VALUES (50530, 722, 10966, 5, 75, 214, 1);
INSERT INTO public.who_global_data VALUES (50531, 69, 3220, 0, 113, 214, 48);
INSERT INTO public.who_global_data VALUES (50532, 8, 2380, 0, 86, 214, 232);
INSERT INTO public.who_global_data VALUES (50533, 0, 25, 0, 1, 214, 175);
INSERT INTO public.who_global_data VALUES (50534, 1, 1004, 0, 19, 214, 21);
INSERT INTO public.who_global_data VALUES (50535, 51, 12566, 2, 350, 214, 156);
INSERT INTO public.who_global_data VALUES (50536, 0, 0, 0, 0, 214, 95);
INSERT INTO public.who_global_data VALUES (50537, 21, 7431, 0, 181, 214, 177);
INSERT INTO public.who_global_data VALUES (50538, 46, 12878, 1, 607, 214, 210);
INSERT INTO public.who_global_data VALUES (50539, 30, 4822, 0, 55, 214, 120);
INSERT INTO public.who_global_data VALUES (50540, 0, 18, 0, 0, 214, 135);
INSERT INTO public.who_global_data VALUES (50541, 703, 38128, 10, 804, 214, 206);
INSERT INTO public.who_global_data VALUES (50542, 422, 62380, 40, 4821, 214, 189);
INSERT INTO public.who_global_data VALUES (50543, 969, 76222, 79, 3422, 214, 129);
INSERT INTO public.who_global_data VALUES (50544, 250, 8027, 6, 223, 214, 121);
INSERT INTO public.who_global_data VALUES (50545, 0, 1043, 0, 12, 214, 59);
INSERT INTO public.who_global_data VALUES (50546, 0, 215, 0, 0, 214, 96);
INSERT INTO public.who_global_data VALUES (50547, 1, 1994, 0, 63, 214, 41);
INSERT INTO public.who_global_data VALUES (50548, 23, 1011, 0, 13, 214, 216);
INSERT INTO public.who_global_data VALUES (50549, 280, 6666, 3, 119, 214, 236);
INSERT INTO public.who_global_data VALUES (50550, 0, 13, 0, 0, 214, 150);
INSERT INTO public.who_global_data VALUES (50551, 0, 187, 0, 0, 214, 61);
INSERT INTO public.who_global_data VALUES (50552, 0, 19, 0, 0, 214, 7);
INSERT INTO public.who_global_data VALUES (50553, 3, 7275, 0, 328, 214, 169);
INSERT INTO public.who_global_data VALUES (50554, 834, 159568, 23, 29831, 214, 28);
INSERT INTO public.who_global_data VALUES (50555, 141, 5054, 4, 20, 214, 85);
INSERT INTO public.who_global_data VALUES (50556, 0, 62, 0, 0, 214, 211);
INSERT INTO public.who_global_data VALUES (50557, 123, 5743, 2, 46, 214, 60);
INSERT INTO public.who_global_data VALUES (50558, 4, 61, 1, 3, 214, 3);
INSERT INTO public.who_global_data VALUES (50559, 5, 958, 0, 15, 214, 11);
INSERT INTO public.who_global_data VALUES (50560, 390, 196944, 8, 9024, 214, 89);
INSERT INTO public.who_global_data VALUES (50561, 0, 20085, 0, 122, 214, 24);
INSERT INTO public.who_global_data VALUES (50562, 1, 179, 0, 0, 214, 162);
INSERT INTO public.who_global_data VALUES (50563, 43, 3562, 0, 192, 214, 100);
INSERT INTO public.who_global_data VALUES (50564, 0, 13, 0, 0, 214, 47);
INSERT INTO public.who_global_data VALUES (50565, 0, 23, 0, 0, 214, 29);
INSERT INTO public.who_global_data VALUES (50566, 0, 184, 0, 14, 214, 40);
INSERT INTO public.who_global_data VALUES (50567, 13, 293, 0, 5, 214, 222);
INSERT INTO public.who_global_data VALUES (50568, 747, 23248, 27, 947, 214, 132);
INSERT INTO public.who_global_data VALUES (50569, 0, 252, 0, 13, 214, 130);
INSERT INTO public.who_global_data VALUES (50570, 0, 5610, 0, 34, 214, 234);
INSERT INTO public.who_global_data VALUES (50571, 25, 1790, 0, 25, 214, 23);
INSERT INTO public.who_global_data VALUES (50572, 1, 273, 1, 15, 214, 192);
INSERT INTO public.who_global_data VALUES (50573, 39, 6333, 0, 113, 214, 69);
INSERT INTO public.who_global_data VALUES (50574, 0, 12, 0, 0, 214, 187);
INSERT INTO public.who_global_data VALUES (50575, 1022, 23943, 10, 639, 214, 230);
INSERT INTO public.who_global_data VALUES (50576, 6, 4189, 0, 589, 214, 77);
INSERT INTO public.who_global_data VALUES (50577, 2, 1832, 0, 10, 214, 9);
INSERT INTO public.who_global_data VALUES (50578, 22252, 719665, 467, 20160, 214, 74);
INSERT INTO public.who_global_data VALUES (50579, 1209, 64958, 70, 3241, 214, 224);
INSERT INTO public.who_global_data VALUES (50580, 2613, 243051, 160, 11731, 214, 199);
INSERT INTO public.who_global_data VALUES (50581, 1796, 62275, 94, 2567, 214, 190);
INSERT INTO public.who_global_data VALUES (50582, 4, 25531, 0, 1741, 214, 12);
INSERT INTO public.who_global_data VALUES (50583, 0, 336, 0, 24, 214, 104);
INSERT INTO public.who_global_data VALUES (50584, 831, 30157, 2, 341, 214, 153);
INSERT INTO public.who_global_data VALUES (50585, 208, 241819, 8, 34869, 214, 91);
INSERT INTO public.who_global_data VALUES (50586, 4, 732, 0, 10, 214, 215);
INSERT INTO public.who_global_data VALUES (50587, 206, 19981, 1, 978, 214, 84);
INSERT INTO public.who_global_data VALUES (50588, 0, 320, 0, 31, 214, 231);
INSERT INTO public.who_global_data VALUES (50589, 3, 1086, 0, 10, 214, 196);
INSERT INTO public.who_global_data VALUES (50590, 1376, 51059, 0, 264, 214, 105);
INSERT INTO public.who_global_data VALUES (50591, 181, 8067, 4, 164, 214, 122);
INSERT INTO public.who_global_data VALUES (50592, 0, 0, 0, 0, 214, 159);
INSERT INTO public.who_global_data VALUES (50593, 195, 3660, 4, 69, 214, 75);
INSERT INTO public.who_global_data VALUES (50594, 703, 50644, 5, 373, 214, 27);
INSERT INTO public.who_global_data VALUES (50595, 450, 8141, 7, 99, 214, 54);
INSERT INTO public.who_global_data VALUES (50596, 0, 19, 0, 0, 214, 226);
INSERT INTO public.who_global_data VALUES (50597, 3, 1127, 0, 30, 214, 79);
INSERT INTO public.who_global_data VALUES (50598, 12, 1885, 0, 36, 214, 56);
INSERT INTO public.who_global_data VALUES (50599, 0, 91, 0, 0, 214, 117);
INSERT INTO public.who_global_data VALUES (50600, 17, 891, 2, 39, 214, 152);
INSERT INTO public.who_global_data VALUES (50601, 71, 1117, 2, 34, 214, 16);
INSERT INTO public.who_global_data VALUES (50602, 0, 85, 0, 1, 214, 10);
INSERT INTO public.who_global_data VALUES (50603, 3, 1839, 0, 79, 214, 201);
INSERT INTO public.who_global_data VALUES (50604, 20, 4542, 0, 110, 214, 174);
INSERT INTO public.who_global_data VALUES (50605, 309, 3250, 1, 33, 214, 119);
INSERT INTO public.who_global_data VALUES (50606, 76, 1818, 0, 19, 214, 168);
INSERT INTO public.who_global_data VALUES (50607, 5, 8668, 0, 121, 214, 99);
INSERT INTO public.who_global_data VALUES (50608, 23, 2491, 1, 12, 214, 171);
INSERT INTO public.who_global_data VALUES (50609, 1, 2331, 0, 119, 214, 87);
INSERT INTO public.who_global_data VALUES (50610, 1, 672, 0, 9, 214, 123);
INSERT INTO public.who_global_data VALUES (50611, 0, 0, 0, 0, 214, 151);
INSERT INTO public.who_global_data VALUES (50612, 0, 249, 0, 14, 214, 213);
INSERT INTO public.who_global_data VALUES (50613, 0, 4879, 0, 130, 214, 118);
INSERT INTO public.who_global_data VALUES (50614, 1, 342, 0, 10, 214, 134);
INSERT INTO public.who_global_data VALUES (50615, 11, 2679, 0, 36, 214, 65);
INSERT INTO public.who_global_data VALUES (50616, 4683, 256848, 273, 30639, 214, 102);
INSERT INTO public.who_global_data VALUES (50617, 0, 0, 0, 0, 214, 223);
INSERT INTO public.who_global_data VALUES (50618, 0, 78, 0, 1, 214, 4);
INSERT INTO public.who_global_data VALUES (50619, 0, 220, 0, 0, 214, 146);
INSERT INTO public.who_global_data VALUES (50620, 174, 1197, 1, 18, 214, 31);
INSERT INTO public.who_global_data VALUES (50621, 0, 11, 0, 1, 214, 127);
INSERT INTO public.who_global_data VALUES (50622, 164, 14379, 2, 237, 214, 22);
INSERT INTO public.who_global_data VALUES (50623, 25, 1012, 0, 8, 214, 115);
INSERT INTO public.who_global_data VALUES (50624, 3, 316, 0, 6, 214, 106);
INSERT INTO public.who_global_data VALUES (50625, 73, 485, 0, 0, 214, 90);
INSERT INTO public.who_global_data VALUES (50626, 0, 0, 0, 0, 214, 70);
INSERT INTO public.who_global_data VALUES (50627, 180, 15964, 1, 35, 214, 46);
INSERT INTO public.who_global_data VALUES (50628, 41, 50450, 0, 6101, 214, 139);
INSERT INTO public.who_global_data VALUES (50629, 0, 21, 0, 0, 214, 42);
INSERT INTO public.who_global_data VALUES (50630, 2, 1186, 0, 22, 214, 80);
INSERT INTO public.who_global_data VALUES (50631, 0, 2182, 0, 83, 214, 203);
INSERT INTO public.who_global_data VALUES (50632, 0, 1093, 0, 68, 214, 136);
INSERT INTO public.who_global_data VALUES (50633, 575, 29286, 9, 654, 214, 63);
INSERT INTO public.who_global_data VALUES (50634, 0, 0, 0, 0, 214, 17);
INSERT INTO public.who_global_data VALUES (50635, 0, 31, 0, 2, 214, 172);
INSERT INTO public.who_global_data VALUES (50636, 78, 7124, 5, 346, 214, 109);
INSERT INTO public.who_global_data VALUES (50637, 35, 8930, 0, 251, 214, 200);
INSERT INTO public.who_global_data VALUES (50638, 64, 4786, 1, 21, 214, 93);
INSERT INTO public.who_global_data VALUES (50639, 1557, 47735, 5, 218, 214, 5);
INSERT INTO public.who_global_data VALUES (50640, 0, 741, 0, 13, 214, 214);
INSERT INTO public.who_global_data VALUES (50641, 2691, 234509, 77, 4839, 214, 204);
INSERT INTO public.who_global_data VALUES (50642, 0, 0, 0, 0, 214, 198);
INSERT INTO public.who_global_data VALUES (50643, 1166, 38149, 27, 747, 214, 173);
INSERT INTO public.who_global_data VALUES (50644, 0, 11, 0, 0, 214, 229);
INSERT INTO public.who_global_data VALUES (50645, 29, 2456, 0, 20, 214, 76);
INSERT INTO public.who_global_data VALUES (50646, 3638, 302718, 177, 10589, 214, 138);
INSERT INTO public.who_global_data VALUES (50647, 2079, 46333, 6, 1303, 214, 98);
INSERT INTO public.who_global_data VALUES (50648, 0, 0, 0, 0, 214, 103);
INSERT INTO public.who_global_data VALUES (50649, 205, 36155, 4, 1521, 214, 225);
INSERT INTO public.who_global_data VALUES (50650, 232, 44129, 6, 1620, 214, 131);
INSERT INTO public.who_global_data VALUES (50651, 669, 8585, 0, 155, 214, 235);
INSERT INTO public.who_global_data VALUES (50652, 546, 100345, 5, 133, 214, 137);
INSERT INTO public.who_global_data VALUES (50653, 44, 13181, 1, 285, 214, 81);
INSERT INTO public.who_global_data VALUES (50654, 92, 17906, 10, 598, 214, 182);
INSERT INTO public.who_global_data VALUES (50655, 3, 550, 0, 2, 214, 145);
INSERT INTO public.who_global_data VALUES (50656, 250, 29223, 18, 1768, 214, 26);
INSERT INTO public.who_global_data VALUES (50657, 6368, 694230, 198, 10494, 214, 170);
INSERT INTO public.who_global_data VALUES (50658, 8, 1113, 0, 3, 214, 191);
INSERT INTO public.who_global_data VALUES (50659, 0, 3, 0, 0, 214, 221);
INSERT INTO public.who_global_data VALUES (50660, 0, 6, 0, 0, 214, 64);
INSERT INTO public.who_global_data VALUES (50661, 0, 0, 0, 0, 214, 116);
INSERT INTO public.who_global_data VALUES (50662, 0, 16, 0, 0, 214, 128);
INSERT INTO public.who_global_data VALUES (50663, 0, 22, 0, 0, 214, 6);
INSERT INTO public.who_global_data VALUES (50664, 0, 44, 0, 3, 214, 227);
INSERT INTO public.who_global_data VALUES (50665, 0, 1, 0, 0, 214, 68);
INSERT INTO public.who_global_data VALUES (50666, 0, 29, 0, 0, 214, 184);
INSERT INTO public.who_global_data VALUES (50667, 0, 0, 0, 0, 214, 82);
INSERT INTO public.who_global_data VALUES (50668, 0, 713, 0, 42, 214, 149);
INSERT INTO public.who_global_data VALUES (50669, 1, 401, 0, 11, 214, 197);
INSERT INTO public.who_global_data VALUES (50670, 4207, 213716, 52, 1968, 214, 78);
INSERT INTO public.who_global_data VALUES (50671, 78, 7478, 3, 136, 214, 233);
INSERT INTO public.who_global_data VALUES (50672, 289, 16420, 6, 317, 214, 133);
INSERT INTO public.who_global_data VALUES (50673, 0, 81, 0, 0, 214, 35);
INSERT INTO public.who_global_data VALUES (50674, 5, 1547, 0, 62, 214, 114);
INSERT INTO public.who_global_data VALUES (50675, 183, 44983, 0, 26, 214, 237);
INSERT INTO public.who_global_data VALUES (50676, 0, 2, 0, 0, 214, 55);
INSERT INTO public.who_global_data VALUES (50677, 0, 78, 0, 15, 214, 176);
INSERT INTO public.who_global_data VALUES (50678, 1, 1765, 0, 28, 214, 202);
INSERT INTO public.who_global_data VALUES (50679, 23, 1739, 0, 114, 214, 155);
INSERT INTO public.who_global_data VALUES (50680, 0, 0, 0, 0, 214, 32);
INSERT INTO public.who_global_data VALUES (50681, 9, 3006, 0, 92, 214, 220);
INSERT INTO public.who_global_data VALUES (50682, 8971, 205721, 111, 3310, 214, 30);
INSERT INTO public.who_global_data VALUES (50683, 5, 2098, 0, 40, 214, 147);
INSERT INTO public.who_global_data VALUES (50684, 215, 260511, 0, 29767, 214, 208);
INSERT INTO public.who_global_data VALUES (50685, 2, 2078, 0, 11, 214, 45);
INSERT INTO public.who_global_data VALUES (50686, 127, 9894, 8, 616, 214, 110);
INSERT INTO public.who_global_data VALUES (50687, 21, 604, 0, 14, 214, 88);
INSERT INTO public.who_global_data VALUES (50688, 315, 70609, 9, 5576, 214, 51);
INSERT INTO public.who_global_data VALUES (50689, 106, 32399, 0, 1724, 214, 209);
INSERT INTO public.who_global_data VALUES (50690, 14, 372, 1, 14, 214, 205);
INSERT INTO public.who_global_data VALUES (50691, 49, 6262, 0, 53, 214, 18);
INSERT INTO public.who_global_data VALUES (50692, 0, 3195, 0, 58, 214, 72);
INSERT INTO public.who_global_data VALUES (50693, 555, 287680, 11, 40643, 214, 44);
INSERT INTO public.who_global_data VALUES (50694, 0, 24, 0, 0, 214, 15);
INSERT INTO public.who_global_data VALUES (50695, 0, 680, 0, 15, 214, 25);
INSERT INTO public.who_global_data VALUES (50696, 0, 0, 0, 0, 214, 179);
INSERT INTO public.who_global_data VALUES (50697, 0, 0, 0, 0, 214, 34);
INSERT INTO public.who_global_data VALUES (50698, 2, 133, 0, 8, 214, 207);
INSERT INTO public.who_global_data VALUES (50699, 6, 1205, 0, 50, 214, 166);
INSERT INTO public.who_global_data VALUES (50700, 1086, 206844, 16, 5241, 214, 126);
INSERT INTO public.who_global_data VALUES (50701, 0, 0, 0, 0, 214, 97);
INSERT INTO public.who_global_data VALUES (50702, 1, 48, 0, 2, 214, 36);
INSERT INTO public.who_global_data VALUES (50703, 0, 0, 0, 0, 214, 125);
INSERT INTO public.who_global_data VALUES (50704, 14, 953, 0, 0, 214, 124);
INSERT INTO public.who_global_data VALUES (50705, 564, 49607, 21, 1283, 214, 185);
INSERT INTO public.who_global_data VALUES (50706, 528, 52068, 1, 324, 214, 194);
INSERT INTO public.who_global_data VALUES (50707, 0, 509, 0, 21, 214, 144);
INSERT INTO public.who_global_data VALUES (50708, 43686, 2877238, 235, 129643, 214, 19);
INSERT INTO public.who_global_data VALUES (50709, 1, 112, 0, 6, 214, 217);
INSERT INTO public.who_global_data VALUES (50710, 1, 956, 0, 28, 214, 148);
INSERT INTO public.who_global_data VALUES (50711, 316, 10459, 3, 38, 214, 86);
INSERT INTO public.who_global_data VALUES (50712, 0, 0, 0, 0, 214, 13);
INSERT INTO public.who_global_data VALUES (50713, 419, 7169, 2, 64, 214, 157);
INSERT INTO public.who_global_data VALUES (50714, 14, 369, 0, 0, 214, 8);
INSERT INTO public.who_global_data VALUES (50715, 0, 0, 0, 0, 214, 73);
INSERT INTO public.who_global_data VALUES (50716, 19, 1284, 7, 345, 214, 101);
INSERT INTO public.who_global_data VALUES (50717, 0, 1632, 0, 30, 214, 165);
INSERT INTO public.who_global_data VALUES (50718, 18, 734, 1, 9, 214, 14);
INSERT INTO public.who_global_data VALUES (50719, 113, 33150, 23, 891, 215, 193);
INSERT INTO public.who_global_data VALUES (50720, 71, 2964, 3, 79, 215, 113);
INSERT INTO public.who_global_data VALUES (50721, 441, 15941, 6, 952, 215, 143);
INSERT INTO public.who_global_data VALUES (50722, 0, 0, 0, 0, 215, 219);
INSERT INTO public.who_global_data VALUES (50723, 0, 855, 0, 52, 215, 186);
INSERT INTO public.who_global_data VALUES (50724, 7, 353, 0, 19, 215, 52);
INSERT INTO public.who_global_data VALUES (50725, 0, 3, 0, 0, 215, 180);
INSERT INTO public.who_global_data VALUES (50726, 0, 68, 0, 3, 215, 167);
INSERT INTO public.who_global_data VALUES (50727, 2590, 75376, 37, 1490, 215, 154);
INSERT INTO public.who_global_data VALUES (50728, 330, 28249, 7, 486, 215, 94);
INSERT INTO public.who_global_data VALUES (50729, 0, 104, 0, 3, 215, 66);
INSERT INTO public.who_global_data VALUES (50730, 87, 8449, 0, 104, 215, 58);
INSERT INTO public.who_global_data VALUES (50731, 73, 18269, 1, 706, 215, 163);
INSERT INTO public.who_global_data VALUES (50732, 523, 20324, 9, 250, 215, 37);
INSERT INTO public.who_global_data VALUES (50733, 0, 104, 0, 11, 215, 142);
INSERT INTO public.who_global_data VALUES (50734, 510, 29367, 1, 97, 215, 83);
INSERT INTO public.who_global_data VALUES (50735, 2738, 162417, 55, 2052, 215, 228);
INSERT INTO public.who_global_data VALUES (50736, 0, 97, 0, 7, 215, 188);
INSERT INTO public.who_global_data VALUES (50737, 284, 63554, 5, 423, 215, 62);
INSERT INTO public.who_global_data VALUES (50738, 24, 62494, 2, 9642, 215, 160);
INSERT INTO public.who_global_data VALUES (50739, 0, 30, 0, 2, 215, 50);
INSERT INTO public.who_global_data VALUES (50740, 0, 1199, 0, 21, 215, 33);
INSERT INTO public.who_global_data VALUES (50741, 0, 146, 0, 9, 215, 183);
INSERT INTO public.who_global_data VALUES (50742, 2, 80, 0, 0, 215, 92);
INSERT INTO public.who_global_data VALUES (50743, 1253, 38071, 58, 1378, 215, 158);
INSERT INTO public.who_global_data VALUES (50744, 0, 2, 0, 0, 215, 67);
INSERT INTO public.who_global_data VALUES (50745, 144, 5393, 3, 193, 215, 57);
INSERT INTO public.who_global_data VALUES (50746, 0, 275, 0, 1, 215, 38);
INSERT INTO public.who_global_data VALUES (50747, 37923, 1577004, 1091, 64265, 215, 141);
INSERT INTO public.who_global_data VALUES (50748, 0, 8, 0, 1, 215, 178);
INSERT INTO public.who_global_data VALUES (50749, 0, 141, 0, 3, 215, 108);
INSERT INTO public.who_global_data VALUES (50750, 63, 5740, 5, 246, 215, 39);
INSERT INTO public.who_global_data VALUES (50751, 13, 1000, 0, 53, 215, 2);
INSERT INTO public.who_global_data VALUES (50752, 0, 191, 0, 1, 215, 195);
INSERT INTO public.who_global_data VALUES (50753, 31, 1451, 1, 17, 215, 107);
INSERT INTO public.who_global_data VALUES (50754, 0, 141, 0, 0, 215, 161);
INSERT INTO public.who_global_data VALUES (50755, 1445, 14037, 17, 330, 215, 212);
INSERT INTO public.who_global_data VALUES (50756, 226, 105317, 11, 8674, 215, 181);
INSERT INTO public.who_global_data VALUES (50757, 0, 201, 0, 1, 215, 53);
INSERT INTO public.who_global_data VALUES (50758, 0, 3969, 0, 48, 215, 164);
INSERT INTO public.who_global_data VALUES (50759, 1, 872, 0, 74, 215, 140);
INSERT INTO public.who_global_data VALUES (50760, 3685, 295532, 116, 6308, 215, 20);
INSERT INTO public.who_global_data VALUES (50761, 14, 85320, 0, 4648, 215, 112);
INSERT INTO public.who_global_data VALUES (50762, 3884, 113389, 165, 3942, 215, 111);
INSERT INTO public.who_global_data VALUES (50763, 2, 311, 0, 7, 215, 71);
INSERT INTO public.who_global_data VALUES (50764, 0, 1557, 0, 44, 215, 218);
INSERT INTO public.who_global_data VALUES (50765, 0, 0, 0, 0, 215, 43);
INSERT INTO public.who_global_data VALUES (50766, 310, 4621, 0, 18, 215, 49);
INSERT INTO public.who_global_data VALUES (50767, 0, 10244, 0, 70, 215, 1);
INSERT INTO public.who_global_data VALUES (50768, 57, 3151, 0, 113, 215, 48);
INSERT INTO public.who_global_data VALUES (50769, 3, 2372, 0, 86, 215, 232);
INSERT INTO public.who_global_data VALUES (50770, 0, 25, 0, 1, 215, 175);
INSERT INTO public.who_global_data VALUES (50771, 1, 1003, 0, 19, 215, 21);
INSERT INTO public.who_global_data VALUES (50772, 75, 12515, -3, 348, 215, 156);
INSERT INTO public.who_global_data VALUES (50773, 0, 0, 0, 0, 215, 95);
INSERT INTO public.who_global_data VALUES (50774, 32, 7410, 0, 181, 215, 177);
INSERT INTO public.who_global_data VALUES (50775, 0, 12832, 0, 606, 215, 210);
INSERT INTO public.who_global_data VALUES (50776, 56, 4792, 0, 55, 215, 120);
INSERT INTO public.who_global_data VALUES (50777, 0, 18, 0, 0, 215, 135);
INSERT INTO public.who_global_data VALUES (50778, 1241, 37425, 8, 794, 215, 206);
INSERT INTO public.who_global_data VALUES (50779, 423, 61958, 12, 4781, 215, 189);
INSERT INTO public.who_global_data VALUES (50780, 1218, 75253, 63, 3343, 215, 129);
INSERT INTO public.who_global_data VALUES (50781, 270, 7777, 7, 217, 215, 121);
INSERT INTO public.who_global_data VALUES (50782, 0, 1043, 0, 12, 215, 59);
INSERT INTO public.who_global_data VALUES (50783, 0, 215, 0, 0, 215, 96);
INSERT INTO public.who_global_data VALUES (50784, 0, 1993, 0, 63, 215, 41);
INSERT INTO public.who_global_data VALUES (50785, 34, 988, 0, 13, 215, 216);
INSERT INTO public.who_global_data VALUES (50786, 0, 6386, 0, 116, 215, 236);
INSERT INTO public.who_global_data VALUES (50787, 0, 13, 0, 0, 215, 150);
INSERT INTO public.who_global_data VALUES (50788, 0, 187, 0, 0, 215, 61);
INSERT INTO public.who_global_data VALUES (50789, 1, 19, 0, 0, 215, 7);
INSERT INTO public.who_global_data VALUES (50790, 2, 7272, 0, 328, 215, 169);
INSERT INTO public.who_global_data VALUES (50791, 0, 158734, 0, 29808, 215, 28);
INSERT INTO public.who_global_data VALUES (50792, 0, 4913, 0, 16, 215, 85);
INSERT INTO public.who_global_data VALUES (50793, 0, 62, 0, 0, 215, 211);
INSERT INTO public.who_global_data VALUES (50794, 0, 5620, 0, 44, 215, 60);
INSERT INTO public.who_global_data VALUES (50795, 0, 57, 0, 2, 215, 3);
INSERT INTO public.who_global_data VALUES (50796, 2, 953, 0, 15, 215, 11);
INSERT INTO public.who_global_data VALUES (50797, 219, 196554, 4, 9016, 215, 89);
INSERT INTO public.who_global_data VALUES (50798, 697, 20085, 5, 122, 215, 24);
INSERT INTO public.who_global_data VALUES (50799, 0, 178, 0, 0, 215, 162);
INSERT INTO public.who_global_data VALUES (50800, 8, 3519, 0, 192, 215, 100);
INSERT INTO public.who_global_data VALUES (50801, 0, 13, 0, 0, 215, 47);
INSERT INTO public.who_global_data VALUES (50802, 0, 23, 0, 0, 215, 29);
INSERT INTO public.who_global_data VALUES (50803, 0, 184, -2, 14, 215, 40);
INSERT INTO public.who_global_data VALUES (50804, 0, 280, 0, 5, 215, 222);
INSERT INTO public.who_global_data VALUES (50805, 1208, 22501, 40, 920, 215, 132);
INSERT INTO public.who_global_data VALUES (50806, 0, 252, 0, 13, 215, 130);
INSERT INTO public.who_global_data VALUES (50807, 40, 5610, 0, 34, 215, 234);
INSERT INTO public.who_global_data VALUES (50808, 0, 1765, 0, 25, 215, 23);
INSERT INTO public.who_global_data VALUES (50809, 16, 272, 0, 14, 215, 192);
INSERT INTO public.who_global_data VALUES (50810, 64, 6294, 3, 113, 215, 69);
INSERT INTO public.who_global_data VALUES (50811, 0, 12, 0, 0, 215, 187);
INSERT INTO public.who_global_data VALUES (50812, 805, 22921, 24, 629, 215, 230);
INSERT INTO public.who_global_data VALUES (50813, 0, 4183, 0, 589, 215, 77);
INSERT INTO public.who_global_data VALUES (50814, 0, 1830, 0, 10, 215, 9);
INSERT INTO public.who_global_data VALUES (50815, 24248, 697413, 425, 19693, 215, 74);
INSERT INTO public.who_global_data VALUES (50816, 1607, 63749, 82, 3171, 215, 224);
INSERT INTO public.who_global_data VALUES (50817, 2560, 240438, 163, 11571, 215, 199);
INSERT INTO public.who_global_data VALUES (50818, 2125, 60479, 105, 2473, 215, 190);
INSERT INTO public.who_global_data VALUES (50819, 18, 25527, 0, 1741, 215, 12);
INSERT INTO public.who_global_data VALUES (50820, 0, 336, 0, 24, 215, 104);
INSERT INTO public.who_global_data VALUES (50821, 821, 29326, 5, 339, 215, 153);
INSERT INTO public.who_global_data VALUES (50822, 192, 241611, 7, 34861, 215, 91);
INSERT INTO public.who_global_data VALUES (50823, 7, 728, 0, 10, 215, 215);
INSERT INTO public.who_global_data VALUES (50824, 253, 19775, 0, 977, 215, 84);
INSERT INTO public.who_global_data VALUES (50825, 0, 320, 0, 31, 215, 231);
INSERT INTO public.who_global_data VALUES (50826, 12, 1083, 0, 10, 215, 196);
INSERT INTO public.who_global_data VALUES (50827, 1109, 49683, 4, 264, 215, 105);
INSERT INTO public.who_global_data VALUES (50828, 309, 7886, 1, 160, 215, 122);
INSERT INTO public.who_global_data VALUES (50829, 0, 0, 0, 0, 215, 159);
INSERT INTO public.who_global_data VALUES (50830, 152, 3465, 11, 65, 215, 75);
INSERT INTO public.who_global_data VALUES (50831, 638, 49941, 3, 368, 215, 27);
INSERT INTO public.who_global_data VALUES (50832, 597, 7691, 14, 92, 215, 54);
INSERT INTO public.who_global_data VALUES (50833, 0, 19, 0, 0, 215, 226);
INSERT INTO public.who_global_data VALUES (50834, 1, 1124, 0, 30, 215, 79);
INSERT INTO public.who_global_data VALUES (50835, 18, 1873, 1, 36, 215, 56);
INSERT INTO public.who_global_data VALUES (50836, 12, 91, 0, 0, 215, 117);
INSERT INTO public.who_global_data VALUES (50837, 41, 874, 0, 37, 215, 152);
INSERT INTO public.who_global_data VALUES (50838, 57, 1046, 5, 32, 215, 16);
INSERT INTO public.who_global_data VALUES (50839, 1, 85, 0, 1, 215, 10);
INSERT INTO public.who_global_data VALUES (50840, 5, 1836, 0, 79, 215, 201);
INSERT INTO public.who_global_data VALUES (50841, 46, 4522, 0, 110, 215, 174);
INSERT INTO public.who_global_data VALUES (50842, 213, 2941, 3, 32, 215, 119);
INSERT INTO public.who_global_data VALUES (50843, 129, 1742, 2, 19, 215, 168);
INSERT INTO public.who_global_data VALUES (50844, 5, 8663, 0, 121, 215, 99);
INSERT INTO public.who_global_data VALUES (50845, 33, 2468, 1, 11, 215, 171);
INSERT INTO public.who_global_data VALUES (50846, 27, 2330, 1, 119, 215, 87);
INSERT INTO public.who_global_data VALUES (50847, 0, 671, 0, 9, 215, 123);
INSERT INTO public.who_global_data VALUES (50848, 0, 0, 0, 0, 215, 151);
INSERT INTO public.who_global_data VALUES (50849, 0, 249, 0, 14, 215, 213);
INSERT INTO public.who_global_data VALUES (50850, 174, 4879, 1, 130, 215, 118);
INSERT INTO public.who_global_data VALUES (50851, 0, 341, 0, 10, 215, 134);
INSERT INTO public.who_global_data VALUES (50852, 0, 2668, 0, 36, 215, 65);
INSERT INTO public.who_global_data VALUES (50853, 6914, 252165, 523, 30366, 215, 102);
INSERT INTO public.who_global_data VALUES (50854, 0, 0, 0, 0, 215, 223);
INSERT INTO public.who_global_data VALUES (50855, 2, 78, 0, 1, 215, 4);
INSERT INTO public.who_global_data VALUES (50856, 0, 220, 0, 0, 215, 146);
INSERT INTO public.who_global_data VALUES (50857, 130, 1023, 3, 17, 215, 31);
INSERT INTO public.who_global_data VALUES (50858, 0, 11, 0, 1, 215, 127);
INSERT INTO public.who_global_data VALUES (50859, 393, 14215, 3, 235, 215, 22);
INSERT INTO public.who_global_data VALUES (50860, 18, 987, 1, 8, 215, 115);
INSERT INTO public.who_global_data VALUES (50861, 0, 313, 0, 6, 215, 106);
INSERT INTO public.who_global_data VALUES (50862, 37, 412, 0, 0, 215, 90);
INSERT INTO public.who_global_data VALUES (50863, 0, 0, 0, 0, 215, 70);
INSERT INTO public.who_global_data VALUES (50864, 293, 15784, 0, 34, 215, 46);
INSERT INTO public.who_global_data VALUES (50865, 72, 50409, 1, 6101, 215, 139);
INSERT INTO public.who_global_data VALUES (50866, 0, 21, 0, 0, 215, 42);
INSERT INTO public.who_global_data VALUES (50867, 1, 1184, 0, 22, 215, 80);
INSERT INTO public.who_global_data VALUES (50868, 0, 2182, 0, 83, 215, 203);
INSERT INTO public.who_global_data VALUES (50869, 11, 1093, 0, 68, 215, 136);
INSERT INTO public.who_global_data VALUES (50870, 544, 28711, 11, 645, 215, 63);
INSERT INTO public.who_global_data VALUES (50871, 0, 0, 0, 0, 215, 17);
INSERT INTO public.who_global_data VALUES (50872, 0, 31, 0, 2, 215, 172);
INSERT INTO public.who_global_data VALUES (50873, 114, 7046, 7, 341, 215, 109);
INSERT INTO public.who_global_data VALUES (50874, 0, 8895, 0, 251, 215, 200);
INSERT INTO public.who_global_data VALUES (50875, 472, 4722, 1, 20, 215, 93);
INSERT INTO public.who_global_data VALUES (50876, 1072, 46178, 10, 213, 215, 5);
INSERT INTO public.who_global_data VALUES (50877, 0, 741, 0, 13, 215, 214);
INSERT INTO public.who_global_data VALUES (50878, 3344, 231818, 50, 4762, 215, 204);
INSERT INTO public.who_global_data VALUES (50879, 0, 0, 0, 0, 215, 198);
INSERT INTO public.who_global_data VALUES (50880, 988, 36983, 22, 720, 215, 173);
INSERT INTO public.who_global_data VALUES (50881, 0, 11, 0, 0, 215, 229);
INSERT INTO public.who_global_data VALUES (50882, 42, 2427, 0, 20, 215, 76);
INSERT INTO public.who_global_data VALUES (50883, 3481, 299080, 186, 10412, 215, 138);
INSERT INTO public.who_global_data VALUES (50884, 2424, 44254, 7, 1297, 215, 98);
INSERT INTO public.who_global_data VALUES (50885, 0, 0, 0, 0, 215, 103);
INSERT INTO public.who_global_data VALUES (50886, 231, 35950, 5, 1517, 215, 225);
INSERT INTO public.who_global_data VALUES (50887, 328, 43897, 9, 1614, 215, 131);
INSERT INTO public.who_global_data VALUES (50888, 129, 7916, 0, 155, 215, 235);
INSERT INTO public.who_global_data VALUES (50889, 616, 99799, 5, 128, 215, 137);
INSERT INTO public.who_global_data VALUES (50890, 48, 13137, 1, 284, 215, 81);
INSERT INTO public.who_global_data VALUES (50891, 142, 17814, 6, 588, 215, 182);
INSERT INTO public.who_global_data VALUES (50892, 11, 547, 0, 2, 215, 145);
INSERT INTO public.who_global_data VALUES (50893, 391, 28973, 19, 1750, 215, 26);
INSERT INTO public.who_global_data VALUES (50894, 6611, 687862, 135, 10296, 215, 170);
INSERT INTO public.who_global_data VALUES (50895, 13, 1105, 0, 3, 215, 191);
INSERT INTO public.who_global_data VALUES (50896, 0, 3, 0, 0, 215, 221);
INSERT INTO public.who_global_data VALUES (50897, 0, 6, 0, 0, 215, 64);
INSERT INTO public.who_global_data VALUES (50898, 0, 0, 0, 0, 215, 116);
INSERT INTO public.who_global_data VALUES (50899, 1, 16, 0, 0, 215, 128);
INSERT INTO public.who_global_data VALUES (50900, 0, 22, 0, 0, 215, 6);
INSERT INTO public.who_global_data VALUES (50901, 0, 44, 0, 3, 215, 227);
INSERT INTO public.who_global_data VALUES (50902, 0, 1, 0, 0, 215, 68);
INSERT INTO public.who_global_data VALUES (50903, 0, 29, 0, 0, 215, 184);
INSERT INTO public.who_global_data VALUES (50904, 0, 0, 0, 0, 215, 82);
INSERT INTO public.who_global_data VALUES (50905, 0, 713, 0, 42, 215, 149);
INSERT INTO public.who_global_data VALUES (50906, 1, 400, 0, 11, 215, 197);
INSERT INTO public.who_global_data VALUES (50907, 3580, 209509, 58, 1916, 215, 78);
INSERT INTO public.who_global_data VALUES (50908, 128, 7400, 4, 133, 215, 233);
INSERT INTO public.who_global_data VALUES (50909, 302, 16131, 5, 311, 215, 133);
INSERT INTO public.who_global_data VALUES (50910, 0, 81, 0, 0, 215, 35);
INSERT INTO public.who_global_data VALUES (50911, 9, 1542, 0, 62, 215, 114);
INSERT INTO public.who_global_data VALUES (50912, 136, 44800, 0, 26, 215, 237);
INSERT INTO public.who_global_data VALUES (50913, 0, 2, 0, 0, 215, 55);
INSERT INTO public.who_global_data VALUES (50914, 0, 78, 0, 15, 215, 176);
INSERT INTO public.who_global_data VALUES (50915, 15, 1764, 0, 28, 215, 202);
INSERT INTO public.who_global_data VALUES (50916, 16, 1716, 0, 114, 215, 155);
INSERT INTO public.who_global_data VALUES (50917, 0, 0, 0, 0, 215, 32);
INSERT INTO public.who_global_data VALUES (50918, 36, 2997, 0, 92, 215, 220);
INSERT INTO public.who_global_data VALUES (50919, 8773, 196750, 173, 3199, 215, 30);
INSERT INTO public.who_global_data VALUES (50920, 35, 2093, 2, 40, 215, 147);
INSERT INTO public.who_global_data VALUES (50921, 302, 260296, 6, 29767, 215, 208);
INSERT INTO public.who_global_data VALUES (50922, 2, 2076, 0, 11, 215, 45);
INSERT INTO public.who_global_data VALUES (50923, 0, 9767, 0, 608, 215, 110);
INSERT INTO public.who_global_data VALUES (50924, 18, 583, 0, 14, 215, 88);
INSERT INTO public.who_global_data VALUES (50925, 364, 70294, 15, 5567, 215, 51);
INSERT INTO public.who_global_data VALUES (50926, 36, 32293, 0, 1724, 215, 209);
INSERT INTO public.who_global_data VALUES (50927, 20, 358, 3, 13, 215, 205);
INSERT INTO public.who_global_data VALUES (50928, 54, 6213, 1, 53, 215, 18);
INSERT INTO public.who_global_data VALUES (50929, 5, 3195, 0, 58, 215, 72);
INSERT INTO public.who_global_data VALUES (50930, 401, 287125, 19, 40632, 215, 44);
INSERT INTO public.who_global_data VALUES (50931, 0, 24, 0, 0, 215, 15);
INSERT INTO public.who_global_data VALUES (50932, 4, 680, 0, 15, 215, 25);
INSERT INTO public.who_global_data VALUES (50933, 0, 0, 0, 0, 215, 179);
INSERT INTO public.who_global_data VALUES (50934, 0, 0, 0, 0, 215, 34);
INSERT INTO public.who_global_data VALUES (50935, 1, 131, 0, 8, 215, 207);
INSERT INTO public.who_global_data VALUES (50936, 11, 1199, 0, 50, 215, 166);
INSERT INTO public.who_global_data VALUES (50937, 1148, 205758, 19, 5225, 215, 126);
INSERT INTO public.who_global_data VALUES (50938, 0, 0, 0, 0, 215, 97);
INSERT INTO public.who_global_data VALUES (50939, 2, 47, 0, 2, 215, 36);
INSERT INTO public.who_global_data VALUES (50940, 0, 0, 0, 0, 215, 125);
INSERT INTO public.who_global_data VALUES (50941, 12, 939, 0, 0, 215, 124);
INSERT INTO public.who_global_data VALUES (50942, 543, 49043, 13, 1262, 215, 185);
INSERT INTO public.who_global_data VALUES (50943, 683, 51540, 2, 323, 215, 194);
INSERT INTO public.who_global_data VALUES (50944, 0, 509, 0, 21, 215, 144);
INSERT INTO public.who_global_data VALUES (50945, 57186, 2833552, 182, 129408, 215, 19);
INSERT INTO public.who_global_data VALUES (50946, 0, 111, 0, 6, 215, 217);
INSERT INTO public.who_global_data VALUES (50947, 3, 955, 0, 28, 215, 148);
INSERT INTO public.who_global_data VALUES (50948, 314, 10143, 4, 35, 215, 86);
INSERT INTO public.who_global_data VALUES (50949, 0, 0, 0, 0, 215, 13);
INSERT INTO public.who_global_data VALUES (50950, 213, 6750, 3, 62, 215, 157);
INSERT INTO public.who_global_data VALUES (50951, 0, 355, 0, 0, 215, 8);
INSERT INTO public.who_global_data VALUES (50952, 0, 0, 0, 0, 215, 73);
INSERT INTO public.who_global_data VALUES (50953, 17, 1265, 1, 338, 215, 101);
INSERT INTO public.who_global_data VALUES (50954, 0, 1632, 0, 30, 215, 165);
INSERT INTO public.who_global_data VALUES (50955, 18, 716, 0, 8, 215, 14);
INSERT INTO public.who_global_data VALUES (50956, 279, 33037, 38, 868, 216, 193);
INSERT INTO public.who_global_data VALUES (50957, 74, 2893, 2, 76, 216, 113);
INSERT INTO public.who_global_data VALUES (50958, 430, 15500, 9, 946, 216, 143);
INSERT INTO public.who_global_data VALUES (50959, 0, 0, 0, 0, 216, 219);
INSERT INTO public.who_global_data VALUES (50960, 0, 855, 0, 52, 216, 186);
INSERT INTO public.who_global_data VALUES (50961, 18, 346, 1, 19, 216, 52);
INSERT INTO public.who_global_data VALUES (50962, 0, 3, 0, 0, 216, 180);
INSERT INTO public.who_global_data VALUES (50963, 0, 68, 0, 3, 216, 167);
INSERT INTO public.who_global_data VALUES (50964, 2845, 72786, 50, 1453, 216, 154);
INSERT INTO public.who_global_data VALUES (50965, 706, 27919, 7, 479, 216, 94);
INSERT INTO public.who_global_data VALUES (50966, 0, 104, 0, 3, 216, 66);
INSERT INTO public.who_global_data VALUES (50967, 107, 8362, 0, 104, 216, 58);
INSERT INTO public.who_global_data VALUES (50968, 123, 18196, 0, 705, 216, 163);
INSERT INTO public.who_global_data VALUES (50969, 534, 19801, 6, 241, 216, 37);
INSERT INTO public.who_global_data VALUES (50970, 0, 104, 0, 11, 216, 142);
INSERT INTO public.who_global_data VALUES (50971, 447, 28857, 1, 96, 216, 83);
INSERT INTO public.who_global_data VALUES (50972, 3288, 159679, 29, 1997, 216, 228);
INSERT INTO public.who_global_data VALUES (50973, 0, 97, 0, 7, 216, 188);
INSERT INTO public.who_global_data VALUES (50974, 273, 63270, 6, 418, 216, 62);
INSERT INTO public.who_global_data VALUES (50975, 64, 62470, 3, 9640, 216, 160);
INSERT INTO public.who_global_data VALUES (50976, 2, 30, 0, 2, 216, 50);
INSERT INTO public.who_global_data VALUES (50977, 0, 1199, 0, 21, 216, 33);
INSERT INTO public.who_global_data VALUES (50978, 0, 146, 0, 9, 216, 183);
INSERT INTO public.who_global_data VALUES (50979, 0, 78, 0, 0, 216, 92);
INSERT INTO public.who_global_data VALUES (50980, 1290, 36818, 49, 1320, 216, 158);
INSERT INTO public.who_global_data VALUES (50981, 0, 2, 0, 0, 216, 67);
INSERT INTO public.who_global_data VALUES (50982, 289, 5249, 0, 190, 216, 57);
INSERT INTO public.who_global_data VALUES (50983, 0, 275, 0, 1, 216, 38);
INSERT INTO public.who_global_data VALUES (50984, 42223, 1539081, 1290, 63174, 216, 141);
INSERT INTO public.who_global_data VALUES (50985, 0, 8, 0, 1, 216, 178);
INSERT INTO public.who_global_data VALUES (50986, 0, 141, 0, 3, 216, 108);
INSERT INTO public.who_global_data VALUES (50987, 180, 5677, 2, 241, 216, 39);
INSERT INTO public.who_global_data VALUES (50988, 7, 987, 0, 53, 216, 2);
INSERT INTO public.who_global_data VALUES (50989, 0, 191, 0, 1, 216, 195);
INSERT INTO public.who_global_data VALUES (50990, 38, 1420, 1, 16, 216, 107);
INSERT INTO public.who_global_data VALUES (50991, 0, 141, 0, 0, 216, 161);
INSERT INTO public.who_global_data VALUES (50992, 0, 12592, 0, 313, 216, 212);
INSERT INTO public.who_global_data VALUES (50993, 319, 105091, 21, 8663, 216, 181);
INSERT INTO public.who_global_data VALUES (50994, 0, 201, 0, 1, 216, 53);
INSERT INTO public.who_global_data VALUES (50995, 51, 3969, 0, 48, 216, 164);
INSERT INTO public.who_global_data VALUES (50996, 0, 871, 0, 74, 216, 140);
INSERT INTO public.who_global_data VALUES (50997, 3758, 291847, 141, 6192, 216, 20);
INSERT INTO public.who_global_data VALUES (50998, 19, 85306, 0, 4648, 216, 112);
INSERT INTO public.who_global_data VALUES (50999, 3395, 109505, 136, 3777, 216, 111);
INSERT INTO public.who_global_data VALUES (51000, 0, 309, 0, 7, 216, 71);
INSERT INTO public.who_global_data VALUES (51001, 0, 1557, 0, 44, 216, 218);
INSERT INTO public.who_global_data VALUES (51002, 0, 0, 0, 0, 216, 43);
INSERT INTO public.who_global_data VALUES (51003, 288, 4311, 0, 18, 216, 49);
INSERT INTO public.who_global_data VALUES (51004, 252, 10244, 2, 70, 216, 1);
INSERT INTO public.who_global_data VALUES (51005, 86, 3094, 1, 113, 216, 48);
INSERT INTO public.who_global_data VALUES (51006, 8, 2369, 0, 86, 216, 232);
INSERT INTO public.who_global_data VALUES (51007, 0, 25, 0, 1, 216, 175);
INSERT INTO public.who_global_data VALUES (51008, 3, 1002, 0, 19, 216, 21);
INSERT INTO public.who_global_data VALUES (51009, 121, 12440, -1, 351, 216, 156);
INSERT INTO public.who_global_data VALUES (51010, 0, 0, 0, 0, 216, 95);
INSERT INTO public.who_global_data VALUES (51011, 68, 7378, 3, 181, 216, 177);
INSERT INTO public.who_global_data VALUES (51012, 0, 12832, 0, 606, 216, 210);
INSERT INTO public.who_global_data VALUES (51013, 0, 4736, 0, 55, 216, 120);
INSERT INTO public.who_global_data VALUES (51014, 0, 18, 0, 0, 216, 135);
INSERT INTO public.who_global_data VALUES (51015, 1036, 36184, 11, 786, 216, 206);
INSERT INTO public.who_global_data VALUES (51016, 878, 61535, 69, 4769, 216, 189);
INSERT INTO public.who_global_data VALUES (51017, 1324, 74035, 79, 3280, 216, 129);
INSERT INTO public.who_global_data VALUES (51018, 240, 7507, 8, 210, 216, 121);
INSERT INTO public.who_global_data VALUES (51019, 0, 1043, 0, 12, 216, 59);
INSERT INTO public.who_global_data VALUES (51020, 0, 215, 0, 0, 216, 96);
INSERT INTO public.who_global_data VALUES (51021, 2, 1993, 0, 63, 216, 41);
INSERT INTO public.who_global_data VALUES (51022, 45, 954, 0, 13, 216, 216);
INSERT INTO public.who_global_data VALUES (51023, 169, 6386, 2, 116, 216, 236);
INSERT INTO public.who_global_data VALUES (51024, 0, 13, 0, 0, 216, 150);
INSERT INTO public.who_global_data VALUES (51025, 0, 187, 0, 0, 216, 61);
INSERT INTO public.who_global_data VALUES (51026, 0, 18, 0, 0, 216, 7);
INSERT INTO public.who_global_data VALUES (51027, 1, 7270, 0, 328, 216, 169);
INSERT INTO public.who_global_data VALUES (51028, 0, 158734, 0, 29808, 216, 28);
INSERT INTO public.who_global_data VALUES (51029, 355, 4913, 0, 16, 216, 85);
INSERT INTO public.who_global_data VALUES (51030, 0, 62, 0, 0, 216, 211);
INSERT INTO public.who_global_data VALUES (51031, 107, 5620, 2, 44, 216, 60);
INSERT INTO public.who_global_data VALUES (51032, 2, 57, 0, 2, 216, 3);
INSERT INTO public.who_global_data VALUES (51033, 5, 951, 0, 15, 216, 11);
INSERT INTO public.who_global_data VALUES (51034, 239, 196335, 2, 9012, 216, 89);
INSERT INTO public.who_global_data VALUES (51035, 496, 19388, 0, 117, 216, 24);
INSERT INTO public.who_global_data VALUES (51036, 0, 178, 0, 0, 216, 162);
INSERT INTO public.who_global_data VALUES (51037, 25, 3511, 0, 192, 216, 100);
INSERT INTO public.who_global_data VALUES (51038, 0, 13, 0, 0, 216, 47);
INSERT INTO public.who_global_data VALUES (51039, 0, 23, 0, 0, 216, 29);
INSERT INTO public.who_global_data VALUES (51040, 2, 184, 2, 16, 216, 40);
INSERT INTO public.who_global_data VALUES (51041, 2, 280, 0, 5, 216, 222);
INSERT INTO public.who_global_data VALUES (51042, 1221, 21293, 37, 880, 216, 132);
INSERT INTO public.who_global_data VALUES (51043, 0, 252, 0, 13, 216, 130);
INSERT INTO public.who_global_data VALUES (51044, 49, 5570, 1, 34, 216, 234);
INSERT INTO public.who_global_data VALUES (51045, 0, 1765, 0, 25, 216, 23);
INSERT INTO public.who_global_data VALUES (51046, 6, 256, 0, 14, 216, 192);
INSERT INTO public.who_global_data VALUES (51047, 129, 6230, 0, 110, 216, 69);
INSERT INTO public.who_global_data VALUES (51048, 0, 12, 0, 0, 216, 187);
INSERT INTO public.who_global_data VALUES (51049, 996, 22116, 14, 605, 216, 230);
INSERT INTO public.who_global_data VALUES (51050, 11, 4183, 1, 589, 216, 77);
INSERT INTO public.who_global_data VALUES (51051, 0, 1830, 0, 10, 216, 9);
INSERT INTO public.who_global_data VALUES (51052, 24850, 673165, 613, 19268, 216, 74);
INSERT INTO public.who_global_data VALUES (51053, 1447, 62142, 53, 3089, 216, 224);
INSERT INTO public.who_global_data VALUES (51054, 2449, 237878, 148, 11408, 216, 199);
INSERT INTO public.who_global_data VALUES (51055, 2334, 58354, 106, 2368, 216, 190);
INSERT INTO public.who_global_data VALUES (51056, 11, 25509, 1, 1741, 216, 12);
INSERT INTO public.who_global_data VALUES (51057, 0, 336, 0, 24, 216, 104);
INSERT INTO public.who_global_data VALUES (51058, 939, 28505, 3, 334, 216, 153);
INSERT INTO public.who_global_data VALUES (51059, 235, 241419, 21, 34854, 216, 91);
INSERT INTO public.who_global_data VALUES (51060, 6, 721, 0, 10, 216, 215);
INSERT INTO public.who_global_data VALUES (51061, 240, 19522, 0, 977, 216, 84);
INSERT INTO public.who_global_data VALUES (51062, 0, 320, 0, 31, 216, 231);
INSERT INTO public.who_global_data VALUES (51063, 1, 1071, 0, 10, 216, 196);
INSERT INTO public.who_global_data VALUES (51064, 1403, 48574, 18, 260, 216, 105);
INSERT INTO public.who_global_data VALUES (51065, 389, 7577, 5, 159, 216, 122);
INSERT INTO public.who_global_data VALUES (51066, 0, 0, 0, 0, 216, 159);
INSERT INTO public.who_global_data VALUES (51067, 178, 3313, 9, 54, 216, 75);
INSERT INTO public.who_global_data VALUES (51068, 631, 49303, 5, 365, 216, 27);
INSERT INTO public.who_global_data VALUES (51069, 0, 7094, 0, 78, 216, 54);
INSERT INTO public.who_global_data VALUES (51070, 0, 19, 0, 0, 216, 226);
INSERT INTO public.who_global_data VALUES (51071, 1, 1123, 0, 30, 216, 79);
INSERT INTO public.who_global_data VALUES (51072, 25, 1855, 0, 35, 216, 56);
INSERT INTO public.who_global_data VALUES (51073, 16, 79, 0, 0, 216, 117);
INSERT INTO public.who_global_data VALUES (51074, 0, 833, 0, 37, 216, 152);
INSERT INTO public.who_global_data VALUES (51075, 71, 989, 0, 27, 216, 16);
INSERT INTO public.who_global_data VALUES (51076, 0, 84, 0, 1, 216, 10);
INSERT INTO public.who_global_data VALUES (51077, 5, 1831, 0, 79, 216, 201);
INSERT INTO public.who_global_data VALUES (51078, 29, 4476, 0, 110, 216, 174);
INSERT INTO public.who_global_data VALUES (51079, 216, 2728, 3, 29, 216, 119);
INSERT INTO public.who_global_data VALUES (51080, 115, 1613, 1, 17, 216, 168);
INSERT INTO public.who_global_data VALUES (51081, 10, 8658, 0, 121, 216, 99);
INSERT INTO public.who_global_data VALUES (51082, 25, 2435, 2, 10, 216, 171);
INSERT INTO public.who_global_data VALUES (51083, 18, 2303, 1, 118, 216, 87);
INSERT INTO public.who_global_data VALUES (51084, 0, 671, 0, 9, 216, 123);
INSERT INTO public.who_global_data VALUES (51085, 0, 0, 0, 0, 216, 151);
INSERT INTO public.who_global_data VALUES (51086, 7, 249, 0, 14, 216, 213);
INSERT INTO public.who_global_data VALUES (51087, 0, 4705, 0, 129, 216, 118);
INSERT INTO public.who_global_data VALUES (51088, 0, 341, 0, 10, 216, 134);
INSERT INTO public.who_global_data VALUES (51089, 7, 2668, 0, 36, 216, 65);
INSERT INTO public.who_global_data VALUES (51090, 6740, 245251, 654, 29843, 216, 102);
INSERT INTO public.who_global_data VALUES (51091, 0, 0, 0, 0, 216, 223);
INSERT INTO public.who_global_data VALUES (51092, 0, 76, 0, 1, 216, 4);
INSERT INTO public.who_global_data VALUES (51093, 0, 220, 0, 0, 216, 146);
INSERT INTO public.who_global_data VALUES (51094, 151, 893, 0, 14, 216, 31);
INSERT INTO public.who_global_data VALUES (51095, 0, 11, 0, 1, 216, 127);
INSERT INTO public.who_global_data VALUES (51096, 534, 13822, 2, 232, 216, 22);
INSERT INTO public.who_global_data VALUES (51097, 30, 969, 1, 7, 216, 115);
INSERT INTO public.who_global_data VALUES (51098, 7, 313, 0, 6, 216, 106);
INSERT INTO public.who_global_data VALUES (51099, 25, 375, 0, 0, 216, 90);
INSERT INTO public.who_global_data VALUES (51100, 0, 0, 0, 0, 216, 70);
INSERT INTO public.who_global_data VALUES (51101, 232, 15491, 2, 34, 216, 46);
INSERT INTO public.who_global_data VALUES (51102, 65, 50337, 7, 6100, 216, 139);
INSERT INTO public.who_global_data VALUES (51103, 0, 21, 0, 0, 216, 42);
INSERT INTO public.who_global_data VALUES (51104, 3, 1183, 0, 22, 216, 80);
INSERT INTO public.who_global_data VALUES (51105, 0, 2182, 0, 83, 216, 203);
INSERT INTO public.who_global_data VALUES (51106, 0, 1082, 0, 68, 216, 136);
INSERT INTO public.who_global_data VALUES (51107, 603, 28167, 6, 634, 216, 63);
INSERT INTO public.who_global_data VALUES (51108, 0, 0, 0, 0, 216, 17);
INSERT INTO public.who_global_data VALUES (51109, 0, 31, 0, 2, 216, 172);
INSERT INTO public.who_global_data VALUES (51110, 145, 6932, 6, 334, 216, 109);
INSERT INTO public.who_global_data VALUES (51111, 0, 8895, 0, 251, 216, 200);
INSERT INTO public.who_global_data VALUES (51112, 561, 4250, 4, 19, 216, 93);
INSERT INTO public.who_global_data VALUES (51113, 1177, 45106, 10, 203, 216, 5);
INSERT INTO public.who_global_data VALUES (51114, 0, 741, 0, 13, 216, 214);
INSERT INTO public.who_global_data VALUES (51115, 3191, 228474, 93, 4712, 216, 204);
INSERT INTO public.who_global_data VALUES (51116, 0, 0, 0, 0, 216, 198);
INSERT INTO public.who_global_data VALUES (51117, 758, 35995, 31, 698, 216, 173);
INSERT INTO public.who_global_data VALUES (51118, 0, 11, 0, 0, 216, 229);
INSERT INTO public.who_global_data VALUES (51119, 36, 2385, 1, 20, 216, 76);
INSERT INTO public.who_global_data VALUES (51120, 3595, 295599, 181, 10226, 216, 138);
INSERT INTO public.who_global_data VALUES (51121, 1494, 41830, 10, 1290, 216, 98);
INSERT INTO public.who_global_data VALUES (51122, 0, 0, 0, 0, 216, 103);
INSERT INTO public.who_global_data VALUES (51123, 314, 35719, 5, 1512, 216, 225);
INSERT INTO public.who_global_data VALUES (51124, 413, 43569, 7, 1605, 216, 131);
INSERT INTO public.who_global_data VALUES (51125, 104, 7787, 1, 155, 216, 235);
INSERT INTO public.who_global_data VALUES (51126, 530, 99183, 2, 123, 216, 137);
INSERT INTO public.who_global_data VALUES (51127, 61, 13089, 0, 283, 216, 81);
INSERT INTO public.who_global_data VALUES (51128, 227, 17672, 6, 582, 216, 182);
INSERT INTO public.who_global_data VALUES (51129, 3, 536, 0, 2, 216, 145);
INSERT INTO public.who_global_data VALUES (51130, 416, 28582, 23, 1731, 216, 26);
INSERT INTO public.who_global_data VALUES (51131, 6736, 681251, 134, 10161, 216, 170);
INSERT INTO public.who_global_data VALUES (51132, 11, 1092, 0, 3, 216, 191);
INSERT INTO public.who_global_data VALUES (51133, 0, 3, 0, 0, 216, 221);
INSERT INTO public.who_global_data VALUES (51134, 0, 6, 0, 0, 216, 64);
INSERT INTO public.who_global_data VALUES (51135, 0, 0, 0, 0, 216, 116);
INSERT INTO public.who_global_data VALUES (51136, 0, 15, 0, 0, 216, 128);
INSERT INTO public.who_global_data VALUES (51137, 0, 22, 0, 0, 216, 6);
INSERT INTO public.who_global_data VALUES (51138, 1, 44, 0, 3, 216, 227);
INSERT INTO public.who_global_data VALUES (51139, 0, 1, 0, 0, 216, 68);
INSERT INTO public.who_global_data VALUES (51140, 0, 29, 0, 0, 216, 184);
INSERT INTO public.who_global_data VALUES (51141, 0, 0, 0, 0, 216, 82);
INSERT INTO public.who_global_data VALUES (51142, 0, 713, 0, 42, 216, 149);
INSERT INTO public.who_global_data VALUES (51143, 0, 399, 0, 11, 216, 197);
INSERT INTO public.who_global_data VALUES (51144, 4128, 205929, 56, 1858, 216, 78);
INSERT INTO public.who_global_data VALUES (51145, 108, 7272, 4, 129, 216, 233);
INSERT INTO public.who_global_data VALUES (51146, 325, 15829, 8, 306, 216, 133);
INSERT INTO public.who_global_data VALUES (51147, 0, 81, 0, 0, 216, 35);
INSERT INTO public.who_global_data VALUES (51148, 9, 1533, 0, 62, 216, 114);
INSERT INTO public.who_global_data VALUES (51149, 185, 44664, 0, 26, 216, 237);
INSERT INTO public.who_global_data VALUES (51150, 0, 2, 0, 0, 216, 55);
INSERT INTO public.who_global_data VALUES (51151, 0, 78, 0, 15, 216, 176);
INSERT INTO public.who_global_data VALUES (51152, 29, 1749, 0, 28, 216, 202);
INSERT INTO public.who_global_data VALUES (51153, 21, 1700, 0, 114, 216, 155);
INSERT INTO public.who_global_data VALUES (51154, 0, 0, 0, 0, 216, 32);
INSERT INTO public.who_global_data VALUES (51155, 17, 2961, 2, 92, 216, 220);
INSERT INTO public.who_global_data VALUES (51156, 10853, 187977, 74, 3026, 216, 30);
INSERT INTO public.who_global_data VALUES (51157, 22, 2058, 0, 38, 216, 147);
INSERT INTO public.who_global_data VALUES (51158, 615, 259994, 5, 29761, 216, 208);
INSERT INTO public.who_global_data VALUES (51159, 5, 2074, 0, 11, 216, 45);
INSERT INTO public.who_global_data VALUES (51160, 78, 9767, 1, 608, 216, 110);
INSERT INTO public.who_global_data VALUES (51161, 18, 565, 1, 14, 216, 88);
INSERT INTO public.who_global_data VALUES (51162, 694, 69930, 8, 5552, 216, 51);
INSERT INTO public.who_global_data VALUES (51163, 26, 32257, 0, 1724, 216, 209);
INSERT INTO public.who_global_data VALUES (51164, 10, 338, 0, 10, 216, 205);
INSERT INTO public.who_global_data VALUES (51165, 101, 6159, 0, 52, 216, 18);
INSERT INTO public.who_global_data VALUES (51166, 5, 3190, 0, 58, 216, 72);
INSERT INTO public.who_global_data VALUES (51167, 579, 286724, 32, 40613, 216, 44);
INSERT INTO public.who_global_data VALUES (51168, 0, 24, 0, 0, 216, 15);
INSERT INTO public.who_global_data VALUES (51169, 5, 676, 1, 15, 216, 25);
INSERT INTO public.who_global_data VALUES (51170, 0, 0, 0, 0, 216, 179);
INSERT INTO public.who_global_data VALUES (51171, 0, 0, 0, 0, 216, 34);
INSERT INTO public.who_global_data VALUES (51172, 0, 130, 0, 8, 216, 207);
INSERT INTO public.who_global_data VALUES (51173, 2, 1188, 0, 50, 216, 166);
INSERT INTO public.who_global_data VALUES (51174, 1154, 204610, 20, 5206, 216, 126);
INSERT INTO public.who_global_data VALUES (51175, 0, 0, 0, 0, 216, 97);
INSERT INTO public.who_global_data VALUES (51176, 1, 45, 0, 2, 216, 36);
INSERT INTO public.who_global_data VALUES (51177, 0, 0, 0, 0, 216, 125);
INSERT INTO public.who_global_data VALUES (51178, 16, 927, 0, 0, 216, 124);
INSERT INTO public.who_global_data VALUES (51179, 823, 48500, 22, 1249, 216, 185);
INSERT INTO public.who_global_data VALUES (51180, 716, 50857, 3, 321, 216, 194);
INSERT INTO public.who_global_data VALUES (51181, 0, 509, 0, 21, 216, 144);
INSERT INTO public.who_global_data VALUES (51182, 51933, 2776366, 745, 129226, 216, 19);
INSERT INTO public.who_global_data VALUES (51183, 13, 111, 0, 6, 216, 217);
INSERT INTO public.who_global_data VALUES (51184, 5, 952, 0, 28, 216, 148);
INSERT INTO public.who_global_data VALUES (51185, 329, 9829, 2, 31, 216, 86);
INSERT INTO public.who_global_data VALUES (51186, 0, 0, 0, 0, 216, 13);
INSERT INTO public.who_global_data VALUES (51187, 264, 6537, 2, 59, 216, 157);
INSERT INTO public.who_global_data VALUES (51188, 0, 355, 0, 0, 216, 8);
INSERT INTO public.who_global_data VALUES (51189, 0, 0, 0, 0, 216, 73);
INSERT INTO public.who_global_data VALUES (51190, 8, 1248, 2, 337, 216, 101);
INSERT INTO public.who_global_data VALUES (51191, 0, 1632, 0, 30, 216, 165);
INSERT INTO public.who_global_data VALUES (51192, 73, 698, 1, 8, 216, 14);
INSERT INTO public.who_global_data VALUES (51193, 348, 32758, 7, 830, 217, 193);
INSERT INTO public.who_global_data VALUES (51194, 67, 2819, 2, 74, 217, 113);
INSERT INTO public.who_global_data VALUES (51195, 413, 15070, 9, 937, 217, 143);
INSERT INTO public.who_global_data VALUES (51196, 0, 0, 0, 0, 217, 219);
INSERT INTO public.who_global_data VALUES (51197, 0, 855, 0, 52, 217, 186);
INSERT INTO public.who_global_data VALUES (51198, 13, 328, 1, 18, 217, 52);
INSERT INTO public.who_global_data VALUES (51199, 0, 3, 0, 0, 217, 180);
INSERT INTO public.who_global_data VALUES (51200, 0, 68, 0, 3, 217, 167);
INSERT INTO public.who_global_data VALUES (51201, 2744, 69941, 40, 1403, 217, 154);
INSERT INTO public.who_global_data VALUES (51202, 580, 27213, 8, 472, 217, 94);
INSERT INTO public.who_global_data VALUES (51203, 1, 104, 0, 3, 217, 66);
INSERT INTO public.who_global_data VALUES (51204, 254, 8255, 0, 104, 217, 58);
INSERT INTO public.who_global_data VALUES (51205, 121, 18073, 0, 705, 217, 163);
INSERT INTO public.who_global_data VALUES (51206, 583, 19267, 7, 235, 217, 37);
INSERT INTO public.who_global_data VALUES (51207, 0, 104, 0, 11, 217, 142);
INSERT INTO public.who_global_data VALUES (51208, 573, 28410, 1, 95, 217, 83);
INSERT INTO public.who_global_data VALUES (51209, 3114, 156391, 42, 1968, 217, 228);
INSERT INTO public.who_global_data VALUES (51210, 0, 97, 0, 7, 217, 188);
INSERT INTO public.who_global_data VALUES (51211, 299, 62997, 7, 412, 217, 62);
INSERT INTO public.who_global_data VALUES (51212, 94, 62406, 2, 9637, 217, 160);
INSERT INTO public.who_global_data VALUES (51213, 0, 28, 0, 2, 217, 50);
INSERT INTO public.who_global_data VALUES (51214, 0, 1199, 0, 21, 217, 33);
INSERT INTO public.who_global_data VALUES (51215, 0, 146, 0, 9, 217, 183);
INSERT INTO public.who_global_data VALUES (51216, 1, 78, 0, 0, 217, 92);
INSERT INTO public.who_global_data VALUES (51217, 1301, 35528, 70, 1271, 217, 158);
INSERT INTO public.who_global_data VALUES (51218, 0, 2, 0, 0, 217, 67);
INSERT INTO public.who_global_data VALUES (51219, 172, 4960, 2, 190, 217, 57);
INSERT INTO public.who_global_data VALUES (51220, 48, 275, 0, 1, 217, 38);
INSERT INTO public.who_global_data VALUES (51221, 48105, 1496858, 1252, 61884, 217, 141);
INSERT INTO public.who_global_data VALUES (51222, 0, 8, 0, 1, 217, 178);
INSERT INTO public.who_global_data VALUES (51223, 0, 141, 0, 3, 217, 108);
INSERT INTO public.who_global_data VALUES (51224, 182, 5497, 7, 239, 217, 39);
INSERT INTO public.who_global_data VALUES (51225, 13, 980, 0, 53, 217, 2);
INSERT INTO public.who_global_data VALUES (51226, 21, 191, 0, 1, 217, 195);
INSERT INTO public.who_global_data VALUES (51227, 81, 1382, 0, 15, 217, 107);
INSERT INTO public.who_global_data VALUES (51228, 0, 141, 0, 0, 217, 161);
INSERT INTO public.who_global_data VALUES (51229, 0, 12592, 0, 313, 217, 212);
INSERT INTO public.who_global_data VALUES (51230, 568, 104772, 51, 8642, 217, 181);
INSERT INTO public.who_global_data VALUES (51231, 0, 201, 0, 1, 217, 53);
INSERT INTO public.who_global_data VALUES (51232, 130, 3918, 1, 48, 217, 164);
INSERT INTO public.who_global_data VALUES (51233, 3, 871, 0, 74, 217, 140);
INSERT INTO public.who_global_data VALUES (51234, 3548, 288089, 131, 6051, 217, 20);
INSERT INTO public.who_global_data VALUES (51235, 9, 85287, 0, 4648, 217, 112);
INSERT INTO public.who_global_data VALUES (51236, 4101, 106110, 171, 3641, 217, 111);
INSERT INTO public.who_global_data VALUES (51237, 6, 309, 0, 7, 217, 71);
INSERT INTO public.who_global_data VALUES (51238, 114, 1557, 2, 44, 217, 218);
INSERT INTO public.who_global_data VALUES (51239, 0, 0, 0, 0, 217, 43);
INSERT INTO public.who_global_data VALUES (51240, 270, 4023, 2, 18, 217, 49);
INSERT INTO public.who_global_data VALUES (51241, 290, 9992, 0, 68, 217, 1);
INSERT INTO public.who_global_data VALUES (51242, 96, 3008, 2, 112, 217, 48);
INSERT INTO public.who_global_data VALUES (51243, 8, 2361, 0, 86, 217, 232);
INSERT INTO public.who_global_data VALUES (51244, 0, 25, 0, 1, 217, 175);
INSERT INTO public.who_global_data VALUES (51245, 0, 999, 0, 19, 217, 21);
INSERT INTO public.who_global_data VALUES (51246, 141, 12319, 1, 352, 217, 156);
INSERT INTO public.who_global_data VALUES (51247, 0, 0, 0, 0, 217, 95);
INSERT INTO public.who_global_data VALUES (51248, 122, 7310, 3, 178, 217, 177);
INSERT INTO public.who_global_data VALUES (51249, 17, 12832, 0, 606, 217, 210);
INSERT INTO public.who_global_data VALUES (51250, 21, 4736, 0, 55, 217, 120);
INSERT INTO public.who_global_data VALUES (51251, 0, 18, 0, 0, 217, 135);
INSERT INTO public.who_global_data VALUES (51252, 951, 35148, 10, 775, 217, 206);
INSERT INTO public.who_global_data VALUES (51253, 1189, 60657, 61, 4700, 217, 189);
INSERT INTO public.who_global_data VALUES (51254, 1412, 72711, 81, 3201, 217, 129);
INSERT INTO public.who_global_data VALUES (51255, 267, 7267, 11, 202, 217, 121);
INSERT INTO public.who_global_data VALUES (51256, 0, 1043, 0, 12, 217, 59);
INSERT INTO public.who_global_data VALUES (51257, 0, 215, 0, 0, 217, 96);
INSERT INTO public.who_global_data VALUES (51258, 1, 1991, 0, 63, 217, 41);
INSERT INTO public.who_global_data VALUES (51259, 36, 909, 2, 13, 217, 216);
INSERT INTO public.who_global_data VALUES (51260, 54, 6217, 5, 114, 217, 236);
INSERT INTO public.who_global_data VALUES (51261, 0, 13, 0, 0, 217, 150);
INSERT INTO public.who_global_data VALUES (51262, 0, 187, 0, 0, 217, 61);
INSERT INTO public.who_global_data VALUES (51263, 0, 18, 0, 0, 217, 7);
INSERT INTO public.who_global_data VALUES (51264, 28, 7269, 0, 328, 217, 169);
INSERT INTO public.who_global_data VALUES (51265, 448, 158734, 17, 29808, 217, 28);
INSERT INTO public.who_global_data VALUES (51266, 114, 4558, 0, 16, 217, 85);
INSERT INTO public.who_global_data VALUES (51267, 0, 62, 0, 0, 217, 211);
INSERT INTO public.who_global_data VALUES (51268, 0, 5513, 0, 42, 217, 60);
INSERT INTO public.who_global_data VALUES (51269, 0, 55, 0, 2, 217, 3);
INSERT INTO public.who_global_data VALUES (51270, 3, 946, 0, 15, 217, 11);
INSERT INTO public.who_global_data VALUES (51271, 422, 196096, 7, 9010, 217, 89);
INSERT INTO public.who_global_data VALUES (51272, 758, 18892, 0, 117, 217, 24);
INSERT INTO public.who_global_data VALUES (51273, 0, 178, 0, 0, 217, 162);
INSERT INTO public.who_global_data VALUES (51274, 28, 3486, 0, 192, 217, 100);
INSERT INTO public.who_global_data VALUES (51275, 0, 13, 0, 0, 217, 47);
INSERT INTO public.who_global_data VALUES (51276, 0, 23, 0, 0, 217, 29);
INSERT INTO public.who_global_data VALUES (51277, 0, 182, 0, 14, 217, 40);
INSERT INTO public.who_global_data VALUES (51278, 6, 278, 0, 5, 217, 222);
INSERT INTO public.who_global_data VALUES (51279, 1061, 20072, 26, 843, 217, 132);
INSERT INTO public.who_global_data VALUES (51280, 0, 252, 0, 13, 217, 130);
INSERT INTO public.who_global_data VALUES (51281, 71, 5521, -13, 33, 217, 234);
INSERT INTO public.who_global_data VALUES (51282, 55, 1765, 1, 25, 217, 23);
INSERT INTO public.who_global_data VALUES (51283, 2, 250, 2, 14, 217, 192);
INSERT INTO public.who_global_data VALUES (51284, 61, 6101, 3, 110, 217, 69);
INSERT INTO public.who_global_data VALUES (51285, 0, 12, 0, 0, 217, 187);
INSERT INTO public.who_global_data VALUES (51286, 858, 21120, 49, 591, 217, 230);
INSERT INTO public.who_global_data VALUES (51287, 6, 4172, 1, 588, 217, 77);
INSERT INTO public.who_global_data VALUES (51288, 0, 1830, 0, 10, 217, 9);
INSERT INTO public.who_global_data VALUES (51289, 22771, 648315, 442, 18655, 217, 74);
INSERT INTO public.who_global_data VALUES (51290, 1301, 60695, 49, 3036, 217, 224);
INSERT INTO public.who_global_data VALUES (51291, 2566, 235429, 154, 11260, 217, 199);
INSERT INTO public.who_global_data VALUES (51292, 2312, 56020, 102, 2262, 217, 190);
INSERT INTO public.who_global_data VALUES (51293, 9, 25498, 2, 1740, 217, 12);
INSERT INTO public.who_global_data VALUES (51294, 0, 336, 0, 24, 217, 104);
INSERT INTO public.who_global_data VALUES (51295, 1148, 27566, 1, 331, 217, 153);
INSERT INTO public.who_global_data VALUES (51296, 223, 241184, 15, 34833, 217, 91);
INSERT INTO public.who_global_data VALUES (51297, 8, 715, 0, 10, 217, 215);
INSERT INTO public.who_global_data VALUES (51298, 214, 19282, 1, 977, 217, 84);
INSERT INTO public.who_global_data VALUES (51299, 0, 320, 0, 31, 217, 231);
INSERT INTO public.who_global_data VALUES (51300, 10, 1070, 1, 10, 217, 196);
INSERT INTO public.who_global_data VALUES (51301, 1452, 47171, 18, 242, 217, 105);
INSERT INTO public.who_global_data VALUES (51302, 247, 7188, 2, 154, 217, 122);
INSERT INTO public.who_global_data VALUES (51303, 0, 0, 0, 0, 217, 159);
INSERT INTO public.who_global_data VALUES (51304, 114, 3135, 0, 45, 217, 75);
INSERT INTO public.who_global_data VALUES (51305, 813, 48672, 1, 360, 217, 27);
INSERT INTO public.who_global_data VALUES (51306, 327, 7094, 2, 78, 217, 54);
INSERT INTO public.who_global_data VALUES (51307, 0, 19, 0, 0, 217, 226);
INSERT INTO public.who_global_data VALUES (51308, 0, 1122, 0, 30, 217, 79);
INSERT INTO public.who_global_data VALUES (51309, 34, 1830, 0, 35, 217, 56);
INSERT INTO public.who_global_data VALUES (51310, 28, 63, 0, 0, 217, 117);
INSERT INTO public.who_global_data VALUES (51311, 14, 833, 0, 37, 217, 152);
INSERT INTO public.who_global_data VALUES (51312, 27, 918, 1, 27, 217, 16);
INSERT INTO public.who_global_data VALUES (51313, 0, 84, 0, 1, 217, 10);
INSERT INTO public.who_global_data VALUES (51314, 3, 1826, 0, 79, 217, 201);
INSERT INTO public.who_global_data VALUES (51315, 52, 4447, 0, 110, 217, 174);
INSERT INTO public.who_global_data VALUES (51316, 109, 2512, 2, 26, 217, 119);
INSERT INTO public.who_global_data VALUES (51317, 96, 1498, 0, 16, 217, 168);
INSERT INTO public.who_global_data VALUES (51318, 5, 8648, 0, 121, 217, 99);
INSERT INTO public.who_global_data VALUES (51319, 10, 2410, 0, 8, 217, 171);
INSERT INTO public.who_global_data VALUES (51320, 25, 2285, 0, 117, 217, 87);
INSERT INTO public.who_global_data VALUES (51321, 0, 671, 0, 9, 217, 123);
INSERT INTO public.who_global_data VALUES (51322, 0, 0, 0, 0, 217, 151);
INSERT INTO public.who_global_data VALUES (51323, 0, 242, 0, 14, 217, 213);
INSERT INTO public.who_global_data VALUES (51324, 99, 4705, 0, 129, 217, 118);
INSERT INTO public.who_global_data VALUES (51325, 0, 341, 0, 10, 217, 134);
INSERT INTO public.who_global_data VALUES (51326, 18, 2661, 1, 36, 217, 65);
INSERT INTO public.who_global_data VALUES (51327, 6741, 238511, 679, 29189, 217, 102);
INSERT INTO public.who_global_data VALUES (51328, 0, 0, 0, 0, 217, 223);
INSERT INTO public.who_global_data VALUES (51329, 0, 76, 0, 1, 217, 4);
INSERT INTO public.who_global_data VALUES (51330, 0, 220, 0, 0, 217, 146);
INSERT INTO public.who_global_data VALUES (51331, 34, 742, 0, 14, 217, 31);
INSERT INTO public.who_global_data VALUES (51332, 0, 11, 0, 1, 217, 127);
INSERT INTO public.who_global_data VALUES (51333, 319, 13288, 1, 230, 217, 22);
INSERT INTO public.who_global_data VALUES (51334, 21, 939, 0, 6, 217, 115);
INSERT INTO public.who_global_data VALUES (51335, 2, 306, 0, 6, 217, 106);
INSERT INTO public.who_global_data VALUES (51336, 57, 350, 0, 0, 217, 90);
INSERT INTO public.who_global_data VALUES (51337, 0, 0, 0, 0, 217, 70);
INSERT INTO public.who_global_data VALUES (51338, 740, 15259, 1, 32, 217, 46);
INSERT INTO public.who_global_data VALUES (51339, 76, 50272, 1, 6093, 217, 139);
INSERT INTO public.who_global_data VALUES (51340, 0, 21, 0, 0, 217, 42);
INSERT INTO public.who_global_data VALUES (51341, 0, 1180, 0, 22, 217, 80);
INSERT INTO public.who_global_data VALUES (51342, 0, 2182, 0, 83, 217, 203);
INSERT INTO public.who_global_data VALUES (51343, 1, 1082, 0, 68, 217, 136);
INSERT INTO public.who_global_data VALUES (51344, 454, 27564, 12, 628, 217, 63);
INSERT INTO public.who_global_data VALUES (51345, 0, 0, 0, 0, 217, 17);
INSERT INTO public.who_global_data VALUES (51346, 0, 31, 0, 2, 217, 172);
INSERT INTO public.who_global_data VALUES (51347, 144, 6787, 7, 328, 217, 109);
INSERT INTO public.who_global_data VALUES (51348, 0, 8895, 0, 251, 217, 200);
INSERT INTO public.who_global_data VALUES (51349, 272, 3689, 4, 15, 217, 93);
INSERT INTO public.who_global_data VALUES (51350, 1374, 43929, 5, 193, 217, 5);
INSERT INTO public.who_global_data VALUES (51351, 0, 741, 0, 13, 217, 214);
INSERT INTO public.who_global_data VALUES (51352, 3387, 225283, 68, 4619, 217, 204);
INSERT INTO public.who_global_data VALUES (51353, 0, 0, 0, 0, 217, 198);
INSERT INTO public.who_global_data VALUES (51354, 774, 35237, 22, 667, 217, 173);
INSERT INTO public.who_global_data VALUES (51355, 0, 11, 0, 0, 217, 229);
INSERT INTO public.who_global_data VALUES (51356, 46, 2349, 0, 19, 217, 76);
INSERT INTO public.who_global_data VALUES (51357, 3527, 292004, 185, 10045, 217, 138);
INSERT INTO public.who_global_data VALUES (51358, 1531, 40336, 6, 1280, 217, 98);
INSERT INTO public.who_global_data VALUES (51359, 0, 0, 0, 0, 217, 103);
INSERT INTO public.who_global_data VALUES (51360, 259, 35405, 15, 1507, 217, 225);
INSERT INTO public.who_global_data VALUES (51361, 374, 43156, 11, 1598, 217, 131);
INSERT INTO public.who_global_data VALUES (51362, 75, 7683, 1, 154, 217, 235);
INSERT INTO public.who_global_data VALUES (51363, 756, 98653, 3, 121, 217, 137);
INSERT INTO public.who_global_data VALUES (51364, 63, 13028, 1, 283, 217, 81);
INSERT INTO public.who_global_data VALUES (51365, 295, 17445, 13, 576, 217, 182);
INSERT INTO public.who_global_data VALUES (51366, 2, 533, 0, 2, 217, 145);
INSERT INTO public.who_global_data VALUES (51367, 420, 28166, 21, 1708, 217, 26);
INSERT INTO public.who_global_data VALUES (51368, 6632, 674515, 168, 10027, 217, 170);
INSERT INTO public.who_global_data VALUES (51369, 18, 1081, 0, 3, 217, 191);
INSERT INTO public.who_global_data VALUES (51370, 0, 3, 0, 0, 217, 221);
INSERT INTO public.who_global_data VALUES (51371, 0, 6, 0, 0, 217, 64);
INSERT INTO public.who_global_data VALUES (51372, 0, 0, 0, 0, 217, 116);
INSERT INTO public.who_global_data VALUES (51373, 0, 15, 0, 0, 217, 128);
INSERT INTO public.who_global_data VALUES (51374, 3, 22, 0, 0, 217, 6);
INSERT INTO public.who_global_data VALUES (51375, 0, 43, 0, 3, 217, 227);
INSERT INTO public.who_global_data VALUES (51376, 0, 1, 0, 0, 217, 68);
INSERT INTO public.who_global_data VALUES (51377, 0, 29, 0, 0, 217, 184);
INSERT INTO public.who_global_data VALUES (51378, 0, 0, 0, 0, 217, 82);
INSERT INTO public.who_global_data VALUES (51379, 0, 713, 0, 42, 217, 149);
INSERT INTO public.who_global_data VALUES (51380, 2, 399, 0, 11, 217, 197);
INSERT INTO public.who_global_data VALUES (51381, 4193, 201801, 50, 1802, 217, 78);
INSERT INTO public.who_global_data VALUES (51382, 110, 7164, 4, 125, 217, 233);
INSERT INTO public.who_global_data VALUES (51383, 309, 15504, 11, 298, 217, 133);
INSERT INTO public.who_global_data VALUES (51384, 0, 81, 0, 0, 217, 35);
INSERT INTO public.who_global_data VALUES (51385, 6, 1524, 2, 62, 217, 114);
INSERT INTO public.who_global_data VALUES (51386, 169, 44479, 0, 26, 217, 237);
INSERT INTO public.who_global_data VALUES (51387, 0, 2, 0, 0, 217, 55);
INSERT INTO public.who_global_data VALUES (51388, 1, 78, 0, 15, 217, 176);
INSERT INTO public.who_global_data VALUES (51389, 20, 1720, 0, 28, 217, 202);
INSERT INTO public.who_global_data VALUES (51390, 30, 1679, 0, 114, 217, 155);
INSERT INTO public.who_global_data VALUES (51391, 0, 0, 0, 0, 217, 32);
INSERT INTO public.who_global_data VALUES (51392, 0, 2944, 0, 90, 217, 220);
INSERT INTO public.who_global_data VALUES (51393, 9063, 177124, 108, 2952, 217, 30);
INSERT INTO public.who_global_data VALUES (51394, 0, 2036, 0, 38, 217, 147);
INSERT INTO public.who_global_data VALUES (51395, 520, 259379, 1, 29756, 217, 208);
INSERT INTO public.who_global_data VALUES (51396, 3, 2069, 0, 11, 217, 45);
INSERT INTO public.who_global_data VALUES (51397, 0, 9689, 0, 607, 217, 110);
INSERT INTO public.who_global_data VALUES (51398, 12, 547, 0, 13, 217, 88);
INSERT INTO public.who_global_data VALUES (51399, 687, 69236, 15, 5544, 217, 51);
INSERT INTO public.who_global_data VALUES (51400, 96, 32231, 0, 1724, 217, 209);
INSERT INTO public.who_global_data VALUES (51401, 16, 328, 1, 10, 217, 205);
INSERT INTO public.who_global_data VALUES (51402, 53, 6058, 0, 52, 217, 18);
INSERT INTO public.who_global_data VALUES (51403, 5, 3185, 0, 58, 217, 72);
INSERT INTO public.who_global_data VALUES (51404, 602, 286145, 49, 40581, 217, 44);
INSERT INTO public.who_global_data VALUES (51405, 0, 24, 0, 0, 217, 15);
INSERT INTO public.who_global_data VALUES (51406, 4, 671, 0, 14, 217, 25);
INSERT INTO public.who_global_data VALUES (51407, 0, 0, 0, 0, 217, 179);
INSERT INTO public.who_global_data VALUES (51408, 0, 0, 0, 0, 217, 34);
INSERT INTO public.who_global_data VALUES (51409, 0, 130, 0, 8, 217, 207);
INSERT INTO public.who_global_data VALUES (51410, 5, 1186, 0, 50, 217, 166);
INSERT INTO public.who_global_data VALUES (51411, 1172, 203456, 19, 5186, 217, 126);
INSERT INTO public.who_global_data VALUES (51412, 0, 0, 0, 0, 217, 97);
INSERT INTO public.who_global_data VALUES (51413, 2, 44, 0, 2, 217, 36);
INSERT INTO public.who_global_data VALUES (51414, 0, 0, 0, 0, 217, 125);
INSERT INTO public.who_global_data VALUES (51415, 9, 911, 0, 0, 217, 124);
INSERT INTO public.who_global_data VALUES (51416, 914, 47677, 15, 1227, 217, 185);
INSERT INTO public.who_global_data VALUES (51417, 672, 50141, 1, 318, 217, 194);
INSERT INTO public.who_global_data VALUES (51418, 0, 509, 0, 21, 217, 144);
INSERT INTO public.who_global_data VALUES (51419, 53213, 2724433, 623, 128481, 217, 19);
INSERT INTO public.who_global_data VALUES (51420, 6, 98, 0, 6, 217, 217);
INSERT INTO public.who_global_data VALUES (51421, 4, 947, 0, 28, 217, 148);
INSERT INTO public.who_global_data VALUES (51422, 301, 9500, 2, 29, 217, 86);
INSERT INTO public.who_global_data VALUES (51423, 0, 0, 0, 0, 217, 13);
INSERT INTO public.who_global_data VALUES (51424, 211, 6273, 3, 57, 217, 157);
INSERT INTO public.who_global_data VALUES (51425, 0, 355, 0, 0, 217, 8);
INSERT INTO public.who_global_data VALUES (51426, 0, 0, 0, 0, 217, 73);
INSERT INTO public.who_global_data VALUES (51427, 19, 1240, 10, 335, 217, 101);
INSERT INTO public.who_global_data VALUES (51428, 0, 1632, 0, 30, 217, 165);
INSERT INTO public.who_global_data VALUES (51429, 8, 625, 0, 7, 217, 14);
INSERT INTO public.who_global_data VALUES (51430, 302, 32410, 12, 823, 218, 193);
INSERT INTO public.who_global_data VALUES (51431, 90, 2752, 3, 72, 218, 113);
INSERT INTO public.who_global_data VALUES (51432, 385, 14657, 8, 928, 218, 143);
INSERT INTO public.who_global_data VALUES (51433, 0, 0, 0, 0, 218, 219);
INSERT INTO public.who_global_data VALUES (51434, 0, 855, 0, 52, 218, 186);
INSERT INTO public.who_global_data VALUES (51435, 24, 315, 2, 17, 218, 52);
INSERT INTO public.who_global_data VALUES (51436, 0, 3, 0, 0, 218, 180);
INSERT INTO public.who_global_data VALUES (51437, 2, 68, 0, 3, 218, 167);
INSERT INTO public.who_global_data VALUES (51438, 2667, 67197, 53, 1363, 218, 154);
INSERT INTO public.who_global_data VALUES (51439, 662, 26633, 10, 464, 218, 94);
INSERT INTO public.who_global_data VALUES (51440, 0, 103, 0, 3, 218, 66);
INSERT INTO public.who_global_data VALUES (51441, 81, 8001, 0, 104, 218, 58);
INSERT INTO public.who_global_data VALUES (51442, 138, 17952, 0, 705, 218, 163);
INSERT INTO public.who_global_data VALUES (51443, 572, 18684, 8, 228, 218, 37);
INSERT INTO public.who_global_data VALUES (51444, 0, 104, 0, 11, 218, 142);
INSERT INTO public.who_global_data VALUES (51445, 423, 27837, 2, 94, 218, 83);
INSERT INTO public.who_global_data VALUES (51446, 4019, 153277, 38, 1926, 218, 228);
INSERT INTO public.who_global_data VALUES (51447, 0, 97, 0, 7, 218, 188);
INSERT INTO public.who_global_data VALUES (51448, 274, 62698, 7, 405, 218, 62);
INSERT INTO public.who_global_data VALUES (51449, 93, 62312, 5, 9635, 218, 160);
INSERT INTO public.who_global_data VALUES (51450, 0, 28, 0, 2, 218, 50);
INSERT INTO public.who_global_data VALUES (51451, 0, 1199, 0, 21, 218, 33);
INSERT INTO public.who_global_data VALUES (51452, 0, 146, 0, 9, 218, 183);
INSERT INTO public.who_global_data VALUES (51453, 0, 77, 0, 0, 218, 92);
INSERT INTO public.who_global_data VALUES (51454, 1008, 34227, 78, 1201, 218, 158);
INSERT INTO public.who_global_data VALUES (51455, 0, 2, 0, 0, 218, 67);
INSERT INTO public.who_global_data VALUES (51456, 182, 4788, 1, 188, 218, 57);
INSERT INTO public.who_global_data VALUES (51457, 0, 227, 0, 1, 218, 38);
INSERT INTO public.who_global_data VALUES (51458, 46712, 1448753, 1038, 60632, 218, 141);
INSERT INTO public.who_global_data VALUES (51459, 0, 8, 0, 1, 218, 178);
INSERT INTO public.who_global_data VALUES (51460, 0, 141, 0, 3, 218, 108);
INSERT INTO public.who_global_data VALUES (51461, 161, 5315, 0, 232, 218, 39);
INSERT INTO public.who_global_data VALUES (51462, 5, 967, 0, 53, 218, 2);
INSERT INTO public.who_global_data VALUES (51463, 0, 170, 0, 1, 218, 195);
INSERT INTO public.who_global_data VALUES (51464, 34, 1301, 0, 15, 218, 107);
INSERT INTO public.who_global_data VALUES (51465, 0, 141, 0, 0, 218, 161);
INSERT INTO public.who_global_data VALUES (51466, 0, 12592, 0, 313, 218, 212);
INSERT INTO public.who_global_data VALUES (51467, 0, 104204, 0, 8591, 218, 181);
INSERT INTO public.who_global_data VALUES (51468, 1, 201, 0, 1, 218, 53);
INSERT INTO public.who_global_data VALUES (51469, 43, 3788, 0, 47, 218, 164);
INSERT INTO public.who_global_data VALUES (51470, 2, 868, 0, 74, 218, 140);
INSERT INTO public.who_global_data VALUES (51471, 2498, 284541, 167, 5920, 218, 20);
INSERT INTO public.who_global_data VALUES (51472, 15, 85278, 0, 4648, 218, 112);
INSERT INTO public.who_global_data VALUES (51473, 4163, 102009, 136, 3470, 218, 111);
INSERT INTO public.who_global_data VALUES (51474, 0, 303, 0, 7, 218, 71);
INSERT INTO public.who_global_data VALUES (51475, 0, 1443, 0, 42, 218, 218);
INSERT INTO public.who_global_data VALUES (51476, 0, 0, 0, 0, 218, 43);
INSERT INTO public.who_global_data VALUES (51477, 294, 3753, 0, 16, 218, 49);
INSERT INTO public.who_global_data VALUES (51478, 203, 9702, 0, 68, 218, 1);
INSERT INTO public.who_global_data VALUES (51479, 81, 2912, 2, 110, 218, 48);
INSERT INTO public.who_global_data VALUES (51480, 5, 2353, 0, 86, 218, 232);
INSERT INTO public.who_global_data VALUES (51481, 0, 25, 0, 1, 218, 175);
INSERT INTO public.who_global_data VALUES (51482, 0, 999, 0, 19, 218, 21);
INSERT INTO public.who_global_data VALUES (51483, 132, 12178, 2, 351, 218, 156);
INSERT INTO public.who_global_data VALUES (51484, 0, 0, 0, 0, 218, 95);
INSERT INTO public.who_global_data VALUES (51485, 67, 7188, 1, 175, 218, 177);
INSERT INTO public.who_global_data VALUES (51486, 21, 12815, 0, 606, 218, 210);
INSERT INTO public.who_global_data VALUES (51487, 11, 4715, 0, 55, 218, 120);
INSERT INTO public.who_global_data VALUES (51488, 0, 18, 0, 0, 218, 135);
INSERT INTO public.who_global_data VALUES (51489, 810, 34197, 11, 765, 218, 206);
INSERT INTO public.who_global_data VALUES (51490, 3126, 59468, 112, 4639, 218, 189);
INSERT INTO public.who_global_data VALUES (51491, 1485, 71299, 86, 3120, 218, 129);
INSERT INTO public.who_global_data VALUES (51492, 264, 7000, 9, 191, 218, 121);
INSERT INTO public.who_global_data VALUES (51493, 0, 1043, 0, 12, 218, 59);
INSERT INTO public.who_global_data VALUES (51494, 12, 215, 0, 0, 218, 96);
INSERT INTO public.who_global_data VALUES (51495, 1, 1990, 0, 63, 218, 41);
INSERT INTO public.who_global_data VALUES (51496, 33, 873, 0, 11, 218, 216);
INSERT INTO public.who_global_data VALUES (51497, 115, 6163, 2, 109, 218, 236);
INSERT INTO public.who_global_data VALUES (51498, 0, 13, 0, 0, 218, 150);
INSERT INTO public.who_global_data VALUES (51499, 0, 187, 0, 0, 218, 61);
INSERT INTO public.who_global_data VALUES (51500, 0, 18, 0, 0, 218, 7);
INSERT INTO public.who_global_data VALUES (51501, 5, 7241, 0, 328, 218, 169);
INSERT INTO public.who_global_data VALUES (51502, 480, 158286, 14, 29791, 218, 28);
INSERT INTO public.who_global_data VALUES (51503, 176, 4444, 0, 16, 218, 85);
INSERT INTO public.who_global_data VALUES (51504, 0, 62, 0, 0, 218, 211);
INSERT INTO public.who_global_data VALUES (51505, 119, 5513, 0, 42, 218, 60);
INSERT INTO public.who_global_data VALUES (51506, 6, 55, 0, 2, 218, 3);
INSERT INTO public.who_global_data VALUES (51507, 4, 943, 0, 15, 218, 11);
INSERT INTO public.who_global_data VALUES (51508, 446, 195674, 9, 9003, 218, 89);
INSERT INTO public.who_global_data VALUES (51509, 0, 18134, 0, 117, 218, 24);
INSERT INTO public.who_global_data VALUES (51510, 1, 178, 0, 0, 218, 162);
INSERT INTO public.who_global_data VALUES (51511, 26, 3458, 0, 192, 218, 100);
INSERT INTO public.who_global_data VALUES (51512, 0, 13, 0, 0, 218, 47);
INSERT INTO public.who_global_data VALUES (51513, 0, 23, 0, 0, 218, 29);
INSERT INTO public.who_global_data VALUES (51514, 0, 182, 0, 14, 218, 40);
INSERT INTO public.who_global_data VALUES (51515, 0, 272, 0, 5, 218, 222);
INSERT INTO public.who_global_data VALUES (51516, 915, 19011, 44, 817, 218, 132);
INSERT INTO public.who_global_data VALUES (51517, 0, 252, 0, 13, 218, 130);
INSERT INTO public.who_global_data VALUES (51518, 46, 5450, 13, 46, 218, 234);
INSERT INTO public.who_global_data VALUES (51519, 0, 1710, 0, 24, 218, 23);
INSERT INTO public.who_global_data VALUES (51520, 3, 248, 0, 12, 218, 192);
INSERT INTO public.who_global_data VALUES (51521, 65, 6040, 2, 107, 218, 69);
INSERT INTO public.who_global_data VALUES (51522, 0, 12, 0, 0, 218, 187);
INSERT INTO public.who_global_data VALUES (51523, 704, 20262, 45, 542, 218, 230);
INSERT INTO public.who_global_data VALUES (51524, 9, 4166, 1, 587, 218, 77);
INSERT INTO public.who_global_data VALUES (51525, 5, 1830, 0, 10, 218, 9);
INSERT INTO public.who_global_data VALUES (51526, 20903, 625544, 379, 18213, 218, 74);
INSERT INTO public.who_global_data VALUES (51527, 1624, 59394, 53, 2987, 218, 224);
INSERT INTO public.who_global_data VALUES (51528, 2652, 232863, 148, 11106, 218, 199);
INSERT INTO public.who_global_data VALUES (51529, 2184, 53708, 110, 2160, 218, 190);
INSERT INTO public.who_global_data VALUES (51530, 12, 25489, 0, 1738, 218, 12);
INSERT INTO public.who_global_data VALUES (51531, 0, 336, 0, 24, 218, 104);
INSERT INTO public.who_global_data VALUES (51532, 972, 26418, 3, 330, 218, 153);
INSERT INTO public.who_global_data VALUES (51533, 201, 240961, 30, 34818, 218, 91);
INSERT INTO public.who_global_data VALUES (51534, 5, 707, 0, 10, 218, 215);
INSERT INTO public.who_global_data VALUES (51535, 194, 19068, 1, 976, 218, 84);
INSERT INTO public.who_global_data VALUES (51536, 0, 320, 0, 31, 218, 231);
INSERT INTO public.who_global_data VALUES (51537, 3, 1060, 0, 9, 218, 196);
INSERT INTO public.who_global_data VALUES (51538, 1644, 45719, 14, 224, 218, 105);
INSERT INTO public.who_global_data VALUES (51539, 268, 6941, 3, 152, 218, 122);
INSERT INTO public.who_global_data VALUES (51540, 0, 0, 0, 0, 218, 159);
INSERT INTO public.who_global_data VALUES (51541, 73, 3021, 1, 45, 218, 75);
INSERT INTO public.who_global_data VALUES (51542, 919, 47859, 1, 359, 218, 27);
INSERT INTO public.who_global_data VALUES (51543, 506, 6767, 10, 76, 218, 54);
INSERT INTO public.who_global_data VALUES (51544, 0, 19, 0, 0, 218, 226);
INSERT INTO public.who_global_data VALUES (51545, 1, 1122, 0, 30, 218, 79);
INSERT INTO public.who_global_data VALUES (51546, 8, 1796, 1, 35, 218, 56);
INSERT INTO public.who_global_data VALUES (51547, 0, 35, 0, 0, 218, 117);
INSERT INTO public.who_global_data VALUES (51548, 15, 819, 0, 37, 218, 152);
INSERT INTO public.who_global_data VALUES (51549, 17, 891, 1, 26, 218, 16);
INSERT INTO public.who_global_data VALUES (51550, 0, 84, 0, 1, 218, 10);
INSERT INTO public.who_global_data VALUES (51551, 3, 1823, 0, 79, 218, 201);
INSERT INTO public.who_global_data VALUES (51552, 50, 4395, 0, 110, 218, 174);
INSERT INTO public.who_global_data VALUES (51553, 100, 2403, 2, 24, 218, 119);
INSERT INTO public.who_global_data VALUES (51554, 60, 1402, 0, 16, 218, 168);
INSERT INTO public.who_global_data VALUES (51555, 3, 8643, 0, 121, 218, 99);
INSERT INTO public.who_global_data VALUES (51556, 18, 2400, 0, 8, 218, 171);
INSERT INTO public.who_global_data VALUES (51557, 79, 2260, 1, 117, 218, 87);
INSERT INTO public.who_global_data VALUES (51558, 1, 671, 0, 9, 218, 123);
INSERT INTO public.who_global_data VALUES (51559, 0, 0, 0, 0, 218, 151);
INSERT INTO public.who_global_data VALUES (51560, 0, 242, 0, 14, 218, 213);
INSERT INTO public.who_global_data VALUES (51561, 134, 4606, 0, 129, 218, 118);
INSERT INTO public.who_global_data VALUES (51562, 0, 341, 0, 10, 218, 134);
INSERT INTO public.who_global_data VALUES (51563, 0, 2643, 0, 35, 218, 65);
INSERT INTO public.who_global_data VALUES (51564, 5681, 231770, 741, 28510, 218, 102);
INSERT INTO public.who_global_data VALUES (51565, 0, 0, 0, 0, 218, 223);
INSERT INTO public.who_global_data VALUES (51566, 3, 76, 0, 1, 218, 4);
INSERT INTO public.who_global_data VALUES (51567, 0, 220, 0, 0, 218, 146);
INSERT INTO public.who_global_data VALUES (51568, 55, 708, 1, 14, 218, 31);
INSERT INTO public.who_global_data VALUES (51569, 0, 11, 0, 1, 218, 127);
INSERT INTO public.who_global_data VALUES (51570, 333, 12969, 1, 229, 218, 22);
INSERT INTO public.who_global_data VALUES (51571, 15, 918, 0, 6, 218, 115);
INSERT INTO public.who_global_data VALUES (51572, 0, 304, 0, 6, 218, 106);
INSERT INTO public.who_global_data VALUES (51573, 8, 293, 0, 0, 218, 90);
INSERT INTO public.who_global_data VALUES (51574, 0, 0, 0, 0, 218, 70);
INSERT INTO public.who_global_data VALUES (51575, 473, 14519, 1, 31, 218, 46);
INSERT INTO public.who_global_data VALUES (51576, 75, 50196, 3, 6092, 218, 139);
INSERT INTO public.who_global_data VALUES (51577, 0, 21, 0, 0, 218, 42);
INSERT INTO public.who_global_data VALUES (51578, 0, 1180, 0, 22, 218, 80);
INSERT INTO public.who_global_data VALUES (51579, 0, 2182, 0, 83, 218, 203);
INSERT INTO public.who_global_data VALUES (51580, 6, 1081, 1, 68, 218, 136);
INSERT INTO public.who_global_data VALUES (51581, 626, 27110, 13, 616, 218, 63);
INSERT INTO public.who_global_data VALUES (51582, 0, 0, 0, 0, 218, 17);
INSERT INTO public.who_global_data VALUES (51583, 1, 31, 0, 2, 218, 172);
INSERT INTO public.who_global_data VALUES (51584, 173, 6643, 15, 321, 218, 109);
INSERT INTO public.who_global_data VALUES (51585, 8, 8895, 0, 251, 218, 200);
INSERT INTO public.who_global_data VALUES (51586, 322, 3417, 0, 11, 218, 93);
INSERT INTO public.who_global_data VALUES (51587, 1361, 42555, 3, 188, 218, 5);
INSERT INTO public.who_global_data VALUES (51588, 0, 741, 0, 13, 218, 214);
INSERT INTO public.who_global_data VALUES (51589, 4087, 221896, 78, 4551, 218, 204);
INSERT INTO public.who_global_data VALUES (51590, 0, 0, 0, 0, 218, 198);
INSERT INTO public.who_global_data VALUES (51591, 913, 34463, 14, 645, 218, 173);
INSERT INTO public.who_global_data VALUES (51592, 0, 11, 0, 0, 218, 229);
INSERT INTO public.who_global_data VALUES (51593, 43, 2303, 0, 19, 218, 76);
INSERT INTO public.who_global_data VALUES (51594, 3264, 288477, 183, 9860, 218, 138);
INSERT INTO public.who_global_data VALUES (51595, 294, 38805, 4, 1274, 218, 98);
INSERT INTO public.who_global_data VALUES (51596, 0, 0, 0, 0, 218, 103);
INSERT INTO public.who_global_data VALUES (51597, 371, 35146, 15, 1492, 218, 225);
INSERT INTO public.who_global_data VALUES (51598, 328, 42782, 8, 1587, 218, 131);
INSERT INTO public.who_global_data VALUES (51599, 71, 7608, 0, 153, 218, 235);
INSERT INTO public.who_global_data VALUES (51600, 894, 97897, 3, 118, 218, 137);
INSERT INTO public.who_global_data VALUES (51601, 61, 12965, 0, 282, 218, 81);
INSERT INTO public.who_global_data VALUES (51602, 252, 17150, 14, 563, 218, 182);
INSERT INTO public.who_global_data VALUES (51603, 3, 531, 0, 2, 218, 145);
INSERT INTO public.who_global_data VALUES (51604, 450, 27746, 20, 1687, 218, 26);
INSERT INTO public.who_global_data VALUES (51605, 6718, 667883, 176, 9859, 218, 170);
INSERT INTO public.who_global_data VALUES (51606, 21, 1063, 0, 3, 218, 191);
INSERT INTO public.who_global_data VALUES (51607, 0, 3, 0, 0, 218, 221);
INSERT INTO public.who_global_data VALUES (51608, 0, 6, 0, 0, 218, 64);
INSERT INTO public.who_global_data VALUES (51609, 0, 0, 0, 0, 218, 116);
INSERT INTO public.who_global_data VALUES (51610, 0, 15, 0, 0, 218, 128);
INSERT INTO public.who_global_data VALUES (51611, 0, 19, 0, 0, 218, 6);
INSERT INTO public.who_global_data VALUES (51612, 0, 43, 0, 3, 218, 227);
INSERT INTO public.who_global_data VALUES (51613, 0, 1, 0, 0, 218, 68);
INSERT INTO public.who_global_data VALUES (51614, 0, 29, 0, 0, 218, 184);
INSERT INTO public.who_global_data VALUES (51615, 0, 0, 0, 0, 218, 82);
INSERT INTO public.who_global_data VALUES (51616, 0, 713, 0, 42, 218, 149);
INSERT INTO public.who_global_data VALUES (51617, 2, 397, 0, 11, 218, 197);
INSERT INTO public.who_global_data VALUES (51618, 3383, 197608, 54, 1752, 218, 78);
INSERT INTO public.who_global_data VALUES (51619, 129, 7054, 5, 121, 218, 233);
INSERT INTO public.who_global_data VALUES (51620, 359, 15195, 6, 287, 218, 133);
INSERT INTO public.who_global_data VALUES (51621, 0, 81, 0, 0, 218, 35);
INSERT INTO public.who_global_data VALUES (51622, 20, 1518, 0, 60, 218, 114);
INSERT INTO public.who_global_data VALUES (51623, 188, 44310, 0, 26, 218, 237);
INSERT INTO public.who_global_data VALUES (51624, 0, 2, 0, 0, 218, 55);
INSERT INTO public.who_global_data VALUES (51625, 0, 77, 0, 15, 218, 176);
INSERT INTO public.who_global_data VALUES (51626, 13, 1700, 0, 28, 218, 202);
INSERT INTO public.who_global_data VALUES (51627, 16, 1649, 0, 114, 218, 155);
INSERT INTO public.who_global_data VALUES (51628, 0, 0, 0, 0, 218, 32);
INSERT INTO public.who_global_data VALUES (51629, 20, 2944, 0, 90, 218, 220);
INSERT INTO public.who_global_data VALUES (51630, 8728, 168061, 95, 2844, 218, 30);
INSERT INTO public.who_global_data VALUES (51631, 29, 2036, 0, 38, 218, 147);
INSERT INTO public.who_global_data VALUES (51632, 497, 258859, 10, 29755, 218, 208);
INSERT INTO public.who_global_data VALUES (51633, 12, 2066, 0, 11, 218, 45);
INSERT INTO public.who_global_data VALUES (51634, 116, 9689, 5, 607, 218, 110);
INSERT INTO public.who_global_data VALUES (51635, 18, 535, 0, 13, 218, 88);
INSERT INTO public.who_global_data VALUES (51636, 685, 68549, 15, 5529, 218, 51);
INSERT INTO public.who_global_data VALUES (51637, 127, 32135, 0, 1724, 218, 209);
INSERT INTO public.who_global_data VALUES (51638, 19, 312, 0, 9, 218, 205);
INSERT INTO public.who_global_data VALUES (51639, 0, 6005, 0, 52, 218, 18);
INSERT INTO public.who_global_data VALUES (51640, 1, 3180, 0, 58, 218, 72);
INSERT INTO public.who_global_data VALUES (51641, 651, 285543, 41, 40532, 218, 44);
INSERT INTO public.who_global_data VALUES (51642, 0, 24, 0, 0, 218, 15);
INSERT INTO public.who_global_data VALUES (51643, 6, 667, 0, 14, 218, 25);
INSERT INTO public.who_global_data VALUES (51644, 0, 0, 0, 0, 218, 179);
INSERT INTO public.who_global_data VALUES (51645, 0, 0, 0, 0, 218, 34);
INSERT INTO public.who_global_data VALUES (51646, 0, 130, 0, 8, 218, 207);
INSERT INTO public.who_global_data VALUES (51647, 3, 1181, 0, 50, 218, 166);
INSERT INTO public.who_global_data VALUES (51648, 1186, 202284, 17, 5167, 218, 126);
INSERT INTO public.who_global_data VALUES (51649, 0, 0, 0, 0, 218, 97);
INSERT INTO public.who_global_data VALUES (51650, 0, 42, 0, 2, 218, 36);
INSERT INTO public.who_global_data VALUES (51651, 0, 0, 0, 0, 218, 125);
INSERT INTO public.who_global_data VALUES (51652, 9, 902, 0, 0, 218, 124);
INSERT INTO public.who_global_data VALUES (51653, 875, 46763, 27, 1212, 218, 185);
INSERT INTO public.who_global_data VALUES (51654, 400, 49469, 1, 317, 218, 194);
INSERT INTO public.who_global_data VALUES (51655, 0, 509, 0, 21, 218, 144);
INSERT INTO public.who_global_data VALUES (51656, 54271, 2671220, 725, 127858, 218, 19);
INSERT INTO public.who_global_data VALUES (51657, 2, 92, 0, 6, 218, 217);
INSERT INTO public.who_global_data VALUES (51658, 7, 943, 1, 28, 218, 148);
INSERT INTO public.who_global_data VALUES (51659, 295, 9199, 1, 27, 218, 86);
INSERT INTO public.who_global_data VALUES (51660, 0, 0, 0, 0, 218, 13);
INSERT INTO public.who_global_data VALUES (51661, 230, 6062, 3, 54, 218, 157);
INSERT INTO public.who_global_data VALUES (51662, 0, 355, 0, 0, 218, 8);
INSERT INTO public.who_global_data VALUES (51663, 0, 0, 0, 0, 218, 73);
INSERT INTO public.who_global_data VALUES (51664, 31, 1221, 7, 325, 218, 101);
INSERT INTO public.who_global_data VALUES (51665, 0, 1632, 0, 30, 218, 165);
INSERT INTO public.who_global_data VALUES (51666, 12, 617, 0, 7, 218, 14);
INSERT INTO public.who_global_data VALUES (51667, 260, 32108, 33, 811, 219, 193);
INSERT INTO public.who_global_data VALUES (51668, 82, 2662, 4, 69, 219, 113);
INSERT INTO public.who_global_data VALUES (51669, 365, 14272, 8, 920, 219, 143);
INSERT INTO public.who_global_data VALUES (51670, 0, 0, 0, 0, 219, 219);
INSERT INTO public.who_global_data VALUES (51671, 0, 855, 0, 52, 219, 186);
INSERT INTO public.who_global_data VALUES (51672, 7, 291, 2, 15, 219, 52);
INSERT INTO public.who_global_data VALUES (51673, 0, 3, 0, 0, 219, 180);
INSERT INTO public.who_global_data VALUES (51674, 0, 66, 0, 3, 219, 167);
INSERT INTO public.who_global_data VALUES (51675, 2262, 64530, 27, 1310, 219, 154);
INSERT INTO public.who_global_data VALUES (51676, 593, 25971, 6, 454, 219, 94);
INSERT INTO public.who_global_data VALUES (51677, 0, 103, 0, 3, 219, 66);
INSERT INTO public.who_global_data VALUES (51678, 86, 7920, 0, 104, 219, 58);
INSERT INTO public.who_global_data VALUES (51679, 37, 17814, 0, 705, 219, 163);
INSERT INTO public.who_global_data VALUES (51680, 588, 18112, 7, 220, 219, 37);
INSERT INTO public.who_global_data VALUES (51681, 0, 104, 0, 11, 219, 142);
INSERT INTO public.who_global_data VALUES (51682, 656, 27414, 5, 92, 219, 83);
INSERT INTO public.who_global_data VALUES (51683, 3775, 149258, 41, 1888, 219, 228);
INSERT INTO public.who_global_data VALUES (51684, 0, 97, 0, 7, 219, 188);
INSERT INTO public.who_global_data VALUES (51685, 306, 62424, 6, 398, 219, 62);
INSERT INTO public.who_global_data VALUES (51686, 135, 62219, 2, 9630, 219, 160);
INSERT INTO public.who_global_data VALUES (51687, 4, 28, 0, 2, 219, 50);
INSERT INTO public.who_global_data VALUES (51688, 0, 1199, 0, 21, 219, 33);
INSERT INTO public.who_global_data VALUES (51689, 0, 146, 0, 9, 219, 183);
INSERT INTO public.who_global_data VALUES (51690, 0, 77, 0, 0, 219, 92);
INSERT INTO public.who_global_data VALUES (51691, 1094, 33219, 52, 1123, 219, 158);
INSERT INTO public.who_global_data VALUES (51692, 0, 2, 0, 0, 219, 67);
INSERT INTO public.who_global_data VALUES (51693, 153, 4606, 2, 187, 219, 57);
INSERT INTO public.who_global_data VALUES (51694, 0, 227, 0, 1, 219, 38);
INSERT INTO public.who_global_data VALUES (51695, 33846, 1402041, 1280, 59594, 219, 141);
INSERT INTO public.who_global_data VALUES (51696, 0, 8, 0, 1, 219, 178);
INSERT INTO public.who_global_data VALUES (51697, 0, 141, 0, 3, 219, 108);
INSERT INTO public.who_global_data VALUES (51698, 165, 5154, 2, 232, 219, 39);
INSERT INTO public.who_global_data VALUES (51699, 0, 962, 0, 53, 219, 2);
INSERT INTO public.who_global_data VALUES (51700, 0, 170, 0, 1, 219, 195);
INSERT INTO public.who_global_data VALUES (51701, 40, 1267, 0, 15, 219, 107);
INSERT INTO public.who_global_data VALUES (51702, 0, 141, 0, 0, 219, 161);
INSERT INTO public.who_global_data VALUES (51703, 0, 12592, 0, 313, 219, 212);
INSERT INTO public.who_global_data VALUES (51704, 286, 104204, 25, 8591, 219, 181);
INSERT INTO public.who_global_data VALUES (51705, 1, 200, 0, 1, 219, 53);
INSERT INTO public.who_global_data VALUES (51706, 0, 3745, 0, 47, 219, 164);
INSERT INTO public.who_global_data VALUES (51707, 0, 866, 0, 74, 219, 140);
INSERT INTO public.who_global_data VALUES (51708, 2650, 282043, 65, 5753, 219, 20);
INSERT INTO public.who_global_data VALUES (51709, 31, 85263, 0, 4648, 219, 112);
INSERT INTO public.who_global_data VALUES (51710, 2803, 97846, 111, 3334, 219, 111);
INSERT INTO public.who_global_data VALUES (51711, 0, 303, 0, 7, 219, 71);
INSERT INTO public.who_global_data VALUES (51712, 114, 1443, 1, 42, 219, 218);
INSERT INTO public.who_global_data VALUES (51713, 0, 0, 0, 0, 219, 43);
INSERT INTO public.who_global_data VALUES (51714, 190, 3459, 1, 16, 219, 49);
INSERT INTO public.who_global_data VALUES (51715, 285, 9499, 2, 68, 219, 1);
INSERT INTO public.who_global_data VALUES (51716, 54, 2831, 1, 108, 219, 48);
INSERT INTO public.who_global_data VALUES (51717, 7, 2348, 0, 86, 219, 232);
INSERT INTO public.who_global_data VALUES (51718, 0, 25, 0, 1, 219, 175);
INSERT INTO public.who_global_data VALUES (51719, 1, 999, 0, 19, 219, 21);
INSERT INTO public.who_global_data VALUES (51720, 92, 12046, 0, 349, 219, 156);
INSERT INTO public.who_global_data VALUES (51721, 0, 0, 0, 0, 219, 95);
INSERT INTO public.who_global_data VALUES (51722, 83, 7121, 5, 174, 219, 177);
INSERT INTO public.who_global_data VALUES (51723, 26, 12794, 1, 606, 219, 210);
INSERT INTO public.who_global_data VALUES (51724, 22, 4704, 1, 55, 219, 120);
INSERT INTO public.who_global_data VALUES (51725, 0, 18, 0, 0, 219, 135);
INSERT INTO public.who_global_data VALUES (51726, 819, 33387, 7, 754, 219, 206);
INSERT INTO public.who_global_data VALUES (51727, 0, 56342, 0, 4527, 219, 189);
INSERT INTO public.who_global_data VALUES (51728, 1503, 69814, 81, 3034, 219, 129);
INSERT INTO public.who_global_data VALUES (51729, 298, 6736, 8, 182, 219, 121);
INSERT INTO public.who_global_data VALUES (51730, 0, 1043, 0, 12, 219, 59);
INSERT INTO public.who_global_data VALUES (51731, 0, 203, 0, 0, 219, 96);
INSERT INTO public.who_global_data VALUES (51732, 0, 1989, 0, 63, 219, 41);
INSERT INTO public.who_global_data VALUES (51733, 28, 840, 0, 11, 219, 216);
INSERT INTO public.who_global_data VALUES (51734, 202, 6048, 4, 107, 219, 236);
INSERT INTO public.who_global_data VALUES (51735, 0, 13, 0, 0, 219, 150);
INSERT INTO public.who_global_data VALUES (51736, 0, 187, 0, 0, 219, 61);
INSERT INTO public.who_global_data VALUES (51737, 0, 18, 0, 0, 219, 7);
INSERT INTO public.who_global_data VALUES (51738, 22, 7236, 0, 328, 219, 169);
INSERT INTO public.who_global_data VALUES (51739, 612, 157806, 17, 29777, 219, 28);
INSERT INTO public.who_global_data VALUES (51740, 264, 4268, 1, 16, 219, 85);
INSERT INTO public.who_global_data VALUES (51741, 0, 62, 0, 0, 219, 211);
INSERT INTO public.who_global_data VALUES (51742, 0, 5394, 0, 42, 219, 60);
INSERT INTO public.who_global_data VALUES (51743, 0, 49, 0, 2, 219, 3);
INSERT INTO public.who_global_data VALUES (51744, 8, 939, 0, 15, 219, 11);
INSERT INTO public.who_global_data VALUES (51745, 503, 195228, 9, 8994, 219, 89);
INSERT INTO public.who_global_data VALUES (51746, 393, 18134, 5, 117, 219, 24);
INSERT INTO public.who_global_data VALUES (51747, 0, 177, 0, 0, 219, 162);
INSERT INTO public.who_global_data VALUES (51748, 23, 3432, 0, 192, 219, 100);
INSERT INTO public.who_global_data VALUES (51749, 0, 13, 0, 0, 219, 47);
INSERT INTO public.who_global_data VALUES (51750, 0, 23, 0, 0, 219, 29);
INSERT INTO public.who_global_data VALUES (51751, 0, 182, 0, 14, 219, 40);
INSERT INTO public.who_global_data VALUES (51752, 21, 272, 0, 5, 219, 222);
INSERT INTO public.who_global_data VALUES (51753, 687, 18096, 27, 773, 219, 132);
INSERT INTO public.who_global_data VALUES (51754, 0, 252, 0, 13, 219, 130);
INSERT INTO public.who_global_data VALUES (51755, 13, 5404, 0, 33, 219, 234);
INSERT INTO public.who_global_data VALUES (51756, 56, 1710, 0, 24, 219, 23);
INSERT INTO public.who_global_data VALUES (51757, 10, 245, 0, 12, 219, 192);
INSERT INTO public.who_global_data VALUES (51758, 42, 5975, 0, 105, 219, 69);
INSERT INTO public.who_global_data VALUES (51759, 0, 12, 0, 0, 219, 187);
INSERT INTO public.who_global_data VALUES (51760, 740, 19558, 12, 497, 219, 230);
INSERT INTO public.who_global_data VALUES (51761, 2, 4157, 1, 586, 219, 77);
INSERT INTO public.who_global_data VALUES (51762, 1, 1825, 0, 10, 219, 9);
INSERT INTO public.who_global_data VALUES (51763, 19148, 604641, 434, 17834, 219, 74);
INSERT INTO public.who_global_data VALUES (51764, 1385, 57770, 58, 2934, 219, 224);
INSERT INTO public.who_global_data VALUES (51765, 2549, 230211, 141, 10958, 219, 199);
INSERT INTO public.who_global_data VALUES (51766, 2415, 51524, 107, 2050, 219, 190);
INSERT INTO public.who_global_data VALUES (51767, 4, 25477, 2, 1738, 219, 12);
INSERT INTO public.who_global_data VALUES (51768, 0, 336, 0, 24, 219, 104);
INSERT INTO public.who_global_data VALUES (51769, 786, 25446, 1, 327, 219, 153);
INSERT INTO public.who_global_data VALUES (51770, 182, 240760, 21, 34788, 219, 91);
INSERT INTO public.who_global_data VALUES (51771, 4, 702, 0, 10, 219, 215);
INSERT INTO public.who_global_data VALUES (51772, 151, 18874, 1, 975, 219, 84);
INSERT INTO public.who_global_data VALUES (51773, 0, 320, 0, 31, 219, 231);
INSERT INTO public.who_global_data VALUES (51774, 1, 1057, 0, 9, 219, 196);
INSERT INTO public.who_global_data VALUES (51775, 1501, 44075, 12, 210, 219, 105);
INSERT INTO public.who_global_data VALUES (51776, 307, 6673, 1, 149, 219, 122);
INSERT INTO public.who_global_data VALUES (51777, 0, 0, 0, 0, 219, 159);
INSERT INTO public.who_global_data VALUES (51778, 113, 2948, 3, 44, 219, 75);
INSERT INTO public.who_global_data VALUES (51779, 745, 46940, 4, 358, 219, 27);
INSERT INTO public.who_global_data VALUES (51780, 526, 6261, 4, 66, 219, 54);
INSERT INTO public.who_global_data VALUES (51781, 0, 19, 0, 0, 219, 226);
INSERT INTO public.who_global_data VALUES (51782, 3, 1121, 0, 30, 219, 79);
INSERT INTO public.who_global_data VALUES (51783, 10, 1788, 0, 34, 219, 56);
INSERT INTO public.who_global_data VALUES (51784, 8, 35, 0, 0, 219, 117);
INSERT INTO public.who_global_data VALUES (51785, 24, 804, 1, 37, 219, 152);
INSERT INTO public.who_global_data VALUES (51786, 50, 874, 1, 25, 219, 16);
INSERT INTO public.who_global_data VALUES (51787, 1, 84, 0, 1, 219, 10);
INSERT INTO public.who_global_data VALUES (51788, 7, 1820, 1, 79, 219, 201);
INSERT INTO public.who_global_data VALUES (51789, 46, 4345, 0, 110, 219, 174);
INSERT INTO public.who_global_data VALUES (51790, 89, 2303, 2, 22, 219, 119);
INSERT INTO public.who_global_data VALUES (51791, 77, 1342, 0, 16, 219, 168);
INSERT INTO public.who_global_data VALUES (51792, 1, 8640, 0, 121, 219, 99);
INSERT INTO public.who_global_data VALUES (51793, 21, 2382, 0, 8, 219, 171);
INSERT INTO public.who_global_data VALUES (51794, 0, 2181, 0, 116, 219, 87);
INSERT INTO public.who_global_data VALUES (51795, 0, 670, 0, 9, 219, 123);
INSERT INTO public.who_global_data VALUES (51796, 0, 0, 0, 0, 219, 151);
INSERT INTO public.who_global_data VALUES (51797, 0, 242, 0, 14, 219, 213);
INSERT INTO public.who_global_data VALUES (51798, 235, 4472, 1, 129, 219, 118);
INSERT INTO public.who_global_data VALUES (51799, 0, 341, 0, 10, 219, 134);
INSERT INTO public.who_global_data VALUES (51800, 40, 2643, 0, 35, 219, 65);
INSERT INTO public.who_global_data VALUES (51801, 5432, 226089, 648, 27769, 219, 102);
INSERT INTO public.who_global_data VALUES (51802, 0, 0, 0, 0, 219, 223);
INSERT INTO public.who_global_data VALUES (51803, 0, 73, 0, 1, 219, 4);
INSERT INTO public.who_global_data VALUES (51804, 0, 220, 0, 0, 219, 146);
INSERT INTO public.who_global_data VALUES (51805, 43, 653, 0, 13, 219, 31);
INSERT INTO public.who_global_data VALUES (51806, 0, 11, 0, 1, 219, 127);
INSERT INTO public.who_global_data VALUES (51807, 103, 12636, 0, 228, 219, 22);
INSERT INTO public.who_global_data VALUES (51808, 14, 903, 0, 6, 219, 115);
INSERT INTO public.who_global_data VALUES (51809, 5, 304, 0, 6, 219, 106);
INSERT INTO public.who_global_data VALUES (51810, 82, 285, 0, 0, 219, 90);
INSERT INTO public.who_global_data VALUES (51811, 0, 0, 0, 0, 219, 70);
INSERT INTO public.who_global_data VALUES (51812, 482, 14046, 1, 30, 219, 46);
INSERT INTO public.who_global_data VALUES (51813, 62, 50121, 3, 6089, 219, 139);
INSERT INTO public.who_global_data VALUES (51814, 0, 21, 0, 0, 219, 42);
INSERT INTO public.who_global_data VALUES (51815, 2, 1180, 0, 22, 219, 80);
INSERT INTO public.who_global_data VALUES (51816, 168, 2182, 9, 83, 219, 203);
INSERT INTO public.who_global_data VALUES (51817, 0, 1075, 0, 67, 219, 136);
INSERT INTO public.who_global_data VALUES (51818, 790, 26484, 13, 603, 219, 63);
INSERT INTO public.who_global_data VALUES (51819, 0, 0, 0, 0, 219, 17);
INSERT INTO public.who_global_data VALUES (51820, 0, 30, 0, 2, 219, 172);
INSERT INTO public.who_global_data VALUES (51821, 120, 6470, 4, 306, 219, 109);
INSERT INTO public.who_global_data VALUES (51822, 22, 8887, 1, 251, 219, 200);
INSERT INTO public.who_global_data VALUES (51823, 330, 3095, 0, 11, 219, 93);
INSERT INTO public.who_global_data VALUES (51824, 1124, 41194, 9, 185, 219, 5);
INSERT INTO public.who_global_data VALUES (51825, 0, 741, 0, 13, 219, 214);
INSERT INTO public.who_global_data VALUES (51826, 4339, 217809, 78, 4473, 219, 204);
INSERT INTO public.who_global_data VALUES (51827, 0, 0, 0, 0, 219, 198);
INSERT INTO public.who_global_data VALUES (51828, 765, 33550, 11, 631, 219, 173);
INSERT INTO public.who_global_data VALUES (51829, 0, 11, 0, 0, 219, 229);
INSERT INTO public.who_global_data VALUES (51830, 39, 2260, 2, 19, 219, 76);
INSERT INTO public.who_global_data VALUES (51831, 2848, 285213, 173, 9677, 219, 138);
INSERT INTO public.who_global_data VALUES (51832, 997, 38511, 4, 1270, 219, 98);
INSERT INTO public.who_global_data VALUES (51833, 0, 0, 0, 0, 219, 103);
INSERT INTO public.who_global_data VALUES (51834, 382, 34775, 14, 1477, 219, 225);
INSERT INTO public.who_global_data VALUES (51835, 313, 42454, 3, 1579, 219, 131);
INSERT INTO public.who_global_data VALUES (51836, 72, 7537, 0, 153, 219, 235);
INSERT INTO public.who_global_data VALUES (51837, 915, 97003, 2, 115, 219, 137);
INSERT INTO public.who_global_data VALUES (51838, 54, 12904, 0, 282, 219, 81);
INSERT INTO public.who_global_data VALUES (51839, 285, 16898, 2, 549, 219, 182);
INSERT INTO public.who_global_data VALUES (51840, 2, 528, 0, 2, 219, 145);
INSERT INTO public.who_global_data VALUES (51841, 326, 27296, 16, 1667, 219, 26);
INSERT INTO public.who_global_data VALUES (51842, 6760, 661165, 147, 9683, 219, 170);
INSERT INTO public.who_global_data VALUES (51843, 17, 1042, 1, 3, 219, 191);
INSERT INTO public.who_global_data VALUES (51844, 0, 3, 0, 0, 219, 221);
INSERT INTO public.who_global_data VALUES (51845, 0, 6, 0, 0, 219, 64);
INSERT INTO public.who_global_data VALUES (51846, 0, 0, 0, 0, 219, 116);
INSERT INTO public.who_global_data VALUES (51847, 0, 15, 0, 0, 219, 128);
INSERT INTO public.who_global_data VALUES (51848, 0, 19, 0, 0, 219, 6);
INSERT INTO public.who_global_data VALUES (51849, 0, 43, 0, 3, 219, 227);
INSERT INTO public.who_global_data VALUES (51850, 0, 1, 0, 0, 219, 68);
INSERT INTO public.who_global_data VALUES (51851, 0, 29, 0, 0, 219, 184);
INSERT INTO public.who_global_data VALUES (51852, 0, 0, 0, 0, 219, 82);
INSERT INTO public.who_global_data VALUES (51853, 0, 713, 0, 42, 219, 149);
INSERT INTO public.who_global_data VALUES (51854, 1, 395, 0, 11, 219, 197);
INSERT INTO public.who_global_data VALUES (51855, 3402, 194225, 49, 1698, 219, 78);
INSERT INTO public.who_global_data VALUES (51856, 132, 6925, 4, 116, 219, 233);
INSERT INTO public.who_global_data VALUES (51857, 272, 14836, 4, 281, 219, 133);
INSERT INTO public.who_global_data VALUES (51858, 0, 81, 0, 0, 219, 35);
INSERT INTO public.who_global_data VALUES (51859, 36, 1498, 0, 60, 219, 114);
INSERT INTO public.who_global_data VALUES (51860, 215, 44122, 0, 26, 219, 237);
INSERT INTO public.who_global_data VALUES (51861, 0, 2, 0, 0, 219, 55);
INSERT INTO public.who_global_data VALUES (51862, 0, 77, 0, 15, 219, 176);
INSERT INTO public.who_global_data VALUES (51863, 20, 1687, 0, 28, 219, 202);
INSERT INTO public.who_global_data VALUES (51864, 21, 1633, 0, 114, 219, 155);
INSERT INTO public.who_global_data VALUES (51865, 0, 0, 0, 0, 219, 32);
INSERT INTO public.who_global_data VALUES (51866, 0, 2924, 0, 90, 219, 220);
INSERT INTO public.who_global_data VALUES (51867, 8124, 159333, 92, 2749, 219, 30);
INSERT INTO public.who_global_data VALUES (51868, 0, 2007, 0, 38, 219, 147);
INSERT INTO public.who_global_data VALUES (51869, 474, 258362, 10, 29745, 219, 208);
INSERT INTO public.who_global_data VALUES (51870, 7, 2054, 0, 11, 219, 45);
INSERT INTO public.who_global_data VALUES (51871, 73, 9573, 10, 602, 219, 110);
INSERT INTO public.who_global_data VALUES (51872, 2, 517, 0, 13, 219, 88);
INSERT INTO public.who_global_data VALUES (51873, 804, 67864, 20, 5514, 219, 51);
INSERT INTO public.who_global_data VALUES (51874, 101, 32008, 1, 1724, 219, 209);
INSERT INTO public.who_global_data VALUES (51875, 14, 293, 0, 9, 219, 205);
INSERT INTO public.who_global_data VALUES (51876, 51, 6005, 0, 52, 219, 18);
INSERT INTO public.who_global_data VALUES (51877, 6, 3179, 0, 58, 219, 72);
INSERT INTO public.who_global_data VALUES (51878, 617, 284892, 97, 40491, 219, 44);
INSERT INTO public.who_global_data VALUES (51879, 0, 24, 0, 0, 219, 15);
INSERT INTO public.who_global_data VALUES (51880, 18, 661, 0, 14, 219, 25);
INSERT INTO public.who_global_data VALUES (51881, 0, 0, 0, 0, 219, 179);
INSERT INTO public.who_global_data VALUES (51882, 0, 0, 0, 0, 219, 34);
INSERT INTO public.who_global_data VALUES (51883, 0, 130, 0, 8, 219, 207);
INSERT INTO public.who_global_data VALUES (51884, 3, 1178, 0, 50, 219, 166);
INSERT INTO public.who_global_data VALUES (51885, 1192, 201098, 19, 5150, 219, 126);
INSERT INTO public.who_global_data VALUES (51886, 0, 0, 0, 0, 219, 97);
INSERT INTO public.who_global_data VALUES (51887, 1, 42, 0, 2, 219, 36);
INSERT INTO public.who_global_data VALUES (51888, 0, 0, 0, 0, 219, 125);
INSERT INTO public.who_global_data VALUES (51889, 4, 893, 0, 0, 219, 124);
INSERT INTO public.who_global_data VALUES (51890, 890, 45888, 12, 1185, 219, 185);
INSERT INTO public.who_global_data VALUES (51891, 402, 49069, 1, 316, 219, 194);
INSERT INTO public.who_global_data VALUES (51892, 0, 509, 0, 21, 219, 144);
INSERT INTO public.who_global_data VALUES (51893, 43556, 2616949, 560, 127133, 219, 19);
INSERT INTO public.who_global_data VALUES (51894, 6, 90, 0, 6, 219, 217);
INSERT INTO public.who_global_data VALUES (51895, 4, 936, 0, 27, 219, 148);
INSERT INTO public.who_global_data VALUES (51896, 277, 8904, 0, 26, 219, 86);
INSERT INTO public.who_global_data VALUES (51897, 0, 0, 0, 0, 219, 13);
INSERT INTO public.who_global_data VALUES (51898, 302, 5832, 3, 51, 219, 157);
INSERT INTO public.who_global_data VALUES (51899, 0, 355, 0, 0, 219, 8);
INSERT INTO public.who_global_data VALUES (51900, 0, 0, 0, 0, 219, 73);
INSERT INTO public.who_global_data VALUES (51901, 32, 1190, 6, 318, 219, 101);
INSERT INTO public.who_global_data VALUES (51902, 38, 1632, 6, 30, 219, 165);
INSERT INTO public.who_global_data VALUES (51903, 14, 605, 0, 7, 219, 14);
INSERT INTO public.who_global_data VALUES (51904, 403, 31848, 39, 778, 220, 193);
INSERT INTO public.who_global_data VALUES (51905, 45, 2580, 3, 65, 220, 113);
INSERT INTO public.who_global_data VALUES (51906, 336, 13907, 7, 912, 220, 143);
INSERT INTO public.who_global_data VALUES (51907, 0, 0, 0, 0, 220, 219);
INSERT INTO public.who_global_data VALUES (51908, 0, 855, 0, 52, 220, 186);
INSERT INTO public.who_global_data VALUES (51909, 8, 284, 2, 13, 220, 52);
INSERT INTO public.who_global_data VALUES (51910, 0, 3, 0, 0, 220, 180);
INSERT INTO public.who_global_data VALUES (51911, 1, 66, 0, 3, 220, 167);
INSERT INTO public.who_global_data VALUES (51912, 2335, 62268, 38, 1283, 220, 154);
INSERT INTO public.who_global_data VALUES (51913, 523, 25378, 10, 448, 220, 94);
INSERT INTO public.who_global_data VALUES (51914, 2, 103, 0, 3, 220, 66);
INSERT INTO public.who_global_data VALUES (51915, 67, 7834, 0, 104, 220, 58);
INSERT INTO public.who_global_data VALUES (51916, 111, 17777, 2, 705, 220, 163);
INSERT INTO public.who_global_data VALUES (51917, 556, 17524, 7, 213, 220, 37);
INSERT INTO public.who_global_data VALUES (51918, 0, 104, 0, 11, 220, 142);
INSERT INTO public.who_global_data VALUES (51919, 519, 26758, 3, 87, 220, 83);
INSERT INTO public.who_global_data VALUES (51920, 3682, 145483, 64, 1847, 220, 228);
INSERT INTO public.who_global_data VALUES (51921, 0, 97, 0, 7, 220, 188);
INSERT INTO public.who_global_data VALUES (51922, 328, 62118, 5, 392, 220, 62);
INSERT INTO public.who_global_data VALUES (51923, 100, 62084, 8, 9628, 220, 160);
INSERT INTO public.who_global_data VALUES (51924, 0, 24, 0, 2, 220, 50);
INSERT INTO public.who_global_data VALUES (51925, 12, 1199, 2, 21, 220, 33);
INSERT INTO public.who_global_data VALUES (51926, 0, 146, 0, 9, 220, 183);
INSERT INTO public.who_global_data VALUES (51927, 0, 77, 0, 0, 220, 92);
INSERT INTO public.who_global_data VALUES (51928, 601, 32125, 57, 1071, 220, 158);
INSERT INTO public.who_global_data VALUES (51929, 0, 2, 0, 0, 220, 67);
INSERT INTO public.who_global_data VALUES (51930, 110, 4453, 2, 185, 220, 57);
INSERT INTO public.who_global_data VALUES (51931, 52, 227, 0, 1, 220, 38);
INSERT INTO public.who_global_data VALUES (51932, 24052, 1368195, 692, 58314, 220, 141);
INSERT INTO public.who_global_data VALUES (51933, 0, 8, 0, 1, 220, 178);
INSERT INTO public.who_global_data VALUES (51934, 0, 141, 0, 3, 220, 108);
INSERT INTO public.who_global_data VALUES (51935, 158, 4989, 7, 230, 220, 39);
INSERT INTO public.who_global_data VALUES (51936, 3, 962, 0, 53, 220, 2);
INSERT INTO public.who_global_data VALUES (51937, 0, 170, 0, 1, 220, 195);
INSERT INTO public.who_global_data VALUES (51938, 62, 1227, 3, 15, 220, 107);
INSERT INTO public.who_global_data VALUES (51939, 0, 141, 0, 0, 220, 161);
INSERT INTO public.who_global_data VALUES (51940, 0, 12592, 0, 313, 220, 212);
INSERT INTO public.who_global_data VALUES (51941, 668, 103918, 44, 8566, 220, 181);
INSERT INTO public.who_global_data VALUES (51942, 3, 199, 0, 1, 220, 53);
INSERT INTO public.who_global_data VALUES (51943, 132, 3745, 0, 47, 220, 164);
INSERT INTO public.who_global_data VALUES (51944, 0, 866, 0, 74, 220, 140);
INSERT INTO public.who_global_data VALUES (51945, 3394, 279393, 113, 5688, 220, 20);
INSERT INTO public.who_global_data VALUES (51946, 5, 85232, 0, 4648, 220, 112);
INSERT INTO public.who_global_data VALUES (51947, 3274, 95043, 117, 3223, 220, 111);
INSERT INTO public.who_global_data VALUES (51948, 10, 303, 0, 7, 220, 71);
INSERT INTO public.who_global_data VALUES (51949, 84, 1329, 1, 41, 220, 218);
INSERT INTO public.who_global_data VALUES (51950, 0, 0, 0, 0, 220, 43);
INSERT INTO public.who_global_data VALUES (51951, 139, 3269, 0, 15, 220, 49);
INSERT INTO public.who_global_data VALUES (51952, 113, 9214, 0, 66, 220, 1);
INSERT INTO public.who_global_data VALUES (51953, 52, 2777, 0, 107, 220, 48);
INSERT INTO public.who_global_data VALUES (51954, 1, 2341, 0, 86, 220, 232);
INSERT INTO public.who_global_data VALUES (51955, 1, 25, 0, 1, 220, 175);
INSERT INTO public.who_global_data VALUES (51956, 2, 998, 0, 19, 220, 21);
INSERT INTO public.who_global_data VALUES (51957, 149, 11954, 1, 349, 220, 156);
INSERT INTO public.who_global_data VALUES (51958, 0, 0, 0, 0, 220, 95);
INSERT INTO public.who_global_data VALUES (51959, 100, 7038, 3, 169, 220, 177);
INSERT INTO public.who_global_data VALUES (51960, 17, 12768, 0, 605, 220, 210);
INSERT INTO public.who_global_data VALUES (51961, 26, 4682, 1, 54, 220, 120);
INSERT INTO public.who_global_data VALUES (51962, 0, 18, 0, 0, 220, 135);
INSERT INTO public.who_global_data VALUES (51963, 752, 32568, 14, 747, 220, 206);
INSERT INTO public.who_global_data VALUES (51964, 677, 56342, 25, 4527, 220, 189);
INSERT INTO public.who_global_data VALUES (51965, 1557, 68311, 81, 2953, 220, 129);
INSERT INTO public.who_global_data VALUES (51966, 265, 6438, 10, 174, 220, 121);
INSERT INTO public.who_global_data VALUES (51967, 0, 1043, 0, 12, 220, 59);
INSERT INTO public.who_global_data VALUES (51968, 12, 203, 0, 0, 220, 96);
INSERT INTO public.who_global_data VALUES (51969, 2, 1989, 0, 63, 220, 41);
INSERT INTO public.who_global_data VALUES (51970, 17, 812, 0, 11, 220, 216);
INSERT INTO public.who_global_data VALUES (51971, 0, 5846, 0, 103, 220, 236);
INSERT INTO public.who_global_data VALUES (51972, 0, 13, 0, 0, 220, 150);
INSERT INTO public.who_global_data VALUES (51973, 0, 187, 0, 0, 220, 61);
INSERT INTO public.who_global_data VALUES (51974, 0, 18, 0, 0, 220, 7);
INSERT INTO public.who_global_data VALUES (51975, 5, 7214, 0, 328, 220, 169);
INSERT INTO public.who_global_data VALUES (51976, 307, 157194, 30, 29760, 220, 28);
INSERT INTO public.who_global_data VALUES (51977, 230, 4004, 0, 15, 220, 85);
INSERT INTO public.who_global_data VALUES (51978, 0, 62, 0, 0, 220, 211);
INSERT INTO public.who_global_data VALUES (51979, 0, 5394, 0, 42, 220, 60);
INSERT INTO public.who_global_data VALUES (51980, 2, 49, 0, 2, 220, 3);
INSERT INTO public.who_global_data VALUES (51981, 3, 931, 0, 15, 220, 11);
INSERT INTO public.who_global_data VALUES (51982, 466, 194725, 12, 8985, 220, 89);
INSERT INTO public.who_global_data VALUES (51983, 390, 17741, 0, 112, 220, 24);
INSERT INTO public.who_global_data VALUES (51984, 0, 177, 0, 0, 220, 162);
INSERT INTO public.who_global_data VALUES (51985, 19, 3409, 1, 192, 220, 100);
INSERT INTO public.who_global_data VALUES (51986, 0, 13, 0, 0, 220, 47);
INSERT INTO public.who_global_data VALUES (51987, 0, 23, 0, 0, 220, 29);
INSERT INTO public.who_global_data VALUES (51988, 0, 182, 0, 14, 220, 40);
INSERT INTO public.who_global_data VALUES (51989, 4, 251, 0, 5, 220, 222);
INSERT INTO public.who_global_data VALUES (51990, 479, 17409, 19, 746, 220, 132);
INSERT INTO public.who_global_data VALUES (51991, 0, 252, 0, 13, 220, 130);
INSERT INTO public.who_global_data VALUES (51992, 40, 5391, 2, 33, 220, 234);
INSERT INTO public.who_global_data VALUES (51993, 0, 1654, 0, 24, 220, 23);
INSERT INTO public.who_global_data VALUES (51994, 5, 235, 0, 12, 220, 192);
INSERT INTO public.who_global_data VALUES (51995, 86, 5933, 1, 105, 220, 69);
INSERT INTO public.who_global_data VALUES (51996, 0, 12, 0, 0, 220, 187);
INSERT INTO public.who_global_data VALUES (51997, 736, 18818, 6, 485, 220, 230);
INSERT INTO public.who_global_data VALUES (51998, 10, 4155, 0, 585, 220, 77);
INSERT INTO public.who_global_data VALUES (51999, 2, 1824, 0, 10, 220, 9);
INSERT INTO public.who_global_data VALUES (52000, 18653, 585493, 507, 17400, 220, 74);
INSERT INTO public.who_global_data VALUES (52001, 1293, 56385, 71, 2876, 220, 224);
INSERT INTO public.who_global_data VALUES (52002, 2457, 227662, 147, 10817, 220, 199);
INSERT INTO public.who_global_data VALUES (52003, 1958, 49109, 104, 1943, 220, 190);
INSERT INTO public.who_global_data VALUES (52004, 11, 25473, 1, 1736, 220, 12);
INSERT INTO public.who_global_data VALUES (52005, 0, 336, 0, 24, 220, 104);
INSERT INTO public.who_global_data VALUES (52006, 757, 24660, 0, 326, 220, 153);
INSERT INTO public.who_global_data VALUES (52007, 142, 240578, 23, 34767, 220, 91);
INSERT INTO public.who_global_data VALUES (52008, 2, 698, 0, 10, 220, 215);
INSERT INTO public.who_global_data VALUES (52009, 130, 18723, 2, 974, 220, 84);
INSERT INTO public.who_global_data VALUES (52010, 0, 320, 0, 31, 220, 231);
INSERT INTO public.who_global_data VALUES (52011, 4, 1056, 0, 9, 220, 196);
INSERT INTO public.who_global_data VALUES (52012, 1509, 42574, 10, 198, 220, 105);
INSERT INTO public.who_global_data VALUES (52013, 176, 6366, 4, 148, 220, 122);
INSERT INTO public.who_global_data VALUES (52014, 0, 0, 0, 0, 220, 159);
INSERT INTO public.who_global_data VALUES (52015, 79, 2835, 2, 41, 220, 75);
INSERT INTO public.who_global_data VALUES (52016, 671, 46195, 4, 354, 220, 27);
INSERT INTO public.who_global_data VALUES (52017, 439, 5735, 5, 62, 220, 54);
INSERT INTO public.who_global_data VALUES (52018, 0, 19, 0, 0, 220, 226);
INSERT INTO public.who_global_data VALUES (52019, 1, 1118, 0, 30, 220, 79);
INSERT INTO public.who_global_data VALUES (52020, 33, 1778, 0, 34, 220, 56);
INSERT INTO public.who_global_data VALUES (52021, 0, 27, 0, 0, 220, 117);
INSERT INTO public.who_global_data VALUES (52022, 10, 780, 0, 36, 220, 152);
INSERT INTO public.who_global_data VALUES (52023, 22, 824, 1, 24, 220, 16);
INSERT INTO public.who_global_data VALUES (52024, 0, 83, 0, 1, 220, 10);
INSERT INTO public.who_global_data VALUES (52025, 1, 1813, 0, 78, 220, 201);
INSERT INTO public.who_global_data VALUES (52026, 43, 4299, 0, 110, 220, 174);
INSERT INTO public.who_global_data VALUES (52027, 76, 2214, 0, 20, 220, 119);
INSERT INTO public.who_global_data VALUES (52028, 41, 1265, 2, 16, 220, 168);
INSERT INTO public.who_global_data VALUES (52029, 2, 8639, 0, 121, 220, 99);
INSERT INTO public.who_global_data VALUES (52030, 24, 2361, 0, 8, 220, 171);
INSERT INTO public.who_global_data VALUES (52031, 8, 2181, 1, 116, 220, 87);
INSERT INTO public.who_global_data VALUES (52032, 1, 670, 0, 9, 220, 123);
INSERT INTO public.who_global_data VALUES (52033, 0, 0, 0, 0, 220, 151);
INSERT INTO public.who_global_data VALUES (52034, 0, 242, 0, 14, 220, 213);
INSERT INTO public.who_global_data VALUES (52035, 88, 4237, 2, 128, 220, 118);
INSERT INTO public.who_global_data VALUES (52036, 0, 341, 0, 10, 220, 134);
INSERT INTO public.who_global_data VALUES (52037, 0, 2603, 0, 35, 220, 65);
INSERT INTO public.who_global_data VALUES (52038, 3805, 220657, 473, 27121, 220, 102);
INSERT INTO public.who_global_data VALUES (52039, 0, 0, 0, 0, 220, 223);
INSERT INTO public.who_global_data VALUES (52040, 0, 73, 0, 1, 220, 4);
INSERT INTO public.who_global_data VALUES (52041, 0, 220, 0, 0, 220, 146);
INSERT INTO public.who_global_data VALUES (52042, 56, 610, 0, 13, 220, 31);
INSERT INTO public.who_global_data VALUES (52043, 0, 11, 0, 1, 220, 127);
INSERT INTO public.who_global_data VALUES (52044, 243, 12533, 3, 228, 220, 22);
INSERT INTO public.who_global_data VALUES (52045, 6, 889, 1, 6, 220, 115);
INSERT INTO public.who_global_data VALUES (52046, 0, 299, 0, 6, 220, 106);
INSERT INTO public.who_global_data VALUES (52047, 20, 203, 0, 0, 220, 90);
INSERT INTO public.who_global_data VALUES (52048, 0, 0, 0, 0, 220, 70);
INSERT INTO public.who_global_data VALUES (52049, 316, 13564, 0, 29, 220, 46);
INSERT INTO public.who_global_data VALUES (52050, 57, 50059, 5, 6086, 220, 139);
INSERT INTO public.who_global_data VALUES (52051, 0, 21, 0, 0, 220, 42);
INSERT INTO public.who_global_data VALUES (52052, 0, 1178, 0, 22, 220, 80);
INSERT INTO public.who_global_data VALUES (52053, 0, 2014, 0, 74, 220, 203);
INSERT INTO public.who_global_data VALUES (52054, 0, 1075, 0, 67, 220, 136);
INSERT INTO public.who_global_data VALUES (52055, 561, 25694, 17, 590, 220, 63);
INSERT INTO public.who_global_data VALUES (52056, 0, 0, 0, 0, 220, 17);
INSERT INTO public.who_global_data VALUES (52057, 0, 30, 0, 2, 220, 172);
INSERT INTO public.who_global_data VALUES (52058, 126, 6350, 4, 302, 220, 109);
INSERT INTO public.who_global_data VALUES (52059, 10, 8865, 1, 250, 220, 200);
INSERT INTO public.who_global_data VALUES (52060, 322, 2765, 3, 11, 220, 93);
INSERT INTO public.who_global_data VALUES (52061, 1010, 40070, 7, 176, 220, 5);
INSERT INTO public.who_global_data VALUES (52062, 0, 741, 0, 13, 220, 214);
INSERT INTO public.who_global_data VALUES (52063, 4133, 213470, 91, 4395, 220, 204);
INSERT INTO public.who_global_data VALUES (52064, 0, 0, 0, 0, 220, 198);
INSERT INTO public.who_global_data VALUES (52065, 1099, 32785, 16, 620, 220, 173);
INSERT INTO public.who_global_data VALUES (52066, 0, 11, 0, 0, 220, 229);
INSERT INTO public.who_global_data VALUES (52067, 94, 2221, 2, 17, 220, 76);
INSERT INTO public.who_global_data VALUES (52068, 2946, 282365, 187, 9504, 220, 138);
INSERT INTO public.who_global_data VALUES (52069, 1076, 37514, 11, 1266, 220, 98);
INSERT INTO public.who_global_data VALUES (52070, 0, 0, 0, 0, 220, 103);
INSERT INTO public.who_global_data VALUES (52071, 239, 34393, 19, 1463, 220, 225);
INSERT INTO public.who_global_data VALUES (52072, 229, 42141, 8, 1576, 220, 131);
INSERT INTO public.who_global_data VALUES (52073, 215, 7465, 0, 153, 220, 235);
INSERT INTO public.who_global_data VALUES (52074, 982, 96088, 0, 113, 220, 137);
INSERT INTO public.who_global_data VALUES (52075, 51, 12850, 0, 282, 220, 81);
INSERT INTO public.who_global_data VALUES (52076, 256, 16613, 6, 547, 220, 182);
INSERT INTO public.who_global_data VALUES (52077, 4, 526, 0, 2, 220, 145);
INSERT INTO public.who_global_data VALUES (52078, 388, 26970, 17, 1651, 220, 26);
INSERT INTO public.who_global_data VALUES (52079, 6556, 654405, 216, 9536, 220, 170);
INSERT INTO public.who_global_data VALUES (52080, 24, 1025, 0, 2, 220, 191);
INSERT INTO public.who_global_data VALUES (52081, 0, 3, 0, 0, 220, 221);
INSERT INTO public.who_global_data VALUES (52082, 0, 6, 0, 0, 220, 64);
INSERT INTO public.who_global_data VALUES (52083, 0, 0, 0, 0, 220, 116);
INSERT INTO public.who_global_data VALUES (52084, 0, 15, 0, 0, 220, 128);
INSERT INTO public.who_global_data VALUES (52085, 0, 19, 0, 0, 220, 6);
INSERT INTO public.who_global_data VALUES (52086, 0, 43, 0, 3, 220, 227);
INSERT INTO public.who_global_data VALUES (52087, 0, 1, 0, 0, 220, 68);
INSERT INTO public.who_global_data VALUES (52088, 0, 29, 0, 0, 220, 184);
INSERT INTO public.who_global_data VALUES (52089, 0, 0, 0, 0, 220, 82);
INSERT INTO public.who_global_data VALUES (52090, 0, 713, 0, 42, 220, 149);
INSERT INTO public.who_global_data VALUES (52091, 1, 394, 0, 11, 220, 197);
INSERT INTO public.who_global_data VALUES (52092, 4387, 190823, 50, 1649, 220, 78);
INSERT INTO public.who_global_data VALUES (52093, 95, 6793, 4, 112, 220, 233);
INSERT INTO public.who_global_data VALUES (52094, 276, 14564, 3, 277, 220, 133);
INSERT INTO public.who_global_data VALUES (52095, 0, 81, 0, 0, 220, 35);
INSERT INTO public.who_global_data VALUES (52096, 12, 1462, 0, 60, 220, 114);
INSERT INTO public.who_global_data VALUES (52097, 246, 43907, 0, 26, 220, 237);
INSERT INTO public.who_global_data VALUES (52098, 0, 2, 0, 0, 220, 55);
INSERT INTO public.who_global_data VALUES (52099, 0, 77, 0, 15, 220, 176);
INSERT INTO public.who_global_data VALUES (52100, 2, 1667, 0, 28, 220, 202);
INSERT INTO public.who_global_data VALUES (52101, 13, 1612, 0, 114, 220, 155);
INSERT INTO public.who_global_data VALUES (52102, 0, 0, 0, 0, 220, 32);
INSERT INTO public.who_global_data VALUES (52103, 20, 2924, 0, 90, 220, 220);
INSERT INTO public.who_global_data VALUES (52104, 6945, 151209, 128, 2657, 220, 30);
INSERT INTO public.who_global_data VALUES (52105, 1, 2007, 1, 38, 220, 147);
INSERT INTO public.who_global_data VALUES (52106, 288, 257888, 10, 29735, 220, 208);
INSERT INTO public.who_global_data VALUES (52107, 5, 2047, 0, 11, 220, 45);
INSERT INTO public.who_global_data VALUES (52108, 128, 9500, 5, 592, 220, 110);
INSERT INTO public.who_global_data VALUES (52109, 23, 515, 0, 13, 220, 88);
INSERT INTO public.who_global_data VALUES (52110, 726, 67060, 16, 5494, 220, 51);
INSERT INTO public.who_global_data VALUES (52111, 138, 31907, 0, 1723, 220, 209);
INSERT INTO public.who_global_data VALUES (52112, 10, 279, 0, 9, 220, 205);
INSERT INTO public.who_global_data VALUES (52113, 54, 5954, 0, 52, 220, 18);
INSERT INTO public.who_global_data VALUES (52114, 2, 3173, 0, 58, 220, 72);
INSERT INTO public.who_global_data VALUES (52115, 730, 284275, 53, 40394, 220, 44);
INSERT INTO public.who_global_data VALUES (52116, 0, 24, 0, 0, 220, 15);
INSERT INTO public.who_global_data VALUES (52117, 1, 643, 0, 14, 220, 25);
INSERT INTO public.who_global_data VALUES (52118, 0, 0, 0, 0, 220, 179);
INSERT INTO public.who_global_data VALUES (52119, 0, 0, 0, 0, 220, 34);
INSERT INTO public.who_global_data VALUES (52120, 4, 130, 0, 8, 220, 207);
INSERT INTO public.who_global_data VALUES (52121, 1, 1175, 0, 50, 220, 166);
INSERT INTO public.who_global_data VALUES (52122, 1293, 199906, 16, 5131, 220, 126);
INSERT INTO public.who_global_data VALUES (52123, 0, 0, 0, 0, 220, 97);
INSERT INTO public.who_global_data VALUES (52124, 0, 41, 1, 2, 220, 36);
INSERT INTO public.who_global_data VALUES (52125, 0, 0, 0, 0, 220, 125);
INSERT INTO public.who_global_data VALUES (52126, 19, 889, 0, 0, 220, 124);
INSERT INTO public.who_global_data VALUES (52127, 664, 44998, 14, 1173, 220, 185);
INSERT INTO public.who_global_data VALUES (52128, 421, 48667, 1, 315, 220, 194);
INSERT INTO public.who_global_data VALUES (52129, 0, 509, 0, 21, 220, 144);
INSERT INTO public.who_global_data VALUES (52130, 35757, 2573393, 370, 126573, 220, 19);
INSERT INTO public.who_global_data VALUES (52131, 3, 84, 0, 6, 220, 217);
INSERT INTO public.who_global_data VALUES (52132, 3, 932, 0, 27, 220, 148);
INSERT INTO public.who_global_data VALUES (52133, 329, 8627, 2, 26, 220, 86);
INSERT INTO public.who_global_data VALUES (52134, 0, 0, 0, 0, 220, 13);
INSERT INTO public.who_global_data VALUES (52135, 233, 5530, 4, 48, 220, 157);
INSERT INTO public.who_global_data VALUES (52136, 0, 355, 0, 0, 220, 8);
INSERT INTO public.who_global_data VALUES (52137, 0, 0, 0, 0, 220, 73);
INSERT INTO public.who_global_data VALUES (52138, 30, 1158, 8, 312, 220, 101);
INSERT INTO public.who_global_data VALUES (52139, 26, 1594, 2, 24, 220, 165);
INSERT INTO public.who_global_data VALUES (52140, 17, 591, 0, 7, 220, 14);
INSERT INTO public.who_global_data VALUES (52141, 121, 31445, 2, 739, 221, 193);
INSERT INTO public.who_global_data VALUES (52142, 69, 2535, 4, 62, 221, 113);
INSERT INTO public.who_global_data VALUES (52143, 298, 13571, 8, 905, 221, 143);
INSERT INTO public.who_global_data VALUES (52144, 0, 0, 0, 0, 221, 219);
INSERT INTO public.who_global_data VALUES (52145, 0, 855, 0, 52, 221, 186);
INSERT INTO public.who_global_data VALUES (52146, 9, 276, 0, 11, 221, 52);
INSERT INTO public.who_global_data VALUES (52147, 0, 3, 0, 0, 221, 180);
INSERT INTO public.who_global_data VALUES (52148, 0, 65, 0, 3, 221, 167);
INSERT INTO public.who_global_data VALUES (52149, 2189, 59933, 28, 1245, 221, 154);
INSERT INTO public.who_global_data VALUES (52150, 415, 24855, 10, 438, 221, 94);
INSERT INTO public.who_global_data VALUES (52151, 0, 101, 0, 3, 221, 66);
INSERT INTO public.who_global_data VALUES (52152, 81, 7767, 0, 104, 221, 58);
INSERT INTO public.who_global_data VALUES (52153, 41, 17666, 1, 703, 221, 163);
INSERT INTO public.who_global_data VALUES (52154, 544, 16968, 8, 206, 221, 37);
INSERT INTO public.who_global_data VALUES (52155, 0, 104, 0, 11, 221, 142);
INSERT INTO public.who_global_data VALUES (52156, 534, 26239, 1, 84, 221, 83);
INSERT INTO public.who_global_data VALUES (52157, 4014, 141801, 45, 1783, 221, 228);
INSERT INTO public.who_global_data VALUES (52158, 0, 97, 0, 7, 221, 188);
INSERT INTO public.who_global_data VALUES (52159, 315, 61790, 4, 387, 221, 62);
INSERT INTO public.who_global_data VALUES (52160, 127, 61984, 3, 9620, 221, 160);
INSERT INTO public.who_global_data VALUES (52161, 0, 24, 0, 2, 221, 50);
INSERT INTO public.who_global_data VALUES (52162, 38, 1187, 3, 19, 221, 33);
INSERT INTO public.who_global_data VALUES (52163, 0, 146, 0, 9, 221, 183);
INSERT INTO public.who_global_data VALUES (52164, 1, 77, 0, 0, 221, 92);
INSERT INTO public.who_global_data VALUES (52165, 848, 31524, 44, 1014, 221, 158);
INSERT INTO public.who_global_data VALUES (52166, 0, 2, 0, 0, 221, 67);
INSERT INTO public.who_global_data VALUES (52167, 128, 4343, 1, 183, 221, 57);
INSERT INTO public.who_global_data VALUES (52168, 0, 175, 0, 1, 221, 38);
INSERT INTO public.who_global_data VALUES (52169, 30476, 1344143, 552, 57622, 221, 141);
INSERT INTO public.who_global_data VALUES (52170, 0, 8, 0, 1, 221, 178);
INSERT INTO public.who_global_data VALUES (52171, 0, 141, 0, 3, 221, 108);
INSERT INTO public.who_global_data VALUES (52172, 140, 4831, 4, 223, 221, 39);
INSERT INTO public.who_global_data VALUES (52173, 0, 959, 0, 53, 221, 2);
INSERT INTO public.who_global_data VALUES (52174, 0, 170, 0, 1, 221, 195);
INSERT INTO public.who_global_data VALUES (52175, 10, 1165, 0, 12, 221, 107);
INSERT INTO public.who_global_data VALUES (52176, 0, 141, 0, 0, 221, 161);
INSERT INTO public.who_global_data VALUES (52177, 0, 12592, 0, 313, 221, 212);
INSERT INTO public.who_global_data VALUES (52178, 218, 103250, 6, 8522, 221, 181);
INSERT INTO public.who_global_data VALUES (52179, 0, 196, 0, 1, 221, 53);
INSERT INTO public.who_global_data VALUES (52180, 184, 3613, 2, 47, 221, 164);
INSERT INTO public.who_global_data VALUES (52181, 0, 866, 0, 74, 221, 140);
INSERT INTO public.who_global_data VALUES (52182, 4017, 275999, 66, 5575, 221, 20);
INSERT INTO public.who_global_data VALUES (52183, 23, 85227, 0, 4648, 221, 112);
INSERT INTO public.who_global_data VALUES (52184, 3178, 91769, 167, 3106, 221, 111);
INSERT INTO public.who_global_data VALUES (52185, 0, 293, 0, 7, 221, 71);
INSERT INTO public.who_global_data VALUES (52186, 0, 1245, 0, 40, 221, 218);
INSERT INTO public.who_global_data VALUES (52187, 0, 0, 0, 0, 221, 43);
INSERT INTO public.who_global_data VALUES (52188, 151, 3130, 2, 15, 221, 49);
INSERT INTO public.who_global_data VALUES (52189, 157, 9101, 0, 66, 221, 1);
INSERT INTO public.who_global_data VALUES (52190, 34, 2725, 0, 107, 221, 48);
INSERT INTO public.who_global_data VALUES (52191, 8, 2340, 0, 86, 221, 232);
INSERT INTO public.who_global_data VALUES (52192, 1, 24, 0, 1, 221, 175);
INSERT INTO public.who_global_data VALUES (52193, 2, 996, 0, 19, 221, 21);
INSERT INTO public.who_global_data VALUES (52194, 202, 11805, 0, 348, 221, 156);
INSERT INTO public.who_global_data VALUES (52195, 0, 0, 0, 0, 221, 95);
INSERT INTO public.who_global_data VALUES (52196, 112, 6938, 9, 166, 221, 177);
INSERT INTO public.who_global_data VALUES (52197, 76, 12751, 1, 605, 221, 210);
INSERT INTO public.who_global_data VALUES (52198, 13, 4656, 1, 53, 221, 120);
INSERT INTO public.who_global_data VALUES (52199, 0, 18, 0, 0, 221, 135);
INSERT INTO public.who_global_data VALUES (52200, 443, 31816, 7, 733, 221, 206);
INSERT INTO public.who_global_data VALUES (52201, 410, 55665, 73, 4502, 221, 189);
INSERT INTO public.who_global_data VALUES (52202, 1566, 66754, 83, 2872, 221, 129);
INSERT INTO public.who_global_data VALUES (52203, 239, 6173, 12, 164, 221, 121);
INSERT INTO public.who_global_data VALUES (52204, 0, 1043, 0, 12, 221, 59);
INSERT INTO public.who_global_data VALUES (52205, 0, 191, 0, 0, 221, 96);
INSERT INTO public.who_global_data VALUES (52206, 0, 1987, 0, 63, 221, 41);
INSERT INTO public.who_global_data VALUES (52207, 14, 795, 0, 11, 221, 216);
INSERT INTO public.who_global_data VALUES (52208, 157, 5846, 5, 103, 221, 236);
INSERT INTO public.who_global_data VALUES (52209, 0, 13, 0, 0, 221, 150);
INSERT INTO public.who_global_data VALUES (52210, 0, 187, 0, 0, 221, 61);
INSERT INTO public.who_global_data VALUES (52211, 0, 18, 0, 0, 221, 7);
INSERT INTO public.who_global_data VALUES (52212, 18, 7209, 0, 328, 221, 169);
INSERT INTO public.who_global_data VALUES (52213, 731, 156887, 30, 29730, 221, 28);
INSERT INTO public.who_global_data VALUES (52214, 313, 3774, 3, 15, 221, 85);
INSERT INTO public.who_global_data VALUES (52215, 0, 62, 0, 0, 221, 211);
INSERT INTO public.who_global_data VALUES (52216, 185, 5394, 2, 42, 221, 60);
INSERT INTO public.who_global_data VALUES (52217, 2, 47, 0, 2, 221, 3);
INSERT INTO public.who_global_data VALUES (52218, 2, 928, 0, 15, 221, 11);
INSERT INTO public.who_global_data VALUES (52219, 498, 194259, 12, 8973, 221, 89);
INSERT INTO public.who_global_data VALUES (52220, 0, 17351, 0, 112, 221, 24);
INSERT INTO public.who_global_data VALUES (52221, 0, 177, 0, 0, 221, 162);
INSERT INTO public.who_global_data VALUES (52222, 14, 3390, 0, 191, 221, 100);
INSERT INTO public.who_global_data VALUES (52223, 0, 13, 0, 0, 221, 47);
INSERT INTO public.who_global_data VALUES (52224, 0, 23, 0, 0, 221, 29);
INSERT INTO public.who_global_data VALUES (52225, 0, 182, 0, 14, 221, 40);
INSERT INTO public.who_global_data VALUES (52226, 7, 247, 0, 5, 221, 222);
INSERT INTO public.who_global_data VALUES (52227, 533, 16930, 21, 727, 221, 132);
INSERT INTO public.who_global_data VALUES (52228, 0, 252, 0, 13, 221, 130);
INSERT INTO public.who_global_data VALUES (52229, 9, 5351, 0, 31, 221, 234);
INSERT INTO public.who_global_data VALUES (52230, 40, 1654, 3, 24, 221, 23);
INSERT INTO public.who_global_data VALUES (52231, 0, 230, 0, 12, 221, 192);
INSERT INTO public.who_global_data VALUES (52232, 125, 5847, 6, 104, 221, 69);
INSERT INTO public.who_global_data VALUES (52233, 0, 12, 0, 0, 221, 187);
INSERT INTO public.who_global_data VALUES (52234, 1075, 18082, 0, 479, 221, 230);
INSERT INTO public.who_global_data VALUES (52235, 3, 4145, 4, 585, 221, 77);
INSERT INTO public.who_global_data VALUES (52236, 1, 1822, 0, 10, 221, 9);
INSERT INTO public.who_global_data VALUES (52237, 18522, 566840, 418, 16893, 221, 74);
INSERT INTO public.who_global_data VALUES (52238, 1082, 55092, 51, 2805, 221, 224);
INSERT INTO public.who_global_data VALUES (52239, 2536, 225205, 162, 10670, 221, 199);
INSERT INTO public.who_global_data VALUES (52240, 1749, 47151, 83, 1839, 221, 190);
INSERT INTO public.who_global_data VALUES (52241, 23, 25462, 0, 1735, 221, 12);
INSERT INTO public.who_global_data VALUES (52242, 0, 336, 0, 24, 221, 104);
INSERT INTO public.who_global_data VALUES (52243, 385, 23903, 2, 326, 221, 153);
INSERT INTO public.who_global_data VALUES (52244, 126, 240436, 6, 34744, 221, 91);
INSERT INTO public.who_global_data VALUES (52245, 10, 696, 0, 10, 221, 215);
INSERT INTO public.who_global_data VALUES (52246, 117, 18593, 0, 972, 221, 84);
INSERT INTO public.who_global_data VALUES (52247, 0, 320, 0, 31, 221, 231);
INSERT INTO public.who_global_data VALUES (52248, 7, 1052, 0, 9, 221, 196);
INSERT INTO public.who_global_data VALUES (52249, 10897, 41065, 0, 188, 221, 105);
INSERT INTO public.who_global_data VALUES (52250, 120, 6190, 0, 144, 221, 122);
INSERT INTO public.who_global_data VALUES (52251, 0, 0, 0, 0, 221, 159);
INSERT INTO public.who_global_data VALUES (52252, 122, 2756, 1, 39, 221, 75);
INSERT INTO public.who_global_data VALUES (52253, 582, 45524, 2, 350, 221, 27);
INSERT INTO public.who_global_data VALUES (52254, 279, 5296, 7, 57, 221, 54);
INSERT INTO public.who_global_data VALUES (52255, 0, 19, 0, 0, 221, 226);
INSERT INTO public.who_global_data VALUES (52256, 1, 1117, 0, 30, 221, 79);
INSERT INTO public.who_global_data VALUES (52257, 5, 1745, 1, 34, 221, 56);
INSERT INTO public.who_global_data VALUES (52258, 0, 27, 0, 0, 221, 117);
INSERT INTO public.who_global_data VALUES (52259, 2, 770, 2, 36, 221, 152);
INSERT INTO public.who_global_data VALUES (52260, 40, 802, 2, 23, 221, 16);
INSERT INTO public.who_global_data VALUES (52261, 0, 83, 0, 1, 221, 10);
INSERT INTO public.who_global_data VALUES (52262, 1, 1812, 0, 78, 221, 201);
INSERT INTO public.who_global_data VALUES (52263, 14, 4256, 0, 110, 221, 174);
INSERT INTO public.who_global_data VALUES (52264, 60, 2138, 2, 20, 221, 119);
INSERT INTO public.who_global_data VALUES (52265, 72, 1224, 1, 14, 221, 168);
INSERT INTO public.who_global_data VALUES (52266, 3, 8637, 0, 121, 221, 99);
INSERT INTO public.who_global_data VALUES (52267, 13, 2337, 0, 8, 221, 171);
INSERT INTO public.who_global_data VALUES (52268, 26, 2173, 1, 115, 221, 87);
INSERT INTO public.who_global_data VALUES (52269, 0, 669, 0, 9, 221, 123);
INSERT INTO public.who_global_data VALUES (52270, 0, 0, 0, 0, 221, 151);
INSERT INTO public.who_global_data VALUES (52271, 0, 242, 0, 14, 221, 213);
INSERT INTO public.who_global_data VALUES (52272, 242, 4149, 6, 126, 221, 118);
INSERT INTO public.who_global_data VALUES (52273, 0, 341, 0, 10, 221, 134);
INSERT INTO public.who_global_data VALUES (52274, 63, 2603, 0, 35, 221, 65);
INSERT INTO public.who_global_data VALUES (52275, 4050, 216852, 267, 26648, 221, 102);
INSERT INTO public.who_global_data VALUES (52276, 0, 0, 0, 0, 221, 223);
INSERT INTO public.who_global_data VALUES (52277, 0, 73, 0, 1, 221, 4);
INSERT INTO public.who_global_data VALUES (52278, 1, 220, 0, 0, 221, 146);
INSERT INTO public.who_global_data VALUES (52279, 28, 554, 0, 13, 221, 31);
INSERT INTO public.who_global_data VALUES (52280, 0, 11, 0, 1, 221, 127);
INSERT INTO public.who_global_data VALUES (52281, 238, 12290, 4, 225, 221, 22);
INSERT INTO public.who_global_data VALUES (52282, 24, 883, 0, 5, 221, 115);
INSERT INTO public.who_global_data VALUES (52283, 0, 299, 0, 6, 221, 106);
INSERT INTO public.who_global_data VALUES (52284, 33, 183, 0, 0, 221, 90);
INSERT INTO public.who_global_data VALUES (52285, 0, 0, 0, 0, 221, 70);
INSERT INTO public.who_global_data VALUES (52286, 476, 13248, 1, 29, 221, 46);
INSERT INTO public.who_global_data VALUES (52287, 76, 50002, 2, 6081, 221, 139);
INSERT INTO public.who_global_data VALUES (52288, 0, 21, 0, 0, 221, 42);
INSERT INTO public.who_global_data VALUES (52289, 0, 1178, 0, 22, 221, 80);
INSERT INTO public.who_global_data VALUES (52290, 0, 2014, 0, 74, 221, 203);
INSERT INTO public.who_global_data VALUES (52291, 1, 1075, 0, 67, 221, 136);
INSERT INTO public.who_global_data VALUES (52292, 566, 25133, 8, 573, 221, 63);
INSERT INTO public.who_global_data VALUES (52293, 0, 0, 0, 0, 221, 17);
INSERT INTO public.who_global_data VALUES (52294, 0, 30, 0, 2, 221, 172);
INSERT INTO public.who_global_data VALUES (52295, 132, 6224, 12, 298, 221, 109);
INSERT INTO public.who_global_data VALUES (52296, 40, 8855, 0, 249, 221, 200);
INSERT INTO public.who_global_data VALUES (52297, 195, 2443, 1, 8, 221, 93);
INSERT INTO public.who_global_data VALUES (52298, 910, 39060, 6, 169, 221, 5);
INSERT INTO public.who_global_data VALUES (52299, 0, 741, 0, 13, 221, 214);
INSERT INTO public.who_global_data VALUES (52300, 2825, 209337, 137, 4304, 221, 204);
INSERT INTO public.who_global_data VALUES (52301, 0, 0, 0, 0, 221, 198);
INSERT INTO public.who_global_data VALUES (52302, 1028, 31686, 12, 604, 221, 173);
INSERT INTO public.who_global_data VALUES (52303, 0, 11, 0, 0, 221, 229);
INSERT INTO public.who_global_data VALUES (52304, 185, 2127, 0, 15, 221, 76);
INSERT INTO public.who_global_data VALUES (52305, 3430, 279419, 182, 9317, 221, 138);
INSERT INTO public.who_global_data VALUES (52306, 983, 36438, 11, 1255, 221, 98);
INSERT INTO public.who_global_data VALUES (52307, 0, 0, 0, 0, 221, 103);
INSERT INTO public.who_global_data VALUES (52308, 247, 34154, 6, 1444, 221, 225);
INSERT INTO public.who_global_data VALUES (52309, 266, 41912, 4, 1568, 221, 131);
INSERT INTO public.who_global_data VALUES (52310, 61, 7250, 0, 153, 221, 235);
INSERT INTO public.who_global_data VALUES (52311, 693, 95106, 3, 113, 221, 137);
INSERT INTO public.who_global_data VALUES (52312, 42, 12799, 0, 282, 221, 81);
INSERT INTO public.who_global_data VALUES (52313, 107, 16357, 8, 541, 221, 182);
INSERT INTO public.who_global_data VALUES (52314, 1, 522, 0, 2, 221, 145);
INSERT INTO public.who_global_data VALUES (52315, 269, 26582, 22, 1634, 221, 26);
INSERT INTO public.who_global_data VALUES (52316, 6693, 647849, 154, 9320, 221, 170);
INSERT INTO public.who_global_data VALUES (52317, 101, 1001, 0, 2, 221, 191);
INSERT INTO public.who_global_data VALUES (52318, 0, 3, 0, 0, 221, 221);
INSERT INTO public.who_global_data VALUES (52319, 0, 6, 0, 0, 221, 64);
INSERT INTO public.who_global_data VALUES (52320, 0, 0, 0, 0, 221, 116);
INSERT INTO public.who_global_data VALUES (52321, 0, 15, 0, 0, 221, 128);
INSERT INTO public.who_global_data VALUES (52322, 0, 19, 0, 0, 221, 6);
INSERT INTO public.who_global_data VALUES (52323, 1, 43, 0, 3, 221, 227);
INSERT INTO public.who_global_data VALUES (52324, 0, 1, 0, 0, 221, 68);
INSERT INTO public.who_global_data VALUES (52325, 0, 29, 0, 0, 221, 184);
INSERT INTO public.who_global_data VALUES (52326, 0, 0, 0, 0, 221, 82);
INSERT INTO public.who_global_data VALUES (52327, 0, 713, 0, 42, 221, 149);
INSERT INTO public.who_global_data VALUES (52328, 0, 393, 0, 11, 221, 197);
INSERT INTO public.who_global_data VALUES (52329, 3943, 186436, 48, 1599, 221, 78);
INSERT INTO public.who_global_data VALUES (52330, 112, 6698, 3, 108, 221, 233);
INSERT INTO public.who_global_data VALUES (52331, 242, 14288, 4, 274, 221, 133);
INSERT INTO public.who_global_data VALUES (52332, 4, 81, 0, 0, 221, 35);
INSERT INTO public.who_global_data VALUES (52333, 23, 1450, 0, 60, 221, 114);
INSERT INTO public.who_global_data VALUES (52334, 202, 43661, 0, 26, 221, 237);
INSERT INTO public.who_global_data VALUES (52335, 0, 2, 0, 0, 221, 55);
INSERT INTO public.who_global_data VALUES (52336, 0, 77, 0, 15, 221, 176);
INSERT INTO public.who_global_data VALUES (52337, 1, 1665, 0, 28, 221, 202);
INSERT INTO public.who_global_data VALUES (52338, 15, 1599, 0, 114, 221, 155);
INSERT INTO public.who_global_data VALUES (52339, 0, 0, 0, 0, 221, 32);
INSERT INTO public.who_global_data VALUES (52340, 10, 2904, 0, 90, 221, 220);
INSERT INTO public.who_global_data VALUES (52341, 6130, 144264, 73, 2529, 221, 30);
INSERT INTO public.who_global_data VALUES (52342, 40, 2006, 1, 37, 221, 147);
INSERT INTO public.who_global_data VALUES (52343, 191, 257600, 11, 29725, 221, 208);
INSERT INTO public.who_global_data VALUES (52344, 5, 2042, 0, 11, 221, 45);
INSERT INTO public.who_global_data VALUES (52345, 52, 9372, 3, 587, 221, 110);
INSERT INTO public.who_global_data VALUES (52346, 25, 492, 2, 13, 221, 88);
INSERT INTO public.who_global_data VALUES (52347, 415, 66334, 23, 5478, 221, 51);
INSERT INTO public.who_global_data VALUES (52348, 160, 31769, 1, 1723, 221, 209);
INSERT INTO public.who_global_data VALUES (52349, 13, 269, 0, 9, 221, 205);
INSERT INTO public.who_global_data VALUES (52350, 51, 5900, 0, 52, 221, 18);
INSERT INTO public.who_global_data VALUES (52351, 2, 3171, 0, 58, 221, 72);
INSERT INTO public.who_global_data VALUES (52352, 446, 283545, 21, 40341, 221, 44);
INSERT INTO public.who_global_data VALUES (52353, 0, 24, 0, 0, 221, 15);
INSERT INTO public.who_global_data VALUES (52354, 27, 642, 0, 14, 221, 25);
INSERT INTO public.who_global_data VALUES (52355, 0, 0, 0, 0, 221, 179);
INSERT INTO public.who_global_data VALUES (52356, 0, 0, 0, 0, 221, 34);
INSERT INTO public.who_global_data VALUES (52357, 0, 126, 0, 8, 221, 207);
INSERT INTO public.who_global_data VALUES (52358, 2, 1174, 0, 50, 221, 166);
INSERT INTO public.who_global_data VALUES (52359, 1374, 198613, 18, 5115, 221, 126);
INSERT INTO public.who_global_data VALUES (52360, 0, 0, 0, 0, 221, 97);
INSERT INTO public.who_global_data VALUES (52361, 25, 41, 0, 1, 221, 36);
INSERT INTO public.who_global_data VALUES (52362, 0, 0, 0, 0, 221, 125);
INSERT INTO public.who_global_data VALUES (52363, 37, 870, 0, 0, 221, 124);
INSERT INTO public.who_global_data VALUES (52364, 706, 44334, 12, 1159, 221, 185);
INSERT INTO public.who_global_data VALUES (52365, 449, 48246, 1, 314, 221, 194);
INSERT INTO public.who_global_data VALUES (52366, 0, 509, 0, 21, 221, 144);
INSERT INTO public.who_global_data VALUES (52367, 41008, 2537636, 885, 126203, 221, 19);
INSERT INTO public.who_global_data VALUES (52368, 0, 81, 0, 6, 221, 217);
INSERT INTO public.who_global_data VALUES (52369, 5, 929, 1, 27, 221, 148);
INSERT INTO public.who_global_data VALUES (52370, 267, 8298, 2, 24, 221, 86);
INSERT INTO public.who_global_data VALUES (52371, 0, 0, 0, 0, 221, 13);
INSERT INTO public.who_global_data VALUES (52372, 167, 5297, 2, 44, 221, 157);
INSERT INTO public.who_global_data VALUES (52373, 0, 355, 0, 0, 221, 8);
INSERT INTO public.who_global_data VALUES (52374, 0, 0, 0, 0, 221, 73);
INSERT INTO public.who_global_data VALUES (52375, 10, 1128, 2, 304, 221, 101);
INSERT INTO public.who_global_data VALUES (52376, 37, 1568, 1, 22, 221, 165);
INSERT INTO public.who_global_data VALUES (52377, 7, 574, 1, 7, 221, 14);
INSERT INTO public.who_global_data VALUES (52378, 271, 31324, 4, 737, 222, 193);
INSERT INTO public.who_global_data VALUES (52379, 64, 2466, 3, 58, 222, 113);
INSERT INTO public.who_global_data VALUES (52380, 305, 13273, 5, 897, 222, 143);
INSERT INTO public.who_global_data VALUES (52381, 0, 0, 0, 0, 222, 219);
INSERT INTO public.who_global_data VALUES (52382, 0, 855, 0, 52, 222, 186);
INSERT INTO public.who_global_data VALUES (52383, 8, 267, 1, 11, 222, 52);
INSERT INTO public.who_global_data VALUES (52384, 0, 3, 0, 0, 222, 180);
INSERT INTO public.who_global_data VALUES (52385, 39, 65, 0, 3, 222, 167);
INSERT INTO public.who_global_data VALUES (52386, 2401, 57744, 25, 1217, 222, 154);
INSERT INTO public.who_global_data VALUES (52387, 482, 24440, 7, 428, 222, 94);
INSERT INTO public.who_global_data VALUES (52388, 0, 101, 0, 3, 222, 66);
INSERT INTO public.who_global_data VALUES (52389, 45, 7686, 0, 104, 222, 58);
INSERT INTO public.who_global_data VALUES (52390, 63, 17625, 2, 702, 222, 163);
INSERT INTO public.who_global_data VALUES (52391, 534, 16424, 5, 198, 222, 37);
INSERT INTO public.who_global_data VALUES (52392, 0, 104, 0, 11, 222, 142);
INSERT INTO public.who_global_data VALUES (52393, 438, 25705, 5, 83, 222, 83);
INSERT INTO public.who_global_data VALUES (52394, 3809, 137787, 43, 1738, 222, 228);
INSERT INTO public.who_global_data VALUES (52395, 0, 97, 0, 7, 222, 188);
INSERT INTO public.who_global_data VALUES (52396, 380, 61475, 6, 383, 222, 62);
INSERT INTO public.who_global_data VALUES (52397, 24, 61857, 5, 9617, 222, 160);
INSERT INTO public.who_global_data VALUES (52398, 0, 24, 0, 2, 222, 50);
INSERT INTO public.who_global_data VALUES (52399, 25, 1149, 2, 16, 222, 33);
INSERT INTO public.who_global_data VALUES (52400, 0, 146, 0, 9, 222, 183);
INSERT INTO public.who_global_data VALUES (52401, 0, 76, 0, 0, 222, 92);
INSERT INTO public.who_global_data VALUES (52402, 1253, 30676, 36, 970, 222, 158);
INSERT INTO public.who_global_data VALUES (52403, 0, 2, 0, 0, 222, 67);
INSERT INTO public.who_global_data VALUES (52404, 108, 4215, 3, 182, 222, 57);
INSERT INTO public.who_global_data VALUES (52405, 50, 175, 0, 1, 222, 38);
INSERT INTO public.who_global_data VALUES (52406, 38693, 1313667, 1109, 57070, 222, 141);
INSERT INTO public.who_global_data VALUES (52407, 0, 8, 0, 1, 222, 178);
INSERT INTO public.who_global_data VALUES (52408, 0, 141, 0, 3, 222, 108);
INSERT INTO public.who_global_data VALUES (52409, 66, 4691, 3, 219, 222, 39);
INSERT INTO public.who_global_data VALUES (52410, 5, 959, 0, 53, 222, 2);
INSERT INTO public.who_global_data VALUES (52411, 26, 170, 0, 1, 222, 195);
INSERT INTO public.who_global_data VALUES (52412, 64, 1155, 0, 12, 222, 107);
INSERT INTO public.who_global_data VALUES (52413, 2, 141, 0, 0, 222, 161);
INSERT INTO public.who_global_data VALUES (52414, 0, 12592, 0, 313, 222, 212);
INSERT INTO public.who_global_data VALUES (52415, 238, 103032, 8, 8516, 222, 181);
INSERT INTO public.who_global_data VALUES (52416, 0, 196, 0, 1, 222, 53);
INSERT INTO public.who_global_data VALUES (52417, 89, 3429, 5, 45, 222, 164);
INSERT INTO public.who_global_data VALUES (52418, 1, 866, 0, 74, 222, 140);
INSERT INTO public.who_global_data VALUES (52419, 4216, 271982, 162, 5509, 222, 20);
INSERT INTO public.who_global_data VALUES (52420, 14, 85204, 0, 4648, 222, 112);
INSERT INTO public.who_global_data VALUES (52421, 4149, 88591, 128, 2939, 222, 111);
INSERT INTO public.who_global_data VALUES (52422, 21, 293, 0, 7, 222, 71);
INSERT INTO public.who_global_data VALUES (52423, 0, 1245, 0, 40, 222, 218);
INSERT INTO public.who_global_data VALUES (52424, 0, 0, 0, 0, 222, 43);
INSERT INTO public.who_global_data VALUES (52425, 143, 2979, 1, 13, 222, 49);
INSERT INTO public.who_global_data VALUES (52426, 0, 8944, 0, 66, 222, 1);
INSERT INTO public.who_global_data VALUES (52427, 67, 2691, 0, 107, 222, 48);
INSERT INTO public.who_global_data VALUES (52428, 2, 2332, 0, 86, 222, 232);
INSERT INTO public.who_global_data VALUES (52429, 0, 23, 0, 1, 222, 175);
INSERT INTO public.who_global_data VALUES (52430, 0, 994, 0, 19, 222, 21);
INSERT INTO public.who_global_data VALUES (52431, 305, 11603, 1, 348, 222, 156);
INSERT INTO public.who_global_data VALUES (52432, 0, 0, 0, 0, 222, 95);
INSERT INTO public.who_global_data VALUES (52433, 137, 6826, 5, 157, 222, 177);
INSERT INTO public.who_global_data VALUES (52434, 0, 12675, 0, 604, 222, 210);
INSERT INTO public.who_global_data VALUES (52435, 0, 4643, 0, 52, 222, 120);
INSERT INTO public.who_global_data VALUES (52436, 0, 18, 0, 0, 222, 135);
INSERT INTO public.who_global_data VALUES (52437, 754, 31373, 8, 726, 222, 206);
INSERT INTO public.who_global_data VALUES (52438, 681, 55255, 5, 4429, 222, 189);
INSERT INTO public.who_global_data VALUES (52439, 1265, 65188, 81, 2789, 222, 129);
INSERT INTO public.who_global_data VALUES (52440, 207, 5934, 9, 152, 222, 121);
INSERT INTO public.who_global_data VALUES (52441, 0, 1043, 0, 12, 222, 59);
INSERT INTO public.who_global_data VALUES (52442, 0, 191, 0, 0, 222, 96);
INSERT INTO public.who_global_data VALUES (52443, 1, 1987, 0, 63, 222, 41);
INSERT INTO public.who_global_data VALUES (52444, 36, 781, 3, 11, 222, 216);
INSERT INTO public.who_global_data VALUES (52445, 119, 5689, 4, 98, 222, 236);
INSERT INTO public.who_global_data VALUES (52446, 0, 13, 0, 0, 222, 150);
INSERT INTO public.who_global_data VALUES (52447, 0, 187, 0, 0, 222, 61);
INSERT INTO public.who_global_data VALUES (52448, 0, 18, 0, 0, 222, 7);
INSERT INTO public.who_global_data VALUES (52449, 0, 7191, 0, 328, 222, 169);
INSERT INTO public.who_global_data VALUES (52450, 0, 156156, 0, 29700, 222, 28);
INSERT INTO public.who_global_data VALUES (52451, 0, 3461, 0, 12, 222, 85);
INSERT INTO public.who_global_data VALUES (52452, 0, 62, 0, 0, 222, 211);
INSERT INTO public.who_global_data VALUES (52453, 0, 5209, 0, 40, 222, 60);
INSERT INTO public.who_global_data VALUES (52454, 0, 45, 0, 2, 222, 3);
INSERT INTO public.who_global_data VALUES (52455, 2, 926, 0, 15, 222, 11);
INSERT INTO public.who_global_data VALUES (52456, 262, 193761, 4, 8961, 222, 89);
INSERT INTO public.who_global_data VALUES (52457, 920, 17351, 9, 112, 222, 24);
INSERT INTO public.who_global_data VALUES (52458, 1, 177, 0, 0, 222, 162);
INSERT INTO public.who_global_data VALUES (52459, 10, 3376, 0, 191, 222, 100);
INSERT INTO public.who_global_data VALUES (52460, 0, 13, 0, 0, 222, 47);
INSERT INTO public.who_global_data VALUES (52461, 0, 23, 0, 0, 222, 29);
INSERT INTO public.who_global_data VALUES (52462, 0, 182, 0, 14, 222, 40);
INSERT INTO public.who_global_data VALUES (52463, 0, 240, 0, 5, 222, 222);
INSERT INTO public.who_global_data VALUES (52464, 569, 16397, 34, 706, 222, 132);
INSERT INTO public.who_global_data VALUES (52465, 0, 252, 0, 13, 222, 130);
INSERT INTO public.who_global_data VALUES (52466, 51, 5342, 1, 31, 222, 234);
INSERT INTO public.who_global_data VALUES (52467, 0, 1614, 0, 21, 222, 23);
INSERT INTO public.who_global_data VALUES (52468, 0, 230, 0, 12, 222, 192);
INSERT INTO public.who_global_data VALUES (52469, 0, 5722, 0, 98, 222, 69);
INSERT INTO public.who_global_data VALUES (52470, 0, 12, 0, 0, 222, 187);
INSERT INTO public.who_global_data VALUES (52471, 1013, 17007, 8, 479, 222, 230);
INSERT INTO public.who_global_data VALUES (52472, 4, 4142, 3, 581, 222, 77);
INSERT INTO public.who_global_data VALUES (52473, 1, 1821, 0, 10, 222, 9);
INSERT INTO public.who_global_data VALUES (52474, 19459, 548318, 380, 16475, 222, 74);
INSERT INTO public.who_global_data VALUES (52475, 1198, 54010, 34, 2754, 222, 224);
INSERT INTO public.who_global_data VALUES (52476, 2489, 222669, 144, 10508, 222, 199);
INSERT INTO public.who_global_data VALUES (52477, 2140, 45402, 96, 1756, 222, 190);
INSERT INTO public.who_global_data VALUES (52478, 2, 25439, 1, 1735, 222, 12);
INSERT INTO public.who_global_data VALUES (52479, 0, 336, 0, 24, 222, 104);
INSERT INTO public.who_global_data VALUES (52480, 398, 23518, 3, 324, 222, 153);
INSERT INTO public.who_global_data VALUES (52481, 174, 240310, 22, 34738, 222, 91);
INSERT INTO public.who_global_data VALUES (52482, 0, 686, 0, 10, 222, 215);
INSERT INTO public.who_global_data VALUES (52483, 86, 18476, 1, 972, 222, 84);
INSERT INTO public.who_global_data VALUES (52484, 0, 320, 0, 31, 222, 231);
INSERT INTO public.who_global_data VALUES (52485, 9, 1045, 0, 9, 222, 196);
INSERT INTO public.who_global_data VALUES (52486, 492, 30168, 5, 188, 222, 105);
INSERT INTO public.who_global_data VALUES (52487, 259, 6070, 3, 144, 222, 122);
INSERT INTO public.who_global_data VALUES (52488, 0, 0, 0, 0, 222, 159);
INSERT INTO public.who_global_data VALUES (52489, 87, 2634, 1, 38, 222, 75);
INSERT INTO public.who_global_data VALUES (52490, 551, 44942, 4, 348, 222, 27);
INSERT INTO public.who_global_data VALUES (52491, 504, 5017, 4, 50, 222, 54);
INSERT INTO public.who_global_data VALUES (52492, 0, 19, 0, 0, 222, 226);
INSERT INTO public.who_global_data VALUES (52493, 1, 1116, 0, 30, 222, 79);
INSERT INTO public.who_global_data VALUES (52494, 21, 1740, 0, 33, 222, 56);
INSERT INTO public.who_global_data VALUES (52495, 3, 27, 0, 0, 222, 117);
INSERT INTO public.who_global_data VALUES (52496, 84, 768, 0, 34, 222, 152);
INSERT INTO public.who_global_data VALUES (52497, 35, 762, 3, 21, 222, 16);
INSERT INTO public.who_global_data VALUES (52498, 0, 83, 0, 1, 222, 10);
INSERT INTO public.who_global_data VALUES (52499, 1, 1811, 0, 78, 222, 201);
INSERT INTO public.who_global_data VALUES (52500, 25, 4242, 0, 110, 222, 174);
INSERT INTO public.who_global_data VALUES (52501, 73, 2078, 2, 18, 222, 119);
INSERT INTO public.who_global_data VALUES (52502, 114, 1152, 0, 13, 222, 168);
INSERT INTO public.who_global_data VALUES (52503, 18, 8634, 0, 121, 222, 99);
INSERT INTO public.who_global_data VALUES (52504, 19, 2324, 0, 8, 222, 171);
INSERT INTO public.who_global_data VALUES (52505, 87, 2147, 1, 114, 222, 87);
INSERT INTO public.who_global_data VALUES (52506, 0, 669, 0, 9, 222, 123);
INSERT INTO public.who_global_data VALUES (52507, 0, 0, 0, 0, 222, 151);
INSERT INTO public.who_global_data VALUES (52508, 0, 242, 0, 14, 222, 213);
INSERT INTO public.who_global_data VALUES (52509, 0, 3907, 0, 120, 222, 118);
INSERT INTO public.who_global_data VALUES (52510, 0, 341, 0, 10, 222, 134);
INSERT INTO public.who_global_data VALUES (52511, 0, 2540, 0, 35, 222, 65);
INSERT INTO public.who_global_data VALUES (52512, 4410, 212802, 602, 26381, 222, 102);
INSERT INTO public.who_global_data VALUES (52513, 0, 0, 0, 0, 222, 223);
INSERT INTO public.who_global_data VALUES (52514, 0, 73, 0, 1, 222, 4);
INSERT INTO public.who_global_data VALUES (52515, 0, 219, 0, 0, 222, 146);
INSERT INTO public.who_global_data VALUES (52516, 28, 526, 1, 13, 222, 31);
INSERT INTO public.who_global_data VALUES (52517, 0, 11, 0, 1, 222, 127);
INSERT INTO public.who_global_data VALUES (52518, 175, 12052, 1, 221, 222, 22);
INSERT INTO public.who_global_data VALUES (52519, 20, 859, 0, 5, 222, 115);
INSERT INTO public.who_global_data VALUES (52520, 3, 299, 0, 6, 222, 106);
INSERT INTO public.who_global_data VALUES (52521, 14, 150, 0, 0, 222, 90);
INSERT INTO public.who_global_data VALUES (52522, 0, 0, 0, 0, 222, 70);
INSERT INTO public.who_global_data VALUES (52523, 463, 12772, 0, 28, 222, 46);
INSERT INTO public.who_global_data VALUES (52524, 66, 49926, 0, 6079, 222, 139);
INSERT INTO public.who_global_data VALUES (52525, 0, 21, 0, 0, 222, 42);
INSERT INTO public.who_global_data VALUES (52526, 2, 1178, 0, 22, 222, 80);
INSERT INTO public.who_global_data VALUES (52527, 0, 2014, 0, 74, 222, 203);
INSERT INTO public.who_global_data VALUES (52528, 15, 1074, 0, 67, 222, 136);
INSERT INTO public.who_global_data VALUES (52529, 490, 24567, 7, 565, 222, 63);
INSERT INTO public.who_global_data VALUES (52530, 0, 0, 0, 0, 222, 17);
INSERT INTO public.who_global_data VALUES (52531, 0, 30, 0, 2, 222, 172);
INSERT INTO public.who_global_data VALUES (52532, 186, 6092, 9, 286, 222, 109);
INSERT INTO public.who_global_data VALUES (52533, 0, 8815, 0, 249, 222, 200);
INSERT INTO public.who_global_data VALUES (52534, 195, 2248, 0, 7, 222, 93);
INSERT INTO public.who_global_data VALUES (52535, 1197, 38150, 4, 163, 222, 5);
INSERT INTO public.who_global_data VALUES (52536, 0, 741, 0, 13, 222, 214);
INSERT INTO public.who_global_data VALUES (52537, 3557, 206512, 49, 4167, 222, 204);
INSERT INTO public.who_global_data VALUES (52538, 0, 0, 0, 0, 222, 198);
INSERT INTO public.who_global_data VALUES (52539, 753, 30658, 17, 592, 222, 173);
INSERT INTO public.who_global_data VALUES (52540, 0, 11, 0, 0, 222, 229);
INSERT INTO public.who_global_data VALUES (52541, 231, 1942, 2, 15, 222, 76);
INSERT INTO public.who_global_data VALUES (52542, 3625, 275989, 196, 9135, 222, 138);
INSERT INTO public.who_global_data VALUES (52543, 652, 35455, 8, 1244, 222, 98);
INSERT INTO public.who_global_data VALUES (52544, 0, 0, 0, 0, 222, 103);
INSERT INTO public.who_global_data VALUES (52545, 193, 33907, 3, 1438, 222, 225);
INSERT INTO public.who_global_data VALUES (52546, 457, 41646, 3, 1564, 222, 131);
INSERT INTO public.who_global_data VALUES (52547, 123, 7189, 1, 153, 222, 235);
INSERT INTO public.who_global_data VALUES (52548, 750, 94413, 0, 110, 222, 137);
INSERT INTO public.who_global_data VALUES (52549, 42, 12757, 0, 282, 222, 81);
INSERT INTO public.who_global_data VALUES (52550, 170, 16250, 7, 533, 222, 182);
INSERT INTO public.who_global_data VALUES (52551, 1, 521, 0, 2, 222, 145);
INSERT INTO public.who_global_data VALUES (52552, 291, 26313, 23, 1612, 222, 26);
INSERT INTO public.who_global_data VALUES (52553, 6719, 641156, 93, 9166, 222, 170);
INSERT INTO public.who_global_data VALUES (52554, 22, 900, 0, 2, 222, 191);
INSERT INTO public.who_global_data VALUES (52555, 0, 3, 0, 0, 222, 221);
INSERT INTO public.who_global_data VALUES (52556, 0, 6, 0, 0, 222, 64);
INSERT INTO public.who_global_data VALUES (52557, 0, 0, 0, 0, 222, 116);
INSERT INTO public.who_global_data VALUES (52558, 0, 15, 0, 0, 222, 128);
INSERT INTO public.who_global_data VALUES (52559, 0, 19, 0, 0, 222, 6);
INSERT INTO public.who_global_data VALUES (52560, 0, 42, 0, 3, 222, 227);
INSERT INTO public.who_global_data VALUES (52561, 0, 1, 0, 0, 222, 68);
INSERT INTO public.who_global_data VALUES (52562, 0, 29, 0, 0, 222, 184);
INSERT INTO public.who_global_data VALUES (52563, 0, 0, 0, 0, 222, 82);
INSERT INTO public.who_global_data VALUES (52564, 0, 713, 0, 42, 222, 149);
INSERT INTO public.who_global_data VALUES (52565, 0, 393, 0, 11, 222, 197);
INSERT INTO public.who_global_data VALUES (52566, 3989, 182493, 40, 1551, 222, 78);
INSERT INTO public.who_global_data VALUES (52567, 127, 6586, 3, 105, 222, 233);
INSERT INTO public.who_global_data VALUES (52568, 254, 14046, 3, 270, 222, 133);
INSERT INTO public.who_global_data VALUES (52569, 7, 77, 0, 0, 222, 35);
INSERT INTO public.who_global_data VALUES (52570, 17, 1427, 1, 60, 222, 114);
INSERT INTO public.who_global_data VALUES (52571, 213, 43459, 0, 26, 222, 237);
INSERT INTO public.who_global_data VALUES (52572, 0, 2, 0, 0, 222, 55);
INSERT INTO public.who_global_data VALUES (52573, 0, 77, 0, 15, 222, 176);
INSERT INTO public.who_global_data VALUES (52574, 7, 1664, 0, 28, 222, 202);
INSERT INTO public.who_global_data VALUES (52575, 4, 1584, 0, 114, 222, 155);
INSERT INTO public.who_global_data VALUES (52576, 0, 0, 0, 0, 222, 32);
INSERT INTO public.who_global_data VALUES (52577, 16, 2894, 0, 90, 222, 220);
INSERT INTO public.who_global_data VALUES (52578, 6334, 138134, 43, 2456, 222, 30);
INSERT INTO public.who_global_data VALUES (52579, 8, 1966, 0, 36, 222, 147);
INSERT INTO public.who_global_data VALUES (52580, 252, 257409, 3, 29714, 222, 208);
INSERT INTO public.who_global_data VALUES (52581, 4, 2037, 0, 11, 222, 45);
INSERT INTO public.who_global_data VALUES (52582, 6, 9320, 8, 584, 222, 110);
INSERT INTO public.who_global_data VALUES (52583, 76, 467, 1, 11, 222, 88);
INSERT INTO public.who_global_data VALUES (52584, 755, 65919, 14, 5455, 222, 51);
INSERT INTO public.who_global_data VALUES (52585, 24, 31609, 0, 1722, 222, 209);
INSERT INTO public.who_global_data VALUES (52586, 0, 256, 0, 9, 222, 205);
INSERT INTO public.who_global_data VALUES (52587, 50, 5849, 0, 52, 222, 18);
INSERT INTO public.who_global_data VALUES (52588, 7, 3169, 0, 58, 222, 72);
INSERT INTO public.who_global_data VALUES (52589, 649, 283099, 31, 40320, 222, 44);
INSERT INTO public.who_global_data VALUES (52590, 0, 24, 0, 0, 222, 15);
INSERT INTO public.who_global_data VALUES (52591, 0, 615, 0, 14, 222, 25);
INSERT INTO public.who_global_data VALUES (52592, 0, 0, 0, 0, 222, 179);
INSERT INTO public.who_global_data VALUES (52593, 0, 0, 0, 0, 222, 34);
INSERT INTO public.who_global_data VALUES (52594, 2, 126, 0, 8, 222, 207);
INSERT INTO public.who_global_data VALUES (52595, 3, 1172, 0, 50, 222, 166);
INSERT INTO public.who_global_data VALUES (52596, 1356, 197239, 15, 5097, 222, 126);
INSERT INTO public.who_global_data VALUES (52597, 0, 0, 0, 0, 222, 97);
INSERT INTO public.who_global_data VALUES (52598, 0, 16, 0, 1, 222, 36);
INSERT INTO public.who_global_data VALUES (52599, 0, 0, 0, 0, 222, 125);
INSERT INTO public.who_global_data VALUES (52600, 0, 833, 0, 0, 222, 124);
INSERT INTO public.who_global_data VALUES (52601, 646, 43628, 18, 1147, 222, 185);
INSERT INTO public.who_global_data VALUES (52602, 437, 47797, 2, 313, 222, 194);
INSERT INTO public.who_global_data VALUES (52603, 0, 509, 0, 21, 222, 144);
INSERT INTO public.who_global_data VALUES (52604, 44580, 2496628, 507, 125318, 222, 19);
INSERT INTO public.who_global_data VALUES (52605, 0, 81, 0, 6, 222, 217);
INSERT INTO public.who_global_data VALUES (52606, 5, 924, 0, 26, 222, 148);
INSERT INTO public.who_global_data VALUES (52607, 306, 8031, 2, 22, 222, 86);
INSERT INTO public.who_global_data VALUES (52608, 0, 0, 0, 0, 222, 13);
INSERT INTO public.who_global_data VALUES (52609, 351, 5130, 1, 42, 222, 157);
INSERT INTO public.who_global_data VALUES (52610, 0, 355, 0, 0, 222, 8);
INSERT INTO public.who_global_data VALUES (52611, 0, 0, 0, 0, 222, 73);
INSERT INTO public.who_global_data VALUES (52612, 15, 1118, 6, 302, 222, 101);
INSERT INTO public.who_global_data VALUES (52613, 0, 1531, 0, 21, 222, 165);
INSERT INTO public.who_global_data VALUES (52614, 0, 567, -1, 6, 222, 14);
INSERT INTO public.who_global_data VALUES (52615, 351, 31053, 26, 733, 223, 193);
INSERT INTO public.who_global_data VALUES (52616, 72, 2402, 2, 55, 223, 113);
INSERT INTO public.who_global_data VALUES (52617, 283, 12968, 7, 892, 223, 143);
INSERT INTO public.who_global_data VALUES (52618, 0, 0, 0, 0, 223, 219);
INSERT INTO public.who_global_data VALUES (52619, 0, 855, 0, 52, 223, 186);
INSERT INTO public.who_global_data VALUES (52620, 47, 259, 0, 10, 223, 52);
INSERT INTO public.who_global_data VALUES (52621, 0, 3, 0, 0, 223, 180);
INSERT INTO public.who_global_data VALUES (52622, 0, 26, 0, 3, 223, 167);
INSERT INTO public.who_global_data VALUES (52623, 2886, 55343, 25, 1192, 223, 154);
INSERT INTO public.who_global_data VALUES (52624, 736, 23958, 6, 421, 223, 94);
INSERT INTO public.who_global_data VALUES (52625, 0, 101, 0, 3, 223, 66);
INSERT INTO public.who_global_data VALUES (52626, 46, 7641, 0, 104, 223, 58);
INSERT INTO public.who_global_data VALUES (52627, 64, 17562, 2, 700, 223, 163);
INSERT INTO public.who_global_data VALUES (52628, 521, 15890, 6, 193, 223, 37);
INSERT INTO public.who_global_data VALUES (52629, 0, 104, 0, 11, 223, 142);
INSERT INTO public.who_global_data VALUES (52630, 462, 25267, 5, 78, 223, 83);
INSERT INTO public.who_global_data VALUES (52631, 3504, 133978, 34, 1695, 223, 228);
INSERT INTO public.who_global_data VALUES (52632, 0, 97, 0, 7, 223, 188);
INSERT INTO public.who_global_data VALUES (52633, 382, 61095, 4, 377, 223, 62);
INSERT INTO public.who_global_data VALUES (52634, 41, 61833, 8, 9612, 223, 160);
INSERT INTO public.who_global_data VALUES (52635, 1, 24, 0, 2, 223, 50);
INSERT INTO public.who_global_data VALUES (52636, 71, 1124, 0, 14, 223, 33);
INSERT INTO public.who_global_data VALUES (52637, 0, 146, 0, 9, 223, 183);
INSERT INTO public.who_global_data VALUES (52638, 6, 76, 0, 0, 223, 92);
INSERT INTO public.who_global_data VALUES (52639, 920, 29423, 21, 934, 223, 158);
INSERT INTO public.who_global_data VALUES (52640, 0, 2, 0, 0, 223, 67);
INSERT INTO public.who_global_data VALUES (52641, 173, 4107, 2, 179, 223, 57);
INSERT INTO public.who_global_data VALUES (52642, 0, 125, 0, 1, 223, 38);
INSERT INTO public.who_global_data VALUES (52643, 46860, 1274974, 990, 55961, 223, 141);
INSERT INTO public.who_global_data VALUES (52644, 0, 8, 0, 1, 223, 178);
INSERT INTO public.who_global_data VALUES (52645, 0, 141, 0, 3, 223, 108);
INSERT INTO public.who_global_data VALUES (52646, 112, 4625, 1, 216, 223, 39);
INSERT INTO public.who_global_data VALUES (52647, 20, 954, 0, 53, 223, 2);
INSERT INTO public.who_global_data VALUES (52648, 0, 144, 0, 1, 223, 195);
INSERT INTO public.who_global_data VALUES (52649, 64, 1091, 2, 12, 223, 107);
INSERT INTO public.who_global_data VALUES (52650, 0, 139, 0, 0, 223, 161);
INSERT INTO public.who_global_data VALUES (52651, 0, 12592, 0, 313, 223, 212);
INSERT INTO public.who_global_data VALUES (52652, 172, 102794, 4, 8508, 223, 181);
INSERT INTO public.who_global_data VALUES (52653, 0, 196, 0, 1, 223, 53);
INSERT INTO public.who_global_data VALUES (52654, 0, 3340, 0, 40, 223, 164);
INSERT INTO public.who_global_data VALUES (52655, 0, 865, 0, 74, 223, 140);
INSERT INTO public.who_global_data VALUES (52656, 4406, 267766, 279, 5347, 223, 20);
INSERT INTO public.who_global_data VALUES (52657, 18, 85190, 0, 4648, 223, 112);
INSERT INTO public.who_global_data VALUES (52658, 3843, 84442, 157, 2811, 223, 111);
INSERT INTO public.who_global_data VALUES (52659, 0, 272, 0, 7, 223, 71);
INSERT INTO public.who_global_data VALUES (52660, 41, 1245, 2, 40, 223, 218);
INSERT INTO public.who_global_data VALUES (52661, 0, 0, 0, 0, 223, 43);
INSERT INTO public.who_global_data VALUES (52662, 152, 2836, 0, 12, 223, 49);
INSERT INTO public.who_global_data VALUES (52663, 205, 8944, 2, 66, 223, 1);
INSERT INTO public.who_global_data VALUES (52664, 85, 2624, 0, 107, 223, 48);
INSERT INTO public.who_global_data VALUES (52665, 5, 2330, 1, 86, 223, 232);
INSERT INTO public.who_global_data VALUES (52666, 0, 23, 0, 1, 223, 175);
INSERT INTO public.who_global_data VALUES (52667, 2, 994, 0, 19, 223, 21);
INSERT INTO public.who_global_data VALUES (52668, 260, 11298, 2, 347, 223, 156);
INSERT INTO public.who_global_data VALUES (52669, 0, 0, 0, 0, 223, 95);
INSERT INTO public.who_global_data VALUES (52670, 138, 6689, 4, 152, 223, 177);
INSERT INTO public.who_global_data VALUES (52671, 0, 12675, 0, 604, 223, 210);
INSERT INTO public.who_global_data VALUES (52672, 0, 4643, 0, 52, 223, 120);
INSERT INTO public.who_global_data VALUES (52673, 0, 18, 0, 0, 223, 135);
INSERT INTO public.who_global_data VALUES (52674, 855, 30619, 6, 718, 223, 206);
INSERT INTO public.who_global_data VALUES (52675, 718, 54574, 18, 4424, 223, 189);
INSERT INTO public.who_global_data VALUES (52676, 1168, 63923, 88, 2708, 223, 129);
INSERT INTO public.who_global_data VALUES (52677, 210, 5727, 10, 143, 223, 121);
INSERT INTO public.who_global_data VALUES (52678, 0, 1043, 0, 12, 223, 59);
INSERT INTO public.who_global_data VALUES (52679, 24, 191, 0, 0, 223, 96);
INSERT INTO public.who_global_data VALUES (52680, 0, 1986, 0, 63, 223, 41);
INSERT INTO public.who_global_data VALUES (52681, 14, 745, 0, 8, 223, 216);
INSERT INTO public.who_global_data VALUES (52682, 145, 5570, 5, 94, 223, 236);
INSERT INTO public.who_global_data VALUES (52683, 0, 13, 0, 0, 223, 150);
INSERT INTO public.who_global_data VALUES (52684, 0, 187, 0, 0, 223, 61);
INSERT INTO public.who_global_data VALUES (52685, 0, 18, 0, 0, 223, 7);
INSERT INTO public.who_global_data VALUES (52686, 0, 7191, 0, 328, 223, 169);
INSERT INTO public.who_global_data VALUES (52687, 0, 156156, 0, 29700, 223, 28);
INSERT INTO public.who_global_data VALUES (52688, 191, 3461, 1, 12, 223, 85);
INSERT INTO public.who_global_data VALUES (52689, 2, 62, 0, 0, 223, 211);
INSERT INTO public.who_global_data VALUES (52690, 0, 5209, 0, 40, 223, 60);
INSERT INTO public.who_global_data VALUES (52691, 1, 45, 0, 2, 223, 3);
INSERT INTO public.who_global_data VALUES (52692, 3, 924, 1, 15, 223, 11);
INSERT INTO public.who_global_data VALUES (52693, 256, 193499, 3, 8957, 223, 89);
INSERT INTO public.who_global_data VALUES (52694, 597, 16431, 0, 103, 223, 24);
INSERT INTO public.who_global_data VALUES (52695, 0, 176, 0, 0, 223, 162);
INSERT INTO public.who_global_data VALUES (52696, 23, 3366, 0, 191, 223, 100);
INSERT INTO public.who_global_data VALUES (52697, 0, 13, 0, 0, 223, 47);
INSERT INTO public.who_global_data VALUES (52698, 0, 23, 0, 0, 223, 29);
INSERT INTO public.who_global_data VALUES (52699, 0, 182, 0, 14, 223, 40);
INSERT INTO public.who_global_data VALUES (52700, 0, 240, 0, 5, 223, 222);
INSERT INTO public.who_global_data VALUES (52701, 209, 15828, 49, 672, 223, 132);
INSERT INTO public.who_global_data VALUES (52702, 0, 252, 0, 13, 223, 130);
INSERT INTO public.who_global_data VALUES (52703, 31, 5291, 1, 30, 223, 234);
INSERT INTO public.who_global_data VALUES (52704, 58, 1614, 2, 21, 223, 23);
INSERT INTO public.who_global_data VALUES (52705, 15, 230, 0, 12, 223, 192);
INSERT INTO public.who_global_data VALUES (52706, 179, 5722, 2, 98, 223, 69);
INSERT INTO public.who_global_data VALUES (52707, 0, 12, 0, 0, 223, 187);
INSERT INTO public.who_global_data VALUES (52708, 628, 15994, 45, 471, 223, 230);
INSERT INTO public.who_global_data VALUES (52709, 11, 4138, 0, 578, 223, 77);
INSERT INTO public.who_global_data VALUES (52710, 0, 1820, 0, 10, 223, 9);
INSERT INTO public.who_global_data VALUES (52711, 19906, 528859, 410, 16095, 223, 74);
INSERT INTO public.who_global_data VALUES (52712, 1385, 52812, 37, 2720, 223, 224);
INSERT INTO public.who_global_data VALUES (52713, 2456, 220180, 125, 10364, 223, 199);
INSERT INTO public.who_global_data VALUES (52714, 2069, 43262, 101, 1660, 223, 190);
INSERT INTO public.who_global_data VALUES (52715, 23, 25437, 4, 1734, 223, 12);
INSERT INTO public.who_global_data VALUES (52716, 0, 336, 0, 24, 223, 104);
INSERT INTO public.who_global_data VALUES (52717, 464, 23120, 3, 321, 223, 153);
INSERT INTO public.who_global_data VALUES (52718, 175, 240136, 8, 34716, 223, 91);
INSERT INTO public.who_global_data VALUES (52719, 2, 686, 0, 10, 223, 215);
INSERT INTO public.who_global_data VALUES (52720, 93, 18390, 0, 971, 223, 84);
INSERT INTO public.who_global_data VALUES (52721, 0, 320, 0, 31, 223, 231);
INSERT INTO public.who_global_data VALUES (52722, 6, 1036, 0, 9, 223, 196);
INSERT INTO public.who_global_data VALUES (52723, 1613, 29676, 10, 183, 223, 105);
INSERT INTO public.who_global_data VALUES (52724, 278, 5811, 4, 141, 223, 122);
INSERT INTO public.who_global_data VALUES (52725, 0, 0, 0, 0, 223, 159);
INSERT INTO public.who_global_data VALUES (52726, 96, 2547, 3, 37, 223, 75);
INSERT INTO public.who_global_data VALUES (52727, 688, 44391, 3, 344, 223, 27);
INSERT INTO public.who_global_data VALUES (52728, 0, 4513, 0, 46, 223, 54);
INSERT INTO public.who_global_data VALUES (52729, 0, 19, 0, 0, 223, 226);
INSERT INTO public.who_global_data VALUES (52730, 3, 1115, 0, 30, 223, 79);
INSERT INTO public.who_global_data VALUES (52731, 22, 1719, 0, 33, 223, 56);
INSERT INTO public.who_global_data VALUES (52732, 0, 24, 0, 0, 223, 117);
INSERT INTO public.who_global_data VALUES (52733, 0, 684, 0, 34, 223, 152);
INSERT INTO public.who_global_data VALUES (52734, 14, 727, 0, 18, 223, 16);
INSERT INTO public.who_global_data VALUES (52735, 0, 83, 0, 1, 223, 10);
INSERT INTO public.who_global_data VALUES (52736, 2, 1810, 0, 78, 223, 201);
INSERT INTO public.who_global_data VALUES (52737, 44, 4217, 0, 110, 223, 174);
INSERT INTO public.who_global_data VALUES (52738, 176, 2005, 0, 16, 223, 119);
INSERT INTO public.who_global_data VALUES (52739, 33, 1038, 0, 13, 223, 168);
INSERT INTO public.who_global_data VALUES (52740, 10, 8616, 0, 121, 223, 99);
INSERT INTO public.who_global_data VALUES (52741, 22, 2305, 0, 8, 223, 171);
INSERT INTO public.who_global_data VALUES (52742, 0, 2060, 0, 113, 223, 87);
INSERT INTO public.who_global_data VALUES (52743, 0, 669, 0, 9, 223, 123);
INSERT INTO public.who_global_data VALUES (52744, 0, 0, 0, 0, 223, 151);
INSERT INTO public.who_global_data VALUES (52745, 6, 242, 0, 14, 223, 213);
INSERT INTO public.who_global_data VALUES (52746, 168, 3907, 1, 120, 223, 118);
INSERT INTO public.who_global_data VALUES (52747, 0, 341, 0, 10, 223, 134);
INSERT INTO public.who_global_data VALUES (52748, 14, 2540, 1, 35, 223, 65);
INSERT INTO public.who_global_data VALUES (52749, 5441, 208392, 719, 25779, 223, 102);
INSERT INTO public.who_global_data VALUES (52750, 0, 0, 0, 0, 223, 223);
INSERT INTO public.who_global_data VALUES (52751, 1, 73, 0, 1, 223, 4);
INSERT INTO public.who_global_data VALUES (52752, 0, 219, 0, 0, 223, 146);
INSERT INTO public.who_global_data VALUES (52753, 23, 498, 2, 12, 223, 31);
INSERT INTO public.who_global_data VALUES (52754, 0, 11, 0, 1, 223, 127);
INSERT INTO public.who_global_data VALUES (52755, 244, 11877, 2, 220, 223, 22);
INSERT INTO public.who_global_data VALUES (52756, 51, 839, 0, 5, 223, 115);
INSERT INTO public.who_global_data VALUES (52757, 3, 296, 0, 6, 223, 106);
INSERT INTO public.who_global_data VALUES (52758, 34, 136, 0, 0, 223, 90);
INSERT INTO public.who_global_data VALUES (52759, 0, 0, 0, 0, 223, 70);
INSERT INTO public.who_global_data VALUES (52760, 554, 12309, 1, 28, 223, 46);
INSERT INTO public.who_global_data VALUES (52761, 77, 49860, 3, 6079, 223, 139);
INSERT INTO public.who_global_data VALUES (52762, 0, 21, 0, 0, 223, 42);
INSERT INTO public.who_global_data VALUES (52763, 4, 1176, 0, 22, 223, 80);
INSERT INTO public.who_global_data VALUES (52764, 0, 2014, 0, 74, 223, 203);
INSERT INTO public.who_global_data VALUES (52765, 0, 1059, 0, 67, 223, 136);
INSERT INTO public.who_global_data VALUES (52766, 779, 24077, 4, 558, 223, 63);
INSERT INTO public.who_global_data VALUES (52767, 0, 0, 0, 0, 223, 17);
INSERT INTO public.who_global_data VALUES (52768, 0, 30, 0, 2, 223, 172);
INSERT INTO public.who_global_data VALUES (52769, 148, 5906, 9, 277, 223, 109);
INSERT INTO public.who_global_data VALUES (52770, 0, 8815, 0, 249, 223, 200);
INSERT INTO public.who_global_data VALUES (52771, 258, 2053, 2, 7, 223, 93);
INSERT INTO public.who_global_data VALUES (52772, 919, 36953, 6, 159, 223, 5);
INSERT INTO public.who_global_data VALUES (52773, 0, 741, 0, 13, 223, 214);
INSERT INTO public.who_global_data VALUES (52774, 4072, 202955, 83, 4118, 223, 204);
INSERT INTO public.who_global_data VALUES (52775, 0, 0, 0, 0, 223, 198);
INSERT INTO public.who_global_data VALUES (52776, 868, 29905, 11, 575, 223, 173);
INSERT INTO public.who_global_data VALUES (52777, 0, 11, 0, 0, 223, 229);
INSERT INTO public.who_global_data VALUES (52778, 0, 1711, 0, 13, 223, 76);
INSERT INTO public.who_global_data VALUES (52779, 3762, 272364, 178, 8939, 223, 138);
INSERT INTO public.who_global_data VALUES (52780, 730, 34803, 12, 1236, 223, 98);
INSERT INTO public.who_global_data VALUES (52781, 0, 0, 0, 0, 223, 103);
INSERT INTO public.who_global_data VALUES (52782, 319, 33714, 6, 1435, 223, 225);
INSERT INTO public.who_global_data VALUES (52783, 323, 41189, 6, 1561, 223, 131);
INSERT INTO public.who_global_data VALUES (52784, 144, 7066, 1, 152, 223, 235);
INSERT INTO public.who_global_data VALUES (52785, 879, 93663, 1, 110, 223, 137);
INSERT INTO public.who_global_data VALUES (52786, 62, 12715, 0, 282, 223, 81);
INSERT INTO public.who_global_data VALUES (52787, 304, 16080, 11, 526, 223, 182);
INSERT INTO public.who_global_data VALUES (52788, 3, 520, 0, 2, 223, 145);
INSERT INTO public.who_global_data VALUES (52789, 325, 26022, 10, 1589, 223, 26);
INSERT INTO public.who_global_data VALUES (52790, 6791, 634437, 104, 9073, 223, 170);
INSERT INTO public.who_global_data VALUES (52791, 20, 878, 0, 2, 223, 191);
INSERT INTO public.who_global_data VALUES (52792, 0, 3, 0, 0, 223, 221);
INSERT INTO public.who_global_data VALUES (52793, 0, 6, 0, 0, 223, 64);
INSERT INTO public.who_global_data VALUES (52794, 0, 0, 0, 0, 223, 116);
INSERT INTO public.who_global_data VALUES (52795, 0, 15, 0, 0, 223, 128);
INSERT INTO public.who_global_data VALUES (52796, 0, 19, 0, 0, 223, 6);
INSERT INTO public.who_global_data VALUES (52797, 0, 42, 0, 3, 223, 227);
INSERT INTO public.who_global_data VALUES (52798, 0, 1, 0, 0, 223, 68);
INSERT INTO public.who_global_data VALUES (52799, 0, 29, 0, 0, 223, 184);
INSERT INTO public.who_global_data VALUES (52800, 0, 0, 0, 0, 223, 82);
INSERT INTO public.who_global_data VALUES (52801, 0, 713, 0, 42, 223, 149);
INSERT INTO public.who_global_data VALUES (52802, 1, 393, 0, 11, 223, 197);
INSERT INTO public.who_global_data VALUES (52803, 3927, 178504, 37, 1511, 223, 78);
INSERT INTO public.who_global_data VALUES (52804, 105, 6459, 4, 102, 223, 233);
INSERT INTO public.who_global_data VALUES (52805, 227, 13792, 2, 267, 223, 133);
INSERT INTO public.who_global_data VALUES (52806, 50, 70, 0, 0, 223, 35);
INSERT INTO public.who_global_data VALUES (52807, 16, 1410, 0, 59, 223, 114);
INSERT INTO public.who_global_data VALUES (52808, 291, 43246, 0, 26, 223, 237);
INSERT INTO public.who_global_data VALUES (52809, 0, 2, 0, 0, 223, 55);
INSERT INTO public.who_global_data VALUES (52810, 0, 77, 0, 15, 223, 176);
INSERT INTO public.who_global_data VALUES (52811, 14, 1657, 0, 28, 223, 202);
INSERT INTO public.who_global_data VALUES (52812, 9, 1580, 0, 114, 223, 155);
INSERT INTO public.who_global_data VALUES (52813, 0, 0, 0, 0, 223, 32);
INSERT INTO public.who_global_data VALUES (52814, 0, 2878, 0, 90, 223, 220);
INSERT INTO public.who_global_data VALUES (52815, 7210, 131800, 73, 2413, 223, 30);
INSERT INTO public.who_global_data VALUES (52816, 6, 1958, 0, 36, 223, 147);
INSERT INTO public.who_global_data VALUES (52817, 525, 257157, 8, 29711, 223, 208);
INSERT INTO public.who_global_data VALUES (52818, 19, 2033, 0, 11, 223, 45);
INSERT INTO public.who_global_data VALUES (52819, 57, 9314, 4, 576, 223, 110);
INSERT INTO public.who_global_data VALUES (52820, 18, 391, 0, 10, 223, 88);
INSERT INTO public.who_global_data VALUES (52821, 1204, 65164, 11, 5441, 223, 51);
INSERT INTO public.who_global_data VALUES (52822, 36, 31585, 0, 1722, 223, 209);
INSERT INTO public.who_global_data VALUES (52823, 2, 256, 2, 9, 223, 205);
INSERT INTO public.who_global_data VALUES (52824, 52, 5799, 0, 52, 223, 18);
INSERT INTO public.who_global_data VALUES (52825, 0, 3162, 0, 58, 223, 72);
INSERT INTO public.who_global_data VALUES (52826, 671, 282450, 40, 40289, 223, 44);
INSERT INTO public.who_global_data VALUES (52827, 0, 24, 0, 0, 223, 15);
INSERT INTO public.who_global_data VALUES (52828, 24, 615, 0, 14, 223, 25);
INSERT INTO public.who_global_data VALUES (52829, 0, 0, 0, 0, 223, 179);
INSERT INTO public.who_global_data VALUES (52830, 0, 0, 0, 0, 223, 34);
INSERT INTO public.who_global_data VALUES (52831, 1, 124, 0, 8, 223, 207);
INSERT INTO public.who_global_data VALUES (52832, 1, 1169, 0, 50, 223, 166);
INSERT INTO public.who_global_data VALUES (52833, 1372, 195883, 17, 5082, 223, 126);
INSERT INTO public.who_global_data VALUES (52834, 0, 0, 0, 0, 223, 97);
INSERT INTO public.who_global_data VALUES (52835, 0, 16, 0, 1, 223, 36);
INSERT INTO public.who_global_data VALUES (52836, 0, 0, 0, 0, 223, 125);
INSERT INTO public.who_global_data VALUES (52837, 0, 833, 0, 0, 223, 124);
INSERT INTO public.who_global_data VALUES (52838, 917, 42982, 19, 1129, 223, 185);
INSERT INTO public.who_global_data VALUES (52839, 387, 47360, 1, 311, 223, 194);
INSERT INTO public.who_global_data VALUES (52840, 0, 509, 0, 21, 223, 144);
INSERT INTO public.who_global_data VALUES (52841, 44458, 2452048, 650, 124811, 223, 19);
INSERT INTO public.who_global_data VALUES (52842, 0, 81, 0, 6, 223, 217);
INSERT INTO public.who_global_data VALUES (52843, 12, 919, 0, 26, 223, 148);
INSERT INTO public.who_global_data VALUES (52844, 235, 7725, 0, 20, 223, 86);
INSERT INTO public.who_global_data VALUES (52845, 0, 0, 0, 0, 223, 13);
INSERT INTO public.who_global_data VALUES (52846, 216, 4779, 2, 41, 223, 157);
INSERT INTO public.who_global_data VALUES (52847, 2, 355, 0, 0, 223, 8);
INSERT INTO public.who_global_data VALUES (52848, 0, 0, 0, 0, 223, 73);
INSERT INTO public.who_global_data VALUES (52849, 14, 1103, 3, 296, 223, 101);
INSERT INTO public.who_global_data VALUES (52850, 0, 1531, 0, 21, 223, 165);
INSERT INTO public.who_global_data VALUES (52851, 6, 567, 0, 7, 223, 14);
INSERT INTO public.who_global_data VALUES (52852, 356, 30702, 23, 707, 224, 193);
INSERT INTO public.who_global_data VALUES (52853, 61, 2330, 2, 53, 224, 113);
INSERT INTO public.who_global_data VALUES (52854, 240, 12685, 7, 885, 224, 143);
INSERT INTO public.who_global_data VALUES (52855, 0, 0, 0, 0, 224, 219);
INSERT INTO public.who_global_data VALUES (52856, 0, 855, 0, 52, 224, 186);
INSERT INTO public.who_global_data VALUES (52857, 0, 212, 0, 10, 224, 52);
INSERT INTO public.who_global_data VALUES (52858, 0, 3, 0, 0, 224, 180);
INSERT INTO public.who_global_data VALUES (52859, 0, 26, 0, 3, 224, 167);
INSERT INTO public.who_global_data VALUES (52860, 2606, 52457, 43, 1167, 224, 154);
INSERT INTO public.who_global_data VALUES (52861, 662, 23222, 10, 415, 224, 94);
INSERT INTO public.who_global_data VALUES (52862, 0, 101, 0, 3, 224, 66);
INSERT INTO public.who_global_data VALUES (52863, 37, 7595, 0, 104, 224, 58);
INSERT INTO public.who_global_data VALUES (52864, 67, 17498, 0, 698, 224, 163);
INSERT INTO public.who_global_data VALUES (52865, 517, 15369, 7, 187, 224, 37);
INSERT INTO public.who_global_data VALUES (52866, 0, 104, 0, 11, 224, 142);
INSERT INTO public.who_global_data VALUES (52867, 724, 24805, 2, 73, 224, 83);
INSERT INTO public.who_global_data VALUES (52868, 3868, 130474, 40, 1661, 224, 228);
INSERT INTO public.who_global_data VALUES (52869, 0, 97, 0, 7, 224, 188);
INSERT INTO public.who_global_data VALUES (52870, 331, 60713, 6, 373, 224, 62);
INSERT INTO public.who_global_data VALUES (52871, 113, 61792, 2, 9604, 224, 160);
INSERT INTO public.who_global_data VALUES (52872, 0, 23, 0, 2, 224, 50);
INSERT INTO public.who_global_data VALUES (52873, 36, 1053, 0, 14, 224, 33);
INSERT INTO public.who_global_data VALUES (52874, 0, 146, 0, 9, 224, 183);
INSERT INTO public.who_global_data VALUES (52875, 0, 70, 0, 0, 224, 92);
INSERT INTO public.who_global_data VALUES (52876, 1016, 28503, 37, 913, 224, 158);
INSERT INTO public.who_global_data VALUES (52877, 0, 2, 0, 0, 224, 67);
INSERT INTO public.who_global_data VALUES (52878, 140, 3934, 3, 177, 224, 57);
INSERT INTO public.who_global_data VALUES (52879, 0, 125, 0, 1, 224, 38);
INSERT INTO public.who_global_data VALUES (52880, 39483, 1228114, 1141, 54971, 224, 141);
INSERT INTO public.who_global_data VALUES (52881, 0, 8, 0, 1, 224, 178);
INSERT INTO public.who_global_data VALUES (52882, 0, 141, 0, 3, 224, 108);
INSERT INTO public.who_global_data VALUES (52883, 105, 4513, 4, 215, 224, 39);
INSERT INTO public.who_global_data VALUES (52884, 0, 934, 0, 53, 224, 2);
INSERT INTO public.who_global_data VALUES (52885, 0, 144, 0, 1, 224, 195);
INSERT INTO public.who_global_data VALUES (52886, 24, 1027, 2, 10, 224, 107);
INSERT INTO public.who_global_data VALUES (52887, 9, 139, 0, 0, 224, 161);
INSERT INTO public.who_global_data VALUES (52888, 0, 12592, 0, 313, 224, 212);
INSERT INTO public.who_global_data VALUES (52889, 380, 102622, 20, 8504, 224, 181);
INSERT INTO public.who_global_data VALUES (52890, 0, 196, 0, 1, 224, 53);
INSERT INTO public.who_global_data VALUES (52891, 96, 3340, 0, 40, 224, 164);
INSERT INTO public.who_global_data VALUES (52892, 2, 865, 0, 74, 224, 140);
INSERT INTO public.who_global_data VALUES (52893, 4296, 263360, 165, 5068, 224, 20);
INSERT INTO public.who_global_data VALUES (52894, 24, 85172, 0, 4648, 224, 112);
INSERT INTO public.who_global_data VALUES (52895, 3486, 80599, 163, 2654, 224, 111);
INSERT INTO public.who_global_data VALUES (52896, 0, 272, 0, 7, 224, 71);
INSERT INTO public.who_global_data VALUES (52897, 0, 1204, 0, 38, 224, 218);
INSERT INTO public.who_global_data VALUES (52898, 0, 0, 0, 0, 224, 43);
INSERT INTO public.who_global_data VALUES (52899, 169, 2684, 0, 12, 224, 49);
INSERT INTO public.who_global_data VALUES (52900, 405, 8739, 4, 64, 224, 1);
INSERT INTO public.who_global_data VALUES (52901, 56, 2539, 0, 107, 224, 48);
INSERT INTO public.who_global_data VALUES (52902, 4, 2325, 0, 85, 224, 232);
INSERT INTO public.who_global_data VALUES (52903, -1, 23, 0, 1, 224, 175);
INSERT INTO public.who_global_data VALUES (52904, 0, 992, 0, 19, 224, 21);
INSERT INTO public.who_global_data VALUES (52905, 168, 11038, 0, 345, 224, 156);
INSERT INTO public.who_global_data VALUES (52906, 0, 0, 0, 0, 224, 95);
INSERT INTO public.who_global_data VALUES (52907, 141, 6551, 7, 148, 224, 177);
INSERT INTO public.who_global_data VALUES (52908, 39, 12675, 1, 604, 224, 210);
INSERT INTO public.who_global_data VALUES (52909, 8, 4643, 0, 52, 224, 120);
INSERT INTO public.who_global_data VALUES (52910, 0, 18, 0, 0, 224, 135);
INSERT INTO public.who_global_data VALUES (52911, 623, 29764, 14, 712, 224, 206);
INSERT INTO public.who_global_data VALUES (52912, 700, 53856, 63, 4406, 224, 189);
INSERT INTO public.who_global_data VALUES (52913, 1625, 62755, 87, 2620, 224, 129);
INSERT INTO public.who_global_data VALUES (52914, 181, 5517, 7, 133, 224, 121);
INSERT INTO public.who_global_data VALUES (52915, 0, 1043, 0, 12, 224, 59);
INSERT INTO public.who_global_data VALUES (52916, 23, 167, 0, 0, 224, 96);
INSERT INTO public.who_global_data VALUES (52917, 2, 1986, 0, 63, 224, 41);
INSERT INTO public.who_global_data VALUES (52918, 25, 731, 0, 8, 224, 216);
INSERT INTO public.who_global_data VALUES (52919, 250, 5425, 8, 89, 224, 236);
INSERT INTO public.who_global_data VALUES (52920, 0, 13, 0, 0, 224, 150);
INSERT INTO public.who_global_data VALUES (52921, 0, 187, 0, 0, 224, 61);
INSERT INTO public.who_global_data VALUES (52922, 0, 18, 0, 0, 224, 7);
INSERT INTO public.who_global_data VALUES (52923, 19, 7191, 1, 328, 224, 169);
INSERT INTO public.who_global_data VALUES (52924, 900, 156156, 25, 29700, 224, 28);
INSERT INTO public.who_global_data VALUES (52925, 237, 3270, 1, 11, 224, 85);
INSERT INTO public.who_global_data VALUES (52926, 0, 60, 0, 0, 224, 211);
INSERT INTO public.who_global_data VALUES (52927, 122, 5209, 0, 40, 224, 60);
INSERT INTO public.who_global_data VALUES (52928, 1, 44, 0, 2, 224, 3);
INSERT INTO public.who_global_data VALUES (52929, 2, 921, 0, 14, 224, 11);
INSERT INTO public.who_global_data VALUES (52930, 687, 193243, 6, 8954, 224, 89);
INSERT INTO public.who_global_data VALUES (52931, 361, 15834, 8, 103, 224, 24);
INSERT INTO public.who_global_data VALUES (52932, 0, 176, 0, 0, 224, 162);
INSERT INTO public.who_global_data VALUES (52933, 22, 3343, 0, 191, 224, 100);
INSERT INTO public.who_global_data VALUES (52934, 0, 13, 0, 0, 224, 47);
INSERT INTO public.who_global_data VALUES (52935, 0, 23, 0, 0, 224, 29);
INSERT INTO public.who_global_data VALUES (52936, 8, 182, 0, 14, 224, 40);
INSERT INTO public.who_global_data VALUES (52937, 3, 240, 0, 5, 224, 222);
INSERT INTO public.who_global_data VALUES (52938, 800, 15619, 22, 623, 224, 132);
INSERT INTO public.who_global_data VALUES (52939, 0, 252, 0, 13, 224, 130);
INSERT INTO public.who_global_data VALUES (52940, 49, 5260, 0, 29, 224, 234);
INSERT INTO public.who_global_data VALUES (52941, 0, 1556, 0, 19, 224, 23);
INSERT INTO public.who_global_data VALUES (52942, 6, 215, 0, 12, 224, 192);
INSERT INTO public.who_global_data VALUES (52943, 114, 5543, 4, 96, 224, 69);
INSERT INTO public.who_global_data VALUES (52944, 0, 12, 0, 0, 224, 187);
INSERT INTO public.who_global_data VALUES (52945, 795, 15366, 9, 426, 224, 230);
INSERT INTO public.who_global_data VALUES (52946, 4, 4127, 1, 578, 224, 77);
INSERT INTO public.who_global_data VALUES (52947, 2, 1820, 0, 10, 224, 9);
INSERT INTO public.who_global_data VALUES (52948, 18552, 508953, 384, 15685, 224, 74);
INSERT INTO public.who_global_data VALUES (52949, 1240, 51427, 63, 2683, 224, 224);
INSERT INTO public.who_global_data VALUES (52950, 2628, 217724, 109, 10239, 224, 199);
INSERT INTO public.who_global_data VALUES (52951, 2054, 41193, 122, 1559, 224, 190);
INSERT INTO public.who_global_data VALUES (52952, 9, 25414, 3, 1730, 224, 12);
INSERT INTO public.who_global_data VALUES (52953, 0, 336, 0, 24, 224, 104);
INSERT INTO public.who_global_data VALUES (52954, 516, 22656, 4, 318, 224, 153);
INSERT INTO public.who_global_data VALUES (52955, 255, 239961, 30, 34708, 224, 91);
INSERT INTO public.who_global_data VALUES (52956, 6, 684, 0, 10, 224, 215);
INSERT INTO public.who_global_data VALUES (52957, 100, 18297, 2, 971, 224, 84);
INSERT INTO public.who_global_data VALUES (52958, 0, 320, 0, 31, 224, 231);
INSERT INTO public.who_global_data VALUES (52959, 17, 1030, 0, 9, 224, 196);
INSERT INTO public.who_global_data VALUES (52960, 1486, 28063, 15, 173, 224, 105);
INSERT INTO public.who_global_data VALUES (52961, 149, 5533, 5, 137, 224, 122);
INSERT INTO public.who_global_data VALUES (52962, 0, 0, 0, 0, 224, 159);
INSERT INTO public.who_global_data VALUES (52963, 62, 2451, 3, 34, 224, 75);
INSERT INTO public.who_global_data VALUES (52964, 915, 43703, 2, 341, 224, 27);
INSERT INTO public.who_global_data VALUES (52965, 309, 4513, 3, 46, 224, 54);
INSERT INTO public.who_global_data VALUES (52966, 0, 19, 0, 0, 224, 226);
INSERT INTO public.who_global_data VALUES (52967, 1, 1112, 0, 30, 224, 79);
INSERT INTO public.who_global_data VALUES (52968, 35, 1697, 0, 33, 224, 56);
INSERT INTO public.who_global_data VALUES (52969, 4, 24, 0, 0, 224, 117);
INSERT INTO public.who_global_data VALUES (52970, 3, 684, 0, 34, 224, 152);
INSERT INTO public.who_global_data VALUES (52971, 15, 713, 0, 18, 224, 16);
INSERT INTO public.who_global_data VALUES (52972, 0, 83, 0, 1, 224, 10);
INSERT INTO public.who_global_data VALUES (52973, 5, 1808, 0, 78, 224, 201);
INSERT INTO public.who_global_data VALUES (52974, 22, 4173, 0, 110, 224, 174);
INSERT INTO public.who_global_data VALUES (52975, 0, 1829, 0, 16, 224, 119);
INSERT INTO public.who_global_data VALUES (52976, 45, 1005, 1, 13, 224, 168);
INSERT INTO public.who_global_data VALUES (52977, 6, 8606, 0, 121, 224, 99);
INSERT INTO public.who_global_data VALUES (52978, 6, 2283, 0, 8, 224, 171);
INSERT INTO public.who_global_data VALUES (52979, 21, 2060, 0, 113, 224, 87);
INSERT INTO public.who_global_data VALUES (52980, 0, 669, 0, 9, 224, 123);
INSERT INTO public.who_global_data VALUES (52981, 0, 0, 0, 0, 224, 151);
INSERT INTO public.who_global_data VALUES (52982, 0, 236, 0, 14, 224, 213);
INSERT INTO public.who_global_data VALUES (52983, 220, 3739, 3, 119, 224, 118);
INSERT INTO public.who_global_data VALUES (52984, 0, 341, 0, 10, 224, 134);
INSERT INTO public.who_global_data VALUES (52985, 18, 2526, 0, 34, 224, 65);
INSERT INTO public.who_global_data VALUES (52986, 6104, 202951, 736, 25060, 224, 102);
INSERT INTO public.who_global_data VALUES (52987, 0, 0, 0, 0, 224, 223);
INSERT INTO public.who_global_data VALUES (52988, 0, 72, 0, 1, 224, 4);
INSERT INTO public.who_global_data VALUES (52989, 3, 219, 0, 0, 224, 146);
INSERT INTO public.who_global_data VALUES (52990, 26, 475, 1, 10, 224, 31);
INSERT INTO public.who_global_data VALUES (52991, 0, 11, 0, 1, 224, 127);
INSERT INTO public.who_global_data VALUES (52992, 295, 11633, 1, 218, 224, 22);
INSERT INTO public.who_global_data VALUES (52993, 0, 788, 0, 5, 224, 115);
INSERT INTO public.who_global_data VALUES (52994, 0, 293, 0, 6, 224, 106);
INSERT INTO public.who_global_data VALUES (52995, 0, 102, 0, 0, 224, 90);
INSERT INTO public.who_global_data VALUES (52996, 0, 0, 0, 0, 224, 70);
INSERT INTO public.who_global_data VALUES (52997, 593, 11755, 1, 27, 224, 46);
INSERT INTO public.who_global_data VALUES (52998, 93, 49783, 2, 6076, 224, 139);
INSERT INTO public.who_global_data VALUES (52999, 0, 21, 0, 0, 224, 42);
INSERT INTO public.who_global_data VALUES (53000, 2, 1172, 0, 22, 224, 80);
INSERT INTO public.who_global_data VALUES (53001, 0, 2014, 0, 74, 224, 203);
INSERT INTO public.who_global_data VALUES (53002, 0, 1059, 0, 67, 224, 136);
INSERT INTO public.who_global_data VALUES (53003, 684, 23298, 5, 554, 224, 63);
INSERT INTO public.who_global_data VALUES (53004, 0, 0, 0, 0, 224, 17);
INSERT INTO public.who_global_data VALUES (53005, 0, 30, 0, 2, 224, 172);
INSERT INTO public.who_global_data VALUES (53006, 155, 5758, 3, 268, 224, 109);
INSERT INTO public.who_global_data VALUES (53007, 22, 8815, 0, 249, 224, 200);
INSERT INTO public.who_global_data VALUES (53008, 207, 1795, 0, 5, 224, 93);
INSERT INTO public.who_global_data VALUES (53009, 1132, 36034, 9, 153, 224, 5);
INSERT INTO public.who_global_data VALUES (53010, 0, 741, 0, 13, 224, 214);
INSERT INTO public.who_global_data VALUES (53011, 3138, 198883, 73, 4035, 224, 204);
INSERT INTO public.who_global_data VALUES (53012, 0, 0, 0, 0, 224, 198);
INSERT INTO public.who_global_data VALUES (53013, 1007, 29037, 17, 564, 224, 173);
INSERT INTO public.who_global_data VALUES (53014, 0, 11, 0, 0, 224, 229);
INSERT INTO public.who_global_data VALUES (53015, 142, 1711, 0, 13, 224, 76);
INSERT INTO public.who_global_data VALUES (53016, 3913, 268602, 175, 8761, 224, 138);
INSERT INTO public.who_global_data VALUES (53017, 1004, 34073, 12, 1224, 224, 98);
INSERT INTO public.who_global_data VALUES (53018, 0, 0, 0, 0, 224, 103);
INSERT INTO public.who_global_data VALUES (53019, 276, 33395, 17, 1429, 224, 225);
INSERT INTO public.who_global_data VALUES (53020, 451, 40866, 6, 1555, 224, 131);
INSERT INTO public.who_global_data VALUES (53021, 45, 6922, 0, 151, 224, 235);
INSERT INTO public.who_global_data VALUES (53022, 946, 92784, 3, 109, 224, 137);
INSERT INTO public.who_global_data VALUES (53023, 51, 12653, 0, 282, 224, 81);
INSERT INTO public.who_global_data VALUES (53024, 323, 15776, 13, 515, 224, 182);
INSERT INTO public.who_global_data VALUES (53025, 1, 517, 0, 2, 224, 145);
INSERT INTO public.who_global_data VALUES (53026, 411, 25697, 14, 1579, 224, 26);
INSERT INTO public.who_global_data VALUES (53027, 6852, 627646, 188, 8969, 224, 170);
INSERT INTO public.who_global_data VALUES (53028, 8, 858, 0, 2, 224, 191);
INSERT INTO public.who_global_data VALUES (53029, 0, 3, 0, 0, 224, 221);
INSERT INTO public.who_global_data VALUES (53030, 0, 6, 0, 0, 224, 64);
INSERT INTO public.who_global_data VALUES (53031, 0, 0, 0, 0, 224, 116);
INSERT INTO public.who_global_data VALUES (53032, 0, 15, 0, 0, 224, 128);
INSERT INTO public.who_global_data VALUES (53033, 0, 19, 0, 0, 224, 6);
INSERT INTO public.who_global_data VALUES (53034, 0, 42, 0, 3, 224, 227);
INSERT INTO public.who_global_data VALUES (53035, 0, 1, 0, 0, 224, 68);
INSERT INTO public.who_global_data VALUES (53036, 0, 29, 0, 0, 224, 184);
INSERT INTO public.who_global_data VALUES (53037, 0, 0, 0, 0, 224, 82);
INSERT INTO public.who_global_data VALUES (53038, 0, 713, 0, 42, 224, 149);
INSERT INTO public.who_global_data VALUES (53039, 0, 392, 0, 11, 224, 197);
INSERT INTO public.who_global_data VALUES (53040, 3938, 174577, 46, 1474, 224, 78);
INSERT INTO public.who_global_data VALUES (53041, 121, 6354, 4, 98, 224, 233);
INSERT INTO public.who_global_data VALUES (53042, 193, 13565, 1, 265, 224, 133);
INSERT INTO public.who_global_data VALUES (53043, 4, 20, 0, 0, 224, 35);
INSERT INTO public.who_global_data VALUES (53044, 13, 1394, 3, 59, 224, 114);
INSERT INTO public.who_global_data VALUES (53045, 219, 42955, 0, 26, 224, 237);
INSERT INTO public.who_global_data VALUES (53046, 0, 2, 0, 0, 224, 55);
INSERT INTO public.who_global_data VALUES (53047, 0, 77, 0, 15, 224, 176);
INSERT INTO public.who_global_data VALUES (53048, 13, 1643, 0, 28, 224, 202);
INSERT INTO public.who_global_data VALUES (53049, 14, 1571, 0, 114, 224, 155);
INSERT INTO public.who_global_data VALUES (53050, 0, 0, 0, 0, 224, 32);
INSERT INTO public.who_global_data VALUES (53051, 0, 2878, 0, 90, 224, 220);
INSERT INTO public.who_global_data VALUES (53052, 6215, 124590, 48, 2340, 224, 30);
INSERT INTO public.who_global_data VALUES (53053, 10, 1952, 0, 36, 224, 147);
INSERT INTO public.who_global_data VALUES (53054, 385, 256632, 11, 29703, 224, 208);
INSERT INTO public.who_global_data VALUES (53055, 4, 2014, 0, 11, 224, 45);
INSERT INTO public.who_global_data VALUES (53056, 275, 9257, 16, 572, 224, 110);
INSERT INTO public.who_global_data VALUES (53057, 16, 373, 0, 10, 224, 88);
INSERT INTO public.who_global_data VALUES (53058, 1278, 63960, 23, 5430, 224, 51);
INSERT INTO public.who_global_data VALUES (53059, 92, 31549, 0, 1722, 224, 209);
INSERT INTO public.who_global_data VALUES (53060, 12, 254, 0, 7, 224, 205);
INSERT INTO public.who_global_data VALUES (53061, 56, 5747, 0, 52, 224, 18);
INSERT INTO public.who_global_data VALUES (53062, 0, 3162, 0, 58, 224, 72);
INSERT INTO public.who_global_data VALUES (53063, 721, 281779, 77, 40249, 224, 44);
INSERT INTO public.who_global_data VALUES (53064, 0, 24, 0, 0, 224, 15);
INSERT INTO public.who_global_data VALUES (53065, 3, 591, 0, 14, 224, 25);
INSERT INTO public.who_global_data VALUES (53066, 0, 0, 0, 0, 224, 179);
INSERT INTO public.who_global_data VALUES (53067, 0, 0, 0, 0, 224, 34);
INSERT INTO public.who_global_data VALUES (53068, 0, 123, 0, 8, 224, 207);
INSERT INTO public.who_global_data VALUES (53069, 4, 1168, 0, 50, 224, 166);
INSERT INTO public.who_global_data VALUES (53070, 1396, 194511, 19, 5065, 224, 126);
INSERT INTO public.who_global_data VALUES (53071, 0, 0, 0, 0, 224, 97);
INSERT INTO public.who_global_data VALUES (53072, 1, 16, 0, 1, 224, 36);
INSERT INTO public.who_global_data VALUES (53073, 0, 0, 0, 0, 224, 125);
INSERT INTO public.who_global_data VALUES (53074, 12, 833, 0, 0, 224, 124);
INSERT INTO public.who_global_data VALUES (53075, 948, 42065, 24, 1110, 224, 185);
INSERT INTO public.who_global_data VALUES (53076, 410, 46973, 2, 310, 224, 194);
INSERT INTO public.who_global_data VALUES (53077, 0, 509, 0, 21, 224, 144);
INSERT INTO public.who_global_data VALUES (53078, 40526, 2407590, 2516, 124161, 224, 19);
INSERT INTO public.who_global_data VALUES (53079, 1, 81, 0, 6, 224, 217);
INSERT INTO public.who_global_data VALUES (53080, 5, 907, 0, 26, 224, 148);
INSERT INTO public.who_global_data VALUES (53081, 262, 7490, 0, 20, 224, 86);
INSERT INTO public.who_global_data VALUES (53082, 0, 0, 0, 0, 224, 13);
INSERT INTO public.who_global_data VALUES (53083, 198, 4563, 1, 39, 224, 157);
INSERT INTO public.who_global_data VALUES (53084, 1, 353, 0, 0, 224, 8);
INSERT INTO public.who_global_data VALUES (53085, 0, 0, 0, 0, 224, 73);
INSERT INTO public.who_global_data VALUES (53086, 13, 1089, 5, 293, 224, 101);
INSERT INTO public.who_global_data VALUES (53087, 34, 1531, 3, 21, 224, 165);
INSERT INTO public.who_global_data VALUES (53088, 10, 561, 1, 7, 224, 14);
INSERT INTO public.who_global_data VALUES (53089, 85, 30346, 5, 684, 225, 193);
INSERT INTO public.who_global_data VALUES (53090, 77, 2269, 3, 51, 225, 113);
INSERT INTO public.who_global_data VALUES (53091, 197, 12445, 9, 878, 225, 143);
INSERT INTO public.who_global_data VALUES (53092, 0, 0, 0, 0, 225, 219);
INSERT INTO public.who_global_data VALUES (53093, 0, 855, 0, 52, 225, 186);
INSERT INTO public.who_global_data VALUES (53094, 15, 212, 0, 10, 225, 52);
INSERT INTO public.who_global_data VALUES (53095, 0, 3, 0, 0, 225, 180);
INSERT INTO public.who_global_data VALUES (53096, 0, 26, 0, 3, 225, 167);
INSERT INTO public.who_global_data VALUES (53097, 2635, 49851, 39, 1124, 225, 154);
INSERT INTO public.who_global_data VALUES (53098, 759, 22560, 13, 405, 225, 94);
INSERT INTO public.who_global_data VALUES (53099, 0, 101, 0, 3, 225, 66);
INSERT INTO public.who_global_data VALUES (53100, 37, 7558, 1, 104, 225, 58);
INSERT INTO public.who_global_data VALUES (53101, 47, 17431, 5, 698, 225, 163);
INSERT INTO public.who_global_data VALUES (53102, 547, 14852, 6, 180, 225, 37);
INSERT INTO public.who_global_data VALUES (53103, 0, 104, 0, 11, 225, 142);
INSERT INTO public.who_global_data VALUES (53104, 511, 24081, 2, 71, 225, 83);
INSERT INTO public.who_global_data VALUES (53105, 3946, 126606, 39, 1621, 225, 228);
INSERT INTO public.who_global_data VALUES (53106, 0, 97, 0, 7, 225, 188);
INSERT INTO public.who_global_data VALUES (53107, 437, 60382, 5, 367, 225, 62);
INSERT INTO public.who_global_data VALUES (53108, 76, 61679, 5, 9602, 225, 160);
INSERT INTO public.who_global_data VALUES (53109, 0, 23, 0, 2, 225, 50);
INSERT INTO public.who_global_data VALUES (53110, 115, 1017, 1, 14, 225, 33);
INSERT INTO public.who_global_data VALUES (53111, 0, 146, 0, 9, 225, 183);
INSERT INTO public.who_global_data VALUES (53112, 0, 70, 0, 0, 225, 92);
INSERT INTO public.who_global_data VALUES (53113, 1098, 27487, 30, 876, 225, 158);
INSERT INTO public.who_global_data VALUES (53114, 0, 2, 0, 0, 225, 67);
INSERT INTO public.who_global_data VALUES (53115, 119, 3794, 2, 174, 225, 57);
INSERT INTO public.who_global_data VALUES (53116, 0, 125, 0, 1, 225, 38);
INSERT INTO public.who_global_data VALUES (53117, 42725, 1188631, 1185, 53830, 225, 141);
INSERT INTO public.who_global_data VALUES (53118, 0, 8, 0, 1, 225, 178);
INSERT INTO public.who_global_data VALUES (53119, 0, 141, 0, 3, 225, 108);
INSERT INTO public.who_global_data VALUES (53120, 166, 4408, 2, 211, 225, 39);
INSERT INTO public.who_global_data VALUES (53121, 0, 934, 0, 53, 225, 2);
INSERT INTO public.who_global_data VALUES (53122, 0, 144, 0, 1, 225, 195);
INSERT INTO public.who_global_data VALUES (53123, 4, 1003, 0, 8, 225, 107);
INSERT INTO public.who_global_data VALUES (53124, 0, 130, 0, 0, 225, 161);
INSERT INTO public.who_global_data VALUES (53125, 322, 12592, 0, 313, 225, 212);
INSERT INTO public.who_global_data VALUES (53126, 279, 102242, 30, 8484, 225, 181);
INSERT INTO public.who_global_data VALUES (53127, 1, 196, 0, 1, 225, 53);
INSERT INTO public.who_global_data VALUES (53128, 193, 3244, 3, 40, 225, 164);
INSERT INTO public.who_global_data VALUES (53129, 3, 863, 0, 74, 225, 140);
INSERT INTO public.who_global_data VALUES (53130, 4648, 259064, 172, 4903, 225, 20);
INSERT INTO public.who_global_data VALUES (53131, 29, 85148, 1, 4648, 225, 112);
INSERT INTO public.who_global_data VALUES (53132, 3541, 77113, 87, 2491, 225, 111);
INSERT INTO public.who_global_data VALUES (53133, 7, 272, 0, 7, 225, 71);
INSERT INTO public.who_global_data VALUES (53134, 63, 1204, 1, 38, 225, 218);
INSERT INTO public.who_global_data VALUES (53135, 0, 0, 0, 0, 225, 43);
INSERT INTO public.who_global_data VALUES (53136, 147, 2515, 0, 12, 225, 49);
INSERT INTO public.who_global_data VALUES (53137, 170, 8334, 2, 60, 225, 1);
INSERT INTO public.who_global_data VALUES (53138, 95, 2483, 0, 107, 225, 48);
INSERT INTO public.who_global_data VALUES (53139, 2, 2321, 0, 85, 225, 232);
INSERT INTO public.who_global_data VALUES (53140, 0, 24, 0, 1, 225, 175);
INSERT INTO public.who_global_data VALUES (53141, 1, 992, 0, 19, 225, 21);
INSERT INTO public.who_global_data VALUES (53142, 93, 10870, 2, 345, 225, 156);
INSERT INTO public.who_global_data VALUES (53143, 0, 0, 0, 0, 225, 95);
INSERT INTO public.who_global_data VALUES (53144, 198, 6410, 0, 141, 225, 177);
INSERT INTO public.who_global_data VALUES (53145, 21, 12636, 0, 603, 225, 210);
INSERT INTO public.who_global_data VALUES (53146, 5, 4635, 0, 52, 225, 120);
INSERT INTO public.who_global_data VALUES (53147, 0, 18, 0, 0, 225, 135);
INSERT INTO public.who_global_data VALUES (53148, 510, 29141, 7, 698, 225, 206);
INSERT INTO public.who_global_data VALUES (53149, 822, 53156, 34, 4343, 225, 189);
INSERT INTO public.who_global_data VALUES (53150, 1569, 61130, 83, 2533, 225, 129);
INSERT INTO public.who_global_data VALUES (53151, 186, 5336, 7, 126, 225, 121);
INSERT INTO public.who_global_data VALUES (53152, 0, 1043, 0, 12, 225, 59);
INSERT INTO public.who_global_data VALUES (53153, 0, 144, 0, 0, 225, 96);
INSERT INTO public.who_global_data VALUES (53154, 1, 1984, 0, 63, 225, 41);
INSERT INTO public.who_global_data VALUES (53155, 16, 706, 1, 8, 225, 216);
INSERT INTO public.who_global_data VALUES (53156, 141, 5175, 3, 81, 225, 236);
INSERT INTO public.who_global_data VALUES (53157, 0, 13, 0, 0, 225, 150);
INSERT INTO public.who_global_data VALUES (53158, 0, 187, 0, 0, 225, 61);
INSERT INTO public.who_global_data VALUES (53159, 0, 18, 0, 0, 225, 7);
INSERT INTO public.who_global_data VALUES (53160, 5, 7172, 0, 327, 225, 169);
INSERT INTO public.who_global_data VALUES (53161, 0, 155256, 27, 29675, 225, 28);
INSERT INTO public.who_global_data VALUES (53162, 206, 3033, 1, 10, 225, 85);
INSERT INTO public.who_global_data VALUES (53163, 0, 60, 0, 0, 225, 211);
INSERT INTO public.who_global_data VALUES (53164, 131, 5087, 1, 40, 225, 60);
INSERT INTO public.who_global_data VALUES (53165, 1, 43, 0, 2, 225, 3);
INSERT INTO public.who_global_data VALUES (53166, 2, 919, 0, 14, 225, 11);
INSERT INTO public.who_global_data VALUES (53167, 477, 192556, 21, 8948, 225, 89);
INSERT INTO public.who_global_data VALUES (53168, 460, 15473, 0, 95, 225, 24);
INSERT INTO public.who_global_data VALUES (53169, 0, 176, 0, 0, 225, 162);
INSERT INTO public.who_global_data VALUES (53170, 11, 3321, 1, 191, 225, 100);
INSERT INTO public.who_global_data VALUES (53171, 0, 13, 0, 0, 225, 47);
INSERT INTO public.who_global_data VALUES (53172, 0, 23, 0, 0, 225, 29);
INSERT INTO public.who_global_data VALUES (53173, 0, 174, 0, 14, 225, 40);
INSERT INTO public.who_global_data VALUES (53174, 14, 237, 0, 5, 225, 222);
INSERT INTO public.who_global_data VALUES (53175, 279, 14819, 19, 601, 225, 132);
INSERT INTO public.who_global_data VALUES (53176, 0, 252, 0, 13, 225, 130);
INSERT INTO public.who_global_data VALUES (53177, 37, 5211, 0, 29, 225, 234);
INSERT INTO public.who_global_data VALUES (53178, 0, 1556, 0, 19, 225, 23);
INSERT INTO public.who_global_data VALUES (53179, 3, 209, 0, 12, 225, 192);
INSERT INTO public.who_global_data VALUES (53180, 105, 5429, 3, 92, 225, 69);
INSERT INTO public.who_global_data VALUES (53181, 0, 12, 0, 0, 225, 187);
INSERT INTO public.who_global_data VALUES (53182, 628, 14571, 12, 417, 225, 230);
INSERT INTO public.who_global_data VALUES (53183, 9, 4123, 1, 577, 225, 77);
INSERT INTO public.who_global_data VALUES (53184, 1, 1818, 0, 10, 225, 9);
INSERT INTO public.who_global_data VALUES (53185, 17296, 490401, 407, 15301, 225, 74);
INSERT INTO public.who_global_data VALUES (53186, 1178, 50187, 47, 2620, 225, 224);
INSERT INTO public.who_global_data VALUES (53187, 2595, 215096, 134, 10130, 225, 199);
INSERT INTO public.who_global_data VALUES (53188, 2437, 39139, 107, 1437, 225, 190);
INSERT INTO public.who_global_data VALUES (53189, 9, 25405, 1, 1727, 225, 12);
INSERT INTO public.who_global_data VALUES (53190, 0, 336, 0, 24, 225, 104);
INSERT INTO public.who_global_data VALUES (53191, 487, 22140, 3, 314, 225, 153);
INSERT INTO public.who_global_data VALUES (53192, 296, 239706, 34, 34678, 225, 91);
INSERT INTO public.who_global_data VALUES (53193, 8, 678, 0, 10, 225, 215);
INSERT INTO public.who_global_data VALUES (53194, 87, 18197, 1, 969, 225, 84);
INSERT INTO public.who_global_data VALUES (53195, 2, 320, 0, 31, 225, 231);
INSERT INTO public.who_global_data VALUES (53196, 14, 1013, 0, 9, 225, 196);
INSERT INTO public.who_global_data VALUES (53197, 1557, 26577, 11, 158, 225, 105);
INSERT INTO public.who_global_data VALUES (53198, 178, 5384, 2, 132, 225, 122);
INSERT INTO public.who_global_data VALUES (53199, 0, 0, 0, 0, 225, 159);
INSERT INTO public.who_global_data VALUES (53200, 69, 2389, 2, 31, 225, 75);
INSERT INTO public.who_global_data VALUES (53201, 909, 42788, 2, 339, 225, 27);
INSERT INTO public.who_global_data VALUES (53202, 250, 4204, 0, 43, 225, 54);
INSERT INTO public.who_global_data VALUES (53203, 0, 19, 0, 0, 225, 226);
INSERT INTO public.who_global_data VALUES (53204, 0, 1111, 0, 30, 225, 79);
INSERT INTO public.who_global_data VALUES (53205, 18, 1662, 0, 33, 225, 56);
INSERT INTO public.who_global_data VALUES (53206, 3, 20, 0, 0, 225, 117);
INSERT INTO public.who_global_data VALUES (53207, 19, 681, 0, 34, 225, 152);
INSERT INTO public.who_global_data VALUES (53208, 59, 698, 0, 18, 225, 16);
INSERT INTO public.who_global_data VALUES (53209, 0, 83, 0, 1, 225, 10);
INSERT INTO public.who_global_data VALUES (53210, 2, 1803, 0, 78, 225, 201);
INSERT INTO public.who_global_data VALUES (53211, 11, 4151, 0, 110, 225, 174);
INSERT INTO public.who_global_data VALUES (53212, 42, 1829, 0, 16, 225, 119);
INSERT INTO public.who_global_data VALUES (53213, 112, 960, 1, 12, 225, 168);
INSERT INTO public.who_global_data VALUES (53214, 4, 8600, 0, 121, 225, 99);
INSERT INTO public.who_global_data VALUES (53215, 17, 2277, 0, 8, 225, 171);
INSERT INTO public.who_global_data VALUES (53216, 34, 2039, 0, 113, 225, 87);
INSERT INTO public.who_global_data VALUES (53217, 2, 669, 0, 9, 225, 123);
INSERT INTO public.who_global_data VALUES (53218, 0, 0, 0, 0, 225, 151);
INSERT INTO public.who_global_data VALUES (53219, 0, 236, 0, 14, 225, 213);
INSERT INTO public.who_global_data VALUES (53220, 227, 3519, 2, 116, 225, 118);
INSERT INTO public.who_global_data VALUES (53221, 0, 341, 0, 10, 225, 134);
INSERT INTO public.who_global_data VALUES (53222, 41, 2508, 0, 34, 225, 65);
INSERT INTO public.who_global_data VALUES (53223, 5437, 196847, 947, 24324, 225, 102);
INSERT INTO public.who_global_data VALUES (53224, 0, 0, 0, 0, 225, 223);
INSERT INTO public.who_global_data VALUES (53225, 0, 72, 0, 1, 225, 4);
INSERT INTO public.who_global_data VALUES (53226, 1, 216, 0, 0, 225, 146);
INSERT INTO public.who_global_data VALUES (53227, 25, 449, 0, 9, 225, 31);
INSERT INTO public.who_global_data VALUES (53228, 0, 11, 0, 1, 225, 127);
INSERT INTO public.who_global_data VALUES (53229, 431, 11338, 1, 217, 225, 22);
INSERT INTO public.who_global_data VALUES (53230, 26, 788, 0, 5, 225, 115);
INSERT INTO public.who_global_data VALUES (53231, 0, 293, 0, 6, 225, 106);
INSERT INTO public.who_global_data VALUES (53232, 26, 102, 0, 0, 225, 90);
INSERT INTO public.who_global_data VALUES (53233, 0, 0, 0, 0, 225, 70);
INSERT INTO public.who_global_data VALUES (53234, 434, 11162, 2, 26, 225, 46);
INSERT INTO public.who_global_data VALUES (53235, 110, 49690, 3, 6074, 225, 139);
INSERT INTO public.who_global_data VALUES (53236, 0, 21, 0, 0, 225, 42);
INSERT INTO public.who_global_data VALUES (53237, 1, 1170, 0, 22, 225, 80);
INSERT INTO public.who_global_data VALUES (53238, 0, 2014, 0, 74, 225, 203);
INSERT INTO public.who_global_data VALUES (53239, 3, 1059, 0, 67, 225, 136);
INSERT INTO public.who_global_data VALUES (53240, 594, 22614, 7, 549, 225, 63);
INSERT INTO public.who_global_data VALUES (53241, 0, 0, 0, 0, 225, 17);
INSERT INTO public.who_global_data VALUES (53242, 0, 30, 0, 2, 225, 172);
INSERT INTO public.who_global_data VALUES (53243, 153, 5603, 6, 265, 225, 109);
INSERT INTO public.who_global_data VALUES (53244, 16, 8793, 0, 249, 225, 200);
INSERT INTO public.who_global_data VALUES (53245, 54, 1588, 0, 5, 225, 93);
INSERT INTO public.who_global_data VALUES (53246, 1366, 34902, 2, 144, 225, 5);
INSERT INTO public.who_global_data VALUES (53247, 0, 741, 0, 13, 225, 214);
INSERT INTO public.who_global_data VALUES (53248, 2775, 195745, 59, 3962, 225, 204);
INSERT INTO public.who_global_data VALUES (53249, 0, 0, 0, 0, 225, 198);
INSERT INTO public.who_global_data VALUES (53250, 716, 28030, 11, 547, 225, 173);
INSERT INTO public.who_global_data VALUES (53251, 1, 11, 0, 0, 225, 229);
INSERT INTO public.who_global_data VALUES (53252, 41, 1569, 0, 13, 225, 76);
INSERT INTO public.who_global_data VALUES (53253, 3879, 264689, 182, 8586, 225, 138);
INSERT INTO public.who_global_data VALUES (53254, 774, 33069, 8, 1212, 225, 98);
INSERT INTO public.who_global_data VALUES (53255, 0, 0, 0, 0, 225, 103);
INSERT INTO public.who_global_data VALUES (53256, 298, 33119, 16, 1412, 225, 225);
INSERT INTO public.who_global_data VALUES (53257, 311, 40415, 6, 1549, 225, 131);
INSERT INTO public.who_global_data VALUES (53258, 57, 6877, 2, 151, 225, 235);
INSERT INTO public.who_global_data VALUES (53259, 1060, 91838, 2, 106, 225, 137);
INSERT INTO public.who_global_data VALUES (53260, 39, 12602, 0, 282, 225, 81);
INSERT INTO public.who_global_data VALUES (53261, 375, 15453, 0, 502, 225, 182);
INSERT INTO public.who_global_data VALUES (53262, 8, 516, 0, 2, 225, 145);
INSERT INTO public.who_global_data VALUES (53263, 460, 25286, 10, 1565, 225, 26);
INSERT INTO public.who_global_data VALUES (53264, 6800, 620794, 176, 8781, 225, 170);
INSERT INTO public.who_global_data VALUES (53265, 20, 850, 0, 2, 225, 191);
INSERT INTO public.who_global_data VALUES (53266, 0, 3, 0, 0, 225, 221);
INSERT INTO public.who_global_data VALUES (53267, 0, 6, 0, 0, 225, 64);
INSERT INTO public.who_global_data VALUES (53268, 0, 0, 0, 0, 225, 116);
INSERT INTO public.who_global_data VALUES (53269, 0, 15, 0, 0, 225, 128);
INSERT INTO public.who_global_data VALUES (53270, 0, 19, 0, 0, 225, 6);
INSERT INTO public.who_global_data VALUES (53271, 0, 42, 0, 3, 225, 227);
INSERT INTO public.who_global_data VALUES (53272, 0, 1, 0, 0, 225, 68);
INSERT INTO public.who_global_data VALUES (53273, 0, 29, 0, 0, 225, 184);
INSERT INTO public.who_global_data VALUES (53274, 0, 0, 0, 0, 225, 82);
INSERT INTO public.who_global_data VALUES (53275, 0, 713, 0, 42, 225, 149);
INSERT INTO public.who_global_data VALUES (53276, 4, 392, 1, 11, 225, 197);
INSERT INTO public.who_global_data VALUES (53277, 3372, 170639, 41, 1428, 225, 78);
INSERT INTO public.who_global_data VALUES (53278, 104, 6233, 1, 94, 225, 233);
INSERT INTO public.who_global_data VALUES (53279, 137, 13372, 1, 264, 225, 133);
INSERT INTO public.who_global_data VALUES (53280, 5, 16, 0, 0, 225, 35);
INSERT INTO public.who_global_data VALUES (53281, 27, 1381, 0, 56, 225, 114);
INSERT INTO public.who_global_data VALUES (53282, 113, 42736, 0, 26, 225, 237);
INSERT INTO public.who_global_data VALUES (53283, 0, 2, 0, 0, 225, 55);
INSERT INTO public.who_global_data VALUES (53284, 0, 77, 0, 15, 225, 176);
INSERT INTO public.who_global_data VALUES (53285, 23, 1630, 0, 28, 225, 202);
INSERT INTO public.who_global_data VALUES (53286, 11, 1557, 0, 114, 225, 155);
INSERT INTO public.who_global_data VALUES (53287, 0, 0, 0, 0, 225, 32);
INSERT INTO public.who_global_data VALUES (53288, 18, 2878, 0, 90, 225, 220);
INSERT INTO public.who_global_data VALUES (53289, 6579, 118375, 87, 2292, 225, 30);
INSERT INTO public.who_global_data VALUES (53290, 12, 1942, 0, 36, 225, 147);
INSERT INTO public.who_global_data VALUES (53291, 329, 256247, 12, 29692, 225, 208);
INSERT INTO public.who_global_data VALUES (53292, 9, 2010, 0, 11, 225, 45);
INSERT INTO public.who_global_data VALUES (53293, 95, 8982, 8, 556, 225, 110);
INSERT INTO public.who_global_data VALUES (53294, 38, 357, 1, 10, 225, 88);
INSERT INTO public.who_global_data VALUES (53295, 1698, 62682, 22, 5407, 225, 51);
INSERT INTO public.who_global_data VALUES (53296, 48, 31457, 0, 1722, 225, 209);
INSERT INTO public.who_global_data VALUES (53297, 11, 242, 0, 7, 225, 205);
INSERT INTO public.who_global_data VALUES (53298, 61, 5691, 0, 52, 225, 18);
INSERT INTO public.who_global_data VALUES (53299, 4, 3162, 0, 58, 225, 72);
INSERT INTO public.who_global_data VALUES (53300, 778, 281058, 99, 40172, 225, 44);
INSERT INTO public.who_global_data VALUES (53301, 0, 24, 0, 0, 225, 15);
INSERT INTO public.who_global_data VALUES (53302, 12, 588, 1, 14, 225, 25);
INSERT INTO public.who_global_data VALUES (53303, 0, 0, 0, 0, 225, 179);
INSERT INTO public.who_global_data VALUES (53304, 0, 0, 0, 0, 225, 34);
INSERT INTO public.who_global_data VALUES (53305, 0, 123, 0, 8, 225, 207);
INSERT INTO public.who_global_data VALUES (53306, 2, 1164, 0, 50, 225, 166);
INSERT INTO public.who_global_data VALUES (53307, 1458, 193115, 21, 5046, 225, 126);
INSERT INTO public.who_global_data VALUES (53308, 0, 0, 0, 0, 225, 97);
INSERT INTO public.who_global_data VALUES (53309, 1, 15, 0, 1, 225, 36);
INSERT INTO public.who_global_data VALUES (53310, 0, 0, 0, 0, 225, 125);
INSERT INTO public.who_global_data VALUES (53311, 16, 821, 0, 0, 225, 124);
INSERT INTO public.who_global_data VALUES (53312, 1109, 41117, 19, 1086, 225, 185);
INSERT INTO public.who_global_data VALUES (53313, 430, 46563, 1, 308, 225, 194);
INSERT INTO public.who_global_data VALUES (53314, 0, 509, 0, 21, 225, 144);
INSERT INTO public.who_global_data VALUES (53315, 37601, 2367064, 690, 121645, 225, 19);
INSERT INTO public.who_global_data VALUES (53316, 4, 80, 0, 6, 225, 217);
INSERT INTO public.who_global_data VALUES (53317, 17, 902, 1, 26, 225, 148);
INSERT INTO public.who_global_data VALUES (53318, 238, 7228, 1, 20, 225, 86);
INSERT INTO public.who_global_data VALUES (53319, 0, 0, 0, 0, 225, 13);
INSERT INTO public.who_global_data VALUES (53320, 179, 4365, 3, 38, 225, 157);
INSERT INTO public.who_global_data VALUES (53321, 0, 352, 0, 0, 225, 8);
INSERT INTO public.who_global_data VALUES (53322, 0, 0, 0, 0, 225, 73);
INSERT INTO public.who_global_data VALUES (53323, 61, 1076, 14, 288, 225, 101);
INSERT INTO public.who_global_data VALUES (53324, 8, 1497, 0, 18, 225, 165);
INSERT INTO public.who_global_data VALUES (53325, 21, 551, 0, 6, 225, 14);
INSERT INTO public.who_global_data VALUES (53326, 535, 30261, 36, 679, 226, 193);
INSERT INTO public.who_global_data VALUES (53327, 78, 2192, 1, 48, 226, 113);
INSERT INTO public.who_global_data VALUES (53328, 172, 12248, 8, 869, 226, 143);
INSERT INTO public.who_global_data VALUES (53329, 0, 0, 0, 0, 226, 219);
INSERT INTO public.who_global_data VALUES (53330, 0, 855, 0, 52, 226, 186);
INSERT INTO public.who_global_data VALUES (53331, 8, 197, 0, 10, 226, 52);
INSERT INTO public.who_global_data VALUES (53332, 0, 3, 0, 0, 226, 180);
INSERT INTO public.who_global_data VALUES (53333, 0, 26, 0, 3, 226, 167);
INSERT INTO public.who_global_data VALUES (53334, 2285, 47216, 36, 1085, 226, 154);
INSERT INTO public.who_global_data VALUES (53335, 771, 21801, 11, 392, 226, 94);
INSERT INTO public.who_global_data VALUES (53336, 0, 101, 0, 3, 226, 66);
INSERT INTO public.who_global_data VALUES (53337, 29, 7521, 1, 103, 226, 58);
INSERT INTO public.who_global_data VALUES (53338, 33, 17384, 0, 693, 226, 163);
INSERT INTO public.who_global_data VALUES (53339, 590, 14305, 7, 174, 226, 37);
INSERT INTO public.who_global_data VALUES (53340, 0, 104, 0, 11, 226, 142);
INSERT INTO public.who_global_data VALUES (53341, 508, 23570, 2, 69, 226, 83);
INSERT INTO public.who_global_data VALUES (53342, 3462, 122660, 37, 1582, 226, 228);
INSERT INTO public.who_global_data VALUES (53343, 0, 97, 0, 7, 226, 188);
INSERT INTO public.who_global_data VALUES (53344, 458, 59945, 5, 362, 226, 62);
INSERT INTO public.who_global_data VALUES (53345, 100, 61603, 3, 9597, 226, 160);
INSERT INTO public.who_global_data VALUES (53346, 0, 23, 0, 2, 226, 50);
INSERT INTO public.who_global_data VALUES (53347, 52, 902, 0, 13, 226, 33);
INSERT INTO public.who_global_data VALUES (53348, 0, 146, 0, 9, 226, 183);
INSERT INTO public.who_global_data VALUES (53349, 0, 70, 0, 0, 226, 92);
INSERT INTO public.who_global_data VALUES (53350, 896, 26389, 26, 846, 226, 158);
INSERT INTO public.who_global_data VALUES (53351, 0, 2, 0, 0, 226, 67);
INSERT INTO public.who_global_data VALUES (53352, 88, 3675, 1, 172, 226, 57);
INSERT INTO public.who_global_data VALUES (53353, 36, 125, 0, 1, 226, 38);
INSERT INTO public.who_global_data VALUES (53354, 39436, 1145906, 1374, 52645, 226, 141);
INSERT INTO public.who_global_data VALUES (53355, 0, 8, 0, 1, 226, 178);
INSERT INTO public.who_global_data VALUES (53356, 0, 141, 0, 3, 226, 108);
INSERT INTO public.who_global_data VALUES (53357, 128, 4242, 1, 209, 226, 39);
INSERT INTO public.who_global_data VALUES (53358, 31, 934, 0, 53, 226, 2);
INSERT INTO public.who_global_data VALUES (53359, 0, 144, 0, 1, 226, 195);
INSERT INTO public.who_global_data VALUES (53360, 16, 999, 0, 8, 226, 107);
INSERT INTO public.who_global_data VALUES (53361, 0, 130, 0, 0, 226, 161);
INSERT INTO public.who_global_data VALUES (53362, 229, 12270, 5, 313, 226, 212);
INSERT INTO public.who_global_data VALUES (53363, 326, 101963, 18, 8454, 226, 181);
INSERT INTO public.who_global_data VALUES (53364, 0, 195, 0, 1, 226, 53);
INSERT INTO public.who_global_data VALUES (53365, 0, 3051, 0, 37, 226, 164);
INSERT INTO public.who_global_data VALUES (53366, 0, 860, 0, 74, 226, 140);
INSERT INTO public.who_global_data VALUES (53367, 3649, 254416, 226, 4731, 226, 20);
INSERT INTO public.who_global_data VALUES (53368, 21, 85119, 0, 4647, 226, 112);
INSERT INTO public.who_global_data VALUES (53369, 2389, 73572, 94, 2404, 226, 111);
INSERT INTO public.who_global_data VALUES (53370, 0, 265, 0, 7, 226, 71);
INSERT INTO public.who_global_data VALUES (53371, 0, 1141, 0, 37, 226, 218);
INSERT INTO public.who_global_data VALUES (53372, 0, 0, 0, 0, 226, 43);
INSERT INTO public.who_global_data VALUES (53373, 91, 2368, 0, 12, 226, 49);
INSERT INTO public.who_global_data VALUES (53374, 260, 8164, 0, 58, 226, 1);
INSERT INTO public.who_global_data VALUES (53375, 22, 2388, 0, 107, 226, 48);
INSERT INTO public.who_global_data VALUES (53376, 1, 2319, 0, 85, 226, 232);
INSERT INTO public.who_global_data VALUES (53377, 0, 24, 0, 1, 226, 175);
INSERT INTO public.who_global_data VALUES (53378, 1, 991, 0, 19, 226, 21);
INSERT INTO public.who_global_data VALUES (53379, 127, 10777, 4, 343, 226, 156);
INSERT INTO public.who_global_data VALUES (53380, 0, 0, 0, 0, 226, 95);
INSERT INTO public.who_global_data VALUES (53381, 186, 6212, 7, 141, 226, 177);
INSERT INTO public.who_global_data VALUES (53382, 54, 12615, 0, 603, 226, 210);
INSERT INTO public.who_global_data VALUES (53383, 13, 4630, 3, 52, 226, 120);
INSERT INTO public.who_global_data VALUES (53384, 0, 18, 0, 0, 226, 135);
INSERT INTO public.who_global_data VALUES (53385, 695, 28631, 16, 691, 226, 206);
INSERT INTO public.who_global_data VALUES (53386, 691, 52334, 35, 4309, 226, 189);
INSERT INTO public.who_global_data VALUES (53387, 1420, 59561, 85, 2450, 226, 129);
INSERT INTO public.who_global_data VALUES (53388, 177, 5150, 6, 119, 226, 121);
INSERT INTO public.who_global_data VALUES (53389, 0, 1043, 0, 12, 226, 59);
INSERT INTO public.who_global_data VALUES (53390, 1, 144, 0, 0, 226, 96);
INSERT INTO public.who_global_data VALUES (53391, 1, 1983, 0, 63, 226, 41);
INSERT INTO public.who_global_data VALUES (53392, 16, 690, 0, 7, 226, 216);
INSERT INTO public.who_global_data VALUES (53393, 186, 5034, 3, 78, 226, 236);
INSERT INTO public.who_global_data VALUES (53394, 0, 13, 0, 0, 226, 150);
INSERT INTO public.who_global_data VALUES (53395, 0, 187, 0, 0, 226, 61);
INSERT INTO public.who_global_data VALUES (53396, 0, 18, 0, 0, 226, 7);
INSERT INTO public.who_global_data VALUES (53397, 12, 7167, 0, 327, 226, 169);
INSERT INTO public.who_global_data VALUES (53398, 0, 155256, 0, 29648, 226, 28);
INSERT INTO public.who_global_data VALUES (53399, 234, 2827, 1, 9, 226, 85);
INSERT INTO public.who_global_data VALUES (53400, 0, 60, 0, 0, 226, 211);
INSERT INTO public.who_global_data VALUES (53401, 107, 4956, 0, 39, 226, 60);
INSERT INTO public.who_global_data VALUES (53402, 0, 42, 0, 2, 226, 3);
INSERT INTO public.who_global_data VALUES (53403, 3, 917, 0, 14, 226, 11);
INSERT INTO public.who_global_data VALUES (53404, 630, 192079, 13, 8927, 226, 89);
INSERT INTO public.who_global_data VALUES (53405, 445, 15013, 0, 95, 226, 24);
INSERT INTO public.who_global_data VALUES (53406, 0, 176, 0, 0, 226, 162);
INSERT INTO public.who_global_data VALUES (53407, 8, 3310, 0, 190, 226, 100);
INSERT INTO public.who_global_data VALUES (53408, 0, 13, 0, 0, 226, 47);
INSERT INTO public.who_global_data VALUES (53409, 0, 23, 0, 0, 226, 29);
INSERT INTO public.who_global_data VALUES (53410, 0, 174, 0, 14, 226, 40);
INSERT INTO public.who_global_data VALUES (53411, 6, 223, 0, 5, 226, 222);
INSERT INTO public.who_global_data VALUES (53412, 771, 14540, 35, 582, 226, 132);
INSERT INTO public.who_global_data VALUES (53413, 0, 252, 0, 13, 226, 130);
INSERT INTO public.who_global_data VALUES (53414, 70, 5174, 0, 29, 226, 234);
INSERT INTO public.who_global_data VALUES (53415, 0, 1556, 0, 19, 226, 23);
INSERT INTO public.who_global_data VALUES (53416, 1, 206, 0, 12, 226, 192);
INSERT INTO public.who_global_data VALUES (53417, 108, 5324, 1, 89, 226, 69);
INSERT INTO public.who_global_data VALUES (53418, 0, 12, 0, 0, 226, 187);
INSERT INTO public.who_global_data VALUES (53419, 587, 13943, 10, 405, 226, 230);
INSERT INTO public.who_global_data VALUES (53420, 7, 4114, 3, 576, 226, 77);
INSERT INTO public.who_global_data VALUES (53421, 2, 1817, 0, 10, 226, 9);
INSERT INTO public.who_global_data VALUES (53422, 16922, 473105, 418, 14894, 226, 74);
INSERT INTO public.who_global_data VALUES (53423, 1113, 49009, 38, 2573, 226, 224);
INSERT INTO public.who_global_data VALUES (53424, 2531, 212501, 133, 9996, 226, 199);
INSERT INTO public.who_global_data VALUES (53425, 2200, 36702, 79, 1330, 226, 190);
INSERT INTO public.who_global_data VALUES (53426, 5, 25396, 6, 1726, 226, 12);
INSERT INTO public.who_global_data VALUES (53427, 0, 336, 0, 24, 226, 104);
INSERT INTO public.who_global_data VALUES (53428, 452, 21653, 2, 311, 226, 153);
INSERT INTO public.who_global_data VALUES (53429, 577, 239410, -31, 34644, 226, 91);
INSERT INTO public.who_global_data VALUES (53430, 5, 670, 0, 10, 226, 215);
INSERT INTO public.who_global_data VALUES (53431, 86, 18110, 5, 968, 226, 84);
INSERT INTO public.who_global_data VALUES (53432, 0, 318, 0, 31, 226, 231);
INSERT INTO public.who_global_data VALUES (53433, 19, 999, 0, 9, 226, 196);
INSERT INTO public.who_global_data VALUES (53434, 1348, 25020, 11, 147, 226, 105);
INSERT INTO public.who_global_data VALUES (53435, 254, 5206, 2, 130, 226, 122);
INSERT INTO public.who_global_data VALUES (53436, 0, 0, 0, 0, 226, 159);
INSERT INTO public.who_global_data VALUES (53437, 95, 2320, 1, 29, 226, 75);
INSERT INTO public.who_global_data VALUES (53438, 846, 41879, 3, 337, 226, 27);
INSERT INTO public.who_global_data VALUES (53439, 228, 3954, 1, 43, 226, 54);
INSERT INTO public.who_global_data VALUES (53440, 0, 19, 0, 0, 226, 226);
INSERT INTO public.who_global_data VALUES (53441, 0, 1111, 0, 30, 226, 79);
INSERT INTO public.who_global_data VALUES (53442, 22, 1644, 1, 33, 226, 56);
INSERT INTO public.who_global_data VALUES (53443, 0, 17, 0, 0, 226, 117);
INSERT INTO public.who_global_data VALUES (53444, 10, 662, 0, 34, 226, 152);
INSERT INTO public.who_global_data VALUES (53445, 0, 639, 1, 18, 226, 16);
INSERT INTO public.who_global_data VALUES (53446, 0, 83, 0, 1, 226, 10);
INSERT INTO public.who_global_data VALUES (53447, 2, 1801, 0, 78, 226, 201);
INSERT INTO public.who_global_data VALUES (53448, 7, 4140, 0, 110, 226, 174);
INSERT INTO public.who_global_data VALUES (53449, 147, 1787, 1, 16, 226, 119);
INSERT INTO public.who_global_data VALUES (53450, 45, 848, 0, 11, 226, 168);
INSERT INTO public.who_global_data VALUES (53451, 6, 8596, 0, 121, 226, 99);
INSERT INTO public.who_global_data VALUES (53452, 22, 2260, 0, 8, 226, 171);
INSERT INTO public.who_global_data VALUES (53453, 27, 2005, 2, 113, 226, 87);
INSERT INTO public.who_global_data VALUES (53454, 3, 667, 0, 9, 226, 123);
INSERT INTO public.who_global_data VALUES (53455, 0, 0, 0, 0, 226, 151);
INSERT INTO public.who_global_data VALUES (53456, 0, 236, 0, 14, 226, 213);
INSERT INTO public.who_global_data VALUES (53457, 171, 3292, 2, 114, 226, 118);
INSERT INTO public.who_global_data VALUES (53458, 1, 341, 0, 10, 226, 134);
INSERT INTO public.who_global_data VALUES (53459, 15, 2467, 2, 34, 226, 65);
INSERT INTO public.who_global_data VALUES (53460, 6288, 191410, 793, 23377, 226, 102);
INSERT INTO public.who_global_data VALUES (53461, 0, 0, 0, 0, 226, 223);
INSERT INTO public.who_global_data VALUES (53462, 1, 72, 0, 1, 226, 4);
INSERT INTO public.who_global_data VALUES (53463, 0, 215, 0, 0, 226, 146);
INSERT INTO public.who_global_data VALUES (53464, 29, 424, 0, 9, 226, 31);
INSERT INTO public.who_global_data VALUES (53465, 0, 11, 0, 1, 226, 127);
INSERT INTO public.who_global_data VALUES (53466, 563, 10907, 2, 216, 226, 22);
INSERT INTO public.who_global_data VALUES (53467, 5, 762, 0, 5, 226, 115);
INSERT INTO public.who_global_data VALUES (53468, 1, 293, 0, 6, 226, 106);
INSERT INTO public.who_global_data VALUES (53469, 4, 76, 0, 0, 226, 90);
INSERT INTO public.who_global_data VALUES (53470, 0, 0, 0, 0, 226, 70);
INSERT INTO public.who_global_data VALUES (53471, 629, 10728, 0, 24, 226, 46);
INSERT INTO public.who_global_data VALUES (53472, 80, 49580, 3, 6071, 226, 139);
INSERT INTO public.who_global_data VALUES (53473, 0, 21, 0, 0, 226, 42);
INSERT INTO public.who_global_data VALUES (53474, 3, 1169, 0, 22, 226, 80);
INSERT INTO public.who_global_data VALUES (53475, 0, 2014, 10, 74, 226, 203);
INSERT INTO public.who_global_data VALUES (53476, 5, 1056, 0, 67, 226, 136);
INSERT INTO public.who_global_data VALUES (53477, 649, 22020, 9, 542, 226, 63);
INSERT INTO public.who_global_data VALUES (53478, 0, 0, 0, 0, 226, 17);
INSERT INTO public.who_global_data VALUES (53479, 0, 30, 0, 2, 226, 172);
INSERT INTO public.who_global_data VALUES (53480, 136, 5450, 8, 259, 226, 109);
INSERT INTO public.who_global_data VALUES (53481, 26, 8777, 1, 249, 226, 200);
INSERT INTO public.who_global_data VALUES (53482, 159, 1534, 0, 5, 226, 93);
INSERT INTO public.who_global_data VALUES (53483, 1142, 33536, 2, 142, 226, 5);
INSERT INTO public.who_global_data VALUES (53484, 0, 741, 0, 13, 226, 214);
INSERT INTO public.who_global_data VALUES (53485, 4044, 192970, 148, 3903, 226, 204);
INSERT INTO public.who_global_data VALUES (53486, 0, 0, 0, 0, 226, 198);
INSERT INTO public.who_global_data VALUES (53487, 562, 27314, 15, 536, 226, 173);
INSERT INTO public.who_global_data VALUES (53488, 1, 10, 0, 0, 226, 229);
INSERT INTO public.who_global_data VALUES (53489, 106, 1528, 0, 13, 226, 76);
INSERT INTO public.who_global_data VALUES (53490, 3363, 260810, 181, 8404, 226, 138);
INSERT INTO public.who_global_data VALUES (53491, 470, 32295, 18, 1204, 226, 98);
INSERT INTO public.who_global_data VALUES (53492, 0, 0, 0, 0, 226, 103);
INSERT INTO public.who_global_data VALUES (53493, 294, 32821, 21, 1396, 226, 225);
INSERT INTO public.who_global_data VALUES (53494, 367, 40104, 3, 1543, 226, 131);
INSERT INTO public.who_global_data VALUES (53495, 135, 6820, 0, 149, 226, 235);
INSERT INTO public.who_global_data VALUES (53496, 1199, 90778, 5, 104, 226, 137);
INSERT INTO public.who_global_data VALUES (53497, 28, 12563, 1, 282, 226, 81);
INSERT INTO public.who_global_data VALUES (53498, 364, 15078, 10, 502, 226, 182);
INSERT INTO public.who_global_data VALUES (53499, 1, 508, 1, 2, 226, 145);
INSERT INTO public.who_global_data VALUES (53500, 321, 24826, 16, 1555, 226, 26);
INSERT INTO public.who_global_data VALUES (53501, 7113, 613994, 92, 8605, 226, 170);
INSERT INTO public.who_global_data VALUES (53502, 32, 830, 0, 2, 226, 191);
INSERT INTO public.who_global_data VALUES (53503, 0, 3, 0, 0, 226, 221);
INSERT INTO public.who_global_data VALUES (53504, 0, 6, 0, 0, 226, 64);
INSERT INTO public.who_global_data VALUES (53505, 0, 0, 0, 0, 226, 116);
INSERT INTO public.who_global_data VALUES (53506, 0, 15, 0, 0, 226, 128);
INSERT INTO public.who_global_data VALUES (53507, 0, 19, 0, 0, 226, 6);
INSERT INTO public.who_global_data VALUES (53508, 0, 42, 0, 3, 226, 227);
INSERT INTO public.who_global_data VALUES (53509, 0, 1, 0, 0, 226, 68);
INSERT INTO public.who_global_data VALUES (53510, 0, 29, 0, 0, 226, 184);
INSERT INTO public.who_global_data VALUES (53511, 0, 0, 0, 0, 226, 82);
INSERT INTO public.who_global_data VALUES (53512, 0, 713, 0, 42, 226, 149);
INSERT INTO public.who_global_data VALUES (53513, 0, 388, 0, 10, 226, 197);
INSERT INTO public.who_global_data VALUES (53514, 3123, 167267, 41, 1387, 226, 78);
INSERT INTO public.who_global_data VALUES (53515, 95, 6129, 4, 93, 226, 233);
INSERT INTO public.who_global_data VALUES (53516, 143, 13235, 0, 263, 226, 133);
INSERT INTO public.who_global_data VALUES (53517, 0, 11, 0, 0, 226, 35);
INSERT INTO public.who_global_data VALUES (53518, 7, 1354, 1, 56, 226, 114);
INSERT INTO public.who_global_data VALUES (53519, 191, 42623, 0, 26, 226, 237);
INSERT INTO public.who_global_data VALUES (53520, 0, 2, 0, 0, 226, 55);
INSERT INTO public.who_global_data VALUES (53521, 0, 77, 0, 15, 226, 176);
INSERT INTO public.who_global_data VALUES (53522, 18, 1607, 0, 28, 226, 202);
INSERT INTO public.who_global_data VALUES (53523, 6, 1546, 0, 114, 226, 155);
INSERT INTO public.who_global_data VALUES (53524, 0, 0, 0, 0, 226, 32);
INSERT INTO public.who_global_data VALUES (53525, 25, 2860, 0, 90, 226, 220);
INSERT INTO public.who_global_data VALUES (53526, 5688, 111796, 103, 2205, 226, 30);
INSERT INTO public.who_global_data VALUES (53527, 14, 1930, 1, 36, 226, 147);
INSERT INTO public.who_global_data VALUES (53528, 464, 255918, 9, 29680, 226, 208);
INSERT INTO public.who_global_data VALUES (53529, 10, 2001, 0, 11, 226, 45);
INSERT INTO public.who_global_data VALUES (53530, 0, 8887, 0, 548, 226, 110);
INSERT INTO public.who_global_data VALUES (53531, 0, 319, 0, 9, 226, 88);
INSERT INTO public.who_global_data VALUES (53532, 1309, 60984, 25, 5385, 226, 51);
INSERT INTO public.who_global_data VALUES (53533, 64, 31409, 0, 1722, 226, 209);
INSERT INTO public.who_global_data VALUES (53534, 0, 231, 0, 7, 226, 205);
INSERT INTO public.who_global_data VALUES (53535, 63, 5630, 0, 52, 226, 18);
INSERT INTO public.who_global_data VALUES (53536, 1, 3158, 0, 58, 226, 72);
INSERT INTO public.who_global_data VALUES (53537, 886, 280280, 87, 40073, 226, 44);
INSERT INTO public.who_global_data VALUES (53538, 0, 24, 0, 0, 226, 15);
INSERT INTO public.who_global_data VALUES (53539, 0, 576, 0, 13, 226, 25);
INSERT INTO public.who_global_data VALUES (53540, 0, 0, 0, 0, 226, 179);
INSERT INTO public.who_global_data VALUES (53541, 0, 0, 0, 0, 226, 34);
INSERT INTO public.who_global_data VALUES (53542, 0, 123, 0, 8, 226, 207);
INSERT INTO public.who_global_data VALUES (53543, 2, 1162, 0, 50, 226, 166);
INSERT INTO public.who_global_data VALUES (53544, 1492, 191657, 24, 5025, 226, 126);
INSERT INTO public.who_global_data VALUES (53545, 0, 0, 0, 0, 226, 97);
INSERT INTO public.who_global_data VALUES (53546, 0, 14, 0, 1, 226, 36);
INSERT INTO public.who_global_data VALUES (53547, 0, 0, 0, 0, 226, 125);
INSERT INTO public.who_global_data VALUES (53548, 8, 805, 0, 0, 226, 124);
INSERT INTO public.who_global_data VALUES (53549, 994, 40008, 16, 1067, 226, 185);
INSERT INTO public.who_global_data VALUES (53550, 450, 46133, 2, 307, 226, 194);
INSERT INTO public.who_global_data VALUES (53551, 0, 509, 0, 21, 226, 144);
INSERT INTO public.who_global_data VALUES (53552, 34191, 2329463, 784, 120955, 226, 19);
INSERT INTO public.who_global_data VALUES (53553, 0, 76, 0, 6, 226, 217);
INSERT INTO public.who_global_data VALUES (53554, 3, 885, 0, 25, 226, 148);
INSERT INTO public.who_global_data VALUES (53555, 235, 6990, 0, 19, 226, 86);
INSERT INTO public.who_global_data VALUES (53556, 0, 0, 0, 0, 226, 13);
INSERT INTO public.who_global_data VALUES (53557, 138, 4186, 0, 35, 226, 157);
INSERT INTO public.who_global_data VALUES (53558, 3, 352, 0, 0, 226, 8);
INSERT INTO public.who_global_data VALUES (53559, 0, 0, 0, 0, 226, 73);
INSERT INTO public.who_global_data VALUES (53560, 23, 1015, 13, 274, 226, 101);
INSERT INTO public.who_global_data VALUES (53561, 12, 1489, 0, 18, 226, 165);
INSERT INTO public.who_global_data VALUES (53562, 5, 530, 0, 6, 226, 14);
INSERT INTO public.who_global_data VALUES (53563, 159, 29726, 21, 643, 227, 193);
INSERT INTO public.who_global_data VALUES (53564, 67, 2114, 2, 47, 227, 113);
INSERT INTO public.who_global_data VALUES (53565, 156, 12076, 9, 861, 227, 143);
INSERT INTO public.who_global_data VALUES (53566, 0, 0, 0, 0, 227, 219);
INSERT INTO public.who_global_data VALUES (53567, 0, 855, 0, 52, 227, 186);
INSERT INTO public.who_global_data VALUES (53568, 6, 189, 1, 10, 227, 52);
INSERT INTO public.who_global_data VALUES (53569, 0, 3, 0, 0, 227, 180);
INSERT INTO public.who_global_data VALUES (53570, 0, 26, 0, 3, 227, 167);
INSERT INTO public.who_global_data VALUES (53571, 2146, 44931, 33, 1049, 227, 154);
INSERT INTO public.who_global_data VALUES (53572, 711, 21030, 14, 381, 227, 94);
INSERT INTO public.who_global_data VALUES (53573, 0, 101, 0, 3, 227, 66);
INSERT INTO public.who_global_data VALUES (53574, 18, 7492, 0, 102, 227, 58);
INSERT INTO public.who_global_data VALUES (53575, 31, 17351, 3, 693, 227, 163);
INSERT INTO public.who_global_data VALUES (53576, 508, 13715, 6, 167, 227, 37);
INSERT INTO public.who_global_data VALUES (53577, 0, 104, 0, 11, 227, 142);
INSERT INTO public.who_global_data VALUES (53578, 655, 23062, 2, 67, 227, 83);
INSERT INTO public.who_global_data VALUES (53579, 3412, 119198, 43, 1545, 227, 228);
INSERT INTO public.who_global_data VALUES (53580, 0, 97, 0, 7, 227, 188);
INSERT INTO public.who_global_data VALUES (53581, 464, 59487, 6, 357, 227, 62);
INSERT INTO public.who_global_data VALUES (53582, 110, 61503, 4, 9594, 227, 160);
INSERT INTO public.who_global_data VALUES (53583, 1, 23, 0, 2, 227, 50);
INSERT INTO public.who_global_data VALUES (53584, 43, 850, 0, 13, 227, 33);
INSERT INTO public.who_global_data VALUES (53585, 0, 146, 0, 9, 227, 183);
INSERT INTO public.who_global_data VALUES (53586, 1, 70, 0, 0, 227, 92);
INSERT INTO public.who_global_data VALUES (53587, 1105, 25493, 47, 820, 227, 158);
INSERT INTO public.who_global_data VALUES (53588, 0, 2, 0, 0, 227, 67);
INSERT INTO public.who_global_data VALUES (53589, 63, 3587, 1, 171, 227, 57);
INSERT INTO public.who_global_data VALUES (53590, 0, 89, 0, 1, 227, 38);
INSERT INTO public.who_global_data VALUES (53591, 21432, 1106470, 654, 51271, 227, 141);
INSERT INTO public.who_global_data VALUES (53592, 0, 8, 0, 1, 227, 178);
INSERT INTO public.who_global_data VALUES (53593, 0, 141, 0, 3, 227, 108);
INSERT INTO public.who_global_data VALUES (53594, 130, 4114, 1, 208, 227, 39);
INSERT INTO public.who_global_data VALUES (53595, 0, 903, 0, 53, 227, 2);
INSERT INTO public.who_global_data VALUES (53596, 0, 144, 0, 1, 227, 195);
INSERT INTO public.who_global_data VALUES (53597, 39, 983, 0, 8, 227, 107);
INSERT INTO public.who_global_data VALUES (53598, 1, 130, 0, 0, 227, 161);
INSERT INTO public.who_global_data VALUES (53599, 149, 12041, 5, 308, 227, 212);
INSERT INTO public.who_global_data VALUES (53600, 300, 101637, 6, 8436, 227, 181);
INSERT INTO public.who_global_data VALUES (53601, 0, 195, 0, 1, 227, 53);
INSERT INTO public.who_global_data VALUES (53602, 88, 3051, 7, 37, 227, 164);
INSERT INTO public.who_global_data VALUES (53603, 2, 860, 0, 74, 227, 140);
INSERT INTO public.who_global_data VALUES (53604, 3804, 250767, 3, 4505, 227, 20);
INSERT INTO public.who_global_data VALUES (53605, 28, 85098, 1, 4647, 227, 112);
INSERT INTO public.who_global_data VALUES (53606, 2531, 71183, 73, 2310, 227, 111);
INSERT INTO public.who_global_data VALUES (53607, 18, 265, 2, 7, 227, 71);
INSERT INTO public.who_global_data VALUES (53608, 54, 1141, 0, 37, 227, 218);
INSERT INTO public.who_global_data VALUES (53609, 0, 0, 0, 0, 227, 43);
INSERT INTO public.who_global_data VALUES (53610, 64, 2277, 0, 12, 227, 49);
INSERT INTO public.who_global_data VALUES (53611, 227, 7904, 2, 58, 227, 1);
INSERT INTO public.who_global_data VALUES (53612, 30, 2366, 0, 107, 227, 48);
INSERT INTO public.who_global_data VALUES (53613, 3, 2318, 0, 85, 227, 232);
INSERT INTO public.who_global_data VALUES (53614, 1, 24, 0, 1, 227, 175);
INSERT INTO public.who_global_data VALUES (53615, 2, 990, 0, 19, 227, 21);
INSERT INTO public.who_global_data VALUES (53616, 89, 10650, 3, 339, 227, 156);
INSERT INTO public.who_global_data VALUES (53617, 0, 0, 0, 0, 227, 95);
INSERT INTO public.who_global_data VALUES (53618, 102, 6026, 0, 134, 227, 177);
INSERT INTO public.who_global_data VALUES (53619, 34, 12561, 1, 603, 227, 210);
INSERT INTO public.who_global_data VALUES (53620, 18, 4617, 1, 49, 227, 120);
INSERT INTO public.who_global_data VALUES (53621, 0, 18, 0, 0, 227, 135);
INSERT INTO public.who_global_data VALUES (53622, 566, 27936, 6, 675, 227, 206);
INSERT INTO public.who_global_data VALUES (53623, 728, 51643, 28, 4274, 227, 189);
INSERT INTO public.who_global_data VALUES (53624, 1332, 58141, 87, 2365, 227, 129);
INSERT INTO public.who_global_data VALUES (53625, 165, 4973, 6, 113, 227, 121);
INSERT INTO public.who_global_data VALUES (53626, 0, 1043, 0, 12, 227, 59);
INSERT INTO public.who_global_data VALUES (53627, 0, 143, 0, 0, 227, 96);
INSERT INTO public.who_global_data VALUES (53628, 1, 1982, 0, 63, 227, 41);
INSERT INTO public.who_global_data VALUES (53629, 31, 674, 1, 7, 227, 216);
INSERT INTO public.who_global_data VALUES (53630, 185, 4848, 0, 75, 227, 236);
INSERT INTO public.who_global_data VALUES (53631, 0, 13, 0, 0, 227, 150);
INSERT INTO public.who_global_data VALUES (53632, 0, 187, 0, 0, 227, 61);
INSERT INTO public.who_global_data VALUES (53633, 0, 18, 0, 0, 227, 7);
INSERT INTO public.who_global_data VALUES (53634, 11, 7155, 0, 327, 227, 169);
INSERT INTO public.who_global_data VALUES (53635, 364, 155256, 57, 29648, 227, 28);
INSERT INTO public.who_global_data VALUES (53636, 135, 2593, 0, 8, 227, 85);
INSERT INTO public.who_global_data VALUES (53637, 0, 60, 0, 0, 227, 211);
INSERT INTO public.who_global_data VALUES (53638, 110, 4849, 0, 39, 227, 60);
INSERT INTO public.who_global_data VALUES (53639, 1, 42, 0, 2, 227, 3);
INSERT INTO public.who_global_data VALUES (53640, 3, 914, 0, 14, 227, 11);
INSERT INTO public.who_global_data VALUES (53641, 587, 191449, 19, 8914, 227, 89);
INSERT INTO public.who_global_data VALUES (53642, 414, 14568, 10, 95, 227, 24);
INSERT INTO public.who_global_data VALUES (53643, 0, 176, 0, 0, 227, 162);
INSERT INTO public.who_global_data VALUES (53644, 15, 3302, 0, 190, 227, 100);
INSERT INTO public.who_global_data VALUES (53645, 0, 13, 0, 0, 227, 47);
INSERT INTO public.who_global_data VALUES (53646, 0, 23, 0, 0, 227, 29);
INSERT INTO public.who_global_data VALUES (53647, 0, 174, 0, 14, 227, 40);
INSERT INTO public.who_global_data VALUES (53648, 1, 217, 0, 5, 227, 222);
INSERT INTO public.who_global_data VALUES (53649, 624, 13769, 16, 547, 227, 132);
INSERT INTO public.who_global_data VALUES (53650, 0, 252, 0, 13, 227, 130);
INSERT INTO public.who_global_data VALUES (53651, 116, 5104, 2, 29, 227, 234);
INSERT INTO public.who_global_data VALUES (53652, 0, 1556, 0, 19, 227, 23);
INSERT INTO public.who_global_data VALUES (53653, 21, 205, 0, 12, 227, 192);
INSERT INTO public.who_global_data VALUES (53654, 5, 5216, 0, 88, 227, 69);
INSERT INTO public.who_global_data VALUES (53655, 0, 12, 0, 0, 227, 187);
INSERT INTO public.who_global_data VALUES (53656, 531, 13356, 32, 395, 227, 230);
INSERT INTO public.who_global_data VALUES (53657, 0, 4107, 0, 573, 227, 77);
INSERT INTO public.who_global_data VALUES (53658, 0, 1815, 0, 10, 227, 9);
INSERT INTO public.who_global_data VALUES (53659, 15968, 456183, 465, 14476, 227, 74);
INSERT INTO public.who_global_data VALUES (53660, 1051, 47896, 35, 2535, 227, 224);
INSERT INTO public.who_global_data VALUES (53661, 2445, 209970, 121, 9863, 227, 199);
INSERT INTO public.who_global_data VALUES (53662, 1826, 34502, 84, 1251, 227, 190);
INSERT INTO public.who_global_data VALUES (53663, 8, 25391, 3, 1720, 227, 12);
INSERT INTO public.who_global_data VALUES (53664, 0, 336, 0, 24, 227, 104);
INSERT INTO public.who_global_data VALUES (53665, 345, 21201, 1, 309, 227, 153);
INSERT INTO public.who_global_data VALUES (53666, 113, 238833, 18, 34675, 227, 91);
INSERT INTO public.who_global_data VALUES (53667, 6, 665, 0, 10, 227, 215);
INSERT INTO public.who_global_data VALUES (53668, 56, 18024, 8, 963, 227, 84);
INSERT INTO public.who_global_data VALUES (53669, 0, 318, 0, 31, 227, 231);
INSERT INTO public.who_global_data VALUES (53670, 4, 980, 0, 9, 227, 196);
INSERT INTO public.who_global_data VALUES (53671, 1476, 23672, 2, 136, 227, 105);
INSERT INTO public.who_global_data VALUES (53672, 155, 4952, 3, 128, 227, 122);
INSERT INTO public.who_global_data VALUES (53673, 0, 0, 0, 0, 227, 159);
INSERT INTO public.who_global_data VALUES (53674, 52, 2225, 1, 28, 227, 75);
INSERT INTO public.who_global_data VALUES (53675, 742, 41033, 4, 334, 227, 27);
INSERT INTO public.who_global_data VALUES (53676, 207, 3726, 1, 42, 227, 54);
INSERT INTO public.who_global_data VALUES (53677, 0, 19, 0, 0, 227, 226);
INSERT INTO public.who_global_data VALUES (53678, 0, 1111, 0, 30, 227, 79);
INSERT INTO public.who_global_data VALUES (53679, 19, 1622, 0, 32, 227, 56);
INSERT INTO public.who_global_data VALUES (53680, 5, 17, 0, 0, 227, 117);
INSERT INTO public.who_global_data VALUES (53681, 2, 652, 0, 34, 227, 152);
INSERT INTO public.who_global_data VALUES (53682, 68, 639, 7, 17, 227, 16);
INSERT INTO public.who_global_data VALUES (53683, 0, 83, 0, 1, 227, 10);
INSERT INTO public.who_global_data VALUES (53684, 1, 1799, 1, 78, 227, 201);
INSERT INTO public.who_global_data VALUES (53685, 12, 4133, 0, 110, 227, 174);
INSERT INTO public.who_global_data VALUES (53686, 0, 1640, 0, 15, 227, 119);
INSERT INTO public.who_global_data VALUES (53687, 58, 803, 0, 11, 227, 168);
INSERT INTO public.who_global_data VALUES (53688, 3, 8590, 0, 121, 227, 99);
INSERT INTO public.who_global_data VALUES (53689, 21, 2238, 0, 8, 227, 171);
INSERT INTO public.who_global_data VALUES (53690, 17, 1978, 0, 111, 227, 87);
INSERT INTO public.who_global_data VALUES (53691, 0, 664, 0, 9, 227, 123);
INSERT INTO public.who_global_data VALUES (53692, 0, 0, 0, 0, 227, 151);
INSERT INTO public.who_global_data VALUES (53693, 0, 236, 0, 14, 227, 213);
INSERT INTO public.who_global_data VALUES (53694, 137, 3121, 1, 112, 227, 118);
INSERT INTO public.who_global_data VALUES (53695, 0, 340, 0, 10, 227, 134);
INSERT INTO public.who_global_data VALUES (53696, 18, 2452, 0, 32, 227, 65);
INSERT INTO public.who_global_data VALUES (53697, 4577, 185122, 759, 22584, 227, 102);
INSERT INTO public.who_global_data VALUES (53698, 0, 0, 0, 0, 227, 223);
INSERT INTO public.who_global_data VALUES (53699, 0, 71, 0, 1, 227, 4);
INSERT INTO public.who_global_data VALUES (53700, 2, 215, 0, 0, 227, 146);
INSERT INTO public.who_global_data VALUES (53701, 12, 395, 0, 9, 227, 31);
INSERT INTO public.who_global_data VALUES (53702, 0, 11, 0, 1, 227, 127);
INSERT INTO public.who_global_data VALUES (53703, 172, 10344, 0, 214, 227, 22);
INSERT INTO public.who_global_data VALUES (53704, 20, 757, 0, 5, 227, 115);
INSERT INTO public.who_global_data VALUES (53705, 1, 292, 0, 6, 227, 106);
INSERT INTO public.who_global_data VALUES (53706, 9, 72, 0, 0, 227, 90);
INSERT INTO public.who_global_data VALUES (53707, 0, 0, 0, 0, 227, 70);
INSERT INTO public.who_global_data VALUES (53708, 538, 10099, 1, 24, 227, 46);
INSERT INTO public.who_global_data VALUES (53709, 70, 49500, 5, 6068, 227, 139);
INSERT INTO public.who_global_data VALUES (53710, 0, 21, 0, 0, 227, 42);
INSERT INTO public.who_global_data VALUES (53711, 1, 1166, 0, 22, 227, 80);
INSERT INTO public.who_global_data VALUES (53712, 0, 2014, 0, 64, 227, 203);
INSERT INTO public.who_global_data VALUES (53713, 5, 1051, 0, 67, 227, 136);
INSERT INTO public.who_global_data VALUES (53714, 452, 21371, 8, 533, 227, 63);
INSERT INTO public.who_global_data VALUES (53715, 0, 0, 0, 0, 227, 17);
INSERT INTO public.who_global_data VALUES (53716, 0, 30, 0, 2, 227, 172);
INSERT INTO public.who_global_data VALUES (53717, 118, 5314, 4, 251, 227, 109);
INSERT INTO public.who_global_data VALUES (53718, 6, 8751, 0, 248, 227, 200);
INSERT INTO public.who_global_data VALUES (53719, 179, 1375, 0, 5, 227, 93);
INSERT INTO public.who_global_data VALUES (53720, 1318, 32394, 3, 140, 227, 5);
INSERT INTO public.who_global_data VALUES (53721, 0, 741, 0, 13, 227, 214);
INSERT INTO public.who_global_data VALUES (53722, 3892, 188926, 60, 3755, 227, 204);
INSERT INTO public.who_global_data VALUES (53723, 0, 0, 0, 0, 227, 198);
INSERT INTO public.who_global_data VALUES (53724, 722, 26752, 20, 521, 227, 173);
INSERT INTO public.who_global_data VALUES (53725, 0, 9, 0, 0, 227, 229);
INSERT INTO public.who_global_data VALUES (53726, 30, 1422, 0, 13, 227, 76);
INSERT INTO public.who_global_data VALUES (53727, 2511, 257447, 178, 8223, 227, 138);
INSERT INTO public.who_global_data VALUES (53728, 1143, 31825, 9, 1186, 227, 98);
INSERT INTO public.who_global_data VALUES (53729, 0, 0, 0, 0, 227, 103);
INSERT INTO public.who_global_data VALUES (53730, 300, 32527, 16, 1375, 227, 225);
INSERT INTO public.who_global_data VALUES (53731, 345, 39737, 6, 1540, 227, 131);
INSERT INTO public.who_global_data VALUES (53732, 121, 6685, 0, 149, 227, 235);
INSERT INTO public.who_global_data VALUES (53733, 1176, 89579, 0, 99, 227, 137);
INSERT INTO public.who_global_data VALUES (53734, 51, 12535, 0, 281, 227, 81);
INSERT INTO public.who_global_data VALUES (53735, 351, 14714, 8, 492, 227, 182);
INSERT INTO public.who_global_data VALUES (53736, 0, 507, 0, 1, 227, 145);
INSERT INTO public.who_global_data VALUES (53737, 214, 24505, 16, 1539, 227, 26);
INSERT INTO public.who_global_data VALUES (53738, 7176, 606881, 154, 8513, 227, 170);
INSERT INTO public.who_global_data VALUES (53739, 11, 798, 0, 2, 227, 191);
INSERT INTO public.who_global_data VALUES (53740, 0, 3, 0, 0, 227, 221);
INSERT INTO public.who_global_data VALUES (53741, 0, 6, 0, 0, 227, 64);
INSERT INTO public.who_global_data VALUES (53742, 0, 0, 0, 0, 227, 116);
INSERT INTO public.who_global_data VALUES (53743, 0, 15, 0, 0, 227, 128);
INSERT INTO public.who_global_data VALUES (53744, 0, 19, 0, 0, 227, 6);
INSERT INTO public.who_global_data VALUES (53745, 0, 42, 0, 3, 227, 227);
INSERT INTO public.who_global_data VALUES (53746, 0, 1, 0, 0, 227, 68);
INSERT INTO public.who_global_data VALUES (53747, 0, 29, 0, 0, 227, 184);
INSERT INTO public.who_global_data VALUES (53748, 0, 0, 0, 0, 227, 82);
INSERT INTO public.who_global_data VALUES (53749, 0, 713, 0, 42, 227, 149);
INSERT INTO public.who_global_data VALUES (53750, 0, 388, 0, 10, 227, 197);
INSERT INTO public.who_global_data VALUES (53751, 3139, 164144, 39, 1346, 227, 78);
INSERT INTO public.who_global_data VALUES (53752, 64, 6034, 3, 89, 227, 233);
INSERT INTO public.who_global_data VALUES (53753, 102, 13092, 1, 263, 227, 133);
INSERT INTO public.who_global_data VALUES (53754, 0, 11, 0, 0, 227, 35);
INSERT INTO public.who_global_data VALUES (53755, 7, 1347, 0, 55, 227, 114);
INSERT INTO public.who_global_data VALUES (53756, 119, 42432, 0, 26, 227, 237);
INSERT INTO public.who_global_data VALUES (53757, 0, 2, 0, 0, 227, 55);
INSERT INTO public.who_global_data VALUES (53758, 0, 77, 0, 15, 227, 176);
INSERT INTO public.who_global_data VALUES (53759, 1, 1589, 0, 28, 227, 202);
INSERT INTO public.who_global_data VALUES (53760, 6, 1540, 0, 114, 227, 155);
INSERT INTO public.who_global_data VALUES (53761, 0, 0, 0, 0, 227, 32);
INSERT INTO public.who_global_data VALUES (53762, 23, 2835, 0, 90, 227, 220);
INSERT INTO public.who_global_data VALUES (53763, 4518, 106108, 111, 2102, 227, 30);
INSERT INTO public.who_global_data VALUES (53764, 24, 1916, 1, 35, 227, 147);
INSERT INTO public.who_global_data VALUES (53765, 260, 255454, 7, 29671, 227, 208);
INSERT INTO public.who_global_data VALUES (53766, 40, 1991, 0, 11, 227, 45);
INSERT INTO public.who_global_data VALUES (53767, 91, 8887, 7, 548, 227, 110);
INSERT INTO public.who_global_data VALUES (53768, 1, 319, 1, 9, 227, 88);
INSERT INTO public.who_global_data VALUES (53769, 800, 59675, 20, 5360, 227, 51);
INSERT INTO public.who_global_data VALUES (53770, 37, 31345, 0, 1722, 227, 209);
INSERT INTO public.who_global_data VALUES (53771, 12, 231, 0, 7, 227, 205);
INSERT INTO public.who_global_data VALUES (53772, 54, 5567, 0, 52, 227, 18);
INSERT INTO public.who_global_data VALUES (53773, 1, 3157, 0, 58, 227, 72);
INSERT INTO public.who_global_data VALUES (53774, 896, 279394, 94, 39986, 227, 44);
INSERT INTO public.who_global_data VALUES (53775, 0, 24, 0, 0, 227, 15);
INSERT INTO public.who_global_data VALUES (53776, 7, 576, 0, 13, 227, 25);
INSERT INTO public.who_global_data VALUES (53777, 0, 0, 0, 0, 227, 179);
INSERT INTO public.who_global_data VALUES (53778, 0, 0, 0, 0, 227, 34);
INSERT INTO public.who_global_data VALUES (53779, 0, 123, 0, 8, 227, 207);
INSERT INTO public.who_global_data VALUES (53780, 1, 1160, 0, 50, 227, 166);
INSERT INTO public.who_global_data VALUES (53781, 1268, 190165, 27, 5001, 227, 126);
INSERT INTO public.who_global_data VALUES (53782, 0, 0, 0, 0, 227, 97);
INSERT INTO public.who_global_data VALUES (53783, 0, 14, 0, 1, 227, 36);
INSERT INTO public.who_global_data VALUES (53784, 0, 0, 0, 0, 227, 125);
INSERT INTO public.who_global_data VALUES (53785, 23, 797, 0, 0, 227, 124);
INSERT INTO public.who_global_data VALUES (53786, 940, 39014, 16, 1051, 227, 185);
INSERT INTO public.who_global_data VALUES (53787, 380, 45683, 2, 305, 227, 194);
INSERT INTO public.who_global_data VALUES (53788, 0, 509, 0, 21, 227, 144);
INSERT INTO public.who_global_data VALUES (53789, 26519, 2295272, 410, 120171, 227, 19);
INSERT INTO public.who_global_data VALUES (53790, 0, 76, 0, 6, 227, 217);
INSERT INTO public.who_global_data VALUES (53791, 6, 882, 0, 25, 227, 148);
INSERT INTO public.who_global_data VALUES (53792, 255, 6755, 0, 19, 227, 86);
INSERT INTO public.who_global_data VALUES (53793, 0, 0, 0, 0, 227, 13);
INSERT INTO public.who_global_data VALUES (53794, 130, 4048, 2, 35, 227, 157);
INSERT INTO public.who_global_data VALUES (53795, 0, 349, 0, 0, 227, 8);
INSERT INTO public.who_global_data VALUES (53796, 0, 0, 0, 0, 227, 73);
INSERT INTO public.who_global_data VALUES (53797, 25, 992, 4, 261, 227, 101);
INSERT INTO public.who_global_data VALUES (53798, 47, 1477, 7, 18, 227, 165);
INSERT INTO public.who_global_data VALUES (53799, 13, 525, 0, 6, 227, 14);
INSERT INTO public.who_global_data VALUES (53800, 338, 29567, 20, 622, 228, 193);
INSERT INTO public.who_global_data VALUES (53801, 52, 2047, 1, 45, 228, 113);
INSERT INTO public.who_global_data VALUES (53802, 149, 11920, 7, 852, 228, 143);
INSERT INTO public.who_global_data VALUES (53803, 0, 0, 0, 0, 228, 219);
INSERT INTO public.who_global_data VALUES (53804, 0, 855, 0, 52, 228, 186);
INSERT INTO public.who_global_data VALUES (53805, 7, 183, 0, 9, 228, 52);
INSERT INTO public.who_global_data VALUES (53806, 0, 3, 0, 0, 228, 180);
INSERT INTO public.who_global_data VALUES (53807, 0, 26, 0, 3, 228, 167);
INSERT INTO public.who_global_data VALUES (53808, 1581, 42785, 24, 1016, 228, 154);
INSERT INTO public.who_global_data VALUES (53809, 418, 20319, 12, 367, 228, 94);
INSERT INTO public.who_global_data VALUES (53810, 0, 101, 0, 3, 228, 66);
INSERT INTO public.who_global_data VALUES (53811, 13, 7474, 0, 102, 228, 58);
INSERT INTO public.who_global_data VALUES (53812, 35, 17320, 0, 690, 228, 163);
INSERT INTO public.who_global_data VALUES (53813, 478, 13207, 7, 161, 228, 37);
INSERT INTO public.who_global_data VALUES (53814, 0, 104, 0, 11, 228, 142);
INSERT INTO public.who_global_data VALUES (53815, 643, 22407, 2, 65, 228, 83);
INSERT INTO public.who_global_data VALUES (53816, 3480, 115786, 38, 1502, 228, 228);
INSERT INTO public.who_global_data VALUES (53817, 0, 97, 0, 7, 228, 188);
INSERT INTO public.who_global_data VALUES (53818, 518, 59023, 5, 351, 228, 62);
INSERT INTO public.who_global_data VALUES (53819, 143, 61393, 12, 9590, 228, 160);
INSERT INTO public.who_global_data VALUES (53820, 0, 22, 0, 2, 228, 50);
INSERT INTO public.who_global_data VALUES (53821, 42, 807, 0, 13, 228, 33);
INSERT INTO public.who_global_data VALUES (53822, 0, 146, 0, 9, 228, 183);
INSERT INTO public.who_global_data VALUES (53823, 1, 69, 0, 0, 228, 92);
INSERT INTO public.who_global_data VALUES (53824, 876, 24388, 33, 773, 228, 158);
INSERT INTO public.who_global_data VALUES (53825, 0, 2, 0, 0, 228, 67);
INSERT INTO public.who_global_data VALUES (53826, 93, 3524, 1, 170, 228, 57);
INSERT INTO public.who_global_data VALUES (53827, 0, 89, 0, 1, 228, 38);
INSERT INTO public.who_global_data VALUES (53828, 17459, 1085038, 641, 50617, 228, 141);
INSERT INTO public.who_global_data VALUES (53829, 0, 8, 0, 1, 228, 178);
INSERT INTO public.who_global_data VALUES (53830, 0, 141, 0, 3, 228, 108);
INSERT INTO public.who_global_data VALUES (53831, 79, 3984, 8, 207, 228, 39);
INSERT INTO public.who_global_data VALUES (53832, 2, 903, 0, 53, 228, 2);
INSERT INTO public.who_global_data VALUES (53833, 0, 144, 0, 1, 228, 195);
INSERT INTO public.who_global_data VALUES (53834, 54, 944, 0, 8, 228, 107);
INSERT INTO public.who_global_data VALUES (53835, 0, 129, 0, 0, 228, 161);
INSERT INTO public.who_global_data VALUES (53836, 611, 11892, 3, 303, 228, 212);
INSERT INTO public.who_global_data VALUES (53837, 318, 101337, 20, 8430, 228, 181);
INSERT INTO public.who_global_data VALUES (53838, 0, 195, 0, 1, 228, 53);
INSERT INTO public.who_global_data VALUES (53839, 155, 2963, 7, 30, 228, 164);
INSERT INTO public.who_global_data VALUES (53840, 0, 858, 0, 74, 228, 140);
INSERT INTO public.who_global_data VALUES (53841, 4608, 246963, 23, 4502, 228, 20);
INSERT INTO public.who_global_data VALUES (53842, 52, 85070, 0, 4646, 228, 112);
INSERT INTO public.who_global_data VALUES (53843, 3019, 68652, 111, 2237, 228, 111);
INSERT INTO public.who_global_data VALUES (53844, 0, 247, 0, 5, 228, 71);
INSERT INTO public.who_global_data VALUES (53845, 204, 1087, 10, 37, 228, 218);
INSERT INTO public.who_global_data VALUES (53846, 0, 0, 0, 0, 228, 43);
INSERT INTO public.who_global_data VALUES (53847, 86, 2213, 0, 12, 228, 49);
INSERT INTO public.who_global_data VALUES (53848, 185, 7677, 2, 56, 228, 1);
INSERT INTO public.who_global_data VALUES (53849, 19, 2336, 0, 107, 228, 48);
INSERT INTO public.who_global_data VALUES (53850, 3, 2315, 0, 85, 228, 232);
INSERT INTO public.who_global_data VALUES (53851, 0, 23, 0, 1, 228, 175);
INSERT INTO public.who_global_data VALUES (53852, 2, 988, 0, 19, 228, 21);
INSERT INTO public.who_global_data VALUES (53853, 63, 10561, 0, 336, 228, 156);
INSERT INTO public.who_global_data VALUES (53854, 0, 0, 0, 0, 228, 95);
INSERT INTO public.who_global_data VALUES (53855, 99, 5924, 5, 134, 228, 177);
INSERT INTO public.who_global_data VALUES (53856, 136, 12527, 2, 602, 228, 210);
INSERT INTO public.who_global_data VALUES (53857, 17, 4599, 3, 48, 228, 120);
INSERT INTO public.who_global_data VALUES (53858, 0, 18, 0, 0, 228, 135);
INSERT INTO public.who_global_data VALUES (53859, 693, 27370, 7, 669, 228, 206);
INSERT INTO public.who_global_data VALUES (53860, 275, 50915, 23, 4246, 228, 189);
INSERT INTO public.who_global_data VALUES (53861, 1576, 56809, 85, 2278, 228, 129);
INSERT INTO public.who_global_data VALUES (53862, 182, 4808, 9, 107, 228, 121);
INSERT INTO public.who_global_data VALUES (53863, 0, 1043, 0, 12, 228, 59);
INSERT INTO public.who_global_data VALUES (53864, 0, 143, 0, 0, 228, 96);
INSERT INTO public.who_global_data VALUES (53865, 0, 1981, 0, 63, 228, 41);
INSERT INTO public.who_global_data VALUES (53866, 8, 643, 1, 6, 228, 216);
INSERT INTO public.who_global_data VALUES (53867, 131, 4663, 1, 75, 228, 236);
INSERT INTO public.who_global_data VALUES (53868, 0, 13, 0, 0, 228, 150);
INSERT INTO public.who_global_data VALUES (53869, 0, 187, 0, 0, 228, 61);
INSERT INTO public.who_global_data VALUES (53870, 0, 18, 0, 0, 228, 7);
INSERT INTO public.who_global_data VALUES (53871, 1, 7144, 1, 327, 228, 169);
INSERT INTO public.who_global_data VALUES (53872, 325, 154892, 20, 29591, 228, 28);
INSERT INTO public.who_global_data VALUES (53873, 17, 2458, 2, 8, 228, 85);
INSERT INTO public.who_global_data VALUES (53874, 0, 60, 0, 0, 228, 211);
INSERT INTO public.who_global_data VALUES (53875, 311, 4739, 5, 39, 228, 60);
INSERT INTO public.who_global_data VALUES (53876, 4, 41, 0, 2, 228, 3);
INSERT INTO public.who_global_data VALUES (53877, 3, 911, 0, 14, 228, 11);
INSERT INTO public.who_global_data VALUES (53878, 503, 190862, 10, 8895, 228, 89);
INSERT INTO public.who_global_data VALUES (53879, 0, 14154, 0, 85, 228, 24);
INSERT INTO public.who_global_data VALUES (53880, 0, 176, 0, 0, 228, 162);
INSERT INTO public.who_global_data VALUES (53881, 21, 3287, 0, 190, 228, 100);
INSERT INTO public.who_global_data VALUES (53882, 0, 13, 0, 0, 228, 47);
INSERT INTO public.who_global_data VALUES (53883, 0, 23, 0, 0, 228, 29);
INSERT INTO public.who_global_data VALUES (53884, 0, 174, 0, 14, 228, 40);
INSERT INTO public.who_global_data VALUES (53885, 2, 216, 0, 5, 228, 222);
INSERT INTO public.who_global_data VALUES (53886, 390, 13145, 17, 531, 228, 132);
INSERT INTO public.who_global_data VALUES (53887, 0, 252, 0, 13, 228, 130);
INSERT INTO public.who_global_data VALUES (53888, 0, 4988, 0, 27, 228, 234);
INSERT INTO public.who_global_data VALUES (53889, 44, 1556, 3, 19, 228, 23);
INSERT INTO public.who_global_data VALUES (53890, 1, 184, 0, 12, 228, 192);
INSERT INTO public.who_global_data VALUES (53891, 134, 5211, 0, 88, 228, 69);
INSERT INTO public.who_global_data VALUES (53892, 0, 12, 0, 0, 228, 187);
INSERT INTO public.who_global_data VALUES (53893, 519, 12825, 5, 363, 228, 230);
INSERT INTO public.who_global_data VALUES (53894, 5, 4107, 1, 573, 228, 77);
INSERT INTO public.who_global_data VALUES (53895, 0, 1815, 0, 10, 228, 9);
INSERT INTO public.who_global_data VALUES (53896, 14933, 440215, 312, 14011, 228, 74);
INSERT INTO public.who_global_data VALUES (53897, 954, 46845, 35, 2500, 228, 224);
INSERT INTO public.who_global_data VALUES (53898, 2573, 207525, 119, 9742, 228, 199);
INSERT INTO public.who_global_data VALUES (53899, 1808, 32676, 67, 1167, 228, 190);
INSERT INTO public.who_global_data VALUES (53900, 4, 25383, 2, 1717, 228, 12);
INSERT INTO public.who_global_data VALUES (53901, 0, 336, 0, 24, 228, 104);
INSERT INTO public.who_global_data VALUES (53902, 173, 20856, 0, 308, 228, 153);
INSERT INTO public.who_global_data VALUES (53903, 221, 238720, 23, 34657, 228, 91);
INSERT INTO public.who_global_data VALUES (53904, 2, 659, 0, 10, 228, 215);
INSERT INTO public.who_global_data VALUES (53905, 52, 17968, 2, 955, 228, 84);
INSERT INTO public.who_global_data VALUES (53906, 0, 318, 0, 31, 228, 231);
INSERT INTO public.who_global_data VALUES (53907, 9, 976, 0, 9, 228, 196);
INSERT INTO public.who_global_data VALUES (53908, 1630, 22196, 7, 134, 228, 105);
INSERT INTO public.who_global_data VALUES (53909, 59, 4797, 2, 125, 228, 122);
INSERT INTO public.who_global_data VALUES (53910, 0, 0, 0, 0, 228, 159);
INSERT INTO public.who_global_data VALUES (53911, 47, 2173, 1, 27, 228, 75);
INSERT INTO public.who_global_data VALUES (53912, 641, 40291, 4, 330, 228, 27);
INSERT INTO public.who_global_data VALUES (53913, 163, 3519, 1, 41, 228, 54);
INSERT INTO public.who_global_data VALUES (53914, 0, 19, 0, 0, 228, 226);
INSERT INTO public.who_global_data VALUES (53915, 0, 1111, 0, 30, 228, 79);
INSERT INTO public.who_global_data VALUES (53916, 16, 1603, 0, 32, 228, 56);
INSERT INTO public.who_global_data VALUES (53917, 8, 12, 0, 0, 228, 117);
INSERT INTO public.who_global_data VALUES (53918, 24, 650, 0, 34, 228, 152);
INSERT INTO public.who_global_data VALUES (53919, 0, 571, 0, 10, 228, 16);
INSERT INTO public.who_global_data VALUES (53920, 0, 83, 0, 1, 228, 10);
INSERT INTO public.who_global_data VALUES (53921, 2, 1798, 1, 77, 228, 201);
INSERT INTO public.who_global_data VALUES (53922, 1, 4121, 0, 110, 228, 174);
INSERT INTO public.who_global_data VALUES (53923, 44, 1640, 1, 15, 228, 119);
INSERT INTO public.who_global_data VALUES (53924, 15, 745, 0, 11, 228, 168);
INSERT INTO public.who_global_data VALUES (53925, 15, 8587, 0, 121, 228, 99);
INSERT INTO public.who_global_data VALUES (53926, 14, 2217, 0, 8, 228, 171);
INSERT INTO public.who_global_data VALUES (53927, 0, 1961, 0, 111, 228, 87);
INSERT INTO public.who_global_data VALUES (53928, 0, 664, 0, 9, 228, 123);
INSERT INTO public.who_global_data VALUES (53929, 0, 0, 0, 0, 228, 151);
INSERT INTO public.who_global_data VALUES (53930, 0, 236, 0, 14, 228, 213);
INSERT INTO public.who_global_data VALUES (53931, 171, 2984, 3, 111, 228, 118);
INSERT INTO public.who_global_data VALUES (53932, 3, 340, 0, 10, 228, 134);
INSERT INTO public.who_global_data VALUES (53933, 30, 2434, 1, 32, 228, 65);
INSERT INTO public.who_global_data VALUES (53934, 5343, 180545, 1044, 21825, 228, 102);
INSERT INTO public.who_global_data VALUES (53935, 0, 0, 0, 0, 228, 223);
INSERT INTO public.who_global_data VALUES (53936, 0, 71, 0, 1, 228, 4);
INSERT INTO public.who_global_data VALUES (53937, 7, 213, 0, 0, 228, 146);
INSERT INTO public.who_global_data VALUES (53938, 16, 383, 0, 9, 228, 31);
INSERT INTO public.who_global_data VALUES (53939, 0, 11, 0, 1, 228, 127);
INSERT INTO public.who_global_data VALUES (53940, 195, 10172, 0, 214, 228, 22);
INSERT INTO public.who_global_data VALUES (53941, 4, 737, 0, 5, 228, 115);
INSERT INTO public.who_global_data VALUES (53942, 1, 291, 0, 6, 228, 106);
INSERT INTO public.who_global_data VALUES (53943, 8, 63, 0, 0, 228, 90);
INSERT INTO public.who_global_data VALUES (53944, 0, 0, 0, 0, 228, 70);
INSERT INTO public.who_global_data VALUES (53945, 535, 9561, 0, 23, 228, 46);
INSERT INTO public.who_global_data VALUES (53946, 68, 49430, 0, 6063, 228, 139);
INSERT INTO public.who_global_data VALUES (53947, 0, 21, 0, 0, 228, 42);
INSERT INTO public.who_global_data VALUES (53948, 2, 1165, 0, 22, 228, 80);
INSERT INTO public.who_global_data VALUES (53949, 0, 2014, 0, 64, 228, 203);
INSERT INTO public.who_global_data VALUES (53950, 10, 1046, 0, 67, 228, 136);
INSERT INTO public.who_global_data VALUES (53951, 675, 20919, 7, 525, 228, 63);
INSERT INTO public.who_global_data VALUES (53952, 0, 0, 0, 0, 228, 17);
INSERT INTO public.who_global_data VALUES (53953, 0, 30, 0, 2, 228, 172);
INSERT INTO public.who_global_data VALUES (53954, 90, 5196, 9, 247, 228, 109);
INSERT INTO public.who_global_data VALUES (53955, 37, 8745, 4, 248, 228, 200);
INSERT INTO public.who_global_data VALUES (53956, 168, 1196, 0, 5, 228, 93);
INSERT INTO public.who_global_data VALUES (53957, 1605, 31076, 6, 137, 228, 5);
INSERT INTO public.who_global_data VALUES (53958, 0, 741, 0, 13, 228, 214);
INSERT INTO public.who_global_data VALUES (53959, 3946, 185034, 105, 3695, 228, 204);
INSERT INTO public.who_global_data VALUES (53960, 0, 0, 0, 0, 228, 198);
INSERT INTO public.who_global_data VALUES (53961, 808, 26030, 8, 501, 228, 173);
INSERT INTO public.who_global_data VALUES (53962, 0, 9, 0, 0, 228, 229);
INSERT INTO public.who_global_data VALUES (53963, 13, 1392, 0, 13, 228, 76);
INSERT INTO public.who_global_data VALUES (53964, 3598, 254936, 184, 8045, 228, 138);
INSERT INTO public.who_global_data VALUES (53965, 630, 30682, 8, 1177, 228, 98);
INSERT INTO public.who_global_data VALUES (53966, 0, 0, 0, 0, 228, 103);
INSERT INTO public.who_global_data VALUES (53967, 296, 32227, 3, 1359, 228, 225);
INSERT INTO public.who_global_data VALUES (53968, 259, 39392, 4, 1534, 228, 131);
INSERT INTO public.who_global_data VALUES (53969, 39, 6564, 0, 149, 228, 235);
INSERT INTO public.who_global_data VALUES (53970, 1034, 88403, 1, 99, 228, 137);
INSERT INTO public.who_global_data VALUES (53971, 46, 12484, 1, 281, 228, 81);
INSERT INTO public.who_global_data VALUES (53972, 163, 14363, 9, 484, 228, 182);
INSERT INTO public.who_global_data VALUES (53973, 1, 507, 0, 1, 228, 145);
INSERT INTO public.who_global_data VALUES (53974, 246, 24291, 11, 1523, 228, 26);
INSERT INTO public.who_global_data VALUES (53975, 7425, 599705, 153, 8359, 228, 170);
INSERT INTO public.who_global_data VALUES (53976, 59, 787, 0, 2, 228, 191);
INSERT INTO public.who_global_data VALUES (53977, 0, 3, 0, 0, 228, 221);
INSERT INTO public.who_global_data VALUES (53978, 0, 6, 0, 0, 228, 64);
INSERT INTO public.who_global_data VALUES (53979, 0, 0, 0, 0, 228, 116);
INSERT INTO public.who_global_data VALUES (53980, 0, 15, 0, 0, 228, 128);
INSERT INTO public.who_global_data VALUES (53981, 0, 19, 0, 0, 228, 6);
INSERT INTO public.who_global_data VALUES (53982, 0, 42, 0, 3, 228, 227);
INSERT INTO public.who_global_data VALUES (53983, 0, 1, 0, 0, 228, 68);
INSERT INTO public.who_global_data VALUES (53984, 0, 29, 0, 0, 228, 184);
INSERT INTO public.who_global_data VALUES (53985, 0, 0, 0, 0, 228, 82);
INSERT INTO public.who_global_data VALUES (53986, 0, 713, 0, 42, 228, 149);
INSERT INTO public.who_global_data VALUES (53987, 0, 388, 0, 10, 228, 197);
INSERT INTO public.who_global_data VALUES (53988, 3393, 161005, 40, 1307, 228, 78);
INSERT INTO public.who_global_data VALUES (53989, 82, 5970, 2, 86, 228, 233);
INSERT INTO public.who_global_data VALUES (53990, 96, 12990, 1, 262, 228, 133);
INSERT INTO public.who_global_data VALUES (53991, 0, 11, 0, 0, 228, 35);
INSERT INTO public.who_global_data VALUES (53992, 13, 1340, 0, 55, 228, 114);
INSERT INTO public.who_global_data VALUES (53993, 218, 42313, 0, 26, 228, 237);
INSERT INTO public.who_global_data VALUES (53994, 0, 2, 0, 0, 228, 55);
INSERT INTO public.who_global_data VALUES (53995, 0, 77, 0, 15, 228, 176);
INSERT INTO public.who_global_data VALUES (53996, 1, 1588, 0, 28, 228, 202);
INSERT INTO public.who_global_data VALUES (53997, 13, 1534, 0, 114, 228, 155);
INSERT INTO public.who_global_data VALUES (53998, 0, 0, 0, 0, 228, 32);
INSERT INTO public.who_global_data VALUES (53999, 33, 2812, 0, 90, 228, 220);
INSERT INTO public.who_global_data VALUES (54000, 4288, 101590, 61, 1991, 228, 30);
INSERT INTO public.who_global_data VALUES (54001, 10, 1892, 0, 34, 228, 147);
INSERT INTO public.who_global_data VALUES (54002, 172, 255194, 15, 29664, 228, 208);
INSERT INTO public.who_global_data VALUES (54003, 1, 1951, 0, 11, 228, 45);
INSERT INTO public.who_global_data VALUES (54004, 98, 8796, 8, 541, 228, 110);
INSERT INTO public.who_global_data VALUES (54005, 16, 318, 0, 8, 228, 88);
INSERT INTO public.who_global_data VALUES (54006, 321, 58875, 22, 5340, 228, 51);
INSERT INTO public.who_global_data VALUES (54007, 56, 31308, 1, 1722, 228, 209);
INSERT INTO public.who_global_data VALUES (54008, 15, 219, 0, 7, 228, 205);
INSERT INTO public.who_global_data VALUES (54009, 56, 5513, 0, 52, 228, 18);
INSERT INTO public.who_global_data VALUES (54010, 5, 3156, 0, 58, 228, 72);
INSERT INTO public.who_global_data VALUES (54011, 639, 278498, 14, 39892, 228, 44);
INSERT INTO public.who_global_data VALUES (54012, 0, 24, 0, 0, 228, 15);
INSERT INTO public.who_global_data VALUES (54013, 0, 569, 0, 13, 228, 25);
INSERT INTO public.who_global_data VALUES (54014, 0, 0, 0, 0, 228, 179);
INSERT INTO public.who_global_data VALUES (54015, 0, 0, 0, 0, 228, 34);
INSERT INTO public.who_global_data VALUES (54016, 0, 123, 0, 8, 228, 207);
INSERT INTO public.who_global_data VALUES (54017, 0, 1159, 0, 50, 228, 166);
INSERT INTO public.who_global_data VALUES (54018, 1212, 188897, 24, 4974, 228, 126);
INSERT INTO public.who_global_data VALUES (54019, 0, 0, 0, 0, 228, 97);
INSERT INTO public.who_global_data VALUES (54020, 0, 14, 0, 1, 228, 36);
INSERT INTO public.who_global_data VALUES (54021, 0, 0, 0, 0, 228, 125);
INSERT INTO public.who_global_data VALUES (54022, 19, 774, 0, 0, 228, 124);
INSERT INTO public.who_global_data VALUES (54023, 833, 38074, 23, 1035, 228, 185);
INSERT INTO public.who_global_data VALUES (54024, 378, 45303, 1, 303, 228, 194);
INSERT INTO public.who_global_data VALUES (54025, 0, 509, 0, 21, 228, 144);
INSERT INTO public.who_global_data VALUES (54026, 27575, 2268753, 308, 119761, 228, 19);
INSERT INTO public.who_global_data VALUES (54027, 0, 76, 0, 6, 228, 217);
INSERT INTO public.who_global_data VALUES (54028, 17, 876, 0, 25, 228, 148);
INSERT INTO public.who_global_data VALUES (54029, 142, 6500, 0, 19, 228, 86);
INSERT INTO public.who_global_data VALUES (54030, 0, 0, 0, 0, 228, 13);
INSERT INTO public.who_global_data VALUES (54031, 128, 3918, 0, 33, 228, 157);
INSERT INTO public.who_global_data VALUES (54032, 0, 349, 0, 0, 228, 8);
INSERT INTO public.who_global_data VALUES (54033, 0, 0, 0, 0, 228, 73);
INSERT INTO public.who_global_data VALUES (54034, 26, 967, 1, 257, 228, 101);
INSERT INTO public.who_global_data VALUES (54035, 0, 1430, 0, 11, 228, 165);
INSERT INTO public.who_global_data VALUES (54036, 23, 512, 0, 6, 228, 14);
INSERT INTO public.who_global_data VALUES (54037, 310, 29229, 17, 602, 229, 193);
INSERT INTO public.who_global_data VALUES (54038, 104, 1995, 1, 44, 229, 113);
INSERT INTO public.who_global_data VALUES (54039, 140, 11771, 8, 845, 229, 143);
INSERT INTO public.who_global_data VALUES (54040, 0, 0, 0, 0, 229, 219);
INSERT INTO public.who_global_data VALUES (54041, 0, 855, 0, 52, 229, 186);
INSERT INTO public.who_global_data VALUES (54042, 4, 176, 1, 9, 229, 52);
INSERT INTO public.who_global_data VALUES (54043, 0, 3, 0, 0, 229, 180);
INSERT INTO public.who_global_data VALUES (54044, 0, 26, 0, 3, 229, 167);
INSERT INTO public.who_global_data VALUES (54045, 1634, 41204, 13, 992, 229, 154);
INSERT INTO public.who_global_data VALUES (54046, 320, 19901, 10, 355, 229, 94);
INSERT INTO public.who_global_data VALUES (54047, 0, 101, 0, 3, 229, 66);
INSERT INTO public.who_global_data VALUES (54048, 25, 7461, 0, 102, 229, 58);
INSERT INTO public.who_global_data VALUES (54049, 38, 17285, 2, 690, 229, 163);
INSERT INTO public.who_global_data VALUES (54050, 491, 12729, 6, 154, 229, 37);
INSERT INTO public.who_global_data VALUES (54051, 0, 104, 0, 11, 229, 142);
INSERT INTO public.who_global_data VALUES (54052, 433, 21764, 3, 63, 229, 83);
INSERT INTO public.who_global_data VALUES (54053, 3531, 112306, 39, 1464, 229, 228);
INSERT INTO public.who_global_data VALUES (54054, 0, 97, 0, 7, 229, 188);
INSERT INTO public.who_global_data VALUES (54055, 569, 58505, 3, 346, 229, 62);
INSERT INTO public.who_global_data VALUES (54056, 20, 61250, 9, 9578, 229, 160);
INSERT INTO public.who_global_data VALUES (54057, 0, 22, 0, 2, 229, 50);
INSERT INTO public.who_global_data VALUES (54058, 115, 765, 2, 13, 229, 33);
INSERT INTO public.who_global_data VALUES (54059, 0, 146, 0, 9, 229, 183);
INSERT INTO public.who_global_data VALUES (54060, 0, 68, 0, 0, 229, 92);
INSERT INTO public.who_global_data VALUES (54061, 1036, 23512, 25, 740, 229, 158);
INSERT INTO public.who_global_data VALUES (54062, 0, 2, 0, 0, 229, 67);
INSERT INTO public.who_global_data VALUES (54063, 77, 3431, 0, 169, 229, 57);
INSERT INTO public.who_global_data VALUES (54064, 0, 89, 0, 1, 229, 38);
INSERT INTO public.who_global_data VALUES (54065, 34666, 1067579, 1022, 49976, 229, 141);
INSERT INTO public.who_global_data VALUES (54066, 0, 8, 0, 1, 229, 178);
INSERT INTO public.who_global_data VALUES (54067, 0, 141, 0, 3, 229, 108);
INSERT INTO public.who_global_data VALUES (54068, 33, 3905, 0, 199, 229, 39);
INSERT INTO public.who_global_data VALUES (54069, 0, 901, 0, 53, 229, 2);
INSERT INTO public.who_global_data VALUES (54070, 0, 144, 0, 1, 229, 195);
INSERT INTO public.who_global_data VALUES (54071, 27, 890, 0, 8, 229, 107);
INSERT INTO public.who_global_data VALUES (54072, 0, 129, 0, 0, 229, 161);
INSERT INTO public.who_global_data VALUES (54073, 643, 11281, 18, 300, 229, 212);
INSERT INTO public.who_global_data VALUES (54074, 390, 101019, 64, 8410, 229, 181);
INSERT INTO public.who_global_data VALUES (54075, 0, 195, 0, 1, 229, 53);
INSERT INTO public.who_global_data VALUES (54076, 0, 2808, 0, 23, 229, 164);
INSERT INTO public.who_global_data VALUES (54077, 0, 858, 0, 74, 229, 140);
INSERT INTO public.who_global_data VALUES (54078, 5607, 242355, 184, 4479, 229, 20);
INSERT INTO public.who_global_data VALUES (54079, 21, 85018, 0, 4646, 229, 112);
INSERT INTO public.who_global_data VALUES (54080, 2357, 65633, 81, 2126, 229, 111);
INSERT INTO public.who_global_data VALUES (54081, 0, 247, 0, 5, 229, 71);
INSERT INTO public.who_global_data VALUES (54082, 0, 883, 0, 27, 229, 218);
INSERT INTO public.who_global_data VALUES (54083, 0, 0, 0, 0, 229, 43);
INSERT INTO public.who_global_data VALUES (54084, 69, 2127, 0, 12, 229, 49);
INSERT INTO public.who_global_data VALUES (54085, 216, 7492, 2, 54, 229, 1);
INSERT INTO public.who_global_data VALUES (54086, 18, 2317, 0, 107, 229, 48);
INSERT INTO public.who_global_data VALUES (54087, 3, 2312, 0, 85, 229, 232);
INSERT INTO public.who_global_data VALUES (54088, 0, 23, 0, 1, 229, 175);
INSERT INTO public.who_global_data VALUES (54089, 1, 986, 0, 19, 229, 21);
INSERT INTO public.who_global_data VALUES (54090, 50, 10498, 0, 336, 229, 156);
INSERT INTO public.who_global_data VALUES (54091, 0, 0, 0, 0, 229, 95);
INSERT INTO public.who_global_data VALUES (54092, 154, 5825, 5, 129, 229, 177);
INSERT INTO public.who_global_data VALUES (54093, 0, 12391, 0, 600, 229, 210);
INSERT INTO public.who_global_data VALUES (54094, 17, 4582, 0, 45, 229, 120);
INSERT INTO public.who_global_data VALUES (54095, 0, 18, 0, 0, 229, 135);
INSERT INTO public.who_global_data VALUES (54096, 899, 26677, 7, 662, 229, 206);
INSERT INTO public.who_global_data VALUES (54097, 457, 50640, 24, 4223, 229, 189);
INSERT INTO public.who_global_data VALUES (54098, 1475, 55233, 87, 2193, 229, 129);
INSERT INTO public.who_global_data VALUES (54099, 151, 4626, 5, 98, 229, 121);
INSERT INTO public.who_global_data VALUES (54100, 0, 1043, 0, 12, 229, 59);
INSERT INTO public.who_global_data VALUES (54101, 1, 143, 0, 0, 229, 96);
INSERT INTO public.who_global_data VALUES (54102, 0, 1981, 0, 63, 229, 41);
INSERT INTO public.who_global_data VALUES (54103, 8, 635, 0, 5, 229, 216);
INSERT INTO public.who_global_data VALUES (54104, 63, 4532, 2, 74, 229, 236);
INSERT INTO public.who_global_data VALUES (54105, 0, 13, 0, 0, 229, 150);
INSERT INTO public.who_global_data VALUES (54106, 0, 187, 0, 0, 229, 61);
INSERT INTO public.who_global_data VALUES (54107, 0, 18, 0, 0, 229, 7);
INSERT INTO public.who_global_data VALUES (54108, 1, 7143, 0, 326, 229, 169);
INSERT INTO public.who_global_data VALUES (54109, 5, 154567, 6, 29571, 229, 28);
INSERT INTO public.who_global_data VALUES (54110, 278, 2441, 1, 6, 229, 85);
INSERT INTO public.who_global_data VALUES (54111, 0, 60, 0, 0, 229, 211);
INSERT INTO public.who_global_data VALUES (54112, 0, 4428, 0, 34, 229, 60);
INSERT INTO public.who_global_data VALUES (54113, 0, 37, 0, 2, 229, 3);
INSERT INTO public.who_global_data VALUES (54114, 2, 908, 0, 14, 229, 11);
INSERT INTO public.who_global_data VALUES (54115, 537, 190359, 3, 8885, 229, 89);
INSERT INTO public.who_global_data VALUES (54116, 437, 14154, 0, 85, 229, 24);
INSERT INTO public.who_global_data VALUES (54117, 0, 176, 0, 0, 229, 162);
INSERT INTO public.who_global_data VALUES (54118, 10, 3266, 0, 190, 229, 100);
INSERT INTO public.who_global_data VALUES (54119, 0, 13, 0, 0, 229, 47);
INSERT INTO public.who_global_data VALUES (54120, 0, 23, 0, 0, 229, 29);
INSERT INTO public.who_global_data VALUES (54121, 0, 174, 0, 14, 229, 40);
INSERT INTO public.who_global_data VALUES (54122, 0, 214, 0, 5, 229, 222);
INSERT INTO public.who_global_data VALUES (54123, 246, 12755, 31, 514, 229, 132);
INSERT INTO public.who_global_data VALUES (54124, 0, 252, 0, 13, 229, 130);
INSERT INTO public.who_global_data VALUES (54125, 28, 4988, 0, 27, 229, 234);
INSERT INTO public.who_global_data VALUES (54126, 0, 1512, 0, 16, 229, 23);
INSERT INTO public.who_global_data VALUES (54127, 0, 183, 0, 12, 229, 192);
INSERT INTO public.who_global_data VALUES (54128, 97, 5077, 1, 88, 229, 69);
INSERT INTO public.who_global_data VALUES (54129, 0, 12, 0, 0, 229, 187);
INSERT INTO public.who_global_data VALUES (54130, 1048, 12306, 9, 358, 229, 230);
INSERT INTO public.who_global_data VALUES (54131, 8, 4102, 2, 572, 229, 77);
INSERT INTO public.who_global_data VALUES (54132, 0, 1815, 0, 10, 229, 9);
INSERT INTO public.who_global_data VALUES (54133, 14821, 425282, 445, 13699, 229, 74);
INSERT INTO public.who_global_data VALUES (54134, 862, 45891, 36, 2465, 229, 224);
INSERT INTO public.who_global_data VALUES (54135, 2368, 204952, 116, 9623, 229, 199);
INSERT INTO public.who_global_data VALUES (54136, 1646, 30868, 87, 1100, 229, 190);
INSERT INTO public.who_global_data VALUES (54137, 5, 25379, 0, 1715, 229, 12);
INSERT INTO public.who_global_data VALUES (54138, 0, 336, 0, 24, 229, 104);
INSERT INTO public.who_global_data VALUES (54139, 160, 20683, 1, 308, 229, 153);
INSERT INTO public.who_global_data VALUES (54140, 224, 238499, 24, 34634, 229, 91);
INSERT INTO public.who_global_data VALUES (54141, 5, 657, 0, 10, 229, 215);
INSERT INTO public.who_global_data VALUES (54142, 52, 17916, 0, 953, 229, 84);
INSERT INTO public.who_global_data VALUES (54143, 0, 318, 0, 31, 229, 231);
INSERT INTO public.who_global_data VALUES (54144, 17, 967, 0, 9, 229, 196);
INSERT INTO public.who_global_data VALUES (54145, 1315, 20566, 7, 127, 229, 105);
INSERT INTO public.who_global_data VALUES (54146, 260, 4738, 2, 123, 229, 122);
INSERT INTO public.who_global_data VALUES (54147, 0, 0, 0, 0, 229, 159);
INSERT INTO public.who_global_data VALUES (54148, 96, 2126, 1, 26, 229, 75);
INSERT INTO public.who_global_data VALUES (54149, 505, 39650, 7, 326, 229, 27);
INSERT INTO public.who_global_data VALUES (54150, 205, 3356, 5, 40, 229, 54);
INSERT INTO public.who_global_data VALUES (54151, 0, 19, 0, 0, 229, 226);
INSERT INTO public.who_global_data VALUES (54152, 0, 1111, 0, 30, 229, 79);
INSERT INTO public.who_global_data VALUES (54153, 51, 1587, 0, 32, 229, 56);
INSERT INTO public.who_global_data VALUES (54154, 0, 4, 0, 0, 229, 117);
INSERT INTO public.who_global_data VALUES (54155, 25, 626, 1, 34, 229, 152);
INSERT INTO public.who_global_data VALUES (54156, 27, 571, 0, 10, 229, 16);
INSERT INTO public.who_global_data VALUES (54157, 0, 83, 0, 1, 229, 10);
INSERT INTO public.who_global_data VALUES (54158, 3, 1796, 0, 76, 229, 201);
INSERT INTO public.who_global_data VALUES (54159, 15, 4120, 0, 110, 229, 174);
INSERT INTO public.who_global_data VALUES (54160, 93, 1596, 1, 14, 229, 119);
INSERT INTO public.who_global_data VALUES (54161, 0, 730, 0, 11, 229, 168);
INSERT INTO public.who_global_data VALUES (54162, 16, 8572, 0, 121, 229, 99);
INSERT INTO public.who_global_data VALUES (54163, 16, 2203, 0, 8, 229, 171);
INSERT INTO public.who_global_data VALUES (54164, 28, 1961, 2, 111, 229, 87);
INSERT INTO public.who_global_data VALUES (54165, 0, 664, 0, 9, 229, 123);
INSERT INTO public.who_global_data VALUES (54166, 0, 0, 0, 0, 229, 151);
INSERT INTO public.who_global_data VALUES (54167, 0, 236, 0, 14, 229, 213);
INSERT INTO public.who_global_data VALUES (54168, 192, 2813, 6, 108, 229, 118);
INSERT INTO public.who_global_data VALUES (54169, 0, 337, 0, 10, 229, 134);
INSERT INTO public.who_global_data VALUES (54170, 0, 2404, 0, 31, 229, 65);
INSERT INTO public.who_global_data VALUES (54171, 4717, 175202, 387, 20781, 229, 102);
INSERT INTO public.who_global_data VALUES (54172, 0, 0, 0, 0, 229, 223);
INSERT INTO public.who_global_data VALUES (54173, 1, 71, 0, 1, 229, 4);
INSERT INTO public.who_global_data VALUES (54174, 2, 206, 0, 0, 229, 146);
INSERT INTO public.who_global_data VALUES (54175, 6, 367, 0, 9, 229, 31);
INSERT INTO public.who_global_data VALUES (54176, 0, 11, 0, 1, 229, 127);
INSERT INTO public.who_global_data VALUES (54177, 138, 9977, 1, 214, 229, 22);
INSERT INTO public.who_global_data VALUES (54178, 45, 733, 1, 5, 229, 115);
INSERT INTO public.who_global_data VALUES (54179, 4, 290, 0, 6, 229, 106);
INSERT INTO public.who_global_data VALUES (54180, 9, 55, 0, 0, 229, 90);
INSERT INTO public.who_global_data VALUES (54181, 0, 0, 0, 0, 229, 70);
INSERT INTO public.who_global_data VALUES (54182, 421, 9026, 1, 23, 229, 46);
INSERT INTO public.who_global_data VALUES (54183, 95, 49362, 1, 6063, 229, 139);
INSERT INTO public.who_global_data VALUES (54184, 0, 21, 0, 0, 229, 42);
INSERT INTO public.who_global_data VALUES (54185, 4, 1163, 0, 22, 229, 80);
INSERT INTO public.who_global_data VALUES (54186, 0, 2014, 0, 64, 229, 203);
INSERT INTO public.who_global_data VALUES (54187, 1, 1036, 0, 67, 229, 136);
INSERT INTO public.who_global_data VALUES (54188, 436, 20244, 12, 518, 229, 63);
INSERT INTO public.who_global_data VALUES (54189, 0, 0, 0, 0, 229, 17);
INSERT INTO public.who_global_data VALUES (54190, 0, 30, 0, 2, 229, 172);
INSERT INTO public.who_global_data VALUES (54191, 101, 5106, 5, 238, 229, 109);
INSERT INTO public.who_global_data VALUES (54192, 0, 8708, 0, 244, 229, 200);
INSERT INTO public.who_global_data VALUES (54193, 49, 1028, 0, 5, 229, 93);
INSERT INTO public.who_global_data VALUES (54194, 905, 29471, 3, 131, 229, 5);
INSERT INTO public.who_global_data VALUES (54195, 0, 741, 0, 13, 229, 214);
INSERT INTO public.who_global_data VALUES (54196, 4471, 181088, 89, 3590, 229, 204);
INSERT INTO public.who_global_data VALUES (54197, 0, 0, 0, 0, 229, 198);
INSERT INTO public.who_global_data VALUES (54198, 948, 25222, 8, 493, 229, 173);
INSERT INTO public.who_global_data VALUES (54199, 0, 9, 0, 0, 229, 229);
INSERT INTO public.who_global_data VALUES (54200, 17, 1379, 0, 13, 229, 76);
INSERT INTO public.who_global_data VALUES (54201, 3413, 251338, 201, 7861, 229, 138);
INSERT INTO public.who_global_data VALUES (54202, 652, 30052, 19, 1169, 229, 98);
INSERT INTO public.who_global_data VALUES (54203, 0, 0, 0, 0, 229, 103);
INSERT INTO public.who_global_data VALUES (54204, 311, 31931, 10, 1356, 229, 225);
INSERT INTO public.who_global_data VALUES (54205, 292, 39133, 2, 1530, 229, 131);
INSERT INTO public.who_global_data VALUES (54206, 62, 6525, 2, 149, 229, 235);
INSERT INTO public.who_global_data VALUES (54207, 881, 87369, 4, 98, 229, 137);
INSERT INTO public.who_global_data VALUES (54208, 17, 12438, 0, 280, 229, 81);
INSERT INTO public.who_global_data VALUES (54209, 247, 14200, 11, 475, 229, 182);
INSERT INTO public.who_global_data VALUES (54210, 1, 506, 0, 1, 229, 145);
INSERT INTO public.who_global_data VALUES (54211, 315, 24045, 12, 1512, 229, 26);
INSERT INTO public.who_global_data VALUES (54212, 7600, 592280, 95, 8206, 229, 170);
INSERT INTO public.who_global_data VALUES (54213, 26, 728, 0, 2, 229, 191);
INSERT INTO public.who_global_data VALUES (54214, 0, 3, 0, 0, 229, 221);
INSERT INTO public.who_global_data VALUES (54215, 0, 6, 0, 0, 229, 64);
INSERT INTO public.who_global_data VALUES (54216, 0, 0, 0, 0, 229, 116);
INSERT INTO public.who_global_data VALUES (54217, 0, 15, 0, 0, 229, 128);
INSERT INTO public.who_global_data VALUES (54218, 0, 19, 0, 0, 229, 6);
INSERT INTO public.who_global_data VALUES (54219, 0, 42, 0, 3, 229, 227);
INSERT INTO public.who_global_data VALUES (54220, 0, 1, 0, 0, 229, 68);
INSERT INTO public.who_global_data VALUES (54221, 0, 29, 0, 0, 229, 184);
INSERT INTO public.who_global_data VALUES (54222, 0, 0, 0, 0, 229, 82);
INSERT INTO public.who_global_data VALUES (54223, 0, 713, 0, 42, 229, 149);
INSERT INTO public.who_global_data VALUES (54224, 0, 388, 0, 10, 229, 197);
INSERT INTO public.who_global_data VALUES (54225, 3379, 157612, 37, 1267, 229, 78);
INSERT INTO public.who_global_data VALUES (54226, 105, 5888, 2, 84, 229, 233);
INSERT INTO public.who_global_data VALUES (54227, 91, 12894, 1, 261, 229, 133);
INSERT INTO public.who_global_data VALUES (54228, 0, 11, 0, 0, 229, 35);
INSERT INTO public.who_global_data VALUES (54229, 18, 1327, 2, 55, 229, 114);
INSERT INTO public.who_global_data VALUES (54230, 262, 42095, 0, 26, 229, 237);
INSERT INTO public.who_global_data VALUES (54231, 0, 2, 0, 0, 229, 55);
INSERT INTO public.who_global_data VALUES (54232, 0, 77, 0, 15, 229, 176);
INSERT INTO public.who_global_data VALUES (54233, 1, 1587, 0, 28, 229, 202);
INSERT INTO public.who_global_data VALUES (54234, 1, 1521, 0, 114, 229, 155);
INSERT INTO public.who_global_data VALUES (54235, 0, 0, 0, 0, 229, 32);
INSERT INTO public.who_global_data VALUES (54236, 24, 2779, 2, 90, 229, 220);
INSERT INTO public.who_global_data VALUES (54237, 4621, 97302, 53, 1930, 229, 30);
INSERT INTO public.who_global_data VALUES (54238, 18, 1882, 0, 34, 229, 147);
INSERT INTO public.who_global_data VALUES (54239, 232, 255022, 13, 29649, 229, 208);
INSERT INTO public.who_global_data VALUES (54240, 0, 1950, 0, 11, 229, 45);
INSERT INTO public.who_global_data VALUES (54241, 118, 8698, 12, 533, 229, 110);
INSERT INTO public.who_global_data VALUES (54242, 9, 302, 0, 8, 229, 88);
INSERT INTO public.who_global_data VALUES (54243, 698, 58554, 29, 5318, 229, 51);
INSERT INTO public.who_global_data VALUES (54244, 13, 31252, 1, 1721, 229, 209);
INSERT INTO public.who_global_data VALUES (54245, 6, 204, 0, 7, 229, 205);
INSERT INTO public.who_global_data VALUES (54246, 58, 5457, 0, 52, 229, 18);
INSERT INTO public.who_global_data VALUES (54247, 3, 3151, 0, 58, 229, 72);
INSERT INTO public.who_global_data VALUES (54248, 687, 277859, 31, 39878, 229, 44);
INSERT INTO public.who_global_data VALUES (54249, 0, 24, 0, 0, 229, 15);
INSERT INTO public.who_global_data VALUES (54250, 8, 569, 0, 13, 229, 25);
INSERT INTO public.who_global_data VALUES (54251, 0, 0, 0, 0, 229, 179);
INSERT INTO public.who_global_data VALUES (54252, 0, 0, 0, 0, 229, 34);
INSERT INTO public.who_global_data VALUES (54253, 0, 123, 0, 8, 229, 207);
INSERT INTO public.who_global_data VALUES (54254, 2, 1159, 0, 50, 229, 166);
INSERT INTO public.who_global_data VALUES (54255, 1192, 187685, 23, 4950, 229, 126);
INSERT INTO public.who_global_data VALUES (54256, 0, 0, 0, 0, 229, 97);
INSERT INTO public.who_global_data VALUES (54257, 2, 14, 0, 1, 229, 36);
INSERT INTO public.who_global_data VALUES (54258, 0, 0, 0, 0, 229, 125);
INSERT INTO public.who_global_data VALUES (54259, -68, 755, 0, 0, 229, 124);
INSERT INTO public.who_global_data VALUES (54260, 681, 37241, 10, 1012, 229, 185);
INSERT INTO public.who_global_data VALUES (54261, 392, 44925, 1, 302, 229, 194);
INSERT INTO public.who_global_data VALUES (54262, 0, 509, 0, 21, 229, 144);
INSERT INTO public.who_global_data VALUES (54263, 32349, 2241178, 558, 119453, 229, 19);
INSERT INTO public.who_global_data VALUES (54264, 2, 76, 0, 6, 229, 217);
INSERT INTO public.who_global_data VALUES (54265, 6, 859, 1, 25, 229, 148);
INSERT INTO public.who_global_data VALUES (54266, 142, 6358, 0, 19, 229, 86);
INSERT INTO public.who_global_data VALUES (54267, 0, 0, 0, 0, 229, 13);
INSERT INTO public.who_global_data VALUES (54268, 199, 3790, 3, 33, 229, 157);
INSERT INTO public.who_global_data VALUES (54269, 0, 349, 0, 0, 229, 8);
INSERT INTO public.who_global_data VALUES (54270, 0, 0, 0, 0, 229, 73);
INSERT INTO public.who_global_data VALUES (54271, 19, 941, 2, 256, 229, 101);
INSERT INTO public.who_global_data VALUES (54272, 0, 1430, 0, 11, 229, 165);
INSERT INTO public.who_global_data VALUES (54273, 10, 489, 2, 6, 229, 14);
INSERT INTO public.who_global_data VALUES (54274, 536, 28919, 33, 585, 230, 193);
INSERT INTO public.who_global_data VALUES (54275, 53, 1891, 1, 43, 230, 113);
INSERT INTO public.who_global_data VALUES (54276, 127, 11631, 12, 837, 230, 143);
INSERT INTO public.who_global_data VALUES (54277, 0, 0, 0, 0, 230, 219);
INSERT INTO public.who_global_data VALUES (54278, 0, 855, 0, 52, 230, 186);
INSERT INTO public.who_global_data VALUES (54279, 6, 172, 0, 8, 230, 52);
INSERT INTO public.who_global_data VALUES (54280, 0, 3, 0, 0, 230, 180);
INSERT INTO public.who_global_data VALUES (54281, 0, 26, 0, 3, 230, 167);
INSERT INTO public.who_global_data VALUES (54282, 2060, 39570, 25, 979, 230, 154);
INSERT INTO public.who_global_data VALUES (54283, 560, 19581, 18, 345, 230, 94);
INSERT INTO public.who_global_data VALUES (54284, 0, 101, 0, 3, 230, 66);
INSERT INTO public.who_global_data VALUES (54285, 27, 7436, 0, 102, 230, 58);
INSERT INTO public.who_global_data VALUES (54286, 62, 17247, 0, 688, 230, 163);
INSERT INTO public.who_global_data VALUES (54287, 471, 12238, 5, 148, 230, 37);
INSERT INTO public.who_global_data VALUES (54288, 0, 104, 0, 11, 230, 142);
INSERT INTO public.who_global_data VALUES (54289, 415, 21331, 3, 60, 230, 83);
INSERT INTO public.who_global_data VALUES (54290, 3240, 108775, 37, 1425, 230, 228);
INSERT INTO public.who_global_data VALUES (54291, 0, 97, 0, 7, 230, 188);
INSERT INTO public.who_global_data VALUES (54292, 603, 57936, 6, 343, 230, 62);
INSERT INTO public.who_global_data VALUES (54293, 50, 61230, 3, 9569, 230, 160);
INSERT INTO public.who_global_data VALUES (54294, 0, 22, 0, 2, 230, 50);
INSERT INTO public.who_global_data VALUES (54295, 0, 650, 0, 11, 230, 33);
INSERT INTO public.who_global_data VALUES (54296, 2, 146, 0, 9, 230, 183);
INSERT INTO public.who_global_data VALUES (54297, 0, 68, 0, 0, 230, 92);
INSERT INTO public.who_global_data VALUES (54298, 977, 22476, 18, 715, 230, 158);
INSERT INTO public.who_global_data VALUES (54299, 0, 2, 0, 0, 230, 67);
INSERT INTO public.who_global_data VALUES (54300, 66, 3354, 1, 169, 230, 57);
INSERT INTO public.who_global_data VALUES (54301, 0, 89, 0, 1, 230, 38);
INSERT INTO public.who_global_data VALUES (54302, 54771, 1032913, 1206, 48954, 230, 141);
INSERT INTO public.who_global_data VALUES (54303, 0, 8, 0, 1, 230, 178);
INSERT INTO public.who_global_data VALUES (54304, 0, 141, 0, 3, 230, 108);
INSERT INTO public.who_global_data VALUES (54305, 117, 3872, 6, 199, 230, 39);
INSERT INTO public.who_global_data VALUES (54306, 0, 901, 0, 53, 230, 2);
INSERT INTO public.who_global_data VALUES (54307, 40, 144, 0, 1, 230, 195);
INSERT INTO public.who_global_data VALUES (54308, 15, 863, 0, 8, 230, 107);
INSERT INTO public.who_global_data VALUES (54309, 0, 129, 0, 0, 230, 161);
INSERT INTO public.who_global_data VALUES (54310, 0, 10638, 0, 282, 230, 212);
INSERT INTO public.who_global_data VALUES (54311, 409, 100629, 46, 8346, 230, 181);
INSERT INTO public.who_global_data VALUES (54312, 2, 195, 0, 1, 230, 53);
INSERT INTO public.who_global_data VALUES (54313, 203, 2808, 4, 23, 230, 164);
INSERT INTO public.who_global_data VALUES (54314, 0, 858, 0, 74, 230, 140);
INSERT INTO public.who_global_data VALUES (54315, 5355, 236748, 202, 4295, 230, 20);
INSERT INTO public.who_global_data VALUES (54316, 27, 84997, 1, 4646, 230, 112);
INSERT INTO public.who_global_data VALUES (54317, 3059, 63276, 95, 2045, 230, 111);
INSERT INTO public.who_global_data VALUES (54318, 37, 247, 0, 5, 230, 71);
INSERT INTO public.who_global_data VALUES (54319, 0, 883, 0, 27, 230, 218);
INSERT INTO public.who_global_data VALUES (54320, 0, 0, 0, 0, 230, 43);
INSERT INTO public.who_global_data VALUES (54321, 119, 2058, 0, 12, 230, 49);
INSERT INTO public.who_global_data VALUES (54322, 402, 7276, 3, 52, 230, 1);
INSERT INTO public.who_global_data VALUES (54323, 19, 2299, 0, 107, 230, 48);
INSERT INTO public.who_global_data VALUES (54324, 4, 2309, 0, 85, 230, 232);
INSERT INTO public.who_global_data VALUES (54325, 0, 23, 0, 1, 230, 175);
INSERT INTO public.who_global_data VALUES (54326, 0, 985, 0, 19, 230, 21);
INSERT INTO public.who_global_data VALUES (54327, 42, 10448, 1, 336, 230, 156);
INSERT INTO public.who_global_data VALUES (54328, 0, 0, 0, 0, 230, 95);
INSERT INTO public.who_global_data VALUES (54329, 195, 5671, 3, 124, 230, 177);
INSERT INTO public.who_global_data VALUES (54330, 0, 12391, 0, 600, 230, 210);
INSERT INTO public.who_global_data VALUES (54331, 0, 4565, 0, 45, 230, 120);
INSERT INTO public.who_global_data VALUES (54332, 0, 18, 0, 0, 230, 135);
INSERT INTO public.who_global_data VALUES (54333, 710, 25778, 8, 655, 230, 206);
INSERT INTO public.who_global_data VALUES (54334, 452, 50183, 43, 4199, 230, 189);
INSERT INTO public.who_global_data VALUES (54335, 1547, 53758, 89, 2106, 230, 129);
INSERT INTO public.who_global_data VALUES (54336, 146, 4475, 7, 93, 230, 121);
INSERT INTO public.who_global_data VALUES (54337, 0, 1043, 0, 12, 230, 59);
INSERT INTO public.who_global_data VALUES (54338, 0, 142, 0, 0, 230, 96);
INSERT INTO public.who_global_data VALUES (54339, 2, 1981, 0, 63, 230, 41);
INSERT INTO public.who_global_data VALUES (54340, 4, 627, 1, 5, 230, 216);
INSERT INTO public.who_global_data VALUES (54341, 399, 4469, 0, 72, 230, 236);
INSERT INTO public.who_global_data VALUES (54342, 0, 13, 0, 0, 230, 150);
INSERT INTO public.who_global_data VALUES (54343, 0, 187, 0, 0, 230, 61);
INSERT INTO public.who_global_data VALUES (54344, 0, 18, 0, 0, 230, 7);
INSERT INTO public.who_global_data VALUES (54345, 9, 7142, 0, 326, 230, 169);
INSERT INTO public.who_global_data VALUES (54346, 421, 154562, 14, 29565, 230, 28);
INSERT INTO public.who_global_data VALUES (54347, 194, 2163, 0, 5, 230, 85);
INSERT INTO public.who_global_data VALUES (54348, 0, 60, 0, 0, 230, 211);
INSERT INTO public.who_global_data VALUES (54349, 88, 4428, 2, 34, 230, 60);
INSERT INTO public.who_global_data VALUES (54350, 1, 37, 1, 2, 230, 3);
INSERT INTO public.who_global_data VALUES (54351, 8, 906, 0, 14, 230, 11);
INSERT INTO public.who_global_data VALUES (54352, 687, 189822, 0, 8882, 230, 89);
INSERT INTO public.who_global_data VALUES (54353, 514, 13717, 15, 85, 230, 24);
INSERT INTO public.who_global_data VALUES (54354, 0, 176, 0, 0, 230, 162);
INSERT INTO public.who_global_data VALUES (54355, 19, 3256, 1, 190, 230, 100);
INSERT INTO public.who_global_data VALUES (54356, 0, 13, 0, 0, 230, 47);
INSERT INTO public.who_global_data VALUES (54357, 0, 23, 0, 0, 230, 29);
INSERT INTO public.who_global_data VALUES (54358, 0, 174, 0, 14, 230, 40);
INSERT INTO public.who_global_data VALUES (54359, 22, 214, 0, 5, 230, 222);
INSERT INTO public.who_global_data VALUES (54360, 641, 12509, 34, 483, 230, 132);
INSERT INTO public.who_global_data VALUES (54361, 0, 252, 0, 13, 230, 130);
INSERT INTO public.who_global_data VALUES (54362, 56, 4960, 0, 27, 230, 234);
INSERT INTO public.who_global_data VALUES (54363, 0, 1512, 0, 16, 230, 23);
INSERT INTO public.who_global_data VALUES (54364, 0, 183, 0, 12, 230, 192);
INSERT INTO public.who_global_data VALUES (54365, 64, 4980, 3, 87, 230, 69);
INSERT INTO public.who_global_data VALUES (54366, 0, 12, 0, 0, 230, 187);
INSERT INTO public.who_global_data VALUES (54367, 519, 11258, 6, 349, 230, 230);
INSERT INTO public.who_global_data VALUES (54368, 8, 4094, 0, 570, 230, 77);
INSERT INTO public.who_global_data VALUES (54369, 0, 1815, 0, 10, 230, 9);
INSERT INTO public.who_global_data VALUES (54370, 15413, 410461, 306, 13254, 230, 74);
INSERT INTO public.who_global_data VALUES (54371, 1226, 45029, 56, 2429, 230, 224);
INSERT INTO public.who_global_data VALUES (54372, 2322, 202584, 115, 9507, 230, 199);
INSERT INTO public.who_global_data VALUES (54373, 1870, 29222, 88, 1013, 230, 190);
INSERT INTO public.who_global_data VALUES (54374, 6, 25374, 1, 1715, 230, 12);
INSERT INTO public.who_global_data VALUES (54375, 0, 336, 0, 24, 230, 104);
INSERT INTO public.who_global_data VALUES (54376, 310, 20523, 1, 307, 230, 153);
INSERT INTO public.who_global_data VALUES (54377, 264, 238275, 49, 34610, 230, 91);
INSERT INTO public.who_global_data VALUES (54378, 14, 652, 0, 10, 230, 215);
INSERT INTO public.who_global_data VALUES (54379, 65, 17864, 1, 953, 230, 84);
INSERT INTO public.who_global_data VALUES (54380, 0, 318, 1, 31, 230, 231);
INSERT INTO public.who_global_data VALUES (54381, 7, 950, 0, 9, 230, 196);
INSERT INTO public.who_global_data VALUES (54382, 1410, 19251, 2, 120, 230, 105);
INSERT INTO public.who_global_data VALUES (54383, 104, 4478, 2, 121, 230, 122);
INSERT INTO public.who_global_data VALUES (54384, 0, 0, 0, 0, 230, 159);
INSERT INTO public.who_global_data VALUES (54385, 75, 2030, 1, 25, 230, 75);
INSERT INTO public.who_global_data VALUES (54386, 467, 39145, 6, 319, 230, 27);
INSERT INTO public.who_global_data VALUES (54387, 170, 3151, 0, 35, 230, 54);
INSERT INTO public.who_global_data VALUES (54388, 0, 19, 0, 0, 230, 226);
INSERT INTO public.who_global_data VALUES (54389, 1, 1111, 0, 30, 230, 79);
INSERT INTO public.who_global_data VALUES (54390, 26, 1536, 0, 32, 230, 56);
INSERT INTO public.who_global_data VALUES (54391, 0, 4, 0, 0, 230, 117);
INSERT INTO public.who_global_data VALUES (54392, 20, 601, 0, 33, 230, 152);
INSERT INTO public.who_global_data VALUES (54393, 24, 544, 0, 10, 230, 16);
INSERT INTO public.who_global_data VALUES (54394, 0, 83, 0, 1, 230, 10);
INSERT INTO public.who_global_data VALUES (54395, 3, 1793, 0, 76, 230, 201);
INSERT INTO public.who_global_data VALUES (54396, 6, 4105, 0, 110, 230, 174);
INSERT INTO public.who_global_data VALUES (54397, 60, 1503, 0, 13, 230, 119);
INSERT INTO public.who_global_data VALUES (54398, 82, 730, 3, 11, 230, 168);
INSERT INTO public.who_global_data VALUES (54399, 21, 8556, 0, 121, 230, 99);
INSERT INTO public.who_global_data VALUES (54400, 37, 2187, 0, 8, 230, 171);
INSERT INTO public.who_global_data VALUES (54401, 10, 1933, 1, 109, 230, 87);
INSERT INTO public.who_global_data VALUES (54402, 1, 664, 0, 9, 230, 123);
INSERT INTO public.who_global_data VALUES (54403, 0, 0, 0, 0, 230, 151);
INSERT INTO public.who_global_data VALUES (54404, 15, 236, 0, 14, 230, 213);
INSERT INTO public.who_global_data VALUES (54405, 197, 2621, 5, 102, 230, 118);
INSERT INTO public.who_global_data VALUES (54406, 0, 337, 0, 10, 230, 134);
INSERT INTO public.who_global_data VALUES (54407, 10, 2404, 2, 31, 230, 65);
INSERT INTO public.who_global_data VALUES (54408, 5030, 170485, 647, 20394, 230, 102);
INSERT INTO public.who_global_data VALUES (54409, 0, 0, 0, 0, 230, 223);
INSERT INTO public.who_global_data VALUES (54410, 0, 70, 0, 1, 230, 4);
INSERT INTO public.who_global_data VALUES (54411, 0, 204, 0, 0, 230, 146);
INSERT INTO public.who_global_data VALUES (54412, 3, 361, 0, 9, 230, 31);
INSERT INTO public.who_global_data VALUES (54413, 0, 11, 0, 1, 230, 127);
INSERT INTO public.who_global_data VALUES (54414, 226, 9839, 0, 213, 230, 22);
INSERT INTO public.who_global_data VALUES (54415, 20, 688, 0, 4, 230, 115);
INSERT INTO public.who_global_data VALUES (54416, 0, 286, 0, 6, 230, 106);
INSERT INTO public.who_global_data VALUES (54417, 1, 46, 0, 0, 230, 90);
INSERT INTO public.who_global_data VALUES (54418, 0, 0, 0, 0, 230, 70);
INSERT INTO public.who_global_data VALUES (54419, 331, 8605, 0, 22, 230, 46);
INSERT INTO public.who_global_data VALUES (54420, 90, 49267, 8, 6062, 230, 139);
INSERT INTO public.who_global_data VALUES (54421, 0, 21, 0, 0, 230, 42);
INSERT INTO public.who_global_data VALUES (54422, 0, 1159, 0, 22, 230, 80);
INSERT INTO public.who_global_data VALUES (54423, 0, 2014, 0, 64, 230, 203);
INSERT INTO public.who_global_data VALUES (54424, 9, 1035, 0, 67, 230, 136);
INSERT INTO public.who_global_data VALUES (54425, 661, 19808, 19, 506, 230, 63);
INSERT INTO public.who_global_data VALUES (54426, 0, 0, 0, 0, 230, 17);
INSERT INTO public.who_global_data VALUES (54427, 0, 30, 0, 2, 230, 172);
INSERT INTO public.who_global_data VALUES (54428, 185, 5005, 11, 233, 230, 109);
INSERT INTO public.who_global_data VALUES (54429, 16, 8708, 0, 244, 230, 200);
INSERT INTO public.who_global_data VALUES (54430, 109, 979, 0, 5, 230, 93);
INSERT INTO public.who_global_data VALUES (54431, 896, 28566, 3, 128, 230, 5);
INSERT INTO public.who_global_data VALUES (54432, 0, 741, 0, 13, 230, 214);
INSERT INTO public.who_global_data VALUES (54433, 4951, 176617, 119, 3501, 230, 204);
INSERT INTO public.who_global_data VALUES (54434, 0, 0, 0, 0, 230, 198);
INSERT INTO public.who_global_data VALUES (54435, 923, 24274, 10, 485, 230, 173);
INSERT INTO public.who_global_data VALUES (54436, 1, 9, 0, 0, 230, 229);
INSERT INTO public.who_global_data VALUES (54437, 26, 1362, 0, 13, 230, 76);
INSERT INTO public.who_global_data VALUES (54438, 3537, 247925, 199, 7660, 230, 138);
INSERT INTO public.who_global_data VALUES (54439, 941, 29400, 20, 1150, 230, 98);
INSERT INTO public.who_global_data VALUES (54440, 0, 0, 0, 0, 230, 103);
INSERT INTO public.who_global_data VALUES (54441, 304, 31620, 12, 1346, 230, 225);
INSERT INTO public.who_global_data VALUES (54442, 377, 38841, 1, 1528, 230, 131);
INSERT INTO public.who_global_data VALUES (54443, 268, 6463, 0, 147, 230, 235);
INSERT INTO public.who_global_data VALUES (54444, 1026, 86488, 1, 94, 230, 137);
INSERT INTO public.who_global_data VALUES (54445, 48, 12421, 0, 280, 230, 81);
INSERT INTO public.who_global_data VALUES (54446, 397, 13953, 6, 464, 230, 182);
INSERT INTO public.who_global_data VALUES (54447, 1, 505, 0, 1, 230, 145);
INSERT INTO public.who_global_data VALUES (54448, 330, 23730, 16, 1500, 230, 26);
INSERT INTO public.who_global_data VALUES (54449, 7728, 584680, 109, 8111, 230, 170);
INSERT INTO public.who_global_data VALUES (54450, 41, 702, 0, 2, 230, 191);
INSERT INTO public.who_global_data VALUES (54451, 0, 3, 0, 0, 230, 221);
INSERT INTO public.who_global_data VALUES (54452, 0, 6, 0, 0, 230, 64);
INSERT INTO public.who_global_data VALUES (54453, 0, 0, 0, 0, 230, 116);
INSERT INTO public.who_global_data VALUES (54454, 0, 15, 0, 0, 230, 128);
INSERT INTO public.who_global_data VALUES (54455, 0, 19, 0, 0, 230, 6);
INSERT INTO public.who_global_data VALUES (54456, 0, 42, 0, 3, 230, 227);
INSERT INTO public.who_global_data VALUES (54457, 0, 1, 0, 0, 230, 68);
INSERT INTO public.who_global_data VALUES (54458, 0, 29, 0, 0, 230, 184);
INSERT INTO public.who_global_data VALUES (54459, 0, 0, 0, 0, 230, 82);
INSERT INTO public.who_global_data VALUES (54460, 0, 713, 0, 42, 230, 149);
INSERT INTO public.who_global_data VALUES (54461, 0, 388, 0, 10, 230, 197);
INSERT INTO public.who_global_data VALUES (54462, 3941, 154233, 46, 1230, 230, 78);
INSERT INTO public.who_global_data VALUES (54463, 144, 5783, 3, 82, 230, 233);
INSERT INTO public.who_global_data VALUES (54464, 94, 12803, 1, 260, 230, 133);
INSERT INTO public.who_global_data VALUES (54465, 0, 11, 0, 0, 230, 35);
INSERT INTO public.who_global_data VALUES (54466, 11, 1309, 0, 53, 230, 114);
INSERT INTO public.who_global_data VALUES (54467, 218, 41833, 0, 26, 230, 237);
INSERT INTO public.who_global_data VALUES (54468, 0, 2, 0, 0, 230, 55);
INSERT INTO public.who_global_data VALUES (54469, 0, 77, 0, 15, 230, 176);
INSERT INTO public.who_global_data VALUES (54470, 10, 1586, 0, 28, 230, 202);
INSERT INTO public.who_global_data VALUES (54471, 1, 1520, 0, 114, 230, 155);
INSERT INTO public.who_global_data VALUES (54472, 0, 0, 0, 0, 230, 32);
INSERT INTO public.who_global_data VALUES (54473, 36, 2755, 0, 88, 230, 220);
INSERT INTO public.who_global_data VALUES (54474, 4966, 92681, 46, 1877, 230, 30);
INSERT INTO public.who_global_data VALUES (54475, 34, 1864, 2, 34, 230, 147);
INSERT INTO public.who_global_data VALUES (54476, 360, 254790, 18, 29636, 230, 208);
INSERT INTO public.who_global_data VALUES (54477, 0, 1950, 0, 11, 230, 45);
INSERT INTO public.who_global_data VALUES (54478, 164, 8580, 8, 521, 230, 110);
INSERT INTO public.who_global_data VALUES (54479, 16, 293, 0, 8, 230, 88);
INSERT INTO public.who_global_data VALUES (54480, 1209, 57856, 30, 5289, 230, 51);
INSERT INTO public.who_global_data VALUES (54481, 32, 31239, 0, 1720, 230, 209);
INSERT INTO public.who_global_data VALUES (54482, 11, 198, 0, 7, 230, 205);
INSERT INTO public.who_global_data VALUES (54483, 61, 5399, 1, 52, 230, 18);
INSERT INTO public.who_global_data VALUES (54484, 1, 3148, 0, 58, 230, 72);
INSERT INTO public.who_global_data VALUES (54485, 986, 277172, 71, 39847, 230, 44);
INSERT INTO public.who_global_data VALUES (54486, 0, 24, 0, 0, 230, 15);
INSERT INTO public.who_global_data VALUES (54487, 6, 561, 0, 13, 230, 25);
INSERT INTO public.who_global_data VALUES (54488, 0, 0, 0, 0, 230, 179);
INSERT INTO public.who_global_data VALUES (54489, 0, 0, 0, 0, 230, 34);
INSERT INTO public.who_global_data VALUES (54490, 0, 123, 0, 8, 230, 207);
INSERT INTO public.who_global_data VALUES (54491, 1, 1157, 0, 50, 230, 166);
INSERT INTO public.who_global_data VALUES (54492, 1248, 186493, 22, 4927, 230, 126);
INSERT INTO public.who_global_data VALUES (54493, 0, 0, 0, 0, 230, 97);
INSERT INTO public.who_global_data VALUES (54494, 0, 12, 0, 1, 230, 36);
INSERT INTO public.who_global_data VALUES (54495, 0, 0, 0, 0, 230, 125);
INSERT INTO public.who_global_data VALUES (54496, 0, 823, 0, 0, 230, 124);
INSERT INTO public.who_global_data VALUES (54497, 735, 36560, 8, 1002, 230, 185);
INSERT INTO public.who_global_data VALUES (54498, 388, 44533, 1, 301, 230, 194);
INSERT INTO public.who_global_data VALUES (54499, 0, 509, 0, 21, 230, 144);
INSERT INTO public.who_global_data VALUES (54500, 36617, 2208829, 690, 118895, 230, 19);
INSERT INTO public.who_global_data VALUES (54501, 1, 74, 0, 6, 230, 217);
INSERT INTO public.who_global_data VALUES (54502, 3, 853, 0, 24, 230, 148);
INSERT INTO public.who_global_data VALUES (54503, 191, 6216, 0, 19, 230, 86);
INSERT INTO public.who_global_data VALUES (54504, 0, 0, 0, 0, 230, 13);
INSERT INTO public.who_global_data VALUES (54505, 107, 3591, 2, 30, 230, 157);
INSERT INTO public.who_global_data VALUES (54506, 0, 349, 0, 0, 230, 8);
INSERT INTO public.who_global_data VALUES (54507, 0, 0, 0, 0, 230, 73);
INSERT INTO public.who_global_data VALUES (54508, 3, 922, 3, 254, 230, 101);
INSERT INTO public.who_global_data VALUES (54509, 0, 1430, 0, 11, 230, 165);
INSERT INTO public.who_global_data VALUES (54510, 0, 479, 0, 4, 230, 14);
INSERT INTO public.who_global_data VALUES (54511, 419, 28383, 0, 552, 231, 193);
INSERT INTO public.who_global_data VALUES (54512, 0, 1838, 0, 42, 231, 113);
INSERT INTO public.who_global_data VALUES (54513, 119, 11504, 14, 825, 231, 143);
INSERT INTO public.who_global_data VALUES (54514, 0, 0, 0, 0, 231, 219);
INSERT INTO public.who_global_data VALUES (54515, 0, 855, 0, 52, 231, 186);
INSERT INTO public.who_global_data VALUES (54516, 0, 166, 0, 8, 231, 52);
INSERT INTO public.who_global_data VALUES (54517, 0, 3, 0, 0, 231, 180);
INSERT INTO public.who_global_data VALUES (54518, 0, 26, 0, 3, 231, 167);
INSERT INTO public.who_global_data VALUES (54519, 1958, 37510, 25, 954, 231, 154);
INSERT INTO public.who_global_data VALUES (54520, 551, 19021, 13, 327, 231, 94);
INSERT INTO public.who_global_data VALUES (54521, 0, 101, 0, 3, 231, 66);
INSERT INTO public.who_global_data VALUES (54522, 18, 7409, 0, 102, 231, 58);
INSERT INTO public.who_global_data VALUES (54523, 30, 17185, 0, 688, 231, 163);
INSERT INTO public.who_global_data VALUES (54524, 438, 11767, 4, 143, 231, 37);
INSERT INTO public.who_global_data VALUES (54525, 0, 104, 0, 11, 231, 142);
INSERT INTO public.who_global_data VALUES (54526, 486, 20916, 2, 57, 231, 83);
INSERT INTO public.who_global_data VALUES (54527, 3243, 105535, 45, 1388, 231, 228);
INSERT INTO public.who_global_data VALUES (54528, 0, 97, 0, 7, 231, 188);
INSERT INTO public.who_global_data VALUES (54529, 676, 57333, 6, 337, 231, 62);
INSERT INTO public.who_global_data VALUES (54530, 121, 61180, 4, 9566, 231, 160);
INSERT INTO public.who_global_data VALUES (54531, 0, 22, 0, 2, 231, 50);
INSERT INTO public.who_global_data VALUES (54532, 53, 650, 0, 11, 231, 33);
INSERT INTO public.who_global_data VALUES (54533, 0, 144, 0, 9, 231, 183);
INSERT INTO public.who_global_data VALUES (54534, 1, 68, 0, 0, 231, 92);
INSERT INTO public.who_global_data VALUES (54535, 814, 21499, 18, 697, 231, 158);
INSERT INTO public.who_global_data VALUES (54536, 0, 2, 0, 0, 231, 67);
INSERT INTO public.who_global_data VALUES (54537, 86, 3288, 1, 168, 231, 57);
INSERT INTO public.who_global_data VALUES (54538, 10, 89, 0, 1, 231, 38);
INSERT INTO public.who_global_data VALUES (54539, 22765, 978142, 1238, 47748, 231, 141);
INSERT INTO public.who_global_data VALUES (54540, 0, 8, 0, 1, 231, 178);
INSERT INTO public.who_global_data VALUES (54541, 0, 141, 0, 3, 231, 108);
INSERT INTO public.who_global_data VALUES (54542, 81, 3755, 3, 193, 231, 39);
INSERT INTO public.who_global_data VALUES (54543, 2, 901, 0, 53, 231, 2);
INSERT INTO public.who_global_data VALUES (54544, 0, 104, 0, 1, 231, 195);
INSERT INTO public.who_global_data VALUES (54545, 25, 848, 1, 8, 231, 107);
INSERT INTO public.who_global_data VALUES (54546, 0, 129, 0, 0, 231, 161);
INSERT INTO public.who_global_data VALUES (54547, 774, 10638, 6, 282, 231, 212);
INSERT INTO public.who_global_data VALUES (54548, 367, 100220, 46, 8300, 231, 181);
INSERT INTO public.who_global_data VALUES (54549, 0, 193, 0, 1, 231, 53);
INSERT INTO public.who_global_data VALUES (54550, 0, 2605, 0, 19, 231, 164);
INSERT INTO public.who_global_data VALUES (54551, 4, 858, 0, 74, 231, 140);
INSERT INTO public.who_global_data VALUES (54552, 6290, 231393, 252, 4093, 231, 20);
INSERT INTO public.who_global_data VALUES (54553, 30, 84970, 0, 4645, 231, 112);
INSERT INTO public.who_global_data VALUES (54554, 3171, 60217, 86, 1950, 231, 111);
INSERT INTO public.who_global_data VALUES (54555, 0, 210, 0, 5, 231, 71);
INSERT INTO public.who_global_data VALUES (54556, 0, 883, 0, 27, 231, 218);
INSERT INTO public.who_global_data VALUES (54557, 0, 0, 0, 0, 231, 43);
INSERT INTO public.who_global_data VALUES (54558, 68, 1939, 0, 12, 231, 49);
INSERT INTO public.who_global_data VALUES (54559, 430, 6874, 0, 49, 231, 1);
INSERT INTO public.who_global_data VALUES (54560, 11, 2280, 0, 107, 231, 48);
INSERT INTO public.who_global_data VALUES (54561, 10, 2305, 0, 85, 231, 232);
INSERT INTO public.who_global_data VALUES (54562, 0, 23, 0, 1, 231, 175);
INSERT INTO public.who_global_data VALUES (54563, 0, 985, 0, 19, 231, 21);
INSERT INTO public.who_global_data VALUES (54564, 176, 10406, 1, 335, 231, 156);
INSERT INTO public.who_global_data VALUES (54565, 0, 0, 0, 0, 231, 95);
INSERT INTO public.who_global_data VALUES (54566, 194, 5476, 5, 121, 231, 177);
INSERT INTO public.who_global_data VALUES (54567, 47, 12391, 0, 600, 231, 210);
INSERT INTO public.who_global_data VALUES (54568, 8, 4565, 2, 45, 231, 120);
INSERT INTO public.who_global_data VALUES (54569, 0, 18, 0, 0, 231, 135);
INSERT INTO public.who_global_data VALUES (54570, 423, 25068, 12, 647, 231, 206);
INSERT INTO public.who_global_data VALUES (54571, 634, 49731, 69, 4156, 231, 189);
INSERT INTO public.who_global_data VALUES (54572, 1774, 52211, 79, 2017, 231, 129);
INSERT INTO public.who_global_data VALUES (54573, 129, 4329, 4, 86, 231, 121);
INSERT INTO public.who_global_data VALUES (54574, 0, 1043, 0, 12, 231, 59);
INSERT INTO public.who_global_data VALUES (54575, 0, 142, 0, 0, 231, 96);
INSERT INTO public.who_global_data VALUES (54576, 2, 1979, 0, 63, 231, 41);
INSERT INTO public.who_global_data VALUES (54577, 37, 623, 0, 4, 231, 216);
INSERT INTO public.who_global_data VALUES (54578, 116, 4070, 7, 72, 231, 236);
INSERT INTO public.who_global_data VALUES (54579, 0, 13, 0, 0, 231, 150);
INSERT INTO public.who_global_data VALUES (54580, 0, 187, 0, 0, 231, 61);
INSERT INTO public.who_global_data VALUES (54581, 0, 18, 0, 0, 231, 7);
INSERT INTO public.who_global_data VALUES (54582, 16, 7133, 0, 326, 231, 169);
INSERT INTO public.who_global_data VALUES (54583, 584, 154141, 14, 29551, 231, 28);
INSERT INTO public.who_global_data VALUES (54584, 211, 1969, 0, 5, 231, 85);
INSERT INTO public.who_global_data VALUES (54585, 0, 60, 0, 0, 231, 211);
INSERT INTO public.who_global_data VALUES (54586, 0, 4340, 0, 32, 231, 60);
INSERT INTO public.who_global_data VALUES (54587, 0, 36, 0, 1, 231, 3);
INSERT INTO public.who_global_data VALUES (54588, 3, 898, 0, 14, 231, 11);
INSERT INTO public.who_global_data VALUES (54589, 601, 189135, 10, 8882, 231, 89);
INSERT INTO public.who_global_data VALUES (54590, 274, 13203, 4, 70, 231, 24);
INSERT INTO public.who_global_data VALUES (54591, 0, 176, 0, 0, 231, 162);
INSERT INTO public.who_global_data VALUES (54592, 10, 3237, 1, 189, 231, 100);
INSERT INTO public.who_global_data VALUES (54593, 0, 13, 0, 0, 231, 47);
INSERT INTO public.who_global_data VALUES (54594, 0, 23, 0, 0, 231, 29);
INSERT INTO public.who_global_data VALUES (54595, 3, 174, 0, 14, 231, 40);
INSERT INTO public.who_global_data VALUES (54596, 7, 192, 0, 5, 231, 222);
INSERT INTO public.who_global_data VALUES (54597, 617, 11868, 17, 449, 231, 132);
INSERT INTO public.who_global_data VALUES (54598, 0, 252, 0, 13, 231, 130);
INSERT INTO public.who_global_data VALUES (54599, 63, 4904, 1, 27, 231, 234);
INSERT INTO public.who_global_data VALUES (54600, 0, 1512, 0, 16, 231, 23);
INSERT INTO public.who_global_data VALUES (54601, 0, 183, 0, 12, 231, 192);
INSERT INTO public.who_global_data VALUES (54602, 228, 4916, 2, 84, 231, 69);
INSERT INTO public.who_global_data VALUES (54603, 0, 12, 0, 0, 231, 187);
INSERT INTO public.who_global_data VALUES (54604, 440, 10739, 7, 343, 231, 230);
INSERT INTO public.who_global_data VALUES (54605, 5, 4086, 2, 570, 231, 77);
INSERT INTO public.who_global_data VALUES (54606, 1, 1815, 0, 10, 231, 9);
INSERT INTO public.who_global_data VALUES (54607, 14516, 395048, 375, 12948, 231, 74);
INSERT INTO public.who_global_data VALUES (54608, 1041, 43803, 34, 2373, 231, 224);
INSERT INTO public.who_global_data VALUES (54609, 2615, 200262, 120, 9392, 231, 199);
INSERT INTO public.who_global_data VALUES (54610, 1635, 27352, 69, 925, 231, 190);
INSERT INTO public.who_global_data VALUES (54611, 13, 25368, 0, 1714, 231, 12);
INSERT INTO public.who_global_data VALUES (54612, 0, 336, 0, 24, 231, 104);
INSERT INTO public.who_global_data VALUES (54613, 302, 20213, 0, 306, 231, 153);
INSERT INTO public.who_global_data VALUES (54614, -148, 238011, 47, 34561, 231, 91);
INSERT INTO public.who_global_data VALUES (54615, 12, 638, 0, 10, 231, 215);
INSERT INTO public.who_global_data VALUES (54616, 59, 17799, 17, 952, 231, 84);
INSERT INTO public.who_global_data VALUES (54617, 0, 318, 0, 30, 231, 231);
INSERT INTO public.who_global_data VALUES (54618, 6, 943, 0, 9, 231, 196);
INSERT INTO public.who_global_data VALUES (54619, 1062, 17841, 5, 118, 231, 105);
INSERT INTO public.who_global_data VALUES (54620, 117, 4374, 2, 119, 231, 122);
INSERT INTO public.who_global_data VALUES (54621, 0, 0, 0, 0, 231, 159);
INSERT INTO public.who_global_data VALUES (54622, 82, 1955, 0, 24, 231, 75);
INSERT INTO public.who_global_data VALUES (54623, 604, 38678, 5, 313, 231, 27);
INSERT INTO public.who_global_data VALUES (54624, 192, 2981, 3, 35, 231, 54);
INSERT INTO public.who_global_data VALUES (54625, 0, 19, 0, 0, 231, 226);
INSERT INTO public.who_global_data VALUES (54626, 2, 1110, 0, 30, 231, 79);
INSERT INTO public.who_global_data VALUES (54627, 15, 1510, 0, 32, 231, 56);
INSERT INTO public.who_global_data VALUES (54628, 0, 4, 0, 0, 231, 117);
INSERT INTO public.who_global_data VALUES (54629, 39, 581, 0, 33, 231, 152);
INSERT INTO public.who_global_data VALUES (54630, 10, 520, 0, 10, 231, 16);
INSERT INTO public.who_global_data VALUES (54631, 0, 83, 0, 1, 231, 10);
INSERT INTO public.who_global_data VALUES (54632, 3, 1790, 0, 76, 231, 201);
INSERT INTO public.who_global_data VALUES (54633, 8, 4099, 0, 110, 231, 174);
INSERT INTO public.who_global_data VALUES (54634, 40, 1443, 0, 13, 231, 119);
INSERT INTO public.who_global_data VALUES (54635, 56, 648, 0, 8, 231, 168);
INSERT INTO public.who_global_data VALUES (54636, 6, 8535, 0, 121, 231, 99);
INSERT INTO public.who_global_data VALUES (54637, 13, 2150, 0, 8, 231, 171);
INSERT INTO public.who_global_data VALUES (54638, 17, 1923, 1, 108, 231, 87);
INSERT INTO public.who_global_data VALUES (54639, 1, 663, 0, 9, 231, 123);
INSERT INTO public.who_global_data VALUES (54640, 0, 0, 0, 0, 231, 151);
INSERT INTO public.who_global_data VALUES (54641, 0, 221, 0, 14, 231, 213);
INSERT INTO public.who_global_data VALUES (54642, 201, 2424, 2, 97, 231, 118);
INSERT INTO public.who_global_data VALUES (54643, 0, 337, 0, 10, 231, 134);
INSERT INTO public.who_global_data VALUES (54644, 11, 2394, 0, 29, 231, 65);
INSERT INTO public.who_global_data VALUES (54645, 5662, 165455, 667, 19747, 231, 102);
INSERT INTO public.who_global_data VALUES (54646, 0, 0, 0, 0, 231, 223);
INSERT INTO public.who_global_data VALUES (54647, 0, 70, 0, 1, 231, 4);
INSERT INTO public.who_global_data VALUES (54648, 3, 204, 0, 0, 231, 146);
INSERT INTO public.who_global_data VALUES (54649, 4, 358, 0, 9, 231, 31);
INSERT INTO public.who_global_data VALUES (54650, 0, 11, 0, 1, 231, 127);
INSERT INTO public.who_global_data VALUES (54651, 539, 9613, 0, 213, 231, 22);
INSERT INTO public.who_global_data VALUES (54652, 6, 668, 0, 4, 231, 115);
INSERT INTO public.who_global_data VALUES (54653, 0, 286, 0, 6, 231, 106);
INSERT INTO public.who_global_data VALUES (54654, 6, 45, 0, 0, 231, 90);
INSERT INTO public.who_global_data VALUES (54655, 0, 0, 0, 0, 231, 70);
INSERT INTO public.who_global_data VALUES (54656, 426, 8274, 0, 22, 231, 46);
INSERT INTO public.who_global_data VALUES (54657, 108, 49177, 4, 6054, 231, 139);
INSERT INTO public.who_global_data VALUES (54658, 0, 21, 0, 0, 231, 42);
INSERT INTO public.who_global_data VALUES (54659, 2, 1159, 0, 22, 231, 80);
INSERT INTO public.who_global_data VALUES (54660, 0, 2014, 0, 64, 231, 203);
INSERT INTO public.who_global_data VALUES (54661, 6, 1026, 0, 67, 231, 136);
INSERT INTO public.who_global_data VALUES (54662, 667, 19147, 12, 487, 231, 63);
INSERT INTO public.who_global_data VALUES (54663, 0, 0, 0, 0, 231, 17);
INSERT INTO public.who_global_data VALUES (54664, 0, 30, 0, 2, 231, 172);
INSERT INTO public.who_global_data VALUES (54665, 156, 4820, 6, 222, 231, 109);
INSERT INTO public.who_global_data VALUES (54666, 0, 8692, 0, 244, 231, 200);
INSERT INTO public.who_global_data VALUES (54667, 75, 870, 0, 5, 231, 93);
INSERT INTO public.who_global_data VALUES (54668, 852, 27670, 6, 125, 231, 5);
INSERT INTO public.who_global_data VALUES (54669, 0, 741, 0, 13, 231, 214);
INSERT INTO public.who_global_data VALUES (54670, 6604, 171666, 153, 3382, 231, 204);
INSERT INTO public.who_global_data VALUES (54671, 0, 0, 0, 0, 231, 198);
INSERT INTO public.who_global_data VALUES (54672, 754, 23351, 5, 475, 231, 173);
INSERT INTO public.who_global_data VALUES (54673, 0, 8, 0, 0, 231, 229);
INSERT INTO public.who_global_data VALUES (54674, 6, 1336, 0, 13, 231, 76);
INSERT INTO public.who_global_data VALUES (54675, 3480, 244388, 204, 7461, 231, 138);
INSERT INTO public.who_global_data VALUES (54676, 660, 28459, 14, 1130, 231, 98);
INSERT INTO public.who_global_data VALUES (54677, 0, 0, 0, 0, 231, 103);
INSERT INTO public.who_global_data VALUES (54678, 301, 31316, 18, 1334, 231, 225);
INSERT INTO public.who_global_data VALUES (54679, 375, 38464, 3, 1527, 231, 131);
INSERT INTO public.who_global_data VALUES (54680, 84, 6195, 0, 147, 231, 235);
INSERT INTO public.who_global_data VALUES (54681, 1021, 85462, 7, 93, 231, 137);
INSERT INTO public.who_global_data VALUES (54682, 67, 12373, 0, 280, 231, 81);
INSERT INTO public.who_global_data VALUES (54683, 450, 13556, 9, 458, 231, 182);
INSERT INTO public.who_global_data VALUES (54684, 2, 504, 0, 1, 231, 145);
INSERT INTO public.who_global_data VALUES (54685, 320, 23400, 11, 1484, 231, 26);
INSERT INTO public.who_global_data VALUES (54686, 7889, 576952, 161, 8002, 231, 170);
INSERT INTO public.who_global_data VALUES (54687, 15, 661, 0, 2, 231, 191);
INSERT INTO public.who_global_data VALUES (54688, 0, 3, 0, 0, 231, 221);
INSERT INTO public.who_global_data VALUES (54689, 0, 6, 0, 0, 231, 64);
INSERT INTO public.who_global_data VALUES (54690, 0, 0, 0, 0, 231, 116);
INSERT INTO public.who_global_data VALUES (54691, 0, 15, 0, 0, 231, 128);
INSERT INTO public.who_global_data VALUES (54692, 0, 19, 0, 0, 231, 6);
INSERT INTO public.who_global_data VALUES (54693, 0, 42, 0, 3, 231, 227);
INSERT INTO public.who_global_data VALUES (54694, 0, 1, 0, 0, 231, 68);
INSERT INTO public.who_global_data VALUES (54695, 0, 29, 0, 0, 231, 184);
INSERT INTO public.who_global_data VALUES (54696, 0, 0, 0, 0, 231, 82);
INSERT INTO public.who_global_data VALUES (54697, 4, 713, 0, 42, 231, 149);
INSERT INTO public.who_global_data VALUES (54698, 0, 388, 0, 10, 231, 197);
INSERT INTO public.who_global_data VALUES (54699, 4301, 150292, 45, 1184, 231, 78);
INSERT INTO public.who_global_data VALUES (54700, 164, 5639, 3, 79, 231, 233);
INSERT INTO public.who_global_data VALUES (54701, 93, 12709, 1, 259, 231, 133);
INSERT INTO public.who_global_data VALUES (54702, 0, 11, 0, 0, 231, 35);
INSERT INTO public.who_global_data VALUES (54703, 26, 1298, 2, 53, 231, 114);
INSERT INTO public.who_global_data VALUES (54704, 142, 41615, 0, 26, 231, 237);
INSERT INTO public.who_global_data VALUES (54705, 0, 2, 0, 0, 231, 55);
INSERT INTO public.who_global_data VALUES (54706, 0, 77, 0, 15, 231, 176);
INSERT INTO public.who_global_data VALUES (54707, 14, 1576, 0, 28, 231, 202);
INSERT INTO public.who_global_data VALUES (54708, 6, 1519, 0, 114, 231, 155);
INSERT INTO public.who_global_data VALUES (54709, 0, 0, 0, 0, 231, 32);
INSERT INTO public.who_global_data VALUES (54710, 0, 2719, 0, 88, 231, 220);
INSERT INTO public.who_global_data VALUES (54711, 3825, 87715, 94, 1831, 231, 30);
INSERT INTO public.who_global_data VALUES (54712, 17, 1830, 1, 32, 231, 147);
INSERT INTO public.who_global_data VALUES (54713, 391, 254430, 11, 29618, 231, 208);
INSERT INTO public.who_global_data VALUES (54714, 3, 1950, 0, 11, 231, 45);
INSERT INTO public.who_global_data VALUES (54715, 396, 8416, 26, 513, 231, 110);
INSERT INTO public.who_global_data VALUES (54716, 16, 277, 1, 8, 231, 88);
INSERT INTO public.who_global_data VALUES (54717, 1494, 56647, 29, 5259, 231, 51);
INSERT INTO public.who_global_data VALUES (54718, 37, 31207, 0, 1720, 231, 209);
INSERT INTO public.who_global_data VALUES (54719, 0, 187, 0, 7, 231, 205);
INSERT INTO public.who_global_data VALUES (54720, 59, 5338, 0, 51, 231, 18);
INSERT INTO public.who_global_data VALUES (54721, 1, 3147, 0, 58, 231, 72);
INSERT INTO public.who_global_data VALUES (54722, 1027, 276186, 84, 39776, 231, 44);
INSERT INTO public.who_global_data VALUES (54723, 0, 24, 0, 0, 231, 15);
INSERT INTO public.who_global_data VALUES (54724, 11, 555, 0, 13, 231, 25);
INSERT INTO public.who_global_data VALUES (54725, 0, 0, 0, 0, 231, 179);
INSERT INTO public.who_global_data VALUES (54726, 0, 0, 0, 0, 231, 34);
INSERT INTO public.who_global_data VALUES (54727, 0, 123, 0, 8, 231, 207);
INSERT INTO public.who_global_data VALUES (54728, 10, 1156, 0, 50, 231, 166);
INSERT INTO public.who_global_data VALUES (54729, 1214, 185245, 23, 4905, 231, 126);
INSERT INTO public.who_global_data VALUES (54730, 0, 0, 0, 0, 231, 97);
INSERT INTO public.who_global_data VALUES (54731, 0, 12, 0, 1, 231, 36);
INSERT INTO public.who_global_data VALUES (54732, 0, 0, 0, 0, 231, 125);
INSERT INTO public.who_global_data VALUES (54733, 0, 823, 0, 0, 231, 124);
INSERT INTO public.who_global_data VALUES (54734, 841, 35825, 9, 994, 231, 185);
INSERT INTO public.who_global_data VALUES (54735, 393, 44145, 2, 300, 231, 194);
INSERT INTO public.who_global_data VALUES (54736, 0, 509, 0, 21, 231, 144);
INSERT INTO public.who_global_data VALUES (54737, 23046, 2172212, 733, 118205, 231, 19);
INSERT INTO public.who_global_data VALUES (54738, 0, 73, 0, 6, 231, 217);
INSERT INTO public.who_global_data VALUES (54739, 1, 850, 0, 24, 231, 148);
INSERT INTO public.who_global_data VALUES (54740, 170, 6025, 0, 19, 231, 86);
INSERT INTO public.who_global_data VALUES (54741, 0, 0, 0, 0, 231, 13);
INSERT INTO public.who_global_data VALUES (54742, 98, 3484, 0, 28, 231, 157);
INSERT INTO public.who_global_data VALUES (54743, 7, 349, 0, 0, 231, 8);
INSERT INTO public.who_global_data VALUES (54744, 0, 0, 0, 0, 231, 73);
INSERT INTO public.who_global_data VALUES (54745, 10, 919, 3, 251, 231, 101);
INSERT INTO public.who_global_data VALUES (54746, 14, 1430, 0, 11, 231, 165);
INSERT INTO public.who_global_data VALUES (54747, 16, 479, 0, 4, 231, 14);
INSERT INTO public.who_global_data VALUES (54748, 541, 27964, 2, 552, 232, 193);
INSERT INTO public.who_global_data VALUES (54749, 50, 1838, 3, 42, 232, 113);
INSERT INTO public.who_global_data VALUES (54750, 117, 11385, 12, 811, 232, 143);
INSERT INTO public.who_global_data VALUES (54751, 0, 0, 0, 0, 232, 219);
INSERT INTO public.who_global_data VALUES (54752, 1, 855, 0, 52, 232, 186);
INSERT INTO public.who_global_data VALUES (54753, 11, 166, 1, 8, 232, 52);
INSERT INTO public.who_global_data VALUES (54754, 0, 3, 0, 0, 232, 180);
INSERT INTO public.who_global_data VALUES (54755, 0, 26, 0, 3, 232, 167);
INSERT INTO public.who_global_data VALUES (54756, 1393, 35552, 43, 929, 232, 154);
INSERT INTO public.who_global_data VALUES (54757, 459, 18470, 10, 314, 232, 94);
INSERT INTO public.who_global_data VALUES (54758, 0, 101, 0, 3, 232, 66);
INSERT INTO public.who_global_data VALUES (54759, 21, 7391, 0, 102, 232, 58);
INSERT INTO public.who_global_data VALUES (54760, 40, 17155, 1, 688, 232, 163);
INSERT INTO public.who_global_data VALUES (54761, 338, 11329, 6, 139, 232, 37);
INSERT INTO public.who_global_data VALUES (54762, 0, 104, 0, 11, 232, 142);
INSERT INTO public.who_global_data VALUES (54763, 469, 20430, 6, 55, 232, 83);
INSERT INTO public.who_global_data VALUES (54764, 3803, 102292, 38, 1343, 232, 228);
INSERT INTO public.who_global_data VALUES (54765, 0, 97, 0, 7, 232, 188);
INSERT INTO public.who_global_data VALUES (54766, 625, 56657, 7, 331, 232, 62);
INSERT INTO public.who_global_data VALUES (54767, 108, 61059, 5, 9562, 232, 160);
INSERT INTO public.who_global_data VALUES (54768, 0, 22, 0, 2, 232, 50);
INSERT INTO public.who_global_data VALUES (54769, 25, 597, 2, 11, 232, 33);
INSERT INTO public.who_global_data VALUES (54770, 0, 144, 0, 9, 232, 183);
INSERT INTO public.who_global_data VALUES (54771, 0, 67, 0, 0, 232, 92);
INSERT INTO public.who_global_data VALUES (54772, 802, 20685, 20, 679, 232, 158);
INSERT INTO public.who_global_data VALUES (54773, 0, 2, 0, 0, 232, 67);
INSERT INTO public.who_global_data VALUES (54774, 58, 3202, 0, 167, 232, 57);
INSERT INTO public.who_global_data VALUES (54775, 0, 79, 0, 1, 232, 38);
INSERT INTO public.who_global_data VALUES (54776, 32188, 955377, 1269, 46510, 232, 141);
INSERT INTO public.who_global_data VALUES (54777, 0, 8, 0, 1, 232, 178);
INSERT INTO public.who_global_data VALUES (54778, 0, 141, 0, 3, 232, 108);
INSERT INTO public.who_global_data VALUES (54779, 132, 3674, 6, 190, 232, 39);
INSERT INTO public.who_global_data VALUES (54780, 0, 899, 0, 53, 232, 2);
INSERT INTO public.who_global_data VALUES (54781, 0, 104, 0, 1, 232, 195);
INSERT INTO public.who_global_data VALUES (54782, 31, 823, 0, 7, 232, 107);
INSERT INTO public.who_global_data VALUES (54783, 0, 129, 0, 0, 232, 161);
INSERT INTO public.who_global_data VALUES (54784, 0, 9864, 0, 276, 232, 212);
INSERT INTO public.who_global_data VALUES (54785, 386, 99853, 41, 8254, 232, 181);
INSERT INTO public.who_global_data VALUES (54786, 0, 193, 0, 1, 232, 53);
INSERT INTO public.who_global_data VALUES (54787, 41, 2605, 1, 19, 232, 164);
INSERT INTO public.who_global_data VALUES (54788, 0, 854, 0, 74, 232, 140);
INSERT INTO public.who_global_data VALUES (54789, 4475, 225103, 226, 3841, 232, 20);
INSERT INTO public.who_global_data VALUES (54790, 37, 84940, 0, 4645, 232, 112);
INSERT INTO public.who_global_data VALUES (54791, 2115, 57046, 63, 1864, 232, 111);
INSERT INTO public.who_global_data VALUES (54792, 13, 210, 2, 5, 232, 71);
INSERT INTO public.who_global_data VALUES (54793, 0, 883, 0, 27, 232, 218);
INSERT INTO public.who_global_data VALUES (54794, 0, 0, 0, 0, 232, 43);
INSERT INTO public.who_global_data VALUES (54795, 75, 1871, 0, 12, 232, 49);
INSERT INTO public.who_global_data VALUES (54796, 381, 6444, 1, 49, 232, 1);
INSERT INTO public.who_global_data VALUES (54797, 11, 2269, 0, 107, 232, 48);
INSERT INTO public.who_global_data VALUES (54798, 15, 2295, 1, 85, 232, 232);
INSERT INTO public.who_global_data VALUES (54799, 0, 23, 0, 1, 232, 175);
INSERT INTO public.who_global_data VALUES (54800, 0, 985, 1, 19, 232, 21);
INSERT INTO public.who_global_data VALUES (54801, 68, 10230, 1, 334, 232, 156);
INSERT INTO public.who_global_data VALUES (54802, 0, 0, 0, 0, 232, 95);
INSERT INTO public.who_global_data VALUES (54803, 183, 5282, 2, 116, 232, 177);
INSERT INTO public.who_global_data VALUES (54804, 50, 12344, 2, 600, 232, 210);
INSERT INTO public.who_global_data VALUES (54805, 12, 4557, 0, 43, 232, 120);
INSERT INTO public.who_global_data VALUES (54806, 0, 18, 0, 0, 232, 135);
INSERT INTO public.who_global_data VALUES (54807, 540, 24645, 2, 635, 232, 206);
INSERT INTO public.who_global_data VALUES (54808, 607, 49097, 80, 4087, 232, 189);
INSERT INTO public.who_global_data VALUES (54809, 1218, 50437, 88, 1938, 232, 129);
INSERT INTO public.who_global_data VALUES (54810, 134, 4200, 3, 82, 232, 121);
INSERT INTO public.who_global_data VALUES (54811, 0, 1043, 0, 12, 232, 59);
INSERT INTO public.who_global_data VALUES (54812, 11, 142, 0, 0, 232, 96);
INSERT INTO public.who_global_data VALUES (54813, 0, 1977, 0, 63, 232, 41);
INSERT INTO public.who_global_data VALUES (54814, 23, 586, 0, 4, 232, 216);
INSERT INTO public.who_global_data VALUES (54815, 195, 3954, 2, 65, 232, 236);
INSERT INTO public.who_global_data VALUES (54816, 0, 13, 0, 0, 232, 150);
INSERT INTO public.who_global_data VALUES (54817, 0, 187, 0, 0, 232, 61);
INSERT INTO public.who_global_data VALUES (54818, 0, 18, 0, 0, 232, 7);
INSERT INTO public.who_global_data VALUES (54819, 0, 7117, 0, 326, 232, 169);
INSERT INTO public.who_global_data VALUES (54820, 201, 153557, 28, 29537, 232, 28);
INSERT INTO public.who_global_data VALUES (54821, 204, 1758, 0, 5, 232, 85);
INSERT INTO public.who_global_data VALUES (54822, 0, 60, 0, 0, 232, 211);
INSERT INTO public.who_global_data VALUES (54823, 111, 4340, 2, 32, 232, 60);
INSERT INTO public.who_global_data VALUES (54824, 2, 36, 0, 1, 232, 3);
INSERT INTO public.who_global_data VALUES (54825, 2, 895, 0, 14, 232, 11);
INSERT INTO public.who_global_data VALUES (54826, 770, 188534, 16, 8872, 232, 89);
INSERT INTO public.who_global_data VALUES (54827, 339, 12929, 0, 66, 232, 24);
INSERT INTO public.who_global_data VALUES (54828, 0, 176, 0, 0, 232, 162);
INSERT INTO public.who_global_data VALUES (54829, 24, 3227, 1, 188, 232, 100);
INSERT INTO public.who_global_data VALUES (54830, 0, 13, 0, 0, 232, 47);
INSERT INTO public.who_global_data VALUES (54831, 0, 23, 0, 0, 232, 29);
INSERT INTO public.who_global_data VALUES (54832, 0, 171, 0, 14, 232, 40);
INSERT INTO public.who_global_data VALUES (54833, 5, 185, 0, 5, 232, 222);
INSERT INTO public.who_global_data VALUES (54834, 545, 11251, 14, 432, 232, 132);
INSERT INTO public.who_global_data VALUES (54835, 0, 252, 0, 13, 232, 130);
INSERT INTO public.who_global_data VALUES (54836, 173, 4841, 0, 26, 232, 234);
INSERT INTO public.who_global_data VALUES (54837, 20, 1512, 1, 16, 232, 23);
INSERT INTO public.who_global_data VALUES (54838, 12, 183, 0, 12, 232, 192);
INSERT INTO public.who_global_data VALUES (54839, 141, 4688, 2, 82, 232, 69);
INSERT INTO public.who_global_data VALUES (54840, 0, 12, 0, 0, 232, 187);
INSERT INTO public.who_global_data VALUES (54841, 643, 10299, 6, 336, 232, 230);
INSERT INTO public.who_global_data VALUES (54842, 2, 4081, 0, 568, 232, 77);
INSERT INTO public.who_global_data VALUES (54843, 2, 1814, 0, 10, 232, 9);
INSERT INTO public.who_global_data VALUES (54844, 13586, 380532, 336, 12573, 232, 74);
INSERT INTO public.who_global_data VALUES (54845, 1331, 42762, 63, 2339, 232, 224);
INSERT INTO public.who_global_data VALUES (54846, 2596, 197647, 87, 9272, 232, 199);
INSERT INTO public.who_global_data VALUES (54847, 1463, 25717, 83, 856, 232, 190);
INSERT INTO public.who_global_data VALUES (54848, 14, 25355, 4, 1714, 232, 12);
INSERT INTO public.who_global_data VALUES (54849, 0, 336, 0, 24, 232, 104);
INSERT INTO public.who_global_data VALUES (54850, 271, 19911, 0, 306, 232, 153);
INSERT INTO public.who_global_data VALUES (54851, 331, 238159, 66, 34514, 232, 91);
INSERT INTO public.who_global_data VALUES (54852, 5, 626, 0, 10, 232, 215);
INSERT INTO public.who_global_data VALUES (54853, 72, 17740, 0, 935, 232, 84);
INSERT INTO public.who_global_data VALUES (54854, 2, 318, 0, 30, 232, 231);
INSERT INTO public.who_global_data VALUES (54855, 10, 937, 0, 9, 232, 196);
INSERT INTO public.who_global_data VALUES (54856, 428, 16779, 8, 113, 232, 105);
INSERT INTO public.who_global_data VALUES (54857, 213, 4257, 10, 117, 232, 122);
INSERT INTO public.who_global_data VALUES (54858, 0, 0, 0, 0, 232, 159);
INSERT INTO public.who_global_data VALUES (54859, 83, 1873, 0, 24, 232, 75);
INSERT INTO public.who_global_data VALUES (54860, 541, 38074, 2, 308, 232, 27);
INSERT INTO public.who_global_data VALUES (54861, 132, 2789, 1, 32, 232, 54);
INSERT INTO public.who_global_data VALUES (54862, 0, 19, 0, 0, 232, 226);
INSERT INTO public.who_global_data VALUES (54863, 4, 1108, 0, 30, 232, 79);
INSERT INTO public.who_global_data VALUES (54864, 6, 1495, 0, 32, 232, 56);
INSERT INTO public.who_global_data VALUES (54865, 0, 4, 0, 0, 232, 117);
INSERT INTO public.who_global_data VALUES (54866, 26, 542, 0, 33, 232, 152);
INSERT INTO public.who_global_data VALUES (54867, 26, 510, 0, 10, 232, 16);
INSERT INTO public.who_global_data VALUES (54868, 0, 83, 0, 1, 232, 10);
INSERT INTO public.who_global_data VALUES (54869, 8, 1787, 0, 76, 232, 201);
INSERT INTO public.who_global_data VALUES (54870, 6, 4091, 0, 110, 232, 174);
INSERT INTO public.who_global_data VALUES (54871, 25, 1403, 1, 13, 232, 119);
INSERT INTO public.who_global_data VALUES (54872, 20, 592, 2, 8, 232, 168);
INSERT INTO public.who_global_data VALUES (54873, 14, 8529, 0, 121, 232, 99);
INSERT INTO public.who_global_data VALUES (54874, 17, 2137, 0, 8, 232, 171);
INSERT INTO public.who_global_data VALUES (54875, 16, 1906, 0, 107, 232, 87);
INSERT INTO public.who_global_data VALUES (54876, 0, 662, 0, 9, 232, 123);
INSERT INTO public.who_global_data VALUES (54877, 0, 0, 0, 0, 232, 151);
INSERT INTO public.who_global_data VALUES (54878, 19, 221, 0, 14, 232, 213);
INSERT INTO public.who_global_data VALUES (54879, 166, 2223, 2, 95, 232, 118);
INSERT INTO public.who_global_data VALUES (54880, 0, 337, 0, 10, 232, 134);
INSERT INTO public.who_global_data VALUES (54881, 38, 2383, 0, 29, 232, 65);
INSERT INTO public.who_global_data VALUES (54882, 4930, 159793, 770, 19080, 232, 102);
INSERT INTO public.who_global_data VALUES (54883, 0, 0, 0, 0, 232, 223);
INSERT INTO public.who_global_data VALUES (54884, 0, 70, 0, 1, 232, 4);
INSERT INTO public.who_global_data VALUES (54885, 4, 201, 0, 0, 232, 146);
INSERT INTO public.who_global_data VALUES (54886, 17, 354, 0, 9, 232, 31);
INSERT INTO public.who_global_data VALUES (54887, 0, 11, 0, 1, 232, 127);
INSERT INTO public.who_global_data VALUES (54888, 77, 9074, 0, 213, 232, 22);
INSERT INTO public.who_global_data VALUES (54889, 11, 662, 0, 4, 232, 115);
INSERT INTO public.who_global_data VALUES (54890, 23, 286, 0, 6, 232, 106);
INSERT INTO public.who_global_data VALUES (54891, 5, 39, 0, 0, 232, 90);
INSERT INTO public.who_global_data VALUES (54892, 0, 0, 0, 0, 232, 70);
INSERT INTO public.who_global_data VALUES (54893, 671, 7848, 2, 22, 232, 46);
INSERT INTO public.who_global_data VALUES (54894, 125, 49069, 3, 6050, 232, 139);
INSERT INTO public.who_global_data VALUES (54895, 0, 21, 0, 0, 232, 42);
INSERT INTO public.who_global_data VALUES (54896, 0, 1157, 0, 22, 232, 80);
INSERT INTO public.who_global_data VALUES (54897, 0, 2014, 0, 64, 232, 203);
INSERT INTO public.who_global_data VALUES (54898, 0, 1020, 0, 67, 232, 136);
INSERT INTO public.who_global_data VALUES (54899, 745, 18480, 6, 475, 232, 63);
INSERT INTO public.who_global_data VALUES (54900, 0, 0, 0, 0, 232, 17);
INSERT INTO public.who_global_data VALUES (54901, 0, 30, 0, 2, 232, 172);
INSERT INTO public.who_global_data VALUES (54902, 182, 4664, 6, 216, 232, 109);
INSERT INTO public.who_global_data VALUES (54903, 32, 8692, 1, 244, 232, 200);
INSERT INTO public.who_global_data VALUES (54904, 50, 795, 0, 5, 232, 93);
INSERT INTO public.who_global_data VALUES (54905, 739, 26818, 3, 119, 232, 5);
INSERT INTO public.who_global_data VALUES (54906, 0, 741, 0, 13, 232, 214);
INSERT INTO public.who_global_data VALUES (54907, 4944, 165062, 136, 3229, 232, 204);
INSERT INTO public.who_global_data VALUES (54908, 0, 0, 0, 0, 232, 198);
INSERT INTO public.who_global_data VALUES (54909, 635, 22597, 13, 470, 232, 173);
INSERT INTO public.who_global_data VALUES (54910, 0, 8, 0, 0, 232, 229);
INSERT INTO public.who_global_data VALUES (54911, 22, 1330, 0, 13, 232, 76);
INSERT INTO public.who_global_data VALUES (54912, 3752, 240908, 201, 7257, 232, 138);
INSERT INTO public.who_global_data VALUES (54913, 561, 27799, 8, 1116, 232, 98);
INSERT INTO public.who_global_data VALUES (54914, 0, 0, 0, 0, 232, 103);
INSERT INTO public.who_global_data VALUES (54915, 314, 31015, 30, 1316, 232, 225);
INSERT INTO public.who_global_data VALUES (54916, 417, 38089, 1, 1524, 232, 131);
INSERT INTO public.who_global_data VALUES (54917, 108, 6111, 0, 147, 232, 235);
INSERT INTO public.who_global_data VALUES (54918, 1267, 84441, 4, 86, 232, 137);
INSERT INTO public.who_global_data VALUES (54919, 49, 12306, 0, 280, 232, 81);
INSERT INTO public.who_global_data VALUES (54920, 374, 13106, 16, 449, 232, 182);
INSERT INTO public.who_global_data VALUES (54921, 5, 502, 0, 1, 232, 145);
INSERT INTO public.who_global_data VALUES (54922, 320, 23080, 22, 1473, 232, 26);
INSERT INTO public.who_global_data VALUES (54923, 7972, 569063, 181, 7841, 232, 170);
INSERT INTO public.who_global_data VALUES (54924, 7, 646, 0, 2, 232, 191);
INSERT INTO public.who_global_data VALUES (54925, 0, 3, 0, 0, 232, 221);
INSERT INTO public.who_global_data VALUES (54926, 0, 6, 0, 0, 232, 64);
INSERT INTO public.who_global_data VALUES (54927, 0, 0, 0, 0, 232, 116);
INSERT INTO public.who_global_data VALUES (54928, 0, 15, 0, 0, 232, 128);
INSERT INTO public.who_global_data VALUES (54929, 0, 19, 0, 0, 232, 6);
INSERT INTO public.who_global_data VALUES (54930, 0, 42, 0, 3, 232, 227);
INSERT INTO public.who_global_data VALUES (54931, 0, 1, 0, 0, 232, 68);
INSERT INTO public.who_global_data VALUES (54932, 0, 29, 0, 0, 232, 184);
INSERT INTO public.who_global_data VALUES (54933, 0, 0, 0, 0, 232, 82);
INSERT INTO public.who_global_data VALUES (54934, 0, 709, 0, 42, 232, 149);
INSERT INTO public.who_global_data VALUES (54935, 0, 388, 0, 10, 232, 197);
INSERT INTO public.who_global_data VALUES (54936, 4757, 145991, 48, 1139, 232, 78);
INSERT INTO public.who_global_data VALUES (54937, 106, 5475, 3, 76, 232, 233);
INSERT INTO public.who_global_data VALUES (54938, 94, 12616, 1, 258, 232, 133);
INSERT INTO public.who_global_data VALUES (54939, 0, 11, 0, 0, 232, 35);
INSERT INTO public.who_global_data VALUES (54940, 23, 1272, 0, 51, 232, 114);
INSERT INTO public.who_global_data VALUES (54941, 257, 41473, 0, 26, 232, 237);
INSERT INTO public.who_global_data VALUES (54942, 0, 2, 0, 0, 232, 55);
INSERT INTO public.who_global_data VALUES (54943, 0, 77, 0, 15, 232, 176);
INSERT INTO public.who_global_data VALUES (54944, 1, 1562, 0, 28, 232, 202);
INSERT INTO public.who_global_data VALUES (54945, 2, 1513, 0, 114, 232, 155);
INSERT INTO public.who_global_data VALUES (54946, 0, 0, 0, 0, 232, 32);
INSERT INTO public.who_global_data VALUES (54947, 23, 2719, 0, 88, 232, 220);
INSERT INTO public.who_global_data VALUES (54948, 3478, 83890, 63, 1737, 232, 30);
INSERT INTO public.who_global_data VALUES (54949, 6, 1813, 0, 31, 232, 147);
INSERT INTO public.who_global_data VALUES (54950, 357, 254039, 23, 29607, 232, 208);
INSERT INTO public.who_global_data VALUES (54951, 23, 1947, 0, 11, 232, 45);
INSERT INTO public.who_global_data VALUES (54952, 0, 8020, 0, 487, 232, 110);
INSERT INTO public.who_global_data VALUES (54953, 19, 261, 1, 7, 232, 88);
INSERT INTO public.who_global_data VALUES (54954, 1457, 55153, 32, 5230, 232, 51);
INSERT INTO public.who_global_data VALUES (54955, 18, 31170, 0, 1720, 232, 209);
INSERT INTO public.who_global_data VALUES (54956, 9, 187, 0, 7, 232, 205);
INSERT INTO public.who_global_data VALUES (54957, 58, 5279, 0, 51, 232, 18);
INSERT INTO public.who_global_data VALUES (54958, 5, 3146, 0, 58, 232, 72);
INSERT INTO public.who_global_data VALUES (54959, 1013, 275159, 67, 39692, 232, 44);
INSERT INTO public.who_global_data VALUES (54960, 0, 24, 0, 0, 232, 15);
INSERT INTO public.who_global_data VALUES (54961, 7, 544, 0, 13, 232, 25);
INSERT INTO public.who_global_data VALUES (54962, 0, 0, 0, 0, 232, 179);
INSERT INTO public.who_global_data VALUES (54963, 0, 0, 0, 0, 232, 34);
INSERT INTO public.who_global_data VALUES (54964, 0, 123, 0, 8, 232, 207);
INSERT INTO public.who_global_data VALUES (54965, 14, 1146, 0, 50, 232, 166);
INSERT INTO public.who_global_data VALUES (54966, 1304, 184031, 21, 4882, 232, 126);
INSERT INTO public.who_global_data VALUES (54967, 0, 0, 0, 0, 232, 97);
INSERT INTO public.who_global_data VALUES (54968, 0, 12, 0, 1, 232, 36);
INSERT INTO public.who_global_data VALUES (54969, 0, 0, 0, 0, 232, 125);
INSERT INTO public.who_global_data VALUES (54970, 0, 823, 0, 0, 232, 124);
INSERT INTO public.who_global_data VALUES (54971, 921, 34984, 19, 985, 232, 185);
INSERT INTO public.who_global_data VALUES (54972, 388, 43752, 3, 298, 232, 194);
INSERT INTO public.who_global_data VALUES (54973, 0, 509, 0, 21, 232, 144);
INSERT INTO public.who_global_data VALUES (54974, 23139, 2149166, 770, 117472, 232, 19);
INSERT INTO public.who_global_data VALUES (54975, 0, 73, 0, 6, 232, 217);
INSERT INTO public.who_global_data VALUES (54976, 0, 849, 0, 24, 232, 148);
INSERT INTO public.who_global_data VALUES (54977, 158, 5855, 0, 19, 232, 86);
INSERT INTO public.who_global_data VALUES (54978, 0, 0, 0, 0, 232, 13);
INSERT INTO public.who_global_data VALUES (54979, 236, 3386, 1, 28, 232, 157);
INSERT INTO public.who_global_data VALUES (54980, 7, 342, 0, 0, 232, 8);
INSERT INTO public.who_global_data VALUES (54981, 0, 0, 0, 0, 232, 73);
INSERT INTO public.who_global_data VALUES (54982, 7, 909, 4, 248, 232, 101);
INSERT INTO public.who_global_data VALUES (54983, 4, 1416, 0, 11, 232, 165);
INSERT INTO public.who_global_data VALUES (54984, 62, 463, 0, 4, 232, 14);
INSERT INTO public.who_global_data VALUES (54985, 463, 27423, 42, 550, 233, 193);
INSERT INTO public.who_global_data VALUES (54986, 66, 1788, 1, 39, 233, 113);
INSERT INTO public.who_global_data VALUES (54987, 121, 11268, 11, 799, 233, 143);
INSERT INTO public.who_global_data VALUES (54988, 0, 0, 0, 0, 233, 219);
INSERT INTO public.who_global_data VALUES (54989, 0, 854, 0, 52, 233, 186);
INSERT INTO public.who_global_data VALUES (54990, 13, 155, 1, 7, 233, 52);
INSERT INTO public.who_global_data VALUES (54991, 0, 3, 0, 0, 233, 180);
INSERT INTO public.who_global_data VALUES (54992, 0, 26, 0, 3, 233, 167);
INSERT INTO public.who_global_data VALUES (54993, 1374, 34159, 24, 886, 233, 154);
INSERT INTO public.who_global_data VALUES (54994, 665, 18011, 7, 304, 233, 94);
INSERT INTO public.who_global_data VALUES (54995, 0, 101, 0, 3, 233, 66);
INSERT INTO public.who_global_data VALUES (54996, 23, 7370, 0, 102, 233, 58);
INSERT INTO public.who_global_data VALUES (54997, 17, 17115, 6, 687, 233, 163);
INSERT INTO public.who_global_data VALUES (54998, 329, 10991, 7, 133, 233, 37);
INSERT INTO public.who_global_data VALUES (54999, 0, 104, 0, 11, 233, 142);
INSERT INTO public.who_global_data VALUES (55000, 408, 19961, 2, 49, 233, 83);
INSERT INTO public.who_global_data VALUES (55001, 4008, 98489, 43, 1305, 233, 228);
INSERT INTO public.who_global_data VALUES (55002, 0, 97, 0, 7, 233, 188);
INSERT INTO public.who_global_data VALUES (55003, 663, 56032, 6, 324, 233, 62);
INSERT INTO public.who_global_data VALUES (55004, 123, 60951, 7, 9557, 233, 160);
INSERT INTO public.who_global_data VALUES (55005, 1, 22, 0, 2, 233, 50);
INSERT INTO public.who_global_data VALUES (55006, 40, 572, 0, 9, 233, 33);
INSERT INTO public.who_global_data VALUES (55007, 0, 144, 0, 9, 233, 183);
INSERT INTO public.who_global_data VALUES (55008, 0, 67, 0, 0, 233, 92);
INSERT INTO public.who_global_data VALUES (55009, 810, 19883, 27, 659, 233, 158);
INSERT INTO public.who_global_data VALUES (55010, 0, 2, 0, 0, 233, 67);
INSERT INTO public.who_global_data VALUES (55011, 60, 3144, 0, 167, 233, 57);
INSERT INTO public.who_global_data VALUES (55012, 19, 79, 0, 1, 233, 38);
INSERT INTO public.who_global_data VALUES (55013, 34918, 923189, 1282, 45241, 233, 141);
INSERT INTO public.who_global_data VALUES (55014, 0, 8, 0, 1, 233, 178);
INSERT INTO public.who_global_data VALUES (55015, 0, 141, 0, 3, 233, 108);
INSERT INTO public.who_global_data VALUES (55016, 89, 3542, 3, 184, 233, 39);
INSERT INTO public.who_global_data VALUES (55017, 4, 899, 0, 53, 233, 2);
INSERT INTO public.who_global_data VALUES (55018, 0, 104, 0, 1, 233, 195);
INSERT INTO public.who_global_data VALUES (55019, 11, 792, 0, 7, 233, 107);
INSERT INTO public.who_global_data VALUES (55020, 1, 129, 0, 0, 233, 161);
INSERT INTO public.who_global_data VALUES (55021, 0, 9864, 0, 276, 233, 212);
INSERT INTO public.who_global_data VALUES (55022, 320, 99467, 38, 8213, 233, 181);
INSERT INTO public.who_global_data VALUES (55023, 6, 193, 0, 1, 233, 53);
INSERT INTO public.who_global_data VALUES (55024, 154, 2564, 4, 18, 233, 164);
INSERT INTO public.who_global_data VALUES (55025, 1, 854, 0, 74, 233, 140);
INSERT INTO public.who_global_data VALUES (55026, 36179, 220628, 232, 3615, 233, 20);
INSERT INTO public.who_global_data VALUES (55027, 36, 84903, 0, 4645, 233, 112);
INSERT INTO public.who_global_data VALUES (55028, 1868, 54931, 75, 1801, 233, 111);
INSERT INTO public.who_global_data VALUES (55029, 0, 197, 0, 3, 233, 71);
INSERT INTO public.who_global_data VALUES (55030, 0, 883, 0, 27, 233, 218);
INSERT INTO public.who_global_data VALUES (55031, 0, 0, 0, 0, 233, 43);
INSERT INTO public.who_global_data VALUES (55032, 52, 1796, 0, 12, 233, 49);
INSERT INTO public.who_global_data VALUES (55033, 384, 6063, 2, 48, 233, 1);
INSERT INTO public.who_global_data VALUES (55034, 3, 2258, 0, 107, 233, 48);
INSERT INTO public.who_global_data VALUES (55035, 7, 2280, 0, 84, 233, 232);
INSERT INTO public.who_global_data VALUES (55036, 1, 23, 0, 1, 233, 175);
INSERT INTO public.who_global_data VALUES (55037, 0, 985, 0, 18, 233, 21);
INSERT INTO public.who_global_data VALUES (55038, 51, 10162, 2, 333, 233, 156);
INSERT INTO public.who_global_data VALUES (55039, 0, 0, 0, 0, 233, 95);
INSERT INTO public.who_global_data VALUES (55040, 126, 5099, 3, 114, 233, 177);
INSERT INTO public.who_global_data VALUES (55041, 44, 12294, 0, 598, 233, 210);
INSERT INTO public.who_global_data VALUES (55042, 6, 4545, 0, 43, 233, 120);
INSERT INTO public.who_global_data VALUES (55043, 0, 18, 0, 0, 233, 135);
INSERT INTO public.who_global_data VALUES (55044, 419, 24105, 18, 633, 233, 206);
INSERT INTO public.who_global_data VALUES (55045, 547, 48490, 37, 4007, 233, 189);
INSERT INTO public.who_global_data VALUES (55046, 1363, 49219, 84, 1850, 233, 129);
INSERT INTO public.who_global_data VALUES (55047, 125, 4066, 3, 79, 233, 121);
INSERT INTO public.who_global_data VALUES (55048, 0, 1043, 0, 12, 233, 59);
INSERT INTO public.who_global_data VALUES (55049, 10, 131, 0, 0, 233, 96);
INSERT INTO public.who_global_data VALUES (55050, 2, 1977, 0, 63, 233, 41);
INSERT INTO public.who_global_data VALUES (55051, 43, 563, 0, 4, 233, 216);
INSERT INTO public.who_global_data VALUES (55052, 129, 3759, 2, 63, 233, 236);
INSERT INTO public.who_global_data VALUES (55053, 0, 13, 0, 0, 233, 150);
INSERT INTO public.who_global_data VALUES (55054, 0, 187, 0, 0, 233, 61);
INSERT INTO public.who_global_data VALUES (55055, 0, 18, 0, 0, 233, 7);
INSERT INTO public.who_global_data VALUES (55056, 5, 7117, 0, 326, 233, 169);
INSERT INTO public.who_global_data VALUES (55057, 311, 153356, 28, 29509, 233, 28);
INSERT INTO public.who_global_data VALUES (55058, 133, 1554, 0, 5, 233, 85);
INSERT INTO public.who_global_data VALUES (55059, 0, 60, 0, 0, 233, 211);
INSERT INTO public.who_global_data VALUES (55060, 115, 4229, 1, 30, 233, 60);
INSERT INTO public.who_global_data VALUES (55061, 0, 34, 0, 1, 233, 3);
INSERT INTO public.who_global_data VALUES (55062, 5, 893, 0, 14, 233, 11);
INSERT INTO public.who_global_data VALUES (55063, 580, 187764, 26, 8856, 233, 89);
INSERT INTO public.who_global_data VALUES (55064, 397, 12590, 8, 66, 233, 24);
INSERT INTO public.who_global_data VALUES (55065, 0, 176, 0, 0, 233, 162);
INSERT INTO public.who_global_data VALUES (55066, 55, 3203, 2, 187, 233, 100);
INSERT INTO public.who_global_data VALUES (55067, 0, 13, 0, 0, 233, 47);
INSERT INTO public.who_global_data VALUES (55068, 0, 23, 0, 0, 233, 29);
INSERT INTO public.who_global_data VALUES (55069, 0, 171, 0, 14, 233, 40);
INSERT INTO public.who_global_data VALUES (55070, 2, 180, 0, 5, 233, 222);
INSERT INTO public.who_global_data VALUES (55071, 434, 10706, 19, 418, 233, 132);
INSERT INTO public.who_global_data VALUES (55072, 0, 252, 0, 13, 233, 130);
INSERT INTO public.who_global_data VALUES (55073, 29, 4668, 0, 26, 233, 234);
INSERT INTO public.who_global_data VALUES (55074, 0, 1492, 0, 15, 233, 23);
INSERT INTO public.who_global_data VALUES (55075, 12, 171, 0, 12, 233, 192);
INSERT INTO public.who_global_data VALUES (55076, 106, 4547, 4, 80, 233, 69);
INSERT INTO public.who_global_data VALUES (55077, 0, 12, 0, 0, 233, 187);
INSERT INTO public.who_global_data VALUES (55078, 478, 9656, 8, 330, 233, 230);
INSERT INTO public.who_global_data VALUES (55079, 1, 4079, 1, 568, 233, 77);
INSERT INTO public.who_global_data VALUES (55080, 0, 1812, 0, 10, 233, 9);
INSERT INTO public.who_global_data VALUES (55081, 12881, 366946, 334, 12237, 233, 74);
INSERT INTO public.who_global_data VALUES (55082, 1031, 41431, 45, 2276, 233, 224);
INSERT INTO public.who_global_data VALUES (55083, 2612, 195051, 120, 9185, 233, 199);
INSERT INTO public.who_global_data VALUES (55084, 1554, 24254, 61, 773, 233, 190);
INSERT INTO public.who_global_data VALUES (55085, 7, 25341, 1, 1710, 233, 12);
INSERT INTO public.who_global_data VALUES (55086, 0, 336, 0, 24, 233, 104);
INSERT INTO public.who_global_data VALUES (55087, 300, 19640, 1, 306, 233, 153);
INSERT INTO public.who_global_data VALUES (55088, 328, 237828, 43, 34448, 233, 91);
INSERT INTO public.who_global_data VALUES (55089, 0, 621, 0, 10, 233, 215);
INSERT INTO public.who_global_data VALUES (55090, 40, 17668, 4, 935, 233, 84);
INSERT INTO public.who_global_data VALUES (55091, 0, 316, 0, 30, 233, 231);
INSERT INTO public.who_global_data VALUES (55092, 6, 927, 0, 9, 233, 196);
INSERT INTO public.who_global_data VALUES (55093, 474, 16351, 5, 105, 233, 105);
INSERT INTO public.who_global_data VALUES (55094, 184, 4044, 2, 107, 233, 122);
INSERT INTO public.who_global_data VALUES (55095, 0, 0, 0, 0, 233, 159);
INSERT INTO public.who_global_data VALUES (55096, 77, 1790, 0, 24, 233, 75);
INSERT INTO public.who_global_data VALUES (55097, 575, 37533, 3, 306, 233, 27);
INSERT INTO public.who_global_data VALUES (55098, 95, 2657, 1, 31, 233, 54);
INSERT INTO public.who_global_data VALUES (55099, 0, 19, 0, 0, 233, 226);
INSERT INTO public.who_global_data VALUES (55100, 6, 1104, 2, 30, 233, 79);
INSERT INTO public.who_global_data VALUES (55101, 16, 1489, 0, 32, 233, 56);
INSERT INTO public.who_global_data VALUES (55102, 0, 4, 0, 0, 233, 117);
INSERT INTO public.who_global_data VALUES (55103, 7, 516, 0, 33, 233, 152);
INSERT INTO public.who_global_data VALUES (55104, 17, 484, 0, 10, 233, 16);
INSERT INTO public.who_global_data VALUES (55105, 0, 83, 0, 1, 233, 10);
INSERT INTO public.who_global_data VALUES (55106, 6, 1779, 0, 76, 233, 201);
INSERT INTO public.who_global_data VALUES (55107, 10, 4085, 0, 110, 233, 174);
INSERT INTO public.who_global_data VALUES (55108, 61, 1378, 0, 12, 233, 119);
INSERT INTO public.who_global_data VALUES (55109, 8, 572, 0, 6, 233, 168);
INSERT INTO public.who_global_data VALUES (55110, 10, 8515, 0, 121, 233, 99);
INSERT INTO public.who_global_data VALUES (55111, 26, 2120, 0, 8, 233, 171);
INSERT INTO public.who_global_data VALUES (55112, 5, 1890, 1, 107, 233, 87);
INSERT INTO public.who_global_data VALUES (55113, 1, 662, 0, 9, 233, 123);
INSERT INTO public.who_global_data VALUES (55114, 0, 0, 0, 0, 233, 151);
INSERT INTO public.who_global_data VALUES (55115, 0, 202, 0, 14, 233, 213);
INSERT INTO public.who_global_data VALUES (55116, 170, 2057, 2, 93, 233, 118);
INSERT INTO public.who_global_data VALUES (55117, 0, 337, 0, 10, 233, 134);
INSERT INTO public.who_global_data VALUES (55118, 12, 2345, 0, 29, 233, 65);
INSERT INTO public.who_global_data VALUES (55119, 4599, 154863, 730, 18310, 233, 102);
INSERT INTO public.who_global_data VALUES (55120, 0, 0, 0, 0, 233, 223);
INSERT INTO public.who_global_data VALUES (55121, 0, 70, 0, 1, 233, 4);
INSERT INTO public.who_global_data VALUES (55122, 0, 197, 0, 0, 233, 146);
INSERT INTO public.who_global_data VALUES (55123, 4, 337, 0, 9, 233, 31);
INSERT INTO public.who_global_data VALUES (55124, 0, 11, 0, 1, 233, 127);
INSERT INTO public.who_global_data VALUES (55125, 66, 8997, 1, 213, 233, 22);
INSERT INTO public.who_global_data VALUES (55126, 13, 651, 0, 4, 233, 115);
INSERT INTO public.who_global_data VALUES (55127, 1, 263, 0, 6, 233, 106);
INSERT INTO public.who_global_data VALUES (55128, 0, 34, 0, 0, 233, 90);
INSERT INTO public.who_global_data VALUES (55129, 0, 0, 0, 0, 233, 70);
INSERT INTO public.who_global_data VALUES (55130, 586, 7177, 1, 20, 233, 46);
INSERT INTO public.who_global_data VALUES (55131, 113, 48944, 5, 6047, 233, 139);
INSERT INTO public.who_global_data VALUES (55132, 0, 21, 0, 0, 233, 42);
INSERT INTO public.who_global_data VALUES (55133, 1, 1157, 0, 22, 233, 80);
INSERT INTO public.who_global_data VALUES (55134, 359, 2014, 9, 64, 233, 203);
INSERT INTO public.who_global_data VALUES (55135, 4, 1020, 1, 67, 233, 136);
INSERT INTO public.who_global_data VALUES (55136, 587, 17735, 45, 469, 233, 63);
INSERT INTO public.who_global_data VALUES (55137, 0, 0, 0, 0, 233, 17);
INSERT INTO public.who_global_data VALUES (55138, 0, 30, 0, 2, 233, 172);
INSERT INTO public.who_global_data VALUES (55139, 193, 4482, 9, 210, 233, 109);
INSERT INTO public.who_global_data VALUES (55140, 29, 8660, 1, 243, 233, 200);
INSERT INTO public.who_global_data VALUES (55141, 50, 745, 0, 5, 233, 93);
INSERT INTO public.who_global_data VALUES (55142, 810, 26079, 2, 116, 233, 5);
INSERT INTO public.who_global_data VALUES (55143, 0, 741, 0, 13, 233, 214);
INSERT INTO public.who_global_data VALUES (55144, 5358, 160118, 118, 3093, 233, 204);
INSERT INTO public.who_global_data VALUES (55145, 0, 0, 0, 0, 233, 198);
INSERT INTO public.who_global_data VALUES (55146, 540, 21962, 9, 457, 233, 173);
INSERT INTO public.who_global_data VALUES (55147, 0, 8, 0, 0, 233, 229);
INSERT INTO public.who_global_data VALUES (55148, 5, 1308, 1, 13, 233, 76);
INSERT INTO public.who_global_data VALUES (55149, 4164, 237156, 196, 7056, 233, 138);
INSERT INTO public.who_global_data VALUES (55150, 457, 27238, 5, 1108, 233, 98);
INSERT INTO public.who_global_data VALUES (55151, 0, 0, 0, 0, 233, 103);
INSERT INTO public.who_global_data VALUES (55152, 506, 30701, 14, 1286, 233, 225);
INSERT INTO public.who_global_data VALUES (55153, 336, 37672, 1, 1523, 233, 131);
INSERT INTO public.who_global_data VALUES (55154, 52, 6003, 0, 147, 233, 235);
INSERT INTO public.who_global_data VALUES (55155, 1097, 83174, 2, 82, 233, 137);
INSERT INTO public.who_global_data VALUES (55156, 59, 12257, 1, 280, 233, 81);
INSERT INTO public.who_global_data VALUES (55157, 478, 12732, 6, 433, 233, 182);
INSERT INTO public.who_global_data VALUES (55158, 2, 497, 0, 1, 233, 145);
INSERT INTO public.who_global_data VALUES (55159, 345, 22760, 14, 1451, 233, 26);
INSERT INTO public.who_global_data VALUES (55160, 7790, 561091, 182, 7660, 233, 170);
INSERT INTO public.who_global_data VALUES (55161, 3, 639, 0, 2, 233, 191);
INSERT INTO public.who_global_data VALUES (55162, 0, 3, 0, 0, 233, 221);
INSERT INTO public.who_global_data VALUES (55163, 0, 6, 0, 0, 233, 64);
INSERT INTO public.who_global_data VALUES (55164, 0, 0, 0, 0, 233, 116);
INSERT INTO public.who_global_data VALUES (55165, 0, 15, 0, 0, 233, 128);
INSERT INTO public.who_global_data VALUES (55166, 0, 19, 0, 0, 233, 6);
INSERT INTO public.who_global_data VALUES (55167, 0, 42, 0, 3, 233, 227);
INSERT INTO public.who_global_data VALUES (55168, 0, 1, 0, 0, 233, 68);
INSERT INTO public.who_global_data VALUES (55169, 2, 29, 0, 0, 233, 184);
INSERT INTO public.who_global_data VALUES (55170, 0, 0, 0, 0, 233, 82);
INSERT INTO public.who_global_data VALUES (55171, 14, 709, 0, 42, 233, 149);
INSERT INTO public.who_global_data VALUES (55172, -10, 388, 0, 10, 233, 197);
INSERT INTO public.who_global_data VALUES (55173, 4919, 141234, 39, 1091, 233, 78);
INSERT INTO public.who_global_data VALUES (55174, 122, 5369, 3, 73, 233, 233);
INSERT INTO public.who_global_data VALUES (55175, 96, 12522, 1, 257, 233, 133);
INSERT INTO public.who_global_data VALUES (55176, 0, 11, 0, 0, 233, 35);
INSERT INTO public.who_global_data VALUES (55177, 24, 1249, 0, 51, 233, 114);
INSERT INTO public.who_global_data VALUES (55178, 247, 41216, 0, 26, 233, 237);
INSERT INTO public.who_global_data VALUES (55179, 0, 2, 0, 0, 233, 55);
INSERT INTO public.who_global_data VALUES (55180, 0, 77, 0, 15, 233, 176);
INSERT INTO public.who_global_data VALUES (55181, 9, 1561, 0, 28, 233, 202);
INSERT INTO public.who_global_data VALUES (55182, 8, 1511, 0, 114, 233, 155);
INSERT INTO public.who_global_data VALUES (55183, 0, 0, 0, 0, 233, 32);
INSERT INTO public.who_global_data VALUES (55184, 38, 2696, 0, 88, 233, 220);
INSERT INTO public.who_global_data VALUES (55185, 4078, 80412, 49, 1674, 233, 30);
INSERT INTO public.who_global_data VALUES (55186, 31, 1807, 1, 31, 233, 147);
INSERT INTO public.who_global_data VALUES (55187, 387, 253682, 12, 29584, 233, 208);
INSERT INTO public.who_global_data VALUES (55188, 9, 1924, 0, 11, 233, 45);
INSERT INTO public.who_global_data VALUES (55189, 280, 8020, 10, 487, 233, 110);
INSERT INTO public.who_global_data VALUES (55190, 6, 242, 0, 6, 233, 88);
INSERT INTO public.who_global_data VALUES (55191, 1209, 53696, 28, 5198, 233, 51);
INSERT INTO public.who_global_data VALUES (55192, 18, 31152, 0, 1720, 233, 209);
INSERT INTO public.who_global_data VALUES (55193, 1, 178, 1, 7, 233, 205);
INSERT INTO public.who_global_data VALUES (55194, 61, 5221, 1, 51, 233, 18);
INSERT INTO public.who_global_data VALUES (55195, 6, 3141, 0, 58, 233, 72);
INSERT INTO public.who_global_data VALUES (55196, 1102, 274146, 110, 39625, 233, 44);
INSERT INTO public.who_global_data VALUES (55197, 0, 24, 0, 0, 233, 15);
INSERT INTO public.who_global_data VALUES (55198, 0, 537, 0, 13, 233, 25);
INSERT INTO public.who_global_data VALUES (55199, 0, 0, 0, 0, 233, 179);
INSERT INTO public.who_global_data VALUES (55200, 0, 0, 0, 0, 233, 34);
INSERT INTO public.who_global_data VALUES (55201, 0, 123, 0, 8, 233, 207);
INSERT INTO public.who_global_data VALUES (55202, 4, 1132, 0, 50, 233, 166);
INSERT INTO public.who_global_data VALUES (55203, 1429, 182727, 19, 4861, 233, 126);
INSERT INTO public.who_global_data VALUES (55204, 0, 0, 0, 0, 233, 97);
INSERT INTO public.who_global_data VALUES (55205, 0, 12, 0, 1, 233, 36);
INSERT INTO public.who_global_data VALUES (55206, 0, 0, 0, 0, 233, 125);
INSERT INTO public.who_global_data VALUES (55207, 0, 823, 0, 0, 233, 124);
INSERT INTO public.who_global_data VALUES (55208, 829, 34063, 23, 966, 233, 185);
INSERT INTO public.who_global_data VALUES (55209, 382, 43364, 2, 295, 233, 194);
INSERT INTO public.who_global_data VALUES (55210, 0, 509, 0, 21, 233, 144);
INSERT INTO public.who_global_data VALUES (55211, 27921, 2126027, 722, 116702, 233, 19);
INSERT INTO public.who_global_data VALUES (55212, 0, 73, 0, 6, 233, 217);
INSERT INTO public.who_global_data VALUES (55213, 1, 849, 1, 24, 233, 148);
INSERT INTO public.who_global_data VALUES (55214, 136, 5697, 0, 19, 233, 86);
INSERT INTO public.who_global_data VALUES (55215, 0, 0, 0, 0, 233, 13);
INSERT INTO public.who_global_data VALUES (55216, 88, 3150, 1, 27, 233, 157);
INSERT INTO public.who_global_data VALUES (55217, 0, 335, 0, 0, 233, 8);
INSERT INTO public.who_global_data VALUES (55218, 0, 0, 0, 0, 233, 73);
INSERT INTO public.who_global_data VALUES (55219, 17, 902, 30, 244, 233, 101);
INSERT INTO public.who_global_data VALUES (55220, 7, 1412, 0, 11, 233, 165);
INSERT INTO public.who_global_data VALUES (55221, 10, 401, 0, 4, 233, 14);
INSERT INTO public.who_global_data VALUES (55222, 1241, 26960, 20, 508, 234, 193);
INSERT INTO public.who_global_data VALUES (55223, 50, 1722, 1, 38, 234, 113);
INSERT INTO public.who_global_data VALUES (55224, 116, 11147, 11, 788, 234, 143);
INSERT INTO public.who_global_data VALUES (55225, 0, 0, 0, 0, 234, 219);
INSERT INTO public.who_global_data VALUES (55226, 1, 854, 1, 52, 234, 186);
INSERT INTO public.who_global_data VALUES (55227, 0, 142, 0, 6, 234, 52);
INSERT INTO public.who_global_data VALUES (55228, 0, 3, 0, 0, 234, 180);
INSERT INTO public.who_global_data VALUES (55229, 0, 26, 0, 3, 234, 167);
INSERT INTO public.who_global_data VALUES (55230, 1208, 32785, 20, 862, 234, 154);
INSERT INTO public.who_global_data VALUES (55231, 544, 17346, 9, 297, 234, 94);
INSERT INTO public.who_global_data VALUES (55232, 0, 101, 0, 3, 234, 66);
INSERT INTO public.who_global_data VALUES (55233, 12, 7347, 0, 102, 234, 58);
INSERT INTO public.who_global_data VALUES (55234, 33, 17098, 3, 681, 234, 163);
INSERT INTO public.who_global_data VALUES (55235, 338, 10662, 4, 126, 234, 37);
INSERT INTO public.who_global_data VALUES (55236, 0, 104, 0, 11, 234, 142);
INSERT INTO public.who_global_data VALUES (55237, 540, 19553, 1, 47, 234, 83);
INSERT INTO public.who_global_data VALUES (55238, 3862, 94481, 53, 1262, 234, 228);
INSERT INTO public.who_global_data VALUES (55239, 0, 97, 0, 7, 234, 188);
INSERT INTO public.who_global_data VALUES (55240, 689, 55369, 6, 318, 234, 62);
INSERT INTO public.who_global_data VALUES (55241, 99, 60828, 7, 9550, 234, 160);
INSERT INTO public.who_global_data VALUES (55242, 0, 21, 0, 2, 234, 50);
INSERT INTO public.who_global_data VALUES (55243, 49, 532, 0, 9, 234, 33);
INSERT INTO public.who_global_data VALUES (55244, 0, 144, 0, 9, 234, 183);
INSERT INTO public.who_global_data VALUES (55245, 0, 67, 0, 0, 234, 92);
INSERT INTO public.who_global_data VALUES (55246, 614, 19073, 21, 632, 234, 158);
INSERT INTO public.who_global_data VALUES (55247, 0, 2, 0, 0, 234, 67);
INSERT INTO public.who_global_data VALUES (55248, 45, 3084, 3, 167, 234, 57);
INSERT INTO public.who_global_data VALUES (55249, 0, 60, 0, 1, 234, 38);
INSERT INTO public.who_global_data VALUES (55250, 20647, 888271, 627, 43959, 234, 141);
INSERT INTO public.who_global_data VALUES (55251, 0, 8, 0, 1, 234, 178);
INSERT INTO public.who_global_data VALUES (55252, 0, 141, 1, 3, 234, 108);
INSERT INTO public.who_global_data VALUES (55253, 112, 3453, 5, 181, 234, 39);
INSERT INTO public.who_global_data VALUES (55254, 1, 895, 0, 53, 234, 2);
INSERT INTO public.who_global_data VALUES (55255, 0, 104, 0, 1, 234, 195);
INSERT INTO public.who_global_data VALUES (55256, 21, 781, 0, 7, 234, 107);
INSERT INTO public.who_global_data VALUES (55257, 0, 128, 0, 0, 234, 161);
INSERT INTO public.who_global_data VALUES (55258, 0, 9864, 0, 276, 234, 212);
INSERT INTO public.who_global_data VALUES (55259, 360, 99147, 29, 8175, 234, 181);
INSERT INTO public.who_global_data VALUES (55260, 0, 187, 0, 1, 234, 53);
INSERT INTO public.who_global_data VALUES (55261, 188, 2410, 7, 14, 234, 164);
INSERT INTO public.who_global_data VALUES (55262, 3, 853, 1, 74, 234, 140);
INSERT INTO public.who_global_data VALUES (55263, 5013, 184449, 21, 3383, 234, 20);
INSERT INTO public.who_global_data VALUES (55264, 44, 84867, 0, 4645, 234, 112);
INSERT INTO public.who_global_data VALUES (55265, 2124, 53063, 59, 1726, 234, 111);
INSERT INTO public.who_global_data VALUES (55266, 21, 197, 1, 3, 234, 71);
INSERT INTO public.who_global_data VALUES (55267, 0, 883, 0, 27, 234, 218);
INSERT INTO public.who_global_data VALUES (55268, 0, 0, 0, 0, 234, 43);
INSERT INTO public.who_global_data VALUES (55269, 29, 1744, 0, 12, 234, 49);
INSERT INTO public.who_global_data VALUES (55270, 595, 5679, 1, 46, 234, 1);
INSERT INTO public.who_global_data VALUES (55271, 1, 2255, 0, 107, 234, 48);
INSERT INTO public.who_global_data VALUES (55272, 11, 2273, 0, 84, 234, 232);
INSERT INTO public.who_global_data VALUES (55273, 0, 22, 0, 1, 234, 175);
INSERT INTO public.who_global_data VALUES (55274, 0, 985, 0, 18, 234, 21);
INSERT INTO public.who_global_data VALUES (55275, 47, 10111, 1, 331, 234, 156);
INSERT INTO public.who_global_data VALUES (55276, 0, 0, 0, 0, 234, 95);
INSERT INTO public.who_global_data VALUES (55277, 196, 4973, 5, 111, 234, 177);
INSERT INTO public.who_global_data VALUES (55278, 33, 12250, 0, 598, 234, 210);
INSERT INTO public.who_global_data VALUES (55279, 38, 4539, 0, 43, 234, 120);
INSERT INTO public.who_global_data VALUES (55280, 0, 18, 0, 0, 234, 135);
INSERT INTO public.who_global_data VALUES (55281, 415, 23686, 10, 615, 234, 206);
INSERT INTO public.who_global_data VALUES (55282, 621, 47943, 41, 3970, 234, 189);
INSERT INTO public.who_global_data VALUES (55283, 1567, 47856, 94, 1766, 234, 129);
INSERT INTO public.who_global_data VALUES (55284, 115, 3941, 2, 76, 234, 121);
INSERT INTO public.who_global_data VALUES (55285, 0, 1043, 0, 12, 234, 59);
INSERT INTO public.who_global_data VALUES (55286, 12, 121, 0, 0, 234, 96);
INSERT INTO public.who_global_data VALUES (55287, 1, 1975, 0, 63, 234, 41);
INSERT INTO public.who_global_data VALUES (55288, 14, 520, 0, 4, 234, 216);
INSERT INTO public.who_global_data VALUES (55289, 109, 3630, 1, 61, 234, 236);
INSERT INTO public.who_global_data VALUES (55290, 0, 13, 0, 0, 234, 150);
INSERT INTO public.who_global_data VALUES (55291, 0, 187, 0, 0, 234, 61);
INSERT INTO public.who_global_data VALUES (55292, 0, 18, 0, 0, 234, 7);
INSERT INTO public.who_global_data VALUES (55293, 4, 7112, 0, 326, 234, 169);
INSERT INTO public.who_global_data VALUES (55294, 226, 153045, 108, 29481, 234, 28);
INSERT INTO public.who_global_data VALUES (55295, 95, 1421, 2, 5, 234, 85);
INSERT INTO public.who_global_data VALUES (55296, 0, 60, 0, 0, 234, 211);
INSERT INTO public.who_global_data VALUES (55297, 81, 4114, 2, 29, 234, 60);
INSERT INTO public.who_global_data VALUES (55298, 6, 34, 0, 1, 234, 3);
INSERT INTO public.who_global_data VALUES (55299, 9, 888, 0, 14, 234, 11);
INSERT INTO public.who_global_data VALUES (55300, 345, 187184, 30, 8830, 234, 89);
INSERT INTO public.who_global_data VALUES (55301, 229, 12193, 4, 58, 234, 24);
INSERT INTO public.who_global_data VALUES (55302, 0, 176, 0, 0, 234, 162);
INSERT INTO public.who_global_data VALUES (55303, 14, 3148, 1, 185, 234, 100);
INSERT INTO public.who_global_data VALUES (55304, 0, 13, 0, 0, 234, 47);
INSERT INTO public.who_global_data VALUES (55305, 0, 23, 0, 0, 234, 29);
INSERT INTO public.who_global_data VALUES (55306, 0, 171, 0, 14, 234, 40);
INSERT INTO public.who_global_data VALUES (55307, 0, 178, 0, 5, 234, 222);
INSERT INTO public.who_global_data VALUES (55308, 427, 10272, 15, 399, 234, 132);
INSERT INTO public.who_global_data VALUES (55309, 0, 252, 0, 13, 234, 130);
INSERT INTO public.who_global_data VALUES (55310, 67, 4639, 0, 26, 234, 234);
INSERT INTO public.who_global_data VALUES (55311, 32, 1492, 0, 15, 234, 23);
INSERT INTO public.who_global_data VALUES (55312, 0, 159, 0, 12, 234, 192);
INSERT INTO public.who_global_data VALUES (55313, 132, 4441, 3, 76, 234, 69);
INSERT INTO public.who_global_data VALUES (55314, 0, 12, 0, 0, 234, 187);
INSERT INTO public.who_global_data VALUES (55315, 320, 9178, 10, 322, 234, 230);
INSERT INTO public.who_global_data VALUES (55316, 1, 4078, 2, 567, 234, 77);
INSERT INTO public.who_global_data VALUES (55317, 1, 1812, 0, 10, 234, 9);
INSERT INTO public.who_global_data VALUES (55318, 10974, 354065, 2003, 11903, 234, 74);
INSERT INTO public.who_global_data VALUES (55319, 1106, 40400, 33, 2231, 234, 224);
INSERT INTO public.who_global_data VALUES (55320, 2563, 192439, 115, 9065, 234, 199);
INSERT INTO public.who_global_data VALUES (55321, 1385, 22700, 60, 712, 234, 190);
INSERT INTO public.who_global_data VALUES (55322, 13, 25334, 3, 1709, 234, 12);
INSERT INTO public.who_global_data VALUES (55323, 0, 336, 0, 24, 234, 104);
INSERT INTO public.who_global_data VALUES (55324, 198, 19340, 0, 305, 234, 153);
INSERT INTO public.who_global_data VALUES (55325, 210, 237500, 34, 34405, 234, 91);
INSERT INTO public.who_global_data VALUES (55326, 4, 621, 0, 10, 234, 215);
INSERT INTO public.who_global_data VALUES (55327, 41, 17628, 4, 931, 234, 84);
INSERT INTO public.who_global_data VALUES (55328, 3, 316, 0, 30, 234, 231);
INSERT INTO public.who_global_data VALUES (55329, 0, 921, 0, 9, 234, 196);
INSERT INTO public.who_global_data VALUES (55330, 335, 15877, 12, 100, 234, 105);
INSERT INTO public.who_global_data VALUES (55331, 133, 3860, 1, 105, 234, 122);
INSERT INTO public.who_global_data VALUES (55332, 0, 0, 0, 0, 234, 159);
INSERT INTO public.who_global_data VALUES (55333, 141, 1713, 1, 24, 234, 75);
INSERT INTO public.who_global_data VALUES (55334, 527, 36958, 5, 303, 234, 27);
INSERT INTO public.who_global_data VALUES (55335, 90, 2562, 1, 30, 234, 54);
INSERT INTO public.who_global_data VALUES (55336, 0, 19, 0, 0, 234, 226);
INSERT INTO public.who_global_data VALUES (55337, 1, 1098, 0, 28, 234, 79);
INSERT INTO public.who_global_data VALUES (55338, 9, 1473, 0, 32, 234, 56);
INSERT INTO public.who_global_data VALUES (55339, 0, 4, 0, 0, 234, 117);
INSERT INTO public.who_global_data VALUES (55340, 11, 509, 0, 33, 234, 152);
INSERT INTO public.who_global_data VALUES (55341, 0, 467, 0, 10, 234, 16);
INSERT INTO public.who_global_data VALUES (55342, 0, 83, 0, 1, 234, 10);
INSERT INTO public.who_global_data VALUES (55343, 2, 1773, 0, 76, 234, 201);
INSERT INTO public.who_global_data VALUES (55344, 3, 4075, 0, 110, 234, 174);
INSERT INTO public.who_global_data VALUES (55345, 27, 1317, 2, 12, 234, 119);
INSERT INTO public.who_global_data VALUES (55346, 8, 564, 0, 6, 234, 168);
INSERT INTO public.who_global_data VALUES (55347, 11, 8505, 0, 121, 234, 99);
INSERT INTO public.who_global_data VALUES (55348, 29, 2094, 0, 8, 234, 171);
INSERT INTO public.who_global_data VALUES (55349, 25, 1885, 2, 106, 234, 87);
INSERT INTO public.who_global_data VALUES (55350, 6, 661, 0, 9, 234, 123);
INSERT INTO public.who_global_data VALUES (55351, 0, 0, 0, 0, 234, 151);
INSERT INTO public.who_global_data VALUES (55352, 0, 202, 0, 14, 234, 213);
INSERT INTO public.who_global_data VALUES (55353, 104, 1887, 4, 91, 234, 118);
INSERT INTO public.who_global_data VALUES (55354, 0, 337, 0, 10, 234, 134);
INSERT INTO public.who_global_data VALUES (55355, 23, 2333, 1, 29, 234, 65);
INSERT INTO public.who_global_data VALUES (55356, 3427, 150264, 439, 17580, 234, 102);
INSERT INTO public.who_global_data VALUES (55357, 0, 0, 0, 0, 234, 223);
INSERT INTO public.who_global_data VALUES (55358, 0, 70, 0, 1, 234, 4);
INSERT INTO public.who_global_data VALUES (55359, 0, 197, 0, 0, 234, 146);
INSERT INTO public.who_global_data VALUES (55360, 7, 333, 0, 9, 234, 31);
INSERT INTO public.who_global_data VALUES (55361, 0, 11, 0, 1, 234, 127);
INSERT INTO public.who_global_data VALUES (55362, 46, 8931, 0, 212, 234, 22);
INSERT INTO public.who_global_data VALUES (55363, 29, 638, 1, 4, 234, 115);
INSERT INTO public.who_global_data VALUES (55364, 0, 262, 0, 6, 234, 106);
INSERT INTO public.who_global_data VALUES (55365, 2, 34, 0, 0, 234, 90);
INSERT INTO public.who_global_data VALUES (55366, 0, 0, 0, 0, 234, 70);
INSERT INTO public.who_global_data VALUES (55367, 380, 6591, 0, 19, 234, 46);
INSERT INTO public.who_global_data VALUES (55368, 134, 48831, 4, 6042, 234, 139);
INSERT INTO public.who_global_data VALUES (55369, 0, 21, 0, 0, 234, 42);
INSERT INTO public.who_global_data VALUES (55370, 0, 1156, 0, 22, 234, 80);
INSERT INTO public.who_global_data VALUES (55371, 0, 1655, 0, 55, 234, 203);
INSERT INTO public.who_global_data VALUES (55372, 36, 1016, 0, 66, 234, 136);
INSERT INTO public.who_global_data VALUES (55373, 490, 17148, 0, 424, 234, 63);
INSERT INTO public.who_global_data VALUES (55374, 0, 0, 0, 0, 234, 17);
INSERT INTO public.who_global_data VALUES (55375, 0, 30, 0, 2, 234, 172);
INSERT INTO public.who_global_data VALUES (55376, 132, 4289, 8, 201, 234, 109);
INSERT INTO public.who_global_data VALUES (55377, 0, 8631, 0, 242, 234, 200);
INSERT INTO public.who_global_data VALUES (55378, 6, 695, 0, 5, 234, 93);
INSERT INTO public.who_global_data VALUES (55379, 745, 25269, 6, 114, 234, 5);
INSERT INTO public.who_global_data VALUES (55380, 0, 741, 0, 13, 234, 214);
INSERT INTO public.who_global_data VALUES (55381, 5839, 154760, 136, 2975, 234, 204);
INSERT INTO public.who_global_data VALUES (55382, 0, 0, 0, 0, 234, 198);
INSERT INTO public.who_global_data VALUES (55383, 736, 21422, 11, 448, 234, 173);
INSERT INTO public.who_global_data VALUES (55384, 0, 8, 0, 0, 234, 229);
INSERT INTO public.who_global_data VALUES (55385, 7, 1303, 0, 12, 234, 76);
INSERT INTO public.who_global_data VALUES (55386, 3256, 232992, 172, 6860, 234, 138);
INSERT INTO public.who_global_data VALUES (55387, 361, 26781, 5, 1103, 234, 98);
INSERT INTO public.who_global_data VALUES (55388, 0, 0, 0, 0, 234, 103);
INSERT INTO public.who_global_data VALUES (55389, 407, 30195, 16, 1272, 234, 225);
INSERT INTO public.who_global_data VALUES (55390, 300, 37336, 2, 1522, 234, 131);
INSERT INTO public.who_global_data VALUES (55391, 61, 5951, 0, 147, 234, 235);
INSERT INTO public.who_global_data VALUES (55392, 1201, 82077, 4, 80, 234, 137);
INSERT INTO public.who_global_data VALUES (55393, 43, 12198, 1, 279, 234, 81);
INSERT INTO public.who_global_data VALUES (55394, 375, 12254, 10, 427, 234, 182);
INSERT INTO public.who_global_data VALUES (55395, -1, 495, 0, 1, 234, 145);
INSERT INTO public.who_global_data VALUES (55396, 250, 22415, 10, 1437, 234, 26);
INSERT INTO public.who_global_data VALUES (55397, 7843, 553301, 194, 7478, 234, 170);
INSERT INTO public.who_global_data VALUES (55398, 24, 636, 0, 2, 234, 191);
INSERT INTO public.who_global_data VALUES (55399, 0, 3, 0, 0, 234, 221);
INSERT INTO public.who_global_data VALUES (55400, 0, 6, 0, 0, 234, 64);
INSERT INTO public.who_global_data VALUES (55401, 0, 0, 0, 0, 234, 116);
INSERT INTO public.who_global_data VALUES (55402, 0, 15, 0, 0, 234, 128);
INSERT INTO public.who_global_data VALUES (55403, 0, 19, 0, 0, 234, 6);
INSERT INTO public.who_global_data VALUES (55404, 1, 42, 0, 3, 234, 227);
INSERT INTO public.who_global_data VALUES (55405, 0, 1, 0, 0, 234, 68);
INSERT INTO public.who_global_data VALUES (55406, 0, 27, 0, 0, 234, 184);
INSERT INTO public.who_global_data VALUES (55407, 0, 0, 0, 0, 234, 82);
INSERT INTO public.who_global_data VALUES (55408, 0, 695, 0, 42, 234, 149);
INSERT INTO public.who_global_data VALUES (55409, 10, 398, 0, 10, 234, 197);
INSERT INTO public.who_global_data VALUES (55410, 4267, 136315, 41, 1052, 234, 78);
INSERT INTO public.who_global_data VALUES (55411, 157, 5247, 10, 70, 234, 233);
INSERT INTO public.who_global_data VALUES (55412, 59, 12426, 1, 256, 234, 133);
INSERT INTO public.who_global_data VALUES (55413, 0, 11, 0, 0, 234, 35);
INSERT INTO public.who_global_data VALUES (55414, 49, 1225, 0, 51, 234, 114);
INSERT INTO public.who_global_data VALUES (55415, 151, 40969, 0, 26, 234, 237);
INSERT INTO public.who_global_data VALUES (55416, 0, 2, 0, 0, 234, 55);
INSERT INTO public.who_global_data VALUES (55417, 0, 77, 0, 15, 234, 176);
INSERT INTO public.who_global_data VALUES (55418, 0, 1552, 0, 28, 234, 202);
INSERT INTO public.who_global_data VALUES (55419, 4, 1503, 1, 114, 234, 155);
INSERT INTO public.who_global_data VALUES (55420, 0, 0, 0, 0, 234, 32);
INSERT INTO public.who_global_data VALUES (55421, 16, 2658, 0, 88, 234, 220);
INSERT INTO public.who_global_data VALUES (55422, 2801, 76334, 57, 1625, 234, 30);
INSERT INTO public.who_global_data VALUES (55423, 21, 1776, 0, 30, 234, 147);
INSERT INTO public.who_global_data VALUES (55424, 301, 253295, 20, 29572, 234, 208);
INSERT INTO public.who_global_data VALUES (55425, 10, 1915, 0, 11, 234, 45);
INSERT INTO public.who_global_data VALUES (55426, 305, 7740, 9, 477, 234, 110);
INSERT INTO public.who_global_data VALUES (55427, 28, 236, 2, 6, 234, 88);
INSERT INTO public.who_global_data VALUES (55428, 685, 52487, 30, 5170, 234, 51);
INSERT INTO public.who_global_data VALUES (55429, 21, 31134, 1, 1720, 234, 209);
INSERT INTO public.who_global_data VALUES (55430, 0, 177, 0, 6, 234, 205);
INSERT INTO public.who_global_data VALUES (55431, 63, 5160, 0, 50, 234, 18);
INSERT INTO public.who_global_data VALUES (55432, 0, 3135, 0, 58, 234, 72);
INSERT INTO public.who_global_data VALUES (55433, 1043, 273044, 120, 39515, 234, 44);
INSERT INTO public.who_global_data VALUES (55434, 0, 24, 0, 0, 234, 15);
INSERT INTO public.who_global_data VALUES (55435, 6, 537, 0, 13, 234, 25);
INSERT INTO public.who_global_data VALUES (55436, 0, 0, 0, 0, 234, 179);
INSERT INTO public.who_global_data VALUES (55437, 0, 0, 0, 0, 234, 34);
INSERT INTO public.who_global_data VALUES (55438, 0, 123, 0, 8, 234, 207);
INSERT INTO public.who_global_data VALUES (55439, 3, 1128, 1, 50, 234, 166);
INSERT INTO public.who_global_data VALUES (55440, 1467, 181298, 17, 4842, 234, 126);
INSERT INTO public.who_global_data VALUES (55441, 0, 0, 0, 0, 234, 97);
INSERT INTO public.who_global_data VALUES (55442, 0, 12, 0, 1, 234, 36);
INSERT INTO public.who_global_data VALUES (55443, 0, 0, 0, 0, 234, 125);
INSERT INTO public.who_global_data VALUES (55444, 0, 823, 0, 0, 234, 124);
INSERT INTO public.who_global_data VALUES (55445, 758, 33234, 30, 943, 234, 185);
INSERT INTO public.who_global_data VALUES (55446, 346, 42982, 2, 293, 234, 194);
INSERT INTO public.who_global_data VALUES (55447, 0, 509, 0, 21, 234, 144);
INSERT INTO public.who_global_data VALUES (55448, 18514, 2098106, 496, 115980, 234, 19);
INSERT INTO public.who_global_data VALUES (55449, 1, 73, 0, 6, 234, 217);
INSERT INTO public.who_global_data VALUES (55450, 0, 848, 0, 23, 234, 148);
INSERT INTO public.who_global_data VALUES (55451, 268, 5561, 0, 19, 234, 86);
INSERT INTO public.who_global_data VALUES (55452, 0, 0, 0, 0, 234, 13);
INSERT INTO public.who_global_data VALUES (55453, 84, 3062, 1, 26, 234, 157);
INSERT INTO public.who_global_data VALUES (55454, 1, 335, 0, 0, 234, 8);
INSERT INTO public.who_global_data VALUES (55455, 0, 0, 0, 0, 234, 73);
INSERT INTO public.who_global_data VALUES (55456, 41, 885, 6, 214, 234, 101);
INSERT INTO public.who_global_data VALUES (55457, 23, 1405, 0, 11, 234, 165);
INSERT INTO public.who_global_data VALUES (55458, 4, 391, 0, 4, 234, 14);
INSERT INTO public.who_global_data VALUES (55459, 106, 25719, 8, 488, 235, 193);
INSERT INTO public.who_global_data VALUES (55460, 82, 1672, 1, 37, 235, 113);
INSERT INTO public.who_global_data VALUES (55461, 112, 11031, 10, 777, 235, 143);
INSERT INTO public.who_global_data VALUES (55462, 0, 0, 0, 0, 235, 219);
INSERT INTO public.who_global_data VALUES (55463, 0, 853, 0, 51, 235, 186);
INSERT INTO public.who_global_data VALUES (55464, 2, 142, 0, 6, 235, 52);
INSERT INTO public.who_global_data VALUES (55465, 0, 3, 0, 0, 235, 180);
INSERT INTO public.who_global_data VALUES (55466, 0, 26, 0, 3, 235, 167);
INSERT INTO public.who_global_data VALUES (55467, 1282, 31577, 23, 842, 235, 154);
INSERT INTO public.who_global_data VALUES (55468, 425, 16802, 8, 288, 235, 94);
INSERT INTO public.who_global_data VALUES (55469, 0, 101, 0, 3, 235, 66);
INSERT INTO public.who_global_data VALUES (55470, 15, 7335, 0, 102, 235, 58);
INSERT INTO public.who_global_data VALUES (55471, 27, 17065, 1, 678, 235, 163);
INSERT INTO public.who_global_data VALUES (55472, 367, 10324, 3, 122, 235, 37);
INSERT INTO public.who_global_data VALUES (55473, 1, 104, 0, 11, 235, 142);
INSERT INTO public.who_global_data VALUES (55474, 469, 19013, 3, 46, 235, 83);
INSERT INTO public.who_global_data VALUES (55475, 3099, 90619, 38, 1209, 235, 228);
INSERT INTO public.who_global_data VALUES (55476, 1, 97, 0, 7, 235, 188);
INSERT INTO public.who_global_data VALUES (55477, 707, 54680, 4, 312, 235, 62);
INSERT INTO public.who_global_data VALUES (55478, 147, 60729, 8, 9543, 235, 160);
INSERT INTO public.who_global_data VALUES (55479, 0, 21, 0, 2, 235, 50);
INSERT INTO public.who_global_data VALUES (55480, 13, 483, 2, 9, 235, 33);
INSERT INTO public.who_global_data VALUES (55481, 0, 144, 0, 9, 235, 183);
INSERT INTO public.who_global_data VALUES (55482, 1, 67, 0, 0, 235, 92);
INSERT INTO public.who_global_data VALUES (55483, 617, 18459, 26, 611, 235, 158);
INSERT INTO public.who_global_data VALUES (55484, 0, 2, 0, 0, 235, 67);
INSERT INTO public.who_global_data VALUES (55485, 38, 3039, 1, 164, 235, 57);
INSERT INTO public.who_global_data VALUES (55486, 0, 60, 0, 1, 235, 38);
INSERT INTO public.who_global_data VALUES (55487, 17110, 867624, 612, 43332, 235, 141);
INSERT INTO public.who_global_data VALUES (55488, 0, 8, 0, 1, 235, 178);
INSERT INTO public.who_global_data VALUES (55489, 0, 141, 0, 2, 235, 108);
INSERT INTO public.who_global_data VALUES (55490, 51, 3341, 2, 176, 235, 39);
INSERT INTO public.who_global_data VALUES (55491, 0, 894, 0, 53, 235, 2);
INSERT INTO public.who_global_data VALUES (55492, 10, 104, 0, 1, 235, 195);
INSERT INTO public.who_global_data VALUES (55493, 10, 760, 1, 7, 235, 107);
INSERT INTO public.who_global_data VALUES (55494, 0, 128, 0, 0, 235, 161);
INSERT INTO public.who_global_data VALUES (55495, 292, 9864, 1, 276, 235, 212);
INSERT INTO public.who_global_data VALUES (55496, 377, 98787, 39, 8146, 235, 181);
INSERT INTO public.who_global_data VALUES (55497, 0, 187, 0, 1, 235, 53);
INSERT INTO public.who_global_data VALUES (55498, 0, 2222, 0, 7, 235, 164);
INSERT INTO public.who_global_data VALUES (55499, 0, 850, 0, 73, 235, 140);
INSERT INTO public.who_global_data VALUES (55500, 5143, 179436, 39, 3362, 235, 20);
INSERT INTO public.who_global_data VALUES (55501, 45, 84823, 0, 4645, 235, 112);
INSERT INTO public.who_global_data VALUES (55502, 2193, 50939, 75, 1667, 235, 111);
INSERT INTO public.who_global_data VALUES (55503, 0, 176, 0, 2, 235, 71);
INSERT INTO public.who_global_data VALUES (55504, 104, 883, 2, 27, 235, 218);
INSERT INTO public.who_global_data VALUES (55505, 0, 0, 0, 0, 235, 43);
INSERT INTO public.who_global_data VALUES (55506, 53, 1715, 0, 12, 235, 49);
INSERT INTO public.who_global_data VALUES (55507, 0, 5084, 0, 45, 235, 1);
INSERT INTO public.who_global_data VALUES (55508, 2, 2254, 0, 107, 235, 48);
INSERT INTO public.who_global_data VALUES (55509, 14, 2262, 0, 84, 235, 232);
INSERT INTO public.who_global_data VALUES (55510, 0, 22, 0, 1, 235, 175);
INSERT INTO public.who_global_data VALUES (55511, 2, 985, 0, 18, 235, 21);
INSERT INTO public.who_global_data VALUES (55512, 40, 10064, 1, 330, 235, 156);
INSERT INTO public.who_global_data VALUES (55513, 0, 0, 0, 0, 235, 95);
INSERT INTO public.who_global_data VALUES (55514, 0, 4777, 0, 106, 235, 177);
INSERT INTO public.who_global_data VALUES (55515, 24, 12217, 1, 598, 235, 210);
INSERT INTO public.who_global_data VALUES (55516, 36, 4501, 0, 43, 235, 120);
INSERT INTO public.who_global_data VALUES (55517, 0, 18, 0, 0, 235, 135);
INSERT INTO public.who_global_data VALUES (55518, 309, 23271, 13, 605, 235, 206);
INSERT INTO public.who_global_data VALUES (55519, 571, 47322, 33, 3929, 235, 189);
INSERT INTO public.who_global_data VALUES (55520, 1691, 46289, 97, 1672, 235, 129);
INSERT INTO public.who_global_data VALUES (55521, 106, 3826, 2, 74, 235, 121);
INSERT INTO public.who_global_data VALUES (55522, 0, 1043, 0, 12, 235, 59);
INSERT INTO public.who_global_data VALUES (55523, 13, 109, 0, 0, 235, 96);
INSERT INTO public.who_global_data VALUES (55524, 1, 1974, 0, 63, 235, 41);
INSERT INTO public.who_global_data VALUES (55525, 16, 506, 0, 4, 235, 216);
INSERT INTO public.who_global_data VALUES (55526, 176, 3521, 3, 60, 235, 236);
INSERT INTO public.who_global_data VALUES (55527, 0, 13, 0, 0, 235, 150);
INSERT INTO public.who_global_data VALUES (55528, 0, 187, 0, 0, 235, 61);
INSERT INTO public.who_global_data VALUES (55529, 0, 18, 0, 0, 235, 7);
INSERT INTO public.who_global_data VALUES (55530, 4, 7108, 0, 326, 235, 169);
INSERT INTO public.who_global_data VALUES (55531, 52, 152819, 30, 29373, 235, 28);
INSERT INTO public.who_global_data VALUES (55532, 71, 1326, 0, 3, 235, 85);
INSERT INTO public.who_global_data VALUES (55533, 0, 60, 0, 0, 235, 211);
INSERT INTO public.who_global_data VALUES (55534, 570, 4033, 4, 27, 235, 60);
INSERT INTO public.who_global_data VALUES (55535, 0, 28, 0, 1, 235, 3);
INSERT INTO public.who_global_data VALUES (55536, 0, 879, 0, 14, 235, 11);
INSERT INTO public.who_global_data VALUES (55537, 378, 186839, 9, 8800, 235, 89);
INSERT INTO public.who_global_data VALUES (55538, 542, 11964, 3, 54, 235, 24);
INSERT INTO public.who_global_data VALUES (55539, 0, 176, 0, 0, 235, 162);
INSERT INTO public.who_global_data VALUES (55540, 13, 3134, 1, 184, 235, 100);
INSERT INTO public.who_global_data VALUES (55541, 0, 13, 0, 0, 235, 47);
INSERT INTO public.who_global_data VALUES (55542, 0, 23, 0, 0, 235, 29);
INSERT INTO public.who_global_data VALUES (55543, 0, 171, 0, 14, 235, 40);
INSERT INTO public.who_global_data VALUES (55544, 1, 178, 0, 5, 235, 222);
INSERT INTO public.who_global_data VALUES (55545, 354, 9845, 17, 384, 235, 132);
INSERT INTO public.who_global_data VALUES (55546, 0, 252, 0, 13, 235, 130);
INSERT INTO public.who_global_data VALUES (55547, 38, 4572, 1, 26, 235, 234);
INSERT INTO public.who_global_data VALUES (55548, 0, 1460, 0, 15, 235, 23);
INSERT INTO public.who_global_data VALUES (55549, 0, 159, 0, 12, 235, 192);
INSERT INTO public.who_global_data VALUES (55550, 144, 4309, 3, 73, 235, 69);
INSERT INTO public.who_global_data VALUES (55551, 0, 12, 0, 0, 235, 187);
INSERT INTO public.who_global_data VALUES (55552, 403, 8858, 2, 312, 235, 230);
INSERT INTO public.who_global_data VALUES (55553, 1, 4077, 2, 565, 235, 77);
INSERT INTO public.who_global_data VALUES (55554, 1, 1811, 0, 10, 235, 9);
INSERT INTO public.who_global_data VALUES (55555, 10667, 343091, 380, 9900, 235, 74);
INSERT INTO public.who_global_data VALUES (55556, 1017, 39294, 64, 2198, 235, 224);
INSERT INTO public.who_global_data VALUES (55557, 2449, 189876, 113, 8950, 235, 199);
INSERT INTO public.who_global_data VALUES (55558, 1106, 21315, 45, 652, 235, 190);
INSERT INTO public.who_global_data VALUES (55559, 18, 25321, 0, 1706, 235, 12);
INSERT INTO public.who_global_data VALUES (55560, 0, 336, 0, 24, 235, 104);
INSERT INTO public.who_global_data VALUES (55561, 136, 19142, 2, 305, 235, 153);
INSERT INTO public.who_global_data VALUES (55562, 301, 237290, 26, 34371, 235, 91);
INSERT INTO public.who_global_data VALUES (55563, 2, 617, 0, 10, 235, 215);
INSERT INTO public.who_global_data VALUES (55564, 85, 17587, 2, 927, 235, 84);
INSERT INTO public.who_global_data VALUES (55565, 0, 313, 0, 30, 235, 231);
INSERT INTO public.who_global_data VALUES (55566, 18, 921, 0, 9, 235, 196);
INSERT INTO public.who_global_data VALUES (55567, 350, 15542, 7, 88, 235, 105);
INSERT INTO public.who_global_data VALUES (55568, 133, 3727, 1, 104, 235, 122);
INSERT INTO public.who_global_data VALUES (55569, 0, 0, 0, 0, 235, 159);
INSERT INTO public.who_global_data VALUES (55570, 129, 1572, 0, 23, 235, 75);
INSERT INTO public.who_global_data VALUES (55571, 511, 36431, 2, 298, 235, 27);
INSERT INTO public.who_global_data VALUES (55572, 100, 2472, 2, 29, 235, 54);
INSERT INTO public.who_global_data VALUES (55573, 0, 19, 0, 0, 235, 226);
INSERT INTO public.who_global_data VALUES (55574, 0, 1097, 0, 28, 235, 79);
INSERT INTO public.who_global_data VALUES (55575, 18, 1464, 0, 32, 235, 56);
INSERT INTO public.who_global_data VALUES (55576, 0, 4, 0, 0, 235, 117);
INSERT INTO public.who_global_data VALUES (55577, 40, 498, 1, 33, 235, 152);
INSERT INTO public.who_global_data VALUES (55578, 49, 467, 2, 10, 235, 16);
INSERT INTO public.who_global_data VALUES (55579, 0, 83, 0, 1, 235, 10);
INSERT INTO public.who_global_data VALUES (55580, 3, 1771, 0, 76, 235, 201);
INSERT INTO public.who_global_data VALUES (55581, 2, 4072, 0, 110, 235, 174);
INSERT INTO public.who_global_data VALUES (55582, 18, 1290, 0, 10, 235, 119);
INSERT INTO public.who_global_data VALUES (55583, 9, 556, 0, 6, 235, 168);
INSERT INTO public.who_global_data VALUES (55584, 41, 8494, 0, 121, 235, 99);
INSERT INTO public.who_global_data VALUES (55585, 30, 2065, 0, 8, 235, 171);
INSERT INTO public.who_global_data VALUES (55586, 51, 1860, 0, 104, 235, 87);
INSERT INTO public.who_global_data VALUES (55587, 6, 655, 0, 9, 235, 123);
INSERT INTO public.who_global_data VALUES (55588, 0, 0, 0, 0, 235, 151);
INSERT INTO public.who_global_data VALUES (55589, 0, 202, 0, 14, 235, 213);
INSERT INTO public.who_global_data VALUES (55590, 0, 1783, 0, 87, 235, 118);
INSERT INTO public.who_global_data VALUES (55591, 0, 337, 0, 10, 235, 134);
INSERT INTO public.who_global_data VALUES (55592, 28, 2310, -1, 28, 235, 65);
INSERT INTO public.who_global_data VALUES (55593, 4147, 146837, 269, 17141, 235, 102);
INSERT INTO public.who_global_data VALUES (55594, 0, 0, 0, 0, 235, 223);
INSERT INTO public.who_global_data VALUES (55595, 0, 70, 0, 1, 235, 4);
INSERT INTO public.who_global_data VALUES (55596, 0, 197, 0, 0, 235, 146);
INSERT INTO public.who_global_data VALUES (55597, 0, 326, 0, 9, 235, 31);
INSERT INTO public.who_global_data VALUES (55598, 0, 11, 0, 1, 235, 127);
INSERT INTO public.who_global_data VALUES (55599, 92, 8885, 0, 212, 235, 22);
INSERT INTO public.who_global_data VALUES (55600, 26, 609, 1, 3, 235, 115);
INSERT INTO public.who_global_data VALUES (55601, 0, 262, 0, 6, 235, 106);
INSERT INTO public.who_global_data VALUES (55602, 0, 32, 0, 0, 235, 90);
INSERT INTO public.who_global_data VALUES (55603, 0, 0, 0, 0, 235, 70);
INSERT INTO public.who_global_data VALUES (55604, 451, 6211, 0, 19, 235, 46);
INSERT INTO public.who_global_data VALUES (55605, 159, 48697, 7, 6038, 235, 139);
INSERT INTO public.who_global_data VALUES (55606, 0, 21, 0, 0, 235, 42);
INSERT INTO public.who_global_data VALUES (55607, 2, 1156, 0, 22, 235, 80);
INSERT INTO public.who_global_data VALUES (55608, 0, 1655, 0, 55, 235, 203);
INSERT INTO public.who_global_data VALUES (55609, 0, 980, 0, 66, 235, 136);
INSERT INTO public.who_global_data VALUES (55610, 573, 16658, 4, 424, 235, 63);
INSERT INTO public.who_global_data VALUES (55611, 0, 0, 0, 0, 235, 17);
INSERT INTO public.who_global_data VALUES (55612, 0, 30, 0, 2, 235, 172);
INSERT INTO public.who_global_data VALUES (55613, 100, 4157, 5, 193, 235, 109);
INSERT INTO public.who_global_data VALUES (55614, 25, 8631, 0, 242, 235, 200);
INSERT INTO public.who_global_data VALUES (55615, 13, 689, 0, 5, 235, 93);
INSERT INTO public.who_global_data VALUES (55616, 1043, 24524, 4, 108, 235, 5);
INSERT INTO public.who_global_data VALUES (55617, 0, 741, 0, 13, 235, 214);
INSERT INTO public.who_global_data VALUES (55618, 4443, 148921, 110, 2839, 235, 204);
INSERT INTO public.who_global_data VALUES (55619, 0, 0, 0, 0, 235, 198);
INSERT INTO public.who_global_data VALUES (55620, 627, 20686, 8, 437, 235, 173);
INSERT INTO public.who_global_data VALUES (55621, 0, 8, 0, 0, 235, 229);
INSERT INTO public.who_global_data VALUES (55622, 7, 1296, 1, 12, 235, 76);
INSERT INTO public.who_global_data VALUES (55623, 4604, 229736, 190, 6688, 235, 138);
INSERT INTO public.who_global_data VALUES (55624, 490, 26420, 10, 1098, 235, 98);
INSERT INTO public.who_global_data VALUES (55625, 0, 0, 0, 0, 235, 103);
INSERT INTO public.who_global_data VALUES (55626, 396, 29788, 9, 1256, 235, 225);
INSERT INTO public.who_global_data VALUES (55627, 346, 37036, 3, 1520, 235, 131);
INSERT INTO public.who_global_data VALUES (55628, 79, 5890, 0, 147, 235, 235);
INSERT INTO public.who_global_data VALUES (55629, 1274, 80876, 3, 76, 235, 137);
INSERT INTO public.who_global_data VALUES (55630, 34, 12155, 1, 278, 235, 81);
INSERT INTO public.who_global_data VALUES (55631, 139, 11879, 11, 417, 235, 182);
INSERT INTO public.who_global_data VALUES (55632, 1, 496, 0, 1, 235, 145);
INSERT INTO public.who_global_data VALUES (55633, 166, 22165, 17, 1427, 235, 26);
INSERT INTO public.who_global_data VALUES (55634, 8248, 545458, 193, 7284, 235, 170);
INSERT INTO public.who_global_data VALUES (55635, 30, 612, 0, 2, 235, 191);
INSERT INTO public.who_global_data VALUES (55636, 0, 3, 0, 0, 235, 221);
INSERT INTO public.who_global_data VALUES (55637, 0, 6, 0, 0, 235, 64);
INSERT INTO public.who_global_data VALUES (55638, 0, 0, 0, 0, 235, 116);
INSERT INTO public.who_global_data VALUES (55639, 0, 15, 0, 0, 235, 128);
INSERT INTO public.who_global_data VALUES (55640, 0, 19, 0, 0, 235, 6);
INSERT INTO public.who_global_data VALUES (55641, 0, 41, 0, 3, 235, 227);
INSERT INTO public.who_global_data VALUES (55642, 0, 1, 0, 0, 235, 68);
INSERT INTO public.who_global_data VALUES (55643, 0, 27, 0, 0, 235, 184);
INSERT INTO public.who_global_data VALUES (55644, 0, 0, 0, 0, 235, 82);
INSERT INTO public.who_global_data VALUES (55645, 0, 695, 0, 42, 235, 149);
INSERT INTO public.who_global_data VALUES (55646, 0, 388, 0, 10, 235, 197);
INSERT INTO public.who_global_data VALUES (55647, 4507, 132048, 39, 1011, 235, 78);
INSERT INTO public.who_global_data VALUES (55648, 0, 5090, 0, 60, 235, 233);
INSERT INTO public.who_global_data VALUES (55649, 57, 12367, 1, 255, 235, 133);
INSERT INTO public.who_global_data VALUES (55650, 0, 11, 0, 0, 235, 35);
INSERT INTO public.who_global_data VALUES (55651, 7, 1176, 0, 51, 235, 114);
INSERT INTO public.who_global_data VALUES (55652, 214, 40818, 0, 26, 235, 237);
INSERT INTO public.who_global_data VALUES (55653, 0, 2, 0, 0, 235, 55);
INSERT INTO public.who_global_data VALUES (55654, 0, 77, 0, 15, 235, 176);
INSERT INTO public.who_global_data VALUES (55655, 4, 1552, 0, 28, 235, 202);
INSERT INTO public.who_global_data VALUES (55656, 3, 1499, 0, 113, 235, 155);
INSERT INTO public.who_global_data VALUES (55657, 0, 0, 0, 0, 235, 32);
INSERT INTO public.who_global_data VALUES (55658, 39, 2642, 0, 88, 235, 220);
INSERT INTO public.who_global_data VALUES (55659, 3495, 73533, 88, 1568, 235, 30);
INSERT INTO public.who_global_data VALUES (55660, 62, 1755, 3, 30, 235, 147);
INSERT INTO public.who_global_data VALUES (55661, 96, 252994, 18, 29552, 235, 208);
INSERT INTO public.who_global_data VALUES (55662, 16, 1905, 0, 11, 235, 45);
INSERT INTO public.who_global_data VALUES (55663, 215, 7435, 9, 468, 235, 110);
INSERT INTO public.who_global_data VALUES (55664, 21, 208, 1, 4, 235, 88);
INSERT INTO public.who_global_data VALUES (55665, 418, 51802, 27, 5140, 235, 51);
INSERT INTO public.who_global_data VALUES (55666, 32, 31113, 0, 1719, 235, 209);
INSERT INTO public.who_global_data VALUES (55667, 0, 177, 0, 6, 235, 205);
INSERT INTO public.who_global_data VALUES (55668, 62, 5097, 0, 50, 235, 18);
INSERT INTO public.who_global_data VALUES (55669, 0, 3135, 0, 58, 235, 72);
INSERT INTO public.who_global_data VALUES (55670, 822, 272001, 29, 39395, 235, 44);
INSERT INTO public.who_global_data VALUES (55671, 0, 24, 0, 0, 235, 15);
INSERT INTO public.who_global_data VALUES (55672, 1, 531, 0, 13, 235, 25);
INSERT INTO public.who_global_data VALUES (55673, 0, 0, 0, 0, 235, 179);
INSERT INTO public.who_global_data VALUES (55674, 0, 0, 0, 0, 235, 34);
INSERT INTO public.who_global_data VALUES (55675, 6, 123, 0, 8, 235, 207);
INSERT INTO public.who_global_data VALUES (55676, 15, 1125, 0, 49, 235, 166);
INSERT INTO public.who_global_data VALUES (55677, 1592, 179831, 18, 4825, 235, 126);
INSERT INTO public.who_global_data VALUES (55678, 0, 0, 0, 0, 235, 97);
INSERT INTO public.who_global_data VALUES (55679, 0, 12, 0, 1, 235, 36);
INSERT INTO public.who_global_data VALUES (55680, 0, 0, 0, 0, 235, 125);
INSERT INTO public.who_global_data VALUES (55681, 0, 823, 0, 0, 235, 124);
INSERT INTO public.who_global_data VALUES (55682, 666, 32476, 12, 913, 235, 185);
INSERT INTO public.who_global_data VALUES (55683, 342, 42636, 2, 291, 235, 194);
INSERT INTO public.who_global_data VALUES (55684, 0, 509, 0, 21, 235, 144);
INSERT INTO public.who_global_data VALUES (55685, 21754, 2079592, 372, 115484, 235, 19);
INSERT INTO public.who_global_data VALUES (55686, 0, 72, 0, 6, 235, 217);
INSERT INTO public.who_global_data VALUES (55687, 1, 848, 0, 23, 235, 148);
INSERT INTO public.who_global_data VALUES (55688, 190, 5293, 0, 19, 235, 86);
INSERT INTO public.who_global_data VALUES (55689, 0, 0, 0, 0, 235, 13);
INSERT INTO public.who_global_data VALUES (55690, 74, 2978, 1, 25, 235, 157);
INSERT INTO public.who_global_data VALUES (55691, 0, 334, 0, 0, 235, 8);
INSERT INTO public.who_global_data VALUES (55692, 0, 0, 0, 0, 235, 73);
INSERT INTO public.who_global_data VALUES (55693, 116, 844, 44, 208, 235, 101);
INSERT INTO public.who_global_data VALUES (55694, 24, 1382, 0, 11, 235, 165);
INSERT INTO public.who_global_data VALUES (55695, 4, 387, 0, 4, 235, 14);
INSERT INTO public.who_global_data VALUES (55696, 761, 25613, 5, 480, 236, 193);
INSERT INTO public.who_global_data VALUES (55697, 69, 1590, 0, 36, 236, 113);
INSERT INTO public.who_global_data VALUES (55698, 109, 10919, 7, 767, 236, 143);
INSERT INTO public.who_global_data VALUES (55699, 0, 0, 0, 0, 236, 219);
INSERT INTO public.who_global_data VALUES (55700, 0, 853, 0, 51, 236, 186);
INSERT INTO public.who_global_data VALUES (55701, 2, 140, 0, 6, 236, 52);
INSERT INTO public.who_global_data VALUES (55702, 0, 3, 0, 0, 236, 180);
INSERT INTO public.who_global_data VALUES (55703, 0, 26, 0, 3, 236, 167);
INSERT INTO public.who_global_data VALUES (55704, 1531, 30295, 17, 819, 236, 154);
INSERT INTO public.who_global_data VALUES (55705, 397, 16377, 16, 280, 236, 94);
INSERT INTO public.who_global_data VALUES (55706, 0, 101, 0, 3, 236, 66);
INSERT INTO public.who_global_data VALUES (55707, 18, 7320, 0, 102, 236, 58);
INSERT INTO public.who_global_data VALUES (55708, 24, 17038, 0, 677, 236, 163);
INSERT INTO public.who_global_data VALUES (55709, 387, 9957, 4, 119, 236, 37);
INSERT INTO public.who_global_data VALUES (55710, 0, 103, 0, 11, 236, 142);
INSERT INTO public.who_global_data VALUES (55711, 317, 18544, 4, 43, 236, 83);
INSERT INTO public.who_global_data VALUES (55712, 3141, 87520, 32, 1171, 236, 228);
INSERT INTO public.who_global_data VALUES (55713, 0, 96, 0, 7, 236, 188);
INSERT INTO public.who_global_data VALUES (55714, 732, 53973, 5, 308, 236, 62);
INSERT INTO public.who_global_data VALUES (55715, 22, 60582, 3, 9535, 236, 160);
INSERT INTO public.who_global_data VALUES (55716, 1, 21, 0, 2, 236, 50);
INSERT INTO public.who_global_data VALUES (55717, 58, 470, 1, 7, 236, 33);
INSERT INTO public.who_global_data VALUES (55718, 2, 144, 0, 9, 236, 183);
INSERT INTO public.who_global_data VALUES (55719, 0, 66, 0, 0, 236, 92);
INSERT INTO public.who_global_data VALUES (55720, 913, 17842, 26, 585, 236, 158);
INSERT INTO public.who_global_data VALUES (55721, 0, 2, 0, 0, 236, 67);
INSERT INTO public.who_global_data VALUES (55722, 109, 3001, 1, 163, 236, 57);
INSERT INTO public.who_global_data VALUES (55723, 0, 60, 0, 1, 236, 38);
INSERT INTO public.who_global_data VALUES (55724, 21704, 850514, 892, 42720, 236, 141);
INSERT INTO public.who_global_data VALUES (55725, 0, 8, 0, 1, 236, 178);
INSERT INTO public.who_global_data VALUES (55726, 0, 141, 0, 2, 236, 108);
INSERT INTO public.who_global_data VALUES (55727, 24, 3290, 2, 174, 236, 39);
INSERT INTO public.who_global_data VALUES (55728, 2, 894, 0, 53, 236, 2);
INSERT INTO public.who_global_data VALUES (55729, 0, 94, 0, 1, 236, 195);
INSERT INTO public.who_global_data VALUES (55730, 24, 750, 0, 6, 236, 107);
INSERT INTO public.who_global_data VALUES (55731, 2, 128, 0, 0, 236, 161);
INSERT INTO public.who_global_data VALUES (55732, 829, 9572, 5, 275, 236, 212);
INSERT INTO public.who_global_data VALUES (55733, 467, 98410, 58, 8107, 236, 181);
INSERT INTO public.who_global_data VALUES (55734, 0, 187, 0, 1, 236, 53);
INSERT INTO public.who_global_data VALUES (55735, 165, 2222, 0, 7, 236, 164);
INSERT INTO public.who_global_data VALUES (55736, 2, 850, 1, 73, 236, 140);
INSERT INTO public.who_global_data VALUES (55737, 6938, 174293, 222, 3323, 236, 20);
INSERT INTO public.who_global_data VALUES (55738, 49, 84778, 0, 4645, 236, 112);
INSERT INTO public.who_global_data VALUES (55739, 1888, 48746, 47, 1592, 236, 111);
INSERT INTO public.who_global_data VALUES (55740, 0, 176, 0, 2, 236, 71);
INSERT INTO public.who_global_data VALUES (55741, 0, 779, 0, 25, 236, 218);
INSERT INTO public.who_global_data VALUES (55742, 0, 0, 0, 0, 236, 43);
INSERT INTO public.who_global_data VALUES (55743, 50, 1662, 0, 12, 236, 49);
INSERT INTO public.who_global_data VALUES (55744, 236, 5084, 0, 45, 236, 1);
INSERT INTO public.who_global_data VALUES (55745, 1, 2252, 0, 107, 236, 48);
INSERT INTO public.who_global_data VALUES (55746, 10, 2248, 0, 84, 236, 232);
INSERT INTO public.who_global_data VALUES (55747, 0, 22, 0, 1, 236, 175);
INSERT INTO public.who_global_data VALUES (55748, 3, 983, 0, 18, 236, 21);
INSERT INTO public.who_global_data VALUES (55749, 33, 10024, 0, 329, 236, 156);
INSERT INTO public.who_global_data VALUES (55750, 0, 0, 0, 0, 236, 95);
INSERT INTO public.who_global_data VALUES (55751, 54, 4777, 1, 106, 236, 177);
INSERT INTO public.who_global_data VALUES (55752, 54, 12193, 0, 597, 236, 210);
INSERT INTO public.who_global_data VALUES (55753, 16, 4465, 2, 43, 236, 120);
INSERT INTO public.who_global_data VALUES (55754, 0, 18, 0, 0, 236, 135);
INSERT INTO public.who_global_data VALUES (55755, 390, 22962, 15, 592, 236, 206);
INSERT INTO public.who_global_data VALUES (55756, 395, 46751, 22, 3896, 236, 189);
INSERT INTO public.who_global_data VALUES (55757, 1618, 44598, 91, 1575, 236, 129);
INSERT INTO public.who_global_data VALUES (55758, 117, 3720, 0, 72, 236, 121);
INSERT INTO public.who_global_data VALUES (55759, 0, 1043, 0, 12, 236, 59);
INSERT INTO public.who_global_data VALUES (55760, 31, 96, 0, 0, 236, 96);
INSERT INTO public.who_global_data VALUES (55761, 0, 1973, 0, 63, 236, 41);
INSERT INTO public.who_global_data VALUES (55762, 4, 490, 1, 4, 236, 216);
INSERT INTO public.who_global_data VALUES (55763, 179, 3345, 2, 57, 236, 236);
INSERT INTO public.who_global_data VALUES (55764, 0, 13, 0, 0, 236, 150);
INSERT INTO public.who_global_data VALUES (55765, 0, 187, 0, 0, 236, 61);
INSERT INTO public.who_global_data VALUES (55766, 0, 18, 0, 0, 236, 7);
INSERT INTO public.who_global_data VALUES (55767, 17, 7104, 1, 326, 236, 169);
INSERT INTO public.who_global_data VALUES (55768, 307, 152767, 8, 29343, 236, 28);
INSERT INTO public.who_global_data VALUES (55769, 94, 1255, 1, 3, 236, 85);
INSERT INTO public.who_global_data VALUES (55770, 0, 60, 0, 0, 236, 211);
INSERT INTO public.who_global_data VALUES (55771, 0, 3463, 0, 23, 236, 60);
INSERT INTO public.who_global_data VALUES (55772, 0, 28, 0, 1, 236, 3);
INSERT INTO public.who_global_data VALUES (55773, 15, 879, 0, 14, 236, 11);
INSERT INTO public.who_global_data VALUES (55774, 192, 186461, 4, 8791, 236, 89);
INSERT INTO public.who_global_data VALUES (55775, 304, 11422, 3, 51, 236, 24);
INSERT INTO public.who_global_data VALUES (55776, 0, 176, 0, 0, 236, 162);
INSERT INTO public.who_global_data VALUES (55777, 9, 3121, 0, 183, 236, 100);
INSERT INTO public.who_global_data VALUES (55778, 0, 13, 0, 0, 236, 47);
INSERT INTO public.who_global_data VALUES (55779, 0, 23, 0, 0, 236, 29);
INSERT INTO public.who_global_data VALUES (55780, 0, 171, 0, 14, 236, 40);
INSERT INTO public.who_global_data VALUES (55781, 0, 177, 0, 5, 236, 222);
INSERT INTO public.who_global_data VALUES (55782, 509, 9491, 16, 367, 236, 132);
INSERT INTO public.who_global_data VALUES (55783, 0, 252, 0, 13, 236, 130);
INSERT INTO public.who_global_data VALUES (55784, 50, 4534, 0, 25, 236, 234);
INSERT INTO public.who_global_data VALUES (55785, 0, 1460, 0, 15, 236, 23);
INSERT INTO public.who_global_data VALUES (55786, 0, 159, 0, 12, 236, 192);
INSERT INTO public.who_global_data VALUES (55787, 224, 4165, 6, 70, 236, 69);
INSERT INTO public.who_global_data VALUES (55788, 0, 12, 0, 0, 236, 187);
INSERT INTO public.who_global_data VALUES (55789, 323, 8455, 4, 310, 236, 230);
INSERT INTO public.who_global_data VALUES (55790, 12, 4076, 4, 563, 236, 77);
INSERT INTO public.who_global_data VALUES (55791, 0, 1810, 0, 10, 236, 9);
INSERT INTO public.who_global_data VALUES (55792, 11502, 332424, 325, 9520, 236, 74);
INSERT INTO public.who_global_data VALUES (55793, 857, 38277, 43, 2134, 236, 224);
INSERT INTO public.who_global_data VALUES (55794, 2472, 187427, 107, 8837, 236, 199);
INSERT INTO public.who_global_data VALUES (55795, 1259, 20209, 58, 607, 236, 190);
INSERT INTO public.who_global_data VALUES (55796, 8, 25303, 1, 1706, 236, 12);
INSERT INTO public.who_global_data VALUES (55797, 0, 336, 0, 24, 236, 104);
INSERT INTO public.who_global_data VALUES (55798, 149, 19006, 1, 303, 236, 153);
INSERT INTO public.who_global_data VALUES (55799, 338, 236989, 44, 34345, 236, 91);
INSERT INTO public.who_global_data VALUES (55800, 1, 615, 0, 10, 236, 215);
INSERT INTO public.who_global_data VALUES (55801, 73, 17502, 0, 925, 236, 84);
INSERT INTO public.who_global_data VALUES (55802, 0, 313, 0, 30, 236, 231);
INSERT INTO public.who_global_data VALUES (55803, 8, 903, 0, 9, 236, 196);
INSERT INTO public.who_global_data VALUES (55804, 383, 15192, 4, 81, 236, 105);
INSERT INTO public.who_global_data VALUES (55805, 137, 3594, 3, 103, 236, 122);
INSERT INTO public.who_global_data VALUES (55806, 0, 0, 0, 0, 236, 159);
INSERT INTO public.who_global_data VALUES (55807, 6, 1443, 0, 23, 236, 75);
INSERT INTO public.who_global_data VALUES (55808, 454, 35920, 7, 296, 236, 27);
INSERT INTO public.who_global_data VALUES (55809, 87, 2372, 0, 27, 236, 54);
INSERT INTO public.who_global_data VALUES (55810, 0, 19, 0, 0, 236, 226);
INSERT INTO public.who_global_data VALUES (55811, 0, 1097, 0, 28, 236, 79);
INSERT INTO public.who_global_data VALUES (55812, 4, 1446, 0, 32, 236, 56);
INSERT INTO public.who_global_data VALUES (55813, 0, 4, 0, 0, 236, 117);
INSERT INTO public.who_global_data VALUES (55814, 12, 458, 0, 32, 236, 152);
INSERT INTO public.who_global_data VALUES (55815, 0, 418, 0, 8, 236, 16);
INSERT INTO public.who_global_data VALUES (55816, 0, 83, 0, 1, 236, 10);
INSERT INTO public.who_global_data VALUES (55817, 5, 1768, 1, 76, 236, 201);
INSERT INTO public.who_global_data VALUES (55818, 7, 4070, 0, 110, 236, 174);
INSERT INTO public.who_global_data VALUES (55819, 20, 1272, 0, 10, 236, 119);
INSERT INTO public.who_global_data VALUES (55820, 18, 547, 1, 6, 236, 168);
INSERT INTO public.who_global_data VALUES (55821, 8, 8453, 1, 121, 236, 99);
INSERT INTO public.who_global_data VALUES (55822, 22, 2035, 0, 8, 236, 171);
INSERT INTO public.who_global_data VALUES (55823, 33, 1809, 0, 104, 236, 87);
INSERT INTO public.who_global_data VALUES (55824, 2, 649, 0, 9, 236, 123);
INSERT INTO public.who_global_data VALUES (55825, 0, 0, 0, 0, 236, 151);
INSERT INTO public.who_global_data VALUES (55826, 0, 202, 0, 14, 236, 213);
INSERT INTO public.who_global_data VALUES (55827, 210, 1783, 6, 87, 236, 118);
INSERT INTO public.who_global_data VALUES (55828, 0, 337, 0, 10, 236, 134);
INSERT INTO public.who_global_data VALUES (55829, 0, 2282, 0, 29, 236, 65);
INSERT INTO public.who_global_data VALUES (55830, 3494, 142690, 424, 16872, 236, 102);
INSERT INTO public.who_global_data VALUES (55831, 0, 0, 0, 0, 236, 223);
INSERT INTO public.who_global_data VALUES (55832, 0, 70, 0, 1, 236, 4);
INSERT INTO public.who_global_data VALUES (55833, 0, 197, 0, 0, 236, 146);
INSERT INTO public.who_global_data VALUES (55834, 1, 326, 0, 9, 236, 31);
INSERT INTO public.who_global_data VALUES (55835, 0, 11, 0, 1, 236, 127);
INSERT INTO public.who_global_data VALUES (55836, 101, 8793, 0, 212, 236, 22);
INSERT INTO public.who_global_data VALUES (55837, 30, 583, 0, 2, 236, 115);
INSERT INTO public.who_global_data VALUES (55838, 1, 262, 0, 6, 236, 106);
INSERT INTO public.who_global_data VALUES (55839, 0, 32, 0, 0, 236, 90);
INSERT INTO public.who_global_data VALUES (55840, 0, 0, 0, 0, 236, 70);
INSERT INTO public.who_global_data VALUES (55841, 425, 5760, 1, 19, 236, 46);
INSERT INTO public.who_global_data VALUES (55842, 144, 48538, 1, 6031, 236, 139);
INSERT INTO public.who_global_data VALUES (55843, 0, 21, 0, 0, 236, 42);
INSERT INTO public.who_global_data VALUES (55844, 0, 1154, 0, 22, 236, 80);
INSERT INTO public.who_global_data VALUES (55845, 0, 1655, 0, 55, 236, 203);
INSERT INTO public.who_global_data VALUES (55846, 2, 980, 1, 66, 236, 136);
INSERT INTO public.who_global_data VALUES (55847, 904, 16085, 21, 420, 236, 63);
INSERT INTO public.who_global_data VALUES (55848, 0, 0, 0, 0, 236, 17);
INSERT INTO public.who_global_data VALUES (55849, 0, 30, 0, 2, 236, 172);
INSERT INTO public.who_global_data VALUES (55850, 155, 4057, 9, 188, 236, 109);
INSERT INTO public.who_global_data VALUES (55851, 0, 8606, 0, 242, 236, 200);
INSERT INTO public.who_global_data VALUES (55852, 3, 676, 0, 5, 236, 93);
INSERT INTO public.who_global_data VALUES (55853, 1404, 23481, 5, 104, 236, 5);
INSERT INTO public.who_global_data VALUES (55854, 0, 741, 0, 13, 236, 214);
INSERT INTO public.who_global_data VALUES (55855, 5248, 144478, 97, 2729, 236, 204);
INSERT INTO public.who_global_data VALUES (55856, 0, 0, 0, 0, 236, 198);
INSERT INTO public.who_global_data VALUES (55857, 848, 20059, 8, 429, 236, 173);
INSERT INTO public.who_global_data VALUES (55858, 0, 8, 0, 0, 236, 229);
INSERT INTO public.who_global_data VALUES (55859, 28, 1289, 0, 11, 236, 76);
INSERT INTO public.who_global_data VALUES (55860, 4383, 225132, 190, 6498, 236, 138);
INSERT INTO public.who_global_data VALUES (55861, 538, 25930, 14, 1088, 236, 98);
INSERT INTO public.who_global_data VALUES (55862, 0, 0, 0, 0, 236, 103);
INSERT INTO public.who_global_data VALUES (55863, 375, 29392, 10, 1247, 236, 225);
INSERT INTO public.who_global_data VALUES (55864, 227, 36690, 5, 1517, 236, 131);
INSERT INTO public.who_global_data VALUES (55865, 121, 5811, 1, 147, 236, 235);
INSERT INTO public.who_global_data VALUES (55866, 1186, 79602, 3, 73, 236, 137);
INSERT INTO public.who_global_data VALUES (55867, 37, 12121, 0, 277, 236, 81);
INSERT INTO public.who_global_data VALUES (55868, 281, 11740, 7, 406, 236, 182);
INSERT INTO public.who_global_data VALUES (55869, 6, 495, 0, 1, 236, 145);
INSERT INTO public.who_global_data VALUES (55870, 320, 21999, 19, 1410, 236, 26);
INSERT INTO public.who_global_data VALUES (55871, 8246, 537210, 143, 7091, 236, 170);
INSERT INTO public.who_global_data VALUES (55872, 41, 582, 0, 2, 236, 191);
INSERT INTO public.who_global_data VALUES (55873, 0, 3, 0, 0, 236, 221);
INSERT INTO public.who_global_data VALUES (55874, 0, 6, 0, 0, 236, 64);
INSERT INTO public.who_global_data VALUES (55875, 0, 0, 0, 0, 236, 116);
INSERT INTO public.who_global_data VALUES (55876, 0, 15, 0, 0, 236, 128);
INSERT INTO public.who_global_data VALUES (55877, 0, 19, 0, 0, 236, 6);
INSERT INTO public.who_global_data VALUES (55878, 0, 41, 0, 3, 236, 227);
INSERT INTO public.who_global_data VALUES (55879, 0, 1, 0, 0, 236, 68);
INSERT INTO public.who_global_data VALUES (55880, 0, 27, 0, 0, 236, 184);
INSERT INTO public.who_global_data VALUES (55881, 0, 0, 0, 0, 236, 82);
INSERT INTO public.who_global_data VALUES (55882, 0, 695, 0, 42, 236, 149);
INSERT INTO public.who_global_data VALUES (55883, 0, 388, 0, 10, 236, 197);
INSERT INTO public.who_global_data VALUES (55884, 4233, 127541, 40, 972, 236, 78);
INSERT INTO public.who_global_data VALUES (55885, 94, 5090, 0, 60, 236, 233);
INSERT INTO public.who_global_data VALUES (55886, 59, 12310, 1, 254, 236, 133);
INSERT INTO public.who_global_data VALUES (55887, 0, 11, 0, 0, 236, 35);
INSERT INTO public.who_global_data VALUES (55888, 37, 1169, 0, 51, 236, 114);
INSERT INTO public.who_global_data VALUES (55889, 407, 40604, 0, 26, 236, 237);
INSERT INTO public.who_global_data VALUES (55890, 0, 2, 0, 0, 236, 55);
INSERT INTO public.who_global_data VALUES (55891, 0, 77, 0, 15, 236, 176);
INSERT INTO public.who_global_data VALUES (55892, 3, 1548, 0, 28, 236, 202);
INSERT INTO public.who_global_data VALUES (55893, 1, 1496, 0, 113, 236, 155);
INSERT INTO public.who_global_data VALUES (55894, 0, 0, 0, 0, 236, 32);
INSERT INTO public.who_global_data VALUES (55895, 24, 2603, 1, 88, 236, 220);
INSERT INTO public.who_global_data VALUES (55896, 4302, 70038, 57, 1480, 236, 30);
INSERT INTO public.who_global_data VALUES (55897, 9, 1693, 2, 27, 236, 147);
INSERT INTO public.who_global_data VALUES (55898, 132, 252898, 22, 29534, 236, 208);
INSERT INTO public.who_global_data VALUES (55899, 5, 1889, 0, 11, 236, 45);
INSERT INTO public.who_global_data VALUES (55900, 213, 7220, 12, 459, 236, 110);
INSERT INTO public.who_global_data VALUES (55901, 0, 187, 0, 3, 236, 88);
INSERT INTO public.who_global_data VALUES (55902, 1032, 51384, 33, 5113, 236, 51);
INSERT INTO public.who_global_data VALUES (55903, 12, 31081, 0, 1719, 236, 209);
INSERT INTO public.who_global_data VALUES (55904, 7, 177, 0, 6, 236, 205);
INSERT INTO public.who_global_data VALUES (55905, 64, 5035, 0, 50, 236, 18);
INSERT INTO public.who_global_data VALUES (55906, 0, 3135, 0, 58, 236, 72);
INSERT INTO public.who_global_data VALUES (55907, 890, 271179, 27, 39366, 236, 44);
INSERT INTO public.who_global_data VALUES (55908, 0, 24, 0, 0, 236, 15);
INSERT INTO public.who_global_data VALUES (55909, 5, 530, 0, 13, 236, 25);
INSERT INTO public.who_global_data VALUES (55910, 0, 0, 0, 0, 236, 179);
INSERT INTO public.who_global_data VALUES (55911, 0, 0, 0, 0, 236, 34);
INSERT INTO public.who_global_data VALUES (55912, 0, 117, 0, 8, 236, 207);
INSERT INTO public.who_global_data VALUES (55913, 14, 1110, 0, 49, 236, 166);
INSERT INTO public.who_global_data VALUES (55914, 1562, 178239, 15, 4807, 236, 126);
INSERT INTO public.who_global_data VALUES (55915, 0, 0, 0, 0, 236, 97);
INSERT INTO public.who_global_data VALUES (55916, 0, 12, 0, 1, 236, 36);
INSERT INTO public.who_global_data VALUES (55917, 0, 0, 0, 0, 236, 125);
INSERT INTO public.who_global_data VALUES (55918, 0, 823, 0, 0, 236, 124);
INSERT INTO public.who_global_data VALUES (55919, 656, 31810, 12, 901, 236, 185);
INSERT INTO public.who_global_data VALUES (55920, 304, 42294, 1, 289, 236, 194);
INSERT INTO public.who_global_data VALUES (55921, 0, 509, 0, 21, 236, 144);
INSERT INTO public.who_global_data VALUES (55922, 25314, 2057838, 646, 115112, 236, 19);
INSERT INTO public.who_global_data VALUES (55923, 0, 72, 0, 6, 236, 217);
INSERT INTO public.who_global_data VALUES (55924, 0, 847, 0, 23, 236, 148);
INSERT INTO public.who_global_data VALUES (55925, 109, 5103, 0, 19, 236, 86);
INSERT INTO public.who_global_data VALUES (55926, 0, 0, 0, 0, 236, 13);
INSERT INTO public.who_global_data VALUES (55927, 25, 2904, 1, 24, 236, 157);
INSERT INTO public.who_global_data VALUES (55928, 0, 334, 0, 0, 236, 8);
INSERT INTO public.who_global_data VALUES (55929, 0, 0, 0, 0, 236, 73);
INSERT INTO public.who_global_data VALUES (55930, 23, 728, 4, 164, 236, 101);
INSERT INTO public.who_global_data VALUES (55931, 1, 1358, 1, 11, 236, 165);
INSERT INTO public.who_global_data VALUES (55932, 27, 383, 0, 4, 236, 14);
INSERT INTO public.who_global_data VALUES (55933, 664, 24852, 20, 475, 237, 193);
INSERT INTO public.who_global_data VALUES (55934, 57, 1521, 0, 36, 237, 113);
INSERT INTO public.who_global_data VALUES (55935, 112, 10810, 9, 760, 237, 143);
INSERT INTO public.who_global_data VALUES (55936, 0, 0, 0, 0, 237, 219);
INSERT INTO public.who_global_data VALUES (55937, 0, 853, 0, 51, 237, 186);
INSERT INTO public.who_global_data VALUES (55938, 8, 138, 1, 6, 237, 52);
INSERT INTO public.who_global_data VALUES (55939, 0, 3, 0, 0, 237, 180);
INSERT INTO public.who_global_data VALUES (55940, 1, 26, 0, 3, 237, 167);
INSERT INTO public.who_global_data VALUES (55941, 1391, 28764, 30, 802, 237, 154);
INSERT INTO public.who_global_data VALUES (55942, 723, 15980, 6, 264, 237, 94);
INSERT INTO public.who_global_data VALUES (55943, 0, 101, 0, 3, 237, 66);
INSERT INTO public.who_global_data VALUES (55944, 12, 7302, 0, 102, 237, 58);
INSERT INTO public.who_global_data VALUES (55945, 20, 17014, 2, 677, 237, 163);
INSERT INTO public.who_global_data VALUES (55946, 352, 9570, 2, 115, 237, 37);
INSERT INTO public.who_global_data VALUES (55947, 0, 103, 0, 11, 237, 142);
INSERT INTO public.who_global_data VALUES (55948, 514, 18227, 3, 39, 237, 83);
INSERT INTO public.who_global_data VALUES (55949, 2856, 84379, 44, 1139, 237, 228);
INSERT INTO public.who_global_data VALUES (55950, 0, 96, 0, 7, 237, 188);
INSERT INTO public.who_global_data VALUES (55951, 721, 53241, 5, 303, 237, 62);
INSERT INTO public.who_global_data VALUES (55952, 49, 60560, 5, 9532, 237, 160);
INSERT INTO public.who_global_data VALUES (55953, 0, 20, 0, 2, 237, 50);
INSERT INTO public.who_global_data VALUES (55954, 0, 412, 0, 6, 237, 33);
INSERT INTO public.who_global_data VALUES (55955, 1, 142, 0, 9, 237, 183);
INSERT INTO public.who_global_data VALUES (55956, 4, 66, 0, 0, 237, 92);
INSERT INTO public.who_global_data VALUES (55957, 764, 16929, 26, 559, 237, 158);
INSERT INTO public.who_global_data VALUES (55958, 0, 2, 0, 0, 237, 67);
INSERT INTO public.who_global_data VALUES (55959, 0, 2892, 0, 162, 237, 57);
INSERT INTO public.who_global_data VALUES (55960, 0, 60, 0, 1, 237, 38);
INSERT INTO public.who_global_data VALUES (55961, 25982, 828810, 909, 41828, 237, 141);
INSERT INTO public.who_global_data VALUES (55962, 0, 8, 0, 1, 237, 178);
INSERT INTO public.who_global_data VALUES (55963, 0, 141, 0, 2, 237, 108);
INSERT INTO public.who_global_data VALUES (55964, 75, 3266, 0, 172, 237, 39);
INSERT INTO public.who_global_data VALUES (55965, 0, 892, 0, 53, 237, 2);
INSERT INTO public.who_global_data VALUES (55966, 0, 94, 0, 1, 237, 195);
INSERT INTO public.who_global_data VALUES (55967, 29, 726, 0, 6, 237, 107);
INSERT INTO public.who_global_data VALUES (55968, 0, 126, 0, 0, 237, 161);
INSERT INTO public.who_global_data VALUES (55969, 0, 8743, 0, 270, 237, 212);
INSERT INTO public.who_global_data VALUES (55970, 413, 97943, 55, 8049, 237, 181);
INSERT INTO public.who_global_data VALUES (55971, 1, 187, 0, 1, 237, 53);
INSERT INTO public.who_global_data VALUES (55972, 0, 2057, 0, 7, 237, 164);
INSERT INTO public.who_global_data VALUES (55973, 0, 848, 0, 72, 237, 140);
INSERT INTO public.who_global_data VALUES (55974, 6509, 167355, 231, 3101, 237, 20);
INSERT INTO public.who_global_data VALUES (55975, 58, 84729, 0, 4645, 237, 112);
INSERT INTO public.who_global_data VALUES (55976, 1646, 46858, 57, 1545, 237, 111);
INSERT INTO public.who_global_data VALUES (55977, 13, 176, 0, 2, 237, 71);
INSERT INTO public.who_global_data VALUES (55978, 34, 779, 0, 25, 237, 218);
INSERT INTO public.who_global_data VALUES (55979, 0, 0, 0, 0, 237, 43);
INSERT INTO public.who_global_data VALUES (55980, 74, 1612, 0, 12, 237, 49);
INSERT INTO public.who_global_data VALUES (55981, 164, 4848, 0, 45, 237, 1);
INSERT INTO public.who_global_data VALUES (55982, 2, 2251, 0, 107, 237, 48);
INSERT INTO public.who_global_data VALUES (55983, 5, 2238, 0, 84, 237, 232);
INSERT INTO public.who_global_data VALUES (55984, 0, 22, 0, 1, 237, 175);
INSERT INTO public.who_global_data VALUES (55985, 0, 980, 0, 18, 237, 21);
INSERT INTO public.who_global_data VALUES (55986, 53, 9991, 0, 329, 237, 156);
INSERT INTO public.who_global_data VALUES (55987, 0, 0, 0, 0, 237, 95);
INSERT INTO public.who_global_data VALUES (55988, 87, 4723, 5, 105, 237, 177);
INSERT INTO public.who_global_data VALUES (55989, 40, 12139, 3, 597, 237, 210);
INSERT INTO public.who_global_data VALUES (55990, 8, 4449, 3, 41, 237, 120);
INSERT INTO public.who_global_data VALUES (55991, 0, 18, 0, 0, 237, 135);
INSERT INTO public.who_global_data VALUES (55992, 564, 22572, 9, 577, 237, 206);
INSERT INTO public.who_global_data VALUES (55993, 578, 46356, 46, 3874, 237, 189);
INSERT INTO public.who_global_data VALUES (55994, 1677, 42980, 62, 1484, 237, 129);
INSERT INTO public.who_global_data VALUES (55995, 122, 3603, 4, 72, 237, 121);
INSERT INTO public.who_global_data VALUES (55996, 0, 1043, 0, 12, 237, 59);
INSERT INTO public.who_global_data VALUES (55997, 24, 65, 0, 0, 237, 96);
INSERT INTO public.who_global_data VALUES (55998, 3, 1973, 0, 63, 237, 41);
INSERT INTO public.who_global_data VALUES (55999, 14, 486, 0, 3, 237, 216);
INSERT INTO public.who_global_data VALUES (56000, 251, 3166, 8, 55, 237, 236);
INSERT INTO public.who_global_data VALUES (56001, 0, 13, 0, 0, 237, 150);
INSERT INTO public.who_global_data VALUES (56002, 0, 187, 0, 0, 237, 61);
INSERT INTO public.who_global_data VALUES (56003, 0, 18, 0, 0, 237, 7);
INSERT INTO public.who_global_data VALUES (56004, 14, 7087, 0, 325, 237, 169);
INSERT INTO public.who_global_data VALUES (56005, 393, 152460, 23, 29335, 237, 28);
INSERT INTO public.who_global_data VALUES (56006, 118, 1161, 0, 2, 237, 85);
INSERT INTO public.who_global_data VALUES (56007, 0, 60, 0, 0, 237, 211);
INSERT INTO public.who_global_data VALUES (56008, 0, 3463, 0, 23, 237, 60);
INSERT INTO public.who_global_data VALUES (56009, 0, 28, 0, 1, 237, 3);
INSERT INTO public.who_global_data VALUES (56010, 13, 864, 1, 14, 237, 11);
INSERT INTO public.who_global_data VALUES (56011, 247, 186269, 6, 8787, 237, 89);
INSERT INTO public.who_global_data VALUES (56012, 262, 11118, 0, 48, 237, 24);
INSERT INTO public.who_global_data VALUES (56013, 0, 176, 0, 0, 237, 162);
INSERT INTO public.who_global_data VALUES (56014, 4, 3112, 0, 183, 237, 100);
INSERT INTO public.who_global_data VALUES (56015, 0, 13, 0, 0, 237, 47);
INSERT INTO public.who_global_data VALUES (56016, 0, 23, 0, 0, 237, 29);
INSERT INTO public.who_global_data VALUES (56017, 0, 171, 0, 14, 237, 40);
INSERT INTO public.who_global_data VALUES (56018, 1, 177, 0, 5, 237, 222);
INSERT INTO public.who_global_data VALUES (56019, 421, 8982, 17, 351, 237, 132);
INSERT INTO public.who_global_data VALUES (56020, 0, 252, 0, 13, 237, 130);
INSERT INTO public.who_global_data VALUES (56021, 58, 4484, 1, 25, 237, 234);
INSERT INTO public.who_global_data VALUES (56022, 71, 1460, 3, 15, 237, 23);
INSERT INTO public.who_global_data VALUES (56023, 1, 159, 0, 12, 237, 192);
INSERT INTO public.who_global_data VALUES (56024, 0, 3941, 0, 64, 237, 69);
INSERT INTO public.who_global_data VALUES (56025, 0, 12, 0, 0, 237, 187);
INSERT INTO public.who_global_data VALUES (56026, 463, 8132, 12, 306, 237, 230);
INSERT INTO public.who_global_data VALUES (56027, 11, 4064, 4, 559, 237, 77);
INSERT INTO public.who_global_data VALUES (56028, 2, 1810, 0, 10, 237, 9);
INSERT INTO public.who_global_data VALUES (56029, 11929, 320922, 311, 9195, 237, 74);
INSERT INTO public.who_global_data VALUES (56030, 1014, 37420, 43, 2091, 237, 224);
INSERT INTO public.who_global_data VALUES (56031, 2410, 184955, 71, 8730, 237, 199);
INSERT INTO public.who_global_data VALUES (56032, 1180, 18950, 53, 549, 237, 190);
INSERT INTO public.who_global_data VALUES (56033, 45, 25295, 0, 1705, 237, 12);
INSERT INTO public.who_global_data VALUES (56034, 0, 336, 0, 24, 237, 104);
INSERT INTO public.who_global_data VALUES (56035, 184, 18857, 0, 302, 237, 153);
INSERT INTO public.who_global_data VALUES (56036, 346, 236651, 78, 34301, 237, 91);
INSERT INTO public.who_global_data VALUES (56037, 3, 614, 0, 10, 237, 215);
INSERT INTO public.who_global_data VALUES (56038, 47, 17429, 1, 925, 237, 84);
INSERT INTO public.who_global_data VALUES (56039, 0, 313, 0, 30, 237, 231);
INSERT INTO public.who_global_data VALUES (56040, 38, 895, 0, 9, 237, 196);
INSERT INTO public.who_global_data VALUES (56041, 313, 14809, 4, 77, 237, 105);
INSERT INTO public.who_global_data VALUES (56042, 152, 3457, 4, 100, 237, 122);
INSERT INTO public.who_global_data VALUES (56043, 0, 0, 0, 0, 237, 159);
INSERT INTO public.who_global_data VALUES (56044, 111, 1437, 1, 23, 237, 75);
INSERT INTO public.who_global_data VALUES (56045, 514, 35466, 4, 289, 237, 27);
INSERT INTO public.who_global_data VALUES (56046, 78, 2285, 0, 27, 237, 54);
INSERT INTO public.who_global_data VALUES (56047, 0, 19, 0, 0, 237, 226);
INSERT INTO public.who_global_data VALUES (56048, 1, 1097, 1, 28, 237, 79);
INSERT INTO public.who_global_data VALUES (56049, 20, 1442, 1, 32, 237, 56);
INSERT INTO public.who_global_data VALUES (56050, 0, 4, 0, 0, 237, 117);
INSERT INTO public.who_global_data VALUES (56051, 25, 446, 0, 32, 237, 152);
INSERT INTO public.who_global_data VALUES (56052, 9, 418, 2, 8, 237, 16);
INSERT INTO public.who_global_data VALUES (56053, 0, 83, 0, 1, 237, 10);
INSERT INTO public.who_global_data VALUES (56054, 5, 1763, 0, 75, 237, 201);
INSERT INTO public.who_global_data VALUES (56055, 8, 4063, 0, 110, 237, 174);
INSERT INTO public.who_global_data VALUES (56056, 22, 1252, 0, 10, 237, 119);
INSERT INTO public.who_global_data VALUES (56057, 48, 529, 1, 5, 237, 168);
INSERT INTO public.who_global_data VALUES (56058, 43, 8445, 1, 120, 237, 99);
INSERT INTO public.who_global_data VALUES (56059, 10, 2013, 0, 8, 237, 171);
INSERT INTO public.who_global_data VALUES (56060, 24, 1776, 3, 104, 237, 87);
INSERT INTO public.who_global_data VALUES (56061, 2, 647, 0, 9, 237, 123);
INSERT INTO public.who_global_data VALUES (56062, 0, 0, 0, 0, 237, 151);
INSERT INTO public.who_global_data VALUES (56063, 0, 202, 0, 14, 237, 213);
INSERT INTO public.who_global_data VALUES (56064, 134, 1573, 7, 81, 237, 118);
INSERT INTO public.who_global_data VALUES (56065, 0, 337, 0, 10, 237, 134);
INSERT INTO public.who_global_data VALUES (56066, 14, 2282, 1, 29, 237, 65);
INSERT INTO public.who_global_data VALUES (56067, 5222, 139196, 504, 16448, 237, 102);
INSERT INTO public.who_global_data VALUES (56068, 0, 0, 0, 0, 237, 223);
INSERT INTO public.who_global_data VALUES (56069, 0, 70, 0, 1, 237, 4);
INSERT INTO public.who_global_data VALUES (56070, 0, 197, 0, 0, 237, 146);
INSERT INTO public.who_global_data VALUES (56071, 1, 325, 0, 9, 237, 31);
INSERT INTO public.who_global_data VALUES (56072, 0, 11, 0, 1, 237, 127);
INSERT INTO public.who_global_data VALUES (56073, 82, 8692, 0, 212, 237, 22);
INSERT INTO public.who_global_data VALUES (56074, 44, 553, 0, 2, 237, 115);
INSERT INTO public.who_global_data VALUES (56075, 0, 261, 0, 6, 237, 106);
INSERT INTO public.who_global_data VALUES (56076, 1, 32, 0, 0, 237, 90);
INSERT INTO public.who_global_data VALUES (56077, 0, 0, 0, 0, 237, 70);
INSERT INTO public.who_global_data VALUES (56078, 273, 5335, 2, 18, 237, 46);
INSERT INTO public.who_global_data VALUES (56079, 181, 48394, 6, 6030, 237, 139);
INSERT INTO public.who_global_data VALUES (56080, 0, 21, 0, 0, 237, 42);
INSERT INTO public.who_global_data VALUES (56081, 0, 1154, 0, 22, 237, 80);
INSERT INTO public.who_global_data VALUES (56082, 0, 1655, 0, 55, 237, 203);
INSERT INTO public.who_global_data VALUES (56083, 0, 978, 0, 65, 237, 136);
INSERT INTO public.who_global_data VALUES (56084, 627, 15181, 12, 399, 237, 63);
INSERT INTO public.who_global_data VALUES (56085, 0, 0, 0, 0, 237, 17);
INSERT INTO public.who_global_data VALUES (56086, 0, 30, 0, 2, 237, 172);
INSERT INTO public.who_global_data VALUES (56087, 196, 3902, 8, 179, 237, 109);
INSERT INTO public.who_global_data VALUES (56088, 0, 8606, 0, 242, 237, 200);
INSERT INTO public.who_global_data VALUES (56089, 4, 673, 0, 5, 237, 93);
INSERT INTO public.who_global_data VALUES (56090, 1006, 22077, 3, 99, 237, 5);
INSERT INTO public.who_global_data VALUES (56091, 0, 741, 0, 13, 237, 214);
INSERT INTO public.who_global_data VALUES (56092, 6825, 139230, 81, 2632, 237, 204);
INSERT INTO public.who_global_data VALUES (56093, 0, 0, 0, 0, 237, 198);
INSERT INTO public.who_global_data VALUES (56094, 625, 19211, 3, 421, 237, 173);
INSERT INTO public.who_global_data VALUES (56095, 0, 8, 0, 0, 237, 229);
INSERT INTO public.who_global_data VALUES (56096, 7, 1261, 0, 11, 237, 76);
INSERT INTO public.who_global_data VALUES (56097, 5961, 220749, 199, 6308, 237, 138);
INSERT INTO public.who_global_data VALUES (56098, 605, 25392, 22, 1074, 237, 98);
INSERT INTO public.who_global_data VALUES (56099, 0, 0, 0, 0, 237, 103);
INSERT INTO public.who_global_data VALUES (56100, 440, 29017, 15, 1237, 237, 225);
INSERT INTO public.who_global_data VALUES (56101, 283, 36463, 7, 1512, 237, 131);
INSERT INTO public.who_global_data VALUES (56102, 154, 5690, 0, 146, 237, 235);
INSERT INTO public.who_global_data VALUES (56103, 1828, 78416, 0, 70, 237, 137);
INSERT INTO public.who_global_data VALUES (56104, 34, 12084, 0, 277, 237, 81);
INSERT INTO public.who_global_data VALUES (56105, 366, 11459, 4, 399, 237, 182);
INSERT INTO public.who_global_data VALUES (56106, 1, 489, 0, 1, 237, 145);
INSERT INTO public.who_global_data VALUES (56107, 275, 21679, 11, 1391, 237, 26);
INSERT INTO public.who_global_data VALUES (56108, 8835, 528964, 119, 6948, 237, 170);
INSERT INTO public.who_global_data VALUES (56109, 31, 541, 0, 2, 237, 191);
INSERT INTO public.who_global_data VALUES (56110, 0, 3, 0, 0, 237, 221);
INSERT INTO public.who_global_data VALUES (56111, 0, 6, 0, 0, 237, 64);
INSERT INTO public.who_global_data VALUES (56112, 0, 0, 0, 0, 237, 116);
INSERT INTO public.who_global_data VALUES (56113, 0, 15, 0, 0, 237, 128);
INSERT INTO public.who_global_data VALUES (56114, 0, 19, 0, 0, 237, 6);
INSERT INTO public.who_global_data VALUES (56115, 0, 41, 0, 3, 237, 227);
INSERT INTO public.who_global_data VALUES (56116, 0, 1, 0, 0, 237, 68);
INSERT INTO public.who_global_data VALUES (56117, 0, 27, 0, 0, 237, 184);
INSERT INTO public.who_global_data VALUES (56118, 0, 0, 0, 0, 237, 82);
INSERT INTO public.who_global_data VALUES (56119, 0, 695, 0, 42, 237, 149);
INSERT INTO public.who_global_data VALUES (56120, 0, 388, 0, 10, 237, 197);
INSERT INTO public.who_global_data VALUES (56121, 3366, 123308, 39, 932, 237, 78);
INSERT INTO public.who_global_data VALUES (56122, 145, 4996, 4, 60, 237, 233);
INSERT INTO public.who_global_data VALUES (56123, 76, 12251, 1, 253, 237, 133);
INSERT INTO public.who_global_data VALUES (56124, 0, 11, 0, 0, 237, 35);
INSERT INTO public.who_global_data VALUES (56125, 29, 1132, 0, 51, 237, 114);
INSERT INTO public.who_global_data VALUES (56126, 347, 40197, 1, 26, 237, 237);
INSERT INTO public.who_global_data VALUES (56127, 0, 2, 0, 0, 237, 55);
INSERT INTO public.who_global_data VALUES (56128, 0, 77, 0, 15, 237, 176);
INSERT INTO public.who_global_data VALUES (56129, 3, 1545, 0, 28, 237, 202);
INSERT INTO public.who_global_data VALUES (56130, 3, 1495, 0, 113, 237, 155);
INSERT INTO public.who_global_data VALUES (56131, 0, 0, 0, 0, 237, 32);
INSERT INTO public.who_global_data VALUES (56132, 66, 2579, 2, 87, 237, 220);
INSERT INTO public.who_global_data VALUES (56133, 3809, 65736, 69, 1423, 237, 30);
INSERT INTO public.who_global_data VALUES (56134, 14, 1684, 3, 25, 237, 147);
INSERT INTO public.who_global_data VALUES (56135, 531, 252766, 19, 29512, 237, 208);
INSERT INTO public.who_global_data VALUES (56136, 4, 1884, 0, 11, 237, 45);
INSERT INTO public.who_global_data VALUES (56137, 128, 7007, 14, 447, 237, 110);
INSERT INTO public.who_global_data VALUES (56138, 19, 187, 1, 3, 237, 88);
INSERT INTO public.who_global_data VALUES (56139, 1329, 50352, 29, 5080, 237, 51);
INSERT INTO public.who_global_data VALUES (56140, 9, 31069, 1, 1719, 237, 209);
INSERT INTO public.who_global_data VALUES (56141, 0, 170, 0, 6, 237, 205);
INSERT INTO public.who_global_data VALUES (56142, 69, 4971, 1, 50, 237, 18);
INSERT INTO public.who_global_data VALUES (56143, 1, 3135, 0, 58, 237, 72);
INSERT INTO public.who_global_data VALUES (56144, 1052, 270289, 107, 39339, 237, 44);
INSERT INTO public.who_global_data VALUES (56145, 0, 24, 0, 0, 237, 15);
INSERT INTO public.who_global_data VALUES (56146, 1, 525, 0, 13, 237, 25);
INSERT INTO public.who_global_data VALUES (56147, 0, 0, 0, 0, 237, 179);
INSERT INTO public.who_global_data VALUES (56148, 0, 0, 0, 0, 237, 34);
INSERT INTO public.who_global_data VALUES (56149, 0, 117, 0, 8, 237, 207);
INSERT INTO public.who_global_data VALUES (56150, 2, 1096, 0, 49, 237, 166);
INSERT INTO public.who_global_data VALUES (56151, 1459, 176677, 14, 4792, 237, 126);
INSERT INTO public.who_global_data VALUES (56152, 0, 0, 0, 0, 237, 97);
INSERT INTO public.who_global_data VALUES (56153, 0, 12, 0, 1, 237, 36);
INSERT INTO public.who_global_data VALUES (56154, 0, 0, 0, 0, 237, 125);
INSERT INTO public.who_global_data VALUES (56155, 15, 823, 0, 0, 237, 124);
INSERT INTO public.who_global_data VALUES (56156, 648, 31154, 9, 889, 237, 185);
INSERT INTO public.who_global_data VALUES (56157, 491, 41990, 1, 288, 237, 194);
INSERT INTO public.who_global_data VALUES (56158, 0, 509, 0, 21, 237, 144);
INSERT INTO public.who_global_data VALUES (56159, 22133, 2032524, 709, 114466, 237, 19);
INSERT INTO public.who_global_data VALUES (56160, 0, 72, 0, 6, 237, 217);
INSERT INTO public.who_global_data VALUES (56161, 0, 847, 0, 23, 237, 148);
INSERT INTO public.who_global_data VALUES (56162, 93, 4994, 0, 19, 237, 86);
INSERT INTO public.who_global_data VALUES (56163, 0, 0, 0, 0, 237, 13);
INSERT INTO public.who_global_data VALUES (56164, 65, 2879, 0, 23, 237, 157);
INSERT INTO public.who_global_data VALUES (56165, 2, 334, 0, 0, 237, 8);
INSERT INTO public.who_global_data VALUES (56166, 0, 0, 0, 0, 237, 73);
INSERT INTO public.who_global_data VALUES (56167, 73, 705, 21, 160, 237, 101);
INSERT INTO public.who_global_data VALUES (56168, 36, 1357, 0, 10, 237, 165);
INSERT INTO public.who_global_data VALUES (56169, 13, 356, 0, 4, 237, 14);
INSERT INTO public.who_global_data VALUES (56170, 556, 24188, 5, 455, 238, 193);
INSERT INTO public.who_global_data VALUES (56171, 48, 1464, 0, 36, 238, 113);
INSERT INTO public.who_global_data VALUES (56172, 109, 10698, 10, 751, 238, 143);
INSERT INTO public.who_global_data VALUES (56173, 0, 0, 0, 0, 238, 219);
INSERT INTO public.who_global_data VALUES (56174, 1, 853, 0, 51, 238, 186);
INSERT INTO public.who_global_data VALUES (56175, 12, 130, 0, 5, 238, 52);
INSERT INTO public.who_global_data VALUES (56176, 0, 3, 0, 0, 238, 180);
INSERT INTO public.who_global_data VALUES (56177, 0, 25, 0, 3, 238, 167);
INSERT INTO public.who_global_data VALUES (56178, 1386, 27373, 31, 772, 238, 154);
INSERT INTO public.who_global_data VALUES (56179, 612, 15257, 13, 258, 238, 94);
INSERT INTO public.who_global_data VALUES (56180, 0, 101, 0, 3, 238, 66);
INSERT INTO public.who_global_data VALUES (56181, 5, 7290, 0, 102, 238, 58);
INSERT INTO public.who_global_data VALUES (56182, 30, 16994, 1, 675, 238, 163);
INSERT INTO public.who_global_data VALUES (56183, 336, 9218, 5, 113, 238, 37);
INSERT INTO public.who_global_data VALUES (56184, 0, 103, 0, 11, 238, 142);
INSERT INTO public.who_global_data VALUES (56185, 444, 17713, 0, 36, 238, 83);
INSERT INTO public.who_global_data VALUES (56186, 3471, 81523, 46, 1095, 238, 228);
INSERT INTO public.who_global_data VALUES (56187, 0, 96, 0, 7, 238, 188);
INSERT INTO public.who_global_data VALUES (56188, 704, 52520, 5, 298, 238, 62);
INSERT INTO public.who_global_data VALUES (56189, 89, 60511, 10, 9527, 238, 160);
INSERT INTO public.who_global_data VALUES (56190, 0, 20, 0, 2, 238, 50);
INSERT INTO public.who_global_data VALUES (56191, 22, 412, 1, 6, 238, 33);
INSERT INTO public.who_global_data VALUES (56192, 0, 141, 0, 9, 238, 183);
INSERT INTO public.who_global_data VALUES (56193, 0, 62, 0, 0, 238, 92);
INSERT INTO public.who_global_data VALUES (56194, 884, 16165, 21, 533, 238, 158);
INSERT INTO public.who_global_data VALUES (56195, 0, 2, 0, 0, 238, 67);
INSERT INTO public.who_global_data VALUES (56196, 61, 2892, 2, 162, 238, 57);
INSERT INTO public.who_global_data VALUES (56197, 12, 60, 0, 1, 238, 38);
INSERT INTO public.who_global_data VALUES (56198, 30412, 802828, 1239, 40919, 238, 141);
INSERT INTO public.who_global_data VALUES (56199, 0, 8, 0, 1, 238, 178);
INSERT INTO public.who_global_data VALUES (56200, 0, 141, 0, 2, 238, 108);
INSERT INTO public.who_global_data VALUES (56201, 105, 3191, 4, 172, 238, 39);
INSERT INTO public.who_global_data VALUES (56202, 1, 892, 0, 53, 238, 2);
INSERT INTO public.who_global_data VALUES (56203, 0, 94, 0, 1, 238, 195);
INSERT INTO public.who_global_data VALUES (56204, 40, 697, 0, 6, 238, 107);
INSERT INTO public.who_global_data VALUES (56205, 0, 126, 0, 0, 238, 161);
INSERT INTO public.who_global_data VALUES (56206, 62, 8743, 55, 270, 238, 212);
INSERT INTO public.who_global_data VALUES (56207, 405, 97530, 34, 7994, 238, 181);
INSERT INTO public.who_global_data VALUES (56208, 6, 186, 0, 1, 238, 53);
INSERT INTO public.who_global_data VALUES (56209, 13, 2057, 2, 7, 238, 164);
INSERT INTO public.who_global_data VALUES (56210, 0, 848, 0, 72, 238, 140);
INSERT INTO public.who_global_data VALUES (56211, 6754, 160846, 222, 2870, 238, 20);
INSERT INTO public.who_global_data VALUES (56212, 12, 84671, 0, 4645, 238, 112);
INSERT INTO public.who_global_data VALUES (56213, 1530, 45212, 55, 1488, 238, 111);
INSERT INTO public.who_global_data VALUES (56214, 1, 163, 0, 2, 238, 71);
INSERT INTO public.who_global_data VALUES (56215, 0, 745, 0, 25, 238, 218);
INSERT INTO public.who_global_data VALUES (56216, 0, 0, 0, 0, 238, 43);
INSERT INTO public.who_global_data VALUES (56217, 77, 1538, 0, 12, 238, 49);
INSERT INTO public.who_global_data VALUES (56218, 280, 4684, 4, 45, 238, 1);
INSERT INTO public.who_global_data VALUES (56219, 0, 2249, 1, 107, 238, 48);
INSERT INTO public.who_global_data VALUES (56220, 14, 2233, 0, 84, 238, 232);
INSERT INTO public.who_global_data VALUES (56221, 0, 22, 0, 1, 238, 175);
INSERT INTO public.who_global_data VALUES (56222, 5, 980, 0, 18, 238, 21);
INSERT INTO public.who_global_data VALUES (56223, 52, 9938, 0, 329, 238, 156);
INSERT INTO public.who_global_data VALUES (56224, 0, 0, 0, 0, 238, 95);
INSERT INTO public.who_global_data VALUES (56225, 122, 4636, 3, 100, 238, 177);
INSERT INTO public.who_global_data VALUES (56226, 64, 12099, 1, 594, 238, 210);
INSERT INTO public.who_global_data VALUES (56227, 43, 4441, 1, 38, 238, 120);
INSERT INTO public.who_global_data VALUES (56228, 2, 18, 0, 0, 238, 135);
INSERT INTO public.who_global_data VALUES (56229, 571, 22008, 7, 568, 238, 206);
INSERT INTO public.who_global_data VALUES (56230, 1338, 45778, 108, 3828, 238, 189);
INSERT INTO public.who_global_data VALUES (56231, 1577, 41303, 45, 1422, 238, 129);
INSERT INTO public.who_global_data VALUES (56232, 108, 3481, 4, 68, 238, 121);
INSERT INTO public.who_global_data VALUES (56233, 0, 1043, 0, 12, 238, 59);
INSERT INTO public.who_global_data VALUES (56234, 0, 41, 0, 0, 238, 96);
INSERT INTO public.who_global_data VALUES (56235, 5, 1970, 0, 63, 238, 41);
INSERT INTO public.who_global_data VALUES (56236, 23, 472, 0, 3, 238, 216);
INSERT INTO public.who_global_data VALUES (56237, 245, 2915, 7, 47, 238, 236);
INSERT INTO public.who_global_data VALUES (56238, 0, 13, 0, 0, 238, 150);
INSERT INTO public.who_global_data VALUES (56239, 0, 187, 0, 0, 238, 61);
INSERT INTO public.who_global_data VALUES (56240, 0, 18, 0, 0, 238, 7);
INSERT INTO public.who_global_data VALUES (56241, 9, 7073, 0, 325, 238, 169);
INSERT INTO public.who_global_data VALUES (56242, 564, 152067, 28, 29312, 238, 28);
INSERT INTO public.who_global_data VALUES (56243, 126, 1043, 0, 2, 238, 85);
INSERT INTO public.who_global_data VALUES (56244, 0, 60, 0, 0, 238, 211);
INSERT INTO public.who_global_data VALUES (56245, 0, 3463, 0, 23, 238, 60);
INSERT INTO public.who_global_data VALUES (56246, 0, 28, 0, 1, 238, 3);
INSERT INTO public.who_global_data VALUES (56247, 14, 851, 0, 13, 238, 11);
INSERT INTO public.who_global_data VALUES (56248, 348, 186022, 18, 8781, 238, 89);
INSERT INTO public.who_global_data VALUES (56249, 498, 10856, 0, 48, 238, 24);
INSERT INTO public.who_global_data VALUES (56250, 0, 176, 0, 0, 238, 162);
INSERT INTO public.who_global_data VALUES (56251, 20, 3108, 0, 183, 238, 100);
INSERT INTO public.who_global_data VALUES (56252, 0, 13, 0, 0, 238, 47);
INSERT INTO public.who_global_data VALUES (56253, 0, 23, 0, 0, 238, 29);
INSERT INTO public.who_global_data VALUES (56254, 7, 171, 0, 14, 238, 40);
INSERT INTO public.who_global_data VALUES (56255, 2, 176, 0, 5, 238, 222);
INSERT INTO public.who_global_data VALUES (56256, 340, 8561, 18, 334, 238, 132);
INSERT INTO public.who_global_data VALUES (56257, 0, 252, 0, 13, 238, 130);
INSERT INTO public.who_global_data VALUES (56258, 54, 4426, 1, 24, 238, 234);
INSERT INTO public.who_global_data VALUES (56259, 0, 1389, 0, 12, 238, 23);
INSERT INTO public.who_global_data VALUES (56260, 2, 158, 0, 12, 238, 192);
INSERT INTO public.who_global_data VALUES (56261, 145, 3941, 6, 64, 238, 69);
INSERT INTO public.who_global_data VALUES (56262, 0, 12, 0, 0, 238, 187);
INSERT INTO public.who_global_data VALUES (56263, 309, 7669, 4, 294, 238, 230);
INSERT INTO public.who_global_data VALUES (56264, 14, 4053, 2, 555, 238, 77);
INSERT INTO public.who_global_data VALUES (56265, 1, 1808, 0, 10, 238, 9);
INSERT INTO public.who_global_data VALUES (56266, 11458, 308993, 386, 8884, 238, 74);
INSERT INTO public.who_global_data VALUES (56267, 1111, 36406, 48, 2048, 238, 224);
INSERT INTO public.who_global_data VALUES (56268, 2369, 182545, 75, 8659, 238, 199);
INSERT INTO public.who_global_data VALUES (56269, 1095, 17770, 39, 496, 238, 190);
INSERT INTO public.who_global_data VALUES (56270, 12, 25250, 2, 1705, 238, 12);
INSERT INTO public.who_global_data VALUES (56271, 0, 336, 0, 24, 238, 104);
INSERT INTO public.who_global_data VALUES (56272, 191, 18673, 0, 302, 238, 153);
INSERT INTO public.who_global_data VALUES (56273, 163, 236305, 56, 34223, 238, 91);
INSERT INTO public.who_global_data VALUES (56274, 13, 611, 0, 10, 238, 215);
INSERT INTO public.who_global_data VALUES (56275, 50, 17382, 2, 924, 238, 84);
INSERT INTO public.who_global_data VALUES (56276, 0, 313, 0, 30, 238, 231);
INSERT INTO public.who_global_data VALUES (56277, 21, 857, 0, 9, 238, 196);
INSERT INTO public.who_global_data VALUES (56278, 258, 14496, 3, 73, 238, 105);
INSERT INTO public.who_global_data VALUES (56279, 90, 3305, 4, 96, 238, 122);
INSERT INTO public.who_global_data VALUES (56280, 0, 0, 0, 0, 238, 159);
INSERT INTO public.who_global_data VALUES (56281, 0, 1326, 1, 22, 238, 75);
INSERT INTO public.who_global_data VALUES (56282, 520, 34952, 6, 285, 238, 27);
INSERT INTO public.who_global_data VALUES (56283, 41, 2207, 1, 27, 238, 54);
INSERT INTO public.who_global_data VALUES (56284, 0, 19, 0, 0, 238, 226);
INSERT INTO public.who_global_data VALUES (56285, 2, 1096, 1, 27, 238, 79);
INSERT INTO public.who_global_data VALUES (56286, 20, 1422, 0, 31, 238, 56);
INSERT INTO public.who_global_data VALUES (56287, 0, 4, 0, 0, 238, 117);
INSERT INTO public.who_global_data VALUES (56288, 11, 421, 1, 32, 238, 152);
INSERT INTO public.who_global_data VALUES (56289, 16, 409, 1, 6, 238, 16);
INSERT INTO public.who_global_data VALUES (56290, 0, 83, 0, 1, 238, 10);
INSERT INTO public.who_global_data VALUES (56291, 7, 1758, 0, 75, 238, 201);
INSERT INTO public.who_global_data VALUES (56292, 3, 4055, 0, 110, 238, 174);
INSERT INTO public.who_global_data VALUES (56293, 27, 1230, 0, 10, 238, 119);
INSERT INTO public.who_global_data VALUES (56294, 0, 481, 0, 4, 238, 168);
INSERT INTO public.who_global_data VALUES (56295, 33, 8402, 1, 119, 238, 99);
INSERT INTO public.who_global_data VALUES (56296, 27, 2003, 0, 8, 238, 171);
INSERT INTO public.who_global_data VALUES (56297, 30, 1752, 4, 101, 238, 87);
INSERT INTO public.who_global_data VALUES (56298, 1, 645, 0, 9, 238, 123);
INSERT INTO public.who_global_data VALUES (56299, 0, 0, 0, 0, 238, 151);
INSERT INTO public.who_global_data VALUES (56300, 0, 202, 0, 14, 238, 213);
INSERT INTO public.who_global_data VALUES (56301, 156, 1439, 3, 74, 238, 118);
INSERT INTO public.who_global_data VALUES (56302, 0, 337, 0, 10, 238, 134);
INSERT INTO public.who_global_data VALUES (56303, 28, 2268, 0, 28, 238, 65);
INSERT INTO public.who_global_data VALUES (56304, 4790, 133974, 587, 15944, 238, 102);
INSERT INTO public.who_global_data VALUES (56305, 0, 0, 0, 0, 238, 223);
INSERT INTO public.who_global_data VALUES (56306, 0, 70, 0, 1, 238, 4);
INSERT INTO public.who_global_data VALUES (56307, 3, 197, 0, 0, 238, 146);
INSERT INTO public.who_global_data VALUES (56308, 0, 324, 0, 9, 238, 31);
INSERT INTO public.who_global_data VALUES (56309, 0, 11, 0, 1, 238, 127);
INSERT INTO public.who_global_data VALUES (56310, 73, 8610, 1, 212, 238, 22);
INSERT INTO public.who_global_data VALUES (56311, 20, 509, 0, 2, 238, 115);
INSERT INTO public.who_global_data VALUES (56312, 0, 261, 0, 6, 238, 106);
INSERT INTO public.who_global_data VALUES (56313, 0, 31, 0, 0, 238, 90);
INSERT INTO public.who_global_data VALUES (56314, 0, 0, 0, 0, 238, 70);
INSERT INTO public.who_global_data VALUES (56315, 448, 5062, 1, 16, 238, 46);
INSERT INTO public.who_global_data VALUES (56316, 207, 48213, 7, 6024, 238, 139);
INSERT INTO public.who_global_data VALUES (56317, 0, 21, 0, 0, 238, 42);
INSERT INTO public.who_global_data VALUES (56318, 0, 1154, 0, 22, 238, 80);
INSERT INTO public.who_global_data VALUES (56319, 0, 1655, 0, 55, 238, 203);
INSERT INTO public.who_global_data VALUES (56320, 4, 978, 0, 65, 238, 136);
INSERT INTO public.who_global_data VALUES (56321, 0, 14554, 0, 387, 238, 63);
INSERT INTO public.who_global_data VALUES (56322, 0, 0, 0, 0, 238, 17);
INSERT INTO public.who_global_data VALUES (56323, 0, 30, 0, 2, 238, 172);
INSERT INTO public.who_global_data VALUES (56324, 164, 3706, 2, 171, 238, 109);
INSERT INTO public.who_global_data VALUES (56325, 12, 8606, 0, 242, 238, 200);
INSERT INTO public.who_global_data VALUES (56326, 2, 669, 0, 5, 238, 93);
INSERT INTO public.who_global_data VALUES (56327, 1117, 21071, 7, 96, 238, 5);
INSERT INTO public.who_global_data VALUES (56328, 0, 741, 0, 13, 238, 214);
INSERT INTO public.who_global_data VALUES (56329, 6884, 132405, 88, 2551, 238, 204);
INSERT INTO public.who_global_data VALUES (56330, 0, 0, 0, 0, 238, 198);
INSERT INTO public.who_global_data VALUES (56331, 697, 18586, 5, 418, 238, 173);
INSERT INTO public.who_global_data VALUES (56332, 0, 8, 0, 0, 238, 229);
INSERT INTO public.who_global_data VALUES (56333, 24, 1254, 0, 11, 238, 76);
INSERT INTO public.who_global_data VALUES (56334, 5965, 214788, 206, 6109, 238, 138);
INSERT INTO public.who_global_data VALUES (56335, 612, 24787, 16, 1052, 238, 98);
INSERT INTO public.who_global_data VALUES (56336, 0, 0, 0, 0, 238, 103);
INSERT INTO public.who_global_data VALUES (56337, 376, 28577, 7, 1222, 238, 225);
INSERT INTO public.who_global_data VALUES (56338, 270, 36180, 1, 1505, 238, 131);
INSERT INTO public.who_global_data VALUES (56339, 184, 5536, 2, 146, 238, 235);
INSERT INTO public.who_global_data VALUES (56340, 1517, 76588, 1, 70, 238, 137);
INSERT INTO public.who_global_data VALUES (56341, 48, 12050, 0, 277, 238, 81);
INSERT INTO public.who_global_data VALUES (56342, 366, 11093, 20, 395, 238, 182);
INSERT INTO public.who_global_data VALUES (56343, 1, 488, 0, 1, 238, 145);
INSERT INTO public.who_global_data VALUES (56344, 222, 21404, 11, 1380, 238, 26);
INSERT INTO public.who_global_data VALUES (56345, 8706, 520129, 114, 6829, 238, 170);
INSERT INTO public.who_global_data VALUES (56346, 16, 510, 0, 2, 238, 191);
INSERT INTO public.who_global_data VALUES (56347, 0, 3, 0, 0, 238, 221);
INSERT INTO public.who_global_data VALUES (56348, 0, 6, 0, 0, 238, 64);
INSERT INTO public.who_global_data VALUES (56349, 0, 0, 0, 0, 238, 116);
INSERT INTO public.who_global_data VALUES (56350, 0, 15, 0, 0, 238, 128);
INSERT INTO public.who_global_data VALUES (56351, 0, 19, 0, 0, 238, 6);
INSERT INTO public.who_global_data VALUES (56352, 0, 41, 0, 3, 238, 227);
INSERT INTO public.who_global_data VALUES (56353, 0, 1, 0, 0, 238, 68);
INSERT INTO public.who_global_data VALUES (56354, 0, 27, 0, 0, 238, 184);
INSERT INTO public.who_global_data VALUES (56355, 0, 0, 0, 0, 238, 82);
INSERT INTO public.who_global_data VALUES (56356, 0, 695, 0, 42, 238, 149);
INSERT INTO public.who_global_data VALUES (56357, 0, 388, 0, 10, 238, 197);
INSERT INTO public.who_global_data VALUES (56358, 3921, 119942, 36, 893, 238, 78);
INSERT INTO public.who_global_data VALUES (56359, 92, 4851, 1, 56, 238, 233);
INSERT INTO public.who_global_data VALUES (56360, 73, 12175, 0, 252, 238, 133);
INSERT INTO public.who_global_data VALUES (56361, 0, 11, 0, 0, 238, 35);
INSERT INTO public.who_global_data VALUES (56362, 18, 1103, 1, 51, 238, 114);
INSERT INTO public.who_global_data VALUES (56363, 463, 39850, 0, 25, 238, 237);
INSERT INTO public.who_global_data VALUES (56364, 0, 2, 0, 0, 238, 55);
INSERT INTO public.who_global_data VALUES (56365, 0, 77, 0, 15, 238, 176);
INSERT INTO public.who_global_data VALUES (56366, 1, 1542, 0, 28, 238, 202);
INSERT INTO public.who_global_data VALUES (56367, 2, 1492, 0, 113, 238, 155);
INSERT INTO public.who_global_data VALUES (56368, 0, 0, 0, 0, 238, 32);
INSERT INTO public.who_global_data VALUES (56369, 0, 2513, 0, 85, 238, 220);
INSERT INTO public.who_global_data VALUES (56370, 3359, 61927, 70, 1354, 238, 30);
INSERT INTO public.who_global_data VALUES (56371, 64, 1670, 0, 22, 238, 147);
INSERT INTO public.who_global_data VALUES (56372, 411, 252235, 24, 29493, 238, 208);
INSERT INTO public.who_global_data VALUES (56373, 3, 1880, 0, 11, 238, 45);
INSERT INTO public.who_global_data VALUES (56374, 149, 6879, 20, 433, 238, 110);
INSERT INTO public.who_global_data VALUES (56375, 24, 168, 0, 2, 238, 88);
INSERT INTO public.who_global_data VALUES (56376, 1293, 49023, 35, 5051, 238, 51);
INSERT INTO public.who_global_data VALUES (56377, 34, 31060, 1, 1718, 238, 209);
INSERT INTO public.who_global_data VALUES (56378, 6, 170, 0, 6, 238, 205);
INSERT INTO public.who_global_data VALUES (56379, 68, 4902, 0, 49, 238, 18);
INSERT INTO public.who_global_data VALUES (56380, 5, 3134, 0, 58, 238, 72);
INSERT INTO public.who_global_data VALUES (56381, 1017, 269237, 131, 39232, 238, 44);
INSERT INTO public.who_global_data VALUES (56382, 0, 24, 0, 0, 238, 15);
INSERT INTO public.who_global_data VALUES (56383, 2, 524, 0, 13, 238, 25);
INSERT INTO public.who_global_data VALUES (56384, 0, 0, 0, 0, 238, 179);
INSERT INTO public.who_global_data VALUES (56385, 0, 0, 0, 0, 238, 34);
INSERT INTO public.who_global_data VALUES (56386, 0, 117, 0, 8, 238, 207);
INSERT INTO public.who_global_data VALUES (56387, 1, 1094, 0, 49, 238, 166);
INSERT INTO public.who_global_data VALUES (56388, 1195, 175218, 15, 4778, 238, 126);
INSERT INTO public.who_global_data VALUES (56389, 0, 0, 0, 0, 238, 97);
INSERT INTO public.who_global_data VALUES (56390, 0, 12, 0, 1, 238, 36);
INSERT INTO public.who_global_data VALUES (56391, 0, 0, 0, 0, 238, 125);
INSERT INTO public.who_global_data VALUES (56392, 0, 808, 0, 0, 238, 124);
INSERT INTO public.who_global_data VALUES (56393, 753, 30506, 10, 880, 238, 185);
INSERT INTO public.who_global_data VALUES (56394, 513, 41499, 1, 287, 238, 194);
INSERT INTO public.who_global_data VALUES (56395, 0, 509, 0, 21, 238, 144);
INSERT INTO public.who_global_data VALUES (56396, 21745, 2010391, 947, 113757, 238, 19);
INSERT INTO public.who_global_data VALUES (56397, 0, 72, 0, 6, 238, 217);
INSERT INTO public.who_global_data VALUES (56398, 0, 847, 0, 23, 238, 148);
INSERT INTO public.who_global_data VALUES (56399, 82, 4901, 0, 19, 238, 86);
INSERT INTO public.who_global_data VALUES (56400, 0, 0, 0, 0, 238, 13);
INSERT INTO public.who_global_data VALUES (56401, 76, 2814, 0, 23, 238, 157);
INSERT INTO public.who_global_data VALUES (56402, 0, 332, 0, 0, 238, 8);
INSERT INTO public.who_global_data VALUES (56403, 0, 0, 0, 0, 238, 73);
INSERT INTO public.who_global_data VALUES (56404, 41, 632, 3, 139, 238, 101);
INSERT INTO public.who_global_data VALUES (56405, 69, 1321, 0, 10, 238, 165);
INSERT INTO public.who_global_data VALUES (56406, 11, 343, 0, 4, 238, 14);
INSERT INTO public.who_global_data VALUES (56407, 656, 23632, 20, 450, 239, 193);
INSERT INTO public.who_global_data VALUES (56408, 31, 1416, 2, 36, 239, 113);
INSERT INTO public.who_global_data VALUES (56409, 105, 10589, 9, 741, 239, 143);
INSERT INTO public.who_global_data VALUES (56410, 0, 0, 0, 0, 239, 219);
INSERT INTO public.who_global_data VALUES (56411, 0, 852, 0, 51, 239, 186);
INSERT INTO public.who_global_data VALUES (56412, 5, 118, 1, 5, 239, 52);
INSERT INTO public.who_global_data VALUES (56413, 0, 3, 0, 0, 239, 180);
INSERT INTO public.who_global_data VALUES (56414, 0, 25, 0, 3, 239, 167);
INSERT INTO public.who_global_data VALUES (56415, 1226, 25987, 24, 741, 239, 154);
INSERT INTO public.who_global_data VALUES (56416, 566, 14645, 18, 245, 239, 94);
INSERT INTO public.who_global_data VALUES (56417, 0, 101, 0, 3, 239, 66);
INSERT INTO public.who_global_data VALUES (56418, 18, 7285, 0, 102, 239, 58);
INSERT INTO public.who_global_data VALUES (56419, 28, 16964, 1, 674, 239, 163);
INSERT INTO public.who_global_data VALUES (56420, 352, 8882, 6, 108, 239, 37);
INSERT INTO public.who_global_data VALUES (56421, 0, 103, 0, 11, 239, 142);
INSERT INTO public.who_global_data VALUES (56422, 602, 17269, 4, 36, 239, 83);
INSERT INTO public.who_global_data VALUES (56423, 3187, 78052, 37, 1049, 239, 228);
INSERT INTO public.who_global_data VALUES (56424, 0, 96, 0, 7, 239, 188);
INSERT INTO public.who_global_data VALUES (56425, 750, 51816, 5, 293, 239, 62);
INSERT INTO public.who_global_data VALUES (56426, 95, 60422, 7, 9517, 239, 160);
INSERT INTO public.who_global_data VALUES (56427, 0, 20, 0, 2, 239, 50);
INSERT INTO public.who_global_data VALUES (56428, 51, 390, 1, 5, 239, 33);
INSERT INTO public.who_global_data VALUES (56429, 0, 141, 0, 9, 239, 183);
INSERT INTO public.who_global_data VALUES (56430, 0, 62, 0, 0, 239, 92);
INSERT INTO public.who_global_data VALUES (56431, 637, 15281, 25, 512, 239, 158);
INSERT INTO public.who_global_data VALUES (56432, 0, 2, 0, 0, 239, 67);
INSERT INTO public.who_global_data VALUES (56433, 55, 2831, 0, 160, 239, 57);
INSERT INTO public.who_global_data VALUES (56434, 0, 48, 0, 1, 239, 38);
INSERT INTO public.who_global_data VALUES (56435, 32913, 772416, 1274, 39680, 239, 141);
INSERT INTO public.who_global_data VALUES (56436, 0, 8, 0, 1, 239, 178);
INSERT INTO public.who_global_data VALUES (56437, 0, 141, 0, 2, 239, 108);
INSERT INTO public.who_global_data VALUES (56438, 93, 3086, 1, 168, 239, 39);
INSERT INTO public.who_global_data VALUES (56439, 0, 891, 0, 53, 239, 2);
INSERT INTO public.who_global_data VALUES (56440, 11, 94, 0, 1, 239, 195);
INSERT INTO public.who_global_data VALUES (56441, 41, 657, 1, 6, 239, 107);
INSERT INTO public.who_global_data VALUES (56442, 0, 126, 0, 0, 239, 161);
INSERT INTO public.who_global_data VALUES (56443, 0, 8681, 0, 215, 239, 212);
INSERT INTO public.who_global_data VALUES (56444, 472, 97125, 63, 7960, 239, 181);
INSERT INTO public.who_global_data VALUES (56445, 4, 180, 0, 1, 239, 53);
INSERT INTO public.who_global_data VALUES (56446, 156, 2044, 0, 5, 239, 164);
INSERT INTO public.who_global_data VALUES (56447, 2, 848, 0, 72, 239, 140);
INSERT INTO public.who_global_data VALUES (56448, 5596, 154092, 173, 2648, 239, 20);
INSERT INTO public.who_global_data VALUES (56449, 7, 84659, 0, 4645, 239, 112);
INSERT INTO public.who_global_data VALUES (56450, 1604, 43682, 61, 1433, 239, 111);
INSERT INTO public.who_global_data VALUES (56451, 0, 162, 0, 2, 239, 71);
INSERT INTO public.who_global_data VALUES (56452, 17, 745, 1, 25, 239, 218);
INSERT INTO public.who_global_data VALUES (56453, 0, 0, 0, 0, 239, 43);
INSERT INTO public.who_global_data VALUES (56454, 86, 1461, 1, 12, 239, 49);
INSERT INTO public.who_global_data VALUES (56455, 223, 4404, 0, 41, 239, 1);
INSERT INTO public.who_global_data VALUES (56456, 0, 2249, 0, 106, 239, 48);
INSERT INTO public.who_global_data VALUES (56457, 8, 2219, 1, 84, 239, 232);
INSERT INTO public.who_global_data VALUES (56458, 0, 22, 0, 1, 239, 175);
INSERT INTO public.who_global_data VALUES (56459, 1, 975, 0, 18, 239, 21);
INSERT INTO public.who_global_data VALUES (56460, 62, 9886, 1, 329, 239, 156);
INSERT INTO public.who_global_data VALUES (56461, 0, 0, 0, 0, 239, 95);
INSERT INTO public.who_global_data VALUES (56462, 125, 4514, 1, 97, 239, 177);
INSERT INTO public.who_global_data VALUES (56463, 19, 12035, 0, 593, 239, 210);
INSERT INTO public.who_global_data VALUES (56464, 25, 4398, 3, 37, 239, 120);
INSERT INTO public.who_global_data VALUES (56465, 0, 16, 0, 0, 239, 135);
INSERT INTO public.who_global_data VALUES (56466, 629, 21437, 11, 561, 239, 206);
INSERT INTO public.who_global_data VALUES (56467, 0, 44440, 0, 3720, 239, 189);
INSERT INTO public.who_global_data VALUES (56468, 1442, 39726, 35, 1377, 239, 129);
INSERT INTO public.who_global_data VALUES (56469, 99, 3373, 4, 64, 239, 121);
INSERT INTO public.who_global_data VALUES (56470, 0, 1043, 0, 12, 239, 59);
INSERT INTO public.who_global_data VALUES (56471, 0, 41, 0, 0, 239, 96);
INSERT INTO public.who_global_data VALUES (56472, 7, 1965, 0, 63, 239, 41);
INSERT INTO public.who_global_data VALUES (56473, 51, 449, 0, 3, 239, 216);
INSERT INTO public.who_global_data VALUES (56474, 164, 2670, 5, 40, 239, 236);
INSERT INTO public.who_global_data VALUES (56475, 0, 13, 0, 0, 239, 150);
INSERT INTO public.who_global_data VALUES (56476, 0, 187, 0, 0, 239, 61);
INSERT INTO public.who_global_data VALUES (56477, 0, 18, 0, 0, 239, 7);
INSERT INTO public.who_global_data VALUES (56478, 24, 7064, 1, 325, 239, 169);
INSERT INTO public.who_global_data VALUES (56479, 338, 151503, 27, 29284, 239, 28);
INSERT INTO public.who_global_data VALUES (56480, 52, 917, 0, 2, 239, 85);
INSERT INTO public.who_global_data VALUES (56481, 0, 60, 0, 0, 239, 211);
INSERT INTO public.who_global_data VALUES (56482, 169, 3463, 2, 23, 239, 60);
INSERT INTO public.who_global_data VALUES (56483, 0, 28, 0, 1, 239, 3);
INSERT INTO public.who_global_data VALUES (56484, 9, 837, 0, 13, 239, 11);
INSERT INTO public.who_global_data VALUES (56485, 258, 185674, 8, 8763, 239, 89);
INSERT INTO public.who_global_data VALUES (56486, 157, 10358, 0, 48, 239, 24);
INSERT INTO public.who_global_data VALUES (56487, 0, 176, 0, 0, 239, 162);
INSERT INTO public.who_global_data VALUES (56488, 20, 3088, 0, 183, 239, 100);
INSERT INTO public.who_global_data VALUES (56489, 0, 13, 0, 0, 239, 47);
INSERT INTO public.who_global_data VALUES (56490, 0, 23, 0, 0, 239, 29);
INSERT INTO public.who_global_data VALUES (56491, 0, 164, 0, 14, 239, 40);
INSERT INTO public.who_global_data VALUES (56492, 0, 174, 0, 5, 239, 222);
INSERT INTO public.who_global_data VALUES (56493, 355, 8221, 27, 316, 239, 132);
INSERT INTO public.who_global_data VALUES (56494, 0, 252, 0, 13, 239, 130);
INSERT INTO public.who_global_data VALUES (56495, 81, 4372, 0, 23, 239, 234);
INSERT INTO public.who_global_data VALUES (56496, 0, 1389, 0, 12, 239, 23);
INSERT INTO public.who_global_data VALUES (56497, 0, 156, 0, 12, 239, 192);
INSERT INTO public.who_global_data VALUES (56498, 134, 3796, 2, 58, 239, 69);
INSERT INTO public.who_global_data VALUES (56499, 0, 12, 0, 0, 239, 187);
INSERT INTO public.who_global_data VALUES (56500, 425, 7360, 19, 290, 239, 230);
INSERT INTO public.who_global_data VALUES (56501, 12, 4039, 2, 553, 239, 77);
INSERT INTO public.who_global_data VALUES (56502, 0, 1807, 0, 10, 239, 9);
INSERT INTO public.who_global_data VALUES (56503, 10956, 297535, 396, 8498, 239, 74);
INSERT INTO public.who_global_data VALUES (56504, 979, 35295, 41, 2000, 239, 224);
INSERT INTO public.who_global_data VALUES (56505, 2238, 180176, 78, 8584, 239, 199);
INSERT INTO public.who_global_data VALUES (56506, 1261, 16675, 31, 457, 239, 190);
INSERT INTO public.who_global_data VALUES (56507, 7, 25238, 8, 1703, 239, 12);
INSERT INTO public.who_global_data VALUES (56508, 0, 336, 0, 24, 239, 104);
INSERT INTO public.who_global_data VALUES (56509, 240, 18482, 1, 302, 239, 153);
INSERT INTO public.who_global_data VALUES (56510, 379, 236142, 53, 34167, 239, 91);
INSERT INTO public.who_global_data VALUES (56511, 0, 598, 0, 10, 239, 215);
INSERT INTO public.who_global_data VALUES (56512, 40, 17332, 2, 922, 239, 84);
INSERT INTO public.who_global_data VALUES (56513, 0, 313, 0, 30, 239, 231);
INSERT INTO public.who_global_data VALUES (56514, 21, 836, 0, 9, 239, 196);
INSERT INTO public.who_global_data VALUES (56515, 366, 14238, 3, 70, 239, 105);
INSERT INTO public.who_global_data VALUES (56516, 121, 3215, 3, 92, 239, 122);
INSERT INTO public.who_global_data VALUES (56517, 0, 0, 0, 0, 239, 159);
INSERT INTO public.who_global_data VALUES (56518, 28, 1326, 0, 21, 239, 75);
INSERT INTO public.who_global_data VALUES (56519, 609, 34432, 4, 279, 239, 27);
INSERT INTO public.who_global_data VALUES (56520, 37, 2166, 0, 26, 239, 54);
INSERT INTO public.who_global_data VALUES (56521, 0, 19, 0, 0, 239, 226);
INSERT INTO public.who_global_data VALUES (56522, 2, 1094, 0, 26, 239, 79);
INSERT INTO public.who_global_data VALUES (56523, 14, 1402, 1, 31, 239, 56);
INSERT INTO public.who_global_data VALUES (56524, 0, 4, 0, 0, 239, 117);
INSERT INTO public.who_global_data VALUES (56525, 13, 410, 0, 31, 239, 152);
INSERT INTO public.who_global_data VALUES (56526, 15, 393, 0, 5, 239, 16);
INSERT INTO public.who_global_data VALUES (56527, 0, 83, 0, 1, 239, 10);
INSERT INTO public.who_global_data VALUES (56528, 4, 1751, 1, 75, 239, 201);
INSERT INTO public.who_global_data VALUES (56529, 3, 4052, 0, 110, 239, 174);
INSERT INTO public.who_global_data VALUES (56530, 41, 1203, 0, 10, 239, 119);
INSERT INTO public.who_global_data VALUES (56531, 26, 481, 0, 4, 239, 168);
INSERT INTO public.who_global_data VALUES (56532, 31, 8369, 0, 118, 239, 99);
INSERT INTO public.who_global_data VALUES (56533, 14, 1976, 0, 8, 239, 171);
INSERT INTO public.who_global_data VALUES (56534, 55, 1722, 1, 97, 239, 87);
INSERT INTO public.who_global_data VALUES (56535, 5, 644, 0, 9, 239, 123);
INSERT INTO public.who_global_data VALUES (56536, 0, 0, 0, 0, 239, 151);
INSERT INTO public.who_global_data VALUES (56537, 0, 202, 0, 14, 239, 213);
INSERT INTO public.who_global_data VALUES (56538, 0, 1283, 0, 71, 239, 118);
INSERT INTO public.who_global_data VALUES (56539, 0, 337, 0, 10, 239, 134);
INSERT INTO public.who_global_data VALUES (56540, 34, 2240, 0, 28, 239, 65);
INSERT INTO public.who_global_data VALUES (56541, 4883, 129184, 708, 15357, 239, 102);
INSERT INTO public.who_global_data VALUES (56542, 0, 0, 0, 0, 239, 223);
INSERT INTO public.who_global_data VALUES (56543, 0, 70, 0, 1, 239, 4);
INSERT INTO public.who_global_data VALUES (56544, 0, 194, 0, 0, 239, 146);
INSERT INTO public.who_global_data VALUES (56545, 0, 324, 0, 9, 239, 31);
INSERT INTO public.who_global_data VALUES (56546, 0, 11, 0, 1, 239, 127);
INSERT INTO public.who_global_data VALUES (56547, 29, 8537, 0, 211, 239, 22);
INSERT INTO public.who_global_data VALUES (56548, 17, 489, 0, 2, 239, 115);
INSERT INTO public.who_global_data VALUES (56549, 13, 261, 0, 6, 239, 106);
INSERT INTO public.who_global_data VALUES (56550, 0, 31, 0, 0, 239, 90);
INSERT INTO public.who_global_data VALUES (56551, 0, 0, 0, 0, 239, 70);
INSERT INTO public.who_global_data VALUES (56552, 250, 4614, 0, 15, 239, 46);
INSERT INTO public.who_global_data VALUES (56553, 162, 48006, 4, 6017, 239, 139);
INSERT INTO public.who_global_data VALUES (56554, 0, 21, 0, 0, 239, 42);
INSERT INTO public.who_global_data VALUES (56555, 0, 1154, 0, 22, 239, 80);
INSERT INTO public.who_global_data VALUES (56556, 0, 1655, 0, 55, 239, 203);
INSERT INTO public.who_global_data VALUES (56557, 0, 974, 0, 65, 239, 136);
INSERT INTO public.who_global_data VALUES (56558, 681, 14554, 5, 387, 239, 63);
INSERT INTO public.who_global_data VALUES (56559, 0, 0, 0, 0, 239, 17);
INSERT INTO public.who_global_data VALUES (56560, 0, 30, 0, 2, 239, 172);
INSERT INTO public.who_global_data VALUES (56561, 175, 3542, 5, 169, 239, 109);
INSERT INTO public.who_global_data VALUES (56562, 18, 8594, 3, 242, 239, 200);
INSERT INTO public.who_global_data VALUES (56563, 2, 667, 0, 5, 239, 93);
INSERT INTO public.who_global_data VALUES (56564, 1067, 19954, 5, 89, 239, 5);
INSERT INTO public.who_global_data VALUES (56565, 0, 741, 0, 13, 239, 214);
INSERT INTO public.who_global_data VALUES (56566, 5985, 125521, 107, 2463, 239, 204);
INSERT INTO public.who_global_data VALUES (56567, 0, 0, 0, 0, 239, 198);
INSERT INTO public.who_global_data VALUES (56568, 656, 17889, 10, 413, 239, 173);
INSERT INTO public.who_global_data VALUES (56569, 0, 8, 0, 0, 239, 229);
INSERT INTO public.who_global_data VALUES (56570, 28, 1230, 0, 11, 239, 76);
INSERT INTO public.who_global_data VALUES (56571, 5087, 208823, 165, 5903, 239, 138);
INSERT INTO public.who_global_data VALUES (56572, 443, 24175, 9, 1036, 239, 98);
INSERT INTO public.who_global_data VALUES (56573, 0, 0, 0, 0, 239, 103);
INSERT INTO public.who_global_data VALUES (56574, 444, 28201, 9, 1215, 239, 225);
INSERT INTO public.who_global_data VALUES (56575, 310, 35910, 9, 1504, 239, 131);
INSERT INTO public.who_global_data VALUES (56576, 23, 5352, 1, 144, 239, 235);
INSERT INTO public.who_global_data VALUES (56577, 1476, 75071, 3, 69, 239, 137);
INSERT INTO public.who_global_data VALUES (56578, 56, 12002, 1, 277, 239, 81);
INSERT INTO public.who_global_data VALUES (56579, 406, 10727, 4, 375, 239, 182);
INSERT INTO public.who_global_data VALUES (56580, 1, 487, 0, 1, 239, 145);
INSERT INTO public.who_global_data VALUES (56581, 237, 21182, 9, 1369, 239, 26);
INSERT INTO public.who_global_data VALUES (56582, 8987, 511423, 183, 6715, 239, 170);
INSERT INTO public.who_global_data VALUES (56583, 18, 494, 0, 2, 239, 191);
INSERT INTO public.who_global_data VALUES (56584, 0, 3, 0, 0, 239, 221);
INSERT INTO public.who_global_data VALUES (56585, 0, 6, 0, 0, 239, 64);
INSERT INTO public.who_global_data VALUES (56586, 0, 0, 0, 0, 239, 116);
INSERT INTO public.who_global_data VALUES (56587, 0, 15, 0, 0, 239, 128);
INSERT INTO public.who_global_data VALUES (56588, 0, 19, 0, 0, 239, 6);
INSERT INTO public.who_global_data VALUES (56589, 0, 41, 0, 3, 239, 227);
INSERT INTO public.who_global_data VALUES (56590, 0, 1, 0, 0, 239, 68);
INSERT INTO public.who_global_data VALUES (56591, 0, 27, 0, 0, 239, 184);
INSERT INTO public.who_global_data VALUES (56592, 0, 0, 0, 0, 239, 82);
INSERT INTO public.who_global_data VALUES (56593, 0, 695, 0, 42, 239, 149);
INSERT INTO public.who_global_data VALUES (56594, 0, 388, 0, 10, 239, 197);
INSERT INTO public.who_global_data VALUES (56595, 3733, 116021, 38, 857, 239, 78);
INSERT INTO public.who_global_data VALUES (56596, 119, 4759, 1, 55, 239, 233);
INSERT INTO public.who_global_data VALUES (56597, 71, 12102, 1, 252, 239, 133);
INSERT INTO public.who_global_data VALUES (56598, 0, 11, 0, 0, 239, 35);
INSERT INTO public.who_global_data VALUES (56599, 23, 1085, 0, 50, 239, 114);
INSERT INTO public.who_global_data VALUES (56600, 422, 39387, 0, 25, 239, 237);
INSERT INTO public.who_global_data VALUES (56601, 0, 2, 0, 0, 239, 55);
INSERT INTO public.who_global_data VALUES (56602, 0, 77, 0, 15, 239, 176);
INSERT INTO public.who_global_data VALUES (56603, 8, 1541, 0, 28, 239, 202);
INSERT INTO public.who_global_data VALUES (56604, 2, 1490, 0, 113, 239, 155);
INSERT INTO public.who_global_data VALUES (56605, 0, 0, 0, 0, 239, 32);
INSERT INTO public.who_global_data VALUES (56606, 61, 2513, 0, 85, 239, 220);
INSERT INTO public.who_global_data VALUES (56607, 3147, 58568, 74, 1284, 239, 30);
INSERT INTO public.who_global_data VALUES (56608, 0, 1606, 2, 22, 239, 147);
INSERT INTO public.who_global_data VALUES (56609, 508, 251824, 29, 29469, 239, 208);
INSERT INTO public.who_global_data VALUES (56610, 8, 1877, 0, 11, 239, 45);
INSERT INTO public.who_global_data VALUES (56611, 148, 6730, 12, 413, 239, 110);
INSERT INTO public.who_global_data VALUES (56612, 7, 144, 0, 2, 239, 88);
INSERT INTO public.who_global_data VALUES (56613, 1437, 47730, 39, 5016, 239, 51);
INSERT INTO public.who_global_data VALUES (56614, 25, 31026, 0, 1717, 239, 209);
INSERT INTO public.who_global_data VALUES (56615, 12, 164, 0, 6, 239, 205);
INSERT INTO public.who_global_data VALUES (56616, 71, 4834, 1, 49, 239, 18);
INSERT INTO public.who_global_data VALUES (56617, 4, 3129, 0, 58, 239, 72);
INSERT INTO public.who_global_data VALUES (56618, 1199, 268220, 76, 39101, 239, 44);
INSERT INTO public.who_global_data VALUES (56619, 0, 24, 0, 0, 239, 15);
INSERT INTO public.who_global_data VALUES (56620, 0, 522, 0, 13, 239, 25);
INSERT INTO public.who_global_data VALUES (56621, 0, 0, 0, 0, 239, 179);
INSERT INTO public.who_global_data VALUES (56622, 0, 0, 0, 0, 239, 34);
INSERT INTO public.who_global_data VALUES (56623, 0, 117, 0, 8, 239, 207);
INSERT INTO public.who_global_data VALUES (56624, 6, 1093, 0, 49, 239, 166);
INSERT INTO public.who_global_data VALUES (56625, 987, 174023, 17, 4763, 239, 126);
INSERT INTO public.who_global_data VALUES (56626, 0, 0, 0, 0, 239, 97);
INSERT INTO public.who_global_data VALUES (56627, 0, 12, 0, 1, 239, 36);
INSERT INTO public.who_global_data VALUES (56628, 0, 0, 0, 0, 239, 125);
INSERT INTO public.who_global_data VALUES (56629, 14, 808, 0, 0, 239, 124);
INSERT INTO public.who_global_data VALUES (56630, 683, 29753, 16, 870, 239, 185);
INSERT INTO public.who_global_data VALUES (56631, 479, 40986, 2, 286, 239, 194);
INSERT INTO public.who_global_data VALUES (56632, 0, 509, 0, 21, 239, 144);
INSERT INTO public.who_global_data VALUES (56633, 20315, 1988646, 832, 112810, 239, 19);
INSERT INTO public.who_global_data VALUES (56634, 0, 72, 0, 6, 239, 217);
INSERT INTO public.who_global_data VALUES (56635, 1, 847, 0, 23, 239, 148);
INSERT INTO public.who_global_data VALUES (56636, 124, 4819, 0, 19, 239, 86);
INSERT INTO public.who_global_data VALUES (56637, 0, 0, 0, 0, 239, 13);
INSERT INTO public.who_global_data VALUES (56638, 106, 2738, 0, 23, 239, 157);
INSERT INTO public.who_global_data VALUES (56639, 0, 332, 0, 0, 239, 8);
INSERT INTO public.who_global_data VALUES (56640, 0, 0, 0, 0, 239, 73);
INSERT INTO public.who_global_data VALUES (56641, 31, 591, 7, 136, 239, 101);
INSERT INTO public.who_global_data VALUES (56642, 0, 1252, 0, 10, 239, 165);
INSERT INTO public.who_global_data VALUES (56643, 12, 332, 0, 4, 239, 14);
INSERT INTO public.who_global_data VALUES (56644, 748, 22976, 21, 430, 240, 193);
INSERT INTO public.who_global_data VALUES (56645, 44, 1385, 0, 34, 240, 113);
INSERT INTO public.who_global_data VALUES (56646, 102, 10484, 8, 732, 240, 143);
INSERT INTO public.who_global_data VALUES (56647, 0, 0, 0, 0, 240, 219);
INSERT INTO public.who_global_data VALUES (56648, 0, 852, 0, 51, 240, 186);
INSERT INTO public.who_global_data VALUES (56649, 17, 113, 0, 4, 240, 52);
INSERT INTO public.who_global_data VALUES (56650, 0, 3, 0, 0, 240, 180);
INSERT INTO public.who_global_data VALUES (56651, 0, 25, 0, 3, 240, 167);
INSERT INTO public.who_global_data VALUES (56652, 1141, 24761, 19, 717, 240, 154);
INSERT INTO public.who_global_data VALUES (56653, 428, 14079, 10, 227, 240, 94);
INSERT INTO public.who_global_data VALUES (56654, 0, 101, 0, 3, 240, 66);
INSERT INTO public.who_global_data VALUES (56655, 0, 7267, 0, 102, 240, 58);
INSERT INTO public.who_global_data VALUES (56656, 34, 16936, 1, 673, 240, 163);
INSERT INTO public.who_global_data VALUES (56657, 339, 8530, 4, 102, 240, 37);
INSERT INTO public.who_global_data VALUES (56658, 0, 103, 0, 11, 240, 142);
INSERT INTO public.who_global_data VALUES (56659, 468, 16667, 3, 32, 240, 83);
INSERT INTO public.who_global_data VALUES (56660, 3190, 74865, 37, 1012, 240, 228);
INSERT INTO public.who_global_data VALUES (56661, 4, 96, 0, 7, 240, 188);
INSERT INTO public.who_global_data VALUES (56662, 801, 51066, 6, 288, 240, 62);
INSERT INTO public.who_global_data VALUES (56663, 119, 60327, 12, 9510, 240, 160);
INSERT INTO public.who_global_data VALUES (56664, 1, 20, 0, 2, 240, 50);
INSERT INTO public.who_global_data VALUES (56665, 0, 339, 0, 4, 240, 33);
INSERT INTO public.who_global_data VALUES (56666, 0, 141, 0, 9, 240, 183);
INSERT INTO public.who_global_data VALUES (56667, 3, 62, 0, 0, 240, 92);
INSERT INTO public.who_global_data VALUES (56668, 695, 14644, 12, 487, 240, 158);
INSERT INTO public.who_global_data VALUES (56669, 0, 2, 0, 0, 240, 67);
INSERT INTO public.who_global_data VALUES (56670, 49, 2776, 1, 160, 240, 57);
INSERT INTO public.who_global_data VALUES (56671, 6, 48, 0, 1, 240, 38);
INSERT INTO public.who_global_data VALUES (56672, 32091, 739503, 1272, 38406, 240, 141);
INSERT INTO public.who_global_data VALUES (56673, 0, 8, 0, 1, 240, 178);
INSERT INTO public.who_global_data VALUES (56674, 0, 141, 0, 2, 240, 108);
INSERT INTO public.who_global_data VALUES (56675, 104, 2993, 0, 167, 240, 39);
INSERT INTO public.who_global_data VALUES (56676, 0, 891, 0, 53, 240, 2);
INSERT INTO public.who_global_data VALUES (56677, 0, 83, 0, 1, 240, 195);
INSERT INTO public.who_global_data VALUES (56678, 31, 616, 0, 5, 240, 107);
INSERT INTO public.who_global_data VALUES (56679, 0, 126, 0, 0, 240, 161);
INSERT INTO public.who_global_data VALUES (56680, 369, 8681, 0, 215, 240, 212);
INSERT INTO public.who_global_data VALUES (56681, 409, 96653, 62, 7897, 240, 181);
INSERT INTO public.who_global_data VALUES (56682, 5, 176, 0, 1, 240, 53);
INSERT INTO public.who_global_data VALUES (56683, 38, 1888, 0, 5, 240, 164);
INSERT INTO public.who_global_data VALUES (56684, 2, 846, 1, 72, 240, 140);
INSERT INTO public.who_global_data VALUES (56685, 5737, 148496, 192, 2475, 240, 20);
INSERT INTO public.who_global_data VALUES (56686, 11, 84652, 0, 4645, 240, 112);
INSERT INTO public.who_global_data VALUES (56687, 1359, 42078, 64, 1372, 240, 111);
INSERT INTO public.who_global_data VALUES (56688, 65, 162, 0, 2, 240, 71);
INSERT INTO public.who_global_data VALUES (56689, 10, 728, 0, 24, 240, 218);
INSERT INTO public.who_global_data VALUES (56690, 0, 0, 0, 0, 240, 43);
INSERT INTO public.who_global_data VALUES (56691, 33, 1375, 1, 11, 240, 49);
INSERT INTO public.who_global_data VALUES (56692, 186, 4181, 3, 41, 240, 1);
INSERT INTO public.who_global_data VALUES (56693, 2, 2249, 0, 106, 240, 48);
INSERT INTO public.who_global_data VALUES (56694, 6, 2211, 0, 83, 240, 232);
INSERT INTO public.who_global_data VALUES (56695, 1, 22, 0, 1, 240, 175);
INSERT INTO public.who_global_data VALUES (56696, 2, 974, 0, 18, 240, 21);
INSERT INTO public.who_global_data VALUES (56697, 73, 9824, 0, 328, 240, 156);
INSERT INTO public.who_global_data VALUES (56698, 0, 0, 0, 0, 240, 95);
INSERT INTO public.who_global_data VALUES (56699, 131, 4389, 6, 96, 240, 177);
INSERT INTO public.who_global_data VALUES (56700, 15, 12016, 0, 593, 240, 210);
INSERT INTO public.who_global_data VALUES (56701, 42, 4373, 0, 34, 240, 120);
INSERT INTO public.who_global_data VALUES (56702, 0, 16, 0, 0, 240, 135);
INSERT INTO public.who_global_data VALUES (56703, 393, 20808, 6, 550, 240, 206);
INSERT INTO public.who_global_data VALUES (56704, 523, 44440, 30, 3720, 240, 189);
INSERT INTO public.who_global_data VALUES (56705, 1455, 38284, 36, 1342, 240, 129);
INSERT INTO public.who_global_data VALUES (56706, 83, 3274, 2, 60, 240, 121);
INSERT INTO public.who_global_data VALUES (56707, 0, 1043, 0, 12, 240, 59);
INSERT INTO public.who_global_data VALUES (56708, 0, 41, 0, 0, 240, 96);
INSERT INTO public.who_global_data VALUES (56709, 11, 1958, 0, 63, 240, 41);
INSERT INTO public.who_global_data VALUES (56710, 27, 398, 0, 3, 240, 216);
INSERT INTO public.who_global_data VALUES (56711, 170, 2506, 3, 35, 240, 236);
INSERT INTO public.who_global_data VALUES (56712, 0, 13, 0, 0, 240, 150);
INSERT INTO public.who_global_data VALUES (56713, 0, 187, 0, 0, 240, 61);
INSERT INTO public.who_global_data VALUES (56714, 0, 18, 0, 0, 240, 7);
INSERT INTO public.who_global_data VALUES (56715, 15, 7040, 0, 324, 240, 169);
INSERT INTO public.who_global_data VALUES (56716, 417, 151165, 23, 29257, 240, 28);
INSERT INTO public.who_global_data VALUES (56717, 92, 865, 0, 2, 240, 85);
INSERT INTO public.who_global_data VALUES (56718, 0, 60, 0, 0, 240, 211);
INSERT INTO public.who_global_data VALUES (56719, 0, 3294, 0, 21, 240, 60);
INSERT INTO public.who_global_data VALUES (56720, 0, 28, 0, 1, 240, 3);
INSERT INTO public.who_global_data VALUES (56721, 6, 828, 0, 13, 240, 11);
INSERT INTO public.who_global_data VALUES (56722, 555, 185416, 26, 8755, 240, 89);
INSERT INTO public.who_global_data VALUES (56723, 0, 10201, 0, 48, 240, 24);
INSERT INTO public.who_global_data VALUES (56724, 0, 176, 0, 0, 240, 162);
INSERT INTO public.who_global_data VALUES (56725, 10, 3068, 0, 183, 240, 100);
INSERT INTO public.who_global_data VALUES (56726, 0, 13, 0, 0, 240, 47);
INSERT INTO public.who_global_data VALUES (56727, 0, 23, 0, 0, 240, 29);
INSERT INTO public.who_global_data VALUES (56728, 0, 164, 0, 14, 240, 40);
INSERT INTO public.who_global_data VALUES (56729, 2, 174, 0, 5, 240, 222);
INSERT INTO public.who_global_data VALUES (56730, 364, 7866, 22, 289, 240, 132);
INSERT INTO public.who_global_data VALUES (56731, 0, 252, 0, 13, 240, 130);
INSERT INTO public.who_global_data VALUES (56732, 33, 4291, 0, 23, 240, 234);
INSERT INTO public.who_global_data VALUES (56733, 0, 1389, 0, 12, 240, 23);
INSERT INTO public.who_global_data VALUES (56734, 2, 156, 0, 12, 240, 192);
INSERT INTO public.who_global_data VALUES (56735, 124, 3662, 2, 56, 240, 69);
INSERT INTO public.who_global_data VALUES (56736, 0, 12, 0, 0, 240, 187);
INSERT INTO public.who_global_data VALUES (56737, 485, 6935, 9, 271, 240, 230);
INSERT INTO public.who_global_data VALUES (56738, 10, 4027, 1, 551, 240, 77);
INSERT INTO public.who_global_data VALUES (56739, 0, 1807, 0, 10, 240, 9);
INSERT INTO public.who_global_data VALUES (56740, 9996, 286579, 357, 8102, 240, 74);
INSERT INTO public.who_global_data VALUES (56741, 1240, 34316, 36, 1959, 240, 224);
INSERT INTO public.who_global_data VALUES (56742, 2011, 177938, 81, 8506, 240, 199);
INSERT INTO public.who_global_data VALUES (56743, 1146, 15414, 34, 426, 240, 190);
INSERT INTO public.who_global_data VALUES (56744, 16, 25231, 4, 1695, 240, 12);
INSERT INTO public.who_global_data VALUES (56745, 0, 336, 0, 24, 240, 104);
INSERT INTO public.who_global_data VALUES (56746, 173, 18242, 1, 301, 240, 153);
INSERT INTO public.who_global_data VALUES (56747, 202, 235763, 71, 34114, 240, 91);
INSERT INTO public.who_global_data VALUES (56748, 0, 598, 0, 10, 240, 215);
INSERT INTO public.who_global_data VALUES (56749, 41, 17292, 1, 920, 240, 84);
INSERT INTO public.who_global_data VALUES (56750, 0, 313, 0, 30, 240, 231);
INSERT INTO public.who_global_data VALUES (56751, 13, 815, 0, 9, 240, 196);
INSERT INTO public.who_global_data VALUES (56752, 313, 13872, 0, 67, 240, 105);
INSERT INTO public.who_global_data VALUES (56753, 105, 3094, 1, 89, 240, 122);
INSERT INTO public.who_global_data VALUES (56754, 0, 0, 0, 0, 240, 159);
INSERT INTO public.who_global_data VALUES (56755, 35, 1298, 0, 21, 240, 75);
INSERT INTO public.who_global_data VALUES (56756, 683, 33823, 2, 275, 240, 27);
INSERT INTO public.who_global_data VALUES (56757, 36, 2129, 0, 26, 240, 54);
INSERT INTO public.who_global_data VALUES (56758, 0, 19, 0, 0, 240, 226);
INSERT INTO public.who_global_data VALUES (56759, 3, 1092, 0, 26, 240, 79);
INSERT INTO public.who_global_data VALUES (56760, 20, 1388, 0, 30, 240, 56);
INSERT INTO public.who_global_data VALUES (56761, 0, 4, 0, 0, 240, 117);
INSERT INTO public.who_global_data VALUES (56762, 14, 397, 0, 31, 240, 152);
INSERT INTO public.who_global_data VALUES (56763, 19, 378, 0, 5, 240, 16);
INSERT INTO public.who_global_data VALUES (56764, 0, 83, 0, 1, 240, 10);
INSERT INTO public.who_global_data VALUES (56765, 19, 1747, 0, 74, 240, 201);
INSERT INTO public.who_global_data VALUES (56766, 3, 4049, 0, 110, 240, 174);
INSERT INTO public.who_global_data VALUES (56767, 24, 1162, 1, 10, 240, 119);
INSERT INTO public.who_global_data VALUES (56768, 0, 455, 0, 4, 240, 168);
INSERT INTO public.who_global_data VALUES (56769, 2, 8338, 1, 118, 240, 99);
INSERT INTO public.who_global_data VALUES (56770, 20, 1962, 0, 8, 240, 171);
INSERT INTO public.who_global_data VALUES (56771, 81, 1667, 2, 96, 240, 87);
INSERT INTO public.who_global_data VALUES (56772, 5, 639, 0, 9, 240, 123);
INSERT INTO public.who_global_data VALUES (56773, 0, 0, 0, 0, 240, 151);
INSERT INTO public.who_global_data VALUES (56774, 0, 202, 0, 14, 240, 213);
INSERT INTO public.who_global_data VALUES (56775, 121, 1283, 8, 71, 240, 118);
INSERT INTO public.who_global_data VALUES (56776, 0, 337, 0, 10, 240, 134);
INSERT INTO public.who_global_data VALUES (56777, 31, 2206, 0, 28, 240, 65);
INSERT INTO public.who_global_data VALUES (56778, 4199, 124301, 596, 14649, 240, 102);
INSERT INTO public.who_global_data VALUES (56779, 0, 0, 0, 0, 240, 223);
INSERT INTO public.who_global_data VALUES (56780, 0, 70, 0, 1, 240, 4);
INSERT INTO public.who_global_data VALUES (56781, 0, 194, 0, 0, 240, 146);
INSERT INTO public.who_global_data VALUES (56782, 0, 324, 0, 9, 240, 31);
INSERT INTO public.who_global_data VALUES (56783, 0, 11, 0, 1, 240, 127);
INSERT INTO public.who_global_data VALUES (56784, 71, 8508, 1, 211, 240, 22);
INSERT INTO public.who_global_data VALUES (56785, 19, 472, 0, 2, 240, 115);
INSERT INTO public.who_global_data VALUES (56786, 2, 248, 0, 6, 240, 106);
INSERT INTO public.who_global_data VALUES (56787, 0, 31, 0, 0, 240, 90);
INSERT INTO public.who_global_data VALUES (56788, 0, 0, 0, 0, 240, 70);
INSERT INTO public.who_global_data VALUES (56789, 279, 4364, 0, 15, 240, 46);
INSERT INTO public.who_global_data VALUES (56790, 181, 47844, 14, 6013, 240, 139);
INSERT INTO public.who_global_data VALUES (56791, 0, 21, 0, 0, 240, 42);
INSERT INTO public.who_global_data VALUES (56792, 0, 1154, 0, 22, 240, 80);
INSERT INTO public.who_global_data VALUES (56793, 346, 1655, 9, 55, 240, 203);
INSERT INTO public.who_global_data VALUES (56794, 0, 974, 0, 65, 240, 136);
INSERT INTO public.who_global_data VALUES (56795, 409, 13873, 17, 382, 240, 63);
INSERT INTO public.who_global_data VALUES (56796, 0, 0, 0, 0, 240, 17);
INSERT INTO public.who_global_data VALUES (56797, 0, 30, 0, 2, 240, 172);
INSERT INTO public.who_global_data VALUES (56798, 125, 3367, 7, 164, 240, 109);
INSERT INTO public.who_global_data VALUES (56799, 13, 8576, 0, 239, 240, 200);
INSERT INTO public.who_global_data VALUES (56800, 4, 665, 0, 5, 240, 93);
INSERT INTO public.who_global_data VALUES (56801, 689, 18887, 1, 84, 240, 5);
INSERT INTO public.who_global_data VALUES (56802, 0, 741, 0, 13, 240, 214);
INSERT INTO public.who_global_data VALUES (56803, 5834, 119536, 101, 2356, 240, 204);
INSERT INTO public.who_global_data VALUES (56804, 0, 0, 0, 0, 240, 198);
INSERT INTO public.who_global_data VALUES (56805, 379, 17233, 5, 403, 240, 173);
INSERT INTO public.who_global_data VALUES (56806, 0, 8, 0, 0, 240, 229);
INSERT INTO public.who_global_data VALUES (56807, 15, 1202, 0, 11, 240, 76);
INSERT INTO public.who_global_data VALUES (56808, 4040, 203736, 167, 5738, 240, 138);
INSERT INTO public.who_global_data VALUES (56809, 740, 23732, 10, 1027, 240, 98);
INSERT INTO public.who_global_data VALUES (56810, 0, 0, 0, 0, 240, 103);
INSERT INTO public.who_global_data VALUES (56811, 197, 27757, 23, 1206, 240, 225);
INSERT INTO public.who_global_data VALUES (56812, 294, 35600, 3, 1495, 240, 131);
INSERT INTO public.who_global_data VALUES (56813, 144, 5329, 1, 143, 240, 235);
INSERT INTO public.who_global_data VALUES (56814, 1716, 73595, 4, 66, 240, 137);
INSERT INTO public.who_global_data VALUES (56815, 45, 11946, 0, 276, 240, 81);
INSERT INTO public.who_global_data VALUES (56816, 296, 10321, 4, 371, 240, 182);
INSERT INTO public.who_global_data VALUES (56817, 5, 486, 0, 1, 240, 145);
INSERT INTO public.who_global_data VALUES (56818, 196, 20945, 15, 1360, 240, 26);
INSERT INTO public.who_global_data VALUES (56819, 8779, 502436, 174, 6532, 240, 170);
INSERT INTO public.who_global_data VALUES (56820, 13, 476, 0, 2, 240, 191);
INSERT INTO public.who_global_data VALUES (56821, 0, 3, 0, 0, 240, 221);
INSERT INTO public.who_global_data VALUES (56822, 0, 6, 0, 0, 240, 64);
INSERT INTO public.who_global_data VALUES (56823, 0, 0, 0, 0, 240, 116);
INSERT INTO public.who_global_data VALUES (56824, 0, 15, 0, 0, 240, 128);
INSERT INTO public.who_global_data VALUES (56825, 0, 19, 0, 0, 240, 6);
INSERT INTO public.who_global_data VALUES (56826, 0, 41, 0, 3, 240, 227);
INSERT INTO public.who_global_data VALUES (56827, 0, 1, 0, 0, 240, 68);
INSERT INTO public.who_global_data VALUES (56828, 0, 27, 0, 0, 240, 184);
INSERT INTO public.who_global_data VALUES (56829, 0, 0, 0, 0, 240, 82);
INSERT INTO public.who_global_data VALUES (56830, 0, 695, 0, 42, 240, 149);
INSERT INTO public.who_global_data VALUES (56831, 93, 388, 0, 10, 240, 197);
INSERT INTO public.who_global_data VALUES (56832, 3717, 112288, 36, 819, 240, 78);
INSERT INTO public.who_global_data VALUES (56833, 124, 4640, 2, 54, 240, 233);
INSERT INTO public.who_global_data VALUES (56834, 66, 12031, 1, 251, 240, 133);
INSERT INTO public.who_global_data VALUES (56835, 0, 11, 0, 0, 240, 35);
INSERT INTO public.who_global_data VALUES (56836, 37, 1062, 0, 50, 240, 114);
INSERT INTO public.who_global_data VALUES (56837, 451, 38965, 0, 25, 240, 237);
INSERT INTO public.who_global_data VALUES (56838, 0, 2, 0, 0, 240, 55);
INSERT INTO public.who_global_data VALUES (56839, 0, 77, 0, 15, 240, 176);
INSERT INTO public.who_global_data VALUES (56840, 2, 1533, 0, 28, 240, 202);
INSERT INTO public.who_global_data VALUES (56841, 0, 1488, 0, 113, 240, 155);
INSERT INTO public.who_global_data VALUES (56842, 0, 0, 0, 0, 240, 32);
INSERT INTO public.who_global_data VALUES (56843, 36, 2452, 0, 85, 240, 220);
INSERT INTO public.who_global_data VALUES (56844, 2430, 55421, 48, 1210, 240, 30);
INSERT INTO public.who_global_data VALUES (56845, 0, 1606, 0, 20, 240, 147);
INSERT INTO public.who_global_data VALUES (56846, 485, 251316, 13, 29440, 240, 208);
INSERT INTO public.who_global_data VALUES (56847, 10, 1869, 0, 11, 240, 45);
INSERT INTO public.who_global_data VALUES (56848, 155, 6582, 12, 401, 240, 110);
INSERT INTO public.who_global_data VALUES (56849, 4, 137, 0, 2, 240, 88);
INSERT INTO public.who_global_data VALUES (56850, 937, 46293, 33, 4977, 240, 51);
INSERT INTO public.who_global_data VALUES (56851, 24, 31001, 1, 1717, 240, 209);
INSERT INTO public.who_global_data VALUES (56852, 6, 152, 0, 6, 240, 205);
INSERT INTO public.who_global_data VALUES (56853, 73, 4763, 0, 48, 240, 18);
INSERT INTO public.who_global_data VALUES (56854, 0, 3125, 0, 58, 240, 72);
INSERT INTO public.who_global_data VALUES (56855, 1158, 267021, 164, 39025, 240, 44);
INSERT INTO public.who_global_data VALUES (56856, 0, 24, 0, 0, 240, 15);
INSERT INTO public.who_global_data VALUES (56857, 25, 522, 0, 13, 240, 25);
INSERT INTO public.who_global_data VALUES (56858, 0, 0, 0, 0, 240, 179);
INSERT INTO public.who_global_data VALUES (56859, 0, 0, 0, 0, 240, 34);
INSERT INTO public.who_global_data VALUES (56860, 0, 117, 0, 8, 240, 207);
INSERT INTO public.who_global_data VALUES (56861, 0, 1087, 0, 49, 240, 166);
INSERT INTO public.who_global_data VALUES (56862, 922, 173036, 17, 4746, 240, 126);
INSERT INTO public.who_global_data VALUES (56863, 0, 0, 0, 0, 240, 97);
INSERT INTO public.who_global_data VALUES (56864, 0, 12, 0, 1, 240, 36);
INSERT INTO public.who_global_data VALUES (56865, 0, 0, 0, 0, 240, 125);
INSERT INTO public.who_global_data VALUES (56866, 19, 794, 0, 0, 240, 124);
INSERT INTO public.who_global_data VALUES (56867, 689, 29070, 21, 854, 240, 185);
INSERT INTO public.who_global_data VALUES (56868, 603, 40507, 1, 284, 240, 194);
INSERT INTO public.who_global_data VALUES (56869, 0, 509, 0, 21, 240, 144);
INSERT INTO public.who_global_data VALUES (56870, 17235, 1968331, 1208, 111978, 240, 19);
INSERT INTO public.who_global_data VALUES (56871, 1, 72, 0, 6, 240, 217);
INSERT INTO public.who_global_data VALUES (56872, 1, 846, 0, 23, 240, 148);
INSERT INTO public.who_global_data VALUES (56873, 148, 4695, 1, 19, 240, 86);
INSERT INTO public.who_global_data VALUES (56874, 0, 0, 0, 0, 240, 13);
INSERT INTO public.who_global_data VALUES (56875, 159, 2632, 1, 23, 240, 157);
INSERT INTO public.who_global_data VALUES (56876, 0, 332, 0, 0, 240, 8);
INSERT INTO public.who_global_data VALUES (56877, 0, 0, 0, 0, 240, 73);
INSERT INTO public.who_global_data VALUES (56878, 36, 560, 2, 129, 240, 101);
INSERT INTO public.who_global_data VALUES (56879, 52, 1252, 0, 10, 240, 165);
INSERT INTO public.who_global_data VALUES (56880, 6, 320, 0, 4, 240, 14);
INSERT INTO public.who_global_data VALUES (56881, 920, 22228, 29, 409, 241, 193);
INSERT INTO public.who_global_data VALUES (56882, 42, 1341, 0, 34, 241, 113);
INSERT INTO public.who_global_data VALUES (56883, 117, 10382, 9, 724, 241, 143);
INSERT INTO public.who_global_data VALUES (56884, 0, 0, 0, 0, 241, 219);
INSERT INTO public.who_global_data VALUES (56885, 0, 852, 0, 51, 241, 186);
INSERT INTO public.who_global_data VALUES (56886, 4, 96, 0, 4, 241, 52);
INSERT INTO public.who_global_data VALUES (56887, 0, 3, 0, 0, 241, 180);
INSERT INTO public.who_global_data VALUES (56888, 0, 25, 0, 3, 241, 167);
INSERT INTO public.who_global_data VALUES (56889, 826, 23620, 28, 698, 241, 154);
INSERT INTO public.who_global_data VALUES (56890, 350, 13651, 6, 217, 241, 94);
INSERT INTO public.who_global_data VALUES (56891, 0, 101, 0, 3, 241, 66);
INSERT INTO public.who_global_data VALUES (56892, 2, 7267, 0, 102, 241, 58);
INSERT INTO public.who_global_data VALUES (56893, 13, 16902, 0, 672, 241, 163);
INSERT INTO public.who_global_data VALUES (56894, 315, 8191, 5, 98, 241, 37);
INSERT INTO public.who_global_data VALUES (56895, 0, 103, 0, 11, 241, 142);
INSERT INTO public.who_global_data VALUES (56896, 783, 16199, 2, 29, 241, 83);
INSERT INTO public.who_global_data VALUES (56897, 3171, 71675, 45, 975, 241, 228);
INSERT INTO public.who_global_data VALUES (56898, 0, 92, 0, 7, 241, 188);
INSERT INTO public.who_global_data VALUES (56899, 812, 50265, 6, 282, 241, 62);
INSERT INTO public.who_global_data VALUES (56900, 145, 60208, 12, 9498, 241, 160);
INSERT INTO public.who_global_data VALUES (56901, 0, 19, 0, 2, 241, 50);
INSERT INTO public.who_global_data VALUES (56902, 34, 339, 0, 4, 241, 33);
INSERT INTO public.who_global_data VALUES (56903, 0, 141, 0, 9, 241, 183);
INSERT INTO public.who_global_data VALUES (56904, 0, 59, 0, 0, 241, 92);
INSERT INTO public.who_global_data VALUES (56905, 306, 13949, 10, 475, 241, 158);
INSERT INTO public.who_global_data VALUES (56906, 0, 2, 0, 0, 241, 67);
INSERT INTO public.who_global_data VALUES (56907, 24, 2727, 0, 159, 241, 57);
INSERT INTO public.who_global_data VALUES (56908, 0, 42, 0, 1, 241, 38);
INSERT INTO public.who_global_data VALUES (56909, 15654, 707412, 679, 37134, 241, 141);
INSERT INTO public.who_global_data VALUES (56910, 0, 8, 0, 1, 241, 178);
INSERT INTO public.who_global_data VALUES (56911, 0, 141, 0, 2, 241, 108);
INSERT INTO public.who_global_data VALUES (56912, 79, 2889, 3, 167, 241, 39);
INSERT INTO public.who_global_data VALUES (56913, 1, 891, 0, 53, 241, 2);
INSERT INTO public.who_global_data VALUES (56914, 0, 83, 0, 1, 241, 195);
INSERT INTO public.who_global_data VALUES (56915, 18, 585, 0, 5, 241, 107);
INSERT INTO public.who_global_data VALUES (56916, 0, 126, 0, 0, 241, 161);
INSERT INTO public.who_global_data VALUES (56917, 252, 8312, 0, 215, 241, 212);
INSERT INTO public.who_global_data VALUES (56918, 545, 96244, 35, 7835, 241, 181);
INSERT INTO public.who_global_data VALUES (56919, 7, 171, 0, 1, 241, 53);
INSERT INTO public.who_global_data VALUES (56920, 0, 1850, 0, 5, 241, 164);
INSERT INTO public.who_global_data VALUES (56921, 5, 844, 1, 71, 241, 140);
INSERT INTO public.who_global_data VALUES (56922, 3913, 142759, 19, 2283, 241, 20);
INSERT INTO public.who_global_data VALUES (56923, 3, 84641, 0, 4645, 241, 112);
INSERT INTO public.who_global_data VALUES (56924, 1483, 40719, 49, 1308, 241, 111);
INSERT INTO public.who_global_data VALUES (56925, 0, 97, 0, 2, 241, 71);
INSERT INTO public.who_global_data VALUES (56926, 35, 718, 4, 24, 241, 218);
INSERT INTO public.who_global_data VALUES (56927, 0, 0, 0, 0, 241, 43);
INSERT INTO public.who_global_data VALUES (56928, 24, 1342, 0, 10, 241, 49);
INSERT INTO public.who_global_data VALUES (56929, 114, 3995, 0, 38, 241, 1);
INSERT INTO public.who_global_data VALUES (56930, 0, 2247, 2, 106, 241, 48);
INSERT INTO public.who_global_data VALUES (56931, 5, 2205, 0, 83, 241, 232);
INSERT INTO public.who_global_data VALUES (56932, 0, 21, 0, 1, 241, 175);
INSERT INTO public.who_global_data VALUES (56933, 2, 972, 0, 18, 241, 21);
INSERT INTO public.who_global_data VALUES (56934, 54, 9751, 0, 328, 241, 156);
INSERT INTO public.who_global_data VALUES (56935, 0, 0, 0, 0, 241, 95);
INSERT INTO public.who_global_data VALUES (56936, 153, 4258, 3, 90, 241, 177);
INSERT INTO public.who_global_data VALUES (56937, 39, 12001, 0, 593, 241, 210);
INSERT INTO public.who_global_data VALUES (56938, 53, 4331, 3, 34, 241, 120);
INSERT INTO public.who_global_data VALUES (56939, 0, 16, 0, 0, 241, 135);
INSERT INTO public.who_global_data VALUES (56940, 289, 20415, 5, 544, 241, 206);
INSERT INTO public.who_global_data VALUES (56941, 539, 43917, 48, 3690, 241, 189);
INSERT INTO public.who_global_data VALUES (56942, 1385, 36829, 35, 1306, 241, 129);
INSERT INTO public.who_global_data VALUES (56943, 87, 3191, 3, 58, 241, 121);
INSERT INTO public.who_global_data VALUES (56944, 0, 1043, 0, 12, 241, 59);
INSERT INTO public.who_global_data VALUES (56945, 0, 41, 0, 0, 241, 96);
INSERT INTO public.who_global_data VALUES (56946, 7, 1947, 0, 63, 241, 41);
INSERT INTO public.who_global_data VALUES (56947, 31, 371, 0, 3, 241, 216);
INSERT INTO public.who_global_data VALUES (56948, 180, 2336, 5, 32, 241, 236);
INSERT INTO public.who_global_data VALUES (56949, 0, 13, 0, 0, 241, 150);
INSERT INTO public.who_global_data VALUES (56950, 0, 187, 0, 0, 241, 61);
INSERT INTO public.who_global_data VALUES (56951, 0, 18, 0, 0, 241, 7);
INSERT INTO public.who_global_data VALUES (56952, 24, 7025, 1, 324, 241, 169);
INSERT INTO public.who_global_data VALUES (56953, 335, 150748, 85, 29234, 241, 28);
INSERT INTO public.who_global_data VALUES (56954, 44, 773, 0, 2, 241, 85);
INSERT INTO public.who_global_data VALUES (56955, 0, 60, 0, 0, 241, 211);
INSERT INTO public.who_global_data VALUES (56956, 193, 3294, 0, 21, 241, 60);
INSERT INTO public.who_global_data VALUES (56957, 0, 28, 0, 1, 241, 3);
INSERT INTO public.who_global_data VALUES (56958, 4, 822, 0, 13, 241, 11);
INSERT INTO public.who_global_data VALUES (56959, 318, 184861, 18, 8729, 241, 89);
INSERT INTO public.who_global_data VALUES (56960, 291, 10201, 0, 48, 241, 24);
INSERT INTO public.who_global_data VALUES (56961, 0, 176, 0, 0, 241, 162);
INSERT INTO public.who_global_data VALUES (56962, 9, 3058, 1, 183, 241, 100);
INSERT INTO public.who_global_data VALUES (56963, 0, 13, 0, 0, 241, 47);
INSERT INTO public.who_global_data VALUES (56964, 0, 23, 0, 0, 241, 29);
INSERT INTO public.who_global_data VALUES (56965, 0, 164, 0, 14, 241, 40);
INSERT INTO public.who_global_data VALUES (56966, 1, 172, 0, 5, 241, 222);
INSERT INTO public.who_global_data VALUES (56967, 447, 7502, 15, 267, 241, 132);
INSERT INTO public.who_global_data VALUES (56968, 0, 252, 0, 13, 241, 130);
INSERT INTO public.who_global_data VALUES (56969, 42, 4258, 0, 23, 241, 234);
INSERT INTO public.who_global_data VALUES (56970, 0, 1389, 0, 12, 241, 23);
INSERT INTO public.who_global_data VALUES (56971, 0, 154, 0, 12, 241, 192);
INSERT INTO public.who_global_data VALUES (56972, 204, 3538, 3, 54, 241, 69);
INSERT INTO public.who_global_data VALUES (56973, 0, 12, 0, 0, 241, 187);
INSERT INTO public.who_global_data VALUES (56974, 123, 6450, 4, 262, 241, 230);
INSERT INTO public.who_global_data VALUES (56975, 3, 4017, 2, 550, 241, 77);
INSERT INTO public.who_global_data VALUES (56976, 0, 1807, 0, 10, 241, 9);
INSERT INTO public.who_global_data VALUES (56977, 9985, 276583, 279, 7745, 241, 74);
INSERT INTO public.who_global_data VALUES (56978, 1043, 33076, 40, 1923, 241, 224);
INSERT INTO public.who_global_data VALUES (56979, 2095, 175927, 74, 8425, 241, 199);
INSERT INTO public.who_global_data VALUES (56980, 787, 14268, 22, 392, 241, 190);
INSERT INTO public.who_global_data VALUES (56981, 8, 25215, 8, 1691, 241, 12);
INSERT INTO public.who_global_data VALUES (56982, 0, 336, 0, 24, 241, 104);
INSERT INTO public.who_global_data VALUES (56983, 179, 18069, 0, 300, 241, 153);
INSERT INTO public.who_global_data VALUES (56984, 283, 235561, 79, 34043, 241, 91);
INSERT INTO public.who_global_data VALUES (56985, 0, 598, 0, 10, 241, 215);
INSERT INTO public.who_global_data VALUES (56986, 41, 17251, 3, 919, 241, 84);
INSERT INTO public.who_global_data VALUES (56987, 2, 313, 0, 30, 241, 231);
INSERT INTO public.who_global_data VALUES (56988, 10, 802, 0, 9, 241, 196);
INSERT INTO public.who_global_data VALUES (56989, 240, 13559, 6, 67, 241, 105);
INSERT INTO public.who_global_data VALUES (56990, 127, 2989, 3, 88, 241, 122);
INSERT INTO public.who_global_data VALUES (56991, 0, 0, 0, 0, 241, 159);
INSERT INTO public.who_global_data VALUES (56992, 0, 1263, 0, 21, 241, 75);
INSERT INTO public.who_global_data VALUES (56993, 630, 33140, 4, 273, 241, 27);
INSERT INTO public.who_global_data VALUES (56994, 38, 2093, 2, 26, 241, 54);
INSERT INTO public.who_global_data VALUES (56995, 0, 19, 0, 0, 241, 226);
INSERT INTO public.who_global_data VALUES (56996, 1, 1089, 0, 26, 241, 79);
INSERT INTO public.who_global_data VALUES (56997, 18, 1368, 0, 30, 241, 56);
INSERT INTO public.who_global_data VALUES (56998, 0, 4, 0, 0, 241, 117);
INSERT INTO public.who_global_data VALUES (56999, 13, 383, 1, 31, 241, 152);
INSERT INTO public.who_global_data VALUES (57000, 27, 359, 0, 5, 241, 16);
INSERT INTO public.who_global_data VALUES (57001, 0, 83, 0, 1, 241, 10);
INSERT INTO public.who_global_data VALUES (57002, 6, 1728, 3, 74, 241, 201);
INSERT INTO public.who_global_data VALUES (57003, 6, 4046, 0, 110, 241, 174);
INSERT INTO public.who_global_data VALUES (57004, 44, 1138, 0, 9, 241, 119);
INSERT INTO public.who_global_data VALUES (57005, 12, 455, 0, 4, 241, 168);
INSERT INTO public.who_global_data VALUES (57006, 7, 8336, 0, 117, 241, 99);
INSERT INTO public.who_global_data VALUES (57007, 26, 1942, 0, 8, 241, 171);
INSERT INTO public.who_global_data VALUES (57008, 39, 1586, 2, 94, 241, 87);
INSERT INTO public.who_global_data VALUES (57009, 3, 634, 0, 9, 241, 123);
INSERT INTO public.who_global_data VALUES (57010, 0, 0, 0, 0, 241, 151);
INSERT INTO public.who_global_data VALUES (57011, 0, 202, 0, 14, 241, 213);
INSERT INTO public.who_global_data VALUES (57012, 113, 1162, 20, 63, 241, 118);
INSERT INTO public.who_global_data VALUES (57013, 0, 337, 0, 10, 241, 134);
INSERT INTO public.who_global_data VALUES (57014, 24, 2175, 2, 28, 241, 65);
INSERT INTO public.who_global_data VALUES (57015, 2999, 120102, 354, 14053, 241, 102);
INSERT INTO public.who_global_data VALUES (57016, 0, 0, 0, 0, 241, 223);
INSERT INTO public.who_global_data VALUES (57017, 0, 70, 0, 1, 241, 4);
INSERT INTO public.who_global_data VALUES (57018, 0, 194, 0, 0, 241, 146);
INSERT INTO public.who_global_data VALUES (57019, 0, 324, 0, 9, 241, 31);
INSERT INTO public.who_global_data VALUES (57020, 0, 11, 0, 1, 241, 127);
INSERT INTO public.who_global_data VALUES (57021, 135, 8437, 2, 210, 241, 22);
INSERT INTO public.who_global_data VALUES (57022, 20, 453, 0, 2, 241, 115);
INSERT INTO public.who_global_data VALUES (57023, 2, 246, 0, 6, 241, 106);
INSERT INTO public.who_global_data VALUES (57024, 0, 31, 0, 0, 241, 90);
INSERT INTO public.who_global_data VALUES (57025, 0, 0, 0, 0, 241, 70);
INSERT INTO public.who_global_data VALUES (57026, 323, 4085, 1, 15, 241, 46);
INSERT INTO public.who_global_data VALUES (57027, 164, 47663, 13, 5999, 241, 139);
INSERT INTO public.who_global_data VALUES (57028, 1, 21, 0, 0, 241, 42);
INSERT INTO public.who_global_data VALUES (57029, 0, 1154, 0, 22, 241, 80);
INSERT INTO public.who_global_data VALUES (57030, 0, 1309, 0, 46, 241, 203);
INSERT INTO public.who_global_data VALUES (57031, 1, 974, 0, 65, 241, 136);
INSERT INTO public.who_global_data VALUES (57032, 663, 13464, 4, 365, 241, 63);
INSERT INTO public.who_global_data VALUES (57033, 0, 0, 0, 0, 241, 17);
INSERT INTO public.who_global_data VALUES (57034, 2, 30, 0, 2, 241, 172);
INSERT INTO public.who_global_data VALUES (57035, 87, 3242, 1, 157, 241, 109);
INSERT INTO public.who_global_data VALUES (57036, 16, 8563, 0, 239, 241, 200);
INSERT INTO public.who_global_data VALUES (57037, 9, 661, 0, 5, 241, 93);
INSERT INTO public.who_global_data VALUES (57038, 712, 18198, 2, 83, 241, 5);
INSERT INTO public.who_global_data VALUES (57039, 0, 741, 0, 13, 241, 214);
INSERT INTO public.who_global_data VALUES (57040, 5385, 113702, 83, 2255, 241, 204);
INSERT INTO public.who_global_data VALUES (57041, 0, 0, 0, 0, 241, 198);
INSERT INTO public.who_global_data VALUES (57042, 429, 16854, 5, 398, 241, 173);
INSERT INTO public.who_global_data VALUES (57043, 0, 8, 0, 0, 241, 229);
INSERT INTO public.who_global_data VALUES (57044, 42, 1187, 0, 11, 241, 76);
INSERT INTO public.who_global_data VALUES (57045, 3181, 199696, 106, 5571, 241, 138);
INSERT INTO public.who_global_data VALUES (57046, 518, 22992, 6, 1017, 241, 98);
INSERT INTO public.who_global_data VALUES (57047, 0, 0, 0, 0, 241, 103);
INSERT INTO public.who_global_data VALUES (57048, 400, 27560, 17, 1183, 241, 225);
INSERT INTO public.who_global_data VALUES (57049, 421, 35306, 7, 1492, 241, 131);
INSERT INTO public.who_global_data VALUES (57050, 139, 5185, 0, 142, 241, 235);
INSERT INTO public.who_global_data VALUES (57051, 1721, 71879, 5, 62, 241, 137);
INSERT INTO public.who_global_data VALUES (57052, 50, 11901, 2, 276, 241, 81);
INSERT INTO public.who_global_data VALUES (57053, 218, 10025, 8, 367, 241, 182);
INSERT INTO public.who_global_data VALUES (57054, 0, 481, 0, 1, 241, 145);
INSERT INTO public.who_global_data VALUES (57055, 145, 20749, 11, 1345, 241, 26);
INSERT INTO public.who_global_data VALUES (57056, 8404, 493657, 216, 6358, 241, 170);
INSERT INTO public.who_global_data VALUES (57057, 12, 463, 0, 2, 241, 191);
INSERT INTO public.who_global_data VALUES (57058, 0, 3, 0, 0, 241, 221);
INSERT INTO public.who_global_data VALUES (57059, 0, 6, 0, 0, 241, 64);
INSERT INTO public.who_global_data VALUES (57060, 0, 0, 0, 0, 241, 116);
INSERT INTO public.who_global_data VALUES (57061, 0, 15, 0, 0, 241, 128);
INSERT INTO public.who_global_data VALUES (57062, 0, 19, 0, 0, 241, 6);
INSERT INTO public.who_global_data VALUES (57063, 0, 41, 0, 3, 241, 227);
INSERT INTO public.who_global_data VALUES (57064, 0, 1, 0, 0, 241, 68);
INSERT INTO public.who_global_data VALUES (57065, 0, 27, 0, 0, 241, 184);
INSERT INTO public.who_global_data VALUES (57066, 0, 0, 0, 0, 241, 82);
INSERT INTO public.who_global_data VALUES (57067, 0, 695, 0, 42, 241, 149);
INSERT INTO public.who_global_data VALUES (57068, 0, 295, 0, 10, 241, 197);
INSERT INTO public.who_global_data VALUES (57069, 3288, 108571, 37, 783, 241, 78);
INSERT INTO public.who_global_data VALUES (57070, 86, 4516, 3, 52, 241, 233);
INSERT INTO public.who_global_data VALUES (57071, 69, 11965, 0, 250, 241, 133);
INSERT INTO public.who_global_data VALUES (57072, 0, 11, 0, 0, 241, 35);
INSERT INTO public.who_global_data VALUES (57073, 24, 1025, 1, 50, 241, 114);
INSERT INTO public.who_global_data VALUES (57074, 218, 38514, 0, 25, 241, 237);
INSERT INTO public.who_global_data VALUES (57075, 0, 2, 0, 0, 241, 55);
INSERT INTO public.who_global_data VALUES (57076, 0, 77, 0, 15, 241, 176);
INSERT INTO public.who_global_data VALUES (57077, 1, 1531, 0, 28, 241, 202);
INSERT INTO public.who_global_data VALUES (57078, 2, 1488, 0, 113, 241, 155);
INSERT INTO public.who_global_data VALUES (57079, 0, 0, 0, 0, 241, 32);
INSERT INTO public.who_global_data VALUES (57080, 48, 2416, 1, 85, 241, 220);
INSERT INTO public.who_global_data VALUES (57081, 2112, 52991, 82, 1162, 241, 30);
INSERT INTO public.who_global_data VALUES (57082, 2, 1606, 1, 20, 241, 147);
INSERT INTO public.who_global_data VALUES (57083, 379, 250831, 29, 29427, 241, 208);
INSERT INTO public.who_global_data VALUES (57084, 2, 1859, 0, 11, 241, 45);
INSERT INTO public.who_global_data VALUES (57085, 185, 6427, 17, 389, 241, 110);
INSERT INTO public.who_global_data VALUES (57086, 5, 133, 0, 2, 241, 88);
INSERT INTO public.who_global_data VALUES (57087, 677, 45356, 38, 4944, 241, 51);
INSERT INTO public.who_global_data VALUES (57088, 11, 30977, 0, 1716, 241, 209);
INSERT INTO public.who_global_data VALUES (57089, 2, 146, 0, 6, 241, 205);
INSERT INTO public.who_global_data VALUES (57090, 81, 4690, 0, 48, 241, 18);
INSERT INTO public.who_global_data VALUES (57091, 4, 3125, 0, 58, 241, 72);
INSERT INTO public.who_global_data VALUES (57092, 1099, 265863, 195, 38861, 241, 44);
INSERT INTO public.who_global_data VALUES (57093, 0, 24, 0, 0, 241, 15);
INSERT INTO public.who_global_data VALUES (57094, 0, 497, 0, 13, 241, 25);
INSERT INTO public.who_global_data VALUES (57095, 0, 0, 0, 0, 241, 179);
INSERT INTO public.who_global_data VALUES (57096, 0, 0, 0, 0, 241, 34);
INSERT INTO public.who_global_data VALUES (57097, 0, 117, 0, 8, 241, 207);
INSERT INTO public.who_global_data VALUES (57098, 0, 1087, 0, 49, 241, 166);
INSERT INTO public.who_global_data VALUES (57099, 993, 172114, 18, 4729, 241, 126);
INSERT INTO public.who_global_data VALUES (57100, 0, 0, 0, 0, 241, 97);
INSERT INTO public.who_global_data VALUES (57101, 0, 12, 0, 1, 241, 36);
INSERT INTO public.who_global_data VALUES (57102, 0, 0, 0, 0, 241, 125);
INSERT INTO public.who_global_data VALUES (57103, 0, 775, 0, 0, 241, 124);
INSERT INTO public.who_global_data VALUES (57104, 525, 28381, 23, 833, 241, 185);
INSERT INTO public.who_global_data VALUES (57105, 528, 39904, 2, 283, 241, 194);
INSERT INTO public.who_global_data VALUES (57106, 0, 509, 0, 21, 241, 144);
INSERT INTO public.who_global_data VALUES (57107, 17536, 1951096, 550, 110770, 241, 19);
INSERT INTO public.who_global_data VALUES (57108, 0, 71, 0, 6, 241, 217);
INSERT INTO public.who_global_data VALUES (57109, 0, 845, 0, 23, 241, 148);
INSERT INTO public.who_global_data VALUES (57110, 99, 4547, 0, 18, 241, 86);
INSERT INTO public.who_global_data VALUES (57111, 0, 0, 0, 0, 241, 13);
INSERT INTO public.who_global_data VALUES (57112, 96, 2473, 0, 22, 241, 157);
INSERT INTO public.who_global_data VALUES (57113, 0, 332, 0, 0, 241, 8);
INSERT INTO public.who_global_data VALUES (57114, 0, 0, 0, 0, 241, 73);
INSERT INTO public.who_global_data VALUES (57115, 28, 524, 15, 127, 241, 101);
INSERT INTO public.who_global_data VALUES (57116, 0, 1200, 0, 10, 241, 165);
INSERT INTO public.who_global_data VALUES (57117, 27, 314, 0, 4, 241, 14);
INSERT INTO public.who_global_data VALUES (57118, 305, 21308, 7, 380, 242, 193);
INSERT INTO public.who_global_data VALUES (57119, 36, 1299, 0, 34, 242, 113);
INSERT INTO public.who_global_data VALUES (57120, 111, 10265, 8, 715, 242, 143);
INSERT INTO public.who_global_data VALUES (57121, 0, 0, 0, 0, 242, 219);
INSERT INTO public.who_global_data VALUES (57122, 0, 852, 0, 51, 242, 186);
INSERT INTO public.who_global_data VALUES (57123, 1, 92, 0, 4, 242, 52);
INSERT INTO public.who_global_data VALUES (57124, 0, 3, 0, 0, 242, 180);
INSERT INTO public.who_global_data VALUES (57125, 0, 25, 0, 3, 242, 167);
INSERT INTO public.who_global_data VALUES (57126, 774, 22794, 14, 670, 242, 154);
INSERT INTO public.who_global_data VALUES (57127, 195, 13301, 11, 211, 242, 94);
INSERT INTO public.who_global_data VALUES (57128, 0, 101, 0, 3, 242, 66);
INSERT INTO public.who_global_data VALUES (57129, 5, 7265, 0, 102, 242, 58);
INSERT INTO public.who_global_data VALUES (57130, 21, 16889, 0, 672, 242, 163);
INSERT INTO public.who_global_data VALUES (57131, 323, 7876, 5, 93, 242, 37);
INSERT INTO public.who_global_data VALUES (57132, 0, 103, 0, 11, 242, 142);
INSERT INTO public.who_global_data VALUES (57133, 654, 15416, 1, 27, 242, 83);
INSERT INTO public.who_global_data VALUES (57134, 2735, 68504, 42, 930, 242, 228);
INSERT INTO public.who_global_data VALUES (57135, 0, 92, 0, 7, 242, 188);
INSERT INTO public.who_global_data VALUES (57136, 823, 49453, 7, 276, 242, 62);
INSERT INTO public.who_global_data VALUES (57137, 152, 60063, 9, 9486, 242, 160);
INSERT INTO public.who_global_data VALUES (57138, 0, 19, 0, 2, 242, 50);
INSERT INTO public.who_global_data VALUES (57139, 37, 305, 0, 4, 242, 33);
INSERT INTO public.who_global_data VALUES (57140, 0, 141, 0, 9, 242, 183);
INSERT INTO public.who_global_data VALUES (57141, 0, 59, 0, 0, 242, 92);
INSERT INTO public.who_global_data VALUES (57142, 285, 13643, 11, 465, 242, 158);
INSERT INTO public.who_global_data VALUES (57143, 0, 2, 0, 0, 242, 67);
INSERT INTO public.who_global_data VALUES (57144, 30, 2703, 0, 159, 242, 57);
INSERT INTO public.who_global_data VALUES (57145, 2, 42, 0, 1, 242, 38);
INSERT INTO public.who_global_data VALUES (57146, 18912, 691758, 525, 36455, 242, 141);
INSERT INTO public.who_global_data VALUES (57147, 0, 8, 0, 1, 242, 178);
INSERT INTO public.who_global_data VALUES (57148, 0, 141, 0, 2, 242, 108);
INSERT INTO public.who_global_data VALUES (57149, 83, 2810, 4, 164, 242, 39);
INSERT INTO public.who_global_data VALUES (57150, 2, 890, 0, 53, 242, 2);
INSERT INTO public.who_global_data VALUES (57151, 0, 83, 0, 1, 242, 195);
INSERT INTO public.who_global_data VALUES (57152, 13, 567, 0, 5, 242, 107);
INSERT INTO public.who_global_data VALUES (57153, 0, 126, 0, 0, 242, 161);
INSERT INTO public.who_global_data VALUES (57154, 200, 8060, 0, 215, 242, 212);
INSERT INTO public.who_global_data VALUES (57155, 642, 95699, 27, 7800, 242, 181);
INSERT INTO public.who_global_data VALUES (57156, 0, 164, 0, 1, 242, 53);
INSERT INTO public.who_global_data VALUES (57157, 216, 1850, 0, 5, 242, 164);
INSERT INTO public.who_global_data VALUES (57158, 2, 839, 1, 70, 242, 140);
INSERT INTO public.who_global_data VALUES (57159, 4696, 138846, 627, 2264, 242, 20);
INSERT INTO public.who_global_data VALUES (57160, 4, 84638, 0, 4645, 242, 112);
INSERT INTO public.who_global_data VALUES (57161, 1209, 39236, 54, 1259, 242, 111);
INSERT INTO public.who_global_data VALUES (57162, 0, 97, 0, 2, 242, 71);
INSERT INTO public.who_global_data VALUES (57163, 0, 683, -2, 20, 242, 218);
INSERT INTO public.who_global_data VALUES (57164, 0, 0, 0, 0, 242, 43);
INSERT INTO public.who_global_data VALUES (57165, 55, 1318, 0, 10, 242, 49);
INSERT INTO public.who_global_data VALUES (57166, 142, 3881, 2, 38, 242, 1);
INSERT INTO public.who_global_data VALUES (57167, 0, 2247, 0, 104, 242, 48);
INSERT INTO public.who_global_data VALUES (57168, 9, 2200, 0, 83, 242, 232);
INSERT INTO public.who_global_data VALUES (57169, 0, 21, 0, 1, 242, 175);
INSERT INTO public.who_global_data VALUES (57170, 6, 970, 0, 18, 242, 21);
INSERT INTO public.who_global_data VALUES (57171, 69, 9697, 1, 328, 242, 156);
INSERT INTO public.who_global_data VALUES (57172, 0, 0, 0, 0, 242, 95);
INSERT INTO public.who_global_data VALUES (57173, 90, 4105, 3, 87, 242, 177);
INSERT INTO public.who_global_data VALUES (57174, 14, 11962, 4, 593, 242, 210);
INSERT INTO public.who_global_data VALUES (57175, 71, 4278, 3, 31, 242, 120);
INSERT INTO public.who_global_data VALUES (57176, 0, 16, 0, 0, 242, 135);
INSERT INTO public.who_global_data VALUES (57177, 526, 20126, 1, 539, 242, 206);
INSERT INTO public.who_global_data VALUES (57178, 258, 43378, 21, 3642, 242, 189);
INSERT INTO public.who_global_data VALUES (57179, 1365, 35444, 34, 1271, 242, 129);
INSERT INTO public.who_global_data VALUES (57180, 89, 3104, 0, 55, 242, 121);
INSERT INTO public.who_global_data VALUES (57181, 0, 1043, 0, 12, 242, 59);
INSERT INTO public.who_global_data VALUES (57182, 0, 41, 0, 0, 242, 96);
INSERT INTO public.who_global_data VALUES (57183, 1, 1940, 0, 63, 242, 41);
INSERT INTO public.who_global_data VALUES (57184, 7, 340, 0, 3, 242, 216);
INSERT INTO public.who_global_data VALUES (57185, 136, 2156, 0, 27, 242, 236);
INSERT INTO public.who_global_data VALUES (57186, 0, 13, 0, 0, 242, 150);
INSERT INTO public.who_global_data VALUES (57187, 0, 187, 0, 0, 242, 61);
INSERT INTO public.who_global_data VALUES (57188, 0, 18, 0, 0, 242, 7);
INSERT INTO public.who_global_data VALUES (57189, 20, 7001, 0, 323, 242, 169);
INSERT INTO public.who_global_data VALUES (57190, 98, 150413, 52, 29149, 242, 28);
INSERT INTO public.who_global_data VALUES (57191, 40, 729, 1, 2, 242, 85);
INSERT INTO public.who_global_data VALUES (57192, 0, 60, 0, 0, 242, 211);
INSERT INTO public.who_global_data VALUES (57193, 0, 3101, 0, 21, 242, 60);
INSERT INTO public.who_global_data VALUES (57194, 2, 28, 0, 1, 242, 3);
INSERT INTO public.who_global_data VALUES (57195, 8, 818, 0, 13, 242, 11);
INSERT INTO public.who_global_data VALUES (57196, 350, 184543, 37, 8711, 242, 89);
INSERT INTO public.who_global_data VALUES (57197, 272, 9910, 4, 48, 242, 24);
INSERT INTO public.who_global_data VALUES (57198, 1, 176, 0, 0, 242, 162);
INSERT INTO public.who_global_data VALUES (57199, 52, 3049, 2, 182, 242, 100);
INSERT INTO public.who_global_data VALUES (57200, 0, 13, 0, 0, 242, 47);
INSERT INTO public.who_global_data VALUES (57201, 0, 23, 0, 0, 242, 29);
INSERT INTO public.who_global_data VALUES (57202, 0, 164, 0, 14, 242, 40);
INSERT INTO public.who_global_data VALUES (57203, 0, 171, 0, 5, 242, 222);
INSERT INTO public.who_global_data VALUES (57204, 263, 7055, 22, 252, 242, 132);
INSERT INTO public.who_global_data VALUES (57205, 0, 252, 0, 13, 242, 130);
INSERT INTO public.who_global_data VALUES (57206, 51, 4216, 0, 23, 242, 234);
INSERT INTO public.who_global_data VALUES (57207, 21, 1389, 0, 12, 242, 23);
INSERT INTO public.who_global_data VALUES (57208, 0, 154, 0, 12, 242, 192);
INSERT INTO public.who_global_data VALUES (57209, 262, 3334, 1, 51, 242, 69);
INSERT INTO public.who_global_data VALUES (57210, 0, 12, 0, 0, 242, 187);
INSERT INTO public.who_global_data VALUES (57211, 172, 6327, 8, 258, 242, 230);
INSERT INTO public.who_global_data VALUES (57212, 44, 4014, 6, 548, 242, 77);
INSERT INTO public.who_global_data VALUES (57213, 0, 1807, 0, 10, 242, 9);
INSERT INTO public.who_global_data VALUES (57214, 9987, 266598, 331, 7466, 242, 74);
INSERT INTO public.who_global_data VALUES (57215, 847, 32033, 32, 1883, 242, 224);
INSERT INTO public.who_global_data VALUES (57216, 2043, 173832, 70, 8351, 242, 199);
INSERT INTO public.who_global_data VALUES (57217, 1115, 13481, 24, 370, 242, 190);
INSERT INTO public.who_global_data VALUES (57218, 6, 25207, 4, 1683, 242, 12);
INSERT INTO public.who_global_data VALUES (57219, 0, 336, 0, 24, 242, 104);
INSERT INTO public.who_global_data VALUES (57220, 140, 17890, 2, 300, 242, 153);
INSERT INTO public.who_global_data VALUES (57221, 280, 235278, 65, 33964, 242, 91);
INSERT INTO public.who_global_data VALUES (57222, 2, 598, 0, 10, 242, 215);
INSERT INTO public.who_global_data VALUES (57223, 36, 17210, 0, 916, 242, 84);
INSERT INTO public.who_global_data VALUES (57224, 0, 311, 0, 30, 242, 231);
INSERT INTO public.who_global_data VALUES (57225, 23, 792, 0, 9, 242, 196);
INSERT INTO public.who_global_data VALUES (57226, 245, 13319, 3, 61, 242, 105);
INSERT INTO public.who_global_data VALUES (57227, 95, 2862, 1, 85, 242, 122);
INSERT INTO public.who_global_data VALUES (57228, 0, 0, 0, 0, 242, 159);
INSERT INTO public.who_global_data VALUES (57229, 72, 1263, 0, 21, 242, 75);
INSERT INTO public.who_global_data VALUES (57230, 662, 32510, 5, 269, 242, 27);
INSERT INTO public.who_global_data VALUES (57231, 23, 2055, 1, 24, 242, 54);
INSERT INTO public.who_global_data VALUES (57232, 0, 19, 0, 0, 242, 226);
INSERT INTO public.who_global_data VALUES (57233, 0, 1088, 1, 26, 242, 79);
INSERT INTO public.who_global_data VALUES (57234, 19, 1350, 0, 30, 242, 56);
INSERT INTO public.who_global_data VALUES (57235, 0, 4, 0, 0, 242, 117);
INSERT INTO public.who_global_data VALUES (57236, 11, 370, 0, 30, 242, 152);
INSERT INTO public.who_global_data VALUES (57237, 62, 332, 0, 5, 242, 16);
INSERT INTO public.who_global_data VALUES (57238, 0, 83, 0, 1, 242, 10);
INSERT INTO public.who_global_data VALUES (57239, 6, 1722, 0, 71, 242, 201);
INSERT INTO public.who_global_data VALUES (57240, 1, 4040, 0, 110, 242, 174);
INSERT INTO public.who_global_data VALUES (57241, 42, 1094, 0, 9, 242, 119);
INSERT INTO public.who_global_data VALUES (57242, 5, 443, 0, 4, 242, 168);
INSERT INTO public.who_global_data VALUES (57243, 7, 8329, 0, 117, 242, 99);
INSERT INTO public.who_global_data VALUES (57244, 13, 1916, 0, 8, 242, 171);
INSERT INTO public.who_global_data VALUES (57245, 14, 1547, 0, 92, 242, 87);
INSERT INTO public.who_global_data VALUES (57246, 2, 631, 0, 9, 242, 123);
INSERT INTO public.who_global_data VALUES (57247, 0, 0, 0, 0, 242, 151);
INSERT INTO public.who_global_data VALUES (57248, 0, 202, 0, 14, 242, 213);
INSERT INTO public.who_global_data VALUES (57249, 102, 1049, 0, 43, 242, 118);
INSERT INTO public.who_global_data VALUES (57250, 0, 337, 0, 10, 242, 134);
INSERT INTO public.who_global_data VALUES (57251, 72, 2151, 1, 26, 242, 65);
INSERT INTO public.who_global_data VALUES (57252, 3484, 117103, 188, 13699, 242, 102);
INSERT INTO public.who_global_data VALUES (57253, 0, 0, 0, 0, 242, 223);
INSERT INTO public.who_global_data VALUES (57254, 0, 70, 0, 1, 242, 4);
INSERT INTO public.who_global_data VALUES (57255, 1, 194, 0, 0, 242, 146);
INSERT INTO public.who_global_data VALUES (57256, 0, 324, 0, 9, 242, 31);
INSERT INTO public.who_global_data VALUES (57257, 0, 11, 0, 1, 242, 127);
INSERT INTO public.who_global_data VALUES (57258, 78, 8302, 0, 208, 242, 22);
INSERT INTO public.who_global_data VALUES (57259, 9, 433, 0, 2, 242, 115);
INSERT INTO public.who_global_data VALUES (57260, 2, 244, 0, 6, 242, 106);
INSERT INTO public.who_global_data VALUES (57261, 2, 31, 0, 0, 242, 90);
INSERT INTO public.who_global_data VALUES (57262, 0, 0, 0, 0, 242, 70);
INSERT INTO public.who_global_data VALUES (57263, 314, 3762, 1, 14, 242, 46);
INSERT INTO public.who_global_data VALUES (57264, 166, 47499, 3, 5986, 242, 139);
INSERT INTO public.who_global_data VALUES (57265, 0, 20, 0, 0, 242, 42);
INSERT INTO public.who_global_data VALUES (57266, 0, 1154, 0, 22, 242, 80);
INSERT INTO public.who_global_data VALUES (57267, 0, 1309, 0, 46, 242, 203);
INSERT INTO public.who_global_data VALUES (57268, 0, 973, 0, 65, 242, 136);
INSERT INTO public.who_global_data VALUES (57269, 315, 12801, 7, 361, 242, 63);
INSERT INTO public.who_global_data VALUES (57270, 0, 0, 0, 0, 242, 17);
INSERT INTO public.who_global_data VALUES (57271, 1, 28, 0, 2, 242, 172);
INSERT INTO public.who_global_data VALUES (57272, 127, 3155, 3, 156, 242, 109);
INSERT INTO public.who_global_data VALUES (57273, 43, 8547, 1, 239, 242, 200);
INSERT INTO public.who_global_data VALUES (57274, 9, 652, 0, 5, 242, 93);
INSERT INTO public.who_global_data VALUES (57275, 604, 17486, 6, 81, 242, 5);
INSERT INTO public.who_global_data VALUES (57276, 0, 741, 0, 13, 242, 214);
INSERT INTO public.who_global_data VALUES (57277, 4646, 108317, 105, 2172, 242, 204);
INSERT INTO public.who_global_data VALUES (57278, 0, 0, 0, 0, 242, 198);
INSERT INTO public.who_global_data VALUES (57279, 421, 16425, 7, 393, 242, 173);
INSERT INTO public.who_global_data VALUES (57280, 0, 8, 0, 0, 242, 229);
INSERT INTO public.who_global_data VALUES (57281, 10, 1145, 0, 11, 242, 76);
INSERT INTO public.who_global_data VALUES (57282, 4757, 196515, 164, 5465, 242, 138);
INSERT INTO public.who_global_data VALUES (57283, 579, 22474, 8, 1011, 242, 98);
INSERT INTO public.who_global_data VALUES (57284, 0, 0, 0, 0, 242, 103);
INSERT INTO public.who_global_data VALUES (57285, 599, 27160, 9, 1166, 242, 225);
INSERT INTO public.who_global_data VALUES (57286, 392, 34885, 6, 1485, 242, 131);
INSERT INTO public.who_global_data VALUES (57287, 61, 5046, 0, 142, 242, 235);
INSERT INTO public.who_global_data VALUES (57288, 1368, 70158, 3, 57, 242, 137);
INSERT INTO public.who_global_data VALUES (57289, 38, 11851, 1, 274, 242, 81);
INSERT INTO public.who_global_data VALUES (57290, 107, 9807, 13, 359, 242, 182);
INSERT INTO public.who_global_data VALUES (57291, 1, 481, 0, 1, 242, 145);
INSERT INTO public.who_global_data VALUES (57292, 125, 20604, 8, 1334, 242, 26);
INSERT INTO public.who_global_data VALUES (57293, 8595, 485253, 171, 6142, 242, 170);
INSERT INTO public.who_global_data VALUES (57294, 12, 451, 0, 2, 242, 191);
INSERT INTO public.who_global_data VALUES (57295, 0, 3, 0, 0, 242, 221);
INSERT INTO public.who_global_data VALUES (57296, 0, 6, 0, 0, 242, 64);
INSERT INTO public.who_global_data VALUES (57297, 0, 0, 0, 0, 242, 116);
INSERT INTO public.who_global_data VALUES (57298, 0, 15, 0, 0, 242, 128);
INSERT INTO public.who_global_data VALUES (57299, 0, 19, 0, 0, 242, 6);
INSERT INTO public.who_global_data VALUES (57300, 0, 41, 0, 3, 242, 227);
INSERT INTO public.who_global_data VALUES (57301, 0, 1, 0, 0, 242, 68);
INSERT INTO public.who_global_data VALUES (57302, 1, 27, 0, 0, 242, 184);
INSERT INTO public.who_global_data VALUES (57303, 0, 0, 0, 0, 242, 82);
INSERT INTO public.who_global_data VALUES (57304, 0, 695, 0, 42, 242, 149);
INSERT INTO public.who_global_data VALUES (57305, 0, 295, 0, 10, 242, 197);
INSERT INTO public.who_global_data VALUES (57306, 3369, 105283, 34, 746, 242, 78);
INSERT INTO public.who_global_data VALUES (57307, 102, 4430, 0, 49, 242, 233);
INSERT INTO public.who_global_data VALUES (57308, 73, 11896, 1, 250, 242, 133);
INSERT INTO public.who_global_data VALUES (57309, 0, 11, 0, 0, 242, 35);
INSERT INTO public.who_global_data VALUES (57310, 32, 1001, 1, 49, 242, 114);
INSERT INTO public.who_global_data VALUES (57311, 386, 38296, 0, 25, 242, 237);
INSERT INTO public.who_global_data VALUES (57312, 0, 2, 0, 0, 242, 55);
INSERT INTO public.who_global_data VALUES (57313, 0, 77, 0, 15, 242, 176);
INSERT INTO public.who_global_data VALUES (57314, 2, 1530, 0, 28, 242, 202);
INSERT INTO public.who_global_data VALUES (57315, 1, 1486, 0, 113, 242, 155);
INSERT INTO public.who_global_data VALUES (57316, 0, 0, 0, 0, 242, 32);
INSERT INTO public.who_global_data VALUES (57317, 34, 2368, 1, 84, 242, 220);
INSERT INTO public.who_global_data VALUES (57318, 2594, 50879, 82, 1080, 242, 30);
INSERT INTO public.who_global_data VALUES (57319, 287, 1604, 5, 19, 242, 147);
INSERT INTO public.who_global_data VALUES (57320, 153, 250452, 20, 29398, 242, 208);
INSERT INTO public.who_global_data VALUES (57321, 22, 1857, 0, 11, 242, 45);
INSERT INTO public.who_global_data VALUES (57322, 161, 6242, 13, 372, 242, 110);
INSERT INTO public.who_global_data VALUES (57323, 27, 128, 1, 2, 242, 88);
INSERT INTO public.who_global_data VALUES (57324, 462, 44679, 33, 4906, 242, 51);
INSERT INTO public.who_global_data VALUES (57325, 25, 30966, 1, 1716, 242, 209);
INSERT INTO public.who_global_data VALUES (57326, 3, 144, 0, 6, 242, 205);
INSERT INTO public.who_global_data VALUES (57327, 80, 4609, 0, 48, 242, 18);
INSERT INTO public.who_global_data VALUES (57328, 2, 3121, 0, 58, 242, 72);
INSERT INTO public.who_global_data VALUES (57329, 721, 264764, 47, 38666, 242, 44);
INSERT INTO public.who_global_data VALUES (57330, 0, 24, 0, 0, 242, 15);
INSERT INTO public.who_global_data VALUES (57331, 2, 497, 0, 13, 242, 25);
INSERT INTO public.who_global_data VALUES (57332, 0, 0, 0, 0, 242, 179);
INSERT INTO public.who_global_data VALUES (57333, 0, 0, 0, 0, 242, 34);
INSERT INTO public.who_global_data VALUES (57334, 0, 117, 0, 8, 242, 207);
INSERT INTO public.who_global_data VALUES (57335, 0, 1087, 0, 49, 242, 166);
INSERT INTO public.who_global_data VALUES (57336, 989, 171121, 19, 4711, 242, 126);
INSERT INTO public.who_global_data VALUES (57337, 0, 0, 0, 0, 242, 97);
INSERT INTO public.who_global_data VALUES (57338, 0, 12, 0, 1, 242, 36);
INSERT INTO public.who_global_data VALUES (57339, 0, 0, 0, 0, 242, 125);
INSERT INTO public.who_global_data VALUES (57340, 30, 775, 0, 0, 242, 124);
INSERT INTO public.who_global_data VALUES (57341, 394, 27856, 13, 810, 242, 185);
INSERT INTO public.who_global_data VALUES (57342, 568, 39376, 5, 281, 242, 194);
INSERT INTO public.who_global_data VALUES (57343, 0, 509, 0, 21, 242, 144);
INSERT INTO public.who_global_data VALUES (57344, 17848, 1933560, 474, 110220, 242, 19);
INSERT INTO public.who_global_data VALUES (57345, 0, 71, 0, 6, 242, 217);
INSERT INTO public.who_global_data VALUES (57346, 0, 845, 0, 23, 242, 148);
INSERT INTO public.who_global_data VALUES (57347, 96, 4448, 1, 18, 242, 86);
INSERT INTO public.who_global_data VALUES (57348, 0, 0, 0, 0, 242, 13);
INSERT INTO public.who_global_data VALUES (57349, 61, 2377, 0, 22, 242, 157);
INSERT INTO public.who_global_data VALUES (57350, 3, 332, 0, 0, 242, 8);
INSERT INTO public.who_global_data VALUES (57351, 0, 0, 0, 0, 242, 73);
INSERT INTO public.who_global_data VALUES (57352, 12, 496, 0, 112, 242, 101);
INSERT INTO public.who_global_data VALUES (57353, 46, 1200, 3, 10, 242, 165);
INSERT INTO public.who_global_data VALUES (57354, 8, 287, 0, 4, 242, 14);
INSERT INTO public.who_global_data VALUES (57355, 575, 21003, 12, 373, 243, 193);
INSERT INTO public.who_global_data VALUES (57356, 17, 1263, 0, 34, 243, 113);
INSERT INTO public.who_global_data VALUES (57357, 104, 10154, 9, 707, 243, 143);
INSERT INTO public.who_global_data VALUES (57358, 0, 0, 0, 0, 243, 219);
INSERT INTO public.who_global_data VALUES (57359, 0, 852, 0, 51, 243, 186);
INSERT INTO public.who_global_data VALUES (57360, 5, 91, 0, 4, 243, 52);
INSERT INTO public.who_global_data VALUES (57361, 0, 3, 0, 0, 243, 180);
INSERT INTO public.who_global_data VALUES (57362, 0, 25, 0, 3, 243, 167);
INSERT INTO public.who_global_data VALUES (57363, 983, 22020, 14, 656, 243, 154);
INSERT INTO public.who_global_data VALUES (57364, 766, 13106, 10, 200, 243, 94);
INSERT INTO public.who_global_data VALUES (57365, 0, 101, 0, 3, 243, 66);
INSERT INTO public.who_global_data VALUES (57366, 5, 7260, 0, 102, 243, 58);
INSERT INTO public.who_global_data VALUES (57367, 46, 16868, 0, 672, 243, 163);
INSERT INTO public.who_global_data VALUES (57368, 314, 7553, 4, 88, 243, 37);
INSERT INTO public.who_global_data VALUES (57369, 0, 103, 0, 11, 243, 142);
INSERT INTO public.who_global_data VALUES (57370, 379, 14762, 2, 26, 243, 83);
INSERT INTO public.who_global_data VALUES (57371, 2743, 65769, 42, 888, 243, 228);
INSERT INTO public.who_global_data VALUES (57372, 0, 92, 0, 7, 243, 188);
INSERT INTO public.who_global_data VALUES (57373, 1762, 48630, 10, 269, 243, 62);
INSERT INTO public.who_global_data VALUES (57374, 53, 59911, 12, 9477, 243, 160);
INSERT INTO public.who_global_data VALUES (57375, 0, 19, 0, 2, 243, 50);
INSERT INTO public.who_global_data VALUES (57376, 0, 268, 0, 4, 243, 33);
INSERT INTO public.who_global_data VALUES (57377, 0, 141, 0, 9, 243, 183);
INSERT INTO public.who_global_data VALUES (57378, 11, 59, 0, 0, 243, 92);
INSERT INTO public.who_global_data VALUES (57379, 630, 13358, 27, 454, 243, 158);
INSERT INTO public.who_global_data VALUES (57380, 0, 2, 0, 0, 243, 67);
INSERT INTO public.who_global_data VALUES (57381, 28, 2673, 1, 159, 243, 57);
INSERT INTO public.who_global_data VALUES (57382, 0, 40, 0, 1, 243, 38);
INSERT INTO public.who_global_data VALUES (57383, 27075, 672846, 904, 35930, 243, 141);
INSERT INTO public.who_global_data VALUES (57384, 0, 8, 0, 1, 243, 178);
INSERT INTO public.who_global_data VALUES (57385, 0, 141, 0, 2, 243, 108);
INSERT INTO public.who_global_data VALUES (57386, 16, 2727, 0, 160, 243, 39);
INSERT INTO public.who_global_data VALUES (57387, 0, 888, 0, 53, 243, 2);
INSERT INTO public.who_global_data VALUES (57388, 0, 83, 0, 1, 243, 195);
INSERT INTO public.who_global_data VALUES (57389, 12, 554, 0, 5, 243, 107);
INSERT INTO public.who_global_data VALUES (57390, 0, 126, 0, 0, 243, 161);
INSERT INTO public.who_global_data VALUES (57391, 261, 7860, 3, 215, 243, 212);
INSERT INTO public.who_global_data VALUES (57392, 722, 95057, 70, 7773, 243, 181);
INSERT INTO public.who_global_data VALUES (57393, 0, 164, 0, 1, 243, 53);
INSERT INTO public.who_global_data VALUES (57394, 64, 1634, 0, 5, 243, 164);
INSERT INTO public.who_global_data VALUES (57395, 1, 837, 0, 69, 243, 140);
INSERT INTO public.who_global_data VALUES (57396, 6405, 134150, 96, 1637, 243, 20);
INSERT INTO public.who_global_data VALUES (57397, 5, 84634, 0, 4645, 243, 112);
INSERT INTO public.who_global_data VALUES (57398, 1392, 38027, 60, 1205, 243, 111);
INSERT INTO public.who_global_data VALUES (57399, 0, 97, 0, 2, 243, 71);
INSERT INTO public.who_global_data VALUES (57400, 30, 683, 2, 22, 243, 218);
INSERT INTO public.who_global_data VALUES (57401, 0, 0, 0, 0, 243, 43);
INSERT INTO public.who_global_data VALUES (57402, 0, 1263, 0, 10, 243, 49);
INSERT INTO public.who_global_data VALUES (57403, 182, 3739, 0, 36, 243, 1);
INSERT INTO public.who_global_data VALUES (57404, 0, 2247, 0, 104, 243, 48);
INSERT INTO public.who_global_data VALUES (57405, 18, 2191, 0, 83, 243, 232);
INSERT INTO public.who_global_data VALUES (57406, 0, 21, 0, 1, 243, 175);
INSERT INTO public.who_global_data VALUES (57407, 4, 964, 0, 18, 243, 21);
INSERT INTO public.who_global_data VALUES (57408, 61, 9628, 0, 327, 243, 156);
INSERT INTO public.who_global_data VALUES (57409, 0, 0, 0, 0, 243, 95);
INSERT INTO public.who_global_data VALUES (57410, 138, 4015, 3, 84, 243, 177);
INSERT INTO public.who_global_data VALUES (57411, 24, 11948, 2, 589, 243, 210);
INSERT INTO public.who_global_data VALUES (57412, 38, 4207, 2, 28, 243, 120);
INSERT INTO public.who_global_data VALUES (57413, 0, 16, 0, 0, 243, 135);
INSERT INTO public.who_global_data VALUES (57414, 405, 19600, 2, 538, 243, 206);
INSERT INTO public.who_global_data VALUES (57415, 392, 43120, 13, 3621, 243, 189);
INSERT INTO public.who_global_data VALUES (57416, 1467, 34079, 39, 1237, 243, 129);
INSERT INTO public.who_global_data VALUES (57417, 81, 3015, 2, 55, 243, 121);
INSERT INTO public.who_global_data VALUES (57418, 0, 1043, 0, 12, 243, 59);
INSERT INTO public.who_global_data VALUES (57419, 0, 41, 0, 0, 243, 96);
INSERT INTO public.who_global_data VALUES (57420, 8, 1939, 0, 63, 243, 41);
INSERT INTO public.who_global_data VALUES (57421, 11, 333, 0, 3, 243, 216);
INSERT INTO public.who_global_data VALUES (57422, 86, 2020, 7, 27, 243, 236);
INSERT INTO public.who_global_data VALUES (57423, 0, 13, 0, 0, 243, 150);
INSERT INTO public.who_global_data VALUES (57424, 0, 187, 0, 0, 243, 61);
INSERT INTO public.who_global_data VALUES (57425, 0, 18, 0, 0, 243, 7);
INSERT INTO public.who_global_data VALUES (57426, 17, 6981, 1, 323, 243, 169);
INSERT INTO public.who_global_data VALUES (57427, 293, 150315, 13, 29097, 243, 28);
INSERT INTO public.who_global_data VALUES (57428, 50, 689, 0, 1, 243, 85);
INSERT INTO public.who_global_data VALUES (57429, 0, 60, 0, 0, 243, 211);
INSERT INTO public.who_global_data VALUES (57430, 0, 3101, 0, 21, 243, 60);
INSERT INTO public.who_global_data VALUES (57431, 0, 26, 0, 1, 243, 3);
INSERT INTO public.who_global_data VALUES (57432, 1, 810, 0, 13, 243, 11);
INSERT INTO public.who_global_data VALUES (57433, 214, 184193, 6, 8674, 243, 89);
INSERT INTO public.who_global_data VALUES (57434, 176, 9638, 0, 44, 243, 24);
INSERT INTO public.who_global_data VALUES (57435, 1, 175, 0, 0, 243, 162);
INSERT INTO public.who_global_data VALUES (57436, 17, 2997, 0, 180, 243, 100);
INSERT INTO public.who_global_data VALUES (57437, 0, 13, 0, 0, 243, 47);
INSERT INTO public.who_global_data VALUES (57438, 0, 23, 0, 0, 243, 29);
INSERT INTO public.who_global_data VALUES (57439, 0, 164, 0, 14, 243, 40);
INSERT INTO public.who_global_data VALUES (57440, 0, 171, 0, 5, 243, 222);
INSERT INTO public.who_global_data VALUES (57441, 307, 6792, 14, 230, 243, 132);
INSERT INTO public.who_global_data VALUES (57442, 0, 252, 0, 13, 243, 130);
INSERT INTO public.who_global_data VALUES (57443, 48, 4165, 0, 23, 243, 234);
INSERT INTO public.who_global_data VALUES (57444, 0, 1368, 0, 12, 243, 23);
INSERT INTO public.who_global_data VALUES (57445, 1, 154, 0, 12, 243, 192);
INSERT INTO public.who_global_data VALUES (57446, 148, 3072, 0, 50, 243, 69);
INSERT INTO public.who_global_data VALUES (57447, 0, 12, 0, 0, 243, 187);
INSERT INTO public.who_global_data VALUES (57448, 184, 6155, 2, 250, 243, 230);
INSERT INTO public.who_global_data VALUES (57449, 0, 3970, 0, 542, 243, 77);
INSERT INTO public.who_global_data VALUES (57450, 1, 1807, 0, 10, 243, 9);
INSERT INTO public.who_global_data VALUES (57451, 9983, 256611, 206, 7135, 243, 74);
INSERT INTO public.who_global_data VALUES (57452, 672, 31186, 50, 1851, 243, 224);
INSERT INTO public.who_global_data VALUES (57453, 2364, 171789, 72, 8281, 243, 199);
INSERT INTO public.who_global_data VALUES (57454, 1268, 12366, 28, 346, 243, 190);
INSERT INTO public.who_global_data VALUES (57455, 18, 25201, 9, 1679, 243, 12);
INSERT INTO public.who_global_data VALUES (57456, 0, 336, 0, 24, 243, 104);
INSERT INTO public.who_global_data VALUES (57457, 78, 17750, 4, 298, 243, 153);
INSERT INTO public.who_global_data VALUES (57458, 197, 234998, 53, 33899, 243, 91);
INSERT INTO public.who_global_data VALUES (57459, 1, 596, 0, 10, 243, 215);
INSERT INTO public.who_global_data VALUES (57460, 33, 17174, 0, 916, 243, 84);
INSERT INTO public.who_global_data VALUES (57461, 2, 311, 0, 30, 243, 231);
INSERT INTO public.who_global_data VALUES (57462, 8, 769, 0, 9, 243, 196);
INSERT INTO public.who_global_data VALUES (57463, 215, 13074, 2, 58, 243, 105);
INSERT INTO public.who_global_data VALUES (57464, 167, 2767, 1, 84, 243, 122);
INSERT INTO public.who_global_data VALUES (57465, 0, 0, 0, 0, 243, 159);
INSERT INTO public.who_global_data VALUES (57466, 40, 1191, 0, 21, 243, 75);
INSERT INTO public.who_global_data VALUES (57467, 717, 31848, 10, 264, 243, 27);
INSERT INTO public.who_global_data VALUES (57468, 25, 2032, 1, 23, 243, 54);
INSERT INTO public.who_global_data VALUES (57469, 0, 19, 0, 0, 243, 226);
INSERT INTO public.who_global_data VALUES (57470, 2, 1088, 0, 25, 243, 79);
INSERT INTO public.who_global_data VALUES (57471, 11, 1331, 1, 30, 243, 56);
INSERT INTO public.who_global_data VALUES (57472, 0, 4, 0, 0, 243, 117);
INSERT INTO public.who_global_data VALUES (57473, 14, 359, 0, 30, 243, 152);
INSERT INTO public.who_global_data VALUES (57474, 14, 270, 0, 5, 243, 16);
INSERT INTO public.who_global_data VALUES (57475, 0, 83, 0, 1, 243, 10);
INSERT INTO public.who_global_data VALUES (57476, 7, 1716, 0, 71, 243, 201);
INSERT INTO public.who_global_data VALUES (57477, 4, 4039, 0, 110, 243, 174);
INSERT INTO public.who_global_data VALUES (57478, 26, 1052, 1, 9, 243, 119);
INSERT INTO public.who_global_data VALUES (57479, 29, 438, 0, 4, 243, 168);
INSERT INTO public.who_global_data VALUES (57480, 19, 8322, 0, 117, 243, 99);
INSERT INTO public.who_global_data VALUES (57481, 2, 1903, 0, 8, 243, 171);
INSERT INTO public.who_global_data VALUES (57482, 10, 1533, 2, 92, 243, 87);
INSERT INTO public.who_global_data VALUES (57483, 1, 629, 0, 9, 243, 123);
INSERT INTO public.who_global_data VALUES (57484, 0, 0, 0, 0, 243, 151);
INSERT INTO public.who_global_data VALUES (57485, 0, 202, 0, 14, 243, 213);
INSERT INTO public.who_global_data VALUES (57486, 0, 947, 0, 43, 243, 118);
INSERT INTO public.who_global_data VALUES (57487, 0, 337, 0, 10, 243, 134);
INSERT INTO public.who_global_data VALUES (57488, 0, 2079, 0, 25, 243, 65);
INSERT INTO public.who_global_data VALUES (57489, 3593, 113619, 341, 13511, 243, 102);
INSERT INTO public.who_global_data VALUES (57490, 0, 0, 0, 0, 243, 223);
INSERT INTO public.who_global_data VALUES (57491, 0, 70, 0, 1, 243, 4);
INSERT INTO public.who_global_data VALUES (57492, 0, 193, 0, 0, 243, 146);
INSERT INTO public.who_global_data VALUES (57493, 0, 324, 0, 9, 243, 31);
INSERT INTO public.who_global_data VALUES (57494, 0, 11, 0, 1, 243, 127);
INSERT INTO public.who_global_data VALUES (57495, 73, 8224, 0, 208, 243, 22);
INSERT INTO public.who_global_data VALUES (57496, 15, 424, 0, 2, 243, 115);
INSERT INTO public.who_global_data VALUES (57497, 2, 242, 0, 6, 243, 106);
INSERT INTO public.who_global_data VALUES (57498, 0, 29, 0, 0, 243, 90);
INSERT INTO public.who_global_data VALUES (57499, 0, 0, 0, 0, 243, 70);
INSERT INTO public.who_global_data VALUES (57500, 213, 3448, 0, 13, 243, 46);
INSERT INTO public.who_global_data VALUES (57501, 239, 47333, 3, 5983, 243, 139);
INSERT INTO public.who_global_data VALUES (57502, 0, 20, 0, 0, 243, 42);
INSERT INTO public.who_global_data VALUES (57503, 0, 1154, 0, 22, 243, 80);
INSERT INTO public.who_global_data VALUES (57504, 0, 1309, 0, 46, 243, 203);
INSERT INTO public.who_global_data VALUES (57505, 3, 973, 0, 65, 243, 136);
INSERT INTO public.who_global_data VALUES (57506, 253, 12486, 12, 354, 243, 63);
INSERT INTO public.who_global_data VALUES (57507, 0, 0, 0, 0, 243, 17);
INSERT INTO public.who_global_data VALUES (57508, 1, 27, 0, 2, 243, 172);
INSERT INTO public.who_global_data VALUES (57509, 113, 3028, 2, 153, 243, 109);
INSERT INTO public.who_global_data VALUES (57510, 0, 8504, 0, 238, 243, 200);
INSERT INTO public.who_global_data VALUES (57511, 0, 643, 0, 5, 243, 93);
INSERT INTO public.who_global_data VALUES (57512, 866, 16882, 3, 75, 243, 5);
INSERT INTO public.who_global_data VALUES (57513, 0, 741, 0, 13, 243, 214);
INSERT INTO public.who_global_data VALUES (57514, 4728, 103671, 65, 2067, 243, 204);
INSERT INTO public.who_global_data VALUES (57515, 0, 0, 0, 0, 243, 198);
INSERT INTO public.who_global_data VALUES (57516, 541, 16004, 16, 386, 243, 173);
INSERT INTO public.who_global_data VALUES (57517, 0, 8, 0, 0, 243, 229);
INSERT INTO public.who_global_data VALUES (57518, 45, 1135, 0, 11, 243, 76);
INSERT INTO public.who_global_data VALUES (57519, 4358, 191758, 139, 5301, 243, 138);
INSERT INTO public.who_global_data VALUES (57520, 555, 21895, 9, 1003, 243, 98);
INSERT INTO public.who_global_data VALUES (57521, 0, 0, 0, 0, 243, 103);
INSERT INTO public.who_global_data VALUES (57522, 575, 26561, 4, 1157, 243, 225);
INSERT INTO public.who_global_data VALUES (57523, 142, 34493, 5, 1479, 243, 131);
INSERT INTO public.who_global_data VALUES (57524, 70, 4985, 0, 142, 243, 235);
INSERT INTO public.who_global_data VALUES (57525, 1595, 68790, 3, 54, 243, 137);
INSERT INTO public.who_global_data VALUES (57526, 37, 11813, 0, 273, 243, 81);
INSERT INTO public.who_global_data VALUES (57527, 189, 9700, 11, 346, 243, 182);
INSERT INTO public.who_global_data VALUES (57528, 0, 480, 0, 1, 243, 145);
INSERT INTO public.who_global_data VALUES (57529, 189, 20479, 8, 1326, 243, 26);
INSERT INTO public.who_global_data VALUES (57530, 8985, 476658, 112, 5971, 243, 170);
INSERT INTO public.who_global_data VALUES (57531, 8, 439, 0, 2, 243, 191);
INSERT INTO public.who_global_data VALUES (57532, 0, 3, 0, 0, 243, 221);
INSERT INTO public.who_global_data VALUES (57533, 0, 6, 0, 0, 243, 64);
INSERT INTO public.who_global_data VALUES (57534, 0, 0, 0, 0, 243, 116);
INSERT INTO public.who_global_data VALUES (57535, 0, 15, 0, 0, 243, 128);
INSERT INTO public.who_global_data VALUES (57536, 0, 19, 0, 0, 243, 6);
INSERT INTO public.who_global_data VALUES (57537, 0, 41, 0, 3, 243, 227);
INSERT INTO public.who_global_data VALUES (57538, 0, 1, 0, 0, 243, 68);
INSERT INTO public.who_global_data VALUES (57539, 0, 26, 0, 0, 243, 184);
INSERT INTO public.who_global_data VALUES (57540, 0, 0, 0, 0, 243, 82);
INSERT INTO public.who_global_data VALUES (57541, 0, 695, 0, 42, 243, 149);
INSERT INTO public.who_global_data VALUES (57542, 0, 295, 0, 10, 243, 197);
INSERT INTO public.who_global_data VALUES (57543, 3045, 101914, 36, 712, 243, 78);
INSERT INTO public.who_global_data VALUES (57544, 79, 4328, 2, 49, 243, 233);
INSERT INTO public.who_global_data VALUES (57545, 82, 11823, 1, 249, 243, 133);
INSERT INTO public.who_global_data VALUES (57546, 0, 11, 0, 0, 243, 35);
INSERT INTO public.who_global_data VALUES (57547, 23, 969, 0, 48, 243, 114);
INSERT INTO public.who_global_data VALUES (57548, 383, 37910, 0, 25, 243, 237);
INSERT INTO public.who_global_data VALUES (57549, 0, 2, 0, 0, 243, 55);
INSERT INTO public.who_global_data VALUES (57550, 0, 77, 0, 15, 243, 176);
INSERT INTO public.who_global_data VALUES (57551, 0, 1528, 0, 28, 243, 202);
INSERT INTO public.who_global_data VALUES (57552, 0, 1485, 0, 113, 243, 155);
INSERT INTO public.who_global_data VALUES (57553, 0, 0, 0, 0, 243, 32);
INSERT INTO public.who_global_data VALUES (57554, 45, 2334, 1, 83, 243, 220);
INSERT INTO public.who_global_data VALUES (57555, 2312, 48285, 46, 998, 243, 30);
INSERT INTO public.who_global_data VALUES (57556, 0, 1317, 0, 14, 243, 147);
INSERT INTO public.who_global_data VALUES (57557, 278, 250299, 30, 29378, 243, 208);
INSERT INTO public.who_global_data VALUES (57558, 21, 1835, 0, 11, 243, 45);
INSERT INTO public.who_global_data VALUES (57559, 0, 6081, 0, 359, 243, 110);
INSERT INTO public.who_global_data VALUES (57560, 11, 101, 0, 1, 243, 88);
INSERT INTO public.who_global_data VALUES (57561, 780, 44217, 29, 4873, 243, 51);
INSERT INTO public.who_global_data VALUES (57562, 8, 30941, 0, 1715, 243, 209);
INSERT INTO public.who_global_data VALUES (57563, 16, 141, 0, 6, 243, 205);
INSERT INTO public.who_global_data VALUES (57564, 76, 4529, 0, 48, 243, 18);
INSERT INTO public.who_global_data VALUES (57565, 7, 3119, 0, 58, 243, 72);
INSERT INTO public.who_global_data VALUES (57566, 801, 264043, 54, 38619, 243, 44);
INSERT INTO public.who_global_data VALUES (57567, 0, 24, 0, 0, 243, 15);
INSERT INTO public.who_global_data VALUES (57568, 8, 495, 0, 13, 243, 25);
INSERT INTO public.who_global_data VALUES (57569, 0, 0, 0, 0, 243, 179);
INSERT INTO public.who_global_data VALUES (57570, 0, 0, 0, 0, 243, 34);
INSERT INTO public.who_global_data VALUES (57571, 0, 117, 0, 8, 243, 207);
INSERT INTO public.who_global_data VALUES (57572, 0, 1087, 0, 49, 243, 166);
INSERT INTO public.who_global_data VALUES (57573, 914, 170132, 23, 4692, 243, 126);
INSERT INTO public.who_global_data VALUES (57574, 0, 0, 0, 0, 243, 97);
INSERT INTO public.who_global_data VALUES (57575, 0, 12, 0, 1, 243, 36);
INSERT INTO public.who_global_data VALUES (57576, 0, 0, 0, 0, 243, 125);
INSERT INTO public.who_global_data VALUES (57577, 23, 745, 0, 0, 243, 124);
INSERT INTO public.who_global_data VALUES (57578, 463, 27462, 9, 797, 243, 185);
INSERT INTO public.who_global_data VALUES (57579, 540, 38808, 1, 276, 243, 194);
INSERT INTO public.who_global_data VALUES (57580, 0, 509, 0, 21, 243, 144);
INSERT INTO public.who_global_data VALUES (57581, 28918, 1915712, 708, 109746, 243, 19);
INSERT INTO public.who_global_data VALUES (57582, 0, 71, 0, 6, 243, 217);
INSERT INTO public.who_global_data VALUES (57583, 11, 845, 0, 23, 243, 148);
INSERT INTO public.who_global_data VALUES (57584, 171, 4352, 0, 17, 243, 86);
INSERT INTO public.who_global_data VALUES (57585, 0, 0, 0, 0, 243, 13);
INSERT INTO public.who_global_data VALUES (57586, 171, 2316, 2, 22, 243, 157);
INSERT INTO public.who_global_data VALUES (57587, 0, 329, 0, 0, 243, 8);
INSERT INTO public.who_global_data VALUES (57588, 0, 0, 0, 0, 243, 73);
INSERT INTO public.who_global_data VALUES (57589, 2, 484, 1, 112, 243, 101);
INSERT INTO public.who_global_data VALUES (57590, 0, 1154, 0, 7, 243, 165);
INSERT INTO public.who_global_data VALUES (57591, 0, 279, 0, 4, 243, 14);
INSERT INTO public.who_global_data VALUES (57592, 791, 20428, 30, 361, 244, 193);
INSERT INTO public.who_global_data VALUES (57593, 14, 1246, 0, 34, 244, 113);
INSERT INTO public.who_global_data VALUES (57594, 115, 10050, 8, 698, 244, 143);
INSERT INTO public.who_global_data VALUES (57595, 0, 0, 0, 0, 244, 219);
INSERT INTO public.who_global_data VALUES (57596, 0, 852, 0, 51, 244, 186);
INSERT INTO public.who_global_data VALUES (57597, 0, 86, 0, 4, 244, 52);
INSERT INTO public.who_global_data VALUES (57598, 0, 3, 0, 0, 244, 180);
INSERT INTO public.who_global_data VALUES (57599, 0, 25, 0, 3, 244, 167);
INSERT INTO public.who_global_data VALUES (57600, 840, 21037, 27, 642, 244, 154);
INSERT INTO public.who_global_data VALUES (57601, 547, 12340, 7, 190, 244, 94);
INSERT INTO public.who_global_data VALUES (57602, 0, 101, 0, 3, 244, 66);
INSERT INTO public.who_global_data VALUES (57603, 4, 7255, 0, 102, 244, 58);
INSERT INTO public.who_global_data VALUES (57604, 19, 16822, 0, 672, 244, 163);
INSERT INTO public.who_global_data VALUES (57605, 379, 7239, 2, 84, 244, 37);
INSERT INTO public.who_global_data VALUES (57606, 1, 103, 0, 11, 244, 142);
INSERT INTO public.who_global_data VALUES (57607, 548, 14383, 2, 24, 244, 83);
INSERT INTO public.who_global_data VALUES (57608, 2635, 63026, 35, 846, 244, 228);
INSERT INTO public.who_global_data VALUES (57609, 0, 92, 0, 7, 244, 188);
INSERT INTO public.who_global_data VALUES (57610, 0, 46868, 0, 259, 244, 62);
INSERT INTO public.who_global_data VALUES (57611, 69, 59858, 11, 9465, 244, 160);
INSERT INTO public.who_global_data VALUES (57612, 1, 19, 0, 2, 244, 50);
INSERT INTO public.who_global_data VALUES (57613, 7, 268, 1, 4, 244, 33);
INSERT INTO public.who_global_data VALUES (57614, 0, 141, 0, 9, 244, 183);
INSERT INTO public.who_global_data VALUES (57615, 0, 48, 0, 0, 244, 92);
INSERT INTO public.who_global_data VALUES (57616, 483, 12728, 12, 427, 244, 158);
INSERT INTO public.who_global_data VALUES (57617, 0, 2, 0, 0, 244, 67);
INSERT INTO public.who_global_data VALUES (57618, 40, 2645, 0, 158, 244, 57);
INSERT INTO public.who_global_data VALUES (57619, 0, 40, 0, 1, 244, 38);
INSERT INTO public.who_global_data VALUES (57620, 30830, 645771, 1005, 35026, 244, 141);
INSERT INTO public.who_global_data VALUES (57621, 0, 8, 0, 1, 244, 178);
INSERT INTO public.who_global_data VALUES (57622, 0, 141, 0, 2, 244, 108);
INSERT INTO public.who_global_data VALUES (57623, 43, 2711, 0, 160, 244, 39);
INSERT INTO public.who_global_data VALUES (57624, 3, 888, 0, 53, 244, 2);
INSERT INTO public.who_global_data VALUES (57625, 20, 83, 0, 1, 244, 195);
INSERT INTO public.who_global_data VALUES (57626, 6, 542, 0, 5, 244, 107);
INSERT INTO public.who_global_data VALUES (57627, 1, 126, 0, 0, 244, 161);
INSERT INTO public.who_global_data VALUES (57628, 207, 7599, 7, 212, 244, 212);
INSERT INTO public.who_global_data VALUES (57629, 265, 94335, 51, 7703, 244, 181);
INSERT INTO public.who_global_data VALUES (57630, 4, 164, 0, 1, 244, 53);
INSERT INTO public.who_global_data VALUES (57631, 119, 1570, 1, 5, 244, 164);
INSERT INTO public.who_global_data VALUES (57632, 0, 836, 1, 69, 244, 140);
INSERT INTO public.who_global_data VALUES (57633, 5246, 127745, 93, 1541, 244, 20);
INSERT INTO public.who_global_data VALUES (57634, 9, 84629, 0, 4645, 244, 112);
INSERT INTO public.who_global_data VALUES (57635, 1515, 36635, 58, 1145, 244, 111);
INSERT INTO public.who_global_data VALUES (57636, 35, 97, 0, 2, 244, 71);
INSERT INTO public.who_global_data VALUES (57637, 14, 653, 0, 20, 244, 218);
INSERT INTO public.who_global_data VALUES (57638, 0, 0, 0, 0, 244, 43);
INSERT INTO public.who_global_data VALUES (57639, 69, 1263, 0, 10, 244, 49);
INSERT INTO public.who_global_data VALUES (57640, 126, 3557, 0, 36, 244, 1);
INSERT INTO public.who_global_data VALUES (57641, 0, 2247, 1, 104, 244, 48);
INSERT INTO public.who_global_data VALUES (57642, 40, 2173, 0, 83, 244, 232);
INSERT INTO public.who_global_data VALUES (57643, 0, 21, 0, 1, 244, 175);
INSERT INTO public.who_global_data VALUES (57644, 0, 960, 1, 18, 244, 21);
INSERT INTO public.who_global_data VALUES (57645, 38, 9567, 0, 327, 244, 156);
INSERT INTO public.who_global_data VALUES (57646, 0, 0, 0, 0, 244, 95);
INSERT INTO public.who_global_data VALUES (57647, 114, 3877, 1, 81, 244, 177);
INSERT INTO public.who_global_data VALUES (57648, 49, 11924, 1, 587, 244, 210);
INSERT INTO public.who_global_data VALUES (57649, 46, 4169, 0, 26, 244, 120);
INSERT INTO public.who_global_data VALUES (57650, 0, 16, 0, 0, 244, 135);
INSERT INTO public.who_global_data VALUES (57651, 487, 19195, 11, 536, 244, 206);
INSERT INTO public.who_global_data VALUES (57652, 622, 42728, 16, 3608, 244, 189);
INSERT INTO public.who_global_data VALUES (57653, 1497, 32612, 32, 1198, 244, 129);
INSERT INTO public.who_global_data VALUES (57654, 85, 2934, 0, 53, 244, 121);
INSERT INTO public.who_global_data VALUES (57655, 0, 1043, 0, 12, 244, 59);
INSERT INTO public.who_global_data VALUES (57656, 0, 41, 0, 0, 244, 96);
INSERT INTO public.who_global_data VALUES (57657, 21, 1931, 0, 63, 244, 41);
INSERT INTO public.who_global_data VALUES (57658, 17, 322, 0, 3, 244, 216);
INSERT INTO public.who_global_data VALUES (57659, 129, 1934, 1, 20, 244, 236);
INSERT INTO public.who_global_data VALUES (57660, 0, 13, 0, 0, 244, 150);
INSERT INTO public.who_global_data VALUES (57661, 0, 187, 0, 0, 244, 61);
INSERT INTO public.who_global_data VALUES (57662, 0, 18, 0, 0, 244, 7);
INSERT INTO public.who_global_data VALUES (57663, 23, 6964, 0, 322, 244, 169);
INSERT INTO public.who_global_data VALUES (57664, 527, 150022, 31, 29084, 244, 28);
INSERT INTO public.who_global_data VALUES (57665, 50, 639, 0, 1, 244, 85);
INSERT INTO public.who_global_data VALUES (57666, 0, 60, 0, 0, 244, 211);
INSERT INTO public.who_global_data VALUES (57667, 0, 3101, 0, 21, 244, 60);
INSERT INTO public.who_global_data VALUES (57668, 0, 26, 0, 1, 244, 3);
INSERT INTO public.who_global_data VALUES (57669, 1, 809, 0, 13, 244, 11);
INSERT INTO public.who_global_data VALUES (57670, 301, 183979, 22, 8668, 244, 89);
INSERT INTO public.who_global_data VALUES (57671, 294, 9462, 2, 44, 244, 24);
INSERT INTO public.who_global_data VALUES (57672, 0, 174, 0, 0, 244, 162);
INSERT INTO public.who_global_data VALUES (57673, 13, 2980, 0, 180, 244, 100);
INSERT INTO public.who_global_data VALUES (57674, 0, 13, 0, 0, 244, 47);
INSERT INTO public.who_global_data VALUES (57675, 0, 23, 0, 0, 244, 29);
INSERT INTO public.who_global_data VALUES (57676, 0, 164, 0, 14, 244, 40);
INSERT INTO public.who_global_data VALUES (57677, 0, 171, 0, 5, 244, 222);
INSERT INTO public.who_global_data VALUES (57678, 331, 6485, 58, 216, 244, 132);
INSERT INTO public.who_global_data VALUES (57679, 0, 252, 0, 13, 244, 130);
INSERT INTO public.who_global_data VALUES (57680, 57, 4117, 0, 23, 244, 234);
INSERT INTO public.who_global_data VALUES (57681, 0, 1368, 0, 12, 244, 23);
INSERT INTO public.who_global_data VALUES (57682, 0, 153, 0, 12, 244, 192);
INSERT INTO public.who_global_data VALUES (57683, 284, 2924, 0, 50, 244, 69);
INSERT INTO public.who_global_data VALUES (57684, 0, 12, 0, 0, 244, 187);
INSERT INTO public.who_global_data VALUES (57685, 91, 5971, 5, 248, 244, 230);
INSERT INTO public.who_global_data VALUES (57686, 0, 3970, 0, 542, 244, 77);
INSERT INTO public.who_global_data VALUES (57687, 0, 1806, 0, 10, 244, 9);
INSERT INTO public.who_global_data VALUES (57688, 9971, 246628, 287, 6929, 244, 74);
INSERT INTO public.who_global_data VALUES (57689, 993, 30514, 31, 1801, 244, 224);
INSERT INTO public.who_global_data VALUES (57690, 2269, 169425, 75, 8209, 244, 199);
INSERT INTO public.who_global_data VALUES (57691, 1252, 11098, 33, 318, 244, 190);
INSERT INTO public.who_global_data VALUES (57692, 20, 25183, 0, 1670, 244, 12);
INSERT INTO public.who_global_data VALUES (57693, 0, 336, 0, 24, 244, 104);
INSERT INTO public.who_global_data VALUES (57694, 127, 17672, 1, 294, 244, 153);
INSERT INTO public.who_global_data VALUES (57695, 270, 234801, 72, 33846, 244, 91);
INSERT INTO public.who_global_data VALUES (57696, 4, 595, 0, 10, 244, 215);
INSERT INTO public.who_global_data VALUES (57697, 38, 17141, 2, 916, 244, 84);
INSERT INTO public.who_global_data VALUES (57698, 0, 309, 0, 30, 244, 231);
INSERT INTO public.who_global_data VALUES (57699, 6, 761, 0, 9, 244, 196);
INSERT INTO public.who_global_data VALUES (57700, 165, 12859, 2, 56, 244, 105);
INSERT INTO public.who_global_data VALUES (57701, 126, 2600, 4, 83, 244, 122);
INSERT INTO public.who_global_data VALUES (57702, 0, 0, 0, 0, 244, 159);
INSERT INTO public.who_global_data VALUES (57703, 9, 1151, 0, 21, 244, 75);
INSERT INTO public.who_global_data VALUES (57704, 487, 31131, 10, 254, 244, 27);
INSERT INTO public.who_global_data VALUES (57705, 33, 2007, 0, 22, 244, 54);
INSERT INTO public.who_global_data VALUES (57706, 0, 19, 0, 0, 244, 226);
INSERT INTO public.who_global_data VALUES (57707, 4, 1086, 0, 25, 244, 79);
INSERT INTO public.who_global_data VALUES (57708, 8, 1320, 1, 29, 244, 56);
INSERT INTO public.who_global_data VALUES (57709, 0, 4, 0, 0, 244, 117);
INSERT INTO public.who_global_data VALUES (57710, 11, 345, 0, 30, 244, 152);
INSERT INTO public.who_global_data VALUES (57711, 17, 256, 0, 5, 244, 16);
INSERT INTO public.who_global_data VALUES (57712, 0, 83, 0, 1, 244, 10);
INSERT INTO public.who_global_data VALUES (57713, 9, 1709, 0, 71, 244, 201);
INSERT INTO public.who_global_data VALUES (57714, 3, 4035, 0, 110, 244, 174);
INSERT INTO public.who_global_data VALUES (57715, 51, 1026, 1, 8, 244, 119);
INSERT INTO public.who_global_data VALUES (57716, 0, 409, 0, 4, 244, 168);
INSERT INTO public.who_global_data VALUES (57717, 37, 8303, 1, 117, 244, 99);
INSERT INTO public.who_global_data VALUES (57718, 18, 1901, 1, 8, 244, 171);
INSERT INTO public.who_global_data VALUES (57719, 38, 1523, 3, 90, 244, 87);
INSERT INTO public.who_global_data VALUES (57720, 2, 628, 0, 9, 244, 123);
INSERT INTO public.who_global_data VALUES (57721, 0, 0, 0, 0, 244, 151);
INSERT INTO public.who_global_data VALUES (57722, 2, 202, 0, 14, 244, 213);
INSERT INTO public.who_global_data VALUES (57723, 64, 947, 0, 43, 244, 118);
INSERT INTO public.who_global_data VALUES (57724, 0, 337, 0, 10, 244, 134);
INSERT INTO public.who_global_data VALUES (57725, 0, 2079, 0, 25, 244, 65);
INSERT INTO public.who_global_data VALUES (57726, 4346, 110026, 625, 13170, 244, 102);
INSERT INTO public.who_global_data VALUES (57727, 0, 0, 0, 0, 244, 223);
INSERT INTO public.who_global_data VALUES (57728, 0, 70, 0, 1, 244, 4);
INSERT INTO public.who_global_data VALUES (57729, 2, 193, 0, 0, 244, 146);
INSERT INTO public.who_global_data VALUES (57730, 0, 324, 0, 9, 244, 31);
INSERT INTO public.who_global_data VALUES (57731, 0, 11, 0, 1, 244, 127);
INSERT INTO public.who_global_data VALUES (57732, 80, 8151, 0, 208, 244, 22);
INSERT INTO public.who_global_data VALUES (57733, 57, 409, 0, 2, 244, 115);
INSERT INTO public.who_global_data VALUES (57734, 4, 240, 0, 6, 244, 106);
INSERT INTO public.who_global_data VALUES (57735, 4, 29, 0, 0, 244, 90);
INSERT INTO public.who_global_data VALUES (57736, 0, 0, 0, 0, 244, 70);
INSERT INTO public.who_global_data VALUES (57737, 323, 3235, 2, 13, 244, 46);
INSERT INTO public.who_global_data VALUES (57738, 190, 47094, 8, 5980, 244, 139);
INSERT INTO public.who_global_data VALUES (57739, 0, 20, 0, 0, 244, 42);
INSERT INTO public.who_global_data VALUES (57740, 0, 1154, 0, 22, 244, 80);
INSERT INTO public.who_global_data VALUES (57741, 0, 1309, 0, 46, 244, 203);
INSERT INTO public.who_global_data VALUES (57742, 4, 970, 0, 65, 244, 136);
INSERT INTO public.who_global_data VALUES (57743, 389, 12233, 9, 342, 244, 63);
INSERT INTO public.who_global_data VALUES (57744, 0, 0, 0, 0, 244, 17);
INSERT INTO public.who_global_data VALUES (57745, 0, 26, 0, 2, 244, 172);
INSERT INTO public.who_global_data VALUES (57746, 123, 2915, 2, 151, 244, 109);
INSERT INTO public.who_global_data VALUES (57747, 0, 8504, 0, 238, 244, 200);
INSERT INTO public.who_global_data VALUES (57748, 0, 643, 0, 5, 244, 93);
INSERT INTO public.who_global_data VALUES (57749, 930, 16016, 0, 72, 244, 5);
INSERT INTO public.who_global_data VALUES (57750, 0, 741, 0, 13, 244, 214);
INSERT INTO public.who_global_data VALUES (57751, 4960, 98943, 67, 2002, 244, 204);
INSERT INTO public.who_global_data VALUES (57752, 0, 0, 0, 0, 244, 198);
INSERT INTO public.who_global_data VALUES (57753, 419, 15463, 7, 370, 244, 173);
INSERT INTO public.who_global_data VALUES (57754, 0, 8, 0, 0, 244, 229);
INSERT INTO public.who_global_data VALUES (57755, 3, 1090, 0, 11, 244, 76);
INSERT INTO public.who_global_data VALUES (57756, 4202, 187400, 131, 5162, 244, 138);
INSERT INTO public.who_global_data VALUES (57757, 714, 21340, 7, 994, 244, 98);
INSERT INTO public.who_global_data VALUES (57758, 0, 0, 0, 0, 244, 103);
INSERT INTO public.who_global_data VALUES (57759, 567, 25986, 16, 1153, 244, 225);
INSERT INTO public.who_global_data VALUES (57760, 382, 34351, 9, 1474, 244, 131);
INSERT INTO public.who_global_data VALUES (57761, 295, 4915, 1, 142, 244, 235);
INSERT INTO public.who_global_data VALUES (57762, 1700, 67195, 2, 51, 244, 137);
INSERT INTO public.who_global_data VALUES (57763, 57, 11776, 0, 273, 244, 81);
INSERT INTO public.who_global_data VALUES (57764, 264, 9511, 12, 335, 244, 182);
INSERT INTO public.who_global_data VALUES (57765, 0, 480, 0, 1, 244, 145);
INSERT INTO public.who_global_data VALUES (57766, 187, 20290, 10, 1318, 244, 26);
INSERT INTO public.who_global_data VALUES (57767, 8984, 467673, 134, 5859, 244, 170);
INSERT INTO public.who_global_data VALUES (57768, 11, 431, 0, 2, 244, 191);
INSERT INTO public.who_global_data VALUES (57769, 0, 3, 0, 0, 244, 221);
INSERT INTO public.who_global_data VALUES (57770, 0, 6, 0, 0, 244, 64);
INSERT INTO public.who_global_data VALUES (57771, 0, 0, 0, 0, 244, 116);
INSERT INTO public.who_global_data VALUES (57772, 0, 15, 0, 0, 244, 128);
INSERT INTO public.who_global_data VALUES (57773, 0, 19, 0, 0, 244, 6);
INSERT INTO public.who_global_data VALUES (57774, 0, 41, 0, 3, 244, 227);
INSERT INTO public.who_global_data VALUES (57775, 0, 1, 0, 0, 244, 68);
INSERT INTO public.who_global_data VALUES (57776, 0, 26, 0, 0, 244, 184);
INSERT INTO public.who_global_data VALUES (57777, 0, 0, 0, 0, 244, 82);
INSERT INTO public.who_global_data VALUES (57778, 0, 695, 0, 42, 244, 149);
INSERT INTO public.who_global_data VALUES (57779, 0, 295, 0, 10, 244, 197);
INSERT INTO public.who_global_data VALUES (57780, 3121, 98869, 34, 676, 244, 78);
INSERT INTO public.who_global_data VALUES (57781, 94, 4249, 2, 47, 244, 233);
INSERT INTO public.who_global_data VALUES (57782, 74, 11741, 1, 248, 244, 133);
INSERT INTO public.who_global_data VALUES (57783, 0, 11, 0, 0, 244, 35);
INSERT INTO public.who_global_data VALUES (57784, 17, 946, 1, 48, 244, 114);
INSERT INTO public.who_global_data VALUES (57785, 344, 37527, 1, 25, 244, 237);
INSERT INTO public.who_global_data VALUES (57786, 0, 2, 0, 0, 244, 55);
INSERT INTO public.who_global_data VALUES (57787, 0, 77, 0, 15, 244, 176);
INSERT INTO public.who_global_data VALUES (57788, 2, 1528, 0, 28, 244, 202);
INSERT INTO public.who_global_data VALUES (57789, 1, 1485, 0, 113, 244, 155);
INSERT INTO public.who_global_data VALUES (57790, 0, 0, 0, 0, 244, 32);
INSERT INTO public.who_global_data VALUES (57791, 85, 2289, 3, 82, 244, 220);
INSERT INTO public.who_global_data VALUES (57792, 2539, 45973, 44, 952, 244, 30);
INSERT INTO public.who_global_data VALUES (57793, 0, 1317, 0, 14, 244, 147);
INSERT INTO public.who_global_data VALUES (57794, 709, 250021, 23, 29348, 244, 208);
INSERT INTO public.who_global_data VALUES (57795, 13, 1814, 0, 11, 244, 45);
INSERT INTO public.who_global_data VALUES (57796, 215, 6081, 12, 359, 244, 110);
INSERT INTO public.who_global_data VALUES (57797, 8, 90, 0, 1, 244, 88);
INSERT INTO public.who_global_data VALUES (57798, 1146, 43437, 37, 4844, 244, 51);
INSERT INTO public.who_global_data VALUES (57799, 10, 30933, 1, 1715, 244, 209);
INSERT INTO public.who_global_data VALUES (57800, 1, 125, 0, 6, 244, 205);
INSERT INTO public.who_global_data VALUES (57801, 83, 4453, 0, 48, 244, 18);
INSERT INTO public.who_global_data VALUES (57802, 8, 3112, 0, 58, 244, 72);
INSERT INTO public.who_global_data VALUES (57803, 1120, 263242, 143, 38565, 244, 44);
INSERT INTO public.who_global_data VALUES (57804, 0, 24, 0, 0, 244, 15);
INSERT INTO public.who_global_data VALUES (57805, 2, 487, 0, 13, 244, 25);
INSERT INTO public.who_global_data VALUES (57806, 0, 0, 0, 0, 244, 179);
INSERT INTO public.who_global_data VALUES (57807, 0, 0, 0, 0, 244, 34);
INSERT INTO public.who_global_data VALUES (57808, 0, 117, 0, 8, 244, 207);
INSERT INTO public.who_global_data VALUES (57809, 0, 1087, 0, 49, 244, 166);
INSERT INTO public.who_global_data VALUES (57810, 878, 169218, 21, 4669, 244, 126);
INSERT INTO public.who_global_data VALUES (57811, 0, 0, 0, 0, 244, 97);
INSERT INTO public.who_global_data VALUES (57812, 0, 12, 0, 1, 244, 36);
INSERT INTO public.who_global_data VALUES (57813, 0, 0, 0, 0, 244, 125);
INSERT INTO public.who_global_data VALUES (57814, 36, 722, 0, 0, 244, 124);
INSERT INTO public.who_global_data VALUES (57815, 485, 26999, 11, 788, 244, 185);
INSERT INTO public.who_global_data VALUES (57816, 626, 38268, 1, 275, 244, 194);
INSERT INTO public.who_global_data VALUES (57817, 0, 509, 0, 21, 244, 144);
INSERT INTO public.who_global_data VALUES (57818, 28922, 1886794, 1127, 109038, 244, 19);
INSERT INTO public.who_global_data VALUES (57819, 0, 71, 0, 6, 244, 217);
INSERT INTO public.who_global_data VALUES (57820, 2, 834, 0, 23, 244, 148);
INSERT INTO public.who_global_data VALUES (57821, 159, 4181, 1, 17, 244, 86);
INSERT INTO public.who_global_data VALUES (57822, 0, 0, 0, 0, 244, 13);
INSERT INTO public.who_global_data VALUES (57823, 58, 2145, 0, 20, 244, 157);
INSERT INTO public.who_global_data VALUES (57824, 0, 329, 0, 0, 244, 8);
INSERT INTO public.who_global_data VALUES (57825, 0, 0, 0, 0, 244, 73);
INSERT INTO public.who_global_data VALUES (57826, 13, 482, 0, 111, 244, 101);
INSERT INTO public.who_global_data VALUES (57827, 43, 1154, 0, 7, 244, 165);
INSERT INTO public.who_global_data VALUES (57828, 14, 279, 0, 4, 244, 14);
INSERT INTO public.who_global_data VALUES (57829, 582, 19637, 18, 331, 245, 193);
INSERT INTO public.who_global_data VALUES (57830, 20, 1232, 1, 34, 245, 113);
INSERT INTO public.who_global_data VALUES (57831, 104, 9935, 9, 690, 245, 143);
INSERT INTO public.who_global_data VALUES (57832, 0, 0, 0, 0, 245, 219);
INSERT INTO public.who_global_data VALUES (57833, 0, 852, 0, 51, 245, 186);
INSERT INTO public.who_global_data VALUES (57834, 0, 86, 0, 4, 245, 52);
INSERT INTO public.who_global_data VALUES (57835, 0, 3, 0, 0, 245, 180);
INSERT INTO public.who_global_data VALUES (57836, 0, 25, 0, 3, 245, 167);
INSERT INTO public.who_global_data VALUES (57837, 929, 20197, 27, 615, 245, 154);
INSERT INTO public.who_global_data VALUES (57838, 596, 11793, 7, 183, 245, 94);
INSERT INTO public.who_global_data VALUES (57839, 0, 101, 0, 3, 245, 66);
INSERT INTO public.who_global_data VALUES (57840, 11, 7251, 0, 102, 245, 58);
INSERT INTO public.who_global_data VALUES (57841, 62, 16803, 2, 672, 245, 163);
INSERT INTO public.who_global_data VALUES (57842, 338, 6860, 4, 82, 245, 37);
INSERT INTO public.who_global_data VALUES (57843, 0, 102, 0, 11, 245, 142);
INSERT INTO public.who_global_data VALUES (57844, 539, 13835, 1, 22, 245, 83);
INSERT INTO public.who_global_data VALUES (57845, 2828, 60391, 30, 811, 245, 228);
INSERT INTO public.who_global_data VALUES (57846, 0, 92, 0, 7, 245, 188);
INSERT INTO public.who_global_data VALUES (57847, 887, 46868, 6, 259, 245, 62);
INSERT INTO public.who_global_data VALUES (57848, 154, 59789, 12, 9454, 245, 160);
INSERT INTO public.who_global_data VALUES (57849, 0, 18, 0, 2, 245, 50);
INSERT INTO public.who_global_data VALUES (57850, 0, 261, 0, 3, 245, 33);
INSERT INTO public.who_global_data VALUES (57851, 0, 141, 0, 9, 245, 183);
INSERT INTO public.who_global_data VALUES (57852, 1, 48, 0, 0, 245, 92);
INSERT INTO public.who_global_data VALUES (57853, 607, 12245, 15, 415, 245, 158);
INSERT INTO public.who_global_data VALUES (57854, 0, 2, 0, 0, 245, 67);
INSERT INTO public.who_global_data VALUES (57855, 12, 2605, 0, 158, 245, 57);
INSERT INTO public.who_global_data VALUES (57856, 0, 40, 0, 1, 245, 38);
INSERT INTO public.who_global_data VALUES (57857, 30925, 614941, 1473, 34021, 245, 141);
INSERT INTO public.who_global_data VALUES (57858, 0, 8, 0, 1, 245, 178);
INSERT INTO public.who_global_data VALUES (57859, 0, 141, 0, 2, 245, 108);
INSERT INTO public.who_global_data VALUES (57860, 83, 2668, 13, 160, 245, 39);
INSERT INTO public.who_global_data VALUES (57861, 0, 885, 0, 53, 245, 2);
INSERT INTO public.who_global_data VALUES (57862, 0, 63, 0, 1, 245, 195);
INSERT INTO public.who_global_data VALUES (57863, 34, 536, 0, 5, 245, 107);
INSERT INTO public.who_global_data VALUES (57864, 0, 125, 0, 0, 245, 161);
INSERT INTO public.who_global_data VALUES (57865, 603, 7392, 2, 205, 245, 212);
INSERT INTO public.who_global_data VALUES (57866, 629, 94070, 109, 7652, 245, 181);
INSERT INTO public.who_global_data VALUES (57867, 4, 160, 0, 1, 245, 53);
INSERT INTO public.who_global_data VALUES (57868, 163, 1451, 0, 4, 245, 164);
INSERT INTO public.who_global_data VALUES (57869, 8, 836, 2, 68, 245, 140);
INSERT INTO public.who_global_data VALUES (57870, 4207, 122499, 92, 1448, 245, 20);
INSERT INTO public.who_global_data VALUES (57871, 6, 84620, 0, 4645, 245, 112);
INSERT INTO public.who_global_data VALUES (57872, 1766, 35120, 42, 1087, 245, 111);
INSERT INTO public.who_global_data VALUES (57873, 0, 62, 0, 2, 245, 71);
INSERT INTO public.who_global_data VALUES (57874, 4, 639, 0, 20, 245, 218);
INSERT INTO public.who_global_data VALUES (57875, 0, 0, 0, 0, 245, 43);
INSERT INTO public.who_global_data VALUES (57876, 37, 1194, 0, 10, 245, 49);
INSERT INTO public.who_global_data VALUES (57877, 169, 3431, 1, 36, 245, 1);
INSERT INTO public.who_global_data VALUES (57878, 0, 2247, 0, 103, 245, 48);
INSERT INTO public.who_global_data VALUES (57879, 14, 2133, 0, 83, 245, 232);
INSERT INTO public.who_global_data VALUES (57880, 0, 21, 0, 1, 245, 175);
INSERT INTO public.who_global_data VALUES (57881, 2, 960, 0, 17, 245, 21);
INSERT INTO public.who_global_data VALUES (57882, 35, 9529, 1, 327, 245, 156);
INSERT INTO public.who_global_data VALUES (57883, 0, 0, 0, 0, 245, 95);
INSERT INTO public.who_global_data VALUES (57884, 120, 3763, 3, 80, 245, 177);
INSERT INTO public.who_global_data VALUES (57885, 64, 11875, 4, 586, 245, 210);
INSERT INTO public.who_global_data VALUES (57886, 69, 4123, 0, 26, 245, 120);
INSERT INTO public.who_global_data VALUES (57887, 0, 16, 0, 0, 245, 135);
INSERT INTO public.who_global_data VALUES (57888, 389, 18708, 5, 525, 245, 206);
INSERT INTO public.who_global_data VALUES (57889, 1140, 42106, 106, 3592, 245, 189);
INSERT INTO public.who_global_data VALUES (57890, 1348, 31115, 40, 1166, 245, 129);
INSERT INTO public.who_global_data VALUES (57891, 68, 2849, 1, 53, 245, 121);
INSERT INTO public.who_global_data VALUES (57892, 0, 1043, 0, 12, 245, 59);
INSERT INTO public.who_global_data VALUES (57893, 0, 41, 0, 0, 245, 96);
INSERT INTO public.who_global_data VALUES (57894, 20, 1910, 0, 63, 245, 41);
INSERT INTO public.who_global_data VALUES (57895, 5, 305, 0, 3, 245, 216);
INSERT INTO public.who_global_data VALUES (57896, 169, 1805, 1, 19, 245, 236);
INSERT INTO public.who_global_data VALUES (57897, 0, 13, 0, 0, 245, 150);
INSERT INTO public.who_global_data VALUES (57898, 0, 187, 0, 0, 245, 61);
INSERT INTO public.who_global_data VALUES (57899, 0, 18, 0, 0, 245, 7);
INSERT INTO public.who_global_data VALUES (57900, 30, 6941, 0, 322, 245, 169);
INSERT INTO public.who_global_data VALUES (57901, 554, 149495, 46, 29053, 245, 28);
INSERT INTO public.who_global_data VALUES (57902, 33, 589, 0, 1, 245, 85);
INSERT INTO public.who_global_data VALUES (57903, 0, 60, 0, 0, 245, 211);
INSERT INTO public.who_global_data VALUES (57904, 146, 3101, 0, 21, 245, 60);
INSERT INTO public.who_global_data VALUES (57905, 0, 26, 0, 1, 245, 3);
INSERT INTO public.who_global_data VALUES (57906, 2, 808, 0, 13, 245, 11);
INSERT INTO public.who_global_data VALUES (57907, 407, 183678, 33, 8646, 245, 89);
INSERT INTO public.who_global_data VALUES (57908, 283, 9168, 4, 42, 245, 24);
INSERT INTO public.who_global_data VALUES (57909, 1, 174, 0, 0, 245, 162);
INSERT INTO public.who_global_data VALUES (57910, 15, 2967, 0, 180, 245, 100);
INSERT INTO public.who_global_data VALUES (57911, 0, 13, 0, 0, 245, 47);
INSERT INTO public.who_global_data VALUES (57912, 0, 23, 0, 0, 245, 29);
INSERT INTO public.who_global_data VALUES (57913, 2, 164, 0, 14, 245, 40);
INSERT INTO public.who_global_data VALUES (57914, 0, 171, 0, 5, 245, 222);
INSERT INTO public.who_global_data VALUES (57915, 394, 6154, 15, 158, 245, 132);
INSERT INTO public.who_global_data VALUES (57916, 0, 252, 0, 13, 245, 130);
INSERT INTO public.who_global_data VALUES (57917, 69, 4060, 0, 23, 245, 234);
INSERT INTO public.who_global_data VALUES (57918, 22, 1368, 3, 12, 245, 23);
INSERT INTO public.who_global_data VALUES (57919, 0, 153, 0, 12, 245, 192);
INSERT INTO public.who_global_data VALUES (57920, 36, 2640, 0, 50, 245, 69);
INSERT INTO public.who_global_data VALUES (57921, 0, 12, 0, 0, 245, 187);
INSERT INTO public.who_global_data VALUES (57922, 190, 5880, 9, 243, 245, 230);
INSERT INTO public.who_global_data VALUES (57923, 16, 3970, 3, 542, 245, 77);
INSERT INTO public.who_global_data VALUES (57924, 0, 1806, 0, 10, 245, 9);
INSERT INTO public.who_global_data VALUES (57925, 9887, 236657, 294, 6642, 245, 74);
INSERT INTO public.who_global_data VALUES (57926, 703, 29521, 49, 1770, 245, 224);
INSERT INTO public.who_global_data VALUES (57927, 2886, 167156, 63, 8134, 245, 199);
INSERT INTO public.who_global_data VALUES (57928, 1006, 9846, 14, 285, 245, 190);
INSERT INTO public.who_global_data VALUES (57929, 21, 25163, 6, 1670, 245, 12);
INSERT INTO public.who_global_data VALUES (57930, 0, 336, 0, 24, 245, 104);
INSERT INTO public.who_global_data VALUES (57931, 142, 17545, 0, 293, 245, 153);
INSERT INTO public.who_global_data VALUES (57932, 518, 234531, 85, 33774, 245, 91);
INSERT INTO public.who_global_data VALUES (57933, 1, 591, 1, 10, 245, 215);
INSERT INTO public.who_global_data VALUES (57934, 39, 17103, 7, 914, 245, 84);
INSERT INTO public.who_global_data VALUES (57935, 0, 309, 0, 30, 245, 231);
INSERT INTO public.who_global_data VALUES (57936, 8, 755, 0, 9, 245, 196);
INSERT INTO public.who_global_data VALUES (57937, 183, 12694, 2, 54, 245, 105);
INSERT INTO public.who_global_data VALUES (57938, 134, 2474, 1, 79, 245, 122);
INSERT INTO public.who_global_data VALUES (57939, 0, 0, 0, 0, 245, 159);
INSERT INTO public.who_global_data VALUES (57940, 0, 1142, 0, 21, 245, 75);
INSERT INTO public.who_global_data VALUES (57941, 723, 30644, 8, 244, 245, 27);
INSERT INTO public.who_global_data VALUES (57942, 38, 1974, 0, 22, 245, 54);
INSERT INTO public.who_global_data VALUES (57943, 0, 19, 0, 0, 245, 226);
INSERT INTO public.who_global_data VALUES (57944, 0, 1082, 0, 25, 245, 79);
INSERT INTO public.who_global_data VALUES (57945, 6, 1312, 0, 28, 245, 56);
INSERT INTO public.who_global_data VALUES (57946, 0, 4, 0, 0, 245, 117);
INSERT INTO public.who_global_data VALUES (57947, 13, 334, 2, 30, 245, 152);
INSERT INTO public.who_global_data VALUES (57948, 30, 239, 0, 5, 245, 16);
INSERT INTO public.who_global_data VALUES (57949, 0, 83, 0, 1, 245, 10);
INSERT INTO public.who_global_data VALUES (57950, 11, 1700, 0, 71, 245, 201);
INSERT INTO public.who_global_data VALUES (57951, 5, 4032, 0, 110, 245, 174);
INSERT INTO public.who_global_data VALUES (57952, 18, 975, 0, 7, 245, 119);
INSERT INTO public.who_global_data VALUES (57953, 16, 409, 0, 4, 245, 168);
INSERT INTO public.who_global_data VALUES (57954, 19, 8266, 1, 116, 245, 99);
INSERT INTO public.who_global_data VALUES (57955, 11, 1883, 0, 7, 245, 171);
INSERT INTO public.who_global_data VALUES (57956, 24, 1485, 2, 87, 245, 87);
INSERT INTO public.who_global_data VALUES (57957, 2, 626, 0, 9, 245, 123);
INSERT INTO public.who_global_data VALUES (57958, 0, 0, 0, 0, 245, 151);
INSERT INTO public.who_global_data VALUES (57959, 0, 200, 0, 14, 245, 213);
INSERT INTO public.who_global_data VALUES (57960, 99, 883, 4, 43, 245, 118);
INSERT INTO public.who_global_data VALUES (57961, 2, 337, 0, 10, 245, 134);
INSERT INTO public.who_global_data VALUES (57962, 21, 2079, 0, 25, 245, 65);
INSERT INTO public.who_global_data VALUES (57963, 4442, 105680, 817, 12545, 245, 102);
INSERT INTO public.who_global_data VALUES (57964, 0, 0, 0, 0, 245, 223);
INSERT INTO public.who_global_data VALUES (57965, 0, 70, 0, 1, 245, 4);
INSERT INTO public.who_global_data VALUES (57966, 5, 191, 0, 0, 245, 146);
INSERT INTO public.who_global_data VALUES (57967, 0, 324, 0, 9, 245, 31);
INSERT INTO public.who_global_data VALUES (57968, 0, 11, 0, 1, 245, 127);
INSERT INTO public.who_global_data VALUES (57969, 68, 8071, 0, 208, 245, 22);
INSERT INTO public.who_global_data VALUES (57970, 0, 352, 0, 2, 245, 115);
INSERT INTO public.who_global_data VALUES (57971, 0, 236, 0, 6, 245, 106);
INSERT INTO public.who_global_data VALUES (57972, 0, 25, 0, 0, 245, 90);
INSERT INTO public.who_global_data VALUES (57973, 0, 0, 0, 0, 245, 70);
INSERT INTO public.who_global_data VALUES (57974, 278, 2912, 1, 11, 245, 46);
INSERT INTO public.who_global_data VALUES (57975, 217, 46904, 15, 5972, 245, 139);
INSERT INTO public.who_global_data VALUES (57976, 0, 20, 0, 0, 245, 42);
INSERT INTO public.who_global_data VALUES (57977, 0, 1154, 0, 22, 245, 80);
INSERT INTO public.who_global_data VALUES (57978, 0, 1309, 0, 46, 245, 203);
INSERT INTO public.who_global_data VALUES (57979, 3, 966, 0, 65, 245, 136);
INSERT INTO public.who_global_data VALUES (57980, 328, 11844, 10, 333, 245, 63);
INSERT INTO public.who_global_data VALUES (57981, 0, 0, 0, 0, 245, 17);
INSERT INTO public.who_global_data VALUES (57982, 0, 26, 0, 2, 245, 172);
INSERT INTO public.who_global_data VALUES (57983, 180, 2792, 2, 149, 245, 109);
INSERT INTO public.who_global_data VALUES (57984, 27, 8504, 0, 238, 245, 200);
INSERT INTO public.who_global_data VALUES (57985, 0, 643, 0, 5, 245, 93);
INSERT INTO public.who_global_data VALUES (57986, 770, 15086, 5, 72, 245, 5);
INSERT INTO public.who_global_data VALUES (57987, 0, 741, 0, 13, 245, 214);
INSERT INTO public.who_global_data VALUES (57988, 4734, 93983, 97, 1935, 245, 204);
INSERT INTO public.who_global_data VALUES (57989, 0, 0, 0, 0, 245, 198);
INSERT INTO public.who_global_data VALUES (57990, 435, 15044, 6, 363, 245, 173);
INSERT INTO public.who_global_data VALUES (57991, 0, 8, 0, 0, 245, 229);
INSERT INTO public.who_global_data VALUES (57992, 1, 1087, 0, 11, 245, 76);
INSERT INTO public.who_global_data VALUES (57993, 4284, 183198, 137, 5031, 245, 138);
INSERT INTO public.who_global_data VALUES (57994, 244, 20626, 3, 987, 245, 98);
INSERT INTO public.who_global_data VALUES (57995, 0, 0, 0, 0, 245, 103);
INSERT INTO public.who_global_data VALUES (57996, 371, 25419, 20, 1137, 245, 225);
INSERT INTO public.who_global_data VALUES (57997, 377, 33969, 10, 1465, 245, 131);
INSERT INTO public.who_global_data VALUES (57998, 112, 4620, 1, 141, 245, 235);
INSERT INTO public.who_global_data VALUES (57999, 1754, 65495, 4, 49, 245, 137);
INSERT INTO public.who_global_data VALUES (58000, 51, 11719, 0, 273, 245, 81);
INSERT INTO public.who_global_data VALUES (58001, 229, 9247, 8, 323, 245, 182);
INSERT INTO public.who_global_data VALUES (58002, 1, 480, 0, 1, 245, 145);
INSERT INTO public.who_global_data VALUES (58003, 196, 20103, 9, 1308, 245, 26);
INSERT INTO public.who_global_data VALUES (58004, 8855, 458689, 197, 5725, 245, 170);
INSERT INTO public.who_global_data VALUES (58005, 10, 420, 0, 2, 245, 191);
INSERT INTO public.who_global_data VALUES (58006, 0, 3, 0, 0, 245, 221);
INSERT INTO public.who_global_data VALUES (58007, 0, 6, 0, 0, 245, 64);
INSERT INTO public.who_global_data VALUES (58008, 0, 0, 0, 0, 245, 116);
INSERT INTO public.who_global_data VALUES (58009, 0, 15, 0, 0, 245, 128);
INSERT INTO public.who_global_data VALUES (58010, 1, 19, 0, 0, 245, 6);
INSERT INTO public.who_global_data VALUES (58011, 0, 41, 0, 3, 245, 227);
INSERT INTO public.who_global_data VALUES (58012, 0, 1, 0, 0, 245, 68);
INSERT INTO public.who_global_data VALUES (58013, 0, 26, 0, 0, 245, 184);
INSERT INTO public.who_global_data VALUES (58014, 0, 0, 0, 0, 245, 82);
INSERT INTO public.who_global_data VALUES (58015, 0, 695, 0, 42, 245, 149);
INSERT INTO public.who_global_data VALUES (58016, 0, 295, 0, 10, 245, 197);
INSERT INTO public.who_global_data VALUES (58017, 2591, 95748, 31, 642, 245, 78);
INSERT INTO public.who_global_data VALUES (58018, 134, 4155, 0, 45, 245, 233);
INSERT INTO public.who_global_data VALUES (58019, 96, 11667, 1, 247, 245, 133);
INSERT INTO public.who_global_data VALUES (58020, 0, 11, 0, 0, 245, 35);
INSERT INTO public.who_global_data VALUES (58021, 15, 929, 0, 47, 245, 114);
INSERT INTO public.who_global_data VALUES (58022, 261, 37183, 0, 24, 245, 237);
INSERT INTO public.who_global_data VALUES (58023, 0, 2, 0, 0, 245, 55);
INSERT INTO public.who_global_data VALUES (58024, -1, 77, 0, 15, 245, 176);
INSERT INTO public.who_global_data VALUES (58025, 0, 1526, 0, 28, 245, 202);
INSERT INTO public.who_global_data VALUES (58026, 5, 1484, 0, 113, 245, 155);
INSERT INTO public.who_global_data VALUES (58027, 0, 0, 0, 0, 245, 32);
INSERT INTO public.who_global_data VALUES (58028, 0, 2204, 0, 79, 245, 220);
INSERT INTO public.who_global_data VALUES (58029, 2642, 43434, 60, 908, 245, 30);
INSERT INTO public.who_global_data VALUES (58030, 0, 1317, 0, 14, 245, 147);
INSERT INTO public.who_global_data VALUES (58031, 532, 249312, 45, 29325, 245, 208);
INSERT INTO public.who_global_data VALUES (58032, 4, 1801, 0, 11, 245, 45);
INSERT INTO public.who_global_data VALUES (58033, 152, 5866, 14, 347, 245, 110);
INSERT INTO public.who_global_data VALUES (58034, 0, 82, 0, 1, 245, 88);
INSERT INTO public.who_global_data VALUES (58035, 1039, 42291, 43, 4807, 245, 51);
INSERT INTO public.who_global_data VALUES (58036, 15, 30923, 0, 1714, 245, 209);
INSERT INTO public.who_global_data VALUES (58037, 0, 124, 0, 6, 245, 205);
INSERT INTO public.who_global_data VALUES (58038, 81, 4370, 0, 48, 245, 18);
INSERT INTO public.who_global_data VALUES (58039, 2, 3104, 0, 58, 245, 72);
INSERT INTO public.who_global_data VALUES (58040, 1243, 262122, 258, 38422, 245, 44);
INSERT INTO public.who_global_data VALUES (58041, 0, 24, 0, 0, 245, 15);
INSERT INTO public.who_global_data VALUES (58042, 20, 485, 0, 13, 245, 25);
INSERT INTO public.who_global_data VALUES (58043, 0, 0, 0, 0, 245, 179);
INSERT INTO public.who_global_data VALUES (58044, 0, 0, 0, 0, 245, 34);
INSERT INTO public.who_global_data VALUES (58045, 0, 117, 0, 8, 245, 207);
INSERT INTO public.who_global_data VALUES (58046, 0, 1087, 0, 49, 245, 166);
INSERT INTO public.who_global_data VALUES (58047, 930, 168340, 18, 4648, 245, 126);
INSERT INTO public.who_global_data VALUES (58048, 0, 0, 0, 0, 245, 97);
INSERT INTO public.who_global_data VALUES (58049, 0, 12, 0, 1, 245, 36);
INSERT INTO public.who_global_data VALUES (58050, 0, 0, 0, 0, 245, 125);
INSERT INTO public.who_global_data VALUES (58051, 35, 686, 0, 0, 245, 124);
INSERT INTO public.who_global_data VALUES (58052, 550, 26514, 15, 777, 245, 185);
INSERT INTO public.who_global_data VALUES (58053, 624, 37642, 1, 274, 245, 194);
INSERT INTO public.who_global_data VALUES (58054, 0, 509, 0, 21, 245, 144);
INSERT INTO public.who_global_data VALUES (58055, 20069, 1857872, 1035, 107911, 245, 19);
INSERT INTO public.who_global_data VALUES (58056, 0, 71, 0, 6, 245, 217);
INSERT INTO public.who_global_data VALUES (58057, 4, 832, 0, 23, 245, 148);
INSERT INTO public.who_global_data VALUES (58058, 57, 4022, 0, 16, 245, 86);
INSERT INTO public.who_global_data VALUES (58059, 0, 0, 0, 0, 245, 13);
INSERT INTO public.who_global_data VALUES (58060, 135, 2087, 0, 20, 245, 157);
INSERT INTO public.who_global_data VALUES (58061, 1, 329, 0, 0, 245, 8);
INSERT INTO public.who_global_data VALUES (58062, 0, 0, 0, 0, 245, 73);
INSERT INTO public.who_global_data VALUES (58063, 16, 469, 8, 111, 245, 101);
INSERT INTO public.who_global_data VALUES (58064, 0, 1111, 0, 7, 245, 165);
INSERT INTO public.who_global_data VALUES (58065, 43, 265, 0, 4, 245, 14);
INSERT INTO public.who_global_data VALUES (58066, 1078, 19055, 10, 313, 246, 193);
INSERT INTO public.who_global_data VALUES (58067, 15, 1212, 0, 33, 246, 113);
INSERT INTO public.who_global_data VALUES (58068, 98, 9831, 8, 681, 246, 143);
INSERT INTO public.who_global_data VALUES (58069, 0, 0, 0, 0, 246, 219);
INSERT INTO public.who_global_data VALUES (58070, 1, 852, 0, 51, 246, 186);
INSERT INTO public.who_global_data VALUES (58071, 0, 86, 0, 4, 246, 52);
INSERT INTO public.who_global_data VALUES (58072, 0, 3, 0, 0, 246, 180);
INSERT INTO public.who_global_data VALUES (58073, 0, 25, 0, 3, 246, 167);
INSERT INTO public.who_global_data VALUES (58074, 949, 19268, 18, 588, 246, 154);
INSERT INTO public.who_global_data VALUES (58075, 697, 11197, 6, 176, 246, 94);
INSERT INTO public.who_global_data VALUES (58076, 0, 101, 0, 3, 246, 66);
INSERT INTO public.who_global_data VALUES (58077, 11, 7240, 0, 102, 246, 58);
INSERT INTO public.who_global_data VALUES (58078, 36, 16741, 0, 670, 246, 163);
INSERT INTO public.who_global_data VALUES (58079, 262, 6522, 2, 78, 246, 37);
INSERT INTO public.who_global_data VALUES (58080, 0, 102, 0, 11, 246, 142);
INSERT INTO public.who_global_data VALUES (58081, 481, 13296, 1, 21, 246, 83);
INSERT INTO public.who_global_data VALUES (58082, 2423, 57563, 35, 781, 246, 228);
INSERT INTO public.who_global_data VALUES (58083, 0, 92, 0, 7, 246, 188);
INSERT INTO public.who_global_data VALUES (58084, 865, 45981, 5, 253, 246, 62);
INSERT INTO public.who_global_data VALUES (58085, 172, 59635, 14, 9442, 246, 160);
INSERT INTO public.who_global_data VALUES (58086, 0, 18, 0, 2, 246, 50);
INSERT INTO public.who_global_data VALUES (58087, 17, 261, 0, 3, 246, 33);
INSERT INTO public.who_global_data VALUES (58088, 0, 141, 0, 9, 246, 183);
INSERT INTO public.who_global_data VALUES (58089, 0, 47, 0, 0, 246, 92);
INSERT INTO public.who_global_data VALUES (58090, 647, 11638, 24, 400, 246, 158);
INSERT INTO public.who_global_data VALUES (58091, 0, 2, 0, 0, 246, 67);
INSERT INTO public.who_global_data VALUES (58092, 43, 2593, 2, 158, 246, 57);
INSERT INTO public.who_global_data VALUES (58093, 0, 40, 0, 1, 246, 38);
INSERT INTO public.who_global_data VALUES (58094, 28633, 584016, 1349, 32548, 246, 141);
INSERT INTO public.who_global_data VALUES (58095, 0, 8, 0, 1, 246, 178);
INSERT INTO public.who_global_data VALUES (58096, 0, 141, 0, 2, 246, 108);
INSERT INTO public.who_global_data VALUES (58097, 0, 2585, 0, 147, 246, 39);
INSERT INTO public.who_global_data VALUES (58098, 1, 885, 0, 53, 246, 2);
INSERT INTO public.who_global_data VALUES (58099, 0, 63, 0, 1, 246, 195);
INSERT INTO public.who_global_data VALUES (58100, 25, 502, 0, 5, 246, 107);
INSERT INTO public.who_global_data VALUES (58101, 0, 125, 0, 0, 246, 161);
INSERT INTO public.who_global_data VALUES (58102, 37, 6789, 3, 203, 246, 212);
INSERT INTO public.who_global_data VALUES (58103, 693, 93441, 129, 7543, 246, 181);
INSERT INTO public.who_global_data VALUES (58104, 5, 156, 0, 1, 246, 53);
INSERT INTO public.who_global_data VALUES (58105, 99, 1288, 0, 4, 246, 164);
INSERT INTO public.who_global_data VALUES (58106, 8, 828, 0, 66, 246, 140);
INSERT INTO public.who_global_data VALUES (58107, 4664, 118292, 81, 1356, 246, 20);
INSERT INTO public.who_global_data VALUES (58108, 11, 84614, 0, 4645, 246, 112);
INSERT INTO public.who_global_data VALUES (58109, 1521, 33354, 36, 1045, 246, 111);
INSERT INTO public.who_global_data VALUES (58110, 0, 62, 0, 2, 246, 71);
INSERT INTO public.who_global_data VALUES (58111, 3, 635, 0, 20, 246, 218);
INSERT INTO public.who_global_data VALUES (58112, 0, 0, 0, 0, 246, 43);
INSERT INTO public.who_global_data VALUES (58113, 52, 1157, 0, 10, 246, 49);
INSERT INTO public.who_global_data VALUES (58114, 152, 3262, 0, 35, 246, 1);
INSERT INTO public.who_global_data VALUES (58115, 1, 2247, 0, 103, 246, 48);
INSERT INTO public.who_global_data VALUES (58116, 12, 2119, 0, 83, 246, 232);
INSERT INTO public.who_global_data VALUES (58117, 1, 21, 0, 1, 246, 175);
INSERT INTO public.who_global_data VALUES (58118, 0, 958, 0, 17, 246, 21);
INSERT INTO public.who_global_data VALUES (58119, 56, 9494, 2, 326, 246, 156);
INSERT INTO public.who_global_data VALUES (58120, 0, 0, 0, 0, 246, 95);
INSERT INTO public.who_global_data VALUES (58121, 149, 3643, 3, 77, 246, 177);
INSERT INTO public.who_global_data VALUES (58122, 40, 11811, 2, 582, 246, 210);
INSERT INTO public.who_global_data VALUES (58123, 119, 4054, 0, 26, 246, 120);
INSERT INTO public.who_global_data VALUES (58124, 0, 16, 0, 0, 246, 135);
INSERT INTO public.who_global_data VALUES (58125, 279, 18319, 4, 520, 246, 206);
INSERT INTO public.who_global_data VALUES (58126, 0, 40966, 0, 3486, 246, 189);
INSERT INTO public.who_global_data VALUES (58127, 1152, 29767, 38, 1126, 246, 129);
INSERT INTO public.who_global_data VALUES (58128, 76, 2781, 1, 52, 246, 121);
INSERT INTO public.who_global_data VALUES (58129, 0, 1043, 0, 12, 246, 59);
INSERT INTO public.who_global_data VALUES (58130, 2, 41, 0, 0, 246, 96);
INSERT INTO public.who_global_data VALUES (58131, 10, 1890, 0, 63, 246, 41);
INSERT INTO public.who_global_data VALUES (58132, 5, 300, 0, 3, 246, 216);
INSERT INTO public.who_global_data VALUES (58133, 150, 1636, 1, 18, 246, 236);
INSERT INTO public.who_global_data VALUES (58134, 0, 13, 0, 0, 246, 150);
INSERT INTO public.who_global_data VALUES (58135, 0, 187, 0, 0, 246, 61);
INSERT INTO public.who_global_data VALUES (58136, 0, 18, 0, 0, 246, 7);
INSERT INTO public.who_global_data VALUES (58137, 0, 6911, 1, 322, 246, 169);
INSERT INTO public.who_global_data VALUES (58138, 678, 148941, 43, 29007, 246, 28);
INSERT INTO public.who_global_data VALUES (58139, 23, 556, 0, 1, 246, 85);
INSERT INTO public.who_global_data VALUES (58140, 0, 60, 0, 0, 246, 211);
INSERT INTO public.who_global_data VALUES (58141, 53, 2955, 1, 21, 246, 60);
INSERT INTO public.who_global_data VALUES (58142, 0, 26, 0, 1, 246, 3);
INSERT INTO public.who_global_data VALUES (58143, 5, 806, 0, 13, 246, 11);
INSERT INTO public.who_global_data VALUES (58144, 507, 183271, 32, 8613, 246, 89);
INSERT INTO public.who_global_data VALUES (58145, 337, 8885, 0, 38, 246, 24);
INSERT INTO public.who_global_data VALUES (58146, 1, 173, 0, 0, 246, 162);
INSERT INTO public.who_global_data VALUES (58147, 15, 2952, 1, 180, 246, 100);
INSERT INTO public.who_global_data VALUES (58148, 0, 13, 0, 0, 246, 47);
INSERT INTO public.who_global_data VALUES (58149, 0, 23, 0, 0, 246, 29);
INSERT INTO public.who_global_data VALUES (58150, 0, 162, 0, 14, 246, 40);
INSERT INTO public.who_global_data VALUES (58151, 1, 171, 0, 5, 246, 222);
INSERT INTO public.who_global_data VALUES (58152, 174, 5760, 20, 143, 246, 132);
INSERT INTO public.who_global_data VALUES (58153, 0, 252, 0, 13, 246, 130);
INSERT INTO public.who_global_data VALUES (58154, 58, 3991, 0, 23, 246, 234);
INSERT INTO public.who_global_data VALUES (58155, 0, 1346, 0, 9, 246, 23);
INSERT INTO public.who_global_data VALUES (58156, 0, 153, 0, 12, 246, 192);
INSERT INTO public.who_global_data VALUES (58157, 97, 2604, 2, 50, 246, 69);
INSERT INTO public.who_global_data VALUES (58158, 0, 12, 0, 0, 246, 187);
INSERT INTO public.who_global_data VALUES (58159, 163, 5690, 9, 234, 246, 230);
INSERT INTO public.who_global_data VALUES (58160, 23, 3954, 5, 539, 246, 77);
INSERT INTO public.who_global_data VALUES (58161, 0, 1806, 0, 10, 246, 9);
INSERT INTO public.who_global_data VALUES (58162, 9851, 226770, 273, 6348, 246, 74);
INSERT INTO public.who_global_data VALUES (58163, 585, 28818, 23, 1721, 246, 224);
INSERT INTO public.who_global_data VALUES (58164, 3574, 164270, 59, 8071, 246, 199);
INSERT INTO public.who_global_data VALUES (58165, 672, 8840, 15, 271, 246, 190);
INSERT INTO public.who_global_data VALUES (58166, 31, 25142, 5, 1664, 246, 12);
INSERT INTO public.who_global_data VALUES (58167, 0, 336, 0, 24, 246, 104);
INSERT INTO public.who_global_data VALUES (58168, 97, 17403, 1, 293, 246, 153);
INSERT INTO public.who_global_data VALUES (58169, 177, 234013, 88, 33689, 246, 91);
INSERT INTO public.who_global_data VALUES (58170, 0, 590, 0, 9, 246, 215);
INSERT INTO public.who_global_data VALUES (58171, 46, 17064, 4, 907, 246, 84);
INSERT INTO public.who_global_data VALUES (58172, 1, 309, 0, 30, 246, 231);
INSERT INTO public.who_global_data VALUES (58173, 2, 747, 0, 9, 246, 196);
INSERT INTO public.who_global_data VALUES (58174, 199, 12511, 4, 52, 246, 105);
INSERT INTO public.who_global_data VALUES (58175, 124, 2340, 4, 78, 246, 122);
INSERT INTO public.who_global_data VALUES (58176, 0, 0, 0, 0, 246, 159);
INSERT INTO public.who_global_data VALUES (58177, 0, 1142, 0, 21, 246, 75);
INSERT INTO public.who_global_data VALUES (58178, 562, 29921, 6, 236, 246, 27);
INSERT INTO public.who_global_data VALUES (58179, 37, 1936, 2, 22, 246, 54);
INSERT INTO public.who_global_data VALUES (58180, 0, 19, 0, 0, 246, 226);
INSERT INTO public.who_global_data VALUES (58181, 3, 1082, 1, 25, 246, 79);
INSERT INTO public.who_global_data VALUES (58182, 50, 1306, 1, 28, 246, 56);
INSERT INTO public.who_global_data VALUES (58183, 0, 4, 0, 0, 246, 117);
INSERT INTO public.who_global_data VALUES (58184, 5, 321, 0, 28, 246, 152);
INSERT INTO public.who_global_data VALUES (58185, 13, 209, 0, 5, 246, 16);
INSERT INTO public.who_global_data VALUES (58186, 0, 83, 0, 1, 246, 10);
INSERT INTO public.who_global_data VALUES (58187, 5, 1689, 0, 71, 246, 201);
INSERT INTO public.who_global_data VALUES (58188, 7, 4027, 0, 110, 246, 174);
INSERT INTO public.who_global_data VALUES (58189, 49, 957, 1, 7, 246, 119);
INSERT INTO public.who_global_data VALUES (58190, 24, 393, 0, 4, 246, 168);
INSERT INTO public.who_global_data VALUES (58191, 277, 8247, 0, 115, 246, 99);
INSERT INTO public.who_global_data VALUES (58192, 22, 1872, 0, 7, 246, 171);
INSERT INTO public.who_global_data VALUES (58193, 75, 1461, 6, 85, 246, 87);
INSERT INTO public.who_global_data VALUES (58194, 3, 624, 0, 9, 246, 123);
INSERT INTO public.who_global_data VALUES (58195, 0, 0, 0, 0, 246, 151);
INSERT INTO public.who_global_data VALUES (58196, 0, 200, 0, 14, 246, 213);
INSERT INTO public.who_global_data VALUES (58197, 116, 784, 8, 39, 246, 118);
INSERT INTO public.who_global_data VALUES (58198, 0, 335, 0, 10, 246, 134);
INSERT INTO public.who_global_data VALUES (58199, 65, 2058, 1, 25, 246, 65);
INSERT INTO public.who_global_data VALUES (58200, 3912, 101238, 1091, 11728, 246, 102);
INSERT INTO public.who_global_data VALUES (58201, 0, 0, 0, 0, 246, 223);
INSERT INTO public.who_global_data VALUES (58202, 0, 70, 0, 1, 246, 4);
INSERT INTO public.who_global_data VALUES (58203, 1, 186, 0, 0, 246, 146);
INSERT INTO public.who_global_data VALUES (58204, 0, 324, 0, 9, 246, 31);
INSERT INTO public.who_global_data VALUES (58205, 0, 11, 0, 1, 246, 127);
INSERT INTO public.who_global_data VALUES (58206, 81, 8003, 2, 208, 246, 22);
INSERT INTO public.who_global_data VALUES (58207, 36, 352, 0, 2, 246, 115);
INSERT INTO public.who_global_data VALUES (58208, 2, 236, 0, 6, 246, 106);
INSERT INTO public.who_global_data VALUES (58209, 0, 25, 0, 0, 246, 90);
INSERT INTO public.who_global_data VALUES (58210, 0, 0, 0, 0, 246, 70);
INSERT INTO public.who_global_data VALUES (58211, 334, 2634, 1, 10, 246, 46);
INSERT INTO public.who_global_data VALUES (58212, 188, 46687, 12, 5957, 246, 139);
INSERT INTO public.who_global_data VALUES (58213, 1, 20, 0, 0, 246, 42);
INSERT INTO public.who_global_data VALUES (58214, 0, 1154, 0, 22, 246, 80);
INSERT INTO public.who_global_data VALUES (58215, 0, 1309, 0, 46, 246, 203);
INSERT INTO public.who_global_data VALUES (58216, 2, 963, 0, 65, 246, 136);
INSERT INTO public.who_global_data VALUES (58217, 350, 11516, 8, 323, 246, 63);
INSERT INTO public.who_global_data VALUES (58218, 0, 0, 0, 0, 246, 17);
INSERT INTO public.who_global_data VALUES (58219, 2, 26, 0, 2, 246, 172);
INSERT INTO public.who_global_data VALUES (58220, 120, 2612, 2, 147, 246, 109);
INSERT INTO public.who_global_data VALUES (58221, 31, 8477, 1, 238, 246, 200);
INSERT INTO public.who_global_data VALUES (58222, 7, 643, 0, 5, 246, 93);
INSERT INTO public.who_global_data VALUES (58223, 779, 14316, 0, 67, 246, 5);
INSERT INTO public.who_global_data VALUES (58224, 0, 741, 0, 13, 246, 214);
INSERT INTO public.who_global_data VALUES (58225, 3985, 89249, 68, 1838, 246, 204);
INSERT INTO public.who_global_data VALUES (58226, 0, 0, 0, 0, 246, 198);
INSERT INTO public.who_global_data VALUES (58227, 514, 14609, 5, 357, 246, 173);
INSERT INTO public.who_global_data VALUES (58228, 0, 8, 0, 0, 246, 229);
INSERT INTO public.who_global_data VALUES (58229, 16, 1086, 0, 11, 246, 76);
INSERT INTO public.who_global_data VALUES (58230, 4030, 178914, 127, 4894, 246, 138);
INSERT INTO public.who_global_data VALUES (58231, 634, 20382, 10, 984, 246, 98);
INSERT INTO public.who_global_data VALUES (58232, 0, 0, 0, 0, 246, 103);
INSERT INTO public.who_global_data VALUES (58233, 361, 25048, 2, 1117, 246, 225);
INSERT INTO public.who_global_data VALUES (58234, 331, 33592, 8, 1455, 246, 131);
INSERT INTO public.who_global_data VALUES (58235, 485, 4508, 0, 140, 246, 235);
INSERT INTO public.who_global_data VALUES (58236, 1581, 63741, 0, 45, 246, 137);
INSERT INTO public.who_global_data VALUES (58237, 39, 11668, 0, 273, 246, 81);
INSERT INTO public.who_global_data VALUES (58238, 223, 9018, 1, 315, 246, 182);
INSERT INTO public.who_global_data VALUES (58239, 1, 479, 0, 1, 246, 145);
INSERT INTO public.who_global_data VALUES (58240, 238, 19907, 11, 1299, 246, 26);
INSERT INTO public.who_global_data VALUES (58241, 8726, 449834, 144, 5528, 246, 170);
INSERT INTO public.who_global_data VALUES (58242, 13, 410, 0, 2, 246, 191);
INSERT INTO public.who_global_data VALUES (58243, 0, 3, 0, 0, 246, 221);
INSERT INTO public.who_global_data VALUES (58244, 0, 6, 0, 0, 246, 64);
INSERT INTO public.who_global_data VALUES (58245, 0, 0, 0, 0, 246, 116);
INSERT INTO public.who_global_data VALUES (58246, 0, 15, 0, 0, 246, 128);
INSERT INTO public.who_global_data VALUES (58247, 0, 18, 0, 0, 246, 6);
INSERT INTO public.who_global_data VALUES (58248, 0, 41, 0, 3, 246, 227);
INSERT INTO public.who_global_data VALUES (58249, 0, 1, 0, 0, 246, 68);
INSERT INTO public.who_global_data VALUES (58250, 0, 26, 0, 0, 246, 184);
INSERT INTO public.who_global_data VALUES (58251, 0, 0, 0, 0, 246, 82);
INSERT INTO public.who_global_data VALUES (58252, 8, 695, 0, 42, 246, 149);
INSERT INTO public.who_global_data VALUES (58253, 0, 295, 0, 10, 246, 197);
INSERT INTO public.who_global_data VALUES (58254, 1975, 93157, 32, 611, 246, 78);
INSERT INTO public.who_global_data VALUES (58255, 89, 4021, 0, 45, 246, 233);
INSERT INTO public.who_global_data VALUES (58256, 48, 11571, 1, 246, 246, 133);
INSERT INTO public.who_global_data VALUES (58257, 0, 11, 0, 0, 246, 35);
INSERT INTO public.who_global_data VALUES (58258, 5, 914, 0, 47, 246, 114);
INSERT INTO public.who_global_data VALUES (58259, 517, 36922, 0, 24, 246, 237);
INSERT INTO public.who_global_data VALUES (58260, 0, 2, 0, 0, 246, 55);
INSERT INTO public.who_global_data VALUES (58261, 0, 78, 0, 15, 246, 176);
INSERT INTO public.who_global_data VALUES (58262, 1, 1526, 0, 28, 246, 202);
INSERT INTO public.who_global_data VALUES (58263, 2, 1479, 0, 113, 246, 155);
INSERT INTO public.who_global_data VALUES (58264, 0, 0, 0, 0, 246, 32);
INSERT INTO public.who_global_data VALUES (58265, 58, 2204, 0, 79, 246, 220);
INSERT INTO public.who_global_data VALUES (58266, 3267, 40792, 56, 848, 246, 30);
INSERT INTO public.who_global_data VALUES (58267, 0, 1317, 0, 14, 246, 147);
INSERT INTO public.who_global_data VALUES (58268, 631, 248780, 38, 29280, 246, 208);
INSERT INTO public.who_global_data VALUES (58269, 48, 1797, 0, 11, 246, 45);
INSERT INTO public.who_global_data VALUES (58270, 215, 5714, 19, 333, 246, 110);
INSERT INTO public.who_global_data VALUES (58271, 28, 82, 0, 1, 246, 88);
INSERT INTO public.who_global_data VALUES (58272, 1046, 41252, 28, 4764, 246, 51);
INSERT INTO public.who_global_data VALUES (58273, 17, 30908, 0, 1714, 246, 209);
INSERT INTO public.who_global_data VALUES (58274, 1, 124, 0, 6, 246, 205);
INSERT INTO public.who_global_data VALUES (58275, 98, 4289, 0, 48, 246, 18);
INSERT INTO public.who_global_data VALUES (58276, 1, 3102, 0, 58, 246, 72);
INSERT INTO public.who_global_data VALUES (58277, 1356, 260879, 130, 38164, 246, 44);
INSERT INTO public.who_global_data VALUES (58278, 0, 24, 0, 0, 246, 15);
INSERT INTO public.who_global_data VALUES (58279, 13, 465, 0, 13, 246, 25);
INSERT INTO public.who_global_data VALUES (58280, 0, 0, 0, 0, 246, 179);
INSERT INTO public.who_global_data VALUES (58281, 0, 0, 0, 0, 246, 34);
INSERT INTO public.who_global_data VALUES (58282, 0, 117, 0, 8, 246, 207);
INSERT INTO public.who_global_data VALUES (58283, 0, 1087, 0, 49, 246, 166);
INSERT INTO public.who_global_data VALUES (58284, 988, 167410, 21, 4630, 246, 126);
INSERT INTO public.who_global_data VALUES (58285, 0, 0, 0, 0, 246, 97);
INSERT INTO public.who_global_data VALUES (58286, 0, 12, 0, 1, 246, 36);
INSERT INTO public.who_global_data VALUES (58287, 0, 0, 0, 0, 246, 125);
INSERT INTO public.who_global_data VALUES (58288, 15, 651, 0, 0, 246, 124);
INSERT INTO public.who_global_data VALUES (58289, 553, 25964, 14, 762, 246, 185);
INSERT INTO public.who_global_data VALUES (58290, 659, 37018, 3, 273, 246, 194);
INSERT INTO public.who_global_data VALUES (58291, 0, 509, 0, 21, 246, 144);
INSERT INTO public.who_global_data VALUES (58292, 14583, 1837803, 825, 106876, 246, 19);
INSERT INTO public.who_global_data VALUES (58293, 1, 71, 0, 6, 246, 217);
INSERT INTO public.who_global_data VALUES (58294, 2, 828, 0, 23, 246, 148);
INSERT INTO public.who_global_data VALUES (58295, 91, 3965, 0, 16, 246, 86);
INSERT INTO public.who_global_data VALUES (58296, 0, 0, 0, 0, 246, 13);
INSERT INTO public.who_global_data VALUES (58297, 133, 1952, 2, 20, 246, 157);
INSERT INTO public.who_global_data VALUES (58298, 0, 328, 0, 0, 246, 8);
INSERT INTO public.who_global_data VALUES (58299, 0, 0, 0, 0, 246, 73);
INSERT INTO public.who_global_data VALUES (58300, 34, 453, 8, 103, 246, 101);
INSERT INTO public.who_global_data VALUES (58301, 22, 1111, 0, 7, 246, 165);
INSERT INTO public.who_global_data VALUES (58302, 0, 222, 0, 4, 246, 14);
INSERT INTO public.who_global_data VALUES (58303, 624, 17977, 5, 303, 247, 193);
INSERT INTO public.who_global_data VALUES (58304, 36, 1197, 0, 33, 247, 113);
INSERT INTO public.who_global_data VALUES (58305, 107, 9733, 6, 673, 247, 143);
INSERT INTO public.who_global_data VALUES (58306, 0, 0, 0, 0, 247, 219);
INSERT INTO public.who_global_data VALUES (58307, 7, 851, 0, 51, 247, 186);
INSERT INTO public.who_global_data VALUES (58308, 0, 86, 0, 4, 247, 52);
INSERT INTO public.who_global_data VALUES (58309, 0, 3, 0, 0, 247, 180);
INSERT INTO public.who_global_data VALUES (58310, 0, 25, 0, 3, 247, 167);
INSERT INTO public.who_global_data VALUES (58311, 904, 18319, 10, 570, 247, 154);
INSERT INTO public.who_global_data VALUES (58312, 515, 10500, 12, 170, 247, 94);
INSERT INTO public.who_global_data VALUES (58313, 0, 101, 0, 3, 247, 66);
INSERT INTO public.who_global_data VALUES (58314, 8, 7229, -1, 102, 247, 58);
INSERT INTO public.who_global_data VALUES (58315, 31, 16705, 1, 670, 247, 163);
INSERT INTO public.who_global_data VALUES (58316, 325, 6260, 5, 76, 247, 37);
INSERT INTO public.who_global_data VALUES (58317, 0, 102, 0, 11, 247, 142);
INSERT INTO public.who_global_data VALUES (58318, 504, 12815, 1, 20, 247, 83);
INSERT INTO public.who_global_data VALUES (58319, 2695, 55140, 37, 746, 247, 228);
INSERT INTO public.who_global_data VALUES (58320, 0, 92, 0, 7, 247, 188);
INSERT INTO public.who_global_data VALUES (58321, 861, 45116, 5, 248, 247, 62);
INSERT INTO public.who_global_data VALUES (58322, 159, 59463, 20, 9428, 247, 160);
INSERT INTO public.who_global_data VALUES (58323, 0, 18, 0, 2, 247, 50);
INSERT INTO public.who_global_data VALUES (58324, 0, 244, 0, 3, 247, 33);
INSERT INTO public.who_global_data VALUES (58325, 0, 141, 0, 9, 247, 183);
INSERT INTO public.who_global_data VALUES (58326, 0, 47, 0, 0, 247, 92);
INSERT INTO public.who_global_data VALUES (58327, 460, 10991, 33, 376, 247, 158);
INSERT INTO public.who_global_data VALUES (58328, 0, 2, 0, 0, 247, 67);
INSERT INTO public.who_global_data VALUES (58329, 16, 2550, 0, 156, 247, 57);
INSERT INTO public.who_global_data VALUES (58330, 0, 40, 0, 1, 247, 38);
INSERT INTO public.who_global_data VALUES (58331, 28936, 555383, 1262, 31199, 247, 141);
INSERT INTO public.who_global_data VALUES (58332, 0, 8, 0, 1, 247, 178);
INSERT INTO public.who_global_data VALUES (58333, 0, 141, 0, 2, 247, 108);
INSERT INTO public.who_global_data VALUES (58334, 47, 2585, 3, 147, 247, 39);
INSERT INTO public.who_global_data VALUES (58335, 0, 884, 0, 53, 247, 2);
INSERT INTO public.who_global_data VALUES (58336, 0, 63, 0, 1, 247, 195);
INSERT INTO public.who_global_data VALUES (58337, 11, 477, 0, 5, 247, 107);
INSERT INTO public.who_global_data VALUES (58338, 0, 125, 0, 0, 247, 161);
INSERT INTO public.who_global_data VALUES (58339, 167, 6752, 0, 200, 247, 212);
INSERT INTO public.who_global_data VALUES (58340, 597, 92748, 70, 7414, 247, 181);
INSERT INTO public.who_global_data VALUES (58341, 1, 151, 0, 1, 247, 53);
INSERT INTO public.who_global_data VALUES (58342, 120, 1189, 0, 4, 247, 164);
INSERT INTO public.who_global_data VALUES (58343, 17, 820, 0, 66, 247, 140);
INSERT INTO public.who_global_data VALUES (58344, 4942, 113628, 87, 1275, 247, 20);
INSERT INTO public.who_global_data VALUES (58345, 1, 84603, 0, 4645, 247, 112);
INSERT INTO public.who_global_data VALUES (58346, 1340, 31833, 40, 1009, 247, 111);
INSERT INTO public.who_global_data VALUES (58347, 0, 62, 0, 2, 247, 71);
INSERT INTO public.who_global_data VALUES (58348, 14, 632, 0, 20, 247, 218);
INSERT INTO public.who_global_data VALUES (58349, 0, 0, 0, 0, 247, 43);
INSERT INTO public.who_global_data VALUES (58350, 21, 1105, 0, 10, 247, 49);
INSERT INTO public.who_global_data VALUES (58351, 86, 3110, 2, 35, 247, 1);
INSERT INTO public.who_global_data VALUES (58352, 0, 2246, 0, 103, 247, 48);
INSERT INTO public.who_global_data VALUES (58353, 15, 2107, 0, 83, 247, 232);
INSERT INTO public.who_global_data VALUES (58354, 0, 20, 0, 1, 247, 175);
INSERT INTO public.who_global_data VALUES (58355, 6, 958, 0, 17, 247, 21);
INSERT INTO public.who_global_data VALUES (58356, 74, 9438, 1, 324, 247, 156);
INSERT INTO public.who_global_data VALUES (58357, 0, 0, 0, 0, 247, 95);
INSERT INTO public.who_global_data VALUES (58358, 169, 3494, 3, 74, 247, 177);
INSERT INTO public.who_global_data VALUES (58359, 37, 11771, 0, 580, 247, 210);
INSERT INTO public.who_global_data VALUES (58360, 156, 3935, 1, 26, 247, 120);
INSERT INTO public.who_global_data VALUES (58361, 0, 16, 0, 0, 247, 135);
INSERT INTO public.who_global_data VALUES (58362, 288, 18040, 1, 516, 247, 206);
INSERT INTO public.who_global_data VALUES (58363, 552, 40966, 48, 3486, 247, 189);
INSERT INTO public.who_global_data VALUES (58364, 1079, 28615, 36, 1088, 247, 129);
INSERT INTO public.who_global_data VALUES (58365, 52, 2705, 5, 51, 247, 121);
INSERT INTO public.who_global_data VALUES (58366, 0, 1043, 0, 12, 247, 59);
INSERT INTO public.who_global_data VALUES (58367, 0, 39, 0, 0, 247, 96);
INSERT INTO public.who_global_data VALUES (58368, 10, 1880, 0, 63, 247, 41);
INSERT INTO public.who_global_data VALUES (58369, 1, 295, 0, 3, 247, 216);
INSERT INTO public.who_global_data VALUES (58370, 142, 1486, 3, 17, 247, 236);
INSERT INTO public.who_global_data VALUES (58371, 0, 13, 0, 0, 247, 150);
INSERT INTO public.who_global_data VALUES (58372, 0, 187, 0, 0, 247, 61);
INSERT INTO public.who_global_data VALUES (58373, 0, 18, 0, 0, 247, 7);
INSERT INTO public.who_global_data VALUES (58374, 24, 6911, 1, 321, 247, 169);
INSERT INTO public.who_global_data VALUES (58375, 328, 148263, 81, 28964, 247, 28);
INSERT INTO public.who_global_data VALUES (58376, 16, 533, 0, 1, 247, 85);
INSERT INTO public.who_global_data VALUES (58377, 0, 60, 0, 0, 247, 211);
INSERT INTO public.who_global_data VALUES (58378, 99, 2902, 0, 20, 247, 60);
INSERT INTO public.who_global_data VALUES (58379, 0, 26, 0, 1, 247, 3);
INSERT INTO public.who_global_data VALUES (58380, 1, 801, 0, 13, 247, 11);
INSERT INTO public.who_global_data VALUES (58381, 394, 182764, 30, 8581, 247, 89);
INSERT INTO public.who_global_data VALUES (58382, 251, 8548, 0, 38, 247, 24);
INSERT INTO public.who_global_data VALUES (58383, 2, 172, 0, 0, 247, 162);
INSERT INTO public.who_global_data VALUES (58384, 0, 2937, 0, 179, 247, 100);
INSERT INTO public.who_global_data VALUES (58385, 0, 13, 0, 0, 247, 47);
INSERT INTO public.who_global_data VALUES (58386, 0, 23, 0, 0, 247, 29);
INSERT INTO public.who_global_data VALUES (58387, 0, 162, 0, 14, 247, 40);
INSERT INTO public.who_global_data VALUES (58388, 1, 170, 0, 5, 247, 222);
INSERT INTO public.who_global_data VALUES (58389, 250, 5586, 7, 123, 247, 132);
INSERT INTO public.who_global_data VALUES (58390, 0, 252, 0, 13, 247, 130);
INSERT INTO public.who_global_data VALUES (58391, 47, 3933, 0, 23, 247, 234);
INSERT INTO public.who_global_data VALUES (58392, 7, 1346, 1, 9, 247, 23);
INSERT INTO public.who_global_data VALUES (58393, 0, 153, 0, 12, 247, 192);
INSERT INTO public.who_global_data VALUES (58394, 281, 2507, 3, 48, 247, 69);
INSERT INTO public.who_global_data VALUES (58395, 0, 12, 0, 0, 247, 187);
INSERT INTO public.who_global_data VALUES (58396, 165, 5527, 8, 225, 247, 230);
INSERT INTO public.who_global_data VALUES (58397, 0, 3931, 0, 534, 247, 77);
INSERT INTO public.who_global_data VALUES (58398, 0, 1806, 0, 10, 247, 9);
INSERT INTO public.who_global_data VALUES (58399, 9304, 216919, 260, 6075, 247, 74);
INSERT INTO public.who_global_data VALUES (58400, 684, 28233, 35, 1698, 247, 224);
INSERT INTO public.who_global_data VALUES (58401, 3134, 160696, 70, 8012, 247, 199);
INSERT INTO public.who_global_data VALUES (58402, 781, 8168, 21, 256, 247, 190);
INSERT INTO public.who_global_data VALUES (58403, 45, 25111, 1, 1659, 247, 12);
INSERT INTO public.who_global_data VALUES (58404, 0, 336, 0, 24, 247, 104);
INSERT INTO public.who_global_data VALUES (58405, 121, 17306, 2, 292, 247, 153);
INSERT INTO public.who_global_data VALUES (58406, 321, 233836, 71, 33601, 247, 91);
INSERT INTO public.who_global_data VALUES (58407, 2, 590, 0, 9, 247, 215);
INSERT INTO public.who_global_data VALUES (58408, 32, 17018, 3, 903, 247, 84);
INSERT INTO public.who_global_data VALUES (58409, 0, 308, 1, 30, 247, 231);
INSERT INTO public.who_global_data VALUES (58410, 0, 745, 0, 9, 247, 196);
INSERT INTO public.who_global_data VALUES (58411, 245, 12312, 0, 48, 247, 105);
INSERT INTO public.who_global_data VALUES (58412, 123, 2216, 3, 74, 247, 122);
INSERT INTO public.who_global_data VALUES (58413, 0, 0, 0, 0, 247, 159);
INSERT INTO public.who_global_data VALUES (58414, 62, 1142, 0, 21, 247, 75);
INSERT INTO public.who_global_data VALUES (58415, 710, 29359, 4, 230, 247, 27);
INSERT INTO public.who_global_data VALUES (58416, 28, 1899, 0, 20, 247, 54);
INSERT INTO public.who_global_data VALUES (58417, 0, 19, 0, 0, 247, 226);
INSERT INTO public.who_global_data VALUES (58418, 0, 1079, 0, 24, 247, 79);
INSERT INTO public.who_global_data VALUES (58419, 14, 1256, 0, 27, 247, 56);
INSERT INTO public.who_global_data VALUES (58420, 2, 4, 0, 0, 247, 117);
INSERT INTO public.who_global_data VALUES (58421, 5, 316, 0, 28, 247, 152);
INSERT INTO public.who_global_data VALUES (58422, 14, 196, 0, 5, 247, 16);
INSERT INTO public.who_global_data VALUES (58423, 0, 83, 0, 1, 247, 10);
INSERT INTO public.who_global_data VALUES (58424, 5, 1684, 0, 71, 247, 201);
INSERT INTO public.who_global_data VALUES (58425, 0, 4020, 0, 110, 247, 174);
INSERT INTO public.who_global_data VALUES (58426, 63, 908, 0, 6, 247, 119);
INSERT INTO public.who_global_data VALUES (58427, 11, 369, 0, 4, 247, 168);
INSERT INTO public.who_global_data VALUES (58428, 93, 7970, 0, 115, 247, 99);
INSERT INTO public.who_global_data VALUES (58429, 9, 1850, 0, 7, 247, 171);
INSERT INTO public.who_global_data VALUES (58430, 35, 1386, 1, 79, 247, 87);
INSERT INTO public.who_global_data VALUES (58431, 0, 621, 0, 9, 247, 123);
INSERT INTO public.who_global_data VALUES (58432, 0, 0, 0, 0, 247, 151);
INSERT INTO public.who_global_data VALUES (58433, 0, 200, 0, 14, 247, 213);
INSERT INTO public.who_global_data VALUES (58434, 80, 668, 5, 31, 247, 118);
INSERT INTO public.who_global_data VALUES (58435, 0, 335, 0, 10, 247, 134);
INSERT INTO public.who_global_data VALUES (58436, 7, 1993, 0, 24, 247, 65);
INSERT INTO public.who_global_data VALUES (58437, 3891, 97326, 470, 10637, 247, 102);
INSERT INTO public.who_global_data VALUES (58438, 0, 0, 0, 0, 247, 223);
INSERT INTO public.who_global_data VALUES (58439, 0, 70, 0, 1, 247, 4);
INSERT INTO public.who_global_data VALUES (58440, 0, 185, 0, 0, 247, 146);
INSERT INTO public.who_global_data VALUES (58441, 0, 324, 0, 9, 247, 31);
INSERT INTO public.who_global_data VALUES (58442, 0, 11, 0, 1, 247, 127);
INSERT INTO public.who_global_data VALUES (58443, 56, 7922, 0, 206, 247, 22);
INSERT INTO public.who_global_data VALUES (58444, 9, 316, 0, 2, 247, 115);
INSERT INTO public.who_global_data VALUES (58445, 1, 234, 0, 6, 247, 106);
INSERT INTO public.who_global_data VALUES (58446, 0, 25, 0, 0, 247, 90);
INSERT INTO public.who_global_data VALUES (58447, 0, 0, 0, 0, 247, 70);
INSERT INTO public.who_global_data VALUES (58448, 201, 2300, 1, 9, 247, 46);
INSERT INTO public.who_global_data VALUES (58449, 93, 46499, 13, 5945, 247, 139);
INSERT INTO public.who_global_data VALUES (58450, 0, 19, 0, 0, 247, 42);
INSERT INTO public.who_global_data VALUES (58451, 0, 1154, 0, 22, 247, 80);
INSERT INTO public.who_global_data VALUES (58452, 359, 1309, 11, 46, 247, 203);
INSERT INTO public.who_global_data VALUES (58453, 1, 961, 0, 65, 247, 136);
INSERT INTO public.who_global_data VALUES (58454, 347, 11166, 1, 315, 247, 63);
INSERT INTO public.who_global_data VALUES (58455, 0, 0, 0, 0, 247, 17);
INSERT INTO public.who_global_data VALUES (58456, 1, 24, 0, 2, 247, 172);
INSERT INTO public.who_global_data VALUES (58457, 101, 2492, 4, 145, 247, 109);
INSERT INTO public.who_global_data VALUES (58458, 0, 8446, 0, 237, 247, 200);
INSERT INTO public.who_global_data VALUES (58459, 6, 636, 0, 5, 247, 93);
INSERT INTO public.who_global_data VALUES (58460, 738, 13537, 8, 67, 247, 5);
INSERT INTO public.who_global_data VALUES (58461, 0, 741, 0, 13, 247, 214);
INSERT INTO public.who_global_data VALUES (58462, 4801, 85264, 82, 1770, 247, 204);
INSERT INTO public.who_global_data VALUES (58463, 0, 0, 0, 0, 247, 198);
INSERT INTO public.who_global_data VALUES (58464, 258, 14095, 8, 352, 247, 173);
INSERT INTO public.who_global_data VALUES (58465, 0, 8, 0, 0, 247, 229);
INSERT INTO public.who_global_data VALUES (58466, 57, 1070, 0, 11, 247, 76);
INSERT INTO public.who_global_data VALUES (58467, 4845, 174884, 133, 4767, 247, 138);
INSERT INTO public.who_global_data VALUES (58468, 751, 19748, 8, 974, 247, 98);
INSERT INTO public.who_global_data VALUES (58469, 0, 0, 0, 0, 247, 103);
INSERT INTO public.who_global_data VALUES (58470, 292, 24687, 23, 1115, 247, 225);
INSERT INTO public.who_global_data VALUES (58471, 366, 33261, 11, 1447, 247, 131);
INSERT INTO public.who_global_data VALUES (58472, 88, 4023, 2, 140, 247, 235);
INSERT INTO public.who_global_data VALUES (58473, 1901, 62160, 2, 45, 247, 137);
INSERT INTO public.who_global_data VALUES (58474, 39, 11629, 0, 273, 247, 81);
INSERT INTO public.who_global_data VALUES (58475, 247, 8795, 5, 314, 247, 182);
INSERT INTO public.who_global_data VALUES (58476, 1, 478, 0, 1, 247, 145);
INSERT INTO public.who_global_data VALUES (58477, 152, 19669, 9, 1288, 247, 26);
INSERT INTO public.who_global_data VALUES (58478, 8831, 441108, 169, 5384, 247, 170);
INSERT INTO public.who_global_data VALUES (58479, 13, 397, 0, 2, 247, 191);
INSERT INTO public.who_global_data VALUES (58480, 0, 3, 0, 0, 247, 221);
INSERT INTO public.who_global_data VALUES (58481, 0, 6, 0, 0, 247, 64);
INSERT INTO public.who_global_data VALUES (58482, 0, 0, 0, 0, 247, 116);
INSERT INTO public.who_global_data VALUES (58483, 0, 15, 0, 0, 247, 128);
INSERT INTO public.who_global_data VALUES (58484, 0, 18, 0, 0, 247, 6);
INSERT INTO public.who_global_data VALUES (58485, 0, 41, 0, 3, 247, 227);
INSERT INTO public.who_global_data VALUES (58486, 0, 1, 0, 0, 247, 68);
INSERT INTO public.who_global_data VALUES (58487, 0, 26, 0, 0, 247, 184);
INSERT INTO public.who_global_data VALUES (58488, 0, 0, 0, 0, 247, 82);
INSERT INTO public.who_global_data VALUES (58489, 0, 687, 0, 42, 247, 149);
INSERT INTO public.who_global_data VALUES (58490, 0, 295, 0, 10, 247, 197);
INSERT INTO public.who_global_data VALUES (58491, 2171, 91182, 30, 579, 247, 78);
INSERT INTO public.who_global_data VALUES (58492, 96, 3932, 2, 45, 247, 233);
INSERT INTO public.who_global_data VALUES (58493, 69, 11523, 0, 245, 247, 133);
INSERT INTO public.who_global_data VALUES (58494, 0, 11, 0, 0, 247, 35);
INSERT INTO public.who_global_data VALUES (58495, 13, 909, 1, 47, 247, 114);
INSERT INTO public.who_global_data VALUES (58496, 569, 36405, 0, 24, 247, 237);
INSERT INTO public.who_global_data VALUES (58497, 0, 2, 0, 0, 247, 55);
INSERT INTO public.who_global_data VALUES (58498, 0, 78, 0, 15, 247, 176);
INSERT INTO public.who_global_data VALUES (58499, 3, 1525, 0, 28, 247, 202);
INSERT INTO public.who_global_data VALUES (58500, 0, 1477, 0, 113, 247, 155);
INSERT INTO public.who_global_data VALUES (58501, 0, 0, 0, 0, 247, 32);
INSERT INTO public.who_global_data VALUES (58502, 57, 2146, 0, 79, 247, 220);
INSERT INTO public.who_global_data VALUES (58503, 1713, 37525, 37, 792, 247, 30);
INSERT INTO public.who_global_data VALUES (58504, 323, 1317, 4, 14, 247, 147);
INSERT INTO public.who_global_data VALUES (58505, 493, 248149, 47, 29242, 247, 208);
INSERT INTO public.who_global_data VALUES (58506, 66, 1749, 0, 11, 247, 45);
INSERT INTO public.who_global_data VALUES (58507, 189, 5499, 7, 314, 247, 110);
INSERT INTO public.who_global_data VALUES (58508, 1, 54, 0, 1, 247, 88);
INSERT INTO public.who_global_data VALUES (58509, 900, 40206, 36, 4736, 247, 51);
INSERT INTO public.who_global_data VALUES (58510, 23, 30891, 0, 1714, 247, 209);
INSERT INTO public.who_global_data VALUES (58511, 0, 123, 0, 6, 247, 205);
INSERT INTO public.who_global_data VALUES (58512, 91, 4191, 1, 48, 247, 18);
INSERT INTO public.who_global_data VALUES (58513, 17, 3101, 0, 58, 247, 72);
INSERT INTO public.who_global_data VALUES (58514, 1484, 259523, 254, 38034, 247, 44);
INSERT INTO public.who_global_data VALUES (58515, 0, 24, 0, 0, 247, 15);
INSERT INTO public.who_global_data VALUES (58516, 7, 452, 0, 13, 247, 25);
INSERT INTO public.who_global_data VALUES (58517, 0, 0, 0, 0, 247, 179);
INSERT INTO public.who_global_data VALUES (58518, 0, 0, 0, 0, 247, 34);
INSERT INTO public.who_global_data VALUES (58519, 0, 117, 0, 8, 247, 207);
INSERT INTO public.who_global_data VALUES (58520, 0, 1087, 0, 49, 247, 166);
INSERT INTO public.who_global_data VALUES (58521, 867, 166422, 24, 4609, 247, 126);
INSERT INTO public.who_global_data VALUES (58522, 0, 0, 0, 0, 247, 97);
INSERT INTO public.who_global_data VALUES (58523, 0, 12, 0, 1, 247, 36);
INSERT INTO public.who_global_data VALUES (58524, 0, 0, 0, 0, 247, 125);
INSERT INTO public.who_global_data VALUES (58525, 50, 636, 0, 0, 247, 124);
INSERT INTO public.who_global_data VALUES (58526, 588, 25411, 13, 748, 247, 185);
INSERT INTO public.who_global_data VALUES (58527, 571, 36359, 1, 270, 247, 194);
INSERT INTO public.who_global_data VALUES (58528, 0, 509, 0, 21, 247, 144);
INSERT INTO public.who_global_data VALUES (58529, 24890, 1823220, 1043, 106051, 247, 19);
INSERT INTO public.who_global_data VALUES (58530, 0, 70, 0, 6, 247, 217);
INSERT INTO public.who_global_data VALUES (58531, 1, 826, 0, 23, 247, 148);
INSERT INTO public.who_global_data VALUES (58532, 156, 3874, 1, 16, 247, 86);
INSERT INTO public.who_global_data VALUES (58533, 0, 0, 0, 0, 247, 13);
INSERT INTO public.who_global_data VALUES (58534, 157, 1819, 1, 18, 247, 157);
INSERT INTO public.who_global_data VALUES (58535, 0, 328, 0, 0, 247, 8);
INSERT INTO public.who_global_data VALUES (58536, 0, 0, 0, 0, 247, 73);
INSERT INTO public.who_global_data VALUES (58537, 20, 419, 8, 95, 247, 101);
INSERT INTO public.who_global_data VALUES (58538, 0, 1089, 0, 7, 247, 165);
INSERT INTO public.who_global_data VALUES (58539, 16, 222, 0, 4, 247, 14);
INSERT INTO public.who_global_data VALUES (58540, 775, 17353, 24, 298, 248, 193);
INSERT INTO public.who_global_data VALUES (58541, 20, 1161, 1, 33, 248, 113);
INSERT INTO public.who_global_data VALUES (58542, 113, 9626, 6, 667, 248, 143);
INSERT INTO public.who_global_data VALUES (58543, 0, 0, 0, 0, 248, 219);
INSERT INTO public.who_global_data VALUES (58544, 79, 844, 0, 51, 248, 186);
INSERT INTO public.who_global_data VALUES (58545, 0, 86, 0, 4, 248, 52);
INSERT INTO public.who_global_data VALUES (58546, 0, 3, 0, 0, 248, 180);
INSERT INTO public.who_global_data VALUES (58547, 0, 25, 0, 3, 248, 167);
INSERT INTO public.who_global_data VALUES (58548, 564, 17415, 19, 560, 248, 154);
INSERT INTO public.who_global_data VALUES (58549, 517, 9985, 19, 158, 248, 94);
INSERT INTO public.who_global_data VALUES (58550, 0, 101, 0, 3, 248, 66);
INSERT INTO public.who_global_data VALUES (58551, 17, 7221, 0, 103, 248, 58);
INSERT INTO public.who_global_data VALUES (58552, 11, 16674, 1, 669, 248, 163);
INSERT INTO public.who_global_data VALUES (58553, 273, 5935, 3, 71, 248, 37);
INSERT INTO public.who_global_data VALUES (58554, 0, 102, 0, 11, 248, 142);
INSERT INTO public.who_global_data VALUES (58555, 440, 12311, 0, 19, 248, 83);
INSERT INTO public.who_global_data VALUES (58556, 2911, 52445, 37, 709, 248, 228);
INSERT INTO public.who_global_data VALUES (58557, 0, 92, 0, 7, 248, 188);
INSERT INTO public.who_global_data VALUES (58558, 852, 44255, 3, 243, 248, 62);
INSERT INTO public.who_global_data VALUES (58559, 181, 59304, 23, 9408, 248, 160);
INSERT INTO public.who_global_data VALUES (58560, 0, 18, 0, 2, 248, 50);
INSERT INTO public.who_global_data VALUES (58561, 1, 244, 0, 3, 248, 33);
INSERT INTO public.who_global_data VALUES (58562, 1, 141, 0, 9, 248, 183);
INSERT INTO public.who_global_data VALUES (58563, 0, 47, 0, 0, 248, 92);
INSERT INTO public.who_global_data VALUES (58564, 549, 10531, 30, 343, 248, 158);
INSERT INTO public.who_global_data VALUES (58565, 0, 2, 0, 0, 248, 67);
INSERT INTO public.who_global_data VALUES (58566, 11, 2534, 3, 156, 248, 57);
INSERT INTO public.who_global_data VALUES (58567, 2, 40, 0, 1, 248, 38);
INSERT INTO public.who_global_data VALUES (58568, 11598, 526447, 623, 29937, 248, 141);
INSERT INTO public.who_global_data VALUES (58569, 0, 8, 0, 1, 248, 178);
INSERT INTO public.who_global_data VALUES (58570, 0, 141, 0, 2, 248, 108);
INSERT INTO public.who_global_data VALUES (58571, 25, 2538, 0, 144, 248, 39);
INSERT INTO public.who_global_data VALUES (58572, 1, 884, 0, 53, 248, 2);
INSERT INTO public.who_global_data VALUES (58573, 0, 63, 0, 1, 248, 195);
INSERT INTO public.who_global_data VALUES (58574, 8, 466, 1, 5, 248, 107);
INSERT INTO public.who_global_data VALUES (58575, 0, 125, 0, 0, 248, 161);
INSERT INTO public.who_global_data VALUES (58576, 188, 6585, 1, 200, 248, 212);
INSERT INTO public.who_global_data VALUES (58577, 800, 92151, 39, 7344, 248, 181);
INSERT INTO public.who_global_data VALUES (58578, 9, 150, 0, 1, 248, 53);
INSERT INTO public.who_global_data VALUES (58579, 0, 1069, 0, 4, 248, 164);
INSERT INTO public.who_global_data VALUES (58580, 13, 803, 0, 66, 248, 140);
INSERT INTO public.who_global_data VALUES (58581, 3527, 108686, 75, 1188, 248, 20);
INSERT INTO public.who_global_data VALUES (58582, 5, 84602, 0, 4645, 248, 112);
INSERT INTO public.who_global_data VALUES (58583, 1110, 30493, 30, 969, 248, 111);
INSERT INTO public.who_global_data VALUES (58584, 0, 62, 0, 2, 248, 71);
INSERT INTO public.who_global_data VALUES (58585, 7, 618, 0, 20, 248, 218);
INSERT INTO public.who_global_data VALUES (58586, 0, 0, 0, 0, 248, 43);
INSERT INTO public.who_global_data VALUES (58587, 28, 1084, 0, 10, 248, 49);
INSERT INTO public.who_global_data VALUES (58588, 73, 3024, 0, 33, 248, 1);
INSERT INTO public.who_global_data VALUES (58589, 0, 2246, 0, 103, 248, 48);
INSERT INTO public.who_global_data VALUES (58590, 9, 2092, 0, 83, 248, 232);
INSERT INTO public.who_global_data VALUES (58591, 0, 20, 0, 1, 248, 175);
INSERT INTO public.who_global_data VALUES (58592, 3, 952, 0, 17, 248, 21);
INSERT INTO public.who_global_data VALUES (58593, 62, 9364, 2, 323, 248, 156);
INSERT INTO public.who_global_data VALUES (58594, 0, 0, 0, 0, 248, 95);
INSERT INTO public.who_global_data VALUES (58595, 131, 3325, 0, 71, 248, 177);
INSERT INTO public.who_global_data VALUES (58596, 35, 11734, 4, 580, 248, 210);
INSERT INTO public.who_global_data VALUES (58597, 210, 3779, 1, 25, 248, 120);
INSERT INTO public.who_global_data VALUES (58598, 0, 16, 0, 0, 248, 135);
INSERT INTO public.who_global_data VALUES (58599, 180, 17752, 13, 515, 248, 206);
INSERT INTO public.who_global_data VALUES (58600, 1316, 40414, 80, 3438, 248, 189);
INSERT INTO public.who_global_data VALUES (58601, 1152, 27536, 47, 1052, 248, 129);
INSERT INTO public.who_global_data VALUES (58602, 71, 2653, 0, 46, 248, 121);
INSERT INTO public.who_global_data VALUES (58603, 0, 1043, 0, 12, 248, 59);
INSERT INTO public.who_global_data VALUES (58604, 0, 39, 0, 0, 248, 96);
INSERT INTO public.who_global_data VALUES (58605, 0, 1870, 0, 63, 248, 41);
INSERT INTO public.who_global_data VALUES (58606, 1, 294, 0, 3, 248, 216);
INSERT INTO public.who_global_data VALUES (58607, 87, 1344, 2, 14, 248, 236);
INSERT INTO public.who_global_data VALUES (58608, 0, 13, 0, 0, 248, 150);
INSERT INTO public.who_global_data VALUES (58609, 0, 187, 0, 0, 248, 61);
INSERT INTO public.who_global_data VALUES (58610, 0, 18, 0, 0, 248, 7);
INSERT INTO public.who_global_data VALUES (58611, 2, 6887, 0, 320, 248, 169);
INSERT INTO public.who_global_data VALUES (58612, -840, 147935, 107, 28883, 248, 28);
INSERT INTO public.who_global_data VALUES (58613, 18, 517, 0, 1, 248, 85);
INSERT INTO public.who_global_data VALUES (58614, 0, 60, 0, 0, 248, 211);
INSERT INTO public.who_global_data VALUES (58615, 148, 2803, 3, 20, 248, 60);
INSERT INTO public.who_global_data VALUES (58616, 1, 26, 0, 1, 248, 3);
INSERT INTO public.who_global_data VALUES (58617, 4, 800, 1, 13, 248, 11);
INSERT INTO public.who_global_data VALUES (58618, 342, 182370, 29, 8551, 248, 89);
INSERT INTO public.who_global_data VALUES (58619, 227, 8297, 2, 38, 248, 24);
INSERT INTO public.who_global_data VALUES (58620, 0, 170, 0, 0, 248, 162);
INSERT INTO public.who_global_data VALUES (58621, 19, 2937, 0, 179, 248, 100);
INSERT INTO public.who_global_data VALUES (58622, 0, 13, 0, 0, 248, 47);
INSERT INTO public.who_global_data VALUES (58623, 0, 23, 0, 0, 248, 29);
INSERT INTO public.who_global_data VALUES (58624, 0, 162, 0, 14, 248, 40);
INSERT INTO public.who_global_data VALUES (58625, 2, 169, 0, 5, 248, 222);
INSERT INTO public.who_global_data VALUES (58626, 249, 5336, 8, 116, 248, 132);
INSERT INTO public.who_global_data VALUES (58627, 0, 252, 0, 13, 248, 130);
INSERT INTO public.who_global_data VALUES (58628, 42, 3886, 0, 23, 248, 234);
INSERT INTO public.who_global_data VALUES (58629, 0, 1339, 0, 8, 248, 23);
INSERT INTO public.who_global_data VALUES (58630, 0, 153, 0, 12, 248, 192);
INSERT INTO public.who_global_data VALUES (58631, 102, 2226, 1, 45, 248, 69);
INSERT INTO public.who_global_data VALUES (58632, 0, 12, 0, 0, 248, 187);
INSERT INTO public.who_global_data VALUES (58633, 160, 5362, 5, 217, 248, 230);
INSERT INTO public.who_global_data VALUES (58634, 10, 3931, 2, 534, 248, 77);
INSERT INTO public.who_global_data VALUES (58635, 0, 1806, 0, 10, 248, 9);
INSERT INTO public.who_global_data VALUES (58636, 8909, 207615, 217, 5815, 248, 74);
INSERT INTO public.who_global_data VALUES (58637, 609, 27549, 22, 1663, 248, 224);
INSERT INTO public.who_global_data VALUES (58638, 3117, 157562, 64, 7942, 248, 199);
INSERT INTO public.who_global_data VALUES (58639, 519, 7387, 20, 235, 248, 190);
INSERT INTO public.who_global_data VALUES (58640, 4, 25066, 8, 1658, 248, 12);
INSERT INTO public.who_global_data VALUES (58641, 0, 336, 0, 24, 248, 104);
INSERT INTO public.who_global_data VALUES (58642, 100, 17185, 3, 290, 248, 153);
INSERT INTO public.who_global_data VALUES (58643, 318, 233515, 55, 33530, 248, 91);
INSERT INTO public.who_global_data VALUES (58644, 7, 588, 0, 9, 248, 215);
INSERT INTO public.who_global_data VALUES (58645, 56, 16986, 6, 900, 248, 84);
INSERT INTO public.who_global_data VALUES (58646, 0, 308, 0, 29, 248, 231);
INSERT INTO public.who_global_data VALUES (58647, 5, 745, 0, 9, 248, 196);
INSERT INTO public.who_global_data VALUES (58648, 271, 12067, 4, 48, 248, 105);
INSERT INTO public.who_global_data VALUES (58649, 72, 2093, 2, 71, 248, 122);
INSERT INTO public.who_global_data VALUES (58650, 0, 0, 0, 0, 248, 159);
INSERT INTO public.who_global_data VALUES (58651, 13, 1080, 0, 21, 248, 75);
INSERT INTO public.who_global_data VALUES (58652, 887, 28649, 6, 226, 248, 27);
INSERT INTO public.who_global_data VALUES (58653, 26, 1871, 3, 20, 248, 54);
INSERT INTO public.who_global_data VALUES (58654, 0, 19, 0, 0, 248, 226);
INSERT INTO public.who_global_data VALUES (58655, 8, 1079, 0, 24, 248, 79);
INSERT INTO public.who_global_data VALUES (58656, 9, 1242, 0, 27, 248, 56);
INSERT INTO public.who_global_data VALUES (58657, 0, 2, 0, 0, 248, 117);
INSERT INTO public.who_global_data VALUES (58658, 15, 311, 1, 28, 248, 152);
INSERT INTO public.who_global_data VALUES (58659, 14, 182, 0, 5, 248, 16);
INSERT INTO public.who_global_data VALUES (58660, 0, 83, 0, 1, 248, 10);
INSERT INTO public.who_global_data VALUES (58661, 3, 1679, 0, 71, 248, 201);
INSERT INTO public.who_global_data VALUES (58662, 1, 4020, 0, 110, 248, 174);
INSERT INTO public.who_global_data VALUES (58663, 19, 845, 0, 6, 248, 119);
INSERT INTO public.who_global_data VALUES (58664, 22, 358, 0, 4, 248, 168);
INSERT INTO public.who_global_data VALUES (58665, 20, 7877, 0, 115, 248, 99);
INSERT INTO public.who_global_data VALUES (58666, 12, 1841, 1, 7, 248, 171);
INSERT INTO public.who_global_data VALUES (58667, 36, 1351, 0, 78, 248, 87);
INSERT INTO public.who_global_data VALUES (58668, 2, 621, 0, 9, 248, 123);
INSERT INTO public.who_global_data VALUES (58669, 0, 0, 0, 0, 248, 151);
INSERT INTO public.who_global_data VALUES (58670, 0, 200, 0, 14, 248, 213);
INSERT INTO public.who_global_data VALUES (58671, 58, 588, 3, 26, 248, 118);
INSERT INTO public.who_global_data VALUES (58672, 0, 335, 0, 10, 248, 134);
INSERT INTO public.who_global_data VALUES (58673, 52, 1986, 0, 24, 248, 65);
INSERT INTO public.who_global_data VALUES (58674, 2771, 93435, 237, 10167, 248, 102);
INSERT INTO public.who_global_data VALUES (58675, 0, 0, 0, 0, 248, 223);
INSERT INTO public.who_global_data VALUES (58676, 0, 70, 0, 1, 248, 4);
INSERT INTO public.who_global_data VALUES (58677, 0, 185, 0, 0, 248, 146);
INSERT INTO public.who_global_data VALUES (58678, 0, 324, 0, 9, 248, 31);
INSERT INTO public.who_global_data VALUES (58679, 0, 11, 0, 1, 248, 127);
INSERT INTO public.who_global_data VALUES (58680, 33, 7866, 1, 206, 248, 22);
INSERT INTO public.who_global_data VALUES (58681, 53, 307, 0, 2, 248, 115);
INSERT INTO public.who_global_data VALUES (58682, 5, 233, 0, 6, 248, 106);
INSERT INTO public.who_global_data VALUES (58683, 0, 25, 0, 0, 248, 90);
INSERT INTO public.who_global_data VALUES (58684, 0, 0, 0, 0, 248, 70);
INSERT INTO public.who_global_data VALUES (58685, 288, 2099, 0, 8, 248, 46);
INSERT INTO public.who_global_data VALUES (58686, 95, 46406, 4, 5932, 248, 139);
INSERT INTO public.who_global_data VALUES (58687, 0, 19, 0, 0, 248, 42);
INSERT INTO public.who_global_data VALUES (58688, 0, 1154, 0, 22, 248, 80);
INSERT INTO public.who_global_data VALUES (58689, 65, 950, 0, 35, 248, 203);
INSERT INTO public.who_global_data VALUES (58690, 2, 960, 1, 65, 248, 136);
INSERT INTO public.who_global_data VALUES (58691, 241, 10819, 15, 314, 248, 63);
INSERT INTO public.who_global_data VALUES (58692, 0, 0, 0, 0, 248, 17);
INSERT INTO public.who_global_data VALUES (58693, 1, 23, 0, 2, 248, 172);
INSERT INTO public.who_global_data VALUES (58694, 76, 2391, 1, 141, 248, 109);
INSERT INTO public.who_global_data VALUES (58695, 35, 8446, 1, 237, 248, 200);
INSERT INTO public.who_global_data VALUES (58696, 2, 630, 0, 5, 248, 93);
INSERT INTO public.who_global_data VALUES (58697, 576, 12799, 9, 59, 248, 5);
INSERT INTO public.who_global_data VALUES (58698, 0, 741, 0, 13, 248, 214);
INSERT INTO public.who_global_data VALUES (58699, 4065, 80463, 67, 1688, 248, 204);
INSERT INTO public.who_global_data VALUES (58700, 0, 0, 0, 0, 248, 198);
INSERT INTO public.who_global_data VALUES (58701, 374, 13837, 8, 344, 248, 173);
INSERT INTO public.who_global_data VALUES (58702, 0, 8, 0, 0, 248, 229);
INSERT INTO public.who_global_data VALUES (58703, 18, 1013, 0, 11, 248, 76);
INSERT INTO public.who_global_data VALUES (58704, 5563, 170039, 128, 4634, 248, 138);
INSERT INTO public.who_global_data VALUES (58705, 359, 18997, 6, 966, 248, 98);
INSERT INTO public.who_global_data VALUES (58706, 0, 0, 0, 0, 248, 103);
INSERT INTO public.who_global_data VALUES (58707, 230, 24395, 18, 1092, 248, 225);
INSERT INTO public.who_global_data VALUES (58708, 195, 32895, 12, 1436, 248, 131);
INSERT INTO public.who_global_data VALUES (58709, 62, 3935, 2, 138, 248, 235);
INSERT INTO public.who_global_data VALUES (58710, 1826, 60259, 3, 43, 248, 137);
INSERT INTO public.who_global_data VALUES (58711, 49, 11590, 1, 273, 248, 81);
INSERT INTO public.who_global_data VALUES (58712, 188, 8548, 2, 309, 248, 182);
INSERT INTO public.who_global_data VALUES (58713, 4, 477, 0, 1, 248, 145);
INSERT INTO public.who_global_data VALUES (58714, 119, 19517, 0, 1279, 248, 26);
INSERT INTO public.who_global_data VALUES (58715, 8536, 432277, 178, 5215, 248, 170);
INSERT INTO public.who_global_data VALUES (58716, 7, 384, 1, 2, 248, 191);
INSERT INTO public.who_global_data VALUES (58717, 0, 3, 0, 0, 248, 221);
INSERT INTO public.who_global_data VALUES (58718, 0, 6, 0, 0, 248, 64);
INSERT INTO public.who_global_data VALUES (58719, 0, 0, 0, 0, 248, 116);
INSERT INTO public.who_global_data VALUES (58720, 0, 15, 0, 0, 248, 128);
INSERT INTO public.who_global_data VALUES (58721, 0, 18, 0, 0, 248, 6);
INSERT INTO public.who_global_data VALUES (58722, 0, 41, 0, 3, 248, 227);
INSERT INTO public.who_global_data VALUES (58723, 0, 1, 0, 0, 248, 68);
INSERT INTO public.who_global_data VALUES (58724, 0, 26, 0, 0, 248, 184);
INSERT INTO public.who_global_data VALUES (58725, 0, 0, 0, 0, 248, 82);
INSERT INTO public.who_global_data VALUES (58726, 0, 687, 0, 42, 248, 149);
INSERT INTO public.who_global_data VALUES (58727, 0, 295, 0, 10, 248, 197);
INSERT INTO public.who_global_data VALUES (58728, 1869, 89011, 24, 549, 248, 78);
INSERT INTO public.who_global_data VALUES (58729, 97, 3836, 1, 43, 248, 233);
INSERT INTO public.who_global_data VALUES (58730, 24, 11454, 1, 245, 248, 133);
INSERT INTO public.who_global_data VALUES (58731, 0, 11, 0, 0, 248, 35);
INSERT INTO public.who_global_data VALUES (58732, 31, 896, 0, 46, 248, 114);
INSERT INTO public.who_global_data VALUES (58733, 544, 35836, 0, 24, 248, 237);
INSERT INTO public.who_global_data VALUES (58734, 0, 2, 0, 0, 248, 55);
INSERT INTO public.who_global_data VALUES (58735, 0, 78, 0, 15, 248, 176);
INSERT INTO public.who_global_data VALUES (58736, 0, 1522, 0, 28, 248, 202);
INSERT INTO public.who_global_data VALUES (58737, 2, 1477, 0, 113, 248, 155);
INSERT INTO public.who_global_data VALUES (58738, 0, 0, 0, 0, 248, 32);
INSERT INTO public.who_global_data VALUES (58739, 66, 2089, 0, 79, 248, 220);
INSERT INTO public.who_global_data VALUES (58740, 1455, 35812, 50, 755, 248, 30);
INSERT INTO public.who_global_data VALUES (58741, 0, 994, 0, 10, 248, 147);
INSERT INTO public.who_global_data VALUES (58742, 359, 247656, 34, 29195, 248, 208);
INSERT INTO public.who_global_data VALUES (58743, 40, 1683, 0, 11, 248, 45);
INSERT INTO public.who_global_data VALUES (58744, 137, 5310, 9, 307, 248, 110);
INSERT INTO public.who_global_data VALUES (58745, 26, 53, 0, 1, 248, 88);
INSERT INTO public.who_global_data VALUES (58746, 648, 39306, 39, 4700, 248, 51);
INSERT INTO public.who_global_data VALUES (58747, 23, 30868, 0, 1714, 248, 209);
INSERT INTO public.who_global_data VALUES (58748, 0, 123, 1, 6, 248, 205);
INSERT INTO public.who_global_data VALUES (58749, 87, 4100, 0, 47, 248, 18);
INSERT INTO public.who_global_data VALUES (58750, 1, 3084, 0, 58, 248, 72);
INSERT INTO public.who_global_data VALUES (58751, 1441, 258039, 249, 37780, 248, 44);
INSERT INTO public.who_global_data VALUES (58752, 0, 24, 0, 0, 248, 15);
INSERT INTO public.who_global_data VALUES (58753, 2, 445, 0, 13, 248, 25);
INSERT INTO public.who_global_data VALUES (58754, 0, 0, 0, 0, 248, 179);
INSERT INTO public.who_global_data VALUES (58755, 0, 0, 0, 0, 248, 34);
INSERT INTO public.who_global_data VALUES (58756, 0, 117, 0, 8, 248, 207);
INSERT INTO public.who_global_data VALUES (58757, 1, 1087, 1, 49, 248, 166);
INSERT INTO public.who_global_data VALUES (58758, 786, 165555, 22, 4585, 248, 126);
INSERT INTO public.who_global_data VALUES (58759, 0, 0, 0, 0, 248, 97);
INSERT INTO public.who_global_data VALUES (58760, 0, 12, 0, 1, 248, 36);
INSERT INTO public.who_global_data VALUES (58761, 0, 0, 0, 0, 248, 125);
INSERT INTO public.who_global_data VALUES (58762, 128, 586, 0, 0, 248, 124);
INSERT INTO public.who_global_data VALUES (58763, 483, 24823, 8, 735, 248, 185);
INSERT INTO public.who_global_data VALUES (58764, 596, 35788, 3, 269, 248, 194);
INSERT INTO public.who_global_data VALUES (58765, 0, 509, 0, 21, 248, 144);
INSERT INTO public.who_global_data VALUES (58766, 14692, 1798330, 761, 105008, 248, 19);
INSERT INTO public.who_global_data VALUES (58767, 0, 70, 0, 6, 248, 217);
INSERT INTO public.who_global_data VALUES (58768, 2, 825, 1, 23, 248, 148);
INSERT INTO public.who_global_data VALUES (58769, 0, 3718, 0, 15, 248, 86);
INSERT INTO public.who_global_data VALUES (58770, 0, 0, 0, 0, 248, 13);
INSERT INTO public.who_global_data VALUES (58771, 152, 1662, 3, 17, 248, 157);
INSERT INTO public.who_global_data VALUES (58772, 0, 328, 0, 0, 248, 8);
INSERT INTO public.who_global_data VALUES (58773, 0, 0, 0, 0, 248, 73);
INSERT INTO public.who_global_data VALUES (58774, 45, 399, 3, 87, 248, 101);
INSERT INTO public.who_global_data VALUES (58775, 0, 1089, 0, 7, 248, 165);
INSERT INTO public.who_global_data VALUES (58776, 28, 206, 0, 4, 248, 14);
INSERT INTO public.who_global_data VALUES (58777, 742, 16578, 5, 274, 249, 193);
INSERT INTO public.who_global_data VALUES (58778, 36, 1141, 0, 32, 249, 113);
INSERT INTO public.who_global_data VALUES (58779, 119, 9513, 8, 661, 249, 143);
INSERT INTO public.who_global_data VALUES (58780, 0, 0, 0, 0, 249, 219);
INSERT INTO public.who_global_data VALUES (58781, 1, 765, 0, 51, 249, 186);
INSERT INTO public.who_global_data VALUES (58782, 0, 86, 0, 4, 249, 52);
INSERT INTO public.who_global_data VALUES (58783, 0, 3, 0, 0, 249, 180);
INSERT INTO public.who_global_data VALUES (58784, 0, 25, 0, 3, 249, 167);
INSERT INTO public.who_global_data VALUES (58785, 637, 16851, 11, 541, 249, 154);
INSERT INTO public.who_global_data VALUES (58786, 210, 9468, 8, 139, 249, 94);
INSERT INTO public.who_global_data VALUES (58787, 0, 101, 0, 3, 249, 66);
INSERT INTO public.who_global_data VALUES (58788, 9, 7204, 0, 103, 249, 58);
INSERT INTO public.who_global_data VALUES (58789, 21, 16663, 0, 668, 249, 163);
INSERT INTO public.who_global_data VALUES (58790, 168, 5662, 5, 68, 249, 37);
INSERT INTO public.who_global_data VALUES (58791, 1, 102, 0, 11, 249, 142);
INSERT INTO public.who_global_data VALUES (58792, 473, 11871, 0, 19, 249, 83);
INSERT INTO public.who_global_data VALUES (58793, 2381, 49534, 22, 672, 249, 228);
INSERT INTO public.who_global_data VALUES (58794, 0, 92, 0, 7, 249, 188);
INSERT INTO public.who_global_data VALUES (58795, 847, 43403, 5, 240, 249, 62);
INSERT INTO public.who_global_data VALUES (58796, 59, 59123, 21, 9385, 249, 160);
INSERT INTO public.who_global_data VALUES (58797, 0, 18, 0, 2, 249, 50);
INSERT INTO public.who_global_data VALUES (58798, 11, 243, 0, 3, 249, 33);
INSERT INTO public.who_global_data VALUES (58799, 0, 140, 0, 9, 249, 183);
INSERT INTO public.who_global_data VALUES (58800, 4, 47, 0, 0, 249, 92);
INSERT INTO public.who_global_data VALUES (58801, 390, 9982, 3, 313, 249, 158);
INSERT INTO public.who_global_data VALUES (58802, 0, 2, 0, 0, 249, 67);
INSERT INTO public.who_global_data VALUES (58803, 14, 2523, 1, 153, 249, 57);
INSERT INTO public.who_global_data VALUES (58804, 0, 38, 0, 1, 249, 38);
INSERT INTO public.who_global_data VALUES (58805, 16409, 514849, 480, 29314, 249, 141);
INSERT INTO public.who_global_data VALUES (58806, 0, 8, 0, 1, 249, 178);
INSERT INTO public.who_global_data VALUES (58807, 0, 141, 0, 2, 249, 108);
INSERT INTO public.who_global_data VALUES (58808, 0, 2513, 4, 144, 249, 39);
INSERT INTO public.who_global_data VALUES (58809, 2, 883, 0, 53, 249, 2);
INSERT INTO public.who_global_data VALUES (58810, 0, 63, 0, 1, 249, 195);
INSERT INTO public.who_global_data VALUES (58811, 23, 458, 0, 4, 249, 107);
INSERT INTO public.who_global_data VALUES (58812, 0, 125, 0, 0, 249, 161);
INSERT INTO public.who_global_data VALUES (58813, 493, 6397, 8, 199, 249, 212);
INSERT INTO public.who_global_data VALUES (58814, 835, 91351, 213, 7305, 249, 181);
INSERT INTO public.who_global_data VALUES (58815, 0, 141, 0, 1, 249, 53);
INSERT INTO public.who_global_data VALUES (58816, 58, 1069, 2, 4, 249, 164);
INSERT INTO public.who_global_data VALUES (58817, 12, 790, 1, 66, 249, 140);
INSERT INTO public.who_global_data VALUES (58818, 5471, 105159, 59, 1113, 249, 20);
INSERT INTO public.who_global_data VALUES (58819, 9, 84597, 0, 4645, 249, 112);
INSERT INTO public.who_global_data VALUES (58820, 1147, 29383, 49, 939, 249, 111);
INSERT INTO public.who_global_data VALUES (58821, 0, 62, 0, 2, 249, 71);
INSERT INTO public.who_global_data VALUES (58822, 7, 611, 0, 20, 249, 218);
INSERT INTO public.who_global_data VALUES (58823, 0, 0, 0, 0, 249, 43);
INSERT INTO public.who_global_data VALUES (58824, 9, 1056, 0, 10, 249, 49);
INSERT INTO public.who_global_data VALUES (58825, 118, 2951, 0, 33, 249, 1);
INSERT INTO public.who_global_data VALUES (58826, 0, 2246, 0, 103, 249, 48);
INSERT INTO public.who_global_data VALUES (58827, 38, 2083, 0, 83, 249, 232);
INSERT INTO public.who_global_data VALUES (58828, 0, 20, 0, 1, 249, 175);
INSERT INTO public.who_global_data VALUES (58829, 5, 949, 0, 17, 249, 21);
INSERT INTO public.who_global_data VALUES (58830, 29, 9302, 1, 321, 249, 156);
INSERT INTO public.who_global_data VALUES (58831, 0, 0, 0, 0, 249, 95);
INSERT INTO public.who_global_data VALUES (58832, 146, 3194, 0, 71, 249, 177);
INSERT INTO public.who_global_data VALUES (58833, 30, 11699, 2, 576, 249, 210);
INSERT INTO public.who_global_data VALUES (58834, 215, 3569, 0, 24, 249, 120);
INSERT INTO public.who_global_data VALUES (58835, 0, 16, 0, 0, 249, 135);
INSERT INTO public.who_global_data VALUES (58836, 287, 17572, 0, 502, 249, 206);
INSERT INTO public.who_global_data VALUES (58837, 0, 39098, 0, 3358, 249, 189);
INSERT INTO public.who_global_data VALUES (58838, 1399, 26384, 46, 1005, 249, 129);
INSERT INTO public.who_global_data VALUES (58839, 65, 2582, 0, 46, 249, 121);
INSERT INTO public.who_global_data VALUES (58840, 0, 1043, 0, 12, 249, 59);
INSERT INTO public.who_global_data VALUES (58841, 0, 39, 0, 0, 249, 96);
INSERT INTO public.who_global_data VALUES (58842, 1, 1870, 0, 63, 249, 41);
INSERT INTO public.who_global_data VALUES (58843, 8, 293, 1, 3, 249, 216);
INSERT INTO public.who_global_data VALUES (58844, 85, 1257, 1, 12, 249, 236);
INSERT INTO public.who_global_data VALUES (58845, 0, 13, 0, 0, 249, 150);
INSERT INTO public.who_global_data VALUES (58846, 0, 187, 0, 0, 249, 61);
INSERT INTO public.who_global_data VALUES (58847, 0, 18, 0, 0, 249, 7);
INSERT INTO public.who_global_data VALUES (58848, 26, 6885, 0, 320, 249, 169);
INSERT INTO public.who_global_data VALUES (58849, 251, 148775, 30, 28776, 249, 28);
INSERT INTO public.who_global_data VALUES (58850, 22, 499, 0, 1, 249, 85);
INSERT INTO public.who_global_data VALUES (58851, 0, 60, 0, 0, 249, 211);
INSERT INTO public.who_global_data VALUES (58852, 0, 2655, 0, 17, 249, 60);
INSERT INTO public.who_global_data VALUES (58853, 0, 25, 0, 1, 249, 3);
INSERT INTO public.who_global_data VALUES (58854, 2, 796, 0, 12, 249, 11);
INSERT INTO public.who_global_data VALUES (58855, 213, 182028, 11, 8522, 249, 89);
INSERT INTO public.who_global_data VALUES (58856, 189, 8070, 0, 36, 249, 24);
INSERT INTO public.who_global_data VALUES (58857, 1, 170, 0, 0, 249, 162);
INSERT INTO public.who_global_data VALUES (58858, 1, 2918, 4, 179, 249, 100);
INSERT INTO public.who_global_data VALUES (58859, 0, 13, 0, 0, 249, 47);
INSERT INTO public.who_global_data VALUES (58860, 0, 23, 0, 0, 249, 29);
INSERT INTO public.who_global_data VALUES (58861, 0, 162, 0, 14, 249, 40);
INSERT INTO public.who_global_data VALUES (58862, 1, 167, 0, 5, 249, 222);
INSERT INTO public.who_global_data VALUES (58863, 348, 5087, 6, 108, 249, 132);
INSERT INTO public.who_global_data VALUES (58864, 0, 252, 0, 13, 249, 130);
INSERT INTO public.who_global_data VALUES (58865, 73, 3844, 0, 23, 249, 234);
INSERT INTO public.who_global_data VALUES (58866, 17, 1339, 0, 8, 249, 23);
INSERT INTO public.who_global_data VALUES (58867, 1, 153, 0, 12, 249, 192);
INSERT INTO public.who_global_data VALUES (58868, 259, 2124, 3, 44, 249, 69);
INSERT INTO public.who_global_data VALUES (58869, 0, 12, 0, 0, 249, 187);
INSERT INTO public.who_global_data VALUES (58870, 108, 5202, 11, 212, 249, 230);
INSERT INTO public.who_global_data VALUES (58871, 45, 3921, 6, 532, 249, 77);
INSERT INTO public.who_global_data VALUES (58872, 0, 1806, 0, 10, 249, 9);
INSERT INTO public.who_global_data VALUES (58873, 8171, 198706, 204, 5598, 249, 74);
INSERT INTO public.who_global_data VALUES (58874, 467, 26940, 28, 1641, 249, 224);
INSERT INTO public.who_global_data VALUES (58875, 2979, 154445, 81, 7878, 249, 199);
INSERT INTO public.who_global_data VALUES (58876, 429, 6868, 10, 215, 249, 190);
INSERT INTO public.who_global_data VALUES (58877, 72, 25062, 0, 1650, 249, 12);
INSERT INTO public.who_global_data VALUES (58878, 0, 336, 0, 24, 249, 104);
INSERT INTO public.who_global_data VALUES (58879, 87, 17085, 0, 287, 249, 153);
INSERT INTO public.who_global_data VALUES (58880, 178, 233197, 60, 33475, 249, 91);
INSERT INTO public.who_global_data VALUES (58881, 0, 581, 0, 9, 249, 215);
INSERT INTO public.who_global_data VALUES (58882, 46, 16930, 2, 894, 249, 84);
INSERT INTO public.who_global_data VALUES (58883, 0, 308, 0, 29, 249, 231);
INSERT INTO public.who_global_data VALUES (58884, 7, 740, 0, 9, 249, 196);
INSERT INTO public.who_global_data VALUES (58885, 225, 11796, 3, 44, 249, 105);
INSERT INTO public.who_global_data VALUES (58886, 59, 2021, 5, 69, 249, 122);
INSERT INTO public.who_global_data VALUES (58887, 0, 0, 0, 0, 249, 159);
INSERT INTO public.who_global_data VALUES (58888, 3, 1067, 0, 21, 249, 75);
INSERT INTO public.who_global_data VALUES (58889, 719, 27762, 8, 220, 249, 27);
INSERT INTO public.who_global_data VALUES (58890, 28, 1845, 1, 17, 249, 54);
INSERT INTO public.who_global_data VALUES (58891, 0, 19, 0, 0, 249, 226);
INSERT INTO public.who_global_data VALUES (58892, 5, 1071, 0, 24, 249, 79);
INSERT INTO public.who_global_data VALUES (58893, 13, 1233, 0, 27, 249, 56);
INSERT INTO public.who_global_data VALUES (58894, 0, 2, 0, 0, 249, 117);
INSERT INTO public.who_global_data VALUES (58895, 8, 296, 0, 27, 249, 152);
INSERT INTO public.who_global_data VALUES (58896, 12, 168, 0, 5, 249, 16);
INSERT INTO public.who_global_data VALUES (58897, 0, 83, 0, 1, 249, 10);
INSERT INTO public.who_global_data VALUES (58898, 5, 1676, 0, 71, 249, 201);
INSERT INTO public.who_global_data VALUES (58899, 1, 4019, 0, 110, 249, 174);
INSERT INTO public.who_global_data VALUES (58900, 55, 826, 0, 6, 249, 119);
INSERT INTO public.who_global_data VALUES (58901, 52, 336, 0, 4, 249, 168);
INSERT INTO public.who_global_data VALUES (58902, 38, 7857, 0, 115, 249, 99);
INSERT INTO public.who_global_data VALUES (58903, 56, 1829, 1, 6, 249, 171);
INSERT INTO public.who_global_data VALUES (58904, 50, 1315, 1, 78, 249, 87);
INSERT INTO public.who_global_data VALUES (58905, 1, 619, 0, 9, 249, 123);
INSERT INTO public.who_global_data VALUES (58906, 0, 0, 0, 0, 249, 151);
INSERT INTO public.who_global_data VALUES (58907, 0, 200, 0, 14, 249, 213);
INSERT INTO public.who_global_data VALUES (58908, 0, 530, 0, 23, 249, 118);
INSERT INTO public.who_global_data VALUES (58909, 0, 335, 0, 10, 249, 134);
INSERT INTO public.who_global_data VALUES (58910, 63, 1934, 1, 24, 249, 65);
INSERT INTO public.who_global_data VALUES (58911, 3152, 90664, 151, 9930, 249, 102);
INSERT INTO public.who_global_data VALUES (58912, 0, 0, 0, 0, 249, 223);
INSERT INTO public.who_global_data VALUES (58913, 0, 70, 0, 1, 249, 4);
INSERT INTO public.who_global_data VALUES (58914, 6, 185, 0, 0, 249, 146);
INSERT INTO public.who_global_data VALUES (58915, 0, 324, 0, 9, 249, 31);
INSERT INTO public.who_global_data VALUES (58916, 0, 11, 0, 1, 249, 127);
INSERT INTO public.who_global_data VALUES (58917, 26, 7833, 0, 205, 249, 22);
INSERT INTO public.who_global_data VALUES (58918, 0, 254, 0, 2, 249, 115);
INSERT INTO public.who_global_data VALUES (58919, 4, 228, 0, 6, 249, 106);
INSERT INTO public.who_global_data VALUES (58920, 1, 25, 0, 0, 249, 90);
INSERT INTO public.who_global_data VALUES (58921, 0, 0, 0, 0, 249, 70);
INSERT INTO public.who_global_data VALUES (58922, 239, 1811, 0, 8, 249, 46);
INSERT INTO public.who_global_data VALUES (58923, 105, 46311, 5, 5928, 249, 139);
INSERT INTO public.who_global_data VALUES (58924, 0, 19, 0, 0, 249, 42);
INSERT INTO public.who_global_data VALUES (58925, 0, 1154, 0, 22, 249, 80);
INSERT INTO public.who_global_data VALUES (58926, 0, 885, 0, 35, 249, 203);
INSERT INTO public.who_global_data VALUES (58927, 0, 958, 0, 64, 249, 136);
INSERT INTO public.who_global_data VALUES (58928, 416, 10578, 12, 299, 249, 63);
INSERT INTO public.who_global_data VALUES (58929, 0, 0, 0, 0, 249, 17);
INSERT INTO public.who_global_data VALUES (58930, 0, 22, 0, 2, 249, 172);
INSERT INTO public.who_global_data VALUES (58931, 89, 2315, 7, 140, 249, 109);
INSERT INTO public.who_global_data VALUES (58932, 0, 8411, 0, 236, 249, 200);
INSERT INTO public.who_global_data VALUES (58933, 1, 628, 0, 5, 249, 93);
INSERT INTO public.who_global_data VALUES (58934, 786, 12223, 1, 50, 249, 5);
INSERT INTO public.who_global_data VALUES (58935, 0, 741, 0, 13, 249, 214);
INSERT INTO public.who_global_data VALUES (58936, 3938, 76398, 78, 1621, 249, 204);
INSERT INTO public.who_global_data VALUES (58937, 0, 0, 0, 0, 249, 198);
INSERT INTO public.who_global_data VALUES (58938, 445, 13463, 6, 336, 249, 173);
INSERT INTO public.who_global_data VALUES (58939, 0, 8, 0, 0, 249, 229);
INSERT INTO public.who_global_data VALUES (58940, 9, 995, 0, 11, 249, 76);
INSERT INTO public.who_global_data VALUES (58941, 8805, 164476, 135, 4506, 249, 138);
INSERT INTO public.who_global_data VALUES (58942, 552, 18638, 3, 960, 249, 98);
INSERT INTO public.who_global_data VALUES (58943, 0, 0, 0, 0, 249, 103);
INSERT INTO public.who_global_data VALUES (58944, 379, 24165, 10, 1074, 249, 225);
INSERT INTO public.who_global_data VALUES (58945, 200, 32700, 14, 1424, 249, 131);
INSERT INTO public.who_global_data VALUES (58946, 97, 3873, 0, 136, 249, 235);
INSERT INTO public.who_global_data VALUES (58947, 1523, 58433, 2, 40, 249, 137);
INSERT INTO public.who_global_data VALUES (58948, 38, 11541, 1, 272, 249, 81);
INSERT INTO public.who_global_data VALUES (58949, 109, 8360, 12, 307, 249, 182);
INSERT INTO public.who_global_data VALUES (58950, 2, 473, 0, 1, 249, 145);
INSERT INTO public.who_global_data VALUES (58951, 141, 19398, 17, 1279, 249, 26);
INSERT INTO public.who_global_data VALUES (58952, 8863, 423741, 182, 5037, 249, 170);
INSERT INTO public.who_global_data VALUES (58953, 7, 377, 0, 1, 249, 191);
INSERT INTO public.who_global_data VALUES (58954, 0, 3, 0, 0, 249, 221);
INSERT INTO public.who_global_data VALUES (58955, 0, 6, 0, 0, 249, 64);
INSERT INTO public.who_global_data VALUES (58956, 0, 0, 0, 0, 249, 116);
INSERT INTO public.who_global_data VALUES (58957, 0, 15, 0, 0, 249, 128);
INSERT INTO public.who_global_data VALUES (58958, 0, 18, 0, 0, 249, 6);
INSERT INTO public.who_global_data VALUES (58959, 0, 41, 0, 3, 249, 227);
INSERT INTO public.who_global_data VALUES (58960, 0, 1, 0, 0, 249, 68);
INSERT INTO public.who_global_data VALUES (58961, 0, 26, 0, 0, 249, 184);
INSERT INTO public.who_global_data VALUES (58962, 0, 0, 0, 0, 249, 82);
INSERT INTO public.who_global_data VALUES (58963, 0, 687, 0, 42, 249, 149);
INSERT INTO public.who_global_data VALUES (58964, 0, 295, 0, 10, 249, 197);
INSERT INTO public.who_global_data VALUES (58965, 1881, 87142, 22, 525, 249, 78);
INSERT INTO public.who_global_data VALUES (58966, 94, 3739, 0, 42, 249, 233);
INSERT INTO public.who_global_data VALUES (58967, 18, 11430, 1, 244, 249, 133);
INSERT INTO public.who_global_data VALUES (58968, 0, 11, 0, 0, 249, 35);
INSERT INTO public.who_global_data VALUES (58969, 4, 865, 0, 46, 249, 114);
INSERT INTO public.who_global_data VALUES (58970, 408, 35292, 1, 24, 249, 237);
INSERT INTO public.who_global_data VALUES (58971, 0, 2, 0, 0, 249, 55);
INSERT INTO public.who_global_data VALUES (58972, 0, 78, 0, 15, 249, 176);
INSERT INTO public.who_global_data VALUES (58973, 0, 1522, 0, 28, 249, 202);
INSERT INTO public.who_global_data VALUES (58974, 2, 1475, 0, 113, 249, 155);
INSERT INTO public.who_global_data VALUES (58975, 0, 0, 0, 0, 249, 32);
INSERT INTO public.who_global_data VALUES (58976, 47, 2023, 1, 79, 249, 220);
INSERT INTO public.who_global_data VALUES (58977, 1674, 34357, 22, 705, 249, 30);
INSERT INTO public.who_global_data VALUES (58978, 0, 994, 0, 10, 249, 147);
INSERT INTO public.who_global_data VALUES (58979, 191, 247297, 39, 29161, 249, 208);
INSERT INTO public.who_global_data VALUES (58980, 10, 1643, 1, 11, 249, 45);
INSERT INTO public.who_global_data VALUES (58981, 147, 5173, 12, 298, 249, 110);
INSERT INTO public.who_global_data VALUES (58982, 13, 27, 0, 1, 249, 88);
INSERT INTO public.who_global_data VALUES (58983, 265, 38658, 46, 4661, 249, 51);
INSERT INTO public.who_global_data VALUES (58984, 3, 30845, 0, 1714, 249, 209);
INSERT INTO public.who_global_data VALUES (58985, 1, 123, 0, 5, 249, 205);
INSERT INTO public.who_global_data VALUES (58986, 83, 4013, 0, 47, 249, 18);
INSERT INTO public.who_global_data VALUES (58987, 1, 3083, 1, 58, 249, 72);
INSERT INTO public.who_global_data VALUES (58988, 1079, 256598, 86, 37531, 249, 44);
INSERT INTO public.who_global_data VALUES (58989, 0, 24, 0, 0, 249, 15);
INSERT INTO public.who_global_data VALUES (58990, 1, 443, 0, 13, 249, 25);
INSERT INTO public.who_global_data VALUES (58991, 0, 0, 0, 0, 249, 179);
INSERT INTO public.who_global_data VALUES (58992, 0, 0, 0, 0, 249, 34);
INSERT INTO public.who_global_data VALUES (58993, 0, 117, 0, 8, 249, 207);
INSERT INTO public.who_global_data VALUES (58994, 2, 1086, 0, 48, 249, 166);
INSERT INTO public.who_global_data VALUES (58995, 827, 164769, 23, 4563, 249, 126);
INSERT INTO public.who_global_data VALUES (58996, 0, 0, 0, 0, 249, 97);
INSERT INTO public.who_global_data VALUES (58997, 0, 12, 0, 1, 249, 36);
INSERT INTO public.who_global_data VALUES (58998, 0, 0, 0, 0, 249, 125);
INSERT INTO public.who_global_data VALUES (58999, 0, 458, 0, 0, 249, 124);
INSERT INTO public.who_global_data VALUES (59000, 328, 24340, 9, 727, 249, 185);
INSERT INTO public.who_global_data VALUES (59001, 635, 35192, 2, 266, 249, 194);
INSERT INTO public.who_global_data VALUES (59002, 0, 509, 0, 21, 249, 144);
INSERT INTO public.who_global_data VALUES (59003, 26116, 1783638, 693, 104247, 249, 19);
INSERT INTO public.who_global_data VALUES (59004, 1, 70, 0, 6, 249, 217);
INSERT INTO public.who_global_data VALUES (59005, 2, 823, 0, 22, 249, 148);
INSERT INTO public.who_global_data VALUES (59006, 56, 3718, 0, 15, 249, 86);
INSERT INTO public.who_global_data VALUES (59007, 0, 0, 0, 0, 249, 13);
INSERT INTO public.who_global_data VALUES (59008, 51, 1510, 0, 14, 249, 157);
INSERT INTO public.who_global_data VALUES (59009, 0, 328, 0, 0, 249, 8);
INSERT INTO public.who_global_data VALUES (59010, 0, 0, 0, 0, 249, 73);
INSERT INTO public.who_global_data VALUES (59011, 31, 354, 4, 84, 249, 101);
INSERT INTO public.who_global_data VALUES (59012, 32, 1089, 0, 7, 249, 165);
INSERT INTO public.who_global_data VALUES (59013, 0, 178, 0, 4, 249, 14);
INSERT INTO public.who_global_data VALUES (59014, 656, 15836, 15, 269, 250, 193);
INSERT INTO public.who_global_data VALUES (59015, 7, 1105, 0, 32, 250, 113);
INSERT INTO public.who_global_data VALUES (59016, 127, 9394, 7, 653, 250, 143);
INSERT INTO public.who_global_data VALUES (59017, 0, 0, 0, 0, 250, 219);
INSERT INTO public.who_global_data VALUES (59018, 0, 764, 0, 51, 250, 186);
INSERT INTO public.who_global_data VALUES (59019, 2, 86, 0, 4, 250, 52);
INSERT INTO public.who_global_data VALUES (59020, 0, 3, 0, 0, 250, 180);
INSERT INTO public.who_global_data VALUES (59021, 0, 25, 0, 3, 250, 167);
INSERT INTO public.who_global_data VALUES (59022, 1512, 16214, 20, 530, 250, 154);
INSERT INTO public.who_global_data VALUES (59023, 355, 9258, 4, 131, 250, 94);
INSERT INTO public.who_global_data VALUES (59024, 0, 101, 0, 3, 250, 66);
INSERT INTO public.who_global_data VALUES (59025, 10, 7195, 0, 103, 250, 58);
INSERT INTO public.who_global_data VALUES (59026, 4, 16642, 0, 668, 250, 163);
INSERT INTO public.who_global_data VALUES (59027, 248, 5494, 2, 63, 250, 37);
INSERT INTO public.who_global_data VALUES (59028, 0, 101, 0, 11, 250, 142);
INSERT INTO public.who_global_data VALUES (59029, 605, 11398, 2, 19, 250, 83);
INSERT INTO public.who_global_data VALUES (59030, 0, 47153, 0, 650, 250, 228);
INSERT INTO public.who_global_data VALUES (59031, 0, 92, 0, 7, 250, 188);
INSERT INTO public.who_global_data VALUES (59032, 898, 42556, 6, 235, 250, 62);
INSERT INTO public.who_global_data VALUES (59033, 49, 59064, 22, 9364, 250, 160);
INSERT INTO public.who_global_data VALUES (59034, 0, 18, 0, 2, 250, 50);
INSERT INTO public.who_global_data VALUES (59035, 0, 232, 0, 3, 250, 33);
INSERT INTO public.who_global_data VALUES (59036, 0, 140, 0, 9, 250, 183);
INSERT INTO public.who_global_data VALUES (59037, 0, 43, 0, 0, 250, 92);
INSERT INTO public.who_global_data VALUES (59038, 861, 9592, 10, 310, 250, 158);
INSERT INTO public.who_global_data VALUES (59039, 0, 2, 0, 0, 250, 67);
INSERT INTO public.who_global_data VALUES (59040, 16, 2509, 0, 152, 250, 57);
INSERT INTO public.who_global_data VALUES (59041, 3, 38, 0, 1, 250, 38);
INSERT INTO public.who_global_data VALUES (59042, 33274, 498440, 956, 28834, 250, 141);
INSERT INTO public.who_global_data VALUES (59043, 0, 8, 0, 1, 250, 178);
INSERT INTO public.who_global_data VALUES (59044, 0, 141, 0, 2, 250, 108);
INSERT INTO public.who_global_data VALUES (59045, 0, 2513, 0, 140, 250, 39);
INSERT INTO public.who_global_data VALUES (59046, 28, 881, 0, 53, 250, 2);
INSERT INTO public.who_global_data VALUES (59047, 21, 63, 0, 1, 250, 195);
INSERT INTO public.who_global_data VALUES (59048, 14, 435, 0, 4, 250, 107);
INSERT INTO public.who_global_data VALUES (59049, 0, 125, 0, 0, 250, 161);
INSERT INTO public.who_global_data VALUES (59050, 245, 5904, 6, 191, 250, 212);
INSERT INTO public.who_global_data VALUES (59051, 775, 90516, 96, 7092, 250, 181);
INSERT INTO public.who_global_data VALUES (59052, 0, 141, 0, 1, 250, 53);
INSERT INTO public.who_global_data VALUES (59053, 137, 1011, 1, 2, 250, 164);
INSERT INTO public.who_global_data VALUES (59054, 19, 778, 0, 65, 250, 140);
INSERT INTO public.who_global_data VALUES (59055, 4830, 99688, 57, 1054, 250, 20);
INSERT INTO public.who_global_data VALUES (59056, 18, 84588, 0, 4645, 250, 112);
INSERT INTO public.who_global_data VALUES (59057, 1548, 28236, 37, 890, 250, 111);
INSERT INTO public.who_global_data VALUES (59058, 19, 62, 0, 2, 250, 71);
INSERT INTO public.who_global_data VALUES (59059, 17, 604, 1, 20, 250, 218);
INSERT INTO public.who_global_data VALUES (59060, 0, 0, 0, 0, 250, 43);
INSERT INTO public.who_global_data VALUES (59061, 25, 1047, 0, 10, 250, 49);
INSERT INTO public.who_global_data VALUES (59062, 34, 2833, 0, 33, 250, 1);
INSERT INTO public.who_global_data VALUES (59063, 0, 2246, 0, 103, 250, 48);
INSERT INTO public.who_global_data VALUES (59064, 20, 2045, 0, 83, 250, 232);
INSERT INTO public.who_global_data VALUES (59065, 0, 20, 0, 1, 250, 175);
INSERT INTO public.who_global_data VALUES (59066, 1, 944, 0, 17, 250, 21);
INSERT INTO public.who_global_data VALUES (59067, 43, 9273, 1, 320, 250, 156);
INSERT INTO public.who_global_data VALUES (59068, 0, 0, 0, 0, 250, 95);
INSERT INTO public.who_global_data VALUES (59069, 83, 3048, 3, 71, 250, 177);
INSERT INTO public.who_global_data VALUES (59070, 36, 11669, 3, 574, 250, 210);
INSERT INTO public.who_global_data VALUES (59071, 160, 3354, 2, 24, 250, 120);
INSERT INTO public.who_global_data VALUES (59072, 0, 16, 0, 0, 250, 135);
INSERT INTO public.who_global_data VALUES (59073, 377, 17285, 4, 502, 250, 206);
INSERT INTO public.who_global_data VALUES (59074, 527, 39098, 24, 3358, 250, 189);
INSERT INTO public.who_global_data VALUES (59075, 1536, 24985, 46, 959, 250, 129);
INSERT INTO public.who_global_data VALUES (59076, 122, 2517, 2, 46, 250, 121);
INSERT INTO public.who_global_data VALUES (59077, 0, 1043, 0, 12, 250, 59);
INSERT INTO public.who_global_data VALUES (59078, 0, 39, 0, 0, 250, 96);
INSERT INTO public.who_global_data VALUES (59079, 4, 1869, 0, 63, 250, 41);
INSERT INTO public.who_global_data VALUES (59080, 2, 285, 0, 2, 250, 216);
INSERT INTO public.who_global_data VALUES (59081, 109, 1172, 3, 11, 250, 236);
INSERT INTO public.who_global_data VALUES (59082, 0, 13, 0, 0, 250, 150);
INSERT INTO public.who_global_data VALUES (59083, 0, 187, 0, 0, 250, 61);
INSERT INTO public.who_global_data VALUES (59084, 0, 18, 0, 0, 250, 7);
INSERT INTO public.who_global_data VALUES (59085, 33, 6859, 4, 320, 250, 169);
INSERT INTO public.who_global_data VALUES (59086, 88, 148524, 29, 28746, 250, 28);
INSERT INTO public.who_global_data VALUES (59087, 41, 477, 0, 1, 250, 85);
INSERT INTO public.who_global_data VALUES (59088, 0, 60, 0, 0, 250, 211);
INSERT INTO public.who_global_data VALUES (59089, 42, 2655, 2, 17, 250, 60);
INSERT INTO public.who_global_data VALUES (59090, 0, 25, 0, 1, 250, 3);
INSERT INTO public.who_global_data VALUES (59091, 11, 794, 0, 12, 250, 11);
INSERT INTO public.who_global_data VALUES (59092, 333, 181815, 11, 8511, 250, 89);
INSERT INTO public.who_global_data VALUES (59093, 113, 7881, 1, 36, 250, 24);
INSERT INTO public.who_global_data VALUES (59094, 8, 169, 0, 0, 250, 162);
INSERT INTO public.who_global_data VALUES (59095, 2, 2917, 0, 175, 250, 100);
INSERT INTO public.who_global_data VALUES (59096, 0, 13, 0, 0, 250, 47);
INSERT INTO public.who_global_data VALUES (59097, 0, 23, 0, 0, 250, 29);
INSERT INTO public.who_global_data VALUES (59098, 0, 162, 0, 14, 250, 40);
INSERT INTO public.who_global_data VALUES (59099, 0, 166, 0, 5, 250, 222);
INSERT INTO public.who_global_data VALUES (59100, 132, 4739, 12, 102, 250, 132);
INSERT INTO public.who_global_data VALUES (59101, 0, 252, 0, 13, 250, 130);
INSERT INTO public.who_global_data VALUES (59102, 65, 3771, 0, 23, 250, 234);
INSERT INTO public.who_global_data VALUES (59103, 66, 1322, 0, 8, 250, 23);
INSERT INTO public.who_global_data VALUES (59104, 2, 152, 1, 12, 250, 192);
INSERT INTO public.who_global_data VALUES (59105, 281, 1865, 6, 41, 250, 69);
INSERT INTO public.who_global_data VALUES (59106, 0, 12, 0, 0, 250, 187);
INSERT INTO public.who_global_data VALUES (59107, 208, 5094, 2, 201, 250, 230);
INSERT INTO public.who_global_data VALUES (59108, 9, 3876, 2, 526, 250, 77);
INSERT INTO public.who_global_data VALUES (59109, 0, 1806, 0, 10, 250, 9);
INSERT INTO public.who_global_data VALUES (59110, 8392, 190535, 230, 5394, 250, 74);
INSERT INTO public.who_global_data VALUES (59111, 0, 26473, 0, 1613, 250, 224);
INSERT INTO public.who_global_data VALUES (59112, 2516, 151466, 63, 7797, 250, 199);
INSERT INTO public.who_global_data VALUES (59113, 260, 6439, 10, 205, 250, 190);
INSERT INTO public.who_global_data VALUES (59114, 61, 24990, 0, 1650, 250, 12);
INSERT INTO public.who_global_data VALUES (59115, 0, 336, 0, 24, 250, 104);
INSERT INTO public.who_global_data VALUES (59116, 29, 16998, 0, 287, 250, 153);
INSERT INTO public.who_global_data VALUES (59117, 355, 233019, 75, 33415, 250, 91);
INSERT INTO public.who_global_data VALUES (59118, 6, 581, 0, 9, 250, 215);
INSERT INTO public.who_global_data VALUES (59119, 33, 16884, 1, 892, 250, 84);
INSERT INTO public.who_global_data VALUES (59120, 0, 308, 0, 29, 250, 231);
INSERT INTO public.who_global_data VALUES (59121, 3, 733, 0, 9, 250, 196);
INSERT INTO public.who_global_data VALUES (59122, 263, 11571, 0, 41, 250, 105);
INSERT INTO public.who_global_data VALUES (59123, 74, 1962, 1, 64, 250, 122);
INSERT INTO public.who_global_data VALUES (59124, 0, 0, 0, 0, 250, 159);
INSERT INTO public.who_global_data VALUES (59125, 0, 1064, 0, 21, 250, 75);
INSERT INTO public.who_global_data VALUES (59126, 851, 27043, 7, 212, 250, 27);
INSERT INTO public.who_global_data VALUES (59127, 69, 1817, 0, 16, 250, 54);
INSERT INTO public.who_global_data VALUES (59128, 0, 19, 0, 0, 250, 226);
INSERT INTO public.who_global_data VALUES (59129, 1, 1066, 0, 24, 250, 79);
INSERT INTO public.who_global_data VALUES (59130, 29, 1220, 1, 27, 250, 56);
INSERT INTO public.who_global_data VALUES (59131, 0, 2, 0, 0, 250, 117);
INSERT INTO public.who_global_data VALUES (59132, 8, 288, 0, 27, 250, 152);
INSERT INTO public.who_global_data VALUES (59133, 26, 156, 0, 5, 250, 16);
INSERT INTO public.who_global_data VALUES (59134, 0, 83, 0, 1, 250, 10);
INSERT INTO public.who_global_data VALUES (59135, 4, 1671, 1, 71, 250, 201);
INSERT INTO public.who_global_data VALUES (59136, 2, 4018, 0, 110, 250, 174);
INSERT INTO public.who_global_data VALUES (59137, 13, 771, 0, 6, 250, 119);
INSERT INTO public.who_global_data VALUES (59138, 5, 284, 0, 4, 250, 168);
INSERT INTO public.who_global_data VALUES (59139, 57, 7819, 0, 115, 250, 99);
INSERT INTO public.who_global_data VALUES (59140, 101, 1773, 0, 5, 250, 171);
INSERT INTO public.who_global_data VALUES (59141, 15, 1265, 1, 77, 250, 87);
INSERT INTO public.who_global_data VALUES (59142, 1, 618, 0, 9, 250, 123);
INSERT INTO public.who_global_data VALUES (59143, 0, 0, 0, 0, 250, 151);
INSERT INTO public.who_global_data VALUES (59144, 0, 200, 0, 14, 250, 213);
INSERT INTO public.who_global_data VALUES (59145, 47, 530, 2, 23, 250, 118);
INSERT INTO public.who_global_data VALUES (59146, 0, 335, 0, 10, 250, 134);
INSERT INTO public.who_global_data VALUES (59147, 128, 1871, 2, 23, 250, 65);
INSERT INTO public.who_global_data VALUES (59148, 2885, 87512, 364, 9779, 250, 102);
INSERT INTO public.who_global_data VALUES (59149, 0, 0, 0, 0, 250, 223);
INSERT INTO public.who_global_data VALUES (59150, 0, 70, 0, 1, 250, 4);
INSERT INTO public.who_global_data VALUES (59151, 0, 179, 0, 0, 250, 146);
INSERT INTO public.who_global_data VALUES (59152, 0, 324, 0, 9, 250, 31);
INSERT INTO public.who_global_data VALUES (59153, 0, 11, 0, 1, 250, 127);
INSERT INTO public.who_global_data VALUES (59154, 27, 7807, 1, 205, 250, 22);
INSERT INTO public.who_global_data VALUES (59155, 10, 254, 0, 2, 250, 115);
INSERT INTO public.who_global_data VALUES (59156, 0, 224, 0, 6, 250, 106);
INSERT INTO public.who_global_data VALUES (59157, 1, 24, 0, 0, 250, 90);
INSERT INTO public.who_global_data VALUES (59158, 0, 0, 0, 0, 250, 70);
INSERT INTO public.who_global_data VALUES (59159, 0, 1572, 0, 8, 250, 46);
INSERT INTO public.who_global_data VALUES (59160, 176, 46206, 4, 5923, 250, 139);
INSERT INTO public.who_global_data VALUES (59161, 0, 19, 0, 0, 250, 42);
INSERT INTO public.who_global_data VALUES (59162, 0, 1154, 0, 22, 250, 80);
INSERT INTO public.who_global_data VALUES (59163, 0, 885, 0, 35, 250, 203);
INSERT INTO public.who_global_data VALUES (59164, 2, 958, 0, 64, 250, 136);
INSERT INTO public.who_global_data VALUES (59165, 307, 10162, 14, 287, 250, 63);
INSERT INTO public.who_global_data VALUES (59166, 0, 0, 0, 0, 250, 17);
INSERT INTO public.who_global_data VALUES (59167, 0, 22, 0, 2, 250, 172);
INSERT INTO public.who_global_data VALUES (59168, 62, 2226, 2, 133, 250, 109);
INSERT INTO public.who_global_data VALUES (59169, 0, 8411, 0, 236, 250, 200);
INSERT INTO public.who_global_data VALUES (59170, 1, 627, 0, 5, 250, 93);
INSERT INTO public.who_global_data VALUES (59171, 1014, 11437, 7, 49, 250, 5);
INSERT INTO public.who_global_data VALUES (59172, 0, 741, 0, 13, 250, 214);
INSERT INTO public.who_global_data VALUES (59173, 2964, 72460, 60, 1543, 250, 204);
INSERT INTO public.who_global_data VALUES (59174, 0, 0, 0, 0, 250, 198);
INSERT INTO public.who_global_data VALUES (59175, 487, 13018, 4, 330, 250, 173);
INSERT INTO public.who_global_data VALUES (59176, 0, 8, 0, 0, 250, 229);
INSERT INTO public.who_global_data VALUES (59177, 22, 986, 0, 11, 250, 76);
INSERT INTO public.who_global_data VALUES (59178, 7386, 155671, 141, 4371, 250, 138);
INSERT INTO public.who_global_data VALUES (59179, 0, 18086, 0, 957, 250, 98);
INSERT INTO public.who_global_data VALUES (59180, 0, 0, 0, 0, 250, 103);
INSERT INTO public.who_global_data VALUES (59181, 215, 23786, 3, 1064, 250, 225);
INSERT INTO public.who_global_data VALUES (59182, 297, 32500, 14, 1410, 250, 131);
INSERT INTO public.who_global_data VALUES (59183, 58, 3776, 3, 136, 250, 235);
INSERT INTO public.who_global_data VALUES (59184, 1648, 56910, 2, 38, 250, 137);
INSERT INTO public.who_global_data VALUES (59185, 35, 11503, 1, 271, 250, 81);
INSERT INTO public.who_global_data VALUES (59186, 153, 8251, 1, 295, 250, 182);
INSERT INTO public.who_global_data VALUES (59187, 0, 471, 0, 1, 250, 145);
INSERT INTO public.who_global_data VALUES (59188, 124, 19257, 9, 1262, 250, 26);
INSERT INTO public.who_global_data VALUES (59189, 9035, 414878, 162, 4855, 250, 170);
INSERT INTO public.who_global_data VALUES (59190, 11, 370, 0, 1, 250, 191);
INSERT INTO public.who_global_data VALUES (59191, 0, 3, 0, 0, 250, 221);
INSERT INTO public.who_global_data VALUES (59192, 0, 6, 0, 0, 250, 64);
INSERT INTO public.who_global_data VALUES (59193, 0, 0, 0, 0, 250, 116);
INSERT INTO public.who_global_data VALUES (59194, 0, 15, 0, 0, 250, 128);
INSERT INTO public.who_global_data VALUES (59195, 0, 18, 0, 0, 250, 6);
INSERT INTO public.who_global_data VALUES (59196, 0, 41, 0, 3, 250, 227);
INSERT INTO public.who_global_data VALUES (59197, 0, 1, 0, 0, 250, 68);
INSERT INTO public.who_global_data VALUES (59198, 1, 26, 0, 0, 250, 184);
INSERT INTO public.who_global_data VALUES (59199, 0, 0, 0, 0, 250, 82);
INSERT INTO public.who_global_data VALUES (59200, 0, 687, 0, 42, 250, 149);
INSERT INTO public.who_global_data VALUES (59201, 0, 295, 0, 10, 250, 197);
INSERT INTO public.who_global_data VALUES (59202, 1877, 85261, 23, 503, 250, 78);
INSERT INTO public.who_global_data VALUES (59203, 110, 3645, 0, 42, 250, 233);
INSERT INTO public.who_global_data VALUES (59204, 31, 11412, 1, 243, 250, 133);
INSERT INTO public.who_global_data VALUES (59205, 0, 11, 0, 0, 250, 35);
INSERT INTO public.who_global_data VALUES (59206, 9, 861, 0, 46, 250, 114);
INSERT INTO public.who_global_data VALUES (59207, 518, 34884, 0, 23, 250, 237);
INSERT INTO public.who_global_data VALUES (59208, 0, 2, 0, 0, 250, 55);
INSERT INTO public.who_global_data VALUES (59209, 0, 78, 0, 15, 250, 176);
INSERT INTO public.who_global_data VALUES (59210, 1, 1522, 0, 28, 250, 202);
INSERT INTO public.who_global_data VALUES (59211, 0, 1473, 0, 113, 250, 155);
INSERT INTO public.who_global_data VALUES (59212, 0, 0, 0, 0, 250, 32);
INSERT INTO public.who_global_data VALUES (59213, 60, 1976, 5, 78, 250, 220);
INSERT INTO public.who_global_data VALUES (59214, 1716, 32683, 40, 683, 250, 30);
INSERT INTO public.who_global_data VALUES (59215, 0, 994, 0, 10, 250, 147);
INSERT INTO public.who_global_data VALUES (59216, 367, 247106, 43, 29122, 250, 208);
INSERT INTO public.who_global_data VALUES (59217, 3, 1633, 0, 10, 250, 45);
INSERT INTO public.who_global_data VALUES (59218, 226, 5026, 24, 286, 250, 110);
INSERT INTO public.who_global_data VALUES (59219, 2, 14, 0, 1, 250, 88);
INSERT INTO public.who_global_data VALUES (59220, 432, 38393, 38, 4615, 250, 51);
INSERT INTO public.who_global_data VALUES (59221, 7, 30842, 0, 1714, 250, 209);
INSERT INTO public.who_global_data VALUES (59222, 0, 122, 1, 5, 250, 205);
INSERT INTO public.who_global_data VALUES (59223, 123, 3930, 0, 47, 250, 18);
INSERT INTO public.who_global_data VALUES (59224, 1, 3082, 0, 57, 250, 72);
INSERT INTO public.who_global_data VALUES (59225, 1125, 255519, 60, 37445, 250, 44);
INSERT INTO public.who_global_data VALUES (59226, 0, 24, 0, 0, 250, 15);
INSERT INTO public.who_global_data VALUES (59227, 14, 442, 0, 13, 250, 25);
INSERT INTO public.who_global_data VALUES (59228, 0, 0, 0, 0, 250, 179);
INSERT INTO public.who_global_data VALUES (59229, 0, 0, 0, 0, 250, 34);
INSERT INTO public.who_global_data VALUES (59230, 1, 117, 0, 8, 250, 207);
INSERT INTO public.who_global_data VALUES (59231, 7, 1084, 0, 48, 250, 166);
INSERT INTO public.who_global_data VALUES (59232, 839, 163942, 25, 4540, 250, 126);
INSERT INTO public.who_global_data VALUES (59233, 0, 0, 0, 0, 250, 97);
INSERT INTO public.who_global_data VALUES (59234, 0, 12, 0, 1, 250, 36);
INSERT INTO public.who_global_data VALUES (59235, 0, 0, 0, 0, 250, 125);
INSERT INTO public.who_global_data VALUES (59236, 12, 458, 0, 0, 250, 124);
INSERT INTO public.who_global_data VALUES (59237, 340, 24012, 10, 718, 250, 185);
INSERT INTO public.who_global_data VALUES (59238, 661, 34557, 2, 264, 250, 194);
INSERT INTO public.who_global_data VALUES (59239, 0, 509, 0, 21, 250, 144);
INSERT INTO public.who_global_data VALUES (59240, 23482, 1757522, 914, 103554, 250, 19);
INSERT INTO public.who_global_data VALUES (59241, 0, 69, 0, 6, 250, 217);
INSERT INTO public.who_global_data VALUES (59242, 5, 821, 0, 22, 250, 148);
INSERT INTO public.who_global_data VALUES (59243, 108, 3662, 1, 15, 250, 86);
INSERT INTO public.who_global_data VALUES (59244, 0, 0, 0, 0, 250, 13);
INSERT INTO public.who_global_data VALUES (59245, 89, 1459, 0, 14, 250, 157);
INSERT INTO public.who_global_data VALUES (59246, 0, 328, 0, 0, 250, 8);
INSERT INTO public.who_global_data VALUES (59247, 0, 0, 0, 0, 250, 73);
INSERT INTO public.who_global_data VALUES (59248, 13, 323, 3, 80, 250, 101);
INSERT INTO public.who_global_data VALUES (59249, 0, 1057, 0, 7, 250, 165);
INSERT INTO public.who_global_data VALUES (59250, 4, 178, 0, 4, 250, 14);
INSERT INTO public.who_global_data VALUES (59251, 651, 15180, 2, 254, 251, 193);
INSERT INTO public.who_global_data VALUES (59252, 14, 1098, 0, 32, 251, 113);
INSERT INTO public.who_global_data VALUES (59253, 133, 9267, 8, 646, 251, 143);
INSERT INTO public.who_global_data VALUES (59254, 0, 0, 0, 0, 251, 219);
INSERT INTO public.who_global_data VALUES (59255, 0, 764, 0, 51, 251, 186);
INSERT INTO public.who_global_data VALUES (59256, 3, 84, 0, 4, 251, 52);
INSERT INTO public.who_global_data VALUES (59257, 0, 3, 0, 0, 251, 180);
INSERT INTO public.who_global_data VALUES (59258, 0, 25, 0, 3, 251, 167);
INSERT INTO public.who_global_data VALUES (59259, 0, 14702, 0, 510, 251, 154);
INSERT INTO public.who_global_data VALUES (59260, 251, 8903, 7, 127, 251, 94);
INSERT INTO public.who_global_data VALUES (59261, 0, 101, 0, 3, 251, 66);
INSERT INTO public.who_global_data VALUES (59262, 12, 7185, 0, 103, 251, 58);
INSERT INTO public.who_global_data VALUES (59263, 44, 16638, 0, 668, 251, 163);
INSERT INTO public.who_global_data VALUES (59264, 257, 5246, 3, 61, 251, 37);
INSERT INTO public.who_global_data VALUES (59265, 0, 101, 0, 11, 251, 142);
INSERT INTO public.who_global_data VALUES (59266, 344, 10793, 2, 17, 251, 83);
INSERT INTO public.who_global_data VALUES (59267, 2545, 47153, 40, 650, 251, 228);
INSERT INTO public.who_global_data VALUES (59268, 0, 92, 0, 7, 251, 188);
INSERT INTO public.who_global_data VALUES (59269, 894, 41658, 5, 229, 251, 62);
INSERT INTO public.who_global_data VALUES (59270, 61, 59015, 22, 9342, 251, 160);
INSERT INTO public.who_global_data VALUES (59271, 0, 18, 0, 2, 251, 50);
INSERT INTO public.who_global_data VALUES (59272, 14, 232, 0, 3, 251, 33);
INSERT INTO public.who_global_data VALUES (59273, 0, 140, 0, 9, 251, 183);
INSERT INTO public.who_global_data VALUES (59274, 10, 43, 0, 0, 251, 92);
INSERT INTO public.who_global_data VALUES (59275, 344, 8731, 7, 300, 251, 158);
INSERT INTO public.who_global_data VALUES (59276, 0, 2, 0, 0, 251, 67);
INSERT INTO public.who_global_data VALUES (59277, 9, 2493, 0, 152, 251, 57);
INSERT INTO public.who_global_data VALUES (59278, 0, 35, 0, 1, 251, 38);
INSERT INTO public.who_global_data VALUES (59279, 26928, 465166, 1124, 27878, 251, 141);
INSERT INTO public.who_global_data VALUES (59280, 0, 8, 0, 1, 251, 178);
INSERT INTO public.who_global_data VALUES (59281, 0, 141, 0, 2, 251, 108);
INSERT INTO public.who_global_data VALUES (59282, 14, 2513, 1, 140, 251, 39);
INSERT INTO public.who_global_data VALUES (59283, 6, 853, 0, 53, 251, 2);
INSERT INTO public.who_global_data VALUES (59284, 0, 42, 0, 1, 251, 195);
INSERT INTO public.who_global_data VALUES (59285, 16, 421, 0, 4, 251, 107);
INSERT INTO public.who_global_data VALUES (59286, 0, 125, 0, 0, 251, 161);
INSERT INTO public.who_global_data VALUES (59287, 223, 5659, 8, 185, 251, 212);
INSERT INTO public.who_global_data VALUES (59288, 885, 89741, 78, 6996, 251, 181);
INSERT INTO public.who_global_data VALUES (59289, 1, 141, 0, 1, 251, 53);
INSERT INTO public.who_global_data VALUES (59290, 0, 874, 0, 1, 251, 164);
INSERT INTO public.who_global_data VALUES (59291, 0, 759, 0, 65, 251, 140);
INSERT INTO public.who_global_data VALUES (59292, 4220, 94858, 53, 997, 251, 20);
INSERT INTO public.who_global_data VALUES (59293, 5, 84570, 0, 4645, 251, 112);
INSERT INTO public.who_global_data VALUES (59294, 1322, 26688, 31, 853, 251, 111);
INSERT INTO public.who_global_data VALUES (59295, 0, 43, 0, 2, 251, 71);
INSERT INTO public.who_global_data VALUES (59296, 0, 587, 0, 19, 251, 218);
INSERT INTO public.who_global_data VALUES (59297, 0, 0, 0, 0, 251, 43);
INSERT INTO public.who_global_data VALUES (59298, 22, 1022, 0, 10, 251, 49);
INSERT INTO public.who_global_data VALUES (59299, 49, 2799, 1, 33, 251, 1);
INSERT INTO public.who_global_data VALUES (59300, 1, 2246, 0, 103, 251, 48);
INSERT INTO public.who_global_data VALUES (59301, 20, 2025, 1, 83, 251, 232);
INSERT INTO public.who_global_data VALUES (59302, 0, 20, 0, 1, 251, 175);
INSERT INTO public.who_global_data VALUES (59303, 2, 943, 0, 17, 251, 21);
INSERT INTO public.who_global_data VALUES (59304, 34, 9230, 0, 319, 251, 156);
INSERT INTO public.who_global_data VALUES (59305, 0, 0, 0, 0, 251, 95);
INSERT INTO public.who_global_data VALUES (59306, 133, 2965, 0, 68, 251, 177);
INSERT INTO public.who_global_data VALUES (59307, 40, 11633, 3, 571, 251, 210);
INSERT INTO public.who_global_data VALUES (59308, 280, 3194, 2, 22, 251, 120);
INSERT INTO public.who_global_data VALUES (59309, 0, 16, 0, 0, 251, 135);
INSERT INTO public.who_global_data VALUES (59310, 377, 16908, 10, 498, 251, 206);
INSERT INTO public.who_global_data VALUES (59311, 0, 38571, 0, 3334, 251, 189);
INSERT INTO public.who_global_data VALUES (59312, 1367, 23449, 34, 913, 251, 129);
INSERT INTO public.who_global_data VALUES (59313, 117, 2395, 2, 44, 251, 121);
INSERT INTO public.who_global_data VALUES (59314, 0, 1043, 0, 12, 251, 59);
INSERT INTO public.who_global_data VALUES (59315, 0, 39, 0, 0, 251, 96);
INSERT INTO public.who_global_data VALUES (59316, 6, 1865, 0, 63, 251, 41);
INSERT INTO public.who_global_data VALUES (59317, 4, 283, 0, 2, 251, 216);
INSERT INTO public.who_global_data VALUES (59318, 95, 1063, 0, 8, 251, 236);
INSERT INTO public.who_global_data VALUES (59319, 0, 13, 0, 0, 251, 150);
INSERT INTO public.who_global_data VALUES (59320, 0, 187, 0, 0, 251, 61);
INSERT INTO public.who_global_data VALUES (59321, 0, 18, 0, 0, 251, 7);
INSERT INTO public.who_global_data VALUES (59322, 50, 6826, 2, 316, 251, 169);
INSERT INTO public.who_global_data VALUES (59323, 1779, 148436, 57, 28717, 251, 28);
INSERT INTO public.who_global_data VALUES (59324, 0, 436, 0, 1, 251, 85);
INSERT INTO public.who_global_data VALUES (59325, 0, 60, 0, 0, 251, 211);
INSERT INTO public.who_global_data VALUES (59326, 0, 2613, 0, 15, 251, 60);
INSERT INTO public.who_global_data VALUES (59327, 0, 25, 0, 1, 251, 3);
INSERT INTO public.who_global_data VALUES (59328, 26, 783, 0, 12, 251, 11);
INSERT INTO public.who_global_data VALUES (59329, 286, 181482, 11, 8500, 251, 89);
INSERT INTO public.who_global_data VALUES (59330, 152, 7768, 1, 35, 251, 24);
INSERT INTO public.who_global_data VALUES (59331, 3, 161, 0, 0, 251, 162);
INSERT INTO public.who_global_data VALUES (59332, 6, 2915, 0, 175, 251, 100);
INSERT INTO public.who_global_data VALUES (59333, 0, 13, 0, 0, 251, 47);
INSERT INTO public.who_global_data VALUES (59334, 0, 23, 0, 0, 251, 29);
INSERT INTO public.who_global_data VALUES (59335, 0, 162, 0, 14, 251, 40);
INSERT INTO public.who_global_data VALUES (59336, 1, 166, 0, 5, 251, 222);
INSERT INTO public.who_global_data VALUES (59337, 259, 4607, 10, 90, 251, 132);
INSERT INTO public.who_global_data VALUES (59338, 0, 252, 0, 13, 251, 130);
INSERT INTO public.who_global_data VALUES (59339, 50, 3706, 1, 23, 251, 234);
INSERT INTO public.who_global_data VALUES (59340, 0, 1256, 0, 8, 251, 23);
INSERT INTO public.who_global_data VALUES (59341, 0, 150, 0, 11, 251, 192);
INSERT INTO public.who_global_data VALUES (59342, 141, 1584, 0, 35, 251, 69);
INSERT INTO public.who_global_data VALUES (59343, 0, 12, 0, 0, 251, 187);
INSERT INTO public.who_global_data VALUES (59344, 134, 4886, 3, 199, 251, 230);
INSERT INTO public.who_global_data VALUES (59345, 26, 3867, 7, 524, 251, 77);
INSERT INTO public.who_global_data VALUES (59346, 1, 1806, 0, 10, 251, 9);
INSERT INTO public.who_global_data VALUES (59347, 8380, 182143, 193, 5164, 251, 74);
INSERT INTO public.who_global_data VALUES (59348, 700, 26473, 40, 1613, 251, 224);
INSERT INTO public.who_global_data VALUES (59349, 2282, 148950, 57, 7734, 251, 199);
INSERT INTO public.who_global_data VALUES (59350, 306, 6179, 10, 195, 251, 190);
INSERT INTO public.who_global_data VALUES (59351, 53, 24929, 5, 1650, 251, 12);
INSERT INTO public.who_global_data VALUES (59352, 0, 336, 0, 24, 251, 104);
INSERT INTO public.who_global_data VALUES (59353, 113, 16969, 0, 287, 251, 153);
INSERT INTO public.who_global_data VALUES (59354, 416, 232664, 111, 33340, 251, 91);
INSERT INTO public.who_global_data VALUES (59355, 6, 575, 0, 9, 251, 215);
INSERT INTO public.who_global_data VALUES (59356, 47, 16851, 5, 891, 251, 84);
INSERT INTO public.who_global_data VALUES (59357, 0, 308, 0, 29, 251, 231);
INSERT INTO public.who_global_data VALUES (59358, 4, 730, 0, 9, 251, 196);
INSERT INTO public.who_global_data VALUES (59359, 450, 11308, 3, 41, 251, 105);
INSERT INTO public.who_global_data VALUES (59360, 143, 1888, 1, 63, 251, 122);
INSERT INTO public.who_global_data VALUES (59361, 0, 0, 0, 0, 251, 159);
INSERT INTO public.who_global_data VALUES (59362, 16, 1064, 0, 21, 251, 75);
INSERT INTO public.who_global_data VALUES (59363, 1008, 26192, 11, 205, 251, 27);
INSERT INTO public.who_global_data VALUES (59364, 26, 1748, 0, 16, 251, 54);
INSERT INTO public.who_global_data VALUES (59365, 0, 19, 0, 0, 251, 226);
INSERT INTO public.who_global_data VALUES (59366, 1, 1065, 0, 24, 251, 79);
INSERT INTO public.who_global_data VALUES (59367, 19, 1191, 0, 26, 251, 56);
INSERT INTO public.who_global_data VALUES (59368, 0, 2, 0, 0, 251, 117);
INSERT INTO public.who_global_data VALUES (59369, 7, 280, 0, 27, 251, 152);
INSERT INTO public.who_global_data VALUES (59370, 12, 130, 0, 5, 251, 16);
INSERT INTO public.who_global_data VALUES (59371, 0, 83, 0, 1, 251, 10);
INSERT INTO public.who_global_data VALUES (59372, 5, 1667, 0, 70, 251, 201);
INSERT INTO public.who_global_data VALUES (59373, 4, 4016, 0, 110, 251, 174);
INSERT INTO public.who_global_data VALUES (59374, 60, 758, 1, 6, 251, 119);
INSERT INTO public.who_global_data VALUES (59375, 6, 279, 0, 4, 251, 168);
INSERT INTO public.who_global_data VALUES (59376, 30, 7762, 0, 115, 251, 99);
INSERT INTO public.who_global_data VALUES (59377, 39, 1672, 0, 5, 251, 171);
INSERT INTO public.who_global_data VALUES (59378, 24, 1250, 3, 76, 251, 87);
INSERT INTO public.who_global_data VALUES (59379, 0, 617, 0, 9, 251, 123);
INSERT INTO public.who_global_data VALUES (59380, 0, 0, 0, 0, 251, 151);
INSERT INTO public.who_global_data VALUES (59381, 3, 200, 0, 14, 251, 213);
INSERT INTO public.who_global_data VALUES (59382, 60, 483, 1, 21, 251, 118);
INSERT INTO public.who_global_data VALUES (59383, 0, 335, 0, 10, 251, 134);
INSERT INTO public.who_global_data VALUES (59384, 44, 1743, 0, 21, 251, 65);
INSERT INTO public.who_global_data VALUES (59385, 3227, 84627, 371, 9415, 251, 102);
INSERT INTO public.who_global_data VALUES (59386, 0, 0, 0, 0, 251, 223);
INSERT INTO public.who_global_data VALUES (59387, 0, 70, 0, 1, 251, 4);
INSERT INTO public.who_global_data VALUES (59388, 0, 179, 0, 0, 251, 146);
INSERT INTO public.who_global_data VALUES (59389, 0, 324, 0, 9, 251, 31);
INSERT INTO public.who_global_data VALUES (59390, 0, 11, 0, 1, 251, 127);
INSERT INTO public.who_global_data VALUES (59391, 66, 7780, 2, 204, 251, 22);
INSERT INTO public.who_global_data VALUES (59392, 10, 244, 0, 2, 251, 115);
INSERT INTO public.who_global_data VALUES (59393, 0, 224, 0, 6, 251, 106);
INSERT INTO public.who_global_data VALUES (59394, 0, 23, 0, 0, 251, 90);
INSERT INTO public.who_global_data VALUES (59395, 0, 0, 0, 0, 251, 70);
INSERT INTO public.who_global_data VALUES (59396, 171, 1572, 2, 8, 251, 46);
INSERT INTO public.who_global_data VALUES (59397, 141, 46030, 20, 5919, 251, 139);
INSERT INTO public.who_global_data VALUES (59398, 0, 19, 0, 0, 251, 42);
INSERT INTO public.who_global_data VALUES (59399, 0, 1154, 0, 22, 251, 80);
INSERT INTO public.who_global_data VALUES (59400, 0, 885, 0, 35, 251, 203);
INSERT INTO public.who_global_data VALUES (59401, 1, 956, 0, 64, 251, 136);
INSERT INTO public.who_global_data VALUES (59402, 553, 9855, 12, 273, 251, 63);
INSERT INTO public.who_global_data VALUES (59403, 0, 0, 0, 0, 251, 17);
INSERT INTO public.who_global_data VALUES (59404, 0, 22, 0, 2, 251, 172);
INSERT INTO public.who_global_data VALUES (59405, 34, 2164, 5, 131, 251, 109);
INSERT INTO public.who_global_data VALUES (59406, 0, 8411, 0, 236, 251, 200);
INSERT INTO public.who_global_data VALUES (59407, 1, 626, 0, 5, 251, 93);
INSERT INTO public.who_global_data VALUES (59408, 603, 10423, 1, 42, 251, 5);
INSERT INTO public.who_global_data VALUES (59409, 0, 741, 0, 13, 251, 214);
INSERT INTO public.who_global_data VALUES (59410, 3039, 69496, 88, 1483, 251, 204);
INSERT INTO public.who_global_data VALUES (59411, 0, 0, 0, 0, 251, 198);
INSERT INTO public.who_global_data VALUES (59412, 400, 12531, 6, 326, 251, 173);
INSERT INTO public.who_global_data VALUES (59413, 0, 8, 0, 0, 251, 229);
INSERT INTO public.who_global_data VALUES (59414, 47, 964, 0, 11, 251, 76);
INSERT INTO public.who_global_data VALUES (59415, 6506, 148285, 131, 4230, 251, 138);
INSERT INTO public.who_global_data VALUES (59416, 1452, 18086, 15, 957, 251, 98);
INSERT INTO public.who_global_data VALUES (59417, 0, 0, 0, 0, 251, 103);
INSERT INTO public.who_global_data VALUES (59418, 416, 23571, 10, 1061, 251, 225);
INSERT INTO public.who_global_data VALUES (59419, 257, 32203, 13, 1396, 251, 131);
INSERT INTO public.who_global_data VALUES (59420, 71, 3718, 1, 133, 251, 235);
INSERT INTO public.who_global_data VALUES (59421, 2355, 55262, 0, 36, 251, 137);
INSERT INTO public.who_global_data VALUES (59422, 27, 11468, 1, 270, 251, 81);
INSERT INTO public.who_global_data VALUES (59423, 202, 8098, 5, 294, 251, 182);
INSERT INTO public.who_global_data VALUES (59424, 1, 471, 0, 1, 251, 145);
INSERT INTO public.who_global_data VALUES (59425, 151, 19133, 13, 1253, 251, 26);
INSERT INTO public.who_global_data VALUES (59426, 9268, 405843, 138, 4693, 251, 170);
INSERT INTO public.who_global_data VALUES (59427, 4, 359, 1, 1, 251, 191);
INSERT INTO public.who_global_data VALUES (59428, 0, 3, 0, 0, 251, 221);
INSERT INTO public.who_global_data VALUES (59429, 0, 6, 0, 0, 251, 64);
INSERT INTO public.who_global_data VALUES (59430, 0, 0, 0, 0, 251, 116);
INSERT INTO public.who_global_data VALUES (59431, 0, 15, 0, 0, 251, 128);
INSERT INTO public.who_global_data VALUES (59432, 0, 18, 0, 0, 251, 6);
INSERT INTO public.who_global_data VALUES (59433, 1, 41, 0, 3, 251, 227);
INSERT INTO public.who_global_data VALUES (59434, 0, 1, 0, 0, 251, 68);
INSERT INTO public.who_global_data VALUES (59435, 0, 25, 0, 0, 251, 184);
INSERT INTO public.who_global_data VALUES (59436, 0, 0, 0, 0, 251, 82);
INSERT INTO public.who_global_data VALUES (59437, 0, 687, 0, 42, 251, 149);
INSERT INTO public.who_global_data VALUES (59438, 0, 295, 0, 10, 251, 197);
INSERT INTO public.who_global_data VALUES (59439, 1618, 83384, 22, 480, 251, 78);
INSERT INTO public.who_global_data VALUES (59440, 106, 3535, 1, 42, 251, 233);
INSERT INTO public.who_global_data VALUES (59441, 27, 11381, 0, 242, 251, 133);
INSERT INTO public.who_global_data VALUES (59442, 0, 11, 0, 0, 251, 35);
INSERT INTO public.who_global_data VALUES (59443, 23, 852, 1, 46, 251, 114);
INSERT INTO public.who_global_data VALUES (59444, 506, 34366, 0, 23, 251, 237);
INSERT INTO public.who_global_data VALUES (59445, 0, 2, 0, 0, 251, 55);
INSERT INTO public.who_global_data VALUES (59446, 0, 78, 0, 15, 251, 176);
INSERT INTO public.who_global_data VALUES (59447, 1, 1521, 0, 28, 251, 202);
INSERT INTO public.who_global_data VALUES (59448, 0, 1473, 0, 113, 251, 155);
INSERT INTO public.who_global_data VALUES (59449, 0, 0, 0, 0, 251, 32);
INSERT INTO public.who_global_data VALUES (59450, 88, 1916, 1, 73, 251, 220);
INSERT INTO public.who_global_data VALUES (59451, 1727, 30967, 32, 643, 251, 30);
INSERT INTO public.who_global_data VALUES (59452, 0, 994, 0, 10, 251, 147);
INSERT INTO public.who_global_data VALUES (59453, 801, 246739, 43, 29079, 251, 208);
INSERT INTO public.who_global_data VALUES (59454, 64, 1630, 0, 10, 251, 45);
INSERT INTO public.who_global_data VALUES (59455, 279, 4800, 29, 262, 251, 110);
INSERT INTO public.who_global_data VALUES (59456, 0, 12, 0, 1, 251, 88);
INSERT INTO public.who_global_data VALUES (59457, 773, 37961, 40, 4577, 251, 51);
INSERT INTO public.who_global_data VALUES (59458, 10, 30835, 0, 1714, 251, 209);
INSERT INTO public.who_global_data VALUES (59459, 0, 122, 0, 4, 251, 205);
INSERT INTO public.who_global_data VALUES (59460, 121, 3807, 0, 47, 251, 18);
INSERT INTO public.who_global_data VALUES (59461, 4, 3081, 0, 57, 251, 72);
INSERT INTO public.who_global_data VALUES (59462, 1527, 254394, 154, 37385, 251, 44);
INSERT INTO public.who_global_data VALUES (59463, 0, 24, 0, 0, 251, 15);
INSERT INTO public.who_global_data VALUES (59464, 0, 428, 0, 13, 251, 25);
INSERT INTO public.who_global_data VALUES (59465, 0, 0, 0, 0, 251, 179);
INSERT INTO public.who_global_data VALUES (59466, 0, 0, 0, 0, 251, 34);
INSERT INTO public.who_global_data VALUES (59467, 0, 116, 0, 8, 251, 207);
INSERT INTO public.who_global_data VALUES (59468, 1, 1077, 0, 48, 251, 166);
INSERT INTO public.who_global_data VALUES (59469, 983, 163103, 26, 4515, 251, 126);
INSERT INTO public.who_global_data VALUES (59470, 0, 0, 0, 0, 251, 97);
INSERT INTO public.who_global_data VALUES (59471, 0, 12, 0, 1, 251, 36);
INSERT INTO public.who_global_data VALUES (59472, 0, 0, 0, 0, 251, 125);
INSERT INTO public.who_global_data VALUES (59473, 36, 446, 0, 0, 251, 124);
INSERT INTO public.who_global_data VALUES (59474, 468, 23672, 12, 708, 251, 185);
INSERT INTO public.who_global_data VALUES (59475, 726, 33896, 2, 262, 251, 194);
INSERT INTO public.who_global_data VALUES (59476, 0, 509, 0, 21, 251, 144);
INSERT INTO public.who_global_data VALUES (59477, 17962, 1734040, 1073, 102640, 251, 19);
INSERT INTO public.who_global_data VALUES (59478, 0, 69, 0, 6, 251, 217);
INSERT INTO public.who_global_data VALUES (59479, 5, 816, 0, 22, 251, 148);
INSERT INTO public.who_global_data VALUES (59480, 41, 3554, 0, 14, 251, 86);
INSERT INTO public.who_global_data VALUES (59481, 0, 0, 0, 0, 251, 13);
INSERT INTO public.who_global_data VALUES (59482, 43, 1370, 3, 14, 251, 157);
INSERT INTO public.who_global_data VALUES (59483, 1, 328, 0, 0, 251, 8);
INSERT INTO public.who_global_data VALUES (59484, 0, 0, 0, 0, 251, 73);
INSERT INTO public.who_global_data VALUES (59485, 27, 310, 12, 77, 251, 101);
INSERT INTO public.who_global_data VALUES (59486, 0, 1057, 0, 7, 251, 165);
INSERT INTO public.who_global_data VALUES (59487, 25, 174, 0, 4, 251, 14);
INSERT INTO public.who_global_data VALUES (59488, 784, 14529, 2, 252, 252, 193);
INSERT INTO public.who_global_data VALUES (59489, 23, 1084, 0, 32, 252, 113);
INSERT INTO public.who_global_data VALUES (59490, 137, 9134, 8, 638, 252, 143);
INSERT INTO public.who_global_data VALUES (59491, 0, 0, 0, 0, 252, 219);
INSERT INTO public.who_global_data VALUES (59492, 0, 764, 0, 51, 252, 186);
INSERT INTO public.who_global_data VALUES (59493, 8, 81, 0, 4, 252, 52);
INSERT INTO public.who_global_data VALUES (59494, 0, 3, 0, 0, 252, 180);
INSERT INTO public.who_global_data VALUES (59495, 0, 25, 0, 3, 252, 167);
INSERT INTO public.who_global_data VALUES (59496, 769, 14702, 9, 510, 252, 154);
INSERT INTO public.who_global_data VALUES (59497, 460, 8652, 7, 120, 252, 94);
INSERT INTO public.who_global_data VALUES (59498, 0, 101, 0, 3, 252, 66);
INSERT INTO public.who_global_data VALUES (59499, 23, 7173, 0, 103, 252, 58);
INSERT INTO public.who_global_data VALUES (59500, 51, 16594, 0, 668, 252, 163);
INSERT INTO public.who_global_data VALUES (59501, 230, 4989, 2, 58, 252, 37);
INSERT INTO public.who_global_data VALUES (59502, 1, 101, 0, 11, 252, 142);
INSERT INTO public.who_global_data VALUES (59503, 397, 10449, 0, 15, 252, 83);
INSERT INTO public.who_global_data VALUES (59504, 1764, 44608, 28, 610, 252, 228);
INSERT INTO public.who_global_data VALUES (59505, 0, 92, 0, 7, 252, 188);
INSERT INTO public.who_global_data VALUES (59506, 906, 40764, 5, 224, 252, 62);
INSERT INTO public.who_global_data VALUES (59507, 165, 58954, 16, 9320, 252, 160);
INSERT INTO public.who_global_data VALUES (59508, 0, 18, 0, 2, 252, 50);
INSERT INTO public.who_global_data VALUES (59509, 0, 218, 0, 3, 252, 33);
INSERT INTO public.who_global_data VALUES (59510, 1, 140, 0, 9, 252, 183);
INSERT INTO public.who_global_data VALUES (59511, 2, 33, 0, 0, 252, 92);
INSERT INTO public.who_global_data VALUES (59512, 619, 8387, 13, 293, 252, 158);
INSERT INTO public.who_global_data VALUES (59513, 0, 2, 0, 0, 252, 67);
INSERT INTO public.who_global_data VALUES (59514, 22, 2484, 0, 152, 252, 57);
INSERT INTO public.who_global_data VALUES (59515, 0, 35, 0, 1, 252, 38);
INSERT INTO public.who_global_data VALUES (59516, 26417, 438238, 1156, 26754, 252, 141);
INSERT INTO public.who_global_data VALUES (59517, 0, 8, 0, 1, 252, 178);
INSERT INTO public.who_global_data VALUES (59518, 0, 141, 0, 2, 252, 108);
INSERT INTO public.who_global_data VALUES (59519, 14, 2499, 3, 139, 252, 39);
INSERT INTO public.who_global_data VALUES (59520, 0, 847, 0, 53, 252, 2);
INSERT INTO public.who_global_data VALUES (59521, 0, 42, 0, 1, 252, 195);
INSERT INTO public.who_global_data VALUES (59522, 15, 405, 0, 4, 252, 107);
INSERT INTO public.who_global_data VALUES (59523, 1, 125, 0, 0, 252, 161);
INSERT INTO public.who_global_data VALUES (59524, 0, 5436, 0, 177, 252, 212);
INSERT INTO public.who_global_data VALUES (59525, 954, 88856, 119, 6918, 252, 181);
INSERT INTO public.who_global_data VALUES (59526, 0, 140, 0, 1, 252, 53);
INSERT INTO public.who_global_data VALUES (59527, 119, 874, 0, 1, 252, 164);
INSERT INTO public.who_global_data VALUES (59528, 33, 759, 0, 65, 252, 140);
INSERT INTO public.who_global_data VALUES (59529, 3695, 90638, 54, 944, 252, 20);
INSERT INTO public.who_global_data VALUES (59530, 18, 84565, 0, 4645, 252, 112);
INSERT INTO public.who_global_data VALUES (59531, 1262, 25366, 19, 822, 252, 111);
INSERT INTO public.who_global_data VALUES (59532, 0, 43, 0, 2, 252, 71);
INSERT INTO public.who_global_data VALUES (59533, 16, 587, 0, 19, 252, 218);
INSERT INTO public.who_global_data VALUES (59534, 0, 0, 0, 0, 252, 43);
INSERT INTO public.who_global_data VALUES (59535, 16, 1000, 0, 10, 252, 49);
INSERT INTO public.who_global_data VALUES (59536, 109, 2750, 0, 32, 252, 1);
INSERT INTO public.who_global_data VALUES (59537, 0, 2245, 1, 103, 252, 48);
INSERT INTO public.who_global_data VALUES (59538, 22, 2005, 0, 82, 252, 232);
INSERT INTO public.who_global_data VALUES (59539, 0, 20, 0, 1, 252, 175);
INSERT INTO public.who_global_data VALUES (59540, 0, 941, 0, 17, 252, 21);
INSERT INTO public.who_global_data VALUES (59541, 56, 9196, 0, 319, 252, 156);
INSERT INTO public.who_global_data VALUES (59542, 0, 0, 0, 0, 252, 95);
INSERT INTO public.who_global_data VALUES (59543, 0, 2832, 0, 68, 252, 177);
INSERT INTO public.who_global_data VALUES (59544, 81, 11593, 0, 568, 252, 210);
INSERT INTO public.who_global_data VALUES (59545, 0, 2914, 0, 20, 252, 120);
INSERT INTO public.who_global_data VALUES (59546, 0, 16, 0, 0, 252, 135);
INSERT INTO public.who_global_data VALUES (59547, 463, 16531, 3, 488, 252, 206);
INSERT INTO public.who_global_data VALUES (59548, 100, 38571, 21, 3334, 252, 189);
INSERT INTO public.who_global_data VALUES (59549, 1289, 22082, 34, 879, 252, 129);
INSERT INTO public.who_global_data VALUES (59550, 84, 2278, 3, 42, 252, 121);
INSERT INTO public.who_global_data VALUES (59551, 0, 1043, 0, 12, 252, 59);
INSERT INTO public.who_global_data VALUES (59552, 0, 39, 0, 0, 252, 96);
INSERT INTO public.who_global_data VALUES (59553, 8, 1859, 0, 63, 252, 41);
INSERT INTO public.who_global_data VALUES (59554, 0, 279, 0, 2, 252, 216);
INSERT INTO public.who_global_data VALUES (59555, 137, 968, 1, 8, 252, 236);
INSERT INTO public.who_global_data VALUES (59556, 0, 13, 0, 0, 252, 150);
INSERT INTO public.who_global_data VALUES (59557, 0, 187, 0, 0, 252, 61);
INSERT INTO public.who_global_data VALUES (59558, 0, 18, 0, 0, 252, 7);
INSERT INTO public.who_global_data VALUES (59559, 33, 6776, 1, 314, 252, 169);
INSERT INTO public.who_global_data VALUES (59560, 535, 146657, 52, 28660, 252, 28);
INSERT INTO public.who_global_data VALUES (59561, 27, 436, 0, 1, 252, 85);
INSERT INTO public.who_global_data VALUES (59562, 0, 60, 0, 0, 252, 211);
INSERT INTO public.who_global_data VALUES (59563, 182, 2613, 1, 15, 252, 60);
INSERT INTO public.who_global_data VALUES (59564, 0, 25, 0, 1, 252, 3);
INSERT INTO public.who_global_data VALUES (59565, 11, 757, 0, 12, 252, 11);
INSERT INTO public.who_global_data VALUES (59566, 738, 181196, 39, 8489, 252, 89);
INSERT INTO public.who_global_data VALUES (59567, 313, 7616, 0, 34, 252, 24);
INSERT INTO public.who_global_data VALUES (59568, 1, 158, 0, 0, 252, 162);
INSERT INTO public.who_global_data VALUES (59569, 3, 2909, 0, 175, 252, 100);
INSERT INTO public.who_global_data VALUES (59570, 0, 13, 0, 0, 252, 47);
INSERT INTO public.who_global_data VALUES (59571, 0, 23, 0, 0, 252, 29);
INSERT INTO public.who_global_data VALUES (59572, 1, 162, 0, 14, 252, 40);
INSERT INTO public.who_global_data VALUES (59573, 0, 165, 0, 5, 252, 222);
INSERT INTO public.who_global_data VALUES (59574, 203, 4348, 12, 80, 252, 132);
INSERT INTO public.who_global_data VALUES (59575, 0, 252, 0, 13, 252, 130);
INSERT INTO public.who_global_data VALUES (59576, 103, 3656, 0, 22, 252, 234);
INSERT INTO public.who_global_data VALUES (59577, 61, 1256, 0, 8, 252, 23);
INSERT INTO public.who_global_data VALUES (59578, 11, 150, 0, 11, 252, 192);
INSERT INTO public.who_global_data VALUES (59579, 123, 1443, 1, 35, 252, 69);
INSERT INTO public.who_global_data VALUES (59580, 0, 12, 0, 0, 252, 187);
INSERT INTO public.who_global_data VALUES (59581, 112, 4752, 2, 196, 252, 230);
INSERT INTO public.who_global_data VALUES (59582, 0, 3841, 0, 517, 252, 77);
INSERT INTO public.who_global_data VALUES (59583, 0, 1805, 0, 10, 252, 9);
INSERT INTO public.who_global_data VALUES (59584, 7964, 173763, 265, 4971, 252, 74);
INSERT INTO public.who_global_data VALUES (59585, 557, 25773, 53, 1573, 252, 224);
INSERT INTO public.who_global_data VALUES (59586, 2819, 146668, 50, 7677, 252, 199);
INSERT INTO public.who_global_data VALUES (59587, 416, 5873, 6, 185, 252, 190);
INSERT INTO public.who_global_data VALUES (59588, 35, 24876, 6, 1645, 252, 12);
INSERT INTO public.who_global_data VALUES (59589, 0, 336, 0, 24, 252, 104);
INSERT INTO public.who_global_data VALUES (59590, 77, 16856, 1, 287, 252, 153);
INSERT INTO public.who_global_data VALUES (59591, 516, 232248, 87, 33229, 252, 91);
INSERT INTO public.who_global_data VALUES (59592, 0, 569, 0, 9, 252, 215);
INSERT INTO public.who_global_data VALUES (59593, 85, 16804, 12, 886, 252, 84);
INSERT INTO public.who_global_data VALUES (59594, 0, 308, 0, 29, 252, 231);
INSERT INTO public.who_global_data VALUES (59595, 1, 726, 0, 9, 252, 196);
INSERT INTO public.who_global_data VALUES (59596, 476, 10858, 1, 38, 252, 105);
INSERT INTO public.who_global_data VALUES (59597, 127, 1745, 4, 62, 252, 122);
INSERT INTO public.who_global_data VALUES (59598, 0, 0, 0, 0, 252, 159);
INSERT INTO public.who_global_data VALUES (59599, 0, 1048, 0, 21, 252, 75);
INSERT INTO public.who_global_data VALUES (59600, 1072, 25184, 9, 194, 252, 27);
INSERT INTO public.who_global_data VALUES (59601, 60, 1722, 0, 16, 252, 54);
INSERT INTO public.who_global_data VALUES (59602, 0, 19, 0, 0, 252, 226);
INSERT INTO public.who_global_data VALUES (59603, 3, 1064, 0, 24, 252, 79);
INSERT INTO public.who_global_data VALUES (59604, 4, 1172, 0, 26, 252, 56);
INSERT INTO public.who_global_data VALUES (59605, 0, 2, 0, 0, 252, 117);
INSERT INTO public.who_global_data VALUES (59606, 4, 273, 0, 27, 252, 152);
INSERT INTO public.who_global_data VALUES (59607, 13, 118, 0, 5, 252, 16);
INSERT INTO public.who_global_data VALUES (59608, 0, 83, 0, 1, 252, 10);
INSERT INTO public.who_global_data VALUES (59609, 8, 1662, 2, 70, 252, 201);
INSERT INTO public.who_global_data VALUES (59610, 4, 4012, 0, 110, 252, 174);
INSERT INTO public.who_global_data VALUES (59611, 42, 698, 3, 5, 252, 119);
INSERT INTO public.who_global_data VALUES (59612, 70, 273, 0, 4, 252, 168);
INSERT INTO public.who_global_data VALUES (59613, 103, 7732, 0, 115, 252, 99);
INSERT INTO public.who_global_data VALUES (59614, 120, 1633, 0, 5, 252, 171);
INSERT INTO public.who_global_data VALUES (59615, 32, 1226, 1, 73, 252, 87);
INSERT INTO public.who_global_data VALUES (59616, 2, 617, 2, 9, 252, 123);
INSERT INTO public.who_global_data VALUES (59617, 0, 0, 0, 0, 252, 151);
INSERT INTO public.who_global_data VALUES (59618, 0, 197, 0, 14, 252, 213);
INSERT INTO public.who_global_data VALUES (59619, 77, 423, 1, 20, 252, 118);
INSERT INTO public.who_global_data VALUES (59620, 1, 335, 0, 10, 252, 134);
INSERT INTO public.who_global_data VALUES (59621, 29, 1699, 0, 21, 252, 65);
INSERT INTO public.who_global_data VALUES (59622, 3377, 81400, 447, 9044, 252, 102);
INSERT INTO public.who_global_data VALUES (59623, 0, 0, 0, 0, 252, 223);
INSERT INTO public.who_global_data VALUES (59624, 0, 70, 0, 1, 252, 4);
INSERT INTO public.who_global_data VALUES (59625, 0, 179, 0, 0, 252, 146);
INSERT INTO public.who_global_data VALUES (59626, 0, 324, 0, 9, 252, 31);
INSERT INTO public.who_global_data VALUES (59627, 0, 11, 0, 1, 252, 127);
INSERT INTO public.who_global_data VALUES (59628, 71, 7714, 0, 202, 252, 22);
INSERT INTO public.who_global_data VALUES (59629, 1, 234, 0, 2, 252, 115);
INSERT INTO public.who_global_data VALUES (59630, 18, 224, 0, 6, 252, 106);
INSERT INTO public.who_global_data VALUES (59631, 1, 23, 0, 0, 252, 90);
INSERT INTO public.who_global_data VALUES (59632, 0, 0, 0, 0, 252, 70);
INSERT INTO public.who_global_data VALUES (59633, 189, 1401, 0, 6, 252, 46);
INSERT INTO public.who_global_data VALUES (59634, 178, 45889, 29, 5899, 252, 139);
INSERT INTO public.who_global_data VALUES (59635, 0, 19, 0, 0, 252, 42);
INSERT INTO public.who_global_data VALUES (59636, 0, 1154, 0, 22, 252, 80);
INSERT INTO public.who_global_data VALUES (59637, 0, 885, 0, 35, 252, 203);
INSERT INTO public.who_global_data VALUES (59638, 0, 955, 0, 64, 252, 136);
INSERT INTO public.who_global_data VALUES (59639, 387, 9302, 2, 261, 252, 63);
INSERT INTO public.who_global_data VALUES (59640, 0, 0, 0, 0, 252, 17);
INSERT INTO public.who_global_data VALUES (59641, 0, 22, 0, 2, 252, 172);
INSERT INTO public.who_global_data VALUES (59642, 52, 2130, 4, 126, 252, 109);
INSERT INTO public.who_global_data VALUES (59643, 10, 8411, 0, 236, 252, 200);
INSERT INTO public.who_global_data VALUES (59644, 0, 625, 0, 5, 252, 93);
INSERT INTO public.who_global_data VALUES (59645, 811, 9820, 1, 41, 252, 5);
INSERT INTO public.who_global_data VALUES (59646, 0, 741, 0, 13, 252, 214);
INSERT INTO public.who_global_data VALUES (59647, 2429, 66457, 78, 1395, 252, 204);
INSERT INTO public.who_global_data VALUES (59648, 0, 0, 0, 0, 252, 198);
INSERT INTO public.who_global_data VALUES (59649, 403, 12131, 5, 320, 252, 173);
INSERT INTO public.who_global_data VALUES (59650, 0, 8, 0, 0, 252, 229);
INSERT INTO public.who_global_data VALUES (59651, 17, 917, 0, 11, 252, 76);
INSERT INTO public.who_global_data VALUES (59652, 5874, 141779, 116, 4099, 252, 138);
INSERT INTO public.who_global_data VALUES (59653, 1046, 16634, 21, 942, 252, 98);
INSERT INTO public.who_global_data VALUES (59654, 0, 0, 0, 0, 252, 103);
INSERT INTO public.who_global_data VALUES (59655, 330, 23155, 13, 1051, 252, 225);
INSERT INTO public.who_global_data VALUES (59656, 350, 31946, 14, 1383, 252, 131);
INSERT INTO public.who_global_data VALUES (59657, 161, 3647, 1, 132, 252, 235);
INSERT INTO public.who_global_data VALUES (59658, 1993, 52907, 3, 36, 252, 137);
INSERT INTO public.who_global_data VALUES (59659, 39, 11441, 0, 269, 252, 81);
INSERT INTO public.who_global_data VALUES (59660, 171, 7896, 7, 289, 252, 182);
INSERT INTO public.who_global_data VALUES (59661, 5, 470, 0, 1, 252, 145);
INSERT INTO public.who_global_data VALUES (59662, 191, 18982, 11, 1240, 252, 26);
INSERT INTO public.who_global_data VALUES (59663, 8952, 396575, 181, 4555, 252, 170);
INSERT INTO public.who_global_data VALUES (59664, 6, 355, 0, 0, 252, 191);
INSERT INTO public.who_global_data VALUES (59665, 0, 3, 0, 0, 252, 221);
INSERT INTO public.who_global_data VALUES (59666, 0, 6, 0, 0, 252, 64);
INSERT INTO public.who_global_data VALUES (59667, 0, 0, 0, 0, 252, 116);
INSERT INTO public.who_global_data VALUES (59668, 0, 15, 0, 0, 252, 128);
INSERT INTO public.who_global_data VALUES (59669, 0, 18, 0, 0, 252, 6);
INSERT INTO public.who_global_data VALUES (59670, 0, 40, 0, 3, 252, 227);
INSERT INTO public.who_global_data VALUES (59671, 0, 1, 0, 0, 252, 68);
INSERT INTO public.who_global_data VALUES (59672, 0, 25, 0, 0, 252, 184);
INSERT INTO public.who_global_data VALUES (59673, 0, 0, 0, 0, 252, 82);
INSERT INTO public.who_global_data VALUES (59674, 0, 687, 0, 42, 252, 149);
INSERT INTO public.who_global_data VALUES (59675, 0, 295, 0, 10, 252, 197);
INSERT INTO public.who_global_data VALUES (59676, 1581, 81766, 17, 458, 252, 78);
INSERT INTO public.who_global_data VALUES (59677, 81, 3429, 0, 41, 252, 233);
INSERT INTO public.who_global_data VALUES (59678, 54, 11354, 1, 242, 252, 133);
INSERT INTO public.who_global_data VALUES (59679, 0, 11, 0, 0, 252, 35);
INSERT INTO public.who_global_data VALUES (59680, 17, 829, 0, 45, 252, 114);
INSERT INTO public.who_global_data VALUES (59681, 611, 33860, 0, 23, 252, 237);
INSERT INTO public.who_global_data VALUES (59682, 0, 2, 0, 0, 252, 55);
INSERT INTO public.who_global_data VALUES (59683, 0, 78, 0, 15, 252, 176);
INSERT INTO public.who_global_data VALUES (59684, 0, 1520, 0, 28, 252, 202);
INSERT INTO public.who_global_data VALUES (59685, 0, 1473, 0, 113, 252, 155);
INSERT INTO public.who_global_data VALUES (59686, 0, 0, 0, 0, 252, 32);
INSERT INTO public.who_global_data VALUES (59687, 0, 1828, 0, 72, 252, 220);
INSERT INTO public.who_global_data VALUES (59688, 1837, 29240, 34, 611, 252, 30);
INSERT INTO public.who_global_data VALUES (59689, 0, 994, 0, 10, 252, 147);
INSERT INTO public.who_global_data VALUES (59690, 746, 245938, 40, 29036, 252, 208);
INSERT INTO public.who_global_data VALUES (59691, 26, 1566, 0, 10, 252, 45);
INSERT INTO public.who_global_data VALUES (59692, 175, 4521, 38, 233, 252, 110);
INSERT INTO public.who_global_data VALUES (59693, 0, 12, 0, 1, 252, 88);
INSERT INTO public.who_global_data VALUES (59694, 774, 37188, 40, 4537, 252, 51);
INSERT INTO public.who_global_data VALUES (59695, 21, 30825, 0, 1714, 252, 209);
INSERT INTO public.who_global_data VALUES (59696, 0, 122, 0, 4, 252, 205);
INSERT INTO public.who_global_data VALUES (59697, 123, 3686, 0, 47, 252, 18);
INSERT INTO public.who_global_data VALUES (59698, 1, 3077, 0, 57, 252, 72);
INSERT INTO public.who_global_data VALUES (59699, 1760, 252867, 274, 37231, 252, 44);
INSERT INTO public.who_global_data VALUES (59700, 0, 24, 0, 0, 252, 15);
INSERT INTO public.who_global_data VALUES (59701, 6, 428, 0, 13, 252, 25);
INSERT INTO public.who_global_data VALUES (59702, 0, 0, 0, 0, 252, 179);
INSERT INTO public.who_global_data VALUES (59703, 0, 0, 0, 0, 252, 34);
INSERT INTO public.who_global_data VALUES (59704, 0, 116, 0, 8, 252, 207);
INSERT INTO public.who_global_data VALUES (59705, 5, 1076, 0, 48, 252, 166);
INSERT INTO public.who_global_data VALUES (59706, 1141, 162120, 28, 4489, 252, 126);
INSERT INTO public.who_global_data VALUES (59707, 0, 0, 0, 0, 252, 97);
INSERT INTO public.who_global_data VALUES (59708, 0, 12, 0, 1, 252, 36);
INSERT INTO public.who_global_data VALUES (59709, 0, 0, 0, 0, 252, 125);
INSERT INTO public.who_global_data VALUES (59710, 0, 410, 0, 0, 252, 124);
INSERT INTO public.who_global_data VALUES (59711, 393, 23204, 17, 696, 252, 185);
INSERT INTO public.who_global_data VALUES (59712, 638, 33170, 2, 260, 252, 194);
INSERT INTO public.who_global_data VALUES (59713, 0, 509, 0, 21, 252, 144);
INSERT INTO public.who_global_data VALUES (59714, 21214, 1716078, 1263, 101567, 252, 19);
INSERT INTO public.who_global_data VALUES (59715, 0, 69, 0, 6, 252, 217);
INSERT INTO public.who_global_data VALUES (59716, 8, 811, 0, 22, 252, 148);
INSERT INTO public.who_global_data VALUES (59717, 50, 3513, 0, 14, 252, 86);
INSERT INTO public.who_global_data VALUES (59718, 0, 0, 0, 0, 252, 13);
INSERT INTO public.who_global_data VALUES (59719, 82, 1327, 0, 11, 252, 157);
INSERT INTO public.who_global_data VALUES (59720, 0, 327, 0, 0, 252, 8);
INSERT INTO public.who_global_data VALUES (59721, 0, 0, 0, 0, 252, 73);
INSERT INTO public.who_global_data VALUES (59722, 5, 283, 8, 65, 252, 101);
INSERT INTO public.who_global_data VALUES (59723, 0, 1057, 0, 7, 252, 165);
INSERT INTO public.who_global_data VALUES (59724, 17, 149, 0, 4, 252, 14);
INSERT INTO public.who_global_data VALUES (59725, 643, 13745, 11, 250, 253, 193);
INSERT INTO public.who_global_data VALUES (59726, 23, 1061, 0, 32, 253, 113);
INSERT INTO public.who_global_data VALUES (59727, 140, 8997, 7, 630, 253, 143);
INSERT INTO public.who_global_data VALUES (59728, 0, 0, 0, 0, 253, 219);
INSERT INTO public.who_global_data VALUES (59729, 1, 764, 0, 51, 253, 186);
INSERT INTO public.who_global_data VALUES (59730, 2, 73, 0, 4, 253, 52);
INSERT INTO public.who_global_data VALUES (59731, 0, 3, 0, 0, 253, 180);
INSERT INTO public.who_global_data VALUES (59732, 0, 25, 0, 3, 253, 167);
INSERT INTO public.who_global_data VALUES (59733, 705, 13933, 9, 501, 253, 154);
INSERT INTO public.who_global_data VALUES (59734, 442, 8192, 15, 113, 253, 94);
INSERT INTO public.who_global_data VALUES (59735, 0, 101, 0, 3, 253, 66);
INSERT INTO public.who_global_data VALUES (59736, 11, 7150, 0, 103, 253, 58);
INSERT INTO public.who_global_data VALUES (59737, 28, 16543, 23, 668, 253, 163);
INSERT INTO public.who_global_data VALUES (59738, 191, 4759, 2, 56, 253, 37);
INSERT INTO public.who_global_data VALUES (59739, 0, 100, 0, 11, 253, 142);
INSERT INTO public.who_global_data VALUES (59740, 360, 10052, 0, 15, 253, 83);
INSERT INTO public.who_global_data VALUES (59741, 2523, 42844, 23, 582, 253, 228);
INSERT INTO public.who_global_data VALUES (59742, 0, 92, 0, 7, 253, 188);
INSERT INTO public.who_global_data VALUES (59743, 902, 39858, 5, 219, 253, 62);
INSERT INTO public.who_global_data VALUES (59744, 171, 58789, 26, 9304, 253, 160);
INSERT INTO public.who_global_data VALUES (59745, 0, 18, 0, 2, 253, 50);
INSERT INTO public.who_global_data VALUES (59746, 8, 218, 0, 3, 253, 33);
INSERT INTO public.who_global_data VALUES (59747, 0, 139, 0, 9, 253, 183);
INSERT INTO public.who_global_data VALUES (59748, 3, 31, 0, 0, 253, 92);
INSERT INTO public.who_global_data VALUES (59749, 632, 7768, 6, 280, 253, 158);
INSERT INTO public.who_global_data VALUES (59750, 0, 2, 0, 0, 253, 67);
INSERT INTO public.who_global_data VALUES (59751, 47, 2462, 3, 152, 253, 57);
INSERT INTO public.who_global_data VALUES (59752, 0, 35, 0, 1, 253, 38);
INSERT INTO public.who_global_data VALUES (59753, 20599, 411821, 1086, 25598, 253, 141);
INSERT INTO public.who_global_data VALUES (59754, 0, 8, 0, 1, 253, 178);
INSERT INTO public.who_global_data VALUES (59755, 0, 141, 0, 2, 253, 108);
INSERT INTO public.who_global_data VALUES (59756, 25, 2485, 3, 136, 253, 39);
INSERT INTO public.who_global_data VALUES (59757, 2, 847, 0, 53, 253, 2);
INSERT INTO public.who_global_data VALUES (59758, 0, 42, 0, 1, 253, 195);
INSERT INTO public.who_global_data VALUES (59759, 0, 390, 0, 4, 253, 107);
INSERT INTO public.who_global_data VALUES (59760, 0, 124, 0, 0, 253, 161);
INSERT INTO public.who_global_data VALUES (59761, 0, 5436, 0, 177, 253, 212);
INSERT INTO public.who_global_data VALUES (59762, 963, 87902, 128, 6799, 253, 181);
INSERT INTO public.who_global_data VALUES (59763, 3, 140, 0, 1, 253, 53);
INSERT INTO public.who_global_data VALUES (59764, 54, 755, 0, 1, 253, 164);
INSERT INTO public.who_global_data VALUES (59765, 11, 726, 1, 65, 253, 140);
INSERT INTO public.who_global_data VALUES (59766, 4654, 86943, 49, 890, 253, 20);
INSERT INTO public.who_global_data VALUES (59767, 0, 84547, 0, 4645, 253, 112);
INSERT INTO public.who_global_data VALUES (59768, 1101, 24104, 27, 803, 253, 111);
INSERT INTO public.who_global_data VALUES (59769, 0, 43, 0, 2, 253, 71);
INSERT INTO public.who_global_data VALUES (59770, 0, 571, 0, 19, 253, 218);
INSERT INTO public.who_global_data VALUES (59771, 0, 0, 0, 0, 253, 43);
INSERT INTO public.who_global_data VALUES (59772, 28, 984, 0, 10, 253, 49);
INSERT INTO public.who_global_data VALUES (59773, 85, 2641, 1, 32, 253, 1);
INSERT INTO public.who_global_data VALUES (59774, 1, 2245, 1, 102, 253, 48);
INSERT INTO public.who_global_data VALUES (59775, 9, 1983, 0, 82, 253, 232);
INSERT INTO public.who_global_data VALUES (59776, 2, 20, 0, 1, 253, 175);
INSERT INTO public.who_global_data VALUES (59777, 2, 941, 0, 17, 253, 21);
INSERT INTO public.who_global_data VALUES (59778, 54, 9140, 2, 319, 253, 156);
INSERT INTO public.who_global_data VALUES (59779, 0, 0, 0, 0, 253, 95);
INSERT INTO public.who_global_data VALUES (59780, 173, 2832, 0, 68, 253, 177);
INSERT INTO public.who_global_data VALUES (59781, 32, 11512, 3, 568, 253, 210);
INSERT INTO public.who_global_data VALUES (59782, 217, 2914, 2, 20, 253, 120);
INSERT INTO public.who_global_data VALUES (59783, 0, 16, 0, 0, 253, 135);
INSERT INTO public.who_global_data VALUES (59784, 345, 16068, 11, 485, 253, 206);
INSERT INTO public.who_global_data VALUES (59785, 368, 38471, 38, 3313, 253, 189);
INSERT INTO public.who_global_data VALUES (59786, 1127, 20793, 29, 845, 253, 129);
INSERT INTO public.who_global_data VALUES (59787, 85, 2194, 2, 39, 253, 121);
INSERT INTO public.who_global_data VALUES (59788, 0, 1043, 0, 12, 253, 59);
INSERT INTO public.who_global_data VALUES (59789, 0, 39, 0, 0, 253, 96);
INSERT INTO public.who_global_data VALUES (59790, 11, 1851, 0, 63, 253, 41);
INSERT INTO public.who_global_data VALUES (59791, 7, 279, 0, 2, 253, 216);
INSERT INTO public.who_global_data VALUES (59792, 100, 831, 1, 7, 253, 236);
INSERT INTO public.who_global_data VALUES (59793, 0, 13, 0, 0, 253, 150);
INSERT INTO public.who_global_data VALUES (59794, 0, 187, 0, 0, 253, 61);
INSERT INTO public.who_global_data VALUES (59795, 0, 18, 0, 0, 253, 7);
INSERT INTO public.who_global_data VALUES (59796, 51, 6743, 0, 313, 253, 169);
INSERT INTO public.who_global_data VALUES (59797, 3270, 146122, 65, 28608, 253, 28);
INSERT INTO public.who_global_data VALUES (59798, 25, 409, 0, 1, 253, 85);
INSERT INTO public.who_global_data VALUES (59799, 0, 60, 0, 0, 253, 211);
INSERT INTO public.who_global_data VALUES (59800, 112, 2431, 0, 14, 253, 60);
INSERT INTO public.who_global_data VALUES (59801, 0, 25, 0, 1, 253, 3);
INSERT INTO public.who_global_data VALUES (59802, 8, 746, 0, 12, 253, 11);
INSERT INTO public.who_global_data VALUES (59803, 741, 180458, 39, 8450, 253, 89);
INSERT INTO public.who_global_data VALUES (59804, 0, 7303, 0, 34, 253, 24);
INSERT INTO public.who_global_data VALUES (59805, 3, 157, 0, 0, 253, 162);
INSERT INTO public.who_global_data VALUES (59806, 3, 2906, 2, 175, 253, 100);
INSERT INTO public.who_global_data VALUES (59807, 1, 13, 0, 0, 253, 47);
INSERT INTO public.who_global_data VALUES (59808, 0, 23, 0, 0, 253, 29);
INSERT INTO public.who_global_data VALUES (59809, 0, 161, 0, 14, 253, 40);
INSERT INTO public.who_global_data VALUES (59810, 1, 165, 0, 5, 253, 222);
INSERT INTO public.who_global_data VALUES (59811, 191, 4145, 5, 68, 253, 132);
INSERT INTO public.who_global_data VALUES (59812, 0, 252, 0, 13, 253, 130);
INSERT INTO public.who_global_data VALUES (59813, 107, 3553, 1, 22, 253, 234);
INSERT INTO public.who_global_data VALUES (59814, 22, 1195, 2, 8, 253, 23);
INSERT INTO public.who_global_data VALUES (59815, 0, 139, 0, 11, 253, 192);
INSERT INTO public.who_global_data VALUES (59816, 146, 1320, 1, 34, 253, 69);
INSERT INTO public.who_global_data VALUES (59817, 0, 12, 0, 0, 253, 187);
INSERT INTO public.who_global_data VALUES (59818, 239, 4640, 6, 194, 253, 230);
INSERT INTO public.who_global_data VALUES (59819, 25, 3841, 8, 517, 253, 77);
INSERT INTO public.who_global_data VALUES (59820, 0, 1805, 0, 10, 253, 9);
INSERT INTO public.who_global_data VALUES (59821, 7466, 165799, 175, 4706, 253, 74);
INSERT INTO public.who_global_data VALUES (59822, 678, 25216, 24, 1520, 253, 224);
INSERT INTO public.who_global_data VALUES (59823, 2258, 143849, 63, 7627, 253, 199);
INSERT INTO public.who_global_data VALUES (59824, 322, 5457, 4, 179, 253, 190);
INSERT INTO public.who_global_data VALUES (59825, 38, 24841, 8, 1639, 253, 12);
INSERT INTO public.who_global_data VALUES (59826, 0, 336, 0, 24, 253, 104);
INSERT INTO public.who_global_data VALUES (59827, 40, 16779, 2, 286, 253, 153);
INSERT INTO public.who_global_data VALUES (59828, 593, 231732, 70, 33142, 253, 91);
INSERT INTO public.who_global_data VALUES (59829, 5, 569, 0, 9, 253, 215);
INSERT INTO public.who_global_data VALUES (59830, 36, 16719, 7, 874, 253, 84);
INSERT INTO public.who_global_data VALUES (59831, 1, 308, 0, 29, 253, 231);
INSERT INTO public.who_global_data VALUES (59832, 7, 725, 0, 9, 253, 196);
INSERT INTO public.who_global_data VALUES (59833, 450, 10382, 0, 37, 253, 105);
INSERT INTO public.who_global_data VALUES (59834, 147, 1618, 3, 58, 253, 122);
INSERT INTO public.who_global_data VALUES (59835, 0, 0, 0, 0, 253, 159);
INSERT INTO public.who_global_data VALUES (59836, 1, 1048, 0, 21, 253, 75);
INSERT INTO public.who_global_data VALUES (59837, 845, 24112, 10, 185, 253, 27);
INSERT INTO public.who_global_data VALUES (59838, 68, 1662, 0, 16, 253, 54);
INSERT INTO public.who_global_data VALUES (59839, 0, 19, 0, 0, 253, 226);
INSERT INTO public.who_global_data VALUES (59840, 4, 1061, 1, 24, 253, 79);
INSERT INTO public.who_global_data VALUES (59841, 7, 1168, 0, 26, 253, 56);
INSERT INTO public.who_global_data VALUES (59842, 0, 2, 0, 0, 253, 117);
INSERT INTO public.who_global_data VALUES (59843, 3, 269, 0, 27, 253, 152);
INSERT INTO public.who_global_data VALUES (59844, 6, 105, 1, 5, 253, 16);
INSERT INTO public.who_global_data VALUES (59845, 0, 83, 0, 1, 253, 10);
INSERT INTO public.who_global_data VALUES (59846, 5, 1654, 0, 68, 253, 201);
INSERT INTO public.who_global_data VALUES (59847, 7, 4008, 0, 110, 253, 174);
INSERT INTO public.who_global_data VALUES (59848, 44, 656, 0, 2, 253, 119);
INSERT INTO public.who_global_data VALUES (59849, 102, 203, 0, 4, 253, 168);
INSERT INTO public.who_global_data VALUES (59850, 10, 7629, 0, 115, 253, 99);
INSERT INTO public.who_global_data VALUES (59851, 56, 1513, 0, 5, 253, 171);
INSERT INTO public.who_global_data VALUES (59852, 78, 1194, 2, 72, 253, 87);
INSERT INTO public.who_global_data VALUES (59853, 0, 615, 0, 7, 253, 123);
INSERT INTO public.who_global_data VALUES (59854, 0, 0, 0, 0, 253, 151);
INSERT INTO public.who_global_data VALUES (59855, 0, 197, 0, 14, 253, 213);
INSERT INTO public.who_global_data VALUES (59856, 54, 346, 3, 19, 253, 118);
INSERT INTO public.who_global_data VALUES (59857, 0, 334, 0, 10, 253, 134);
INSERT INTO public.who_global_data VALUES (59858, 25, 1670, 1, 21, 253, 65);
INSERT INTO public.who_global_data VALUES (59859, 3463, 78023, 463, 8597, 253, 102);
INSERT INTO public.who_global_data VALUES (59860, 0, 0, 0, 0, 253, 223);
INSERT INTO public.who_global_data VALUES (59861, 0, 70, 0, 1, 253, 4);
INSERT INTO public.who_global_data VALUES (59862, 18, 179, 0, 0, 253, 146);
INSERT INTO public.who_global_data VALUES (59863, 0, 324, 0, 9, 253, 31);
INSERT INTO public.who_global_data VALUES (59864, 0, 11, 0, 1, 253, 127);
INSERT INTO public.who_global_data VALUES (59865, 42, 7643, 0, 202, 253, 22);
INSERT INTO public.who_global_data VALUES (59866, 6, 233, 1, 2, 253, 115);
INSERT INTO public.who_global_data VALUES (59867, 0, 206, 0, 6, 253, 106);
INSERT INTO public.who_global_data VALUES (59868, 0, 22, 0, 0, 253, 90);
INSERT INTO public.who_global_data VALUES (59869, 0, 0, 0, 0, 253, 70);
INSERT INTO public.who_global_data VALUES (59870, 170, 1212, 1, 6, 253, 46);
INSERT INTO public.who_global_data VALUES (59871, 179, 45711, 27, 5870, 253, 139);
INSERT INTO public.who_global_data VALUES (59872, 1, 19, 0, 0, 253, 42);
INSERT INTO public.who_global_data VALUES (59873, 0, 1154, 0, 22, 253, 80);
INSERT INTO public.who_global_data VALUES (59874, 126, 885, 0, 35, 253, 203);
INSERT INTO public.who_global_data VALUES (59875, 0, 955, 0, 64, 253, 136);
INSERT INTO public.who_global_data VALUES (59876, 182, 8915, 5, 259, 253, 63);
INSERT INTO public.who_global_data VALUES (59877, 0, 0, 0, 0, 253, 17);
INSERT INTO public.who_global_data VALUES (59878, 0, 22, 0, 2, 253, 172);
INSERT INTO public.who_global_data VALUES (59879, 38, 2078, 3, 122, 253, 109);
INSERT INTO public.who_global_data VALUES (59880, 18, 8401, 1, 236, 253, 200);
INSERT INTO public.who_global_data VALUES (59881, 12, 625, 0, 5, 253, 93);
INSERT INTO public.who_global_data VALUES (59882, 636, 9009, 1, 40, 253, 5);
INSERT INTO public.who_global_data VALUES (59883, 0, 741, 0, 13, 253, 214);
INSERT INTO public.who_global_data VALUES (59884, 2801, 64028, 57, 1317, 253, 204);
INSERT INTO public.who_global_data VALUES (59885, 0, 0, 0, 0, 253, 198);
INSERT INTO public.who_global_data VALUES (59886, 281, 11728, 2, 315, 253, 173);
INSERT INTO public.who_global_data VALUES (59887, 0, 8, 0, 0, 253, 229);
INSERT INTO public.who_global_data VALUES (59888, 16, 900, 0, 11, 253, 76);
INSERT INTO public.who_global_data VALUES (59889, 6154, 135905, 195, 3983, 253, 138);
INSERT INTO public.who_global_data VALUES (59890, 539, 15588, 17, 921, 253, 98);
INSERT INTO public.who_global_data VALUES (59891, 0, 0, 0, 0, 253, 103);
INSERT INTO public.who_global_data VALUES (59892, 352, 22825, 10, 1038, 253, 225);
INSERT INTO public.who_global_data VALUES (59893, 304, 31596, 13, 1369, 253, 131);
INSERT INTO public.who_global_data VALUES (59894, 89, 3486, 2, 131, 253, 235);
INSERT INTO public.who_global_data VALUES (59895, 1967, 50914, 3, 33, 253, 137);
INSERT INTO public.who_global_data VALUES (59896, 58, 11402, 0, 269, 253, 81);
INSERT INTO public.who_global_data VALUES (59897, 188, 7725, 6, 282, 253, 182);
INSERT INTO public.who_global_data VALUES (59898, 5, 465, 0, 1, 253, 145);
INSERT INTO public.who_global_data VALUES (59899, 197, 18791, 10, 1229, 253, 26);
INSERT INTO public.who_global_data VALUES (59900, 8572, 387623, 232, 4374, 253, 170);
INSERT INTO public.who_global_data VALUES (59901, 3, 349, 0, 0, 253, 191);
INSERT INTO public.who_global_data VALUES (59902, 0, 3, 0, 0, 253, 221);
INSERT INTO public.who_global_data VALUES (59903, 0, 6, 0, 0, 253, 64);
INSERT INTO public.who_global_data VALUES (59904, 0, 0, 0, 0, 253, 116);
INSERT INTO public.who_global_data VALUES (59905, 0, 15, 0, 0, 253, 128);
INSERT INTO public.who_global_data VALUES (59906, 0, 18, 0, 0, 253, 6);
INSERT INTO public.who_global_data VALUES (59907, 0, 40, 0, 3, 253, 227);
INSERT INTO public.who_global_data VALUES (59908, 0, 1, 0, 0, 253, 68);
INSERT INTO public.who_global_data VALUES (59909, 7, 25, 0, 0, 253, 184);
INSERT INTO public.who_global_data VALUES (59910, 0, 0, 0, 0, 253, 82);
INSERT INTO public.who_global_data VALUES (59911, 15, 687, 0, 42, 253, 149);
INSERT INTO public.who_global_data VALUES (59912, 0, 295, 0, 10, 253, 197);
INSERT INTO public.who_global_data VALUES (59913, 1644, 80185, 16, 441, 253, 78);
INSERT INTO public.who_global_data VALUES (59914, 95, 3348, 2, 41, 253, 233);
INSERT INTO public.who_global_data VALUES (59915, 25, 11300, 1, 241, 253, 133);
INSERT INTO public.who_global_data VALUES (59916, 0, 11, 0, 0, 253, 35);
INSERT INTO public.who_global_data VALUES (59917, 30, 812, 0, 45, 253, 114);
INSERT INTO public.who_global_data VALUES (59918, 373, 33249, 0, 23, 253, 237);
INSERT INTO public.who_global_data VALUES (59919, 0, 2, 0, 0, 253, 55);
INSERT INTO public.who_global_data VALUES (59920, 0, 78, 0, 15, 253, 176);
INSERT INTO public.who_global_data VALUES (59921, 5, 1520, 0, 28, 253, 202);
INSERT INTO public.who_global_data VALUES (59922, 0, 1473, 0, 113, 253, 155);
INSERT INTO public.who_global_data VALUES (59923, 0, 0, 0, 0, 253, 32);
INSERT INTO public.who_global_data VALUES (59924, 97, 1828, 5, 72, 253, 220);
INSERT INTO public.who_global_data VALUES (59925, 1466, 27403, 25, 577, 253, 30);
INSERT INTO public.who_global_data VALUES (59926, 188, 994, 2, 10, 253, 147);
INSERT INTO public.who_global_data VALUES (59927, 662, 245192, 45, 28996, 253, 208);
INSERT INTO public.who_global_data VALUES (59928, 37, 1540, 0, 10, 253, 45);
INSERT INTO public.who_global_data VALUES (59929, 0, 4346, 0, 195, 253, 110);
INSERT INTO public.who_global_data VALUES (59930, 1, 12, 0, 1, 253, 88);
INSERT INTO public.who_global_data VALUES (59931, 800, 36414, 38, 4497, 253, 51);
INSERT INTO public.who_global_data VALUES (59932, 30, 30804, 0, 1714, 253, 209);
INSERT INTO public.who_global_data VALUES (59933, 1, 122, 0, 4, 253, 205);
INSERT INTO public.who_global_data VALUES (59934, 139, 3563, 0, 47, 253, 18);
INSERT INTO public.who_global_data VALUES (59935, 11, 3076, 0, 57, 253, 72);
INSERT INTO public.who_global_data VALUES (59936, 1835, 251107, 343, 36957, 253, 44);
INSERT INTO public.who_global_data VALUES (59937, 0, 24, 0, 0, 253, 15);
INSERT INTO public.who_global_data VALUES (59938, 27, 422, 0, 13, 253, 25);
INSERT INTO public.who_global_data VALUES (59939, 0, 0, 0, 0, 253, 179);
INSERT INTO public.who_global_data VALUES (59940, 0, 0, 0, 0, 253, 34);
INSERT INTO public.who_global_data VALUES (59941, 0, 116, 0, 8, 253, 207);
INSERT INTO public.who_global_data VALUES (59942, 3, 1071, 0, 48, 253, 166);
INSERT INTO public.who_global_data VALUES (59943, 1182, 160979, 30, 4461, 253, 126);
INSERT INTO public.who_global_data VALUES (59944, 0, 0, 0, 0, 253, 97);
INSERT INTO public.who_global_data VALUES (59945, 0, 12, 0, 1, 253, 36);
INSERT INTO public.who_global_data VALUES (59946, 0, 0, 0, 0, 253, 125);
INSERT INTO public.who_global_data VALUES (59947, 59, 410, 0, 0, 253, 124);
INSERT INTO public.who_global_data VALUES (59948, 429, 22811, 10, 679, 253, 185);
INSERT INTO public.who_global_data VALUES (59949, 563, 32532, 3, 258, 253, 194);
INSERT INTO public.who_global_data VALUES (59950, 0, 509, 0, 21, 253, 144);
INSERT INTO public.who_global_data VALUES (59951, 19606, 1694864, 1415, 100304, 253, 19);
INSERT INTO public.who_global_data VALUES (59952, 0, 69, 0, 6, 253, 217);
INSERT INTO public.who_global_data VALUES (59953, 14, 803, 0, 22, 253, 148);
INSERT INTO public.who_global_data VALUES (59954, 67, 3463, 0, 14, 253, 86);
INSERT INTO public.who_global_data VALUES (59955, 0, 0, 0, 0, 253, 13);
INSERT INTO public.who_global_data VALUES (59956, 34, 1245, 0, 11, 253, 157);
INSERT INTO public.who_global_data VALUES (59957, 0, 327, 0, 0, 253, 8);
INSERT INTO public.who_global_data VALUES (59958, 0, 0, 0, 0, 253, 73);
INSERT INTO public.who_global_data VALUES (59959, 22, 278, 4, 57, 253, 101);
INSERT INTO public.who_global_data VALUES (59960, 0, 1057, 0, 7, 253, 165);
INSERT INTO public.who_global_data VALUES (59961, 0, 132, 0, 4, 253, 14);
INSERT INTO public.who_global_data VALUES (59962, 637, 13102, 9, 239, 254, 193);
INSERT INTO public.who_global_data VALUES (59963, 26, 1038, 0, 32, 254, 113);
INSERT INTO public.who_global_data VALUES (59964, 160, 8857, 6, 623, 254, 143);
INSERT INTO public.who_global_data VALUES (59965, 0, 0, 0, 0, 254, 219);
INSERT INTO public.who_global_data VALUES (59966, 0, 763, 0, 51, 254, 186);
INSERT INTO public.who_global_data VALUES (59967, 0, 71, 0, 4, 254, 52);
INSERT INTO public.who_global_data VALUES (59968, 0, 3, 0, 0, 254, 180);
INSERT INTO public.who_global_data VALUES (59969, 0, 25, 0, 3, 254, 167);
INSERT INTO public.who_global_data VALUES (59970, 600, 13228, 21, 492, 254, 154);
INSERT INTO public.who_global_data VALUES (59971, 372, 7750, 7, 98, 254, 94);
INSERT INTO public.who_global_data VALUES (59972, 0, 101, 0, 3, 254, 66);
INSERT INTO public.who_global_data VALUES (59973, 6, 7139, 1, 103, 254, 58);
INSERT INTO public.who_global_data VALUES (59974, 18, 16515, 2, 645, 254, 163);
INSERT INTO public.who_global_data VALUES (59975, 165, 4568, 2, 54, 254, 37);
INSERT INTO public.who_global_data VALUES (59976, 0, 100, 0, 11, 254, 142);
INSERT INTO public.who_global_data VALUES (59977, 326, 9692, 1, 15, 254, 83);
INSERT INTO public.who_global_data VALUES (59978, 2029, 40321, 15, 559, 254, 228);
INSERT INTO public.who_global_data VALUES (59979, 0, 92, 0, 7, 254, 188);
INSERT INTO public.who_global_data VALUES (59980, 897, 38956, 6, 214, 254, 62);
INSERT INTO public.who_global_data VALUES (59981, 182, 58618, 24, 9278, 254, 160);
INSERT INTO public.who_global_data VALUES (59982, 0, 18, 0, 2, 254, 50);
INSERT INTO public.who_global_data VALUES (59983, 2, 210, 0, 3, 254, 33);
INSERT INTO public.who_global_data VALUES (59984, 6, 139, 0, 9, 254, 183);
INSERT INTO public.who_global_data VALUES (59985, 1, 28, 0, 0, 254, 92);
INSERT INTO public.who_global_data VALUES (59986, 476, 7136, 13, 274, 254, 158);
INSERT INTO public.who_global_data VALUES (59987, 0, 2, 0, 0, 254, 67);
INSERT INTO public.who_global_data VALUES (59988, 0, 2415, 0, 149, 254, 57);
INSERT INTO public.who_global_data VALUES (59989, 0, 35, 0, 1, 254, 38);
INSERT INTO public.who_global_data VALUES (59990, 16324, 391222, 1039, 24512, 254, 141);
INSERT INTO public.who_global_data VALUES (59991, 0, 8, 0, 1, 254, 178);
INSERT INTO public.who_global_data VALUES (59992, 0, 141, 1, 2, 254, 108);
INSERT INTO public.who_global_data VALUES (59993, 0, 2460, 0, 133, 254, 39);
INSERT INTO public.who_global_data VALUES (59994, 0, 845, 0, 53, 254, 2);
INSERT INTO public.who_global_data VALUES (59995, 0, 42, 0, 1, 254, 195);
INSERT INTO public.who_global_data VALUES (59996, 0, 390, 0, 4, 254, 107);
INSERT INTO public.who_global_data VALUES (59997, 0, 124, 0, 0, 254, 161);
INSERT INTO public.who_global_data VALUES (59998, 0, 5436, 0, 177, 254, 212);
INSERT INTO public.who_global_data VALUES (59999, 941, 86939, 105, 6671, 254, 181);
INSERT INTO public.who_global_data VALUES (60000, 3, 137, 0, 1, 254, 53);
INSERT INTO public.who_global_data VALUES (60001, 49, 701, 0, 1, 254, 164);
INSERT INTO public.who_global_data VALUES (60002, 15, 715, 2, 64, 254, 140);
INSERT INTO public.who_global_data VALUES (60003, 4328, 82289, 35, 841, 254, 20);
INSERT INTO public.who_global_data VALUES (60004, 3, 84547, 0, 4645, 254, 112);
INSERT INTO public.who_global_data VALUES (60005, 1022, 23003, 26, 776, 254, 111);
INSERT INTO public.who_global_data VALUES (60006, 0, 43, 1, 2, 254, 71);
INSERT INTO public.who_global_data VALUES (60007, 2, 571, 0, 19, 254, 218);
INSERT INTO public.who_global_data VALUES (60008, 0, 0, 0, 0, 254, 43);
INSERT INTO public.who_global_data VALUES (60009, 5, 956, 0, 10, 254, 49);
INSERT INTO public.who_global_data VALUES (60010, 79, 2556, 1, 31, 254, 1);
INSERT INTO public.who_global_data VALUES (60011, 0, 2244, 0, 101, 254, 48);
INSERT INTO public.who_global_data VALUES (60012, 11, 1974, 0, 82, 254, 232);
INSERT INTO public.who_global_data VALUES (60013, 0, 18, 0, 1, 254, 175);
INSERT INTO public.who_global_data VALUES (60014, 0, 939, 0, 17, 254, 21);
INSERT INTO public.who_global_data VALUES (60015, 36, 9086, 0, 317, 254, 156);
INSERT INTO public.who_global_data VALUES (60016, 0, 0, 0, 0, 254, 95);
INSERT INTO public.who_global_data VALUES (60017, 257, 2659, 1, 68, 254, 177);
INSERT INTO public.who_global_data VALUES (60018, 52, 11480, 2, 565, 254, 210);
INSERT INTO public.who_global_data VALUES (60019, 229, 2697, 4, 18, 254, 120);
INSERT INTO public.who_global_data VALUES (60020, 0, 16, 0, 0, 254, 135);
INSERT INTO public.who_global_data VALUES (60021, 459, 15723, 6, 474, 254, 206);
INSERT INTO public.who_global_data VALUES (60022, 447, 38103, 54, 3275, 254, 189);
INSERT INTO public.who_global_data VALUES (60023, 910, 19666, 19, 816, 254, 129);
INSERT INTO public.who_global_data VALUES (60024, 67, 2109, 1, 37, 254, 121);
INSERT INTO public.who_global_data VALUES (60025, 0, 1043, 0, 12, 254, 59);
INSERT INTO public.who_global_data VALUES (60026, 0, 39, 0, 0, 254, 96);
INSERT INTO public.who_global_data VALUES (60027, 6, 1840, 0, 63, 254, 41);
INSERT INTO public.who_global_data VALUES (60028, 11, 272, 0, 2, 254, 216);
INSERT INTO public.who_global_data VALUES (60029, 30, 731, 0, 6, 254, 236);
INSERT INTO public.who_global_data VALUES (60030, 0, 13, 0, 0, 254, 150);
INSERT INTO public.who_global_data VALUES (60031, 0, 187, 0, 0, 254, 61);
INSERT INTO public.who_global_data VALUES (60032, 0, 18, 0, 0, 254, 7);
INSERT INTO public.who_global_data VALUES (60033, 64, 6692, 1, 313, 254, 169);
INSERT INTO public.who_global_data VALUES (60034, 148, 142852, 66, 28543, 254, 28);
INSERT INTO public.who_global_data VALUES (60035, 31, 384, 0, 1, 254, 85);
INSERT INTO public.who_global_data VALUES (60036, 0, 60, 0, 0, 254, 211);
INSERT INTO public.who_global_data VALUES (60037, 81, 2319, 0, 14, 254, 60);
INSERT INTO public.who_global_data VALUES (60038, 0, 25, 0, 1, 254, 3);
INSERT INTO public.who_global_data VALUES (60039, 3, 738, 0, 12, 254, 11);
INSERT INTO public.who_global_data VALUES (60040, 353, 179717, 62, 8411, 254, 89);
INSERT INTO public.who_global_data VALUES (60041, 339, 7303, 2, 34, 254, 24);
INSERT INTO public.who_global_data VALUES (60042, 0, 154, 0, 0, 254, 162);
INSERT INTO public.who_global_data VALUES (60043, 11, 2903, 0, 173, 254, 100);
INSERT INTO public.who_global_data VALUES (60044, 0, 12, 0, 0, 254, 47);
INSERT INTO public.who_global_data VALUES (60045, 0, 23, 0, 0, 254, 29);
INSERT INTO public.who_global_data VALUES (60046, 0, 161, 0, 14, 254, 40);
INSERT INTO public.who_global_data VALUES (60047, 1, 164, 0, 5, 254, 222);
INSERT INTO public.who_global_data VALUES (60048, 194, 3954, 4, 63, 254, 132);
INSERT INTO public.who_global_data VALUES (60049, 0, 252, 0, 13, 254, 130);
INSERT INTO public.who_global_data VALUES (60050, 88, 3446, 1, 21, 254, 234);
INSERT INTO public.who_global_data VALUES (60051, 0, 1173, 0, 6, 254, 23);
INSERT INTO public.who_global_data VALUES (60052, 2, 139, 0, 11, 254, 192);
INSERT INTO public.who_global_data VALUES (60053, 111, 1174, 2, 33, 254, 69);
INSERT INTO public.who_global_data VALUES (60054, 0, 12, 0, 0, 254, 187);
INSERT INTO public.who_global_data VALUES (60055, 212, 4401, 6, 188, 254, 230);
INSERT INTO public.who_global_data VALUES (60056, 23, 3816, 4, 509, 254, 77);
INSERT INTO public.who_global_data VALUES (60057, 1, 1805, 0, 10, 254, 9);
INSERT INTO public.who_global_data VALUES (60058, 6566, 158333, 194, 4531, 254, 74);
INSERT INTO public.who_global_data VALUES (60059, 687, 24538, 23, 1496, 254, 224);
INSERT INTO public.who_global_data VALUES (60060, 2080, 141591, 56, 7564, 254, 199);
INSERT INTO public.who_global_data VALUES (60061, 287, 5135, 6, 175, 254, 190);
INSERT INTO public.who_global_data VALUES (60062, 68, 24803, 16, 1631, 254, 12);
INSERT INTO public.who_global_data VALUES (60063, 0, 336, 0, 24, 254, 104);
INSERT INTO public.who_global_data VALUES (60064, 50, 16739, 0, 284, 254, 153);
INSERT INTO public.who_global_data VALUES (60065, 584, 231139, 117, 33072, 254, 91);
INSERT INTO public.who_global_data VALUES (60066, 8, 564, 0, 9, 254, 215);
INSERT INTO public.who_global_data VALUES (60067, 32, 16683, 9, 867, 254, 84);
INSERT INTO public.who_global_data VALUES (60068, 0, 307, 0, 29, 254, 231);
INSERT INTO public.who_global_data VALUES (60069, 2, 718, 0, 9, 254, 196);
INSERT INTO public.who_global_data VALUES (60070, 356, 9932, 0, 37, 254, 105);
INSERT INTO public.who_global_data VALUES (60071, 123, 1471, 3, 55, 254, 122);
INSERT INTO public.who_global_data VALUES (60072, 0, 0, 0, 0, 254, 159);
INSERT INTO public.who_global_data VALUES (60073, 9, 1047, 0, 21, 254, 75);
INSERT INTO public.who_global_data VALUES (60074, 692, 23267, 3, 175, 254, 27);
INSERT INTO public.who_global_data VALUES (60075, 74, 1594, 0, 16, 254, 54);
INSERT INTO public.who_global_data VALUES (60076, 0, 19, 0, 0, 254, 226);
INSERT INTO public.who_global_data VALUES (60077, 4, 1057, 1, 23, 254, 79);
INSERT INTO public.who_global_data VALUES (60078, 21, 1161, 0, 26, 254, 56);
INSERT INTO public.who_global_data VALUES (60079, 0, 2, 0, 0, 254, 117);
INSERT INTO public.who_global_data VALUES (60080, 0, 266, 1, 27, 254, 152);
INSERT INTO public.who_global_data VALUES (60081, 22, 99, 1, 4, 254, 16);
INSERT INTO public.who_global_data VALUES (60082, 0, 83, 0, 1, 254, 10);
INSERT INTO public.who_global_data VALUES (60083, 9, 1649, 2, 68, 254, 201);
INSERT INTO public.who_global_data VALUES (60084, 6, 4001, 0, 110, 254, 174);
INSERT INTO public.who_global_data VALUES (60085, 26, 612, 0, 2, 254, 119);
INSERT INTO public.who_global_data VALUES (60086, 0, 101, 0, 4, 254, 168);
INSERT INTO public.who_global_data VALUES (60087, 15, 7619, 0, 115, 254, 99);
INSERT INTO public.who_global_data VALUES (60088, 0, 1457, 0, 5, 254, 171);
INSERT INTO public.who_global_data VALUES (60089, 39, 1116, 0, 70, 254, 87);
INSERT INTO public.who_global_data VALUES (60090, 4, 615, 1, 7, 254, 123);
INSERT INTO public.who_global_data VALUES (60091, 0, 0, 0, 0, 254, 151);
INSERT INTO public.who_global_data VALUES (60092, 0, 197, 0, 14, 254, 213);
INSERT INTO public.who_global_data VALUES (60093, 30, 292, 7, 16, 254, 118);
INSERT INTO public.who_global_data VALUES (60094, 0, 334, 0, 10, 254, 134);
INSERT INTO public.who_global_data VALUES (60095, 11, 1645, 0, 20, 254, 65);
INSERT INTO public.who_global_data VALUES (60096, 3455, 74560, 501, 8134, 254, 102);
INSERT INTO public.who_global_data VALUES (60097, 0, 0, 0, 0, 254, 223);
INSERT INTO public.who_global_data VALUES (60098, 0, 70, 0, 1, 254, 4);
INSERT INTO public.who_global_data VALUES (60099, 13, 161, 0, 0, 254, 146);
INSERT INTO public.who_global_data VALUES (60100, 0, 324, 0, 9, 254, 31);
INSERT INTO public.who_global_data VALUES (60101, 0, 11, 0, 1, 254, 127);
INSERT INTO public.who_global_data VALUES (60102, 24, 7601, 0, 202, 254, 22);
INSERT INTO public.who_global_data VALUES (60103, 14, 227, 0, 1, 254, 115);
INSERT INTO public.who_global_data VALUES (60104, 0, 206, 0, 6, 254, 106);
INSERT INTO public.who_global_data VALUES (60105, 1, 22, 0, 0, 254, 90);
INSERT INTO public.who_global_data VALUES (60106, 0, 0, 0, 0, 254, 70);
INSERT INTO public.who_global_data VALUES (60107, 156, 1042, 1, 5, 254, 46);
INSERT INTO public.who_global_data VALUES (60108, 194, 45532, 19, 5843, 254, 139);
INSERT INTO public.who_global_data VALUES (60109, 0, 18, 0, 0, 254, 42);
INSERT INTO public.who_global_data VALUES (60110, 0, 1154, 1, 22, 254, 80);
INSERT INTO public.who_global_data VALUES (60111, 480, 759, 18, 35, 254, 203);
INSERT INTO public.who_global_data VALUES (60112, 3, 955, 1, 64, 254, 136);
INSERT INTO public.who_global_data VALUES (60113, 389, 8733, 5, 254, 254, 63);
INSERT INTO public.who_global_data VALUES (60114, 0, 0, 0, 0, 254, 17);
INSERT INTO public.who_global_data VALUES (60115, 0, 22, 0, 2, 254, 172);
INSERT INTO public.who_global_data VALUES (60116, 25, 2040, 3, 119, 254, 109);
INSERT INTO public.who_global_data VALUES (60117, 19, 8383, 0, 235, 254, 200);
INSERT INTO public.who_global_data VALUES (60118, 8, 613, 0, 5, 254, 93);
INSERT INTO public.who_global_data VALUES (60119, 255, 8373, 2, 39, 254, 5);
INSERT INTO public.who_global_data VALUES (60120, 0, 741, 0, 13, 254, 214);
INSERT INTO public.who_global_data VALUES (60121, 2076, 61227, 35, 1260, 254, 204);
INSERT INTO public.who_global_data VALUES (60122, 0, 0, 0, 0, 254, 198);
INSERT INTO public.who_global_data VALUES (60123, 264, 11447, 3, 313, 254, 173);
INSERT INTO public.who_global_data VALUES (60124, 0, 8, 0, 0, 254, 229);
INSERT INTO public.who_global_data VALUES (60125, 7, 884, 0, 11, 254, 76);
INSERT INTO public.who_global_data VALUES (60126, 5772, 129751, 159, 3788, 254, 138);
INSERT INTO public.who_global_data VALUES (60127, 380, 15049, 18, 904, 254, 98);
INSERT INTO public.who_global_data VALUES (60128, 0, 0, 0, 0, 254, 103);
INSERT INTO public.who_global_data VALUES (60129, 399, 22473, 4, 1028, 254, 225);
INSERT INTO public.who_global_data VALUES (60130, 285, 31292, 14, 1356, 254, 131);
INSERT INTO public.who_global_data VALUES (60131, 73, 3397, 0, 129, 254, 235);
INSERT INTO public.who_global_data VALUES (60132, 1740, 48947, 2, 30, 254, 137);
INSERT INTO public.who_global_data VALUES (60133, 79, 11344, 0, 269, 254, 81);
INSERT INTO public.who_global_data VALUES (60134, 232, 7537, 3, 276, 254, 182);
INSERT INTO public.who_global_data VALUES (60135, 1, 460, 0, 1, 254, 145);
INSERT INTO public.who_global_data VALUES (60136, 165, 18594, 9, 1219, 254, 26);
INSERT INTO public.who_global_data VALUES (60137, 8371, 379051, 174, 4142, 254, 170);
INSERT INTO public.who_global_data VALUES (60138, 7, 346, 0, 0, 254, 191);
INSERT INTO public.who_global_data VALUES (60139, 0, 3, 0, 0, 254, 221);
INSERT INTO public.who_global_data VALUES (60140, 0, 6, 0, 0, 254, 64);
INSERT INTO public.who_global_data VALUES (60141, 0, 0, 0, 0, 254, 116);
INSERT INTO public.who_global_data VALUES (60142, 0, 15, 0, 0, 254, 128);
INSERT INTO public.who_global_data VALUES (60143, 0, 18, 0, 0, 254, 6);
INSERT INTO public.who_global_data VALUES (60144, 0, 40, 0, 3, 254, 227);
INSERT INTO public.who_global_data VALUES (60145, 0, 1, 0, 0, 254, 68);
INSERT INTO public.who_global_data VALUES (60146, 0, 18, 0, 0, 254, 184);
INSERT INTO public.who_global_data VALUES (60147, 0, 0, 0, 0, 254, 82);
INSERT INTO public.who_global_data VALUES (60148, 0, 672, 0, 42, 254, 149);
INSERT INTO public.who_global_data VALUES (60149, 0, 295, 0, 10, 254, 197);
INSERT INTO public.who_global_data VALUES (60150, 1815, 78541, 14, 425, 254, 78);
INSERT INTO public.who_global_data VALUES (60151, 92, 3253, 2, 39, 254, 233);
INSERT INTO public.who_global_data VALUES (60152, 48, 11275, 1, 240, 254, 133);
INSERT INTO public.who_global_data VALUES (60153, 0, 11, 0, 0, 254, 35);
INSERT INTO public.who_global_data VALUES (60154, 28, 782, 1, 45, 254, 114);
INSERT INTO public.who_global_data VALUES (60155, 533, 32876, 0, 23, 254, 237);
INSERT INTO public.who_global_data VALUES (60156, 0, 2, 0, 0, 254, 55);
INSERT INTO public.who_global_data VALUES (60157, 0, 78, 0, 15, 254, 176);
INSERT INTO public.who_global_data VALUES (60158, 2, 1515, 0, 28, 254, 202);
INSERT INTO public.who_global_data VALUES (60159, 2, 1473, 0, 113, 254, 155);
INSERT INTO public.who_global_data VALUES (60160, 0, 0, 0, 0, 254, 32);
INSERT INTO public.who_global_data VALUES (60161, 20, 1731, 0, 67, 254, 220);
INSERT INTO public.who_global_data VALUES (60162, 1673, 25937, 28, 552, 254, 30);
INSERT INTO public.who_global_data VALUES (60163, 0, 806, 0, 8, 254, 147);
INSERT INTO public.who_global_data VALUES (60164, 812, 244530, 56, 28951, 254, 208);
INSERT INTO public.who_global_data VALUES (60165, 78, 1503, 0, 10, 254, 45);
INSERT INTO public.who_global_data VALUES (60166, 200, 4346, 11, 195, 254, 110);
INSERT INTO public.who_global_data VALUES (60167, 0, 11, 0, 1, 254, 88);
INSERT INTO public.who_global_data VALUES (60168, 746, 35614, 28, 4459, 254, 51);
INSERT INTO public.who_global_data VALUES (60169, 25, 30774, 0, 1714, 254, 209);
INSERT INTO public.who_global_data VALUES (60170, 0, 121, 0, 4, 254, 205);
INSERT INTO public.who_global_data VALUES (60171, 158, 3424, 0, 47, 254, 18);
INSERT INTO public.who_global_data VALUES (60172, 11, 3065, 0, 57, 254, 72);
INSERT INTO public.who_global_data VALUES (60173, 1672, 249272, 422, 36614, 254, 44);
INSERT INTO public.who_global_data VALUES (60174, 0, 24, 0, 0, 254, 15);
INSERT INTO public.who_global_data VALUES (60175, 4, 395, 0, 13, 254, 25);
INSERT INTO public.who_global_data VALUES (60176, 0, 0, 0, 0, 254, 179);
INSERT INTO public.who_global_data VALUES (60177, 0, 0, 0, 0, 254, 34);
INSERT INTO public.who_global_data VALUES (60178, 0, 116, 0, 8, 254, 207);
INSERT INTO public.who_global_data VALUES (60179, 17, 1068, 0, 48, 254, 166);
INSERT INTO public.who_global_data VALUES (60180, 1035, 159797, 34, 4431, 254, 126);
INSERT INTO public.who_global_data VALUES (60181, 0, 0, 0, 0, 254, 97);
INSERT INTO public.who_global_data VALUES (60182, 0, 12, 0, 1, 254, 36);
INSERT INTO public.who_global_data VALUES (60183, 0, 0, 0, 0, 254, 125);
INSERT INTO public.who_global_data VALUES (60184, 10, 351, 0, 0, 254, 124);
INSERT INTO public.who_global_data VALUES (60185, 477, 22382, 11, 669, 254, 185);
INSERT INTO public.who_global_data VALUES (60186, 883, 31969, 2, 255, 254, 194);
INSERT INTO public.who_global_data VALUES (60187, 0, 509, 0, 21, 254, 144);
INSERT INTO public.who_global_data VALUES (60188, 16362, 1675258, 770, 98889, 254, 19);
INSERT INTO public.who_global_data VALUES (60189, 0, 69, 0, 6, 254, 217);
INSERT INTO public.who_global_data VALUES (60190, 2, 789, 0, 22, 254, 148);
INSERT INTO public.who_global_data VALUES (60191, 63, 3396, 0, 14, 254, 86);
INSERT INTO public.who_global_data VALUES (60192, 0, 0, 0, 0, 254, 13);
INSERT INTO public.who_global_data VALUES (60193, 34, 1211, 1, 11, 254, 157);
INSERT INTO public.who_global_data VALUES (60194, 0, 327, 0, 0, 254, 8);
INSERT INTO public.who_global_data VALUES (60195, 0, 0, 0, 0, 254, 73);
INSERT INTO public.who_global_data VALUES (60196, 7, 256, 4, 53, 254, 101);
INSERT INTO public.who_global_data VALUES (60197, 137, 1057, 0, 7, 254, 165);
INSERT INTO public.who_global_data VALUES (60198, 76, 132, 0, 4, 254, 14);
INSERT INTO public.who_global_data VALUES (60199, 548, 12465, 6, 230, 255, 193);
INSERT INTO public.who_global_data VALUES (60200, 21, 1012, 0, 32, 255, 113);
INSERT INTO public.who_global_data VALUES (60201, 194, 8697, 8, 617, 255, 143);
INSERT INTO public.who_global_data VALUES (60202, 0, 0, 0, 0, 255, 219);
INSERT INTO public.who_global_data VALUES (60203, 0, 763, 0, 51, 255, 186);
INSERT INTO public.who_global_data VALUES (60204, 2, 71, 0, 4, 255, 52);
INSERT INTO public.who_global_data VALUES (60205, 0, 3, 0, 0, 255, 180);
INSERT INTO public.who_global_data VALUES (60206, 0, 25, 0, 3, 255, 167);
INSERT INTO public.who_global_data VALUES (60207, 552, 12628, 19, 471, 255, 154);
INSERT INTO public.who_global_data VALUES (60208, 289, 7378, 4, 91, 255, 94);
INSERT INTO public.who_global_data VALUES (60209, 0, 101, 0, 3, 255, 66);
INSERT INTO public.who_global_data VALUES (60210, 15, 7133, 0, 102, 255, 58);
INSERT INTO public.who_global_data VALUES (60211, 38, 16497, 2, 643, 255, 163);
INSERT INTO public.who_global_data VALUES (60212, 132, 4403, 1, 52, 255, 37);
INSERT INTO public.who_global_data VALUES (60213, 0, 100, 0, 11, 255, 142);
INSERT INTO public.who_global_data VALUES (60214, 195, 9366, 0, 14, 255, 83);
INSERT INTO public.who_global_data VALUES (60215, 1541, 38292, 22, 544, 255, 228);
INSERT INTO public.who_global_data VALUES (60216, 0, 92, 0, 7, 255, 188);
INSERT INTO public.who_global_data VALUES (60217, 915, 38059, 4, 208, 255, 62);
INSERT INTO public.who_global_data VALUES (60218, 202, 58436, 24, 9254, 255, 160);
INSERT INTO public.who_global_data VALUES (60219, 0, 18, 0, 2, 255, 50);
INSERT INTO public.who_global_data VALUES (60220, 17, 208, 0, 3, 255, 33);
INSERT INTO public.who_global_data VALUES (60221, 0, 133, 0, 9, 255, 183);
INSERT INTO public.who_global_data VALUES (60222, 0, 27, 0, 0, 255, 92);
INSERT INTO public.who_global_data VALUES (60223, 397, 6660, 11, 261, 255, 158);
INSERT INTO public.who_global_data VALUES (60224, 0, 2, 0, 0, 255, 67);
INSERT INTO public.who_global_data VALUES (60225, 10, 2415, 4, 149, 255, 57);
INSERT INTO public.who_global_data VALUES (60226, 0, 35, 0, 1, 255, 38);
INSERT INTO public.who_global_data VALUES (60227, 11687, 374898, 807, 23473, 255, 141);
INSERT INTO public.who_global_data VALUES (60228, 0, 8, 0, 1, 255, 178);
INSERT INTO public.who_global_data VALUES (60229, 0, 141, 0, 1, 255, 108);
INSERT INTO public.who_global_data VALUES (60230, 27, 2460, 3, 133, 255, 39);
INSERT INTO public.who_global_data VALUES (60231, 4, 845, 1, 53, 255, 2);
INSERT INTO public.who_global_data VALUES (60232, 0, 42, 0, 1, 255, 195);
INSERT INTO public.who_global_data VALUES (60233, 0, 390, 1, 4, 255, 107);
INSERT INTO public.who_global_data VALUES (60234, 0, 124, 0, 0, 255, 161);
INSERT INTO public.who_global_data VALUES (60235, 546, 5436, 12, 177, 255, 212);
INSERT INTO public.who_global_data VALUES (60236, 895, 85998, 113, 6566, 255, 181);
INSERT INTO public.who_global_data VALUES (60237, 5, 134, 0, 1, 255, 53);
INSERT INTO public.who_global_data VALUES (60238, 0, 652, 0, 1, 255, 164);
INSERT INTO public.who_global_data VALUES (60239, 13, 700, 1, 62, 255, 140);
INSERT INTO public.who_global_data VALUES (60240, 3964, 77961, 45, 806, 255, 20);
INSERT INTO public.who_global_data VALUES (60241, 1, 84544, 0, 4645, 255, 112);
INSERT INTO public.who_global_data VALUES (60242, 806, 21981, 23, 750, 255, 111);
INSERT INTO public.who_global_data VALUES (60243, 0, 43, 0, 1, 255, 71);
INSERT INTO public.who_global_data VALUES (60244, 38, 569, 2, 19, 255, 218);
INSERT INTO public.who_global_data VALUES (60245, 0, 0, 0, 0, 255, 43);
INSERT INTO public.who_global_data VALUES (60246, 21, 951, 0, 10, 255, 49);
INSERT INTO public.who_global_data VALUES (60247, 54, 2477, 0, 30, 255, 1);
INSERT INTO public.who_global_data VALUES (60248, 0, 2244, 1, 101, 255, 48);
INSERT INTO public.who_global_data VALUES (60249, 16, 1963, 0, 82, 255, 232);
INSERT INTO public.who_global_data VALUES (60250, 1, 18, 0, 1, 255, 175);
INSERT INTO public.who_global_data VALUES (60251, 2, 939, 0, 17, 255, 21);
INSERT INTO public.who_global_data VALUES (60252, 46, 9050, 0, 317, 255, 156);
INSERT INTO public.who_global_data VALUES (60253, 0, 0, 0, 0, 255, 95);
INSERT INTO public.who_global_data VALUES (60254, 98, 2402, 1, 67, 255, 177);
INSERT INTO public.who_global_data VALUES (60255, 41, 11428, 0, 563, 255, 210);
INSERT INTO public.who_global_data VALUES (60256, 0, 2468, 0, 14, 255, 120);
INSERT INTO public.who_global_data VALUES (60257, 0, 16, 0, 0, 255, 135);
INSERT INTO public.who_global_data VALUES (60258, 191, 15264, 8, 468, 255, 206);
INSERT INTO public.who_global_data VALUES (60259, 301, 37656, 18, 3221, 255, 189);
INSERT INTO public.who_global_data VALUES (60260, 789, 18756, 14, 797, 255, 129);
INSERT INTO public.who_global_data VALUES (60261, 59, 2042, 1, 36, 255, 121);
INSERT INTO public.who_global_data VALUES (60262, 0, 1043, 0, 12, 255, 59);
INSERT INTO public.who_global_data VALUES (60263, 0, 39, 0, 0, 255, 96);
INSERT INTO public.who_global_data VALUES (60264, 10, 1834, 0, 63, 255, 41);
INSERT INTO public.who_global_data VALUES (60265, 5, 261, 0, 2, 255, 216);
INSERT INTO public.who_global_data VALUES (60266, 46, 701, 1, 6, 255, 236);
INSERT INTO public.who_global_data VALUES (60267, 0, 13, 0, 0, 255, 150);
INSERT INTO public.who_global_data VALUES (60268, 0, 187, 0, 0, 255, 61);
INSERT INTO public.who_global_data VALUES (60269, 0, 18, 0, 0, 255, 7);
INSERT INTO public.who_global_data VALUES (60270, 29, 6628, 4, 312, 255, 169);
INSERT INTO public.who_global_data VALUES (60271, 222, 142704, 98, 28477, 255, 28);
INSERT INTO public.who_global_data VALUES (60272, 25, 353, 0, 1, 255, 85);
INSERT INTO public.who_global_data VALUES (60273, 0, 60, 0, 0, 255, 211);
INSERT INTO public.who_global_data VALUES (60274, 103, 2238, 0, 14, 255, 60);
INSERT INTO public.who_global_data VALUES (60275, 0, 25, 0, 1, 255, 3);
INSERT INTO public.who_global_data VALUES (60276, 3, 735, 0, 12, 255, 11);
INSERT INTO public.who_global_data VALUES (60277, 362, 179364, 47, 8349, 255, 89);
INSERT INTO public.who_global_data VALUES (60278, 156, 6964, 0, 32, 255, 24);
INSERT INTO public.who_global_data VALUES (60279, 0, 154, 0, 0, 255, 162);
INSERT INTO public.who_global_data VALUES (60280, 10, 2892, 1, 173, 255, 100);
INSERT INTO public.who_global_data VALUES (60281, 0, 12, 0, 0, 255, 47);
INSERT INTO public.who_global_data VALUES (60282, 1, 23, 0, 0, 255, 29);
INSERT INTO public.who_global_data VALUES (60283, 0, 161, 0, 14, 255, 40);
INSERT INTO public.who_global_data VALUES (60284, 2, 163, 0, 5, 255, 222);
INSERT INTO public.who_global_data VALUES (60285, 336, 3760, 1, 59, 255, 132);
INSERT INTO public.who_global_data VALUES (60286, 0, 252, 0, 13, 255, 130);
INSERT INTO public.who_global_data VALUES (60287, 36, 3358, 0, 20, 255, 234);
INSERT INTO public.who_global_data VALUES (60288, 0, 1173, 0, 6, 255, 23);
INSERT INTO public.who_global_data VALUES (60289, 2, 137, 1, 11, 255, 192);
INSERT INTO public.who_global_data VALUES (60290, 105, 1063, 4, 31, 255, 69);
INSERT INTO public.who_global_data VALUES (60291, 0, 12, 0, 0, 255, 187);
INSERT INTO public.who_global_data VALUES (60292, 239, 4189, 2, 182, 255, 230);
INSERT INTO public.who_global_data VALUES (60293, 22, 3793, 6, 505, 255, 77);
INSERT INTO public.who_global_data VALUES (60294, 0, 1804, 0, 10, 255, 9);
INSERT INTO public.who_global_data VALUES (60295, 6387, 151767, 170, 4337, 255, 74);
INSERT INTO public.who_global_data VALUES (60296, 686, 23851, 55, 1473, 255, 224);
INSERT INTO public.who_global_data VALUES (60297, 1787, 139511, 57, 7508, 255, 199);
INSERT INTO public.who_global_data VALUES (60298, 216, 4848, 6, 169, 255, 190);
INSERT INTO public.who_global_data VALUES (60299, 37, 24735, 9, 1615, 255, 12);
INSERT INTO public.who_global_data VALUES (60300, 0, 336, 0, 24, 255, 104);
INSERT INTO public.who_global_data VALUES (60301, 22, 16689, 2, 284, 255, 153);
INSERT INTO public.who_global_data VALUES (60302, 397, 230555, 78, 32955, 255, 91);
INSERT INTO public.who_global_data VALUES (60303, 4, 556, 0, 9, 255, 215);
INSERT INTO public.who_global_data VALUES (60304, 28, 16651, 12, 858, 255, 84);
INSERT INTO public.who_global_data VALUES (60305, 1, 307, 0, 29, 255, 231);
INSERT INTO public.who_global_data VALUES (60306, 7, 716, 0, 9, 255, 196);
INSERT INTO public.who_global_data VALUES (60307, 272, 9576, 0, 37, 255, 105);
INSERT INTO public.who_global_data VALUES (60308, 62, 1348, 0, 52, 255, 122);
INSERT INTO public.who_global_data VALUES (60309, 0, 0, 0, 0, 255, 159);
INSERT INTO public.who_global_data VALUES (60310, 0, 1038, 0, 21, 255, 75);
INSERT INTO public.who_global_data VALUES (60311, 608, 22575, 7, 172, 255, 27);
INSERT INTO public.who_global_data VALUES (60312, 52, 1520, 0, 16, 255, 54);
INSERT INTO public.who_global_data VALUES (60313, 0, 19, 0, 0, 255, 226);
INSERT INTO public.who_global_data VALUES (60314, 4, 1053, 0, 22, 255, 79);
INSERT INTO public.who_global_data VALUES (60315, 21, 1140, 0, 26, 255, 56);
INSERT INTO public.who_global_data VALUES (60316, 0, 2, 0, 0, 255, 117);
INSERT INTO public.who_global_data VALUES (60317, 1, 266, 0, 26, 255, 152);
INSERT INTO public.who_global_data VALUES (60318, 2, 77, 0, 3, 255, 16);
INSERT INTO public.who_global_data VALUES (60319, 0, 83, 0, 1, 255, 10);
INSERT INTO public.who_global_data VALUES (60320, 8, 1640, 0, 66, 255, 201);
INSERT INTO public.who_global_data VALUES (60321, 2, 3995, 0, 110, 255, 174);
INSERT INTO public.who_global_data VALUES (60322, 44, 586, 0, 2, 255, 119);
INSERT INTO public.who_global_data VALUES (60323, 0, 101, 0, 4, 255, 168);
INSERT INTO public.who_global_data VALUES (60324, 187, 7604, 0, 115, 255, 99);
INSERT INTO public.who_global_data VALUES (60325, 62, 1457, 1, 5, 255, 171);
INSERT INTO public.who_global_data VALUES (60326, 18, 1077, 3, 70, 255, 87);
INSERT INTO public.who_global_data VALUES (60327, 1, 611, 0, 6, 255, 123);
INSERT INTO public.who_global_data VALUES (60328, 0, 0, 0, 0, 255, 151);
INSERT INTO public.who_global_data VALUES (60329, 0, 197, 0, 14, 255, 213);
INSERT INTO public.who_global_data VALUES (60330, 0, 262, 0, 9, 255, 118);
INSERT INTO public.who_global_data VALUES (60331, 0, 334, 0, 10, 255, 134);
INSERT INTO public.who_global_data VALUES (60332, 25, 1634, 0, 20, 255, 65);
INSERT INTO public.who_global_data VALUES (60333, 2485, 71105, 239, 7633, 255, 102);
INSERT INTO public.who_global_data VALUES (60334, 0, 0, 0, 0, 255, 223);
INSERT INTO public.who_global_data VALUES (60335, 0, 70, 0, 1, 255, 4);
INSERT INTO public.who_global_data VALUES (60336, 7, 148, 0, 0, 255, 146);
INSERT INTO public.who_global_data VALUES (60337, 0, 324, 0, 9, 255, 31);
INSERT INTO public.who_global_data VALUES (60338, 0, 11, 0, 1, 255, 127);
INSERT INTO public.who_global_data VALUES (60339, 45, 7577, 2, 202, 255, 22);
INSERT INTO public.who_global_data VALUES (60340, 4, 213, 0, 1, 255, 115);
INSERT INTO public.who_global_data VALUES (60341, 0, 206, 0, 6, 255, 106);
INSERT INTO public.who_global_data VALUES (60342, 0, 21, 0, 0, 255, 90);
INSERT INTO public.who_global_data VALUES (60343, 0, 0, 0, 0, 255, 70);
INSERT INTO public.who_global_data VALUES (60344, 114, 886, 0, 4, 255, 46);
INSERT INTO public.who_global_data VALUES (60345, 129, 45338, 20, 5824, 255, 139);
INSERT INTO public.who_global_data VALUES (60346, 0, 18, 0, 0, 255, 42);
INSERT INTO public.who_global_data VALUES (60347, 0, 1154, 0, 21, 255, 80);
INSERT INTO public.who_global_data VALUES (60348, 0, 279, 0, 17, 255, 203);
INSERT INTO public.who_global_data VALUES (60349, 1, 952, 1, 63, 255, 136);
INSERT INTO public.who_global_data VALUES (60350, 276, 8344, 16, 249, 255, 63);
INSERT INTO public.who_global_data VALUES (60351, 0, 0, 0, 0, 255, 17);
INSERT INTO public.who_global_data VALUES (60352, 0, 22, 0, 2, 255, 172);
INSERT INTO public.who_global_data VALUES (60353, 16, 2015, 3, 116, 255, 109);
INSERT INTO public.who_global_data VALUES (60354, 12, 8364, 0, 235, 255, 200);
INSERT INTO public.who_global_data VALUES (60355, 3, 605, 0, 5, 255, 93);
INSERT INTO public.who_global_data VALUES (60356, 348, 8118, 0, 37, 255, 5);
INSERT INTO public.who_global_data VALUES (60357, 0, 741, 0, 13, 255, 214);
INSERT INTO public.who_global_data VALUES (60358, 1446, 59151, 28, 1225, 255, 204);
INSERT INTO public.who_global_data VALUES (60359, 0, 0, 0, 0, 255, 198);
INSERT INTO public.who_global_data VALUES (60360, 257, 11183, 4, 310, 255, 173);
INSERT INTO public.who_global_data VALUES (60361, 0, 8, 0, 0, 255, 229);
INSERT INTO public.who_global_data VALUES (60362, 12, 877, 0, 11, 255, 76);
INSERT INTO public.who_global_data VALUES (60363, 4020, 123979, 173, 3629, 255, 138);
INSERT INTO public.who_global_data VALUES (60364, 350, 14669, 13, 886, 255, 98);
INSERT INTO public.who_global_data VALUES (60365, 0, 0, 0, 0, 255, 103);
INSERT INTO public.who_global_data VALUES (60366, 443, 22074, 17, 1024, 255, 225);
INSERT INTO public.who_global_data VALUES (60367, 219, 31007, 12, 1342, 255, 131);
INSERT INTO public.who_global_data VALUES (60368, 64, 3324, 0, 129, 255, 235);
INSERT INTO public.who_global_data VALUES (60369, 1742, 47207, 2, 28, 255, 137);
INSERT INTO public.who_global_data VALUES (60370, 40, 11265, 0, 269, 255, 81);
INSERT INTO public.who_global_data VALUES (60371, 156, 7305, 8, 273, 255, 182);
INSERT INTO public.who_global_data VALUES (60372, 3, 459, 0, 1, 255, 145);
INSERT INTO public.who_global_data VALUES (60373, 146, 18429, 13, 1210, 255, 26);
INSERT INTO public.who_global_data VALUES (60374, 8338, 370680, 161, 3968, 255, 170);
INSERT INTO public.who_global_data VALUES (60375, 3, 339, 0, 0, 255, 191);
INSERT INTO public.who_global_data VALUES (60376, 0, 3, 0, 0, 255, 221);
INSERT INTO public.who_global_data VALUES (60377, 0, 6, 0, 0, 255, 64);
INSERT INTO public.who_global_data VALUES (60378, 0, 0, 0, 0, 255, 116);
INSERT INTO public.who_global_data VALUES (60379, 0, 15, 0, 0, 255, 128);
INSERT INTO public.who_global_data VALUES (60380, 0, 18, 0, 0, 255, 6);
INSERT INTO public.who_global_data VALUES (60381, 1, 40, 0, 3, 255, 227);
INSERT INTO public.who_global_data VALUES (60382, 0, 1, 0, 0, 255, 68);
INSERT INTO public.who_global_data VALUES (60383, 0, 18, 0, 0, 255, 184);
INSERT INTO public.who_global_data VALUES (60384, 0, 0, 0, 0, 255, 82);
INSERT INTO public.who_global_data VALUES (60385, 0, 672, 0, 42, 255, 149);
INSERT INTO public.who_global_data VALUES (60386, 130, 295, 0, 10, 255, 197);
INSERT INTO public.who_global_data VALUES (60387, 1931, 76726, 12, 411, 255, 78);
INSERT INTO public.who_global_data VALUES (60388, 31, 3161, 2, 37, 255, 233);
INSERT INTO public.who_global_data VALUES (60389, 34, 11227, 0, 239, 255, 133);
INSERT INTO public.who_global_data VALUES (60390, 0, 11, 0, 0, 255, 35);
INSERT INTO public.who_global_data VALUES (60391, 19, 754, 2, 44, 255, 114);
INSERT INTO public.who_global_data VALUES (60392, 383, 32343, 0, 23, 255, 237);
INSERT INTO public.who_global_data VALUES (60393, 0, 2, 0, 0, 255, 55);
INSERT INTO public.who_global_data VALUES (60394, 0, 78, 0, 15, 255, 176);
INSERT INTO public.who_global_data VALUES (60395, 2, 1513, 0, 28, 255, 202);
INSERT INTO public.who_global_data VALUES (60396, 2, 1471, 0, 113, 255, 155);
INSERT INTO public.who_global_data VALUES (60397, 0, 0, 0, 0, 255, 32);
INSERT INTO public.who_global_data VALUES (60398, 22, 1711, 1, 67, 255, 220);
INSERT INTO public.who_global_data VALUES (60399, 649, 24264, 43, 524, 255, 30);
INSERT INTO public.who_global_data VALUES (60400, 151, 806, 0, 8, 255, 147);
INSERT INTO public.who_global_data VALUES (60401, 645, 243718, 66, 28895, 255, 208);
INSERT INTO public.who_global_data VALUES (60402, 147, 1425, 0, 10, 255, 45);
INSERT INTO public.who_global_data VALUES (60403, 170, 4146, 14, 184, 255, 110);
INSERT INTO public.who_global_data VALUES (60404, 0, 11, 0, 1, 255, 88);
INSERT INTO public.who_global_data VALUES (60405, 491, 34868, 42, 4431, 255, 51);
INSERT INTO public.who_global_data VALUES (60406, 18, 30749, 2, 1714, 255, 209);
INSERT INTO public.who_global_data VALUES (60407, 15, 121, 0, 4, 255, 205);
INSERT INTO public.who_global_data VALUES (60408, 166, 3266, 1, 47, 255, 18);
INSERT INTO public.who_global_data VALUES (60409, 9, 3054, 0, 57, 255, 72);
INSERT INTO public.who_global_data VALUES (60410, 1624, 247600, 131, 36192, 255, 44);
INSERT INTO public.who_global_data VALUES (60411, 0, 24, 0, 0, 255, 15);
INSERT INTO public.who_global_data VALUES (60412, 5, 391, 0, 13, 255, 25);
INSERT INTO public.who_global_data VALUES (60413, 0, 0, 0, 0, 255, 179);
INSERT INTO public.who_global_data VALUES (60414, 0, 0, 0, 0, 255, 34);
INSERT INTO public.who_global_data VALUES (60415, 0, 116, 0, 8, 255, 207);
INSERT INTO public.who_global_data VALUES (60416, 0, 1051, 0, 48, 255, 166);
INSERT INTO public.who_global_data VALUES (60417, 948, 158762, 28, 4397, 255, 126);
INSERT INTO public.who_global_data VALUES (60418, 0, 0, 0, 0, 255, 97);
INSERT INTO public.who_global_data VALUES (60419, 0, 12, 0, 1, 255, 36);
INSERT INTO public.who_global_data VALUES (60420, 0, 0, 0, 0, 255, 125);
INSERT INTO public.who_global_data VALUES (60421, 37, 341, 0, 0, 255, 124);
INSERT INTO public.who_global_data VALUES (60422, 321, 21905, 14, 658, 255, 185);
INSERT INTO public.who_global_data VALUES (60423, 779, 31086, 5, 253, 255, 194);
INSERT INTO public.who_global_data VALUES (60424, 0, 509, 0, 21, 255, 144);
INSERT INTO public.who_global_data VALUES (60425, 24886, 1658896, 590, 98119, 255, 19);
INSERT INTO public.who_global_data VALUES (60426, 0, 69, 0, 6, 255, 217);
INSERT INTO public.who_global_data VALUES (60427, 18, 787, 0, 22, 255, 148);
INSERT INTO public.who_global_data VALUES (60428, 72, 3333, 1, 14, 255, 86);
INSERT INTO public.who_global_data VALUES (60429, 0, 0, 0, 0, 255, 13);
INSERT INTO public.who_global_data VALUES (60430, 56, 1177, 0, 10, 255, 157);
INSERT INTO public.who_global_data VALUES (60431, 1, 327, 0, 0, 255, 8);
INSERT INTO public.who_global_data VALUES (60432, 0, 0, 0, 0, 255, 73);
INSERT INTO public.who_global_data VALUES (60433, 16, 249, 5, 49, 255, 101);
INSERT INTO public.who_global_data VALUES (60434, 0, 920, 0, 7, 255, 165);
INSERT INTO public.who_global_data VALUES (60435, 0, 56, 0, 4, 255, 14);
INSERT INTO public.who_global_data VALUES (60436, 737, 11917, 1, 224, 256, 193);
INSERT INTO public.who_global_data VALUES (60437, 25, 991, 1, 32, 256, 113);
INSERT INTO public.who_global_data VALUES (60438, 197, 8503, 9, 609, 256, 143);
INSERT INTO public.who_global_data VALUES (60439, 0, 0, 0, 0, 256, 219);
INSERT INTO public.who_global_data VALUES (60440, 0, 763, 0, 51, 256, 186);
INSERT INTO public.who_global_data VALUES (60441, 0, 69, 0, 4, 256, 52);
INSERT INTO public.who_global_data VALUES (60442, 0, 3, 0, 0, 256, 180);
INSERT INTO public.who_global_data VALUES (60443, 0, 25, 0, 3, 256, 167);
INSERT INTO public.who_global_data VALUES (60444, 723, 12076, 7, 452, 256, 154);
INSERT INTO public.who_global_data VALUES (60445, 452, 7089, 6, 87, 256, 94);
INSERT INTO public.who_global_data VALUES (60446, 0, 101, 0, 3, 256, 66);
INSERT INTO public.who_global_data VALUES (60447, 9, 7118, 0, 102, 256, 58);
INSERT INTO public.who_global_data VALUES (60448, 20, 16459, 1, 641, 256, 163);
INSERT INTO public.who_global_data VALUES (60449, 149, 4271, 2, 51, 256, 37);
INSERT INTO public.who_global_data VALUES (60450, 0, 100, 0, 11, 256, 142);
INSERT INTO public.who_global_data VALUES (60451, 33, 9171, 1, 14, 256, 83);
INSERT INTO public.who_global_data VALUES (60452, 1166, 36751, 21, 522, 256, 228);
INSERT INTO public.who_global_data VALUES (60453, 0, 92, 0, 7, 256, 188);
INSERT INTO public.who_global_data VALUES (60454, 946, 37144, 5, 204, 256, 62);
INSERT INTO public.who_global_data VALUES (60455, 314, 58234, 26, 9230, 256, 160);
INSERT INTO public.who_global_data VALUES (60456, 0, 18, 0, 2, 256, 50);
INSERT INTO public.who_global_data VALUES (60457, 0, 191, 0, 3, 256, 33);
INSERT INTO public.who_global_data VALUES (60458, 0, 133, 0, 9, 256, 183);
INSERT INTO public.who_global_data VALUES (60459, 0, 27, 0, 0, 256, 92);
INSERT INTO public.who_global_data VALUES (60460, 348, 6263, 10, 250, 256, 158);
INSERT INTO public.who_global_data VALUES (60461, 0, 2, 0, 0, 256, 67);
INSERT INTO public.who_global_data VALUES (60462, 14, 2405, 4, 145, 256, 57);
INSERT INTO public.who_global_data VALUES (60463, 0, 35, 0, 1, 256, 38);
INSERT INTO public.who_global_data VALUES (60464, 15813, 363211, 653, 22666, 256, 141);
INSERT INTO public.who_global_data VALUES (60465, 0, 8, 0, 1, 256, 178);
INSERT INTO public.who_global_data VALUES (60466, 0, 141, 0, 1, 256, 108);
INSERT INTO public.who_global_data VALUES (60467, 0, 2433, 0, 130, 256, 39);
INSERT INTO public.who_global_data VALUES (60468, 9, 841, 0, 52, 256, 2);
INSERT INTO public.who_global_data VALUES (60469, 0, 42, 0, 1, 256, 195);
INSERT INTO public.who_global_data VALUES (60470, 10, 390, 0, 3, 256, 107);
INSERT INTO public.who_global_data VALUES (60471, 0, 124, 0, 0, 256, 161);
INSERT INTO public.who_global_data VALUES (60472, 490, 4890, 6, 165, 256, 212);
INSERT INTO public.who_global_data VALUES (60473, 1022, 85103, 73, 6453, 256, 181);
INSERT INTO public.who_global_data VALUES (60474, 0, 129, 0, 1, 256, 53);
INSERT INTO public.who_global_data VALUES (60475, 48, 652, 0, 1, 256, 164);
INSERT INTO public.who_global_data VALUES (60476, 12, 687, 1, 61, 256, 140);
INSERT INTO public.who_global_data VALUES (60477, 4895, 73997, 43, 761, 256, 20);
INSERT INTO public.who_global_data VALUES (60478, 7, 84543, 0, 4645, 256, 112);
INSERT INTO public.who_global_data VALUES (60479, 998, 21175, 22, 727, 256, 111);
INSERT INTO public.who_global_data VALUES (60480, 0, 43, 0, 1, 256, 71);
INSERT INTO public.who_global_data VALUES (60481, 44, 531, 1, 17, 256, 218);
INSERT INTO public.who_global_data VALUES (60482, 0, 0, 0, 0, 256, 43);
INSERT INTO public.who_global_data VALUES (60483, 12, 930, 0, 10, 256, 49);
INSERT INTO public.who_global_data VALUES (60484, 47, 2423, 0, 30, 256, 1);
INSERT INTO public.who_global_data VALUES (60485, 0, 2244, 1, 100, 256, 48);
INSERT INTO public.who_global_data VALUES (60486, 6, 1947, 0, 82, 256, 232);
INSERT INTO public.who_global_data VALUES (60487, 0, 17, 0, 1, 256, 175);
INSERT INTO public.who_global_data VALUES (60488, 2, 937, 0, 17, 256, 21);
INSERT INTO public.who_global_data VALUES (60489, 47, 9004, 2, 317, 256, 156);
INSERT INTO public.who_global_data VALUES (60490, 0, 0, 0, 0, 256, 95);
INSERT INTO public.who_global_data VALUES (60491, 164, 2304, 4, 66, 256, 177);
INSERT INTO public.who_global_data VALUES (60492, 27, 11387, 1, 563, 256, 210);
INSERT INTO public.who_global_data VALUES (60493, 198, 2468, 4, 14, 256, 120);
INSERT INTO public.who_global_data VALUES (60494, 0, 16, 0, 0, 256, 135);
INSERT INTO public.who_global_data VALUES (60495, 272, 15073, 2, 460, 256, 206);
INSERT INTO public.who_global_data VALUES (60496, 599, 37355, 95, 3203, 256, 189);
INSERT INTO public.who_global_data VALUES (60497, 702, 17967, 19, 783, 256, 129);
INSERT INTO public.who_global_data VALUES (60498, 68, 1983, 0, 35, 256, 121);
INSERT INTO public.who_global_data VALUES (60499, 0, 1043, 0, 12, 256, 59);
INSERT INTO public.who_global_data VALUES (60500, 0, 39, 0, 0, 256, 96);
INSERT INTO public.who_global_data VALUES (60501, 1, 1824, 0, 63, 256, 41);
INSERT INTO public.who_global_data VALUES (60502, 6, 256, 0, 2, 256, 216);
INSERT INTO public.who_global_data VALUES (60503, 73, 655, 0, 5, 256, 236);
INSERT INTO public.who_global_data VALUES (60504, 0, 13, 0, 0, 256, 150);
INSERT INTO public.who_global_data VALUES (60505, 0, 187, 0, 0, 256, 61);
INSERT INTO public.who_global_data VALUES (60506, 0, 18, 0, 0, 256, 7);
INSERT INTO public.who_global_data VALUES (60507, 20, 6599, 1, 308, 256, 169);
INSERT INTO public.who_global_data VALUES (60508, 278, 142482, 64, 28379, 256, 28);
INSERT INTO public.who_global_data VALUES (60509, 49, 328, 0, 1, 256, 85);
INSERT INTO public.who_global_data VALUES (60510, 0, 60, 0, 0, 256, 211);
INSERT INTO public.who_global_data VALUES (60511, 201, 2135, 2, 14, 256, 60);
INSERT INTO public.who_global_data VALUES (60512, 0, 25, 0, 1, 256, 3);
INSERT INTO public.who_global_data VALUES (60513, 1, 732, 0, 12, 256, 11);
INSERT INTO public.who_global_data VALUES (60514, 432, 179002, 45, 8302, 256, 89);
INSERT INTO public.who_global_data VALUES (60515, 125, 6808, 0, 32, 256, 24);
INSERT INTO public.who_global_data VALUES (60516, 0, 154, 0, 0, 256, 162);
INSERT INTO public.who_global_data VALUES (60517, 4, 2882, 1, 172, 256, 100);
INSERT INTO public.who_global_data VALUES (60518, 1, 12, 0, 0, 256, 47);
INSERT INTO public.who_global_data VALUES (60519, 0, 22, 0, 0, 256, 29);
INSERT INTO public.who_global_data VALUES (60520, 5, 161, 1, 14, 256, 40);
INSERT INTO public.who_global_data VALUES (60521, 0, 161, 0, 5, 256, 222);
INSERT INTO public.who_global_data VALUES (60522, 370, 3424, 1, 58, 256, 132);
INSERT INTO public.who_global_data VALUES (60523, 0, 252, 0, 13, 256, 130);
INSERT INTO public.who_global_data VALUES (60524, 47, 3322, 0, 20, 256, 234);
INSERT INTO public.who_global_data VALUES (60525, 0, 1173, 0, 6, 256, 23);
INSERT INTO public.who_global_data VALUES (60526, 8, 135, 0, 10, 256, 192);
INSERT INTO public.who_global_data VALUES (60527, 93, 958, 1, 27, 256, 69);
INSERT INTO public.who_global_data VALUES (60528, 0, 12, 0, 0, 256, 187);
INSERT INTO public.who_global_data VALUES (60529, 207, 3950, 6, 180, 256, 230);
INSERT INTO public.who_global_data VALUES (60530, 15, 3771, 8, 499, 256, 77);
INSERT INTO public.who_global_data VALUES (60531, 0, 1804, 0, 10, 256, 9);
INSERT INTO public.who_global_data VALUES (60532, 6535, 145380, 146, 4167, 256, 74);
INSERT INTO public.who_global_data VALUES (60533, 415, 23165, 27, 1418, 256, 224);
INSERT INTO public.who_global_data VALUES (60534, 2023, 137724, 34, 7451, 256, 199);
INSERT INTO public.who_global_data VALUES (60535, 163, 4632, 3, 163, 256, 190);
INSERT INTO public.who_global_data VALUES (60536, 59, 24698, 0, 1606, 256, 12);
INSERT INTO public.who_global_data VALUES (60537, 0, 336, 0, 24, 256, 104);
INSERT INTO public.who_global_data VALUES (60538, 13, 16667, 1, 282, 256, 153);
INSERT INTO public.who_global_data VALUES (60539, 300, 230158, 92, 32877, 256, 91);
INSERT INTO public.who_global_data VALUES (60540, 2, 552, 0, 9, 256, 215);
INSERT INTO public.who_global_data VALUES (60541, 42, 16623, 16, 846, 256, 84);
INSERT INTO public.who_global_data VALUES (60542, 0, 306, 0, 29, 256, 231);
INSERT INTO public.who_global_data VALUES (60543, 3, 709, 0, 9, 256, 196);
INSERT INTO public.who_global_data VALUES (60544, 335, 9304, 2, 37, 256, 105);
INSERT INTO public.who_global_data VALUES (60545, 72, 1286, 1, 52, 256, 122);
INSERT INTO public.who_global_data VALUES (60546, 0, 0, 0, 0, 256, 159);
INSERT INTO public.who_global_data VALUES (60547, 6, 1038, 0, 21, 256, 75);
INSERT INTO public.who_global_data VALUES (60548, 665, 21967, 9, 165, 256, 27);
INSERT INTO public.who_global_data VALUES (60549, 35, 1468, 0, 16, 256, 54);
INSERT INTO public.who_global_data VALUES (60550, 0, 19, 0, 0, 256, 226);
INSERT INTO public.who_global_data VALUES (60551, 2, 1049, 0, 22, 256, 79);
INSERT INTO public.who_global_data VALUES (60552, 5, 1119, 0, 26, 256, 56);
INSERT INTO public.who_global_data VALUES (60553, 0, 2, 0, 0, 256, 117);
INSERT INTO public.who_global_data VALUES (60554, 0, 265, 0, 26, 256, 152);
INSERT INTO public.who_global_data VALUES (60555, 0, 75, 0, 3, 256, 16);
INSERT INTO public.who_global_data VALUES (60556, 0, 83, 0, 1, 256, 10);
INSERT INTO public.who_global_data VALUES (60557, 4, 1632, 1, 66, 256, 201);
INSERT INTO public.who_global_data VALUES (60558, 1, 3993, 0, 110, 256, 174);
INSERT INTO public.who_global_data VALUES (60559, 15, 542, 0, 2, 256, 119);
INSERT INTO public.who_global_data VALUES (60560, 18, 101, 0, 4, 256, 168);
INSERT INTO public.who_global_data VALUES (60561, 172, 7417, 0, 115, 256, 99);
INSERT INTO public.who_global_data VALUES (60562, 0, 1395, 0, 4, 256, 171);
INSERT INTO public.who_global_data VALUES (60563, 29, 1059, 2, 67, 256, 87);
INSERT INTO public.who_global_data VALUES (60564, 0, 610, 0, 6, 256, 123);
INSERT INTO public.who_global_data VALUES (60565, 0, 0, 0, 0, 256, 151);
INSERT INTO public.who_global_data VALUES (60566, 0, 197, 0, 14, 256, 213);
INSERT INTO public.who_global_data VALUES (60567, 25, 262, 3, 9, 256, 118);
INSERT INTO public.who_global_data VALUES (60568, 0, 334, 0, 10, 256, 134);
INSERT INTO public.who_global_data VALUES (60569, 22, 1609, 0, 20, 256, 65);
INSERT INTO public.who_global_data VALUES (60570, 2764, 68620, 215, 7394, 256, 102);
INSERT INTO public.who_global_data VALUES (60571, 0, 0, 0, 0, 256, 223);
INSERT INTO public.who_global_data VALUES (60572, 0, 70, 0, 1, 256, 4);
INSERT INTO public.who_global_data VALUES (60573, 0, 141, 0, 0, 256, 146);
INSERT INTO public.who_global_data VALUES (60574, 0, 324, 0, 9, 256, 31);
INSERT INTO public.who_global_data VALUES (60575, 0, 11, 0, 1, 256, 127);
INSERT INTO public.who_global_data VALUES (60576, 99, 7532, 1, 200, 256, 22);
INSERT INTO public.who_global_data VALUES (60577, 15, 209, 1, 1, 256, 115);
INSERT INTO public.who_global_data VALUES (60578, 5, 206, 0, 6, 256, 106);
INSERT INTO public.who_global_data VALUES (60579, 0, 21, 0, 0, 256, 90);
INSERT INTO public.who_global_data VALUES (60580, 0, 0, 0, 0, 256, 70);
INSERT INTO public.who_global_data VALUES (60581, 90, 772, 0, 4, 256, 46);
INSERT INTO public.who_global_data VALUES (60582, 213, 45209, 9, 5804, 256, 139);
INSERT INTO public.who_global_data VALUES (60583, 0, 18, 0, 0, 256, 42);
INSERT INTO public.who_global_data VALUES (60584, 0, 1154, 0, 21, 256, 80);
INSERT INTO public.who_global_data VALUES (60585, 0, 279, 0, 17, 256, 203);
INSERT INTO public.who_global_data VALUES (60586, 6, 951, 1, 62, 256, 136);
INSERT INTO public.who_global_data VALUES (60587, 229, 8068, 7, 233, 256, 63);
INSERT INTO public.who_global_data VALUES (60588, 0, 0, 0, 0, 256, 17);
INSERT INTO public.who_global_data VALUES (60589, 0, 22, 0, 2, 256, 172);
INSERT INTO public.who_global_data VALUES (60590, 21, 1999, 0, 113, 256, 109);
INSERT INTO public.who_global_data VALUES (60591, 43, 8352, 0, 235, 256, 200);
INSERT INTO public.who_global_data VALUES (60592, 0, 602, 0, 5, 256, 93);
INSERT INTO public.who_global_data VALUES (60593, 0, 7770, 0, 37, 256, 5);
INSERT INTO public.who_global_data VALUES (60594, 0, 741, 0, 13, 256, 214);
INSERT INTO public.who_global_data VALUES (60595, 1356, 57705, 30, 1197, 256, 204);
INSERT INTO public.who_global_data VALUES (60596, 0, 0, 0, 0, 256, 198);
INSERT INTO public.who_global_data VALUES (60597, 349, 10926, 7, 306, 256, 173);
INSERT INTO public.who_global_data VALUES (60598, 0, 8, 0, 0, 256, 229);
INSERT INTO public.who_global_data VALUES (60599, 3, 865, 0, 11, 256, 76);
INSERT INTO public.who_global_data VALUES (60600, 4205, 119959, 83, 3456, 256, 138);
INSERT INTO public.who_global_data VALUES (60601, 284, 14319, 5, 873, 256, 98);
INSERT INTO public.who_global_data VALUES (60602, 0, 0, 0, 0, 256, 103);
INSERT INTO public.who_global_data VALUES (60603, 305, 21631, 11, 1007, 256, 225);
INSERT INTO public.who_global_data VALUES (60604, 165, 30788, 14, 1330, 256, 131);
INSERT INTO public.who_global_data VALUES (60605, 71, 3260, 2, 129, 256, 235);
INSERT INTO public.who_global_data VALUES (60606, 1751, 45465, 3, 26, 256, 137);
INSERT INTO public.who_global_data VALUES (60607, 19, 11225, 2, 269, 256, 81);
INSERT INTO public.who_global_data VALUES (60608, 56, 7149, 9, 265, 256, 182);
INSERT INTO public.who_global_data VALUES (60609, 4, 456, 0, 1, 256, 145);
INSERT INTO public.who_global_data VALUES (60610, 213, 18283, 18, 1197, 256, 26);
INSERT INTO public.who_global_data VALUES (60611, 8915, 362342, 174, 3807, 256, 170);
INSERT INTO public.who_global_data VALUES (60612, 9, 336, 0, 0, 256, 191);
INSERT INTO public.who_global_data VALUES (60613, 1, 3, 0, 0, 256, 221);
INSERT INTO public.who_global_data VALUES (60614, 0, 6, 0, 0, 256, 64);
INSERT INTO public.who_global_data VALUES (60615, 0, 0, 0, 0, 256, 116);
INSERT INTO public.who_global_data VALUES (60616, 0, 15, 0, 0, 256, 128);
INSERT INTO public.who_global_data VALUES (60617, 0, 18, 0, 0, 256, 6);
INSERT INTO public.who_global_data VALUES (60618, 0, 39, 0, 3, 256, 227);
INSERT INTO public.who_global_data VALUES (60619, 0, 1, 0, 0, 256, 68);
INSERT INTO public.who_global_data VALUES (60620, 0, 18, 0, 0, 256, 184);
INSERT INTO public.who_global_data VALUES (60621, 0, 0, 0, 0, 256, 82);
INSERT INTO public.who_global_data VALUES (60622, 0, 672, 0, 42, 256, 149);
INSERT INTO public.who_global_data VALUES (60623, -9, 165, 1, 10, 256, 197);
INSERT INTO public.who_global_data VALUES (60624, 2235, 74795, 9, 399, 256, 78);
INSERT INTO public.who_global_data VALUES (60625, 83, 3130, 0, 35, 256, 233);
INSERT INTO public.who_global_data VALUES (60626, 34, 11193, 1, 239, 256, 133);
INSERT INTO public.who_global_data VALUES (60627, 0, 11, 0, 0, 256, 35);
INSERT INTO public.who_global_data VALUES (60628, 14, 735, 2, 42, 256, 114);
INSERT INTO public.who_global_data VALUES (60629, 344, 31960, 0, 23, 256, 237);
INSERT INTO public.who_global_data VALUES (60630, 0, 2, 0, 0, 256, 55);
INSERT INTO public.who_global_data VALUES (60631, 0, 78, 0, 15, 256, 176);
INSERT INTO public.who_global_data VALUES (60632, 2, 1511, 0, 28, 256, 202);
INSERT INTO public.who_global_data VALUES (60633, 0, 1469, 0, 113, 256, 155);
INSERT INTO public.who_global_data VALUES (60634, 0, 0, 0, 0, 256, 32);
INSERT INTO public.who_global_data VALUES (60635, 95, 1689, 5, 66, 256, 220);
INSERT INTO public.who_global_data VALUES (60636, 1032, 23615, 52, 481, 256, 30);
INSERT INTO public.who_global_data VALUES (60637, 0, 655, 0, 8, 256, 147);
INSERT INTO public.who_global_data VALUES (60638, 306, 243073, 55, 28829, 256, 208);
INSERT INTO public.who_global_data VALUES (60639, 96, 1278, 1, 10, 256, 45);
INSERT INTO public.who_global_data VALUES (60640, 150, 3976, 5, 170, 256, 110);
INSERT INTO public.who_global_data VALUES (60641, 0, 11, 0, 1, 256, 88);
INSERT INTO public.who_global_data VALUES (60642, 210, 34377, 44, 4389, 256, 51);
INSERT INTO public.who_global_data VALUES (60643, 15, 30731, 2, 1712, 256, 209);
INSERT INTO public.who_global_data VALUES (60644, 20, 106, 0, 4, 256, 205);
INSERT INTO public.who_global_data VALUES (60645, 171, 3100, 0, 46, 256, 18);
INSERT INTO public.who_global_data VALUES (60646, 3, 3045, 0, 57, 256, 72);
INSERT INTO public.who_global_data VALUES (60647, 1364, 245976, 104, 36061, 256, 44);
INSERT INTO public.who_global_data VALUES (60648, 0, 24, 0, 0, 256, 15);
INSERT INTO public.who_global_data VALUES (60649, 5, 386, 1, 13, 256, 25);
INSERT INTO public.who_global_data VALUES (60650, 0, 0, 0, 0, 256, 179);
INSERT INTO public.who_global_data VALUES (60651, 0, 0, 0, 0, 256, 34);
INSERT INTO public.who_global_data VALUES (60652, 0, 116, 0, 8, 256, 207);
INSERT INTO public.who_global_data VALUES (60653, 0, 1051, 0, 48, 256, 166);
INSERT INTO public.who_global_data VALUES (60654, 987, 157814, 29, 4369, 256, 126);
INSERT INTO public.who_global_data VALUES (60655, 0, 0, 0, 0, 256, 97);
INSERT INTO public.who_global_data VALUES (60656, 0, 12, 0, 1, 256, 36);
INSERT INTO public.who_global_data VALUES (60657, 0, 0, 0, 0, 256, 125);
INSERT INTO public.who_global_data VALUES (60658, 0, 304, 0, 0, 256, 124);
INSERT INTO public.who_global_data VALUES (60659, 339, 21584, 21, 644, 256, 185);
INSERT INTO public.who_global_data VALUES (60660, 822, 30307, 3, 248, 256, 194);
INSERT INTO public.who_global_data VALUES (60661, 0, 509, 0, 21, 256, 144);
INSERT INTO public.who_global_data VALUES (60662, 15253, 1634010, 620, 97529, 256, 19);
INSERT INTO public.who_global_data VALUES (60663, 0, 69, 0, 6, 256, 217);
INSERT INTO public.who_global_data VALUES (60664, 5, 769, 0, 22, 256, 148);
INSERT INTO public.who_global_data VALUES (60665, 81, 3261, 0, 13, 256, 86);
INSERT INTO public.who_global_data VALUES (60666, 0, 0, 0, 0, 256, 13);
INSERT INTO public.who_global_data VALUES (60667, 111, 1121, 0, 10, 256, 157);
INSERT INTO public.who_global_data VALUES (60668, 1, 326, 0, 0, 256, 8);
INSERT INTO public.who_global_data VALUES (60669, 0, 0, 0, 0, 256, 73);
INSERT INTO public.who_global_data VALUES (60670, 11, 233, 2, 44, 256, 101);
INSERT INTO public.who_global_data VALUES (60671, 0, 920, 0, 7, 256, 165);
INSERT INTO public.who_global_data VALUES (60672, 0, 56, 0, 4, 256, 14);
INSERT INTO public.who_global_data VALUES (60673, 512, 11180, 1, 223, 257, 193);
INSERT INTO public.who_global_data VALUES (60674, 15, 966, 0, 31, 257, 113);
INSERT INTO public.who_global_data VALUES (60675, 193, 8306, 8, 600, 257, 143);
INSERT INTO public.who_global_data VALUES (60676, 0, 0, 0, 0, 257, 219);
INSERT INTO public.who_global_data VALUES (60677, 0, 763, 0, 51, 257, 186);
INSERT INTO public.who_global_data VALUES (60678, 9, 69, 1, 4, 257, 52);
INSERT INTO public.who_global_data VALUES (60679, 0, 3, 0, 0, 257, 180);
INSERT INTO public.who_global_data VALUES (60680, 0, 25, 0, 3, 257, 167);
INSERT INTO public.who_global_data VALUES (60681, 704, 11353, 6, 445, 257, 154);
INSERT INTO public.who_global_data VALUES (60682, 359, 6637, 4, 81, 257, 94);
INSERT INTO public.who_global_data VALUES (60683, 0, 101, 0, 3, 257, 66);
INSERT INTO public.who_global_data VALUES (60684, 3, 7109, 0, 102, 257, 58);
INSERT INTO public.who_global_data VALUES (60685, 32, 16439, 1, 640, 257, 163);
INSERT INTO public.who_global_data VALUES (60686, 140, 4122, 0, 49, 257, 37);
INSERT INTO public.who_global_data VALUES (60687, 3, 100, 0, 11, 257, 142);
INSERT INTO public.who_global_data VALUES (60688, 336, 9138, 0, 13, 257, 83);
INSERT INTO public.who_global_data VALUES (60689, 1975, 35585, 21, 501, 257, 228);
INSERT INTO public.who_global_data VALUES (60690, 2, 92, 0, 7, 257, 188);
INSERT INTO public.who_global_data VALUES (60691, 954, 36198, 5, 199, 257, 62);
INSERT INTO public.who_global_data VALUES (60692, 75, 57920, 33, 9204, 257, 160);
INSERT INTO public.who_global_data VALUES (60693, 0, 18, 0, 2, 257, 50);
INSERT INTO public.who_global_data VALUES (60694, 56, 191, 0, 3, 257, 33);
INSERT INTO public.who_global_data VALUES (60695, 5, 133, 0, 9, 257, 183);
INSERT INTO public.who_global_data VALUES (60696, 3, 27, 0, 0, 257, 92);
INSERT INTO public.who_global_data VALUES (60697, 336, 5915, 10, 240, 257, 158);
INSERT INTO public.who_global_data VALUES (60698, 0, 2, 0, 0, 257, 67);
INSERT INTO public.who_global_data VALUES (60699, 20, 2391, 1, 141, 257, 57);
INSERT INTO public.who_global_data VALUES (60700, 6, 35, 0, 1, 257, 38);
INSERT INTO public.who_global_data VALUES (60701, 16508, 347398, 965, 22013, 257, 141);
INSERT INTO public.who_global_data VALUES (60702, 0, 8, 0, 1, 257, 178);
INSERT INTO public.who_global_data VALUES (60703, 0, 141, 0, 1, 257, 108);
INSERT INTO public.who_global_data VALUES (60704, 25, 2433, 4, 130, 257, 39);
INSERT INTO public.who_global_data VALUES (60705, 1, 832, 0, 52, 257, 2);
INSERT INTO public.who_global_data VALUES (60706, 0, 42, 0, 1, 257, 195);
INSERT INTO public.who_global_data VALUES (60707, 9, 380, 0, 3, 257, 107);
INSERT INTO public.who_global_data VALUES (60708, 0, 124, 0, 0, 257, 161);
INSERT INTO public.who_global_data VALUES (60709, 0, 4400, 0, 159, 257, 212);
INSERT INTO public.who_global_data VALUES (60710, 1189, 84081, 103, 6380, 257, 181);
INSERT INTO public.who_global_data VALUES (60711, 0, 129, 0, 1, 257, 53);
INSERT INTO public.who_global_data VALUES (60712, 52, 604, 0, 1, 257, 164);
INSERT INTO public.who_global_data VALUES (60713, 27, 675, 0, 60, 257, 140);
INSERT INTO public.who_global_data VALUES (60714, 3709, 69102, 45, 718, 257, 20);
INSERT INTO public.who_global_data VALUES (60715, 11, 84536, 0, 4645, 257, 112);
INSERT INTO public.who_global_data VALUES (60716, 1046, 20177, 23, 705, 257, 111);
INSERT INTO public.who_global_data VALUES (60717, 9, 43, 0, 1, 257, 71);
INSERT INTO public.who_global_data VALUES (60718, 0, 487, 0, 16, 257, 218);
INSERT INTO public.who_global_data VALUES (60719, 0, 0, 0, 0, 257, 43);
INSERT INTO public.who_global_data VALUES (60720, 7, 918, 0, 10, 257, 49);
INSERT INTO public.who_global_data VALUES (60721, 10, 2376, 0, 30, 257, 1);
INSERT INTO public.who_global_data VALUES (60722, 1, 2244, 0, 99, 257, 48);
INSERT INTO public.who_global_data VALUES (60723, 10, 1941, 1, 82, 257, 232);
INSERT INTO public.who_global_data VALUES (60724, 1, 17, 0, 1, 257, 175);
INSERT INTO public.who_global_data VALUES (60725, 8, 935, 0, 17, 257, 21);
INSERT INTO public.who_global_data VALUES (60726, 67, 8957, 1, 315, 257, 156);
INSERT INTO public.who_global_data VALUES (60727, 0, 0, 0, 0, 257, 95);
INSERT INTO public.who_global_data VALUES (60728, 0, 2140, 0, 62, 257, 177);
INSERT INTO public.who_global_data VALUES (60729, 71, 11360, 1, 562, 257, 210);
INSERT INTO public.who_global_data VALUES (60730, 0, 2270, 0, 10, 257, 120);
INSERT INTO public.who_global_data VALUES (60731, 0, 16, 0, 0, 257, 135);
INSERT INTO public.who_global_data VALUES (60732, 379, 14801, 0, 458, 257, 206);
INSERT INTO public.who_global_data VALUES (60733, 498, 36756, 12, 3108, 257, 189);
INSERT INTO public.who_global_data VALUES (60734, 752, 17265, 29, 764, 257, 129);
INSERT INTO public.who_global_data VALUES (60735, 96, 1915, 2, 35, 257, 121);
INSERT INTO public.who_global_data VALUES (60736, 0, 1043, 0, 12, 257, 59);
INSERT INTO public.who_global_data VALUES (60737, 0, 39, 0, 0, 257, 96);
INSERT INTO public.who_global_data VALUES (60738, 2, 1823, 0, 63, 257, 41);
INSERT INTO public.who_global_data VALUES (60739, 12, 250, 0, 2, 257, 216);
INSERT INTO public.who_global_data VALUES (60740, 88, 582, 0, 5, 257, 236);
INSERT INTO public.who_global_data VALUES (60741, 0, 13, 0, 0, 257, 150);
INSERT INTO public.who_global_data VALUES (60742, 0, 187, 0, 0, 257, 61);
INSERT INTO public.who_global_data VALUES (60743, 0, 18, 0, 0, 257, 7);
INSERT INTO public.who_global_data VALUES (60744, 11, 6579, 1, 307, 257, 169);
INSERT INTO public.who_global_data VALUES (60745, 31, 142204, 34, 28315, 257, 28);
INSERT INTO public.who_global_data VALUES (60746, 18, 279, 0, 1, 257, 85);
INSERT INTO public.who_global_data VALUES (60747, 0, 60, 0, 0, 257, 211);
INSERT INTO public.who_global_data VALUES (60748, 0, 1934, 0, 12, 257, 60);
INSERT INTO public.who_global_data VALUES (60749, 0, 25, 0, 1, 257, 3);
INSERT INTO public.who_global_data VALUES (60750, 1, 731, 0, 12, 257, 11);
INSERT INTO public.who_global_data VALUES (60751, 289, 178570, 10, 8257, 257, 89);
INSERT INTO public.who_global_data VALUES (60752, 66, 6683, 1, 32, 257, 24);
INSERT INTO public.who_global_data VALUES (60753, 3, 154, 0, 0, 257, 162);
INSERT INTO public.who_global_data VALUES (60754, 2, 2878, 0, 171, 257, 100);
INSERT INTO public.who_global_data VALUES (60755, 0, 11, 0, 0, 257, 47);
INSERT INTO public.who_global_data VALUES (60756, 0, 22, 0, 0, 257, 29);
INSERT INTO public.who_global_data VALUES (60757, 0, 156, 0, 13, 257, 40);
INSERT INTO public.who_global_data VALUES (60758, 0, 161, 0, 5, 257, 222);
INSERT INTO public.who_global_data VALUES (60759, 311, 3054, 4, 57, 257, 132);
INSERT INTO public.who_global_data VALUES (60760, 0, 252, 0, 13, 257, 130);
INSERT INTO public.who_global_data VALUES (60761, 99, 3275, 0, 20, 257, 234);
INSERT INTO public.who_global_data VALUES (60762, 59, 1173, 0, 6, 257, 23);
INSERT INTO public.who_global_data VALUES (60763, 0, 127, 0, 10, 257, 192);
INSERT INTO public.who_global_data VALUES (60764, 53, 865, 1, 26, 257, 69);
INSERT INTO public.who_global_data VALUES (60765, 0, 12, 0, 0, 257, 187);
INSERT INTO public.who_global_data VALUES (60766, 266, 3743, 7, 174, 257, 230);
INSERT INTO public.who_global_data VALUES (60767, 15, 3756, 5, 491, 257, 77);
INSERT INTO public.who_global_data VALUES (60768, 0, 1804, 0, 10, 257, 9);
INSERT INTO public.who_global_data VALUES (60769, 6977, 138845, 154, 4021, 257, 74);
INSERT INTO public.who_global_data VALUES (60770, 479, 22750, 19, 1391, 257, 224);
INSERT INTO public.who_global_data VALUES (60771, 2180, 135701, 58, 7417, 257, 199);
INSERT INTO public.who_global_data VALUES (60772, 197, 4469, 8, 160, 257, 190);
INSERT INTO public.who_global_data VALUES (60773, 57, 24639, 2, 1606, 257, 12);
INSERT INTO public.who_global_data VALUES (60774, 0, 336, 0, 24, 257, 104);
INSERT INTO public.who_global_data VALUES (60775, 5, 16654, 0, 281, 257, 153);
INSERT INTO public.who_global_data VALUES (60776, 531, 229858, 50, 32785, 257, 91);
INSERT INTO public.who_global_data VALUES (60777, 6, 550, 0, 9, 257, 215);
INSERT INTO public.who_global_data VALUES (60778, 31, 16581, 10, 830, 257, 84);
INSERT INTO public.who_global_data VALUES (60779, 0, 306, 0, 29, 257, 231);
INSERT INTO public.who_global_data VALUES (60780, 4, 706, 0, 9, 257, 196);
INSERT INTO public.who_global_data VALUES (60781, 438, 8969, 0, 35, 257, 105);
INSERT INTO public.who_global_data VALUES (60782, 22, 1214, 1, 51, 257, 122);
INSERT INTO public.who_global_data VALUES (60783, 0, 0, 0, 0, 257, 159);
INSERT INTO public.who_global_data VALUES (60784, 7, 1032, 1, 21, 257, 75);
INSERT INTO public.who_global_data VALUES (60785, 838, 21302, 8, 156, 257, 27);
INSERT INTO public.who_global_data VALUES (60786, 30, 1433, 2, 16, 257, 54);
INSERT INTO public.who_global_data VALUES (60787, 0, 19, 0, 0, 257, 226);
INSERT INTO public.who_global_data VALUES (60788, 1, 1047, 0, 22, 257, 79);
INSERT INTO public.who_global_data VALUES (60789, 17, 1114, 0, 26, 257, 56);
INSERT INTO public.who_global_data VALUES (60790, 0, 2, 0, 0, 257, 117);
INSERT INTO public.who_global_data VALUES (60791, 10, 265, 0, 26, 257, 152);
INSERT INTO public.who_global_data VALUES (60792, 0, 75, 0, 3, 257, 16);
INSERT INTO public.who_global_data VALUES (60793, 0, 83, 0, 1, 257, 10);
INSERT INTO public.who_global_data VALUES (60794, 10, 1628, 1, 65, 257, 201);
INSERT INTO public.who_global_data VALUES (60795, 2, 3992, 1, 110, 257, 174);
INSERT INTO public.who_global_data VALUES (60796, 39, 527, 0, 2, 257, 119);
INSERT INTO public.who_global_data VALUES (60797, 0, 83, 0, 4, 257, 168);
INSERT INTO public.who_global_data VALUES (60798, 60, 7245, 0, 115, 257, 99);
INSERT INTO public.who_global_data VALUES (60799, 82, 1395, 0, 4, 257, 171);
INSERT INTO public.who_global_data VALUES (60800, 15, 1030, 3, 65, 257, 87);
INSERT INTO public.who_global_data VALUES (60801, 1, 610, 0, 6, 257, 123);
INSERT INTO public.who_global_data VALUES (60802, 0, 0, 0, 0, 257, 151);
INSERT INTO public.who_global_data VALUES (60803, 0, 197, 0, 14, 257, 213);
INSERT INTO public.who_global_data VALUES (60804, 10, 237, 0, 6, 257, 118);
INSERT INTO public.who_global_data VALUES (60805, 2, 334, 0, 10, 257, 134);
INSERT INTO public.who_global_data VALUES (60806, 66, 1587, 1, 20, 257, 65);
INSERT INTO public.who_global_data VALUES (60807, 3329, 65856, 190, 7179, 257, 102);
INSERT INTO public.who_global_data VALUES (60808, 0, 0, 0, 0, 257, 223);
INSERT INTO public.who_global_data VALUES (60809, 2, 70, 0, 1, 257, 4);
INSERT INTO public.who_global_data VALUES (60810, 0, 141, 0, 0, 257, 146);
INSERT INTO public.who_global_data VALUES (60811, 0, 324, 0, 9, 257, 31);
INSERT INTO public.who_global_data VALUES (60812, 0, 11, 0, 1, 257, 127);
INSERT INTO public.who_global_data VALUES (60813, 27, 7433, 1, 199, 257, 22);
INSERT INTO public.who_global_data VALUES (60814, 26, 194, 0, 0, 257, 115);
INSERT INTO public.who_global_data VALUES (60815, 0, 201, 0, 6, 257, 106);
INSERT INTO public.who_global_data VALUES (60816, 1, 21, 0, 0, 257, 90);
INSERT INTO public.who_global_data VALUES (60817, 0, 0, 0, 0, 257, 70);
INSERT INTO public.who_global_data VALUES (60818, 79, 682, 1, 4, 257, 46);
INSERT INTO public.who_global_data VALUES (60819, 173, 44996, 11, 5795, 257, 139);
INSERT INTO public.who_global_data VALUES (60820, 0, 18, 0, 0, 257, 42);
INSERT INTO public.who_global_data VALUES (60821, 0, 1154, 0, 21, 257, 80);
INSERT INTO public.who_global_data VALUES (60822, 0, 279, 0, 17, 257, 203);
INSERT INTO public.who_global_data VALUES (60823, 2, 945, 0, 61, 257, 136);
INSERT INTO public.who_global_data VALUES (60824, 313, 7839, 5, 226, 257, 63);
INSERT INTO public.who_global_data VALUES (60825, 0, 0, 0, 0, 257, 17);
INSERT INTO public.who_global_data VALUES (60826, 0, 22, 0, 2, 257, 172);
INSERT INTO public.who_global_data VALUES (60827, 37, 1978, 0, 113, 257, 109);
INSERT INTO public.who_global_data VALUES (60828, 0, 8309, 0, 235, 257, 200);
INSERT INTO public.who_global_data VALUES (60829, 0, 602, 0, 5, 257, 93);
INSERT INTO public.who_global_data VALUES (60830, 513, 7770, 1, 37, 257, 5);
INSERT INTO public.who_global_data VALUES (60831, 0, 741, 0, 13, 257, 214);
INSERT INTO public.who_global_data VALUES (60832, 1748, 56349, 34, 1167, 257, 204);
INSERT INTO public.who_global_data VALUES (60833, 0, 0, 0, 0, 257, 198);
INSERT INTO public.who_global_data VALUES (60834, 310, 10577, 4, 299, 257, 173);
INSERT INTO public.who_global_data VALUES (60835, 0, 8, 0, 0, 257, 229);
INSERT INTO public.who_global_data VALUES (60836, 12, 862, 0, 11, 257, 76);
INSERT INTO public.who_global_data VALUES (60837, 4056, 115754, 129, 3373, 257, 138);
INSERT INTO public.who_global_data VALUES (60838, 258, 14035, 5, 868, 257, 98);
INSERT INTO public.who_global_data VALUES (60839, 0, 0, 0, 0, 257, 103);
INSERT INTO public.who_global_data VALUES (60840, 395, 21326, 3, 996, 257, 225);
INSERT INTO public.who_global_data VALUES (60841, 152, 30623, 14, 1316, 257, 131);
INSERT INTO public.who_global_data VALUES (60842, 89, 3189, 0, 127, 257, 235);
INSERT INTO public.who_global_data VALUES (60843, 1501, 43714, 2, 23, 257, 137);
INSERT INTO public.who_global_data VALUES (60844, 16, 11206, 1, 267, 257, 81);
INSERT INTO public.who_global_data VALUES (60845, 99, 7093, 6, 256, 257, 182);
INSERT INTO public.who_global_data VALUES (60846, 0, 452, 0, 1, 257, 145);
INSERT INTO public.who_global_data VALUES (60847, 213, 18070, 9, 1179, 257, 26);
INSERT INTO public.who_global_data VALUES (60848, 8946, 353427, 92, 3633, 257, 170);
INSERT INTO public.who_global_data VALUES (60849, 2, 327, 0, 0, 257, 191);
INSERT INTO public.who_global_data VALUES (60850, 0, 2, 0, 0, 257, 221);
INSERT INTO public.who_global_data VALUES (60851, 0, 6, 0, 0, 257, 64);
INSERT INTO public.who_global_data VALUES (60852, 0, 0, 0, 0, 257, 116);
INSERT INTO public.who_global_data VALUES (60853, 0, 15, 0, 0, 257, 128);
INSERT INTO public.who_global_data VALUES (60854, 0, 18, 0, 0, 257, 6);
INSERT INTO public.who_global_data VALUES (60855, 0, 39, 0, 3, 257, 227);
INSERT INTO public.who_global_data VALUES (60856, 0, 1, 0, 0, 257, 68);
INSERT INTO public.who_global_data VALUES (60857, 0, 18, 0, 0, 257, 184);
INSERT INTO public.who_global_data VALUES (60858, 0, 0, 0, 0, 257, 82);
INSERT INTO public.who_global_data VALUES (60859, 0, 672, 0, 42, 257, 149);
INSERT INTO public.who_global_data VALUES (60860, 0, 174, 1, 9, 257, 197);
INSERT INTO public.who_global_data VALUES (60861, 2399, 72560, 11, 390, 257, 78);
INSERT INTO public.who_global_data VALUES (60862, 71, 3047, 1, 35, 257, 233);
INSERT INTO public.who_global_data VALUES (60863, 67, 11159, 0, 238, 257, 133);
INSERT INTO public.who_global_data VALUES (60864, 0, 11, 0, 0, 257, 35);
INSERT INTO public.who_global_data VALUES (60865, 100, 721, 1, 40, 257, 114);
INSERT INTO public.who_global_data VALUES (60866, 548, 31616, 0, 23, 257, 237);
INSERT INTO public.who_global_data VALUES (60867, 0, 2, 0, 0, 257, 55);
INSERT INTO public.who_global_data VALUES (60868, 0, 78, 0, 15, 257, 176);
INSERT INTO public.who_global_data VALUES (60869, 5, 1509, 0, 28, 257, 202);
INSERT INTO public.who_global_data VALUES (60870, 1, 1469, 0, 113, 257, 155);
INSERT INTO public.who_global_data VALUES (60871, 0, 0, 0, 0, 257, 32);
INSERT INTO public.who_global_data VALUES (60872, 0, 1594, 0, 61, 257, 220);
INSERT INTO public.who_global_data VALUES (60873, 1240, 22583, 22, 429, 257, 30);
INSERT INTO public.who_global_data VALUES (60874, 92, 655, 2, 8, 257, 147);
INSERT INTO public.who_global_data VALUES (60875, 363, 242767, 59, 28774, 257, 208);
INSERT INTO public.who_global_data VALUES (60876, 64, 1182, 0, 9, 257, 45);
INSERT INTO public.who_global_data VALUES (60877, 192, 3826, 19, 165, 257, 110);
INSERT INTO public.who_global_data VALUES (60878, 0, 11, 0, 1, 257, 88);
INSERT INTO public.who_global_data VALUES (60879, 403, 34167, 55, 4345, 257, 51);
INSERT INTO public.who_global_data VALUES (60880, 10, 30716, 0, 1710, 257, 209);
INSERT INTO public.who_global_data VALUES (60881, 16, 86, 0, 4, 257, 205);
INSERT INTO public.who_global_data VALUES (60882, 191, 2929, 2, 46, 257, 18);
INSERT INTO public.who_global_data VALUES (60883, 2, 3042, 1, 57, 257, 72);
INSERT INTO public.who_global_data VALUES (60884, 1527, 244612, 379, 35957, 257, 44);
INSERT INTO public.who_global_data VALUES (60885, 0, 24, 0, 0, 257, 15);
INSERT INTO public.who_global_data VALUES (60886, 8, 381, 0, 12, 257, 25);
INSERT INTO public.who_global_data VALUES (60887, 0, 0, 0, 0, 257, 179);
INSERT INTO public.who_global_data VALUES (60888, 0, 0, 0, 0, 257, 34);
INSERT INTO public.who_global_data VALUES (60889, 0, 116, 0, 8, 257, 207);
INSERT INTO public.who_global_data VALUES (60890, 3, 1051, 0, 48, 257, 166);
INSERT INTO public.who_global_data VALUES (60891, 1141, 156827, 32, 4340, 257, 126);
INSERT INTO public.who_global_data VALUES (60892, 0, 0, 0, 0, 257, 97);
INSERT INTO public.who_global_data VALUES (60893, 0, 12, 0, 1, 257, 36);
INSERT INTO public.who_global_data VALUES (60894, 0, 0, 0, 0, 257, 125);
INSERT INTO public.who_global_data VALUES (60895, -8, 304, 0, 0, 257, 124);
INSERT INTO public.who_global_data VALUES (60896, 259, 21245, 6, 623, 257, 185);
INSERT INTO public.who_global_data VALUES (60897, 781, 29485, 1, 245, 257, 194);
INSERT INTO public.who_global_data VALUES (60898, 0, 509, 0, 21, 257, 144);
INSERT INTO public.who_global_data VALUES (60899, 26158, 1618757, 1046, 96909, 257, 19);
INSERT INTO public.who_global_data VALUES (60900, 0, 69, 0, 6, 257, 217);
INSERT INTO public.who_global_data VALUES (60901, 11, 764, 2, 22, 257, 148);
INSERT INTO public.who_global_data VALUES (60902, 48, 3180, 0, 13, 257, 86);
INSERT INTO public.who_global_data VALUES (60903, 0, 0, 0, 0, 257, 13);
INSERT INTO public.who_global_data VALUES (60904, 66, 1010, 0, 10, 257, 157);
INSERT INTO public.who_global_data VALUES (60905, 0, 325, 0, 0, 257, 8);
INSERT INTO public.who_global_data VALUES (60906, 0, 0, 0, 0, 257, 73);
INSERT INTO public.who_global_data VALUES (60907, 10, 222, 3, 42, 257, 101);
INSERT INTO public.who_global_data VALUES (60908, 0, 920, 0, 7, 257, 165);
INSERT INTO public.who_global_data VALUES (60909, 0, 56, 0, 4, 257, 14);
INSERT INTO public.who_global_data VALUES (60910, 716, 10668, 7, 222, 258, 193);
INSERT INTO public.who_global_data VALUES (60911, 8, 951, 1, 31, 258, 113);
INSERT INTO public.who_global_data VALUES (60912, 195, 8113, 10, 592, 258, 143);
INSERT INTO public.who_global_data VALUES (60913, 0, 0, 0, 0, 258, 219);
INSERT INTO public.who_global_data VALUES (60914, 1, 763, 0, 51, 258, 186);
INSERT INTO public.who_global_data VALUES (60915, 0, 60, 0, 3, 258, 52);
INSERT INTO public.who_global_data VALUES (60916, 0, 3, 0, 0, 258, 180);
INSERT INTO public.who_global_data VALUES (60917, 0, 25, 0, 3, 258, 167);
INSERT INTO public.who_global_data VALUES (60918, 718, 10649, 20, 439, 258, 154);
INSERT INTO public.who_global_data VALUES (60919, 374, 6278, 3, 77, 258, 94);
INSERT INTO public.who_global_data VALUES (60920, 0, 101, 0, 3, 258, 66);
INSERT INTO public.who_global_data VALUES (60921, 11, 7106, 1, 102, 258, 58);
INSERT INTO public.who_global_data VALUES (60922, 46, 16407, 4, 639, 258, 163);
INSERT INTO public.who_global_data VALUES (60923, 127, 3982, 3, 49, 258, 37);
INSERT INTO public.who_global_data VALUES (60924, 0, 97, 0, 11, 258, 142);
INSERT INTO public.who_global_data VALUES (60925, 388, 8802, 1, 13, 258, 83);
INSERT INTO public.who_global_data VALUES (60926, 1532, 33610, 28, 480, 258, 228);
INSERT INTO public.who_global_data VALUES (60927, 0, 90, 0, 7, 258, 188);
INSERT INTO public.who_global_data VALUES (60928, 941, 35244, 4, 194, 258, 62);
INSERT INTO public.who_global_data VALUES (60929, 123, 57845, 25, 9171, 258, 160);
INSERT INTO public.who_global_data VALUES (60930, 0, 18, 0, 2, 258, 50);
INSERT INTO public.who_global_data VALUES (60931, 0, 135, 0, 3, 258, 33);
INSERT INTO public.who_global_data VALUES (60932, 3, 128, 0, 9, 258, 183);
INSERT INTO public.who_global_data VALUES (60933, 3, 24, 0, 0, 258, 92);
INSERT INTO public.who_global_data VALUES (60934, 392, 5579, 15, 230, 258, 158);
INSERT INTO public.who_global_data VALUES (60935, 0, 2, 0, 0, 258, 67);
INSERT INTO public.who_global_data VALUES (60936, 0, 2371, 0, 140, 258, 57);
INSERT INTO public.who_global_data VALUES (60937, 0, 29, 0, 1, 258, 38);
INSERT INTO public.who_global_data VALUES (60938, 20803, 330890, 1001, 21048, 258, 141);
INSERT INTO public.who_global_data VALUES (60939, 0, 8, 0, 1, 258, 178);
INSERT INTO public.who_global_data VALUES (60940, 0, 141, 0, 1, 258, 108);
INSERT INTO public.who_global_data VALUES (60941, 0, 2408, 0, 126, 258, 39);
INSERT INTO public.who_global_data VALUES (60942, 17, 831, 0, 52, 258, 2);
INSERT INTO public.who_global_data VALUES (60943, 0, 42, 0, 1, 258, 195);
INSERT INTO public.who_global_data VALUES (60944, 9, 371, 0, 3, 258, 107);
INSERT INTO public.who_global_data VALUES (60945, 0, 124, 0, 0, 258, 161);
INSERT INTO public.who_global_data VALUES (60946, 0, 4400, 0, 159, 258, 212);
INSERT INTO public.who_global_data VALUES (60947, 1127, 82892, 97, 6277, 258, 181);
INSERT INTO public.who_global_data VALUES (60948, 8, 129, 0, 1, 258, 53);
INSERT INTO public.who_global_data VALUES (60949, 73, 552, 1, 1, 258, 164);
INSERT INTO public.who_global_data VALUES (60950, 37, 648, 1, 60, 258, 140);
INSERT INTO public.who_global_data VALUES (60951, 3536, 65393, 43, 673, 258, 20);
INSERT INTO public.who_global_data VALUES (60952, 3, 84525, 0, 4645, 258, 112);
INSERT INTO public.who_global_data VALUES (60953, 801, 19131, 30, 682, 258, 111);
INSERT INTO public.who_global_data VALUES (60954, 0, 34, 0, 1, 258, 71);
INSERT INTO public.who_global_data VALUES (60955, 18, 487, 0, 16, 258, 218);
INSERT INTO public.who_global_data VALUES (60956, 0, 0, 0, 0, 258, 43);
INSERT INTO public.who_global_data VALUES (60957, 8, 911, 0, 10, 258, 49);
INSERT INTO public.who_global_data VALUES (60958, 25, 2366, 1, 30, 258, 1);
INSERT INTO public.who_global_data VALUES (60959, 0, 2243, 0, 99, 258, 48);
INSERT INTO public.who_global_data VALUES (60960, 15, 1931, 0, 81, 258, 232);
INSERT INTO public.who_global_data VALUES (60961, 0, 16, 0, 1, 258, 175);
INSERT INTO public.who_global_data VALUES (60962, 0, 927, 0, 17, 258, 21);
INSERT INTO public.who_global_data VALUES (60963, 77, 8890, 2, 314, 258, 156);
INSERT INTO public.who_global_data VALUES (60964, 0, 0, 0, 0, 258, 95);
INSERT INTO public.who_global_data VALUES (60965, 196, 2140, 0, 62, 258, 177);
INSERT INTO public.who_global_data VALUES (60966, 59, 11289, 0, 561, 258, 210);
INSERT INTO public.who_global_data VALUES (60967, 0, 2270, 0, 10, 258, 120);
INSERT INTO public.who_global_data VALUES (60968, 0, 16, 0, 0, 258, 135);
INSERT INTO public.who_global_data VALUES (60969, 433, 14422, 2, 458, 258, 206);
INSERT INTO public.who_global_data VALUES (60970, 430, 36258, 40, 3096, 258, 189);
INSERT INTO public.who_global_data VALUES (60971, 727, 16513, 28, 735, 258, 129);
INSERT INTO public.who_global_data VALUES (60972, 94, 1819, 0, 33, 258, 121);
INSERT INTO public.who_global_data VALUES (60973, 83, 1043, 1, 12, 258, 59);
INSERT INTO public.who_global_data VALUES (60974, 0, 39, 0, 0, 258, 96);
INSERT INTO public.who_global_data VALUES (60975, 14, 1821, 0, 63, 258, 41);
INSERT INTO public.who_global_data VALUES (60976, 13, 238, 0, 2, 258, 216);
INSERT INTO public.who_global_data VALUES (60977, 61, 494, 0, 5, 258, 236);
INSERT INTO public.who_global_data VALUES (60978, 0, 13, 0, 0, 258, 150);
INSERT INTO public.who_global_data VALUES (60979, 0, 187, 0, 0, 258, 61);
INSERT INTO public.who_global_data VALUES (60980, 0, 18, 0, 0, 258, 7);
INSERT INTO public.who_global_data VALUES (60981, 31, 6568, 0, 306, 258, 169);
INSERT INTO public.who_global_data VALUES (60982, 224, 142173, 43, 28281, 258, 28);
INSERT INTO public.who_global_data VALUES (60983, 12, 261, 0, 1, 258, 85);
INSERT INTO public.who_global_data VALUES (60984, 0, 60, 0, 0, 258, 211);
INSERT INTO public.who_global_data VALUES (60985, 206, 1934, 0, 12, 258, 60);
INSERT INTO public.who_global_data VALUES (60986, 0, 25, 0, 1, 258, 3);
INSERT INTO public.who_global_data VALUES (60987, 7, 730, 0, 12, 258, 11);
INSERT INTO public.who_global_data VALUES (60988, 431, 178281, 31, 8247, 258, 89);
INSERT INTO public.who_global_data VALUES (60989, 131, 6617, 0, 31, 258, 24);
INSERT INTO public.who_global_data VALUES (60990, 0, 151, 0, 0, 258, 162);
INSERT INTO public.who_global_data VALUES (60991, 3, 2876, 2, 171, 258, 100);
INSERT INTO public.who_global_data VALUES (60992, 0, 11, 0, 0, 258, 47);
INSERT INTO public.who_global_data VALUES (60993, 0, 22, 0, 0, 258, 29);
INSERT INTO public.who_global_data VALUES (60994, 1, 156, 0, 13, 258, 40);
INSERT INTO public.who_global_data VALUES (60995, 1, 161, 0, 5, 258, 222);
INSERT INTO public.who_global_data VALUES (60996, 231, 2743, 5, 53, 258, 132);
INSERT INTO public.who_global_data VALUES (60997, 0, 252, 0, 13, 258, 130);
INSERT INTO public.who_global_data VALUES (60998, 62, 3176, 1, 20, 258, 234);
INSERT INTO public.who_global_data VALUES (60999, 0, 1114, 0, 6, 258, 23);
INSERT INTO public.who_global_data VALUES (61000, 0, 127, 0, 10, 258, 192);
INSERT INTO public.who_global_data VALUES (61001, 78, 812, 0, 25, 258, 69);
INSERT INTO public.who_global_data VALUES (61002, 0, 12, 0, 0, 258, 187);
INSERT INTO public.who_global_data VALUES (61003, 273, 3477, 11, 167, 258, 230);
INSERT INTO public.who_global_data VALUES (61004, 28, 3741, 4, 486, 258, 77);
INSERT INTO public.who_global_data VALUES (61005, 1, 1804, 0, 10, 258, 9);
INSERT INTO public.who_global_data VALUES (61006, 6767, 131868, 147, 3867, 258, 74);
INSERT INTO public.who_global_data VALUES (61007, 526, 22271, 21, 1372, 258, 224);
INSERT INTO public.who_global_data VALUES (61008, 1869, 133521, 59, 7359, 258, 199);
INSERT INTO public.who_global_data VALUES (61009, 308, 4272, 5, 152, 258, 190);
INSERT INTO public.who_global_data VALUES (61010, 76, 24582, 12, 1604, 258, 12);
INSERT INTO public.who_global_data VALUES (61011, 0, 336, 0, 24, 258, 104);
INSERT INTO public.who_global_data VALUES (61012, 19, 16649, 0, 281, 258, 153);
INSERT INTO public.who_global_data VALUES (61013, 669, 229327, 119, 32735, 258, 91);
INSERT INTO public.who_global_data VALUES (61014, 10, 544, 0, 9, 258, 215);
INSERT INTO public.who_global_data VALUES (61015, 14, 16550, 12, 820, 258, 84);
INSERT INTO public.who_global_data VALUES (61016, 0, 306, 0, 29, 258, 231);
INSERT INTO public.who_global_data VALUES (61017, 2, 702, 0, 9, 258, 196);
INSERT INTO public.who_global_data VALUES (61018, 209, 8531, 0, 35, 258, 105);
INSERT INTO public.who_global_data VALUES (61019, 31, 1192, 0, 50, 258, 122);
INSERT INTO public.who_global_data VALUES (61020, 0, 0, 0, 0, 258, 159);
INSERT INTO public.who_global_data VALUES (61021, 21, 1025, 0, 20, 258, 75);
INSERT INTO public.who_global_data VALUES (61022, 900, 20464, 10, 148, 258, 27);
INSERT INTO public.who_global_data VALUES (61023, 38, 1403, 0, 14, 258, 54);
INSERT INTO public.who_global_data VALUES (61024, 0, 19, 0, 0, 258, 226);
INSERT INTO public.who_global_data VALUES (61025, 16, 1046, 0, 22, 258, 79);
INSERT INTO public.who_global_data VALUES (61026, 11, 1097, 0, 26, 258, 56);
INSERT INTO public.who_global_data VALUES (61027, 0, 2, 0, 0, 258, 117);
INSERT INTO public.who_global_data VALUES (61028, 6, 255, 2, 26, 258, 152);
INSERT INTO public.who_global_data VALUES (61029, 3, 75, 0, 3, 258, 16);
INSERT INTO public.who_global_data VALUES (61030, 0, 83, 0, 1, 258, 10);
INSERT INTO public.who_global_data VALUES (61031, 6, 1618, 1, 64, 258, 201);
INSERT INTO public.who_global_data VALUES (61032, 9, 3990, 0, 109, 258, 174);
INSERT INTO public.who_global_data VALUES (61033, 40, 488, 0, 2, 258, 119);
INSERT INTO public.who_global_data VALUES (61034, 1, 83, 1, 4, 258, 168);
INSERT INTO public.who_global_data VALUES (61035, 48, 7185, 0, 115, 258, 99);
INSERT INTO public.who_global_data VALUES (61036, 39, 1313, 0, 4, 258, 171);
INSERT INTO public.who_global_data VALUES (61037, 46, 1015, 0, 62, 258, 87);
INSERT INTO public.who_global_data VALUES (61038, 1, 609, 0, 6, 258, 123);
INSERT INTO public.who_global_data VALUES (61039, 0, 0, 0, 0, 258, 151);
INSERT INTO public.who_global_data VALUES (61040, 0, 197, 0, 14, 258, 213);
INSERT INTO public.who_global_data VALUES (61041, 54, 227, 1, 6, 258, 118);
INSERT INTO public.who_global_data VALUES (61042, 0, 332, 0, 10, 258, 134);
INSERT INTO public.who_global_data VALUES (61043, 0, 1521, 0, 19, 258, 65);
INSERT INTO public.who_global_data VALUES (61044, 2960, 62527, 479, 6989, 258, 102);
INSERT INTO public.who_global_data VALUES (61045, 0, 0, 0, 0, 258, 223);
INSERT INTO public.who_global_data VALUES (61046, 0, 68, 0, 1, 258, 4);
INSERT INTO public.who_global_data VALUES (61047, 0, 141, 0, 0, 258, 146);
INSERT INTO public.who_global_data VALUES (61048, 0, 324, 0, 9, 258, 31);
INSERT INTO public.who_global_data VALUES (61049, 0, 11, 0, 1, 258, 127);
INSERT INTO public.who_global_data VALUES (61050, 74, 7406, 1, 198, 258, 22);
INSERT INTO public.who_global_data VALUES (61051, 4, 168, 0, 0, 258, 115);
INSERT INTO public.who_global_data VALUES (61052, 0, 201, 0, 6, 258, 106);
INSERT INTO public.who_global_data VALUES (61053, 1, 20, 0, 0, 258, 90);
INSERT INTO public.who_global_data VALUES (61054, 0, 0, 0, 0, 258, 70);
INSERT INTO public.who_global_data VALUES (61055, 19, 603, 0, 3, 258, 46);
INSERT INTO public.who_global_data VALUES (61056, 177, 44823, 23, 5784, 258, 139);
INSERT INTO public.who_global_data VALUES (61057, 0, 18, 0, 0, 258, 42);
INSERT INTO public.who_global_data VALUES (61058, 0, 1154, 0, 21, 258, 80);
INSERT INTO public.who_global_data VALUES (61059, 0, 279, 0, 17, 258, 203);
INSERT INTO public.who_global_data VALUES (61060, 6, 943, 1, 61, 258, 136);
INSERT INTO public.who_global_data VALUES (61061, 265, 7526, 0, 221, 258, 63);
INSERT INTO public.who_global_data VALUES (61062, 0, 0, 0, 0, 258, 17);
INSERT INTO public.who_global_data VALUES (61063, 0, 22, 0, 2, 258, 172);
INSERT INTO public.who_global_data VALUES (61064, 20, 1941, 1, 113, 258, 109);
INSERT INTO public.who_global_data VALUES (61065, 0, 8309, 0, 235, 258, 200);
INSERT INTO public.who_global_data VALUES (61066, 0, 602, 1, 5, 258, 93);
INSERT INTO public.who_global_data VALUES (61067, 463, 7257, 2, 36, 258, 5);
INSERT INTO public.who_global_data VALUES (61068, 0, 741, 0, 13, 258, 214);
INSERT INTO public.who_global_data VALUES (61069, 2164, 54601, 32, 1133, 258, 204);
INSERT INTO public.who_global_data VALUES (61070, 0, 0, 0, 0, 258, 198);
INSERT INTO public.who_global_data VALUES (61071, 151, 10267, 4, 295, 258, 173);
INSERT INTO public.who_global_data VALUES (61072, 0, 8, 0, 0, 258, 229);
INSERT INTO public.who_global_data VALUES (61073, 12, 850, 0, 11, 258, 76);
INSERT INTO public.who_global_data VALUES (61074, 2929, 111698, 96, 3244, 258, 138);
INSERT INTO public.who_global_data VALUES (61075, 180, 13777, 6, 863, 258, 98);
INSERT INTO public.who_global_data VALUES (61076, 0, 0, 0, 0, 258, 103);
INSERT INTO public.who_global_data VALUES (61077, 312, 20931, 11, 993, 258, 225);
INSERT INTO public.who_global_data VALUES (61078, 271, 30471, 13, 1302, 258, 131);
INSERT INTO public.who_global_data VALUES (61079, 70, 3100, 1, 127, 258, 235);
INSERT INTO public.who_global_data VALUES (61080, 1732, 42213, 2, 21, 258, 137);
INSERT INTO public.who_global_data VALUES (61081, 25, 11190, 0, 266, 258, 81);
INSERT INTO public.who_global_data VALUES (61082, 147, 6994, 12, 250, 258, 182);
INSERT INTO public.who_global_data VALUES (61083, 3, 452, 0, 1, 258, 145);
INSERT INTO public.who_global_data VALUES (61084, 145, 17857, 11, 1170, 258, 26);
INSERT INTO public.who_global_data VALUES (61085, 8599, 344481, 153, 3541, 258, 170);
INSERT INTO public.who_global_data VALUES (61086, 4, 325, 0, 0, 258, 191);
INSERT INTO public.who_global_data VALUES (61087, 0, 2, 0, 0, 258, 221);
INSERT INTO public.who_global_data VALUES (61088, 0, 6, 0, 0, 258, 64);
INSERT INTO public.who_global_data VALUES (61089, 0, 0, 0, 0, 258, 116);
INSERT INTO public.who_global_data VALUES (61090, 0, 15, 0, 0, 258, 128);
INSERT INTO public.who_global_data VALUES (61091, 0, 18, 0, 0, 258, 6);
INSERT INTO public.who_global_data VALUES (61092, 0, 39, 0, 3, 258, 227);
INSERT INTO public.who_global_data VALUES (61093, 0, 1, 0, 0, 258, 68);
INSERT INTO public.who_global_data VALUES (61094, 0, 18, 0, 0, 258, 184);
INSERT INTO public.who_global_data VALUES (61095, 0, 0, 0, 0, 258, 82);
INSERT INTO public.who_global_data VALUES (61096, 0, 672, 1, 42, 258, 149);
INSERT INTO public.who_global_data VALUES (61097, 9, 174, 0, 8, 258, 197);
INSERT INTO public.who_global_data VALUES (61098, 2442, 70161, 15, 379, 258, 78);
INSERT INTO public.who_global_data VALUES (61099, 67, 2976, 1, 34, 258, 233);
INSERT INTO public.who_global_data VALUES (61100, 68, 11092, 1, 238, 258, 133);
INSERT INTO public.who_global_data VALUES (61101, 0, 11, 0, 0, 258, 35);
INSERT INTO public.who_global_data VALUES (61102, 15, 621, 1, 39, 258, 114);
INSERT INTO public.who_global_data VALUES (61103, 642, 31068, 0, 23, 258, 237);
INSERT INTO public.who_global_data VALUES (61104, 0, 2, 0, 0, 258, 55);
INSERT INTO public.who_global_data VALUES (61105, 0, 78, 0, 15, 258, 176);
INSERT INTO public.who_global_data VALUES (61106, 1, 1504, 0, 28, 258, 202);
INSERT INTO public.who_global_data VALUES (61107, 0, 1468, 0, 113, 258, 155);
INSERT INTO public.who_global_data VALUES (61108, 0, 0, 0, 0, 258, 32);
INSERT INTO public.who_global_data VALUES (61109, 0, 1594, 0, 61, 258, 220);
INSERT INTO public.who_global_data VALUES (61110, 1218, 21343, 10, 407, 258, 30);
INSERT INTO public.who_global_data VALUES (61111, 90, 563, 1, 6, 258, 147);
INSERT INTO public.who_global_data VALUES (61112, 969, 242404, 72, 28715, 258, 208);
INSERT INTO public.who_global_data VALUES (61113, 33, 1118, 0, 9, 258, 45);
INSERT INTO public.who_global_data VALUES (61114, 256, 3634, 9, 146, 258, 110);
INSERT INTO public.who_global_data VALUES (61115, 0, 11, 0, 1, 258, 88);
INSERT INTO public.who_global_data VALUES (61116, 532, 33764, 56, 4290, 258, 51);
INSERT INTO public.who_global_data VALUES (61117, 14, 30706, 1, 1710, 258, 209);
INSERT INTO public.who_global_data VALUES (61118, 11, 70, 0, 4, 258, 205);
INSERT INTO public.who_global_data VALUES (61119, 187, 2738, 0, 44, 258, 18);
INSERT INTO public.who_global_data VALUES (61120, 0, 3040, 0, 56, 258, 72);
INSERT INTO public.who_global_data VALUES (61121, 2062, 243085, 220, 35578, 258, 44);
INSERT INTO public.who_global_data VALUES (61122, 0, 24, 0, 0, 258, 15);
INSERT INTO public.who_global_data VALUES (61123, 10, 373, 0, 12, 258, 25);
INSERT INTO public.who_global_data VALUES (61124, 0, 0, 0, 0, 258, 179);
INSERT INTO public.who_global_data VALUES (61125, 0, 0, 0, 0, 258, 34);
INSERT INTO public.who_global_data VALUES (61126, 0, 116, 0, 8, 258, 207);
INSERT INTO public.who_global_data VALUES (61127, 0, 1048, 1, 48, 258, 166);
INSERT INTO public.who_global_data VALUES (61128, 1186, 155686, 32, 4308, 258, 126);
INSERT INTO public.who_global_data VALUES (61129, 0, 0, 0, 0, 258, 97);
INSERT INTO public.who_global_data VALUES (61130, 0, 12, 0, 1, 258, 36);
INSERT INTO public.who_global_data VALUES (61131, 0, 0, 0, 0, 258, 125);
INSERT INTO public.who_global_data VALUES (61132, 38, 312, 0, 0, 258, 124);
INSERT INTO public.who_global_data VALUES (61133, 406, 20986, 12, 617, 258, 185);
INSERT INTO public.who_global_data VALUES (61134, 812, 28704, 3, 244, 258, 194);
INSERT INTO public.who_global_data VALUES (61135, 0, 509, 0, 21, 258, 144);
INSERT INTO public.who_global_data VALUES (61136, 24151, 1592599, 1852, 95863, 258, 19);
INSERT INTO public.who_global_data VALUES (61137, 0, 69, 0, 6, 258, 217);
INSERT INTO public.who_global_data VALUES (61138, 4, 753, 0, 20, 258, 148);
INSERT INTO public.who_global_data VALUES (61139, 54, 3132, 0, 13, 258, 86);
INSERT INTO public.who_global_data VALUES (61140, 0, 0, 0, 0, 258, 13);
INSERT INTO public.who_global_data VALUES (61141, 62, 944, 0, 10, 258, 157);
INSERT INTO public.who_global_data VALUES (61142, 1, 325, 0, 0, 258, 8);
INSERT INTO public.who_global_data VALUES (61143, 0, 0, 0, 0, 258, 73);
INSERT INTO public.who_global_data VALUES (61144, 7, 212, 6, 39, 258, 101);
INSERT INTO public.who_global_data VALUES (61145, 0, 920, 0, 7, 258, 165);
INSERT INTO public.who_global_data VALUES (61146, 5, 56, 0, 4, 258, 14);
INSERT INTO public.who_global_data VALUES (61147, 736, 9952, 10, 215, 259, 193);
INSERT INTO public.who_global_data VALUES (61148, 12, 943, 0, 30, 259, 113);
INSERT INTO public.who_global_data VALUES (61149, 190, 7918, 7, 582, 259, 143);
INSERT INTO public.who_global_data VALUES (61150, 0, 0, 0, 0, 259, 219);
INSERT INTO public.who_global_data VALUES (61151, 0, 762, 0, 51, 259, 186);
INSERT INTO public.who_global_data VALUES (61152, 0, 60, 0, 3, 259, 52);
INSERT INTO public.who_global_data VALUES (61153, 0, 3, 0, 0, 259, 180);
INSERT INTO public.who_global_data VALUES (61154, 0, 25, 0, 3, 259, 167);
INSERT INTO public.who_global_data VALUES (61155, 648, 9931, 16, 419, 259, 154);
INSERT INTO public.who_global_data VALUES (61156, 322, 5904, 4, 74, 259, 94);
INSERT INTO public.who_global_data VALUES (61157, 0, 101, 0, 3, 259, 66);
INSERT INTO public.who_global_data VALUES (61158, 14, 7095, 1, 101, 259, 58);
INSERT INTO public.who_global_data VALUES (61159, 29, 16361, 2, 635, 259, 163);
INSERT INTO public.who_global_data VALUES (61160, 106, 3855, 2, 46, 259, 37);
INSERT INTO public.who_global_data VALUES (61161, 0, 97, 0, 11, 259, 142);
INSERT INTO public.who_global_data VALUES (61162, 240, 8414, 0, 12, 259, 83);
INSERT INTO public.who_global_data VALUES (61163, 1873, 32078, 20, 452, 259, 228);
INSERT INTO public.who_global_data VALUES (61164, 0, 90, 0, 7, 259, 188);
INSERT INTO public.who_global_data VALUES (61165, 0, 34303, 0, 190, 259, 62);
INSERT INTO public.who_global_data VALUES (61166, 248, 57722, 41, 9146, 259, 160);
INSERT INTO public.who_global_data VALUES (61167, 0, 18, 0, 2, 259, 50);
INSERT INTO public.who_global_data VALUES (61168, 0, 135, 0, 3, 259, 33);
INSERT INTO public.who_global_data VALUES (61169, 0, 125, 0, 9, 259, 183);
INSERT INTO public.who_global_data VALUES (61170, 0, 21, 0, 0, 259, 92);
INSERT INTO public.who_global_data VALUES (61171, 268, 5187, 16, 215, 259, 158);
INSERT INTO public.who_global_data VALUES (61172, 0, 2, 0, 0, 259, 67);
INSERT INTO public.who_global_data VALUES (61173, 19, 2371, 1, 140, 259, 57);
INSERT INTO public.who_global_data VALUES (61174, 0, 29, 0, 1, 259, 38);
INSERT INTO public.who_global_data VALUES (61175, 18508, 310087, 1188, 20047, 259, 141);
INSERT INTO public.who_global_data VALUES (61176, 0, 8, 0, 1, 259, 178);
INSERT INTO public.who_global_data VALUES (61177, 0, 141, 0, 1, 259, 108);
INSERT INTO public.who_global_data VALUES (61178, 36, 2408, 1, 126, 259, 39);
INSERT INTO public.who_global_data VALUES (61179, 2, 814, 0, 52, 259, 2);
INSERT INTO public.who_global_data VALUES (61180, 0, 42, 0, 1, 259, 195);
INSERT INTO public.who_global_data VALUES (61181, 6, 362, 0, 3, 259, 107);
INSERT INTO public.who_global_data VALUES (61182, 1, 124, 0, 0, 259, 161);
INSERT INTO public.who_global_data VALUES (61183, 112, 4400, 3, 159, 259, 212);
INSERT INTO public.who_global_data VALUES (61184, 1210, 81765, 118, 6180, 259, 181);
INSERT INTO public.who_global_data VALUES (61185, 10, 121, 0, 1, 259, 53);
INSERT INTO public.who_global_data VALUES (61186, 43, 479, 0, 0, 259, 164);
INSERT INTO public.who_global_data VALUES (61187, 23, 611, 1, 59, 259, 140);
INSERT INTO public.who_global_data VALUES (61188, 8240, 61857, 86, 630, 259, 20);
INSERT INTO public.who_global_data VALUES (61189, 2, 84522, 0, 4645, 259, 112);
INSERT INTO public.who_global_data VALUES (61190, 643, 18330, 22, 652, 259, 111);
INSERT INTO public.who_global_data VALUES (61191, 0, 34, 0, 1, 259, 71);
INSERT INTO public.who_global_data VALUES (61192, 0, 469, 0, 16, 259, 218);
INSERT INTO public.who_global_data VALUES (61193, 0, 0, 0, 0, 259, 43);
INSERT INTO public.who_global_data VALUES (61194, 21, 903, 0, 10, 259, 49);
INSERT INTO public.who_global_data VALUES (61195, 40, 2341, 0, 29, 259, 1);
INSERT INTO public.who_global_data VALUES (61196, 6, 2243, 2, 99, 259, 48);
INSERT INTO public.who_global_data VALUES (61197, 8, 1916, 1, 81, 259, 232);
INSERT INTO public.who_global_data VALUES (61198, 0, 16, 0, 1, 259, 175);
INSERT INTO public.who_global_data VALUES (61199, 4, 927, 0, 17, 259, 21);
INSERT INTO public.who_global_data VALUES (61200, 59, 8813, 6, 312, 259, 156);
INSERT INTO public.who_global_data VALUES (61201, 0, 0, 0, 0, 259, 95);
INSERT INTO public.who_global_data VALUES (61202, 0, 1944, 0, 62, 259, 177);
INSERT INTO public.who_global_data VALUES (61203, 48, 11230, 0, 561, 259, 210);
INSERT INTO public.who_global_data VALUES (61204, 223, 2270, 0, 10, 259, 120);
INSERT INTO public.who_global_data VALUES (61205, 0, 16, 0, 0, 259, 135);
INSERT INTO public.who_global_data VALUES (61206, 332, 13989, 8, 456, 259, 206);
INSERT INTO public.who_global_data VALUES (61207, 974, 35828, 168, 3056, 259, 189);
INSERT INTO public.who_global_data VALUES (61208, 783, 15786, 11, 707, 259, 129);
INSERT INTO public.who_global_data VALUES (61209, 85, 1725, 1, 33, 259, 121);
INSERT INTO public.who_global_data VALUES (61210, 0, 960, 0, 11, 259, 59);
INSERT INTO public.who_global_data VALUES (61211, 0, 39, 0, 0, 259, 96);
INSERT INTO public.who_global_data VALUES (61212, 7, 1807, 0, 63, 259, 41);
INSERT INTO public.who_global_data VALUES (61213, 5, 225, 0, 2, 259, 216);
INSERT INTO public.who_global_data VALUES (61214, 34, 433, 0, 5, 259, 236);
INSERT INTO public.who_global_data VALUES (61215, 0, 13, 0, 0, 259, 150);
INSERT INTO public.who_global_data VALUES (61216, 0, 187, 0, 0, 259, 61);
INSERT INTO public.who_global_data VALUES (61217, 0, 18, 0, 0, 259, 7);
INSERT INTO public.who_global_data VALUES (61218, 44, 6537, 0, 306, 259, 169);
INSERT INTO public.who_global_data VALUES (61219, 359, 141949, 74, 28238, 259, 28);
INSERT INTO public.who_global_data VALUES (61220, 12, 249, 0, 1, 259, 85);
INSERT INTO public.who_global_data VALUES (61221, 0, 60, 0, 0, 259, 211);
INSERT INTO public.who_global_data VALUES (61222, 161, 1728, 0, 12, 259, 60);
INSERT INTO public.who_global_data VALUES (61223, 1, 25, 0, 1, 259, 3);
INSERT INTO public.who_global_data VALUES (61224, 0, 723, 0, 12, 259, 11);
INSERT INTO public.who_global_data VALUES (61225, 638, 177850, 42, 8216, 259, 89);
INSERT INTO public.who_global_data VALUES (61226, 217, 6486, 0, 31, 259, 24);
INSERT INTO public.who_global_data VALUES (61227, 2, 151, 0, 0, 259, 162);
INSERT INTO public.who_global_data VALUES (61228, 20, 2873, 1, 169, 259, 100);
INSERT INTO public.who_global_data VALUES (61229, 0, 11, 0, 0, 259, 47);
INSERT INTO public.who_global_data VALUES (61230, 0, 22, 0, 0, 259, 29);
INSERT INTO public.who_global_data VALUES (61231, 0, 155, 0, 13, 259, 40);
INSERT INTO public.who_global_data VALUES (61232, 0, 160, 0, 5, 259, 222);
INSERT INTO public.who_global_data VALUES (61233, 247, 2512, 3, 48, 259, 132);
INSERT INTO public.who_global_data VALUES (61234, 0, 252, 0, 13, 259, 130);
INSERT INTO public.who_global_data VALUES (61235, 47, 3114, 0, 19, 259, 234);
INSERT INTO public.who_global_data VALUES (61236, 5, 1114, 0, 6, 259, 23);
INSERT INTO public.who_global_data VALUES (61237, 2, 127, 0, 10, 259, 192);
INSERT INTO public.who_global_data VALUES (61238, 71, 734, 3, 25, 259, 69);
INSERT INTO public.who_global_data VALUES (61239, 0, 12, 0, 0, 259, 187);
INSERT INTO public.who_global_data VALUES (61240, 104, 3204, 5, 156, 259, 230);
INSERT INTO public.who_global_data VALUES (61241, 35, 3713, 6, 482, 259, 77);
INSERT INTO public.who_global_data VALUES (61242, 0, 1803, 0, 10, 259, 9);
INSERT INTO public.who_global_data VALUES (61243, 6654, 125101, 137, 3720, 259, 74);
INSERT INTO public.who_global_data VALUES (61244, 949, 21745, 25, 1351, 259, 224);
INSERT INTO public.who_global_data VALUES (61245, 2311, 131652, 51, 7300, 259, 199);
INSERT INTO public.who_global_data VALUES (61246, 87, 3964, 7, 147, 259, 190);
INSERT INTO public.who_global_data VALUES (61247, 115, 24506, 9, 1592, 259, 12);
INSERT INTO public.who_global_data VALUES (61248, 0, 336, 0, 24, 259, 104);
INSERT INTO public.who_global_data VALUES (61249, 17, 16630, 0, 281, 259, 153);
INSERT INTO public.who_global_data VALUES (61250, 652, 228658, 130, 32616, 259, 91);
INSERT INTO public.who_global_data VALUES (61251, 5, 534, 0, 9, 259, 215);
INSERT INTO public.who_global_data VALUES (61252, 23, 16536, 12, 808, 259, 84);
INSERT INTO public.who_global_data VALUES (61253, 0, 306, 0, 29, 259, 231);
INSERT INTO public.who_global_data VALUES (61254, 16, 700, 0, 9, 259, 196);
INSERT INTO public.who_global_data VALUES (61255, 403, 8322, 0, 35, 259, 105);
INSERT INTO public.who_global_data VALUES (61256, 52, 1161, 0, 50, 259, 122);
INSERT INTO public.who_global_data VALUES (61257, 0, 0, 0, 0, 259, 159);
INSERT INTO public.who_global_data VALUES (61258, 1, 1004, 0, 20, 259, 75);
INSERT INTO public.who_global_data VALUES (61259, 955, 19564, 9, 138, 259, 27);
INSERT INTO public.who_global_data VALUES (61260, 15, 1365, 0, 14, 259, 54);
INSERT INTO public.who_global_data VALUES (61261, 0, 19, 0, 0, 259, 226);
INSERT INTO public.who_global_data VALUES (61262, 5, 1030, 0, 22, 259, 79);
INSERT INTO public.who_global_data VALUES (61263, 62, 1086, 0, 26, 259, 56);
INSERT INTO public.who_global_data VALUES (61264, 1, 2, 0, 0, 259, 117);
INSERT INTO public.who_global_data VALUES (61265, 9, 249, 1, 24, 259, 152);
INSERT INTO public.who_global_data VALUES (61266, 1, 72, 0, 3, 259, 16);
INSERT INTO public.who_global_data VALUES (61267, 0, 83, 0, 1, 259, 10);
INSERT INTO public.who_global_data VALUES (61268, 14, 1612, 2, 63, 259, 201);
INSERT INTO public.who_global_data VALUES (61269, 1, 3981, 0, 109, 259, 174);
INSERT INTO public.who_global_data VALUES (61270, 43, 448, 0, 2, 259, 119);
INSERT INTO public.who_global_data VALUES (61271, 10, 82, 0, 3, 259, 168);
INSERT INTO public.who_global_data VALUES (61272, 78, 7137, 1, 115, 259, 99);
INSERT INTO public.who_global_data VALUES (61273, 58, 1274, 0, 4, 259, 171);
INSERT INTO public.who_global_data VALUES (61274, 38, 969, 7, 62, 259, 87);
INSERT INTO public.who_global_data VALUES (61275, 9, 608, 0, 6, 259, 123);
INSERT INTO public.who_global_data VALUES (61276, 0, 0, 0, 0, 259, 151);
INSERT INTO public.who_global_data VALUES (61277, 5, 197, 0, 14, 259, 213);
INSERT INTO public.who_global_data VALUES (61278, 0, 173, 0, 5, 259, 118);
INSERT INTO public.who_global_data VALUES (61279, 0, 332, 0, 10, 259, 134);
INSERT INTO public.who_global_data VALUES (61280, 27, 1521, 0, 19, 259, 65);
INSERT INTO public.who_global_data VALUES (61281, 2973, 59567, 420, 6510, 259, 102);
INSERT INTO public.who_global_data VALUES (61282, 0, 0, 0, 0, 259, 223);
INSERT INTO public.who_global_data VALUES (61283, 0, 68, 0, 1, 259, 4);
INSERT INTO public.who_global_data VALUES (61284, 0, 141, 0, 0, 259, 146);
INSERT INTO public.who_global_data VALUES (61285, 0, 324, 0, 9, 259, 31);
INSERT INTO public.who_global_data VALUES (61286, 0, 11, 0, 1, 259, 127);
INSERT INTO public.who_global_data VALUES (61287, 121, 7332, 1, 197, 259, 22);
INSERT INTO public.who_global_data VALUES (61288, 2, 164, 0, 0, 259, 115);
INSERT INTO public.who_global_data VALUES (61289, 2, 201, 0, 6, 259, 106);
INSERT INTO public.who_global_data VALUES (61290, 1, 19, 0, 0, 259, 90);
INSERT INTO public.who_global_data VALUES (61291, 0, 0, 0, 0, 259, 70);
INSERT INTO public.who_global_data VALUES (61292, 68, 584, 0, 3, 259, 46);
INSERT INTO public.who_global_data VALUES (61293, 184, 44646, 10, 5761, 259, 139);
INSERT INTO public.who_global_data VALUES (61294, 0, 18, 0, 0, 259, 42);
INSERT INTO public.who_global_data VALUES (61295, 0, 1154, 0, 21, 259, 80);
INSERT INTO public.who_global_data VALUES (61296, 0, 279, 0, 17, 259, 203);
INSERT INTO public.who_global_data VALUES (61297, 13, 937, 0, 60, 259, 136);
INSERT INTO public.who_global_data VALUES (61298, 245, 7261, 10, 221, 259, 63);
INSERT INTO public.who_global_data VALUES (61299, 0, 0, 0, 0, 259, 17);
INSERT INTO public.who_global_data VALUES (61300, 0, 22, 0, 2, 259, 172);
INSERT INTO public.who_global_data VALUES (61301, 23, 1921, 1, 112, 259, 109);
INSERT INTO public.who_global_data VALUES (61302, 41, 8309, 1, 235, 259, 200);
INSERT INTO public.who_global_data VALUES (61303, 0, 602, 0, 4, 259, 93);
INSERT INTO public.who_global_data VALUES (61304, 424, 6794, 2, 34, 259, 5);
INSERT INTO public.who_global_data VALUES (61305, 29, 741, 0, 13, 259, 214);
INSERT INTO public.who_global_data VALUES (61306, 1743, 52437, 34, 1101, 259, 204);
INSERT INTO public.who_global_data VALUES (61307, 0, 0, 0, 0, 259, 198);
INSERT INTO public.who_global_data VALUES (61308, 139, 10116, 4, 291, 259, 173);
INSERT INTO public.who_global_data VALUES (61309, 0, 8, 0, 0, 259, 229);
INSERT INTO public.who_global_data VALUES (61310, 2, 838, 0, 11, 259, 76);
INSERT INTO public.who_global_data VALUES (61311, 4749, 108769, 124, 3148, 259, 138);
INSERT INTO public.who_global_data VALUES (61312, 0, 13597, 0, 857, 259, 98);
INSERT INTO public.who_global_data VALUES (61313, 0, 0, 0, 0, 259, 103);
INSERT INTO public.who_global_data VALUES (61314, 476, 20619, 10, 982, 259, 225);
INSERT INTO public.who_global_data VALUES (61315, 288, 30200, 12, 1289, 259, 131);
INSERT INTO public.who_global_data VALUES (61316, 117, 3030, 0, 126, 259, 235);
INSERT INTO public.who_global_data VALUES (61317, 1830, 40481, 2, 19, 259, 137);
INSERT INTO public.who_global_data VALUES (61318, 23, 11165, 2, 266, 259, 81);
INSERT INTO public.who_global_data VALUES (61319, 143, 6847, 5, 238, 259, 182);
INSERT INTO public.who_global_data VALUES (61320, 0, 449, 0, 1, 259, 145);
INSERT INTO public.who_global_data VALUES (61321, 127, 17712, 8, 1159, 259, 26);
INSERT INTO public.who_global_data VALUES (61322, 9434, 335882, 139, 3388, 259, 170);
INSERT INTO public.who_global_data VALUES (61323, 1, 321, 0, 0, 259, 191);
INSERT INTO public.who_global_data VALUES (61324, 0, 2, 0, 0, 259, 221);
INSERT INTO public.who_global_data VALUES (61325, 0, 6, 0, 0, 259, 64);
INSERT INTO public.who_global_data VALUES (61326, 0, 0, 0, 0, 259, 116);
INSERT INTO public.who_global_data VALUES (61327, 0, 15, 0, 0, 259, 128);
INSERT INTO public.who_global_data VALUES (61328, 0, 18, 0, 0, 259, 6);
INSERT INTO public.who_global_data VALUES (61329, 0, 39, 0, 3, 259, 227);
INSERT INTO public.who_global_data VALUES (61330, 0, 1, 0, 0, 259, 68);
INSERT INTO public.who_global_data VALUES (61331, 0, 18, 0, 0, 259, 184);
INSERT INTO public.who_global_data VALUES (61332, 0, 0, 0, 0, 259, 82);
INSERT INTO public.who_global_data VALUES (61333, 0, 672, 0, 41, 259, 149);
INSERT INTO public.who_global_data VALUES (61334, 0, 165, 0, 8, 259, 197);
INSERT INTO public.who_global_data VALUES (61335, 2642, 67719, 13, 364, 259, 78);
INSERT INTO public.who_global_data VALUES (61336, 94, 2909, 0, 33, 259, 233);
INSERT INTO public.who_global_data VALUES (61337, 105, 11024, 0, 237, 259, 133);
INSERT INTO public.who_global_data VALUES (61338, 0, 11, 0, 0, 259, 35);
INSERT INTO public.who_global_data VALUES (61339, 21, 606, 3, 38, 259, 114);
INSERT INTO public.who_global_data VALUES (61340, 614, 30426, 0, 23, 259, 237);
INSERT INTO public.who_global_data VALUES (61341, 0, 2, 0, 0, 259, 55);
INSERT INTO public.who_global_data VALUES (61342, 0, 78, 0, 15, 259, 176);
INSERT INTO public.who_global_data VALUES (61343, 1, 1503, 0, 28, 259, 202);
INSERT INTO public.who_global_data VALUES (61344, 0, 1468, 0, 113, 259, 155);
INSERT INTO public.who_global_data VALUES (61345, 0, 0, 0, 0, 259, 32);
INSERT INTO public.who_global_data VALUES (61346, 0, 1594, 0, 61, 259, 220);
INSERT INTO public.who_global_data VALUES (61347, 988, 20125, 28, 397, 259, 30);
INSERT INTO public.who_global_data VALUES (61348, 0, 473, -1, 5, 259, 147);
INSERT INTO public.who_global_data VALUES (61349, 922, 241435, 70, 28643, 259, 208);
INSERT INTO public.who_global_data VALUES (61350, 25, 1085, 0, 9, 259, 45);
INSERT INTO public.who_global_data VALUES (61351, 240, 3378, 16, 137, 259, 110);
INSERT INTO public.who_global_data VALUES (61352, 0, 11, 0, 1, 259, 88);
INSERT INTO public.who_global_data VALUES (61353, 610, 33232, 53, 4234, 259, 51);
INSERT INTO public.who_global_data VALUES (61354, 20, 30692, 1, 1709, 259, 209);
INSERT INTO public.who_global_data VALUES (61355, 1, 59, 1, 4, 259, 205);
INSERT INTO public.who_global_data VALUES (61356, 201, 2551, 0, 44, 259, 18);
INSERT INTO public.who_global_data VALUES (61357, 3, 3040, 0, 56, 259, 72);
INSERT INTO public.who_global_data VALUES (61358, 2574, 241023, 291, 35358, 259, 44);
INSERT INTO public.who_global_data VALUES (61359, 0, 24, 0, 0, 259, 15);
INSERT INTO public.who_global_data VALUES (61360, 9, 363, 0, 12, 259, 25);
INSERT INTO public.who_global_data VALUES (61361, 0, 0, 0, 0, 259, 179);
INSERT INTO public.who_global_data VALUES (61362, 0, 0, 0, 0, 259, 34);
INSERT INTO public.who_global_data VALUES (61363, 0, 116, 0, 8, 259, 207);
INSERT INTO public.who_global_data VALUES (61364, 2, 1048, 0, 47, 259, 166);
INSERT INTO public.who_global_data VALUES (61365, 952, 154500, 27, 4276, 259, 126);
INSERT INTO public.who_global_data VALUES (61366, 0, 0, 0, 0, 259, 97);
INSERT INTO public.who_global_data VALUES (61367, 0, 12, 0, 1, 259, 36);
INSERT INTO public.who_global_data VALUES (61368, 0, 0, 0, 0, 259, 125);
INSERT INTO public.who_global_data VALUES (61369, 10, 274, 0, 0, 259, 124);
INSERT INTO public.who_global_data VALUES (61370, 432, 20580, 17, 605, 259, 185);
INSERT INTO public.who_global_data VALUES (61371, 994, 27892, 4, 241, 259, 194);
INSERT INTO public.who_global_data VALUES (61372, 0, 509, 0, 21, 259, 144);
INSERT INTO public.who_global_data VALUES (61373, 20475, 1568448, 1088, 94011, 259, 19);
INSERT INTO public.who_global_data VALUES (61374, 0, 69, 0, 6, 259, 217);
INSERT INTO public.who_global_data VALUES (61375, 3, 749, 0, 20, 259, 148);
INSERT INTO public.who_global_data VALUES (61376, 72, 3078, 0, 13, 259, 86);
INSERT INTO public.who_global_data VALUES (61377, 0, 0, 0, 0, 259, 13);
INSERT INTO public.who_global_data VALUES (61378, 58, 882, 0, 10, 259, 157);
INSERT INTO public.who_global_data VALUES (61379, 0, 324, 0, 0, 259, 8);
INSERT INTO public.who_global_data VALUES (61380, 0, 0, 0, 0, 259, 73);
INSERT INTO public.who_global_data VALUES (61381, 12, 205, 0, 33, 259, 101);
INSERT INTO public.who_global_data VALUES (61382, 54, 920, 0, 7, 259, 165);
INSERT INTO public.who_global_data VALUES (61383, 0, 51, 0, 4, 259, 14);
INSERT INTO public.who_global_data VALUES (61384, 540, 9216, 12, 205, 260, 193);
INSERT INTO public.who_global_data VALUES (61385, 0, 931, 0, 30, 260, 113);
INSERT INTO public.who_global_data VALUES (61386, 186, 7728, 7, 575, 260, 143);
INSERT INTO public.who_global_data VALUES (61387, 0, 0, 0, 0, 260, 219);
INSERT INTO public.who_global_data VALUES (61388, 0, 762, 0, 51, 260, 186);
INSERT INTO public.who_global_data VALUES (61389, 2, 60, 0, 3, 260, 52);
INSERT INTO public.who_global_data VALUES (61390, 0, 3, 0, 0, 260, 180);
INSERT INTO public.who_global_data VALUES (61391, 0, 25, 0, 3, 260, 167);
INSERT INTO public.who_global_data VALUES (61392, 474, 9283, 10, 403, 260, 154);
INSERT INTO public.who_global_data VALUES (61393, 335, 5582, 3, 70, 260, 94);
INSERT INTO public.who_global_data VALUES (61394, 0, 101, 0, 3, 260, 66);
INSERT INTO public.who_global_data VALUES (61395, 2, 7081, 0, 100, 260, 58);
INSERT INTO public.who_global_data VALUES (61396, 57, 16332, 0, 633, 260, 163);
INSERT INTO public.who_global_data VALUES (61397, 118, 3749, 1, 44, 260, 37);
INSERT INTO public.who_global_data VALUES (61398, 1, 97, 0, 11, 260, 142);
INSERT INTO public.who_global_data VALUES (61399, 135, 8174, 0, 12, 260, 83);
INSERT INTO public.who_global_data VALUES (61400, 1694, 30205, 24, 432, 260, 228);
INSERT INTO public.who_global_data VALUES (61401, 0, 90, 0, 7, 260, 188);
INSERT INTO public.who_global_data VALUES (61402, 932, 34303, 5, 190, 260, 62);
INSERT INTO public.who_global_data VALUES (61403, 70, 57474, 34, 9105, 260, 160);
INSERT INTO public.who_global_data VALUES (61404, 0, 18, 0, 2, 260, 50);
INSERT INTO public.who_global_data VALUES (61405, 5, 135, 1, 3, 260, 33);
INSERT INTO public.who_global_data VALUES (61406, 0, 125, 0, 9, 260, 183);
INSERT INTO public.who_global_data VALUES (61407, 0, 21, 0, 0, 260, 92);
INSERT INTO public.who_global_data VALUES (61408, 438, 4919, 10, 199, 260, 158);
INSERT INTO public.who_global_data VALUES (61409, 0, 2, 0, 0, 260, 67);
INSERT INTO public.who_global_data VALUES (61410, 18, 2352, 4, 139, 260, 57);
INSERT INTO public.who_global_data VALUES (61411, 4, 29, 0, 1, 260, 38);
INSERT INTO public.who_global_data VALUES (61412, 19951, 291579, 888, 18859, 260, 141);
INSERT INTO public.who_global_data VALUES (61413, 0, 8, 0, 1, 260, 178);
INSERT INTO public.who_global_data VALUES (61414, 0, 141, 0, 1, 260, 108);
INSERT INTO public.who_global_data VALUES (61415, 41, 2372, 5, 125, 260, 39);
INSERT INTO public.who_global_data VALUES (61416, 3, 812, 0, 52, 260, 2);
INSERT INTO public.who_global_data VALUES (61417, 0, 42, 0, 1, 260, 195);
INSERT INTO public.who_global_data VALUES (61418, 7, 356, 0, 3, 260, 107);
INSERT INTO public.who_global_data VALUES (61419, 1, 123, 0, 0, 260, 161);
INSERT INTO public.who_global_data VALUES (61420, 555, 4288, 10, 156, 260, 212);
INSERT INTO public.who_global_data VALUES (61421, 1053, 80555, 107, 6062, 260, 181);
INSERT INTO public.who_global_data VALUES (61422, 0, 111, 0, 1, 260, 53);
INSERT INTO public.who_global_data VALUES (61423, 25, 436, 0, 0, 260, 164);
INSERT INTO public.who_global_data VALUES (61424, 23, 588, 1, 58, 260, 140);
INSERT INTO public.who_global_data VALUES (61425, 0, 53617, 0, 544, 260, 20);
INSERT INTO public.who_global_data VALUES (61426, 13, 84520, 0, 4645, 260, 112);
INSERT INTO public.who_global_data VALUES (61427, 752, 17687, 17, 630, 260, 111);
INSERT INTO public.who_global_data VALUES (61428, 0, 34, 0, 1, 260, 71);
INSERT INTO public.who_global_data VALUES (61429, 49, 469, 1, 16, 260, 218);
INSERT INTO public.who_global_data VALUES (61430, 0, 0, 0, 0, 260, 43);
INSERT INTO public.who_global_data VALUES (61431, 0, 882, 0, 10, 260, 49);
INSERT INTO public.who_global_data VALUES (61432, 70, 2301, 0, 29, 260, 1);
INSERT INTO public.who_global_data VALUES (61433, 3, 2237, 1, 97, 260, 48);
INSERT INTO public.who_global_data VALUES (61434, 8, 1908, 1, 80, 260, 232);
INSERT INTO public.who_global_data VALUES (61435, 0, 16, 0, 1, 260, 175);
INSERT INTO public.who_global_data VALUES (61436, 1, 923, 0, 17, 260, 21);
INSERT INTO public.who_global_data VALUES (61437, 33, 8754, 2, 306, 260, 156);
INSERT INTO public.who_global_data VALUES (61438, 0, 0, 0, 0, 260, 95);
INSERT INTO public.who_global_data VALUES (61439, 110, 1944, 2, 62, 260, 177);
INSERT INTO public.who_global_data VALUES (61440, 65, 11182, 7, 561, 260, 210);
INSERT INTO public.who_global_data VALUES (61441, 0, 2047, 0, 10, 260, 120);
INSERT INTO public.who_global_data VALUES (61442, 0, 16, 0, 0, 260, 135);
INSERT INTO public.who_global_data VALUES (61443, 180, 13657, 2, 448, 260, 206);
INSERT INTO public.who_global_data VALUES (61444, 703, 34854, 49, 2888, 260, 189);
INSERT INTO public.who_global_data VALUES (61445, 774, 15003, 16, 696, 260, 129);
INSERT INTO public.who_global_data VALUES (61446, 69, 1640, 1, 32, 260, 121);
INSERT INTO public.who_global_data VALUES (61447, 57, 960, 1, 11, 260, 59);
INSERT INTO public.who_global_data VALUES (61448, 0, 39, 0, 0, 260, 96);
INSERT INTO public.who_global_data VALUES (61449, 6, 1800, 0, 63, 260, 41);
INSERT INTO public.who_global_data VALUES (61450, 3, 220, 0, 2, 260, 216);
INSERT INTO public.who_global_data VALUES (61451, 10, 399, 0, 5, 260, 236);
INSERT INTO public.who_global_data VALUES (61452, 0, 13, 0, 0, 260, 150);
INSERT INTO public.who_global_data VALUES (61453, 0, 187, 0, 0, 260, 61);
INSERT INTO public.who_global_data VALUES (61454, 0, 18, 0, 0, 260, 7);
INSERT INTO public.who_global_data VALUES (61455, 50, 6493, 2, 306, 260, 169);
INSERT INTO public.who_global_data VALUES (61456, 278, 141590, 83, 28164, 260, 28);
INSERT INTO public.who_global_data VALUES (61457, 19, 237, 0, 1, 260, 85);
INSERT INTO public.who_global_data VALUES (61458, 0, 60, 0, 0, 260, 211);
INSERT INTO public.who_global_data VALUES (61459, 0, 1567, 0, 12, 260, 60);
INSERT INTO public.who_global_data VALUES (61460, 0, 24, 0, 1, 260, 3);
INSERT INTO public.who_global_data VALUES (61461, 2, 723, 0, 12, 260, 11);
INSERT INTO public.who_global_data VALUES (61462, 460, 177212, 27, 8174, 260, 89);
INSERT INTO public.who_global_data VALUES (61463, 173, 6269, 0, 31, 260, 24);
INSERT INTO public.who_global_data VALUES (61464, 2, 149, 0, 0, 260, 162);
INSERT INTO public.who_global_data VALUES (61465, 3, 2853, 2, 168, 260, 100);
INSERT INTO public.who_global_data VALUES (61466, 0, 11, 0, 0, 260, 47);
INSERT INTO public.who_global_data VALUES (61467, 0, 22, 0, 0, 260, 29);
INSERT INTO public.who_global_data VALUES (61468, 0, 155, 0, 13, 260, 40);
INSERT INTO public.who_global_data VALUES (61469, 0, 160, 0, 5, 260, 222);
INSERT INTO public.who_global_data VALUES (61470, 132, 2265, 2, 45, 260, 132);
INSERT INTO public.who_global_data VALUES (61471, 0, 252, 0, 13, 260, 130);
INSERT INTO public.who_global_data VALUES (61472, 140, 3067, 0, 19, 260, 234);
INSERT INTO public.who_global_data VALUES (61473, 20, 1109, 0, 6, 260, 23);
INSERT INTO public.who_global_data VALUES (61474, 0, 125, 0, 10, 260, 192);
INSERT INTO public.who_global_data VALUES (61475, 67, 663, 0, 22, 260, 69);
INSERT INTO public.who_global_data VALUES (61476, 0, 12, 0, 0, 260, 187);
INSERT INTO public.who_global_data VALUES (61477, 145, 3100, 4, 151, 260, 230);
INSERT INTO public.who_global_data VALUES (61478, 37, 3678, 3, 476, 260, 77);
INSERT INTO public.who_global_data VALUES (61479, 0, 1803, 0, 10, 260, 9);
INSERT INTO public.who_global_data VALUES (61480, 6088, 118447, 148, 3583, 260, 74);
INSERT INTO public.who_global_data VALUES (61481, 634, 20796, 48, 1326, 260, 224);
INSERT INTO public.who_global_data VALUES (61482, 0, 129341, 0, 7249, 260, 199);
INSERT INTO public.who_global_data VALUES (61483, 0, 3877, 0, 140, 260, 190);
INSERT INTO public.who_global_data VALUES (61484, 76, 24391, 12, 1583, 260, 12);
INSERT INTO public.who_global_data VALUES (61485, 1, 336, 0, 24, 260, 104);
INSERT INTO public.who_global_data VALUES (61486, 15, 16613, 1, 281, 260, 153);
INSERT INTO public.who_global_data VALUES (61487, 642, 228006, 156, 32486, 260, 91);
INSERT INTO public.who_global_data VALUES (61488, 9, 529, 0, 9, 260, 215);
INSERT INTO public.who_global_data VALUES (61489, 89, 16513, 19, 796, 260, 84);
INSERT INTO public.who_global_data VALUES (61490, 3, 306, 1, 29, 260, 231);
INSERT INTO public.who_global_data VALUES (61491, 0, 684, 0, 9, 260, 196);
INSERT INTO public.who_global_data VALUES (61492, 322, 7919, 0, 35, 260, 105);
INSERT INTO public.who_global_data VALUES (61493, 80, 1109, 0, 50, 260, 122);
INSERT INTO public.who_global_data VALUES (61494, 0, 0, 0, 0, 260, 159);
INSERT INTO public.who_global_data VALUES (61495, 14, 1003, 0, 20, 260, 75);
INSERT INTO public.who_global_data VALUES (61496, 0, 18609, 0, 129, 260, 27);
INSERT INTO public.who_global_data VALUES (61497, 37, 1350, 0, 14, 260, 54);
INSERT INTO public.who_global_data VALUES (61498, 0, 19, 0, 0, 260, 226);
INSERT INTO public.who_global_data VALUES (61499, 9, 1025, 1, 22, 260, 79);
INSERT INTO public.who_global_data VALUES (61500, 0, 1024, 0, 26, 260, 56);
INSERT INTO public.who_global_data VALUES (61501, 0, 1, 0, 0, 260, 117);
INSERT INTO public.who_global_data VALUES (61502, 2, 240, 0, 23, 260, 152);
INSERT INTO public.who_global_data VALUES (61503, 0, 71, 0, 3, 260, 16);
INSERT INTO public.who_global_data VALUES (61504, 0, 83, 0, 1, 260, 10);
INSERT INTO public.who_global_data VALUES (61505, 6, 1598, 0, 61, 260, 201);
INSERT INTO public.who_global_data VALUES (61506, 9, 3980, 0, 109, 260, 174);
INSERT INTO public.who_global_data VALUES (61507, 34, 405, 0, 2, 260, 119);
INSERT INTO public.who_global_data VALUES (61508, 0, 72, 0, 3, 260, 168);
INSERT INTO public.who_global_data VALUES (61509, 50, 7059, 0, 114, 260, 99);
INSERT INTO public.who_global_data VALUES (61510, 0, 1216, 0, 4, 260, 171);
INSERT INTO public.who_global_data VALUES (61511, 0, 931, 0, 55, 260, 87);
INSERT INTO public.who_global_data VALUES (61512, 1, 599, 0, 6, 260, 123);
INSERT INTO public.who_global_data VALUES (61513, 0, 0, 0, 0, 260, 151);
INSERT INTO public.who_global_data VALUES (61514, 0, 192, 0, 14, 260, 213);
INSERT INTO public.who_global_data VALUES (61515, 32, 173, 1, 5, 260, 118);
INSERT INTO public.who_global_data VALUES (61516, 0, 332, 0, 10, 260, 134);
INSERT INTO public.who_global_data VALUES (61517, 19, 1494, 0, 19, 260, 65);
INSERT INTO public.who_global_data VALUES (61518, 2248, 56594, 424, 6090, 260, 102);
INSERT INTO public.who_global_data VALUES (61519, 0, 0, 0, 0, 260, 223);
INSERT INTO public.who_global_data VALUES (61520, 0, 68, 0, 1, 260, 4);
INSERT INTO public.who_global_data VALUES (61521, 1, 141, 0, 0, 260, 146);
INSERT INTO public.who_global_data VALUES (61522, 0, 324, 0, 9, 260, 31);
INSERT INTO public.who_global_data VALUES (61523, 0, 11, 0, 1, 260, 127);
INSERT INTO public.who_global_data VALUES (61524, 26, 7211, 0, 196, 260, 22);
INSERT INTO public.who_global_data VALUES (61525, 6, 162, 0, 0, 260, 115);
INSERT INTO public.who_global_data VALUES (61526, 0, 199, 0, 6, 260, 106);
INSERT INTO public.who_global_data VALUES (61527, 2, 18, 0, 0, 260, 90);
INSERT INTO public.who_global_data VALUES (61528, 0, 0, 0, 0, 260, 70);
INSERT INTO public.who_global_data VALUES (61529, 62, 516, 0, 3, 260, 46);
INSERT INTO public.who_global_data VALUES (61530, 254, 44462, 29, 5751, 260, 139);
INSERT INTO public.who_global_data VALUES (61531, 0, 18, 0, 0, 260, 42);
INSERT INTO public.who_global_data VALUES (61532, 1, 1154, 0, 21, 260, 80);
INSERT INTO public.who_global_data VALUES (61533, 0, 279, 0, 17, 260, 203);
INSERT INTO public.who_global_data VALUES (61534, 4, 924, 2, 60, 260, 136);
INSERT INTO public.who_global_data VALUES (61535, 339, 7016, 11, 211, 260, 63);
INSERT INTO public.who_global_data VALUES (61536, 0, 0, 0, 0, 260, 17);
INSERT INTO public.who_global_data VALUES (61537, 1, 22, 0, 2, 260, 172);
INSERT INTO public.who_global_data VALUES (61538, 40, 1898, 1, 111, 260, 109);
INSERT INTO public.who_global_data VALUES (61539, 0, 8268, 0, 234, 260, 200);
INSERT INTO public.who_global_data VALUES (61540, 6, 602, 0, 4, 260, 93);
INSERT INTO public.who_global_data VALUES (61541, 0, 6370, 2, 32, 260, 5);
INSERT INTO public.who_global_data VALUES (61542, 0, 712, 0, 13, 260, 214);
INSERT INTO public.who_global_data VALUES (61543, 2603, 50694, 50, 1067, 260, 204);
INSERT INTO public.who_global_data VALUES (61544, 0, 0, 0, 0, 260, 198);
INSERT INTO public.who_global_data VALUES (61545, 110, 9977, 6, 287, 260, 173);
INSERT INTO public.who_global_data VALUES (61546, 0, 8, 0, 0, 260, 229);
INSERT INTO public.who_global_data VALUES (61547, 3, 836, 0, 11, 260, 76);
INSERT INTO public.who_global_data VALUES (61548, 4537, 104020, 110, 3024, 260, 138);
INSERT INTO public.who_global_data VALUES (61549, 163, 13597, 11, 857, 260, 98);
INSERT INTO public.who_global_data VALUES (61550, 0, 0, 0, 0, 260, 103);
INSERT INTO public.who_global_data VALUES (61551, 404, 20143, 10, 972, 260, 225);
INSERT INTO public.who_global_data VALUES (61552, 252, 29912, 14, 1277, 260, 131);
INSERT INTO public.who_global_data VALUES (61553, 47, 2913, 1, 126, 260, 235);
INSERT INTO public.who_global_data VALUES (61554, 0, 38651, 0, 17, 260, 137);
INSERT INTO public.who_global_data VALUES (61555, 20, 11142, 0, 264, 260, 81);
INSERT INTO public.who_global_data VALUES (61556, 151, 6704, 1, 233, 260, 182);
INSERT INTO public.who_global_data VALUES (61557, 2, 449, 0, 1, 260, 145);
INSERT INTO public.who_global_data VALUES (61558, 198, 17585, 10, 1151, 260, 26);
INSERT INTO public.who_global_data VALUES (61559, 8894, 326448, 150, 3249, 260, 170);
INSERT INTO public.who_global_data VALUES (61560, 6, 320, 0, 0, 260, 191);
INSERT INTO public.who_global_data VALUES (61561, 0, 2, 0, 0, 260, 221);
INSERT INTO public.who_global_data VALUES (61562, 0, 6, 0, 0, 260, 64);
INSERT INTO public.who_global_data VALUES (61563, 0, 0, 0, 0, 260, 116);
INSERT INTO public.who_global_data VALUES (61564, 0, 15, 0, 0, 260, 128);
INSERT INTO public.who_global_data VALUES (61565, 0, 18, 0, 0, 260, 6);
INSERT INTO public.who_global_data VALUES (61566, 0, 39, 0, 3, 260, 227);
INSERT INTO public.who_global_data VALUES (61567, 0, 1, 0, 0, 260, 68);
INSERT INTO public.who_global_data VALUES (61568, 0, 18, 0, 0, 260, 184);
INSERT INTO public.who_global_data VALUES (61569, 0, 0, 0, 0, 260, 82);
INSERT INTO public.who_global_data VALUES (61570, 2, 672, 0, 41, 260, 149);
INSERT INTO public.who_global_data VALUES (61571, 0, 165, 0, 8, 260, 197);
INSERT INTO public.who_global_data VALUES (61572, 0, 65077, 0, 351, 260, 78);
INSERT INTO public.who_global_data VALUES (61573, 101, 2815, 3, 33, 260, 233);
INSERT INTO public.who_global_data VALUES (61574, 86, 10919, 2, 237, 260, 133);
INSERT INTO public.who_global_data VALUES (61575, 0, 11, 0, 0, 260, 35);
INSERT INTO public.who_global_data VALUES (61576, 15, 585, 1, 35, 260, 114);
INSERT INTO public.who_global_data VALUES (61577, 448, 29812, 1, 23, 260, 237);
INSERT INTO public.who_global_data VALUES (61578, 0, 2, 0, 0, 260, 55);
INSERT INTO public.who_global_data VALUES (61579, 0, 78, 0, 15, 260, 176);
INSERT INTO public.who_global_data VALUES (61580, 6, 1502, 0, 28, 260, 202);
INSERT INTO public.who_global_data VALUES (61581, 0, 1468, 0, 113, 260, 155);
INSERT INTO public.who_global_data VALUES (61582, 0, 0, 0, 0, 260, 32);
INSERT INTO public.who_global_data VALUES (61583, 0, 1594, 0, 61, 260, 220);
INSERT INTO public.who_global_data VALUES (61584, 1134, 19137, 30, 369, 260, 30);
INSERT INTO public.who_global_data VALUES (61585, 134, 473, 0, 6, 260, 147);
INSERT INTO public.who_global_data VALUES (61586, 820, 240513, 56, 28573, 260, 208);
INSERT INTO public.who_global_data VALUES (61587, 15, 1060, 0, 9, 260, 45);
INSERT INTO public.who_global_data VALUES (61588, 0, 3138, 0, 121, 260, 110);
INSERT INTO public.who_global_data VALUES (61589, 0, 11, 0, 1, 260, 88);
INSERT INTO public.who_global_data VALUES (61590, 808, 32622, 52, 4181, 260, 51);
INSERT INTO public.who_global_data VALUES (61591, 11, 30672, 5, 1708, 260, 209);
INSERT INTO public.who_global_data VALUES (61592, 0, 58, 0, 3, 260, 205);
INSERT INTO public.who_global_data VALUES (61593, 210, 2350, 0, 44, 260, 18);
INSERT INTO public.who_global_data VALUES (61594, 0, 3037, 0, 56, 260, 72);
INSERT INTO public.who_global_data VALUES (61595, 2718, 238449, 273, 35067, 260, 44);
INSERT INTO public.who_global_data VALUES (61596, 0, 24, 0, 0, 260, 15);
INSERT INTO public.who_global_data VALUES (61597, 16, 354, 0, 12, 260, 25);
INSERT INTO public.who_global_data VALUES (61598, 0, 0, 0, 0, 260, 179);
INSERT INTO public.who_global_data VALUES (61599, 0, 0, 0, 0, 260, 34);
INSERT INTO public.who_global_data VALUES (61600, 0, 116, 0, 8, 260, 207);
INSERT INTO public.who_global_data VALUES (61601, 1, 1046, 0, 47, 260, 166);
INSERT INTO public.who_global_data VALUES (61602, 961, 153548, 27, 4249, 260, 126);
INSERT INTO public.who_global_data VALUES (61603, 0, 0, 0, 0, 260, 97);
INSERT INTO public.who_global_data VALUES (61604, 0, 12, 0, 1, 260, 36);
INSERT INTO public.who_global_data VALUES (61605, 0, 0, 0, 0, 260, 125);
INSERT INTO public.who_global_data VALUES (61606, 0, 264, 0, 0, 260, 124);
INSERT INTO public.who_global_data VALUES (61607, 442, 20148, 9, 588, 260, 185);
INSERT INTO public.who_global_data VALUES (61608, 894, 26898, 4, 237, 260, 194);
INSERT INTO public.who_global_data VALUES (61609, 0, 509, 0, 21, 260, 144);
INSERT INTO public.who_global_data VALUES (61610, 22787, 1547973, 1396, 92923, 260, 19);
INSERT INTO public.who_global_data VALUES (61611, 0, 69, 0, 6, 260, 217);
INSERT INTO public.who_global_data VALUES (61612, 8, 746, 0, 20, 260, 148);
INSERT INTO public.who_global_data VALUES (61613, 56, 3006, 0, 13, 260, 86);
INSERT INTO public.who_global_data VALUES (61614, 0, 0, 0, 0, 260, 13);
INSERT INTO public.who_global_data VALUES (61615, 0, 824, 0, 10, 260, 157);
INSERT INTO public.who_global_data VALUES (61616, 0, 324, 0, 0, 260, 8);
INSERT INTO public.who_global_data VALUES (61617, 0, 0, 0, 0, 260, 73);
INSERT INTO public.who_global_data VALUES (61618, 9, 193, 3, 33, 260, 101);
INSERT INTO public.who_global_data VALUES (61619, 34, 866, 0, 7, 260, 165);
INSERT INTO public.who_global_data VALUES (61620, 3, 51, 0, 4, 260, 14);
INSERT INTO public.who_global_data VALUES (61621, 531, 8676, 6, 193, 261, 193);
INSERT INTO public.who_global_data VALUES (61622, 5, 931, 0, 30, 261, 113);
INSERT INTO public.who_global_data VALUES (61623, 165, 7542, 7, 568, 261, 143);
INSERT INTO public.who_global_data VALUES (61624, 0, 0, 0, 0, 261, 219);
INSERT INTO public.who_global_data VALUES (61625, 1, 762, 0, 51, 261, 186);
INSERT INTO public.who_global_data VALUES (61626, 6, 58, 0, 3, 261, 52);
INSERT INTO public.who_global_data VALUES (61627, 0, 3, 0, 0, 261, 180);
INSERT INTO public.who_global_data VALUES (61628, 0, 25, 0, 3, 261, 167);
INSERT INTO public.who_global_data VALUES (61629, 438, 8809, 11, 393, 261, 154);
INSERT INTO public.who_global_data VALUES (61630, 230, 5247, 3, 67, 261, 94);
INSERT INTO public.who_global_data VALUES (61631, 0, 101, 0, 3, 261, 66);
INSERT INTO public.who_global_data VALUES (61632, 11, 7079, 1, 100, 261, 58);
INSERT INTO public.who_global_data VALUES (61633, 18, 16275, 1, 633, 261, 163);
INSERT INTO public.who_global_data VALUES (61634, 113, 3631, 2, 43, 261, 37);
INSERT INTO public.who_global_data VALUES (61635, 0, 96, 0, 11, 261, 142);
INSERT INTO public.who_global_data VALUES (61636, 507, 8039, 0, 12, 261, 83);
INSERT INTO public.who_global_data VALUES (61637, 1773, 28511, 22, 408, 261, 228);
INSERT INTO public.who_global_data VALUES (61638, 2, 90, 0, 7, 261, 188);
INSERT INTO public.who_global_data VALUES (61639, 1863, 33371, 10, 185, 261, 62);
INSERT INTO public.who_global_data VALUES (61640, 385, 57404, 30, 9071, 261, 160);
INSERT INTO public.who_global_data VALUES (61641, 0, 18, 0, 2, 261, 50);
INSERT INTO public.who_global_data VALUES (61642, 0, 130, 0, 2, 261, 33);
INSERT INTO public.who_global_data VALUES (61643, 0, 125, 0, 9, 261, 183);
INSERT INTO public.who_global_data VALUES (61644, 0, 21, 0, 0, 261, 92);
INSERT INTO public.who_global_data VALUES (61645, 218, 4481, 15, 189, 261, 158);
INSERT INTO public.who_global_data VALUES (61646, 0, 2, 0, 0, 261, 67);
INSERT INTO public.who_global_data VALUES (61647, 15, 2334, 2, 135, 261, 57);
INSERT INTO public.who_global_data VALUES (61648, 0, 25, 0, 1, 261, 38);
INSERT INTO public.who_global_data VALUES (61649, 17408, 271628, 1179, 17971, 261, 141);
INSERT INTO public.who_global_data VALUES (61650, 0, 8, 0, 1, 261, 178);
INSERT INTO public.who_global_data VALUES (61651, 0, 141, 0, 1, 261, 108);
INSERT INTO public.who_global_data VALUES (61652, 39, 2331, 4, 120, 261, 39);
INSERT INTO public.who_global_data VALUES (61653, 3, 809, 0, 52, 261, 2);
INSERT INTO public.who_global_data VALUES (61654, 0, 42, 0, 1, 261, 195);
INSERT INTO public.who_global_data VALUES (61655, 14, 349, 0, 3, 261, 107);
INSERT INTO public.who_global_data VALUES (61656, 0, 122, 0, 0, 261, 161);
INSERT INTO public.who_global_data VALUES (61657, 204, 3733, 6, 146, 261, 212);
INSERT INTO public.who_global_data VALUES (61658, 1003, 79502, 98, 5955, 261, 181);
INSERT INTO public.who_global_data VALUES (61659, 17, 111, 0, 1, 261, 53);
INSERT INTO public.who_global_data VALUES (61660, 0, 411, 0, 0, 261, 164);
INSERT INTO public.who_global_data VALUES (61661, 20, 565, 1, 57, 261, 140);
INSERT INTO public.who_global_data VALUES (61662, 7558, 53617, 66, 544, 261, 20);
INSERT INTO public.who_global_data VALUES (61663, 2, 84507, 0, 4645, 261, 112);
INSERT INTO public.who_global_data VALUES (61664, 640, 16935, 21, 613, 261, 111);
INSERT INTO public.who_global_data VALUES (61665, 0, 34, 0, 1, 261, 71);
INSERT INTO public.who_global_data VALUES (61666, 0, 420, 0, 15, 261, 218);
INSERT INTO public.who_global_data VALUES (61667, 0, 0, 0, 0, 261, 43);
INSERT INTO public.who_global_data VALUES (61668, 0, 882, 0, 10, 261, 49);
INSERT INTO public.who_global_data VALUES (61669, 78, 2231, 1, 29, 261, 1);
INSERT INTO public.who_global_data VALUES (61670, 2, 2234, 0, 96, 261, 48);
INSERT INTO public.who_global_data VALUES (61671, 13, 1900, 0, 79, 261, 232);
INSERT INTO public.who_global_data VALUES (61672, 0, 16, 0, 1, 261, 175);
INSERT INTO public.who_global_data VALUES (61673, 4, 922, 0, 17, 261, 21);
INSERT INTO public.who_global_data VALUES (61674, 74, 8721, 2, 304, 261, 156);
INSERT INTO public.who_global_data VALUES (61675, 0, 0, 0, 0, 261, 95);
INSERT INTO public.who_global_data VALUES (61676, 104, 1834, 0, 60, 261, 177);
INSERT INTO public.who_global_data VALUES (61677, 73, 11117, 3, 554, 261, 210);
INSERT INTO public.who_global_data VALUES (61678, 219, 2047, 1, 10, 261, 120);
INSERT INTO public.who_global_data VALUES (61679, 0, 16, 0, 0, 261, 135);
INSERT INTO public.who_global_data VALUES (61680, 254, 13477, 5, 446, 261, 206);
INSERT INTO public.who_global_data VALUES (61681, 0, 34151, 0, 2839, 261, 189);
INSERT INTO public.who_global_data VALUES (61682, 0, 14229, 0, 680, 261, 129);
INSERT INTO public.who_global_data VALUES (61683, 73, 1571, 1, 31, 261, 121);
INSERT INTO public.who_global_data VALUES (61684, 13, 903, 3, 10, 261, 59);
INSERT INTO public.who_global_data VALUES (61685, 0, 39, 0, 0, 261, 96);
INSERT INTO public.who_global_data VALUES (61686, 3, 1794, 0, 63, 261, 41);
INSERT INTO public.who_global_data VALUES (61687, 9, 217, 0, 2, 261, 216);
INSERT INTO public.who_global_data VALUES (61688, 24, 389, 0, 5, 261, 236);
INSERT INTO public.who_global_data VALUES (61689, 0, 13, 0, 0, 261, 150);
INSERT INTO public.who_global_data VALUES (61690, 0, 187, 0, 0, 261, 61);
INSERT INTO public.who_global_data VALUES (61691, 0, 18, 0, 0, 261, 7);
INSERT INTO public.who_global_data VALUES (61692, 44, 6443, 3, 304, 261, 169);
INSERT INTO public.who_global_data VALUES (61693, 353, 141312, 109, 28081, 261, 28);
INSERT INTO public.who_global_data VALUES (61694, 8, 218, 0, 1, 261, 85);
INSERT INTO public.who_global_data VALUES (61695, 0, 60, 0, 0, 261, 211);
INSERT INTO public.who_global_data VALUES (61696, 65, 1567, 0, 12, 261, 60);
INSERT INTO public.who_global_data VALUES (61697, 0, 24, 0, 1, 261, 3);
INSERT INTO public.who_global_data VALUES (61698, 8, 721, 0, 12, 261, 11);
INSERT INTO public.who_global_data VALUES (61699, 745, 176752, 57, 8147, 261, 89);
INSERT INTO public.who_global_data VALUES (61700, 0, 6096, 0, 31, 261, 24);
INSERT INTO public.who_global_data VALUES (61701, 0, 147, 0, 0, 261, 162);
INSERT INTO public.who_global_data VALUES (61702, 10, 2850, 1, 166, 261, 100);
INSERT INTO public.who_global_data VALUES (61703, 0, 11, 0, 0, 261, 47);
INSERT INTO public.who_global_data VALUES (61704, 0, 22, 0, 0, 261, 29);
INSERT INTO public.who_global_data VALUES (61705, 0, 155, 0, 13, 261, 40);
INSERT INTO public.who_global_data VALUES (61706, 11, 160, 0, 5, 261, 222);
INSERT INTO public.who_global_data VALUES (61707, 132, 2133, 5, 43, 261, 132);
INSERT INTO public.who_global_data VALUES (61708, 0, 252, 0, 13, 261, 130);
INSERT INTO public.who_global_data VALUES (61709, 64, 2927, 1, 19, 261, 234);
INSERT INTO public.who_global_data VALUES (61710, 51, 1089, 0, 6, 261, 23);
INSERT INTO public.who_global_data VALUES (61711, 1, 125, 0, 10, 261, 192);
INSERT INTO public.who_global_data VALUES (61712, 63, 596, 1, 22, 261, 69);
INSERT INTO public.who_global_data VALUES (61713, 0, 12, 0, 0, 261, 187);
INSERT INTO public.who_global_data VALUES (61714, 157, 2955, 1, 147, 261, 230);
INSERT INTO public.who_global_data VALUES (61715, 43, 3641, 3, 473, 261, 77);
INSERT INTO public.who_global_data VALUES (61716, 1, 1803, 0, 10, 261, 9);
INSERT INTO public.who_global_data VALUES (61717, 5609, 112359, 132, 3435, 261, 74);
INSERT INTO public.who_global_data VALUES (61718, 973, 20162, 36, 1278, 261, 224);
INSERT INTO public.who_global_data VALUES (61719, 2392, 129341, 66, 7249, 261, 199);
INSERT INTO public.who_global_data VALUES (61720, 153, 3877, 6, 140, 261, 190);
INSERT INTO public.who_global_data VALUES (61721, 64, 24315, 10, 1571, 261, 12);
INSERT INTO public.who_global_data VALUES (61722, 0, 335, 0, 24, 261, 104);
INSERT INTO public.who_global_data VALUES (61723, 22, 16598, 2, 280, 261, 153);
INSERT INTO public.who_global_data VALUES (61724, 665, 227364, 161, 32330, 261, 91);
INSERT INTO public.who_global_data VALUES (61725, 0, 520, 0, 9, 261, 215);
INSERT INTO public.who_global_data VALUES (61726, 39, 16424, 6, 777, 261, 84);
INSERT INTO public.who_global_data VALUES (61727, 0, 303, 1, 28, 261, 231);
INSERT INTO public.who_global_data VALUES (61728, 12, 684, 0, 9, 261, 196);
INSERT INTO public.who_global_data VALUES (61729, 363, 7597, 0, 35, 261, 105);
INSERT INTO public.who_global_data VALUES (61730, 66, 1029, 0, 50, 261, 122);
INSERT INTO public.who_global_data VALUES (61731, 0, 0, 0, 0, 261, 159);
INSERT INTO public.who_global_data VALUES (61732, 0, 989, 0, 20, 261, 75);
INSERT INTO public.who_global_data VALUES (61733, 1041, 18609, 5, 129, 261, 27);
INSERT INTO public.who_global_data VALUES (61734, 43, 1313, 0, 14, 261, 54);
INSERT INTO public.who_global_data VALUES (61735, 0, 19, 0, 0, 261, 226);
INSERT INTO public.who_global_data VALUES (61736, 4, 1016, 0, 21, 261, 79);
INSERT INTO public.who_global_data VALUES (61737, 63, 1024, 0, 26, 261, 56);
INSERT INTO public.who_global_data VALUES (61738, 0, 1, 0, 0, 261, 117);
INSERT INTO public.who_global_data VALUES (61739, 5, 238, 0, 23, 261, 152);
INSERT INTO public.who_global_data VALUES (61740, 3, 71, 0, 3, 261, 16);
INSERT INTO public.who_global_data VALUES (61741, 0, 83, 0, 1, 261, 10);
INSERT INTO public.who_global_data VALUES (61742, 12, 1592, 0, 61, 261, 201);
INSERT INTO public.who_global_data VALUES (61743, 13, 3971, 0, 109, 261, 174);
INSERT INTO public.who_global_data VALUES (61744, 45, 371, 0, 2, 261, 119);
INSERT INTO public.who_global_data VALUES (61745, 1, 72, 0, 3, 261, 168);
INSERT INTO public.who_global_data VALUES (61746, 31, 7009, 0, 114, 261, 99);
INSERT INTO public.who_global_data VALUES (61747, 30, 1216, 0, 4, 261, 171);
INSERT INTO public.who_global_data VALUES (61748, 30, 931, 2, 55, 261, 87);
INSERT INTO public.who_global_data VALUES (61749, 15, 598, 0, 6, 261, 123);
INSERT INTO public.who_global_data VALUES (61750, 0, 0, 0, 0, 261, 151);
INSERT INTO public.who_global_data VALUES (61751, 0, 192, 0, 14, 261, 213);
INSERT INTO public.who_global_data VALUES (61752, 10, 141, 0, 4, 261, 118);
INSERT INTO public.who_global_data VALUES (61753, 0, 332, 0, 10, 261, 134);
INSERT INTO public.who_global_data VALUES (61754, 56, 1475, 0, 19, 261, 65);
INSERT INTO public.who_global_data VALUES (61755, 2713, 54346, 334, 5666, 261, 102);
INSERT INTO public.who_global_data VALUES (61756, 0, 0, 0, 0, 261, 223);
INSERT INTO public.who_global_data VALUES (61757, 0, 68, 0, 1, 261, 4);
INSERT INTO public.who_global_data VALUES (61758, 0, 140, 0, 0, 261, 146);
INSERT INTO public.who_global_data VALUES (61759, 0, 324, 0, 9, 261, 31);
INSERT INTO public.who_global_data VALUES (61760, 0, 11, 0, 1, 261, 127);
INSERT INTO public.who_global_data VALUES (61761, 137, 7185, 2, 196, 261, 22);
INSERT INTO public.who_global_data VALUES (61762, 10, 156, 0, 0, 261, 115);
INSERT INTO public.who_global_data VALUES (61763, 6, 199, 0, 6, 261, 106);
INSERT INTO public.who_global_data VALUES (61764, 0, 16, 0, 0, 261, 90);
INSERT INTO public.who_global_data VALUES (61765, 0, 0, 0, 0, 261, 70);
INSERT INTO public.who_global_data VALUES (61766, 27, 454, 1, 3, 261, 46);
INSERT INTO public.who_global_data VALUES (61767, 187, 44208, 33, 5722, 261, 139);
INSERT INTO public.who_global_data VALUES (61768, 0, 18, 0, 0, 261, 42);
INSERT INTO public.who_global_data VALUES (61769, 0, 1153, 0, 21, 261, 80);
INSERT INTO public.who_global_data VALUES (61770, 254, 279, 9, 17, 261, 203);
INSERT INTO public.who_global_data VALUES (61771, 6, 920, 3, 58, 261, 136);
INSERT INTO public.who_global_data VALUES (61772, 276, 6677, 8, 200, 261, 63);
INSERT INTO public.who_global_data VALUES (61773, 0, 0, 0, 0, 261, 17);
INSERT INTO public.who_global_data VALUES (61774, 0, 21, 0, 2, 261, 172);
INSERT INTO public.who_global_data VALUES (61775, 19, 1858, 4, 110, 261, 109);
INSERT INTO public.who_global_data VALUES (61776, 11, 8268, 1, 234, 261, 200);
INSERT INTO public.who_global_data VALUES (61777, 19, 596, 0, 4, 261, 93);
INSERT INTO public.who_global_data VALUES (61778, 327, 6370, 1, 30, 261, 5);
INSERT INTO public.who_global_data VALUES (61779, 0, 712, 0, 13, 261, 214);
INSERT INTO public.who_global_data VALUES (61780, 2193, 48091, 32, 1017, 261, 204);
INSERT INTO public.who_global_data VALUES (61781, 0, 0, 0, 0, 261, 198);
INSERT INTO public.who_global_data VALUES (61782, 141, 9867, 2, 281, 261, 173);
INSERT INTO public.who_global_data VALUES (61783, 0, 8, 0, 0, 261, 229);
INSERT INTO public.who_global_data VALUES (61784, 4, 833, 0, 11, 261, 76);
INSERT INTO public.who_global_data VALUES (61785, 4550, 99483, 125, 2914, 261, 138);
INSERT INTO public.who_global_data VALUES (61786, 492, 13434, 9, 846, 261, 98);
INSERT INTO public.who_global_data VALUES (61787, 0, 0, 0, 0, 261, 103);
INSERT INTO public.who_global_data VALUES (61788, 471, 19739, 14, 962, 261, 225);
INSERT INTO public.who_global_data VALUES (61789, 228, 29660, 16, 1263, 261, 131);
INSERT INTO public.who_global_data VALUES (61790, 61, 2866, 1, 125, 261, 235);
INSERT INTO public.who_global_data VALUES (61791, 1554, 38651, 1, 17, 261, 137);
INSERT INTO public.who_global_data VALUES (61792, 12, 11122, 1, 264, 261, 81);
INSERT INTO public.who_global_data VALUES (61793, 213, 6553, 8, 232, 261, 182);
INSERT INTO public.who_global_data VALUES (61794, 1, 447, 1, 1, 261, 145);
INSERT INTO public.who_global_data VALUES (61795, 196, 17387, 15, 1141, 261, 26);
INSERT INTO public.who_global_data VALUES (61796, 8849, 317554, 127, 3099, 261, 170);
INSERT INTO public.who_global_data VALUES (61797, 6, 314, 0, 0, 261, 191);
INSERT INTO public.who_global_data VALUES (61798, 0, 2, 0, 0, 261, 221);
INSERT INTO public.who_global_data VALUES (61799, 0, 6, 0, 0, 261, 64);
INSERT INTO public.who_global_data VALUES (61800, 0, 0, 0, 0, 261, 116);
INSERT INTO public.who_global_data VALUES (61801, 0, 15, 0, 0, 261, 128);
INSERT INTO public.who_global_data VALUES (61802, 0, 18, 0, 0, 261, 6);
INSERT INTO public.who_global_data VALUES (61803, 0, 39, 0, 3, 261, 227);
INSERT INTO public.who_global_data VALUES (61804, 0, 1, 0, 0, 261, 68);
INSERT INTO public.who_global_data VALUES (61805, 1, 18, 0, 0, 261, 184);
INSERT INTO public.who_global_data VALUES (61806, 0, 0, 0, 0, 261, 82);
INSERT INTO public.who_global_data VALUES (61807, 2, 670, 0, 41, 261, 149);
INSERT INTO public.who_global_data VALUES (61808, 0, 165, 1, 8, 261, 197);
INSERT INTO public.who_global_data VALUES (61809, 2532, 65077, 12, 351, 261, 78);
INSERT INTO public.who_global_data VALUES (61810, 97, 2714, 0, 30, 261, 233);
INSERT INTO public.who_global_data VALUES (61811, 100, 10833, 1, 235, 261, 133);
INSERT INTO public.who_global_data VALUES (61812, 0, 11, 0, 0, 261, 35);
INSERT INTO public.who_global_data VALUES (61813, 36, 570, 1, 34, 261, 114);
INSERT INTO public.who_global_data VALUES (61814, 570, 29364, 0, 22, 261, 237);
INSERT INTO public.who_global_data VALUES (61815, 0, 2, 0, 0, 261, 55);
INSERT INTO public.who_global_data VALUES (61816, 0, 78, 0, 15, 261, 176);
INSERT INTO public.who_global_data VALUES (61817, 1, 1496, 0, 28, 261, 202);
INSERT INTO public.who_global_data VALUES (61818, 0, 1468, 1, 113, 261, 155);
INSERT INTO public.who_global_data VALUES (61819, 0, 0, 0, 0, 261, 32);
INSERT INTO public.who_global_data VALUES (61820, 21, 1594, 0, 61, 261, 220);
INSERT INTO public.who_global_data VALUES (61821, 803, 18003, 27, 339, 261, 30);
INSERT INTO public.who_global_data VALUES (61822, 57, 339, 2, 6, 261, 147);
INSERT INTO public.who_global_data VALUES (61823, 948, 239693, 67, 28517, 261, 208);
INSERT INTO public.who_global_data VALUES (61824, 18, 1045, 0, 9, 261, 45);
INSERT INTO public.who_global_data VALUES (61825, 410, 3138, 10, 121, 261, 110);
INSERT INTO public.who_global_data VALUES (61826, 0, 11, 0, 1, 261, 88);
INSERT INTO public.who_global_data VALUES (61827, 666, 31814, 41, 4129, 261, 51);
INSERT INTO public.who_global_data VALUES (61828, 29, 30661, 0, 1703, 261, 209);
INSERT INTO public.who_global_data VALUES (61829, 0, 58, 0, 3, 261, 205);
INSERT INTO public.who_global_data VALUES (61830, 204, 2140, 0, 44, 261, 18);
INSERT INTO public.who_global_data VALUES (61831, 3, 3037, 0, 56, 261, 72);
INSERT INTO public.who_global_data VALUES (61832, 3052, 235731, 328, 34794, 261, 44);
INSERT INTO public.who_global_data VALUES (61833, 0, 24, 0, 0, 261, 15);
INSERT INTO public.who_global_data VALUES (61834, 0, 338, 0, 12, 261, 25);
INSERT INTO public.who_global_data VALUES (61835, 0, 0, 0, 0, 261, 179);
INSERT INTO public.who_global_data VALUES (61836, 0, 0, 0, 0, 261, 34);
INSERT INTO public.who_global_data VALUES (61837, 0, 116, 0, 8, 261, 207);
INSERT INTO public.who_global_data VALUES (61838, 1, 1045, 0, 47, 261, 166);
INSERT INTO public.who_global_data VALUES (61839, 972, 152587, 23, 4222, 261, 126);
INSERT INTO public.who_global_data VALUES (61840, 0, 0, 0, 0, 261, 97);
INSERT INTO public.who_global_data VALUES (61841, 0, 12, 0, 1, 261, 36);
INSERT INTO public.who_global_data VALUES (61842, 0, 0, 0, 0, 261, 125);
INSERT INTO public.who_global_data VALUES (61843, 4, 264, 0, 0, 261, 124);
INSERT INTO public.who_global_data VALUES (61844, 476, 19706, 15, 579, 261, 185);
INSERT INTO public.who_global_data VALUES (61845, 941, 26004, 6, 233, 261, 194);
INSERT INTO public.who_global_data VALUES (61846, 0, 509, 0, 21, 261, 144);
INSERT INTO public.who_global_data VALUES (61847, 23310, 1525186, 1324, 91527, 261, 19);
INSERT INTO public.who_global_data VALUES (61848, 0, 69, 0, 6, 261, 217);
INSERT INTO public.who_global_data VALUES (61849, 1, 738, 0, 20, 261, 148);
INSERT INTO public.who_global_data VALUES (61850, 70, 2950, 0, 13, 261, 86);
INSERT INTO public.who_global_data VALUES (61851, 0, 0, 0, 0, 261, 13);
INSERT INTO public.who_global_data VALUES (61852, 206, 824, 0, 10, 261, 157);
INSERT INTO public.who_global_data VALUES (61853, 0, 324, 0, 0, 261, 8);
INSERT INTO public.who_global_data VALUES (61854, 0, 0, 0, 0, 261, 73);
INSERT INTO public.who_global_data VALUES (61855, 13, 184, 1, 30, 261, 101);
INSERT INTO public.who_global_data VALUES (61856, 60, 832, 0, 7, 261, 165);
INSERT INTO public.who_global_data VALUES (61857, 2, 48, 0, 4, 261, 14);
INSERT INTO public.who_global_data VALUES (61858, 490, 8145, 10, 187, 262, 193);
INSERT INTO public.who_global_data VALUES (61859, 16, 926, 0, 30, 262, 113);
INSERT INTO public.who_global_data VALUES (61860, 176, 7377, 6, 561, 262, 143);
INSERT INTO public.who_global_data VALUES (61861, 0, 0, 0, 0, 262, 219);
INSERT INTO public.who_global_data VALUES (61862, 0, 761, 0, 51, 262, 186);
INSERT INTO public.who_global_data VALUES (61863, 2, 52, 1, 3, 262, 52);
INSERT INTO public.who_global_data VALUES (61864, 0, 3, 0, 0, 262, 180);
INSERT INTO public.who_global_data VALUES (61865, 0, 25, 0, 3, 262, 167);
INSERT INTO public.who_global_data VALUES (61866, 303, 8371, 9, 382, 262, 154);
INSERT INTO public.who_global_data VALUES (61867, 218, 5017, 3, 64, 262, 94);
INSERT INTO public.who_global_data VALUES (61868, 0, 101, 0, 3, 262, 66);
INSERT INTO public.who_global_data VALUES (61869, 8, 7068, 0, 99, 262, 58);
INSERT INTO public.who_global_data VALUES (61870, 78, 16257, 3, 632, 262, 163);
INSERT INTO public.who_global_data VALUES (61871, 131, 3518, 1, 41, 262, 37);
INSERT INTO public.who_global_data VALUES (61872, 0, 96, 0, 11, 262, 142);
INSERT INTO public.who_global_data VALUES (61873, 158, 7532, 0, 12, 262, 83);
INSERT INTO public.who_global_data VALUES (61874, 1617, 26738, 16, 386, 262, 228);
INSERT INTO public.who_global_data VALUES (61875, 0, 88, 0, 7, 262, 188);
INSERT INTO public.who_global_data VALUES (61876, 936, 31508, 4, 175, 262, 62);
INSERT INTO public.who_global_data VALUES (61877, 292, 57019, 32, 9041, 262, 160);
INSERT INTO public.who_global_data VALUES (61878, 0, 18, 0, 2, 262, 50);
INSERT INTO public.who_global_data VALUES (61879, 1, 130, 0, 2, 262, 33);
INSERT INTO public.who_global_data VALUES (61880, 2, 125, 0, 9, 262, 183);
INSERT INTO public.who_global_data VALUES (61881, 0, 21, 0, 0, 262, 92);
INSERT INTO public.who_global_data VALUES (61882, 175, 4263, 5, 174, 262, 158);
INSERT INTO public.who_global_data VALUES (61883, 0, 2, 0, 0, 262, 67);
INSERT INTO public.who_global_data VALUES (61884, 16, 2319, 1, 133, 262, 57);
INSERT INTO public.who_global_data VALUES (61885, 0, 25, 0, 1, 262, 38);
INSERT INTO public.who_global_data VALUES (61886, 13140, 254220, 674, 16792, 262, 141);
INSERT INTO public.who_global_data VALUES (61887, 0, 8, 0, 1, 262, 178);
INSERT INTO public.who_global_data VALUES (61888, 0, 141, 0, 1, 262, 108);
INSERT INTO public.who_global_data VALUES (61889, 33, 2292, 4, 116, 262, 39);
INSERT INTO public.who_global_data VALUES (61890, 10, 806, 1, 52, 262, 2);
INSERT INTO public.who_global_data VALUES (61891, 0, 42, 0, 1, 262, 195);
INSERT INTO public.who_global_data VALUES (61892, 7, 335, 0, 3, 262, 107);
INSERT INTO public.who_global_data VALUES (61893, 0, 122, 0, 0, 262, 161);
INSERT INTO public.who_global_data VALUES (61894, 0, 3529, 0, 140, 262, 212);
INSERT INTO public.who_global_data VALUES (61895, 1193, 78499, 52, 5857, 262, 181);
INSERT INTO public.who_global_data VALUES (61896, 0, 94, 0, 1, 262, 53);
INSERT INTO public.who_global_data VALUES (61897, 75, 411, 0, 0, 262, 164);
INSERT INTO public.who_global_data VALUES (61898, 26, 545, 2, 56, 262, 140);
INSERT INTO public.who_global_data VALUES (61899, 0, 46059, 0, 478, 262, 20);
INSERT INTO public.who_global_data VALUES (61900, 5, 84505, 0, 4645, 262, 112);
INSERT INTO public.who_global_data VALUES (61901, 721, 16295, 18, 592, 262, 111);
INSERT INTO public.who_global_data VALUES (61902, 23, 34, 0, 1, 262, 71);
INSERT INTO public.who_global_data VALUES (61903, 6, 420, 0, 15, 262, 218);
INSERT INTO public.who_global_data VALUES (61904, 0, 0, 0, 0, 262, 43);
INSERT INTO public.who_global_data VALUES (61905, 19, 882, 0, 10, 262, 49);
INSERT INTO public.who_global_data VALUES (61906, 34, 2153, 0, 28, 262, 1);
INSERT INTO public.who_global_data VALUES (61907, 4, 2232, 1, 96, 262, 48);
INSERT INTO public.who_global_data VALUES (61908, 6, 1887, 0, 79, 262, 232);
INSERT INTO public.who_global_data VALUES (61909, 0, 16, 0, 1, 262, 175);
INSERT INTO public.who_global_data VALUES (61910, 1, 918, 0, 17, 262, 21);
INSERT INTO public.who_global_data VALUES (61911, 61, 8647, 5, 302, 262, 156);
INSERT INTO public.who_global_data VALUES (61912, 0, 0, 0, 0, 262, 95);
INSERT INTO public.who_global_data VALUES (61913, 193, 1730, 0, 60, 262, 177);
INSERT INTO public.who_global_data VALUES (61914, 76, 11044, 3, 551, 262, 210);
INSERT INTO public.who_global_data VALUES (61915, 210, 1828, 2, 9, 262, 120);
INSERT INTO public.who_global_data VALUES (61916, 0, 16, 0, 0, 262, 135);
INSERT INTO public.who_global_data VALUES (61917, 498, 13223, 7, 441, 262, 206);
INSERT INTO public.who_global_data VALUES (61918, 969, 34151, 103, 2839, 262, 189);
INSERT INTO public.who_global_data VALUES (61919, 1465, 14229, 35, 680, 262, 129);
INSERT INTO public.who_global_data VALUES (61920, 85, 1498, 0, 30, 262, 121);
INSERT INTO public.who_global_data VALUES (61921, 65, 890, 0, 7, 262, 59);
INSERT INTO public.who_global_data VALUES (61922, 0, 39, 0, 0, 262, 96);
INSERT INTO public.who_global_data VALUES (61923, 7, 1791, 0, 63, 262, 41);
INSERT INTO public.who_global_data VALUES (61924, 3, 208, 0, 2, 262, 216);
INSERT INTO public.who_global_data VALUES (61925, 13, 365, 0, 5, 262, 236);
INSERT INTO public.who_global_data VALUES (61926, 0, 13, 0, 0, 262, 150);
INSERT INTO public.who_global_data VALUES (61927, 0, 187, 0, 0, 262, 61);
INSERT INTO public.who_global_data VALUES (61928, 0, 18, 0, 0, 262, 7);
INSERT INTO public.who_global_data VALUES (61929, 19, 6399, 1, 301, 262, 169);
INSERT INTO public.who_global_data VALUES (61930, 462, 140959, 124, 27972, 262, 28);
INSERT INTO public.who_global_data VALUES (61931, 13, 210, 0, 1, 262, 85);
INSERT INTO public.who_global_data VALUES (61932, 0, 60, 0, 0, 262, 211);
INSERT INTO public.who_global_data VALUES (61933, 70, 1502, 1, 12, 262, 60);
INSERT INTO public.who_global_data VALUES (61934, 0, 24, 0, 1, 262, 3);
INSERT INTO public.who_global_data VALUES (61935, 11, 713, 0, 12, 262, 11);
INSERT INTO public.who_global_data VALUES (61936, 797, 176007, 83, 8090, 262, 89);
INSERT INTO public.who_global_data VALUES (61937, 361, 6096, 2, 31, 262, 24);
INSERT INTO public.who_global_data VALUES (61938, 0, 147, 0, 0, 262, 162);
INSERT INTO public.who_global_data VALUES (61939, 4, 2840, 0, 165, 262, 100);
INSERT INTO public.who_global_data VALUES (61940, 0, 11, 0, 0, 262, 47);
INSERT INTO public.who_global_data VALUES (61941, 0, 22, 0, 0, 262, 29);
INSERT INTO public.who_global_data VALUES (61942, 0, 155, 0, 13, 262, 40);
INSERT INTO public.who_global_data VALUES (61943, 0, 149, 0, 5, 262, 222);
INSERT INTO public.who_global_data VALUES (61944, 89, 2001, 3, 38, 262, 132);
INSERT INTO public.who_global_data VALUES (61945, 0, 252, 0, 13, 262, 130);
INSERT INTO public.who_global_data VALUES (61946, 67, 2863, 2, 18, 262, 234);
INSERT INTO public.who_global_data VALUES (61947, 0, 1038, 0, 6, 262, 23);
INSERT INTO public.who_global_data VALUES (61948, 7, 124, 0, 10, 262, 192);
INSERT INTO public.who_global_data VALUES (61949, 77, 533, 1, 21, 262, 69);
INSERT INTO public.who_global_data VALUES (61950, 0, 12, 0, 0, 262, 187);
INSERT INTO public.who_global_data VALUES (61951, 152, 2798, 4, 146, 262, 230);
INSERT INTO public.who_global_data VALUES (61952, 42, 3598, 3, 470, 262, 77);
INSERT INTO public.who_global_data VALUES (61953, 0, 1802, 0, 10, 262, 9);
INSERT INTO public.who_global_data VALUES (61954, 5611, 106750, 140, 3303, 262, 74);
INSERT INTO public.who_global_data VALUES (61955, 693, 19189, 21, 1242, 262, 224);
INSERT INTO public.who_global_data VALUES (61956, 2346, 126949, 64, 7183, 262, 199);
INSERT INTO public.who_global_data VALUES (61957, 113, 3724, 3, 134, 262, 190);
INSERT INTO public.who_global_data VALUES (61958, 51, 24251, 14, 1561, 262, 12);
INSERT INTO public.who_global_data VALUES (61959, 0, 335, 0, 24, 262, 104);
INSERT INTO public.who_global_data VALUES (61960, 27, 16576, 3, 278, 262, 153);
INSERT INTO public.who_global_data VALUES (61961, 813, 226699, 162, 32169, 262, 91);
INSERT INTO public.who_global_data VALUES (61962, 0, 520, 0, 9, 262, 215);
INSERT INTO public.who_global_data VALUES (61963, 20, 16385, 8, 771, 262, 84);
INSERT INTO public.who_global_data VALUES (61964, 1, 303, 0, 27, 262, 231);
INSERT INTO public.who_global_data VALUES (61965, 23, 672, 0, 9, 262, 196);
INSERT INTO public.who_global_data VALUES (61966, 265, 7234, 0, 35, 262, 105);
INSERT INTO public.who_global_data VALUES (61967, 51, 963, 0, 50, 262, 122);
INSERT INTO public.who_global_data VALUES (61968, 0, 0, 0, 0, 262, 159);
INSERT INTO public.who_global_data VALUES (61969, 34, 989, 0, 20, 262, 75);
INSERT INTO public.who_global_data VALUES (61970, 804, 17568, 3, 124, 262, 27);
INSERT INTO public.who_global_data VALUES (61971, 27, 1270, 0, 14, 262, 54);
INSERT INTO public.who_global_data VALUES (61972, 0, 19, 0, 0, 262, 226);
INSERT INTO public.who_global_data VALUES (61973, 3, 1012, 2, 21, 262, 79);
INSERT INTO public.who_global_data VALUES (61974, 7, 961, 0, 26, 262, 56);
INSERT INTO public.who_global_data VALUES (61975, 0, 1, 0, 0, 262, 117);
INSERT INTO public.who_global_data VALUES (61976, 4, 233, 1, 23, 262, 152);
INSERT INTO public.who_global_data VALUES (61977, 3, 68, 0, 3, 262, 16);
INSERT INTO public.who_global_data VALUES (61978, 0, 83, 0, 1, 262, 10);
INSERT INTO public.who_global_data VALUES (61979, 21, 1580, 1, 61, 262, 201);
INSERT INTO public.who_global_data VALUES (61980, 11, 3958, 2, 109, 262, 174);
INSERT INTO public.who_global_data VALUES (61981, 4, 326, 1, 2, 262, 119);
INSERT INTO public.who_global_data VALUES (61982, 1, 71, 0, 3, 262, 168);
INSERT INTO public.who_global_data VALUES (61983, 37, 6978, 1, 114, 262, 99);
INSERT INTO public.who_global_data VALUES (61984, 43, 1186, 0, 4, 262, 171);
INSERT INTO public.who_global_data VALUES (61985, 27, 901, 1, 53, 262, 87);
INSERT INTO public.who_global_data VALUES (61986, 15, 583, 0, 6, 262, 123);
INSERT INTO public.who_global_data VALUES (61987, 0, 0, 0, 0, 262, 151);
INSERT INTO public.who_global_data VALUES (61988, 0, 192, 0, 14, 262, 213);
INSERT INTO public.who_global_data VALUES (61989, 50, 131, 0, 4, 262, 118);
INSERT INTO public.who_global_data VALUES (61990, 0, 332, 0, 10, 262, 134);
INSERT INTO public.who_global_data VALUES (61991, 49, 1419, 1, 19, 262, 65);
INSERT INTO public.who_global_data VALUES (61992, 2414, 51633, 155, 5332, 262, 102);
INSERT INTO public.who_global_data VALUES (61993, 0, 0, 0, 0, 262, 223);
INSERT INTO public.who_global_data VALUES (61994, 0, 68, 0, 1, 262, 4);
INSERT INTO public.who_global_data VALUES (61995, 0, 140, 0, 0, 262, 146);
INSERT INTO public.who_global_data VALUES (61996, 0, 324, 0, 9, 262, 31);
INSERT INTO public.who_global_data VALUES (61997, 0, 11, 0, 1, 262, 127);
INSERT INTO public.who_global_data VALUES (61998, 76, 7048, 1, 194, 262, 22);
INSERT INTO public.who_global_data VALUES (61999, 1, 146, 0, 0, 262, 115);
INSERT INTO public.who_global_data VALUES (62000, 2, 193, 0, 6, 262, 106);
INSERT INTO public.who_global_data VALUES (62001, 0, 16, 0, 0, 262, 90);
INSERT INTO public.who_global_data VALUES (62002, 0, 0, 0, 0, 262, 70);
INSERT INTO public.who_global_data VALUES (62003, 25, 427, 0, 2, 262, 46);
INSERT INTO public.who_global_data VALUES (62004, 111, 44021, 24, 5689, 262, 139);
INSERT INTO public.who_global_data VALUES (62005, 0, 18, 0, 0, 262, 42);
INSERT INTO public.who_global_data VALUES (62006, 0, 1153, 0, 21, 262, 80);
INSERT INTO public.who_global_data VALUES (62007, 0, 25, 0, 8, 262, 203);
INSERT INTO public.who_global_data VALUES (62008, 5, 914, 0, 55, 262, 136);
INSERT INTO public.who_global_data VALUES (62009, 226, 6401, 1, 192, 262, 63);
INSERT INTO public.who_global_data VALUES (62010, 0, 0, 0, 0, 262, 17);
INSERT INTO public.who_global_data VALUES (62011, 0, 21, 0, 2, 262, 172);
INSERT INTO public.who_global_data VALUES (62012, 22, 1839, 2, 106, 262, 109);
INSERT INTO public.who_global_data VALUES (62013, 8, 8257, 0, 233, 262, 200);
INSERT INTO public.who_global_data VALUES (62014, 10, 577, 0, 4, 262, 93);
INSERT INTO public.who_global_data VALUES (62015, 372, 6043, 2, 29, 262, 5);
INSERT INTO public.who_global_data VALUES (62016, 0, 712, 0, 13, 262, 214);
INSERT INTO public.who_global_data VALUES (62017, 1932, 45898, 46, 985, 262, 204);
INSERT INTO public.who_global_data VALUES (62018, 0, 0, 0, 0, 262, 198);
INSERT INTO public.who_global_data VALUES (62019, 120, 9726, 4, 279, 262, 173);
INSERT INTO public.who_global_data VALUES (62020, 0, 8, 0, 0, 262, 229);
INSERT INTO public.who_global_data VALUES (62021, 41, 829, 0, 11, 262, 76);
INSERT INTO public.who_global_data VALUES (62022, 2660, 94933, 141, 2789, 262, 138);
INSERT INTO public.who_global_data VALUES (62023, 224, 12942, 6, 837, 262, 98);
INSERT INTO public.who_global_data VALUES (62024, 0, 0, 0, 0, 262, 103);
INSERT INTO public.who_global_data VALUES (62025, 383, 19268, 12, 948, 262, 225);
INSERT INTO public.who_global_data VALUES (62026, 223, 29432, 16, 1247, 262, 131);
INSERT INTO public.who_global_data VALUES (62027, 95, 2805, 0, 124, 262, 235);
INSERT INTO public.who_global_data VALUES (62028, 1491, 37097, 1, 16, 262, 137);
INSERT INTO public.who_global_data VALUES (62029, 32, 11110, 0, 263, 262, 81);
INSERT INTO public.who_global_data VALUES (62030, 202, 6340, 5, 224, 262, 182);
INSERT INTO public.who_global_data VALUES (62031, 0, 446, 0, 0, 262, 145);
INSERT INTO public.who_global_data VALUES (62032, 155, 17191, 19, 1126, 262, 26);
INSERT INTO public.who_global_data VALUES (62033, 8764, 308705, 135, 2972, 262, 170);
INSERT INTO public.who_global_data VALUES (62034, 11, 308, 0, 0, 262, 191);
INSERT INTO public.who_global_data VALUES (62035, 0, 2, 0, 0, 262, 221);
INSERT INTO public.who_global_data VALUES (62036, 0, 6, 0, 0, 262, 64);
INSERT INTO public.who_global_data VALUES (62037, 0, 0, 0, 0, 262, 116);
INSERT INTO public.who_global_data VALUES (62038, 0, 15, 0, 0, 262, 128);
INSERT INTO public.who_global_data VALUES (62039, 0, 18, 0, 0, 262, 6);
INSERT INTO public.who_global_data VALUES (62040, 0, 39, 0, 3, 262, 227);
INSERT INTO public.who_global_data VALUES (62041, 0, 1, 0, 0, 262, 68);
INSERT INTO public.who_global_data VALUES (62042, 0, 17, 0, 0, 262, 184);
INSERT INTO public.who_global_data VALUES (62043, 0, 0, 0, 0, 262, 82);
INSERT INTO public.who_global_data VALUES (62044, 0, 668, 0, 41, 262, 149);
INSERT INTO public.who_global_data VALUES (62045, 0, 165, 0, 7, 262, 197);
INSERT INTO public.who_global_data VALUES (62046, 2691, 62545, 10, 339, 262, 78);
INSERT INTO public.who_global_data VALUES (62047, 73, 2617, 4, 30, 262, 233);
INSERT INTO public.who_global_data VALUES (62048, 34, 10733, 3, 234, 262, 133);
INSERT INTO public.who_global_data VALUES (62049, 0, 11, 0, 0, 262, 35);
INSERT INTO public.who_global_data VALUES (62050, 15, 534, 0, 33, 262, 114);
INSERT INTO public.who_global_data VALUES (62051, 451, 28794, 0, 22, 262, 237);
INSERT INTO public.who_global_data VALUES (62052, 0, 2, 0, 0, 262, 55);
INSERT INTO public.who_global_data VALUES (62053, 0, 78, 0, 15, 262, 176);
INSERT INTO public.who_global_data VALUES (62054, 0, 1495, 0, 28, 262, 202);
INSERT INTO public.who_global_data VALUES (62055, 1, 1468, 1, 112, 262, 155);
INSERT INTO public.who_global_data VALUES (62056, 0, 0, 0, 0, 262, 32);
INSERT INTO public.who_global_data VALUES (62057, 71, 1573, 2, 61, 262, 220);
INSERT INTO public.who_global_data VALUES (62058, 767, 17200, 26, 312, 262, 30);
INSERT INTO public.who_global_data VALUES (62059, 0, 282, 0, 4, 262, 147);
INSERT INTO public.who_global_data VALUES (62060, 682, 238745, 72, 28450, 262, 208);
INSERT INTO public.who_global_data VALUES (62061, 7, 1027, 0, 9, 262, 45);
INSERT INTO public.who_global_data VALUES (62062, 137, 2728, 6, 111, 262, 110);
INSERT INTO public.who_global_data VALUES (62063, 0, 11, 0, 1, 262, 88);
INSERT INTO public.who_global_data VALUES (62064, 430, 31148, 59, 4088, 262, 51);
INSERT INTO public.who_global_data VALUES (62065, 36, 30632, 4, 1703, 262, 209);
INSERT INTO public.who_global_data VALUES (62066, 0, 58, 0, 3, 262, 205);
INSERT INTO public.who_global_data VALUES (62067, 207, 1936, 0, 44, 262, 18);
INSERT INTO public.who_global_data VALUES (62068, 1, 3034, 0, 56, 262, 72);
INSERT INTO public.who_global_data VALUES (62069, 2589, 232679, 500, 34466, 262, 44);
INSERT INTO public.who_global_data VALUES (62070, 0, 24, 0, 0, 262, 15);
INSERT INTO public.who_global_data VALUES (62071, 8, 338, 0, 12, 262, 25);
INSERT INTO public.who_global_data VALUES (62072, 0, 0, 0, 0, 262, 179);
INSERT INTO public.who_global_data VALUES (62073, 0, 0, 0, 0, 262, 34);
INSERT INTO public.who_global_data VALUES (62074, 0, 116, 0, 8, 262, 207);
INSERT INTO public.who_global_data VALUES (62075, 1, 1044, 1, 47, 262, 166);
INSERT INTO public.who_global_data VALUES (62076, 1022, 151615, 28, 4199, 262, 126);
INSERT INTO public.who_global_data VALUES (62077, 0, 0, 0, 0, 262, 97);
INSERT INTO public.who_global_data VALUES (62078, 0, 12, 0, 1, 262, 36);
INSERT INTO public.who_global_data VALUES (62079, 0, 0, 0, 0, 262, 125);
INSERT INTO public.who_global_data VALUES (62080, 0, 260, 0, 0, 262, 124);
INSERT INTO public.who_global_data VALUES (62081, 354, 19230, 16, 564, 262, 185);
INSERT INTO public.who_global_data VALUES (62082, 0, 25063, 0, 227, 262, 194);
INSERT INTO public.who_global_data VALUES (62083, 0, 509, 0, 21, 262, 144);
INSERT INTO public.who_global_data VALUES (62084, 24417, 1501876, 932, 90203, 262, 19);
INSERT INTO public.who_global_data VALUES (62085, 0, 69, 0, 6, 262, 217);
INSERT INTO public.who_global_data VALUES (62086, 3, 737, 0, 20, 262, 148);
INSERT INTO public.who_global_data VALUES (62087, 78, 2880, 0, 13, 262, 86);
INSERT INTO public.who_global_data VALUES (62088, 0, 0, 0, 0, 262, 13);
INSERT INTO public.who_global_data VALUES (62089, 0, 618, 0, 10, 262, 157);
INSERT INTO public.who_global_data VALUES (62090, 0, 324, 0, 0, 262, 8);
INSERT INTO public.who_global_data VALUES (62091, 0, 0, 0, 0, 262, 73);
INSERT INTO public.who_global_data VALUES (62092, 37, 171, 8, 29, 262, 101);
INSERT INTO public.who_global_data VALUES (62093, 11, 772, 0, 7, 262, 165);
INSERT INTO public.who_global_data VALUES (62094, 0, 46, 0, 4, 262, 14);
INSERT INTO public.who_global_data VALUES (62095, 583, 7655, 4, 177, 263, 193);
INSERT INTO public.who_global_data VALUES (62096, 0, 910, 0, 30, 263, 113);
INSERT INTO public.who_global_data VALUES (62097, 182, 7201, 7, 555, 263, 143);
INSERT INTO public.who_global_data VALUES (62098, 0, 0, 0, 0, 263, 219);
INSERT INTO public.who_global_data VALUES (62099, 0, 761, 0, 51, 263, 186);
INSERT INTO public.who_global_data VALUES (62100, 2, 50, 0, 2, 263, 52);
INSERT INTO public.who_global_data VALUES (62101, 0, 3, 0, 0, 263, 180);
INSERT INTO public.who_global_data VALUES (62102, 0, 25, 0, 3, 263, 167);
INSERT INTO public.who_global_data VALUES (62103, 263, 8068, 7, 373, 263, 154);
INSERT INTO public.who_global_data VALUES (62104, 351, 4799, 1, 61, 263, 94);
INSERT INTO public.who_global_data VALUES (62105, 0, 101, 0, 3, 263, 66);
INSERT INTO public.who_global_data VALUES (62106, 15, 7060, 1, 99, 263, 58);
INSERT INTO public.who_global_data VALUES (62107, 25, 16179, 0, 629, 263, 163);
INSERT INTO public.who_global_data VALUES (62108, 113, 3387, 1, 40, 263, 37);
INSERT INTO public.who_global_data VALUES (62109, 0, 96, 0, 11, 263, 142);
INSERT INTO public.who_global_data VALUES (62110, 218, 7374, 0, 12, 263, 83);
INSERT INTO public.who_global_data VALUES (62111, 1251, 25121, 21, 370, 263, 228);
INSERT INTO public.who_global_data VALUES (62112, 2, 88, 0, 7, 263, 188);
INSERT INTO public.who_global_data VALUES (62113, 922, 30572, 6, 171, 263, 62);
INSERT INTO public.who_global_data VALUES (62114, 317, 56727, 35, 9009, 263, 160);
INSERT INTO public.who_global_data VALUES (62115, 0, 18, 0, 2, 263, 50);
INSERT INTO public.who_global_data VALUES (62116, -210, 129, 0, 2, 263, 33);
INSERT INTO public.who_global_data VALUES (62117, 0, 123, 0, 9, 263, 183);
INSERT INTO public.who_global_data VALUES (62118, 0, 21, 0, 0, 263, 92);
INSERT INTO public.who_global_data VALUES (62119, 262, 4088, 4, 169, 263, 158);
INSERT INTO public.who_global_data VALUES (62120, 0, 2, 0, 0, 263, 67);
INSERT INTO public.who_global_data VALUES (62121, 14, 2303, 0, 132, 263, 57);
INSERT INTO public.who_global_data VALUES (62122, 0, 25, 0, 1, 263, 38);
INSERT INTO public.who_global_data VALUES (62123, 7938, 241080, 485, 16118, 263, 141);
INSERT INTO public.who_global_data VALUES (62124, 0, 8, 0, 1, 263, 178);
INSERT INTO public.who_global_data VALUES (62125, 0, 141, 0, 1, 263, 108);
INSERT INTO public.who_global_data VALUES (62126, 24, 2259, 2, 112, 263, 39);
INSERT INTO public.who_global_data VALUES (62127, 0, 796, 0, 51, 263, 2);
INSERT INTO public.who_global_data VALUES (62128, 0, 42, 0, 1, 263, 195);
INSERT INTO public.who_global_data VALUES (62129, 0, 328, 0, 3, 263, 107);
INSERT INTO public.who_global_data VALUES (62130, 0, 122, 0, 0, 263, 161);
INSERT INTO public.who_global_data VALUES (62131, 482, 3529, 1, 140, 263, 212);
INSERT INTO public.who_global_data VALUES (62132, 1102, 77306, 103, 5805, 263, 181);
INSERT INTO public.who_global_data VALUES (62133, 0, 94, 0, 1, 263, 53);
INSERT INTO public.who_global_data VALUES (62134, 9, 336, 0, 0, 263, 164);
INSERT INTO public.who_global_data VALUES (62135, 16, 519, 1, 54, 263, 140);
INSERT INTO public.who_global_data VALUES (62136, 2278, 46059, 28, 478, 263, 20);
INSERT INTO public.who_global_data VALUES (62137, 6, 84500, 0, 4645, 263, 112);
INSERT INTO public.who_global_data VALUES (62138, 635, 15574, 12, 574, 263, 111);
INSERT INTO public.who_global_data VALUES (62139, 0, 11, 0, 1, 263, 71);
INSERT INTO public.who_global_data VALUES (62140, 4, 414, 0, 15, 263, 218);
INSERT INTO public.who_global_data VALUES (62141, 0, 0, 0, 0, 263, 43);
INSERT INTO public.who_global_data VALUES (62142, 10, 863, 0, 10, 263, 49);
INSERT INTO public.who_global_data VALUES (62143, 10, 2119, 1, 28, 263, 1);
INSERT INTO public.who_global_data VALUES (62144, 2, 2228, 0, 95, 263, 48);
INSERT INTO public.who_global_data VALUES (62145, 9, 1881, 0, 79, 263, 232);
INSERT INTO public.who_global_data VALUES (62146, 0, 16, 0, 1, 263, 175);
INSERT INTO public.who_global_data VALUES (62147, 1, 917, 0, 17, 263, 21);
INSERT INTO public.who_global_data VALUES (62148, 111, 8586, 0, 297, 263, 156);
INSERT INTO public.who_global_data VALUES (62149, 0, 0, 0, 0, 263, 95);
INSERT INTO public.who_global_data VALUES (62150, 83, 1537, 0, 60, 263, 177);
INSERT INTO public.who_global_data VALUES (62151, 41, 10968, 1, 548, 263, 210);
INSERT INTO public.who_global_data VALUES (62152, 100, 1618, 0, 7, 263, 120);
INSERT INTO public.who_global_data VALUES (62153, 0, 16, 0, 0, 263, 135);
INSERT INTO public.who_global_data VALUES (62154, 411, 12725, 6, 434, 263, 206);
INSERT INTO public.who_global_data VALUES (62155, 459, 33182, 48, 2736, 263, 189);
INSERT INTO public.who_global_data VALUES (62156, 535, 12764, 15, 645, 263, 129);
INSERT INTO public.who_global_data VALUES (62157, 75, 1413, 3, 30, 263, 121);
INSERT INTO public.who_global_data VALUES (62158, 106, 825, 0, 7, 263, 59);
INSERT INTO public.who_global_data VALUES (62159, 0, 39, 0, 0, 263, 96);
INSERT INTO public.who_global_data VALUES (62160, 10, 1784, 0, 63, 263, 41);
INSERT INTO public.who_global_data VALUES (62161, 2, 205, 0, 2, 263, 216);
INSERT INTO public.who_global_data VALUES (62162, 35, 352, 0, 5, 263, 236);
INSERT INTO public.who_global_data VALUES (62163, 0, 13, 0, 0, 263, 150);
INSERT INTO public.who_global_data VALUES (62164, 0, 187, 0, 0, 263, 61);
INSERT INTO public.who_global_data VALUES (62165, 0, 18, 0, 0, 263, 7);
INSERT INTO public.who_global_data VALUES (62166, 33, 6380, 2, 300, 263, 169);
INSERT INTO public.who_global_data VALUES (62167, 461, 140497, 186, 27848, 263, 28);
INSERT INTO public.who_global_data VALUES (62168, 0, 197, 0, 1, 263, 85);
INSERT INTO public.who_global_data VALUES (62169, 0, 60, 0, 0, 263, 211);
INSERT INTO public.who_global_data VALUES (62170, 112, 1432, 0, 11, 263, 60);
INSERT INTO public.who_global_data VALUES (62171, 0, 24, 0, 1, 263, 3);
INSERT INTO public.who_global_data VALUES (62172, 1, 702, 0, 12, 263, 11);
INSERT INTO public.who_global_data VALUES (62173, 513, 175210, 72, 8007, 263, 89);
INSERT INTO public.who_global_data VALUES (62174, 0, 5735, 0, 29, 263, 24);
INSERT INTO public.who_global_data VALUES (62175, 0, 147, 0, 0, 263, 162);
INSERT INTO public.who_global_data VALUES (62176, 2, 2836, 2, 165, 263, 100);
INSERT INTO public.who_global_data VALUES (62177, 0, 11, 0, 0, 263, 47);
INSERT INTO public.who_global_data VALUES (62178, 0, 22, 0, 0, 263, 29);
INSERT INTO public.who_global_data VALUES (62179, 0, 155, 0, 13, 263, 40);
INSERT INTO public.who_global_data VALUES (62180, 0, 149, 0, 5, 263, 222);
INSERT INTO public.who_global_data VALUES (62181, 149, 1912, 2, 35, 263, 132);
INSERT INTO public.who_global_data VALUES (62182, 0, 252, 0, 13, 263, 130);
INSERT INTO public.who_global_data VALUES (62183, 69, 2796, 0, 16, 263, 234);
INSERT INTO public.who_global_data VALUES (62184, 48, 1038, 2, 6, 263, 23);
INSERT INTO public.who_global_data VALUES (62185, 0, 117, 0, 10, 263, 192);
INSERT INTO public.who_global_data VALUES (62186, 98, 456, 0, 20, 263, 69);
INSERT INTO public.who_global_data VALUES (62187, 0, 12, 0, 0, 263, 187);
INSERT INTO public.who_global_data VALUES (62188, 81, 2646, 4, 142, 263, 230);
INSERT INTO public.who_global_data VALUES (62189, 21, 3556, 5, 467, 263, 77);
INSERT INTO public.who_global_data VALUES (62190, 0, 1802, 0, 10, 263, 9);
INSERT INTO public.who_global_data VALUES (62191, 4970, 101139, 134, 3163, 263, 74);
INSERT INTO public.who_global_data VALUES (62192, 486, 18496, 30, 1221, 263, 224);
INSERT INTO public.who_global_data VALUES (62193, 2111, 124603, 62, 7119, 263, 199);
INSERT INTO public.who_global_data VALUES (62194, 57, 3611, 4, 131, 263, 190);
INSERT INTO public.who_global_data VALUES (62195, 88, 24200, 4, 1547, 263, 12);
INSERT INTO public.who_global_data VALUES (62196, 0, 335, 0, 24, 263, 104);
INSERT INTO public.who_global_data VALUES (62197, 15, 16549, 4, 275, 263, 153);
INSERT INTO public.who_global_data VALUES (62198, 451, 225886, 99, 32007, 263, 91);
INSERT INTO public.who_global_data VALUES (62199, 3, 520, 0, 9, 263, 215);
INSERT INTO public.who_global_data VALUES (62200, 60, 16365, 14, 763, 263, 84);
INSERT INTO public.who_global_data VALUES (62201, 5, 302, 0, 27, 263, 231);
INSERT INTO public.who_global_data VALUES (62202, 20, 649, 0, 9, 263, 196);
INSERT INTO public.who_global_data VALUES (62203, 218, 6969, 0, 35, 263, 105);
INSERT INTO public.who_global_data VALUES (62204, 25, 912, 0, 50, 263, 122);
INSERT INTO public.who_global_data VALUES (62205, 0, 0, 0, 0, 263, 159);
INSERT INTO public.who_global_data VALUES (62206, 0, 955, 0, 20, 263, 75);
INSERT INTO public.who_global_data VALUES (62207, 1073, 16764, 3, 121, 263, 27);
INSERT INTO public.who_global_data VALUES (62208, 27, 1243, 0, 14, 263, 54);
INSERT INTO public.who_global_data VALUES (62209, 0, 19, 0, 0, 263, 226);
INSERT INTO public.who_global_data VALUES (62210, 1, 1009, 0, 19, 263, 79);
INSERT INTO public.who_global_data VALUES (62211, 23, 954, 0, 26, 263, 56);
INSERT INTO public.who_global_data VALUES (62212, 0, 1, 0, 0, 263, 117);
INSERT INTO public.who_global_data VALUES (62213, 3, 229, 1, 22, 263, 152);
INSERT INTO public.who_global_data VALUES (62214, 0, 65, 0, 3, 263, 16);
INSERT INTO public.who_global_data VALUES (62215, 0, 83, 0, 1, 263, 10);
INSERT INTO public.who_global_data VALUES (62216, 8, 1559, 0, 60, 263, 201);
INSERT INTO public.who_global_data VALUES (62217, 2, 3947, 0, 107, 263, 174);
INSERT INTO public.who_global_data VALUES (62218, 18, 322, 0, 1, 263, 119);
INSERT INTO public.who_global_data VALUES (62219, 0, 70, 0, 3, 263, 168);
INSERT INTO public.who_global_data VALUES (62220, 47, 6941, 0, 113, 263, 99);
INSERT INTO public.who_global_data VALUES (62221, 49, 1143, 0, 4, 263, 171);
INSERT INTO public.who_global_data VALUES (62222, 14, 874, 0, 52, 263, 87);
INSERT INTO public.who_global_data VALUES (62223, 11, 568, 0, 6, 263, 123);
INSERT INTO public.who_global_data VALUES (62224, 0, 0, 0, 0, 263, 151);
INSERT INTO public.who_global_data VALUES (62225, 0, 192, 0, 14, 263, 213);
INSERT INTO public.who_global_data VALUES (62226, 19, 81, 0, 4, 263, 118);
INSERT INTO public.who_global_data VALUES (62227, 0, 332, 0, 10, 263, 134);
INSERT INTO public.who_global_data VALUES (62228, 28, 1370, 0, 18, 263, 65);
INSERT INTO public.who_global_data VALUES (62229, 2075, 49219, 132, 5177, 263, 102);
INSERT INTO public.who_global_data VALUES (62230, 0, 0, 0, 0, 263, 223);
INSERT INTO public.who_global_data VALUES (62231, 1, 68, 0, 1, 263, 4);
INSERT INTO public.who_global_data VALUES (62232, 0, 140, 0, 0, 263, 146);
INSERT INTO public.who_global_data VALUES (62233, 0, 324, 0, 9, 263, 31);
INSERT INTO public.who_global_data VALUES (62234, 0, 11, 0, 1, 263, 127);
INSERT INTO public.who_global_data VALUES (62235, 42, 6972, 1, 193, 263, 22);
INSERT INTO public.who_global_data VALUES (62236, 8, 145, 0, 0, 263, 115);
INSERT INTO public.who_global_data VALUES (62237, 3, 191, 0, 6, 263, 106);
INSERT INTO public.who_global_data VALUES (62238, 0, 16, 0, 0, 263, 90);
INSERT INTO public.who_global_data VALUES (62239, 0, 0, 0, 0, 263, 70);
INSERT INTO public.who_global_data VALUES (62240, 45, 402, 0, 2, 263, 46);
INSERT INTO public.who_global_data VALUES (62241, 148, 43910, 13, 5665, 263, 139);
INSERT INTO public.who_global_data VALUES (62242, 0, 18, 0, 0, 263, 42);
INSERT INTO public.who_global_data VALUES (62243, 4, 1153, 0, 21, 263, 80);
INSERT INTO public.who_global_data VALUES (62244, 0, 25, 0, 8, 263, 203);
INSERT INTO public.who_global_data VALUES (62245, 5, 909, 1, 55, 263, 136);
INSERT INTO public.who_global_data VALUES (62246, 216, 6175, 9, 191, 263, 63);
INSERT INTO public.who_global_data VALUES (62247, 0, 0, 0, 0, 263, 17);
INSERT INTO public.who_global_data VALUES (62248, 0, 21, 0, 2, 263, 172);
INSERT INTO public.who_global_data VALUES (62249, 25, 1817, 3, 104, 263, 109);
INSERT INTO public.who_global_data VALUES (62250, 52, 8249, 1, 233, 263, 200);
INSERT INTO public.who_global_data VALUES (62251, 7, 567, 0, 4, 263, 93);
INSERT INTO public.who_global_data VALUES (62252, 292, 5671, 4, 27, 263, 5);
INSERT INTO public.who_global_data VALUES (62253, 0, 712, 0, 13, 263, 214);
INSERT INTO public.who_global_data VALUES (62254, 1841, 43966, 36, 939, 263, 204);
INSERT INTO public.who_global_data VALUES (62255, 0, 0, 0, 0, 263, 198);
INSERT INTO public.who_global_data VALUES (62256, 157, 9606, 6, 275, 263, 173);
INSERT INTO public.who_global_data VALUES (62257, 0, 8, 0, 0, 263, 229);
INSERT INTO public.who_global_data VALUES (62258, 2, 788, 0, 11, 263, 76);
INSERT INTO public.who_global_data VALUES (62259, 3732, 92273, 125, 2648, 263, 138);
INSERT INTO public.who_global_data VALUES (62260, 0, 12718, 0, 831, 263, 98);
INSERT INTO public.who_global_data VALUES (62261, 0, 0, 0, 0, 263, 103);
INSERT INTO public.who_global_data VALUES (62262, 356, 18885, 11, 936, 263, 225);
INSERT INTO public.who_global_data VALUES (62263, 173, 29209, 13, 1231, 263, 131);
INSERT INTO public.who_global_data VALUES (62264, 64, 2710, 1, 124, 263, 235);
INSERT INTO public.who_global_data VALUES (62265, 1637, 35606, 0, 15, 263, 137);
INSERT INTO public.who_global_data VALUES (62266, 13, 11078, 0, 263, 263, 81);
INSERT INTO public.who_global_data VALUES (62267, 78, 6138, 8, 219, 263, 182);
INSERT INTO public.who_global_data VALUES (62268, 3, 446, 0, 0, 263, 145);
INSERT INTO public.who_global_data VALUES (62269, 165, 17036, 10, 1107, 263, 26);
INSERT INTO public.who_global_data VALUES (62270, 9263, 299941, 115, 2837, 263, 170);
INSERT INTO public.who_global_data VALUES (62271, 5, 297, 0, 0, 263, 191);
INSERT INTO public.who_global_data VALUES (62272, 0, 2, 0, 0, 263, 221);
INSERT INTO public.who_global_data VALUES (62273, 0, 6, 0, 0, 263, 64);
INSERT INTO public.who_global_data VALUES (62274, 0, 0, 0, 0, 263, 116);
INSERT INTO public.who_global_data VALUES (62275, 0, 15, 0, 0, 263, 128);
INSERT INTO public.who_global_data VALUES (62276, 0, 18, 0, 0, 263, 6);
INSERT INTO public.who_global_data VALUES (62277, 0, 39, 0, 3, 263, 227);
INSERT INTO public.who_global_data VALUES (62278, 0, 1, 0, 0, 263, 68);
INSERT INTO public.who_global_data VALUES (62279, 0, 17, 0, 0, 263, 184);
INSERT INTO public.who_global_data VALUES (62280, 0, 0, 0, 0, 263, 82);
INSERT INTO public.who_global_data VALUES (62281, 0, 668, 0, 41, 263, 149);
INSERT INTO public.who_global_data VALUES (62282, -4, 165, 0, 7, 263, 197);
INSERT INTO public.who_global_data VALUES (62283, 2509, 59854, 9, 329, 263, 78);
INSERT INTO public.who_global_data VALUES (62284, 64, 2544, 1, 26, 263, 233);
INSERT INTO public.who_global_data VALUES (62285, 89, 10699, 1, 231, 263, 133);
INSERT INTO public.who_global_data VALUES (62286, 0, 11, 0, 0, 263, 35);
INSERT INTO public.who_global_data VALUES (62287, 14, 519, 1, 33, 263, 114);
INSERT INTO public.who_global_data VALUES (62288, 305, 28343, 0, 22, 263, 237);
INSERT INTO public.who_global_data VALUES (62289, 0, 2, 0, 0, 263, 55);
INSERT INTO public.who_global_data VALUES (62290, 0, 78, 0, 15, 263, 176);
INSERT INTO public.who_global_data VALUES (62291, 1, 1495, 0, 28, 263, 202);
INSERT INTO public.who_global_data VALUES (62292, 1, 1467, 0, 111, 263, 155);
INSERT INTO public.who_global_data VALUES (62293, 0, 0, 0, 0, 263, 32);
INSERT INTO public.who_global_data VALUES (62294, 47, 1502, 2, 59, 263, 220);
INSERT INTO public.who_global_data VALUES (62295, 918, 16433, 22, 286, 263, 30);
INSERT INTO public.who_global_data VALUES (62296, 0, 282, 0, 4, 263, 147);
INSERT INTO public.who_global_data VALUES (62297, 256, 238063, 61, 28378, 263, 208);
INSERT INTO public.who_global_data VALUES (62298, 34, 1020, 0, 9, 263, 45);
INSERT INTO public.who_global_data VALUES (62299, 0, 2591, 0, 105, 263, 110);
INSERT INTO public.who_global_data VALUES (62300, 1, 11, 0, 1, 263, 88);
INSERT INTO public.who_global_data VALUES (62301, 259, 30718, 52, 4029, 263, 51);
INSERT INTO public.who_global_data VALUES (62302, 34, 30596, 3, 1699, 263, 209);
INSERT INTO public.who_global_data VALUES (62303, 0, 58, 0, 3, 263, 205);
INSERT INTO public.who_global_data VALUES (62304, 407, 1729, 5, 44, 263, 18);
INSERT INTO public.who_global_data VALUES (62305, 2, 3033, 0, 56, 263, 72);
INSERT INTO public.who_global_data VALUES (62306, 1838, 230090, 146, 33966, 263, 44);
INSERT INTO public.who_global_data VALUES (62307, 0, 24, 0, 0, 263, 15);
INSERT INTO public.who_global_data VALUES (62308, 29, 330, 1, 12, 263, 25);
INSERT INTO public.who_global_data VALUES (62309, 0, 0, 0, 0, 263, 179);
INSERT INTO public.who_global_data VALUES (62310, 0, 0, 0, 0, 263, 34);
INSERT INTO public.who_global_data VALUES (62311, 0, 116, 0, 8, 263, 207);
INSERT INTO public.who_global_data VALUES (62312, 6, 1043, 1, 46, 263, 166);
INSERT INTO public.who_global_data VALUES (62313, 1158, 150593, 31, 4171, 263, 126);
INSERT INTO public.who_global_data VALUES (62314, 0, 0, 0, 0, 263, 97);
INSERT INTO public.who_global_data VALUES (62315, 0, 12, 0, 1, 263, 36);
INSERT INTO public.who_global_data VALUES (62316, 0, 0, 0, 0, 263, 125);
INSERT INTO public.who_global_data VALUES (62317, 33, 260, 0, 0, 263, 124);
INSERT INTO public.who_global_data VALUES (62318, 260, 18876, 13, 548, 263, 185);
INSERT INTO public.who_global_data VALUES (62319, 1705, 25063, 7, 227, 263, 194);
INSERT INTO public.who_global_data VALUES (62320, 0, 509, 0, 21, 263, 144);
INSERT INTO public.who_global_data VALUES (62321, 13227, 1477459, 697, 89271, 263, 19);
INSERT INTO public.who_global_data VALUES (62322, 0, 69, 0, 6, 263, 217);
INSERT INTO public.who_global_data VALUES (62323, 0, 734, 1, 20, 263, 148);
INSERT INTO public.who_global_data VALUES (62324, 40, 2802, 1, 13, 263, 86);
INSERT INTO public.who_global_data VALUES (62325, 0, 0, 0, 0, 263, 13);
INSERT INTO public.who_global_data VALUES (62326, 77, 618, 0, 10, 263, 157);
INSERT INTO public.who_global_data VALUES (62327, 4, 324, 0, 0, 263, 8);
INSERT INTO public.who_global_data VALUES (62328, 0, 0, 0, 0, 263, 73);
INSERT INTO public.who_global_data VALUES (62329, 2, 134, 0, 21, 263, 101);
INSERT INTO public.who_global_data VALUES (62330, 8, 761, 0, 7, 263, 165);
INSERT INTO public.who_global_data VALUES (62331, 2, 46, 0, 4, 263, 14);
INSERT INTO public.who_global_data VALUES (62332, 408, 7072, 4, 173, 264, 193);
INSERT INTO public.who_global_data VALUES (62333, 2, 910, 0, 30, 264, 113);
INSERT INTO public.who_global_data VALUES (62334, 198, 7019, 6, 548, 264, 143);
INSERT INTO public.who_global_data VALUES (62335, 0, 0, 0, 0, 264, 219);
INSERT INTO public.who_global_data VALUES (62336, 0, 761, 0, 51, 264, 186);
INSERT INTO public.who_global_data VALUES (62337, 0, 48, 0, 2, 264, 52);
INSERT INTO public.who_global_data VALUES (62338, 0, 3, 0, 0, 264, 180);
INSERT INTO public.who_global_data VALUES (62339, 0, 25, 0, 3, 264, 167);
INSERT INTO public.who_global_data VALUES (62340, 326, 7805, 3, 366, 264, 154);
INSERT INTO public.who_global_data VALUES (62341, 189, 4448, 5, 60, 264, 94);
INSERT INTO public.who_global_data VALUES (62342, 0, 101, 0, 3, 264, 66);
INSERT INTO public.who_global_data VALUES (62343, 9, 7045, 0, 98, 264, 58);
INSERT INTO public.who_global_data VALUES (62344, 14, 16154, 1, 629, 264, 163);
INSERT INTO public.who_global_data VALUES (62345, 136, 3274, 3, 39, 264, 37);
INSERT INTO public.who_global_data VALUES (62346, 0, 96, 0, 11, 264, 142);
INSERT INTO public.who_global_data VALUES (62347, 226, 7156, 0, 12, 264, 83);
INSERT INTO public.who_global_data VALUES (62348, 2875, 23870, 35, 349, 264, 228);
INSERT INTO public.who_global_data VALUES (62349, 1, 86, 0, 7, 264, 188);
INSERT INTO public.who_global_data VALUES (62350, 969, 29650, 5, 165, 264, 62);
INSERT INTO public.who_global_data VALUES (62351, 81, 56410, 31, 8974, 264, 160);
INSERT INTO public.who_global_data VALUES (62352, 0, 18, 0, 2, 264, 50);
INSERT INTO public.who_global_data VALUES (62353, 0, 339, 0, 2, 264, 33);
INSERT INTO public.who_global_data VALUES (62354, 0, 123, 0, 9, 264, 183);
INSERT INTO public.who_global_data VALUES (62355, 0, 21, 0, 0, 264, 92);
INSERT INTO public.who_global_data VALUES (62356, 249, 3826, 1, 165, 264, 158);
INSERT INTO public.who_global_data VALUES (62357, 0, 2, 0, 0, 264, 67);
INSERT INTO public.who_global_data VALUES (62358, 24, 2289, 1, 132, 264, 57);
INSERT INTO public.who_global_data VALUES (62359, 0, 25, 0, 1, 264, 38);
INSERT INTO public.who_global_data VALUES (62360, 14919, 233142, 816, 15633, 264, 141);
INSERT INTO public.who_global_data VALUES (62361, 0, 8, 0, 1, 264, 178);
INSERT INTO public.who_global_data VALUES (62362, 0, 141, 0, 1, 264, 108);
INSERT INTO public.who_global_data VALUES (62363, 24, 2235, 2, 110, 264, 39);
INSERT INTO public.who_global_data VALUES (62364, 14, 796, 0, 51, 264, 2);
INSERT INTO public.who_global_data VALUES (62365, 15, 42, 0, 1, 264, 195);
INSERT INTO public.who_global_data VALUES (62366, 0, 328, 0, 3, 264, 107);
INSERT INTO public.who_global_data VALUES (62367, 0, 122, 0, 0, 264, 161);
INSERT INTO public.who_global_data VALUES (62368, 0, 3047, 0, 139, 264, 212);
INSERT INTO public.who_global_data VALUES (62369, 1211, 76204, 107, 5702, 264, 181);
INSERT INTO public.who_global_data VALUES (62370, 0, 94, 0, 1, 264, 53);
INSERT INTO public.who_global_data VALUES (62371, 26, 327, 0, 0, 264, 164);
INSERT INTO public.who_global_data VALUES (62372, 29, 503, 3, 53, 264, 140);
INSERT INTO public.who_global_data VALUES (62373, 2353, 43781, 29, 450, 264, 20);
INSERT INTO public.who_global_data VALUES (62374, 10, 84494, 0, 4645, 264, 112);
INSERT INTO public.who_global_data VALUES (62375, 723, 14939, 16, 562, 264, 111);
INSERT INTO public.who_global_data VALUES (62376, 0, 11, 0, 1, 264, 71);
INSERT INTO public.who_global_data VALUES (62377, 19, 410, 0, 15, 264, 218);
INSERT INTO public.who_global_data VALUES (62378, 0, 0, 0, 0, 264, 43);
INSERT INTO public.who_global_data VALUES (62379, 10, 853, 2, 10, 264, 49);
INSERT INTO public.who_global_data VALUES (62380, 48, 2109, 2, 27, 264, 1);
INSERT INTO public.who_global_data VALUES (62381, 2, 2226, 0, 95, 264, 48);
INSERT INTO public.who_global_data VALUES (62382, 10, 1872, 0, 79, 264, 232);
INSERT INTO public.who_global_data VALUES (62383, 0, 16, 0, 1, 264, 175);
INSERT INTO public.who_global_data VALUES (62384, 2, 916, 0, 17, 264, 21);
INSERT INTO public.who_global_data VALUES (62385, 20, 8475, 1, 297, 264, 156);
INSERT INTO public.who_global_data VALUES (62386, 0, 0, 0, 0, 264, 95);
INSERT INTO public.who_global_data VALUES (62387, 0, 1454, 0, 60, 264, 177);
INSERT INTO public.who_global_data VALUES (62388, 69, 10927, 4, 547, 264, 210);
INSERT INTO public.who_global_data VALUES (62389, 117, 1518, 3, 7, 264, 120);
INSERT INTO public.who_global_data VALUES (62390, 0, 16, 0, 0, 264, 135);
INSERT INTO public.who_global_data VALUES (62391, 204, 12314, 0, 428, 264, 206);
INSERT INTO public.who_global_data VALUES (62392, 1256, 32723, 94, 2688, 264, 189);
INSERT INTO public.who_global_data VALUES (62393, 510, 12229, 18, 630, 264, 129);
INSERT INTO public.who_global_data VALUES (62394, 73, 1338, 2, 27, 264, 121);
INSERT INTO public.who_global_data VALUES (62395, 29, 719, 0, 7, 264, 59);
INSERT INTO public.who_global_data VALUES (62396, 0, 39, 0, 0, 264, 96);
INSERT INTO public.who_global_data VALUES (62397, 4, 1774, 0, 63, 264, 41);
INSERT INTO public.who_global_data VALUES (62398, 1, 203, 0, 2, 264, 216);
INSERT INTO public.who_global_data VALUES (62399, 11, 317, 0, 5, 264, 236);
INSERT INTO public.who_global_data VALUES (62400, 0, 13, 0, 0, 264, 150);
INSERT INTO public.who_global_data VALUES (62401, 0, 187, 0, 0, 264, 61);
INSERT INTO public.who_global_data VALUES (62402, 0, 18, 0, 0, 264, 7);
INSERT INTO public.who_global_data VALUES (62403, 61, 6347, 1, 298, 264, 169);
INSERT INTO public.who_global_data VALUES (62404, 28, 140036, 66, 27662, 264, 28);
INSERT INTO public.who_global_data VALUES (62405, 8, 197, 0, 1, 264, 85);
INSERT INTO public.who_global_data VALUES (62406, 0, 60, 0, 0, 264, 211);
INSERT INTO public.who_global_data VALUES (62407, 0, 1320, 0, 11, 264, 60);
INSERT INTO public.who_global_data VALUES (62408, 1, 24, 0, 1, 264, 3);
INSERT INTO public.who_global_data VALUES (62409, 6, 701, 0, 12, 264, 11);
INSERT INTO public.who_global_data VALUES (62410, 342, 174697, 21, 7935, 264, 89);
INSERT INTO public.who_global_data VALUES (62411, 0, 5735, 0, 29, 264, 24);
INSERT INTO public.who_global_data VALUES (62412, 0, 147, 0, 0, 264, 162);
INSERT INTO public.who_global_data VALUES (62413, 15, 2834, 1, 163, 264, 100);
INSERT INTO public.who_global_data VALUES (62414, 0, 11, 0, 0, 264, 47);
INSERT INTO public.who_global_data VALUES (62415, 0, 22, 0, 0, 264, 29);
INSERT INTO public.who_global_data VALUES (62416, 0, 155, 0, 13, 264, 40);
INSERT INTO public.who_global_data VALUES (62417, 0, 149, 0, 5, 264, 222);
INSERT INTO public.who_global_data VALUES (62418, 120, 1763, 3, 33, 264, 132);
INSERT INTO public.who_global_data VALUES (62419, 0, 252, 0, 13, 264, 130);
INSERT INTO public.who_global_data VALUES (62420, 69, 2727, 0, 16, 264, 234);
INSERT INTO public.who_global_data VALUES (62421, 77, 990, 1, 4, 264, 23);
INSERT INTO public.who_global_data VALUES (62422, 1, 117, 0, 10, 264, 192);
INSERT INTO public.who_global_data VALUES (62423, 48, 358, 0, 20, 264, 69);
INSERT INTO public.who_global_data VALUES (62424, 0, 12, 0, 0, 264, 187);
INSERT INTO public.who_global_data VALUES (62425, 105, 2565, 4, 138, 264, 230);
INSERT INTO public.who_global_data VALUES (62426, 26, 3535, 11, 462, 264, 77);
INSERT INTO public.who_global_data VALUES (62427, 0, 1802, 0, 10, 264, 9);
INSERT INTO public.who_global_data VALUES (62428, 5242, 96169, 157, 3029, 264, 74);
INSERT INTO public.who_global_data VALUES (62429, 496, 18010, 43, 1191, 264, 224);
INSERT INTO public.who_global_data VALUES (62430, 2294, 122492, 69, 7057, 264, 199);
INSERT INTO public.who_global_data VALUES (62431, 150, 3554, 4, 127, 264, 190);
INSERT INTO public.who_global_data VALUES (62432, 64, 24112, 10, 1543, 264, 12);
INSERT INTO public.who_global_data VALUES (62433, 1, 335, 0, 24, 264, 104);
INSERT INTO public.who_global_data VALUES (62434, 5, 16534, 3, 271, 264, 153);
INSERT INTO public.who_global_data VALUES (62435, 675, 225435, 145, 31908, 264, 91);
INSERT INTO public.who_global_data VALUES (62436, 6, 517, 0, 9, 264, 215);
INSERT INTO public.who_global_data VALUES (62437, 20, 16305, 5, 749, 264, 84);
INSERT INTO public.who_global_data VALUES (62438, 0, 297, 0, 27, 264, 231);
INSERT INTO public.who_global_data VALUES (62439, 16, 629, 0, 9, 264, 196);
INSERT INTO public.who_global_data VALUES (62440, 311, 6751, 1, 35, 264, 105);
INSERT INTO public.who_global_data VALUES (62441, 57, 887, 0, 50, 264, 122);
INSERT INTO public.who_global_data VALUES (62442, 0, 0, 0, 0, 264, 159);
INSERT INTO public.who_global_data VALUES (62443, 11, 955, 0, 20, 264, 75);
INSERT INTO public.who_global_data VALUES (62444, 841, 15691, 6, 118, 264, 27);
INSERT INTO public.who_global_data VALUES (62445, 78, 1216, 0, 14, 264, 54);
INSERT INTO public.who_global_data VALUES (62446, 0, 19, 0, 0, 264, 226);
INSERT INTO public.who_global_data VALUES (62447, 11, 1008, 0, 19, 264, 79);
INSERT INTO public.who_global_data VALUES (62448, 20, 931, 0, 26, 264, 56);
INSERT INTO public.who_global_data VALUES (62449, 0, 1, 0, 0, 264, 117);
INSERT INTO public.who_global_data VALUES (62450, 3, 226, 1, 21, 264, 152);
INSERT INTO public.who_global_data VALUES (62451, 0, 65, 0, 3, 264, 16);
INSERT INTO public.who_global_data VALUES (62452, 0, 83, 0, 1, 264, 10);
INSERT INTO public.who_global_data VALUES (62453, 6, 1551, 2, 60, 264, 201);
INSERT INTO public.who_global_data VALUES (62454, 15, 3945, 3, 107, 264, 174);
INSERT INTO public.who_global_data VALUES (62455, 21, 304, 1, 1, 264, 119);
INSERT INTO public.who_global_data VALUES (62456, 5, 70, 0, 3, 264, 168);
INSERT INTO public.who_global_data VALUES (62457, 22, 6894, 0, 113, 264, 99);
INSERT INTO public.who_global_data VALUES (62458, 16, 1094, 0, 4, 264, 171);
INSERT INTO public.who_global_data VALUES (62459, 25, 860, 4, 52, 264, 87);
INSERT INTO public.who_global_data VALUES (62460, 5, 557, 0, 6, 264, 123);
INSERT INTO public.who_global_data VALUES (62461, 0, 0, 0, 0, 264, 151);
INSERT INTO public.who_global_data VALUES (62462, 0, 192, 0, 14, 264, 213);
INSERT INTO public.who_global_data VALUES (62463, 22, 62, 0, 4, 264, 118);
INSERT INTO public.who_global_data VALUES (62464, 0, 332, 0, 10, 264, 134);
INSERT INTO public.who_global_data VALUES (62465, 84, 1342, 2, 18, 264, 65);
INSERT INTO public.who_global_data VALUES (62466, 2112, 47144, 278, 5045, 264, 102);
INSERT INTO public.who_global_data VALUES (62467, 0, 0, 0, 0, 264, 223);
INSERT INTO public.who_global_data VALUES (62468, 0, 67, 0, 1, 264, 4);
INSERT INTO public.who_global_data VALUES (62469, 4, 140, 0, 0, 264, 146);
INSERT INTO public.who_global_data VALUES (62470, 0, 324, 0, 9, 264, 31);
INSERT INTO public.who_global_data VALUES (62471, 0, 11, 0, 1, 264, 127);
INSERT INTO public.who_global_data VALUES (62472, 132, 6930, 0, 192, 264, 22);
INSERT INTO public.who_global_data VALUES (62473, 8, 137, 0, 0, 264, 115);
INSERT INTO public.who_global_data VALUES (62474, 4, 188, 0, 6, 264, 106);
INSERT INTO public.who_global_data VALUES (62475, 0, 16, 0, 0, 264, 90);
INSERT INTO public.who_global_data VALUES (62476, 0, 0, 0, 0, 264, 70);
INSERT INTO public.who_global_data VALUES (62477, 62, 357, 0, 2, 264, 46);
INSERT INTO public.who_global_data VALUES (62478, 125, 43762, 10, 5652, 264, 139);
INSERT INTO public.who_global_data VALUES (62479, 0, 18, 0, 0, 264, 42);
INSERT INTO public.who_global_data VALUES (62480, 0, 1149, 0, 21, 264, 80);
INSERT INTO public.who_global_data VALUES (62481, 0, 25, 0, 8, 264, 203);
INSERT INTO public.who_global_data VALUES (62482, 15, 904, 3, 54, 264, 136);
INSERT INTO public.who_global_data VALUES (62483, 338, 5959, 6, 182, 264, 63);
INSERT INTO public.who_global_data VALUES (62484, 0, 0, 0, 0, 264, 17);
INSERT INTO public.who_global_data VALUES (62485, 0, 21, 0, 2, 264, 172);
INSERT INTO public.who_global_data VALUES (62486, 30, 1792, 3, 101, 264, 109);
INSERT INTO public.who_global_data VALUES (62487, 0, 8197, 0, 232, 264, 200);
INSERT INTO public.who_global_data VALUES (62488, 0, 560, 0, 4, 264, 93);
INSERT INTO public.who_global_data VALUES (62489, 193, 5379, 1, 23, 264, 5);
INSERT INTO public.who_global_data VALUES (62490, 0, 712, 0, 13, 264, 214);
INSERT INTO public.who_global_data VALUES (62491, 1974, 42125, 30, 903, 264, 204);
INSERT INTO public.who_global_data VALUES (62492, 0, 0, 0, 0, 264, 198);
INSERT INTO public.who_global_data VALUES (62493, 181, 9449, 3, 269, 264, 173);
INSERT INTO public.who_global_data VALUES (62494, 0, 8, 0, 0, 264, 229);
INSERT INTO public.who_global_data VALUES (62495, 8, 786, 0, 11, 264, 76);
INSERT INTO public.who_global_data VALUES (62496, 4046, 88541, 131, 2523, 264, 138);
INSERT INTO public.who_global_data VALUES (62497, 205, 12718, 7, 831, 264, 98);
INSERT INTO public.who_global_data VALUES (62498, 0, 0, 0, 0, 264, 103);
INSERT INTO public.who_global_data VALUES (62499, 272, 18529, 10, 925, 264, 225);
INSERT INTO public.who_global_data VALUES (62500, 226, 29036, 15, 1218, 264, 131);
INSERT INTO public.who_global_data VALUES (62501, 57, 2646, 1, 123, 264, 235);
INSERT INTO public.who_global_data VALUES (62502, 1365, 33969, 0, 15, 264, 137);
INSERT INTO public.who_global_data VALUES (62503, 15, 11065, 1, 263, 264, 81);
INSERT INTO public.who_global_data VALUES (62504, 126, 6060, 2, 211, 264, 182);
INSERT INTO public.who_global_data VALUES (62505, 0, 443, 0, 0, 264, 145);
INSERT INTO public.who_global_data VALUES (62506, 167, 16871, 16, 1097, 264, 26);
INSERT INTO public.who_global_data VALUES (62507, 8926, 290678, 91, 2722, 264, 170);
INSERT INTO public.who_global_data VALUES (62508, 3, 292, 0, 0, 264, 191);
INSERT INTO public.who_global_data VALUES (62509, 0, 2, 0, 0, 264, 221);
INSERT INTO public.who_global_data VALUES (62510, 0, 6, 0, 0, 264, 64);
INSERT INTO public.who_global_data VALUES (62511, 0, 0, 0, 0, 264, 116);
INSERT INTO public.who_global_data VALUES (62512, 0, 15, 0, 0, 264, 128);
INSERT INTO public.who_global_data VALUES (62513, 0, 18, 0, 0, 264, 6);
INSERT INTO public.who_global_data VALUES (62514, 0, 39, 0, 3, 264, 227);
INSERT INTO public.who_global_data VALUES (62515, 0, 1, 0, 0, 264, 68);
INSERT INTO public.who_global_data VALUES (62516, 0, 17, 0, 0, 264, 184);
INSERT INTO public.who_global_data VALUES (62517, 0, 0, 0, 0, 264, 82);
INSERT INTO public.who_global_data VALUES (62518, 16, 668, 0, 41, 264, 149);
INSERT INTO public.who_global_data VALUES (62519, 0, 169, 0, 7, 264, 197);
INSERT INTO public.who_global_data VALUES (62520, 2593, 57345, 8, 320, 264, 78);
INSERT INTO public.who_global_data VALUES (62521, 51, 2480, 0, 25, 264, 233);
INSERT INTO public.who_global_data VALUES (62522, 114, 10610, 2, 230, 264, 133);
INSERT INTO public.who_global_data VALUES (62523, 0, 11, 0, 0, 264, 35);
INSERT INTO public.who_global_data VALUES (62524, 43, 505, 3, 32, 264, 114);
INSERT INTO public.who_global_data VALUES (62525, 682, 28038, 0, 22, 264, 237);
INSERT INTO public.who_global_data VALUES (62526, 0, 2, 0, 0, 264, 55);
INSERT INTO public.who_global_data VALUES (62527, 0, 78, 0, 15, 264, 176);
INSERT INTO public.who_global_data VALUES (62528, 1, 1494, 0, 28, 264, 202);
INSERT INTO public.who_global_data VALUES (62529, 0, 1466, 0, 111, 264, 155);
INSERT INTO public.who_global_data VALUES (62530, 0, 0, 0, 0, 264, 32);
INSERT INTO public.who_global_data VALUES (62531, 34, 1455, 1, 57, 264, 220);
INSERT INTO public.who_global_data VALUES (62532, 1160, 15515, 3, 264, 264, 30);
INSERT INTO public.who_global_data VALUES (62533, 51, 282, 3, 4, 264, 147);
INSERT INTO public.who_global_data VALUES (62534, 390, 237807, 64, 28317, 264, 208);
INSERT INTO public.who_global_data VALUES (62535, 16, 986, 0, 9, 264, 45);
INSERT INTO public.who_global_data VALUES (62536, 302, 2591, 8, 105, 264, 110);
INSERT INTO public.who_global_data VALUES (62537, 0, 10, 0, 1, 264, 88);
INSERT INTO public.who_global_data VALUES (62538, 358, 30459, 48, 3977, 264, 51);
INSERT INTO public.who_global_data VALUES (62539, 12, 30562, 4, 1696, 264, 209);
INSERT INTO public.who_global_data VALUES (62540, 7, 58, 0, 3, 264, 205);
INSERT INTO public.who_global_data VALUES (62541, 0, 1322, 0, 39, 264, 18);
INSERT INTO public.who_global_data VALUES (62542, 3, 3031, 0, 56, 264, 72);
INSERT INTO public.who_global_data VALUES (62543, 2079, 228252, 67, 33820, 264, 44);
INSERT INTO public.who_global_data VALUES (62544, 0, 24, 0, 0, 264, 15);
INSERT INTO public.who_global_data VALUES (62545, 3, 301, 0, 11, 264, 25);
INSERT INTO public.who_global_data VALUES (62546, 0, 0, 0, 0, 264, 179);
INSERT INTO public.who_global_data VALUES (62547, 0, 0, 0, 0, 264, 34);
INSERT INTO public.who_global_data VALUES (62548, 0, 116, 0, 8, 264, 207);
INSERT INTO public.who_global_data VALUES (62549, 0, 1037, 0, 45, 264, 166);
INSERT INTO public.who_global_data VALUES (62550, 1368, 149435, 44, 4140, 264, 126);
INSERT INTO public.who_global_data VALUES (62551, 0, 0, 0, 0, 264, 97);
INSERT INTO public.who_global_data VALUES (62552, 0, 12, 0, 1, 264, 36);
INSERT INTO public.who_global_data VALUES (62553, 0, 0, 0, 0, 264, 125);
INSERT INTO public.who_global_data VALUES (62554, 0, 227, 0, 0, 264, 124);
INSERT INTO public.who_global_data VALUES (62555, 325, 18616, 21, 535, 264, 185);
INSERT INTO public.who_global_data VALUES (62556, 0, 23358, 0, 220, 264, 194);
INSERT INTO public.who_global_data VALUES (62557, 0, 509, 0, 21, 264, 144);
INSERT INTO public.who_global_data VALUES (62558, 31967, 1464232, 1394, 88574, 264, 19);
INSERT INTO public.who_global_data VALUES (62559, 0, 69, 0, 6, 264, 217);
INSERT INTO public.who_global_data VALUES (62560, 2, 734, 0, 19, 264, 148);
INSERT INTO public.who_global_data VALUES (62561, 21, 2762, 1, 12, 264, 86);
INSERT INTO public.who_global_data VALUES (62562, 0, 0, 0, 0, 264, 13);
INSERT INTO public.who_global_data VALUES (62563, 37, 541, 0, 10, 264, 157);
INSERT INTO public.who_global_data VALUES (62564, 2, 320, 0, 0, 264, 8);
INSERT INTO public.who_global_data VALUES (62565, 0, 0, 0, 0, 264, 73);
INSERT INTO public.who_global_data VALUES (62566, 6, 132, 2, 21, 264, 101);
INSERT INTO public.who_global_data VALUES (62567, 74, 753, 0, 7, 264, 165);
INSERT INTO public.who_global_data VALUES (62568, 0, 44, 0, 4, 264, 14);
INSERT INTO public.who_global_data VALUES (62569, 262, 6664, 1, 169, 265, 193);
INSERT INTO public.who_global_data VALUES (62570, 13, 908, 0, 30, 265, 113);
INSERT INTO public.who_global_data VALUES (62571, 191, 6821, 6, 542, 265, 143);
INSERT INTO public.who_global_data VALUES (62572, 0, 0, 0, 0, 265, 219);
INSERT INTO public.who_global_data VALUES (62573, 0, 761, 2, 51, 265, 186);
INSERT INTO public.who_global_data VALUES (62574, 0, 48, 0, 2, 265, 52);
INSERT INTO public.who_global_data VALUES (62575, 0, 3, 0, 0, 265, 180);
INSERT INTO public.who_global_data VALUES (62576, 0, 25, 0, 3, 265, 167);
INSERT INTO public.who_global_data VALUES (62577, 345, 7479, 10, 363, 265, 154);
INSERT INTO public.who_global_data VALUES (62578, 239, 4259, 3, 55, 265, 94);
INSERT INTO public.who_global_data VALUES (62579, 0, 101, 0, 3, 265, 66);
INSERT INTO public.who_global_data VALUES (62580, 17, 7036, 0, 98, 265, 58);
INSERT INTO public.who_global_data VALUES (62581, 72, 16140, 0, 628, 265, 163);
INSERT INTO public.who_global_data VALUES (62582, 158, 3138, 0, 36, 265, 37);
INSERT INTO public.who_global_data VALUES (62583, 0, 96, 0, 11, 265, 142);
INSERT INTO public.who_global_data VALUES (62584, 275, 6930, 0, 12, 265, 83);
INSERT INTO public.who_global_data VALUES (62585, 0, 20995, 0, 314, 265, 228);
INSERT INTO public.who_global_data VALUES (62586, 0, 85, 0, 7, 265, 188);
INSERT INTO public.who_global_data VALUES (62587, 951, 28681, 4, 160, 265, 62);
INSERT INTO public.who_global_data VALUES (62588, 147, 56329, 29, 8943, 265, 160);
INSERT INTO public.who_global_data VALUES (62589, 0, 18, 0, 2, 265, 50);
INSERT INTO public.who_global_data VALUES (62590, 0, 339, 0, 2, 265, 33);
INSERT INTO public.who_global_data VALUES (62591, 1, 123, 0, 9, 265, 183);
INSERT INTO public.who_global_data VALUES (62592, 0, 21, 0, 0, 265, 92);
INSERT INTO public.who_global_data VALUES (62593, 205, 3577, 12, 164, 265, 158);
INSERT INTO public.who_global_data VALUES (62594, 0, 2, 0, 0, 265, 67);
INSERT INTO public.who_global_data VALUES (62595, 28, 2265, 4, 131, 265, 57);
INSERT INTO public.who_global_data VALUES (62596, 1, 25, 0, 1, 265, 38);
INSERT INTO public.who_global_data VALUES (62597, 15305, 218223, 824, 14817, 265, 141);
INSERT INTO public.who_global_data VALUES (62598, 0, 8, 0, 1, 265, 178);
INSERT INTO public.who_global_data VALUES (62599, 0, 141, 0, 1, 265, 108);
INSERT INTO public.who_global_data VALUES (62600, 73, 2211, 6, 108, 265, 39);
INSERT INTO public.who_global_data VALUES (62601, 2, 782, 0, 51, 265, 2);
INSERT INTO public.who_global_data VALUES (62602, 0, 27, 0, 1, 265, 195);
INSERT INTO public.who_global_data VALUES (62603, 2, 328, 1, 3, 265, 107);
INSERT INTO public.who_global_data VALUES (62604, 0, 122, 0, 0, 265, 161);
INSERT INTO public.who_global_data VALUES (62605, 0, 3047, 0, 139, 265, 212);
INSERT INTO public.who_global_data VALUES (62606, 1164, 74993, 96, 5595, 265, 181);
INSERT INTO public.who_global_data VALUES (62607, 1, 94, 0, 1, 265, 53);
INSERT INTO public.who_global_data VALUES (62608, 0, 301, 0, 0, 265, 164);
INSERT INTO public.who_global_data VALUES (62609, 46, 474, 2, 50, 265, 140);
INSERT INTO public.who_global_data VALUES (62610, 4388, 41428, 53, 421, 265, 20);
INSERT INTO public.who_global_data VALUES (62611, 6, 84484, 1, 4645, 265, 112);
INSERT INTO public.who_global_data VALUES (62612, 606, 14216, 21, 546, 265, 111);
INSERT INTO public.who_global_data VALUES (62613, 0, 11, 0, 1, 265, 71);
INSERT INTO public.who_global_data VALUES (62614, 0, 391, 0, 15, 265, 218);
INSERT INTO public.who_global_data VALUES (62615, 0, 0, 0, 0, 265, 43);
INSERT INTO public.who_global_data VALUES (62616, 13, 843, 0, 8, 265, 49);
INSERT INTO public.who_global_data VALUES (62617, 44, 2061, 1, 25, 265, 1);
INSERT INTO public.who_global_data VALUES (62618, 2, 2224, 0, 95, 265, 48);
INSERT INTO public.who_global_data VALUES (62619, 22, 1862, 0, 79, 265, 232);
INSERT INTO public.who_global_data VALUES (62620, 0, 16, 0, 1, 265, 175);
INSERT INTO public.who_global_data VALUES (62621, 4, 914, 0, 17, 265, 21);
INSERT INTO public.who_global_data VALUES (62622, 49, 8455, 1, 296, 265, 156);
INSERT INTO public.who_global_data VALUES (62623, 0, 0, 0, 0, 265, 95);
INSERT INTO public.who_global_data VALUES (62624, 85, 1454, 0, 60, 265, 177);
INSERT INTO public.who_global_data VALUES (62625, 67, 10858, 6, 543, 265, 210);
INSERT INTO public.who_global_data VALUES (62626, 70, 1401, 0, 4, 265, 120);
INSERT INTO public.who_global_data VALUES (62627, 0, 16, 0, 0, 265, 135);
INSERT INTO public.who_global_data VALUES (62628, 371, 12110, 4, 428, 265, 206);
INSERT INTO public.who_global_data VALUES (62629, 965, 31467, 256, 2594, 265, 189);
INSERT INTO public.who_global_data VALUES (62630, 491, 11719, 20, 612, 265, 129);
INSERT INTO public.who_global_data VALUES (62631, 55, 1265, 2, 25, 265, 121);
INSERT INTO public.who_global_data VALUES (62632, 96, 690, 0, 7, 265, 59);
INSERT INTO public.who_global_data VALUES (62633, 0, 39, 0, 0, 265, 96);
INSERT INTO public.who_global_data VALUES (62634, 4, 1770, 0, 63, 265, 41);
INSERT INTO public.who_global_data VALUES (62635, 12, 202, 0, 2, 265, 216);
INSERT INTO public.who_global_data VALUES (62636, 19, 306, 0, 5, 265, 236);
INSERT INTO public.who_global_data VALUES (62637, 0, 13, 0, 0, 265, 150);
INSERT INTO public.who_global_data VALUES (62638, 0, 187, 0, 0, 265, 61);
INSERT INTO public.who_global_data VALUES (62639, 0, 18, 0, 0, 265, 7);
INSERT INTO public.who_global_data VALUES (62640, 58, 6286, 4, 297, 265, 169);
INSERT INTO public.who_global_data VALUES (62641, 362, 140008, 88, 27596, 265, 28);
INSERT INTO public.who_global_data VALUES (62642, 5, 189, 0, 1, 265, 85);
INSERT INTO public.who_global_data VALUES (62643, 0, 60, 0, 0, 265, 211);
INSERT INTO public.who_global_data VALUES (62644, 111, 1320, 1, 11, 265, 60);
INSERT INTO public.who_global_data VALUES (62645, 0, 23, 0, 1, 265, 3);
INSERT INTO public.who_global_data VALUES (62646, 18, 695, 0, 12, 265, 11);
INSERT INTO public.who_global_data VALUES (62647, 583, 174355, 33, 7914, 265, 89);
INSERT INTO public.who_global_data VALUES (62648, 97, 5735, 1, 29, 265, 24);
INSERT INTO public.who_global_data VALUES (62649, 0, 147, 0, 0, 265, 162);
INSERT INTO public.who_global_data VALUES (62650, 9, 2819, 2, 162, 265, 100);
INSERT INTO public.who_global_data VALUES (62651, 0, 11, 0, 0, 265, 47);
INSERT INTO public.who_global_data VALUES (62652, 0, 22, 0, 0, 265, 29);
INSERT INTO public.who_global_data VALUES (62653, 0, 155, 0, 13, 265, 40);
INSERT INTO public.who_global_data VALUES (62654, 0, 149, 0, 5, 265, 222);
INSERT INTO public.who_global_data VALUES (62655, 125, 1643, 1, 30, 265, 132);
INSERT INTO public.who_global_data VALUES (62656, 0, 252, 0, 13, 265, 130);
INSERT INTO public.who_global_data VALUES (62657, 127, 2658, 1, 16, 265, 234);
INSERT INTO public.who_global_data VALUES (62658, 0, 913, 0, 3, 265, 23);
INSERT INTO public.who_global_data VALUES (62659, 3, 116, 0, 10, 265, 192);
INSERT INTO public.who_global_data VALUES (62660, 37, 310, 0, 20, 265, 69);
INSERT INTO public.who_global_data VALUES (62661, 0, 12, 0, 0, 265, 187);
INSERT INTO public.who_global_data VALUES (62662, 142, 2460, 1, 134, 265, 230);
INSERT INTO public.who_global_data VALUES (62663, 36, 3509, 3, 451, 265, 77);
INSERT INTO public.who_global_data VALUES (62664, 0, 1802, 0, 10, 265, 9);
INSERT INTO public.who_global_data VALUES (62665, 4987, 90927, 120, 2872, 265, 74);
INSERT INTO public.who_global_data VALUES (62666, 489, 17514, 59, 1148, 265, 224);
INSERT INTO public.who_global_data VALUES (62667, 1806, 120198, 51, 6988, 265, 199);
INSERT INTO public.who_global_data VALUES (62668, 144, 3404, 2, 123, 265, 190);
INSERT INTO public.who_global_data VALUES (62669, 92, 24048, 15, 1533, 265, 12);
INSERT INTO public.who_global_data VALUES (62670, 1, 334, 0, 24, 265, 104);
INSERT INTO public.who_global_data VALUES (62671, 12, 16529, 0, 268, 265, 153);
INSERT INTO public.who_global_data VALUES (62672, 875, 224760, 153, 31763, 265, 91);
INSERT INTO public.who_global_data VALUES (62673, 2, 511, 0, 9, 265, 215);
INSERT INTO public.who_global_data VALUES (62674, 48, 16285, 19, 744, 265, 84);
INSERT INTO public.who_global_data VALUES (62675, 0, 297, 0, 27, 265, 231);
INSERT INTO public.who_global_data VALUES (62676, 6, 613, 0, 9, 265, 196);
INSERT INTO public.who_global_data VALUES (62677, 283, 6440, 0, 34, 265, 105);
INSERT INTO public.who_global_data VALUES (62678, 49, 830, 4, 50, 265, 122);
INSERT INTO public.who_global_data VALUES (62679, 0, 0, 0, 0, 265, 159);
INSERT INTO public.who_global_data VALUES (62680, 0, 944, 0, 20, 265, 75);
INSERT INTO public.who_global_data VALUES (62681, 1048, 14850, 5, 112, 265, 27);
INSERT INTO public.who_global_data VALUES (62682, 21, 1138, 0, 14, 265, 54);
INSERT INTO public.who_global_data VALUES (62683, 0, 19, 0, 0, 265, 226);
INSERT INTO public.who_global_data VALUES (62684, 27, 997, 0, 19, 265, 79);
INSERT INTO public.who_global_data VALUES (62685, 9, 911, 0, 26, 265, 56);
INSERT INTO public.who_global_data VALUES (62686, 0, 1, 0, 0, 265, 117);
INSERT INTO public.who_global_data VALUES (62687, 4, 223, 0, 20, 265, 152);
INSERT INTO public.who_global_data VALUES (62688, 1, 65, 0, 3, 265, 16);
INSERT INTO public.who_global_data VALUES (62689, 0, 83, 0, 1, 265, 10);
INSERT INTO public.who_global_data VALUES (62690, 9, 1545, 2, 58, 265, 201);
INSERT INTO public.who_global_data VALUES (62691, 7, 3930, 0, 104, 265, 174);
INSERT INTO public.who_global_data VALUES (62692, 45, 283, 0, 0, 265, 119);
INSERT INTO public.who_global_data VALUES (62693, 2, 65, 0, 3, 265, 168);
INSERT INTO public.who_global_data VALUES (62694, 17, 6872, 1, 113, 265, 99);
INSERT INTO public.who_global_data VALUES (62695, 0, 1078, 0, 4, 265, 171);
INSERT INTO public.who_global_data VALUES (62696, 29, 835, 2, 48, 265, 87);
INSERT INTO public.who_global_data VALUES (62697, 7, 552, 0, 6, 265, 123);
INSERT INTO public.who_global_data VALUES (62698, 0, 0, 0, 0, 265, 151);
INSERT INTO public.who_global_data VALUES (62699, 3, 192, 0, 14, 265, 213);
INSERT INTO public.who_global_data VALUES (62700, 11, 40, 1, 4, 265, 118);
INSERT INTO public.who_global_data VALUES (62701, 0, 332, 0, 10, 265, 134);
INSERT INTO public.who_global_data VALUES (62702, 0, 1258, 0, 16, 265, 65);
INSERT INTO public.who_global_data VALUES (62703, 2437, 45032, 290, 4767, 265, 102);
INSERT INTO public.who_global_data VALUES (62704, 0, 0, 0, 0, 265, 223);
INSERT INTO public.who_global_data VALUES (62705, 0, 67, 0, 1, 265, 4);
INSERT INTO public.who_global_data VALUES (62706, 1, 136, 0, 0, 265, 146);
INSERT INTO public.who_global_data VALUES (62707, 0, 324, 0, 9, 265, 31);
INSERT INTO public.who_global_data VALUES (62708, 0, 11, 0, 1, 265, 127);
INSERT INTO public.who_global_data VALUES (62709, 117, 6798, 0, 192, 265, 22);
INSERT INTO public.who_global_data VALUES (62710, 10, 129, 0, 0, 265, 115);
INSERT INTO public.who_global_data VALUES (62711, 2, 184, 0, 6, 265, 106);
INSERT INTO public.who_global_data VALUES (62712, 0, 16, 0, 0, 265, 90);
INSERT INTO public.who_global_data VALUES (62713, 0, 0, 0, 0, 265, 70);
INSERT INTO public.who_global_data VALUES (62714, 14, 295, 1, 2, 265, 46);
INSERT INTO public.who_global_data VALUES (62715, 194, 43637, 34, 5642, 265, 139);
INSERT INTO public.who_global_data VALUES (62716, 0, 18, 0, 0, 265, 42);
INSERT INTO public.who_global_data VALUES (62717, 1, 1149, 0, 21, 265, 80);
INSERT INTO public.who_global_data VALUES (62718, 0, 25, 0, 8, 265, 203);
INSERT INTO public.who_global_data VALUES (62719, 4, 889, 0, 51, 265, 136);
INSERT INTO public.who_global_data VALUES (62720, 171, 5621, 5, 176, 265, 63);
INSERT INTO public.who_global_data VALUES (62721, 0, 0, 0, 0, 265, 17);
INSERT INTO public.who_global_data VALUES (62722, 2, 21, 0, 2, 265, 172);
INSERT INTO public.who_global_data VALUES (62723, 22, 1762, 1, 98, 265, 109);
INSERT INTO public.who_global_data VALUES (62724, 0, 8197, 0, 232, 265, 200);
INSERT INTO public.who_global_data VALUES (62725, 6, 560, 0, 4, 265, 93);
INSERT INTO public.who_global_data VALUES (62726, 157, 5186, 1, 22, 265, 5);
INSERT INTO public.who_global_data VALUES (62727, 0, 712, 0, 13, 265, 214);
INSERT INTO public.who_global_data VALUES (62728, 1352, 40151, 39, 873, 265, 204);
INSERT INTO public.who_global_data VALUES (62729, 0, 0, 0, 0, 265, 198);
INSERT INTO public.who_global_data VALUES (62730, 150, 9268, 6, 266, 265, 173);
INSERT INTO public.who_global_data VALUES (62731, 0, 8, 0, 0, 265, 229);
INSERT INTO public.who_global_data VALUES (62732, 19, 778, 0, 11, 265, 76);
INSERT INTO public.who_global_data VALUES (62733, 3891, 84495, 125, 2392, 265, 138);
INSERT INTO public.who_global_data VALUES (62734, 208, 12513, 7, 824, 265, 98);
INSERT INTO public.who_global_data VALUES (62735, 0, 0, 0, 0, 265, 103);
INSERT INTO public.who_global_data VALUES (62736, 241, 18257, 8, 915, 265, 225);
INSERT INTO public.who_global_data VALUES (62737, 227, 28810, 13, 1203, 265, 131);
INSERT INTO public.who_global_data VALUES (62738, 47, 2589, 0, 122, 265, 235);
INSERT INTO public.who_global_data VALUES (62739, 1632, 32604, 0, 15, 265, 137);
INSERT INTO public.who_global_data VALUES (62740, 13, 11050, 0, 262, 265, 81);
INSERT INTO public.who_global_data VALUES (62741, 189, 5934, 5, 209, 265, 182);
INSERT INTO public.who_global_data VALUES (62742, 2, 443, 0, 0, 265, 145);
INSERT INTO public.who_global_data VALUES (62743, 267, 16704, 25, 1081, 265, 26);
INSERT INTO public.who_global_data VALUES (62744, 9709, 281752, 94, 2631, 265, 170);
INSERT INTO public.who_global_data VALUES (62745, 2, 289, 0, 0, 265, 191);
INSERT INTO public.who_global_data VALUES (62746, 0, 2, 0, 0, 265, 221);
INSERT INTO public.who_global_data VALUES (62747, 0, 6, 0, 0, 265, 64);
INSERT INTO public.who_global_data VALUES (62748, 0, 0, 0, 0, 265, 116);
INSERT INTO public.who_global_data VALUES (62749, 0, 15, 0, 0, 265, 128);
INSERT INTO public.who_global_data VALUES (62750, 0, 18, 0, 0, 265, 6);
INSERT INTO public.who_global_data VALUES (62751, 0, 39, 0, 3, 265, 227);
INSERT INTO public.who_global_data VALUES (62752, 0, 1, 0, 0, 265, 68);
INSERT INTO public.who_global_data VALUES (62753, 0, 17, 0, 0, 265, 184);
INSERT INTO public.who_global_data VALUES (62754, 0, 0, 0, 0, 265, 82);
INSERT INTO public.who_global_data VALUES (62755, 0, 652, 0, 41, 265, 149);
INSERT INTO public.who_global_data VALUES (62756, 3, 169, 0, 7, 265, 197);
INSERT INTO public.who_global_data VALUES (62757, 2736, 54752, 10, 312, 265, 78);
INSERT INTO public.who_global_data VALUES (62758, 119, 2429, 2, 25, 265, 233);
INSERT INTO public.who_global_data VALUES (62759, 58, 10496, 3, 228, 265, 133);
INSERT INTO public.who_global_data VALUES (62760, 0, 11, 0, 0, 265, 35);
INSERT INTO public.who_global_data VALUES (62761, 15, 462, 2, 29, 265, 114);
INSERT INTO public.who_global_data VALUES (62762, 465, 27356, 1, 22, 265, 237);
INSERT INTO public.who_global_data VALUES (62763, 0, 2, 0, 0, 265, 55);
INSERT INTO public.who_global_data VALUES (62764, 0, 78, 0, 15, 265, 176);
INSERT INTO public.who_global_data VALUES (62765, 13, 1493, 1, 28, 265, 202);
INSERT INTO public.who_global_data VALUES (62766, 1, 1466, 0, 111, 265, 155);
INSERT INTO public.who_global_data VALUES (62767, 0, 0, 0, 0, 265, 32);
INSERT INTO public.who_global_data VALUES (62768, 64, 1421, 1, 56, 265, 220);
INSERT INTO public.who_global_data VALUES (62769, 831, 14355, 14, 261, 265, 30);
INSERT INTO public.who_global_data VALUES (62770, 0, 231, 0, 1, 265, 147);
INSERT INTO public.who_global_data VALUES (62771, 893, 237417, 78, 28253, 265, 208);
INSERT INTO public.who_global_data VALUES (62772, 21, 970, 0, 9, 265, 45);
INSERT INTO public.who_global_data VALUES (62773, 325, 2289, 6, 97, 265, 110);
INSERT INTO public.who_global_data VALUES (62774, 0, 10, 0, 1, 265, 88);
INSERT INTO public.who_global_data VALUES (62775, 688, 30101, 58, 3929, 265, 51);
INSERT INTO public.who_global_data VALUES (62776, 15, 30550, 1, 1692, 265, 209);
INSERT INTO public.who_global_data VALUES (62777, 1, 51, 0, 3, 265, 205);
INSERT INTO public.who_global_data VALUES (62778, 204, 1322, 3, 39, 265, 18);
INSERT INTO public.who_global_data VALUES (62779, 3, 3028, 0, 56, 265, 72);
INSERT INTO public.who_global_data VALUES (62780, 2526, 226173, 411, 33753, 265, 44);
INSERT INTO public.who_global_data VALUES (62781, 0, 24, 0, 0, 265, 15);
INSERT INTO public.who_global_data VALUES (62782, 35, 298, 0, 11, 265, 25);
INSERT INTO public.who_global_data VALUES (62783, 0, 0, 0, 0, 265, 179);
INSERT INTO public.who_global_data VALUES (62784, 0, 0, 0, 0, 265, 34);
INSERT INTO public.who_global_data VALUES (62785, 0, 116, 0, 8, 265, 207);
INSERT INTO public.who_global_data VALUES (62786, 2, 1037, 0, 45, 265, 166);
INSERT INTO public.who_global_data VALUES (62787, 1610, 148067, 41, 4096, 265, 126);
INSERT INTO public.who_global_data VALUES (62788, 0, 0, 0, 0, 265, 97);
INSERT INTO public.who_global_data VALUES (62789, 0, 12, 0, 1, 265, 36);
INSERT INTO public.who_global_data VALUES (62790, 0, 0, 0, 0, 265, 125);
INSERT INTO public.who_global_data VALUES (62791, 24, 227, 0, 0, 265, 124);
INSERT INTO public.who_global_data VALUES (62792, 433, 18291, 17, 514, 265, 185);
INSERT INTO public.who_global_data VALUES (62793, 1527, 23358, 10, 220, 265, 194);
INSERT INTO public.who_global_data VALUES (62794, 0, 509, 0, 21, 265, 144);
INSERT INTO public.who_global_data VALUES (62795, 22813, 1432265, 1320, 87180, 265, 19);
INSERT INTO public.who_global_data VALUES (62796, 0, 69, 0, 6, 265, 217);
INSERT INTO public.who_global_data VALUES (62797, 8, 732, 0, 19, 265, 148);
INSERT INTO public.who_global_data VALUES (62798, 50, 2741, 0, 11, 265, 86);
INSERT INTO public.who_global_data VALUES (62799, 0, 0, 0, 0, 265, 13);
INSERT INTO public.who_global_data VALUES (62800, 49, 504, 0, 10, 265, 157);
INSERT INTO public.who_global_data VALUES (62801, 0, 318, 0, 0, 265, 8);
INSERT INTO public.who_global_data VALUES (62802, 0, 0, 0, 0, 265, 73);
INSERT INTO public.who_global_data VALUES (62803, 2, 126, 0, 19, 265, 101);
INSERT INTO public.who_global_data VALUES (62804, 11, 679, 0, 7, 265, 165);
INSERT INTO public.who_global_data VALUES (62805, 2, 44, 0, 4, 265, 14);
INSERT INTO public.who_global_data VALUES (62806, 349, 6402, 15, 168, 266, 193);
INSERT INTO public.who_global_data VALUES (62807, 35, 895, 0, 30, 266, 113);
INSERT INTO public.who_global_data VALUES (62808, 188, 6630, 7, 536, 266, 143);
INSERT INTO public.who_global_data VALUES (62809, 0, 0, 0, 0, 266, 219);
INSERT INTO public.who_global_data VALUES (62810, 0, 761, 0, 49, 266, 186);
INSERT INTO public.who_global_data VALUES (62811, 0, 48, 0, 2, 266, 52);
INSERT INTO public.who_global_data VALUES (62812, 0, 3, 0, 0, 266, 180);
INSERT INTO public.who_global_data VALUES (62813, 0, 25, 0, 3, 266, 167);
INSERT INTO public.who_global_data VALUES (62814, 161, 7134, 8, 353, 266, 154);
INSERT INTO public.who_global_data VALUES (62815, 184, 4020, 3, 52, 266, 94);
INSERT INTO public.who_global_data VALUES (62816, 0, 101, 0, 3, 266, 66);
INSERT INTO public.who_global_data VALUES (62817, 30, 7019, 0, 98, 266, 58);
INSERT INTO public.who_global_data VALUES (62818, 63, 16068, 2, 628, 266, 163);
INSERT INTO public.who_global_data VALUES (62819, 101, 2980, 1, 36, 266, 37);
INSERT INTO public.who_global_data VALUES (62820, 2, 96, 0, 11, 266, 142);
INSERT INTO public.who_global_data VALUES (62821, 237, 6655, 2, 12, 266, 83);
INSERT INTO public.who_global_data VALUES (62822, 930, 20995, 16, 314, 266, 228);
INSERT INTO public.who_global_data VALUES (62823, 0, 85, 0, 7, 266, 188);
INSERT INTO public.who_global_data VALUES (62824, 958, 27730, 5, 156, 266, 62);
INSERT INTO public.who_global_data VALUES (62825, 346, 56182, 45, 8914, 266, 160);
INSERT INTO public.who_global_data VALUES (62826, 0, 18, 0, 2, 266, 50);
INSERT INTO public.who_global_data VALUES (62827, 0, 339, 0, 2, 266, 33);
INSERT INTO public.who_global_data VALUES (62828, 1, 122, 1, 9, 266, 183);
INSERT INTO public.who_global_data VALUES (62829, 1, 21, 0, 0, 266, 92);
INSERT INTO public.who_global_data VALUES (62830, 224, 3372, 10, 152, 266, 158);
INSERT INTO public.who_global_data VALUES (62831, 0, 2, 0, 0, 266, 67);
INSERT INTO public.who_global_data VALUES (62832, 21, 2237, 4, 127, 266, 57);
INSERT INTO public.who_global_data VALUES (62833, 0, 24, 0, 1, 266, 38);
INSERT INTO public.who_global_data VALUES (62834, 13944, 202918, 844, 13993, 266, 141);
INSERT INTO public.who_global_data VALUES (62835, 1, 8, 0, 1, 266, 178);
INSERT INTO public.who_global_data VALUES (62836, 0, 141, 0, 1, 266, 108);
INSERT INTO public.who_global_data VALUES (62837, 38, 2138, 3, 102, 266, 39);
INSERT INTO public.who_global_data VALUES (62838, 7, 780, 0, 51, 266, 2);
INSERT INTO public.who_global_data VALUES (62839, 0, 27, 0, 1, 266, 195);
INSERT INTO public.who_global_data VALUES (62840, 11, 326, 0, 2, 266, 107);
INSERT INTO public.who_global_data VALUES (62841, 0, 122, 0, 0, 266, 161);
INSERT INTO public.who_global_data VALUES (62842, 93, 3047, 0, 139, 266, 212);
INSERT INTO public.who_global_data VALUES (62843, 1293, 73829, 162, 5499, 266, 181);
INSERT INTO public.who_global_data VALUES (62844, 7, 93, 0, 1, 266, 53);
INSERT INTO public.who_global_data VALUES (62845, 80, 301, 0, 0, 266, 164);
INSERT INTO public.who_global_data VALUES (62846, 29, 428, 2, 48, 266, 140);
INSERT INTO public.who_global_data VALUES (62847, 0, 37040, 0, 368, 266, 20);
INSERT INTO public.who_global_data VALUES (62848, 9, 84478, 0, 4644, 266, 112);
INSERT INTO public.who_global_data VALUES (62849, 680, 13610, 16, 525, 266, 111);
INSERT INTO public.who_global_data VALUES (62850, 0, 11, 0, 1, 266, 71);
INSERT INTO public.who_global_data VALUES (62851, 0, 391, 0, 15, 266, 218);
INSERT INTO public.who_global_data VALUES (62852, 0, 0, 0, 0, 266, 43);
INSERT INTO public.who_global_data VALUES (62853, 15, 830, 1, 8, 266, 49);
INSERT INTO public.who_global_data VALUES (62854, 46, 2017, 0, 24, 266, 1);
INSERT INTO public.who_global_data VALUES (62855, 1, 2222, 1, 95, 266, 48);
INSERT INTO public.who_global_data VALUES (62856, 10, 1840, 0, 79, 266, 232);
INSERT INTO public.who_global_data VALUES (62857, 0, 16, 0, 1, 266, 175);
INSERT INTO public.who_global_data VALUES (62858, 3, 910, 0, 17, 266, 21);
INSERT INTO public.who_global_data VALUES (62859, 55, 8406, 2, 295, 266, 156);
INSERT INTO public.who_global_data VALUES (62860, 0, 0, 0, 0, 266, 95);
INSERT INTO public.who_global_data VALUES (62861, 71, 1369, 10, 60, 266, 177);
INSERT INTO public.who_global_data VALUES (62862, 78, 10791, 0, 537, 266, 210);
INSERT INTO public.who_global_data VALUES (62863, 22, 1331, 0, 4, 266, 120);
INSERT INTO public.who_global_data VALUES (62864, 0, 16, 0, 0, 266, 135);
INSERT INTO public.who_global_data VALUES (62865, 419, 11739, 2, 424, 266, 206);
INSERT INTO public.who_global_data VALUES (62866, 0, 30502, 0, 2338, 266, 189);
INSERT INTO public.who_global_data VALUES (62867, 399, 11228, 21, 592, 266, 129);
INSERT INTO public.who_global_data VALUES (62868, 98, 1210, 3, 23, 266, 121);
INSERT INTO public.who_global_data VALUES (62869, 0, 594, 0, 7, 266, 59);
INSERT INTO public.who_global_data VALUES (62870, 0, 39, 0, 0, 266, 96);
INSERT INTO public.who_global_data VALUES (62871, 8, 1766, 1, 63, 266, 41);
INSERT INTO public.who_global_data VALUES (62872, 3, 190, 0, 2, 266, 216);
INSERT INTO public.who_global_data VALUES (62873, 15, 287, 0, 5, 266, 236);
INSERT INTO public.who_global_data VALUES (62874, 0, 13, 0, 0, 266, 150);
INSERT INTO public.who_global_data VALUES (62875, 0, 187, 0, 0, 266, 61);
INSERT INTO public.who_global_data VALUES (62876, 0, 18, 0, 0, 266, 7);
INSERT INTO public.who_global_data VALUES (62877, 83, 6228, 6, 293, 266, 169);
INSERT INTO public.who_global_data VALUES (62878, 494, 139646, 130, 27508, 266, 28);
INSERT INTO public.who_global_data VALUES (62879, 20, 184, 0, 1, 266, 85);
INSERT INTO public.who_global_data VALUES (62880, 0, 60, 0, 0, 266, 211);
INSERT INTO public.who_global_data VALUES (62881, 105, 1209, 0, 10, 266, 60);
INSERT INTO public.who_global_data VALUES (62882, 0, 23, 0, 1, 266, 3);
INSERT INTO public.who_global_data VALUES (62883, 6, 677, 0, 12, 266, 11);
INSERT INTO public.who_global_data VALUES (62884, 620, 173772, 57, 7881, 266, 89);
INSERT INTO public.who_global_data VALUES (62885, 108, 5638, 4, 28, 266, 24);
INSERT INTO public.who_global_data VALUES (62886, 0, 147, 0, 0, 266, 162);
INSERT INTO public.who_global_data VALUES (62887, 40, 2810, 4, 160, 266, 100);
INSERT INTO public.who_global_data VALUES (62888, 0, 11, 0, 0, 266, 47);
INSERT INTO public.who_global_data VALUES (62889, 1, 22, 0, 0, 266, 29);
INSERT INTO public.who_global_data VALUES (62890, 0, 155, 0, 13, 266, 40);
INSERT INTO public.who_global_data VALUES (62891, 0, 149, 0, 5, 266, 222);
INSERT INTO public.who_global_data VALUES (62892, 176, 1518, 0, 29, 266, 132);
INSERT INTO public.who_global_data VALUES (62893, 0, 252, 0, 13, 266, 130);
INSERT INTO public.who_global_data VALUES (62894, 58, 2531, 1, 15, 266, 234);
INSERT INTO public.who_global_data VALUES (62895, 0, 913, 0, 3, 266, 23);
INSERT INTO public.who_global_data VALUES (62896, 0, 113, 0, 10, 266, 192);
INSERT INTO public.who_global_data VALUES (62897, 39, 273, 2, 20, 266, 69);
INSERT INTO public.who_global_data VALUES (62898, 0, 12, 0, 0, 266, 187);
INSERT INTO public.who_global_data VALUES (62899, 63, 2318, 10, 133, 266, 230);
INSERT INTO public.who_global_data VALUES (62900, 56, 3473, 6, 448, 266, 77);
INSERT INTO public.who_global_data VALUES (62901, 0, 1802, 0, 10, 266, 9);
INSERT INTO public.who_global_data VALUES (62902, 3970, 85940, 103, 2752, 266, 74);
INSERT INTO public.who_global_data VALUES (62903, 529, 17025, 13, 1089, 266, 224);
INSERT INTO public.who_global_data VALUES (62904, 1757, 118392, 35, 6937, 266, 199);
INSERT INTO public.who_global_data VALUES (62905, 67, 3260, 4, 121, 266, 190);
INSERT INTO public.who_global_data VALUES (62906, 129, 23956, 12, 1518, 266, 12);
INSERT INTO public.who_global_data VALUES (62907, 2, 333, 1, 24, 266, 104);
INSERT INTO public.who_global_data VALUES (62908, 22, 16517, 2, 268, 266, 153);
INSERT INTO public.who_global_data VALUES (62909, 789, 223885, 242, 31610, 266, 91);
INSERT INTO public.who_global_data VALUES (62910, 0, 509, 0, 9, 266, 215);
INSERT INTO public.who_global_data VALUES (62911, 44, 16237, 15, 725, 266, 84);
INSERT INTO public.who_global_data VALUES (62912, 0, 297, 0, 27, 266, 231);
INSERT INTO public.who_global_data VALUES (62913, 11, 607, 0, 9, 266, 196);
INSERT INTO public.who_global_data VALUES (62914, 307, 6157, 0, 34, 266, 105);
INSERT INTO public.who_global_data VALUES (62915, 23, 781, 4, 46, 266, 122);
INSERT INTO public.who_global_data VALUES (62916, 0, 0, 0, 0, 266, 159);
INSERT INTO public.who_global_data VALUES (62917, 0, 944, 0, 20, 266, 75);
INSERT INTO public.who_global_data VALUES (62918, 942, 13802, 11, 107, 266, 27);
INSERT INTO public.who_global_data VALUES (62919, 6, 1117, 0, 14, 266, 54);
INSERT INTO public.who_global_data VALUES (62920, 0, 19, 0, 0, 266, 226);
INSERT INTO public.who_global_data VALUES (62921, 8, 970, 0, 19, 266, 79);
INSERT INTO public.who_global_data VALUES (62922, 11, 902, 0, 26, 266, 56);
INSERT INTO public.who_global_data VALUES (62923, 0, 1, 0, 0, 266, 117);
INSERT INTO public.who_global_data VALUES (62924, 4, 219, 0, 20, 266, 152);
INSERT INTO public.who_global_data VALUES (62925, 0, 64, 0, 3, 266, 16);
INSERT INTO public.who_global_data VALUES (62926, 0, 83, 0, 1, 266, 10);
INSERT INTO public.who_global_data VALUES (62927, 15, 1536, 1, 56, 266, 201);
INSERT INTO public.who_global_data VALUES (62928, 8, 3923, 1, 104, 266, 174);
INSERT INTO public.who_global_data VALUES (62929, 8, 238, 0, 0, 266, 119);
INSERT INTO public.who_global_data VALUES (62930, 0, 63, 0, 3, 266, 168);
INSERT INTO public.who_global_data VALUES (62931, 36, 6855, 0, 112, 266, 99);
INSERT INTO public.who_global_data VALUES (62932, 58, 1078, 0, 4, 266, 171);
INSERT INTO public.who_global_data VALUES (62933, 27, 806, 0, 46, 266, 87);
INSERT INTO public.who_global_data VALUES (62934, 14, 545, 0, 6, 266, 123);
INSERT INTO public.who_global_data VALUES (62935, 0, 0, 0, 0, 266, 151);
INSERT INTO public.who_global_data VALUES (62936, 0, 189, 0, 14, 266, 213);
INSERT INTO public.who_global_data VALUES (62937, 13, 29, 1, 3, 266, 118);
INSERT INTO public.who_global_data VALUES (62938, 0, 332, 0, 10, 266, 134);
INSERT INTO public.who_global_data VALUES (62939, 48, 1258, 0, 16, 266, 65);
INSERT INTO public.who_global_data VALUES (62940, 2409, 42595, 257, 4477, 266, 102);
INSERT INTO public.who_global_data VALUES (62941, 0, 0, 0, 0, 266, 223);
INSERT INTO public.who_global_data VALUES (62942, 0, 67, 0, 1, 266, 4);
INSERT INTO public.who_global_data VALUES (62943, 37, 135, 0, 0, 266, 146);
INSERT INTO public.who_global_data VALUES (62944, 0, 324, 0, 9, 266, 31);
INSERT INTO public.who_global_data VALUES (62945, 0, 11, 0, 1, 266, 127);
INSERT INTO public.who_global_data VALUES (62946, 58, 6681, 2, 192, 266, 22);
INSERT INTO public.who_global_data VALUES (62947, 4, 119, 0, 0, 266, 115);
INSERT INTO public.who_global_data VALUES (62948, 1, 182, 0, 6, 266, 106);
INSERT INTO public.who_global_data VALUES (62949, 0, 16, 0, 0, 266, 90);
INSERT INTO public.who_global_data VALUES (62950, 0, 0, 0, 0, 266, 70);
INSERT INTO public.who_global_data VALUES (62951, 23, 281, 1, 1, 266, 46);
INSERT INTO public.who_global_data VALUES (62952, 202, 43443, 50, 5608, 266, 139);
INSERT INTO public.who_global_data VALUES (62953, 0, 18, 0, 0, 266, 42);
INSERT INTO public.who_global_data VALUES (62954, 0, 1148, 0, 21, 266, 80);
INSERT INTO public.who_global_data VALUES (62955, 0, 25, 0, 8, 266, 203);
INSERT INTO public.who_global_data VALUES (62956, 9, 885, 1, 51, 266, 136);
INSERT INTO public.who_global_data VALUES (62957, 288, 5450, 4, 171, 266, 63);
INSERT INTO public.who_global_data VALUES (62958, 0, 0, 0, 0, 266, 17);
INSERT INTO public.who_global_data VALUES (62959, 0, 19, 0, 2, 266, 172);
INSERT INTO public.who_global_data VALUES (62960, 17, 1740, 2, 97, 266, 109);
INSERT INTO public.who_global_data VALUES (62961, 22, 8197, 0, 232, 266, 200);
INSERT INTO public.who_global_data VALUES (62962, 0, 554, 0, 4, 266, 93);
INSERT INTO public.who_global_data VALUES (62963, 404, 5029, 1, 21, 266, 5);
INSERT INTO public.who_global_data VALUES (62964, 0, 712, 0, 13, 266, 214);
INSERT INTO public.who_global_data VALUES (62965, 1581, 38799, 31, 834, 266, 204);
INSERT INTO public.who_global_data VALUES (62966, 0, 0, 0, 0, 266, 198);
INSERT INTO public.who_global_data VALUES (62967, 174, 9118, 4, 260, 266, 173);
INSERT INTO public.who_global_data VALUES (62968, 0, 8, 0, 0, 266, 229);
INSERT INTO public.who_global_data VALUES (62969, 5, 759, 0, 11, 266, 76);
INSERT INTO public.who_global_data VALUES (62970, 4298, 80604, 98, 2267, 266, 138);
INSERT INTO public.who_global_data VALUES (62971, 429, 12305, 27, 817, 266, 98);
INSERT INTO public.who_global_data VALUES (62972, 0, 0, 0, 0, 266, 103);
INSERT INTO public.who_global_data VALUES (62973, 401, 18016, 24, 907, 266, 225);
INSERT INTO public.who_global_data VALUES (62974, 264, 28583, 6, 1190, 266, 131);
INSERT INTO public.who_global_data VALUES (62975, 115, 2542, 5, 122, 266, 235);
INSERT INTO public.who_global_data VALUES (62976, 1547, 30972, 1, 15, 266, 137);
INSERT INTO public.who_global_data VALUES (62977, 19, 11037, 2, 262, 266, 81);
INSERT INTO public.who_global_data VALUES (62978, 192, 5745, 8, 204, 266, 182);
INSERT INTO public.who_global_data VALUES (62979, 1, 441, 0, 0, 266, 145);
INSERT INTO public.who_global_data VALUES (62980, 190, 16437, 10, 1056, 266, 26);
INSERT INTO public.who_global_data VALUES (62981, 9200, 272043, 119, 2537, 266, 170);
INSERT INTO public.who_global_data VALUES (62982, 0, 287, 0, 0, 266, 191);
INSERT INTO public.who_global_data VALUES (62983, 0, 2, 0, 0, 266, 221);
INSERT INTO public.who_global_data VALUES (62984, 0, 6, 0, 0, 266, 64);
INSERT INTO public.who_global_data VALUES (62985, 0, 0, 0, 0, 266, 116);
INSERT INTO public.who_global_data VALUES (62986, 0, 15, 0, 0, 266, 128);
INSERT INTO public.who_global_data VALUES (62987, 0, 18, 0, 0, 266, 6);
INSERT INTO public.who_global_data VALUES (62988, 0, 39, 0, 3, 266, 227);
INSERT INTO public.who_global_data VALUES (62989, 0, 1, 0, 0, 266, 68);
INSERT INTO public.who_global_data VALUES (62990, 0, 17, 0, 0, 266, 184);
INSERT INTO public.who_global_data VALUES (62991, 0, 0, 0, 0, 266, 82);
INSERT INTO public.who_global_data VALUES (62992, 5, 652, 0, 41, 266, 149);
INSERT INTO public.who_global_data VALUES (62993, 0, 166, 0, 7, 266, 197);
INSERT INTO public.who_global_data VALUES (62994, 2840, 52016, 10, 302, 266, 78);
INSERT INTO public.who_global_data VALUES (62995, 121, 2310, 0, 23, 266, 233);
INSERT INTO public.who_global_data VALUES (62996, 64, 10438, 1, 225, 266, 133);
INSERT INTO public.who_global_data VALUES (62997, 0, 11, 0, 0, 266, 35);
INSERT INTO public.who_global_data VALUES (62998, 39, 447, 1, 27, 266, 114);
INSERT INTO public.who_global_data VALUES (62999, 793, 26891, 0, 21, 266, 237);
INSERT INTO public.who_global_data VALUES (63000, 0, 2, 0, 0, 266, 55);
INSERT INTO public.who_global_data VALUES (63001, 0, 78, 0, 15, 266, 176);
INSERT INTO public.who_global_data VALUES (63002, 3, 1480, 0, 27, 266, 202);
INSERT INTO public.who_global_data VALUES (63003, 0, 1465, 0, 111, 266, 155);
INSERT INTO public.who_global_data VALUES (63004, 0, 0, 0, 0, 266, 32);
INSERT INTO public.who_global_data VALUES (63005, 73, 1357, 2, 55, 266, 220);
INSERT INTO public.who_global_data VALUES (63006, 785, 13524, 9, 247, 266, 30);
INSERT INTO public.who_global_data VALUES (63007, 0, 231, 0, 1, 266, 147);
INSERT INTO public.who_global_data VALUES (63008, 880, 236524, 86, 28175, 266, 208);
INSERT INTO public.who_global_data VALUES (63009, 24, 949, 0, 9, 266, 45);
INSERT INTO public.who_global_data VALUES (63010, 0, 1964, 0, 91, 266, 110);
INSERT INTO public.who_global_data VALUES (63011, 0, 10, 0, 1, 266, 88);
INSERT INTO public.who_global_data VALUES (63012, 657, 29413, 46, 3871, 266, 51);
INSERT INTO public.who_global_data VALUES (63013, 41, 30535, 5, 1691, 266, 209);
INSERT INTO public.who_global_data VALUES (63014, 2, 50, 0, 3, 266, 205);
INSERT INTO public.who_global_data VALUES (63015, 33, 1118, 0, 36, 266, 18);
INSERT INTO public.who_global_data VALUES (63016, 0, 3025, 0, 56, 266, 72);
INSERT INTO public.who_global_data VALUES (63017, 2628, 223647, 350, 33342, 266, 44);
INSERT INTO public.who_global_data VALUES (63018, 0, 24, 0, 0, 266, 15);
INSERT INTO public.who_global_data VALUES (63019, 25, 263, 0, 11, 266, 25);
INSERT INTO public.who_global_data VALUES (63020, 0, 0, 0, 0, 266, 179);
INSERT INTO public.who_global_data VALUES (63021, 0, 0, 0, 0, 266, 34);
INSERT INTO public.who_global_data VALUES (63022, 0, 116, 0, 8, 266, 207);
INSERT INTO public.who_global_data VALUES (63023, 3, 1035, 0, 45, 266, 166);
INSERT INTO public.who_global_data VALUES (63024, 1708, 146457, 48, 4055, 266, 126);
INSERT INTO public.who_global_data VALUES (63025, 0, 0, 0, 0, 266, 97);
INSERT INTO public.who_global_data VALUES (63026, 0, 12, 0, 1, 266, 36);
INSERT INTO public.who_global_data VALUES (63027, 0, 0, 0, 0, 266, 125);
INSERT INTO public.who_global_data VALUES (63028, 43, 203, 0, 0, 266, 124);
INSERT INTO public.who_global_data VALUES (63029, 528, 17858, 21, 497, 266, 185);
INSERT INTO public.who_global_data VALUES (63030, 0, 21831, 0, 210, 266, 194);
INSERT INTO public.who_global_data VALUES (63031, 0, 509, 0, 21, 266, 144);
INSERT INTO public.who_global_data VALUES (63032, 27090, 1409452, 2041, 85860, 266, 19);
INSERT INTO public.who_global_data VALUES (63033, 0, 69, 0, 6, 266, 217);
INSERT INTO public.who_global_data VALUES (63034, 5, 724, 0, 19, 266, 148);
INSERT INTO public.who_global_data VALUES (63035, 39, 2691, 0, 11, 266, 86);
INSERT INTO public.who_global_data VALUES (63036, 0, 0, 0, 0, 266, 13);
INSERT INTO public.who_global_data VALUES (63037, 15, 455, 0, 10, 266, 157);
INSERT INTO public.who_global_data VALUES (63038, 30, 318, 0, 0, 266, 8);
INSERT INTO public.who_global_data VALUES (63039, 0, 0, 0, 0, 266, 73);
INSERT INTO public.who_global_data VALUES (63040, 16, 124, 3, 19, 266, 101);
INSERT INTO public.who_global_data VALUES (63041, 14, 668, 0, 7, 266, 165);
INSERT INTO public.who_global_data VALUES (63042, 5, 42, 0, 4, 266, 14);
INSERT INTO public.who_global_data VALUES (63043, 714, 6053, 17, 153, 267, 193);
INSERT INTO public.who_global_data VALUES (63044, 18, 860, 0, 30, 267, 113);
INSERT INTO public.who_global_data VALUES (63045, 189, 6442, 7, 529, 267, 143);
INSERT INTO public.who_global_data VALUES (63046, 0, 0, 0, 0, 267, 219);
INSERT INTO public.who_global_data VALUES (63047, 0, 761, 0, 49, 267, 186);
INSERT INTO public.who_global_data VALUES (63048, 3, 48, 0, 2, 267, 52);
INSERT INTO public.who_global_data VALUES (63049, 0, 3, 0, 0, 267, 180);
INSERT INTO public.who_global_data VALUES (63050, 0, 25, 0, 3, 267, 167);
INSERT INTO public.who_global_data VALUES (63051, 410, 6973, 24, 345, 267, 154);
INSERT INTO public.who_global_data VALUES (63052, 142, 3836, 1, 49, 267, 94);
INSERT INTO public.who_global_data VALUES (63053, 0, 101, 0, 3, 267, 66);
INSERT INTO public.who_global_data VALUES (63054, 14, 6989, 0, 98, 267, 58);
INSERT INTO public.who_global_data VALUES (63055, 41, 16005, 2, 626, 267, 163);
INSERT INTO public.who_global_data VALUES (63056, 121, 2879, 0, 35, 267, 37);
INSERT INTO public.who_global_data VALUES (63057, 1, 94, 0, 11, 267, 142);
INSERT INTO public.who_global_data VALUES (63058, 349, 6418, 0, 10, 267, 83);
INSERT INTO public.who_global_data VALUES (63059, 1202, 20065, 15, 298, 267, 228);
INSERT INTO public.who_global_data VALUES (63060, 0, 85, 0, 7, 267, 188);
INSERT INTO public.who_global_data VALUES (63061, 932, 26772, 2, 151, 267, 62);
INSERT INTO public.who_global_data VALUES (63062, 305, 55836, 43, 8869, 267, 160);
INSERT INTO public.who_global_data VALUES (63063, 0, 18, 0, 2, 267, 50);
INSERT INTO public.who_global_data VALUES (63064, 12, 339, 0, 2, 267, 33);
INSERT INTO public.who_global_data VALUES (63065, 0, 121, 0, 8, 267, 183);
INSERT INTO public.who_global_data VALUES (63066, 5, 20, 0, 0, 267, 92);
INSERT INTO public.who_global_data VALUES (63067, 184, 3148, 14, 142, 267, 158);
INSERT INTO public.who_global_data VALUES (63068, 0, 2, 0, 0, 267, 67);
INSERT INTO public.who_global_data VALUES (63069, 35, 2216, 4, 123, 267, 57);
INSERT INTO public.who_global_data VALUES (63070, 0, 24, 0, 1, 267, 38);
INSERT INTO public.who_global_data VALUES (63071, 11385, 188974, 749, 13149, 267, 141);
INSERT INTO public.who_global_data VALUES (63072, 0, 7, 0, 1, 267, 178);
INSERT INTO public.who_global_data VALUES (63073, 0, 141, 0, 1, 267, 108);
INSERT INTO public.who_global_data VALUES (63074, 31, 2100, 3, 99, 267, 39);
INSERT INTO public.who_global_data VALUES (63075, 0, 773, 0, 51, 267, 2);
INSERT INTO public.who_global_data VALUES (63076, 0, 27, 0, 1, 267, 195);
INSERT INTO public.who_global_data VALUES (63077, 26, 315, 0, 2, 267, 107);
INSERT INTO public.who_global_data VALUES (63078, 0, 122, 0, 0, 267, 161);
INSERT INTO public.who_global_data VALUES (63079, 154, 2954, 3, 139, 267, 212);
INSERT INTO public.who_global_data VALUES (63080, 1050, 72536, 128, 5337, 267, 181);
INSERT INTO public.who_global_data VALUES (63081, 1, 86, 0, 1, 267, 53);
INSERT INTO public.who_global_data VALUES (63082, 34, 221, 0, 0, 267, 164);
INSERT INTO public.who_global_data VALUES (63083, 27, 399, 4, 46, 267, 140);
INSERT INTO public.who_global_data VALUES (63084, 2659, 37040, 22, 368, 267, 20);
INSERT INTO public.who_global_data VALUES (63085, 5, 84469, 0, 4644, 267, 112);
INSERT INTO public.who_global_data VALUES (63086, 658, 12930, 16, 509, 267, 111);
INSERT INTO public.who_global_data VALUES (63087, 0, 11, 0, 1, 267, 71);
INSERT INTO public.who_global_data VALUES (63088, 50, 391, 4, 15, 267, 218);
INSERT INTO public.who_global_data VALUES (63089, 0, 0, 0, 0, 267, 43);
INSERT INTO public.who_global_data VALUES (63090, 11, 815, 0, 7, 267, 49);
INSERT INTO public.who_global_data VALUES (63091, 59, 1971, 0, 24, 267, 1);
INSERT INTO public.who_global_data VALUES (63092, 8, 2221, 0, 94, 267, 48);
INSERT INTO public.who_global_data VALUES (63093, 20, 1830, 0, 79, 267, 232);
INSERT INTO public.who_global_data VALUES (63094, 0, 16, 0, 1, 267, 175);
INSERT INTO public.who_global_data VALUES (63095, 2, 907, 0, 17, 267, 21);
INSERT INTO public.who_global_data VALUES (63096, 82, 8351, 3, 293, 267, 156);
INSERT INTO public.who_global_data VALUES (63097, 0, 0, 0, 0, 267, 95);
INSERT INTO public.who_global_data VALUES (63098, 56, 1298, 0, 50, 267, 177);
INSERT INTO public.who_global_data VALUES (63099, 46, 10713, 4, 537, 267, 210);
INSERT INTO public.who_global_data VALUES (63100, 41, 1309, 1, 4, 267, 120);
INSERT INTO public.who_global_data VALUES (63101, 0, 16, 0, 0, 267, 135);
INSERT INTO public.who_global_data VALUES (63102, 124, 11320, 13, 422, 267, 206);
INSERT INTO public.who_global_data VALUES (63103, 16, 30502, 4, 2338, 267, 189);
INSERT INTO public.who_global_data VALUES (63104, 0, 10829, 0, 571, 267, 129);
INSERT INTO public.who_global_data VALUES (63105, 75, 1112, 0, 20, 267, 121);
INSERT INTO public.who_global_data VALUES (63106, 11, 594, 0, 7, 267, 59);
INSERT INTO public.who_global_data VALUES (63107, 0, 39, 0, 0, 267, 96);
INSERT INTO public.who_global_data VALUES (63108, 7, 1758, 1, 62, 267, 41);
INSERT INTO public.who_global_data VALUES (63109, 0, 187, 0, 2, 267, 216);
INSERT INTO public.who_global_data VALUES (63110, 9, 272, 0, 5, 267, 236);
INSERT INTO public.who_global_data VALUES (63111, 0, 13, 0, 0, 267, 150);
INSERT INTO public.who_global_data VALUES (63112, 0, 187, 0, 0, 267, 61);
INSERT INTO public.who_global_data VALUES (63113, 0, 18, 0, 0, 267, 7);
INSERT INTO public.who_global_data VALUES (63114, 91, 6145, 3, 287, 267, 169);
INSERT INTO public.who_global_data VALUES (63115, 543, 139152, 349, 27378, 267, 28);
INSERT INTO public.who_global_data VALUES (63116, 11, 164, 0, 1, 267, 85);
INSERT INTO public.who_global_data VALUES (63117, 0, 60, 0, 0, 267, 211);
INSERT INTO public.who_global_data VALUES (63118, 100, 1104, 1, 10, 267, 60);
INSERT INTO public.who_global_data VALUES (63119, 0, 23, 0, 1, 267, 3);
INSERT INTO public.who_global_data VALUES (63120, 19, 671, 1, 12, 267, 11);
INSERT INTO public.who_global_data VALUES (63121, 913, 173152, 101, 7824, 267, 89);
INSERT INTO public.who_global_data VALUES (63122, 122, 5530, 0, 24, 267, 24);
INSERT INTO public.who_global_data VALUES (63123, 0, 147, 0, 0, 267, 162);
INSERT INTO public.who_global_data VALUES (63124, 10, 2770, 1, 156, 267, 100);
INSERT INTO public.who_global_data VALUES (63125, 0, 11, 0, 0, 267, 47);
INSERT INTO public.who_global_data VALUES (63126, 0, 21, 0, 0, 267, 29);
INSERT INTO public.who_global_data VALUES (63127, 0, 155, 0, 13, 267, 40);
INSERT INTO public.who_global_data VALUES (63128, 1, 149, 0, 5, 267, 222);
INSERT INTO public.who_global_data VALUES (63129, 143, 1342, 2, 29, 267, 132);
INSERT INTO public.who_global_data VALUES (63130, 0, 252, 0, 13, 267, 130);
INSERT INTO public.who_global_data VALUES (63131, 101, 2473, 0, 14, 267, 234);
INSERT INTO public.who_global_data VALUES (63132, 77, 913, 0, 3, 267, 23);
INSERT INTO public.who_global_data VALUES (63133, 0, 113, 0, 10, 267, 192);
INSERT INTO public.who_global_data VALUES (63134, 15, 234, 0, 18, 267, 69);
INSERT INTO public.who_global_data VALUES (63135, 0, 12, 0, 0, 267, 187);
INSERT INTO public.who_global_data VALUES (63136, 175, 2255, 2, 123, 267, 230);
INSERT INTO public.who_global_data VALUES (63137, 37, 3417, 6, 442, 267, 77);
INSERT INTO public.who_global_data VALUES (63138, 0, 1802, 0, 10, 267, 9);
INSERT INTO public.who_global_data VALUES (63139, 3967, 81970, 100, 2649, 267, 74);
INSERT INTO public.who_global_data VALUES (63140, 490, 16496, 33, 1076, 267, 224);
INSERT INTO public.who_global_data VALUES (63141, 2102, 116635, 48, 6902, 267, 199);
INSERT INTO public.who_global_data VALUES (63142, 50, 3193, 2, 117, 267, 190);
INSERT INTO public.who_global_data VALUES (63143, 426, 23827, 9, 1506, 267, 12);
INSERT INTO public.who_global_data VALUES (63144, 0, 331, 0, 23, 267, 104);
INSERT INTO public.who_global_data VALUES (63145, 39, 16495, 3, 266, 267, 153);
INSERT INTO public.who_global_data VALUES (63146, 992, 223096, 262, 31368, 267, 91);
INSERT INTO public.who_global_data VALUES (63147, 2, 509, 0, 9, 267, 215);
INSERT INTO public.who_global_data VALUES (63148, 114, 16193, 23, 710, 267, 84);
INSERT INTO public.who_global_data VALUES (63149, 0, 297, 0, 27, 267, 231);
INSERT INTO public.who_global_data VALUES (63150, 10, 596, 0, 9, 267, 196);
INSERT INTO public.who_global_data VALUES (63151, 161, 5850, 0, 34, 267, 105);
INSERT INTO public.who_global_data VALUES (63152, 21, 758, 2, 42, 267, 122);
INSERT INTO public.who_global_data VALUES (63153, 0, 0, 0, 0, 267, 159);
INSERT INTO public.who_global_data VALUES (63154, 25, 944, 0, 20, 267, 75);
INSERT INTO public.who_global_data VALUES (63155, 885, 12860, 8, 96, 267, 27);
INSERT INTO public.who_global_data VALUES (63156, 29, 1111, 2, 14, 267, 54);
INSERT INTO public.who_global_data VALUES (63157, 0, 19, 0, 0, 267, 226);
INSERT INTO public.who_global_data VALUES (63158, 11, 962, 0, 19, 267, 79);
INSERT INTO public.who_global_data VALUES (63159, 5, 891, 0, 26, 267, 56);
INSERT INTO public.who_global_data VALUES (63160, 0, 1, 0, 0, 267, 117);
INSERT INTO public.who_global_data VALUES (63161, 2, 215, 0, 20, 267, 152);
INSERT INTO public.who_global_data VALUES (63162, 0, 64, 0, 3, 267, 16);
INSERT INTO public.who_global_data VALUES (63163, 0, 83, 0, 1, 267, 10);
INSERT INTO public.who_global_data VALUES (63164, 10, 1521, 1, 55, 267, 201);
INSERT INTO public.who_global_data VALUES (63165, 11, 3915, 0, 103, 267, 174);
INSERT INTO public.who_global_data VALUES (63166, 18, 230, 0, 0, 267, 119);
INSERT INTO public.who_global_data VALUES (63167, 0, 63, 0, 3, 267, 168);
INSERT INTO public.who_global_data VALUES (63168, 40, 6819, 1, 112, 267, 99);
INSERT INTO public.who_global_data VALUES (63169, 52, 1020, 0, 4, 267, 171);
INSERT INTO public.who_global_data VALUES (63170, 21, 779, 2, 46, 267, 87);
INSERT INTO public.who_global_data VALUES (63171, 10, 531, 0, 6, 267, 123);
INSERT INTO public.who_global_data VALUES (63172, 0, 0, 0, 0, 267, 151);
INSERT INTO public.who_global_data VALUES (63173, 0, 189, 0, 14, 267, 213);
INSERT INTO public.who_global_data VALUES (63174, 7, 16, 1, 2, 267, 118);
INSERT INTO public.who_global_data VALUES (63175, 0, 332, 0, 10, 267, 134);
INSERT INTO public.who_global_data VALUES (63176, 67, 1210, 2, 16, 267, 65);
INSERT INTO public.who_global_data VALUES (63177, 1862, 40186, 294, 4220, 267, 102);
INSERT INTO public.who_global_data VALUES (63178, 0, 0, 0, 0, 267, 223);
INSERT INTO public.who_global_data VALUES (63179, 0, 67, 0, 1, 267, 4);
INSERT INTO public.who_global_data VALUES (63180, 56, 98, 0, 0, 267, 146);
INSERT INTO public.who_global_data VALUES (63181, 0, 324, 0, 9, 267, 31);
INSERT INTO public.who_global_data VALUES (63182, 0, 11, 0, 1, 267, 127);
INSERT INTO public.who_global_data VALUES (63183, 30, 6623, 1, 190, 267, 22);
INSERT INTO public.who_global_data VALUES (63184, 8, 115, 0, 0, 267, 115);
INSERT INTO public.who_global_data VALUES (63185, 0, 181, 0, 6, 267, 106);
INSERT INTO public.who_global_data VALUES (63186, 0, 16, 0, 0, 267, 90);
INSERT INTO public.who_global_data VALUES (63187, 0, 0, 0, 0, 267, 70);
INSERT INTO public.who_global_data VALUES (63188, 9, 258, 0, 0, 267, 46);
INSERT INTO public.who_global_data VALUES (63189, 274, 43241, 30, 5558, 267, 139);
INSERT INTO public.who_global_data VALUES (63190, 0, 18, 0, 0, 267, 42);
INSERT INTO public.who_global_data VALUES (63191, 1, 1148, 0, 21, 267, 80);
INSERT INTO public.who_global_data VALUES (63192, 0, 25, 0, 8, 267, 203);
INSERT INTO public.who_global_data VALUES (63193, 16, 876, 1, 50, 267, 136);
INSERT INTO public.who_global_data VALUES (63194, 191, 5162, 3, 167, 267, 63);
INSERT INTO public.who_global_data VALUES (63195, 0, 0, 0, 0, 267, 17);
INSERT INTO public.who_global_data VALUES (63196, 0, 19, 0, 2, 267, 172);
INSERT INTO public.who_global_data VALUES (63197, 29, 1723, 0, 95, 267, 109);
INSERT INTO public.who_global_data VALUES (63198, 17, 8175, 3, 232, 267, 200);
INSERT INTO public.who_global_data VALUES (63199, 6, 554, 0, 4, 267, 93);
INSERT INTO public.who_global_data VALUES (63200, 284, 4625, 3, 20, 267, 5);
INSERT INTO public.who_global_data VALUES (63201, 0, 712, 0, 13, 267, 214);
INSERT INTO public.who_global_data VALUES (63202, 1430, 37218, 33, 803, 267, 204);
INSERT INTO public.who_global_data VALUES (63203, 0, 0, 0, 0, 267, 198);
INSERT INTO public.who_global_data VALUES (63204, 328, 8944, 7, 256, 267, 173);
INSERT INTO public.who_global_data VALUES (63205, 0, 8, 0, 0, 267, 229);
INSERT INTO public.who_global_data VALUES (63206, 14, 754, 0, 11, 267, 76);
INSERT INTO public.who_global_data VALUES (63207, 4247, 76306, 112, 2169, 267, 138);
INSERT INTO public.who_global_data VALUES (63208, 258, 11876, 18, 790, 267, 98);
INSERT INTO public.who_global_data VALUES (63209, 0, 0, 0, 0, 267, 103);
INSERT INTO public.who_global_data VALUES (63210, 411, 17615, 22, 883, 267, 225);
INSERT INTO public.who_global_data VALUES (63211, 187, 28319, 9, 1184, 267, 131);
INSERT INTO public.who_global_data VALUES (63212, 98, 2427, 2, 117, 267, 235);
INSERT INTO public.who_global_data VALUES (63213, 1153, 29425, 0, 14, 267, 137);
INSERT INTO public.who_global_data VALUES (63214, 27, 11018, 0, 260, 267, 81);
INSERT INTO public.who_global_data VALUES (63215, 147, 5553, 6, 196, 267, 182);
INSERT INTO public.who_global_data VALUES (63216, 1, 440, 0, 0, 267, 145);
INSERT INTO public.who_global_data VALUES (63217, 245, 16247, 30, 1046, 267, 26);
INSERT INTO public.who_global_data VALUES (63218, 10598, 262843, 113, 2418, 267, 170);
INSERT INTO public.who_global_data VALUES (63219, 0, 287, 0, 0, 267, 191);
INSERT INTO public.who_global_data VALUES (63220, 0, 2, 0, 0, 267, 221);
INSERT INTO public.who_global_data VALUES (63221, 0, 6, 0, 0, 267, 64);
INSERT INTO public.who_global_data VALUES (63222, 0, 0, 0, 0, 267, 116);
INSERT INTO public.who_global_data VALUES (63223, 0, 15, 0, 0, 267, 128);
INSERT INTO public.who_global_data VALUES (63224, 0, 18, 0, 0, 267, 6);
INSERT INTO public.who_global_data VALUES (63225, 0, 39, 0, 3, 267, 227);
INSERT INTO public.who_global_data VALUES (63226, 0, 1, 0, 0, 267, 68);
INSERT INTO public.who_global_data VALUES (63227, 0, 17, 0, 0, 267, 184);
INSERT INTO public.who_global_data VALUES (63228, 0, 0, 0, 0, 267, 82);
INSERT INTO public.who_global_data VALUES (63229, 0, 647, 0, 41, 267, 149);
INSERT INTO public.who_global_data VALUES (63230, 1, 166, 0, 7, 267, 197);
INSERT INTO public.who_global_data VALUES (63231, 2307, 49176, 9, 292, 267, 78);
INSERT INTO public.who_global_data VALUES (63232, 84, 2189, 1, 23, 267, 233);
INSERT INTO public.who_global_data VALUES (63233, 79, 10374, 2, 224, 267, 133);
INSERT INTO public.who_global_data VALUES (63234, 0, 11, 0, 0, 267, 35);
INSERT INTO public.who_global_data VALUES (63235, 21, 408, 5, 26, 267, 114);
INSERT INTO public.who_global_data VALUES (63236, 752, 26098, 0, 21, 267, 237);
INSERT INTO public.who_global_data VALUES (63237, 0, 2, 0, 0, 267, 55);
INSERT INTO public.who_global_data VALUES (63238, 0, 78, 0, 15, 267, 176);
INSERT INTO public.who_global_data VALUES (63239, 8, 1477, 0, 27, 267, 202);
INSERT INTO public.who_global_data VALUES (63240, 1, 1465, 0, 111, 267, 155);
INSERT INTO public.who_global_data VALUES (63241, 0, 0, 0, 0, 267, 32);
INSERT INTO public.who_global_data VALUES (63242, 0, 1284, 0, 53, 267, 220);
INSERT INTO public.who_global_data VALUES (63243, 665, 12739, 19, 238, 267, 30);
INSERT INTO public.who_global_data VALUES (63244, 37, 231, 1, 1, 267, 147);
INSERT INTO public.who_global_data VALUES (63245, 876, 235644, 87, 28089, 267, 208);
INSERT INTO public.who_global_data VALUES (63246, 9, 925, 0, 9, 267, 45);
INSERT INTO public.who_global_data VALUES (63247, 146, 1964, 1, 91, 267, 110);
INSERT INTO public.who_global_data VALUES (63248, 0, 10, 0, 1, 267, 88);
INSERT INTO public.who_global_data VALUES (63249, 698, 28756, 50, 3825, 267, 51);
INSERT INTO public.who_global_data VALUES (63250, 37, 30494, 2, 1686, 267, 209);
INSERT INTO public.who_global_data VALUES (63251, 0, 48, 0, 3, 267, 205);
INSERT INTO public.who_global_data VALUES (63252, 178, 1085, 4, 36, 267, 18);
INSERT INTO public.who_global_data VALUES (63253, 7, 3025, 0, 56, 267, 72);
INSERT INTO public.who_global_data VALUES (63254, 3307, 221019, 352, 32992, 267, 44);
INSERT INTO public.who_global_data VALUES (63255, 0, 24, 0, 0, 267, 15);
INSERT INTO public.who_global_data VALUES (63256, 19, 238, 0, 11, 267, 25);
INSERT INTO public.who_global_data VALUES (63257, 0, 0, 0, 0, 267, 179);
INSERT INTO public.who_global_data VALUES (63258, 0, 0, 0, 0, 267, 34);
INSERT INTO public.who_global_data VALUES (63259, 0, 116, 0, 8, 267, 207);
INSERT INTO public.who_global_data VALUES (63260, 0, 1032, 0, 45, 267, 166);
INSERT INTO public.who_global_data VALUES (63261, 1635, 144749, 55, 4007, 267, 126);
INSERT INTO public.who_global_data VALUES (63262, 0, 0, 0, 0, 267, 97);
INSERT INTO public.who_global_data VALUES (63263, 0, 12, 0, 1, 267, 36);
INSERT INTO public.who_global_data VALUES (63264, 0, 0, 0, 0, 267, 125);
INSERT INTO public.who_global_data VALUES (63265, 21, 160, 0, 0, 267, 124);
INSERT INTO public.who_global_data VALUES (63266, 483, 17330, 20, 476, 267, 185);
INSERT INTO public.who_global_data VALUES (63267, 747, 21831, 2, 210, 267, 194);
INSERT INTO public.who_global_data VALUES (63268, 0, 509, 0, 21, 267, 144);
INSERT INTO public.who_global_data VALUES (63269, 20840, 1382362, 1700, 83819, 267, 19);
INSERT INTO public.who_global_data VALUES (63270, 0, 69, 0, 6, 267, 217);
INSERT INTO public.who_global_data VALUES (63271, 2, 719, 0, 19, 267, 148);
INSERT INTO public.who_global_data VALUES (63272, 32, 2652, 0, 11, 267, 86);
INSERT INTO public.who_global_data VALUES (63273, 0, 0, 0, 0, 267, 13);
INSERT INTO public.who_global_data VALUES (63274, 0, 440, 0, 10, 267, 157);
INSERT INTO public.who_global_data VALUES (63275, 0, 288, 0, 0, 267, 8);
INSERT INTO public.who_global_data VALUES (63276, 0, 0, 0, 0, 267, 73);
INSERT INTO public.who_global_data VALUES (63277, 21, 108, 3, 16, 267, 101);
INSERT INTO public.who_global_data VALUES (63278, 208, 654, 0, 7, 267, 165);
INSERT INTO public.who_global_data VALUES (63279, 0, 37, 0, 4, 267, 14);
INSERT INTO public.who_global_data VALUES (63280, 113, 5339, 6, 136, 268, 193);
INSERT INTO public.who_global_data VALUES (63281, 4, 842, 0, 30, 268, 113);
INSERT INTO public.who_global_data VALUES (63282, 186, 6253, 7, 522, 268, 143);
INSERT INTO public.who_global_data VALUES (63283, 0, 0, 0, 0, 268, 219);
INSERT INTO public.who_global_data VALUES (63284, 2, 761, 1, 49, 268, 186);
INSERT INTO public.who_global_data VALUES (63285, 0, 45, 0, 2, 268, 52);
INSERT INTO public.who_global_data VALUES (63286, 0, 3, 0, 0, 268, 180);
INSERT INTO public.who_global_data VALUES (63287, 0, 25, 0, 3, 268, 167);
INSERT INTO public.who_global_data VALUES (63288, 285, 6563, 4, 321, 268, 154);
INSERT INTO public.who_global_data VALUES (63289, 180, 3694, 1, 48, 268, 94);
INSERT INTO public.who_global_data VALUES (63290, 0, 101, 0, 3, 268, 66);
INSERT INTO public.who_global_data VALUES (63291, 11, 6975, 1, 98, 268, 58);
INSERT INTO public.who_global_data VALUES (63292, 54, 15964, 1, 624, 268, 163);
INSERT INTO public.who_global_data VALUES (63293, 65, 2758, 2, 35, 268, 37);
INSERT INTO public.who_global_data VALUES (63294, 0, 93, 0, 11, 268, 142);
INSERT INTO public.who_global_data VALUES (63295, 289, 6069, 1, 10, 268, 83);
INSERT INTO public.who_global_data VALUES (63296, 1041, 18863, 14, 283, 268, 228);
INSERT INTO public.who_global_data VALUES (63297, 1, 85, 0, 7, 268, 188);
INSERT INTO public.who_global_data VALUES (63298, 0, 25840, 0, 149, 268, 62);
INSERT INTO public.who_global_data VALUES (63299, 321, 55531, 56, 8826, 268, 160);
INSERT INTO public.who_global_data VALUES (63300, 0, 18, 0, 2, 268, 50);
INSERT INTO public.who_global_data VALUES (63301, 0, 327, 0, 2, 268, 33);
INSERT INTO public.who_global_data VALUES (63302, 2, 121, 0, 8, 268, 183);
INSERT INTO public.who_global_data VALUES (63303, 4, 15, 0, 0, 268, 92);
INSERT INTO public.who_global_data VALUES (63304, 133, 2964, 6, 128, 268, 158);
INSERT INTO public.who_global_data VALUES (63305, 0, 2, 0, 0, 268, 67);
INSERT INTO public.who_global_data VALUES (63306, 19, 2181, 3, 119, 268, 57);
INSERT INTO public.who_global_data VALUES (63307, 0, 24, 0, 1, 268, 38);
INSERT INTO public.who_global_data VALUES (63308, 9258, 177589, 881, 12400, 268, 141);
INSERT INTO public.who_global_data VALUES (63309, 0, 7, 0, 1, 268, 178);
INSERT INTO public.who_global_data VALUES (63310, 0, 141, 0, 1, 268, 108);
INSERT INTO public.who_global_data VALUES (63311, 46, 2069, 1, 96, 268, 39);
INSERT INTO public.who_global_data VALUES (63312, 7, 773, 0, 51, 268, 2);
INSERT INTO public.who_global_data VALUES (63313, 0, 27, 0, 1, 268, 195);
INSERT INTO public.who_global_data VALUES (63314, 19, 289, 0, 2, 268, 107);
INSERT INTO public.who_global_data VALUES (63315, 0, 122, 0, 0, 268, 161);
INSERT INTO public.who_global_data VALUES (63316, 111, 2800, 11, 136, 268, 212);
INSERT INTO public.who_global_data VALUES (63317, 1144, 71486, 160, 5209, 268, 181);
INSERT INTO public.who_global_data VALUES (63318, 1, 85, 0, 1, 268, 53);
INSERT INTO public.who_global_data VALUES (63319, 8, 187, 0, 0, 268, 164);
INSERT INTO public.who_global_data VALUES (63320, 15, 372, 2, 42, 268, 140);
INSERT INTO public.who_global_data VALUES (63321, 2660, 34381, 11, 346, 268, 20);
INSERT INTO public.who_global_data VALUES (63322, 6, 84464, 0, 4644, 268, 112);
INSERT INTO public.who_global_data VALUES (63323, 659, 12272, 14, 493, 268, 111);
INSERT INTO public.who_global_data VALUES (63324, 0, 11, 0, 1, 268, 71);
INSERT INTO public.who_global_data VALUES (63325, 8, 341, 0, 11, 268, 218);
INSERT INTO public.who_global_data VALUES (63326, 0, 0, 0, 0, 268, 43);
INSERT INTO public.who_global_data VALUES (63327, 3, 804, 0, 7, 268, 49);
INSERT INTO public.who_global_data VALUES (63328, 55, 1912, 3, 24, 268, 1);
INSERT INTO public.who_global_data VALUES (63329, 6, 2213, 3, 94, 268, 48);
INSERT INTO public.who_global_data VALUES (63330, 6, 1810, 1, 79, 268, 232);
INSERT INTO public.who_global_data VALUES (63331, 0, 16, 0, 1, 268, 175);
INSERT INTO public.who_global_data VALUES (63332, 2, 905, 1, 17, 268, 21);
INSERT INTO public.who_global_data VALUES (63333, 48, 8269, 7, 290, 268, 156);
INSERT INTO public.who_global_data VALUES (63334, 0, 0, 0, 0, 268, 95);
INSERT INTO public.who_global_data VALUES (63335, 73, 1242, 0, 50, 268, 177);
INSERT INTO public.who_global_data VALUES (63336, 76, 10667, 6, 533, 268, 210);
INSERT INTO public.who_global_data VALUES (63337, 0, 1268, 0, 3, 268, 120);
INSERT INTO public.who_global_data VALUES (63338, 0, 16, 0, 0, 268, 135);
INSERT INTO public.who_global_data VALUES (63339, 296, 11196, 7, 409, 268, 206);
INSERT INTO public.who_global_data VALUES (63340, 67, 30486, 7, 2334, 268, 189);
INSERT INTO public.who_global_data VALUES (63341, 398, 10829, 15, 571, 268, 129);
INSERT INTO public.who_global_data VALUES (63342, 39, 1037, 2, 20, 268, 121);
INSERT INTO public.who_global_data VALUES (63343, 61, 583, 1, 7, 268, 59);
INSERT INTO public.who_global_data VALUES (63344, 0, 39, 0, 0, 268, 96);
INSERT INTO public.who_global_data VALUES (63345, 5, 1751, 0, 61, 268, 41);
INSERT INTO public.who_global_data VALUES (63346, 3, 187, 0, 2, 268, 216);
INSERT INTO public.who_global_data VALUES (63347, 2, 263, 0, 5, 268, 236);
INSERT INTO public.who_global_data VALUES (63348, 0, 13, 0, 0, 268, 150);
INSERT INTO public.who_global_data VALUES (63349, 0, 187, 0, 0, 268, 61);
INSERT INTO public.who_global_data VALUES (63350, 0, 18, 0, 0, 268, 7);
INSERT INTO public.who_global_data VALUES (63351, 51, 6054, 9, 284, 268, 169);
INSERT INTO public.who_global_data VALUES (63352, 448, 138609, 81, 27029, 268, 28);
INSERT INTO public.who_global_data VALUES (63353, 7, 153, 0, 1, 268, 85);
INSERT INTO public.who_global_data VALUES (63354, 0, 60, 0, 0, 268, 211);
INSERT INTO public.who_global_data VALUES (63355, 141, 1004, 0, 9, 268, 60);
INSERT INTO public.who_global_data VALUES (63356, 0, 23, 0, 1, 268, 3);
INSERT INTO public.who_global_data VALUES (63357, 10, 652, 0, 11, 268, 11);
INSERT INTO public.who_global_data VALUES (63358, 933, 172239, 89, 7723, 268, 89);
INSERT INTO public.who_global_data VALUES (63359, 281, 5408, 2, 24, 268, 24);
INSERT INTO public.who_global_data VALUES (63360, 0, 147, 0, 0, 268, 162);
INSERT INTO public.who_global_data VALUES (63361, 16, 2760, 3, 155, 268, 100);
INSERT INTO public.who_global_data VALUES (63362, 0, 11, 0, 0, 268, 47);
INSERT INTO public.who_global_data VALUES (63363, 0, 21, 0, 0, 268, 29);
INSERT INTO public.who_global_data VALUES (63364, 0, 155, 0, 13, 268, 40);
INSERT INTO public.who_global_data VALUES (63365, 0, 148, 0, 5, 268, 222);
INSERT INTO public.who_global_data VALUES (63366, 85, 1199, 1, 27, 268, 132);
INSERT INTO public.who_global_data VALUES (63367, 0, 252, 0, 13, 268, 130);
INSERT INTO public.who_global_data VALUES (63368, 74, 2372, 3, 14, 268, 234);
INSERT INTO public.who_global_data VALUES (63369, 16, 836, 0, 3, 268, 23);
INSERT INTO public.who_global_data VALUES (63370, 4, 113, 0, 10, 268, 192);
INSERT INTO public.who_global_data VALUES (63371, 10, 219, 2, 18, 268, 69);
INSERT INTO public.who_global_data VALUES (63372, 0, 12, 0, 0, 268, 187);
INSERT INTO public.who_global_data VALUES (63373, -20, 2080, 5, 121, 268, 230);
INSERT INTO public.who_global_data VALUES (63374, 39, 3380, 6, 436, 268, 77);
INSERT INTO public.who_global_data VALUES (63375, 1, 1802, 0, 10, 268, 9);
INSERT INTO public.who_global_data VALUES (63376, 3722, 78003, 134, 2549, 268, 74);
INSERT INTO public.who_global_data VALUES (63377, 568, 16006, 15, 1043, 268, 224);
INSERT INTO public.who_global_data VALUES (63378, 1808, 114533, 71, 6854, 268, 199);
INSERT INTO public.who_global_data VALUES (63379, 111, 3143, 0, 115, 268, 190);
INSERT INTO public.who_global_data VALUES (63380, 159, 23401, 9, 1497, 268, 12);
INSERT INTO public.who_global_data VALUES (63381, 1, 331, 0, 23, 268, 104);
INSERT INTO public.who_global_data VALUES (63382, 23, 16456, 3, 263, 268, 153);
INSERT INTO public.who_global_data VALUES (63383, 888, 222104, 195, 31106, 268, 91);
INSERT INTO public.who_global_data VALUES (63384, 2, 507, 0, 9, 268, 215);
INSERT INTO public.who_global_data VALUES (63385, 55, 16079, 19, 687, 268, 84);
INSERT INTO public.who_global_data VALUES (63386, 1, 297, 1, 27, 268, 231);
INSERT INTO public.who_global_data VALUES (63387, 4, 586, 0, 9, 268, 196);
INSERT INTO public.who_global_data VALUES (63388, 118, 5689, 1, 34, 268, 105);
INSERT INTO public.who_global_data VALUES (63389, 22, 737, 4, 40, 268, 122);
INSERT INTO public.who_global_data VALUES (63390, 0, 0, 0, 0, 268, 159);
INSERT INTO public.who_global_data VALUES (63391, 0, 919, 0, 20, 268, 75);
INSERT INTO public.who_global_data VALUES (63392, 947, 11975, 6, 88, 268, 27);
INSERT INTO public.who_global_data VALUES (63393, 38, 1082, 0, 12, 268, 54);
INSERT INTO public.who_global_data VALUES (63394, 0, 19, 0, 0, 268, 226);
INSERT INTO public.who_global_data VALUES (63395, 1, 951, 1, 19, 268, 79);
INSERT INTO public.who_global_data VALUES (63396, 8, 886, 0, 26, 268, 56);
INSERT INTO public.who_global_data VALUES (63397, 1, 1, 0, 0, 268, 117);
INSERT INTO public.who_global_data VALUES (63398, 1, 213, 0, 20, 268, 152);
INSERT INTO public.who_global_data VALUES (63399, 0, 64, 0, 3, 268, 16);
INSERT INTO public.who_global_data VALUES (63400, 0, 83, 0, 1, 268, 10);
INSERT INTO public.who_global_data VALUES (63401, 9, 1511, 0, 54, 268, 201);
INSERT INTO public.who_global_data VALUES (63402, 10, 3904, 1, 103, 268, 174);
INSERT INTO public.who_global_data VALUES (63403, 20, 212, 0, 0, 268, 119);
INSERT INTO public.who_global_data VALUES (63404, 5, 63, 0, 3, 268, 168);
INSERT INTO public.who_global_data VALUES (63405, 37, 6779, 2, 111, 268, 99);
INSERT INTO public.who_global_data VALUES (63406, 64, 968, 1, 4, 268, 171);
INSERT INTO public.who_global_data VALUES (63407, 28, 758, 4, 44, 268, 87);
INSERT INTO public.who_global_data VALUES (63408, 14, 521, 0, 6, 268, 123);
INSERT INTO public.who_global_data VALUES (63409, 0, 0, 0, 0, 268, 151);
INSERT INTO public.who_global_data VALUES (63410, 2, 189, 0, 14, 268, 213);
INSERT INTO public.who_global_data VALUES (63411, 1, 9, 0, 1, 268, 118);
INSERT INTO public.who_global_data VALUES (63412, 0, 332, 0, 10, 268, 134);
INSERT INTO public.who_global_data VALUES (63413, 48, 1143, 2, 14, 268, 65);
INSERT INTO public.who_global_data VALUES (63414, 1997, 38324, 353, 3926, 268, 102);
INSERT INTO public.who_global_data VALUES (63415, 0, 0, 0, 0, 268, 223);
INSERT INTO public.who_global_data VALUES (63416, 0, 67, 0, 1, 268, 4);
INSERT INTO public.who_global_data VALUES (63417, 0, 42, 0, 0, 268, 146);
INSERT INTO public.who_global_data VALUES (63418, 0, 324, 0, 9, 268, 31);
INSERT INTO public.who_global_data VALUES (63419, 0, 11, 0, 1, 268, 127);
INSERT INTO public.who_global_data VALUES (63420, 127, 6593, 1, 189, 268, 22);
INSERT INTO public.who_global_data VALUES (63421, 3, 107, 0, 0, 268, 115);
INSERT INTO public.who_global_data VALUES (63422, 1, 181, 0, 6, 268, 106);
INSERT INTO public.who_global_data VALUES (63423, 0, 16, 0, 0, 268, 90);
INSERT INTO public.who_global_data VALUES (63424, 0, 0, 0, 0, 268, 70);
INSERT INTO public.who_global_data VALUES (63425, 6, 249, 0, 0, 268, 46);
INSERT INTO public.who_global_data VALUES (63426, 223, 42967, 52, 5528, 268, 139);
INSERT INTO public.who_global_data VALUES (63427, 0, 18, 0, 0, 268, 42);
INSERT INTO public.who_global_data VALUES (63428, 0, 1147, 0, 21, 268, 80);
INSERT INTO public.who_global_data VALUES (63429, 9, 25, 3, 8, 268, 203);
INSERT INTO public.who_global_data VALUES (63430, 6, 860, 2, 49, 268, 136);
INSERT INTO public.who_global_data VALUES (63431, 184, 4971, 6, 164, 268, 63);
INSERT INTO public.who_global_data VALUES (63432, 0, 0, 0, 0, 268, 17);
INSERT INTO public.who_global_data VALUES (63433, 0, 19, 0, 2, 268, 172);
INSERT INTO public.who_global_data VALUES (63434, 20, 1694, 3, 95, 268, 109);
INSERT INTO public.who_global_data VALUES (63435, 23, 8158, 1, 229, 268, 200);
INSERT INTO public.who_global_data VALUES (63436, 0, 548, 0, 4, 268, 93);
INSERT INTO public.who_global_data VALUES (63437, 322, 4341, 0, 17, 268, 5);
INSERT INTO public.who_global_data VALUES (63438, 0, 712, 0, 13, 268, 214);
INSERT INTO public.who_global_data VALUES (63439, 1452, 35788, 33, 770, 268, 204);
INSERT INTO public.who_global_data VALUES (63440, 0, 0, 0, 0, 268, 198);
INSERT INTO public.who_global_data VALUES (63441, 0, 8616, 0, 249, 268, 173);
INSERT INTO public.who_global_data VALUES (63442, 0, 8, 0, 0, 268, 229);
INSERT INTO public.who_global_data VALUES (63443, 3, 740, 1, 11, 268, 76);
INSERT INTO public.who_global_data VALUES (63444, 3237, 72059, 96, 2057, 268, 138);
INSERT INTO public.who_global_data VALUES (63445, 268, 11618, 21, 772, 268, 98);
INSERT INTO public.who_global_data VALUES (63446, 0, 0, 0, 0, 268, 103);
INSERT INTO public.who_global_data VALUES (63447, 283, 17204, 22, 861, 268, 225);
INSERT INTO public.who_global_data VALUES (63448, 219, 28132, 12, 1175, 268, 131);
INSERT INTO public.who_global_data VALUES (63449, 30, 2329, 1, 115, 268, 235);
INSERT INTO public.who_global_data VALUES (63450, 1733, 28272, 0, 14, 268, 137);
INSERT INTO public.who_global_data VALUES (63451, 29, 10991, 1, 260, 268, 81);
INSERT INTO public.who_global_data VALUES (63452, 252, 5406, 8, 190, 268, 182);
INSERT INTO public.who_global_data VALUES (63453, 2, 439, 0, 0, 268, 145);
INSERT INTO public.who_global_data VALUES (63454, 224, 16002, 14, 1016, 268, 26);
INSERT INTO public.who_global_data VALUES (63455, 9974, 252245, 93, 2305, 268, 170);
INSERT INTO public.who_global_data VALUES (63456, 1, 287, 0, 0, 268, 191);
INSERT INTO public.who_global_data VALUES (63457, 0, 2, 0, 0, 268, 221);
INSERT INTO public.who_global_data VALUES (63458, 0, 6, 0, 0, 268, 64);
INSERT INTO public.who_global_data VALUES (63459, 0, 0, 0, 0, 268, 116);
INSERT INTO public.who_global_data VALUES (63460, 0, 15, 0, 0, 268, 128);
INSERT INTO public.who_global_data VALUES (63461, 0, 18, 0, 0, 268, 6);
INSERT INTO public.who_global_data VALUES (63462, 0, 39, 0, 3, 268, 227);
INSERT INTO public.who_global_data VALUES (63463, 0, 1, 0, 0, 268, 68);
INSERT INTO public.who_global_data VALUES (63464, 0, 17, 0, 0, 268, 184);
INSERT INTO public.who_global_data VALUES (63465, 0, 0, 0, 0, 268, 82);
INSERT INTO public.who_global_data VALUES (63466, 0, 647, 0, 41, 268, 149);
INSERT INTO public.who_global_data VALUES (63467, 0, 165, 3, 7, 268, 197);
INSERT INTO public.who_global_data VALUES (63468, 2039, 46869, 10, 283, 268, 78);
INSERT INTO public.who_global_data VALUES (63469, 110, 2105, 3, 22, 268, 233);
INSERT INTO public.who_global_data VALUES (63470, 52, 10295, 2, 222, 268, 133);
INSERT INTO public.who_global_data VALUES (63471, 0, 11, 0, 0, 268, 35);
INSERT INTO public.who_global_data VALUES (63472, 49, 387, 1, 21, 268, 114);
INSERT INTO public.who_global_data VALUES (63473, 675, 25346, 0, 21, 268, 237);
INSERT INTO public.who_global_data VALUES (63474, 0, 2, 0, 0, 268, 55);
INSERT INTO public.who_global_data VALUES (63475, 1, 78, 0, 15, 268, 176);
INSERT INTO public.who_global_data VALUES (63476, 4, 1469, 0, 27, 268, 202);
INSERT INTO public.who_global_data VALUES (63477, 1, 1464, 0, 111, 268, 155);
INSERT INTO public.who_global_data VALUES (63478, 0, 0, 0, 0, 268, 32);
INSERT INTO public.who_global_data VALUES (63479, 65, 1284, 1, 53, 268, 220);
INSERT INTO public.who_global_data VALUES (63480, 724, 12074, 13, 219, 268, 30);
INSERT INTO public.who_global_data VALUES (63481, 20, 194, 0, 0, 268, 147);
INSERT INTO public.who_global_data VALUES (63482, 712, 234768, 113, 28002, 268, 208);
INSERT INTO public.who_global_data VALUES (63483, 23, 916, 0, 9, 268, 45);
INSERT INTO public.who_global_data VALUES (63484, 158, 1818, 10, 90, 268, 110);
INSERT INTO public.who_global_data VALUES (63485, 0, 10, 0, 1, 268, 88);
INSERT INTO public.who_global_data VALUES (63486, 754, 28058, 61, 3775, 268, 51);
INSERT INTO public.who_global_data VALUES (63487, 37, 30457, 1, 1684, 268, 209);
INSERT INTO public.who_global_data VALUES (63488, 0, 48, 0, 3, 268, 205);
INSERT INTO public.who_global_data VALUES (63489, 178, 907, 9, 32, 268, 18);
INSERT INTO public.who_global_data VALUES (63490, 1, 3018, 0, 56, 268, 72);
INSERT INTO public.who_global_data VALUES (63491, 3402, 217712, 447, 32640, 268, 44);
INSERT INTO public.who_global_data VALUES (63492, 0, 24, 0, 0, 268, 15);
INSERT INTO public.who_global_data VALUES (63493, 20, 219, 0, 11, 268, 25);
INSERT INTO public.who_global_data VALUES (63494, 0, 0, 0, 0, 268, 179);
INSERT INTO public.who_global_data VALUES (63495, 0, 0, 0, 0, 268, 34);
INSERT INTO public.who_global_data VALUES (63496, 0, 116, 0, 8, 268, 207);
INSERT INTO public.who_global_data VALUES (63497, 0, 1032, 0, 45, 268, 166);
INSERT INTO public.who_global_data VALUES (63498, 1639, 143114, 58, 3952, 268, 126);
INSERT INTO public.who_global_data VALUES (63499, 0, 0, 0, 0, 268, 97);
INSERT INTO public.who_global_data VALUES (63500, 0, 12, 0, 1, 268, 36);
INSERT INTO public.who_global_data VALUES (63501, 0, 0, 0, 0, 268, 125);
INSERT INTO public.who_global_data VALUES (63502, 13, 139, 0, 0, 268, 124);
INSERT INTO public.who_global_data VALUES (63503, 422, 16847, 17, 456, 268, 185);
INSERT INTO public.who_global_data VALUES (63504, 1423, 21084, 5, 208, 268, 194);
INSERT INTO public.who_global_data VALUES (63505, 0, 509, 0, 21, 268, 144);
INSERT INTO public.who_global_data VALUES (63506, 21424, 1361522, 1424, 82119, 268, 19);
INSERT INTO public.who_global_data VALUES (63507, 0, 69, 1, 6, 268, 217);
INSERT INTO public.who_global_data VALUES (63508, 6, 717, 0, 19, 268, 148);
INSERT INTO public.who_global_data VALUES (63509, 22, 2620, 1, 11, 268, 86);
INSERT INTO public.who_global_data VALUES (63510, 0, 0, 0, 0, 268, 13);
INSERT INTO public.who_global_data VALUES (63511, 18, 440, 0, 10, 268, 157);
INSERT INTO public.who_global_data VALUES (63512, 0, 288, 0, 0, 268, 8);
INSERT INTO public.who_global_data VALUES (63513, 0, 0, 0, 0, 268, 73);
INSERT INTO public.who_global_data VALUES (63514, 15, 87, 0, 13, 268, 101);
INSERT INTO public.who_global_data VALUES (63515, 5, 446, 0, 7, 268, 165);
INSERT INTO public.who_global_data VALUES (63516, 0, 37, 0, 4, 268, 14);
INSERT INTO public.who_global_data VALUES (63517, 259, 5226, 3, 130, 269, 193);
INSERT INTO public.who_global_data VALUES (63518, 4, 838, 0, 30, 269, 113);
INSERT INTO public.who_global_data VALUES (63519, 176, 6067, 8, 515, 269, 143);
INSERT INTO public.who_global_data VALUES (63520, 0, 0, 0, 0, 269, 219);
INSERT INTO public.who_global_data VALUES (63521, 3, 759, 0, 48, 269, 186);
INSERT INTO public.who_global_data VALUES (63522, 0, 45, 0, 2, 269, 52);
INSERT INTO public.who_global_data VALUES (63523, 0, 3, 0, 0, 269, 180);
INSERT INTO public.who_global_data VALUES (63524, 0, 25, 0, 3, 269, 167);
INSERT INTO public.who_global_data VALUES (63525, 244, 6278, 12, 317, 269, 154);
INSERT INTO public.who_global_data VALUES (63526, 146, 3514, 1, 47, 269, 94);
INSERT INTO public.who_global_data VALUES (63527, 0, 101, 0, 3, 269, 66);
INSERT INTO public.who_global_data VALUES (63528, 16, 6964, 0, 97, 269, 58);
INSERT INTO public.who_global_data VALUES (63529, 36, 15910, 3, 623, 269, 163);
INSERT INTO public.who_global_data VALUES (63530, 104, 2693, 1, 33, 269, 37);
INSERT INTO public.who_global_data VALUES (63531, 1, 93, 0, 11, 269, 142);
INSERT INTO public.who_global_data VALUES (63532, 371, 5780, 0, 9, 269, 83);
INSERT INTO public.who_global_data VALUES (63533, 1162, 17822, 19, 269, 269, 228);
INSERT INTO public.who_global_data VALUES (63534, 0, 84, 0, 7, 269, 188);
INSERT INTO public.who_global_data VALUES (63535, 1934, 25840, 14, 149, 269, 62);
INSERT INTO public.who_global_data VALUES (63536, 395, 55210, 45, 8770, 269, 160);
INSERT INTO public.who_global_data VALUES (63537, 0, 18, 0, 2, 269, 50);
INSERT INTO public.who_global_data VALUES (63538, 8, 327, 0, 2, 269, 33);
INSERT INTO public.who_global_data VALUES (63539, 1, 119, 1, 8, 269, 183);
INSERT INTO public.who_global_data VALUES (63540, 0, 11, 0, 0, 269, 92);
INSERT INTO public.who_global_data VALUES (63541, 275, 2831, 4, 122, 269, 158);
INSERT INTO public.who_global_data VALUES (63542, 0, 2, 0, 0, 269, 67);
INSERT INTO public.who_global_data VALUES (63543, 20, 2162, 4, 116, 269, 57);
INSERT INTO public.who_global_data VALUES (63544, 0, 24, 0, 1, 269, 38);
INSERT INTO public.who_global_data VALUES (63545, 5632, 168331, 396, 11519, 269, 141);
INSERT INTO public.who_global_data VALUES (63546, 0, 7, 0, 1, 269, 178);
INSERT INTO public.who_global_data VALUES (63547, 0, 141, 0, 1, 269, 108);
INSERT INTO public.who_global_data VALUES (63548, 33, 2023, 2, 95, 269, 39);
INSERT INTO public.who_global_data VALUES (63549, 6, 766, 1, 51, 269, 2);
INSERT INTO public.who_global_data VALUES (63550, 8, 27, 0, 1, 269, 195);
INSERT INTO public.who_global_data VALUES (63551, 10, 270, 0, 2, 269, 107);
INSERT INTO public.who_global_data VALUES (63552, 0, 122, 0, 0, 269, 161);
INSERT INTO public.who_global_data VALUES (63553, 110, 2689, 11, 125, 269, 212);
INSERT INTO public.who_global_data VALUES (63554, 1186, 70342, 143, 5049, 269, 181);
INSERT INTO public.who_global_data VALUES (63555, 3, 84, 0, 1, 269, 53);
INSERT INTO public.who_global_data VALUES (63556, 0, 179, 0, 0, 269, 164);
INSERT INTO public.who_global_data VALUES (63557, 35, 357, 9, 40, 269, 140);
INSERT INTO public.who_global_data VALUES (63558, 1658, 31721, 12, 335, 269, 20);
INSERT INTO public.who_global_data VALUES (63559, 7, 84458, 0, 4644, 269, 112);
INSERT INTO public.who_global_data VALUES (63560, 550, 11613, 16, 479, 269, 111);
INSERT INTO public.who_global_data VALUES (63561, 0, 11, 0, 1, 269, 71);
INSERT INTO public.who_global_data VALUES (63562, 0, 333, 0, 11, 269, 218);
INSERT INTO public.who_global_data VALUES (63563, 0, 0, 0, 0, 269, 43);
INSERT INTO public.who_global_data VALUES (63564, 9, 801, 1, 7, 269, 49);
INSERT INTO public.who_global_data VALUES (63565, 127, 1857, 0, 21, 269, 1);
INSERT INTO public.who_global_data VALUES (63566, 11, 2207, 0, 91, 269, 48);
INSERT INTO public.who_global_data VALUES (63567, 21, 1804, 1, 78, 269, 232);
INSERT INTO public.who_global_data VALUES (63568, 0, 16, 0, 1, 269, 175);
INSERT INTO public.who_global_data VALUES (63569, 2, 903, 0, 16, 269, 21);
INSERT INTO public.who_global_data VALUES (63570, 45, 8221, 1, 283, 269, 156);
INSERT INTO public.who_global_data VALUES (63571, 0, 0, 0, 0, 269, 95);
INSERT INTO public.who_global_data VALUES (63572, 67, 1169, 6, 50, 269, 177);
INSERT INTO public.who_global_data VALUES (63573, 78, 10591, -6, 527, 269, 210);
INSERT INTO public.who_global_data VALUES (63574, 12, 1268, 0, 3, 269, 120);
INSERT INTO public.who_global_data VALUES (63575, 0, 16, 0, 0, 269, 135);
INSERT INTO public.who_global_data VALUES (63576, 266, 10900, 9, 402, 269, 206);
INSERT INTO public.who_global_data VALUES (63577, 910, 30419, 182, 2327, 269, 189);
INSERT INTO public.who_global_data VALUES (63578, 685, 10431, 23, 556, 269, 129);
INSERT INTO public.who_global_data VALUES (63579, 40, 998, 1, 18, 269, 121);
INSERT INTO public.who_global_data VALUES (63580, 83, 522, 2, 6, 269, 59);
INSERT INTO public.who_global_data VALUES (63581, 0, 39, 0, 0, 269, 96);
INSERT INTO public.who_global_data VALUES (63582, 5, 1746, 0, 61, 269, 41);
INSERT INTO public.who_global_data VALUES (63583, 9, 184, 0, 2, 269, 216);
INSERT INTO public.who_global_data VALUES (63584, 11, 261, 0, 5, 269, 236);
INSERT INTO public.who_global_data VALUES (63585, 0, 13, 0, 0, 269, 150);
INSERT INTO public.who_global_data VALUES (63586, 0, 187, 0, 0, 269, 61);
INSERT INTO public.who_global_data VALUES (63587, 0, 18, 0, 0, 269, 7);
INSERT INTO public.who_global_data VALUES (63588, 19, 6003, 4, 275, 269, 169);
INSERT INTO public.who_global_data VALUES (63589, 670, 138161, 348, 26948, 269, 28);
INSERT INTO public.who_global_data VALUES (63590, 2, 146, 0, 1, 269, 85);
INSERT INTO public.who_global_data VALUES (63591, 0, 60, 0, 0, 269, 211);
INSERT INTO public.who_global_data VALUES (63592, 61, 863, 0, 9, 269, 60);
INSERT INTO public.who_global_data VALUES (63593, 1, 23, 0, 1, 269, 3);
INSERT INTO public.who_global_data VALUES (63594, 3, 642, 0, 11, 269, 11);
INSERT INTO public.who_global_data VALUES (63595, 798, 171306, 101, 7634, 269, 89);
INSERT INTO public.who_global_data VALUES (63596, 427, 5127, 0, 22, 269, 24);
INSERT INTO public.who_global_data VALUES (63597, 1, 147, 0, 0, 269, 162);
INSERT INTO public.who_global_data VALUES (63598, 18, 2744, 1, 152, 269, 100);
INSERT INTO public.who_global_data VALUES (63599, 0, 11, 0, 0, 269, 47);
INSERT INTO public.who_global_data VALUES (63600, 0, 21, 0, 0, 269, 29);
INSERT INTO public.who_global_data VALUES (63601, 1, 155, 0, 13, 269, 40);
INSERT INTO public.who_global_data VALUES (63602, 1, 148, 0, 5, 269, 222);
INSERT INTO public.who_global_data VALUES (63603, 62, 1114, 0, 26, 269, 132);
INSERT INTO public.who_global_data VALUES (63604, 0, 252, 0, 13, 269, 130);
INSERT INTO public.who_global_data VALUES (63605, 152, 2298, 0, 11, 269, 234);
INSERT INTO public.who_global_data VALUES (63606, 59, 820, 0, 3, 269, 23);
INSERT INTO public.who_global_data VALUES (63607, 5, 109, 0, 10, 269, 192);
INSERT INTO public.who_global_data VALUES (63608, 27, 209, 1, 16, 269, 69);
INSERT INTO public.who_global_data VALUES (63609, 0, 12, 0, 0, 269, 187);
INSERT INTO public.who_global_data VALUES (63610, 128, 2100, 8, 116, 269, 230);
INSERT INTO public.who_global_data VALUES (63611, 28, 3341, 5, 430, 269, 77);
INSERT INTO public.who_global_data VALUES (63612, 0, 1801, 0, 10, 269, 9);
INSERT INTO public.who_global_data VALUES (63613, 3525, 74281, 122, 2415, 269, 74);
INSERT INTO public.who_global_data VALUES (63614, 689, 15438, 21, 1028, 269, 224);
INSERT INTO public.who_global_data VALUES (63615, 1958, 112725, 50, 6783, 269, 199);
INSERT INTO public.who_global_data VALUES (63616, 119, 3032, 3, 115, 269, 190);
INSERT INTO public.who_global_data VALUES (63617, 107, 23242, 21, 1488, 269, 12);
INSERT INTO public.who_global_data VALUES (63618, 0, 330, 0, 23, 269, 104);
INSERT INTO public.who_global_data VALUES (63619, 39, 16433, 5, 260, 269, 153);
INSERT INTO public.who_global_data VALUES (63620, 1402, 221216, 172, 30911, 269, 91);
INSERT INTO public.who_global_data VALUES (63621, 3, 505, 0, 9, 269, 215);
INSERT INTO public.who_global_data VALUES (63622, 150, 16024, 25, 668, 269, 84);
INSERT INTO public.who_global_data VALUES (63623, 0, 296, 0, 26, 269, 231);
INSERT INTO public.who_global_data VALUES (63624, 6, 582, 0, 9, 269, 196);
INSERT INTO public.who_global_data VALUES (63625, 154, 5571, 1, 33, 269, 105);
INSERT INTO public.who_global_data VALUES (63626, 15, 715, 3, 36, 269, 122);
INSERT INTO public.who_global_data VALUES (63627, 0, 0, 0, 0, 269, 159);
INSERT INTO public.who_global_data VALUES (63628, 35, 919, 0, 20, 269, 75);
INSERT INTO public.who_global_data VALUES (63629, 751, 11028, 7, 82, 269, 27);
INSERT INTO public.who_global_data VALUES (63630, 7, 1044, 0, 12, 269, 54);
INSERT INTO public.who_global_data VALUES (63631, 0, 19, 0, 0, 269, 226);
INSERT INTO public.who_global_data VALUES (63632, 4, 950, 0, 18, 269, 79);
INSERT INTO public.who_global_data VALUES (63633, 8, 878, 0, 26, 269, 56);
INSERT INTO public.who_global_data VALUES (63634, 0, 0, 0, 0, 269, 117);
INSERT INTO public.who_global_data VALUES (63635, 1, 212, 0, 20, 269, 152);
INSERT INTO public.who_global_data VALUES (63636, 0, 64, 0, 3, 269, 16);
INSERT INTO public.who_global_data VALUES (63637, 0, 83, 0, 1, 269, 10);
INSERT INTO public.who_global_data VALUES (63638, 14, 1502, 0, 54, 269, 201);
INSERT INTO public.who_global_data VALUES (63639, 6, 3894, 1, 102, 269, 174);
INSERT INTO public.who_global_data VALUES (63640, 6, 192, 0, 0, 269, 119);
INSERT INTO public.who_global_data VALUES (63641, 1, 58, 0, 3, 269, 168);
INSERT INTO public.who_global_data VALUES (63642, 16, 6742, 0, 109, 269, 99);
INSERT INTO public.who_global_data VALUES (63643, 7, 904, 0, 3, 269, 171);
INSERT INTO public.who_global_data VALUES (63644, 18, 730, 1, 40, 269, 87);
INSERT INTO public.who_global_data VALUES (63645, 2, 507, 1, 6, 269, 123);
INSERT INTO public.who_global_data VALUES (63646, 0, 0, 0, 0, 269, 151);
INSERT INTO public.who_global_data VALUES (63647, 0, 187, 0, 14, 269, 213);
INSERT INTO public.who_global_data VALUES (63648, 0, 8, 0, 1, 269, 118);
INSERT INTO public.who_global_data VALUES (63649, 0, 332, 0, 10, 269, 134);
INSERT INTO public.who_global_data VALUES (63650, 34, 1095, 0, 12, 269, 65);
INSERT INTO public.who_global_data VALUES (63651, 1305, 36327, 108, 3573, 269, 102);
INSERT INTO public.who_global_data VALUES (63652, 0, 0, 0, 0, 269, 223);
INSERT INTO public.who_global_data VALUES (63653, 0, 67, 0, 1, 269, 4);
INSERT INTO public.who_global_data VALUES (63654, 0, 42, 0, 0, 269, 146);
INSERT INTO public.who_global_data VALUES (63655, 0, 324, 0, 9, 269, 31);
INSERT INTO public.who_global_data VALUES (63656, 0, 11, 0, 1, 269, 127);
INSERT INTO public.who_global_data VALUES (63657, 86, 6466, 0, 188, 269, 22);
INSERT INTO public.who_global_data VALUES (63658, 1, 104, 0, 0, 269, 115);
INSERT INTO public.who_global_data VALUES (63659, 0, 180, 0, 6, 269, 106);
INSERT INTO public.who_global_data VALUES (63660, 0, 16, 0, 0, 269, 90);
INSERT INTO public.who_global_data VALUES (63661, 0, 0, 0, 0, 269, 70);
INSERT INTO public.who_global_data VALUES (63662, 52, 243, 0, 0, 269, 46);
INSERT INTO public.who_global_data VALUES (63663, 195, 42744, 56, 5476, 269, 139);
INSERT INTO public.who_global_data VALUES (63664, 0, 18, 0, 0, 269, 42);
INSERT INTO public.who_global_data VALUES (63665, 0, 1147, 0, 21, 269, 80);
INSERT INTO public.who_global_data VALUES (63666, 0, 16, 0, 5, 269, 203);
INSERT INTO public.who_global_data VALUES (63667, 22, 854, 1, 47, 269, 136);
INSERT INTO public.who_global_data VALUES (63668, 146, 4787, 8, 158, 269, 63);
INSERT INTO public.who_global_data VALUES (63669, 0, 0, 0, 0, 269, 17);
INSERT INTO public.who_global_data VALUES (63670, 0, 19, 0, 2, 269, 172);
INSERT INTO public.who_global_data VALUES (63671, 10, 1674, 1, 92, 269, 109);
INSERT INTO public.who_global_data VALUES (63672, 29, 8135, 4, 228, 269, 200);
INSERT INTO public.who_global_data VALUES (63673, 1, 548, 0, 4, 269, 93);
INSERT INTO public.who_global_data VALUES (63674, 298, 4019, 0, 17, 269, 5);
INSERT INTO public.who_global_data VALUES (63675, 0, 712, 0, 13, 269, 214);
INSERT INTO public.who_global_data VALUES (63676, 1662, 34336, 13, 737, 269, 204);
INSERT INTO public.who_global_data VALUES (63677, 0, 0, 0, 0, 269, 198);
INSERT INTO public.who_global_data VALUES (63678, 168, 8616, 5, 249, 269, 173);
INSERT INTO public.who_global_data VALUES (63679, 0, 8, 0, 0, 269, 229);
INSERT INTO public.who_global_data VALUES (63680, 13, 737, 0, 10, 269, 76);
INSERT INTO public.who_global_data VALUES (63681, 1515, 68822, 72, 1961, 269, 138);
INSERT INTO public.who_global_data VALUES (63682, 264, 11350, 25, 751, 269, 98);
INSERT INTO public.who_global_data VALUES (63683, 0, 0, 0, 0, 269, 103);
INSERT INTO public.who_global_data VALUES (63684, 595, 16921, 28, 839, 269, 225);
INSERT INTO public.who_global_data VALUES (63685, 234, 27913, 19, 1163, 269, 131);
INSERT INTO public.who_global_data VALUES (63686, 43, 2299, 1, 114, 269, 235);
INSERT INTO public.who_global_data VALUES (63687, 1390, 26539, 0, 14, 269, 137);
INSERT INTO public.who_global_data VALUES (63688, 26, 10962, 1, 259, 269, 81);
INSERT INTO public.who_global_data VALUES (63689, 159, 5154, 3, 182, 269, 182);
INSERT INTO public.who_global_data VALUES (63690, 1, 437, 0, 0, 269, 145);
INSERT INTO public.who_global_data VALUES (63691, 190, 15778, 30, 1002, 269, 26);
INSERT INTO public.who_global_data VALUES (63692, 10028, 242271, 96, 2212, 269, 170);
INSERT INTO public.who_global_data VALUES (63693, 1, 286, 0, 0, 269, 191);
INSERT INTO public.who_global_data VALUES (63694, 0, 2, 0, 0, 269, 221);
INSERT INTO public.who_global_data VALUES (63695, 0, 6, 0, 0, 269, 64);
INSERT INTO public.who_global_data VALUES (63696, 0, 0, 0, 0, 269, 116);
INSERT INTO public.who_global_data VALUES (63697, 0, 15, 0, 0, 269, 128);
INSERT INTO public.who_global_data VALUES (63698, 0, 18, 0, 0, 269, 6);
INSERT INTO public.who_global_data VALUES (63699, 0, 39, 0, 3, 269, 227);
INSERT INTO public.who_global_data VALUES (63700, 0, 1, 0, 0, 269, 68);
INSERT INTO public.who_global_data VALUES (63701, 0, 17, 0, 0, 269, 184);
INSERT INTO public.who_global_data VALUES (63702, 0, 0, 0, 0, 269, 82);
INSERT INTO public.who_global_data VALUES (63703, 0, 647, 0, 41, 269, 149);
INSERT INTO public.who_global_data VALUES (63704, 0, 165, 0, 4, 269, 197);
INSERT INTO public.who_global_data VALUES (63705, 1905, 44830, 9, 273, 269, 78);
INSERT INTO public.who_global_data VALUES (63706, 109, 1995, 0, 19, 269, 233);
INSERT INTO public.who_global_data VALUES (63707, 67, 10243, 2, 220, 269, 133);
INSERT INTO public.who_global_data VALUES (63708, 0, 11, 0, 0, 269, 35);
INSERT INTO public.who_global_data VALUES (63709, 0, 338, 1, 20, 269, 114);
INSERT INTO public.who_global_data VALUES (63710, 849, 24671, 0, 21, 269, 237);
INSERT INTO public.who_global_data VALUES (63711, 0, 2, 0, 0, 269, 55);
INSERT INTO public.who_global_data VALUES (63712, 0, 77, 0, 15, 269, 176);
INSERT INTO public.who_global_data VALUES (63713, 8, 1465, 1, 27, 269, 202);
INSERT INTO public.who_global_data VALUES (63714, 2, 1463, 1, 111, 269, 155);
INSERT INTO public.who_global_data VALUES (63715, 0, 0, 0, 0, 269, 32);
INSERT INTO public.who_global_data VALUES (63716, 49, 1219, 0, 52, 269, 220);
INSERT INTO public.who_global_data VALUES (63717, 698, 11350, 0, 206, 269, 30);
INSERT INTO public.who_global_data VALUES (63718, 0, 174, 0, 0, 269, 147);
INSERT INTO public.who_global_data VALUES (63719, 592, 234056, 122, 27889, 269, 208);
INSERT INTO public.who_global_data VALUES (63720, 24, 893, 0, 9, 269, 45);
INSERT INTO public.who_global_data VALUES (63721, 134, 1660, 6, 80, 269, 110);
INSERT INTO public.who_global_data VALUES (63722, 0, 10, 0, 1, 269, 88);
INSERT INTO public.who_global_data VALUES (63723, 455, 27304, 65, 3714, 269, 51);
INSERT INTO public.who_global_data VALUES (63724, 42, 30420, 1, 1683, 269, 209);
INSERT INTO public.who_global_data VALUES (63725, 1, 48, 0, 3, 269, 205);
INSERT INTO public.who_global_data VALUES (63726, 68, 729, 2, 23, 269, 18);
INSERT INTO public.who_global_data VALUES (63727, 0, 3017, 0, 56, 269, 72);
INSERT INTO public.who_global_data VALUES (63728, 3586, 214310, 614, 32193, 269, 44);
INSERT INTO public.who_global_data VALUES (63729, 0, 24, 0, 0, 269, 15);
INSERT INTO public.who_global_data VALUES (63730, 18, 199, 0, 11, 269, 25);
INSERT INTO public.who_global_data VALUES (63731, 0, 0, 0, 0, 269, 179);
INSERT INTO public.who_global_data VALUES (63732, 0, 0, 0, 0, 269, 34);
INSERT INTO public.who_global_data VALUES (63733, 0, 116, 0, 8, 269, 207);
INSERT INTO public.who_global_data VALUES (63734, 0, 1032, 0, 45, 269, 166);
INSERT INTO public.who_global_data VALUES (63735, 1704, 141475, 53, 3894, 269, 126);
INSERT INTO public.who_global_data VALUES (63736, 0, 0, 0, 0, 269, 97);
INSERT INTO public.who_global_data VALUES (63737, 0, 12, 0, 1, 269, 36);
INSERT INTO public.who_global_data VALUES (63738, 0, 0, 0, 0, 269, 125);
INSERT INTO public.who_global_data VALUES (63739, 4, 126, 0, 0, 269, 124);
INSERT INTO public.who_global_data VALUES (63740, 402, 16425, 14, 439, 269, 185);
INSERT INTO public.who_global_data VALUES (63741, 0, 19661, 0, 203, 269, 194);
INSERT INTO public.who_global_data VALUES (63742, 0, 509, 0, 21, 269, 144);
INSERT INTO public.who_global_data VALUES (63743, 18044, 1340098, 1061, 80695, 269, 19);
INSERT INTO public.who_global_data VALUES (63744, 0, 69, 0, 5, 269, 217);
INSERT INTO public.who_global_data VALUES (63745, 4, 711, 0, 19, 269, 148);
INSERT INTO public.who_global_data VALUES (63746, 89, 2598, 0, 10, 269, 86);
INSERT INTO public.who_global_data VALUES (63747, 0, 0, 0, 0, 269, 13);
INSERT INTO public.who_global_data VALUES (63748, 8, 422, 0, 10, 269, 157);
INSERT INTO public.who_global_data VALUES (63749, 0, 288, 0, 0, 269, 8);
INSERT INTO public.who_global_data VALUES (63750, 0, 0, 0, 0, 269, 73);
INSERT INTO public.who_global_data VALUES (63751, 5, 72, 2, 13, 269, 101);
INSERT INTO public.who_global_data VALUES (63752, 174, 441, 0, 7, 269, 165);
INSERT INTO public.who_global_data VALUES (63753, 1, 37, 0, 4, 269, 14);
INSERT INTO public.who_global_data VALUES (63754, 303, 4967, 6, 127, 270, 193);
INSERT INTO public.who_global_data VALUES (63755, 4, 834, 0, 30, 270, 113);
INSERT INTO public.who_global_data VALUES (63756, 168, 5891, 5, 507, 270, 143);
INSERT INTO public.who_global_data VALUES (63757, 0, 0, 0, 0, 270, 219);
INSERT INTO public.who_global_data VALUES (63758, 0, 756, 0, 48, 270, 186);
INSERT INTO public.who_global_data VALUES (63759, 0, 45, 0, 2, 270, 52);
INSERT INTO public.who_global_data VALUES (63760, 0, 3, 0, 0, 270, 180);
INSERT INTO public.who_global_data VALUES (63761, 0, 25, 0, 3, 270, 167);
INSERT INTO public.who_global_data VALUES (63762, 110, 6034, 5, 305, 270, 154);
INSERT INTO public.who_global_data VALUES (63763, 79, 3368, 1, 46, 270, 94);
INSERT INTO public.who_global_data VALUES (63764, 0, 101, 0, 3, 270, 66);
INSERT INTO public.who_global_data VALUES (63765, 7, 6948, 0, 97, 270, 58);
INSERT INTO public.who_global_data VALUES (63766, 87, 15874, 2, 620, 270, 163);
INSERT INTO public.who_global_data VALUES (63767, 70, 2589, 0, 32, 270, 37);
INSERT INTO public.who_global_data VALUES (63768, 0, 92, 0, 11, 270, 142);
INSERT INTO public.who_global_data VALUES (63769, 252, 5409, 1, 9, 270, 83);
INSERT INTO public.who_global_data VALUES (63770, 969, 16660, 11, 250, 270, 228);
INSERT INTO public.who_global_data VALUES (63771, 0, 84, 0, 7, 270, 188);
INSERT INTO public.who_global_data VALUES (63772, 0, 23906, 0, 135, 270, 62);
INSERT INTO public.who_global_data VALUES (63773, 476, 54815, 65, 8725, 270, 160);
INSERT INTO public.who_global_data VALUES (63774, 0, 18, 0, 2, 270, 50);
INSERT INTO public.who_global_data VALUES (63775, 0, 319, 0, 2, 270, 33);
INSERT INTO public.who_global_data VALUES (63776, 0, 118, 0, 7, 270, 183);
INSERT INTO public.who_global_data VALUES (63777, 2, 11, 0, 0, 270, 92);
INSERT INTO public.who_global_data VALUES (63778, 119, 2556, 4, 118, 270, 158);
INSERT INTO public.who_global_data VALUES (63779, 0, 2, 0, 0, 270, 67);
INSERT INTO public.who_global_data VALUES (63780, 44, 2142, 9, 112, 270, 57);
INSERT INTO public.who_global_data VALUES (63781, 1, 24, 0, 1, 270, 38);
INSERT INTO public.who_global_data VALUES (63782, 6760, 162699, 496, 11123, 270, 141);
INSERT INTO public.who_global_data VALUES (63783, 0, 7, 0, 1, 270, 178);
INSERT INTO public.who_global_data VALUES (63784, 0, 141, 0, 1, 270, 108);
INSERT INTO public.who_global_data VALUES (63785, 25, 1990, 2, 93, 270, 39);
INSERT INTO public.who_global_data VALUES (63786, 9, 760, 1, 50, 270, 2);
INSERT INTO public.who_global_data VALUES (63787, 0, 19, 0, 1, 270, 195);
INSERT INTO public.who_global_data VALUES (63788, 14, 260, 0, 2, 270, 107);
INSERT INTO public.who_global_data VALUES (63789, 0, 122, 0, 0, 270, 161);
INSERT INTO public.who_global_data VALUES (63790, 0, 2579, 0, 114, 270, 212);
INSERT INTO public.who_global_data VALUES (63791, 1160, 69156, 178, 4906, 270, 181);
INSERT INTO public.who_global_data VALUES (63792, 0, 81, 0, 1, 270, 53);
INSERT INTO public.who_global_data VALUES (63793, 0, 179, 0, 0, 270, 164);
INSERT INTO public.who_global_data VALUES (63794, 0, 322, 0, 31, 270, 140);
INSERT INTO public.who_global_data VALUES (63795, 1197, 30063, 11, 323, 270, 20);
INSERT INTO public.who_global_data VALUES (63796, 1, 84451, 1, 4644, 270, 112);
INSERT INTO public.who_global_data VALUES (63797, 568, 11063, 18, 463, 270, 111);
INSERT INTO public.who_global_data VALUES (63798, 0, 11, 0, 1, 270, 71);
INSERT INTO public.who_global_data VALUES (63799, 46, 333, 1, 11, 270, 218);
INSERT INTO public.who_global_data VALUES (63800, 0, 0, 0, 0, 270, 43);
INSERT INTO public.who_global_data VALUES (63801, 12, 792, 0, 6, 270, 49);
INSERT INTO public.who_global_data VALUES (63802, 30, 1730, 0, 21, 270, 1);
INSERT INTO public.who_global_data VALUES (63803, 9, 2196, 1, 91, 270, 48);
INSERT INTO public.who_global_data VALUES (63804, 17, 1783, 0, 77, 270, 232);
INSERT INTO public.who_global_data VALUES (63805, 0, 16, 0, 1, 270, 175);
INSERT INTO public.who_global_data VALUES (63806, 3, 901, 0, 16, 270, 21);
INSERT INTO public.who_global_data VALUES (63807, 53, 8176, 2, 282, 270, 156);
INSERT INTO public.who_global_data VALUES (63808, 0, 0, 0, 0, 270, 95);
INSERT INTO public.who_global_data VALUES (63809, 78, 1102, 3, 44, 270, 177);
INSERT INTO public.who_global_data VALUES (63810, 84, 10513, 4, 533, 270, 210);
INSERT INTO public.who_global_data VALUES (63811, 46, 1256, 0, 3, 270, 120);
INSERT INTO public.who_global_data VALUES (63812, 0, 16, 0, 0, 270, 135);
INSERT INTO public.who_global_data VALUES (63813, 287, 10634, 5, 393, 270, 206);
INSERT INTO public.who_global_data VALUES (63814, -50, 29509, 18, 2145, 270, 189);
INSERT INTO public.who_global_data VALUES (63815, 0, 9746, 0, 533, 270, 129);
INSERT INTO public.who_global_data VALUES (63816, 69, 958, 0, 17, 270, 121);
INSERT INTO public.who_global_data VALUES (63817, 0, 439, 0, 4, 270, 59);
INSERT INTO public.who_global_data VALUES (63818, 0, 39, 0, 0, 270, 96);
INSERT INTO public.who_global_data VALUES (63819, 2, 1741, 1, 61, 270, 41);
INSERT INTO public.who_global_data VALUES (63820, 3, 175, 0, 2, 270, 216);
INSERT INTO public.who_global_data VALUES (63821, 11, 250, 0, 5, 270, 236);
INSERT INTO public.who_global_data VALUES (63822, 0, 13, 0, 0, 270, 150);
INSERT INTO public.who_global_data VALUES (63823, 0, 187, 0, 0, 270, 61);
INSERT INTO public.who_global_data VALUES (63824, 0, 18, 0, 0, 270, 7);
INSERT INTO public.who_global_data VALUES (63825, 22, 5984, 4, 271, 270, 169);
INSERT INTO public.who_global_data VALUES (63826, 418, 137491, 262, 26600, 270, 28);
INSERT INTO public.who_global_data VALUES (63827, 0, 144, 0, 1, 270, 85);
INSERT INTO public.who_global_data VALUES (63828, 0, 60, 0, 0, 270, 211);
INSERT INTO public.who_global_data VALUES (63829, 141, 802, 1, 9, 270, 60);
INSERT INTO public.who_global_data VALUES (63830, 2, 22, 0, 1, 270, 3);
INSERT INTO public.who_global_data VALUES (63831, 1, 639, 1, 11, 270, 11);
INSERT INTO public.who_global_data VALUES (63832, 933, 170508, 116, 7533, 270, 89);
INSERT INTO public.who_global_data VALUES (63833, 437, 4700, 0, 22, 270, 24);
INSERT INTO public.who_global_data VALUES (63834, 0, 146, 0, 0, 270, 162);
INSERT INTO public.who_global_data VALUES (63835, 10, 2726, 0, 151, 270, 100);
INSERT INTO public.who_global_data VALUES (63836, 0, 11, 0, 0, 270, 47);
INSERT INTO public.who_global_data VALUES (63837, 0, 21, 0, 0, 270, 29);
INSERT INTO public.who_global_data VALUES (63838, 0, 154, 0, 13, 270, 40);
INSERT INTO public.who_global_data VALUES (63839, 0, 147, 0, 5, 270, 222);
INSERT INTO public.who_global_data VALUES (63840, 85, 1052, 2, 26, 270, 132);
INSERT INTO public.who_global_data VALUES (63841, 0, 252, 0, 13, 270, 130);
INSERT INTO public.who_global_data VALUES (63842, 0, 2146, 0, 11, 270, 234);
INSERT INTO public.who_global_data VALUES (63843, 119, 761, 0, 3, 270, 23);
INSERT INTO public.who_global_data VALUES (63844, 7, 104, 0, 10, 270, 192);
INSERT INTO public.who_global_data VALUES (63845, 31, 182, 3, 15, 270, 69);
INSERT INTO public.who_global_data VALUES (63846, 0, 12, 0, 0, 270, 187);
INSERT INTO public.who_global_data VALUES (63847, 142, 1972, 0, 108, 270, 230);
INSERT INTO public.who_global_data VALUES (63848, 29, 3313, 4, 425, 270, 77);
INSERT INTO public.who_global_data VALUES (63849, 0, 1801, 0, 10, 270, 9);
INSERT INTO public.who_global_data VALUES (63850, 3604, 70756, 87, 2293, 270, 74);
INSERT INTO public.who_global_data VALUES (63851, 484, 14749, 16, 1007, 270, 224);
INSERT INTO public.who_global_data VALUES (63852, 1481, 110767, 48, 6733, 270, 199);
INSERT INTO public.who_global_data VALUES (63853, 95, 2913, 2, 112, 270, 190);
INSERT INTO public.who_global_data VALUES (63854, 139, 23135, 9, 1467, 270, 12);
INSERT INTO public.who_global_data VALUES (63855, 0, 330, 0, 23, 270, 104);
INSERT INTO public.who_global_data VALUES (63856, 29, 16394, 4, 255, 270, 153);
INSERT INTO public.who_global_data VALUES (63857, 744, 219814, 179, 30739, 270, 91);
INSERT INTO public.who_global_data VALUES (63858, 4, 502, 0, 9, 270, 215);
INSERT INTO public.who_global_data VALUES (63859, 76, 15874, 22, 643, 270, 84);
INSERT INTO public.who_global_data VALUES (63860, 3, 296, 1, 26, 270, 231);
INSERT INTO public.who_global_data VALUES (63861, 14, 576, 0, 9, 270, 196);
INSERT INTO public.who_global_data VALUES (63862, 210, 5417, 0, 32, 270, 105);
INSERT INTO public.who_global_data VALUES (63863, 28, 700, 1, 33, 270, 122);
INSERT INTO public.who_global_data VALUES (63864, 0, 0, 0, 0, 270, 159);
INSERT INTO public.who_global_data VALUES (63865, 14, 884, 1, 20, 270, 75);
INSERT INTO public.who_global_data VALUES (63866, 991, 10277, 10, 75, 270, 27);
INSERT INTO public.who_global_data VALUES (63867, 21, 1037, 0, 12, 270, 54);
INSERT INTO public.who_global_data VALUES (63868, 0, 19, 0, 0, 270, 226);
INSERT INTO public.who_global_data VALUES (63869, 7, 946, 0, 18, 270, 79);
INSERT INTO public.who_global_data VALUES (63870, 11, 870, 0, 26, 270, 56);
INSERT INTO public.who_global_data VALUES (63871, 0, 0, 0, 0, 270, 117);
INSERT INTO public.who_global_data VALUES (63872, 7, 211, 0, 20, 270, 152);
INSERT INTO public.who_global_data VALUES (63873, 0, 64, 0, 3, 270, 16);
INSERT INTO public.who_global_data VALUES (63874, 0, 83, 0, 1, 270, 10);
INSERT INTO public.who_global_data VALUES (63875, 9, 1488, 3, 54, 270, 201);
INSERT INTO public.who_global_data VALUES (63876, 2, 3888, 0, 101, 270, 174);
INSERT INTO public.who_global_data VALUES (63877, 17, 186, 0, 0, 270, 119);
INSERT INTO public.who_global_data VALUES (63878, 1, 57, 0, 3, 270, 168);
INSERT INTO public.who_global_data VALUES (63879, 70, 6726, 1, 109, 270, 99);
INSERT INTO public.who_global_data VALUES (63880, 62, 897, 0, 3, 270, 171);
INSERT INTO public.who_global_data VALUES (63881, 8, 712, 1, 39, 270, 87);
INSERT INTO public.who_global_data VALUES (63882, 3, 505, 0, 5, 270, 123);
INSERT INTO public.who_global_data VALUES (63883, 0, 0, 0, 0, 270, 151);
INSERT INTO public.who_global_data VALUES (63884, 0, 187, 0, 14, 270, 213);
INSERT INTO public.who_global_data VALUES (63885, 0, 8, 0, 1, 270, 118);
INSERT INTO public.who_global_data VALUES (63886, 0, 332, 0, 10, 270, 134);
INSERT INTO public.who_global_data VALUES (63887, 38, 1061, 1, 12, 270, 65);
INSERT INTO public.who_global_data VALUES (63888, 1562, 35022, 112, 3465, 270, 102);
INSERT INTO public.who_global_data VALUES (63889, 0, 0, 0, 0, 270, 223);
INSERT INTO public.who_global_data VALUES (63890, 1, 67, 0, 1, 270, 4);
INSERT INTO public.who_global_data VALUES (63891, 0, 42, 0, 0, 270, 146);
INSERT INTO public.who_global_data VALUES (63892, 0, 324, 0, 9, 270, 31);
INSERT INTO public.who_global_data VALUES (63893, 0, 11, 0, 1, 270, 127);
INSERT INTO public.who_global_data VALUES (63894, 154, 6380, 0, 188, 270, 22);
INSERT INTO public.who_global_data VALUES (63895, 12, 103, 0, 0, 270, 115);
INSERT INTO public.who_global_data VALUES (63896, 0, 180, 0, 6, 270, 106);
INSERT INTO public.who_global_data VALUES (63897, 0, 16, 0, 0, 270, 90);
INSERT INTO public.who_global_data VALUES (63898, 0, 0, 0, 0, 270, 70);
INSERT INTO public.who_global_data VALUES (63899, 70, 191, 0, 0, 270, 46);
INSERT INTO public.who_global_data VALUES (63900, 179, 42549, 7, 5420, 270, 139);
INSERT INTO public.who_global_data VALUES (63901, 0, 18, 0, 0, 270, 42);
INSERT INTO public.who_global_data VALUES (63902, 0, 1147, 0, 21, 270, 80);
INSERT INTO public.who_global_data VALUES (63903, 0, 16, 0, 5, 270, 203);
INSERT INTO public.who_global_data VALUES (63904, 11, 832, 0, 46, 270, 136);
INSERT INTO public.who_global_data VALUES (63905, 242, 4641, 7, 150, 270, 63);
INSERT INTO public.who_global_data VALUES (63906, 0, 0, 0, 0, 270, 17);
INSERT INTO public.who_global_data VALUES (63907, 3, 19, 0, 2, 270, 172);
INSERT INTO public.who_global_data VALUES (63908, 22, 1664, 0, 91, 270, 109);
INSERT INTO public.who_global_data VALUES (63909, 7, 8106, 7, 224, 270, 200);
INSERT INTO public.who_global_data VALUES (63910, 0, 547, 0, 4, 270, 93);
INSERT INTO public.who_global_data VALUES (63911, 147, 3721, 0, 17, 270, 5);
INSERT INTO public.who_global_data VALUES (63912, 0, 712, 0, 13, 270, 214);
INSERT INTO public.who_global_data VALUES (63913, 1733, 32674, 57, 724, 270, 204);
INSERT INTO public.who_global_data VALUES (63914, 0, 0, 0, 0, 270, 198);
INSERT INTO public.who_global_data VALUES (63915, 166, 8448, 7, 244, 270, 173);
INSERT INTO public.who_global_data VALUES (63916, 0, 8, 0, 0, 270, 229);
INSERT INTO public.who_global_data VALUES (63917, 11, 724, 0, 10, 270, 76);
INSERT INTO public.who_global_data VALUES (63918, 2292, 67307, 75, 1889, 270, 138);
INSERT INTO public.who_global_data VALUES (63919, 292, 11086, 7, 726, 270, 98);
INSERT INTO public.who_global_data VALUES (63920, 0, 0, 0, 0, 270, 103);
INSERT INTO public.who_global_data VALUES (63921, 330, 16326, 11, 811, 270, 225);
INSERT INTO public.who_global_data VALUES (63922, 98, 27679, 9, 1144, 270, 131);
INSERT INTO public.who_global_data VALUES (63923, 58, 2256, 2, 113, 270, 235);
INSERT INTO public.who_global_data VALUES (63924, 1526, 25149, 0, 14, 270, 137);
INSERT INTO public.who_global_data VALUES (63925, 27, 10936, 2, 258, 270, 81);
INSERT INTO public.who_global_data VALUES (63926, 68, 4995, 8, 179, 270, 182);
INSERT INTO public.who_global_data VALUES (63927, 0, 436, 0, 0, 270, 145);
INSERT INTO public.who_global_data VALUES (63928, 226, 15588, 20, 972, 270, 26);
INSERT INTO public.who_global_data VALUES (63929, 10899, 232243, 107, 2116, 270, 170);
INSERT INTO public.who_global_data VALUES (63930, 1, 285, 0, 0, 270, 191);
INSERT INTO public.who_global_data VALUES (63931, 0, 2, 0, 0, 270, 221);
INSERT INTO public.who_global_data VALUES (63932, 0, 6, 0, 0, 270, 64);
INSERT INTO public.who_global_data VALUES (63933, 0, 0, 0, 0, 270, 116);
INSERT INTO public.who_global_data VALUES (63934, 0, 15, 0, 0, 270, 128);
INSERT INTO public.who_global_data VALUES (63935, 0, 18, 0, 0, 270, 6);
INSERT INTO public.who_global_data VALUES (63936, 0, 39, 0, 3, 270, 227);
INSERT INTO public.who_global_data VALUES (63937, 0, 1, 0, 0, 270, 68);
INSERT INTO public.who_global_data VALUES (63938, 0, 17, 0, 0, 270, 184);
INSERT INTO public.who_global_data VALUES (63939, 0, 0, 0, 0, 270, 82);
INSERT INTO public.who_global_data VALUES (63940, 10, 647, 0, 41, 270, 149);
INSERT INTO public.who_global_data VALUES (63941, 0, 165, 0, 4, 270, 197);
INSERT INTO public.who_global_data VALUES (63942, 1911, 42925, 9, 264, 270, 78);
INSERT INTO public.who_global_data VALUES (63943, 177, 1886, 0, 19, 270, 233);
INSERT INTO public.who_global_data VALUES (63944, 62, 10176, 3, 218, 270, 133);
INSERT INTO public.who_global_data VALUES (63945, 0, 11, 0, 0, 270, 35);
INSERT INTO public.who_global_data VALUES (63946, 31, 338, 1, 19, 270, 114);
INSERT INTO public.who_global_data VALUES (63947, 486, 23822, 1, 21, 270, 237);
INSERT INTO public.who_global_data VALUES (63948, 0, 2, 0, 0, 270, 55);
INSERT INTO public.who_global_data VALUES (63949, 0, 77, 0, 15, 270, 176);
INSERT INTO public.who_global_data VALUES (63950, 0, 1457, 0, 26, 270, 202);
INSERT INTO public.who_global_data VALUES (63951, 1, 1461, 0, 110, 270, 155);
INSERT INTO public.who_global_data VALUES (63952, 0, 0, 0, 0, 270, 32);
INSERT INTO public.who_global_data VALUES (63953, 81, 1170, 0, 52, 270, 220);
INSERT INTO public.who_global_data VALUES (63954, 637, 10652, 12, 206, 270, 30);
INSERT INTO public.who_global_data VALUES (63955, 18, 174, 0, 0, 270, 147);
INSERT INTO public.who_global_data VALUES (63956, 318, 233464, 110, 27767, 270, 208);
INSERT INTO public.who_global_data VALUES (63957, 6, 869, 0, 9, 270, 45);
INSERT INTO public.who_global_data VALUES (63958, 161, 1526, 4, 74, 270, 110);
INSERT INTO public.who_global_data VALUES (63959, 0, 10, 0, 1, 270, 88);
INSERT INTO public.who_global_data VALUES (63960, 279, 26849, 73, 3649, 270, 51);
INSERT INTO public.who_global_data VALUES (63961, 47, 30378, 3, 1682, 270, 209);
INSERT INTO public.who_global_data VALUES (63962, 0, 47, 0, 3, 270, 205);
INSERT INTO public.who_global_data VALUES (63963, 49, 661, 1, 21, 270, 18);
INSERT INTO public.who_global_data VALUES (63964, 2, 3017, 0, 56, 270, 72);
INSERT INTO public.who_global_data VALUES (63965, 2329, 210724, 187, 31579, 270, 44);
INSERT INTO public.who_global_data VALUES (63966, 0, 24, 0, 0, 270, 15);
INSERT INTO public.who_global_data VALUES (63967, 8, 181, 0, 11, 270, 25);
INSERT INTO public.who_global_data VALUES (63968, 0, 0, 0, 0, 270, 179);
INSERT INTO public.who_global_data VALUES (63969, 0, 0, 0, 0, 270, 34);
INSERT INTO public.who_global_data VALUES (63970, 0, 116, 0, 8, 270, 207);
INSERT INTO public.who_global_data VALUES (63971, 0, 1032, 0, 45, 270, 166);
INSERT INTO public.who_global_data VALUES (63972, 1114, 139771, 55, 3841, 270, 126);
INSERT INTO public.who_global_data VALUES (63973, 0, 0, 0, 0, 270, 97);
INSERT INTO public.who_global_data VALUES (63974, 0, 12, 0, 1, 270, 36);
INSERT INTO public.who_global_data VALUES (63975, 0, 0, 0, 0, 270, 125);
INSERT INTO public.who_global_data VALUES (63976, 1, 122, 0, 0, 270, 124);
INSERT INTO public.who_global_data VALUES (63977, 375, 16023, 17, 425, 270, 185);
INSERT INTO public.who_global_data VALUES (63978, 1463, 19661, 5, 203, 270, 194);
INSERT INTO public.who_global_data VALUES (63979, 0, 509, 0, 21, 270, 144);
INSERT INTO public.who_global_data VALUES (63980, 23767, 1322054, 982, 79634, 270, 19);
INSERT INTO public.who_global_data VALUES (63981, 0, 69, 1, 5, 270, 217);
INSERT INTO public.who_global_data VALUES (63982, 5, 707, 2, 19, 270, 148);
INSERT INTO public.who_global_data VALUES (63983, 98, 2509, 0, 10, 270, 86);
INSERT INTO public.who_global_data VALUES (63984, 0, 0, 0, 0, 270, 13);
INSERT INTO public.who_global_data VALUES (63985, 12, 414, 0, 10, 270, 157);
INSERT INTO public.who_global_data VALUES (63986, 0, 288, 0, 0, 270, 8);
INSERT INTO public.who_global_data VALUES (63987, 0, 0, 0, 0, 270, 73);
INSERT INTO public.who_global_data VALUES (63988, 14, 67, 2, 11, 270, 101);
INSERT INTO public.who_global_data VALUES (63989, 0, 267, 0, 7, 270, 165);
INSERT INTO public.who_global_data VALUES (63990, 0, 36, 0, 4, 270, 14);
INSERT INTO public.who_global_data VALUES (63991, 262, 4664, 2, 121, 271, 193);
INSERT INTO public.who_global_data VALUES (63992, 0, 830, 0, 30, 271, 113);
INSERT INTO public.who_global_data VALUES (63993, 165, 5723, 8, 502, 271, 143);
INSERT INTO public.who_global_data VALUES (63994, 0, 0, 0, 0, 271, 219);
INSERT INTO public.who_global_data VALUES (63995, 2, 756, 0, 48, 271, 186);
INSERT INTO public.who_global_data VALUES (63996, 2, 45, 0, 2, 271, 52);
INSERT INTO public.who_global_data VALUES (63997, 0, 3, 0, 0, 271, 180);
INSERT INTO public.who_global_data VALUES (63998, 0, 25, 0, 3, 271, 167);
INSERT INTO public.who_global_data VALUES (63999, 244, 5924, 3, 300, 271, 154);
INSERT INTO public.who_global_data VALUES (64000, 138, 3289, 1, 45, 271, 94);
INSERT INTO public.who_global_data VALUES (64001, 0, 101, 0, 3, 271, 66);
INSERT INTO public.who_global_data VALUES (64002, 12, 6941, 0, 97, 271, 58);
INSERT INTO public.who_global_data VALUES (64003, 10, 15787, 3, 618, 271, 163);
INSERT INTO public.who_global_data VALUES (64004, 97, 2519, 1, 32, 271, 37);
INSERT INTO public.who_global_data VALUES (64005, 0, 92, 0, 11, 271, 142);
INSERT INTO public.who_global_data VALUES (64006, 301, 5157, 0, 8, 271, 83);
INSERT INTO public.who_global_data VALUES (64007, 1034, 15691, 11, 239, 271, 228);
INSERT INTO public.who_global_data VALUES (64008, 2, 84, 0, 7, 271, 188);
INSERT INTO public.who_global_data VALUES (64009, 933, 23906, 4, 135, 271, 62);
INSERT INTO public.who_global_data VALUES (64010, 118, 54339, 72, 8660, 271, 160);
INSERT INTO public.who_global_data VALUES (64011, 0, 18, 0, 2, 271, 50);
INSERT INTO public.who_global_data VALUES (64012, 35, 319, 0, 2, 271, 33);
INSERT INTO public.who_global_data VALUES (64013, 0, 118, 0, 7, 271, 183);
INSERT INTO public.who_global_data VALUES (64014, 2, 9, 0, 0, 271, 92);
INSERT INTO public.who_global_data VALUES (64015, 171, 2437, 8, 114, 271, 158);
INSERT INTO public.who_global_data VALUES (64016, 0, 2, 0, 0, 271, 67);
INSERT INTO public.who_global_data VALUES (64017, 28, 2098, 6, 103, 271, 57);
INSERT INTO public.who_global_data VALUES (64018, 0, 23, 0, 1, 271, 38);
INSERT INTO public.who_global_data VALUES (64019, 10611, 155939, 730, 10627, 271, 141);
INSERT INTO public.who_global_data VALUES (64020, 0, 7, 0, 1, 271, 178);
INSERT INTO public.who_global_data VALUES (64021, 0, 141, 0, 1, 271, 108);
INSERT INTO public.who_global_data VALUES (64022, 10, 1965, 1, 91, 271, 39);
INSERT INTO public.who_global_data VALUES (64023, 3, 751, 1, 49, 271, 2);
INSERT INTO public.who_global_data VALUES (64024, 0, 19, 0, 1, 271, 195);
INSERT INTO public.who_global_data VALUES (64025, 10, 246, 0, 2, 271, 107);
INSERT INTO public.who_global_data VALUES (64026, 0, 122, 0, 0, 271, 161);
INSERT INTO public.who_global_data VALUES (64027, 244, 2579, 4, 114, 271, 212);
INSERT INTO public.who_global_data VALUES (64028, 1216, 67996, 100, 4728, 271, 181);
INSERT INTO public.who_global_data VALUES (64029, 0, 81, 0, 1, 271, 53);
INSERT INTO public.who_global_data VALUES (64030, 36, 179, 0, 0, 271, 164);
INSERT INTO public.who_global_data VALUES (64031, 0, 322, 0, 31, 271, 140);
INSERT INTO public.who_global_data VALUES (64032, 1647, 28866, 8, 312, 271, 20);
INSERT INTO public.who_global_data VALUES (64033, 20, 84450, 0, 4643, 271, 112);
INSERT INTO public.who_global_data VALUES (64034, 444, 10495, 17, 445, 271, 111);
INSERT INTO public.who_global_data VALUES (64035, 0, 11, 0, 1, 271, 71);
INSERT INTO public.who_global_data VALUES (64036, 0, 287, 0, 10, 271, 218);
INSERT INTO public.who_global_data VALUES (64037, 0, 0, 0, 0, 271, 43);
INSERT INTO public.who_global_data VALUES (64038, 7, 780, 0, 6, 271, 49);
INSERT INTO public.who_global_data VALUES (64039, 33, 1700, 0, 21, 271, 1);
INSERT INTO public.who_global_data VALUES (64040, 11, 2187, 3, 90, 271, 48);
INSERT INTO public.who_global_data VALUES (64041, 12, 1766, 3, 77, 271, 232);
INSERT INTO public.who_global_data VALUES (64042, 0, 16, 0, 1, 271, 175);
INSERT INTO public.who_global_data VALUES (64043, 6, 898, 1, 16, 271, 21);
INSERT INTO public.who_global_data VALUES (64044, 28, 8123, 4, 280, 271, 156);
INSERT INTO public.who_global_data VALUES (64045, 0, 0, 0, 0, 271, 95);
INSERT INTO public.who_global_data VALUES (64046, 33, 1024, 0, 41, 271, 177);
INSERT INTO public.who_global_data VALUES (64047, 110, 10429, 3, 529, 271, 210);
INSERT INTO public.who_global_data VALUES (64048, 21, 1210, 0, 3, 271, 120);
INSERT INTO public.who_global_data VALUES (64049, 0, 16, 0, 0, 271, 135);
INSERT INTO public.who_global_data VALUES (64050, 465, 10347, 3, 388, 271, 206);
INSERT INTO public.who_global_data VALUES (64051, 741, 29559, 423, 2127, 271, 189);
INSERT INTO public.who_global_data VALUES (64052, 346, 9746, 8, 533, 271, 129);
INSERT INTO public.who_global_data VALUES (64053, 105, 889, 1, 17, 271, 121);
INSERT INTO public.who_global_data VALUES (64054, 0, 439, 0, 4, 271, 59);
INSERT INTO public.who_global_data VALUES (64055, 0, 39, 0, 0, 271, 96);
INSERT INTO public.who_global_data VALUES (64056, 6, 1739, 0, 60, 271, 41);
INSERT INTO public.who_global_data VALUES (64057, 9, 172, 0, 2, 271, 216);
INSERT INTO public.who_global_data VALUES (64058, 29, 239, 0, 5, 271, 236);
INSERT INTO public.who_global_data VALUES (64059, 0, 13, 0, 0, 271, 150);
INSERT INTO public.who_global_data VALUES (64060, 0, 187, 0, 0, 271, 61);
INSERT INTO public.who_global_data VALUES (64061, 0, 18, 0, 0, 271, 7);
INSERT INTO public.who_global_data VALUES (64062, 82, 5962, 2, 267, 271, 169);
INSERT INTO public.who_global_data VALUES (64063, 65, 137073, 70, 26338, 271, 28);
INSERT INTO public.who_global_data VALUES (64064, 3, 144, 0, 1, 271, 85);
INSERT INTO public.who_global_data VALUES (64065, 0, 60, 0, 0, 271, 211);
INSERT INTO public.who_global_data VALUES (64066, 0, 661, 0, 8, 271, 60);
INSERT INTO public.who_global_data VALUES (64067, 0, 20, 0, 1, 271, 3);
INSERT INTO public.who_global_data VALUES (64068, 3, 638, 0, 10, 271, 11);
INSERT INTO public.who_global_data VALUES (64069, 357, 169575, 22, 7417, 271, 89);
INSERT INTO public.who_global_data VALUES (64070, 0, 4263, 0, 22, 271, 24);
INSERT INTO public.who_global_data VALUES (64071, 0, 146, 0, 0, 271, 162);
INSERT INTO public.who_global_data VALUES (64072, 6, 2716, 0, 151, 271, 100);
INSERT INTO public.who_global_data VALUES (64073, 0, 11, 0, 0, 271, 47);
INSERT INTO public.who_global_data VALUES (64074, 0, 21, 0, 0, 271, 29);
INSERT INTO public.who_global_data VALUES (64075, 0, 154, 0, 13, 271, 40);
INSERT INTO public.who_global_data VALUES (64076, 0, 147, 0, 5, 271, 222);
INSERT INTO public.who_global_data VALUES (64077, 67, 967, 0, 24, 271, 132);
INSERT INTO public.who_global_data VALUES (64078, 0, 252, 0, 13, 271, 130);
INSERT INTO public.who_global_data VALUES (64079, 104, 2146, 0, 11, 271, 234);
INSERT INTO public.who_global_data VALUES (64080, 0, 642, 0, 3, 271, 23);
INSERT INTO public.who_global_data VALUES (64081, 4, 97, 0, 10, 271, 192);
INSERT INTO public.who_global_data VALUES (64082, 5, 151, 0, 12, 271, 69);
INSERT INTO public.who_global_data VALUES (64083, 0, 12, 0, 0, 271, 187);
INSERT INTO public.who_global_data VALUES (64084, 59, 1830, 1, 108, 271, 230);
INSERT INTO public.who_global_data VALUES (64085, 21, 3284, 8, 421, 271, 77);
INSERT INTO public.who_global_data VALUES (64086, 0, 1801, 0, 10, 271, 9);
INSERT INTO public.who_global_data VALUES (64087, 4213, 67152, 97, 2206, 271, 74);
INSERT INTO public.who_global_data VALUES (64088, 233, 14265, 18, 991, 271, 224);
INSERT INTO public.who_global_data VALUES (64089, 1683, 109286, 45, 6685, 271, 199);
INSERT INTO public.who_global_data VALUES (64090, 51, 2818, 1, 110, 271, 190);
INSERT INTO public.who_global_data VALUES (64091, 236, 22996, 12, 1458, 271, 12);
INSERT INTO public.who_global_data VALUES (64092, 1, 330, 0, 23, 271, 104);
INSERT INTO public.who_global_data VALUES (64093, 19, 16365, 3, 251, 271, 153);
INSERT INTO public.who_global_data VALUES (64094, 802, 219070, 165, 30560, 271, 91);
INSERT INTO public.who_global_data VALUES (64095, 8, 498, 0, 9, 271, 215);
INSERT INTO public.who_global_data VALUES (64096, 51, 15798, 8, 621, 271, 84);
INSERT INTO public.who_global_data VALUES (64097, 0, 293, 0, 25, 271, 231);
INSERT INTO public.who_global_data VALUES (64098, 22, 562, 0, 9, 271, 196);
INSERT INTO public.who_global_data VALUES (64099, 69, 5207, 1, 32, 271, 105);
INSERT INTO public.who_global_data VALUES (64100, 23, 672, 2, 32, 271, 122);
INSERT INTO public.who_global_data VALUES (64101, 0, 0, 0, 0, 271, 159);
INSERT INTO public.who_global_data VALUES (64102, 0, 870, 0, 19, 271, 75);
INSERT INTO public.who_global_data VALUES (64103, 598, 9286, 7, 65, 271, 27);
INSERT INTO public.who_global_data VALUES (64104, 14, 1016, 0, 12, 271, 54);
INSERT INTO public.who_global_data VALUES (64105, 0, 19, 0, 0, 271, 226);
INSERT INTO public.who_global_data VALUES (64106, 9, 939, 0, 18, 271, 79);
INSERT INTO public.who_global_data VALUES (64107, 14, 859, 0, 26, 271, 56);
INSERT INTO public.who_global_data VALUES (64108, 0, 0, 0, 0, 271, 117);
INSERT INTO public.who_global_data VALUES (64109, 5, 204, 0, 20, 271, 152);
INSERT INTO public.who_global_data VALUES (64110, 0, 64, 0, 3, 271, 16);
INSERT INTO public.who_global_data VALUES (64111, 0, 83, 0, 1, 271, 10);
INSERT INTO public.who_global_data VALUES (64112, 8, 1479, 0, 51, 271, 201);
INSERT INTO public.who_global_data VALUES (64113, 9, 3886, 0, 101, 271, 174);
INSERT INTO public.who_global_data VALUES (64114, 0, 169, 0, 0, 271, 119);
INSERT INTO public.who_global_data VALUES (64115, 0, 56, 0, 3, 271, 168);
INSERT INTO public.who_global_data VALUES (64116, 67, 6656, 0, 108, 271, 99);
INSERT INTO public.who_global_data VALUES (64117, 50, 835, 0, 3, 271, 171);
INSERT INTO public.who_global_data VALUES (64118, 12, 704, 1, 38, 271, 87);
INSERT INTO public.who_global_data VALUES (64119, 7, 502, 0, 5, 271, 123);
INSERT INTO public.who_global_data VALUES (64120, 0, 0, 0, 0, 271, 151);
INSERT INTO public.who_global_data VALUES (64121, 1, 187, 0, 14, 271, 213);
INSERT INTO public.who_global_data VALUES (64122, 0, 8, 0, 1, 271, 118);
INSERT INTO public.who_global_data VALUES (64123, 0, 332, 0, 10, 271, 134);
INSERT INTO public.who_global_data VALUES (64124, 133, 1023, 0, 11, 271, 65);
INSERT INTO public.who_global_data VALUES (64125, 1938, 33460, 193, 3353, 271, 102);
INSERT INTO public.who_global_data VALUES (64126, 0, 0, 0, 0, 271, 223);
INSERT INTO public.who_global_data VALUES (64127, 0, 66, 0, 1, 271, 4);
INSERT INTO public.who_global_data VALUES (64128, 0, 42, 0, 0, 271, 146);
INSERT INTO public.who_global_data VALUES (64129, 0, 324, 0, 9, 271, 31);
INSERT INTO public.who_global_data VALUES (64130, 0, 11, 0, 1, 271, 127);
INSERT INTO public.who_global_data VALUES (64131, 188, 6226, 0, 188, 271, 22);
INSERT INTO public.who_global_data VALUES (64132, 4, 91, 0, 0, 271, 115);
INSERT INTO public.who_global_data VALUES (64133, 2, 180, 0, 6, 271, 106);
INSERT INTO public.who_global_data VALUES (64134, 0, 16, 0, 0, 271, 90);
INSERT INTO public.who_global_data VALUES (64135, 0, 0, 0, 0, 271, 70);
INSERT INTO public.who_global_data VALUES (64136, 11, 121, 0, 0, 271, 46);
INSERT INTO public.who_global_data VALUES (64137, 242, 42370, 19, 5413, 271, 139);
INSERT INTO public.who_global_data VALUES (64138, 0, 18, 0, 0, 271, 42);
INSERT INTO public.who_global_data VALUES (64139, 3, 1147, 0, 21, 271, 80);
INSERT INTO public.who_global_data VALUES (64140, 0, 16, 0, 5, 271, 203);
INSERT INTO public.who_global_data VALUES (64141, 6, 821, 1, 46, 271, 136);
INSERT INTO public.who_global_data VALUES (64142, 248, 4399, 15, 143, 271, 63);
INSERT INTO public.who_global_data VALUES (64143, 0, 0, 0, 0, 271, 17);
INSERT INTO public.who_global_data VALUES (64144, 0, 16, 0, 2, 271, 172);
INSERT INTO public.who_global_data VALUES (64145, 20, 1642, 0, 91, 271, 109);
INSERT INTO public.who_global_data VALUES (64146, 30, 8099, 4, 217, 271, 200);
INSERT INTO public.who_global_data VALUES (64147, 0, 547, 0, 4, 271, 93);
INSERT INTO public.who_global_data VALUES (64148, 174, 3574, 0, 17, 271, 5);
INSERT INTO public.who_global_data VALUES (64149, 0, 712, 0, 13, 271, 214);
INSERT INTO public.who_global_data VALUES (64150, 1476, 30941, 28, 667, 271, 204);
INSERT INTO public.who_global_data VALUES (64151, 0, 0, 0, 0, 271, 198);
INSERT INTO public.who_global_data VALUES (64152, 212, 8282, 6, 237, 271, 173);
INSERT INTO public.who_global_data VALUES (64153, 0, 8, 0, 0, 271, 229);
INSERT INTO public.who_global_data VALUES (64154, 24, 713, 0, 10, 271, 76);
INSERT INTO public.who_global_data VALUES (64155, 3168, 65015, 100, 1814, 271, 138);
INSERT INTO public.who_global_data VALUES (64156, 184, 10794, 15, 719, 271, 98);
INSERT INTO public.who_global_data VALUES (64157, 0, 0, 0, 0, 271, 103);
INSERT INTO public.who_global_data VALUES (64158, 345, 15996, 15, 800, 271, 225);
INSERT INTO public.who_global_data VALUES (64159, 175, 27581, 9, 1135, 271, 131);
INSERT INTO public.who_global_data VALUES (64160, 25, 2198, 3, 111, 271, 235);
INSERT INTO public.who_global_data VALUES (64161, 1103, 23623, 0, 14, 271, 137);
INSERT INTO public.who_global_data VALUES (64162, 35, 10909, 0, 256, 271, 81);
INSERT INTO public.who_global_data VALUES (64163, 60, 4927, 6, 171, 271, 182);
INSERT INTO public.who_global_data VALUES (64164, 6, 436, 0, 0, 271, 145);
INSERT INTO public.who_global_data VALUES (64165, 231, 15362, 26, 952, 271, 26);
INSERT INTO public.who_global_data VALUES (64166, 11656, 221344, 94, 2009, 271, 170);
INSERT INTO public.who_global_data VALUES (64167, 4, 284, 0, 0, 271, 191);
INSERT INTO public.who_global_data VALUES (64168, 0, 2, 0, 0, 271, 221);
INSERT INTO public.who_global_data VALUES (64169, 0, 6, 0, 0, 271, 64);
INSERT INTO public.who_global_data VALUES (64170, 0, 0, 0, 0, 271, 116);
INSERT INTO public.who_global_data VALUES (64171, 0, 15, 0, 0, 271, 128);
INSERT INTO public.who_global_data VALUES (64172, 0, 18, 0, 0, 271, 6);
INSERT INTO public.who_global_data VALUES (64173, 1, 39, 0, 3, 271, 227);
INSERT INTO public.who_global_data VALUES (64174, 0, 1, 0, 0, 271, 68);
INSERT INTO public.who_global_data VALUES (64175, 0, 17, 0, 0, 271, 184);
INSERT INTO public.who_global_data VALUES (64176, 0, 0, 0, 0, 271, 82);
INSERT INTO public.who_global_data VALUES (64177, 5, 637, 0, 41, 271, 149);
INSERT INTO public.who_global_data VALUES (64178, 0, 165, 0, 4, 271, 197);
INSERT INTO public.who_global_data VALUES (64179, 1966, 41014, 9, 255, 271, 78);
INSERT INTO public.who_global_data VALUES (64180, 75, 1709, 2, 19, 271, 233);
INSERT INTO public.who_global_data VALUES (64181, 82, 10114, 2, 215, 271, 133);
INSERT INTO public.who_global_data VALUES (64182, 0, 11, 0, 0, 271, 35);
INSERT INTO public.who_global_data VALUES (64183, 16, 307, 0, 18, 271, 114);
INSERT INTO public.who_global_data VALUES (64184, 876, 23336, 0, 20, 271, 237);
INSERT INTO public.who_global_data VALUES (64185, 0, 2, 0, 0, 271, 55);
INSERT INTO public.who_global_data VALUES (64186, 0, 77, 0, 15, 271, 176);
INSERT INTO public.who_global_data VALUES (64187, 2, 1457, 0, 26, 271, 202);
INSERT INTO public.who_global_data VALUES (64188, 3, 1460, 0, 110, 271, 155);
INSERT INTO public.who_global_data VALUES (64189, 0, 0, 0, 0, 271, 32);
INSERT INTO public.who_global_data VALUES (64190, 35, 1089, 1, 52, 271, 220);
INSERT INTO public.who_global_data VALUES (64191, 595, 10015, 8, 194, 271, 30);
INSERT INTO public.who_global_data VALUES (64192, 36, 156, 0, 0, 271, 147);
INSERT INTO public.who_global_data VALUES (64193, 494, 233146, 125, 27657, 271, 208);
INSERT INTO public.who_global_data VALUES (64194, 16, 863, 0, 9, 271, 45);
INSERT INTO public.who_global_data VALUES (64195, 201, 1365, 6, 70, 271, 110);
INSERT INTO public.who_global_data VALUES (64196, 0, 10, 0, 1, 271, 88);
INSERT INTO public.who_global_data VALUES (64197, 509, 26570, 68, 3576, 271, 51);
INSERT INTO public.who_global_data VALUES (64198, 16, 30331, 7, 1679, 271, 209);
INSERT INTO public.who_global_data VALUES (64199, 0, 47, 0, 3, 271, 205);
INSERT INTO public.who_global_data VALUES (64200, 51, 612, 1, 20, 271, 18);
INSERT INTO public.who_global_data VALUES (64201, 6, 3015, 0, 56, 271, 72);
INSERT INTO public.who_global_data VALUES (64202, 2157, 208395, 217, 31392, 271, 44);
INSERT INTO public.who_global_data VALUES (64203, 0, 24, 0, 0, 271, 15);
INSERT INTO public.who_global_data VALUES (64204, 20, 173, 1, 11, 271, 25);
INSERT INTO public.who_global_data VALUES (64205, 0, 0, 0, 0, 271, 179);
INSERT INTO public.who_global_data VALUES (64206, 0, 0, 0, 0, 271, 34);
INSERT INTO public.who_global_data VALUES (64207, 0, 116, 0, 8, 271, 207);
INSERT INTO public.who_global_data VALUES (64208, 0, 1032, 0, 45, 271, 166);
INSERT INTO public.who_global_data VALUES (64209, 1542, 138657, 47, 3786, 271, 126);
INSERT INTO public.who_global_data VALUES (64210, 0, 0, 0, 0, 271, 97);
INSERT INTO public.who_global_data VALUES (64211, 0, 12, 0, 1, 271, 36);
INSERT INTO public.who_global_data VALUES (64212, 0, 0, 0, 0, 271, 125);
INSERT INTO public.who_global_data VALUES (64213, 5, 121, 0, 0, 271, 124);
INSERT INTO public.who_global_data VALUES (64214, 416, 15648, 17, 408, 271, 185);
INSERT INTO public.who_global_data VALUES (64215, 0, 18198, 0, 198, 271, 194);
INSERT INTO public.who_global_data VALUES (64216, 0, 509, 0, 21, 271, 144);
INSERT INTO public.who_global_data VALUES (64217, 26642, 1298287, 1736, 78652, 271, 19);
INSERT INTO public.who_global_data VALUES (64218, 1, 69, 0, 4, 271, 217);
INSERT INTO public.who_global_data VALUES (64219, 8, 702, 0, 17, 271, 148);
INSERT INTO public.who_global_data VALUES (64220, 24, 2411, 0, 10, 271, 86);
INSERT INTO public.who_global_data VALUES (64221, 0, 0, 0, 0, 271, 13);
INSERT INTO public.who_global_data VALUES (64222, 14, 402, 0, 10, 271, 157);
INSERT INTO public.who_global_data VALUES (64223, 0, 288, 0, 0, 271, 8);
INSERT INTO public.who_global_data VALUES (64224, 0, 0, 0, 0, 271, 73);
INSERT INTO public.who_global_data VALUES (64225, 17, 53, 1, 9, 271, 101);
INSERT INTO public.who_global_data VALUES (64226, 15, 267, 3, 7, 271, 165);
INSERT INTO public.who_global_data VALUES (64227, 1, 36, 0, 4, 271, 14);
INSERT INTO public.who_global_data VALUES (64228, 361, 4402, 4, 119, 272, 193);
INSERT INTO public.who_global_data VALUES (64229, 12, 830, 0, 30, 272, 113);
INSERT INTO public.who_global_data VALUES (64230, 189, 5558, 6, 494, 272, 143);
INSERT INTO public.who_global_data VALUES (64231, 0, 0, 0, 0, 272, 219);
INSERT INTO public.who_global_data VALUES (64232, 0, 754, 1, 48, 272, 186);
INSERT INTO public.who_global_data VALUES (64233, 7, 43, 0, 2, 272, 52);
INSERT INTO public.who_global_data VALUES (64234, 0, 3, 0, 0, 272, 180);
INSERT INTO public.who_global_data VALUES (64235, 0, 25, 0, 3, 272, 167);
INSERT INTO public.who_global_data VALUES (64236, 150, 5680, 8, 297, 272, 154);
INSERT INTO public.who_global_data VALUES (64237, 146, 3151, 1, 44, 272, 94);
INSERT INTO public.who_global_data VALUES (64238, 0, 101, 0, 3, 272, 66);
INSERT INTO public.who_global_data VALUES (64239, 15, 6929, 0, 97, 272, 58);
INSERT INTO public.who_global_data VALUES (64240, 42, 15777, 1, 615, 272, 163);
INSERT INTO public.who_global_data VALUES (64241, 143, 2422, 3, 31, 272, 37);
INSERT INTO public.who_global_data VALUES (64242, 0, 92, 0, 11, 272, 142);
INSERT INTO public.who_global_data VALUES (64243, 261, 4856, 0, 8, 272, 83);
INSERT INTO public.who_global_data VALUES (64244, 887, 14657, 14, 228, 272, 228);
INSERT INTO public.who_global_data VALUES (64245, 0, 82, 0, 7, 272, 188);
INSERT INTO public.who_global_data VALUES (64246, 1872, 22973, 10, 131, 272, 62);
INSERT INTO public.who_global_data VALUES (64247, 240, 54221, 71, 8588, 272, 160);
INSERT INTO public.who_global_data VALUES (64248, 0, 18, 0, 2, 272, 50);
INSERT INTO public.who_global_data VALUES (64249, 42, 284, 0, 2, 272, 33);
INSERT INTO public.who_global_data VALUES (64250, 0, 118, 0, 7, 272, 183);
INSERT INTO public.who_global_data VALUES (64251, 0, 7, 0, 0, 272, 92);
INSERT INTO public.who_global_data VALUES (64252, 185, 2266, 4, 106, 272, 158);
INSERT INTO public.who_global_data VALUES (64253, 0, 2, 0, 0, 272, 67);
INSERT INTO public.who_global_data VALUES (64254, 0, 2070, 0, 97, 272, 57);
INSERT INTO public.who_global_data VALUES (64255, 0, 23, 0, 1, 272, 38);
INSERT INTO public.who_global_data VALUES (64256, 10222, 145328, 751, 9897, 272, 141);
INSERT INTO public.who_global_data VALUES (64257, 0, 7, 0, 1, 272, 178);
INSERT INTO public.who_global_data VALUES (64258, 0, 141, 0, 1, 272, 108);
INSERT INTO public.who_global_data VALUES (64259, 44, 1955, 2, 90, 272, 39);
INSERT INTO public.who_global_data VALUES (64260, 12, 748, 0, 48, 272, 2);
INSERT INTO public.who_global_data VALUES (64261, 0, 19, 0, 1, 272, 195);
INSERT INTO public.who_global_data VALUES (64262, 6, 236, 0, 2, 272, 107);
INSERT INTO public.who_global_data VALUES (64263, 0, 122, 0, 0, 272, 161);
INSERT INTO public.who_global_data VALUES (64264, 70, 2335, 2, 110, 272, 212);
INSERT INTO public.who_global_data VALUES (64265, 1381, 66780, 157, 4628, 272, 181);
INSERT INTO public.who_global_data VALUES (64266, 1, 81, 0, 1, 272, 53);
INSERT INTO public.who_global_data VALUES (64267, 49, 143, 0, 0, 272, 164);
INSERT INTO public.who_global_data VALUES (64268, 62, 322, 3, 31, 272, 140);
INSERT INTO public.who_global_data VALUES (64269, 1247, 27219, 10, 304, 272, 20);
INSERT INTO public.who_global_data VALUES (64270, 14, 84430, 0, 4643, 272, 112);
INSERT INTO public.who_global_data VALUES (64271, 595, 10051, 21, 428, 272, 111);
INSERT INTO public.who_global_data VALUES (64272, 3, 11, 0, 1, 272, 71);
INSERT INTO public.who_global_data VALUES (64273, 0, 287, 0, 10, 272, 218);
INSERT INTO public.who_global_data VALUES (64274, 0, 0, 0, 0, 272, 43);
INSERT INTO public.who_global_data VALUES (64275, 8, 773, 0, 6, 272, 49);
INSERT INTO public.who_global_data VALUES (64276, 65, 1667, 1, 21, 272, 1);
INSERT INTO public.who_global_data VALUES (64277, 15, 2176, 1, 87, 272, 48);
INSERT INTO public.who_global_data VALUES (64278, 13, 1754, 0, 74, 272, 232);
INSERT INTO public.who_global_data VALUES (64279, 0, 16, 0, 1, 272, 175);
INSERT INTO public.who_global_data VALUES (64280, 1, 892, 0, 15, 272, 21);
INSERT INTO public.who_global_data VALUES (64281, 18, 8095, 3, 276, 272, 156);
INSERT INTO public.who_global_data VALUES (64282, 0, 0, 0, 0, 272, 95);
INSERT INTO public.who_global_data VALUES (64283, 54, 991, 2, 41, 272, 177);
INSERT INTO public.who_global_data VALUES (64284, 101, 10319, 4, 526, 272, 210);
INSERT INTO public.who_global_data VALUES (64285, 0, 1189, 0, 3, 272, 120);
INSERT INTO public.who_global_data VALUES (64286, 0, 16, 0, 0, 272, 135);
INSERT INTO public.who_global_data VALUES (64287, 506, 9882, 5, 385, 272, 206);
INSERT INTO public.who_global_data VALUES (64288, -1480, 28818, 50, 1704, 272, 189);
INSERT INTO public.who_global_data VALUES (64289, 924, 9400, 22, 525, 272, 129);
INSERT INTO public.who_global_data VALUES (64290, 42, 784, 1, 16, 272, 121);
INSERT INTO public.who_global_data VALUES (64291, 0, 439, 0, 4, 272, 59);
INSERT INTO public.who_global_data VALUES (64292, 0, 39, 0, 0, 272, 96);
INSERT INTO public.who_global_data VALUES (64293, 8, 1733, 4, 60, 272, 41);
INSERT INTO public.who_global_data VALUES (64294, 4, 163, 0, 2, 272, 216);
INSERT INTO public.who_global_data VALUES (64295, 16, 210, 1, 5, 272, 236);
INSERT INTO public.who_global_data VALUES (64296, 0, 13, 0, 0, 272, 150);
INSERT INTO public.who_global_data VALUES (64297, 0, 187, 0, 0, 272, 61);
INSERT INTO public.who_global_data VALUES (64298, 0, 18, 0, 0, 272, 7);
INSERT INTO public.who_global_data VALUES (64299, 142, 5880, 5, 265, 272, 169);
INSERT INTO public.who_global_data VALUES (64300, 430, 137008, 80, 26268, 272, 28);
INSERT INTO public.who_global_data VALUES (64301, 0, 141, 0, 1, 272, 85);
INSERT INTO public.who_global_data VALUES (64302, 0, 60, 0, 0, 272, 211);
INSERT INTO public.who_global_data VALUES (64303, 41, 661, 0, 8, 272, 60);
INSERT INTO public.who_global_data VALUES (64304, 0, 20, 0, 1, 272, 3);
INSERT INTO public.who_global_data VALUES (64305, 9, 635, 0, 10, 272, 11);
INSERT INTO public.who_global_data VALUES (64306, 667, 169218, 26, 7395, 272, 89);
INSERT INTO public.who_global_data VALUES (64307, 251, 4263, 4, 22, 272, 24);
INSERT INTO public.who_global_data VALUES (64308, 2, 146, 0, 0, 272, 162);
INSERT INTO public.who_global_data VALUES (64309, 19, 2710, 1, 151, 272, 100);
INSERT INTO public.who_global_data VALUES (64310, 0, 11, 0, 0, 272, 47);
INSERT INTO public.who_global_data VALUES (64311, 0, 21, 0, 0, 272, 29);
INSERT INTO public.who_global_data VALUES (64312, 0, 154, 0, 13, 272, 40);
INSERT INTO public.who_global_data VALUES (64313, 0, 147, 0, 5, 272, 222);
INSERT INTO public.who_global_data VALUES (64314, 68, 900, 1, 24, 272, 132);
INSERT INTO public.who_global_data VALUES (64315, 0, 252, 0, 13, 272, 130);
INSERT INTO public.who_global_data VALUES (64316, 33, 2042, 0, 11, 272, 234);
INSERT INTO public.who_global_data VALUES (64317, 134, 642, 1, 3, 272, 23);
INSERT INTO public.who_global_data VALUES (64318, 0, 93, 0, 10, 272, 192);
INSERT INTO public.who_global_data VALUES (64319, 17, 146, 0, 12, 272, 69);
INSERT INTO public.who_global_data VALUES (64320, 0, 12, 0, 0, 272, 187);
INSERT INTO public.who_global_data VALUES (64321, 86, 1771, 2, 107, 272, 230);
INSERT INTO public.who_global_data VALUES (64322, 50, 3263, 8, 413, 272, 77);
INSERT INTO public.who_global_data VALUES (64323, 0, 1801, 0, 10, 272, 9);
INSERT INTO public.who_global_data VALUES (64324, 3277, 62939, 128, 2109, 272, 74);
INSERT INTO public.who_global_data VALUES (64325, 387, 14032, 14, 973, 272, 224);
INSERT INTO public.who_global_data VALUES (64326, 1383, 107603, 51, 6640, 272, 199);
INSERT INTO public.who_global_data VALUES (64327, 164, 2767, 5, 109, 272, 190);
INSERT INTO public.who_global_data VALUES (64328, 219, 22760, 17, 1446, 272, 12);
INSERT INTO public.who_global_data VALUES (64329, 0, 329, 0, 23, 272, 104);
INSERT INTO public.who_global_data VALUES (64330, 33, 16346, 6, 248, 272, 153);
INSERT INTO public.who_global_data VALUES (64331, 1083, 218268, 194, 30395, 272, 91);
INSERT INTO public.who_global_data VALUES (64332, 2, 490, 0, 9, 272, 215);
INSERT INTO public.who_global_data VALUES (64333, 98, 15747, 13, 613, 272, 84);
INSERT INTO public.who_global_data VALUES (64334, 0, 293, 0, 25, 272, 231);
INSERT INTO public.who_global_data VALUES (64335, 18, 540, 0, 9, 272, 196);
INSERT INTO public.who_global_data VALUES (64336, 82, 5138, 0, 31, 272, 105);
INSERT INTO public.who_global_data VALUES (64337, 28, 649, 1, 30, 272, 122);
INSERT INTO public.who_global_data VALUES (64338, 0, 0, 0, 0, 272, 159);
INSERT INTO public.who_global_data VALUES (64339, 8, 870, 0, 19, 272, 75);
INSERT INTO public.who_global_data VALUES (64340, 1065, 8688, 9, 58, 272, 27);
INSERT INTO public.who_global_data VALUES (64341, 71, 1002, 0, 12, 272, 54);
INSERT INTO public.who_global_data VALUES (64342, 0, 19, 0, 0, 272, 226);
INSERT INTO public.who_global_data VALUES (64343, 2, 930, 0, 18, 272, 79);
INSERT INTO public.who_global_data VALUES (64344, 36, 845, 0, 26, 272, 56);
INSERT INTO public.who_global_data VALUES (64345, 0, 0, 0, 0, 272, 117);
INSERT INTO public.who_global_data VALUES (64346, 0, 199, 0, 20, 272, 152);
INSERT INTO public.who_global_data VALUES (64347, 0, 64, 0, 3, 272, 16);
INSERT INTO public.who_global_data VALUES (64348, 0, 83, 0, 1, 272, 10);
INSERT INTO public.who_global_data VALUES (64349, 12, 1471, 1, 51, 272, 201);
INSERT INTO public.who_global_data VALUES (64350, 6, 3877, 1, 101, 272, 174);
INSERT INTO public.who_global_data VALUES (64351, 0, 169, 0, 0, 272, 119);
INSERT INTO public.who_global_data VALUES (64352, 13, 56, 0, 3, 272, 168);
INSERT INTO public.who_global_data VALUES (64353, 54, 6589, 1, 108, 272, 99);
INSERT INTO public.who_global_data VALUES (64354, 41, 785, 0, 3, 272, 171);
INSERT INTO public.who_global_data VALUES (64355, 24, 692, 2, 37, 272, 87);
INSERT INTO public.who_global_data VALUES (64356, 6, 495, 0, 5, 272, 123);
INSERT INTO public.who_global_data VALUES (64357, 0, 0, 0, 0, 272, 151);
INSERT INTO public.who_global_data VALUES (64358, 3, 186, 0, 14, 272, 213);
INSERT INTO public.who_global_data VALUES (64359, 0, 8, 0, 1, 272, 118);
INSERT INTO public.who_global_data VALUES (64360, 0, 332, 0, 10, 272, 134);
INSERT INTO public.who_global_data VALUES (64361, 0, 890, 0, 11, 272, 65);
INSERT INTO public.who_global_data VALUES (64362, 1906, 31522, 199, 3160, 272, 102);
INSERT INTO public.who_global_data VALUES (64363, 0, 0, 0, 0, 272, 223);
INSERT INTO public.who_global_data VALUES (64364, 0, 66, 0, 1, 272, 4);
INSERT INTO public.who_global_data VALUES (64365, 0, 42, 0, 0, 272, 146);
INSERT INTO public.who_global_data VALUES (64366, 0, 324, 0, 9, 272, 31);
INSERT INTO public.who_global_data VALUES (64367, 0, 11, 0, 1, 272, 127);
INSERT INTO public.who_global_data VALUES (64368, 165, 6038, 2, 188, 272, 22);
INSERT INTO public.who_global_data VALUES (64369, 5, 87, 0, 0, 272, 115);
INSERT INTO public.who_global_data VALUES (64370, 1, 178, 0, 6, 272, 106);
INSERT INTO public.who_global_data VALUES (64371, 0, 16, 0, 0, 272, 90);
INSERT INTO public.who_global_data VALUES (64372, 0, 0, 0, 0, 272, 70);
INSERT INTO public.who_global_data VALUES (64373, 1, 110, 0, 0, 272, 46);
INSERT INTO public.who_global_data VALUES (64374, 288, 42128, 66, 5394, 272, 139);
INSERT INTO public.who_global_data VALUES (64375, 0, 18, 0, 0, 272, 42);
INSERT INTO public.who_global_data VALUES (64376, 2, 1144, 0, 21, 272, 80);
INSERT INTO public.who_global_data VALUES (64377, 0, 16, 0, 5, 272, 203);
INSERT INTO public.who_global_data VALUES (64378, 20, 815, 1, 45, 272, 136);
INSERT INTO public.who_global_data VALUES (64379, 239, 4151, 11, 128, 272, 63);
INSERT INTO public.who_global_data VALUES (64380, 0, 0, 0, 0, 272, 17);
INSERT INTO public.who_global_data VALUES (64381, 1, 16, 0, 2, 272, 172);
INSERT INTO public.who_global_data VALUES (64382, 36, 1622, 1, 91, 272, 109);
INSERT INTO public.who_global_data VALUES (64383, 35, 8069, 0, 213, 272, 200);
INSERT INTO public.who_global_data VALUES (64384, 0, 547, 0, 4, 272, 93);
INSERT INTO public.who_global_data VALUES (64385, 176, 3400, 0, 17, 272, 5);
INSERT INTO public.who_global_data VALUES (64386, 0, 712, 0, 13, 272, 214);
INSERT INTO public.who_global_data VALUES (64387, 1991, 29465, 21, 639, 272, 204);
INSERT INTO public.who_global_data VALUES (64388, 0, 0, 0, 0, 272, 198);
INSERT INTO public.who_global_data VALUES (64389, 202, 8070, 6, 231, 272, 173);
INSERT INTO public.who_global_data VALUES (64390, 0, 8, 0, 0, 272, 229);
INSERT INTO public.who_global_data VALUES (64391, 126, 689, 0, 10, 272, 76);
INSERT INTO public.who_global_data VALUES (64392, 3321, 61847, 87, 1714, 272, 138);
INSERT INTO public.who_global_data VALUES (64393, 147, 10610, 8, 704, 272, 98);
INSERT INTO public.who_global_data VALUES (64394, 0, 0, 0, 0, 272, 103);
INSERT INTO public.who_global_data VALUES (64395, 285, 15651, 9, 785, 272, 225);
INSERT INTO public.who_global_data VALUES (64396, 138, 27406, 12, 1126, 272, 131);
INSERT INTO public.who_global_data VALUES (64397, 17, 2173, 52, 108, 272, 235);
INSERT INTO public.who_global_data VALUES (64398, 1189, 22520, 1, 14, 272, 137);
INSERT INTO public.who_global_data VALUES (64399, 34, 10874, 0, 256, 272, 81);
INSERT INTO public.who_global_data VALUES (64400, 139, 4867, 6, 165, 272, 182);
INSERT INTO public.who_global_data VALUES (64401, 0, 430, 0, 0, 272, 145);
INSERT INTO public.who_global_data VALUES (64402, 320, 15131, 28, 926, 272, 26);
INSERT INTO public.who_global_data VALUES (64403, 11012, 209688, 88, 1915, 272, 170);
INSERT INTO public.who_global_data VALUES (64404, 7, 280, 0, 0, 272, 191);
INSERT INTO public.who_global_data VALUES (64405, 0, 2, 0, 0, 272, 221);
INSERT INTO public.who_global_data VALUES (64406, 0, 6, 0, 0, 272, 64);
INSERT INTO public.who_global_data VALUES (64407, 0, 0, 0, 0, 272, 116);
INSERT INTO public.who_global_data VALUES (64408, 0, 15, 0, 0, 272, 128);
INSERT INTO public.who_global_data VALUES (64409, 0, 18, 0, 0, 272, 6);
INSERT INTO public.who_global_data VALUES (64410, 0, 38, 0, 3, 272, 227);
INSERT INTO public.who_global_data VALUES (64411, 0, 1, 0, 0, 272, 68);
INSERT INTO public.who_global_data VALUES (64412, 0, 17, 0, 0, 272, 184);
INSERT INTO public.who_global_data VALUES (64413, 0, 0, 0, 0, 272, 82);
INSERT INTO public.who_global_data VALUES (64414, 0, 632, 0, 41, 272, 149);
INSERT INTO public.who_global_data VALUES (64415, -43, 165, -1, 4, 272, 197);
INSERT INTO public.who_global_data VALUES (64416, 1912, 39048, 7, 246, 272, 78);
INSERT INTO public.who_global_data VALUES (64417, 83, 1634, 4, 17, 272, 233);
INSERT INTO public.who_global_data VALUES (64418, 89, 10032, 4, 213, 272, 133);
INSERT INTO public.who_global_data VALUES (64419, 0, 11, 0, 0, 272, 35);
INSERT INTO public.who_global_data VALUES (64420, 34, 291, 1, 18, 272, 114);
INSERT INTO public.who_global_data VALUES (64421, 753, 22460, 0, 20, 272, 237);
INSERT INTO public.who_global_data VALUES (64422, 0, 2, 0, 0, 272, 55);
INSERT INTO public.who_global_data VALUES (64423, 1, 77, 1, 15, 272, 176);
INSERT INTO public.who_global_data VALUES (64424, 0, 1455, 0, 26, 272, 202);
INSERT INTO public.who_global_data VALUES (64425, 3, 1457, 1, 110, 272, 155);
INSERT INTO public.who_global_data VALUES (64426, 0, 0, 0, 0, 272, 32);
INSERT INTO public.who_global_data VALUES (64427, 57, 1054, 3, 51, 272, 220);
INSERT INTO public.who_global_data VALUES (64428, 525, 9420, 8, 186, 272, 30);
INSERT INTO public.who_global_data VALUES (64429, 0, 120, 0, 0, 272, 147);
INSERT INTO public.who_global_data VALUES (64430, 923, 232652, 146, 27532, 272, 208);
INSERT INTO public.who_global_data VALUES (64431, 12, 847, 0, 9, 272, 45);
INSERT INTO public.who_global_data VALUES (64432, 53, 1164, 5, 64, 272, 110);
INSERT INTO public.who_global_data VALUES (64433, 0, 10, 0, 1, 272, 88);
INSERT INTO public.who_global_data VALUES (64434, 701, 26061, 60, 3508, 272, 51);
INSERT INTO public.who_global_data VALUES (64435, 39, 30315, 5, 1672, 272, 209);
INSERT INTO public.who_global_data VALUES (64436, 0, 47, 0, 3, 272, 205);
INSERT INTO public.who_global_data VALUES (64437, 39, 561, 1, 19, 272, 18);
INSERT INTO public.who_global_data VALUES (64438, 5, 3009, 0, 56, 272, 72);
INSERT INTO public.who_global_data VALUES (64439, 3063, 206238, 275, 31175, 272, 44);
INSERT INTO public.who_global_data VALUES (64440, 0, 24, 0, 0, 272, 15);
INSERT INTO public.who_global_data VALUES (64441, 8, 153, 0, 10, 272, 25);
INSERT INTO public.who_global_data VALUES (64442, 0, 0, 0, 0, 272, 179);
INSERT INTO public.who_global_data VALUES (64443, 0, 0, 0, 0, 272, 34);
INSERT INTO public.who_global_data VALUES (64444, 0, 116, 0, 8, 272, 207);
INSERT INTO public.who_global_data VALUES (64445, 2, 1032, 0, 45, 272, 166);
INSERT INTO public.who_global_data VALUES (64446, 1546, 137115, 50, 3739, 272, 126);
INSERT INTO public.who_global_data VALUES (64447, 0, 0, 0, 0, 272, 97);
INSERT INTO public.who_global_data VALUES (64448, 0, 12, 0, 1, 272, 36);
INSERT INTO public.who_global_data VALUES (64449, 0, 0, 0, 0, 272, 125);
INSERT INTO public.who_global_data VALUES (64450, 15, 116, 0, 0, 272, 124);
INSERT INTO public.who_global_data VALUES (64451, 522, 15232, 15, 391, 272, 185);
INSERT INTO public.who_global_data VALUES (64452, 1405, 18198, 24, 198, 272, 194);
INSERT INTO public.who_global_data VALUES (64453, 0, 509, 0, 21, 272, 144);
INSERT INTO public.who_global_data VALUES (64454, 25870, 1271645, 1552, 76916, 272, 19);
INSERT INTO public.who_global_data VALUES (64455, 0, 68, 0, 4, 272, 217);
INSERT INTO public.who_global_data VALUES (64456, 10, 694, 0, 17, 272, 148);
INSERT INTO public.who_global_data VALUES (64457, 51, 2387, 0, 10, 272, 86);
INSERT INTO public.who_global_data VALUES (64458, 0, 0, 0, 0, 272, 13);
INSERT INTO public.who_global_data VALUES (64459, 7, 388, 0, 10, 272, 157);
INSERT INTO public.who_global_data VALUES (64460, 0, 288, 0, 0, 272, 8);
INSERT INTO public.who_global_data VALUES (64461, 0, 0, 0, 0, 272, 73);
INSERT INTO public.who_global_data VALUES (64462, 0, 36, 0, 8, 272, 101);
INSERT INTO public.who_global_data VALUES (64463, 85, 252, 0, 4, 272, 165);
INSERT INTO public.who_global_data VALUES (64464, 1, 35, 0, 4, 272, 14);
INSERT INTO public.who_global_data VALUES (64465, 478, 4041, 10, 115, 273, 193);
INSERT INTO public.who_global_data VALUES (64466, 6, 818, 0, 30, 273, 113);
INSERT INTO public.who_global_data VALUES (64467, 187, 5369, 5, 488, 273, 143);
INSERT INTO public.who_global_data VALUES (64468, 0, 0, 0, 0, 273, 219);
INSERT INTO public.who_global_data VALUES (64469, 2, 754, 0, 47, 273, 186);
INSERT INTO public.who_global_data VALUES (64470, 0, 36, 0, 2, 273, 52);
INSERT INTO public.who_global_data VALUES (64471, 0, 3, 0, 0, 273, 180);
INSERT INTO public.who_global_data VALUES (64472, 0, 25, 0, 3, 273, 167);
INSERT INTO public.who_global_data VALUES (64473, 225, 5530, 14, 289, 273, 154);
INSERT INTO public.who_global_data VALUES (64474, 145, 3005, 1, 43, 273, 94);
INSERT INTO public.who_global_data VALUES (64475, 0, 101, 1, 3, 273, 66);
INSERT INTO public.who_global_data VALUES (64476, 18, 6914, 0, 97, 273, 58);
INSERT INTO public.who_global_data VALUES (64477, 62, 15735, 5, 614, 273, 163);
INSERT INTO public.who_global_data VALUES (64478, 75, 2279, 0, 28, 273, 37);
INSERT INTO public.who_global_data VALUES (64479, 0, 92, 0, 11, 273, 142);
INSERT INTO public.who_global_data VALUES (64480, 191, 4595, 0, 8, 273, 83);
INSERT INTO public.who_global_data VALUES (64481, 636, 13770, 8, 214, 273, 228);
INSERT INTO public.who_global_data VALUES (64482, 0, 82, 0, 7, 273, 188);
INSERT INTO public.who_global_data VALUES (64483, 933, 21101, 5, 121, 273, 62);
INSERT INTO public.who_global_data VALUES (64484, 483, 53981, 73, 8517, 273, 160);
INSERT INTO public.who_global_data VALUES (64485, 0, 18, 0, 2, 273, 50);
INSERT INTO public.who_global_data VALUES (64486, 102, 242, 0, 2, 273, 33);
INSERT INTO public.who_global_data VALUES (64487, 0, 118, 0, 7, 273, 183);
INSERT INTO public.who_global_data VALUES (64488, 0, 7, 0, 0, 273, 92);
INSERT INTO public.who_global_data VALUES (64489, 195, 2081, 11, 102, 273, 158);
INSERT INTO public.who_global_data VALUES (64490, 0, 2, 0, 0, 273, 67);
INSERT INTO public.who_global_data VALUES (64491, 43, 2070, 8, 97, 273, 57);
INSERT INTO public.who_global_data VALUES (64492, 0, 23, 0, 1, 273, 38);
INSERT INTO public.who_global_data VALUES (64493, 9888, 135106, 610, 9146, 273, 141);
INSERT INTO public.who_global_data VALUES (64494, 0, 7, 0, 1, 273, 178);
INSERT INTO public.who_global_data VALUES (64495, 0, 141, 0, 1, 273, 108);
INSERT INTO public.who_global_data VALUES (64496, 82, 1911, 4, 88, 273, 39);
INSERT INTO public.who_global_data VALUES (64497, 0, 736, 0, 48, 273, 2);
INSERT INTO public.who_global_data VALUES (64498, 0, 19, 0, 1, 273, 195);
INSERT INTO public.who_global_data VALUES (64499, 12, 230, 0, 2, 273, 107);
INSERT INTO public.who_global_data VALUES (64500, 0, 122, 0, 0, 273, 161);
INSERT INTO public.who_global_data VALUES (64501, 0, 2265, 0, 108, 273, 212);
INSERT INTO public.who_global_data VALUES (64502, 1504, 65399, 191, 4471, 273, 181);
INSERT INTO public.who_global_data VALUES (64503, 2, 80, 0, 1, 273, 53);
INSERT INTO public.who_global_data VALUES (64504, 0, 94, 0, 0, 273, 164);
INSERT INTO public.who_global_data VALUES (64505, 7, 260, 1, 28, 273, 140);
INSERT INTO public.who_global_data VALUES (64506, 1391, 25972, 9, 294, 273, 20);
INSERT INTO public.who_global_data VALUES (64507, 1, 84416, 0, 4643, 273, 112);
INSERT INTO public.who_global_data VALUES (64508, 497, 9456, 10, 407, 273, 111);
INSERT INTO public.who_global_data VALUES (64509, 0, 8, 0, 1, 273, 71);
INSERT INTO public.who_global_data VALUES (64510, 13, 287, 0, 10, 273, 218);
INSERT INTO public.who_global_data VALUES (64511, 0, 0, 0, 0, 273, 43);
INSERT INTO public.who_global_data VALUES (64512, 4, 765, 0, 6, 273, 49);
INSERT INTO public.who_global_data VALUES (64513, 31, 1602, 0, 20, 273, 1);
INSERT INTO public.who_global_data VALUES (64514, 36, 2161, 0, 86, 273, 48);
INSERT INTO public.who_global_data VALUES (64515, 12, 1741, 1, 74, 273, 232);
INSERT INTO public.who_global_data VALUES (64516, 0, 16, 0, 1, 273, 175);
INSERT INTO public.who_global_data VALUES (64517, 2, 891, 0, 15, 273, 21);
INSERT INTO public.who_global_data VALUES (64518, 46, 8077, 3, 273, 273, 156);
INSERT INTO public.who_global_data VALUES (64519, 0, 0, 0, 0, 273, 95);
INSERT INTO public.who_global_data VALUES (64520, 40, 937, 3, 39, 273, 177);
INSERT INTO public.who_global_data VALUES (64521, 135, 10218, 8, 522, 273, 210);
INSERT INTO public.who_global_data VALUES (64522, 54, 1189, 0, 3, 273, 120);
INSERT INTO public.who_global_data VALUES (64523, 0, 16, 0, 0, 273, 135);
INSERT INTO public.who_global_data VALUES (64524, 281, 9376, 7, 380, 273, 206);
INSERT INTO public.who_global_data VALUES (64525, 0, 30298, 0, 1654, 273, 189);
INSERT INTO public.who_global_data VALUES (64526, 495, 8476, 21, 503, 273, 129);
INSERT INTO public.who_global_data VALUES (64527, 47, 742, 0, 15, 273, 121);
INSERT INTO public.who_global_data VALUES (64528, 0, 439, 0, 4, 273, 59);
INSERT INTO public.who_global_data VALUES (64529, 0, 39, 0, 0, 273, 96);
INSERT INTO public.who_global_data VALUES (64530, 5, 1725, 0, 56, 273, 41);
INSERT INTO public.who_global_data VALUES (64531, 6, 159, 0, 2, 273, 216);
INSERT INTO public.who_global_data VALUES (64532, 3, 194, 0, 4, 273, 236);
INSERT INTO public.who_global_data VALUES (64533, 0, 13, 0, 0, 273, 150);
INSERT INTO public.who_global_data VALUES (64534, 0, 187, 0, 0, 273, 61);
INSERT INTO public.who_global_data VALUES (64535, 0, 18, 0, 0, 273, 7);
INSERT INTO public.who_global_data VALUES (64536, 65, 5738, 5, 260, 273, 169);
INSERT INTO public.who_global_data VALUES (64537, 598, 136578, 242, 26188, 273, 28);
INSERT INTO public.who_global_data VALUES (64538, 3, 141, 0, 1, 273, 85);
INSERT INTO public.who_global_data VALUES (64539, 0, 60, 0, 0, 273, 211);
INSERT INTO public.who_global_data VALUES (64540, 116, 620, 0, 8, 273, 60);
INSERT INTO public.who_global_data VALUES (64541, 2, 20, 0, 1, 273, 3);
INSERT INTO public.who_global_data VALUES (64542, 3, 626, 1, 10, 273, 11);
INSERT INTO public.who_global_data VALUES (64543, 1251, 168551, 103, 7369, 273, 89);
INSERT INTO public.who_global_data VALUES (64544, 921, 4012, 0, 18, 273, 24);
INSERT INTO public.who_global_data VALUES (64545, 0, 144, 0, 0, 273, 162);
INSERT INTO public.who_global_data VALUES (64546, 13, 2691, 2, 150, 273, 100);
INSERT INTO public.who_global_data VALUES (64547, 0, 11, 0, 0, 273, 47);
INSERT INTO public.who_global_data VALUES (64548, 0, 21, 0, 0, 273, 29);
INSERT INTO public.who_global_data VALUES (64549, 1, 154, 0, 13, 273, 40);
INSERT INTO public.who_global_data VALUES (64550, 0, 147, 0, 5, 273, 222);
INSERT INTO public.who_global_data VALUES (64551, 34, 832, 2, 23, 273, 132);
INSERT INTO public.who_global_data VALUES (64552, 0, 252, 0, 13, 273, 130);
INSERT INTO public.who_global_data VALUES (64553, 82, 2009, 0, 11, 273, 234);
INSERT INTO public.who_global_data VALUES (64554, 0, 508, 0, 2, 273, 23);
INSERT INTO public.who_global_data VALUES (64555, 0, 93, 0, 10, 273, 192);
INSERT INTO public.who_global_data VALUES (64556, 21, 129, 0, 12, 273, 69);
INSERT INTO public.who_global_data VALUES (64557, 0, 12, 0, 0, 273, 187);
INSERT INTO public.who_global_data VALUES (64558, 224, 1685, 6, 105, 273, 230);
INSERT INTO public.who_global_data VALUES (64559, 35, 3213, 13, 405, 273, 77);
INSERT INTO public.who_global_data VALUES (64560, 0, 1801, 0, 10, 273, 9);
INSERT INTO public.who_global_data VALUES (64561, 3320, 59662, 95, 1981, 273, 74);
INSERT INTO public.who_global_data VALUES (64562, 533, 13645, 16, 959, 273, 224);
INSERT INTO public.who_global_data VALUES (64563, 1529, 106220, 48, 6589, 273, 199);
INSERT INTO public.who_global_data VALUES (64564, 60, 2603, 2, 104, 273, 190);
INSERT INTO public.who_global_data VALUES (64565, 156, 22541, 26, 1429, 273, 12);
INSERT INTO public.who_global_data VALUES (64566, 2, 329, 0, 23, 273, 104);
INSERT INTO public.who_global_data VALUES (64567, 61, 16313, 1, 242, 273, 153);
INSERT INTO public.who_global_data VALUES (64568, 1327, 217185, 243, 30201, 273, 91);
INSERT INTO public.who_global_data VALUES (64569, 10, 488, 0, 9, 273, 215);
INSERT INTO public.who_global_data VALUES (64570, 102, 15649, 43, 600, 273, 84);
INSERT INTO public.who_global_data VALUES (64571, 0, 293, 0, 25, 273, 231);
INSERT INTO public.who_global_data VALUES (64572, 28, 522, 0, 9, 273, 196);
INSERT INTO public.who_global_data VALUES (64573, 134, 5056, 0, 31, 273, 105);
INSERT INTO public.who_global_data VALUES (64574, 14, 621, 0, 29, 273, 122);
INSERT INTO public.who_global_data VALUES (64575, 0, 0, 0, 0, 273, 159);
INSERT INTO public.who_global_data VALUES (64576, 1, 862, 0, 19, 273, 75);
INSERT INTO public.who_global_data VALUES (64577, 415, 7623, 2, 49, 273, 27);
INSERT INTO public.who_global_data VALUES (64578, 25, 931, 0, 12, 273, 54);
INSERT INTO public.who_global_data VALUES (64579, 0, 19, 0, 0, 273, 226);
INSERT INTO public.who_global_data VALUES (64580, 19, 928, 0, 18, 273, 79);
INSERT INTO public.who_global_data VALUES (64581, 13, 809, 0, 26, 273, 56);
INSERT INTO public.who_global_data VALUES (64582, 0, 0, 0, 0, 273, 117);
INSERT INTO public.who_global_data VALUES (64583, 10, 199, 0, 20, 273, 152);
INSERT INTO public.who_global_data VALUES (64584, 0, 64, 0, 3, 273, 16);
INSERT INTO public.who_global_data VALUES (64585, 0, 83, 0, 1, 273, 10);
INSERT INTO public.who_global_data VALUES (64586, 29, 1459, 1, 50, 273, 201);
INSERT INTO public.who_global_data VALUES (64587, 12, 3871, 0, 100, 273, 174);
INSERT INTO public.who_global_data VALUES (64588, -24, 169, 0, 0, 273, 119);
INSERT INTO public.who_global_data VALUES (64589, 0, 43, 0, 3, 273, 168);
INSERT INTO public.who_global_data VALUES (64590, 68, 6535, 0, 107, 273, 99);
INSERT INTO public.who_global_data VALUES (64591, 96, 744, 0, 3, 273, 171);
INSERT INTO public.who_global_data VALUES (64592, 18, 668, 3, 35, 273, 87);
INSERT INTO public.who_global_data VALUES (64593, 1, 489, 0, 5, 273, 123);
INSERT INTO public.who_global_data VALUES (64594, 0, 0, 0, 0, 273, 151);
INSERT INTO public.who_global_data VALUES (64595, 1, 183, 0, 14, 273, 213);
INSERT INTO public.who_global_data VALUES (64596, 0, 8, 0, 1, 273, 118);
INSERT INTO public.who_global_data VALUES (64597, 0, 332, 0, 10, 273, 134);
INSERT INTO public.who_global_data VALUES (64598, 36, 890, 1, 11, 273, 65);
INSERT INTO public.who_global_data VALUES (64599, 1982, 29616, 257, 2961, 273, 102);
INSERT INTO public.who_global_data VALUES (64600, 0, 0, 0, 0, 273, 223);
INSERT INTO public.who_global_data VALUES (64601, 0, 66, 0, 1, 273, 4);
INSERT INTO public.who_global_data VALUES (64602, 0, 42, 0, 0, 273, 146);
INSERT INTO public.who_global_data VALUES (64603, 0, 324, 1, 9, 273, 31);
INSERT INTO public.who_global_data VALUES (64604, 0, 11, 0, 1, 273, 127);
INSERT INTO public.who_global_data VALUES (64605, 212, 5873, 1, 186, 273, 22);
INSERT INTO public.who_global_data VALUES (64606, 1, 82, 0, 0, 273, 115);
INSERT INTO public.who_global_data VALUES (64607, 1, 177, 0, 6, 273, 106);
INSERT INTO public.who_global_data VALUES (64608, 0, 16, 0, 0, 273, 90);
INSERT INTO public.who_global_data VALUES (64609, 0, 0, 0, 0, 273, 70);
INSERT INTO public.who_global_data VALUES (64610, 7, 109, 0, 0, 273, 46);
INSERT INTO public.who_global_data VALUES (64611, 320, 41840, 76, 5328, 273, 139);
INSERT INTO public.who_global_data VALUES (64612, 0, 18, 0, 0, 273, 42);
INSERT INTO public.who_global_data VALUES (64613, 1, 1142, 0, 21, 273, 80);
INSERT INTO public.who_global_data VALUES (64614, 0, 16, 0, 5, 273, 203);
INSERT INTO public.who_global_data VALUES (64615, 14, 795, 2, 44, 273, 136);
INSERT INTO public.who_global_data VALUES (64616, 386, 3912, 10, 117, 273, 63);
INSERT INTO public.who_global_data VALUES (64617, 0, 0, 0, 0, 273, 17);
INSERT INTO public.who_global_data VALUES (64618, 0, 15, 0, 2, 273, 172);
INSERT INTO public.who_global_data VALUES (64619, 14, 1586, 1, 90, 273, 109);
INSERT INTO public.who_global_data VALUES (64620, 39, 8034, 4, 213, 273, 200);
INSERT INTO public.who_global_data VALUES (64621, 0, 547, 0, 4, 273, 93);
INSERT INTO public.who_global_data VALUES (64622, 112, 3224, 2, 17, 273, 5);
INSERT INTO public.who_global_data VALUES (64623, 0, 712, 0, 13, 273, 214);
INSERT INTO public.who_global_data VALUES (64624, 1039, 27474, 19, 618, 273, 204);
INSERT INTO public.who_global_data VALUES (64625, 0, 0, 0, 0, 273, 198);
INSERT INTO public.who_global_data VALUES (64626, 137, 7868, 7, 225, 273, 173);
INSERT INTO public.who_global_data VALUES (64627, 0, 8, 0, 0, 273, 229);
INSERT INTO public.who_global_data VALUES (64628, 101, 563, 0, 10, 273, 76);
INSERT INTO public.who_global_data VALUES (64629, 3709, 58526, 94, 1627, 273, 138);
INSERT INTO public.who_global_data VALUES (64630, 120, 10463, 11, 696, 273, 98);
INSERT INTO public.who_global_data VALUES (64631, 0, 0, 0, 0, 273, 103);
INSERT INTO public.who_global_data VALUES (64632, 319, 15366, 21, 776, 273, 225);
INSERT INTO public.who_global_data VALUES (64633, 553, 27268, 9, 1114, 273, 131);
INSERT INTO public.who_global_data VALUES (64634, 125, 2156, 0, 56, 273, 235);
INSERT INTO public.who_global_data VALUES (64635, 1130, 21331, 1, 13, 273, 137);
INSERT INTO public.who_global_data VALUES (64636, 18, 10840, 0, 256, 273, 81);
INSERT INTO public.who_global_data VALUES (64637, 123, 4728, 14, 159, 273, 182);
INSERT INTO public.who_global_data VALUES (64638, 3, 430, 0, 0, 273, 145);
INSERT INTO public.who_global_data VALUES (64639, 312, 14811, 22, 898, 273, 26);
INSERT INTO public.who_global_data VALUES (64640, 10817, 198676, 104, 1827, 273, 170);
INSERT INTO public.who_global_data VALUES (64641, 2, 273, 0, 0, 273, 191);
INSERT INTO public.who_global_data VALUES (64642, 0, 2, 0, 0, 273, 221);
INSERT INTO public.who_global_data VALUES (64643, 0, 6, 0, 0, 273, 64);
INSERT INTO public.who_global_data VALUES (64644, 0, 0, 0, 0, 273, 116);
INSERT INTO public.who_global_data VALUES (64645, 0, 15, 0, 0, 273, 128);
INSERT INTO public.who_global_data VALUES (64646, 0, 18, 0, 0, 273, 6);
INSERT INTO public.who_global_data VALUES (64647, 0, 38, 0, 3, 273, 227);
INSERT INTO public.who_global_data VALUES (64648, 0, 1, 0, 0, 273, 68);
INSERT INTO public.who_global_data VALUES (64649, 0, 17, 0, 0, 273, 184);
INSERT INTO public.who_global_data VALUES (64650, 0, 0, 0, 0, 273, 82);
INSERT INTO public.who_global_data VALUES (64651, 0, 632, 0, 41, 273, 149);
INSERT INTO public.who_global_data VALUES (64652, 43, 208, 1, 5, 273, 197);
INSERT INTO public.who_global_data VALUES (64653, 1704, 37136, 10, 239, 273, 78);
INSERT INTO public.who_global_data VALUES (64654, 59, 1551, 0, 13, 273, 233);
INSERT INTO public.who_global_data VALUES (64655, 95, 9943, 3, 209, 273, 133);
INSERT INTO public.who_global_data VALUES (64656, 0, 11, 0, 0, 273, 35);
INSERT INTO public.who_global_data VALUES (64657, 26, 257, 3, 17, 273, 114);
INSERT INTO public.who_global_data VALUES (64658, 768, 21707, 0, 20, 273, 237);
INSERT INTO public.who_global_data VALUES (64659, 0, 2, 0, 0, 273, 55);
INSERT INTO public.who_global_data VALUES (64660, 0, 76, 0, 14, 273, 176);
INSERT INTO public.who_global_data VALUES (64661, 10, 1455, 0, 26, 273, 202);
INSERT INTO public.who_global_data VALUES (64662, 4, 1454, 1, 109, 273, 155);
INSERT INTO public.who_global_data VALUES (64663, 0, 0, 0, 0, 273, 32);
INSERT INTO public.who_global_data VALUES (64664, 69, 997, 4, 48, 273, 220);
INSERT INTO public.who_global_data VALUES (64665, 663, 8895, 17, 178, 273, 30);
INSERT INTO public.who_global_data VALUES (64666, 30, 120, 0, 0, 273, 147);
INSERT INTO public.who_global_data VALUES (64667, 961, 231729, 166, 27386, 273, 208);
INSERT INTO public.who_global_data VALUES (64668, 11, 835, 0, 9, 273, 45);
INSERT INTO public.who_global_data VALUES (64669, 181, 1111, 7, 59, 273, 110);
INSERT INTO public.who_global_data VALUES (64670, 0, 10, 0, 1, 273, 88);
INSERT INTO public.who_global_data VALUES (64671, 785, 25360, 80, 3448, 273, 51);
INSERT INTO public.who_global_data VALUES (64672, 59, 30276, 7, 1667, 273, 209);
INSERT INTO public.who_global_data VALUES (64673, 2, 47, 0, 3, 273, 205);
INSERT INTO public.who_global_data VALUES (64674, 61, 522, 2, 18, 273, 18);
INSERT INTO public.who_global_data VALUES (64675, 4, 3004, 1, 56, 273, 72);
INSERT INTO public.who_global_data VALUES (64676, 3767, 203175, 579, 30900, 273, 44);
INSERT INTO public.who_global_data VALUES (64677, 0, 24, 0, 0, 273, 15);
INSERT INTO public.who_global_data VALUES (64678, 10, 145, 1, 10, 273, 25);
INSERT INTO public.who_global_data VALUES (64679, 0, 0, 0, 0, 273, 179);
INSERT INTO public.who_global_data VALUES (64680, 0, 0, 0, 0, 273, 34);
INSERT INTO public.who_global_data VALUES (64681, 0, 116, 0, 8, 273, 207);
INSERT INTO public.who_global_data VALUES (64682, 4, 1030, 1, 45, 273, 166);
INSERT INTO public.who_global_data VALUES (64683, 1848, 135569, 48, 3689, 273, 126);
INSERT INTO public.who_global_data VALUES (64684, 0, 0, 0, 0, 273, 97);
INSERT INTO public.who_global_data VALUES (64685, 0, 12, 0, 1, 273, 36);
INSERT INTO public.who_global_data VALUES (64686, 0, 0, 0, 0, 273, 125);
INSERT INTO public.who_global_data VALUES (64687, 0, 101, 0, 0, 273, 124);
INSERT INTO public.who_global_data VALUES (64688, 515, 14710, 15, 376, 273, 185);
INSERT INTO public.who_global_data VALUES (64689, 0, 16793, 0, 174, 273, 194);
INSERT INTO public.who_global_data VALUES (64690, 0, 509, 0, 21, 273, 144);
INSERT INTO public.who_global_data VALUES (64691, 30204, 1245775, 2840, 75364, 273, 19);
INSERT INTO public.who_global_data VALUES (64692, 2, 68, 0, 4, 273, 217);
INSERT INTO public.who_global_data VALUES (64693, 11, 684, 0, 17, 273, 148);
INSERT INTO public.who_global_data VALUES (64694, 22, 2336, 0, 10, 273, 86);
INSERT INTO public.who_global_data VALUES (64695, 0, 0, 0, 0, 273, 13);
INSERT INTO public.who_global_data VALUES (64696, 2, 381, 0, 10, 273, 157);
INSERT INTO public.who_global_data VALUES (64697, 0, 288, 0, 0, 273, 8);
INSERT INTO public.who_global_data VALUES (64698, 0, 0, 0, 0, 273, 73);
INSERT INTO public.who_global_data VALUES (64699, 1, 36, 1, 8, 273, 101);
INSERT INTO public.who_global_data VALUES (64700, 14, 167, 0, 4, 273, 165);
INSERT INTO public.who_global_data VALUES (64701, 0, 34, 0, 4, 273, 14);
INSERT INTO public.who_global_data VALUES (64702, 0, 3563, 0, 105, 274, 193);
INSERT INTO public.who_global_data VALUES (64703, 18, 812, 0, 30, 274, 113);
INSERT INTO public.who_global_data VALUES (64704, 185, 5182, 7, 483, 274, 143);
INSERT INTO public.who_global_data VALUES (64705, 0, 0, 0, 0, 274, 219);
INSERT INTO public.who_global_data VALUES (64706, 0, 752, 0, 47, 274, 186);
INSERT INTO public.who_global_data VALUES (64707, 0, 36, 0, 2, 274, 52);
INSERT INTO public.who_global_data VALUES (64708, 0, 3, 0, 0, 274, 180);
INSERT INTO public.who_global_data VALUES (64709, 0, 25, 0, 3, 274, 167);
INSERT INTO public.who_global_data VALUES (64710, 229, 5305, 11, 275, 274, 154);
INSERT INTO public.who_global_data VALUES (64711, 102, 2860, 2, 42, 274, 94);
INSERT INTO public.who_global_data VALUES (64712, 0, 101, 0, 2, 274, 66);
INSERT INTO public.who_global_data VALUES (64713, 21, 6896, 0, 97, 274, 58);
INSERT INTO public.who_global_data VALUES (64714, 22, 15673, 1, 609, 274, 163);
INSERT INTO public.who_global_data VALUES (64715, 77, 2204, 0, 28, 274, 37);
INSERT INTO public.who_global_data VALUES (64716, 3, 92, 0, 11, 274, 142);
INSERT INTO public.who_global_data VALUES (64717, 273, 4404, 0, 8, 274, 83);
INSERT INTO public.who_global_data VALUES (64718, 709, 13134, 20, 206, 274, 228);
INSERT INTO public.who_global_data VALUES (64719, 0, 82, 0, 7, 274, 188);
INSERT INTO public.who_global_data VALUES (64720, 913, 20168, 4, 116, 274, 62);
INSERT INTO public.who_global_data VALUES (64721, 442, 53498, 70, 8444, 274, 160);
INSERT INTO public.who_global_data VALUES (64722, 0, 18, 0, 2, 274, 50);
INSERT INTO public.who_global_data VALUES (64723, 38, 140, 0, 2, 274, 33);
INSERT INTO public.who_global_data VALUES (64724, 3, 118, 0, 7, 274, 183);
INSERT INTO public.who_global_data VALUES (64725, 0, 7, 0, 0, 274, 92);
INSERT INTO public.who_global_data VALUES (64726, 84, 1886, 5, 91, 274, 158);
INSERT INTO public.who_global_data VALUES (64727, 0, 2, 0, 0, 274, 67);
INSERT INTO public.who_global_data VALUES (64728, 10, 2027, 2, 89, 274, 57);
INSERT INTO public.who_global_data VALUES (64729, 0, 23, 0, 1, 274, 38);
INSERT INTO public.who_global_data VALUES (64730, 10503, 125218, 615, 8536, 274, 141);
INSERT INTO public.who_global_data VALUES (64731, 0, 7, 0, 1, 274, 178);
INSERT INTO public.who_global_data VALUES (64732, 2, 141, 0, 1, 274, 108);
INSERT INTO public.who_global_data VALUES (64733, 51, 1829, 0, 84, 274, 39);
INSERT INTO public.who_global_data VALUES (64734, 7, 736, 0, 48, 274, 2);
INSERT INTO public.who_global_data VALUES (64735, 0, 19, 0, 1, 274, 195);
INSERT INTO public.who_global_data VALUES (64736, 27, 218, 0, 2, 274, 107);
INSERT INTO public.who_global_data VALUES (64737, 0, 122, 0, 0, 274, 161);
INSERT INTO public.who_global_data VALUES (64738, 0, 2265, 0, 108, 274, 212);
INSERT INTO public.who_global_data VALUES (64739, 1437, 63895, 169, 4280, 274, 181);
INSERT INTO public.who_global_data VALUES (64740, 0, 78, 0, 1, 274, 53);
INSERT INTO public.who_global_data VALUES (64741, 0, 94, 0, 0, 274, 164);
INSERT INTO public.who_global_data VALUES (64742, 83, 253, 10, 27, 274, 140);
INSERT INTO public.who_global_data VALUES (64743, 1533, 24581, 4, 285, 274, 20);
INSERT INTO public.who_global_data VALUES (64744, 6, 84415, 0, 4643, 274, 112);
INSERT INTO public.who_global_data VALUES (64745, 346, 8959, 19, 397, 274, 111);
INSERT INTO public.who_global_data VALUES (64746, 0, 8, 0, 1, 274, 71);
INSERT INTO public.who_global_data VALUES (64747, 10, 274, 0, 10, 274, 218);
INSERT INTO public.who_global_data VALUES (64748, 0, 0, 0, 0, 274, 43);
INSERT INTO public.who_global_data VALUES (64749, 6, 761, 0, 6, 274, 49);
INSERT INTO public.who_global_data VALUES (64750, 55, 1571, 2, 20, 274, 1);
INSERT INTO public.who_global_data VALUES (64751, 6, 2125, 1, 86, 274, 48);
INSERT INTO public.who_global_data VALUES (64752, 26, 1729, 4, 73, 274, 232);
INSERT INTO public.who_global_data VALUES (64753, 0, 16, 0, 1, 274, 175);
INSERT INTO public.who_global_data VALUES (64754, 6, 889, 0, 15, 274, 21);
INSERT INTO public.who_global_data VALUES (64755, 57, 8031, 8, 270, 274, 156);
INSERT INTO public.who_global_data VALUES (64756, 0, 0, 0, 0, 274, 95);
INSERT INTO public.who_global_data VALUES (64757, 100, 897, 1, 36, 274, 177);
INSERT INTO public.who_global_data VALUES (64758, 100, 10083, 8, 514, 274, 210);
INSERT INTO public.who_global_data VALUES (64759, 2, 1135, 0, 3, 274, 120);
INSERT INTO public.who_global_data VALUES (64760, 0, 16, 0, 0, 274, 135);
INSERT INTO public.who_global_data VALUES (64761, 288, 9095, 11, 373, 274, 206);
INSERT INTO public.who_global_data VALUES (64762, 878, 30298, 36, 1654, 274, 189);
INSERT INTO public.who_global_data VALUES (64763, 393, 7981, 13, 482, 274, 129);
INSERT INTO public.who_global_data VALUES (64764, 62, 695, 1, 15, 274, 121);
INSERT INTO public.who_global_data VALUES (64765, 0, 439, 0, 4, 274, 59);
INSERT INTO public.who_global_data VALUES (64766, 0, 39, 0, 0, 274, 96);
INSERT INTO public.who_global_data VALUES (64767, 7, 1720, 1, 56, 274, 41);
INSERT INTO public.who_global_data VALUES (64768, 30, 153, 0, 2, 274, 216);
INSERT INTO public.who_global_data VALUES (64769, 29, 191, 0, 4, 274, 236);
INSERT INTO public.who_global_data VALUES (64770, 0, 13, 0, 0, 274, 150);
INSERT INTO public.who_global_data VALUES (64771, 0, 187, 0, 0, 274, 61);
INSERT INTO public.who_global_data VALUES (64772, 0, 18, 0, 0, 274, 7);
INSERT INTO public.who_global_data VALUES (64773, 100, 5673, 3, 255, 274, 169);
INSERT INTO public.who_global_data VALUES (64774, 512, 135980, 177, 25946, 274, 28);
INSERT INTO public.who_global_data VALUES (64775, 0, 138, 0, 1, 274, 85);
INSERT INTO public.who_global_data VALUES (64776, 0, 60, 0, 0, 274, 211);
INSERT INTO public.who_global_data VALUES (64777, 107, 504, 2, 8, 274, 60);
INSERT INTO public.who_global_data VALUES (64778, 1, 18, 0, 1, 274, 3);
INSERT INTO public.who_global_data VALUES (64779, 9, 623, 0, 9, 274, 11);
INSERT INTO public.who_global_data VALUES (64780, 1209, 167300, 147, 7266, 274, 89);
INSERT INTO public.who_global_data VALUES (64781, 372, 3091, 0, 18, 274, 24);
INSERT INTO public.who_global_data VALUES (64782, 0, 144, 0, 0, 274, 162);
INSERT INTO public.who_global_data VALUES (64783, 15, 2678, 1, 148, 274, 100);
INSERT INTO public.who_global_data VALUES (64784, 0, 11, 0, 0, 274, 47);
INSERT INTO public.who_global_data VALUES (64785, 0, 21, 0, 0, 274, 29);
INSERT INTO public.who_global_data VALUES (64786, 0, 153, 0, 13, 274, 40);
INSERT INTO public.who_global_data VALUES (64787, 0, 147, 0, 5, 274, 222);
INSERT INTO public.who_global_data VALUES (64788, 35, 798, 2, 21, 274, 132);
INSERT INTO public.who_global_data VALUES (64789, 0, 252, 0, 13, 274, 130);
INSERT INTO public.who_global_data VALUES (64790, 71, 1927, 0, 11, 274, 234);
INSERT INTO public.who_global_data VALUES (64791, 0, 508, 0, 2, 274, 23);
INSERT INTO public.who_global_data VALUES (64792, 0, 93, 0, 10, 274, 192);
INSERT INTO public.who_global_data VALUES (64793, 7, 108, 0, 12, 274, 69);
INSERT INTO public.who_global_data VALUES (64794, 0, 12, 0, 0, 274, 187);
INSERT INTO public.who_global_data VALUES (64795, 191, 1461, 6, 99, 274, 230);
INSERT INTO public.who_global_data VALUES (64796, 28, 3178, 9, 392, 274, 77);
INSERT INTO public.who_global_data VALUES (64797, 2, 1801, 0, 10, 274, 9);
INSERT INTO public.who_global_data VALUES (64798, 3390, 56342, 103, 1886, 274, 74);
INSERT INTO public.who_global_data VALUES (64799, 336, 13112, 13, 943, 274, 224);
INSERT INTO public.who_global_data VALUES (64800, 1556, 104691, 55, 6541, 274, 199);
INSERT INTO public.who_global_data VALUES (64801, 63, 2543, 0, 102, 274, 190);
INSERT INTO public.who_global_data VALUES (64802, 137, 22385, 28, 1403, 274, 12);
INSERT INTO public.who_global_data VALUES (64803, 1, 327, 0, 23, 274, 104);
INSERT INTO public.who_global_data VALUES (64804, 65, 16252, 1, 241, 274, 153);
INSERT INTO public.who_global_data VALUES (64805, 1401, 215858, 274, 29958, 274, 91);
INSERT INTO public.who_global_data VALUES (64806, 5, 478, 0, 9, 274, 215);
INSERT INTO public.who_global_data VALUES (64807, 84, 15547, 6, 557, 274, 84);
INSERT INTO public.who_global_data VALUES (64808, 0, 293, 1, 25, 274, 231);
INSERT INTO public.who_global_data VALUES (64809, 10, 494, 0, 9, 274, 196);
INSERT INTO public.who_global_data VALUES (64810, 344, 4922, 1, 31, 274, 105);
INSERT INTO public.who_global_data VALUES (64811, 25, 607, 3, 29, 274, 122);
INSERT INTO public.who_global_data VALUES (64812, 0, 0, 0, 0, 274, 159);
INSERT INTO public.who_global_data VALUES (64813, 1, 861, 1, 19, 274, 75);
INSERT INTO public.who_global_data VALUES (64814, 641, 7208, 3, 47, 274, 27);
INSERT INTO public.who_global_data VALUES (64815, 11, 906, 0, 12, 274, 54);
INSERT INTO public.who_global_data VALUES (64816, 0, 19, 0, 0, 274, 226);
INSERT INTO public.who_global_data VALUES (64817, 9, 909, 1, 18, 274, 79);
INSERT INTO public.who_global_data VALUES (64818, 12, 796, 1, 26, 274, 56);
INSERT INTO public.who_global_data VALUES (64819, 0, 0, 0, 0, 274, 117);
INSERT INTO public.who_global_data VALUES (64820, 11, 189, 0, 20, 274, 152);
INSERT INTO public.who_global_data VALUES (64821, 0, 64, 0, 3, 274, 16);
INSERT INTO public.who_global_data VALUES (64822, 0, 83, 0, 1, 274, 10);
INSERT INTO public.who_global_data VALUES (64823, 9, 1430, 0, 49, 274, 201);
INSERT INTO public.who_global_data VALUES (64824, 8, 3859, 2, 100, 274, 174);
INSERT INTO public.who_global_data VALUES (64825, 0, 193, 0, 0, 274, 119);
INSERT INTO public.who_global_data VALUES (64826, 0, 43, 0, 3, 274, 168);
INSERT INTO public.who_global_data VALUES (64827, 39, 6467, 0, 107, 274, 99);
INSERT INTO public.who_global_data VALUES (64828, 30, 648, 1, 3, 274, 171);
INSERT INTO public.who_global_data VALUES (64829, 19, 650, 0, 32, 274, 87);
INSERT INTO public.who_global_data VALUES (64830, 3, 488, 0, 5, 274, 123);
INSERT INTO public.who_global_data VALUES (64831, 0, 0, 0, 0, 274, 151);
INSERT INTO public.who_global_data VALUES (64832, 0, 182, 0, 14, 274, 213);
INSERT INTO public.who_global_data VALUES (64833, 0, 8, 0, 1, 274, 118);
INSERT INTO public.who_global_data VALUES (64834, 0, 332, 0, 10, 274, 134);
INSERT INTO public.who_global_data VALUES (64835, 115, 854, 1, 10, 274, 65);
INSERT INTO public.who_global_data VALUES (64836, 1609, 27634, 197, 2704, 274, 102);
INSERT INTO public.who_global_data VALUES (64837, 0, 0, 0, 0, 274, 223);
INSERT INTO public.who_global_data VALUES (64838, 0, 66, 0, 1, 274, 4);
INSERT INTO public.who_global_data VALUES (64839, 1, 42, 0, 0, 274, 146);
INSERT INTO public.who_global_data VALUES (64840, 0, 324, 0, 8, 274, 31);
INSERT INTO public.who_global_data VALUES (64841, 0, 11, 0, 1, 274, 127);
INSERT INTO public.who_global_data VALUES (64842, 156, 5661, 2, 185, 274, 22);
INSERT INTO public.who_global_data VALUES (64843, 0, 81, 0, 0, 274, 115);
INSERT INTO public.who_global_data VALUES (64844, 14, 176, 0, 6, 274, 106);
INSERT INTO public.who_global_data VALUES (64845, 0, 16, 0, 0, 274, 90);
INSERT INTO public.who_global_data VALUES (64846, 0, 0, 0, 0, 274, 70);
INSERT INTO public.who_global_data VALUES (64847, 3, 102, 0, 0, 274, 46);
INSERT INTO public.who_global_data VALUES (64848, 361, 41520, 89, 5252, 274, 139);
INSERT INTO public.who_global_data VALUES (64849, 0, 18, 0, 0, 274, 42);
INSERT INTO public.who_global_data VALUES (64850, 2, 1141, 0, 21, 274, 80);
INSERT INTO public.who_global_data VALUES (64851, 0, 16, 0, 5, 274, 203);
INSERT INTO public.who_global_data VALUES (64852, 11, 781, 4, 42, 274, 136);
INSERT INTO public.who_global_data VALUES (64853, 381, 3526, 4, 107, 274, 63);
INSERT INTO public.who_global_data VALUES (64854, 0, 0, 0, 0, 274, 17);
INSERT INTO public.who_global_data VALUES (64855, 0, 15, 0, 2, 274, 172);
INSERT INTO public.who_global_data VALUES (64856, 33, 1572, 1, 89, 274, 109);
INSERT INTO public.who_global_data VALUES (64857, 42, 7995, 0, 209, 274, 200);
INSERT INTO public.who_global_data VALUES (64858, 0, 547, 0, 4, 274, 93);
INSERT INTO public.who_global_data VALUES (64859, 154, 3112, 1, 15, 274, 5);
INSERT INTO public.who_global_data VALUES (64860, 0, 712, 0, 13, 274, 214);
INSERT INTO public.who_global_data VALUES (64861, 1791, 26435, 14, 599, 274, 204);
INSERT INTO public.who_global_data VALUES (64862, 0, 0, 0, 0, 274, 198);
INSERT INTO public.who_global_data VALUES (64863, 208, 7731, 8, 218, 274, 173);
INSERT INTO public.who_global_data VALUES (64864, 0, 8, 0, 0, 274, 229);
INSERT INTO public.who_global_data VALUES (64865, 22, 462, 0, 10, 274, 76);
INSERT INTO public.who_global_data VALUES (64866, 3628, 54817, 89, 1533, 274, 138);
INSERT INTO public.who_global_data VALUES (64867, 339, 10343, 27, 685, 274, 98);
INSERT INTO public.who_global_data VALUES (64868, 0, 0, 0, 0, 274, 103);
INSERT INTO public.who_global_data VALUES (64869, 307, 15047, 22, 755, 274, 225);
INSERT INTO public.who_global_data VALUES (64870, 533, 26715, 16, 1105, 274, 131);
INSERT INTO public.who_global_data VALUES (64871, 63, 2031, 0, 56, 274, 235);
INSERT INTO public.who_global_data VALUES (64872, 1311, 20201, 0, 12, 274, 137);
INSERT INTO public.who_global_data VALUES (64873, 12, 10822, 0, 256, 274, 81);
INSERT INTO public.who_global_data VALUES (64874, 129, 4605, 2, 145, 274, 182);
INSERT INTO public.who_global_data VALUES (64875, 2, 427, 0, 0, 274, 145);
INSERT INTO public.who_global_data VALUES (64876, 392, 14499, 18, 876, 274, 26);
INSERT INTO public.who_global_data VALUES (64877, 10699, 187859, 98, 1723, 274, 170);
INSERT INTO public.who_global_data VALUES (64878, 3, 271, 0, 0, 274, 191);
INSERT INTO public.who_global_data VALUES (64879, 0, 2, 0, 0, 274, 221);
INSERT INTO public.who_global_data VALUES (64880, 0, 6, 0, 0, 274, 64);
INSERT INTO public.who_global_data VALUES (64881, 0, 0, 0, 0, 274, 116);
INSERT INTO public.who_global_data VALUES (64882, 0, 15, 0, 0, 274, 128);
INSERT INTO public.who_global_data VALUES (64883, 0, 18, 0, 0, 274, 6);
INSERT INTO public.who_global_data VALUES (64884, 0, 38, 0, 3, 274, 227);
INSERT INTO public.who_global_data VALUES (64885, 0, 1, 0, 0, 274, 68);
INSERT INTO public.who_global_data VALUES (64886, 0, 17, 0, 0, 274, 184);
INSERT INTO public.who_global_data VALUES (64887, 0, 0, 0, 0, 274, 82);
INSERT INTO public.who_global_data VALUES (64888, 24, 632, 0, 41, 274, 149);
INSERT INTO public.who_global_data VALUES (64889, -9, 165, 1, 4, 274, 197);
INSERT INTO public.who_global_data VALUES (64890, 1701, 35432, 10, 229, 274, 78);
INSERT INTO public.who_global_data VALUES (64891, 59, 1492, 1, 13, 274, 233);
INSERT INTO public.who_global_data VALUES (64892, 57, 9848, 3, 206, 274, 133);
INSERT INTO public.who_global_data VALUES (64893, 0, 11, 0, 0, 274, 35);
INSERT INTO public.who_global_data VALUES (64894, 6, 231, 0, 14, 274, 114);
INSERT INTO public.who_global_data VALUES (64895, 741, 20939, 0, 20, 274, 237);
INSERT INTO public.who_global_data VALUES (64896, 0, 2, 0, 0, 274, 55);
INSERT INTO public.who_global_data VALUES (64897, 0, 76, 0, 14, 274, 176);
INSERT INTO public.who_global_data VALUES (64898, 16, 1445, 1, 26, 274, 202);
INSERT INTO public.who_global_data VALUES (64899, 1, 1450, 1, 108, 274, 155);
INSERT INTO public.who_global_data VALUES (64900, 0, 0, 0, 0, 274, 32);
INSERT INTO public.who_global_data VALUES (64901, 0, 928, 0, 44, 274, 220);
INSERT INTO public.who_global_data VALUES (64902, 424, 8232, 8, 161, 274, 30);
INSERT INTO public.who_global_data VALUES (64903, 32, 90, 0, 0, 274, 147);
INSERT INTO public.who_global_data VALUES (64904, 981, 230768, 153, 27220, 274, 208);
INSERT INTO public.who_global_data VALUES (64905, 27, 824, 0, 9, 274, 45);
INSERT INTO public.who_global_data VALUES (64906, 0, 930, 0, 52, 274, 110);
INSERT INTO public.who_global_data VALUES (64907, 0, 10, 0, 1, 274, 88);
INSERT INTO public.who_global_data VALUES (64908, 745, 24575, 73, 3368, 274, 51);
INSERT INTO public.who_global_data VALUES (64909, 46, 30217, 12, 1660, 274, 209);
INSERT INTO public.who_global_data VALUES (64910, 0, 45, 0, 3, 274, 205);
INSERT INTO public.who_global_data VALUES (64911, 82, 461, 7, 16, 274, 18);
INSERT INTO public.who_global_data VALUES (64912, 8, 3000, 0, 55, 274, 72);
INSERT INTO public.who_global_data VALUES (64913, 3827, 199408, 458, 30321, 274, 44);
INSERT INTO public.who_global_data VALUES (64914, 0, 24, 0, 0, 274, 15);
INSERT INTO public.who_global_data VALUES (64915, 7, 135, 0, 9, 274, 25);
INSERT INTO public.who_global_data VALUES (64916, 0, 0, 0, 0, 274, 179);
INSERT INTO public.who_global_data VALUES (64917, 0, 0, 0, 0, 274, 34);
INSERT INTO public.who_global_data VALUES (64918, 0, 116, 0, 8, 274, 207);
INSERT INTO public.who_global_data VALUES (64919, 1, 1026, 1, 44, 274, 166);
INSERT INTO public.who_global_data VALUES (64920, 1977, 133721, 57, 3641, 274, 126);
INSERT INTO public.who_global_data VALUES (64921, 0, 0, 0, 0, 274, 97);
INSERT INTO public.who_global_data VALUES (64922, 0, 12, 0, 1, 274, 36);
INSERT INTO public.who_global_data VALUES (64923, 0, 0, 0, 0, 274, 125);
INSERT INTO public.who_global_data VALUES (64924, 3, 101, 0, 0, 274, 124);
INSERT INTO public.who_global_data VALUES (64925, 504, 14195, 21, 361, 274, 185);
INSERT INTO public.who_global_data VALUES (64926, 553, 16793, 9, 174, 274, 194);
INSERT INTO public.who_global_data VALUES (64927, 29, 509, 3, 21, 274, 144);
INSERT INTO public.who_global_data VALUES (64928, 22119, 1215571, 1968, 72524, 274, 19);
INSERT INTO public.who_global_data VALUES (64929, 0, 66, 0, 4, 274, 217);
INSERT INTO public.who_global_data VALUES (64930, 3, 673, 0, 17, 274, 148);
INSERT INTO public.who_global_data VALUES (64931, 48, 2314, 0, 10, 274, 86);
INSERT INTO public.who_global_data VALUES (64932, 0, 0, 0, 0, 274, 13);
INSERT INTO public.who_global_data VALUES (64933, 12, 379, 0, 10, 274, 157);
INSERT INTO public.who_global_data VALUES (64934, 0, 288, 0, 0, 274, 8);
INSERT INTO public.who_global_data VALUES (64935, 0, 0, 0, 0, 274, 73);
INSERT INTO public.who_global_data VALUES (64936, 9, 35, 1, 7, 274, 101);
INSERT INTO public.who_global_data VALUES (64937, 14, 153, 0, 4, 274, 165);
INSERT INTO public.who_global_data VALUES (64938, 0, 34, 0, 4, 274, 14);
INSERT INTO public.who_global_data VALUES (64939, 171, 3563, 1, 105, 275, 193);
INSERT INTO public.who_global_data VALUES (64940, 0, 794, 0, 30, 275, 113);
INSERT INTO public.who_global_data VALUES (64941, 159, 4997, 6, 476, 275, 143);
INSERT INTO public.who_global_data VALUES (64942, 0, 0, 0, 0, 275, 219);
INSERT INTO public.who_global_data VALUES (64943, 1, 752, 1, 47, 275, 186);
INSERT INTO public.who_global_data VALUES (64944, 0, 36, 0, 2, 275, 52);
INSERT INTO public.who_global_data VALUES (64945, 0, 3, 0, 0, 275, 180);
INSERT INTO public.who_global_data VALUES (64946, 0, 25, 0, 3, 275, 167);
INSERT INTO public.who_global_data VALUES (64947, 154, 5076, 2, 264, 275, 154);
INSERT INTO public.who_global_data VALUES (64948, 163, 2758, 0, 40, 275, 94);
INSERT INTO public.who_global_data VALUES (64949, 0, 101, 0, 2, 275, 66);
INSERT INTO public.who_global_data VALUES (64950, 26, 6875, 1, 97, 275, 58);
INSERT INTO public.who_global_data VALUES (64951, 65, 15651, 2, 608, 275, 163);
INSERT INTO public.who_global_data VALUES (64952, 67, 2127, 2, 28, 275, 37);
INSERT INTO public.who_global_data VALUES (64953, 5, 89, 0, 11, 275, 142);
INSERT INTO public.who_global_data VALUES (64954, 289, 4131, 0, 8, 275, 83);
INSERT INTO public.who_global_data VALUES (64955, 706, 12425, 0, 186, 275, 228);
INSERT INTO public.who_global_data VALUES (64956, 0, 82, 0, 7, 275, 188);
INSERT INTO public.who_global_data VALUES (64957, 0, 19255, 0, 112, 275, 62);
INSERT INTO public.who_global_data VALUES (64958, 552, 53056, 75, 8374, 275, 160);
INSERT INTO public.who_global_data VALUES (64959, 0, 18, 0, 2, 275, 50);
INSERT INTO public.who_global_data VALUES (64960, 0, 102, 0, 2, 275, 33);
INSERT INTO public.who_global_data VALUES (64961, 0, 115, 0, 7, 275, 183);
INSERT INTO public.who_global_data VALUES (64962, 0, 7, 0, 0, 275, 92);
INSERT INTO public.who_global_data VALUES (64963, 121, 1802, 4, 86, 275, 158);
INSERT INTO public.who_global_data VALUES (64964, 0, 2, 0, 0, 275, 67);
INSERT INTO public.who_global_data VALUES (64965, 49, 2017, 5, 87, 275, 57);
INSERT INTO public.who_global_data VALUES (64966, 0, 23, 0, 1, 275, 38);
INSERT INTO public.who_global_data VALUES (64967, 6935, 114715, 600, 7921, 275, 141);
INSERT INTO public.who_global_data VALUES (64968, 0, 7, 0, 1, 275, 178);
INSERT INTO public.who_global_data VALUES (64969, 1, 139, 0, 1, 275, 108);
INSERT INTO public.who_global_data VALUES (64970, 89, 1778, 6, 84, 275, 39);
INSERT INTO public.who_global_data VALUES (64971, 40, 729, 0, 48, 275, 2);
INSERT INTO public.who_global_data VALUES (64972, 0, 19, 0, 1, 275, 195);
INSERT INTO public.who_global_data VALUES (64973, 5, 191, 0, 2, 275, 107);
INSERT INTO public.who_global_data VALUES (64974, 0, 122, 0, 0, 275, 161);
INSERT INTO public.who_global_data VALUES (64975, 0, 2265, 0, 108, 275, 212);
INSERT INTO public.who_global_data VALUES (64976, 1299, 62458, 196, 4111, 275, 181);
INSERT INTO public.who_global_data VALUES (64977, 3, 78, 0, 1, 275, 53);
INSERT INTO public.who_global_data VALUES (64978, 0, 94, 0, 0, 275, 164);
INSERT INTO public.who_global_data VALUES (64979, 0, 170, 0, 17, 275, 140);
INSERT INTO public.who_global_data VALUES (64980, 1032, 23048, 6, 281, 275, 20);
INSERT INTO public.who_global_data VALUES (64981, 3, 84409, 0, 4643, 275, 112);
INSERT INTO public.who_global_data VALUES (64982, 640, 8613, 20, 378, 275, 111);
INSERT INTO public.who_global_data VALUES (64983, 4, 8, 0, 1, 275, 71);
INSERT INTO public.who_global_data VALUES (64984, 28, 264, 0, 10, 275, 218);
INSERT INTO public.who_global_data VALUES (64985, 0, 0, 0, 0, 275, 43);
INSERT INTO public.who_global_data VALUES (64986, 13, 755, 0, 6, 275, 49);
INSERT INTO public.who_global_data VALUES (64987, 52, 1516, 0, 18, 275, 1);
INSERT INTO public.who_global_data VALUES (64988, 7, 2119, 2, 85, 275, 48);
INSERT INTO public.who_global_data VALUES (64989, 18, 1703, 0, 69, 275, 232);
INSERT INTO public.who_global_data VALUES (64990, 0, 16, 0, 1, 275, 175);
INSERT INTO public.who_global_data VALUES (64991, 5, 883, 0, 15, 275, 21);
INSERT INTO public.who_global_data VALUES (64992, 78, 7974, 5, 262, 275, 156);
INSERT INTO public.who_global_data VALUES (64993, 0, 0, 0, 0, 275, 95);
INSERT INTO public.who_global_data VALUES (64994, 92, 797, 1, 35, 275, 177);
INSERT INTO public.who_global_data VALUES (64995, 162, 9983, 3, 506, 275, 210);
INSERT INTO public.who_global_data VALUES (64996, 13, 1133, 1, 3, 275, 120);
INSERT INTO public.who_global_data VALUES (64997, 0, 16, 0, 0, 275, 135);
INSERT INTO public.who_global_data VALUES (64998, 327, 8807, 8, 362, 275, 206);
INSERT INTO public.who_global_data VALUES (64999, -2461, 29420, 49, 1618, 275, 189);
INSERT INTO public.who_global_data VALUES (65000, 0, 7588, 0, 469, 275, 129);
INSERT INTO public.who_global_data VALUES (65001, 46, 633, 1, 14, 275, 121);
INSERT INTO public.who_global_data VALUES (65002, 0, 439, 0, 4, 275, 59);
INSERT INTO public.who_global_data VALUES (65003, 0, 39, 0, 0, 275, 96);
INSERT INTO public.who_global_data VALUES (65004, 2, 1713, 0, 55, 275, 41);
INSERT INTO public.who_global_data VALUES (65005, 4, 123, 1, 2, 275, 216);
INSERT INTO public.who_global_data VALUES (65006, 17, 162, 0, 4, 275, 236);
INSERT INTO public.who_global_data VALUES (65007, 0, 13, 0, 0, 275, 150);
INSERT INTO public.who_global_data VALUES (65008, 0, 187, 0, 0, 275, 61);
INSERT INTO public.who_global_data VALUES (65009, 0, 18, 0, 0, 275, 7);
INSERT INTO public.who_global_data VALUES (65010, 161, 5573, 6, 252, 275, 169);
INSERT INTO public.who_global_data VALUES (65011, 4176, 135468, 278, 25769, 275, 28);
INSERT INTO public.who_global_data VALUES (65012, 5, 138, 0, 1, 275, 85);
INSERT INTO public.who_global_data VALUES (65013, 0, 60, 0, 0, 275, 211);
INSERT INTO public.who_global_data VALUES (65014, 0, 397, 0, 6, 275, 60);
INSERT INTO public.who_global_data VALUES (65015, 0, 17, 0, 1, 275, 3);
INSERT INTO public.who_global_data VALUES (65016, 4, 614, 0, 9, 275, 11);
INSERT INTO public.who_global_data VALUES (65017, 1284, 166091, 123, 7119, 275, 89);
INSERT INTO public.who_global_data VALUES (65018, 0, 2719, 0, 18, 275, 24);
INSERT INTO public.who_global_data VALUES (65019, 0, 144, 0, 0, 275, 162);
INSERT INTO public.who_global_data VALUES (65020, 21, 2663, 1, 147, 275, 100);
INSERT INTO public.who_global_data VALUES (65021, 0, 11, 0, 0, 275, 47);
INSERT INTO public.who_global_data VALUES (65022, 0, 21, 0, 0, 275, 29);
INSERT INTO public.who_global_data VALUES (65023, 1, 153, 0, 13, 275, 40);
INSERT INTO public.who_global_data VALUES (65024, 2, 147, 0, 5, 275, 222);
INSERT INTO public.who_global_data VALUES (65025, 33, 763, 0, 19, 275, 132);
INSERT INTO public.who_global_data VALUES (65026, 0, 252, 0, 13, 275, 130);
INSERT INTO public.who_global_data VALUES (65027, 45, 1856, 1, 11, 275, 234);
INSERT INTO public.who_global_data VALUES (65028, 216, 508, 0, 2, 275, 23);
INSERT INTO public.who_global_data VALUES (65029, 1, 93, 1, 10, 275, 192);
INSERT INTO public.who_global_data VALUES (65030, 1, 101, 1, 12, 275, 69);
INSERT INTO public.who_global_data VALUES (65031, 1, 12, 0, 0, 275, 187);
INSERT INTO public.who_global_data VALUES (65032, 92, 1270, 4, 93, 275, 230);
INSERT INTO public.who_global_data VALUES (65033, 39, 3150, 10, 383, 275, 77);
INSERT INTO public.who_global_data VALUES (65034, 0, 1799, 0, 10, 275, 9);
INSERT INTO public.who_global_data VALUES (65035, 3561, 52952, 89, 1783, 275, 74);
INSERT INTO public.who_global_data VALUES (65036, 338, 12776, 35, 930, 275, 224);
INSERT INTO public.who_global_data VALUES (65037, 1485, 103135, 68, 6486, 275, 199);
INSERT INTO public.who_global_data VALUES (65038, 49, 2480, 0, 102, 275, 190);
INSERT INTO public.who_global_data VALUES (65039, 265, 22248, 36, 1375, 275, 12);
INSERT INTO public.who_global_data VALUES (65040, 1, 326, 0, 23, 275, 104);
INSERT INTO public.who_global_data VALUES (65041, 32, 16187, 2, 240, 275, 153);
INSERT INTO public.who_global_data VALUES (65042, 1444, 214457, 369, 29684, 275, 91);
INSERT INTO public.who_global_data VALUES (65043, 2, 473, 0, 9, 275, 215);
INSERT INTO public.who_global_data VALUES (65044, 109, 15463, 8, 551, 275, 84);
INSERT INTO public.who_global_data VALUES (65045, 0, 293, 0, 24, 275, 231);
INSERT INTO public.who_global_data VALUES (65046, 11, 484, 0, 9, 275, 196);
INSERT INTO public.who_global_data VALUES (65047, 69, 4578, 0, 30, 275, 105);
INSERT INTO public.who_global_data VALUES (65048, 47, 582, 0, 26, 275, 122);
INSERT INTO public.who_global_data VALUES (65049, 0, 0, 0, 0, 275, 159);
INSERT INTO public.who_global_data VALUES (65050, 4, 860, 1, 18, 275, 75);
INSERT INTO public.who_global_data VALUES (65051, 278, 6567, 2, 44, 275, 27);
INSERT INTO public.who_global_data VALUES (65052, 24, 895, 0, 12, 275, 54);
INSERT INTO public.who_global_data VALUES (65053, 0, 19, 0, 0, 275, 226);
INSERT INTO public.who_global_data VALUES (65054, 4, 900, 0, 17, 275, 79);
INSERT INTO public.who_global_data VALUES (65055, 34, 784, 0, 25, 275, 56);
INSERT INTO public.who_global_data VALUES (65056, 0, 0, 0, 0, 275, 117);
INSERT INTO public.who_global_data VALUES (65057, 8, 178, 0, 20, 275, 152);
INSERT INTO public.who_global_data VALUES (65058, 0, 64, 0, 3, 275, 16);
INSERT INTO public.who_global_data VALUES (65059, 0, 83, 0, 1, 275, 10);
INSERT INTO public.who_global_data VALUES (65060, 5, 1421, 1, 49, 275, 201);
INSERT INTO public.who_global_data VALUES (65061, 11, 3851, 2, 98, 275, 174);
INSERT INTO public.who_global_data VALUES (65062, 35, 193, 0, 0, 275, 119);
INSERT INTO public.who_global_data VALUES (65063, 2, 43, 0, 3, 275, 168);
INSERT INTO public.who_global_data VALUES (65064, 45, 6428, 1, 107, 275, 99);
INSERT INTO public.who_global_data VALUES (65065, 0, 618, 0, 2, 275, 171);
INSERT INTO public.who_global_data VALUES (65066, 19, 631, 0, 32, 275, 87);
INSERT INTO public.who_global_data VALUES (65067, 2, 485, 0, 5, 275, 123);
INSERT INTO public.who_global_data VALUES (65068, 0, 0, 0, 0, 275, 151);
INSERT INTO public.who_global_data VALUES (65069, 1, 182, 0, 14, 275, 213);
INSERT INTO public.who_global_data VALUES (65070, 0, 8, 0, 1, 275, 118);
INSERT INTO public.who_global_data VALUES (65071, 0, 332, 0, 10, 275, 134);
INSERT INTO public.who_global_data VALUES (65072, 0, 739, 0, 9, 275, 65);
INSERT INTO public.who_global_data VALUES (65073, 1120, 26025, 236, 2507, 275, 102);
INSERT INTO public.who_global_data VALUES (65074, 0, 0, 0, 0, 275, 223);
INSERT INTO public.who_global_data VALUES (65075, 0, 66, 0, 1, 275, 4);
INSERT INTO public.who_global_data VALUES (65076, 0, 41, 0, 0, 275, 146);
INSERT INTO public.who_global_data VALUES (65077, 0, 324, 0, 8, 275, 31);
INSERT INTO public.who_global_data VALUES (65078, 0, 11, 0, 1, 275, 127);
INSERT INTO public.who_global_data VALUES (65079, 123, 5505, 1, 183, 275, 22);
INSERT INTO public.who_global_data VALUES (65080, 1, 81, 0, 0, 275, 115);
INSERT INTO public.who_global_data VALUES (65081, 1, 162, 0, 6, 275, 106);
INSERT INTO public.who_global_data VALUES (65082, 0, 16, 0, 0, 275, 90);
INSERT INTO public.who_global_data VALUES (65083, 0, 0, 0, 0, 275, 70);
INSERT INTO public.who_global_data VALUES (65084, 0, 99, 0, 0, 275, 46);
INSERT INTO public.who_global_data VALUES (65085, 319, 41159, 33, 5163, 275, 139);
INSERT INTO public.who_global_data VALUES (65086, 0, 18, 0, 0, 275, 42);
INSERT INTO public.who_global_data VALUES (65087, 1, 1139, 0, 21, 275, 80);
INSERT INTO public.who_global_data VALUES (65088, 1, 16, 0, 5, 275, 203);
INSERT INTO public.who_global_data VALUES (65089, 7, 770, 0, 38, 275, 136);
INSERT INTO public.who_global_data VALUES (65090, 195, 3145, 5, 103, 275, 63);
INSERT INTO public.who_global_data VALUES (65091, 0, 0, 0, 0, 275, 17);
INSERT INTO public.who_global_data VALUES (65092, 1, 15, 0, 2, 275, 172);
INSERT INTO public.who_global_data VALUES (65093, 13, 1539, 2, 88, 275, 109);
INSERT INTO public.who_global_data VALUES (65094, 50, 7953, 0, 209, 275, 200);
INSERT INTO public.who_global_data VALUES (65095, 1, 547, 0, 4, 275, 93);
INSERT INTO public.who_global_data VALUES (65096, 55, 2958, 1, 14, 275, 5);
INSERT INTO public.who_global_data VALUES (65097, 0, 712, 0, 13, 275, 214);
INSERT INTO public.who_global_data VALUES (65098, 2094, 24644, 59, 585, 275, 204);
INSERT INTO public.who_global_data VALUES (65099, 0, 0, 0, 0, 275, 198);
INSERT INTO public.who_global_data VALUES (65100, 136, 7523, 7, 210, 275, 173);
INSERT INTO public.who_global_data VALUES (65101, 0, 8, 0, 0, 275, 229);
INSERT INTO public.who_global_data VALUES (65102, 9, 440, 0, 10, 275, 76);
INSERT INTO public.who_global_data VALUES (65103, 3817, 51189, 100, 1444, 275, 138);
INSERT INTO public.who_global_data VALUES (65104, 320, 10004, 21, 658, 275, 98);
INSERT INTO public.who_global_data VALUES (65105, 0, 0, 0, 0, 275, 103);
INSERT INTO public.who_global_data VALUES (65106, 309, 14740, 17, 733, 275, 225);
INSERT INTO public.who_global_data VALUES (65107, 480, 26182, 15, 1089, 275, 131);
INSERT INTO public.who_global_data VALUES (65108, 44, 1968, 0, 56, 275, 235);
INSERT INTO public.who_global_data VALUES (65109, 918, 18890, 0, 12, 275, 137);
INSERT INTO public.who_global_data VALUES (65110, 4, 10810, 1, 256, 275, 81);
INSERT INTO public.who_global_data VALUES (65111, 113, 4476, 3, 143, 275, 182);
INSERT INTO public.who_global_data VALUES (65112, 0, 425, 0, 0, 275, 145);
INSERT INTO public.who_global_data VALUES (65113, 270, 14107, 31, 858, 275, 26);
INSERT INTO public.who_global_data VALUES (65114, 11231, 177160, 88, 1625, 275, 170);
INSERT INTO public.who_global_data VALUES (65115, 7, 268, 0, 0, 275, 191);
INSERT INTO public.who_global_data VALUES (65116, 0, 2, 0, 0, 275, 221);
INSERT INTO public.who_global_data VALUES (65117, 0, 6, 0, 0, 275, 64);
INSERT INTO public.who_global_data VALUES (65118, 0, 0, 0, 0, 275, 116);
INSERT INTO public.who_global_data VALUES (65119, 0, 15, 0, 0, 275, 128);
INSERT INTO public.who_global_data VALUES (65120, 0, 18, 0, 0, 275, 6);
INSERT INTO public.who_global_data VALUES (65121, 0, 38, 0, 3, 275, 227);
INSERT INTO public.who_global_data VALUES (65122, 0, 1, 0, 0, 275, 68);
INSERT INTO public.who_global_data VALUES (65123, 0, 17, 0, 0, 275, 184);
INSERT INTO public.who_global_data VALUES (65124, 0, 0, 0, 0, 275, 82);
INSERT INTO public.who_global_data VALUES (65125, 19, 608, 0, 41, 275, 149);
INSERT INTO public.who_global_data VALUES (65126, 3, 174, 0, 3, 275, 197);
INSERT INTO public.who_global_data VALUES (65127, 1793, 33731, 10, 219, 275, 78);
INSERT INTO public.who_global_data VALUES (65128, 104, 1433, 1, 12, 275, 233);
INSERT INTO public.who_global_data VALUES (65129, 114, 9791, 3, 203, 275, 133);
INSERT INTO public.who_global_data VALUES (65130, 0, 11, 0, 0, 275, 35);
INSERT INTO public.who_global_data VALUES (65131, 26, 225, 3, 14, 275, 114);
INSERT INTO public.who_global_data VALUES (65132, 788, 20198, 2, 20, 275, 237);
INSERT INTO public.who_global_data VALUES (65133, 0, 2, 0, 0, 275, 55);
INSERT INTO public.who_global_data VALUES (65134, 0, 76, 0, 14, 275, 176);
INSERT INTO public.who_global_data VALUES (65135, 8, 1429, 0, 25, 275, 202);
INSERT INTO public.who_global_data VALUES (65136, 1, 1449, 0, 107, 275, 155);
INSERT INTO public.who_global_data VALUES (65137, 0, 0, 0, 0, 275, 32);
INSERT INTO public.who_global_data VALUES (65138, 55, 928, 5, 44, 275, 220);
INSERT INTO public.who_global_data VALUES (65139, 369, 7808, 5, 153, 275, 30);
INSERT INTO public.who_global_data VALUES (65140, 9, 58, 0, 0, 275, 147);
INSERT INTO public.who_global_data VALUES (65141, 983, 229787, 183, 27067, 275, 208);
INSERT INTO public.who_global_data VALUES (65142, 26, 797, 0, 9, 275, 45);
INSERT INTO public.who_global_data VALUES (65143, 78, 930, 3, 52, 275, 110);
INSERT INTO public.who_global_data VALUES (65144, 0, 10, 0, 1, 275, 88);
INSERT INTO public.who_global_data VALUES (65145, 657, 23830, 72, 3295, 275, 51);
INSERT INTO public.who_global_data VALUES (65146, 79, 30171, 4, 1648, 275, 209);
INSERT INTO public.who_global_data VALUES (65147, 0, 45, 0, 3, 275, 205);
INSERT INTO public.who_global_data VALUES (65148, 86, 379, 2, 9, 275, 18);
INSERT INTO public.who_global_data VALUES (65149, 3, 2992, 0, 55, 275, 72);
INSERT INTO public.who_global_data VALUES (65150, 3682, 195581, 647, 29863, 275, 44);
INSERT INTO public.who_global_data VALUES (65151, 0, 24, 0, 0, 275, 15);
INSERT INTO public.who_global_data VALUES (65152, 0, 128, 0, 9, 275, 25);
INSERT INTO public.who_global_data VALUES (65153, 0, 0, 0, 0, 275, 179);
INSERT INTO public.who_global_data VALUES (65154, 0, 0, 0, 0, 275, 34);
INSERT INTO public.who_global_data VALUES (65155, 0, 116, 0, 8, 275, 207);
INSERT INTO public.who_global_data VALUES (65156, 3, 1025, 0, 43, 275, 166);
INSERT INTO public.who_global_data VALUES (65157, 2253, 131744, 64, 3584, 275, 126);
INSERT INTO public.who_global_data VALUES (65158, 0, 0, 0, 0, 275, 97);
INSERT INTO public.who_global_data VALUES (65159, 0, 12, 0, 1, 275, 36);
INSERT INTO public.who_global_data VALUES (65160, 0, 0, 0, 0, 275, 125);
INSERT INTO public.who_global_data VALUES (65161, 1, 98, 0, 0, 275, 124);
INSERT INTO public.who_global_data VALUES (65162, 507, 13691, 13, 340, 275, 185);
INSERT INTO public.who_global_data VALUES (65163, 1048, 16240, 19, 165, 275, 194);
INSERT INTO public.who_global_data VALUES (65164, 0, 480, 0, 18, 275, 144);
INSERT INTO public.who_global_data VALUES (65165, 22267, 1193452, 2475, 70556, 275, 19);
INSERT INTO public.who_global_data VALUES (65166, 0, 66, 0, 4, 275, 217);
INSERT INTO public.who_global_data VALUES (65167, 13, 670, 0, 17, 275, 148);
INSERT INTO public.who_global_data VALUES (65168, 49, 2266, 0, 10, 275, 86);
INSERT INTO public.who_global_data VALUES (65169, 0, 0, 0, 0, 275, 13);
INSERT INTO public.who_global_data VALUES (65170, 6, 367, 0, 10, 275, 157);
INSERT INTO public.who_global_data VALUES (65171, 17, 288, 0, 0, 275, 8);
INSERT INTO public.who_global_data VALUES (65172, 0, 0, 0, 0, 275, 73);
INSERT INTO public.who_global_data VALUES (65173, 0, 26, 1, 6, 275, 101);
INSERT INTO public.who_global_data VALUES (65174, 2, 139, 0, 4, 275, 165);
INSERT INTO public.who_global_data VALUES (65175, 0, 34, 0, 4, 275, 14);
INSERT INTO public.who_global_data VALUES (65176, 168, 3392, 9, 104, 276, 193);
INSERT INTO public.who_global_data VALUES (65177, 12, 794, 0, 30, 276, 113);
INSERT INTO public.who_global_data VALUES (65178, 190, 4838, 5, 470, 276, 143);
INSERT INTO public.who_global_data VALUES (65179, 0, 0, 0, 0, 276, 219);
INSERT INTO public.who_global_data VALUES (65180, 0, 751, 1, 46, 276, 186);
INSERT INTO public.who_global_data VALUES (65181, 1, 36, 0, 2, 276, 52);
INSERT INTO public.who_global_data VALUES (65182, 0, 3, 0, 0, 276, 180);
INSERT INTO public.who_global_data VALUES (65183, 0, 25, 0, 3, 276, 167);
INSERT INTO public.who_global_data VALUES (65184, 123, 4922, 12, 262, 276, 154);
INSERT INTO public.who_global_data VALUES (65185, 112, 2595, 1, 40, 276, 94);
INSERT INTO public.who_global_data VALUES (65186, 1, 101, 0, 2, 276, 66);
INSERT INTO public.who_global_data VALUES (65187, 24, 6849, 1, 96, 276, 58);
INSERT INTO public.who_global_data VALUES (65188, 17, 15586, 6, 606, 276, 163);
INSERT INTO public.who_global_data VALUES (65189, 76, 2060, 0, 26, 276, 37);
INSERT INTO public.who_global_data VALUES (65190, 1, 84, 0, 11, 276, 142);
INSERT INTO public.who_global_data VALUES (65191, 163, 3842, 0, 8, 276, 83);
INSERT INTO public.who_global_data VALUES (65192, 790, 11719, 3, 186, 276, 228);
INSERT INTO public.who_global_data VALUES (65193, 0, 82, 0, 7, 276, 188);
INSERT INTO public.who_global_data VALUES (65194, 1766, 19255, 9, 112, 276, 62);
INSERT INTO public.who_global_data VALUES (65195, 546, 52504, 81, 8299, 276, 160);
INSERT INTO public.who_global_data VALUES (65196, 0, 18, 0, 2, 276, 50);
INSERT INTO public.who_global_data VALUES (65197, 6, 102, 0, 2, 276, 33);
INSERT INTO public.who_global_data VALUES (65198, 0, 115, 0, 7, 276, 183);
INSERT INTO public.who_global_data VALUES (65199, 0, 7, 0, 0, 276, 92);
INSERT INTO public.who_global_data VALUES (65200, 87, 1681, 6, 82, 276, 158);
INSERT INTO public.who_global_data VALUES (65201, 0, 2, 0, 0, 276, 67);
INSERT INTO public.who_global_data VALUES (65202, 42, 1968, 5, 82, 276, 57);
INSERT INTO public.who_global_data VALUES (65203, 0, 23, 0, 1, 276, 38);
INSERT INTO public.who_global_data VALUES (65204, 6633, 107780, 296, 7321, 276, 141);
INSERT INTO public.who_global_data VALUES (65205, 1, 7, 0, 1, 276, 178);
INSERT INTO public.who_global_data VALUES (65206, 0, 138, 0, 1, 276, 108);
INSERT INTO public.who_global_data VALUES (65207, 37, 1689, 0, 78, 276, 39);
INSERT INTO public.who_global_data VALUES (65208, 17, 689, 2, 48, 276, 2);
INSERT INTO public.who_global_data VALUES (65209, 0, 19, 0, 1, 276, 195);
INSERT INTO public.who_global_data VALUES (65210, 21, 186, 0, 2, 276, 107);
INSERT INTO public.who_global_data VALUES (65211, 0, 122, 0, 0, 276, 161);
INSERT INTO public.who_global_data VALUES (65212, 188, 2265, 44, 108, 276, 212);
INSERT INTO public.who_global_data VALUES (65213, 1315, 61159, 149, 3915, 276, 181);
INSERT INTO public.who_global_data VALUES (65214, 1, 75, 0, 1, 276, 53);
INSERT INTO public.who_global_data VALUES (65215, 0, 94, 0, 0, 276, 164);
INSERT INTO public.who_global_data VALUES (65216, 53, 170, 7, 17, 276, 140);
INSERT INTO public.who_global_data VALUES (65217, 1373, 22016, 5, 275, 276, 20);
INSERT INTO public.who_global_data VALUES (65218, 2, 84406, 0, 4643, 276, 112);
INSERT INTO public.who_global_data VALUES (65219, 305, 7973, 18, 358, 276, 111);
INSERT INTO public.who_global_data VALUES (65220, 0, 4, 0, 1, 276, 71);
INSERT INTO public.who_global_data VALUES (65221, 0, 236, 0, 10, 276, 218);
INSERT INTO public.who_global_data VALUES (65222, 0, 0, 0, 0, 276, 43);
INSERT INTO public.who_global_data VALUES (65223, 3, 742, 0, 6, 276, 49);
INSERT INTO public.who_global_data VALUES (65224, 32, 1464, 1, 18, 276, 1);
INSERT INTO public.who_global_data VALUES (65225, 11, 2112, 3, 83, 276, 48);
INSERT INTO public.who_global_data VALUES (65226, 17, 1685, 0, 69, 276, 232);
INSERT INTO public.who_global_data VALUES (65227, 0, 16, 0, 1, 276, 175);
INSERT INTO public.who_global_data VALUES (65228, 4, 878, 0, 15, 276, 21);
INSERT INTO public.who_global_data VALUES (65229, 77, 7896, 5, 257, 276, 156);
INSERT INTO public.who_global_data VALUES (65230, 0, 0, 0, 0, 276, 95);
INSERT INTO public.who_global_data VALUES (65231, 23, 705, 0, 34, 276, 177);
INSERT INTO public.who_global_data VALUES (65232, 151, 9821, 10, 503, 276, 210);
INSERT INTO public.who_global_data VALUES (65233, 0, 1120, 0, 2, 276, 120);
INSERT INTO public.who_global_data VALUES (65234, 0, 16, 0, 0, 276, 135);
INSERT INTO public.who_global_data VALUES (65235, 245, 8480, 8, 354, 276, 206);
INSERT INTO public.who_global_data VALUES (65236, 0, 31881, 0, 1569, 276, 189);
INSERT INTO public.who_global_data VALUES (65237, 387, 7588, 17, 469, 276, 129);
INSERT INTO public.who_global_data VALUES (65238, 32, 587, 1, 13, 276, 121);
INSERT INTO public.who_global_data VALUES (65239, 124, 439, 2, 4, 276, 59);
INSERT INTO public.who_global_data VALUES (65240, 0, 39, 0, 0, 276, 96);
INSERT INTO public.who_global_data VALUES (65241, 8, 1711, 0, 55, 276, 41);
INSERT INTO public.who_global_data VALUES (65242, 3, 119, 0, 1, 276, 216);
INSERT INTO public.who_global_data VALUES (65243, 5, 145, 1, 4, 276, 236);
INSERT INTO public.who_global_data VALUES (65244, 0, 13, 0, 0, 276, 150);
INSERT INTO public.who_global_data VALUES (65245, 0, 187, 0, 0, 276, 61);
INSERT INTO public.who_global_data VALUES (65246, 0, 18, 0, 0, 276, 7);
INSERT INTO public.who_global_data VALUES (65247, 85, 5412, 6, 246, 276, 169);
INSERT INTO public.who_global_data VALUES (65248, 1050, 131292, 326, 25491, 276, 28);
INSERT INTO public.who_global_data VALUES (65249, 0, 133, 0, 1, 276, 85);
INSERT INTO public.who_global_data VALUES (65250, 2, 60, 0, 0, 276, 211);
INSERT INTO public.who_global_data VALUES (65251, 30, 397, 0, 6, 276, 60);
INSERT INTO public.who_global_data VALUES (65252, 0, 17, 0, 1, 276, 3);
INSERT INTO public.who_global_data VALUES (65253, 6, 610, 0, 9, 276, 11);
INSERT INTO public.who_global_data VALUES (65254, 947, 164807, 165, 6996, 276, 89);
INSERT INTO public.who_global_data VALUES (65255, 0, 2719, 0, 18, 276, 24);
INSERT INTO public.who_global_data VALUES (65256, 0, 144, 0, 0, 276, 162);
INSERT INTO public.who_global_data VALUES (65257, 10, 2642, 0, 146, 276, 100);
INSERT INTO public.who_global_data VALUES (65258, 0, 11, 0, 0, 276, 47);
INSERT INTO public.who_global_data VALUES (65259, 0, 21, 0, 0, 276, 29);
INSERT INTO public.who_global_data VALUES (65260, 0, 152, 1, 13, 276, 40);
INSERT INTO public.who_global_data VALUES (65261, 0, 145, 0, 5, 276, 222);
INSERT INTO public.who_global_data VALUES (65262, 27, 730, 2, 19, 276, 132);
INSERT INTO public.who_global_data VALUES (65263, 0, 252, 0, 13, 276, 130);
INSERT INTO public.who_global_data VALUES (65264, 101, 1811, 1, 10, 276, 234);
INSERT INTO public.who_global_data VALUES (65265, 0, 292, 0, 2, 276, 23);
INSERT INTO public.who_global_data VALUES (65266, 10, 92, 0, 9, 276, 192);
INSERT INTO public.who_global_data VALUES (65267, 12, 100, 2, 11, 276, 69);
INSERT INTO public.who_global_data VALUES (65268, 0, 11, 0, 0, 276, 187);
INSERT INTO public.who_global_data VALUES (65269, 123, 1178, 7, 89, 276, 230);
INSERT INTO public.who_global_data VALUES (65270, 46, 3111, 10, 373, 276, 77);
INSERT INTO public.who_global_data VALUES (65271, 0, 1799, 0, 10, 276, 9);
INSERT INTO public.who_global_data VALUES (65272, 2958, 49391, 126, 1694, 276, 74);
INSERT INTO public.who_global_data VALUES (65273, 367, 12438, 23, 895, 276, 224);
INSERT INTO public.who_global_data VALUES (65274, 1680, 101650, 78, 6418, 276, 199);
INSERT INTO public.who_global_data VALUES (65275, 85, 2431, 4, 102, 276, 190);
INSERT INTO public.who_global_data VALUES (65276, 261, 21983, 20, 1339, 276, 12);
INSERT INTO public.who_global_data VALUES (65277, 4, 325, 0, 23, 276, 104);
INSERT INTO public.who_global_data VALUES (65278, 53, 16155, 3, 238, 276, 153);
INSERT INTO public.who_global_data VALUES (65279, 1075, 213013, 236, 29315, 276, 91);
INSERT INTO public.who_global_data VALUES (65280, 2, 471, 0, 9, 276, 215);
INSERT INTO public.who_global_data VALUES (65281, 123, 15354, 22, 543, 276, 84);
INSERT INTO public.who_global_data VALUES (65282, 1, 293, 0, 24, 276, 231);
INSERT INTO public.who_global_data VALUES (65283, 2, 473, 0, 9, 276, 196);
INSERT INTO public.who_global_data VALUES (65284, 211, 4509, 1, 30, 276, 105);
INSERT INTO public.who_global_data VALUES (65285, 45, 535, 2, 26, 276, 122);
INSERT INTO public.who_global_data VALUES (65286, 0, 0, 0, 0, 276, 159);
INSERT INTO public.who_global_data VALUES (65287, 1, 856, 0, 17, 276, 75);
INSERT INTO public.who_global_data VALUES (65288, 485, 6289, 2, 42, 276, 27);
INSERT INTO public.who_global_data VALUES (65289, 28, 871, 2, 12, 276, 54);
INSERT INTO public.who_global_data VALUES (65290, 0, 19, 0, 0, 276, 226);
INSERT INTO public.who_global_data VALUES (65291, 0, 896, 1, 17, 276, 79);
INSERT INTO public.who_global_data VALUES (65292, 9, 750, 0, 25, 276, 56);
INSERT INTO public.who_global_data VALUES (65293, 0, 0, 0, 0, 276, 117);
INSERT INTO public.who_global_data VALUES (65294, 4, 170, 2, 20, 276, 152);
INSERT INTO public.who_global_data VALUES (65295, 1, 64, 0, 3, 276, 16);
INSERT INTO public.who_global_data VALUES (65296, 0, 83, 0, 1, 276, 10);
INSERT INTO public.who_global_data VALUES (65297, 6, 1416, 2, 48, 276, 201);
INSERT INTO public.who_global_data VALUES (65298, 12, 3840, 0, 96, 276, 174);
INSERT INTO public.who_global_data VALUES (65299, 0, 158, 0, 0, 276, 119);
INSERT INTO public.who_global_data VALUES (65300, 0, 41, 0, 3, 276, 168);
INSERT INTO public.who_global_data VALUES (65301, 30, 6383, 1, 106, 276, 99);
INSERT INTO public.who_global_data VALUES (65302, 61, 618, 1, 2, 276, 171);
INSERT INTO public.who_global_data VALUES (65303, 32, 612, 3, 32, 276, 87);
INSERT INTO public.who_global_data VALUES (65304, 3, 483, 1, 5, 276, 123);
INSERT INTO public.who_global_data VALUES (65305, 0, 0, 0, 0, 276, 151);
INSERT INTO public.who_global_data VALUES (65306, 0, 181, 0, 14, 276, 213);
INSERT INTO public.who_global_data VALUES (65307, 0, 8, 0, 1, 276, 118);
INSERT INTO public.who_global_data VALUES (65308, 0, 332, 0, 10, 276, 134);
INSERT INTO public.who_global_data VALUES (65309, 53, 739, 3, 9, 276, 65);
INSERT INTO public.who_global_data VALUES (65310, 1434, 24905, 117, 2271, 276, 102);
INSERT INTO public.who_global_data VALUES (65311, 0, 0, 0, 0, 276, 223);
INSERT INTO public.who_global_data VALUES (65312, 0, 66, 0, 1, 276, 4);
INSERT INTO public.who_global_data VALUES (65313, 0, 41, 0, 0, 276, 146);
INSERT INTO public.who_global_data VALUES (65314, 0, 324, 0, 8, 276, 31);
INSERT INTO public.who_global_data VALUES (65315, 0, 11, 0, 1, 276, 127);
INSERT INTO public.who_global_data VALUES (65316, 229, 5382, 2, 182, 276, 22);
INSERT INTO public.who_global_data VALUES (65317, 0, 80, 0, 0, 276, 115);
INSERT INTO public.who_global_data VALUES (65318, 0, 161, 0, 6, 276, 106);
INSERT INTO public.who_global_data VALUES (65319, 0, 16, 0, 0, 276, 90);
INSERT INTO public.who_global_data VALUES (65320, 0, 0, 0, 0, 276, 70);
INSERT INTO public.who_global_data VALUES (65321, 17, 99, 0, 0, 276, 46);
INSERT INTO public.who_global_data VALUES (65322, 319, 40840, 90, 5130, 276, 139);
INSERT INTO public.who_global_data VALUES (65323, 0, 18, 0, 0, 276, 42);
INSERT INTO public.who_global_data VALUES (65324, 1, 1138, 1, 21, 276, 80);
INSERT INTO public.who_global_data VALUES (65325, 0, 15, 0, 5, 276, 203);
INSERT INTO public.who_global_data VALUES (65326, 8, 763, 1, 38, 276, 136);
INSERT INTO public.who_global_data VALUES (65327, 148, 2950, 5, 98, 276, 63);
INSERT INTO public.who_global_data VALUES (65328, 0, 0, 0, 0, 276, 17);
INSERT INTO public.who_global_data VALUES (65329, 0, 14, 0, 2, 276, 172);
INSERT INTO public.who_global_data VALUES (65330, 8, 1526, 1, 86, 276, 109);
INSERT INTO public.who_global_data VALUES (65331, 56, 7903, 1, 209, 276, 200);
INSERT INTO public.who_global_data VALUES (65332, 8, 546, 0, 4, 276, 93);
INSERT INTO public.who_global_data VALUES (65333, 168, 2903, 1, 13, 276, 5);
INSERT INTO public.who_global_data VALUES (65334, 0, 712, 0, 13, 276, 214);
INSERT INTO public.who_global_data VALUES (65335, 1049, 22550, 40, 526, 276, 204);
INSERT INTO public.who_global_data VALUES (65336, 0, 0, 0, 0, 276, 198);
INSERT INTO public.who_global_data VALUES (65337, 190, 7387, 3, 203, 276, 173);
INSERT INTO public.who_global_data VALUES (65338, 0, 8, 0, 0, 276, 229);
INSERT INTO public.who_global_data VALUES (65339, 35, 431, 0, 10, 276, 76);
INSERT INTO public.who_global_data VALUES (65340, 1444, 47372, 58, 1344, 276, 138);
INSERT INTO public.who_global_data VALUES (65341, 199, 9684, 14, 637, 276, 98);
INSERT INTO public.who_global_data VALUES (65342, 0, 0, 0, 0, 276, 103);
INSERT INTO public.who_global_data VALUES (65343, 425, 14431, 18, 716, 276, 225);
INSERT INTO public.who_global_data VALUES (65344, 178, 25702, 11, 1074, 276, 131);
INSERT INTO public.who_global_data VALUES (65345, 81, 1924, 2, 56, 276, 235);
INSERT INTO public.who_global_data VALUES (65346, 830, 17972, 0, 12, 276, 137);
INSERT INTO public.who_global_data VALUES (65347, 2, 10806, 1, 255, 276, 81);
INSERT INTO public.who_global_data VALUES (65348, 115, 4363, 7, 140, 276, 182);
INSERT INTO public.who_global_data VALUES (65349, 1, 425, 0, 0, 276, 145);
INSERT INTO public.who_global_data VALUES (65350, 325, 13837, 24, 827, 276, 26);
INSERT INTO public.who_global_data VALUES (65351, 10559, 165929, 86, 1537, 276, 170);
INSERT INTO public.who_global_data VALUES (65352, 0, 261, 0, 0, 276, 191);
INSERT INTO public.who_global_data VALUES (65353, 0, 2, 0, 0, 276, 221);
INSERT INTO public.who_global_data VALUES (65354, 0, 6, 0, 0, 276, 64);
INSERT INTO public.who_global_data VALUES (65355, 0, 0, 0, 0, 276, 116);
INSERT INTO public.who_global_data VALUES (65356, 0, 15, 0, 0, 276, 128);
INSERT INTO public.who_global_data VALUES (65357, 0, 18, 0, 0, 276, 6);
INSERT INTO public.who_global_data VALUES (65358, 0, 38, 0, 3, 276, 227);
INSERT INTO public.who_global_data VALUES (65359, 0, 1, 0, 0, 276, 68);
INSERT INTO public.who_global_data VALUES (65360, 0, 17, 0, 0, 276, 184);
INSERT INTO public.who_global_data VALUES (65361, 0, 0, 0, 0, 276, 82);
INSERT INTO public.who_global_data VALUES (65362, 7, 589, 0, 41, 276, 149);
INSERT INTO public.who_global_data VALUES (65363, 10, 171, 0, 3, 276, 197);
INSERT INTO public.who_global_data VALUES (65364, 1687, 31938, 9, 209, 276, 78);
INSERT INTO public.who_global_data VALUES (65365, 58, 1329, 1, 11, 276, 233);
INSERT INTO public.who_global_data VALUES (65366, 120, 9677, 3, 200, 276, 133);
INSERT INTO public.who_global_data VALUES (65367, 0, 11, 0, 0, 276, 35);
INSERT INTO public.who_global_data VALUES (65368, 21, 199, 2, 11, 276, 114);
INSERT INTO public.who_global_data VALUES (65369, 632, 19410, 0, 18, 276, 237);
INSERT INTO public.who_global_data VALUES (65370, 0, 2, 0, 0, 276, 55);
INSERT INTO public.who_global_data VALUES (65371, 0, 76, 1, 14, 276, 176);
INSERT INTO public.who_global_data VALUES (65372, 8, 1421, 0, 25, 276, 202);
INSERT INTO public.who_global_data VALUES (65373, 3, 1448, 2, 107, 276, 155);
INSERT INTO public.who_global_data VALUES (65374, 0, 0, 0, 0, 276, 32);
INSERT INTO public.who_global_data VALUES (65375, 38, 873, 1, 39, 276, 220);
INSERT INTO public.who_global_data VALUES (65376, 219, 7439, 10, 148, 276, 30);
INSERT INTO public.who_global_data VALUES (65377, 0, 49, 0, 0, 276, 147);
INSERT INTO public.who_global_data VALUES (65378, 1015, 228804, 186, 26884, 276, 208);
INSERT INTO public.who_global_data VALUES (65379, 16, 771, 1, 9, 276, 45);
INSERT INTO public.who_global_data VALUES (65380, 74, 852, 4, 49, 276, 110);
INSERT INTO public.who_global_data VALUES (65381, 0, 10, 0, 1, 276, 88);
INSERT INTO public.who_global_data VALUES (65382, 477, 23173, 84, 3223, 276, 51);
INSERT INTO public.who_global_data VALUES (65383, 73, 30092, 10, 1644, 276, 209);
INSERT INTO public.who_global_data VALUES (65384, 1, 45, 0, 3, 276, 205);
INSERT INTO public.who_global_data VALUES (65385, 63, 293, 0, 7, 276, 18);
INSERT INTO public.who_global_data VALUES (65386, 1, 2989, 1, 55, 276, 72);
INSERT INTO public.who_global_data VALUES (65387, 3389, 191899, 726, 29216, 276, 44);
INSERT INTO public.who_global_data VALUES (65388, 0, 24, 0, 0, 276, 15);
INSERT INTO public.who_global_data VALUES (65389, 2, 128, 0, 9, 276, 25);
INSERT INTO public.who_global_data VALUES (65390, 0, 0, 0, 0, 276, 179);
INSERT INTO public.who_global_data VALUES (65391, 0, 0, 0, 0, 276, 34);
INSERT INTO public.who_global_data VALUES (65392, 0, 116, 0, 8, 276, 207);
INSERT INTO public.who_global_data VALUES (65393, 4, 1022, 0, 43, 276, 166);
INSERT INTO public.who_global_data VALUES (65394, 1832, 129491, 59, 3520, 276, 126);
INSERT INTO public.who_global_data VALUES (65395, 0, 0, 0, 0, 276, 97);
INSERT INTO public.who_global_data VALUES (65396, 0, 12, 0, 1, 276, 36);
INSERT INTO public.who_global_data VALUES (65397, 0, 0, 0, 0, 276, 125);
INSERT INTO public.who_global_data VALUES (65398, 8, 97, 0, 0, 276, 124);
INSERT INTO public.who_global_data VALUES (65399, 487, 13184, 11, 327, 276, 185);
INSERT INTO public.who_global_data VALUES (65400, 0, 15192, 0, 146, 276, 194);
INSERT INTO public.who_global_data VALUES (65401, 0, 480, 0, 18, 276, 144);
INSERT INTO public.who_global_data VALUES (65402, 16200, 1171185, 802, 68081, 276, 19);
INSERT INTO public.who_global_data VALUES (65403, 0, 66, 0, 4, 276, 217);
INSERT INTO public.who_global_data VALUES (65404, 2, 657, 0, 17, 276, 148);
INSERT INTO public.who_global_data VALUES (65405, 28, 2217, 0, 10, 276, 86);
INSERT INTO public.who_global_data VALUES (65406, 0, 0, 0, 0, 276, 13);
INSERT INTO public.who_global_data VALUES (65407, 4, 361, 0, 10, 276, 157);
INSERT INTO public.who_global_data VALUES (65408, 0, 271, 0, 0, 276, 8);
INSERT INTO public.who_global_data VALUES (65409, 0, 0, 0, 0, 276, 73);
INSERT INTO public.who_global_data VALUES (65410, 5, 26, 2, 5, 276, 101);
INSERT INTO public.who_global_data VALUES (65411, 0, 137, 1, 4, 276, 165);
INSERT INTO public.who_global_data VALUES (65412, 0, 34, 0, 4, 276, 14);
INSERT INTO public.who_global_data VALUES (65413, 755, 3224, 23, 95, 277, 193);
INSERT INTO public.who_global_data VALUES (65414, 17, 782, 0, 30, 277, 113);
INSERT INTO public.who_global_data VALUES (65415, 174, 4648, 2, 465, 277, 143);
INSERT INTO public.who_global_data VALUES (65416, 0, 0, 0, 0, 277, 219);
INSERT INTO public.who_global_data VALUES (65417, 2, 751, 0, 45, 277, 186);
INSERT INTO public.who_global_data VALUES (65418, 0, 35, 0, 2, 277, 52);
INSERT INTO public.who_global_data VALUES (65419, 0, 3, 0, 0, 277, 180);
INSERT INTO public.who_global_data VALUES (65420, 0, 25, 0, 3, 277, 167);
INSERT INTO public.who_global_data VALUES (65421, 118, 4799, 9, 250, 277, 154);
INSERT INTO public.who_global_data VALUES (65422, 121, 2483, 4, 39, 277, 94);
INSERT INTO public.who_global_data VALUES (65423, 0, 100, 0, 2, 277, 66);
INSERT INTO public.who_global_data VALUES (65424, 24, 6825, 0, 95, 277, 58);
INSERT INTO public.who_global_data VALUES (65425, 31, 15569, 2, 600, 277, 163);
INSERT INTO public.who_global_data VALUES (65426, 52, 1984, 1, 26, 277, 37);
INSERT INTO public.who_global_data VALUES (65427, 1, 83, 0, 11, 277, 142);
INSERT INTO public.who_global_data VALUES (65428, 215, 3679, 0, 8, 277, 83);
INSERT INTO public.who_global_data VALUES (65429, 786, 10929, 1, 183, 277, 228);
INSERT INTO public.who_global_data VALUES (65430, 1, 82, 0, 7, 277, 188);
INSERT INTO public.who_global_data VALUES (65431, 0, 17489, 0, 103, 277, 62);
INSERT INTO public.who_global_data VALUES (65432, 670, 51958, 93, 8218, 277, 160);
INSERT INTO public.who_global_data VALUES (65433, 0, 18, 0, 2, 277, 50);
INSERT INTO public.who_global_data VALUES (65434, 6, 96, 0, 2, 277, 33);
INSERT INTO public.who_global_data VALUES (65435, 0, 115, 0, 7, 277, 183);
INSERT INTO public.who_global_data VALUES (65436, 0, 7, 0, 0, 277, 92);
INSERT INTO public.who_global_data VALUES (65437, 124, 1594, 5, 76, 277, 158);
INSERT INTO public.who_global_data VALUES (65438, 0, 2, 0, 0, 277, 67);
INSERT INTO public.who_global_data VALUES (65439, 69, 1926, 1, 77, 277, 57);
INSERT INTO public.who_global_data VALUES (65440, 0, 23, 0, 1, 277, 38);
INSERT INTO public.who_global_data VALUES (65441, 4588, 101147, 275, 7025, 277, 141);
INSERT INTO public.who_global_data VALUES (65442, 0, 6, 0, 1, 277, 178);
INSERT INTO public.who_global_data VALUES (65443, 0, 138, 0, 1, 277, 108);
INSERT INTO public.who_global_data VALUES (65444, 34, 1652, 5, 78, 277, 39);
INSERT INTO public.who_global_data VALUES (65445, 10, 672, 1, 46, 277, 2);
INSERT INTO public.who_global_data VALUES (65446, 0, 19, 0, 1, 277, 195);
INSERT INTO public.who_global_data VALUES (65447, 0, 165, 0, 2, 277, 107);
INSERT INTO public.who_global_data VALUES (65448, 0, 122, 0, 0, 277, 161);
INSERT INTO public.who_global_data VALUES (65449, 0, 2077, 0, 64, 277, 212);
INSERT INTO public.who_global_data VALUES (65450, 479, 59844, 85, 3766, 277, 181);
INSERT INTO public.who_global_data VALUES (65451, 0, 74, 0, 1, 277, 53);
INSERT INTO public.who_global_data VALUES (65452, 22, 94, 0, 0, 277, 164);
INSERT INTO public.who_global_data VALUES (65453, 0, 117, 0, 10, 277, 140);
INSERT INTO public.who_global_data VALUES (65454, 980, 20643, 10, 270, 277, 20);
INSERT INTO public.who_global_data VALUES (65455, 3, 84404, 0, 4643, 277, 112);
INSERT INTO public.who_global_data VALUES (65456, 383, 7668, 16, 340, 277, 111);
INSERT INTO public.who_global_data VALUES (65457, 1, 4, 1, 1, 277, 71);
INSERT INTO public.who_global_data VALUES (65458, 7, 236, 0, 10, 277, 218);
INSERT INTO public.who_global_data VALUES (65459, 0, 0, 0, 0, 277, 43);
INSERT INTO public.who_global_data VALUES (65460, 6, 739, 0, 6, 277, 49);
INSERT INTO public.who_global_data VALUES (65461, 34, 1432, 0, 17, 277, 1);
INSERT INTO public.who_global_data VALUES (65462, 5, 2101, 1, 80, 277, 48);
INSERT INTO public.who_global_data VALUES (65463, 19, 1668, 2, 69, 277, 232);
INSERT INTO public.who_global_data VALUES (65464, 0, 16, 0, 1, 277, 175);
INSERT INTO public.who_global_data VALUES (65465, 2, 874, 0, 15, 277, 21);
INSERT INTO public.who_global_data VALUES (65466, 38, 7819, 4, 252, 277, 156);
INSERT INTO public.who_global_data VALUES (65467, 0, 0, 0, 0, 277, 95);
INSERT INTO public.who_global_data VALUES (65468, 0, 682, 0, 34, 277, 177);
INSERT INTO public.who_global_data VALUES (65469, 147, 9670, 9, 493, 277, 210);
INSERT INTO public.who_global_data VALUES (65470, 8, 1120, 0, 2, 277, 120);
INSERT INTO public.who_global_data VALUES (65471, 0, 16, 0, 0, 277, 135);
INSERT INTO public.who_global_data VALUES (65472, 281, 8235, 13, 346, 277, 206);
INSERT INTO public.who_global_data VALUES (65473, 2343, 31881, 5, 1569, 277, 189);
INSERT INTO public.who_global_data VALUES (65474, 736, 7201, 23, 452, 277, 129);
INSERT INTO public.who_global_data VALUES (65475, 65, 555, 1, 12, 277, 121);
INSERT INTO public.who_global_data VALUES (65476, 0, 315, 0, 2, 277, 59);
INSERT INTO public.who_global_data VALUES (65477, 0, 39, 0, 0, 277, 96);
INSERT INTO public.who_global_data VALUES (65478, 3, 1703, 0, 55, 277, 41);
INSERT INTO public.who_global_data VALUES (65479, 4, 116, 0, 1, 277, 216);
INSERT INTO public.who_global_data VALUES (65480, 5, 140, 0, 3, 277, 236);
INSERT INTO public.who_global_data VALUES (65481, 0, 13, 0, 0, 277, 150);
INSERT INTO public.who_global_data VALUES (65482, 0, 187, 0, 0, 277, 61);
INSERT INTO public.who_global_data VALUES (65483, 0, 18, 0, 0, 277, 7);
INSERT INTO public.who_global_data VALUES (65484, 73, 5327, 10, 240, 277, 169);
INSERT INTO public.who_global_data VALUES (65485, 534, 130242, 306, 25165, 277, 28);
INSERT INTO public.who_global_data VALUES (65486, 5, 133, 0, 1, 277, 85);
INSERT INTO public.who_global_data VALUES (65487, 0, 58, 0, 0, 277, 211);
INSERT INTO public.who_global_data VALUES (65488, 32, 367, 1, 6, 277, 60);
INSERT INTO public.who_global_data VALUES (65489, 0, 17, 0, 1, 277, 3);
INSERT INTO public.who_global_data VALUES (65490, 11, 604, 0, 9, 277, 11);
INSERT INTO public.who_global_data VALUES (65491, 685, 163860, 139, 6831, 277, 89);
INSERT INTO public.who_global_data VALUES (65492, 550, 2719, 0, 18, 277, 24);
INSERT INTO public.who_global_data VALUES (65493, 0, 144, 0, 0, 277, 162);
INSERT INTO public.who_global_data VALUES (65494, 6, 2632, 2, 146, 277, 100);
INSERT INTO public.who_global_data VALUES (65495, 0, 11, 0, 0, 277, 47);
INSERT INTO public.who_global_data VALUES (65496, 0, 21, 0, 0, 277, 29);
INSERT INTO public.who_global_data VALUES (65497, 0, 152, 0, 12, 277, 40);
INSERT INTO public.who_global_data VALUES (65498, 0, 145, 0, 5, 277, 222);
INSERT INTO public.who_global_data VALUES (65499, 15, 703, -2, 17, 277, 132);
INSERT INTO public.who_global_data VALUES (65500, 0, 252, 0, 13, 277, 130);
INSERT INTO public.who_global_data VALUES (65501, 60, 1710, 2, 9, 277, 234);
INSERT INTO public.who_global_data VALUES (65502, 0, 292, 0, 2, 277, 23);
INSERT INTO public.who_global_data VALUES (65503, 0, 82, 0, 9, 277, 192);
INSERT INTO public.who_global_data VALUES (65504, 3, 88, 1, 9, 277, 69);
INSERT INTO public.who_global_data VALUES (65505, 0, 11, 0, 0, 277, 187);
INSERT INTO public.who_global_data VALUES (65506, 45, 1055, 6, 82, 277, 230);
INSERT INTO public.who_global_data VALUES (65507, 30, 3065, 12, 363, 277, 77);
INSERT INTO public.who_global_data VALUES (65508, 0, 1799, 0, 10, 277, 9);
INSERT INTO public.who_global_data VALUES (65509, 3900, 46433, 195, 1568, 277, 74);
INSERT INTO public.who_global_data VALUES (65510, 484, 12071, 8, 872, 277, 224);
INSERT INTO public.who_global_data VALUES (65511, 1323, 99970, 63, 6340, 277, 199);
INSERT INTO public.who_global_data VALUES (65512, 50, 2346, 1, 98, 277, 190);
INSERT INTO public.who_global_data VALUES (65513, 216, 21722, 16, 1319, 277, 12);
INSERT INTO public.who_global_data VALUES (65514, 1, 321, 0, 23, 277, 104);
INSERT INTO public.who_global_data VALUES (65515, 27, 16102, 3, 235, 277, 153);
INSERT INTO public.who_global_data VALUES (65516, 1221, 211938, 195, 29079, 277, 91);
INSERT INTO public.who_global_data VALUES (65517, 6, 469, 1, 9, 277, 215);
INSERT INTO public.who_global_data VALUES (65518, 174, 15231, 11, 521, 277, 84);
INSERT INTO public.who_global_data VALUES (65519, 1, 292, 0, 24, 277, 231);
INSERT INTO public.who_global_data VALUES (65520, 6, 471, 0, 9, 277, 196);
INSERT INTO public.who_global_data VALUES (65521, 138, 4298, 0, 29, 277, 105);
INSERT INTO public.who_global_data VALUES (65522, 24, 490, 0, 24, 277, 122);
INSERT INTO public.who_global_data VALUES (65523, 0, 0, 0, 0, 277, 159);
INSERT INTO public.who_global_data VALUES (65524, 4, 855, 0, 17, 277, 75);
INSERT INTO public.who_global_data VALUES (65525, 526, 5804, 0, 40, 277, 27);
INSERT INTO public.who_global_data VALUES (65526, 13, 843, 0, 10, 277, 54);
INSERT INTO public.who_global_data VALUES (65527, 0, 19, 0, 0, 277, 226);
INSERT INTO public.who_global_data VALUES (65528, 17, 896, 0, 16, 277, 79);
INSERT INTO public.who_global_data VALUES (65529, 1, 741, 0, 25, 277, 56);
INSERT INTO public.who_global_data VALUES (65530, 0, 0, 0, 0, 277, 117);
INSERT INTO public.who_global_data VALUES (65531, 8, 166, 0, 18, 277, 152);
INSERT INTO public.who_global_data VALUES (65532, 0, 63, 0, 3, 277, 16);
INSERT INTO public.who_global_data VALUES (65533, 0, 83, 0, 1, 277, 10);
INSERT INTO public.who_global_data VALUES (65534, 3, 1410, 0, 46, 277, 201);
INSERT INTO public.who_global_data VALUES (65535, 4, 3828, 0, 96, 277, 174);
INSERT INTO public.who_global_data VALUES (65536, 7, 158, 0, 0, 277, 119);
INSERT INTO public.who_global_data VALUES (65537, 2, 41, 0, 3, 277, 168);
INSERT INTO public.who_global_data VALUES (65538, 55, 6353, 0, 105, 277, 99);
INSERT INTO public.who_global_data VALUES (65539, 30, 557, 0, 1, 277, 171);
INSERT INTO public.who_global_data VALUES (65540, 17, 580, 2, 29, 277, 87);
INSERT INTO public.who_global_data VALUES (65541, 1, 480, 0, 4, 277, 123);
INSERT INTO public.who_global_data VALUES (65542, 0, 0, 0, 0, 277, 151);
INSERT INTO public.who_global_data VALUES (65543, 0, 181, 0, 14, 277, 213);
INSERT INTO public.who_global_data VALUES (65544, 0, 8, 0, 1, 277, 118);
INSERT INTO public.who_global_data VALUES (65545, 0, 332, 0, 10, 277, 134);
INSERT INTO public.who_global_data VALUES (65546, 36, 686, 0, 6, 277, 65);
INSERT INTO public.who_global_data VALUES (65547, 1383, 23471, 93, 2154, 277, 102);
INSERT INTO public.who_global_data VALUES (65548, 0, 0, 0, 0, 277, 223);
INSERT INTO public.who_global_data VALUES (65549, 0, 66, 0, 1, 277, 4);
INSERT INTO public.who_global_data VALUES (65550, 1, 41, 0, 0, 277, 146);
INSERT INTO public.who_global_data VALUES (65551, 0, 324, 0, 8, 277, 31);
INSERT INTO public.who_global_data VALUES (65552, 0, 11, 0, 1, 277, 127);
INSERT INTO public.who_global_data VALUES (65553, 153, 5153, 3, 180, 277, 22);
INSERT INTO public.who_global_data VALUES (65554, 0, 80, 0, 0, 277, 115);
INSERT INTO public.who_global_data VALUES (65555, 6, 161, 0, 6, 277, 106);
INSERT INTO public.who_global_data VALUES (65556, 0, 16, 0, 0, 277, 90);
INSERT INTO public.who_global_data VALUES (65557, 0, 0, 0, 0, 277, 70);
INSERT INTO public.who_global_data VALUES (65558, 7, 82, 0, 0, 277, 46);
INSERT INTO public.who_global_data VALUES (65559, 201, 40521, 15, 5040, 277, 139);
INSERT INTO public.who_global_data VALUES (65560, 0, 18, 0, 0, 277, 42);
INSERT INTO public.who_global_data VALUES (65561, 0, 1137, 0, 20, 277, 80);
INSERT INTO public.who_global_data VALUES (65562, 1, 15, 1, 5, 277, 203);
INSERT INTO public.who_global_data VALUES (65563, 5, 755, 1, 37, 277, 136);
INSERT INTO public.who_global_data VALUES (65564, 414, 2802, 8, 93, 277, 63);
INSERT INTO public.who_global_data VALUES (65565, 0, 0, 0, 0, 277, 17);
INSERT INTO public.who_global_data VALUES (65566, 0, 14, 0, 2, 277, 172);
INSERT INTO public.who_global_data VALUES (65567, 7, 1518, 1, 85, 277, 109);
INSERT INTO public.who_global_data VALUES (65568, 38, 7847, 0, 208, 277, 200);
INSERT INTO public.who_global_data VALUES (65569, 14, 538, 0, 4, 277, 93);
INSERT INTO public.who_global_data VALUES (65570, 98, 2735, 0, 12, 277, 5);
INSERT INTO public.who_global_data VALUES (65571, 0, 712, 0, 13, 277, 214);
INSERT INTO public.who_global_data VALUES (65572, 617, 21501, 10, 486, 277, 204);
INSERT INTO public.who_global_data VALUES (65573, 0, 0, 0, 0, 277, 198);
INSERT INTO public.who_global_data VALUES (65574, 107, 7197, 3, 200, 277, 173);
INSERT INTO public.who_global_data VALUES (65575, 0, 8, 0, 0, 277, 229);
INSERT INTO public.who_global_data VALUES (65576, 26, 396, 0, 10, 277, 76);
INSERT INTO public.who_global_data VALUES (65577, 3394, 45928, 86, 1286, 277, 138);
INSERT INTO public.who_global_data VALUES (65578, 262, 9485, 16, 623, 277, 98);
INSERT INTO public.who_global_data VALUES (65579, 0, 0, 0, 0, 277, 103);
INSERT INTO public.who_global_data VALUES (65580, 313, 14006, 20, 698, 277, 225);
INSERT INTO public.who_global_data VALUES (65581, 0, 25524, 0, 1063, 277, 131);
INSERT INTO public.who_global_data VALUES (65582, 35, 1843, -43, 54, 277, 235);
INSERT INTO public.who_global_data VALUES (65583, 951, 17142, 0, 12, 277, 137);
INSERT INTO public.who_global_data VALUES (65584, 3, 10804, 2, 254, 277, 81);
INSERT INTO public.who_global_data VALUES (65585, 127, 4248, 5, 133, 277, 182);
INSERT INTO public.who_global_data VALUES (65586, 1, 424, 0, 0, 277, 145);
INSERT INTO public.who_global_data VALUES (65587, 349, 13512, 23, 803, 277, 26);
INSERT INTO public.who_global_data VALUES (65588, 10102, 155370, 95, 1451, 277, 170);
INSERT INTO public.who_global_data VALUES (65589, 2, 261, 0, 0, 277, 191);
INSERT INTO public.who_global_data VALUES (65590, 0, 2, 0, 0, 277, 221);
INSERT INTO public.who_global_data VALUES (65591, 0, 6, 0, 0, 277, 64);
INSERT INTO public.who_global_data VALUES (65592, 0, 0, 0, 0, 277, 116);
INSERT INTO public.who_global_data VALUES (65593, 0, 15, 0, 0, 277, 128);
INSERT INTO public.who_global_data VALUES (65594, 1, 18, 0, 0, 277, 6);
INSERT INTO public.who_global_data VALUES (65595, 0, 38, 0, 3, 277, 227);
INSERT INTO public.who_global_data VALUES (65596, 0, 1, 0, 0, 277, 68);
INSERT INTO public.who_global_data VALUES (65597, 1, 17, 0, 0, 277, 184);
INSERT INTO public.who_global_data VALUES (65598, 0, 0, 0, 0, 277, 82);
INSERT INTO public.who_global_data VALUES (65599, 0, 582, 0, 41, 277, 149);
INSERT INTO public.who_global_data VALUES (65600, 138, 161, 0, 3, 277, 197);
INSERT INTO public.who_global_data VALUES (65601, 1595, 30251, 9, 200, 277, 78);
INSERT INTO public.who_global_data VALUES (65602, 0, 1271, 1, 10, 277, 233);
INSERT INTO public.who_global_data VALUES (65603, 93, 9557, 4, 197, 277, 133);
INSERT INTO public.who_global_data VALUES (65604, 0, 11, 0, 0, 277, 35);
INSERT INTO public.who_global_data VALUES (65605, 21, 178, 1, 9, 277, 114);
INSERT INTO public.who_global_data VALUES (65606, 573, 18778, 0, 18, 277, 237);
INSERT INTO public.who_global_data VALUES (65607, 0, 2, 0, 0, 277, 55);
INSERT INTO public.who_global_data VALUES (65608, 0, 76, 0, 13, 277, 176);
INSERT INTO public.who_global_data VALUES (65609, 5, 1413, 1, 25, 277, 202);
INSERT INTO public.who_global_data VALUES (65610, 6, 1445, 0, 105, 277, 155);
INSERT INTO public.who_global_data VALUES (65611, 0, 0, 0, 0, 277, 32);
INSERT INTO public.who_global_data VALUES (65612, 79, 835, 3, 38, 277, 220);
INSERT INTO public.who_global_data VALUES (65613, 437, 7220, 7, 138, 277, 30);
INSERT INTO public.who_global_data VALUES (65614, 3, 49, 0, 0, 277, 147);
INSERT INTO public.who_global_data VALUES (65615, 451, 227789, 197, 26698, 277, 208);
INSERT INTO public.who_global_data VALUES (65616, 37, 755, 1, 8, 277, 45);
INSERT INTO public.who_global_data VALUES (65617, 100, 778, 4, 45, 277, 110);
INSERT INTO public.who_global_data VALUES (65618, 0, 10, 0, 1, 277, 88);
INSERT INTO public.who_global_data VALUES (65619, 261, 22696, 75, 3139, 277, 51);
INSERT INTO public.who_global_data VALUES (65620, 90, 30019, 9, 1634, 277, 209);
INSERT INTO public.who_global_data VALUES (65621, 0, 44, 0, 3, 277, 205);
INSERT INTO public.who_global_data VALUES (65622, 102, 230, 3, 7, 277, 18);
INSERT INTO public.who_global_data VALUES (65623, 1, 2988, 0, 54, 277, 72);
INSERT INTO public.who_global_data VALUES (65624, 2982, 188510, 272, 28490, 277, 44);
INSERT INTO public.who_global_data VALUES (65625, 0, 24, 0, 0, 277, 15);
INSERT INTO public.who_global_data VALUES (65626, 2, 126, 0, 9, 277, 25);
INSERT INTO public.who_global_data VALUES (65627, 0, 0, 0, 0, 277, 179);
INSERT INTO public.who_global_data VALUES (65628, 0, 0, 0, 0, 277, 34);
INSERT INTO public.who_global_data VALUES (65629, 0, 116, 0, 8, 277, 207);
INSERT INTO public.who_global_data VALUES (65630, 5, 1018, 1, 43, 277, 166);
INSERT INTO public.who_global_data VALUES (65631, 1614, 127659, 64, 3461, 277, 126);
INSERT INTO public.who_global_data VALUES (65632, 0, 0, 0, 0, 277, 97);
INSERT INTO public.who_global_data VALUES (65633, 0, 12, 0, 1, 277, 36);
INSERT INTO public.who_global_data VALUES (65634, 0, 0, 0, 0, 277, 125);
INSERT INTO public.who_global_data VALUES (65635, 1, 89, 0, 0, 277, 124);
INSERT INTO public.who_global_data VALUES (65636, 366, 12697, 13, 316, 277, 185);
INSERT INTO public.who_global_data VALUES (65637, 1029, 15192, 20, 146, 277, 194);
INSERT INTO public.who_global_data VALUES (65638, 0, 480, 0, 18, 277, 144);
INSERT INTO public.who_global_data VALUES (65639, 29266, 1154985, -514, 67279, 277, 19);
INSERT INTO public.who_global_data VALUES (65640, 0, 66, 0, 4, 277, 217);
INSERT INTO public.who_global_data VALUES (65641, 3, 655, 0, 17, 277, 148);
INSERT INTO public.who_global_data VALUES (65642, 29, 2189, 0, 10, 277, 86);
INSERT INTO public.who_global_data VALUES (65643, 0, 0, 0, 0, 277, 13);
INSERT INTO public.who_global_data VALUES (65644, 12, 357, 0, 10, 277, 157);
INSERT INTO public.who_global_data VALUES (65645, 0, 271, 0, 0, 277, 8);
INSERT INTO public.who_global_data VALUES (65646, 0, 0, 0, 0, 277, 73);
INSERT INTO public.who_global_data VALUES (65647, 11, 21, 1, 3, 277, 101);
INSERT INTO public.who_global_data VALUES (65648, 13, 137, 0, 3, 277, 165);
INSERT INTO public.who_global_data VALUES (65649, 0, 34, 0, 4, 277, 14);
INSERT INTO public.who_global_data VALUES (65650, 0, 2469, 0, 72, 278, 193);
INSERT INTO public.who_global_data VALUES (65651, 8, 765, 0, 30, 278, 113);
INSERT INTO public.who_global_data VALUES (65652, 179, 4474, 4, 463, 278, 143);
INSERT INTO public.who_global_data VALUES (65653, 0, 0, 0, 0, 278, 219);
INSERT INTO public.who_global_data VALUES (65654, 2, 749, 1, 45, 278, 186);
INSERT INTO public.who_global_data VALUES (65655, 0, 35, 0, 2, 278, 52);
INSERT INTO public.who_global_data VALUES (65656, 0, 3, 0, 0, 278, 180);
INSERT INTO public.who_global_data VALUES (65657, 1, 25, 0, 3, 278, 167);
INSERT INTO public.who_global_data VALUES (65658, 149, 4681, 12, 241, 278, 154);
INSERT INTO public.who_global_data VALUES (65659, 113, 2362, 2, 35, 278, 94);
INSERT INTO public.who_global_data VALUES (65660, 0, 100, 0, 2, 278, 66);
INSERT INTO public.who_global_data VALUES (65661, 18, 6801, 2, 95, 278, 58);
INSERT INTO public.who_global_data VALUES (65662, 68, 15538, 2, 598, 278, 163);
INSERT INTO public.who_global_data VALUES (65663, 38, 1932, 0, 25, 278, 37);
INSERT INTO public.who_global_data VALUES (65664, 0, 82, 0, 11, 278, 142);
INSERT INTO public.who_global_data VALUES (65665, 108, 3464, 0, 8, 278, 83);
INSERT INTO public.who_global_data VALUES (65666, 688, 10143, 5, 182, 278, 228);
INSERT INTO public.who_global_data VALUES (65667, 0, 81, 0, 7, 278, 188);
INSERT INTO public.who_global_data VALUES (65668, 1661, 17489, 6, 103, 278, 62);
INSERT INTO public.who_global_data VALUES (65669, 140, 51288, 93, 8125, 278, 160);
INSERT INTO public.who_global_data VALUES (65670, 0, 18, 0, 2, 278, 50);
INSERT INTO public.who_global_data VALUES (65671, 0, 90, 0, 2, 278, 33);
INSERT INTO public.who_global_data VALUES (65672, 1, 115, 1, 7, 278, 183);
INSERT INTO public.who_global_data VALUES (65673, 0, 7, 0, 0, 278, 92);
INSERT INTO public.who_global_data VALUES (65674, 241, 1470, 5, 71, 278, 158);
INSERT INTO public.who_global_data VALUES (65675, 0, 2, 0, 0, 278, 67);
INSERT INTO public.who_global_data VALUES (65676, 17, 1857, 5, 76, 278, 57);
INSERT INTO public.who_global_data VALUES (65677, 0, 23, 0, 1, 278, 38);
INSERT INTO public.who_global_data VALUES (65678, 4970, 96559, 421, 6750, 278, 141);
INSERT INTO public.who_global_data VALUES (65679, 0, 6, 0, 1, 278, 178);
INSERT INTO public.who_global_data VALUES (65680, 0, 138, 0, 1, 278, 108);
INSERT INTO public.who_global_data VALUES (65681, 24, 1618, 1, 73, 278, 39);
INSERT INTO public.who_global_data VALUES (65682, 10, 662, 1, 45, 278, 2);
INSERT INTO public.who_global_data VALUES (65683, 0, 19, 0, 1, 278, 195);
INSERT INTO public.who_global_data VALUES (65684, 13, 165, 0, 2, 278, 107);
INSERT INTO public.who_global_data VALUES (65685, 0, 122, 0, 0, 278, 161);
INSERT INTO public.who_global_data VALUES (65686, 0, 2077, 0, 64, 278, 212);
INSERT INTO public.who_global_data VALUES (65687, 3793, 59365, 235, 3681, 278, 181);
INSERT INTO public.who_global_data VALUES (65688, 0, 74, 0, 1, 278, 53);
INSERT INTO public.who_global_data VALUES (65689, 0, 72, 0, 0, 278, 164);
INSERT INTO public.who_global_data VALUES (65690, 0, 117, 0, 10, 278, 140);
INSERT INTO public.who_global_data VALUES (65691, 1228, 19663, 13, 260, 278, 20);
INSERT INTO public.who_global_data VALUES (65692, 8, 84401, 0, 4643, 278, 112);
INSERT INTO public.who_global_data VALUES (65693, 279, 7285, 10, 324, 278, 111);
INSERT INTO public.who_global_data VALUES (65694, 0, 3, 0, 0, 278, 71);
INSERT INTO public.who_global_data VALUES (65695, 0, 229, 0, 10, 278, 218);
INSERT INTO public.who_global_data VALUES (65696, 0, 0, 0, 0, 278, 43);
INSERT INTO public.who_global_data VALUES (65697, 8, 733, 0, 6, 278, 49);
INSERT INTO public.who_global_data VALUES (65698, 36, 1398, 2, 17, 278, 1);
INSERT INTO public.who_global_data VALUES (65699, 8, 2096, 2, 79, 278, 48);
INSERT INTO public.who_global_data VALUES (65700, 38, 1649, 1, 67, 278, 232);
INSERT INTO public.who_global_data VALUES (65701, 0, 16, 0, 1, 278, 175);
INSERT INTO public.who_global_data VALUES (65702, 8, 872, 0, 15, 278, 21);
INSERT INTO public.who_global_data VALUES (65703, 26, 7781, 3, 248, 278, 156);
INSERT INTO public.who_global_data VALUES (65704, 0, 0, 0, 0, 278, 95);
INSERT INTO public.who_global_data VALUES (65705, 8, 682, 1, 34, 278, 177);
INSERT INTO public.who_global_data VALUES (65706, 116, 9523, 9, 484, 278, 210);
INSERT INTO public.who_global_data VALUES (65707, 0, 1112, 0, 2, 278, 120);
INSERT INTO public.who_global_data VALUES (65708, 0, 16, 0, 0, 278, 135);
INSERT INTO public.who_global_data VALUES (65709, 376, 7954, 7, 333, 278, 206);
INSERT INTO public.who_global_data VALUES (65710, 2074, 29538, 193, 1564, 278, 189);
INSERT INTO public.who_global_data VALUES (65711, 272, 6465, 14, 429, 278, 129);
INSERT INTO public.who_global_data VALUES (65712, 44, 490, 1, 11, 278, 121);
INSERT INTO public.who_global_data VALUES (65713, 0, 315, 0, 2, 278, 59);
INSERT INTO public.who_global_data VALUES (65714, 0, 39, 0, 0, 278, 96);
INSERT INTO public.who_global_data VALUES (65715, 1, 1700, 2, 55, 278, 41);
INSERT INTO public.who_global_data VALUES (65716, 4, 112, 0, 1, 278, 216);
INSERT INTO public.who_global_data VALUES (65717, 2, 135, 0, 3, 278, 236);
INSERT INTO public.who_global_data VALUES (65718, 0, 13, 0, 0, 278, 150);
INSERT INTO public.who_global_data VALUES (65719, 0, 187, 0, 0, 278, 61);
INSERT INTO public.who_global_data VALUES (65720, 0, 18, 0, 0, 278, 7);
INSERT INTO public.who_global_data VALUES (65721, 75, 5254, 10, 230, 278, 169);
INSERT INTO public.who_global_data VALUES (65722, 250, 129708, 135, 24859, 278, 28);
INSERT INTO public.who_global_data VALUES (65723, 0, 128, 0, 1, 278, 85);
INSERT INTO public.who_global_data VALUES (65724, 0, 58, 0, 0, 278, 211);
INSERT INTO public.who_global_data VALUES (65725, 0, 335, 0, 5, 278, 60);
INSERT INTO public.who_global_data VALUES (65726, 0, 17, 0, 1, 278, 3);
INSERT INTO public.who_global_data VALUES (65727, 4, 593, 1, 9, 278, 11);
INSERT INTO public.who_global_data VALUES (65728, 679, 163175, 43, 6692, 278, 89);
INSERT INTO public.who_global_data VALUES (65729, 0, 2169, 0, 18, 278, 24);
INSERT INTO public.who_global_data VALUES (65730, 0, 144, 0, 0, 278, 162);
INSERT INTO public.who_global_data VALUES (65731, 6, 2626, 1, 144, 278, 100);
INSERT INTO public.who_global_data VALUES (65732, 0, 11, 0, 0, 278, 47);
INSERT INTO public.who_global_data VALUES (65733, 1, 21, 0, 0, 278, 29);
INSERT INTO public.who_global_data VALUES (65734, 0, 152, 0, 12, 278, 40);
INSERT INTO public.who_global_data VALUES (65735, 2, 145, 0, 5, 278, 222);
INSERT INTO public.who_global_data VALUES (65736, 44, 688, 1, 19, 278, 132);
INSERT INTO public.who_global_data VALUES (65737, 0, 252, 0, 13, 278, 130);
INSERT INTO public.who_global_data VALUES (65738, 64, 1650, 0, 7, 278, 234);
INSERT INTO public.who_global_data VALUES (65739, 32, 292, 1, 2, 278, 23);
INSERT INTO public.who_global_data VALUES (65740, 0, 82, 0, 9, 278, 192);
INSERT INTO public.who_global_data VALUES (65741, 0, 85, 0, 8, 278, 69);
INSERT INTO public.who_global_data VALUES (65742, 0, 11, 0, 0, 278, 187);
INSERT INTO public.who_global_data VALUES (65743, 111, 1010, 1, 76, 278, 230);
INSERT INTO public.who_global_data VALUES (65744, 37, 3035, 11, 351, 278, 77);
INSERT INTO public.who_global_data VALUES (65745, 1, 1799, 0, 10, 278, 9);
INSERT INTO public.who_global_data VALUES (65746, 2553, 42533, 72, 1373, 278, 74);
INSERT INTO public.who_global_data VALUES (65747, 395, 11587, 19, 864, 278, 224);
INSERT INTO public.who_global_data VALUES (65748, 1223, 98647, 74, 6277, 278, 199);
INSERT INTO public.who_global_data VALUES (65749, 77, 2296, 2, 97, 278, 190);
INSERT INTO public.who_global_data VALUES (65750, 330, 21506, 38, 1303, 278, 12);
INSERT INTO public.who_global_data VALUES (65751, 5, 320, 0, 23, 278, 104);
INSERT INTO public.who_global_data VALUES (65752, 57, 16075, 3, 232, 278, 153);
INSERT INTO public.who_global_data VALUES (65753, 1389, 210717, 174, 28884, 278, 91);
INSERT INTO public.who_global_data VALUES (65754, 31, 463, 0, 8, 278, 215);
INSERT INTO public.who_global_data VALUES (65755, 218, 15057, 18, 510, 278, 84);
INSERT INTO public.who_global_data VALUES (65756, 1, 291, 1, 24, 278, 231);
INSERT INTO public.who_global_data VALUES (65757, 4, 465, 0, 9, 278, 196);
INSERT INTO public.who_global_data VALUES (65758, 172, 4160, 2, 29, 278, 105);
INSERT INTO public.who_global_data VALUES (65759, 31, 466, 2, 24, 278, 122);
INSERT INTO public.who_global_data VALUES (65760, 0, 0, 0, 0, 278, 159);
INSERT INTO public.who_global_data VALUES (65761, 28, 851, 0, 17, 278, 75);
INSERT INTO public.who_global_data VALUES (65762, 295, 5278, 2, 40, 278, 27);
INSERT INTO public.who_global_data VALUES (65763, 35, 830, 0, 10, 278, 54);
INSERT INTO public.who_global_data VALUES (65764, 0, 19, 0, 0, 278, 226);
INSERT INTO public.who_global_data VALUES (65765, 8, 879, 0, 16, 278, 79);
INSERT INTO public.who_global_data VALUES (65766, 3, 740, 0, 25, 278, 56);
INSERT INTO public.who_global_data VALUES (65767, 0, 0, 0, 0, 278, 117);
INSERT INTO public.who_global_data VALUES (65768, 4, 158, 0, 18, 278, 152);
INSERT INTO public.who_global_data VALUES (65769, 0, 63, 0, 3, 278, 16);
INSERT INTO public.who_global_data VALUES (65770, 0, 83, 0, 1, 278, 10);
INSERT INTO public.who_global_data VALUES (65771, 8, 1407, 0, 46, 278, 201);
INSERT INTO public.who_global_data VALUES (65772, 12, 3824, 4, 96, 278, 174);
INSERT INTO public.who_global_data VALUES (65773, 2, 151, 0, 0, 278, 119);
INSERT INTO public.who_global_data VALUES (65774, 1, 39, 0, 3, 278, 168);
INSERT INTO public.who_global_data VALUES (65775, 122, 6298, 2, 105, 278, 99);
INSERT INTO public.who_global_data VALUES (65776, 8, 527, 0, 1, 278, 171);
INSERT INTO public.who_global_data VALUES (65777, 19, 563, 1, 27, 278, 87);
INSERT INTO public.who_global_data VALUES (65778, 3, 479, 0, 4, 278, 123);
INSERT INTO public.who_global_data VALUES (65779, 0, 0, 0, 0, 278, 151);
INSERT INTO public.who_global_data VALUES (65780, 1, 181, 0, 14, 278, 213);
INSERT INTO public.who_global_data VALUES (65781, 0, 8, 0, 1, 278, 118);
INSERT INTO public.who_global_data VALUES (65782, 0, 332, 0, 10, 278, 134);
INSERT INTO public.who_global_data VALUES (65783, 54, 650, 0, 6, 278, 65);
INSERT INTO public.who_global_data VALUES (65784, 1349, 22088, 89, 2061, 278, 102);
INSERT INTO public.who_global_data VALUES (65785, 0, 0, 0, 0, 278, 223);
INSERT INTO public.who_global_data VALUES (65786, 0, 66, 0, 1, 278, 4);
INSERT INTO public.who_global_data VALUES (65787, 1, 40, 0, 0, 278, 146);
INSERT INTO public.who_global_data VALUES (65788, 1, 324, 0, 8, 278, 31);
INSERT INTO public.who_global_data VALUES (65789, 0, 11, 0, 1, 278, 127);
INSERT INTO public.who_global_data VALUES (65790, 120, 5000, 3, 177, 278, 22);
INSERT INTO public.who_global_data VALUES (65791, 1, 80, 0, 0, 278, 115);
INSERT INTO public.who_global_data VALUES (65792, 4, 155, 0, 6, 278, 106);
INSERT INTO public.who_global_data VALUES (65793, 0, 16, 0, 0, 278, 90);
INSERT INTO public.who_global_data VALUES (65794, 0, 0, 0, 0, 278, 70);
INSERT INTO public.who_global_data VALUES (65795, 6, 75, 0, 0, 278, 46);
INSERT INTO public.who_global_data VALUES (65796, 338, 40320, 82, 5025, 278, 139);
INSERT INTO public.who_global_data VALUES (65797, 0, 18, 0, 0, 278, 42);
INSERT INTO public.who_global_data VALUES (65798, 1, 1137, 0, 20, 278, 80);
INSERT INTO public.who_global_data VALUES (65799, 0, 14, 0, 4, 278, 203);
INSERT INTO public.who_global_data VALUES (65800, 14, 750, 1, 36, 278, 136);
INSERT INTO public.who_global_data VALUES (65801, 0, 2388, 0, 85, 278, 63);
INSERT INTO public.who_global_data VALUES (65802, 0, 0, 0, 0, 278, 17);
INSERT INTO public.who_global_data VALUES (65803, 0, 14, 0, 2, 278, 172);
INSERT INTO public.who_global_data VALUES (65804, 5, 1511, 2, 84, 278, 109);
INSERT INTO public.who_global_data VALUES (65805, 50, 7809, 4, 208, 278, 200);
INSERT INTO public.who_global_data VALUES (65806, 171, 524, 2, 4, 278, 93);
INSERT INTO public.who_global_data VALUES (65807, 69, 2637, 0, 12, 278, 5);
INSERT INTO public.who_global_data VALUES (65808, 0, 712, 0, 13, 278, 214);
INSERT INTO public.who_global_data VALUES (65809, 800, 20884, 19, 476, 278, 204);
INSERT INTO public.who_global_data VALUES (65810, 0, 0, 0, 0, 278, 198);
INSERT INTO public.who_global_data VALUES (65811, 370, 7090, 5, 197, 278, 173);
INSERT INTO public.who_global_data VALUES (65812, 0, 8, 0, 0, 278, 229);
INSERT INTO public.who_global_data VALUES (65813, 37, 370, 0, 10, 278, 76);
INSERT INTO public.who_global_data VALUES (65814, 2075, 42534, 76, 1200, 278, 138);
INSERT INTO public.who_global_data VALUES (65815, 295, 9223, 4, 607, 278, 98);
INSERT INTO public.who_global_data VALUES (65816, 0, 0, 0, 0, 278, 103);
INSERT INTO public.who_global_data VALUES (65817, 318, 13693, 14, 678, 278, 225);
INSERT INTO public.who_global_data VALUES (65818, 334, 25524, 40, 1063, 278, 131);
INSERT INTO public.who_global_data VALUES (65819, 51, 1808, 43, 97, 278, 235);
INSERT INTO public.who_global_data VALUES (65820, 640, 16191, 0, 12, 278, 137);
INSERT INTO public.who_global_data VALUES (65821, 8, 10801, 2, 252, 278, 81);
INSERT INTO public.who_global_data VALUES (65822, 69, 4121, 4, 128, 278, 182);
INSERT INTO public.who_global_data VALUES (65823, 3, 423, 0, 0, 278, 145);
INSERT INTO public.who_global_data VALUES (65824, 431, 13163, 9, 780, 278, 26);
INSERT INTO public.who_global_data VALUES (65825, 10581, 145268, 76, 1356, 278, 170);
INSERT INTO public.who_global_data VALUES (65826, 4, 259, 0, 0, 278, 191);
INSERT INTO public.who_global_data VALUES (65827, 0, 2, 0, 0, 278, 221);
INSERT INTO public.who_global_data VALUES (65828, 0, 6, 0, 0, 278, 64);
INSERT INTO public.who_global_data VALUES (65829, 0, 0, 0, 0, 278, 116);
INSERT INTO public.who_global_data VALUES (65830, 0, 15, 0, 0, 278, 128);
INSERT INTO public.who_global_data VALUES (65831, 0, 17, 0, 0, 278, 6);
INSERT INTO public.who_global_data VALUES (65832, 0, 38, 0, 3, 278, 227);
INSERT INTO public.who_global_data VALUES (65833, 0, 1, 0, 0, 278, 68);
INSERT INTO public.who_global_data VALUES (65834, 0, 16, 0, 0, 278, 184);
INSERT INTO public.who_global_data VALUES (65835, 0, 0, 0, 0, 278, 82);
INSERT INTO public.who_global_data VALUES (65836, 2, 582, 0, 41, 278, 149);
INSERT INTO public.who_global_data VALUES (65837, 0, 23, 0, 3, 278, 197);
INSERT INTO public.who_global_data VALUES (65838, 1645, 28656, 7, 191, 278, 78);
INSERT INTO public.who_global_data VALUES (65839, 158, 1271, 0, 9, 278, 233);
INSERT INTO public.who_global_data VALUES (65840, 102, 9464, 4, 193, 278, 133);
INSERT INTO public.who_global_data VALUES (65841, 0, 11, 0, 0, 278, 35);
INSERT INTO public.who_global_data VALUES (65842, 2, 157, 0, 8, 278, 114);
INSERT INTO public.who_global_data VALUES (65843, 657, 18205, 1, 18, 278, 237);
INSERT INTO public.who_global_data VALUES (65844, 0, 2, 0, 0, 278, 55);
INSERT INTO public.who_global_data VALUES (65845, 0, 76, 0, 13, 278, 176);
INSERT INTO public.who_global_data VALUES (65846, 1, 1408, 0, 24, 278, 202);
INSERT INTO public.who_global_data VALUES (65847, 0, 1439, 1, 105, 278, 155);
INSERT INTO public.who_global_data VALUES (65848, 0, 0, 0, 0, 278, 32);
INSERT INTO public.who_global_data VALUES (65849, 34, 756, 3, 35, 278, 220);
INSERT INTO public.who_global_data VALUES (65850, 447, 6783, 8, 131, 278, 30);
INSERT INTO public.who_global_data VALUES (65851, 1, 46, 0, 0, 278, 147);
INSERT INTO public.who_global_data VALUES (65852, 567, 227338, 202, 26501, 278, 208);
INSERT INTO public.who_global_data VALUES (65853, 13, 718, 0, 7, 278, 45);
INSERT INTO public.who_global_data VALUES (65854, 86, 678, 0, 41, 278, 110);
INSERT INTO public.who_global_data VALUES (65855, 0, 10, 0, 1, 278, 88);
INSERT INTO public.who_global_data VALUES (65856, 299, 22435, 72, 3064, 278, 51);
INSERT INTO public.who_global_data VALUES (65857, 22, 29929, 8, 1625, 278, 209);
INSERT INTO public.who_global_data VALUES (65858, 0, 44, 0, 3, 278, 205);
INSERT INTO public.who_global_data VALUES (65859, 52, 128, 2, 4, 278, 18);
INSERT INTO public.who_global_data VALUES (65860, 18, 2987, 0, 54, 278, 72);
INSERT INTO public.who_global_data VALUES (65861, 3229, 185528, 253, 28218, 278, 44);
INSERT INTO public.who_global_data VALUES (65862, 0, 24, 0, 0, 278, 15);
INSERT INTO public.who_global_data VALUES (65863, 1, 124, 0, 9, 278, 25);
INSERT INTO public.who_global_data VALUES (65864, 0, 0, 0, 0, 278, 179);
INSERT INTO public.who_global_data VALUES (65865, 0, 0, 0, 0, 278, 34);
INSERT INTO public.who_global_data VALUES (65866, 0, 116, 0, 8, 278, 207);
INSERT INTO public.who_global_data VALUES (65867, 4, 1013, 0, 42, 278, 166);
INSERT INTO public.who_global_data VALUES (65868, 1670, 126045, 61, 3397, 278, 126);
INSERT INTO public.who_global_data VALUES (65869, 0, 0, 0, 0, 278, 97);
INSERT INTO public.who_global_data VALUES (65870, 0, 12, 0, 1, 278, 36);
INSERT INTO public.who_global_data VALUES (65871, 0, 0, 0, 0, 278, 125);
INSERT INTO public.who_global_data VALUES (65872, 3, 88, 0, 0, 278, 124);
INSERT INTO public.who_global_data VALUES (65873, 418, 12331, 15, 303, 278, 185);
INSERT INTO public.who_global_data VALUES (65874, 0, 14163, 0, 126, 278, 194);
INSERT INTO public.who_global_data VALUES (65875, 0, 480, 0, 18, 278, 144);
INSERT INTO public.who_global_data VALUES (65876, 31839, 1125719, 156, 67793, 278, 19);
INSERT INTO public.who_global_data VALUES (65877, 0, 66, 0, 4, 278, 217);
INSERT INTO public.who_global_data VALUES (65878, 4, 652, 0, 17, 278, 148);
INSERT INTO public.who_global_data VALUES (65879, 33, 2160, 1, 10, 278, 86);
INSERT INTO public.who_global_data VALUES (65880, 0, 0, 0, 0, 278, 13);
INSERT INTO public.who_global_data VALUES (65881, 0, 345, 0, 10, 278, 157);
INSERT INTO public.who_global_data VALUES (65882, 1, 271, 0, 0, 278, 8);
INSERT INTO public.who_global_data VALUES (65883, 0, 0, 0, 0, 278, 73);
INSERT INTO public.who_global_data VALUES (65884, 0, 10, 0, 2, 278, 101);
INSERT INTO public.who_global_data VALUES (65885, 5, 124, 0, 3, 278, 165);
INSERT INTO public.who_global_data VALUES (65886, 0, 34, 0, 4, 278, 14);
INSERT INTO public.who_global_data VALUES (65887, 0, 2469, 0, 72, 279, 193);
INSERT INTO public.who_global_data VALUES (65888, 6, 757, 0, 30, 279, 113);
INSERT INTO public.who_global_data VALUES (65889, 141, 4295, 6, 459, 279, 143);
INSERT INTO public.who_global_data VALUES (65890, 0, 0, 0, 0, 279, 219);
INSERT INTO public.who_global_data VALUES (65891, 1, 747, 1, 44, 279, 186);
INSERT INTO public.who_global_data VALUES (65892, 6, 35, 0, 2, 279, 52);
INSERT INTO public.who_global_data VALUES (65893, 0, 3, 0, 0, 279, 180);
INSERT INTO public.who_global_data VALUES (65894, 0, 24, 0, 3, 279, 167);
INSERT INTO public.who_global_data VALUES (65895, 56, 4532, 9, 229, 279, 154);
INSERT INTO public.who_global_data VALUES (65896, 125, 2249, 0, 33, 279, 94);
INSERT INTO public.who_global_data VALUES (65897, 0, 100, 0, 2, 279, 66);
INSERT INTO public.who_global_data VALUES (65898, 16, 6783, 0, 93, 279, 58);
INSERT INTO public.who_global_data VALUES (65899, 12, 15470, 7, 596, 279, 163);
INSERT INTO public.who_global_data VALUES (65900, 40, 1894, 0, 25, 279, 37);
INSERT INTO public.who_global_data VALUES (65901, 1, 82, 0, 11, 279, 142);
INSERT INTO public.who_global_data VALUES (65902, 83, 3356, 0, 8, 279, 83);
INSERT INTO public.who_global_data VALUES (65903, 665, 9455, 2, 177, 279, 228);
INSERT INTO public.who_global_data VALUES (65904, 0, 81, 0, 7, 279, 188);
INSERT INTO public.who_global_data VALUES (65905, 911, 15828, 4, 97, 279, 62);
INSERT INTO public.who_global_data VALUES (65906, 286, 51148, 75, 8032, 279, 160);
INSERT INTO public.who_global_data VALUES (65907, 0, 18, 0, 2, 279, 50);
INSERT INTO public.who_global_data VALUES (65908, 0, 90, 0, 2, 279, 33);
INSERT INTO public.who_global_data VALUES (65909, 0, 114, 0, 6, 279, 183);
INSERT INTO public.who_global_data VALUES (65910, 0, 7, 0, 0, 279, 92);
INSERT INTO public.who_global_data VALUES (65911, 62, 1229, 4, 66, 279, 158);
INSERT INTO public.who_global_data VALUES (65912, 0, 2, 0, 0, 279, 67);
INSERT INTO public.who_global_data VALUES (65913, 0, 1840, 0, 71, 279, 57);
INSERT INTO public.who_global_data VALUES (65914, 0, 23, 0, 1, 279, 38);
INSERT INTO public.who_global_data VALUES (65915, 6209, 91589, 428, 6329, 279, 141);
INSERT INTO public.who_global_data VALUES (65916, 0, 6, 0, 1, 279, 178);
INSERT INTO public.who_global_data VALUES (65917, 0, 138, 0, 1, 279, 108);
INSERT INTO public.who_global_data VALUES (65918, 6, 1594, 3, 72, 279, 39);
INSERT INTO public.who_global_data VALUES (65919, 3, 652, 0, 44, 279, 2);
INSERT INTO public.who_global_data VALUES (65920, 4, 19, 0, 1, 279, 195);
INSERT INTO public.who_global_data VALUES (65921, 31, 152, 1, 2, 279, 107);
INSERT INTO public.who_global_data VALUES (65922, 0, 122, 0, 0, 279, 161);
INSERT INTO public.who_global_data VALUES (65923, 8, 2077, 3, 64, 279, 212);
INSERT INTO public.who_global_data VALUES (65924, 1915, 55572, 223, 3446, 279, 181);
INSERT INTO public.who_global_data VALUES (65925, 1, 74, 0, 1, 279, 53);
INSERT INTO public.who_global_data VALUES (65926, 8, 72, 0, 0, 279, 164);
INSERT INTO public.who_global_data VALUES (65927, 44, 117, 5, 10, 279, 140);
INSERT INTO public.who_global_data VALUES (65928, 1427, 18435, 13, 247, 279, 20);
INSERT INTO public.who_global_data VALUES (65929, 2, 84393, 0, 4643, 279, 112);
INSERT INTO public.who_global_data VALUES (65930, 499, 7006, 21, 314, 279, 111);
INSERT INTO public.who_global_data VALUES (65931, 2, 3, 0, 0, 279, 71);
INSERT INTO public.who_global_data VALUES (65932, 0, 229, 0, 10, 279, 218);
INSERT INTO public.who_global_data VALUES (65933, 0, 0, 0, 0, 279, 43);
INSERT INTO public.who_global_data VALUES (65934, 6, 725, 0, 6, 279, 49);
INSERT INTO public.who_global_data VALUES (65935, 87, 1362, 1, 15, 279, 1);
INSERT INTO public.who_global_data VALUES (65936, 3, 2088, 2, 77, 279, 48);
INSERT INTO public.who_global_data VALUES (65937, 74, 1611, 2, 66, 279, 232);
INSERT INTO public.who_global_data VALUES (65938, 0, 16, 0, 1, 279, 175);
INSERT INTO public.who_global_data VALUES (65939, 7, 864, 0, 15, 279, 21);
INSERT INTO public.who_global_data VALUES (65940, 18, 7755, 5, 245, 279, 156);
INSERT INTO public.who_global_data VALUES (65941, 0, 0, 0, 0, 279, 95);
INSERT INTO public.who_global_data VALUES (65942, 70, 674, 1, 33, 279, 177);
INSERT INTO public.who_global_data VALUES (65943, 96, 9407, 15, 475, 279, 210);
INSERT INTO public.who_global_data VALUES (65944, 0, 1112, 0, 2, 279, 120);
INSERT INTO public.who_global_data VALUES (65945, 0, 16, 0, 0, 279, 135);
INSERT INTO public.who_global_data VALUES (65946, 290, 7578, 13, 326, 279, 206);
INSERT INTO public.who_global_data VALUES (65947, 1128, 27464, 308, 1371, 279, 189);
INSERT INTO public.who_global_data VALUES (65948, 298, 6193, 9, 415, 279, 129);
INSERT INTO public.who_global_data VALUES (65949, 22, 446, 0, 10, 279, 121);
INSERT INTO public.who_global_data VALUES (65950, 0, 315, 0, 2, 279, 59);
INSERT INTO public.who_global_data VALUES (65951, 0, 39, 0, 0, 279, 96);
INSERT INTO public.who_global_data VALUES (65952, 5, 1699, 1, 53, 279, 41);
INSERT INTO public.who_global_data VALUES (65953, 2, 108, 0, 1, 279, 216);
INSERT INTO public.who_global_data VALUES (65954, 0, 133, 0, 3, 279, 236);
INSERT INTO public.who_global_data VALUES (65955, 0, 13, 0, 0, 279, 150);
INSERT INTO public.who_global_data VALUES (65956, 0, 187, 0, 0, 279, 61);
INSERT INTO public.who_global_data VALUES (65957, 0, 18, 0, 0, 279, 7);
INSERT INTO public.who_global_data VALUES (65958, 128, 5179, 2, 220, 279, 169);
INSERT INTO public.who_global_data VALUES (65959, 736, 129458, 164, 24724, 279, 28);
INSERT INTO public.who_global_data VALUES (65960, 0, 128, 0, 1, 279, 85);
INSERT INTO public.who_global_data VALUES (65961, 0, 58, 0, 0, 279, 211);
INSERT INTO public.who_global_data VALUES (65962, 27, 335, 1, 5, 279, 60);
INSERT INTO public.who_global_data VALUES (65963, 5, 17, 0, 1, 279, 3);
INSERT INTO public.who_global_data VALUES (65964, 7, 589, 0, 8, 279, 11);
INSERT INTO public.who_global_data VALUES (65965, 793, 162496, 74, 6649, 279, 89);
INSERT INTO public.who_global_data VALUES (65966, 95, 2169, 1, 18, 279, 24);
INSERT INTO public.who_global_data VALUES (65967, 0, 144, 0, 0, 279, 162);
INSERT INTO public.who_global_data VALUES (65968, 29, 2620, 3, 143, 279, 100);
INSERT INTO public.who_global_data VALUES (65969, 0, 11, 0, 0, 279, 47);
INSERT INTO public.who_global_data VALUES (65970, 0, 20, 0, 0, 279, 29);
INSERT INTO public.who_global_data VALUES (65971, 0, 152, 0, 12, 279, 40);
INSERT INTO public.who_global_data VALUES (65972, 1, 143, 0, 5, 279, 222);
INSERT INTO public.who_global_data VALUES (65973, 45, 644, 2, 18, 279, 132);
INSERT INTO public.who_global_data VALUES (65974, 1, 252, 0, 13, 279, 130);
INSERT INTO public.who_global_data VALUES (65975, 49, 1586, 0, 7, 279, 234);
INSERT INTO public.who_global_data VALUES (65976, 3, 260, 0, 1, 279, 23);
INSERT INTO public.who_global_data VALUES (65977, 0, 82, 0, 9, 279, 192);
INSERT INTO public.who_global_data VALUES (65978, 4, 85, 0, 8, 279, 69);
INSERT INTO public.who_global_data VALUES (65979, 0, 11, 0, 0, 279, 187);
INSERT INTO public.who_global_data VALUES (65980, 95, 899, 0, 75, 279, 230);
INSERT INTO public.who_global_data VALUES (65981, 56, 2998, 5, 340, 279, 77);
INSERT INTO public.who_global_data VALUES (65982, 0, 1798, 0, 10, 279, 9);
INSERT INTO public.who_global_data VALUES (65983, 2644, 39980, 83, 1301, 279, 74);
INSERT INTO public.who_global_data VALUES (65984, 349, 11192, 14, 845, 279, 224);
INSERT INTO public.who_global_data VALUES (65985, 976, 97424, 47, 6203, 279, 199);
INSERT INTO public.who_global_data VALUES (65986, 66, 2219, 1, 95, 279, 190);
INSERT INTO public.who_global_data VALUES (65987, 343, 21176, 0, 1265, 279, 12);
INSERT INTO public.who_global_data VALUES (65988, 4, 315, 1, 23, 279, 104);
INSERT INTO public.who_global_data VALUES (65989, 116, 16018, 4, 229, 279, 153);
INSERT INTO public.who_global_data VALUES (65990, 1900, 209328, 474, 28710, 279, 91);
INSERT INTO public.who_global_data VALUES (65991, 10, 432, 0, 8, 279, 215);
INSERT INTO public.who_global_data VALUES (65992, 294, 14839, 38, 492, 279, 84);
INSERT INTO public.who_global_data VALUES (65993, 0, 290, 1, 23, 279, 231);
INSERT INTO public.who_global_data VALUES (65994, 2, 461, 0, 9, 279, 196);
INSERT INTO public.who_global_data VALUES (65995, 111, 3988, 1, 27, 279, 105);
INSERT INTO public.who_global_data VALUES (65996, 24, 435, 1, 22, 279, 122);
INSERT INTO public.who_global_data VALUES (65997, 0, 0, 0, 0, 279, 159);
INSERT INTO public.who_global_data VALUES (65998, 10, 823, 0, 17, 279, 75);
INSERT INTO public.who_global_data VALUES (65999, 364, 4983, 5, 38, 279, 27);
INSERT INTO public.who_global_data VALUES (66000, 26, 795, 2, 10, 279, 54);
INSERT INTO public.who_global_data VALUES (66001, 0, 19, 0, 0, 279, 226);
INSERT INTO public.who_global_data VALUES (66002, 1, 871, 0, 16, 279, 79);
INSERT INTO public.who_global_data VALUES (66003, 4, 737, 0, 25, 279, 56);
INSERT INTO public.who_global_data VALUES (66004, 0, 0, 0, 0, 279, 117);
INSERT INTO public.who_global_data VALUES (66005, 2, 154, 0, 18, 279, 152);
INSERT INTO public.who_global_data VALUES (66006, 0, 63, 0, 3, 279, 16);
INSERT INTO public.who_global_data VALUES (66007, 0, 83, 0, 1, 279, 10);
INSERT INTO public.who_global_data VALUES (66008, 5, 1399, 0, 46, 279, 201);
INSERT INTO public.who_global_data VALUES (66009, 10, 3812, 0, 92, 279, 174);
INSERT INTO public.who_global_data VALUES (66010, 14, 149, 0, 0, 279, 119);
INSERT INTO public.who_global_data VALUES (66011, 1, 38, 0, 3, 279, 168);
INSERT INTO public.who_global_data VALUES (66012, 105, 6176, 0, 103, 279, 99);
INSERT INTO public.who_global_data VALUES (66013, 28, 519, 0, 1, 279, 171);
INSERT INTO public.who_global_data VALUES (66014, 36, 544, 0, 26, 279, 87);
INSERT INTO public.who_global_data VALUES (66015, 9, 476, 0, 4, 279, 123);
INSERT INTO public.who_global_data VALUES (66016, 0, 0, 0, 0, 279, 151);
INSERT INTO public.who_global_data VALUES (66017, 1, 180, 0, 14, 279, 213);
INSERT INTO public.who_global_data VALUES (66018, 0, 8, 0, 1, 279, 118);
INSERT INTO public.who_global_data VALUES (66019, 0, 332, 0, 10, 279, 134);
INSERT INTO public.who_global_data VALUES (66020, 57, 596, 2, 6, 279, 65);
INSERT INTO public.who_global_data VALUES (66021, 1515, 20739, 113, 1972, 279, 102);
INSERT INTO public.who_global_data VALUES (66022, 0, 0, 0, 0, 279, 223);
INSERT INTO public.who_global_data VALUES (66023, 0, 66, 0, 1, 279, 4);
INSERT INTO public.who_global_data VALUES (66024, 1, 39, 0, 0, 279, 146);
INSERT INTO public.who_global_data VALUES (66025, 1, 323, 0, 8, 279, 31);
INSERT INTO public.who_global_data VALUES (66026, 0, 11, 0, 1, 279, 127);
INSERT INTO public.who_global_data VALUES (66027, 193, 4880, 2, 174, 279, 22);
INSERT INTO public.who_global_data VALUES (66028, 0, 79, 0, 0, 279, 115);
INSERT INTO public.who_global_data VALUES (66029, 0, 151, 0, 6, 279, 106);
INSERT INTO public.who_global_data VALUES (66030, 0, 16, 0, 0, 279, 90);
INSERT INTO public.who_global_data VALUES (66031, 0, 0, 0, 0, 279, 70);
INSERT INTO public.who_global_data VALUES (66032, 10, 69, 0, 0, 279, 46);
INSERT INTO public.who_global_data VALUES (66033, 437, 39982, 87, 4943, 279, 139);
INSERT INTO public.who_global_data VALUES (66034, 0, 18, 0, 0, 279, 42);
INSERT INTO public.who_global_data VALUES (66035, 2, 1136, 0, 20, 279, 80);
INSERT INTO public.who_global_data VALUES (66036, 0, 14, 0, 4, 279, 203);
INSERT INTO public.who_global_data VALUES (66037, 8, 736, 2, 35, 279, 136);
INSERT INTO public.who_global_data VALUES (66038, 218, 2388, 17, 85, 279, 63);
INSERT INTO public.who_global_data VALUES (66039, 0, 0, 0, 0, 279, 17);
INSERT INTO public.who_global_data VALUES (66040, 0, 14, 0, 2, 279, 172);
INSERT INTO public.who_global_data VALUES (66041, 12, 1506, 1, 82, 279, 109);
INSERT INTO public.who_global_data VALUES (66042, 0, 7759, 0, 204, 279, 200);
INSERT INTO public.who_global_data VALUES (66043, 0, 353, 0, 2, 279, 93);
INSERT INTO public.who_global_data VALUES (66044, 85, 2568, 0, 12, 279, 5);
INSERT INTO public.who_global_data VALUES (66045, 0, 712, 0, 13, 279, 214);
INSERT INTO public.who_global_data VALUES (66046, 1314, 20084, 25, 457, 279, 204);
INSERT INTO public.who_global_data VALUES (66047, 0, 0, 0, 0, 279, 198);
INSERT INTO public.who_global_data VALUES (66048, 188, 6720, 4, 192, 279, 173);
INSERT INTO public.who_global_data VALUES (66049, 0, 8, 0, 0, 279, 229);
INSERT INTO public.who_global_data VALUES (66050, 67, 333, 0, 10, 279, 76);
INSERT INTO public.who_global_data VALUES (66051, 3483, 40459, 73, 1124, 279, 138);
INSERT INTO public.who_global_data VALUES (66052, 156, 8928, 24, 603, 279, 98);
INSERT INTO public.who_global_data VALUES (66053, 0, 0, 0, 0, 279, 103);
INSERT INTO public.who_global_data VALUES (66054, 270, 13375, 13, 664, 279, 225);
INSERT INTO public.who_global_data VALUES (66055, -161, 25190, 16, 1023, 279, 131);
INSERT INTO public.who_global_data VALUES (66056, 182, 1757, 0, 54, 279, 235);
INSERT INTO public.who_global_data VALUES (66057, 679, 15551, 0, 12, 279, 137);
INSERT INTO public.who_global_data VALUES (66058, 13, 10793, 0, 250, 279, 81);
INSERT INTO public.who_global_data VALUES (66059, 72, 4052, 2, 124, 279, 182);
INSERT INTO public.who_global_data VALUES (66060, 0, 420, 0, 0, 279, 145);
INSERT INTO public.who_global_data VALUES (66061, 165, 12732, 27, 771, 279, 26);
INSERT INTO public.who_global_data VALUES (66062, 10633, 134687, 58, 1280, 279, 170);
INSERT INTO public.who_global_data VALUES (66063, 6, 255, 0, 0, 279, 191);
INSERT INTO public.who_global_data VALUES (66064, 0, 2, 0, 0, 279, 221);
INSERT INTO public.who_global_data VALUES (66065, 0, 6, 0, 0, 279, 64);
INSERT INTO public.who_global_data VALUES (66066, 0, 0, 0, 0, 279, 116);
INSERT INTO public.who_global_data VALUES (66067, 0, 15, 0, 0, 279, 128);
INSERT INTO public.who_global_data VALUES (66068, 0, 17, 0, 0, 279, 6);
INSERT INTO public.who_global_data VALUES (66069, 0, 38, 0, 3, 279, 227);
INSERT INTO public.who_global_data VALUES (66070, 0, 1, 0, 0, 279, 68);
INSERT INTO public.who_global_data VALUES (66071, 0, 16, 0, 0, 279, 184);
INSERT INTO public.who_global_data VALUES (66072, 0, 0, 0, 0, 279, 82);
INSERT INTO public.who_global_data VALUES (66073, 0, 580, 0, 41, 279, 149);
INSERT INTO public.who_global_data VALUES (66074, 7, 23, 2, 3, 279, 197);
INSERT INTO public.who_global_data VALUES (66075, 1552, 27011, 8, 184, 279, 78);
INSERT INTO public.who_global_data VALUES (66076, 89, 1113, 0, 9, 279, 233);
INSERT INTO public.who_global_data VALUES (66077, 157, 9362, 4, 189, 279, 133);
INSERT INTO public.who_global_data VALUES (66078, 0, 11, 0, 0, 279, 35);
INSERT INTO public.who_global_data VALUES (66079, 19, 155, 0, 8, 279, 114);
INSERT INTO public.who_global_data VALUES (66080, 447, 17548, 1, 17, 279, 237);
INSERT INTO public.who_global_data VALUES (66081, 0, 2, 0, 0, 279, 55);
INSERT INTO public.who_global_data VALUES (66082, 0, 76, 0, 13, 279, 176);
INSERT INTO public.who_global_data VALUES (66083, 4, 1407, 1, 24, 279, 202);
INSERT INTO public.who_global_data VALUES (66084, 0, 1439, 2, 104, 279, 155);
INSERT INTO public.who_global_data VALUES (66085, 0, 0, 0, 0, 279, 32);
INSERT INTO public.who_global_data VALUES (66086, 51, 722, 1, 32, 279, 220);
INSERT INTO public.who_global_data VALUES (66087, 385, 6336, 7, 123, 279, 30);
INSERT INTO public.who_global_data VALUES (66088, 0, 45, 0, 0, 279, 147);
INSERT INTO public.who_global_data VALUES (66089, 796, 226771, 176, 26299, 279, 208);
INSERT INTO public.who_global_data VALUES (66090, 15, 705, 0, 7, 279, 45);
INSERT INTO public.who_global_data VALUES (66091, 59, 592, 5, 41, 279, 110);
INSERT INTO public.who_global_data VALUES (66092, 0, 10, 0, 1, 279, 88);
INSERT INTO public.who_global_data VALUES (66093, 532, 22136, 78, 2992, 279, 51);
INSERT INTO public.who_global_data VALUES (66094, 47, 29907, 9, 1617, 279, 209);
INSERT INTO public.who_global_data VALUES (66095, 0, 44, 0, 3, 279, 205);
INSERT INTO public.who_global_data VALUES (66096, 44, 76, 2, 2, 279, 18);
INSERT INTO public.who_global_data VALUES (66097, 3, 2969, 0, 54, 279, 72);
INSERT INTO public.who_global_data VALUES (66098, 4737, 182299, 584, 27965, 279, 44);
INSERT INTO public.who_global_data VALUES (66099, 0, 24, 0, 0, 279, 15);
INSERT INTO public.who_global_data VALUES (66100, 0, 123, 0, 9, 279, 25);
INSERT INTO public.who_global_data VALUES (66101, 0, 0, 0, 0, 279, 179);
INSERT INTO public.who_global_data VALUES (66102, 0, 0, 0, 0, 279, 34);
INSERT INTO public.who_global_data VALUES (66103, 0, 116, 0, 8, 279, 207);
INSERT INTO public.who_global_data VALUES (66104, 11, 1009, 1, 42, 279, 166);
INSERT INTO public.who_global_data VALUES (66105, 1983, 124375, 78, 3336, 279, 126);
INSERT INTO public.who_global_data VALUES (66106, 0, 0, 0, 0, 279, 97);
INSERT INTO public.who_global_data VALUES (66107, 0, 12, 0, 1, 279, 36);
INSERT INTO public.who_global_data VALUES (66108, 0, 0, 0, 0, 279, 125);
INSERT INTO public.who_global_data VALUES (66109, 2, 85, 0, 0, 279, 124);
INSERT INTO public.who_global_data VALUES (66110, 502, 11913, 9, 288, 279, 185);
INSERT INTO public.who_global_data VALUES (66111, 1125, 14163, 15, 126, 279, 194);
INSERT INTO public.who_global_data VALUES (66112, 0, 480, 1, 18, 279, 144);
INSERT INTO public.who_global_data VALUES (66113, 26753, 1093880, 5000, 67637, 279, 19);
INSERT INTO public.who_global_data VALUES (66114, 0, 66, 0, 4, 279, 217);
INSERT INTO public.who_global_data VALUES (66115, 5, 648, 0, 17, 279, 148);
INSERT INTO public.who_global_data VALUES (66116, 33, 2127, 0, 9, 279, 86);
INSERT INTO public.who_global_data VALUES (66117, 0, 0, 0, 0, 279, 13);
INSERT INTO public.who_global_data VALUES (66118, 12, 345, 0, 10, 279, 157);
INSERT INTO public.who_global_data VALUES (66119, 0, 270, 0, 0, 279, 8);
INSERT INTO public.who_global_data VALUES (66120, 0, 0, 0, 0, 279, 73);
INSERT INTO public.who_global_data VALUES (66121, 3, 10, 0, 2, 279, 101);
INSERT INTO public.who_global_data VALUES (66122, 10, 119, 0, 3, 279, 165);
INSERT INTO public.who_global_data VALUES (66123, 0, 34, 0, 4, 279, 14);
INSERT INTO public.who_global_data VALUES (66124, 298, 2469, 8, 72, 280, 193);
INSERT INTO public.who_global_data VALUES (66125, 16, 751, 0, 30, 280, 113);
INSERT INTO public.who_global_data VALUES (66126, 148, 4154, 3, 453, 280, 143);
INSERT INTO public.who_global_data VALUES (66127, 0, 0, 0, 0, 280, 219);
INSERT INTO public.who_global_data VALUES (66128, 0, 746, 1, 43, 280, 186);
INSERT INTO public.who_global_data VALUES (66129, 2, 29, 0, 2, 280, 52);
INSERT INTO public.who_global_data VALUES (66130, 0, 3, 0, 0, 280, 180);
INSERT INTO public.who_global_data VALUES (66131, 0, 24, 0, 3, 280, 167);
INSERT INTO public.who_global_data VALUES (66132, 172, 4476, 5, 220, 280, 154);
INSERT INTO public.who_global_data VALUES (66133, 82, 2124, 1, 33, 280, 94);
INSERT INTO public.who_global_data VALUES (66134, 0, 100, 0, 2, 280, 66);
INSERT INTO public.who_global_data VALUES (66135, 5, 6767, 1, 93, 280, 58);
INSERT INTO public.who_global_data VALUES (66136, 34, 15458, 5, 589, 280, 163);
INSERT INTO public.who_global_data VALUES (66137, 50, 1854, 1, 25, 280, 37);
INSERT INTO public.who_global_data VALUES (66138, 1, 81, 0, 11, 280, 142);
INSERT INTO public.who_global_data VALUES (66139, 104, 3273, 0, 8, 280, 83);
INSERT INTO public.who_global_data VALUES (66140, 552, 8790, 5, 175, 280, 228);
INSERT INTO public.who_global_data VALUES (66141, 1, 81, 0, 7, 280, 188);
INSERT INTO public.who_global_data VALUES (66142, 890, 14917, 4, 93, 280, 62);
INSERT INTO public.who_global_data VALUES (66143, 237, 50862, 93, 7957, 280, 160);
INSERT INTO public.who_global_data VALUES (66144, 0, 18, 0, 2, 280, 50);
INSERT INTO public.who_global_data VALUES (66145, 6, 90, 0, 2, 280, 33);
INSERT INTO public.who_global_data VALUES (66146, 3, 114, 0, 6, 280, 183);
INSERT INTO public.who_global_data VALUES (66147, 0, 7, 0, 0, 280, 92);
INSERT INTO public.who_global_data VALUES (66148, 57, 1167, 3, 62, 280, 158);
INSERT INTO public.who_global_data VALUES (66149, 0, 2, 0, 0, 280, 67);
INSERT INTO public.who_global_data VALUES (66150, 58, 1840, 2, 71, 280, 57);
INSERT INTO public.who_global_data VALUES (66151, 0, 23, 0, 1, 280, 38);
INSERT INTO public.who_global_data VALUES (66152, 7218, 85380, 435, 5901, 280, 141);
INSERT INTO public.who_global_data VALUES (66153, 0, 6, 0, 1, 280, 178);
INSERT INTO public.who_global_data VALUES (66154, 0, 138, 0, 1, 280, 108);
INSERT INTO public.who_global_data VALUES (66155, 82, 1588, 3, 69, 280, 39);
INSERT INTO public.who_global_data VALUES (66156, 4, 649, 1, 44, 280, 2);
INSERT INTO public.who_global_data VALUES (66157, 0, 15, 0, 1, 280, 195);
INSERT INTO public.who_global_data VALUES (66158, 0, 121, 0, 1, 280, 107);
INSERT INTO public.who_global_data VALUES (66159, 0, 122, 0, 0, 280, 161);
INSERT INTO public.who_global_data VALUES (66160, 237, 2069, 0, 61, 280, 212);
INSERT INTO public.who_global_data VALUES (66161, 1601, 53657, 141, 3223, 280, 181);
INSERT INTO public.who_global_data VALUES (66162, 0, 73, 0, 1, 280, 53);
INSERT INTO public.who_global_data VALUES (66163, 0, 64, 0, 0, 280, 164);
INSERT INTO public.who_global_data VALUES (66164, 0, 73, 2, 5, 280, 140);
INSERT INTO public.who_global_data VALUES (66165, 985, 17008, 7, 234, 280, 20);
INSERT INTO public.who_global_data VALUES (66166, 6, 84391, 0, 4643, 280, 112);
INSERT INTO public.who_global_data VALUES (66167, 296, 6507, 15, 293, 280, 111);
INSERT INTO public.who_global_data VALUES (66168, 0, 1, 0, 0, 280, 71);
INSERT INTO public.who_global_data VALUES (66169, 9, 229, 1, 10, 280, 218);
INSERT INTO public.who_global_data VALUES (66170, 0, 0, 0, 0, 280, 43);
INSERT INTO public.who_global_data VALUES (66171, 6, 719, 0, 6, 280, 49);
INSERT INTO public.who_global_data VALUES (66172, 0, 1275, 0, 14, 280, 1);
INSERT INTO public.who_global_data VALUES (66173, 9, 2085, 6, 75, 280, 48);
INSERT INTO public.who_global_data VALUES (66174, 36, 1537, 3, 64, 280, 232);
INSERT INTO public.who_global_data VALUES (66175, 0, 16, 0, 1, 280, 175);
INSERT INTO public.who_global_data VALUES (66176, 7, 857, 0, 15, 280, 21);
INSERT INTO public.who_global_data VALUES (66177, 55, 7737, 4, 240, 280, 156);
INSERT INTO public.who_global_data VALUES (66178, 0, 0, 0, 0, 280, 95);
INSERT INTO public.who_global_data VALUES (66179, 32, 604, 1, 32, 280, 177);
INSERT INTO public.who_global_data VALUES (66180, 153, 9311, 8, 460, 280, 210);
INSERT INTO public.who_global_data VALUES (66181, 15, 1112, 0, 2, 280, 120);
INSERT INTO public.who_global_data VALUES (66182, 0, 16, 0, 0, 280, 135);
INSERT INTO public.who_global_data VALUES (66183, 316, 7288, 12, 313, 280, 206);
INSERT INTO public.who_global_data VALUES (66184, 1402, 26336, 163, 1063, 280, 189);
INSERT INTO public.who_global_data VALUES (66185, 0, 5895, 0, 406, 280, 129);
INSERT INTO public.who_global_data VALUES (66186, 29, 424, 1, 10, 280, 121);
INSERT INTO public.who_global_data VALUES (66187, 0, 315, 0, 2, 280, 59);
INSERT INTO public.who_global_data VALUES (66188, 0, 39, 0, 0, 280, 96);
INSERT INTO public.who_global_data VALUES (66189, 5, 1694, 0, 52, 280, 41);
INSERT INTO public.who_global_data VALUES (66190, 6, 106, 0, 1, 280, 216);
INSERT INTO public.who_global_data VALUES (66191, 2, 133, 0, 3, 280, 236);
INSERT INTO public.who_global_data VALUES (66192, 0, 13, 0, 0, 280, 150);
INSERT INTO public.who_global_data VALUES (66193, 0, 187, 0, 0, 280, 61);
INSERT INTO public.who_global_data VALUES (66194, 0, 18, 0, 0, 280, 7);
INSERT INTO public.who_global_data VALUES (66195, 56, 5051, 7, 218, 280, 169);
INSERT INTO public.who_global_data VALUES (66196, 601, 128722, 218, 24560, 280, 28);
INSERT INTO public.who_global_data VALUES (66197, 2, 128, 0, 1, 280, 85);
INSERT INTO public.who_global_data VALUES (66198, 0, 58, 0, 0, 280, 211);
INSERT INTO public.who_global_data VALUES (66199, 32, 308, 1, 4, 280, 60);
INSERT INTO public.who_global_data VALUES (66200, 0, 12, 0, 1, 280, 3);
INSERT INTO public.who_global_data VALUES (66201, 16, 582, 2, 8, 280, 11);
INSERT INTO public.who_global_data VALUES (66202, 945, 161703, 94, 6575, 280, 89);
INSERT INTO public.who_global_data VALUES (66203, 0, 2074, 0, 17, 280, 24);
INSERT INTO public.who_global_data VALUES (66204, 3, 144, 0, 0, 280, 162);
INSERT INTO public.who_global_data VALUES (66205, 0, 2591, 0, 140, 280, 100);
INSERT INTO public.who_global_data VALUES (66206, 0, 11, 0, 0, 280, 47);
INSERT INTO public.who_global_data VALUES (66207, 0, 20, 0, 0, 280, 29);
INSERT INTO public.who_global_data VALUES (66208, 0, 152, 0, 12, 280, 40);
INSERT INTO public.who_global_data VALUES (66209, 0, 142, 0, 5, 280, 222);
INSERT INTO public.who_global_data VALUES (66210, 14, 599, 0, 16, 280, 132);
INSERT INTO public.who_global_data VALUES (66211, 0, 251, 0, 13, 280, 130);
INSERT INTO public.who_global_data VALUES (66212, 42, 1537, 0, 7, 280, 234);
INSERT INTO public.who_global_data VALUES (66213, 56, 257, 0, 1, 280, 23);
INSERT INTO public.who_global_data VALUES (66214, 4, 82, 1, 9, 280, 192);
INSERT INTO public.who_global_data VALUES (66215, 5, 81, 1, 8, 280, 69);
INSERT INTO public.who_global_data VALUES (66216, 0, 11, 0, 0, 280, 187);
INSERT INTO public.who_global_data VALUES (66217, 33, 804, 4, 75, 280, 230);
INSERT INTO public.who_global_data VALUES (66218, 79, 2942, 12, 335, 280, 77);
INSERT INTO public.who_global_data VALUES (66219, 1, 1798, 0, 10, 280, 9);
INSERT INTO public.who_global_data VALUES (66220, 2293, 37336, 71, 1218, 280, 74);
INSERT INTO public.who_global_data VALUES (66221, 292, 10843, 31, 831, 280, 224);
INSERT INTO public.who_global_data VALUES (66222, 802, 96448, 65, 6156, 280, 199);
INSERT INTO public.who_global_data VALUES (66223, 68, 2153, 1, 94, 280, 190);
INSERT INTO public.who_global_data VALUES (66224, 221, 20833, 33, 1265, 280, 12);
INSERT INTO public.who_global_data VALUES (66225, 0, 311, 0, 22, 280, 104);
INSERT INTO public.who_global_data VALUES (66226, 142, 15902, 6, 225, 280, 153);
INSERT INTO public.who_global_data VALUES (66227, 1965, 207428, 269, 28236, 280, 91);
INSERT INTO public.who_global_data VALUES (66228, 26, 422, 1, 8, 280, 215);
INSERT INTO public.who_global_data VALUES (66229, 264, 14545, 22, 454, 280, 84);
INSERT INTO public.who_global_data VALUES (66230, 0, 290, 2, 22, 280, 231);
INSERT INTO public.who_global_data VALUES (66231, 6, 459, 1, 9, 280, 196);
INSERT INTO public.who_global_data VALUES (66232, 92, 3877, 1, 26, 280, 105);
INSERT INTO public.who_global_data VALUES (66233, 15, 411, 4, 21, 280, 122);
INSERT INTO public.who_global_data VALUES (66234, 0, 0, 0, 0, 280, 159);
INSERT INTO public.who_global_data VALUES (66235, 14, 813, 0, 17, 280, 75);
INSERT INTO public.who_global_data VALUES (66236, 242, 4619, 3, 33, 280, 27);
INSERT INTO public.who_global_data VALUES (66237, 13, 769, 0, 8, 280, 54);
INSERT INTO public.who_global_data VALUES (66238, 0, 19, 0, 0, 280, 226);
INSERT INTO public.who_global_data VALUES (66239, 12, 870, 1, 16, 280, 79);
INSERT INTO public.who_global_data VALUES (66240, 4, 733, 1, 25, 280, 56);
INSERT INTO public.who_global_data VALUES (66241, 0, 0, 0, 0, 280, 117);
INSERT INTO public.who_global_data VALUES (66242, 11, 152, 2, 18, 280, 152);
INSERT INTO public.who_global_data VALUES (66243, 0, 63, 0, 3, 280, 16);
INSERT INTO public.who_global_data VALUES (66244, 0, 83, 0, 1, 280, 10);
INSERT INTO public.who_global_data VALUES (66245, 5, 1394, 1, 46, 280, 201);
INSERT INTO public.who_global_data VALUES (66246, 18, 3802, 2, 92, 280, 174);
INSERT INTO public.who_global_data VALUES (66247, 3, 135, 0, 0, 280, 119);
INSERT INTO public.who_global_data VALUES (66248, 0, 37, 0, 3, 280, 168);
INSERT INTO public.who_global_data VALUES (66249, 69, 6071, 1, 103, 280, 99);
INSERT INTO public.who_global_data VALUES (66250, 23, 491, 0, 1, 280, 171);
INSERT INTO public.who_global_data VALUES (66251, 18, 508, 0, 26, 280, 87);
INSERT INTO public.who_global_data VALUES (66252, 1, 467, 0, 4, 280, 123);
INSERT INTO public.who_global_data VALUES (66253, 0, 0, 0, 0, 280, 151);
INSERT INTO public.who_global_data VALUES (66254, 1, 179, 0, 14, 280, 213);
INSERT INTO public.who_global_data VALUES (66255, 0, 8, 0, 1, 280, 118);
INSERT INTO public.who_global_data VALUES (66256, 0, 332, 0, 10, 280, 134);
INSERT INTO public.who_global_data VALUES (66257, 0, 539, 0, 4, 280, 65);
INSERT INTO public.who_global_data VALUES (66258, 1425, 19224, 127, 1859, 280, 102);
INSERT INTO public.who_global_data VALUES (66259, 0, 0, 0, 0, 280, 223);
INSERT INTO public.who_global_data VALUES (66260, 0, 66, 0, 1, 280, 4);
INSERT INTO public.who_global_data VALUES (66261, 0, 38, 0, 0, 280, 146);
INSERT INTO public.who_global_data VALUES (66262, 0, 322, 1, 8, 280, 31);
INSERT INTO public.who_global_data VALUES (66263, 0, 11, 0, 1, 280, 127);
INSERT INTO public.who_global_data VALUES (66264, 158, 4687, 1, 172, 280, 22);
INSERT INTO public.who_global_data VALUES (66265, 3, 79, 0, 0, 280, 115);
INSERT INTO public.who_global_data VALUES (66266, 0, 151, 0, 6, 280, 106);
INSERT INTO public.who_global_data VALUES (66267, 0, 16, 0, 0, 280, 90);
INSERT INTO public.who_global_data VALUES (66268, 0, 0, 0, 0, 280, 70);
INSERT INTO public.who_global_data VALUES (66269, 0, 59, 0, 0, 280, 46);
INSERT INTO public.who_global_data VALUES (66270, 478, 39545, 101, 4856, 280, 139);
INSERT INTO public.who_global_data VALUES (66271, 0, 18, 0, 0, 280, 42);
INSERT INTO public.who_global_data VALUES (66272, 2, 1134, 1, 20, 280, 80);
INSERT INTO public.who_global_data VALUES (66273, 0, 14, 0, 4, 280, 203);
INSERT INTO public.who_global_data VALUES (66274, 9, 728, 1, 33, 280, 136);
INSERT INTO public.who_global_data VALUES (66275, 238, 2170, 10, 68, 280, 63);
INSERT INTO public.who_global_data VALUES (66276, 0, 0, 0, 0, 280, 17);
INSERT INTO public.who_global_data VALUES (66277, 0, 14, 0, 2, 280, 172);
INSERT INTO public.who_global_data VALUES (66278, 29, 1494, 4, 81, 280, 109);
INSERT INTO public.who_global_data VALUES (66279, 49, 7759, 0, 204, 280, 200);
INSERT INTO public.who_global_data VALUES (66280, 0, 353, 0, 2, 280, 93);
INSERT INTO public.who_global_data VALUES (66281, 36, 2483, 1, 12, 280, 5);
INSERT INTO public.who_global_data VALUES (66282, 0, 712, 0, 13, 280, 214);
INSERT INTO public.who_global_data VALUES (66283, 1159, 18770, 26, 432, 280, 204);
INSERT INTO public.who_global_data VALUES (66284, 0, 0, 0, 0, 280, 198);
INSERT INTO public.who_global_data VALUES (66285, 154, 6532, 10, 188, 280, 173);
INSERT INTO public.who_global_data VALUES (66286, 0, 8, 0, 0, 280, 229);
INSERT INTO public.who_global_data VALUES (66287, 17, 266, 1, 10, 280, 76);
INSERT INTO public.who_global_data VALUES (66288, 3045, 36976, 108, 1051, 280, 138);
INSERT INTO public.who_global_data VALUES (66289, 284, 8772, 11, 579, 280, 98);
INSERT INTO public.who_global_data VALUES (66290, 0, 0, 0, 0, 280, 103);
INSERT INTO public.who_global_data VALUES (66291, 228, 13105, 7, 651, 280, 225);
INSERT INTO public.who_global_data VALUES (66292, 364, 25351, 0, 1007, 280, 131);
INSERT INTO public.who_global_data VALUES (66293, 36, 1575, 0, 54, 280, 235);
INSERT INTO public.who_global_data VALUES (66294, 776, 14872, 0, 12, 280, 137);
INSERT INTO public.who_global_data VALUES (66295, 6, 10780, 2, 250, 280, 81);
INSERT INTO public.who_global_data VALUES (66296, 83, 3980, 3, 122, 280, 182);
INSERT INTO public.who_global_data VALUES (66297, 0, 420, 0, 0, 280, 145);
INSERT INTO public.who_global_data VALUES (66298, 327, 12567, 27, 744, 280, 26);
INSERT INTO public.who_global_data VALUES (66299, 9623, 124054, 53, 1222, 280, 170);
INSERT INTO public.who_global_data VALUES (66300, 6, 249, 0, 0, 280, 191);
INSERT INTO public.who_global_data VALUES (66301, 0, 2, 0, 0, 280, 221);
INSERT INTO public.who_global_data VALUES (66302, 0, 6, 0, 0, 280, 64);
INSERT INTO public.who_global_data VALUES (66303, 0, 0, 0, 0, 280, 116);
INSERT INTO public.who_global_data VALUES (66304, 0, 15, 0, 0, 280, 128);
INSERT INTO public.who_global_data VALUES (66305, 0, 17, 0, 0, 280, 6);
INSERT INTO public.who_global_data VALUES (66306, 0, 38, 0, 3, 280, 227);
INSERT INTO public.who_global_data VALUES (66307, 0, 1, 0, 0, 280, 68);
INSERT INTO public.who_global_data VALUES (66308, 0, 16, 0, 0, 280, 184);
INSERT INTO public.who_global_data VALUES (66309, 0, 0, 0, 0, 280, 82);
INSERT INTO public.who_global_data VALUES (66310, 11, 580, 0, 41, 280, 149);
INSERT INTO public.who_global_data VALUES (66311, 0, 16, 0, 1, 280, 197);
INSERT INTO public.who_global_data VALUES (66312, 1362, 25459, 7, 176, 280, 78);
INSERT INTO public.who_global_data VALUES (66313, 91, 1024, 0, 9, 280, 233);
INSERT INTO public.who_global_data VALUES (66314, 196, 9205, 6, 185, 280, 133);
INSERT INTO public.who_global_data VALUES (66315, 0, 11, 0, 0, 280, 35);
INSERT INTO public.who_global_data VALUES (66316, 12, 136, 1, 8, 280, 114);
INSERT INTO public.who_global_data VALUES (66317, 932, 17101, 1, 16, 280, 237);
INSERT INTO public.who_global_data VALUES (66318, 0, 2, 0, 0, 280, 55);
INSERT INTO public.who_global_data VALUES (66319, 0, 76, 0, 13, 280, 176);
INSERT INTO public.who_global_data VALUES (66320, 7, 1403, 0, 23, 280, 202);
INSERT INTO public.who_global_data VALUES (66321, 5, 1439, 2, 102, 280, 155);
INSERT INTO public.who_global_data VALUES (66322, 0, 0, 0, 0, 280, 32);
INSERT INTO public.who_global_data VALUES (66323, 70, 671, 3, 31, 280, 220);
INSERT INTO public.who_global_data VALUES (66324, 304, 5951, 13, 116, 280, 30);
INSERT INTO public.who_global_data VALUES (66325, 10, 45, 0, 0, 280, 147);
INSERT INTO public.who_global_data VALUES (66326, 1441, 225975, 223, 26123, 280, 208);
INSERT INTO public.who_global_data VALUES (66327, 25, 690, 0, 7, 280, 45);
INSERT INTO public.who_global_data VALUES (66328, 91, 533, 5, 36, 280, 110);
INSERT INTO public.who_global_data VALUES (66329, 0, 10, 0, 1, 280, 88);
INSERT INTO public.who_global_data VALUES (66330, 636, 21604, 78, 2914, 280, 51);
INSERT INTO public.who_global_data VALUES (66331, 83, 29860, 12, 1608, 280, 209);
INSERT INTO public.who_global_data VALUES (66332, 1, 44, 0, 3, 280, 205);
INSERT INTO public.who_global_data VALUES (66333, 17, 32, 0, 0, 280, 18);
INSERT INTO public.who_global_data VALUES (66334, 6, 2966, 0, 54, 280, 72);
INSERT INTO public.who_global_data VALUES (66335, 4966, 177562, 698, 27381, 280, 44);
INSERT INTO public.who_global_data VALUES (66336, 0, 24, 0, 0, 280, 15);
INSERT INTO public.who_global_data VALUES (66337, 7, 123, 0, 9, 280, 25);
INSERT INTO public.who_global_data VALUES (66338, 0, 0, 0, 0, 280, 179);
INSERT INTO public.who_global_data VALUES (66339, 0, 0, 0, 0, 280, 34);
INSERT INTO public.who_global_data VALUES (66340, 0, 116, 0, 8, 280, 207);
INSERT INTO public.who_global_data VALUES (66341, 4, 998, 0, 41, 280, 166);
INSERT INTO public.who_global_data VALUES (66342, 2188, 122392, 84, 3258, 280, 126);
INSERT INTO public.who_global_data VALUES (66343, 0, 0, 0, 0, 280, 97);
INSERT INTO public.who_global_data VALUES (66344, 0, 12, 0, 1, 280, 36);
INSERT INTO public.who_global_data VALUES (66345, 0, 0, 0, 0, 280, 125);
INSERT INTO public.who_global_data VALUES (66346, 2, 83, 0, 0, 280, 124);
INSERT INTO public.who_global_data VALUES (66347, 550, 11411, 7, 279, 280, 185);
INSERT INTO public.who_global_data VALUES (66348, 0, 13038, 0, 111, 280, 194);
INSERT INTO public.who_global_data VALUES (66349, 0, 480, 0, 17, 280, 144);
INSERT INTO public.who_global_data VALUES (66350, 31774, 1067127, 2005, 62637, 280, 19);
INSERT INTO public.who_global_data VALUES (66351, 0, 66, 0, 4, 280, 217);
INSERT INTO public.who_global_data VALUES (66352, 13, 643, 2, 17, 280, 148);
INSERT INTO public.who_global_data VALUES (66353, 48, 2094, 0, 9, 280, 86);
INSERT INTO public.who_global_data VALUES (66354, 0, 0, 0, 0, 280, 13);
INSERT INTO public.who_global_data VALUES (66355, 2, 333, 0, 10, 280, 157);
INSERT INTO public.who_global_data VALUES (66356, 0, 270, 0, 0, 280, 8);
INSERT INTO public.who_global_data VALUES (66357, 0, 0, 0, 0, 280, 73);
INSERT INTO public.who_global_data VALUES (66358, 1, 7, 0, 2, 280, 101);
INSERT INTO public.who_global_data VALUES (66359, 3, 109, 0, 3, 280, 165);
INSERT INTO public.who_global_data VALUES (66360, 2, 34, 0, 4, 280, 14);
INSERT INTO public.who_global_data VALUES (66361, 0, 2171, 0, 64, 281, 193);
INSERT INTO public.who_global_data VALUES (66362, 0, 735, 0, 30, 281, 113);
INSERT INTO public.who_global_data VALUES (66363, 158, 4006, 6, 450, 281, 143);
INSERT INTO public.who_global_data VALUES (66364, 0, 0, 0, 0, 281, 219);
INSERT INTO public.who_global_data VALUES (66365, 2, 746, 0, 42, 281, 186);
INSERT INTO public.who_global_data VALUES (66366, 0, 27, 0, 2, 281, 52);
INSERT INTO public.who_global_data VALUES (66367, 0, 3, 0, 0, 281, 180);
INSERT INTO public.who_global_data VALUES (66368, 0, 24, 0, 3, 281, 167);
INSERT INTO public.who_global_data VALUES (66369, 103, 4304, 8, 215, 281, 154);
INSERT INTO public.who_global_data VALUES (66370, 134, 2042, 2, 32, 281, 94);
INSERT INTO public.who_global_data VALUES (66371, 0, 100, 0, 2, 281, 66);
INSERT INTO public.who_global_data VALUES (66372, 16, 6762, 2, 92, 281, 58);
INSERT INTO public.who_global_data VALUES (66373, 60, 15424, 4, 584, 281, 163);
INSERT INTO public.who_global_data VALUES (66374, 38, 1804, 1, 24, 281, 37);
INSERT INTO public.who_global_data VALUES (66375, 0, 80, 0, 11, 281, 142);
INSERT INTO public.who_global_data VALUES (66376, 132, 3169, 0, 8, 281, 83);
INSERT INTO public.who_global_data VALUES (66377, 571, 8238, 2, 170, 281, 228);
INSERT INTO public.who_global_data VALUES (66378, 0, 80, 1, 7, 281, 188);
INSERT INTO public.who_global_data VALUES (66379, 846, 14027, 5, 89, 281, 62);
INSERT INTO public.who_global_data VALUES (66380, 586, 50625, 87, 7864, 281, 160);
INSERT INTO public.who_global_data VALUES (66381, 0, 18, 0, 2, 281, 50);
INSERT INTO public.who_global_data VALUES (66382, 15, 84, 0, 2, 281, 33);
INSERT INTO public.who_global_data VALUES (66383, 0, 111, 0, 6, 281, 183);
INSERT INTO public.who_global_data VALUES (66384, 0, 7, 0, 0, 281, 92);
INSERT INTO public.who_global_data VALUES (66385, 57, 1110, 4, 59, 281, 158);
INSERT INTO public.who_global_data VALUES (66386, 0, 2, 0, 0, 281, 67);
INSERT INTO public.who_global_data VALUES (66387, 93, 1782, 5, 69, 281, 57);
INSERT INTO public.who_global_data VALUES (66388, 0, 23, 0, 1, 281, 38);
INSERT INTO public.who_global_data VALUES (66389, 6276, 78162, 449, 5466, 281, 141);
INSERT INTO public.who_global_data VALUES (66390, 0, 6, 0, 1, 281, 178);
INSERT INTO public.who_global_data VALUES (66391, 0, 138, 0, 1, 281, 108);
INSERT INTO public.who_global_data VALUES (66392, 59, 1506, 2, 66, 281, 39);
INSERT INTO public.who_global_data VALUES (66393, 7, 645, 1, 43, 281, 2);
INSERT INTO public.who_global_data VALUES (66394, 0, 15, 0, 1, 281, 195);
INSERT INTO public.who_global_data VALUES (66395, 8, 121, 0, 1, 281, 107);
INSERT INTO public.who_global_data VALUES (66396, 0, 122, 0, 0, 281, 161);
INSERT INTO public.who_global_data VALUES (66397, 26, 1832, 2, 61, 281, 212);
INSERT INTO public.who_global_data VALUES (66398, 1693, 52056, 178, 3082, 281, 181);
INSERT INTO public.who_global_data VALUES (66399, 0, 73, 0, 1, 281, 53);
INSERT INTO public.who_global_data VALUES (66400, 14, 64, 0, 0, 281, 164);
INSERT INTO public.who_global_data VALUES (66401, 21, 73, 1, 3, 281, 140);
INSERT INTO public.who_global_data VALUES (66402, 1138, 16023, 11, 227, 281, 20);
INSERT INTO public.who_global_data VALUES (66403, 12, 84385, 0, 4643, 281, 112);
INSERT INTO public.who_global_data VALUES (66404, 262, 6211, 9, 278, 281, 111);
INSERT INTO public.who_global_data VALUES (66405, 1, 1, 0, 0, 281, 71);
INSERT INTO public.who_global_data VALUES (66406, 0, 220, 0, 9, 281, 218);
INSERT INTO public.who_global_data VALUES (66407, 0, 0, 0, 0, 281, 43);
INSERT INTO public.who_global_data VALUES (66408, 8, 713, 0, 6, 281, 49);
INSERT INTO public.who_global_data VALUES (66409, 37, 1275, 0, 14, 281, 1);
INSERT INTO public.who_global_data VALUES (66410, 14, 2076, 2, 69, 281, 48);
INSERT INTO public.who_global_data VALUES (66411, 34, 1501, 3, 61, 281, 232);
INSERT INTO public.who_global_data VALUES (66412, 0, 16, 0, 1, 281, 175);
INSERT INTO public.who_global_data VALUES (66413, 7, 850, 0, 15, 281, 21);
INSERT INTO public.who_global_data VALUES (66414, 103, 7682, 9, 236, 281, 156);
INSERT INTO public.who_global_data VALUES (66415, 0, 0, 0, 0, 281, 95);
INSERT INTO public.who_global_data VALUES (66416, 72, 572, 0, 31, 281, 177);
INSERT INTO public.who_global_data VALUES (66417, 150, 9158, 9, 452, 281, 210);
INSERT INTO public.who_global_data VALUES (66418, 8, 1097, 0, 2, 281, 120);
INSERT INTO public.who_global_data VALUES (66419, 0, 16, 0, 0, 281, 135);
INSERT INTO public.who_global_data VALUES (66420, 320, 6972, 8, 301, 281, 206);
INSERT INTO public.who_global_data VALUES (66421, 259, 24934, 17, 900, 281, 189);
INSERT INTO public.who_global_data VALUES (66422, 358, 5895, 14, 406, 281, 129);
INSERT INTO public.who_global_data VALUES (66423, 18, 395, 0, 9, 281, 121);
INSERT INTO public.who_global_data VALUES (66424, 0, 315, 1, 2, 281, 59);
INSERT INTO public.who_global_data VALUES (66425, 0, 39, 0, 0, 281, 96);
INSERT INTO public.who_global_data VALUES (66426, 23, 1689, 2, 52, 281, 41);
INSERT INTO public.who_global_data VALUES (66427, 9, 100, 0, 1, 281, 216);
INSERT INTO public.who_global_data VALUES (66428, 1, 131, 0, 3, 281, 236);
INSERT INTO public.who_global_data VALUES (66429, 0, 13, 0, 0, 281, 150);
INSERT INTO public.who_global_data VALUES (66430, 0, 187, 0, 0, 281, 61);
INSERT INTO public.who_global_data VALUES (66431, 0, 18, 0, 0, 281, 7);
INSERT INTO public.who_global_data VALUES (66432, 89, 4995, 5, 211, 281, 169);
INSERT INTO public.who_global_data VALUES (66433, 1055, 128121, 288, 24342, 281, 28);
INSERT INTO public.who_global_data VALUES (66434, 1, 126, 0, 1, 281, 85);
INSERT INTO public.who_global_data VALUES (66435, 0, 58, 0, 0, 281, 211);
INSERT INTO public.who_global_data VALUES (66436, 0, 276, 0, 3, 281, 60);
INSERT INTO public.who_global_data VALUES (66437, 1, 12, 0, 1, 281, 3);
INSERT INTO public.who_global_data VALUES (66438, 27, 566, 0, 6, 281, 11);
INSERT INTO public.who_global_data VALUES (66439, 1639, 160758, 193, 6481, 281, 89);
INSERT INTO public.who_global_data VALUES (66440, 403, 2074, 1, 17, 281, 24);
INSERT INTO public.who_global_data VALUES (66441, 0, 141, 0, 0, 281, 162);
INSERT INTO public.who_global_data VALUES (66442, 15, 2591, 1, 140, 281, 100);
INSERT INTO public.who_global_data VALUES (66443, 0, 11, 0, 0, 281, 47);
INSERT INTO public.who_global_data VALUES (66444, 1, 20, 0, 0, 281, 29);
INSERT INTO public.who_global_data VALUES (66445, 1, 152, 1, 12, 281, 40);
INSERT INTO public.who_global_data VALUES (66446, 1, 142, 0, 5, 281, 222);
INSERT INTO public.who_global_data VALUES (66447, 28, 585, 0, 16, 281, 132);
INSERT INTO public.who_global_data VALUES (66448, 4, 251, 0, 13, 281, 130);
INSERT INTO public.who_global_data VALUES (66449, 144, 1495, 0, 7, 281, 234);
INSERT INTO public.who_global_data VALUES (66450, 124, 201, 0, 1, 281, 23);
INSERT INTO public.who_global_data VALUES (66451, 3, 78, 0, 8, 281, 192);
INSERT INTO public.who_global_data VALUES (66452, 0, 76, 1, 7, 281, 69);
INSERT INTO public.who_global_data VALUES (66453, 1, 11, 0, 0, 281, 187);
INSERT INTO public.who_global_data VALUES (66454, 33, 771, 5, 71, 281, 230);
INSERT INTO public.who_global_data VALUES (66455, 88, 2863, 11, 323, 281, 77);
INSERT INTO public.who_global_data VALUES (66456, 0, 1797, 0, 10, 281, 9);
INSERT INTO public.who_global_data VALUES (66457, 1993, 35043, 73, 1147, 281, 74);
INSERT INTO public.who_global_data VALUES (66458, 433, 10551, 8, 800, 281, 224);
INSERT INTO public.who_global_data VALUES (66459, 1006, 95646, 63, 6091, 281, 199);
INSERT INTO public.who_global_data VALUES (66460, 82, 2085, 1, 93, 281, 190);
INSERT INTO public.who_global_data VALUES (66461, 359, 20612, 42, 1232, 281, 12);
INSERT INTO public.who_global_data VALUES (66462, 2, 311, 1, 22, 281, 104);
INSERT INTO public.who_global_data VALUES (66463, 82, 15760, 6, 219, 281, 153);
INSERT INTO public.who_global_data VALUES (66464, 1872, 205463, 285, 27967, 281, 91);
INSERT INTO public.who_global_data VALUES (66465, 15, 396, 0, 7, 281, 215);
INSERT INTO public.who_global_data VALUES (66466, 193, 14281, 17, 432, 281, 84);
INSERT INTO public.who_global_data VALUES (66467, 6, 290, 0, 20, 281, 231);
INSERT INTO public.who_global_data VALUES (66468, 0, 453, 0, 8, 281, 196);
INSERT INTO public.who_global_data VALUES (66469, 234, 3785, 0, 25, 281, 105);
INSERT INTO public.who_global_data VALUES (66470, 12, 396, 2, 17, 281, 122);
INSERT INTO public.who_global_data VALUES (66471, 0, 0, 0, 0, 281, 159);
INSERT INTO public.who_global_data VALUES (66472, 0, 799, 0, 17, 281, 75);
INSERT INTO public.who_global_data VALUES (66473, 353, 4377, 4, 30, 281, 27);
INSERT INTO public.who_global_data VALUES (66474, 10, 756, 0, 8, 281, 54);
INSERT INTO public.who_global_data VALUES (66475, 0, 19, 0, 0, 281, 226);
INSERT INTO public.who_global_data VALUES (66476, 9, 858, 0, 15, 281, 79);
INSERT INTO public.who_global_data VALUES (66477, 4, 729, 0, 24, 281, 56);
INSERT INTO public.who_global_data VALUES (66478, 0, 0, 0, 0, 281, 117);
INSERT INTO public.who_global_data VALUES (66479, 0, 141, 0, 16, 281, 152);
INSERT INTO public.who_global_data VALUES (66480, 2, 63, 1, 3, 281, 16);
INSERT INTO public.who_global_data VALUES (66481, 0, 83, 0, 1, 281, 10);
INSERT INTO public.who_global_data VALUES (66482, 14, 1389, 0, 45, 281, 201);
INSERT INTO public.who_global_data VALUES (66483, 15, 3784, 1, 90, 281, 174);
INSERT INTO public.who_global_data VALUES (66484, 4, 132, 0, 0, 281, 119);
INSERT INTO public.who_global_data VALUES (66485, 1, 37, 0, 3, 281, 168);
INSERT INTO public.who_global_data VALUES (66486, 57, 6002, 2, 102, 281, 99);
INSERT INTO public.who_global_data VALUES (66487, 72, 468, 1, 1, 281, 171);
INSERT INTO public.who_global_data VALUES (66488, 8, 490, 1, 26, 281, 87);
INSERT INTO public.who_global_data VALUES (66489, 2, 466, 0, 4, 281, 123);
INSERT INTO public.who_global_data VALUES (66490, 0, 0, 0, 0, 281, 151);
INSERT INTO public.who_global_data VALUES (66491, 3, 178, 0, 14, 281, 213);
INSERT INTO public.who_global_data VALUES (66492, 1, 8, 0, 1, 281, 118);
INSERT INTO public.who_global_data VALUES (66493, 0, 332, 0, 10, 281, 134);
INSERT INTO public.who_global_data VALUES (66494, 79, 539, 0, 4, 281, 65);
INSERT INTO public.who_global_data VALUES (66495, 1047, 17799, 163, 1732, 281, 102);
INSERT INTO public.who_global_data VALUES (66496, 0, 0, 0, 0, 281, 223);
INSERT INTO public.who_global_data VALUES (66497, 0, 66, 0, 1, 281, 4);
INSERT INTO public.who_global_data VALUES (66498, 0, 38, 0, 0, 281, 146);
INSERT INTO public.who_global_data VALUES (66499, 0, 322, 0, 7, 281, 31);
INSERT INTO public.who_global_data VALUES (66500, 0, 11, 0, 1, 281, 127);
INSERT INTO public.who_global_data VALUES (66501, 170, 4529, 3, 171, 281, 22);
INSERT INTO public.who_global_data VALUES (66502, 0, 76, 0, 0, 281, 115);
INSERT INTO public.who_global_data VALUES (66503, 1, 151, 0, 6, 281, 106);
INSERT INTO public.who_global_data VALUES (66504, 0, 16, 0, 0, 281, 90);
INSERT INTO public.who_global_data VALUES (66505, 0, 0, 0, 0, 281, 70);
INSERT INTO public.who_global_data VALUES (66506, 2, 59, 0, 0, 281, 46);
INSERT INTO public.who_global_data VALUES (66507, 507, 39067, 85, 4755, 281, 139);
INSERT INTO public.who_global_data VALUES (66508, 0, 18, 0, 0, 281, 42);
INSERT INTO public.who_global_data VALUES (66509, 3, 1132, 0, 19, 281, 80);
INSERT INTO public.who_global_data VALUES (66510, 1, 14, 1, 4, 281, 203);
INSERT INTO public.who_global_data VALUES (66511, 6, 719, 0, 32, 281, 136);
INSERT INTO public.who_global_data VALUES (66512, 400, 1932, 14, 58, 281, 63);
INSERT INTO public.who_global_data VALUES (66513, 0, 0, 0, 0, 281, 17);
INSERT INTO public.who_global_data VALUES (66514, 0, 14, 0, 2, 281, 172);
INSERT INTO public.who_global_data VALUES (66515, 23, 1465, 4, 77, 281, 109);
INSERT INTO public.who_global_data VALUES (66516, 43, 7710, 2, 204, 281, 200);
INSERT INTO public.who_global_data VALUES (66517, 9, 353, 0, 2, 281, 93);
INSERT INTO public.who_global_data VALUES (66518, 99, 2447, 0, 11, 281, 5);
INSERT INTO public.who_global_data VALUES (66519, 0, 712, 0, 13, 281, 214);
INSERT INTO public.who_global_data VALUES (66520, 1494, 17611, 48, 406, 281, 204);
INSERT INTO public.who_global_data VALUES (66521, 0, 0, 0, 0, 281, 198);
INSERT INTO public.who_global_data VALUES (66522, 178, 6378, 2, 178, 281, 173);
INSERT INTO public.who_global_data VALUES (66523, 0, 8, 0, 0, 281, 229);
INSERT INTO public.who_global_data VALUES (66524, 10, 249, 0, 9, 281, 76);
INSERT INTO public.who_global_data VALUES (66525, 2741, 33931, 89, 943, 281, 138);
INSERT INTO public.who_global_data VALUES (66526, 276, 8488, 10, 568, 281, 98);
INSERT INTO public.who_global_data VALUES (66527, 0, 0, 0, 0, 281, 103);
INSERT INTO public.who_global_data VALUES (66528, 237, 12877, 20, 644, 281, 225);
INSERT INTO public.who_global_data VALUES (66529, 295, 24987, 18, 1007, 281, 131);
INSERT INTO public.who_global_data VALUES (66530, 106, 1539, 0, 54, 281, 235);
INSERT INTO public.who_global_data VALUES (66531, 687, 14096, 2, 12, 281, 137);
INSERT INTO public.who_global_data VALUES (66532, 9, 10774, 1, 248, 281, 81);
INSERT INTO public.who_global_data VALUES (66533, 126, 3897, 3, 119, 281, 182);
INSERT INTO public.who_global_data VALUES (66534, 0, 420, 0, 0, 281, 145);
INSERT INTO public.who_global_data VALUES (66535, 262, 12240, 42, 717, 281, 26);
INSERT INTO public.who_global_data VALUES (66536, 7933, 114431, 96, 1169, 281, 170);
INSERT INTO public.who_global_data VALUES (66537, 18, 243, 0, 0, 281, 191);
INSERT INTO public.who_global_data VALUES (66538, 0, 2, 0, 0, 281, 221);
INSERT INTO public.who_global_data VALUES (66539, 0, 6, 0, 0, 281, 64);
INSERT INTO public.who_global_data VALUES (66540, 0, 0, 0, 0, 281, 116);
INSERT INTO public.who_global_data VALUES (66541, 0, 15, 0, 0, 281, 128);
INSERT INTO public.who_global_data VALUES (66542, 0, 17, 0, 0, 281, 6);
INSERT INTO public.who_global_data VALUES (66543, 0, 38, 0, 3, 281, 227);
INSERT INTO public.who_global_data VALUES (66544, 0, 1, 0, 0, 281, 68);
INSERT INTO public.who_global_data VALUES (66545, 0, 16, 0, 0, 281, 184);
INSERT INTO public.who_global_data VALUES (66546, 0, 0, 0, 0, 281, 82);
INSERT INTO public.who_global_data VALUES (66547, 6, 569, 0, 41, 281, 149);
INSERT INTO public.who_global_data VALUES (66548, 5, 16, 1, 1, 281, 197);
INSERT INTO public.who_global_data VALUES (66549, 1344, 24097, 7, 169, 281, 78);
INSERT INTO public.who_global_data VALUES (66550, 51, 933, 0, 9, 281, 233);
INSERT INTO public.who_global_data VALUES (66551, 285, 9009, 6, 179, 281, 133);
INSERT INTO public.who_global_data VALUES (66552, 0, 11, 0, 0, 281, 35);
INSERT INTO public.who_global_data VALUES (66553, 8, 124, 2, 7, 281, 114);
INSERT INTO public.who_global_data VALUES (66554, 528, 16169, 1, 15, 281, 237);
INSERT INTO public.who_global_data VALUES (66555, 0, 2, 0, 0, 281, 55);
INSERT INTO public.who_global_data VALUES (66556, 1, 76, 0, 13, 281, 176);
INSERT INTO public.who_global_data VALUES (66557, 5, 1396, 1, 23, 281, 202);
INSERT INTO public.who_global_data VALUES (66558, 5, 1434, 3, 100, 281, 155);
INSERT INTO public.who_global_data VALUES (66559, 0, 0, 0, 0, 281, 32);
INSERT INTO public.who_global_data VALUES (66560, 0, 601, 0, 28, 281, 220);
INSERT INTO public.who_global_data VALUES (66561, 297, 5647, 0, 103, 281, 30);
INSERT INTO public.who_global_data VALUES (66562, 1, 35, 0, 0, 281, 147);
INSERT INTO public.who_global_data VALUES (66563, 1485, 224534, 236, 25900, 281, 208);
INSERT INTO public.who_global_data VALUES (66564, 16, 665, 0, 7, 281, 45);
INSERT INTO public.who_global_data VALUES (66565, 67, 442, 3, 31, 281, 110);
INSERT INTO public.who_global_data VALUES (66566, 0, 10, 0, 1, 281, 88);
INSERT INTO public.who_global_data VALUES (66567, 799, 20968, 83, 2836, 281, 51);
INSERT INTO public.who_global_data VALUES (66568, 101, 29777, 13, 1596, 281, 209);
INSERT INTO public.who_global_data VALUES (66569, 0, 43, 0, 3, 281, 205);
INSERT INTO public.who_global_data VALUES (66570, 15, 15, 0, 0, 281, 18);
INSERT INTO public.who_global_data VALUES (66571, 6, 2960, 0, 54, 281, 72);
INSERT INTO public.who_global_data VALUES (66572, 5446, 172596, 634, 26683, 281, 44);
INSERT INTO public.who_global_data VALUES (66573, 0, 24, 0, 0, 281, 15);
INSERT INTO public.who_global_data VALUES (66574, 7, 116, 2, 9, 281, 25);
INSERT INTO public.who_global_data VALUES (66575, 0, 0, 0, 0, 281, 179);
INSERT INTO public.who_global_data VALUES (66576, 0, 0, 0, 0, 281, 34);
INSERT INTO public.who_global_data VALUES (66577, 0, 116, 0, 8, 281, 207);
INSERT INTO public.who_global_data VALUES (66578, 14, 994, 1, 41, 281, 166);
INSERT INTO public.who_global_data VALUES (66579, 2615, 120204, 93, 3174, 281, 126);
INSERT INTO public.who_global_data VALUES (66580, 0, 0, 0, 0, 281, 97);
INSERT INTO public.who_global_data VALUES (66581, 0, 12, 0, 1, 281, 36);
INSERT INTO public.who_global_data VALUES (66582, 0, 0, 0, 0, 281, 125);
INSERT INTO public.who_global_data VALUES (66583, 2, 81, 0, 0, 281, 124);
INSERT INTO public.who_global_data VALUES (66584, 455, 10861, 11, 272, 281, 185);
INSERT INTO public.who_global_data VALUES (66585, 557, 13038, 6, 111, 281, 194);
INSERT INTO public.who_global_data VALUES (66586, 0, 480, 1, 17, 281, 144);
INSERT INTO public.who_global_data VALUES (66587, 31379, 1035353, 2902, 60632, 281, 19);
INSERT INTO public.who_global_data VALUES (66588, 4, 66, 0, 4, 281, 217);
INSERT INTO public.who_global_data VALUES (66589, 5, 630, 0, 15, 281, 148);
INSERT INTO public.who_global_data VALUES (66590, 15, 2046, 0, 9, 281, 86);
INSERT INTO public.who_global_data VALUES (66591, 0, 0, 0, 0, 281, 13);
INSERT INTO public.who_global_data VALUES (66592, 2, 331, 0, 10, 281, 157);
INSERT INTO public.who_global_data VALUES (66593, 0, 270, 0, 0, 281, 8);
INSERT INTO public.who_global_data VALUES (66594, 0, 0, 0, 0, 281, 73);
INSERT INTO public.who_global_data VALUES (66595, 0, 6, 2, 2, 281, 101);
INSERT INTO public.who_global_data VALUES (66596, 9, 106, 0, 3, 281, 165);
INSERT INTO public.who_global_data VALUES (66597, 0, 32, 0, 4, 281, 14);
INSERT INTO public.who_global_data VALUES (66598, 344, 2171, 4, 64, 282, 193);
INSERT INTO public.who_global_data VALUES (66599, 7, 735, 1, 30, 282, 113);
INSERT INTO public.who_global_data VALUES (66600, 199, 3848, 7, 444, 282, 143);
INSERT INTO public.who_global_data VALUES (66601, 0, 0, 0, 0, 282, 219);
INSERT INTO public.who_global_data VALUES (66602, 2, 744, 0, 42, 282, 186);
INSERT INTO public.who_global_data VALUES (66603, 0, 27, 0, 2, 282, 52);
INSERT INTO public.who_global_data VALUES (66604, 0, 3, 0, 0, 282, 180);
INSERT INTO public.who_global_data VALUES (66605, 0, 24, 0, 3, 282, 167);
INSERT INTO public.who_global_data VALUES (66606, 182, 4201, 10, 207, 282, 154);
INSERT INTO public.who_global_data VALUES (66607, 65, 1908, 0, 30, 282, 94);
INSERT INTO public.who_global_data VALUES (66608, 0, 100, 0, 2, 282, 66);
INSERT INTO public.who_global_data VALUES (66609, 8, 6746, 2, 90, 282, 58);
INSERT INTO public.who_global_data VALUES (66610, 50, 15364, 11, 580, 282, 163);
INSERT INTO public.who_global_data VALUES (66611, 49, 1766, 1, 23, 282, 37);
INSERT INTO public.who_global_data VALUES (66612, 0, 80, 0, 11, 282, 142);
INSERT INTO public.who_global_data VALUES (66613, 168, 3037, 0, 8, 282, 83);
INSERT INTO public.who_global_data VALUES (66614, 564, 7667, 5, 168, 282, 228);
INSERT INTO public.who_global_data VALUES (66615, 0, 80, 0, 6, 282, 188);
INSERT INTO public.who_global_data VALUES (66616, 973, 13181, 5, 84, 282, 62);
INSERT INTO public.who_global_data VALUES (66617, 522, 50039, 106, 7777, 282, 160);
INSERT INTO public.who_global_data VALUES (66618, 0, 18, 0, 2, 282, 50);
INSERT INTO public.who_global_data VALUES (66619, 5, 69, 1, 2, 282, 33);
INSERT INTO public.who_global_data VALUES (66620, 1, 111, 0, 6, 282, 183);
INSERT INTO public.who_global_data VALUES (66621, 0, 7, 0, 0, 282, 92);
INSERT INTO public.who_global_data VALUES (66622, 39, 1053, 2, 55, 282, 158);
INSERT INTO public.who_global_data VALUES (66623, 0, 2, 0, 0, 282, 67);
INSERT INTO public.who_global_data VALUES (66624, 101, 1689, 2, 64, 282, 57);
INSERT INTO public.who_global_data VALUES (66625, 0, 23, 0, 1, 282, 38);
INSERT INTO public.who_global_data VALUES (66626, 5385, 71886, 474, 5017, 282, 141);
INSERT INTO public.who_global_data VALUES (66627, 0, 6, 0, 1, 282, 178);
INSERT INTO public.who_global_data VALUES (66628, 0, 138, 0, 1, 282, 108);
INSERT INTO public.who_global_data VALUES (66629, 48, 1447, 6, 64, 282, 39);
INSERT INTO public.who_global_data VALUES (66630, 0, 638, 0, 42, 282, 2);
INSERT INTO public.who_global_data VALUES (66631, 0, 15, 0, 1, 282, 195);
INSERT INTO public.who_global_data VALUES (66632, 0, 113, 0, 1, 282, 107);
INSERT INTO public.who_global_data VALUES (66633, 0, 122, 0, 0, 282, 161);
INSERT INTO public.who_global_data VALUES (66634, 101, 1806, 1, 59, 282, 212);
INSERT INTO public.who_global_data VALUES (66635, 1349, 50363, 138, 2904, 282, 181);
INSERT INTO public.who_global_data VALUES (66636, 3, 73, 0, 1, 282, 53);
INSERT INTO public.who_global_data VALUES (66637, 0, 50, 0, 0, 282, 164);
INSERT INTO public.who_global_data VALUES (66638, 0, 52, 0, 2, 282, 140);
INSERT INTO public.who_global_data VALUES (66639, 520, 14885, 9, 216, 282, 20);
INSERT INTO public.who_global_data VALUES (66640, 4, 84373, 0, 4643, 282, 112);
INSERT INTO public.who_global_data VALUES (66641, 352, 5949, 16, 269, 282, 111);
INSERT INTO public.who_global_data VALUES (66642, 0, 0, 0, 0, 282, 71);
INSERT INTO public.who_global_data VALUES (66643, 13, 220, 1, 9, 282, 218);
INSERT INTO public.who_global_data VALUES (66644, 0, 0, 0, 0, 282, 43);
INSERT INTO public.who_global_data VALUES (66645, 8, 705, 0, 6, 282, 49);
INSERT INTO public.who_global_data VALUES (66646, 55, 1238, 0, 14, 282, 1);
INSERT INTO public.who_global_data VALUES (66647, 15, 2062, 4, 67, 282, 48);
INSERT INTO public.who_global_data VALUES (66648, 30, 1467, 0, 58, 282, 232);
INSERT INTO public.who_global_data VALUES (66649, 0, 16, 0, 1, 282, 175);
INSERT INTO public.who_global_data VALUES (66650, 6, 843, 0, 15, 282, 21);
INSERT INTO public.who_global_data VALUES (66651, 75, 7579, 0, 227, 282, 156);
INSERT INTO public.who_global_data VALUES (66652, 0, 0, 0, 0, 282, 95);
INSERT INTO public.who_global_data VALUES (66653, 9, 500, 1, 31, 282, 177);
INSERT INTO public.who_global_data VALUES (66654, 157, 9008, 9, 443, 282, 210);
INSERT INTO public.who_global_data VALUES (66655, 12, 1089, 0, 2, 282, 120);
INSERT INTO public.who_global_data VALUES (66656, 0, 16, 0, 0, 282, 135);
INSERT INTO public.who_global_data VALUES (66657, 236, 6652, 7, 293, 282, 206);
INSERT INTO public.who_global_data VALUES (66658, 417, 24675, 12, 883, 282, 189);
INSERT INTO public.who_global_data VALUES (66659, 269, 5537, 12, 392, 282, 129);
INSERT INTO public.who_global_data VALUES (66660, 32, 377, 1, 9, 282, 121);
INSERT INTO public.who_global_data VALUES (66661, 0, 315, 0, 1, 282, 59);
INSERT INTO public.who_global_data VALUES (66662, 0, 39, 0, 0, 282, 96);
INSERT INTO public.who_global_data VALUES (66663, 6, 1666, 0, 50, 282, 41);
INSERT INTO public.who_global_data VALUES (66664, 20, 91, 0, 1, 282, 216);
INSERT INTO public.who_global_data VALUES (66665, 4, 130, 0, 3, 282, 236);
INSERT INTO public.who_global_data VALUES (66666, 0, 13, 0, 0, 282, 150);
INSERT INTO public.who_global_data VALUES (66667, 0, 187, 0, 0, 282, 61);
INSERT INTO public.who_global_data VALUES (66668, 0, 18, 0, 0, 282, 7);
INSERT INTO public.who_global_data VALUES (66669, 166, 4906, 7, 206, 282, 169);
INSERT INTO public.who_global_data VALUES (66670, 1601, 127066, 427, 24054, 282, 28);
INSERT INTO public.who_global_data VALUES (66671, 1, 125, 0, 1, 282, 85);
INSERT INTO public.who_global_data VALUES (66672, 0, 58, 0, 0, 282, 211);
INSERT INTO public.who_global_data VALUES (66673, 38, 276, 0, 3, 282, 60);
INSERT INTO public.who_global_data VALUES (66674, 1, 11, 0, 1, 282, 3);
INSERT INTO public.who_global_data VALUES (66675, 22, 539, 0, 6, 282, 11);
INSERT INTO public.who_global_data VALUES (66676, 1478, 159119, 173, 6288, 282, 89);
INSERT INTO public.who_global_data VALUES (66677, 0, 1671, 0, 16, 282, 24);
INSERT INTO public.who_global_data VALUES (66678, 0, 141, 0, 0, 282, 162);
INSERT INTO public.who_global_data VALUES (66679, 42, 2576, 3, 139, 282, 100);
INSERT INTO public.who_global_data VALUES (66680, 0, 11, 0, 0, 282, 47);
INSERT INTO public.who_global_data VALUES (66681, 1, 19, 0, 0, 282, 29);
INSERT INTO public.who_global_data VALUES (66682, 2, 151, 0, 11, 282, 40);
INSERT INTO public.who_global_data VALUES (66683, 0, 141, 0, 5, 282, 222);
INSERT INTO public.who_global_data VALUES (66684, 27, 557, 1, 16, 282, 132);
INSERT INTO public.who_global_data VALUES (66685, 0, 247, 0, 13, 282, 130);
INSERT INTO public.who_global_data VALUES (66686, 111, 1351, 0, 7, 282, 234);
INSERT INTO public.who_global_data VALUES (66687, 4, 77, 0, 1, 282, 23);
INSERT INTO public.who_global_data VALUES (66688, 1, 75, 0, 8, 282, 192);
INSERT INTO public.who_global_data VALUES (66689, 0, 76, 0, 6, 282, 69);
INSERT INTO public.who_global_data VALUES (66690, 0, 10, 0, 0, 282, 187);
INSERT INTO public.who_global_data VALUES (66691, 36, 738, 2, 66, 282, 230);
INSERT INTO public.who_global_data VALUES (66692, 48, 2775, 12, 312, 282, 77);
INSERT INTO public.who_global_data VALUES (66693, 2, 1797, 0, 10, 282, 9);
INSERT INTO public.who_global_data VALUES (66694, 1718, 33050, 67, 1074, 282, 74);
INSERT INTO public.who_global_data VALUES (66695, 347, 10118, 8, 792, 282, 224);
INSERT INTO public.who_global_data VALUES (66696, 983, 94640, 71, 6028, 282, 199);
INSERT INTO public.who_global_data VALUES (66697, 75, 2003, 2, 92, 282, 190);
INSERT INTO public.who_global_data VALUES (66698, 376, 20253, 31, 1190, 282, 12);
INSERT INTO public.who_global_data VALUES (66699, 1, 309, 1, 21, 282, 104);
INSERT INTO public.who_global_data VALUES (66700, 159, 15678, 5, 213, 282, 153);
INSERT INTO public.who_global_data VALUES (66701, 2086, 203591, 323, 27682, 282, 91);
INSERT INTO public.who_global_data VALUES (66702, 17, 381, 0, 7, 282, 215);
INSERT INTO public.who_global_data VALUES (66703, 236, 14088, 26, 415, 282, 84);
INSERT INTO public.who_global_data VALUES (66704, 1, 284, 1, 20, 282, 231);
INSERT INTO public.who_global_data VALUES (66705, 4, 453, 0, 8, 282, 196);
INSERT INTO public.who_global_data VALUES (66706, 218, 3551, 0, 25, 282, 105);
INSERT INTO public.who_global_data VALUES (66707, 10, 384, 1, 15, 282, 122);
INSERT INTO public.who_global_data VALUES (66708, 0, 0, 0, 0, 282, 159);
INSERT INTO public.who_global_data VALUES (66709, 9, 799, 0, 17, 282, 75);
INSERT INTO public.who_global_data VALUES (66710, 284, 4024, 2, 26, 282, 27);
INSERT INTO public.who_global_data VALUES (66711, 17, 746, 0, 8, 282, 54);
INSERT INTO public.who_global_data VALUES (66712, 0, 19, 0, 0, 282, 226);
INSERT INTO public.who_global_data VALUES (66713, 13, 849, 2, 15, 282, 79);
INSERT INTO public.who_global_data VALUES (66714, 4, 725, 0, 24, 282, 56);
INSERT INTO public.who_global_data VALUES (66715, 0, 0, 0, 0, 282, 117);
INSERT INTO public.who_global_data VALUES (66716, 0, 141, 0, 16, 282, 152);
INSERT INTO public.who_global_data VALUES (66717, 0, 61, 0, 2, 282, 16);
INSERT INTO public.who_global_data VALUES (66718, 0, 83, 0, 1, 282, 10);
INSERT INTO public.who_global_data VALUES (66719, 11, 1375, 0, 45, 282, 201);
INSERT INTO public.who_global_data VALUES (66720, 28, 3769, 0, 89, 282, 174);
INSERT INTO public.who_global_data VALUES (66721, 0, 128, 0, 0, 282, 119);
INSERT INTO public.who_global_data VALUES (66722, 0, 36, 0, 3, 282, 168);
INSERT INTO public.who_global_data VALUES (66723, 94, 5945, 0, 100, 282, 99);
INSERT INTO public.who_global_data VALUES (66724, 140, 396, 0, 0, 282, 171);
INSERT INTO public.who_global_data VALUES (66725, 58, 482, 1, 25, 282, 87);
INSERT INTO public.who_global_data VALUES (66726, 2, 464, 0, 4, 282, 123);
INSERT INTO public.who_global_data VALUES (66727, 0, 0, 0, 0, 282, 151);
INSERT INTO public.who_global_data VALUES (66728, 0, 175, 0, 14, 282, 213);
INSERT INTO public.who_global_data VALUES (66729, 0, 7, 0, 1, 282, 118);
INSERT INTO public.who_global_data VALUES (66730, 0, 332, 0, 10, 282, 134);
INSERT INTO public.who_global_data VALUES (66731, 0, 460, 0, 4, 282, 65);
INSERT INTO public.who_global_data VALUES (66732, 1223, 16752, 135, 1569, 282, 102);
INSERT INTO public.who_global_data VALUES (66733, 0, 0, 0, 0, 282, 223);
INSERT INTO public.who_global_data VALUES (66734, 0, 66, 0, 1, 282, 4);
INSERT INTO public.who_global_data VALUES (66735, 0, 38, 0, 0, 282, 146);
INSERT INTO public.who_global_data VALUES (66736, 0, 322, 0, 7, 282, 31);
INSERT INTO public.who_global_data VALUES (66737, 0, 11, 0, 1, 282, 127);
INSERT INTO public.who_global_data VALUES (66738, 70, 4359, 1, 168, 282, 22);
INSERT INTO public.who_global_data VALUES (66739, 0, 76, 0, 0, 282, 115);
INSERT INTO public.who_global_data VALUES (66740, 0, 150, 1, 6, 282, 106);
INSERT INTO public.who_global_data VALUES (66741, 0, 16, 0, 0, 282, 90);
INSERT INTO public.who_global_data VALUES (66742, 0, 0, 0, 0, 282, 70);
INSERT INTO public.who_global_data VALUES (66743, 0, 57, 0, 0, 282, 46);
INSERT INTO public.who_global_data VALUES (66744, 388, 38560, 141, 4670, 282, 139);
INSERT INTO public.who_global_data VALUES (66745, 0, 18, 0, 0, 282, 42);
INSERT INTO public.who_global_data VALUES (66746, 3, 1129, 0, 19, 282, 80);
INSERT INTO public.who_global_data VALUES (66747, 0, 13, 0, 3, 282, 203);
INSERT INTO public.who_global_data VALUES (66748, 4, 713, 1, 32, 282, 136);
INSERT INTO public.who_global_data VALUES (66749, 195, 1532, 4, 44, 282, 63);
INSERT INTO public.who_global_data VALUES (66750, 0, 0, 0, 0, 282, 17);
INSERT INTO public.who_global_data VALUES (66751, 0, 14, 0, 2, 282, 172);
INSERT INTO public.who_global_data VALUES (66752, 21, 1442, 2, 73, 282, 109);
INSERT INTO public.who_global_data VALUES (66753, 62, 7667, 7, 202, 282, 200);
INSERT INTO public.who_global_data VALUES (66754, 1, 344, 0, 2, 282, 93);
INSERT INTO public.who_global_data VALUES (66755, 74, 2348, 1, 11, 282, 5);
INSERT INTO public.who_global_data VALUES (66756, 0, 712, 0, 13, 282, 214);
INSERT INTO public.who_global_data VALUES (66757, 828, 16117, 23, 358, 282, 204);
INSERT INTO public.who_global_data VALUES (66758, 0, 0, 0, 0, 282, 198);
INSERT INTO public.who_global_data VALUES (66759, 179, 6200, 9, 176, 282, 173);
INSERT INTO public.who_global_data VALUES (66760, 0, 8, 0, 0, 282, 229);
INSERT INTO public.who_global_data VALUES (66761, 9, 239, 0, 9, 282, 76);
INSERT INTO public.who_global_data VALUES (66762, 2491, 31190, 72, 854, 282, 138);
INSERT INTO public.who_global_data VALUES (66763, 254, 8212, 28, 558, 282, 98);
INSERT INTO public.who_global_data VALUES (66764, 0, 0, 0, 0, 282, 103);
INSERT INTO public.who_global_data VALUES (66765, 422, 12640, 28, 624, 282, 225);
INSERT INTO public.who_global_data VALUES (66766, 368, 24692, 16, 989, 282, 131);
INSERT INTO public.who_global_data VALUES (66767, 33, 1433, 0, 54, 282, 235);
INSERT INTO public.who_global_data VALUES (66768, 845, 13409, 0, 10, 282, 137);
INSERT INTO public.who_global_data VALUES (66769, 4, 10765, 1, 247, 282, 81);
INSERT INTO public.who_global_data VALUES (66770, 133, 3771, 7, 116, 282, 182);
INSERT INTO public.who_global_data VALUES (66771, 3, 420, 0, 0, 282, 145);
INSERT INTO public.who_global_data VALUES (66772, 362, 11978, 25, 675, 282, 26);
INSERT INTO public.who_global_data VALUES (66773, 7099, 106498, 101, 1073, 282, 170);
INSERT INTO public.who_global_data VALUES (66774, 13, 225, 0, 0, 282, 191);
INSERT INTO public.who_global_data VALUES (66775, 0, 2, 0, 0, 282, 221);
INSERT INTO public.who_global_data VALUES (66776, 0, 6, 0, 0, 282, 64);
INSERT INTO public.who_global_data VALUES (66777, 0, 0, 0, 0, 282, 116);
INSERT INTO public.who_global_data VALUES (66778, 0, 15, 0, 0, 282, 128);
INSERT INTO public.who_global_data VALUES (66779, 2, 17, 0, 0, 282, 6);
INSERT INTO public.who_global_data VALUES (66780, 0, 38, 0, 3, 282, 227);
INSERT INTO public.who_global_data VALUES (66781, 0, 1, 0, 0, 282, 68);
INSERT INTO public.who_global_data VALUES (66782, 1, 16, 0, 0, 282, 184);
INSERT INTO public.who_global_data VALUES (66783, 0, 0, 0, 0, 282, 82);
INSERT INTO public.who_global_data VALUES (66784, 10, 563, 0, 41, 282, 149);
INSERT INTO public.who_global_data VALUES (66785, 0, 11, 0, 0, 282, 197);
INSERT INTO public.who_global_data VALUES (66786, 1351, 22753, 5, 162, 282, 78);
INSERT INTO public.who_global_data VALUES (66787, 59, 882, 0, 9, 282, 233);
INSERT INTO public.who_global_data VALUES (66788, 227, 8724, 5, 173, 282, 133);
INSERT INTO public.who_global_data VALUES (66789, 0, 11, 0, 0, 282, 35);
INSERT INTO public.who_global_data VALUES (66790, 12, 116, 1, 5, 282, 114);
INSERT INTO public.who_global_data VALUES (66791, 690, 15641, 0, 14, 282, 237);
INSERT INTO public.who_global_data VALUES (66792, 0, 2, 0, 0, 282, 55);
INSERT INTO public.who_global_data VALUES (66793, 0, 75, 0, 13, 282, 176);
INSERT INTO public.who_global_data VALUES (66794, 7, 1391, 2, 22, 282, 202);
INSERT INTO public.who_global_data VALUES (66795, 11, 1429, 1, 97, 282, 155);
INSERT INTO public.who_global_data VALUES (66796, 0, 0, 0, 0, 282, 32);
INSERT INTO public.who_global_data VALUES (66797, 19, 601, 0, 28, 282, 220);
INSERT INTO public.who_global_data VALUES (66798, 354, 5350, 10, 103, 282, 30);
INSERT INTO public.who_global_data VALUES (66799, 0, 34, 0, 0, 282, 147);
INSERT INTO public.who_global_data VALUES (66800, 1742, 223049, 259, 25664, 282, 208);
INSERT INTO public.who_global_data VALUES (66801, 30, 649, 0, 7, 282, 45);
INSERT INTO public.who_global_data VALUES (66802, 0, 375, 0, 28, 282, 110);
INSERT INTO public.who_global_data VALUES (66803, 0, 10, 0, 1, 282, 88);
INSERT INTO public.who_global_data VALUES (66804, 742, 20169, 83, 2753, 282, 51);
INSERT INTO public.who_global_data VALUES (66805, 120, 29676, 11, 1583, 282, 209);
INSERT INTO public.who_global_data VALUES (66806, 0, 43, 0, 3, 282, 205);
INSERT INTO public.who_global_data VALUES (66807, 0, 0, 0, 0, 282, 18);
INSERT INTO public.who_global_data VALUES (66808, 7, 2954, 0, 54, 282, 72);
INSERT INTO public.who_global_data VALUES (66809, 4729, 167150, 769, 26049, 282, 44);
INSERT INTO public.who_global_data VALUES (66810, 0, 24, 0, 0, 282, 15);
INSERT INTO public.who_global_data VALUES (66811, 10, 109, 1, 7, 282, 25);
INSERT INTO public.who_global_data VALUES (66812, 0, 0, 0, 0, 282, 179);
INSERT INTO public.who_global_data VALUES (66813, 0, 0, 0, 0, 282, 34);
INSERT INTO public.who_global_data VALUES (66814, 0, 116, 0, 8, 282, 207);
INSERT INTO public.who_global_data VALUES (66815, 5, 980, 0, 40, 282, 166);
INSERT INTO public.who_global_data VALUES (66816, 2936, 117589, 89, 3081, 282, 126);
INSERT INTO public.who_global_data VALUES (66817, 0, 0, 0, 0, 282, 97);
INSERT INTO public.who_global_data VALUES (66818, 0, 12, 0, 1, 282, 36);
INSERT INTO public.who_global_data VALUES (66819, 0, 0, 0, 0, 282, 125);
INSERT INTO public.who_global_data VALUES (66820, 0, 79, 0, 0, 282, 124);
INSERT INTO public.who_global_data VALUES (66821, 540, 10406, 11, 261, 282, 185);
INSERT INTO public.who_global_data VALUES (66822, 1101, 12481, 16, 105, 282, 194);
INSERT INTO public.who_global_data VALUES (66823, 180, 480, 6, 16, 282, 144);
INSERT INTO public.who_global_data VALUES (66824, 20517, 1003974, 2010, 57730, 282, 19);
INSERT INTO public.who_global_data VALUES (66825, 3, 62, 0, 4, 282, 217);
INSERT INTO public.who_global_data VALUES (66826, 5, 625, 0, 15, 282, 148);
INSERT INTO public.who_global_data VALUES (66827, 76, 2031, 1, 9, 282, 86);
INSERT INTO public.who_global_data VALUES (66828, 0, 0, 0, 0, 282, 13);
INSERT INTO public.who_global_data VALUES (66829, 0, 329, 0, 10, 282, 157);
INSERT INTO public.who_global_data VALUES (66830, 0, 270, 0, 0, 282, 8);
INSERT INTO public.who_global_data VALUES (66831, 0, 0, 0, 0, 282, 73);
INSERT INTO public.who_global_data VALUES (66832, 0, 6, 0, 0, 282, 101);
INSERT INTO public.who_global_data VALUES (66833, 2, 97, 0, 3, 282, 165);
INSERT INTO public.who_global_data VALUES (66834, 0, 32, 0, 4, 282, 14);
INSERT INTO public.who_global_data VALUES (66835, 0, 1827, 0, 60, 283, 193);
INSERT INTO public.who_global_data VALUES (66836, 30, 728, 2, 29, 283, 113);
INSERT INTO public.who_global_data VALUES (66837, 132, 3649, 5, 437, 283, 143);
INSERT INTO public.who_global_data VALUES (66838, 0, 0, 0, 0, 283, 219);
INSERT INTO public.who_global_data VALUES (66839, 1, 742, 1, 42, 283, 186);
INSERT INTO public.who_global_data VALUES (66840, 0, 27, 0, 2, 283, 52);
INSERT INTO public.who_global_data VALUES (66841, 0, 3, 0, 0, 283, 180);
INSERT INTO public.who_global_data VALUES (66842, 0, 24, 0, 3, 283, 167);
INSERT INTO public.who_global_data VALUES (66843, 127, 4019, 5, 197, 283, 154);
INSERT INTO public.who_global_data VALUES (66844, 59, 1843, 1, 30, 283, 94);
INSERT INTO public.who_global_data VALUES (66845, 0, 100, 0, 2, 283, 66);
INSERT INTO public.who_global_data VALUES (66846, 13, 6738, 4, 88, 283, 58);
INSERT INTO public.who_global_data VALUES (66847, 58, 15314, 20, 569, 283, 163);
INSERT INTO public.who_global_data VALUES (66848, 39, 1717, 0, 22, 283, 37);
INSERT INTO public.who_global_data VALUES (66849, 0, 80, 0, 11, 283, 142);
INSERT INTO public.who_global_data VALUES (66850, 59, 2869, 0, 8, 283, 83);
INSERT INTO public.who_global_data VALUES (66851, 641, 7103, 8, 163, 283, 228);
INSERT INTO public.who_global_data VALUES (66852, 1, 80, 0, 6, 283, 188);
INSERT INTO public.who_global_data VALUES (66853, 0, 12208, 0, 79, 283, 62);
INSERT INTO public.who_global_data VALUES (66854, 569, 49517, 110, 7671, 283, 160);
INSERT INTO public.who_global_data VALUES (66855, 0, 18, 0, 2, 283, 50);
INSERT INTO public.who_global_data VALUES (66856, 0, 64, 0, 1, 283, 33);
INSERT INTO public.who_global_data VALUES (66857, 1, 110, 0, 6, 283, 183);
INSERT INTO public.who_global_data VALUES (66858, 0, 7, 0, 0, 283, 92);
INSERT INTO public.who_global_data VALUES (66859, 64, 1014, 3, 53, 283, 158);
INSERT INTO public.who_global_data VALUES (66860, 0, 2, 0, 0, 283, 67);
INSERT INTO public.who_global_data VALUES (66861, 24, 1588, 2, 62, 283, 57);
INSERT INTO public.who_global_data VALUES (66862, 1, 23, 0, 1, 283, 38);
INSERT INTO public.who_global_data VALUES (66863, 4613, 66501, 338, 4543, 283, 141);
INSERT INTO public.who_global_data VALUES (66864, 0, 6, 0, 1, 283, 178);
INSERT INTO public.who_global_data VALUES (66865, 0, 138, 0, 1, 283, 108);
INSERT INTO public.who_global_data VALUES (66866, 36, 1399, 0, 58, 283, 39);
INSERT INTO public.who_global_data VALUES (66867, 6, 638, 0, 42, 283, 2);
INSERT INTO public.who_global_data VALUES (66868, 0, 15, 0, 1, 283, 195);
INSERT INTO public.who_global_data VALUES (66869, 7, 113, 0, 1, 283, 107);
INSERT INTO public.who_global_data VALUES (66870, 0, 122, 0, 0, 283, 161);
INSERT INTO public.who_global_data VALUES (66871, 84, 1705, 2, 58, 283, 212);
INSERT INTO public.who_global_data VALUES (66872, 1698, 49014, 149, 2766, 283, 181);
INSERT INTO public.who_global_data VALUES (66873, 0, 70, 0, 1, 283, 53);
INSERT INTO public.who_global_data VALUES (66874, 8, 50, 0, 0, 283, 164);
INSERT INTO public.who_global_data VALUES (66875, 6, 52, 2, 2, 283, 140);
INSERT INTO public.who_global_data VALUES (66876, 552, 14365, 9, 207, 283, 20);
INSERT INTO public.who_global_data VALUES (66877, 22, 84369, 0, 4643, 283, 112);
INSERT INTO public.who_global_data VALUES (66878, 218, 5597, 9, 253, 283, 111);
INSERT INTO public.who_global_data VALUES (66879, 0, 0, 0, 0, 283, 71);
INSERT INTO public.who_global_data VALUES (66880, 0, 207, 0, 8, 283, 218);
INSERT INTO public.who_global_data VALUES (66881, 0, 0, 0, 0, 283, 43);
INSERT INTO public.who_global_data VALUES (66882, 2, 697, 0, 6, 283, 49);
INSERT INTO public.who_global_data VALUES (66883, 19, 1183, 0, 14, 283, 1);
INSERT INTO public.who_global_data VALUES (66884, 8, 2047, 4, 63, 283, 48);
INSERT INTO public.who_global_data VALUES (66885, 48, 1437, 2, 58, 283, 232);
INSERT INTO public.who_global_data VALUES (66886, 0, 16, 0, 1, 283, 175);
INSERT INTO public.who_global_data VALUES (66887, 15, 837, 0, 15, 283, 21);
INSERT INTO public.who_global_data VALUES (66888, 55, 7504, 4, 227, 283, 156);
INSERT INTO public.who_global_data VALUES (66889, 0, 0, 0, 0, 283, 95);
INSERT INTO public.who_global_data VALUES (66890, 20, 491, 0, 30, 283, 177);
INSERT INTO public.who_global_data VALUES (66891, 153, 8851, 7, 434, 283, 210);
INSERT INTO public.who_global_data VALUES (66892, 5, 1077, 0, 2, 283, 120);
INSERT INTO public.who_global_data VALUES (66893, 0, 16, 0, 0, 283, 135);
INSERT INTO public.who_global_data VALUES (66894, 123, 6416, 4, 286, 283, 206);
INSERT INTO public.who_global_data VALUES (66895, 1018, 24258, 208, 871, 283, 189);
INSERT INTO public.who_global_data VALUES (66896, 226, 5268, 21, 380, 283, 129);
INSERT INTO public.who_global_data VALUES (66897, 22, 345, 0, 8, 283, 121);
INSERT INTO public.who_global_data VALUES (66898, 57, 315, 0, 1, 283, 59);
INSERT INTO public.who_global_data VALUES (66899, 0, 39, 0, 0, 283, 96);
INSERT INTO public.who_global_data VALUES (66900, 13, 1660, 0, 50, 283, 41);
INSERT INTO public.who_global_data VALUES (66901, 6, 71, 0, 1, 283, 216);
INSERT INTO public.who_global_data VALUES (66902, 2, 126, 0, 3, 283, 236);
INSERT INTO public.who_global_data VALUES (66903, 0, 13, 0, 0, 283, 150);
INSERT INTO public.who_global_data VALUES (66904, 0, 187, 0, 0, 283, 61);
INSERT INTO public.who_global_data VALUES (66905, 0, 18, 0, 0, 283, 7);
INSERT INTO public.who_global_data VALUES (66906, 45, 4740, 6, 199, 283, 169);
INSERT INTO public.who_global_data VALUES (66907, 1025, 125465, 366, 23627, 283, 28);
INSERT INTO public.who_global_data VALUES (66908, 13, 124, 0, 1, 283, 85);
INSERT INTO public.who_global_data VALUES (66909, 0, 58, 0, 0, 283, 211);
INSERT INTO public.who_global_data VALUES (66910, 62, 238, 0, 3, 283, 60);
INSERT INTO public.who_global_data VALUES (66911, 0, 10, 0, 1, 283, 3);
INSERT INTO public.who_global_data VALUES (66912, 6, 517, 0, 6, 283, 11);
INSERT INTO public.who_global_data VALUES (66913, 1304, 157641, 202, 6115, 283, 89);
INSERT INTO public.who_global_data VALUES (66914, 121, 1671, 5, 16, 283, 24);
INSERT INTO public.who_global_data VALUES (66915, 0, 141, 0, 0, 283, 162);
INSERT INTO public.who_global_data VALUES (66916, 0, 2534, 0, 136, 283, 100);
INSERT INTO public.who_global_data VALUES (66917, 0, 11, 0, 0, 283, 47);
INSERT INTO public.who_global_data VALUES (66918, 0, 18, 0, 0, 283, 29);
INSERT INTO public.who_global_data VALUES (66919, 0, 149, 1, 11, 283, 40);
INSERT INTO public.who_global_data VALUES (66920, 1, 141, 0, 5, 283, 222);
INSERT INTO public.who_global_data VALUES (66921, 30, 530, 0, 15, 283, 132);
INSERT INTO public.who_global_data VALUES (66922, 0, 247, 0, 13, 283, 130);
INSERT INTO public.who_global_data VALUES (66923, 77, 1240, 0, 7, 283, 234);
INSERT INTO public.who_global_data VALUES (66924, 0, 73, 0, 1, 283, 23);
INSERT INTO public.who_global_data VALUES (66925, 0, 74, 0, 8, 283, 192);
INSERT INTO public.who_global_data VALUES (66926, 2, 76, 0, 6, 283, 69);
INSERT INTO public.who_global_data VALUES (66927, 1, 10, 0, 0, 283, 187);
INSERT INTO public.who_global_data VALUES (66928, 41, 702, 3, 64, 283, 230);
INSERT INTO public.who_global_data VALUES (66929, 78, 2727, 9, 300, 283, 77);
INSERT INTO public.who_global_data VALUES (66930, 3, 1795, 0, 10, 283, 9);
INSERT INTO public.who_global_data VALUES (66931, 1897, 31332, 73, 1007, 283, 74);
INSERT INTO public.who_global_data VALUES (66932, 260, 9771, 11, 784, 283, 224);
INSERT INTO public.who_global_data VALUES (66933, 1073, 93657, 80, 5957, 283, 199);
INSERT INTO public.who_global_data VALUES (66934, 81, 1928, 2, 90, 283, 190);
INSERT INTO public.who_global_data VALUES (66935, 229, 19877, 57, 1159, 283, 12);
INSERT INTO public.who_global_data VALUES (66936, 0, 308, 2, 20, 283, 104);
INSERT INTO public.who_global_data VALUES (66937, 128, 15519, 4, 208, 283, 153);
INSERT INTO public.who_global_data VALUES (66938, 2091, 201505, 382, 27359, 283, 91);
INSERT INTO public.who_global_data VALUES (66939, 59, 364, 0, 7, 283, 215);
INSERT INTO public.who_global_data VALUES (66940, 276, 13852, 13, 389, 283, 84);
INSERT INTO public.who_global_data VALUES (66941, 2, 283, 0, 19, 283, 231);
INSERT INTO public.who_global_data VALUES (66942, 0, 449, 0, 8, 283, 196);
INSERT INTO public.who_global_data VALUES (66943, 255, 3333, 0, 25, 283, 105);
INSERT INTO public.who_global_data VALUES (66944, 11, 374, 0, 14, 283, 122);
INSERT INTO public.who_global_data VALUES (66945, 0, 0, 0, 0, 283, 159);
INSERT INTO public.who_global_data VALUES (66946, 10, 790, 0, 17, 283, 75);
INSERT INTO public.who_global_data VALUES (66947, 300, 3740, 1, 24, 283, 27);
INSERT INTO public.who_global_data VALUES (66948, 21, 729, 0, 8, 283, 54);
INSERT INTO public.who_global_data VALUES (66949, 0, 19, 0, 0, 283, 226);
INSERT INTO public.who_global_data VALUES (66950, 18, 836, 0, 13, 283, 79);
INSERT INTO public.who_global_data VALUES (66951, 4, 721, 0, 24, 283, 56);
INSERT INTO public.who_global_data VALUES (66952, 0, 0, 0, 0, 283, 117);
INSERT INTO public.who_global_data VALUES (66953, 8, 141, 0, 16, 283, 152);
INSERT INTO public.who_global_data VALUES (66954, 0, 61, 0, 2, 283, 16);
INSERT INTO public.who_global_data VALUES (66955, 0, 83, 0, 1, 283, 10);
INSERT INTO public.who_global_data VALUES (66956, 27, 1364, 1, 45, 283, 201);
INSERT INTO public.who_global_data VALUES (66957, 12, 3741, 1, 89, 283, 174);
INSERT INTO public.who_global_data VALUES (66958, 0, 128, 0, 0, 283, 119);
INSERT INTO public.who_global_data VALUES (66959, 0, 36, 0, 3, 283, 168);
INSERT INTO public.who_global_data VALUES (66960, 31, 5851, 1, 100, 283, 99);
INSERT INTO public.who_global_data VALUES (66961, 11, 256, 0, 0, 283, 171);
INSERT INTO public.who_global_data VALUES (66962, 16, 424, 1, 24, 283, 87);
INSERT INTO public.who_global_data VALUES (66963, 5, 462, 0, 4, 283, 123);
INSERT INTO public.who_global_data VALUES (66964, 0, 0, 0, 0, 283, 151);
INSERT INTO public.who_global_data VALUES (66965, 0, 175, 0, 14, 283, 213);
INSERT INTO public.who_global_data VALUES (66966, 0, 7, 0, 1, 283, 118);
INSERT INTO public.who_global_data VALUES (66967, 0, 332, 1, 10, 283, 134);
INSERT INTO public.who_global_data VALUES (66968, 27, 460, 0, 4, 283, 65);
INSERT INTO public.who_global_data VALUES (66969, 852, 15529, 83, 1434, 283, 102);
INSERT INTO public.who_global_data VALUES (66970, 0, 0, 0, 0, 283, 223);
INSERT INTO public.who_global_data VALUES (66971, 0, 66, 0, 1, 283, 4);
INSERT INTO public.who_global_data VALUES (66972, 0, 38, 0, 0, 283, 146);
INSERT INTO public.who_global_data VALUES (66973, 1, 322, 0, 7, 283, 31);
INSERT INTO public.who_global_data VALUES (66974, 0, 11, 0, 1, 283, 127);
INSERT INTO public.who_global_data VALUES (66975, 43, 4289, 4, 167, 283, 22);
INSERT INTO public.who_global_data VALUES (66976, 0, 76, 0, 0, 283, 115);
INSERT INTO public.who_global_data VALUES (66977, 4, 150, 0, 5, 283, 106);
INSERT INTO public.who_global_data VALUES (66978, 0, 16, 0, 0, 283, 90);
INSERT INTO public.who_global_data VALUES (66979, 0, 0, 0, 0, 283, 70);
INSERT INTO public.who_global_data VALUES (66980, 5, 57, 0, 0, 283, 46);
INSERT INTO public.who_global_data VALUES (66981, 193, 38172, 47, 4529, 283, 139);
INSERT INTO public.who_global_data VALUES (66982, 0, 18, 0, 0, 283, 42);
INSERT INTO public.who_global_data VALUES (66983, 2, 1126, 0, 19, 283, 80);
INSERT INTO public.who_global_data VALUES (66984, 0, 13, 0, 3, 283, 203);
INSERT INTO public.who_global_data VALUES (66985, 8, 709, 2, 31, 283, 136);
INSERT INTO public.who_global_data VALUES (66986, 0, 1337, 0, 40, 283, 63);
INSERT INTO public.who_global_data VALUES (66987, 0, 0, 0, 0, 283, 17);
INSERT INTO public.who_global_data VALUES (66988, 0, 14, 0, 2, 283, 172);
INSERT INTO public.who_global_data VALUES (66989, 22, 1421, 6, 71, 283, 109);
INSERT INTO public.who_global_data VALUES (66990, 72, 7605, 2, 195, 283, 200);
INSERT INTO public.who_global_data VALUES (66991, 0, 343, 0, 2, 283, 93);
INSERT INTO public.who_global_data VALUES (66992, 143, 2274, 0, 10, 283, 5);
INSERT INTO public.who_global_data VALUES (66993, 0, 712, 0, 13, 283, 214);
INSERT INTO public.who_global_data VALUES (66994, 1210, 15289, 34, 335, 283, 204);
INSERT INTO public.who_global_data VALUES (66995, 0, 0, 0, 0, 283, 198);
INSERT INTO public.who_global_data VALUES (66996, 242, 6021, 2, 167, 283, 173);
INSERT INTO public.who_global_data VALUES (66997, 0, 8, 0, 0, 283, 229);
INSERT INTO public.who_global_data VALUES (66998, 2, 230, 0, 9, 283, 76);
INSERT INTO public.who_global_data VALUES (66999, 1182, 28699, 54, 782, 283, 138);
INSERT INTO public.who_global_data VALUES (67000, 181, 7958, 19, 530, 283, 98);
INSERT INTO public.who_global_data VALUES (67001, 0, 0, 0, 0, 283, 103);
INSERT INTO public.who_global_data VALUES (67002, 316, 12218, 34, 596, 283, 225);
INSERT INTO public.who_global_data VALUES (67003, 180, 24324, 25, 973, 283, 131);
INSERT INTO public.who_global_data VALUES (67004, 11, 1400, 1, 54, 283, 235);
INSERT INTO public.who_global_data VALUES (67005, 643, 12564, 0, 10, 283, 137);
INSERT INTO public.who_global_data VALUES (67006, 9, 10761, 2, 246, 283, 81);
INSERT INTO public.who_global_data VALUES (67007, 157, 3638, 6, 109, 283, 182);
INSERT INTO public.who_global_data VALUES (67008, 0, 417, 0, 0, 283, 145);
INSERT INTO public.who_global_data VALUES (67009, 277, 11616, 19, 650, 283, 26);
INSERT INTO public.who_global_data VALUES (67010, 5841, 99399, 105, 972, 283, 170);
INSERT INTO public.who_global_data VALUES (67011, 5, 212, 0, 0, 283, 191);
INSERT INTO public.who_global_data VALUES (67012, 0, 2, 0, 0, 283, 221);
INSERT INTO public.who_global_data VALUES (67013, 0, 6, 0, 0, 283, 64);
INSERT INTO public.who_global_data VALUES (67014, 0, 0, 0, 0, 283, 116);
INSERT INTO public.who_global_data VALUES (67015, 0, 15, 0, 0, 283, 128);
INSERT INTO public.who_global_data VALUES (67016, 0, 15, 0, 0, 283, 6);
INSERT INTO public.who_global_data VALUES (67017, 0, 38, 0, 3, 283, 227);
INSERT INTO public.who_global_data VALUES (67018, 0, 1, 0, 0, 283, 68);
INSERT INTO public.who_global_data VALUES (67019, 0, 15, 0, 0, 283, 184);
INSERT INTO public.who_global_data VALUES (67020, 0, 0, 0, 0, 283, 82);
INSERT INTO public.who_global_data VALUES (67021, 15, 553, 0, 41, 283, 149);
INSERT INTO public.who_global_data VALUES (67022, 3, 11, 0, 0, 283, 197);
INSERT INTO public.who_global_data VALUES (67023, 1325, 21402, 5, 157, 283, 78);
INSERT INTO public.who_global_data VALUES (67024, 88, 823, 0, 9, 283, 233);
INSERT INTO public.who_global_data VALUES (67025, 222, 8497, 6, 168, 283, 133);
INSERT INTO public.who_global_data VALUES (67026, 0, 11, 0, 0, 283, 35);
INSERT INTO public.who_global_data VALUES (67027, 5, 104, 0, 4, 283, 114);
INSERT INTO public.who_global_data VALUES (67028, 528, 14951, 0, 14, 283, 237);
INSERT INTO public.who_global_data VALUES (67029, 0, 2, 0, 0, 283, 55);
INSERT INTO public.who_global_data VALUES (67030, 1, 75, 0, 13, 283, 176);
INSERT INTO public.who_global_data VALUES (67031, 3, 1384, 2, 20, 283, 202);
INSERT INTO public.who_global_data VALUES (67032, 9, 1418, 3, 96, 283, 155);
INSERT INTO public.who_global_data VALUES (67033, 0, 0, 0, 0, 283, 32);
INSERT INTO public.who_global_data VALUES (67034, 54, 582, 0, 28, 283, 220);
INSERT INTO public.who_global_data VALUES (67035, 203, 4996, 3, 93, 283, 30);
INSERT INTO public.who_global_data VALUES (67036, 28, 34, 0, 0, 283, 147);
INSERT INTO public.who_global_data VALUES (67037, 1655, 221307, 258, 25405, 283, 208);
INSERT INTO public.who_global_data VALUES (67038, 31, 619, 0, 7, 283, 45);
INSERT INTO public.who_global_data VALUES (67039, 57, 375, 3, 28, 283, 110);
INSERT INTO public.who_global_data VALUES (67040, 0, 10, 0, 1, 283, 88);
INSERT INTO public.who_global_data VALUES (67041, 563, 19427, 74, 2670, 283, 51);
INSERT INTO public.who_global_data VALUES (67042, 153, 29556, 12, 1572, 283, 209);
INSERT INTO public.who_global_data VALUES (67043, 0, 43, 0, 3, 283, 205);
INSERT INTO public.who_global_data VALUES (67044, 0, 0, 0, 0, 283, 18);
INSERT INTO public.who_global_data VALUES (67045, 9, 2947, 0, 54, 283, 72);
INSERT INTO public.who_global_data VALUES (67046, 4706, 162421, 969, 25280, 283, 44);
INSERT INTO public.who_global_data VALUES (67047, 0, 24, 0, 0, 283, 15);
INSERT INTO public.who_global_data VALUES (67048, 0, 99, 0, 6, 283, 25);
INSERT INTO public.who_global_data VALUES (67049, 0, 0, 0, 0, 283, 179);
INSERT INTO public.who_global_data VALUES (67050, 0, 0, 0, 0, 283, 34);
INSERT INTO public.who_global_data VALUES (67051, 0, 116, 0, 8, 283, 207);
INSERT INTO public.who_global_data VALUES (67052, 8, 975, 1, 40, 283, 166);
INSERT INTO public.who_global_data VALUES (67053, 2392, 114653, 92, 2992, 283, 126);
INSERT INTO public.who_global_data VALUES (67054, 0, 0, 0, 0, 283, 97);
INSERT INTO public.who_global_data VALUES (67055, 0, 12, 0, 1, 283, 36);
INSERT INTO public.who_global_data VALUES (67056, 0, 0, 0, 0, 283, 125);
INSERT INTO public.who_global_data VALUES (67057, 0, 79, 0, 0, 283, 124);
INSERT INTO public.who_global_data VALUES (67058, 456, 9866, 11, 250, 283, 185);
INSERT INTO public.who_global_data VALUES (67059, 0, 11380, 0, 89, 283, 194);
INSERT INTO public.who_global_data VALUES (67060, 0, 300, 0, 10, 283, 144);
INSERT INTO public.who_global_data VALUES (67061, 22541, 983457, 1322, 55720, 283, 19);
INSERT INTO public.who_global_data VALUES (67062, 0, 59, 0, 4, 283, 217);
INSERT INTO public.who_global_data VALUES (67063, 14, 620, 0, 15, 283, 148);
INSERT INTO public.who_global_data VALUES (67064, 31, 1955, 0, 8, 283, 86);
INSERT INTO public.who_global_data VALUES (67065, 0, 0, 0, 0, 283, 13);
INSERT INTO public.who_global_data VALUES (67066, 4, 329, 0, 10, 283, 157);
INSERT INTO public.who_global_data VALUES (67067, 0, 270, 0, 0, 283, 8);
INSERT INTO public.who_global_data VALUES (67068, 0, 0, 0, 0, 283, 73);
INSERT INTO public.who_global_data VALUES (67069, 5, 6, 0, 0, 283, 101);
INSERT INTO public.who_global_data VALUES (67070, 6, 95, 0, 3, 283, 165);
INSERT INTO public.who_global_data VALUES (67071, 1, 32, 0, 4, 283, 14);
INSERT INTO public.who_global_data VALUES (67072, 124, 1827, 3, 60, 284, 193);
INSERT INTO public.who_global_data VALUES (67073, 10, 698, 0, 27, 284, 113);
INSERT INTO public.who_global_data VALUES (67074, 135, 3517, 7, 432, 284, 143);
INSERT INTO public.who_global_data VALUES (67075, 0, 0, 0, 0, 284, 219);
INSERT INTO public.who_global_data VALUES (67076, 1, 741, 1, 41, 284, 186);
INSERT INTO public.who_global_data VALUES (67077, 1, 27, 0, 2, 284, 52);
INSERT INTO public.who_global_data VALUES (67078, 0, 3, 0, 0, 284, 180);
INSERT INTO public.who_global_data VALUES (67079, 0, 24, 0, 3, 284, 167);
INSERT INTO public.who_global_data VALUES (67080, 54, 3892, 13, 192, 284, 154);
INSERT INTO public.who_global_data VALUES (67081, 62, 1784, 1, 29, 284, 94);
INSERT INTO public.who_global_data VALUES (67082, 0, 100, 0, 2, 284, 66);
INSERT INTO public.who_global_data VALUES (67083, 12, 6725, 1, 84, 284, 58);
INSERT INTO public.who_global_data VALUES (67084, 67, 15256, 7, 549, 284, 163);
INSERT INTO public.who_global_data VALUES (67085, 33, 1678, 1, 22, 284, 37);
INSERT INTO public.who_global_data VALUES (67086, 2, 80, 0, 11, 284, 142);
INSERT INTO public.who_global_data VALUES (67087, 102, 2810, 0, 8, 284, 83);
INSERT INTO public.who_global_data VALUES (67088, 549, 6462, 3, 155, 284, 228);
INSERT INTO public.who_global_data VALUES (67089, 0, 79, 0, 6, 284, 188);
INSERT INTO public.who_global_data VALUES (67090, 1745, 12208, 7, 79, 284, 62);
INSERT INTO public.who_global_data VALUES (67091, 755, 48948, 134, 7561, 284, 160);
INSERT INTO public.who_global_data VALUES (67092, 0, 18, 0, 2, 284, 50);
INSERT INTO public.who_global_data VALUES (67093, 0, 64, 0, 1, 284, 33);
INSERT INTO public.who_global_data VALUES (67094, 0, 109, 1, 6, 284, 183);
INSERT INTO public.who_global_data VALUES (67095, 0, 7, 0, 0, 284, 92);
INSERT INTO public.who_global_data VALUES (67096, 84, 950, 4, 50, 284, 158);
INSERT INTO public.who_global_data VALUES (67097, 1, 2, 0, 0, 284, 67);
INSERT INTO public.who_global_data VALUES (67098, 48, 1564, 2, 60, 284, 57);
INSERT INTO public.who_global_data VALUES (67099, 0, 22, 0, 1, 284, 38);
INSERT INTO public.who_global_data VALUES (67100, 3379, 61888, 189, 4205, 284, 141);
INSERT INTO public.who_global_data VALUES (67101, 0, 6, 0, 1, 284, 178);
INSERT INTO public.who_global_data VALUES (67102, 0, 138, 0, 1, 284, 108);
INSERT INTO public.who_global_data VALUES (67103, 63, 1363, 2, 58, 284, 39);
INSERT INTO public.who_global_data VALUES (67104, 0, 632, 0, 42, 284, 2);
INSERT INTO public.who_global_data VALUES (67105, 0, 15, 0, 1, 284, 195);
INSERT INTO public.who_global_data VALUES (67106, 0, 106, 0, 1, 284, 107);
INSERT INTO public.who_global_data VALUES (67107, 0, 122, 0, 0, 284, 161);
INSERT INTO public.who_global_data VALUES (67108, 0, 1621, 0, 56, 284, 212);
INSERT INTO public.who_global_data VALUES (67109, 1538, 47316, 128, 2617, 284, 181);
INSERT INTO public.who_global_data VALUES (67110, 0, 70, 0, 1, 284, 53);
INSERT INTO public.who_global_data VALUES (67111, 23, 42, 0, 0, 284, 164);
INSERT INTO public.who_global_data VALUES (67112, 0, 46, 0, 0, 284, 140);
INSERT INTO public.who_global_data VALUES (67113, 482, 13813, 9, 198, 284, 20);
INSERT INTO public.who_global_data VALUES (67114, 6, 84347, 0, 4643, 284, 112);
INSERT INTO public.who_global_data VALUES (67115, 237, 5379, 11, 244, 284, 111);
INSERT INTO public.who_global_data VALUES (67116, 0, 0, 0, 0, 284, 71);
INSERT INTO public.who_global_data VALUES (67117, 7, 207, 0, 8, 284, 218);
INSERT INTO public.who_global_data VALUES (67118, 0, 0, 0, 0, 284, 43);
INSERT INTO public.who_global_data VALUES (67119, 2, 695, 0, 6, 284, 49);
INSERT INTO public.who_global_data VALUES (67120, 14, 1164, 0, 14, 284, 1);
INSERT INTO public.who_global_data VALUES (67121, 9, 2039, 4, 59, 284, 48);
INSERT INTO public.who_global_data VALUES (67122, 20, 1389, 2, 56, 284, 232);
INSERT INTO public.who_global_data VALUES (67123, 2, 16, 0, 1, 284, 175);
INSERT INTO public.who_global_data VALUES (67124, 5, 822, 1, 15, 284, 21);
INSERT INTO public.who_global_data VALUES (67125, 45, 7449, 2, 223, 284, 156);
INSERT INTO public.who_global_data VALUES (67126, 0, 0, 0, 0, 284, 95);
INSERT INTO public.who_global_data VALUES (67127, 12, 471, 2, 30, 284, 177);
INSERT INTO public.who_global_data VALUES (67128, 123, 8698, 5, 427, 284, 210);
INSERT INTO public.who_global_data VALUES (67129, 37, 1072, 0, 2, 284, 120);
INSERT INTO public.who_global_data VALUES (67130, 0, 16, 0, 0, 284, 135);
INSERT INTO public.who_global_data VALUES (67131, 158, 6293, 4, 282, 284, 206);
INSERT INTO public.who_global_data VALUES (67132, 521, 23240, 87, 663, 284, 189);
INSERT INTO public.who_global_data VALUES (67133, 260, 5042, 22, 359, 284, 129);
INSERT INTO public.who_global_data VALUES (67134, 25, 323, 0, 8, 284, 121);
INSERT INTO public.who_global_data VALUES (67135, 0, 258, 0, 1, 284, 59);
INSERT INTO public.who_global_data VALUES (67136, 0, 39, 0, 0, 284, 96);
INSERT INTO public.who_global_data VALUES (67137, 4, 1647, 1, 50, 284, 41);
INSERT INTO public.who_global_data VALUES (67138, 6, 65, 0, 1, 284, 216);
INSERT INTO public.who_global_data VALUES (67139, 1, 124, 0, 3, 284, 236);
INSERT INTO public.who_global_data VALUES (67140, 0, 13, 0, 0, 284, 150);
INSERT INTO public.who_global_data VALUES (67141, 0, 187, 0, 0, 284, 61);
INSERT INTO public.who_global_data VALUES (67142, 0, 18, 0, 0, 284, 7);
INSERT INTO public.who_global_data VALUES (67143, 119, 4695, 3, 193, 284, 169);
INSERT INTO public.who_global_data VALUES (67144, 1160, 124440, 437, 23261, 284, 28);
INSERT INTO public.who_global_data VALUES (67145, 2, 111, 0, 1, 284, 85);
INSERT INTO public.who_global_data VALUES (67146, 1, 58, 0, 0, 284, 211);
INSERT INTO public.who_global_data VALUES (67147, 0, 176, 0, 3, 284, 60);
INSERT INTO public.who_global_data VALUES (67148, 0, 10, 0, 1, 284, 3);
INSERT INTO public.who_global_data VALUES (67149, 15, 511, 0, 6, 284, 11);
INSERT INTO public.who_global_data VALUES (67150, 1144, 156337, 163, 5913, 284, 89);
INSERT INTO public.who_global_data VALUES (67151, 0, 1550, 0, 11, 284, 24);
INSERT INTO public.who_global_data VALUES (67152, 0, 141, 0, 0, 284, 162);
INSERT INTO public.who_global_data VALUES (67153, 28, 2534, 6, 136, 284, 100);
INSERT INTO public.who_global_data VALUES (67154, 0, 11, 0, 0, 284, 47);
INSERT INTO public.who_global_data VALUES (67155, 0, 18, 0, 0, 284, 29);
INSERT INTO public.who_global_data VALUES (67156, 0, 149, 0, 10, 284, 40);
INSERT INTO public.who_global_data VALUES (67157, 2, 140, 0, 5, 284, 222);
INSERT INTO public.who_global_data VALUES (67158, 27, 500, 0, 15, 284, 132);
INSERT INTO public.who_global_data VALUES (67159, 2, 247, 1, 13, 284, 130);
INSERT INTO public.who_global_data VALUES (67160, 69, 1163, 0, 7, 284, 234);
INSERT INTO public.who_global_data VALUES (67161, 20, 73, 0, 1, 284, 23);
INSERT INTO public.who_global_data VALUES (67162, 0, 74, 0, 8, 284, 192);
INSERT INTO public.who_global_data VALUES (67163, 2, 74, 0, 6, 284, 69);
INSERT INTO public.who_global_data VALUES (67164, 0, 9, 0, 0, 284, 187);
INSERT INTO public.who_global_data VALUES (67165, 34, 661, 2, 61, 284, 230);
INSERT INTO public.who_global_data VALUES (67166, 66, 2649, 11, 291, 284, 77);
INSERT INTO public.who_global_data VALUES (67167, 0, 1792, 0, 10, 284, 9);
INSERT INTO public.who_global_data VALUES (67168, 1543, 29435, 62, 934, 284, 74);
INSERT INTO public.who_global_data VALUES (67169, 415, 9511, 8, 773, 284, 224);
INSERT INTO public.who_global_data VALUES (67170, 1112, 92584, 71, 5877, 284, 199);
INSERT INTO public.who_global_data VALUES (67171, 27, 1847, 1, 88, 284, 190);
INSERT INTO public.who_global_data VALUES (67172, 386, 19648, 15, 1102, 284, 12);
INSERT INTO public.who_global_data VALUES (67173, 0, 308, 0, 18, 284, 104);
INSERT INTO public.who_global_data VALUES (67174, 83, 15391, 2, 204, 284, 153);
INSERT INTO public.who_global_data VALUES (67175, 1739, 199414, 333, 26977, 284, 91);
INSERT INTO public.who_global_data VALUES (67176, 0, 305, 0, 7, 284, 215);
INSERT INTO public.who_global_data VALUES (67177, 191, 13576, 25, 376, 284, 84);
INSERT INTO public.who_global_data VALUES (67178, 1, 281, 0, 19, 284, 231);
INSERT INTO public.who_global_data VALUES (67179, 0, 449, 1, 8, 284, 196);
INSERT INTO public.who_global_data VALUES (67180, 96, 3078, 0, 25, 284, 105);
INSERT INTO public.who_global_data VALUES (67181, 8, 363, 0, 14, 284, 122);
INSERT INTO public.who_global_data VALUES (67182, 0, 0, 0, 0, 284, 159);
INSERT INTO public.who_global_data VALUES (67183, 17, 780, 0, 17, 284, 75);
INSERT INTO public.who_global_data VALUES (67184, 152, 3440, 1, 23, 284, 27);
INSERT INTO public.who_global_data VALUES (67185, 13, 708, 0, 8, 284, 54);
INSERT INTO public.who_global_data VALUES (67186, 0, 19, 0, 0, 284, 226);
INSERT INTO public.who_global_data VALUES (67187, 6, 818, 1, 13, 284, 79);
INSERT INTO public.who_global_data VALUES (67188, 7, 717, 0, 24, 284, 56);
INSERT INTO public.who_global_data VALUES (67189, 0, 0, 0, 0, 284, 117);
INSERT INTO public.who_global_data VALUES (67190, 9, 133, 4, 16, 284, 152);
INSERT INTO public.who_global_data VALUES (67191, 0, 61, 0, 2, 284, 16);
INSERT INTO public.who_global_data VALUES (67192, 0, 83, 0, 1, 284, 10);
INSERT INTO public.who_global_data VALUES (67193, 9, 1337, 0, 44, 284, 201);
INSERT INTO public.who_global_data VALUES (67194, 6, 3729, 0, 88, 284, 174);
INSERT INTO public.who_global_data VALUES (67195, 0, 128, 0, 0, 284, 119);
INSERT INTO public.who_global_data VALUES (67196, 2, 36, 0, 3, 284, 168);
INSERT INTO public.who_global_data VALUES (67197, 40, 5820, 1, 99, 284, 99);
INSERT INTO public.who_global_data VALUES (67198, 31, 245, 0, 0, 284, 171);
INSERT INTO public.who_global_data VALUES (67199, 19, 408, 0, 23, 284, 87);
INSERT INTO public.who_global_data VALUES (67200, 8, 457, 0, 4, 284, 123);
INSERT INTO public.who_global_data VALUES (67201, 0, 0, 0, 0, 284, 151);
INSERT INTO public.who_global_data VALUES (67202, 0, 175, 0, 14, 284, 213);
INSERT INTO public.who_global_data VALUES (67203, 0, 7, 0, 1, 284, 118);
INSERT INTO public.who_global_data VALUES (67204, 0, 332, 0, 9, 284, 134);
INSERT INTO public.who_global_data VALUES (67205, 32, 433, 0, 4, 284, 65);
INSERT INTO public.who_global_data VALUES (67206, 835, 14677, 46, 1351, 284, 102);
INSERT INTO public.who_global_data VALUES (67207, 0, 0, 0, 0, 284, 223);
INSERT INTO public.who_global_data VALUES (67208, 1, 66, 0, 1, 284, 4);
INSERT INTO public.who_global_data VALUES (67209, 0, 38, 0, 0, 284, 146);
INSERT INTO public.who_global_data VALUES (67210, 0, 321, 0, 7, 284, 31);
INSERT INTO public.who_global_data VALUES (67211, 0, 11, 0, 1, 284, 127);
INSERT INTO public.who_global_data VALUES (67212, 131, 4246, 2, 163, 284, 22);
INSERT INTO public.who_global_data VALUES (67213, 0, 76, 0, 0, 284, 115);
INSERT INTO public.who_global_data VALUES (67214, 0, 146, 0, 5, 284, 106);
INSERT INTO public.who_global_data VALUES (67215, 0, 16, 0, 0, 284, 90);
INSERT INTO public.who_global_data VALUES (67216, 0, 0, 0, 0, 284, 70);
INSERT INTO public.who_global_data VALUES (67217, 0, 52, 0, 0, 284, 46);
INSERT INTO public.who_global_data VALUES (67218, 405, 37979, 44, 4482, 284, 139);
INSERT INTO public.who_global_data VALUES (67219, 0, 18, 0, 0, 284, 42);
INSERT INTO public.who_global_data VALUES (67220, 2, 1124, 0, 19, 284, 80);
INSERT INTO public.who_global_data VALUES (67221, 0, 13, 0, 3, 284, 203);
INSERT INTO public.who_global_data VALUES (67222, 5, 701, 0, 29, 284, 136);
INSERT INTO public.who_global_data VALUES (67223, 64, 1337, 0, 40, 284, 63);
INSERT INTO public.who_global_data VALUES (67224, 0, 0, 0, 0, 284, 17);
INSERT INTO public.who_global_data VALUES (67225, 0, 14, 0, 2, 284, 172);
INSERT INTO public.who_global_data VALUES (67226, 13, 1399, 4, 65, 284, 109);
INSERT INTO public.who_global_data VALUES (67227, 28, 7533, 0, 193, 284, 200);
INSERT INTO public.who_global_data VALUES (67228, 1, 343, 0, 2, 284, 93);
INSERT INTO public.who_global_data VALUES (67229, 82, 2131, 0, 10, 284, 5);
INSERT INTO public.who_global_data VALUES (67230, 0, 712, 0, 13, 284, 214);
INSERT INTO public.who_global_data VALUES (67231, 164, 14079, 9, 301, 284, 204);
INSERT INTO public.who_global_data VALUES (67232, 0, 0, 0, 0, 284, 198);
INSERT INTO public.who_global_data VALUES (67233, 241, 5779, 6, 165, 284, 173);
INSERT INTO public.who_global_data VALUES (67234, 0, 8, 0, 0, 284, 229);
INSERT INTO public.who_global_data VALUES (67235, 0, 228, 0, 9, 284, 76);
INSERT INTO public.who_global_data VALUES (67236, 2186, 27517, 28, 728, 284, 138);
INSERT INTO public.who_global_data VALUES (67237, 198, 7777, 10, 511, 284, 98);
INSERT INTO public.who_global_data VALUES (67238, 0, 0, 0, 0, 284, 103);
INSERT INTO public.who_global_data VALUES (67239, 285, 11902, 27, 562, 284, 225);
INSERT INTO public.who_global_data VALUES (67240, 298, 24144, 20, 948, 284, 131);
INSERT INTO public.who_global_data VALUES (67241, 18, 1389, 0, 53, 284, 235);
INSERT INTO public.who_global_data VALUES (67242, 677, 11921, 0, 10, 284, 137);
INSERT INTO public.who_global_data VALUES (67243, 14, 10752, 1, 244, 284, 81);
INSERT INTO public.who_global_data VALUES (67244, 73, 3481, 7, 103, 284, 182);
INSERT INTO public.who_global_data VALUES (67245, 1, 417, 0, 0, 284, 145);
INSERT INTO public.who_global_data VALUES (67246, 303, 11339, 23, 631, 284, 26);
INSERT INTO public.who_global_data VALUES (67247, 6411, 93558, 73, 867, 284, 170);
INSERT INTO public.who_global_data VALUES (67248, 16, 207, 0, 0, 284, 191);
INSERT INTO public.who_global_data VALUES (67249, 0, 2, 0, 0, 284, 221);
INSERT INTO public.who_global_data VALUES (67250, 0, 6, 0, 0, 284, 64);
INSERT INTO public.who_global_data VALUES (67251, 0, 0, 0, 0, 284, 116);
INSERT INTO public.who_global_data VALUES (67252, 0, 15, 0, 0, 284, 128);
INSERT INTO public.who_global_data VALUES (67253, 0, 15, 0, 0, 284, 6);
INSERT INTO public.who_global_data VALUES (67254, 0, 38, 0, 3, 284, 227);
INSERT INTO public.who_global_data VALUES (67255, 0, 1, 0, 0, 284, 68);
INSERT INTO public.who_global_data VALUES (67256, 1, 15, 0, 0, 284, 184);
INSERT INTO public.who_global_data VALUES (67257, 0, 0, 0, 0, 284, 82);
INSERT INTO public.who_global_data VALUES (67258, 0, 538, 0, 41, 284, 149);
INSERT INTO public.who_global_data VALUES (67259, 0, 8, 0, 0, 284, 197);
INSERT INTO public.who_global_data VALUES (67260, 1266, 20077, 8, 152, 284, 78);
INSERT INTO public.who_global_data VALUES (67261, 64, 735, 0, 9, 284, 233);
INSERT INTO public.who_global_data VALUES (67262, 233, 8275, 6, 162, 284, 133);
INSERT INTO public.who_global_data VALUES (67263, 0, 11, 0, 0, 284, 35);
INSERT INTO public.who_global_data VALUES (67264, 6, 99, 0, 4, 284, 114);
INSERT INTO public.who_global_data VALUES (67265, 799, 14423, 2, 14, 284, 237);
INSERT INTO public.who_global_data VALUES (67266, 0, 2, 0, 0, 284, 55);
INSERT INTO public.who_global_data VALUES (67267, 0, 74, 0, 13, 284, 176);
INSERT INTO public.who_global_data VALUES (67268, 2, 1381, 0, 18, 284, 202);
INSERT INTO public.who_global_data VALUES (67269, 6, 1409, 3, 93, 284, 155);
INSERT INTO public.who_global_data VALUES (67270, 0, 0, 0, 0, 284, 32);
INSERT INTO public.who_global_data VALUES (67271, 48, 528, 2, 28, 284, 220);
INSERT INTO public.who_global_data VALUES (67272, 247, 4793, 3, 90, 284, 30);
INSERT INTO public.who_global_data VALUES (67273, 0, 6, 0, 0, 284, 147);
INSERT INTO public.who_global_data VALUES (67274, 818, 219652, 272, 25147, 284, 208);
INSERT INTO public.who_global_data VALUES (67275, 65, 588, 0, 7, 284, 45);
INSERT INTO public.who_global_data VALUES (67276, 43, 318, 3, 25, 284, 110);
INSERT INTO public.who_global_data VALUES (67277, 0, 10, 0, 1, 284, 88);
INSERT INTO public.who_global_data VALUES (67278, 300, 18864, 74, 2596, 284, 51);
INSERT INTO public.who_global_data VALUES (67279, 173, 29403, 23, 1560, 284, 209);
INSERT INTO public.who_global_data VALUES (67280, 0, 43, 0, 3, 284, 205);
INSERT INTO public.who_global_data VALUES (67281, 0, 0, 0, 0, 284, 18);
INSERT INTO public.who_global_data VALUES (67282, 7, 2938, 2, 54, 284, 72);
INSERT INTO public.who_global_data VALUES (67283, 3473, 157715, 320, 24311, 284, 44);
INSERT INTO public.who_global_data VALUES (67284, 0, 24, 0, 0, 284, 15);
INSERT INTO public.who_global_data VALUES (67285, 1, 99, 0, 6, 284, 25);
INSERT INTO public.who_global_data VALUES (67286, 0, 0, 0, 0, 284, 179);
INSERT INTO public.who_global_data VALUES (67287, 0, 0, 0, 0, 284, 34);
INSERT INTO public.who_global_data VALUES (67288, 1, 116, 0, 8, 284, 207);
INSERT INTO public.who_global_data VALUES (67289, 18, 967, 1, 39, 284, 166);
INSERT INTO public.who_global_data VALUES (67290, 2131, 112261, 95, 2900, 284, 126);
INSERT INTO public.who_global_data VALUES (67291, 0, 0, 0, 0, 284, 97);
INSERT INTO public.who_global_data VALUES (67292, 1, 12, 0, 1, 284, 36);
INSERT INTO public.who_global_data VALUES (67293, 0, 0, 0, 0, 284, 125);
INSERT INTO public.who_global_data VALUES (67294, 4, 79, 0, 0, 284, 124);
INSERT INTO public.who_global_data VALUES (67295, 401, 9410, 19, 239, 284, 185);
INSERT INTO public.who_global_data VALUES (67296, 1031, 11380, 13, 89, 284, 194);
INSERT INTO public.who_global_data VALUES (67297, 0, 300, 0, 10, 284, 144);
INSERT INTO public.who_global_data VALUES (67298, 29218, 960916, 1109, 54398, 284, 19);
INSERT INTO public.who_global_data VALUES (67299, 4, 59, 1, 4, 284, 217);
INSERT INTO public.who_global_data VALUES (67300, 10, 606, 1, 15, 284, 148);
INSERT INTO public.who_global_data VALUES (67301, 37, 1924, 0, 8, 284, 86);
INSERT INTO public.who_global_data VALUES (67302, 0, 0, 0, 0, 284, 13);
INSERT INTO public.who_global_data VALUES (67303, 2, 325, 0, 10, 284, 157);
INSERT INTO public.who_global_data VALUES (67304, 0, 270, 0, 0, 284, 8);
INSERT INTO public.who_global_data VALUES (67305, 0, 0, 0, 0, 284, 73);
INSERT INTO public.who_global_data VALUES (67306, 0, 1, 0, 0, 284, 101);
INSERT INTO public.who_global_data VALUES (67307, 1, 89, 0, 3, 284, 165);
INSERT INTO public.who_global_data VALUES (67308, 0, 31, 0, 4, 284, 14);
INSERT INTO public.who_global_data VALUES (67309, 240, 1703, 8, 57, 285, 193);
INSERT INTO public.who_global_data VALUES (67310, 14, 688, 1, 27, 285, 113);
INSERT INTO public.who_global_data VALUES (67311, 126, 3382, 6, 425, 285, 143);
INSERT INTO public.who_global_data VALUES (67312, 0, 0, 0, 0, 285, 219);
INSERT INTO public.who_global_data VALUES (67313, 2, 740, 0, 40, 285, 186);
INSERT INTO public.who_global_data VALUES (67314, 1, 26, 0, 2, 285, 52);
INSERT INTO public.who_global_data VALUES (67315, 0, 3, 0, 0, 285, 180);
INSERT INTO public.who_global_data VALUES (67316, 0, 24, 0, 3, 285, 167);
INSERT INTO public.who_global_data VALUES (67317, 137, 3838, 0, 179, 285, 154);
INSERT INTO public.who_global_data VALUES (67318, 69, 1722, 0, 28, 285, 94);
INSERT INTO public.who_global_data VALUES (67319, 0, 100, 0, 2, 285, 66);
INSERT INTO public.who_global_data VALUES (67320, 10, 6713, 2, 83, 285, 58);
INSERT INTO public.who_global_data VALUES (67321, 55, 15189, 6, 542, 285, 163);
INSERT INTO public.who_global_data VALUES (67322, 28, 1645, 0, 21, 285, 37);
INSERT INTO public.who_global_data VALUES (67323, 6, 78, 0, 11, 285, 142);
INSERT INTO public.who_global_data VALUES (67324, 75, 2708, 0, 8, 285, 83);
INSERT INTO public.who_global_data VALUES (67325, 497, 5913, 7, 152, 285, 228);
INSERT INTO public.who_global_data VALUES (67326, 2, 79, 0, 6, 285, 188);
INSERT INTO public.who_global_data VALUES (67327, 873, 10463, 5, 72, 285, 62);
INSERT INTO public.who_global_data VALUES (67328, 205, 48193, 153, 7427, 285, 160);
INSERT INTO public.who_global_data VALUES (67329, 0, 18, 0, 2, 285, 50);
INSERT INTO public.who_global_data VALUES (67330, 6, 64, 0, 1, 285, 33);
INSERT INTO public.who_global_data VALUES (67331, 10, 109, 0, 5, 285, 183);
INSERT INTO public.who_global_data VALUES (67332, 0, 7, 0, 0, 285, 92);
INSERT INTO public.who_global_data VALUES (67333, 59, 866, 2, 46, 285, 158);
INSERT INTO public.who_global_data VALUES (67334, 0, 1, 0, 0, 285, 67);
INSERT INTO public.who_global_data VALUES (67335, 31, 1516, 2, 58, 285, 57);
INSERT INTO public.who_global_data VALUES (67336, 0, 22, 0, 1, 285, 38);
INSERT INTO public.who_global_data VALUES (67337, 5514, 58509, 346, 4016, 285, 141);
INSERT INTO public.who_global_data VALUES (67338, 0, 6, 0, 1, 285, 178);
INSERT INTO public.who_global_data VALUES (67339, 0, 138, 0, 1, 285, 108);
INSERT INTO public.who_global_data VALUES (67340, 53, 1300, 1, 56, 285, 39);
INSERT INTO public.who_global_data VALUES (67341, 3, 632, 1, 42, 285, 2);
INSERT INTO public.who_global_data VALUES (67342, 3, 15, 0, 1, 285, 195);
INSERT INTO public.who_global_data VALUES (67343, 16, 106, 0, 1, 285, 107);
INSERT INTO public.who_global_data VALUES (67344, 0, 122, 0, 0, 285, 161);
INSERT INTO public.who_global_data VALUES (67345, 103, 1621, 3, 56, 285, 212);
INSERT INTO public.who_global_data VALUES (67346, 1425, 45778, 139, 2489, 285, 181);
INSERT INTO public.who_global_data VALUES (67347, 0, 70, 0, 1, 285, 53);
INSERT INTO public.who_global_data VALUES (67348, 0, 19, 0, 0, 285, 164);
INSERT INTO public.who_global_data VALUES (67349, 0, 46, 0, 0, 285, 140);
INSERT INTO public.who_global_data VALUES (67350, 473, 13331, 8, 189, 285, 20);
INSERT INTO public.who_global_data VALUES (67351, 3, 84341, 1, 4643, 285, 112);
INSERT INTO public.who_global_data VALUES (67352, 261, 5142, 8, 233, 285, 111);
INSERT INTO public.who_global_data VALUES (67353, 0, 0, 0, 0, 285, 71);
INSERT INTO public.who_global_data VALUES (67354, 0, 200, 0, 8, 285, 218);
INSERT INTO public.who_global_data VALUES (67355, 0, 0, 0, 0, 285, 43);
INSERT INTO public.who_global_data VALUES (67356, 6, 693, 0, 6, 285, 49);
INSERT INTO public.who_global_data VALUES (67357, 39, 1150, 0, 14, 285, 1);
INSERT INTO public.who_global_data VALUES (67358, 14, 2030, 1, 55, 285, 48);
INSERT INTO public.who_global_data VALUES (67359, 32, 1369, 3, 54, 285, 232);
INSERT INTO public.who_global_data VALUES (67360, 0, 14, 0, 1, 285, 175);
INSERT INTO public.who_global_data VALUES (67361, 7, 817, 0, 14, 285, 21);
INSERT INTO public.who_global_data VALUES (67362, 52, 7404, 3, 221, 285, 156);
INSERT INTO public.who_global_data VALUES (67363, 0, 0, 0, 0, 285, 95);
INSERT INTO public.who_global_data VALUES (67364, 17, 459, 0, 28, 285, 177);
INSERT INTO public.who_global_data VALUES (67365, 130, 8575, 4, 422, 285, 210);
INSERT INTO public.who_global_data VALUES (67366, 12, 1035, 0, 2, 285, 120);
INSERT INTO public.who_global_data VALUES (67367, 0, 16, 0, 0, 285, 135);
INSERT INTO public.who_global_data VALUES (67368, 209, 6135, 5, 278, 285, 206);
INSERT INTO public.who_global_data VALUES (67369, 0, 22719, 0, 576, 285, 189);
INSERT INTO public.who_global_data VALUES (67370, 463, 4782, 30, 337, 285, 129);
INSERT INTO public.who_global_data VALUES (67371, 24, 298, 0, 8, 285, 121);
INSERT INTO public.who_global_data VALUES (67372, 0, 258, 0, 1, 285, 59);
INSERT INTO public.who_global_data VALUES (67373, 0, 39, 0, 0, 285, 96);
INSERT INTO public.who_global_data VALUES (67374, 8, 1643, 3, 49, 285, 41);
INSERT INTO public.who_global_data VALUES (67375, 3, 59, 0, 1, 285, 216);
INSERT INTO public.who_global_data VALUES (67376, 1, 123, 0, 3, 285, 236);
INSERT INTO public.who_global_data VALUES (67377, 0, 13, 0, 0, 285, 150);
INSERT INTO public.who_global_data VALUES (67378, 0, 187, 0, 0, 285, 61);
INSERT INTO public.who_global_data VALUES (67379, 0, 18, 0, 0, 285, 7);
INSERT INTO public.who_global_data VALUES (67380, 101, 4576, 4, 190, 285, 169);
INSERT INTO public.who_global_data VALUES (67381, 404, 123280, 242, 22824, 285, 28);
INSERT INTO public.who_global_data VALUES (67382, 0, 109, 0, 1, 285, 85);
INSERT INTO public.who_global_data VALUES (67383, 0, 57, 0, 0, 285, 211);
INSERT INTO public.who_global_data VALUES (67384, 0, 176, 0, 3, 285, 60);
INSERT INTO public.who_global_data VALUES (67385, 0, 10, 0, 1, 285, 3);
INSERT INTO public.who_global_data VALUES (67386, 11, 496, 1, 6, 285, 11);
INSERT INTO public.who_global_data VALUES (67387, 1018, 155193, 110, 5750, 285, 89);
INSERT INTO public.who_global_data VALUES (67388, 271, 1550, 1, 11, 285, 24);
INSERT INTO public.who_global_data VALUES (67389, 5, 141, 0, 0, 285, 162);
INSERT INTO public.who_global_data VALUES (67390, 0, 2506, 0, 130, 285, 100);
INSERT INTO public.who_global_data VALUES (67391, 0, 11, 0, 0, 285, 47);
INSERT INTO public.who_global_data VALUES (67392, 3, 18, 0, 0, 285, 29);
INSERT INTO public.who_global_data VALUES (67393, 0, 149, 0, 10, 285, 40);
INSERT INTO public.who_global_data VALUES (67394, 1, 138, 0, 5, 285, 222);
INSERT INTO public.who_global_data VALUES (67395, 43, 473, 2, 15, 285, 132);
INSERT INTO public.who_global_data VALUES (67396, 0, 245, 1, 12, 285, 130);
INSERT INTO public.who_global_data VALUES (67397, 98, 1094, 0, 7, 285, 234);
INSERT INTO public.who_global_data VALUES (67398, 1, 53, 1, 1, 285, 23);
INSERT INTO public.who_global_data VALUES (67399, 1, 74, 1, 8, 285, 192);
INSERT INTO public.who_global_data VALUES (67400, 0, 72, 0, 6, 285, 69);
INSERT INTO public.who_global_data VALUES (67401, 0, 9, 0, 0, 285, 187);
INSERT INTO public.who_global_data VALUES (67402, 36, 627, 4, 59, 285, 230);
INSERT INTO public.who_global_data VALUES (67403, 83, 2583, 8, 280, 285, 77);
INSERT INTO public.who_global_data VALUES (67404, 2, 1792, 0, 10, 285, 9);
INSERT INTO public.who_global_data VALUES (67405, 1396, 27892, 48, 872, 285, 74);
INSERT INTO public.who_global_data VALUES (67406, 214, 9096, 22, 765, 285, 224);
INSERT INTO public.who_global_data VALUES (67407, 991, 91472, 96, 5806, 285, 199);
INSERT INTO public.who_global_data VALUES (67408, 57, 1820, 1, 87, 285, 190);
INSERT INTO public.who_global_data VALUES (67409, 701, 19262, 24, 1087, 285, 12);
INSERT INTO public.who_global_data VALUES (67410, 0, 308, 0, 18, 285, 104);
INSERT INTO public.who_global_data VALUES (67411, 159, 15308, 3, 202, 285, 153);
INSERT INTO public.who_global_data VALUES (67412, 2324, 197675, 260, 26644, 285, 91);
INSERT INTO public.who_global_data VALUES (67413, 17, 305, 0, 7, 285, 215);
INSERT INTO public.who_global_data VALUES (67414, 203, 13385, 3, 351, 285, 84);
INSERT INTO public.who_global_data VALUES (67415, 2, 280, 0, 19, 285, 231);
INSERT INTO public.who_global_data VALUES (67416, 2, 449, 0, 7, 285, 196);
INSERT INTO public.who_global_data VALUES (67417, 191, 2982, 0, 25, 285, 105);
INSERT INTO public.who_global_data VALUES (67418, 12, 355, 0, 14, 285, 122);
INSERT INTO public.who_global_data VALUES (67419, 0, 0, 0, 0, 285, 159);
INSERT INTO public.who_global_data VALUES (67420, 32, 763, 1, 17, 285, 75);
INSERT INTO public.who_global_data VALUES (67421, 213, 3288, 2, 22, 285, 27);
INSERT INTO public.who_global_data VALUES (67422, 13, 695, 0, 8, 285, 54);
INSERT INTO public.who_global_data VALUES (67423, 0, 19, 0, 0, 285, 226);
INSERT INTO public.who_global_data VALUES (67424, 8, 812, 0, 12, 285, 79);
INSERT INTO public.who_global_data VALUES (67425, 3, 710, 0, 24, 285, 56);
INSERT INTO public.who_global_data VALUES (67426, 0, 0, 0, 0, 285, 117);
INSERT INTO public.who_global_data VALUES (67427, 4, 124, 1, 12, 285, 152);
INSERT INTO public.who_global_data VALUES (67428, 0, 61, 0, 2, 285, 16);
INSERT INTO public.who_global_data VALUES (67429, 0, 83, 0, 1, 285, 10);
INSERT INTO public.who_global_data VALUES (67430, 12, 1328, 1, 44, 285, 201);
INSERT INTO public.who_global_data VALUES (67431, 12, 3723, 3, 88, 285, 174);
INSERT INTO public.who_global_data VALUES (67432, 4, 128, 0, 0, 285, 119);
INSERT INTO public.who_global_data VALUES (67433, 1, 34, 0, 3, 285, 168);
INSERT INTO public.who_global_data VALUES (67434, 38, 5780, 0, 98, 285, 99);
INSERT INTO public.who_global_data VALUES (67435, 26, 214, 0, 0, 285, 171);
INSERT INTO public.who_global_data VALUES (67436, 19, 389, 2, 23, 285, 87);
INSERT INTO public.who_global_data VALUES (67437, 0, 449, 0, 4, 285, 123);
INSERT INTO public.who_global_data VALUES (67438, 0, 0, 0, 0, 285, 151);
INSERT INTO public.who_global_data VALUES (67439, 5, 175, 0, 14, 285, 213);
INSERT INTO public.who_global_data VALUES (67440, 0, 7, 0, 1, 285, 118);
INSERT INTO public.who_global_data VALUES (67441, 1, 332, 0, 9, 285, 134);
INSERT INTO public.who_global_data VALUES (67442, 47, 401, 0, 4, 285, 65);
INSERT INTO public.who_global_data VALUES (67443, 970, 13842, 84, 1305, 285, 102);
INSERT INTO public.who_global_data VALUES (67444, 0, 0, 0, 0, 285, 223);
INSERT INTO public.who_global_data VALUES (67445, 0, 65, 0, 1, 285, 4);
INSERT INTO public.who_global_data VALUES (67446, 1, 38, 0, 0, 285, 146);
INSERT INTO public.who_global_data VALUES (67447, 0, 321, 0, 7, 285, 31);
INSERT INTO public.who_global_data VALUES (67448, 0, 11, 0, 1, 285, 127);
INSERT INTO public.who_global_data VALUES (67449, 68, 4115, 1, 161, 285, 22);
INSERT INTO public.who_global_data VALUES (67450, 6, 76, 0, 0, 285, 115);
INSERT INTO public.who_global_data VALUES (67451, 0, 146, 0, 5, 285, 106);
INSERT INTO public.who_global_data VALUES (67452, 0, 16, 0, 0, 285, 90);
INSERT INTO public.who_global_data VALUES (67453, 0, 0, 0, 0, 285, 70);
INSERT INTO public.who_global_data VALUES (67454, 1, 52, 0, 0, 285, 46);
INSERT INTO public.who_global_data VALUES (67455, 651, 37574, 64, 4438, 285, 139);
INSERT INTO public.who_global_data VALUES (67456, 0, 18, 0, 0, 285, 42);
INSERT INTO public.who_global_data VALUES (67457, 1, 1122, 1, 19, 285, 80);
INSERT INTO public.who_global_data VALUES (67458, 2, 13, 0, 3, 285, 203);
INSERT INTO public.who_global_data VALUES (67459, 12, 696, 2, 29, 285, 136);
INSERT INTO public.who_global_data VALUES (67460, 91, 1273, 5, 40, 285, 63);
INSERT INTO public.who_global_data VALUES (67461, 0, 0, 0, 0, 285, 17);
INSERT INTO public.who_global_data VALUES (67462, 0, 14, 0, 2, 285, 172);
INSERT INTO public.who_global_data VALUES (67463, 19, 1386, 2, 61, 285, 109);
INSERT INTO public.who_global_data VALUES (67464, 38, 7505, 0, 193, 285, 200);
INSERT INTO public.who_global_data VALUES (67465, 0, 342, 0, 2, 285, 93);
INSERT INTO public.who_global_data VALUES (67466, 51, 2049, 0, 10, 285, 5);
INSERT INTO public.who_global_data VALUES (67467, 0, 712, 0, 13, 285, 214);
INSERT INTO public.who_global_data VALUES (67468, 718, 13915, 15, 292, 285, 204);
INSERT INTO public.who_global_data VALUES (67469, 0, 0, 0, 0, 285, 198);
INSERT INTO public.who_global_data VALUES (67470, 200, 5538, 5, 159, 285, 173);
INSERT INTO public.who_global_data VALUES (67471, 0, 8, 0, 0, 285, 229);
INSERT INTO public.who_global_data VALUES (67472, 5, 228, 0, 9, 285, 76);
INSERT INTO public.who_global_data VALUES (67473, 3683, 25331, 66, 700, 285, 138);
INSERT INTO public.who_global_data VALUES (67474, 285, 7579, 7, 501, 285, 98);
INSERT INTO public.who_global_data VALUES (67475, 0, 0, 0, 0, 285, 103);
INSERT INTO public.who_global_data VALUES (67476, 344, 11617, 11, 535, 285, 225);
INSERT INTO public.who_global_data VALUES (67477, 163, 23846, 25, 928, 285, 131);
INSERT INTO public.who_global_data VALUES (67478, 95, 1371, 0, 53, 285, 235);
INSERT INTO public.who_global_data VALUES (67479, 957, 11244, 0, 10, 285, 137);
INSERT INTO public.who_global_data VALUES (67480, 10, 10738, 1, 243, 285, 81);
INSERT INTO public.who_global_data VALUES (67481, 104, 3408, 2, 96, 285, 182);
INSERT INTO public.who_global_data VALUES (67482, 5, 416, 0, 0, 285, 145);
INSERT INTO public.who_global_data VALUES (67483, 401, 11036, 33, 608, 285, 26);
INSERT INTO public.who_global_data VALUES (67484, 6198, 87147, 47, 794, 285, 170);
INSERT INTO public.who_global_data VALUES (67485, 8, 191, 0, 0, 285, 191);
INSERT INTO public.who_global_data VALUES (67486, 0, 2, 0, 0, 285, 221);
INSERT INTO public.who_global_data VALUES (67487, 0, 6, 0, 0, 285, 64);
INSERT INTO public.who_global_data VALUES (67488, 0, 0, 0, 0, 285, 116);
INSERT INTO public.who_global_data VALUES (67489, 0, 15, 0, 0, 285, 128);
INSERT INTO public.who_global_data VALUES (67490, 0, 15, 0, 0, 285, 6);
INSERT INTO public.who_global_data VALUES (67491, 0, 38, 0, 3, 285, 227);
INSERT INTO public.who_global_data VALUES (67492, 0, 1, 0, 0, 285, 68);
INSERT INTO public.who_global_data VALUES (67493, 0, 14, 0, 0, 285, 184);
INSERT INTO public.who_global_data VALUES (67494, 0, 0, 0, 0, 285, 82);
INSERT INTO public.who_global_data VALUES (67495, 25, 538, 1, 41, 285, 149);
INSERT INTO public.who_global_data VALUES (67496, 0, 8, 0, 0, 285, 197);
INSERT INTO public.who_global_data VALUES (67497, 1289, 18811, 5, 144, 285, 78);
INSERT INTO public.who_global_data VALUES (67498, 57, 671, 2, 9, 285, 233);
INSERT INTO public.who_global_data VALUES (67499, 263, 8042, 5, 156, 285, 133);
INSERT INTO public.who_global_data VALUES (67500, 0, 11, 0, 0, 285, 35);
INSERT INTO public.who_global_data VALUES (67501, 7, 93, 1, 4, 285, 114);
INSERT INTO public.who_global_data VALUES (67502, 931, 13624, 0, 12, 285, 237);
INSERT INTO public.who_global_data VALUES (67503, 0, 2, 0, 0, 285, 55);
INSERT INTO public.who_global_data VALUES (67504, 1, 74, 1, 13, 285, 176);
INSERT INTO public.who_global_data VALUES (67505, 6, 1379, 1, 18, 285, 202);
INSERT INTO public.who_global_data VALUES (67506, 6, 1403, 0, 90, 285, 155);
INSERT INTO public.who_global_data VALUES (67507, 0, 0, 0, 0, 285, 32);
INSERT INTO public.who_global_data VALUES (67508, 44, 480, 3, 26, 285, 220);
INSERT INTO public.who_global_data VALUES (67509, 185, 4546, 1, 87, 285, 30);
INSERT INTO public.who_global_data VALUES (67510, 1, 6, 0, 0, 285, 147);
INSERT INTO public.who_global_data VALUES (67511, 1296, 218834, 295, 24875, 285, 208);
INSERT INTO public.who_global_data VALUES (67512, 63, 523, 0, 7, 285, 45);
INSERT INTO public.who_global_data VALUES (67513, 38, 275, 1, 22, 285, 110);
INSERT INTO public.who_global_data VALUES (67514, 0, 10, 0, 1, 285, 88);
INSERT INTO public.who_global_data VALUES (67515, 473, 18564, 73, 2522, 285, 51);
INSERT INTO public.who_global_data VALUES (67516, 61, 29230, 13, 1537, 285, 209);
INSERT INTO public.who_global_data VALUES (67517, 1, 43, 0, 3, 285, 205);
INSERT INTO public.who_global_data VALUES (67518, 0, 0, 0, 0, 285, 18);
INSERT INTO public.who_global_data VALUES (67519, 9, 2931, 1, 52, 285, 72);
INSERT INTO public.who_global_data VALUES (67520, 3748, 154242, 364, 23991, 285, 44);
INSERT INTO public.who_global_data VALUES (67521, 0, 24, 0, 0, 285, 15);
INSERT INTO public.who_global_data VALUES (67522, 2, 98, 0, 6, 285, 25);
INSERT INTO public.who_global_data VALUES (67523, 0, 0, 0, 0, 285, 179);
INSERT INTO public.who_global_data VALUES (67524, 0, 0, 0, 0, 285, 34);
INSERT INTO public.who_global_data VALUES (67525, 0, 115, 0, 8, 285, 207);
INSERT INTO public.who_global_data VALUES (67526, 10, 949, 0, 38, 285, 166);
INSERT INTO public.who_global_data VALUES (67527, 2357, 110130, 99, 2805, 285, 126);
INSERT INTO public.who_global_data VALUES (67528, 0, 0, 0, 0, 285, 97);
INSERT INTO public.who_global_data VALUES (67529, 0, 11, 0, 1, 285, 36);
INSERT INTO public.who_global_data VALUES (67530, 0, 0, 0, 0, 285, 125);
INSERT INTO public.who_global_data VALUES (67531, 0, 75, 0, 0, 285, 124);
INSERT INTO public.who_global_data VALUES (67532, 392, 9009, 11, 220, 285, 185);
INSERT INTO public.who_global_data VALUES (67533, 0, 10349, 0, 76, 285, 194);
INSERT INTO public.who_global_data VALUES (67534, 0, 300, 0, 10, 285, 144);
INSERT INTO public.who_global_data VALUES (67535, 32417, 931698, 1964, 53289, 285, 19);
INSERT INTO public.who_global_data VALUES (67536, 0, 55, 0, 3, 285, 217);
INSERT INTO public.who_global_data VALUES (67537, 33, 596, 2, 14, 285, 148);
INSERT INTO public.who_global_data VALUES (67538, 22, 1887, 0, 8, 285, 86);
INSERT INTO public.who_global_data VALUES (67539, 0, 0, 0, 0, 285, 13);
INSERT INTO public.who_global_data VALUES (67540, 5, 323, 0, 10, 285, 157);
INSERT INTO public.who_global_data VALUES (67541, 0, 270, 0, 0, 285, 8);
INSERT INTO public.who_global_data VALUES (67542, 0, 0, 0, 0, 285, 73);
INSERT INTO public.who_global_data VALUES (67543, 0, 1, 0, 0, 285, 101);
INSERT INTO public.who_global_data VALUES (67544, 4, 88, 0, 3, 285, 165);
INSERT INTO public.who_global_data VALUES (67545, 0, 31, 0, 4, 285, 14);
INSERT INTO public.who_global_data VALUES (67546, 0, 1463, 2, 49, 286, 193);
INSERT INTO public.who_global_data VALUES (67547, 34, 674, 0, 26, 286, 113);
INSERT INTO public.who_global_data VALUES (67548, 129, 3256, 4, 419, 286, 143);
INSERT INTO public.who_global_data VALUES (67549, 0, 0, 0, 0, 286, 219);
INSERT INTO public.who_global_data VALUES (67550, 5, 738, 0, 40, 286, 186);
INSERT INTO public.who_global_data VALUES (67551, 0, 25, 0, 2, 286, 52);
INSERT INTO public.who_global_data VALUES (67552, 0, 3, 0, 0, 286, 180);
INSERT INTO public.who_global_data VALUES (67553, 0, 24, 0, 3, 286, 167);
INSERT INTO public.who_global_data VALUES (67554, 222, 3701, 12, 179, 286, 154);
INSERT INTO public.who_global_data VALUES (67555, 81, 1653, 1, 28, 286, 94);
INSERT INTO public.who_global_data VALUES (67556, 0, 100, 0, 2, 286, 66);
INSERT INTO public.who_global_data VALUES (67557, 16, 6703, 2, 81, 286, 58);
INSERT INTO public.who_global_data VALUES (67558, 66, 15134, 23, 536, 286, 163);
INSERT INTO public.who_global_data VALUES (67559, 25, 1617, 0, 21, 286, 37);
INSERT INTO public.who_global_data VALUES (67560, 0, 72, 0, 11, 286, 142);
INSERT INTO public.who_global_data VALUES (67561, 45, 2633, 0, 8, 286, 83);
INSERT INTO public.who_global_data VALUES (67562, 418, 5416, 5, 145, 286, 228);
INSERT INTO public.who_global_data VALUES (67563, 1, 77, 0, 6, 286, 188);
INSERT INTO public.who_global_data VALUES (67564, 817, 9590, 4, 67, 286, 62);
INSERT INTO public.who_global_data VALUES (67565, 388, 47988, 142, 7274, 286, 160);
INSERT INTO public.who_global_data VALUES (67566, 0, 18, 0, 2, 286, 50);
INSERT INTO public.who_global_data VALUES (67567, 0, 58, 0, 1, 286, 33);
INSERT INTO public.who_global_data VALUES (67568, 0, 99, 0, 5, 286, 183);
INSERT INTO public.who_global_data VALUES (67569, 0, 7, 0, 0, 286, 92);
INSERT INTO public.who_global_data VALUES (67570, 104, 807, 1, 44, 286, 158);
INSERT INTO public.who_global_data VALUES (67571, 0, 1, 0, 0, 286, 67);
INSERT INTO public.who_global_data VALUES (67572, 57, 1485, 2, 56, 286, 57);
INSERT INTO public.who_global_data VALUES (67573, 0, 22, 0, 1, 286, 38);
INSERT INTO public.who_global_data VALUES (67574, 3503, 52995, 357, 3670, 286, 141);
INSERT INTO public.who_global_data VALUES (67575, 1, 6, 0, 1, 286, 178);
INSERT INTO public.who_global_data VALUES (67576, 0, 138, 0, 1, 286, 108);
INSERT INTO public.who_global_data VALUES (67577, 59, 1247, 1, 55, 286, 39);
INSERT INTO public.who_global_data VALUES (67578, 13, 629, 0, 41, 286, 2);
INSERT INTO public.who_global_data VALUES (67579, 0, 12, 0, 1, 286, 195);
INSERT INTO public.who_global_data VALUES (67580, 2, 90, 0, 1, 286, 107);
INSERT INTO public.who_global_data VALUES (67581, 0, 122, 0, 0, 286, 161);
INSERT INTO public.who_global_data VALUES (67582, 115, 1518, 4, 53, 286, 212);
INSERT INTO public.who_global_data VALUES (67583, 1614, 44353, 153, 2350, 286, 181);
INSERT INTO public.who_global_data VALUES (67584, 4, 70, 0, 1, 286, 53);
INSERT INTO public.who_global_data VALUES (67585, 0, 19, 0, 0, 286, 164);
INSERT INTO public.who_global_data VALUES (67586, 6, 46, 0, 0, 286, 140);
INSERT INTO public.who_global_data VALUES (67587, 552, 12858, 7, 181, 286, 20);
INSERT INTO public.who_global_data VALUES (67588, 14, 84338, 0, 4642, 286, 112);
INSERT INTO public.who_global_data VALUES (67589, 320, 4881, 10, 225, 286, 111);
INSERT INTO public.who_global_data VALUES (67590, 0, 0, 0, 0, 286, 71);
INSERT INTO public.who_global_data VALUES (67591, 0, 200, 2, 8, 286, 218);
INSERT INTO public.who_global_data VALUES (67592, 0, 0, 0, 0, 286, 43);
INSERT INTO public.who_global_data VALUES (67593, 1, 687, 0, 6, 286, 49);
INSERT INTO public.who_global_data VALUES (67594, 34, 1111, 0, 14, 286, 1);
INSERT INTO public.who_global_data VALUES (67595, 7, 2016, 3, 54, 286, 48);
INSERT INTO public.who_global_data VALUES (67596, 52, 1337, 2, 51, 286, 232);
INSERT INTO public.who_global_data VALUES (67597, 0, 14, 0, 1, 286, 175);
INSERT INTO public.who_global_data VALUES (67598, 6, 810, 0, 14, 286, 21);
INSERT INTO public.who_global_data VALUES (67599, 79, 7352, 3, 218, 286, 156);
INSERT INTO public.who_global_data VALUES (67600, 0, 0, 0, 0, 286, 95);
INSERT INTO public.who_global_data VALUES (67601, 26, 442, 0, 28, 286, 177);
INSERT INTO public.who_global_data VALUES (67602, 235, 8445, 15, 418, 286, 210);
INSERT INTO public.who_global_data VALUES (67603, 15, 1023, 0, 2, 286, 120);
INSERT INTO public.who_global_data VALUES (67604, 0, 16, 0, 0, 286, 135);
INSERT INTO public.who_global_data VALUES (67605, 177, 5926, 6, 273, 286, 206);
INSERT INTO public.who_global_data VALUES (67606, 0, 22719, 0, 576, 286, 189);
INSERT INTO public.who_global_data VALUES (67607, 227, 4319, 13, 307, 286, 129);
INSERT INTO public.who_global_data VALUES (67608, 13, 274, 0, 8, 286, 121);
INSERT INTO public.who_global_data VALUES (67609, 46, 258, 0, 1, 286, 59);
INSERT INTO public.who_global_data VALUES (67610, 0, 39, 0, 0, 286, 96);
INSERT INTO public.who_global_data VALUES (67611, 30, 1635, 0, 46, 286, 41);
INSERT INTO public.who_global_data VALUES (67612, 16, 56, 0, 1, 286, 216);
INSERT INTO public.who_global_data VALUES (67613, 5, 122, 0, 3, 286, 236);
INSERT INTO public.who_global_data VALUES (67614, 1, 13, 0, 0, 286, 150);
INSERT INTO public.who_global_data VALUES (67615, 0, 187, 0, 0, 286, 61);
INSERT INTO public.who_global_data VALUES (67616, 0, 18, 0, 0, 286, 7);
INSERT INTO public.who_global_data VALUES (67617, 80, 4475, 9, 186, 286, 169);
INSERT INTO public.who_global_data VALUES (67618, 1537, 122876, 368, 22582, 286, 28);
INSERT INTO public.who_global_data VALUES (67619, 0, 109, 0, 1, 286, 85);
INSERT INTO public.who_global_data VALUES (67620, 0, 57, 0, 0, 286, 211);
INSERT INTO public.who_global_data VALUES (67621, 4, 176, 0, 3, 286, 60);
INSERT INTO public.who_global_data VALUES (67622, 0, 10, 0, 1, 286, 3);
INSERT INTO public.who_global_data VALUES (67623, 29, 485, 0, 5, 286, 11);
INSERT INTO public.who_global_data VALUES (67624, 1737, 154175, 140, 5640, 286, 89);
INSERT INTO public.who_global_data VALUES (67625, 0, 1279, 0, 10, 286, 24);
INSERT INTO public.who_global_data VALUES (67626, 3, 136, 0, 0, 286, 162);
INSERT INTO public.who_global_data VALUES (67627, 16, 2506, 0, 130, 286, 100);
INSERT INTO public.who_global_data VALUES (67628, 0, 11, 0, 0, 286, 47);
INSERT INTO public.who_global_data VALUES (67629, 0, 15, 0, 0, 286, 29);
INSERT INTO public.who_global_data VALUES (67630, 0, 149, 0, 10, 286, 40);
INSERT INTO public.who_global_data VALUES (67631, 1, 137, 0, 5, 286, 222);
INSERT INTO public.who_global_data VALUES (67632, 46, 430, 2, 13, 286, 132);
INSERT INTO public.who_global_data VALUES (67633, 0, 245, 1, 11, 286, 130);
INSERT INTO public.who_global_data VALUES (67634, 42, 996, 1, 7, 286, 234);
INSERT INTO public.who_global_data VALUES (67635, 0, 52, 0, 0, 286, 23);
INSERT INTO public.who_global_data VALUES (67636, 3, 73, 0, 7, 286, 192);
INSERT INTO public.who_global_data VALUES (67637, 0, 72, 1, 6, 286, 69);
INSERT INTO public.who_global_data VALUES (67638, 0, 9, 0, 0, 286, 187);
INSERT INTO public.who_global_data VALUES (67639, 29, 591, 8, 55, 286, 230);
INSERT INTO public.who_global_data VALUES (67640, 57, 2500, 10, 272, 286, 77);
INSERT INTO public.who_global_data VALUES (67641, 1, 1790, 0, 10, 286, 9);
INSERT INTO public.who_global_data VALUES (67642, 1990, 26496, 49, 824, 286, 74);
INSERT INTO public.who_global_data VALUES (67643, 275, 8882, 23, 743, 286, 224);
INSERT INTO public.who_global_data VALUES (67644, 1153, 90481, 60, 5710, 286, 199);
INSERT INTO public.who_global_data VALUES (67645, 55, 1763, 0, 86, 286, 190);
INSERT INTO public.who_global_data VALUES (67646, 377, 18561, 234, 1063, 286, 12);
INSERT INTO public.who_global_data VALUES (67647, 0, 308, 1, 18, 286, 104);
INSERT INTO public.who_global_data VALUES (67648, 248, 15149, 3, 199, 286, 153);
INSERT INTO public.who_global_data VALUES (67649, 2357, 195351, 415, 26384, 286, 91);
INSERT INTO public.who_global_data VALUES (67650, 31, 288, 0, 7, 286, 215);
INSERT INTO public.who_global_data VALUES (67651, 353, 13182, 14, 348, 286, 84);
INSERT INTO public.who_global_data VALUES (67652, 2, 278, 0, 19, 286, 231);
INSERT INTO public.who_global_data VALUES (67653, 3, 447, 0, 7, 286, 196);
INSERT INTO public.who_global_data VALUES (67654, 190, 2791, 0, 25, 286, 105);
INSERT INTO public.who_global_data VALUES (67655, 7, 343, 0, 14, 286, 122);
INSERT INTO public.who_global_data VALUES (67656, 0, 0, 0, 0, 286, 159);
INSERT INTO public.who_global_data VALUES (67657, 28, 731, 0, 16, 286, 75);
INSERT INTO public.who_global_data VALUES (67658, 183, 3075, 1, 20, 286, 27);
INSERT INTO public.who_global_data VALUES (67659, 17, 682, 0, 8, 286, 54);
INSERT INTO public.who_global_data VALUES (67660, 0, 19, 0, 0, 286, 226);
INSERT INTO public.who_global_data VALUES (67661, 20, 804, 0, 12, 286, 79);
INSERT INTO public.who_global_data VALUES (67662, 3, 707, 0, 24, 286, 56);
INSERT INTO public.who_global_data VALUES (67663, 0, 0, 0, 0, 286, 117);
INSERT INTO public.who_global_data VALUES (67664, 3, 120, 3, 11, 286, 152);
INSERT INTO public.who_global_data VALUES (67665, 0, 61, 0, 2, 286, 16);
INSERT INTO public.who_global_data VALUES (67666, 0, 83, 0, 1, 286, 10);
INSERT INTO public.who_global_data VALUES (67667, 15, 1316, 2, 43, 286, 201);
INSERT INTO public.who_global_data VALUES (67668, 16, 3711, 0, 85, 286, 174);
INSERT INTO public.who_global_data VALUES (67669, 2, 124, 0, 0, 286, 119);
INSERT INTO public.who_global_data VALUES (67670, 0, 33, 0, 3, 286, 168);
INSERT INTO public.who_global_data VALUES (67671, 51, 5742, 2, 98, 286, 99);
INSERT INTO public.who_global_data VALUES (67672, 51, 188, 0, 0, 286, 171);
INSERT INTO public.who_global_data VALUES (67673, 45, 370, 0, 21, 286, 87);
INSERT INTO public.who_global_data VALUES (67674, 2, 449, 1, 4, 286, 123);
INSERT INTO public.who_global_data VALUES (67675, 0, 0, 0, 0, 286, 151);
INSERT INTO public.who_global_data VALUES (67676, 0, 170, 0, 14, 286, 213);
INSERT INTO public.who_global_data VALUES (67677, 0, 7, 0, 1, 286, 118);
INSERT INTO public.who_global_data VALUES (67678, 0, 331, 0, 9, 286, 134);
INSERT INTO public.who_global_data VALUES (67679, 0, 354, 0, 4, 286, 65);
INSERT INTO public.who_global_data VALUES (67680, 1239, 12872, 152, 1221, 286, 102);
INSERT INTO public.who_global_data VALUES (67681, 0, 0, 0, 0, 286, 223);
INSERT INTO public.who_global_data VALUES (67682, 0, 65, 0, 1, 286, 4);
INSERT INTO public.who_global_data VALUES (67683, 1, 37, 0, 0, 286, 146);
INSERT INTO public.who_global_data VALUES (67684, 0, 321, 1, 7, 286, 31);
INSERT INTO public.who_global_data VALUES (67685, 0, 11, 1, 1, 286, 127);
INSERT INTO public.who_global_data VALUES (67686, 158, 4047, 1, 160, 286, 22);
INSERT INTO public.who_global_data VALUES (67687, 5, 70, 0, 0, 286, 115);
INSERT INTO public.who_global_data VALUES (67688, 2, 146, 0, 5, 286, 106);
INSERT INTO public.who_global_data VALUES (67689, 0, 16, 0, 0, 286, 90);
INSERT INTO public.who_global_data VALUES (67690, 0, 0, 0, 0, 286, 70);
INSERT INTO public.who_global_data VALUES (67691, 2, 51, 0, 0, 286, 46);
INSERT INTO public.who_global_data VALUES (67692, 647, 36923, 127, 4374, 286, 139);
INSERT INTO public.who_global_data VALUES (67693, 0, 18, 0, 0, 286, 42);
INSERT INTO public.who_global_data VALUES (67694, 4, 1121, 0, 18, 286, 80);
INSERT INTO public.who_global_data VALUES (67695, 0, 11, 0, 3, 286, 203);
INSERT INTO public.who_global_data VALUES (67696, 3, 684, 3, 27, 286, 136);
INSERT INTO public.who_global_data VALUES (67697, 87, 1182, 3, 35, 286, 63);
INSERT INTO public.who_global_data VALUES (67698, 0, 0, 0, 0, 286, 17);
INSERT INTO public.who_global_data VALUES (67699, 0, 14, 0, 2, 286, 172);
INSERT INTO public.who_global_data VALUES (67700, 41, 1367, 2, 59, 286, 109);
INSERT INTO public.who_global_data VALUES (67701, 59, 7467, 2, 193, 286, 200);
INSERT INTO public.who_global_data VALUES (67702, 0, 342, 0, 2, 286, 93);
INSERT INTO public.who_global_data VALUES (67703, 93, 1998, 0, 10, 286, 5);
INSERT INTO public.who_global_data VALUES (67704, 0, 712, 0, 13, 286, 214);
INSERT INTO public.who_global_data VALUES (67705, 970, 13197, 21, 277, 286, 204);
INSERT INTO public.who_global_data VALUES (67706, 0, 0, 0, 0, 286, 198);
INSERT INTO public.who_global_data VALUES (67707, 172, 5338, 8, 154, 286, 173);
INSERT INTO public.who_global_data VALUES (67708, 0, 8, 0, 0, 286, 229);
INSERT INTO public.who_global_data VALUES (67709, 3, 223, 0, 9, 286, 76);
INSERT INTO public.who_global_data VALUES (67710, 734, 21648, 62, 634, 286, 138);
INSERT INTO public.who_global_data VALUES (67711, 102, 7294, 17, 494, 286, 98);
INSERT INTO public.who_global_data VALUES (67712, 0, 0, 0, 0, 286, 103);
INSERT INTO public.who_global_data VALUES (67713, 381, 11273, 30, 524, 286, 225);
INSERT INTO public.who_global_data VALUES (67714, 412, 23683, 23, 903, 286, 131);
INSERT INTO public.who_global_data VALUES (67715, 0, 1276, 2, 53, 286, 235);
INSERT INTO public.who_global_data VALUES (67716, 929, 10287, 0, 10, 286, 137);
INSERT INTO public.who_global_data VALUES (67717, 10, 10728, 2, 242, 286, 81);
INSERT INTO public.who_global_data VALUES (67718, 194, 3304, 7, 94, 286, 182);
INSERT INTO public.who_global_data VALUES (67719, 0, 411, 0, 0, 286, 145);
INSERT INTO public.who_global_data VALUES (67720, 218, 10635, 23, 575, 286, 26);
INSERT INTO public.who_global_data VALUES (67721, 6361, 80949, 66, 747, 286, 170);
INSERT INTO public.who_global_data VALUES (67722, 7, 183, 0, 0, 286, 191);
INSERT INTO public.who_global_data VALUES (67723, 0, 2, 0, 0, 286, 221);
INSERT INTO public.who_global_data VALUES (67724, 0, 6, 0, 0, 286, 64);
INSERT INTO public.who_global_data VALUES (67725, 0, 0, 0, 0, 286, 116);
INSERT INTO public.who_global_data VALUES (67726, 0, 15, 0, 0, 286, 128);
INSERT INTO public.who_global_data VALUES (67727, 0, 15, 0, 0, 286, 6);
INSERT INTO public.who_global_data VALUES (67728, 0, 38, 1, 3, 286, 227);
INSERT INTO public.who_global_data VALUES (67729, 0, 1, 0, 0, 286, 68);
INSERT INTO public.who_global_data VALUES (67730, 0, 14, 0, 0, 286, 184);
INSERT INTO public.who_global_data VALUES (67731, 0, 0, 0, 0, 286, 82);
INSERT INTO public.who_global_data VALUES (67732, 0, 513, 0, 40, 286, 149);
INSERT INTO public.who_global_data VALUES (67733, 0, 8, 0, 0, 286, 197);
INSERT INTO public.who_global_data VALUES (67734, 1223, 17522, 3, 139, 286, 78);
INSERT INTO public.who_global_data VALUES (67735, 69, 614, 0, 7, 286, 233);
INSERT INTO public.who_global_data VALUES (67736, 296, 7779, 7, 151, 286, 133);
INSERT INTO public.who_global_data VALUES (67737, 0, 11, 0, 0, 286, 35);
INSERT INTO public.who_global_data VALUES (67738, 4, 86, 0, 3, 286, 114);
INSERT INTO public.who_global_data VALUES (67739, 618, 12693, 0, 12, 286, 237);
INSERT INTO public.who_global_data VALUES (67740, 0, 2, 0, 0, 286, 55);
INSERT INTO public.who_global_data VALUES (67741, 0, 73, 0, 12, 286, 176);
INSERT INTO public.who_global_data VALUES (67742, 13, 1373, 0, 17, 286, 202);
INSERT INTO public.who_global_data VALUES (67743, 8, 1397, 1, 90, 286, 155);
INSERT INTO public.who_global_data VALUES (67744, 0, 0, 0, 0, 286, 32);
INSERT INTO public.who_global_data VALUES (67745, 46, 436, 5, 23, 286, 220);
INSERT INTO public.who_global_data VALUES (67746, 141, 4361, 7, 86, 286, 30);
INSERT INTO public.who_global_data VALUES (67747, 0, 5, 0, 0, 286, 147);
INSERT INTO public.who_global_data VALUES (67748, 2292, 217538, 330, 24580, 286, 208);
INSERT INTO public.who_global_data VALUES (67749, 40, 460, 0, 7, 286, 45);
INSERT INTO public.who_global_data VALUES (67750, 24, 237, 4, 21, 286, 110);
INSERT INTO public.who_global_data VALUES (67751, 0, 10, 0, 1, 286, 88);
INSERT INTO public.who_global_data VALUES (67752, 780, 18091, 89, 2449, 286, 51);
INSERT INTO public.who_global_data VALUES (67753, 87, 29169, 25, 1524, 286, 209);
INSERT INTO public.who_global_data VALUES (67754, 0, 42, 0, 3, 286, 205);
INSERT INTO public.who_global_data VALUES (67755, 0, 0, 0, 0, 286, 18);
INSERT INTO public.who_global_data VALUES (67756, 15, 2922, 0, 51, 286, 72);
INSERT INTO public.who_global_data VALUES (67757, 4970, 150494, 815, 23627, 286, 44);
INSERT INTO public.who_global_data VALUES (67758, 0, 24, 0, 0, 286, 15);
INSERT INTO public.who_global_data VALUES (67759, 6, 96, 0, 6, 286, 25);
INSERT INTO public.who_global_data VALUES (67760, 0, 0, 0, 0, 286, 179);
INSERT INTO public.who_global_data VALUES (67761, 0, 0, 0, 0, 286, 34);
INSERT INTO public.who_global_data VALUES (67762, 0, 115, 0, 8, 286, 207);
INSERT INTO public.who_global_data VALUES (67763, 17, 939, 0, 38, 286, 166);
INSERT INTO public.who_global_data VALUES (67764, 2861, 107773, 106, 2706, 286, 126);
INSERT INTO public.who_global_data VALUES (67765, 0, 0, 0, 0, 286, 97);
INSERT INTO public.who_global_data VALUES (67766, 0, 11, 0, 1, 286, 36);
INSERT INTO public.who_global_data VALUES (67767, 0, 0, 0, 0, 286, 125);
INSERT INTO public.who_global_data VALUES (67768, 0, 75, 0, 0, 286, 124);
INSERT INTO public.who_global_data VALUES (67769, 492, 8617, 8, 209, 286, 185);
INSERT INTO public.who_global_data VALUES (67770, 1068, 10349, 12, 76, 286, 194);
INSERT INTO public.who_global_data VALUES (67771, 0, 300, 0, 10, 286, 144);
INSERT INTO public.who_global_data VALUES (67772, 38509, 899281, 2151, 51325, 286, 19);
INSERT INTO public.who_global_data VALUES (67773, 1, 55, 0, 3, 286, 217);
INSERT INTO public.who_global_data VALUES (67774, 6, 563, 0, 12, 286, 148);
INSERT INTO public.who_global_data VALUES (67775, 29, 1865, 0, 8, 286, 86);
INSERT INTO public.who_global_data VALUES (67776, 0, 0, 0, 0, 286, 13);
INSERT INTO public.who_global_data VALUES (67777, 0, 318, 0, 10, 286, 157);
INSERT INTO public.who_global_data VALUES (67778, 0, 270, 0, 0, 286, 8);
INSERT INTO public.who_global_data VALUES (67779, 0, 0, 0, 0, 286, 73);
INSERT INTO public.who_global_data VALUES (67780, 0, 1, 0, 0, 286, 101);
INSERT INTO public.who_global_data VALUES (67781, 0, 84, 0, 3, 286, 165);
INSERT INTO public.who_global_data VALUES (67782, 2, 31, 0, 4, 286, 14);
INSERT INTO public.who_global_data VALUES (67783, 237, 1463, 7, 47, 287, 193);
INSERT INTO public.who_global_data VALUES (67784, 0, 640, 0, 26, 287, 113);
INSERT INTO public.who_global_data VALUES (67785, 120, 3127, 8, 415, 287, 143);
INSERT INTO public.who_global_data VALUES (67786, 0, 0, 0, 0, 287, 219);
INSERT INTO public.who_global_data VALUES (67787, 7, 733, 2, 40, 287, 186);
INSERT INTO public.who_global_data VALUES (67788, 0, 25, 0, 2, 287, 52);
INSERT INTO public.who_global_data VALUES (67789, 0, 3, 0, 0, 287, 180);
INSERT INTO public.who_global_data VALUES (67790, 0, 24, 0, 3, 287, 167);
INSERT INTO public.who_global_data VALUES (67791, 139, 3479, 8, 167, 287, 154);
INSERT INTO public.who_global_data VALUES (67792, 73, 1572, 3, 27, 287, 94);
INSERT INTO public.who_global_data VALUES (67793, 0, 100, 0, 2, 287, 66);
INSERT INTO public.who_global_data VALUES (67794, 20, 6687, 3, 79, 287, 58);
INSERT INTO public.who_global_data VALUES (67795, 83, 15068, 5, 513, 287, 163);
INSERT INTO public.who_global_data VALUES (67796, 44, 1592, 1, 21, 287, 37);
INSERT INTO public.who_global_data VALUES (67797, 2, 72, 2, 11, 287, 142);
INSERT INTO public.who_global_data VALUES (67798, 82, 2588, 0, 8, 287, 83);
INSERT INTO public.who_global_data VALUES (67799, 309, 4998, 9, 140, 287, 228);
INSERT INTO public.who_global_data VALUES (67800, 0, 76, 0, 6, 287, 188);
INSERT INTO public.who_global_data VALUES (67801, 751, 8773, 3, 63, 287, 62);
INSERT INTO public.who_global_data VALUES (67802, 811, 47600, 155, 7132, 287, 160);
INSERT INTO public.who_global_data VALUES (67803, 0, 18, 0, 2, 287, 50);
INSERT INTO public.who_global_data VALUES (67804, 0, 58, 0, 1, 287, 33);
INSERT INTO public.who_global_data VALUES (67805, 0, 99, 0, 5, 287, 183);
INSERT INTO public.who_global_data VALUES (67806, 0, 7, 0, 0, 287, 92);
INSERT INTO public.who_global_data VALUES (67807, 31, 703, 3, 43, 287, 158);
INSERT INTO public.who_global_data VALUES (67808, 0, 1, 0, 0, 287, 67);
INSERT INTO public.who_global_data VALUES (67809, 15, 1428, 1, 54, 287, 57);
INSERT INTO public.who_global_data VALUES (67810, 0, 22, 0, 1, 287, 38);
INSERT INTO public.who_global_data VALUES (67811, 3735, 49492, 407, 3313, 287, 141);
INSERT INTO public.who_global_data VALUES (67812, 0, 5, 0, 1, 287, 178);
INSERT INTO public.who_global_data VALUES (67813, 0, 138, 0, 1, 287, 108);
INSERT INTO public.who_global_data VALUES (67814, 91, 1188, 2, 54, 287, 39);
INSERT INTO public.who_global_data VALUES (67815, 16, 616, 3, 41, 287, 2);
INSERT INTO public.who_global_data VALUES (67816, 1, 12, 0, 1, 287, 195);
INSERT INTO public.who_global_data VALUES (67817, 21, 88, 0, 1, 287, 107);
INSERT INTO public.who_global_data VALUES (67818, 0, 122, 0, 0, 287, 161);
INSERT INTO public.who_global_data VALUES (67819, 2, 1403, 0, 49, 287, 212);
INSERT INTO public.who_global_data VALUES (67820, 1926, 42739, 169, 2197, 287, 181);
INSERT INTO public.who_global_data VALUES (67821, 0, 66, 0, 1, 287, 53);
INSERT INTO public.who_global_data VALUES (67822, 3, 19, 0, 0, 287, 164);
INSERT INTO public.who_global_data VALUES (67823, 6, 40, 0, 0, 287, 140);
INSERT INTO public.who_global_data VALUES (67824, 494, 12306, 6, 174, 287, 20);
INSERT INTO public.who_global_data VALUES (67825, 12, 84324, 0, 4642, 287, 112);
INSERT INTO public.who_global_data VALUES (67826, 205, 4561, 9, 215, 287, 111);
INSERT INTO public.who_global_data VALUES (67827, 0, 0, 0, 0, 287, 71);
INSERT INTO public.who_global_data VALUES (67828, 14, 200, 0, 6, 287, 218);
INSERT INTO public.who_global_data VALUES (67829, 0, 0, 0, 0, 287, 43);
INSERT INTO public.who_global_data VALUES (67830, 5, 686, 0, 6, 287, 49);
INSERT INTO public.who_global_data VALUES (67831, 73, 1077, 0, 14, 287, 1);
INSERT INTO public.who_global_data VALUES (67832, 28, 2009, 1, 51, 287, 48);
INSERT INTO public.who_global_data VALUES (67833, 50, 1285, 6, 49, 287, 232);
INSERT INTO public.who_global_data VALUES (67834, 0, 14, 0, 1, 287, 175);
INSERT INTO public.who_global_data VALUES (67835, 9, 804, 0, 14, 287, 21);
INSERT INTO public.who_global_data VALUES (67836, 85, 7273, 2, 215, 287, 156);
INSERT INTO public.who_global_data VALUES (67837, 0, 0, 0, 0, 287, 95);
INSERT INTO public.who_global_data VALUES (67838, 22, 416, 3, 28, 287, 177);
INSERT INTO public.who_global_data VALUES (67839, 137, 8210, 9, 403, 287, 210);
INSERT INTO public.who_global_data VALUES (67840, 9, 1008, 0, 2, 287, 120);
INSERT INTO public.who_global_data VALUES (67841, 0, 16, 0, 0, 287, 135);
INSERT INTO public.who_global_data VALUES (67842, 206, 5749, 2, 267, 287, 206);
INSERT INTO public.who_global_data VALUES (67843, 11536, 22719, 16, 576, 287, 189);
INSERT INTO public.who_global_data VALUES (67844, 0, 4092, 0, 294, 287, 129);
INSERT INTO public.who_global_data VALUES (67845, 11, 261, 0, 8, 287, 121);
INSERT INTO public.who_global_data VALUES (67846, 128, 212, 0, 1, 287, 59);
INSERT INTO public.who_global_data VALUES (67847, 0, 39, 0, 0, 287, 96);
INSERT INTO public.who_global_data VALUES (67848, 13, 1605, 1, 46, 287, 41);
INSERT INTO public.who_global_data VALUES (67849, 9, 40, 0, 1, 287, 216);
INSERT INTO public.who_global_data VALUES (67850, 1, 117, 0, 3, 287, 236);
INSERT INTO public.who_global_data VALUES (67851, 0, 12, 0, 0, 287, 150);
INSERT INTO public.who_global_data VALUES (67852, 0, 187, 0, 0, 287, 61);
INSERT INTO public.who_global_data VALUES (67853, 0, 18, 0, 0, 287, 7);
INSERT INTO public.who_global_data VALUES (67854, 111, 4395, 5, 177, 287, 169);
INSERT INTO public.who_global_data VALUES (67855, 1755, 121339, 389, 22214, 287, 28);
INSERT INTO public.who_global_data VALUES (67856, 2, 109, 0, 1, 287, 85);
INSERT INTO public.who_global_data VALUES (67857, 0, 57, 0, 0, 287, 211);
INSERT INTO public.who_global_data VALUES (67858, 6, 172, 1, 3, 287, 60);
INSERT INTO public.who_global_data VALUES (67859, 0, 10, 0, 1, 287, 3);
INSERT INTO public.who_global_data VALUES (67860, 25, 456, 0, 5, 287, 11);
INSERT INTO public.who_global_data VALUES (67861, 2055, 152438, 179, 5500, 287, 89);
INSERT INTO public.who_global_data VALUES (67862, 125, 1279, 1, 10, 287, 24);
INSERT INTO public.who_global_data VALUES (67863, 0, 133, 0, 0, 287, 162);
INSERT INTO public.who_global_data VALUES (67864, 27, 2490, 5, 130, 287, 100);
INSERT INTO public.who_global_data VALUES (67865, 0, 11, 0, 0, 287, 47);
INSERT INTO public.who_global_data VALUES (67866, 0, 15, 0, 0, 287, 29);
INSERT INTO public.who_global_data VALUES (67867, 1, 149, 0, 10, 287, 40);
INSERT INTO public.who_global_data VALUES (67868, 0, 136, 0, 5, 287, 222);
INSERT INTO public.who_global_data VALUES (67869, 42, 384, 1, 11, 287, 132);
INSERT INTO public.who_global_data VALUES (67870, 2, 245, 0, 10, 287, 130);
INSERT INTO public.who_global_data VALUES (67871, 92, 954, 0, 6, 287, 234);
INSERT INTO public.who_global_data VALUES (67872, 0, 52, 0, 0, 287, 23);
INSERT INTO public.who_global_data VALUES (67873, 3, 70, 0, 7, 287, 192);
INSERT INTO public.who_global_data VALUES (67874, 10, 72, 1, 5, 287, 69);
INSERT INTO public.who_global_data VALUES (67875, 0, 9, 0, 0, 287, 187);
INSERT INTO public.who_global_data VALUES (67876, 43, 562, 0, 47, 287, 230);
INSERT INTO public.who_global_data VALUES (67877, 60, 2443, 12, 262, 287, 77);
INSERT INTO public.who_global_data VALUES (67878, 0, 1789, 0, 10, 287, 9);
INSERT INTO public.who_global_data VALUES (67879, 1429, 24506, 57, 775, 287, 74);
INSERT INTO public.who_global_data VALUES (67880, 396, 8607, 31, 720, 287, 224);
INSERT INTO public.who_global_data VALUES (67881, 1134, 89328, 76, 5650, 287, 199);
INSERT INTO public.who_global_data VALUES (67882, 31, 1708, 3, 86, 287, 190);
INSERT INTO public.who_global_data VALUES (67883, 577, 18184, 35, 829, 287, 12);
INSERT INTO public.who_global_data VALUES (67884, 1, 308, 1, 17, 287, 104);
INSERT INTO public.who_global_data VALUES (67885, 276, 14901, 4, 196, 287, 153);
INSERT INTO public.who_global_data VALUES (67886, 3021, 192994, 420, 25969, 287, 91);
INSERT INTO public.who_global_data VALUES (67887, 14, 257, 1, 7, 287, 215);
INSERT INTO public.who_global_data VALUES (67888, 441, 12829, 17, 334, 287, 84);
INSERT INTO public.who_global_data VALUES (67889, 21, 276, 1, 19, 287, 231);
INSERT INTO public.who_global_data VALUES (67890, 7, 444, 0, 7, 287, 196);
INSERT INTO public.who_global_data VALUES (67891, 185, 2601, 0, 25, 287, 105);
INSERT INTO public.who_global_data VALUES (67892, 16, 336, 0, 14, 287, 122);
INSERT INTO public.who_global_data VALUES (67893, 0, 0, 0, 0, 287, 159);
INSERT INTO public.who_global_data VALUES (67894, 34, 703, 1, 16, 287, 75);
INSERT INTO public.who_global_data VALUES (67895, 278, 2892, 4, 19, 287, 27);
INSERT INTO public.who_global_data VALUES (67896, 9, 665, 0, 8, 287, 54);
INSERT INTO public.who_global_data VALUES (67897, 0, 19, 0, 0, 287, 226);
INSERT INTO public.who_global_data VALUES (67898, 6, 784, 1, 12, 287, 79);
INSERT INTO public.who_global_data VALUES (67899, 8, 704, 2, 24, 287, 56);
INSERT INTO public.who_global_data VALUES (67900, 0, 0, 0, 0, 287, 117);
INSERT INTO public.who_global_data VALUES (67901, 16, 117, 0, 8, 287, 152);
INSERT INTO public.who_global_data VALUES (67902, 1, 61, 0, 2, 287, 16);
INSERT INTO public.who_global_data VALUES (67903, 0, 83, 0, 1, 287, 10);
INSERT INTO public.who_global_data VALUES (67904, 10, 1301, 1, 41, 287, 201);
INSERT INTO public.who_global_data VALUES (67905, 30, 3695, 2, 85, 287, 174);
INSERT INTO public.who_global_data VALUES (67906, 1, 122, 0, 0, 287, 119);
INSERT INTO public.who_global_data VALUES (67907, 0, 33, 0, 3, 287, 168);
INSERT INTO public.who_global_data VALUES (67908, 88, 5691, 1, 96, 287, 99);
INSERT INTO public.who_global_data VALUES (67909, 21, 137, 0, 0, 287, 171);
INSERT INTO public.who_global_data VALUES (67910, 16, 325, 0, 21, 287, 87);
INSERT INTO public.who_global_data VALUES (67911, 1, 447, 0, 3, 287, 123);
INSERT INTO public.who_global_data VALUES (67912, 0, 0, 0, 0, 287, 151);
INSERT INTO public.who_global_data VALUES (67913, 0, 170, 0, 14, 287, 213);
INSERT INTO public.who_global_data VALUES (67914, 0, 7, 0, 1, 287, 118);
INSERT INTO public.who_global_data VALUES (67915, 0, 331, 0, 9, 287, 134);
INSERT INTO public.who_global_data VALUES (67916, 15, 354, 0, 4, 287, 65);
INSERT INTO public.who_global_data VALUES (67917, 1089, 11633, 99, 1069, 287, 102);
INSERT INTO public.who_global_data VALUES (67918, 0, 0, 0, 0, 287, 223);
INSERT INTO public.who_global_data VALUES (67919, 0, 65, 0, 1, 287, 4);
INSERT INTO public.who_global_data VALUES (67920, 0, 36, 0, 0, 287, 146);
INSERT INTO public.who_global_data VALUES (67921, 2, 321, 0, 6, 287, 31);
INSERT INTO public.who_global_data VALUES (67922, 0, 11, 0, 0, 287, 127);
INSERT INTO public.who_global_data VALUES (67923, 197, 3889, 4, 159, 287, 22);
INSERT INTO public.who_global_data VALUES (67924, 24, 65, 0, 0, 287, 115);
INSERT INTO public.who_global_data VALUES (67925, 5, 144, 0, 5, 287, 106);
INSERT INTO public.who_global_data VALUES (67926, 0, 16, 0, 0, 287, 90);
INSERT INTO public.who_global_data VALUES (67927, 0, 0, 0, 0, 287, 70);
INSERT INTO public.who_global_data VALUES (67928, 1, 49, 0, 0, 287, 46);
INSERT INTO public.who_global_data VALUES (67929, 805, 36276, 111, 4247, 287, 139);
INSERT INTO public.who_global_data VALUES (67930, 0, 18, 0, 0, 287, 42);
INSERT INTO public.who_global_data VALUES (67931, 3, 1117, 1, 18, 287, 80);
INSERT INTO public.who_global_data VALUES (67932, 1, 11, 1, 3, 287, 203);
INSERT INTO public.who_global_data VALUES (67933, 10, 681, 0, 24, 287, 136);
INSERT INTO public.who_global_data VALUES (67934, 114, 1095, 1, 32, 287, 63);
INSERT INTO public.who_global_data VALUES (67935, 0, 0, 0, 0, 287, 17);
INSERT INTO public.who_global_data VALUES (67936, 0, 14, 0, 2, 287, 172);
INSERT INTO public.who_global_data VALUES (67937, 26, 1326, 1, 57, 287, 109);
INSERT INTO public.who_global_data VALUES (67938, 63, 7408, 11, 191, 287, 200);
INSERT INTO public.who_global_data VALUES (67939, 2, 342, 0, 2, 287, 93);
INSERT INTO public.who_global_data VALUES (67940, 115, 1905, 1, 10, 287, 5);
INSERT INTO public.who_global_data VALUES (67941, 0, 712, 0, 13, 287, 214);
INSERT INTO public.who_global_data VALUES (67942, 1072, 12227, 19, 256, 287, 204);
INSERT INTO public.who_global_data VALUES (67943, 0, 0, 0, 0, 287, 198);
INSERT INTO public.who_global_data VALUES (67944, 174, 5166, 2, 146, 287, 173);
INSERT INTO public.who_global_data VALUES (67945, 0, 8, 0, 0, 287, 229);
INSERT INTO public.who_global_data VALUES (67946, 7, 220, 0, 9, 287, 76);
INSERT INTO public.who_global_data VALUES (67947, 1664, 20914, 42, 572, 287, 138);
INSERT INTO public.who_global_data VALUES (67948, 211, 7192, 15, 477, 287, 98);
INSERT INTO public.who_global_data VALUES (67949, 0, 0, 0, 0, 287, 103);
INSERT INTO public.who_global_data VALUES (67950, 381, 10892, 40, 494, 287, 225);
INSERT INTO public.who_global_data VALUES (67951, 918, 23271, 60, 880, 287, 131);
INSERT INTO public.who_global_data VALUES (67952, 0, 1276, 3, 51, 287, 235);
INSERT INTO public.who_global_data VALUES (67953, 833, 9358, 0, 10, 287, 137);
INSERT INTO public.who_global_data VALUES (67954, 10, 10718, 0, 240, 287, 81);
INSERT INTO public.who_global_data VALUES (67955, 184, 3110, 7, 87, 287, 182);
INSERT INTO public.who_global_data VALUES (67956, 0, 411, 0, 0, 287, 145);
INSERT INTO public.who_global_data VALUES (67957, 321, 10417, 25, 552, 287, 26);
INSERT INTO public.who_global_data VALUES (67958, 5966, 74588, 66, 681, 287, 170);
INSERT INTO public.who_global_data VALUES (67959, 22, 176, 0, 0, 287, 191);
INSERT INTO public.who_global_data VALUES (67960, 0, 2, 0, 0, 287, 221);
INSERT INTO public.who_global_data VALUES (67961, 0, 6, 0, 0, 287, 64);
INSERT INTO public.who_global_data VALUES (67962, 0, 0, 0, 0, 287, 116);
INSERT INTO public.who_global_data VALUES (67963, 0, 15, 0, 0, 287, 128);
INSERT INTO public.who_global_data VALUES (67964, 0, 15, 0, 0, 287, 6);
INSERT INTO public.who_global_data VALUES (67965, 0, 38, 0, 2, 287, 227);
INSERT INTO public.who_global_data VALUES (67966, 0, 1, 0, 0, 287, 68);
INSERT INTO public.who_global_data VALUES (67967, 1, 14, 0, 0, 287, 184);
INSERT INTO public.who_global_data VALUES (67968, 0, 0, 0, 0, 287, 82);
INSERT INTO public.who_global_data VALUES (67969, 12, 513, 0, 40, 287, 149);
INSERT INTO public.who_global_data VALUES (67970, 0, 8, 0, 0, 287, 197);
INSERT INTO public.who_global_data VALUES (67971, 1197, 16299, 9, 136, 287, 78);
INSERT INTO public.who_global_data VALUES (67972, 66, 545, 1, 7, 287, 233);
INSERT INTO public.who_global_data VALUES (67973, 207, 7483, 5, 144, 287, 133);
INSERT INTO public.who_global_data VALUES (67974, 0, 11, 0, 0, 287, 35);
INSERT INTO public.who_global_data VALUES (67975, 18, 82, 2, 3, 287, 114);
INSERT INTO public.who_global_data VALUES (67976, 897, 12075, 0, 12, 287, 237);
INSERT INTO public.who_global_data VALUES (67977, 0, 2, 0, 0, 287, 55);
INSERT INTO public.who_global_data VALUES (67978, 0, 73, 0, 12, 287, 176);
INSERT INTO public.who_global_data VALUES (67979, 35, 1360, 2, 17, 287, 202);
INSERT INTO public.who_global_data VALUES (67980, 15, 1389, 1, 89, 287, 155);
INSERT INTO public.who_global_data VALUES (67981, 0, 0, 0, 0, 287, 32);
INSERT INTO public.who_global_data VALUES (67982, 62, 390, 2, 18, 287, 220);
INSERT INTO public.who_global_data VALUES (67983, 267, 4220, 4, 79, 287, 30);
INSERT INTO public.who_global_data VALUES (67984, 1, 5, 0, 0, 287, 147);
INSERT INTO public.who_global_data VALUES (67985, 2222, 215246, 331, 24250, 287, 208);
INSERT INTO public.who_global_data VALUES (67986, 52, 420, 0, 7, 287, 45);
INSERT INTO public.who_global_data VALUES (67987, 39, 213, 1, 17, 287, 110);
INSERT INTO public.who_global_data VALUES (67988, 0, 10, 0, 1, 287, 88);
INSERT INTO public.who_global_data VALUES (67989, 758, 17311, 86, 2360, 287, 51);
INSERT INTO public.who_global_data VALUES (67990, 167, 29082, 27, 1499, 287, 209);
INSERT INTO public.who_global_data VALUES (67991, 0, 42, 0, 3, 287, 205);
INSERT INTO public.who_global_data VALUES (67992, 0, 0, 0, 0, 287, 18);
INSERT INTO public.who_global_data VALUES (67993, 53, 2907, 1, 51, 287, 72);
INSERT INTO public.who_global_data VALUES (67994, 5158, 145524, 1010, 22812, 287, 44);
INSERT INTO public.who_global_data VALUES (67995, 0, 24, 0, 0, 287, 15);
INSERT INTO public.who_global_data VALUES (67996, 2, 90, 0, 6, 287, 25);
INSERT INTO public.who_global_data VALUES (67997, 0, 0, 0, 0, 287, 179);
INSERT INTO public.who_global_data VALUES (67998, 0, 0, 0, 0, 287, 34);
INSERT INTO public.who_global_data VALUES (67999, 0, 115, 0, 8, 287, 207);
INSERT INTO public.who_global_data VALUES (68000, 4, 922, 0, 38, 287, 166);
INSERT INTO public.who_global_data VALUES (68001, 3122, 104912, 109, 2600, 287, 126);
INSERT INTO public.who_global_data VALUES (68002, 0, 0, 0, 0, 287, 97);
INSERT INTO public.who_global_data VALUES (68003, 0, 11, 0, 1, 287, 36);
INSERT INTO public.who_global_data VALUES (68004, 0, 0, 0, 0, 287, 125);
INSERT INTO public.who_global_data VALUES (68005, 12, 75, 0, 0, 287, 124);
INSERT INTO public.who_global_data VALUES (68006, 478, 8125, 8, 201, 287, 185);
INSERT INTO public.who_global_data VALUES (68007, 0, 9281, 0, 64, 287, 194);
INSERT INTO public.who_global_data VALUES (68008, 15, 300, 0, 10, 287, 144);
INSERT INTO public.who_global_data VALUES (68009, 30719, 860772, 1742, 49174, 287, 19);
INSERT INTO public.who_global_data VALUES (68010, 0, 54, 0, 3, 287, 217);
INSERT INTO public.who_global_data VALUES (68011, 8, 557, 0, 12, 287, 148);
INSERT INTO public.who_global_data VALUES (68012, 58, 1836, 1, 8, 287, 86);
INSERT INTO public.who_global_data VALUES (68013, 0, 0, 0, 0, 287, 13);
INSERT INTO public.who_global_data VALUES (68014, 20, 318, 0, 10, 287, 157);
INSERT INTO public.who_global_data VALUES (68015, 2, 270, 0, 0, 287, 8);
INSERT INTO public.who_global_data VALUES (68016, 0, 0, 0, 0, 287, 73);
INSERT INTO public.who_global_data VALUES (68017, 0, 1, 0, 0, 287, 101);
INSERT INTO public.who_global_data VALUES (68018, 8, 84, 0, 3, 287, 165);
INSERT INTO public.who_global_data VALUES (68019, 1, 29, 0, 4, 287, 14);
INSERT INTO public.who_global_data VALUES (68020, 50, 1226, 0, 40, 288, 193);
INSERT INTO public.who_global_data VALUES (68021, 44, 640, 0, 26, 288, 113);
INSERT INTO public.who_global_data VALUES (68022, 97, 3007, 5, 407, 288, 143);
INSERT INTO public.who_global_data VALUES (68023, 0, 0, 0, 0, 288, 219);
INSERT INTO public.who_global_data VALUES (68024, 2, 726, 1, 38, 288, 186);
INSERT INTO public.who_global_data VALUES (68025, 1, 25, 0, 2, 288, 52);
INSERT INTO public.who_global_data VALUES (68026, 0, 3, 0, 0, 288, 180);
INSERT INTO public.who_global_data VALUES (68027, 0, 24, 0, 3, 288, 167);
INSERT INTO public.who_global_data VALUES (68028, 143, 3340, 7, 159, 288, 154);
INSERT INTO public.who_global_data VALUES (68029, 50, 1499, 0, 24, 288, 94);
INSERT INTO public.who_global_data VALUES (68030, 0, 100, 0, 2, 288, 66);
INSERT INTO public.who_global_data VALUES (68031, 6, 6667, 1, 76, 288, 58);
INSERT INTO public.who_global_data VALUES (68032, 61, 14985, 14, 508, 288, 163);
INSERT INTO public.who_global_data VALUES (68033, 30, 1548, 0, 20, 288, 37);
INSERT INTO public.who_global_data VALUES (68034, 5, 70, 0, 9, 288, 142);
INSERT INTO public.who_global_data VALUES (68035, 408, 2506, 0, 8, 288, 83);
INSERT INTO public.who_global_data VALUES (68036, 503, 4689, 4, 131, 288, 228);
INSERT INTO public.who_global_data VALUES (68037, 1, 76, 1, 6, 288, 188);
INSERT INTO public.who_global_data VALUES (68038, 741, 8022, 0, 60, 288, 62);
INSERT INTO public.who_global_data VALUES (68039, 976, 46789, 155, 6977, 288, 160);
INSERT INTO public.who_global_data VALUES (68040, 0, 18, 0, 2, 288, 50);
INSERT INTO public.who_global_data VALUES (68041, 4, 58, 0, 1, 288, 33);
INSERT INTO public.who_global_data VALUES (68042, 1, 99, 0, 5, 288, 183);
INSERT INTO public.who_global_data VALUES (68043, 0, 7, 0, 0, 288, 92);
INSERT INTO public.who_global_data VALUES (68044, 63, 672, 3, 40, 288, 158);
INSERT INTO public.who_global_data VALUES (68045, 0, 1, 0, 0, 288, 67);
INSERT INTO public.who_global_data VALUES (68046, 46, 1413, 1, 53, 288, 57);
INSERT INTO public.who_global_data VALUES (68047, 0, 22, 0, 1, 288, 38);
INSERT INTO public.who_global_data VALUES (68048, 2678, 45757, 165, 2906, 288, 141);
INSERT INTO public.who_global_data VALUES (68049, 1, 5, 0, 1, 288, 178);
INSERT INTO public.who_global_data VALUES (68050, 0, 138, 0, 1, 288, 108);
INSERT INTO public.who_global_data VALUES (68051, 73, 1097, 3, 52, 288, 39);
INSERT INTO public.who_global_data VALUES (68052, 0, 600, 0, 38, 288, 2);
INSERT INTO public.who_global_data VALUES (68053, 0, 11, 0, 1, 288, 195);
INSERT INTO public.who_global_data VALUES (68054, 0, 67, 0, 1, 288, 107);
INSERT INTO public.who_global_data VALUES (68055, 0, 122, 0, 0, 288, 161);
INSERT INTO public.who_global_data VALUES (68056, 238, 1401, 6, 49, 288, 212);
INSERT INTO public.who_global_data VALUES (68057, 1890, 40813, 157, 2028, 288, 181);
INSERT INTO public.who_global_data VALUES (68058, 0, 66, 0, 1, 288, 53);
INSERT INTO public.who_global_data VALUES (68059, 2, 16, 0, 0, 288, 164);
INSERT INTO public.who_global_data VALUES (68060, 0, 34, 0, 0, 288, 140);
INSERT INTO public.who_global_data VALUES (68061, 516, 11812, 8, 168, 288, 20);
INSERT INTO public.who_global_data VALUES (68062, 9, 84312, 0, 4642, 288, 112);
INSERT INTO public.who_global_data VALUES (68063, 207, 4356, 10, 206, 288, 111);
INSERT INTO public.who_global_data VALUES (68064, 0, 0, 0, 0, 288, 71);
INSERT INTO public.who_global_data VALUES (68065, 0, 186, 0, 6, 288, 218);
INSERT INTO public.who_global_data VALUES (68066, 0, 0, 0, 0, 288, 43);
INSERT INTO public.who_global_data VALUES (68067, 12, 681, 0, 6, 288, 49);
INSERT INTO public.who_global_data VALUES (68068, 52, 1004, 0, 14, 288, 1);
INSERT INTO public.who_global_data VALUES (68069, 31, 1981, 2, 50, 288, 48);
INSERT INTO public.who_global_data VALUES (68070, 46, 1235, 3, 43, 288, 232);
INSERT INTO public.who_global_data VALUES (68071, 0, 14, 0, 1, 288, 175);
INSERT INTO public.who_global_data VALUES (68072, 5, 795, 0, 14, 288, 21);
INSERT INTO public.who_global_data VALUES (68073, 52, 7188, 3, 213, 288, 156);
INSERT INTO public.who_global_data VALUES (68074, 0, 0, 0, 0, 288, 95);
INSERT INTO public.who_global_data VALUES (68075, 35, 394, 0, 25, 288, 177);
INSERT INTO public.who_global_data VALUES (68076, 161, 8073, 10, 394, 288, 210);
INSERT INTO public.who_global_data VALUES (68077, 13, 999, 0, 2, 288, 120);
INSERT INTO public.who_global_data VALUES (68078, 0, 16, 0, 0, 288, 135);
INSERT INTO public.who_global_data VALUES (68079, 243, 5543, 5, 265, 288, 206);
INSERT INTO public.who_global_data VALUES (68080, 333, 11183, 23, 560, 288, 189);
INSERT INTO public.who_global_data VALUES (68081, 433, 4092, 18, 294, 288, 129);
INSERT INTO public.who_global_data VALUES (68082, 13, 250, 1, 8, 288, 121);
INSERT INTO public.who_global_data VALUES (68083, 0, 84, 0, 1, 288, 59);
INSERT INTO public.who_global_data VALUES (68084, 0, 39, 0, 0, 288, 96);
INSERT INTO public.who_global_data VALUES (68085, 33, 1592, 1, 45, 288, 41);
INSERT INTO public.who_global_data VALUES (68086, 0, 31, 0, 1, 288, 216);
INSERT INTO public.who_global_data VALUES (68087, 0, 116, 0, 3, 288, 236);
INSERT INTO public.who_global_data VALUES (68088, 0, 12, 0, 0, 288, 150);
INSERT INTO public.who_global_data VALUES (68089, 2, 187, 0, 0, 288, 61);
INSERT INTO public.who_global_data VALUES (68090, 0, 18, 0, 0, 288, 7);
INSERT INTO public.who_global_data VALUES (68091, 155, 4284, 23, 172, 288, 169);
INSERT INTO public.who_global_data VALUES (68092, 1623, 119584, 516, 21825, 288, 28);
INSERT INTO public.who_global_data VALUES (68093, 10, 107, 0, 1, 288, 85);
INSERT INTO public.who_global_data VALUES (68094, 0, 57, 0, 0, 288, 211);
INSERT INTO public.who_global_data VALUES (68095, 0, 166, 1, 2, 288, 60);
INSERT INTO public.who_global_data VALUES (68096, 0, 10, 0, 1, 288, 3);
INSERT INTO public.who_global_data VALUES (68097, 11, 431, 0, 5, 288, 11);
INSERT INTO public.who_global_data VALUES (68098, 2337, 150383, 227, 5321, 288, 89);
INSERT INTO public.who_global_data VALUES (68099, 0, 1154, 0, 9, 288, 24);
INSERT INTO public.who_global_data VALUES (68100, 0, 133, 0, 0, 288, 162);
INSERT INTO public.who_global_data VALUES (68101, 55, 2463, 4, 125, 288, 100);
INSERT INTO public.who_global_data VALUES (68102, 0, 11, 0, 0, 288, 47);
INSERT INTO public.who_global_data VALUES (68103, 1, 15, 0, 0, 288, 29);
INSERT INTO public.who_global_data VALUES (68104, 0, 148, 0, 10, 288, 40);
INSERT INTO public.who_global_data VALUES (68105, 1, 136, 0, 5, 288, 222);
INSERT INTO public.who_global_data VALUES (68106, 26, 342, 2, 10, 288, 132);
INSERT INTO public.who_global_data VALUES (68107, 2, 243, 0, 10, 288, 130);
INSERT INTO public.who_global_data VALUES (68108, 101, 862, 0, 6, 288, 234);
INSERT INTO public.who_global_data VALUES (68109, 2, 52, 0, 0, 288, 23);
INSERT INTO public.who_global_data VALUES (68110, 0, 67, 0, 7, 288, 192);
INSERT INTO public.who_global_data VALUES (68111, 4, 62, 0, 4, 288, 69);
INSERT INTO public.who_global_data VALUES (68112, 0, 9, 0, 0, 288, 187);
INSERT INTO public.who_global_data VALUES (68113, 9, 519, 1, 47, 288, 230);
INSERT INTO public.who_global_data VALUES (68114, 99, 2383, 25, 250, 288, 77);
INSERT INTO public.who_global_data VALUES (68115, 4, 1789, 0, 10, 288, 9);
INSERT INTO public.who_global_data VALUES (68116, 1684, 23077, 37, 718, 288, 74);
INSERT INTO public.who_global_data VALUES (68117, 436, 8211, 42, 689, 288, 224);
INSERT INTO public.who_global_data VALUES (68118, 1168, 88194, 93, 5574, 288, 199);
INSERT INTO public.who_global_data VALUES (68119, 0, 1677, 0, 83, 288, 190);
INSERT INTO public.who_global_data VALUES (68120, 936, 17607, 25, 794, 288, 12);
INSERT INTO public.who_global_data VALUES (68121, 0, 307, 6, 16, 288, 104);
INSERT INTO public.who_global_data VALUES (68122, 225, 14625, 3, 192, 288, 153);
INSERT INTO public.who_global_data VALUES (68123, 2646, 189973, 464, 25549, 288, 91);
INSERT INTO public.who_global_data VALUES (68124, 10, 243, 0, 6, 288, 215);
INSERT INTO public.who_global_data VALUES (68125, 469, 12388, 30, 317, 288, 84);
INSERT INTO public.who_global_data VALUES (68126, 0, 255, 4, 18, 288, 231);
INSERT INTO public.who_global_data VALUES (68127, 2, 437, 0, 7, 288, 196);
INSERT INTO public.who_global_data VALUES (68128, 391, 2416, 6, 25, 288, 105);
INSERT INTO public.who_global_data VALUES (68129, 17, 320, 0, 14, 288, 122);
INSERT INTO public.who_global_data VALUES (68130, 0, 0, 0, 0, 288, 159);
INSERT INTO public.who_global_data VALUES (68131, 39, 669, 0, 15, 288, 75);
INSERT INTO public.who_global_data VALUES (68132, 215, 2614, 1, 15, 288, 27);
INSERT INTO public.who_global_data VALUES (68133, 25, 656, 0, 8, 288, 54);
INSERT INTO public.who_global_data VALUES (68134, 0, 19, 0, 0, 288, 226);
INSERT INTO public.who_global_data VALUES (68135, 17, 778, 0, 11, 288, 79);
INSERT INTO public.who_global_data VALUES (68136, 8, 696, 0, 22, 288, 56);
INSERT INTO public.who_global_data VALUES (68137, 0, 0, 0, 0, 288, 117);
INSERT INTO public.who_global_data VALUES (68138, 0, 101, 0, 8, 288, 152);
INSERT INTO public.who_global_data VALUES (68139, 0, 60, 1, 2, 288, 16);
INSERT INTO public.who_global_data VALUES (68140, 1, 83, 0, 1, 288, 10);
INSERT INTO public.who_global_data VALUES (68141, 19, 1291, 1, 40, 288, 201);
INSERT INTO public.who_global_data VALUES (68142, 11, 3665, 3, 83, 288, 174);
INSERT INTO public.who_global_data VALUES (68143, 0, 121, 0, 0, 288, 119);
INSERT INTO public.who_global_data VALUES (68144, 10, 33, 0, 3, 288, 168);
INSERT INTO public.who_global_data VALUES (68145, 71, 5603, 2, 95, 288, 99);
INSERT INTO public.who_global_data VALUES (68146, 22, 116, 0, 0, 288, 171);
INSERT INTO public.who_global_data VALUES (68147, 16, 309, 4, 21, 288, 87);
INSERT INTO public.who_global_data VALUES (68148, 2, 446, 0, 3, 288, 123);
INSERT INTO public.who_global_data VALUES (68149, 0, 0, 0, 0, 288, 151);
INSERT INTO public.who_global_data VALUES (68150, 6, 170, 0, 14, 288, 213);
INSERT INTO public.who_global_data VALUES (68151, 0, 7, 0, 1, 288, 118);
INSERT INTO public.who_global_data VALUES (68152, 2, 331, 0, 9, 288, 134);
INSERT INTO public.who_global_data VALUES (68153, 13, 339, 0, 4, 288, 65);
INSERT INTO public.who_global_data VALUES (68154, 1043, 10544, 113, 970, 288, 102);
INSERT INTO public.who_global_data VALUES (68155, 0, 0, 0, 0, 288, 223);
INSERT INTO public.who_global_data VALUES (68156, 0, 65, 0, 1, 288, 4);
INSERT INTO public.who_global_data VALUES (68157, 1, 36, 0, 0, 288, 146);
INSERT INTO public.who_global_data VALUES (68158, 0, 319, 1, 6, 288, 31);
INSERT INTO public.who_global_data VALUES (68159, 0, 11, 0, 0, 288, 127);
INSERT INTO public.who_global_data VALUES (68160, 155, 3692, 4, 155, 288, 22);
INSERT INTO public.who_global_data VALUES (68161, 0, 41, 0, 0, 288, 115);
INSERT INTO public.who_global_data VALUES (68162, 12, 139, 0, 5, 288, 106);
INSERT INTO public.who_global_data VALUES (68163, 0, 16, 0, 0, 288, 90);
INSERT INTO public.who_global_data VALUES (68164, 0, 0, 0, 0, 288, 70);
INSERT INTO public.who_global_data VALUES (68165, 3, 48, 0, 0, 288, 46);
INSERT INTO public.who_global_data VALUES (68166, 876, 35471, 133, 4136, 288, 139);
INSERT INTO public.who_global_data VALUES (68167, 0, 18, 0, 0, 288, 42);
INSERT INTO public.who_global_data VALUES (68168, 2, 1114, 1, 17, 288, 80);
INSERT INTO public.who_global_data VALUES (68169, 0, 10, 0, 2, 288, 203);
INSERT INTO public.who_global_data VALUES (68170, 9, 671, 2, 24, 288, 136);
INSERT INTO public.who_global_data VALUES (68171, 440, 981, 12, 31, 288, 63);
INSERT INTO public.who_global_data VALUES (68172, 0, 0, 0, 0, 288, 17);
INSERT INTO public.who_global_data VALUES (68173, 0, 14, 0, 2, 288, 172);
INSERT INTO public.who_global_data VALUES (68174, 41, 1300, 0, 56, 288, 109);
INSERT INTO public.who_global_data VALUES (68175, 95, 7345, 11, 180, 288, 200);
INSERT INTO public.who_global_data VALUES (68176, 4, 340, 0, 2, 288, 93);
INSERT INTO public.who_global_data VALUES (68177, 74, 1790, 1, 9, 288, 5);
INSERT INTO public.who_global_data VALUES (68178, 0, 712, 0, 13, 288, 214);
INSERT INTO public.who_global_data VALUES (68179, 340, 11155, 9, 237, 288, 204);
INSERT INTO public.who_global_data VALUES (68180, 0, 0, 0, 0, 288, 198);
INSERT INTO public.who_global_data VALUES (68181, 171, 4992, 3, 144, 288, 173);
INSERT INTO public.who_global_data VALUES (68182, 0, 8, 0, 0, 288, 229);
INSERT INTO public.who_global_data VALUES (68183, 0, 213, 0, 9, 288, 76);
INSERT INTO public.who_global_data VALUES (68184, 1413, 19250, 46, 530, 288, 138);
INSERT INTO public.who_global_data VALUES (68185, 271, 6981, 16, 462, 288, 98);
INSERT INTO public.who_global_data VALUES (68186, 0, 0, 0, 0, 288, 103);
INSERT INTO public.who_global_data VALUES (68187, 342, 10511, 28, 454, 288, 225);
INSERT INTO public.who_global_data VALUES (68188, 371, 22353, 35, 820, 288, 131);
INSERT INTO public.who_global_data VALUES (68189, 0, 1276, 0, 48, 288, 235);
INSERT INTO public.who_global_data VALUES (68190, 761, 8525, 0, 10, 288, 137);
INSERT INTO public.who_global_data VALUES (68191, 6, 10708, 0, 240, 288, 81);
INSERT INTO public.who_global_data VALUES (68192, 148, 2926, 4, 80, 288, 182);
INSERT INTO public.who_global_data VALUES (68193, 1, 411, 0, 0, 288, 145);
INSERT INTO public.who_global_data VALUES (68194, 386, 10096, 19, 527, 288, 26);
INSERT INTO public.who_global_data VALUES (68195, 5849, 68622, 60, 615, 288, 170);
INSERT INTO public.who_global_data VALUES (68196, 1, 154, 0, 0, 288, 191);
INSERT INTO public.who_global_data VALUES (68197, 0, 2, 0, 0, 288, 221);
INSERT INTO public.who_global_data VALUES (68198, 0, 6, 0, 0, 288, 64);
INSERT INTO public.who_global_data VALUES (68199, 0, 0, 0, 0, 288, 116);
INSERT INTO public.who_global_data VALUES (68200, 0, 15, 0, 0, 288, 128);
INSERT INTO public.who_global_data VALUES (68201, 0, 15, 0, 0, 288, 6);
INSERT INTO public.who_global_data VALUES (68202, 0, 38, 0, 2, 288, 227);
INSERT INTO public.who_global_data VALUES (68203, 0, 1, 0, 0, 288, 68);
INSERT INTO public.who_global_data VALUES (68204, 0, 13, 0, 0, 288, 184);
INSERT INTO public.who_global_data VALUES (68205, 0, 0, 0, 0, 288, 82);
INSERT INTO public.who_global_data VALUES (68206, 13, 501, 0, 40, 288, 149);
INSERT INTO public.who_global_data VALUES (68207, 1, 8, 0, 0, 288, 197);
INSERT INTO public.who_global_data VALUES (68208, 1172, 15102, 6, 127, 288, 78);
INSERT INTO public.who_global_data VALUES (68209, 37, 479, 0, 6, 288, 233);
INSERT INTO public.who_global_data VALUES (68210, 162, 7276, 5, 139, 288, 133);
INSERT INTO public.who_global_data VALUES (68211, 0, 11, 0, 0, 288, 35);
INSERT INTO public.who_global_data VALUES (68212, 3, 64, 0, 1, 288, 114);
INSERT INTO public.who_global_data VALUES (68213, 1037, 11178, 0, 12, 288, 237);
INSERT INTO public.who_global_data VALUES (68214, 0, 2, 0, 0, 288, 55);
INSERT INTO public.who_global_data VALUES (68215, 2, 73, 1, 12, 288, 176);
INSERT INTO public.who_global_data VALUES (68216, 81, 1325, 1, 15, 288, 202);
INSERT INTO public.who_global_data VALUES (68217, 7, 1374, 1, 88, 288, 155);
INSERT INTO public.who_global_data VALUES (68218, 0, 0, 0, 0, 288, 32);
INSERT INTO public.who_global_data VALUES (68219, 0, 328, 0, 16, 288, 220);
INSERT INTO public.who_global_data VALUES (68220, 318, 3953, 10, 75, 288, 30);
INSERT INTO public.who_global_data VALUES (68221, 0, 4, 0, 0, 288, 147);
INSERT INTO public.who_global_data VALUES (68222, 2774, 213024, 344, 23919, 288, 208);
INSERT INTO public.who_global_data VALUES (68223, 38, 368, 0, 7, 288, 45);
INSERT INTO public.who_global_data VALUES (68224, 12, 174, 3, 16, 288, 110);
INSERT INTO public.who_global_data VALUES (68225, 0, 10, 0, 1, 288, 88);
INSERT INTO public.who_global_data VALUES (68226, 722, 16553, 77, 2274, 288, 51);
INSERT INTO public.who_global_data VALUES (68227, 207, 28915, 31, 1472, 288, 209);
INSERT INTO public.who_global_data VALUES (68228, 0, 42, 0, 3, 288, 205);
INSERT INTO public.who_global_data VALUES (68229, 0, 0, 0, 0, 288, 18);
INSERT INTO public.who_global_data VALUES (68230, 15, 2854, 0, 50, 288, 72);
INSERT INTO public.who_global_data VALUES (68231, 5487, 140366, 682, 21802, 288, 44);
INSERT INTO public.who_global_data VALUES (68232, 1, 24, 0, 0, 288, 15);
INSERT INTO public.who_global_data VALUES (68233, 0, 88, 0, 6, 288, 25);
INSERT INTO public.who_global_data VALUES (68234, 0, 0, 0, 0, 288, 179);
INSERT INTO public.who_global_data VALUES (68235, 0, 0, 0, 0, 288, 34);
INSERT INTO public.who_global_data VALUES (68236, 0, 115, 0, 8, 288, 207);
INSERT INTO public.who_global_data VALUES (68237, 9, 918, 0, 38, 288, 166);
INSERT INTO public.who_global_data VALUES (68238, 3116, 101790, 115, 2491, 288, 126);
INSERT INTO public.who_global_data VALUES (68239, 0, 0, 0, 0, 288, 97);
INSERT INTO public.who_global_data VALUES (68240, 0, 11, 0, 1, 288, 36);
INSERT INTO public.who_global_data VALUES (68241, 0, 0, 0, 0, 288, 125);
INSERT INTO public.who_global_data VALUES (68242, 2, 63, 0, 0, 288, 124);
INSERT INTO public.who_global_data VALUES (68243, 477, 7647, 6, 193, 288, 185);
INSERT INTO public.who_global_data VALUES (68244, 525, 9281, 8, 64, 288, 194);
INSERT INTO public.who_global_data VALUES (68245, 0, 285, 0, 10, 288, 144);
INSERT INTO public.who_global_data VALUES (68246, 29127, 830053, 2390, 47432, 288, 19);
INSERT INTO public.who_global_data VALUES (68247, 0, 54, 0, 3, 288, 217);
INSERT INTO public.who_global_data VALUES (68248, 6, 549, 0, 12, 288, 148);
INSERT INTO public.who_global_data VALUES (68249, 62, 1778, 0, 7, 288, 86);
INSERT INTO public.who_global_data VALUES (68250, 0, 0, 0, 0, 288, 13);
INSERT INTO public.who_global_data VALUES (68251, 10, 298, 0, 10, 288, 157);
INSERT INTO public.who_global_data VALUES (68252, 0, 268, 0, 0, 288, 8);
INSERT INTO public.who_global_data VALUES (68253, 0, 0, 0, 0, 288, 73);
INSERT INTO public.who_global_data VALUES (68254, 0, 1, 0, 0, 288, 101);
INSERT INTO public.who_global_data VALUES (68255, 2, 76, 0, 3, 288, 165);
INSERT INTO public.who_global_data VALUES (68256, 0, 28, 0, 4, 288, 14);
INSERT INTO public.who_global_data VALUES (68257, 0, 1176, 0, 40, 289, 193);
INSERT INTO public.who_global_data VALUES (68258, 0, 596, 1, 26, 289, 113);
INSERT INTO public.who_global_data VALUES (68259, 99, 2910, 10, 402, 289, 143);
INSERT INTO public.who_global_data VALUES (68260, 0, 0, 0, 0, 289, 219);
INSERT INTO public.who_global_data VALUES (68261, 1, 724, 0, 37, 289, 186);
INSERT INTO public.who_global_data VALUES (68262, 0, 24, 0, 2, 289, 52);
INSERT INTO public.who_global_data VALUES (68263, 0, 3, 0, 0, 289, 180);
INSERT INTO public.who_global_data VALUES (68264, 1, 24, 0, 3, 289, 167);
INSERT INTO public.who_global_data VALUES (68265, 124, 3197, 7, 152, 289, 154);
INSERT INTO public.who_global_data VALUES (68266, 72, 1449, 0, 24, 289, 94);
INSERT INTO public.who_global_data VALUES (68267, 3, 100, 0, 2, 289, 66);
INSERT INTO public.who_global_data VALUES (68268, 14, 6661, 1, 75, 289, 58);
INSERT INTO public.who_global_data VALUES (68269, 91, 14924, 31, 494, 289, 163);
INSERT INTO public.who_global_data VALUES (68270, 38, 1518, 0, 20, 289, 37);
INSERT INTO public.who_global_data VALUES (68271, 1, 65, 0, 9, 289, 142);
INSERT INTO public.who_global_data VALUES (68272, 91, 2098, 1, 8, 289, 83);
INSERT INTO public.who_global_data VALUES (68273, 414, 4186, 7, 127, 289, 228);
INSERT INTO public.who_global_data VALUES (68274, 0, 75, 0, 5, 289, 188);
INSERT INTO public.who_global_data VALUES (68275, 558, 7281, 5, 60, 289, 62);
INSERT INTO public.who_global_data VALUES (68276, 777, 45813, 181, 6822, 289, 160);
INSERT INTO public.who_global_data VALUES (68277, 0, 18, 0, 2, 289, 50);
INSERT INTO public.who_global_data VALUES (68278, 0, 54, 0, 1, 289, 33);
INSERT INTO public.who_global_data VALUES (68279, 12, 98, 0, 5, 289, 183);
INSERT INTO public.who_global_data VALUES (68280, 1, 7, 0, 0, 289, 92);
INSERT INTO public.who_global_data VALUES (68281, 11, 609, 3, 37, 289, 158);
INSERT INTO public.who_global_data VALUES (68282, 0, 1, 0, 0, 289, 67);
INSERT INTO public.who_global_data VALUES (68283, 27, 1367, 2, 52, 289, 57);
INSERT INTO public.who_global_data VALUES (68284, 2, 22, 0, 1, 289, 38);
INSERT INTO public.who_global_data VALUES (68285, 2498, 43079, 166, 2741, 289, 141);
INSERT INTO public.who_global_data VALUES (68286, 0, 4, 0, 1, 289, 178);
INSERT INTO public.who_global_data VALUES (68287, 0, 138, 0, 1, 289, 108);
INSERT INTO public.who_global_data VALUES (68288, 49, 1024, 4, 49, 289, 39);
INSERT INTO public.who_global_data VALUES (68289, 19, 600, 0, 38, 289, 2);
INSERT INTO public.who_global_data VALUES (68290, 0, 11, 0, 1, 289, 195);
INSERT INTO public.who_global_data VALUES (68291, 0, 67, 0, 1, 289, 107);
INSERT INTO public.who_global_data VALUES (68292, 0, 122, 0, 0, 289, 161);
INSERT INTO public.who_global_data VALUES (68293, 0, 1163, 0, 43, 289, 212);
INSERT INTO public.who_global_data VALUES (68294, 1549, 38923, 143, 1871, 289, 181);
INSERT INTO public.who_global_data VALUES (68295, 0, 66, 0, 1, 289, 53);
INSERT INTO public.who_global_data VALUES (68296, 0, 14, 0, 0, 289, 164);
INSERT INTO public.who_global_data VALUES (68297, 0, 34, 0, 0, 289, 140);
INSERT INTO public.who_global_data VALUES (68298, 464, 11296, 13, 160, 289, 20);
INSERT INTO public.who_global_data VALUES (68299, 15, 84303, 0, 4642, 289, 112);
INSERT INTO public.who_global_data VALUES (68300, 172, 4149, 7, 196, 289, 111);
INSERT INTO public.who_global_data VALUES (68301, 0, 0, 0, 0, 289, 71);
INSERT INTO public.who_global_data VALUES (68302, 21, 186, 0, 6, 289, 218);
INSERT INTO public.who_global_data VALUES (68303, 0, 0, 0, 0, 289, 43);
INSERT INTO public.who_global_data VALUES (68304, 7, 669, 0, 6, 289, 49);
INSERT INTO public.who_global_data VALUES (68305, 36, 952, 1, 14, 289, 1);
INSERT INTO public.who_global_data VALUES (68306, 42, 1950, 0, 48, 289, 48);
INSERT INTO public.who_global_data VALUES (68307, 52, 1189, 2, 40, 289, 232);
INSERT INTO public.who_global_data VALUES (68308, 0, 14, 0, 1, 289, 175);
INSERT INTO public.who_global_data VALUES (68309, 6, 790, 2, 14, 289, 21);
INSERT INTO public.who_global_data VALUES (68310, 95, 7136, 9, 210, 289, 156);
INSERT INTO public.who_global_data VALUES (68311, 0, 0, 0, 0, 289, 95);
INSERT INTO public.who_global_data VALUES (68312, 0, 359, 0, 25, 289, 177);
INSERT INTO public.who_global_data VALUES (68313, 217, 7912, 14, 384, 289, 210);
INSERT INTO public.who_global_data VALUES (68314, 12, 986, 0, 2, 289, 120);
INSERT INTO public.who_global_data VALUES (68315, 0, 16, 0, 0, 289, 135);
INSERT INTO public.who_global_data VALUES (68316, 256, 5300, 15, 260, 289, 206);
INSERT INTO public.who_global_data VALUES (68317, 452, 10850, 17, 537, 289, 189);
INSERT INTO public.who_global_data VALUES (68318, 169, 3659, 12, 276, 289, 129);
INSERT INTO public.who_global_data VALUES (68319, 12, 237, 0, 7, 289, 121);
INSERT INTO public.who_global_data VALUES (68320, 5, 84, 1, 1, 289, 59);
INSERT INTO public.who_global_data VALUES (68321, 0, 39, 0, 0, 289, 96);
INSERT INTO public.who_global_data VALUES (68322, 7, 1559, 1, 44, 289, 41);
INSERT INTO public.who_global_data VALUES (68323, 7, 31, 0, 1, 289, 216);
INSERT INTO public.who_global_data VALUES (68324, 2, 116, 0, 3, 289, 236);
INSERT INTO public.who_global_data VALUES (68325, 1, 12, 0, 0, 289, 150);
INSERT INTO public.who_global_data VALUES (68326, 0, 185, 0, 0, 289, 61);
INSERT INTO public.who_global_data VALUES (68327, 0, 18, 0, 0, 289, 7);
INSERT INTO public.who_global_data VALUES (68328, 115, 4129, 8, 149, 289, 169);
INSERT INTO public.who_global_data VALUES (68329, 1810, 117961, 544, 21309, 289, 28);
INSERT INTO public.who_global_data VALUES (68330, 0, 97, 0, 1, 289, 85);
INSERT INTO public.who_global_data VALUES (68331, 0, 57, 0, 0, 289, 211);
INSERT INTO public.who_global_data VALUES (68332, 10, 166, 0, 1, 289, 60);
INSERT INTO public.who_global_data VALUES (68333, 0, 10, 0, 1, 289, 3);
INSERT INTO public.who_global_data VALUES (68334, 9, 420, 0, 5, 289, 11);
INSERT INTO public.who_global_data VALUES (68335, 2352, 148046, 215, 5094, 289, 89);
INSERT INTO public.who_global_data VALUES (68336, 112, 1154, 0, 9, 289, 24);
INSERT INTO public.who_global_data VALUES (68337, 0, 133, 0, 0, 289, 162);
INSERT INTO public.who_global_data VALUES (68338, 7, 2408, 0, 121, 289, 100);
INSERT INTO public.who_global_data VALUES (68339, 0, 11, 0, 0, 289, 47);
INSERT INTO public.who_global_data VALUES (68340, 0, 14, 0, 0, 289, 29);
INSERT INTO public.who_global_data VALUES (68341, 0, 148, 0, 10, 289, 40);
INSERT INTO public.who_global_data VALUES (68342, 2, 135, 0, 5, 289, 222);
INSERT INTO public.who_global_data VALUES (68343, 22, 316, 0, 8, 289, 132);
INSERT INTO public.who_global_data VALUES (68344, 2, 241, 0, 10, 289, 130);
INSERT INTO public.who_global_data VALUES (68345, 73, 761, 0, 6, 289, 234);
INSERT INTO public.who_global_data VALUES (68346, 0, 50, 0, 0, 289, 23);
INSERT INTO public.who_global_data VALUES (68347, 1, 67, 0, 7, 289, 192);
INSERT INTO public.who_global_data VALUES (68348, 1, 58, 1, 4, 289, 69);
INSERT INTO public.who_global_data VALUES (68349, 0, 9, 0, 0, 289, 187);
INSERT INTO public.who_global_data VALUES (68350, 16, 510, 0, 46, 289, 230);
INSERT INTO public.who_global_data VALUES (68351, 116, 2284, 0, 225, 289, 77);
INSERT INTO public.who_global_data VALUES (68352, 7, 1785, 0, 10, 289, 9);
INSERT INTO public.who_global_data VALUES (68353, 1409, 21393, 41, 681, 289, 74);
INSERT INTO public.who_global_data VALUES (68354, 357, 7775, 12, 647, 289, 224);
INSERT INTO public.who_global_data VALUES (68355, 1030, 87026, 90, 5481, 289, 199);
INSERT INTO public.who_global_data VALUES (68356, 75, 1677, 0, 83, 289, 190);
INSERT INTO public.who_global_data VALUES (68357, 631, 16671, 39, 769, 289, 12);
INSERT INTO public.who_global_data VALUES (68358, 0, 307, 0, 10, 289, 104);
INSERT INTO public.who_global_data VALUES (68359, 282, 14400, 9, 189, 289, 153);
INSERT INTO public.who_global_data VALUES (68360, 3370, 187327, 437, 25085, 289, 91);
INSERT INTO public.who_global_data VALUES (68361, 10, 233, 0, 6, 289, 215);
INSERT INTO public.who_global_data VALUES (68362, 423, 11919, 10, 287, 289, 84);
INSERT INTO public.who_global_data VALUES (68363, 5, 255, 0, 14, 289, 231);
INSERT INTO public.who_global_data VALUES (68364, 7, 435, 0, 7, 289, 196);
INSERT INTO public.who_global_data VALUES (68365, 0, 2025, 0, 19, 289, 105);
INSERT INTO public.who_global_data VALUES (68366, 7, 303, 0, 14, 289, 122);
INSERT INTO public.who_global_data VALUES (68367, 0, 0, 0, 0, 289, 159);
INSERT INTO public.who_global_data VALUES (68368, 26, 630, 1, 15, 289, 75);
INSERT INTO public.who_global_data VALUES (68369, 151, 2399, 1, 14, 289, 27);
INSERT INTO public.who_global_data VALUES (68370, 19, 631, 1, 8, 289, 54);
INSERT INTO public.who_global_data VALUES (68371, 0, 19, 0, 0, 289, 226);
INSERT INTO public.who_global_data VALUES (68372, 13, 761, 2, 11, 289, 79);
INSERT INTO public.who_global_data VALUES (68373, 6, 688, 0, 22, 289, 56);
INSERT INTO public.who_global_data VALUES (68374, 0, 0, 0, 0, 289, 117);
INSERT INTO public.who_global_data VALUES (68375, 0, 101, 0, 8, 289, 152);
INSERT INTO public.who_global_data VALUES (68376, 1, 60, 0, 1, 289, 16);
INSERT INTO public.who_global_data VALUES (68377, 0, 82, 0, 1, 289, 10);
INSERT INTO public.who_global_data VALUES (68378, 22, 1272, 0, 39, 289, 201);
INSERT INTO public.who_global_data VALUES (68379, 36, 3654, 2, 80, 289, 174);
INSERT INTO public.who_global_data VALUES (68380, 0, 121, 0, 0, 289, 119);
INSERT INTO public.who_global_data VALUES (68381, 5, 23, 1, 3, 289, 168);
INSERT INTO public.who_global_data VALUES (68382, 50, 5532, 1, 93, 289, 99);
INSERT INTO public.who_global_data VALUES (68383, 9, 94, 0, 0, 289, 171);
INSERT INTO public.who_global_data VALUES (68384, 35, 293, 3, 17, 289, 87);
INSERT INTO public.who_global_data VALUES (68385, 0, 444, 0, 3, 289, 123);
INSERT INTO public.who_global_data VALUES (68386, 0, 0, 0, 0, 289, 151);
INSERT INTO public.who_global_data VALUES (68387, 1, 164, 0, 14, 289, 213);
INSERT INTO public.who_global_data VALUES (68388, 0, 7, 0, 1, 289, 118);
INSERT INTO public.who_global_data VALUES (68389, 1, 329, 0, 9, 289, 134);
INSERT INTO public.who_global_data VALUES (68390, 15, 326, 0, 4, 289, 65);
INSERT INTO public.who_global_data VALUES (68391, 729, 9501, 145, 857, 289, 102);
INSERT INTO public.who_global_data VALUES (68392, 0, 0, 0, 0, 289, 223);
INSERT INTO public.who_global_data VALUES (68393, 0, 65, 0, 1, 289, 4);
INSERT INTO public.who_global_data VALUES (68394, 0, 35, 0, 0, 289, 146);
INSERT INTO public.who_global_data VALUES (68395, 3, 319, 0, 5, 289, 31);
INSERT INTO public.who_global_data VALUES (68396, 0, 11, 0, 0, 289, 127);
INSERT INTO public.who_global_data VALUES (68397, 160, 3537, 2, 151, 289, 22);
INSERT INTO public.who_global_data VALUES (68398, 2, 41, 0, 0, 289, 115);
INSERT INTO public.who_global_data VALUES (68399, 6, 127, 0, 5, 289, 106);
INSERT INTO public.who_global_data VALUES (68400, 0, 16, 0, 0, 289, 90);
INSERT INTO public.who_global_data VALUES (68401, 0, 0, 0, 0, 289, 70);
INSERT INTO public.who_global_data VALUES (68402, 3, 45, 0, 0, 289, 46);
INSERT INTO public.who_global_data VALUES (68403, 708, 34595, 134, 4003, 289, 139);
INSERT INTO public.who_global_data VALUES (68404, 0, 18, 0, 0, 289, 42);
INSERT INTO public.who_global_data VALUES (68405, 0, 1112, 2, 16, 289, 80);
INSERT INTO public.who_global_data VALUES (68406, 0, 10, 0, 2, 289, 203);
INSERT INTO public.who_global_data VALUES (68407, 5, 662, 2, 22, 289, 136);
INSERT INTO public.who_global_data VALUES (68408, 0, 541, 0, 19, 289, 63);
INSERT INTO public.who_global_data VALUES (68409, 0, 0, 0, 0, 289, 17);
INSERT INTO public.who_global_data VALUES (68410, 0, 14, 0, 2, 289, 172);
INSERT INTO public.who_global_data VALUES (68411, 28, 1259, 1, 56, 289, 109);
INSERT INTO public.who_global_data VALUES (68412, 84, 7250, 6, 169, 289, 200);
INSERT INTO public.who_global_data VALUES (68413, 1, 336, 0, 2, 289, 93);
INSERT INTO public.who_global_data VALUES (68414, 102, 1716, 0, 8, 289, 5);
INSERT INTO public.who_global_data VALUES (68415, 0, 712, 0, 13, 289, 214);
INSERT INTO public.who_global_data VALUES (68416, 1066, 10815, 19, 228, 289, 204);
INSERT INTO public.who_global_data VALUES (68417, 0, 0, 0, 0, 289, 198);
INSERT INTO public.who_global_data VALUES (68418, 163, 4821, 5, 141, 289, 173);
INSERT INTO public.who_global_data VALUES (68419, 1, 8, 0, 0, 289, 229);
INSERT INTO public.who_global_data VALUES (68420, 5, 213, 1, 9, 289, 76);
INSERT INTO public.who_global_data VALUES (68421, 1512, 17837, 39, 484, 289, 138);
INSERT INTO public.who_global_data VALUES (68422, 111, 6710, 9, 446, 289, 98);
INSERT INTO public.who_global_data VALUES (68423, 0, 0, 0, 0, 289, 103);
INSERT INTO public.who_global_data VALUES (68424, 313, 10169, 25, 426, 289, 225);
INSERT INTO public.who_global_data VALUES (68425, 603, 21982, 23, 785, 289, 131);
INSERT INTO public.who_global_data VALUES (68426, 0, 1276, 0, 48, 289, 235);
INSERT INTO public.who_global_data VALUES (68427, 623, 7764, 0, 10, 289, 137);
INSERT INTO public.who_global_data VALUES (68428, 8, 10702, 2, 240, 289, 81);
INSERT INTO public.who_global_data VALUES (68429, 137, 2778, 3, 76, 289, 182);
INSERT INTO public.who_global_data VALUES (68430, 0, 410, 0, 0, 289, 145);
INSERT INTO public.who_global_data VALUES (68431, 468, 9710, 25, 508, 289, 26);
INSERT INTO public.who_global_data VALUES (68432, 4774, 62773, 42, 555, 289, 170);
INSERT INTO public.who_global_data VALUES (68433, 3, 153, 0, 0, 289, 191);
INSERT INTO public.who_global_data VALUES (68434, 0, 2, 0, 0, 289, 221);
INSERT INTO public.who_global_data VALUES (68435, 0, 6, 0, 0, 289, 64);
INSERT INTO public.who_global_data VALUES (68436, 0, 0, 0, 0, 289, 116);
INSERT INTO public.who_global_data VALUES (68437, 0, 15, 0, 0, 289, 128);
INSERT INTO public.who_global_data VALUES (68438, 0, 15, 0, 0, 289, 6);
INSERT INTO public.who_global_data VALUES (68439, 1, 38, 0, 2, 289, 227);
INSERT INTO public.who_global_data VALUES (68440, 0, 1, 0, 0, 289, 68);
INSERT INTO public.who_global_data VALUES (68441, 1, 13, 0, 0, 289, 184);
INSERT INTO public.who_global_data VALUES (68442, 0, 0, 0, 0, 289, 82);
INSERT INTO public.who_global_data VALUES (68443, 12, 488, 0, 40, 289, 149);
INSERT INTO public.who_global_data VALUES (68444, 3, 7, 0, 0, 289, 197);
INSERT INTO public.who_global_data VALUES (68445, 1158, 13930, 7, 121, 289, 78);
INSERT INTO public.who_global_data VALUES (68446, 30, 442, 1, 6, 289, 233);
INSERT INTO public.who_global_data VALUES (68447, 224, 7114, 4, 134, 289, 133);
INSERT INTO public.who_global_data VALUES (68448, 0, 11, 0, 0, 289, 35);
INSERT INTO public.who_global_data VALUES (68449, 11, 61, 1, 1, 289, 114);
INSERT INTO public.who_global_data VALUES (68450, 1016, 10141, 1, 12, 289, 237);
INSERT INTO public.who_global_data VALUES (68451, 0, 2, 0, 0, 289, 55);
INSERT INTO public.who_global_data VALUES (68452, 3, 71, 1, 11, 289, 176);
INSERT INTO public.who_global_data VALUES (68453, 45, 1244, 0, 14, 289, 202);
INSERT INTO public.who_global_data VALUES (68454, 13, 1367, 0, 87, 289, 155);
INSERT INTO public.who_global_data VALUES (68455, 0, 0, 0, 0, 289, 32);
INSERT INTO public.who_global_data VALUES (68456, 42, 328, 2, 16, 289, 220);
INSERT INTO public.who_global_data VALUES (68457, 170, 3635, 7, 65, 289, 30);
INSERT INTO public.who_global_data VALUES (68458, 0, 4, 0, 0, 289, 147);
INSERT INTO public.who_global_data VALUES (68459, 2732, 210250, 427, 23575, 289, 208);
INSERT INTO public.who_global_data VALUES (68460, 20, 330, 0, 7, 289, 45);
INSERT INTO public.who_global_data VALUES (68461, 22, 162, 0, 13, 289, 110);
INSERT INTO public.who_global_data VALUES (68462, 0, 10, 0, 1, 289, 88);
INSERT INTO public.who_global_data VALUES (68463, 707, 15831, 62, 2197, 289, 51);
INSERT INTO public.who_global_data VALUES (68464, 155, 28708, 27, 1441, 289, 209);
INSERT INTO public.who_global_data VALUES (68465, 0, 42, 0, 3, 289, 205);
INSERT INTO public.who_global_data VALUES (68466, 0, 0, 0, 0, 289, 18);
INSERT INTO public.who_global_data VALUES (68467, 13, 2839, 1, 50, 289, 72);
INSERT INTO public.who_global_data VALUES (68468, 4760, 134879, 847, 21120, 289, 44);
INSERT INTO public.who_global_data VALUES (68469, 0, 23, 0, 0, 289, 15);
INSERT INTO public.who_global_data VALUES (68470, 2, 88, 0, 6, 289, 25);
INSERT INTO public.who_global_data VALUES (68471, 0, 0, 0, 0, 289, 179);
INSERT INTO public.who_global_data VALUES (68472, 0, 0, 0, 0, 289, 34);
INSERT INTO public.who_global_data VALUES (68473, 1, 115, 0, 8, 289, 207);
INSERT INTO public.who_global_data VALUES (68474, 8, 909, 0, 38, 289, 166);
INSERT INTO public.who_global_data VALUES (68475, 3083, 98674, 117, 2376, 289, 126);
INSERT INTO public.who_global_data VALUES (68476, 0, 0, 0, 0, 289, 97);
INSERT INTO public.who_global_data VALUES (68477, 0, 11, 0, 1, 289, 36);
INSERT INTO public.who_global_data VALUES (68478, 0, 0, 0, 0, 289, 125);
INSERT INTO public.who_global_data VALUES (68479, 5, 61, 0, 0, 289, 124);
INSERT INTO public.who_global_data VALUES (68480, 578, 7170, 13, 187, 289, 185);
INSERT INTO public.who_global_data VALUES (68481, 518, 8756, 4, 56, 289, 194);
INSERT INTO public.who_global_data VALUES (68482, 30, 285, 0, 10, 289, 144);
INSERT INTO public.who_global_data VALUES (68483, 24019, 800926, 2575, 45042, 289, 19);
INSERT INTO public.who_global_data VALUES (68484, 0, 54, 0, 3, 289, 217);
INSERT INTO public.who_global_data VALUES (68485, 8, 543, 2, 12, 289, 148);
INSERT INTO public.who_global_data VALUES (68486, 59, 1716, 1, 7, 289, 86);
INSERT INTO public.who_global_data VALUES (68487, 0, 0, 0, 0, 289, 13);
INSERT INTO public.who_global_data VALUES (68488, 3, 288, 0, 10, 289, 157);
INSERT INTO public.who_global_data VALUES (68489, 0, 268, 0, 0, 289, 8);
INSERT INTO public.who_global_data VALUES (68490, 0, 0, 0, 0, 289, 73);
INSERT INTO public.who_global_data VALUES (68491, 0, 1, 0, 0, 289, 101);
INSERT INTO public.who_global_data VALUES (68492, 4, 74, 0, 3, 289, 165);
INSERT INTO public.who_global_data VALUES (68493, 0, 28, 1, 4, 289, 14);
INSERT INTO public.who_global_data VALUES (68494, 84, 1176, 4, 40, 290, 193);
INSERT INTO public.who_global_data VALUES (68495, 25, 596, 0, 25, 290, 113);
INSERT INTO public.who_global_data VALUES (68496, 93, 2811, 8, 392, 290, 143);
INSERT INTO public.who_global_data VALUES (68497, 0, 0, 0, 0, 290, 219);
INSERT INTO public.who_global_data VALUES (68498, 5, 723, 1, 37, 290, 186);
INSERT INTO public.who_global_data VALUES (68499, 0, 24, 0, 2, 290, 52);
INSERT INTO public.who_global_data VALUES (68500, 0, 3, 0, 0, 290, 180);
INSERT INTO public.who_global_data VALUES (68501, 0, 23, 0, 3, 290, 167);
INSERT INTO public.who_global_data VALUES (68502, 113, 3073, 9, 145, 290, 154);
INSERT INTO public.who_global_data VALUES (68503, 62, 1377, 2, 24, 290, 94);
INSERT INTO public.who_global_data VALUES (68504, 0, 97, 0, 2, 290, 66);
INSERT INTO public.who_global_data VALUES (68505, 22, 6647, 3, 74, 290, 58);
INSERT INTO public.who_global_data VALUES (68506, 50, 14833, 1, 463, 290, 163);
INSERT INTO public.who_global_data VALUES (68507, 44, 1480, 1, 20, 290, 37);
INSERT INTO public.who_global_data VALUES (68508, 4, 64, 0, 9, 290, 142);
INSERT INTO public.who_global_data VALUES (68509, 55, 2007, 0, 7, 290, 83);
INSERT INTO public.who_global_data VALUES (68510, 390, 3772, 10, 120, 290, 228);
INSERT INTO public.who_global_data VALUES (68511, 0, 75, 0, 5, 290, 188);
INSERT INTO public.who_global_data VALUES (68512, 459, 6723, 4, 55, 290, 62);
INSERT INTO public.who_global_data VALUES (68513, 1270, 45036, 203, 6641, 290, 160);
INSERT INTO public.who_global_data VALUES (68514, 0, 18, 0, 2, 290, 50);
INSERT INTO public.who_global_data VALUES (68515, 0, 54, 0, 1, 290, 33);
INSERT INTO public.who_global_data VALUES (68516, 0, 86, 0, 5, 290, 183);
INSERT INTO public.who_global_data VALUES (68517, 0, 6, 0, 0, 290, 92);
INSERT INTO public.who_global_data VALUES (68518, 34, 598, 1, 34, 290, 158);
INSERT INTO public.who_global_data VALUES (68519, 0, 1, 0, 0, 290, 67);
INSERT INTO public.who_global_data VALUES (68520, 40, 1340, 1, 50, 290, 57);
INSERT INTO public.who_global_data VALUES (68521, 0, 20, 0, 1, 290, 38);
INSERT INTO public.who_global_data VALUES (68522, 1927, 40581, 113, 2575, 290, 141);
INSERT INTO public.who_global_data VALUES (68523, 0, 4, 0, 1, 290, 178);
INSERT INTO public.who_global_data VALUES (68524, 0, 138, 0, 1, 290, 108);
INSERT INTO public.who_global_data VALUES (68525, 46, 975, 2, 45, 290, 39);
INSERT INTO public.who_global_data VALUES (68526, 5, 581, 2, 38, 290, 2);
INSERT INTO public.who_global_data VALUES (68527, 5, 11, 0, 1, 290, 195);
INSERT INTO public.who_global_data VALUES (68528, 12, 67, 0, 1, 290, 107);
INSERT INTO public.who_global_data VALUES (68529, 0, 122, 0, 0, 290, 161);
INSERT INTO public.who_global_data VALUES (68530, 0, 1163, 1, 43, 290, 212);
INSERT INTO public.who_global_data VALUES (68531, 1991, 37374, 117, 1728, 290, 181);
INSERT INTO public.who_global_data VALUES (68532, 5, 66, 0, 1, 290, 53);
INSERT INTO public.who_global_data VALUES (68533, 2, 14, 0, 0, 290, 164);
INSERT INTO public.who_global_data VALUES (68534, 1, 34, 0, 0, 290, 140);
INSERT INTO public.who_global_data VALUES (68535, 325, 10832, 8, 147, 290, 20);
INSERT INTO public.who_global_data VALUES (68536, 35, 84288, 0, 4642, 290, 112);
INSERT INTO public.who_global_data VALUES (68537, 185, 3977, 10, 189, 290, 111);
INSERT INTO public.who_global_data VALUES (68538, 0, 0, 0, 0, 290, 71);
INSERT INTO public.who_global_data VALUES (68539, 5, 165, 0, 6, 290, 218);
INSERT INTO public.who_global_data VALUES (68540, 0, 0, 0, 0, 290, 43);
INSERT INTO public.who_global_data VALUES (68541, 2, 662, 1, 6, 290, 49);
INSERT INTO public.who_global_data VALUES (68542, 37, 916, 3, 13, 290, 1);
INSERT INTO public.who_global_data VALUES (68543, 27, 1908, 1, 48, 290, 48);
INSERT INTO public.who_global_data VALUES (68544, 50, 1137, 2, 38, 290, 232);
INSERT INTO public.who_global_data VALUES (68545, 0, 14, 0, 1, 290, 175);
INSERT INTO public.who_global_data VALUES (68546, 12, 784, 0, 12, 290, 21);
INSERT INTO public.who_global_data VALUES (68547, 127, 7041, 5, 201, 290, 156);
INSERT INTO public.who_global_data VALUES (68548, 0, 0, 0, 0, 290, 95);
INSERT INTO public.who_global_data VALUES (68549, 9, 359, 0, 25, 290, 177);
INSERT INTO public.who_global_data VALUES (68550, 180, 7695, 6, 370, 290, 210);
INSERT INTO public.who_global_data VALUES (68551, 29, 974, 0, 2, 290, 120);
INSERT INTO public.who_global_data VALUES (68552, 0, 16, 0, 0, 290, 135);
INSERT INTO public.who_global_data VALUES (68553, 80, 5044, 10, 245, 290, 206);
INSERT INTO public.who_global_data VALUES (68554, 270, 10398, 13, 520, 290, 189);
INSERT INTO public.who_global_data VALUES (68555, 157, 3490, 14, 264, 290, 129);
INSERT INTO public.who_global_data VALUES (68556, 7, 225, 0, 7, 290, 121);
INSERT INTO public.who_global_data VALUES (68557, 0, 79, 0, 0, 290, 59);
INSERT INTO public.who_global_data VALUES (68558, 0, 39, 0, 0, 290, 96);
INSERT INTO public.who_global_data VALUES (68559, 17, 1552, 3, 43, 290, 41);
INSERT INTO public.who_global_data VALUES (68560, 0, 24, 0, 1, 290, 216);
INSERT INTO public.who_global_data VALUES (68561, 3, 114, 0, 3, 290, 236);
INSERT INTO public.who_global_data VALUES (68562, 0, 11, 0, 0, 290, 150);
INSERT INTO public.who_global_data VALUES (68563, 0, 185, 0, 0, 290, 61);
INSERT INTO public.who_global_data VALUES (68564, 0, 18, 0, 0, 290, 7);
INSERT INTO public.who_global_data VALUES (68565, 146, 4014, 43, 141, 290, 169);
INSERT INTO public.who_global_data VALUES (68566, 2638, 116151, 531, 20765, 290, 28);
INSERT INTO public.who_global_data VALUES (68567, 0, 97, 0, 1, 290, 85);
INSERT INTO public.who_global_data VALUES (68568, 1, 57, 0, 0, 290, 211);
INSERT INTO public.who_global_data VALUES (68569, 36, 156, 0, 1, 290, 60);
INSERT INTO public.who_global_data VALUES (68570, 0, 10, 0, 1, 290, 3);
INSERT INTO public.who_global_data VALUES (68571, 3, 411, 1, 5, 290, 11);
INSERT INTO public.who_global_data VALUES (68572, 2237, 145694, 281, 4879, 290, 89);
INSERT INTO public.who_global_data VALUES (68573, 0, 1042, 0, 9, 290, 24);
INSERT INTO public.who_global_data VALUES (68574, 0, 133, 0, 0, 290, 162);
INSERT INTO public.who_global_data VALUES (68575, 156, 2401, 5, 121, 290, 100);
INSERT INTO public.who_global_data VALUES (68576, 0, 11, 0, 0, 290, 47);
INSERT INTO public.who_global_data VALUES (68577, 1, 14, 0, 0, 290, 29);
INSERT INTO public.who_global_data VALUES (68578, 0, 148, 0, 10, 290, 40);
INSERT INTO public.who_global_data VALUES (68579, 0, 133, 0, 5, 290, 222);
INSERT INTO public.who_global_data VALUES (68580, 5, 294, 1, 8, 290, 132);
INSERT INTO public.who_global_data VALUES (68581, 0, 239, 1, 10, 290, 130);
INSERT INTO public.who_global_data VALUES (68582, 66, 688, 1, 6, 290, 234);
INSERT INTO public.who_global_data VALUES (68583, 0, 50, 0, 0, 290, 23);
INSERT INTO public.who_global_data VALUES (68584, 1, 66, 0, 7, 290, 192);
INSERT INTO public.who_global_data VALUES (68585, 10, 57, 0, 3, 290, 69);
INSERT INTO public.who_global_data VALUES (68586, 0, 9, 0, 0, 290, 187);
INSERT INTO public.who_global_data VALUES (68587, 17, 494, 0, 46, 290, 230);
INSERT INTO public.who_global_data VALUES (68588, 70, 2168, 12, 225, 290, 77);
INSERT INTO public.who_global_data VALUES (68589, 5, 1778, 0, 10, 290, 9);
INSERT INTO public.who_global_data VALUES (68590, 1383, 19984, 50, 640, 290, 74);
INSERT INTO public.who_global_data VALUES (68591, 283, 7418, 19, 635, 290, 224);
INSERT INTO public.who_global_data VALUES (68592, 1194, 85996, 94, 5391, 290, 199);
INSERT INTO public.who_global_data VALUES (68593, 0, 1602, 0, 83, 290, 190);
INSERT INTO public.who_global_data VALUES (68594, 388, 16040, 43, 730, 290, 12);
INSERT INTO public.who_global_data VALUES (68595, 10, 307, 6, 10, 290, 104);
INSERT INTO public.who_global_data VALUES (68596, 299, 14118, 6, 180, 290, 153);
INSERT INTO public.who_global_data VALUES (68597, 2729, 183957, 534, 24648, 290, 91);
INSERT INTO public.who_global_data VALUES (68598, 27, 223, 1, 6, 290, 215);
INSERT INTO public.who_global_data VALUES (68599, 377, 11496, 91, 277, 290, 84);
INSERT INTO public.who_global_data VALUES (68600, 1, 250, 2, 14, 290, 231);
INSERT INTO public.who_global_data VALUES (68601, 3, 428, 0, 7, 290, 196);
INSERT INTO public.who_global_data VALUES (68602, 30, 2025, 0, 19, 290, 105);
INSERT INTO public.who_global_data VALUES (68603, 15, 296, 0, 14, 290, 122);
INSERT INTO public.who_global_data VALUES (68604, 0, 0, 0, 0, 290, 159);
INSERT INTO public.who_global_data VALUES (68605, 32, 604, 0, 14, 290, 75);
INSERT INTO public.who_global_data VALUES (68606, 168, 2248, 2, 13, 290, 27);
INSERT INTO public.who_global_data VALUES (68607, 22, 612, 0, 7, 290, 54);
INSERT INTO public.who_global_data VALUES (68608, 0, 19, 0, 0, 290, 226);
INSERT INTO public.who_global_data VALUES (68609, 9, 748, 4, 9, 290, 79);
INSERT INTO public.who_global_data VALUES (68610, 5, 682, 1, 22, 290, 56);
INSERT INTO public.who_global_data VALUES (68611, 0, 0, 0, 0, 290, 117);
INSERT INTO public.who_global_data VALUES (68612, 2, 101, 0, 8, 290, 152);
INSERT INTO public.who_global_data VALUES (68613, 8, 59, 0, 1, 290, 16);
INSERT INTO public.who_global_data VALUES (68614, 0, 82, 0, 1, 290, 10);
INSERT INTO public.who_global_data VALUES (68615, 24, 1250, 1, 39, 290, 201);
INSERT INTO public.who_global_data VALUES (68616, 60, 3618, 3, 78, 290, 174);
INSERT INTO public.who_global_data VALUES (68617, 0, 121, 0, 0, 290, 119);
INSERT INTO public.who_global_data VALUES (68618, 1, 18, 0, 2, 290, 168);
INSERT INTO public.who_global_data VALUES (68619, 58, 5482, 3, 92, 290, 99);
INSERT INTO public.who_global_data VALUES (68620, 2, 85, 0, 0, 290, 171);
INSERT INTO public.who_global_data VALUES (68621, 12, 258, 0, 14, 290, 87);
INSERT INTO public.who_global_data VALUES (68622, 1, 444, 0, 3, 290, 123);
INSERT INTO public.who_global_data VALUES (68623, 0, 0, 0, 0, 290, 151);
INSERT INTO public.who_global_data VALUES (68624, 0, 163, 0, 14, 290, 213);
INSERT INTO public.who_global_data VALUES (68625, 0, 7, 0, 1, 290, 118);
INSERT INTO public.who_global_data VALUES (68626, 0, 328, 0, 9, 290, 134);
INSERT INTO public.who_global_data VALUES (68627, 27, 311, 0, 4, 290, 65);
INSERT INTO public.who_global_data VALUES (68628, 511, 8772, 26, 712, 290, 102);
INSERT INTO public.who_global_data VALUES (68629, 0, 0, 0, 0, 290, 223);
INSERT INTO public.who_global_data VALUES (68630, 0, 65, 0, 1, 290, 4);
INSERT INTO public.who_global_data VALUES (68631, 1, 35, 0, 0, 290, 146);
INSERT INTO public.who_global_data VALUES (68632, 2, 316, 0, 5, 290, 31);
INSERT INTO public.who_global_data VALUES (68633, 0, 11, 0, 0, 290, 127);
INSERT INTO public.who_global_data VALUES (68634, 191, 3377, 5, 149, 290, 22);
INSERT INTO public.who_global_data VALUES (68635, 4, 39, 0, 0, 290, 115);
INSERT INTO public.who_global_data VALUES (68636, 2, 121, 0, 5, 290, 106);
INSERT INTO public.who_global_data VALUES (68637, 0, 16, 0, 0, 290, 90);
INSERT INTO public.who_global_data VALUES (68638, 0, 0, 0, 0, 290, 70);
INSERT INTO public.who_global_data VALUES (68639, 10, 42, 0, 0, 290, 46);
INSERT INTO public.who_global_data VALUES (68640, 716, 33887, 163, 3869, 290, 139);
INSERT INTO public.who_global_data VALUES (68641, 0, 18, 0, 0, 290, 42);
INSERT INTO public.who_global_data VALUES (68642, 5, 1112, 1, 14, 290, 80);
INSERT INTO public.who_global_data VALUES (68643, 1, 10, 0, 2, 290, 203);
INSERT INTO public.who_global_data VALUES (68644, 2, 657, 0, 20, 290, 136);
INSERT INTO public.who_global_data VALUES (68645, 0, 541, 0, 19, 290, 63);
INSERT INTO public.who_global_data VALUES (68646, 0, 0, 0, 0, 290, 17);
INSERT INTO public.who_global_data VALUES (68647, 0, 14, 0, 2, 290, 172);
INSERT INTO public.who_global_data VALUES (68648, 6, 1231, 1, 55, 290, 109);
INSERT INTO public.who_global_data VALUES (68649, 53, 7166, 9, 163, 290, 200);
INSERT INTO public.who_global_data VALUES (68650, 6, 335, 0, 2, 290, 93);
INSERT INTO public.who_global_data VALUES (68651, 106, 1614, 0, 8, 290, 5);
INSERT INTO public.who_global_data VALUES (68652, 0, 712, 0, 13, 290, 214);
INSERT INTO public.who_global_data VALUES (68653, 244, 9749, 12, 209, 290, 204);
INSERT INTO public.who_global_data VALUES (68654, 0, 0, 0, 0, 290, 198);
INSERT INTO public.who_global_data VALUES (68655, 191, 4658, 10, 136, 290, 173);
INSERT INTO public.who_global_data VALUES (68656, 0, 7, 0, 0, 290, 229);
INSERT INTO public.who_global_data VALUES (68657, 0, 208, 0, 8, 290, 76);
INSERT INTO public.who_global_data VALUES (68658, 697, 16325, 45, 445, 290, 138);
INSERT INTO public.who_global_data VALUES (68659, 140, 6599, 9, 437, 290, 98);
INSERT INTO public.who_global_data VALUES (68660, 0, 0, 0, 0, 290, 103);
INSERT INTO public.who_global_data VALUES (68661, 263, 9856, 21, 401, 290, 225);
INSERT INTO public.who_global_data VALUES (68662, 516, 21379, 27, 762, 290, 131);
INSERT INTO public.who_global_data VALUES (68663, 24, 1276, 0, 48, 290, 235);
INSERT INTO public.who_global_data VALUES (68664, 608, 7141, 1, 10, 290, 137);
INSERT INTO public.who_global_data VALUES (68665, 11, 10694, 1, 238, 290, 81);
INSERT INTO public.who_global_data VALUES (68666, 93, 2641, 3, 73, 290, 182);
INSERT INTO public.who_global_data VALUES (68667, 2, 410, 0, 0, 290, 145);
INSERT INTO public.who_global_data VALUES (68668, 306, 9242, 32, 483, 290, 26);
INSERT INTO public.who_global_data VALUES (68669, 5236, 57999, 57, 513, 290, 170);
INSERT INTO public.who_global_data VALUES (68670, 3, 150, 0, 0, 290, 191);
INSERT INTO public.who_global_data VALUES (68671, 0, 2, 0, 0, 290, 221);
INSERT INTO public.who_global_data VALUES (68672, 0, 6, 0, 0, 290, 64);
INSERT INTO public.who_global_data VALUES (68673, 0, 0, 0, 0, 290, 116);
INSERT INTO public.who_global_data VALUES (68674, 0, 15, 0, 0, 290, 128);
INSERT INTO public.who_global_data VALUES (68675, 0, 15, 0, 0, 290, 6);
INSERT INTO public.who_global_data VALUES (68676, 0, 37, 0, 2, 290, 227);
INSERT INTO public.who_global_data VALUES (68677, 0, 1, 0, 0, 290, 68);
INSERT INTO public.who_global_data VALUES (68678, 0, 12, 0, 0, 290, 184);
INSERT INTO public.who_global_data VALUES (68679, 0, 0, 0, 0, 290, 82);
INSERT INTO public.who_global_data VALUES (68680, 14, 476, 1, 40, 290, 149);
INSERT INTO public.who_global_data VALUES (68681, 0, 4, 0, 0, 290, 197);
INSERT INTO public.who_global_data VALUES (68682, 1141, 12772, 5, 114, 290, 78);
INSERT INTO public.who_global_data VALUES (68683, 35, 412, 0, 5, 290, 233);
INSERT INTO public.who_global_data VALUES (68684, 260, 6890, 5, 130, 290, 133);
INSERT INTO public.who_global_data VALUES (68685, 0, 11, 0, 0, 290, 35);
INSERT INTO public.who_global_data VALUES (68686, 7, 50, 0, 0, 290, 114);
INSERT INTO public.who_global_data VALUES (68687, 1111, 9125, 0, 11, 290, 237);
INSERT INTO public.who_global_data VALUES (68688, 0, 2, 0, 0, 290, 55);
INSERT INTO public.who_global_data VALUES (68689, 1, 68, 0, 10, 290, 176);
INSERT INTO public.who_global_data VALUES (68690, 26, 1199, 1, 14, 290, 202);
INSERT INTO public.who_global_data VALUES (68691, 9, 1354, 3, 87, 290, 155);
INSERT INTO public.who_global_data VALUES (68692, 0, 0, 0, 0, 290, 32);
INSERT INTO public.who_global_data VALUES (68693, 49, 286, 6, 14, 290, 220);
INSERT INTO public.who_global_data VALUES (68694, 165, 3465, 0, 58, 290, 30);
INSERT INTO public.who_global_data VALUES (68695, 0, 4, 0, 0, 290, 147);
INSERT INTO public.who_global_data VALUES (68696, 2519, 207518, 387, 23148, 290, 208);
INSERT INTO public.who_global_data VALUES (68697, 6, 310, 0, 7, 290, 45);
INSERT INTO public.who_global_data VALUES (68698, 33, 140, 1, 13, 290, 110);
INSERT INTO public.who_global_data VALUES (68699, 0, 10, 0, 1, 290, 88);
INSERT INTO public.who_global_data VALUES (68700, 461, 15124, 85, 2135, 290, 51);
INSERT INTO public.who_global_data VALUES (68701, 213, 28553, 33, 1414, 290, 209);
INSERT INTO public.who_global_data VALUES (68702, 3, 42, 0, 3, 290, 205);
INSERT INTO public.who_global_data VALUES (68703, 0, 0, 0, 0, 290, 18);
INSERT INTO public.who_global_data VALUES (68704, 15, 2826, 1, 49, 290, 72);
INSERT INTO public.who_global_data VALUES (68705, 4854, 130119, 1224, 20273, 290, 44);
INSERT INTO public.who_global_data VALUES (68706, 0, 23, 0, 0, 290, 15);
INSERT INTO public.who_global_data VALUES (68707, 2, 86, 1, 6, 290, 25);
INSERT INTO public.who_global_data VALUES (68708, 0, 0, 0, 0, 290, 179);
INSERT INTO public.who_global_data VALUES (68709, 0, 0, 0, 0, 290, 34);
INSERT INTO public.who_global_data VALUES (68710, 0, 114, 0, 8, 290, 207);
INSERT INTO public.who_global_data VALUES (68711, 17, 901, 0, 38, 290, 166);
INSERT INTO public.who_global_data VALUES (68712, 4611, 95591, 119, 2259, 290, 126);
INSERT INTO public.who_global_data VALUES (68713, 0, 0, 0, 0, 290, 97);
INSERT INTO public.who_global_data VALUES (68714, 0, 11, 0, 1, 290, 36);
INSERT INTO public.who_global_data VALUES (68715, 0, 0, 0, 0, 290, 125);
INSERT INTO public.who_global_data VALUES (68716, 1, 56, 0, 0, 290, 124);
INSERT INTO public.who_global_data VALUES (68717, 467, 6592, 13, 174, 290, 185);
INSERT INTO public.who_global_data VALUES (68718, 483, 8238, 6, 52, 290, 194);
INSERT INTO public.who_global_data VALUES (68719, 0, 255, 0, 10, 290, 144);
INSERT INTO public.who_global_data VALUES (68720, 25634, 776907, 2154, 42467, 290, 19);
INSERT INTO public.who_global_data VALUES (68721, 1, 54, 0, 3, 290, 217);
INSERT INTO public.who_global_data VALUES (68722, 7, 535, 0, 10, 290, 148);
INSERT INTO public.who_global_data VALUES (68723, 0, 1657, 1, 6, 290, 86);
INSERT INTO public.who_global_data VALUES (68724, 0, 0, 0, 0, 290, 13);
INSERT INTO public.who_global_data VALUES (68725, 29, 285, 1, 10, 290, 157);
INSERT INTO public.who_global_data VALUES (68726, 0, 268, 0, 0, 290, 8);
INSERT INTO public.who_global_data VALUES (68727, 0, 0, 0, 0, 290, 73);
INSERT INTO public.who_global_data VALUES (68728, 0, 1, 0, 0, 290, 101);
INSERT INTO public.who_global_data VALUES (68729, 5, 70, 0, 3, 290, 165);
INSERT INTO public.who_global_data VALUES (68730, 3, 28, 0, 3, 290, 14);
INSERT INTO public.who_global_data VALUES (68731, 96, 1092, 3, 36, 291, 193);
INSERT INTO public.who_global_data VALUES (68732, 47, 571, 0, 25, 291, 113);
INSERT INTO public.who_global_data VALUES (68733, 89, 2718, 9, 384, 291, 143);
INSERT INTO public.who_global_data VALUES (68734, 0, 0, 0, 0, 291, 219);
INSERT INTO public.who_global_data VALUES (68735, 1, 718, 0, 36, 291, 186);
INSERT INTO public.who_global_data VALUES (68736, 5, 24, 0, 2, 291, 52);
INSERT INTO public.who_global_data VALUES (68737, 0, 3, 0, 0, 291, 180);
INSERT INTO public.who_global_data VALUES (68738, 0, 23, 0, 3, 291, 167);
INSERT INTO public.who_global_data VALUES (68739, 121, 2960, 4, 136, 291, 154);
INSERT INTO public.who_global_data VALUES (68740, 48, 1315, 2, 22, 291, 94);
INSERT INTO public.who_global_data VALUES (68741, 0, 97, 0, 2, 291, 66);
INSERT INTO public.who_global_data VALUES (68742, 13, 6625, 1, 71, 291, 58);
INSERT INTO public.who_global_data VALUES (68743, 73, 14783, 10, 462, 291, 163);
INSERT INTO public.who_global_data VALUES (68744, 38, 1436, 0, 19, 291, 37);
INSERT INTO public.who_global_data VALUES (68745, 2, 60, 0, 9, 291, 142);
INSERT INTO public.who_global_data VALUES (68746, 57, 1952, 0, 7, 291, 83);
INSERT INTO public.who_global_data VALUES (68747, 434, 3382, 9, 110, 291, 228);
INSERT INTO public.who_global_data VALUES (68748, 0, 75, 0, 5, 291, 188);
INSERT INTO public.who_global_data VALUES (68749, 457, 6264, 4, 51, 291, 62);
INSERT INTO public.who_global_data VALUES (68750, 1276, 43766, 206, 6438, 291, 160);
INSERT INTO public.who_global_data VALUES (68751, 0, 18, 0, 2, 291, 50);
INSERT INTO public.who_global_data VALUES (68752, 17, 54, 0, 1, 291, 33);
INSERT INTO public.who_global_data VALUES (68753, 0, 86, 0, 5, 291, 183);
INSERT INTO public.who_global_data VALUES (68754, 1, 6, 0, 0, 291, 92);
INSERT INTO public.who_global_data VALUES (68755, 44, 564, 1, 33, 291, 158);
INSERT INTO public.who_global_data VALUES (68756, 0, 1, 0, 0, 291, 67);
INSERT INTO public.who_global_data VALUES (68757, 14, 1300, 3, 49, 291, 57);
INSERT INTO public.who_global_data VALUES (68758, 0, 20, 0, 1, 291, 38);
INSERT INTO public.who_global_data VALUES (68759, 2055, 38654, 115, 2462, 291, 141);
INSERT INTO public.who_global_data VALUES (68760, 0, 4, 0, 1, 291, 178);
INSERT INTO public.who_global_data VALUES (68761, 0, 138, 0, 1, 291, 108);
INSERT INTO public.who_global_data VALUES (68762, 14, 929, 0, 43, 291, 39);
INSERT INTO public.who_global_data VALUES (68763, 11, 576, 0, 36, 291, 2);
INSERT INTO public.who_global_data VALUES (68764, 0, 6, 0, 1, 291, 195);
INSERT INTO public.who_global_data VALUES (68765, 0, 55, 0, 1, 291, 107);
INSERT INTO public.who_global_data VALUES (68766, 0, 122, 0, 0, 291, 161);
INSERT INTO public.who_global_data VALUES (68767, 147, 1163, 21, 42, 291, 212);
INSERT INTO public.who_global_data VALUES (68768, 1474, 35383, 105, 1611, 291, 181);
INSERT INTO public.who_global_data VALUES (68769, 0, 61, 0, 1, 291, 53);
INSERT INTO public.who_global_data VALUES (68770, 0, 12, 0, 0, 291, 164);
INSERT INTO public.who_global_data VALUES (68771, 0, 33, 0, 0, 291, 140);
INSERT INTO public.who_global_data VALUES (68772, 419, 10507, 6, 139, 291, 20);
INSERT INTO public.who_global_data VALUES (68773, 14, 84253, 0, 4642, 291, 112);
INSERT INTO public.who_global_data VALUES (68774, 171, 3792, 13, 179, 291, 111);
INSERT INTO public.who_global_data VALUES (68775, 0, 0, 0, 0, 291, 71);
INSERT INTO public.who_global_data VALUES (68776, 17, 160, 0, 6, 291, 218);
INSERT INTO public.who_global_data VALUES (68777, 0, 0, 0, 0, 291, 43);
INSERT INTO public.who_global_data VALUES (68778, 5, 660, 1, 5, 291, 49);
INSERT INTO public.who_global_data VALUES (68779, 32, 879, 1, 10, 291, 1);
INSERT INTO public.who_global_data VALUES (68780, 10, 1881, 0, 47, 291, 48);
INSERT INTO public.who_global_data VALUES (68781, 52, 1087, 2, 36, 291, 232);
INSERT INTO public.who_global_data VALUES (68782, 0, 14, 0, 1, 291, 175);
INSERT INTO public.who_global_data VALUES (68783, 5, 772, 0, 12, 291, 21);
INSERT INTO public.who_global_data VALUES (68784, 127, 6914, 8, 196, 291, 156);
INSERT INTO public.who_global_data VALUES (68785, 0, 0, 0, 0, 291, 95);
INSERT INTO public.who_global_data VALUES (68786, 18, 350, 0, 25, 291, 177);
INSERT INTO public.who_global_data VALUES (68787, 131, 7515, 9, 364, 291, 210);
INSERT INTO public.who_global_data VALUES (68788, 99, 945, 0, 2, 291, 120);
INSERT INTO public.who_global_data VALUES (68789, 0, 16, 0, 0, 291, 135);
INSERT INTO public.who_global_data VALUES (68790, 284, 4964, 9, 235, 291, 206);
INSERT INTO public.who_global_data VALUES (68791, 660, 10128, 33, 507, 291, 189);
INSERT INTO public.who_global_data VALUES (68792, 189, 3333, 11, 250, 291, 129);
INSERT INTO public.who_global_data VALUES (68793, 17, 218, 0, 7, 291, 121);
INSERT INTO public.who_global_data VALUES (68794, 0, 79, 0, 0, 291, 59);
INSERT INTO public.who_global_data VALUES (68795, 0, 39, 0, 0, 291, 96);
INSERT INTO public.who_global_data VALUES (68796, 7, 1535, 0, 40, 291, 41);
INSERT INTO public.who_global_data VALUES (68797, 2, 24, 0, 1, 291, 216);
INSERT INTO public.who_global_data VALUES (68798, 3, 111, 0, 3, 291, 236);
INSERT INTO public.who_global_data VALUES (68799, 0, 11, 0, 0, 291, 150);
INSERT INTO public.who_global_data VALUES (68800, 0, 185, 0, 0, 291, 61);
INSERT INTO public.who_global_data VALUES (68801, 1, 18, 0, 0, 291, 7);
INSERT INTO public.who_global_data VALUES (68802, 85, 3868, 4, 98, 291, 169);
INSERT INTO public.who_global_data VALUES (68803, 2050, 113513, 544, 20234, 291, 28);
INSERT INTO public.who_global_data VALUES (68804, 1, 97, 1, 1, 291, 85);
INSERT INTO public.who_global_data VALUES (68805, 1, 56, 0, 0, 291, 211);
INSERT INTO public.who_global_data VALUES (68806, 11, 120, 0, 1, 291, 60);
INSERT INTO public.who_global_data VALUES (68807, 1, 10, 0, 1, 291, 3);
INSERT INTO public.who_global_data VALUES (68808, 9, 408, 0, 4, 291, 11);
INSERT INTO public.who_global_data VALUES (68809, 1785, 143457, 194, 4598, 291, 89);
INSERT INTO public.who_global_data VALUES (68810, 0, 1042, 0, 9, 291, 24);
INSERT INTO public.who_global_data VALUES (68811, 0, 133, 0, 0, 291, 162);
INSERT INTO public.who_global_data VALUES (68812, 10, 2245, 6, 116, 291, 100);
INSERT INTO public.who_global_data VALUES (68813, 0, 11, 0, 0, 291, 47);
INSERT INTO public.who_global_data VALUES (68814, 0, 13, 0, 0, 291, 29);
INSERT INTO public.who_global_data VALUES (68815, 0, 148, 0, 10, 291, 40);
INSERT INTO public.who_global_data VALUES (68816, 0, 133, 0, 5, 291, 222);
INSERT INTO public.who_global_data VALUES (68817, 32, 289, 0, 7, 291, 132);
INSERT INTO public.who_global_data VALUES (68818, 0, 239, 0, 9, 291, 130);
INSERT INTO public.who_global_data VALUES (68819, 145, 622, 2, 5, 291, 234);
INSERT INTO public.who_global_data VALUES (68820, 0, 50, 0, 0, 291, 23);
INSERT INTO public.who_global_data VALUES (68821, 2, 65, 0, 7, 291, 192);
INSERT INTO public.who_global_data VALUES (68822, 3, 47, 0, 3, 291, 69);
INSERT INTO public.who_global_data VALUES (68823, 1, 9, 0, 0, 291, 187);
INSERT INTO public.who_global_data VALUES (68824, 5, 477, 0, 46, 291, 230);
INSERT INTO public.who_global_data VALUES (68825, 114, 2098, 14, 213, 291, 77);
INSERT INTO public.who_global_data VALUES (68826, 2, 1773, 1, 10, 291, 9);
INSERT INTO public.who_global_data VALUES (68827, 1336, 18601, 47, 590, 291, 74);
INSERT INTO public.who_global_data VALUES (68828, 375, 7135, 26, 616, 291, 224);
INSERT INTO public.who_global_data VALUES (68829, 1297, 84802, 88, 5297, 291, 199);
INSERT INTO public.who_global_data VALUES (68830, 28, 1602, 1, 83, 291, 190);
INSERT INTO public.who_global_data VALUES (68831, 401, 15652, 77, 687, 291, 12);
INSERT INTO public.who_global_data VALUES (68832, 0, 297, 0, 4, 291, 104);
INSERT INTO public.who_global_data VALUES (68833, 276, 13819, 8, 174, 291, 153);
INSERT INTO public.who_global_data VALUES (68834, 2256, 181228, 454, 24114, 291, 91);
INSERT INTO public.who_global_data VALUES (68835, 23, 196, 0, 5, 291, 215);
INSERT INTO public.who_global_data VALUES (68836, 368, 11119, 15, 186, 291, 84);
INSERT INTO public.who_global_data VALUES (68837, 4, 249, 0, 12, 291, 231);
INSERT INTO public.who_global_data VALUES (68838, 8, 425, 0, 7, 291, 196);
INSERT INTO public.who_global_data VALUES (68839, 143, 1995, 0, 19, 291, 105);
INSERT INTO public.who_global_data VALUES (68840, 11, 281, 0, 14, 291, 122);
INSERT INTO public.who_global_data VALUES (68841, 0, 0, 0, 0, 291, 159);
INSERT INTO public.who_global_data VALUES (68842, 37, 572, 1, 14, 291, 75);
INSERT INTO public.who_global_data VALUES (68843, 85, 2080, 2, 11, 291, 27);
INSERT INTO public.who_global_data VALUES (68844, 22, 590, 0, 7, 291, 54);
INSERT INTO public.who_global_data VALUES (68845, 0, 19, 0, 0, 291, 226);
INSERT INTO public.who_global_data VALUES (68846, 12, 739, 0, 5, 291, 79);
INSERT INTO public.who_global_data VALUES (68847, 0, 677, 0, 21, 291, 56);
INSERT INTO public.who_global_data VALUES (68848, 0, 0, 0, 0, 291, 117);
INSERT INTO public.who_global_data VALUES (68849, 8, 99, 0, 8, 291, 152);
INSERT INTO public.who_global_data VALUES (68850, 0, 51, 0, 1, 291, 16);
INSERT INTO public.who_global_data VALUES (68851, 0, 82, 0, 1, 291, 10);
INSERT INTO public.who_global_data VALUES (68852, 53, 1226, 1, 38, 291, 201);
INSERT INTO public.who_global_data VALUES (68853, 8, 3558, 2, 75, 291, 174);
INSERT INTO public.who_global_data VALUES (68854, 0, 121, 0, 0, 291, 119);
INSERT INTO public.who_global_data VALUES (68855, 0, 17, 0, 2, 291, 168);
INSERT INTO public.who_global_data VALUES (68856, 35, 5424, 0, 89, 291, 99);
INSERT INTO public.who_global_data VALUES (68857, 23, 83, 0, 0, 291, 171);
INSERT INTO public.who_global_data VALUES (68858, 22, 246, 0, 14, 291, 87);
INSERT INTO public.who_global_data VALUES (68859, 12, 443, 0, 3, 291, 123);
INSERT INTO public.who_global_data VALUES (68860, 0, 0, 0, 0, 291, 151);
INSERT INTO public.who_global_data VALUES (68861, 0, 163, 2, 14, 291, 213);
INSERT INTO public.who_global_data VALUES (68862, 0, 7, 0, 1, 291, 118);
INSERT INTO public.who_global_data VALUES (68863, 0, 328, 0, 9, 291, 134);
INSERT INTO public.who_global_data VALUES (68864, 0, 284, 0, 4, 291, 65);
INSERT INTO public.who_global_data VALUES (68865, 764, 8261, 36, 686, 291, 102);
INSERT INTO public.who_global_data VALUES (68866, 0, 0, 0, 0, 291, 223);
INSERT INTO public.who_global_data VALUES (68867, 0, 65, 0, 1, 291, 4);
INSERT INTO public.who_global_data VALUES (68868, 1, 34, 0, 0, 291, 146);
INSERT INTO public.who_global_data VALUES (68869, 1, 314, 0, 5, 291, 31);
INSERT INTO public.who_global_data VALUES (68870, 0, 11, 0, 0, 291, 127);
INSERT INTO public.who_global_data VALUES (68871, 196, 3186, 1, 144, 291, 22);
INSERT INTO public.who_global_data VALUES (68872, 0, 35, 0, 0, 291, 115);
INSERT INTO public.who_global_data VALUES (68873, 8, 119, 0, 5, 291, 106);
INSERT INTO public.who_global_data VALUES (68874, 0, 16, 0, 0, 291, 90);
INSERT INTO public.who_global_data VALUES (68875, 0, 0, 0, 0, 291, 70);
INSERT INTO public.who_global_data VALUES (68876, 1, 32, 0, 0, 291, 46);
INSERT INTO public.who_global_data VALUES (68877, 748, 33171, 59, 3706, 291, 139);
INSERT INTO public.who_global_data VALUES (68878, 0, 18, 0, 0, 291, 42);
INSERT INTO public.who_global_data VALUES (68879, 2, 1107, 1, 13, 291, 80);
INSERT INTO public.who_global_data VALUES (68880, 0, 9, 1, 2, 291, 203);
INSERT INTO public.who_global_data VALUES (68881, 7, 655, 0, 20, 291, 136);
INSERT INTO public.who_global_data VALUES (68882, 0, 541, 0, 19, 291, 63);
INSERT INTO public.who_global_data VALUES (68883, 0, 0, 0, 0, 291, 17);
INSERT INTO public.who_global_data VALUES (68884, 0, 14, 0, 2, 291, 172);
INSERT INTO public.who_global_data VALUES (68885, 18, 1225, 3, 54, 291, 109);
INSERT INTO public.who_global_data VALUES (68886, 45, 7113, 0, 154, 291, 200);
INSERT INTO public.who_global_data VALUES (68887, 0, 329, 0, 2, 291, 93);
INSERT INTO public.who_global_data VALUES (68888, 98, 1508, 1, 8, 291, 5);
INSERT INTO public.who_global_data VALUES (68889, 0, 712, 0, 13, 291, 214);
INSERT INTO public.who_global_data VALUES (68890, 1087, 9505, 21, 197, 291, 204);
INSERT INTO public.who_global_data VALUES (68891, 0, 0, 0, 0, 291, 198);
INSERT INTO public.who_global_data VALUES (68892, 194, 4467, 6, 126, 291, 173);
INSERT INTO public.who_global_data VALUES (68893, 0, 7, 0, 0, 291, 229);
INSERT INTO public.who_global_data VALUES (68894, 2, 208, 0, 8, 291, 76);
INSERT INTO public.who_global_data VALUES (68895, 1208, 15628, 52, 400, 291, 138);
INSERT INTO public.who_global_data VALUES (68896, 200, 6459, 19, 428, 291, 98);
INSERT INTO public.who_global_data VALUES (68897, 0, 0, 0, 0, 291, 103);
INSERT INTO public.who_global_data VALUES (68898, 306, 9593, 20, 380, 291, 225);
INSERT INTO public.who_global_data VALUES (68899, 657, 20863, 21, 735, 291, 131);
INSERT INTO public.who_global_data VALUES (68900, 39, 1252, 0, 48, 291, 235);
INSERT INTO public.who_global_data VALUES (68901, 518, 6533, 0, 9, 291, 137);
INSERT INTO public.who_global_data VALUES (68902, 9, 10683, 1, 237, 291, 81);
INSERT INTO public.who_global_data VALUES (68903, 76, 2548, 3, 70, 291, 182);
INSERT INTO public.who_global_data VALUES (68904, 0, 408, 0, 0, 291, 145);
INSERT INTO public.who_global_data VALUES (68905, 190, 8936, 17, 451, 291, 26);
INSERT INTO public.who_global_data VALUES (68906, 5642, 52763, 51, 456, 291, 170);
INSERT INTO public.who_global_data VALUES (68907, 0, 147, 0, 0, 291, 191);
INSERT INTO public.who_global_data VALUES (68908, 0, 2, 0, 0, 291, 221);
INSERT INTO public.who_global_data VALUES (68909, 0, 6, 0, 0, 291, 64);
INSERT INTO public.who_global_data VALUES (68910, 0, 0, 0, 0, 291, 116);
INSERT INTO public.who_global_data VALUES (68911, 1, 15, 0, 0, 291, 128);
INSERT INTO public.who_global_data VALUES (68912, 0, 15, 0, 0, 291, 6);
INSERT INTO public.who_global_data VALUES (68913, 0, 37, 0, 2, 291, 227);
INSERT INTO public.who_global_data VALUES (68914, 0, 1, 0, 0, 291, 68);
INSERT INTO public.who_global_data VALUES (68915, 0, 12, 0, 0, 291, 184);
INSERT INTO public.who_global_data VALUES (68916, 0, 0, 0, 0, 291, 82);
INSERT INTO public.who_global_data VALUES (68917, 1, 462, 0, 39, 291, 149);
INSERT INTO public.who_global_data VALUES (68918, 0, 4, 0, 0, 291, 197);
INSERT INTO public.who_global_data VALUES (68919, 1147, 11631, 6, 109, 291, 78);
INSERT INTO public.who_global_data VALUES (68920, 10, 377, 2, 5, 291, 233);
INSERT INTO public.who_global_data VALUES (68921, 312, 6630, 3, 125, 291, 133);
INSERT INTO public.who_global_data VALUES (68922, 0, 11, 0, 0, 291, 35);
INSERT INTO public.who_global_data VALUES (68923, 8, 43, 0, 0, 291, 114);
INSERT INTO public.who_global_data VALUES (68924, 1426, 8014, 0, 11, 291, 237);
INSERT INTO public.who_global_data VALUES (68925, 0, 2, 0, 0, 291, 55);
INSERT INTO public.who_global_data VALUES (68926, 3, 67, 1, 10, 291, 176);
INSERT INTO public.who_global_data VALUES (68927, 12, 1173, 1, 13, 291, 202);
INSERT INTO public.who_global_data VALUES (68928, 9, 1345, 1, 84, 291, 155);
INSERT INTO public.who_global_data VALUES (68929, 0, 0, 0, 0, 291, 32);
INSERT INTO public.who_global_data VALUES (68930, 73, 237, 1, 8, 291, 220);
INSERT INTO public.who_global_data VALUES (68931, 142, 3300, 4, 58, 291, 30);
INSERT INTO public.who_global_data VALUES (68932, 0, 4, 0, 0, 291, 147);
INSERT INTO public.who_global_data VALUES (68933, 1446, 204999, 401, 22761, 291, 208);
INSERT INTO public.who_global_data VALUES (68934, 33, 304, 0, 7, 291, 45);
INSERT INTO public.who_global_data VALUES (68935, 15, 107, 0, 12, 291, 110);
INSERT INTO public.who_global_data VALUES (68936, 0, 10, 0, 1, 291, 88);
INSERT INTO public.who_global_data VALUES (68937, 388, 14663, 87, 2050, 291, 51);
INSERT INTO public.who_global_data VALUES (68938, 277, 28340, 38, 1381, 291, 209);
INSERT INTO public.who_global_data VALUES (68939, 0, 39, 0, 3, 291, 205);
INSERT INTO public.who_global_data VALUES (68940, 0, 0, 0, 0, 291, 18);
INSERT INTO public.who_global_data VALUES (68941, 19, 2811, 1, 48, 291, 72);
INSERT INTO public.who_global_data VALUES (68942, 3853, 125265, 570, 19049, 291, 44);
INSERT INTO public.who_global_data VALUES (68943, 1, 23, 0, 0, 291, 15);
INSERT INTO public.who_global_data VALUES (68944, 1, 84, 0, 5, 291, 25);
INSERT INTO public.who_global_data VALUES (68945, 0, 0, 0, 0, 291, 179);
INSERT INTO public.who_global_data VALUES (68946, 0, 0, 0, 0, 291, 34);
INSERT INTO public.who_global_data VALUES (68947, 0, 114, 0, 8, 291, 207);
INSERT INTO public.who_global_data VALUES (68948, 5, 884, 0, 38, 291, 166);
INSERT INTO public.who_global_data VALUES (68949, 4674, 90980, 123, 2140, 291, 126);
INSERT INTO public.who_global_data VALUES (68950, 0, 0, 0, 0, 291, 97);
INSERT INTO public.who_global_data VALUES (68951, 0, 11, 0, 1, 291, 36);
INSERT INTO public.who_global_data VALUES (68952, 0, 0, 0, 0, 291, 125);
INSERT INTO public.who_global_data VALUES (68953, 0, 55, 0, 0, 291, 124);
INSERT INTO public.who_global_data VALUES (68954, 415, 6125, 10, 161, 291, 185);
INSERT INTO public.who_global_data VALUES (68955, 490, 7755, 3, 46, 291, 194);
INSERT INTO public.who_global_data VALUES (68956, 84, 255, 3, 10, 291, 144);
INSERT INTO public.who_global_data VALUES (68957, 27668, 751273, 1801, 40313, 291, 19);
INSERT INTO public.who_global_data VALUES (68958, 0, 53, 0, 3, 291, 217);
INSERT INTO public.who_global_data VALUES (68959, 11, 528, 1, 10, 291, 148);
INSERT INTO public.who_global_data VALUES (68960, 92, 1657, 0, 5, 291, 86);
INSERT INTO public.who_global_data VALUES (68961, 0, 0, 0, 0, 291, 13);
INSERT INTO public.who_global_data VALUES (68962, 28, 256, 0, 9, 291, 157);
INSERT INTO public.who_global_data VALUES (68963, 0, 268, 0, 0, 291, 8);
INSERT INTO public.who_global_data VALUES (68964, 0, 0, 0, 0, 291, 73);
INSERT INTO public.who_global_data VALUES (68965, 0, 1, 0, 0, 291, 101);
INSERT INTO public.who_global_data VALUES (68966, 4, 65, 0, 3, 291, 165);
INSERT INTO public.who_global_data VALUES (68967, 0, 25, 0, 3, 291, 14);
INSERT INTO public.who_global_data VALUES (68968, 0, 996, 0, 33, 292, 193);
INSERT INTO public.who_global_data VALUES (68969, 14, 524, 0, 25, 292, 113);
INSERT INTO public.who_global_data VALUES (68970, 95, 2629, 8, 375, 292, 143);
INSERT INTO public.who_global_data VALUES (68971, 0, 0, 0, 0, 292, 219);
INSERT INTO public.who_global_data VALUES (68972, 13, 717, 1, 36, 292, 186);
INSERT INTO public.who_global_data VALUES (68973, 0, 19, 0, 2, 292, 52);
INSERT INTO public.who_global_data VALUES (68974, 0, 3, 0, 0, 292, 180);
INSERT INTO public.who_global_data VALUES (68975, 0, 23, 1, 3, 292, 167);
INSERT INTO public.who_global_data VALUES (68976, 55, 2839, 3, 132, 292, 154);
INSERT INTO public.who_global_data VALUES (68977, 43, 1267, 0, 20, 292, 94);
INSERT INTO public.who_global_data VALUES (68978, 1, 97, 0, 2, 292, 66);
INSERT INTO public.who_global_data VALUES (68979, 6, 6612, 0, 70, 292, 58);
INSERT INTO public.who_global_data VALUES (68980, 48, 14710, 9, 452, 292, 163);
INSERT INTO public.who_global_data VALUES (68981, 25, 1398, 1, 19, 292, 37);
INSERT INTO public.who_global_data VALUES (68982, 4, 58, 0, 9, 292, 142);
INSERT INTO public.who_global_data VALUES (68983, 22, 1895, 0, 7, 292, 83);
INSERT INTO public.who_global_data VALUES (68984, 492, 2948, 10, 101, 292, 228);
INSERT INTO public.who_global_data VALUES (68985, 0, 75, 0, 5, 292, 188);
INSERT INTO public.who_global_data VALUES (68986, 518, 5807, 2, 47, 292, 62);
INSERT INTO public.who_global_data VALUES (68987, 443, 42490, 190, 6232, 292, 160);
INSERT INTO public.who_global_data VALUES (68988, 0, 18, 0, 2, 292, 50);
INSERT INTO public.who_global_data VALUES (68989, 0, 37, 0, 1, 292, 33);
INSERT INTO public.who_global_data VALUES (68990, 3, 86, 0, 5, 292, 183);
INSERT INTO public.who_global_data VALUES (68991, 0, 5, 0, 0, 292, 92);
INSERT INTO public.who_global_data VALUES (68992, 27, 520, 1, 32, 292, 158);
INSERT INTO public.who_global_data VALUES (68993, 0, 1, 0, 0, 292, 67);
INSERT INTO public.who_global_data VALUES (68994, 18, 1286, 0, 46, 292, 57);
INSERT INTO public.who_global_data VALUES (68995, 5, 20, 0, 1, 292, 38);
INSERT INTO public.who_global_data VALUES (68996, 2917, 36599, 206, 2347, 292, 141);
INSERT INTO public.who_global_data VALUES (68997, 1, 4, 1, 1, 292, 178);
INSERT INTO public.who_global_data VALUES (68998, 1, 138, 0, 1, 292, 108);
INSERT INTO public.who_global_data VALUES (68999, 37, 915, 2, 43, 292, 39);
INSERT INTO public.who_global_data VALUES (69000, 18, 565, 4, 36, 292, 2);
INSERT INTO public.who_global_data VALUES (69001, 1, 6, 1, 1, 292, 195);
INSERT INTO public.who_global_data VALUES (69002, 0, 55, 0, 1, 292, 107);
INSERT INTO public.who_global_data VALUES (69003, 0, 122, 0, 0, 292, 161);
INSERT INTO public.who_global_data VALUES (69004, 0, 1016, 0, 21, 292, 212);
INSERT INTO public.who_global_data VALUES (69005, 1509, 33909, 160, 1506, 292, 181);
INSERT INTO public.who_global_data VALUES (69006, 0, 61, 0, 1, 292, 53);
INSERT INTO public.who_global_data VALUES (69007, 0, 12, 0, 0, 292, 164);
INSERT INTO public.who_global_data VALUES (69008, 0, 33, 0, 0, 292, 140);
INSERT INTO public.who_global_data VALUES (69009, 358, 10088, 7, 133, 292, 20);
INSERT INTO public.who_global_data VALUES (69010, 16, 84239, 0, 4642, 292, 112);
INSERT INTO public.who_global_data VALUES (69011, 182, 3621, 13, 166, 292, 111);
INSERT INTO public.who_global_data VALUES (69012, 0, 0, 0, 0, 292, 71);
INSERT INTO public.who_global_data VALUES (69013, 0, 143, 0, 6, 292, 218);
INSERT INTO public.who_global_data VALUES (69014, 0, 0, 0, 0, 292, 43);
INSERT INTO public.who_global_data VALUES (69015, 6, 655, 0, 4, 292, 49);
INSERT INTO public.who_global_data VALUES (69016, 105, 847, 3, 9, 292, 1);
INSERT INTO public.who_global_data VALUES (69017, 39, 1871, 8, 47, 292, 48);
INSERT INTO public.who_global_data VALUES (69018, 49, 1035, 2, 34, 292, 232);
INSERT INTO public.who_global_data VALUES (69019, 0, 14, 0, 1, 292, 175);
INSERT INTO public.who_global_data VALUES (69020, 6, 767, 0, 12, 292, 21);
INSERT INTO public.who_global_data VALUES (69021, 133, 6787, 7, 188, 292, 156);
INSERT INTO public.who_global_data VALUES (69022, 0, 0, 0, 0, 292, 95);
INSERT INTO public.who_global_data VALUES (69023, 5, 332, 0, 25, 292, 177);
INSERT INTO public.who_global_data VALUES (69024, 142, 7384, 9, 355, 292, 210);
INSERT INTO public.who_global_data VALUES (69025, 114, 846, 0, 2, 292, 120);
INSERT INTO public.who_global_data VALUES (69026, 0, 16, 0, 0, 292, 135);
INSERT INTO public.who_global_data VALUES (69027, 345, 4680, 9, 226, 292, 206);
INSERT INTO public.who_global_data VALUES (69028, 446, 9468, 18, 474, 292, 189);
INSERT INTO public.who_global_data VALUES (69029, 112, 3144, 15, 239, 292, 129);
INSERT INTO public.who_global_data VALUES (69030, 11, 201, 0, 7, 292, 121);
INSERT INTO public.who_global_data VALUES (69031, 0, 79, 0, 0, 292, 59);
INSERT INTO public.who_global_data VALUES (69032, 0, 39, 0, 0, 292, 96);
INSERT INTO public.who_global_data VALUES (69033, 16, 1528, 2, 40, 292, 41);
INSERT INTO public.who_global_data VALUES (69034, 0, 22, 0, 1, 292, 216);
INSERT INTO public.who_global_data VALUES (69035, 3, 108, 0, 3, 292, 236);
INSERT INTO public.who_global_data VALUES (69036, 0, 11, 0, 0, 292, 150);
INSERT INTO public.who_global_data VALUES (69037, 1, 185, 0, 0, 292, 61);
INSERT INTO public.who_global_data VALUES (69038, 0, 17, 0, 0, 292, 7);
INSERT INTO public.who_global_data VALUES (69039, 102, 3783, 4, 94, 292, 169);
INSERT INTO public.who_global_data VALUES (69040, 742, 111463, 395, 19690, 292, 28);
INSERT INTO public.who_global_data VALUES (69041, 0, 96, 0, 0, 292, 85);
INSERT INTO public.who_global_data VALUES (69042, 0, 55, 0, 0, 292, 211);
INSERT INTO public.who_global_data VALUES (69043, 1, 109, 0, 1, 292, 60);
INSERT INTO public.who_global_data VALUES (69044, 0, 9, 0, 1, 292, 3);
INSERT INTO public.who_global_data VALUES (69045, 5, 399, 0, 4, 292, 11);
INSERT INTO public.who_global_data VALUES (69046, 1775, 141672, 110, 4404, 292, 89);
INSERT INTO public.who_global_data VALUES (69047, 208, 1042, 0, 9, 292, 24);
INSERT INTO public.who_global_data VALUES (69048, 0, 133, 0, 0, 292, 162);
INSERT INTO public.who_global_data VALUES (69049, 28, 2235, 5, 110, 292, 100);
INSERT INTO public.who_global_data VALUES (69050, 0, 11, 0, 0, 292, 47);
INSERT INTO public.who_global_data VALUES (69051, 0, 13, 0, 0, 292, 29);
INSERT INTO public.who_global_data VALUES (69052, 3, 148, 0, 10, 292, 40);
INSERT INTO public.who_global_data VALUES (69053, 0, 133, 0, 5, 292, 222);
INSERT INTO public.who_global_data VALUES (69054, 22, 257, 0, 7, 292, 132);
INSERT INTO public.who_global_data VALUES (69055, 3, 239, 0, 9, 292, 130);
INSERT INTO public.who_global_data VALUES (69056, 0, 477, 0, 3, 292, 234);
INSERT INTO public.who_global_data VALUES (69057, 0, 50, 0, 0, 292, 23);
INSERT INTO public.who_global_data VALUES (69058, 0, 63, 1, 7, 292, 192);
INSERT INTO public.who_global_data VALUES (69059, 0, 44, 0, 3, 292, 69);
INSERT INTO public.who_global_data VALUES (69060, 0, 8, 0, 0, 292, 187);
INSERT INTO public.who_global_data VALUES (69061, 15, 472, 0, 46, 292, 230);
INSERT INTO public.who_global_data VALUES (69062, 68, 1984, 10, 199, 292, 77);
INSERT INTO public.who_global_data VALUES (69063, 11, 1771, 0, 9, 292, 9);
INSERT INTO public.who_global_data VALUES (69064, 1553, 17265, 36, 543, 292, 74);
INSERT INTO public.who_global_data VALUES (69065, 185, 6760, 8, 590, 292, 224);
INSERT INTO public.who_global_data VALUES (69066, 1294, 83505, 91, 5209, 292, 199);
INSERT INTO public.who_global_data VALUES (69067, 61, 1574, 0, 82, 292, 190);
INSERT INTO public.who_global_data VALUES (69068, 493, 15251, 39, 610, 292, 12);
INSERT INTO public.who_global_data VALUES (69069, 6, 297, 0, 4, 292, 104);
INSERT INTO public.who_global_data VALUES (69070, 291, 13543, 11, 166, 292, 153);
INSERT INTO public.who_global_data VALUES (69071, 3047, 178972, 433, 23660, 292, 91);
INSERT INTO public.who_global_data VALUES (69072, 10, 173, 0, 5, 292, 215);
INSERT INTO public.who_global_data VALUES (69073, 390, 10751, 10, 171, 292, 84);
INSERT INTO public.who_global_data VALUES (69074, 11, 245, 1, 12, 292, 231);
INSERT INTO public.who_global_data VALUES (69075, 4, 417, 0, 7, 292, 196);
INSERT INTO public.who_global_data VALUES (69076, 84, 1852, 0, 19, 292, 105);
INSERT INTO public.who_global_data VALUES (69077, 8, 270, 2, 14, 292, 122);
INSERT INTO public.who_global_data VALUES (69078, 0, 0, 0, 0, 292, 159);
INSERT INTO public.who_global_data VALUES (69079, 25, 535, 0, 13, 292, 75);
INSERT INTO public.who_global_data VALUES (69080, 80, 1995, 2, 9, 292, 27);
INSERT INTO public.who_global_data VALUES (69081, 14, 568, 2, 7, 292, 54);
INSERT INTO public.who_global_data VALUES (69082, 0, 19, 0, 0, 292, 226);
INSERT INTO public.who_global_data VALUES (69083, 15, 727, 0, 5, 292, 79);
INSERT INTO public.who_global_data VALUES (69084, 4, 677, 0, 21, 292, 56);
INSERT INTO public.who_global_data VALUES (69085, 0, 0, 0, 0, 292, 117);
INSERT INTO public.who_global_data VALUES (69086, 10, 91, 1, 8, 292, 152);
INSERT INTO public.who_global_data VALUES (69087, 2, 51, 0, 1, 292, 16);
INSERT INTO public.who_global_data VALUES (69088, 0, 82, 0, 1, 292, 10);
INSERT INTO public.who_global_data VALUES (69089, 20, 1173, 3, 37, 292, 201);
INSERT INTO public.who_global_data VALUES (69090, 13, 3550, 1, 73, 292, 174);
INSERT INTO public.who_global_data VALUES (69091, 1, 121, 0, 0, 292, 119);
INSERT INTO public.who_global_data VALUES (69092, 0, 17, 0, 2, 292, 168);
INSERT INTO public.who_global_data VALUES (69093, 84, 5389, 1, 89, 292, 99);
INSERT INTO public.who_global_data VALUES (69094, 9, 60, 0, 0, 292, 171);
INSERT INTO public.who_global_data VALUES (69095, 8, 224, 1, 14, 292, 87);
INSERT INTO public.who_global_data VALUES (69096, 4, 431, 0, 3, 292, 123);
INSERT INTO public.who_global_data VALUES (69097, 0, 0, 0, 0, 292, 151);
INSERT INTO public.who_global_data VALUES (69098, 0, 163, 0, 12, 292, 213);
INSERT INTO public.who_global_data VALUES (69099, 0, 7, 0, 1, 292, 118);
INSERT INTO public.who_global_data VALUES (69100, 3, 328, 0, 9, 292, 134);
INSERT INTO public.who_global_data VALUES (69101, 39, 284, 0, 4, 292, 65);
INSERT INTO public.who_global_data VALUES (69102, 622, 7497, 104, 650, 292, 102);
INSERT INTO public.who_global_data VALUES (69103, 0, 0, 0, 0, 292, 223);
INSERT INTO public.who_global_data VALUES (69104, 0, 65, 0, 1, 292, 4);
INSERT INTO public.who_global_data VALUES (69105, 1, 33, 0, 0, 292, 146);
INSERT INTO public.who_global_data VALUES (69106, 2, 313, 0, 5, 292, 31);
INSERT INTO public.who_global_data VALUES (69107, 0, 11, 0, 0, 292, 127);
INSERT INTO public.who_global_data VALUES (69108, 170, 2990, 5, 143, 292, 22);
INSERT INTO public.who_global_data VALUES (69109, 4, 35, 0, 0, 292, 115);
INSERT INTO public.who_global_data VALUES (69110, 4, 111, 0, 5, 292, 106);
INSERT INTO public.who_global_data VALUES (69111, 0, 16, 0, 0, 292, 90);
INSERT INTO public.who_global_data VALUES (69112, 0, 0, 0, 0, 292, 70);
INSERT INTO public.who_global_data VALUES (69113, 0, 31, 0, 0, 292, 46);
INSERT INTO public.who_global_data VALUES (69114, 1023, 32423, 79, 3647, 292, 139);
INSERT INTO public.who_global_data VALUES (69115, 0, 18, 0, 0, 292, 42);
INSERT INTO public.who_global_data VALUES (69116, 7, 1105, 1, 12, 292, 80);
INSERT INTO public.who_global_data VALUES (69117, 0, 9, 0, 1, 292, 203);
INSERT INTO public.who_global_data VALUES (69118, 9, 648, 1, 20, 292, 136);
INSERT INTO public.who_global_data VALUES (69119, 168, 541, 8, 19, 292, 63);
INSERT INTO public.who_global_data VALUES (69120, 0, 0, 0, 0, 292, 17);
INSERT INTO public.who_global_data VALUES (69121, 0, 14, 0, 2, 292, 172);
INSERT INTO public.who_global_data VALUES (69122, 37, 1207, 2, 51, 292, 109);
INSERT INTO public.who_global_data VALUES (69123, 84, 7068, 6, 154, 292, 200);
INSERT INTO public.who_global_data VALUES (69124, 7, 329, 0, 2, 292, 93);
INSERT INTO public.who_global_data VALUES (69125, 144, 1410, 1, 7, 292, 5);
INSERT INTO public.who_global_data VALUES (69126, 0, 712, 0, 13, 292, 214);
INSERT INTO public.who_global_data VALUES (69127, 425, 8418, 17, 176, 292, 204);
INSERT INTO public.who_global_data VALUES (69128, 0, 0, 0, 0, 292, 198);
INSERT INTO public.who_global_data VALUES (69129, 63, 4273, 5, 120, 292, 173);
INSERT INTO public.who_global_data VALUES (69130, 0, 7, 0, 0, 292, 229);
INSERT INTO public.who_global_data VALUES (69131, 4, 206, 0, 8, 292, 76);
INSERT INTO public.who_global_data VALUES (69132, 931, 14420, 48, 348, 292, 138);
INSERT INTO public.who_global_data VALUES (69133, 172, 6259, 12, 409, 292, 98);
INSERT INTO public.who_global_data VALUES (69134, 0, 0, 0, 0, 292, 103);
INSERT INTO public.who_global_data VALUES (69135, 545, 9287, 13, 360, 292, 225);
INSERT INTO public.who_global_data VALUES (69136, 521, 20206, 27, 714, 292, 131);
INSERT INTO public.who_global_data VALUES (69137, 95, 1213, 0, 48, 292, 235);
INSERT INTO public.who_global_data VALUES (69138, 567, 6015, 1, 9, 292, 137);
INSERT INTO public.who_global_data VALUES (69139, 13, 10674, 2, 236, 292, 81);
INSERT INTO public.who_global_data VALUES (69140, 121, 2472, 7, 67, 292, 182);
INSERT INTO public.who_global_data VALUES (69141, 1, 408, 0, 0, 292, 145);
INSERT INTO public.who_global_data VALUES (69142, 328, 8746, 17, 434, 292, 26);
INSERT INTO public.who_global_data VALUES (69143, 4268, 47121, 44, 405, 292, 170);
INSERT INTO public.who_global_data VALUES (69144, 3, 147, 0, 0, 292, 191);
INSERT INTO public.who_global_data VALUES (69145, 0, 2, 0, 0, 292, 221);
INSERT INTO public.who_global_data VALUES (69146, 0, 6, 0, 0, 292, 64);
INSERT INTO public.who_global_data VALUES (69147, 0, 0, 0, 0, 292, 116);
INSERT INTO public.who_global_data VALUES (69148, 0, 14, 0, 0, 292, 128);
INSERT INTO public.who_global_data VALUES (69149, 0, 15, 0, 0, 292, 6);
INSERT INTO public.who_global_data VALUES (69150, 0, 37, 0, 2, 292, 227);
INSERT INTO public.who_global_data VALUES (69151, 0, 1, 0, 0, 292, 68);
INSERT INTO public.who_global_data VALUES (69152, 0, 12, 0, 0, 292, 184);
INSERT INTO public.who_global_data VALUES (69153, 0, 0, 0, 0, 292, 82);
INSERT INTO public.who_global_data VALUES (69154, 6, 461, 0, 39, 292, 149);
INSERT INTO public.who_global_data VALUES (69155, 0, 4, 0, 0, 292, 197);
INSERT INTO public.who_global_data VALUES (69156, 1122, 10484, 6, 103, 292, 78);
INSERT INTO public.who_global_data VALUES (69157, 17, 367, 0, 3, 292, 233);
INSERT INTO public.who_global_data VALUES (69158, 324, 6318, 5, 122, 292, 133);
INSERT INTO public.who_global_data VALUES (69159, 0, 11, 0, 0, 292, 35);
INSERT INTO public.who_global_data VALUES (69160, 5, 35, 0, 0, 292, 114);
INSERT INTO public.who_global_data VALUES (69161, 596, 6588, 0, 11, 292, 237);
INSERT INTO public.who_global_data VALUES (69162, 0, 2, 0, 0, 292, 55);
INSERT INTO public.who_global_data VALUES (69163, 7, 64, 0, 9, 292, 176);
INSERT INTO public.who_global_data VALUES (69164, 72, 1161, 1, 12, 292, 202);
INSERT INTO public.who_global_data VALUES (69165, 5, 1336, 5, 83, 292, 155);
INSERT INTO public.who_global_data VALUES (69166, 0, 0, 0, 0, 292, 32);
INSERT INTO public.who_global_data VALUES (69167, 29, 164, 0, 7, 292, 220);
INSERT INTO public.who_global_data VALUES (69168, 124, 3158, 2, 54, 292, 30);
INSERT INTO public.who_global_data VALUES (69169, 0, 4, 0, 0, 292, 147);
INSERT INTO public.who_global_data VALUES (69170, 2182, 203553, 435, 22360, 292, 208);
INSERT INTO public.who_global_data VALUES (69171, 17, 271, 0, 7, 292, 45);
INSERT INTO public.who_global_data VALUES (69172, 26, 92, 2, 12, 292, 110);
INSERT INTO public.who_global_data VALUES (69173, 0, 10, 0, 1, 292, 88);
INSERT INTO public.who_global_data VALUES (69174, 532, 14275, 86, 1963, 292, 51);
INSERT INTO public.who_global_data VALUES (69175, 87, 28063, 21, 1343, 292, 209);
INSERT INTO public.who_global_data VALUES (69176, 1, 39, 1, 3, 292, 205);
INSERT INTO public.who_global_data VALUES (69177, 0, 0, 0, 0, 292, 18);
INSERT INTO public.who_global_data VALUES (69178, 27, 2792, 0, 47, 292, 72);
INSERT INTO public.who_global_data VALUES (69179, 4721, 121412, 432, 18479, 292, 44);
INSERT INTO public.who_global_data VALUES (69180, 3, 22, 0, 0, 292, 15);
INSERT INTO public.who_global_data VALUES (69181, 0, 83, 0, 5, 292, 25);
INSERT INTO public.who_global_data VALUES (69182, 0, 0, 0, 0, 292, 179);
INSERT INTO public.who_global_data VALUES (69183, 0, 0, 0, 0, 292, 34);
INSERT INTO public.who_global_data VALUES (69184, 0, 114, 0, 8, 292, 207);
INSERT INTO public.who_global_data VALUES (69185, 13, 879, 1, 38, 292, 166);
INSERT INTO public.who_global_data VALUES (69186, 3977, 86306, 127, 2017, 292, 126);
INSERT INTO public.who_global_data VALUES (69187, 0, 0, 0, 0, 292, 97);
INSERT INTO public.who_global_data VALUES (69188, 0, 11, 0, 1, 292, 36);
INSERT INTO public.who_global_data VALUES (69189, 0, 0, 0, 0, 292, 125);
INSERT INTO public.who_global_data VALUES (69190, 0, 55, 0, 0, 292, 124);
INSERT INTO public.who_global_data VALUES (69191, 261, 5710, 10, 151, 292, 185);
INSERT INTO public.who_global_data VALUES (69192, 484, 7265, 2, 43, 292, 194);
INSERT INTO public.who_global_data VALUES (69193, 23, 171, 2, 7, 292, 144);
INSERT INTO public.who_global_data VALUES (69194, 28252, 723605, 1776, 38512, 292, 19);
INSERT INTO public.who_global_data VALUES (69195, 0, 53, 0, 3, 292, 217);
INSERT INTO public.who_global_data VALUES (69196, 9, 517, 0, 9, 292, 148);
INSERT INTO public.who_global_data VALUES (69197, 70, 1565, 0, 5, 292, 86);
INSERT INTO public.who_global_data VALUES (69198, 0, 0, 0, 0, 292, 13);
INSERT INTO public.who_global_data VALUES (69199, 24, 228, 0, 9, 292, 157);
INSERT INTO public.who_global_data VALUES (69200, 0, 268, 0, 0, 292, 8);
INSERT INTO public.who_global_data VALUES (69201, 0, 0, 0, 0, 292, 73);
INSERT INTO public.who_global_data VALUES (69202, 0, 1, 0, 0, 292, 101);
INSERT INTO public.who_global_data VALUES (69203, 4, 61, 1, 3, 292, 165);
INSERT INTO public.who_global_data VALUES (69204, 0, 25, 0, 3, 292, 14);
INSERT INTO public.who_global_data VALUES (69205, 88, 996, 3, 33, 293, 193);
INSERT INTO public.who_global_data VALUES (69206, 0, 510, 0, 25, 293, 113);
INSERT INTO public.who_global_data VALUES (69207, 116, 2534, 3, 367, 293, 143);
INSERT INTO public.who_global_data VALUES (69208, 0, 0, 0, 0, 293, 219);
INSERT INTO public.who_global_data VALUES (69209, 1, 704, 0, 35, 293, 186);
INSERT INTO public.who_global_data VALUES (69210, 0, 19, 0, 2, 293, 52);
INSERT INTO public.who_global_data VALUES (69211, 0, 3, 0, 0, 293, 180);
INSERT INTO public.who_global_data VALUES (69212, 0, 23, 0, 2, 293, 167);
INSERT INTO public.who_global_data VALUES (69213, 90, 2784, 7, 129, 293, 154);
INSERT INTO public.who_global_data VALUES (69214, 47, 1224, 1, 20, 293, 94);
INSERT INTO public.who_global_data VALUES (69215, 0, 96, 0, 2, 293, 66);
INSERT INTO public.who_global_data VALUES (69216, 73, 6606, 3, 70, 293, 58);
INSERT INTO public.who_global_data VALUES (69217, 59, 14662, 12, 443, 293, 163);
INSERT INTO public.who_global_data VALUES (69218, 33, 1373, 3, 18, 293, 37);
INSERT INTO public.who_global_data VALUES (69219, 0, 54, 0, 9, 293, 142);
INSERT INTO public.who_global_data VALUES (69220, 106, 1873, 0, 7, 293, 83);
INSERT INTO public.who_global_data VALUES (69221, 312, 2456, 7, 91, 293, 228);
INSERT INTO public.who_global_data VALUES (69222, 0, 75, 0, 5, 293, 188);
INSERT INTO public.who_global_data VALUES (69223, 510, 5289, 2, 45, 293, 62);
INSERT INTO public.who_global_data VALUES (69224, 722, 42047, 208, 6042, 293, 160);
INSERT INTO public.who_global_data VALUES (69225, 0, 18, 0, 2, 293, 50);
INSERT INTO public.who_global_data VALUES (69226, 0, 37, 0, 1, 293, 33);
INSERT INTO public.who_global_data VALUES (69227, 0, 83, 0, 5, 293, 183);
INSERT INTO public.who_global_data VALUES (69228, 0, 5, 0, 0, 293, 92);
INSERT INTO public.who_global_data VALUES (69229, 28, 493, 0, 31, 293, 158);
INSERT INTO public.who_global_data VALUES (69230, 0, 1, 0, 0, 293, 67);
INSERT INTO public.who_global_data VALUES (69231, 58, 1268, 2, 46, 293, 57);
INSERT INTO public.who_global_data VALUES (69232, 0, 15, 0, 1, 293, 38);
INSERT INTO public.who_global_data VALUES (69233, 3257, 33682, 217, 2141, 293, 141);
INSERT INTO public.who_global_data VALUES (69234, 0, 3, 0, 0, 293, 178);
INSERT INTO public.who_global_data VALUES (69235, 1, 137, 0, 1, 293, 108);
INSERT INTO public.who_global_data VALUES (69236, 32, 878, 0, 41, 293, 39);
INSERT INTO public.who_global_data VALUES (69237, 0, 547, 0, 32, 293, 2);
INSERT INTO public.who_global_data VALUES (69238, 0, 5, 0, 0, 293, 195);
INSERT INTO public.who_global_data VALUES (69239, 0, 55, 0, 1, 293, 107);
INSERT INTO public.who_global_data VALUES (69240, 0, 122, 0, 0, 293, 161);
INSERT INTO public.who_global_data VALUES (69241, 0, 1016, 0, 21, 293, 212);
INSERT INTO public.who_global_data VALUES (69242, 1741, 32400, 96, 1346, 293, 181);
INSERT INTO public.who_global_data VALUES (69243, 0, 61, 0, 1, 293, 53);
INSERT INTO public.who_global_data VALUES (69244, 0, 12, 0, 0, 293, 164);
INSERT INTO public.who_global_data VALUES (69245, 0, 33, 0, 0, 293, 140);
INSERT INTO public.who_global_data VALUES (69246, 478, 9730, 10, 126, 293, 20);
INSERT INTO public.who_global_data VALUES (69247, 43, 84223, 0, 4642, 293, 112);
INSERT INTO public.who_global_data VALUES (69248, 206, 3439, 9, 153, 293, 111);
INSERT INTO public.who_global_data VALUES (69249, 0, 0, 0, 0, 293, 71);
INSERT INTO public.who_global_data VALUES (69250, 0, 143, 0, 6, 293, 218);
INSERT INTO public.who_global_data VALUES (69251, 0, 0, 0, 0, 293, 43);
INSERT INTO public.who_global_data VALUES (69252, 7, 649, 0, 4, 293, 49);
INSERT INTO public.who_global_data VALUES (69253, 0, 742, 0, 6, 293, 1);
INSERT INTO public.who_global_data VALUES (69254, 18, 1832, 3, 39, 293, 48);
INSERT INTO public.who_global_data VALUES (69255, 63, 986, 1, 32, 293, 232);
INSERT INTO public.who_global_data VALUES (69256, 0, 14, 0, 1, 293, 175);
INSERT INTO public.who_global_data VALUES (69257, 26, 761, 0, 12, 293, 21);
INSERT INTO public.who_global_data VALUES (69258, 105, 6654, 8, 181, 293, 156);
INSERT INTO public.who_global_data VALUES (69259, 0, 0, 0, 0, 293, 95);
INSERT INTO public.who_global_data VALUES (69260, 40, 327, 2, 25, 293, 177);
INSERT INTO public.who_global_data VALUES (69261, 169, 7242, 10, 346, 293, 210);
INSERT INTO public.who_global_data VALUES (69262, 0, 732, 0, 2, 293, 120);
INSERT INTO public.who_global_data VALUES (69263, 0, 16, 0, 0, 293, 135);
INSERT INTO public.who_global_data VALUES (69264, 209, 4335, 17, 217, 293, 206);
INSERT INTO public.who_global_data VALUES (69265, 572, 9022, 35, 456, 293, 189);
INSERT INTO public.who_global_data VALUES (69266, 188, 3032, 19, 224, 293, 129);
INSERT INTO public.who_global_data VALUES (69267, 13, 190, 0, 7, 293, 121);
INSERT INTO public.who_global_data VALUES (69268, 28, 79, 0, 0, 293, 59);
INSERT INTO public.who_global_data VALUES (69269, 4, 39, 0, 0, 293, 96);
INSERT INTO public.who_global_data VALUES (69270, 53, 1512, 0, 38, 293, 41);
INSERT INTO public.who_global_data VALUES (69271, 3, 22, 0, 1, 293, 216);
INSERT INTO public.who_global_data VALUES (69272, 9, 105, 0, 3, 293, 236);
INSERT INTO public.who_global_data VALUES (69273, 0, 11, 0, 0, 293, 150);
INSERT INTO public.who_global_data VALUES (69274, 0, 184, 0, 0, 293, 61);
INSERT INTO public.who_global_data VALUES (69275, 0, 17, 0, 0, 293, 7);
INSERT INTO public.who_global_data VALUES (69276, 192, 3681, 8, 90, 293, 169);
INSERT INTO public.who_global_data VALUES (69277, 2558, 110721, 636, 19295, 293, 28);
INSERT INTO public.who_global_data VALUES (69278, 0, 96, 0, 0, 293, 85);
INSERT INTO public.who_global_data VALUES (69279, 0, 55, 0, 0, 293, 211);
INSERT INTO public.who_global_data VALUES (69280, 13, 108, 0, 1, 293, 60);
INSERT INTO public.who_global_data VALUES (69281, 0, 9, 0, 1, 293, 3);
INSERT INTO public.who_global_data VALUES (69282, 9, 394, 1, 4, 293, 11);
INSERT INTO public.who_global_data VALUES (69283, 2458, 139897, 184, 4294, 293, 89);
INSERT INTO public.who_global_data VALUES (69284, 193, 834, 1, 9, 293, 24);
INSERT INTO public.who_global_data VALUES (69285, 0, 133, 0, 0, 293, 162);
INSERT INTO public.who_global_data VALUES (69286, 0, 2207, 0, 105, 293, 100);
INSERT INTO public.who_global_data VALUES (69287, 0, 11, 0, 0, 293, 47);
INSERT INTO public.who_global_data VALUES (69288, 0, 13, 0, 0, 293, 29);
INSERT INTO public.who_global_data VALUES (69289, 0, 145, 2, 10, 293, 40);
INSERT INTO public.who_global_data VALUES (69290, 0, 133, 0, 5, 293, 222);
INSERT INTO public.who_global_data VALUES (69291, 21, 235, 0, 7, 293, 132);
INSERT INTO public.who_global_data VALUES (69292, 2, 236, 0, 9, 293, 130);
INSERT INTO public.who_global_data VALUES (69293, 39, 477, 2, 3, 293, 234);
INSERT INTO public.who_global_data VALUES (69294, 0, 50, 0, 0, 293, 23);
INSERT INTO public.who_global_data VALUES (69295, 6, 63, 0, 6, 293, 192);
INSERT INTO public.who_global_data VALUES (69296, 1, 44, 0, 3, 293, 69);
INSERT INTO public.who_global_data VALUES (69297, 0, 8, 0, 0, 293, 187);
INSERT INTO public.who_global_data VALUES (69298, 15, 457, 5, 46, 293, 230);
INSERT INTO public.who_global_data VALUES (69299, 82, 1916, 17, 189, 293, 77);
INSERT INTO public.who_global_data VALUES (69300, 6, 1760, 1, 9, 293, 9);
INSERT INTO public.who_global_data VALUES (69301, 1334, 15712, 27, 507, 293, 74);
INSERT INTO public.who_global_data VALUES (69302, 327, 6575, 47, 582, 293, 224);
INSERT INTO public.who_global_data VALUES (69303, 1343, 82211, 87, 5118, 293, 199);
INSERT INTO public.who_global_data VALUES (69304, 31, 1513, 1, 82, 293, 190);
INSERT INTO public.who_global_data VALUES (69305, 778, 14758, 41, 571, 293, 12);
INSERT INTO public.who_global_data VALUES (69306, 2, 291, 0, 4, 293, 104);
INSERT INTO public.who_global_data VALUES (69307, 298, 13252, 9, 155, 293, 153);
INSERT INTO public.who_global_data VALUES (69308, 3491, 175925, 480, 23227, 293, 91);
INSERT INTO public.who_global_data VALUES (69309, 20, 163, 0, 5, 293, 215);
INSERT INTO public.who_global_data VALUES (69310, 566, 10361, 7, 161, 293, 84);
INSERT INTO public.who_global_data VALUES (69311, 11, 234, 1, 11, 293, 231);
INSERT INTO public.who_global_data VALUES (69312, 6, 413, 0, 7, 293, 196);
INSERT INTO public.who_global_data VALUES (69313, 141, 1768, 0, 19, 293, 105);
INSERT INTO public.who_global_data VALUES (69314, 16, 262, 1, 12, 293, 122);
INSERT INTO public.who_global_data VALUES (69315, 0, 0, 0, 0, 293, 159);
INSERT INTO public.who_global_data VALUES (69316, 30, 510, 0, 13, 293, 75);
INSERT INTO public.who_global_data VALUES (69317, 164, 1915, 1, 7, 293, 27);
INSERT INTO public.who_global_data VALUES (69318, 48, 554, 0, 5, 293, 54);
INSERT INTO public.who_global_data VALUES (69319, 0, 19, 0, 0, 293, 226);
INSERT INTO public.who_global_data VALUES (69320, 30, 712, 0, 5, 293, 79);
INSERT INTO public.who_global_data VALUES (69321, 1, 673, 0, 21, 293, 56);
INSERT INTO public.who_global_data VALUES (69322, 0, 0, 0, 0, 293, 117);
INSERT INTO public.who_global_data VALUES (69323, 5, 81, 0, 7, 293, 152);
INSERT INTO public.who_global_data VALUES (69324, 0, 49, 0, 1, 293, 16);
INSERT INTO public.who_global_data VALUES (69325, 0, 82, 0, 1, 293, 10);
INSERT INTO public.who_global_data VALUES (69326, 62, 1153, 1, 34, 293, 201);
INSERT INTO public.who_global_data VALUES (69327, 57, 3537, 0, 72, 293, 174);
INSERT INTO public.who_global_data VALUES (69328, 3, 120, 0, 0, 293, 119);
INSERT INTO public.who_global_data VALUES (69329, 0, 17, 0, 2, 293, 168);
INSERT INTO public.who_global_data VALUES (69330, 54, 5305, 2, 88, 293, 99);
INSERT INTO public.who_global_data VALUES (69331, 17, 51, 0, 0, 293, 171);
INSERT INTO public.who_global_data VALUES (69332, 26, 216, 0, 13, 293, 87);
INSERT INTO public.who_global_data VALUES (69333, 1, 427, 0, 3, 293, 123);
INSERT INTO public.who_global_data VALUES (69334, 0, 0, 0, 0, 293, 151);
INSERT INTO public.who_global_data VALUES (69335, 4, 163, 4, 12, 293, 213);
INSERT INTO public.who_global_data VALUES (69336, 0, 7, 0, 1, 293, 118);
INSERT INTO public.who_global_data VALUES (69337, 1, 325, 0, 9, 293, 134);
INSERT INTO public.who_global_data VALUES (69338, 0, 245, 0, 4, 293, 65);
INSERT INTO public.who_global_data VALUES (69339, 578, 6875, 60, 546, 293, 102);
INSERT INTO public.who_global_data VALUES (69340, 0, 0, 0, 0, 293, 223);
INSERT INTO public.who_global_data VALUES (69341, 0, 65, 0, 1, 293, 4);
INSERT INTO public.who_global_data VALUES (69342, 1, 32, 0, 0, 293, 146);
INSERT INTO public.who_global_data VALUES (69343, 3, 311, 0, 5, 293, 31);
INSERT INTO public.who_global_data VALUES (69344, 0, 11, 0, 0, 293, 127);
INSERT INTO public.who_global_data VALUES (69345, 150, 2820, 1, 138, 293, 22);
INSERT INTO public.who_global_data VALUES (69346, 0, 31, 0, 0, 293, 115);
INSERT INTO public.who_global_data VALUES (69347, 13, 107, 0, 5, 293, 106);
INSERT INTO public.who_global_data VALUES (69348, 0, 16, 0, 0, 293, 90);
INSERT INTO public.who_global_data VALUES (69349, 0, 0, 0, 0, 293, 70);
INSERT INTO public.who_global_data VALUES (69350, 1, 31, 0, 0, 293, 46);
INSERT INTO public.who_global_data VALUES (69351, 1186, 31400, 149, 3568, 293, 139);
INSERT INTO public.who_global_data VALUES (69352, 0, 18, 0, 0, 293, 42);
INSERT INTO public.who_global_data VALUES (69353, 4, 1098, 0, 11, 293, 80);
INSERT INTO public.who_global_data VALUES (69354, 0, 9, 0, 1, 293, 203);
INSERT INTO public.who_global_data VALUES (69355, 12, 639, 1, 19, 293, 136);
INSERT INTO public.who_global_data VALUES (69356, 0, 373, 0, 11, 293, 63);
INSERT INTO public.who_global_data VALUES (69357, 0, 0, 0, 0, 293, 17);
INSERT INTO public.who_global_data VALUES (69358, 0, 14, 0, 2, 293, 172);
INSERT INTO public.who_global_data VALUES (69359, 53, 1170, 0, 49, 293, 109);
INSERT INTO public.who_global_data VALUES (69360, 193, 6984, 12, 148, 293, 200);
INSERT INTO public.who_global_data VALUES (69361, 9, 322, 0, 2, 293, 93);
INSERT INTO public.who_global_data VALUES (69362, 86, 1266, 0, 6, 293, 5);
INSERT INTO public.who_global_data VALUES (69363, 0, 712, 0, 13, 293, 214);
INSERT INTO public.who_global_data VALUES (69364, 355, 7993, 16, 159, 293, 204);
INSERT INTO public.who_global_data VALUES (69365, 0, 0, 0, 0, 293, 198);
INSERT INTO public.who_global_data VALUES (69366, 194, 4210, 6, 115, 293, 173);
INSERT INTO public.who_global_data VALUES (69367, 0, 7, 0, 0, 293, 229);
INSERT INTO public.who_global_data VALUES (69368, 3, 202, 0, 8, 293, 76);
INSERT INTO public.who_global_data VALUES (69369, 0, 13489, 0, 300, 293, 138);
INSERT INTO public.who_global_data VALUES (69370, 209, 6087, 10, 397, 293, 98);
INSERT INTO public.who_global_data VALUES (69371, 0, 0, 0, 0, 293, 103);
INSERT INTO public.who_global_data VALUES (69372, 363, 8742, 15, 347, 293, 225);
INSERT INTO public.who_global_data VALUES (69373, 663, 19685, 30, 687, 293, 131);
INSERT INTO public.who_global_data VALUES (69374, 50, 1118, 0, 48, 293, 235);
INSERT INTO public.who_global_data VALUES (69375, 440, 5448, 0, 8, 293, 137);
INSERT INTO public.who_global_data VALUES (69376, 8, 10661, 2, 234, 293, 81);
INSERT INTO public.who_global_data VALUES (69377, 87, 2351, 4, 60, 293, 182);
INSERT INTO public.who_global_data VALUES (69378, 5, 407, 0, 0, 293, 145);
INSERT INTO public.who_global_data VALUES (69379, 351, 8418, 17, 417, 293, 26);
INSERT INTO public.who_global_data VALUES (69380, 6060, 42853, 48, 361, 293, 170);
INSERT INTO public.who_global_data VALUES (69381, 6, 144, 0, 0, 293, 191);
INSERT INTO public.who_global_data VALUES (69382, 0, 2, 0, 0, 293, 221);
INSERT INTO public.who_global_data VALUES (69383, 0, 6, 0, 0, 293, 64);
INSERT INTO public.who_global_data VALUES (69384, 0, 0, 0, 0, 293, 116);
INSERT INTO public.who_global_data VALUES (69385, 0, 14, 0, 0, 293, 128);
INSERT INTO public.who_global_data VALUES (69386, 0, 15, 0, 0, 293, 6);
INSERT INTO public.who_global_data VALUES (69387, 2, 37, 0, 2, 293, 227);
INSERT INTO public.who_global_data VALUES (69388, 0, 1, 0, 0, 293, 68);
INSERT INTO public.who_global_data VALUES (69389, 0, 12, 0, 0, 293, 184);
INSERT INTO public.who_global_data VALUES (69390, 0, 0, 0, 0, 293, 82);
INSERT INTO public.who_global_data VALUES (69391, 29, 455, 1, 39, 293, 149);
INSERT INTO public.who_global_data VALUES (69392, 0, 4, 0, 0, 293, 197);
INSERT INTO public.who_global_data VALUES (69393, 1088, 9362, 5, 97, 293, 78);
INSERT INTO public.who_global_data VALUES (69394, 8, 350, 0, 3, 293, 233);
INSERT INTO public.who_global_data VALUES (69395, 304, 5994, 7, 117, 293, 133);
INSERT INTO public.who_global_data VALUES (69396, 0, 11, 0, 0, 293, 35);
INSERT INTO public.who_global_data VALUES (69397, 4, 30, 0, 0, 293, 114);
INSERT INTO public.who_global_data VALUES (69398, 942, 5992, 0, 11, 293, 237);
INSERT INTO public.who_global_data VALUES (69399, 0, 2, 0, 0, 293, 55);
INSERT INTO public.who_global_data VALUES (69400, 0, 57, 0, 9, 293, 176);
INSERT INTO public.who_global_data VALUES (69401, 40, 1089, 2, 11, 293, 202);
INSERT INTO public.who_global_data VALUES (69402, 13, 1331, 3, 78, 293, 155);
INSERT INTO public.who_global_data VALUES (69403, 0, 0, 0, 0, 293, 32);
INSERT INTO public.who_global_data VALUES (69404, 19, 135, 2, 7, 293, 220);
INSERT INTO public.who_global_data VALUES (69405, 251, 3034, 2, 52, 293, 30);
INSERT INTO public.who_global_data VALUES (69406, 0, 4, 0, 0, 293, 147);
INSERT INTO public.who_global_data VALUES (69407, 3464, 201371, 507, 21925, 293, 208);
INSERT INTO public.who_global_data VALUES (69408, 10, 254, 0, 7, 293, 45);
INSERT INTO public.who_global_data VALUES (69409, 0, 66, 0, 10, 293, 110);
INSERT INTO public.who_global_data VALUES (69410, 0, 10, 0, 1, 293, 88);
INSERT INTO public.who_global_data VALUES (69411, 688, 13743, 83, 1877, 293, 51);
INSERT INTO public.who_global_data VALUES (69412, 145, 27976, 34, 1322, 293, 209);
INSERT INTO public.who_global_data VALUES (69413, 0, 38, 0, 2, 293, 205);
INSERT INTO public.who_global_data VALUES (69414, 0, 0, 0, 0, 293, 18);
INSERT INTO public.who_global_data VALUES (69415, 32, 2765, 0, 47, 293, 72);
INSERT INTO public.who_global_data VALUES (69416, 4956, 116691, 1105, 18047, 293, 44);
INSERT INTO public.who_global_data VALUES (69417, 1, 19, 0, 0, 293, 15);
INSERT INTO public.who_global_data VALUES (69418, 0, 83, 0, 5, 293, 25);
INSERT INTO public.who_global_data VALUES (69419, 0, 0, 0, 0, 293, 179);
INSERT INTO public.who_global_data VALUES (69420, 0, 0, 0, 0, 293, 34);
INSERT INTO public.who_global_data VALUES (69421, 0, 114, 0, 8, 293, 207);
INSERT INTO public.who_global_data VALUES (69422, 2, 866, 0, 37, 293, 166);
INSERT INTO public.who_global_data VALUES (69423, 3783, 82329, 121, 1890, 293, 126);
INSERT INTO public.who_global_data VALUES (69424, 0, 0, 0, 0, 293, 97);
INSERT INTO public.who_global_data VALUES (69425, 0, 11, 0, 1, 293, 36);
INSERT INTO public.who_global_data VALUES (69426, 0, 0, 0, 0, 293, 125);
INSERT INTO public.who_global_data VALUES (69427, 0, 55, 0, 0, 293, 124);
INSERT INTO public.who_global_data VALUES (69428, 343, 5449, 8, 141, 293, 185);
INSERT INTO public.who_global_data VALUES (69429, 479, 6781, 4, 41, 293, 194);
INSERT INTO public.who_global_data VALUES (69430, 0, 148, 0, 5, 293, 144);
INSERT INTO public.who_global_data VALUES (69431, 30023, 695353, 2438, 36736, 293, 19);
INSERT INTO public.who_global_data VALUES (69432, 2, 53, 1, 3, 293, 217);
INSERT INTO public.who_global_data VALUES (69433, 6, 508, 0, 9, 293, 148);
INSERT INTO public.who_global_data VALUES (69434, 45, 1495, 1, 5, 293, 86);
INSERT INTO public.who_global_data VALUES (69435, 0, 0, 0, 0, 293, 13);
INSERT INTO public.who_global_data VALUES (69436, 0, 204, 0, 9, 293, 157);
INSERT INTO public.who_global_data VALUES (69437, 0, 268, 0, 0, 293, 8);
INSERT INTO public.who_global_data VALUES (69438, 0, 0, 0, 0, 293, 73);
INSERT INTO public.who_global_data VALUES (69439, 0, 1, 0, 0, 293, 101);
INSERT INTO public.who_global_data VALUES (69440, 5, 57, 0, 2, 293, 165);
INSERT INTO public.who_global_data VALUES (69441, 1, 25, 0, 3, 293, 14);
INSERT INTO public.who_global_data VALUES (69442, 63, 908, 0, 30, 294, 193);
INSERT INTO public.who_global_data VALUES (69443, 30, 510, 0, 25, 294, 113);
INSERT INTO public.who_global_data VALUES (69444, 150, 2418, 16, 364, 294, 143);
INSERT INTO public.who_global_data VALUES (69445, 0, 0, 0, 0, 294, 219);
INSERT INTO public.who_global_data VALUES (69446, 9, 703, 1, 35, 294, 186);
INSERT INTO public.who_global_data VALUES (69447, 0, 19, 0, 2, 294, 52);
INSERT INTO public.who_global_data VALUES (69448, 0, 3, 0, 0, 294, 180);
INSERT INTO public.who_global_data VALUES (69449, 0, 23, 0, 2, 294, 167);
INSERT INTO public.who_global_data VALUES (69450, 96, 2694, 7, 122, 294, 154);
INSERT INTO public.who_global_data VALUES (69451, 42, 1177, 1, 19, 294, 94);
INSERT INTO public.who_global_data VALUES (69452, 1, 96, 0, 2, 294, 66);
INSERT INTO public.who_global_data VALUES (69453, 65, 6533, 4, 67, 294, 58);
INSERT INTO public.who_global_data VALUES (69454, 155, 14603, 21, 431, 294, 163);
INSERT INTO public.who_global_data VALUES (69455, 57, 1340, 0, 15, 294, 37);
INSERT INTO public.who_global_data VALUES (69456, 1, 54, 1, 9, 294, 142);
INSERT INTO public.who_global_data VALUES (69457, 27, 1767, 0, 7, 294, 83);
INSERT INTO public.who_global_data VALUES (69458, 306, 2144, 9, 84, 294, 228);
INSERT INTO public.who_global_data VALUES (69459, 0, 75, 0, 5, 294, 188);
INSERT INTO public.who_global_data VALUES (69460, 575, 4779, 3, 43, 294, 62);
INSERT INTO public.who_global_data VALUES (69461, 1394, 41325, 205, 5834, 294, 160);
INSERT INTO public.who_global_data VALUES (69462, 0, 18, 0, 2, 294, 50);
INSERT INTO public.who_global_data VALUES (69463, 0, 37, 0, 1, 294, 33);
INSERT INTO public.who_global_data VALUES (69464, 2, 83, 0, 5, 294, 183);
INSERT INTO public.who_global_data VALUES (69465, 0, 5, 0, 0, 294, 92);
INSERT INTO public.who_global_data VALUES (69466, 24, 465, 2, 31, 294, 158);
INSERT INTO public.who_global_data VALUES (69467, 0, 1, 0, 0, 294, 67);
INSERT INTO public.who_global_data VALUES (69468, 41, 1210, 2, 44, 294, 57);
INSERT INTO public.who_global_data VALUES (69469, 0, 15, 0, 1, 294, 38);
INSERT INTO public.who_global_data VALUES (69470, 2105, 30425, 188, 1924, 294, 141);
INSERT INTO public.who_global_data VALUES (69471, 0, 3, 0, 0, 294, 178);
INSERT INTO public.who_global_data VALUES (69472, 0, 136, 0, 1, 294, 108);
INSERT INTO public.who_global_data VALUES (69473, 46, 846, 3, 41, 294, 39);
INSERT INTO public.who_global_data VALUES (69474, 4, 547, 0, 32, 294, 2);
INSERT INTO public.who_global_data VALUES (69475, 0, 5, 0, 0, 294, 195);
INSERT INTO public.who_global_data VALUES (69476, 0, 55, 0, 1, 294, 107);
INSERT INTO public.who_global_data VALUES (69477, 0, 122, 0, 0, 294, 161);
INSERT INTO public.who_global_data VALUES (69478, 161, 1016, 4, 21, 294, 212);
INSERT INTO public.who_global_data VALUES (69479, 1775, 30659, 202, 1250, 294, 181);
INSERT INTO public.who_global_data VALUES (69480, 1, 61, 0, 1, 294, 53);
INSERT INTO public.who_global_data VALUES (69481, 0, 12, 0, 0, 294, 164);
INSERT INTO public.who_global_data VALUES (69482, 6, 33, 0, 0, 294, 140);
INSERT INTO public.who_global_data VALUES (69483, 445, 9252, 11, 116, 294, 20);
INSERT INTO public.who_global_data VALUES (69484, 31, 84180, 0, 4642, 294, 112);
INSERT INTO public.who_global_data VALUES (69485, 128, 3233, 13, 144, 294, 111);
INSERT INTO public.who_global_data VALUES (69486, 0, 0, 0, 0, 294, 71);
INSERT INTO public.who_global_data VALUES (69487, 26, 143, 1, 6, 294, 218);
INSERT INTO public.who_global_data VALUES (69488, 0, 0, 0, 0, 294, 43);
INSERT INTO public.who_global_data VALUES (69489, 16, 642, 0, 4, 294, 49);
INSERT INTO public.who_global_data VALUES (69490, 54, 742, 0, 6, 294, 1);
INSERT INTO public.who_global_data VALUES (69491, 23, 1814, 1, 36, 294, 48);
INSERT INTO public.who_global_data VALUES (69492, 61, 923, 4, 31, 294, 232);
INSERT INTO public.who_global_data VALUES (69493, 0, 14, 0, 1, 294, 175);
INSERT INTO public.who_global_data VALUES (69494, 0, 735, 0, 12, 294, 21);
INSERT INTO public.who_global_data VALUES (69495, 116, 6549, 4, 173, 294, 156);
INSERT INTO public.who_global_data VALUES (69496, 0, 0, 0, 0, 294, 95);
INSERT INTO public.who_global_data VALUES (69497, 0, 287, 0, 23, 294, 177);
INSERT INTO public.who_global_data VALUES (69498, 194, 7073, 15, 336, 294, 210);
INSERT INTO public.who_global_data VALUES (69499, 0, 732, 0, 2, 294, 120);
INSERT INTO public.who_global_data VALUES (69500, 0, 16, 0, 0, 294, 135);
INSERT INTO public.who_global_data VALUES (69501, 371, 4126, 4, 200, 294, 206);
INSERT INTO public.who_global_data VALUES (69502, 225, 8450, 18, 421, 294, 189);
INSERT INTO public.who_global_data VALUES (69503, 171, 2844, 9, 205, 294, 129);
INSERT INTO public.who_global_data VALUES (69504, 13, 177, 1, 7, 294, 121);
INSERT INTO public.who_global_data VALUES (69505, 0, 51, 0, 0, 294, 59);
INSERT INTO public.who_global_data VALUES (69506, 0, 35, 0, 0, 294, 96);
INSERT INTO public.who_global_data VALUES (69507, 25, 1459, 2, 38, 294, 41);
INSERT INTO public.who_global_data VALUES (69508, 3, 19, 0, 1, 294, 216);
INSERT INTO public.who_global_data VALUES (69509, 4, 96, 0, 3, 294, 236);
INSERT INTO public.who_global_data VALUES (69510, 0, 11, 0, 0, 294, 150);
INSERT INTO public.who_global_data VALUES (69511, 0, 184, 0, 0, 294, 61);
INSERT INTO public.who_global_data VALUES (69512, 0, 17, 0, 0, 294, 7);
INSERT INTO public.who_global_data VALUES (69513, 120, 3489, 7, 82, 294, 169);
INSERT INTO public.who_global_data VALUES (69514, 385, 108163, 760, 18659, 294, 28);
INSERT INTO public.who_global_data VALUES (69515, 0, 96, 0, 0, 294, 85);
INSERT INTO public.who_global_data VALUES (69516, 0, 55, 0, 0, 294, 211);
INSERT INTO public.who_global_data VALUES (69517, 0, 95, 0, 1, 294, 60);
INSERT INTO public.who_global_data VALUES (69518, 0, 9, 0, 1, 294, 3);
INSERT INTO public.who_global_data VALUES (69519, 15, 385, 0, 3, 294, 11);
INSERT INTO public.who_global_data VALUES (69520, 3609, 137439, 242, 4110, 294, 89);
INSERT INTO public.who_global_data VALUES (69521, 0, 641, 0, 8, 294, 24);
INSERT INTO public.who_global_data VALUES (69522, 2, 133, 0, 0, 294, 162);
INSERT INTO public.who_global_data VALUES (69523, 0, 2207, 0, 105, 294, 100);
INSERT INTO public.who_global_data VALUES (69524, 0, 11, 0, 0, 294, 47);
INSERT INTO public.who_global_data VALUES (69525, 0, 13, 0, 0, 294, 29);
INSERT INTO public.who_global_data VALUES (69526, 0, 145, 0, 8, 294, 40);
INSERT INTO public.who_global_data VALUES (69527, 0, 133, 0, 5, 294, 222);
INSERT INTO public.who_global_data VALUES (69528, 18, 214, 2, 7, 294, 132);
INSERT INTO public.who_global_data VALUES (69529, 6, 234, 1, 9, 294, 130);
INSERT INTO public.who_global_data VALUES (69530, 0, 438, 0, 1, 294, 234);
INSERT INTO public.who_global_data VALUES (69531, 4, 50, 0, 0, 294, 23);
INSERT INTO public.who_global_data VALUES (69532, 2, 57, 0, 6, 294, 192);
INSERT INTO public.who_global_data VALUES (69533, 2, 43, 0, 3, 294, 69);
INSERT INTO public.who_global_data VALUES (69534, 0, 8, 0, 0, 294, 187);
INSERT INTO public.who_global_data VALUES (69535, 16, 442, 6, 41, 294, 230);
INSERT INTO public.who_global_data VALUES (69536, 71, 1834, 16, 172, 294, 77);
INSERT INTO public.who_global_data VALUES (69537, 15, 1754, 0, 8, 294, 9);
INSERT INTO public.who_global_data VALUES (69538, 991, 14378, 43, 480, 294, 74);
INSERT INTO public.who_global_data VALUES (69539, 325, 6248, 15, 535, 294, 224);
INSERT INTO public.who_global_data VALUES (69540, 1374, 80868, 73, 5031, 294, 199);
INSERT INTO public.who_global_data VALUES (69541, 48, 1482, 1, 81, 294, 190);
INSERT INTO public.who_global_data VALUES (69542, 709, 13980, 44, 530, 294, 12);
INSERT INTO public.who_global_data VALUES (69543, 31, 289, 0, 4, 294, 104);
INSERT INTO public.who_global_data VALUES (69544, 296, 12954, 7, 146, 294, 153);
INSERT INTO public.who_global_data VALUES (69545, 3493, 172434, 575, 22747, 294, 91);
INSERT INTO public.who_global_data VALUES (69546, 18, 143, 0, 5, 294, 215);
INSERT INTO public.who_global_data VALUES (69547, 628, 9795, 6, 154, 294, 84);
INSERT INTO public.who_global_data VALUES (69548, 4, 223, 3, 10, 294, 231);
INSERT INTO public.who_global_data VALUES (69549, 5, 407, 0, 7, 294, 196);
INSERT INTO public.who_global_data VALUES (69550, 81, 1627, 2, 19, 294, 105);
INSERT INTO public.who_global_data VALUES (69551, 12, 246, 0, 11, 294, 122);
INSERT INTO public.who_global_data VALUES (69552, 0, 0, 0, 0, 294, 159);
INSERT INTO public.who_global_data VALUES (69553, 31, 480, 0, 13, 294, 75);
INSERT INTO public.who_global_data VALUES (69554, 93, 1751, 1, 6, 294, 27);
INSERT INTO public.who_global_data VALUES (69555, 17, 506, 0, 5, 294, 54);
INSERT INTO public.who_global_data VALUES (69556, 0, 19, 0, 0, 294, 226);
INSERT INTO public.who_global_data VALUES (69557, 7, 682, 0, 5, 294, 79);
INSERT INTO public.who_global_data VALUES (69558, 4, 672, 0, 21, 294, 56);
INSERT INTO public.who_global_data VALUES (69559, 0, 0, 0, 0, 294, 117);
INSERT INTO public.who_global_data VALUES (69560, 3, 76, 1, 7, 294, 152);
INSERT INTO public.who_global_data VALUES (69561, 0, 49, 0, 1, 294, 16);
INSERT INTO public.who_global_data VALUES (69562, 0, 82, 0, 1, 294, 10);
INSERT INTO public.who_global_data VALUES (69563, 41, 1091, 1, 33, 294, 201);
INSERT INTO public.who_global_data VALUES (69564, 36, 3480, 3, 72, 294, 174);
INSERT INTO public.who_global_data VALUES (69565, 0, 117, 0, 0, 294, 119);
INSERT INTO public.who_global_data VALUES (69566, 1, 17, 0, 2, 294, 168);
INSERT INTO public.who_global_data VALUES (69567, 69, 5251, 2, 86, 294, 99);
INSERT INTO public.who_global_data VALUES (69568, 6, 34, 0, 0, 294, 171);
INSERT INTO public.who_global_data VALUES (69569, 19, 190, 0, 13, 294, 87);
INSERT INTO public.who_global_data VALUES (69570, 4, 426, 0, 3, 294, 123);
INSERT INTO public.who_global_data VALUES (69571, 0, 0, 0, 0, 294, 151);
INSERT INTO public.who_global_data VALUES (69572, 0, 159, 0, 8, 294, 213);
INSERT INTO public.who_global_data VALUES (69573, 0, 7, 0, 1, 294, 118);
INSERT INTO public.who_global_data VALUES (69574, 0, 324, 0, 9, 294, 134);
INSERT INTO public.who_global_data VALUES (69575, 12, 245, 1, 4, 294, 65);
INSERT INTO public.who_global_data VALUES (69576, 450, 6297, 37, 486, 294, 102);
INSERT INTO public.who_global_data VALUES (69577, 0, 0, 0, 0, 294, 223);
INSERT INTO public.who_global_data VALUES (69578, 1, 65, 0, 1, 294, 4);
INSERT INTO public.who_global_data VALUES (69579, 0, 31, 0, 0, 294, 146);
INSERT INTO public.who_global_data VALUES (69580, 3, 308, 0, 5, 294, 31);
INSERT INTO public.who_global_data VALUES (69581, 0, 11, 0, 0, 294, 127);
INSERT INTO public.who_global_data VALUES (69582, 142, 2670, 4, 137, 294, 22);
INSERT INTO public.who_global_data VALUES (69583, 2, 31, 0, 0, 294, 115);
INSERT INTO public.who_global_data VALUES (69584, 9, 94, 1, 5, 294, 106);
INSERT INTO public.who_global_data VALUES (69585, 0, 16, 0, 0, 294, 90);
INSERT INTO public.who_global_data VALUES (69586, 0, 0, 0, 0, 294, 70);
INSERT INTO public.who_global_data VALUES (69587, 14, 30, 0, 0, 294, 46);
INSERT INTO public.who_global_data VALUES (69588, 1234, 30214, 153, 3419, 294, 139);
INSERT INTO public.who_global_data VALUES (69589, 0, 18, 0, 0, 294, 42);
INSERT INTO public.who_global_data VALUES (69590, 8, 1094, 0, 11, 294, 80);
INSERT INTO public.who_global_data VALUES (69591, 0, 9, 0, 1, 294, 203);
INSERT INTO public.who_global_data VALUES (69592, 18, 627, 3, 18, 294, 136);
INSERT INTO public.who_global_data VALUES (69593, 0, 373, 0, 11, 294, 63);
INSERT INTO public.who_global_data VALUES (69594, 0, 0, 0, 0, 294, 17);
INSERT INTO public.who_global_data VALUES (69595, 1, 14, 0, 2, 294, 172);
INSERT INTO public.who_global_data VALUES (69596, 36, 1117, 3, 49, 294, 109);
INSERT INTO public.who_global_data VALUES (69597, 0, 6791, 0, 136, 294, 200);
INSERT INTO public.who_global_data VALUES (69598, 6, 313, 0, 2, 294, 93);
INSERT INTO public.who_global_data VALUES (69599, 111, 1180, 1, 6, 294, 5);
INSERT INTO public.who_global_data VALUES (69600, 0, 712, 0, 13, 294, 214);
INSERT INTO public.who_global_data VALUES (69601, 613, 7638, 8, 143, 294, 204);
INSERT INTO public.who_global_data VALUES (69602, 0, 0, 0, 0, 294, 198);
INSERT INTO public.who_global_data VALUES (69603, 265, 4016, 6, 109, 294, 173);
INSERT INTO public.who_global_data VALUES (69604, 0, 7, 0, 0, 294, 229);
INSERT INTO public.who_global_data VALUES (69605, 25, 199, 0, 8, 294, 76);
INSERT INTO public.who_global_data VALUES (69606, 2014, 13489, 46, 300, 294, 138);
INSERT INTO public.who_global_data VALUES (69607, 218, 5878, 25, 387, 294, 98);
INSERT INTO public.who_global_data VALUES (69608, 0, 0, 0, 0, 294, 103);
INSERT INTO public.who_global_data VALUES (69609, 461, 8379, 18, 332, 294, 225);
INSERT INTO public.who_global_data VALUES (69610, 181, 19022, 28, 657, 294, 131);
INSERT INTO public.who_global_data VALUES (69611, 25, 1068, 0, 48, 294, 235);
INSERT INTO public.who_global_data VALUES (69612, 345, 5008, 1, 8, 294, 137);
INSERT INTO public.who_global_data VALUES (69613, 18, 10653, 2, 232, 294, 81);
INSERT INTO public.who_global_data VALUES (69614, 110, 2264, 2, 56, 294, 182);
INSERT INTO public.who_global_data VALUES (69615, 8, 402, 0, 0, 294, 145);
INSERT INTO public.who_global_data VALUES (69616, 360, 8067, 13, 400, 294, 26);
INSERT INTO public.who_global_data VALUES (69617, 4785, 36793, 40, 313, 294, 170);
INSERT INTO public.who_global_data VALUES (69618, 0, 138, 0, 0, 294, 191);
INSERT INTO public.who_global_data VALUES (69619, 0, 2, 0, 0, 294, 221);
INSERT INTO public.who_global_data VALUES (69620, 0, 6, 0, 0, 294, 64);
INSERT INTO public.who_global_data VALUES (69621, 0, 0, 0, 0, 294, 116);
INSERT INTO public.who_global_data VALUES (69622, 0, 14, 0, 0, 294, 128);
INSERT INTO public.who_global_data VALUES (69623, 0, 15, 0, 0, 294, 6);
INSERT INTO public.who_global_data VALUES (69624, 0, 35, 0, 2, 294, 227);
INSERT INTO public.who_global_data VALUES (69625, 0, 1, 0, 0, 294, 68);
INSERT INTO public.who_global_data VALUES (69626, 0, 12, 0, 0, 294, 184);
INSERT INTO public.who_global_data VALUES (69627, 0, 0, 0, 0, 294, 82);
INSERT INTO public.who_global_data VALUES (69628, 0, 426, 0, 38, 294, 149);
INSERT INTO public.who_global_data VALUES (69629, 0, 4, 0, 0, 294, 197);
INSERT INTO public.who_global_data VALUES (69630, 1132, 8274, 5, 92, 294, 78);
INSERT INTO public.who_global_data VALUES (69631, 7, 342, 1, 3, 294, 233);
INSERT INTO public.who_global_data VALUES (69632, 372, 5690, 7, 110, 294, 133);
INSERT INTO public.who_global_data VALUES (69633, 0, 11, 0, 0, 294, 35);
INSERT INTO public.who_global_data VALUES (69634, 11, 26, 0, 0, 294, 114);
INSERT INTO public.who_global_data VALUES (69635, 623, 5050, 1, 11, 294, 237);
INSERT INTO public.who_global_data VALUES (69636, 0, 2, 0, 0, 294, 55);
INSERT INTO public.who_global_data VALUES (69637, 0, 57, 0, 9, 294, 176);
INSERT INTO public.who_global_data VALUES (69638, 72, 1049, 1, 9, 294, 202);
INSERT INTO public.who_global_data VALUES (69639, 13, 1318, 4, 75, 294, 155);
INSERT INTO public.who_global_data VALUES (69640, 0, 0, 0, 0, 294, 32);
INSERT INTO public.who_global_data VALUES (69641, 36, 116, 0, 5, 294, 220);
INSERT INTO public.who_global_data VALUES (69642, 178, 2783, 2, 50, 294, 30);
INSERT INTO public.who_global_data VALUES (69643, 0, 4, 0, 0, 294, 147);
INSERT INTO public.who_global_data VALUES (69644, 3418, 197907, 487, 21418, 294, 208);
INSERT INTO public.who_global_data VALUES (69645, 6, 244, 0, 7, 294, 45);
INSERT INTO public.who_global_data VALUES (69646, 34, 66, 5, 10, 294, 110);
INSERT INTO public.who_global_data VALUES (69647, 0, 10, 0, 1, 294, 88);
INSERT INTO public.who_global_data VALUES (69648, 623, 13055, 111, 1794, 294, 51);
INSERT INTO public.who_global_data VALUES (69649, 291, 27831, 36, 1288, 294, 209);
INSERT INTO public.who_global_data VALUES (69650, 5, 38, 0, 2, 294, 205);
INSERT INTO public.who_global_data VALUES (69651, 0, 0, 0, 0, 294, 18);
INSERT INTO public.who_global_data VALUES (69652, 33, 2733, 0, 47, 294, 72);
INSERT INTO public.who_global_data VALUES (69653, 5292, 111735, 913, 16942, 294, 44);
INSERT INTO public.who_global_data VALUES (69654, 0, 18, 0, 0, 294, 15);
INSERT INTO public.who_global_data VALUES (69655, 2, 83, 0, 5, 294, 25);
INSERT INTO public.who_global_data VALUES (69656, 0, 0, 0, 0, 294, 179);
INSERT INTO public.who_global_data VALUES (69657, 0, 0, 0, 0, 294, 34);
INSERT INTO public.who_global_data VALUES (69658, 0, 114, 0, 8, 294, 207);
INSERT INTO public.who_global_data VALUES (69659, 42, 864, 0, 37, 294, 166);
INSERT INTO public.who_global_data VALUES (69660, 4353, 78546, 126, 1769, 294, 126);
INSERT INTO public.who_global_data VALUES (69661, 0, 0, 0, 0, 294, 97);
INSERT INTO public.who_global_data VALUES (69662, 0, 11, 0, 1, 294, 36);
INSERT INTO public.who_global_data VALUES (69663, 0, 0, 0, 0, 294, 125);
INSERT INTO public.who_global_data VALUES (69664, 0, 55, 0, 0, 294, 124);
INSERT INTO public.who_global_data VALUES (69665, 444, 5106, 8, 133, 294, 185);
INSERT INTO public.who_global_data VALUES (69666, 477, 6302, 2, 37, 294, 194);
INSERT INTO public.who_global_data VALUES (69667, 54, 148, 1, 5, 294, 144);
INSERT INTO public.who_global_data VALUES (69668, 32549, 665330, 2018, 34298, 294, 19);
INSERT INTO public.who_global_data VALUES (69669, 0, 51, 1, 2, 294, 217);
INSERT INTO public.who_global_data VALUES (69670, 9, 502, 0, 9, 294, 148);
INSERT INTO public.who_global_data VALUES (69671, 70, 1450, 0, 4, 294, 86);
INSERT INTO public.who_global_data VALUES (69672, 0, 0, 0, 0, 294, 13);
INSERT INTO public.who_global_data VALUES (69673, 7, 204, 0, 9, 294, 157);
INSERT INTO public.who_global_data VALUES (69674, 0, 268, 0, 0, 294, 8);
INSERT INTO public.who_global_data VALUES (69675, 0, 0, 0, 0, 294, 73);
INSERT INTO public.who_global_data VALUES (69676, 0, 1, 0, 0, 294, 101);
INSERT INTO public.who_global_data VALUES (69677, 4, 52, 0, 2, 294, 165);
INSERT INTO public.who_global_data VALUES (69678, 1, 24, 0, 3, 294, 14);
INSERT INTO public.who_global_data VALUES (69679, 51, 845, 1, 30, 295, 193);
INSERT INTO public.who_global_data VALUES (69680, 24, 480, 1, 25, 295, 113);
INSERT INTO public.who_global_data VALUES (69681, 108, 2268, 12, 348, 295, 143);
INSERT INTO public.who_global_data VALUES (69682, 0, 0, 0, 0, 295, 219);
INSERT INTO public.who_global_data VALUES (69683, 21, 694, 1, 34, 295, 186);
INSERT INTO public.who_global_data VALUES (69684, 0, 19, 0, 2, 295, 52);
INSERT INTO public.who_global_data VALUES (69685, 0, 3, 0, 0, 295, 180);
INSERT INTO public.who_global_data VALUES (69686, 0, 23, 0, 2, 295, 167);
INSERT INTO public.who_global_data VALUES (69687, 121, 2598, 7, 115, 295, 154);
INSERT INTO public.who_global_data VALUES (69688, 48, 1135, 1, 18, 295, 94);
INSERT INTO public.who_global_data VALUES (69689, 2, 95, 1, 2, 295, 66);
INSERT INTO public.who_global_data VALUES (69690, 10, 6468, 0, 63, 295, 58);
INSERT INTO public.who_global_data VALUES (69691, 78, 14448, 17, 410, 295, 163);
INSERT INTO public.who_global_data VALUES (69692, 30, 1283, 2, 15, 295, 37);
INSERT INTO public.who_global_data VALUES (69693, 4, 53, 0, 8, 295, 142);
INSERT INTO public.who_global_data VALUES (69694, 42, 1740, 0, 7, 295, 83);
INSERT INTO public.who_global_data VALUES (69695, 266, 1838, 15, 75, 295, 228);
INSERT INTO public.who_global_data VALUES (69696, 2, 75, 0, 5, 295, 188);
INSERT INTO public.who_global_data VALUES (69697, 476, 4204, 4, 40, 295, 62);
INSERT INTO public.who_global_data VALUES (69698, 1674, 39931, 246, 5629, 295, 160);
INSERT INTO public.who_global_data VALUES (69699, 0, 18, 0, 2, 295, 50);
INSERT INTO public.who_global_data VALUES (69700, 2, 37, 0, 1, 295, 33);
INSERT INTO public.who_global_data VALUES (69701, 24, 81, 0, 5, 295, 183);
INSERT INTO public.who_global_data VALUES (69702, 0, 5, 0, 0, 295, 92);
INSERT INTO public.who_global_data VALUES (69703, 44, 441, 1, 29, 295, 158);
INSERT INTO public.who_global_data VALUES (69704, 0, 1, 0, 0, 295, 67);
INSERT INTO public.who_global_data VALUES (69705, 53, 1169, 1, 42, 295, 57);
INSERT INTO public.who_global_data VALUES (69706, 2, 15, 0, 1, 295, 38);
INSERT INTO public.who_global_data VALUES (69707, 3058, 28320, 204, 1736, 295, 141);
INSERT INTO public.who_global_data VALUES (69708, 0, 3, 0, 0, 295, 178);
INSERT INTO public.who_global_data VALUES (69709, 0, 136, 0, 1, 295, 108);
INSERT INTO public.who_global_data VALUES (69710, 53, 800, 2, 38, 295, 39);
INSERT INTO public.who_global_data VALUES (69711, 15, 543, 4, 32, 295, 2);
INSERT INTO public.who_global_data VALUES (69712, 0, 5, 0, 0, 295, 195);
INSERT INTO public.who_global_data VALUES (69713, 45, 55, 0, 1, 295, 107);
INSERT INTO public.who_global_data VALUES (69714, 0, 122, 0, 0, 295, 161);
INSERT INTO public.who_global_data VALUES (69715, 0, 855, 0, 17, 295, 212);
INSERT INTO public.who_global_data VALUES (69716, 1344, 28884, 94, 1048, 295, 181);
INSERT INTO public.who_global_data VALUES (69717, 6, 60, 0, 1, 295, 53);
INSERT INTO public.who_global_data VALUES (69718, 1, 12, 0, 0, 295, 164);
INSERT INTO public.who_global_data VALUES (69719, 0, 27, 0, 0, 295, 140);
INSERT INTO public.who_global_data VALUES (69720, 534, 8807, 11, 105, 295, 20);
INSERT INTO public.who_global_data VALUES (69721, 352, 84149, 1290, 4642, 295, 112);
INSERT INTO public.who_global_data VALUES (69722, 126, 3105, 4, 131, 295, 111);
INSERT INTO public.who_global_data VALUES (69723, 0, 0, 0, 0, 295, 71);
INSERT INTO public.who_global_data VALUES (69724, 0, 117, 0, 5, 295, 218);
INSERT INTO public.who_global_data VALUES (69725, 0, 0, 0, 0, 295, 43);
INSERT INTO public.who_global_data VALUES (69726, 8, 626, 1, 4, 295, 49);
INSERT INTO public.who_global_data VALUES (69727, 34, 688, 0, 6, 295, 1);
INSERT INTO public.who_global_data VALUES (69728, 50, 1791, 1, 35, 295, 48);
INSERT INTO public.who_global_data VALUES (69729, 48, 862, 3, 27, 295, 232);
INSERT INTO public.who_global_data VALUES (69730, 0, 14, 0, 1, 295, 175);
INSERT INTO public.who_global_data VALUES (69731, 20, 735, 0, 12, 295, 21);
INSERT INTO public.who_global_data VALUES (69732, 130, 6433, 3, 169, 295, 156);
INSERT INTO public.who_global_data VALUES (69733, 0, 0, 0, 0, 295, 95);
INSERT INTO public.who_global_data VALUES (69734, 20, 287, 1, 23, 295, 177);
INSERT INTO public.who_global_data VALUES (69735, 198, 6879, 12, 321, 295, 210);
INSERT INTO public.who_global_data VALUES (69736, 141, 732, 0, 2, 295, 120);
INSERT INTO public.who_global_data VALUES (69737, 0, 16, 0, 0, 295, 135);
INSERT INTO public.who_global_data VALUES (69738, 141, 3755, 7, 196, 295, 206);
INSERT INTO public.who_global_data VALUES (69739, 367, 8225, 15, 403, 295, 189);
INSERT INTO public.who_global_data VALUES (69740, 168, 2673, 13, 196, 295, 129);
INSERT INTO public.who_global_data VALUES (69741, 5, 164, 0, 6, 295, 121);
INSERT INTO public.who_global_data VALUES (69742, 0, 51, 0, 0, 295, 59);
INSERT INTO public.who_global_data VALUES (69743, 0, 35, 0, 0, 295, 96);
INSERT INTO public.who_global_data VALUES (69744, 32, 1434, 1, 36, 295, 41);
INSERT INTO public.who_global_data VALUES (69745, 0, 16, 1, 1, 295, 216);
INSERT INTO public.who_global_data VALUES (69746, 7, 92, 0, 3, 295, 236);
INSERT INTO public.who_global_data VALUES (69747, 0, 11, 0, 0, 295, 150);
INSERT INTO public.who_global_data VALUES (69748, 0, 184, 0, 0, 295, 61);
INSERT INTO public.who_global_data VALUES (69749, 1, 17, 0, 0, 295, 7);
INSERT INTO public.who_global_data VALUES (69750, 132, 3369, 3, 75, 295, 169);
INSERT INTO public.who_global_data VALUES (69751, 2623, 107778, 753, 17899, 295, 28);
INSERT INTO public.who_global_data VALUES (69752, 1, 96, 0, 0, 295, 85);
INSERT INTO public.who_global_data VALUES (69753, 0, 55, 0, 0, 295, 211);
INSERT INTO public.who_global_data VALUES (69754, 8, 95, 0, 1, 295, 60);
INSERT INTO public.who_global_data VALUES (69755, 0, 9, 0, 1, 295, 3);
INSERT INTO public.who_global_data VALUES (69756, 34, 370, 0, 3, 295, 11);
INSERT INTO public.who_global_data VALUES (69757, 3380, 133830, 299, 3868, 295, 89);
INSERT INTO public.who_global_data VALUES (69758, 5, 641, 0, 8, 295, 24);
INSERT INTO public.who_global_data VALUES (69759, 2, 131, 0, 0, 295, 162);
INSERT INTO public.who_global_data VALUES (69760, 15, 2207, 3, 105, 295, 100);
INSERT INTO public.who_global_data VALUES (69761, 0, 11, 0, 0, 295, 47);
INSERT INTO public.who_global_data VALUES (69762, 0, 13, 0, 0, 295, 29);
INSERT INTO public.who_global_data VALUES (69763, 0, 145, 0, 8, 295, 40);
INSERT INTO public.who_global_data VALUES (69764, 0, 133, 0, 5, 295, 222);
INSERT INTO public.who_global_data VALUES (69765, 16, 196, 0, 5, 295, 132);
INSERT INTO public.who_global_data VALUES (69766, 5, 228, 1, 8, 295, 130);
INSERT INTO public.who_global_data VALUES (69767, 34, 438, 0, 1, 295, 234);
INSERT INTO public.who_global_data VALUES (69768, 3, 46, 0, 0, 295, 23);
INSERT INTO public.who_global_data VALUES (69769, 7, 55, 0, 6, 295, 192);
INSERT INTO public.who_global_data VALUES (69770, 0, 41, 0, 3, 295, 69);
INSERT INTO public.who_global_data VALUES (69771, 0, 8, 0, 0, 295, 187);
INSERT INTO public.who_global_data VALUES (69772, 7, 426, 4, 35, 295, 230);
INSERT INTO public.who_global_data VALUES (69773, 111, 1763, 14, 156, 295, 77);
INSERT INTO public.who_global_data VALUES (69774, 12, 1739, 0, 8, 295, 9);
INSERT INTO public.who_global_data VALUES (69775, 1007, 13387, 23, 437, 295, 74);
INSERT INTO public.who_global_data VALUES (69776, 407, 5923, 24, 520, 295, 224);
INSERT INTO public.who_global_data VALUES (69777, 1499, 79494, 89, 4958, 295, 199);
INSERT INTO public.who_global_data VALUES (69778, 0, 1434, 0, 80, 295, 190);
INSERT INTO public.who_global_data VALUES (69779, 724, 13271, 42, 486, 295, 12);
INSERT INTO public.who_global_data VALUES (69780, 4, 258, 2, 4, 295, 104);
INSERT INTO public.who_global_data VALUES (69781, 311, 12658, 13, 139, 295, 153);
INSERT INTO public.who_global_data VALUES (69782, 3786, 168941, 525, 22172, 295, 91);
INSERT INTO public.who_global_data VALUES (69783, 20, 125, 0, 5, 295, 215);
INSERT INTO public.who_global_data VALUES (69784, 585, 9167, 12, 148, 295, 84);
INSERT INTO public.who_global_data VALUES (69785, 2, 219, 1, 7, 295, 231);
INSERT INTO public.who_global_data VALUES (69786, 1, 402, 0, 7, 295, 196);
INSERT INTO public.who_global_data VALUES (69787, 66, 1546, 1, 17, 295, 105);
INSERT INTO public.who_global_data VALUES (69788, 9, 234, 1, 11, 295, 122);
INSERT INTO public.who_global_data VALUES (69789, 0, 0, 0, 0, 295, 159);
INSERT INTO public.who_global_data VALUES (69790, 52, 449, 1, 13, 295, 75);
INSERT INTO public.who_global_data VALUES (69791, 134, 1658, 2, 5, 295, 27);
INSERT INTO public.who_global_data VALUES (69792, 23, 489, 0, 5, 295, 54);
INSERT INTO public.who_global_data VALUES (69793, 0, 19, 0, 0, 295, 226);
INSERT INTO public.who_global_data VALUES (69794, 9, 675, 0, 5, 295, 79);
INSERT INTO public.who_global_data VALUES (69795, 5, 668, 0, 21, 295, 56);
INSERT INTO public.who_global_data VALUES (69796, 0, 0, 0, 0, 295, 117);
INSERT INTO public.who_global_data VALUES (69797, 14, 73, 0, 6, 295, 152);
INSERT INTO public.who_global_data VALUES (69798, 1, 49, 0, 1, 295, 16);
INSERT INTO public.who_global_data VALUES (69799, 1, 82, 0, 1, 295, 10);
INSERT INTO public.who_global_data VALUES (69800, 28, 1050, 2, 32, 295, 201);
INSERT INTO public.who_global_data VALUES (69801, 71, 3444, 0, 69, 295, 174);
INSERT INTO public.who_global_data VALUES (69802, 7, 117, 0, 0, 295, 119);
INSERT INTO public.who_global_data VALUES (69803, 0, 16, 0, 2, 295, 168);
INSERT INTO public.who_global_data VALUES (69804, 110, 5182, 1, 84, 295, 99);
INSERT INTO public.who_global_data VALUES (69805, 5, 28, 0, 0, 295, 171);
INSERT INTO public.who_global_data VALUES (69806, 27, 171, 0, 13, 295, 87);
INSERT INTO public.who_global_data VALUES (69807, 10, 422, 0, 3, 295, 123);
INSERT INTO public.who_global_data VALUES (69808, 0, 0, 0, 0, 295, 151);
INSERT INTO public.who_global_data VALUES (69809, 1, 159, 0, 8, 295, 213);
INSERT INTO public.who_global_data VALUES (69810, 0, 7, 0, 1, 295, 118);
INSERT INTO public.who_global_data VALUES (69811, 0, 324, 0, 9, 295, 134);
INSERT INTO public.who_global_data VALUES (69812, 12, 233, 0, 3, 295, 65);
INSERT INTO public.who_global_data VALUES (69813, 448, 5847, 43, 449, 295, 102);
INSERT INTO public.who_global_data VALUES (69814, 0, 0, 0, 0, 295, 223);
INSERT INTO public.who_global_data VALUES (69815, 0, 64, 0, 1, 295, 4);
INSERT INTO public.who_global_data VALUES (69816, 0, 31, 0, 0, 295, 146);
INSERT INTO public.who_global_data VALUES (69817, 2, 305, 1, 5, 295, 31);
INSERT INTO public.who_global_data VALUES (69818, 0, 11, 0, 0, 295, 127);
INSERT INTO public.who_global_data VALUES (69819, 277, 2528, 5, 133, 295, 22);
INSERT INTO public.who_global_data VALUES (69820, 1, 29, 0, 0, 295, 115);
INSERT INTO public.who_global_data VALUES (69821, 0, 85, 0, 4, 295, 106);
INSERT INTO public.who_global_data VALUES (69822, 0, 16, 0, 0, 295, 90);
INSERT INTO public.who_global_data VALUES (69823, 0, 0, 0, 0, 295, 70);
INSERT INTO public.who_global_data VALUES (69824, 0, 16, 0, 0, 295, 46);
INSERT INTO public.who_global_data VALUES (69825, 1071, 28980, 177, 3266, 295, 139);
INSERT INTO public.who_global_data VALUES (69826, 0, 18, 0, 0, 295, 42);
INSERT INTO public.who_global_data VALUES (69827, 2, 1086, 2, 11, 295, 80);
INSERT INTO public.who_global_data VALUES (69828, 0, 9, 0, 1, 295, 203);
INSERT INTO public.who_global_data VALUES (69829, 25, 609, 1, 15, 295, 136);
INSERT INTO public.who_global_data VALUES (69830, 0, 373, 0, 11, 295, 63);
INSERT INTO public.who_global_data VALUES (69831, 0, 0, 0, 0, 295, 17);
INSERT INTO public.who_global_data VALUES (69832, 0, 13, 0, 2, 295, 172);
INSERT INTO public.who_global_data VALUES (69833, 107, 1081, 1, 46, 295, 109);
INSERT INTO public.who_global_data VALUES (69834, 114, 6791, 6, 136, 295, 200);
INSERT INTO public.who_global_data VALUES (69835, 13, 307, 0, 2, 295, 93);
INSERT INTO public.who_global_data VALUES (69836, 50, 1069, 1, 5, 295, 5);
INSERT INTO public.who_global_data VALUES (69837, 0, 712, 1, 13, 295, 214);
INSERT INTO public.who_global_data VALUES (69838, 106, 7025, 7, 135, 295, 204);
INSERT INTO public.who_global_data VALUES (69839, 0, 0, 0, 0, 295, 198);
INSERT INTO public.who_global_data VALUES (69840, 177, 3751, 8, 103, 295, 173);
INSERT INTO public.who_global_data VALUES (69841, 5, 7, 0, 0, 295, 229);
INSERT INTO public.who_global_data VALUES (69842, 13, 174, 0, 8, 295, 76);
INSERT INTO public.who_global_data VALUES (69843, 1172, 11475, 24, 254, 295, 138);
INSERT INTO public.who_global_data VALUES (69844, 0, 5660, 0, 362, 295, 98);
INSERT INTO public.who_global_data VALUES (69845, 0, 0, 0, 0, 295, 103);
INSERT INTO public.who_global_data VALUES (69846, 336, 7918, 28, 314, 295, 225);
INSERT INTO public.who_global_data VALUES (69847, 750, 18841, 30, 629, 295, 131);
INSERT INTO public.who_global_data VALUES (69848, 69, 1043, 0, 48, 295, 235);
INSERT INTO public.who_global_data VALUES (69849, 560, 4663, 0, 7, 295, 137);
INSERT INTO public.who_global_data VALUES (69850, 22, 10635, 1, 230, 295, 81);
INSERT INTO public.who_global_data VALUES (69851, 105, 2154, 8, 54, 295, 182);
INSERT INTO public.who_global_data VALUES (69852, 4, 394, 0, 0, 295, 145);
INSERT INTO public.who_global_data VALUES (69853, 491, 7707, 15, 387, 295, 26);
INSERT INTO public.who_global_data VALUES (69854, 4070, 32008, 41, 273, 295, 170);
INSERT INTO public.who_global_data VALUES (69855, 2, 138, 0, 0, 295, 191);
INSERT INTO public.who_global_data VALUES (69856, 0, 2, 0, 0, 295, 221);
INSERT INTO public.who_global_data VALUES (69857, 0, 6, 0, 0, 295, 64);
INSERT INTO public.who_global_data VALUES (69858, 0, 0, 0, 0, 295, 116);
INSERT INTO public.who_global_data VALUES (69859, 0, 14, 0, 0, 295, 128);
INSERT INTO public.who_global_data VALUES (69860, 0, 15, 0, 0, 295, 6);
INSERT INTO public.who_global_data VALUES (69861, 0, 35, 0, 2, 295, 227);
INSERT INTO public.who_global_data VALUES (69862, 0, 1, 0, 0, 295, 68);
INSERT INTO public.who_global_data VALUES (69863, 0, 12, 0, 0, 295, 184);
INSERT INTO public.who_global_data VALUES (69864, 0, 0, 0, 0, 295, 82);
INSERT INTO public.who_global_data VALUES (69865, 33, 426, 2, 38, 295, 149);
INSERT INTO public.who_global_data VALUES (69866, 0, 4, 0, 0, 295, 197);
INSERT INTO public.who_global_data VALUES (69867, 762, 7142, 4, 87, 295, 78);
INSERT INTO public.who_global_data VALUES (69868, 21, 335, 0, 2, 295, 233);
INSERT INTO public.who_global_data VALUES (69869, 445, 5318, 4, 103, 295, 133);
INSERT INTO public.who_global_data VALUES (69870, 0, 11, 0, 0, 295, 35);
INSERT INTO public.who_global_data VALUES (69871, 2, 15, 0, 0, 295, 114);
INSERT INTO public.who_global_data VALUES (69872, 728, 4427, 0, 10, 295, 237);
INSERT INTO public.who_global_data VALUES (69873, 0, 2, 0, 0, 295, 55);
INSERT INTO public.who_global_data VALUES (69874, 4, 57, 0, 9, 295, 176);
INSERT INTO public.who_global_data VALUES (69875, 114, 977, 2, 8, 295, 202);
INSERT INTO public.who_global_data VALUES (69876, 36, 1305, 6, 71, 295, 155);
INSERT INTO public.who_global_data VALUES (69877, 0, 0, 0, 0, 295, 32);
INSERT INTO public.who_global_data VALUES (69878, 0, 80, 0, 5, 295, 220);
INSERT INTO public.who_global_data VALUES (69879, 99, 2605, 14, 48, 295, 30);
INSERT INTO public.who_global_data VALUES (69880, 0, 4, 0, 0, 295, 147);
INSERT INTO public.who_global_data VALUES (69881, 3703, 194489, 552, 20931, 295, 208);
INSERT INTO public.who_global_data VALUES (69882, 0, 238, 0, 7, 295, 45);
INSERT INTO public.who_global_data VALUES (69883, 0, 32, 0, 5, 295, 110);
INSERT INTO public.who_global_data VALUES (69884, 0, 10, 0, 1, 295, 88);
INSERT INTO public.who_global_data VALUES (69885, 604, 12432, 115, 1683, 295, 51);
INSERT INTO public.who_global_data VALUES (69886, 320, 27540, 38, 1252, 295, 209);
INSERT INTO public.who_global_data VALUES (69887, 0, 33, 0, 2, 295, 205);
INSERT INTO public.who_global_data VALUES (69888, 0, 0, 0, 0, 295, 18);
INSERT INTO public.who_global_data VALUES (69889, 28, 2700, 1, 47, 295, 72);
INSERT INTO public.who_global_data VALUES (69890, 5065, 106443, 1036, 16029, 295, 44);
INSERT INTO public.who_global_data VALUES (69891, 0, 18, 0, 0, 295, 15);
INSERT INTO public.who_global_data VALUES (69892, 4, 81, 2, 5, 295, 25);
INSERT INTO public.who_global_data VALUES (69893, 0, 0, 0, 0, 295, 179);
INSERT INTO public.who_global_data VALUES (69894, 0, 0, 0, 0, 295, 34);
INSERT INTO public.who_global_data VALUES (69895, 0, 114, 0, 8, 295, 207);
INSERT INTO public.who_global_data VALUES (69896, 42, 822, 2, 37, 295, 166);
INSERT INTO public.who_global_data VALUES (69897, 4801, 74193, 125, 1643, 295, 126);
INSERT INTO public.who_global_data VALUES (69898, 0, 0, 0, 0, 295, 97);
INSERT INTO public.who_global_data VALUES (69899, 1, 11, 0, 1, 295, 36);
INSERT INTO public.who_global_data VALUES (69900, 0, 0, 0, 0, 295, 125);
INSERT INTO public.who_global_data VALUES (69901, 0, 55, 0, 0, 295, 124);
INSERT INTO public.who_global_data VALUES (69902, 500, 4662, 10, 125, 295, 185);
INSERT INTO public.who_global_data VALUES (69903, 460, 5825, 2, 35, 295, 194);
INSERT INTO public.who_global_data VALUES (69904, 6, 94, 0, 4, 295, 144);
INSERT INTO public.who_global_data VALUES (69905, 28711, 632781, 6409, 32280, 295, 19);
INSERT INTO public.who_global_data VALUES (69906, 0, 51, 0, 1, 295, 217);
INSERT INTO public.who_global_data VALUES (69907, 1, 493, 1, 9, 295, 148);
INSERT INTO public.who_global_data VALUES (69908, 31, 1380, 0, 4, 295, 86);
INSERT INTO public.who_global_data VALUES (69909, 0, 0, 0, 0, 295, 13);
INSERT INTO public.who_global_data VALUES (69910, 4, 197, 0, 9, 295, 157);
INSERT INTO public.who_global_data VALUES (69911, 1, 268, 0, 0, 295, 8);
INSERT INTO public.who_global_data VALUES (69912, 0, 0, 0, 0, 295, 73);
INSERT INTO public.who_global_data VALUES (69913, 0, 1, 0, 0, 295, 101);
INSERT INTO public.who_global_data VALUES (69914, 0, 48, 0, 2, 295, 165);
INSERT INTO public.who_global_data VALUES (69915, 0, 23, 0, 3, 295, 14);
INSERT INTO public.who_global_data VALUES (69916, 10, 794, 4, 29, 296, 193);
INSERT INTO public.who_global_data VALUES (69917, 19, 456, 1, 24, 296, 113);
INSERT INTO public.who_global_data VALUES (69918, 90, 2160, 10, 336, 296, 143);
INSERT INTO public.who_global_data VALUES (69919, 0, 0, 0, 0, 296, 219);
INSERT INTO public.who_global_data VALUES (69920, 14, 673, 2, 33, 296, 186);
INSERT INTO public.who_global_data VALUES (69921, 0, 19, 0, 2, 296, 52);
INSERT INTO public.who_global_data VALUES (69922, 0, 3, 0, 0, 296, 180);
INSERT INTO public.who_global_data VALUES (69923, 0, 23, 0, 2, 296, 167);
INSERT INTO public.who_global_data VALUES (69924, 141, 2477, 7, 108, 296, 154);
INSERT INTO public.who_global_data VALUES (69925, 44, 1087, 1, 17, 296, 94);
INSERT INTO public.who_global_data VALUES (69926, 1, 93, 1, 1, 296, 66);
INSERT INTO public.who_global_data VALUES (69927, 42, 6458, 2, 63, 296, 58);
INSERT INTO public.who_global_data VALUES (69928, 136, 14370, 9, 393, 296, 163);
INSERT INTO public.who_global_data VALUES (69929, 56, 1253, 0, 13, 296, 37);
INSERT INTO public.who_global_data VALUES (69930, 0, 49, 0, 8, 296, 142);
INSERT INTO public.who_global_data VALUES (69931, 27, 1698, 0, 7, 296, 83);
INSERT INTO public.who_global_data VALUES (69932, 341, 1572, 10, 60, 296, 228);
INSERT INTO public.who_global_data VALUES (69933, 1, 73, 1, 5, 296, 188);
INSERT INTO public.who_global_data VALUES (69934, 447, 3728, 3, 36, 296, 62);
INSERT INTO public.who_global_data VALUES (69935, 1633, 38257, 280, 5383, 296, 160);
INSERT INTO public.who_global_data VALUES (69936, 0, 18, 0, 2, 296, 50);
INSERT INTO public.who_global_data VALUES (69937, 0, 35, 0, 1, 296, 33);
INSERT INTO public.who_global_data VALUES (69938, 0, 57, 0, 5, 296, 183);
INSERT INTO public.who_global_data VALUES (69939, 0, 5, 0, 0, 296, 92);
INSERT INTO public.who_global_data VALUES (69940, 43, 397, 0, 28, 296, 158);
INSERT INTO public.who_global_data VALUES (69941, 1, 1, 0, 0, 296, 67);
INSERT INTO public.who_global_data VALUES (69942, 30, 1116, 1, 41, 296, 57);
INSERT INTO public.who_global_data VALUES (69943, 0, 13, 0, 1, 296, 38);
INSERT INTO public.who_global_data VALUES (69944, 1832, 25262, 204, 1532, 296, 141);
INSERT INTO public.who_global_data VALUES (69945, 0, 3, 0, 0, 296, 178);
INSERT INTO public.who_global_data VALUES (69946, 0, 136, 0, 1, 296, 108);
INSERT INTO public.who_global_data VALUES (69947, 34, 747, 1, 36, 296, 39);
INSERT INTO public.who_global_data VALUES (69948, 13, 528, 0, 28, 296, 2);
INSERT INTO public.who_global_data VALUES (69949, 0, 5, 0, 0, 296, 195);
INSERT INTO public.who_global_data VALUES (69950, 0, 10, 0, 1, 296, 107);
INSERT INTO public.who_global_data VALUES (69951, 0, 122, 0, 0, 296, 161);
INSERT INTO public.who_global_data VALUES (69952, 0, 855, 2, 17, 296, 212);
INSERT INTO public.who_global_data VALUES (69953, 1394, 27540, 131, 954, 296, 181);
INSERT INTO public.who_global_data VALUES (69954, 0, 54, 0, 1, 296, 53);
INSERT INTO public.who_global_data VALUES (69955, 0, 11, 0, 0, 296, 164);
INSERT INTO public.who_global_data VALUES (69956, 4, 27, 0, 0, 296, 140);
INSERT INTO public.who_global_data VALUES (69957, 356, 8273, 2, 94, 296, 20);
INSERT INTO public.who_global_data VALUES (69958, 50, 83797, 0, 3352, 296, 112);
INSERT INTO public.who_global_data VALUES (69959, 127, 2979, 15, 127, 296, 111);
INSERT INTO public.who_global_data VALUES (69960, 0, 0, 0, 0, 296, 71);
INSERT INTO public.who_global_data VALUES (69961, 43, 117, 0, 5, 296, 218);
INSERT INTO public.who_global_data VALUES (69962, 0, 0, 0, 0, 296, 43);
INSERT INTO public.who_global_data VALUES (69963, 6, 618, 0, 3, 296, 49);
INSERT INTO public.who_global_data VALUES (69964, 16, 654, 0, 6, 296, 1);
INSERT INTO public.who_global_data VALUES (69965, 37, 1741, 3, 34, 296, 48);
INSERT INTO public.who_global_data VALUES (69966, 48, 814, 3, 24, 296, 232);
INSERT INTO public.who_global_data VALUES (69967, 0, 14, 0, 1, 296, 175);
INSERT INTO public.who_global_data VALUES (69968, 20, 715, 0, 12, 296, 21);
INSERT INTO public.who_global_data VALUES (69969, 162, 6303, 5, 166, 296, 156);
INSERT INTO public.who_global_data VALUES (69970, 0, 0, 0, 0, 296, 95);
INSERT INTO public.who_global_data VALUES (69971, 13, 267, 1, 22, 296, 177);
INSERT INTO public.who_global_data VALUES (69972, 170, 6681, 10, 309, 296, 210);
INSERT INTO public.who_global_data VALUES (69973, 156, 591, 0, 2, 296, 120);
INSERT INTO public.who_global_data VALUES (69974, 0, 16, 0, 0, 296, 135);
INSERT INTO public.who_global_data VALUES (69975, 328, 3614, 6, 189, 296, 206);
INSERT INTO public.who_global_data VALUES (69976, 255, 7858, 19, 388, 296, 189);
INSERT INTO public.who_global_data VALUES (69977, 155, 2505, 5, 183, 296, 129);
INSERT INTO public.who_global_data VALUES (69978, 10, 159, 0, 6, 296, 121);
INSERT INTO public.who_global_data VALUES (69979, 10, 51, 0, 0, 296, 59);
INSERT INTO public.who_global_data VALUES (69980, 1, 35, 0, 0, 296, 96);
INSERT INTO public.who_global_data VALUES (69981, 29, 1402, 4, 35, 296, 41);
INSERT INTO public.who_global_data VALUES (69982, 1, 16, 0, 0, 296, 216);
INSERT INTO public.who_global_data VALUES (69983, 3, 85, 0, 3, 296, 236);
INSERT INTO public.who_global_data VALUES (69984, 0, 11, 0, 0, 296, 150);
INSERT INTO public.who_global_data VALUES (69985, 0, 184, 0, 0, 296, 61);
INSERT INTO public.who_global_data VALUES (69986, 0, 16, 0, 0, 296, 7);
INSERT INTO public.who_global_data VALUES (69987, 76, 3237, 8, 72, 296, 169);
INSERT INTO public.who_global_data VALUES (69988, 2621, 105155, 1438, 17146, 296, 28);
INSERT INTO public.who_global_data VALUES (69989, 7, 95, 0, 0, 296, 85);
INSERT INTO public.who_global_data VALUES (69990, 0, 55, 0, 0, 296, 211);
INSERT INTO public.who_global_data VALUES (69991, 7, 87, 0, 1, 296, 60);
INSERT INTO public.who_global_data VALUES (69992, 0, 9, 0, 1, 296, 3);
INSERT INTO public.who_global_data VALUES (69993, 30, 336, 0, 3, 296, 11);
INSERT INTO public.who_global_data VALUES (69994, 2866, 130450, 315, 3569, 296, 89);
INSERT INTO public.who_global_data VALUES (69995, 0, 636, 0, 8, 296, 24);
INSERT INTO public.who_global_data VALUES (69996, 0, 129, 0, 0, 296, 162);
INSERT INTO public.who_global_data VALUES (69997, 22, 2192, 1, 102, 296, 100);
INSERT INTO public.who_global_data VALUES (69998, 0, 11, 0, 0, 296, 47);
INSERT INTO public.who_global_data VALUES (69999, 0, 13, 0, 0, 296, 29);
INSERT INTO public.who_global_data VALUES (70000, 0, 145, 0, 8, 296, 40);
INSERT INTO public.who_global_data VALUES (70001, 0, 133, 0, 5, 296, 222);
INSERT INTO public.who_global_data VALUES (70002, 13, 180, 0, 5, 296, 132);
INSERT INTO public.who_global_data VALUES (70003, 4, 223, 1, 7, 296, 130);
INSERT INTO public.who_global_data VALUES (70004, 41, 404, 1, 1, 296, 234);
INSERT INTO public.who_global_data VALUES (70005, 3, 43, 0, 0, 296, 23);
INSERT INTO public.who_global_data VALUES (70006, 1, 48, 0, 6, 296, 192);
INSERT INTO public.who_global_data VALUES (70007, 1, 41, 0, 3, 296, 69);
INSERT INTO public.who_global_data VALUES (70008, 0, 8, 0, 0, 296, 187);
INSERT INTO public.who_global_data VALUES (70009, 12, 419, 5, 31, 296, 230);
INSERT INTO public.who_global_data VALUES (70010, 73, 1652, 8, 142, 296, 77);
INSERT INTO public.who_global_data VALUES (70011, 7, 1727, 0, 8, 296, 9);
INSERT INTO public.who_global_data VALUES (70012, 941, 12380, 37, 414, 296, 74);
INSERT INTO public.who_global_data VALUES (70013, 380, 5516, 27, 496, 296, 224);
INSERT INTO public.who_global_data VALUES (70014, 1606, 77995, 92, 4869, 296, 199);
INSERT INTO public.who_global_data VALUES (70015, 19, 1434, 1, 80, 296, 190);
INSERT INTO public.who_global_data VALUES (70016, 1068, 12547, 38, 444, 296, 12);
INSERT INTO public.who_global_data VALUES (70017, 12, 254, 0, 2, 296, 104);
INSERT INTO public.who_global_data VALUES (70018, 399, 12347, 8, 126, 296, 153);
INSERT INTO public.who_global_data VALUES (70019, 2667, 165155, 578, 21647, 296, 91);
INSERT INTO public.who_global_data VALUES (70020, 32, 105, 1, 5, 296, 215);
INSERT INTO public.who_global_data VALUES (70021, 482, 8582, 17, 136, 296, 84);
INSERT INTO public.who_global_data VALUES (70022, 0, 217, 2, 6, 296, 231);
INSERT INTO public.who_global_data VALUES (70023, 4, 401, 0, 7, 296, 196);
INSERT INTO public.who_global_data VALUES (70024, 185, 1480, 0, 16, 296, 105);
INSERT INTO public.who_global_data VALUES (70025, 9, 225, 1, 10, 296, 122);
INSERT INTO public.who_global_data VALUES (70026, 0, 0, 0, 0, 296, 159);
INSERT INTO public.who_global_data VALUES (70027, 10, 397, 2, 12, 296, 75);
INSERT INTO public.who_global_data VALUES (70028, 119, 1524, 0, 3, 296, 27);
INSERT INTO public.who_global_data VALUES (70029, 17, 466, 0, 5, 296, 54);
INSERT INTO public.who_global_data VALUES (70030, 0, 19, 0, 0, 296, 226);
INSERT INTO public.who_global_data VALUES (70031, 9, 666, 0, 5, 296, 79);
INSERT INTO public.who_global_data VALUES (70032, 5, 663, 0, 21, 296, 56);
INSERT INTO public.who_global_data VALUES (70033, 0, 0, 0, 0, 296, 117);
INSERT INTO public.who_global_data VALUES (70034, 0, 59, 0, 6, 296, 152);
INSERT INTO public.who_global_data VALUES (70035, 13, 48, 0, 1, 296, 16);
INSERT INTO public.who_global_data VALUES (70036, 0, 81, 0, 1, 296, 10);
INSERT INTO public.who_global_data VALUES (70037, 27, 1022, 0, 30, 296, 201);
INSERT INTO public.who_global_data VALUES (70038, 66, 3373, 2, 69, 296, 174);
INSERT INTO public.who_global_data VALUES (70039, 0, 110, 0, 0, 296, 119);
INSERT INTO public.who_global_data VALUES (70040, 0, 16, 0, 2, 296, 168);
INSERT INTO public.who_global_data VALUES (70041, 85, 5072, 1, 83, 296, 99);
INSERT INTO public.who_global_data VALUES (70042, 2, 23, 0, 0, 296, 171);
INSERT INTO public.who_global_data VALUES (70043, 21, 144, 3, 13, 296, 87);
INSERT INTO public.who_global_data VALUES (70044, 13, 412, 0, 3, 296, 123);
INSERT INTO public.who_global_data VALUES (70045, 0, 0, 0, 0, 296, 151);
INSERT INTO public.who_global_data VALUES (70046, 1, 158, 0, 8, 296, 213);
INSERT INTO public.who_global_data VALUES (70047, 0, 7, 0, 1, 296, 118);
INSERT INTO public.who_global_data VALUES (70048, 0, 324, 0, 9, 296, 134);
INSERT INTO public.who_global_data VALUES (70049, 4, 221, 0, 3, 296, 65);
INSERT INTO public.who_global_data VALUES (70050, 385, 5399, 74, 406, 296, 102);
INSERT INTO public.who_global_data VALUES (70051, 0, 0, 0, 0, 296, 223);
INSERT INTO public.who_global_data VALUES (70052, 0, 64, 0, 1, 296, 4);
INSERT INTO public.who_global_data VALUES (70053, 1, 31, 0, 0, 296, 146);
INSERT INTO public.who_global_data VALUES (70054, 13, 303, 0, 4, 296, 31);
INSERT INTO public.who_global_data VALUES (70055, 0, 11, 0, 0, 296, 127);
INSERT INTO public.who_global_data VALUES (70056, 263, 2251, 1, 128, 296, 22);
INSERT INTO public.who_global_data VALUES (70057, 0, 28, 0, 0, 296, 115);
INSERT INTO public.who_global_data VALUES (70058, 11, 85, 0, 4, 296, 106);
INSERT INTO public.who_global_data VALUES (70059, 0, 16, 0, 0, 296, 90);
INSERT INTO public.who_global_data VALUES (70060, 0, 0, 0, 0, 296, 70);
INSERT INTO public.who_global_data VALUES (70061, 0, 16, 0, 0, 296, 46);
INSERT INTO public.who_global_data VALUES (70062, 730, 27909, 202, 3089, 296, 139);
INSERT INTO public.who_global_data VALUES (70063, 0, 18, 0, 0, 296, 42);
INSERT INTO public.who_global_data VALUES (70064, 6, 1084, 0, 9, 296, 80);
INSERT INTO public.who_global_data VALUES (70065, 0, 9, 0, 1, 296, 203);
INSERT INTO public.who_global_data VALUES (70066, 14, 584, 0, 14, 296, 136);
INSERT INTO public.who_global_data VALUES (70067, 30, 373, 1, 11, 296, 63);
INSERT INTO public.who_global_data VALUES (70068, 0, 0, 0, 0, 296, 17);
INSERT INTO public.who_global_data VALUES (70069, 0, 13, 0, 2, 296, 172);
INSERT INTO public.who_global_data VALUES (70070, 66, 974, 1, 45, 296, 109);
INSERT INTO public.who_global_data VALUES (70071, 111, 6677, 3, 130, 296, 200);
INSERT INTO public.who_global_data VALUES (70072, 3, 294, 0, 2, 296, 93);
INSERT INTO public.who_global_data VALUES (70073, 109, 1019, 0, 4, 296, 5);
INSERT INTO public.who_global_data VALUES (70074, 0, 712, 0, 12, 296, 214);
INSERT INTO public.who_global_data VALUES (70075, 931, 6919, 21, 128, 296, 204);
INSERT INTO public.who_global_data VALUES (70076, 0, 0, 0, 0, 296, 198);
INSERT INTO public.who_global_data VALUES (70077, 102, 3574, 1, 95, 296, 173);
INSERT INTO public.who_global_data VALUES (70078, 0, 2, 0, 0, 296, 229);
INSERT INTO public.who_global_data VALUES (70079, 2, 161, 1, 8, 296, 76);
INSERT INTO public.who_global_data VALUES (70080, 2784, 10303, 37, 230, 296, 138);
INSERT INTO public.who_global_data VALUES (70081, 437, 5660, 27, 362, 296, 98);
INSERT INTO public.who_global_data VALUES (70082, 0, 0, 0, 0, 296, 103);
INSERT INTO public.who_global_data VALUES (70083, 380, 7582, 23, 286, 296, 225);
INSERT INTO public.who_global_data VALUES (70084, 643, 18091, 32, 599, 296, 131);
INSERT INTO public.who_global_data VALUES (70085, 51, 974, 3, 48, 296, 235);
INSERT INTO public.who_global_data VALUES (70086, 392, 4103, 0, 7, 296, 137);
INSERT INTO public.who_global_data VALUES (70087, 22, 10613, 4, 229, 296, 81);
INSERT INTO public.who_global_data VALUES (70088, 115, 2049, 5, 46, 296, 182);
INSERT INTO public.who_global_data VALUES (70089, 0, 390, 0, 0, 296, 145);
INSERT INTO public.who_global_data VALUES (70090, 337, 7216, 28, 372, 296, 26);
INSERT INTO public.who_global_data VALUES (70091, 3448, 27938, 34, 232, 296, 170);
INSERT INTO public.who_global_data VALUES (70092, 2, 136, 0, 0, 296, 191);
INSERT INTO public.who_global_data VALUES (70093, 0, 2, 0, 0, 296, 221);
INSERT INTO public.who_global_data VALUES (70094, 0, 6, 0, 0, 296, 64);
INSERT INTO public.who_global_data VALUES (70095, 0, 0, 0, 0, 296, 116);
INSERT INTO public.who_global_data VALUES (70096, 2, 14, 0, 0, 296, 128);
INSERT INTO public.who_global_data VALUES (70097, 0, 15, 0, 0, 296, 6);
INSERT INTO public.who_global_data VALUES (70098, 0, 35, 0, 2, 296, 227);
INSERT INTO public.who_global_data VALUES (70099, 0, 1, 0, 0, 296, 68);
INSERT INTO public.who_global_data VALUES (70100, 0, 12, 0, 0, 296, 184);
INSERT INTO public.who_global_data VALUES (70101, 0, 0, 0, 0, 296, 82);
INSERT INTO public.who_global_data VALUES (70102, 21, 393, 0, 36, 296, 149);
INSERT INTO public.who_global_data VALUES (70103, 0, 4, 0, 0, 296, 197);
INSERT INTO public.who_global_data VALUES (70104, 518, 6380, 4, 83, 296, 78);
INSERT INTO public.who_global_data VALUES (70105, 15, 314, 0, 2, 296, 233);
INSERT INTO public.who_global_data VALUES (70106, 408, 4873, 5, 99, 296, 133);
INSERT INTO public.who_global_data VALUES (70107, 0, 11, 0, 0, 296, 35);
INSERT INTO public.who_global_data VALUES (70108, 2, 13, 0, 0, 296, 114);
INSERT INTO public.who_global_data VALUES (70109, 447, 3699, 0, 10, 296, 237);
INSERT INTO public.who_global_data VALUES (70110, 0, 2, 0, 0, 296, 55);
INSERT INTO public.who_global_data VALUES (70111, 1, 53, 0, 9, 296, 176);
INSERT INTO public.who_global_data VALUES (70112, 28, 863, 4, 6, 296, 202);
INSERT INTO public.who_global_data VALUES (70113, 21, 1269, 0, 65, 296, 155);
INSERT INTO public.who_global_data VALUES (70114, 0, 0, 0, 0, 296, 32);
INSERT INTO public.who_global_data VALUES (70115, 20, 80, 3, 5, 296, 220);
INSERT INTO public.who_global_data VALUES (70116, 91, 2506, 7, 34, 296, 30);
INSERT INTO public.who_global_data VALUES (70117, 0, 4, 0, 0, 296, 147);
INSERT INTO public.who_global_data VALUES (70118, 3994, 190786, 607, 20379, 296, 208);
INSERT INTO public.who_global_data VALUES (70119, 5, 238, 0, 7, 296, 45);
INSERT INTO public.who_global_data VALUES (70120, 0, 32, 0, 5, 296, 110);
INSERT INTO public.who_global_data VALUES (70121, 0, 10, 0, 1, 296, 88);
INSERT INTO public.who_global_data VALUES (70122, 479, 11828, 91, 1568, 296, 51);
INSERT INTO public.who_global_data VALUES (70123, 328, 27220, 38, 1214, 296, 209);
INSERT INTO public.who_global_data VALUES (70124, 4, 33, 0, 2, 296, 205);
INSERT INTO public.who_global_data VALUES (70125, 0, 0, 0, 0, 296, 18);
INSERT INTO public.who_global_data VALUES (70126, 29, 2672, 3, 46, 296, 72);
INSERT INTO public.who_global_data VALUES (70127, 4326, 101378, 880, 14993, 296, 44);
INSERT INTO public.who_global_data VALUES (70128, 12, 18, 0, 0, 296, 15);
INSERT INTO public.who_global_data VALUES (70129, 0, 77, 0, 3, 296, 25);
INSERT INTO public.who_global_data VALUES (70130, 0, 0, 0, 0, 296, 179);
INSERT INTO public.who_global_data VALUES (70131, 0, 0, 0, 0, 296, 34);
INSERT INTO public.who_global_data VALUES (70132, 1, 114, 0, 8, 296, 207);
INSERT INTO public.who_global_data VALUES (70133, 33, 780, 1, 35, 296, 166);
INSERT INTO public.who_global_data VALUES (70134, 4281, 69392, 115, 1518, 296, 126);
INSERT INTO public.who_global_data VALUES (70135, 0, 0, 0, 0, 296, 97);
INSERT INTO public.who_global_data VALUES (70136, 0, 10, 0, 1, 296, 36);
INSERT INTO public.who_global_data VALUES (70137, 0, 0, 0, 0, 296, 125);
INSERT INTO public.who_global_data VALUES (70138, 1, 55, 0, 0, 296, 124);
INSERT INTO public.who_global_data VALUES (70139, 398, 4162, 7, 115, 296, 185);
INSERT INTO public.who_global_data VALUES (70140, 432, 5365, 5, 33, 296, 194);
INSERT INTO public.who_global_data VALUES (70141, 35, 88, 1, 4, 296, 144);
INSERT INTO public.who_global_data VALUES (70142, 25802, 604070, 2395, 25871, 296, 19);
INSERT INTO public.who_global_data VALUES (70143, 0, 51, 0, 1, 296, 217);
INSERT INTO public.who_global_data VALUES (70144, 9, 492, 0, 8, 296, 148);
INSERT INTO public.who_global_data VALUES (70145, 135, 1349, 0, 4, 296, 86);
INSERT INTO public.who_global_data VALUES (70146, 0, 0, 0, 0, 296, 13);
INSERT INTO public.who_global_data VALUES (70147, 12, 193, 0, 9, 296, 157);
INSERT INTO public.who_global_data VALUES (70148, 0, 267, 0, 0, 296, 8);
INSERT INTO public.who_global_data VALUES (70149, 0, 0, 0, 0, 296, 73);
INSERT INTO public.who_global_data VALUES (70150, 0, 1, 0, 0, 296, 101);
INSERT INTO public.who_global_data VALUES (70151, 3, 48, 0, 2, 296, 165);
INSERT INTO public.who_global_data VALUES (70152, 5, 23, 0, 3, 296, 14);
INSERT INTO public.who_global_data VALUES (70153, 70, 784, 2, 25, 297, 193);
INSERT INTO public.who_global_data VALUES (70154, 0, 437, 1, 23, 297, 113);
INSERT INTO public.who_global_data VALUES (70155, 87, 2070, 13, 326, 297, 143);
INSERT INTO public.who_global_data VALUES (70156, 0, 0, 0, 0, 297, 219);
INSERT INTO public.who_global_data VALUES (70157, 8, 659, 2, 31, 297, 186);
INSERT INTO public.who_global_data VALUES (70158, 0, 19, 0, 2, 297, 52);
INSERT INTO public.who_global_data VALUES (70159, 0, 3, 0, 0, 297, 180);
INSERT INTO public.who_global_data VALUES (70160, 0, 23, 0, 2, 297, 167);
INSERT INTO public.who_global_data VALUES (70161, 84, 2336, 6, 101, 297, 154);
INSERT INTO public.who_global_data VALUES (70162, 28, 1043, 2, 16, 297, 94);
INSERT INTO public.who_global_data VALUES (70163, 0, 92, 0, 0, 297, 66);
INSERT INTO public.who_global_data VALUES (70164, 50, 6416, 0, 61, 297, 58);
INSERT INTO public.who_global_data VALUES (70165, 191, 14234, 16, 384, 297, 163);
INSERT INTO public.who_global_data VALUES (70166, 49, 1197, 1, 13, 297, 37);
INSERT INTO public.who_global_data VALUES (70167, 2, 49, 0, 8, 297, 142);
INSERT INTO public.who_global_data VALUES (70168, 143, 1671, 0, 7, 297, 83);
INSERT INTO public.who_global_data VALUES (70169, 219, 1231, 4, 50, 297, 228);
INSERT INTO public.who_global_data VALUES (70170, 1, 72, 0, 4, 297, 188);
INSERT INTO public.who_global_data VALUES (70171, 362, 3281, 4, 33, 297, 62);
INSERT INTO public.who_global_data VALUES (70172, 1560, 36624, 261, 5103, 297, 160);
INSERT INTO public.who_global_data VALUES (70173, 4, 18, 0, 2, 297, 50);
INSERT INTO public.who_global_data VALUES (70174, 0, 35, 0, 1, 297, 33);
INSERT INTO public.who_global_data VALUES (70175, 0, 57, 1, 5, 297, 183);
INSERT INTO public.who_global_data VALUES (70176, 0, 5, 0, 0, 297, 92);
INSERT INTO public.who_global_data VALUES (70177, 24, 354, 1, 28, 297, 158);
INSERT INTO public.who_global_data VALUES (70178, 0, 0, 0, 0, 297, 67);
INSERT INTO public.who_global_data VALUES (70179, 52, 1086, 2, 40, 297, 57);
INSERT INTO public.who_global_data VALUES (70180, 0, 13, 0, 1, 297, 38);
INSERT INTO public.who_global_data VALUES (70181, 1261, 23430, 105, 1328, 297, 141);
INSERT INTO public.who_global_data VALUES (70182, 0, 3, 0, 0, 297, 178);
INSERT INTO public.who_global_data VALUES (70183, 0, 136, 0, 1, 297, 108);
INSERT INTO public.who_global_data VALUES (70184, 28, 713, 3, 35, 297, 39);
INSERT INTO public.who_global_data VALUES (70185, 18, 515, 1, 28, 297, 2);
INSERT INTO public.who_global_data VALUES (70186, 0, 5, 0, 0, 297, 195);
INSERT INTO public.who_global_data VALUES (70187, 0, 10, 0, 1, 297, 107);
INSERT INTO public.who_global_data VALUES (70188, 0, 122, 0, 0, 297, 161);
INSERT INTO public.who_global_data VALUES (70189, 52, 855, 5, 15, 297, 212);
INSERT INTO public.who_global_data VALUES (70190, 1360, 26146, 89, 823, 297, 181);
INSERT INTO public.who_global_data VALUES (70191, 1, 54, 0, 1, 297, 53);
INSERT INTO public.who_global_data VALUES (70192, 0, 11, 0, 0, 297, 164);
INSERT INTO public.who_global_data VALUES (70193, 0, 23, 0, 0, 297, 140);
INSERT INTO public.who_global_data VALUES (70194, 392, 7917, 10, 92, 297, 20);
INSERT INTO public.who_global_data VALUES (70195, 51, 83747, 1, 3352, 297, 112);
INSERT INTO public.who_global_data VALUES (70196, 76, 2852, 3, 112, 297, 111);
INSERT INTO public.who_global_data VALUES (70197, 0, 0, 0, 0, 297, 71);
INSERT INTO public.who_global_data VALUES (70198, 0, 74, 0, 5, 297, 218);
INSERT INTO public.who_global_data VALUES (70199, 0, 0, 0, 0, 297, 43);
INSERT INTO public.who_global_data VALUES (70200, 17, 612, 0, 3, 297, 49);
INSERT INTO public.who_global_data VALUES (70201, 12, 638, 0, 6, 297, 1);
INSERT INTO public.who_global_data VALUES (70202, 54, 1704, 6, 31, 297, 48);
INSERT INTO public.who_global_data VALUES (70203, 40, 766, 0, 21, 297, 232);
INSERT INTO public.who_global_data VALUES (70204, 0, 14, 0, 1, 297, 175);
INSERT INTO public.who_global_data VALUES (70205, 33, 695, 0, 12, 297, 21);
INSERT INTO public.who_global_data VALUES (70206, 82, 6141, 18, 161, 297, 156);
INSERT INTO public.who_global_data VALUES (70207, 0, 0, 0, 0, 297, 95);
INSERT INTO public.who_global_data VALUES (70208, 13, 254, 1, 21, 297, 177);
INSERT INTO public.who_global_data VALUES (70209, 193, 6511, 14, 299, 297, 210);
INSERT INTO public.who_global_data VALUES (70210, 72, 435, 0, 2, 297, 120);
INSERT INTO public.who_global_data VALUES (70211, 0, 16, 0, 0, 297, 135);
INSERT INTO public.who_global_data VALUES (70212, 119, 3286, 6, 183, 297, 206);
INSERT INTO public.who_global_data VALUES (70213, 74, 7603, 14, 369, 297, 189);
INSERT INTO public.who_global_data VALUES (70214, 160, 2350, 14, 178, 297, 129);
INSERT INTO public.who_global_data VALUES (70215, 12, 149, 0, 6, 297, 121);
INSERT INTO public.who_global_data VALUES (70216, 20, 41, 0, 0, 297, 59);
INSERT INTO public.who_global_data VALUES (70217, 0, 34, 0, 0, 297, 96);
INSERT INTO public.who_global_data VALUES (70218, 41, 1373, 3, 31, 297, 41);
INSERT INTO public.who_global_data VALUES (70219, 1, 15, 0, 0, 297, 216);
INSERT INTO public.who_global_data VALUES (70220, 8, 82, 0, 3, 297, 236);
INSERT INTO public.who_global_data VALUES (70221, 6, 11, 0, 0, 297, 150);
INSERT INTO public.who_global_data VALUES (70222, 0, 184, 0, 0, 297, 61);
INSERT INTO public.who_global_data VALUES (70223, 0, 16, 0, 0, 297, 7);
INSERT INTO public.who_global_data VALUES (70224, 97, 3161, 5, 64, 297, 169);
INSERT INTO public.who_global_data VALUES (70225, 5483, 102534, 762, 15708, 297, 28);
INSERT INTO public.who_global_data VALUES (70226, 0, 88, 0, 0, 297, 85);
INSERT INTO public.who_global_data VALUES (70227, 0, 55, 0, 0, 297, 211);
INSERT INTO public.who_global_data VALUES (70228, 23, 80, 0, 1, 297, 60);
INSERT INTO public.who_global_data VALUES (70229, 0, 9, 0, 1, 297, 3);
INSERT INTO public.who_global_data VALUES (70230, 10, 306, 0, 3, 297, 11);
INSERT INTO public.who_global_data VALUES (70231, 2486, 127584, 285, 3254, 297, 89);
INSERT INTO public.who_global_data VALUES (70232, 70, 636, 0, 8, 297, 24);
INSERT INTO public.who_global_data VALUES (70233, 0, 129, 0, 0, 297, 162);
INSERT INTO public.who_global_data VALUES (70234, 25, 2170, 2, 101, 297, 100);
INSERT INTO public.who_global_data VALUES (70235, 0, 11, 0, 0, 297, 47);
INSERT INTO public.who_global_data VALUES (70236, 0, 13, 0, 0, 297, 29);
INSERT INTO public.who_global_data VALUES (70237, 2, 145, 0, 8, 297, 40);
INSERT INTO public.who_global_data VALUES (70238, 0, 133, 0, 5, 297, 222);
INSERT INTO public.who_global_data VALUES (70239, 11, 167, 0, 5, 297, 132);
INSERT INTO public.who_global_data VALUES (70240, 1, 219, 0, 6, 297, 130);
INSERT INTO public.who_global_data VALUES (70241, 44, 363, 0, 0, 297, 234);
INSERT INTO public.who_global_data VALUES (70242, 1, 40, 0, 0, 297, 23);
INSERT INTO public.who_global_data VALUES (70243, 0, 47, 0, 6, 297, 192);
INSERT INTO public.who_global_data VALUES (70244, 0, 40, 0, 3, 297, 69);
INSERT INTO public.who_global_data VALUES (70245, 0, 8, 0, 0, 297, 187);
INSERT INTO public.who_global_data VALUES (70246, 10, 407, 1, 26, 297, 230);
INSERT INTO public.who_global_data VALUES (70247, 67, 1579, 12, 134, 297, 77);
INSERT INTO public.who_global_data VALUES (70248, 9, 1720, 0, 8, 297, 9);
INSERT INTO public.who_global_data VALUES (70249, 1076, 11439, 38, 377, 297, 74);
INSERT INTO public.who_global_data VALUES (70250, 297, 5136, 10, 469, 297, 224);
INSERT INTO public.who_global_data VALUES (70251, 1512, 76389, 94, 4777, 297, 199);
INSERT INTO public.who_global_data VALUES (70252, 15, 1415, 1, 79, 297, 190);
INSERT INTO public.who_global_data VALUES (70253, 832, 11479, 41, 406, 297, 12);
INSERT INTO public.who_global_data VALUES (70254, 14, 242, 0, 2, 297, 104);
INSERT INTO public.who_global_data VALUES (70255, 438, 11948, 9, 118, 297, 153);
INSERT INTO public.who_global_data VALUES (70256, 2972, 162488, 604, 21069, 297, 91);
INSERT INTO public.who_global_data VALUES (70257, 1, 73, 0, 4, 297, 215);
INSERT INTO public.who_global_data VALUES (70258, 455, 8100, 10, 119, 297, 84);
INSERT INTO public.who_global_data VALUES (70259, 4, 217, 0, 4, 297, 231);
INSERT INTO public.who_global_data VALUES (70260, 6, 397, 0, 7, 297, 196);
INSERT INTO public.who_global_data VALUES (70261, 20, 1295, 4, 16, 297, 105);
INSERT INTO public.who_global_data VALUES (70262, 8, 216, 0, 9, 297, 122);
INSERT INTO public.who_global_data VALUES (70263, 0, 0, 0, 0, 297, 159);
INSERT INTO public.who_global_data VALUES (70264, 10, 387, 1, 10, 297, 75);
INSERT INTO public.who_global_data VALUES (70265, 50, 1405, 0, 3, 297, 27);
INSERT INTO public.who_global_data VALUES (70266, 19, 449, 0, 5, 297, 54);
INSERT INTO public.who_global_data VALUES (70267, 0, 19, 0, 0, 297, 226);
INSERT INTO public.who_global_data VALUES (70268, 2, 657, 0, 5, 297, 79);
INSERT INTO public.who_global_data VALUES (70269, 17, 658, 0, 21, 297, 56);
INSERT INTO public.who_global_data VALUES (70270, 0, 0, 0, 0, 297, 117);
INSERT INTO public.who_global_data VALUES (70271, 8, 59, 0, 6, 297, 152);
INSERT INTO public.who_global_data VALUES (70272, 9, 35, 0, 1, 297, 16);
INSERT INTO public.who_global_data VALUES (70273, 0, 81, 0, 1, 297, 10);
INSERT INTO public.who_global_data VALUES (70274, 18, 995, 4, 30, 297, 201);
INSERT INTO public.who_global_data VALUES (70275, 15, 3307, 0, 67, 297, 174);
INSERT INTO public.who_global_data VALUES (70276, 4, 110, 0, 0, 297, 119);
INSERT INTO public.who_global_data VALUES (70277, 0, 16, 0, 2, 297, 168);
INSERT INTO public.who_global_data VALUES (70278, 170, 4987, 5, 82, 297, 99);
INSERT INTO public.who_global_data VALUES (70279, 1, 21, 0, 0, 297, 171);
INSERT INTO public.who_global_data VALUES (70280, 7, 123, 1, 10, 297, 87);
INSERT INTO public.who_global_data VALUES (70281, 6, 399, 0, 3, 297, 123);
INSERT INTO public.who_global_data VALUES (70282, 0, 0, 0, 0, 297, 151);
INSERT INTO public.who_global_data VALUES (70283, 0, 157, 0, 8, 297, 213);
INSERT INTO public.who_global_data VALUES (70284, 0, 7, 0, 1, 297, 118);
INSERT INTO public.who_global_data VALUES (70285, 0, 324, 0, 9, 297, 134);
INSERT INTO public.who_global_data VALUES (70286, 10, 217, 0, 3, 297, 65);
INSERT INTO public.who_global_data VALUES (70287, 353, 5014, 36, 332, 297, 102);
INSERT INTO public.who_global_data VALUES (70288, 0, 0, 0, 0, 297, 223);
INSERT INTO public.who_global_data VALUES (70289, 0, 64, 0, 1, 297, 4);
INSERT INTO public.who_global_data VALUES (70290, 0, 30, 0, 0, 297, 146);
INSERT INTO public.who_global_data VALUES (70291, 2, 290, 0, 4, 297, 31);
INSERT INTO public.who_global_data VALUES (70292, 0, 11, 0, 0, 297, 127);
INSERT INTO public.who_global_data VALUES (70293, 150, 1988, 1, 127, 297, 22);
INSERT INTO public.who_global_data VALUES (70294, 7, 28, 0, 0, 297, 115);
INSERT INTO public.who_global_data VALUES (70295, 12, 74, 0, 4, 297, 106);
INSERT INTO public.who_global_data VALUES (70296, 0, 16, 0, 0, 297, 90);
INSERT INTO public.who_global_data VALUES (70297, 0, 0, 0, 0, 297, 70);
INSERT INTO public.who_global_data VALUES (70298, 0, 16, 0, 0, 297, 46);
INSERT INTO public.who_global_data VALUES (70299, 862, 27179, 107, 2887, 297, 139);
INSERT INTO public.who_global_data VALUES (70300, 0, 18, 0, 0, 297, 42);
INSERT INTO public.who_global_data VALUES (70301, 6, 1078, 0, 9, 297, 80);
INSERT INTO public.who_global_data VALUES (70302, 0, 9, 0, 1, 297, 203);
INSERT INTO public.who_global_data VALUES (70303, 22, 570, 1, 14, 297, 136);
INSERT INTO public.who_global_data VALUES (70304, 0, 343, 0, 10, 297, 63);
INSERT INTO public.who_global_data VALUES (70305, 0, 0, 0, 0, 297, 17);
INSERT INTO public.who_global_data VALUES (70306, 2, 13, 0, 2, 297, 172);
INSERT INTO public.who_global_data VALUES (70307, 54, 908, 6, 44, 297, 109);
INSERT INTO public.who_global_data VALUES (70308, 78, 6566, 13, 127, 297, 200);
INSERT INTO public.who_global_data VALUES (70309, 4, 291, 0, 2, 297, 93);
INSERT INTO public.who_global_data VALUES (70310, 97, 910, 0, 4, 297, 5);
INSERT INTO public.who_global_data VALUES (70311, 0, 712, 0, 12, 297, 214);
INSERT INTO public.who_global_data VALUES (70312, 151, 5988, 11, 107, 297, 204);
INSERT INTO public.who_global_data VALUES (70313, 0, 0, 0, 0, 297, 198);
INSERT INTO public.who_global_data VALUES (70314, 72, 3472, 7, 94, 297, 173);
INSERT INTO public.who_global_data VALUES (70315, 0, 2, 0, 0, 297, 229);
INSERT INTO public.who_global_data VALUES (70316, 12, 159, 1, 7, 297, 76);
INSERT INTO public.who_global_data VALUES (70317, 0, 7519, 0, 193, 297, 138);
INSERT INTO public.who_global_data VALUES (70318, 0, 5223, 0, 335, 297, 98);
INSERT INTO public.who_global_data VALUES (70319, 0, 0, 0, 0, 297, 103);
INSERT INTO public.who_global_data VALUES (70320, 268, 7202, 18, 263, 297, 225);
INSERT INTO public.who_global_data VALUES (70321, 514, 17448, 32, 567, 297, 131);
INSERT INTO public.who_global_data VALUES (70322, 20, 923, 0, 45, 297, 235);
INSERT INTO public.who_global_data VALUES (70323, 283, 3711, 0, 7, 297, 137);
INSERT INTO public.who_global_data VALUES (70324, 27, 10591, 3, 225, 297, 81);
INSERT INTO public.who_global_data VALUES (70325, 222, 1934, 5, 41, 297, 182);
INSERT INTO public.who_global_data VALUES (70326, 0, 390, 0, 0, 297, 145);
INSERT INTO public.who_global_data VALUES (70327, 246, 6879, 26, 344, 297, 26);
INSERT INTO public.who_global_data VALUES (70328, 3388, 24490, 28, 198, 297, 170);
INSERT INTO public.who_global_data VALUES (70329, 7, 134, 0, 0, 297, 191);
INSERT INTO public.who_global_data VALUES (70330, 0, 2, 0, 0, 297, 221);
INSERT INTO public.who_global_data VALUES (70331, 0, 6, 0, 0, 297, 64);
INSERT INTO public.who_global_data VALUES (70332, 0, 0, 0, 0, 297, 116);
INSERT INTO public.who_global_data VALUES (70333, 0, 12, 0, 0, 297, 128);
INSERT INTO public.who_global_data VALUES (70334, 0, 15, 0, 0, 297, 6);
INSERT INTO public.who_global_data VALUES (70335, 2, 35, 0, 2, 297, 227);
INSERT INTO public.who_global_data VALUES (70336, 0, 1, 0, 0, 297, 68);
INSERT INTO public.who_global_data VALUES (70337, 0, 12, 0, 0, 297, 184);
INSERT INTO public.who_global_data VALUES (70338, 0, 0, 0, 0, 297, 82);
INSERT INTO public.who_global_data VALUES (70339, 1, 372, 0, 36, 297, 149);
INSERT INTO public.who_global_data VALUES (70340, 0, 4, 0, 0, 297, 197);
INSERT INTO public.who_global_data VALUES (70341, 493, 5862, 6, 79, 297, 78);
INSERT INTO public.who_global_data VALUES (70342, 8, 299, 0, 2, 297, 233);
INSERT INTO public.who_global_data VALUES (70343, 411, 4465, 9, 94, 297, 133);
INSERT INTO public.who_global_data VALUES (70344, 0, 11, 0, 0, 297, 35);
INSERT INTO public.who_global_data VALUES (70345, 1, 11, 0, 0, 297, 114);
INSERT INTO public.who_global_data VALUES (70346, 334, 3252, 1, 10, 297, 237);
INSERT INTO public.who_global_data VALUES (70347, 0, 2, 0, 0, 297, 55);
INSERT INTO public.who_global_data VALUES (70348, 0, 52, 0, 9, 297, 176);
INSERT INTO public.who_global_data VALUES (70349, 66, 835, 0, 2, 297, 202);
INSERT INTO public.who_global_data VALUES (70350, 27, 1248, 1, 65, 297, 155);
INSERT INTO public.who_global_data VALUES (70351, 0, 0, 0, 0, 297, 32);
INSERT INTO public.who_global_data VALUES (70352, 0, 60, 0, 2, 297, 220);
INSERT INTO public.who_global_data VALUES (70353, 143, 2415, 0, 27, 297, 30);
INSERT INTO public.who_global_data VALUES (70354, 0, 4, 0, 0, 297, 147);
INSERT INTO public.who_global_data VALUES (70355, 3126, 186792, 587, 19772, 297, 208);
INSERT INTO public.who_global_data VALUES (70356, 15, 233, 0, 7, 297, 45);
INSERT INTO public.who_global_data VALUES (70357, 3, 32, 1, 5, 297, 110);
INSERT INTO public.who_global_data VALUES (70358, 0, 10, 0, 1, 297, 88);
INSERT INTO public.who_global_data VALUES (70359, 437, 11349, 84, 1477, 297, 51);
INSERT INTO public.who_global_data VALUES (70360, 424, 26892, 37, 1176, 297, 209);
INSERT INTO public.who_global_data VALUES (70361, 4, 29, 0, 2, 297, 205);
INSERT INTO public.who_global_data VALUES (70362, 0, 0, 0, 0, 297, 18);
INSERT INTO public.who_global_data VALUES (70363, 30, 2643, 2, 43, 297, 72);
INSERT INTO public.who_global_data VALUES (70364, 4178, 97052, 1076, 14113, 297, 44);
INSERT INTO public.who_global_data VALUES (70365, 0, 6, 0, 0, 297, 15);
INSERT INTO public.who_global_data VALUES (70366, 1, 77, 0, 3, 297, 25);
INSERT INTO public.who_global_data VALUES (70367, 0, 0, 0, 0, 297, 179);
INSERT INTO public.who_global_data VALUES (70368, 0, 0, 0, 0, 297, 34);
INSERT INTO public.who_global_data VALUES (70369, 0, 113, 0, 8, 297, 207);
INSERT INTO public.who_global_data VALUES (70370, 21, 747, 0, 34, 297, 166);
INSERT INTO public.who_global_data VALUES (70371, 4062, 65111, 107, 1403, 297, 126);
INSERT INTO public.who_global_data VALUES (70372, 0, 0, 0, 0, 297, 97);
INSERT INTO public.who_global_data VALUES (70373, 1, 10, 0, 1, 297, 36);
INSERT INTO public.who_global_data VALUES (70374, 0, 0, 0, 0, 297, 125);
INSERT INTO public.who_global_data VALUES (70375, 0, 54, 0, 0, 297, 124);
INSERT INTO public.who_global_data VALUES (70376, 392, 3764, 10, 108, 297, 185);
INSERT INTO public.who_global_data VALUES (70377, 412, 4933, 3, 28, 297, 194);
INSERT INTO public.who_global_data VALUES (70378, 4, 53, 0, 3, 297, 144);
INSERT INTO public.who_global_data VALUES (70379, 24446, 578268, 1504, 23476, 297, 19);
INSERT INTO public.who_global_data VALUES (70380, 0, 51, 0, 1, 297, 217);
INSERT INTO public.who_global_data VALUES (70381, 0, 483, 1, 8, 297, 148);
INSERT INTO public.who_global_data VALUES (70382, 160, 1214, 0, 4, 297, 86);
INSERT INTO public.who_global_data VALUES (70383, 0, 0, 0, 0, 297, 13);
INSERT INTO public.who_global_data VALUES (70384, 0, 181, 0, 9, 297, 157);
INSERT INTO public.who_global_data VALUES (70385, 2, 267, 0, 0, 297, 8);
INSERT INTO public.who_global_data VALUES (70386, 0, 0, 0, 0, 297, 73);
INSERT INTO public.who_global_data VALUES (70387, 0, 1, 0, 0, 297, 101);
INSERT INTO public.who_global_data VALUES (70388, 0, 45, 0, 2, 297, 165);
INSERT INTO public.who_global_data VALUES (70389, 1, 18, 0, 3, 297, 14);
INSERT INTO public.who_global_data VALUES (70390, 49, 714, 2, 23, 298, 193);
INSERT INTO public.who_global_data VALUES (70391, 29, 437, 0, 22, 298, 113);
INSERT INTO public.who_global_data VALUES (70392, 69, 1983, 20, 313, 298, 143);
INSERT INTO public.who_global_data VALUES (70393, 0, 0, 0, 0, 298, 219);
INSERT INTO public.who_global_data VALUES (70394, 12, 651, 0, 29, 298, 186);
INSERT INTO public.who_global_data VALUES (70395, 0, 19, 0, 2, 298, 52);
INSERT INTO public.who_global_data VALUES (70396, 0, 3, 0, 0, 298, 180);
INSERT INTO public.who_global_data VALUES (70397, 2, 23, 0, 2, 298, 167);
INSERT INTO public.who_global_data VALUES (70398, 277, 2252, 13, 95, 298, 154);
INSERT INTO public.who_global_data VALUES (70399, 26, 1015, 1, 14, 298, 94);
INSERT INTO public.who_global_data VALUES (70400, 0, 92, 0, 0, 298, 66);
INSERT INTO public.who_global_data VALUES (70401, 44, 6366, 0, 61, 298, 58);
INSERT INTO public.who_global_data VALUES (70402, 106, 14043, 18, 368, 298, 163);
INSERT INTO public.who_global_data VALUES (70403, 50, 1148, 1, 12, 298, 37);
INSERT INTO public.who_global_data VALUES (70404, 5, 47, 0, 8, 298, 142);
INSERT INTO public.who_global_data VALUES (70405, 180, 1528, 1, 7, 298, 83);
INSERT INTO public.who_global_data VALUES (70406, 209, 1012, 7, 46, 298, 228);
INSERT INTO public.who_global_data VALUES (70407, 3, 71, 0, 4, 298, 188);
INSERT INTO public.who_global_data VALUES (70408, 341, 2919, 3, 29, 298, 62);
INSERT INTO public.who_global_data VALUES (70409, 537, 35064, 277, 4842, 298, 160);
INSERT INTO public.who_global_data VALUES (70410, 1, 14, 0, 2, 298, 50);
INSERT INTO public.who_global_data VALUES (70411, 0, 35, 0, 1, 298, 33);
INSERT INTO public.who_global_data VALUES (70412, 7, 57, 0, 4, 298, 183);
INSERT INTO public.who_global_data VALUES (70413, 0, 5, 0, 0, 298, 92);
INSERT INTO public.who_global_data VALUES (70414, 30, 330, 3, 27, 298, 158);
INSERT INTO public.who_global_data VALUES (70415, 0, 0, 0, 0, 298, 67);
INSERT INTO public.who_global_data VALUES (70416, 27, 1034, 0, 38, 298, 57);
INSERT INTO public.who_global_data VALUES (70417, 0, 13, 0, 1, 298, 38);
INSERT INTO public.who_global_data VALUES (70418, 1442, 22169, 99, 1223, 298, 141);
INSERT INTO public.who_global_data VALUES (70419, 0, 3, 0, 0, 298, 178);
INSERT INTO public.who_global_data VALUES (70420, 0, 136, 0, 1, 298, 108);
INSERT INTO public.who_global_data VALUES (70421, 10, 685, 3, 32, 298, 39);
INSERT INTO public.who_global_data VALUES (70422, 54, 497, 8, 27, 298, 2);
INSERT INTO public.who_global_data VALUES (70423, 0, 5, 0, 0, 298, 195);
INSERT INTO public.who_global_data VALUES (70424, 3, 10, 0, 1, 298, 107);
INSERT INTO public.who_global_data VALUES (70425, 0, 122, 0, 0, 298, 161);
INSERT INTO public.who_global_data VALUES (70426, 0, 803, 0, 10, 298, 212);
INSERT INTO public.who_global_data VALUES (70427, 1084, 24786, 60, 734, 298, 181);
INSERT INTO public.who_global_data VALUES (70428, 0, 53, 0, 1, 298, 53);
INSERT INTO public.who_global_data VALUES (70429, 0, 11, 0, 0, 298, 164);
INSERT INTO public.who_global_data VALUES (70430, 5, 23, 0, 0, 298, 140);
INSERT INTO public.who_global_data VALUES (70431, 312, 7525, 2, 82, 298, 20);
INSERT INTO public.who_global_data VALUES (70432, 99, 83696, 0, 3351, 298, 112);
INSERT INTO public.who_global_data VALUES (70433, 67, 2776, 9, 109, 298, 111);
INSERT INTO public.who_global_data VALUES (70434, 0, 0, 0, 0, 298, 71);
INSERT INTO public.who_global_data VALUES (70435, 4, 74, 0, 5, 298, 218);
INSERT INTO public.who_global_data VALUES (70436, 0, 0, 0, 0, 298, 43);
INSERT INTO public.who_global_data VALUES (70437, 18, 595, 0, 3, 298, 49);
INSERT INTO public.who_global_data VALUES (70438, 93, 626, 2, 6, 298, 1);
INSERT INTO public.who_global_data VALUES (70439, 50, 1650, 2, 25, 298, 48);
INSERT INTO public.who_global_data VALUES (70440, 57, 726, 3, 21, 298, 232);
INSERT INTO public.who_global_data VALUES (70441, 0, 14, 0, 1, 298, 175);
INSERT INTO public.who_global_data VALUES (70442, 29, 662, 1, 12, 298, 21);
INSERT INTO public.who_global_data VALUES (70443, 68, 6059, 5, 143, 298, 156);
INSERT INTO public.who_global_data VALUES (70444, 0, 0, 0, 0, 298, 95);
INSERT INTO public.who_global_data VALUES (70445, 6, 241, 0, 20, 298, 177);
INSERT INTO public.who_global_data VALUES (70446, 144, 6318, 12, 285, 298, 210);
INSERT INTO public.who_global_data VALUES (70447, 65, 363, 0, 2, 298, 120);
INSERT INTO public.who_global_data VALUES (70448, 0, 16, 0, 0, 298, 135);
INSERT INTO public.who_global_data VALUES (70449, 200, 3167, 4, 177, 298, 206);
INSERT INTO public.who_global_data VALUES (70450, 63, 7529, 22, 355, 298, 189);
INSERT INTO public.who_global_data VALUES (70451, 125, 2190, 5, 164, 298, 129);
INSERT INTO public.who_global_data VALUES (70452, 12, 137, 0, 6, 298, 121);
INSERT INTO public.who_global_data VALUES (70453, 3, 21, 0, 0, 298, 59);
INSERT INTO public.who_global_data VALUES (70454, 0, 34, 0, 0, 298, 96);
INSERT INTO public.who_global_data VALUES (70455, 23, 1332, 3, 28, 298, 41);
INSERT INTO public.who_global_data VALUES (70456, 0, 14, 0, 0, 298, 216);
INSERT INTO public.who_global_data VALUES (70457, 3, 74, 0, 3, 298, 236);
INSERT INTO public.who_global_data VALUES (70458, 0, 5, 0, 0, 298, 150);
INSERT INTO public.who_global_data VALUES (70459, 0, 184, 0, 0, 298, 61);
INSERT INTO public.who_global_data VALUES (70460, 0, 16, 0, 0, 298, 7);
INSERT INTO public.who_global_data VALUES (70461, 90, 3064, 3, 59, 298, 169);
INSERT INTO public.who_global_data VALUES (70462, 2669, 97051, 572, 14946, 298, 28);
INSERT INTO public.who_global_data VALUES (70463, 2, 88, 0, 0, 298, 85);
INSERT INTO public.who_global_data VALUES (70464, 2, 55, 0, 0, 298, 211);
INSERT INTO public.who_global_data VALUES (70465, 0, 57, 0, 1, 298, 60);
INSERT INTO public.who_global_data VALUES (70466, 0, 9, 0, 1, 298, 3);
INSERT INTO public.who_global_data VALUES (70467, 30, 296, 0, 3, 298, 11);
INSERT INTO public.who_global_data VALUES (70468, 2082, 125098, 170, 2969, 298, 89);
INSERT INTO public.who_global_data VALUES (70469, 0, 566, 0, 8, 298, 24);
INSERT INTO public.who_global_data VALUES (70470, 0, 129, 0, 0, 298, 162);
INSERT INTO public.who_global_data VALUES (70471, 31, 2145, 1, 99, 298, 100);
INSERT INTO public.who_global_data VALUES (70472, 0, 11, 0, 0, 298, 47);
INSERT INTO public.who_global_data VALUES (70473, 0, 13, 0, 0, 298, 29);
INSERT INTO public.who_global_data VALUES (70474, 0, 143, 0, 8, 298, 40);
INSERT INTO public.who_global_data VALUES (70475, 0, 133, 0, 5, 298, 222);
INSERT INTO public.who_global_data VALUES (70476, 3, 156, 2, 5, 298, 132);
INSERT INTO public.who_global_data VALUES (70477, 9, 218, 0, 6, 298, 130);
INSERT INTO public.who_global_data VALUES (70478, 69, 319, 0, 0, 298, 234);
INSERT INTO public.who_global_data VALUES (70479, 0, 39, 0, 0, 298, 23);
INSERT INTO public.who_global_data VALUES (70480, 10, 47, 0, 6, 298, 192);
INSERT INTO public.who_global_data VALUES (70481, 9, 40, 1, 3, 298, 69);
INSERT INTO public.who_global_data VALUES (70482, 0, 8, 0, 0, 298, 187);
INSERT INTO public.who_global_data VALUES (70483, 4, 397, 0, 25, 298, 230);
INSERT INTO public.who_global_data VALUES (70484, 54, 1512, 13, 122, 298, 77);
INSERT INTO public.who_global_data VALUES (70485, 10, 1711, 0, 8, 298, 9);
INSERT INTO public.who_global_data VALUES (70486, 1211, 10363, 31, 339, 298, 74);
INSERT INTO public.who_global_data VALUES (70487, 282, 4839, 60, 459, 298, 224);
INSERT INTO public.who_global_data VALUES (70488, 1574, 74877, 98, 4683, 298, 199);
INSERT INTO public.who_global_data VALUES (70489, 22, 1400, 0, 78, 298, 190);
INSERT INTO public.who_global_data VALUES (70490, 992, 10647, 31, 365, 298, 12);
INSERT INTO public.who_global_data VALUES (70491, 2, 228, 1, 2, 298, 104);
INSERT INTO public.who_global_data VALUES (70492, 552, 11510, 6, 109, 298, 153);
INSERT INTO public.who_global_data VALUES (70493, 3153, 159516, 564, 20465, 298, 91);
INSERT INTO public.who_global_data VALUES (70494, 3, 72, 0, 4, 298, 215);
INSERT INTO public.who_global_data VALUES (70495, 390, 7645, 7, 109, 298, 84);
INSERT INTO public.who_global_data VALUES (70496, 15, 213, 0, 4, 298, 231);
INSERT INTO public.who_global_data VALUES (70497, 2, 391, 0, 7, 298, 196);
INSERT INTO public.who_global_data VALUES (70498, 184, 1275, 0, 12, 298, 105);
INSERT INTO public.who_global_data VALUES (70499, 11, 208, 1, 9, 298, 122);
INSERT INTO public.who_global_data VALUES (70500, 0, 0, 0, 0, 298, 159);
INSERT INTO public.who_global_data VALUES (70501, 15, 377, 1, 9, 298, 75);
INSERT INTO public.who_global_data VALUES (70502, 55, 1355, 1, 3, 298, 27);
INSERT INTO public.who_global_data VALUES (70503, 11, 430, 0, 5, 298, 54);
INSERT INTO public.who_global_data VALUES (70504, 0, 19, 0, 0, 298, 226);
INSERT INTO public.who_global_data VALUES (70505, 4, 655, 0, 5, 298, 79);
INSERT INTO public.who_global_data VALUES (70506, 9, 641, 1, 21, 298, 56);
INSERT INTO public.who_global_data VALUES (70507, 0, 0, 0, 0, 298, 117);
INSERT INTO public.who_global_data VALUES (70508, 1, 51, 1, 6, 298, 152);
INSERT INTO public.who_global_data VALUES (70509, 1, 26, 0, 1, 298, 16);
INSERT INTO public.who_global_data VALUES (70510, 0, 81, 0, 1, 298, 10);
INSERT INTO public.who_global_data VALUES (70511, 7, 977, 1, 26, 298, 201);
INSERT INTO public.who_global_data VALUES (70512, 11, 3292, 1, 67, 298, 174);
INSERT INTO public.who_global_data VALUES (70513, 0, 106, 0, 0, 298, 119);
INSERT INTO public.who_global_data VALUES (70514, 3, 16, 0, 2, 298, 168);
INSERT INTO public.who_global_data VALUES (70515, 134, 4817, 1, 77, 298, 99);
INSERT INTO public.who_global_data VALUES (70516, 0, 20, 0, 0, 298, 171);
INSERT INTO public.who_global_data VALUES (70517, 29, 116, 2, 9, 298, 87);
INSERT INTO public.who_global_data VALUES (70518, 9, 393, 0, 3, 298, 123);
INSERT INTO public.who_global_data VALUES (70519, 0, 0, 0, 0, 298, 151);
INSERT INTO public.who_global_data VALUES (70520, 1, 157, 2, 8, 298, 213);
INSERT INTO public.who_global_data VALUES (70521, 0, 7, 0, 1, 298, 118);
INSERT INTO public.who_global_data VALUES (70522, 0, 324, 0, 9, 298, 134);
INSERT INTO public.who_global_data VALUES (70523, 0, 207, 0, 3, 298, 65);
INSERT INTO public.who_global_data VALUES (70524, 442, 4661, 23, 296, 298, 102);
INSERT INTO public.who_global_data VALUES (70525, 0, 0, 0, 0, 298, 223);
INSERT INTO public.who_global_data VALUES (70526, 0, 64, 0, 1, 298, 4);
INSERT INTO public.who_global_data VALUES (70527, 14, 30, 0, 0, 298, 146);
INSERT INTO public.who_global_data VALUES (70528, 10, 288, 0, 4, 298, 31);
INSERT INTO public.who_global_data VALUES (70529, 2, 11, 0, 0, 298, 127);
INSERT INTO public.who_global_data VALUES (70530, 92, 1838, 6, 126, 298, 22);
INSERT INTO public.who_global_data VALUES (70531, 1, 21, 0, 0, 298, 115);
INSERT INTO public.who_global_data VALUES (70532, 21, 62, 0, 4, 298, 106);
INSERT INTO public.who_global_data VALUES (70533, 0, 16, 0, 0, 298, 90);
INSERT INTO public.who_global_data VALUES (70534, 0, 0, 0, 0, 298, 70);
INSERT INTO public.who_global_data VALUES (70535, 2, 16, 0, 0, 298, 46);
INSERT INTO public.who_global_data VALUES (70536, 959, 26317, 74, 2780, 298, 139);
INSERT INTO public.who_global_data VALUES (70537, 0, 18, 0, 0, 298, 42);
INSERT INTO public.who_global_data VALUES (70538, 8, 1072, 4, 9, 298, 80);
INSERT INTO public.who_global_data VALUES (70539, 0, 9, 0, 1, 298, 203);
INSERT INTO public.who_global_data VALUES (70540, 19, 548, 1, 13, 298, 136);
INSERT INTO public.who_global_data VALUES (70541, 20, 343, 0, 10, 298, 63);
INSERT INTO public.who_global_data VALUES (70542, 0, 0, 0, 0, 298, 17);
INSERT INTO public.who_global_data VALUES (70543, 0, 11, 0, 2, 298, 172);
INSERT INTO public.who_global_data VALUES (70544, 26, 854, 4, 38, 298, 109);
INSERT INTO public.who_global_data VALUES (70545, 73, 6488, 11, 114, 298, 200);
INSERT INTO public.who_global_data VALUES (70546, 14, 287, 0, 2, 298, 93);
INSERT INTO public.who_global_data VALUES (70547, 86, 813, 0, 4, 298, 5);
INSERT INTO public.who_global_data VALUES (70548, 0, 712, 0, 12, 298, 214);
INSERT INTO public.who_global_data VALUES (70549, 341, 5837, 3, 96, 298, 204);
INSERT INTO public.who_global_data VALUES (70550, 0, 0, 0, 0, 298, 198);
INSERT INTO public.who_global_data VALUES (70551, 166, 3400, 8, 87, 298, 173);
INSERT INTO public.who_global_data VALUES (70552, 0, 2, 0, 0, 298, 229);
INSERT INTO public.who_global_data VALUES (70553, 13, 147, 0, 6, 298, 76);
INSERT INTO public.who_global_data VALUES (70554, 671, 7519, 12, 193, 298, 138);
INSERT INTO public.who_global_data VALUES (70555, 291, 5223, 20, 335, 298, 98);
INSERT INTO public.who_global_data VALUES (70556, 0, 0, 0, 0, 298, 103);
INSERT INTO public.who_global_data VALUES (70557, 260, 6934, 13, 245, 298, 225);
INSERT INTO public.who_global_data VALUES (70558, 349, 16934, 31, 535, 298, 131);
INSERT INTO public.who_global_data VALUES (70559, 6, 903, 1, 45, 298, 235);
INSERT INTO public.who_global_data VALUES (70560, 197, 3428, 0, 7, 298, 137);
INSERT INTO public.who_global_data VALUES (70561, 27, 10564, 5, 222, 298, 81);
INSERT INTO public.who_global_data VALUES (70562, 50, 1712, 3, 36, 298, 182);
INSERT INTO public.who_global_data VALUES (70563, 1, 390, 0, 0, 298, 145);
INSERT INTO public.who_global_data VALUES (70564, 333, 6633, 12, 318, 298, 26);
INSERT INTO public.who_global_data VALUES (70565, 2774, 21102, 22, 170, 298, 170);
INSERT INTO public.who_global_data VALUES (70566, 1, 127, 0, 0, 298, 191);
INSERT INTO public.who_global_data VALUES (70567, 0, 2, 0, 0, 298, 221);
INSERT INTO public.who_global_data VALUES (70568, 0, 6, 0, 0, 298, 64);
INSERT INTO public.who_global_data VALUES (70569, 0, 0, 0, 0, 298, 116);
INSERT INTO public.who_global_data VALUES (70570, 0, 12, 0, 0, 298, 128);
INSERT INTO public.who_global_data VALUES (70571, 0, 15, 0, 0, 298, 6);
INSERT INTO public.who_global_data VALUES (70572, 0, 33, 0, 2, 298, 227);
INSERT INTO public.who_global_data VALUES (70573, 0, 1, 0, 0, 298, 68);
INSERT INTO public.who_global_data VALUES (70574, 0, 12, 0, 0, 298, 184);
INSERT INTO public.who_global_data VALUES (70575, 0, 0, 0, 0, 298, 82);
INSERT INTO public.who_global_data VALUES (70576, 15, 371, 1, 36, 298, 149);
INSERT INTO public.who_global_data VALUES (70577, 0, 4, 0, 0, 298, 197);
INSERT INTO public.who_global_data VALUES (70578, 435, 5369, 8, 73, 298, 78);
INSERT INTO public.who_global_data VALUES (70579, 11, 291, 0, 2, 298, 233);
INSERT INTO public.who_global_data VALUES (70580, 424, 4054, 5, 85, 298, 133);
INSERT INTO public.who_global_data VALUES (70581, 0, 11, 0, 0, 298, 35);
INSERT INTO public.who_global_data VALUES (70582, 0, 10, 0, 0, 298, 114);
INSERT INTO public.who_global_data VALUES (70583, 386, 2918, 1, 9, 298, 237);
INSERT INTO public.who_global_data VALUES (70584, 0, 2, 0, 0, 298, 55);
INSERT INTO public.who_global_data VALUES (70585, 2, 52, 0, 9, 298, 176);
INSERT INTO public.who_global_data VALUES (70586, 27, 769, 0, 2, 298, 202);
INSERT INTO public.who_global_data VALUES (70587, 8, 1221, 3, 64, 298, 155);
INSERT INTO public.who_global_data VALUES (70588, 0, 0, 0, 0, 298, 32);
INSERT INTO public.who_global_data VALUES (70589, 35, 60, 0, 2, 298, 220);
INSERT INTO public.who_global_data VALUES (70590, 99, 2272, 2, 27, 298, 30);
INSERT INTO public.who_global_data VALUES (70591, 0, 4, 0, 0, 298, 147);
INSERT INTO public.who_global_data VALUES (70592, 2379, 183666, 544, 19185, 298, 208);
INSERT INTO public.who_global_data VALUES (70593, 8, 218, 0, 7, 298, 45);
INSERT INTO public.who_global_data VALUES (70594, 10, 29, 2, 4, 298, 110);
INSERT INTO public.who_global_data VALUES (70595, 0, 10, 0, 1, 298, 88);
INSERT INTO public.who_global_data VALUES (70596, 464, 10912, 97, 1393, 298, 51);
INSERT INTO public.who_global_data VALUES (70597, 245, 26468, 36, 1139, 298, 209);
INSERT INTO public.who_global_data VALUES (70598, 0, 25, 0, 2, 298, 205);
INSERT INTO public.who_global_data VALUES (70599, 0, 0, 0, 0, 298, 18);
INSERT INTO public.who_global_data VALUES (70600, 34, 2613, 1, 41, 298, 72);
INSERT INTO public.who_global_data VALUES (70601, 3489, 92874, 724, 13037, 298, 44);
INSERT INTO public.who_global_data VALUES (70602, 2, 6, 0, 0, 298, 15);
INSERT INTO public.who_global_data VALUES (70603, 0, 76, 0, 3, 298, 25);
INSERT INTO public.who_global_data VALUES (70604, 0, 0, 0, 0, 298, 179);
INSERT INTO public.who_global_data VALUES (70605, 0, 0, 0, 0, 298, 34);
INSERT INTO public.who_global_data VALUES (70606, 1, 113, 0, 8, 298, 207);
INSERT INTO public.who_global_data VALUES (70607, 19, 726, 3, 34, 298, 166);
INSERT INTO public.who_global_data VALUES (70608, 4093, 61049, 98, 1296, 298, 126);
INSERT INTO public.who_global_data VALUES (70609, 0, 0, 0, 0, 298, 97);
INSERT INTO public.who_global_data VALUES (70610, 0, 9, 0, 1, 298, 36);
INSERT INTO public.who_global_data VALUES (70611, 0, 0, 0, 0, 298, 125);
INSERT INTO public.who_global_data VALUES (70612, 0, 54, 0, 0, 298, 124);
INSERT INTO public.who_global_data VALUES (70613, 270, 3372, 5, 98, 298, 185);
INSERT INTO public.who_global_data VALUES (70614, 398, 4521, 0, 25, 298, 194);
INSERT INTO public.who_global_data VALUES (70615, 17, 49, 0, 3, 298, 144);
INSERT INTO public.who_global_data VALUES (70616, 29308, 553822, 1528, 21972, 298, 19);
INSERT INTO public.who_global_data VALUES (70617, 0, 51, 0, 1, 298, 217);
INSERT INTO public.who_global_data VALUES (70618, 11, 483, 0, 7, 298, 148);
INSERT INTO public.who_global_data VALUES (70619, 158, 1054, 0, 4, 298, 86);
INSERT INTO public.who_global_data VALUES (70620, 0, 0, 0, 0, 298, 13);
INSERT INTO public.who_global_data VALUES (70621, 10, 181, 0, 9, 298, 157);
INSERT INTO public.who_global_data VALUES (70622, 3, 265, 0, 0, 298, 8);
INSERT INTO public.who_global_data VALUES (70623, 0, 0, 0, 0, 298, 73);
INSERT INTO public.who_global_data VALUES (70624, 0, 1, 0, 0, 298, 101);
INSERT INTO public.who_global_data VALUES (70625, 2, 45, 0, 2, 298, 165);
INSERT INTO public.who_global_data VALUES (70626, 3, 17, 0, 3, 298, 14);
INSERT INTO public.who_global_data VALUES (70627, 110, 665, 3, 21, 299, 193);
INSERT INTO public.who_global_data VALUES (70628, 0, 408, 0, 22, 299, 113);
INSERT INTO public.who_global_data VALUES (70629, 89, 1914, 18, 293, 299, 143);
INSERT INTO public.who_global_data VALUES (70630, 0, 0, 0, 0, 299, 219);
INSERT INTO public.who_global_data VALUES (70631, 17, 639, 1, 29, 299, 186);
INSERT INTO public.who_global_data VALUES (70632, 0, 19, 0, 2, 299, 52);
INSERT INTO public.who_global_data VALUES (70633, 0, 3, 0, 0, 299, 180);
INSERT INTO public.who_global_data VALUES (70634, 0, 21, 0, 2, 299, 167);
INSERT INTO public.who_global_data VALUES (70635, 0, 1975, 0, 82, 299, 154);
INSERT INTO public.who_global_data VALUES (70636, 46, 989, 0, 13, 299, 94);
INSERT INTO public.who_global_data VALUES (70637, 0, 92, 0, 0, 299, 66);
INSERT INTO public.who_global_data VALUES (70638, 9, 6322, 2, 61, 299, 58);
INSERT INTO public.who_global_data VALUES (70639, 130, 13937, 13, 350, 299, 163);
INSERT INTO public.who_global_data VALUES (70640, 40, 1098, 0, 11, 299, 37);
INSERT INTO public.who_global_data VALUES (70641, 0, 42, 0, 8, 299, 142);
INSERT INTO public.who_global_data VALUES (70642, 261, 1348, 0, 6, 299, 83);
INSERT INTO public.who_global_data VALUES (70643, 182, 803, 5, 39, 299, 228);
INSERT INTO public.who_global_data VALUES (70644, 1, 68, 0, 4, 299, 188);
INSERT INTO public.who_global_data VALUES (70645, 352, 2578, 3, 26, 299, 62);
INSERT INTO public.who_global_data VALUES (70646, 524, 34527, 265, 4565, 299, 160);
INSERT INTO public.who_global_data VALUES (70647, 3, 13, 0, 2, 299, 50);
INSERT INTO public.who_global_data VALUES (70648, 0, 35, 0, 1, 299, 33);
INSERT INTO public.who_global_data VALUES (70649, 2, 50, 0, 4, 299, 183);
INSERT INTO public.who_global_data VALUES (70650, 0, 5, 0, 0, 299, 92);
INSERT INTO public.who_global_data VALUES (70651, 25, 300, 4, 24, 299, 158);
INSERT INTO public.who_global_data VALUES (70652, 0, 0, 0, 0, 299, 67);
INSERT INTO public.who_global_data VALUES (70653, 59, 1007, 1, 38, 299, 57);
INSERT INTO public.who_global_data VALUES (70654, 0, 13, 0, 1, 299, 38);
INSERT INTO public.who_global_data VALUES (70655, 1089, 20727, 68, 1124, 299, 141);
INSERT INTO public.who_global_data VALUES (70656, 0, 3, 0, 0, 299, 178);
INSERT INTO public.who_global_data VALUES (70657, 0, 136, 0, 1, 299, 108);
INSERT INTO public.who_global_data VALUES (70658, 14, 675, 1, 29, 299, 39);
INSERT INTO public.who_global_data VALUES (70659, 0, 443, 0, 19, 299, 2);
INSERT INTO public.who_global_data VALUES (70660, 2, 5, 0, 0, 299, 195);
INSERT INTO public.who_global_data VALUES (70661, 0, 7, 0, 1, 299, 107);
INSERT INTO public.who_global_data VALUES (70662, 0, 122, 0, 0, 299, 161);
INSERT INTO public.who_global_data VALUES (70663, 0, 803, 0, 10, 299, 212);
INSERT INTO public.who_global_data VALUES (70664, 1158, 23702, 74, 674, 299, 181);
INSERT INTO public.who_global_data VALUES (70665, 8, 53, 0, 1, 299, 53);
INSERT INTO public.who_global_data VALUES (70666, 0, 11, 0, 0, 299, 164);
INSERT INTO public.who_global_data VALUES (70667, 7, 18, 0, 0, 299, 140);
INSERT INTO public.who_global_data VALUES (70668, 286, 7213, 7, 80, 299, 20);
INSERT INTO public.who_global_data VALUES (70669, 112, 83597, 2, 3351, 299, 112);
INSERT INTO public.who_global_data VALUES (70670, 236, 2709, 20, 100, 299, 111);
INSERT INTO public.who_global_data VALUES (70671, 0, 0, 0, 0, 299, 71);
INSERT INTO public.who_global_data VALUES (70672, 10, 70, 0, 5, 299, 218);
INSERT INTO public.who_global_data VALUES (70673, 0, 0, 0, 0, 299, 43);
INSERT INTO public.who_global_data VALUES (70674, 19, 577, 0, 3, 299, 49);
INSERT INTO public.who_global_data VALUES (70675, 0, 533, 0, 4, 299, 1);
INSERT INTO public.who_global_data VALUES (70676, 66, 1600, 2, 23, 299, 48);
INSERT INTO public.who_global_data VALUES (70677, 49, 669, 2, 18, 299, 232);
INSERT INTO public.who_global_data VALUES (70678, 0, 14, 0, 1, 299, 175);
INSERT INTO public.who_global_data VALUES (70679, 17, 633, 1, 11, 299, 21);
INSERT INTO public.who_global_data VALUES (70680, 89, 5991, 9, 138, 299, 156);
INSERT INTO public.who_global_data VALUES (70681, 0, 0, 0, 0, 299, 95);
INSERT INTO public.who_global_data VALUES (70682, 12, 235, 0, 20, 299, 177);
INSERT INTO public.who_global_data VALUES (70683, 178, 6174, 13, 273, 299, 210);
INSERT INTO public.who_global_data VALUES (70684, 83, 298, 0, 2, 299, 120);
INSERT INTO public.who_global_data VALUES (70685, 0, 16, 0, 0, 299, 135);
INSERT INTO public.who_global_data VALUES (70686, 347, 2967, 47, 173, 299, 206);
INSERT INTO public.who_global_data VALUES (70687, 209, 7466, 18, 333, 299, 189);
INSERT INTO public.who_global_data VALUES (70688, 126, 2065, 13, 159, 299, 129);
INSERT INTO public.who_global_data VALUES (70689, 7, 125, 0, 6, 299, 121);
INSERT INTO public.who_global_data VALUES (70690, 0, 18, 0, 0, 299, 59);
INSERT INTO public.who_global_data VALUES (70691, 1, 34, 0, 0, 299, 96);
INSERT INTO public.who_global_data VALUES (70692, 5, 1309, 1, 25, 299, 41);
INSERT INTO public.who_global_data VALUES (70693, 2, 14, 0, 0, 299, 216);
INSERT INTO public.who_global_data VALUES (70694, 2, 71, 0, 3, 299, 236);
INSERT INTO public.who_global_data VALUES (70695, 0, 5, 0, 0, 299, 150);
INSERT INTO public.who_global_data VALUES (70696, 0, 184, 0, 0, 299, 61);
INSERT INTO public.who_global_data VALUES (70697, 0, 16, 0, 0, 299, 7);
INSERT INTO public.who_global_data VALUES (70698, 69, 2974, 7, 56, 299, 169);
INSERT INTO public.who_global_data VALUES (70699, 1595, 94382, 560, 14374, 299, 28);
INSERT INTO public.who_global_data VALUES (70700, 0, 86, 0, 0, 299, 85);
INSERT INTO public.who_global_data VALUES (70701, 2, 53, 0, 0, 299, 211);
INSERT INTO public.who_global_data VALUES (70702, 8, 57, 0, 1, 299, 60);
INSERT INTO public.who_global_data VALUES (70703, 0, 9, 0, 1, 299, 3);
INSERT INTO public.who_global_data VALUES (70704, 14, 266, 0, 3, 299, 11);
INSERT INTO public.who_global_data VALUES (70705, 2537, 123016, 126, 2799, 299, 89);
INSERT INTO public.who_global_data VALUES (70706, 158, 566, 0, 8, 299, 24);
INSERT INTO public.who_global_data VALUES (70707, 16, 129, 0, 0, 299, 162);
INSERT INTO public.who_global_data VALUES (70708, 33, 2114, 5, 98, 299, 100);
INSERT INTO public.who_global_data VALUES (70709, 0, 11, 0, 0, 299, 47);
INSERT INTO public.who_global_data VALUES (70710, 0, 13, 0, 0, 299, 29);
INSERT INTO public.who_global_data VALUES (70711, 0, 143, 0, 8, 299, 40);
INSERT INTO public.who_global_data VALUES (70712, 0, 133, 0, 5, 299, 222);
INSERT INTO public.who_global_data VALUES (70713, 16, 153, 0, 3, 299, 132);
INSERT INTO public.who_global_data VALUES (70714, 9, 209, 0, 6, 299, 130);
INSERT INTO public.who_global_data VALUES (70715, 0, 250, 0, 0, 299, 234);
INSERT INTO public.who_global_data VALUES (70716, 1, 39, 0, 0, 299, 23);
INSERT INTO public.who_global_data VALUES (70717, 0, 37, 0, 6, 299, 192);
INSERT INTO public.who_global_data VALUES (70718, 0, 31, 0, 2, 299, 69);
INSERT INTO public.who_global_data VALUES (70719, 0, 8, 0, 0, 299, 187);
INSERT INTO public.who_global_data VALUES (70720, 1, 393, 1, 25, 299, 230);
INSERT INTO public.who_global_data VALUES (70721, 48, 1458, 10, 109, 299, 77);
INSERT INTO public.who_global_data VALUES (70722, 12, 1701, 0, 8, 299, 9);
INSERT INTO public.who_global_data VALUES (70723, 796, 9152, 35, 308, 299, 74);
INSERT INTO public.who_global_data VALUES (70724, 316, 4557, 26, 399, 299, 224);
INSERT INTO public.who_global_data VALUES (70725, 1617, 73303, 111, 4585, 299, 199);
INSERT INTO public.who_global_data VALUES (70726, 26, 1378, 2, 78, 299, 190);
INSERT INTO public.who_global_data VALUES (70727, 727, 9655, 14, 334, 299, 12);
INSERT INTO public.who_global_data VALUES (70728, 22, 226, 0, 1, 299, 104);
INSERT INTO public.who_global_data VALUES (70729, 345, 10958, 6, 103, 299, 153);
INSERT INTO public.who_global_data VALUES (70730, 4092, 156363, 431, 19901, 299, 91);
INSERT INTO public.who_global_data VALUES (70731, 4, 69, 0, 4, 299, 215);
INSERT INTO public.who_global_data VALUES (70732, 507, 7255, 4, 102, 299, 84);
INSERT INTO public.who_global_data VALUES (70733, 0, 198, 0, 4, 299, 231);
INSERT INTO public.who_global_data VALUES (70734, 8, 389, 0, 7, 299, 196);
INSERT INTO public.who_global_data VALUES (70735, 112, 1091, 0, 12, 299, 105);
INSERT INTO public.who_global_data VALUES (70736, 6, 197, 1, 8, 299, 122);
INSERT INTO public.who_global_data VALUES (70737, 0, 0, 0, 0, 299, 159);
INSERT INTO public.who_global_data VALUES (70738, 79, 362, 1, 8, 299, 75);
INSERT INTO public.who_global_data VALUES (70739, 66, 1300, 1, 2, 299, 27);
INSERT INTO public.who_global_data VALUES (70740, 42, 419, 0, 5, 299, 54);
INSERT INTO public.who_global_data VALUES (70741, 1, 19, 0, 0, 299, 226);
INSERT INTO public.who_global_data VALUES (70742, 21, 651, 2, 5, 299, 79);
INSERT INTO public.who_global_data VALUES (70743, 2, 632, 0, 20, 299, 56);
INSERT INTO public.who_global_data VALUES (70744, 0, 0, 0, 0, 299, 117);
INSERT INTO public.who_global_data VALUES (70745, 2, 50, 0, 5, 299, 152);
INSERT INTO public.who_global_data VALUES (70746, 0, 25, 0, 1, 299, 16);
INSERT INTO public.who_global_data VALUES (70747, 0, 81, 0, 1, 299, 10);
INSERT INTO public.who_global_data VALUES (70748, 18, 970, 0, 25, 299, 201);
INSERT INTO public.who_global_data VALUES (70749, 11, 3281, 4, 66, 299, 174);
INSERT INTO public.who_global_data VALUES (70750, 2, 106, 0, 0, 299, 119);
INSERT INTO public.who_global_data VALUES (70751, 1, 13, 0, 2, 299, 168);
INSERT INTO public.who_global_data VALUES (70752, 153, 4683, 3, 76, 299, 99);
INSERT INTO public.who_global_data VALUES (70753, 0, 20, 0, 0, 299, 171);
INSERT INTO public.who_global_data VALUES (70754, 0, 87, 0, 7, 299, 87);
INSERT INTO public.who_global_data VALUES (70755, 6, 384, 0, 3, 299, 123);
INSERT INTO public.who_global_data VALUES (70756, 0, 0, 0, 0, 299, 151);
INSERT INTO public.who_global_data VALUES (70757, 1, 156, 0, 6, 299, 213);
INSERT INTO public.who_global_data VALUES (70758, 0, 7, 0, 1, 299, 118);
INSERT INTO public.who_global_data VALUES (70759, 5, 324, 0, 9, 299, 134);
INSERT INTO public.who_global_data VALUES (70760, 16, 207, 1, 3, 299, 65);
INSERT INTO public.who_global_data VALUES (70761, 375, 4219, 40, 273, 299, 102);
INSERT INTO public.who_global_data VALUES (70762, 0, 0, 0, 0, 299, 223);
INSERT INTO public.who_global_data VALUES (70763, 1, 64, 0, 1, 299, 4);
INSERT INTO public.who_global_data VALUES (70764, 0, 16, 0, 0, 299, 146);
INSERT INTO public.who_global_data VALUES (70765, 5, 278, 1, 4, 299, 31);
INSERT INTO public.who_global_data VALUES (70766, 0, 9, 0, 0, 299, 127);
INSERT INTO public.who_global_data VALUES (70767, 129, 1746, 7, 120, 299, 22);
INSERT INTO public.who_global_data VALUES (70768, 0, 20, 0, 0, 299, 115);
INSERT INTO public.who_global_data VALUES (70769, 3, 41, 1, 4, 299, 106);
INSERT INTO public.who_global_data VALUES (70770, 0, 16, 0, 0, 299, 90);
INSERT INTO public.who_global_data VALUES (70771, 0, 0, 0, 0, 299, 70);
INSERT INTO public.who_global_data VALUES (70772, 2, 14, 0, 0, 299, 46);
INSERT INTO public.who_global_data VALUES (70773, 1171, 25358, 96, 2706, 299, 139);
INSERT INTO public.who_global_data VALUES (70774, 0, 18, 0, 0, 299, 42);
INSERT INTO public.who_global_data VALUES (70775, 15, 1064, 1, 5, 299, 80);
INSERT INTO public.who_global_data VALUES (70776, 2, 9, 0, 1, 299, 203);
INSERT INTO public.who_global_data VALUES (70777, 38, 529, 1, 12, 299, 136);
INSERT INTO public.who_global_data VALUES (70778, 5, 323, 0, 10, 299, 63);
INSERT INTO public.who_global_data VALUES (70779, 0, 0, 0, 0, 299, 17);
INSERT INTO public.who_global_data VALUES (70780, 0, 11, 0, 2, 299, 172);
INSERT INTO public.who_global_data VALUES (70781, 0, 828, 0, 34, 299, 109);
INSERT INTO public.who_global_data VALUES (70782, 95, 6415, 5, 103, 299, 200);
INSERT INTO public.who_global_data VALUES (70783, 5, 273, 0, 2, 299, 93);
INSERT INTO public.who_global_data VALUES (70784, 128, 727, 0, 4, 299, 5);
INSERT INTO public.who_global_data VALUES (70785, 0, 712, 1, 12, 299, 214);
INSERT INTO public.who_global_data VALUES (70786, 313, 5496, 5, 93, 299, 204);
INSERT INTO public.who_global_data VALUES (70787, 0, 0, 0, 0, 299, 198);
INSERT INTO public.who_global_data VALUES (70788, 260, 3234, 5, 79, 299, 173);
INSERT INTO public.who_global_data VALUES (70789, 0, 2, 0, 0, 299, 229);
INSERT INTO public.who_global_data VALUES (70790, 1, 134, 0, 6, 299, 76);
INSERT INTO public.who_global_data VALUES (70791, 951, 6848, 12, 181, 299, 138);
INSERT INTO public.who_global_data VALUES (70792, 284, 4932, 18, 315, 299, 98);
INSERT INTO public.who_global_data VALUES (70793, 0, 0, 0, 0, 299, 103);
INSERT INTO public.who_global_data VALUES (70794, 318, 6674, 24, 232, 299, 225);
INSERT INTO public.who_global_data VALUES (70795, 598, 16585, 34, 504, 299, 131);
INSERT INTO public.who_global_data VALUES (70796, 109, 897, 2, 44, 299, 235);
INSERT INTO public.who_global_data VALUES (70797, 252, 3231, 0, 7, 299, 137);
INSERT INTO public.who_global_data VALUES (70798, 25, 10537, 3, 217, 299, 81);
INSERT INTO public.who_global_data VALUES (70799, 102, 1662, 3, 33, 299, 182);
INSERT INTO public.who_global_data VALUES (70800, 1, 389, 0, 0, 299, 145);
INSERT INTO public.who_global_data VALUES (70801, 310, 6300, 24, 306, 299, 26);
INSERT INTO public.who_global_data VALUES (70802, 2558, 18328, 18, 148, 299, 170);
INSERT INTO public.who_global_data VALUES (70803, 6, 126, 0, 0, 299, 191);
INSERT INTO public.who_global_data VALUES (70804, 1, 2, 0, 0, 299, 221);
INSERT INTO public.who_global_data VALUES (70805, 0, 6, 0, 0, 299, 64);
INSERT INTO public.who_global_data VALUES (70806, 0, 0, 0, 0, 299, 116);
INSERT INTO public.who_global_data VALUES (70807, 0, 12, 0, 0, 299, 128);
INSERT INTO public.who_global_data VALUES (70808, 0, 15, 0, 0, 299, 6);
INSERT INTO public.who_global_data VALUES (70809, 0, 33, 0, 2, 299, 227);
INSERT INTO public.who_global_data VALUES (70810, 0, 1, 0, 0, 299, 68);
INSERT INTO public.who_global_data VALUES (70811, 0, 12, 0, 0, 299, 184);
INSERT INTO public.who_global_data VALUES (70812, 0, 0, 0, 0, 299, 82);
INSERT INTO public.who_global_data VALUES (70813, 0, 356, 0, 35, 299, 149);
INSERT INTO public.who_global_data VALUES (70814, 0, 4, 0, 0, 299, 197);
INSERT INTO public.who_global_data VALUES (70815, 472, 4934, 6, 65, 299, 78);
INSERT INTO public.who_global_data VALUES (70816, 2, 280, 0, 2, 299, 233);
INSERT INTO public.who_global_data VALUES (70817, 250, 3630, 6, 80, 299, 133);
INSERT INTO public.who_global_data VALUES (70818, 0, 11, 0, 0, 299, 35);
INSERT INTO public.who_global_data VALUES (70819, 2, 10, 0, 0, 299, 114);
INSERT INTO public.who_global_data VALUES (70820, 233, 2532, 0, 8, 299, 237);
INSERT INTO public.who_global_data VALUES (70821, 0, 2, 0, 0, 299, 55);
INSERT INTO public.who_global_data VALUES (70822, 0, 50, 0, 9, 299, 176);
INSERT INTO public.who_global_data VALUES (70823, 14, 742, 0, 2, 299, 202);
INSERT INTO public.who_global_data VALUES (70824, 7, 1213, 4, 61, 299, 155);
INSERT INTO public.who_global_data VALUES (70825, 0, 0, 0, 0, 299, 32);
INSERT INTO public.who_global_data VALUES (70826, 4, 25, 1, 2, 299, 220);
INSERT INTO public.who_global_data VALUES (70827, 145, 2173, 0, 25, 299, 30);
INSERT INTO public.who_global_data VALUES (70828, 0, 4, 0, 0, 299, 147);
INSERT INTO public.who_global_data VALUES (70829, 3077, 181287, 628, 18641, 299, 208);
INSERT INTO public.who_global_data VALUES (70830, 11, 210, 0, 7, 299, 45);
INSERT INTO public.who_global_data VALUES (70831, 0, 19, 0, 2, 299, 110);
INSERT INTO public.who_global_data VALUES (70832, 0, 10, 0, 1, 299, 88);
INSERT INTO public.who_global_data VALUES (70833, 395, 10448, 102, 1296, 299, 51);
INSERT INTO public.who_global_data VALUES (70834, 219, 26223, 36, 1103, 299, 209);
INSERT INTO public.who_global_data VALUES (70835, 0, 25, 0, 2, 299, 205);
INSERT INTO public.who_global_data VALUES (70836, 0, 0, 0, 0, 299, 18);
INSERT INTO public.who_global_data VALUES (70837, 28, 2579, 2, 40, 299, 72);
INSERT INTO public.who_global_data VALUES (70838, 3579, 89385, 657, 12313, 299, 44);
INSERT INTO public.who_global_data VALUES (70839, 2, 4, 0, 0, 299, 15);
INSERT INTO public.who_global_data VALUES (70840, 3, 76, 0, 3, 299, 25);
INSERT INTO public.who_global_data VALUES (70841, 0, 0, 0, 0, 299, 179);
INSERT INTO public.who_global_data VALUES (70842, 0, 0, 0, 0, 299, 34);
INSERT INTO public.who_global_data VALUES (70843, 3, 112, 0, 8, 299, 207);
INSERT INTO public.who_global_data VALUES (70844, 22, 707, 3, 31, 299, 166);
INSERT INTO public.who_global_data VALUES (70845, 4789, 56956, 97, 1198, 299, 126);
INSERT INTO public.who_global_data VALUES (70846, 0, 0, 0, 0, 299, 97);
INSERT INTO public.who_global_data VALUES (70847, 1, 9, 0, 1, 299, 36);
INSERT INTO public.who_global_data VALUES (70848, 0, 0, 0, 0, 299, 125);
INSERT INTO public.who_global_data VALUES (70849, 1, 54, 0, 0, 299, 124);
INSERT INTO public.who_global_data VALUES (70850, 325, 3102, 10, 93, 299, 185);
INSERT INTO public.who_global_data VALUES (70851, 387, 4123, 5, 25, 299, 194);
INSERT INTO public.who_global_data VALUES (70852, 0, 32, 0, 3, 299, 144);
INSERT INTO public.who_global_data VALUES (70853, 31633, 524514, 1928, 20444, 299, 19);
INSERT INTO public.who_global_data VALUES (70854, 0, 51, 0, 1, 299, 217);
INSERT INTO public.who_global_data VALUES (70855, 7, 472, 0, 7, 299, 148);
INSERT INTO public.who_global_data VALUES (70856, 100, 896, 1, 4, 299, 86);
INSERT INTO public.who_global_data VALUES (70857, 0, 0, 0, 0, 299, 13);
INSERT INTO public.who_global_data VALUES (70858, 0, 171, 0, 9, 299, 157);
INSERT INTO public.who_global_data VALUES (70859, 4, 262, 0, 0, 299, 8);
INSERT INTO public.who_global_data VALUES (70860, 0, 0, 0, 0, 299, 73);
INSERT INTO public.who_global_data VALUES (70861, 0, 1, 0, 0, 299, 101);
INSERT INTO public.who_global_data VALUES (70862, 3, 43, 0, 2, 299, 165);
INSERT INTO public.who_global_data VALUES (70863, 1, 14, 0, 3, 299, 14);
INSERT INTO public.who_global_data VALUES (70864, 34, 555, 3, 18, 300, 193);
INSERT INTO public.who_global_data VALUES (70865, 30, 408, 0, 22, 300, 113);
INSERT INTO public.who_global_data VALUES (70866, 64, 1825, 19, 275, 300, 143);
INSERT INTO public.who_global_data VALUES (70867, 0, 0, 0, 0, 300, 219);
INSERT INTO public.who_global_data VALUES (70868, 20, 622, 2, 28, 300, 186);
INSERT INTO public.who_global_data VALUES (70869, 0, 19, 0, 2, 300, 52);
INSERT INTO public.who_global_data VALUES (70870, 0, 3, 0, 0, 300, 180);
INSERT INTO public.who_global_data VALUES (70871, 2, 21, 0, 2, 300, 167);
INSERT INTO public.who_global_data VALUES (70872, 46, 1975, 3, 82, 300, 154);
INSERT INTO public.who_global_data VALUES (70873, 30, 943, 2, 13, 300, 94);
INSERT INTO public.who_global_data VALUES (70874, 6, 92, 0, 0, 300, 66);
INSERT INTO public.who_global_data VALUES (70875, 24, 6313, 3, 59, 300, 58);
INSERT INTO public.who_global_data VALUES (70876, 247, 13807, 18, 337, 300, 163);
INSERT INTO public.who_global_data VALUES (70877, 67, 1058, 1, 11, 300, 37);
INSERT INTO public.who_global_data VALUES (70878, 1, 42, 0, 8, 300, 142);
INSERT INTO public.who_global_data VALUES (70879, 71, 1087, 0, 6, 300, 83);
INSERT INTO public.who_global_data VALUES (70880, 139, 621, 4, 34, 300, 228);
INSERT INTO public.who_global_data VALUES (70881, 1, 67, 0, 4, 300, 188);
INSERT INTO public.who_global_data VALUES (70882, 245, 2226, 4, 23, 300, 62);
INSERT INTO public.who_global_data VALUES (70883, 1029, 34003, 284, 4300, 300, 160);
INSERT INTO public.who_global_data VALUES (70884, 0, 10, 1, 2, 300, 50);
INSERT INTO public.who_global_data VALUES (70885, 5, 35, 0, 1, 300, 33);
INSERT INTO public.who_global_data VALUES (70886, 0, 48, 0, 4, 300, 183);
INSERT INTO public.who_global_data VALUES (70887, 0, 5, 0, 0, 300, 92);
INSERT INTO public.who_global_data VALUES (70888, 7, 275, 1, 20, 300, 158);
INSERT INTO public.who_global_data VALUES (70889, 0, 0, 0, 0, 300, 67);
INSERT INTO public.who_global_data VALUES (70890, 47, 948, 0, 37, 300, 57);
INSERT INTO public.who_global_data VALUES (70891, 0, 13, 0, 1, 300, 38);
INSERT INTO public.who_global_data VALUES (70892, 1781, 19638, 115, 1056, 300, 141);
INSERT INTO public.who_global_data VALUES (70893, 0, 3, 0, 0, 300, 178);
INSERT INTO public.who_global_data VALUES (70894, 0, 136, 0, 1, 300, 108);
INSERT INTO public.who_global_data VALUES (70895, 26, 661, 3, 28, 300, 39);
INSERT INTO public.who_global_data VALUES (70896, 0, 443, 0, 19, 300, 2);
INSERT INTO public.who_global_data VALUES (70897, 0, 3, 0, 0, 300, 195);
INSERT INTO public.who_global_data VALUES (70898, 0, 7, 0, 1, 300, 107);
INSERT INTO public.who_global_data VALUES (70899, 2, 122, 0, 0, 300, 161);
INSERT INTO public.who_global_data VALUES (70900, 0, 803, 0, 10, 300, 212);
INSERT INTO public.who_global_data VALUES (70901, 1318, 22544, 69, 600, 300, 181);
INSERT INTO public.who_global_data VALUES (70902, 0, 45, 0, 1, 300, 53);
INSERT INTO public.who_global_data VALUES (70903, 0, 11, 0, 0, 300, 164);
INSERT INTO public.who_global_data VALUES (70904, 0, 11, 0, 0, 300, 140);
INSERT INTO public.who_global_data VALUES (70905, 426, 6927, 8, 73, 300, 20);
INSERT INTO public.who_global_data VALUES (70906, 102, 83485, 0, 3349, 300, 112);
INSERT INTO public.who_global_data VALUES (70907, 250, 2473, 11, 80, 300, 111);
INSERT INTO public.who_global_data VALUES (70908, 0, 0, 0, 0, 300, 71);
INSERT INTO public.who_global_data VALUES (70909, 0, 60, 0, 5, 300, 218);
INSERT INTO public.who_global_data VALUES (70910, 0, 0, 0, 0, 300, 43);
INSERT INTO public.who_global_data VALUES (70911, 19, 558, 0, 3, 300, 49);
INSERT INTO public.who_global_data VALUES (70912, 53, 533, 1, 4, 300, 1);
INSERT INTO public.who_global_data VALUES (70913, 39, 1534, 0, 21, 300, 48);
INSERT INTO public.who_global_data VALUES (70914, 56, 620, 1, 16, 300, 232);
INSERT INTO public.who_global_data VALUES (70915, 0, 14, 0, 1, 300, 175);
INSERT INTO public.who_global_data VALUES (70916, 21, 616, 0, 10, 300, 21);
INSERT INTO public.who_global_data VALUES (70917, 170, 5902, 10, 129, 300, 156);
INSERT INTO public.who_global_data VALUES (70918, 0, 0, 0, 0, 300, 95);
INSERT INTO public.who_global_data VALUES (70919, 8, 223, 0, 20, 300, 177);
INSERT INTO public.who_global_data VALUES (70920, 177, 5996, 13, 260, 300, 210);
INSERT INTO public.who_global_data VALUES (70921, 28, 215, 0, 2, 300, 120);
INSERT INTO public.who_global_data VALUES (70922, 0, 16, 0, 0, 300, 135);
INSERT INTO public.who_global_data VALUES (70923, 271, 2620, 8, 126, 300, 206);
INSERT INTO public.who_global_data VALUES (70924, 96, 7257, 18, 315, 300, 189);
INSERT INTO public.who_global_data VALUES (70925, 145, 1939, 11, 146, 300, 129);
INSERT INTO public.who_global_data VALUES (70926, 1, 118, 0, 6, 300, 121);
INSERT INTO public.who_global_data VALUES (70927, 0, 18, 0, 0, 300, 59);
INSERT INTO public.who_global_data VALUES (70928, 0, 33, 0, 0, 300, 96);
INSERT INTO public.who_global_data VALUES (70929, 46, 1304, 0, 24, 300, 41);
INSERT INTO public.who_global_data VALUES (70930, 0, 12, 0, 0, 300, 216);
INSERT INTO public.who_global_data VALUES (70931, 4, 69, 1, 3, 300, 236);
INSERT INTO public.who_global_data VALUES (70932, 0, 5, 0, 0, 300, 150);
INSERT INTO public.who_global_data VALUES (70933, 0, 184, 0, 0, 300, 61);
INSERT INTO public.who_global_data VALUES (70934, 0, 16, 0, 0, 300, 7);
INSERT INTO public.who_global_data VALUES (70935, 136, 2905, 1, 49, 300, 169);
INSERT INTO public.who_global_data VALUES (70936, 3104, 92787, 635, 13814, 300, 28);
INSERT INTO public.who_global_data VALUES (70937, 2, 86, 0, 0, 300, 85);
INSERT INTO public.who_global_data VALUES (70938, 0, 51, 0, 0, 300, 211);
INSERT INTO public.who_global_data VALUES (70939, 5, 49, 0, 1, 300, 60);
INSERT INTO public.who_global_data VALUES (70940, 5, 9, 0, 1, 300, 3);
INSERT INTO public.who_global_data VALUES (70941, 19, 252, 0, 3, 300, 11);
INSERT INTO public.who_global_data VALUES (70942, 2821, 120479, 129, 2673, 300, 89);
INSERT INTO public.who_global_data VALUES (70943, 30, 408, 2, 8, 300, 24);
INSERT INTO public.who_global_data VALUES (70944, 0, 113, 0, 0, 300, 162);
INSERT INTO public.who_global_data VALUES (70945, 70, 2081, 3, 93, 300, 100);
INSERT INTO public.who_global_data VALUES (70946, 0, 11, 0, 0, 300, 47);
INSERT INTO public.who_global_data VALUES (70947, 1, 13, 0, 0, 300, 29);
INSERT INTO public.who_global_data VALUES (70948, 0, 143, 0, 8, 300, 40);
INSERT INTO public.who_global_data VALUES (70949, 3, 133, 1, 5, 300, 222);
INSERT INTO public.who_global_data VALUES (70950, 11, 137, 0, 3, 300, 132);
INSERT INTO public.who_global_data VALUES (70951, 9, 200, 1, 6, 300, 130);
INSERT INTO public.who_global_data VALUES (70952, 56, 250, 0, 0, 300, 234);
INSERT INTO public.who_global_data VALUES (70953, 3, 38, 0, 0, 300, 23);
INSERT INTO public.who_global_data VALUES (70954, 0, 37, 0, 6, 300, 192);
INSERT INTO public.who_global_data VALUES (70955, 1, 31, 0, 2, 300, 69);
INSERT INTO public.who_global_data VALUES (70956, 0, 8, 0, 0, 300, 187);
INSERT INTO public.who_global_data VALUES (70957, 10, 392, 1, 24, 300, 230);
INSERT INTO public.who_global_data VALUES (70958, 100, 1410, 14, 99, 300, 77);
INSERT INTO public.who_global_data VALUES (70959, 14, 1689, 1, 8, 300, 9);
INSERT INTO public.who_global_data VALUES (70960, 909, 8356, 34, 273, 300, 74);
INSERT INTO public.who_global_data VALUES (70961, 399, 4241, 46, 373, 300, 224);
INSERT INTO public.who_global_data VALUES (70962, 1657, 71686, 117, 4474, 300, 199);
INSERT INTO public.who_global_data VALUES (70963, 34, 1352, 4, 76, 300, 190);
INSERT INTO public.who_global_data VALUES (70964, 839, 8928, 33, 320, 300, 12);
INSERT INTO public.who_global_data VALUES (70965, 14, 204, 0, 1, 300, 104);
INSERT INTO public.who_global_data VALUES (70966, 359, 10613, 8, 97, 300, 153);
INSERT INTO public.who_global_data VALUES (70967, 4694, 152271, 619, 19470, 300, 91);
INSERT INTO public.who_global_data VALUES (70968, 2, 65, 0, 4, 300, 215);
INSERT INTO public.who_global_data VALUES (70969, 743, 6748, 4, 98, 300, 84);
INSERT INTO public.who_global_data VALUES (70970, 15, 198, 0, 4, 300, 231);
INSERT INTO public.who_global_data VALUES (70971, 9, 381, 0, 7, 300, 196);
INSERT INTO public.who_global_data VALUES (70972, 82, 979, 2, 12, 300, 105);
INSERT INTO public.who_global_data VALUES (70973, 2, 191, 0, 7, 300, 122);
INSERT INTO public.who_global_data VALUES (70974, 0, 0, 0, 0, 300, 159);
INSERT INTO public.who_global_data VALUES (70975, 33, 283, 0, 7, 300, 75);
INSERT INTO public.who_global_data VALUES (70976, 80, 1234, 0, 1, 300, 27);
INSERT INTO public.who_global_data VALUES (70977, 38, 377, 0, 5, 300, 54);
INSERT INTO public.who_global_data VALUES (70978, 2, 18, 0, 0, 300, 226);
INSERT INTO public.who_global_data VALUES (70979, 18, 630, 1, 3, 300, 79);
INSERT INTO public.who_global_data VALUES (70980, 11, 630, 0, 20, 300, 56);
INSERT INTO public.who_global_data VALUES (70981, 0, 0, 0, 0, 300, 117);
INSERT INTO public.who_global_data VALUES (70982, 11, 48, 0, 5, 300, 152);
INSERT INTO public.who_global_data VALUES (70983, 1, 25, 0, 1, 300, 16);
INSERT INTO public.who_global_data VALUES (70984, 1, 81, 0, 1, 300, 10);
INSERT INTO public.who_global_data VALUES (70985, 26, 952, 1, 25, 300, 201);
INSERT INTO public.who_global_data VALUES (70986, 47, 3270, 8, 62, 300, 174);
INSERT INTO public.who_global_data VALUES (70987, 9, 104, 0, 0, 300, 119);
INSERT INTO public.who_global_data VALUES (70988, 3, 12, 1, 2, 300, 168);
INSERT INTO public.who_global_data VALUES (70989, 184, 4530, 3, 73, 300, 99);
INSERT INTO public.who_global_data VALUES (70990, 1, 20, 0, 0, 300, 171);
INSERT INTO public.who_global_data VALUES (70991, 13, 87, 0, 7, 300, 87);
INSERT INTO public.who_global_data VALUES (70992, 8, 378, 1, 3, 300, 123);
INSERT INTO public.who_global_data VALUES (70993, 0, 0, 0, 0, 300, 151);
INSERT INTO public.who_global_data VALUES (70994, 1, 155, 0, 6, 300, 213);
INSERT INTO public.who_global_data VALUES (70995, 0, 7, 0, 1, 300, 118);
INSERT INTO public.who_global_data VALUES (70996, 1, 319, 0, 9, 300, 134);
INSERT INTO public.who_global_data VALUES (70997, 0, 191, 0, 2, 300, 65);
INSERT INTO public.who_global_data VALUES (70998, 403, 3844, 39, 233, 300, 102);
INSERT INTO public.who_global_data VALUES (70999, 0, 0, 0, 0, 300, 223);
INSERT INTO public.who_global_data VALUES (71000, 0, 63, 0, 1, 300, 4);
INSERT INTO public.who_global_data VALUES (71001, 0, 16, 0, 0, 300, 146);
INSERT INTO public.who_global_data VALUES (71002, 6, 273, 1, 3, 300, 31);
INSERT INTO public.who_global_data VALUES (71003, 0, 9, 0, 0, 300, 127);
INSERT INTO public.who_global_data VALUES (71004, 90, 1617, 3, 113, 300, 22);
INSERT INTO public.who_global_data VALUES (71005, 0, 20, 0, 0, 300, 115);
INSERT INTO public.who_global_data VALUES (71006, 10, 38, 0, 3, 300, 106);
INSERT INTO public.who_global_data VALUES (71007, 0, 16, 0, 0, 300, 90);
INSERT INTO public.who_global_data VALUES (71008, 0, 0, 0, 0, 300, 70);
INSERT INTO public.who_global_data VALUES (71009, 3, 12, 0, 0, 300, 46);
INSERT INTO public.who_global_data VALUES (71010, 1301, 24187, 142, 2610, 300, 139);
INSERT INTO public.who_global_data VALUES (71011, 0, 18, 0, 0, 300, 42);
INSERT INTO public.who_global_data VALUES (71012, 14, 1049, 0, 4, 300, 80);
INSERT INTO public.who_global_data VALUES (71013, 0, 7, 0, 1, 300, 203);
INSERT INTO public.who_global_data VALUES (71014, 53, 491, 0, 11, 300, 136);
INSERT INTO public.who_global_data VALUES (71015, 13, 318, 3, 10, 300, 63);
INSERT INTO public.who_global_data VALUES (71016, 0, 0, 0, 0, 300, 17);
INSERT INTO public.who_global_data VALUES (71017, 0, 11, 0, 2, 300, 172);
INSERT INTO public.who_global_data VALUES (71018, 117, 828, 2, 34, 300, 109);
INSERT INTO public.who_global_data VALUES (71019, 76, 6320, 6, 98, 300, 200);
INSERT INTO public.who_global_data VALUES (71020, 0, 268, 0, 2, 300, 93);
INSERT INTO public.who_global_data VALUES (71021, 53, 599, 1, 4, 300, 5);
INSERT INTO public.who_global_data VALUES (71022, 0, 712, 0, 11, 300, 214);
INSERT INTO public.who_global_data VALUES (71023, 213, 5183, 11, 88, 300, 204);
INSERT INTO public.who_global_data VALUES (71024, 0, 0, 0, 0, 300, 198);
INSERT INTO public.who_global_data VALUES (71025, 222, 2974, 8, 74, 300, 173);
INSERT INTO public.who_global_data VALUES (71026, 0, 2, 0, 0, 300, 229);
INSERT INTO public.who_global_data VALUES (71027, 4, 133, 0, 6, 300, 76);
INSERT INTO public.who_global_data VALUES (71028, 641, 5897, 31, 169, 300, 138);
INSERT INTO public.who_global_data VALUES (71029, 220, 4648, 50, 297, 300, 98);
INSERT INTO public.who_global_data VALUES (71030, 0, 0, 0, 0, 300, 103);
INSERT INTO public.who_global_data VALUES (71031, 401, 6356, 27, 208, 300, 225);
INSERT INTO public.who_global_data VALUES (71032, 515, 15987, 35, 470, 300, 131);
INSERT INTO public.who_global_data VALUES (71033, 63, 788, 3, 42, 300, 235);
INSERT INTO public.who_global_data VALUES (71034, 251, 2979, 1, 7, 300, 137);
INSERT INTO public.who_global_data VALUES (71035, 32, 10512, 3, 214, 300, 81);
INSERT INTO public.who_global_data VALUES (71036, 122, 1560, 1, 30, 300, 182);
INSERT INTO public.who_global_data VALUES (71037, 6, 388, 0, 0, 300, 145);
INSERT INTO public.who_global_data VALUES (71038, 523, 5990, 25, 282, 300, 26);
INSERT INTO public.who_global_data VALUES (71039, 2186, 15770, 24, 130, 300, 170);
INSERT INTO public.who_global_data VALUES (71040, 2, 120, 0, 0, 300, 191);
INSERT INTO public.who_global_data VALUES (71041, 0, 1, 0, 0, 300, 221);
INSERT INTO public.who_global_data VALUES (71042, 0, 6, 0, 0, 300, 64);
INSERT INTO public.who_global_data VALUES (71043, 0, 0, 0, 0, 300, 116);
INSERT INTO public.who_global_data VALUES (71044, 1, 12, 0, 0, 300, 128);
INSERT INTO public.who_global_data VALUES (71045, 1, 15, 0, 0, 300, 6);
INSERT INTO public.who_global_data VALUES (71046, 1, 33, 0, 2, 300, 227);
INSERT INTO public.who_global_data VALUES (71047, 0, 1, 0, 0, 300, 68);
INSERT INTO public.who_global_data VALUES (71048, 0, 12, 0, 0, 300, 184);
INSERT INTO public.who_global_data VALUES (71049, 0, 0, 0, 0, 300, 82);
INSERT INTO public.who_global_data VALUES (71050, 12, 356, 1, 35, 300, 149);
INSERT INTO public.who_global_data VALUES (71051, 0, 4, 0, 0, 300, 197);
INSERT INTO public.who_global_data VALUES (71052, 429, 4462, 7, 59, 300, 78);
INSERT INTO public.who_global_data VALUES (71053, 13, 278, 0, 2, 300, 233);
INSERT INTO public.who_global_data VALUES (71054, 275, 3380, 3, 74, 300, 133);
INSERT INTO public.who_global_data VALUES (71055, 0, 11, 0, 0, 300, 35);
INSERT INTO public.who_global_data VALUES (71056, 1, 8, 0, 0, 300, 114);
INSERT INTO public.who_global_data VALUES (71057, 191, 2299, 1, 8, 300, 237);
INSERT INTO public.who_global_data VALUES (71058, 0, 2, 0, 0, 300, 55);
INSERT INTO public.who_global_data VALUES (71059, 0, 50, 0, 9, 300, 176);
INSERT INTO public.who_global_data VALUES (71060, 13, 728, 0, 2, 300, 202);
INSERT INTO public.who_global_data VALUES (71061, 17, 1206, 3, 57, 300, 155);
INSERT INTO public.who_global_data VALUES (71062, 0, 0, 0, 0, 300, 32);
INSERT INTO public.who_global_data VALUES (71063, 0, 21, 0, 1, 300, 220);
INSERT INTO public.who_global_data VALUES (71064, 25, 2028, 1, 25, 300, 30);
INSERT INTO public.who_global_data VALUES (71065, 1, 4, 0, 0, 300, 147);
INSERT INTO public.who_global_data VALUES (71066, 4437, 178210, 676, 18013, 300, 208);
INSERT INTO public.who_global_data VALUES (71067, 2, 199, 0, 7, 300, 45);
INSERT INTO public.who_global_data VALUES (71068, 0, 19, 0, 2, 300, 110);
INSERT INTO public.who_global_data VALUES (71069, 0, 10, 0, 1, 300, 88);
INSERT INTO public.who_global_data VALUES (71070, 454, 10053, 90, 1194, 300, 51);
INSERT INTO public.who_global_data VALUES (71071, 261, 26004, 45, 1067, 300, 209);
INSERT INTO public.who_global_data VALUES (71072, 0, 25, 0, 2, 300, 205);
INSERT INTO public.who_global_data VALUES (71073, 0, 0, 0, 0, 300, 18);
INSERT INTO public.who_global_data VALUES (71074, 33, 2551, 3, 38, 300, 72);
INSERT INTO public.who_global_data VALUES (71075, 4313, 85806, 843, 11656, 300, 44);
INSERT INTO public.who_global_data VALUES (71076, 0, 2, 0, 0, 300, 15);
INSERT INTO public.who_global_data VALUES (71077, 0, 73, 0, 3, 300, 25);
INSERT INTO public.who_global_data VALUES (71078, 0, 0, 0, 0, 300, 179);
INSERT INTO public.who_global_data VALUES (71079, 0, 0, 0, 0, 300, 34);
INSERT INTO public.who_global_data VALUES (71080, 0, 109, 0, 8, 300, 207);
INSERT INTO public.who_global_data VALUES (71081, 14, 685, 3, 28, 300, 166);
INSERT INTO public.who_global_data VALUES (71082, 5138, 52167, 95, 1101, 300, 126);
INSERT INTO public.who_global_data VALUES (71083, 0, 0, 0, 0, 300, 97);
INSERT INTO public.who_global_data VALUES (71084, 0, 8, 0, 1, 300, 36);
INSERT INTO public.who_global_data VALUES (71085, 0, 0, 0, 0, 300, 125);
INSERT INTO public.who_global_data VALUES (71086, 0, 53, 0, 0, 300, 124);
INSERT INTO public.who_global_data VALUES (71087, 266, 2777, 10, 83, 300, 185);
INSERT INTO public.who_global_data VALUES (71088, 0, 3736, 0, 20, 300, 194);
INSERT INTO public.who_global_data VALUES (71089, 0, 32, 0, 3, 300, 144);
INSERT INTO public.who_global_data VALUES (71090, 31606, 492881, 1920, 18516, 300, 19);
INSERT INTO public.who_global_data VALUES (71091, 0, 51, 0, 1, 300, 217);
INSERT INTO public.who_global_data VALUES (71092, 12, 465, 0, 7, 300, 148);
INSERT INTO public.who_global_data VALUES (71093, 172, 796, 0, 3, 300, 86);
INSERT INTO public.who_global_data VALUES (71094, 0, 0, 0, 0, 300, 13);
INSERT INTO public.who_global_data VALUES (71095, 0, 171, 0, 9, 300, 157);
INSERT INTO public.who_global_data VALUES (71096, 1, 258, 0, 0, 300, 8);
INSERT INTO public.who_global_data VALUES (71097, 0, 0, 0, 0, 300, 73);
INSERT INTO public.who_global_data VALUES (71098, 0, 1, 0, 0, 300, 101);
INSERT INTO public.who_global_data VALUES (71099, 0, 40, 0, 2, 300, 165);
INSERT INTO public.who_global_data VALUES (71100, 2, 13, 0, 3, 300, 14);
INSERT INTO public.who_global_data VALUES (71101, 0, 521, 0, 15, 301, 193);
INSERT INTO public.who_global_data VALUES (71102, 0, 378, 0, 22, 301, 113);
INSERT INTO public.who_global_data VALUES (71103, 95, 1761, 21, 256, 301, 143);
INSERT INTO public.who_global_data VALUES (71104, 0, 0, 0, 0, 301, 219);
INSERT INTO public.who_global_data VALUES (71105, 13, 602, 0, 26, 301, 186);
INSERT INTO public.who_global_data VALUES (71106, 0, 19, 0, 2, 301, 52);
INSERT INTO public.who_global_data VALUES (71107, 0, 3, 0, 0, 301, 180);
INSERT INTO public.who_global_data VALUES (71108, 0, 19, 0, 2, 301, 167);
INSERT INTO public.who_global_data VALUES (71109, 134, 1929, 12, 79, 301, 154);
INSERT INTO public.who_global_data VALUES (71110, 16, 913, 1, 11, 301, 94);
INSERT INTO public.who_global_data VALUES (71111, 4, 86, 0, 0, 301, 66);
INSERT INTO public.who_global_data VALUES (71112, 137, 6289, 4, 56, 301, 58);
INSERT INTO public.who_global_data VALUES (71113, 312, 13560, 24, 319, 301, 163);
INSERT INTO public.who_global_data VALUES (71114, 65, 991, 1, 10, 301, 37);
INSERT INTO public.who_global_data VALUES (71115, 1, 41, 1, 8, 301, 142);
INSERT INTO public.who_global_data VALUES (71116, 103, 1016, 0, 6, 301, 83);
INSERT INTO public.who_global_data VALUES (71117, 58, 482, 3, 30, 301, 228);
INSERT INTO public.who_global_data VALUES (71118, 3, 66, 1, 4, 301, 188);
INSERT INTO public.who_global_data VALUES (71119, 915, 1981, 6, 19, 301, 62);
INSERT INTO public.who_global_data VALUES (71120, 2336, 32974, 302, 4016, 301, 160);
INSERT INTO public.who_global_data VALUES (71121, 1, 10, 0, 1, 301, 50);
INSERT INTO public.who_global_data VALUES (71122, 0, 30, 0, 1, 301, 33);
INSERT INTO public.who_global_data VALUES (71123, 9, 48, 1, 4, 301, 183);
INSERT INTO public.who_global_data VALUES (71124, 0, 5, 0, 0, 301, 92);
INSERT INTO public.who_global_data VALUES (71125, 4, 268, 1, 19, 301, 158);
INSERT INTO public.who_global_data VALUES (71126, 0, 0, 0, 0, 301, 67);
INSERT INTO public.who_global_data VALUES (71127, 26, 901, 1, 37, 301, 57);
INSERT INTO public.who_global_data VALUES (71128, 0, 13, 0, 1, 301, 38);
INSERT INTO public.who_global_data VALUES (71129, 1930, 17857, 141, 941, 301, 141);
INSERT INTO public.who_global_data VALUES (71130, 0, 3, 0, 0, 301, 178);
INSERT INTO public.who_global_data VALUES (71131, 1, 136, 0, 1, 301, 108);
INSERT INTO public.who_global_data VALUES (71132, 11, 635, 1, 25, 301, 39);
INSERT INTO public.who_global_data VALUES (71133, 29, 443, 0, 19, 301, 2);
INSERT INTO public.who_global_data VALUES (71134, 0, 3, 0, 0, 301, 195);
INSERT INTO public.who_global_data VALUES (71135, 0, 7, 0, 1, 301, 107);
INSERT INTO public.who_global_data VALUES (71136, 2, 120, 0, 0, 301, 161);
INSERT INTO public.who_global_data VALUES (71137, 73, 803, 0, 10, 301, 212);
INSERT INTO public.who_global_data VALUES (71138, 1467, 21226, 70, 531, 301, 181);
INSERT INTO public.who_global_data VALUES (71139, 0, 45, 0, 1, 301, 53);
INSERT INTO public.who_global_data VALUES (71140, 1, 11, 0, 0, 301, 164);
INSERT INTO public.who_global_data VALUES (71141, 0, 11, 0, 0, 301, 140);
INSERT INTO public.who_global_data VALUES (71142, 529, 6501, 8, 65, 301, 20);
INSERT INTO public.who_global_data VALUES (71143, 78, 83383, 4, 3349, 301, 112);
INSERT INTO public.who_global_data VALUES (71144, 169, 2223, 14, 69, 301, 111);
INSERT INTO public.who_global_data VALUES (71145, 0, 0, 0, 0, 301, 71);
INSERT INTO public.who_global_data VALUES (71146, 0, 60, 0, 5, 301, 218);
INSERT INTO public.who_global_data VALUES (71147, 0, 0, 0, 0, 301, 43);
INSERT INTO public.who_global_data VALUES (71148, 37, 539, 0, 3, 301, 49);
INSERT INTO public.who_global_data VALUES (71149, 96, 480, 0, 3, 301, 1);
INSERT INTO public.who_global_data VALUES (71150, 88, 1495, 1, 21, 301, 48);
INSERT INTO public.who_global_data VALUES (71151, 49, 564, 0, 15, 301, 232);
INSERT INTO public.who_global_data VALUES (71152, 0, 14, 0, 1, 301, 175);
INSERT INTO public.who_global_data VALUES (71153, 31, 595, 0, 10, 301, 21);
INSERT INTO public.who_global_data VALUES (71154, 163, 5732, 7, 119, 301, 156);
INSERT INTO public.who_global_data VALUES (71155, 0, 0, 0, 0, 301, 95);
INSERT INTO public.who_global_data VALUES (71156, 0, 215, 0, 20, 301, 177);
INSERT INTO public.who_global_data VALUES (71157, 184, 5819, 10, 247, 301, 210);
INSERT INTO public.who_global_data VALUES (71158, 37, 187, 1, 2, 301, 120);
INSERT INTO public.who_global_data VALUES (71159, 1, 16, 0, 0, 301, 135);
INSERT INTO public.who_global_data VALUES (71160, 0, 2349, 0, 118, 301, 206);
INSERT INTO public.who_global_data VALUES (71161, 2196, 7161, 25, 297, 301, 189);
INSERT INTO public.who_global_data VALUES (71162, 95, 1794, 17, 135, 301, 129);
INSERT INTO public.who_global_data VALUES (71163, 14, 117, 1, 6, 301, 121);
INSERT INTO public.who_global_data VALUES (71164, 0, 18, 0, 0, 301, 59);
INSERT INTO public.who_global_data VALUES (71165, 0, 33, 0, 0, 301, 96);
INSERT INTO public.who_global_data VALUES (71166, 51, 1258, 0, 24, 301, 41);
INSERT INTO public.who_global_data VALUES (71167, 0, 12, 0, 0, 301, 216);
INSERT INTO public.who_global_data VALUES (71168, 9, 65, 0, 2, 301, 236);
INSERT INTO public.who_global_data VALUES (71169, 0, 5, 0, 0, 301, 150);
INSERT INTO public.who_global_data VALUES (71170, 0, 184, 0, 0, 301, 61);
INSERT INTO public.who_global_data VALUES (71171, 1, 16, 0, 0, 301, 7);
INSERT INTO public.who_global_data VALUES (71172, 164, 2769, 6, 48, 301, 169);
INSERT INTO public.who_global_data VALUES (71173, 4333, 89683, 987, 13179, 301, 28);
INSERT INTO public.who_global_data VALUES (71174, 1, 84, 0, 0, 301, 85);
INSERT INTO public.who_global_data VALUES (71175, 0, 51, 0, 0, 301, 211);
INSERT INTO public.who_global_data VALUES (71176, 0, 44, 0, 1, 301, 60);
INSERT INTO public.who_global_data VALUES (71177, 0, 4, 0, 1, 301, 3);
INSERT INTO public.who_global_data VALUES (71178, 3, 233, 0, 3, 301, 11);
INSERT INTO public.who_global_data VALUES (71179, 4133, 117658, 171, 2544, 301, 89);
INSERT INTO public.who_global_data VALUES (71180, 65, 378, 0, 6, 301, 24);
INSERT INTO public.who_global_data VALUES (71181, 0, 113, 0, 0, 301, 162);
INSERT INTO public.who_global_data VALUES (71182, 56, 2011, 4, 90, 301, 100);
INSERT INTO public.who_global_data VALUES (71183, 0, 11, 0, 0, 301, 47);
INSERT INTO public.who_global_data VALUES (71184, 0, 12, 0, 0, 301, 29);
INSERT INTO public.who_global_data VALUES (71185, 2, 143, 0, 8, 301, 40);
INSERT INTO public.who_global_data VALUES (71186, 2, 130, 0, 4, 301, 222);
INSERT INTO public.who_global_data VALUES (71187, 31, 126, 0, 3, 301, 132);
INSERT INTO public.who_global_data VALUES (71188, 10, 191, 0, 5, 301, 130);
INSERT INTO public.who_global_data VALUES (71189, 0, 194, 0, 0, 301, 234);
INSERT INTO public.who_global_data VALUES (71190, 0, 35, 0, 0, 301, 23);
INSERT INTO public.who_global_data VALUES (71191, 0, 37, 0, 6, 301, 192);
INSERT INTO public.who_global_data VALUES (71192, 0, 30, 0, 2, 301, 69);
INSERT INTO public.who_global_data VALUES (71193, 0, 8, 0, 0, 301, 187);
INSERT INTO public.who_global_data VALUES (71194, 39, 382, 0, 23, 301, 230);
INSERT INTO public.who_global_data VALUES (71195, 120, 1310, 8, 85, 301, 77);
INSERT INTO public.who_global_data VALUES (71196, 27, 1675, 1, 7, 301, 9);
INSERT INTO public.who_global_data VALUES (71197, 1035, 7447, 40, 239, 301, 74);
INSERT INTO public.who_global_data VALUES (71198, 330, 3842, 21, 327, 301, 224);
INSERT INTO public.who_global_data VALUES (71199, 1837, 70029, 125, 4357, 301, 199);
INSERT INTO public.who_global_data VALUES (71200, 39, 1318, 2, 72, 301, 190);
INSERT INTO public.who_global_data VALUES (71201, 696, 8089, 24, 287, 301, 12);
INSERT INTO public.who_global_data VALUES (71202, 25, 190, 0, 1, 301, 104);
INSERT INTO public.who_global_data VALUES (71203, 343, 10254, 9, 89, 301, 153);
INSERT INTO public.who_global_data VALUES (71204, 3951, 147577, 570, 18851, 301, 91);
INSERT INTO public.who_global_data VALUES (71205, 0, 63, 0, 4, 301, 215);
INSERT INTO public.who_global_data VALUES (71206, 658, 6005, 6, 94, 301, 84);
INSERT INTO public.who_global_data VALUES (71207, 13, 183, 1, 4, 301, 231);
INSERT INTO public.who_global_data VALUES (71208, 0, 372, 0, 7, 301, 196);
INSERT INTO public.who_global_data VALUES (71209, 38, 897, 0, 10, 301, 105);
INSERT INTO public.who_global_data VALUES (71210, 5, 189, 0, 7, 301, 122);
INSERT INTO public.who_global_data VALUES (71211, 0, 0, 0, 0, 301, 159);
INSERT INTO public.who_global_data VALUES (71212, 23, 250, 0, 7, 301, 75);
INSERT INTO public.who_global_data VALUES (71213, 161, 1154, 0, 1, 301, 27);
INSERT INTO public.who_global_data VALUES (71214, 41, 339, 0, 5, 301, 54);
INSERT INTO public.who_global_data VALUES (71215, 0, 16, 0, 0, 301, 226);
INSERT INTO public.who_global_data VALUES (71216, 23, 612, 0, 2, 301, 79);
INSERT INTO public.who_global_data VALUES (71217, 10, 619, 0, 20, 301, 56);
INSERT INTO public.who_global_data VALUES (71218, 0, 0, 0, 0, 301, 117);
INSERT INTO public.who_global_data VALUES (71219, 6, 37, 1, 5, 301, 152);
INSERT INTO public.who_global_data VALUES (71220, 0, 24, 0, 1, 301, 16);
INSERT INTO public.who_global_data VALUES (71221, 0, 80, 0, 1, 301, 10);
INSERT INTO public.who_global_data VALUES (71222, 30, 926, 2, 24, 301, 201);
INSERT INTO public.who_global_data VALUES (71223, 108, 3223, 2, 54, 301, 174);
INSERT INTO public.who_global_data VALUES (71224, 0, 95, 0, 0, 301, 119);
INSERT INTO public.who_global_data VALUES (71225, 1, 9, 0, 1, 301, 168);
INSERT INTO public.who_global_data VALUES (71226, 118, 4346, 3, 70, 301, 99);
INSERT INTO public.who_global_data VALUES (71227, 0, 19, 0, 0, 301, 171);
INSERT INTO public.who_global_data VALUES (71228, 15, 74, 0, 7, 301, 87);
INSERT INTO public.who_global_data VALUES (71229, 20, 370, 0, 2, 301, 123);
INSERT INTO public.who_global_data VALUES (71230, 0, 0, 0, 0, 301, 151);
INSERT INTO public.who_global_data VALUES (71231, 0, 154, 0, 6, 301, 213);
INSERT INTO public.who_global_data VALUES (71232, 1, 7, 0, 1, 301, 118);
INSERT INTO public.who_global_data VALUES (71233, 4, 318, 2, 9, 301, 134);
INSERT INTO public.who_global_data VALUES (71234, 0, 191, 0, 2, 301, 65);
INSERT INTO public.who_global_data VALUES (71235, 260, 3441, 20, 194, 301, 102);
INSERT INTO public.who_global_data VALUES (71236, 0, 0, 0, 0, 301, 223);
INSERT INTO public.who_global_data VALUES (71237, 6, 63, 0, 1, 301, 4);
INSERT INTO public.who_global_data VALUES (71238, 0, 16, 0, 0, 301, 146);
INSERT INTO public.who_global_data VALUES (71239, 5, 267, 0, 2, 301, 31);
INSERT INTO public.who_global_data VALUES (71240, 1, 9, 0, 0, 301, 127);
INSERT INTO public.who_global_data VALUES (71241, 96, 1527, 5, 110, 301, 22);
INSERT INTO public.who_global_data VALUES (71242, 3, 20, 0, 0, 301, 115);
INSERT INTO public.who_global_data VALUES (71243, 1, 28, 0, 3, 301, 106);
INSERT INTO public.who_global_data VALUES (71244, 0, 16, 0, 0, 301, 90);
INSERT INTO public.who_global_data VALUES (71245, 0, 0, 0, 0, 301, 70);
INSERT INTO public.who_global_data VALUES (71246, 0, 9, 0, 0, 301, 46);
INSERT INTO public.who_global_data VALUES (71247, 1327, 22886, 119, 2468, 301, 139);
INSERT INTO public.who_global_data VALUES (71248, 0, 18, 0, 0, 301, 42);
INSERT INTO public.who_global_data VALUES (71249, 20, 1035, 3, 4, 301, 80);
INSERT INTO public.who_global_data VALUES (71250, 1, 7, 0, 1, 301, 203);
INSERT INTO public.who_global_data VALUES (71251, 28, 438, 0, 11, 301, 136);
INSERT INTO public.who_global_data VALUES (71252, 17, 305, 0, 7, 301, 63);
INSERT INTO public.who_global_data VALUES (71253, 0, 0, 0, 0, 301, 17);
INSERT INTO public.who_global_data VALUES (71254, 0, 11, 0, 2, 301, 172);
INSERT INTO public.who_global_data VALUES (71255, 48, 711, 2, 32, 301, 109);
INSERT INTO public.who_global_data VALUES (71256, 84, 6244, 4, 92, 301, 200);
INSERT INTO public.who_global_data VALUES (71257, 2, 268, 0, 2, 301, 93);
INSERT INTO public.who_global_data VALUES (71258, 62, 546, 0, 3, 301, 5);
INSERT INTO public.who_global_data VALUES (71259, 0, 712, 0, 11, 301, 214);
INSERT INTO public.who_global_data VALUES (71260, 275, 4970, 11, 77, 301, 204);
INSERT INTO public.who_global_data VALUES (71261, 0, 0, 0, 0, 301, 198);
INSERT INTO public.who_global_data VALUES (71262, 224, 2752, 3, 66, 301, 173);
INSERT INTO public.who_global_data VALUES (71263, 0, 2, 0, 0, 301, 229);
INSERT INTO public.who_global_data VALUES (71264, 5, 129, 1, 6, 301, 76);
INSERT INTO public.who_global_data VALUES (71265, 914, 5256, 17, 138, 301, 138);
INSERT INTO public.who_global_data VALUES (71266, 352, 4428, 44, 247, 301, 98);
INSERT INTO public.who_global_data VALUES (71267, 0, 0, 0, 0, 301, 103);
INSERT INTO public.who_global_data VALUES (71268, 380, 5955, 7, 181, 301, 225);
INSERT INTO public.who_global_data VALUES (71269, 1516, 15472, 26, 435, 301, 131);
INSERT INTO public.who_global_data VALUES (71270, 42, 725, 6, 39, 301, 235);
INSERT INTO public.who_global_data VALUES (71271, 216, 2728, 0, 6, 301, 137);
INSERT INTO public.who_global_data VALUES (71272, 30, 10480, 3, 211, 301, 81);
INSERT INTO public.who_global_data VALUES (71273, 149, 1438, 0, 29, 301, 182);
INSERT INTO public.who_global_data VALUES (71274, 6, 382, 0, 0, 301, 145);
INSERT INTO public.who_global_data VALUES (71275, 265, 5467, 28, 257, 301, 26);
INSERT INTO public.who_global_data VALUES (71276, 1667, 13584, 12, 106, 301, 170);
INSERT INTO public.who_global_data VALUES (71277, 5, 118, 0, 0, 301, 191);
INSERT INTO public.who_global_data VALUES (71278, 1, 1, 0, 0, 301, 221);
INSERT INTO public.who_global_data VALUES (71279, 0, 6, 0, 0, 301, 64);
INSERT INTO public.who_global_data VALUES (71280, 0, 0, 0, 0, 301, 116);
INSERT INTO public.who_global_data VALUES (71281, 0, 11, 0, 0, 301, 128);
INSERT INTO public.who_global_data VALUES (71282, 0, 14, 0, 0, 301, 6);
INSERT INTO public.who_global_data VALUES (71283, 0, 32, 0, 2, 301, 227);
INSERT INTO public.who_global_data VALUES (71284, 0, 1, 0, 0, 301, 68);
INSERT INTO public.who_global_data VALUES (71285, 4, 12, 0, 0, 301, 184);
INSERT INTO public.who_global_data VALUES (71286, 0, 0, 0, 0, 301, 82);
INSERT INTO public.who_global_data VALUES (71287, 0, 344, 0, 34, 301, 149);
INSERT INTO public.who_global_data VALUES (71288, 0, 4, 0, 0, 301, 197);
INSERT INTO public.who_global_data VALUES (71289, 382, 4033, 5, 52, 301, 78);
INSERT INTO public.who_global_data VALUES (71290, 15, 265, 0, 2, 301, 233);
INSERT INTO public.who_global_data VALUES (71291, 238, 3105, 6, 71, 301, 133);
INSERT INTO public.who_global_data VALUES (71292, 0, 11, 0, 0, 301, 35);
INSERT INTO public.who_global_data VALUES (71293, 0, 7, 0, 0, 301, 114);
INSERT INTO public.who_global_data VALUES (71294, 198, 2108, 0, 7, 301, 237);
INSERT INTO public.who_global_data VALUES (71295, 0, 2, 0, 0, 301, 55);
INSERT INTO public.who_global_data VALUES (71296, 7, 50, 1, 9, 301, 176);
INSERT INTO public.who_global_data VALUES (71297, 14, 715, 0, 2, 301, 202);
INSERT INTO public.who_global_data VALUES (71298, 29, 1189, 6, 54, 301, 155);
INSERT INTO public.who_global_data VALUES (71299, 0, 0, 0, 0, 301, 32);
INSERT INTO public.who_global_data VALUES (71300, 9, 21, 0, 1, 301, 220);
INSERT INTO public.who_global_data VALUES (71301, 69, 2003, 6, 24, 301, 30);
INSERT INTO public.who_global_data VALUES (71302, 0, 3, 0, 0, 301, 147);
INSERT INTO public.who_global_data VALUES (71303, 4610, 173773, 667, 17337, 301, 208);
INSERT INTO public.who_global_data VALUES (71304, 7, 197, 0, 7, 301, 45);
INSERT INTO public.who_global_data VALUES (71305, 4, 19, 0, 2, 301, 110);
INSERT INTO public.who_global_data VALUES (71306, 0, 10, 0, 1, 301, 88);
INSERT INTO public.who_global_data VALUES (71307, 645, 9599, 86, 1104, 301, 51);
INSERT INTO public.who_global_data VALUES (71308, 309, 25743, 52, 1022, 301, 209);
INSERT INTO public.who_global_data VALUES (71309, 6, 25, 0, 2, 301, 205);
INSERT INTO public.who_global_data VALUES (71310, 0, 0, 0, 0, 301, 18);
INSERT INTO public.who_global_data VALUES (71311, 45, 2518, 2, 35, 301, 72);
INSERT INTO public.who_global_data VALUES (71312, 4858, 81493, 1122, 10813, 301, 44);
INSERT INTO public.who_global_data VALUES (71313, 1, 2, 0, 0, 301, 15);
INSERT INTO public.who_global_data VALUES (71314, 0, 73, 0, 3, 301, 25);
INSERT INTO public.who_global_data VALUES (71315, 0, 0, 0, 0, 301, 179);
INSERT INTO public.who_global_data VALUES (71316, 0, 0, 0, 0, 301, 34);
INSERT INTO public.who_global_data VALUES (71317, 0, 109, 0, 8, 301, 207);
INSERT INTO public.who_global_data VALUES (71318, 28, 671, 0, 25, 301, 166);
INSERT INTO public.who_global_data VALUES (71319, 4747, 47029, 98, 1006, 301, 126);
INSERT INTO public.who_global_data VALUES (71320, 0, 0, 0, 0, 301, 97);
INSERT INTO public.who_global_data VALUES (71321, 0, 8, 0, 1, 301, 36);
INSERT INTO public.who_global_data VALUES (71322, 0, 0, 0, 0, 301, 125);
INSERT INTO public.who_global_data VALUES (71323, 0, 53, 0, 0, 301, 124);
INSERT INTO public.who_global_data VALUES (71324, 308, 2511, 4, 73, 301, 185);
INSERT INTO public.who_global_data VALUES (71325, 746, 3736, 6, 20, 301, 194);
INSERT INTO public.who_global_data VALUES (71326, 7, 32, 2, 3, 301, 144);
INSERT INTO public.who_global_data VALUES (71327, 35386, 461275, 1931, 16596, 301, 19);
INSERT INTO public.who_global_data VALUES (71328, 5, 51, 0, 1, 301, 217);
INSERT INTO public.who_global_data VALUES (71329, 7, 453, 0, 7, 301, 148);
INSERT INTO public.who_global_data VALUES (71330, 0, 624, 0, 3, 301, 86);
INSERT INTO public.who_global_data VALUES (71331, 0, 0, 0, 0, 301, 13);
INSERT INTO public.who_global_data VALUES (71332, 5, 171, 2, 9, 301, 157);
INSERT INTO public.who_global_data VALUES (71333, 2, 257, 0, 0, 301, 8);
INSERT INTO public.who_global_data VALUES (71334, 0, 0, 0, 0, 301, 73);
INSERT INTO public.who_global_data VALUES (71335, 0, 1, 0, 0, 301, 101);
INSERT INTO public.who_global_data VALUES (71336, 1, 40, 1, 2, 301, 165);
INSERT INTO public.who_global_data VALUES (71337, 0, 11, 0, 3, 301, 14);
INSERT INTO public.who_global_data VALUES (71338, 37, 521, 0, 15, 302, 193);
INSERT INTO public.who_global_data VALUES (71339, 7, 378, 1, 22, 302, 113);
INSERT INTO public.who_global_data VALUES (71340, 94, 1666, 30, 235, 302, 143);
INSERT INTO public.who_global_data VALUES (71341, 0, 0, 0, 0, 302, 219);
INSERT INTO public.who_global_data VALUES (71342, 23, 589, 2, 26, 302, 186);
INSERT INTO public.who_global_data VALUES (71343, 0, 19, 0, 2, 302, 52);
INSERT INTO public.who_global_data VALUES (71344, 0, 3, 0, 0, 302, 180);
INSERT INTO public.who_global_data VALUES (71345, 0, 19, 0, 2, 302, 167);
INSERT INTO public.who_global_data VALUES (71346, 80, 1795, 7, 67, 302, 154);
INSERT INTO public.who_global_data VALUES (71347, 40, 897, 1, 10, 302, 94);
INSERT INTO public.who_global_data VALUES (71348, 8, 82, 0, 0, 302, 66);
INSERT INTO public.who_global_data VALUES (71349, 100, 6152, 2, 52, 302, 58);
INSERT INTO public.who_global_data VALUES (71350, 279, 13248, 22, 295, 302, 163);
INSERT INTO public.who_global_data VALUES (71351, 104, 926, 1, 9, 302, 37);
INSERT INTO public.who_global_data VALUES (71352, 4, 40, 1, 7, 302, 142);
INSERT INTO public.who_global_data VALUES (71353, 58, 913, 1, 6, 302, 83);
INSERT INTO public.who_global_data VALUES (71354, 94, 424, 6, 27, 302, 228);
INSERT INTO public.who_global_data VALUES (71355, 0, 63, 0, 3, 302, 188);
INSERT INTO public.who_global_data VALUES (71356, 0, 1066, 0, 13, 302, 62);
INSERT INTO public.who_global_data VALUES (71357, 2239, 30638, 272, 3714, 302, 160);
INSERT INTO public.who_global_data VALUES (71358, 1, 9, 0, 1, 302, 50);
INSERT INTO public.who_global_data VALUES (71359, 4, 30, 0, 1, 302, 33);
INSERT INTO public.who_global_data VALUES (71360, 0, 39, 1, 3, 302, 183);
INSERT INTO public.who_global_data VALUES (71361, 0, 5, 0, 0, 302, 92);
INSERT INTO public.who_global_data VALUES (71362, 54, 264, 3, 18, 302, 158);
INSERT INTO public.who_global_data VALUES (71363, 0, 0, 0, 0, 302, 67);
INSERT INTO public.who_global_data VALUES (71364, 59, 875, 1, 36, 302, 57);
INSERT INTO public.who_global_data VALUES (71365, 7, 13, 0, 1, 302, 38);
INSERT INTO public.who_global_data VALUES (71366, 2210, 15927, 133, 800, 302, 141);
INSERT INTO public.who_global_data VALUES (71367, 0, 3, 0, 0, 302, 178);
INSERT INTO public.who_global_data VALUES (71368, 0, 135, 0, 1, 302, 108);
INSERT INTO public.who_global_data VALUES (71369, 31, 624, 0, 24, 302, 39);
INSERT INTO public.who_global_data VALUES (71370, 30, 414, 0, 19, 302, 2);
INSERT INTO public.who_global_data VALUES (71371, 0, 3, 0, 0, 302, 195);
INSERT INTO public.who_global_data VALUES (71372, 0, 7, 0, 1, 302, 107);
INSERT INTO public.who_global_data VALUES (71373, 1, 118, 0, 0, 302, 161);
INSERT INTO public.who_global_data VALUES (71374, 0, 730, 0, 10, 302, 212);
INSERT INTO public.who_global_data VALUES (71375, 1326, 19759, 60, 461, 302, 181);
INSERT INTO public.who_global_data VALUES (71376, 0, 45, 0, 1, 302, 53);
INSERT INTO public.who_global_data VALUES (71377, 0, 10, 0, 0, 302, 164);
INSERT INTO public.who_global_data VALUES (71378, 1, 11, 0, 0, 302, 140);
INSERT INTO public.who_global_data VALUES (71379, 426, 5972, 9, 57, 302, 20);
INSERT INTO public.who_global_data VALUES (71380, 56, 83305, 1, 3345, 302, 112);
INSERT INTO public.who_global_data VALUES (71381, 274, 2054, 5, 55, 302, 111);
INSERT INTO public.who_global_data VALUES (71382, 0, 0, 0, 0, 302, 71);
INSERT INTO public.who_global_data VALUES (71383, 0, 60, 0, 5, 302, 218);
INSERT INTO public.who_global_data VALUES (71384, 0, 0, 0, 0, 302, 43);
INSERT INTO public.who_global_data VALUES (71385, 19, 502, 1, 3, 302, 49);
INSERT INTO public.who_global_data VALUES (71386, 0, 384, 0, 3, 302, 1);
INSERT INTO public.who_global_data VALUES (71387, 64, 1407, 1, 20, 302, 48);
INSERT INTO public.who_global_data VALUES (71388, 58, 515, 3, 15, 302, 232);
INSERT INTO public.who_global_data VALUES (71389, 0, 14, 0, 1, 302, 175);
INSERT INTO public.who_global_data VALUES (71390, 38, 564, 1, 10, 302, 21);
INSERT INTO public.who_global_data VALUES (71391, 257, 5569, 13, 112, 302, 156);
INSERT INTO public.who_global_data VALUES (71392, 0, 0, 0, 0, 302, 95);
INSERT INTO public.who_global_data VALUES (71393, 8, 215, 0, 20, 302, 177);
INSERT INTO public.who_global_data VALUES (71394, 233, 5635, 19, 237, 302, 210);
INSERT INTO public.who_global_data VALUES (71395, 10, 150, 0, 1, 302, 120);
INSERT INTO public.who_global_data VALUES (71396, 0, 15, 0, 0, 302, 135);
INSERT INTO public.who_global_data VALUES (71397, 393, 2349, 20, 118, 302, 206);
INSERT INTO public.who_global_data VALUES (71398, 515, 4965, 30, 272, 302, 189);
INSERT INTO public.who_global_data VALUES (71399, 139, 1699, 15, 118, 302, 129);
INSERT INTO public.who_global_data VALUES (71400, 10, 103, 0, 5, 302, 121);
INSERT INTO public.who_global_data VALUES (71401, 2, 18, 0, 0, 302, 59);
INSERT INTO public.who_global_data VALUES (71402, 0, 33, 0, 0, 302, 96);
INSERT INTO public.who_global_data VALUES (71403, 22, 1207, 0, 24, 302, 41);
INSERT INTO public.who_global_data VALUES (71404, 0, 12, 0, 0, 302, 216);
INSERT INTO public.who_global_data VALUES (71405, 1, 56, 0, 2, 302, 236);
INSERT INTO public.who_global_data VALUES (71406, 0, 5, 0, 0, 302, 150);
INSERT INTO public.who_global_data VALUES (71407, 0, 184, 0, 0, 302, 61);
INSERT INTO public.who_global_data VALUES (71408, 0, 15, 0, 0, 302, 7);
INSERT INTO public.who_global_data VALUES (71409, 118, 2605, 2, 42, 302, 169);
INSERT INTO public.who_global_data VALUES (71410, 4256, 85350, 1339, 12192, 302, 28);
INSERT INTO public.who_global_data VALUES (71411, 6, 83, 0, 0, 302, 85);
INSERT INTO public.who_global_data VALUES (71412, 0, 51, 0, 0, 302, 211);
INSERT INTO public.who_global_data VALUES (71413, 20, 44, 0, 1, 302, 60);
INSERT INTO public.who_global_data VALUES (71414, 0, 4, 0, 1, 302, 3);
INSERT INTO public.who_global_data VALUES (71415, 16, 230, 0, 3, 302, 11);
INSERT INTO public.who_global_data VALUES (71416, 5323, 113525, 266, 2373, 302, 89);
INSERT INTO public.who_global_data VALUES (71417, 0, 313, 0, 6, 302, 24);
INSERT INTO public.who_global_data VALUES (71418, 0, 113, 0, 0, 302, 162);
INSERT INTO public.who_global_data VALUES (71419, 71, 1955, 3, 86, 302, 100);
INSERT INTO public.who_global_data VALUES (71420, 0, 11, 0, 0, 302, 47);
INSERT INTO public.who_global_data VALUES (71421, 0, 12, 0, 0, 302, 29);
INSERT INTO public.who_global_data VALUES (71422, 2, 141, 0, 8, 302, 40);
INSERT INTO public.who_global_data VALUES (71423, 3, 128, 0, 4, 302, 222);
INSERT INTO public.who_global_data VALUES (71424, 8, 95, 0, 3, 302, 132);
INSERT INTO public.who_global_data VALUES (71425, 15, 181, 1, 5, 302, 130);
INSERT INTO public.who_global_data VALUES (71426, 30, 194, 0, 0, 302, 234);
INSERT INTO public.who_global_data VALUES (71427, 2, 35, 0, 0, 302, 23);
INSERT INTO public.who_global_data VALUES (71428, 4, 37, 1, 6, 302, 192);
INSERT INTO public.who_global_data VALUES (71429, 3, 30, 1, 2, 302, 69);
INSERT INTO public.who_global_data VALUES (71430, 0, 8, 0, 0, 302, 187);
INSERT INTO public.who_global_data VALUES (71431, 31, 343, 1, 23, 302, 230);
INSERT INTO public.who_global_data VALUES (71432, 210, 1190, 11, 77, 302, 77);
INSERT INTO public.who_global_data VALUES (71433, 32, 1648, 0, 6, 302, 9);
INSERT INTO public.who_global_data VALUES (71434, 547, 6412, 30, 199, 302, 74);
INSERT INTO public.who_global_data VALUES (71435, 219, 3512, 26, 306, 302, 224);
INSERT INTO public.who_global_data VALUES (71436, 1972, 68192, 122, 4232, 302, 199);
INSERT INTO public.who_global_data VALUES (71437, 77, 1279, 1, 70, 302, 190);
INSERT INTO public.who_global_data VALUES (71438, 1169, 7393, 28, 263, 302, 12);
INSERT INTO public.who_global_data VALUES (71439, 15, 165, 0, 1, 302, 104);
INSERT INTO public.who_global_data VALUES (71440, 338, 9911, 8, 80, 302, 153);
INSERT INTO public.who_global_data VALUES (71441, 4204, 143626, 612, 18281, 302, 91);
INSERT INTO public.who_global_data VALUES (71442, 0, 63, 1, 4, 302, 215);
INSERT INTO public.who_global_data VALUES (71443, 579, 5347, 3, 88, 302, 84);
INSERT INTO public.who_global_data VALUES (71444, 0, 170, 0, 3, 302, 231);
INSERT INTO public.who_global_data VALUES (71445, 14, 372, 1, 7, 302, 196);
INSERT INTO public.who_global_data VALUES (71446, 57, 859, 1, 10, 302, 105);
INSERT INTO public.who_global_data VALUES (71447, 5, 184, 1, 7, 302, 122);
INSERT INTO public.who_global_data VALUES (71448, 0, 0, 0, 0, 302, 159);
INSERT INTO public.who_global_data VALUES (71449, 3, 227, 0, 7, 302, 75);
INSERT INTO public.who_global_data VALUES (71450, 83, 993, 0, 1, 302, 27);
INSERT INTO public.who_global_data VALUES (71451, 18, 298, 1, 5, 302, 54);
INSERT INTO public.who_global_data VALUES (71452, 1, 16, 0, 0, 302, 226);
INSERT INTO public.who_global_data VALUES (71453, 12, 589, 0, 2, 302, 79);
INSERT INTO public.who_global_data VALUES (71454, 27, 609, 1, 20, 302, 56);
INSERT INTO public.who_global_data VALUES (71455, 0, 0, 0, 0, 302, 117);
INSERT INTO public.who_global_data VALUES (71456, 0, 31, 0, 4, 302, 152);
INSERT INTO public.who_global_data VALUES (71457, 3, 24, 0, 1, 302, 16);
INSERT INTO public.who_global_data VALUES (71458, 0, 80, 0, 1, 302, 10);
INSERT INTO public.who_global_data VALUES (71459, 38, 896, 1, 22, 302, 201);
INSERT INTO public.who_global_data VALUES (71460, 81, 3115, 6, 52, 302, 174);
INSERT INTO public.who_global_data VALUES (71461, 2, 95, 0, 0, 302, 119);
INSERT INTO public.who_global_data VALUES (71462, 0, 8, 0, 1, 302, 168);
INSERT INTO public.who_global_data VALUES (71463, 109, 4228, 2, 67, 302, 99);
INSERT INTO public.who_global_data VALUES (71464, 0, 19, 0, 0, 302, 171);
INSERT INTO public.who_global_data VALUES (71465, 3, 59, 1, 7, 302, 87);
INSERT INTO public.who_global_data VALUES (71466, 13, 350, 1, 2, 302, 123);
INSERT INTO public.who_global_data VALUES (71467, 0, 0, 0, 0, 302, 151);
INSERT INTO public.who_global_data VALUES (71468, 2, 154, 2, 6, 302, 213);
INSERT INTO public.who_global_data VALUES (71469, 0, 6, 0, 1, 302, 118);
INSERT INTO public.who_global_data VALUES (71470, 41, 314, 0, 7, 302, 134);
INSERT INTO public.who_global_data VALUES (71471, 5, 191, 0, 2, 302, 65);
INSERT INTO public.who_global_data VALUES (71472, 396, 3181, 33, 174, 302, 102);
INSERT INTO public.who_global_data VALUES (71473, 0, 0, 0, 0, 302, 223);
INSERT INTO public.who_global_data VALUES (71474, 3, 57, 1, 1, 302, 4);
INSERT INTO public.who_global_data VALUES (71475, 0, 16, 0, 0, 302, 146);
INSERT INTO public.who_global_data VALUES (71476, 7, 262, 0, 2, 302, 31);
INSERT INTO public.who_global_data VALUES (71477, 0, 8, 0, 0, 302, 127);
INSERT INTO public.who_global_data VALUES (71478, 85, 1431, 9, 105, 302, 22);
INSERT INTO public.who_global_data VALUES (71479, 0, 17, 0, 0, 302, 115);
INSERT INTO public.who_global_data VALUES (71480, 5, 27, 0, 3, 302, 106);
INSERT INTO public.who_global_data VALUES (71481, 0, 16, 0, 0, 302, 90);
INSERT INTO public.who_global_data VALUES (71482, 0, 0, 0, 0, 302, 70);
INSERT INTO public.who_global_data VALUES (71483, 0, 9, 0, 0, 302, 46);
INSERT INTO public.who_global_data VALUES (71484, 1209, 21559, 143, 2349, 302, 139);
INSERT INTO public.who_global_data VALUES (71485, 0, 18, 0, 0, 302, 42);
INSERT INTO public.who_global_data VALUES (71486, 23, 1015, 0, 1, 302, 80);
INSERT INTO public.who_global_data VALUES (71487, 0, 6, 0, 1, 302, 203);
INSERT INTO public.who_global_data VALUES (71488, 68, 410, 0, 11, 302, 136);
INSERT INTO public.who_global_data VALUES (71489, 12, 288, 1, 7, 302, 63);
INSERT INTO public.who_global_data VALUES (71490, 0, 0, 0, 0, 302, 17);
INSERT INTO public.who_global_data VALUES (71491, 0, 11, 0, 2, 302, 172);
INSERT INTO public.who_global_data VALUES (71492, 46, 663, 0, 30, 302, 109);
INSERT INTO public.who_global_data VALUES (71493, 150, 6160, 8, 88, 302, 200);
INSERT INTO public.who_global_data VALUES (71494, 3, 266, 1, 2, 302, 93);
INSERT INTO public.who_global_data VALUES (71495, 27, 484, 1, 3, 302, 5);
INSERT INTO public.who_global_data VALUES (71496, 0, 712, 0, 11, 302, 214);
INSERT INTO public.who_global_data VALUES (71497, 206, 4695, 3, 66, 302, 204);
INSERT INTO public.who_global_data VALUES (71498, 0, 0, 0, 0, 302, 198);
INSERT INTO public.who_global_data VALUES (71499, 279, 2528, 4, 63, 302, 173);
INSERT INTO public.who_global_data VALUES (71500, 0, 2, 0, 0, 302, 229);
INSERT INTO public.who_global_data VALUES (71501, 5, 124, 0, 5, 302, 76);
INSERT INTO public.who_global_data VALUES (71502, 1388, 4342, 14, 121, 302, 138);
INSERT INTO public.who_global_data VALUES (71503, 0, 4076, 0, 203, 302, 98);
INSERT INTO public.who_global_data VALUES (71504, 0, 0, 0, 0, 302, 103);
INSERT INTO public.who_global_data VALUES (71505, 370, 5575, 15, 174, 302, 225);
INSERT INTO public.who_global_data VALUES (71506, 815, 13956, 29, 409, 302, 131);
INSERT INTO public.who_global_data VALUES (71507, 63, 683, 9, 33, 302, 235);
INSERT INTO public.who_global_data VALUES (71508, 136, 2512, 0, 6, 302, 137);
INSERT INTO public.who_global_data VALUES (71509, 27, 10450, 4, 208, 302, 81);
INSERT INTO public.who_global_data VALUES (71510, 115, 1289, 1, 29, 302, 182);
INSERT INTO public.who_global_data VALUES (71511, 14, 376, 0, 0, 302, 145);
INSERT INTO public.who_global_data VALUES (71512, 441, 5202, 20, 229, 302, 26);
INSERT INTO public.who_global_data VALUES (71513, 1786, 11917, 18, 94, 302, 170);
INSERT INTO public.who_global_data VALUES (71514, 3, 113, 0, 0, 302, 191);
INSERT INTO public.who_global_data VALUES (71515, 0, 0, 0, 0, 302, 221);
INSERT INTO public.who_global_data VALUES (71516, 0, 6, 0, 0, 302, 64);
INSERT INTO public.who_global_data VALUES (71517, 0, 0, 0, 0, 302, 116);
INSERT INTO public.who_global_data VALUES (71518, 0, 11, 0, 0, 302, 128);
INSERT INTO public.who_global_data VALUES (71519, 0, 14, 0, 0, 302, 6);
INSERT INTO public.who_global_data VALUES (71520, 1, 32, 0, 2, 302, 227);
INSERT INTO public.who_global_data VALUES (71521, 0, 1, 0, 0, 302, 68);
INSERT INTO public.who_global_data VALUES (71522, 0, 8, 0, 0, 302, 184);
INSERT INTO public.who_global_data VALUES (71523, 0, 0, 0, 0, 302, 82);
INSERT INTO public.who_global_data VALUES (71524, 36, 344, 0, 34, 302, 149);
INSERT INTO public.who_global_data VALUES (71525, 0, 4, 0, 0, 302, 197);
INSERT INTO public.who_global_data VALUES (71526, 364, 3651, 3, 47, 302, 78);
INSERT INTO public.who_global_data VALUES (71527, 6, 250, 0, 2, 302, 233);
INSERT INTO public.who_global_data VALUES (71528, 201, 2867, 0, 65, 302, 133);
INSERT INTO public.who_global_data VALUES (71529, 0, 11, 0, 0, 302, 35);
INSERT INTO public.who_global_data VALUES (71530, 0, 7, 0, 0, 302, 114);
INSERT INTO public.who_global_data VALUES (71531, 287, 1910, 1, 7, 302, 237);
INSERT INTO public.who_global_data VALUES (71532, 0, 2, 0, 0, 302, 55);
INSERT INTO public.who_global_data VALUES (71533, 3, 43, 0, 8, 302, 176);
INSERT INTO public.who_global_data VALUES (71534, 19, 701, 0, 2, 302, 202);
INSERT INTO public.who_global_data VALUES (71535, 35, 1160, 2, 48, 302, 155);
INSERT INTO public.who_global_data VALUES (71536, 0, 0, 0, 0, 302, 32);
INSERT INTO public.who_global_data VALUES (71537, 0, 12, 0, 1, 302, 220);
INSERT INTO public.who_global_data VALUES (71538, 89, 1934, 0, 18, 302, 30);
INSERT INTO public.who_global_data VALUES (71539, 2, 3, 0, 0, 302, 147);
INSERT INTO public.who_global_data VALUES (71540, 5489, 169163, 749, 16670, 302, 208);
INSERT INTO public.who_global_data VALUES (71541, 1, 190, 0, 7, 302, 45);
INSERT INTO public.who_global_data VALUES (71542, 1, 15, 0, 2, 302, 110);
INSERT INTO public.who_global_data VALUES (71543, 0, 10, 0, 1, 302, 88);
INSERT INTO public.who_global_data VALUES (71544, 654, 8954, 154, 1018, 302, 51);
INSERT INTO public.who_global_data VALUES (71545, 559, 25434, 44, 970, 302, 209);
INSERT INTO public.who_global_data VALUES (71546, 0, 19, 0, 2, 302, 205);
INSERT INTO public.who_global_data VALUES (71547, 0, 0, 0, 0, 302, 18);
INSERT INTO public.who_global_data VALUES (71548, 50, 2473, 1, 33, 302, 72);
INSERT INTO public.who_global_data VALUES (71549, 5131, 76635, 1116, 9691, 302, 44);
INSERT INTO public.who_global_data VALUES (71550, 0, 1, 0, 0, 302, 15);
INSERT INTO public.who_global_data VALUES (71551, 3, 73, 0, 3, 302, 25);
INSERT INTO public.who_global_data VALUES (71552, 0, 0, 0, 0, 302, 179);
INSERT INTO public.who_global_data VALUES (71553, 0, 0, 0, 0, 302, 34);
INSERT INTO public.who_global_data VALUES (71554, 2, 109, 0, 8, 302, 207);
INSERT INTO public.who_global_data VALUES (71555, 15, 643, 1, 25, 302, 166);
INSERT INTO public.who_global_data VALUES (71556, 4056, 42282, 96, 908, 302, 126);
INSERT INTO public.who_global_data VALUES (71557, 0, 0, 0, 0, 302, 97);
INSERT INTO public.who_global_data VALUES (71558, 0, 8, 0, 1, 302, 36);
INSERT INTO public.who_global_data VALUES (71559, 0, 0, 0, 0, 302, 125);
INSERT INTO public.who_global_data VALUES (71560, 0, 53, 0, 0, 302, 124);
INSERT INTO public.who_global_data VALUES (71561, 311, 2203, 12, 69, 302, 185);
INSERT INTO public.who_global_data VALUES (71562, 331, 2990, 2, 14, 302, 194);
INSERT INTO public.who_global_data VALUES (71563, 0, 25, 0, 1, 302, 144);
INSERT INTO public.who_global_data VALUES (71564, 30859, 425889, 1925, 14665, 302, 19);
INSERT INTO public.who_global_data VALUES (71565, 1, 46, 0, 1, 302, 217);
INSERT INTO public.who_global_data VALUES (71566, 22, 446, 0, 7, 302, 148);
INSERT INTO public.who_global_data VALUES (71567, 69, 624, 0, 3, 302, 86);
INSERT INTO public.who_global_data VALUES (71568, 0, 0, 0, 0, 302, 13);
INSERT INTO public.who_global_data VALUES (71569, 0, 166, 0, 7, 302, 157);
INSERT INTO public.who_global_data VALUES (71570, 4, 255, 0, 0, 302, 8);
INSERT INTO public.who_global_data VALUES (71571, 0, 0, 0, 0, 302, 73);
INSERT INTO public.who_global_data VALUES (71572, 1, 1, 0, 0, 302, 101);
INSERT INTO public.who_global_data VALUES (71573, 0, 39, 0, 1, 302, 165);
INSERT INTO public.who_global_data VALUES (71574, 0, 11, 0, 3, 302, 14);
INSERT INTO public.who_global_data VALUES (71575, 61, 484, 1, 15, 303, 193);
INSERT INTO public.who_global_data VALUES (71576, 9, 371, 0, 21, 303, 113);
INSERT INTO public.who_global_data VALUES (71577, 104, 1572, 11, 205, 303, 143);
INSERT INTO public.who_global_data VALUES (71578, 0, 0, 0, 0, 303, 219);
INSERT INTO public.who_global_data VALUES (71579, 15, 566, 2, 24, 303, 186);
INSERT INTO public.who_global_data VALUES (71580, 2, 19, 0, 2, 303, 52);
INSERT INTO public.who_global_data VALUES (71581, 0, 3, 0, 0, 303, 180);
INSERT INTO public.who_global_data VALUES (71582, 4, 19, 2, 2, 303, 167);
INSERT INTO public.who_global_data VALUES (71583, 87, 1715, 7, 60, 303, 154);
INSERT INTO public.who_global_data VALUES (71584, 28, 857, 1, 9, 303, 94);
INSERT INTO public.who_global_data VALUES (71585, 3, 74, 0, 0, 303, 66);
INSERT INTO public.who_global_data VALUES (71586, 96, 6052, 5, 50, 303, 58);
INSERT INTO public.who_global_data VALUES (71587, 329, 12969, 30, 273, 303, 163);
INSERT INTO public.who_global_data VALUES (71588, 105, 822, 0, 8, 303, 37);
INSERT INTO public.who_global_data VALUES (71589, 3, 36, 1, 6, 303, 142);
INSERT INTO public.who_global_data VALUES (71590, 34, 855, 0, 5, 303, 83);
INSERT INTO public.who_global_data VALUES (71591, 112, 330, 1, 21, 303, 228);
INSERT INTO public.who_global_data VALUES (71592, 3, 63, 1, 3, 303, 188);
INSERT INTO public.who_global_data VALUES (71593, 205, 1066, 0, 13, 303, 62);
INSERT INTO public.who_global_data VALUES (71594, 1598, 28399, 322, 3442, 303, 160);
INSERT INTO public.who_global_data VALUES (71595, 1, 8, 0, 1, 303, 50);
INSERT INTO public.who_global_data VALUES (71596, 0, 26, 0, 1, 303, 33);
INSERT INTO public.who_global_data VALUES (71597, 0, 39, 0, 2, 303, 183);
INSERT INTO public.who_global_data VALUES (71598, 0, 5, 0, 0, 303, 92);
INSERT INTO public.who_global_data VALUES (71599, 16, 210, 1, 15, 303, 158);
INSERT INTO public.who_global_data VALUES (71600, 0, 0, 0, 0, 303, 67);
INSERT INTO public.who_global_data VALUES (71601, 35, 816, 3, 35, 303, 57);
INSERT INTO public.who_global_data VALUES (71602, 0, 6, 0, 1, 303, 38);
INSERT INTO public.who_global_data VALUES (71603, 1661, 13717, 114, 667, 303, 141);
INSERT INTO public.who_global_data VALUES (71604, 0, 3, 0, 0, 303, 178);
INSERT INTO public.who_global_data VALUES (71605, 0, 135, 0, 1, 303, 108);
INSERT INTO public.who_global_data VALUES (71606, 16, 593, 1, 24, 303, 39);
INSERT INTO public.who_global_data VALUES (71607, 0, 384, 1, 19, 303, 2);
INSERT INTO public.who_global_data VALUES (71608, 0, 3, 0, 0, 303, 195);
INSERT INTO public.who_global_data VALUES (71609, 0, 7, 0, 1, 303, 107);
INSERT INTO public.who_global_data VALUES (71610, 0, 117, 0, 0, 303, 161);
INSERT INTO public.who_global_data VALUES (71611, 175, 730, 1, 10, 303, 212);
INSERT INTO public.who_global_data VALUES (71612, 1384, 18433, 56, 401, 303, 181);
INSERT INTO public.who_global_data VALUES (71613, 6, 45, 0, 1, 303, 53);
INSERT INTO public.who_global_data VALUES (71614, 1, 10, 0, 0, 303, 164);
INSERT INTO public.who_global_data VALUES (71615, 0, 10, 0, 0, 303, 140);
INSERT INTO public.who_global_data VALUES (71616, 430, 5546, 5, 48, 303, 20);
INSERT INTO public.who_global_data VALUES (71617, 88, 83249, 2, 3344, 303, 112);
INSERT INTO public.who_global_data VALUES (71618, 201, 1780, 4, 50, 303, 111);
INSERT INTO public.who_global_data VALUES (71619, 0, 0, 0, 0, 303, 71);
INSERT INTO public.who_global_data VALUES (71620, 11, 60, 0, 5, 303, 218);
INSERT INTO public.who_global_data VALUES (71621, 0, 0, 0, 0, 303, 43);
INSERT INTO public.who_global_data VALUES (71622, 16, 483, 0, 2, 303, 49);
INSERT INTO public.who_global_data VALUES (71623, 35, 384, 0, 3, 303, 1);
INSERT INTO public.who_global_data VALUES (71624, 61, 1343, 1, 19, 303, 48);
INSERT INTO public.who_global_data VALUES (71625, 61, 457, 1, 12, 303, 232);
INSERT INTO public.who_global_data VALUES (71626, 1, 14, 0, 1, 303, 175);
INSERT INTO public.who_global_data VALUES (71627, 32, 526, 0, 9, 303, 21);
INSERT INTO public.who_global_data VALUES (71628, 295, 5312, 11, 99, 303, 156);
INSERT INTO public.who_global_data VALUES (71629, 0, 0, 0, 0, 303, 95);
INSERT INTO public.who_global_data VALUES (71630, 24, 207, 0, 20, 303, 177);
INSERT INTO public.who_global_data VALUES (71631, 331, 5402, 15, 218, 303, 210);
INSERT INTO public.who_global_data VALUES (71632, 5, 140, 1, 1, 303, 120);
INSERT INTO public.who_global_data VALUES (71633, 0, 15, 0, 0, 303, 135);
INSERT INTO public.who_global_data VALUES (71634, 0, 1956, 0, 98, 303, 206);
INSERT INTO public.who_global_data VALUES (71635, 703, 4450, 51, 242, 303, 189);
INSERT INTO public.who_global_data VALUES (71636, 110, 1560, 9, 103, 303, 129);
INSERT INTO public.who_global_data VALUES (71637, 15, 93, 1, 5, 303, 121);
INSERT INTO public.who_global_data VALUES (71638, 0, 16, 0, 0, 303, 59);
INSERT INTO public.who_global_data VALUES (71639, 2, 33, 0, 0, 303, 96);
INSERT INTO public.who_global_data VALUES (71640, 36, 1185, 3, 24, 303, 41);
INSERT INTO public.who_global_data VALUES (71641, 2, 12, 0, 0, 303, 216);
INSERT INTO public.who_global_data VALUES (71642, 3, 55, 0, 2, 303, 236);
INSERT INTO public.who_global_data VALUES (71643, 3, 5, 0, 0, 303, 150);
INSERT INTO public.who_global_data VALUES (71644, 0, 184, 0, 0, 303, 61);
INSERT INTO public.who_global_data VALUES (71645, 0, 15, 0, 0, 303, 7);
INSERT INTO public.who_global_data VALUES (71646, 179, 2487, 6, 40, 303, 169);
INSERT INTO public.who_global_data VALUES (71647, 3869, 81094, 540, 10853, 303, 28);
INSERT INTO public.who_global_data VALUES (71648, 5, 77, 0, 0, 303, 85);
INSERT INTO public.who_global_data VALUES (71649, 4, 51, 0, 0, 303, 211);
INSERT INTO public.who_global_data VALUES (71650, 0, 24, 0, 1, 303, 60);
INSERT INTO public.who_global_data VALUES (71651, 0, 4, 0, 1, 303, 3);
INSERT INTO public.who_global_data VALUES (71652, 6, 214, 0, 3, 303, 11);
INSERT INTO public.who_global_data VALUES (71653, 4974, 108202, 246, 2107, 303, 89);
INSERT INTO public.who_global_data VALUES (71654, 26, 313, 1, 6, 303, 24);
INSERT INTO public.who_global_data VALUES (71655, 0, 113, 0, 0, 303, 162);
INSERT INTO public.who_global_data VALUES (71656, 52, 1884, 2, 83, 303, 100);
INSERT INTO public.who_global_data VALUES (71657, 0, 11, 0, 0, 303, 47);
INSERT INTO public.who_global_data VALUES (71658, 0, 12, 0, 0, 303, 29);
INSERT INTO public.who_global_data VALUES (71659, 0, 139, 1, 8, 303, 40);
INSERT INTO public.who_global_data VALUES (71660, 1, 125, 0, 4, 303, 222);
INSERT INTO public.who_global_data VALUES (71661, 10, 87, 0, 3, 303, 132);
INSERT INTO public.who_global_data VALUES (71662, 0, 166, 0, 4, 303, 130);
INSERT INTO public.who_global_data VALUES (71663, 20, 164, 0, 0, 303, 234);
INSERT INTO public.who_global_data VALUES (71664, 0, 33, 0, 0, 303, 23);
INSERT INTO public.who_global_data VALUES (71665, 2, 33, 0, 5, 303, 192);
INSERT INTO public.who_global_data VALUES (71666, 2, 27, 0, 1, 303, 69);
INSERT INTO public.who_global_data VALUES (71667, 1, 8, 0, 0, 303, 187);
INSERT INTO public.who_global_data VALUES (71668, 7, 312, 0, 22, 303, 230);
INSERT INTO public.who_global_data VALUES (71669, 85, 980, 8, 66, 303, 77);
INSERT INTO public.who_global_data VALUES (71670, 30, 1616, 0, 6, 303, 9);
INSERT INTO public.who_global_data VALUES (71671, 591, 5865, 20, 169, 303, 74);
INSERT INTO public.who_global_data VALUES (71672, 337, 3293, 40, 280, 303, 224);
INSERT INTO public.who_global_data VALUES (71673, 1634, 66220, 117, 4110, 303, 199);
INSERT INTO public.who_global_data VALUES (71674, 80, 1202, 4, 69, 303, 190);
INSERT INTO public.who_global_data VALUES (71675, 515, 6224, 25, 235, 303, 12);
INSERT INTO public.who_global_data VALUES (71676, 0, 150, 0, 1, 303, 104);
INSERT INTO public.who_global_data VALUES (71677, 377, 9573, 8, 72, 303, 153);
INSERT INTO public.who_global_data VALUES (71678, 3836, 139422, 540, 17669, 303, 91);
INSERT INTO public.who_global_data VALUES (71679, 4, 63, 0, 3, 303, 215);
INSERT INTO public.who_global_data VALUES (71680, 511, 4768, 4, 85, 303, 84);
INSERT INTO public.who_global_data VALUES (71681, 0, 170, 0, 3, 303, 231);
INSERT INTO public.who_global_data VALUES (71682, 5, 358, 0, 6, 303, 196);
INSERT INTO public.who_global_data VALUES (71683, 75, 802, 2, 9, 303, 105);
INSERT INTO public.who_global_data VALUES (71684, 7, 179, 0, 6, 303, 122);
INSERT INTO public.who_global_data VALUES (71685, 0, 0, 0, 0, 303, 159);
INSERT INTO public.who_global_data VALUES (71686, 40, 224, 1, 7, 303, 75);
INSERT INTO public.who_global_data VALUES (71687, 55, 910, 0, 1, 303, 27);
INSERT INTO public.who_global_data VALUES (71688, 10, 280, 0, 4, 303, 54);
INSERT INTO public.who_global_data VALUES (71689, 1, 15, 0, 0, 303, 226);
INSERT INTO public.who_global_data VALUES (71690, 29, 577, 0, 2, 303, 79);
INSERT INTO public.who_global_data VALUES (71691, 7, 582, 0, 19, 303, 56);
INSERT INTO public.who_global_data VALUES (71692, 0, 0, 0, 0, 303, 117);
INSERT INTO public.who_global_data VALUES (71693, 17, 31, 1, 4, 303, 152);
INSERT INTO public.who_global_data VALUES (71694, 0, 21, 0, 1, 303, 16);
INSERT INTO public.who_global_data VALUES (71695, 1, 80, 0, 1, 303, 10);
INSERT INTO public.who_global_data VALUES (71696, 37, 858, 1, 21, 303, 201);
INSERT INTO public.who_global_data VALUES (71697, 64, 3034, 2, 46, 303, 174);
INSERT INTO public.who_global_data VALUES (71698, 1, 93, 0, 0, 303, 119);
INSERT INTO public.who_global_data VALUES (71699, 0, 8, 0, 1, 303, 168);
INSERT INTO public.who_global_data VALUES (71700, 156, 4119, 2, 65, 303, 99);
INSERT INTO public.who_global_data VALUES (71701, 0, 19, 0, 0, 303, 171);
INSERT INTO public.who_global_data VALUES (71702, 9, 56, 1, 6, 303, 87);
INSERT INTO public.who_global_data VALUES (71703, 38, 337, 1, 1, 303, 123);
INSERT INTO public.who_global_data VALUES (71704, 0, 0, 0, 0, 303, 151);
INSERT INTO public.who_global_data VALUES (71705, 1, 152, 0, 4, 303, 213);
INSERT INTO public.who_global_data VALUES (71706, 0, 6, 0, 1, 303, 118);
INSERT INTO public.who_global_data VALUES (71707, 5, 273, 0, 7, 303, 134);
INSERT INTO public.who_global_data VALUES (71708, 2, 186, 0, 2, 303, 65);
INSERT INTO public.who_global_data VALUES (71709, 346, 2785, 16, 141, 303, 102);
INSERT INTO public.who_global_data VALUES (71710, 0, 0, 0, 0, 303, 223);
INSERT INTO public.who_global_data VALUES (71711, 0, 54, 0, 0, 303, 4);
INSERT INTO public.who_global_data VALUES (71712, 0, 16, 0, 0, 303, 146);
INSERT INTO public.who_global_data VALUES (71713, 3, 255, 0, 2, 303, 31);
INSERT INTO public.who_global_data VALUES (71714, 2, 8, 0, 0, 303, 127);
INSERT INTO public.who_global_data VALUES (71715, 104, 1346, 5, 96, 303, 22);
INSERT INTO public.who_global_data VALUES (71716, 7, 17, 0, 0, 303, 115);
INSERT INTO public.who_global_data VALUES (71717, 0, 22, 0, 3, 303, 106);
INSERT INTO public.who_global_data VALUES (71718, 0, 16, 0, 0, 303, 90);
INSERT INTO public.who_global_data VALUES (71719, 0, 0, 0, 0, 303, 70);
INSERT INTO public.who_global_data VALUES (71720, 0, 9, 0, 0, 303, 46);
INSERT INTO public.who_global_data VALUES (71721, 959, 20350, 157, 2206, 303, 139);
INSERT INTO public.who_global_data VALUES (71722, 0, 18, 0, 0, 303, 42);
INSERT INTO public.who_global_data VALUES (71723, 23, 992, 0, 1, 303, 80);
INSERT INTO public.who_global_data VALUES (71724, 0, 6, 0, 1, 303, 203);
INSERT INTO public.who_global_data VALUES (71725, 64, 342, 0, 11, 303, 136);
INSERT INTO public.who_global_data VALUES (71726, 22, 276, 0, 6, 303, 63);
INSERT INTO public.who_global_data VALUES (71727, 0, 0, 0, 0, 303, 17);
INSERT INTO public.who_global_data VALUES (71728, 0, 11, 0, 2, 303, 172);
INSERT INTO public.who_global_data VALUES (71729, 18, 617, 3, 30, 303, 109);
INSERT INTO public.who_global_data VALUES (71730, 147, 6010, 11, 80, 303, 200);
INSERT INTO public.who_global_data VALUES (71731, 0, 263, 0, 1, 303, 93);
INSERT INTO public.who_global_data VALUES (71732, 38, 457, 0, 2, 303, 5);
INSERT INTO public.who_global_data VALUES (71733, 0, 712, 0, 11, 303, 214);
INSERT INTO public.who_global_data VALUES (71734, 306, 4489, 5, 63, 303, 204);
INSERT INTO public.who_global_data VALUES (71735, 0, 0, 0, 0, 303, 198);
INSERT INTO public.who_global_data VALUES (71736, 149, 2249, 4, 59, 303, 173);
INSERT INTO public.who_global_data VALUES (71737, 1, 2, 0, 0, 303, 229);
INSERT INTO public.who_global_data VALUES (71738, 4, 119, 0, 5, 303, 76);
INSERT INTO public.who_global_data VALUES (71739, 393, 2954, 15, 107, 303, 138);
INSERT INTO public.who_global_data VALUES (71740, 206, 4076, 21, 203, 303, 98);
INSERT INTO public.who_global_data VALUES (71741, 0, 0, 0, 0, 303, 103);
INSERT INTO public.who_global_data VALUES (71742, 357, 5205, 30, 159, 303, 225);
INSERT INTO public.who_global_data VALUES (71743, 699, 13141, 35, 380, 303, 131);
INSERT INTO public.who_global_data VALUES (71744, 47, 620, 1, 24, 303, 235);
INSERT INTO public.who_global_data VALUES (71745, 166, 2376, 0, 6, 303, 137);
INSERT INTO public.who_global_data VALUES (71746, 39, 10423, 4, 204, 303, 81);
INSERT INTO public.who_global_data VALUES (71747, 118, 1174, 6, 28, 303, 182);
INSERT INTO public.who_global_data VALUES (71748, 4, 362, 0, 0, 303, 145);
INSERT INTO public.who_global_data VALUES (71749, 344, 4761, 27, 209, 303, 26);
INSERT INTO public.who_global_data VALUES (71750, 2634, 10131, 18, 76, 303, 170);
INSERT INTO public.who_global_data VALUES (71751, 5, 110, 0, 0, 303, 191);
INSERT INTO public.who_global_data VALUES (71752, 0, 0, 0, 0, 303, 221);
INSERT INTO public.who_global_data VALUES (71753, 0, 6, 0, 0, 303, 64);
INSERT INTO public.who_global_data VALUES (71754, 0, 0, 0, 0, 303, 116);
INSERT INTO public.who_global_data VALUES (71755, 1, 11, 0, 0, 303, 128);
INSERT INTO public.who_global_data VALUES (71756, 0, 14, 0, 0, 303, 6);
INSERT INTO public.who_global_data VALUES (71757, 0, 31, 0, 2, 303, 227);
INSERT INTO public.who_global_data VALUES (71758, 0, 1, 0, 0, 303, 68);
INSERT INTO public.who_global_data VALUES (71759, 1, 8, 0, 0, 303, 184);
INSERT INTO public.who_global_data VALUES (71760, 0, 0, 0, 0, 303, 82);
INSERT INTO public.who_global_data VALUES (71761, 29, 308, 0, 34, 303, 149);
INSERT INTO public.who_global_data VALUES (71762, 0, 4, 0, 0, 303, 197);
INSERT INTO public.who_global_data VALUES (71763, 355, 3287, 3, 44, 303, 78);
INSERT INTO public.who_global_data VALUES (71764, 7, 244, 0, 2, 303, 233);
INSERT INTO public.who_global_data VALUES (71765, 219, 2666, 4, 65, 303, 133);
INSERT INTO public.who_global_data VALUES (71766, 0, 11, 0, 0, 303, 35);
INSERT INTO public.who_global_data VALUES (71767, 1, 7, 0, 0, 303, 114);
INSERT INTO public.who_global_data VALUES (71768, 142, 1623, 0, 6, 303, 237);
INSERT INTO public.who_global_data VALUES (71769, 0, 2, 0, 0, 303, 55);
INSERT INTO public.who_global_data VALUES (71770, 0, 40, 0, 8, 303, 176);
INSERT INTO public.who_global_data VALUES (71771, 101, 682, 0, 2, 303, 202);
INSERT INTO public.who_global_data VALUES (71772, 33, 1125, 4, 46, 303, 155);
INSERT INTO public.who_global_data VALUES (71773, 0, 0, 0, 0, 303, 32);
INSERT INTO public.who_global_data VALUES (71774, 4, 12, 1, 1, 303, 220);
INSERT INTO public.who_global_data VALUES (71775, 96, 1845, 5, 18, 303, 30);
INSERT INTO public.who_global_data VALUES (71776, 0, 1, 0, 0, 303, 147);
INSERT INTO public.who_global_data VALUES (71777, 5322, 163674, 736, 15921, 303, 208);
INSERT INTO public.who_global_data VALUES (71778, 3, 189, 1, 7, 303, 45);
INSERT INTO public.who_global_data VALUES (71779, 0, 14, 0, 2, 303, 110);
INSERT INTO public.who_global_data VALUES (71780, 0, 10, 0, 1, 303, 88);
INSERT INTO public.who_global_data VALUES (71781, 739, 8300, 84, 864, 303, 51);
INSERT INTO public.who_global_data VALUES (71782, 612, 24875, 58, 926, 303, 209);
INSERT INTO public.who_global_data VALUES (71783, 0, 19, 0, 2, 303, 205);
INSERT INTO public.who_global_data VALUES (71784, 0, 0, 0, 0, 303, 18);
INSERT INTO public.who_global_data VALUES (71785, 54, 2423, 2, 32, 303, 72);
INSERT INTO public.who_global_data VALUES (71786, 5450, 71504, 1030, 8575, 303, 44);
INSERT INTO public.who_global_data VALUES (71787, 0, 1, 0, 0, 303, 15);
INSERT INTO public.who_global_data VALUES (71788, 12, 70, 0, 3, 303, 25);
INSERT INTO public.who_global_data VALUES (71789, 0, 0, 0, 0, 303, 179);
INSERT INTO public.who_global_data VALUES (71790, 0, 0, 0, 0, 303, 34);
INSERT INTO public.who_global_data VALUES (71791, 1, 107, 0, 8, 303, 207);
INSERT INTO public.who_global_data VALUES (71792, 5, 628, 1, 24, 303, 166);
INSERT INTO public.who_global_data VALUES (71793, 4117, 38226, 87, 812, 303, 126);
INSERT INTO public.who_global_data VALUES (71794, 0, 0, 0, 0, 303, 97);
INSERT INTO public.who_global_data VALUES (71795, 0, 8, 0, 1, 303, 36);
INSERT INTO public.who_global_data VALUES (71796, 0, 0, 0, 0, 303, 125);
INSERT INTO public.who_global_data VALUES (71797, 1, 53, 0, 0, 303, 124);
INSERT INTO public.who_global_data VALUES (71798, 224, 1892, 5, 57, 303, 185);
INSERT INTO public.who_global_data VALUES (71799, 0, 2659, 0, 12, 303, 194);
INSERT INTO public.who_global_data VALUES (71800, 1, 25, 0, 1, 303, 144);
INSERT INTO public.who_global_data VALUES (71801, 31709, 395030, 1895, 12740, 303, 19);
INSERT INTO public.who_global_data VALUES (71802, 2, 45, 0, 1, 303, 217);
INSERT INTO public.who_global_data VALUES (71803, 9, 424, 1, 7, 303, 148);
INSERT INTO public.who_global_data VALUES (71804, 21, 555, 0, 3, 303, 86);
INSERT INTO public.who_global_data VALUES (71805, 0, 0, 0, 0, 303, 13);
INSERT INTO public.who_global_data VALUES (71806, 1, 166, 0, 7, 303, 157);
INSERT INTO public.who_global_data VALUES (71807, 0, 251, 0, 0, 303, 8);
INSERT INTO public.who_global_data VALUES (71808, 0, 0, 0, 0, 303, 73);
INSERT INTO public.who_global_data VALUES (71809, 0, 0, 0, 0, 303, 101);
INSERT INTO public.who_global_data VALUES (71810, 0, 39, 0, 1, 303, 165);
INSERT INTO public.who_global_data VALUES (71811, 0, 11, 1, 3, 303, 14);
INSERT INTO public.who_global_data VALUES (71812, 56, 423, 3, 14, 304, 193);
INSERT INTO public.who_global_data VALUES (71813, 23, 362, 0, 21, 304, 113);
INSERT INTO public.who_global_data VALUES (71814, 45, 1468, 21, 194, 304, 143);
INSERT INTO public.who_global_data VALUES (71815, 0, 0, 0, 0, 304, 219);
INSERT INTO public.who_global_data VALUES (71816, 11, 551, 1, 22, 304, 186);
INSERT INTO public.who_global_data VALUES (71817, 1, 17, 0, 2, 304, 52);
INSERT INTO public.who_global_data VALUES (71818, 0, 3, 0, 0, 304, 180);
INSERT INTO public.who_global_data VALUES (71819, 0, 15, 0, 0, 304, 167);
INSERT INTO public.who_global_data VALUES (71820, 74, 1628, 7, 53, 304, 154);
INSERT INTO public.who_global_data VALUES (71821, 20, 829, 0, 8, 304, 94);
INSERT INTO public.who_global_data VALUES (71822, 7, 71, 0, 0, 304, 66);
INSERT INTO public.who_global_data VALUES (71823, 112, 5956, 3, 45, 304, 58);
INSERT INTO public.who_global_data VALUES (71824, 343, 12640, 23, 243, 304, 163);
INSERT INTO public.who_global_data VALUES (71825, 76, 717, 1, 8, 304, 37);
INSERT INTO public.who_global_data VALUES (71826, 4, 33, 0, 5, 304, 142);
INSERT INTO public.who_global_data VALUES (71827, 10, 821, 1, 5, 304, 83);
INSERT INTO public.who_global_data VALUES (71828, 54, 218, 3, 20, 304, 228);
INSERT INTO public.who_global_data VALUES (71829, 4, 60, 1, 2, 304, 188);
INSERT INTO public.who_global_data VALUES (71830, 161, 861, 0, 13, 304, 62);
INSERT INTO public.who_global_data VALUES (71831, 1515, 26801, 277, 3120, 304, 160);
INSERT INTO public.who_global_data VALUES (71832, 0, 7, 0, 1, 304, 50);
INSERT INTO public.who_global_data VALUES (71833, 3, 26, 0, 1, 304, 33);
INSERT INTO public.who_global_data VALUES (71834, 2, 39, 2, 2, 304, 183);
INSERT INTO public.who_global_data VALUES (71835, 0, 5, 0, 0, 304, 92);
INSERT INTO public.who_global_data VALUES (71836, 11, 194, 3, 14, 304, 158);
INSERT INTO public.who_global_data VALUES (71837, 0, 0, 0, 0, 304, 67);
INSERT INTO public.who_global_data VALUES (71838, 86, 781, 4, 32, 304, 57);
INSERT INTO public.who_global_data VALUES (71839, 0, 6, 0, 1, 304, 38);
INSERT INTO public.who_global_data VALUES (71840, 926, 12056, 67, 553, 304, 141);
INSERT INTO public.who_global_data VALUES (71841, 0, 3, 0, 0, 304, 178);
INSERT INTO public.who_global_data VALUES (71842, 0, 135, 0, 1, 304, 108);
INSERT INTO public.who_global_data VALUES (71843, 28, 577, 1, 23, 304, 39);
INSERT INTO public.who_global_data VALUES (71844, 39, 384, 1, 18, 304, 2);
INSERT INTO public.who_global_data VALUES (71845, 0, 3, 0, 0, 304, 195);
INSERT INTO public.who_global_data VALUES (71846, 0, 7, 0, 1, 304, 107);
INSERT INTO public.who_global_data VALUES (71847, 2, 117, 0, 0, 304, 161);
INSERT INTO public.who_global_data VALUES (71848, 0, 555, 0, 9, 304, 212);
INSERT INTO public.who_global_data VALUES (71849, 1243, 17049, 52, 345, 304, 181);
INSERT INTO public.who_global_data VALUES (71850, 0, 39, 0, 1, 304, 53);
INSERT INTO public.who_global_data VALUES (71851, 0, 9, 0, 0, 304, 164);
INSERT INTO public.who_global_data VALUES (71852, 1, 10, 0, 0, 304, 140);
INSERT INTO public.who_global_data VALUES (71853, 301, 5116, 6, 43, 304, 20);
INSERT INTO public.who_global_data VALUES (71854, 90, 83161, 2, 3342, 304, 112);
INSERT INTO public.who_global_data VALUES (71855, 94, 1579, 11, 46, 304, 111);
INSERT INTO public.who_global_data VALUES (71856, 0, 0, 0, 0, 304, 71);
INSERT INTO public.who_global_data VALUES (71857, 4, 49, 0, 5, 304, 218);
INSERT INTO public.who_global_data VALUES (71858, 0, 0, 0, 0, 304, 43);
INSERT INTO public.who_global_data VALUES (71859, 13, 467, 0, 2, 304, 49);
INSERT INTO public.who_global_data VALUES (71860, 26, 349, 0, 3, 304, 1);
INSERT INTO public.who_global_data VALUES (71861, 60, 1282, 2, 18, 304, 48);
INSERT INTO public.who_global_data VALUES (71862, 46, 396, 2, 11, 304, 232);
INSERT INTO public.who_global_data VALUES (71863, 0, 13, 0, 1, 304, 175);
INSERT INTO public.who_global_data VALUES (71864, 29, 494, 0, 9, 304, 21);
INSERT INTO public.who_global_data VALUES (71865, 195, 5017, 10, 88, 304, 156);
INSERT INTO public.who_global_data VALUES (71866, 0, 0, 0, 0, 304, 95);
INSERT INTO public.who_global_data VALUES (71867, 22, 183, 2, 20, 304, 177);
INSERT INTO public.who_global_data VALUES (71868, 390, 5071, 16, 203, 304, 210);
INSERT INTO public.who_global_data VALUES (71869, 14, 135, 0, 0, 304, 120);
INSERT INTO public.who_global_data VALUES (71870, 1, 15, 0, 0, 304, 135);
INSERT INTO public.who_global_data VALUES (71871, 128, 1956, 12, 98, 304, 206);
INSERT INTO public.who_global_data VALUES (71872, 0, 3747, 0, 191, 304, 189);
INSERT INTO public.who_global_data VALUES (71873, 128, 1450, 9, 94, 304, 129);
INSERT INTO public.who_global_data VALUES (71874, 9, 78, 1, 4, 304, 121);
INSERT INTO public.who_global_data VALUES (71875, 0, 16, 0, 0, 304, 59);
INSERT INTO public.who_global_data VALUES (71876, 2, 31, 0, 0, 304, 96);
INSERT INTO public.who_global_data VALUES (71877, 41, 1149, 2, 21, 304, 41);
INSERT INTO public.who_global_data VALUES (71878, 1, 10, 0, 0, 304, 216);
INSERT INTO public.who_global_data VALUES (71879, 8, 52, 1, 2, 304, 236);
INSERT INTO public.who_global_data VALUES (71880, 0, 2, 0, 0, 304, 150);
INSERT INTO public.who_global_data VALUES (71881, 1, 184, 0, 0, 304, 61);
INSERT INTO public.who_global_data VALUES (71882, 0, 15, 0, 0, 304, 7);
INSERT INTO public.who_global_data VALUES (71883, 132, 2308, 7, 34, 304, 169);
INSERT INTO public.who_global_data VALUES (71884, 3737, 77225, 1417, 10313, 304, 28);
INSERT INTO public.who_global_data VALUES (71885, 4, 72, 0, 0, 304, 85);
INSERT INTO public.who_global_data VALUES (71886, 5, 47, 0, 0, 304, 211);
INSERT INTO public.who_global_data VALUES (71887, 3, 24, 0, 1, 304, 60);
INSERT INTO public.who_global_data VALUES (71888, 0, 4, 0, 1, 304, 3);
INSERT INTO public.who_global_data VALUES (71889, 13, 208, 1, 3, 304, 11);
INSERT INTO public.who_global_data VALUES (71890, 4003, 103228, 254, 1861, 304, 89);
INSERT INTO public.who_global_data VALUES (71891, 73, 287, 0, 5, 304, 24);
INSERT INTO public.who_global_data VALUES (71892, 10, 113, 0, 0, 304, 162);
INSERT INTO public.who_global_data VALUES (71893, 77, 1832, 2, 81, 304, 100);
INSERT INTO public.who_global_data VALUES (71894, 0, 11, 0, 0, 304, 47);
INSERT INTO public.who_global_data VALUES (71895, 0, 12, 0, 0, 304, 29);
INSERT INTO public.who_global_data VALUES (71896, 4, 139, 0, 7, 304, 40);
INSERT INTO public.who_global_data VALUES (71897, 11, 124, 0, 4, 304, 222);
INSERT INTO public.who_global_data VALUES (71898, 7, 77, 0, 3, 304, 132);
INSERT INTO public.who_global_data VALUES (71899, 12, 166, 1, 4, 304, 130);
INSERT INTO public.who_global_data VALUES (71900, 33, 144, 0, 0, 304, 234);
INSERT INTO public.who_global_data VALUES (71901, 0, 33, 0, 0, 304, 23);
INSERT INTO public.who_global_data VALUES (71902, 2, 31, 1, 5, 304, 192);
INSERT INTO public.who_global_data VALUES (71903, 1, 25, 0, 1, 304, 69);
INSERT INTO public.who_global_data VALUES (71904, 0, 7, 0, 0, 304, 187);
INSERT INTO public.who_global_data VALUES (71905, 7, 305, 0, 22, 304, 230);
INSERT INTO public.who_global_data VALUES (71906, 78, 895, 11, 58, 304, 77);
INSERT INTO public.who_global_data VALUES (71907, 24, 1586, 0, 6, 304, 9);
INSERT INTO public.who_global_data VALUES (71908, 853, 5274, 35, 149, 304, 74);
INSERT INTO public.who_global_data VALUES (71909, 218, 2956, 19, 240, 304, 224);
INSERT INTO public.who_global_data VALUES (71910, 1997, 64586, 121, 3993, 304, 199);
INSERT INTO public.who_global_data VALUES (71911, 91, 1122, 1, 65, 304, 190);
INSERT INTO public.who_global_data VALUES (71912, 345, 5709, 36, 210, 304, 12);
INSERT INTO public.who_global_data VALUES (71913, 23, 150, 0, 1, 304, 104);
INSERT INTO public.who_global_data VALUES (71914, 451, 9196, 8, 64, 304, 153);
INSERT INTO public.who_global_data VALUES (71915, 3039, 135586, 604, 17129, 304, 91);
INSERT INTO public.who_global_data VALUES (71916, 1, 59, 0, 3, 304, 215);
INSERT INTO public.who_global_data VALUES (71917, 351, 4257, 1, 81, 304, 84);
INSERT INTO public.who_global_data VALUES (71918, 15, 170, 0, 3, 304, 231);
INSERT INTO public.who_global_data VALUES (71919, 4, 353, 0, 6, 304, 196);
INSERT INTO public.who_global_data VALUES (71920, 18, 727, 1, 7, 304, 105);
INSERT INTO public.who_global_data VALUES (71921, 30, 172, 2, 6, 304, 122);
INSERT INTO public.who_global_data VALUES (71922, 0, 0, 0, 0, 304, 159);
INSERT INTO public.who_global_data VALUES (71923, 19, 184, 3, 6, 304, 75);
INSERT INTO public.who_global_data VALUES (71924, 112, 855, 0, 1, 304, 27);
INSERT INTO public.who_global_data VALUES (71925, 42, 270, 0, 4, 304, 54);
INSERT INTO public.who_global_data VALUES (71926, 2, 14, 0, 0, 304, 226);
INSERT INTO public.who_global_data VALUES (71927, 6, 548, 1, 2, 304, 79);
INSERT INTO public.who_global_data VALUES (71928, 27, 575, 0, 19, 304, 56);
INSERT INTO public.who_global_data VALUES (71929, 0, 0, 0, 0, 304, 117);
INSERT INTO public.who_global_data VALUES (71930, 0, 14, 0, 3, 304, 152);
INSERT INTO public.who_global_data VALUES (71931, 2, 21, 0, 1, 304, 16);
INSERT INTO public.who_global_data VALUES (71932, 0, 79, 0, 1, 304, 10);
INSERT INTO public.who_global_data VALUES (71933, 38, 821, 0, 20, 304, 201);
INSERT INTO public.who_global_data VALUES (71934, 127, 2970, 3, 44, 304, 174);
INSERT INTO public.who_global_data VALUES (71935, 7, 92, 0, 0, 304, 119);
INSERT INTO public.who_global_data VALUES (71936, 4, 8, 1, 1, 304, 168);
INSERT INTO public.who_global_data VALUES (71937, 170, 3963, 1, 63, 304, 99);
INSERT INTO public.who_global_data VALUES (71938, 0, 19, 0, 0, 304, 171);
INSERT INTO public.who_global_data VALUES (71939, 8, 47, 1, 5, 304, 87);
INSERT INTO public.who_global_data VALUES (71940, 6, 299, 0, 0, 304, 123);
INSERT INTO public.who_global_data VALUES (71941, 0, 0, 0, 0, 304, 151);
INSERT INTO public.who_global_data VALUES (71942, 2, 151, 0, 4, 304, 213);
INSERT INTO public.who_global_data VALUES (71943, 0, 6, 0, 1, 304, 118);
INSERT INTO public.who_global_data VALUES (71944, 24, 268, 0, 7, 304, 134);
INSERT INTO public.who_global_data VALUES (71945, 20, 184, 0, 2, 304, 65);
INSERT INTO public.who_global_data VALUES (71946, 296, 2439, 31, 125, 304, 102);
INSERT INTO public.who_global_data VALUES (71947, 0, 0, 0, 0, 304, 223);
INSERT INTO public.who_global_data VALUES (71948, 2, 54, 0, 0, 304, 4);
INSERT INTO public.who_global_data VALUES (71949, 1, 16, 0, 0, 304, 146);
INSERT INTO public.who_global_data VALUES (71950, 4, 252, 0, 2, 304, 31);
INSERT INTO public.who_global_data VALUES (71951, 0, 6, 0, 0, 304, 127);
INSERT INTO public.who_global_data VALUES (71952, 101, 1242, 8, 91, 304, 22);
INSERT INTO public.who_global_data VALUES (71953, 0, 10, 0, 0, 304, 115);
INSERT INTO public.who_global_data VALUES (71954, 0, 22, 2, 3, 304, 106);
INSERT INTO public.who_global_data VALUES (71955, 0, 16, 0, 0, 304, 90);
INSERT INTO public.who_global_data VALUES (71956, 0, 0, 0, 0, 304, 70);
INSERT INTO public.who_global_data VALUES (71957, 0, 9, 0, 0, 304, 46);
INSERT INTO public.who_global_data VALUES (71958, 782, 19391, 231, 2049, 304, 139);
INSERT INTO public.who_global_data VALUES (71959, 0, 18, 0, 0, 304, 42);
INSERT INTO public.who_global_data VALUES (71960, 26, 969, 0, 1, 304, 80);
INSERT INTO public.who_global_data VALUES (71961, 0, 6, 0, 1, 304, 203);
INSERT INTO public.who_global_data VALUES (71962, 25, 278, 1, 11, 304, 136);
INSERT INTO public.who_global_data VALUES (71963, 22, 254, 1, 6, 304, 63);
INSERT INTO public.who_global_data VALUES (71964, 0, 0, 0, 0, 304, 17);
INSERT INTO public.who_global_data VALUES (71965, 3, 11, 1, 2, 304, 172);
INSERT INTO public.who_global_data VALUES (71966, 29, 599, 6, 27, 304, 109);
INSERT INTO public.who_global_data VALUES (71967, 108, 5863, 10, 69, 304, 200);
INSERT INTO public.who_global_data VALUES (71968, 9, 263, 0, 1, 304, 93);
INSERT INTO public.who_global_data VALUES (71969, 48, 419, 0, 2, 304, 5);
INSERT INTO public.who_global_data VALUES (71970, 0, 712, 0, 11, 304, 214);
INSERT INTO public.who_global_data VALUES (71971, 178, 4183, 4, 58, 304, 204);
INSERT INTO public.who_global_data VALUES (71972, 0, 0, 0, 0, 304, 198);
INSERT INTO public.who_global_data VALUES (71973, 112, 2100, 1, 55, 304, 173);
INSERT INTO public.who_global_data VALUES (71974, 0, 1, 0, 0, 304, 229);
INSERT INTO public.who_global_data VALUES (71975, 2, 115, 0, 5, 304, 76);
INSERT INTO public.who_global_data VALUES (71976, 280, 2561, 9, 92, 304, 138);
INSERT INTO public.who_global_data VALUES (71977, 210, 3870, 19, 182, 304, 98);
INSERT INTO public.who_global_data VALUES (71978, 0, 0, 0, 0, 304, 103);
INSERT INTO public.who_global_data VALUES (71979, 435, 4848, 22, 129, 304, 225);
INSERT INTO public.who_global_data VALUES (71980, 712, 12442, 34, 345, 304, 131);
INSERT INTO public.who_global_data VALUES (71981, 60, 573, 2, 23, 304, 235);
INSERT INTO public.who_global_data VALUES (71982, 378, 2210, 2, 6, 304, 137);
INSERT INTO public.who_global_data VALUES (71983, 53, 10384, 8, 200, 304, 81);
INSERT INTO public.who_global_data VALUES (71984, 91, 1056, 3, 22, 304, 182);
INSERT INTO public.who_global_data VALUES (71985, 9, 358, 0, 0, 304, 145);
INSERT INTO public.who_global_data VALUES (71986, 360, 4417, 25, 182, 304, 26);
INSERT INTO public.who_global_data VALUES (71987, 1154, 7497, 11, 58, 304, 170);
INSERT INTO public.who_global_data VALUES (71988, 1, 105, 0, 0, 304, 191);
INSERT INTO public.who_global_data VALUES (71989, 0, 0, 0, 0, 304, 221);
INSERT INTO public.who_global_data VALUES (71990, 0, 6, 0, 0, 304, 64);
INSERT INTO public.who_global_data VALUES (71991, 0, 0, 0, 0, 304, 116);
INSERT INTO public.who_global_data VALUES (71992, 0, 10, 0, 0, 304, 128);
INSERT INTO public.who_global_data VALUES (71993, 0, 14, 0, 0, 304, 6);
INSERT INTO public.who_global_data VALUES (71994, 0, 31, 0, 2, 304, 227);
INSERT INTO public.who_global_data VALUES (71995, 1, 1, 0, 0, 304, 68);
INSERT INTO public.who_global_data VALUES (71996, 0, 7, 0, 0, 304, 184);
INSERT INTO public.who_global_data VALUES (71997, 0, 0, 0, 0, 304, 82);
INSERT INTO public.who_global_data VALUES (71998, 2, 279, 2, 34, 304, 149);
INSERT INTO public.who_global_data VALUES (71999, 0, 4, 0, 0, 304, 197);
INSERT INTO public.who_global_data VALUES (72000, 137, 2932, 0, 41, 304, 78);
INSERT INTO public.who_global_data VALUES (72001, 11, 237, 0, 2, 304, 233);
INSERT INTO public.who_global_data VALUES (72002, 247, 2447, 3, 61, 304, 133);
INSERT INTO public.who_global_data VALUES (72003, 0, 11, 0, 0, 304, 35);
INSERT INTO public.who_global_data VALUES (72004, 0, 6, 0, 0, 304, 114);
INSERT INTO public.who_global_data VALUES (72005, 106, 1481, 0, 6, 304, 237);
INSERT INTO public.who_global_data VALUES (72006, 0, 2, 0, 0, 304, 55);
INSERT INTO public.who_global_data VALUES (72007, 3, 40, 2, 8, 304, 176);
INSERT INTO public.who_global_data VALUES (72008, 47, 581, 0, 2, 304, 202);
INSERT INTO public.who_global_data VALUES (72009, 36, 1092, 2, 42, 304, 155);
INSERT INTO public.who_global_data VALUES (72010, 0, 0, 0, 0, 304, 32);
INSERT INTO public.who_global_data VALUES (72011, 1, 8, 0, 0, 304, 220);
INSERT INTO public.who_global_data VALUES (72012, 63, 1749, 1, 13, 304, 30);
INSERT INTO public.who_global_data VALUES (72013, 0, 1, 0, 0, 304, 147);
INSERT INTO public.who_global_data VALUES (72014, 5395, 158352, 766, 15185, 304, 208);
INSERT INTO public.who_global_data VALUES (72015, 6, 186, 0, 6, 304, 45);
INSERT INTO public.who_global_data VALUES (72016, 0, 14, 0, 2, 304, 110);
INSERT INTO public.who_global_data VALUES (72017, 0, 10, 0, 1, 304, 88);
INSERT INTO public.who_global_data VALUES (72018, 389, 7561, 90, 780, 304, 51);
INSERT INTO public.who_global_data VALUES (72019, 715, 24263, 56, 868, 304, 209);
INSERT INTO public.who_global_data VALUES (72020, 0, 19, 0, 2, 304, 205);
INSERT INTO public.who_global_data VALUES (72021, 0, 0, 0, 0, 304, 18);
INSERT INTO public.who_global_data VALUES (72022, 111, 2369, 3, 30, 304, 72);
INSERT INTO public.who_global_data VALUES (72023, 5282, 66054, 1105, 7545, 304, 44);
INSERT INTO public.who_global_data VALUES (72024, 0, 1, 0, 0, 304, 15);
INSERT INTO public.who_global_data VALUES (72025, 14, 58, 0, 3, 304, 25);
INSERT INTO public.who_global_data VALUES (72026, 0, 0, 0, 0, 304, 179);
INSERT INTO public.who_global_data VALUES (72027, 0, 0, 0, 0, 304, 34);
INSERT INTO public.who_global_data VALUES (72028, 1, 106, 0, 8, 304, 207);
INSERT INTO public.who_global_data VALUES (72029, 27, 623, 1, 23, 304, 166);
INSERT INTO public.who_global_data VALUES (72030, 3892, 34109, 76, 725, 304, 126);
INSERT INTO public.who_global_data VALUES (72031, 0, 0, 0, 0, 304, 97);
INSERT INTO public.who_global_data VALUES (72032, 3, 8, 0, 1, 304, 36);
INSERT INTO public.who_global_data VALUES (72033, 0, 0, 0, 0, 304, 125);
INSERT INTO public.who_global_data VALUES (72034, 0, 52, 0, 0, 304, 124);
INSERT INTO public.who_global_data VALUES (72035, 206, 1668, 7, 52, 304, 185);
INSERT INTO public.who_global_data VALUES (72036, 583, 2659, 1, 12, 304, 194);
INSERT INTO public.who_global_data VALUES (72037, 0, 24, 0, 1, 304, 144);
INSERT INTO public.who_global_data VALUES (72038, 29510, 363321, 1286, 10845, 304, 19);
INSERT INTO public.who_global_data VALUES (72039, 0, 43, 0, 1, 304, 217);
INSERT INTO public.who_global_data VALUES (72040, 9, 415, 0, 6, 304, 148);
INSERT INTO public.who_global_data VALUES (72041, 62, 534, 1, 3, 304, 86);
INSERT INTO public.who_global_data VALUES (72042, 0, 0, 0, 0, 304, 13);
INSERT INTO public.who_global_data VALUES (72043, 6, 165, 4, 7, 304, 157);
INSERT INTO public.who_global_data VALUES (72044, 6, 251, 0, 0, 304, 8);
INSERT INTO public.who_global_data VALUES (72045, 0, 0, 0, 0, 304, 73);
INSERT INTO public.who_global_data VALUES (72046, 0, 0, 0, 0, 304, 101);
INSERT INTO public.who_global_data VALUES (72047, 0, 39, 0, 1, 304, 165);
INSERT INTO public.who_global_data VALUES (72048, 2, 11, 1, 2, 304, 14);
INSERT INTO public.who_global_data VALUES (72049, 30, 367, 4, 11, 305, 193);
INSERT INTO public.who_global_data VALUES (72050, 0, 339, 1, 21, 305, 113);
INSERT INTO public.who_global_data VALUES (72051, 172, 1423, 43, 173, 305, 143);
INSERT INTO public.who_global_data VALUES (72052, 0, 0, 0, 0, 305, 219);
INSERT INTO public.who_global_data VALUES (72053, 17, 540, 4, 21, 305, 186);
INSERT INTO public.who_global_data VALUES (72054, 2, 16, 0, 2, 305, 52);
INSERT INTO public.who_global_data VALUES (72055, 0, 3, 0, 0, 305, 180);
INSERT INTO public.who_global_data VALUES (72056, 8, 15, 0, 0, 305, 167);
INSERT INTO public.who_global_data VALUES (72057, 103, 1554, 2, 46, 305, 154);
INSERT INTO public.who_global_data VALUES (72058, 11, 809, 1, 8, 305, 94);
INSERT INTO public.who_global_data VALUES (72059, 0, 64, 0, 0, 305, 66);
INSERT INTO public.who_global_data VALUES (72060, 49, 5844, 3, 42, 305, 58);
INSERT INTO public.who_global_data VALUES (72061, 314, 12297, 16, 220, 305, 163);
INSERT INTO public.who_global_data VALUES (72062, 57, 641, 2, 7, 305, 37);
INSERT INTO public.who_global_data VALUES (72063, 1, 29, 1, 5, 305, 142);
INSERT INTO public.who_global_data VALUES (72064, 88, 811, 0, 4, 305, 83);
INSERT INTO public.who_global_data VALUES (72065, 41, 164, 5, 17, 305, 228);
INSERT INTO public.who_global_data VALUES (72066, 5, 56, 1, 1, 305, 188);
INSERT INTO public.who_global_data VALUES (72067, 138, 700, 5, 13, 305, 62);
INSERT INTO public.who_global_data VALUES (72068, 1934, 25286, 257, 2843, 305, 160);
INSERT INTO public.who_global_data VALUES (72069, 2, 7, 1, 1, 305, 50);
INSERT INTO public.who_global_data VALUES (72070, 1, 23, 1, 1, 305, 33);
INSERT INTO public.who_global_data VALUES (72071, 0, 37, 0, 0, 305, 183);
INSERT INTO public.who_global_data VALUES (72072, 0, 5, 0, 0, 305, 92);
INSERT INTO public.who_global_data VALUES (72073, 26, 183, 1, 11, 305, 158);
INSERT INTO public.who_global_data VALUES (72074, 0, 0, 0, 0, 305, 67);
INSERT INTO public.who_global_data VALUES (72075, 33, 695, 7, 28, 305, 57);
INSERT INTO public.who_global_data VALUES (72076, 2, 6, 0, 1, 305, 38);
INSERT INTO public.who_global_data VALUES (72077, 852, 11130, 54, 486, 305, 141);
INSERT INTO public.who_global_data VALUES (72078, 0, 3, 0, 0, 305, 178);
INSERT INTO public.who_global_data VALUES (72079, 0, 135, 0, 1, 305, 108);
INSERT INTO public.who_global_data VALUES (72080, 18, 549, 2, 22, 305, 39);
INSERT INTO public.who_global_data VALUES (72081, 0, 345, 0, 17, 305, 2);
INSERT INTO public.who_global_data VALUES (72082, 0, 3, 0, 0, 305, 195);
INSERT INTO public.who_global_data VALUES (72083, 2, 7, 0, 1, 305, 107);
INSERT INTO public.who_global_data VALUES (72084, 1, 115, 0, 0, 305, 161);
INSERT INTO public.who_global_data VALUES (72085, 0, 555, 0, 9, 305, 212);
INSERT INTO public.who_global_data VALUES (72086, 1902, 15806, 62, 293, 305, 181);
INSERT INTO public.who_global_data VALUES (72087, 4, 39, 0, 1, 305, 53);
INSERT INTO public.who_global_data VALUES (72088, 0, 9, 0, 0, 305, 164);
INSERT INTO public.who_global_data VALUES (72089, 0, 9, 0, 0, 305, 140);
INSERT INTO public.who_global_data VALUES (72090, 344, 4815, 3, 37, 305, 20);
INSERT INTO public.who_global_data VALUES (72091, 66, 83071, 0, 3340, 305, 112);
INSERT INTO public.who_global_data VALUES (72092, 79, 1485, 3, 35, 305, 111);
INSERT INTO public.who_global_data VALUES (72093, 0, 0, 0, 0, 305, 71);
INSERT INTO public.who_global_data VALUES (72094, 0, 45, 0, 5, 305, 218);
INSERT INTO public.who_global_data VALUES (72095, 0, 0, 0, 0, 305, 43);
INSERT INTO public.who_global_data VALUES (72096, 19, 454, 0, 2, 305, 49);
INSERT INTO public.who_global_data VALUES (72097, 62, 323, 1, 3, 305, 1);
INSERT INTO public.who_global_data VALUES (72098, 40, 1222, 1, 16, 305, 48);
INSERT INTO public.who_global_data VALUES (72099, 30, 350, 1, 9, 305, 232);
INSERT INTO public.who_global_data VALUES (72100, 2, 13, 0, 1, 305, 175);
INSERT INTO public.who_global_data VALUES (72101, 19, 465, 0, 9, 305, 21);
INSERT INTO public.who_global_data VALUES (72102, 235, 4822, 11, 78, 305, 156);
INSERT INTO public.who_global_data VALUES (72103, 0, 0, 0, 0, 305, 95);
INSERT INTO public.who_global_data VALUES (72104, 0, 161, 0, 18, 305, 177);
INSERT INTO public.who_global_data VALUES (72105, 312, 4681, 8, 187, 305, 210);
INSERT INTO public.who_global_data VALUES (72106, 31, 121, 0, 0, 305, 120);
INSERT INTO public.who_global_data VALUES (72107, 3, 14, 0, 0, 305, 135);
INSERT INTO public.who_global_data VALUES (72108, 340, 1828, 18, 86, 305, 206);
INSERT INTO public.who_global_data VALUES (72109, 282, 3747, 19, 191, 305, 189);
INSERT INTO public.who_global_data VALUES (72110, 149, 1322, 7, 85, 305, 129);
INSERT INTO public.who_global_data VALUES (72111, 7, 69, 0, 3, 305, 121);
INSERT INTO public.who_global_data VALUES (72112, 0, 16, 0, 0, 305, 59);
INSERT INTO public.who_global_data VALUES (72113, 0, 29, 0, 0, 305, 96);
INSERT INTO public.who_global_data VALUES (72114, 11, 1108, 4, 19, 305, 41);
INSERT INTO public.who_global_data VALUES (72115, 0, 9, 0, 0, 305, 216);
INSERT INTO public.who_global_data VALUES (72116, 1, 44, 0, 1, 305, 236);
INSERT INTO public.who_global_data VALUES (72117, 0, 2, 0, 0, 305, 150);
INSERT INTO public.who_global_data VALUES (72118, 2, 183, 0, 0, 305, 61);
INSERT INTO public.who_global_data VALUES (72119, 1, 15, 0, 0, 305, 7);
INSERT INTO public.who_global_data VALUES (72120, 249, 2176, 0, 27, 305, 169);
INSERT INTO public.who_global_data VALUES (72121, 3881, 73488, 832, 8896, 305, 28);
INSERT INTO public.who_global_data VALUES (72122, 2, 68, 0, 0, 305, 85);
INSERT INTO public.who_global_data VALUES (72123, 1, 42, 0, 0, 305, 211);
INSERT INTO public.who_global_data VALUES (72124, 0, 21, 0, 1, 305, 60);
INSERT INTO public.who_global_data VALUES (72125, 0, 4, 0, 1, 305, 3);
INSERT INTO public.who_global_data VALUES (72126, 7, 195, 0, 2, 305, 11);
INSERT INTO public.who_global_data VALUES (72127, 3834, 99225, 173, 1607, 305, 89);
INSERT INTO public.who_global_data VALUES (72128, 0, 214, 0, 5, 305, 24);
INSERT INTO public.who_global_data VALUES (72129, 0, 103, 0, 0, 305, 162);
INSERT INTO public.who_global_data VALUES (72130, 20, 1755, 6, 79, 305, 100);
INSERT INTO public.who_global_data VALUES (72131, 0, 11, 0, 0, 305, 47);
INSERT INTO public.who_global_data VALUES (72132, 0, 12, 0, 0, 305, 29);
INSERT INTO public.who_global_data VALUES (72133, 1, 135, 0, 7, 305, 40);
INSERT INTO public.who_global_data VALUES (72134, 1, 113, 0, 4, 305, 222);
INSERT INTO public.who_global_data VALUES (72135, 9, 70, 1, 3, 305, 132);
INSERT INTO public.who_global_data VALUES (72136, 0, 154, 0, 3, 305, 130);
INSERT INTO public.who_global_data VALUES (72137, 0, 111, 0, 0, 305, 234);
INSERT INTO public.who_global_data VALUES (72138, 15, 33, 0, 0, 305, 23);
INSERT INTO public.who_global_data VALUES (72139, 5, 29, 0, 4, 305, 192);
INSERT INTO public.who_global_data VALUES (72140, 3, 24, 1, 1, 305, 69);
INSERT INTO public.who_global_data VALUES (72141, 0, 7, 0, 0, 305, 187);
INSERT INTO public.who_global_data VALUES (72142, 30, 298, 0, 22, 305, 230);
INSERT INTO public.who_global_data VALUES (72143, 73, 817, 9, 47, 305, 77);
INSERT INTO public.who_global_data VALUES (72144, 76, 1562, 2, 6, 305, 9);
INSERT INTO public.who_global_data VALUES (72145, 354, 4421, 5, 114, 305, 74);
INSERT INTO public.who_global_data VALUES (72146, 247, 2738, 12, 221, 305, 224);
INSERT INTO public.who_global_data VALUES (72147, 2089, 62589, 133, 3872, 305, 199);
INSERT INTO public.who_global_data VALUES (72148, 0, 1031, 0, 64, 305, 190);
INSERT INTO public.who_global_data VALUES (72149, 253, 5364, 16, 174, 305, 12);
INSERT INTO public.who_global_data VALUES (72150, 0, 127, 0, 1, 305, 104);
INSERT INTO public.who_global_data VALUES (72151, 583, 8745, 7, 56, 305, 153);
INSERT INTO public.who_global_data VALUES (72152, 3599, 132547, 636, 16525, 305, 91);
INSERT INTO public.who_global_data VALUES (72153, 3, 58, 0, 3, 305, 215);
INSERT INTO public.who_global_data VALUES (72154, 252, 3906, 7, 80, 305, 84);
INSERT INTO public.who_global_data VALUES (72155, 0, 155, 0, 3, 305, 231);
INSERT INTO public.who_global_data VALUES (72156, 4, 349, 1, 6, 305, 196);
INSERT INTO public.who_global_data VALUES (72157, 39, 709, 0, 6, 305, 105);
INSERT INTO public.who_global_data VALUES (72158, 0, 142, 0, 4, 305, 122);
INSERT INTO public.who_global_data VALUES (72159, 0, 0, 0, 0, 305, 159);
INSERT INTO public.who_global_data VALUES (72160, 20, 165, 2, 3, 305, 75);
INSERT INTO public.who_global_data VALUES (72161, 78, 743, 0, 1, 305, 27);
INSERT INTO public.who_global_data VALUES (72162, 12, 228, 0, 4, 305, 54);
INSERT INTO public.who_global_data VALUES (72163, 1, 12, 0, 0, 305, 226);
INSERT INTO public.who_global_data VALUES (72164, 9, 542, 0, 1, 305, 79);
INSERT INTO public.who_global_data VALUES (72165, 7, 548, 0, 19, 305, 56);
INSERT INTO public.who_global_data VALUES (72166, 0, 0, 0, 0, 305, 117);
INSERT INTO public.who_global_data VALUES (72167, 1, 14, 0, 3, 305, 152);
INSERT INTO public.who_global_data VALUES (72168, 1, 19, 0, 1, 305, 16);
INSERT INTO public.who_global_data VALUES (72169, 1, 79, 0, 1, 305, 10);
INSERT INTO public.who_global_data VALUES (72170, 33, 783, 6, 20, 305, 201);
INSERT INTO public.who_global_data VALUES (72171, 39, 2843, 5, 41, 305, 174);
INSERT INTO public.who_global_data VALUES (72172, 8, 85, 0, 0, 305, 119);
INSERT INTO public.who_global_data VALUES (72173, 0, 4, 0, 0, 305, 168);
INSERT INTO public.who_global_data VALUES (72174, 131, 3793, 1, 62, 305, 99);
INSERT INTO public.who_global_data VALUES (72175, 0, 19, 0, 0, 305, 171);
INSERT INTO public.who_global_data VALUES (72176, 0, 39, 0, 4, 305, 87);
INSERT INTO public.who_global_data VALUES (72177, 52, 293, 0, 0, 305, 123);
INSERT INTO public.who_global_data VALUES (72178, 0, 0, 0, 0, 305, 151);
INSERT INTO public.who_global_data VALUES (72179, 4, 149, 1, 4, 305, 213);
INSERT INTO public.who_global_data VALUES (72180, 0, 6, 0, 1, 305, 118);
INSERT INTO public.who_global_data VALUES (72181, 17, 244, 0, 7, 305, 134);
INSERT INTO public.who_global_data VALUES (72182, 17, 164, 0, 2, 305, 65);
INSERT INTO public.who_global_data VALUES (72183, 253, 2143, 15, 94, 305, 102);
INSERT INTO public.who_global_data VALUES (72184, 0, 0, 0, 0, 305, 223);
INSERT INTO public.who_global_data VALUES (72185, 1, 52, 0, 0, 305, 4);
INSERT INTO public.who_global_data VALUES (72186, 0, 15, 0, 0, 305, 146);
INSERT INTO public.who_global_data VALUES (72187, 9, 248, 0, 2, 305, 31);
INSERT INTO public.who_global_data VALUES (72188, 0, 6, 0, 0, 305, 127);
INSERT INTO public.who_global_data VALUES (72189, 28, 1141, 12, 83, 305, 22);
INSERT INTO public.who_global_data VALUES (72190, 0, 10, 0, 0, 305, 115);
INSERT INTO public.who_global_data VALUES (72191, 1, 22, 0, 1, 305, 106);
INSERT INTO public.who_global_data VALUES (72192, 0, 16, 0, 0, 305, 90);
INSERT INTO public.who_global_data VALUES (72193, 0, 0, 0, 0, 305, 70);
INSERT INTO public.who_global_data VALUES (72194, 0, 9, 0, 0, 305, 46);
INSERT INTO public.who_global_data VALUES (72195, 945, 18609, 91, 1818, 305, 139);
INSERT INTO public.who_global_data VALUES (72196, 0, 18, 0, 0, 305, 42);
INSERT INTO public.who_global_data VALUES (72197, 32, 943, 0, 1, 305, 80);
INSERT INTO public.who_global_data VALUES (72198, 1, 6, 0, 1, 305, 203);
INSERT INTO public.who_global_data VALUES (72199, 69, 253, 0, 10, 305, 136);
INSERT INTO public.who_global_data VALUES (72200, 0, 232, 0, 5, 305, 63);
INSERT INTO public.who_global_data VALUES (72201, 0, 0, 0, 0, 305, 17);
INSERT INTO public.who_global_data VALUES (72202, 0, 8, 0, 1, 305, 172);
INSERT INTO public.who_global_data VALUES (72203, 15, 570, 3, 21, 305, 109);
INSERT INTO public.who_global_data VALUES (72204, 115, 5755, 1, 59, 305, 200);
INSERT INTO public.who_global_data VALUES (72205, 1, 254, 0, 1, 305, 93);
INSERT INTO public.who_global_data VALUES (72206, 40, 371, 0, 2, 305, 5);
INSERT INTO public.who_global_data VALUES (72207, 0, 712, 0, 11, 305, 214);
INSERT INTO public.who_global_data VALUES (72208, 581, 4005, 4, 54, 305, 204);
INSERT INTO public.who_global_data VALUES (72209, 0, 0, 0, 0, 305, 198);
INSERT INTO public.who_global_data VALUES (72210, 187, 1988, 8, 54, 305, 173);
INSERT INTO public.who_global_data VALUES (72211, 0, 1, 0, 0, 305, 229);
INSERT INTO public.who_global_data VALUES (72212, 9, 113, 2, 5, 305, 76);
INSERT INTO public.who_global_data VALUES (72213, 535, 2281, 10, 83, 305, 138);
INSERT INTO public.who_global_data VALUES (72214, 414, 3660, 11, 163, 305, 98);
INSERT INTO public.who_global_data VALUES (72215, 0, 0, 0, 0, 305, 103);
INSERT INTO public.who_global_data VALUES (72216, 311, 4413, 13, 107, 305, 225);
INSERT INTO public.who_global_data VALUES (72217, 452, 11730, 16, 311, 305, 131);
INSERT INTO public.who_global_data VALUES (72218, 61, 513, 3, 21, 305, 235);
INSERT INTO public.who_global_data VALUES (72219, 228, 1832, 0, 4, 305, 137);
INSERT INTO public.who_global_data VALUES (72220, 47, 10331, 6, 192, 305, 81);
INSERT INTO public.who_global_data VALUES (72221, 101, 965, 4, 19, 305, 182);
INSERT INTO public.who_global_data VALUES (72222, 5, 349, 0, 0, 305, 145);
INSERT INTO public.who_global_data VALUES (72223, 193, 4057, 9, 157, 305, 26);
INSERT INTO public.who_global_data VALUES (72224, 954, 6343, 2, 47, 305, 170);
INSERT INTO public.who_global_data VALUES (72225, 2, 104, 0, 0, 305, 191);
INSERT INTO public.who_global_data VALUES (72226, 0, 0, 0, 0, 305, 221);
INSERT INTO public.who_global_data VALUES (72227, 0, 6, 0, 0, 305, 64);
INSERT INTO public.who_global_data VALUES (72228, 0, 0, 0, 0, 305, 116);
INSERT INTO public.who_global_data VALUES (72229, 1, 10, 0, 0, 305, 128);
INSERT INTO public.who_global_data VALUES (72230, 0, 14, 0, 0, 305, 6);
INSERT INTO public.who_global_data VALUES (72231, 2, 31, 0, 2, 305, 227);
INSERT INTO public.who_global_data VALUES (72232, 0, 0, 0, 0, 305, 68);
INSERT INTO public.who_global_data VALUES (72233, 4, 7, 0, 0, 305, 184);
INSERT INTO public.who_global_data VALUES (72234, 0, 0, 0, 0, 305, 82);
INSERT INTO public.who_global_data VALUES (72235, 11, 277, 0, 32, 305, 149);
INSERT INTO public.who_global_data VALUES (72236, 0, 4, 0, 0, 305, 197);
INSERT INTO public.who_global_data VALUES (72237, 272, 2795, 3, 41, 305, 78);
INSERT INTO public.who_global_data VALUES (72238, 0, 226, 0, 2, 305, 233);
INSERT INTO public.who_global_data VALUES (72239, 292, 2200, 7, 58, 305, 133);
INSERT INTO public.who_global_data VALUES (72240, 1, 11, 0, 0, 305, 35);
INSERT INTO public.who_global_data VALUES (72241, 0, 6, 0, 0, 305, 114);
INSERT INTO public.who_global_data VALUES (72242, 66, 1375, 0, 6, 305, 237);
INSERT INTO public.who_global_data VALUES (72243, 0, 2, 0, 0, 305, 55);
INSERT INTO public.who_global_data VALUES (72244, 14, 37, 4, 6, 305, 176);
INSERT INTO public.who_global_data VALUES (72245, 49, 534, 2, 2, 305, 202);
INSERT INTO public.who_global_data VALUES (72246, 35, 1056, 7, 40, 305, 155);
INSERT INTO public.who_global_data VALUES (72247, 0, 0, 0, 0, 305, 32);
INSERT INTO public.who_global_data VALUES (72248, 0, 7, 0, 0, 305, 220);
INSERT INTO public.who_global_data VALUES (72249, 31, 1686, 1, 12, 305, 30);
INSERT INTO public.who_global_data VALUES (72250, 0, 1, 0, 0, 305, 147);
INSERT INTO public.who_global_data VALUES (72251, 3146, 152957, 750, 14419, 305, 208);
INSERT INTO public.who_global_data VALUES (72252, 4, 180, 1, 6, 305, 45);
INSERT INTO public.who_global_data VALUES (72253, 2, 14, 0, 2, 305, 110);
INSERT INTO public.who_global_data VALUES (72254, 0, 10, 1, 1, 305, 88);
INSERT INTO public.who_global_data VALUES (72255, 340, 7172, 85, 690, 305, 51);
INSERT INTO public.who_global_data VALUES (72256, 924, 23548, 50, 812, 305, 209);
INSERT INTO public.who_global_data VALUES (72257, 0, 19, 0, 2, 305, 205);
INSERT INTO public.who_global_data VALUES (72258, 0, 0, 0, 0, 305, 18);
INSERT INTO public.who_global_data VALUES (72259, 38, 2258, 1, 27, 305, 72);
INSERT INTO public.who_global_data VALUES (72260, 3592, 60772, 567, 6440, 305, 44);
INSERT INTO public.who_global_data VALUES (72261, 0, 1, 0, 0, 305, 15);
INSERT INTO public.who_global_data VALUES (72262, 0, 44, 0, 3, 305, 25);
INSERT INTO public.who_global_data VALUES (72263, 0, 0, 0, 0, 305, 179);
INSERT INTO public.who_global_data VALUES (72264, 0, 0, 0, 0, 305, 34);
INSERT INTO public.who_global_data VALUES (72265, 2, 105, 2, 8, 305, 207);
INSERT INTO public.who_global_data VALUES (72266, 22, 596, 0, 22, 305, 166);
INSERT INTO public.who_global_data VALUES (72267, 3148, 30217, 75, 649, 305, 126);
INSERT INTO public.who_global_data VALUES (72268, 0, 0, 0, 0, 305, 97);
INSERT INTO public.who_global_data VALUES (72269, 0, 5, 0, 1, 305, 36);
INSERT INTO public.who_global_data VALUES (72270, 0, 0, 0, 0, 305, 125);
INSERT INTO public.who_global_data VALUES (72271, 4, 52, 0, 0, 305, 124);
INSERT INTO public.who_global_data VALUES (72272, 143, 1462, 7, 45, 305, 185);
INSERT INTO public.who_global_data VALUES (72273, 0, 2076, 0, 11, 305, 194);
INSERT INTO public.who_global_data VALUES (72274, 2, 24, 0, 1, 305, 144);
INSERT INTO public.who_global_data VALUES (72275, 26493, 333811, 1201, 9559, 305, 19);
INSERT INTO public.who_global_data VALUES (72276, 1, 43, 1, 1, 305, 217);
INSERT INTO public.who_global_data VALUES (72277, 6, 406, 1, 6, 305, 148);
INSERT INTO public.who_global_data VALUES (72278, 82, 472, 0, 2, 305, 86);
INSERT INTO public.who_global_data VALUES (72279, 0, 0, 0, 0, 305, 13);
INSERT INTO public.who_global_data VALUES (72280, 15, 159, 0, 3, 305, 157);
INSERT INTO public.who_global_data VALUES (72281, 4, 245, 0, 0, 305, 8);
INSERT INTO public.who_global_data VALUES (72282, 0, 0, 0, 0, 305, 73);
INSERT INTO public.who_global_data VALUES (72283, 0, 0, 0, 0, 305, 101);
INSERT INTO public.who_global_data VALUES (72284, 0, 39, 0, 1, 305, 165);
INSERT INTO public.who_global_data VALUES (72285, 0, 9, 0, 1, 305, 14);
INSERT INTO public.who_global_data VALUES (72286, 38, 337, 0, 7, 306, 193);
INSERT INTO public.who_global_data VALUES (72287, 44, 339, 3, 20, 306, 113);
INSERT INTO public.who_global_data VALUES (72288, 0, 1251, 0, 130, 306, 143);
INSERT INTO public.who_global_data VALUES (72289, 0, 0, 0, 0, 306, 219);
INSERT INTO public.who_global_data VALUES (72290, 57, 523, 0, 17, 306, 186);
INSERT INTO public.who_global_data VALUES (72291, 4, 14, 0, 2, 306, 52);
INSERT INTO public.who_global_data VALUES (72292, 0, 3, 0, 0, 306, 180);
INSERT INTO public.who_global_data VALUES (72293, 0, 7, 0, 0, 306, 167);
INSERT INTO public.who_global_data VALUES (72294, 98, 1451, 2, 44, 306, 154);
INSERT INTO public.who_global_data VALUES (72295, 52, 798, 0, 7, 306, 94);
INSERT INTO public.who_global_data VALUES (72296, 0, 64, 0, 0, 306, 66);
INSERT INTO public.who_global_data VALUES (72297, 160, 5795, 5, 39, 306, 58);
INSERT INTO public.who_global_data VALUES (72298, 217, 11983, 18, 204, 306, 163);
INSERT INTO public.who_global_data VALUES (72299, 72, 584, 0, 5, 306, 37);
INSERT INTO public.who_global_data VALUES (72300, 4, 28, 1, 4, 306, 142);
INSERT INTO public.who_global_data VALUES (72301, 25, 723, 0, 4, 306, 83);
INSERT INTO public.who_global_data VALUES (72302, 35, 123, 4, 12, 306, 228);
INSERT INTO public.who_global_data VALUES (72303, 0, 51, 0, 0, 306, 188);
INSERT INTO public.who_global_data VALUES (72304, 122, 562, 4, 8, 306, 62);
INSERT INTO public.who_global_data VALUES (72305, 665, 23352, 247, 2586, 306, 160);
INSERT INTO public.who_global_data VALUES (72306, 1, 5, 0, 0, 306, 50);
INSERT INTO public.who_global_data VALUES (72307, 9, 22, 0, 0, 306, 33);
INSERT INTO public.who_global_data VALUES (72308, 2, 37, 0, 0, 306, 183);
INSERT INTO public.who_global_data VALUES (72309, 0, 5, 0, 0, 306, 92);
INSERT INTO public.who_global_data VALUES (72310, 18, 157, 0, 10, 306, 158);
INSERT INTO public.who_global_data VALUES (72311, 0, 0, 0, 0, 306, 67);
INSERT INTO public.who_global_data VALUES (72312, 30, 662, 0, 21, 306, 57);
INSERT INTO public.who_global_data VALUES (72313, 0, 4, 0, 1, 306, 38);
INSERT INTO public.who_global_data VALUES (72314, 1222, 10278, 73, 432, 306, 141);
INSERT INTO public.who_global_data VALUES (72315, 0, 3, 0, 0, 306, 178);
INSERT INTO public.who_global_data VALUES (72316, 0, 135, 0, 1, 306, 108);
INSERT INTO public.who_global_data VALUES (72317, 28, 531, 3, 20, 306, 39);
INSERT INTO public.who_global_data VALUES (72318, 43, 345, 2, 17, 306, 2);
INSERT INTO public.who_global_data VALUES (72319, 0, 3, 0, 0, 306, 195);
INSERT INTO public.who_global_data VALUES (72320, 0, 5, 0, 1, 306, 107);
INSERT INTO public.who_global_data VALUES (72321, 0, 114, 0, 0, 306, 161);
INSERT INTO public.who_global_data VALUES (72322, 0, 555, 0, 9, 306, 212);
INSERT INTO public.who_global_data VALUES (72323, 966, 13904, 17, 231, 306, 181);
INSERT INTO public.who_global_data VALUES (72324, 7, 35, 0, 1, 306, 53);
INSERT INTO public.who_global_data VALUES (72325, 0, 9, 0, 0, 306, 164);
INSERT INTO public.who_global_data VALUES (72326, 2, 9, 0, 0, 306, 140);
INSERT INTO public.who_global_data VALUES (72327, 310, 4471, 7, 34, 306, 20);
INSERT INTO public.who_global_data VALUES (72328, 75, 83005, 2, 3340, 306, 112);
INSERT INTO public.who_global_data VALUES (72329, 139, 1406, 7, 32, 306, 111);
INSERT INTO public.who_global_data VALUES (72330, 0, 0, 0, 0, 306, 71);
INSERT INTO public.who_global_data VALUES (72331, 0, 45, 0, 5, 306, 218);
INSERT INTO public.who_global_data VALUES (72332, 0, 0, 0, 0, 306, 43);
INSERT INTO public.who_global_data VALUES (72333, 19, 435, 0, 2, 306, 49);
INSERT INTO public.who_global_data VALUES (72334, 16, 261, 0, 2, 306, 1);
INSERT INTO public.who_global_data VALUES (72335, 56, 1182, 3, 15, 306, 48);
INSERT INTO public.who_global_data VALUES (72336, 32, 320, 2, 8, 306, 232);
INSERT INTO public.who_global_data VALUES (72337, 0, 11, 0, 1, 306, 175);
INSERT INTO public.who_global_data VALUES (72338, 20, 446, 0, 9, 306, 21);
INSERT INTO public.who_global_data VALUES (72339, 115, 4587, 8, 67, 306, 156);
INSERT INTO public.who_global_data VALUES (72340, 0, 0, 0, 0, 306, 95);
INSERT INTO public.who_global_data VALUES (72341, 13, 161, 2, 18, 306, 177);
INSERT INTO public.who_global_data VALUES (72342, 292, 4369, 18, 179, 306, 210);
INSERT INTO public.who_global_data VALUES (72343, 31, 90, 0, 0, 306, 120);
INSERT INTO public.who_global_data VALUES (72344, 0, 11, 0, 0, 306, 135);
INSERT INTO public.who_global_data VALUES (72345, 0, 1488, 0, 68, 306, 206);
INSERT INTO public.who_global_data VALUES (72346, 0, 3465, 0, 172, 306, 189);
INSERT INTO public.who_global_data VALUES (72347, 103, 1173, 7, 78, 306, 129);
INSERT INTO public.who_global_data VALUES (72348, 6, 62, 0, 3, 306, 121);
INSERT INTO public.who_global_data VALUES (72349, 0, 16, 0, 0, 306, 59);
INSERT INTO public.who_global_data VALUES (72350, 9, 29, 0, 0, 306, 96);
INSERT INTO public.who_global_data VALUES (72351, 79, 1097, 2, 15, 306, 41);
INSERT INTO public.who_global_data VALUES (72352, 0, 9, 0, 0, 306, 216);
INSERT INTO public.who_global_data VALUES (72353, 5, 43, 1, 1, 306, 236);
INSERT INTO public.who_global_data VALUES (72354, 1, 2, 0, 0, 306, 150);
INSERT INTO public.who_global_data VALUES (72355, 0, 181, 0, 0, 306, 61);
INSERT INTO public.who_global_data VALUES (72356, 2, 14, 0, 0, 306, 7);
INSERT INTO public.who_global_data VALUES (72357, 45, 1927, 2, 27, 306, 169);
INSERT INTO public.who_global_data VALUES (72358, 1850, 69607, 518, 8064, 306, 28);
INSERT INTO public.who_global_data VALUES (72359, 4, 66, 0, 0, 306, 85);
INSERT INTO public.who_global_data VALUES (72360, 1, 41, 0, 0, 306, 211);
INSERT INTO public.who_global_data VALUES (72361, 0, 21, 0, 1, 306, 60);
INSERT INTO public.who_global_data VALUES (72362, 0, 4, 0, 1, 306, 3);
INSERT INTO public.who_global_data VALUES (72363, 18, 188, 1, 2, 306, 11);
INSERT INTO public.who_global_data VALUES (72364, 3677, 95391, 92, 1434, 306, 89);
INSERT INTO public.who_global_data VALUES (72365, 9, 214, 1, 5, 306, 24);
INSERT INTO public.who_global_data VALUES (72366, 5, 103, 0, 0, 306, 162);
INSERT INTO public.who_global_data VALUES (72367, 62, 1735, 5, 73, 306, 100);
INSERT INTO public.who_global_data VALUES (72368, 1, 11, 0, 0, 306, 47);
INSERT INTO public.who_global_data VALUES (72369, 0, 12, 0, 0, 306, 29);
INSERT INTO public.who_global_data VALUES (72370, 4, 134, 0, 7, 306, 40);
INSERT INTO public.who_global_data VALUES (72371, 19, 112, 0, 4, 306, 222);
INSERT INTO public.who_global_data VALUES (72372, 11, 61, 1, 2, 306, 132);
INSERT INTO public.who_global_data VALUES (72373, 18, 154, 1, 3, 306, 130);
INSERT INTO public.who_global_data VALUES (72374, 0, 111, 0, 0, 306, 234);
INSERT INTO public.who_global_data VALUES (72375, 0, 18, 0, 0, 306, 23);
INSERT INTO public.who_global_data VALUES (72376, 1, 24, 0, 4, 306, 192);
INSERT INTO public.who_global_data VALUES (72377, 3, 21, 0, 0, 306, 69);
INSERT INTO public.who_global_data VALUES (72378, 0, 7, 0, 0, 306, 187);
INSERT INTO public.who_global_data VALUES (72379, 4, 268, 7, 22, 306, 230);
INSERT INTO public.who_global_data VALUES (72380, 11, 744, 4, 38, 306, 77);
INSERT INTO public.who_global_data VALUES (72381, 69, 1486, 0, 4, 306, 9);
INSERT INTO public.who_global_data VALUES (72382, 693, 4067, 32, 109, 306, 74);
INSERT INTO public.who_global_data VALUES (72383, 218, 2491, 11, 209, 306, 224);
INSERT INTO public.who_global_data VALUES (72384, 2274, 60500, 136, 3739, 306, 199);
INSERT INTO public.who_global_data VALUES (72385, 70, 1031, 3, 64, 306, 190);
INSERT INTO public.who_global_data VALUES (72386, 507, 5111, 21, 158, 306, 12);
INSERT INTO public.who_global_data VALUES (72387, 1, 127, 0, 1, 306, 104);
INSERT INTO public.who_global_data VALUES (72388, 428, 8162, 6, 49, 306, 153);
INSERT INTO public.who_global_data VALUES (72389, 4316, 128948, 527, 15889, 306, 91);
INSERT INTO public.who_global_data VALUES (72390, 2, 55, 0, 3, 306, 215);
INSERT INTO public.who_global_data VALUES (72391, 383, 3654, 3, 73, 306, 84);
INSERT INTO public.who_global_data VALUES (72392, 32, 155, 0, 3, 306, 231);
INSERT INTO public.who_global_data VALUES (72393, 22, 345, 0, 5, 306, 196);
INSERT INTO public.who_global_data VALUES (72394, 66, 670, 1, 6, 306, 105);
INSERT INTO public.who_global_data VALUES (72395, 20, 142, 0, 4, 306, 122);
INSERT INTO public.who_global_data VALUES (72396, 0, 0, 0, 0, 306, 159);
INSERT INTO public.who_global_data VALUES (72397, 5, 145, 0, 1, 306, 75);
INSERT INTO public.who_global_data VALUES (72398, 109, 665, 0, 1, 306, 27);
INSERT INTO public.who_global_data VALUES (72399, 69, 216, 3, 4, 306, 54);
INSERT INTO public.who_global_data VALUES (72400, 1, 11, 0, 0, 306, 226);
INSERT INTO public.who_global_data VALUES (72401, 24, 533, 0, 1, 306, 79);
INSERT INTO public.who_global_data VALUES (72402, 14, 541, 1, 19, 306, 56);
INSERT INTO public.who_global_data VALUES (72403, 0, 0, 0, 0, 306, 117);
INSERT INTO public.who_global_data VALUES (72404, 3, 13, 2, 3, 306, 152);
INSERT INTO public.who_global_data VALUES (72405, 0, 18, 0, 1, 306, 16);
INSERT INTO public.who_global_data VALUES (72406, 0, 78, 0, 1, 306, 10);
INSERT INTO public.who_global_data VALUES (72407, 34, 750, 2, 14, 306, 201);
INSERT INTO public.who_global_data VALUES (72408, 75, 2804, 5, 36, 306, 174);
INSERT INTO public.who_global_data VALUES (72409, 7, 77, 0, 0, 306, 119);
INSERT INTO public.who_global_data VALUES (72410, 1, 4, 0, 0, 306, 168);
INSERT INTO public.who_global_data VALUES (72411, 179, 3662, 4, 61, 306, 99);
INSERT INTO public.who_global_data VALUES (72412, 0, 19, 0, 0, 306, 171);
INSERT INTO public.who_global_data VALUES (72413, 0, 39, 0, 4, 306, 87);
INSERT INTO public.who_global_data VALUES (72414, 14, 241, 0, 0, 306, 123);
INSERT INTO public.who_global_data VALUES (72415, 0, 0, 0, 0, 306, 151);
INSERT INTO public.who_global_data VALUES (72416, 0, 145, 0, 3, 306, 213);
INSERT INTO public.who_global_data VALUES (72417, 0, 6, 0, 1, 306, 118);
INSERT INTO public.who_global_data VALUES (72418, 31, 227, 0, 7, 306, 134);
INSERT INTO public.who_global_data VALUES (72419, 0, 147, 0, 2, 306, 65);
INSERT INTO public.who_global_data VALUES (72420, 202, 1890, 19, 79, 306, 102);
INSERT INTO public.who_global_data VALUES (72421, 0, 0, 0, 0, 306, 223);
INSERT INTO public.who_global_data VALUES (72422, 3, 51, 0, 0, 306, 4);
INSERT INTO public.who_global_data VALUES (72423, 1, 15, 0, 0, 306, 146);
INSERT INTO public.who_global_data VALUES (72424, 16, 239, 0, 2, 306, 31);
INSERT INTO public.who_global_data VALUES (72425, 0, 6, 0, 0, 306, 127);
INSERT INTO public.who_global_data VALUES (72426, 153, 1113, 5, 71, 306, 22);
INSERT INTO public.who_global_data VALUES (72427, 0, 10, 0, 0, 306, 115);
INSERT INTO public.who_global_data VALUES (72428, 0, 21, 0, 1, 306, 106);
INSERT INTO public.who_global_data VALUES (72429, 2, 16, 0, 0, 306, 90);
INSERT INTO public.who_global_data VALUES (72430, 0, 0, 0, 0, 306, 70);
INSERT INTO public.who_global_data VALUES (72431, 0, 9, 0, 0, 306, 46);
INSERT INTO public.who_global_data VALUES (72432, 1099, 17664, 103, 1727, 306, 139);
INSERT INTO public.who_global_data VALUES (72433, 0, 18, 0, 0, 306, 42);
INSERT INTO public.who_global_data VALUES (72434, 39, 911, 0, 1, 306, 80);
INSERT INTO public.who_global_data VALUES (72435, 0, 5, 0, 1, 306, 203);
INSERT INTO public.who_global_data VALUES (72436, 40, 184, 2, 10, 306, 136);
INSERT INTO public.who_global_data VALUES (72437, 24, 232, 1, 5, 306, 63);
INSERT INTO public.who_global_data VALUES (72438, 0, 0, 0, 0, 306, 17);
INSERT INTO public.who_global_data VALUES (72439, 0, 8, 0, 1, 306, 172);
INSERT INTO public.who_global_data VALUES (72440, 72, 555, 1, 18, 306, 109);
INSERT INTO public.who_global_data VALUES (72441, 130, 5640, 8, 58, 306, 200);
INSERT INTO public.who_global_data VALUES (72442, 36, 253, 0, 1, 306, 93);
INSERT INTO public.who_global_data VALUES (72443, 33, 331, 0, 2, 306, 5);
INSERT INTO public.who_global_data VALUES (72444, 0, 712, 0, 11, 306, 214);
INSERT INTO public.who_global_data VALUES (72445, 365, 3424, 5, 50, 306, 204);
INSERT INTO public.who_global_data VALUES (72446, 0, 0, 0, 0, 306, 198);
INSERT INTO public.who_global_data VALUES (72447, 128, 1801, 5, 46, 306, 173);
INSERT INTO public.who_global_data VALUES (72448, 0, 1, 0, 0, 306, 229);
INSERT INTO public.who_global_data VALUES (72449, 8, 104, 0, 3, 306, 76);
INSERT INTO public.who_global_data VALUES (72450, 151, 1746, 12, 73, 306, 138);
INSERT INTO public.who_global_data VALUES (72451, 152, 3246, 8, 152, 306, 98);
INSERT INTO public.who_global_data VALUES (72452, 0, 0, 0, 0, 306, 103);
INSERT INTO public.who_global_data VALUES (72453, 475, 4102, 15, 94, 306, 225);
INSERT INTO public.who_global_data VALUES (72454, 754, 11278, 29, 295, 306, 131);
INSERT INTO public.who_global_data VALUES (72455, 0, 452, 0, 18, 306, 235);
INSERT INTO public.who_global_data VALUES (72456, 279, 1604, 1, 4, 306, 137);
INSERT INTO public.who_global_data VALUES (72457, 47, 10284, 3, 186, 306, 81);
INSERT INTO public.who_global_data VALUES (72458, 112, 864, 3, 15, 306, 182);
INSERT INTO public.who_global_data VALUES (72459, 10, 344, 0, 0, 306, 145);
INSERT INTO public.who_global_data VALUES (72460, 251, 3864, 7, 148, 306, 26);
INSERT INTO public.who_global_data VALUES (72461, 658, 5389, 2, 45, 306, 170);
INSERT INTO public.who_global_data VALUES (72462, 0, 102, 0, 0, 306, 191);
INSERT INTO public.who_global_data VALUES (72463, 0, 0, 0, 0, 306, 221);
INSERT INTO public.who_global_data VALUES (72464, 0, 6, 0, 0, 306, 64);
INSERT INTO public.who_global_data VALUES (72465, 0, 0, 0, 0, 306, 116);
INSERT INTO public.who_global_data VALUES (72466, 0, 9, 0, 0, 306, 128);
INSERT INTO public.who_global_data VALUES (72467, 1, 14, 0, 0, 306, 6);
INSERT INTO public.who_global_data VALUES (72468, 5, 29, 0, 2, 306, 227);
INSERT INTO public.who_global_data VALUES (72469, 0, 0, 0, 0, 306, 68);
INSERT INTO public.who_global_data VALUES (72470, 0, 3, 0, 0, 306, 184);
INSERT INTO public.who_global_data VALUES (72471, 0, 0, 0, 0, 306, 82);
INSERT INTO public.who_global_data VALUES (72472, 7, 266, 0, 32, 306, 149);
INSERT INTO public.who_global_data VALUES (72473, 4, 4, 0, 0, 306, 197);
INSERT INTO public.who_global_data VALUES (72474, 138, 2523, 4, 38, 306, 78);
INSERT INTO public.who_global_data VALUES (72475, 7, 226, 0, 2, 306, 233);
INSERT INTO public.who_global_data VALUES (72476, 284, 1908, 12, 51, 306, 133);
INSERT INTO public.who_global_data VALUES (72477, 0, 10, 0, 0, 306, 35);
INSERT INTO public.who_global_data VALUES (72478, 2, 6, 0, 0, 306, 114);
INSERT INTO public.who_global_data VALUES (72479, 120, 1309, 1, 6, 306, 237);
INSERT INTO public.who_global_data VALUES (72480, 0, 2, 0, 0, 306, 55);
INSERT INTO public.who_global_data VALUES (72481, 0, 23, 0, 2, 306, 176);
INSERT INTO public.who_global_data VALUES (72482, 14, 485, 0, 0, 306, 202);
INSERT INTO public.who_global_data VALUES (72483, 23, 1021, 3, 33, 306, 155);
INSERT INTO public.who_global_data VALUES (72484, 0, 0, 0, 0, 306, 32);
INSERT INTO public.who_global_data VALUES (72485, 0, 7, 0, 0, 306, 220);
INSERT INTO public.who_global_data VALUES (72486, 70, 1655, 2, 11, 306, 30);
INSERT INTO public.who_global_data VALUES (72487, 1, 1, 0, 0, 306, 147);
INSERT INTO public.who_global_data VALUES (72488, 4670, 149811, 740, 13669, 306, 208);
INSERT INTO public.who_global_data VALUES (72489, 10, 176, 0, 5, 306, 45);
INSERT INTO public.who_global_data VALUES (72490, 0, 12, 0, 2, 306, 110);
INSERT INTO public.who_global_data VALUES (72491, 0, 10, 0, 0, 306, 88);
INSERT INTO public.who_global_data VALUES (72492, 357, 6832, 70, 605, 306, 51);
INSERT INTO public.who_global_data VALUES (72493, 281, 22624, 50, 762, 306, 209);
INSERT INTO public.who_global_data VALUES (72494, 0, 19, 0, 2, 306, 205);
INSERT INTO public.who_global_data VALUES (72495, 0, 0, 0, 0, 306, 18);
INSERT INTO public.who_global_data VALUES (72496, 51, 2220, 3, 26, 306, 72);
INSERT INTO public.who_global_data VALUES (72497, 4020, 57180, 599, 5873, 306, 44);
INSERT INTO public.who_global_data VALUES (72498, 0, 1, 0, 0, 306, 15);
INSERT INTO public.who_global_data VALUES (72499, 4, 44, 0, 3, 306, 25);
INSERT INTO public.who_global_data VALUES (72500, 0, 0, 0, 0, 306, 179);
INSERT INTO public.who_global_data VALUES (72501, 0, 0, 0, 0, 306, 34);
INSERT INTO public.who_global_data VALUES (72502, 3, 103, 0, 6, 306, 207);
INSERT INTO public.who_global_data VALUES (72503, 21, 574, 3, 22, 306, 166);
INSERT INTO public.who_global_data VALUES (72504, 3135, 27069, 73, 574, 306, 126);
INSERT INTO public.who_global_data VALUES (72505, 0, 0, 0, 0, 306, 97);
INSERT INTO public.who_global_data VALUES (72506, 0, 5, 1, 1, 306, 36);
INSERT INTO public.who_global_data VALUES (72507, 0, 0, 0, 0, 306, 125);
INSERT INTO public.who_global_data VALUES (72508, 0, 48, 0, 0, 306, 124);
INSERT INTO public.who_global_data VALUES (72509, 68, 1319, 6, 38, 306, 185);
INSERT INTO public.who_global_data VALUES (72510, 571, 2076, 1, 11, 306, 194);
INSERT INTO public.who_global_data VALUES (72511, 2, 22, 0, 1, 306, 144);
INSERT INTO public.who_global_data VALUES (72512, 33510, 307318, 1338, 8358, 306, 19);
INSERT INTO public.who_global_data VALUES (72513, 2, 42, 0, 0, 306, 217);
INSERT INTO public.who_global_data VALUES (72514, 14, 400, 1, 5, 306, 148);
INSERT INTO public.who_global_data VALUES (72515, 92, 390, 0, 2, 306, 86);
INSERT INTO public.who_global_data VALUES (72516, 0, 0, 0, 0, 306, 13);
INSERT INTO public.who_global_data VALUES (72517, 0, 144, 0, 3, 306, 157);
INSERT INTO public.who_global_data VALUES (72518, 1, 241, 0, 0, 306, 8);
INSERT INTO public.who_global_data VALUES (72519, 0, 0, 0, 0, 306, 73);
INSERT INTO public.who_global_data VALUES (72520, 0, 0, 0, 0, 306, 101);
INSERT INTO public.who_global_data VALUES (72521, 0, 39, 0, 1, 306, 165);
INSERT INTO public.who_global_data VALUES (72522, 0, 9, 0, 1, 306, 14);
INSERT INTO public.who_global_data VALUES (72523, 29, 299, 2, 7, 307, 193);
INSERT INTO public.who_global_data VALUES (72524, 0, 295, 1, 17, 307, 113);
INSERT INTO public.who_global_data VALUES (72525, 80, 1251, 25, 130, 307, 143);
INSERT INTO public.who_global_data VALUES (72526, 0, 0, 0, 0, 307, 219);
INSERT INTO public.who_global_data VALUES (72527, 24, 466, 1, 17, 307, 186);
INSERT INTO public.who_global_data VALUES (72528, 0, 10, 0, 2, 307, 52);
INSERT INTO public.who_global_data VALUES (72529, 0, 3, 0, 0, 307, 180);
INSERT INTO public.who_global_data VALUES (72530, 0, 7, 0, 0, 307, 167);
INSERT INTO public.who_global_data VALUES (72531, 88, 1353, 5, 42, 307, 154);
INSERT INTO public.who_global_data VALUES (72532, 34, 746, 0, 7, 307, 94);
INSERT INTO public.who_global_data VALUES (72533, 2, 64, 0, 0, 307, 66);
INSERT INTO public.who_global_data VALUES (72534, 181, 5635, 6, 34, 307, 58);
INSERT INTO public.who_global_data VALUES (72535, 241, 11766, 18, 186, 307, 163);
INSERT INTO public.who_global_data VALUES (72536, 69, 512, 0, 5, 307, 37);
INSERT INTO public.who_global_data VALUES (72537, 0, 24, 0, 3, 307, 142);
INSERT INTO public.who_global_data VALUES (72538, 10, 698, 0, 4, 307, 83);
INSERT INTO public.who_global_data VALUES (72539, 18, 88, 0, 8, 307, 228);
INSERT INTO public.who_global_data VALUES (72540, 6, 51, 0, 0, 307, 188);
INSERT INTO public.who_global_data VALUES (72541, 186, 440, 0, 4, 307, 62);
INSERT INTO public.who_global_data VALUES (72542, 922, 22687, 271, 2339, 307, 160);
INSERT INTO public.who_global_data VALUES (72543, 1, 4, 0, 0, 307, 50);
INSERT INTO public.who_global_data VALUES (72544, 0, 13, 0, 0, 307, 33);
INSERT INTO public.who_global_data VALUES (72545, 0, 35, 0, 0, 307, 183);
INSERT INTO public.who_global_data VALUES (72546, 0, 5, 0, 0, 307, 92);
INSERT INTO public.who_global_data VALUES (72547, 7, 139, 1, 10, 307, 158);
INSERT INTO public.who_global_data VALUES (72548, 0, 0, 0, 0, 307, 67);
INSERT INTO public.who_global_data VALUES (72549, 46, 632, 3, 21, 307, 57);
INSERT INTO public.who_global_data VALUES (72550, 0, 4, 0, 1, 307, 38);
INSERT INTO public.who_global_data VALUES (72551, 1146, 9056, 60, 359, 307, 141);
INSERT INTO public.who_global_data VALUES (72552, 0, 3, 0, 0, 307, 178);
INSERT INTO public.who_global_data VALUES (72553, 1, 135, 0, 1, 307, 108);
INSERT INTO public.who_global_data VALUES (72554, 18, 503, 3, 17, 307, 39);
INSERT INTO public.who_global_data VALUES (72555, 0, 302, 0, 15, 307, 2);
INSERT INTO public.who_global_data VALUES (72556, 0, 3, 0, 0, 307, 195);
INSERT INTO public.who_global_data VALUES (72557, 0, 5, 0, 1, 307, 107);
INSERT INTO public.who_global_data VALUES (72558, 0, 114, 0, 0, 307, 161);
INSERT INTO public.who_global_data VALUES (72559, 46, 555, 1, 9, 307, 212);
INSERT INTO public.who_global_data VALUES (72560, 1206, 12938, 62, 214, 307, 181);
INSERT INTO public.who_global_data VALUES (72561, 0, 28, 0, 1, 307, 53);
INSERT INTO public.who_global_data VALUES (72562, 1, 9, 0, 0, 307, 164);
INSERT INTO public.who_global_data VALUES (72563, 0, 7, 0, 0, 307, 140);
INSERT INTO public.who_global_data VALUES (72564, 424, 4161, 5, 27, 307, 20);
INSERT INTO public.who_global_data VALUES (72565, 55, 82930, 3, 3338, 307, 112);
INSERT INTO public.who_global_data VALUES (72566, 106, 1267, 6, 25, 307, 111);
INSERT INTO public.who_global_data VALUES (72567, 0, 0, 0, 0, 307, 71);
INSERT INTO public.who_global_data VALUES (72568, 4, 45, 2, 5, 307, 218);
INSERT INTO public.who_global_data VALUES (72569, 0, 0, 0, 0, 307, 43);
INSERT INTO public.who_global_data VALUES (72570, 20, 416, 0, 2, 307, 49);
INSERT INTO public.who_global_data VALUES (72571, 27, 245, 1, 2, 307, 1);
INSERT INTO public.who_global_data VALUES (72572, 47, 1126, 4, 12, 307, 48);
INSERT INTO public.who_global_data VALUES (72573, 19, 288, 0, 6, 307, 232);
INSERT INTO public.who_global_data VALUES (72574, 0, 11, 0, 1, 307, 175);
INSERT INTO public.who_global_data VALUES (72575, 30, 426, 0, 9, 307, 21);
INSERT INTO public.who_global_data VALUES (72576, 282, 4472, 6, 59, 307, 156);
INSERT INTO public.who_global_data VALUES (72577, 0, 0, 0, 0, 307, 95);
INSERT INTO public.who_global_data VALUES (72578, 0, 148, 0, 16, 307, 177);
INSERT INTO public.who_global_data VALUES (72579, 320, 4077, 22, 161, 307, 210);
INSERT INTO public.who_global_data VALUES (72580, 8, 59, 0, 0, 307, 120);
INSERT INTO public.who_global_data VALUES (72581, 0, 11, 0, 0, 307, 135);
INSERT INTO public.who_global_data VALUES (72582, 0, 1488, 0, 68, 307, 206);
INSERT INTO public.who_global_data VALUES (72583, 302, 3465, 52, 172, 307, 189);
INSERT INTO public.who_global_data VALUES (72584, 85, 1070, 5, 71, 307, 129);
INSERT INTO public.who_global_data VALUES (72585, 10, 56, 1, 3, 307, 121);
INSERT INTO public.who_global_data VALUES (72586, 1, 16, 0, 0, 307, 59);
INSERT INTO public.who_global_data VALUES (72587, 0, 20, 0, 0, 307, 96);
INSERT INTO public.who_global_data VALUES (72588, 57, 1018, 1, 13, 307, 41);
INSERT INTO public.who_global_data VALUES (72589, 0, 9, 0, 0, 307, 216);
INSERT INTO public.who_global_data VALUES (72590, 3, 38, 0, 0, 307, 236);
INSERT INTO public.who_global_data VALUES (72591, 1, 1, 0, 0, 307, 150);
INSERT INTO public.who_global_data VALUES (72592, 2, 181, 0, 0, 307, 61);
INSERT INTO public.who_global_data VALUES (72593, 5, 12, 0, 0, 307, 7);
INSERT INTO public.who_global_data VALUES (72594, 267, 1882, 5, 25, 307, 169);
INSERT INTO public.who_global_data VALUES (72595, 4221, 67757, 1053, 7546, 307, 28);
INSERT INTO public.who_global_data VALUES (72596, 5, 62, 0, 0, 307, 85);
INSERT INTO public.who_global_data VALUES (72597, 1, 40, 0, 0, 307, 211);
INSERT INTO public.who_global_data VALUES (72598, 0, 21, 0, 1, 307, 60);
INSERT INTO public.who_global_data VALUES (72599, 0, 4, 0, 1, 307, 3);
INSERT INTO public.who_global_data VALUES (72600, 13, 170, 1, 1, 307, 11);
INSERT INTO public.who_global_data VALUES (72601, 5936, 91714, 184, 1342, 307, 89);
INSERT INTO public.who_global_data VALUES (72602, 0, 205, 0, 4, 307, 24);
INSERT INTO public.who_global_data VALUES (72603, 3, 98, 0, 0, 307, 162);
INSERT INTO public.who_global_data VALUES (72604, 60, 1673, 9, 68, 307, 100);
INSERT INTO public.who_global_data VALUES (72605, 0, 10, 0, 0, 307, 47);
INSERT INTO public.who_global_data VALUES (72606, 2, 12, 0, 0, 307, 29);
INSERT INTO public.who_global_data VALUES (72607, 0, 130, 0, 7, 307, 40);
INSERT INTO public.who_global_data VALUES (72608, 9, 93, 1, 4, 307, 222);
INSERT INTO public.who_global_data VALUES (72609, 0, 50, 0, 1, 307, 132);
INSERT INTO public.who_global_data VALUES (72610, 22, 136, 0, 2, 307, 130);
INSERT INTO public.who_global_data VALUES (72611, 59, 111, 0, 0, 307, 234);
INSERT INTO public.who_global_data VALUES (72612, 3, 18, 0, 0, 307, 23);
INSERT INTO public.who_global_data VALUES (72613, 4, 23, 0, 4, 307, 192);
INSERT INTO public.who_global_data VALUES (72614, 0, 18, 0, 0, 307, 69);
INSERT INTO public.who_global_data VALUES (72615, 0, 7, 0, 0, 307, 187);
INSERT INTO public.who_global_data VALUES (72616, 42, 264, 0, 15, 307, 230);
INSERT INTO public.who_global_data VALUES (72617, 55, 733, 2, 34, 307, 77);
INSERT INTO public.who_global_data VALUES (72618, 53, 1417, 0, 4, 307, 9);
INSERT INTO public.who_global_data VALUES (72619, 472, 3374, 9, 77, 307, 74);
INSERT INTO public.who_global_data VALUES (72620, 181, 2273, 7, 198, 307, 224);
INSERT INTO public.who_global_data VALUES (72621, 2483, 58226, 151, 3603, 307, 199);
INSERT INTO public.who_global_data VALUES (72622, 83, 961, 5, 61, 307, 190);
INSERT INTO public.who_global_data VALUES (72623, 331, 4604, 17, 137, 307, 12);
INSERT INTO public.who_global_data VALUES (72624, 12, 126, 0, 1, 307, 104);
INSERT INTO public.who_global_data VALUES (72625, 597, 7734, 5, 43, 307, 153);
INSERT INTO public.who_global_data VALUES (72626, 4805, 124632, 681, 15362, 307, 91);
INSERT INTO public.who_global_data VALUES (72627, 6, 53, 0, 3, 307, 215);
INSERT INTO public.who_global_data VALUES (72628, 336, 3271, 1, 70, 307, 84);
INSERT INTO public.who_global_data VALUES (72629, 5, 123, 1, 3, 307, 231);
INSERT INTO public.who_global_data VALUES (72630, 13, 323, 0, 5, 307, 196);
INSERT INTO public.who_global_data VALUES (72631, 73, 604, 0, 5, 307, 105);
INSERT INTO public.who_global_data VALUES (72632, 0, 122, 0, 4, 307, 122);
INSERT INTO public.who_global_data VALUES (72633, 0, 0, 0, 0, 307, 159);
INSERT INTO public.who_global_data VALUES (72634, 8, 140, 0, 1, 307, 75);
INSERT INTO public.who_global_data VALUES (72635, 77, 556, 0, 1, 307, 27);
INSERT INTO public.who_global_data VALUES (72636, 3, 147, 0, 1, 307, 54);
INSERT INTO public.who_global_data VALUES (72637, 0, 10, 0, 0, 307, 226);
INSERT INTO public.who_global_data VALUES (72638, 16, 509, 0, 1, 307, 79);
INSERT INTO public.who_global_data VALUES (72639, 7, 527, 1, 18, 307, 56);
INSERT INTO public.who_global_data VALUES (72640, 0, 0, 0, 0, 307, 117);
INSERT INTO public.who_global_data VALUES (72641, 3, 10, 1, 1, 307, 152);
INSERT INTO public.who_global_data VALUES (72642, 1, 18, 0, 1, 307, 16);
INSERT INTO public.who_global_data VALUES (72643, 0, 78, 0, 1, 307, 10);
INSERT INTO public.who_global_data VALUES (72644, 33, 716, 1, 12, 307, 201);
INSERT INTO public.who_global_data VALUES (72645, 117, 2729, 0, 31, 307, 174);
INSERT INTO public.who_global_data VALUES (72646, 0, 70, 0, 0, 307, 119);
INSERT INTO public.who_global_data VALUES (72647, 0, 3, 0, 0, 307, 168);
INSERT INTO public.who_global_data VALUES (72648, 150, 3483, 4, 57, 307, 99);
INSERT INTO public.who_global_data VALUES (72649, 0, 19, 0, 0, 307, 171);
INSERT INTO public.who_global_data VALUES (72650, 3, 39, 1, 4, 307, 87);
INSERT INTO public.who_global_data VALUES (72651, 14, 227, 0, 0, 307, 123);
INSERT INTO public.who_global_data VALUES (72652, 0, 0, 0, 0, 307, 151);
INSERT INTO public.who_global_data VALUES (72653, 7, 145, 0, 3, 307, 213);
INSERT INTO public.who_global_data VALUES (72654, 0, 6, 0, 1, 307, 118);
INSERT INTO public.who_global_data VALUES (72655, 10, 196, 0, 7, 307, 134);
INSERT INTO public.who_global_data VALUES (72656, 19, 147, 0, 2, 307, 65);
INSERT INTO public.who_global_data VALUES (72657, 178, 1688, 10, 60, 307, 102);
INSERT INTO public.who_global_data VALUES (72658, 0, 0, 0, 0, 307, 223);
INSERT INTO public.who_global_data VALUES (72659, 1, 48, 0, 0, 307, 4);
INSERT INTO public.who_global_data VALUES (72660, 0, 14, 0, 0, 307, 146);
INSERT INTO public.who_global_data VALUES (72661, 20, 223, 0, 2, 307, 31);
INSERT INTO public.who_global_data VALUES (72662, 1, 6, 0, 0, 307, 127);
INSERT INTO public.who_global_data VALUES (72663, 102, 960, 16, 66, 307, 22);
INSERT INTO public.who_global_data VALUES (72664, 0, 10, 0, 0, 307, 115);
INSERT INTO public.who_global_data VALUES (72665, 1, 21, 0, 1, 307, 106);
INSERT INTO public.who_global_data VALUES (72666, 1, 14, 0, 0, 307, 90);
INSERT INTO public.who_global_data VALUES (72667, 0, 0, 0, 0, 307, 70);
INSERT INTO public.who_global_data VALUES (72668, 3, 9, 0, 0, 307, 46);
INSERT INTO public.who_global_data VALUES (72669, 1002, 16565, 187, 1624, 307, 139);
INSERT INTO public.who_global_data VALUES (72670, 0, 18, 0, 0, 307, 42);
INSERT INTO public.who_global_data VALUES (72671, 48, 872, 0, 1, 307, 80);
INSERT INTO public.who_global_data VALUES (72672, 0, 5, 0, 1, 307, 203);
INSERT INTO public.who_global_data VALUES (72673, 24, 144, 3, 8, 307, 136);
INSERT INTO public.who_global_data VALUES (72674, 0, 208, 0, 4, 307, 63);
INSERT INTO public.who_global_data VALUES (72675, 0, 0, 0, 0, 307, 17);
INSERT INTO public.who_global_data VALUES (72676, 0, 8, 0, 1, 307, 172);
INSERT INTO public.who_global_data VALUES (72677, 53, 483, 5, 17, 307, 109);
INSERT INTO public.who_global_data VALUES (72678, 302, 5510, 6, 50, 307, 200);
INSERT INTO public.who_global_data VALUES (72679, 12, 217, 0, 1, 307, 93);
INSERT INTO public.who_global_data VALUES (72680, 21, 298, 1, 2, 307, 5);
INSERT INTO public.who_global_data VALUES (72681, 0, 712, 0, 11, 307, 214);
INSERT INTO public.who_global_data VALUES (72682, 609, 3059, 10, 45, 307, 204);
INSERT INTO public.who_global_data VALUES (72683, 0, 0, 0, 0, 307, 198);
INSERT INTO public.who_global_data VALUES (72684, 198, 1673, 4, 41, 307, 173);
INSERT INTO public.who_global_data VALUES (72685, 0, 1, 0, 0, 307, 229);
INSERT INTO public.who_global_data VALUES (72686, 4, 96, 0, 3, 307, 76);
INSERT INTO public.who_global_data VALUES (72687, 181, 1595, 10, 61, 307, 138);
INSERT INTO public.who_global_data VALUES (72688, 76, 3094, 8, 144, 307, 98);
INSERT INTO public.who_global_data VALUES (72689, 0, 0, 0, 0, 307, 103);
INSERT INTO public.who_global_data VALUES (72690, 244, 3627, 8, 79, 307, 225);
INSERT INTO public.who_global_data VALUES (72691, 638, 10524, 20, 266, 307, 131);
INSERT INTO public.who_global_data VALUES (72692, 74, 452, 3, 18, 307, 235);
INSERT INTO public.who_global_data VALUES (72693, 250, 1325, 0, 3, 307, 137);
INSERT INTO public.who_global_data VALUES (72694, 81, 10237, 6, 183, 307, 81);
INSERT INTO public.who_global_data VALUES (72695, 161, 752, 3, 12, 307, 182);
INSERT INTO public.who_global_data VALUES (72696, 13, 334, 0, 0, 307, 145);
INSERT INTO public.who_global_data VALUES (72697, 430, 3613, 8, 141, 307, 26);
INSERT INTO public.who_global_data VALUES (72698, 582, 4731, 9, 43, 307, 170);
INSERT INTO public.who_global_data VALUES (72699, 13, 102, 0, 0, 307, 191);
INSERT INTO public.who_global_data VALUES (72700, 0, 0, 0, 0, 307, 221);
INSERT INTO public.who_global_data VALUES (72701, 0, 6, 0, 0, 307, 64);
INSERT INTO public.who_global_data VALUES (72702, 0, 0, 0, 0, 307, 116);
INSERT INTO public.who_global_data VALUES (72703, 1, 9, 0, 0, 307, 128);
INSERT INTO public.who_global_data VALUES (72704, 0, 13, 0, 0, 307, 6);
INSERT INTO public.who_global_data VALUES (72705, 2, 24, 0, 2, 307, 227);
INSERT INTO public.who_global_data VALUES (72706, 0, 0, 0, 0, 307, 68);
INSERT INTO public.who_global_data VALUES (72707, 0, 3, 0, 0, 307, 184);
INSERT INTO public.who_global_data VALUES (72708, 0, 0, 0, 0, 307, 82);
INSERT INTO public.who_global_data VALUES (72709, 7, 259, 0, 32, 307, 149);
INSERT INTO public.who_global_data VALUES (72710, 0, 0, 0, 0, 307, 197);
INSERT INTO public.who_global_data VALUES (72711, 206, 2385, 5, 34, 307, 78);
INSERT INTO public.who_global_data VALUES (72712, 0, 219, 0, 2, 307, 233);
INSERT INTO public.who_global_data VALUES (72713, 148, 1624, 0, 39, 307, 133);
INSERT INTO public.who_global_data VALUES (72714, 0, 10, 0, 0, 307, 35);
INSERT INTO public.who_global_data VALUES (72715, 2, 4, 0, 0, 307, 114);
INSERT INTO public.who_global_data VALUES (72716, 75, 1189, 0, 5, 307, 237);
INSERT INTO public.who_global_data VALUES (72717, 0, 2, 0, 0, 307, 55);
INSERT INTO public.who_global_data VALUES (72718, 0, 23, 0, 2, 307, 176);
INSERT INTO public.who_global_data VALUES (72719, 21, 471, 0, 0, 307, 202);
INSERT INTO public.who_global_data VALUES (72720, 20, 998, 4, 30, 307, 155);
INSERT INTO public.who_global_data VALUES (72721, 0, 0, 0, 0, 307, 32);
INSERT INTO public.who_global_data VALUES (72722, 0, 7, 0, 0, 307, 220);
INSERT INTO public.who_global_data VALUES (72723, 80, 1585, 2, 9, 307, 30);
INSERT INTO public.who_global_data VALUES (72724, 0, 0, 0, 0, 307, 147);
INSERT INTO public.who_global_data VALUES (72725, 6821, 145141, 786, 12929, 307, 208);
INSERT INTO public.who_global_data VALUES (72726, 7, 166, 0, 5, 307, 45);
INSERT INTO public.who_global_data VALUES (72727, 2, 12, 0, 2, 307, 110);
INSERT INTO public.who_global_data VALUES (72728, 0, 10, 0, 0, 307, 88);
INSERT INTO public.who_global_data VALUES (72729, 601, 6475, 80, 535, 307, 51);
INSERT INTO public.who_global_data VALUES (72730, 486, 22343, 55, 712, 307, 209);
INSERT INTO public.who_global_data VALUES (72731, 3, 19, 0, 2, 307, 205);
INSERT INTO public.who_global_data VALUES (72732, 0, 0, 0, 0, 307, 18);
INSERT INTO public.who_global_data VALUES (72733, 102, 2169, 3, 23, 307, 72);
INSERT INTO public.who_global_data VALUES (72734, 4911, 53160, 756, 5274, 307, 44);
INSERT INTO public.who_global_data VALUES (72735, 0, 1, 0, 0, 307, 15);
INSERT INTO public.who_global_data VALUES (72736, 1, 40, 1, 3, 307, 25);
INSERT INTO public.who_global_data VALUES (72737, 0, 0, 0, 0, 307, 179);
INSERT INTO public.who_global_data VALUES (72738, 0, 0, 0, 0, 307, 34);
INSERT INTO public.who_global_data VALUES (72739, 3, 100, 0, 6, 307, 207);
INSERT INTO public.who_global_data VALUES (72740, 58, 553, 1, 19, 307, 166);
INSERT INTO public.who_global_data VALUES (72741, 3013, 23934, 76, 501, 307, 126);
INSERT INTO public.who_global_data VALUES (72742, 0, 0, 0, 0, 307, 97);
INSERT INTO public.who_global_data VALUES (72743, 0, 5, 0, 0, 307, 36);
INSERT INTO public.who_global_data VALUES (72744, 0, 0, 0, 0, 307, 125);
INSERT INTO public.who_global_data VALUES (72745, 0, 48, 0, 0, 307, 124);
INSERT INTO public.who_global_data VALUES (72746, 155, 1251, 4, 32, 307, 185);
INSERT INTO public.who_global_data VALUES (72747, 0, 1505, 0, 10, 307, 194);
INSERT INTO public.who_global_data VALUES (72748, 0, 20, 0, 1, 307, 144);
INSERT INTO public.who_global_data VALUES (72749, 32105, 273808, 1166, 7020, 307, 19);
INSERT INTO public.who_global_data VALUES (72750, 3, 40, 0, 0, 307, 217);
INSERT INTO public.who_global_data VALUES (72751, 17, 386, 0, 4, 307, 148);
INSERT INTO public.who_global_data VALUES (72752, 57, 298, 0, 2, 307, 86);
INSERT INTO public.who_global_data VALUES (72753, 0, 0, 0, 0, 307, 13);
INSERT INTO public.who_global_data VALUES (72754, 0, 144, 0, 3, 307, 157);
INSERT INTO public.who_global_data VALUES (72755, 1, 240, 0, 0, 307, 8);
INSERT INTO public.who_global_data VALUES (72756, 0, 0, 0, 0, 307, 73);
INSERT INTO public.who_global_data VALUES (72757, 0, 0, 0, 0, 307, 101);
INSERT INTO public.who_global_data VALUES (72758, 0, 39, 0, 1, 307, 165);
INSERT INTO public.who_global_data VALUES (72759, 0, 9, 0, 1, 307, 14);
INSERT INTO public.who_global_data VALUES (72760, 1, 270, 0, 5, 308, 193);
INSERT INTO public.who_global_data VALUES (72761, 56, 295, 1, 16, 308, 113);
INSERT INTO public.who_global_data VALUES (72762, 185, 1171, 22, 105, 308, 143);
INSERT INTO public.who_global_data VALUES (72763, 0, 0, 0, 0, 308, 219);
INSERT INTO public.who_global_data VALUES (72764, 13, 442, 1, 16, 308, 186);
INSERT INTO public.who_global_data VALUES (72765, 2, 10, 0, 2, 308, 52);
INSERT INTO public.who_global_data VALUES (72766, 1, 3, 0, 0, 308, 180);
INSERT INTO public.who_global_data VALUES (72767, 0, 7, 0, 0, 308, 167);
INSERT INTO public.who_global_data VALUES (72768, 132, 1265, 6, 37, 308, 154);
INSERT INTO public.who_global_data VALUES (72769, 72, 712, 3, 7, 308, 94);
INSERT INTO public.who_global_data VALUES (72770, 2, 62, 0, 0, 308, 66);
INSERT INTO public.who_global_data VALUES (72771, 104, 5454, 2, 28, 308, 58);
INSERT INTO public.who_global_data VALUES (72772, 396, 11525, 10, 168, 308, 163);
INSERT INTO public.who_global_data VALUES (72773, 43, 443, 0, 5, 308, 37);
INSERT INTO public.who_global_data VALUES (72774, 3, 24, 2, 3, 308, 142);
INSERT INTO public.who_global_data VALUES (72775, 16, 688, 0, 4, 308, 83);
INSERT INTO public.who_global_data VALUES (72776, 9, 70, 2, 8, 308, 228);
INSERT INTO public.who_global_data VALUES (72777, 0, 45, 0, 0, 308, 188);
INSERT INTO public.who_global_data VALUES (72778, 0, 254, 0, 4, 308, 62);
INSERT INTO public.who_global_data VALUES (72779, 1694, 21765, 236, 2068, 308, 160);
INSERT INTO public.who_global_data VALUES (72780, 0, 3, 0, 0, 308, 50);
INSERT INTO public.who_global_data VALUES (72781, 0, 13, 0, 0, 308, 33);
INSERT INTO public.who_global_data VALUES (72782, 3, 35, 0, 0, 308, 183);
INSERT INTO public.who_global_data VALUES (72783, 0, 5, 0, 0, 308, 92);
INSERT INTO public.who_global_data VALUES (72784, 9, 132, 1, 9, 308, 158);
INSERT INTO public.who_global_data VALUES (72785, 0, 0, 0, 0, 308, 67);
INSERT INTO public.who_global_data VALUES (72786, 65, 586, 2, 18, 308, 57);
INSERT INTO public.who_global_data VALUES (72787, 0, 4, 0, 1, 308, 38);
INSERT INTO public.who_global_data VALUES (72788, 1074, 7910, 58, 299, 308, 141);
INSERT INTO public.who_global_data VALUES (72789, 0, 3, 0, 0, 308, 178);
INSERT INTO public.who_global_data VALUES (72790, 1, 134, 0, 1, 308, 108);
INSERT INTO public.who_global_data VALUES (72791, 28, 485, 4, 14, 308, 39);
INSERT INTO public.who_global_data VALUES (72792, 41, 302, 0, 15, 308, 2);
INSERT INTO public.who_global_data VALUES (72793, 0, 3, 0, 0, 308, 195);
INSERT INTO public.who_global_data VALUES (72794, 0, 5, 0, 1, 308, 107);
INSERT INTO public.who_global_data VALUES (72795, 4, 114, 0, 0, 308, 161);
INSERT INTO public.who_global_data VALUES (72796, 263, 509, 1, 8, 308, 212);
INSERT INTO public.who_global_data VALUES (72797, 1618, 11732, 25, 152, 308, 181);
INSERT INTO public.who_global_data VALUES (72798, 6, 28, 0, 1, 308, 53);
INSERT INTO public.who_global_data VALUES (72799, 0, 8, 0, 0, 308, 164);
INSERT INTO public.who_global_data VALUES (72800, 0, 7, 0, 0, 308, 140);
INSERT INTO public.who_global_data VALUES (72801, 333, 3737, 4, 22, 308, 20);
INSERT INTO public.who_global_data VALUES (72802, 73, 82875, 4, 3335, 308, 112);
INSERT INTO public.who_global_data VALUES (72803, 96, 1161, 2, 19, 308, 111);
INSERT INTO public.who_global_data VALUES (72804, 0, 0, 0, 0, 308, 71);
INSERT INTO public.who_global_data VALUES (72805, 0, 41, 1, 3, 308, 218);
INSERT INTO public.who_global_data VALUES (72806, 0, 0, 0, 0, 308, 43);
INSERT INTO public.who_global_data VALUES (72807, 21, 396, 0, 2, 308, 49);
INSERT INTO public.who_global_data VALUES (72808, 28, 218, 0, 1, 308, 1);
INSERT INTO public.who_global_data VALUES (72809, 68, 1079, 1, 8, 308, 48);
INSERT INTO public.who_global_data VALUES (72810, 36, 269, 0, 6, 308, 232);
INSERT INTO public.who_global_data VALUES (72811, 0, 11, 0, 1, 308, 175);
INSERT INTO public.who_global_data VALUES (72812, 40, 396, 0, 9, 308, 21);
INSERT INTO public.who_global_data VALUES (72813, 332, 4190, 9, 53, 308, 156);
INSERT INTO public.who_global_data VALUES (72814, 0, 0, 0, 0, 308, 95);
INSERT INTO public.who_global_data VALUES (72815, 14, 148, 3, 16, 308, 177);
INSERT INTO public.who_global_data VALUES (72816, 371, 3757, 16, 139, 308, 210);
INSERT INTO public.who_global_data VALUES (72817, 1, 51, 0, 0, 308, 120);
INSERT INTO public.who_global_data VALUES (72818, 0, 11, 0, 0, 308, 135);
INSERT INTO public.who_global_data VALUES (72819, 108, 1488, 8, 68, 308, 206);
INSERT INTO public.who_global_data VALUES (72820, 0, 3163, 0, 120, 308, 189);
INSERT INTO public.who_global_data VALUES (72821, 120, 985, 8, 66, 308, 129);
INSERT INTO public.who_global_data VALUES (72822, 5, 46, 0, 2, 308, 121);
INSERT INTO public.who_global_data VALUES (72823, 0, 15, 0, 0, 308, 59);
INSERT INTO public.who_global_data VALUES (72824, 0, 20, 0, 0, 308, 96);
INSERT INTO public.who_global_data VALUES (72825, 103, 961, 1, 12, 308, 41);
INSERT INTO public.who_global_data VALUES (72826, 0, 9, 0, 0, 308, 216);
INSERT INTO public.who_global_data VALUES (72827, 4, 35, 0, 0, 308, 236);
INSERT INTO public.who_global_data VALUES (72828, 0, 0, 0, 0, 308, 150);
INSERT INTO public.who_global_data VALUES (72829, 2, 179, 0, 0, 308, 61);
INSERT INTO public.who_global_data VALUES (72830, 0, 7, 0, 0, 308, 7);
INSERT INTO public.who_global_data VALUES (72831, 97, 1615, 1, 20, 308, 169);
INSERT INTO public.who_global_data VALUES (72832, 5209, 63536, 2003, 6493, 308, 28);
INSERT INTO public.who_global_data VALUES (72833, 2, 57, 0, 0, 308, 85);
INSERT INTO public.who_global_data VALUES (72834, 2, 39, 0, 0, 308, 211);
INSERT INTO public.who_global_data VALUES (72835, 3, 21, 0, 1, 308, 60);
INSERT INTO public.who_global_data VALUES (72836, 0, 4, 0, 1, 308, 3);
INSERT INTO public.who_global_data VALUES (72837, 9, 157, 0, 0, 308, 11);
INSERT INTO public.who_global_data VALUES (72838, 6082, 85778, 141, 1158, 308, 89);
INSERT INTO public.who_global_data VALUES (72839, 1, 205, 0, 4, 308, 24);
INSERT INTO public.who_global_data VALUES (72840, 14, 95, 0, 0, 308, 162);
INSERT INTO public.who_global_data VALUES (72841, 99, 1613, 6, 59, 308, 100);
INSERT INTO public.who_global_data VALUES (72842, 0, 10, 0, 0, 308, 47);
INSERT INTO public.who_global_data VALUES (72843, 0, 10, 0, 0, 308, 29);
INSERT INTO public.who_global_data VALUES (72844, 2, 130, 1, 7, 308, 40);
INSERT INTO public.who_global_data VALUES (72845, 2, 84, 0, 3, 308, 222);
INSERT INTO public.who_global_data VALUES (72846, 3, 50, 0, 1, 308, 132);
INSERT INTO public.who_global_data VALUES (72847, 23, 114, 1, 2, 308, 130);
INSERT INTO public.who_global_data VALUES (72848, 0, 52, 0, 0, 308, 234);
INSERT INTO public.who_global_data VALUES (72849, 6, 15, 0, 0, 308, 23);
INSERT INTO public.who_global_data VALUES (72850, 0, 19, 0, 4, 308, 192);
INSERT INTO public.who_global_data VALUES (72851, 2, 18, 0, 0, 308, 69);
INSERT INTO public.who_global_data VALUES (72852, 0, 7, 0, 0, 308, 187);
INSERT INTO public.who_global_data VALUES (72853, 3, 222, 1, 15, 308, 230);
INSERT INTO public.who_global_data VALUES (72854, 55, 678, 6, 32, 308, 77);
INSERT INTO public.who_global_data VALUES (72855, 45, 1364, 0, 4, 308, 9);
INSERT INTO public.who_global_data VALUES (72856, 601, 2902, 12, 68, 308, 74);
INSERT INTO public.who_global_data VALUES (72857, 106, 2092, 10, 191, 308, 224);
INSERT INTO public.who_global_data VALUES (72858, 2560, 55743, 158, 3452, 308, 199);
INSERT INTO public.who_global_data VALUES (72859, 58, 878, 2, 56, 308, 190);
INSERT INTO public.who_global_data VALUES (72860, 424, 4273, 22, 120, 308, 12);
INSERT INTO public.who_global_data VALUES (72861, 43, 114, 0, 1, 308, 104);
INSERT INTO public.who_global_data VALUES (72862, 719, 7137, 9, 38, 308, 153);
INSERT INTO public.who_global_data VALUES (72863, 4585, 119827, 764, 14681, 308, 91);
INSERT INTO public.who_global_data VALUES (72864, 3, 47, 0, 3, 308, 215);
INSERT INTO public.who_global_data VALUES (72865, 318, 2935, 4, 69, 308, 84);
INSERT INTO public.who_global_data VALUES (72866, 37, 118, 0, 2, 308, 231);
INSERT INTO public.who_global_data VALUES (72867, 11, 310, 0, 5, 308, 196);
INSERT INTO public.who_global_data VALUES (72868, 71, 531, 2, 5, 308, 105);
INSERT INTO public.who_global_data VALUES (72869, 12, 122, 1, 4, 308, 122);
INSERT INTO public.who_global_data VALUES (72870, 0, 0, 0, 0, 308, 159);
INSERT INTO public.who_global_data VALUES (72871, 6, 132, 0, 1, 308, 75);
INSERT INTO public.who_global_data VALUES (72872, 62, 479, 1, 1, 308, 27);
INSERT INTO public.who_global_data VALUES (72873, 14, 144, 0, 1, 308, 54);
INSERT INTO public.who_global_data VALUES (72874, 0, 10, 0, 0, 308, 226);
INSERT INTO public.who_global_data VALUES (72875, 35, 493, 1, 1, 308, 79);
INSERT INTO public.who_global_data VALUES (72876, 12, 520, 0, 17, 308, 56);
INSERT INTO public.who_global_data VALUES (72877, 0, 0, 0, 0, 308, 117);
INSERT INTO public.who_global_data VALUES (72878, 1, 7, 0, 0, 308, 152);
INSERT INTO public.who_global_data VALUES (72879, 6, 17, 0, 1, 308, 16);
INSERT INTO public.who_global_data VALUES (72880, 1, 78, 1, 1, 308, 10);
INSERT INTO public.who_global_data VALUES (72881, 52, 683, 2, 11, 308, 201);
INSERT INTO public.who_global_data VALUES (72882, 125, 2612, 1, 31, 308, 174);
INSERT INTO public.who_global_data VALUES (72883, 5, 70, 0, 0, 308, 119);
INSERT INTO public.who_global_data VALUES (72884, 0, 3, 0, 0, 308, 168);
INSERT INTO public.who_global_data VALUES (72885, 217, 3333, 3, 53, 308, 99);
INSERT INTO public.who_global_data VALUES (72886, 0, 19, 0, 0, 308, 171);
INSERT INTO public.who_global_data VALUES (72887, 8, 36, 0, 3, 308, 87);
INSERT INTO public.who_global_data VALUES (72888, 11, 213, 0, 0, 308, 123);
INSERT INTO public.who_global_data VALUES (72889, 0, 0, 0, 0, 308, 151);
INSERT INTO public.who_global_data VALUES (72890, 7, 138, 0, 3, 308, 213);
INSERT INTO public.who_global_data VALUES (72891, 1, 6, 1, 1, 308, 118);
INSERT INTO public.who_global_data VALUES (72892, 17, 186, 0, 7, 308, 134);
INSERT INTO public.who_global_data VALUES (72893, 0, 128, 0, 2, 308, 65);
INSERT INTO public.who_global_data VALUES (72894, 132, 1510, 13, 50, 308, 102);
INSERT INTO public.who_global_data VALUES (72895, 0, 0, 0, 0, 308, 223);
INSERT INTO public.who_global_data VALUES (72896, 4, 47, 0, 0, 308, 4);
INSERT INTO public.who_global_data VALUES (72897, 0, 14, 0, 0, 308, 146);
INSERT INTO public.who_global_data VALUES (72898, 6, 203, 0, 2, 308, 31);
INSERT INTO public.who_global_data VALUES (72899, 0, 5, 0, 0, 308, 127);
INSERT INTO public.who_global_data VALUES (72900, 123, 858, 3, 50, 308, 22);
INSERT INTO public.who_global_data VALUES (72901, 0, 10, 0, 0, 308, 115);
INSERT INTO public.who_global_data VALUES (72902, 0, 20, 0, 1, 308, 106);
INSERT INTO public.who_global_data VALUES (72903, 0, 13, 0, 0, 308, 90);
INSERT INTO public.who_global_data VALUES (72904, 0, 0, 0, 0, 308, 70);
INSERT INTO public.who_global_data VALUES (72905, 0, 6, 0, 0, 308, 46);
INSERT INTO public.who_global_data VALUES (72906, 1020, 15563, 145, 1437, 308, 139);
INSERT INTO public.who_global_data VALUES (72907, 0, 18, 0, 0, 308, 42);
INSERT INTO public.who_global_data VALUES (72908, 50, 824, 0, 1, 308, 80);
INSERT INTO public.who_global_data VALUES (72909, 0, 5, 0, 1, 308, 203);
INSERT INTO public.who_global_data VALUES (72910, 22, 120, 0, 5, 308, 136);
INSERT INTO public.who_global_data VALUES (72911, 18, 208, 2, 4, 308, 63);
INSERT INTO public.who_global_data VALUES (72912, 0, 0, 0, 0, 308, 17);
INSERT INTO public.who_global_data VALUES (72913, 0, 8, 0, 1, 308, 172);
INSERT INTO public.who_global_data VALUES (72914, 46, 430, 1, 12, 308, 109);
INSERT INTO public.who_global_data VALUES (72915, 273, 5208, 2, 44, 308, 200);
INSERT INTO public.who_global_data VALUES (72916, 34, 205, 0, 1, 308, 93);
INSERT INTO public.who_global_data VALUES (72917, 25, 277, 0, 1, 308, 5);
INSERT INTO public.who_global_data VALUES (72918, 0, 712, 0, 11, 308, 214);
INSERT INTO public.who_global_data VALUES (72919, 0, 2450, 0, 35, 308, 204);
INSERT INTO public.who_global_data VALUES (72920, 0, 0, 0, 0, 308, 198);
INSERT INTO public.who_global_data VALUES (72921, 158, 1475, 5, 37, 308, 173);
INSERT INTO public.who_global_data VALUES (72922, 0, 1, 0, 0, 308, 229);
INSERT INTO public.who_global_data VALUES (72923, 15, 92, 0, 3, 308, 76);
INSERT INTO public.who_global_data VALUES (72924, 91, 1414, 10, 51, 308, 138);
INSERT INTO public.who_global_data VALUES (72925, 385, 3018, 29, 136, 308, 98);
INSERT INTO public.who_global_data VALUES (72926, 0, 0, 0, 0, 308, 103);
INSERT INTO public.who_global_data VALUES (72927, 437, 3383, 14, 71, 308, 225);
INSERT INTO public.who_global_data VALUES (72928, 852, 9886, 37, 246, 308, 131);
INSERT INTO public.who_global_data VALUES (72929, 62, 378, 3, 15, 308, 235);
INSERT INTO public.who_global_data VALUES (72930, 0, 1075, 0, 3, 308, 137);
INSERT INTO public.who_global_data VALUES (72931, 94, 10156, 3, 177, 308, 81);
INSERT INTO public.who_global_data VALUES (72932, 0, 591, 1, 9, 308, 182);
INSERT INTO public.who_global_data VALUES (72933, 13, 321, 0, 0, 308, 145);
INSERT INTO public.who_global_data VALUES (72934, 445, 3183, 39, 133, 308, 26);
INSERT INTO public.who_global_data VALUES (72935, 601, 4149, 4, 34, 308, 170);
INSERT INTO public.who_global_data VALUES (72936, 5, 89, 0, 0, 308, 191);
INSERT INTO public.who_global_data VALUES (72937, 0, 0, 0, 0, 308, 221);
INSERT INTO public.who_global_data VALUES (72938, 0, 6, 0, 0, 308, 64);
INSERT INTO public.who_global_data VALUES (72939, 0, 0, 0, 0, 308, 116);
INSERT INTO public.who_global_data VALUES (72940, 0, 8, 0, 0, 308, 128);
INSERT INTO public.who_global_data VALUES (72941, 0, 13, 0, 0, 308, 6);
INSERT INTO public.who_global_data VALUES (72942, 0, 22, 0, 2, 308, 227);
INSERT INTO public.who_global_data VALUES (72943, 0, 0, 0, 0, 308, 68);
INSERT INTO public.who_global_data VALUES (72944, 1, 3, 0, 0, 308, 184);
INSERT INTO public.who_global_data VALUES (72945, 0, 0, 0, 0, 308, 82);
INSERT INTO public.who_global_data VALUES (72946, 7, 252, 2, 32, 308, 149);
INSERT INTO public.who_global_data VALUES (72947, 0, 0, 0, 0, 308, 197);
INSERT INTO public.who_global_data VALUES (72948, 140, 2179, 4, 29, 308, 78);
INSERT INTO public.who_global_data VALUES (72949, 24, 219, 1, 2, 308, 233);
INSERT INTO public.who_global_data VALUES (72950, 305, 1476, 26, 39, 308, 133);
INSERT INTO public.who_global_data VALUES (72951, 0, 10, 0, 0, 308, 35);
INSERT INTO public.who_global_data VALUES (72952, 0, 2, 0, 0, 308, 114);
INSERT INTO public.who_global_data VALUES (72953, 65, 1114, 1, 5, 308, 237);
INSERT INTO public.who_global_data VALUES (72954, 0, 2, 0, 0, 308, 55);
INSERT INTO public.who_global_data VALUES (72955, 5, 23, 1, 2, 308, 176);
INSERT INTO public.who_global_data VALUES (72956, 24, 450, 0, 0, 308, 202);
INSERT INTO public.who_global_data VALUES (72957, 41, 978, 3, 26, 308, 155);
INSERT INTO public.who_global_data VALUES (72958, 0, 0, 0, 0, 308, 32);
INSERT INTO public.who_global_data VALUES (72959, 2, 7, 0, 0, 308, 220);
INSERT INTO public.who_global_data VALUES (72960, 43, 1505, 2, 7, 308, 30);
INSERT INTO public.who_global_data VALUES (72961, 0, 0, 0, 0, 308, 147);
INSERT INTO public.who_global_data VALUES (72962, 6908, 138320, 858, 12143, 308, 208);
INSERT INTO public.who_global_data VALUES (72963, 8, 159, 1, 5, 308, 45);
INSERT INTO public.who_global_data VALUES (72964, 0, 10, 0, 2, 308, 110);
INSERT INTO public.who_global_data VALUES (72965, 2, 10, 0, 0, 308, 88);
INSERT INTO public.who_global_data VALUES (72966, 554, 5874, 70, 455, 308, 51);
INSERT INTO public.who_global_data VALUES (72967, 927, 21857, 57, 657, 308, 209);
INSERT INTO public.who_global_data VALUES (72968, 0, 16, 0, 2, 308, 205);
INSERT INTO public.who_global_data VALUES (72969, 0, 0, 0, 0, 308, 18);
INSERT INTO public.who_global_data VALUES (72970, 89, 2067, 1, 20, 308, 72);
INSERT INTO public.who_global_data VALUES (72971, 4868, 48249, 736, 4518, 308, 44);
INSERT INTO public.who_global_data VALUES (72972, 0, 1, 0, 0, 308, 15);
INSERT INTO public.who_global_data VALUES (72973, 0, 39, 0, 2, 308, 25);
INSERT INTO public.who_global_data VALUES (72974, 0, 0, 0, 0, 308, 179);
INSERT INTO public.who_global_data VALUES (72975, 0, 0, 0, 0, 308, 34);
INSERT INTO public.who_global_data VALUES (72976, 7, 97, 1, 6, 308, 207);
INSERT INTO public.who_global_data VALUES (72977, 0, 495, 0, 18, 308, 166);
INSERT INTO public.who_global_data VALUES (72978, 2786, 20921, 69, 425, 308, 126);
INSERT INTO public.who_global_data VALUES (72979, 0, 0, 0, 0, 308, 97);
INSERT INTO public.who_global_data VALUES (72980, 0, 5, 0, 0, 308, 36);
INSERT INTO public.who_global_data VALUES (72981, 0, 0, 0, 0, 308, 125);
INSERT INTO public.who_global_data VALUES (72982, 3, 48, 0, 0, 308, 124);
INSERT INTO public.who_global_data VALUES (72983, 109, 1096, 5, 28, 308, 185);
INSERT INTO public.who_global_data VALUES (72984, 481, 1505, 2, 10, 308, 194);
INSERT INTO public.who_global_data VALUES (72985, 0, 20, 0, 1, 308, 144);
INSERT INTO public.who_global_data VALUES (72986, 28103, 241703, 1061, 5854, 308, 19);
INSERT INTO public.who_global_data VALUES (72987, 4, 37, 0, 0, 308, 217);
INSERT INTO public.who_global_data VALUES (72988, 19, 369, 0, 4, 308, 148);
INSERT INTO public.who_global_data VALUES (72989, 20, 241, 0, 2, 308, 86);
INSERT INTO public.who_global_data VALUES (72990, 0, 0, 0, 0, 308, 13);
INSERT INTO public.who_global_data VALUES (72991, 0, 144, 0, 3, 308, 157);
INSERT INTO public.who_global_data VALUES (72992, 6, 239, 0, 0, 308, 8);
INSERT INTO public.who_global_data VALUES (72993, 0, 0, 0, 0, 308, 73);
INSERT INTO public.who_global_data VALUES (72994, 0, 0, 0, 0, 308, 101);
INSERT INTO public.who_global_data VALUES (72995, 0, 39, 0, 1, 308, 165);
INSERT INTO public.who_global_data VALUES (72996, 0, 9, 0, 1, 308, 14);
INSERT INTO public.who_global_data VALUES (72997, 34, 269, 1, 5, 309, 193);
INSERT INTO public.who_global_data VALUES (72998, 0, 239, 1, 15, 309, 113);
INSERT INTO public.who_global_data VALUES (72999, 139, 986, 25, 83, 309, 143);
INSERT INTO public.who_global_data VALUES (73000, 0, 0, 0, 0, 309, 219);
INSERT INTO public.who_global_data VALUES (73001, 33, 429, 2, 15, 309, 186);
INSERT INTO public.who_global_data VALUES (73002, 0, 8, 0, 2, 309, 52);
INSERT INTO public.who_global_data VALUES (73003, 0, 2, 0, 0, 309, 180);
INSERT INTO public.who_global_data VALUES (73004, 0, 7, 0, 0, 309, 167);
INSERT INTO public.who_global_data VALUES (73005, 79, 1133, 4, 31, 309, 154);
INSERT INTO public.who_global_data VALUES (73006, 92, 640, 1, 4, 309, 94);
INSERT INTO public.who_global_data VALUES (73007, 5, 60, 0, 0, 309, 66);
INSERT INTO public.who_global_data VALUES (73008, 374, 5350, 5, 26, 309, 58);
INSERT INTO public.who_global_data VALUES (73009, 418, 11129, 12, 158, 309, 163);
INSERT INTO public.who_global_data VALUES (73010, 41, 400, 0, 5, 309, 37);
INSERT INTO public.who_global_data VALUES (73011, 6, 21, 1, 1, 309, 142);
INSERT INTO public.who_global_data VALUES (73012, 37, 672, 0, 4, 309, 83);
INSERT INTO public.who_global_data VALUES (73013, 5, 61, 0, 6, 309, 228);
INSERT INTO public.who_global_data VALUES (73014, 12, 45, 0, 0, 309, 188);
INSERT INTO public.who_global_data VALUES (73015, 62, 254, 2, 4, 309, 62);
INSERT INTO public.who_global_data VALUES (73016, 1478, 20071, 219, 1832, 309, 160);
INSERT INTO public.who_global_data VALUES (73017, 0, 3, 0, 0, 309, 50);
INSERT INTO public.who_global_data VALUES (73018, 0, 13, 0, 0, 309, 33);
INSERT INTO public.who_global_data VALUES (73019, 0, 32, 0, 0, 309, 183);
INSERT INTO public.who_global_data VALUES (73020, 0, 5, 0, 0, 309, 92);
INSERT INTO public.who_global_data VALUES (73021, 8, 123, 1, 8, 309, 158);
INSERT INTO public.who_global_data VALUES (73022, 0, 0, 0, 0, 309, 67);
INSERT INTO public.who_global_data VALUES (73023, 57, 521, 3, 16, 309, 57);
INSERT INTO public.who_global_data VALUES (73024, 1, 4, 0, 1, 309, 38);
INSERT INTO public.who_global_data VALUES (73025, 1119, 6836, 40, 241, 309, 141);
INSERT INTO public.who_global_data VALUES (73026, 0, 3, 0, 0, 309, 178);
INSERT INTO public.who_global_data VALUES (73027, 2, 133, 0, 1, 309, 108);
INSERT INTO public.who_global_data VALUES (73028, 35, 457, 0, 10, 309, 39);
INSERT INTO public.who_global_data VALUES (73029, 0, 261, 1, 15, 309, 2);
INSERT INTO public.who_global_data VALUES (73030, 1, 3, 0, 0, 309, 195);
INSERT INTO public.who_global_data VALUES (73031, 0, 5, 0, 1, 309, 107);
INSERT INTO public.who_global_data VALUES (73032, 1, 110, 0, 0, 309, 161);
INSERT INTO public.who_global_data VALUES (73033, 107, 246, 1, 7, 309, 212);
INSERT INTO public.who_global_data VALUES (73034, 1109, 10114, 22, 127, 309, 181);
INSERT INTO public.who_global_data VALUES (73035, 8, 22, 0, 1, 309, 53);
INSERT INTO public.who_global_data VALUES (73036, 0, 8, 0, 0, 309, 164);
INSERT INTO public.who_global_data VALUES (73037, 0, 7, 0, 0, 309, 140);
INSERT INTO public.who_global_data VALUES (73038, 373, 3404, 2, 18, 309, 20);
INSERT INTO public.who_global_data VALUES (73039, 78, 82802, 4, 3331, 309, 112);
INSERT INTO public.who_global_data VALUES (73040, 159, 1065, 1, 17, 309, 111);
INSERT INTO public.who_global_data VALUES (73041, 0, 0, 0, 0, 309, 71);
INSERT INTO public.who_global_data VALUES (73042, 19, 41, 0, 2, 309, 218);
INSERT INTO public.who_global_data VALUES (73043, 0, 0, 0, 0, 309, 43);
INSERT INTO public.who_global_data VALUES (73044, 28, 375, 0, 2, 309, 49);
INSERT INTO public.who_global_data VALUES (73045, 0, 190, 0, 1, 309, 1);
INSERT INTO public.who_global_data VALUES (73046, 48, 1011, 1, 7, 309, 48);
INSERT INTO public.who_global_data VALUES (73047, 21, 233, 0, 6, 309, 232);
INSERT INTO public.who_global_data VALUES (73048, 0, 11, 0, 1, 309, 175);
INSERT INTO public.who_global_data VALUES (73049, 36, 356, 0, 9, 309, 21);
INSERT INTO public.who_global_data VALUES (73050, 269, 3858, 5, 44, 309, 156);
INSERT INTO public.who_global_data VALUES (73051, 0, 0, 0, 0, 309, 95);
INSERT INTO public.who_global_data VALUES (73052, 11, 134, 2, 13, 309, 177);
INSERT INTO public.who_global_data VALUES (73053, 279, 3386, 19, 123, 309, 210);
INSERT INTO public.who_global_data VALUES (73054, 9, 50, 0, 0, 309, 120);
INSERT INTO public.who_global_data VALUES (73055, 0, 11, 0, 0, 309, 135);
INSERT INTO public.who_global_data VALUES (73056, 96, 1380, 3, 60, 309, 206);
INSERT INTO public.who_global_data VALUES (73057, 791, 3163, 41, 120, 309, 189);
INSERT INTO public.who_global_data VALUES (73058, 86, 865, 6, 58, 309, 129);
INSERT INTO public.who_global_data VALUES (73059, 9, 41, 1, 2, 309, 121);
INSERT INTO public.who_global_data VALUES (73060, 0, 15, 0, 0, 309, 59);
INSERT INTO public.who_global_data VALUES (73061, 5, 20, 0, 0, 309, 96);
INSERT INTO public.who_global_data VALUES (73062, 79, 858, 6, 11, 309, 41);
INSERT INTO public.who_global_data VALUES (73063, 0, 9, 0, 0, 309, 216);
INSERT INTO public.who_global_data VALUES (73064, 5, 31, 0, 0, 309, 236);
INSERT INTO public.who_global_data VALUES (73065, 0, 0, 0, 0, 309, 150);
INSERT INTO public.who_global_data VALUES (73066, 4, 177, 0, 0, 309, 61);
INSERT INTO public.who_global_data VALUES (73067, 2, 7, 0, 0, 309, 7);
INSERT INTO public.who_global_data VALUES (73068, 72, 1518, 2, 19, 309, 169);
INSERT INTO public.who_global_data VALUES (73069, 2066, 58327, 471, 4490, 309, 28);
INSERT INTO public.who_global_data VALUES (73070, 4, 55, 0, 0, 309, 85);
INSERT INTO public.who_global_data VALUES (73071, 0, 37, 0, 0, 309, 211);
INSERT INTO public.who_global_data VALUES (73072, 11, 18, 0, 1, 309, 60);
INSERT INTO public.who_global_data VALUES (73073, 1, 4, 0, 1, 309, 3);
INSERT INTO public.who_global_data VALUES (73074, 27, 148, 0, 0, 309, 11);
INSERT INTO public.who_global_data VALUES (73075, 6174, 79696, 145, 1017, 309, 89);
INSERT INTO public.who_global_data VALUES (73076, 9, 204, 0, 4, 309, 24);
INSERT INTO public.who_global_data VALUES (73077, 12, 81, 0, 0, 309, 162);
INSERT INTO public.who_global_data VALUES (73078, 139, 1514, 3, 53, 309, 100);
INSERT INTO public.who_global_data VALUES (73079, 0, 10, 0, 0, 309, 47);
INSERT INTO public.who_global_data VALUES (73080, 1, 10, 0, 0, 309, 29);
INSERT INTO public.who_global_data VALUES (73081, 3, 128, 0, 6, 309, 40);
INSERT INTO public.who_global_data VALUES (73082, 5, 82, 0, 3, 309, 222);
INSERT INTO public.who_global_data VALUES (73083, 8, 47, 0, 1, 309, 132);
INSERT INTO public.who_global_data VALUES (73084, 13, 91, 0, 1, 309, 130);
INSERT INTO public.who_global_data VALUES (73085, 22, 52, 0, 0, 309, 234);
INSERT INTO public.who_global_data VALUES (73086, 0, 9, 0, 0, 309, 23);
INSERT INTO public.who_global_data VALUES (73087, 0, 19, 2, 4, 309, 192);
INSERT INTO public.who_global_data VALUES (73088, 0, 16, 0, 0, 309, 69);
INSERT INTO public.who_global_data VALUES (73089, 1, 7, 0, 0, 309, 187);
INSERT INTO public.who_global_data VALUES (73090, 47, 219, 4, 14, 309, 230);
INSERT INTO public.who_global_data VALUES (73091, 38, 623, 5, 26, 309, 77);
INSERT INTO public.who_global_data VALUES (73092, 99, 1319, 2, 4, 309, 9);
INSERT INTO public.who_global_data VALUES (73093, 336, 2301, 6, 56, 309, 74);
INSERT INTO public.who_global_data VALUES (73094, 196, 1986, 11, 181, 309, 224);
INSERT INTO public.who_global_data VALUES (73095, 2715, 53183, 134, 3294, 309, 199);
INSERT INTO public.who_global_data VALUES (73096, 48, 820, 0, 54, 309, 190);
INSERT INTO public.who_global_data VALUES (73097, 402, 3849, 13, 98, 309, 12);
INSERT INTO public.who_global_data VALUES (73098, 6, 71, 1, 1, 309, 104);
INSERT INTO public.who_global_data VALUES (73099, 696, 6418, 8, 29, 309, 153);
INSERT INTO public.who_global_data VALUES (73100, 4668, 115242, 760, 13917, 309, 91);
INSERT INTO public.who_global_data VALUES (73101, 6, 44, 2, 3, 309, 215);
INSERT INTO public.who_global_data VALUES (73102, 233, 2617, 8, 65, 309, 84);
INSERT INTO public.who_global_data VALUES (73103, 0, 81, 0, 2, 309, 231);
INSERT INTO public.who_global_data VALUES (73104, 21, 299, 0, 5, 309, 196);
INSERT INTO public.who_global_data VALUES (73105, 25, 460, 0, 3, 309, 105);
INSERT INTO public.who_global_data VALUES (73106, 29, 110, 2, 3, 309, 122);
INSERT INTO public.who_global_data VALUES (73107, 0, 0, 0, 0, 309, 159);
INSERT INTO public.who_global_data VALUES (73108, 1, 126, 0, 1, 309, 75);
INSERT INTO public.who_global_data VALUES (73109, 75, 417, 0, 0, 309, 27);
INSERT INTO public.who_global_data VALUES (73110, 15, 130, 1, 1, 309, 54);
INSERT INTO public.who_global_data VALUES (73111, 0, 10, 0, 0, 309, 226);
INSERT INTO public.who_global_data VALUES (73112, 12, 458, 0, 0, 309, 79);
INSERT INTO public.who_global_data VALUES (73113, 14, 508, 1, 17, 309, 56);
INSERT INTO public.who_global_data VALUES (73114, 0, 0, 0, 0, 309, 117);
INSERT INTO public.who_global_data VALUES (73115, 0, 6, 0, 0, 309, 152);
INSERT INTO public.who_global_data VALUES (73116, 1, 11, 1, 1, 309, 16);
INSERT INTO public.who_global_data VALUES (73117, 1, 77, 0, 0, 309, 10);
INSERT INTO public.who_global_data VALUES (73118, 52, 631, 0, 9, 309, 201);
INSERT INTO public.who_global_data VALUES (73119, 168, 2487, 1, 30, 309, 174);
INSERT INTO public.who_global_data VALUES (73120, 6, 65, 0, 0, 309, 119);
INSERT INTO public.who_global_data VALUES (73121, 3, 3, 0, 0, 309, 168);
INSERT INTO public.who_global_data VALUES (73122, 208, 3116, 5, 50, 309, 99);
INSERT INTO public.who_global_data VALUES (73123, 0, 19, 0, 0, 309, 171);
INSERT INTO public.who_global_data VALUES (73124, 0, 28, 3, 3, 309, 87);
INSERT INTO public.who_global_data VALUES (73125, 7, 202, 0, 0, 309, 123);
INSERT INTO public.who_global_data VALUES (73126, 0, 0, 0, 0, 309, 151);
INSERT INTO public.who_global_data VALUES (73127, 3, 131, 0, 3, 309, 213);
INSERT INTO public.who_global_data VALUES (73128, 0, 5, 0, 0, 309, 118);
INSERT INTO public.who_global_data VALUES (73129, 15, 169, 2, 7, 309, 134);
INSERT INTO public.who_global_data VALUES (73130, 12, 128, 0, 2, 309, 65);
INSERT INTO public.who_global_data VALUES (73131, 163, 1378, 8, 37, 309, 102);
INSERT INTO public.who_global_data VALUES (73132, 0, 0, 0, 0, 309, 223);
INSERT INTO public.who_global_data VALUES (73133, 3, 43, 0, 0, 309, 4);
INSERT INTO public.who_global_data VALUES (73134, 0, 14, 0, 0, 309, 146);
INSERT INTO public.who_global_data VALUES (73135, 37, 197, 0, 2, 309, 31);
INSERT INTO public.who_global_data VALUES (73136, 0, 5, 0, 0, 309, 127);
INSERT INTO public.who_global_data VALUES (73137, 59, 735, 7, 47, 309, 22);
INSERT INTO public.who_global_data VALUES (73138, 0, 10, 0, 0, 309, 115);
INSERT INTO public.who_global_data VALUES (73139, 4, 20, 0, 1, 309, 106);
INSERT INTO public.who_global_data VALUES (73140, 0, 13, 0, 0, 309, 90);
INSERT INTO public.who_global_data VALUES (73141, 0, 0, 0, 0, 309, 70);
INSERT INTO public.who_global_data VALUES (73142, 1, 6, 0, 0, 309, 46);
INSERT INTO public.who_global_data VALUES (73143, 1083, 14543, 155, 1292, 309, 139);
INSERT INTO public.who_global_data VALUES (73144, 1, 18, 0, 0, 309, 42);
INSERT INTO public.who_global_data VALUES (73145, 51, 774, 0, 1, 309, 80);
INSERT INTO public.who_global_data VALUES (73146, 0, 5, 0, 1, 309, 203);
INSERT INTO public.who_global_data VALUES (73147, 24, 98, 0, 5, 309, 136);
INSERT INTO public.who_global_data VALUES (73148, 16, 190, 0, 2, 309, 63);
INSERT INTO public.who_global_data VALUES (73149, 0, 0, 0, 0, 309, 17);
INSERT INTO public.who_global_data VALUES (73150, 2, 8, 1, 1, 309, 172);
INSERT INTO public.who_global_data VALUES (73151, 30, 384, 0, 11, 309, 109);
INSERT INTO public.who_global_data VALUES (73152, 270, 4935, 10, 42, 309, 200);
INSERT INTO public.who_global_data VALUES (73153, 16, 171, 0, 1, 309, 93);
INSERT INTO public.who_global_data VALUES (73154, 21, 252, 0, 1, 309, 5);
INSERT INTO public.who_global_data VALUES (73155, 0, 712, 0, 11, 309, 214);
INSERT INTO public.who_global_data VALUES (73156, 159, 2450, 4, 35, 309, 204);
INSERT INTO public.who_global_data VALUES (73157, 0, 0, 0, 0, 309, 198);
INSERT INTO public.who_global_data VALUES (73158, 136, 1317, 2, 32, 309, 173);
INSERT INTO public.who_global_data VALUES (73159, 0, 1, 0, 0, 309, 229);
INSERT INTO public.who_global_data VALUES (73160, 8, 77, 0, 3, 309, 76);
INSERT INTO public.who_global_data VALUES (73161, 0, 1323, 17, 41, 309, 138);
INSERT INTO public.who_global_data VALUES (73162, 322, 2633, 11, 107, 309, 98);
INSERT INTO public.who_global_data VALUES (73163, 0, 0, 0, 0, 309, 103);
INSERT INTO public.who_global_data VALUES (73164, 392, 2946, 14, 57, 309, 225);
INSERT INTO public.who_global_data VALUES (73165, 783, 9034, 22, 209, 309, 131);
INSERT INTO public.who_global_data VALUES (73166, 30, 316, 1, 12, 309, 235);
INSERT INTO public.who_global_data VALUES (73167, 240, 1075, 1, 3, 309, 137);
INSERT INTO public.who_global_data VALUES (73168, 86, 10062, 5, 174, 309, 81);
INSERT INTO public.who_global_data VALUES (73169, 168, 591, 3, 8, 309, 182);
INSERT INTO public.who_global_data VALUES (73170, 27, 308, 0, 0, 309, 145);
INSERT INTO public.who_global_data VALUES (73171, 278, 2738, 9, 94, 309, 26);
INSERT INTO public.who_global_data VALUES (73172, 771, 3548, 6, 30, 309, 170);
INSERT INTO public.who_global_data VALUES (73173, 2, 84, 0, 0, 309, 191);
INSERT INTO public.who_global_data VALUES (73174, 0, 0, 0, 0, 309, 221);
INSERT INTO public.who_global_data VALUES (73175, 0, 6, 0, 0, 309, 64);
INSERT INTO public.who_global_data VALUES (73176, 0, 0, 0, 0, 309, 116);
INSERT INTO public.who_global_data VALUES (73177, 0, 8, 0, 0, 309, 128);
INSERT INTO public.who_global_data VALUES (73178, 0, 13, 0, 0, 309, 6);
INSERT INTO public.who_global_data VALUES (73179, 1, 22, 0, 2, 309, 227);
INSERT INTO public.who_global_data VALUES (73180, 0, 0, 0, 0, 309, 68);
INSERT INTO public.who_global_data VALUES (73181, 1, 2, 0, 0, 309, 184);
INSERT INTO public.who_global_data VALUES (73182, 0, 0, 0, 0, 309, 82);
INSERT INTO public.who_global_data VALUES (73183, 9, 245, 2, 30, 309, 149);
INSERT INTO public.who_global_data VALUES (73184, 0, 0, 0, 0, 309, 197);
INSERT INTO public.who_global_data VALUES (73185, 154, 2039, 4, 25, 309, 78);
INSERT INTO public.who_global_data VALUES (73186, 5, 195, 0, 1, 309, 233);
INSERT INTO public.who_global_data VALUES (73187, 111, 1171, 0, 13, 309, 133);
INSERT INTO public.who_global_data VALUES (73188, 0, 10, 0, 0, 309, 35);
INSERT INTO public.who_global_data VALUES (73189, 0, 2, 0, 0, 309, 114);
INSERT INTO public.who_global_data VALUES (73190, 49, 1049, 1, 4, 309, 237);
INSERT INTO public.who_global_data VALUES (73191, 0, 2, 0, 0, 309, 55);
INSERT INTO public.who_global_data VALUES (73192, 12, 18, 1, 1, 309, 176);
INSERT INTO public.who_global_data VALUES (73193, 26, 426, 0, 0, 309, 202);
INSERT INTO public.who_global_data VALUES (73194, 40, 937, 3, 23, 309, 155);
INSERT INTO public.who_global_data VALUES (73195, 0, 0, 0, 0, 309, 32);
INSERT INTO public.who_global_data VALUES (73196, 0, 5, 0, 0, 309, 220);
INSERT INTO public.who_global_data VALUES (73197, 82, 1462, 0, 5, 309, 30);
INSERT INTO public.who_global_data VALUES (73198, 0, 0, 0, 0, 309, 147);
INSERT INTO public.who_global_data VALUES (73199, 7057, 131412, 895, 11285, 309, 208);
INSERT INTO public.who_global_data VALUES (73200, 3, 151, 1, 4, 309, 45);
INSERT INTO public.who_global_data VALUES (73201, 3, 10, 0, 2, 309, 110);
INSERT INTO public.who_global_data VALUES (73202, 0, 8, 0, 0, 309, 88);
INSERT INTO public.who_global_data VALUES (73203, 486, 5320, 53, 385, 309, 51);
INSERT INTO public.who_global_data VALUES (73204, 877, 20930, 60, 600, 309, 209);
INSERT INTO public.who_global_data VALUES (73205, 6, 16, 0, 2, 309, 205);
INSERT INTO public.who_global_data VALUES (73206, 0, 0, 0, 0, 309, 18);
INSERT INTO public.who_global_data VALUES (73207, 103, 1978, 4, 19, 309, 72);
INSERT INTO public.who_global_data VALUES (73208, 4913, 43381, 657, 3782, 309, 44);
INSERT INTO public.who_global_data VALUES (73209, 0, 1, 0, 0, 309, 15);
INSERT INTO public.who_global_data VALUES (73210, 3, 39, 0, 2, 309, 25);
INSERT INTO public.who_global_data VALUES (73211, 0, 0, 0, 0, 309, 179);
INSERT INTO public.who_global_data VALUES (73212, 0, 0, 0, 0, 309, 34);
INSERT INTO public.who_global_data VALUES (73213, 1, 90, 0, 5, 309, 207);
INSERT INTO public.who_global_data VALUES (73214, 40, 495, 5, 18, 309, 166);
INSERT INTO public.who_global_data VALUES (73215, 2456, 18135, 79, 356, 309, 126);
INSERT INTO public.who_global_data VALUES (73216, 0, 0, 0, 0, 309, 97);
INSERT INTO public.who_global_data VALUES (73217, 0, 5, 0, 0, 309, 36);
INSERT INTO public.who_global_data VALUES (73218, 0, 0, 0, 0, 309, 125);
INSERT INTO public.who_global_data VALUES (73219, 1, 45, 0, 0, 309, 124);
INSERT INTO public.who_global_data VALUES (73220, 183, 987, 3, 23, 309, 185);
INSERT INTO public.who_global_data VALUES (73221, 210, 1024, 0, 8, 309, 194);
INSERT INTO public.who_global_data VALUES (73222, 0, 20, 0, 1, 309, 144);
INSERT INTO public.who_global_data VALUES (73223, 26298, 213600, 947, 4793, 309, 19);
INSERT INTO public.who_global_data VALUES (73224, 3, 33, 0, 0, 309, 217);
INSERT INTO public.who_global_data VALUES (73225, 12, 350, 2, 4, 309, 148);
INSERT INTO public.who_global_data VALUES (73226, 31, 221, 0, 2, 309, 86);
INSERT INTO public.who_global_data VALUES (73227, 0, 0, 0, 0, 309, 13);
INSERT INTO public.who_global_data VALUES (73228, 1, 144, 0, 3, 309, 157);
INSERT INTO public.who_global_data VALUES (73229, 17, 233, 0, 0, 309, 8);
INSERT INTO public.who_global_data VALUES (73230, 0, 0, 0, 0, 309, 73);
INSERT INTO public.who_global_data VALUES (73231, 0, 0, 0, 0, 309, 101);
INSERT INTO public.who_global_data VALUES (73232, 3, 39, 1, 1, 309, 165);
INSERT INTO public.who_global_data VALUES (73233, 1, 9, 0, 1, 309, 14);
INSERT INTO public.who_global_data VALUES (73234, 43, 235, 0, 4, 310, 193);
INSERT INTO public.who_global_data VALUES (73235, 0, 239, 0, 14, 310, 113);
INSERT INTO public.who_global_data VALUES (73236, 263, 847, 23, 58, 310, 143);
INSERT INTO public.who_global_data VALUES (73237, 0, 0, 0, 0, 310, 219);
INSERT INTO public.who_global_data VALUES (73238, 0, 396, 0, 13, 310, 186);
INSERT INTO public.who_global_data VALUES (73239, 1, 8, 0, 2, 310, 52);
INSERT INTO public.who_global_data VALUES (73240, 0, 2, 0, 0, 310, 180);
INSERT INTO public.who_global_data VALUES (73241, 0, 7, 0, 0, 310, 167);
INSERT INTO public.who_global_data VALUES (73242, 88, 1054, 3, 27, 310, 154);
INSERT INTO public.who_global_data VALUES (73243, 39, 548, 0, 3, 310, 94);
INSERT INTO public.who_global_data VALUES (73244, 0, 55, 0, 0, 310, 66);
INSERT INTO public.who_global_data VALUES (73245, 116, 4976, 1, 21, 310, 58);
INSERT INTO public.who_global_data VALUES (73246, 529, 10711, 18, 146, 310, 163);
INSERT INTO public.who_global_data VALUES (73247, 61, 359, 0, 5, 310, 37);
INSERT INTO public.who_global_data VALUES (73248, 1, 15, 0, 0, 310, 142);
INSERT INTO public.who_global_data VALUES (73249, 66, 635, 0, 4, 310, 83);
INSERT INTO public.who_global_data VALUES (73250, 2, 56, 0, 6, 310, 228);
INSERT INTO public.who_global_data VALUES (73251, 0, 33, 0, 0, 310, 188);
INSERT INTO public.who_global_data VALUES (73252, 0, 192, 0, 2, 310, 62);
INSERT INTO public.who_global_data VALUES (73253, 1516, 18593, 233, 1613, 310, 160);
INSERT INTO public.who_global_data VALUES (73254, 0, 3, 0, 0, 310, 50);
INSERT INTO public.who_global_data VALUES (73255, 4, 13, 0, 0, 310, 33);
INSERT INTO public.who_global_data VALUES (73256, 5, 32, 0, 0, 310, 183);
INSERT INTO public.who_global_data VALUES (73257, 1, 5, 0, 0, 310, 92);
INSERT INTO public.who_global_data VALUES (73258, 8, 115, 1, 7, 310, 158);
INSERT INTO public.who_global_data VALUES (73259, 0, 0, 0, 0, 310, 67);
INSERT INTO public.who_global_data VALUES (73260, 0, 464, 0, 13, 310, 57);
INSERT INTO public.who_global_data VALUES (73261, 0, 3, 1, 1, 310, 38);
INSERT INTO public.who_global_data VALUES (73262, 1138, 5717, 42, 201, 310, 141);
INSERT INTO public.who_global_data VALUES (73263, 0, 3, 0, 0, 310, 178);
INSERT INTO public.who_global_data VALUES (73264, 2, 131, 0, 1, 310, 108);
INSERT INTO public.who_global_data VALUES (73265, 23, 422, 2, 10, 310, 39);
INSERT INTO public.who_global_data VALUES (73266, 0, 261, 0, 14, 310, 2);
INSERT INTO public.who_global_data VALUES (73267, 0, 2, 0, 0, 310, 195);
INSERT INTO public.who_global_data VALUES (73268, 0, 5, 0, 1, 310, 107);
INSERT INTO public.who_global_data VALUES (73269, 0, 109, 0, 0, 310, 161);
INSERT INTO public.who_global_data VALUES (73270, 0, 139, 0, 6, 310, 212);
INSERT INTO public.who_global_data VALUES (73271, 1310, 9005, 16, 105, 310, 181);
INSERT INTO public.who_global_data VALUES (73272, 2, 14, 0, 1, 310, 53);
INSERT INTO public.who_global_data VALUES (73273, 2, 8, 0, 0, 310, 164);
INSERT INTO public.who_global_data VALUES (73274, 0, 7, 0, 0, 310, 140);
INSERT INTO public.who_global_data VALUES (73275, 293, 3031, 4, 16, 310, 20);
INSERT INTO public.who_global_data VALUES (73276, 86, 82724, 6, 3327, 310, 112);
INSERT INTO public.who_global_data VALUES (73277, 108, 906, 2, 16, 310, 111);
INSERT INTO public.who_global_data VALUES (73278, 0, 0, 0, 0, 310, 71);
INSERT INTO public.who_global_data VALUES (73279, 0, 22, 0, 2, 310, 218);
INSERT INTO public.who_global_data VALUES (73280, 0, 0, 0, 0, 310, 43);
INSERT INTO public.who_global_data VALUES (73281, 33, 347, 0, 2, 310, 49);
INSERT INTO public.who_global_data VALUES (73282, 21, 190, 1, 1, 310, 1);
INSERT INTO public.who_global_data VALUES (73283, 96, 963, 0, 6, 310, 48);
INSERT INTO public.who_global_data VALUES (73284, 26, 212, 0, 6, 310, 232);
INSERT INTO public.who_global_data VALUES (73285, 0, 11, 0, 1, 310, 175);
INSERT INTO public.who_global_data VALUES (73286, 58, 320, 1, 9, 310, 21);
INSERT INTO public.who_global_data VALUES (73287, 281, 3589, 8, 39, 310, 156);
INSERT INTO public.who_global_data VALUES (73288, 0, 0, 0, 0, 310, 95);
INSERT INTO public.who_global_data VALUES (73289, 14, 123, 2, 11, 310, 177);
INSERT INTO public.who_global_data VALUES (73290, 247, 3107, 14, 104, 310, 210);
INSERT INTO public.who_global_data VALUES (73291, 7, 41, 0, 0, 310, 120);
INSERT INTO public.who_global_data VALUES (73292, 0, 11, 0, 0, 310, 135);
INSERT INTO public.who_global_data VALUES (73293, 175, 1284, 6, 57, 310, 206);
INSERT INTO public.who_global_data VALUES (73294, 132, 2372, 71, 79, 310, 189);
INSERT INTO public.who_global_data VALUES (73295, 69, 779, 6, 52, 310, 129);
INSERT INTO public.who_global_data VALUES (73296, 2, 32, 1, 1, 310, 121);
INSERT INTO public.who_global_data VALUES (73297, 1, 15, 0, 0, 310, 59);
INSERT INTO public.who_global_data VALUES (73298, 9, 15, 0, 0, 310, 96);
INSERT INTO public.who_global_data VALUES (73299, 34, 779, 1, 5, 310, 41);
INSERT INTO public.who_global_data VALUES (73300, 0, 9, 0, 0, 310, 216);
INSERT INTO public.who_global_data VALUES (73301, 0, 26, 0, 0, 310, 236);
INSERT INTO public.who_global_data VALUES (73302, 0, 0, 0, 0, 310, 150);
INSERT INTO public.who_global_data VALUES (73303, 4, 173, 0, 0, 310, 61);
INSERT INTO public.who_global_data VALUES (73304, 0, 5, 0, 0, 310, 7);
INSERT INTO public.who_global_data VALUES (73305, 62, 1446, 0, 17, 310, 169);
INSERT INTO public.who_global_data VALUES (73306, 4784, 56261, 505, 4019, 310, 28);
INSERT INTO public.who_global_data VALUES (73307, 5, 51, 0, 0, 310, 85);
INSERT INTO public.who_global_data VALUES (73308, 0, 37, 0, 0, 310, 211);
INSERT INTO public.who_global_data VALUES (73309, 0, 7, 0, 1, 310, 60);
INSERT INTO public.who_global_data VALUES (73310, 0, 3, 0, 1, 310, 3);
INSERT INTO public.who_global_data VALUES (73311, 0, 121, 0, 0, 310, 11);
INSERT INTO public.who_global_data VALUES (73312, 6156, 73522, 140, 872, 310, 89);
INSERT INTO public.who_global_data VALUES (73313, 34, 195, 0, 4, 310, 24);
INSERT INTO public.who_global_data VALUES (73314, 0, 69, 0, 0, 310, 162);
INSERT INTO public.who_global_data VALUES (73315, 61, 1375, 1, 50, 310, 100);
INSERT INTO public.who_global_data VALUES (73316, 0, 10, 0, 0, 310, 47);
INSERT INTO public.who_global_data VALUES (73317, 0, 9, 0, 0, 310, 29);
INSERT INTO public.who_global_data VALUES (73318, 11, 125, 1, 6, 310, 40);
INSERT INTO public.who_global_data VALUES (73319, 8, 77, 1, 3, 310, 222);
INSERT INTO public.who_global_data VALUES (73320, 3, 39, 0, 1, 310, 132);
INSERT INTO public.who_global_data VALUES (73321, 18, 78, 0, 1, 310, 130);
INSERT INTO public.who_global_data VALUES (73322, 14, 30, 0, 0, 310, 234);
INSERT INTO public.who_global_data VALUES (73323, 0, 9, 0, 0, 310, 23);
INSERT INTO public.who_global_data VALUES (73324, 7, 19, 0, 2, 310, 192);
INSERT INTO public.who_global_data VALUES (73325, 1, 16, 0, 0, 310, 69);
INSERT INTO public.who_global_data VALUES (73326, 0, 6, 0, 0, 310, 187);
INSERT INTO public.who_global_data VALUES (73327, 33, 172, 8, 10, 310, 230);
INSERT INTO public.who_global_data VALUES (73328, 60, 585, 1, 21, 310, 77);
INSERT INTO public.who_global_data VALUES (73329, 85, 1220, 0, 2, 310, 9);
INSERT INTO public.who_global_data VALUES (73330, 329, 1965, 12, 50, 310, 74);
INSERT INTO public.who_global_data VALUES (73331, 113, 1790, 13, 170, 310, 224);
INSERT INTO public.who_global_data VALUES (73332, 2875, 50468, 124, 3160, 310, 199);
INSERT INTO public.who_global_data VALUES (73333, 78, 772, 4, 54, 310, 190);
INSERT INTO public.who_global_data VALUES (73334, 212, 3447, 14, 85, 310, 12);
INSERT INTO public.who_global_data VALUES (73335, 13, 65, 0, 0, 310, 104);
INSERT INTO public.who_global_data VALUES (73336, 738, 5722, 4, 21, 310, 153);
INSERT INTO public.who_global_data VALUES (73337, 4782, 110574, 727, 13157, 310, 91);
INSERT INTO public.who_global_data VALUES (73338, 2, 38, 0, 1, 310, 215);
INSERT INTO public.who_global_data VALUES (73339, 206, 2384, 0, 57, 310, 84);
INSERT INTO public.who_global_data VALUES (73340, 18, 81, 0, 2, 310, 231);
INSERT INTO public.who_global_data VALUES (73341, 4, 278, 0, 5, 310, 196);
INSERT INTO public.who_global_data VALUES (73342, 49, 435, 0, 3, 310, 105);
INSERT INTO public.who_global_data VALUES (73343, 22, 81, 0, 1, 310, 122);
INSERT INTO public.who_global_data VALUES (73344, 0, 0, 0, 0, 310, 159);
INSERT INTO public.who_global_data VALUES (73345, 0, 125, 0, 1, 310, 75);
INSERT INTO public.who_global_data VALUES (73346, 25, 342, 0, 0, 310, 27);
INSERT INTO public.who_global_data VALUES (73347, 4, 115, 0, 0, 310, 54);
INSERT INTO public.who_global_data VALUES (73348, 1, 10, 0, 0, 310, 226);
INSERT INTO public.who_global_data VALUES (73349, 48, 446, 0, 0, 310, 79);
INSERT INTO public.who_global_data VALUES (73350, 15, 494, 4, 16, 310, 56);
INSERT INTO public.who_global_data VALUES (73351, 0, 0, 0, 0, 310, 117);
INSERT INTO public.who_global_data VALUES (73352, 0, 6, 0, 0, 310, 152);
INSERT INTO public.who_global_data VALUES (73353, 0, 10, 0, 0, 310, 16);
INSERT INTO public.who_global_data VALUES (73354, 3, 76, 0, 0, 310, 10);
INSERT INTO public.who_global_data VALUES (73355, 67, 579, 1, 9, 310, 201);
INSERT INTO public.who_global_data VALUES (73356, 141, 2319, 6, 29, 310, 174);
INSERT INTO public.who_global_data VALUES (73357, 6, 59, 0, 0, 310, 119);
INSERT INTO public.who_global_data VALUES (73358, 0, 0, 0, 0, 310, 168);
INSERT INTO public.who_global_data VALUES (73359, 142, 2908, 2, 45, 310, 99);
INSERT INTO public.who_global_data VALUES (73360, 1, 19, 0, 0, 310, 171);
INSERT INTO public.who_global_data VALUES (73361, 10, 28, 0, 0, 310, 87);
INSERT INTO public.who_global_data VALUES (73362, 7, 195, 0, 0, 310, 123);
INSERT INTO public.who_global_data VALUES (73363, 0, 0, 0, 0, 310, 151);
INSERT INTO public.who_global_data VALUES (73364, 9, 128, 1, 3, 310, 213);
INSERT INTO public.who_global_data VALUES (73365, 0, 5, 0, 0, 310, 118);
INSERT INTO public.who_global_data VALUES (73366, 11, 154, 0, 5, 310, 134);
INSERT INTO public.who_global_data VALUES (73367, 15, 116, 2, 2, 310, 65);
INSERT INTO public.who_global_data VALUES (73368, 121, 1215, 1, 29, 310, 102);
INSERT INTO public.who_global_data VALUES (73369, 0, 0, 0, 0, 310, 223);
INSERT INTO public.who_global_data VALUES (73370, 3, 40, 0, 0, 310, 4);
INSERT INTO public.who_global_data VALUES (73371, 0, 14, 0, 0, 310, 146);
INSERT INTO public.who_global_data VALUES (73372, 20, 160, 0, 2, 310, 31);
INSERT INTO public.who_global_data VALUES (73373, 0, 5, 0, 0, 310, 127);
INSERT INTO public.who_global_data VALUES (73374, 38, 676, 3, 40, 310, 22);
INSERT INTO public.who_global_data VALUES (73375, 2, 10, 0, 0, 310, 115);
INSERT INTO public.who_global_data VALUES (73376, 1, 16, 0, 1, 310, 106);
INSERT INTO public.who_global_data VALUES (73377, 2, 13, 0, 0, 310, 90);
INSERT INTO public.who_global_data VALUES (73378, 0, 0, 0, 0, 310, 70);
INSERT INTO public.who_global_data VALUES (73379, 0, 5, 0, 0, 310, 46);
INSERT INTO public.who_global_data VALUES (73380, 1008, 13460, 133, 1137, 310, 139);
INSERT INTO public.who_global_data VALUES (73381, 1, 17, 0, 0, 310, 42);
INSERT INTO public.who_global_data VALUES (73382, 76, 723, 0, 1, 310, 80);
INSERT INTO public.who_global_data VALUES (73383, 1, 5, 0, 1, 310, 203);
INSERT INTO public.who_global_data VALUES (73384, 54, 74, 2, 5, 310, 136);
INSERT INTO public.who_global_data VALUES (73385, 35, 174, 0, 2, 310, 63);
INSERT INTO public.who_global_data VALUES (73386, 0, 0, 0, 0, 310, 17);
INSERT INTO public.who_global_data VALUES (73387, 0, 6, 0, 0, 310, 172);
INSERT INTO public.who_global_data VALUES (73388, 0, 354, 0, 11, 310, 109);
INSERT INTO public.who_global_data VALUES (73389, 218, 4665, 4, 32, 310, 200);
INSERT INTO public.who_global_data VALUES (73390, 21, 155, 0, 1, 310, 93);
INSERT INTO public.who_global_data VALUES (73391, 21, 231, 0, 1, 310, 5);
INSERT INTO public.who_global_data VALUES (73392, 0, 712, 0, 11, 310, 214);
INSERT INTO public.who_global_data VALUES (73393, 252, 2291, 5, 31, 310, 204);
INSERT INTO public.who_global_data VALUES (73394, 0, 0, 0, 0, 310, 198);
INSERT INTO public.who_global_data VALUES (73395, 192, 1181, 6, 30, 310, 173);
INSERT INTO public.who_global_data VALUES (73396, 0, 1, 0, 0, 310, 229);
INSERT INTO public.who_global_data VALUES (73397, 4, 69, 0, 3, 310, 76);
INSERT INTO public.who_global_data VALUES (73398, 258, 1323, 0, 24, 310, 138);
INSERT INTO public.who_global_data VALUES (73399, 0, 2311, 0, 96, 310, 98);
INSERT INTO public.who_global_data VALUES (73400, 0, 0, 0, 0, 310, 103);
INSERT INTO public.who_global_data VALUES (73401, 243, 2554, 10, 43, 310, 225);
INSERT INTO public.who_global_data VALUES (73402, 808, 8251, 27, 187, 310, 131);
INSERT INTO public.who_global_data VALUES (73403, 47, 286, 3, 11, 310, 235);
INSERT INTO public.who_global_data VALUES (73404, 54, 835, 0, 2, 310, 137);
INSERT INTO public.who_global_data VALUES (73405, 89, 9976, 4, 169, 310, 81);
INSERT INTO public.who_global_data VALUES (73406, 0, 423, 0, 5, 310, 182);
INSERT INTO public.who_global_data VALUES (73407, 34, 281, 0, 0, 310, 145);
INSERT INTO public.who_global_data VALUES (73408, 215, 2460, 16, 85, 310, 26);
INSERT INTO public.who_global_data VALUES (73409, 0, 2777, 0, 24, 310, 170);
INSERT INTO public.who_global_data VALUES (73410, 7, 82, 0, 0, 310, 191);
INSERT INTO public.who_global_data VALUES (73411, 0, 0, 0, 0, 310, 221);
INSERT INTO public.who_global_data VALUES (73412, 0, 6, 0, 0, 310, 64);
INSERT INTO public.who_global_data VALUES (73413, 0, 0, 0, 0, 310, 116);
INSERT INTO public.who_global_data VALUES (73414, 0, 8, 0, 0, 310, 128);
INSERT INTO public.who_global_data VALUES (73415, 4, 13, 0, 0, 310, 6);
INSERT INTO public.who_global_data VALUES (73416, 3, 21, 0, 2, 310, 227);
INSERT INTO public.who_global_data VALUES (73417, 0, 0, 0, 0, 310, 68);
INSERT INTO public.who_global_data VALUES (73418, 0, 1, 0, 0, 310, 184);
INSERT INTO public.who_global_data VALUES (73419, 0, 0, 0, 0, 310, 82);
INSERT INTO public.who_global_data VALUES (73420, 0, 236, 0, 28, 310, 149);
INSERT INTO public.who_global_data VALUES (73421, 0, 0, 0, 0, 310, 197);
INSERT INTO public.who_global_data VALUES (73422, 165, 1885, 5, 21, 310, 78);
INSERT INTO public.who_global_data VALUES (73423, 15, 190, 1, 1, 310, 233);
INSERT INTO public.who_global_data VALUES (73424, 160, 1060, 0, 13, 310, 133);
INSERT INTO public.who_global_data VALUES (73425, 2, 10, 0, 0, 310, 35);
INSERT INTO public.who_global_data VALUES (73426, 1, 2, 0, 0, 310, 114);
INSERT INTO public.who_global_data VALUES (73427, 74, 1000, 0, 3, 310, 237);
INSERT INTO public.who_global_data VALUES (73428, 2, 2, 0, 0, 310, 55);
INSERT INTO public.who_global_data VALUES (73429, 0, 6, 0, 0, 310, 176);
INSERT INTO public.who_global_data VALUES (73430, 37, 400, 0, 0, 310, 202);
INSERT INTO public.who_global_data VALUES (73431, 55, 897, 1, 20, 310, 155);
INSERT INTO public.who_global_data VALUES (73432, 0, 0, 0, 0, 310, 32);
INSERT INTO public.who_global_data VALUES (73433, 0, 5, 0, 0, 310, 220);
INSERT INTO public.who_global_data VALUES (73434, 27, 1380, 0, 5, 310, 30);
INSERT INTO public.who_global_data VALUES (73435, 0, 0, 0, 0, 310, 147);
INSERT INTO public.who_global_data VALUES (73436, 7926, 124355, 899, 10390, 310, 208);
INSERT INTO public.who_global_data VALUES (73437, 5, 148, 1, 3, 310, 45);
INSERT INTO public.who_global_data VALUES (73438, 0, 7, 0, 2, 310, 110);
INSERT INTO public.who_global_data VALUES (73439, 0, 8, 0, 0, 310, 88);
INSERT INTO public.who_global_data VALUES (73440, 474, 4834, 48, 332, 310, 51);
INSERT INTO public.who_global_data VALUES (73441, 1013, 20053, 57, 540, 310, 209);
INSERT INTO public.who_global_data VALUES (73442, 0, 10, 0, 2, 310, 205);
INSERT INTO public.who_global_data VALUES (73443, 0, 0, 0, 0, 310, 18);
INSERT INTO public.who_global_data VALUES (73444, 104, 1875, 3, 15, 310, 72);
INSERT INTO public.who_global_data VALUES (73445, 4514, 38468, 672, 3125, 310, 44);
INSERT INTO public.who_global_data VALUES (73446, 0, 1, 0, 0, 310, 15);
INSERT INTO public.who_global_data VALUES (73447, 2, 36, 1, 2, 310, 25);
INSERT INTO public.who_global_data VALUES (73448, 0, 0, 0, 0, 310, 179);
INSERT INTO public.who_global_data VALUES (73449, 0, 0, 0, 0, 310, 34);
INSERT INTO public.who_global_data VALUES (73450, 4, 89, 2, 5, 310, 207);
INSERT INTO public.who_global_data VALUES (73451, 61, 455, 3, 13, 310, 166);
INSERT INTO public.who_global_data VALUES (73452, 2148, 15679, 63, 277, 310, 126);
INSERT INTO public.who_global_data VALUES (73453, 0, 0, 0, 0, 310, 97);
INSERT INTO public.who_global_data VALUES (73454, 0, 5, 0, 0, 310, 36);
INSERT INTO public.who_global_data VALUES (73455, 0, 0, 0, 0, 310, 125);
INSERT INTO public.who_global_data VALUES (73456, 11, 44, 0, 0, 310, 124);
INSERT INTO public.who_global_data VALUES (73457, 135, 804, 3, 20, 310, 185);
INSERT INTO public.who_global_data VALUES (73458, 150, 814, 2, 8, 310, 194);
INSERT INTO public.who_global_data VALUES (73459, 0, 20, 0, 1, 310, 144);
INSERT INTO public.who_global_data VALUES (73460, 24103, 187302, 996, 3846, 310, 19);
INSERT INTO public.who_global_data VALUES (73461, 0, 30, 0, 0, 310, 217);
INSERT INTO public.who_global_data VALUES (73462, 18, 338, 1, 2, 310, 148);
INSERT INTO public.who_global_data VALUES (73463, 17, 190, 0, 2, 310, 86);
INSERT INTO public.who_global_data VALUES (73464, 0, 0, 0, 0, 310, 13);
INSERT INTO public.who_global_data VALUES (73465, 14, 143, 0, 3, 310, 157);
INSERT INTO public.who_global_data VALUES (73466, 4, 216, 0, 0, 310, 8);
INSERT INTO public.who_global_data VALUES (73467, 0, 0, 0, 0, 310, 73);
INSERT INTO public.who_global_data VALUES (73468, 0, 0, 0, 0, 310, 101);
INSERT INTO public.who_global_data VALUES (73469, 1, 36, 0, 0, 310, 165);
INSERT INTO public.who_global_data VALUES (73470, 0, 8, 0, 1, 310, 14);
INSERT INTO public.who_global_data VALUES (73471, 26, 192, 0, 4, 311, 193);
INSERT INTO public.who_global_data VALUES (73472, 34, 239, 2, 14, 311, 113);
INSERT INTO public.who_global_data VALUES (73473, 73, 584, 4, 35, 311, 143);
INSERT INTO public.who_global_data VALUES (73474, 0, 0, 0, 0, 311, 219);
INSERT INTO public.who_global_data VALUES (73475, 20, 396, 1, 13, 311, 186);
INSERT INTO public.who_global_data VALUES (73476, 0, 7, 1, 2, 311, 52);
INSERT INTO public.who_global_data VALUES (73477, 0, 2, 0, 0, 311, 180);
INSERT INTO public.who_global_data VALUES (73478, 0, 7, 0, 0, 311, 167);
INSERT INTO public.who_global_data VALUES (73479, 146, 966, 4, 24, 311, 154);
INSERT INTO public.who_global_data VALUES (73480, 50, 509, 0, 3, 311, 94);
INSERT INTO public.who_global_data VALUES (73481, 5, 55, 0, 0, 311, 66);
INSERT INTO public.who_global_data VALUES (73482, 303, 4860, 1, 20, 311, 58);
INSERT INTO public.who_global_data VALUES (73483, 564, 10182, 20, 128, 311, 163);
INSERT INTO public.who_global_data VALUES (73484, 25, 298, 1, 5, 311, 37);
INSERT INTO public.who_global_data VALUES (73485, 0, 14, 0, 0, 311, 142);
INSERT INTO public.who_global_data VALUES (73486, 2, 569, 0, 4, 311, 83);
INSERT INTO public.who_global_data VALUES (73487, 5, 54, 1, 6, 311, 228);
INSERT INTO public.who_global_data VALUES (73488, 0, 33, 0, 0, 311, 188);
INSERT INTO public.who_global_data VALUES (73489, 40, 192, 2, 2, 311, 62);
INSERT INTO public.who_global_data VALUES (73490, 1681, 17077, 208, 1380, 311, 160);
INSERT INTO public.who_global_data VALUES (73491, 0, 3, 0, 0, 311, 50);
INSERT INTO public.who_global_data VALUES (73492, 3, 9, 0, 0, 311, 33);
INSERT INTO public.who_global_data VALUES (73493, 5, 27, 0, 0, 311, 183);
INSERT INTO public.who_global_data VALUES (73494, 0, 4, 0, 0, 311, 92);
INSERT INTO public.who_global_data VALUES (73495, 10, 107, 1, 6, 311, 158);
INSERT INTO public.who_global_data VALUES (73496, 0, 0, 0, 0, 311, 67);
INSERT INTO public.who_global_data VALUES (73497, 51, 464, 1, 13, 311, 57);
INSERT INTO public.who_global_data VALUES (73498, 3, 3, 0, 0, 311, 38);
INSERT INTO public.who_global_data VALUES (73499, 323, 4579, 23, 159, 311, 141);
INSERT INTO public.who_global_data VALUES (73500, 1, 3, 0, 0, 311, 178);
INSERT INTO public.who_global_data VALUES (73501, 2, 129, 0, 1, 311, 108);
INSERT INTO public.who_global_data VALUES (73502, 40, 399, 0, 8, 311, 39);
INSERT INTO public.who_global_data VALUES (73503, 15, 261, 2, 14, 311, 2);
INSERT INTO public.who_global_data VALUES (73504, 2, 2, 0, 0, 311, 195);
INSERT INTO public.who_global_data VALUES (73505, 0, 5, 0, 1, 311, 107);
INSERT INTO public.who_global_data VALUES (73506, 2, 109, 0, 0, 311, 161);
INSERT INTO public.who_global_data VALUES (73507, 0, 139, 0, 6, 311, 212);
INSERT INTO public.who_global_data VALUES (73508, 1378, 7695, 23, 89, 311, 181);
INSERT INTO public.who_global_data VALUES (73509, 0, 12, 0, 1, 311, 53);
INSERT INTO public.who_global_data VALUES (73510, 0, 6, 0, 0, 311, 164);
INSERT INTO public.who_global_data VALUES (73511, 2, 7, 0, 0, 311, 140);
INSERT INTO public.who_global_data VALUES (73512, 289, 2738, 4, 12, 311, 20);
INSERT INTO public.who_global_data VALUES (73513, 93, 82638, 7, 3321, 311, 112);
INSERT INTO public.who_global_data VALUES (73514, 96, 798, 4, 14, 311, 111);
INSERT INTO public.who_global_data VALUES (73515, 0, 0, 0, 0, 311, 71);
INSERT INTO public.who_global_data VALUES (73516, 3, 22, 2, 2, 311, 218);
INSERT INTO public.who_global_data VALUES (73517, 0, 0, 0, 0, 311, 43);
INSERT INTO public.who_global_data VALUES (73518, 0, 314, 0, 2, 311, 49);
INSERT INTO public.who_global_data VALUES (73519, 0, 169, 0, 0, 311, 1);
INSERT INTO public.who_global_data VALUES (73520, 77, 867, 0, 6, 311, 48);
INSERT INTO public.who_global_data VALUES (73521, 16, 186, 2, 6, 311, 232);
INSERT INTO public.who_global_data VALUES (73522, 0, 11, 0, 1, 311, 175);
INSERT INTO public.who_global_data VALUES (73523, 32, 262, 1, 8, 311, 21);
INSERT INTO public.who_global_data VALUES (73524, 306, 3308, 7, 31, 311, 156);
INSERT INTO public.who_global_data VALUES (73525, 0, 0, 0, 0, 311, 95);
INSERT INTO public.who_global_data VALUES (73526, 11, 109, 1, 9, 311, 177);
INSERT INTO public.who_global_data VALUES (73527, 283, 2860, 13, 90, 311, 210);
INSERT INTO public.who_global_data VALUES (73528, 3, 34, 0, 0, 311, 120);
INSERT INTO public.who_global_data VALUES (73529, 0, 11, 0, 0, 311, 135);
INSERT INTO public.who_global_data VALUES (73530, 208, 1109, 9, 51, 311, 206);
INSERT INTO public.who_global_data VALUES (73531, 278, 2240, 0, 8, 311, 189);
INSERT INTO public.who_global_data VALUES (73532, 54, 710, 5, 46, 311, 129);
INSERT INTO public.who_global_data VALUES (73533, 0, 30, 0, 0, 311, 121);
INSERT INTO public.who_global_data VALUES (73534, 0, 14, 0, 0, 311, 59);
INSERT INTO public.who_global_data VALUES (73535, 0, 6, 0, 0, 311, 96);
INSERT INTO public.who_global_data VALUES (73536, 30, 745, 1, 4, 311, 41);
INSERT INTO public.who_global_data VALUES (73537, 0, 9, 0, 0, 311, 216);
INSERT INTO public.who_global_data VALUES (73538, 3, 26, 0, 0, 311, 236);
INSERT INTO public.who_global_data VALUES (73539, 0, 0, 0, 0, 311, 150);
INSERT INTO public.who_global_data VALUES (73540, 1, 169, 0, 0, 311, 61);
INSERT INTO public.who_global_data VALUES (73541, 0, 5, 0, 0, 311, 7);
INSERT INTO public.who_global_data VALUES (73542, 71, 1384, 4, 17, 311, 169);
INSERT INTO public.who_global_data VALUES (73543, 7500, 51477, 497, 3514, 311, 28);
INSERT INTO public.who_global_data VALUES (73544, 3, 46, 0, 0, 311, 85);
INSERT INTO public.who_global_data VALUES (73545, 1, 37, 0, 0, 311, 211);
INSERT INTO public.who_global_data VALUES (73546, 0, 7, 0, 1, 311, 60);
INSERT INTO public.who_global_data VALUES (73547, 0, 3, 0, 1, 311, 3);
INSERT INTO public.who_global_data VALUES (73548, 6, 121, 0, 0, 311, 11);
INSERT INTO public.who_global_data VALUES (73549, 5453, 67366, 149, 732, 311, 89);
INSERT INTO public.who_global_data VALUES (73550, 9, 161, 0, 4, 311, 24);
INSERT INTO public.who_global_data VALUES (73551, 0, 69, 0, 0, 311, 162);
INSERT INTO public.who_global_data VALUES (73552, 102, 1314, 6, 49, 311, 100);
INSERT INTO public.who_global_data VALUES (73553, 0, 10, 0, 0, 311, 47);
INSERT INTO public.who_global_data VALUES (73554, 0, 9, 0, 0, 311, 29);
INSERT INTO public.who_global_data VALUES (73555, 8, 114, 1, 5, 311, 40);
INSERT INTO public.who_global_data VALUES (73556, 11, 69, 1, 2, 311, 222);
INSERT INTO public.who_global_data VALUES (73557, 0, 36, 0, 1, 311, 132);
INSERT INTO public.who_global_data VALUES (73558, 0, 60, 0, 1, 311, 130);
INSERT INTO public.who_global_data VALUES (73559, 0, 16, 0, 0, 311, 234);
INSERT INTO public.who_global_data VALUES (73560, 1, 9, 0, 0, 311, 23);
INSERT INTO public.who_global_data VALUES (73561, 4, 12, 1, 2, 311, 192);
INSERT INTO public.who_global_data VALUES (73562, 0, 15, 0, 0, 311, 69);
INSERT INTO public.who_global_data VALUES (73563, 0, 6, 0, 0, 311, 187);
INSERT INTO public.who_global_data VALUES (73564, 0, 139, 0, 2, 311, 230);
INSERT INTO public.who_global_data VALUES (73565, 33, 525, 4, 20, 311, 77);
INSERT INTO public.who_global_data VALUES (73566, 49, 1135, 0, 2, 311, 9);
INSERT INTO public.who_global_data VALUES (73567, 385, 1636, 6, 38, 311, 74);
INSERT INTO public.who_global_data VALUES (73568, 149, 1677, 21, 157, 311, 224);
INSERT INTO public.who_global_data VALUES (73569, 2987, 47593, 138, 3036, 311, 199);
INSERT INTO public.who_global_data VALUES (73570, 64, 694, 4, 50, 311, 190);
INSERT INTO public.who_global_data VALUES (73571, 325, 3235, 17, 71, 311, 12);
INSERT INTO public.who_global_data VALUES (73572, 0, 52, 0, 0, 311, 104);
INSERT INTO public.who_global_data VALUES (73573, 547, 4984, 1, 17, 311, 153);
INSERT INTO public.who_global_data VALUES (73574, 4053, 105792, 839, 12430, 311, 91);
INSERT INTO public.who_global_data VALUES (73575, 0, 36, 0, 1, 311, 215);
INSERT INTO public.who_global_data VALUES (73576, 225, 2178, 1, 57, 311, 84);
INSERT INTO public.who_global_data VALUES (73577, 0, 63, 0, 2, 311, 231);
INSERT INTO public.who_global_data VALUES (73578, 6, 274, 0, 5, 311, 196);
INSERT INTO public.who_global_data VALUES (73579, 38, 386, 1, 3, 311, 105);
INSERT INTO public.who_global_data VALUES (73580, 9, 59, 0, 1, 311, 122);
INSERT INTO public.who_global_data VALUES (73581, 0, 0, 0, 0, 311, 159);
INSERT INTO public.who_global_data VALUES (73582, 13, 125, 0, 1, 311, 75);
INSERT INTO public.who_global_data VALUES (73583, 28, 317, 0, 0, 311, 27);
INSERT INTO public.who_global_data VALUES (73584, 4, 111, 0, 0, 311, 54);
INSERT INTO public.who_global_data VALUES (73585, 0, 9, 0, 0, 311, 226);
INSERT INTO public.who_global_data VALUES (73586, 22, 398, 0, 0, 311, 79);
INSERT INTO public.who_global_data VALUES (73587, 16, 479, 0, 12, 311, 56);
INSERT INTO public.who_global_data VALUES (73588, 0, 0, 0, 0, 311, 117);
INSERT INTO public.who_global_data VALUES (73589, 3, 6, 0, 0, 311, 152);
INSERT INTO public.who_global_data VALUES (73590, 2, 10, 0, 0, 311, 16);
INSERT INTO public.who_global_data VALUES (73591, 4, 73, 0, 0, 311, 10);
INSERT INTO public.who_global_data VALUES (73592, 44, 512, 1, 8, 311, 201);
INSERT INTO public.who_global_data VALUES (73593, 190, 2178, 1, 23, 311, 174);
INSERT INTO public.who_global_data VALUES (73594, 7, 53, 0, 0, 311, 119);
INSERT INTO public.who_global_data VALUES (73595, 0, 0, 0, 0, 311, 168);
INSERT INTO public.who_global_data VALUES (73596, 140, 2766, 6, 43, 311, 99);
INSERT INTO public.who_global_data VALUES (73597, 1, 18, 0, 0, 311, 171);
INSERT INTO public.who_global_data VALUES (73598, 0, 18, 0, 0, 311, 87);
INSERT INTO public.who_global_data VALUES (73599, 19, 188, 0, 0, 311, 123);
INSERT INTO public.who_global_data VALUES (73600, 0, 0, 0, 0, 311, 151);
INSERT INTO public.who_global_data VALUES (73601, 8, 119, 0, 2, 311, 213);
INSERT INTO public.who_global_data VALUES (73602, 0, 5, 0, 0, 311, 118);
INSERT INTO public.who_global_data VALUES (73603, 15, 143, 3, 5, 311, 134);
INSERT INTO public.who_global_data VALUES (73604, 19, 101, 0, 0, 311, 65);
INSERT INTO public.who_global_data VALUES (73605, 101, 1094, 8, 28, 311, 102);
INSERT INTO public.who_global_data VALUES (73606, 0, 0, 0, 0, 311, 223);
INSERT INTO public.who_global_data VALUES (73607, 1, 37, 0, 0, 311, 4);
INSERT INTO public.who_global_data VALUES (73608, 2, 14, 0, 0, 311, 146);
INSERT INTO public.who_global_data VALUES (73609, 20, 140, 0, 2, 311, 31);
INSERT INTO public.who_global_data VALUES (73610, 0, 5, 0, 0, 311, 127);
INSERT INTO public.who_global_data VALUES (73611, 64, 638, 4, 37, 311, 22);
INSERT INTO public.who_global_data VALUES (73612, 0, 8, 0, 0, 311, 115);
INSERT INTO public.who_global_data VALUES (73613, 1, 15, 1, 1, 311, 106);
INSERT INTO public.who_global_data VALUES (73614, 0, 11, 0, 0, 311, 90);
INSERT INTO public.who_global_data VALUES (73615, 0, 0, 0, 0, 311, 70);
INSERT INTO public.who_global_data VALUES (73616, 0, 5, 0, 0, 311, 46);
INSERT INTO public.who_global_data VALUES (73617, 836, 12452, 168, 1004, 311, 139);
INSERT INTO public.who_global_data VALUES (73618, 1, 16, 0, 0, 311, 42);
INSERT INTO public.who_global_data VALUES (73619, 47, 647, 0, 1, 311, 80);
INSERT INTO public.who_global_data VALUES (73620, 0, 4, 0, 1, 311, 203);
INSERT INTO public.who_global_data VALUES (73621, 0, 20, 0, 3, 311, 136);
INSERT INTO public.who_global_data VALUES (73622, 28, 139, 1, 2, 311, 63);
INSERT INTO public.who_global_data VALUES (73623, 0, 0, 0, 0, 311, 17);
INSERT INTO public.who_global_data VALUES (73624, 4, 6, 0, 0, 311, 172);
INSERT INTO public.who_global_data VALUES (73625, 25, 354, 2, 11, 311, 109);
INSERT INTO public.who_global_data VALUES (73626, 221, 4447, 2, 28, 311, 200);
INSERT INTO public.who_global_data VALUES (73627, 17, 134, 0, 1, 311, 93);
INSERT INTO public.who_global_data VALUES (73628, 18, 210, 1, 1, 311, 5);
INSERT INTO public.who_global_data VALUES (73629, 0, 712, 0, 11, 311, 214);
INSERT INTO public.who_global_data VALUES (73630, 174, 2039, 1, 26, 311, 204);
INSERT INTO public.who_global_data VALUES (73631, 0, 0, 0, 0, 311, 198);
INSERT INTO public.who_global_data VALUES (73632, 0, 989, 0, 24, 311, 173);
INSERT INTO public.who_global_data VALUES (73633, 0, 1, 0, 0, 311, 229);
INSERT INTO public.who_global_data VALUES (73634, 1, 65, 0, 3, 311, 76);
INSERT INTO public.who_global_data VALUES (73635, 213, 1065, 13, 24, 311, 138);
INSERT INTO public.who_global_data VALUES (73636, 765, 2311, 18, 96, 311, 98);
INSERT INTO public.who_global_data VALUES (73637, 0, 0, 0, 0, 311, 103);
INSERT INTO public.who_global_data VALUES (73638, 256, 2311, 2, 33, 311, 225);
INSERT INTO public.who_global_data VALUES (73639, 1035, 7443, 20, 160, 311, 131);
INSERT INTO public.who_global_data VALUES (73640, 65, 239, 2, 8, 311, 235);
INSERT INTO public.who_global_data VALUES (73641, 88, 781, 1, 2, 311, 137);
INSERT INTO public.who_global_data VALUES (73642, 101, 9887, 3, 165, 311, 81);
INSERT INTO public.who_global_data VALUES (73643, 70, 423, 2, 5, 311, 182);
INSERT INTO public.who_global_data VALUES (73644, 40, 247, 0, 0, 311, 145);
INSERT INTO public.who_global_data VALUES (73645, 293, 2245, 25, 69, 311, 26);
INSERT INTO public.who_global_data VALUES (73646, 440, 2777, 7, 24, 311, 170);
INSERT INTO public.who_global_data VALUES (73647, 5, 75, 0, 0, 311, 191);
INSERT INTO public.who_global_data VALUES (73648, 0, 0, 0, 0, 311, 221);
INSERT INTO public.who_global_data VALUES (73649, 0, 6, 0, 0, 311, 64);
INSERT INTO public.who_global_data VALUES (73650, 0, 0, 0, 0, 311, 116);
INSERT INTO public.who_global_data VALUES (73651, 6, 8, 0, 0, 311, 128);
INSERT INTO public.who_global_data VALUES (73652, 0, 9, 0, 0, 311, 6);
INSERT INTO public.who_global_data VALUES (73653, 0, 18, 1, 2, 311, 227);
INSERT INTO public.who_global_data VALUES (73654, 0, 0, 0, 0, 311, 68);
INSERT INTO public.who_global_data VALUES (73655, 0, 1, 0, 0, 311, 184);
INSERT INTO public.who_global_data VALUES (73656, 0, 0, 0, 0, 311, 82);
INSERT INTO public.who_global_data VALUES (73657, 0, 236, 2, 28, 311, 149);
INSERT INTO public.who_global_data VALUES (73658, 0, 0, 0, 0, 311, 197);
INSERT INTO public.who_global_data VALUES (73659, 157, 1720, 6, 16, 311, 78);
INSERT INTO public.who_global_data VALUES (73660, 13, 175, 0, 0, 311, 233);
INSERT INTO public.who_global_data VALUES (73661, 115, 900, 0, 13, 311, 133);
INSERT INTO public.who_global_data VALUES (73662, 0, 8, 0, 0, 311, 35);
INSERT INTO public.who_global_data VALUES (73663, 1, 1, 0, 0, 311, 114);
INSERT INTO public.who_global_data VALUES (73664, 47, 926, 0, 3, 311, 237);
INSERT INTO public.who_global_data VALUES (73665, 0, 0, 0, 0, 311, 55);
INSERT INTO public.who_global_data VALUES (73666, 0, 6, 0, 0, 311, 176);
INSERT INTO public.who_global_data VALUES (73667, 27, 363, 0, 0, 311, 202);
INSERT INTO public.who_global_data VALUES (73668, 37, 842, 1, 19, 311, 155);
INSERT INTO public.who_global_data VALUES (73669, 0, 0, 0, 0, 311, 32);
INSERT INTO public.who_global_data VALUES (73670, 2, 5, 0, 0, 311, 220);
INSERT INTO public.who_global_data VALUES (73671, 27, 1353, 2, 5, 311, 30);
INSERT INTO public.who_global_data VALUES (73672, 0, 0, 0, 0, 311, 147);
INSERT INTO public.who_global_data VALUES (73673, 8008, 116429, 913, 9491, 311, 208);
INSERT INTO public.who_global_data VALUES (73674, 21, 143, 0, 2, 311, 45);
INSERT INTO public.who_global_data VALUES (73675, 0, 7, 0, 2, 311, 110);
INSERT INTO public.who_global_data VALUES (73676, 0, 8, 0, 0, 311, 88);
INSERT INTO public.who_global_data VALUES (73677, 416, 4360, 45, 284, 311, 51);
INSERT INTO public.who_global_data VALUES (73678, 1134, 19040, 44, 483, 311, 209);
INSERT INTO public.who_global_data VALUES (73679, 0, 10, 0, 2, 311, 205);
INSERT INTO public.who_global_data VALUES (73680, 0, 0, 0, 0, 311, 18);
INSERT INTO public.who_global_data VALUES (73681, 120, 1771, 2, 12, 311, 72);
INSERT INTO public.who_global_data VALUES (73682, 4273, 33954, 403, 2453, 311, 44);
INSERT INTO public.who_global_data VALUES (73683, 0, 1, 0, 0, 311, 15);
INSERT INTO public.who_global_data VALUES (73684, 0, 34, 0, 1, 311, 25);
INSERT INTO public.who_global_data VALUES (73685, 0, 0, 0, 0, 311, 179);
INSERT INTO public.who_global_data VALUES (73686, 0, 0, 0, 0, 311, 34);
INSERT INTO public.who_global_data VALUES (73687, 3, 85, 0, 3, 311, 207);
INSERT INTO public.who_global_data VALUES (73688, 32, 394, 1, 10, 311, 166);
INSERT INTO public.who_global_data VALUES (73689, 2704, 13531, 46, 214, 311, 126);
INSERT INTO public.who_global_data VALUES (73690, 0, 0, 0, 0, 311, 97);
INSERT INTO public.who_global_data VALUES (73691, 0, 5, 0, 0, 311, 36);
INSERT INTO public.who_global_data VALUES (73692, 0, 0, 0, 0, 311, 125);
INSERT INTO public.who_global_data VALUES (73693, 0, 33, 0, 0, 311, 124);
INSERT INTO public.who_global_data VALUES (73694, 120, 669, 4, 17, 311, 185);
INSERT INTO public.who_global_data VALUES (73695, 0, 664, 0, 6, 311, 194);
INSERT INTO public.who_global_data VALUES (73696, 1, 20, 1, 1, 311, 144);
INSERT INTO public.who_global_data VALUES (73697, 22559, 163199, 452, 2850, 311, 19);
INSERT INTO public.who_global_data VALUES (73698, 0, 30, 0, 0, 311, 217);
INSERT INTO public.who_global_data VALUES (73699, 11, 320, 1, 1, 311, 148);
INSERT INTO public.who_global_data VALUES (73700, 6, 173, 0, 2, 311, 86);
INSERT INTO public.who_global_data VALUES (73701, 0, 0, 0, 0, 311, 13);
INSERT INTO public.who_global_data VALUES (73702, 0, 129, 0, 3, 311, 157);
INSERT INTO public.who_global_data VALUES (73703, 9, 212, 0, 0, 311, 8);
INSERT INTO public.who_global_data VALUES (73704, 0, 0, 0, 0, 311, 73);
INSERT INTO public.who_global_data VALUES (73705, 0, 0, 0, 0, 311, 101);
INSERT INTO public.who_global_data VALUES (73706, 0, 35, 0, 0, 311, 165);
INSERT INTO public.who_global_data VALUES (73707, 0, 8, 0, 1, 311, 14);
INSERT INTO public.who_global_data VALUES (73708, 52, 166, 0, 4, 312, 193);
INSERT INTO public.who_global_data VALUES (73709, 20, 205, 2, 12, 312, 113);
INSERT INTO public.who_global_data VALUES (73710, 57, 511, 2, 31, 312, 143);
INSERT INTO public.who_global_data VALUES (73711, 0, 0, 0, 0, 312, 219);
INSERT INTO public.who_global_data VALUES (73712, 6, 376, 4, 12, 312, 186);
INSERT INTO public.who_global_data VALUES (73713, 5, 7, 1, 1, 312, 52);
INSERT INTO public.who_global_data VALUES (73714, 0, 2, 0, 0, 312, 180);
INSERT INTO public.who_global_data VALUES (73715, 0, 7, 0, 0, 312, 167);
INSERT INTO public.who_global_data VALUES (73716, 75, 820, 1, 20, 312, 154);
INSERT INTO public.who_global_data VALUES (73717, 58, 459, 0, 3, 312, 94);
INSERT INTO public.who_global_data VALUES (73718, 4, 50, 0, 0, 312, 66);
INSERT INTO public.who_global_data VALUES (73719, 312, 4557, 1, 19, 312, 58);
INSERT INTO public.who_global_data VALUES (73720, 805, 9618, 22, 108, 312, 163);
INSERT INTO public.who_global_data VALUES (73721, 83, 273, 0, 4, 312, 37);
INSERT INTO public.who_global_data VALUES (73722, 4, 14, 0, 0, 312, 142);
INSERT INTO public.who_global_data VALUES (73723, 52, 567, 0, 4, 312, 83);
INSERT INTO public.who_global_data VALUES (73724, 0, 49, 0, 5, 312, 228);
INSERT INTO public.who_global_data VALUES (73725, 7, 33, 0, 0, 312, 188);
INSERT INTO public.who_global_data VALUES (73726, 58, 152, 0, 0, 312, 62);
INSERT INTO public.who_global_data VALUES (73727, 1738, 15396, 170, 1172, 312, 160);
INSERT INTO public.who_global_data VALUES (73728, 1, 3, 0, 0, 312, 50);
INSERT INTO public.who_global_data VALUES (73729, 0, 6, 0, 0, 312, 33);
INSERT INTO public.who_global_data VALUES (73730, 0, 22, 0, 0, 312, 183);
INSERT INTO public.who_global_data VALUES (73731, 0, 4, 0, 0, 312, 92);
INSERT INTO public.who_global_data VALUES (73732, 23, 97, 5, 5, 312, 158);
INSERT INTO public.who_global_data VALUES (73733, 0, 0, 0, 0, 312, 67);
INSERT INTO public.who_global_data VALUES (73734, 54, 413, 3, 12, 312, 57);
INSERT INTO public.who_global_data VALUES (73735, 0, 0, 0, 0, 312, 38);
INSERT INTO public.who_global_data VALUES (73736, 352, 4256, 22, 136, 312, 141);
INSERT INTO public.who_global_data VALUES (73737, 0, 2, 0, 0, 312, 178);
INSERT INTO public.who_global_data VALUES (73738, 1, 127, 0, 1, 312, 108);
INSERT INTO public.who_global_data VALUES (73739, 13, 359, 0, 8, 312, 39);
INSERT INTO public.who_global_data VALUES (73740, 24, 246, 0, 12, 312, 2);
INSERT INTO public.who_global_data VALUES (73741, 0, 0, 0, 0, 312, 195);
INSERT INTO public.who_global_data VALUES (73742, 0, 5, 0, 1, 312, 107);
INSERT INTO public.who_global_data VALUES (73743, 0, 107, 0, 0, 312, 161);
INSERT INTO public.who_global_data VALUES (73744, 26, 139, 4, 6, 312, 212);
INSERT INTO public.who_global_data VALUES (73745, 662, 6317, 5, 66, 312, 181);
INSERT INTO public.who_global_data VALUES (73746, 4, 12, 0, 1, 312, 53);
INSERT INTO public.who_global_data VALUES (73747, 0, 6, 0, 0, 312, 164);
INSERT INTO public.who_global_data VALUES (73748, 0, 5, 0, 0, 312, 140);
INSERT INTO public.who_global_data VALUES (73749, 540, 2449, 2, 8, 312, 20);
INSERT INTO public.who_global_data VALUES (73750, 90, 82545, 4, 3314, 312, 112);
INSERT INTO public.who_global_data VALUES (73751, 94, 702, 4, 10, 312, 111);
INSERT INTO public.who_global_data VALUES (73752, 0, 0, 0, 0, 312, 71);
INSERT INTO public.who_global_data VALUES (73753, 0, 19, 0, 0, 312, 218);
INSERT INTO public.who_global_data VALUES (73754, 0, 0, 0, 0, 312, 43);
INSERT INTO public.who_global_data VALUES (73755, 19, 314, 0, 2, 312, 49);
INSERT INTO public.who_global_data VALUES (73756, 4, 169, 0, 0, 312, 1);
INSERT INTO public.who_global_data VALUES (73757, 77, 790, 0, 6, 312, 48);
INSERT INTO public.who_global_data VALUES (73758, 51, 170, 1, 4, 312, 232);
INSERT INTO public.who_global_data VALUES (73759, 4, 11, 0, 1, 312, 175);
INSERT INTO public.who_global_data VALUES (73760, 16, 230, 1, 7, 312, 21);
INSERT INTO public.who_global_data VALUES (73761, 173, 3002, 8, 24, 312, 156);
INSERT INTO public.who_global_data VALUES (73762, 0, 0, 0, 0, 312, 95);
INSERT INTO public.who_global_data VALUES (73763, 17, 98, 0, 8, 312, 177);
INSERT INTO public.who_global_data VALUES (73764, 182, 2577, 5, 77, 312, 210);
INSERT INTO public.who_global_data VALUES (73765, 5, 31, 0, 0, 312, 120);
INSERT INTO public.who_global_data VALUES (73766, 0, 11, 0, 0, 312, 135);
INSERT INTO public.who_global_data VALUES (73767, 320, 901, 22, 42, 312, 206);
INSERT INTO public.who_global_data VALUES (73768, 127, 1962, 0, 8, 312, 189);
INSERT INTO public.who_global_data VALUES (73769, 47, 656, 1, 41, 312, 129);
INSERT INTO public.who_global_data VALUES (73770, 6, 30, 0, 0, 312, 121);
INSERT INTO public.who_global_data VALUES (73771, 1, 14, 0, 0, 312, 59);
INSERT INTO public.who_global_data VALUES (73772, 0, 6, 0, 0, 312, 96);
INSERT INTO public.who_global_data VALUES (73773, 36, 715, 0, 3, 312, 41);
INSERT INTO public.who_global_data VALUES (73774, 0, 9, 0, 0, 312, 216);
INSERT INTO public.who_global_data VALUES (73775, 2, 23, 0, 0, 312, 236);
INSERT INTO public.who_global_data VALUES (73776, 0, 0, 0, 0, 312, 150);
INSERT INTO public.who_global_data VALUES (73777, 9, 168, 0, 0, 312, 61);
INSERT INTO public.who_global_data VALUES (73778, 0, 5, 0, 0, 312, 7);
INSERT INTO public.who_global_data VALUES (73779, 95, 1313, 2, 13, 312, 169);
INSERT INTO public.who_global_data VALUES (73780, 4341, 43977, 415, 3017, 312, 28);
INSERT INTO public.who_global_data VALUES (73781, 12, 43, 0, 0, 312, 85);
INSERT INTO public.who_global_data VALUES (73782, 1, 36, 0, 0, 312, 211);
INSERT INTO public.who_global_data VALUES (73783, 0, 7, 0, 1, 312, 60);
INSERT INTO public.who_global_data VALUES (73784, 0, 3, 0, 1, 312, 3);
INSERT INTO public.who_global_data VALUES (73785, 12, 115, 0, 0, 312, 11);
INSERT INTO public.who_global_data VALUES (73786, 4615, 61913, 128, 583, 312, 89);
INSERT INTO public.who_global_data VALUES (73787, 0, 152, 0, 4, 312, 24);
INSERT INTO public.who_global_data VALUES (73788, 4, 69, 0, 0, 312, 162);
INSERT INTO public.who_global_data VALUES (73789, 56, 1212, 5, 43, 312, 100);
INSERT INTO public.who_global_data VALUES (73790, 0, 10, 0, 0, 312, 47);
INSERT INTO public.who_global_data VALUES (73791, 2, 9, 0, 0, 312, 29);
INSERT INTO public.who_global_data VALUES (73792, 10, 106, 2, 4, 312, 40);
INSERT INTO public.who_global_data VALUES (73793, 2, 58, 0, 1, 312, 222);
INSERT INTO public.who_global_data VALUES (73794, 2, 36, 0, 1, 312, 132);
INSERT INTO public.who_global_data VALUES (73795, 15, 60, 1, 1, 312, 130);
INSERT INTO public.who_global_data VALUES (73796, 0, 16, 0, 0, 312, 234);
INSERT INTO public.who_global_data VALUES (73797, 6, 8, 0, 0, 312, 23);
INSERT INTO public.who_global_data VALUES (73798, -1, 8, 0, 1, 312, 192);
INSERT INTO public.who_global_data VALUES (73799, 0, 15, 0, 0, 312, 69);
INSERT INTO public.who_global_data VALUES (73800, 0, 6, 0, 0, 312, 187);
INSERT INTO public.who_global_data VALUES (73801, 29, 139, 0, 2, 312, 230);
INSERT INTO public.who_global_data VALUES (73802, 45, 492, 1, 16, 312, 77);
INSERT INTO public.who_global_data VALUES (73803, 66, 1086, 0, 2, 312, 9);
INSERT INTO public.who_global_data VALUES (73804, 180, 1251, 3, 32, 312, 74);
INSERT INTO public.who_global_data VALUES (73805, 114, 1528, 14, 136, 312, 224);
INSERT INTO public.who_global_data VALUES (73806, 3111, 44606, 141, 2898, 312, 199);
INSERT INTO public.who_global_data VALUES (73807, 83, 630, 4, 46, 312, 190);
INSERT INTO public.who_global_data VALUES (73808, 295, 2910, 8, 54, 312, 12);
INSERT INTO public.who_global_data VALUES (73809, 10, 52, 0, 0, 312, 104);
INSERT INTO public.who_global_data VALUES (73810, 532, 4437, 3, 16, 312, 153);
INSERT INTO public.who_global_data VALUES (73811, 4050, 101739, 810, 11591, 312, 91);
INSERT INTO public.who_global_data VALUES (73812, 4, 36, 0, 1, 312, 215);
INSERT INTO public.who_global_data VALUES (73813, 87, 1953, 2, 56, 312, 84);
INSERT INTO public.who_global_data VALUES (73814, 0, 63, 0, 2, 312, 231);
INSERT INTO public.who_global_data VALUES (73815, 9, 268, 1, 5, 312, 196);
INSERT INTO public.who_global_data VALUES (73816, 36, 348, 1, 2, 312, 105);
INSERT INTO public.who_global_data VALUES (73817, 12, 50, 0, 1, 312, 122);
INSERT INTO public.who_global_data VALUES (73818, 0, 0, 0, 0, 312, 159);
INSERT INTO public.who_global_data VALUES (73819, 6, 112, 0, 1, 312, 75);
INSERT INTO public.who_global_data VALUES (73820, 23, 289, 0, 0, 312, 27);
INSERT INTO public.who_global_data VALUES (73821, 23, 107, 0, 0, 312, 54);
INSERT INTO public.who_global_data VALUES (73822, 1, 9, 0, 0, 312, 226);
INSERT INTO public.who_global_data VALUES (73823, 0, 376, 0, 0, 312, 79);
INSERT INTO public.who_global_data VALUES (73824, 17, 463, 1, 12, 312, 56);
INSERT INTO public.who_global_data VALUES (73825, 0, 0, 0, 0, 312, 117);
INSERT INTO public.who_global_data VALUES (73826, 0, 3, 0, 0, 312, 152);
INSERT INTO public.who_global_data VALUES (73827, 0, 8, 0, 0, 312, 16);
INSERT INTO public.who_global_data VALUES (73828, 4, 69, 0, 0, 312, 10);
INSERT INTO public.who_global_data VALUES (73829, 44, 468, 0, 7, 312, 201);
INSERT INTO public.who_global_data VALUES (73830, 38, 1988, 1, 22, 312, 174);
INSERT INTO public.who_global_data VALUES (73831, 2, 46, 0, 0, 312, 119);
INSERT INTO public.who_global_data VALUES (73832, 0, 0, 0, 0, 312, 168);
INSERT INTO public.who_global_data VALUES (73833, 156, 2626, 3, 37, 312, 99);
INSERT INTO public.who_global_data VALUES (73834, 0, 17, 0, 0, 312, 171);
INSERT INTO public.who_global_data VALUES (73835, 0, 18, 0, 0, 312, 87);
INSERT INTO public.who_global_data VALUES (73836, 13, 169, 0, 0, 312, 123);
INSERT INTO public.who_global_data VALUES (73837, 0, 0, 0, 0, 312, 151);
INSERT INTO public.who_global_data VALUES (73838, 6, 111, 0, 2, 312, 213);
INSERT INTO public.who_global_data VALUES (73839, 0, 5, 0, 0, 312, 118);
INSERT INTO public.who_global_data VALUES (73840, 26, 128, 0, 2, 312, 134);
INSERT INTO public.who_global_data VALUES (73841, 0, 82, 0, 0, 312, 65);
INSERT INTO public.who_global_data VALUES (73842, 145, 993, 4, 20, 312, 102);
INSERT INTO public.who_global_data VALUES (73843, 0, 0, 0, 0, 312, 223);
INSERT INTO public.who_global_data VALUES (73844, 1, 36, 0, 0, 312, 4);
INSERT INTO public.who_global_data VALUES (73845, 0, 12, 0, 0, 312, 146);
INSERT INTO public.who_global_data VALUES (73846, 15, 120, 0, 2, 312, 31);
INSERT INTO public.who_global_data VALUES (73847, 0, 5, 0, 0, 312, 127);
INSERT INTO public.who_global_data VALUES (73848, 58, 574, 4, 33, 312, 22);
INSERT INTO public.who_global_data VALUES (73849, 0, 8, 0, 0, 312, 115);
INSERT INTO public.who_global_data VALUES (73850, 4, 14, 0, 0, 312, 106);
INSERT INTO public.who_global_data VALUES (73851, 0, 11, 0, 0, 312, 90);
INSERT INTO public.who_global_data VALUES (73852, 0, 0, 0, 0, 312, 70);
INSERT INTO public.who_global_data VALUES (73853, 0, 5, 0, 0, 312, 46);
INSERT INTO public.who_global_data VALUES (73854, 874, 11616, 84, 836, 312, 139);
INSERT INTO public.who_global_data VALUES (73855, 0, 15, 0, 0, 312, 42);
INSERT INTO public.who_global_data VALUES (73856, 48, 600, 0, 1, 312, 80);
INSERT INTO public.who_global_data VALUES (73857, 0, 4, 0, 1, 312, 203);
INSERT INTO public.who_global_data VALUES (73858, 0, 20, 0, 3, 312, 136);
INSERT INTO public.who_global_data VALUES (73859, 46, 111, 0, 1, 312, 63);
INSERT INTO public.who_global_data VALUES (73860, 0, 0, 0, 0, 312, 17);
INSERT INTO public.who_global_data VALUES (73861, 0, 2, 0, 0, 312, 172);
INSERT INTO public.who_global_data VALUES (73862, 44, 329, 2, 9, 312, 109);
INSERT INTO public.who_global_data VALUES (73863, 124, 4226, 4, 26, 312, 200);
INSERT INTO public.who_global_data VALUES (73864, 2, 117, 0, 1, 312, 93);
INSERT INTO public.who_global_data VALUES (73865, 13, 192, 0, 0, 312, 5);
INSERT INTO public.who_global_data VALUES (73866, 0, 712, 1, 11, 312, 214);
INSERT INTO public.who_global_data VALUES (73867, 240, 1865, 7, 25, 312, 204);
INSERT INTO public.who_global_data VALUES (73868, 0, 0, 0, 0, 312, 198);
INSERT INTO public.who_global_data VALUES (73869, 88, 989, 7, 24, 312, 173);
INSERT INTO public.who_global_data VALUES (73870, 0, 1, 0, 0, 312, 229);
INSERT INTO public.who_global_data VALUES (73871, 5, 64, 0, 3, 312, 76);
INSERT INTO public.who_global_data VALUES (73872, 181, 852, 0, 11, 312, 138);
INSERT INTO public.who_global_data VALUES (73873, 0, 1546, 0, 78, 312, 98);
INSERT INTO public.who_global_data VALUES (73874, 0, 0, 0, 0, 312, 103);
INSERT INTO public.who_global_data VALUES (73875, 193, 2055, 9, 31, 312, 225);
INSERT INTO public.who_global_data VALUES (73876, 446, 6408, 21, 140, 312, 131);
INSERT INTO public.who_global_data VALUES (73877, 110, 174, 4, 6, 312, 235);
INSERT INTO public.who_global_data VALUES (73878, 59, 693, 0, 1, 312, 137);
INSERT INTO public.who_global_data VALUES (73879, 125, 9786, 4, 162, 312, 81);
INSERT INTO public.who_global_data VALUES (73880, 90, 353, 1, 3, 312, 182);
INSERT INTO public.who_global_data VALUES (73881, 0, 207, 0, 0, 312, 145);
INSERT INTO public.who_global_data VALUES (73882, 192, 1952, 4, 44, 312, 26);
INSERT INTO public.who_global_data VALUES (73883, 500, 2337, 8, 17, 312, 170);
INSERT INTO public.who_global_data VALUES (73884, 0, 70, 0, 0, 312, 191);
INSERT INTO public.who_global_data VALUES (73885, 0, 0, 0, 0, 312, 221);
INSERT INTO public.who_global_data VALUES (73886, 1, 6, 0, 0, 312, 64);
INSERT INTO public.who_global_data VALUES (73887, 0, 0, 0, 0, 312, 116);
INSERT INTO public.who_global_data VALUES (73888, 0, 2, 0, 0, 312, 128);
INSERT INTO public.who_global_data VALUES (73889, 5, 9, 0, 0, 312, 6);
INSERT INTO public.who_global_data VALUES (73890, 6, 18, 1, 1, 312, 227);
INSERT INTO public.who_global_data VALUES (73891, 0, 0, 0, 0, 312, 68);
INSERT INTO public.who_global_data VALUES (73892, 0, 1, 0, 0, 312, 184);
INSERT INTO public.who_global_data VALUES (73893, 0, 0, 0, 0, 312, 82);
INSERT INTO public.who_global_data VALUES (73894, 6, 236, 1, 26, 312, 149);
INSERT INTO public.who_global_data VALUES (73895, 0, 0, 0, 0, 312, 197);
INSERT INTO public.who_global_data VALUES (73896, 110, 1563, 2, 10, 312, 78);
INSERT INTO public.who_global_data VALUES (73897, 20, 162, 0, 0, 312, 233);
INSERT INTO public.who_global_data VALUES (73898, 44, 785, 0, 13, 312, 133);
INSERT INTO public.who_global_data VALUES (73899, 0, 8, 0, 0, 312, 35);
INSERT INTO public.who_global_data VALUES (73900, 0, 0, 0, 0, 312, 114);
INSERT INTO public.who_global_data VALUES (73901, 35, 879, 0, 3, 312, 237);
INSERT INTO public.who_global_data VALUES (73902, 0, 0, 0, 0, 312, 55);
INSERT INTO public.who_global_data VALUES (73903, 3, 6, 0, 0, 312, 176);
INSERT INTO public.who_global_data VALUES (73904, 0, 336, 0, 0, 312, 202);
INSERT INTO public.who_global_data VALUES (73905, 48, 805, 5, 18, 312, 155);
INSERT INTO public.who_global_data VALUES (73906, 0, 0, 0, 0, 312, 32);
INSERT INTO public.who_global_data VALUES (73907, 0, 3, 0, 0, 312, 220);
INSERT INTO public.who_global_data VALUES (73908, 46, 1326, 2, 3, 312, 30);
INSERT INTO public.who_global_data VALUES (73909, 0, 0, 0, 0, 312, 147);
INSERT INTO public.who_global_data VALUES (73910, 5090, 108421, 811, 8578, 312, 208);
INSERT INTO public.who_global_data VALUES (73911, 2, 122, 1, 2, 312, 45);
INSERT INTO public.who_global_data VALUES (73912, 1, 7, 0, 2, 312, 110);
INSERT INTO public.who_global_data VALUES (73913, 0, 8, 0, 0, 312, 88);
INSERT INTO public.who_global_data VALUES (73914, 280, 3944, 38, 239, 312, 51);
INSERT INTO public.who_global_data VALUES (73915, 1307, 17906, 58, 439, 312, 209);
INSERT INTO public.who_global_data VALUES (73916, 1, 10, 1, 2, 312, 205);
INSERT INTO public.who_global_data VALUES (73917, 0, 0, 0, 0, 312, 18);
INSERT INTO public.who_global_data VALUES (73918, 127, 1651, 1, 10, 312, 72);
INSERT INTO public.who_global_data VALUES (73919, 2858, 29681, 374, 2050, 312, 44);
INSERT INTO public.who_global_data VALUES (73920, 0, 1, 0, 0, 312, 15);
INSERT INTO public.who_global_data VALUES (73921, 6, 34, 0, 1, 312, 25);
INSERT INTO public.who_global_data VALUES (73922, 0, 0, 0, 0, 312, 179);
INSERT INTO public.who_global_data VALUES (73923, 0, 0, 0, 0, 312, 34);
INSERT INTO public.who_global_data VALUES (73924, 6, 82, 0, 3, 312, 207);
INSERT INTO public.who_global_data VALUES (73925, 50, 362, 1, 9, 312, 166);
INSERT INTO public.who_global_data VALUES (73926, 1556, 10827, 37, 168, 312, 126);
INSERT INTO public.who_global_data VALUES (73927, 0, 0, 0, 0, 312, 97);
INSERT INTO public.who_global_data VALUES (73928, 1, 5, 0, 0, 312, 36);
INSERT INTO public.who_global_data VALUES (73929, 0, 0, 0, 0, 312, 125);
INSERT INTO public.who_global_data VALUES (73930, 0, 33, 0, 0, 312, 124);
INSERT INTO public.who_global_data VALUES (73931, 69, 549, 2, 13, 312, 185);
INSERT INTO public.who_global_data VALUES (73932, 53, 664, 1, 6, 312, 194);
INSERT INTO public.who_global_data VALUES (73933, 0, 19, 0, 0, 312, 144);
INSERT INTO public.who_global_data VALUES (73934, 17987, 140640, 286, 2398, 312, 19);
INSERT INTO public.who_global_data VALUES (73935, 8, 30, 0, 0, 312, 217);
INSERT INTO public.who_global_data VALUES (73936, 6, 309, 0, 0, 312, 148);
INSERT INTO public.who_global_data VALUES (73937, 18, 167, 0, 2, 312, 86);
INSERT INTO public.who_global_data VALUES (73938, 0, 0, 0, 0, 312, 13);
INSERT INTO public.who_global_data VALUES (73939, 16, 129, 1, 3, 312, 157);
INSERT INTO public.who_global_data VALUES (73940, 9, 203, 0, 0, 312, 8);
INSERT INTO public.who_global_data VALUES (73941, 0, 0, 0, 0, 312, 73);
INSERT INTO public.who_global_data VALUES (73942, 0, 0, 0, 0, 312, 101);
INSERT INTO public.who_global_data VALUES (73943, 0, 35, 0, 0, 312, 165);
INSERT INTO public.who_global_data VALUES (73944, 3, 8, 0, 1, 312, 14);
INSERT INTO public.who_global_data VALUES (73945, 0, 114, 0, 4, 313, 193);
INSERT INTO public.who_global_data VALUES (73946, 11, 185, 1, 10, 313, 113);
INSERT INTO public.who_global_data VALUES (73947, 45, 454, 3, 29, 313, 143);
INSERT INTO public.who_global_data VALUES (73948, 0, 0, 0, 0, 313, 219);
INSERT INTO public.who_global_data VALUES (73949, 29, 370, 2, 8, 313, 186);
INSERT INTO public.who_global_data VALUES (73950, 0, 2, 0, 0, 313, 52);
INSERT INTO public.who_global_data VALUES (73951, 0, 2, 0, 0, 313, 180);
INSERT INTO public.who_global_data VALUES (73952, 0, 7, 0, 0, 313, 167);
INSERT INTO public.who_global_data VALUES (73953, 55, 745, 2, 19, 313, 154);
INSERT INTO public.who_global_data VALUES (73954, 52, 401, 2, 3, 313, 94);
INSERT INTO public.who_global_data VALUES (73955, 0, 46, 0, 0, 313, 66);
INSERT INTO public.who_global_data VALUES (73956, 279, 4245, 2, 18, 313, 58);
INSERT INTO public.who_global_data VALUES (73957, 522, 8813, 18, 86, 313, 163);
INSERT INTO public.who_global_data VALUES (73958, 26, 190, 0, 4, 313, 37);
INSERT INTO public.who_global_data VALUES (73959, 0, 10, 0, 0, 313, 142);
INSERT INTO public.who_global_data VALUES (73960, 16, 515, 0, 4, 313, 83);
INSERT INTO public.who_global_data VALUES (73961, 1, 49, 0, 5, 313, 228);
INSERT INTO public.who_global_data VALUES (73962, 2, 26, 0, 0, 313, 188);
INSERT INTO public.who_global_data VALUES (73963, 0, 94, 0, 0, 313, 62);
INSERT INTO public.who_global_data VALUES (73964, 683, 13658, 149, 1002, 313, 160);
INSERT INTO public.who_global_data VALUES (73965, 0, 2, 0, 0, 313, 50);
INSERT INTO public.who_global_data VALUES (73966, 0, 6, 0, 0, 313, 33);
INSERT INTO public.who_global_data VALUES (73967, 5, 22, 0, 0, 313, 183);
INSERT INTO public.who_global_data VALUES (73968, 1, 4, 0, 0, 313, 92);
INSERT INTO public.who_global_data VALUES (73969, 0, 74, 0, 0, 313, 158);
INSERT INTO public.who_global_data VALUES (73970, 0, 0, 0, 0, 313, 67);
INSERT INTO public.who_global_data VALUES (73971, 34, 359, 3, 9, 313, 57);
INSERT INTO public.who_global_data VALUES (73972, 0, 0, 0, 0, 313, 38);
INSERT INTO public.who_global_data VALUES (73973, 487, 3904, 22, 114, 313, 141);
INSERT INTO public.who_global_data VALUES (73974, 0, 2, 0, 0, 313, 178);
INSERT INTO public.who_global_data VALUES (73975, 6, 126, 0, 1, 313, 108);
INSERT INTO public.who_global_data VALUES (73976, 15, 346, 1, 8, 313, 39);
INSERT INTO public.who_global_data VALUES (73977, 76, 222, 9, 12, 313, 2);
INSERT INTO public.who_global_data VALUES (73978, 0, 0, 0, 0, 313, 195);
INSERT INTO public.who_global_data VALUES (73979, 0, 5, 0, 1, 313, 107);
INSERT INTO public.who_global_data VALUES (73980, 5, 107, 0, 0, 313, 161);
INSERT INTO public.who_global_data VALUES (73981, 22, 113, 0, 2, 313, 212);
INSERT INTO public.who_global_data VALUES (73982, 898, 5655, 6, 61, 313, 181);
INSERT INTO public.who_global_data VALUES (73983, 0, 8, 0, 1, 313, 53);
INSERT INTO public.who_global_data VALUES (73984, 0, 6, 0, 0, 313, 164);
INSERT INTO public.who_global_data VALUES (73985, 0, 5, 0, 0, 313, 140);
INSERT INTO public.who_global_data VALUES (73986, 0, 1909, 0, 6, 313, 20);
INSERT INTO public.who_global_data VALUES (73987, 114, 82455, 4, 3310, 313, 112);
INSERT INTO public.who_global_data VALUES (73988, 69, 608, 0, 6, 313, 111);
INSERT INTO public.who_global_data VALUES (73989, 0, 0, 0, 0, 313, 71);
INSERT INTO public.who_global_data VALUES (73990, 0, 19, 0, 0, 313, 218);
INSERT INTO public.who_global_data VALUES (73991, 0, 0, 0, 0, 313, 43);
INSERT INTO public.who_global_data VALUES (73992, 32, 295, 0, 2, 313, 49);
INSERT INTO public.who_global_data VALUES (73993, 25, 165, 0, 0, 313, 1);
INSERT INTO public.who_global_data VALUES (73994, 56, 713, 1, 6, 313, 48);
INSERT INTO public.who_global_data VALUES (73995, 0, 119, 0, 3, 313, 232);
INSERT INTO public.who_global_data VALUES (73996, 0, 7, 0, 1, 313, 175);
INSERT INTO public.who_global_data VALUES (73997, 35, 214, 1, 6, 313, 21);
INSERT INTO public.who_global_data VALUES (73998, 166, 2829, 5, 16, 313, 156);
INSERT INTO public.who_global_data VALUES (73999, 0, 0, 0, 0, 313, 95);
INSERT INTO public.who_global_data VALUES (74000, 13, 81, 2, 8, 313, 177);
INSERT INTO public.who_global_data VALUES (74001, 194, 2395, 7, 72, 313, 210);
INSERT INTO public.who_global_data VALUES (74002, 7, 26, 0, 0, 313, 120);
INSERT INTO public.who_global_data VALUES (74003, 0, 11, 0, 0, 313, 135);
INSERT INTO public.who_global_data VALUES (74004, 0, 581, 0, 20, 313, 206);
INSERT INTO public.who_global_data VALUES (74005, 12, 1835, 0, 8, 313, 189);
INSERT INTO public.who_global_data VALUES (74006, 33, 609, 4, 40, 313, 129);
INSERT INTO public.who_global_data VALUES (74007, 5, 24, 0, 0, 313, 121);
INSERT INTO public.who_global_data VALUES (74008, 7, 13, 0, 0, 313, 59);
INSERT INTO public.who_global_data VALUES (74009, 0, 6, 0, 0, 313, 96);
INSERT INTO public.who_global_data VALUES (74010, 39, 679, 2, 3, 313, 41);
INSERT INTO public.who_global_data VALUES (74011, 0, 9, 0, 0, 313, 216);
INSERT INTO public.who_global_data VALUES (74012, 5, 21, 0, 0, 313, 236);
INSERT INTO public.who_global_data VALUES (74013, 0, 0, 0, 0, 313, 150);
INSERT INTO public.who_global_data VALUES (74014, 4, 159, 0, 0, 313, 61);
INSERT INTO public.who_global_data VALUES (74015, 0, 5, 0, 0, 313, 7);
INSERT INTO public.who_global_data VALUES (74016, 0, 1218, 2, 11, 313, 169);
INSERT INTO public.who_global_data VALUES (74017, 2491, 39636, 291, 2602, 313, 28);
INSERT INTO public.who_global_data VALUES (74018, 0, 31, 0, 0, 313, 85);
INSERT INTO public.who_global_data VALUES (74019, 1, 35, 0, 0, 313, 211);
INSERT INTO public.who_global_data VALUES (74020, 0, 7, 0, 1, 313, 60);
INSERT INTO public.who_global_data VALUES (74021, 0, 3, 0, 1, 313, 3);
INSERT INTO public.who_global_data VALUES (74022, 5, 103, 0, 0, 313, 11);
INSERT INTO public.who_global_data VALUES (74023, 4751, 57298, 66, 455, 313, 89);
INSERT INTO public.who_global_data VALUES (74024, 15, 152, 0, 4, 313, 24);
INSERT INTO public.who_global_data VALUES (74025, 9, 65, 0, 0, 313, 162);
INSERT INTO public.who_global_data VALUES (74026, 95, 1156, 6, 38, 313, 100);
INSERT INTO public.who_global_data VALUES (74027, 0, 10, 0, 0, 313, 47);
INSERT INTO public.who_global_data VALUES (74028, 0, 7, 0, 0, 313, 29);
INSERT INTO public.who_global_data VALUES (74029, 0, 96, 0, 2, 313, 40);
INSERT INTO public.who_global_data VALUES (74030, 0, 56, 0, 1, 313, 222);
INSERT INTO public.who_global_data VALUES (74031, 2, 34, 0, 1, 313, 132);
INSERT INTO public.who_global_data VALUES (74032, 6, 45, 0, 0, 313, 130);
INSERT INTO public.who_global_data VALUES (74033, 8, 16, 0, 0, 313, 234);
INSERT INTO public.who_global_data VALUES (74034, 0, 2, 0, 0, 313, 23);
INSERT INTO public.who_global_data VALUES (74035, 0, 9, 0, 1, 313, 192);
INSERT INTO public.who_global_data VALUES (74036, 7, 15, 0, 0, 313, 69);
INSERT INTO public.who_global_data VALUES (74037, 2, 6, 0, 0, 313, 187);
INSERT INTO public.who_global_data VALUES (74038, 43, 110, 1, 2, 313, 230);
INSERT INTO public.who_global_data VALUES (74039, 39, 447, 2, 15, 313, 77);
INSERT INTO public.who_global_data VALUES (74040, 57, 1020, 0, 2, 313, 9);
INSERT INTO public.who_global_data VALUES (74041, 92, 1071, 4, 29, 313, 74);
INSERT INTO public.who_global_data VALUES (74042, 129, 1414, 8, 122, 313, 224);
INSERT INTO public.who_global_data VALUES (74043, 3186, 41495, 117, 2757, 313, 199);
INSERT INTO public.who_global_data VALUES (74044, 0, 547, 0, 42, 313, 190);
INSERT INTO public.who_global_data VALUES (74045, 200, 2615, 10, 46, 313, 12);
INSERT INTO public.who_global_data VALUES (74046, 10, 42, 0, 0, 313, 104);
INSERT INTO public.who_global_data VALUES (74047, 480, 3905, 1, 13, 313, 153);
INSERT INTO public.who_global_data VALUES (74048, 5217, 97689, 758, 10781, 313, 91);
INSERT INTO public.who_global_data VALUES (74049, 2, 32, 0, 1, 313, 215);
INSERT INTO public.who_global_data VALUES (74050, 173, 1866, 2, 54, 313, 84);
INSERT INTO public.who_global_data VALUES (74051, 2, 63, 1, 2, 313, 231);
INSERT INTO public.who_global_data VALUES (74052, 13, 259, 3, 4, 313, 196);
INSERT INTO public.who_global_data VALUES (74053, 0, 312, 0, 1, 313, 105);
INSERT INTO public.who_global_data VALUES (74054, 13, 38, 0, 1, 313, 122);
INSERT INTO public.who_global_data VALUES (74055, 0, 0, 0, 0, 313, 159);
INSERT INTO public.who_global_data VALUES (74056, 15, 106, 0, 1, 313, 75);
INSERT INTO public.who_global_data VALUES (74057, 11, 266, 0, 0, 313, 27);
INSERT INTO public.who_global_data VALUES (74058, 0, 84, 0, 0, 313, 54);
INSERT INTO public.who_global_data VALUES (74059, 2, 8, 0, 0, 313, 226);
INSERT INTO public.who_global_data VALUES (74060, 71, 376, 0, 0, 313, 79);
INSERT INTO public.who_global_data VALUES (74061, 8, 446, 1, 11, 313, 56);
INSERT INTO public.who_global_data VALUES (74062, 0, 0, 0, 0, 313, 117);
INSERT INTO public.who_global_data VALUES (74063, 0, 3, 0, 0, 313, 152);
INSERT INTO public.who_global_data VALUES (74064, 5, 8, 0, 0, 313, 16);
INSERT INTO public.who_global_data VALUES (74065, 2, 65, 0, 0, 313, 10);
INSERT INTO public.who_global_data VALUES (74066, 46, 424, 0, 7, 313, 201);
INSERT INTO public.who_global_data VALUES (74067, 119, 1950, 3, 21, 313, 174);
INSERT INTO public.who_global_data VALUES (74068, 7, 44, 0, 0, 313, 119);
INSERT INTO public.who_global_data VALUES (74069, 0, 0, 0, 0, 313, 168);
INSERT INTO public.who_global_data VALUES (74070, 150, 2470, 7, 34, 313, 99);
INSERT INTO public.who_global_data VALUES (74071, 1, 17, 0, 0, 313, 171);
INSERT INTO public.who_global_data VALUES (74072, 0, 18, 0, 0, 313, 87);
INSERT INTO public.who_global_data VALUES (74073, 5, 156, 0, 0, 313, 123);
INSERT INTO public.who_global_data VALUES (74074, 0, 0, 0, 0, 313, 151);
INSERT INTO public.who_global_data VALUES (74075, 12, 105, 1, 2, 313, 213);
INSERT INTO public.who_global_data VALUES (74076, 0, 5, 0, 0, 313, 118);
INSERT INTO public.who_global_data VALUES (74077, 0, 102, 0, 2, 313, 134);
INSERT INTO public.who_global_data VALUES (74078, 32, 82, 0, 0, 313, 65);
INSERT INTO public.who_global_data VALUES (74079, 131, 848, 4, 16, 313, 102);
INSERT INTO public.who_global_data VALUES (74080, 0, 0, 0, 0, 313, 223);
INSERT INTO public.who_global_data VALUES (74081, 2, 35, 0, 0, 313, 4);
INSERT INTO public.who_global_data VALUES (74082, 0, 12, 0, 0, 313, 146);
INSERT INTO public.who_global_data VALUES (74083, 14, 105, 0, 2, 313, 31);
INSERT INTO public.who_global_data VALUES (74084, 0, 5, 0, 0, 313, 127);
INSERT INTO public.who_global_data VALUES (74085, 66, 516, 3, 29, 313, 22);
INSERT INTO public.who_global_data VALUES (74086, 0, 8, 0, 0, 313, 115);
INSERT INTO public.who_global_data VALUES (74087, 2, 10, 0, 0, 313, 106);
INSERT INTO public.who_global_data VALUES (74088, 0, 11, 0, 0, 313, 90);
INSERT INTO public.who_global_data VALUES (74089, 0, 0, 0, 0, 313, 70);
INSERT INTO public.who_global_data VALUES (74090, 0, 5, 0, 0, 313, 46);
INSERT INTO public.who_global_data VALUES (74091, 1092, 10742, 122, 752, 313, 139);
INSERT INTO public.who_global_data VALUES (74092, 0, 15, 0, 0, 313, 42);
INSERT INTO public.who_global_data VALUES (74093, 76, 552, 0, 1, 313, 80);
INSERT INTO public.who_global_data VALUES (74094, 0, 4, 0, 1, 313, 203);
INSERT INTO public.who_global_data VALUES (74095, 10, 20, 2, 3, 313, 136);
INSERT INTO public.who_global_data VALUES (74096, 0, 65, 0, 1, 313, 63);
INSERT INTO public.who_global_data VALUES (74097, 0, 0, 0, 0, 313, 17);
INSERT INTO public.who_global_data VALUES (74098, 0, 2, 0, 0, 313, 172);
INSERT INTO public.who_global_data VALUES (74099, 44, 285, 3, 7, 313, 109);
INSERT INTO public.who_global_data VALUES (74100, 257, 4102, 2, 22, 313, 200);
INSERT INTO public.who_global_data VALUES (74101, 9, 115, 0, 1, 313, 93);
INSERT INTO public.who_global_data VALUES (74102, 12, 179, 0, 0, 313, 5);
INSERT INTO public.who_global_data VALUES (74103, 0, 712, 0, 10, 313, 214);
INSERT INTO public.who_global_data VALUES (74104, 99, 1625, 5, 18, 313, 204);
INSERT INTO public.who_global_data VALUES (74105, 0, 0, 0, 0, 313, 198);
INSERT INTO public.who_global_data VALUES (74106, 115, 901, 3, 17, 313, 173);
INSERT INTO public.who_global_data VALUES (74107, 0, 1, 0, 0, 313, 229);
INSERT INTO public.who_global_data VALUES (74108, 3, 59, 0, 3, 313, 76);
INSERT INTO public.who_global_data VALUES (74109, 36, 671, 0, 11, 313, 138);
INSERT INTO public.who_global_data VALUES (74110, 471, 1546, 10, 78, 313, 98);
INSERT INTO public.who_global_data VALUES (74111, 0, 0, 0, 0, 313, 103);
INSERT INTO public.who_global_data VALUES (74112, 224, 1862, 4, 22, 313, 225);
INSERT INTO public.who_global_data VALUES (74113, 792, 5962, 19, 119, 313, 131);
INSERT INTO public.who_global_data VALUES (74114, 0, 64, 0, 2, 313, 235);
INSERT INTO public.who_global_data VALUES (74115, 44, 634, 1, 1, 313, 137);
INSERT INTO public.who_global_data VALUES (74116, 78, 9661, 6, 158, 313, 81);
INSERT INTO public.who_global_data VALUES (74117, 32, 263, 0, 2, 313, 182);
INSERT INTO public.who_global_data VALUES (74118, 64, 207, 0, 0, 313, 145);
INSERT INTO public.who_global_data VALUES (74119, 308, 1760, 11, 40, 313, 26);
INSERT INTO public.who_global_data VALUES (74120, 303, 1837, 1, 9, 313, 170);
INSERT INTO public.who_global_data VALUES (74121, 10, 70, 0, 0, 313, 191);
INSERT INTO public.who_global_data VALUES (74122, 0, 0, 0, 0, 313, 221);
INSERT INTO public.who_global_data VALUES (74123, 0, 5, 0, 0, 313, 64);
INSERT INTO public.who_global_data VALUES (74124, 0, 0, 0, 0, 313, 116);
INSERT INTO public.who_global_data VALUES (74125, 0, 2, 0, 0, 313, 128);
INSERT INTO public.who_global_data VALUES (74126, 1, 4, 0, 0, 313, 6);
INSERT INTO public.who_global_data VALUES (74127, 0, 12, 0, 0, 313, 227);
INSERT INTO public.who_global_data VALUES (74128, 0, 0, 0, 0, 313, 68);
INSERT INTO public.who_global_data VALUES (74129, 0, 1, 0, 0, 313, 184);
INSERT INTO public.who_global_data VALUES (74130, 0, 0, 0, 0, 313, 82);
INSERT INTO public.who_global_data VALUES (74131, 2, 230, 3, 25, 313, 149);
INSERT INTO public.who_global_data VALUES (74132, 0, 0, 0, 0, 313, 197);
INSERT INTO public.who_global_data VALUES (74133, 154, 1453, 0, 8, 313, 78);
INSERT INTO public.who_global_data VALUES (74134, 12, 142, 0, 0, 313, 233);
INSERT INTO public.who_global_data VALUES (74135, 82, 741, 3, 13, 313, 133);
INSERT INTO public.who_global_data VALUES (74136, 0, 8, 0, 0, 313, 35);
INSERT INTO public.who_global_data VALUES (74137, 0, 0, 0, 0, 313, 114);
INSERT INTO public.who_global_data VALUES (74138, 42, 844, 1, 3, 313, 237);
INSERT INTO public.who_global_data VALUES (74139, 0, 0, 0, 0, 313, 55);
INSERT INTO public.who_global_data VALUES (74140, 0, 3, 0, 0, 313, 176);
INSERT INTO public.who_global_data VALUES (74141, 41, 336, 0, 0, 313, 202);
INSERT INTO public.who_global_data VALUES (74142, 24, 757, 1, 13, 313, 155);
INSERT INTO public.who_global_data VALUES (74143, 0, 0, 0, 0, 313, 32);
INSERT INTO public.who_global_data VALUES (74144, 0, 3, 0, 0, 313, 220);
INSERT INTO public.who_global_data VALUES (74145, 93, 1280, 0, 1, 313, 30);
INSERT INTO public.who_global_data VALUES (74146, 0, 0, 0, 0, 313, 147);
INSERT INTO public.who_global_data VALUES (74147, 7095, 103331, 840, 7767, 313, 208);
INSERT INTO public.who_global_data VALUES (74148, 5, 120, 0, 1, 313, 45);
INSERT INTO public.who_global_data VALUES (74149, 1, 6, 1, 2, 313, 110);
INSERT INTO public.who_global_data VALUES (74150, 0, 8, 0, 0, 313, 88);
INSERT INTO public.who_global_data VALUES (74151, 300, 3664, 35, 201, 313, 51);
INSERT INTO public.who_global_data VALUES (74152, 432, 16599, 46, 381, 313, 209);
INSERT INTO public.who_global_data VALUES (74153, 0, 9, 0, 1, 313, 205);
INSERT INTO public.who_global_data VALUES (74154, 0, 0, 0, 0, 313, 18);
INSERT INTO public.who_global_data VALUES (74155, 136, 1524, 2, 9, 313, 72);
INSERT INTO public.who_global_data VALUES (74156, 2822, 26823, 212, 1676, 313, 44);
INSERT INTO public.who_global_data VALUES (74157, 0, 1, 0, 0, 313, 15);
INSERT INTO public.who_global_data VALUES (74158, 0, 28, 0, 1, 313, 25);
INSERT INTO public.who_global_data VALUES (74159, 0, 0, 0, 0, 313, 179);
INSERT INTO public.who_global_data VALUES (74160, 0, 0, 0, 0, 313, 34);
INSERT INTO public.who_global_data VALUES (74161, 2, 76, 1, 3, 313, 207);
INSERT INTO public.who_global_data VALUES (74162, 34, 312, 0, 8, 313, 166);
INSERT INTO public.who_global_data VALUES (74163, 1869, 9271, 23, 131, 313, 126);
INSERT INTO public.who_global_data VALUES (74164, 0, 0, 0, 0, 313, 97);
INSERT INTO public.who_global_data VALUES (74165, 2, 4, 0, 0, 313, 36);
INSERT INTO public.who_global_data VALUES (74166, 0, 0, 0, 0, 313, 125);
INSERT INTO public.who_global_data VALUES (74167, 3, 33, 0, 0, 313, 124);
INSERT INTO public.who_global_data VALUES (74168, 62, 480, 2, 11, 313, 185);
INSERT INTO public.who_global_data VALUES (74169, 143, 611, 3, 5, 313, 194);
INSERT INTO public.who_global_data VALUES (74170, 5, 19, 0, 0, 313, 144);
INSERT INTO public.who_global_data VALUES (74171, 19332, 122653, 444, 2112, 313, 19);
INSERT INTO public.who_global_data VALUES (74172, 5, 22, 0, 0, 313, 217);
INSERT INTO public.who_global_data VALUES (74173, 29, 303, 0, 0, 313, 148);
INSERT INTO public.who_global_data VALUES (74174, 5, 149, 0, 2, 313, 86);
INSERT INTO public.who_global_data VALUES (74175, 0, 0, 0, 0, 313, 13);
INSERT INTO public.who_global_data VALUES (74176, 0, 113, 0, 2, 313, 157);
INSERT INTO public.who_global_data VALUES (74177, 15, 194, 0, 0, 313, 8);
INSERT INTO public.who_global_data VALUES (74178, 0, 0, 0, 0, 313, 73);
INSERT INTO public.who_global_data VALUES (74179, 0, 0, 0, 0, 313, 101);
INSERT INTO public.who_global_data VALUES (74180, 19, 35, 0, 0, 313, 165);
INSERT INTO public.who_global_data VALUES (74181, 0, 5, 0, 1, 313, 14);
INSERT INTO public.who_global_data VALUES (74182, 8, 114, 1, 4, 314, 193);
INSERT INTO public.who_global_data VALUES (74183, 15, 174, 1, 9, 314, 113);
INSERT INTO public.who_global_data VALUES (74184, 42, 409, 1, 26, 314, 143);
INSERT INTO public.who_global_data VALUES (74185, 0, 0, 0, 0, 314, 219);
INSERT INTO public.who_global_data VALUES (74186, 20, 341, 2, 6, 314, 186);
INSERT INTO public.who_global_data VALUES (74187, 0, 2, 0, 0, 314, 52);
INSERT INTO public.who_global_data VALUES (74188, 0, 2, 0, 0, 314, 180);
INSERT INTO public.who_global_data VALUES (74189, 0, 7, 0, 0, 314, 167);
INSERT INTO public.who_global_data VALUES (74190, 101, 690, 5, 17, 314, 154);
INSERT INTO public.who_global_data VALUES (74191, 43, 349, 0, 1, 314, 94);
INSERT INTO public.who_global_data VALUES (74192, 18, 46, 0, 0, 314, 66);
INSERT INTO public.who_global_data VALUES (74193, 331, 3966, 2, 16, 314, 58);
INSERT INTO public.who_global_data VALUES (74194, 594, 8291, 0, 68, 314, 163);
INSERT INTO public.who_global_data VALUES (74195, 17, 164, 1, 4, 314, 37);
INSERT INTO public.who_global_data VALUES (74196, 1, 10, 0, 0, 314, 142);
INSERT INTO public.who_global_data VALUES (74197, 26, 499, 0, 4, 314, 83);
INSERT INTO public.who_global_data VALUES (74198, 0, 48, 0, 5, 314, 228);
INSERT INTO public.who_global_data VALUES (74199, 0, 24, 0, 0, 314, 188);
INSERT INTO public.who_global_data VALUES (74200, 0, 94, 0, 0, 314, 62);
INSERT INTO public.who_global_data VALUES (74201, 844, 12975, 141, 853, 314, 160);
INSERT INTO public.who_global_data VALUES (74202, 0, 2, 0, 0, 314, 50);
INSERT INTO public.who_global_data VALUES (74203, 0, 6, 0, 0, 314, 33);
INSERT INTO public.who_global_data VALUES (74204, 2, 17, 0, 0, 314, 183);
INSERT INTO public.who_global_data VALUES (74205, 0, 3, 0, 0, 314, 92);
INSERT INTO public.who_global_data VALUES (74206, 13, 74, 0, 0, 314, 158);
INSERT INTO public.who_global_data VALUES (74207, 0, 0, 0, 0, 314, 67);
INSERT INTO public.who_global_data VALUES (74208, 56, 325, 0, 6, 314, 57);
INSERT INTO public.who_global_data VALUES (74209, 0, 0, 0, 0, 314, 38);
INSERT INTO public.who_global_data VALUES (74210, 502, 3417, 15, 92, 314, 141);
INSERT INTO public.who_global_data VALUES (74211, 0, 2, 0, 0, 314, 178);
INSERT INTO public.who_global_data VALUES (74212, 5, 120, 0, 1, 314, 108);
INSERT INTO public.who_global_data VALUES (74213, 38, 331, 4, 7, 314, 39);
INSERT INTO public.who_global_data VALUES (74214, 0, 146, 0, 3, 314, 2);
INSERT INTO public.who_global_data VALUES (74215, 0, 0, 0, 0, 314, 195);
INSERT INTO public.who_global_data VALUES (74216, 0, 5, 0, 1, 314, 107);
INSERT INTO public.who_global_data VALUES (74217, 0, 102, 0, 0, 314, 161);
INSERT INTO public.who_global_data VALUES (74218, 16, 91, 1, 2, 314, 212);
INSERT INTO public.who_global_data VALUES (74219, 739, 4757, 16, 55, 314, 181);
INSERT INTO public.who_global_data VALUES (74220, 0, 8, 0, 1, 314, 53);
INSERT INTO public.who_global_data VALUES (74221, 0, 6, 0, 0, 314, 164);
INSERT INTO public.who_global_data VALUES (74222, 0, 5, 0, 0, 314, 140);
INSERT INTO public.who_global_data VALUES (74223, 299, 1909, 1, 6, 314, 20);
INSERT INTO public.who_global_data VALUES (74224, 128, 82341, 5, 3306, 314, 112);
INSERT INTO public.who_global_data VALUES (74225, 48, 539, 0, 6, 314, 111);
INSERT INTO public.who_global_data VALUES (74226, 0, 0, 0, 0, 314, 71);
INSERT INTO public.who_global_data VALUES (74227, 0, 19, 0, 0, 314, 218);
INSERT INTO public.who_global_data VALUES (74228, 0, 0, 0, 0, 314, 43);
INSERT INTO public.who_global_data VALUES (74229, 32, 263, 0, 2, 314, 49);
INSERT INTO public.who_global_data VALUES (74230, 48, 140, 0, 0, 314, 1);
INSERT INTO public.who_global_data VALUES (74231, 71, 657, 2, 5, 314, 48);
INSERT INTO public.who_global_data VALUES (74232, 39, 119, 1, 3, 314, 232);
INSERT INTO public.who_global_data VALUES (74233, 0, 7, 0, 1, 314, 175);
INSERT INTO public.who_global_data VALUES (74234, 17, 179, 0, 5, 314, 21);
INSERT INTO public.who_global_data VALUES (74235, 384, 2663, 2, 11, 314, 156);
INSERT INTO public.who_global_data VALUES (74236, 0, 0, 0, 0, 314, 95);
INSERT INTO public.who_global_data VALUES (74237, 10, 68, 1, 6, 314, 177);
INSERT INTO public.who_global_data VALUES (74238, 155, 2201, 13, 65, 314, 210);
INSERT INTO public.who_global_data VALUES (74239, 4, 19, 0, 0, 314, 120);
INSERT INTO public.who_global_data VALUES (74240, 0, 11, 0, 0, 314, 135);
INSERT INTO public.who_global_data VALUES (74241, 0, 581, 0, 20, 314, 206);
INSERT INTO public.who_global_data VALUES (74242, 228, 1823, 0, 8, 314, 189);
INSERT INTO public.who_global_data VALUES (74243, 40, 576, 6, 36, 314, 129);
INSERT INTO public.who_global_data VALUES (74244, 6, 19, 0, 0, 314, 121);
INSERT INTO public.who_global_data VALUES (74245, 0, 6, 0, 0, 314, 59);
INSERT INTO public.who_global_data VALUES (74246, 0, 6, 0, 0, 314, 96);
INSERT INTO public.who_global_data VALUES (74247, 65, 640, 0, 1, 314, 41);
INSERT INTO public.who_global_data VALUES (74248, 0, 9, 0, 0, 314, 216);
INSERT INTO public.who_global_data VALUES (74249, 0, 16, 0, 0, 314, 236);
INSERT INTO public.who_global_data VALUES (74250, 0, 0, 0, 0, 314, 150);
INSERT INTO public.who_global_data VALUES (74251, 11, 155, 0, 0, 314, 61);
INSERT INTO public.who_global_data VALUES (74252, 0, 5, 0, 0, 314, 7);
INSERT INTO public.who_global_data VALUES (74253, 193, 1218, 2, 9, 314, 169);
INSERT INTO public.who_global_data VALUES (74254, 4611, 37145, 319, 2311, 314, 28);
INSERT INTO public.who_global_data VALUES (74255, 0, 31, 0, 0, 314, 85);
INSERT INTO public.who_global_data VALUES (74256, 4, 34, 0, 0, 314, 211);
INSERT INTO public.who_global_data VALUES (74257, 0, 7, 0, 1, 314, 60);
INSERT INTO public.who_global_data VALUES (74258, 1, 3, 0, 1, 314, 3);
INSERT INTO public.who_global_data VALUES (74259, 8, 98, 0, 0, 314, 11);
INSERT INTO public.who_global_data VALUES (74260, 3965, 52547, 64, 389, 314, 89);
INSERT INTO public.who_global_data VALUES (74261, 0, 137, 0, 4, 314, 24);
INSERT INTO public.who_global_data VALUES (74262, 1, 56, 0, 0, 314, 162);
INSERT INTO public.who_global_data VALUES (74263, 95, 1061, 4, 32, 314, 100);
INSERT INTO public.who_global_data VALUES (74264, 1, 10, 0, 0, 314, 47);
INSERT INTO public.who_global_data VALUES (74265, 0, 7, 0, 0, 314, 29);
INSERT INTO public.who_global_data VALUES (74266, 0, 96, 0, 2, 314, 40);
INSERT INTO public.who_global_data VALUES (74267, 5, 56, 0, 1, 314, 222);
INSERT INTO public.who_global_data VALUES (74268, 7, 32, 0, 1, 314, 132);
INSERT INTO public.who_global_data VALUES (74269, 3, 39, 0, 0, 314, 130);
INSERT INTO public.who_global_data VALUES (74270, 0, 8, 0, 0, 314, 234);
INSERT INTO public.who_global_data VALUES (74271, 0, 2, 0, 0, 314, 23);
INSERT INTO public.who_global_data VALUES (74272, 0, 9, 0, 1, 314, 192);
INSERT INTO public.who_global_data VALUES (74273, 0, 8, 0, 0, 314, 69);
INSERT INTO public.who_global_data VALUES (74274, 0, 4, 0, 0, 314, 187);
INSERT INTO public.who_global_data VALUES (74275, 0, 67, 0, 1, 314, 230);
INSERT INTO public.who_global_data VALUES (74276, 65, 408, 2, 13, 314, 77);
INSERT INTO public.who_global_data VALUES (74277, 73, 963, 0, 2, 314, 9);
INSERT INTO public.who_global_data VALUES (74278, 255, 979, 8, 25, 314, 74);
INSERT INTO public.who_global_data VALUES (74279, 239, 1285, 27, 114, 314, 224);
INSERT INTO public.who_global_data VALUES (74280, 2901, 38309, 123, 2640, 314, 199);
INSERT INTO public.who_global_data VALUES (74281, 41, 547, 0, 42, 314, 190);
INSERT INTO public.who_global_data VALUES (74282, 294, 2415, 14, 36, 314, 12);
INSERT INTO public.who_global_data VALUES (74283, 3, 32, 0, 0, 314, 104);
INSERT INTO public.who_global_data VALUES (74284, 433, 3425, 2, 12, 314, 153);
INSERT INTO public.who_global_data VALUES (74285, 5974, 92472, 887, 10023, 314, 91);
INSERT INTO public.who_global_data VALUES (74286, 4, 30, 0, 1, 314, 215);
INSERT INTO public.who_global_data VALUES (74287, 194, 1693, 3, 52, 314, 84);
INSERT INTO public.who_global_data VALUES (74288, 9, 61, 0, 1, 314, 231);
INSERT INTO public.who_global_data VALUES (74289, 11, 246, 0, 1, 314, 196);
INSERT INTO public.who_global_data VALUES (74290, 28, 312, 0, 1, 314, 105);
INSERT INTO public.who_global_data VALUES (74291, 0, 25, 0, 1, 314, 122);
INSERT INTO public.who_global_data VALUES (74292, 0, 0, 0, 0, 314, 159);
INSERT INTO public.who_global_data VALUES (74293, 0, 91, 0, 1, 314, 75);
INSERT INTO public.who_global_data VALUES (74294, 20, 255, 0, 0, 314, 27);
INSERT INTO public.who_global_data VALUES (74295, 26, 84, 0, 0, 314, 54);
INSERT INTO public.who_global_data VALUES (74296, 0, 6, 0, 0, 314, 226);
INSERT INTO public.who_global_data VALUES (74297, 25, 305, 0, 0, 314, 79);
INSERT INTO public.who_global_data VALUES (74298, 26, 438, 2, 10, 314, 56);
INSERT INTO public.who_global_data VALUES (74299, 0, 0, 0, 0, 314, 117);
INSERT INTO public.who_global_data VALUES (74300, 0, 3, 0, 0, 314, 152);
INSERT INTO public.who_global_data VALUES (74301, 2, 3, 0, 0, 314, 16);
INSERT INTO public.who_global_data VALUES (74302, 1, 63, 0, 0, 314, 10);
INSERT INTO public.who_global_data VALUES (74303, 39, 378, 2, 7, 314, 201);
INSERT INTO public.who_global_data VALUES (74304, 226, 1831, 3, 18, 314, 174);
INSERT INTO public.who_global_data VALUES (74305, 11, 37, 0, 0, 314, 119);
INSERT INTO public.who_global_data VALUES (74306, 0, 0, 0, 0, 314, 168);
INSERT INTO public.who_global_data VALUES (74307, 159, 2320, 1, 27, 314, 99);
INSERT INTO public.who_global_data VALUES (74308, -1, 16, 0, 0, 314, 171);
INSERT INTO public.who_global_data VALUES (74309, 9, 18, 0, 0, 314, 87);
INSERT INTO public.who_global_data VALUES (74310, 2, 151, 0, 0, 314, 123);
INSERT INTO public.who_global_data VALUES (74311, 0, 0, 0, 0, 314, 151);
INSERT INTO public.who_global_data VALUES (74312, 0, 93, 0, 1, 314, 213);
INSERT INTO public.who_global_data VALUES (74313, 0, 5, 0, 0, 314, 118);
INSERT INTO public.who_global_data VALUES (74314, 6, 102, 0, 2, 314, 134);
INSERT INTO public.who_global_data VALUES (74315, 0, 50, 0, 0, 314, 65);
INSERT INTO public.who_global_data VALUES (74316, 128, 717, 4, 12, 314, 102);
INSERT INTO public.who_global_data VALUES (74317, 0, 0, 0, 0, 314, 223);
INSERT INTO public.who_global_data VALUES (74318, 1, 33, 0, 0, 314, 4);
INSERT INTO public.who_global_data VALUES (74319, 0, 12, 0, 0, 314, 146);
INSERT INTO public.who_global_data VALUES (74320, 6, 91, 1, 2, 314, 31);
INSERT INTO public.who_global_data VALUES (74321, 0, 5, 0, 0, 314, 127);
INSERT INTO public.who_global_data VALUES (74322, 92, 450, 3, 26, 314, 22);
INSERT INTO public.who_global_data VALUES (74323, 1, 8, 0, 0, 314, 115);
INSERT INTO public.who_global_data VALUES (74324, 3, 8, 0, 0, 314, 106);
INSERT INTO public.who_global_data VALUES (74325, 3, 11, 0, 0, 314, 90);
INSERT INTO public.who_global_data VALUES (74326, 0, 0, 0, 0, 314, 70);
INSERT INTO public.who_global_data VALUES (74327, 2, 5, 0, 0, 314, 46);
INSERT INTO public.who_global_data VALUES (74328, 1146, 9650, 89, 630, 314, 139);
INSERT INTO public.who_global_data VALUES (74329, 0, 15, 0, 0, 314, 42);
INSERT INTO public.who_global_data VALUES (74330, 60, 476, 1, 1, 314, 80);
INSERT INTO public.who_global_data VALUES (74331, 2, 4, 0, 1, 314, 203);
INSERT INTO public.who_global_data VALUES (74332, 0, 10, 0, 1, 314, 136);
INSERT INTO public.who_global_data VALUES (74333, 0, 65, 0, 1, 314, 63);
INSERT INTO public.who_global_data VALUES (74334, 0, 0, 0, 0, 314, 17);
INSERT INTO public.who_global_data VALUES (74335, 2, 2, 0, 0, 314, 172);
INSERT INTO public.who_global_data VALUES (74336, 0, 241, 0, 4, 314, 109);
INSERT INTO public.who_global_data VALUES (74337, 264, 3845, 4, 20, 314, 200);
INSERT INTO public.who_global_data VALUES (74338, 9, 106, 0, 1, 314, 93);
INSERT INTO public.who_global_data VALUES (74339, 15, 167, 0, 0, 314, 5);
INSERT INTO public.who_global_data VALUES (74340, 0, 712, 0, 10, 314, 214);
INSERT INTO public.who_global_data VALUES (74341, 118, 1526, 2, 13, 314, 204);
INSERT INTO public.who_global_data VALUES (74342, 0, 0, 0, 0, 314, 198);
INSERT INTO public.who_global_data VALUES (74343, 112, 786, 5, 14, 314, 173);
INSERT INTO public.who_global_data VALUES (74344, 0, 1, 0, 0, 314, 229);
INSERT INTO public.who_global_data VALUES (74345, 4, 56, 0, 3, 314, 76);
INSERT INTO public.who_global_data VALUES (74346, 55, 635, 2, 11, 314, 138);
INSERT INTO public.who_global_data VALUES (74347, 0, 1075, 0, 68, 314, 98);
INSERT INTO public.who_global_data VALUES (74348, 0, 0, 0, 0, 314, 103);
INSERT INTO public.who_global_data VALUES (74349, 249, 1638, 2, 18, 314, 225);
INSERT INTO public.who_global_data VALUES (74350, 902, 5170, 24, 100, 314, 131);
INSERT INTO public.who_global_data VALUES (74351, 0, 64, 0, 2, 314, 235);
INSERT INTO public.who_global_data VALUES (74352, 28, 590, 0, 0, 314, 137);
INSERT INTO public.who_global_data VALUES (74353, 105, 9583, 8, 152, 314, 81);
INSERT INTO public.who_global_data VALUES (74354, 32, 231, 0, 2, 314, 182);
INSERT INTO public.who_global_data VALUES (74355, 0, 143, 0, 0, 314, 145);
INSERT INTO public.who_global_data VALUES (74356, 160, 1452, 5, 29, 314, 26);
INSERT INTO public.who_global_data VALUES (74357, 270, 1534, 4, 8, 314, 170);
INSERT INTO public.who_global_data VALUES (74358, 6, 60, 0, 0, 314, 191);
INSERT INTO public.who_global_data VALUES (74359, 0, 0, 0, 0, 314, 221);
INSERT INTO public.who_global_data VALUES (74360, 0, 5, 0, 0, 314, 64);
INSERT INTO public.who_global_data VALUES (74361, 0, 0, 0, 0, 314, 116);
INSERT INTO public.who_global_data VALUES (74362, 0, 2, 0, 0, 314, 128);
INSERT INTO public.who_global_data VALUES (74363, 0, 3, 0, 0, 314, 6);
INSERT INTO public.who_global_data VALUES (74364, 0, 12, 0, 0, 314, 227);
INSERT INTO public.who_global_data VALUES (74365, 0, 0, 0, 0, 314, 68);
INSERT INTO public.who_global_data VALUES (74366, 0, 1, 0, 0, 314, 184);
INSERT INTO public.who_global_data VALUES (74367, 0, 0, 0, 0, 314, 82);
INSERT INTO public.who_global_data VALUES (74368, 0, 228, 0, 22, 314, 149);
INSERT INTO public.who_global_data VALUES (74369, 0, 0, 0, 0, 314, 197);
INSERT INTO public.who_global_data VALUES (74370, 96, 1299, 4, 8, 314, 78);
INSERT INTO public.who_global_data VALUES (74371, 11, 130, 0, 0, 314, 233);
INSERT INTO public.who_global_data VALUES (74372, 131, 659, 3, 10, 314, 133);
INSERT INTO public.who_global_data VALUES (74373, 1, 8, 0, 0, 314, 35);
INSERT INTO public.who_global_data VALUES (74374, 0, 0, 0, 0, 314, 114);
INSERT INTO public.who_global_data VALUES (74375, 70, 802, 0, 2, 314, 237);
INSERT INTO public.who_global_data VALUES (74376, 0, 0, 0, 0, 314, 55);
INSERT INTO public.who_global_data VALUES (74377, 0, 3, 0, 0, 314, 176);
INSERT INTO public.who_global_data VALUES (74378, 0, 295, 0, 0, 314, 202);
INSERT INTO public.who_global_data VALUES (74379, 47, 733, 2, 12, 314, 155);
INSERT INTO public.who_global_data VALUES (74380, 0, 0, 0, 0, 314, 32);
INSERT INTO public.who_global_data VALUES (74381, 0, 3, 0, 0, 314, 220);
INSERT INTO public.who_global_data VALUES (74382, 17, 1187, 0, 1, 314, 30);
INSERT INTO public.who_global_data VALUES (74383, 0, 0, 0, 0, 314, 147);
INSERT INTO public.who_global_data VALUES (74384, 9107, 96236, 909, 6927, 314, 208);
INSERT INTO public.who_global_data VALUES (74385, 9, 115, 1, 1, 314, 45);
INSERT INTO public.who_global_data VALUES (74386, 0, 5, 0, 1, 314, 110);
INSERT INTO public.who_global_data VALUES (74387, 0, 8, 0, 0, 314, 88);
INSERT INTO public.who_global_data VALUES (74388, 365, 3364, 32, 166, 314, 51);
INSERT INTO public.who_global_data VALUES (74389, 722, 16167, 57, 335, 314, 209);
INSERT INTO public.who_global_data VALUES (74390, 4, 9, 1, 1, 314, 205);
INSERT INTO public.who_global_data VALUES (74391, 0, 0, 0, 0, 314, 18);
INSERT INTO public.who_global_data VALUES (74392, 252, 1388, 2, 7, 314, 72);
INSERT INTO public.who_global_data VALUES (74393, 3197, 24001, 292, 1464, 314, 44);
INSERT INTO public.who_global_data VALUES (74394, 0, 1, 0, 0, 314, 15);
INSERT INTO public.who_global_data VALUES (74395, 3, 28, 1, 1, 314, 25);
INSERT INTO public.who_global_data VALUES (74396, 0, 0, 0, 0, 314, 179);
INSERT INTO public.who_global_data VALUES (74397, 0, 0, 0, 0, 314, 34);
INSERT INTO public.who_global_data VALUES (74398, 8, 74, 0, 2, 314, 207);
INSERT INTO public.who_global_data VALUES (74399, 51, 278, 2, 8, 314, 166);
INSERT INTO public.who_global_data VALUES (74400, 1704, 7402, 16, 108, 314, 126);
INSERT INTO public.who_global_data VALUES (74401, 0, 0, 0, 0, 314, 97);
INSERT INTO public.who_global_data VALUES (74402, 0, 2, 0, 0, 314, 36);
INSERT INTO public.who_global_data VALUES (74403, 0, 0, 0, 0, 314, 125);
INSERT INTO public.who_global_data VALUES (74404, 16, 30, 0, 0, 314, 124);
INSERT INTO public.who_global_data VALUES (74405, 107, 418, 1, 9, 314, 185);
INSERT INTO public.who_global_data VALUES (74406, 0, 468, 0, 2, 314, 194);
INSERT INTO public.who_global_data VALUES (74407, 1, 14, 0, 0, 314, 144);
INSERT INTO public.who_global_data VALUES (74408, 18093, 103321, 425, 1668, 314, 19);
INSERT INTO public.who_global_data VALUES (74409, 0, 17, 0, 0, 314, 217);
INSERT INTO public.who_global_data VALUES (74410, 36, 274, 0, 0, 314, 148);
INSERT INTO public.who_global_data VALUES (74411, 40, 144, 1, 2, 314, 86);
INSERT INTO public.who_global_data VALUES (74412, 0, 0, 0, 0, 314, 13);
INSERT INTO public.who_global_data VALUES (74413, 7, 113, 2, 2, 314, 157);
INSERT INTO public.who_global_data VALUES (74414, 10, 179, 0, 0, 314, 8);
INSERT INTO public.who_global_data VALUES (74415, 0, 0, 0, 0, 314, 73);
INSERT INTO public.who_global_data VALUES (74416, 0, 0, 0, 0, 314, 101);
INSERT INTO public.who_global_data VALUES (74417, 3, 16, 0, 0, 314, 165);
INSERT INTO public.who_global_data VALUES (74418, 0, 5, 0, 1, 314, 14);
INSERT INTO public.who_global_data VALUES (74419, 15, 106, 1, 3, 315, 193);
INSERT INTO public.who_global_data VALUES (74420, 11, 159, 1, 8, 315, 113);
INSERT INTO public.who_global_data VALUES (74421, 62, 367, 4, 25, 315, 143);
INSERT INTO public.who_global_data VALUES (74422, 0, 0, 0, 0, 315, 219);
INSERT INTO public.who_global_data VALUES (74423, 32, 321, 1, 4, 315, 186);
INSERT INTO public.who_global_data VALUES (74424, 0, 2, 0, 0, 315, 52);
INSERT INTO public.who_global_data VALUES (74425, 0, 2, 0, 0, 315, 180);
INSERT INTO public.who_global_data VALUES (74426, 4, 7, 0, 0, 315, 167);
INSERT INTO public.who_global_data VALUES (74427, 87, 589, 4, 12, 315, 154);
INSERT INTO public.who_global_data VALUES (74428, 39, 306, 0, 1, 315, 94);
INSERT INTO public.who_global_data VALUES (74429, 9, 28, 0, 0, 315, 66);
INSERT INTO public.who_global_data VALUES (74430, 650, 3635, 1, 14, 315, 58);
INSERT INTO public.who_global_data VALUES (74431, 668, 7697, 16, 68, 315, 163);
INSERT INTO public.who_global_data VALUES (74432, 25, 147, 0, 3, 315, 37);
INSERT INTO public.who_global_data VALUES (74433, 4, 9, 0, 0, 315, 142);
INSERT INTO public.who_global_data VALUES (74434, 7, 473, 0, 4, 315, 83);
INSERT INTO public.who_global_data VALUES (74435, 0, 48, 0, 5, 315, 228);
INSERT INTO public.who_global_data VALUES (74436, 6, 24, 0, 0, 315, 188);
INSERT INTO public.who_global_data VALUES (74437, 0, 94, 0, 0, 315, 62);
INSERT INTO public.who_global_data VALUES (74438, 1518, 12131, 128, 712, 315, 160);
INSERT INTO public.who_global_data VALUES (74439, 0, 2, 0, 0, 315, 50);
INSERT INTO public.who_global_data VALUES (74440, 0, 6, 0, 0, 315, 33);
INSERT INTO public.who_global_data VALUES (74441, 8, 15, 0, 0, 315, 183);
INSERT INTO public.who_global_data VALUES (74442, 0, 3, 0, 0, 315, 92);
INSERT INTO public.who_global_data VALUES (74443, 22, 61, 0, 0, 315, 158);
INSERT INTO public.who_global_data VALUES (74444, 0, 0, 0, 0, 315, 67);
INSERT INTO public.who_global_data VALUES (74445, 36, 269, 2, 6, 315, 57);
INSERT INTO public.who_global_data VALUES (74446, 0, 0, 0, 0, 315, 38);
INSERT INTO public.who_global_data VALUES (74447, 482, 2915, 20, 77, 315, 141);
INSERT INTO public.who_global_data VALUES (74448, 0, 2, 0, 0, 315, 178);
INSERT INTO public.who_global_data VALUES (74449, 1, 115, 1, 1, 315, 108);
INSERT INTO public.who_global_data VALUES (74450, 29, 293, 0, 3, 315, 39);
INSERT INTO public.who_global_data VALUES (74451, 0, 146, 0, 3, 315, 2);
INSERT INTO public.who_global_data VALUES (74452, 0, 0, 0, 0, 315, 195);
INSERT INTO public.who_global_data VALUES (74453, 2, 5, 1, 1, 315, 107);
INSERT INTO public.who_global_data VALUES (74454, 4, 102, 0, 0, 315, 161);
INSERT INTO public.who_global_data VALUES (74455, 0, 75, 0, 1, 315, 212);
INSERT INTO public.who_global_data VALUES (74456, 463, 4018, 4, 39, 315, 181);
INSERT INTO public.who_global_data VALUES (74457, 0, 8, 0, 1, 315, 53);
INSERT INTO public.who_global_data VALUES (74458, 1, 6, 0, 0, 315, 164);
INSERT INTO public.who_global_data VALUES (74459, 0, 5, 0, 0, 315, 140);
INSERT INTO public.who_global_data VALUES (74460, 304, 1610, 1, 5, 315, 20);
INSERT INTO public.who_global_data VALUES (74461, 120, 82213, 3, 3301, 315, 112);
INSERT INTO public.who_global_data VALUES (74462, 21, 491, 2, 6, 315, 111);
INSERT INTO public.who_global_data VALUES (74463, 0, 0, 0, 0, 315, 71);
INSERT INTO public.who_global_data VALUES (74464, 15, 19, 0, 0, 315, 218);
INSERT INTO public.who_global_data VALUES (74465, 0, 0, 0, 0, 315, 43);
INSERT INTO public.who_global_data VALUES (74466, 30, 231, 0, 2, 315, 49);
INSERT INTO public.who_global_data VALUES (74467, 12, 92, 0, 0, 315, 1);
INSERT INTO public.who_global_data VALUES (74468, 91, 586, 1, 3, 315, 48);
INSERT INTO public.who_global_data VALUES (74469, 13, 80, 1, 2, 315, 232);
INSERT INTO public.who_global_data VALUES (74470, 0, 7, 0, 1, 315, 175);
INSERT INTO public.who_global_data VALUES (74471, 16, 162, 2, 5, 315, 21);
INSERT INTO public.who_global_data VALUES (74472, 217, 2279, 0, 9, 315, 156);
INSERT INTO public.who_global_data VALUES (74473, 0, 0, 0, 0, 315, 95);
INSERT INTO public.who_global_data VALUES (74474, 4, 58, 1, 5, 315, 177);
INSERT INTO public.who_global_data VALUES (74475, 169, 2046, 11, 52, 315, 210);
INSERT INTO public.who_global_data VALUES (74476, 2, 15, 0, 0, 315, 120);
INSERT INTO public.who_global_data VALUES (74477, 0, 11, 0, 0, 315, 135);
INSERT INTO public.who_global_data VALUES (74478, 93, 581, 10, 20, 315, 206);
INSERT INTO public.who_global_data VALUES (74479, 384, 1595, 0, 8, 315, 189);
INSERT INTO public.who_global_data VALUES (74480, 41, 536, 6, 30, 315, 129);
INSERT INTO public.who_global_data VALUES (74481, 0, 13, 0, 0, 315, 121);
INSERT INTO public.who_global_data VALUES (74482, 0, 6, 0, 0, 315, 59);
INSERT INTO public.who_global_data VALUES (74483, 0, 6, 0, 0, 315, 96);
INSERT INTO public.who_global_data VALUES (74484, 37, 575, 0, 1, 315, 41);
INSERT INTO public.who_global_data VALUES (74485, 3, 9, 0, 0, 315, 216);
INSERT INTO public.who_global_data VALUES (74486, 4, 16, 0, 0, 315, 236);
INSERT INTO public.who_global_data VALUES (74487, 0, 0, 0, 0, 315, 150);
INSERT INTO public.who_global_data VALUES (74488, 4, 144, 0, 0, 315, 61);
INSERT INTO public.who_global_data VALUES (74489, 0, 5, 0, 0, 315, 7);
INSERT INTO public.who_global_data VALUES (74490, 67, 1025, 3, 7, 315, 169);
INSERT INTO public.who_global_data VALUES (74491, 3748, 32534, 297, 1992, 315, 28);
INSERT INTO public.who_global_data VALUES (74492, 3, 31, 0, 0, 315, 85);
INSERT INTO public.who_global_data VALUES (74493, 0, 30, 0, 0, 315, 211);
INSERT INTO public.who_global_data VALUES (74494, 1, 7, 0, 1, 315, 60);
INSERT INTO public.who_global_data VALUES (74495, 0, 2, 1, 1, 315, 3);
INSERT INTO public.who_global_data VALUES (74496, 7, 90, 0, 0, 315, 11);
INSERT INTO public.who_global_data VALUES (74497, 6294, 48582, 72, 325, 315, 89);
INSERT INTO public.who_global_data VALUES (74498, 1, 137, 1, 4, 315, 24);
INSERT INTO public.who_global_data VALUES (74499, 20, 55, 0, 0, 315, 162);
INSERT INTO public.who_global_data VALUES (74500, 74, 966, 2, 28, 315, 100);
INSERT INTO public.who_global_data VALUES (74501, 3, 9, 0, 0, 315, 47);
INSERT INTO public.who_global_data VALUES (74502, 0, 7, 0, 0, 315, 29);
INSERT INTO public.who_global_data VALUES (74503, 20, 96, 2, 2, 315, 40);
INSERT INTO public.who_global_data VALUES (74504, 6, 51, 0, 1, 315, 222);
INSERT INTO public.who_global_data VALUES (74505, 1, 25, 0, 1, 315, 132);
INSERT INTO public.who_global_data VALUES (74506, 2, 36, 0, 0, 315, 130);
INSERT INTO public.who_global_data VALUES (74507, 3, 8, 0, 0, 315, 234);
INSERT INTO public.who_global_data VALUES (74508, 0, 2, 0, 0, 315, 23);
INSERT INTO public.who_global_data VALUES (74509, 0, 9, 0, 1, 315, 192);
INSERT INTO public.who_global_data VALUES (74510, 0, 8, 0, 0, 315, 69);
INSERT INTO public.who_global_data VALUES (74511, 0, 4, 0, 0, 315, 187);
INSERT INTO public.who_global_data VALUES (74512, 15, 67, 0, 1, 315, 230);
INSERT INTO public.who_global_data VALUES (74513, 43, 343, 1, 11, 315, 77);
INSERT INTO public.who_global_data VALUES (74514, 88, 890, 0, 2, 315, 9);
INSERT INTO public.who_global_data VALUES (74515, 0, 724, 0, 17, 315, 74);
INSERT INTO public.who_global_data VALUES (74516, 0, 1046, 0, 87, 315, 224);
INSERT INTO public.who_global_data VALUES (74517, 3076, 35408, 139, 2517, 315, 199);
INSERT INTO public.who_global_data VALUES (74518, 48, 506, 2, 42, 315, 190);
INSERT INTO public.who_global_data VALUES (74519, 302, 2121, 3, 22, 315, 12);
INSERT INTO public.who_global_data VALUES (74520, 3, 29, 0, 0, 315, 104);
INSERT INTO public.who_global_data VALUES (74521, 520, 2992, 5, 10, 315, 153);
INSERT INTO public.who_global_data VALUES (74522, 5959, 86498, 971, 9136, 315, 91);
INSERT INTO public.who_global_data VALUES (74523, 0, 26, 0, 1, 315, 215);
INSERT INTO public.who_global_data VALUES (74524, 112, 1499, 3, 49, 315, 84);
INSERT INTO public.who_global_data VALUES (74525, 20, 52, 0, 1, 315, 231);
INSERT INTO public.who_global_data VALUES (74526, 23, 235, 1, 1, 315, 196);
INSERT INTO public.who_global_data VALUES (74527, 56, 284, 0, 1, 315, 105);
INSERT INTO public.who_global_data VALUES (74528, 0, 25, 0, 1, 315, 122);
INSERT INTO public.who_global_data VALUES (74529, 0, 0, 0, 0, 315, 159);
INSERT INTO public.who_global_data VALUES (74530, 3, 91, 0, 1, 315, 75);
INSERT INTO public.who_global_data VALUES (74531, 10, 235, 0, 0, 315, 27);
INSERT INTO public.who_global_data VALUES (74532, 0, 58, 0, 0, 315, 54);
INSERT INTO public.who_global_data VALUES (74533, 0, 6, 0, 0, 315, 226);
INSERT INTO public.who_global_data VALUES (74534, 36, 280, 0, 0, 315, 79);
INSERT INTO public.who_global_data VALUES (74535, 21, 412, 1, 8, 315, 56);
INSERT INTO public.who_global_data VALUES (74536, 0, 0, 0, 0, 315, 117);
INSERT INTO public.who_global_data VALUES (74537, 0, 3, 0, 0, 315, 152);
INSERT INTO public.who_global_data VALUES (74538, 0, 1, 0, 0, 315, 16);
INSERT INTO public.who_global_data VALUES (74539, 1, 62, 0, 0, 315, 10);
INSERT INTO public.who_global_data VALUES (74540, 47, 339, 0, 5, 315, 201);
INSERT INTO public.who_global_data VALUES (74541, 152, 1605, 6, 15, 315, 174);
INSERT INTO public.who_global_data VALUES (74542, 2, 26, 0, 0, 315, 119);
INSERT INTO public.who_global_data VALUES (74543, 0, 0, 0, 0, 315, 168);
INSERT INTO public.who_global_data VALUES (74544, 130, 2161, 3, 26, 315, 99);
INSERT INTO public.who_global_data VALUES (74545, 0, 17, 0, 0, 315, 171);
INSERT INTO public.who_global_data VALUES (74546, 7, 9, 0, 0, 315, 87);
INSERT INTO public.who_global_data VALUES (74547, 10, 149, 0, 0, 315, 123);
INSERT INTO public.who_global_data VALUES (74548, 0, 0, 0, 0, 315, 151);
INSERT INTO public.who_global_data VALUES (74549, 27, 93, 0, 1, 315, 213);
INSERT INTO public.who_global_data VALUES (74550, 2, 5, 0, 0, 315, 118);
INSERT INTO public.who_global_data VALUES (74551, 15, 96, 0, 2, 315, 134);
INSERT INTO public.who_global_data VALUES (74552, 0, 50, 0, 0, 315, 65);
INSERT INTO public.who_global_data VALUES (74553, 111, 589, 3, 8, 315, 102);
INSERT INTO public.who_global_data VALUES (74554, 0, 0, 0, 0, 315, 223);
INSERT INTO public.who_global_data VALUES (74555, 6, 32, 0, 0, 315, 4);
INSERT INTO public.who_global_data VALUES (74556, 1, 12, 0, 0, 315, 146);
INSERT INTO public.who_global_data VALUES (74557, 3, 85, 0, 1, 315, 31);
INSERT INTO public.who_global_data VALUES (74558, 3, 5, 0, 0, 315, 127);
INSERT INTO public.who_global_data VALUES (74559, 83, 358, 13, 23, 315, 22);
INSERT INTO public.who_global_data VALUES (74560, 2, 7, 0, 0, 315, 115);
INSERT INTO public.who_global_data VALUES (74561, 0, 5, 0, 0, 315, 106);
INSERT INTO public.who_global_data VALUES (74562, 0, 8, 0, 0, 315, 90);
INSERT INTO public.who_global_data VALUES (74563, 0, 0, 0, 0, 315, 70);
INSERT INTO public.who_global_data VALUES (74564, 0, 3, 0, 0, 315, 46);
INSERT INTO public.who_global_data VALUES (74565, 1167, 8504, 122, 541, 315, 139);
INSERT INTO public.who_global_data VALUES (74566, 1, 15, 0, 0, 315, 42);
INSERT INTO public.who_global_data VALUES (74567, 78, 416, 0, 0, 315, 80);
INSERT INTO public.who_global_data VALUES (74568, 0, 2, 1, 1, 315, 203);
INSERT INTO public.who_global_data VALUES (74569, 0, 10, 0, 1, 315, 136);
INSERT INTO public.who_global_data VALUES (74570, 0, 65, 0, 1, 315, 63);
INSERT INTO public.who_global_data VALUES (74571, 0, 0, 0, 0, 315, 17);
INSERT INTO public.who_global_data VALUES (74572, 0, 0, 0, 0, 315, 172);
INSERT INTO public.who_global_data VALUES (74573, 22, 241, 1, 4, 315, 109);
INSERT INTO public.who_global_data VALUES (74574, 425, 3581, 2, 16, 315, 200);
INSERT INTO public.who_global_data VALUES (74575, 6, 97, 0, 1, 315, 93);
INSERT INTO public.who_global_data VALUES (74576, 21, 152, 0, 0, 315, 5);
INSERT INTO public.who_global_data VALUES (74577, 0, 712, 0, 10, 315, 214);
INSERT INTO public.who_global_data VALUES (74578, 211, 1408, 2, 11, 315, 204);
INSERT INTO public.who_global_data VALUES (74579, 0, 0, 0, 0, 315, 198);
INSERT INTO public.who_global_data VALUES (74580, 116, 674, 1, 9, 315, 173);
INSERT INTO public.who_global_data VALUES (74581, 0, 1, 0, 0, 315, 229);
INSERT INTO public.who_global_data VALUES (74582, 11, 52, 0, 3, 315, 76);
INSERT INTO public.who_global_data VALUES (74583, 0, 580, 0, 9, 315, 138);
INSERT INTO public.who_global_data VALUES (74584, 368, 1075, 23, 68, 315, 98);
INSERT INTO public.who_global_data VALUES (74585, 0, 0, 0, 0, 315, 103);
INSERT INTO public.who_global_data VALUES (74586, 168, 1389, 0, 16, 315, 225);
INSERT INTO public.who_global_data VALUES (74587, 724, 4268, 16, 76, 315, 131);
INSERT INTO public.who_global_data VALUES (74588, 0, 64, 0, 2, 315, 235);
INSERT INTO public.who_global_data VALUES (74589, 13, 562, 0, 0, 315, 137);
INSERT INTO public.who_global_data VALUES (74590, 146, 9478, 5, 144, 315, 81);
INSERT INTO public.who_global_data VALUES (74591, 0, 199, 0, 2, 315, 182);
INSERT INTO public.who_global_data VALUES (74592, 8, 143, 0, 0, 315, 145);
INSERT INTO public.who_global_data VALUES (74593, 263, 1292, 7, 24, 315, 26);
INSERT INTO public.who_global_data VALUES (74594, 228, 1264, 1, 4, 315, 170);
INSERT INTO public.who_global_data VALUES (74595, 4, 54, 0, 0, 315, 191);
INSERT INTO public.who_global_data VALUES (74596, 0, 0, 0, 0, 315, 221);
INSERT INTO public.who_global_data VALUES (74597, 2, 5, 0, 0, 315, 64);
INSERT INTO public.who_global_data VALUES (74598, 0, 0, 0, 0, 315, 116);
INSERT INTO public.who_global_data VALUES (74599, 0, 2, 0, 0, 315, 128);
INSERT INTO public.who_global_data VALUES (74600, 0, 3, 0, 0, 315, 6);
INSERT INTO public.who_global_data VALUES (74601, 1, 12, 0, 0, 315, 227);
INSERT INTO public.who_global_data VALUES (74602, 0, 0, 0, 0, 315, 68);
INSERT INTO public.who_global_data VALUES (74603, 0, 1, 0, 0, 315, 184);
INSERT INTO public.who_global_data VALUES (74604, 0, 0, 0, 0, 315, 82);
INSERT INTO public.who_global_data VALUES (74605, 5, 228, 1, 22, 315, 149);
INSERT INTO public.who_global_data VALUES (74606, 0, 0, 0, 0, 315, 197);
INSERT INTO public.who_global_data VALUES (74607, 99, 1203, 1, 4, 315, 78);
INSERT INTO public.who_global_data VALUES (74608, 14, 119, 0, 0, 315, 233);
INSERT INTO public.who_global_data VALUES (74609, 71, 528, 0, 7, 315, 133);
INSERT INTO public.who_global_data VALUES (74610, 0, 7, 0, 0, 315, 35);
INSERT INTO public.who_global_data VALUES (74611, 0, 0, 0, 0, 315, 114);
INSERT INTO public.who_global_data VALUES (74612, 49, 732, 0, 2, 315, 237);
INSERT INTO public.who_global_data VALUES (74613, 0, 0, 0, 0, 315, 55);
INSERT INTO public.who_global_data VALUES (74614, 1, 3, 0, 0, 315, 176);
INSERT INTO public.who_global_data VALUES (74615, 69, 295, 0, 0, 315, 202);
INSERT INTO public.who_global_data VALUES (74616, 52, 686, 2, 10, 315, 155);
INSERT INTO public.who_global_data VALUES (74617, 0, 0, 0, 0, 315, 32);
INSERT INTO public.who_global_data VALUES (74618, 0, 3, 0, 0, 315, 220);
INSERT INTO public.who_global_data VALUES (74619, 243, 1170, 1, 1, 315, 30);
INSERT INTO public.who_global_data VALUES (74620, 0, 0, 0, 0, 315, 147);
INSERT INTO public.who_global_data VALUES (74621, 10115, 87129, 871, 6018, 315, 208);
INSERT INTO public.who_global_data VALUES (74622, 0, 106, 0, 0, 315, 45);
INSERT INTO public.who_global_data VALUES (74623, 2, 5, 0, 1, 315, 110);
INSERT INTO public.who_global_data VALUES (74624, 1, 8, 0, 0, 315, 88);
INSERT INTO public.who_global_data VALUES (74625, 286, 2999, 31, 134, 315, 51);
INSERT INTO public.who_global_data VALUES (74626, 1307, 15445, 32, 278, 315, 209);
INSERT INTO public.who_global_data VALUES (74627, 0, 5, 0, 0, 315, 205);
INSERT INTO public.who_global_data VALUES (74628, 0, 0, 0, 0, 315, 18);
INSERT INTO public.who_global_data VALUES (74629, 0, 1136, 0, 5, 315, 72);
INSERT INTO public.who_global_data VALUES (74630, 3087, 20804, 288, 1172, 315, 44);
INSERT INTO public.who_global_data VALUES (74631, 0, 1, 0, 0, 315, 15);
INSERT INTO public.who_global_data VALUES (74632, 1, 25, 0, 0, 315, 25);
INSERT INTO public.who_global_data VALUES (74633, 0, 0, 0, 0, 315, 179);
INSERT INTO public.who_global_data VALUES (74634, 0, 0, 0, 0, 315, 34);
INSERT INTO public.who_global_data VALUES (74635, 5, 66, 1, 2, 315, 207);
INSERT INTO public.who_global_data VALUES (74636, 0, 227, 0, 6, 315, 166);
INSERT INTO public.who_global_data VALUES (74637, 2069, 5698, 17, 92, 315, 126);
INSERT INTO public.who_global_data VALUES (74638, 0, 0, 0, 0, 315, 97);
INSERT INTO public.who_global_data VALUES (74639, 0, 2, 0, 0, 315, 36);
INSERT INTO public.who_global_data VALUES (74640, 0, 0, 0, 0, 315, 125);
INSERT INTO public.who_global_data VALUES (74641, 0, 14, 0, 0, 315, 124);
INSERT INTO public.who_global_data VALUES (74642, 93, 311, 3, 8, 315, 185);
INSERT INTO public.who_global_data VALUES (74643, 135, 468, 0, 2, 315, 194);
INSERT INTO public.who_global_data VALUES (74644, 0, 13, 0, 0, 315, 144);
INSERT INTO public.who_global_data VALUES (74645, 16894, 85228, 252, 1243, 315, 19);
INSERT INTO public.who_global_data VALUES (74646, 0, 17, 0, 0, 315, 217);
INSERT INTO public.who_global_data VALUES (74647, 21, 238, 0, 0, 315, 148);
INSERT INTO public.who_global_data VALUES (74648, 16, 104, 1, 1, 315, 86);
INSERT INTO public.who_global_data VALUES (74649, 0, 0, 0, 0, 315, 13);
INSERT INTO public.who_global_data VALUES (74650, 15, 106, 0, 0, 315, 157);
INSERT INTO public.who_global_data VALUES (74651, 16, 169, 0, 0, 315, 8);
INSERT INTO public.who_global_data VALUES (74652, 0, 0, 0, 0, 315, 73);
INSERT INTO public.who_global_data VALUES (74653, 0, 0, 0, 0, 315, 101);
INSERT INTO public.who_global_data VALUES (74654, 0, 13, 0, 0, 315, 165);
INSERT INTO public.who_global_data VALUES (74655, 0, 5, 0, 1, 315, 14);
INSERT INTO public.who_global_data VALUES (74656, 11, 91, 0, 2, 316, 193);
INSERT INTO public.who_global_data VALUES (74657, 12, 148, 2, 7, 316, 113);
INSERT INTO public.who_global_data VALUES (74658, 41, 305, 4, 21, 316, 143);
INSERT INTO public.who_global_data VALUES (74659, 0, 0, 0, 0, 316, 219);
INSERT INTO public.who_global_data VALUES (74660, 58, 289, 0, 3, 316, 186);
INSERT INTO public.who_global_data VALUES (74661, 0, 2, 0, 0, 316, 52);
INSERT INTO public.who_global_data VALUES (74662, 0, 2, 0, 0, 316, 180);
INSERT INTO public.who_global_data VALUES (74663, 0, 3, 0, 0, 316, 167);
INSERT INTO public.who_global_data VALUES (74664, 0, 502, 0, 8, 316, 154);
INSERT INTO public.who_global_data VALUES (74665, 25, 267, 1, 1, 316, 94);
INSERT INTO public.who_global_data VALUES (74666, 0, 19, 0, 0, 316, 66);
INSERT INTO public.who_global_data VALUES (74667, 186, 2985, 2, 13, 316, 58);
INSERT INTO public.who_global_data VALUES (74668, 1141, 7029, 18, 52, 316, 163);
INSERT INTO public.who_global_data VALUES (74669, 29, 122, 1, 3, 316, 37);
INSERT INTO public.who_global_data VALUES (74670, 0, 5, 0, 0, 316, 142);
INSERT INTO public.who_global_data VALUES (74671, 9, 466, 0, 4, 316, 83);
INSERT INTO public.who_global_data VALUES (74672, 4, 48, 0, 5, 316, 228);
INSERT INTO public.who_global_data VALUES (74673, 0, 18, 0, 0, 316, 188);
INSERT INTO public.who_global_data VALUES (74674, 8, 94, 0, 0, 316, 62);
INSERT INTO public.who_global_data VALUES (74675, 1363, 10613, 102, 584, 316, 160);
INSERT INTO public.who_global_data VALUES (74676, 0, 2, 0, 0, 316, 50);
INSERT INTO public.who_global_data VALUES (74677, 0, 6, 0, 0, 316, 33);
INSERT INTO public.who_global_data VALUES (74678, 0, 7, 0, 0, 316, 183);
INSERT INTO public.who_global_data VALUES (74679, 0, 3, 0, 0, 316, 92);
INSERT INTO public.who_global_data VALUES (74680, 0, 39, 0, 0, 316, 158);
INSERT INTO public.who_global_data VALUES (74681, 0, 0, 0, 0, 316, 67);
INSERT INTO public.who_global_data VALUES (74682, 20, 233, 1, 4, 316, 57);
INSERT INTO public.who_global_data VALUES (74683, 0, 0, 0, 0, 316, 38);
INSERT INTO public.who_global_data VALUES (74684, 0, 2433, 0, 57, 316, 141);
INSERT INTO public.who_global_data VALUES (74685, 0, 2, 0, 0, 316, 178);
INSERT INTO public.who_global_data VALUES (74686, 5, 114, 0, 0, 316, 108);
INSERT INTO public.who_global_data VALUES (74687, 22, 264, 0, 3, 316, 39);
INSERT INTO public.who_global_data VALUES (74688, 0, 146, 0, 3, 316, 2);
INSERT INTO public.who_global_data VALUES (74689, 0, 0, 0, 0, 316, 195);
INSERT INTO public.who_global_data VALUES (74690, 0, 3, 0, 0, 316, 107);
INSERT INTO public.who_global_data VALUES (74691, 2, 98, 0, 0, 316, 161);
INSERT INTO public.who_global_data VALUES (74692, 0, 75, 0, 1, 316, 212);
INSERT INTO public.who_global_data VALUES (74693, 0, 3555, 0, 35, 316, 181);
INSERT INTO public.who_global_data VALUES (74694, 0, 8, 0, 1, 316, 53);
INSERT INTO public.who_global_data VALUES (74695, 0, 5, 0, 0, 316, 164);
INSERT INTO public.who_global_data VALUES (74696, 2, 5, 0, 0, 316, 140);
INSERT INTO public.who_global_data VALUES (74697, 0, 1306, 0, 4, 316, 20);
INSERT INTO public.who_global_data VALUES (74698, 132, 82093, 5, 3298, 316, 112);
INSERT INTO public.who_global_data VALUES (74699, 0, 470, 0, 4, 316, 111);
INSERT INTO public.who_global_data VALUES (74700, 0, 0, 0, 0, 316, 71);
INSERT INTO public.who_global_data VALUES (74701, 0, 4, 0, 0, 316, 218);
INSERT INTO public.who_global_data VALUES (74702, 0, 0, 0, 0, 316, 43);
INSERT INTO public.who_global_data VALUES (74703, 0, 201, 0, 2, 316, 49);
INSERT INTO public.who_global_data VALUES (74704, 0, 80, 0, 0, 316, 1);
INSERT INTO public.who_global_data VALUES (74705, 77, 495, 1, 2, 316, 48);
INSERT INTO public.who_global_data VALUES (74706, 0, 67, 0, 1, 316, 232);
INSERT INTO public.who_global_data VALUES (74707, 0, 7, 0, 1, 316, 175);
INSERT INTO public.who_global_data VALUES (74708, 14, 146, 0, 3, 316, 21);
INSERT INTO public.who_global_data VALUES (74709, 408, 2062, 3, 9, 316, 156);
INSERT INTO public.who_global_data VALUES (74710, 0, 0, 0, 0, 316, 95);
INSERT INTO public.who_global_data VALUES (74711, 3, 54, 1, 4, 316, 177);
INSERT INTO public.who_global_data VALUES (74712, 153, 1877, 7, 41, 316, 210);
INSERT INTO public.who_global_data VALUES (74713, 1, 13, 0, 0, 316, 120);
INSERT INTO public.who_global_data VALUES (74714, 0, 11, 0, 0, 316, 135);
INSERT INTO public.who_global_data VALUES (74715, 0, 488, 0, 10, 316, 206);
INSERT INTO public.who_global_data VALUES (74716, 0, 1211, 0, 8, 316, 189);
INSERT INTO public.who_global_data VALUES (74717, 39, 495, 3, 24, 316, 129);
INSERT INTO public.who_global_data VALUES (74718, 0, 13, 0, 0, 316, 121);
INSERT INTO public.who_global_data VALUES (74719, 0, 6, 0, 0, 316, 59);
INSERT INTO public.who_global_data VALUES (74720, 2, 6, 0, 0, 316, 96);
INSERT INTO public.who_global_data VALUES (74721, 134, 538, 0, 1, 316, 41);
INSERT INTO public.who_global_data VALUES (74722, 2, 6, 0, 0, 316, 216);
INSERT INTO public.who_global_data VALUES (74723, 0, 12, 0, 0, 316, 236);
INSERT INTO public.who_global_data VALUES (74724, 0, 0, 0, 0, 316, 150);
INSERT INTO public.who_global_data VALUES (74725, 8, 140, 0, 0, 316, 61);
INSERT INTO public.who_global_data VALUES (74726, 0, 5, 0, 0, 316, 7);
INSERT INTO public.who_global_data VALUES (74727, 78, 958, 1, 4, 316, 169);
INSERT INTO public.who_global_data VALUES (74728, 3866, 28786, 365, 1695, 316, 28);
INSERT INTO public.who_global_data VALUES (74729, 0, 28, 0, 0, 316, 85);
INSERT INTO public.who_global_data VALUES (74730, 5, 30, 0, 0, 316, 211);
INSERT INTO public.who_global_data VALUES (74731, 0, 6, 0, 1, 316, 60);
INSERT INTO public.who_global_data VALUES (74732, 0, 2, 0, 0, 316, 3);
INSERT INTO public.who_global_data VALUES (74733, 3, 83, 0, 0, 316, 11);
INSERT INTO public.who_global_data VALUES (74734, 5780, 42288, 55, 253, 316, 89);
INSERT INTO public.who_global_data VALUES (74735, 4, 136, 1, 3, 316, 24);
INSERT INTO public.who_global_data VALUES (74736, 9, 35, 0, 0, 316, 162);
INSERT INTO public.who_global_data VALUES (74737, 71, 892, 4, 26, 316, 100);
INSERT INTO public.who_global_data VALUES (74738, 1, 6, 0, 0, 316, 47);
INSERT INTO public.who_global_data VALUES (74739, 0, 7, 0, 0, 316, 29);
INSERT INTO public.who_global_data VALUES (74740, 0, 76, 0, 0, 316, 40);
INSERT INTO public.who_global_data VALUES (74741, 8, 45, 0, 1, 316, 222);
INSERT INTO public.who_global_data VALUES (74742, 0, 24, 0, 1, 316, 132);
INSERT INTO public.who_global_data VALUES (74743, 4, 34, 0, 0, 316, 130);
INSERT INTO public.who_global_data VALUES (74744, 1, 5, 0, 0, 316, 234);
INSERT INTO public.who_global_data VALUES (74745, 0, 2, 0, 0, 316, 23);
INSERT INTO public.who_global_data VALUES (74746, 0, 9, 0, 1, 316, 192);
INSERT INTO public.who_global_data VALUES (74747, 0, 8, 0, 0, 316, 69);
INSERT INTO public.who_global_data VALUES (74748, 0, 4, 0, 0, 316, 187);
INSERT INTO public.who_global_data VALUES (74749, 0, 52, 0, 1, 316, 230);
INSERT INTO public.who_global_data VALUES (74750, 39, 300, 0, 10, 316, 77);
INSERT INTO public.who_global_data VALUES (74751, 65, 802, 0, 2, 316, 9);
INSERT INTO public.who_global_data VALUES (74752, 75, 724, 4, 17, 316, 74);
INSERT INTO public.who_global_data VALUES (74753, 153, 1046, 9, 87, 316, 224);
INSERT INTO public.who_global_data VALUES (74754, 2926, 32332, 144, 2378, 316, 199);
INSERT INTO public.who_global_data VALUES (74755, 76, 458, 4, 40, 316, 190);
INSERT INTO public.who_global_data VALUES (74756, 255, 1819, 10, 19, 316, 12);
INSERT INTO public.who_global_data VALUES (74757, 3, 26, 0, 0, 316, 104);
INSERT INTO public.who_global_data VALUES (74758, 425, 2472, 1, 5, 316, 153);
INSERT INTO public.who_global_data VALUES (74759, 6153, 80539, 660, 8165, 316, 91);
INSERT INTO public.who_global_data VALUES (74760, 0, 26, 0, 1, 316, 215);
INSERT INTO public.who_global_data VALUES (74761, 96, 1387, 1, 46, 316, 84);
INSERT INTO public.who_global_data VALUES (74762, 14, 32, 1, 1, 316, 231);
INSERT INTO public.who_global_data VALUES (74763, 40, 212, 0, 0, 316, 196);
INSERT INTO public.who_global_data VALUES (74764, 78, 228, 1, 1, 316, 105);
INSERT INTO public.who_global_data VALUES (74765, 0, 25, 1, 1, 316, 122);
INSERT INTO public.who_global_data VALUES (74766, 0, 0, 0, 0, 316, 159);
INSERT INTO public.who_global_data VALUES (74767, 9, 88, 0, 1, 316, 75);
INSERT INTO public.who_global_data VALUES (74768, 17, 225, 0, 0, 316, 27);
INSERT INTO public.who_global_data VALUES (74769, 14, 58, 0, 0, 316, 54);
INSERT INTO public.who_global_data VALUES (74770, 3, 6, 0, 0, 316, 226);
INSERT INTO public.who_global_data VALUES (74771, 23, 244, 0, 0, 316, 79);
INSERT INTO public.who_global_data VALUES (74772, 23, 391, 1, 7, 316, 56);
INSERT INTO public.who_global_data VALUES (74773, 0, 0, 0, 0, 316, 117);
INSERT INTO public.who_global_data VALUES (74774, 0, 3, 0, 0, 316, 152);
INSERT INTO public.who_global_data VALUES (74775, 0, 1, 0, 0, 316, 16);
INSERT INTO public.who_global_data VALUES (74776, 4, 61, 0, 0, 316, 10);
INSERT INTO public.who_global_data VALUES (74777, 29, 292, 1, 5, 316, 201);
INSERT INTO public.who_global_data VALUES (74778, 120, 1453, 1, 9, 316, 174);
INSERT INTO public.who_global_data VALUES (74779, 5, 24, 0, 0, 316, 119);
INSERT INTO public.who_global_data VALUES (74780, 0, 0, 0, 0, 316, 168);
INSERT INTO public.who_global_data VALUES (74781, 235, 2031, 2, 23, 316, 99);
INSERT INTO public.who_global_data VALUES (74782, 0, 17, 0, 0, 316, 171);
INSERT INTO public.who_global_data VALUES (74783, 0, 2, 0, 0, 316, 87);
INSERT INTO public.who_global_data VALUES (74784, 5, 139, 0, 0, 316, 123);
INSERT INTO public.who_global_data VALUES (74785, 0, 0, 0, 0, 316, 151);
INSERT INTO public.who_global_data VALUES (74786, 0, 66, 0, 1, 316, 213);
INSERT INTO public.who_global_data VALUES (74787, -3, 3, 0, 0, 316, 118);
INSERT INTO public.who_global_data VALUES (74788, 34, 81, 0, 2, 316, 134);
INSERT INTO public.who_global_data VALUES (74789, 15, 50, 0, 0, 316, 65);
INSERT INTO public.who_global_data VALUES (74790, 0, 478, 0, 5, 316, 102);
INSERT INTO public.who_global_data VALUES (74791, 0, 0, 0, 0, 316, 223);
INSERT INTO public.who_global_data VALUES (74792, 3, 26, 0, 0, 316, 4);
INSERT INTO public.who_global_data VALUES (74793, 0, 11, 0, 0, 316, 146);
INSERT INTO public.who_global_data VALUES (74794, 12, 82, 0, 1, 316, 31);
INSERT INTO public.who_global_data VALUES (74795, 0, 2, 0, 0, 316, 127);
INSERT INTO public.who_global_data VALUES (74796, 50, 275, 4, 10, 316, 22);
INSERT INTO public.who_global_data VALUES (74797, 0, 5, 0, 0, 316, 115);
INSERT INTO public.who_global_data VALUES (74798, 2, 5, 0, 0, 316, 106);
INSERT INTO public.who_global_data VALUES (74799, 0, 8, 0, 0, 316, 90);
INSERT INTO public.who_global_data VALUES (74800, 0, 0, 0, 0, 316, 70);
INSERT INTO public.who_global_data VALUES (74801, 0, 3, 0, 0, 316, 46);
INSERT INTO public.who_global_data VALUES (74802, 1007, 7337, 71, 419, 316, 139);
INSERT INTO public.who_global_data VALUES (74803, 0, 14, 0, 0, 316, 42);
INSERT INTO public.who_global_data VALUES (74804, 76, 338, 0, 0, 316, 80);
INSERT INTO public.who_global_data VALUES (74805, 0, 2, 0, 0, 316, 203);
INSERT INTO public.who_global_data VALUES (74806, 8, 10, 1, 1, 316, 136);
INSERT INTO public.who_global_data VALUES (74807, 19, 65, 0, 1, 316, 63);
INSERT INTO public.who_global_data VALUES (74808, 0, 0, 0, 0, 316, 17);
INSERT INTO public.who_global_data VALUES (74809, 0, 0, 0, 0, 316, 172);
INSERT INTO public.who_global_data VALUES (74810, 18, 219, 0, 3, 316, 109);
INSERT INTO public.who_global_data VALUES (74811, 240, 3156, 2, 14, 316, 200);
INSERT INTO public.who_global_data VALUES (74812, 7, 91, 0, 1, 316, 93);
INSERT INTO public.who_global_data VALUES (74813, 22, 131, 0, 0, 316, 5);
INSERT INTO public.who_global_data VALUES (74814, 0, 712, 0, 10, 316, 214);
INSERT INTO public.who_global_data VALUES (74815, 140, 1197, 1, 9, 316, 204);
INSERT INTO public.who_global_data VALUES (74816, 0, 0, 0, 0, 316, 198);
INSERT INTO public.who_global_data VALUES (74817, 0, 558, 0, 8, 316, 173);
INSERT INTO public.who_global_data VALUES (74818, 0, 1, 0, 0, 316, 229);
INSERT INTO public.who_global_data VALUES (74819, 0, 41, 0, 3, 316, 76);
INSERT INTO public.who_global_data VALUES (74820, 0, 580, 0, 9, 316, 138);
INSERT INTO public.who_global_data VALUES (74821, 0, 707, 0, 45, 316, 98);
INSERT INTO public.who_global_data VALUES (74822, 0, 0, 0, 0, 316, 103);
INSERT INTO public.who_global_data VALUES (74823, 170, 1221, 2, 16, 316, 225);
INSERT INTO public.who_global_data VALUES (74824, 549, 3544, 17, 60, 316, 131);
INSERT INTO public.who_global_data VALUES (74825, 0, 64, 0, 2, 316, 235);
INSERT INTO public.who_global_data VALUES (74826, 12, 549, 0, 0, 316, 137);
INSERT INTO public.who_global_data VALUES (74827, 91, 9332, 8, 139, 316, 81);
INSERT INTO public.who_global_data VALUES (74828, 50, 199, 1, 2, 316, 182);
INSERT INTO public.who_global_data VALUES (74829, 41, 135, 0, 0, 316, 145);
INSERT INTO public.who_global_data VALUES (74830, 123, 1029, 4, 17, 316, 26);
INSERT INTO public.who_global_data VALUES (74831, 196, 1036, 1, 3, 316, 170);
INSERT INTO public.who_global_data VALUES (74832, 9, 50, 0, 0, 316, 191);
INSERT INTO public.who_global_data VALUES (74833, 0, 0, 0, 0, 316, 221);
INSERT INTO public.who_global_data VALUES (74834, 0, 3, 0, 0, 316, 64);
INSERT INTO public.who_global_data VALUES (74835, 0, 0, 0, 0, 316, 116);
INSERT INTO public.who_global_data VALUES (74836, 0, 2, 0, 0, 316, 128);
INSERT INTO public.who_global_data VALUES (74837, 0, 3, 0, 0, 316, 6);
INSERT INTO public.who_global_data VALUES (74838, 0, 11, 0, 0, 316, 227);
INSERT INTO public.who_global_data VALUES (74839, 0, 0, 0, 0, 316, 68);
INSERT INTO public.who_global_data VALUES (74840, 0, 1, 0, 0, 316, 184);
INSERT INTO public.who_global_data VALUES (74841, 0, 0, 0, 0, 316, 82);
INSERT INTO public.who_global_data VALUES (74842, 5, 223, 0, 21, 316, 149);
INSERT INTO public.who_global_data VALUES (74843, 0, 0, 0, 0, 316, 197);
INSERT INTO public.who_global_data VALUES (74844, 92, 1104, 0, 3, 316, 78);
INSERT INTO public.who_global_data VALUES (74845, 6, 105, 0, 0, 316, 233);
INSERT INTO public.who_global_data VALUES (74846, 73, 457, 3, 7, 316, 133);
INSERT INTO public.who_global_data VALUES (74847, 0, 7, 0, 0, 316, 35);
INSERT INTO public.who_global_data VALUES (74848, 0, 0, 0, 0, 316, 114);
INSERT INTO public.who_global_data VALUES (74849, 52, 683, 0, 2, 316, 237);
INSERT INTO public.who_global_data VALUES (74850, 0, 0, 0, 0, 316, 55);
INSERT INTO public.who_global_data VALUES (74851, 0, 2, 0, 0, 316, 176);
INSERT INTO public.who_global_data VALUES (74852, 10, 226, 0, 0, 316, 202);
INSERT INTO public.who_global_data VALUES (74853, 61, 634, 2, 8, 316, 155);
INSERT INTO public.who_global_data VALUES (74854, 0, 0, 0, 0, 316, 32);
INSERT INTO public.who_global_data VALUES (74855, 1, 3, 0, 0, 316, 220);
INSERT INTO public.who_global_data VALUES (74856, 0, 927, 0, 0, 316, 30);
INSERT INTO public.who_global_data VALUES (74857, 0, 0, 0, 0, 316, 147);
INSERT INTO public.who_global_data VALUES (74858, 10141, 77014, 824, 5147, 316, 208);
INSERT INTO public.who_global_data VALUES (74859, 4, 106, 0, 0, 316, 45);
INSERT INTO public.who_global_data VALUES (74860, 0, 3, 0, 1, 316, 110);
INSERT INTO public.who_global_data VALUES (74861, 0, 7, 0, 0, 316, 88);
INSERT INTO public.who_global_data VALUES (74862, 314, 2713, 22, 103, 316, 51);
INSERT INTO public.who_global_data VALUES (74863, 1114, 14138, 38, 246, 316, 209);
INSERT INTO public.who_global_data VALUES (74864, 0, 5, 0, 0, 316, 205);
INSERT INTO public.who_global_data VALUES (74865, 0, 0, 0, 0, 316, 18);
INSERT INTO public.who_global_data VALUES (74866, 91, 1136, 1, 5, 316, 72);
INSERT INTO public.who_global_data VALUES (74867, 2692, 17717, 181, 884, 316, 44);
INSERT INTO public.who_global_data VALUES (74868, 0, 1, 0, 0, 316, 15);
INSERT INTO public.who_global_data VALUES (74869, 1, 24, 0, 0, 316, 25);
INSERT INTO public.who_global_data VALUES (74870, 0, 0, 0, 0, 316, 179);
INSERT INTO public.who_global_data VALUES (74871, 0, 0, 0, 0, 316, 34);
INSERT INTO public.who_global_data VALUES (74872, 0, 61, 0, 1, 316, 207);
INSERT INTO public.who_global_data VALUES (74873, 54, 227, 1, 6, 316, 166);
INSERT INTO public.who_global_data VALUES (74874, 1196, 3629, 16, 75, 316, 126);
INSERT INTO public.who_global_data VALUES (74875, 0, 0, 0, 0, 316, 97);
INSERT INTO public.who_global_data VALUES (74876, 0, 2, 0, 0, 316, 36);
INSERT INTO public.who_global_data VALUES (74877, 0, 0, 0, 0, 316, 125);
INSERT INTO public.who_global_data VALUES (74878, 0, 14, 0, 0, 316, 124);
INSERT INTO public.who_global_data VALUES (74879, 62, 218, 0, 5, 316, 185);
INSERT INTO public.who_global_data VALUES (74880, 0, 333, 0, 2, 316, 194);
INSERT INTO public.who_global_data VALUES (74881, 0, 13, 0, 0, 316, 144);
INSERT INTO public.who_global_data VALUES (74882, 0, 68334, 0, 991, 316, 19);
INSERT INTO public.who_global_data VALUES (74883, 0, 17, 0, 0, 316, 217);
INSERT INTO public.who_global_data VALUES (74884, 0, 217, 0, 0, 316, 148);
INSERT INTO public.who_global_data VALUES (74885, 23, 88, 0, 0, 316, 86);
INSERT INTO public.who_global_data VALUES (74886, 0, 0, 0, 0, 316, 13);
INSERT INTO public.who_global_data VALUES (74887, 0, 91, 0, 0, 316, 157);
INSERT INTO public.who_global_data VALUES (74888, 5, 153, 0, 0, 316, 8);
INSERT INTO public.who_global_data VALUES (74889, 0, 0, 0, 0, 316, 73);
INSERT INTO public.who_global_data VALUES (74890, 0, 0, 0, 0, 316, 101);
INSERT INTO public.who_global_data VALUES (74891, 10, 13, 0, 0, 316, 165);
INSERT INTO public.who_global_data VALUES (74892, 3, 5, 0, 1, 316, 14);
INSERT INTO public.who_global_data VALUES (74893, 6, 80, 1, 2, 317, 193);
INSERT INTO public.who_global_data VALUES (74894, 28, 136, 1, 5, 317, 113);
INSERT INTO public.who_global_data VALUES (74895, 0, 264, 0, 17, 317, 143);
INSERT INTO public.who_global_data VALUES (74896, 0, 0, 0, 0, 317, 219);
INSERT INTO public.who_global_data VALUES (74897, 18, 231, 0, 3, 317, 186);
INSERT INTO public.who_global_data VALUES (74898, 0, 2, 0, 0, 317, 52);
INSERT INTO public.who_global_data VALUES (74899, 2, 2, 0, 0, 317, 180);
INSERT INTO public.who_global_data VALUES (74900, 0, 3, 0, 0, 317, 167);
INSERT INTO public.who_global_data VALUES (74901, 201, 502, 4, 8, 317, 154);
INSERT INTO public.who_global_data VALUES (74902, 30, 242, 0, 0, 317, 94);
INSERT INTO public.who_global_data VALUES (74903, 7, 19, 0, 0, 317, 66);
INSERT INTO public.who_global_data VALUES (74904, 376, 2799, 3, 11, 317, 58);
INSERT INTO public.who_global_data VALUES (74905, 606, 5888, 4, 34, 317, 163);
INSERT INTO public.who_global_data VALUES (74906, 6, 93, 1, 2, 317, 37);
INSERT INTO public.who_global_data VALUES (74907, 1, 5, 0, 0, 317, 142);
INSERT INTO public.who_global_data VALUES (74908, 38, 457, 1, 4, 317, 83);
INSERT INTO public.who_global_data VALUES (74909, 5, 44, 1, 5, 317, 228);
INSERT INTO public.who_global_data VALUES (74910, 0, 18, 0, 0, 317, 188);
INSERT INTO public.who_global_data VALUES (74911, 5, 86, 0, 0, 317, 62);
INSERT INTO public.who_global_data VALUES (74912, 1199, 9250, 107, 482, 317, 160);
INSERT INTO public.who_global_data VALUES (74913, 1, 2, 0, 0, 317, 50);
INSERT INTO public.who_global_data VALUES (74914, 1, 6, 0, 0, 317, 33);
INSERT INTO public.who_global_data VALUES (74915, 1, 7, 0, 0, 317, 183);
INSERT INTO public.who_global_data VALUES (74916, 1, 3, 0, 0, 317, 92);
INSERT INTO public.who_global_data VALUES (74917, 11, 39, 0, 0, 317, 158);
INSERT INTO public.who_global_data VALUES (74918, 0, 0, 0, 0, 317, 67);
INSERT INTO public.who_global_data VALUES (74919, 40, 213, 0, 3, 317, 57);
INSERT INTO public.who_global_data VALUES (74920, 0, 0, 0, 0, 317, 38);
INSERT INTO public.who_global_data VALUES (74921, 232, 2433, 11, 57, 317, 141);
INSERT INTO public.who_global_data VALUES (74922, 2, 2, 0, 0, 317, 178);
INSERT INTO public.who_global_data VALUES (74923, 5, 109, 0, 0, 317, 108);
INSERT INTO public.who_global_data VALUES (74924, 22, 242, 0, 3, 317, 39);
INSERT INTO public.who_global_data VALUES (74925, 32, 146, 0, 3, 317, 2);
INSERT INTO public.who_global_data VALUES (74926, 0, 0, 0, 0, 317, 195);
INSERT INTO public.who_global_data VALUES (74927, 0, 3, 0, 0, 317, 107);
INSERT INTO public.who_global_data VALUES (74928, 5, 96, 0, 0, 317, 161);
INSERT INTO public.who_global_data VALUES (74929, 5, 75, 0, 1, 317, 212);
INSERT INTO public.who_global_data VALUES (74930, 1816, 3555, 10, 35, 317, 181);
INSERT INTO public.who_global_data VALUES (74931, 3, 8, 0, 1, 317, 53);
INSERT INTO public.who_global_data VALUES (74932, 1, 5, 0, 0, 317, 164);
INSERT INTO public.who_global_data VALUES (74933, 0, 3, 0, 0, 317, 140);
INSERT INTO public.who_global_data VALUES (74934, 384, 1306, 2, 4, 317, 20);
INSERT INTO public.who_global_data VALUES (74935, 92, 81961, 6, 3293, 317, 112);
INSERT INTO public.who_global_data VALUES (74936, 164, 470, 1, 4, 317, 111);
INSERT INTO public.who_global_data VALUES (74937, 0, 0, 0, 0, 317, 71);
INSERT INTO public.who_global_data VALUES (74938, 0, 4, 0, 0, 317, 218);
INSERT INTO public.who_global_data VALUES (74939, 0, 0, 0, 0, 317, 43);
INSERT INTO public.who_global_data VALUES (74940, 24, 201, 0, 2, 317, 49);
INSERT INTO public.who_global_data VALUES (74941, 8, 80, 0, 0, 317, 1);
INSERT INTO public.who_global_data VALUES (74942, 36, 418, 0, 1, 317, 48);
INSERT INTO public.who_global_data VALUES (74943, 19, 67, 0, 1, 317, 232);
INSERT INTO public.who_global_data VALUES (74944, 1, 7, 0, 1, 317, 175);
INSERT INTO public.who_global_data VALUES (74945, 8, 132, 0, 3, 317, 21);
INSERT INTO public.who_global_data VALUES (74946, 260, 1654, 3, 6, 317, 156);
INSERT INTO public.who_global_data VALUES (74947, 0, 0, 0, 0, 317, 95);
INSERT INTO public.who_global_data VALUES (74948, 6, 51, 1, 3, 317, 177);
INSERT INTO public.who_global_data VALUES (74949, 133, 1724, 2, 34, 317, 210);
INSERT INTO public.who_global_data VALUES (74950, 0, 12, 0, 0, 317, 120);
INSERT INTO public.who_global_data VALUES (74951, 9, 11, 0, 0, 317, 135);
INSERT INTO public.who_global_data VALUES (74952, 176, 488, 4, 10, 317, 206);
INSERT INTO public.who_global_data VALUES (74953, 162, 1211, 0, 8, 317, 189);
INSERT INTO public.who_global_data VALUES (74954, 14, 456, 0, 21, 317, 129);
INSERT INTO public.who_global_data VALUES (74955, 8, 13, 0, 0, 317, 121);
INSERT INTO public.who_global_data VALUES (74956, 0, 6, 0, 0, 317, 59);
INSERT INTO public.who_global_data VALUES (74957, 3, 4, 0, 0, 317, 96);
INSERT INTO public.who_global_data VALUES (74958, 35, 404, 1, 1, 317, 41);
INSERT INTO public.who_global_data VALUES (74959, 0, 4, 0, 0, 317, 216);
INSERT INTO public.who_global_data VALUES (74960, 0, 12, 0, 0, 317, 236);
INSERT INTO public.who_global_data VALUES (74961, 0, 0, 0, 0, 317, 150);
INSERT INTO public.who_global_data VALUES (74962, 10, 132, 0, 0, 317, 61);
INSERT INTO public.who_global_data VALUES (74963, 0, 5, 0, 0, 317, 7);
INSERT INTO public.who_global_data VALUES (74964, 88, 880, 2, 3, 317, 169);
INSERT INTO public.who_global_data VALUES (74965, 2895, 24920, 230, 1330, 317, 28);
INSERT INTO public.who_global_data VALUES (74966, 5, 28, 0, 0, 317, 85);
INSERT INTO public.who_global_data VALUES (74967, 0, 25, 0, 0, 317, 211);
INSERT INTO public.who_global_data VALUES (74968, 0, 6, 0, 1, 317, 60);
INSERT INTO public.who_global_data VALUES (74969, 0, 2, 0, 0, 317, 3);
INSERT INTO public.who_global_data VALUES (74970, 3, 80, 0, 0, 317, 11);
INSERT INTO public.who_global_data VALUES (74971, 4954, 36508, 49, 198, 317, 89);
INSERT INTO public.who_global_data VALUES (74972, 79, 132, 0, 2, 317, 24);
INSERT INTO public.who_global_data VALUES (74973, 11, 26, 0, 0, 317, 162);
INSERT INTO public.who_global_data VALUES (74974, 78, 821, 2, 22, 317, 100);
INSERT INTO public.who_global_data VALUES (74975, 1, 5, 0, 0, 317, 47);
INSERT INTO public.who_global_data VALUES (74976, 6, 7, 0, 0, 317, 29);
INSERT INTO public.who_global_data VALUES (74977, 3, 76, 0, 0, 317, 40);
INSERT INTO public.who_global_data VALUES (74978, 5, 37, 0, 1, 317, 222);
INSERT INTO public.who_global_data VALUES (74979, 3, 24, 0, 1, 317, 132);
INSERT INTO public.who_global_data VALUES (74980, 7, 30, 0, 0, 317, 130);
INSERT INTO public.who_global_data VALUES (74981, 0, 4, 0, 0, 317, 234);
INSERT INTO public.who_global_data VALUES (74982, 2, 2, 0, 0, 317, 23);
INSERT INTO public.who_global_data VALUES (74983, 0, 9, 0, 1, 317, 192);
INSERT INTO public.who_global_data VALUES (74984, 1, 8, 0, 0, 317, 69);
INSERT INTO public.who_global_data VALUES (74985, 3, 4, 0, 0, 317, 187);
INSERT INTO public.who_global_data VALUES (74986, 22, 52, 1, 1, 317, 230);
INSERT INTO public.who_global_data VALUES (74987, 35, 261, 0, 10, 317, 77);
INSERT INTO public.who_global_data VALUES (74988, 89, 737, 0, 2, 317, 9);
INSERT INTO public.who_global_data VALUES (74989, 43, 649, 3, 13, 317, 74);
INSERT INTO public.who_global_data VALUES (74990, 103, 893, 20, 78, 317, 224);
INSERT INTO public.who_global_data VALUES (74991, 2389, 29406, 157, 2234, 317, 199);
INSERT INTO public.who_global_data VALUES (74992, 36, 382, 7, 36, 317, 190);
INSERT INTO public.who_global_data VALUES (74993, 235, 1564, 2, 9, 317, 12);
INSERT INTO public.who_global_data VALUES (74994, 0, 23, 0, 0, 317, 104);
INSERT INTO public.who_global_data VALUES (74995, 427, 2047, 3, 4, 317, 153);
INSERT INTO public.who_global_data VALUES (74996, 5210, 74386, 685, 7505, 317, 91);
INSERT INTO public.who_global_data VALUES (74997, 5, 26, 0, 1, 317, 215);
INSERT INTO public.who_global_data VALUES (74998, 98, 1291, 2, 45, 317, 84);
INSERT INTO public.who_global_data VALUES (74999, 2, 18, 0, 0, 317, 231);
INSERT INTO public.who_global_data VALUES (75000, 19, 172, 0, 0, 317, 196);
INSERT INTO public.who_global_data VALUES (75001, 53, 150, 0, 0, 317, 105);
INSERT INTO public.who_global_data VALUES (75002, 0, 25, 0, 0, 317, 122);
INSERT INTO public.who_global_data VALUES (75003, 0, 0, 0, 0, 317, 159);
INSERT INTO public.who_global_data VALUES (75004, 8, 79, 0, 1, 317, 75);
INSERT INTO public.who_global_data VALUES (75005, 13, 208, 0, 0, 317, 27);
INSERT INTO public.who_global_data VALUES (75006, 2, 44, 0, 0, 317, 54);
INSERT INTO public.who_global_data VALUES (75007, 1, 3, 0, 0, 317, 226);
INSERT INTO public.who_global_data VALUES (75008, 24, 221, 0, 0, 317, 79);
INSERT INTO public.who_global_data VALUES (75009, 35, 368, 2, 6, 317, 56);
INSERT INTO public.who_global_data VALUES (75010, 0, 0, 0, 0, 317, 117);
INSERT INTO public.who_global_data VALUES (75011, 0, 3, 0, 0, 317, 152);
INSERT INTO public.who_global_data VALUES (75012, 0, 1, 0, 0, 317, 16);
INSERT INTO public.who_global_data VALUES (75013, 4, 57, 0, 0, 317, 10);
INSERT INTO public.who_global_data VALUES (75014, 55, 263, 1, 4, 317, 201);
INSERT INTO public.who_global_data VALUES (75015, 234, 1333, 0, 8, 317, 174);
INSERT INTO public.who_global_data VALUES (75016, 0, 19, 0, 0, 317, 119);
INSERT INTO public.who_global_data VALUES (75017, 0, 0, 0, 0, 317, 168);
INSERT INTO public.who_global_data VALUES (75018, 0, 1796, 5, 21, 317, 99);
INSERT INTO public.who_global_data VALUES (75019, 0, 17, 0, 0, 317, 171);
INSERT INTO public.who_global_data VALUES (75020, 2, 2, 0, 0, 317, 87);
INSERT INTO public.who_global_data VALUES (75021, 5, 134, 0, 0, 317, 123);
INSERT INTO public.who_global_data VALUES (75022, 0, 0, 0, 0, 317, 151);
INSERT INTO public.who_global_data VALUES (75023, 9, 66, 1, 1, 317, 213);
INSERT INTO public.who_global_data VALUES (75024, 0, 6, 0, 0, 317, 118);
INSERT INTO public.who_global_data VALUES (75025, 5, 47, 0, 2, 317, 134);
INSERT INTO public.who_global_data VALUES (75026, 5, 35, 0, 0, 317, 65);
INSERT INTO public.who_global_data VALUES (75027, 162, 478, 3, 5, 317, 102);
INSERT INTO public.who_global_data VALUES (75028, 0, 0, 0, 0, 317, 223);
INSERT INTO public.who_global_data VALUES (75029, 0, 23, 0, 0, 317, 4);
INSERT INTO public.who_global_data VALUES (75030, 1, 11, 0, 0, 317, 146);
INSERT INTO public.who_global_data VALUES (75031, 4, 70, 0, 1, 317, 31);
INSERT INTO public.who_global_data VALUES (75032, -3, 2, 0, 0, 317, 127);
INSERT INTO public.who_global_data VALUES (75033, 55, 225, 1, 6, 317, 22);
INSERT INTO public.who_global_data VALUES (75034, 2, 5, 0, 0, 317, 115);
INSERT INTO public.who_global_data VALUES (75035, 0, 3, 0, 0, 317, 106);
INSERT INTO public.who_global_data VALUES (75036, 4, 8, 0, 0, 317, 90);
INSERT INTO public.who_global_data VALUES (75037, 0, 0, 0, 0, 317, 70);
INSERT INTO public.who_global_data VALUES (75038, 1, 3, 0, 0, 317, 46);
INSERT INTO public.who_global_data VALUES (75039, 843, 6330, 76, 348, 317, 139);
INSERT INTO public.who_global_data VALUES (75040, 2, 14, 0, 0, 317, 42);
INSERT INTO public.who_global_data VALUES (75041, 73, 262, 0, 0, 317, 80);
INSERT INTO public.who_global_data VALUES (75042, 0, 2, 0, 0, 317, 203);
INSERT INTO public.who_global_data VALUES (75043, 0, 2, 0, 0, 317, 136);
INSERT INTO public.who_global_data VALUES (75044, 4, 46, 1, 1, 317, 63);
INSERT INTO public.who_global_data VALUES (75045, 0, 0, 0, 0, 317, 17);
INSERT INTO public.who_global_data VALUES (75046, 0, 0, 0, 0, 317, 172);
INSERT INTO public.who_global_data VALUES (75047, 24, 201, 1, 3, 317, 109);
INSERT INTO public.who_global_data VALUES (75048, 350, 2916, 2, 12, 317, 200);
INSERT INTO public.who_global_data VALUES (75049, 22, 84, 1, 1, 317, 93);
INSERT INTO public.who_global_data VALUES (75050, 10, 109, 0, 0, 317, 5);
INSERT INTO public.who_global_data VALUES (75051, 0, 712, 0, 10, 317, 214);
INSERT INTO public.who_global_data VALUES (75052, 66, 1057, 1, 8, 317, 204);
INSERT INTO public.who_global_data VALUES (75053, 0, 0, 0, 0, 317, 198);
INSERT INTO public.who_global_data VALUES (75054, 213, 558, 2, 8, 317, 173);
INSERT INTO public.who_global_data VALUES (75055, 0, 1, 0, 0, 317, 229);
INSERT INTO public.who_global_data VALUES (75056, 14, 41, 1, 3, 317, 76);
INSERT INTO public.who_global_data VALUES (75057, 164, 580, 4, 9, 317, 138);
INSERT INTO public.who_global_data VALUES (75058, 71, 707, 7, 45, 317, 98);
INSERT INTO public.who_global_data VALUES (75059, 0, 0, 0, 0, 317, 103);
INSERT INTO public.who_global_data VALUES (75060, 150, 1051, 4, 14, 317, 225);
INSERT INTO public.who_global_data VALUES (75061, 633, 2995, 10, 43, 317, 131);
INSERT INTO public.who_global_data VALUES (75062, 25, 64, 0, 2, 317, 235);
INSERT INTO public.who_global_data VALUES (75063, 11, 537, 0, 0, 317, 137);
INSERT INTO public.who_global_data VALUES (75064, 104, 9241, 5, 131, 317, 81);
INSERT INTO public.who_global_data VALUES (75065, 0, 149, 0, 1, 317, 182);
INSERT INTO public.who_global_data VALUES (75066, 11, 94, 0, 0, 317, 145);
INSERT INTO public.who_global_data VALUES (75067, 144, 906, 2, 13, 317, 26);
INSERT INTO public.who_global_data VALUES (75068, 182, 840, 2, 2, 317, 170);
INSERT INTO public.who_global_data VALUES (75069, 1, 41, 0, 0, 317, 191);
INSERT INTO public.who_global_data VALUES (75070, 0, 0, 0, 0, 317, 221);
INSERT INTO public.who_global_data VALUES (75071, 0, 3, 0, 0, 317, 64);
INSERT INTO public.who_global_data VALUES (75072, 0, 0, 0, 0, 317, 116);
INSERT INTO public.who_global_data VALUES (75073, 2, 2, 0, 0, 317, 128);
INSERT INTO public.who_global_data VALUES (75074, 0, 3, 0, 0, 317, 6);
INSERT INTO public.who_global_data VALUES (75075, 3, 11, 0, 0, 317, 227);
INSERT INTO public.who_global_data VALUES (75076, 0, 0, 0, 0, 317, 68);
INSERT INTO public.who_global_data VALUES (75077, 0, 1, 0, 0, 317, 184);
INSERT INTO public.who_global_data VALUES (75078, 0, 0, 0, 0, 317, 82);
INSERT INTO public.who_global_data VALUES (75079, 10, 218, 0, 21, 317, 149);
INSERT INTO public.who_global_data VALUES (75080, 0, 0, 0, 0, 317, 197);
INSERT INTO public.who_global_data VALUES (75081, 112, 1012, 1, 3, 317, 78);
INSERT INTO public.who_global_data VALUES (75082, 13, 99, 0, 0, 317, 233);
INSERT INTO public.who_global_data VALUES (75083, 0, 384, 0, 4, 317, 133);
INSERT INTO public.who_global_data VALUES (75084, 0, 7, 0, 0, 317, 35);
INSERT INTO public.who_global_data VALUES (75085, 0, 0, 0, 0, 317, 114);
INSERT INTO public.who_global_data VALUES (75086, 73, 631, 0, 2, 317, 237);
INSERT INTO public.who_global_data VALUES (75087, 0, 0, 0, 0, 317, 55);
INSERT INTO public.who_global_data VALUES (75088, 0, 2, 0, 0, 317, 176);
INSERT INTO public.who_global_data VALUES (75089, 12, 216, 0, 0, 317, 202);
INSERT INTO public.who_global_data VALUES (75090, 47, 573, 0, 6, 317, 155);
INSERT INTO public.who_global_data VALUES (75091, 0, 0, 0, 0, 317, 32);
INSERT INTO public.who_global_data VALUES (75092, -3, 2, 0, 0, 317, 220);
INSERT INTO public.who_global_data VALUES (75093, 373, 927, 0, 0, 317, 30);
INSERT INTO public.who_global_data VALUES (75094, 0, 0, 0, 0, 317, 147);
INSERT INTO public.who_global_data VALUES (75095, 9725, 66873, 723, 4323, 317, 208);
INSERT INTO public.who_global_data VALUES (75096, 0, 102, 0, 0, 317, 45);
INSERT INTO public.who_global_data VALUES (75097, 0, 3, 0, 1, 317, 110);
INSERT INTO public.who_global_data VALUES (75098, 1, 7, 0, 0, 317, 88);
INSERT INTO public.who_global_data VALUES (75099, 230, 2399, 21, 81, 317, 51);
INSERT INTO public.who_global_data VALUES (75100, 1069, 13024, 39, 208, 317, 209);
INSERT INTO public.who_global_data VALUES (75101, 4, 5, 0, 0, 317, 205);
INSERT INTO public.who_global_data VALUES (75102, 0, 0, 0, 0, 317, 18);
INSERT INTO public.who_global_data VALUES (75103, 111, 1045, 0, 4, 317, 72);
INSERT INTO public.who_global_data VALUES (75104, 2375, 15025, 191, 703, 317, 44);
INSERT INTO public.who_global_data VALUES (75105, 0, 1, 0, 0, 317, 15);
INSERT INTO public.who_global_data VALUES (75106, 3, 23, 0, 0, 317, 25);
INSERT INTO public.who_global_data VALUES (75107, 0, 0, 0, 0, 317, 179);
INSERT INTO public.who_global_data VALUES (75108, 0, 0, 0, 0, 317, 34);
INSERT INTO public.who_global_data VALUES (75109, 4, 61, 1, 1, 317, 207);
INSERT INTO public.who_global_data VALUES (75110, 0, 173, 0, 5, 317, 166);
INSERT INTO public.who_global_data VALUES (75111, 561, 2433, 15, 59, 317, 126);
INSERT INTO public.who_global_data VALUES (75112, 0, 0, 0, 0, 317, 97);
INSERT INTO public.who_global_data VALUES (75113, 1, 2, 0, 0, 317, 36);
INSERT INTO public.who_global_data VALUES (75114, 0, 0, 0, 0, 317, 125);
INSERT INTO public.who_global_data VALUES (75115, 5, 14, 0, 0, 317, 124);
INSERT INTO public.who_global_data VALUES (75116, 43, 156, 1, 5, 317, 185);
INSERT INTO public.who_global_data VALUES (75117, 0, 333, 0, 2, 317, 194);
INSERT INTO public.who_global_data VALUES (75118, 1, 13, 0, 0, 317, 144);
INSERT INTO public.who_global_data VALUES (75119, 16420, 68334, 318, 991, 317, 19);
INSERT INTO public.who_global_data VALUES (75120, 0, 17, 0, 0, 317, 217);
INSERT INTO public.who_global_data VALUES (75121, 55, 217, 0, 0, 317, 148);
INSERT INTO public.who_global_data VALUES (75122, 9, 65, 0, 0, 317, 86);
INSERT INTO public.who_global_data VALUES (75123, 0, 0, 0, 0, 317, 13);
INSERT INTO public.who_global_data VALUES (75124, 14, 91, 0, 0, 317, 157);
INSERT INTO public.who_global_data VALUES (75125, 14, 148, 0, 0, 317, 8);
INSERT INTO public.who_global_data VALUES (75126, 0, 0, 0, 0, 317, 73);
INSERT INTO public.who_global_data VALUES (75127, 0, 0, 0, 0, 317, 101);
INSERT INTO public.who_global_data VALUES (75128, 0, 3, 0, 0, 317, 165);
INSERT INTO public.who_global_data VALUES (75129, 0, 2, 0, 1, 317, 14);
INSERT INTO public.who_global_data VALUES (75130, 32, 74, 0, 1, 318, 193);
INSERT INTO public.who_global_data VALUES (75131, 23, 108, 0, 4, 318, 113);
INSERT INTO public.who_global_data VALUES (75132, 33, 264, 0, 17, 318, 143);
INSERT INTO public.who_global_data VALUES (75133, 0, 0, 0, 0, 318, 219);
INSERT INTO public.who_global_data VALUES (75134, 48, 213, 2, 3, 318, 186);
INSERT INTO public.who_global_data VALUES (75135, 0, 2, 0, 0, 318, 52);
INSERT INTO public.who_global_data VALUES (75136, 0, 0, 0, 0, 318, 180);
INSERT INTO public.who_global_data VALUES (75137, 0, 3, 0, 0, 318, 167);
INSERT INTO public.who_global_data VALUES (75138, 0, 301, 0, 4, 318, 154);
INSERT INTO public.who_global_data VALUES (75139, 41, 212, 0, 0, 318, 94);
INSERT INTO public.who_global_data VALUES (75140, 0, 12, 0, 0, 318, 66);
INSERT INTO public.who_global_data VALUES (75141, 287, 2423, 0, 8, 318, 58);
INSERT INTO public.who_global_data VALUES (75142, 796, 5282, 5, 30, 318, 163);
INSERT INTO public.who_global_data VALUES (75143, 15, 87, 0, 1, 318, 37);
INSERT INTO public.who_global_data VALUES (75144, 0, 4, 0, 0, 318, 142);
INSERT INTO public.who_global_data VALUES (75145, 29, 419, 0, 3, 318, 83);
INSERT INTO public.who_global_data VALUES (75146, 0, 39, 0, 4, 318, 228);
INSERT INTO public.who_global_data VALUES (75147, 0, 18, 0, 0, 318, 188);
INSERT INTO public.who_global_data VALUES (75148, 0, 81, 0, 0, 318, 62);
INSERT INTO public.who_global_data VALUES (75149, 1195, 8051, 77, 375, 318, 160);
INSERT INTO public.who_global_data VALUES (75150, 0, 1, 0, 0, 318, 50);
INSERT INTO public.who_global_data VALUES (75151, 0, 5, 0, 0, 318, 33);
INSERT INTO public.who_global_data VALUES (75152, 0, 6, 0, 0, 318, 183);
INSERT INTO public.who_global_data VALUES (75153, 0, 2, 0, 0, 318, 92);
INSERT INTO public.who_global_data VALUES (75154, 0, 28, 0, 0, 318, 158);
INSERT INTO public.who_global_data VALUES (75155, 0, 0, 0, 0, 318, 67);
INSERT INTO public.who_global_data VALUES (75156, 9, 173, 1, 3, 318, 57);
INSERT INTO public.who_global_data VALUES (75157, 0, 0, 0, 0, 318, 38);
INSERT INTO public.who_global_data VALUES (75158, 0, 2201, 0, 46, 318, 141);
INSERT INTO public.who_global_data VALUES (75159, 0, 0, 0, 0, 318, 178);
INSERT INTO public.who_global_data VALUES (75160, 13, 104, 0, 0, 318, 108);
INSERT INTO public.who_global_data VALUES (75161, 19, 220, 0, 3, 318, 39);
INSERT INTO public.who_global_data VALUES (75162, 15, 114, 0, 3, 318, 2);
INSERT INTO public.who_global_data VALUES (75163, 0, 0, 0, 0, 318, 195);
INSERT INTO public.who_global_data VALUES (75164, 0, 3, 0, 0, 318, 107);
INSERT INTO public.who_global_data VALUES (75165, 4, 91, 0, 0, 318, 161);
INSERT INTO public.who_global_data VALUES (75166, 0, 70, 1, 1, 318, 212);
INSERT INTO public.who_global_data VALUES (75167, 0, 1739, 0, 25, 318, 181);
INSERT INTO public.who_global_data VALUES (75168, 0, 5, 0, 1, 318, 53);
INSERT INTO public.who_global_data VALUES (75169, 0, 4, 0, 0, 318, 164);
INSERT INTO public.who_global_data VALUES (75170, 0, 3, 0, 0, 318, 140);
INSERT INTO public.who_global_data VALUES (75171, 0, 922, 0, 2, 318, 20);
INSERT INTO public.who_global_data VALUES (75172, 102, 81869, 4, 3287, 318, 112);
INSERT INTO public.who_global_data VALUES (75173, 0, 306, 0, 3, 318, 111);
INSERT INTO public.who_global_data VALUES (75174, 0, 0, 0, 0, 318, 71);
INSERT INTO public.who_global_data VALUES (75175, 0, 4, 0, 0, 318, 218);
INSERT INTO public.who_global_data VALUES (75176, 0, 0, 0, 0, 318, 43);
INSERT INTO public.who_global_data VALUES (75177, 0, 177, 0, 2, 318, 49);
INSERT INTO public.who_global_data VALUES (75178, 47, 72, 0, 0, 318, 1);
INSERT INTO public.who_global_data VALUES (75179, 76, 382, 1, 1, 318, 48);
INSERT INTO public.who_global_data VALUES (75180, 0, 48, 0, 1, 318, 232);
INSERT INTO public.who_global_data VALUES (75181, 0, 6, 0, 1, 318, 175);
INSERT INTO public.who_global_data VALUES (75182, 8, 124, 3, 3, 318, 21);
INSERT INTO public.who_global_data VALUES (75183, 158, 1394, 2, 3, 318, 156);
INSERT INTO public.who_global_data VALUES (75184, 0, 0, 0, 0, 318, 95);
INSERT INTO public.who_global_data VALUES (75185, 9, 45, 0, 2, 318, 177);
INSERT INTO public.who_global_data VALUES (75186, 131, 1591, 8, 32, 318, 210);
INSERT INTO public.who_global_data VALUES (75187, 9, 12, 0, 0, 318, 120);
INSERT INTO public.who_global_data VALUES (75188, 0, 2, 0, 0, 318, 135);
INSERT INTO public.who_global_data VALUES (75189, 0, 312, 0, 6, 318, 206);
INSERT INTO public.who_global_data VALUES (75190, 0, 1049, 0, 8, 318, 189);
INSERT INTO public.who_global_data VALUES (75191, 76, 442, 2, 21, 318, 129);
INSERT INTO public.who_global_data VALUES (75192, 0, 5, 0, 0, 318, 121);
INSERT INTO public.who_global_data VALUES (75193, 0, 6, 0, 0, 318, 59);
INSERT INTO public.who_global_data VALUES (75194, 0, 1, 0, 0, 318, 96);
INSERT INTO public.who_global_data VALUES (75195, 17, 369, 0, 0, 318, 41);
INSERT INTO public.who_global_data VALUES (75196, 0, 4, 0, 0, 318, 216);
INSERT INTO public.who_global_data VALUES (75197, 1, 12, 0, 0, 318, 236);
INSERT INTO public.who_global_data VALUES (75198, 0, 0, 0, 0, 318, 150);
INSERT INTO public.who_global_data VALUES (75199, 4, 122, 0, 0, 318, 61);
INSERT INTO public.who_global_data VALUES (75200, 1, 5, 0, 0, 318, 7);
INSERT INTO public.who_global_data VALUES (75201, 92, 792, 0, 1, 318, 169);
INSERT INTO public.who_global_data VALUES (75202, 2428, 22025, 240, 1100, 318, 28);
INSERT INTO public.who_global_data VALUES (75203, 0, 23, 0, 0, 318, 85);
INSERT INTO public.who_global_data VALUES (75204, 2, 25, 0, 0, 318, 211);
INSERT INTO public.who_global_data VALUES (75205, 0, 6, 0, 1, 318, 60);
INSERT INTO public.who_global_data VALUES (75206, -3, 2, 0, 0, 318, 3);
INSERT INTO public.who_global_data VALUES (75207, 7, 77, 0, 0, 318, 11);
INSERT INTO public.who_global_data VALUES (75208, 2342, 31554, 23, 149, 318, 89);
INSERT INTO public.who_global_data VALUES (75209, 26, 53, 0, 2, 318, 24);
INSERT INTO public.who_global_data VALUES (75210, 0, 15, 0, 0, 318, 162);
INSERT INTO public.who_global_data VALUES (75211, 48, 743, 3, 20, 318, 100);
INSERT INTO public.who_global_data VALUES (75212, 0, 4, 0, 0, 318, 47);
INSERT INTO public.who_global_data VALUES (75213, 0, 1, 0, 0, 318, 29);
INSERT INTO public.who_global_data VALUES (75214, 0, 73, 0, 0, 318, 40);
INSERT INTO public.who_global_data VALUES (75215, 3, 32, 0, 1, 318, 222);
INSERT INTO public.who_global_data VALUES (75216, 0, 21, 0, 1, 318, 132);
INSERT INTO public.who_global_data VALUES (75217, 3, 23, 0, 0, 318, 130);
INSERT INTO public.who_global_data VALUES (75218, 0, 4, 0, 0, 318, 234);
INSERT INTO public.who_global_data VALUES (75219, 0, 0, 0, 0, 318, 23);
INSERT INTO public.who_global_data VALUES (75220, 0, 9, 0, 1, 318, 192);
INSERT INTO public.who_global_data VALUES (75221, 0, 7, 0, 0, 318, 69);
INSERT INTO public.who_global_data VALUES (75222, 0, 1, 0, 0, 318, 187);
INSERT INTO public.who_global_data VALUES (75223, 0, 30, 0, 0, 318, 230);
INSERT INTO public.who_global_data VALUES (75224, 39, 226, 2, 10, 318, 77);
INSERT INTO public.who_global_data VALUES (75225, 60, 648, 0, 2, 318, 9);
INSERT INTO public.who_global_data VALUES (75226, 87, 606, 1, 10, 318, 74);
INSERT INTO public.who_global_data VALUES (75227, 211, 790, 9, 58, 318, 224);
INSERT INTO public.who_global_data VALUES (75228, 2206, 27017, 143, 2077, 318, 199);
INSERT INTO public.who_global_data VALUES (75229, 30, 346, 2, 29, 318, 190);
INSERT INTO public.who_global_data VALUES (75230, 204, 1329, 1, 7, 318, 12);
INSERT INTO public.who_global_data VALUES (75231, 10, 23, 0, 0, 318, 104);
INSERT INTO public.who_global_data VALUES (75232, 352, 1620, 0, 1, 318, 153);
INSERT INTO public.who_global_data VALUES (75233, 5249, 69176, 743, 6820, 318, 91);
INSERT INTO public.who_global_data VALUES (75234, 0, 21, 0, 1, 318, 215);
INSERT INTO public.who_global_data VALUES (75235, 65, 1193, 1, 43, 318, 84);
INSERT INTO public.who_global_data VALUES (75236, 0, 16, 0, 0, 318, 231);
INSERT INTO public.who_global_data VALUES (75237, 26, 153, 0, 0, 318, 196);
INSERT INTO public.who_global_data VALUES (75238, 15, 97, 0, 0, 318, 105);
INSERT INTO public.who_global_data VALUES (75239, 9, 25, 0, 0, 318, 122);
INSERT INTO public.who_global_data VALUES (75240, 0, 0, 0, 0, 318, 159);
INSERT INTO public.who_global_data VALUES (75241, 8, 71, 0, 1, 318, 75);
INSERT INTO public.who_global_data VALUES (75242, 4, 195, 0, 0, 318, 27);
INSERT INTO public.who_global_data VALUES (75243, 26, 42, 0, 0, 318, 54);
INSERT INTO public.who_global_data VALUES (75244, 0, 2, 0, 0, 318, 226);
INSERT INTO public.who_global_data VALUES (75245, 17, 197, 0, 0, 318, 79);
INSERT INTO public.who_global_data VALUES (75246, 29, 333, 0, 4, 318, 56);
INSERT INTO public.who_global_data VALUES (75247, 0, 0, 0, 0, 318, 117);
INSERT INTO public.who_global_data VALUES (75248, 0, 3, 0, 0, 318, 152);
INSERT INTO public.who_global_data VALUES (75249, 1, 1, 0, 0, 318, 16);
INSERT INTO public.who_global_data VALUES (75250, 2, 53, 0, 0, 318, 10);
INSERT INTO public.who_global_data VALUES (75251, 42, 208, 2, 3, 318, 201);
INSERT INTO public.who_global_data VALUES (75252, 224, 1099, 0, 8, 318, 174);
INSERT INTO public.who_global_data VALUES (75253, 6, 19, 0, 0, 318, 119);
INSERT INTO public.who_global_data VALUES (75254, 0, 0, 0, 0, 318, 168);
INSERT INTO public.who_global_data VALUES (75255, 278, 1796, 1, 16, 318, 99);
INSERT INTO public.who_global_data VALUES (75256, 0, 17, 0, 0, 318, 171);
INSERT INTO public.who_global_data VALUES (75257, 0, 0, 0, 0, 318, 87);
INSERT INTO public.who_global_data VALUES (75258, 15, 129, 0, 0, 318, 123);
INSERT INTO public.who_global_data VALUES (75259, 0, 0, 0, 0, 318, 151);
INSERT INTO public.who_global_data VALUES (75260, 0, 57, 0, 0, 318, 213);
INSERT INTO public.who_global_data VALUES (75261, 0, 6, 0, 0, 318, 118);
INSERT INTO public.who_global_data VALUES (75262, 6, 42, 2, 2, 318, 134);
INSERT INTO public.who_global_data VALUES (75263, 6, 30, 0, 0, 318, 65);
INSERT INTO public.who_global_data VALUES (75264, 0, 316, 0, 2, 318, 102);
INSERT INTO public.who_global_data VALUES (75265, 0, 0, 0, 0, 318, 223);
INSERT INTO public.who_global_data VALUES (75266, 1, 23, 0, 0, 318, 4);
INSERT INTO public.who_global_data VALUES (75267, 0, 10, 0, 0, 318, 146);
INSERT INTO public.who_global_data VALUES (75268, 15, 66, 0, 1, 318, 31);
INSERT INTO public.who_global_data VALUES (75269, 0, 5, 0, 0, 318, 127);
INSERT INTO public.who_global_data VALUES (75270, 27, 170, 1, 5, 318, 22);
INSERT INTO public.who_global_data VALUES (75271, 2, 3, 0, 0, 318, 115);
INSERT INTO public.who_global_data VALUES (75272, 1, 3, 0, 0, 318, 106);
INSERT INTO public.who_global_data VALUES (75273, -3, 4, 0, 0, 318, 90);
INSERT INTO public.who_global_data VALUES (75274, 0, 0, 0, 0, 318, 70);
INSERT INTO public.who_global_data VALUES (75275, 0, 2, 0, 0, 318, 46);
INSERT INTO public.who_global_data VALUES (75276, 749, 5487, 62, 272, 318, 139);
INSERT INTO public.who_global_data VALUES (75277, 3, 12, 0, 0, 318, 42);
INSERT INTO public.who_global_data VALUES (75278, 47, 189, 0, 0, 318, 80);
INSERT INTO public.who_global_data VALUES (75279, 0, 2, 0, 0, 318, 203);
INSERT INTO public.who_global_data VALUES (75280, 0, 2, 0, 0, 318, 136);
INSERT INTO public.who_global_data VALUES (75281, 20, 42, 0, 0, 318, 63);
INSERT INTO public.who_global_data VALUES (75282, 0, 0, 0, 0, 318, 17);
INSERT INTO public.who_global_data VALUES (75283, 0, 0, 0, 0, 318, 172);
INSERT INTO public.who_global_data VALUES (75284, 29, 177, 0, 2, 318, 109);
INSERT INTO public.who_global_data VALUES (75285, 195, 2566, 2, 10, 318, 200);
INSERT INTO public.who_global_data VALUES (75286, 2, 62, 0, 0, 318, 93);
INSERT INTO public.who_global_data VALUES (75287, 15, 99, 0, 0, 318, 5);
INSERT INTO public.who_global_data VALUES (75288, 0, 712, 0, 10, 318, 214);
INSERT INTO public.who_global_data VALUES (75289, 104, 991, 1, 7, 318, 204);
INSERT INTO public.who_global_data VALUES (75290, 0, 0, 0, 0, 318, 198);
INSERT INTO public.who_global_data VALUES (75291, 0, 345, 0, 6, 318, 173);
INSERT INTO public.who_global_data VALUES (75292, 0, 1, 0, 0, 318, 229);
INSERT INTO public.who_global_data VALUES (75293, 0, 27, 0, 2, 318, 76);
INSERT INTO public.who_global_data VALUES (75294, 0, 416, 0, 5, 318, 138);
INSERT INTO public.who_global_data VALUES (75295, 174, 636, 5, 38, 318, 98);
INSERT INTO public.who_global_data VALUES (75296, 0, 0, 0, 0, 318, 103);
INSERT INTO public.who_global_data VALUES (75297, 152, 901, 2, 10, 318, 225);
INSERT INTO public.who_global_data VALUES (75298, 302, 2362, 10, 33, 318, 131);
INSERT INTO public.who_global_data VALUES (75299, 0, 39, 0, 2, 318, 235);
INSERT INTO public.who_global_data VALUES (75300, 25, 526, 0, 0, 318, 137);
INSERT INTO public.who_global_data VALUES (75301, 100, 9137, 6, 126, 318, 81);
INSERT INTO public.who_global_data VALUES (75302, 40, 149, 0, 1, 318, 182);
INSERT INTO public.who_global_data VALUES (75303, 12, 83, 0, 0, 318, 145);
INSERT INTO public.who_global_data VALUES (75304, 186, 762, 4, 11, 318, 26);
INSERT INTO public.who_global_data VALUES (75305, 163, 658, 0, 0, 318, 170);
INSERT INTO public.who_global_data VALUES (75306, 4, 40, 0, 0, 318, 191);
INSERT INTO public.who_global_data VALUES (75307, 0, 0, 0, 0, 318, 221);
INSERT INTO public.who_global_data VALUES (75308, 0, 3, 0, 0, 318, 64);
INSERT INTO public.who_global_data VALUES (75309, 0, 0, 0, 0, 318, 116);
INSERT INTO public.who_global_data VALUES (75310, 0, 0, 0, 0, 318, 128);
INSERT INTO public.who_global_data VALUES (75311, 0, 3, 0, 0, 318, 6);
INSERT INTO public.who_global_data VALUES (75312, 0, 8, 0, 0, 318, 227);
INSERT INTO public.who_global_data VALUES (75313, 0, 0, 0, 0, 318, 68);
INSERT INTO public.who_global_data VALUES (75314, 0, 1, 0, 0, 318, 184);
INSERT INTO public.who_global_data VALUES (75315, 0, 0, 0, 0, 318, 82);
INSERT INTO public.who_global_data VALUES (75316, 21, 208, 0, 21, 318, 149);
INSERT INTO public.who_global_data VALUES (75317, 0, 0, 0, 0, 318, 197);
INSERT INTO public.who_global_data VALUES (75318, 133, 900, 1, 2, 318, 78);
INSERT INTO public.who_global_data VALUES (75319, 7, 86, 0, 0, 318, 233);
INSERT INTO public.who_global_data VALUES (75320, 135, 384, 2, 4, 318, 133);
INSERT INTO public.who_global_data VALUES (75321, 0, 7, 0, 0, 318, 35);
INSERT INTO public.who_global_data VALUES (75322, 0, 0, 0, 0, 318, 114);
INSERT INTO public.who_global_data VALUES (75323, 51, 558, 0, 2, 318, 237);
INSERT INTO public.who_global_data VALUES (75324, 0, 0, 0, 0, 318, 55);
INSERT INTO public.who_global_data VALUES (75325, 0, 2, 0, 0, 318, 176);
INSERT INTO public.who_global_data VALUES (75326, 13, 204, 0, 0, 318, 202);
INSERT INTO public.who_global_data VALUES (75327, 48, 526, 3, 6, 318, 155);
INSERT INTO public.who_global_data VALUES (75328, 0, 0, 0, 0, 318, 32);
INSERT INTO public.who_global_data VALUES (75329, 0, 5, 0, 0, 318, 220);
INSERT INTO public.who_global_data VALUES (75330, 152, 554, 0, 0, 318, 30);
INSERT INTO public.who_global_data VALUES (75331, 0, 0, 0, 0, 318, 147);
INSERT INTO public.who_global_data VALUES (75332, 8206, 57148, 686, 3600, 318, 208);
INSERT INTO public.who_global_data VALUES (75333, 5, 102, 0, 0, 318, 45);
INSERT INTO public.who_global_data VALUES (75334, 0, 3, 0, 1, 318, 110);
INSERT INTO public.who_global_data VALUES (75335, 0, 6, 0, 0, 318, 88);
INSERT INTO public.who_global_data VALUES (75336, 182, 2169, 11, 60, 318, 51);
INSERT INTO public.who_global_data VALUES (75337, 1241, 11955, 19, 169, 318, 209);
INSERT INTO public.who_global_data VALUES (75338, 0, 1, 0, 0, 318, 205);
INSERT INTO public.who_global_data VALUES (75339, 0, 0, 0, 0, 318, 18);
INSERT INTO public.who_global_data VALUES (75340, 107, 934, 0, 4, 318, 72);
INSERT INTO public.who_global_data VALUES (75341, 2338, 12650, 148, 512, 318, 44);
INSERT INTO public.who_global_data VALUES (75342, 0, 1, 0, 0, 318, 15);
INSERT INTO public.who_global_data VALUES (75343, 2, 20, 0, 0, 318, 25);
INSERT INTO public.who_global_data VALUES (75344, 0, 0, 0, 0, 318, 179);
INSERT INTO public.who_global_data VALUES (75345, 0, 0, 0, 0, 318, 34);
INSERT INTO public.who_global_data VALUES (75346, 0, 57, 0, 0, 318, 207);
INSERT INTO public.who_global_data VALUES (75347, 59, 173, 2, 5, 318, 166);
INSERT INTO public.who_global_data VALUES (75348, 343, 1872, 7, 44, 318, 126);
INSERT INTO public.who_global_data VALUES (75349, 0, 0, 0, 0, 318, 97);
INSERT INTO public.who_global_data VALUES (75350, 0, 1, 0, 0, 318, 36);
INSERT INTO public.who_global_data VALUES (75351, 0, 0, 0, 0, 318, 125);
INSERT INTO public.who_global_data VALUES (75352, 0, 9, 0, 0, 318, 124);
INSERT INTO public.who_global_data VALUES (75353, 29, 113, 1, 4, 318, 185);
INSERT INTO public.who_global_data VALUES (75354, 85, 333, 0, 2, 318, 194);
INSERT INTO public.who_global_data VALUES (75355, 0, 12, 0, 0, 318, 144);
INSERT INTO public.who_global_data VALUES (75356, 0, 51914, 0, 673, 318, 19);
INSERT INTO public.who_global_data VALUES (75357, 0, 17, 0, 0, 318, 217);
INSERT INTO public.who_global_data VALUES (75358, 0, 162, 0, 0, 318, 148);
INSERT INTO public.who_global_data VALUES (75359, 6, 56, 0, 0, 318, 86);
INSERT INTO public.who_global_data VALUES (75360, 0, 0, 0, 0, 318, 13);
INSERT INTO public.who_global_data VALUES (75361, 0, 77, 0, 0, 318, 157);
INSERT INTO public.who_global_data VALUES (75362, 11, 134, 0, 0, 318, 8);
INSERT INTO public.who_global_data VALUES (75363, 0, 0, 0, 0, 318, 73);
INSERT INTO public.who_global_data VALUES (75364, 0, 0, 0, 0, 318, 101);
INSERT INTO public.who_global_data VALUES (75365, 0, 3, 0, 0, 318, 165);
INSERT INTO public.who_global_data VALUES (75366, 0, 2, 0, 1, 318, 14);
INSERT INTO public.who_global_data VALUES (75367, 2, 42, 0, 1, 319, 193);
INSERT INTO public.who_global_data VALUES (75368, 19, 85, 1, 4, 319, 113);
INSERT INTO public.who_global_data VALUES (75369, 30, 231, 0, 17, 319, 143);
INSERT INTO public.who_global_data VALUES (75370, 0, 0, 0, 0, 319, 219);
INSERT INTO public.who_global_data VALUES (75371, 31, 165, 0, 1, 319, 186);
INSERT INTO public.who_global_data VALUES (75372, 0, 2, 0, 0, 319, 52);
INSERT INTO public.who_global_data VALUES (75373, 0, 0, 0, 0, 319, 180);
INSERT INTO public.who_global_data VALUES (75374, -2, 3, 0, 0, 319, 167);
INSERT INTO public.who_global_data VALUES (75375, 76, 301, 0, 4, 319, 154);
INSERT INTO public.who_global_data VALUES (75376, 4, 171, 0, 0, 319, 94);
INSERT INTO public.who_global_data VALUES (75377, 4, 12, 0, 0, 319, 66);
INSERT INTO public.who_global_data VALUES (75378, 427, 2136, 1, 8, 319, 58);
INSERT INTO public.who_global_data VALUES (75379, 855, 4486, 9, 25, 319, 163);
INSERT INTO public.who_global_data VALUES (75380, 0, 72, 0, 1, 319, 37);
INSERT INTO public.who_global_data VALUES (75381, 0, 4, 0, 0, 319, 142);
INSERT INTO public.who_global_data VALUES (75382, 51, 390, 1, 3, 319, 83);
INSERT INTO public.who_global_data VALUES (75383, 12, 39, 2, 4, 319, 228);
INSERT INTO public.who_global_data VALUES (75384, 13, 18, 0, 0, 319, 188);
INSERT INTO public.who_global_data VALUES (75385, 0, 81, 0, 0, 319, 62);
INSERT INTO public.who_global_data VALUES (75386, 1328, 6856, 78, 298, 319, 160);
INSERT INTO public.who_global_data VALUES (75387, 1, 1, 0, 0, 319, 50);
INSERT INTO public.who_global_data VALUES (75388, 3, 5, 0, 0, 319, 33);
INSERT INTO public.who_global_data VALUES (75389, 0, 6, 0, 0, 319, 183);
INSERT INTO public.who_global_data VALUES (75390, 0, 2, 0, 0, 319, 92);
INSERT INTO public.who_global_data VALUES (75391, 4, 28, 0, 0, 319, 158);
INSERT INTO public.who_global_data VALUES (75392, 0, 0, 0, 0, 319, 67);
INSERT INTO public.who_global_data VALUES (75393, 33, 164, 1, 2, 319, 57);
INSERT INTO public.who_global_data VALUES (75394, 0, 0, 0, 0, 319, 38);
INSERT INTO public.who_global_data VALUES (75395, 1297, 2201, 35, 46, 319, 141);
INSERT INTO public.who_global_data VALUES (75396, 0, 0, 0, 0, 319, 178);
INSERT INTO public.who_global_data VALUES (75397, 3, 91, 0, 0, 319, 108);
INSERT INTO public.who_global_data VALUES (75398, 16, 201, 0, 3, 319, 39);
INSERT INTO public.who_global_data VALUES (75399, 24, 99, 0, 3, 319, 2);
INSERT INTO public.who_global_data VALUES (75400, 0, 0, 0, 0, 319, 195);
INSERT INTO public.who_global_data VALUES (75401, 0, 3, 0, 0, 319, 107);
INSERT INTO public.who_global_data VALUES (75402, 1, 87, 0, 0, 319, 161);
INSERT INTO public.who_global_data VALUES (75403, 30, 70, 0, 0, 319, 212);
INSERT INTO public.who_global_data VALUES (75404, 355, 1739, 6, 25, 319, 181);
INSERT INTO public.who_global_data VALUES (75405, 2, 5, 0, 1, 319, 53);
INSERT INTO public.who_global_data VALUES (75406, 0, 4, 0, 0, 319, 164);
INSERT INTO public.who_global_data VALUES (75407, -2, 3, 0, 0, 319, 140);
INSERT INTO public.who_global_data VALUES (75408, 290, 922, 1, 2, 319, 20);
INSERT INTO public.who_global_data VALUES (75409, 164, 81767, 7, 3283, 319, 112);
INSERT INTO public.who_global_data VALUES (75410, 110, 306, 1, 3, 319, 111);
INSERT INTO public.who_global_data VALUES (75411, 0, 0, 0, 0, 319, 71);
INSERT INTO public.who_global_data VALUES (75412, 0, 4, 0, 0, 319, 218);
INSERT INTO public.who_global_data VALUES (75413, 0, 0, 0, 0, 319, 43);
INSERT INTO public.who_global_data VALUES (75414, 60, 177, 0, 2, 319, 49);
INSERT INTO public.who_global_data VALUES (75415, 0, 25, 0, 0, 319, 1);
INSERT INTO public.who_global_data VALUES (75416, 71, 306, 0, 0, 319, 48);
INSERT INTO public.who_global_data VALUES (75417, 32, 48, 0, 1, 319, 232);
INSERT INTO public.who_global_data VALUES (75418, 3, 6, 0, 1, 319, 175);
INSERT INTO public.who_global_data VALUES (75419, 21, 116, 0, 0, 319, 21);
INSERT INTO public.who_global_data VALUES (75420, 71, 1236, 0, 1, 319, 156);
INSERT INTO public.who_global_data VALUES (75421, 0, 0, 0, 0, 319, 95);
INSERT INTO public.who_global_data VALUES (75422, 6, 36, 0, 2, 319, 177);
INSERT INTO public.who_global_data VALUES (75423, 65, 1460, 11, 24, 319, 210);
INSERT INTO public.who_global_data VALUES (75424, 0, 3, 0, 0, 319, 120);
INSERT INTO public.who_global_data VALUES (75425, 2, 2, 0, 0, 319, 135);
INSERT INTO public.who_global_data VALUES (75426, 240, 312, 4, 6, 319, 206);
INSERT INTO public.who_global_data VALUES (75427, 517, 1049, 1, 8, 319, 189);
INSERT INTO public.who_global_data VALUES (75428, 39, 366, 5, 19, 319, 129);
INSERT INTO public.who_global_data VALUES (75429, 4, 5, 0, 0, 319, 121);
INSERT INTO public.who_global_data VALUES (75430, 0, 6, 0, 0, 319, 59);
INSERT INTO public.who_global_data VALUES (75431, 0, 1, 0, 0, 319, 96);
INSERT INTO public.who_global_data VALUES (75432, 26, 352, 0, 0, 319, 41);
INSERT INTO public.who_global_data VALUES (75433, 0, 4, 0, 0, 319, 216);
INSERT INTO public.who_global_data VALUES (75434, 0, 11, 0, 0, 319, 236);
INSERT INTO public.who_global_data VALUES (75435, 0, 0, 0, 0, 319, 150);
INSERT INTO public.who_global_data VALUES (75436, 3, 118, 0, 0, 319, 61);
INSERT INTO public.who_global_data VALUES (75437, 1, 4, 0, 0, 319, 7);
INSERT INTO public.who_global_data VALUES (75438, 74, 700, 0, 1, 319, 169);
INSERT INTO public.who_global_data VALUES (75439, 3776, 19597, 186, 860, 319, 28);
INSERT INTO public.who_global_data VALUES (75440, 5, 23, 0, 0, 319, 85);
INSERT INTO public.who_global_data VALUES (75441, 5, 23, 0, 0, 319, 211);
INSERT INTO public.who_global_data VALUES (75442, 0, 6, 0, 1, 319, 60);
INSERT INTO public.who_global_data VALUES (75443, 0, 5, 0, 0, 319, 3);
INSERT INTO public.who_global_data VALUES (75444, 9, 70, 0, 0, 319, 11);
INSERT INTO public.who_global_data VALUES (75445, 4438, 29212, 32, 126, 319, 89);
INSERT INTO public.who_global_data VALUES (75446, 3, 27, 2, 2, 319, 24);
INSERT INTO public.who_global_data VALUES (75447, 0, 15, 0, 0, 319, 162);
INSERT INTO public.who_global_data VALUES (75448, 71, 695, 2, 17, 319, 100);
INSERT INTO public.who_global_data VALUES (75449, 2, 4, 0, 0, 319, 47);
INSERT INTO public.who_global_data VALUES (75450, 0, 1, 0, 0, 319, 29);
INSERT INTO public.who_global_data VALUES (75451, 17, 73, 0, 0, 319, 40);
INSERT INTO public.who_global_data VALUES (75452, 2, 29, 0, 1, 319, 222);
INSERT INTO public.who_global_data VALUES (75453, 3, 21, 0, 1, 319, 132);
INSERT INTO public.who_global_data VALUES (75454, 3, 20, 0, 0, 319, 130);
INSERT INTO public.who_global_data VALUES (75455, -2, 4, 0, 0, 319, 234);
INSERT INTO public.who_global_data VALUES (75456, 0, 0, 0, 0, 319, 23);
INSERT INTO public.who_global_data VALUES (75457, 0, 9, 0, 1, 319, 192);
INSERT INTO public.who_global_data VALUES (75458, 5, 7, 0, 0, 319, 69);
INSERT INTO public.who_global_data VALUES (75459, 0, 1, 0, 0, 319, 187);
INSERT INTO public.who_global_data VALUES (75460, 4, 30, 0, 0, 319, 230);
INSERT INTO public.who_global_data VALUES (75461, 20, 187, 1, 8, 319, 77);
INSERT INTO public.who_global_data VALUES (75462, 20, 588, 1, 2, 319, 9);
INSERT INTO public.who_global_data VALUES (75463, 85, 519, 0, 9, 319, 74);
INSERT INTO public.who_global_data VALUES (75464, 0, 579, 0, 49, 319, 224);
INSERT INTO public.who_global_data VALUES (75465, 1762, 24811, 122, 1934, 319, 199);
INSERT INTO public.who_global_data VALUES (75466, 50, 316, 4, 27, 319, 190);
INSERT INTO public.who_global_data VALUES (75467, 219, 1125, 2, 6, 319, 12);
INSERT INTO public.who_global_data VALUES (75468, 11, 13, 0, 0, 319, 104);
INSERT INTO public.who_global_data VALUES (75469, 254, 1268, 0, 1, 319, 153);
INSERT INTO public.who_global_data VALUES (75470, 4789, 63927, 601, 6077, 319, 91);
INSERT INTO public.who_global_data VALUES (75471, 2, 21, 0, 1, 319, 215);
INSERT INTO public.who_global_data VALUES (75472, 39, 1128, 1, 42, 319, 84);
INSERT INTO public.who_global_data VALUES (75473, 1, 16, 0, 0, 319, 231);
INSERT INTO public.who_global_data VALUES (75474, 15, 127, 0, 0, 319, 196);
INSERT INTO public.who_global_data VALUES (75475, 10, 82, 0, 0, 319, 105);
INSERT INTO public.who_global_data VALUES (75476, 1, 16, 0, 0, 319, 122);
INSERT INTO public.who_global_data VALUES (75477, 0, 0, 0, 0, 319, 159);
INSERT INTO public.who_global_data VALUES (75478, 28, 63, 0, 1, 319, 75);
INSERT INTO public.who_global_data VALUES (75479, 2, 191, 0, 0, 319, 27);
INSERT INTO public.who_global_data VALUES (75480, 2, 16, 0, 0, 319, 54);
INSERT INTO public.who_global_data VALUES (75481, 2, 2, 0, 0, 319, 226);
INSERT INTO public.who_global_data VALUES (75482, 41, 180, 0, 0, 319, 79);
INSERT INTO public.who_global_data VALUES (75483, 37, 304, 0, 4, 319, 56);
INSERT INTO public.who_global_data VALUES (75484, 0, 0, 0, 0, 319, 117);
INSERT INTO public.who_global_data VALUES (75485, 0, 3, 0, 0, 319, 152);
INSERT INTO public.who_global_data VALUES (75486, 0, 0, 0, 0, 319, 16);
INSERT INTO public.who_global_data VALUES (75487, 3, 51, 0, 0, 319, 10);
INSERT INTO public.who_global_data VALUES (75488, 38, 166, 0, 1, 319, 201);
INSERT INTO public.who_global_data VALUES (75489, 77, 875, 0, 8, 319, 174);
INSERT INTO public.who_global_data VALUES (75490, 1, 13, 0, 0, 319, 119);
INSERT INTO public.who_global_data VALUES (75491, 0, 0, 0, 0, 319, 168);
INSERT INTO public.who_global_data VALUES (75492, 212, 1518, 4, 15, 319, 99);
INSERT INTO public.who_global_data VALUES (75493, 0, 17, 0, 0, 319, 171);
INSERT INTO public.who_global_data VALUES (75494, 0, 0, 0, 0, 319, 87);
INSERT INTO public.who_global_data VALUES (75495, 7, 114, 0, 0, 319, 123);
INSERT INTO public.who_global_data VALUES (75496, 0, 0, 0, 0, 319, 151);
INSERT INTO public.who_global_data VALUES (75497, 20, 57, 0, 0, 319, 213);
INSERT INTO public.who_global_data VALUES (75498, 0, 6, 0, 0, 319, 118);
INSERT INTO public.who_global_data VALUES (75499, 24, 36, 0, 0, 319, 134);
INSERT INTO public.who_global_data VALUES (75500, 10, 24, 0, 0, 319, 65);
INSERT INTO public.who_global_data VALUES (75501, 65, 316, 0, 2, 319, 102);
INSERT INTO public.who_global_data VALUES (75502, 0, 0, 0, 0, 319, 223);
INSERT INTO public.who_global_data VALUES (75503, 2, 22, 0, 0, 319, 4);
INSERT INTO public.who_global_data VALUES (75504, 0, 10, 0, 0, 319, 146);
INSERT INTO public.who_global_data VALUES (75505, 22, 51, 0, 1, 319, 31);
INSERT INTO public.who_global_data VALUES (75506, 0, 5, 0, 0, 319, 127);
INSERT INTO public.who_global_data VALUES (75507, 9, 143, 0, 4, 319, 22);
INSERT INTO public.who_global_data VALUES (75508, 0, 1, 0, 0, 319, 115);
INSERT INTO public.who_global_data VALUES (75509, 2, 2, 0, 0, 319, 106);
INSERT INTO public.who_global_data VALUES (75510, 0, 7, 0, 0, 319, 90);
INSERT INTO public.who_global_data VALUES (75511, 0, 0, 0, 0, 319, 70);
INSERT INTO public.who_global_data VALUES (75512, -3, 2, 0, 0, 319, 46);
INSERT INTO public.who_global_data VALUES (75513, 553, 4738, 32, 210, 319, 139);
INSERT INTO public.who_global_data VALUES (75514, 2, 9, 0, 0, 319, 42);
INSERT INTO public.who_global_data VALUES (75515, 40, 142, 0, 0, 319, 80);
INSERT INTO public.who_global_data VALUES (75516, 0, 2, 0, 0, 319, 203);
INSERT INTO public.who_global_data VALUES (75517, 0, 2, 0, 0, 319, 136);
INSERT INTO public.who_global_data VALUES (75518, 0, 22, 0, 0, 319, 63);
INSERT INTO public.who_global_data VALUES (75519, 0, 0, 0, 0, 319, 17);
INSERT INTO public.who_global_data VALUES (75520, 0, 0, 0, 0, 319, 172);
INSERT INTO public.who_global_data VALUES (75521, 12, 148, 0, 2, 319, 109);
INSERT INTO public.who_global_data VALUES (75522, 239, 2371, 1, 8, 319, 200);
INSERT INTO public.who_global_data VALUES (75523, 1, 60, 0, 0, 319, 93);
INSERT INTO public.who_global_data VALUES (75524, 18, 84, 0, 0, 319, 5);
INSERT INTO public.who_global_data VALUES (75525, 0, 712, 2, 10, 319, 214);
INSERT INTO public.who_global_data VALUES (75526, 103, 887, 1, 6, 319, 204);
INSERT INTO public.who_global_data VALUES (75527, 0, 0, 0, 0, 319, 198);
INSERT INTO public.who_global_data VALUES (75528, 100, 345, 3, 6, 319, 173);
INSERT INTO public.who_global_data VALUES (75529, 0, 1, 0, 0, 319, 229);
INSERT INTO public.who_global_data VALUES (75530, 5, 27, 1, 2, 319, 76);
INSERT INTO public.who_global_data VALUES (75531, 98, 416, 3, 5, 319, 138);
INSERT INTO public.who_global_data VALUES (75532, 66, 462, 0, 33, 319, 98);
INSERT INTO public.who_global_data VALUES (75533, 0, 0, 0, 0, 319, 103);
INSERT INTO public.who_global_data VALUES (75534, 115, 749, 1, 8, 319, 225);
INSERT INTO public.who_global_data VALUES (75535, 460, 2060, 9, 23, 319, 131);
INSERT INTO public.who_global_data VALUES (75536, 16, 39, 1, 2, 319, 235);
INSERT INTO public.who_global_data VALUES (75537, 7, 501, 0, 0, 319, 137);
INSERT INTO public.who_global_data VALUES (75538, 76, 9037, 9, 120, 319, 81);
INSERT INTO public.who_global_data VALUES (75539, 15, 109, 0, 1, 319, 182);
INSERT INTO public.who_global_data VALUES (75540, 7, 71, 0, 0, 319, 145);
INSERT INTO public.who_global_data VALUES (75541, 143, 576, 5, 7, 319, 26);
INSERT INTO public.who_global_data VALUES (75542, 57, 495, 0, 0, 319, 170);
INSERT INTO public.who_global_data VALUES (75543, 19, 36, 0, 0, 319, 191);
INSERT INTO public.who_global_data VALUES (75544, 0, 0, 0, 0, 319, 221);
INSERT INTO public.who_global_data VALUES (75545, 0, 3, 0, 0, 319, 64);
INSERT INTO public.who_global_data VALUES (75546, 0, 0, 0, 0, 319, 116);
INSERT INTO public.who_global_data VALUES (75547, 0, 0, 0, 0, 319, 128);
INSERT INTO public.who_global_data VALUES (75548, -3, 3, 0, 0, 319, 6);
INSERT INTO public.who_global_data VALUES (75549, 3, 8, 0, 0, 319, 227);
INSERT INTO public.who_global_data VALUES (75550, 0, 0, 0, 0, 319, 68);
INSERT INTO public.who_global_data VALUES (75551, 0, 1, 0, 0, 319, 184);
INSERT INTO public.who_global_data VALUES (75552, 0, 0, 0, 0, 319, 82);
INSERT INTO public.who_global_data VALUES (75553, 0, 187, 1, 21, 319, 149);
INSERT INTO public.who_global_data VALUES (75554, 0, 0, 0, 0, 319, 197);
INSERT INTO public.who_global_data VALUES (75555, 205, 767, 1, 1, 319, 78);
INSERT INTO public.who_global_data VALUES (75556, 12, 79, 0, 0, 319, 233);
INSERT INTO public.who_global_data VALUES (75557, 27, 249, 0, 2, 319, 133);
INSERT INTO public.who_global_data VALUES (75558, 0, 7, 0, 0, 319, 35);
INSERT INTO public.who_global_data VALUES (75559, 0, 0, 0, 0, 319, 114);
INSERT INTO public.who_global_data VALUES (75560, 52, 507, 0, 2, 319, 237);
INSERT INTO public.who_global_data VALUES (75561, 0, 0, 0, 0, 319, 55);
INSERT INTO public.who_global_data VALUES (75562, -3, 2, 0, 0, 319, 176);
INSERT INTO public.who_global_data VALUES (75563, 6, 191, 0, 0, 319, 202);
INSERT INTO public.who_global_data VALUES (75564, 36, 478, 1, 3, 319, 155);
INSERT INTO public.who_global_data VALUES (75565, 0, 0, 0, 0, 319, 32);
INSERT INTO public.who_global_data VALUES (75566, 0, 5, 0, 0, 319, 220);
INSERT INTO public.who_global_data VALUES (75567, 128, 402, 0, 0, 319, 30);
INSERT INTO public.who_global_data VALUES (75568, 0, 0, 0, 0, 319, 147);
INSERT INTO public.who_global_data VALUES (75569, 5322, 48942, 551, 2914, 319, 208);
INSERT INTO public.who_global_data VALUES (75570, 3, 97, 0, 0, 319, 45);
INSERT INTO public.who_global_data VALUES (75571, 1, 3, 0, 1, 319, 110);
INSERT INTO public.who_global_data VALUES (75572, 4, 6, 0, 0, 319, 88);
INSERT INTO public.who_global_data VALUES (75573, 118, 1987, 11, 49, 319, 51);
INSERT INTO public.who_global_data VALUES (75574, 1461, 10714, 23, 150, 319, 209);
INSERT INTO public.who_global_data VALUES (75575, 0, 1, 0, 0, 319, 205);
INSERT INTO public.who_global_data VALUES (75576, 0, 0, 0, 0, 319, 18);
INSERT INTO public.who_global_data VALUES (75577, 106, 827, 3, 4, 319, 72);
INSERT INTO public.who_global_data VALUES (75578, 1378, 10312, 76, 364, 319, 44);
INSERT INTO public.who_global_data VALUES (75579, 0, 1, 0, 0, 319, 15);
INSERT INTO public.who_global_data VALUES (75580, 2, 18, 0, 0, 319, 25);
INSERT INTO public.who_global_data VALUES (75581, 0, 0, 0, 0, 319, 179);
INSERT INTO public.who_global_data VALUES (75582, 0, 0, 0, 0, 319, 34);
INSERT INTO public.who_global_data VALUES (75583, 7, 57, 0, 0, 319, 207);
INSERT INTO public.who_global_data VALUES (75584, 25, 114, 0, 3, 319, 166);
INSERT INTO public.who_global_data VALUES (75585, 293, 1529, 7, 37, 319, 126);
INSERT INTO public.who_global_data VALUES (75586, 0, 0, 0, 0, 319, 97);
INSERT INTO public.who_global_data VALUES (75587, 1, 1, 0, 0, 319, 36);
INSERT INTO public.who_global_data VALUES (75588, 0, 0, 0, 0, 319, 125);
INSERT INTO public.who_global_data VALUES (75589, 8, 9, 0, 0, 319, 124);
INSERT INTO public.who_global_data VALUES (75590, 11, 84, 0, 3, 319, 185);
INSERT INTO public.who_global_data VALUES (75591, 50, 248, 0, 2, 319, 194);
INSERT INTO public.who_global_data VALUES (75592, 0, 12, 0, 0, 319, 144);
INSERT INTO public.who_global_data VALUES (75593, 20341, 51914, 271, 673, 319, 19);
INSERT INTO public.who_global_data VALUES (75594, 11, 17, 0, 0, 319, 217);
INSERT INTO public.who_global_data VALUES (75595, 27, 162, 0, 0, 319, 148);
INSERT INTO public.who_global_data VALUES (75596, 4, 50, 0, 0, 319, 86);
INSERT INTO public.who_global_data VALUES (75597, 0, 0, 0, 0, 319, 13);
INSERT INTO public.who_global_data VALUES (75598, 7, 77, 0, 0, 319, 157);
INSERT INTO public.who_global_data VALUES (75599, 5, 123, 0, 0, 319, 8);
INSERT INTO public.who_global_data VALUES (75600, 0, 0, 0, 0, 319, 73);
INSERT INTO public.who_global_data VALUES (75601, 0, 0, 0, 0, 319, 101);
INSERT INTO public.who_global_data VALUES (75602, 0, 3, 0, 0, 319, 165);
INSERT INTO public.who_global_data VALUES (75603, 0, 2, 1, 1, 319, 14);
INSERT INTO public.who_global_data VALUES (75604, 6, 40, 1, 1, 320, 193);
INSERT INTO public.who_global_data VALUES (75605, 15, 66, 2, 3, 320, 113);
INSERT INTO public.who_global_data VALUES (75606, 62, 201, 2, 17, 320, 143);
INSERT INTO public.who_global_data VALUES (75607, 0, 0, 0, 0, 320, 219);
INSERT INTO public.who_global_data VALUES (75608, 1, 134, 0, 1, 320, 186);
INSERT INTO public.who_global_data VALUES (75609, 0, 2, 0, 0, 320, 52);
INSERT INTO public.who_global_data VALUES (75610, 0, 0, 0, 0, 320, 180);
INSERT INTO public.who_global_data VALUES (75611, 0, 5, 0, 0, 320, 167);
INSERT INTO public.who_global_data VALUES (75612, 67, 225, 1, 4, 320, 154);
INSERT INTO public.who_global_data VALUES (75613, 30, 167, 0, 0, 320, 94);
INSERT INTO public.who_global_data VALUES (75614, 3, 8, 0, 0, 320, 66);
INSERT INTO public.who_global_data VALUES (75615, 611, 1709, 0, 7, 320, 58);
INSERT INTO public.who_global_data VALUES (75616, 607, 3631, 8, 16, 320, 163);
INSERT INTO public.who_global_data VALUES (75617, 19, 72, 0, 1, 320, 37);
INSERT INTO public.who_global_data VALUES (75618, 0, 4, 0, 0, 320, 142);
INSERT INTO public.who_global_data VALUES (75619, 5, 339, 0, 2, 320, 83);
INSERT INTO public.who_global_data VALUES (75620, 3, 27, 0, 2, 320, 228);
INSERT INTO public.who_global_data VALUES (75621, 0, 5, 0, 0, 320, 188);
INSERT INTO public.who_global_data VALUES (75622, 5, 81, 0, 0, 320, 62);
INSERT INTO public.who_global_data VALUES (75623, 486, 5528, 47, 220, 320, 160);
INSERT INTO public.who_global_data VALUES (75624, 0, 0, 0, 0, 320, 50);
INSERT INTO public.who_global_data VALUES (75625, 0, 2, 0, 0, 320, 33);
INSERT INTO public.who_global_data VALUES (75626, 0, 6, 0, 0, 320, 183);
INSERT INTO public.who_global_data VALUES (75627, 0, 2, 0, 0, 320, 92);
INSERT INTO public.who_global_data VALUES (75628, 5, 24, 0, 0, 320, 158);
INSERT INTO public.who_global_data VALUES (75629, 0, 0, 0, 0, 320, 67);
INSERT INTO public.who_global_data VALUES (75630, 6, 131, 0, 1, 320, 57);
INSERT INTO public.who_global_data VALUES (75631, 0, 0, 0, 0, 320, 38);
INSERT INTO public.who_global_data VALUES (75632, 0, 904, 0, 11, 320, 141);
INSERT INTO public.who_global_data VALUES (75633, 0, 0, 0, 0, 320, 178);
INSERT INTO public.who_global_data VALUES (75634, 5, 88, 0, 0, 320, 108);
INSERT INTO public.who_global_data VALUES (75635, 22, 185, 0, 3, 320, 39);
INSERT INTO public.who_global_data VALUES (75636, 0, 75, 0, 3, 320, 2);
INSERT INTO public.who_global_data VALUES (75637, 0, 0, 0, 0, 320, 195);
INSERT INTO public.who_global_data VALUES (75638, 0, 3, 0, 0, 320, 107);
INSERT INTO public.who_global_data VALUES (75639, 33, 86, 0, 0, 320, 161);
INSERT INTO public.who_global_data VALUES (75640, 13, 40, 0, 0, 320, 212);
INSERT INTO public.who_global_data VALUES (75641, 336, 1384, 6, 19, 320, 181);
INSERT INTO public.who_global_data VALUES (75642, 0, 3, 0, 1, 320, 53);
INSERT INTO public.who_global_data VALUES (75643, 1, 4, 0, 0, 320, 164);
INSERT INTO public.who_global_data VALUES (75644, 0, 5, 0, 0, 320, 140);
INSERT INTO public.who_global_data VALUES (75645, 198, 632, 0, 1, 320, 20);
INSERT INTO public.who_global_data VALUES (75646, 104, 81603, 9, 3276, 320, 112);
INSERT INTO public.who_global_data VALUES (75647, 0, 196, 2, 2, 320, 111);
INSERT INTO public.who_global_data VALUES (75648, 0, 0, 0, 0, 320, 71);
INSERT INTO public.who_global_data VALUES (75649, 0, 4, 0, 0, 320, 218);
INSERT INTO public.who_global_data VALUES (75650, 0, 0, 0, 0, 320, 43);
INSERT INTO public.who_global_data VALUES (75651, 4, 117, 0, 2, 320, 49);
INSERT INTO public.who_global_data VALUES (75652, 12, 25, 0, 0, 320, 1);
INSERT INTO public.who_global_data VALUES (75653, 29, 235, 0, 0, 320, 48);
INSERT INTO public.who_global_data VALUES (75654, 0, 16, 0, 1, 320, 232);
INSERT INTO public.who_global_data VALUES (75655, 0, 3, 0, 1, 320, 175);
INSERT INTO public.who_global_data VALUES (75656, 11, 95, 0, 0, 320, 21);
INSERT INTO public.who_global_data VALUES (75657, 170, 1165, 1, 1, 320, 156);
INSERT INTO public.who_global_data VALUES (75658, 0, 0, 0, 0, 320, 95);
INSERT INTO public.who_global_data VALUES (75659, 12, 30, 2, 2, 320, 177);
INSERT INTO public.who_global_data VALUES (75660, 69, 1395, 0, 13, 320, 210);
INSERT INTO public.who_global_data VALUES (75661, -2, 3, 0, 0, 320, 120);
INSERT INTO public.who_global_data VALUES (75662, 0, 0, 0, 0, 320, 135);
INSERT INTO public.who_global_data VALUES (75663, 0, 72, 0, 2, 320, 206);
INSERT INTO public.who_global_data VALUES (75664, 26, 532, 0, 7, 320, 189);
INSERT INTO public.who_global_data VALUES (75665, 33, 327, 4, 14, 320, 129);
INSERT INTO public.who_global_data VALUES (75666, 0, 1, 0, 0, 320, 121);
INSERT INTO public.who_global_data VALUES (75667, 0, 6, 0, 0, 320, 59);
INSERT INTO public.who_global_data VALUES (75668, 0, 1, 0, 0, 320, 96);
INSERT INTO public.who_global_data VALUES (75669, 20, 326, 0, 0, 320, 41);
INSERT INTO public.who_global_data VALUES (75670, -1, 4, 0, 0, 320, 216);
INSERT INTO public.who_global_data VALUES (75671, -2, 11, 0, 0, 320, 236);
INSERT INTO public.who_global_data VALUES (75672, 0, 0, 0, 0, 320, 150);
INSERT INTO public.who_global_data VALUES (75673, 23, 115, 0, 0, 320, 61);
INSERT INTO public.who_global_data VALUES (75674, 1, 3, 0, 0, 320, 7);
INSERT INTO public.who_global_data VALUES (75675, 105, 626, 0, 1, 320, 169);
INSERT INTO public.who_global_data VALUES (75676, 1529, 15821, 112, 674, 320, 28);
INSERT INTO public.who_global_data VALUES (75677, 3, 18, 0, 0, 320, 85);
INSERT INTO public.who_global_data VALUES (75678, 3, 18, 0, 0, 320, 211);
INSERT INTO public.who_global_data VALUES (75679, 0, 6, 0, 1, 320, 60);
INSERT INTO public.who_global_data VALUES (75680, 0, 5, 0, 0, 320, 3);
INSERT INTO public.who_global_data VALUES (75681, 7, 61, 0, 0, 320, 11);
INSERT INTO public.who_global_data VALUES (75682, 3311, 24774, 27, 94, 320, 89);
INSERT INTO public.who_global_data VALUES (75683, 5, 24, 0, 0, 320, 24);
INSERT INTO public.who_global_data VALUES (75684, 5, 15, 0, 0, 320, 162);
INSERT INTO public.who_global_data VALUES (75685, 94, 624, 2, 15, 320, 100);
INSERT INTO public.who_global_data VALUES (75686, 0, 2, 0, 0, 320, 47);
INSERT INTO public.who_global_data VALUES (75687, 1, 1, 0, 0, 320, 29);
INSERT INTO public.who_global_data VALUES (75688, 5, 56, 0, 0, 320, 40);
INSERT INTO public.who_global_data VALUES (75689, 12, 27, 1, 1, 320, 222);
INSERT INTO public.who_global_data VALUES (75690, 6, 18, 0, 1, 320, 132);
INSERT INTO public.who_global_data VALUES (75691, 16, 17, 0, 0, 320, 130);
INSERT INTO public.who_global_data VALUES (75692, 0, 6, 0, 0, 320, 234);
INSERT INTO public.who_global_data VALUES (75693, 0, 0, 0, 0, 320, 23);
INSERT INTO public.who_global_data VALUES (75694, 0, 9, 0, 1, 320, 192);
INSERT INTO public.who_global_data VALUES (75695, 0, 2, 0, 0, 320, 69);
INSERT INTO public.who_global_data VALUES (75696, 0, 1, 0, 0, 320, 187);
INSERT INTO public.who_global_data VALUES (75697, 2, 26, 0, 0, 320, 230);
INSERT INTO public.who_global_data VALUES (75698, 36, 167, 3, 7, 320, 77);
INSERT INTO public.who_global_data VALUES (75699, 95, 568, 0, 1, 320, 9);
INSERT INTO public.who_global_data VALUES (75700, 93, 434, 4, 9, 320, 74);
INSERT INTO public.who_global_data VALUES (75701, 65, 579, 1, 49, 320, 224);
INSERT INTO public.who_global_data VALUES (75702, 1411, 23049, 127, 1812, 320, 199);
INSERT INTO public.who_global_data VALUES (75703, 33, 266, 3, 23, 320, 190);
INSERT INTO public.who_global_data VALUES (75704, 121, 906, 1, 4, 320, 12);
INSERT INTO public.who_global_data VALUES (75705, 0, 2, 0, 0, 320, 104);
INSERT INTO public.who_global_data VALUES (75706, 210, 1014, 0, 1, 320, 153);
INSERT INTO public.who_global_data VALUES (75707, 5560, 59138, 649, 5476, 320, 91);
INSERT INTO public.who_global_data VALUES (75708, 3, 19, 0, 1, 320, 215);
INSERT INTO public.who_global_data VALUES (75709, 43, 1089, 5, 41, 320, 84);
INSERT INTO public.who_global_data VALUES (75710, 3, 15, 0, 0, 320, 231);
INSERT INTO public.who_global_data VALUES (75711, 13, 112, 0, 0, 320, 196);
INSERT INTO public.who_global_data VALUES (75712, 10, 72, 0, 0, 320, 105);
INSERT INTO public.who_global_data VALUES (75713, 4, 15, 0, 0, 320, 122);
INSERT INTO public.who_global_data VALUES (75714, 0, 0, 0, 0, 320, 159);
INSERT INTO public.who_global_data VALUES (75715, 4, 35, 0, 1, 320, 75);
INSERT INTO public.who_global_data VALUES (75716, 1, 189, 0, 0, 320, 27);
INSERT INTO public.who_global_data VALUES (75717, 0, 14, 0, 0, 320, 54);
INSERT INTO public.who_global_data VALUES (75718, 0, 0, 0, 0, 320, 226);
INSERT INTO public.who_global_data VALUES (75719, 15, 139, 0, 0, 320, 79);
INSERT INTO public.who_global_data VALUES (75720, 19, 267, 0, 4, 320, 56);
INSERT INTO public.who_global_data VALUES (75721, 0, 0, 0, 0, 320, 117);
INSERT INTO public.who_global_data VALUES (75722, 0, 3, 0, 0, 320, 152);
INSERT INTO public.who_global_data VALUES (75723, 0, 0, 0, 0, 320, 16);
INSERT INTO public.who_global_data VALUES (75724, 2, 48, 0, 0, 320, 10);
INSERT INTO public.who_global_data VALUES (75725, 31, 128, 0, 1, 320, 201);
INSERT INTO public.who_global_data VALUES (75726, 128, 798, 0, 8, 320, 174);
INSERT INTO public.who_global_data VALUES (75727, 9, 12, 0, 0, 320, 119);
INSERT INTO public.who_global_data VALUES (75728, 0, 0, 0, 0, 320, 168);
INSERT INTO public.who_global_data VALUES (75729, 123, 1306, 2, 11, 320, 99);
INSERT INTO public.who_global_data VALUES (75730, 0, 17, 0, 0, 320, 171);
INSERT INTO public.who_global_data VALUES (75731, 0, 0, 0, 0, 320, 87);
INSERT INTO public.who_global_data VALUES (75732, 17, 107, 0, 0, 320, 123);
INSERT INTO public.who_global_data VALUES (75733, 0, 0, 0, 0, 320, 151);
INSERT INTO public.who_global_data VALUES (75734, 5, 37, 0, 0, 320, 213);
INSERT INTO public.who_global_data VALUES (75735, 0, 6, 0, 0, 320, 118);
INSERT INTO public.who_global_data VALUES (75736, 0, 12, 0, 0, 320, 134);
INSERT INTO public.who_global_data VALUES (75737, 3, 14, 0, 0, 320, 65);
INSERT INTO public.who_global_data VALUES (75738, 87, 251, 1, 2, 320, 102);
INSERT INTO public.who_global_data VALUES (75739, 0, 0, 0, 0, 320, 223);
INSERT INTO public.who_global_data VALUES (75740, 2, 20, 0, 0, 320, 4);
INSERT INTO public.who_global_data VALUES (75741, 0, 10, 0, 0, 320, 146);
INSERT INTO public.who_global_data VALUES (75742, 7, 29, 0, 1, 320, 31);
INSERT INTO public.who_global_data VALUES (75743, 0, 5, 0, 0, 320, 127);
INSERT INTO public.who_global_data VALUES (75744, 25, 134, 1, 4, 320, 22);
INSERT INTO public.who_global_data VALUES (75745, 1, 1, 0, 0, 320, 115);
INSERT INTO public.who_global_data VALUES (75746, 0, 0, 0, 0, 320, 106);
INSERT INTO public.who_global_data VALUES (75747, 0, 7, 0, 0, 320, 90);
INSERT INTO public.who_global_data VALUES (75748, 0, 0, 0, 0, 320, 70);
INSERT INTO public.who_global_data VALUES (75749, 0, 5, 0, 0, 320, 46);
INSERT INTO public.who_global_data VALUES (75750, 605, 4185, 44, 178, 320, 139);
INSERT INTO public.who_global_data VALUES (75751, 3, 7, 0, 0, 320, 42);
INSERT INTO public.who_global_data VALUES (75752, 36, 102, 0, 0, 320, 80);
INSERT INTO public.who_global_data VALUES (75753, 0, 2, 0, 0, 320, 203);
INSERT INTO public.who_global_data VALUES (75754, -3, 2, 0, 0, 320, 136);
INSERT INTO public.who_global_data VALUES (75755, 0, 22, 0, 0, 320, 63);
INSERT INTO public.who_global_data VALUES (75756, 0, 0, 0, 0, 320, 17);
INSERT INTO public.who_global_data VALUES (75757, 0, 0, 0, 0, 320, 172);
INSERT INTO public.who_global_data VALUES (75758, 22, 136, 2, 2, 320, 109);
INSERT INTO public.who_global_data VALUES (75759, 206, 2132, 0, 7, 320, 200);
INSERT INTO public.who_global_data VALUES (75760, 0, 59, 0, 0, 320, 93);
INSERT INTO public.who_global_data VALUES (75761, 11, 66, 0, 0, 320, 5);
INSERT INTO public.who_global_data VALUES (75762, 0, 712, 0, 8, 320, 214);
INSERT INTO public.who_global_data VALUES (75763, 138, 784, 2, 5, 320, 204);
INSERT INTO public.who_global_data VALUES (75764, 0, 0, 0, 0, 320, 198);
INSERT INTO public.who_global_data VALUES (75765, 108, 245, 2, 3, 320, 173);
INSERT INTO public.who_global_data VALUES (75766, 0, 1, 0, 0, 320, 229);
INSERT INTO public.who_global_data VALUES (75767, 4, 22, 0, 1, 320, 76);
INSERT INTO public.who_global_data VALUES (75768, 0, 318, 0, 2, 320, 138);
INSERT INTO public.who_global_data VALUES (75769, 16, 396, 8, 33, 320, 98);
INSERT INTO public.who_global_data VALUES (75770, 0, 0, 0, 0, 320, 103);
INSERT INTO public.who_global_data VALUES (75771, 98, 634, 2, 7, 320, 225);
INSERT INTO public.who_global_data VALUES (75772, 320, 1600, 2, 14, 320, 131);
INSERT INTO public.who_global_data VALUES (75773, 2, 23, 0, 1, 320, 235);
INSERT INTO public.who_global_data VALUES (75774, 13, 494, 0, 0, 320, 137);
INSERT INTO public.who_global_data VALUES (75775, 64, 8961, 7, 111, 320, 81);
INSERT INTO public.who_global_data VALUES (75776, 14, 94, 0, 1, 320, 182);
INSERT INTO public.who_global_data VALUES (75777, 17, 64, 0, 0, 320, 145);
INSERT INTO public.who_global_data VALUES (75778, 66, 433, 2, 2, 320, 26);
INSERT INTO public.who_global_data VALUES (75779, 132, 438, 0, 0, 320, 170);
INSERT INTO public.who_global_data VALUES (75780, 0, 17, 0, 0, 320, 191);
INSERT INTO public.who_global_data VALUES (75781, 0, 0, 0, 0, 320, 221);
INSERT INTO public.who_global_data VALUES (75782, 0, 3, 0, 0, 320, 64);
INSERT INTO public.who_global_data VALUES (75783, 0, 0, 0, 0, 320, 116);
INSERT INTO public.who_global_data VALUES (75784, 0, 0, 0, 0, 320, 128);
INSERT INTO public.who_global_data VALUES (75785, 0, 6, 0, 0, 320, 6);
INSERT INTO public.who_global_data VALUES (75786, -3, 5, 0, 0, 320, 227);
INSERT INTO public.who_global_data VALUES (75787, 0, 0, 0, 0, 320, 68);
INSERT INTO public.who_global_data VALUES (75788, 0, 1, 0, 0, 320, 184);
INSERT INTO public.who_global_data VALUES (75789, 0, 0, 0, 0, 320, 82);
INSERT INTO public.who_global_data VALUES (75790, 12, 187, 0, 20, 320, 149);
INSERT INTO public.who_global_data VALUES (75791, 0, 0, 0, 0, 320, 197);
INSERT INTO public.who_global_data VALUES (75792, 51, 562, 0, 0, 320, 78);
INSERT INTO public.who_global_data VALUES (75793, 11, 67, 0, 0, 320, 233);
INSERT INTO public.who_global_data VALUES (75794, 3, 222, 1, 2, 320, 133);
INSERT INTO public.who_global_data VALUES (75795, 0, 7, 0, 0, 320, 35);
INSERT INTO public.who_global_data VALUES (75796, 0, 0, 0, 0, 320, 114);
INSERT INTO public.who_global_data VALUES (75797, 23, 455, 0, 2, 320, 237);
INSERT INTO public.who_global_data VALUES (75798, 0, 0, 0, 0, 320, 55);
INSERT INTO public.who_global_data VALUES (75799, 0, 5, 0, 0, 320, 176);
INSERT INTO public.who_global_data VALUES (75800, 7, 185, 0, 0, 320, 202);
INSERT INTO public.who_global_data VALUES (75801, 36, 442, 1, 2, 320, 155);
INSERT INTO public.who_global_data VALUES (75802, 0, 0, 0, 0, 320, 32);
INSERT INTO public.who_global_data VALUES (75803, 0, 5, 0, 0, 320, 220);
INSERT INTO public.who_global_data VALUES (75804, 34, 274, 0, 0, 320, 30);
INSERT INTO public.who_global_data VALUES (75805, 0, 0, 0, 0, 320, 147);
INSERT INTO public.who_global_data VALUES (75806, 5793, 43620, 506, 2363, 320, 208);
INSERT INTO public.who_global_data VALUES (75807, 22, 94, 0, 0, 320, 45);
INSERT INTO public.who_global_data VALUES (75808, 0, 2, 0, 1, 320, 110);
INSERT INTO public.who_global_data VALUES (75809, 0, 2, 0, 0, 320, 88);
INSERT INTO public.who_global_data VALUES (75810, 136, 1869, 8, 38, 320, 51);
INSERT INTO public.who_global_data VALUES (75811, 546, 9253, 18, 127, 320, 209);
INSERT INTO public.who_global_data VALUES (75812, 1, 1, 0, 0, 320, 205);
INSERT INTO public.who_global_data VALUES (75813, 0, 0, 0, 0, 320, 18);
INSERT INTO public.who_global_data VALUES (75814, 122, 721, 0, 1, 320, 72);
INSERT INTO public.who_global_data VALUES (75815, 1198, 8934, 36, 288, 320, 44);
INSERT INTO public.who_global_data VALUES (75816, 0, 1, 0, 0, 320, 15);
INSERT INTO public.who_global_data VALUES (75817, 1, 16, 0, 0, 320, 25);
INSERT INTO public.who_global_data VALUES (75818, 0, 0, 0, 0, 320, 179);
INSERT INTO public.who_global_data VALUES (75819, 0, 0, 0, 0, 320, 34);
INSERT INTO public.who_global_data VALUES (75820, 41, 50, 0, 0, 320, 207);
INSERT INTO public.who_global_data VALUES (75821, 14, 89, 0, 3, 320, 166);
INSERT INTO public.who_global_data VALUES (75822, 289, 1236, 9, 30, 320, 126);
INSERT INTO public.who_global_data VALUES (75823, 0, 0, 0, 0, 320, 97);
INSERT INTO public.who_global_data VALUES (75824, 0, 0, 0, 0, 320, 36);
INSERT INTO public.who_global_data VALUES (75825, 0, 0, 0, 0, 320, 125);
INSERT INTO public.who_global_data VALUES (75826, 0, 1, 0, 0, 320, 124);
INSERT INTO public.who_global_data VALUES (75827, 26, 73, 0, 3, 320, 185);
INSERT INTO public.who_global_data VALUES (75828, 45, 198, 0, 2, 320, 194);
INSERT INTO public.who_global_data VALUES (75829, 2, 12, 0, 0, 320, 144);
INSERT INTO public.who_global_data VALUES (75830, 16354, 31573, 201, 402, 320, 19);
INSERT INTO public.who_global_data VALUES (75831, 0, 6, 0, 0, 320, 217);
INSERT INTO public.who_global_data VALUES (75832, 41, 135, 0, 0, 320, 148);
INSERT INTO public.who_global_data VALUES (75833, 5, 46, 0, 0, 320, 86);
INSERT INTO public.who_global_data VALUES (75834, 0, 0, 0, 0, 320, 13);
INSERT INTO public.who_global_data VALUES (75835, 30, 70, 0, 0, 320, 157);
INSERT INTO public.who_global_data VALUES (75836, 24, 118, 0, 0, 320, 8);
INSERT INTO public.who_global_data VALUES (75837, 0, 0, 0, 0, 320, 73);
INSERT INTO public.who_global_data VALUES (75838, 0, 0, 0, 0, 320, 101);
INSERT INTO public.who_global_data VALUES (75839, -3, 3, 0, 0, 320, 165);
INSERT INTO public.who_global_data VALUES (75840, 0, 2, 0, 0, 320, 14);
INSERT INTO public.who_global_data VALUES (75841, 10, 34, 0, 0, 321, 193);
INSERT INTO public.who_global_data VALUES (75842, 0, 51, 0, 1, 321, 113);
INSERT INTO public.who_global_data VALUES (75843, 45, 139, 0, 15, 321, 143);
INSERT INTO public.who_global_data VALUES (75844, 0, 0, 0, 0, 321, 219);
INSERT INTO public.who_global_data VALUES (75845, 39, 133, 1, 1, 321, 186);
INSERT INTO public.who_global_data VALUES (75846, 0, 2, 0, 0, 321, 52);
INSERT INTO public.who_global_data VALUES (75847, 0, 0, 0, 0, 321, 180);
INSERT INTO public.who_global_data VALUES (75848, 0, 5, 0, 0, 321, 167);
INSERT INTO public.who_global_data VALUES (75849, 0, 158, 0, 3, 321, 154);
INSERT INTO public.who_global_data VALUES (75850, 24, 137, 0, 0, 321, 94);
INSERT INTO public.who_global_data VALUES (75851, 0, 5, 0, 0, 321, 66);
INSERT INTO public.who_global_data VALUES (75852, 17, 1098, 0, 7, 321, 58);
INSERT INTO public.who_global_data VALUES (75853, 375, 3024, 2, 8, 321, 163);
INSERT INTO public.who_global_data VALUES (75854, 0, 53, 0, 1, 321, 37);
INSERT INTO public.who_global_data VALUES (75855, 0, 4, 0, 0, 321, 142);
INSERT INTO public.who_global_data VALUES (75856, 28, 334, 1, 2, 321, 83);
INSERT INTO public.who_global_data VALUES (75857, 0, 24, 0, 2, 321, 228);
INSERT INTO public.who_global_data VALUES (75858, 0, 5, 0, 0, 321, 188);
INSERT INTO public.who_global_data VALUES (75859, 40, 76, 0, 0, 321, 62);
INSERT INTO public.who_global_data VALUES (75860, 469, 5042, 39, 173, 321, 160);
INSERT INTO public.who_global_data VALUES (75861, 0, 0, 0, 0, 321, 50);
INSERT INTO public.who_global_data VALUES (75862, 0, 2, 0, 0, 321, 33);
INSERT INTO public.who_global_data VALUES (75863, 0, 6, 0, 0, 321, 183);
INSERT INTO public.who_global_data VALUES (75864, 0, 2, 0, 0, 321, 92);
INSERT INTO public.who_global_data VALUES (75865, 0, 19, 0, 0, 321, 158);
INSERT INTO public.who_global_data VALUES (75866, 0, 0, 0, 0, 321, 67);
INSERT INTO public.who_global_data VALUES (75867, 33, 125, 0, 1, 321, 57);
INSERT INTO public.who_global_data VALUES (75868, 0, 0, 0, 0, 321, 38);
INSERT INTO public.who_global_data VALUES (75869, 0, 904, 0, 11, 321, 141);
INSERT INTO public.who_global_data VALUES (75870, 0, 0, 0, 0, 321, 178);
INSERT INTO public.who_global_data VALUES (75871, 0, 83, 0, 0, 321, 108);
INSERT INTO public.who_global_data VALUES (75872, 36, 163, 0, 3, 321, 39);
INSERT INTO public.who_global_data VALUES (75873, 3, 75, 0, 3, 321, 2);
INSERT INTO public.who_global_data VALUES (75874, 0, 0, 0, 0, 321, 195);
INSERT INTO public.who_global_data VALUES (75875, 0, 3, 0, 0, 321, 107);
INSERT INTO public.who_global_data VALUES (75876, 0, 53, 0, 0, 321, 161);
INSERT INTO public.who_global_data VALUES (75877, 0, 27, 0, 0, 321, 212);
INSERT INTO public.who_global_data VALUES (75878, 0, 1048, 0, 13, 321, 181);
INSERT INTO public.who_global_data VALUES (75879, 0, 3, 0, 1, 321, 53);
INSERT INTO public.who_global_data VALUES (75880, 0, 3, 0, 0, 321, 164);
INSERT INTO public.who_global_data VALUES (75881, 0, 5, 0, 0, 321, 140);
INSERT INTO public.who_global_data VALUES (75882, 0, 434, 0, 1, 321, 20);
INSERT INTO public.who_global_data VALUES (75883, 1, 81499, 0, 3267, 321, 112);
INSERT INTO public.who_global_data VALUES (75884, 0, 196, 0, 0, 321, 111);
INSERT INTO public.who_global_data VALUES (75885, 0, 0, 0, 0, 321, 71);
INSERT INTO public.who_global_data VALUES (75886, 0, 4, 0, 0, 321, 218);
INSERT INTO public.who_global_data VALUES (75887, 0, 0, 0, 0, 321, 43);
INSERT INTO public.who_global_data VALUES (75888, 0, 113, 0, 2, 321, 49);
INSERT INTO public.who_global_data VALUES (75889, 0, 13, 0, 0, 321, 1);
INSERT INTO public.who_global_data VALUES (75890, 80, 206, 0, 0, 321, 48);
INSERT INTO public.who_global_data VALUES (75891, 0, 16, 0, 1, 321, 232);
INSERT INTO public.who_global_data VALUES (75892, 0, 3, 0, 1, 321, 175);
INSERT INTO public.who_global_data VALUES (75893, 17, 84, 0, 0, 321, 21);
INSERT INTO public.who_global_data VALUES (75894, 91, 995, 0, 0, 321, 156);
INSERT INTO public.who_global_data VALUES (75895, 0, 0, 0, 0, 321, 95);
INSERT INTO public.who_global_data VALUES (75896, 0, 18, 0, 0, 321, 177);
INSERT INTO public.who_global_data VALUES (75897, 71, 1326, 4, 13, 321, 210);
INSERT INTO public.who_global_data VALUES (75898, 0, 5, 0, 0, 321, 120);
INSERT INTO public.who_global_data VALUES (75899, 0, 0, 0, 0, 321, 135);
INSERT INTO public.who_global_data VALUES (75900, 0, 72, 0, 2, 321, 206);
INSERT INTO public.who_global_data VALUES (75901, 0, 506, 0, 7, 321, 189);
INSERT INTO public.who_global_data VALUES (75902, 9, 294, 2, 10, 321, 129);
INSERT INTO public.who_global_data VALUES (75903, 0, 1, 0, 0, 321, 121);
INSERT INTO public.who_global_data VALUES (75904, 0, 6, 0, 0, 321, 59);
INSERT INTO public.who_global_data VALUES (75905, 0, 1, 0, 0, 321, 96);
INSERT INTO public.who_global_data VALUES (75906, 23, 306, 0, 0, 321, 41);
INSERT INTO public.who_global_data VALUES (75907, 0, 5, 0, 0, 321, 216);
INSERT INTO public.who_global_data VALUES (75908, 0, 13, 0, 0, 321, 236);
INSERT INTO public.who_global_data VALUES (75909, 0, 0, 0, 0, 321, 150);
INSERT INTO public.who_global_data VALUES (75910, 12, 92, 0, 0, 321, 61);
INSERT INTO public.who_global_data VALUES (75911, 0, 2, 0, 0, 321, 7);
INSERT INTO public.who_global_data VALUES (75912, 71, 521, 1, 1, 321, 169);
INSERT INTO public.who_global_data VALUES (75913, 1847, 14292, 112, 562, 321, 28);
INSERT INTO public.who_global_data VALUES (75914, 0, 15, 0, 0, 321, 85);
INSERT INTO public.who_global_data VALUES (75915, 0, 15, 0, 0, 321, 211);
INSERT INTO public.who_global_data VALUES (75916, 3, 6, 0, 1, 321, 60);
INSERT INTO public.who_global_data VALUES (75917, 0, 5, 0, 0, 321, 3);
INSERT INTO public.who_global_data VALUES (75918, 6, 54, 0, 0, 321, 11);
INSERT INTO public.who_global_data VALUES (75919, 3276, 21463, 22, 67, 321, 89);
INSERT INTO public.who_global_data VALUES (75920, 0, 19, 0, 0, 321, 24);
INSERT INTO public.who_global_data VALUES (75921, 0, 10, 0, 0, 321, 162);
INSERT INTO public.who_global_data VALUES (75922, 35, 530, 5, 13, 321, 100);
INSERT INTO public.who_global_data VALUES (75923, 0, 2, 0, 0, 321, 47);
INSERT INTO public.who_global_data VALUES (75924, 0, 0, 0, 0, 321, 29);
INSERT INTO public.who_global_data VALUES (75925, 0, 51, 0, 0, 321, 40);
INSERT INTO public.who_global_data VALUES (75926, 0, 15, 0, 0, 321, 222);
INSERT INTO public.who_global_data VALUES (75927, 0, 12, 0, 1, 321, 132);
INSERT INTO public.who_global_data VALUES (75928, 0, 1, 0, 0, 321, 130);
INSERT INTO public.who_global_data VALUES (75929, 0, 6, 0, 0, 321, 234);
INSERT INTO public.who_global_data VALUES (75930, 0, 0, 0, 0, 321, 23);
INSERT INTO public.who_global_data VALUES (75931, 0, 9, 0, 1, 321, 192);
INSERT INTO public.who_global_data VALUES (75932, 0, 2, 0, 0, 321, 69);
INSERT INTO public.who_global_data VALUES (75933, 0, 1, 0, 0, 321, 187);
INSERT INTO public.who_global_data VALUES (75934, 0, 24, 0, 0, 321, 230);
INSERT INTO public.who_global_data VALUES (75935, 28, 131, 0, 4, 321, 77);
INSERT INTO public.who_global_data VALUES (75936, 64, 473, 0, 1, 321, 9);
INSERT INTO public.who_global_data VALUES (75937, 58, 341, 1, 5, 321, 74);
INSERT INTO public.who_global_data VALUES (75938, 64, 514, 10, 48, 321, 224);
INSERT INTO public.who_global_data VALUES (75939, 1028, 21638, 129, 1685, 321, 199);
INSERT INTO public.who_global_data VALUES (75940, 19, 233, 3, 20, 321, 190);
INSERT INTO public.who_global_data VALUES (75941, 102, 785, 0, 3, 321, 12);
INSERT INTO public.who_global_data VALUES (75942, 1, 2, 0, 0, 321, 104);
INSERT INTO public.who_global_data VALUES (75943, 168, 804, 0, 1, 321, 153);
INSERT INTO public.who_global_data VALUES (75944, 6557, 53578, 795, 4827, 321, 91);
INSERT INTO public.who_global_data VALUES (75945, 0, 16, 0, 1, 321, 215);
INSERT INTO public.who_global_data VALUES (75946, 0, 1046, 0, 36, 321, 84);
INSERT INTO public.who_global_data VALUES (75947, 0, 12, 0, 0, 321, 231);
INSERT INTO public.who_global_data VALUES (75948, 15, 99, 0, 0, 321, 196);
INSERT INTO public.who_global_data VALUES (75949, 5, 62, 0, 0, 321, 105);
INSERT INTO public.who_global_data VALUES (75950, 0, 11, 0, 0, 321, 122);
INSERT INTO public.who_global_data VALUES (75951, 0, 0, 0, 0, 321, 159);
INSERT INTO public.who_global_data VALUES (75952, 7, 31, 1, 1, 321, 75);
INSERT INTO public.who_global_data VALUES (75953, 12, 188, 0, 0, 321, 27);
INSERT INTO public.who_global_data VALUES (75954, 11, 14, 0, 0, 321, 54);
INSERT INTO public.who_global_data VALUES (75955, 0, 0, 0, 0, 321, 226);
INSERT INTO public.who_global_data VALUES (75956, 13, 124, 0, 0, 321, 79);
INSERT INTO public.who_global_data VALUES (75957, 42, 248, 0, 4, 321, 56);
INSERT INTO public.who_global_data VALUES (75958, 0, 0, 0, 0, 321, 117);
INSERT INTO public.who_global_data VALUES (75959, 0, 3, 0, 0, 321, 152);
INSERT INTO public.who_global_data VALUES (75960, 0, 0, 0, 0, 321, 16);
INSERT INTO public.who_global_data VALUES (75961, 2, 46, 0, 0, 321, 10);
INSERT INTO public.who_global_data VALUES (75962, 28, 97, 0, 1, 321, 201);
INSERT INTO public.who_global_data VALUES (75963, 186, 670, 3, 8, 321, 174);
INSERT INTO public.who_global_data VALUES (75964, 0, 3, 0, 0, 321, 119);
INSERT INTO public.who_global_data VALUES (75965, 0, 0, 0, 0, 321, 168);
INSERT INTO public.who_global_data VALUES (75966, 0, 1183, 6, 9, 321, 99);
INSERT INTO public.who_global_data VALUES (75967, 0, 17, 0, 0, 321, 171);
INSERT INTO public.who_global_data VALUES (75968, 0, 0, 0, 0, 321, 87);
INSERT INTO public.who_global_data VALUES (75969, 17, 90, 0, 0, 321, 123);
INSERT INTO public.who_global_data VALUES (75970, 0, 0, 0, 0, 321, 151);
INSERT INTO public.who_global_data VALUES (75971, 0, 32, 0, 0, 321, 213);
INSERT INTO public.who_global_data VALUES (75972, 0, 6, 0, 0, 321, 118);
INSERT INTO public.who_global_data VALUES (75973, 0, 12, 0, 0, 321, 134);
INSERT INTO public.who_global_data VALUES (75974, 0, 11, 0, 0, 321, 65);
INSERT INTO public.who_global_data VALUES (75975, 0, 164, 0, 1, 321, 102);
INSERT INTO public.who_global_data VALUES (75976, 0, 0, 0, 0, 321, 223);
INSERT INTO public.who_global_data VALUES (75977, 0, 18, 0, 0, 321, 4);
INSERT INTO public.who_global_data VALUES (75978, 0, 10, 0, 0, 321, 146);
INSERT INTO public.who_global_data VALUES (75979, 6, 22, 1, 1, 321, 31);
INSERT INTO public.who_global_data VALUES (75980, 0, 5, 0, 0, 321, 127);
INSERT INTO public.who_global_data VALUES (75981, 23, 109, 0, 3, 321, 22);
INSERT INTO public.who_global_data VALUES (75982, 0, 0, 0, 0, 321, 115);
INSERT INTO public.who_global_data VALUES (75983, 0, 0, 0, 0, 321, 106);
INSERT INTO public.who_global_data VALUES (75984, 0, 7, 0, 0, 321, 90);
INSERT INTO public.who_global_data VALUES (75985, 0, 0, 0, 0, 321, 70);
INSERT INTO public.who_global_data VALUES (75986, 0, 5, 0, 0, 321, 46);
INSERT INTO public.who_global_data VALUES (75987, 637, 3580, 30, 134, 321, 139);
INSERT INTO public.who_global_data VALUES (75988, 0, 4, 0, 0, 321, 42);
INSERT INTO public.who_global_data VALUES (75989, 0, 66, 0, 0, 321, 80);
INSERT INTO public.who_global_data VALUES (75990, 0, 2, 0, 0, 321, 203);
INSERT INTO public.who_global_data VALUES (75991, 0, 5, 0, 0, 321, 136);
INSERT INTO public.who_global_data VALUES (75992, 0, 22, 0, 0, 321, 63);
INSERT INTO public.who_global_data VALUES (75993, 0, 0, 0, 0, 321, 17);
INSERT INTO public.who_global_data VALUES (75994, 0, 0, 0, 0, 321, 172);
INSERT INTO public.who_global_data VALUES (75995, 29, 114, 0, 0, 321, 109);
INSERT INTO public.who_global_data VALUES (75996, 184, 1926, 0, 7, 321, 200);
INSERT INTO public.who_global_data VALUES (75997, 7, 59, 0, 0, 321, 93);
INSERT INTO public.who_global_data VALUES (75998, 3, 55, 0, 0, 321, 5);
INSERT INTO public.who_global_data VALUES (75999, 0, 712, 0, 8, 321, 214);
INSERT INTO public.who_global_data VALUES (76000, 151, 646, 0, 3, 321, 204);
INSERT INTO public.who_global_data VALUES (76001, 0, 0, 0, 0, 321, 198);
INSERT INTO public.who_global_data VALUES (76002, 0, 137, 0, 1, 321, 173);
INSERT INTO public.who_global_data VALUES (76003, 0, 1, 0, 0, 321, 229);
INSERT INTO public.who_global_data VALUES (76004, 0, 18, 0, 1, 321, 76);
INSERT INTO public.who_global_data VALUES (76005, 0, 318, 0, 2, 321, 138);
INSERT INTO public.who_global_data VALUES (76006, 73, 380, 6, 25, 321, 98);
INSERT INTO public.who_global_data VALUES (76007, 0, 0, 0, 0, 321, 103);
INSERT INTO public.who_global_data VALUES (76008, 111, 536, 0, 5, 321, 225);
INSERT INTO public.who_global_data VALUES (76009, 260, 1280, 6, 12, 321, 131);
INSERT INTO public.who_global_data VALUES (76010, 0, 21, 0, 1, 321, 235);
INSERT INTO public.who_global_data VALUES (76011, 11, 481, 0, 0, 321, 137);
INSERT INTO public.who_global_data VALUES (76012, 0, 8897, 0, 104, 321, 81);
INSERT INTO public.who_global_data VALUES (76013, 0, 80, 0, 1, 321, 182);
INSERT INTO public.who_global_data VALUES (76014, 0, 47, 0, 0, 321, 145);
INSERT INTO public.who_global_data VALUES (76015, 59, 367, 0, 0, 321, 26);
INSERT INTO public.who_global_data VALUES (76016, 53, 306, 0, 0, 321, 170);
INSERT INTO public.who_global_data VALUES (76017, 0, 17, 0, 0, 321, 191);
INSERT INTO public.who_global_data VALUES (76018, 0, 0, 0, 0, 321, 221);
INSERT INTO public.who_global_data VALUES (76019, 0, 3, 0, 0, 321, 64);
INSERT INTO public.who_global_data VALUES (76020, 0, 0, 0, 0, 321, 116);
INSERT INTO public.who_global_data VALUES (76021, 0, 0, 0, 0, 321, 128);
INSERT INTO public.who_global_data VALUES (76022, 0, 6, 0, 0, 321, 6);
INSERT INTO public.who_global_data VALUES (76023, 0, 8, 0, 0, 321, 227);
INSERT INTO public.who_global_data VALUES (76024, 0, 0, 0, 0, 321, 68);
INSERT INTO public.who_global_data VALUES (76025, 0, 1, 0, 0, 321, 184);
INSERT INTO public.who_global_data VALUES (76026, 0, 0, 0, 0, 321, 82);
INSERT INTO public.who_global_data VALUES (76027, 24, 175, 0, 20, 321, 149);
INSERT INTO public.who_global_data VALUES (76028, 0, 0, 0, 0, 321, 197);
INSERT INTO public.who_global_data VALUES (76029, 119, 511, 0, 0, 321, 78);
INSERT INTO public.who_global_data VALUES (76030, 0, 56, 0, 0, 321, 233);
INSERT INTO public.who_global_data VALUES (76031, 46, 219, 0, 1, 321, 133);
INSERT INTO public.who_global_data VALUES (76032, 0, 7, 0, 0, 321, 35);
INSERT INTO public.who_global_data VALUES (76033, 0, 0, 0, 0, 321, 114);
INSERT INTO public.who_global_data VALUES (76034, 0, 432, 0, 2, 321, 237);
INSERT INTO public.who_global_data VALUES (76035, 0, 0, 0, 0, 321, 55);
INSERT INTO public.who_global_data VALUES (76036, 0, 5, 0, 0, 321, 176);
INSERT INTO public.who_global_data VALUES (76037, 41, 178, 0, 0, 321, 202);
INSERT INTO public.who_global_data VALUES (76038, 37, 406, 0, 1, 321, 155);
INSERT INTO public.who_global_data VALUES (76039, 0, 0, 0, 0, 321, 32);
INSERT INTO public.who_global_data VALUES (76040, 0, 5, 0, 0, 321, 220);
INSERT INTO public.who_global_data VALUES (76041, 0, 240, 0, 0, 321, 30);
INSERT INTO public.who_global_data VALUES (76042, 0, 0, 0, 0, 321, 147);
INSERT INTO public.who_global_data VALUES (76043, 6529, 37827, 433, 1857, 321, 208);
INSERT INTO public.who_global_data VALUES (76044, 0, 72, 0, 0, 321, 45);
INSERT INTO public.who_global_data VALUES (76045, 0, 2, 0, 1, 321, 110);
INSERT INTO public.who_global_data VALUES (76046, 0, 2, 0, 0, 321, 88);
INSERT INTO public.who_global_data VALUES (76047, 180, 1733, 9, 30, 321, 51);
INSERT INTO public.who_global_data VALUES (76048, 691, 8707, 19, 109, 321, 209);
INSERT INTO public.who_global_data VALUES (76049, 0, 0, 0, 0, 321, 205);
INSERT INTO public.who_global_data VALUES (76050, 0, 0, 0, 0, 321, 18);
INSERT INTO public.who_global_data VALUES (76051, 188, 599, 0, 1, 321, 72);
INSERT INTO public.who_global_data VALUES (76052, 1255, 7736, 58, 252, 321, 44);
INSERT INTO public.who_global_data VALUES (76053, 0, 1, 0, 0, 321, 15);
INSERT INTO public.who_global_data VALUES (76054, 0, 15, 0, 0, 321, 25);
INSERT INTO public.who_global_data VALUES (76055, 0, 0, 0, 0, 321, 179);
INSERT INTO public.who_global_data VALUES (76056, 0, 0, 0, 0, 321, 34);
INSERT INTO public.who_global_data VALUES (76057, 0, 9, 0, 0, 321, 207);
INSERT INTO public.who_global_data VALUES (76058, 15, 75, 2, 3, 321, 166);
INSERT INTO public.who_global_data VALUES (76059, 277, 947, 12, 21, 321, 126);
INSERT INTO public.who_global_data VALUES (76060, 0, 0, 0, 0, 321, 97);
INSERT INTO public.who_global_data VALUES (76061, 0, 0, 0, 0, 321, 36);
INSERT INTO public.who_global_data VALUES (76062, 0, 0, 0, 0, 321, 125);
INSERT INTO public.who_global_data VALUES (76063, 0, 1, 0, 0, 321, 124);
INSERT INTO public.who_global_data VALUES (76064, 0, 47, 0, 3, 321, 185);
INSERT INTO public.who_global_data VALUES (76065, 0, 153, 0, 2, 321, 194);
INSERT INTO public.who_global_data VALUES (76066, 0, 10, 0, 0, 321, 144);
INSERT INTO public.who_global_data VALUES (76067, 0, 15219, 0, 201, 321, 19);
INSERT INTO public.who_global_data VALUES (76068, 0, 6, 0, 0, 321, 217);
INSERT INTO public.who_global_data VALUES (76069, 0, 94, 0, 0, 321, 148);
INSERT INTO public.who_global_data VALUES (76070, 0, 41, 0, 0, 321, 86);
INSERT INTO public.who_global_data VALUES (76071, 0, 0, 0, 0, 321, 13);
INSERT INTO public.who_global_data VALUES (76072, 0, 40, 0, 0, 321, 157);
INSERT INTO public.who_global_data VALUES (76073, 0, 94, 0, 0, 321, 8);
INSERT INTO public.who_global_data VALUES (76074, 0, 0, 0, 0, 321, 73);
INSERT INTO public.who_global_data VALUES (76075, 0, 0, 0, 0, 321, 101);
INSERT INTO public.who_global_data VALUES (76076, 0, 6, 0, 0, 321, 165);
INSERT INTO public.who_global_data VALUES (76077, 0, 2, 0, 0, 321, 14);
INSERT INTO public.who_global_data VALUES (76078, 0, 24, 0, 0, 322, 193);
INSERT INTO public.who_global_data VALUES (76079, 19, 51, 0, 1, 322, 113);
INSERT INTO public.who_global_data VALUES (76080, 0, 94, 5, 15, 322, 143);
INSERT INTO public.who_global_data VALUES (76081, 0, 0, 0, 0, 322, 219);
INSERT INTO public.who_global_data VALUES (76082, 19, 94, 0, 0, 322, 186);
INSERT INTO public.who_global_data VALUES (76083, 2, 2, 0, 0, 322, 52);
INSERT INTO public.who_global_data VALUES (76084, 0, 0, 0, 0, 322, 180);
INSERT INTO public.who_global_data VALUES (76085, 0, 5, 0, 0, 322, 167);
INSERT INTO public.who_global_data VALUES (76086, 30, 158, 0, 3, 322, 154);
INSERT INTO public.who_global_data VALUES (76087, 21, 113, 0, 0, 322, 94);
INSERT INTO public.who_global_data VALUES (76088, 0, 5, 0, 0, 322, 66);
INSERT INTO public.who_global_data VALUES (76089, 208, 1081, 0, 7, 322, 58);
INSERT INTO public.who_global_data VALUES (76090, 453, 2649, 0, 6, 322, 163);
INSERT INTO public.who_global_data VALUES (76091, 19, 53, 0, 1, 322, 37);
INSERT INTO public.who_global_data VALUES (76092, 0, 4, 0, 0, 322, 142);
INSERT INTO public.who_global_data VALUES (76093, 21, 306, 0, 1, 322, 83);
INSERT INTO public.who_global_data VALUES (76094, 7, 24, 1, 2, 322, 228);
INSERT INTO public.who_global_data VALUES (76095, 0, 5, 0, 0, 322, 188);
INSERT INTO public.who_global_data VALUES (76096, 0, 36, 0, 0, 322, 62);
INSERT INTO public.who_global_data VALUES (76097, 662, 4573, 35, 134, 322, 160);
INSERT INTO public.who_global_data VALUES (76098, 0, 0, 0, 0, 322, 50);
INSERT INTO public.who_global_data VALUES (76099, 0, 2, 0, 0, 322, 33);
INSERT INTO public.who_global_data VALUES (76100, 0, 6, 0, 0, 322, 183);
INSERT INTO public.who_global_data VALUES (76101, 0, 2, 0, 0, 322, 92);
INSERT INTO public.who_global_data VALUES (76102, 3, 19, 0, 0, 322, 158);
INSERT INTO public.who_global_data VALUES (76103, 0, 0, 0, 0, 322, 67);
INSERT INTO public.who_global_data VALUES (76104, 48, 92, 1, 1, 322, 57);
INSERT INTO public.who_global_data VALUES (76105, 0, 0, 0, 0, 322, 38);
INSERT INTO public.who_global_data VALUES (76106, 283, 904, 7, 11, 322, 141);
INSERT INTO public.who_global_data VALUES (76107, 0, 0, 0, 0, 322, 178);
INSERT INTO public.who_global_data VALUES (76108, 5, 83, 0, 0, 322, 108);
INSERT INTO public.who_global_data VALUES (76109, 22, 127, 0, 3, 322, 39);
INSERT INTO public.who_global_data VALUES (76110, 28, 72, 2, 3, 322, 2);
INSERT INTO public.who_global_data VALUES (76111, 0, 0, 0, 0, 322, 195);
INSERT INTO public.who_global_data VALUES (76112, 2, 3, 0, 0, 322, 107);
INSERT INTO public.who_global_data VALUES (76113, 2, 53, 0, 0, 322, 161);
INSERT INTO public.who_global_data VALUES (76114, 5, 27, 0, 0, 322, 212);
INSERT INTO public.who_global_data VALUES (76115, 202, 1048, 4, 13, 322, 181);
INSERT INTO public.who_global_data VALUES (76116, 0, 3, 0, 1, 322, 53);
INSERT INTO public.who_global_data VALUES (76117, -2, 3, 0, 0, 322, 164);
INSERT INTO public.who_global_data VALUES (76118, 0, 5, 0, 0, 322, 140);
INSERT INTO public.who_global_data VALUES (76119, 0, 434, 1, 1, 322, 20);
INSERT INTO public.who_global_data VALUES (76120, 82, 81498, 6, 3267, 322, 112);
INSERT INTO public.who_global_data VALUES (76121, 51, 196, 0, 0, 322, 111);
INSERT INTO public.who_global_data VALUES (76122, 0, 0, 0, 0, 322, 71);
INSERT INTO public.who_global_data VALUES (76123, 2, 4, 0, 0, 322, 218);
INSERT INTO public.who_global_data VALUES (76124, 0, 0, 0, 0, 322, 43);
INSERT INTO public.who_global_data VALUES (76125, 0, 113, 0, 2, 322, 49);
INSERT INTO public.who_global_data VALUES (76126, 0, 13, 0, 0, 322, 1);
INSERT INTO public.who_global_data VALUES (76127, 22, 126, 0, 0, 322, 48);
INSERT INTO public.who_global_data VALUES (76128, 0, 16, 0, 1, 322, 232);
INSERT INTO public.who_global_data VALUES (76129, -4, 3, 1, 1, 322, 175);
INSERT INTO public.who_global_data VALUES (76130, 9, 67, 0, 0, 322, 21);
INSERT INTO public.who_global_data VALUES (76131, 210, 904, 0, 0, 322, 156);
INSERT INTO public.who_global_data VALUES (76132, 0, 0, 0, 0, 322, 95);
INSERT INTO public.who_global_data VALUES (76133, 0, 18, 0, 0, 322, 177);
INSERT INTO public.who_global_data VALUES (76134, 104, 1255, 3, 9, 322, 210);
INSERT INTO public.who_global_data VALUES (76135, 0, 5, 0, 0, 322, 120);
INSERT INTO public.who_global_data VALUES (76136, 0, 0, 0, 0, 322, 135);
INSERT INTO public.who_global_data VALUES (76137, 0, 72, 0, 2, 322, 206);
INSERT INTO public.who_global_data VALUES (76138, 139, 506, 2, 7, 322, 189);
INSERT INTO public.who_global_data VALUES (76139, 29, 285, 1, 8, 322, 129);
INSERT INTO public.who_global_data VALUES (76140, 0, 1, 0, 0, 322, 121);
INSERT INTO public.who_global_data VALUES (76141, -2, 6, 0, 0, 322, 59);
INSERT INTO public.who_global_data VALUES (76142, 1, 1, 0, 0, 322, 96);
INSERT INTO public.who_global_data VALUES (76143, 16, 283, 0, 0, 322, 41);
INSERT INTO public.who_global_data VALUES (76144, 0, 5, 0, 0, 322, 216);
INSERT INTO public.who_global_data VALUES (76145, 0, 13, 0, 0, 322, 236);
INSERT INTO public.who_global_data VALUES (76146, 0, 0, 0, 0, 322, 150);
INSERT INTO public.who_global_data VALUES (76147, 8, 80, 0, 0, 322, 61);
INSERT INTO public.who_global_data VALUES (76148, 1, 2, 0, 0, 322, 7);
INSERT INTO public.who_global_data VALUES (76149, 50, 450, 0, 0, 322, 169);
INSERT INTO public.who_global_data VALUES (76150, 1595, 12445, 78, 450, 322, 28);
INSERT INTO public.who_global_data VALUES (76151, 0, 15, 0, 0, 322, 85);
INSERT INTO public.who_global_data VALUES (76152, 4, 15, 0, 0, 322, 211);
INSERT INTO public.who_global_data VALUES (76153, 0, 3, 0, 1, 322, 60);
INSERT INTO public.who_global_data VALUES (76154, 0, 5, 0, 0, 322, 3);
INSERT INTO public.who_global_data VALUES (76155, 10, 48, 0, 0, 322, 11);
INSERT INTO public.who_global_data VALUES (76156, 4049, 18187, 2, 45, 322, 89);
INSERT INTO public.who_global_data VALUES (76157, 3, 19, 0, 0, 322, 24);
INSERT INTO public.who_global_data VALUES (76158, 0, 10, 0, 0, 322, 162);
INSERT INTO public.who_global_data VALUES (76159, 31, 495, 3, 8, 322, 100);
INSERT INTO public.who_global_data VALUES (76160, 0, 2, 0, 0, 322, 47);
INSERT INTO public.who_global_data VALUES (76161, 0, 0, 0, 0, 322, 29);
INSERT INTO public.who_global_data VALUES (76162, 0, 51, 0, 0, 322, 40);
INSERT INTO public.who_global_data VALUES (76163, 1, 15, 0, 0, 322, 222);
INSERT INTO public.who_global_data VALUES (76164, 0, 12, 0, 1, 322, 132);
INSERT INTO public.who_global_data VALUES (76165, 0, 1, 0, 0, 322, 130);
INSERT INTO public.who_global_data VALUES (76166, 0, 6, 0, 0, 322, 234);
INSERT INTO public.who_global_data VALUES (76167, 0, 0, 0, 0, 322, 23);
INSERT INTO public.who_global_data VALUES (76168, 0, 9, 0, 1, 322, 192);
INSERT INTO public.who_global_data VALUES (76169, 0, 2, 0, 0, 322, 69);
INSERT INTO public.who_global_data VALUES (76170, 0, 1, 0, 0, 322, 187);
INSERT INTO public.who_global_data VALUES (76171, 0, 24, 0, 0, 322, 230);
INSERT INTO public.who_global_data VALUES (76172, 18, 103, 3, 4, 322, 77);
INSERT INTO public.who_global_data VALUES (76173, 79, 409, 0, 1, 322, 9);
INSERT INTO public.who_global_data VALUES (76174, 88, 283, 0, 4, 322, 74);
INSERT INTO public.who_global_data VALUES (76175, 81, 450, 6, 38, 322, 224);
INSERT INTO public.who_global_data VALUES (76176, 966, 20610, 123, 1556, 322, 199);
INSERT INTO public.who_global_data VALUES (76177, 21, 214, 3, 17, 322, 190);
INSERT INTO public.who_global_data VALUES (76178, 126, 683, 0, 3, 322, 12);
INSERT INTO public.who_global_data VALUES (76179, 0, 1, 0, 0, 322, 104);
INSERT INTO public.who_global_data VALUES (76180, 136, 636, 0, 1, 322, 153);
INSERT INTO public.who_global_data VALUES (76181, 5986, 47021, 625, 4032, 322, 91);
INSERT INTO public.who_global_data VALUES (76182, 0, 16, 0, 1, 322, 215);
INSERT INTO public.who_global_data VALUES (76183, 50, 1046, 1, 36, 322, 84);
INSERT INTO public.who_global_data VALUES (76184, 0, 12, 0, 0, 322, 231);
INSERT INTO public.who_global_data VALUES (76185, 15, 84, 0, 0, 322, 196);
INSERT INTO public.who_global_data VALUES (76186, 4, 57, 0, 0, 322, 105);
INSERT INTO public.who_global_data VALUES (76187, 0, 11, 0, 0, 322, 122);
INSERT INTO public.who_global_data VALUES (76188, 0, 0, 0, 0, 322, 159);
INSERT INTO public.who_global_data VALUES (76189, 4, 24, 0, 0, 322, 75);
INSERT INTO public.who_global_data VALUES (76190, 17, 176, 0, 0, 322, 27);
INSERT INTO public.who_global_data VALUES (76191, 0, 3, 0, 0, 322, 54);
INSERT INTO public.who_global_data VALUES (76192, 0, 0, 0, 0, 322, 226);
INSERT INTO public.who_global_data VALUES (76193, 25, 111, 0, 0, 322, 79);
INSERT INTO public.who_global_data VALUES (76194, 43, 206, 0, 4, 322, 56);
INSERT INTO public.who_global_data VALUES (76195, 0, 0, 0, 0, 322, 117);
INSERT INTO public.who_global_data VALUES (76196, -3, 3, 0, 0, 322, 152);
INSERT INTO public.who_global_data VALUES (76197, 0, 0, 0, 0, 322, 16);
INSERT INTO public.who_global_data VALUES (76198, 8, 44, 0, 0, 322, 10);
INSERT INTO public.who_global_data VALUES (76199, 22, 69, 1, 1, 322, 201);
INSERT INTO public.who_global_data VALUES (76200, 139, 484, 1, 5, 322, 174);
INSERT INTO public.who_global_data VALUES (76201, 3, 3, 0, 0, 322, 119);
INSERT INTO public.who_global_data VALUES (76202, 0, 0, 0, 0, 322, 168);
INSERT INTO public.who_global_data VALUES (76203, 153, 1183, 0, 3, 322, 99);
INSERT INTO public.who_global_data VALUES (76204, 0, 17, 0, 0, 322, 171);
INSERT INTO public.who_global_data VALUES (76205, 0, 0, 0, 0, 322, 87);
INSERT INTO public.who_global_data VALUES (76206, 9, 73, 0, 0, 322, 123);
INSERT INTO public.who_global_data VALUES (76207, 0, 0, 0, 0, 322, 151);
INSERT INTO public.who_global_data VALUES (76208, 0, 32, 0, 0, 322, 213);
INSERT INTO public.who_global_data VALUES (76209, 0, 6, 0, 0, 322, 118);
INSERT INTO public.who_global_data VALUES (76210, 0, 12, 0, 0, 322, 134);
INSERT INTO public.who_global_data VALUES (76211, 3, 11, 0, 0, 322, 65);
INSERT INTO public.who_global_data VALUES (76212, 0, 164, 0, 1, 322, 102);
INSERT INTO public.who_global_data VALUES (76213, 0, 0, 0, 0, 322, 223);
INSERT INTO public.who_global_data VALUES (76214, 6, 18, 0, 0, 322, 4);
INSERT INTO public.who_global_data VALUES (76215, 4, 10, 0, 0, 322, 146);
INSERT INTO public.who_global_data VALUES (76216, 2, 16, 0, 0, 322, 31);
INSERT INTO public.who_global_data VALUES (76217, 0, 5, 0, 0, 322, 127);
INSERT INTO public.who_global_data VALUES (76218, 12, 86, 0, 3, 322, 22);
INSERT INTO public.who_global_data VALUES (76219, 0, 0, 0, 0, 322, 115);
INSERT INTO public.who_global_data VALUES (76220, 0, 0, 0, 0, 322, 106);
INSERT INTO public.who_global_data VALUES (76221, 0, 7, 0, 0, 322, 90);
INSERT INTO public.who_global_data VALUES (76222, 0, 0, 0, 0, 322, 70);
INSERT INTO public.who_global_data VALUES (76223, 0, 5, 0, 0, 322, 46);
INSERT INTO public.who_global_data VALUES (76224, 533, 2943, 28, 104, 322, 139);
INSERT INTO public.who_global_data VALUES (76225, 2, 4, 0, 0, 322, 42);
INSERT INTO public.who_global_data VALUES (76226, 13, 66, 0, 0, 322, 80);
INSERT INTO public.who_global_data VALUES (76227, 1, 2, 0, 0, 322, 203);
INSERT INTO public.who_global_data VALUES (76228, 0, 5, 0, 0, 322, 136);
INSERT INTO public.who_global_data VALUES (76229, 6, 22, 0, 0, 322, 63);
INSERT INTO public.who_global_data VALUES (76230, 0, 0, 0, 0, 322, 17);
INSERT INTO public.who_global_data VALUES (76231, 0, 0, 0, 0, 322, 172);
INSERT INTO public.who_global_data VALUES (76232, 37, 85, 0, 0, 322, 109);
INSERT INTO public.who_global_data VALUES (76233, 190, 1742, 1, 7, 322, 200);
INSERT INTO public.who_global_data VALUES (76234, 4, 52, 0, 0, 322, 93);
INSERT INTO public.who_global_data VALUES (76235, 4, 52, 0, 0, 322, 5);
INSERT INTO public.who_global_data VALUES (76236, 0, 712, 0, 8, 322, 214);
INSERT INTO public.who_global_data VALUES (76237, 34, 495, 1, 3, 322, 204);
INSERT INTO public.who_global_data VALUES (76238, 0, 0, 0, 0, 322, 198);
INSERT INTO public.who_global_data VALUES (76239, 0, 137, 0, 1, 322, 173);
INSERT INTO public.who_global_data VALUES (76240, 0, 1, 0, 0, 322, 229);
INSERT INTO public.who_global_data VALUES (76241, 5, 18, 1, 1, 322, 76);
INSERT INTO public.who_global_data VALUES (76242, 84, 318, 0, 2, 322, 138);
INSERT INTO public.who_global_data VALUES (76243, 77, 307, 1, 19, 322, 98);
INSERT INTO public.who_global_data VALUES (76244, 0, 0, 0, 0, 322, 103);
INSERT INTO public.who_global_data VALUES (76245, 70, 425, 0, 5, 322, 225);
INSERT INTO public.who_global_data VALUES (76246, 235, 1020, 3, 6, 322, 131);
INSERT INTO public.who_global_data VALUES (76247, 7, 21, 1, 1, 322, 235);
INSERT INTO public.who_global_data VALUES (76248, 10, 470, 0, 0, 322, 137);
INSERT INTO public.who_global_data VALUES (76249, 98, 8897, 2, 104, 322, 81);
INSERT INTO public.who_global_data VALUES (76250, 31, 80, 1, 1, 322, 182);
INSERT INTO public.who_global_data VALUES (76251, 19, 47, 0, 0, 322, 145);
INSERT INTO public.who_global_data VALUES (76252, 31, 308, 0, 0, 322, 26);
INSERT INTO public.who_global_data VALUES (76253, 54, 253, 0, 0, 322, 170);
INSERT INTO public.who_global_data VALUES (76254, 2, 17, 0, 0, 322, 191);
INSERT INTO public.who_global_data VALUES (76255, 0, 0, 0, 0, 322, 221);
INSERT INTO public.who_global_data VALUES (76256, 0, 3, 0, 0, 322, 64);
INSERT INTO public.who_global_data VALUES (76257, 0, 0, 0, 0, 322, 116);
INSERT INTO public.who_global_data VALUES (76258, 0, 0, 0, 0, 322, 128);
INSERT INTO public.who_global_data VALUES (76259, 0, 6, 0, 0, 322, 6);
INSERT INTO public.who_global_data VALUES (76260, 0, 8, 0, 0, 322, 227);
INSERT INTO public.who_global_data VALUES (76261, 0, 0, 0, 0, 322, 68);
INSERT INTO public.who_global_data VALUES (76262, 0, 1, 0, 0, 322, 184);
INSERT INTO public.who_global_data VALUES (76263, 0, 0, 0, 0, 322, 82);
INSERT INTO public.who_global_data VALUES (76264, 25, 151, 6, 20, 322, 149);
INSERT INTO public.who_global_data VALUES (76265, 0, 0, 0, 0, 322, 197);
INSERT INTO public.who_global_data VALUES (76266, 118, 392, 0, 0, 322, 78);
INSERT INTO public.who_global_data VALUES (76267, 14, 56, 0, 0, 322, 233);
INSERT INTO public.who_global_data VALUES (76268, 50, 173, 1, 1, 322, 133);
INSERT INTO public.who_global_data VALUES (76269, -3, 7, 0, 0, 322, 35);
INSERT INTO public.who_global_data VALUES (76270, 0, 0, 0, 0, 322, 114);
INSERT INTO public.who_global_data VALUES (76271, 47, 432, 0, 2, 322, 237);
INSERT INTO public.who_global_data VALUES (76272, 0, 0, 0, 0, 322, 55);
INSERT INTO public.who_global_data VALUES (76273, 0, 5, 0, 0, 322, 176);
INSERT INTO public.who_global_data VALUES (76274, 14, 137, 0, 0, 322, 202);
INSERT INTO public.who_global_data VALUES (76275, 28, 369, 0, 1, 322, 155);
INSERT INTO public.who_global_data VALUES (76276, 0, 0, 0, 0, 322, 32);
INSERT INTO public.who_global_data VALUES (76277, 0, 5, 0, 0, 322, 220);
INSERT INTO public.who_global_data VALUES (76278, 35, 240, 0, 0, 322, 30);
INSERT INTO public.who_global_data VALUES (76279, 0, 0, 0, 0, 322, 147);
INSERT INTO public.who_global_data VALUES (76280, 5880, 31298, 322, 1424, 322, 208);
INSERT INTO public.who_global_data VALUES (76281, 13, 72, 0, 0, 322, 45);
INSERT INTO public.who_global_data VALUES (76282, 1, 2, 0, 1, 322, 110);
INSERT INTO public.who_global_data VALUES (76283, 0, 2, 0, 0, 322, 88);
INSERT INTO public.who_global_data VALUES (76284, 143, 1553, 7, 21, 322, 51);
INSERT INTO public.who_global_data VALUES (76285, 1139, 8016, 21, 90, 322, 209);
INSERT INTO public.who_global_data VALUES (76286, 0, 0, 0, 0, 322, 205);
INSERT INTO public.who_global_data VALUES (76287, 0, 0, 0, 0, 322, 18);
INSERT INTO public.who_global_data VALUES (76288, 89, 411, 0, 1, 322, 72);
INSERT INTO public.who_global_data VALUES (76289, 1055, 6481, 32, 194, 322, 44);
INSERT INTO public.who_global_data VALUES (76290, 0, 1, 0, 0, 322, 15);
INSERT INTO public.who_global_data VALUES (76291, 2, 15, 0, 0, 322, 25);
INSERT INTO public.who_global_data VALUES (76292, 0, 0, 0, 0, 322, 179);
INSERT INTO public.who_global_data VALUES (76293, 0, 0, 0, 0, 322, 34);
INSERT INTO public.who_global_data VALUES (76294, 0, 9, 0, 0, 322, 207);
INSERT INTO public.who_global_data VALUES (76295, 6, 60, 0, 1, 322, 166);
INSERT INTO public.who_global_data VALUES (76296, 479, 670, 7, 9, 322, 126);
INSERT INTO public.who_global_data VALUES (76297, 0, 0, 0, 0, 322, 97);
INSERT INTO public.who_global_data VALUES (76298, 0, 0, 0, 0, 322, 36);
INSERT INTO public.who_global_data VALUES (76299, 0, 0, 0, 0, 322, 125);
INSERT INTO public.who_global_data VALUES (76300, 1, 1, 0, 0, 322, 124);
INSERT INTO public.who_global_data VALUES (76301, 31, 47, 1, 3, 322, 185);
INSERT INTO public.who_global_data VALUES (76302, 13, 153, 2, 2, 322, 194);
INSERT INTO public.who_global_data VALUES (76303, 0, 10, 0, 0, 322, 144);
INSERT INTO public.who_global_data VALUES (76304, 0, 15219, 0, 201, 322, 19);
INSERT INTO public.who_global_data VALUES (76305, -1, 6, 0, 0, 322, 217);
INSERT INTO public.who_global_data VALUES (76306, 0, 94, 0, 0, 322, 148);
INSERT INTO public.who_global_data VALUES (76307, 20, 41, 0, 0, 322, 86);
INSERT INTO public.who_global_data VALUES (76308, 0, 0, 0, 0, 322, 13);
INSERT INTO public.who_global_data VALUES (76309, 0, 40, 0, 0, 322, 157);
INSERT INTO public.who_global_data VALUES (76310, 3, 94, 0, 0, 322, 8);
INSERT INTO public.who_global_data VALUES (76311, 0, 0, 0, 0, 322, 73);
INSERT INTO public.who_global_data VALUES (76312, 0, 0, 0, 0, 322, 101);
INSERT INTO public.who_global_data VALUES (76313, 0, 6, 0, 0, 322, 165);
INSERT INTO public.who_global_data VALUES (76314, 1, 2, 0, 0, 322, 14);
INSERT INTO public.who_global_data VALUES (76315, -2, 24, 0, 0, 323, 193);
INSERT INTO public.who_global_data VALUES (76316, 11, 32, 0, 1, 323, 113);
INSERT INTO public.who_global_data VALUES (76317, 8, 94, 3, 10, 323, 143);
INSERT INTO public.who_global_data VALUES (76318, 0, 0, 0, 0, 323, 219);
INSERT INTO public.who_global_data VALUES (76319, 36, 75, 0, 0, 323, 186);
INSERT INTO public.who_global_data VALUES (76320, 0, 0, 0, 0, 323, 52);
INSERT INTO public.who_global_data VALUES (76321, 0, 0, 0, 0, 323, 180);
INSERT INTO public.who_global_data VALUES (76322, 0, 5, 0, 0, 323, 167);
INSERT INTO public.who_global_data VALUES (76323, 27, 128, 1, 3, 323, 154);
INSERT INTO public.who_global_data VALUES (76324, 31, 92, 0, 0, 323, 94);
INSERT INTO public.who_global_data VALUES (76325, 0, 5, 0, 0, 323, 66);
INSERT INTO public.who_global_data VALUES (76326, 164, 873, 1, 7, 323, 58);
INSERT INTO public.who_global_data VALUES (76327, 550, 2196, 2, 6, 323, 163);
INSERT INTO public.who_global_data VALUES (76328, 6, 34, 1, 1, 323, 37);
INSERT INTO public.who_global_data VALUES (76329, -3, 4, 0, 0, 323, 142);
INSERT INTO public.who_global_data VALUES (76330, 12, 285, 0, 1, 323, 83);
INSERT INTO public.who_global_data VALUES (76331, 0, 17, 0, 1, 323, 228);
INSERT INTO public.who_global_data VALUES (76332, -1, 5, 0, 0, 323, 188);
INSERT INTO public.who_global_data VALUES (76333, 0, 36, 0, 0, 323, 62);
INSERT INTO public.who_global_data VALUES (76334, 713, 3911, 33, 99, 323, 160);
INSERT INTO public.who_global_data VALUES (76335, 0, 0, 0, 0, 323, 50);
INSERT INTO public.who_global_data VALUES (76336, 0, 2, 0, 0, 323, 33);
INSERT INTO public.who_global_data VALUES (76337, 0, 6, 0, 0, 323, 183);
INSERT INTO public.who_global_data VALUES (76338, 0, 2, 0, 0, 323, 92);
INSERT INTO public.who_global_data VALUES (76339, 1, 16, 0, 0, 323, 158);
INSERT INTO public.who_global_data VALUES (76340, 0, 0, 0, 0, 323, 67);
INSERT INTO public.who_global_data VALUES (76341, 9, 44, 0, 0, 323, 57);
INSERT INTO public.who_global_data VALUES (76342, 0, 0, 0, 0, 323, 38);
INSERT INTO public.who_global_data VALUES (76343, 193, 621, 0, 4, 323, 141);
INSERT INTO public.who_global_data VALUES (76344, 0, 0, 0, 0, 323, 178);
INSERT INTO public.who_global_data VALUES (76345, 5, 78, 0, 0, 323, 108);
INSERT INTO public.who_global_data VALUES (76346, 13, 105, 1, 3, 323, 39);
INSERT INTO public.who_global_data VALUES (76347, 0, 44, 0, 1, 323, 2);
INSERT INTO public.who_global_data VALUES (76348, 0, 0, 0, 0, 323, 195);
INSERT INTO public.who_global_data VALUES (76349, 1, 1, 0, 0, 323, 107);
INSERT INTO public.who_global_data VALUES (76350, 4, 51, 0, 0, 323, 161);
INSERT INTO public.who_global_data VALUES (76351, 3, 22, 0, 0, 323, 212);
INSERT INTO public.who_global_data VALUES (76352, 110, 846, 0, 9, 323, 181);
INSERT INTO public.who_global_data VALUES (76353, 0, 3, 0, 1, 323, 53);
INSERT INTO public.who_global_data VALUES (76354, 0, 5, 0, 0, 323, 164);
INSERT INTO public.who_global_data VALUES (76355, 0, 5, 0, 0, 323, 140);
INSERT INTO public.who_global_data VALUES (76356, 92, 434, 0, 0, 323, 20);
INSERT INTO public.who_global_data VALUES (76357, 139, 81416, 11, 3261, 323, 112);
INSERT INTO public.who_global_data VALUES (76358, 37, 145, 0, 0, 323, 111);
INSERT INTO public.who_global_data VALUES (76359, 0, 0, 0, 0, 323, 71);
INSERT INTO public.who_global_data VALUES (76360, 0, 2, 0, 0, 323, 218);
INSERT INTO public.who_global_data VALUES (76361, 0, 0, 0, 0, 323, 43);
INSERT INTO public.who_global_data VALUES (76362, 26, 113, 1, 2, 323, 49);
INSERT INTO public.who_global_data VALUES (76363, 0, 13, 0, 0, 323, 1);
INSERT INTO public.who_global_data VALUES (76364, 23, 104, 0, 0, 323, 48);
INSERT INTO public.who_global_data VALUES (76365, 5, 16, 0, 1, 323, 232);
INSERT INTO public.who_global_data VALUES (76366, 0, 7, 0, 0, 323, 175);
INSERT INTO public.who_global_data VALUES (76367, 0, 58, 0, 0, 323, 21);
INSERT INTO public.who_global_data VALUES (76368, 172, 694, 0, 0, 323, 156);
INSERT INTO public.who_global_data VALUES (76369, 0, 0, 0, 0, 323, 95);
INSERT INTO public.who_global_data VALUES (76370, 0, 18, 0, 0, 323, 177);
INSERT INTO public.who_global_data VALUES (76371, 36, 1151, 2, 6, 323, 210);
INSERT INTO public.who_global_data VALUES (76372, 0, 5, 0, 0, 323, 120);
INSERT INTO public.who_global_data VALUES (76373, 0, 0, 0, 0, 323, 135);
INSERT INTO public.who_global_data VALUES (76374, 38, 72, 0, 2, 323, 206);
INSERT INTO public.who_global_data VALUES (76375, 168, 367, 2, 5, 323, 189);
INSERT INTO public.who_global_data VALUES (76376, 42, 256, 1, 7, 323, 129);
INSERT INTO public.who_global_data VALUES (76377, 0, 1, 0, 0, 323, 121);
INSERT INTO public.who_global_data VALUES (76378, 0, 8, 0, 0, 323, 59);
INSERT INTO public.who_global_data VALUES (76379, 0, 0, 0, 0, 323, 96);
INSERT INTO public.who_global_data VALUES (76380, 9, 267, 0, 0, 323, 41);
INSERT INTO public.who_global_data VALUES (76381, 0, 5, 0, 0, 323, 216);
INSERT INTO public.who_global_data VALUES (76382, 0, 13, 0, 0, 323, 236);
INSERT INTO public.who_global_data VALUES (76383, 0, 0, 0, 0, 323, 150);
INSERT INTO public.who_global_data VALUES (76384, 25, 72, 0, 0, 323, 61);
INSERT INTO public.who_global_data VALUES (76385, 0, 1, 0, 0, 323, 7);
INSERT INTO public.who_global_data VALUES (76386, 31, 400, 0, 0, 323, 169);
INSERT INTO public.who_global_data VALUES (76387, 1846, 10850, 128, 372, 323, 28);
INSERT INTO public.who_global_data VALUES (76388, 0, 15, 0, 0, 323, 85);
INSERT INTO public.who_global_data VALUES (76389, 0, 11, 0, 0, 323, 211);
INSERT INTO public.who_global_data VALUES (76390, 1, 3, 1, 1, 323, 60);
INSERT INTO public.who_global_data VALUES (76391, 0, 5, 0, 0, 323, 3);
INSERT INTO public.who_global_data VALUES (76392, 4, 38, 0, 0, 323, 11);
INSERT INTO public.who_global_data VALUES (76393, 5940, 14138, 30, 43, 323, 89);
INSERT INTO public.who_global_data VALUES (76394, 1, 16, 0, 0, 323, 24);
INSERT INTO public.who_global_data VALUES (76395, 7, 10, 0, 0, 323, 162);
INSERT INTO public.who_global_data VALUES (76396, 46, 464, 0, 5, 323, 100);
INSERT INTO public.who_global_data VALUES (76397, 0, 2, 0, 0, 323, 47);
INSERT INTO public.who_global_data VALUES (76398, 0, 0, 0, 0, 323, 29);
INSERT INTO public.who_global_data VALUES (76399, 6, 51, 0, 0, 323, 40);
INSERT INTO public.who_global_data VALUES (76400, 2, 14, 0, 0, 323, 222);
INSERT INTO public.who_global_data VALUES (76401, 3, 12, 0, 1, 323, 132);
INSERT INTO public.who_global_data VALUES (76402, 0, 1, 0, 0, 323, 130);
INSERT INTO public.who_global_data VALUES (76403, 0, 6, 0, 0, 323, 234);
INSERT INTO public.who_global_data VALUES (76404, 0, 0, 0, 0, 323, 23);
INSERT INTO public.who_global_data VALUES (76405, 0, 9, 0, 1, 323, 192);
INSERT INTO public.who_global_data VALUES (76406, 2, 2, 0, 0, 323, 69);
INSERT INTO public.who_global_data VALUES (76407, 0, 1, 0, 0, 323, 187);
INSERT INTO public.who_global_data VALUES (76408, 12, 24, 0, 0, 323, 230);
INSERT INTO public.who_global_data VALUES (76409, 12, 85, 0, 1, 323, 77);
INSERT INTO public.who_global_data VALUES (76410, 80, 330, 1, 1, 323, 9);
INSERT INTO public.who_global_data VALUES (76411, 0, 195, 0, 4, 323, 74);
INSERT INTO public.who_global_data VALUES (76412, 60, 369, 7, 32, 323, 224);
INSERT INTO public.who_global_data VALUES (76413, 1233, 19644, 149, 1433, 323, 199);
INSERT INTO public.who_global_data VALUES (76414, 12, 193, 2, 14, 323, 190);
INSERT INTO public.who_global_data VALUES (76415, 191, 557, 1, 3, 323, 12);
INSERT INTO public.who_global_data VALUES (76416, 1, 1, 0, 0, 323, 104);
INSERT INTO public.who_global_data VALUES (76417, 118, 500, 0, 1, 323, 153);
INSERT INTO public.who_global_data VALUES (76418, 5322, 41035, 429, 3407, 323, 91);
INSERT INTO public.who_global_data VALUES (76419, 1, 16, 0, 1, 323, 215);
INSERT INTO public.who_global_data VALUES (76420, 46, 996, 2, 35, 323, 84);
INSERT INTO public.who_global_data VALUES (76421, 7, 12, 0, 0, 323, 231);
INSERT INTO public.who_global_data VALUES (76422, 9, 69, 0, 0, 323, 196);
INSERT INTO public.who_global_data VALUES (76423, 7, 53, 0, 0, 323, 105);
INSERT INTO public.who_global_data VALUES (76424, 0, 11, 0, 0, 323, 122);
INSERT INTO public.who_global_data VALUES (76425, 0, 0, 0, 0, 323, 159);
INSERT INTO public.who_global_data VALUES (76426, 15, 20, 0, 0, 323, 75);
INSERT INTO public.who_global_data VALUES (76427, 7, 159, 0, 0, 323, 27);
INSERT INTO public.who_global_data VALUES (76428, 0, 3, 0, 0, 323, 54);
INSERT INTO public.who_global_data VALUES (76429, 0, 0, 0, 0, 323, 226);
INSERT INTO public.who_global_data VALUES (76430, 15, 86, 0, 0, 323, 79);
INSERT INTO public.who_global_data VALUES (76431, 10, 163, 0, 4, 323, 56);
INSERT INTO public.who_global_data VALUES (76432, 0, 0, 0, 0, 323, 117);
INSERT INTO public.who_global_data VALUES (76433, 0, 6, 0, 0, 323, 152);
INSERT INTO public.who_global_data VALUES (76434, 0, 0, 0, 0, 323, 16);
INSERT INTO public.who_global_data VALUES (76435, 2, 36, 0, 0, 323, 10);
INSERT INTO public.who_global_data VALUES (76436, 11, 47, 0, 0, 323, 201);
INSERT INTO public.who_global_data VALUES (76437, 135, 345, 2, 4, 323, 174);
INSERT INTO public.who_global_data VALUES (76438, 0, 0, 0, 0, 323, 119);
INSERT INTO public.who_global_data VALUES (76439, 0, 0, 0, 0, 323, 168);
INSERT INTO public.who_global_data VALUES (76440, 130, 1030, 1, 3, 323, 99);
INSERT INTO public.who_global_data VALUES (76441, 0, 17, 0, 0, 323, 171);
INSERT INTO public.who_global_data VALUES (76442, 0, 0, 0, 0, 323, 87);
INSERT INTO public.who_global_data VALUES (76443, 12, 64, 0, 0, 323, 123);
INSERT INTO public.who_global_data VALUES (76444, 0, 0, 0, 0, 323, 151);
INSERT INTO public.who_global_data VALUES (76445, 0, 32, 0, 0, 323, 213);
INSERT INTO public.who_global_data VALUES (76446, 0, 6, 0, 0, 323, 118);
INSERT INTO public.who_global_data VALUES (76447, 1, 12, 0, 0, 323, 134);
INSERT INTO public.who_global_data VALUES (76448, 0, 8, 0, 0, 323, 65);
INSERT INTO public.who_global_data VALUES (76449, 46, 164, 0, 1, 323, 102);
INSERT INTO public.who_global_data VALUES (76450, 0, 0, 0, 0, 323, 223);
INSERT INTO public.who_global_data VALUES (76451, 3, 12, 0, 0, 323, 4);
INSERT INTO public.who_global_data VALUES (76452, 0, 6, 0, 0, 323, 146);
INSERT INTO public.who_global_data VALUES (76453, 1, 14, 0, 0, 323, 31);
INSERT INTO public.who_global_data VALUES (76454, 0, 5, 0, 0, 323, 127);
INSERT INTO public.who_global_data VALUES (76455, 9, 74, 1, 3, 323, 22);
INSERT INTO public.who_global_data VALUES (76456, 0, 0, 0, 0, 323, 115);
INSERT INTO public.who_global_data VALUES (76457, 0, 0, 0, 0, 323, 106);
INSERT INTO public.who_global_data VALUES (76458, 0, 7, 0, 0, 323, 90);
INSERT INTO public.who_global_data VALUES (76459, 0, 0, 0, 0, 323, 70);
INSERT INTO public.who_global_data VALUES (76460, 0, 5, 0, 0, 323, 46);
INSERT INTO public.who_global_data VALUES (76461, 396, 2410, 23, 76, 323, 139);
INSERT INTO public.who_global_data VALUES (76462, 0, 2, 0, 0, 323, 42);
INSERT INTO public.who_global_data VALUES (76463, 14, 53, 0, 0, 323, 80);
INSERT INTO public.who_global_data VALUES (76464, 0, 1, 0, 0, 323, 203);
INSERT INTO public.who_global_data VALUES (76465, 0, 5, 0, 0, 323, 136);
INSERT INTO public.who_global_data VALUES (76466, 0, 16, 0, 0, 323, 63);
INSERT INTO public.who_global_data VALUES (76467, 0, 0, 0, 0, 323, 17);
INSERT INTO public.who_global_data VALUES (76468, 0, 0, 0, 0, 323, 172);
INSERT INTO public.who_global_data VALUES (76469, 13, 48, 0, 0, 323, 109);
INSERT INTO public.who_global_data VALUES (76470, 129, 1552, 3, 6, 323, 200);
INSERT INTO public.who_global_data VALUES (76471, -3, 48, 0, 0, 323, 93);
INSERT INTO public.who_global_data VALUES (76472, 5, 48, 0, 0, 323, 5);
INSERT INTO public.who_global_data VALUES (76473, -4, 712, 1, 8, 323, 214);
INSERT INTO public.who_global_data VALUES (76474, 155, 461, 0, 2, 323, 204);
INSERT INTO public.who_global_data VALUES (76475, 0, 0, 0, 0, 323, 198);
INSERT INTO public.who_global_data VALUES (76476, 28, 137, 0, 1, 323, 173);
INSERT INTO public.who_global_data VALUES (76477, 1, 1, 0, 0, 323, 229);
INSERT INTO public.who_global_data VALUES (76478, -2, 13, 0, 0, 323, 76);
INSERT INTO public.who_global_data VALUES (76479, 0, 234, 2, 2, 323, 138);
INSERT INTO public.who_global_data VALUES (76480, 13, 230, 1, 18, 323, 98);
INSERT INTO public.who_global_data VALUES (76481, 0, 0, 0, 0, 323, 103);
INSERT INTO public.who_global_data VALUES (76482, 68, 355, 0, 5, 323, 225);
INSERT INTO public.who_global_data VALUES (76483, 143, 785, 1, 3, 323, 131);
INSERT INTO public.who_global_data VALUES (76484, 8, 14, 0, 0, 323, 235);
INSERT INTO public.who_global_data VALUES (76485, 4, 460, 0, 0, 323, 137);
INSERT INTO public.who_global_data VALUES (76486, 147, 8799, 8, 102, 323, 81);
INSERT INTO public.who_global_data VALUES (76487, 13, 49, 0, 0, 323, 182);
INSERT INTO public.who_global_data VALUES (76488, 9, 28, 0, 0, 323, 145);
INSERT INTO public.who_global_data VALUES (76489, 17, 277, 0, 0, 323, 26);
INSERT INTO public.who_global_data VALUES (76490, 52, 199, 0, 0, 323, 170);
INSERT INTO public.who_global_data VALUES (76491, 0, 15, 0, 0, 323, 191);
INSERT INTO public.who_global_data VALUES (76492, 0, 0, 0, 0, 323, 221);
INSERT INTO public.who_global_data VALUES (76493, 0, 3, 0, 0, 323, 64);
INSERT INTO public.who_global_data VALUES (76494, 0, 0, 0, 0, 323, 116);
INSERT INTO public.who_global_data VALUES (76495, 0, 0, 0, 0, 323, 128);
INSERT INTO public.who_global_data VALUES (76496, 0, 6, 0, 0, 323, 6);
INSERT INTO public.who_global_data VALUES (76497, 0, 8, 0, 0, 323, 227);
INSERT INTO public.who_global_data VALUES (76498, 0, 0, 0, 0, 323, 68);
INSERT INTO public.who_global_data VALUES (76499, 0, 1, 0, 0, 323, 184);
INSERT INTO public.who_global_data VALUES (76500, 0, 0, 0, 0, 323, 82);
INSERT INTO public.who_global_data VALUES (76501, 17, 126, 0, 14, 323, 149);
INSERT INTO public.who_global_data VALUES (76502, 0, 0, 0, 0, 323, 197);
INSERT INTO public.who_global_data VALUES (76503, 32, 274, 0, 0, 323, 78);
INSERT INTO public.who_global_data VALUES (76504, 0, 42, 0, 0, 323, 233);
INSERT INTO public.who_global_data VALUES (76505, 29, 123, 0, 0, 323, 133);
INSERT INTO public.who_global_data VALUES (76506, 0, 10, 0, 0, 323, 35);
INSERT INTO public.who_global_data VALUES (76507, 0, 0, 0, 0, 323, 114);
INSERT INTO public.who_global_data VALUES (76508, 40, 385, 2, 2, 323, 237);
INSERT INTO public.who_global_data VALUES (76509, 0, 0, 0, 0, 323, 55);
INSERT INTO public.who_global_data VALUES (76510, 0, 5, 0, 0, 323, 176);
INSERT INTO public.who_global_data VALUES (76511, 16, 123, 0, 0, 323, 202);
INSERT INTO public.who_global_data VALUES (76512, 23, 341, 0, 1, 323, 155);
INSERT INTO public.who_global_data VALUES (76513, 0, 0, 0, 0, 323, 32);
INSERT INTO public.who_global_data VALUES (76514, 0, 5, 0, 0, 323, 220);
INSERT INTO public.who_global_data VALUES (76515, 51, 205, 0, 0, 323, 30);
INSERT INTO public.who_global_data VALUES (76516, 0, 0, 0, 0, 323, 147);
INSERT INTO public.who_global_data VALUES (76517, 4785, 25418, 246, 1102, 323, 208);
INSERT INTO public.who_global_data VALUES (76518, 0, 59, 0, 0, 323, 45);
INSERT INTO public.who_global_data VALUES (76519, 0, 1, 0, 1, 323, 110);
INSERT INTO public.who_global_data VALUES (76520, -3, 2, 0, 0, 323, 88);
INSERT INTO public.who_global_data VALUES (76521, 145, 1410, 6, 14, 323, 51);
INSERT INTO public.who_global_data VALUES (76522, 835, 6877, 14, 69, 323, 209);
INSERT INTO public.who_global_data VALUES (76523, 0, 0, 0, 0, 323, 205);
INSERT INTO public.who_global_data VALUES (76524, 0, 0, 0, 0, 323, 18);
INSERT INTO public.who_global_data VALUES (76525, 0, 322, 0, 1, 323, 72);
INSERT INTO public.who_global_data VALUES (76526, 999, 5426, 46, 162, 323, 44);
INSERT INTO public.who_global_data VALUES (76527, 1, 1, 0, 0, 323, 15);
INSERT INTO public.who_global_data VALUES (76528, 0, 13, 0, 0, 323, 25);
INSERT INTO public.who_global_data VALUES (76529, 0, 0, 0, 0, 323, 179);
INSERT INTO public.who_global_data VALUES (76530, 0, 0, 0, 0, 323, 34);
INSERT INTO public.who_global_data VALUES (76531, 0, 9, 0, 0, 323, 207);
INSERT INTO public.who_global_data VALUES (76532, 15, 54, 1, 1, 323, 166);
INSERT INTO public.who_global_data VALUES (76533, 0, 191, 0, 2, 323, 126);
INSERT INTO public.who_global_data VALUES (76534, 0, 0, 0, 0, 323, 97);
INSERT INTO public.who_global_data VALUES (76535, 0, 0, 0, 0, 323, 36);
INSERT INTO public.who_global_data VALUES (76536, 0, 0, 0, 0, 323, 125);
INSERT INTO public.who_global_data VALUES (76537, 0, 0, 0, 0, 323, 124);
INSERT INTO public.who_global_data VALUES (76538, 0, 16, 0, 2, 323, 185);
INSERT INTO public.who_global_data VALUES (76539, 0, 140, 0, 0, 323, 194);
INSERT INTO public.who_global_data VALUES (76540, 0, 10, 0, 0, 323, 144);
INSERT INTO public.who_global_data VALUES (76541, 4777, 15219, 51, 201, 323, 19);
INSERT INTO public.who_global_data VALUES (76542, 0, 7, 0, 0, 323, 217);
INSERT INTO public.who_global_data VALUES (76543, 15, 94, 0, 0, 323, 148);
INSERT INTO public.who_global_data VALUES (76544, 17, 21, 0, 0, 323, 86);
INSERT INTO public.who_global_data VALUES (76545, 0, 0, 0, 0, 323, 13);
INSERT INTO public.who_global_data VALUES (76546, 0, 40, 0, 0, 323, 157);
INSERT INTO public.who_global_data VALUES (76547, 6, 91, 0, 0, 323, 8);
INSERT INTO public.who_global_data VALUES (76548, 0, 0, 0, 0, 323, 73);
INSERT INTO public.who_global_data VALUES (76549, 0, 0, 0, 0, 323, 101);
INSERT INTO public.who_global_data VALUES (76550, 0, 6, 0, 0, 323, 165);
INSERT INTO public.who_global_data VALUES (76551, 1, 1, 0, 0, 323, 14);
INSERT INTO public.who_global_data VALUES (76552, 0, 26, 0, 0, 324, 193);
INSERT INTO public.who_global_data VALUES (76553, 3, 21, 0, 1, 324, 113);
INSERT INTO public.who_global_data VALUES (76554, 10, 86, 1, 7, 324, 143);
INSERT INTO public.who_global_data VALUES (76555, 0, 0, 0, 0, 324, 219);
INSERT INTO public.who_global_data VALUES (76556, 0, 39, 0, 0, 324, 186);
INSERT INTO public.who_global_data VALUES (76557, 0, 0, 0, 0, 324, 52);
INSERT INTO public.who_global_data VALUES (76558, 0, 0, 0, 0, 324, 180);
INSERT INTO public.who_global_data VALUES (76559, 0, 5, 0, 0, 324, 167);
INSERT INTO public.who_global_data VALUES (76560, 0, 101, 0, 2, 324, 154);
INSERT INTO public.who_global_data VALUES (76561, 31, 61, 0, 0, 324, 94);
INSERT INTO public.who_global_data VALUES (76562, -3, 5, 0, 0, 324, 66);
INSERT INTO public.who_global_data VALUES (76563, 195, 709, 0, 6, 324, 58);
INSERT INTO public.who_global_data VALUES (76564, 314, 1646, 1, 4, 324, 163);
INSERT INTO public.who_global_data VALUES (76565, 0, 28, 0, 0, 324, 37);
INSERT INTO public.who_global_data VALUES (76566, 0, 7, 0, 0, 324, 142);
INSERT INTO public.who_global_data VALUES (76567, 13, 273, 0, 1, 324, 83);
INSERT INTO public.who_global_data VALUES (76568, 3, 17, 1, 1, 324, 228);
INSERT INTO public.who_global_data VALUES (76569, 0, 6, 0, 0, 324, 188);
INSERT INTO public.who_global_data VALUES (76570, 0, 36, 0, 0, 324, 62);
INSERT INTO public.who_global_data VALUES (76571, 534, 3198, 22, 66, 324, 160);
INSERT INTO public.who_global_data VALUES (76572, 0, 0, 0, 0, 324, 50);
INSERT INTO public.who_global_data VALUES (76573, 1, 2, 0, 0, 324, 33);
INSERT INTO public.who_global_data VALUES (76574, 0, 6, 0, 0, 324, 183);
INSERT INTO public.who_global_data VALUES (76575, 1, 2, 0, 0, 324, 92);
INSERT INTO public.who_global_data VALUES (76576, -1, 15, 0, 0, 324, 158);
INSERT INTO public.who_global_data VALUES (76577, 0, 0, 0, 0, 324, 67);
INSERT INTO public.who_global_data VALUES (76578, 14, 35, 0, 0, 324, 57);
INSERT INTO public.who_global_data VALUES (76579, 0, 0, 0, 0, 324, 38);
INSERT INTO public.who_global_data VALUES (76580, 133, 428, 3, 4, 324, 141);
INSERT INTO public.who_global_data VALUES (76581, 0, 0, 0, 0, 324, 178);
INSERT INTO public.who_global_data VALUES (76582, 13, 73, 0, 0, 324, 108);
INSERT INTO public.who_global_data VALUES (76583, 11, 92, 0, 2, 324, 39);
INSERT INTO public.who_global_data VALUES (76584, 14, 44, 0, 1, 324, 2);
INSERT INTO public.who_global_data VALUES (76585, 0, 0, 0, 0, 324, 195);
INSERT INTO public.who_global_data VALUES (76586, 0, 0, 0, 0, 324, 107);
INSERT INTO public.who_global_data VALUES (76587, 8, 47, 0, 0, 324, 161);
INSERT INTO public.who_global_data VALUES (76588, 5, 19, 0, 0, 324, 212);
INSERT INTO public.who_global_data VALUES (76589, 163, 736, 0, 9, 324, 181);
INSERT INTO public.who_global_data VALUES (76590, -2, 3, 0, 1, 324, 53);
INSERT INTO public.who_global_data VALUES (76591, 0, 5, 0, 0, 324, 164);
INSERT INTO public.who_global_data VALUES (76592, 5, 5, 0, 0, 324, 140);
INSERT INTO public.who_global_data VALUES (76593, 100, 342, 0, 0, 324, 20);
INSERT INTO public.who_global_data VALUES (76594, 99, 81277, 8, 3250, 324, 112);
INSERT INTO public.who_global_data VALUES (76595, 11, 108, 0, 0, 324, 111);
INSERT INTO public.who_global_data VALUES (76596, 0, 0, 0, 0, 324, 71);
INSERT INTO public.who_global_data VALUES (76597, 0, 2, 0, 0, 324, 218);
INSERT INTO public.who_global_data VALUES (76598, 0, 0, 0, 0, 324, 43);
INSERT INTO public.who_global_data VALUES (76599, 33, 87, 0, 1, 324, 49);
INSERT INTO public.who_global_data VALUES (76600, 0, 13, 0, 0, 324, 1);
INSERT INTO public.who_global_data VALUES (76601, 12, 81, 0, 0, 324, 48);
INSERT INTO public.who_global_data VALUES (76602, -3, 11, 0, 1, 324, 232);
INSERT INTO public.who_global_data VALUES (76603, 0, 7, 0, 0, 324, 175);
INSERT INTO public.who_global_data VALUES (76604, 18, 58, 0, 0, 324, 21);
INSERT INTO public.who_global_data VALUES (76605, 88, 522, 0, 0, 324, 156);
INSERT INTO public.who_global_data VALUES (76606, 0, 0, 0, 0, 324, 95);
INSERT INTO public.who_global_data VALUES (76607, 7, 18, 0, 0, 324, 177);
INSERT INTO public.who_global_data VALUES (76608, 91, 1115, 0, 4, 324, 210);
INSERT INTO public.who_global_data VALUES (76609, 0, 5, 0, 0, 324, 120);
INSERT INTO public.who_global_data VALUES (76610, 0, 0, 0, 0, 324, 135);
INSERT INTO public.who_global_data VALUES (76611, 9, 34, 1, 2, 324, 206);
INSERT INTO public.who_global_data VALUES (76612, 40, 199, 1, 3, 324, 189);
INSERT INTO public.who_global_data VALUES (76613, 14, 214, 0, 6, 324, 129);
INSERT INTO public.who_global_data VALUES (76614, 1, 1, 0, 0, 324, 121);
INSERT INTO public.who_global_data VALUES (76615, 1, 8, 0, 0, 324, 59);
INSERT INTO public.who_global_data VALUES (76616, 0, 0, 0, 0, 324, 96);
INSERT INTO public.who_global_data VALUES (76617, 33, 258, 0, 0, 324, 41);
INSERT INTO public.who_global_data VALUES (76618, 0, 5, 0, 0, 324, 216);
INSERT INTO public.who_global_data VALUES (76619, 3, 13, 0, 0, 324, 236);
INSERT INTO public.who_global_data VALUES (76620, 0, 0, 0, 0, 324, 150);
INSERT INTO public.who_global_data VALUES (76621, 29, 47, 0, 0, 324, 61);
INSERT INTO public.who_global_data VALUES (76622, 1, 1, 0, 0, 324, 7);
INSERT INTO public.who_global_data VALUES (76623, 50, 369, 0, 0, 324, 169);
INSERT INTO public.who_global_data VALUES (76624, 1387, 9004, 69, 244, 324, 28);
INSERT INTO public.who_global_data VALUES (76625, 0, 15, 0, 0, 324, 85);
INSERT INTO public.who_global_data VALUES (76626, 9, 11, 0, 0, 324, 211);
INSERT INTO public.who_global_data VALUES (76627, 0, 2, 0, 0, 324, 60);
INSERT INTO public.who_global_data VALUES (76628, 0, 5, 0, 0, 324, 3);
INSERT INTO public.who_global_data VALUES (76629, 0, 34, 0, 0, 324, 11);
INSERT INTO public.who_global_data VALUES (76630, 1042, 8198, 0, 13, 324, 89);
INSERT INTO public.who_global_data VALUES (76631, 2, 15, 0, 0, 324, 24);
INSERT INTO public.who_global_data VALUES (76632, 0, 3, 0, 0, 324, 162);
INSERT INTO public.who_global_data VALUES (76633, 31, 418, 0, 5, 324, 100);
INSERT INTO public.who_global_data VALUES (76634, 0, 2, 0, 0, 324, 47);
INSERT INTO public.who_global_data VALUES (76635, 0, 0, 0, 0, 324, 29);
INSERT INTO public.who_global_data VALUES (76636, 8, 45, 0, 0, 324, 40);
INSERT INTO public.who_global_data VALUES (76637, 3, 12, 0, 0, 324, 222);
INSERT INTO public.who_global_data VALUES (76638, -1, 9, 0, 1, 324, 132);
INSERT INTO public.who_global_data VALUES (76639, 0, 1, 0, 0, 324, 130);
INSERT INTO public.who_global_data VALUES (76640, 1, 6, 0, 0, 324, 234);
INSERT INTO public.who_global_data VALUES (76641, 0, 0, 0, 0, 324, 23);
INSERT INTO public.who_global_data VALUES (76642, 0, 9, 0, 1, 324, 192);
INSERT INTO public.who_global_data VALUES (76643, 0, 0, 0, 0, 324, 69);
INSERT INTO public.who_global_data VALUES (76644, 0, 1, 0, 0, 324, 187);
INSERT INTO public.who_global_data VALUES (76645, -1, 12, 0, 0, 324, 230);
INSERT INTO public.who_global_data VALUES (76646, 23, 73, 0, 1, 324, 77);
INSERT INTO public.who_global_data VALUES (76647, 3, 250, 0, 0, 324, 9);
INSERT INTO public.who_global_data VALUES (76648, 40, 195, 1, 4, 324, 74);
INSERT INTO public.who_global_data VALUES (76649, 78, 309, 6, 25, 324, 224);
INSERT INTO public.who_global_data VALUES (76650, 1046, 18411, 149, 1284, 324, 199);
INSERT INTO public.who_global_data VALUES (76651, 13, 181, 0, 12, 324, 190);
INSERT INTO public.who_global_data VALUES (76652, 74, 366, 0, 2, 324, 12);
INSERT INTO public.who_global_data VALUES (76653, 0, 0, 0, 0, 324, 104);
INSERT INTO public.who_global_data VALUES (76654, 94, 382, 0, 1, 324, 153);
INSERT INTO public.who_global_data VALUES (76655, 4207, 35713, 473, 2978, 324, 91);
INSERT INTO public.who_global_data VALUES (76656, -2, 15, 1, 1, 324, 215);
INSERT INTO public.who_global_data VALUES (76657, 73, 950, 4, 33, 324, 84);
INSERT INTO public.who_global_data VALUES (76658, 0, 5, 0, 0, 324, 231);
INSERT INTO public.who_global_data VALUES (76659, 4, 60, 0, 0, 324, 196);
INSERT INTO public.who_global_data VALUES (76660, 11, 46, 0, 0, 324, 105);
INSERT INTO public.who_global_data VALUES (76661, 0, 11, 0, 0, 324, 122);
INSERT INTO public.who_global_data VALUES (76662, 0, 0, 0, 0, 324, 159);
INSERT INTO public.who_global_data VALUES (76663, 0, 5, 0, 0, 324, 75);
INSERT INTO public.who_global_data VALUES (76664, 6, 152, 0, 0, 324, 27);
INSERT INTO public.who_global_data VALUES (76665, 0, 3, 0, 0, 324, 54);
INSERT INTO public.who_global_data VALUES (76666, 0, 0, 0, 0, 324, 226);
INSERT INTO public.who_global_data VALUES (76667, 10, 71, 0, 0, 324, 79);
INSERT INTO public.who_global_data VALUES (76668, 29, 153, 0, 4, 324, 56);
INSERT INTO public.who_global_data VALUES (76669, 0, 0, 0, 0, 324, 117);
INSERT INTO public.who_global_data VALUES (76670, 0, 6, 0, 0, 324, 152);
INSERT INTO public.who_global_data VALUES (76671, 0, 0, 0, 0, 324, 16);
INSERT INTO public.who_global_data VALUES (76672, 9, 34, 0, 0, 324, 10);
INSERT INTO public.who_global_data VALUES (76673, 9, 36, 0, 0, 324, 201);
INSERT INTO public.who_global_data VALUES (76674, 70, 210, 1, 2, 324, 174);
INSERT INTO public.who_global_data VALUES (76675, 0, 0, 0, 0, 324, 119);
INSERT INTO public.who_global_data VALUES (76676, 0, 0, 0, 0, 324, 168);
INSERT INTO public.who_global_data VALUES (76677, 223, 900, 0, 2, 324, 99);
INSERT INTO public.who_global_data VALUES (76678, 0, 17, 0, 0, 324, 171);
INSERT INTO public.who_global_data VALUES (76679, 0, 0, 0, 0, 324, 87);
INSERT INTO public.who_global_data VALUES (76680, 4, 52, 0, 0, 324, 123);
INSERT INTO public.who_global_data VALUES (76681, 0, 0, 0, 0, 324, 151);
INSERT INTO public.who_global_data VALUES (76682, 5, 32, 0, 0, 324, 213);
INSERT INTO public.who_global_data VALUES (76683, 0, 6, 0, 0, 324, 118);
INSERT INTO public.who_global_data VALUES (76684, 4, 11, 0, 0, 324, 134);
INSERT INTO public.who_global_data VALUES (76685, 1, 8, 0, 0, 324, 65);
INSERT INTO public.who_global_data VALUES (76686, 21, 118, 1, 1, 324, 102);
INSERT INTO public.who_global_data VALUES (76687, 0, 0, 0, 0, 324, 223);
INSERT INTO public.who_global_data VALUES (76688, 0, 9, 0, 0, 324, 4);
INSERT INTO public.who_global_data VALUES (76689, -3, 6, 0, 0, 324, 146);
INSERT INTO public.who_global_data VALUES (76690, 5, 13, 0, 0, 324, 31);
INSERT INTO public.who_global_data VALUES (76691, 0, 5, 0, 0, 324, 127);
INSERT INTO public.who_global_data VALUES (76692, 12, 65, 0, 2, 324, 22);
INSERT INTO public.who_global_data VALUES (76693, 0, 0, 0, 0, 324, 115);
INSERT INTO public.who_global_data VALUES (76694, 0, 0, 0, 0, 324, 106);
INSERT INTO public.who_global_data VALUES (76695, 1, 7, 0, 0, 324, 90);
INSERT INTO public.who_global_data VALUES (76696, 0, 0, 0, 0, 324, 70);
INSERT INTO public.who_global_data VALUES (76697, 0, 5, 0, 0, 324, 46);
INSERT INTO public.who_global_data VALUES (76698, 347, 2014, 15, 53, 324, 139);
INSERT INTO public.who_global_data VALUES (76699, 2, 2, 0, 0, 324, 42);
INSERT INTO public.who_global_data VALUES (76700, 15, 39, 0, 0, 324, 80);
INSERT INTO public.who_global_data VALUES (76701, 1, 1, 0, 0, 324, 203);
INSERT INTO public.who_global_data VALUES (76702, 5, 5, 0, 0, 324, 136);
INSERT INTO public.who_global_data VALUES (76703, 4, 16, 0, 0, 324, 63);
INSERT INTO public.who_global_data VALUES (76704, 0, 0, 0, 0, 324, 17);
INSERT INTO public.who_global_data VALUES (76705, 0, 0, 0, 0, 324, 172);
INSERT INTO public.who_global_data VALUES (76706, 4, 35, 0, 0, 324, 109);
INSERT INTO public.who_global_data VALUES (76707, 115, 1423, 0, 3, 324, 200);
INSERT INTO public.who_global_data VALUES (76708, 6, 51, 0, 0, 324, 93);
INSERT INTO public.who_global_data VALUES (76709, 6, 43, 0, 0, 324, 5);
INSERT INTO public.who_global_data VALUES (76710, 0, 716, 0, 7, 324, 214);
INSERT INTO public.who_global_data VALUES (76711, 61, 306, 2, 2, 324, 204);
INSERT INTO public.who_global_data VALUES (76712, 0, 0, 0, 0, 324, 198);
INSERT INTO public.who_global_data VALUES (76713, 19, 109, 0, 1, 324, 173);
INSERT INTO public.who_global_data VALUES (76714, 0, 0, 0, 0, 324, 229);
INSERT INTO public.who_global_data VALUES (76715, 0, 15, 0, 0, 324, 76);
INSERT INTO public.who_global_data VALUES (76716, 85, 234, 0, 0, 324, 138);
INSERT INTO public.who_global_data VALUES (76717, 26, 217, 3, 17, 324, 98);
INSERT INTO public.who_global_data VALUES (76718, 0, 0, 0, 0, 324, 103);
INSERT INTO public.who_global_data VALUES (76719, 49, 287, 0, 5, 324, 225);
INSERT INTO public.who_global_data VALUES (76720, 194, 642, 1, 2, 324, 131);
INSERT INTO public.who_global_data VALUES (76721, -3, 6, 0, 0, 324, 235);
INSERT INTO public.who_global_data VALUES (76722, 10, 456, 0, 0, 324, 137);
INSERT INTO public.who_global_data VALUES (76723, 235, 8652, 10, 94, 324, 81);
INSERT INTO public.who_global_data VALUES (76724, 6, 36, 0, 0, 324, 182);
INSERT INTO public.who_global_data VALUES (76725, 3, 19, 0, 0, 324, 145);
INSERT INTO public.who_global_data VALUES (76726, 43, 260, 0, 0, 324, 26);
INSERT INTO public.who_global_data VALUES (76727, 54, 147, 0, 0, 324, 170);
INSERT INTO public.who_global_data VALUES (76728, 0, 15, 0, 0, 324, 191);
INSERT INTO public.who_global_data VALUES (76729, 0, 0, 0, 0, 324, 221);
INSERT INTO public.who_global_data VALUES (76730, 0, 3, 0, 0, 324, 64);
INSERT INTO public.who_global_data VALUES (76731, 0, 0, 0, 0, 324, 116);
INSERT INTO public.who_global_data VALUES (76732, 0, 0, 0, 0, 324, 128);
INSERT INTO public.who_global_data VALUES (76733, 0, 6, 0, 0, 324, 6);
INSERT INTO public.who_global_data VALUES (76734, 0, 8, 0, 0, 324, 227);
INSERT INTO public.who_global_data VALUES (76735, 0, 0, 0, 0, 324, 68);
INSERT INTO public.who_global_data VALUES (76736, 0, 1, 0, 0, 324, 184);
INSERT INTO public.who_global_data VALUES (76737, 0, 0, 0, 0, 324, 82);
INSERT INTO public.who_global_data VALUES (76738, 5, 109, 3, 14, 324, 149);
INSERT INTO public.who_global_data VALUES (76739, 0, 0, 0, 0, 324, 197);
INSERT INTO public.who_global_data VALUES (76740, 0, 242, 0, 0, 324, 78);
INSERT INTO public.who_global_data VALUES (76741, 2, 42, 0, 0, 324, 233);
INSERT INTO public.who_global_data VALUES (76742, 22, 94, 0, 0, 324, 133);
INSERT INTO public.who_global_data VALUES (76743, 0, 10, 0, 0, 324, 35);
INSERT INTO public.who_global_data VALUES (76744, 0, 0, 0, 0, 324, 114);
INSERT INTO public.who_global_data VALUES (76745, 28, 345, 0, 0, 324, 237);
INSERT INTO public.who_global_data VALUES (76746, 0, 0, 0, 0, 324, 55);
INSERT INTO public.who_global_data VALUES (76747, 0, 5, 0, 0, 324, 176);
INSERT INTO public.who_global_data VALUES (76748, 10, 107, 0, 0, 324, 202);
INSERT INTO public.who_global_data VALUES (76749, 32, 318, 0, 1, 324, 155);
INSERT INTO public.who_global_data VALUES (76750, 0, 0, 0, 0, 324, 32);
INSERT INTO public.who_global_data VALUES (76751, 0, 5, 0, 0, 324, 220);
INSERT INTO public.who_global_data VALUES (76752, 34, 154, 0, 0, 324, 30);
INSERT INTO public.who_global_data VALUES (76753, 0, 0, 0, 0, 324, 147);
INSERT INTO public.who_global_data VALUES (76754, 4482, 20633, 191, 856, 324, 208);
INSERT INTO public.who_global_data VALUES (76755, 13, 59, 0, 0, 324, 45);
INSERT INTO public.who_global_data VALUES (76756, 0, 1, 0, 1, 324, 110);
INSERT INTO public.who_global_data VALUES (76757, 0, 5, 0, 0, 324, 88);
INSERT INTO public.who_global_data VALUES (76758, 119, 1265, 1, 8, 324, 51);
INSERT INTO public.who_global_data VALUES (76759, 1205, 6042, 8, 55, 324, 209);
INSERT INTO public.who_global_data VALUES (76760, 0, 0, 0, 0, 324, 205);
INSERT INTO public.who_global_data VALUES (76761, 0, 0, 0, 0, 324, 18);
INSERT INTO public.who_global_data VALUES (76762, 106, 322, 0, 1, 324, 72);
INSERT INTO public.who_global_data VALUES (76763, 769, 4427, 34, 116, 324, 44);
INSERT INTO public.who_global_data VALUES (76764, 0, 0, 0, 0, 324, 15);
INSERT INTO public.who_global_data VALUES (76765, 8, 13, 0, 0, 324, 25);
INSERT INTO public.who_global_data VALUES (76766, 0, 0, 0, 0, 324, 179);
INSERT INTO public.who_global_data VALUES (76767, 0, 0, 0, 0, 324, 34);
INSERT INTO public.who_global_data VALUES (76768, -2, 9, 0, 0, 324, 207);
INSERT INTO public.who_global_data VALUES (76769, 6, 39, 0, 0, 324, 166);
INSERT INTO public.who_global_data VALUES (76770, 93, 191, 2, 2, 324, 126);
INSERT INTO public.who_global_data VALUES (76771, 0, 0, 0, 0, 324, 97);
INSERT INTO public.who_global_data VALUES (76772, 0, 0, 0, 0, 324, 36);
INSERT INTO public.who_global_data VALUES (76773, 0, 0, 0, 0, 324, 125);
INSERT INTO public.who_global_data VALUES (76774, 0, 0, 0, 0, 324, 124);
INSERT INTO public.who_global_data VALUES (76775, 2, 16, 0, 2, 324, 185);
INSERT INTO public.who_global_data VALUES (76776, 23, 140, 0, 0, 324, 194);
INSERT INTO public.who_global_data VALUES (76777, 3, 10, 0, 0, 324, 144);
INSERT INTO public.who_global_data VALUES (76778, 3351, 10442, 50, 150, 324, 19);
INSERT INTO public.who_global_data VALUES (76779, 0, 7, 0, 0, 324, 217);
INSERT INTO public.who_global_data VALUES (76780, 46, 79, 0, 0, 324, 148);
INSERT INTO public.who_global_data VALUES (76781, 0, 4, 0, 0, 324, 86);
INSERT INTO public.who_global_data VALUES (76782, 0, 0, 0, 0, 324, 13);
INSERT INTO public.who_global_data VALUES (76783, 0, 40, 0, 0, 324, 157);
INSERT INTO public.who_global_data VALUES (76784, 15, 85, 0, 0, 324, 8);
INSERT INTO public.who_global_data VALUES (76785, 0, 0, 0, 0, 324, 73);
INSERT INTO public.who_global_data VALUES (76786, 0, 0, 0, 0, 324, 101);
INSERT INTO public.who_global_data VALUES (76787, 0, 6, 0, 0, 324, 165);
INSERT INTO public.who_global_data VALUES (76788, 0, 0, 0, 0, 324, 14);
INSERT INTO public.who_global_data VALUES (76789, 0, 26, 0, 0, 325, 193);
INSERT INTO public.who_global_data VALUES (76790, 4, 18, 0, 1, 325, 113);
INSERT INTO public.who_global_data VALUES (76791, 12, 76, 2, 6, 325, 143);
INSERT INTO public.who_global_data VALUES (76792, 0, 0, 0, 0, 325, 219);
INSERT INTO public.who_global_data VALUES (76793, 25, 39, 0, 0, 325, 186);
INSERT INTO public.who_global_data VALUES (76794, 0, 0, 0, 0, 325, 52);
INSERT INTO public.who_global_data VALUES (76795, 0, 0, 0, 0, 325, 180);
INSERT INTO public.who_global_data VALUES (76796, 0, 5, 0, 0, 325, 167);
INSERT INTO public.who_global_data VALUES (76797, 32, 101, 0, 2, 325, 154);
INSERT INTO public.who_global_data VALUES (76798, 0, 30, 0, 0, 325, 94);
INSERT INTO public.who_global_data VALUES (76799, 2, 8, 0, 0, 325, 66);
INSERT INTO public.who_global_data VALUES (76800, 96, 514, 1, 6, 325, 58);
INSERT INTO public.who_global_data VALUES (76801, 316, 1332, 0, 3, 325, 163);
INSERT INTO public.who_global_data VALUES (76802, 9, 28, 0, 0, 325, 37);
INSERT INTO public.who_global_data VALUES (76803, 2, 7, 0, 0, 325, 142);
INSERT INTO public.who_global_data VALUES (76804, 19, 260, 0, 1, 325, 83);
INSERT INTO public.who_global_data VALUES (76805, 2, 14, 0, 0, 325, 228);
INSERT INTO public.who_global_data VALUES (76806, 6, 6, 0, 0, 325, 188);
INSERT INTO public.who_global_data VALUES (76807, 0, 36, 0, 0, 325, 62);
INSERT INTO public.who_global_data VALUES (76808, 422, 2664, 10, 44, 325, 160);
INSERT INTO public.who_global_data VALUES (76809, 0, 0, 0, 0, 325, 50);
INSERT INTO public.who_global_data VALUES (76810, 0, 1, 0, 0, 325, 33);
INSERT INTO public.who_global_data VALUES (76811, 6, 6, 0, 0, 325, 183);
INSERT INTO public.who_global_data VALUES (76812, 0, 1, 0, 0, 325, 92);
INSERT INTO public.who_global_data VALUES (76813, 1, 16, 0, 0, 325, 158);
INSERT INTO public.who_global_data VALUES (76814, 0, 0, 0, 0, 325, 67);
INSERT INTO public.who_global_data VALUES (76815, 2, 21, 0, 0, 325, 57);
INSERT INTO public.who_global_data VALUES (76816, 0, 0, 0, 0, 325, 38);
INSERT INTO public.who_global_data VALUES (76817, 57, 295, 1, 1, 325, 141);
INSERT INTO public.who_global_data VALUES (76818, 0, 0, 0, 0, 325, 178);
INSERT INTO public.who_global_data VALUES (76819, 2, 60, 0, 0, 325, 108);
INSERT INTO public.who_global_data VALUES (76820, 19, 81, 0, 2, 325, 39);
INSERT INTO public.who_global_data VALUES (76821, 6, 30, 1, 1, 325, 2);
INSERT INTO public.who_global_data VALUES (76822, 0, 0, 0, 0, 325, 195);
INSERT INTO public.who_global_data VALUES (76823, 0, 0, 0, 0, 325, 107);
INSERT INTO public.who_global_data VALUES (76824, 11, 39, 0, 0, 325, 161);
INSERT INTO public.who_global_data VALUES (76825, 5, 14, 0, 0, 325, 212);
INSERT INTO public.who_global_data VALUES (76826, 145, 573, 8, 9, 325, 181);
INSERT INTO public.who_global_data VALUES (76827, 0, 5, 0, 1, 325, 53);
INSERT INTO public.who_global_data VALUES (76828, 0, 5, 0, 0, 325, 164);
INSERT INTO public.who_global_data VALUES (76829, 0, 0, 0, 0, 325, 140);
INSERT INTO public.who_global_data VALUES (76830, 82, 242, 0, 0, 325, 20);
INSERT INTO public.who_global_data VALUES (76831, 58, 81178, 11, 3242, 325, 112);
INSERT INTO public.who_global_data VALUES (76832, 48, 97, 0, 0, 325, 111);
INSERT INTO public.who_global_data VALUES (76833, 0, 0, 0, 0, 325, 71);
INSERT INTO public.who_global_data VALUES (76834, 1, 2, 0, 0, 325, 218);
INSERT INTO public.who_global_data VALUES (76835, 0, 0, 0, 0, 325, 43);
INSERT INTO public.who_global_data VALUES (76836, 9, 54, 1, 1, 325, 49);
INSERT INTO public.who_global_data VALUES (76837, 3, 13, 0, 0, 325, 1);
INSERT INTO public.who_global_data VALUES (76838, 13, 69, 0, 0, 325, 48);
INSERT INTO public.who_global_data VALUES (76839, 5, 14, 1, 1, 325, 232);
INSERT INTO public.who_global_data VALUES (76840, 0, 7, 0, 0, 325, 175);
INSERT INTO public.who_global_data VALUES (76841, 0, 40, 0, 0, 325, 21);
INSERT INTO public.who_global_data VALUES (76842, 90, 434, 0, 0, 325, 156);
INSERT INTO public.who_global_data VALUES (76843, 0, 0, 0, 0, 325, 95);
INSERT INTO public.who_global_data VALUES (76844, 4, 11, 0, 0, 325, 177);
INSERT INTO public.who_global_data VALUES (76845, 92, 1024, 3, 4, 325, 210);
INSERT INTO public.who_global_data VALUES (76846, 5, 5, 0, 0, 325, 120);
INSERT INTO public.who_global_data VALUES (76847, 0, 0, 0, 0, 325, 135);
INSERT INTO public.who_global_data VALUES (76848, 0, 25, 0, 1, 325, 206);
INSERT INTO public.who_global_data VALUES (76849, 97, 159, 0, 2, 325, 189);
INSERT INTO public.who_global_data VALUES (76850, 30, 200, 2, 6, 325, 129);
INSERT INTO public.who_global_data VALUES (76851, 0, 0, 0, 0, 325, 121);
INSERT INTO public.who_global_data VALUES (76852, 2, 7, 0, 0, 325, 59);
INSERT INTO public.who_global_data VALUES (76853, 0, 0, 0, 0, 325, 96);
INSERT INTO public.who_global_data VALUES (76854, 20, 225, 0, 0, 325, 41);
INSERT INTO public.who_global_data VALUES (76855, 0, 5, 0, 0, 325, 216);
INSERT INTO public.who_global_data VALUES (76856, 1, 10, 0, 0, 325, 236);
INSERT INTO public.who_global_data VALUES (76857, 0, 0, 0, 0, 325, 150);
INSERT INTO public.who_global_data VALUES (76858, 7, 18, 0, 0, 325, 61);
INSERT INTO public.who_global_data VALUES (76859, 0, 0, 0, 0, 325, 7);
INSERT INTO public.who_global_data VALUES (76860, 47, 319, 0, 0, 325, 169);
INSERT INTO public.who_global_data VALUES (76861, 1060, 7617, 27, 175, 325, 28);
INSERT INTO public.who_global_data VALUES (76862, 8, 15, 0, 0, 325, 85);
INSERT INTO public.who_global_data VALUES (76863, 0, 2, 0, 0, 325, 211);
INSERT INTO public.who_global_data VALUES (76864, 1, 2, 0, 0, 325, 60);
INSERT INTO public.who_global_data VALUES (76865, 5, 5, 0, 0, 325, 3);
INSERT INTO public.who_global_data VALUES (76866, 1, 34, 0, 0, 325, 11);
INSERT INTO public.who_global_data VALUES (76867, 1144, 7156, 0, 13, 325, 89);
INSERT INTO public.who_global_data VALUES (76868, 3, 13, 0, 0, 325, 24);
INSERT INTO public.who_global_data VALUES (76869, 0, 3, 0, 0, 325, 162);
INSERT INTO public.who_global_data VALUES (76870, 35, 387, 1, 5, 325, 100);
INSERT INTO public.who_global_data VALUES (76871, 2, 2, 0, 0, 325, 47);
INSERT INTO public.who_global_data VALUES (76872, 0, 0, 0, 0, 325, 29);
INSERT INTO public.who_global_data VALUES (76873, 15, 37, 0, 0, 325, 40);
INSERT INTO public.who_global_data VALUES (76874, 2, 9, 0, 0, 325, 222);
INSERT INTO public.who_global_data VALUES (76875, 0, 10, 0, 1, 325, 132);
INSERT INTO public.who_global_data VALUES (76876, 0, 1, 0, 0, 325, 130);
INSERT INTO public.who_global_data VALUES (76877, 0, 5, 0, 0, 325, 234);
INSERT INTO public.who_global_data VALUES (76878, 0, 0, 0, 0, 325, 23);
INSERT INTO public.who_global_data VALUES (76879, 1, 9, 0, 1, 325, 192);
INSERT INTO public.who_global_data VALUES (76880, 0, 0, 0, 0, 325, 69);
INSERT INTO public.who_global_data VALUES (76881, 0, 1, 0, 0, 325, 187);
INSERT INTO public.who_global_data VALUES (76882, 1, 13, 0, 0, 325, 230);
INSERT INTO public.who_global_data VALUES (76883, 0, 50, 0, 1, 325, 77);
INSERT INTO public.who_global_data VALUES (76884, 48, 247, 0, 0, 325, 9);
INSERT INTO public.who_global_data VALUES (76885, 14, 155, 0, 3, 325, 74);
INSERT INTO public.who_global_data VALUES (76886, 55, 231, 14, 19, 325, 224);
INSERT INTO public.who_global_data VALUES (76887, 1192, 17365, 147, 1135, 325, 199);
INSERT INTO public.who_global_data VALUES (76888, 10, 168, 1, 12, 325, 190);
INSERT INTO public.who_global_data VALUES (76889, 69, 292, 0, 2, 325, 12);
INSERT INTO public.who_global_data VALUES (76890, 0, 0, 0, 0, 325, 104);
INSERT INTO public.who_global_data VALUES (76891, 73, 288, 1, 1, 325, 153);
INSERT INTO public.who_global_data VALUES (76892, 3526, 31506, 347, 2505, 325, 91);
INSERT INTO public.who_global_data VALUES (76893, 1, 17, 0, 0, 325, 215);
INSERT INTO public.who_global_data VALUES (76894, 44, 877, 1, 29, 325, 84);
INSERT INTO public.who_global_data VALUES (76895, 3, 5, 0, 0, 325, 231);
INSERT INTO public.who_global_data VALUES (76896, 17, 56, 0, 0, 325, 196);
INSERT INTO public.who_global_data VALUES (76897, 2, 35, 0, 0, 325, 105);
INSERT INTO public.who_global_data VALUES (76898, 4, 11, 0, 0, 325, 122);
INSERT INTO public.who_global_data VALUES (76899, 0, 0, 0, 0, 325, 159);
INSERT INTO public.who_global_data VALUES (76900, 0, 5, 0, 0, 325, 75);
INSERT INTO public.who_global_data VALUES (76901, 12, 146, 0, 0, 325, 27);
INSERT INTO public.who_global_data VALUES (76902, 3, 3, 0, 0, 325, 54);
INSERT INTO public.who_global_data VALUES (76903, 0, 0, 0, 0, 325, 226);
INSERT INTO public.who_global_data VALUES (76904, 25, 61, 0, 0, 325, 79);
INSERT INTO public.who_global_data VALUES (76905, 0, 124, 1, 4, 325, 56);
INSERT INTO public.who_global_data VALUES (76906, 0, 0, 0, 0, 325, 117);
INSERT INTO public.who_global_data VALUES (76907, 1, 6, 0, 0, 325, 152);
INSERT INTO public.who_global_data VALUES (76908, 0, 0, 0, 0, 325, 16);
INSERT INTO public.who_global_data VALUES (76909, 6, 25, 0, 0, 325, 10);
INSERT INTO public.who_global_data VALUES (76910, 8, 27, 0, 0, 325, 201);
INSERT INTO public.who_global_data VALUES (76911, 59, 140, 0, 1, 325, 174);
INSERT INTO public.who_global_data VALUES (76912, 0, 0, 0, 0, 325, 119);
INSERT INTO public.who_global_data VALUES (76913, 0, 0, 0, 0, 325, 168);
INSERT INTO public.who_global_data VALUES (76914, 120, 677, 2, 2, 325, 99);
INSERT INTO public.who_global_data VALUES (76915, 0, 17, 0, 0, 325, 171);
INSERT INTO public.who_global_data VALUES (76916, 0, 0, 0, 0, 325, 87);
INSERT INTO public.who_global_data VALUES (76917, 10, 48, 0, 0, 325, 123);
INSERT INTO public.who_global_data VALUES (76918, 0, 0, 0, 0, 325, 151);
INSERT INTO public.who_global_data VALUES (76919, 7, 27, 0, 0, 325, 213);
INSERT INTO public.who_global_data VALUES (76920, 1, 6, 0, 0, 325, 118);
INSERT INTO public.who_global_data VALUES (76921, 7, 7, 0, 0, 325, 134);
INSERT INTO public.who_global_data VALUES (76922, 2, 7, 0, 0, 325, 65);
INSERT INTO public.who_global_data VALUES (76923, 11, 97, 0, 0, 325, 102);
INSERT INTO public.who_global_data VALUES (76924, 0, 0, 0, 0, 325, 223);
INSERT INTO public.who_global_data VALUES (76925, 0, 9, 0, 0, 325, 4);
INSERT INTO public.who_global_data VALUES (76926, 1, 9, 0, 0, 325, 146);
INSERT INTO public.who_global_data VALUES (76927, 6, 8, 0, 0, 325, 31);
INSERT INTO public.who_global_data VALUES (76928, 5, 5, 0, 0, 325, 127);
INSERT INTO public.who_global_data VALUES (76929, 11, 53, 0, 2, 325, 22);
INSERT INTO public.who_global_data VALUES (76930, 0, 0, 0, 0, 325, 115);
INSERT INTO public.who_global_data VALUES (76931, 0, 0, 0, 0, 325, 106);
INSERT INTO public.who_global_data VALUES (76932, 0, 6, 0, 0, 325, 90);
INSERT INTO public.who_global_data VALUES (76933, 0, 0, 0, 0, 325, 70);
INSERT INTO public.who_global_data VALUES (76934, 0, 5, 0, 0, 325, 46);
INSERT INTO public.who_global_data VALUES (76935, 288, 1667, 17, 38, 325, 139);
INSERT INTO public.who_global_data VALUES (76936, 0, 0, 0, 0, 325, 42);
INSERT INTO public.who_global_data VALUES (76937, 9, 24, 0, 0, 325, 80);
INSERT INTO public.who_global_data VALUES (76938, 0, 0, 0, 0, 325, 203);
INSERT INTO public.who_global_data VALUES (76939, 0, 0, 0, 0, 325, 136);
INSERT INTO public.who_global_data VALUES (76940, 6, 12, 0, 0, 325, 63);
INSERT INTO public.who_global_data VALUES (76941, 0, 0, 0, 0, 325, 17);
INSERT INTO public.who_global_data VALUES (76942, 0, 0, 0, 0, 325, 172);
INSERT INTO public.who_global_data VALUES (76943, 12, 31, 0, 0, 325, 109);
INSERT INTO public.who_global_data VALUES (76944, 139, 1308, 0, 3, 325, 200);
INSERT INTO public.who_global_data VALUES (76945, 0, 45, 0, 0, 325, 93);
INSERT INTO public.who_global_data VALUES (76946, 9, 37, 0, 0, 325, 5);
INSERT INTO public.who_global_data VALUES (76947, 0, 716, 0, 7, 325, 214);
INSERT INTO public.who_global_data VALUES (76948, 54, 245, 0, 0, 325, 204);
INSERT INTO public.who_global_data VALUES (76949, 0, 0, 0, 0, 325, 198);
INSERT INTO public.who_global_data VALUES (76950, 17, 90, 0, 1, 325, 173);
INSERT INTO public.who_global_data VALUES (76951, 0, 0, 0, 0, 325, 229);
INSERT INTO public.who_global_data VALUES (76952, 2, 15, 0, 0, 325, 76);
INSERT INTO public.who_global_data VALUES (76953, 59, 149, 0, 0, 325, 138);
INSERT INTO public.who_global_data VALUES (76954, 0, 191, 2, 14, 325, 98);
INSERT INTO public.who_global_data VALUES (76955, 0, 0, 0, 0, 325, 103);
INSERT INTO public.who_global_data VALUES (76956, 61, 238, 1, 5, 325, 225);
INSERT INTO public.who_global_data VALUES (76957, 117, 448, 1, 1, 325, 131);
INSERT INTO public.who_global_data VALUES (76958, 2, 9, 0, 0, 325, 235);
INSERT INTO public.who_global_data VALUES (76959, 0, 446, 0, 0, 325, 137);
INSERT INTO public.who_global_data VALUES (76960, 93, 8417, 3, 84, 325, 81);
INSERT INTO public.who_global_data VALUES (76961, 7, 30, 0, 0, 325, 182);
INSERT INTO public.who_global_data VALUES (76962, 3, 16, 0, 0, 325, 145);
INSERT INTO public.who_global_data VALUES (76963, 33, 217, 0, 0, 325, 26);
INSERT INTO public.who_global_data VALUES (76964, 0, 93, 0, 0, 325, 170);
INSERT INTO public.who_global_data VALUES (76965, 4, 15, 0, 0, 325, 191);
INSERT INTO public.who_global_data VALUES (76966, 0, 0, 0, 0, 325, 221);
INSERT INTO public.who_global_data VALUES (76967, 0, 3, 0, 0, 325, 64);
INSERT INTO public.who_global_data VALUES (76968, 0, 0, 0, 0, 325, 116);
INSERT INTO public.who_global_data VALUES (76969, 0, 0, 0, 0, 325, 128);
INSERT INTO public.who_global_data VALUES (76970, 0, 6, 0, 0, 325, 6);
INSERT INTO public.who_global_data VALUES (76971, 2, 8, 0, 0, 325, 227);
INSERT INTO public.who_global_data VALUES (76972, 0, 0, 0, 0, 325, 68);
INSERT INTO public.who_global_data VALUES (76973, 0, 1, 0, 0, 325, 184);
INSERT INTO public.who_global_data VALUES (76974, 0, 0, 0, 0, 325, 82);
INSERT INTO public.who_global_data VALUES (76975, 2, 104, 2, 11, 325, 149);
INSERT INTO public.who_global_data VALUES (76976, 0, 0, 0, 0, 325, 197);
INSERT INTO public.who_global_data VALUES (76977, 67, 242, 0, 0, 325, 78);
INSERT INTO public.who_global_data VALUES (76978, 9, 40, 0, 0, 325, 233);
INSERT INTO public.who_global_data VALUES (76979, 26, 72, 0, 0, 325, 133);
INSERT INTO public.who_global_data VALUES (76980, 2, 10, 0, 0, 325, 35);
INSERT INTO public.who_global_data VALUES (76981, 0, 0, 0, 0, 325, 114);
INSERT INTO public.who_global_data VALUES (76982, 47, 317, 0, 0, 325, 237);
INSERT INTO public.who_global_data VALUES (76983, 0, 0, 0, 0, 325, 55);
INSERT INTO public.who_global_data VALUES (76984, 5, 5, 0, 0, 325, 176);
INSERT INTO public.who_global_data VALUES (76985, 13, 97, 0, 0, 325, 202);
INSERT INTO public.who_global_data VALUES (76986, 10, 286, 1, 1, 325, 155);
INSERT INTO public.who_global_data VALUES (76987, 0, 0, 0, 0, 325, 32);
INSERT INTO public.who_global_data VALUES (76988, 0, 5, 0, 0, 325, 220);
INSERT INTO public.who_global_data VALUES (76989, 54, 120, 0, 0, 325, 30);
INSERT INTO public.who_global_data VALUES (76990, 0, 0, 0, 0, 325, 147);
INSERT INTO public.who_global_data VALUES (76991, 3262, 16151, 183, 665, 325, 208);
INSERT INTO public.who_global_data VALUES (76992, 13, 46, 0, 0, 325, 45);
INSERT INTO public.who_global_data VALUES (76993, 0, 1, 0, 1, 325, 110);
INSERT INTO public.who_global_data VALUES (76994, 0, 5, 0, 0, 325, 88);
INSERT INTO public.who_global_data VALUES (76995, 83, 1146, 2, 7, 325, 51);
INSERT INTO public.who_global_data VALUES (76996, 1082, 4837, 12, 47, 325, 209);
INSERT INTO public.who_global_data VALUES (76997, 0, 0, 0, 0, 325, 205);
INSERT INTO public.who_global_data VALUES (76998, 0, 0, 0, 0, 325, 18);
INSERT INTO public.who_global_data VALUES (76999, 35, 216, 0, 1, 325, 72);
INSERT INTO public.who_global_data VALUES (77000, 611, 3658, 17, 82, 325, 44);
INSERT INTO public.who_global_data VALUES (77001, 0, 0, 0, 0, 325, 15);
INSERT INTO public.who_global_data VALUES (77002, 0, 5, 0, 0, 325, 25);
INSERT INTO public.who_global_data VALUES (77003, 0, 0, 0, 0, 325, 179);
INSERT INTO public.who_global_data VALUES (77004, 0, 0, 0, 0, 325, 34);
INSERT INTO public.who_global_data VALUES (77005, 2, 11, 0, 0, 325, 207);
INSERT INTO public.who_global_data VALUES (77006, 5, 33, 0, 0, 325, 166);
INSERT INTO public.who_global_data VALUES (77007, 51, 98, 0, 0, 325, 126);
INSERT INTO public.who_global_data VALUES (77008, 0, 0, 0, 0, 325, 97);
INSERT INTO public.who_global_data VALUES (77009, 0, 0, 0, 0, 325, 36);
INSERT INTO public.who_global_data VALUES (77010, 0, 0, 0, 0, 325, 125);
INSERT INTO public.who_global_data VALUES (77011, 0, 0, 0, 0, 325, 124);
INSERT INTO public.who_global_data VALUES (77012, 11, 14, 1, 2, 325, 185);
INSERT INTO public.who_global_data VALUES (77013, 15, 117, 0, 0, 325, 194);
INSERT INTO public.who_global_data VALUES (77014, 2, 7, 0, 0, 325, 144);
INSERT INTO public.who_global_data VALUES (77015, 3551, 7091, 42, 100, 325, 19);
INSERT INTO public.who_global_data VALUES (77016, 1, 7, 0, 0, 325, 217);
INSERT INTO public.who_global_data VALUES (77017, 23, 33, 0, 0, 325, 148);
INSERT INTO public.who_global_data VALUES (77018, 0, 4, 0, 0, 325, 86);
INSERT INTO public.who_global_data VALUES (77019, 0, 0, 0, 0, 325, 13);
INSERT INTO public.who_global_data VALUES (77020, 3, 40, 0, 0, 325, 157);
INSERT INTO public.who_global_data VALUES (77021, 5, 70, 0, 0, 325, 8);
INSERT INTO public.who_global_data VALUES (77022, 0, 0, 0, 0, 325, 73);
INSERT INTO public.who_global_data VALUES (77023, 0, 0, 0, 0, 325, 101);
INSERT INTO public.who_global_data VALUES (77024, 6, 6, 0, 0, 325, 165);
INSERT INTO public.who_global_data VALUES (77025, 0, 0, 0, 0, 325, 14);
INSERT INTO public.who_global_data VALUES (77026, 1, 26, 0, 0, 326, 193);
INSERT INTO public.who_global_data VALUES (77027, 9, 14, 0, 1, 326, 113);
INSERT INTO public.who_global_data VALUES (77028, 11, 64, 0, 4, 326, 143);
INSERT INTO public.who_global_data VALUES (77029, 0, 0, 0, 0, 326, 219);
INSERT INTO public.who_global_data VALUES (77030, 12, 14, 0, 0, 326, 186);
INSERT INTO public.who_global_data VALUES (77031, 0, 0, 0, 0, 326, 52);
INSERT INTO public.who_global_data VALUES (77032, 0, 0, 0, 0, 326, 180);
INSERT INTO public.who_global_data VALUES (77033, 0, 5, 0, 0, 326, 167);
INSERT INTO public.who_global_data VALUES (77034, 9, 69, 0, 2, 326, 154);
INSERT INTO public.who_global_data VALUES (77035, 4, 30, 0, 0, 326, 94);
INSERT INTO public.who_global_data VALUES (77036, 6, 6, 0, 0, 326, 66);
INSERT INTO public.who_global_data VALUES (77037, 78, 418, 0, 5, 326, 58);
INSERT INTO public.who_global_data VALUES (77038, 156, 1016, 2, 3, 326, 163);
INSERT INTO public.who_global_data VALUES (77039, 0, 19, 0, 0, 326, 37);
INSERT INTO public.who_global_data VALUES (77040, 5, 5, 0, 0, 326, 142);
INSERT INTO public.who_global_data VALUES (77041, 16, 241, 0, 1, 326, 83);
INSERT INTO public.who_global_data VALUES (77042, 0, 12, 0, 0, 326, 228);
INSERT INTO public.who_global_data VALUES (77043, 0, 0, 0, 0, 326, 188);
INSERT INTO public.who_global_data VALUES (77044, 15, 36, 0, 0, 326, 62);
INSERT INTO public.who_global_data VALUES (77045, 387, 2242, 12, 34, 326, 160);
INSERT INTO public.who_global_data VALUES (77046, 0, 0, 0, 0, 326, 50);
INSERT INTO public.who_global_data VALUES (77047, 1, 1, 0, 0, 326, 33);
INSERT INTO public.who_global_data VALUES (77048, 0, 0, 0, 0, 326, 183);
INSERT INTO public.who_global_data VALUES (77049, 0, 1, 0, 0, 326, 92);
INSERT INTO public.who_global_data VALUES (77050, 0, 15, 0, 0, 326, 158);
INSERT INTO public.who_global_data VALUES (77051, 0, 0, 0, 0, 326, 67);
INSERT INTO public.who_global_data VALUES (77052, 1, 19, 0, 0, 326, 57);
INSERT INTO public.who_global_data VALUES (77053, 0, 0, 0, 0, 326, 38);
INSERT INTO public.who_global_data VALUES (77054, 34, 238, 0, 0, 326, 141);
INSERT INTO public.who_global_data VALUES (77055, 0, 0, 0, 0, 326, 178);
INSERT INTO public.who_global_data VALUES (77056, 4, 58, 0, 0, 326, 108);
INSERT INTO public.who_global_data VALUES (77057, 11, 62, 0, 2, 326, 39);
INSERT INTO public.who_global_data VALUES (77058, 5, 24, 0, 0, 326, 2);
INSERT INTO public.who_global_data VALUES (77059, 0, 0, 0, 0, 326, 195);
INSERT INTO public.who_global_data VALUES (77060, 0, 0, 0, 0, 326, 107);
INSERT INTO public.who_global_data VALUES (77061, 12, 28, 0, 0, 326, 161);
INSERT INTO public.who_global_data VALUES (77062, 0, 9, 0, 0, 326, 212);
INSERT INTO public.who_global_data VALUES (77063, 120, 428, 0, 1, 326, 181);
INSERT INTO public.who_global_data VALUES (77064, 0, 5, 0, 1, 326, 53);
INSERT INTO public.who_global_data VALUES (77065, 0, 5, 0, 0, 326, 164);
INSERT INTO public.who_global_data VALUES (77066, 0, 0, 0, 0, 326, 140);
INSERT INTO public.who_global_data VALUES (77067, 81, 160, 0, 0, 326, 20);
INSERT INTO public.who_global_data VALUES (77068, 39, 81120, 13, 3231, 326, 112);
INSERT INTO public.who_global_data VALUES (77069, 11, 49, 0, 0, 326, 111);
INSERT INTO public.who_global_data VALUES (77070, 0, 0, 0, 0, 326, 71);
INSERT INTO public.who_global_data VALUES (77071, 0, 1, 0, 0, 326, 218);
INSERT INTO public.who_global_data VALUES (77072, 0, 0, 0, 0, 326, 43);
INSERT INTO public.who_global_data VALUES (77073, 6, 45, 0, 0, 326, 49);
INSERT INTO public.who_global_data VALUES (77074, 3, 10, 0, 0, 326, 1);
INSERT INTO public.who_global_data VALUES (77075, 8, 56, 0, 0, 326, 48);
INSERT INTO public.who_global_data VALUES (77076, 1, 9, 0, 0, 326, 232);
INSERT INTO public.who_global_data VALUES (77077, 1, 7, 0, 0, 326, 175);
INSERT INTO public.who_global_data VALUES (77078, 10, 40, 0, 0, 326, 21);
INSERT INTO public.who_global_data VALUES (77079, 46, 344, 0, 0, 326, 156);
INSERT INTO public.who_global_data VALUES (77080, 0, 0, 0, 0, 326, 95);
INSERT INTO public.who_global_data VALUES (77081, 1, 7, 0, 0, 326, 177);
INSERT INTO public.who_global_data VALUES (77082, 57, 932, 0, 1, 326, 210);
INSERT INTO public.who_global_data VALUES (77083, 0, 0, 0, 0, 326, 120);
INSERT INTO public.who_global_data VALUES (77084, 0, 0, 0, 0, 326, 135);
INSERT INTO public.who_global_data VALUES (77085, 16, 25, 1, 1, 326, 206);
INSERT INTO public.who_global_data VALUES (77086, 21, 62, 0, 2, 326, 189);
INSERT INTO public.who_global_data VALUES (77087, 40, 170, 2, 4, 326, 129);
INSERT INTO public.who_global_data VALUES (77088, 0, 0, 0, 0, 326, 121);
INSERT INTO public.who_global_data VALUES (77089, 0, 5, 0, 0, 326, 59);
INSERT INTO public.who_global_data VALUES (77090, 0, 0, 0, 0, 326, 96);
INSERT INTO public.who_global_data VALUES (77091, 34, 205, 0, 0, 326, 41);
INSERT INTO public.who_global_data VALUES (77092, 0, 5, 0, 0, 326, 216);
INSERT INTO public.who_global_data VALUES (77093, 1, 9, 0, 0, 326, 236);
INSERT INTO public.who_global_data VALUES (77094, 0, 0, 0, 0, 326, 150);
INSERT INTO public.who_global_data VALUES (77095, 2, 11, 0, 0, 326, 61);
INSERT INTO public.who_global_data VALUES (77096, 0, 0, 0, 0, 326, 7);
INSERT INTO public.who_global_data VALUES (77097, 5, 272, 0, 0, 326, 169);
INSERT INTO public.who_global_data VALUES (77098, 1198, 6557, 21, 148, 326, 28);
INSERT INTO public.who_global_data VALUES (77099, 0, 7, 0, 0, 326, 85);
INSERT INTO public.who_global_data VALUES (77100, 0, 2, 0, 0, 326, 211);
INSERT INTO public.who_global_data VALUES (77101, 0, 1, 0, 0, 326, 60);
INSERT INTO public.who_global_data VALUES (77102, 0, 0, 0, 0, 326, 3);
INSERT INTO public.who_global_data VALUES (77103, 0, 33, 0, 0, 326, 11);
INSERT INTO public.who_global_data VALUES (77104, 1174, 6012, 1, 13, 326, 89);
INSERT INTO public.who_global_data VALUES (77105, 4, 10, 0, 0, 326, 24);
INSERT INTO public.who_global_data VALUES (77106, 2, 3, 0, 0, 326, 162);
INSERT INTO public.who_global_data VALUES (77107, 21, 352, 0, 4, 326, 100);
INSERT INTO public.who_global_data VALUES (77108, 0, 0, 0, 0, 326, 47);
INSERT INTO public.who_global_data VALUES (77109, 0, 0, 0, 0, 326, 29);
INSERT INTO public.who_global_data VALUES (77110, 12, 22, 0, 0, 326, 40);
INSERT INTO public.who_global_data VALUES (77111, 7, 7, 0, 0, 326, 222);
INSERT INTO public.who_global_data VALUES (77112, 5, 10, 0, 1, 326, 132);
INSERT INTO public.who_global_data VALUES (77113, 0, 1, 0, 0, 326, 130);
INSERT INTO public.who_global_data VALUES (77114, 0, 5, 0, 0, 326, 234);
INSERT INTO public.who_global_data VALUES (77115, 0, 0, 0, 0, 326, 23);
INSERT INTO public.who_global_data VALUES (77116, 0, 8, 0, 1, 326, 192);
INSERT INTO public.who_global_data VALUES (77117, 0, 0, 0, 0, 326, 69);
INSERT INTO public.who_global_data VALUES (77118, 0, 1, 0, 0, 326, 187);
INSERT INTO public.who_global_data VALUES (77119, 6, 12, 0, 0, 326, 230);
INSERT INTO public.who_global_data VALUES (77120, 11, 50, 0, 1, 326, 77);
INSERT INTO public.who_global_data VALUES (77121, 21, 199, 0, 0, 326, 9);
INSERT INTO public.who_global_data VALUES (77122, 23, 141, 1, 3, 326, 74);
INSERT INTO public.who_global_data VALUES (77123, 0, 176, 0, 5, 326, 224);
INSERT INTO public.who_global_data VALUES (77124, 1178, 16173, 135, 988, 326, 199);
INSERT INTO public.who_global_data VALUES (77125, 30, 158, 2, 11, 326, 190);
INSERT INTO public.who_global_data VALUES (77126, 54, 223, 0, 2, 326, 12);
INSERT INTO public.who_global_data VALUES (77127, 0, 0, 0, 0, 326, 104);
INSERT INTO public.who_global_data VALUES (77128, 39, 215, 0, 0, 326, 153);
INSERT INTO public.who_global_data VALUES (77129, 4000, 27980, 347, 2158, 326, 91);
INSERT INTO public.who_global_data VALUES (77130, 2, 16, 0, 0, 326, 215);
INSERT INTO public.who_global_data VALUES (77131, 15, 833, 4, 28, 326, 84);
INSERT INTO public.who_global_data VALUES (77132, 0, 2, 0, 0, 326, 231);
INSERT INTO public.who_global_data VALUES (77133, 29, 39, 0, 0, 326, 196);
INSERT INTO public.who_global_data VALUES (77134, 27, 33, 0, 0, 326, 105);
INSERT INTO public.who_global_data VALUES (77135, 0, 7, 0, 0, 326, 122);
INSERT INTO public.who_global_data VALUES (77136, 0, 0, 0, 0, 326, 159);
INSERT INTO public.who_global_data VALUES (77137, 0, 5, 0, 0, 326, 75);
INSERT INTO public.who_global_data VALUES (77138, 7, 134, 0, 0, 326, 27);
INSERT INTO public.who_global_data VALUES (77139, 0, 0, 0, 0, 326, 54);
INSERT INTO public.who_global_data VALUES (77140, 0, 0, 0, 0, 326, 226);
INSERT INTO public.who_global_data VALUES (77141, 5, 36, 0, 0, 326, 79);
INSERT INTO public.who_global_data VALUES (77142, 21, 124, 0, 3, 326, 56);
INSERT INTO public.who_global_data VALUES (77143, 0, 0, 0, 0, 326, 117);
INSERT INTO public.who_global_data VALUES (77144, 5, 5, 0, 0, 326, 152);
INSERT INTO public.who_global_data VALUES (77145, 0, 0, 0, 0, 326, 16);
INSERT INTO public.who_global_data VALUES (77146, 5, 19, 0, 0, 326, 10);
INSERT INTO public.who_global_data VALUES (77147, 7, 19, 0, 0, 326, 201);
INSERT INTO public.who_global_data VALUES (77148, 4, 81, 0, 1, 326, 174);
INSERT INTO public.who_global_data VALUES (77149, 0, 0, 0, 0, 326, 119);
INSERT INTO public.who_global_data VALUES (77150, 0, 0, 0, 0, 326, 168);
INSERT INTO public.who_global_data VALUES (77151, 0, 557, 0, 0, 326, 99);
INSERT INTO public.who_global_data VALUES (77152, 0, 17, 0, 0, 326, 171);
INSERT INTO public.who_global_data VALUES (77153, 0, 0, 0, 0, 326, 87);
INSERT INTO public.who_global_data VALUES (77154, 8, 38, 0, 0, 326, 123);
INSERT INTO public.who_global_data VALUES (77155, 0, 0, 0, 0, 326, 151);
INSERT INTO public.who_global_data VALUES (77156, 0, 20, 0, 0, 326, 213);
INSERT INTO public.who_global_data VALUES (77157, 0, 5, 0, 0, 326, 118);
INSERT INTO public.who_global_data VALUES (77158, 0, 0, 0, 0, 326, 134);
INSERT INTO public.who_global_data VALUES (77159, 0, 5, 0, 0, 326, 65);
INSERT INTO public.who_global_data VALUES (77160, 29, 86, 0, 0, 326, 102);
INSERT INTO public.who_global_data VALUES (77161, 0, 0, 0, 0, 326, 223);
INSERT INTO public.who_global_data VALUES (77162, 0, 9, 0, 0, 326, 4);
INSERT INTO public.who_global_data VALUES (77163, 0, 8, 0, 0, 326, 146);
INSERT INTO public.who_global_data VALUES (77164, 2, 2, 0, 0, 326, 31);
INSERT INTO public.who_global_data VALUES (77165, 0, 0, 0, 0, 326, 127);
INSERT INTO public.who_global_data VALUES (77166, 9, 42, 1, 2, 326, 22);
INSERT INTO public.who_global_data VALUES (77167, 0, 0, 0, 0, 326, 115);
INSERT INTO public.who_global_data VALUES (77168, 0, 0, 0, 0, 326, 106);
INSERT INTO public.who_global_data VALUES (77169, 0, 6, 0, 0, 326, 90);
INSERT INTO public.who_global_data VALUES (77170, 0, 0, 0, 0, 326, 70);
INSERT INTO public.who_global_data VALUES (77171, 0, 5, 0, 0, 326, 46);
INSERT INTO public.who_global_data VALUES (77172, 270, 1379, 4, 21, 326, 139);
INSERT INTO public.who_global_data VALUES (77173, 0, 0, 0, 0, 326, 42);
INSERT INTO public.who_global_data VALUES (77174, 5, 15, 0, 0, 326, 80);
INSERT INTO public.who_global_data VALUES (77175, 0, 0, 0, 0, 326, 203);
INSERT INTO public.who_global_data VALUES (77176, 0, 0, 0, 0, 326, 136);
INSERT INTO public.who_global_data VALUES (77177, 0, 6, 0, 0, 326, 63);
INSERT INTO public.who_global_data VALUES (77178, 0, 0, 0, 0, 326, 17);
INSERT INTO public.who_global_data VALUES (77179, 0, 0, 0, 0, 326, 172);
INSERT INTO public.who_global_data VALUES (77180, 6, 19, 0, 0, 326, 109);
INSERT INTO public.who_global_data VALUES (77181, 92, 1169, 2, 3, 326, 200);
INSERT INTO public.who_global_data VALUES (77182, 2, 45, 0, 0, 326, 93);
INSERT INTO public.who_global_data VALUES (77183, 2, 28, 0, 0, 326, 5);
INSERT INTO public.who_global_data VALUES (77184, 0, 716, 0, 7, 326, 214);
INSERT INTO public.who_global_data VALUES (77185, 134, 191, 0, 0, 326, 204);
INSERT INTO public.who_global_data VALUES (77186, 0, 0, 0, 0, 326, 198);
INSERT INTO public.who_global_data VALUES (77187, 26, 73, 0, 1, 326, 173);
INSERT INTO public.who_global_data VALUES (77188, 0, 0, 0, 0, 326, 229);
INSERT INTO public.who_global_data VALUES (77189, 1, 13, 0, 0, 326, 76);
INSERT INTO public.who_global_data VALUES (77190, 15, 90, 0, 0, 326, 138);
INSERT INTO public.who_global_data VALUES (77191, 45, 191, 0, 12, 326, 98);
INSERT INTO public.who_global_data VALUES (77192, 0, 0, 0, 0, 326, 103);
INSERT INTO public.who_global_data VALUES (77193, 52, 177, 1, 4, 326, 225);
INSERT INTO public.who_global_data VALUES (77194, 86, 331, 0, 0, 326, 131);
INSERT INTO public.who_global_data VALUES (77195, 0, 7, 0, 0, 326, 235);
INSERT INTO public.who_global_data VALUES (77196, 41, 446, 0, 0, 326, 137);
INSERT INTO public.who_global_data VALUES (77197, 84, 8324, 6, 81, 326, 81);
INSERT INTO public.who_global_data VALUES (77198, 0, 23, 0, 0, 326, 182);
INSERT INTO public.who_global_data VALUES (77199, 0, 13, 0, 0, 326, 145);
INSERT INTO public.who_global_data VALUES (77200, 45, 184, 0, 0, 326, 26);
INSERT INTO public.who_global_data VALUES (77201, 59, 93, 0, 0, 326, 170);
INSERT INTO public.who_global_data VALUES (77202, 2, 11, 0, 0, 326, 191);
INSERT INTO public.who_global_data VALUES (77203, 0, 0, 0, 0, 326, 221);
INSERT INTO public.who_global_data VALUES (77204, 0, 3, 0, 0, 326, 64);
INSERT INTO public.who_global_data VALUES (77205, 0, 0, 0, 0, 326, 116);
INSERT INTO public.who_global_data VALUES (77206, 0, 0, 0, 0, 326, 128);
INSERT INTO public.who_global_data VALUES (77207, 0, 6, 0, 0, 326, 6);
INSERT INTO public.who_global_data VALUES (77208, 0, 6, 0, 0, 326, 227);
INSERT INTO public.who_global_data VALUES (77209, 0, 0, 0, 0, 326, 68);
INSERT INTO public.who_global_data VALUES (77210, 0, 1, 0, 0, 326, 184);
INSERT INTO public.who_global_data VALUES (77211, 0, 0, 0, 0, 326, 82);
INSERT INTO public.who_global_data VALUES (77212, 25, 102, 4, 9, 326, 149);
INSERT INTO public.who_global_data VALUES (77213, 0, 0, 0, 0, 326, 197);
INSERT INTO public.who_global_data VALUES (77214, 38, 175, 0, 0, 326, 78);
INSERT INTO public.who_global_data VALUES (77215, 1, 31, 0, 0, 326, 233);
INSERT INTO public.who_global_data VALUES (77216, 0, 46, 0, 0, 326, 133);
INSERT INTO public.who_global_data VALUES (77217, 0, 8, 0, 0, 326, 35);
INSERT INTO public.who_global_data VALUES (77218, 0, 0, 0, 0, 326, 114);
INSERT INTO public.who_global_data VALUES (77219, 23, 270, 0, 0, 326, 237);
INSERT INTO public.who_global_data VALUES (77220, 0, 0, 0, 0, 326, 55);
INSERT INTO public.who_global_data VALUES (77221, 0, 0, 0, 0, 326, 176);
INSERT INTO public.who_global_data VALUES (77222, 23, 84, 0, 0, 326, 202);
INSERT INTO public.who_global_data VALUES (77223, 26, 276, 0, 0, 326, 155);
INSERT INTO public.who_global_data VALUES (77224, 0, 0, 0, 0, 326, 32);
INSERT INTO public.who_global_data VALUES (77225, 0, 5, 0, 0, 326, 220);
INSERT INTO public.who_global_data VALUES (77226, 11, 66, 0, 0, 326, 30);
INSERT INTO public.who_global_data VALUES (77227, 0, 0, 0, 0, 326, 147);
INSERT INTO public.who_global_data VALUES (77228, 2311, 12889, 131, 482, 326, 208);
INSERT INTO public.who_global_data VALUES (77229, 10, 33, 0, 0, 326, 45);
INSERT INTO public.who_global_data VALUES (77230, 0, 1, 0, 1, 326, 110);
INSERT INTO public.who_global_data VALUES (77231, 0, 5, 0, 0, 326, 88);
INSERT INTO public.who_global_data VALUES (77232, 69, 1063, 2, 5, 326, 51);
INSERT INTO public.who_global_data VALUES (77233, 1060, 3755, 7, 35, 326, 209);
INSERT INTO public.who_global_data VALUES (77234, 0, 0, 0, 0, 326, 205);
INSERT INTO public.who_global_data VALUES (77235, 0, 0, 0, 0, 326, 18);
INSERT INTO public.who_global_data VALUES (77236, 30, 181, 0, 1, 326, 72);
INSERT INTO public.who_global_data VALUES (77237, 442, 3047, 22, 65, 326, 44);
INSERT INTO public.who_global_data VALUES (77238, 0, 0, 0, 0, 326, 15);
INSERT INTO public.who_global_data VALUES (77239, 0, 5, 0, 0, 326, 25);
INSERT INTO public.who_global_data VALUES (77240, 0, 0, 0, 0, 326, 179);
INSERT INTO public.who_global_data VALUES (77241, 0, 0, 0, 0, 326, 34);
INSERT INTO public.who_global_data VALUES (77242, 3, 9, 0, 0, 326, 207);
INSERT INTO public.who_global_data VALUES (77243, 4, 28, 0, 0, 326, 166);
INSERT INTO public.who_global_data VALUES (77244, 29, 47, 0, 0, 326, 126);
INSERT INTO public.who_global_data VALUES (77245, 0, 0, 0, 0, 326, 97);
INSERT INTO public.who_global_data VALUES (77246, 0, 0, 0, 0, 326, 36);
INSERT INTO public.who_global_data VALUES (77247, 0, 0, 0, 0, 326, 125);
INSERT INTO public.who_global_data VALUES (77248, 0, 0, 0, 0, 326, 124);
INSERT INTO public.who_global_data VALUES (77249, 0, 3, 0, 1, 326, 185);
INSERT INTO public.who_global_data VALUES (77250, 0, 102, 0, 0, 326, 194);
INSERT INTO public.who_global_data VALUES (77251, 5, 5, 0, 0, 326, 144);
INSERT INTO public.who_global_data VALUES (77252, 1822, 3540, 17, 58, 326, 19);
INSERT INTO public.who_global_data VALUES (77253, 1, 6, 0, 0, 326, 217);
INSERT INTO public.who_global_data VALUES (77254, 2, 10, 0, 0, 326, 148);
INSERT INTO public.who_global_data VALUES (77255, 0, 4, 0, 0, 326, 86);
INSERT INTO public.who_global_data VALUES (77256, 0, 0, 0, 0, 326, 13);
INSERT INTO public.who_global_data VALUES (77257, 16, 37, 0, 0, 326, 157);
INSERT INTO public.who_global_data VALUES (77258, 4, 65, 0, 0, 326, 8);
INSERT INTO public.who_global_data VALUES (77259, 0, 0, 0, 0, 326, 73);
INSERT INTO public.who_global_data VALUES (77260, 0, 0, 0, 0, 326, 101);
INSERT INTO public.who_global_data VALUES (77261, 0, 0, 0, 0, 326, 165);
INSERT INTO public.who_global_data VALUES (77262, 0, 0, 0, 0, 326, 14);
INSERT INTO public.who_global_data VALUES (77263, 5, 25, 0, 0, 327, 193);
INSERT INTO public.who_global_data VALUES (77264, 2, 5, 0, 1, 327, 113);
INSERT INTO public.who_global_data VALUES (77265, 0, 53, 1, 4, 327, 143);
INSERT INTO public.who_global_data VALUES (77266, 0, 0, 0, 0, 327, 219);
INSERT INTO public.who_global_data VALUES (77267, 0, 2, 0, 0, 327, 186);
INSERT INTO public.who_global_data VALUES (77268, 0, 0, 0, 0, 327, 52);
INSERT INTO public.who_global_data VALUES (77269, 0, 0, 0, 0, 327, 180);
INSERT INTO public.who_global_data VALUES (77270, 0, 5, 0, 0, 327, 167);
INSERT INTO public.who_global_data VALUES (77271, 11, 60, 0, 2, 327, 154);
INSERT INTO public.who_global_data VALUES (77272, 18, 26, 0, 0, 327, 94);
INSERT INTO public.who_global_data VALUES (77273, 0, 0, 0, 0, 327, 66);
INSERT INTO public.who_global_data VALUES (77274, 38, 340, 0, 5, 327, 58);
INSERT INTO public.who_global_data VALUES (77275, 205, 860, 0, 1, 327, 163);
INSERT INTO public.who_global_data VALUES (77276, 0, 19, 0, 0, 327, 37);
INSERT INTO public.who_global_data VALUES (77277, 0, 0, 0, 0, 327, 142);
INSERT INTO public.who_global_data VALUES (77278, 7, 225, 1, 1, 327, 83);
INSERT INTO public.who_global_data VALUES (77279, 5, 12, 0, 0, 327, 228);
INSERT INTO public.who_global_data VALUES (77280, 0, 0, 0, 0, 327, 188);
INSERT INTO public.who_global_data VALUES (77281, 0, 21, 0, 0, 327, 62);
INSERT INTO public.who_global_data VALUES (77282, 214, 1855, 5, 22, 327, 160);
INSERT INTO public.who_global_data VALUES (77283, 0, 0, 0, 0, 327, 50);
INSERT INTO public.who_global_data VALUES (77284, 0, 0, 0, 0, 327, 33);
INSERT INTO public.who_global_data VALUES (77285, 0, 0, 0, 0, 327, 183);
INSERT INTO public.who_global_data VALUES (77286, 0, 1, 0, 0, 327, 92);
INSERT INTO public.who_global_data VALUES (77287, 8, 15, 0, 0, 327, 158);
INSERT INTO public.who_global_data VALUES (77288, 0, 0, 0, 0, 327, 67);
INSERT INTO public.who_global_data VALUES (77289, 5, 18, 0, 0, 327, 57);
INSERT INTO public.who_global_data VALUES (77290, 0, 0, 0, 0, 327, 38);
INSERT INTO public.who_global_data VALUES (77291, 79, 204, 0, 0, 327, 141);
INSERT INTO public.who_global_data VALUES (77292, 0, 0, 0, 0, 327, 178);
INSERT INTO public.who_global_data VALUES (77293, 10, 54, 0, 0, 327, 108);
INSERT INTO public.who_global_data VALUES (77294, 10, 51, 0, 2, 327, 39);
INSERT INTO public.who_global_data VALUES (77295, 12, 19, 0, 0, 327, 2);
INSERT INTO public.who_global_data VALUES (77296, 0, 0, 0, 0, 327, 195);
INSERT INTO public.who_global_data VALUES (77297, 0, 0, 0, 0, 327, 107);
INSERT INTO public.who_global_data VALUES (77298, 0, 16, 0, 0, 327, 161);
INSERT INTO public.who_global_data VALUES (77299, 2, 9, 0, 0, 327, 212);
INSERT INTO public.who_global_data VALUES (77300, 0, 308, 0, 1, 327, 181);
INSERT INTO public.who_global_data VALUES (77301, 0, 5, 1, 1, 327, 53);
INSERT INTO public.who_global_data VALUES (77302, 0, 5, 0, 0, 327, 164);
INSERT INTO public.who_global_data VALUES (77303, 0, 0, 0, 0, 327, 140);
INSERT INTO public.who_global_data VALUES (77304, 14, 79, 0, 0, 327, 20);
INSERT INTO public.who_global_data VALUES (77305, 29, 81081, 14, 3218, 327, 112);
INSERT INTO public.who_global_data VALUES (77306, 10, 38, 0, 0, 327, 111);
INSERT INTO public.who_global_data VALUES (77307, 0, 0, 0, 0, 327, 71);
INSERT INTO public.who_global_data VALUES (77308, 0, 1, 0, 0, 327, 218);
INSERT INTO public.who_global_data VALUES (77309, 0, 0, 0, 0, 327, 43);
INSERT INTO public.who_global_data VALUES (77310, 12, 39, 0, 0, 327, 49);
INSERT INTO public.who_global_data VALUES (77311, 0, 7, 0, 0, 327, 1);
INSERT INTO public.who_global_data VALUES (77312, 11, 48, 0, 0, 327, 48);
INSERT INTO public.who_global_data VALUES (77313, 0, 8, 0, 0, 327, 232);
INSERT INTO public.who_global_data VALUES (77314, 0, 6, 0, 0, 327, 175);
INSERT INTO public.who_global_data VALUES (77315, 9, 30, 0, 0, 327, 21);
INSERT INTO public.who_global_data VALUES (77316, 84, 298, 0, 0, 327, 156);
INSERT INTO public.who_global_data VALUES (77317, 0, 0, 0, 0, 327, 95);
INSERT INTO public.who_global_data VALUES (77318, 0, 6, 0, 0, 327, 177);
INSERT INTO public.who_global_data VALUES (77319, 48, 875, 1, 1, 327, 210);
INSERT INTO public.who_global_data VALUES (77320, 0, 0, 0, 0, 327, 120);
INSERT INTO public.who_global_data VALUES (77321, 0, 0, 0, 0, 327, 135);
INSERT INTO public.who_global_data VALUES (77322, 0, 9, 0, 0, 327, 206);
INSERT INTO public.who_global_data VALUES (77323, 14, 41, 2, 2, 327, 189);
INSERT INTO public.who_global_data VALUES (77324, 16, 130, 0, 2, 327, 129);
INSERT INTO public.who_global_data VALUES (77325, 0, 0, 0, 0, 327, 121);
INSERT INTO public.who_global_data VALUES (77326, 0, 5, 0, 0, 327, 59);
INSERT INTO public.who_global_data VALUES (77327, 0, 0, 0, 0, 327, 96);
INSERT INTO public.who_global_data VALUES (77328, 56, 171, 0, 0, 327, 41);
INSERT INTO public.who_global_data VALUES (77329, 0, 5, 0, 0, 327, 216);
INSERT INTO public.who_global_data VALUES (77330, 3, 8, 0, 0, 327, 236);
INSERT INTO public.who_global_data VALUES (77331, 0, 0, 0, 0, 327, 150);
INSERT INTO public.who_global_data VALUES (77332, 6, 9, 0, 0, 327, 61);
INSERT INTO public.who_global_data VALUES (77333, 0, 0, 0, 0, 327, 7);
INSERT INTO public.who_global_data VALUES (77334, 57, 267, 0, 0, 327, 169);
INSERT INTO public.who_global_data VALUES (77335, 923, 5359, 36, 127, 327, 28);
INSERT INTO public.who_global_data VALUES (77336, 0, 7, 0, 0, 327, 85);
INSERT INTO public.who_global_data VALUES (77337, 0, 2, 0, 0, 327, 211);
INSERT INTO public.who_global_data VALUES (77338, 0, 1, 0, 0, 327, 60);
INSERT INTO public.who_global_data VALUES (77339, 0, 0, 0, 0, 327, 3);
INSERT INTO public.who_global_data VALUES (77340, 3, 33, 0, 0, 327, 11);
INSERT INTO public.who_global_data VALUES (77341, 1043, 4838, 4, 12, 327, 89);
INSERT INTO public.who_global_data VALUES (77342, 0, 6, 0, 0, 327, 24);
INSERT INTO public.who_global_data VALUES (77343, 0, 1, 0, 0, 327, 162);
INSERT INTO public.who_global_data VALUES (77344, 103, 331, 1, 4, 327, 100);
INSERT INTO public.who_global_data VALUES (77345, 0, 0, 0, 0, 327, 47);
INSERT INTO public.who_global_data VALUES (77346, 0, 0, 0, 0, 327, 29);
INSERT INTO public.who_global_data VALUES (77347, 0, 10, 0, 0, 327, 40);
INSERT INTO public.who_global_data VALUES (77348, 0, 0, 0, 0, 327, 222);
INSERT INTO public.who_global_data VALUES (77349, 0, 5, 0, 1, 327, 132);
INSERT INTO public.who_global_data VALUES (77350, 0, 1, 0, 0, 327, 130);
INSERT INTO public.who_global_data VALUES (77351, 0, 5, 0, 0, 327, 234);
INSERT INTO public.who_global_data VALUES (77352, 0, 0, 0, 0, 327, 23);
INSERT INTO public.who_global_data VALUES (77353, 0, 8, 0, 1, 327, 192);
INSERT INTO public.who_global_data VALUES (77354, 0, 0, 0, 0, 327, 69);
INSERT INTO public.who_global_data VALUES (77355, 0, 1, 0, 0, 327, 187);
INSERT INTO public.who_global_data VALUES (77356, 0, 6, 0, 0, 327, 230);
INSERT INTO public.who_global_data VALUES (77357, 8, 39, 1, 1, 327, 77);
INSERT INTO public.who_global_data VALUES (77358, 40, 178, 0, 0, 327, 9);
INSERT INTO public.who_global_data VALUES (77359, 7, 118, 0, 2, 327, 74);
INSERT INTO public.who_global_data VALUES (77360, 55, 176, 1, 5, 327, 224);
INSERT INTO public.who_global_data VALUES (77361, 1008, 14995, 129, 853, 327, 199);
INSERT INTO public.who_global_data VALUES (77362, 0, 128, 0, 9, 327, 190);
INSERT INTO public.who_global_data VALUES (77363, 40, 169, 0, 2, 327, 12);
INSERT INTO public.who_global_data VALUES (77364, 0, 0, 0, 0, 327, 104);
INSERT INTO public.who_global_data VALUES (77365, 29, 176, 0, 0, 327, 153);
INSERT INTO public.who_global_data VALUES (77366, 2823, 23980, 370, 1811, 327, 91);
INSERT INTO public.who_global_data VALUES (77367, 2, 14, 0, 0, 327, 215);
INSERT INTO public.who_global_data VALUES (77368, 34, 818, 2, 24, 327, 84);
INSERT INTO public.who_global_data VALUES (77369, 0, 2, 0, 0, 327, 231);
INSERT INTO public.who_global_data VALUES (77370, 0, 10, 0, 0, 327, 196);
INSERT INTO public.who_global_data VALUES (77371, 0, 6, 0, 0, 327, 105);
INSERT INTO public.who_global_data VALUES (77372, 2, 7, 0, 0, 327, 122);
INSERT INTO public.who_global_data VALUES (77373, 0, 0, 0, 0, 327, 159);
INSERT INTO public.who_global_data VALUES (77374, 3, 5, 0, 0, 327, 75);
INSERT INTO public.who_global_data VALUES (77375, 11, 127, 0, 0, 327, 27);
INSERT INTO public.who_global_data VALUES (77376, 0, 0, 0, 0, 327, 54);
INSERT INTO public.who_global_data VALUES (77377, 0, 0, 0, 0, 327, 226);
INSERT INTO public.who_global_data VALUES (77378, 5, 31, 0, 0, 327, 79);
INSERT INTO public.who_global_data VALUES (77379, 0, 103, 0, 3, 327, 56);
INSERT INTO public.who_global_data VALUES (77380, 0, 0, 0, 0, 327, 117);
INSERT INTO public.who_global_data VALUES (77381, 0, 0, 0, 0, 327, 152);
INSERT INTO public.who_global_data VALUES (77382, 0, 0, 0, 0, 327, 16);
INSERT INTO public.who_global_data VALUES (77383, 3, 14, 0, 0, 327, 10);
INSERT INTO public.who_global_data VALUES (77384, 3, 12, 0, 0, 327, 201);
INSERT INTO public.who_global_data VALUES (77385, 39, 77, 0, 1, 327, 174);
INSERT INTO public.who_global_data VALUES (77386, 0, 0, 0, 0, 327, 119);
INSERT INTO public.who_global_data VALUES (77387, 0, 0, 0, 0, 327, 168);
INSERT INTO public.who_global_data VALUES (77388, 315, 557, 0, 0, 327, 99);
INSERT INTO public.who_global_data VALUES (77389, 0, 17, 0, 0, 327, 171);
INSERT INTO public.who_global_data VALUES (77390, 0, 0, 0, 0, 327, 87);
INSERT INTO public.who_global_data VALUES (77391, 11, 30, 0, 0, 327, 123);
INSERT INTO public.who_global_data VALUES (77392, 0, 0, 0, 0, 327, 151);
INSERT INTO public.who_global_data VALUES (77393, 1, 20, 0, 0, 327, 213);
INSERT INTO public.who_global_data VALUES (77394, 0, 5, 0, 0, 327, 118);
INSERT INTO public.who_global_data VALUES (77395, 0, 0, 0, 0, 327, 134);
INSERT INTO public.who_global_data VALUES (77396, 0, 5, 0, 0, 327, 65);
INSERT INTO public.who_global_data VALUES (77397, 12, 57, 0, 0, 327, 102);
INSERT INTO public.who_global_data VALUES (77398, 0, 0, 0, 0, 327, 223);
INSERT INTO public.who_global_data VALUES (77399, 2, 9, 0, 0, 327, 4);
INSERT INTO public.who_global_data VALUES (77400, 3, 8, 0, 0, 327, 146);
INSERT INTO public.who_global_data VALUES (77401, 0, 0, 0, 0, 327, 31);
INSERT INTO public.who_global_data VALUES (77402, 0, 0, 0, 0, 327, 127);
INSERT INTO public.who_global_data VALUES (77403, 1, 33, 0, 1, 327, 22);
INSERT INTO public.who_global_data VALUES (77404, 0, 0, 0, 0, 327, 115);
INSERT INTO public.who_global_data VALUES (77405, 0, 0, 0, 0, 327, 106);
INSERT INTO public.who_global_data VALUES (77406, 0, 6, 0, 0, 327, 90);
INSERT INTO public.who_global_data VALUES (77407, 0, 0, 0, 0, 327, 70);
INSERT INTO public.who_global_data VALUES (77408, 0, 5, 0, 0, 327, 46);
INSERT INTO public.who_global_data VALUES (77409, 173, 1109, 7, 17, 327, 139);
INSERT INTO public.who_global_data VALUES (77410, 0, 0, 0, 0, 327, 42);
INSERT INTO public.who_global_data VALUES (77411, 0, 10, 0, 0, 327, 80);
INSERT INTO public.who_global_data VALUES (77412, 0, 0, 0, 0, 327, 203);
INSERT INTO public.who_global_data VALUES (77413, 0, 0, 0, 0, 327, 136);
INSERT INTO public.who_global_data VALUES (77414, 0, 6, 0, 0, 327, 63);
INSERT INTO public.who_global_data VALUES (77415, 0, 0, 0, 0, 327, 17);
INSERT INTO public.who_global_data VALUES (77416, 0, 0, 0, 0, 327, 172);
INSERT INTO public.who_global_data VALUES (77417, 0, 13, 0, 0, 327, 109);
INSERT INTO public.who_global_data VALUES (77418, 170, 1077, 0, 1, 327, 200);
INSERT INTO public.who_global_data VALUES (77419, 1, 43, 0, 0, 327, 93);
INSERT INTO public.who_global_data VALUES (77420, 0, 26, 0, 0, 327, 5);
INSERT INTO public.who_global_data VALUES (77421, 0, 716, 0, 7, 327, 214);
INSERT INTO public.who_global_data VALUES (77422, 1, 57, 0, 0, 327, 204);
INSERT INTO public.who_global_data VALUES (77423, 0, 0, 0, 0, 327, 198);
INSERT INTO public.who_global_data VALUES (77424, 16, 47, 0, 1, 327, 173);
INSERT INTO public.who_global_data VALUES (77425, 0, 0, 0, 0, 327, 229);
INSERT INTO public.who_global_data VALUES (77426, 2, 12, 0, 0, 327, 76);
INSERT INTO public.who_global_data VALUES (77427, 28, 75, 0, 0, 327, 138);
INSERT INTO public.who_global_data VALUES (77428, 2, 146, 0, 12, 327, 98);
INSERT INTO public.who_global_data VALUES (77429, 0, 0, 0, 0, 327, 103);
INSERT INTO public.who_global_data VALUES (77430, 21, 125, 0, 3, 327, 225);
INSERT INTO public.who_global_data VALUES (77431, 76, 245, 0, 0, 327, 131);
INSERT INTO public.who_global_data VALUES (77432, 0, 7, 0, 0, 327, 235);
INSERT INTO public.who_global_data VALUES (77433, 64, 405, 0, 0, 327, 137);
INSERT INTO public.who_global_data VALUES (77434, 74, 8240, 0, 75, 327, 81);
INSERT INTO public.who_global_data VALUES (77435, 15, 23, 0, 0, 327, 182);
INSERT INTO public.who_global_data VALUES (77436, 0, 13, 0, 0, 327, 145);
INSERT INTO public.who_global_data VALUES (77437, 26, 139, 0, 0, 327, 26);
INSERT INTO public.who_global_data VALUES (77438, 0, 34, 0, 0, 327, 170);
INSERT INTO public.who_global_data VALUES (77439, 0, 9, 0, 0, 327, 191);
INSERT INTO public.who_global_data VALUES (77440, 0, 0, 0, 0, 327, 221);
INSERT INTO public.who_global_data VALUES (77441, 0, 3, 0, 0, 327, 64);
INSERT INTO public.who_global_data VALUES (77442, 0, 0, 0, 0, 327, 116);
INSERT INTO public.who_global_data VALUES (77443, 0, 0, 0, 0, 327, 128);
INSERT INTO public.who_global_data VALUES (77444, 0, 6, 0, 0, 327, 6);
INSERT INTO public.who_global_data VALUES (77445, 0, 6, 0, 0, 327, 227);
INSERT INTO public.who_global_data VALUES (77446, 0, 0, 0, 0, 327, 68);
INSERT INTO public.who_global_data VALUES (77447, 0, 1, 0, 0, 327, 184);
INSERT INTO public.who_global_data VALUES (77448, 0, 0, 0, 0, 327, 82);
INSERT INTO public.who_global_data VALUES (77449, 0, 77, 0, 5, 327, 149);
INSERT INTO public.who_global_data VALUES (77450, 0, 0, 0, 0, 327, 197);
INSERT INTO public.who_global_data VALUES (77451, 30, 137, 0, 0, 327, 78);
INSERT INTO public.who_global_data VALUES (77452, 0, 30, 0, 0, 327, 233);
INSERT INTO public.who_global_data VALUES (77453, 0, 46, 0, 0, 327, 133);
INSERT INTO public.who_global_data VALUES (77454, 2, 8, 0, 0, 327, 35);
INSERT INTO public.who_global_data VALUES (77455, 0, 0, 0, 0, 327, 114);
INSERT INTO public.who_global_data VALUES (77456, 17, 247, 0, 0, 327, 237);
INSERT INTO public.who_global_data VALUES (77457, 0, 0, 0, 0, 327, 55);
INSERT INTO public.who_global_data VALUES (77458, 0, 0, 0, 0, 327, 176);
INSERT INTO public.who_global_data VALUES (77459, 17, 61, 0, 0, 327, 202);
INSERT INTO public.who_global_data VALUES (77460, 35, 250, 0, 0, 327, 155);
INSERT INTO public.who_global_data VALUES (77461, 0, 0, 0, 0, 327, 32);
INSERT INTO public.who_global_data VALUES (77462, 5, 5, 0, 0, 327, 220);
INSERT INTO public.who_global_data VALUES (77463, 13, 55, 0, 0, 327, 30);
INSERT INTO public.who_global_data VALUES (77464, 0, 0, 0, 0, 327, 147);
INSERT INTO public.who_global_data VALUES (77465, 2032, 10578, 108, 351, 327, 208);
INSERT INTO public.who_global_data VALUES (77466, 8, 23, 0, 0, 327, 45);
INSERT INTO public.who_global_data VALUES (77467, 0, 1, 0, 1, 327, 110);
INSERT INTO public.who_global_data VALUES (77468, 0, 5, 0, 0, 327, 88);
INSERT INTO public.who_global_data VALUES (77469, 71, 994, 1, 3, 327, 51);
INSERT INTO public.who_global_data VALUES (77470, 325, 2695, 8, 28, 327, 209);
INSERT INTO public.who_global_data VALUES (77471, 0, 0, 0, 0, 327, 205);
INSERT INTO public.who_global_data VALUES (77472, 0, 0, 0, 0, 327, 18);
INSERT INTO public.who_global_data VALUES (77473, 33, 151, 0, 1, 327, 72);
INSERT INTO public.who_global_data VALUES (77474, 361, 2605, 14, 43, 327, 44);
INSERT INTO public.who_global_data VALUES (77475, 0, 0, 0, 0, 327, 15);
INSERT INTO public.who_global_data VALUES (77476, 0, 5, 0, 0, 327, 25);
INSERT INTO public.who_global_data VALUES (77477, 0, 0, 0, 0, 327, 179);
INSERT INTO public.who_global_data VALUES (77478, 0, 0, 0, 0, 327, 34);
INSERT INTO public.who_global_data VALUES (77479, 0, 6, 0, 0, 327, 207);
INSERT INTO public.who_global_data VALUES (77480, 2, 24, 0, 0, 327, 166);
INSERT INTO public.who_global_data VALUES (77481, 12, 18, 0, 0, 327, 126);
INSERT INTO public.who_global_data VALUES (77482, 0, 0, 0, 0, 327, 97);
INSERT INTO public.who_global_data VALUES (77483, 0, 0, 0, 0, 327, 36);
INSERT INTO public.who_global_data VALUES (77484, 0, 0, 0, 0, 327, 125);
INSERT INTO public.who_global_data VALUES (77485, 0, 0, 0, 0, 327, 124);
INSERT INTO public.who_global_data VALUES (77486, 0, 3, 0, 1, 327, 185);
INSERT INTO public.who_global_data VALUES (77487, 0, 102, 0, 0, 327, 194);
INSERT INTO public.who_global_data VALUES (77488, 0, 0, 0, 0, 327, 144);
INSERT INTO public.who_global_data VALUES (77489, 0, 1718, 0, 41, 327, 19);
INSERT INTO public.who_global_data VALUES (77490, 0, 5, 0, 0, 327, 217);
INSERT INTO public.who_global_data VALUES (77491, 0, 8, 0, 0, 327, 148);
INSERT INTO public.who_global_data VALUES (77492, 4, 4, 0, 0, 327, 86);
INSERT INTO public.who_global_data VALUES (77493, 0, 0, 0, 0, 327, 13);
INSERT INTO public.who_global_data VALUES (77494, 0, 21, 0, 0, 327, 157);
INSERT INTO public.who_global_data VALUES (77495, 4, 61, 0, 0, 327, 8);
INSERT INTO public.who_global_data VALUES (77496, 0, 0, 0, 0, 327, 73);
INSERT INTO public.who_global_data VALUES (77497, 0, 0, 0, 0, 327, 101);
INSERT INTO public.who_global_data VALUES (77498, 0, 0, 0, 0, 327, 165);
INSERT INTO public.who_global_data VALUES (77499, 0, 0, 0, 0, 327, 14);
INSERT INTO public.who_global_data VALUES (77500, 6, 20, 0, 0, 328, 193);
INSERT INTO public.who_global_data VALUES (77501, 0, 3, 0, 1, 328, 113);
INSERT INTO public.who_global_data VALUES (77502, 12, 53, 1, 3, 328, 143);
INSERT INTO public.who_global_data VALUES (77503, 0, 0, 0, 0, 328, 219);
INSERT INTO public.who_global_data VALUES (77504, 0, 2, 0, 0, 328, 186);
INSERT INTO public.who_global_data VALUES (77505, 0, 0, 0, 0, 328, 52);
INSERT INTO public.who_global_data VALUES (77506, 0, 0, 0, 0, 328, 180);
INSERT INTO public.who_global_data VALUES (77507, 0, 5, 0, 0, 328, 167);
INSERT INTO public.who_global_data VALUES (77508, 0, 49, 0, 2, 328, 154);
INSERT INTO public.who_global_data VALUES (77509, 0, 8, 0, 0, 328, 94);
INSERT INTO public.who_global_data VALUES (77510, 0, 0, 0, 0, 328, 66);
INSERT INTO public.who_global_data VALUES (77511, 101, 302, 2, 5, 328, 58);
INSERT INTO public.who_global_data VALUES (77512, 151, 655, 0, 1, 328, 163);
INSERT INTO public.who_global_data VALUES (77513, 8, 19, 0, 0, 328, 37);
INSERT INTO public.who_global_data VALUES (77514, 0, 0, 0, 0, 328, 142);
INSERT INTO public.who_global_data VALUES (77515, 3, 218, 0, 0, 328, 83);
INSERT INTO public.who_global_data VALUES (77516, 0, 7, 0, 0, 328, 228);
INSERT INTO public.who_global_data VALUES (77517, 0, 0, 0, 0, 328, 188);
INSERT INTO public.who_global_data VALUES (77518, 0, 21, 0, 0, 328, 62);
INSERT INTO public.who_global_data VALUES (77519, 179, 1641, 5, 17, 328, 160);
INSERT INTO public.who_global_data VALUES (77520, 0, 0, 0, 0, 328, 50);
INSERT INTO public.who_global_data VALUES (77521, 0, 0, 0, 0, 328, 33);
INSERT INTO public.who_global_data VALUES (77522, 0, 0, 0, 0, 328, 183);
INSERT INTO public.who_global_data VALUES (77523, 0, 1, 0, 0, 328, 92);
INSERT INTO public.who_global_data VALUES (77524, 0, 7, 0, 0, 328, 158);
INSERT INTO public.who_global_data VALUES (77525, 0, 0, 0, 0, 328, 67);
INSERT INTO public.who_global_data VALUES (77526, 0, 13, 0, 0, 328, 57);
INSERT INTO public.who_global_data VALUES (77527, 0, 0, 0, 0, 328, 38);
INSERT INTO public.who_global_data VALUES (77528, 0, 125, 0, 0, 328, 141);
INSERT INTO public.who_global_data VALUES (77529, 0, 0, 0, 0, 328, 178);
INSERT INTO public.who_global_data VALUES (77530, 15, 44, 0, 0, 328, 108);
INSERT INTO public.who_global_data VALUES (77531, 10, 41, 1, 2, 328, 39);
INSERT INTO public.who_global_data VALUES (77532, 0, 7, 0, 0, 328, 2);
INSERT INTO public.who_global_data VALUES (77533, 0, 0, 0, 0, 328, 195);
INSERT INTO public.who_global_data VALUES (77534, 0, 0, 0, 0, 328, 107);
INSERT INTO public.who_global_data VALUES (77535, 5, 16, 0, 0, 328, 161);
INSERT INTO public.who_global_data VALUES (77536, 0, 7, 0, 0, 328, 212);
INSERT INTO public.who_global_data VALUES (77537, 128, 308, 0, 1, 328, 181);
INSERT INTO public.who_global_data VALUES (77538, 0, 5, 0, 0, 328, 53);
INSERT INTO public.who_global_data VALUES (77539, 0, 5, 0, 0, 328, 164);
INSERT INTO public.who_global_data VALUES (77540, 0, 0, 0, 0, 328, 140);
INSERT INTO public.who_global_data VALUES (77541, 0, 65, 0, 0, 328, 20);
INSERT INTO public.who_global_data VALUES (77542, 27, 81052, 10, 3204, 328, 112);
INSERT INTO public.who_global_data VALUES (77543, 0, 28, 0, 0, 328, 111);
INSERT INTO public.who_global_data VALUES (77544, 0, 0, 0, 0, 328, 71);
INSERT INTO public.who_global_data VALUES (77545, 1, 1, 0, 0, 328, 218);
INSERT INTO public.who_global_data VALUES (77546, 0, 0, 0, 0, 328, 43);
INSERT INTO public.who_global_data VALUES (77547, 0, 27, 0, 0, 328, 49);
INSERT INTO public.who_global_data VALUES (77548, 0, 7, 0, 0, 328, 1);
INSERT INTO public.who_global_data VALUES (77549, 6, 37, 0, 0, 328, 48);
INSERT INTO public.who_global_data VALUES (77550, 0, 8, 0, 0, 328, 232);
INSERT INTO public.who_global_data VALUES (77551, 1, 6, 0, 0, 328, 175);
INSERT INTO public.who_global_data VALUES (77552, 7, 21, 0, 0, 328, 21);
INSERT INTO public.who_global_data VALUES (77553, 64, 214, 0, 0, 328, 156);
INSERT INTO public.who_global_data VALUES (77554, 0, 0, 0, 0, 328, 95);
INSERT INTO public.who_global_data VALUES (77555, 0, 6, 0, 0, 328, 177);
INSERT INTO public.who_global_data VALUES (77556, 23, 827, 0, 0, 328, 210);
INSERT INTO public.who_global_data VALUES (77557, 0, 0, 0, 0, 328, 120);
INSERT INTO public.who_global_data VALUES (77558, 0, 0, 0, 0, 328, 135);
INSERT INTO public.who_global_data VALUES (77559, 0, 9, 0, 0, 328, 206);
INSERT INTO public.who_global_data VALUES (77560, 0, 27, 0, 0, 328, 189);
INSERT INTO public.who_global_data VALUES (77561, 17, 114, 0, 2, 328, 129);
INSERT INTO public.who_global_data VALUES (77562, 0, 0, 0, 0, 328, 121);
INSERT INTO public.who_global_data VALUES (77563, 0, 5, 0, 0, 328, 59);
INSERT INTO public.who_global_data VALUES (77564, 0, 0, 0, 0, 328, 96);
INSERT INTO public.who_global_data VALUES (77565, 36, 115, 0, 0, 328, 41);
INSERT INTO public.who_global_data VALUES (77566, 0, 5, 0, 0, 328, 216);
INSERT INTO public.who_global_data VALUES (77567, 0, 5, 0, 0, 328, 236);
INSERT INTO public.who_global_data VALUES (77568, 0, 0, 0, 0, 328, 150);
INSERT INTO public.who_global_data VALUES (77569, 0, 3, 0, 0, 328, 61);
INSERT INTO public.who_global_data VALUES (77570, 0, 0, 0, 0, 328, 7);
INSERT INTO public.who_global_data VALUES (77571, 27, 210, 0, 0, 328, 169);
INSERT INTO public.who_global_data VALUES (77572, 825, 4436, 12, 91, 328, 28);
INSERT INTO public.who_global_data VALUES (77573, 0, 7, 0, 0, 328, 85);
INSERT INTO public.who_global_data VALUES (77574, 1, 2, 0, 0, 328, 211);
INSERT INTO public.who_global_data VALUES (77575, 0, 1, 0, 0, 328, 60);
INSERT INTO public.who_global_data VALUES (77576, 0, 0, 0, 0, 328, 3);
INSERT INTO public.who_global_data VALUES (77577, 5, 30, 0, 0, 328, 11);
INSERT INTO public.who_global_data VALUES (77578, 733, 3795, 3, 8, 328, 89);
INSERT INTO public.who_global_data VALUES (77579, 1, 6, 0, 0, 328, 24);
INSERT INTO public.who_global_data VALUES (77580, 0, 1, 0, 0, 328, 162);
INSERT INTO public.who_global_data VALUES (77581, 38, 228, 2, 3, 328, 100);
INSERT INTO public.who_global_data VALUES (77582, 0, 0, 0, 0, 328, 47);
INSERT INTO public.who_global_data VALUES (77583, 0, 0, 0, 0, 328, 29);
INSERT INTO public.who_global_data VALUES (77584, 3, 10, 0, 0, 328, 40);
INSERT INTO public.who_global_data VALUES (77585, 0, 0, 0, 0, 328, 222);
INSERT INTO public.who_global_data VALUES (77586, 5, 5, 1, 1, 328, 132);
INSERT INTO public.who_global_data VALUES (77587, 0, 1, 0, 0, 328, 130);
INSERT INTO public.who_global_data VALUES (77588, 0, 5, 0, 0, 328, 234);
INSERT INTO public.who_global_data VALUES (77589, 0, 0, 0, 0, 328, 23);
INSERT INTO public.who_global_data VALUES (77590, 3, 8, 0, 1, 328, 192);
INSERT INTO public.who_global_data VALUES (77591, 0, 0, 0, 0, 328, 69);
INSERT INTO public.who_global_data VALUES (77592, 0, 1, 0, 0, 328, 187);
INSERT INTO public.who_global_data VALUES (77593, 0, 6, 0, 0, 328, 230);
INSERT INTO public.who_global_data VALUES (77594, 6, 31, 0, 0, 328, 77);
INSERT INTO public.who_global_data VALUES (77595, 21, 138, 0, 0, 328, 9);
INSERT INTO public.who_global_data VALUES (77596, 23, 111, 0, 2, 328, 74);
INSERT INTO public.who_global_data VALUES (77597, 48, 121, 0, 4, 328, 224);
INSERT INTO public.who_global_data VALUES (77598, 1254, 13987, 116, 724, 328, 199);
INSERT INTO public.who_global_data VALUES (77599, 31, 128, 0, 9, 328, 190);
INSERT INTO public.who_global_data VALUES (77600, 38, 129, 1, 2, 328, 12);
INSERT INTO public.who_global_data VALUES (77601, 0, 0, 0, 0, 328, 104);
INSERT INTO public.who_global_data VALUES (77602, 35, 147, 0, 0, 328, 153);
INSERT INTO public.who_global_data VALUES (77603, 3497, 21157, 173, 1441, 328, 91);
INSERT INTO public.who_global_data VALUES (77604, 0, 12, 0, 0, 328, 215);
INSERT INTO public.who_global_data VALUES (77605, 0, 784, 0, 22, 328, 84);
INSERT INTO public.who_global_data VALUES (77606, 0, 2, 0, 0, 328, 231);
INSERT INTO public.who_global_data VALUES (77607, 5, 10, 0, 0, 328, 196);
INSERT INTO public.who_global_data VALUES (77608, 0, 6, 0, 0, 328, 105);
INSERT INTO public.who_global_data VALUES (77609, 0, 5, 0, 0, 328, 122);
INSERT INTO public.who_global_data VALUES (77610, 0, 0, 0, 0, 328, 159);
INSERT INTO public.who_global_data VALUES (77611, 0, 2, 0, 0, 328, 75);
INSERT INTO public.who_global_data VALUES (77612, 8, 116, 0, 0, 328, 27);
INSERT INTO public.who_global_data VALUES (77613, 0, 0, 0, 0, 328, 54);
INSERT INTO public.who_global_data VALUES (77614, 0, 0, 0, 0, 328, 226);
INSERT INTO public.who_global_data VALUES (77615, 7, 26, 0, 0, 328, 79);
INSERT INTO public.who_global_data VALUES (77616, 6, 103, 0, 3, 328, 56);
INSERT INTO public.who_global_data VALUES (77617, 0, 0, 0, 0, 328, 117);
INSERT INTO public.who_global_data VALUES (77618, 0, 0, 0, 0, 328, 152);
INSERT INTO public.who_global_data VALUES (77619, 0, 0, 0, 0, 328, 16);
INSERT INTO public.who_global_data VALUES (77620, 4, 11, 0, 0, 328, 10);
INSERT INTO public.who_global_data VALUES (77621, 3, 9, 0, 0, 328, 201);
INSERT INTO public.who_global_data VALUES (77622, 0, 38, 0, 1, 328, 174);
INSERT INTO public.who_global_data VALUES (77623, 0, 0, 0, 0, 328, 119);
INSERT INTO public.who_global_data VALUES (77624, 0, 0, 0, 0, 328, 168);
INSERT INTO public.who_global_data VALUES (77625, 41, 242, 0, 0, 328, 99);
INSERT INTO public.who_global_data VALUES (77626, 4, 17, 0, 0, 328, 171);
INSERT INTO public.who_global_data VALUES (77627, 0, 0, 0, 0, 328, 87);
INSERT INTO public.who_global_data VALUES (77628, 1, 19, 0, 0, 328, 123);
INSERT INTO public.who_global_data VALUES (77629, 0, 0, 0, 0, 328, 151);
INSERT INTO public.who_global_data VALUES (77630, 5, 19, 0, 0, 328, 213);
INSERT INTO public.who_global_data VALUES (77631, 0, 5, 0, 0, 328, 118);
INSERT INTO public.who_global_data VALUES (77632, 0, 0, 0, 0, 328, 134);
INSERT INTO public.who_global_data VALUES (77633, 0, 5, 0, 0, 328, 65);
INSERT INTO public.who_global_data VALUES (77634, 15, 45, 0, 0, 328, 102);
INSERT INTO public.who_global_data VALUES (77635, 0, 0, 0, 0, 328, 223);
INSERT INTO public.who_global_data VALUES (77636, 4, 7, 0, 0, 328, 4);
INSERT INTO public.who_global_data VALUES (77637, 0, 5, 0, 0, 328, 146);
INSERT INTO public.who_global_data VALUES (77638, 0, 0, 0, 0, 328, 31);
INSERT INTO public.who_global_data VALUES (77639, 0, 0, 0, 0, 328, 127);
INSERT INTO public.who_global_data VALUES (77640, 10, 32, 0, 1, 328, 22);
INSERT INTO public.who_global_data VALUES (77641, 0, 0, 0, 0, 328, 115);
INSERT INTO public.who_global_data VALUES (77642, 0, 0, 0, 0, 328, 106);
INSERT INTO public.who_global_data VALUES (77643, 0, 6, 0, 0, 328, 90);
INSERT INTO public.who_global_data VALUES (77644, 0, 0, 0, 0, 328, 70);
INSERT INTO public.who_global_data VALUES (77645, 0, 5, 0, 0, 328, 46);
INSERT INTO public.who_global_data VALUES (77646, 219, 936, 4, 10, 328, 139);
INSERT INTO public.who_global_data VALUES (77647, 0, 0, 0, 0, 328, 42);
INSERT INTO public.who_global_data VALUES (77648, 0, 10, 0, 0, 328, 80);
INSERT INTO public.who_global_data VALUES (77649, 0, 0, 0, 0, 328, 203);
INSERT INTO public.who_global_data VALUES (77650, 0, 0, 0, 0, 328, 136);
INSERT INTO public.who_global_data VALUES (77651, 0, 6, 0, 0, 328, 63);
INSERT INTO public.who_global_data VALUES (77652, 0, 0, 0, 0, 328, 17);
INSERT INTO public.who_global_data VALUES (77653, 0, 0, 0, 0, 328, 172);
INSERT INTO public.who_global_data VALUES (77654, 4, 13, 0, 0, 328, 109);
INSERT INTO public.who_global_data VALUES (77655, 286, 907, 0, 1, 328, 200);
INSERT INTO public.who_global_data VALUES (77656, 0, 42, 0, 0, 328, 93);
INSERT INTO public.who_global_data VALUES (77657, 2, 26, 0, 0, 328, 5);
INSERT INTO public.who_global_data VALUES (77658, 15, 716, 0, 7, 328, 214);
INSERT INTO public.who_global_data VALUES (77659, 24, 56, 0, 0, 328, 204);
INSERT INTO public.who_global_data VALUES (77660, 0, 0, 0, 0, 328, 198);
INSERT INTO public.who_global_data VALUES (77661, 0, 31, 0, 1, 328, 173);
INSERT INTO public.who_global_data VALUES (77662, 0, 0, 0, 0, 328, 229);
INSERT INTO public.who_global_data VALUES (77663, 0, 10, 0, 0, 328, 76);
INSERT INTO public.who_global_data VALUES (77664, 15, 47, 0, 0, 328, 138);
INSERT INTO public.who_global_data VALUES (77665, 76, 144, 10, 12, 328, 98);
INSERT INTO public.who_global_data VALUES (77666, 0, 0, 0, 0, 328, 103);
INSERT INTO public.who_global_data VALUES (77667, 36, 104, 1, 3, 328, 225);
INSERT INTO public.who_global_data VALUES (77668, 57, 169, 0, 0, 328, 131);
INSERT INTO public.who_global_data VALUES (77669, 0, 7, 0, 0, 328, 235);
INSERT INTO public.who_global_data VALUES (77670, 0, 341, 0, 0, 328, 137);
INSERT INTO public.who_global_data VALUES (77671, 76, 8166, 3, 75, 328, 81);
INSERT INTO public.who_global_data VALUES (77672, 0, 8, 0, 0, 328, 182);
INSERT INTO public.who_global_data VALUES (77673, 3, 13, 0, 0, 328, 145);
INSERT INTO public.who_global_data VALUES (77674, 24, 113, 0, 0, 328, 26);
INSERT INTO public.who_global_data VALUES (77675, 0, 34, 0, 0, 328, 170);
INSERT INTO public.who_global_data VALUES (77676, 9, 9, 0, 0, 328, 191);
INSERT INTO public.who_global_data VALUES (77677, 0, 0, 0, 0, 328, 221);
INSERT INTO public.who_global_data VALUES (77678, 2, 3, 0, 0, 328, 64);
INSERT INTO public.who_global_data VALUES (77679, 0, 0, 0, 0, 328, 116);
INSERT INTO public.who_global_data VALUES (77680, 0, 0, 0, 0, 328, 128);
INSERT INTO public.who_global_data VALUES (77681, 6, 6, 0, 0, 328, 6);
INSERT INTO public.who_global_data VALUES (77682, 0, 6, 0, 0, 328, 227);
INSERT INTO public.who_global_data VALUES (77683, 0, 0, 0, 0, 328, 68);
INSERT INTO public.who_global_data VALUES (77684, 0, 1, 0, 0, 328, 184);
INSERT INTO public.who_global_data VALUES (77685, 0, 0, 0, 0, 328, 82);
INSERT INTO public.who_global_data VALUES (77686, 0, 77, 0, 5, 328, 149);
INSERT INTO public.who_global_data VALUES (77687, 0, 0, 0, 0, 328, 197);
INSERT INTO public.who_global_data VALUES (77688, 0, 107, 0, 0, 328, 78);
INSERT INTO public.who_global_data VALUES (77689, 5, 30, 0, 0, 328, 233);
INSERT INTO public.who_global_data VALUES (77690, 32, 46, 0, 0, 328, 133);
INSERT INTO public.who_global_data VALUES (77691, 6, 6, 0, 0, 328, 35);
INSERT INTO public.who_global_data VALUES (77692, 0, 0, 0, 0, 328, 114);
INSERT INTO public.who_global_data VALUES (77693, 14, 230, 0, 0, 328, 237);
INSERT INTO public.who_global_data VALUES (77694, 0, 0, 0, 0, 328, 55);
INSERT INTO public.who_global_data VALUES (77695, 0, 0, 0, 0, 328, 176);
INSERT INTO public.who_global_data VALUES (77696, 14, 44, 0, 0, 328, 202);
INSERT INTO public.who_global_data VALUES (77697, 36, 215, 0, 0, 328, 155);
INSERT INTO public.who_global_data VALUES (77698, 0, 0, 0, 0, 328, 32);
INSERT INTO public.who_global_data VALUES (77699, 0, 0, 0, 0, 328, 220);
INSERT INTO public.who_global_data VALUES (77700, 0, 42, 0, 0, 328, 30);
INSERT INTO public.who_global_data VALUES (77701, 0, 0, 0, 0, 328, 147);
INSERT INTO public.who_global_data VALUES (77702, 2178, 8546, 79, 243, 328, 208);
INSERT INTO public.who_global_data VALUES (77703, 5, 15, 0, 0, 328, 45);
INSERT INTO public.who_global_data VALUES (77704, 0, 1, 1, 1, 328, 110);
INSERT INTO public.who_global_data VALUES (77705, 5, 5, 0, 0, 328, 88);
INSERT INTO public.who_global_data VALUES (77706, 152, 923, 1, 2, 328, 51);
INSERT INTO public.who_global_data VALUES (77707, 416, 2370, 5, 20, 328, 209);
INSERT INTO public.who_global_data VALUES (77708, 0, 0, 0, 0, 328, 205);
INSERT INTO public.who_global_data VALUES (77709, 0, 0, 0, 0, 328, 18);
INSERT INTO public.who_global_data VALUES (77710, 39, 118, 0, 1, 328, 72);
INSERT INTO public.who_global_data VALUES (77711, 478, 2244, 19, 29, 328, 44);
INSERT INTO public.who_global_data VALUES (77712, 0, 0, 0, 0, 328, 15);
INSERT INTO public.who_global_data VALUES (77713, 0, 5, 0, 0, 328, 25);
INSERT INTO public.who_global_data VALUES (77714, 0, 0, 0, 0, 328, 179);
INSERT INTO public.who_global_data VALUES (77715, 0, 0, 0, 0, 328, 34);
INSERT INTO public.who_global_data VALUES (77716, 1, 6, 0, 0, 328, 207);
INSERT INTO public.who_global_data VALUES (77717, 2, 22, 0, 0, 328, 166);
INSERT INTO public.who_global_data VALUES (77718, 1, 6, 0, 0, 328, 126);
INSERT INTO public.who_global_data VALUES (77719, 0, 0, 0, 0, 328, 97);
INSERT INTO public.who_global_data VALUES (77720, 0, 0, 0, 0, 328, 36);
INSERT INTO public.who_global_data VALUES (77721, 0, 0, 0, 0, 328, 125);
INSERT INTO public.who_global_data VALUES (77722, 0, 0, 0, 0, 328, 124);
INSERT INTO public.who_global_data VALUES (77723, 0, 3, 0, 1, 328, 185);
INSERT INTO public.who_global_data VALUES (77724, 13, 102, 0, 0, 328, 194);
INSERT INTO public.who_global_data VALUES (77725, 0, 0, 0, 0, 328, 144);
INSERT INTO public.who_global_data VALUES (77726, 36, 1718, 0, 41, 328, 19);
INSERT INTO public.who_global_data VALUES (77727, 0, 5, 0, 0, 328, 217);
INSERT INTO public.who_global_data VALUES (77728, 8, 8, 0, 0, 328, 148);
INSERT INTO public.who_global_data VALUES (77729, 0, 0, 0, 0, 328, 86);
INSERT INTO public.who_global_data VALUES (77730, 0, 0, 0, 0, 328, 13);
INSERT INTO public.who_global_data VALUES (77731, 15, 21, 0, 0, 328, 157);
INSERT INTO public.who_global_data VALUES (77732, 5, 57, 0, 0, 328, 8);
INSERT INTO public.who_global_data VALUES (77733, 0, 0, 0, 0, 328, 73);
INSERT INTO public.who_global_data VALUES (77734, 0, 0, 0, 0, 328, 101);
INSERT INTO public.who_global_data VALUES (77735, 0, 0, 0, 0, 328, 165);
INSERT INTO public.who_global_data VALUES (77736, 0, 0, 0, 0, 328, 14);
INSERT INTO public.who_global_data VALUES (77737, 3, 14, 0, 0, 329, 193);
INSERT INTO public.who_global_data VALUES (77738, 0, 3, 0, 1, 329, 113);
INSERT INTO public.who_global_data VALUES (77739, 12, 41, 1, 2, 329, 143);
INSERT INTO public.who_global_data VALUES (77740, 0, 0, 0, 0, 329, 219);
INSERT INTO public.who_global_data VALUES (77741, 1, 2, 0, 0, 329, 186);
INSERT INTO public.who_global_data VALUES (77742, 0, 0, 0, 0, 329, 52);
INSERT INTO public.who_global_data VALUES (77743, 0, 0, 0, 0, 329, 180);
INSERT INTO public.who_global_data VALUES (77744, 0, 5, 0, 0, 329, 167);
INSERT INTO public.who_global_data VALUES (77745, 14, 49, 1, 2, 329, 154);
INSERT INTO public.who_global_data VALUES (77746, 7, 8, 0, 0, 329, 94);
INSERT INTO public.who_global_data VALUES (77747, 0, 0, 0, 0, 329, 66);
INSERT INTO public.who_global_data VALUES (77748, 8, 201, 0, 3, 329, 58);
INSERT INTO public.who_global_data VALUES (77749, 143, 504, 0, 1, 329, 163);
INSERT INTO public.who_global_data VALUES (77750, 0, 11, 0, 0, 329, 37);
INSERT INTO public.who_global_data VALUES (77751, 0, 0, 0, 0, 329, 142);
INSERT INTO public.who_global_data VALUES (77752, 16, 215, 0, 0, 329, 83);
INSERT INTO public.who_global_data VALUES (77753, 0, 7, 0, 0, 329, 228);
INSERT INTO public.who_global_data VALUES (77754, 0, 0, 0, 0, 329, 188);
INSERT INTO public.who_global_data VALUES (77755, 9, 21, 0, 0, 329, 62);
INSERT INTO public.who_global_data VALUES (77756, 338, 1462, 3, 12, 329, 160);
INSERT INTO public.who_global_data VALUES (77757, 0, 0, 0, 0, 329, 50);
INSERT INTO public.who_global_data VALUES (77758, 0, 0, 0, 0, 329, 33);
INSERT INTO public.who_global_data VALUES (77759, 0, 0, 0, 0, 329, 183);
INSERT INTO public.who_global_data VALUES (77760, 0, 1, 0, 0, 329, 92);
INSERT INTO public.who_global_data VALUES (77761, 0, 7, 0, 0, 329, 158);
INSERT INTO public.who_global_data VALUES (77762, 0, 0, 0, 0, 329, 67);
INSERT INTO public.who_global_data VALUES (77763, 8, 13, 0, 0, 329, 57);
INSERT INTO public.who_global_data VALUES (77764, 0, 0, 0, 0, 329, 38);
INSERT INTO public.who_global_data VALUES (77765, 23, 125, 0, 0, 329, 141);
INSERT INTO public.who_global_data VALUES (77766, 0, 0, 0, 0, 329, 178);
INSERT INTO public.who_global_data VALUES (77767, 13, 29, 0, 0, 329, 108);
INSERT INTO public.who_global_data VALUES (77768, 8, 31, 0, 1, 329, 39);
INSERT INTO public.who_global_data VALUES (77769, 1, 7, 0, 0, 329, 2);
INSERT INTO public.who_global_data VALUES (77770, 0, 0, 0, 0, 329, 195);
INSERT INTO public.who_global_data VALUES (77771, 0, 0, 0, 0, 329, 107);
INSERT INTO public.who_global_data VALUES (77772, 2, 11, 0, 0, 329, 161);
INSERT INTO public.who_global_data VALUES (77773, 1, 7, 0, 0, 329, 212);
INSERT INTO public.who_global_data VALUES (77774, 24, 180, 0, 1, 329, 181);
INSERT INTO public.who_global_data VALUES (77775, 0, 5, 0, 0, 329, 53);
INSERT INTO public.who_global_data VALUES (77776, 5, 5, 0, 0, 329, 164);
INSERT INTO public.who_global_data VALUES (77777, 0, 0, 0, 0, 329, 140);
INSERT INTO public.who_global_data VALUES (77778, 18, 65, 0, 0, 329, 20);
INSERT INTO public.who_global_data VALUES (77779, 30, 81025, 14, 3194, 329, 112);
INSERT INTO public.who_global_data VALUES (77780, 8, 28, 0, 0, 329, 111);
INSERT INTO public.who_global_data VALUES (77781, 0, 0, 0, 0, 329, 71);
INSERT INTO public.who_global_data VALUES (77782, 0, 0, 0, 0, 329, 218);
INSERT INTO public.who_global_data VALUES (77783, 0, 0, 0, 0, 329, 43);
INSERT INTO public.who_global_data VALUES (77784, 0, 27, 0, 0, 329, 49);
INSERT INTO public.who_global_data VALUES (77785, 2, 7, 0, 0, 329, 1);
INSERT INTO public.who_global_data VALUES (77786, 6, 31, 0, 0, 329, 48);
INSERT INTO public.who_global_data VALUES (77787, 0, 8, 0, 0, 329, 232);
INSERT INTO public.who_global_data VALUES (77788, 0, 5, 0, 0, 329, 175);
INSERT INTO public.who_global_data VALUES (77789, 8, 14, 0, 0, 329, 21);
INSERT INTO public.who_global_data VALUES (77790, 34, 150, 0, 0, 329, 156);
INSERT INTO public.who_global_data VALUES (77791, 0, 0, 0, 0, 329, 95);
INSERT INTO public.who_global_data VALUES (77792, 1, 6, 0, 0, 329, 177);
INSERT INTO public.who_global_data VALUES (77793, 128, 804, 0, 0, 329, 210);
INSERT INTO public.who_global_data VALUES (77794, 0, 0, 0, 0, 329, 120);
INSERT INTO public.who_global_data VALUES (77795, 0, 0, 0, 0, 329, 135);
INSERT INTO public.who_global_data VALUES (77796, 0, 9, 0, 0, 329, 206);
INSERT INTO public.who_global_data VALUES (77797, 0, 27, 0, 0, 329, 189);
INSERT INTO public.who_global_data VALUES (77798, 26, 97, 1, 2, 329, 129);
INSERT INTO public.who_global_data VALUES (77799, 0, 0, 0, 0, 329, 121);
INSERT INTO public.who_global_data VALUES (77800, 5, 5, 0, 0, 329, 59);
INSERT INTO public.who_global_data VALUES (77801, 0, 0, 0, 0, 329, 96);
INSERT INTO public.who_global_data VALUES (77802, 52, 79, 0, 0, 329, 41);
INSERT INTO public.who_global_data VALUES (77803, 5, 5, 0, 0, 329, 216);
INSERT INTO public.who_global_data VALUES (77804, 5, 5, 0, 0, 329, 236);
INSERT INTO public.who_global_data VALUES (77805, 0, 0, 0, 0, 329, 150);
INSERT INTO public.who_global_data VALUES (77806, 0, 3, 0, 0, 329, 61);
INSERT INTO public.who_global_data VALUES (77807, 0, 0, 0, 0, 329, 7);
INSERT INTO public.who_global_data VALUES (77808, 28, 183, 0, 0, 329, 169);
INSERT INTO public.who_global_data VALUES (77809, 763, 3611, 18, 79, 329, 28);
INSERT INTO public.who_global_data VALUES (77810, 1, 7, 0, 0, 329, 85);
INSERT INTO public.who_global_data VALUES (77811, 0, 1, 0, 0, 329, 211);
INSERT INTO public.who_global_data VALUES (77812, 1, 1, 0, 0, 329, 60);
INSERT INTO public.who_global_data VALUES (77813, 0, 0, 0, 0, 329, 3);
INSERT INTO public.who_global_data VALUES (77814, 0, 25, 0, 0, 329, 11);
INSERT INTO public.who_global_data VALUES (77815, 693, 3062, 0, 5, 329, 89);
INSERT INTO public.who_global_data VALUES (77816, 5, 5, 0, 0, 329, 24);
INSERT INTO public.who_global_data VALUES (77817, 0, 1, 0, 0, 329, 162);
INSERT INTO public.who_global_data VALUES (77818, 57, 190, 0, 1, 329, 100);
INSERT INTO public.who_global_data VALUES (77819, 0, 0, 0, 0, 329, 47);
INSERT INTO public.who_global_data VALUES (77820, 0, 0, 0, 0, 329, 29);
INSERT INTO public.who_global_data VALUES (77821, 7, 7, 0, 0, 329, 40);
INSERT INTO public.who_global_data VALUES (77822, 0, 0, 0, 0, 329, 222);
INSERT INTO public.who_global_data VALUES (77823, 0, 0, 0, 0, 329, 132);
INSERT INTO public.who_global_data VALUES (77824, 0, 1, 0, 0, 329, 130);
INSERT INTO public.who_global_data VALUES (77825, 5, 5, 0, 0, 329, 234);
INSERT INTO public.who_global_data VALUES (77826, 0, 0, 0, 0, 329, 23);
INSERT INTO public.who_global_data VALUES (77827, 0, 5, 0, 1, 329, 192);
INSERT INTO public.who_global_data VALUES (77828, 0, 0, 0, 0, 329, 69);
INSERT INTO public.who_global_data VALUES (77829, 0, 1, 0, 0, 329, 187);
INSERT INTO public.who_global_data VALUES (77830, 0, 6, 0, 0, 329, 230);
INSERT INTO public.who_global_data VALUES (77831, 9, 25, 0, 0, 329, 77);
INSERT INTO public.who_global_data VALUES (77832, 0, 117, 0, 0, 329, 9);
INSERT INTO public.who_global_data VALUES (77833, 3, 88, 1, 2, 329, 74);
INSERT INTO public.who_global_data VALUES (77834, 0, 73, 0, 4, 329, 224);
INSERT INTO public.who_global_data VALUES (77835, 1365, 12733, 94, 608, 329, 199);
INSERT INTO public.who_global_data VALUES (77836, 23, 97, 2, 9, 329, 190);
INSERT INTO public.who_global_data VALUES (77837, 21, 91, 0, 1, 329, 12);
INSERT INTO public.who_global_data VALUES (77838, 0, 0, 0, 0, 329, 104);
INSERT INTO public.who_global_data VALUES (77839, 22, 112, 0, 0, 329, 153);
INSERT INTO public.who_global_data VALUES (77840, 2547, 17660, 252, 1268, 329, 91);
INSERT INTO public.who_global_data VALUES (77841, 6, 12, 0, 0, 329, 215);
INSERT INTO public.who_global_data VALUES (77842, 105, 784, 3, 22, 329, 84);
INSERT INTO public.who_global_data VALUES (77843, 0, 2, 0, 0, 329, 231);
INSERT INTO public.who_global_data VALUES (77844, 0, 5, 0, 0, 329, 196);
INSERT INTO public.who_global_data VALUES (77845, 4, 6, 0, 0, 329, 105);
INSERT INTO public.who_global_data VALUES (77846, 5, 5, 0, 0, 329, 122);
INSERT INTO public.who_global_data VALUES (77847, 0, 0, 0, 0, 329, 159);
INSERT INTO public.who_global_data VALUES (77848, 0, 2, 0, 0, 329, 75);
INSERT INTO public.who_global_data VALUES (77849, 4, 108, 0, 0, 329, 27);
INSERT INTO public.who_global_data VALUES (77850, 0, 0, 0, 0, 329, 54);
INSERT INTO public.who_global_data VALUES (77851, 0, 0, 0, 0, 329, 226);
INSERT INTO public.who_global_data VALUES (77852, 3, 19, 0, 0, 329, 79);
INSERT INTO public.who_global_data VALUES (77853, 27, 97, 0, 3, 329, 56);
INSERT INTO public.who_global_data VALUES (77854, 0, 0, 0, 0, 329, 117);
INSERT INTO public.who_global_data VALUES (77855, 0, 0, 0, 0, 329, 152);
INSERT INTO public.who_global_data VALUES (77856, 0, 0, 0, 0, 329, 16);
INSERT INTO public.who_global_data VALUES (77857, 2, 7, 0, 0, 329, 10);
INSERT INTO public.who_global_data VALUES (77858, 2, 6, 0, 0, 329, 201);
INSERT INTO public.who_global_data VALUES (77859, 12, 38, 1, 1, 329, 174);
INSERT INTO public.who_global_data VALUES (77860, 0, 0, 0, 0, 329, 119);
INSERT INTO public.who_global_data VALUES (77861, 0, 0, 0, 0, 329, 168);
INSERT INTO public.who_global_data VALUES (77862, 68, 201, 0, 0, 329, 99);
INSERT INTO public.who_global_data VALUES (77863, 1, 13, 0, 0, 329, 171);
INSERT INTO public.who_global_data VALUES (77864, 0, 0, 0, 0, 329, 87);
INSERT INTO public.who_global_data VALUES (77865, 10, 18, 0, 0, 329, 123);
INSERT INTO public.who_global_data VALUES (77866, 0, 0, 0, 0, 329, 151);
INSERT INTO public.who_global_data VALUES (77867, 6, 14, 0, 0, 329, 213);
INSERT INTO public.who_global_data VALUES (77868, 5, 5, 0, 0, 329, 118);
INSERT INTO public.who_global_data VALUES (77869, 0, 0, 0, 0, 329, 134);
INSERT INTO public.who_global_data VALUES (77870, 5, 5, 0, 0, 329, 65);
INSERT INTO public.who_global_data VALUES (77871, 14, 30, 0, 0, 329, 102);
INSERT INTO public.who_global_data VALUES (77872, 0, 0, 0, 0, 329, 223);
INSERT INTO public.who_global_data VALUES (77873, 1, 3, 0, 0, 329, 4);
INSERT INTO public.who_global_data VALUES (77874, 0, 5, 0, 0, 329, 146);
INSERT INTO public.who_global_data VALUES (77875, 0, 0, 0, 0, 329, 31);
INSERT INTO public.who_global_data VALUES (77876, 0, 0, 0, 0, 329, 127);
INSERT INTO public.who_global_data VALUES (77877, 12, 22, 0, 1, 329, 22);
INSERT INTO public.who_global_data VALUES (77878, 0, 0, 0, 0, 329, 115);
INSERT INTO public.who_global_data VALUES (77879, 0, 0, 0, 0, 329, 106);
INSERT INTO public.who_global_data VALUES (77880, 6, 6, 0, 0, 329, 90);
INSERT INTO public.who_global_data VALUES (77881, 0, 0, 0, 0, 329, 70);
INSERT INTO public.who_global_data VALUES (77882, 0, 5, 0, 0, 329, 46);
INSERT INTO public.who_global_data VALUES (77883, 113, 717, 2, 6, 329, 139);
INSERT INTO public.who_global_data VALUES (77884, 0, 0, 0, 0, 329, 42);
INSERT INTO public.who_global_data VALUES (77885, 1, 10, 0, 0, 329, 80);
INSERT INTO public.who_global_data VALUES (77886, 0, 0, 0, 0, 329, 203);
INSERT INTO public.who_global_data VALUES (77887, 0, 0, 0, 0, 329, 136);
INSERT INTO public.who_global_data VALUES (77888, 0, 6, 0, 0, 329, 63);
INSERT INTO public.who_global_data VALUES (77889, 0, 0, 0, 0, 329, 17);
INSERT INTO public.who_global_data VALUES (77890, 0, 0, 0, 0, 329, 172);
INSERT INTO public.who_global_data VALUES (77891, 2, 9, 0, 0, 329, 109);
INSERT INTO public.who_global_data VALUES (77892, 0, 621, 0, 1, 329, 200);
INSERT INTO public.who_global_data VALUES (77893, 3, 42, 0, 0, 329, 93);
INSERT INTO public.who_global_data VALUES (77894, 2, 24, 0, 0, 329, 5);
INSERT INTO public.who_global_data VALUES (77895, 0, 701, 0, 7, 329, 214);
INSERT INTO public.who_global_data VALUES (77896, 8, 32, 0, 0, 329, 204);
INSERT INTO public.who_global_data VALUES (77897, 0, 0, 0, 0, 329, 198);
INSERT INTO public.who_global_data VALUES (77898, 13, 31, 0, 1, 329, 173);
INSERT INTO public.who_global_data VALUES (77899, 0, 0, 0, 0, 329, 229);
INSERT INTO public.who_global_data VALUES (77900, 1, 10, 0, 0, 329, 76);
INSERT INTO public.who_global_data VALUES (77901, 6, 32, 0, 0, 329, 138);
INSERT INTO public.who_global_data VALUES (77902, 12, 68, 0, 2, 329, 98);
INSERT INTO public.who_global_data VALUES (77903, 0, 0, 0, 0, 329, 103);
INSERT INTO public.who_global_data VALUES (77904, 19, 68, 1, 2, 329, 225);
INSERT INTO public.who_global_data VALUES (77905, 34, 112, 0, 0, 329, 131);
INSERT INTO public.who_global_data VALUES (77906, 7, 7, 0, 0, 329, 235);
INSERT INTO public.who_global_data VALUES (77907, 75, 341, 0, 0, 329, 137);
INSERT INTO public.who_global_data VALUES (77908, 107, 8090, 5, 72, 329, 81);
INSERT INTO public.who_global_data VALUES (77909, 4, 8, 0, 0, 329, 182);
INSERT INTO public.who_global_data VALUES (77910, 3, 10, 0, 0, 329, 145);
INSERT INTO public.who_global_data VALUES (77911, 25, 89, 0, 0, 329, 26);
INSERT INTO public.who_global_data VALUES (77912, 0, 34, 0, 0, 329, 170);
INSERT INTO public.who_global_data VALUES (77913, 0, 0, 0, 0, 329, 191);
INSERT INTO public.who_global_data VALUES (77914, 0, 0, 0, 0, 329, 221);
INSERT INTO public.who_global_data VALUES (77915, 0, 1, 0, 0, 329, 64);
INSERT INTO public.who_global_data VALUES (77916, 0, 0, 0, 0, 329, 116);
INSERT INTO public.who_global_data VALUES (77917, 0, 0, 0, 0, 329, 128);
INSERT INTO public.who_global_data VALUES (77918, 0, 0, 0, 0, 329, 6);
INSERT INTO public.who_global_data VALUES (77919, 0, 6, 0, 0, 329, 227);
INSERT INTO public.who_global_data VALUES (77920, 0, 0, 0, 0, 329, 68);
INSERT INTO public.who_global_data VALUES (77921, 0, 1, 0, 0, 329, 184);
INSERT INTO public.who_global_data VALUES (77922, 0, 0, 0, 0, 329, 82);
INSERT INTO public.who_global_data VALUES (77923, 13, 77, 0, 5, 329, 149);
INSERT INTO public.who_global_data VALUES (77924, 0, 0, 0, 0, 329, 197);
INSERT INTO public.who_global_data VALUES (77925, 82, 107, 0, 0, 329, 78);
INSERT INTO public.who_global_data VALUES (77926, 11, 25, 0, 0, 329, 233);
INSERT INTO public.who_global_data VALUES (77927, 2, 14, 0, 0, 329, 133);
INSERT INTO public.who_global_data VALUES (77928, 0, 0, 0, 0, 329, 35);
INSERT INTO public.who_global_data VALUES (77929, 0, 0, 0, 0, 329, 114);
INSERT INTO public.who_global_data VALUES (77930, 12, 216, 0, 0, 329, 237);
INSERT INTO public.who_global_data VALUES (77931, 0, 0, 0, 0, 329, 55);
INSERT INTO public.who_global_data VALUES (77932, 0, 0, 0, 0, 329, 176);
INSERT INTO public.who_global_data VALUES (77933, 9, 30, 0, 0, 329, 202);
INSERT INTO public.who_global_data VALUES (77934, 46, 179, 0, 0, 329, 155);
INSERT INTO public.who_global_data VALUES (77935, 0, 0, 0, 0, 329, 32);
INSERT INTO public.who_global_data VALUES (77936, 0, 0, 0, 0, 329, 220);
INSERT INTO public.who_global_data VALUES (77937, 21, 42, 0, 0, 329, 30);
INSERT INTO public.who_global_data VALUES (77938, 0, 0, 0, 0, 329, 147);
INSERT INTO public.who_global_data VALUES (77939, 1810, 6368, 59, 164, 329, 208);
INSERT INTO public.who_global_data VALUES (77940, 3, 10, 0, 0, 329, 45);
INSERT INTO public.who_global_data VALUES (77941, 1, 1, 0, 0, 329, 110);
INSERT INTO public.who_global_data VALUES (77942, 0, 0, 0, 0, 329, 88);
INSERT INTO public.who_global_data VALUES (77943, 151, 771, 0, 1, 329, 51);
INSERT INTO public.who_global_data VALUES (77944, 431, 1954, 3, 15, 329, 209);
INSERT INTO public.who_global_data VALUES (77945, 0, 0, 0, 0, 329, 205);
INSERT INTO public.who_global_data VALUES (77946, 0, 0, 0, 0, 329, 18);
INSERT INTO public.who_global_data VALUES (77947, 0, 79, 0, 1, 329, 72);
INSERT INTO public.who_global_data VALUES (77948, 484, 1766, 1, 10, 329, 44);
INSERT INTO public.who_global_data VALUES (77949, 0, 0, 0, 0, 329, 15);
INSERT INTO public.who_global_data VALUES (77950, 0, 5, 0, 0, 329, 25);
INSERT INTO public.who_global_data VALUES (77951, 0, 0, 0, 0, 329, 179);
INSERT INTO public.who_global_data VALUES (77952, 0, 0, 0, 0, 329, 34);
INSERT INTO public.who_global_data VALUES (77953, 0, 5, 0, 0, 329, 207);
INSERT INTO public.who_global_data VALUES (77954, 9, 20, 0, 0, 329, 166);
INSERT INTO public.who_global_data VALUES (77955, 4, 5, 0, 0, 329, 126);
INSERT INTO public.who_global_data VALUES (77956, 0, 0, 0, 0, 329, 97);
INSERT INTO public.who_global_data VALUES (77957, 0, 0, 0, 0, 329, 36);
INSERT INTO public.who_global_data VALUES (77958, 0, 0, 0, 0, 329, 125);
INSERT INTO public.who_global_data VALUES (77959, 0, 0, 0, 0, 329, 124);
INSERT INTO public.who_global_data VALUES (77960, 0, 3, 1, 1, 329, 185);
INSERT INTO public.who_global_data VALUES (77961, 0, 89, 0, 0, 329, 194);
INSERT INTO public.who_global_data VALUES (77962, 0, 0, 0, 0, 329, 144);
INSERT INTO public.who_global_data VALUES (77963, 414, 1682, 5, 41, 329, 19);
INSERT INTO public.who_global_data VALUES (77964, 0, 5, 0, 0, 329, 217);
INSERT INTO public.who_global_data VALUES (77965, 0, 0, 0, 0, 329, 148);
INSERT INTO public.who_global_data VALUES (77966, 0, 0, 0, 0, 329, 86);
INSERT INTO public.who_global_data VALUES (77967, 0, 0, 0, 0, 329, 13);
INSERT INTO public.who_global_data VALUES (77968, 6, 6, 0, 0, 329, 157);
INSERT INTO public.who_global_data VALUES (77969, 9, 52, 0, 0, 329, 8);
INSERT INTO public.who_global_data VALUES (77970, 0, 0, 0, 0, 329, 73);
INSERT INTO public.who_global_data VALUES (77971, 0, 0, 0, 0, 329, 101);
INSERT INTO public.who_global_data VALUES (77972, 0, 0, 0, 0, 329, 165);
INSERT INTO public.who_global_data VALUES (77973, 0, 0, 0, 0, 329, 14);
INSERT INTO public.who_global_data VALUES (77974, 0, 11, 0, 0, 330, 193);
INSERT INTO public.who_global_data VALUES (77975, 0, 3, 0, 1, 330, 113);
INSERT INTO public.who_global_data VALUES (77976, 0, 29, 0, 1, 330, 143);
INSERT INTO public.who_global_data VALUES (77977, 0, 0, 0, 0, 330, 219);
INSERT INTO public.who_global_data VALUES (77978, 0, 1, 0, 0, 330, 186);
INSERT INTO public.who_global_data VALUES (77979, 0, 0, 0, 0, 330, 52);
INSERT INTO public.who_global_data VALUES (77980, 0, 0, 0, 0, 330, 180);
INSERT INTO public.who_global_data VALUES (77981, 5, 5, 0, 0, 330, 167);
INSERT INTO public.who_global_data VALUES (77982, 12, 35, 0, 1, 330, 154);
INSERT INTO public.who_global_data VALUES (77983, 0, 1, 0, 0, 330, 94);
INSERT INTO public.who_global_data VALUES (77984, 0, 0, 0, 0, 330, 66);
INSERT INTO public.who_global_data VALUES (77985, 49, 193, 0, 3, 330, 58);
INSERT INTO public.who_global_data VALUES (77986, 115, 361, 1, 1, 330, 163);
INSERT INTO public.who_global_data VALUES (77987, 2, 11, 0, 0, 330, 37);
INSERT INTO public.who_global_data VALUES (77988, 0, 0, 0, 0, 330, 142);
INSERT INTO public.who_global_data VALUES (77989, 0, 199, 0, 0, 330, 83);
INSERT INTO public.who_global_data VALUES (77990, 0, 7, 0, 0, 330, 228);
INSERT INTO public.who_global_data VALUES (77991, 0, 0, 0, 0, 330, 188);
INSERT INTO public.who_global_data VALUES (77992, 0, 12, 0, 0, 330, 62);
INSERT INTO public.who_global_data VALUES (77993, 250, 1124, 1, 9, 330, 160);
INSERT INTO public.who_global_data VALUES (77994, 0, 0, 0, 0, 330, 50);
INSERT INTO public.who_global_data VALUES (77995, 0, 0, 0, 0, 330, 33);
INSERT INTO public.who_global_data VALUES (77996, 0, 0, 0, 0, 330, 183);
INSERT INTO public.who_global_data VALUES (77997, 0, 1, 0, 0, 330, 92);
INSERT INTO public.who_global_data VALUES (77998, 1, 7, 0, 0, 330, 158);
INSERT INTO public.who_global_data VALUES (77999, 0, 0, 0, 0, 330, 67);
INSERT INTO public.who_global_data VALUES (78000, 0, 5, 0, 0, 330, 57);
INSERT INTO public.who_global_data VALUES (78001, 0, 0, 0, 0, 330, 38);
INSERT INTO public.who_global_data VALUES (78002, 46, 102, 0, 0, 330, 141);
INSERT INTO public.who_global_data VALUES (78003, 0, 0, 0, 0, 330, 178);
INSERT INTO public.who_global_data VALUES (78004, 0, 16, 0, 0, 330, 108);
INSERT INTO public.who_global_data VALUES (78005, 16, 23, 0, 1, 330, 39);
INSERT INTO public.who_global_data VALUES (78006, 0, 6, 0, 0, 330, 2);
INSERT INTO public.who_global_data VALUES (78007, 0, 0, 0, 0, 330, 195);
INSERT INTO public.who_global_data VALUES (78008, 0, 0, 0, 0, 330, 107);
INSERT INTO public.who_global_data VALUES (78009, 0, 9, 0, 0, 330, 161);
INSERT INTO public.who_global_data VALUES (78010, 0, 6, 0, 0, 330, 212);
INSERT INTO public.who_global_data VALUES (78011, 59, 156, 0, 1, 330, 181);
INSERT INTO public.who_global_data VALUES (78012, 5, 5, 0, 0, 330, 53);
INSERT INTO public.who_global_data VALUES (78013, 0, 0, 0, 0, 330, 164);
INSERT INTO public.who_global_data VALUES (78014, 0, 0, 0, 0, 330, 140);
INSERT INTO public.who_global_data VALUES (78015, 20, 47, 0, 0, 330, 20);
INSERT INTO public.who_global_data VALUES (78016, 10, 80995, 7, 3180, 330, 112);
INSERT INTO public.who_global_data VALUES (78017, 7, 20, 0, 0, 330, 111);
INSERT INTO public.who_global_data VALUES (78018, 0, 0, 0, 0, 330, 71);
INSERT INTO public.who_global_data VALUES (78019, 0, 0, 0, 0, 330, 218);
INSERT INTO public.who_global_data VALUES (78020, 0, 0, 0, 0, 330, 43);
INSERT INTO public.who_global_data VALUES (78021, 10, 27, 0, 0, 330, 49);
INSERT INTO public.who_global_data VALUES (78022, 0, 5, 0, 0, 330, 1);
INSERT INTO public.who_global_data VALUES (78023, 9, 25, 0, 0, 330, 48);
INSERT INTO public.who_global_data VALUES (78024, 8, 8, 0, 0, 330, 232);
INSERT INTO public.who_global_data VALUES (78025, 5, 5, 0, 0, 330, 175);
INSERT INTO public.who_global_data VALUES (78026, 0, 6, 0, 0, 330, 21);
INSERT INTO public.who_global_data VALUES (78027, 22, 116, 0, 0, 330, 156);
INSERT INTO public.who_global_data VALUES (78028, 0, 0, 0, 0, 330, 95);
INSERT INTO public.who_global_data VALUES (78029, 0, 5, 0, 0, 330, 177);
INSERT INTO public.who_global_data VALUES (78030, 160, 676, 0, 0, 330, 210);
INSERT INTO public.who_global_data VALUES (78031, 0, 0, 0, 0, 330, 120);
INSERT INTO public.who_global_data VALUES (78032, 0, 0, 0, 0, 330, 135);
INSERT INTO public.who_global_data VALUES (78033, 0, 9, 0, 0, 330, 206);
INSERT INTO public.who_global_data VALUES (78034, 6, 27, 0, 0, 330, 189);
INSERT INTO public.who_global_data VALUES (78035, 0, 71, 0, 1, 330, 129);
INSERT INTO public.who_global_data VALUES (78036, 0, 0, 0, 0, 330, 121);
INSERT INTO public.who_global_data VALUES (78037, 0, 0, 0, 0, 330, 59);
INSERT INTO public.who_global_data VALUES (78038, 0, 0, 0, 0, 330, 96);
INSERT INTO public.who_global_data VALUES (78039, 11, 27, 0, 0, 330, 41);
INSERT INTO public.who_global_data VALUES (78040, 0, 0, 0, 0, 330, 216);
INSERT INTO public.who_global_data VALUES (78041, 0, 0, 0, 0, 330, 236);
INSERT INTO public.who_global_data VALUES (78042, 0, 0, 0, 0, 330, 150);
INSERT INTO public.who_global_data VALUES (78043, 0, 3, 0, 0, 330, 61);
INSERT INTO public.who_global_data VALUES (78044, 0, 0, 0, 0, 330, 7);
INSERT INTO public.who_global_data VALUES (78045, 96, 155, 0, 0, 330, 169);
INSERT INTO public.who_global_data VALUES (78046, 586, 2848, 13, 61, 330, 28);
INSERT INTO public.who_global_data VALUES (78047, 1, 6, 0, 0, 330, 85);
INSERT INTO public.who_global_data VALUES (78048, 0, 1, 0, 0, 330, 211);
INSERT INTO public.who_global_data VALUES (78049, 0, 0, 0, 0, 330, 60);
INSERT INTO public.who_global_data VALUES (78050, 0, 0, 0, 0, 330, 3);
INSERT INTO public.who_global_data VALUES (78051, 2, 25, 0, 0, 330, 11);
INSERT INTO public.who_global_data VALUES (78052, 802, 2369, 2, 5, 330, 89);
INSERT INTO public.who_global_data VALUES (78053, 0, 0, 0, 0, 330, 24);
INSERT INTO public.who_global_data VALUES (78054, 0, 1, 0, 0, 330, 162);
INSERT INTO public.who_global_data VALUES (78055, 34, 133, 0, 1, 330, 100);
INSERT INTO public.who_global_data VALUES (78056, 0, 0, 0, 0, 330, 47);
INSERT INTO public.who_global_data VALUES (78057, 0, 0, 0, 0, 330, 29);
INSERT INTO public.who_global_data VALUES (78058, 0, 0, 0, 0, 330, 40);
INSERT INTO public.who_global_data VALUES (78059, 0, 0, 0, 0, 330, 222);
INSERT INTO public.who_global_data VALUES (78060, 0, 0, 0, 0, 330, 132);
INSERT INTO public.who_global_data VALUES (78061, 0, 1, 0, 0, 330, 130);
INSERT INTO public.who_global_data VALUES (78062, 0, 0, 0, 0, 330, 234);
INSERT INTO public.who_global_data VALUES (78063, 0, 0, 0, 0, 330, 23);
INSERT INTO public.who_global_data VALUES (78064, 5, 5, 1, 1, 330, 192);
INSERT INTO public.who_global_data VALUES (78065, 0, 0, 0, 0, 330, 69);
INSERT INTO public.who_global_data VALUES (78066, 0, 1, 0, 0, 330, 187);
INSERT INTO public.who_global_data VALUES (78067, 0, 6, 0, 0, 330, 230);
INSERT INTO public.who_global_data VALUES (78068, 3, 16, 0, 0, 330, 77);
INSERT INTO public.who_global_data VALUES (78069, 32, 117, 0, 0, 330, 9);
INSERT INTO public.who_global_data VALUES (78070, 7, 85, 1, 1, 330, 74);
INSERT INTO public.who_global_data VALUES (78071, 35, 73, 3, 4, 330, 224);
INSERT INTO public.who_global_data VALUES (78072, 1289, 11368, 85, 514, 330, 199);
INSERT INTO public.who_global_data VALUES (78073, 0, 74, 0, 7, 330, 190);
INSERT INTO public.who_global_data VALUES (78074, 27, 70, 0, 1, 330, 12);
INSERT INTO public.who_global_data VALUES (78075, 0, 0, 0, 0, 330, 104);
INSERT INTO public.who_global_data VALUES (78076, 19, 90, 0, 0, 330, 153);
INSERT INTO public.who_global_data VALUES (78077, 2651, 15113, 189, 1016, 330, 91);
INSERT INTO public.who_global_data VALUES (78078, 1, 6, 0, 0, 330, 215);
INSERT INTO public.who_global_data VALUES (78079, 55, 679, 4, 19, 330, 84);
INSERT INTO public.who_global_data VALUES (78080, 0, 2, 0, 0, 330, 231);
INSERT INTO public.who_global_data VALUES (78081, 0, 5, 0, 0, 330, 196);
INSERT INTO public.who_global_data VALUES (78082, 2, 2, 0, 0, 330, 105);
INSERT INTO public.who_global_data VALUES (78083, 0, 0, 0, 0, 330, 122);
INSERT INTO public.who_global_data VALUES (78084, 0, 0, 0, 0, 330, 159);
INSERT INTO public.who_global_data VALUES (78085, 2, 2, 0, 0, 330, 75);
INSERT INTO public.who_global_data VALUES (78086, 20, 104, 0, 0, 330, 27);
INSERT INTO public.who_global_data VALUES (78087, 0, 0, 0, 0, 330, 54);
INSERT INTO public.who_global_data VALUES (78088, 0, 0, 0, 0, 330, 226);
INSERT INTO public.who_global_data VALUES (78089, 6, 16, 0, 0, 330, 79);
INSERT INTO public.who_global_data VALUES (78090, 0, 70, 0, 3, 330, 56);
INSERT INTO public.who_global_data VALUES (78091, 0, 0, 0, 0, 330, 117);
INSERT INTO public.who_global_data VALUES (78092, 0, 0, 0, 0, 330, 152);
INSERT INTO public.who_global_data VALUES (78093, 0, 0, 0, 0, 330, 16);
INSERT INTO public.who_global_data VALUES (78094, 1, 5, 0, 0, 330, 10);
INSERT INTO public.who_global_data VALUES (78095, 1, 4, 0, 0, 330, 201);
INSERT INTO public.who_global_data VALUES (78096, 19, 26, 0, 0, 330, 174);
INSERT INTO public.who_global_data VALUES (78097, 0, 0, 0, 0, 330, 119);
INSERT INTO public.who_global_data VALUES (78098, 0, 0, 0, 0, 330, 168);
INSERT INTO public.who_global_data VALUES (78099, 0, 133, 0, 0, 330, 99);
INSERT INTO public.who_global_data VALUES (78100, 0, 12, 0, 0, 330, 171);
INSERT INTO public.who_global_data VALUES (78101, 0, 0, 0, 0, 330, 87);
INSERT INTO public.who_global_data VALUES (78102, 1, 8, 0, 0, 330, 123);
INSERT INTO public.who_global_data VALUES (78103, 0, 0, 0, 0, 330, 151);
INSERT INTO public.who_global_data VALUES (78104, 1, 8, 0, 0, 330, 213);
INSERT INTO public.who_global_data VALUES (78105, 0, 0, 0, 0, 330, 118);
INSERT INTO public.who_global_data VALUES (78106, 0, 0, 0, 0, 330, 134);
INSERT INTO public.who_global_data VALUES (78107, 0, 0, 0, 0, 330, 65);
INSERT INTO public.who_global_data VALUES (78108, 1, 16, 0, 0, 330, 102);
INSERT INTO public.who_global_data VALUES (78109, 0, 0, 0, 0, 330, 223);
INSERT INTO public.who_global_data VALUES (78110, 0, 2, 0, 0, 330, 4);
INSERT INTO public.who_global_data VALUES (78111, 0, 5, 0, 0, 330, 146);
INSERT INTO public.who_global_data VALUES (78112, 0, 0, 0, 0, 330, 31);
INSERT INTO public.who_global_data VALUES (78113, 0, 0, 0, 0, 330, 127);
INSERT INTO public.who_global_data VALUES (78114, 0, 10, 0, 1, 330, 22);
INSERT INTO public.who_global_data VALUES (78115, 0, 0, 0, 0, 330, 115);
INSERT INTO public.who_global_data VALUES (78116, 0, 0, 0, 0, 330, 106);
INSERT INTO public.who_global_data VALUES (78117, 0, 0, 0, 0, 330, 90);
INSERT INTO public.who_global_data VALUES (78118, 0, 0, 0, 0, 330, 70);
INSERT INTO public.who_global_data VALUES (78119, 0, 5, 0, 0, 330, 46);
INSERT INTO public.who_global_data VALUES (78120, 127, 604, 0, 4, 330, 139);
INSERT INTO public.who_global_data VALUES (78121, 0, 0, 0, 0, 330, 42);
INSERT INTO public.who_global_data VALUES (78122, 0, 9, 0, 0, 330, 80);
INSERT INTO public.who_global_data VALUES (78123, 0, 0, 0, 0, 330, 203);
INSERT INTO public.who_global_data VALUES (78124, 0, 0, 0, 0, 330, 136);
INSERT INTO public.who_global_data VALUES (78125, 0, 6, 0, 0, 330, 63);
INSERT INTO public.who_global_data VALUES (78126, 0, 0, 0, 0, 330, 17);
INSERT INTO public.who_global_data VALUES (78127, 0, 0, 0, 0, 330, 172);
INSERT INTO public.who_global_data VALUES (78128, 0, 7, 0, 0, 330, 109);
INSERT INTO public.who_global_data VALUES (78129, 132, 621, 1, 1, 330, 200);
INSERT INTO public.who_global_data VALUES (78130, 4, 39, 0, 0, 330, 93);
INSERT INTO public.who_global_data VALUES (78131, 0, 22, 0, 0, 330, 5);
INSERT INTO public.who_global_data VALUES (78132, 1, 701, 0, 7, 330, 214);
INSERT INTO public.who_global_data VALUES (78133, 0, 24, 0, 0, 330, 204);
INSERT INTO public.who_global_data VALUES (78134, 0, 0, 0, 0, 330, 198);
INSERT INTO public.who_global_data VALUES (78135, 4, 18, 0, 1, 330, 173);
INSERT INTO public.who_global_data VALUES (78136, 0, 0, 0, 0, 330, 229);
INSERT INTO public.who_global_data VALUES (78137, 0, 9, 0, 0, 330, 76);
INSERT INTO public.who_global_data VALUES (78138, 5, 26, 0, 0, 330, 138);
INSERT INTO public.who_global_data VALUES (78139, 0, 56, 0, 2, 330, 98);
INSERT INTO public.who_global_data VALUES (78140, 0, 0, 0, 0, 330, 103);
INSERT INTO public.who_global_data VALUES (78141, 18, 49, 1, 1, 330, 225);
INSERT INTO public.who_global_data VALUES (78142, 19, 78, 0, 0, 330, 131);
INSERT INTO public.who_global_data VALUES (78143, 0, 0, 0, 0, 330, 235);
INSERT INTO public.who_global_data VALUES (78144, 0, 266, 0, 0, 330, 137);
INSERT INTO public.who_global_data VALUES (78145, 0, 7983, 1, 67, 330, 81);
INSERT INTO public.who_global_data VALUES (78146, 1, 4, 0, 0, 330, 182);
INSERT INTO public.who_global_data VALUES (78147, 7, 7, 0, 0, 330, 145);
INSERT INTO public.who_global_data VALUES (78148, 19, 64, 0, 0, 330, 26);
INSERT INTO public.who_global_data VALUES (78149, 14, 34, 0, 0, 330, 170);
INSERT INTO public.who_global_data VALUES (78150, 0, 0, 0, 0, 330, 191);
INSERT INTO public.who_global_data VALUES (78151, 0, 0, 0, 0, 330, 221);
INSERT INTO public.who_global_data VALUES (78152, 0, 1, 0, 0, 330, 64);
INSERT INTO public.who_global_data VALUES (78153, 0, 0, 0, 0, 330, 116);
INSERT INTO public.who_global_data VALUES (78154, 0, 0, 0, 0, 330, 128);
INSERT INTO public.who_global_data VALUES (78155, 0, 0, 0, 0, 330, 6);
INSERT INTO public.who_global_data VALUES (78156, 0, 6, 0, 0, 330, 227);
INSERT INTO public.who_global_data VALUES (78157, 0, 0, 0, 0, 330, 68);
INSERT INTO public.who_global_data VALUES (78158, 1, 1, 0, 0, 330, 184);
INSERT INTO public.who_global_data VALUES (78159, 0, 0, 0, 0, 330, 82);
INSERT INTO public.who_global_data VALUES (78160, 4, 64, 3, 5, 330, 149);
INSERT INTO public.who_global_data VALUES (78161, 0, 0, 0, 0, 330, 197);
INSERT INTO public.who_global_data VALUES (78162, 0, 25, 0, 0, 330, 78);
INSERT INTO public.who_global_data VALUES (78163, 0, 14, 0, 0, 330, 233);
INSERT INTO public.who_global_data VALUES (78164, 0, 12, 0, 0, 330, 133);
INSERT INTO public.who_global_data VALUES (78165, 0, 0, 0, 0, 330, 35);
INSERT INTO public.who_global_data VALUES (78166, 0, 0, 0, 0, 330, 114);
INSERT INTO public.who_global_data VALUES (78167, 13, 204, 0, 0, 330, 237);
INSERT INTO public.who_global_data VALUES (78168, 0, 0, 0, 0, 330, 55);
INSERT INTO public.who_global_data VALUES (78169, 0, 0, 0, 0, 330, 176);
INSERT INTO public.who_global_data VALUES (78170, 11, 21, 0, 0, 330, 202);
INSERT INTO public.who_global_data VALUES (78171, 50, 133, 0, 0, 330, 155);
INSERT INTO public.who_global_data VALUES (78172, 0, 0, 0, 0, 330, 32);
INSERT INTO public.who_global_data VALUES (78173, 0, 0, 0, 0, 330, 220);
INSERT INTO public.who_global_data VALUES (78174, 0, 21, 0, 0, 330, 30);
INSERT INTO public.who_global_data VALUES (78175, 0, 0, 0, 0, 330, 147);
INSERT INTO public.who_global_data VALUES (78176, 1346, 4558, 35, 105, 330, 208);
INSERT INTO public.who_global_data VALUES (78177, 0, 7, 0, 0, 330, 45);
INSERT INTO public.who_global_data VALUES (78178, 0, 0, 0, 0, 330, 110);
INSERT INTO public.who_global_data VALUES (78179, 0, 0, 0, 0, 330, 88);
INSERT INTO public.who_global_data VALUES (78180, 196, 620, 0, 1, 330, 51);
INSERT INTO public.who_global_data VALUES (78181, 356, 1523, 4, 12, 330, 209);
INSERT INTO public.who_global_data VALUES (78182, 0, 0, 0, 0, 330, 205);
INSERT INTO public.who_global_data VALUES (78183, 0, 0, 0, 0, 330, 18);
INSERT INTO public.who_global_data VALUES (78184, 5, 79, 0, 1, 330, 72);
INSERT INTO public.who_global_data VALUES (78185, 406, 1282, 2, 9, 330, 44);
INSERT INTO public.who_global_data VALUES (78186, 0, 0, 0, 0, 330, 15);
INSERT INTO public.who_global_data VALUES (78187, 0, 5, 0, 0, 330, 25);
INSERT INTO public.who_global_data VALUES (78188, 0, 0, 0, 0, 330, 179);
INSERT INTO public.who_global_data VALUES (78189, 0, 0, 0, 0, 330, 34);
INSERT INTO public.who_global_data VALUES (78190, 5, 5, 0, 0, 330, 207);
INSERT INTO public.who_global_data VALUES (78191, 0, 11, 0, 0, 330, 166);
INSERT INTO public.who_global_data VALUES (78192, 0, 1, 0, 0, 330, 126);
INSERT INTO public.who_global_data VALUES (78193, 0, 0, 0, 0, 330, 97);
INSERT INTO public.who_global_data VALUES (78194, 0, 0, 0, 0, 330, 36);
INSERT INTO public.who_global_data VALUES (78195, 0, 0, 0, 0, 330, 125);
INSERT INTO public.who_global_data VALUES (78196, 0, 0, 0, 0, 330, 124);
INSERT INTO public.who_global_data VALUES (78197, 2, 3, 0, 0, 330, 185);
INSERT INTO public.who_global_data VALUES (78198, 0, 89, 0, 0, 330, 194);
INSERT INTO public.who_global_data VALUES (78199, 0, 0, 0, 0, 330, 144);
INSERT INTO public.who_global_data VALUES (78200, 277, 1268, 7, 36, 330, 19);
INSERT INTO public.who_global_data VALUES (78201, 5, 5, 0, 0, 330, 217);
INSERT INTO public.who_global_data VALUES (78202, 0, 0, 0, 0, 330, 148);
INSERT INTO public.who_global_data VALUES (78203, 0, 0, 0, 0, 330, 86);
INSERT INTO public.who_global_data VALUES (78204, 0, 0, 0, 0, 330, 13);
INSERT INTO public.who_global_data VALUES (78205, 0, 0, 0, 0, 330, 157);
INSERT INTO public.who_global_data VALUES (78206, 0, 43, 0, 0, 330, 8);
INSERT INTO public.who_global_data VALUES (78207, 0, 0, 0, 0, 330, 73);
INSERT INTO public.who_global_data VALUES (78208, 0, 0, 0, 0, 330, 101);
INSERT INTO public.who_global_data VALUES (78209, 0, 0, 0, 0, 330, 165);
INSERT INTO public.who_global_data VALUES (78210, 0, 0, 0, 0, 330, 14);
INSERT INTO public.who_global_data VALUES (78211, 0, 11, 0, 0, 331, 193);
INSERT INTO public.who_global_data VALUES (78212, 1, 3, 1, 1, 331, 113);
INSERT INTO public.who_global_data VALUES (78213, 5, 29, 1, 1, 331, 143);
INSERT INTO public.who_global_data VALUES (78214, 0, 0, 0, 0, 331, 219);
INSERT INTO public.who_global_data VALUES (78215, 0, 1, 0, 0, 331, 186);
INSERT INTO public.who_global_data VALUES (78216, 0, 0, 0, 0, 331, 52);
INSERT INTO public.who_global_data VALUES (78217, 0, 0, 0, 0, 331, 180);
INSERT INTO public.who_global_data VALUES (78218, 0, 0, 0, 0, 331, 167);
INSERT INTO public.who_global_data VALUES (78219, 2, 23, 0, 1, 331, 154);
INSERT INTO public.who_global_data VALUES (78220, 0, 1, 0, 0, 331, 94);
INSERT INTO public.who_global_data VALUES (78221, 0, 0, 0, 0, 331, 66);
INSERT INTO public.who_global_data VALUES (78222, 18, 144, 0, 3, 331, 58);
INSERT INTO public.who_global_data VALUES (78223, 64, 246, 0, 0, 331, 163);
INSERT INTO public.who_global_data VALUES (78224, 0, 9, 0, 0, 331, 37);
INSERT INTO public.who_global_data VALUES (78225, 0, 0, 0, 0, 331, 142);
INSERT INTO public.who_global_data VALUES (78226, 6, 199, 0, 0, 331, 83);
INSERT INTO public.who_global_data VALUES (78227, 0, 7, 0, 0, 331, 228);
INSERT INTO public.who_global_data VALUES (78228, 0, 0, 0, 0, 331, 188);
INSERT INTO public.who_global_data VALUES (78229, 3, 12, 0, 0, 331, 62);
INSERT INTO public.who_global_data VALUES (78230, 274, 874, 7, 8, 331, 160);
INSERT INTO public.who_global_data VALUES (78231, 0, 0, 0, 0, 331, 50);
INSERT INTO public.who_global_data VALUES (78232, 0, 0, 0, 0, 331, 33);
INSERT INTO public.who_global_data VALUES (78233, 0, 0, 0, 0, 331, 183);
INSERT INTO public.who_global_data VALUES (78234, 0, 1, 0, 0, 331, 92);
INSERT INTO public.who_global_data VALUES (78235, 0, 6, 0, 0, 331, 158);
INSERT INTO public.who_global_data VALUES (78236, 0, 0, 0, 0, 331, 67);
INSERT INTO public.who_global_data VALUES (78237, 3, 5, 0, 0, 331, 57);
INSERT INTO public.who_global_data VALUES (78238, 0, 0, 0, 0, 331, 38);
INSERT INTO public.who_global_data VALUES (78239, 18, 56, 0, 0, 331, 141);
INSERT INTO public.who_global_data VALUES (78240, 0, 0, 0, 0, 331, 178);
INSERT INTO public.who_global_data VALUES (78241, 0, 16, 0, 0, 331, 108);
INSERT INTO public.who_global_data VALUES (78242, 3, 7, 1, 1, 331, 39);
INSERT INTO public.who_global_data VALUES (78243, 0, 6, 0, 0, 331, 2);
INSERT INTO public.who_global_data VALUES (78244, 0, 0, 0, 0, 331, 195);
INSERT INTO public.who_global_data VALUES (78245, 0, 0, 0, 0, 331, 107);
INSERT INTO public.who_global_data VALUES (78246, 2, 9, 0, 0, 331, 161);
INSERT INTO public.who_global_data VALUES (78247, 0, 6, 0, 0, 331, 212);
INSERT INTO public.who_global_data VALUES (78248, 0, 97, 0, 1, 331, 181);
INSERT INTO public.who_global_data VALUES (78249, 0, 0, 0, 0, 331, 53);
INSERT INTO public.who_global_data VALUES (78250, 0, 0, 0, 0, 331, 164);
INSERT INTO public.who_global_data VALUES (78251, 0, 0, 0, 0, 331, 140);
INSERT INTO public.who_global_data VALUES (78252, 6, 27, 0, 0, 331, 20);
INSERT INTO public.who_global_data VALUES (78253, 26, 80985, 11, 3173, 331, 112);
INSERT INTO public.who_global_data VALUES (78254, 6, 13, 0, 0, 331, 111);
INSERT INTO public.who_global_data VALUES (78255, 0, 0, 0, 0, 331, 71);
INSERT INTO public.who_global_data VALUES (78256, 0, 0, 0, 0, 331, 218);
INSERT INTO public.who_global_data VALUES (78257, 0, 0, 0, 0, 331, 43);
INSERT INTO public.who_global_data VALUES (78258, 0, 17, 0, 0, 331, 49);
INSERT INTO public.who_global_data VALUES (78259, 5, 5, 0, 0, 331, 1);
INSERT INTO public.who_global_data VALUES (78260, 3, 16, 0, 0, 331, 48);
INSERT INTO public.who_global_data VALUES (78261, 0, 0, 0, 0, 331, 232);
INSERT INTO public.who_global_data VALUES (78262, 0, 0, 0, 0, 331, 175);
INSERT INTO public.who_global_data VALUES (78263, 4, 6, 0, 0, 331, 21);
INSERT INTO public.who_global_data VALUES (78264, 31, 94, 0, 0, 331, 156);
INSERT INTO public.who_global_data VALUES (78265, 0, 0, 0, 0, 331, 95);
INSERT INTO public.who_global_data VALUES (78266, 0, 5, 0, 0, 331, 177);
INSERT INTO public.who_global_data VALUES (78267, 252, 516, 0, 0, 331, 210);
INSERT INTO public.who_global_data VALUES (78268, 0, 0, 0, 0, 331, 120);
INSERT INTO public.who_global_data VALUES (78269, 0, 0, 0, 0, 331, 135);
INSERT INTO public.who_global_data VALUES (78270, 0, 9, 0, 0, 331, 206);
INSERT INTO public.who_global_data VALUES (78271, 2, 21, 0, 0, 331, 189);
INSERT INTO public.who_global_data VALUES (78272, 0, 71, 0, 1, 331, 129);
INSERT INTO public.who_global_data VALUES (78273, 0, 0, 0, 0, 331, 121);
INSERT INTO public.who_global_data VALUES (78274, 0, 0, 0, 0, 331, 59);
INSERT INTO public.who_global_data VALUES (78275, 0, 0, 0, 0, 331, 96);
INSERT INTO public.who_global_data VALUES (78276, 3, 16, 0, 0, 331, 41);
INSERT INTO public.who_global_data VALUES (78277, 0, 0, 0, 0, 331, 216);
INSERT INTO public.who_global_data VALUES (78278, 0, 0, 0, 0, 331, 236);
INSERT INTO public.who_global_data VALUES (78279, 0, 0, 0, 0, 331, 150);
INSERT INTO public.who_global_data VALUES (78280, 0, 3, 0, 0, 331, 61);
INSERT INTO public.who_global_data VALUES (78281, 0, 0, 0, 0, 331, 7);
INSERT INTO public.who_global_data VALUES (78282, 19, 59, 0, 0, 331, 169);
INSERT INTO public.who_global_data VALUES (78283, 497, 2262, 15, 48, 331, 28);
INSERT INTO public.who_global_data VALUES (78284, 0, 5, 0, 0, 331, 85);
INSERT INTO public.who_global_data VALUES (78285, 1, 1, 0, 0, 331, 211);
INSERT INTO public.who_global_data VALUES (78286, 0, 0, 0, 0, 331, 60);
INSERT INTO public.who_global_data VALUES (78287, 0, 0, 0, 0, 331, 3);
INSERT INTO public.who_global_data VALUES (78288, 0, 23, 0, 0, 331, 11);
INSERT INTO public.who_global_data VALUES (78289, 271, 1567, 1, 3, 331, 89);
INSERT INTO public.who_global_data VALUES (78290, 0, 0, 0, 0, 331, 24);
INSERT INTO public.who_global_data VALUES (78291, 0, 1, 0, 0, 331, 162);
INSERT INTO public.who_global_data VALUES (78292, 9, 99, 1, 1, 331, 100);
INSERT INTO public.who_global_data VALUES (78293, 0, 0, 0, 0, 331, 47);
INSERT INTO public.who_global_data VALUES (78294, 0, 0, 0, 0, 331, 29);
INSERT INTO public.who_global_data VALUES (78295, 0, 0, 0, 0, 331, 40);
INSERT INTO public.who_global_data VALUES (78296, 0, 0, 0, 0, 331, 222);
INSERT INTO public.who_global_data VALUES (78297, 0, 0, 0, 0, 331, 132);
INSERT INTO public.who_global_data VALUES (78298, 0, 1, 0, 0, 331, 130);
INSERT INTO public.who_global_data VALUES (78299, 0, 0, 0, 0, 331, 234);
INSERT INTO public.who_global_data VALUES (78300, 0, 0, 0, 0, 331, 23);
INSERT INTO public.who_global_data VALUES (78301, 0, 0, 0, 0, 331, 192);
INSERT INTO public.who_global_data VALUES (78302, 0, 0, 0, 0, 331, 69);
INSERT INTO public.who_global_data VALUES (78303, 0, 1, 0, 0, 331, 187);
INSERT INTO public.who_global_data VALUES (78304, 6, 6, 0, 0, 331, 230);
INSERT INTO public.who_global_data VALUES (78305, 1, 13, 0, 0, 331, 77);
INSERT INTO public.who_global_data VALUES (78306, 15, 85, 0, 0, 331, 9);
INSERT INTO public.who_global_data VALUES (78307, 14, 78, 0, 0, 331, 74);
INSERT INTO public.who_global_data VALUES (78308, 7, 38, 0, 1, 331, 224);
INSERT INTO public.who_global_data VALUES (78309, 1075, 10079, 75, 429, 331, 199);
INSERT INTO public.who_global_data VALUES (78310, 0, 74, 0, 7, 331, 190);
INSERT INTO public.who_global_data VALUES (78311, 8, 43, 1, 1, 331, 12);
INSERT INTO public.who_global_data VALUES (78312, 0, 0, 0, 0, 331, 104);
INSERT INTO public.who_global_data VALUES (78313, 33, 71, 0, 0, 331, 153);
INSERT INTO public.who_global_data VALUES (78314, 2313, 12462, 196, 827, 331, 91);
INSERT INTO public.who_global_data VALUES (78315, 0, 5, 0, 0, 331, 215);
INSERT INTO public.who_global_data VALUES (78316, 52, 624, 3, 15, 331, 84);
INSERT INTO public.who_global_data VALUES (78317, 2, 2, 0, 0, 331, 231);
INSERT INTO public.who_global_data VALUES (78318, 0, 5, 0, 0, 331, 196);
INSERT INTO public.who_global_data VALUES (78319, 0, 0, 0, 0, 331, 105);
INSERT INTO public.who_global_data VALUES (78320, 0, 0, 0, 0, 331, 122);
INSERT INTO public.who_global_data VALUES (78321, 0, 0, 0, 0, 331, 159);
INSERT INTO public.who_global_data VALUES (78322, 0, 0, 0, 0, 331, 75);
INSERT INTO public.who_global_data VALUES (78323, 8, 84, 0, 0, 331, 27);
INSERT INTO public.who_global_data VALUES (78324, 0, 0, 0, 0, 331, 54);
INSERT INTO public.who_global_data VALUES (78325, 0, 0, 0, 0, 331, 226);
INSERT INTO public.who_global_data VALUES (78326, 2, 10, 0, 0, 331, 79);
INSERT INTO public.who_global_data VALUES (78327, 5, 70, 2, 3, 331, 56);
INSERT INTO public.who_global_data VALUES (78328, 0, 0, 0, 0, 331, 117);
INSERT INTO public.who_global_data VALUES (78329, 0, 0, 0, 0, 331, 152);
INSERT INTO public.who_global_data VALUES (78330, 0, 0, 0, 0, 331, 16);
INSERT INTO public.who_global_data VALUES (78331, 1, 4, 0, 0, 331, 10);
INSERT INTO public.who_global_data VALUES (78332, 0, 3, 0, 0, 331, 201);
INSERT INTO public.who_global_data VALUES (78333, 0, 7, 0, 0, 331, 174);
INSERT INTO public.who_global_data VALUES (78334, 0, 0, 0, 0, 331, 119);
INSERT INTO public.who_global_data VALUES (78335, 0, 0, 0, 0, 331, 168);
INSERT INTO public.who_global_data VALUES (78336, 0, 133, 0, 0, 331, 99);
INSERT INTO public.who_global_data VALUES (78337, 0, 12, 0, 0, 331, 171);
INSERT INTO public.who_global_data VALUES (78338, 0, 0, 0, 0, 331, 87);
INSERT INTO public.who_global_data VALUES (78339, 1, 7, 0, 0, 331, 123);
INSERT INTO public.who_global_data VALUES (78340, 0, 0, 0, 0, 331, 151);
INSERT INTO public.who_global_data VALUES (78341, 0, 7, 0, 0, 331, 213);
INSERT INTO public.who_global_data VALUES (78342, 0, 0, 0, 0, 331, 118);
INSERT INTO public.who_global_data VALUES (78343, 0, 0, 0, 0, 331, 134);
INSERT INTO public.who_global_data VALUES (78344, 0, 0, 0, 0, 331, 65);
INSERT INTO public.who_global_data VALUES (78345, 4, 15, 0, 0, 331, 102);
INSERT INTO public.who_global_data VALUES (78346, 0, 0, 0, 0, 331, 223);
INSERT INTO public.who_global_data VALUES (78347, 1, 2, 0, 0, 331, 4);
INSERT INTO public.who_global_data VALUES (78348, 0, 5, 0, 0, 331, 146);
INSERT INTO public.who_global_data VALUES (78349, 0, 0, 0, 0, 331, 31);
INSERT INTO public.who_global_data VALUES (78350, 0, 0, 0, 0, 331, 127);
INSERT INTO public.who_global_data VALUES (78351, 1, 10, 0, 1, 331, 22);
INSERT INTO public.who_global_data VALUES (78352, 0, 0, 0, 0, 331, 115);
INSERT INTO public.who_global_data VALUES (78353, 0, 0, 0, 0, 331, 106);
INSERT INTO public.who_global_data VALUES (78354, 0, 0, 0, 0, 331, 90);
INSERT INTO public.who_global_data VALUES (78355, 0, 0, 0, 0, 331, 70);
INSERT INTO public.who_global_data VALUES (78356, 0, 5, 0, 0, 331, 46);
INSERT INTO public.who_global_data VALUES (78357, 123, 477, 1, 4, 331, 139);
INSERT INTO public.who_global_data VALUES (78358, 0, 0, 0, 0, 331, 42);
INSERT INTO public.who_global_data VALUES (78359, 0, 9, 0, 0, 331, 80);
INSERT INTO public.who_global_data VALUES (78360, 0, 0, 0, 0, 331, 203);
INSERT INTO public.who_global_data VALUES (78361, 0, 0, 0, 0, 331, 136);
INSERT INTO public.who_global_data VALUES (78362, 0, 6, 0, 0, 331, 63);
INSERT INTO public.who_global_data VALUES (78363, 0, 0, 0, 0, 331, 17);
INSERT INTO public.who_global_data VALUES (78364, 0, 0, 0, 0, 331, 172);
INSERT INTO public.who_global_data VALUES (78365, 0, 7, 0, 0, 331, 109);
INSERT INTO public.who_global_data VALUES (78366, 212, 489, 0, 0, 331, 200);
INSERT INTO public.who_global_data VALUES (78367, 1, 35, 0, 0, 331, 93);
INSERT INTO public.who_global_data VALUES (78368, 0, 22, 0, 0, 331, 5);
INSERT INTO public.who_global_data VALUES (78369, 0, 700, 0, 7, 331, 214);
INSERT INTO public.who_global_data VALUES (78370, 1, 24, 0, 0, 331, 204);
INSERT INTO public.who_global_data VALUES (78371, 0, 0, 0, 0, 331, 198);
INSERT INTO public.who_global_data VALUES (78372, 2, 14, 0, 1, 331, 173);
INSERT INTO public.who_global_data VALUES (78373, 0, 0, 0, 0, 331, 229);
INSERT INTO public.who_global_data VALUES (78374, 0, 9, 0, 0, 331, 76);
INSERT INTO public.who_global_data VALUES (78375, 6, 21, 0, 0, 331, 138);
INSERT INTO public.who_global_data VALUES (78376, 3, 56, 1, 2, 331, 98);
INSERT INTO public.who_global_data VALUES (78377, 0, 0, 0, 0, 331, 103);
INSERT INTO public.who_global_data VALUES (78378, 9, 31, 0, 0, 331, 225);
INSERT INTO public.who_global_data VALUES (78379, 18, 59, 0, 0, 331, 131);
INSERT INTO public.who_global_data VALUES (78380, 0, 0, 0, 0, 331, 235);
INSERT INTO public.who_global_data VALUES (78381, 0, 266, 0, 0, 331, 137);
INSERT INTO public.who_global_data VALUES (78382, 224, 7983, 6, 66, 331, 81);
INSERT INTO public.who_global_data VALUES (78383, 0, 3, 0, 0, 331, 182);
INSERT INTO public.who_global_data VALUES (78384, 0, 0, 0, 0, 331, 145);
INSERT INTO public.who_global_data VALUES (78385, 20, 45, 0, 0, 331, 26);
INSERT INTO public.who_global_data VALUES (78386, 13, 20, 0, 0, 331, 170);
INSERT INTO public.who_global_data VALUES (78387, 0, 0, 0, 0, 331, 191);
INSERT INTO public.who_global_data VALUES (78388, 0, 0, 0, 0, 331, 221);
INSERT INTO public.who_global_data VALUES (78389, 0, 1, 0, 0, 331, 64);
INSERT INTO public.who_global_data VALUES (78390, 0, 0, 0, 0, 331, 116);
INSERT INTO public.who_global_data VALUES (78391, 0, 0, 0, 0, 331, 128);
INSERT INTO public.who_global_data VALUES (78392, 0, 0, 0, 0, 331, 6);
INSERT INTO public.who_global_data VALUES (78393, 0, 6, 0, 0, 331, 227);
INSERT INTO public.who_global_data VALUES (78394, 0, 0, 0, 0, 331, 68);
INSERT INTO public.who_global_data VALUES (78395, 0, 0, 0, 0, 331, 184);
INSERT INTO public.who_global_data VALUES (78396, 0, 0, 0, 0, 331, 82);
INSERT INTO public.who_global_data VALUES (78397, 0, 60, 0, 2, 331, 149);
INSERT INTO public.who_global_data VALUES (78398, 0, 0, 0, 0, 331, 197);
INSERT INTO public.who_global_data VALUES (78399, 0, 25, 0, 0, 331, 78);
INSERT INTO public.who_global_data VALUES (78400, 6, 14, 0, 0, 331, 233);
INSERT INTO public.who_global_data VALUES (78401, 8, 12, 0, 0, 331, 133);
INSERT INTO public.who_global_data VALUES (78402, 0, 0, 0, 0, 331, 35);
INSERT INTO public.who_global_data VALUES (78403, 0, 0, 0, 0, 331, 114);
INSERT INTO public.who_global_data VALUES (78404, 9, 191, 0, 0, 331, 237);
INSERT INTO public.who_global_data VALUES (78405, 0, 0, 0, 0, 331, 55);
INSERT INTO public.who_global_data VALUES (78406, 0, 0, 0, 0, 331, 176);
INSERT INTO public.who_global_data VALUES (78407, 3, 10, 0, 0, 331, 202);
INSERT INTO public.who_global_data VALUES (78408, 35, 83, 0, 0, 331, 155);
INSERT INTO public.who_global_data VALUES (78409, 0, 0, 0, 0, 331, 32);
INSERT INTO public.who_global_data VALUES (78410, 0, 0, 0, 0, 331, 220);
INSERT INTO public.who_global_data VALUES (78411, 10, 21, 0, 0, 331, 30);
INSERT INTO public.who_global_data VALUES (78412, 0, 0, 0, 0, 331, 147);
INSERT INTO public.who_global_data VALUES (78413, 1036, 3212, 28, 70, 331, 208);
INSERT INTO public.who_global_data VALUES (78414, 1, 7, 0, 0, 331, 45);
INSERT INTO public.who_global_data VALUES (78415, 0, 0, 0, 0, 331, 110);
INSERT INTO public.who_global_data VALUES (78416, 0, 0, 0, 0, 331, 88);
INSERT INTO public.who_global_data VALUES (78417, 98, 424, 1, 1, 331, 51);
INSERT INTO public.who_global_data VALUES (78418, 333, 1167, 3, 8, 331, 209);
INSERT INTO public.who_global_data VALUES (78419, 0, 0, 0, 0, 331, 205);
INSERT INTO public.who_global_data VALUES (78420, 0, 0, 0, 0, 331, 18);
INSERT INTO public.who_global_data VALUES (78421, 11, 74, 0, 1, 331, 72);
INSERT INTO public.who_global_data VALUES (78422, 259, 876, 0, 7, 331, 44);
INSERT INTO public.who_global_data VALUES (78423, 0, 0, 0, 0, 331, 15);
INSERT INTO public.who_global_data VALUES (78424, 0, 5, 0, 0, 331, 25);
INSERT INTO public.who_global_data VALUES (78425, 0, 0, 0, 0, 331, 179);
INSERT INTO public.who_global_data VALUES (78426, 0, 0, 0, 0, 331, 34);
INSERT INTO public.who_global_data VALUES (78427, 0, 0, 0, 0, 331, 207);
INSERT INTO public.who_global_data VALUES (78428, 1, 11, 0, 0, 331, 166);
INSERT INTO public.who_global_data VALUES (78429, 0, 1, 0, 0, 331, 126);
INSERT INTO public.who_global_data VALUES (78430, 0, 0, 0, 0, 331, 97);
INSERT INTO public.who_global_data VALUES (78431, 0, 0, 0, 0, 331, 36);
INSERT INTO public.who_global_data VALUES (78432, 0, 0, 0, 0, 331, 125);
INSERT INTO public.who_global_data VALUES (78433, 0, 0, 0, 0, 331, 124);
INSERT INTO public.who_global_data VALUES (78434, 0, 1, 0, 0, 331, 185);
INSERT INTO public.who_global_data VALUES (78435, 11, 89, 0, 0, 331, 194);
INSERT INTO public.who_global_data VALUES (78436, 0, 0, 0, 0, 331, 144);
INSERT INTO public.who_global_data VALUES (78437, 291, 991, 4, 29, 331, 19);
INSERT INTO public.who_global_data VALUES (78438, 0, 0, 0, 0, 331, 217);
INSERT INTO public.who_global_data VALUES (78439, 0, 0, 0, 0, 331, 148);
INSERT INTO public.who_global_data VALUES (78440, 0, 0, 0, 0, 331, 86);
INSERT INTO public.who_global_data VALUES (78441, 0, 0, 0, 0, 331, 13);
INSERT INTO public.who_global_data VALUES (78442, 0, 0, 0, 0, 331, 157);
INSERT INTO public.who_global_data VALUES (78443, 4, 43, 0, 0, 331, 8);
INSERT INTO public.who_global_data VALUES (78444, 0, 0, 0, 0, 331, 73);
INSERT INTO public.who_global_data VALUES (78445, 0, 0, 0, 0, 331, 101);
INSERT INTO public.who_global_data VALUES (78446, 0, 0, 0, 0, 331, 165);
INSERT INTO public.who_global_data VALUES (78447, 0, 0, 0, 0, 331, 14);
INSERT INTO public.who_global_data VALUES (78448, 3, 11, 0, 0, 332, 193);
INSERT INTO public.who_global_data VALUES (78449, 0, 2, 0, 0, 332, 113);
INSERT INTO public.who_global_data VALUES (78450, 0, 24, 0, 0, 332, 143);
INSERT INTO public.who_global_data VALUES (78451, 0, 0, 0, 0, 332, 219);
INSERT INTO public.who_global_data VALUES (78452, 0, 1, 0, 0, 332, 186);
INSERT INTO public.who_global_data VALUES (78453, 0, 0, 0, 0, 332, 52);
INSERT INTO public.who_global_data VALUES (78454, 0, 0, 0, 0, 332, 180);
INSERT INTO public.who_global_data VALUES (78455, 0, 0, 0, 0, 332, 167);
INSERT INTO public.who_global_data VALUES (78456, 5, 21, 0, 1, 332, 154);
INSERT INTO public.who_global_data VALUES (78457, 0, 1, 0, 0, 332, 94);
INSERT INTO public.who_global_data VALUES (78458, 0, 0, 0, 0, 332, 66);
INSERT INTO public.who_global_data VALUES (78459, 30, 126, 0, 3, 332, 58);
INSERT INTO public.who_global_data VALUES (78460, 51, 182, 0, 0, 332, 163);
INSERT INTO public.who_global_data VALUES (78461, 0, 9, 0, 0, 332, 37);
INSERT INTO public.who_global_data VALUES (78462, 0, 0, 0, 0, 332, 142);
INSERT INTO public.who_global_data VALUES (78463, 79, 193, 0, 0, 332, 83);
INSERT INTO public.who_global_data VALUES (78464, 0, 7, 0, 0, 332, 228);
INSERT INTO public.who_global_data VALUES (78465, 0, 0, 0, 0, 332, 188);
INSERT INTO public.who_global_data VALUES (78466, 3, 9, 0, 0, 332, 62);
INSERT INTO public.who_global_data VALUES (78467, 99, 600, 0, 1, 332, 160);
INSERT INTO public.who_global_data VALUES (78468, 0, 0, 0, 0, 332, 50);
INSERT INTO public.who_global_data VALUES (78469, 0, 0, 0, 0, 332, 33);
INSERT INTO public.who_global_data VALUES (78470, 0, 0, 0, 0, 332, 183);
INSERT INTO public.who_global_data VALUES (78471, 0, 1, 0, 0, 332, 92);
INSERT INTO public.who_global_data VALUES (78472, 6, 6, 0, 0, 332, 158);
INSERT INTO public.who_global_data VALUES (78473, 0, 0, 0, 0, 332, 67);
INSERT INTO public.who_global_data VALUES (78474, 0, 2, 0, 0, 332, 57);
INSERT INTO public.who_global_data VALUES (78475, 0, 0, 0, 0, 332, 38);
INSERT INTO public.who_global_data VALUES (78476, 9, 38, 0, 0, 332, 141);
INSERT INTO public.who_global_data VALUES (78477, 0, 0, 0, 0, 332, 178);
INSERT INTO public.who_global_data VALUES (78478, 11, 16, 0, 0, 332, 108);
INSERT INTO public.who_global_data VALUES (78479, 0, 4, 0, 0, 332, 39);
INSERT INTO public.who_global_data VALUES (78480, 6, 6, 0, 0, 332, 2);
INSERT INTO public.who_global_data VALUES (78481, 0, 0, 0, 0, 332, 195);
INSERT INTO public.who_global_data VALUES (78482, 0, 0, 0, 0, 332, 107);
INSERT INTO public.who_global_data VALUES (78483, 0, 7, 0, 0, 332, 161);
INSERT INTO public.who_global_data VALUES (78484, 0, 6, 0, 0, 332, 212);
INSERT INTO public.who_global_data VALUES (78485, 16, 97, 1, 1, 332, 181);
INSERT INTO public.who_global_data VALUES (78486, 0, 0, 0, 0, 332, 53);
INSERT INTO public.who_global_data VALUES (78487, 0, 0, 0, 0, 332, 164);
INSERT INTO public.who_global_data VALUES (78488, 0, 0, 0, 0, 332, 140);
INSERT INTO public.who_global_data VALUES (78489, 4, 21, 0, 0, 332, 20);
INSERT INTO public.who_global_data VALUES (78490, 31, 80959, 22, 3162, 332, 112);
INSERT INTO public.who_global_data VALUES (78491, 0, 7, 0, 0, 332, 111);
INSERT INTO public.who_global_data VALUES (78492, 0, 0, 0, 0, 332, 71);
INSERT INTO public.who_global_data VALUES (78493, 0, 0, 0, 0, 332, 218);
INSERT INTO public.who_global_data VALUES (78494, 0, 0, 0, 0, 332, 43);
INSERT INTO public.who_global_data VALUES (78495, 4, 17, 0, 0, 332, 49);
INSERT INTO public.who_global_data VALUES (78496, 0, 0, 0, 0, 332, 1);
INSERT INTO public.who_global_data VALUES (78497, 1, 13, 0, 0, 332, 48);
INSERT INTO public.who_global_data VALUES (78498, 0, 0, 0, 0, 332, 232);
INSERT INTO public.who_global_data VALUES (78499, 0, 0, 0, 0, 332, 175);
INSERT INTO public.who_global_data VALUES (78500, 0, 2, 0, 0, 332, 21);
INSERT INTO public.who_global_data VALUES (78501, 23, 63, 0, 0, 332, 156);
INSERT INTO public.who_global_data VALUES (78502, 0, 0, 0, 0, 332, 95);
INSERT INTO public.who_global_data VALUES (78503, 5, 5, 0, 0, 332, 177);
INSERT INTO public.who_global_data VALUES (78504, 151, 264, 0, 0, 332, 210);
INSERT INTO public.who_global_data VALUES (78505, 0, 0, 0, 0, 332, 120);
INSERT INTO public.who_global_data VALUES (78506, 0, 0, 0, 0, 332, 135);
INSERT INTO public.who_global_data VALUES (78507, 0, 9, 0, 0, 332, 206);
INSERT INTO public.who_global_data VALUES (78508, 0, 19, 0, 0, 332, 189);
INSERT INTO public.who_global_data VALUES (78509, 8, 71, 0, 1, 332, 129);
INSERT INTO public.who_global_data VALUES (78510, 0, 0, 0, 0, 332, 121);
INSERT INTO public.who_global_data VALUES (78511, 0, 0, 0, 0, 332, 59);
INSERT INTO public.who_global_data VALUES (78512, 0, 0, 0, 0, 332, 96);
INSERT INTO public.who_global_data VALUES (78513, 3, 13, 0, 0, 332, 41);
INSERT INTO public.who_global_data VALUES (78514, 0, 0, 0, 0, 332, 216);
INSERT INTO public.who_global_data VALUES (78515, 0, 0, 0, 0, 332, 236);
INSERT INTO public.who_global_data VALUES (78516, 0, 0, 0, 0, 332, 150);
INSERT INTO public.who_global_data VALUES (78517, 0, 3, 0, 0, 332, 61);
INSERT INTO public.who_global_data VALUES (78518, 0, 0, 0, 0, 332, 7);
INSERT INTO public.who_global_data VALUES (78519, 0, 40, 0, 0, 332, 169);
INSERT INTO public.who_global_data VALUES (78520, 371, 1765, 3, 33, 332, 28);
INSERT INTO public.who_global_data VALUES (78521, 0, 5, 0, 0, 332, 85);
INSERT INTO public.who_global_data VALUES (78522, 0, 0, 0, 0, 332, 211);
INSERT INTO public.who_global_data VALUES (78523, 0, 0, 0, 0, 332, 60);
INSERT INTO public.who_global_data VALUES (78524, 0, 0, 0, 0, 332, 3);
INSERT INTO public.who_global_data VALUES (78525, 8, 23, 0, 0, 332, 11);
INSERT INTO public.who_global_data VALUES (78526, 157, 1296, 0, 2, 332, 89);
INSERT INTO public.who_global_data VALUES (78527, 0, 0, 0, 0, 332, 24);
INSERT INTO public.who_global_data VALUES (78528, 0, 1, 0, 0, 332, 162);
INSERT INTO public.who_global_data VALUES (78529, 6, 90, 0, 0, 332, 100);
INSERT INTO public.who_global_data VALUES (78530, 0, 0, 0, 0, 332, 47);
INSERT INTO public.who_global_data VALUES (78531, 0, 0, 0, 0, 332, 29);
INSERT INTO public.who_global_data VALUES (78532, 0, 0, 0, 0, 332, 40);
INSERT INTO public.who_global_data VALUES (78533, 0, 0, 0, 0, 332, 222);
INSERT INTO public.who_global_data VALUES (78534, 0, 0, 0, 0, 332, 132);
INSERT INTO public.who_global_data VALUES (78535, 0, 1, 0, 0, 332, 130);
INSERT INTO public.who_global_data VALUES (78536, 0, 0, 0, 0, 332, 234);
INSERT INTO public.who_global_data VALUES (78537, 0, 0, 0, 0, 332, 23);
INSERT INTO public.who_global_data VALUES (78538, 0, 0, 0, 0, 332, 192);
INSERT INTO public.who_global_data VALUES (78539, 0, 0, 0, 0, 332, 69);
INSERT INTO public.who_global_data VALUES (78540, 0, 1, 0, 0, 332, 187);
INSERT INTO public.who_global_data VALUES (78541, 0, 0, 0, 0, 332, 230);
INSERT INTO public.who_global_data VALUES (78542, 3, 12, 0, 0, 332, 77);
INSERT INTO public.who_global_data VALUES (78543, 5, 70, 0, 0, 332, 9);
INSERT INTO public.who_global_data VALUES (78544, 10, 64, 0, 0, 332, 74);
INSERT INTO public.who_global_data VALUES (78545, 8, 31, 1, 1, 332, 224);
INSERT INTO public.who_global_data VALUES (78546, 958, 9004, 63, 354, 332, 199);
INSERT INTO public.who_global_data VALUES (78547, 9, 74, 1, 7, 332, 190);
INSERT INTO public.who_global_data VALUES (78548, 14, 35, 0, 0, 332, 12);
INSERT INTO public.who_global_data VALUES (78549, 0, 0, 0, 0, 332, 104);
INSERT INTO public.who_global_data VALUES (78550, 4, 38, 0, 0, 332, 153);
INSERT INTO public.who_global_data VALUES (78551, 977, 10149, 167, 631, 332, 91);
INSERT INTO public.who_global_data VALUES (78552, 0, 5, 0, 0, 332, 215);
INSERT INTO public.who_global_data VALUES (78553, 54, 572, 3, 12, 332, 84);
INSERT INTO public.who_global_data VALUES (78554, 0, 0, 0, 0, 332, 231);
INSERT INTO public.who_global_data VALUES (78555, 0, 5, 0, 0, 332, 196);
INSERT INTO public.who_global_data VALUES (78556, 0, 0, 0, 0, 332, 105);
INSERT INTO public.who_global_data VALUES (78557, 0, 0, 0, 0, 332, 122);
INSERT INTO public.who_global_data VALUES (78558, 0, 0, 0, 0, 332, 159);
INSERT INTO public.who_global_data VALUES (78559, 0, 0, 0, 0, 332, 75);
INSERT INTO public.who_global_data VALUES (78560, 3, 76, 0, 0, 332, 27);
INSERT INTO public.who_global_data VALUES (78561, 0, 0, 0, 0, 332, 54);
INSERT INTO public.who_global_data VALUES (78562, 0, 0, 0, 0, 332, 226);
INSERT INTO public.who_global_data VALUES (78563, 2, 8, 0, 0, 332, 79);
INSERT INTO public.who_global_data VALUES (78564, 29, 65, 1, 1, 332, 56);
INSERT INTO public.who_global_data VALUES (78565, 0, 0, 0, 0, 332, 117);
INSERT INTO public.who_global_data VALUES (78566, 0, 0, 0, 0, 332, 152);
INSERT INTO public.who_global_data VALUES (78567, 0, 0, 0, 0, 332, 16);
INSERT INTO public.who_global_data VALUES (78568, 2, 3, 0, 0, 332, 10);
INSERT INTO public.who_global_data VALUES (78569, 2, 3, 0, 0, 332, 201);
INSERT INTO public.who_global_data VALUES (78570, 2, 7, 0, 0, 332, 174);
INSERT INTO public.who_global_data VALUES (78571, 0, 0, 0, 0, 332, 119);
INSERT INTO public.who_global_data VALUES (78572, 0, 0, 0, 0, 332, 168);
INSERT INTO public.who_global_data VALUES (78573, 12, 133, 0, 0, 332, 99);
INSERT INTO public.who_global_data VALUES (78574, 2, 12, 0, 0, 332, 171);
INSERT INTO public.who_global_data VALUES (78575, 0, 0, 0, 0, 332, 87);
INSERT INTO public.who_global_data VALUES (78576, 1, 6, 0, 0, 332, 123);
INSERT INTO public.who_global_data VALUES (78577, 0, 0, 0, 0, 332, 151);
INSERT INTO public.who_global_data VALUES (78578, 1, 7, 0, 0, 332, 213);
INSERT INTO public.who_global_data VALUES (78579, 0, 0, 0, 0, 332, 118);
INSERT INTO public.who_global_data VALUES (78580, 0, 0, 0, 0, 332, 134);
INSERT INTO public.who_global_data VALUES (78581, 0, 0, 0, 0, 332, 65);
INSERT INTO public.who_global_data VALUES (78582, 0, 11, 0, 0, 332, 102);
INSERT INTO public.who_global_data VALUES (78583, 0, 0, 0, 0, 332, 223);
INSERT INTO public.who_global_data VALUES (78584, 0, 1, 0, 0, 332, 4);
INSERT INTO public.who_global_data VALUES (78585, 0, 5, 0, 0, 332, 146);
INSERT INTO public.who_global_data VALUES (78586, 0, 0, 0, 0, 332, 31);
INSERT INTO public.who_global_data VALUES (78587, 0, 0, 0, 0, 332, 127);
INSERT INTO public.who_global_data VALUES (78588, 2, 9, 0, 1, 332, 22);
INSERT INTO public.who_global_data VALUES (78589, 0, 0, 0, 0, 332, 115);
INSERT INTO public.who_global_data VALUES (78590, 0, 0, 0, 0, 332, 106);
INSERT INTO public.who_global_data VALUES (78591, 0, 0, 0, 0, 332, 90);
INSERT INTO public.who_global_data VALUES (78592, 0, 0, 0, 0, 332, 70);
INSERT INTO public.who_global_data VALUES (78593, 0, 5, 0, 0, 332, 46);
INSERT INTO public.who_global_data VALUES (78594, 130, 354, 0, 3, 332, 139);
INSERT INTO public.who_global_data VALUES (78595, 0, 0, 0, 0, 332, 42);
INSERT INTO public.who_global_data VALUES (78596, 0, 9, 0, 0, 332, 80);
INSERT INTO public.who_global_data VALUES (78597, 0, 0, 0, 0, 332, 203);
INSERT INTO public.who_global_data VALUES (78598, 0, 0, 0, 0, 332, 136);
INSERT INTO public.who_global_data VALUES (78599, 0, 6, 0, 0, 332, 63);
INSERT INTO public.who_global_data VALUES (78600, 0, 0, 0, 0, 332, 17);
INSERT INTO public.who_global_data VALUES (78601, 0, 0, 0, 0, 332, 172);
INSERT INTO public.who_global_data VALUES (78602, 3, 7, 0, 0, 332, 109);
INSERT INTO public.who_global_data VALUES (78603, 85, 277, 0, 0, 332, 200);
INSERT INTO public.who_global_data VALUES (78604, 1, 34, 0, 0, 332, 93);
INSERT INTO public.who_global_data VALUES (78605, 0, 22, 0, 0, 332, 5);
INSERT INTO public.who_global_data VALUES (78606, 0, 700, 0, 7, 332, 214);
INSERT INTO public.who_global_data VALUES (78607, 3, 23, 0, 0, 332, 204);
INSERT INTO public.who_global_data VALUES (78608, 0, 0, 0, 0, 332, 198);
INSERT INTO public.who_global_data VALUES (78609, 7, 12, 1, 1, 332, 173);
INSERT INTO public.who_global_data VALUES (78610, 0, 0, 0, 0, 332, 229);
INSERT INTO public.who_global_data VALUES (78611, 4, 9, 0, 0, 332, 76);
INSERT INTO public.who_global_data VALUES (78612, 2, 15, 0, 0, 332, 138);
INSERT INTO public.who_global_data VALUES (78613, 16, 53, 0, 1, 332, 98);
INSERT INTO public.who_global_data VALUES (78614, 0, 0, 0, 0, 332, 103);
INSERT INTO public.who_global_data VALUES (78615, 5, 22, 0, 0, 332, 225);
INSERT INTO public.who_global_data VALUES (78616, 2, 41, 0, 0, 332, 131);
INSERT INTO public.who_global_data VALUES (78617, 0, 0, 0, 0, 332, 235);
INSERT INTO public.who_global_data VALUES (78618, 244, 266, 0, 0, 332, 137);
INSERT INTO public.who_global_data VALUES (78619, 242, 7759, 6, 60, 332, 81);
INSERT INTO public.who_global_data VALUES (78620, 2, 3, 0, 0, 332, 182);
INSERT INTO public.who_global_data VALUES (78621, 0, 0, 0, 0, 332, 145);
INSERT INTO public.who_global_data VALUES (78622, 8, 25, 0, 0, 332, 26);
INSERT INTO public.who_global_data VALUES (78623, 0, 7, 0, 0, 332, 170);
INSERT INTO public.who_global_data VALUES (78624, 0, 0, 0, 0, 332, 191);
INSERT INTO public.who_global_data VALUES (78625, 0, 0, 0, 0, 332, 221);
INSERT INTO public.who_global_data VALUES (78626, 0, 1, 0, 0, 332, 64);
INSERT INTO public.who_global_data VALUES (78627, 0, 0, 0, 0, 332, 116);
INSERT INTO public.who_global_data VALUES (78628, 0, 0, 0, 0, 332, 128);
INSERT INTO public.who_global_data VALUES (78629, 0, 0, 0, 0, 332, 6);
INSERT INTO public.who_global_data VALUES (78630, 0, 6, 0, 0, 332, 227);
INSERT INTO public.who_global_data VALUES (78631, 0, 0, 0, 0, 332, 68);
INSERT INTO public.who_global_data VALUES (78632, 0, 0, 0, 0, 332, 184);
INSERT INTO public.who_global_data VALUES (78633, 0, 0, 0, 0, 332, 82);
INSERT INTO public.who_global_data VALUES (78634, 11, 60, 0, 2, 332, 149);
INSERT INTO public.who_global_data VALUES (78635, 0, 0, 0, 0, 332, 197);
INSERT INTO public.who_global_data VALUES (78636, 1, 25, 0, 0, 332, 78);
INSERT INTO public.who_global_data VALUES (78637, 0, 8, 0, 0, 332, 233);
INSERT INTO public.who_global_data VALUES (78638, 2, 4, 0, 0, 332, 133);
INSERT INTO public.who_global_data VALUES (78639, 0, 0, 0, 0, 332, 35);
INSERT INTO public.who_global_data VALUES (78640, 0, 0, 0, 0, 332, 114);
INSERT INTO public.who_global_data VALUES (78641, 12, 182, 0, 0, 332, 237);
INSERT INTO public.who_global_data VALUES (78642, 0, 0, 0, 0, 332, 55);
INSERT INTO public.who_global_data VALUES (78643, 0, 0, 0, 0, 332, 176);
INSERT INTO public.who_global_data VALUES (78644, 2, 7, 0, 0, 332, 202);
INSERT INTO public.who_global_data VALUES (78645, 17, 48, 0, 0, 332, 155);
INSERT INTO public.who_global_data VALUES (78646, 0, 0, 0, 0, 332, 32);
INSERT INTO public.who_global_data VALUES (78647, 0, 0, 0, 0, 332, 220);
INSERT INTO public.who_global_data VALUES (78648, 0, 11, 0, 0, 332, 30);
INSERT INTO public.who_global_data VALUES (78649, 0, 0, 0, 0, 332, 147);
INSERT INTO public.who_global_data VALUES (78650, 650, 2176, 17, 42, 332, 208);
INSERT INTO public.who_global_data VALUES (78651, 1, 6, 0, 0, 332, 45);
INSERT INTO public.who_global_data VALUES (78652, 0, 0, 0, 0, 332, 110);
INSERT INTO public.who_global_data VALUES (78653, 0, 0, 0, 0, 332, 88);
INSERT INTO public.who_global_data VALUES (78654, 101, 326, 0, 0, 332, 51);
INSERT INTO public.who_global_data VALUES (78655, 210, 834, 2, 5, 332, 209);
INSERT INTO public.who_global_data VALUES (78656, 0, 0, 0, 0, 332, 205);
INSERT INTO public.who_global_data VALUES (78657, 0, 0, 0, 0, 332, 18);
INSERT INTO public.who_global_data VALUES (78658, 6, 63, 0, 1, 332, 72);
INSERT INTO public.who_global_data VALUES (78659, 148, 617, 4, 7, 332, 44);
INSERT INTO public.who_global_data VALUES (78660, 0, 0, 0, 0, 332, 15);
INSERT INTO public.who_global_data VALUES (78661, 0, 5, 0, 0, 332, 25);
INSERT INTO public.who_global_data VALUES (78662, 0, 0, 0, 0, 332, 179);
INSERT INTO public.who_global_data VALUES (78663, 0, 0, 0, 0, 332, 34);
INSERT INTO public.who_global_data VALUES (78664, 0, 0, 0, 0, 332, 207);
INSERT INTO public.who_global_data VALUES (78665, 0, 10, 0, 0, 332, 166);
INSERT INTO public.who_global_data VALUES (78666, 1, 1, 0, 0, 332, 126);
INSERT INTO public.who_global_data VALUES (78667, 0, 0, 0, 0, 332, 97);
INSERT INTO public.who_global_data VALUES (78668, 0, 0, 0, 0, 332, 36);
INSERT INTO public.who_global_data VALUES (78669, 0, 0, 0, 0, 332, 125);
INSERT INTO public.who_global_data VALUES (78670, 0, 0, 0, 0, 332, 124);
INSERT INTO public.who_global_data VALUES (78671, 0, 1, 0, 0, 332, 185);
INSERT INTO public.who_global_data VALUES (78672, 0, 78, 0, 0, 332, 194);
INSERT INTO public.who_global_data VALUES (78673, 0, 0, 0, 0, 332, 144);
INSERT INTO public.who_global_data VALUES (78674, 0, 700, 0, 25, 332, 19);
INSERT INTO public.who_global_data VALUES (78675, 0, 0, 0, 0, 332, 217);
INSERT INTO public.who_global_data VALUES (78676, 0, 0, 0, 0, 332, 148);
INSERT INTO public.who_global_data VALUES (78677, 0, 0, 0, 0, 332, 86);
INSERT INTO public.who_global_data VALUES (78678, 0, 0, 0, 0, 332, 13);
INSERT INTO public.who_global_data VALUES (78679, 0, 0, 0, 0, 332, 157);
INSERT INTO public.who_global_data VALUES (78680, 4, 39, 0, 0, 332, 8);
INSERT INTO public.who_global_data VALUES (78681, 0, 0, 0, 0, 332, 73);
INSERT INTO public.who_global_data VALUES (78682, 0, 0, 0, 0, 332, 101);
INSERT INTO public.who_global_data VALUES (78683, 0, 0, 0, 0, 332, 165);
INSERT INTO public.who_global_data VALUES (78684, 0, 0, 0, 0, 332, 14);
INSERT INTO public.who_global_data VALUES (78685, 0, 8, 0, 0, 333, 193);
INSERT INTO public.who_global_data VALUES (78686, 0, 2, 0, 0, 333, 113);
INSERT INTO public.who_global_data VALUES (78687, 0, 24, 0, 0, 333, 143);
INSERT INTO public.who_global_data VALUES (78688, 0, 0, 0, 0, 333, 219);
INSERT INTO public.who_global_data VALUES (78689, 0, 1, 0, 0, 333, 186);
INSERT INTO public.who_global_data VALUES (78690, 0, 0, 0, 0, 333, 52);
INSERT INTO public.who_global_data VALUES (78691, 0, 0, 0, 0, 333, 180);
INSERT INTO public.who_global_data VALUES (78692, 0, 0, 0, 0, 333, 167);
INSERT INTO public.who_global_data VALUES (78693, 0, 16, 0, 1, 333, 154);
INSERT INTO public.who_global_data VALUES (78694, 0, 1, 0, 0, 333, 94);
INSERT INTO public.who_global_data VALUES (78695, 0, 0, 0, 0, 333, 66);
INSERT INTO public.who_global_data VALUES (78696, 0, 96, 0, 3, 333, 58);
INSERT INTO public.who_global_data VALUES (78697, 29, 131, 0, 0, 333, 163);
INSERT INTO public.who_global_data VALUES (78698, 0, 9, 0, 0, 333, 37);
INSERT INTO public.who_global_data VALUES (78699, 0, 0, 0, 0, 333, 142);
INSERT INTO public.who_global_data VALUES (78700, 15, 114, 0, 0, 333, 83);
INSERT INTO public.who_global_data VALUES (78701, 0, 7, 0, 0, 333, 228);
INSERT INTO public.who_global_data VALUES (78702, 0, 0, 0, 0, 333, 188);
INSERT INTO public.who_global_data VALUES (78703, 0, 6, 0, 0, 333, 62);
INSERT INTO public.who_global_data VALUES (78704, 94, 501, 1, 1, 333, 160);
INSERT INTO public.who_global_data VALUES (78705, 0, 0, 0, 0, 333, 50);
INSERT INTO public.who_global_data VALUES (78706, 0, 0, 0, 0, 333, 33);
INSERT INTO public.who_global_data VALUES (78707, 0, 0, 0, 0, 333, 183);
INSERT INTO public.who_global_data VALUES (78708, 0, 1, 0, 0, 333, 92);
INSERT INTO public.who_global_data VALUES (78709, 0, 0, 0, 0, 333, 158);
INSERT INTO public.who_global_data VALUES (78710, 0, 0, 0, 0, 333, 67);
INSERT INTO public.who_global_data VALUES (78711, 0, 2, 0, 0, 333, 57);
INSERT INTO public.who_global_data VALUES (78712, 0, 0, 0, 0, 333, 38);
INSERT INTO public.who_global_data VALUES (78713, 0, 29, 0, 0, 333, 141);
INSERT INTO public.who_global_data VALUES (78714, 0, 0, 0, 0, 333, 178);
INSERT INTO public.who_global_data VALUES (78715, 5, 5, 0, 0, 333, 108);
INSERT INTO public.who_global_data VALUES (78716, 0, 4, 0, 0, 333, 39);
INSERT INTO public.who_global_data VALUES (78717, 0, 0, 0, 0, 333, 2);
INSERT INTO public.who_global_data VALUES (78718, 0, 0, 0, 0, 333, 195);
INSERT INTO public.who_global_data VALUES (78719, 0, 0, 0, 0, 333, 107);
INSERT INTO public.who_global_data VALUES (78720, 1, 7, 0, 0, 333, 161);
INSERT INTO public.who_global_data VALUES (78721, 0, 6, 0, 0, 333, 212);
INSERT INTO public.who_global_data VALUES (78722, 5, 81, 0, 0, 333, 181);
INSERT INTO public.who_global_data VALUES (78723, 0, 0, 0, 0, 333, 53);
INSERT INTO public.who_global_data VALUES (78724, 0, 0, 0, 0, 333, 164);
INSERT INTO public.who_global_data VALUES (78725, 0, 0, 0, 0, 333, 140);
INSERT INTO public.who_global_data VALUES (78726, 3, 17, 0, 0, 333, 20);
INSERT INTO public.who_global_data VALUES (78727, 20, 80928, 17, 3140, 333, 112);
INSERT INTO public.who_global_data VALUES (78728, 2, 7, 0, 0, 333, 111);
INSERT INTO public.who_global_data VALUES (78729, 0, 0, 0, 0, 333, 71);
INSERT INTO public.who_global_data VALUES (78730, 0, 0, 0, 0, 333, 218);
INSERT INTO public.who_global_data VALUES (78731, 0, 0, 0, 0, 333, 43);
INSERT INTO public.who_global_data VALUES (78732, 0, 13, 0, 0, 333, 49);
INSERT INTO public.who_global_data VALUES (78733, 0, 0, 0, 0, 333, 1);
INSERT INTO public.who_global_data VALUES (78734, 0, 12, 0, 0, 333, 48);
INSERT INTO public.who_global_data VALUES (78735, 0, 0, 0, 0, 333, 232);
INSERT INTO public.who_global_data VALUES (78736, 0, 0, 0, 0, 333, 175);
INSERT INTO public.who_global_data VALUES (78737, 2, 2, 0, 0, 333, 21);
INSERT INTO public.who_global_data VALUES (78738, 8, 40, 0, 0, 333, 156);
INSERT INTO public.who_global_data VALUES (78739, 0, 0, 0, 0, 333, 95);
INSERT INTO public.who_global_data VALUES (78740, 0, 0, 0, 0, 333, 177);
INSERT INTO public.who_global_data VALUES (78741, 75, 113, 0, 0, 333, 210);
INSERT INTO public.who_global_data VALUES (78742, 0, 0, 0, 0, 333, 120);
INSERT INTO public.who_global_data VALUES (78743, 0, 0, 0, 0, 333, 135);
INSERT INTO public.who_global_data VALUES (78744, 4, 9, 0, 0, 333, 206);
INSERT INTO public.who_global_data VALUES (78745, 0, 19, 0, 0, 333, 189);
INSERT INTO public.who_global_data VALUES (78746, 0, 63, 0, 1, 333, 129);
INSERT INTO public.who_global_data VALUES (78747, 0, 0, 0, 0, 333, 121);
INSERT INTO public.who_global_data VALUES (78748, 0, 0, 0, 0, 333, 59);
INSERT INTO public.who_global_data VALUES (78749, 0, 0, 0, 0, 333, 96);
INSERT INTO public.who_global_data VALUES (78750, 0, 10, 0, 0, 333, 41);
INSERT INTO public.who_global_data VALUES (78751, 0, 0, 0, 0, 333, 216);
INSERT INTO public.who_global_data VALUES (78752, 0, 0, 0, 0, 333, 236);
INSERT INTO public.who_global_data VALUES (78753, 0, 0, 0, 0, 333, 150);
INSERT INTO public.who_global_data VALUES (78754, 0, 3, 0, 0, 333, 61);
INSERT INTO public.who_global_data VALUES (78755, 0, 0, 0, 0, 333, 7);
INSERT INTO public.who_global_data VALUES (78756, 10, 40, 0, 0, 333, 169);
INSERT INTO public.who_global_data VALUES (78757, 286, 1394, 11, 30, 333, 28);
INSERT INTO public.who_global_data VALUES (78758, 0, 5, 0, 0, 333, 85);
INSERT INTO public.who_global_data VALUES (78759, 0, 0, 0, 0, 333, 211);
INSERT INTO public.who_global_data VALUES (78760, 0, 0, 0, 0, 333, 60);
INSERT INTO public.who_global_data VALUES (78761, 0, 0, 0, 0, 333, 3);
INSERT INTO public.who_global_data VALUES (78762, 2, 15, 0, 0, 333, 11);
INSERT INTO public.who_global_data VALUES (78763, 237, 1139, 2, 2, 333, 89);
INSERT INTO public.who_global_data VALUES (78764, 0, 0, 0, 0, 333, 24);
INSERT INTO public.who_global_data VALUES (78765, 0, 1, 0, 0, 333, 162);
INSERT INTO public.who_global_data VALUES (78766, 11, 84, 0, 0, 333, 100);
INSERT INTO public.who_global_data VALUES (78767, 0, 0, 0, 0, 333, 47);
INSERT INTO public.who_global_data VALUES (78768, 0, 0, 0, 0, 333, 29);
INSERT INTO public.who_global_data VALUES (78769, 0, 0, 0, 0, 333, 40);
INSERT INTO public.who_global_data VALUES (78770, 0, 0, 0, 0, 333, 222);
INSERT INTO public.who_global_data VALUES (78771, 0, 0, 0, 0, 333, 132);
INSERT INTO public.who_global_data VALUES (78772, 0, 1, 0, 0, 333, 130);
INSERT INTO public.who_global_data VALUES (78773, 0, 0, 0, 0, 333, 234);
INSERT INTO public.who_global_data VALUES (78774, 0, 0, 0, 0, 333, 23);
INSERT INTO public.who_global_data VALUES (78775, 0, 0, 0, 0, 333, 192);
INSERT INTO public.who_global_data VALUES (78776, 0, 0, 0, 0, 333, 69);
INSERT INTO public.who_global_data VALUES (78777, 0, 1, 0, 0, 333, 187);
INSERT INTO public.who_global_data VALUES (78778, 0, 0, 0, 0, 333, 230);
INSERT INTO public.who_global_data VALUES (78779, 1, 9, 0, 0, 333, 77);
INSERT INTO public.who_global_data VALUES (78780, 10, 65, 0, 0, 333, 9);
INSERT INTO public.who_global_data VALUES (78781, 6, 54, 0, 0, 333, 74);
INSERT INTO public.who_global_data VALUES (78782, 13, 23, 0, 0, 333, 224);
INSERT INTO public.who_global_data VALUES (78783, 881, 8046, 54, 291, 333, 199);
INSERT INTO public.who_global_data VALUES (78784, 1, 65, 2, 6, 333, 190);
INSERT INTO public.who_global_data VALUES (78785, 0, 21, 0, 0, 333, 12);
INSERT INTO public.who_global_data VALUES (78786, 0, 0, 0, 0, 333, 104);
INSERT INTO public.who_global_data VALUES (78787, 9, 34, 0, 0, 333, 153);
INSERT INTO public.who_global_data VALUES (78788, 1797, 9172, 98, 464, 333, 91);
INSERT INTO public.who_global_data VALUES (78789, 5, 5, 0, 0, 333, 215);
INSERT INTO public.who_global_data VALUES (78790, 0, 518, 0, 9, 333, 84);
INSERT INTO public.who_global_data VALUES (78791, 0, 0, 0, 0, 333, 231);
INSERT INTO public.who_global_data VALUES (78792, 0, 5, 0, 0, 333, 196);
INSERT INTO public.who_global_data VALUES (78793, 0, 0, 0, 0, 333, 105);
INSERT INTO public.who_global_data VALUES (78794, 0, 0, 0, 0, 333, 122);
INSERT INTO public.who_global_data VALUES (78795, 0, 0, 0, 0, 333, 159);
INSERT INTO public.who_global_data VALUES (78796, 0, 0, 0, 0, 333, 75);
INSERT INTO public.who_global_data VALUES (78797, 5, 73, 0, 0, 333, 27);
INSERT INTO public.who_global_data VALUES (78798, 0, 0, 0, 0, 333, 54);
INSERT INTO public.who_global_data VALUES (78799, 0, 0, 0, 0, 333, 226);
INSERT INTO public.who_global_data VALUES (78800, 3, 6, 0, 0, 333, 79);
INSERT INTO public.who_global_data VALUES (78801, 0, 36, 0, 0, 333, 56);
INSERT INTO public.who_global_data VALUES (78802, 0, 0, 0, 0, 333, 117);
INSERT INTO public.who_global_data VALUES (78803, 0, 0, 0, 0, 333, 152);
INSERT INTO public.who_global_data VALUES (78804, 0, 0, 0, 0, 333, 16);
INSERT INTO public.who_global_data VALUES (78805, 0, 1, 0, 0, 333, 10);
INSERT INTO public.who_global_data VALUES (78806, 0, 1, 0, 0, 333, 201);
INSERT INTO public.who_global_data VALUES (78807, 0, 5, 0, 0, 333, 174);
INSERT INTO public.who_global_data VALUES (78808, 0, 0, 0, 0, 333, 119);
INSERT INTO public.who_global_data VALUES (78809, 0, 0, 0, 0, 333, 168);
INSERT INTO public.who_global_data VALUES (78810, 0, 121, 0, 0, 333, 99);
INSERT INTO public.who_global_data VALUES (78811, 2, 10, 0, 0, 333, 171);
INSERT INTO public.who_global_data VALUES (78812, 0, 0, 0, 0, 333, 87);
INSERT INTO public.who_global_data VALUES (78813, 2, 5, 0, 0, 333, 123);
INSERT INTO public.who_global_data VALUES (78814, 0, 0, 0, 0, 333, 151);
INSERT INTO public.who_global_data VALUES (78815, 0, 6, 0, 0, 333, 213);
INSERT INTO public.who_global_data VALUES (78816, 0, 0, 0, 0, 333, 118);
INSERT INTO public.who_global_data VALUES (78817, 0, 0, 0, 0, 333, 134);
INSERT INTO public.who_global_data VALUES (78818, 0, 0, 0, 0, 333, 65);
INSERT INTO public.who_global_data VALUES (78819, 0, 11, 0, 0, 333, 102);
INSERT INTO public.who_global_data VALUES (78820, 0, 0, 0, 0, 333, 223);
INSERT INTO public.who_global_data VALUES (78821, 0, 1, 0, 0, 333, 4);
INSERT INTO public.who_global_data VALUES (78822, 5, 5, 0, 0, 333, 146);
INSERT INTO public.who_global_data VALUES (78823, 0, 0, 0, 0, 333, 31);
INSERT INTO public.who_global_data VALUES (78824, 0, 0, 0, 0, 333, 127);
INSERT INTO public.who_global_data VALUES (78825, 1, 7, 1, 1, 333, 22);
INSERT INTO public.who_global_data VALUES (78826, 0, 0, 0, 0, 333, 115);
INSERT INTO public.who_global_data VALUES (78827, 0, 0, 0, 0, 333, 106);
INSERT INTO public.who_global_data VALUES (78828, 0, 0, 0, 0, 333, 90);
INSERT INTO public.who_global_data VALUES (78829, 0, 0, 0, 0, 333, 70);
INSERT INTO public.who_global_data VALUES (78830, 0, 5, 0, 0, 333, 46);
INSERT INTO public.who_global_data VALUES (78831, 61, 224, 1, 3, 333, 139);
INSERT INTO public.who_global_data VALUES (78832, 0, 0, 0, 0, 333, 42);
INSERT INTO public.who_global_data VALUES (78833, 0, 9, 0, 0, 333, 80);
INSERT INTO public.who_global_data VALUES (78834, 0, 0, 0, 0, 333, 203);
INSERT INTO public.who_global_data VALUES (78835, 0, 0, 0, 0, 333, 136);
INSERT INTO public.who_global_data VALUES (78836, 0, 6, 0, 0, 333, 63);
INSERT INTO public.who_global_data VALUES (78837, 0, 0, 0, 0, 333, 17);
INSERT INTO public.who_global_data VALUES (78838, 0, 0, 0, 0, 333, 172);
INSERT INTO public.who_global_data VALUES (78839, 1, 4, 0, 0, 333, 109);
INSERT INTO public.who_global_data VALUES (78840, 23, 192, 0, 0, 333, 200);
INSERT INTO public.who_global_data VALUES (78841, 4, 33, 0, 0, 333, 93);
INSERT INTO public.who_global_data VALUES (78842, 2, 22, 0, 0, 333, 5);
INSERT INTO public.who_global_data VALUES (78843, 0, 700, 0, 7, 333, 214);
INSERT INTO public.who_global_data VALUES (78844, 10, 20, 0, 0, 333, 204);
INSERT INTO public.who_global_data VALUES (78845, 0, 0, 0, 0, 333, 198);
INSERT INTO public.who_global_data VALUES (78846, 5, 5, 0, 0, 333, 173);
INSERT INTO public.who_global_data VALUES (78847, 0, 0, 0, 0, 333, 229);
INSERT INTO public.who_global_data VALUES (78848, 0, 5, 0, 0, 333, 76);
INSERT INTO public.who_global_data VALUES (78849, 2, 13, 0, 0, 333, 138);
INSERT INTO public.who_global_data VALUES (78850, 9, 37, 0, 1, 333, 98);
INSERT INTO public.who_global_data VALUES (78851, 0, 0, 0, 0, 333, 103);
INSERT INTO public.who_global_data VALUES (78852, 6, 17, 0, 0, 333, 225);
INSERT INTO public.who_global_data VALUES (78853, 9, 39, 0, 0, 333, 131);
INSERT INTO public.who_global_data VALUES (78854, 0, 0, 0, 0, 333, 235);
INSERT INTO public.who_global_data VALUES (78855, 3, 22, 0, 0, 333, 137);
INSERT INTO public.who_global_data VALUES (78856, 131, 7517, 3, 54, 333, 81);
INSERT INTO public.who_global_data VALUES (78857, 0, 1, 0, 0, 333, 182);
INSERT INTO public.who_global_data VALUES (78858, 0, 0, 0, 0, 333, 145);
INSERT INTO public.who_global_data VALUES (78859, 2, 17, 0, 0, 333, 26);
INSERT INTO public.who_global_data VALUES (78860, 0, 7, 0, 0, 333, 170);
INSERT INTO public.who_global_data VALUES (78861, 0, 0, 0, 0, 333, 191);
INSERT INTO public.who_global_data VALUES (78862, 0, 0, 0, 0, 333, 221);
INSERT INTO public.who_global_data VALUES (78863, 0, 1, 0, 0, 333, 64);
INSERT INTO public.who_global_data VALUES (78864, 0, 0, 0, 0, 333, 116);
INSERT INTO public.who_global_data VALUES (78865, 0, 0, 0, 0, 333, 128);
INSERT INTO public.who_global_data VALUES (78866, 0, 0, 0, 0, 333, 6);
INSERT INTO public.who_global_data VALUES (78867, 0, 6, 0, 0, 333, 227);
INSERT INTO public.who_global_data VALUES (78868, 0, 0, 0, 0, 333, 68);
INSERT INTO public.who_global_data VALUES (78869, 0, 0, 0, 0, 333, 184);
INSERT INTO public.who_global_data VALUES (78870, 0, 0, 0, 0, 333, 82);
INSERT INTO public.who_global_data VALUES (78871, 12, 49, 1, 2, 333, 149);
INSERT INTO public.who_global_data VALUES (78872, 0, 0, 0, 0, 333, 197);
INSERT INTO public.who_global_data VALUES (78873, 5, 24, 0, 0, 333, 78);
INSERT INTO public.who_global_data VALUES (78874, 0, 8, 0, 0, 333, 233);
INSERT INTO public.who_global_data VALUES (78875, 1, 2, 0, 0, 333, 133);
INSERT INTO public.who_global_data VALUES (78876, 0, 0, 0, 0, 333, 35);
INSERT INTO public.who_global_data VALUES (78877, 0, 0, 0, 0, 333, 114);
INSERT INTO public.who_global_data VALUES (78878, 6, 170, 0, 0, 333, 237);
INSERT INTO public.who_global_data VALUES (78879, 0, 0, 0, 0, 333, 55);
INSERT INTO public.who_global_data VALUES (78880, 0, 0, 0, 0, 333, 176);
INSERT INTO public.who_global_data VALUES (78881, 0, 5, 0, 0, 333, 202);
INSERT INTO public.who_global_data VALUES (78882, 11, 31, 0, 0, 333, 155);
INSERT INTO public.who_global_data VALUES (78883, 0, 0, 0, 0, 333, 32);
INSERT INTO public.who_global_data VALUES (78884, 0, 0, 0, 0, 333, 220);
INSERT INTO public.who_global_data VALUES (78885, 4, 11, 0, 0, 333, 30);
INSERT INTO public.who_global_data VALUES (78886, 0, 0, 0, 0, 333, 147);
INSERT INTO public.who_global_data VALUES (78887, 369, 1526, 14, 25, 333, 208);
INSERT INTO public.who_global_data VALUES (78888, 0, 5, 0, 0, 333, 45);
INSERT INTO public.who_global_data VALUES (78889, 0, 0, 0, 0, 333, 110);
INSERT INTO public.who_global_data VALUES (78890, 0, 0, 0, 0, 333, 88);
INSERT INTO public.who_global_data VALUES (78891, 46, 225, 0, 0, 333, 51);
INSERT INTO public.who_global_data VALUES (78892, 192, 624, 0, 3, 333, 209);
INSERT INTO public.who_global_data VALUES (78893, 0, 0, 0, 0, 333, 205);
INSERT INTO public.who_global_data VALUES (78894, 0, 0, 0, 0, 333, 18);
INSERT INTO public.who_global_data VALUES (78895, 3, 57, 0, 1, 333, 72);
INSERT INTO public.who_global_data VALUES (78896, 57, 469, 1, 3, 333, 44);
INSERT INTO public.who_global_data VALUES (78897, 0, 0, 0, 0, 333, 15);
INSERT INTO public.who_global_data VALUES (78898, 0, 5, 0, 0, 333, 25);
INSERT INTO public.who_global_data VALUES (78899, 0, 0, 0, 0, 333, 179);
INSERT INTO public.who_global_data VALUES (78900, 0, 0, 0, 0, 333, 34);
INSERT INTO public.who_global_data VALUES (78901, 0, 0, 0, 0, 333, 207);
INSERT INTO public.who_global_data VALUES (78902, 4, 10, 0, 0, 333, 166);
INSERT INTO public.who_global_data VALUES (78903, 0, 0, 0, 0, 333, 126);
INSERT INTO public.who_global_data VALUES (78904, 0, 0, 0, 0, 333, 97);
INSERT INTO public.who_global_data VALUES (78905, 0, 0, 0, 0, 333, 36);
INSERT INTO public.who_global_data VALUES (78906, 0, 0, 0, 0, 333, 125);
INSERT INTO public.who_global_data VALUES (78907, 0, 0, 0, 0, 333, 124);
INSERT INTO public.who_global_data VALUES (78908, 0, 1, 0, 0, 333, 185);
INSERT INTO public.who_global_data VALUES (78909, 15, 78, 0, 0, 333, 194);
INSERT INTO public.who_global_data VALUES (78910, 0, 0, 0, 0, 333, 144);
INSERT INTO public.who_global_data VALUES (78911, 224, 700, 6, 25, 333, 19);
INSERT INTO public.who_global_data VALUES (78912, 0, 0, 0, 0, 333, 217);
INSERT INTO public.who_global_data VALUES (78913, 0, 0, 0, 0, 333, 148);
INSERT INTO public.who_global_data VALUES (78914, 0, 0, 0, 0, 333, 86);
INSERT INTO public.who_global_data VALUES (78915, 0, 0, 0, 0, 333, 13);
INSERT INTO public.who_global_data VALUES (78916, 0, 0, 0, 0, 333, 157);
INSERT INTO public.who_global_data VALUES (78917, 0, 35, 0, 0, 333, 8);
INSERT INTO public.who_global_data VALUES (78918, 0, 0, 0, 0, 333, 73);
INSERT INTO public.who_global_data VALUES (78919, 0, 0, 0, 0, 333, 101);
INSERT INTO public.who_global_data VALUES (78920, 0, 0, 0, 0, 333, 165);
INSERT INTO public.who_global_data VALUES (78921, 0, 0, 0, 0, 333, 14);
INSERT INTO public.who_global_data VALUES (78922, 0, 8, 0, 0, 334, 193);
INSERT INTO public.who_global_data VALUES (78923, 2, 2, 0, 0, 334, 113);
INSERT INTO public.who_global_data VALUES (78924, 3, 24, 0, 0, 334, 143);
INSERT INTO public.who_global_data VALUES (78925, 0, 0, 0, 0, 334, 219);
INSERT INTO public.who_global_data VALUES (78926, 0, 1, 0, 0, 334, 186);
INSERT INTO public.who_global_data VALUES (78927, 0, 0, 0, 0, 334, 52);
INSERT INTO public.who_global_data VALUES (78928, 0, 0, 0, 0, 334, 180);
INSERT INTO public.who_global_data VALUES (78929, 0, 0, 0, 0, 334, 167);
INSERT INTO public.who_global_data VALUES (78930, 0, 16, 0, 1, 334, 154);
INSERT INTO public.who_global_data VALUES (78931, 0, 1, 0, 0, 334, 94);
INSERT INTO public.who_global_data VALUES (78932, 0, 0, 0, 0, 334, 66);
INSERT INTO public.who_global_data VALUES (78933, 15, 96, 0, 3, 334, 58);
INSERT INTO public.who_global_data VALUES (78934, 3, 102, 0, 0, 334, 163);
INSERT INTO public.who_global_data VALUES (78935, 0, 9, 0, 0, 334, 37);
INSERT INTO public.who_global_data VALUES (78936, 0, 0, 0, 0, 334, 142);
INSERT INTO public.who_global_data VALUES (78937, 16, 99, 0, 0, 334, 83);
INSERT INTO public.who_global_data VALUES (78938, 0, 7, 0, 0, 334, 228);
INSERT INTO public.who_global_data VALUES (78939, 0, 0, 0, 0, 334, 188);
INSERT INTO public.who_global_data VALUES (78940, 0, 6, 0, 0, 334, 62);
INSERT INTO public.who_global_data VALUES (78941, 64, 407, 0, 0, 334, 160);
INSERT INTO public.who_global_data VALUES (78942, 0, 0, 0, 0, 334, 50);
INSERT INTO public.who_global_data VALUES (78943, 0, 0, 0, 0, 334, 33);
INSERT INTO public.who_global_data VALUES (78944, 0, 0, 0, 0, 334, 183);
INSERT INTO public.who_global_data VALUES (78945, 0, 1, 0, 0, 334, 92);
INSERT INTO public.who_global_data VALUES (78946, 0, 0, 0, 0, 334, 158);
INSERT INTO public.who_global_data VALUES (78947, 0, 0, 0, 0, 334, 67);
INSERT INTO public.who_global_data VALUES (78948, 0, 2, 0, 0, 334, 57);
INSERT INTO public.who_global_data VALUES (78949, 0, 0, 0, 0, 334, 38);
INSERT INTO public.who_global_data VALUES (78950, 6, 29, 0, 0, 334, 141);
INSERT INTO public.who_global_data VALUES (78951, 0, 0, 0, 0, 334, 178);
INSERT INTO public.who_global_data VALUES (78952, 0, 0, 0, 0, 334, 108);
INSERT INTO public.who_global_data VALUES (78953, 2, 4, 0, 0, 334, 39);
INSERT INTO public.who_global_data VALUES (78954, 0, 0, 0, 0, 334, 2);
INSERT INTO public.who_global_data VALUES (78955, 0, 0, 0, 0, 334, 195);
INSERT INTO public.who_global_data VALUES (78956, 0, 0, 0, 0, 334, 107);
INSERT INTO public.who_global_data VALUES (78957, 0, 6, 0, 0, 334, 161);
INSERT INTO public.who_global_data VALUES (78958, 0, 6, 0, 0, 334, 212);
INSERT INTO public.who_global_data VALUES (78959, 12, 76, 0, 0, 334, 181);
INSERT INTO public.who_global_data VALUES (78960, 0, 0, 0, 0, 334, 53);
INSERT INTO public.who_global_data VALUES (78961, 0, 0, 0, 0, 334, 164);
INSERT INTO public.who_global_data VALUES (78962, 0, 0, 0, 0, 334, 140);
INSERT INTO public.who_global_data VALUES (78963, 0, 14, 0, 0, 334, 20);
INSERT INTO public.who_global_data VALUES (78964, 45, 80908, 23, 3123, 334, 112);
INSERT INTO public.who_global_data VALUES (78965, 0, 5, 0, 0, 334, 111);
INSERT INTO public.who_global_data VALUES (78966, 0, 0, 0, 0, 334, 71);
INSERT INTO public.who_global_data VALUES (78967, 0, 0, 0, 0, 334, 218);
INSERT INTO public.who_global_data VALUES (78968, 0, 0, 0, 0, 334, 43);
INSERT INTO public.who_global_data VALUES (78969, 4, 13, 0, 0, 334, 49);
INSERT INTO public.who_global_data VALUES (78970, 0, 0, 0, 0, 334, 1);
INSERT INTO public.who_global_data VALUES (78971, 0, 12, 0, 0, 334, 48);
INSERT INTO public.who_global_data VALUES (78972, 0, 0, 0, 0, 334, 232);
INSERT INTO public.who_global_data VALUES (78973, 0, 0, 0, 0, 334, 175);
INSERT INTO public.who_global_data VALUES (78974, 0, 0, 0, 0, 334, 21);
INSERT INTO public.who_global_data VALUES (78975, 6, 32, 0, 0, 334, 156);
INSERT INTO public.who_global_data VALUES (78976, 0, 0, 0, 0, 334, 95);
INSERT INTO public.who_global_data VALUES (78977, 0, 0, 0, 0, 334, 177);
INSERT INTO public.who_global_data VALUES (78978, 7, 38, 0, 0, 334, 210);
INSERT INTO public.who_global_data VALUES (78979, 0, 0, 0, 0, 334, 120);
INSERT INTO public.who_global_data VALUES (78980, 0, 0, 0, 0, 334, 135);
INSERT INTO public.who_global_data VALUES (78981, 0, 5, 0, 0, 334, 206);
INSERT INTO public.who_global_data VALUES (78982, 1, 19, 0, 0, 334, 189);
INSERT INTO public.who_global_data VALUES (78983, 10, 63, 0, 1, 334, 129);
INSERT INTO public.who_global_data VALUES (78984, 0, 0, 0, 0, 334, 121);
INSERT INTO public.who_global_data VALUES (78985, 0, 0, 0, 0, 334, 59);
INSERT INTO public.who_global_data VALUES (78986, 0, 0, 0, 0, 334, 96);
INSERT INTO public.who_global_data VALUES (78987, 0, 10, 0, 0, 334, 41);
INSERT INTO public.who_global_data VALUES (78988, 0, 0, 0, 0, 334, 216);
INSERT INTO public.who_global_data VALUES (78989, 0, 0, 0, 0, 334, 236);
INSERT INTO public.who_global_data VALUES (78990, 0, 0, 0, 0, 334, 150);
INSERT INTO public.who_global_data VALUES (78991, 0, 3, 0, 0, 334, 61);
INSERT INTO public.who_global_data VALUES (78992, 0, 0, 0, 0, 334, 7);
INSERT INTO public.who_global_data VALUES (78993, 11, 30, 0, 0, 334, 169);
INSERT INTO public.who_global_data VALUES (78994, 410, 1108, 9, 19, 334, 28);
INSERT INTO public.who_global_data VALUES (78995, 0, 5, 0, 0, 334, 85);
INSERT INTO public.who_global_data VALUES (78996, 0, 0, 0, 0, 334, 211);
INSERT INTO public.who_global_data VALUES (78997, 0, 0, 0, 0, 334, 60);
INSERT INTO public.who_global_data VALUES (78998, 0, 0, 0, 0, 334, 3);
INSERT INTO public.who_global_data VALUES (78999, 1, 13, 0, 0, 334, 11);
INSERT INTO public.who_global_data VALUES (79000, 55, 902, 0, 0, 334, 89);
INSERT INTO public.who_global_data VALUES (79001, 0, 0, 0, 0, 334, 24);
INSERT INTO public.who_global_data VALUES (79002, 0, 1, 0, 0, 334, 162);
INSERT INTO public.who_global_data VALUES (79003, 7, 73, 0, 0, 334, 100);
INSERT INTO public.who_global_data VALUES (79004, 0, 0, 0, 0, 334, 47);
INSERT INTO public.who_global_data VALUES (79005, 0, 0, 0, 0, 334, 29);
INSERT INTO public.who_global_data VALUES (79006, 0, 0, 0, 0, 334, 40);
INSERT INTO public.who_global_data VALUES (79007, 0, 0, 0, 0, 334, 222);
INSERT INTO public.who_global_data VALUES (79008, 0, 0, 0, 0, 334, 132);
INSERT INTO public.who_global_data VALUES (79009, 1, 1, 0, 0, 334, 130);
INSERT INTO public.who_global_data VALUES (79010, 0, 0, 0, 0, 334, 234);
INSERT INTO public.who_global_data VALUES (79011, 0, 0, 0, 0, 334, 23);
INSERT INTO public.who_global_data VALUES (79012, 0, 0, 0, 0, 334, 192);
INSERT INTO public.who_global_data VALUES (79013, 0, 0, 0, 0, 334, 69);
INSERT INTO public.who_global_data VALUES (79014, 0, 1, 0, 0, 334, 187);
INSERT INTO public.who_global_data VALUES (79015, 0, 0, 0, 0, 334, 230);
INSERT INTO public.who_global_data VALUES (79016, 1, 8, 0, 0, 334, 77);
INSERT INTO public.who_global_data VALUES (79017, 2, 55, 0, 0, 334, 9);
INSERT INTO public.who_global_data VALUES (79018, 5, 48, 0, 0, 334, 74);
INSERT INTO public.who_global_data VALUES (79019, 0, 10, 0, 0, 334, 224);
INSERT INTO public.who_global_data VALUES (79020, 595, 7165, 43, 237, 334, 199);
INSERT INTO public.who_global_data VALUES (79021, 0, 64, 0, 4, 334, 190);
INSERT INTO public.who_global_data VALUES (79022, 2, 21, 0, 0, 334, 12);
INSERT INTO public.who_global_data VALUES (79023, 0, 0, 0, 0, 334, 104);
INSERT INTO public.who_global_data VALUES (79024, 4, 25, 0, 0, 334, 153);
INSERT INTO public.who_global_data VALUES (79025, 1492, 7375, 133, 366, 334, 91);
INSERT INTO public.who_global_data VALUES (79026, 0, 0, 0, 0, 334, 215);
INSERT INTO public.who_global_data VALUES (79027, 59, 518, 3, 9, 334, 84);
INSERT INTO public.who_global_data VALUES (79028, 0, 0, 0, 0, 334, 231);
INSERT INTO public.who_global_data VALUES (79029, 0, 5, 0, 0, 334, 196);
INSERT INTO public.who_global_data VALUES (79030, 0, 0, 0, 0, 334, 105);
INSERT INTO public.who_global_data VALUES (79031, 0, 0, 0, 0, 334, 122);
INSERT INTO public.who_global_data VALUES (79032, 0, 0, 0, 0, 334, 159);
INSERT INTO public.who_global_data VALUES (79033, 0, 0, 0, 0, 334, 75);
INSERT INTO public.who_global_data VALUES (79034, 0, 68, 0, 0, 334, 27);
INSERT INTO public.who_global_data VALUES (79035, 0, 0, 0, 0, 334, 54);
INSERT INTO public.who_global_data VALUES (79036, 0, 0, 0, 0, 334, 226);
INSERT INTO public.who_global_data VALUES (79037, 1, 3, 0, 0, 334, 79);
INSERT INTO public.who_global_data VALUES (79038, 0, 36, 0, 0, 334, 56);
INSERT INTO public.who_global_data VALUES (79039, 0, 0, 0, 0, 334, 117);
INSERT INTO public.who_global_data VALUES (79040, 0, 0, 0, 0, 334, 152);
INSERT INTO public.who_global_data VALUES (79041, 0, 0, 0, 0, 334, 16);
INSERT INTO public.who_global_data VALUES (79042, 0, 1, 0, 0, 334, 10);
INSERT INTO public.who_global_data VALUES (79043, 0, 1, 0, 0, 334, 201);
INSERT INTO public.who_global_data VALUES (79044, 2, 5, 0, 0, 334, 174);
INSERT INTO public.who_global_data VALUES (79045, 0, 0, 0, 0, 334, 119);
INSERT INTO public.who_global_data VALUES (79046, 0, 0, 0, 0, 334, 168);
INSERT INTO public.who_global_data VALUES (79047, 24, 121, 0, 0, 334, 99);
INSERT INTO public.who_global_data VALUES (79048, 0, 8, 0, 0, 334, 171);
INSERT INTO public.who_global_data VALUES (79049, 0, 0, 0, 0, 334, 87);
INSERT INTO public.who_global_data VALUES (79050, 0, 3, 0, 0, 334, 123);
INSERT INTO public.who_global_data VALUES (79051, 0, 0, 0, 0, 334, 151);
INSERT INTO public.who_global_data VALUES (79052, 0, 6, 0, 0, 334, 213);
INSERT INTO public.who_global_data VALUES (79053, 0, 0, 0, 0, 334, 118);
INSERT INTO public.who_global_data VALUES (79054, 0, 0, 0, 0, 334, 134);
INSERT INTO public.who_global_data VALUES (79055, 0, 0, 0, 0, 334, 65);
INSERT INTO public.who_global_data VALUES (79056, 0, 11, 0, 0, 334, 102);
INSERT INTO public.who_global_data VALUES (79057, 0, 0, 0, 0, 334, 223);
INSERT INTO public.who_global_data VALUES (79058, 0, 1, 0, 0, 334, 4);
INSERT INTO public.who_global_data VALUES (79059, 0, 0, 0, 0, 334, 146);
INSERT INTO public.who_global_data VALUES (79060, 0, 0, 0, 0, 334, 31);
INSERT INTO public.who_global_data VALUES (79061, 0, 0, 0, 0, 334, 127);
INSERT INTO public.who_global_data VALUES (79062, 0, 6, 0, 0, 334, 22);
INSERT INTO public.who_global_data VALUES (79063, 0, 0, 0, 0, 334, 115);
INSERT INTO public.who_global_data VALUES (79064, 0, 0, 0, 0, 334, 106);
INSERT INTO public.who_global_data VALUES (79065, 0, 0, 0, 0, 334, 90);
INSERT INTO public.who_global_data VALUES (79066, 0, 0, 0, 0, 334, 70);
INSERT INTO public.who_global_data VALUES (79067, 0, 5, 0, 0, 334, 46);
INSERT INTO public.who_global_data VALUES (79068, 32, 163, 1, 2, 334, 139);
INSERT INTO public.who_global_data VALUES (79069, 0, 0, 0, 0, 334, 42);
INSERT INTO public.who_global_data VALUES (79070, 0, 9, 0, 0, 334, 80);
INSERT INTO public.who_global_data VALUES (79071, 0, 0, 0, 0, 334, 203);
INSERT INTO public.who_global_data VALUES (79072, 0, 0, 0, 0, 334, 136);
INSERT INTO public.who_global_data VALUES (79073, 1, 6, 0, 0, 334, 63);
INSERT INTO public.who_global_data VALUES (79074, 0, 0, 0, 0, 334, 17);
INSERT INTO public.who_global_data VALUES (79075, 0, 0, 0, 0, 334, 172);
INSERT INTO public.who_global_data VALUES (79076, 0, 3, 0, 0, 334, 109);
INSERT INTO public.who_global_data VALUES (79077, 22, 169, 0, 0, 334, 200);
INSERT INTO public.who_global_data VALUES (79078, 6, 29, 0, 0, 334, 93);
INSERT INTO public.who_global_data VALUES (79079, 0, 20, 0, 0, 334, 5);
INSERT INTO public.who_global_data VALUES (79080, 0, 700, 0, 7, 334, 214);
INSERT INTO public.who_global_data VALUES (79081, 0, 10, 0, 0, 334, 204);
INSERT INTO public.who_global_data VALUES (79082, 0, 0, 0, 0, 334, 198);
INSERT INTO public.who_global_data VALUES (79083, 0, 0, 0, 0, 334, 173);
INSERT INTO public.who_global_data VALUES (79084, 0, 0, 0, 0, 334, 229);
INSERT INTO public.who_global_data VALUES (79085, 0, 5, 0, 0, 334, 76);
INSERT INTO public.who_global_data VALUES (79086, 1, 11, 0, 0, 334, 138);
INSERT INTO public.who_global_data VALUES (79087, 14, 28, 0, 1, 334, 98);
INSERT INTO public.who_global_data VALUES (79088, 0, 0, 0, 0, 334, 103);
INSERT INTO public.who_global_data VALUES (79089, 5, 11, 0, 0, 334, 225);
INSERT INTO public.who_global_data VALUES (79090, 9, 30, 0, 0, 334, 131);
INSERT INTO public.who_global_data VALUES (79091, 0, 0, 0, 0, 334, 235);
INSERT INTO public.who_global_data VALUES (79092, 3, 19, 0, 0, 334, 137);
INSERT INTO public.who_global_data VALUES (79093, 248, 7386, 1, 51, 334, 81);
INSERT INTO public.who_global_data VALUES (79094, 0, 1, 0, 0, 334, 182);
INSERT INTO public.who_global_data VALUES (79095, 0, 0, 0, 0, 334, 145);
INSERT INTO public.who_global_data VALUES (79096, 2, 15, 0, 0, 334, 26);
INSERT INTO public.who_global_data VALUES (79097, 0, 7, 0, 0, 334, 170);
INSERT INTO public.who_global_data VALUES (79098, 0, 0, 0, 0, 334, 191);
INSERT INTO public.who_global_data VALUES (79099, 0, 0, 0, 0, 334, 221);
INSERT INTO public.who_global_data VALUES (79100, 0, 1, 0, 0, 334, 64);
INSERT INTO public.who_global_data VALUES (79101, 0, 0, 0, 0, 334, 116);
INSERT INTO public.who_global_data VALUES (79102, 0, 0, 0, 0, 334, 128);
INSERT INTO public.who_global_data VALUES (79103, 0, 0, 0, 0, 334, 6);
INSERT INTO public.who_global_data VALUES (79104, 0, 6, 0, 0, 334, 227);
INSERT INTO public.who_global_data VALUES (79105, 0, 0, 0, 0, 334, 68);
INSERT INTO public.who_global_data VALUES (79106, 0, 0, 0, 0, 334, 184);
INSERT INTO public.who_global_data VALUES (79107, 0, 0, 0, 0, 334, 82);
INSERT INTO public.who_global_data VALUES (79108, 10, 37, 0, 1, 334, 149);
INSERT INTO public.who_global_data VALUES (79109, 0, 0, 0, 0, 334, 197);
INSERT INTO public.who_global_data VALUES (79110, 4, 19, 0, 0, 334, 78);
INSERT INTO public.who_global_data VALUES (79111, 0, 8, 0, 0, 334, 233);
INSERT INTO public.who_global_data VALUES (79112, 0, 1, 0, 0, 334, 133);
INSERT INTO public.who_global_data VALUES (79113, 0, 0, 0, 0, 334, 35);
INSERT INTO public.who_global_data VALUES (79114, 0, 0, 0, 0, 334, 114);
INSERT INTO public.who_global_data VALUES (79115, 10, 164, 0, 0, 334, 237);
INSERT INTO public.who_global_data VALUES (79116, 0, 0, 0, 0, 334, 55);
INSERT INTO public.who_global_data VALUES (79117, 0, 0, 0, 0, 334, 176);
INSERT INTO public.who_global_data VALUES (79118, 2, 5, 0, 0, 334, 202);
INSERT INTO public.who_global_data VALUES (79119, 5, 20, 0, 0, 334, 155);
INSERT INTO public.who_global_data VALUES (79120, 0, 0, 0, 0, 334, 32);
INSERT INTO public.who_global_data VALUES (79121, 0, 0, 0, 0, 334, 220);
INSERT INTO public.who_global_data VALUES (79122, 0, 7, 0, 0, 334, 30);
INSERT INTO public.who_global_data VALUES (79123, 0, 0, 0, 0, 334, 147);
INSERT INTO public.who_global_data VALUES (79124, 290, 1157, 3, 11, 334, 208);
INSERT INTO public.who_global_data VALUES (79125, 0, 5, 0, 0, 334, 45);
INSERT INTO public.who_global_data VALUES (79126, 0, 0, 0, 0, 334, 110);
INSERT INTO public.who_global_data VALUES (79127, 0, 0, 0, 0, 334, 88);
INSERT INTO public.who_global_data VALUES (79128, 33, 179, 0, 0, 334, 51);
INSERT INTO public.who_global_data VALUES (79129, 68, 432, 1, 3, 334, 209);
INSERT INTO public.who_global_data VALUES (79130, 0, 0, 0, 0, 334, 205);
INSERT INTO public.who_global_data VALUES (79131, 0, 0, 0, 0, 334, 18);
INSERT INTO public.who_global_data VALUES (79132, 0, 54, 0, 1, 334, 72);
INSERT INTO public.who_global_data VALUES (79133, 60, 412, 0, 2, 334, 44);
INSERT INTO public.who_global_data VALUES (79134, 0, 0, 0, 0, 334, 15);
INSERT INTO public.who_global_data VALUES (79135, 0, 5, 0, 0, 334, 25);
INSERT INTO public.who_global_data VALUES (79136, 0, 0, 0, 0, 334, 179);
INSERT INTO public.who_global_data VALUES (79137, 0, 0, 0, 0, 334, 34);
INSERT INTO public.who_global_data VALUES (79138, 0, 0, 0, 0, 334, 207);
INSERT INTO public.who_global_data VALUES (79139, 0, 6, 0, 0, 334, 166);
INSERT INTO public.who_global_data VALUES (79140, 0, 0, 0, 0, 334, 126);
INSERT INTO public.who_global_data VALUES (79141, 0, 0, 0, 0, 334, 97);
INSERT INTO public.who_global_data VALUES (79142, 0, 0, 0, 0, 334, 36);
INSERT INTO public.who_global_data VALUES (79143, 0, 0, 0, 0, 334, 125);
INSERT INTO public.who_global_data VALUES (79144, 0, 0, 0, 0, 334, 124);
INSERT INTO public.who_global_data VALUES (79145, 0, 1, 0, 0, 334, 185);
INSERT INTO public.who_global_data VALUES (79146, 14, 63, 0, 0, 334, 194);
INSERT INTO public.who_global_data VALUES (79147, 0, 0, 0, 0, 334, 144);
INSERT INTO public.who_global_data VALUES (79148, 259, 476, 8, 19, 334, 19);
INSERT INTO public.who_global_data VALUES (79149, 0, 0, 0, 0, 334, 217);
INSERT INTO public.who_global_data VALUES (79150, 0, 0, 0, 0, 334, 148);
INSERT INTO public.who_global_data VALUES (79151, 0, 0, 0, 0, 334, 86);
INSERT INTO public.who_global_data VALUES (79152, 0, 0, 0, 0, 334, 13);
INSERT INTO public.who_global_data VALUES (79153, 0, 0, 0, 0, 334, 157);
INSERT INTO public.who_global_data VALUES (79154, 1, 35, 0, 0, 334, 8);
INSERT INTO public.who_global_data VALUES (79155, 0, 0, 0, 0, 334, 73);
INSERT INTO public.who_global_data VALUES (79156, 0, 0, 0, 0, 334, 101);
INSERT INTO public.who_global_data VALUES (79157, 0, 0, 0, 0, 334, 165);
INSERT INTO public.who_global_data VALUES (79158, 0, 0, 0, 0, 334, 14);
INSERT INTO public.who_global_data VALUES (79159, 0, 8, 0, 0, 335, 193);
INSERT INTO public.who_global_data VALUES (79160, 0, 0, 0, 0, 335, 113);
INSERT INTO public.who_global_data VALUES (79161, 0, 21, 0, 0, 335, 143);
INSERT INTO public.who_global_data VALUES (79162, 0, 0, 0, 0, 335, 219);
INSERT INTO public.who_global_data VALUES (79163, 0, 1, 0, 0, 335, 186);
INSERT INTO public.who_global_data VALUES (79164, 0, 0, 0, 0, 335, 52);
INSERT INTO public.who_global_data VALUES (79165, 0, 0, 0, 0, 335, 180);
INSERT INTO public.who_global_data VALUES (79166, 0, 0, 0, 0, 335, 167);
INSERT INTO public.who_global_data VALUES (79167, 3, 16, 0, 1, 335, 154);
INSERT INTO public.who_global_data VALUES (79168, 0, 1, 0, 0, 335, 94);
INSERT INTO public.who_global_data VALUES (79169, 0, 0, 0, 0, 335, 66);
INSERT INTO public.who_global_data VALUES (79170, 7, 81, 1, 3, 335, 58);
INSERT INTO public.who_global_data VALUES (79171, 25, 99, 0, 0, 335, 163);
INSERT INTO public.who_global_data VALUES (79172, 0, 9, 0, 0, 335, 37);
INSERT INTO public.who_global_data VALUES (79173, 0, 0, 0, 0, 335, 142);
INSERT INTO public.who_global_data VALUES (79174, 23, 83, 0, 0, 335, 83);
INSERT INTO public.who_global_data VALUES (79175, 7, 7, 0, 0, 335, 228);
INSERT INTO public.who_global_data VALUES (79176, 0, 0, 0, 0, 335, 188);
INSERT INTO public.who_global_data VALUES (79177, 0, 6, 0, 0, 335, 62);
INSERT INTO public.who_global_data VALUES (79178, 27, 343, 0, 0, 335, 160);
INSERT INTO public.who_global_data VALUES (79179, 0, 0, 0, 0, 335, 50);
INSERT INTO public.who_global_data VALUES (79180, 0, 0, 0, 0, 335, 33);
INSERT INTO public.who_global_data VALUES (79181, 0, 0, 0, 0, 335, 183);
INSERT INTO public.who_global_data VALUES (79182, 0, 1, 0, 0, 335, 92);
INSERT INTO public.who_global_data VALUES (79183, 0, 0, 0, 0, 335, 158);
INSERT INTO public.who_global_data VALUES (79184, 0, 0, 0, 0, 335, 67);
INSERT INTO public.who_global_data VALUES (79185, 0, 2, 0, 0, 335, 57);
INSERT INTO public.who_global_data VALUES (79186, 0, 0, 0, 0, 335, 38);
INSERT INTO public.who_global_data VALUES (79187, 0, 23, 0, 0, 335, 141);
INSERT INTO public.who_global_data VALUES (79188, 0, 0, 0, 0, 335, 178);
INSERT INTO public.who_global_data VALUES (79189, 0, 0, 0, 0, 335, 108);
INSERT INTO public.who_global_data VALUES (79190, 2, 2, 0, 0, 335, 39);
INSERT INTO public.who_global_data VALUES (79191, 0, 0, 0, 0, 335, 2);
INSERT INTO public.who_global_data VALUES (79192, 0, 0, 0, 0, 335, 195);
INSERT INTO public.who_global_data VALUES (79193, 0, 0, 0, 0, 335, 107);
INSERT INTO public.who_global_data VALUES (79194, 0, 6, 0, 0, 335, 161);
INSERT INTO public.who_global_data VALUES (79195, 0, 6, 0, 0, 335, 212);
INSERT INTO public.who_global_data VALUES (79196, 3, 64, 0, 0, 335, 181);
INSERT INTO public.who_global_data VALUES (79197, 0, 0, 0, 0, 335, 53);
INSERT INTO public.who_global_data VALUES (79198, 0, 0, 0, 0, 335, 164);
INSERT INTO public.who_global_data VALUES (79199, 0, 0, 0, 0, 335, 140);
INSERT INTO public.who_global_data VALUES (79200, 5, 14, 0, 0, 335, 20);
INSERT INTO public.who_global_data VALUES (79201, 46, 80863, 27, 3100, 335, 112);
INSERT INTO public.who_global_data VALUES (79202, 0, 5, 0, 0, 335, 111);
INSERT INTO public.who_global_data VALUES (79203, 0, 0, 0, 0, 335, 71);
INSERT INTO public.who_global_data VALUES (79204, 0, 0, 0, 0, 335, 218);
INSERT INTO public.who_global_data VALUES (79205, 0, 0, 0, 0, 335, 43);
INSERT INTO public.who_global_data VALUES (79206, 9, 9, 0, 0, 335, 49);
INSERT INTO public.who_global_data VALUES (79207, 0, 0, 0, 0, 335, 1);
INSERT INTO public.who_global_data VALUES (79208, 1, 12, 0, 0, 335, 48);
INSERT INTO public.who_global_data VALUES (79209, 0, 0, 0, 0, 335, 232);
INSERT INTO public.who_global_data VALUES (79210, 0, 0, 0, 0, 335, 175);
INSERT INTO public.who_global_data VALUES (79211, 0, 0, 0, 0, 335, 21);
INSERT INTO public.who_global_data VALUES (79212, 7, 26, 0, 0, 335, 156);
INSERT INTO public.who_global_data VALUES (79213, 0, 0, 0, 0, 335, 95);
INSERT INTO public.who_global_data VALUES (79214, 0, 0, 0, 0, 335, 177);
INSERT INTO public.who_global_data VALUES (79215, 8, 31, 0, 0, 335, 210);
INSERT INTO public.who_global_data VALUES (79216, 0, 0, 0, 0, 335, 120);
INSERT INTO public.who_global_data VALUES (79217, 0, 0, 0, 0, 335, 135);
INSERT INTO public.who_global_data VALUES (79218, 0, 5, 0, 0, 335, 206);
INSERT INTO public.who_global_data VALUES (79219, 0, 18, 0, 0, 335, 189);
INSERT INTO public.who_global_data VALUES (79220, 1, 53, 1, 1, 335, 129);
INSERT INTO public.who_global_data VALUES (79221, 0, 0, 0, 0, 335, 121);
INSERT INTO public.who_global_data VALUES (79222, 0, 0, 0, 0, 335, 59);
INSERT INTO public.who_global_data VALUES (79223, 0, 0, 0, 0, 335, 96);
INSERT INTO public.who_global_data VALUES (79224, 0, 10, 0, 0, 335, 41);
INSERT INTO public.who_global_data VALUES (79225, 0, 0, 0, 0, 335, 216);
INSERT INTO public.who_global_data VALUES (79226, 0, 0, 0, 0, 335, 236);
INSERT INTO public.who_global_data VALUES (79227, 0, 0, 0, 0, 335, 150);
INSERT INTO public.who_global_data VALUES (79228, 1, 3, 0, 0, 335, 61);
INSERT INTO public.who_global_data VALUES (79229, 0, 0, 0, 0, 335, 7);
INSERT INTO public.who_global_data VALUES (79230, 0, 19, 0, 0, 335, 169);
INSERT INTO public.who_global_data VALUES (79231, 103, 698, 1, 10, 335, 28);
INSERT INTO public.who_global_data VALUES (79232, 0, 5, 0, 0, 335, 85);
INSERT INTO public.who_global_data VALUES (79233, 0, 0, 0, 0, 335, 211);
INSERT INTO public.who_global_data VALUES (79234, 0, 0, 0, 0, 335, 60);
INSERT INTO public.who_global_data VALUES (79235, 0, 0, 0, 0, 335, 3);
INSERT INTO public.who_global_data VALUES (79236, 3, 12, 0, 0, 335, 11);
INSERT INTO public.who_global_data VALUES (79237, 163, 847, 0, 0, 335, 89);
INSERT INTO public.who_global_data VALUES (79238, 0, 0, 0, 0, 335, 24);
INSERT INTO public.who_global_data VALUES (79239, 0, 1, 0, 0, 335, 162);
INSERT INTO public.who_global_data VALUES (79240, 21, 66, 0, 0, 335, 100);
INSERT INTO public.who_global_data VALUES (79241, 0, 0, 0, 0, 335, 47);
INSERT INTO public.who_global_data VALUES (79242, 0, 0, 0, 0, 335, 29);
INSERT INTO public.who_global_data VALUES (79243, 0, 0, 0, 0, 335, 40);
INSERT INTO public.who_global_data VALUES (79244, 0, 0, 0, 0, 335, 222);
INSERT INTO public.who_global_data VALUES (79245, 0, 0, 0, 0, 335, 132);
INSERT INTO public.who_global_data VALUES (79246, 0, 0, 0, 0, 335, 130);
INSERT INTO public.who_global_data VALUES (79247, 0, 0, 0, 0, 335, 234);
INSERT INTO public.who_global_data VALUES (79248, 0, 0, 0, 0, 335, 23);
INSERT INTO public.who_global_data VALUES (79249, 0, 0, 0, 0, 335, 192);
INSERT INTO public.who_global_data VALUES (79250, 0, 0, 0, 0, 335, 69);
INSERT INTO public.who_global_data VALUES (79251, 0, 1, 0, 0, 335, 187);
INSERT INTO public.who_global_data VALUES (79252, 0, 0, 0, 0, 335, 230);
INSERT INTO public.who_global_data VALUES (79253, 3, 7, 0, 0, 335, 77);
INSERT INTO public.who_global_data VALUES (79254, 10, 53, 0, 0, 335, 9);
INSERT INTO public.who_global_data VALUES (79255, 5, 43, 0, 0, 335, 74);
INSERT INTO public.who_global_data VALUES (79256, 2, 10, 0, 0, 335, 224);
INSERT INTO public.who_global_data VALUES (79257, 743, 6570, 49, 194, 335, 199);
INSERT INTO public.who_global_data VALUES (79258, 6, 64, 0, 4, 335, 190);
INSERT INTO public.who_global_data VALUES (79259, 1, 19, 0, 0, 335, 12);
INSERT INTO public.who_global_data VALUES (79260, 0, 0, 0, 0, 335, 104);
INSERT INTO public.who_global_data VALUES (79261, 4, 21, 0, 0, 335, 153);
INSERT INTO public.who_global_data VALUES (79262, 1247, 5883, 36, 233, 335, 91);
INSERT INTO public.who_global_data VALUES (79263, 0, 0, 0, 0, 335, 215);
INSERT INTO public.who_global_data VALUES (79264, 48, 459, 0, 6, 335, 84);
INSERT INTO public.who_global_data VALUES (79265, 0, 0, 0, 0, 335, 231);
INSERT INTO public.who_global_data VALUES (79266, 0, 5, 0, 0, 335, 196);
INSERT INTO public.who_global_data VALUES (79267, 0, 0, 0, 0, 335, 105);
INSERT INTO public.who_global_data VALUES (79268, 0, 0, 0, 0, 335, 122);
INSERT INTO public.who_global_data VALUES (79269, 0, 0, 0, 0, 335, 159);
INSERT INTO public.who_global_data VALUES (79270, 0, 0, 0, 0, 335, 75);
INSERT INTO public.who_global_data VALUES (79271, 3, 68, 0, 0, 335, 27);
INSERT INTO public.who_global_data VALUES (79272, 0, 0, 0, 0, 335, 54);
INSERT INTO public.who_global_data VALUES (79273, 0, 0, 0, 0, 335, 226);
INSERT INTO public.who_global_data VALUES (79274, 1, 2, 0, 0, 335, 79);
INSERT INTO public.who_global_data VALUES (79275, 10, 36, 0, 0, 335, 56);
INSERT INTO public.who_global_data VALUES (79276, 0, 0, 0, 0, 335, 117);
INSERT INTO public.who_global_data VALUES (79277, 0, 0, 0, 0, 335, 152);
INSERT INTO public.who_global_data VALUES (79278, 0, 0, 0, 0, 335, 16);
INSERT INTO public.who_global_data VALUES (79279, 0, 1, 0, 0, 335, 10);
INSERT INTO public.who_global_data VALUES (79280, 0, 1, 0, 0, 335, 201);
INSERT INTO public.who_global_data VALUES (79281, 0, 3, 0, 0, 335, 174);
INSERT INTO public.who_global_data VALUES (79282, 0, 0, 0, 0, 335, 119);
INSERT INTO public.who_global_data VALUES (79283, 0, 0, 0, 0, 335, 168);
INSERT INTO public.who_global_data VALUES (79284, 0, 97, 0, 0, 335, 99);
INSERT INTO public.who_global_data VALUES (79285, 2, 8, 0, 0, 335, 171);
INSERT INTO public.who_global_data VALUES (79286, 0, 0, 0, 0, 335, 87);
INSERT INTO public.who_global_data VALUES (79287, 2, 3, 0, 0, 335, 123);
INSERT INTO public.who_global_data VALUES (79288, 0, 0, 0, 0, 335, 151);
INSERT INTO public.who_global_data VALUES (79289, 0, 6, 0, 0, 335, 213);
INSERT INTO public.who_global_data VALUES (79290, 0, 0, 0, 0, 335, 118);
INSERT INTO public.who_global_data VALUES (79291, 0, 0, 0, 0, 335, 134);
INSERT INTO public.who_global_data VALUES (79292, 0, 0, 0, 0, 335, 65);
INSERT INTO public.who_global_data VALUES (79293, 2, 11, 0, 0, 335, 102);
INSERT INTO public.who_global_data VALUES (79294, 0, 0, 0, 0, 335, 223);
INSERT INTO public.who_global_data VALUES (79295, 0, 1, 0, 0, 335, 4);
INSERT INTO public.who_global_data VALUES (79296, 0, 0, 0, 0, 335, 146);
INSERT INTO public.who_global_data VALUES (79297, 0, 0, 0, 0, 335, 31);
INSERT INTO public.who_global_data VALUES (79298, 0, 0, 0, 0, 335, 127);
INSERT INTO public.who_global_data VALUES (79299, 0, 6, 0, 0, 335, 22);
INSERT INTO public.who_global_data VALUES (79300, 0, 0, 0, 0, 335, 115);
INSERT INTO public.who_global_data VALUES (79301, 0, 0, 0, 0, 335, 106);
INSERT INTO public.who_global_data VALUES (79302, 0, 0, 0, 0, 335, 90);
INSERT INTO public.who_global_data VALUES (79303, 0, 0, 0, 0, 335, 70);
INSERT INTO public.who_global_data VALUES (79304, 0, 5, 0, 0, 335, 46);
INSERT INTO public.who_global_data VALUES (79305, 50, 131, 0, 1, 335, 139);
INSERT INTO public.who_global_data VALUES (79306, 0, 0, 0, 0, 335, 42);
INSERT INTO public.who_global_data VALUES (79307, 0, 9, 0, 0, 335, 80);
INSERT INTO public.who_global_data VALUES (79308, 0, 0, 0, 0, 335, 203);
INSERT INTO public.who_global_data VALUES (79309, 0, 0, 0, 0, 335, 136);
INSERT INTO public.who_global_data VALUES (79310, 0, 5, 0, 0, 335, 63);
INSERT INTO public.who_global_data VALUES (79311, 0, 0, 0, 0, 335, 17);
INSERT INTO public.who_global_data VALUES (79312, 0, 0, 0, 0, 335, 172);
INSERT INTO public.who_global_data VALUES (79313, 0, 3, 0, 0, 335, 109);
INSERT INTO public.who_global_data VALUES (79314, 34, 147, 0, 0, 335, 200);
INSERT INTO public.who_global_data VALUES (79315, 3, 23, 0, 0, 335, 93);
INSERT INTO public.who_global_data VALUES (79316, 0, 20, 0, 0, 335, 5);
INSERT INTO public.who_global_data VALUES (79317, 0, 700, 1, 7, 335, 214);
INSERT INTO public.who_global_data VALUES (79318, 1, 10, 0, 0, 335, 204);
INSERT INTO public.who_global_data VALUES (79319, 0, 0, 0, 0, 335, 198);
INSERT INTO public.who_global_data VALUES (79320, 0, 0, 0, 0, 335, 173);
INSERT INTO public.who_global_data VALUES (79321, 0, 0, 0, 0, 335, 229);
INSERT INTO public.who_global_data VALUES (79322, 5, 5, 0, 0, 335, 76);
INSERT INTO public.who_global_data VALUES (79323, 0, 10, 0, 0, 335, 138);
INSERT INTO public.who_global_data VALUES (79324, 4, 14, 0, 1, 335, 98);
INSERT INTO public.who_global_data VALUES (79325, 0, 0, 0, 0, 335, 103);
INSERT INTO public.who_global_data VALUES (79326, 1, 6, 0, 0, 335, 225);
INSERT INTO public.who_global_data VALUES (79327, 8, 21, 0, 0, 335, 131);
INSERT INTO public.who_global_data VALUES (79328, 0, 0, 0, 0, 335, 235);
INSERT INTO public.who_global_data VALUES (79329, 0, 16, 0, 0, 335, 137);
INSERT INTO public.who_global_data VALUES (79330, 367, 7138, 6, 50, 335, 81);
INSERT INTO public.who_global_data VALUES (79331, 0, 1, 0, 0, 335, 182);
INSERT INTO public.who_global_data VALUES (79332, 0, 0, 0, 0, 335, 145);
INSERT INTO public.who_global_data VALUES (79333, 6, 13, 0, 0, 335, 26);
INSERT INTO public.who_global_data VALUES (79334, 3, 7, 0, 0, 335, 170);
INSERT INTO public.who_global_data VALUES (79335, 0, 0, 0, 0, 335, 191);
INSERT INTO public.who_global_data VALUES (79336, 0, 0, 0, 0, 335, 221);
INSERT INTO public.who_global_data VALUES (79337, 0, 1, 0, 0, 335, 64);
INSERT INTO public.who_global_data VALUES (79338, 0, 0, 0, 0, 335, 116);
INSERT INTO public.who_global_data VALUES (79339, 0, 0, 0, 0, 335, 128);
INSERT INTO public.who_global_data VALUES (79340, 0, 0, 0, 0, 335, 6);
INSERT INTO public.who_global_data VALUES (79341, 0, 6, 0, 0, 335, 227);
INSERT INTO public.who_global_data VALUES (79342, 0, 0, 0, 0, 335, 68);
INSERT INTO public.who_global_data VALUES (79343, 0, 0, 0, 0, 335, 184);
INSERT INTO public.who_global_data VALUES (79344, 0, 0, 0, 0, 335, 82);
INSERT INTO public.who_global_data VALUES (79345, 3, 27, 0, 1, 335, 149);
INSERT INTO public.who_global_data VALUES (79346, 0, 0, 0, 0, 335, 197);
INSERT INTO public.who_global_data VALUES (79347, 4, 15, 0, 0, 335, 78);
INSERT INTO public.who_global_data VALUES (79348, 0, 8, 0, 0, 335, 233);
INSERT INTO public.who_global_data VALUES (79349, 0, 1, 0, 0, 335, 133);
INSERT INTO public.who_global_data VALUES (79350, 0, 0, 0, 0, 335, 35);
INSERT INTO public.who_global_data VALUES (79351, 0, 0, 0, 0, 335, 114);
INSERT INTO public.who_global_data VALUES (79352, 12, 154, 0, 0, 335, 237);
INSERT INTO public.who_global_data VALUES (79353, 0, 0, 0, 0, 335, 55);
INSERT INTO public.who_global_data VALUES (79354, 0, 0, 0, 0, 335, 176);
INSERT INTO public.who_global_data VALUES (79355, 2, 3, 0, 0, 335, 202);
INSERT INTO public.who_global_data VALUES (79356, 5, 15, 0, 0, 335, 155);
INSERT INTO public.who_global_data VALUES (79357, 0, 0, 0, 0, 335, 32);
INSERT INTO public.who_global_data VALUES (79358, 0, 0, 0, 0, 335, 220);
INSERT INTO public.who_global_data VALUES (79359, 1, 7, 0, 0, 335, 30);
INSERT INTO public.who_global_data VALUES (79360, 0, 0, 0, 0, 335, 147);
INSERT INTO public.who_global_data VALUES (79361, 274, 867, 3, 8, 335, 208);
INSERT INTO public.who_global_data VALUES (79362, 0, 5, 0, 0, 335, 45);
INSERT INTO public.who_global_data VALUES (79363, 0, 0, 0, 0, 335, 110);
INSERT INTO public.who_global_data VALUES (79364, 0, 0, 0, 0, 335, 88);
INSERT INTO public.who_global_data VALUES (79365, 59, 146, 0, 0, 335, 51);
INSERT INTO public.who_global_data VALUES (79366, 49, 364, 0, 2, 335, 209);
INSERT INTO public.who_global_data VALUES (79367, 0, 0, 0, 0, 335, 205);
INSERT INTO public.who_global_data VALUES (79368, 0, 0, 0, 0, 335, 18);
INSERT INTO public.who_global_data VALUES (79369, 0, 54, 0, 1, 335, 72);
INSERT INTO public.who_global_data VALUES (79370, 81, 352, 1, 2, 335, 44);
INSERT INTO public.who_global_data VALUES (79371, 0, 0, 0, 0, 335, 15);
INSERT INTO public.who_global_data VALUES (79372, 0, 5, 0, 0, 335, 25);
INSERT INTO public.who_global_data VALUES (79373, 0, 0, 0, 0, 335, 179);
INSERT INTO public.who_global_data VALUES (79374, 0, 0, 0, 0, 335, 34);
INSERT INTO public.who_global_data VALUES (79375, 0, 0, 0, 0, 335, 207);
INSERT INTO public.who_global_data VALUES (79376, 1, 6, 0, 0, 335, 166);
INSERT INTO public.who_global_data VALUES (79377, 0, 0, 0, 0, 335, 126);
INSERT INTO public.who_global_data VALUES (79378, 0, 0, 0, 0, 335, 97);
INSERT INTO public.who_global_data VALUES (79379, 0, 0, 0, 0, 335, 36);
INSERT INTO public.who_global_data VALUES (79380, 0, 0, 0, 0, 335, 125);
INSERT INTO public.who_global_data VALUES (79381, 0, 0, 0, 0, 335, 124);
INSERT INTO public.who_global_data VALUES (79382, 0, 1, 0, 0, 335, 185);
INSERT INTO public.who_global_data VALUES (79383, 0, 49, 0, 0, 335, 194);
INSERT INTO public.who_global_data VALUES (79384, 0, 0, 0, 0, 335, 144);
INSERT INTO public.who_global_data VALUES (79385, 0, 217, 0, 11, 335, 19);
INSERT INTO public.who_global_data VALUES (79386, 0, 0, 0, 0, 335, 217);
INSERT INTO public.who_global_data VALUES (79387, 0, 0, 0, 0, 335, 148);
INSERT INTO public.who_global_data VALUES (79388, 0, 0, 0, 0, 335, 86);
INSERT INTO public.who_global_data VALUES (79389, 0, 0, 0, 0, 335, 13);
INSERT INTO public.who_global_data VALUES (79390, 0, 0, 0, 0, 335, 157);
INSERT INTO public.who_global_data VALUES (79391, 10, 34, 0, 0, 335, 8);
INSERT INTO public.who_global_data VALUES (79392, 0, 0, 0, 0, 335, 73);
INSERT INTO public.who_global_data VALUES (79393, 0, 0, 0, 0, 335, 101);
INSERT INTO public.who_global_data VALUES (79394, 0, 0, 0, 0, 335, 165);
INSERT INTO public.who_global_data VALUES (79395, 0, 0, 0, 0, 335, 14);
INSERT INTO public.who_global_data VALUES (79396, 3, 8, 0, 0, 336, 193);
INSERT INTO public.who_global_data VALUES (79397, 0, 0, 0, 0, 336, 113);
INSERT INTO public.who_global_data VALUES (79398, 0, 21, 0, 0, 336, 143);
INSERT INTO public.who_global_data VALUES (79399, 0, 0, 0, 0, 336, 219);
INSERT INTO public.who_global_data VALUES (79400, 0, 1, 0, 0, 336, 186);
INSERT INTO public.who_global_data VALUES (79401, 0, 0, 0, 0, 336, 52);
INSERT INTO public.who_global_data VALUES (79402, 0, 0, 0, 0, 336, 180);
INSERT INTO public.who_global_data VALUES (79403, 0, 0, 0, 0, 336, 167);
INSERT INTO public.who_global_data VALUES (79404, 7, 13, 1, 1, 336, 154);
INSERT INTO public.who_global_data VALUES (79405, 0, 1, 0, 0, 336, 94);
INSERT INTO public.who_global_data VALUES (79406, 0, 0, 0, 0, 336, 66);
INSERT INTO public.who_global_data VALUES (79407, 8, 74, 0, 2, 336, 58);
INSERT INTO public.who_global_data VALUES (79408, 33, 74, 0, 0, 336, 163);
INSERT INTO public.who_global_data VALUES (79409, 3, 9, 0, 0, 336, 37);
INSERT INTO public.who_global_data VALUES (79410, 0, 0, 0, 0, 336, 142);
INSERT INTO public.who_global_data VALUES (79411, 7, 60, 0, 0, 336, 83);
INSERT INTO public.who_global_data VALUES (79412, 0, 0, 0, 0, 336, 228);
INSERT INTO public.who_global_data VALUES (79413, 0, 0, 0, 0, 336, 188);
INSERT INTO public.who_global_data VALUES (79414, 0, 6, 0, 0, 336, 62);
INSERT INTO public.who_global_data VALUES (79415, 110, 316, 0, 0, 336, 160);
INSERT INTO public.who_global_data VALUES (79416, 0, 0, 0, 0, 336, 50);
INSERT INTO public.who_global_data VALUES (79417, 0, 0, 0, 0, 336, 33);
INSERT INTO public.who_global_data VALUES (79418, 0, 0, 0, 0, 336, 183);
INSERT INTO public.who_global_data VALUES (79419, 0, 1, 0, 0, 336, 92);
INSERT INTO public.who_global_data VALUES (79420, 0, 0, 0, 0, 336, 158);
INSERT INTO public.who_global_data VALUES (79421, 0, 0, 0, 0, 336, 67);
INSERT INTO public.who_global_data VALUES (79422, 0, 2, 0, 0, 336, 57);
INSERT INTO public.who_global_data VALUES (79423, 0, 0, 0, 0, 336, 38);
INSERT INTO public.who_global_data VALUES (79424, 11, 23, 0, 0, 336, 141);
INSERT INTO public.who_global_data VALUES (79425, 0, 0, 0, 0, 336, 178);
INSERT INTO public.who_global_data VALUES (79426, 0, 0, 0, 0, 336, 108);
INSERT INTO public.who_global_data VALUES (79427, 0, 0, 0, 0, 336, 39);
INSERT INTO public.who_global_data VALUES (79428, 0, 0, 0, 0, 336, 2);
INSERT INTO public.who_global_data VALUES (79429, 0, 0, 0, 0, 336, 195);
INSERT INTO public.who_global_data VALUES (79430, 0, 0, 0, 0, 336, 107);
INSERT INTO public.who_global_data VALUES (79431, 1, 6, 0, 0, 336, 161);
INSERT INTO public.who_global_data VALUES (79432, 0, 6, 0, 0, 336, 212);
INSERT INTO public.who_global_data VALUES (79433, 8, 61, 0, 0, 336, 181);
INSERT INTO public.who_global_data VALUES (79434, 0, 0, 0, 0, 336, 53);
INSERT INTO public.who_global_data VALUES (79435, 0, 0, 0, 0, 336, 164);
INSERT INTO public.who_global_data VALUES (79436, 0, 0, 0, 0, 336, 140);
INSERT INTO public.who_global_data VALUES (79437, 0, 9, 0, 0, 336, 20);
INSERT INTO public.who_global_data VALUES (79438, 102, 80817, 28, 3073, 336, 112);
INSERT INTO public.who_global_data VALUES (79439, 0, 5, 0, 0, 336, 111);
INSERT INTO public.who_global_data VALUES (79440, 0, 0, 0, 0, 336, 71);
INSERT INTO public.who_global_data VALUES (79441, 0, 0, 0, 0, 336, 218);
INSERT INTO public.who_global_data VALUES (79442, 0, 0, 0, 0, 336, 43);
INSERT INTO public.who_global_data VALUES (79443, 0, 0, 0, 0, 336, 49);
INSERT INTO public.who_global_data VALUES (79444, 0, 0, 0, 0, 336, 1);
INSERT INTO public.who_global_data VALUES (79445, 1, 11, 0, 0, 336, 48);
INSERT INTO public.who_global_data VALUES (79446, 0, 0, 0, 0, 336, 232);
INSERT INTO public.who_global_data VALUES (79447, 0, 0, 0, 0, 336, 175);
INSERT INTO public.who_global_data VALUES (79448, 0, 0, 0, 0, 336, 21);
INSERT INTO public.who_global_data VALUES (79449, 7, 19, 0, 0, 336, 156);
INSERT INTO public.who_global_data VALUES (79450, 0, 0, 0, 0, 336, 95);
INSERT INTO public.who_global_data VALUES (79451, 0, 0, 0, 0, 336, 177);
INSERT INTO public.who_global_data VALUES (79452, 3, 23, 0, 0, 336, 210);
INSERT INTO public.who_global_data VALUES (79453, 0, 0, 0, 0, 336, 120);
INSERT INTO public.who_global_data VALUES (79454, 0, 0, 0, 0, 336, 135);
INSERT INTO public.who_global_data VALUES (79455, 0, 5, 0, 0, 336, 206);
INSERT INTO public.who_global_data VALUES (79456, 1, 18, 0, 0, 336, 189);
INSERT INTO public.who_global_data VALUES (79457, 45, 52, 0, 0, 336, 129);
INSERT INTO public.who_global_data VALUES (79458, 0, 0, 0, 0, 336, 121);
INSERT INTO public.who_global_data VALUES (79459, 0, 0, 0, 0, 336, 59);
INSERT INTO public.who_global_data VALUES (79460, 0, 0, 0, 0, 336, 96);
INSERT INTO public.who_global_data VALUES (79461, 5, 10, 0, 0, 336, 41);
INSERT INTO public.who_global_data VALUES (79462, 0, 0, 0, 0, 336, 216);
INSERT INTO public.who_global_data VALUES (79463, 0, 0, 0, 0, 336, 236);
INSERT INTO public.who_global_data VALUES (79464, 0, 0, 0, 0, 336, 150);
INSERT INTO public.who_global_data VALUES (79465, 1, 2, 0, 0, 336, 61);
INSERT INTO public.who_global_data VALUES (79466, 0, 0, 0, 0, 336, 7);
INSERT INTO public.who_global_data VALUES (79467, 7, 19, 0, 0, 336, 169);
INSERT INTO public.who_global_data VALUES (79468, 179, 595, 2, 9, 336, 28);
INSERT INTO public.who_global_data VALUES (79469, 5, 5, 0, 0, 336, 85);
INSERT INTO public.who_global_data VALUES (79470, 0, 0, 0, 0, 336, 211);
INSERT INTO public.who_global_data VALUES (79471, 0, 0, 0, 0, 336, 60);
INSERT INTO public.who_global_data VALUES (79472, 0, 0, 0, 0, 336, 3);
INSERT INTO public.who_global_data VALUES (79473, 0, 9, 0, 0, 336, 11);
INSERT INTO public.who_global_data VALUES (79474, 284, 684, 0, 0, 336, 89);
INSERT INTO public.who_global_data VALUES (79475, 0, 0, 0, 0, 336, 24);
INSERT INTO public.who_global_data VALUES (79476, 0, 1, 0, 0, 336, 162);
INSERT INTO public.who_global_data VALUES (79477, 13, 45, 0, 0, 336, 100);
INSERT INTO public.who_global_data VALUES (79478, 0, 0, 0, 0, 336, 47);
INSERT INTO public.who_global_data VALUES (79479, 0, 0, 0, 0, 336, 29);
INSERT INTO public.who_global_data VALUES (79480, 0, 0, 0, 0, 336, 40);
INSERT INTO public.who_global_data VALUES (79481, 0, 0, 0, 0, 336, 222);
INSERT INTO public.who_global_data VALUES (79482, 0, 0, 0, 0, 336, 132);
INSERT INTO public.who_global_data VALUES (79483, 0, 0, 0, 0, 336, 130);
INSERT INTO public.who_global_data VALUES (79484, 0, 0, 0, 0, 336, 234);
INSERT INTO public.who_global_data VALUES (79485, 0, 0, 0, 0, 336, 23);
INSERT INTO public.who_global_data VALUES (79486, 0, 0, 0, 0, 336, 192);
INSERT INTO public.who_global_data VALUES (79487, 0, 0, 0, 0, 336, 69);
INSERT INTO public.who_global_data VALUES (79488, 0, 1, 0, 0, 336, 187);
INSERT INTO public.who_global_data VALUES (79489, 0, 0, 0, 0, 336, 230);
INSERT INTO public.who_global_data VALUES (79490, 2, 4, 0, 0, 336, 77);
INSERT INTO public.who_global_data VALUES (79491, 8, 43, 0, 0, 336, 9);
INSERT INTO public.who_global_data VALUES (79492, 3, 38, 0, 0, 336, 74);
INSERT INTO public.who_global_data VALUES (79493, 0, 8, 0, 0, 336, 224);
INSERT INTO public.who_global_data VALUES (79494, 1076, 5827, 21, 145, 336, 199);
INSERT INTO public.who_global_data VALUES (79495, 10, 58, 0, 4, 336, 190);
INSERT INTO public.who_global_data VALUES (79496, 5, 18, 0, 0, 336, 12);
INSERT INTO public.who_global_data VALUES (79497, 0, 0, 0, 0, 336, 104);
INSERT INTO public.who_global_data VALUES (79498, 2, 17, 0, 0, 336, 153);
INSERT INTO public.who_global_data VALUES (79499, 778, 4636, 49, 197, 336, 91);
INSERT INTO public.who_global_data VALUES (79500, 0, 0, 0, 0, 336, 215);
INSERT INTO public.who_global_data VALUES (79501, 58, 411, 0, 6, 336, 84);
INSERT INTO public.who_global_data VALUES (79502, 0, 0, 0, 0, 336, 231);
INSERT INTO public.who_global_data VALUES (79503, 0, 5, 0, 0, 336, 196);
INSERT INTO public.who_global_data VALUES (79504, 0, 0, 0, 0, 336, 105);
INSERT INTO public.who_global_data VALUES (79505, 0, 0, 0, 0, 336, 122);
INSERT INTO public.who_global_data VALUES (79506, 0, 0, 0, 0, 336, 159);
INSERT INTO public.who_global_data VALUES (79507, 0, 0, 0, 0, 336, 75);
INSERT INTO public.who_global_data VALUES (79508, 3, 65, 0, 0, 336, 27);
INSERT INTO public.who_global_data VALUES (79509, 0, 0, 0, 0, 336, 54);
INSERT INTO public.who_global_data VALUES (79510, 0, 0, 0, 0, 336, 226);
INSERT INTO public.who_global_data VALUES (79511, 0, 1, 0, 0, 336, 79);
INSERT INTO public.who_global_data VALUES (79512, 0, 26, 0, 0, 336, 56);
INSERT INTO public.who_global_data VALUES (79513, 0, 0, 0, 0, 336, 117);
INSERT INTO public.who_global_data VALUES (79514, 0, 0, 0, 0, 336, 152);
INSERT INTO public.who_global_data VALUES (79515, 0, 0, 0, 0, 336, 16);
INSERT INTO public.who_global_data VALUES (79516, 0, 1, 0, 0, 336, 10);
INSERT INTO public.who_global_data VALUES (79517, 0, 1, 0, 0, 336, 201);
INSERT INTO public.who_global_data VALUES (79518, 2, 3, 0, 0, 336, 174);
INSERT INTO public.who_global_data VALUES (79519, 0, 0, 0, 0, 336, 119);
INSERT INTO public.who_global_data VALUES (79520, 0, 0, 0, 0, 336, 168);
INSERT INTO public.who_global_data VALUES (79521, 10, 97, 0, 0, 336, 99);
INSERT INTO public.who_global_data VALUES (79522, 6, 6, 0, 0, 336, 171);
INSERT INTO public.who_global_data VALUES (79523, 0, 0, 0, 0, 336, 87);
INSERT INTO public.who_global_data VALUES (79524, 1, 1, 0, 0, 336, 123);
INSERT INTO public.who_global_data VALUES (79525, 0, 0, 0, 0, 336, 151);
INSERT INTO public.who_global_data VALUES (79526, 6, 6, 0, 0, 336, 213);
INSERT INTO public.who_global_data VALUES (79527, 0, 0, 0, 0, 336, 118);
INSERT INTO public.who_global_data VALUES (79528, 0, 0, 0, 0, 336, 134);
INSERT INTO public.who_global_data VALUES (79529, 0, 0, 0, 0, 336, 65);
INSERT INTO public.who_global_data VALUES (79530, 0, 9, 0, 0, 336, 102);
INSERT INTO public.who_global_data VALUES (79531, 0, 0, 0, 0, 336, 223);
INSERT INTO public.who_global_data VALUES (79532, 0, 1, 0, 0, 336, 4);
INSERT INTO public.who_global_data VALUES (79533, 0, 0, 0, 0, 336, 146);
INSERT INTO public.who_global_data VALUES (79534, 0, 0, 0, 0, 336, 31);
INSERT INTO public.who_global_data VALUES (79535, 0, 0, 0, 0, 336, 127);
INSERT INTO public.who_global_data VALUES (79536, 0, 6, 0, 0, 336, 22);
INSERT INTO public.who_global_data VALUES (79537, 0, 0, 0, 0, 336, 115);
INSERT INTO public.who_global_data VALUES (79538, 0, 0, 0, 0, 336, 106);
INSERT INTO public.who_global_data VALUES (79539, 0, 0, 0, 0, 336, 90);
INSERT INTO public.who_global_data VALUES (79540, 0, 0, 0, 0, 336, 70);
INSERT INTO public.who_global_data VALUES (79541, 0, 5, 0, 0, 336, 46);
INSERT INTO public.who_global_data VALUES (79542, 40, 81, 1, 1, 336, 139);
INSERT INTO public.who_global_data VALUES (79543, 0, 0, 0, 0, 336, 42);
INSERT INTO public.who_global_data VALUES (79544, 1, 9, 0, 0, 336, 80);
INSERT INTO public.who_global_data VALUES (79545, 0, 0, 0, 0, 336, 203);
INSERT INTO public.who_global_data VALUES (79546, 0, 0, 0, 0, 336, 136);
INSERT INTO public.who_global_data VALUES (79547, 0, 5, 0, 0, 336, 63);
INSERT INTO public.who_global_data VALUES (79548, 0, 0, 0, 0, 336, 17);
INSERT INTO public.who_global_data VALUES (79549, 0, 0, 0, 0, 336, 172);
INSERT INTO public.who_global_data VALUES (79550, 2, 3, 0, 0, 336, 109);
INSERT INTO public.who_global_data VALUES (79551, 27, 113, 0, 0, 336, 200);
INSERT INTO public.who_global_data VALUES (79552, 0, 20, 0, 0, 336, 93);
INSERT INTO public.who_global_data VALUES (79553, 0, 20, 0, 0, 336, 5);
INSERT INTO public.who_global_data VALUES (79554, 0, 700, 0, 6, 336, 214);
INSERT INTO public.who_global_data VALUES (79555, 0, 9, 0, 0, 336, 204);
INSERT INTO public.who_global_data VALUES (79556, 0, 0, 0, 0, 336, 198);
INSERT INTO public.who_global_data VALUES (79557, 0, 0, 0, 0, 336, 173);
INSERT INTO public.who_global_data VALUES (79558, 0, 0, 0, 0, 336, 229);
INSERT INTO public.who_global_data VALUES (79559, 0, 0, 0, 0, 336, 76);
INSERT INTO public.who_global_data VALUES (79560, 10, 10, 0, 0, 336, 138);
INSERT INTO public.who_global_data VALUES (79561, 1, 10, 0, 1, 336, 98);
INSERT INTO public.who_global_data VALUES (79562, 0, 0, 0, 0, 336, 103);
INSERT INTO public.who_global_data VALUES (79563, 4, 5, 0, 0, 336, 225);
INSERT INTO public.who_global_data VALUES (79564, 4, 13, 0, 0, 336, 131);
INSERT INTO public.who_global_data VALUES (79565, 0, 0, 0, 0, 336, 235);
INSERT INTO public.who_global_data VALUES (79566, 1, 16, 0, 0, 336, 137);
INSERT INTO public.who_global_data VALUES (79567, 483, 6771, 2, 44, 336, 81);
INSERT INTO public.who_global_data VALUES (79568, 1, 1, 0, 0, 336, 182);
INSERT INTO public.who_global_data VALUES (79569, 0, 0, 0, 0, 336, 145);
INSERT INTO public.who_global_data VALUES (79570, 1, 7, 0, 0, 336, 26);
INSERT INTO public.who_global_data VALUES (79571, 0, 4, 0, 0, 336, 170);
INSERT INTO public.who_global_data VALUES (79572, 0, 0, 0, 0, 336, 191);
INSERT INTO public.who_global_data VALUES (79573, 0, 0, 0, 0, 336, 221);
INSERT INTO public.who_global_data VALUES (79574, 0, 1, 0, 0, 336, 64);
INSERT INTO public.who_global_data VALUES (79575, 0, 0, 0, 0, 336, 116);
INSERT INTO public.who_global_data VALUES (79576, 0, 0, 0, 0, 336, 128);
INSERT INTO public.who_global_data VALUES (79577, 0, 0, 0, 0, 336, 6);
INSERT INTO public.who_global_data VALUES (79578, 0, 6, 0, 0, 336, 227);
INSERT INTO public.who_global_data VALUES (79579, 0, 0, 0, 0, 336, 68);
INSERT INTO public.who_global_data VALUES (79580, 0, 0, 0, 0, 336, 184);
INSERT INTO public.who_global_data VALUES (79581, 0, 0, 0, 0, 336, 82);
INSERT INTO public.who_global_data VALUES (79582, 2, 24, 0, 1, 336, 149);
INSERT INTO public.who_global_data VALUES (79583, 0, 0, 0, 0, 336, 197);
INSERT INTO public.who_global_data VALUES (79584, 2, 11, 0, 0, 336, 78);
INSERT INTO public.who_global_data VALUES (79585, 0, 8, 0, 0, 336, 233);
INSERT INTO public.who_global_data VALUES (79586, 0, 1, 0, 0, 336, 133);
INSERT INTO public.who_global_data VALUES (79587, 0, 0, 0, 0, 336, 35);
INSERT INTO public.who_global_data VALUES (79588, 0, 0, 0, 0, 336, 114);
INSERT INTO public.who_global_data VALUES (79589, 8, 142, 0, 0, 336, 237);
INSERT INTO public.who_global_data VALUES (79590, 0, 0, 0, 0, 336, 55);
INSERT INTO public.who_global_data VALUES (79591, 0, 0, 0, 0, 336, 176);
INSERT INTO public.who_global_data VALUES (79592, 0, 1, 0, 0, 336, 202);
INSERT INTO public.who_global_data VALUES (79593, 4, 10, 0, 0, 336, 155);
INSERT INTO public.who_global_data VALUES (79594, 0, 0, 0, 0, 336, 32);
INSERT INTO public.who_global_data VALUES (79595, 0, 0, 0, 0, 336, 220);
INSERT INTO public.who_global_data VALUES (79596, 1, 6, 0, 0, 336, 30);
INSERT INTO public.who_global_data VALUES (79597, 0, 0, 0, 0, 336, 147);
INSERT INTO public.who_global_data VALUES (79598, 190, 593, 1, 5, 336, 208);
INSERT INTO public.who_global_data VALUES (79599, 0, 5, 0, 0, 336, 45);
INSERT INTO public.who_global_data VALUES (79600, 0, 0, 0, 0, 336, 110);
INSERT INTO public.who_global_data VALUES (79601, 0, 0, 0, 0, 336, 88);
INSERT INTO public.who_global_data VALUES (79602, 25, 87, 0, 0, 336, 51);
INSERT INTO public.who_global_data VALUES (79603, 73, 315, 0, 2, 336, 209);
INSERT INTO public.who_global_data VALUES (79604, 0, 0, 0, 0, 336, 205);
INSERT INTO public.who_global_data VALUES (79605, 0, 0, 0, 0, 336, 18);
INSERT INTO public.who_global_data VALUES (79606, 2, 54, 0, 1, 336, 72);
INSERT INTO public.who_global_data VALUES (79607, 51, 271, 1, 1, 336, 44);
INSERT INTO public.who_global_data VALUES (79608, 0, 0, 0, 0, 336, 15);
INSERT INTO public.who_global_data VALUES (79609, 5, 5, 0, 0, 336, 25);
INSERT INTO public.who_global_data VALUES (79610, 0, 0, 0, 0, 336, 179);
INSERT INTO public.who_global_data VALUES (79611, 0, 0, 0, 0, 336, 34);
INSERT INTO public.who_global_data VALUES (79612, 0, 0, 0, 0, 336, 207);
INSERT INTO public.who_global_data VALUES (79613, 0, 5, 0, 0, 336, 166);
INSERT INTO public.who_global_data VALUES (79614, 0, 0, 0, 0, 336, 126);
INSERT INTO public.who_global_data VALUES (79615, 0, 0, 0, 0, 336, 97);
INSERT INTO public.who_global_data VALUES (79616, 0, 0, 0, 0, 336, 36);
INSERT INTO public.who_global_data VALUES (79617, 0, 0, 0, 0, 336, 125);
INSERT INTO public.who_global_data VALUES (79618, 0, 0, 0, 0, 336, 124);
INSERT INTO public.who_global_data VALUES (79619, 0, 1, 0, 0, 336, 185);
INSERT INTO public.who_global_data VALUES (79620, 0, 49, 0, 0, 336, 194);
INSERT INTO public.who_global_data VALUES (79621, 0, 0, 0, 0, 336, 144);
INSERT INTO public.who_global_data VALUES (79622, 0, 217, 0, 11, 336, 19);
INSERT INTO public.who_global_data VALUES (79623, 0, 0, 0, 0, 336, 217);
INSERT INTO public.who_global_data VALUES (79624, 0, 0, 0, 0, 336, 148);
INSERT INTO public.who_global_data VALUES (79625, 0, 0, 0, 0, 336, 86);
INSERT INTO public.who_global_data VALUES (79626, 0, 0, 0, 0, 336, 13);
INSERT INTO public.who_global_data VALUES (79627, 0, 0, 0, 0, 336, 157);
INSERT INTO public.who_global_data VALUES (79628, 3, 24, 0, 0, 336, 8);
INSERT INTO public.who_global_data VALUES (79629, 0, 0, 0, 0, 336, 73);
INSERT INTO public.who_global_data VALUES (79630, 0, 0, 0, 0, 336, 101);
INSERT INTO public.who_global_data VALUES (79631, 0, 0, 0, 0, 336, 165);
INSERT INTO public.who_global_data VALUES (79632, 0, 0, 0, 0, 336, 14);
INSERT INTO public.who_global_data VALUES (79633, 0, 5, 0, 0, 337, 193);
INSERT INTO public.who_global_data VALUES (79634, 0, 0, 0, 0, 337, 113);
INSERT INTO public.who_global_data VALUES (79635, 5, 21, 0, 0, 337, 143);
INSERT INTO public.who_global_data VALUES (79636, 0, 0, 0, 0, 337, 219);
INSERT INTO public.who_global_data VALUES (79637, 0, 1, 0, 0, 337, 186);
INSERT INTO public.who_global_data VALUES (79638, 0, 0, 0, 0, 337, 52);
INSERT INTO public.who_global_data VALUES (79639, 0, 0, 0, 0, 337, 180);
INSERT INTO public.who_global_data VALUES (79640, 0, 0, 0, 0, 337, 167);
INSERT INTO public.who_global_data VALUES (79641, 1, 6, 0, 0, 337, 154);
INSERT INTO public.who_global_data VALUES (79642, 0, 1, 0, 0, 337, 94);
INSERT INTO public.who_global_data VALUES (79643, 0, 0, 0, 0, 337, 66);
INSERT INTO public.who_global_data VALUES (79644, 19, 66, 1, 2, 337, 58);
INSERT INTO public.who_global_data VALUES (79645, 12, 41, 0, 0, 337, 163);
INSERT INTO public.who_global_data VALUES (79646, 3, 6, 0, 0, 337, 37);
INSERT INTO public.who_global_data VALUES (79647, 0, 0, 0, 0, 337, 142);
INSERT INTO public.who_global_data VALUES (79648, 0, 53, 0, 0, 337, 83);
INSERT INTO public.who_global_data VALUES (79649, 0, 0, 0, 0, 337, 228);
INSERT INTO public.who_global_data VALUES (79650, 0, 0, 0, 0, 337, 188);
INSERT INTO public.who_global_data VALUES (79651, 0, 6, 0, 0, 337, 62);
INSERT INTO public.who_global_data VALUES (79652, 81, 206, 0, 0, 337, 160);
INSERT INTO public.who_global_data VALUES (79653, 0, 0, 0, 0, 337, 50);
INSERT INTO public.who_global_data VALUES (79654, 0, 0, 0, 0, 337, 33);
INSERT INTO public.who_global_data VALUES (79655, 0, 0, 0, 0, 337, 183);
INSERT INTO public.who_global_data VALUES (79656, 1, 1, 0, 0, 337, 92);
INSERT INTO public.who_global_data VALUES (79657, 0, 0, 0, 0, 337, 158);
INSERT INTO public.who_global_data VALUES (79658, 0, 0, 0, 0, 337, 67);
INSERT INTO public.who_global_data VALUES (79659, 0, 2, 0, 0, 337, 57);
INSERT INTO public.who_global_data VALUES (79660, 0, 0, 0, 0, 337, 38);
INSERT INTO public.who_global_data VALUES (79661, 1, 12, 0, 0, 337, 141);
INSERT INTO public.who_global_data VALUES (79662, 0, 0, 0, 0, 337, 178);
INSERT INTO public.who_global_data VALUES (79663, 0, 0, 0, 0, 337, 108);
INSERT INTO public.who_global_data VALUES (79664, 0, 0, 0, 0, 337, 39);
INSERT INTO public.who_global_data VALUES (79665, 0, 0, 0, 0, 337, 2);
INSERT INTO public.who_global_data VALUES (79666, 0, 0, 0, 0, 337, 195);
INSERT INTO public.who_global_data VALUES (79667, 0, 0, 0, 0, 337, 107);
INSERT INTO public.who_global_data VALUES (79668, 0, 5, 0, 0, 337, 161);
INSERT INTO public.who_global_data VALUES (79669, 6, 6, 0, 0, 337, 212);
INSERT INTO public.who_global_data VALUES (79670, 4, 53, 0, 0, 337, 181);
INSERT INTO public.who_global_data VALUES (79671, 0, 0, 0, 0, 337, 53);
INSERT INTO public.who_global_data VALUES (79672, 0, 0, 0, 0, 337, 164);
INSERT INTO public.who_global_data VALUES (79673, 0, 0, 0, 0, 337, 140);
INSERT INTO public.who_global_data VALUES (79674, 4, 9, 0, 0, 337, 20);
INSERT INTO public.who_global_data VALUES (79675, 146, 80715, 30, 3045, 337, 112);
INSERT INTO public.who_global_data VALUES (79676, 5, 5, 0, 0, 337, 111);
INSERT INTO public.who_global_data VALUES (79677, 0, 0, 0, 0, 337, 71);
INSERT INTO public.who_global_data VALUES (79678, 0, 0, 0, 0, 337, 218);
INSERT INTO public.who_global_data VALUES (79679, 0, 0, 0, 0, 337, 43);
INSERT INTO public.who_global_data VALUES (79680, 0, 0, 0, 0, 337, 49);
INSERT INTO public.who_global_data VALUES (79681, 0, 0, 0, 0, 337, 1);
INSERT INTO public.who_global_data VALUES (79682, 1, 10, 0, 0, 337, 48);
INSERT INTO public.who_global_data VALUES (79683, 0, 0, 0, 0, 337, 232);
INSERT INTO public.who_global_data VALUES (79684, 0, 0, 0, 0, 337, 175);
INSERT INTO public.who_global_data VALUES (79685, 0, 0, 0, 0, 337, 21);
INSERT INTO public.who_global_data VALUES (79686, 4, 12, 0, 0, 337, 156);
INSERT INTO public.who_global_data VALUES (79687, 0, 0, 0, 0, 337, 95);
INSERT INTO public.who_global_data VALUES (79688, 0, 0, 0, 0, 337, 177);
INSERT INTO public.who_global_data VALUES (79689, 10, 20, 0, 0, 337, 210);
INSERT INTO public.who_global_data VALUES (79690, 0, 0, 0, 0, 337, 120);
INSERT INTO public.who_global_data VALUES (79691, 0, 0, 0, 0, 337, 135);
INSERT INTO public.who_global_data VALUES (79692, 0, 5, 0, 0, 337, 206);
INSERT INTO public.who_global_data VALUES (79693, 0, 17, 0, 0, 337, 189);
INSERT INTO public.who_global_data VALUES (79694, 0, 7, 0, 0, 337, 129);
INSERT INTO public.who_global_data VALUES (79695, 0, 0, 0, 0, 337, 121);
INSERT INTO public.who_global_data VALUES (79696, 0, 0, 0, 0, 337, 59);
INSERT INTO public.who_global_data VALUES (79697, 0, 0, 0, 0, 337, 96);
INSERT INTO public.who_global_data VALUES (79698, 3, 5, 0, 0, 337, 41);
INSERT INTO public.who_global_data VALUES (79699, 0, 0, 0, 0, 337, 216);
INSERT INTO public.who_global_data VALUES (79700, 0, 0, 0, 0, 337, 236);
INSERT INTO public.who_global_data VALUES (79701, 0, 0, 0, 0, 337, 150);
INSERT INTO public.who_global_data VALUES (79702, 1, 1, 0, 0, 337, 61);
INSERT INTO public.who_global_data VALUES (79703, 0, 0, 0, 0, 337, 7);
INSERT INTO public.who_global_data VALUES (79704, 5, 12, 0, 0, 337, 169);
INSERT INTO public.who_global_data VALUES (79705, 138, 416, 3, 7, 337, 28);
INSERT INTO public.who_global_data VALUES (79706, 0, 0, 0, 0, 337, 85);
INSERT INTO public.who_global_data VALUES (79707, 0, 0, 0, 0, 337, 211);
INSERT INTO public.who_global_data VALUES (79708, 0, 0, 0, 0, 337, 60);
INSERT INTO public.who_global_data VALUES (79709, 0, 0, 0, 0, 337, 3);
INSERT INTO public.who_global_data VALUES (79710, 6, 9, 0, 0, 337, 11);
INSERT INTO public.who_global_data VALUES (79711, 138, 400, 0, 0, 337, 89);
INSERT INTO public.who_global_data VALUES (79712, 0, 0, 0, 0, 337, 24);
INSERT INTO public.who_global_data VALUES (79713, 0, 1, 0, 0, 337, 162);
INSERT INTO public.who_global_data VALUES (79714, 22, 32, 0, 0, 337, 100);
INSERT INTO public.who_global_data VALUES (79715, 0, 0, 0, 0, 337, 47);
INSERT INTO public.who_global_data VALUES (79716, 0, 0, 0, 0, 337, 29);
INSERT INTO public.who_global_data VALUES (79717, 0, 0, 0, 0, 337, 40);
INSERT INTO public.who_global_data VALUES (79718, 0, 0, 0, 0, 337, 222);
INSERT INTO public.who_global_data VALUES (79719, 0, 0, 0, 0, 337, 132);
INSERT INTO public.who_global_data VALUES (79720, 0, 0, 0, 0, 337, 130);
INSERT INTO public.who_global_data VALUES (79721, 0, 0, 0, 0, 337, 234);
INSERT INTO public.who_global_data VALUES (79722, 0, 0, 0, 0, 337, 23);
INSERT INTO public.who_global_data VALUES (79723, 0, 0, 0, 0, 337, 192);
INSERT INTO public.who_global_data VALUES (79724, 0, 0, 0, 0, 337, 69);
INSERT INTO public.who_global_data VALUES (79725, 1, 1, 0, 0, 337, 187);
INSERT INTO public.who_global_data VALUES (79726, 0, 0, 0, 0, 337, 230);
INSERT INTO public.who_global_data VALUES (79727, 0, 2, 0, 0, 337, 77);
INSERT INTO public.who_global_data VALUES (79728, 9, 35, 0, 0, 337, 9);
INSERT INTO public.who_global_data VALUES (79729, 3, 35, 0, 0, 337, 74);
INSERT INTO public.who_global_data VALUES (79730, 2, 8, 0, 0, 337, 224);
INSERT INTO public.who_global_data VALUES (79731, 1234, 4751, 17, 124, 337, 199);
INSERT INTO public.who_global_data VALUES (79732, 8, 48, 2, 4, 337, 190);
INSERT INTO public.who_global_data VALUES (79733, 7, 13, 0, 0, 337, 12);
INSERT INTO public.who_global_data VALUES (79734, 0, 0, 0, 0, 337, 104);
INSERT INTO public.who_global_data VALUES (79735, 0, 15, 0, 0, 337, 153);
INSERT INTO public.who_global_data VALUES (79736, 769, 3858, 41, 148, 337, 91);
INSERT INTO public.who_global_data VALUES (79737, 0, 0, 0, 0, 337, 215);
INSERT INTO public.who_global_data VALUES (79738, 0, 353, 0, 6, 337, 84);
INSERT INTO public.who_global_data VALUES (79739, 0, 0, 0, 0, 337, 231);
INSERT INTO public.who_global_data VALUES (79740, 0, 5, 0, 0, 337, 196);
INSERT INTO public.who_global_data VALUES (79741, 0, 0, 0, 0, 337, 105);
INSERT INTO public.who_global_data VALUES (79742, 0, 0, 0, 0, 337, 122);
INSERT INTO public.who_global_data VALUES (79743, 0, 0, 0, 0, 337, 159);
INSERT INTO public.who_global_data VALUES (79744, 0, 0, 0, 0, 337, 75);
INSERT INTO public.who_global_data VALUES (79745, 0, 62, 0, 0, 337, 27);
INSERT INTO public.who_global_data VALUES (79746, 0, 0, 0, 0, 337, 54);
INSERT INTO public.who_global_data VALUES (79747, 0, 0, 0, 0, 337, 226);
INSERT INTO public.who_global_data VALUES (79748, 0, 1, 0, 0, 337, 79);
INSERT INTO public.who_global_data VALUES (79749, 6, 26, 0, 0, 337, 56);
INSERT INTO public.who_global_data VALUES (79750, 0, 0, 0, 0, 337, 117);
INSERT INTO public.who_global_data VALUES (79751, 0, 0, 0, 0, 337, 152);
INSERT INTO public.who_global_data VALUES (79752, 0, 0, 0, 0, 337, 16);
INSERT INTO public.who_global_data VALUES (79753, 0, 1, 0, 0, 337, 10);
INSERT INTO public.who_global_data VALUES (79754, 0, 1, 0, 0, 337, 201);
INSERT INTO public.who_global_data VALUES (79755, 0, 1, 0, 0, 337, 174);
INSERT INTO public.who_global_data VALUES (79756, 0, 0, 0, 0, 337, 119);
INSERT INTO public.who_global_data VALUES (79757, 0, 0, 0, 0, 337, 168);
INSERT INTO public.who_global_data VALUES (79758, 33, 87, 0, 0, 337, 99);
INSERT INTO public.who_global_data VALUES (79759, 0, 0, 0, 0, 337, 171);
INSERT INTO public.who_global_data VALUES (79760, 0, 0, 0, 0, 337, 87);
INSERT INTO public.who_global_data VALUES (79761, 0, 0, 0, 0, 337, 123);
INSERT INTO public.who_global_data VALUES (79762, 0, 0, 0, 0, 337, 151);
INSERT INTO public.who_global_data VALUES (79763, 0, 0, 0, 0, 337, 213);
INSERT INTO public.who_global_data VALUES (79764, 0, 0, 0, 0, 337, 118);
INSERT INTO public.who_global_data VALUES (79765, 0, 0, 0, 0, 337, 134);
INSERT INTO public.who_global_data VALUES (79766, 0, 0, 0, 0, 337, 65);
INSERT INTO public.who_global_data VALUES (79767, 0, 9, 0, 0, 337, 102);
INSERT INTO public.who_global_data VALUES (79768, 0, 0, 0, 0, 337, 223);
INSERT INTO public.who_global_data VALUES (79769, 0, 1, 0, 0, 337, 4);
INSERT INTO public.who_global_data VALUES (79770, 0, 0, 0, 0, 337, 146);
INSERT INTO public.who_global_data VALUES (79771, 0, 0, 0, 0, 337, 31);
INSERT INTO public.who_global_data VALUES (79772, 0, 0, 0, 0, 337, 127);
INSERT INTO public.who_global_data VALUES (79773, 0, 6, 0, 0, 337, 22);
INSERT INTO public.who_global_data VALUES (79774, 0, 0, 0, 0, 337, 115);
INSERT INTO public.who_global_data VALUES (79775, 0, 0, 0, 0, 337, 106);
INSERT INTO public.who_global_data VALUES (79776, 0, 0, 0, 0, 337, 90);
INSERT INTO public.who_global_data VALUES (79777, 0, 0, 0, 0, 337, 70);
INSERT INTO public.who_global_data VALUES (79778, 0, 5, 0, 0, 337, 46);
INSERT INTO public.who_global_data VALUES (79779, 17, 41, 0, 0, 337, 139);
INSERT INTO public.who_global_data VALUES (79780, 0, 0, 0, 0, 337, 42);
INSERT INTO public.who_global_data VALUES (79781, 2, 8, 0, 0, 337, 80);
INSERT INTO public.who_global_data VALUES (79782, 0, 0, 0, 0, 337, 203);
INSERT INTO public.who_global_data VALUES (79783, 0, 0, 0, 0, 337, 136);
INSERT INTO public.who_global_data VALUES (79784, 0, 5, 0, 0, 337, 63);
INSERT INTO public.who_global_data VALUES (79785, 0, 0, 0, 0, 337, 17);
INSERT INTO public.who_global_data VALUES (79786, 0, 0, 0, 0, 337, 172);
INSERT INTO public.who_global_data VALUES (79787, 0, 1, 0, 0, 337, 109);
INSERT INTO public.who_global_data VALUES (79788, 30, 86, 0, 0, 337, 200);
INSERT INTO public.who_global_data VALUES (79789, 9, 20, 0, 0, 337, 93);
INSERT INTO public.who_global_data VALUES (79790, 0, 20, 0, 0, 337, 5);
INSERT INTO public.who_global_data VALUES (79791, 0, 700, 0, 6, 337, 214);
INSERT INTO public.who_global_data VALUES (79792, 0, 9, 0, 0, 337, 204);
INSERT INTO public.who_global_data VALUES (79793, 0, 0, 0, 0, 337, 198);
INSERT INTO public.who_global_data VALUES (79794, 0, 0, 0, 0, 337, 173);
INSERT INTO public.who_global_data VALUES (79795, 0, 0, 0, 0, 337, 229);
INSERT INTO public.who_global_data VALUES (79796, 0, 0, 0, 0, 337, 76);
INSERT INTO public.who_global_data VALUES (79797, 0, 0, 0, 0, 337, 138);
INSERT INTO public.who_global_data VALUES (79798, 2, 9, 0, 1, 337, 98);
INSERT INTO public.who_global_data VALUES (79799, 0, 0, 0, 0, 337, 103);
INSERT INTO public.who_global_data VALUES (79800, 0, 1, 0, 0, 337, 225);
INSERT INTO public.who_global_data VALUES (79801, 4, 9, 0, 0, 337, 131);
INSERT INTO public.who_global_data VALUES (79802, 0, 0, 0, 0, 337, 235);
INSERT INTO public.who_global_data VALUES (79803, 3, 15, 0, 0, 337, 137);
INSERT INTO public.who_global_data VALUES (79804, 518, 6288, 7, 42, 337, 81);
INSERT INTO public.who_global_data VALUES (79805, 0, 0, 0, 0, 337, 182);
INSERT INTO public.who_global_data VALUES (79806, 0, 0, 0, 0, 337, 145);
INSERT INTO public.who_global_data VALUES (79807, 2, 6, 0, 0, 337, 26);
INSERT INTO public.who_global_data VALUES (79808, 1, 4, 0, 0, 337, 170);
INSERT INTO public.who_global_data VALUES (79809, 0, 0, 0, 0, 337, 191);
INSERT INTO public.who_global_data VALUES (79810, 0, 0, 0, 0, 337, 221);
INSERT INTO public.who_global_data VALUES (79811, 0, 1, 0, 0, 337, 64);
INSERT INTO public.who_global_data VALUES (79812, 0, 0, 0, 0, 337, 116);
INSERT INTO public.who_global_data VALUES (79813, 0, 0, 0, 0, 337, 128);
INSERT INTO public.who_global_data VALUES (79814, 0, 0, 0, 0, 337, 6);
INSERT INTO public.who_global_data VALUES (79815, 0, 6, 0, 0, 337, 227);
INSERT INTO public.who_global_data VALUES (79816, 0, 0, 0, 0, 337, 68);
INSERT INTO public.who_global_data VALUES (79817, 0, 0, 0, 0, 337, 184);
INSERT INTO public.who_global_data VALUES (79818, 0, 0, 0, 0, 337, 82);
INSERT INTO public.who_global_data VALUES (79819, 6, 22, 0, 1, 337, 149);
INSERT INTO public.who_global_data VALUES (79820, 0, 0, 0, 0, 337, 197);
INSERT INTO public.who_global_data VALUES (79821, 0, 9, 0, 0, 337, 78);
INSERT INTO public.who_global_data VALUES (79822, 0, 8, 0, 0, 337, 233);
INSERT INTO public.who_global_data VALUES (79823, 1, 1, 0, 0, 337, 133);
INSERT INTO public.who_global_data VALUES (79824, 0, 0, 0, 0, 337, 35);
INSERT INTO public.who_global_data VALUES (79825, 0, 0, 0, 0, 337, 114);
INSERT INTO public.who_global_data VALUES (79826, 13, 134, 0, 0, 337, 237);
INSERT INTO public.who_global_data VALUES (79827, 0, 0, 0, 0, 337, 55);
INSERT INTO public.who_global_data VALUES (79828, 0, 0, 0, 0, 337, 176);
INSERT INTO public.who_global_data VALUES (79829, 1, 1, 0, 0, 337, 202);
INSERT INTO public.who_global_data VALUES (79830, 5, 6, 0, 0, 337, 155);
INSERT INTO public.who_global_data VALUES (79831, 0, 0, 0, 0, 337, 32);
INSERT INTO public.who_global_data VALUES (79832, 0, 0, 0, 0, 337, 220);
INSERT INTO public.who_global_data VALUES (79833, 0, 5, 0, 0, 337, 30);
INSERT INTO public.who_global_data VALUES (79834, 0, 0, 0, 0, 337, 147);
INSERT INTO public.who_global_data VALUES (79835, 100, 403, 2, 4, 337, 208);
INSERT INTO public.who_global_data VALUES (79836, 0, 5, 0, 0, 337, 45);
INSERT INTO public.who_global_data VALUES (79837, 0, 0, 0, 0, 337, 110);
INSERT INTO public.who_global_data VALUES (79838, 0, 0, 0, 0, 337, 88);
INSERT INTO public.who_global_data VALUES (79839, 30, 62, 0, 0, 337, 51);
INSERT INTO public.who_global_data VALUES (79840, 62, 242, 0, 2, 337, 209);
INSERT INTO public.who_global_data VALUES (79841, 0, 0, 0, 0, 337, 205);
INSERT INTO public.who_global_data VALUES (79842, 0, 0, 0, 0, 337, 18);
INSERT INTO public.who_global_data VALUES (79843, 1, 52, 0, 1, 337, 72);
INSERT INTO public.who_global_data VALUES (79844, 56, 220, 0, 0, 337, 44);
INSERT INTO public.who_global_data VALUES (79845, 0, 0, 0, 0, 337, 15);
INSERT INTO public.who_global_data VALUES (79846, 0, 0, 0, 0, 337, 25);
INSERT INTO public.who_global_data VALUES (79847, 0, 0, 0, 0, 337, 179);
INSERT INTO public.who_global_data VALUES (79848, 0, 0, 0, 0, 337, 34);
INSERT INTO public.who_global_data VALUES (79849, 0, 0, 0, 0, 337, 207);
INSERT INTO public.who_global_data VALUES (79850, 0, 5, 0, 0, 337, 166);
INSERT INTO public.who_global_data VALUES (79851, 0, 0, 0, 0, 337, 126);
INSERT INTO public.who_global_data VALUES (79852, 0, 0, 0, 0, 337, 97);
INSERT INTO public.who_global_data VALUES (79853, 0, 0, 0, 0, 337, 36);
INSERT INTO public.who_global_data VALUES (79854, 0, 0, 0, 0, 337, 125);
INSERT INTO public.who_global_data VALUES (79855, 0, 0, 0, 0, 337, 124);
INSERT INTO public.who_global_data VALUES (79856, 0, 1, 0, 0, 337, 185);
INSERT INTO public.who_global_data VALUES (79857, 18, 49, 0, 0, 337, 194);
INSERT INTO public.who_global_data VALUES (79858, 0, 0, 0, 0, 337, 144);
INSERT INTO public.who_global_data VALUES (79859, 84, 217, 2, 11, 337, 19);
INSERT INTO public.who_global_data VALUES (79860, 0, 0, 0, 0, 337, 217);
INSERT INTO public.who_global_data VALUES (79861, 0, 0, 0, 0, 337, 148);
INSERT INTO public.who_global_data VALUES (79862, 0, 0, 0, 0, 337, 86);
INSERT INTO public.who_global_data VALUES (79863, 0, 0, 0, 0, 337, 13);
INSERT INTO public.who_global_data VALUES (79864, 0, 0, 0, 0, 337, 157);
INSERT INTO public.who_global_data VALUES (79865, 1, 21, 0, 0, 337, 8);
INSERT INTO public.who_global_data VALUES (79866, 0, 0, 0, 0, 337, 73);
INSERT INTO public.who_global_data VALUES (79867, 0, 0, 0, 0, 337, 101);
INSERT INTO public.who_global_data VALUES (79868, 0, 0, 0, 0, 337, 165);
INSERT INTO public.who_global_data VALUES (79869, 0, 0, 0, 0, 337, 14);
INSERT INTO public.who_global_data VALUES (79870, 0, 5, 0, 0, 338, 193);
INSERT INTO public.who_global_data VALUES (79871, 0, 0, 0, 0, 338, 113);
INSERT INTO public.who_global_data VALUES (79872, 0, 16, 0, 0, 338, 143);
INSERT INTO public.who_global_data VALUES (79873, 0, 0, 0, 0, 338, 219);
INSERT INTO public.who_global_data VALUES (79874, 0, 1, 0, 0, 338, 186);
INSERT INTO public.who_global_data VALUES (79875, 0, 0, 0, 0, 338, 52);
INSERT INTO public.who_global_data VALUES (79876, 0, 0, 0, 0, 338, 180);
INSERT INTO public.who_global_data VALUES (79877, 0, 0, 0, 0, 338, 167);
INSERT INTO public.who_global_data VALUES (79878, 0, 5, 0, 0, 338, 154);
INSERT INTO public.who_global_data VALUES (79879, 0, 1, 0, 0, 338, 94);
INSERT INTO public.who_global_data VALUES (79880, 0, 0, 0, 0, 338, 66);
INSERT INTO public.who_global_data VALUES (79881, 10, 47, 0, 1, 338, 58);
INSERT INTO public.who_global_data VALUES (79882, 5, 29, 0, 0, 338, 163);
INSERT INTO public.who_global_data VALUES (79883, 0, 3, 0, 0, 338, 37);
INSERT INTO public.who_global_data VALUES (79884, 0, 0, 0, 0, 338, 142);
INSERT INTO public.who_global_data VALUES (79885, 0, 53, 0, 0, 338, 83);
INSERT INTO public.who_global_data VALUES (79886, 0, 0, 0, 0, 338, 228);
INSERT INTO public.who_global_data VALUES (79887, 0, 0, 0, 0, 338, 188);
INSERT INTO public.who_global_data VALUES (79888, 5, 6, 0, 0, 338, 62);
INSERT INTO public.who_global_data VALUES (79889, 53, 125, 0, 0, 338, 160);
INSERT INTO public.who_global_data VALUES (79890, 0, 0, 0, 0, 338, 50);
INSERT INTO public.who_global_data VALUES (79891, 0, 0, 0, 0, 338, 33);
INSERT INTO public.who_global_data VALUES (79892, 0, 0, 0, 0, 338, 183);
INSERT INTO public.who_global_data VALUES (79893, 0, 0, 0, 0, 338, 92);
INSERT INTO public.who_global_data VALUES (79894, 0, 0, 0, 0, 338, 158);
INSERT INTO public.who_global_data VALUES (79895, 0, 0, 0, 0, 338, 67);
INSERT INTO public.who_global_data VALUES (79896, 2, 2, 0, 0, 338, 57);
INSERT INTO public.who_global_data VALUES (79897, 0, 0, 0, 0, 338, 38);
INSERT INTO public.who_global_data VALUES (79898, 4, 11, 0, 0, 338, 141);
INSERT INTO public.who_global_data VALUES (79899, 0, 0, 0, 0, 338, 178);
INSERT INTO public.who_global_data VALUES (79900, 0, 0, 0, 0, 338, 108);
INSERT INTO public.who_global_data VALUES (79901, 0, 0, 0, 0, 338, 39);
INSERT INTO public.who_global_data VALUES (79902, 0, 0, 0, 0, 338, 2);
INSERT INTO public.who_global_data VALUES (79903, 0, 0, 0, 0, 338, 195);
INSERT INTO public.who_global_data VALUES (79904, 0, 0, 0, 0, 338, 107);
INSERT INTO public.who_global_data VALUES (79905, 0, 5, 0, 0, 338, 161);
INSERT INTO public.who_global_data VALUES (79906, 0, 0, 0, 0, 338, 212);
INSERT INTO public.who_global_data VALUES (79907, 15, 49, 0, 0, 338, 181);
INSERT INTO public.who_global_data VALUES (79908, 0, 0, 0, 0, 338, 53);
INSERT INTO public.who_global_data VALUES (79909, 0, 0, 0, 0, 338, 164);
INSERT INTO public.who_global_data VALUES (79910, 0, 0, 0, 0, 338, 140);
INSERT INTO public.who_global_data VALUES (79911, 0, 5, 0, 0, 338, 20);
INSERT INTO public.who_global_data VALUES (79912, 143, 80569, 31, 3015, 338, 112);
INSERT INTO public.who_global_data VALUES (79913, 0, 0, 0, 0, 338, 111);
INSERT INTO public.who_global_data VALUES (79914, 0, 0, 0, 0, 338, 71);
INSERT INTO public.who_global_data VALUES (79915, 0, 0, 0, 0, 338, 218);
INSERT INTO public.who_global_data VALUES (79916, 0, 0, 0, 0, 338, 43);
INSERT INTO public.who_global_data VALUES (79917, 0, 0, 0, 0, 338, 49);
INSERT INTO public.who_global_data VALUES (79918, 0, 0, 0, 0, 338, 1);
INSERT INTO public.who_global_data VALUES (79919, 0, 9, 0, 0, 338, 48);
INSERT INTO public.who_global_data VALUES (79920, 0, 0, 0, 0, 338, 232);
INSERT INTO public.who_global_data VALUES (79921, 0, 0, 0, 0, 338, 175);
INSERT INTO public.who_global_data VALUES (79922, 0, 0, 0, 0, 338, 21);
INSERT INTO public.who_global_data VALUES (79923, 3, 8, 0, 0, 338, 156);
INSERT INTO public.who_global_data VALUES (79924, 0, 0, 0, 0, 338, 95);
INSERT INTO public.who_global_data VALUES (79925, 0, 0, 0, 0, 338, 177);
INSERT INTO public.who_global_data VALUES (79926, 2, 10, 0, 0, 338, 210);
INSERT INTO public.who_global_data VALUES (79927, 0, 0, 0, 0, 338, 120);
INSERT INTO public.who_global_data VALUES (79928, 0, 0, 0, 0, 338, 135);
INSERT INTO public.who_global_data VALUES (79929, 0, 5, 0, 0, 338, 206);
INSERT INTO public.who_global_data VALUES (79930, 6, 17, 0, 0, 338, 189);
INSERT INTO public.who_global_data VALUES (79931, 1, 7, 0, 0, 338, 129);
INSERT INTO public.who_global_data VALUES (79932, 0, 0, 0, 0, 338, 121);
INSERT INTO public.who_global_data VALUES (79933, 0, 0, 0, 0, 338, 59);
INSERT INTO public.who_global_data VALUES (79934, 0, 0, 0, 0, 338, 96);
INSERT INTO public.who_global_data VALUES (79935, 0, 2, 0, 0, 338, 41);
INSERT INTO public.who_global_data VALUES (79936, 0, 0, 0, 0, 338, 216);
INSERT INTO public.who_global_data VALUES (79937, 0, 0, 0, 0, 338, 236);
INSERT INTO public.who_global_data VALUES (79938, 0, 0, 0, 0, 338, 150);
INSERT INTO public.who_global_data VALUES (79939, 0, 0, 0, 0, 338, 61);
INSERT INTO public.who_global_data VALUES (79940, 0, 0, 0, 0, 338, 7);
INSERT INTO public.who_global_data VALUES (79941, 0, 7, 0, 0, 338, 169);
INSERT INTO public.who_global_data VALUES (79942, 73, 278, 0, 4, 338, 28);
INSERT INTO public.who_global_data VALUES (79943, 0, 0, 0, 0, 338, 85);
INSERT INTO public.who_global_data VALUES (79944, 0, 0, 0, 0, 338, 211);
INSERT INTO public.who_global_data VALUES (79945, 0, 0, 0, 0, 338, 60);
INSERT INTO public.who_global_data VALUES (79946, 0, 0, 0, 0, 338, 3);
INSERT INTO public.who_global_data VALUES (79947, 0, 3, 0, 0, 338, 11);
INSERT INTO public.who_global_data VALUES (79948, 66, 262, 0, 0, 338, 89);
INSERT INTO public.who_global_data VALUES (79949, 0, 0, 0, 0, 338, 24);
INSERT INTO public.who_global_data VALUES (79950, 0, 1, 0, 0, 338, 162);
INSERT INTO public.who_global_data VALUES (79951, 3, 10, 0, 0, 338, 100);
INSERT INTO public.who_global_data VALUES (79952, 0, 0, 0, 0, 338, 47);
INSERT INTO public.who_global_data VALUES (79953, 0, 0, 0, 0, 338, 29);
INSERT INTO public.who_global_data VALUES (79954, 0, 0, 0, 0, 338, 40);
INSERT INTO public.who_global_data VALUES (79955, 0, 0, 0, 0, 338, 222);
INSERT INTO public.who_global_data VALUES (79956, 0, 0, 0, 0, 338, 132);
INSERT INTO public.who_global_data VALUES (79957, 0, 0, 0, 0, 338, 130);
INSERT INTO public.who_global_data VALUES (79958, 0, 0, 0, 0, 338, 234);
INSERT INTO public.who_global_data VALUES (79959, 0, 0, 0, 0, 338, 23);
INSERT INTO public.who_global_data VALUES (79960, 0, 0, 0, 0, 338, 192);
INSERT INTO public.who_global_data VALUES (79961, 0, 0, 0, 0, 338, 69);
INSERT INTO public.who_global_data VALUES (79962, 0, 0, 0, 0, 338, 187);
INSERT INTO public.who_global_data VALUES (79963, 0, 0, 0, 0, 338, 230);
INSERT INTO public.who_global_data VALUES (79964, 2, 2, 0, 0, 338, 77);
INSERT INTO public.who_global_data VALUES (79965, 10, 26, 0, 0, 338, 9);
INSERT INTO public.who_global_data VALUES (79966, 1, 32, 0, 0, 338, 74);
INSERT INTO public.who_global_data VALUES (79967, 0, 6, 0, 0, 338, 224);
INSERT INTO public.who_global_data VALUES (79968, 591, 3517, 15, 107, 338, 199);
INSERT INTO public.who_global_data VALUES (79969, 0, 40, 0, 2, 338, 190);
INSERT INTO public.who_global_data VALUES (79970, 4, 6, 0, 0, 338, 12);
INSERT INTO public.who_global_data VALUES (79971, 0, 0, 0, 0, 338, 104);
INSERT INTO public.who_global_data VALUES (79972, 3, 15, 0, 0, 338, 153);
INSERT INTO public.who_global_data VALUES (79973, 587, 3089, 27, 107, 338, 91);
INSERT INTO public.who_global_data VALUES (79974, 0, 0, 0, 0, 338, 215);
INSERT INTO public.who_global_data VALUES (79975, 62, 353, 0, 6, 338, 84);
INSERT INTO public.who_global_data VALUES (79976, 0, 0, 0, 0, 338, 231);
INSERT INTO public.who_global_data VALUES (79977, 0, 5, 0, 0, 338, 196);
INSERT INTO public.who_global_data VALUES (79978, 0, 0, 0, 0, 338, 105);
INSERT INTO public.who_global_data VALUES (79979, 0, 0, 0, 0, 338, 122);
INSERT INTO public.who_global_data VALUES (79980, 0, 0, 0, 0, 338, 159);
INSERT INTO public.who_global_data VALUES (79981, 0, 0, 0, 0, 338, 75);
INSERT INTO public.who_global_data VALUES (79982, 2, 62, 0, 0, 338, 27);
INSERT INTO public.who_global_data VALUES (79983, 0, 0, 0, 0, 338, 54);
INSERT INTO public.who_global_data VALUES (79984, 0, 0, 0, 0, 338, 226);
INSERT INTO public.who_global_data VALUES (79985, 0, 1, 0, 0, 338, 79);
INSERT INTO public.who_global_data VALUES (79986, 3, 20, 0, 0, 338, 56);
INSERT INTO public.who_global_data VALUES (79987, 0, 0, 0, 0, 338, 117);
INSERT INTO public.who_global_data VALUES (79988, 0, 0, 0, 0, 338, 152);
INSERT INTO public.who_global_data VALUES (79989, 0, 0, 0, 0, 338, 16);
INSERT INTO public.who_global_data VALUES (79990, 0, 1, 0, 0, 338, 10);
INSERT INTO public.who_global_data VALUES (79991, 0, 1, 0, 0, 338, 201);
INSERT INTO public.who_global_data VALUES (79992, 0, 1, 0, 0, 338, 174);
INSERT INTO public.who_global_data VALUES (79993, 0, 0, 0, 0, 338, 119);
INSERT INTO public.who_global_data VALUES (79994, 0, 0, 0, 0, 338, 168);
INSERT INTO public.who_global_data VALUES (79995, 14, 54, 0, 0, 338, 99);
INSERT INTO public.who_global_data VALUES (79996, 0, 0, 0, 0, 338, 171);
INSERT INTO public.who_global_data VALUES (79997, 0, 0, 0, 0, 338, 87);
INSERT INTO public.who_global_data VALUES (79998, 0, 0, 0, 0, 338, 123);
INSERT INTO public.who_global_data VALUES (79999, 0, 0, 0, 0, 338, 151);
INSERT INTO public.who_global_data VALUES (80000, 0, 0, 0, 0, 338, 213);
INSERT INTO public.who_global_data VALUES (80001, 0, 0, 0, 0, 338, 118);
INSERT INTO public.who_global_data VALUES (80002, 0, 0, 0, 0, 338, 134);
INSERT INTO public.who_global_data VALUES (80003, 0, 0, 0, 0, 338, 65);
INSERT INTO public.who_global_data VALUES (80004, 0, 9, 0, 0, 338, 102);
INSERT INTO public.who_global_data VALUES (80005, 0, 0, 0, 0, 338, 223);
INSERT INTO public.who_global_data VALUES (80006, 0, 1, 0, 0, 338, 4);
INSERT INTO public.who_global_data VALUES (80007, 0, 0, 0, 0, 338, 146);
INSERT INTO public.who_global_data VALUES (80008, 0, 0, 0, 0, 338, 31);
INSERT INTO public.who_global_data VALUES (80009, 0, 0, 0, 0, 338, 127);
INSERT INTO public.who_global_data VALUES (80010, 1, 6, 0, 0, 338, 22);
INSERT INTO public.who_global_data VALUES (80011, 0, 0, 0, 0, 338, 115);
INSERT INTO public.who_global_data VALUES (80012, 0, 0, 0, 0, 338, 106);
INSERT INTO public.who_global_data VALUES (80013, 0, 0, 0, 0, 338, 90);
INSERT INTO public.who_global_data VALUES (80014, 0, 0, 0, 0, 338, 70);
INSERT INTO public.who_global_data VALUES (80015, 0, 5, 0, 0, 338, 46);
INSERT INTO public.who_global_data VALUES (80016, 10, 24, 0, 0, 338, 139);
INSERT INTO public.who_global_data VALUES (80017, 0, 0, 0, 0, 338, 42);
INSERT INTO public.who_global_data VALUES (80018, 0, 6, 0, 0, 338, 80);
INSERT INTO public.who_global_data VALUES (80019, 0, 0, 0, 0, 338, 203);
INSERT INTO public.who_global_data VALUES (80020, 0, 0, 0, 0, 338, 136);
INSERT INTO public.who_global_data VALUES (80021, 0, 5, 0, 0, 338, 63);
INSERT INTO public.who_global_data VALUES (80022, 0, 0, 0, 0, 338, 17);
INSERT INTO public.who_global_data VALUES (80023, 0, 0, 0, 0, 338, 172);
INSERT INTO public.who_global_data VALUES (80024, 0, 1, 0, 0, 338, 109);
INSERT INTO public.who_global_data VALUES (80025, 23, 56, 0, 0, 338, 200);
INSERT INTO public.who_global_data VALUES (80026, 11, 11, 0, 0, 338, 93);
INSERT INTO public.who_global_data VALUES (80027, 1, 20, 0, 0, 338, 5);
INSERT INTO public.who_global_data VALUES (80028, 0, 700, 0, 6, 338, 214);
INSERT INTO public.who_global_data VALUES (80029, 0, 9, 0, 0, 338, 204);
INSERT INTO public.who_global_data VALUES (80030, 0, 0, 0, 0, 338, 198);
INSERT INTO public.who_global_data VALUES (80031, 0, 0, 0, 0, 338, 173);
INSERT INTO public.who_global_data VALUES (80032, 0, 0, 0, 0, 338, 229);
INSERT INTO public.who_global_data VALUES (80033, 0, 0, 0, 0, 338, 76);
INSERT INTO public.who_global_data VALUES (80034, 0, 0, 0, 0, 338, 138);
INSERT INTO public.who_global_data VALUES (80035, 0, 7, 0, 1, 338, 98);
INSERT INTO public.who_global_data VALUES (80036, 0, 0, 0, 0, 338, 103);
INSERT INTO public.who_global_data VALUES (80037, 0, 1, 0, 0, 338, 225);
INSERT INTO public.who_global_data VALUES (80038, 1, 5, 0, 0, 338, 131);
INSERT INTO public.who_global_data VALUES (80039, 0, 0, 0, 0, 338, 235);
INSERT INTO public.who_global_data VALUES (80040, 0, 12, 0, 0, 338, 137);
INSERT INTO public.who_global_data VALUES (80041, 438, 5770, 3, 35, 338, 81);
INSERT INTO public.who_global_data VALUES (80042, 0, 0, 0, 0, 338, 182);
INSERT INTO public.who_global_data VALUES (80043, 0, 0, 0, 0, 338, 145);
INSERT INTO public.who_global_data VALUES (80044, 0, 4, 0, 0, 338, 26);
INSERT INTO public.who_global_data VALUES (80045, 0, 3, 0, 0, 338, 170);
INSERT INTO public.who_global_data VALUES (80046, 0, 0, 0, 0, 338, 191);
INSERT INTO public.who_global_data VALUES (80047, 0, 0, 0, 0, 338, 221);
INSERT INTO public.who_global_data VALUES (80048, 0, 1, 0, 0, 338, 64);
INSERT INTO public.who_global_data VALUES (80049, 0, 0, 0, 0, 338, 116);
INSERT INTO public.who_global_data VALUES (80050, 0, 0, 0, 0, 338, 128);
INSERT INTO public.who_global_data VALUES (80051, 0, 0, 0, 0, 338, 6);
INSERT INTO public.who_global_data VALUES (80052, 0, 6, 0, 0, 338, 227);
INSERT INTO public.who_global_data VALUES (80053, 0, 0, 0, 0, 338, 68);
INSERT INTO public.who_global_data VALUES (80054, 0, 0, 0, 0, 338, 184);
INSERT INTO public.who_global_data VALUES (80055, 0, 0, 0, 0, 338, 82);
INSERT INTO public.who_global_data VALUES (80056, 7, 16, 0, 1, 338, 149);
INSERT INTO public.who_global_data VALUES (80057, 0, 0, 0, 0, 338, 197);
INSERT INTO public.who_global_data VALUES (80058, 3, 9, 0, 0, 338, 78);
INSERT INTO public.who_global_data VALUES (80059, 0, 8, 0, 0, 338, 233);
INSERT INTO public.who_global_data VALUES (80060, 0, 0, 0, 0, 338, 133);
INSERT INTO public.who_global_data VALUES (80061, 0, 0, 0, 0, 338, 35);
INSERT INTO public.who_global_data VALUES (80062, 0, 0, 0, 0, 338, 114);
INSERT INTO public.who_global_data VALUES (80063, 7, 121, 0, 0, 338, 237);
INSERT INTO public.who_global_data VALUES (80064, 0, 0, 0, 0, 338, 55);
INSERT INTO public.who_global_data VALUES (80065, 0, 0, 0, 0, 338, 176);
INSERT INTO public.who_global_data VALUES (80066, 0, 0, 0, 0, 338, 202);
INSERT INTO public.who_global_data VALUES (80067, 0, 1, 0, 0, 338, 155);
INSERT INTO public.who_global_data VALUES (80068, 0, 0, 0, 0, 338, 32);
INSERT INTO public.who_global_data VALUES (80069, 0, 0, 0, 0, 338, 220);
INSERT INTO public.who_global_data VALUES (80070, 5, 5, 0, 0, 338, 30);
INSERT INTO public.who_global_data VALUES (80071, 0, 0, 0, 0, 338, 147);
INSERT INTO public.who_global_data VALUES (80072, 85, 303, 1, 2, 338, 208);
INSERT INTO public.who_global_data VALUES (80073, 0, 5, 0, 0, 338, 45);
INSERT INTO public.who_global_data VALUES (80074, 0, 0, 0, 0, 338, 110);
INSERT INTO public.who_global_data VALUES (80075, 0, 0, 0, 0, 338, 88);
INSERT INTO public.who_global_data VALUES (80076, 13, 32, 0, 0, 338, 51);
INSERT INTO public.who_global_data VALUES (80077, 61, 180, 2, 2, 338, 209);
INSERT INTO public.who_global_data VALUES (80078, 0, 0, 0, 0, 338, 205);
INSERT INTO public.who_global_data VALUES (80079, 0, 0, 0, 0, 338, 18);
INSERT INTO public.who_global_data VALUES (80080, 4, 51, 0, 1, 338, 72);
INSERT INTO public.who_global_data VALUES (80081, 55, 164, 0, 0, 338, 44);
INSERT INTO public.who_global_data VALUES (80082, 0, 0, 0, 0, 338, 15);
INSERT INTO public.who_global_data VALUES (80083, 0, 0, 0, 0, 338, 25);
INSERT INTO public.who_global_data VALUES (80084, 0, 0, 0, 0, 338, 179);
INSERT INTO public.who_global_data VALUES (80085, 0, 0, 0, 0, 338, 34);
INSERT INTO public.who_global_data VALUES (80086, 0, 0, 0, 0, 338, 207);
INSERT INTO public.who_global_data VALUES (80087, 0, 5, 0, 0, 338, 166);
INSERT INTO public.who_global_data VALUES (80088, 0, 0, 0, 0, 338, 126);
INSERT INTO public.who_global_data VALUES (80089, 0, 0, 0, 0, 338, 97);
INSERT INTO public.who_global_data VALUES (80090, 0, 0, 0, 0, 338, 36);
INSERT INTO public.who_global_data VALUES (80091, 0, 0, 0, 0, 338, 125);
INSERT INTO public.who_global_data VALUES (80092, 0, 0, 0, 0, 338, 124);
INSERT INTO public.who_global_data VALUES (80093, 0, 1, 0, 0, 338, 185);
INSERT INTO public.who_global_data VALUES (80094, 0, 31, 0, 0, 338, 194);
INSERT INTO public.who_global_data VALUES (80095, 0, 0, 0, 0, 338, 144);
INSERT INTO public.who_global_data VALUES (80096, 0, 133, 4, 9, 338, 19);
INSERT INTO public.who_global_data VALUES (80097, 0, 0, 0, 0, 338, 217);
INSERT INTO public.who_global_data VALUES (80098, 0, 0, 0, 0, 338, 148);
INSERT INTO public.who_global_data VALUES (80099, 0, 0, 0, 0, 338, 86);
INSERT INTO public.who_global_data VALUES (80100, 0, 0, 0, 0, 338, 13);
INSERT INTO public.who_global_data VALUES (80101, 0, 0, 0, 0, 338, 157);
INSERT INTO public.who_global_data VALUES (80102, 0, 20, 0, 0, 338, 8);
INSERT INTO public.who_global_data VALUES (80103, 0, 0, 0, 0, 338, 73);
INSERT INTO public.who_global_data VALUES (80104, 0, 0, 0, 0, 338, 101);
INSERT INTO public.who_global_data VALUES (80105, 0, 0, 0, 0, 338, 165);
INSERT INTO public.who_global_data VALUES (80106, 0, 0, 0, 0, 338, 14);
INSERT INTO public.who_global_data VALUES (80107, 0, 5, 0, 0, 339, 193);
INSERT INTO public.who_global_data VALUES (80108, 0, 0, 0, 0, 339, 113);
INSERT INTO public.who_global_data VALUES (80109, 7, 16, 0, 0, 339, 143);
INSERT INTO public.who_global_data VALUES (80110, 0, 0, 0, 0, 339, 219);
INSERT INTO public.who_global_data VALUES (80111, 0, 1, 0, 0, 339, 186);
INSERT INTO public.who_global_data VALUES (80112, 0, 0, 0, 0, 339, 52);
INSERT INTO public.who_global_data VALUES (80113, 0, 0, 0, 0, 339, 180);
INSERT INTO public.who_global_data VALUES (80114, 0, 0, 0, 0, 339, 167);
INSERT INTO public.who_global_data VALUES (80115, 0, 5, 0, 0, 339, 154);
INSERT INTO public.who_global_data VALUES (80116, 0, 1, 0, 0, 339, 94);
INSERT INTO public.who_global_data VALUES (80117, 0, 0, 0, 0, 339, 66);
INSERT INTO public.who_global_data VALUES (80118, 0, 37, 0, 1, 339, 58);
INSERT INTO public.who_global_data VALUES (80119, 6, 24, 0, 0, 339, 163);
INSERT INTO public.who_global_data VALUES (80120, 0, 3, 0, 0, 339, 37);
INSERT INTO public.who_global_data VALUES (80121, 0, 0, 0, 0, 339, 142);
INSERT INTO public.who_global_data VALUES (80122, 0, 53, 0, 0, 339, 83);
INSERT INTO public.who_global_data VALUES (80123, 0, 0, 0, 0, 339, 228);
INSERT INTO public.who_global_data VALUES (80124, 0, 0, 0, 0, 339, 188);
INSERT INTO public.who_global_data VALUES (80125, 0, 1, 0, 0, 339, 62);
INSERT INTO public.who_global_data VALUES (80126, 34, 72, 0, 0, 339, 160);
INSERT INTO public.who_global_data VALUES (80127, 0, 0, 0, 0, 339, 50);
INSERT INTO public.who_global_data VALUES (80128, 0, 0, 0, 0, 339, 33);
INSERT INTO public.who_global_data VALUES (80129, 0, 0, 0, 0, 339, 183);
INSERT INTO public.who_global_data VALUES (80130, 0, 0, 0, 0, 339, 92);
INSERT INTO public.who_global_data VALUES (80131, 0, 0, 0, 0, 339, 158);
INSERT INTO public.who_global_data VALUES (80132, 0, 0, 0, 0, 339, 67);
INSERT INTO public.who_global_data VALUES (80133, 0, 0, 0, 0, 339, 57);
INSERT INTO public.who_global_data VALUES (80134, 0, 0, 0, 0, 339, 38);
INSERT INTO public.who_global_data VALUES (80135, 1, 7, 0, 0, 339, 141);
INSERT INTO public.who_global_data VALUES (80136, 0, 0, 0, 0, 339, 178);
INSERT INTO public.who_global_data VALUES (80137, 0, 0, 0, 0, 339, 108);
INSERT INTO public.who_global_data VALUES (80138, 0, 0, 0, 0, 339, 39);
INSERT INTO public.who_global_data VALUES (80139, 0, 0, 0, 0, 339, 2);
INSERT INTO public.who_global_data VALUES (80140, 0, 0, 0, 0, 339, 195);
INSERT INTO public.who_global_data VALUES (80141, 0, 0, 0, 0, 339, 107);
INSERT INTO public.who_global_data VALUES (80142, 0, 5, 0, 0, 339, 161);
INSERT INTO public.who_global_data VALUES (80143, 0, 0, 0, 0, 339, 212);
INSERT INTO public.who_global_data VALUES (80144, 0, 34, 0, 0, 339, 181);
INSERT INTO public.who_global_data VALUES (80145, 0, 0, 0, 0, 339, 53);
INSERT INTO public.who_global_data VALUES (80146, 0, 0, 0, 0, 339, 164);
INSERT INTO public.who_global_data VALUES (80147, 0, 0, 0, 0, 339, 140);
INSERT INTO public.who_global_data VALUES (80148, 0, 5, 0, 0, 339, 20);
INSERT INTO public.who_global_data VALUES (80149, 120, 80426, 38, 2984, 339, 112);
INSERT INTO public.who_global_data VALUES (80150, 0, 0, 0, 0, 339, 111);
INSERT INTO public.who_global_data VALUES (80151, 0, 0, 0, 0, 339, 71);
INSERT INTO public.who_global_data VALUES (80152, 0, 0, 0, 0, 339, 218);
INSERT INTO public.who_global_data VALUES (80153, 0, 0, 0, 0, 339, 43);
INSERT INTO public.who_global_data VALUES (80154, 0, 0, 0, 0, 339, 49);
INSERT INTO public.who_global_data VALUES (80155, 0, 0, 0, 0, 339, 1);
INSERT INTO public.who_global_data VALUES (80156, 1, 9, 0, 0, 339, 48);
INSERT INTO public.who_global_data VALUES (80157, 0, 0, 0, 0, 339, 232);
INSERT INTO public.who_global_data VALUES (80158, 0, 0, 0, 0, 339, 175);
INSERT INTO public.who_global_data VALUES (80159, 0, 0, 0, 0, 339, 21);
INSERT INTO public.who_global_data VALUES (80160, 0, 5, 0, 0, 339, 156);
INSERT INTO public.who_global_data VALUES (80161, 0, 0, 0, 0, 339, 95);
INSERT INTO public.who_global_data VALUES (80162, 0, 0, 0, 0, 339, 177);
INSERT INTO public.who_global_data VALUES (80163, 3, 8, 0, 0, 339, 210);
INSERT INTO public.who_global_data VALUES (80164, 0, 0, 0, 0, 339, 120);
INSERT INTO public.who_global_data VALUES (80165, 0, 0, 0, 0, 339, 135);
INSERT INTO public.who_global_data VALUES (80166, 0, 5, 0, 0, 339, 206);
INSERT INTO public.who_global_data VALUES (80167, 0, 11, 0, 0, 339, 189);
INSERT INTO public.who_global_data VALUES (80168, 0, 6, 0, 0, 339, 129);
INSERT INTO public.who_global_data VALUES (80169, 0, 0, 0, 0, 339, 121);
INSERT INTO public.who_global_data VALUES (80170, 0, 0, 0, 0, 339, 59);
INSERT INTO public.who_global_data VALUES (80171, 0, 0, 0, 0, 339, 96);
INSERT INTO public.who_global_data VALUES (80172, 1, 2, 0, 0, 339, 41);
INSERT INTO public.who_global_data VALUES (80173, 0, 0, 0, 0, 339, 216);
INSERT INTO public.who_global_data VALUES (80174, 0, 0, 0, 0, 339, 236);
INSERT INTO public.who_global_data VALUES (80175, 0, 0, 0, 0, 339, 150);
INSERT INTO public.who_global_data VALUES (80176, 0, 0, 0, 0, 339, 61);
INSERT INTO public.who_global_data VALUES (80177, 0, 0, 0, 0, 339, 7);
INSERT INTO public.who_global_data VALUES (80178, 1, 7, 0, 0, 339, 169);
INSERT INTO public.who_global_data VALUES (80179, 34, 205, 1, 4, 339, 28);
INSERT INTO public.who_global_data VALUES (80180, 0, 0, 0, 0, 339, 85);
INSERT INTO public.who_global_data VALUES (80181, 0, 0, 0, 0, 339, 211);
INSERT INTO public.who_global_data VALUES (80182, 0, 0, 0, 0, 339, 60);
INSERT INTO public.who_global_data VALUES (80183, 0, 0, 0, 0, 339, 3);
INSERT INTO public.who_global_data VALUES (80184, 0, 3, 0, 0, 339, 11);
INSERT INTO public.who_global_data VALUES (80185, 39, 196, 0, 0, 339, 89);
INSERT INTO public.who_global_data VALUES (80186, 0, 0, 0, 0, 339, 24);
INSERT INTO public.who_global_data VALUES (80187, 0, 1, 0, 0, 339, 162);
INSERT INTO public.who_global_data VALUES (80188, 0, 7, 0, 0, 339, 100);
INSERT INTO public.who_global_data VALUES (80189, 0, 0, 0, 0, 339, 47);
INSERT INTO public.who_global_data VALUES (80190, 0, 0, 0, 0, 339, 29);
INSERT INTO public.who_global_data VALUES (80191, 0, 0, 0, 0, 339, 40);
INSERT INTO public.who_global_data VALUES (80192, 0, 0, 0, 0, 339, 222);
INSERT INTO public.who_global_data VALUES (80193, 0, 0, 0, 0, 339, 132);
INSERT INTO public.who_global_data VALUES (80194, 0, 0, 0, 0, 339, 130);
INSERT INTO public.who_global_data VALUES (80195, 0, 0, 0, 0, 339, 234);
INSERT INTO public.who_global_data VALUES (80196, 0, 0, 0, 0, 339, 23);
INSERT INTO public.who_global_data VALUES (80197, 0, 0, 0, 0, 339, 192);
INSERT INTO public.who_global_data VALUES (80198, 0, 0, 0, 0, 339, 69);
INSERT INTO public.who_global_data VALUES (80199, 0, 0, 0, 0, 339, 187);
INSERT INTO public.who_global_data VALUES (80200, 0, 0, 0, 0, 339, 230);
INSERT INTO public.who_global_data VALUES (80201, 0, 0, 0, 0, 339, 77);
INSERT INTO public.who_global_data VALUES (80202, 10, 16, 0, 0, 339, 9);
INSERT INTO public.who_global_data VALUES (80203, 22, 31, 0, 0, 339, 74);
INSERT INTO public.who_global_data VALUES (80204, 0, 6, 0, 0, 339, 224);
INSERT INTO public.who_global_data VALUES (80205, 586, 2926, 15, 92, 339, 199);
INSERT INTO public.who_global_data VALUES (80206, 5, 40, 2, 2, 339, 190);
INSERT INTO public.who_global_data VALUES (80207, 1, 2, 0, 0, 339, 12);
INSERT INTO public.who_global_data VALUES (80208, 0, 0, 0, 0, 339, 104);
INSERT INTO public.who_global_data VALUES (80209, 5, 12, 0, 0, 339, 153);
INSERT INTO public.who_global_data VALUES (80210, 466, 2502, 28, 80, 339, 91);
INSERT INTO public.who_global_data VALUES (80211, 0, 0, 0, 0, 339, 215);
INSERT INTO public.who_global_data VALUES (80212, 3, 291, 0, 6, 339, 84);
INSERT INTO public.who_global_data VALUES (80213, 0, 0, 0, 0, 339, 231);
INSERT INTO public.who_global_data VALUES (80214, 0, 5, 0, 0, 339, 196);
INSERT INTO public.who_global_data VALUES (80215, 0, 0, 0, 0, 339, 105);
INSERT INTO public.who_global_data VALUES (80216, 0, 0, 0, 0, 339, 122);
INSERT INTO public.who_global_data VALUES (80217, 0, 0, 0, 0, 339, 159);
INSERT INTO public.who_global_data VALUES (80218, 0, 0, 0, 0, 339, 75);
INSERT INTO public.who_global_data VALUES (80219, 0, 60, 0, 0, 339, 27);
INSERT INTO public.who_global_data VALUES (80220, 0, 0, 0, 0, 339, 54);
INSERT INTO public.who_global_data VALUES (80221, 0, 0, 0, 0, 339, 226);
INSERT INTO public.who_global_data VALUES (80222, 0, 1, 0, 0, 339, 79);
INSERT INTO public.who_global_data VALUES (80223, 0, 17, 0, 0, 339, 56);
INSERT INTO public.who_global_data VALUES (80224, 0, 0, 0, 0, 339, 117);
INSERT INTO public.who_global_data VALUES (80225, 0, 0, 0, 0, 339, 152);
INSERT INTO public.who_global_data VALUES (80226, 0, 0, 0, 0, 339, 16);
INSERT INTO public.who_global_data VALUES (80227, 0, 1, 0, 0, 339, 10);
INSERT INTO public.who_global_data VALUES (80228, 0, 1, 0, 0, 339, 201);
INSERT INTO public.who_global_data VALUES (80229, 0, 1, 0, 0, 339, 174);
INSERT INTO public.who_global_data VALUES (80230, 0, 0, 0, 0, 339, 119);
INSERT INTO public.who_global_data VALUES (80231, 0, 0, 0, 0, 339, 168);
INSERT INTO public.who_global_data VALUES (80232, 0, 40, 0, 0, 339, 99);
INSERT INTO public.who_global_data VALUES (80233, 0, 0, 0, 0, 339, 171);
INSERT INTO public.who_global_data VALUES (80234, 0, 0, 0, 0, 339, 87);
INSERT INTO public.who_global_data VALUES (80235, 0, 0, 0, 0, 339, 123);
INSERT INTO public.who_global_data VALUES (80236, 0, 0, 0, 0, 339, 151);
INSERT INTO public.who_global_data VALUES (80237, 0, 0, 0, 0, 339, 213);
INSERT INTO public.who_global_data VALUES (80238, 0, 0, 0, 0, 339, 118);
INSERT INTO public.who_global_data VALUES (80239, 0, 0, 0, 0, 339, 134);
INSERT INTO public.who_global_data VALUES (80240, 0, 0, 0, 0, 339, 65);
INSERT INTO public.who_global_data VALUES (80241, 0, 9, 0, 0, 339, 102);
INSERT INTO public.who_global_data VALUES (80242, 0, 0, 0, 0, 339, 223);
INSERT INTO public.who_global_data VALUES (80243, 0, 1, 0, 0, 339, 4);
INSERT INTO public.who_global_data VALUES (80244, 0, 0, 0, 0, 339, 146);
INSERT INTO public.who_global_data VALUES (80245, 0, 0, 0, 0, 339, 31);
INSERT INTO public.who_global_data VALUES (80246, 0, 0, 0, 0, 339, 127);
INSERT INTO public.who_global_data VALUES (80247, 0, 5, 0, 0, 339, 22);
INSERT INTO public.who_global_data VALUES (80248, 0, 0, 0, 0, 339, 115);
INSERT INTO public.who_global_data VALUES (80249, 0, 0, 0, 0, 339, 106);
INSERT INTO public.who_global_data VALUES (80250, 0, 0, 0, 0, 339, 90);
INSERT INTO public.who_global_data VALUES (80251, 0, 0, 0, 0, 339, 70);
INSERT INTO public.who_global_data VALUES (80252, 0, 5, 0, 0, 339, 46);
INSERT INTO public.who_global_data VALUES (80253, 4, 14, 0, 0, 339, 139);
INSERT INTO public.who_global_data VALUES (80254, 0, 0, 0, 0, 339, 42);
INSERT INTO public.who_global_data VALUES (80255, 0, 6, 0, 0, 339, 80);
INSERT INTO public.who_global_data VALUES (80256, 0, 0, 0, 0, 339, 203);
INSERT INTO public.who_global_data VALUES (80257, 0, 0, 0, 0, 339, 136);
INSERT INTO public.who_global_data VALUES (80258, 0, 5, 0, 0, 339, 63);
INSERT INTO public.who_global_data VALUES (80259, 0, 0, 0, 0, 339, 17);
INSERT INTO public.who_global_data VALUES (80260, 0, 0, 0, 0, 339, 172);
INSERT INTO public.who_global_data VALUES (80261, 0, 1, 0, 0, 339, 109);
INSERT INTO public.who_global_data VALUES (80262, 8, 33, 0, 0, 339, 200);
INSERT INTO public.who_global_data VALUES (80263, 0, 0, 0, 0, 339, 93);
INSERT INTO public.who_global_data VALUES (80264, 3, 19, 0, 0, 339, 5);
INSERT INTO public.who_global_data VALUES (80265, 0, 700, 0, 6, 339, 214);
INSERT INTO public.who_global_data VALUES (80266, 0, 9, 0, 0, 339, 204);
INSERT INTO public.who_global_data VALUES (80267, 0, 0, 0, 0, 339, 198);
INSERT INTO public.who_global_data VALUES (80268, 0, 0, 0, 0, 339, 173);
INSERT INTO public.who_global_data VALUES (80269, 0, 0, 0, 0, 339, 229);
INSERT INTO public.who_global_data VALUES (80270, 0, 0, 0, 0, 339, 76);
INSERT INTO public.who_global_data VALUES (80271, 0, 0, 0, 0, 339, 138);
INSERT INTO public.who_global_data VALUES (80272, 0, 7, 0, 1, 339, 98);
INSERT INTO public.who_global_data VALUES (80273, 0, 0, 0, 0, 339, 103);
INSERT INTO public.who_global_data VALUES (80274, 1, 1, 0, 0, 339, 225);
INSERT INTO public.who_global_data VALUES (80275, 2, 4, 0, 0, 339, 131);
INSERT INTO public.who_global_data VALUES (80276, 0, 0, 0, 0, 339, 235);
INSERT INTO public.who_global_data VALUES (80277, 0, 12, 0, 0, 339, 137);
INSERT INTO public.who_global_data VALUES (80278, 516, 5332, 4, 32, 339, 81);
INSERT INTO public.who_global_data VALUES (80279, 0, 0, 0, 0, 339, 182);
INSERT INTO public.who_global_data VALUES (80280, 0, 0, 0, 0, 339, 145);
INSERT INTO public.who_global_data VALUES (80281, 1, 4, 0, 0, 339, 26);
INSERT INTO public.who_global_data VALUES (80282, 0, 3, 0, 0, 339, 170);
INSERT INTO public.who_global_data VALUES (80283, 0, 0, 0, 0, 339, 191);
INSERT INTO public.who_global_data VALUES (80284, 0, 0, 0, 0, 339, 221);
INSERT INTO public.who_global_data VALUES (80285, 0, 1, 0, 0, 339, 64);
INSERT INTO public.who_global_data VALUES (80286, 0, 0, 0, 0, 339, 116);
INSERT INTO public.who_global_data VALUES (80287, 0, 0, 0, 0, 339, 128);
INSERT INTO public.who_global_data VALUES (80288, 0, 0, 0, 0, 339, 6);
INSERT INTO public.who_global_data VALUES (80289, 0, 6, 0, 0, 339, 227);
INSERT INTO public.who_global_data VALUES (80290, 0, 0, 0, 0, 339, 68);
INSERT INTO public.who_global_data VALUES (80291, 0, 0, 0, 0, 339, 184);
INSERT INTO public.who_global_data VALUES (80292, 0, 0, 0, 0, 339, 82);
INSERT INTO public.who_global_data VALUES (80293, 0, 9, 0, 1, 339, 149);
INSERT INTO public.who_global_data VALUES (80294, 0, 0, 0, 0, 339, 197);
INSERT INTO public.who_global_data VALUES (80295, 1, 6, 0, 0, 339, 78);
INSERT INTO public.who_global_data VALUES (80296, 3, 8, 0, 0, 339, 233);
INSERT INTO public.who_global_data VALUES (80297, 0, 0, 0, 0, 339, 133);
INSERT INTO public.who_global_data VALUES (80298, 0, 0, 0, 0, 339, 35);
INSERT INTO public.who_global_data VALUES (80299, 0, 0, 0, 0, 339, 114);
INSERT INTO public.who_global_data VALUES (80300, 0, 114, 0, 0, 339, 237);
INSERT INTO public.who_global_data VALUES (80301, 0, 0, 0, 0, 339, 55);
INSERT INTO public.who_global_data VALUES (80302, 0, 0, 0, 0, 339, 176);
INSERT INTO public.who_global_data VALUES (80303, 0, 0, 0, 0, 339, 202);
INSERT INTO public.who_global_data VALUES (80304, 1, 1, 0, 0, 339, 155);
INSERT INTO public.who_global_data VALUES (80305, 0, 0, 0, 0, 339, 32);
INSERT INTO public.who_global_data VALUES (80306, 0, 0, 0, 0, 339, 220);
INSERT INTO public.who_global_data VALUES (80307, 0, 0, 0, 0, 339, 30);
INSERT INTO public.who_global_data VALUES (80308, 0, 0, 0, 0, 339, 147);
INSERT INTO public.who_global_data VALUES (80309, 72, 218, 0, 1, 339, 208);
INSERT INTO public.who_global_data VALUES (80310, 0, 5, 0, 0, 339, 45);
INSERT INTO public.who_global_data VALUES (80311, 0, 0, 0, 0, 339, 110);
INSERT INTO public.who_global_data VALUES (80312, 0, 0, 0, 0, 339, 88);
INSERT INTO public.who_global_data VALUES (80313, 5, 19, 0, 0, 339, 51);
INSERT INTO public.who_global_data VALUES (80314, 33, 119, 0, 0, 339, 209);
INSERT INTO public.who_global_data VALUES (80315, 0, 0, 0, 0, 339, 205);
INSERT INTO public.who_global_data VALUES (80316, 0, 0, 0, 0, 339, 18);
INSERT INTO public.who_global_data VALUES (80317, 0, 47, 0, 1, 339, 72);
INSERT INTO public.who_global_data VALUES (80318, 40, 109, 0, 0, 339, 44);
INSERT INTO public.who_global_data VALUES (80319, 0, 0, 0, 0, 339, 15);
INSERT INTO public.who_global_data VALUES (80320, 0, 0, 0, 0, 339, 25);
INSERT INTO public.who_global_data VALUES (80321, 0, 0, 0, 0, 339, 179);
INSERT INTO public.who_global_data VALUES (80322, 0, 0, 0, 0, 339, 34);
INSERT INTO public.who_global_data VALUES (80323, 0, 0, 0, 0, 339, 207);
INSERT INTO public.who_global_data VALUES (80324, 0, 5, 0, 0, 339, 166);
INSERT INTO public.who_global_data VALUES (80325, 0, 0, 0, 0, 339, 126);
INSERT INTO public.who_global_data VALUES (80326, 0, 0, 0, 0, 339, 97);
INSERT INTO public.who_global_data VALUES (80327, 0, 0, 0, 0, 339, 36);
INSERT INTO public.who_global_data VALUES (80328, 0, 0, 0, 0, 339, 125);
INSERT INTO public.who_global_data VALUES (80329, 0, 0, 0, 0, 339, 124);
INSERT INTO public.who_global_data VALUES (80330, 0, 1, 0, 0, 339, 185);
INSERT INTO public.who_global_data VALUES (80331, 0, 31, 0, 0, 339, 194);
INSERT INTO public.who_global_data VALUES (80332, 0, 0, 0, 0, 339, 144);
INSERT INTO public.who_global_data VALUES (80333, 21, 133, 3, 5, 339, 19);
INSERT INTO public.who_global_data VALUES (80334, 0, 0, 0, 0, 339, 217);
INSERT INTO public.who_global_data VALUES (80335, 0, 0, 0, 0, 339, 148);
INSERT INTO public.who_global_data VALUES (80336, 0, 0, 0, 0, 339, 86);
INSERT INTO public.who_global_data VALUES (80337, 0, 0, 0, 0, 339, 13);
INSERT INTO public.who_global_data VALUES (80338, 0, 0, 0, 0, 339, 157);
INSERT INTO public.who_global_data VALUES (80339, 0, 20, 0, 0, 339, 8);
INSERT INTO public.who_global_data VALUES (80340, 0, 0, 0, 0, 339, 73);
INSERT INTO public.who_global_data VALUES (80341, 0, 0, 0, 0, 339, 101);
INSERT INTO public.who_global_data VALUES (80342, 0, 0, 0, 0, 339, 165);
INSERT INTO public.who_global_data VALUES (80343, 0, 0, 0, 0, 339, 14);
INSERT INTO public.who_global_data VALUES (80344, 0, 5, 0, 0, 340, 193);
INSERT INTO public.who_global_data VALUES (80345, 0, 0, 0, 0, 340, 113);
INSERT INTO public.who_global_data VALUES (80346, 2, 9, 0, 0, 340, 143);
INSERT INTO public.who_global_data VALUES (80347, 0, 0, 0, 0, 340, 219);
INSERT INTO public.who_global_data VALUES (80348, 1, 1, 0, 0, 340, 186);
INSERT INTO public.who_global_data VALUES (80349, 0, 0, 0, 0, 340, 52);
INSERT INTO public.who_global_data VALUES (80350, 0, 0, 0, 0, 340, 180);
INSERT INTO public.who_global_data VALUES (80351, 0, 0, 0, 0, 340, 167);
INSERT INTO public.who_global_data VALUES (80352, 5, 5, 0, 0, 340, 154);
INSERT INTO public.who_global_data VALUES (80353, 0, 1, 0, 0, 340, 94);
INSERT INTO public.who_global_data VALUES (80354, 0, 0, 0, 0, 340, 66);
INSERT INTO public.who_global_data VALUES (80355, 0, 37, 0, 1, 340, 58);
INSERT INTO public.who_global_data VALUES (80356, 4, 18, 0, 0, 340, 163);
INSERT INTO public.who_global_data VALUES (80357, 0, 3, 0, 0, 340, 37);
INSERT INTO public.who_global_data VALUES (80358, 0, 0, 0, 0, 340, 142);
INSERT INTO public.who_global_data VALUES (80359, 0, 53, 0, 0, 340, 83);
INSERT INTO public.who_global_data VALUES (80360, 0, 0, 0, 0, 340, 228);
INSERT INTO public.who_global_data VALUES (80361, 0, 0, 0, 0, 340, 188);
INSERT INTO public.who_global_data VALUES (80362, 0, 1, 0, 0, 340, 62);
INSERT INTO public.who_global_data VALUES (80363, 19, 38, 0, 0, 340, 160);
INSERT INTO public.who_global_data VALUES (80364, 0, 0, 0, 0, 340, 50);
INSERT INTO public.who_global_data VALUES (80365, 0, 0, 0, 0, 340, 33);
INSERT INTO public.who_global_data VALUES (80366, 0, 0, 0, 0, 340, 183);
INSERT INTO public.who_global_data VALUES (80367, 0, 0, 0, 0, 340, 92);
INSERT INTO public.who_global_data VALUES (80368, 0, 0, 0, 0, 340, 158);
INSERT INTO public.who_global_data VALUES (80369, 0, 0, 0, 0, 340, 67);
INSERT INTO public.who_global_data VALUES (80370, 0, 0, 0, 0, 340, 57);
INSERT INTO public.who_global_data VALUES (80371, 0, 0, 0, 0, 340, 38);
INSERT INTO public.who_global_data VALUES (80372, 0, 6, 0, 0, 340, 141);
INSERT INTO public.who_global_data VALUES (80373, 0, 0, 0, 0, 340, 178);
INSERT INTO public.who_global_data VALUES (80374, 0, 0, 0, 0, 340, 108);
INSERT INTO public.who_global_data VALUES (80375, 0, 0, 0, 0, 340, 39);
INSERT INTO public.who_global_data VALUES (80376, 0, 0, 0, 0, 340, 2);
INSERT INTO public.who_global_data VALUES (80377, 0, 0, 0, 0, 340, 195);
INSERT INTO public.who_global_data VALUES (80378, 0, 0, 0, 0, 340, 107);
INSERT INTO public.who_global_data VALUES (80379, 0, 5, 0, 0, 340, 161);
INSERT INTO public.who_global_data VALUES (80380, 0, 0, 0, 0, 340, 212);
INSERT INTO public.who_global_data VALUES (80381, 3, 34, 0, 0, 340, 181);
INSERT INTO public.who_global_data VALUES (80382, 0, 0, 0, 0, 340, 53);
INSERT INTO public.who_global_data VALUES (80383, 0, 0, 0, 0, 340, 164);
INSERT INTO public.who_global_data VALUES (80384, 0, 0, 0, 0, 340, 140);
INSERT INTO public.who_global_data VALUES (80385, 5, 5, 0, 0, 340, 20);
INSERT INTO public.who_global_data VALUES (80386, 128, 80306, 31, 2946, 340, 112);
INSERT INTO public.who_global_data VALUES (80387, 0, 0, 0, 0, 340, 111);
INSERT INTO public.who_global_data VALUES (80388, 0, 0, 0, 0, 340, 71);
INSERT INTO public.who_global_data VALUES (80389, 0, 0, 0, 0, 340, 218);
INSERT INTO public.who_global_data VALUES (80390, 0, 0, 0, 0, 340, 43);
INSERT INTO public.who_global_data VALUES (80391, 0, 0, 0, 0, 340, 49);
INSERT INTO public.who_global_data VALUES (80392, 0, 0, 0, 0, 340, 1);
INSERT INTO public.who_global_data VALUES (80393, 1, 8, 0, 0, 340, 48);
INSERT INTO public.who_global_data VALUES (80394, 0, 0, 0, 0, 340, 232);
INSERT INTO public.who_global_data VALUES (80395, 0, 0, 0, 0, 340, 175);
INSERT INTO public.who_global_data VALUES (80396, 0, 0, 0, 0, 340, 21);
INSERT INTO public.who_global_data VALUES (80397, 2, 5, 0, 0, 340, 156);
INSERT INTO public.who_global_data VALUES (80398, 0, 0, 0, 0, 340, 95);
INSERT INTO public.who_global_data VALUES (80399, 0, 0, 0, 0, 340, 177);
INSERT INTO public.who_global_data VALUES (80400, 1, 5, 0, 0, 340, 210);
INSERT INTO public.who_global_data VALUES (80401, 0, 0, 0, 0, 340, 120);
INSERT INTO public.who_global_data VALUES (80402, 0, 0, 0, 0, 340, 135);
INSERT INTO public.who_global_data VALUES (80403, 0, 5, 0, 0, 340, 206);
INSERT INTO public.who_global_data VALUES (80404, 1, 11, 0, 0, 340, 189);
INSERT INTO public.who_global_data VALUES (80405, 0, 6, 0, 0, 340, 129);
INSERT INTO public.who_global_data VALUES (80406, 0, 0, 0, 0, 340, 121);
INSERT INTO public.who_global_data VALUES (80407, 0, 0, 0, 0, 340, 59);
INSERT INTO public.who_global_data VALUES (80408, 0, 0, 0, 0, 340, 96);
INSERT INTO public.who_global_data VALUES (80409, 0, 1, 0, 0, 340, 41);
INSERT INTO public.who_global_data VALUES (80410, 0, 0, 0, 0, 340, 216);
INSERT INTO public.who_global_data VALUES (80411, 0, 0, 0, 0, 340, 236);
INSERT INTO public.who_global_data VALUES (80412, 0, 0, 0, 0, 340, 150);
INSERT INTO public.who_global_data VALUES (80413, 0, 0, 0, 0, 340, 61);
INSERT INTO public.who_global_data VALUES (80414, 0, 0, 0, 0, 340, 7);
INSERT INTO public.who_global_data VALUES (80415, 0, 6, 0, 0, 340, 169);
INSERT INTO public.who_global_data VALUES (80416, 48, 171, 1, 3, 340, 28);
INSERT INTO public.who_global_data VALUES (80417, 0, 0, 0, 0, 340, 85);
INSERT INTO public.who_global_data VALUES (80418, 0, 0, 0, 0, 340, 211);
INSERT INTO public.who_global_data VALUES (80419, 0, 0, 0, 0, 340, 60);
INSERT INTO public.who_global_data VALUES (80420, 0, 0, 0, 0, 340, 3);
INSERT INTO public.who_global_data VALUES (80421, 0, 3, 0, 0, 340, 11);
INSERT INTO public.who_global_data VALUES (80422, 28, 157, 0, 0, 340, 89);
INSERT INTO public.who_global_data VALUES (80423, 0, 0, 0, 0, 340, 24);
INSERT INTO public.who_global_data VALUES (80424, 1, 1, 0, 0, 340, 162);
INSERT INTO public.who_global_data VALUES (80425, 0, 7, 0, 0, 340, 100);
INSERT INTO public.who_global_data VALUES (80426, 0, 0, 0, 0, 340, 47);
INSERT INTO public.who_global_data VALUES (80427, 0, 0, 0, 0, 340, 29);
INSERT INTO public.who_global_data VALUES (80428, 0, 0, 0, 0, 340, 40);
INSERT INTO public.who_global_data VALUES (80429, 0, 0, 0, 0, 340, 222);
INSERT INTO public.who_global_data VALUES (80430, 0, 0, 0, 0, 340, 132);
INSERT INTO public.who_global_data VALUES (80431, 0, 0, 0, 0, 340, 130);
INSERT INTO public.who_global_data VALUES (80432, 0, 0, 0, 0, 340, 234);
INSERT INTO public.who_global_data VALUES (80433, 0, 0, 0, 0, 340, 23);
INSERT INTO public.who_global_data VALUES (80434, 0, 0, 0, 0, 340, 192);
INSERT INTO public.who_global_data VALUES (80435, 0, 0, 0, 0, 340, 69);
INSERT INTO public.who_global_data VALUES (80436, 0, 0, 0, 0, 340, 187);
INSERT INTO public.who_global_data VALUES (80437, 0, 0, 0, 0, 340, 230);
INSERT INTO public.who_global_data VALUES (80438, 0, 0, 0, 0, 340, 77);
INSERT INTO public.who_global_data VALUES (80439, 3, 6, 0, 0, 340, 9);
INSERT INTO public.who_global_data VALUES (80440, 0, 9, 0, 0, 340, 74);
INSERT INTO public.who_global_data VALUES (80441, 0, 6, 0, 0, 340, 224);
INSERT INTO public.who_global_data VALUES (80442, 835, 2340, 11, 77, 340, 199);
INSERT INTO public.who_global_data VALUES (80443, 5, 35, 0, 0, 340, 190);
INSERT INTO public.who_global_data VALUES (80444, 0, 1, 0, 0, 340, 12);
INSERT INTO public.who_global_data VALUES (80445, 0, 0, 0, 0, 340, 104);
INSERT INTO public.who_global_data VALUES (80446, 1, 7, 0, 0, 340, 153);
INSERT INTO public.who_global_data VALUES (80447, 347, 2036, 17, 52, 340, 91);
INSERT INTO public.who_global_data VALUES (80448, 0, 0, 0, 0, 340, 215);
INSERT INTO public.who_global_data VALUES (80449, 16, 288, 0, 6, 340, 84);
INSERT INTO public.who_global_data VALUES (80450, 0, 0, 0, 0, 340, 231);
INSERT INTO public.who_global_data VALUES (80451, 0, 5, 0, 0, 340, 196);
INSERT INTO public.who_global_data VALUES (80452, 0, 0, 0, 0, 340, 105);
INSERT INTO public.who_global_data VALUES (80453, 0, 0, 0, 0, 340, 122);
INSERT INTO public.who_global_data VALUES (80454, 0, 0, 0, 0, 340, 159);
INSERT INTO public.who_global_data VALUES (80455, 0, 0, 0, 0, 340, 75);
INSERT INTO public.who_global_data VALUES (80456, 0, 60, 0, 0, 340, 27);
INSERT INTO public.who_global_data VALUES (80457, 0, 0, 0, 0, 340, 54);
INSERT INTO public.who_global_data VALUES (80458, 0, 0, 0, 0, 340, 226);
INSERT INTO public.who_global_data VALUES (80459, 0, 1, 0, 0, 340, 79);
INSERT INTO public.who_global_data VALUES (80460, 0, 17, 0, 0, 340, 56);
INSERT INTO public.who_global_data VALUES (80461, 0, 0, 0, 0, 340, 117);
INSERT INTO public.who_global_data VALUES (80462, 0, 0, 0, 0, 340, 152);
INSERT INTO public.who_global_data VALUES (80463, 0, 0, 0, 0, 340, 16);
INSERT INTO public.who_global_data VALUES (80464, 0, 1, 0, 0, 340, 10);
INSERT INTO public.who_global_data VALUES (80465, 0, 1, 0, 0, 340, 201);
INSERT INTO public.who_global_data VALUES (80466, 0, 1, 0, 0, 340, 174);
INSERT INTO public.who_global_data VALUES (80467, 0, 0, 0, 0, 340, 119);
INSERT INTO public.who_global_data VALUES (80468, 0, 0, 0, 0, 340, 168);
INSERT INTO public.who_global_data VALUES (80469, 7, 40, 0, 0, 340, 99);
INSERT INTO public.who_global_data VALUES (80470, 0, 0, 0, 0, 340, 171);
INSERT INTO public.who_global_data VALUES (80471, 0, 0, 0, 0, 340, 87);
INSERT INTO public.who_global_data VALUES (80472, 0, 0, 0, 0, 340, 123);
INSERT INTO public.who_global_data VALUES (80473, 0, 0, 0, 0, 340, 151);
INSERT INTO public.who_global_data VALUES (80474, 0, 0, 0, 0, 340, 213);
INSERT INTO public.who_global_data VALUES (80475, 0, 0, 0, 0, 340, 118);
INSERT INTO public.who_global_data VALUES (80476, 0, 0, 0, 0, 340, 134);
INSERT INTO public.who_global_data VALUES (80477, 0, 0, 0, 0, 340, 65);
INSERT INTO public.who_global_data VALUES (80478, 0, 9, 0, 0, 340, 102);
INSERT INTO public.who_global_data VALUES (80479, 0, 0, 0, 0, 340, 223);
INSERT INTO public.who_global_data VALUES (80480, 0, 1, 0, 0, 340, 4);
INSERT INTO public.who_global_data VALUES (80481, 0, 0, 0, 0, 340, 146);
INSERT INTO public.who_global_data VALUES (80482, 0, 0, 0, 0, 340, 31);
INSERT INTO public.who_global_data VALUES (80483, 0, 0, 0, 0, 340, 127);
INSERT INTO public.who_global_data VALUES (80484, 0, 5, 0, 0, 340, 22);
INSERT INTO public.who_global_data VALUES (80485, 0, 0, 0, 0, 340, 115);
INSERT INTO public.who_global_data VALUES (80486, 0, 0, 0, 0, 340, 106);
INSERT INTO public.who_global_data VALUES (80487, 0, 0, 0, 0, 340, 90);
INSERT INTO public.who_global_data VALUES (80488, 0, 0, 0, 0, 340, 70);
INSERT INTO public.who_global_data VALUES (80489, 0, 5, 0, 0, 340, 46);
INSERT INTO public.who_global_data VALUES (80490, 5, 10, 0, 0, 340, 139);
INSERT INTO public.who_global_data VALUES (80491, 0, 0, 0, 0, 340, 42);
INSERT INTO public.who_global_data VALUES (80492, 1, 6, 0, 0, 340, 80);
INSERT INTO public.who_global_data VALUES (80493, 0, 0, 0, 0, 340, 203);
INSERT INTO public.who_global_data VALUES (80494, 0, 0, 0, 0, 340, 136);
INSERT INTO public.who_global_data VALUES (80495, 0, 5, 0, 0, 340, 63);
INSERT INTO public.who_global_data VALUES (80496, 0, 0, 0, 0, 340, 17);
INSERT INTO public.who_global_data VALUES (80497, 0, 0, 0, 0, 340, 172);
INSERT INTO public.who_global_data VALUES (80498, 0, 1, 0, 0, 340, 109);
INSERT INTO public.who_global_data VALUES (80499, 6, 25, 0, 0, 340, 200);
INSERT INTO public.who_global_data VALUES (80500, 0, 0, 0, 0, 340, 93);
INSERT INTO public.who_global_data VALUES (80501, 6, 16, 0, 0, 340, 5);
INSERT INTO public.who_global_data VALUES (80502, 0, 700, 0, 6, 340, 214);
INSERT INTO public.who_global_data VALUES (80503, 0, 9, 0, 0, 340, 204);
INSERT INTO public.who_global_data VALUES (80504, 0, 0, 0, 0, 340, 198);
INSERT INTO public.who_global_data VALUES (80505, 0, 0, 0, 0, 340, 173);
INSERT INTO public.who_global_data VALUES (80506, 0, 0, 0, 0, 340, 229);
INSERT INTO public.who_global_data VALUES (80507, 0, 0, 0, 0, 340, 76);
INSERT INTO public.who_global_data VALUES (80508, 0, 0, 0, 0, 340, 138);
INSERT INTO public.who_global_data VALUES (80509, 0, 7, 0, 1, 340, 98);
INSERT INTO public.who_global_data VALUES (80510, 0, 0, 0, 0, 340, 103);
INSERT INTO public.who_global_data VALUES (80511, 0, 0, 0, 0, 340, 225);
INSERT INTO public.who_global_data VALUES (80512, 0, 2, 0, 0, 340, 131);
INSERT INTO public.who_global_data VALUES (80513, 0, 0, 0, 0, 340, 235);
INSERT INTO public.who_global_data VALUES (80514, 1, 12, 0, 0, 340, 137);
INSERT INTO public.who_global_data VALUES (80515, 600, 4816, 6, 28, 340, 81);
INSERT INTO public.who_global_data VALUES (80516, 0, 0, 0, 0, 340, 182);
INSERT INTO public.who_global_data VALUES (80517, 0, 0, 0, 0, 340, 145);
INSERT INTO public.who_global_data VALUES (80518, 0, 3, 0, 0, 340, 26);
INSERT INTO public.who_global_data VALUES (80519, 1, 3, 0, 0, 340, 170);
INSERT INTO public.who_global_data VALUES (80520, 0, 0, 0, 0, 340, 191);
INSERT INTO public.who_global_data VALUES (80521, 0, 0, 0, 0, 340, 221);
INSERT INTO public.who_global_data VALUES (80522, 0, 1, 0, 0, 340, 64);
INSERT INTO public.who_global_data VALUES (80523, 0, 0, 0, 0, 340, 116);
INSERT INTO public.who_global_data VALUES (80524, 0, 0, 0, 0, 340, 128);
INSERT INTO public.who_global_data VALUES (80525, 0, 0, 0, 0, 340, 6);
INSERT INTO public.who_global_data VALUES (80526, 0, 6, 0, 0, 340, 227);
INSERT INTO public.who_global_data VALUES (80527, 0, 0, 0, 0, 340, 68);
INSERT INTO public.who_global_data VALUES (80528, 0, 0, 0, 0, 340, 184);
INSERT INTO public.who_global_data VALUES (80529, 0, 0, 0, 0, 340, 82);
INSERT INTO public.who_global_data VALUES (80530, 8, 9, 0, 1, 340, 149);
INSERT INTO public.who_global_data VALUES (80531, 0, 0, 0, 0, 340, 197);
INSERT INTO public.who_global_data VALUES (80532, 0, 5, 0, 0, 340, 78);
INSERT INTO public.who_global_data VALUES (80533, 0, 5, 0, 0, 340, 233);
INSERT INTO public.who_global_data VALUES (80534, 0, 0, 0, 0, 340, 133);
INSERT INTO public.who_global_data VALUES (80535, 0, 0, 0, 0, 340, 35);
INSERT INTO public.who_global_data VALUES (80536, 0, 0, 0, 0, 340, 114);
INSERT INTO public.who_global_data VALUES (80537, 2, 114, 0, 0, 340, 237);
INSERT INTO public.who_global_data VALUES (80538, 0, 0, 0, 0, 340, 55);
INSERT INTO public.who_global_data VALUES (80539, 0, 0, 0, 0, 340, 176);
INSERT INTO public.who_global_data VALUES (80540, 0, 0, 0, 0, 340, 202);
INSERT INTO public.who_global_data VALUES (80541, 0, 0, 0, 0, 340, 155);
INSERT INTO public.who_global_data VALUES (80542, 0, 0, 0, 0, 340, 32);
INSERT INTO public.who_global_data VALUES (80543, 0, 0, 0, 0, 340, 220);
INSERT INTO public.who_global_data VALUES (80544, 0, 0, 0, 0, 340, 30);
INSERT INTO public.who_global_data VALUES (80545, 0, 0, 0, 0, 340, 147);
INSERT INTO public.who_global_data VALUES (80546, 38, 146, 0, 1, 340, 208);
INSERT INTO public.who_global_data VALUES (80547, 0, 5, 0, 0, 340, 45);
INSERT INTO public.who_global_data VALUES (80548, 0, 0, 0, 0, 340, 110);
INSERT INTO public.who_global_data VALUES (80549, 0, 0, 0, 0, 340, 88);
INSERT INTO public.who_global_data VALUES (80550, 0, 14, 0, 0, 340, 51);
INSERT INTO public.who_global_data VALUES (80551, 30, 86, 0, 0, 340, 209);
INSERT INTO public.who_global_data VALUES (80552, 0, 0, 0, 0, 340, 205);
INSERT INTO public.who_global_data VALUES (80553, 0, 0, 0, 0, 340, 18);
INSERT INTO public.who_global_data VALUES (80554, 0, 47, 0, 1, 340, 72);
INSERT INTO public.who_global_data VALUES (80555, 22, 69, 0, 0, 340, 44);
INSERT INTO public.who_global_data VALUES (80556, 0, 0, 0, 0, 340, 15);
INSERT INTO public.who_global_data VALUES (80557, 0, 0, 0, 0, 340, 25);
INSERT INTO public.who_global_data VALUES (80558, 0, 0, 0, 0, 340, 179);
INSERT INTO public.who_global_data VALUES (80559, 0, 0, 0, 0, 340, 34);
INSERT INTO public.who_global_data VALUES (80560, 0, 0, 0, 0, 340, 207);
INSERT INTO public.who_global_data VALUES (80561, 0, 5, 0, 0, 340, 166);
INSERT INTO public.who_global_data VALUES (80562, 0, 0, 0, 0, 340, 126);
INSERT INTO public.who_global_data VALUES (80563, 0, 0, 0, 0, 340, 97);
INSERT INTO public.who_global_data VALUES (80564, 0, 0, 0, 0, 340, 36);
INSERT INTO public.who_global_data VALUES (80565, 0, 0, 0, 0, 340, 125);
INSERT INTO public.who_global_data VALUES (80566, 0, 0, 0, 0, 340, 124);
INSERT INTO public.who_global_data VALUES (80567, 1, 1, 0, 0, 340, 185);
INSERT INTO public.who_global_data VALUES (80568, 6, 31, 0, 0, 340, 194);
INSERT INTO public.who_global_data VALUES (80569, 0, 0, 0, 0, 340, 144);
INSERT INTO public.who_global_data VALUES (80570, 44, 112, 2, 2, 340, 19);
INSERT INTO public.who_global_data VALUES (80571, 0, 0, 0, 0, 340, 217);
INSERT INTO public.who_global_data VALUES (80572, 0, 0, 0, 0, 340, 148);
INSERT INTO public.who_global_data VALUES (80573, 0, 0, 0, 0, 340, 86);
INSERT INTO public.who_global_data VALUES (80574, 0, 0, 0, 0, 340, 13);
INSERT INTO public.who_global_data VALUES (80575, 0, 0, 0, 0, 340, 157);
INSERT INTO public.who_global_data VALUES (80576, 0, 20, 0, 0, 340, 8);
INSERT INTO public.who_global_data VALUES (80577, 0, 0, 0, 0, 340, 73);
INSERT INTO public.who_global_data VALUES (80578, 0, 0, 0, 0, 340, 101);
INSERT INTO public.who_global_data VALUES (80579, 0, 0, 0, 0, 340, 165);
INSERT INTO public.who_global_data VALUES (80580, 0, 0, 0, 0, 340, 14);
INSERT INTO public.who_global_data VALUES (80581, 0, 5, 0, 0, 341, 193);
INSERT INTO public.who_global_data VALUES (80582, 0, 0, 0, 0, 341, 113);
INSERT INTO public.who_global_data VALUES (80583, 2, 7, 0, 0, 341, 143);
INSERT INTO public.who_global_data VALUES (80584, 0, 0, 0, 0, 341, 219);
INSERT INTO public.who_global_data VALUES (80585, 0, 0, 0, 0, 341, 186);
INSERT INTO public.who_global_data VALUES (80586, 0, 0, 0, 0, 341, 52);
INSERT INTO public.who_global_data VALUES (80587, 0, 0, 0, 0, 341, 180);
INSERT INTO public.who_global_data VALUES (80588, 0, 0, 0, 0, 341, 167);
INSERT INTO public.who_global_data VALUES (80589, 0, 0, 0, 0, 341, 154);
INSERT INTO public.who_global_data VALUES (80590, 0, 1, 0, 0, 341, 94);
INSERT INTO public.who_global_data VALUES (80591, 0, 0, 0, 0, 341, 66);
INSERT INTO public.who_global_data VALUES (80592, 6, 37, 0, 1, 341, 58);
INSERT INTO public.who_global_data VALUES (80593, 4, 14, 0, 0, 341, 163);
INSERT INTO public.who_global_data VALUES (80594, 0, 3, 0, 0, 341, 37);
INSERT INTO public.who_global_data VALUES (80595, 0, 0, 0, 0, 341, 142);
INSERT INTO public.who_global_data VALUES (80596, 9, 53, 0, 0, 341, 83);
INSERT INTO public.who_global_data VALUES (80597, 0, 0, 0, 0, 341, 228);
INSERT INTO public.who_global_data VALUES (80598, 0, 0, 0, 0, 341, 188);
INSERT INTO public.who_global_data VALUES (80599, 0, 1, 0, 0, 341, 62);
INSERT INTO public.who_global_data VALUES (80600, 18, 19, 0, 0, 341, 160);
INSERT INTO public.who_global_data VALUES (80601, 0, 0, 0, 0, 341, 50);
INSERT INTO public.who_global_data VALUES (80602, 0, 0, 0, 0, 341, 33);
INSERT INTO public.who_global_data VALUES (80603, 0, 0, 0, 0, 341, 183);
INSERT INTO public.who_global_data VALUES (80604, 0, 0, 0, 0, 341, 92);
INSERT INTO public.who_global_data VALUES (80605, 0, 0, 0, 0, 341, 158);
INSERT INTO public.who_global_data VALUES (80606, 0, 0, 0, 0, 341, 67);
INSERT INTO public.who_global_data VALUES (80607, 0, 0, 0, 0, 341, 57);
INSERT INTO public.who_global_data VALUES (80608, 0, 0, 0, 0, 341, 38);
INSERT INTO public.who_global_data VALUES (80609, 0, 6, 0, 0, 341, 141);
INSERT INTO public.who_global_data VALUES (80610, 0, 0, 0, 0, 341, 178);
INSERT INTO public.who_global_data VALUES (80611, 0, 0, 0, 0, 341, 108);
INSERT INTO public.who_global_data VALUES (80612, 0, 0, 0, 0, 341, 39);
INSERT INTO public.who_global_data VALUES (80613, 0, 0, 0, 0, 341, 2);
INSERT INTO public.who_global_data VALUES (80614, 0, 0, 0, 0, 341, 195);
INSERT INTO public.who_global_data VALUES (80615, 0, 0, 0, 0, 341, 107);
INSERT INTO public.who_global_data VALUES (80616, 0, 5, 0, 0, 341, 161);
INSERT INTO public.who_global_data VALUES (80617, 0, 0, 0, 0, 341, 212);
INSERT INTO public.who_global_data VALUES (80618, 8, 31, 0, 0, 341, 181);
INSERT INTO public.who_global_data VALUES (80619, 0, 0, 0, 0, 341, 53);
INSERT INTO public.who_global_data VALUES (80620, 0, 0, 0, 0, 341, 164);
INSERT INTO public.who_global_data VALUES (80621, 0, 0, 0, 0, 341, 140);
INSERT INTO public.who_global_data VALUES (80622, 0, 0, 0, 0, 341, 20);
INSERT INTO public.who_global_data VALUES (80623, 206, 80178, 42, 2915, 341, 112);
INSERT INTO public.who_global_data VALUES (80624, 0, 0, 0, 0, 341, 111);
INSERT INTO public.who_global_data VALUES (80625, 0, 0, 0, 0, 341, 71);
INSERT INTO public.who_global_data VALUES (80626, 0, 0, 0, 0, 341, 218);
INSERT INTO public.who_global_data VALUES (80627, 0, 0, 0, 0, 341, 43);
INSERT INTO public.who_global_data VALUES (80628, 0, 0, 0, 0, 341, 49);
INSERT INTO public.who_global_data VALUES (80629, 0, 0, 0, 0, 341, 1);
INSERT INTO public.who_global_data VALUES (80630, 2, 7, 0, 0, 341, 48);
INSERT INTO public.who_global_data VALUES (80631, 0, 0, 0, 0, 341, 232);
INSERT INTO public.who_global_data VALUES (80632, 0, 0, 0, 0, 341, 175);
INSERT INTO public.who_global_data VALUES (80633, 0, 0, 0, 0, 341, 21);
INSERT INTO public.who_global_data VALUES (80634, 3, 3, 0, 0, 341, 156);
INSERT INTO public.who_global_data VALUES (80635, 0, 0, 0, 0, 341, 95);
INSERT INTO public.who_global_data VALUES (80636, 0, 0, 0, 0, 341, 177);
INSERT INTO public.who_global_data VALUES (80637, 1, 4, 0, 0, 341, 210);
INSERT INTO public.who_global_data VALUES (80638, 0, 0, 0, 0, 341, 120);
INSERT INTO public.who_global_data VALUES (80639, 0, 0, 0, 0, 341, 135);
INSERT INTO public.who_global_data VALUES (80640, 5, 5, 0, 0, 341, 206);
INSERT INTO public.who_global_data VALUES (80641, 5, 10, 0, 0, 341, 189);
INSERT INTO public.who_global_data VALUES (80642, 1, 6, 0, 0, 341, 129);
INSERT INTO public.who_global_data VALUES (80643, 0, 0, 0, 0, 341, 121);
INSERT INTO public.who_global_data VALUES (80644, 0, 0, 0, 0, 341, 59);
INSERT INTO public.who_global_data VALUES (80645, 0, 0, 0, 0, 341, 96);
INSERT INTO public.who_global_data VALUES (80646, 0, 1, 0, 0, 341, 41);
INSERT INTO public.who_global_data VALUES (80647, 0, 0, 0, 0, 341, 216);
INSERT INTO public.who_global_data VALUES (80648, 0, 0, 0, 0, 341, 236);
INSERT INTO public.who_global_data VALUES (80649, 0, 0, 0, 0, 341, 150);
INSERT INTO public.who_global_data VALUES (80650, 0, 0, 0, 0, 341, 61);
INSERT INTO public.who_global_data VALUES (80651, 0, 0, 0, 0, 341, 7);
INSERT INTO public.who_global_data VALUES (80652, 3, 6, 0, 0, 341, 169);
INSERT INTO public.who_global_data VALUES (80653, 23, 123, 0, 2, 341, 28);
INSERT INTO public.who_global_data VALUES (80654, 0, 0, 0, 0, 341, 85);
INSERT INTO public.who_global_data VALUES (80655, 0, 0, 0, 0, 341, 211);
INSERT INTO public.who_global_data VALUES (80656, 0, 0, 0, 0, 341, 60);
INSERT INTO public.who_global_data VALUES (80657, 0, 0, 0, 0, 341, 3);
INSERT INTO public.who_global_data VALUES (80658, 0, 3, 0, 0, 341, 11);
INSERT INTO public.who_global_data VALUES (80659, 18, 129, 0, 0, 341, 89);
INSERT INTO public.who_global_data VALUES (80660, 0, 0, 0, 0, 341, 24);
INSERT INTO public.who_global_data VALUES (80661, 0, 0, 0, 0, 341, 162);
INSERT INTO public.who_global_data VALUES (80662, 0, 7, 0, 0, 341, 100);
INSERT INTO public.who_global_data VALUES (80663, 0, 0, 0, 0, 341, 47);
INSERT INTO public.who_global_data VALUES (80664, 0, 0, 0, 0, 341, 29);
INSERT INTO public.who_global_data VALUES (80665, 0, 0, 0, 0, 341, 40);
INSERT INTO public.who_global_data VALUES (80666, 0, 0, 0, 0, 341, 222);
INSERT INTO public.who_global_data VALUES (80667, 0, 0, 0, 0, 341, 132);
INSERT INTO public.who_global_data VALUES (80668, 0, 0, 0, 0, 341, 130);
INSERT INTO public.who_global_data VALUES (80669, 0, 0, 0, 0, 341, 234);
INSERT INTO public.who_global_data VALUES (80670, 0, 0, 0, 0, 341, 23);
INSERT INTO public.who_global_data VALUES (80671, 0, 0, 0, 0, 341, 192);
INSERT INTO public.who_global_data VALUES (80672, 0, 0, 0, 0, 341, 69);
INSERT INTO public.who_global_data VALUES (80673, 0, 0, 0, 0, 341, 187);
INSERT INTO public.who_global_data VALUES (80674, 0, 0, 0, 0, 341, 230);
INSERT INTO public.who_global_data VALUES (80675, 0, 0, 0, 0, 341, 77);
INSERT INTO public.who_global_data VALUES (80676, 2, 3, 0, 0, 341, 9);
INSERT INTO public.who_global_data VALUES (80677, 2, 9, 0, 0, 341, 74);
INSERT INTO public.who_global_data VALUES (80678, 6, 6, 0, 0, 341, 224);
INSERT INTO public.who_global_data VALUES (80679, 908, 1505, 23, 66, 341, 199);
INSERT INTO public.who_global_data VALUES (80680, 7, 30, 0, 0, 341, 190);
INSERT INTO public.who_global_data VALUES (80681, 0, 1, 0, 0, 341, 12);
INSERT INTO public.who_global_data VALUES (80682, 0, 0, 0, 0, 341, 104);
INSERT INTO public.who_global_data VALUES (80683, 0, 6, 0, 0, 341, 153);
INSERT INTO public.who_global_data VALUES (80684, 561, 1689, 6, 35, 341, 91);
INSERT INTO public.who_global_data VALUES (80685, 0, 0, 0, 0, 341, 215);
INSERT INTO public.who_global_data VALUES (80686, 29, 272, 0, 6, 341, 84);
INSERT INTO public.who_global_data VALUES (80687, 0, 0, 0, 0, 341, 231);
INSERT INTO public.who_global_data VALUES (80688, 5, 5, 0, 0, 341, 196);
INSERT INTO public.who_global_data VALUES (80689, 0, 0, 0, 0, 341, 105);
INSERT INTO public.who_global_data VALUES (80690, 0, 0, 0, 0, 341, 122);
INSERT INTO public.who_global_data VALUES (80691, 0, 0, 0, 0, 341, 159);
INSERT INTO public.who_global_data VALUES (80692, 0, 0, 0, 0, 341, 75);
INSERT INTO public.who_global_data VALUES (80693, 11, 60, 0, 0, 341, 27);
INSERT INTO public.who_global_data VALUES (80694, 0, 0, 0, 0, 341, 54);
INSERT INTO public.who_global_data VALUES (80695, 0, 0, 0, 0, 341, 226);
INSERT INTO public.who_global_data VALUES (80696, 1, 1, 0, 0, 341, 79);
INSERT INTO public.who_global_data VALUES (80697, 3, 17, 0, 0, 341, 56);
INSERT INTO public.who_global_data VALUES (80698, 0, 0, 0, 0, 341, 117);
INSERT INTO public.who_global_data VALUES (80699, 0, 0, 0, 0, 341, 152);
INSERT INTO public.who_global_data VALUES (80700, 0, 0, 0, 0, 341, 16);
INSERT INTO public.who_global_data VALUES (80701, 1, 1, 0, 0, 341, 10);
INSERT INTO public.who_global_data VALUES (80702, 0, 1, 0, 0, 341, 201);
INSERT INTO public.who_global_data VALUES (80703, 0, 1, 0, 0, 341, 174);
INSERT INTO public.who_global_data VALUES (80704, 0, 0, 0, 0, 341, 119);
INSERT INTO public.who_global_data VALUES (80705, 0, 0, 0, 0, 341, 168);
INSERT INTO public.who_global_data VALUES (80706, 5, 33, 0, 0, 341, 99);
INSERT INTO public.who_global_data VALUES (80707, 0, 0, 0, 0, 341, 171);
INSERT INTO public.who_global_data VALUES (80708, 0, 0, 0, 0, 341, 87);
INSERT INTO public.who_global_data VALUES (80709, 0, 0, 0, 0, 341, 123);
INSERT INTO public.who_global_data VALUES (80710, 0, 0, 0, 0, 341, 151);
INSERT INTO public.who_global_data VALUES (80711, 0, 0, 0, 0, 341, 213);
INSERT INTO public.who_global_data VALUES (80712, 0, 0, 0, 0, 341, 118);
INSERT INTO public.who_global_data VALUES (80713, 0, 0, 0, 0, 341, 134);
INSERT INTO public.who_global_data VALUES (80714, 0, 0, 0, 0, 341, 65);
INSERT INTO public.who_global_data VALUES (80715, 3, 9, 0, 0, 341, 102);
INSERT INTO public.who_global_data VALUES (80716, 0, 0, 0, 0, 341, 223);
INSERT INTO public.who_global_data VALUES (80717, 0, 1, 0, 0, 341, 4);
INSERT INTO public.who_global_data VALUES (80718, 0, 0, 0, 0, 341, 146);
INSERT INTO public.who_global_data VALUES (80719, 0, 0, 0, 0, 341, 31);
INSERT INTO public.who_global_data VALUES (80720, 0, 0, 0, 0, 341, 127);
INSERT INTO public.who_global_data VALUES (80721, 5, 5, 0, 0, 341, 22);
INSERT INTO public.who_global_data VALUES (80722, 0, 0, 0, 0, 341, 115);
INSERT INTO public.who_global_data VALUES (80723, 0, 0, 0, 0, 341, 106);
INSERT INTO public.who_global_data VALUES (80724, 0, 0, 0, 0, 341, 90);
INSERT INTO public.who_global_data VALUES (80725, 0, 0, 0, 0, 341, 70);
INSERT INTO public.who_global_data VALUES (80726, 0, 5, 0, 0, 341, 46);
INSERT INTO public.who_global_data VALUES (80727, 3, 5, 0, 0, 341, 139);
INSERT INTO public.who_global_data VALUES (80728, 0, 0, 0, 0, 341, 42);
INSERT INTO public.who_global_data VALUES (80729, 0, 5, 0, 0, 341, 80);
INSERT INTO public.who_global_data VALUES (80730, 0, 0, 0, 0, 341, 203);
INSERT INTO public.who_global_data VALUES (80731, 0, 0, 0, 0, 341, 136);
INSERT INTO public.who_global_data VALUES (80732, 0, 5, 0, 0, 341, 63);
INSERT INTO public.who_global_data VALUES (80733, 0, 0, 0, 0, 341, 17);
INSERT INTO public.who_global_data VALUES (80734, 0, 0, 0, 0, 341, 172);
INSERT INTO public.who_global_data VALUES (80735, 0, 1, 0, 0, 341, 109);
INSERT INTO public.who_global_data VALUES (80736, 4, 19, 0, 0, 341, 200);
INSERT INTO public.who_global_data VALUES (80737, 0, 0, 0, 0, 341, 93);
INSERT INTO public.who_global_data VALUES (80738, 0, 10, 0, 0, 341, 5);
INSERT INTO public.who_global_data VALUES (80739, 0, 700, 0, 6, 341, 214);
INSERT INTO public.who_global_data VALUES (80740, 1, 9, 0, 0, 341, 204);
INSERT INTO public.who_global_data VALUES (80741, 0, 0, 0, 0, 341, 198);
INSERT INTO public.who_global_data VALUES (80742, 0, 0, 0, 0, 341, 173);
INSERT INTO public.who_global_data VALUES (80743, 0, 0, 0, 0, 341, 229);
INSERT INTO public.who_global_data VALUES (80744, 0, 0, 0, 0, 341, 76);
INSERT INTO public.who_global_data VALUES (80745, 0, 0, 0, 0, 341, 138);
INSERT INTO public.who_global_data VALUES (80746, 0, 7, 0, 1, 341, 98);
INSERT INTO public.who_global_data VALUES (80747, 0, 0, 0, 0, 341, 103);
INSERT INTO public.who_global_data VALUES (80748, 0, 0, 0, 0, 341, 225);
INSERT INTO public.who_global_data VALUES (80749, 2, 2, 0, 0, 341, 131);
INSERT INTO public.who_global_data VALUES (80750, 0, 0, 0, 0, 341, 235);
INSERT INTO public.who_global_data VALUES (80751, 4, 11, 0, 0, 341, 137);
INSERT INTO public.who_global_data VALUES (80752, 476, 4216, 4, 22, 341, 81);
INSERT INTO public.who_global_data VALUES (80753, 0, 0, 0, 0, 341, 182);
INSERT INTO public.who_global_data VALUES (80754, 0, 0, 0, 0, 341, 145);
INSERT INTO public.who_global_data VALUES (80755, 0, 3, 0, 0, 341, 26);
INSERT INTO public.who_global_data VALUES (80756, 0, 2, 0, 0, 341, 170);
INSERT INTO public.who_global_data VALUES (80757, 0, 0, 0, 0, 341, 191);
INSERT INTO public.who_global_data VALUES (80758, 0, 0, 0, 0, 341, 221);
INSERT INTO public.who_global_data VALUES (80759, 1, 1, 0, 0, 341, 64);
INSERT INTO public.who_global_data VALUES (80760, 0, 0, 0, 0, 341, 116);
INSERT INTO public.who_global_data VALUES (80761, 0, 0, 0, 0, 341, 128);
INSERT INTO public.who_global_data VALUES (80762, 0, 0, 0, 0, 341, 6);
INSERT INTO public.who_global_data VALUES (80763, 6, 6, 0, 0, 341, 227);
INSERT INTO public.who_global_data VALUES (80764, 0, 0, 0, 0, 341, 68);
INSERT INTO public.who_global_data VALUES (80765, 0, 0, 0, 0, 341, 184);
INSERT INTO public.who_global_data VALUES (80766, 0, 0, 0, 0, 341, 82);
INSERT INTO public.who_global_data VALUES (80767, 0, 1, 0, 1, 341, 149);
INSERT INTO public.who_global_data VALUES (80768, 0, 0, 0, 0, 341, 197);
INSERT INTO public.who_global_data VALUES (80769, 5, 5, 0, 0, 341, 78);
INSERT INTO public.who_global_data VALUES (80770, 5, 5, 0, 0, 341, 233);
INSERT INTO public.who_global_data VALUES (80771, 0, 0, 0, 0, 341, 133);
INSERT INTO public.who_global_data VALUES (80772, 0, 0, 0, 0, 341, 35);
INSERT INTO public.who_global_data VALUES (80773, 0, 0, 0, 0, 341, 114);
INSERT INTO public.who_global_data VALUES (80774, 2, 112, 0, 0, 341, 237);
INSERT INTO public.who_global_data VALUES (80775, 0, 0, 0, 0, 341, 55);
INSERT INTO public.who_global_data VALUES (80776, 0, 0, 0, 0, 341, 176);
INSERT INTO public.who_global_data VALUES (80777, 0, 0, 0, 0, 341, 202);
INSERT INTO public.who_global_data VALUES (80778, 0, 0, 0, 0, 341, 155);
INSERT INTO public.who_global_data VALUES (80779, 0, 0, 0, 0, 341, 32);
INSERT INTO public.who_global_data VALUES (80780, 0, 0, 0, 0, 341, 220);
INSERT INTO public.who_global_data VALUES (80781, 0, 0, 0, 0, 341, 30);
INSERT INTO public.who_global_data VALUES (80782, 0, 0, 0, 0, 341, 147);
INSERT INTO public.who_global_data VALUES (80783, 19, 108, 0, 1, 341, 208);
INSERT INTO public.who_global_data VALUES (80784, 0, 5, 0, 0, 341, 45);
INSERT INTO public.who_global_data VALUES (80785, 0, 0, 0, 0, 341, 110);
INSERT INTO public.who_global_data VALUES (80786, 0, 0, 0, 0, 341, 88);
INSERT INTO public.who_global_data VALUES (80787, 3, 14, 0, 0, 341, 51);
INSERT INTO public.who_global_data VALUES (80788, 11, 56, 0, 0, 341, 209);
INSERT INTO public.who_global_data VALUES (80789, 0, 0, 0, 0, 341, 205);
INSERT INTO public.who_global_data VALUES (80790, 0, 0, 0, 0, 341, 18);
INSERT INTO public.who_global_data VALUES (80791, 1, 47, 0, 1, 341, 72);
INSERT INTO public.who_global_data VALUES (80792, 5, 47, 0, 0, 341, 44);
INSERT INTO public.who_global_data VALUES (80793, 0, 0, 0, 0, 341, 15);
INSERT INTO public.who_global_data VALUES (80794, 0, 0, 0, 0, 341, 25);
INSERT INTO public.who_global_data VALUES (80795, 0, 0, 0, 0, 341, 179);
INSERT INTO public.who_global_data VALUES (80796, 0, 0, 0, 0, 341, 34);
INSERT INTO public.who_global_data VALUES (80797, 0, 0, 0, 0, 341, 207);
INSERT INTO public.who_global_data VALUES (80798, 5, 5, 0, 0, 341, 166);
INSERT INTO public.who_global_data VALUES (80799, 0, 0, 0, 0, 341, 126);
INSERT INTO public.who_global_data VALUES (80800, 0, 0, 0, 0, 341, 97);
INSERT INTO public.who_global_data VALUES (80801, 0, 0, 0, 0, 341, 36);
INSERT INTO public.who_global_data VALUES (80802, 0, 0, 0, 0, 341, 125);
INSERT INTO public.who_global_data VALUES (80803, 0, 0, 0, 0, 341, 124);
INSERT INTO public.who_global_data VALUES (80804, 0, 0, 0, 0, 341, 185);
INSERT INTO public.who_global_data VALUES (80805, 0, 25, 0, 0, 341, 194);
INSERT INTO public.who_global_data VALUES (80806, 0, 0, 0, 0, 341, 144);
INSERT INTO public.who_global_data VALUES (80807, 2, 68, 0, 0, 341, 19);
INSERT INTO public.who_global_data VALUES (80808, 0, 0, 0, 0, 341, 217);
INSERT INTO public.who_global_data VALUES (80809, 0, 0, 0, 0, 341, 148);
INSERT INTO public.who_global_data VALUES (80810, 0, 0, 0, 0, 341, 86);
INSERT INTO public.who_global_data VALUES (80811, 0, 0, 0, 0, 341, 13);
INSERT INTO public.who_global_data VALUES (80812, 0, 0, 0, 0, 341, 157);
INSERT INTO public.who_global_data VALUES (80813, 0, 20, 0, 0, 341, 8);
INSERT INTO public.who_global_data VALUES (80814, 0, 0, 0, 0, 341, 73);
INSERT INTO public.who_global_data VALUES (80815, 0, 0, 0, 0, 341, 101);
INSERT INTO public.who_global_data VALUES (80816, 0, 0, 0, 0, 341, 165);
INSERT INTO public.who_global_data VALUES (80817, 0, 0, 0, 0, 341, 14);
INSERT INTO public.who_global_data VALUES (80818, 0, 5, 0, 0, 342, 193);
INSERT INTO public.who_global_data VALUES (80819, 0, 0, 0, 0, 342, 113);
INSERT INTO public.who_global_data VALUES (80820, 0, 5, 0, 0, 342, 143);
INSERT INTO public.who_global_data VALUES (80821, 0, 0, 0, 0, 342, 219);
INSERT INTO public.who_global_data VALUES (80822, 0, 0, 0, 0, 342, 186);
INSERT INTO public.who_global_data VALUES (80823, 0, 0, 0, 0, 342, 52);
INSERT INTO public.who_global_data VALUES (80824, 0, 0, 0, 0, 342, 180);
INSERT INTO public.who_global_data VALUES (80825, 0, 0, 0, 0, 342, 167);
INSERT INTO public.who_global_data VALUES (80826, 0, 0, 0, 0, 342, 154);
INSERT INTO public.who_global_data VALUES (80827, 1, 1, 0, 0, 342, 94);
INSERT INTO public.who_global_data VALUES (80828, 0, 0, 0, 0, 342, 66);
INSERT INTO public.who_global_data VALUES (80829, 2, 31, 1, 1, 342, 58);
INSERT INTO public.who_global_data VALUES (80830, 3, 10, 0, 0, 342, 163);
INSERT INTO public.who_global_data VALUES (80831, 2, 3, 0, 0, 342, 37);
INSERT INTO public.who_global_data VALUES (80832, 0, 0, 0, 0, 342, 142);
INSERT INTO public.who_global_data VALUES (80833, 0, 44, 0, 0, 342, 83);
INSERT INTO public.who_global_data VALUES (80834, 0, 0, 0, 0, 342, 228);
INSERT INTO public.who_global_data VALUES (80835, 0, 0, 0, 0, 342, 188);
INSERT INTO public.who_global_data VALUES (80836, 0, 1, 0, 0, 342, 62);
INSERT INTO public.who_global_data VALUES (80837, 0, 1, 0, 0, 342, 160);
INSERT INTO public.who_global_data VALUES (80838, 0, 0, 0, 0, 342, 50);
INSERT INTO public.who_global_data VALUES (80839, 0, 0, 0, 0, 342, 33);
INSERT INTO public.who_global_data VALUES (80840, 0, 0, 0, 0, 342, 183);
INSERT INTO public.who_global_data VALUES (80841, 0, 0, 0, 0, 342, 92);
INSERT INTO public.who_global_data VALUES (80842, 0, 0, 0, 0, 342, 158);
INSERT INTO public.who_global_data VALUES (80843, 0, 0, 0, 0, 342, 67);
INSERT INTO public.who_global_data VALUES (80844, 0, 0, 0, 0, 342, 57);
INSERT INTO public.who_global_data VALUES (80845, 0, 0, 0, 0, 342, 38);
INSERT INTO public.who_global_data VALUES (80846, 1, 6, 0, 0, 342, 141);
INSERT INTO public.who_global_data VALUES (80847, 0, 0, 0, 0, 342, 178);
INSERT INTO public.who_global_data VALUES (80848, 0, 0, 0, 0, 342, 108);
INSERT INTO public.who_global_data VALUES (80849, 0, 0, 0, 0, 342, 39);
INSERT INTO public.who_global_data VALUES (80850, 0, 0, 0, 0, 342, 2);
INSERT INTO public.who_global_data VALUES (80851, 0, 0, 0, 0, 342, 195);
INSERT INTO public.who_global_data VALUES (80852, 0, 0, 0, 0, 342, 107);
INSERT INTO public.who_global_data VALUES (80853, 0, 5, 0, 0, 342, 161);
INSERT INTO public.who_global_data VALUES (80854, 0, 0, 0, 0, 342, 212);
INSERT INTO public.who_global_data VALUES (80855, 5, 23, 0, 0, 342, 181);
INSERT INTO public.who_global_data VALUES (80856, 0, 0, 0, 0, 342, 53);
INSERT INTO public.who_global_data VALUES (80857, 0, 0, 0, 0, 342, 164);
INSERT INTO public.who_global_data VALUES (80858, 0, 0, 0, 0, 342, 140);
INSERT INTO public.who_global_data VALUES (80859, 0, 0, 0, 0, 342, 20);
INSERT INTO public.who_global_data VALUES (80860, 579, 79972, 35, 2873, 342, 112);
INSERT INTO public.who_global_data VALUES (80861, 0, 0, 0, 0, 342, 111);
INSERT INTO public.who_global_data VALUES (80862, 0, 0, 0, 0, 342, 71);
INSERT INTO public.who_global_data VALUES (80863, 0, 0, 0, 0, 342, 218);
INSERT INTO public.who_global_data VALUES (80864, 0, 0, 0, 0, 342, 43);
INSERT INTO public.who_global_data VALUES (80865, 0, 0, 0, 0, 342, 49);
INSERT INTO public.who_global_data VALUES (80866, 0, 0, 0, 0, 342, 1);
INSERT INTO public.who_global_data VALUES (80867, 0, 5, 0, 0, 342, 48);
INSERT INTO public.who_global_data VALUES (80868, 0, 0, 0, 0, 342, 232);
INSERT INTO public.who_global_data VALUES (80869, 0, 0, 0, 0, 342, 175);
INSERT INTO public.who_global_data VALUES (80870, 0, 0, 0, 0, 342, 21);
INSERT INTO public.who_global_data VALUES (80871, 0, 0, 0, 0, 342, 156);
INSERT INTO public.who_global_data VALUES (80872, 0, 0, 0, 0, 342, 95);
INSERT INTO public.who_global_data VALUES (80873, 0, 0, 0, 0, 342, 177);
INSERT INTO public.who_global_data VALUES (80874, 1, 3, 0, 0, 342, 210);
INSERT INTO public.who_global_data VALUES (80875, 0, 0, 0, 0, 342, 120);
INSERT INTO public.who_global_data VALUES (80876, 0, 0, 0, 0, 342, 135);
INSERT INTO public.who_global_data VALUES (80877, 0, 0, 0, 0, 342, 206);
INSERT INTO public.who_global_data VALUES (80878, 0, 5, 0, 0, 342, 189);
INSERT INTO public.who_global_data VALUES (80879, 0, 5, 0, 0, 342, 129);
INSERT INTO public.who_global_data VALUES (80880, 0, 0, 0, 0, 342, 121);
INSERT INTO public.who_global_data VALUES (80881, 0, 0, 0, 0, 342, 59);
INSERT INTO public.who_global_data VALUES (80882, 0, 0, 0, 0, 342, 96);
INSERT INTO public.who_global_data VALUES (80883, 0, 1, 0, 0, 342, 41);
INSERT INTO public.who_global_data VALUES (80884, 0, 0, 0, 0, 342, 216);
INSERT INTO public.who_global_data VALUES (80885, 0, 0, 0, 0, 342, 236);
INSERT INTO public.who_global_data VALUES (80886, 0, 0, 0, 0, 342, 150);
INSERT INTO public.who_global_data VALUES (80887, 0, 0, 0, 0, 342, 61);
INSERT INTO public.who_global_data VALUES (80888, 0, 0, 0, 0, 342, 7);
INSERT INTO public.who_global_data VALUES (80889, 0, 3, 0, 0, 342, 169);
INSERT INTO public.who_global_data VALUES (80890, 43, 100, 0, 2, 342, 28);
INSERT INTO public.who_global_data VALUES (80891, 0, 0, 0, 0, 342, 85);
INSERT INTO public.who_global_data VALUES (80892, 0, 0, 0, 0, 342, 211);
INSERT INTO public.who_global_data VALUES (80893, 0, 0, 0, 0, 342, 60);
INSERT INTO public.who_global_data VALUES (80894, 0, 0, 0, 0, 342, 3);
INSERT INTO public.who_global_data VALUES (80895, 0, 3, 0, 0, 342, 11);
INSERT INTO public.who_global_data VALUES (80896, 54, 111, 0, 0, 342, 89);
INSERT INTO public.who_global_data VALUES (80897, 0, 0, 0, 0, 342, 24);
INSERT INTO public.who_global_data VALUES (80898, 0, 0, 0, 0, 342, 162);
INSERT INTO public.who_global_data VALUES (80899, 3, 7, 0, 0, 342, 100);
INSERT INTO public.who_global_data VALUES (80900, 0, 0, 0, 0, 342, 47);
INSERT INTO public.who_global_data VALUES (80901, 0, 0, 0, 0, 342, 29);
INSERT INTO public.who_global_data VALUES (80902, 0, 0, 0, 0, 342, 40);
INSERT INTO public.who_global_data VALUES (80903, 0, 0, 0, 0, 342, 222);
INSERT INTO public.who_global_data VALUES (80904, 0, 0, 0, 0, 342, 132);
INSERT INTO public.who_global_data VALUES (80905, 0, 0, 0, 0, 342, 130);
INSERT INTO public.who_global_data VALUES (80906, 0, 0, 0, 0, 342, 234);
INSERT INTO public.who_global_data VALUES (80907, 0, 0, 0, 0, 342, 23);
INSERT INTO public.who_global_data VALUES (80908, 0, 0, 0, 0, 342, 192);
INSERT INTO public.who_global_data VALUES (80909, 0, 0, 0, 0, 342, 69);
INSERT INTO public.who_global_data VALUES (80910, 0, 0, 0, 0, 342, 187);
INSERT INTO public.who_global_data VALUES (80911, 0, 0, 0, 0, 342, 230);
INSERT INTO public.who_global_data VALUES (80912, 0, 0, 0, 0, 342, 77);
INSERT INTO public.who_global_data VALUES (80913, 0, 1, 0, 0, 342, 9);
INSERT INTO public.who_global_data VALUES (80914, 0, 7, 0, 0, 342, 74);
INSERT INTO public.who_global_data VALUES (80915, 0, 0, 0, 0, 342, 224);
INSERT INTO public.who_global_data VALUES (80916, 0, 597, 0, 43, 342, 199);
INSERT INTO public.who_global_data VALUES (80917, 6, 23, 0, 0, 342, 190);
INSERT INTO public.who_global_data VALUES (80918, 1, 1, 0, 0, 342, 12);
INSERT INTO public.who_global_data VALUES (80919, 0, 0, 0, 0, 342, 104);
INSERT INTO public.who_global_data VALUES (80920, 3, 6, 0, 0, 342, 153);
INSERT INTO public.who_global_data VALUES (80921, 240, 1128, 8, 29, 342, 91);
INSERT INTO public.who_global_data VALUES (80922, 0, 0, 0, 0, 342, 215);
INSERT INTO public.who_global_data VALUES (80923, 0, 243, 1, 6, 342, 84);
INSERT INTO public.who_global_data VALUES (80924, 0, 0, 0, 0, 342, 231);
INSERT INTO public.who_global_data VALUES (80925, 0, 0, 0, 0, 342, 196);
INSERT INTO public.who_global_data VALUES (80926, 0, 0, 0, 0, 342, 105);
INSERT INTO public.who_global_data VALUES (80927, 0, 0, 0, 0, 342, 122);
INSERT INTO public.who_global_data VALUES (80928, 0, 0, 0, 0, 342, 159);
INSERT INTO public.who_global_data VALUES (80929, 0, 0, 0, 0, 342, 75);
INSERT INTO public.who_global_data VALUES (80930, 0, 49, 0, 0, 342, 27);
INSERT INTO public.who_global_data VALUES (80931, 0, 0, 0, 0, 342, 54);
INSERT INTO public.who_global_data VALUES (80932, 0, 0, 0, 0, 342, 226);
INSERT INTO public.who_global_data VALUES (80933, 0, 0, 0, 0, 342, 79);
INSERT INTO public.who_global_data VALUES (80934, 3, 14, 0, 0, 342, 56);
INSERT INTO public.who_global_data VALUES (80935, 0, 0, 0, 0, 342, 117);
INSERT INTO public.who_global_data VALUES (80936, 0, 0, 0, 0, 342, 152);
INSERT INTO public.who_global_data VALUES (80937, 0, 0, 0, 0, 342, 16);
INSERT INTO public.who_global_data VALUES (80938, 0, 0, 0, 0, 342, 10);
INSERT INTO public.who_global_data VALUES (80939, 0, 1, 0, 0, 342, 201);
INSERT INTO public.who_global_data VALUES (80940, 1, 1, 0, 0, 342, 174);
INSERT INTO public.who_global_data VALUES (80941, 0, 0, 0, 0, 342, 119);
INSERT INTO public.who_global_data VALUES (80942, 0, 0, 0, 0, 342, 168);
INSERT INTO public.who_global_data VALUES (80943, 0, 28, 0, 0, 342, 99);
INSERT INTO public.who_global_data VALUES (80944, 0, 0, 0, 0, 342, 171);
INSERT INTO public.who_global_data VALUES (80945, 0, 0, 0, 0, 342, 87);
INSERT INTO public.who_global_data VALUES (80946, 0, 0, 0, 0, 342, 123);
INSERT INTO public.who_global_data VALUES (80947, 0, 0, 0, 0, 342, 151);
INSERT INTO public.who_global_data VALUES (80948, 0, 0, 0, 0, 342, 213);
INSERT INTO public.who_global_data VALUES (80949, 0, 0, 0, 0, 342, 118);
INSERT INTO public.who_global_data VALUES (80950, 0, 0, 0, 0, 342, 134);
INSERT INTO public.who_global_data VALUES (80951, 0, 0, 0, 0, 342, 65);
INSERT INTO public.who_global_data VALUES (80952, 0, 6, 0, 0, 342, 102);
INSERT INTO public.who_global_data VALUES (80953, 0, 0, 0, 0, 342, 223);
INSERT INTO public.who_global_data VALUES (80954, 1, 1, 0, 0, 342, 4);
INSERT INTO public.who_global_data VALUES (80955, 0, 0, 0, 0, 342, 146);
INSERT INTO public.who_global_data VALUES (80956, 0, 0, 0, 0, 342, 31);
INSERT INTO public.who_global_data VALUES (80957, 0, 0, 0, 0, 342, 127);
INSERT INTO public.who_global_data VALUES (80958, 0, 0, 0, 0, 342, 22);
INSERT INTO public.who_global_data VALUES (80959, 0, 0, 0, 0, 342, 115);
INSERT INTO public.who_global_data VALUES (80960, 0, 0, 0, 0, 342, 106);
INSERT INTO public.who_global_data VALUES (80961, 0, 0, 0, 0, 342, 90);
INSERT INTO public.who_global_data VALUES (80962, 0, 0, 0, 0, 342, 70);
INSERT INTO public.who_global_data VALUES (80963, 0, 5, 0, 0, 342, 46);
INSERT INTO public.who_global_data VALUES (80964, 1, 2, 0, 0, 342, 139);
INSERT INTO public.who_global_data VALUES (80965, 0, 0, 0, 0, 342, 42);
INSERT INTO public.who_global_data VALUES (80966, 0, 5, 0, 0, 342, 80);
INSERT INTO public.who_global_data VALUES (80967, 0, 0, 0, 0, 342, 203);
INSERT INTO public.who_global_data VALUES (80968, 0, 0, 0, 0, 342, 136);
INSERT INTO public.who_global_data VALUES (80969, 0, 5, 0, 0, 342, 63);
INSERT INTO public.who_global_data VALUES (80970, 0, 0, 0, 0, 342, 17);
INSERT INTO public.who_global_data VALUES (80971, 0, 0, 0, 0, 342, 172);
INSERT INTO public.who_global_data VALUES (80972, 0, 1, 0, 0, 342, 109);
INSERT INTO public.who_global_data VALUES (80973, 9, 15, 0, 0, 342, 200);
INSERT INTO public.who_global_data VALUES (80974, 0, 0, 0, 0, 342, 93);
INSERT INTO public.who_global_data VALUES (80975, 0, 10, 0, 0, 342, 5);
INSERT INTO public.who_global_data VALUES (80976, 1, 700, 0, 6, 342, 214);
INSERT INTO public.who_global_data VALUES (80977, 0, 8, 0, 0, 342, 204);
INSERT INTO public.who_global_data VALUES (80978, 0, 0, 0, 0, 342, 198);
INSERT INTO public.who_global_data VALUES (80979, 0, 0, 0, 0, 342, 173);
INSERT INTO public.who_global_data VALUES (80980, 0, 0, 0, 0, 342, 229);
INSERT INTO public.who_global_data VALUES (80981, 0, 0, 0, 0, 342, 76);
INSERT INTO public.who_global_data VALUES (80982, 0, 0, 0, 0, 342, 138);
INSERT INTO public.who_global_data VALUES (80983, 0, 7, 0, 1, 342, 98);
INSERT INTO public.who_global_data VALUES (80984, 0, 0, 0, 0, 342, 103);
INSERT INTO public.who_global_data VALUES (80985, 0, 0, 0, 0, 342, 225);
INSERT INTO public.who_global_data VALUES (80986, 0, 0, 0, 0, 342, 131);
INSERT INTO public.who_global_data VALUES (80987, 0, 0, 0, 0, 342, 235);
INSERT INTO public.who_global_data VALUES (80988, 2, 7, 0, 0, 342, 137);
INSERT INTO public.who_global_data VALUES (80989, 586, 3740, 1, 18, 342, 81);
INSERT INTO public.who_global_data VALUES (80990, 0, 0, 0, 0, 342, 182);
INSERT INTO public.who_global_data VALUES (80991, 0, 0, 0, 0, 342, 145);
INSERT INTO public.who_global_data VALUES (80992, 0, 3, 0, 0, 342, 26);
INSERT INTO public.who_global_data VALUES (80993, 0, 2, 0, 0, 342, 170);
INSERT INTO public.who_global_data VALUES (80994, 0, 0, 0, 0, 342, 191);
INSERT INTO public.who_global_data VALUES (80995, 0, 0, 0, 0, 342, 221);
INSERT INTO public.who_global_data VALUES (80996, 0, 0, 0, 0, 342, 64);
INSERT INTO public.who_global_data VALUES (80997, 0, 0, 0, 0, 342, 116);
INSERT INTO public.who_global_data VALUES (80998, 0, 0, 0, 0, 342, 128);
INSERT INTO public.who_global_data VALUES (80999, 0, 0, 0, 0, 342, 6);
INSERT INTO public.who_global_data VALUES (81000, 0, 0, 0, 0, 342, 227);
INSERT INTO public.who_global_data VALUES (81001, 0, 0, 0, 0, 342, 68);
INSERT INTO public.who_global_data VALUES (81002, 0, 0, 0, 0, 342, 184);
INSERT INTO public.who_global_data VALUES (81003, 0, 0, 0, 0, 342, 82);
INSERT INTO public.who_global_data VALUES (81004, 0, 1, 0, 1, 342, 149);
INSERT INTO public.who_global_data VALUES (81005, 0, 0, 0, 0, 342, 197);
INSERT INTO public.who_global_data VALUES (81006, 0, 0, 0, 0, 342, 78);
INSERT INTO public.who_global_data VALUES (81007, 0, 0, 0, 0, 342, 233);
INSERT INTO public.who_global_data VALUES (81008, 0, 0, 0, 0, 342, 133);
INSERT INTO public.who_global_data VALUES (81009, 0, 0, 0, 0, 342, 35);
INSERT INTO public.who_global_data VALUES (81010, 0, 0, 0, 0, 342, 114);
INSERT INTO public.who_global_data VALUES (81011, 4, 110, 0, 0, 342, 237);
INSERT INTO public.who_global_data VALUES (81012, 0, 0, 0, 0, 342, 55);
INSERT INTO public.who_global_data VALUES (81013, 0, 0, 0, 0, 342, 176);
INSERT INTO public.who_global_data VALUES (81014, 0, 0, 0, 0, 342, 202);
INSERT INTO public.who_global_data VALUES (81015, 0, 0, 0, 0, 342, 155);
INSERT INTO public.who_global_data VALUES (81016, 0, 0, 0, 0, 342, 32);
INSERT INTO public.who_global_data VALUES (81017, 0, 0, 0, 0, 342, 220);
INSERT INTO public.who_global_data VALUES (81018, 0, 0, 0, 0, 342, 30);
INSERT INTO public.who_global_data VALUES (81019, 0, 0, 0, 0, 342, 147);
INSERT INTO public.who_global_data VALUES (81020, 24, 89, 0, 1, 342, 208);
INSERT INTO public.who_global_data VALUES (81021, 0, 5, 0, 0, 342, 45);
INSERT INTO public.who_global_data VALUES (81022, 0, 0, 0, 0, 342, 110);
INSERT INTO public.who_global_data VALUES (81023, 0, 0, 0, 0, 342, 88);
INSERT INTO public.who_global_data VALUES (81024, 8, 11, 0, 0, 342, 51);
INSERT INTO public.who_global_data VALUES (81025, 13, 45, 0, 0, 342, 209);
INSERT INTO public.who_global_data VALUES (81026, 0, 0, 0, 0, 342, 205);
INSERT INTO public.who_global_data VALUES (81027, 0, 0, 0, 0, 342, 18);
INSERT INTO public.who_global_data VALUES (81028, 0, 46, 1, 1, 342, 72);
INSERT INTO public.who_global_data VALUES (81029, 12, 42, 0, 0, 342, 44);
INSERT INTO public.who_global_data VALUES (81030, 0, 0, 0, 0, 342, 15);
INSERT INTO public.who_global_data VALUES (81031, 0, 0, 0, 0, 342, 25);
INSERT INTO public.who_global_data VALUES (81032, 0, 0, 0, 0, 342, 179);
INSERT INTO public.who_global_data VALUES (81033, 0, 0, 0, 0, 342, 34);
INSERT INTO public.who_global_data VALUES (81034, 0, 0, 0, 0, 342, 207);
INSERT INTO public.who_global_data VALUES (81035, 0, 0, 0, 0, 342, 166);
INSERT INTO public.who_global_data VALUES (81036, 0, 0, 0, 0, 342, 126);
INSERT INTO public.who_global_data VALUES (81037, 0, 0, 0, 0, 342, 97);
INSERT INTO public.who_global_data VALUES (81038, 0, 0, 0, 0, 342, 36);
INSERT INTO public.who_global_data VALUES (81039, 0, 0, 0, 0, 342, 125);
INSERT INTO public.who_global_data VALUES (81040, 0, 0, 0, 0, 342, 124);
INSERT INTO public.who_global_data VALUES (81041, 0, 0, 0, 0, 342, 185);
INSERT INTO public.who_global_data VALUES (81042, 2, 25, 0, 0, 342, 194);
INSERT INTO public.who_global_data VALUES (81043, 0, 0, 0, 0, 342, 144);
INSERT INTO public.who_global_data VALUES (81044, 0, 66, 0, 0, 342, 19);
INSERT INTO public.who_global_data VALUES (81045, 0, 0, 0, 0, 342, 217);
INSERT INTO public.who_global_data VALUES (81046, 0, 0, 0, 0, 342, 148);
INSERT INTO public.who_global_data VALUES (81047, 0, 0, 0, 0, 342, 86);
INSERT INTO public.who_global_data VALUES (81048, 0, 0, 0, 0, 342, 13);
INSERT INTO public.who_global_data VALUES (81049, 0, 0, 0, 0, 342, 157);
INSERT INTO public.who_global_data VALUES (81050, 0, 20, 0, 0, 342, 8);
INSERT INTO public.who_global_data VALUES (81051, 0, 0, 0, 0, 342, 73);
INSERT INTO public.who_global_data VALUES (81052, 0, 0, 0, 0, 342, 101);
INSERT INTO public.who_global_data VALUES (81053, 0, 0, 0, 0, 342, 165);
INSERT INTO public.who_global_data VALUES (81054, 0, 0, 0, 0, 342, 14);
INSERT INTO public.who_global_data VALUES (81055, 0, 5, 0, 0, 343, 193);
INSERT INTO public.who_global_data VALUES (81056, 0, 0, 0, 0, 343, 113);
INSERT INTO public.who_global_data VALUES (81057, 0, 5, 0, 0, 343, 143);
INSERT INTO public.who_global_data VALUES (81058, 0, 0, 0, 0, 343, 219);
INSERT INTO public.who_global_data VALUES (81059, 0, 0, 0, 0, 343, 186);
INSERT INTO public.who_global_data VALUES (81060, 0, 0, 0, 0, 343, 52);
INSERT INTO public.who_global_data VALUES (81061, 0, 0, 0, 0, 343, 180);
INSERT INTO public.who_global_data VALUES (81062, 0, 0, 0, 0, 343, 167);
INSERT INTO public.who_global_data VALUES (81063, 0, 0, 0, 0, 343, 154);
INSERT INTO public.who_global_data VALUES (81064, 0, 0, 0, 0, 343, 94);
INSERT INTO public.who_global_data VALUES (81065, 0, 0, 0, 0, 343, 66);
INSERT INTO public.who_global_data VALUES (81066, 2, 29, 0, 0, 343, 58);
INSERT INTO public.who_global_data VALUES (81067, 2, 7, 0, 0, 343, 163);
INSERT INTO public.who_global_data VALUES (81068, 1, 1, 0, 0, 343, 37);
INSERT INTO public.who_global_data VALUES (81069, 0, 0, 0, 0, 343, 142);
INSERT INTO public.who_global_data VALUES (81070, 2, 44, 0, 0, 343, 83);
INSERT INTO public.who_global_data VALUES (81071, 0, 0, 0, 0, 343, 228);
INSERT INTO public.who_global_data VALUES (81072, 0, 0, 0, 0, 343, 188);
INSERT INTO public.who_global_data VALUES (81073, 1, 1, 0, 0, 343, 62);
INSERT INTO public.who_global_data VALUES (81074, 0, 1, 0, 0, 343, 160);
INSERT INTO public.who_global_data VALUES (81075, 0, 0, 0, 0, 343, 50);
INSERT INTO public.who_global_data VALUES (81076, 0, 0, 0, 0, 343, 33);
INSERT INTO public.who_global_data VALUES (81077, 0, 0, 0, 0, 343, 183);
INSERT INTO public.who_global_data VALUES (81078, 0, 0, 0, 0, 343, 92);
INSERT INTO public.who_global_data VALUES (81079, 0, 0, 0, 0, 343, 158);
INSERT INTO public.who_global_data VALUES (81080, 0, 0, 0, 0, 343, 67);
INSERT INTO public.who_global_data VALUES (81081, 0, 0, 0, 0, 343, 57);
INSERT INTO public.who_global_data VALUES (81082, 0, 0, 0, 0, 343, 38);
INSERT INTO public.who_global_data VALUES (81083, 0, 5, 0, 0, 343, 141);
INSERT INTO public.who_global_data VALUES (81084, 0, 0, 0, 0, 343, 178);
INSERT INTO public.who_global_data VALUES (81085, 0, 0, 0, 0, 343, 108);
INSERT INTO public.who_global_data VALUES (81086, 0, 0, 0, 0, 343, 39);
INSERT INTO public.who_global_data VALUES (81087, 0, 0, 0, 0, 343, 2);
INSERT INTO public.who_global_data VALUES (81088, 0, 0, 0, 0, 343, 195);
INSERT INTO public.who_global_data VALUES (81089, 0, 0, 0, 0, 343, 107);
INSERT INTO public.who_global_data VALUES (81090, 0, 5, 0, 0, 343, 161);
INSERT INTO public.who_global_data VALUES (81091, 0, 0, 0, 0, 343, 212);
INSERT INTO public.who_global_data VALUES (81092, 0, 18, 0, 0, 343, 181);
INSERT INTO public.who_global_data VALUES (81093, 0, 0, 0, 0, 343, 53);
INSERT INTO public.who_global_data VALUES (81094, 0, 0, 0, 0, 343, 164);
INSERT INTO public.who_global_data VALUES (81095, 0, 0, 0, 0, 343, 140);
INSERT INTO public.who_global_data VALUES (81096, 0, 0, 0, 0, 343, 20);
INSERT INTO public.who_global_data VALUES (81097, 430, 79393, 47, 2838, 343, 112);
INSERT INTO public.who_global_data VALUES (81098, 0, 0, 0, 0, 343, 111);
INSERT INTO public.who_global_data VALUES (81099, 0, 0, 0, 0, 343, 71);
INSERT INTO public.who_global_data VALUES (81100, 0, 0, 0, 0, 343, 218);
INSERT INTO public.who_global_data VALUES (81101, 0, 0, 0, 0, 343, 43);
INSERT INTO public.who_global_data VALUES (81102, 0, 0, 0, 0, 343, 49);
INSERT INTO public.who_global_data VALUES (81103, 0, 0, 0, 0, 343, 1);
INSERT INTO public.who_global_data VALUES (81104, 2, 5, 0, 0, 343, 48);
INSERT INTO public.who_global_data VALUES (81105, 0, 0, 0, 0, 343, 232);
INSERT INTO public.who_global_data VALUES (81106, 0, 0, 0, 0, 343, 175);
INSERT INTO public.who_global_data VALUES (81107, 0, 0, 0, 0, 343, 21);
INSERT INTO public.who_global_data VALUES (81108, 0, 0, 0, 0, 343, 156);
INSERT INTO public.who_global_data VALUES (81109, 0, 0, 0, 0, 343, 95);
INSERT INTO public.who_global_data VALUES (81110, 0, 0, 0, 0, 343, 177);
INSERT INTO public.who_global_data VALUES (81111, 1, 2, 0, 0, 343, 210);
INSERT INTO public.who_global_data VALUES (81112, 0, 0, 0, 0, 343, 120);
INSERT INTO public.who_global_data VALUES (81113, 0, 0, 0, 0, 343, 135);
INSERT INTO public.who_global_data VALUES (81114, 0, 0, 0, 0, 343, 206);
INSERT INTO public.who_global_data VALUES (81115, 5, 5, 0, 0, 343, 189);
INSERT INTO public.who_global_data VALUES (81116, 0, 5, 0, 0, 343, 129);
INSERT INTO public.who_global_data VALUES (81117, 0, 0, 0, 0, 343, 121);
INSERT INTO public.who_global_data VALUES (81118, 0, 0, 0, 0, 343, 59);
INSERT INTO public.who_global_data VALUES (81119, 0, 0, 0, 0, 343, 96);
INSERT INTO public.who_global_data VALUES (81120, 0, 1, 0, 0, 343, 41);
INSERT INTO public.who_global_data VALUES (81121, 0, 0, 0, 0, 343, 216);
INSERT INTO public.who_global_data VALUES (81122, 0, 0, 0, 0, 343, 236);
INSERT INTO public.who_global_data VALUES (81123, 0, 0, 0, 0, 343, 150);
INSERT INTO public.who_global_data VALUES (81124, 0, 0, 0, 0, 343, 61);
INSERT INTO public.who_global_data VALUES (81125, 0, 0, 0, 0, 343, 7);
INSERT INTO public.who_global_data VALUES (81126, 1, 3, 0, 0, 343, 169);
INSERT INTO public.who_global_data VALUES (81127, 19, 57, 0, 2, 343, 28);
INSERT INTO public.who_global_data VALUES (81128, 0, 0, 0, 0, 343, 85);
INSERT INTO public.who_global_data VALUES (81129, 0, 0, 0, 0, 343, 211);
INSERT INTO public.who_global_data VALUES (81130, 0, 0, 0, 0, 343, 60);
INSERT INTO public.who_global_data VALUES (81131, 0, 0, 0, 0, 343, 3);
INSERT INTO public.who_global_data VALUES (81132, 2, 3, 0, 0, 343, 11);
INSERT INTO public.who_global_data VALUES (81133, 10, 57, 0, 0, 343, 89);
INSERT INTO public.who_global_data VALUES (81134, 0, 0, 0, 0, 343, 24);
INSERT INTO public.who_global_data VALUES (81135, 0, 0, 0, 0, 343, 162);
INSERT INTO public.who_global_data VALUES (81136, 1, 4, 0, 0, 343, 100);
INSERT INTO public.who_global_data VALUES (81137, 0, 0, 0, 0, 343, 47);
INSERT INTO public.who_global_data VALUES (81138, 0, 0, 0, 0, 343, 29);
INSERT INTO public.who_global_data VALUES (81139, 0, 0, 0, 0, 343, 40);
INSERT INTO public.who_global_data VALUES (81140, 0, 0, 0, 0, 343, 222);
INSERT INTO public.who_global_data VALUES (81141, 0, 0, 0, 0, 343, 132);
INSERT INTO public.who_global_data VALUES (81142, 0, 0, 0, 0, 343, 130);
INSERT INTO public.who_global_data VALUES (81143, 0, 0, 0, 0, 343, 234);
INSERT INTO public.who_global_data VALUES (81144, 0, 0, 0, 0, 343, 23);
INSERT INTO public.who_global_data VALUES (81145, 0, 0, 0, 0, 343, 192);
INSERT INTO public.who_global_data VALUES (81146, 0, 0, 0, 0, 343, 69);
INSERT INTO public.who_global_data VALUES (81147, 0, 0, 0, 0, 343, 187);
INSERT INTO public.who_global_data VALUES (81148, 0, 0, 0, 0, 343, 230);
INSERT INTO public.who_global_data VALUES (81149, 0, 0, 0, 0, 343, 77);
INSERT INTO public.who_global_data VALUES (81150, 1, 1, 0, 0, 343, 9);
INSERT INTO public.who_global_data VALUES (81151, 0, 7, 0, 0, 343, 74);
INSERT INTO public.who_global_data VALUES (81152, 0, 0, 0, 0, 343, 224);
INSERT INTO public.who_global_data VALUES (81153, 205, 597, 9, 43, 343, 199);
INSERT INTO public.who_global_data VALUES (81154, 5, 17, 0, 0, 343, 190);
INSERT INTO public.who_global_data VALUES (81155, 0, 0, 0, 0, 343, 12);
INSERT INTO public.who_global_data VALUES (81156, 0, 0, 0, 0, 343, 104);
INSERT INTO public.who_global_data VALUES (81157, 1, 3, 0, 0, 343, 153);
INSERT INTO public.who_global_data VALUES (81158, 238, 888, 4, 21, 343, 91);
INSERT INTO public.who_global_data VALUES (81159, 0, 0, 0, 0, 343, 215);
INSERT INTO public.who_global_data VALUES (81160, 29, 243, 0, 5, 343, 84);
INSERT INTO public.who_global_data VALUES (81161, 0, 0, 0, 0, 343, 231);
INSERT INTO public.who_global_data VALUES (81162, 0, 0, 0, 0, 343, 196);
INSERT INTO public.who_global_data VALUES (81163, 0, 0, 0, 0, 343, 105);
INSERT INTO public.who_global_data VALUES (81164, 0, 0, 0, 0, 343, 122);
INSERT INTO public.who_global_data VALUES (81165, 0, 0, 0, 0, 343, 159);
INSERT INTO public.who_global_data VALUES (81166, 0, 0, 0, 0, 343, 75);
INSERT INTO public.who_global_data VALUES (81167, 0, 49, 0, 0, 343, 27);
INSERT INTO public.who_global_data VALUES (81168, 0, 0, 0, 0, 343, 54);
INSERT INTO public.who_global_data VALUES (81169, 0, 0, 0, 0, 343, 226);
INSERT INTO public.who_global_data VALUES (81170, 0, 0, 0, 0, 343, 79);
INSERT INTO public.who_global_data VALUES (81171, 3, 11, 0, 0, 343, 56);
INSERT INTO public.who_global_data VALUES (81172, 0, 0, 0, 0, 343, 117);
INSERT INTO public.who_global_data VALUES (81173, 0, 0, 0, 0, 343, 152);
INSERT INTO public.who_global_data VALUES (81174, 0, 0, 0, 0, 343, 16);
INSERT INTO public.who_global_data VALUES (81175, 0, 0, 0, 0, 343, 10);
INSERT INTO public.who_global_data VALUES (81176, 0, 1, 0, 0, 343, 201);
INSERT INTO public.who_global_data VALUES (81177, 0, 0, 0, 0, 343, 174);
INSERT INTO public.who_global_data VALUES (81178, 0, 0, 0, 0, 343, 119);
INSERT INTO public.who_global_data VALUES (81179, 0, 0, 0, 0, 343, 168);
INSERT INTO public.who_global_data VALUES (81180, 0, 28, 0, 0, 343, 99);
INSERT INTO public.who_global_data VALUES (81181, 0, 0, 0, 0, 343, 171);
INSERT INTO public.who_global_data VALUES (81182, 0, 0, 0, 0, 343, 87);
INSERT INTO public.who_global_data VALUES (81183, 0, 0, 0, 0, 343, 123);
INSERT INTO public.who_global_data VALUES (81184, 0, 0, 0, 0, 343, 151);
INSERT INTO public.who_global_data VALUES (81185, 0, 0, 0, 0, 343, 213);
INSERT INTO public.who_global_data VALUES (81186, 0, 0, 0, 0, 343, 118);
INSERT INTO public.who_global_data VALUES (81187, 0, 0, 0, 0, 343, 134);
INSERT INTO public.who_global_data VALUES (81188, 0, 0, 0, 0, 343, 65);
INSERT INTO public.who_global_data VALUES (81189, 0, 6, 0, 0, 343, 102);
INSERT INTO public.who_global_data VALUES (81190, 0, 0, 0, 0, 343, 223);
INSERT INTO public.who_global_data VALUES (81191, 0, 0, 0, 0, 343, 4);
INSERT INTO public.who_global_data VALUES (81192, 0, 0, 0, 0, 343, 146);
INSERT INTO public.who_global_data VALUES (81193, 0, 0, 0, 0, 343, 31);
INSERT INTO public.who_global_data VALUES (81194, 0, 0, 0, 0, 343, 127);
INSERT INTO public.who_global_data VALUES (81195, 0, 0, 0, 0, 343, 22);
INSERT INTO public.who_global_data VALUES (81196, 0, 0, 0, 0, 343, 115);
INSERT INTO public.who_global_data VALUES (81197, 0, 0, 0, 0, 343, 106);
INSERT INTO public.who_global_data VALUES (81198, 0, 0, 0, 0, 343, 90);
INSERT INTO public.who_global_data VALUES (81199, 0, 0, 0, 0, 343, 70);
INSERT INTO public.who_global_data VALUES (81200, 0, 5, 0, 0, 343, 46);
INSERT INTO public.who_global_data VALUES (81201, 0, 1, 0, 0, 343, 139);
INSERT INTO public.who_global_data VALUES (81202, 0, 0, 0, 0, 343, 42);
INSERT INTO public.who_global_data VALUES (81203, 0, 5, 0, 0, 343, 80);
INSERT INTO public.who_global_data VALUES (81204, 0, 0, 0, 0, 343, 203);
INSERT INTO public.who_global_data VALUES (81205, 0, 0, 0, 0, 343, 136);
INSERT INTO public.who_global_data VALUES (81206, 0, 5, 0, 0, 343, 63);
INSERT INTO public.who_global_data VALUES (81207, 0, 0, 0, 0, 343, 17);
INSERT INTO public.who_global_data VALUES (81208, 0, 0, 0, 0, 343, 172);
INSERT INTO public.who_global_data VALUES (81209, 0, 1, 0, 0, 343, 109);
INSERT INTO public.who_global_data VALUES (81210, 2, 6, 0, 0, 343, 200);
INSERT INTO public.who_global_data VALUES (81211, 0, 0, 0, 0, 343, 93);
INSERT INTO public.who_global_data VALUES (81212, 0, 10, 0, 0, 343, 5);
INSERT INTO public.who_global_data VALUES (81213, 0, 699, 0, 6, 343, 214);
INSERT INTO public.who_global_data VALUES (81214, 2, 8, 0, 0, 343, 204);
INSERT INTO public.who_global_data VALUES (81215, 0, 0, 0, 0, 343, 198);
INSERT INTO public.who_global_data VALUES (81216, 0, 0, 0, 0, 343, 173);
INSERT INTO public.who_global_data VALUES (81217, 0, 0, 0, 0, 343, 229);
INSERT INTO public.who_global_data VALUES (81218, 0, 0, 0, 0, 343, 76);
INSERT INTO public.who_global_data VALUES (81219, 0, 0, 0, 0, 343, 138);
INSERT INTO public.who_global_data VALUES (81220, 0, 7, 0, 1, 343, 98);
INSERT INTO public.who_global_data VALUES (81221, 0, 0, 0, 0, 343, 103);
INSERT INTO public.who_global_data VALUES (81222, 0, 0, 0, 0, 343, 225);
INSERT INTO public.who_global_data VALUES (81223, 0, 0, 0, 0, 343, 131);
INSERT INTO public.who_global_data VALUES (81224, 0, 0, 0, 0, 343, 235);
INSERT INTO public.who_global_data VALUES (81225, 5, 5, 0, 0, 343, 137);
INSERT INTO public.who_global_data VALUES (81226, 813, 3154, 4, 17, 343, 81);
INSERT INTO public.who_global_data VALUES (81227, 0, 0, 0, 0, 343, 182);
INSERT INTO public.who_global_data VALUES (81228, 0, 0, 0, 0, 343, 145);
INSERT INTO public.who_global_data VALUES (81229, 2, 3, 0, 0, 343, 26);
INSERT INTO public.who_global_data VALUES (81230, 0, 2, 0, 0, 343, 170);
INSERT INTO public.who_global_data VALUES (81231, 0, 0, 0, 0, 343, 191);
INSERT INTO public.who_global_data VALUES (81232, 0, 0, 0, 0, 343, 221);
INSERT INTO public.who_global_data VALUES (81233, 0, 0, 0, 0, 343, 64);
INSERT INTO public.who_global_data VALUES (81234, 0, 0, 0, 0, 343, 116);
INSERT INTO public.who_global_data VALUES (81235, 0, 0, 0, 0, 343, 128);
INSERT INTO public.who_global_data VALUES (81236, 0, 0, 0, 0, 343, 6);
INSERT INTO public.who_global_data VALUES (81237, 0, 0, 0, 0, 343, 227);
INSERT INTO public.who_global_data VALUES (81238, 0, 0, 0, 0, 343, 68);
INSERT INTO public.who_global_data VALUES (81239, 0, 0, 0, 0, 343, 184);
INSERT INTO public.who_global_data VALUES (81240, 0, 0, 0, 0, 343, 82);
INSERT INTO public.who_global_data VALUES (81241, 0, 1, 1, 1, 343, 149);
INSERT INTO public.who_global_data VALUES (81242, 0, 0, 0, 0, 343, 197);
INSERT INTO public.who_global_data VALUES (81243, 0, 0, 0, 0, 343, 78);
INSERT INTO public.who_global_data VALUES (81244, 0, 0, 0, 0, 343, 233);
INSERT INTO public.who_global_data VALUES (81245, 0, 0, 0, 0, 343, 133);
INSERT INTO public.who_global_data VALUES (81246, 0, 0, 0, 0, 343, 35);
INSERT INTO public.who_global_data VALUES (81247, 0, 0, 0, 0, 343, 114);
INSERT INTO public.who_global_data VALUES (81248, 4, 106, 0, 0, 343, 237);
INSERT INTO public.who_global_data VALUES (81249, 0, 0, 0, 0, 343, 55);
INSERT INTO public.who_global_data VALUES (81250, 0, 0, 0, 0, 343, 176);
INSERT INTO public.who_global_data VALUES (81251, 0, 0, 0, 0, 343, 202);
INSERT INTO public.who_global_data VALUES (81252, 0, 0, 0, 0, 343, 155);
INSERT INTO public.who_global_data VALUES (81253, 0, 0, 0, 0, 343, 32);
INSERT INTO public.who_global_data VALUES (81254, 0, 0, 0, 0, 343, 220);
INSERT INTO public.who_global_data VALUES (81255, 0, 0, 0, 0, 343, 30);
INSERT INTO public.who_global_data VALUES (81256, 0, 0, 0, 0, 343, 147);
INSERT INTO public.who_global_data VALUES (81257, 23, 65, 0, 1, 343, 208);
INSERT INTO public.who_global_data VALUES (81258, 0, 5, 0, 0, 343, 45);
INSERT INTO public.who_global_data VALUES (81259, 0, 0, 0, 0, 343, 110);
INSERT INTO public.who_global_data VALUES (81260, 0, 0, 0, 0, 343, 88);
INSERT INTO public.who_global_data VALUES (81261, 1, 3, 0, 0, 343, 51);
INSERT INTO public.who_global_data VALUES (81262, 10, 32, 0, 0, 343, 209);
INSERT INTO public.who_global_data VALUES (81263, 0, 0, 0, 0, 343, 205);
INSERT INTO public.who_global_data VALUES (81264, 0, 0, 0, 0, 343, 18);
INSERT INTO public.who_global_data VALUES (81265, 1, 46, 0, 0, 343, 72);
INSERT INTO public.who_global_data VALUES (81266, 8, 30, 0, 0, 343, 44);
INSERT INTO public.who_global_data VALUES (81267, 0, 0, 0, 0, 343, 15);
INSERT INTO public.who_global_data VALUES (81268, 0, 0, 0, 0, 343, 25);
INSERT INTO public.who_global_data VALUES (81269, 0, 0, 0, 0, 343, 179);
INSERT INTO public.who_global_data VALUES (81270, 0, 0, 0, 0, 343, 34);
INSERT INTO public.who_global_data VALUES (81271, 0, 0, 0, 0, 343, 207);
INSERT INTO public.who_global_data VALUES (81272, 0, 0, 0, 0, 343, 166);
INSERT INTO public.who_global_data VALUES (81273, 0, 0, 0, 0, 343, 126);
INSERT INTO public.who_global_data VALUES (81274, 0, 0, 0, 0, 343, 97);
INSERT INTO public.who_global_data VALUES (81275, 0, 0, 0, 0, 343, 36);
INSERT INTO public.who_global_data VALUES (81276, 0, 0, 0, 0, 343, 125);
INSERT INTO public.who_global_data VALUES (81277, 0, 0, 0, 0, 343, 124);
INSERT INTO public.who_global_data VALUES (81278, 0, 0, 0, 0, 343, 185);
INSERT INTO public.who_global_data VALUES (81279, 0, 23, 0, 0, 343, 194);
INSERT INTO public.who_global_data VALUES (81280, 0, 0, 0, 0, 343, 144);
INSERT INTO public.who_global_data VALUES (81281, 0, 66, 0, 0, 343, 19);
INSERT INTO public.who_global_data VALUES (81282, 0, 0, 0, 0, 343, 217);
INSERT INTO public.who_global_data VALUES (81283, 0, 0, 0, 0, 343, 148);
INSERT INTO public.who_global_data VALUES (81284, 0, 0, 0, 0, 343, 86);
INSERT INTO public.who_global_data VALUES (81285, 0, 0, 0, 0, 343, 13);
INSERT INTO public.who_global_data VALUES (81286, 0, 0, 0, 0, 343, 157);
INSERT INTO public.who_global_data VALUES (81287, 0, 20, 0, 0, 343, 8);
INSERT INTO public.who_global_data VALUES (81288, 0, 0, 0, 0, 343, 73);
INSERT INTO public.who_global_data VALUES (81289, 0, 0, 0, 0, 343, 101);
INSERT INTO public.who_global_data VALUES (81290, 0, 0, 0, 0, 343, 165);
INSERT INTO public.who_global_data VALUES (81291, 0, 0, 0, 0, 343, 14);
INSERT INTO public.who_global_data VALUES (81292, 0, 5, 0, 0, 344, 193);
INSERT INTO public.who_global_data VALUES (81293, 0, 0, 0, 0, 344, 113);
INSERT INTO public.who_global_data VALUES (81294, 0, 5, 0, 0, 344, 143);
INSERT INTO public.who_global_data VALUES (81295, 0, 0, 0, 0, 344, 219);
INSERT INTO public.who_global_data VALUES (81296, 0, 0, 0, 0, 344, 186);
INSERT INTO public.who_global_data VALUES (81297, 0, 0, 0, 0, 344, 52);
INSERT INTO public.who_global_data VALUES (81298, 0, 0, 0, 0, 344, 180);
INSERT INTO public.who_global_data VALUES (81299, 0, 0, 0, 0, 344, 167);
INSERT INTO public.who_global_data VALUES (81300, 0, 0, 0, 0, 344, 154);
INSERT INTO public.who_global_data VALUES (81301, 0, 0, 0, 0, 344, 94);
INSERT INTO public.who_global_data VALUES (81302, 0, 0, 0, 0, 344, 66);
INSERT INTO public.who_global_data VALUES (81303, 0, 27, 0, 0, 344, 58);
INSERT INTO public.who_global_data VALUES (81304, 3, 5, 0, 0, 344, 163);
INSERT INTO public.who_global_data VALUES (81305, 0, 0, 0, 0, 344, 37);
INSERT INTO public.who_global_data VALUES (81306, 0, 0, 0, 0, 344, 142);
INSERT INTO public.who_global_data VALUES (81307, 5, 42, 0, 0, 344, 83);
INSERT INTO public.who_global_data VALUES (81308, 0, 0, 0, 0, 344, 228);
INSERT INTO public.who_global_data VALUES (81309, 0, 0, 0, 0, 344, 188);
INSERT INTO public.who_global_data VALUES (81310, 0, 0, 0, 0, 344, 62);
INSERT INTO public.who_global_data VALUES (81311, 0, 1, 0, 0, 344, 160);
INSERT INTO public.who_global_data VALUES (81312, 0, 0, 0, 0, 344, 50);
INSERT INTO public.who_global_data VALUES (81313, 0, 0, 0, 0, 344, 33);
INSERT INTO public.who_global_data VALUES (81314, 0, 0, 0, 0, 344, 183);
INSERT INTO public.who_global_data VALUES (81315, 0, 0, 0, 0, 344, 92);
INSERT INTO public.who_global_data VALUES (81316, 0, 0, 0, 0, 344, 158);
INSERT INTO public.who_global_data VALUES (81317, 0, 0, 0, 0, 344, 67);
INSERT INTO public.who_global_data VALUES (81318, 0, 0, 0, 0, 344, 57);
INSERT INTO public.who_global_data VALUES (81319, 0, 0, 0, 0, 344, 38);
INSERT INTO public.who_global_data VALUES (81320, 0, 5, 0, 0, 344, 141);
INSERT INTO public.who_global_data VALUES (81321, 0, 0, 0, 0, 344, 178);
INSERT INTO public.who_global_data VALUES (81322, 0, 0, 0, 0, 344, 108);
INSERT INTO public.who_global_data VALUES (81323, 0, 0, 0, 0, 344, 39);
INSERT INTO public.who_global_data VALUES (81324, 0, 0, 0, 0, 344, 2);
INSERT INTO public.who_global_data VALUES (81325, 0, 0, 0, 0, 344, 195);
INSERT INTO public.who_global_data VALUES (81326, 0, 0, 0, 0, 344, 107);
INSERT INTO public.who_global_data VALUES (81327, 0, 5, 0, 0, 344, 161);
INSERT INTO public.who_global_data VALUES (81328, 0, 0, 0, 0, 344, 212);
INSERT INTO public.who_global_data VALUES (81329, 3, 18, 0, 0, 344, 181);
INSERT INTO public.who_global_data VALUES (81330, 0, 0, 0, 0, 344, 53);
INSERT INTO public.who_global_data VALUES (81331, 0, 0, 0, 0, 344, 164);
INSERT INTO public.who_global_data VALUES (81332, 0, 0, 0, 0, 344, 140);
INSERT INTO public.who_global_data VALUES (81333, 0, 0, 0, 0, 344, 20);
INSERT INTO public.who_global_data VALUES (81334, 329, 78963, 44, 2791, 344, 112);
INSERT INTO public.who_global_data VALUES (81335, 0, 0, 0, 0, 344, 111);
INSERT INTO public.who_global_data VALUES (81336, 0, 0, 0, 0, 344, 71);
INSERT INTO public.who_global_data VALUES (81337, 0, 0, 0, 0, 344, 218);
INSERT INTO public.who_global_data VALUES (81338, 0, 0, 0, 0, 344, 43);
INSERT INTO public.who_global_data VALUES (81339, 0, 0, 0, 0, 344, 49);
INSERT INTO public.who_global_data VALUES (81340, 0, 0, 0, 0, 344, 1);
INSERT INTO public.who_global_data VALUES (81341, 1, 3, 0, 0, 344, 48);
INSERT INTO public.who_global_data VALUES (81342, 0, 0, 0, 0, 344, 232);
INSERT INTO public.who_global_data VALUES (81343, 0, 0, 0, 0, 344, 175);
INSERT INTO public.who_global_data VALUES (81344, 0, 0, 0, 0, 344, 21);
INSERT INTO public.who_global_data VALUES (81345, 0, 0, 0, 0, 344, 156);
INSERT INTO public.who_global_data VALUES (81346, 0, 0, 0, 0, 344, 95);
INSERT INTO public.who_global_data VALUES (81347, 0, 0, 0, 0, 344, 177);
INSERT INTO public.who_global_data VALUES (81348, 0, 1, 0, 0, 344, 210);
INSERT INTO public.who_global_data VALUES (81349, 0, 0, 0, 0, 344, 120);
INSERT INTO public.who_global_data VALUES (81350, 0, 0, 0, 0, 344, 135);
INSERT INTO public.who_global_data VALUES (81351, 0, 0, 0, 0, 344, 206);
INSERT INTO public.who_global_data VALUES (81352, 0, 0, 0, 0, 344, 189);
INSERT INTO public.who_global_data VALUES (81353, 0, 5, 0, 0, 344, 129);
INSERT INTO public.who_global_data VALUES (81354, 0, 0, 0, 0, 344, 121);
INSERT INTO public.who_global_data VALUES (81355, 0, 0, 0, 0, 344, 59);
INSERT INTO public.who_global_data VALUES (81356, 0, 0, 0, 0, 344, 96);
INSERT INTO public.who_global_data VALUES (81357, 0, 1, 0, 0, 344, 41);
INSERT INTO public.who_global_data VALUES (81358, 0, 0, 0, 0, 344, 216);
INSERT INTO public.who_global_data VALUES (81359, 0, 0, 0, 0, 344, 236);
INSERT INTO public.who_global_data VALUES (81360, 0, 0, 0, 0, 344, 150);
INSERT INTO public.who_global_data VALUES (81361, 0, 0, 0, 0, 344, 61);
INSERT INTO public.who_global_data VALUES (81362, 0, 0, 0, 0, 344, 7);
INSERT INTO public.who_global_data VALUES (81363, 0, 2, 0, 0, 344, 169);
INSERT INTO public.who_global_data VALUES (81364, 21, 38, 0, 2, 344, 28);
INSERT INTO public.who_global_data VALUES (81365, 0, 0, 0, 0, 344, 85);
INSERT INTO public.who_global_data VALUES (81366, 0, 0, 0, 0, 344, 211);
INSERT INTO public.who_global_data VALUES (81367, 0, 0, 0, 0, 344, 60);
INSERT INTO public.who_global_data VALUES (81368, 0, 0, 0, 0, 344, 3);
INSERT INTO public.who_global_data VALUES (81369, 0, 1, 0, 0, 344, 11);
INSERT INTO public.who_global_data VALUES (81370, 26, 47, 0, 0, 344, 89);
INSERT INTO public.who_global_data VALUES (81371, 0, 0, 0, 0, 344, 24);
INSERT INTO public.who_global_data VALUES (81372, 0, 0, 0, 0, 344, 162);
INSERT INTO public.who_global_data VALUES (81373, 2, 3, 0, 0, 344, 100);
INSERT INTO public.who_global_data VALUES (81374, 0, 0, 0, 0, 344, 47);
INSERT INTO public.who_global_data VALUES (81375, 0, 0, 0, 0, 344, 29);
INSERT INTO public.who_global_data VALUES (81376, 0, 0, 0, 0, 344, 40);
INSERT INTO public.who_global_data VALUES (81377, 0, 0, 0, 0, 344, 222);
INSERT INTO public.who_global_data VALUES (81378, 0, 0, 0, 0, 344, 132);
INSERT INTO public.who_global_data VALUES (81379, 0, 0, 0, 0, 344, 130);
INSERT INTO public.who_global_data VALUES (81380, 0, 0, 0, 0, 344, 234);
INSERT INTO public.who_global_data VALUES (81381, 0, 0, 0, 0, 344, 23);
INSERT INTO public.who_global_data VALUES (81382, 0, 0, 0, 0, 344, 192);
INSERT INTO public.who_global_data VALUES (81383, 0, 0, 0, 0, 344, 69);
INSERT INTO public.who_global_data VALUES (81384, 0, 0, 0, 0, 344, 187);
INSERT INTO public.who_global_data VALUES (81385, 0, 0, 0, 0, 344, 230);
INSERT INTO public.who_global_data VALUES (81386, 0, 0, 0, 0, 344, 77);
INSERT INTO public.who_global_data VALUES (81387, 0, 0, 0, 0, 344, 9);
INSERT INTO public.who_global_data VALUES (81388, 0, 7, 0, 0, 344, 74);
INSERT INTO public.who_global_data VALUES (81389, 0, 0, 0, 0, 344, 224);
INSERT INTO public.who_global_data VALUES (81390, 143, 392, 8, 34, 344, 199);
INSERT INTO public.who_global_data VALUES (81391, 2, 12, 0, 0, 344, 190);
INSERT INTO public.who_global_data VALUES (81392, 0, 0, 0, 0, 344, 12);
INSERT INTO public.who_global_data VALUES (81393, 0, 0, 0, 0, 344, 104);
INSERT INTO public.who_global_data VALUES (81394, 0, 2, 0, 0, 344, 153);
INSERT INTO public.who_global_data VALUES (81395, 250, 650, 5, 17, 344, 91);
INSERT INTO public.who_global_data VALUES (81396, 0, 0, 0, 0, 344, 215);
INSERT INTO public.who_global_data VALUES (81397, 23, 214, 1, 5, 344, 84);
INSERT INTO public.who_global_data VALUES (81398, 0, 0, 0, 0, 344, 231);
INSERT INTO public.who_global_data VALUES (81399, 0, 0, 0, 0, 344, 196);
INSERT INTO public.who_global_data VALUES (81400, 0, 0, 0, 0, 344, 105);
INSERT INTO public.who_global_data VALUES (81401, 0, 0, 0, 0, 344, 122);
INSERT INTO public.who_global_data VALUES (81402, 0, 0, 0, 0, 344, 159);
INSERT INTO public.who_global_data VALUES (81403, 0, 0, 0, 0, 344, 75);
INSERT INTO public.who_global_data VALUES (81404, 2, 49, 0, 0, 344, 27);
INSERT INTO public.who_global_data VALUES (81405, 0, 0, 0, 0, 344, 54);
INSERT INTO public.who_global_data VALUES (81406, 0, 0, 0, 0, 344, 226);
INSERT INTO public.who_global_data VALUES (81407, 0, 0, 0, 0, 344, 79);
INSERT INTO public.who_global_data VALUES (81408, 1, 8, 0, 0, 344, 56);
INSERT INTO public.who_global_data VALUES (81409, 0, 0, 0, 0, 344, 117);
INSERT INTO public.who_global_data VALUES (81410, 0, 0, 0, 0, 344, 152);
INSERT INTO public.who_global_data VALUES (81411, 0, 0, 0, 0, 344, 16);
INSERT INTO public.who_global_data VALUES (81412, 0, 0, 0, 0, 344, 10);
INSERT INTO public.who_global_data VALUES (81413, 1, 1, 0, 0, 344, 201);
INSERT INTO public.who_global_data VALUES (81414, 0, 0, 0, 0, 344, 174);
INSERT INTO public.who_global_data VALUES (81415, 0, 0, 0, 0, 344, 119);
INSERT INTO public.who_global_data VALUES (81416, 0, 0, 0, 0, 344, 168);
INSERT INTO public.who_global_data VALUES (81417, 0, 28, 0, 0, 344, 99);
INSERT INTO public.who_global_data VALUES (81418, 0, 0, 0, 0, 344, 171);
INSERT INTO public.who_global_data VALUES (81419, 0, 0, 0, 0, 344, 87);
INSERT INTO public.who_global_data VALUES (81420, 0, 0, 0, 0, 344, 123);
INSERT INTO public.who_global_data VALUES (81421, 0, 0, 0, 0, 344, 151);
INSERT INTO public.who_global_data VALUES (81422, 0, 0, 0, 0, 344, 213);
INSERT INTO public.who_global_data VALUES (81423, 0, 0, 0, 0, 344, 118);
INSERT INTO public.who_global_data VALUES (81424, 0, 0, 0, 0, 344, 134);
INSERT INTO public.who_global_data VALUES (81425, 0, 0, 0, 0, 344, 65);
INSERT INTO public.who_global_data VALUES (81426, 6, 6, 0, 0, 344, 102);
INSERT INTO public.who_global_data VALUES (81427, 0, 0, 0, 0, 344, 223);
INSERT INTO public.who_global_data VALUES (81428, 0, 0, 0, 0, 344, 4);
INSERT INTO public.who_global_data VALUES (81429, 0, 0, 0, 0, 344, 146);
INSERT INTO public.who_global_data VALUES (81430, 0, 0, 0, 0, 344, 31);
INSERT INTO public.who_global_data VALUES (81431, 0, 0, 0, 0, 344, 127);
INSERT INTO public.who_global_data VALUES (81432, 0, 0, 0, 0, 344, 22);
INSERT INTO public.who_global_data VALUES (81433, 0, 0, 0, 0, 344, 115);
INSERT INTO public.who_global_data VALUES (81434, 0, 0, 0, 0, 344, 106);
INSERT INTO public.who_global_data VALUES (81435, 0, 0, 0, 0, 344, 90);
INSERT INTO public.who_global_data VALUES (81436, 0, 0, 0, 0, 344, 70);
INSERT INTO public.who_global_data VALUES (81437, 0, 5, 0, 0, 344, 46);
INSERT INTO public.who_global_data VALUES (81438, 1, 1, 0, 0, 344, 139);
INSERT INTO public.who_global_data VALUES (81439, 0, 0, 0, 0, 344, 42);
INSERT INTO public.who_global_data VALUES (81440, 5, 5, 0, 0, 344, 80);
INSERT INTO public.who_global_data VALUES (81441, 0, 0, 0, 0, 344, 203);
INSERT INTO public.who_global_data VALUES (81442, 0, 0, 0, 0, 344, 136);
INSERT INTO public.who_global_data VALUES (81443, 5, 5, 0, 0, 344, 63);
INSERT INTO public.who_global_data VALUES (81444, 0, 0, 0, 0, 344, 17);
INSERT INTO public.who_global_data VALUES (81445, 0, 0, 0, 0, 344, 172);
INSERT INTO public.who_global_data VALUES (81446, 0, 1, 0, 0, 344, 109);
INSERT INTO public.who_global_data VALUES (81447, 3, 4, 0, 0, 344, 200);
INSERT INTO public.who_global_data VALUES (81448, 0, 0, 0, 0, 344, 93);
INSERT INTO public.who_global_data VALUES (81449, 0, 10, 0, 0, 344, 5);
INSERT INTO public.who_global_data VALUES (81450, 0, 699, 2, 6, 344, 214);
INSERT INTO public.who_global_data VALUES (81451, 0, 6, 0, 0, 344, 204);
INSERT INTO public.who_global_data VALUES (81452, 0, 0, 0, 0, 344, 198);
INSERT INTO public.who_global_data VALUES (81453, 0, 0, 0, 0, 344, 173);
INSERT INTO public.who_global_data VALUES (81454, 0, 0, 0, 0, 344, 229);
INSERT INTO public.who_global_data VALUES (81455, 0, 0, 0, 0, 344, 76);
INSERT INTO public.who_global_data VALUES (81456, 0, 0, 0, 0, 344, 138);
INSERT INTO public.who_global_data VALUES (81457, 0, 7, 0, 1, 344, 98);
INSERT INTO public.who_global_data VALUES (81458, 0, 0, 0, 0, 344, 103);
INSERT INTO public.who_global_data VALUES (81459, 0, 0, 0, 0, 344, 225);
INSERT INTO public.who_global_data VALUES (81460, 0, 0, 0, 0, 344, 131);
INSERT INTO public.who_global_data VALUES (81461, 0, 0, 0, 0, 344, 235);
INSERT INTO public.who_global_data VALUES (81462, 0, 0, 0, 0, 344, 137);
INSERT INTO public.who_global_data VALUES (81463, 571, 2341, 0, 13, 344, 81);
INSERT INTO public.who_global_data VALUES (81464, 0, 0, 0, 0, 344, 182);
INSERT INTO public.who_global_data VALUES (81465, 0, 0, 0, 0, 344, 145);
INSERT INTO public.who_global_data VALUES (81466, 0, 1, 0, 0, 344, 26);
INSERT INTO public.who_global_data VALUES (81467, 0, 2, 0, 0, 344, 170);
INSERT INTO public.who_global_data VALUES (81468, 0, 0, 0, 0, 344, 191);
INSERT INTO public.who_global_data VALUES (81469, 0, 0, 0, 0, 344, 221);
INSERT INTO public.who_global_data VALUES (81470, 0, 0, 0, 0, 344, 64);
INSERT INTO public.who_global_data VALUES (81471, 0, 0, 0, 0, 344, 116);
INSERT INTO public.who_global_data VALUES (81472, 0, 0, 0, 0, 344, 128);
INSERT INTO public.who_global_data VALUES (81473, 0, 0, 0, 0, 344, 6);
INSERT INTO public.who_global_data VALUES (81474, 0, 0, 0, 0, 344, 227);
INSERT INTO public.who_global_data VALUES (81475, 0, 0, 0, 0, 344, 68);
INSERT INTO public.who_global_data VALUES (81476, 0, 0, 0, 0, 344, 184);
INSERT INTO public.who_global_data VALUES (81477, 0, 0, 0, 0, 344, 82);
INSERT INTO public.who_global_data VALUES (81478, 1, 1, 0, 0, 344, 149);
INSERT INTO public.who_global_data VALUES (81479, 0, 0, 0, 0, 344, 197);
INSERT INTO public.who_global_data VALUES (81480, 0, 0, 0, 0, 344, 78);
INSERT INTO public.who_global_data VALUES (81481, 0, 0, 0, 0, 344, 233);
INSERT INTO public.who_global_data VALUES (81482, 0, 0, 0, 0, 344, 133);
INSERT INTO public.who_global_data VALUES (81483, 0, 0, 0, 0, 344, 35);
INSERT INTO public.who_global_data VALUES (81484, 0, 0, 0, 0, 344, 114);
INSERT INTO public.who_global_data VALUES (81485, 2, 102, 0, 0, 344, 237);
INSERT INTO public.who_global_data VALUES (81486, 0, 0, 0, 0, 344, 55);
INSERT INTO public.who_global_data VALUES (81487, 0, 0, 0, 0, 344, 176);
INSERT INTO public.who_global_data VALUES (81488, 0, 0, 0, 0, 344, 202);
INSERT INTO public.who_global_data VALUES (81489, 0, 0, 0, 0, 344, 155);
INSERT INTO public.who_global_data VALUES (81490, 0, 0, 0, 0, 344, 32);
INSERT INTO public.who_global_data VALUES (81491, 0, 0, 0, 0, 344, 220);
INSERT INTO public.who_global_data VALUES (81492, 0, 0, 0, 0, 344, 30);
INSERT INTO public.who_global_data VALUES (81493, 0, 0, 0, 0, 344, 147);
INSERT INTO public.who_global_data VALUES (81494, 7, 42, 0, 1, 344, 208);
INSERT INTO public.who_global_data VALUES (81495, 0, 5, 0, 0, 344, 45);
INSERT INTO public.who_global_data VALUES (81496, 0, 0, 0, 0, 344, 110);
INSERT INTO public.who_global_data VALUES (81497, 0, 0, 0, 0, 344, 88);
INSERT INTO public.who_global_data VALUES (81498, 1, 2, 0, 0, 344, 51);
INSERT INTO public.who_global_data VALUES (81499, 10, 22, 0, 0, 344, 209);
INSERT INTO public.who_global_data VALUES (81500, 0, 0, 0, 0, 344, 205);
INSERT INTO public.who_global_data VALUES (81501, 0, 0, 0, 0, 344, 18);
INSERT INTO public.who_global_data VALUES (81502, 1, 45, 0, 0, 344, 72);
INSERT INTO public.who_global_data VALUES (81503, 4, 22, 0, 0, 344, 44);
INSERT INTO public.who_global_data VALUES (81504, 0, 0, 0, 0, 344, 15);
INSERT INTO public.who_global_data VALUES (81505, 0, 0, 0, 0, 344, 25);
INSERT INTO public.who_global_data VALUES (81506, 0, 0, 0, 0, 344, 179);
INSERT INTO public.who_global_data VALUES (81507, 0, 0, 0, 0, 344, 34);
INSERT INTO public.who_global_data VALUES (81508, 0, 0, 0, 0, 344, 207);
INSERT INTO public.who_global_data VALUES (81509, 0, 0, 0, 0, 344, 166);
INSERT INTO public.who_global_data VALUES (81510, 0, 0, 0, 0, 344, 126);
INSERT INTO public.who_global_data VALUES (81511, 0, 0, 0, 0, 344, 97);
INSERT INTO public.who_global_data VALUES (81512, 0, 0, 0, 0, 344, 36);
INSERT INTO public.who_global_data VALUES (81513, 0, 0, 0, 0, 344, 125);
INSERT INTO public.who_global_data VALUES (81514, 0, 0, 0, 0, 344, 124);
INSERT INTO public.who_global_data VALUES (81515, 0, 0, 0, 0, 344, 185);
INSERT INTO public.who_global_data VALUES (81516, 0, 23, 0, 0, 344, 194);
INSERT INTO public.who_global_data VALUES (81517, 0, 0, 0, 0, 344, 144);
INSERT INTO public.who_global_data VALUES (81518, 3, 66, 0, 0, 344, 19);
INSERT INTO public.who_global_data VALUES (81519, 0, 0, 0, 0, 344, 217);
INSERT INTO public.who_global_data VALUES (81520, 0, 0, 0, 0, 344, 148);
INSERT INTO public.who_global_data VALUES (81521, 0, 0, 0, 0, 344, 86);
INSERT INTO public.who_global_data VALUES (81522, 0, 0, 0, 0, 344, 13);
INSERT INTO public.who_global_data VALUES (81523, 0, 0, 0, 0, 344, 157);
INSERT INTO public.who_global_data VALUES (81524, 0, 20, 0, 0, 344, 8);
INSERT INTO public.who_global_data VALUES (81525, 0, 0, 0, 0, 344, 73);
INSERT INTO public.who_global_data VALUES (81526, 0, 0, 0, 0, 344, 101);
INSERT INTO public.who_global_data VALUES (81527, 0, 0, 0, 0, 344, 165);
INSERT INTO public.who_global_data VALUES (81528, 0, 0, 0, 0, 344, 14);
INSERT INTO public.who_global_data VALUES (81529, 0, 5, 0, 0, 345, 193);
INSERT INTO public.who_global_data VALUES (81530, 0, 0, 0, 0, 345, 113);
INSERT INTO public.who_global_data VALUES (81531, 0, 5, 0, 0, 345, 143);
INSERT INTO public.who_global_data VALUES (81532, 0, 0, 0, 0, 345, 219);
INSERT INTO public.who_global_data VALUES (81533, 0, 0, 0, 0, 345, 186);
INSERT INTO public.who_global_data VALUES (81534, 0, 0, 0, 0, 345, 52);
INSERT INTO public.who_global_data VALUES (81535, 0, 0, 0, 0, 345, 180);
INSERT INTO public.who_global_data VALUES (81536, 0, 0, 0, 0, 345, 167);
INSERT INTO public.who_global_data VALUES (81537, 0, 0, 0, 0, 345, 154);
INSERT INTO public.who_global_data VALUES (81538, 0, 0, 0, 0, 345, 94);
INSERT INTO public.who_global_data VALUES (81539, 0, 0, 0, 0, 345, 66);
INSERT INTO public.who_global_data VALUES (81540, 0, 27, 0, 0, 345, 58);
INSERT INTO public.who_global_data VALUES (81541, 0, 2, 0, 0, 345, 163);
INSERT INTO public.who_global_data VALUES (81542, 0, 0, 0, 0, 345, 37);
INSERT INTO public.who_global_data VALUES (81543, 0, 0, 0, 0, 345, 142);
INSERT INTO public.who_global_data VALUES (81544, 0, 37, 0, 0, 345, 83);
INSERT INTO public.who_global_data VALUES (81545, 0, 0, 0, 0, 345, 228);
INSERT INTO public.who_global_data VALUES (81546, 0, 0, 0, 0, 345, 188);
INSERT INTO public.who_global_data VALUES (81547, 0, 0, 0, 0, 345, 62);
INSERT INTO public.who_global_data VALUES (81548, 0, 1, 0, 0, 345, 160);
INSERT INTO public.who_global_data VALUES (81549, 0, 0, 0, 0, 345, 50);
INSERT INTO public.who_global_data VALUES (81550, 0, 0, 0, 0, 345, 33);
INSERT INTO public.who_global_data VALUES (81551, 0, 0, 0, 0, 345, 183);
INSERT INTO public.who_global_data VALUES (81552, 0, 0, 0, 0, 345, 92);
INSERT INTO public.who_global_data VALUES (81553, 0, 0, 0, 0, 345, 158);
INSERT INTO public.who_global_data VALUES (81554, 0, 0, 0, 0, 345, 67);
INSERT INTO public.who_global_data VALUES (81555, 0, 0, 0, 0, 345, 57);
INSERT INTO public.who_global_data VALUES (81556, 0, 0, 0, 0, 345, 38);
INSERT INTO public.who_global_data VALUES (81557, 0, 5, 0, 0, 345, 141);
INSERT INTO public.who_global_data VALUES (81558, 0, 0, 0, 0, 345, 178);
INSERT INTO public.who_global_data VALUES (81559, 0, 0, 0, 0, 345, 108);
INSERT INTO public.who_global_data VALUES (81560, 0, 0, 0, 0, 345, 39);
INSERT INTO public.who_global_data VALUES (81561, 0, 0, 0, 0, 345, 2);
INSERT INTO public.who_global_data VALUES (81562, 0, 0, 0, 0, 345, 195);
INSERT INTO public.who_global_data VALUES (81563, 0, 0, 0, 0, 345, 107);
INSERT INTO public.who_global_data VALUES (81564, 0, 5, 0, 0, 345, 161);
INSERT INTO public.who_global_data VALUES (81565, 0, 0, 0, 0, 345, 212);
INSERT INTO public.who_global_data VALUES (81566, 0, 15, 0, 0, 345, 181);
INSERT INTO public.who_global_data VALUES (81567, 0, 0, 0, 0, 345, 53);
INSERT INTO public.who_global_data VALUES (81568, 0, 0, 0, 0, 345, 164);
INSERT INTO public.who_global_data VALUES (81569, 0, 0, 0, 0, 345, 140);
INSERT INTO public.who_global_data VALUES (81570, 0, 0, 0, 0, 345, 20);
INSERT INTO public.who_global_data VALUES (81571, 440, 78634, 29, 2747, 345, 112);
INSERT INTO public.who_global_data VALUES (81572, 0, 0, 0, 0, 345, 111);
INSERT INTO public.who_global_data VALUES (81573, 0, 0, 0, 0, 345, 71);
INSERT INTO public.who_global_data VALUES (81574, 0, 0, 0, 0, 345, 218);
INSERT INTO public.who_global_data VALUES (81575, 0, 0, 0, 0, 345, 43);
INSERT INTO public.who_global_data VALUES (81576, 0, 0, 0, 0, 345, 49);
INSERT INTO public.who_global_data VALUES (81577, 0, 0, 0, 0, 345, 1);
INSERT INTO public.who_global_data VALUES (81578, 1, 2, 0, 0, 345, 48);
INSERT INTO public.who_global_data VALUES (81579, 0, 0, 0, 0, 345, 232);
INSERT INTO public.who_global_data VALUES (81580, 0, 0, 0, 0, 345, 175);
INSERT INTO public.who_global_data VALUES (81581, 0, 0, 0, 0, 345, 21);
INSERT INTO public.who_global_data VALUES (81582, 0, 0, 0, 0, 345, 156);
INSERT INTO public.who_global_data VALUES (81583, 0, 0, 0, 0, 345, 95);
INSERT INTO public.who_global_data VALUES (81584, 0, 0, 0, 0, 345, 177);
INSERT INTO public.who_global_data VALUES (81585, 1, 1, 0, 0, 345, 210);
INSERT INTO public.who_global_data VALUES (81586, 0, 0, 0, 0, 345, 120);
INSERT INTO public.who_global_data VALUES (81587, 0, 0, 0, 0, 345, 135);
INSERT INTO public.who_global_data VALUES (81588, 0, 0, 0, 0, 345, 206);
INSERT INTO public.who_global_data VALUES (81589, 0, 0, 0, 0, 345, 189);
INSERT INTO public.who_global_data VALUES (81590, 0, 5, 0, 0, 345, 129);
INSERT INTO public.who_global_data VALUES (81591, 0, 0, 0, 0, 345, 121);
INSERT INTO public.who_global_data VALUES (81592, 0, 0, 0, 0, 345, 59);
INSERT INTO public.who_global_data VALUES (81593, 0, 0, 0, 0, 345, 96);
INSERT INTO public.who_global_data VALUES (81594, 1, 1, 0, 0, 345, 41);
INSERT INTO public.who_global_data VALUES (81595, 0, 0, 0, 0, 345, 216);
INSERT INTO public.who_global_data VALUES (81596, 0, 0, 0, 0, 345, 236);
INSERT INTO public.who_global_data VALUES (81597, 0, 0, 0, 0, 345, 150);
INSERT INTO public.who_global_data VALUES (81598, 0, 0, 0, 0, 345, 61);
INSERT INTO public.who_global_data VALUES (81599, 0, 0, 0, 0, 345, 7);
INSERT INTO public.who_global_data VALUES (81600, 1, 2, 0, 0, 345, 169);
INSERT INTO public.who_global_data VALUES (81601, 3, 17, 1, 2, 345, 28);
INSERT INTO public.who_global_data VALUES (81602, 0, 0, 0, 0, 345, 85);
INSERT INTO public.who_global_data VALUES (81603, 0, 0, 0, 0, 345, 211);
INSERT INTO public.who_global_data VALUES (81604, 0, 0, 0, 0, 345, 60);
INSERT INTO public.who_global_data VALUES (81605, 0, 0, 0, 0, 345, 3);
INSERT INTO public.who_global_data VALUES (81606, 0, 1, 0, 0, 345, 11);
INSERT INTO public.who_global_data VALUES (81607, 4, 21, 0, 0, 345, 89);
INSERT INTO public.who_global_data VALUES (81608, 0, 0, 0, 0, 345, 24);
INSERT INTO public.who_global_data VALUES (81609, 0, 0, 0, 0, 345, 162);
INSERT INTO public.who_global_data VALUES (81610, 1, 1, 0, 0, 345, 100);
INSERT INTO public.who_global_data VALUES (81611, 0, 0, 0, 0, 345, 47);
INSERT INTO public.who_global_data VALUES (81612, 0, 0, 0, 0, 345, 29);
INSERT INTO public.who_global_data VALUES (81613, 0, 0, 0, 0, 345, 40);
INSERT INTO public.who_global_data VALUES (81614, 0, 0, 0, 0, 345, 222);
INSERT INTO public.who_global_data VALUES (81615, 0, 0, 0, 0, 345, 132);
INSERT INTO public.who_global_data VALUES (81616, 0, 0, 0, 0, 345, 130);
INSERT INTO public.who_global_data VALUES (81617, 0, 0, 0, 0, 345, 234);
INSERT INTO public.who_global_data VALUES (81618, 0, 0, 0, 0, 345, 23);
INSERT INTO public.who_global_data VALUES (81619, 0, 0, 0, 0, 345, 192);
INSERT INTO public.who_global_data VALUES (81620, 0, 0, 0, 0, 345, 69);
INSERT INTO public.who_global_data VALUES (81621, 0, 0, 0, 0, 345, 187);
INSERT INTO public.who_global_data VALUES (81622, 0, 0, 0, 0, 345, 230);
INSERT INTO public.who_global_data VALUES (81623, 0, 0, 0, 0, 345, 77);
INSERT INTO public.who_global_data VALUES (81624, 0, 0, 0, 0, 345, 9);
INSERT INTO public.who_global_data VALUES (81625, 0, 7, 0, 0, 345, 74);
INSERT INTO public.who_global_data VALUES (81626, 0, 0, 0, 0, 345, 224);
INSERT INTO public.who_global_data VALUES (81627, 106, 249, 7, 26, 345, 199);
INSERT INTO public.who_global_data VALUES (81628, 1, 10, 0, 0, 345, 190);
INSERT INTO public.who_global_data VALUES (81629, 0, 0, 0, 0, 345, 12);
INSERT INTO public.who_global_data VALUES (81630, 0, 0, 0, 0, 345, 104);
INSERT INTO public.who_global_data VALUES (81631, 0, 2, 0, 0, 345, 153);
INSERT INTO public.who_global_data VALUES (81632, 78, 400, 1, 12, 345, 91);
INSERT INTO public.who_global_data VALUES (81633, 0, 0, 0, 0, 345, 215);
INSERT INTO public.who_global_data VALUES (81634, 1, 191, 1, 4, 345, 84);
INSERT INTO public.who_global_data VALUES (81635, 0, 0, 0, 0, 345, 231);
INSERT INTO public.who_global_data VALUES (81636, 0, 0, 0, 0, 345, 196);
INSERT INTO public.who_global_data VALUES (81637, 0, 0, 0, 0, 345, 105);
INSERT INTO public.who_global_data VALUES (81638, 0, 0, 0, 0, 345, 122);
INSERT INTO public.who_global_data VALUES (81639, 0, 0, 0, 0, 345, 159);
INSERT INTO public.who_global_data VALUES (81640, 0, 0, 0, 0, 345, 75);
INSERT INTO public.who_global_data VALUES (81641, 17, 47, 0, 0, 345, 27);
INSERT INTO public.who_global_data VALUES (81642, 0, 0, 0, 0, 345, 54);
INSERT INTO public.who_global_data VALUES (81643, 0, 0, 0, 0, 345, 226);
INSERT INTO public.who_global_data VALUES (81644, 0, 0, 0, 0, 345, 79);
INSERT INTO public.who_global_data VALUES (81645, 1, 7, 0, 0, 345, 56);
INSERT INTO public.who_global_data VALUES (81646, 0, 0, 0, 0, 345, 117);
INSERT INTO public.who_global_data VALUES (81647, 0, 0, 0, 0, 345, 152);
INSERT INTO public.who_global_data VALUES (81648, 0, 0, 0, 0, 345, 16);
INSERT INTO public.who_global_data VALUES (81649, 0, 0, 0, 0, 345, 10);
INSERT INTO public.who_global_data VALUES (81650, 0, 0, 0, 0, 345, 201);
INSERT INTO public.who_global_data VALUES (81651, 0, 0, 0, 0, 345, 174);
INSERT INTO public.who_global_data VALUES (81652, 0, 0, 0, 0, 345, 119);
INSERT INTO public.who_global_data VALUES (81653, 0, 0, 0, 0, 345, 168);
INSERT INTO public.who_global_data VALUES (81654, 2, 28, 0, 0, 345, 99);
INSERT INTO public.who_global_data VALUES (81655, 0, 0, 0, 0, 345, 171);
INSERT INTO public.who_global_data VALUES (81656, 0, 0, 0, 0, 345, 87);
INSERT INTO public.who_global_data VALUES (81657, 0, 0, 0, 0, 345, 123);
INSERT INTO public.who_global_data VALUES (81658, 0, 0, 0, 0, 345, 151);
INSERT INTO public.who_global_data VALUES (81659, 0, 0, 0, 0, 345, 213);
INSERT INTO public.who_global_data VALUES (81660, 0, 0, 0, 0, 345, 118);
INSERT INTO public.who_global_data VALUES (81661, 0, 0, 0, 0, 345, 134);
INSERT INTO public.who_global_data VALUES (81662, 0, 0, 0, 0, 345, 65);
INSERT INTO public.who_global_data VALUES (81663, 0, 0, 0, 0, 345, 102);
INSERT INTO public.who_global_data VALUES (81664, 0, 0, 0, 0, 345, 223);
INSERT INTO public.who_global_data VALUES (81665, 0, 0, 0, 0, 345, 4);
INSERT INTO public.who_global_data VALUES (81666, 0, 0, 0, 0, 345, 146);
INSERT INTO public.who_global_data VALUES (81667, 0, 0, 0, 0, 345, 31);
INSERT INTO public.who_global_data VALUES (81668, 0, 0, 0, 0, 345, 127);
INSERT INTO public.who_global_data VALUES (81669, 0, 0, 0, 0, 345, 22);
INSERT INTO public.who_global_data VALUES (81670, 0, 0, 0, 0, 345, 115);
INSERT INTO public.who_global_data VALUES (81671, 0, 0, 0, 0, 345, 106);
INSERT INTO public.who_global_data VALUES (81672, 0, 0, 0, 0, 345, 90);
INSERT INTO public.who_global_data VALUES (81673, 0, 0, 0, 0, 345, 70);
INSERT INTO public.who_global_data VALUES (81674, 0, 5, 0, 0, 345, 46);
INSERT INTO public.who_global_data VALUES (81675, 0, 0, 0, 0, 345, 139);
INSERT INTO public.who_global_data VALUES (81676, 0, 0, 0, 0, 345, 42);
INSERT INTO public.who_global_data VALUES (81677, 0, 0, 0, 0, 345, 80);
INSERT INTO public.who_global_data VALUES (81678, 0, 0, 0, 0, 345, 203);
INSERT INTO public.who_global_data VALUES (81679, 0, 0, 0, 0, 345, 136);
INSERT INTO public.who_global_data VALUES (81680, 0, 0, 0, 0, 345, 63);
INSERT INTO public.who_global_data VALUES (81681, 0, 0, 0, 0, 345, 17);
INSERT INTO public.who_global_data VALUES (81682, 0, 0, 0, 0, 345, 172);
INSERT INTO public.who_global_data VALUES (81683, 0, 1, 0, 0, 345, 109);
INSERT INTO public.who_global_data VALUES (81684, 0, 1, 0, 0, 345, 200);
INSERT INTO public.who_global_data VALUES (81685, 0, 0, 0, 0, 345, 93);
INSERT INTO public.who_global_data VALUES (81686, 2, 10, 0, 0, 345, 5);
INSERT INTO public.who_global_data VALUES (81687, 0, 699, 0, 4, 345, 214);
INSERT INTO public.who_global_data VALUES (81688, 0, 6, 0, 0, 345, 204);
INSERT INTO public.who_global_data VALUES (81689, 0, 0, 0, 0, 345, 198);
INSERT INTO public.who_global_data VALUES (81690, 0, 0, 0, 0, 345, 173);
INSERT INTO public.who_global_data VALUES (81691, 0, 0, 0, 0, 345, 229);
INSERT INTO public.who_global_data VALUES (81692, 0, 0, 0, 0, 345, 76);
INSERT INTO public.who_global_data VALUES (81693, 0, 0, 0, 0, 345, 138);
INSERT INTO public.who_global_data VALUES (81694, 0, 7, 0, 1, 345, 98);
INSERT INTO public.who_global_data VALUES (81695, 0, 0, 0, 0, 345, 103);
INSERT INTO public.who_global_data VALUES (81696, 0, 0, 0, 0, 345, 225);
INSERT INTO public.who_global_data VALUES (81697, 0, 0, 0, 0, 345, 131);
INSERT INTO public.who_global_data VALUES (81698, 0, 0, 0, 0, 345, 235);
INSERT INTO public.who_global_data VALUES (81699, 0, 0, 0, 0, 345, 137);
INSERT INTO public.who_global_data VALUES (81700, 505, 1770, 1, 13, 345, 81);
INSERT INTO public.who_global_data VALUES (81701, 0, 0, 0, 0, 345, 182);
INSERT INTO public.who_global_data VALUES (81702, 0, 0, 0, 0, 345, 145);
INSERT INTO public.who_global_data VALUES (81703, 0, 1, 0, 0, 345, 26);
INSERT INTO public.who_global_data VALUES (81704, 0, 2, 0, 0, 345, 170);
INSERT INTO public.who_global_data VALUES (81705, 0, 0, 0, 0, 345, 191);
INSERT INTO public.who_global_data VALUES (81706, 0, 0, 0, 0, 345, 221);
INSERT INTO public.who_global_data VALUES (81707, 0, 0, 0, 0, 345, 64);
INSERT INTO public.who_global_data VALUES (81708, 0, 0, 0, 0, 345, 116);
INSERT INTO public.who_global_data VALUES (81709, 0, 0, 0, 0, 345, 128);
INSERT INTO public.who_global_data VALUES (81710, 0, 0, 0, 0, 345, 6);
INSERT INTO public.who_global_data VALUES (81711, 0, 0, 0, 0, 345, 227);
INSERT INTO public.who_global_data VALUES (81712, 0, 0, 0, 0, 345, 68);
INSERT INTO public.who_global_data VALUES (81713, 0, 0, 0, 0, 345, 184);
INSERT INTO public.who_global_data VALUES (81714, 0, 0, 0, 0, 345, 82);
INSERT INTO public.who_global_data VALUES (81715, 0, 0, 0, 0, 345, 149);
INSERT INTO public.who_global_data VALUES (81716, 0, 0, 0, 0, 345, 197);
INSERT INTO public.who_global_data VALUES (81717, 0, 0, 0, 0, 345, 78);
INSERT INTO public.who_global_data VALUES (81718, 0, 0, 0, 0, 345, 233);
INSERT INTO public.who_global_data VALUES (81719, 0, 0, 0, 0, 345, 133);
INSERT INTO public.who_global_data VALUES (81720, 0, 0, 0, 0, 345, 35);
INSERT INTO public.who_global_data VALUES (81721, 0, 0, 0, 0, 345, 114);
INSERT INTO public.who_global_data VALUES (81722, 3, 100, 0, 0, 345, 237);
INSERT INTO public.who_global_data VALUES (81723, 0, 0, 0, 0, 345, 55);
INSERT INTO public.who_global_data VALUES (81724, 0, 0, 0, 0, 345, 176);
INSERT INTO public.who_global_data VALUES (81725, 0, 0, 0, 0, 345, 202);
INSERT INTO public.who_global_data VALUES (81726, 0, 0, 0, 0, 345, 155);
INSERT INTO public.who_global_data VALUES (81727, 0, 0, 0, 0, 345, 32);
INSERT INTO public.who_global_data VALUES (81728, 0, 0, 0, 0, 345, 220);
INSERT INTO public.who_global_data VALUES (81729, 0, 0, 0, 0, 345, 30);
INSERT INTO public.who_global_data VALUES (81730, 0, 0, 0, 0, 345, 147);
INSERT INTO public.who_global_data VALUES (81731, 1, 35, 0, 1, 345, 208);
INSERT INTO public.who_global_data VALUES (81732, 0, 5, 0, 0, 345, 45);
INSERT INTO public.who_global_data VALUES (81733, 0, 0, 0, 0, 345, 110);
INSERT INTO public.who_global_data VALUES (81734, 0, 0, 0, 0, 345, 88);
INSERT INTO public.who_global_data VALUES (81735, 0, 1, 0, 0, 345, 51);
INSERT INTO public.who_global_data VALUES (81736, 10, 12, 0, 0, 345, 209);
INSERT INTO public.who_global_data VALUES (81737, 0, 0, 0, 0, 345, 205);
INSERT INTO public.who_global_data VALUES (81738, 0, 0, 0, 0, 345, 18);
INSERT INTO public.who_global_data VALUES (81739, 0, 44, 0, 0, 345, 72);
INSERT INTO public.who_global_data VALUES (81740, 5, 18, 0, 0, 345, 44);
INSERT INTO public.who_global_data VALUES (81741, 0, 0, 0, 0, 345, 15);
INSERT INTO public.who_global_data VALUES (81742, 0, 0, 0, 0, 345, 25);
INSERT INTO public.who_global_data VALUES (81743, 0, 0, 0, 0, 345, 179);
INSERT INTO public.who_global_data VALUES (81744, 0, 0, 0, 0, 345, 34);
INSERT INTO public.who_global_data VALUES (81745, 0, 0, 0, 0, 345, 207);
INSERT INTO public.who_global_data VALUES (81746, 0, 0, 0, 0, 345, 166);
INSERT INTO public.who_global_data VALUES (81747, 0, 0, 0, 0, 345, 126);
INSERT INTO public.who_global_data VALUES (81748, 0, 0, 0, 0, 345, 97);
INSERT INTO public.who_global_data VALUES (81749, 0, 0, 0, 0, 345, 36);
INSERT INTO public.who_global_data VALUES (81750, 0, 0, 0, 0, 345, 125);
INSERT INTO public.who_global_data VALUES (81751, 0, 0, 0, 0, 345, 124);
INSERT INTO public.who_global_data VALUES (81752, 0, 0, 0, 0, 345, 185);
INSERT INTO public.who_global_data VALUES (81753, 6, 23, 0, 0, 345, 194);
INSERT INTO public.who_global_data VALUES (81754, 0, 0, 0, 0, 345, 144);
INSERT INTO public.who_global_data VALUES (81755, 0, 63, 0, 0, 345, 19);
INSERT INTO public.who_global_data VALUES (81756, 0, 0, 0, 0, 345, 217);
INSERT INTO public.who_global_data VALUES (81757, 0, 0, 0, 0, 345, 148);
INSERT INTO public.who_global_data VALUES (81758, 0, 0, 0, 0, 345, 86);
INSERT INTO public.who_global_data VALUES (81759, 0, 0, 0, 0, 345, 13);
INSERT INTO public.who_global_data VALUES (81760, 0, 0, 0, 0, 345, 157);
INSERT INTO public.who_global_data VALUES (81761, 0, 20, 0, 0, 345, 8);
INSERT INTO public.who_global_data VALUES (81762, 0, 0, 0, 0, 345, 73);
INSERT INTO public.who_global_data VALUES (81763, 0, 0, 0, 0, 345, 101);
INSERT INTO public.who_global_data VALUES (81764, 0, 0, 0, 0, 345, 165);
INSERT INTO public.who_global_data VALUES (81765, 0, 0, 0, 0, 345, 14);
INSERT INTO public.who_global_data VALUES (81766, 0, 5, 0, 0, 346, 193);
INSERT INTO public.who_global_data VALUES (81767, 0, 0, 0, 0, 346, 113);
INSERT INTO public.who_global_data VALUES (81768, 0, 5, 0, 0, 346, 143);
INSERT INTO public.who_global_data VALUES (81769, 0, 0, 0, 0, 346, 219);
INSERT INTO public.who_global_data VALUES (81770, 0, 0, 0, 0, 346, 186);
INSERT INTO public.who_global_data VALUES (81771, 0, 0, 0, 0, 346, 52);
INSERT INTO public.who_global_data VALUES (81772, 0, 0, 0, 0, 346, 180);
INSERT INTO public.who_global_data VALUES (81773, 0, 0, 0, 0, 346, 167);
INSERT INTO public.who_global_data VALUES (81774, 0, 0, 0, 0, 346, 154);
INSERT INTO public.who_global_data VALUES (81775, 0, 0, 0, 0, 346, 94);
INSERT INTO public.who_global_data VALUES (81776, 0, 0, 0, 0, 346, 66);
INSERT INTO public.who_global_data VALUES (81777, 0, 27, 0, 0, 346, 58);
INSERT INTO public.who_global_data VALUES (81778, 2, 2, 0, 0, 346, 163);
INSERT INTO public.who_global_data VALUES (81779, 0, 0, 0, 0, 346, 37);
INSERT INTO public.who_global_data VALUES (81780, 0, 0, 0, 0, 346, 142);
INSERT INTO public.who_global_data VALUES (81781, 16, 37, 0, 0, 346, 83);
INSERT INTO public.who_global_data VALUES (81782, 0, 0, 0, 0, 346, 228);
INSERT INTO public.who_global_data VALUES (81783, 0, 0, 0, 0, 346, 188);
INSERT INTO public.who_global_data VALUES (81784, 0, 0, 0, 0, 346, 62);
INSERT INTO public.who_global_data VALUES (81785, 0, 1, 0, 0, 346, 160);
INSERT INTO public.who_global_data VALUES (81786, 0, 0, 0, 0, 346, 50);
INSERT INTO public.who_global_data VALUES (81787, 0, 0, 0, 0, 346, 33);
INSERT INTO public.who_global_data VALUES (81788, 0, 0, 0, 0, 346, 183);
INSERT INTO public.who_global_data VALUES (81789, 0, 0, 0, 0, 346, 92);
INSERT INTO public.who_global_data VALUES (81790, 0, 0, 0, 0, 346, 158);
INSERT INTO public.who_global_data VALUES (81791, 0, 0, 0, 0, 346, 67);
INSERT INTO public.who_global_data VALUES (81792, 0, 0, 0, 0, 346, 57);
INSERT INTO public.who_global_data VALUES (81793, 0, 0, 0, 0, 346, 38);
INSERT INTO public.who_global_data VALUES (81794, 5, 5, 0, 0, 346, 141);
INSERT INTO public.who_global_data VALUES (81795, 0, 0, 0, 0, 346, 178);
INSERT INTO public.who_global_data VALUES (81796, 0, 0, 0, 0, 346, 108);
INSERT INTO public.who_global_data VALUES (81797, 0, 0, 0, 0, 346, 39);
INSERT INTO public.who_global_data VALUES (81798, 0, 0, 0, 0, 346, 2);
INSERT INTO public.who_global_data VALUES (81799, 0, 0, 0, 0, 346, 195);
INSERT INTO public.who_global_data VALUES (81800, 0, 0, 0, 0, 346, 107);
INSERT INTO public.who_global_data VALUES (81801, 0, 5, 0, 0, 346, 161);
INSERT INTO public.who_global_data VALUES (81802, 0, 0, 0, 0, 346, 212);
INSERT INTO public.who_global_data VALUES (81803, 1, 15, 0, 0, 346, 181);
INSERT INTO public.who_global_data VALUES (81804, 0, 0, 0, 0, 346, 53);
INSERT INTO public.who_global_data VALUES (81805, 0, 0, 0, 0, 346, 164);
INSERT INTO public.who_global_data VALUES (81806, 0, 0, 0, 0, 346, 140);
INSERT INTO public.who_global_data VALUES (81807, 0, 0, 0, 0, 346, 20);
INSERT INTO public.who_global_data VALUES (81808, 411, 78194, 52, 2718, 346, 112);
INSERT INTO public.who_global_data VALUES (81809, 0, 0, 0, 0, 346, 111);
INSERT INTO public.who_global_data VALUES (81810, 0, 0, 0, 0, 346, 71);
INSERT INTO public.who_global_data VALUES (81811, 0, 0, 0, 0, 346, 218);
INSERT INTO public.who_global_data VALUES (81812, 0, 0, 0, 0, 346, 43);
INSERT INTO public.who_global_data VALUES (81813, 0, 0, 0, 0, 346, 49);
INSERT INTO public.who_global_data VALUES (81814, 0, 0, 0, 0, 346, 1);
INSERT INTO public.who_global_data VALUES (81815, 1, 1, 0, 0, 346, 48);
INSERT INTO public.who_global_data VALUES (81816, 0, 0, 0, 0, 346, 232);
INSERT INTO public.who_global_data VALUES (81817, 0, 0, 0, 0, 346, 175);
INSERT INTO public.who_global_data VALUES (81818, 0, 0, 0, 0, 346, 21);
INSERT INTO public.who_global_data VALUES (81819, 0, 0, 0, 0, 346, 156);
INSERT INTO public.who_global_data VALUES (81820, 0, 0, 0, 0, 346, 95);
INSERT INTO public.who_global_data VALUES (81821, 0, 0, 0, 0, 346, 177);
INSERT INTO public.who_global_data VALUES (81822, 0, 0, 0, 0, 346, 210);
INSERT INTO public.who_global_data VALUES (81823, 0, 0, 0, 0, 346, 120);
INSERT INTO public.who_global_data VALUES (81824, 0, 0, 0, 0, 346, 135);
INSERT INTO public.who_global_data VALUES (81825, 0, 0, 0, 0, 346, 206);
INSERT INTO public.who_global_data VALUES (81826, 0, 0, 0, 0, 346, 189);
INSERT INTO public.who_global_data VALUES (81827, 0, 5, 0, 0, 346, 129);
INSERT INTO public.who_global_data VALUES (81828, 0, 0, 0, 0, 346, 121);
INSERT INTO public.who_global_data VALUES (81829, 0, 0, 0, 0, 346, 59);
INSERT INTO public.who_global_data VALUES (81830, 0, 0, 0, 0, 346, 96);
INSERT INTO public.who_global_data VALUES (81831, 0, 0, 0, 0, 346, 41);
INSERT INTO public.who_global_data VALUES (81832, 0, 0, 0, 0, 346, 216);
INSERT INTO public.who_global_data VALUES (81833, 0, 0, 0, 0, 346, 236);
INSERT INTO public.who_global_data VALUES (81834, 0, 0, 0, 0, 346, 150);
INSERT INTO public.who_global_data VALUES (81835, 0, 0, 0, 0, 346, 61);
INSERT INTO public.who_global_data VALUES (81836, 0, 0, 0, 0, 346, 7);
INSERT INTO public.who_global_data VALUES (81837, 0, 1, 0, 0, 346, 169);
INSERT INTO public.who_global_data VALUES (81838, 2, 14, 0, 1, 346, 28);
INSERT INTO public.who_global_data VALUES (81839, 0, 0, 0, 0, 346, 85);
INSERT INTO public.who_global_data VALUES (81840, 0, 0, 0, 0, 346, 211);
INSERT INTO public.who_global_data VALUES (81841, 0, 0, 0, 0, 346, 60);
INSERT INTO public.who_global_data VALUES (81842, 0, 0, 0, 0, 346, 3);
INSERT INTO public.who_global_data VALUES (81843, 1, 1, 0, 0, 346, 11);
INSERT INTO public.who_global_data VALUES (81844, 2, 17, 0, 0, 346, 89);
INSERT INTO public.who_global_data VALUES (81845, 0, 0, 0, 0, 346, 24);
INSERT INTO public.who_global_data VALUES (81846, 0, 0, 0, 0, 346, 162);
INSERT INTO public.who_global_data VALUES (81847, 0, 0, 0, 0, 346, 100);
INSERT INTO public.who_global_data VALUES (81848, 0, 0, 0, 0, 346, 47);
INSERT INTO public.who_global_data VALUES (81849, 0, 0, 0, 0, 346, 29);
INSERT INTO public.who_global_data VALUES (81850, 0, 0, 0, 0, 346, 40);
INSERT INTO public.who_global_data VALUES (81851, 0, 0, 0, 0, 346, 222);
INSERT INTO public.who_global_data VALUES (81852, 0, 0, 0, 0, 346, 132);
INSERT INTO public.who_global_data VALUES (81853, 0, 0, 0, 0, 346, 130);
INSERT INTO public.who_global_data VALUES (81854, 0, 0, 0, 0, 346, 234);
INSERT INTO public.who_global_data VALUES (81855, 0, 0, 0, 0, 346, 23);
INSERT INTO public.who_global_data VALUES (81856, 0, 0, 0, 0, 346, 192);
INSERT INTO public.who_global_data VALUES (81857, 0, 0, 0, 0, 346, 69);
INSERT INTO public.who_global_data VALUES (81858, 0, 0, 0, 0, 346, 187);
INSERT INTO public.who_global_data VALUES (81859, 0, 0, 0, 0, 346, 230);
INSERT INTO public.who_global_data VALUES (81860, 0, 0, 0, 0, 346, 77);
INSERT INTO public.who_global_data VALUES (81861, 0, 0, 0, 0, 346, 9);
INSERT INTO public.who_global_data VALUES (81862, 0, 7, 0, 0, 346, 74);
INSERT INTO public.who_global_data VALUES (81863, 0, 0, 0, 0, 346, 224);
INSERT INTO public.who_global_data VALUES (81864, 44, 143, 4, 19, 346, 199);
INSERT INTO public.who_global_data VALUES (81865, 0, 9, 0, 0, 346, 190);
INSERT INTO public.who_global_data VALUES (81866, 0, 0, 0, 0, 346, 12);
INSERT INTO public.who_global_data VALUES (81867, 0, 0, 0, 0, 346, 104);
INSERT INTO public.who_global_data VALUES (81868, 1, 2, 0, 0, 346, 153);
INSERT INTO public.who_global_data VALUES (81869, 93, 322, 5, 11, 346, 91);
INSERT INTO public.who_global_data VALUES (81870, 0, 0, 0, 0, 346, 215);
INSERT INTO public.who_global_data VALUES (81871, 29, 190, 2, 3, 346, 84);
INSERT INTO public.who_global_data VALUES (81872, 0, 0, 0, 0, 346, 231);
INSERT INTO public.who_global_data VALUES (81873, 0, 0, 0, 0, 346, 196);
INSERT INTO public.who_global_data VALUES (81874, 0, 0, 0, 0, 346, 105);
INSERT INTO public.who_global_data VALUES (81875, 0, 0, 0, 0, 346, 122);
INSERT INTO public.who_global_data VALUES (81876, 0, 0, 0, 0, 346, 159);
INSERT INTO public.who_global_data VALUES (81877, 0, 0, 0, 0, 346, 75);
INSERT INTO public.who_global_data VALUES (81878, 17, 30, 0, 0, 346, 27);
INSERT INTO public.who_global_data VALUES (81879, 0, 0, 0, 0, 346, 54);
INSERT INTO public.who_global_data VALUES (81880, 0, 0, 0, 0, 346, 226);
INSERT INTO public.who_global_data VALUES (81881, 0, 0, 0, 0, 346, 79);
INSERT INTO public.who_global_data VALUES (81882, 1, 6, 0, 0, 346, 56);
INSERT INTO public.who_global_data VALUES (81883, 0, 0, 0, 0, 346, 117);
INSERT INTO public.who_global_data VALUES (81884, 0, 0, 0, 0, 346, 152);
INSERT INTO public.who_global_data VALUES (81885, 0, 0, 0, 0, 346, 16);
INSERT INTO public.who_global_data VALUES (81886, 0, 0, 0, 0, 346, 10);
INSERT INTO public.who_global_data VALUES (81887, 0, 0, 0, 0, 346, 201);
INSERT INTO public.who_global_data VALUES (81888, 0, 0, 0, 0, 346, 174);
INSERT INTO public.who_global_data VALUES (81889, 0, 0, 0, 0, 346, 119);
INSERT INTO public.who_global_data VALUES (81890, 0, 0, 0, 0, 346, 168);
INSERT INTO public.who_global_data VALUES (81891, 0, 26, 0, 0, 346, 99);
INSERT INTO public.who_global_data VALUES (81892, 0, 0, 0, 0, 346, 171);
INSERT INTO public.who_global_data VALUES (81893, 0, 0, 0, 0, 346, 87);
INSERT INTO public.who_global_data VALUES (81894, 0, 0, 0, 0, 346, 123);
INSERT INTO public.who_global_data VALUES (81895, 0, 0, 0, 0, 346, 151);
INSERT INTO public.who_global_data VALUES (81896, 0, 0, 0, 0, 346, 213);
INSERT INTO public.who_global_data VALUES (81897, 0, 0, 0, 0, 346, 118);
INSERT INTO public.who_global_data VALUES (81898, 0, 0, 0, 0, 346, 134);
INSERT INTO public.who_global_data VALUES (81899, 0, 0, 0, 0, 346, 65);
INSERT INTO public.who_global_data VALUES (81900, 0, 0, 0, 0, 346, 102);
INSERT INTO public.who_global_data VALUES (81901, 0, 0, 0, 0, 346, 223);
INSERT INTO public.who_global_data VALUES (81902, 0, 0, 0, 0, 346, 4);
INSERT INTO public.who_global_data VALUES (81903, 0, 0, 0, 0, 346, 146);
INSERT INTO public.who_global_data VALUES (81904, 0, 0, 0, 0, 346, 31);
INSERT INTO public.who_global_data VALUES (81905, 0, 0, 0, 0, 346, 127);
INSERT INTO public.who_global_data VALUES (81906, 0, 0, 0, 0, 346, 22);
INSERT INTO public.who_global_data VALUES (81907, 0, 0, 0, 0, 346, 115);
INSERT INTO public.who_global_data VALUES (81908, 0, 0, 0, 0, 346, 106);
INSERT INTO public.who_global_data VALUES (81909, 0, 0, 0, 0, 346, 90);
INSERT INTO public.who_global_data VALUES (81910, 0, 0, 0, 0, 346, 70);
INSERT INTO public.who_global_data VALUES (81911, 0, 5, 0, 0, 346, 46);
INSERT INTO public.who_global_data VALUES (81912, 0, 0, 0, 0, 346, 139);
INSERT INTO public.who_global_data VALUES (81913, 0, 0, 0, 0, 346, 42);
INSERT INTO public.who_global_data VALUES (81914, 0, 0, 0, 0, 346, 80);
INSERT INTO public.who_global_data VALUES (81915, 0, 0, 0, 0, 346, 203);
INSERT INTO public.who_global_data VALUES (81916, 0, 0, 0, 0, 346, 136);
INSERT INTO public.who_global_data VALUES (81917, 0, 0, 0, 0, 346, 63);
INSERT INTO public.who_global_data VALUES (81918, 0, 0, 0, 0, 346, 17);
INSERT INTO public.who_global_data VALUES (81919, 0, 0, 0, 0, 346, 172);
INSERT INTO public.who_global_data VALUES (81920, 1, 1, 0, 0, 346, 109);
INSERT INTO public.who_global_data VALUES (81921, 1, 1, 0, 0, 346, 200);
INSERT INTO public.who_global_data VALUES (81922, 0, 0, 0, 0, 346, 93);
INSERT INTO public.who_global_data VALUES (81923, 0, 8, 0, 0, 346, 5);
INSERT INTO public.who_global_data VALUES (81924, 4, 699, 0, 4, 346, 214);
INSERT INTO public.who_global_data VALUES (81925, 6, 6, 0, 0, 346, 204);
INSERT INTO public.who_global_data VALUES (81926, 0, 0, 0, 0, 346, 198);
INSERT INTO public.who_global_data VALUES (81927, 0, 0, 0, 0, 346, 173);
INSERT INTO public.who_global_data VALUES (81928, 0, 0, 0, 0, 346, 229);
INSERT INTO public.who_global_data VALUES (81929, 0, 0, 0, 0, 346, 76);
INSERT INTO public.who_global_data VALUES (81930, 0, 0, 0, 0, 346, 138);
INSERT INTO public.who_global_data VALUES (81931, 0, 7, 0, 1, 346, 98);
INSERT INTO public.who_global_data VALUES (81932, 0, 0, 0, 0, 346, 103);
INSERT INTO public.who_global_data VALUES (81933, 0, 0, 0, 0, 346, 225);
INSERT INTO public.who_global_data VALUES (81934, 0, 0, 0, 0, 346, 131);
INSERT INTO public.who_global_data VALUES (81935, 0, 0, 0, 0, 346, 235);
INSERT INTO public.who_global_data VALUES (81936, 0, 0, 0, 0, 346, 137);
INSERT INTO public.who_global_data VALUES (81937, 284, 1265, 2, 12, 346, 81);
INSERT INTO public.who_global_data VALUES (81938, 0, 0, 0, 0, 346, 182);
INSERT INTO public.who_global_data VALUES (81939, 0, 0, 0, 0, 346, 145);
INSERT INTO public.who_global_data VALUES (81940, 1, 1, 0, 0, 346, 26);
INSERT INTO public.who_global_data VALUES (81941, 0, 2, 0, 0, 346, 170);
INSERT INTO public.who_global_data VALUES (81942, 0, 0, 0, 0, 346, 191);
INSERT INTO public.who_global_data VALUES (81943, 0, 0, 0, 0, 346, 221);
INSERT INTO public.who_global_data VALUES (81944, 0, 0, 0, 0, 346, 64);
INSERT INTO public.who_global_data VALUES (81945, 0, 0, 0, 0, 346, 116);
INSERT INTO public.who_global_data VALUES (81946, 0, 0, 0, 0, 346, 128);
INSERT INTO public.who_global_data VALUES (81947, 0, 0, 0, 0, 346, 6);
INSERT INTO public.who_global_data VALUES (81948, 0, 0, 0, 0, 346, 227);
INSERT INTO public.who_global_data VALUES (81949, 0, 0, 0, 0, 346, 68);
INSERT INTO public.who_global_data VALUES (81950, 0, 0, 0, 0, 346, 184);
INSERT INTO public.who_global_data VALUES (81951, 0, 0, 0, 0, 346, 82);
INSERT INTO public.who_global_data VALUES (81952, 0, 0, 0, 0, 346, 149);
INSERT INTO public.who_global_data VALUES (81953, 0, 0, 0, 0, 346, 197);
INSERT INTO public.who_global_data VALUES (81954, 0, 0, 0, 0, 346, 78);
INSERT INTO public.who_global_data VALUES (81955, 0, 0, 0, 0, 346, 233);
INSERT INTO public.who_global_data VALUES (81956, 0, 0, 0, 0, 346, 133);
INSERT INTO public.who_global_data VALUES (81957, 0, 0, 0, 0, 346, 35);
INSERT INTO public.who_global_data VALUES (81958, 0, 0, 0, 0, 346, 114);
INSERT INTO public.who_global_data VALUES (81959, 2, 97, 0, 0, 346, 237);
INSERT INTO public.who_global_data VALUES (81960, 0, 0, 0, 0, 346, 55);
INSERT INTO public.who_global_data VALUES (81961, 0, 0, 0, 0, 346, 176);
INSERT INTO public.who_global_data VALUES (81962, 0, 0, 0, 0, 346, 202);
INSERT INTO public.who_global_data VALUES (81963, 0, 0, 0, 0, 346, 155);
INSERT INTO public.who_global_data VALUES (81964, 0, 0, 0, 0, 346, 32);
INSERT INTO public.who_global_data VALUES (81965, 0, 0, 0, 0, 346, 220);
INSERT INTO public.who_global_data VALUES (81966, 0, 0, 0, 0, 346, 30);
INSERT INTO public.who_global_data VALUES (81967, 0, 0, 0, 0, 346, 147);
INSERT INTO public.who_global_data VALUES (81968, 2, 34, 0, 1, 346, 208);
INSERT INTO public.who_global_data VALUES (81969, 0, 5, 0, 0, 346, 45);
INSERT INTO public.who_global_data VALUES (81970, 0, 0, 0, 0, 346, 110);
INSERT INTO public.who_global_data VALUES (81971, 0, 0, 0, 0, 346, 88);
INSERT INTO public.who_global_data VALUES (81972, 0, 1, 0, 0, 346, 51);
INSERT INTO public.who_global_data VALUES (81973, 1, 2, 0, 0, 346, 209);
INSERT INTO public.who_global_data VALUES (81974, 0, 0, 0, 0, 346, 205);
INSERT INTO public.who_global_data VALUES (81975, 0, 0, 0, 0, 346, 18);
INSERT INTO public.who_global_data VALUES (81976, 3, 44, 0, 0, 346, 72);
INSERT INTO public.who_global_data VALUES (81977, 2, 13, 0, 0, 346, 44);
INSERT INTO public.who_global_data VALUES (81978, 0, 0, 0, 0, 346, 15);
INSERT INTO public.who_global_data VALUES (81979, 0, 0, 0, 0, 346, 25);
INSERT INTO public.who_global_data VALUES (81980, 0, 0, 0, 0, 346, 179);
INSERT INTO public.who_global_data VALUES (81981, 0, 0, 0, 0, 346, 34);
INSERT INTO public.who_global_data VALUES (81982, 0, 0, 0, 0, 346, 207);
INSERT INTO public.who_global_data VALUES (81983, 0, 0, 0, 0, 346, 166);
INSERT INTO public.who_global_data VALUES (81984, 0, 0, 0, 0, 346, 126);
INSERT INTO public.who_global_data VALUES (81985, 0, 0, 0, 0, 346, 97);
INSERT INTO public.who_global_data VALUES (81986, 0, 0, 0, 0, 346, 36);
INSERT INTO public.who_global_data VALUES (81987, 0, 0, 0, 0, 346, 125);
INSERT INTO public.who_global_data VALUES (81988, 0, 0, 0, 0, 346, 124);
INSERT INTO public.who_global_data VALUES (81989, 0, 0, 0, 0, 346, 185);
INSERT INTO public.who_global_data VALUES (81990, 0, 17, 0, 0, 346, 194);
INSERT INTO public.who_global_data VALUES (81991, 0, 0, 0, 0, 346, 144);
INSERT INTO public.who_global_data VALUES (81992, 6, 63, 0, 0, 346, 19);
INSERT INTO public.who_global_data VALUES (81993, 0, 0, 0, 0, 346, 217);
INSERT INTO public.who_global_data VALUES (81994, 0, 0, 0, 0, 346, 148);
INSERT INTO public.who_global_data VALUES (81995, 0, 0, 0, 0, 346, 86);
INSERT INTO public.who_global_data VALUES (81996, 0, 0, 0, 0, 346, 13);
INSERT INTO public.who_global_data VALUES (81997, 0, 0, 0, 0, 346, 157);
INSERT INTO public.who_global_data VALUES (81998, 0, 20, 0, 0, 346, 8);
INSERT INTO public.who_global_data VALUES (81999, 0, 0, 0, 0, 346, 73);
INSERT INTO public.who_global_data VALUES (82000, 0, 0, 0, 0, 346, 101);
INSERT INTO public.who_global_data VALUES (82001, 0, 0, 0, 0, 346, 165);
INSERT INTO public.who_global_data VALUES (82002, 0, 0, 0, 0, 346, 14);
INSERT INTO public.who_global_data VALUES (82003, 0, 5, 0, 0, 347, 193);
INSERT INTO public.who_global_data VALUES (82004, 0, 0, 0, 0, 347, 113);
INSERT INTO public.who_global_data VALUES (82005, 5, 5, 0, 0, 347, 143);
INSERT INTO public.who_global_data VALUES (82006, 0, 0, 0, 0, 347, 219);
INSERT INTO public.who_global_data VALUES (82007, 0, 0, 0, 0, 347, 186);
INSERT INTO public.who_global_data VALUES (82008, 0, 0, 0, 0, 347, 52);
INSERT INTO public.who_global_data VALUES (82009, 0, 0, 0, 0, 347, 180);
INSERT INTO public.who_global_data VALUES (82010, 0, 0, 0, 0, 347, 167);
INSERT INTO public.who_global_data VALUES (82011, 0, 0, 0, 0, 347, 154);
INSERT INTO public.who_global_data VALUES (82012, 0, 0, 0, 0, 347, 94);
INSERT INTO public.who_global_data VALUES (82013, 0, 0, 0, 0, 347, 66);
INSERT INTO public.who_global_data VALUES (82014, 1, 27, 0, 0, 347, 58);
INSERT INTO public.who_global_data VALUES (82015, 0, 0, 0, 0, 347, 163);
INSERT INTO public.who_global_data VALUES (82016, 0, 0, 0, 0, 347, 37);
INSERT INTO public.who_global_data VALUES (82017, 0, 0, 0, 0, 347, 142);
INSERT INTO public.who_global_data VALUES (82018, 15, 21, 0, 0, 347, 83);
INSERT INTO public.who_global_data VALUES (82019, 0, 0, 0, 0, 347, 228);
INSERT INTO public.who_global_data VALUES (82020, 0, 0, 0, 0, 347, 188);
INSERT INTO public.who_global_data VALUES (82021, 0, 0, 0, 0, 347, 62);
INSERT INTO public.who_global_data VALUES (82022, 0, 1, 0, 0, 347, 160);
INSERT INTO public.who_global_data VALUES (82023, 0, 0, 0, 0, 347, 50);
INSERT INTO public.who_global_data VALUES (82024, 0, 0, 0, 0, 347, 33);
INSERT INTO public.who_global_data VALUES (82025, 0, 0, 0, 0, 347, 183);
INSERT INTO public.who_global_data VALUES (82026, 0, 0, 0, 0, 347, 92);
INSERT INTO public.who_global_data VALUES (82027, 0, 0, 0, 0, 347, 158);
INSERT INTO public.who_global_data VALUES (82028, 0, 0, 0, 0, 347, 67);
INSERT INTO public.who_global_data VALUES (82029, 0, 0, 0, 0, 347, 57);
INSERT INTO public.who_global_data VALUES (82030, 0, 0, 0, 0, 347, 38);
INSERT INTO public.who_global_data VALUES (82031, 0, 0, 0, 0, 347, 141);
INSERT INTO public.who_global_data VALUES (82032, 0, 0, 0, 0, 347, 178);
INSERT INTO public.who_global_data VALUES (82033, 0, 0, 0, 0, 347, 108);
INSERT INTO public.who_global_data VALUES (82034, 0, 0, 0, 0, 347, 39);
INSERT INTO public.who_global_data VALUES (82035, 0, 0, 0, 0, 347, 2);
INSERT INTO public.who_global_data VALUES (82036, 0, 0, 0, 0, 347, 195);
INSERT INTO public.who_global_data VALUES (82037, 0, 0, 0, 0, 347, 107);
INSERT INTO public.who_global_data VALUES (82038, 0, 5, 0, 0, 347, 161);
INSERT INTO public.who_global_data VALUES (82039, 0, 0, 0, 0, 347, 212);
INSERT INTO public.who_global_data VALUES (82040, 0, 14, 0, 0, 347, 181);
INSERT INTO public.who_global_data VALUES (82041, 0, 0, 0, 0, 347, 53);
INSERT INTO public.who_global_data VALUES (82042, 0, 0, 0, 0, 347, 164);
INSERT INTO public.who_global_data VALUES (82043, 0, 0, 0, 0, 347, 140);
INSERT INTO public.who_global_data VALUES (82044, 0, 0, 0, 0, 347, 20);
INSERT INTO public.who_global_data VALUES (82045, 517, 77783, 71, 2666, 347, 112);
INSERT INTO public.who_global_data VALUES (82046, 0, 0, 0, 0, 347, 111);
INSERT INTO public.who_global_data VALUES (82047, 0, 0, 0, 0, 347, 71);
INSERT INTO public.who_global_data VALUES (82048, 0, 0, 0, 0, 347, 218);
INSERT INTO public.who_global_data VALUES (82049, 0, 0, 0, 0, 347, 43);
INSERT INTO public.who_global_data VALUES (82050, 0, 0, 0, 0, 347, 49);
INSERT INTO public.who_global_data VALUES (82051, 0, 0, 0, 0, 347, 1);
INSERT INTO public.who_global_data VALUES (82052, 0, 0, 0, 0, 347, 48);
INSERT INTO public.who_global_data VALUES (82053, 0, 0, 0, 0, 347, 232);
INSERT INTO public.who_global_data VALUES (82054, 0, 0, 0, 0, 347, 175);
INSERT INTO public.who_global_data VALUES (82055, 0, 0, 0, 0, 347, 21);
INSERT INTO public.who_global_data VALUES (82056, 0, 0, 0, 0, 347, 156);
INSERT INTO public.who_global_data VALUES (82057, 0, 0, 0, 0, 347, 95);
INSERT INTO public.who_global_data VALUES (82058, 0, 0, 0, 0, 347, 177);
INSERT INTO public.who_global_data VALUES (82059, 0, 0, 0, 0, 347, 210);
INSERT INTO public.who_global_data VALUES (82060, 0, 0, 0, 0, 347, 120);
INSERT INTO public.who_global_data VALUES (82061, 0, 0, 0, 0, 347, 135);
INSERT INTO public.who_global_data VALUES (82062, 0, 0, 0, 0, 347, 206);
INSERT INTO public.who_global_data VALUES (82063, 0, 0, 0, 0, 347, 189);
INSERT INTO public.who_global_data VALUES (82064, 0, 5, 0, 0, 347, 129);
INSERT INTO public.who_global_data VALUES (82065, 0, 0, 0, 0, 347, 121);
INSERT INTO public.who_global_data VALUES (82066, 0, 0, 0, 0, 347, 59);
INSERT INTO public.who_global_data VALUES (82067, 0, 0, 0, 0, 347, 96);
INSERT INTO public.who_global_data VALUES (82068, 0, 0, 0, 0, 347, 41);
INSERT INTO public.who_global_data VALUES (82069, 0, 0, 0, 0, 347, 216);
INSERT INTO public.who_global_data VALUES (82070, 0, 0, 0, 0, 347, 236);
INSERT INTO public.who_global_data VALUES (82071, 0, 0, 0, 0, 347, 150);
INSERT INTO public.who_global_data VALUES (82072, 0, 0, 0, 0, 347, 61);
INSERT INTO public.who_global_data VALUES (82073, 0, 0, 0, 0, 347, 7);
INSERT INTO public.who_global_data VALUES (82074, 0, 1, 0, 0, 347, 169);
INSERT INTO public.who_global_data VALUES (82075, 0, 12, 0, 1, 347, 28);
INSERT INTO public.who_global_data VALUES (82076, 0, 0, 0, 0, 347, 85);
INSERT INTO public.who_global_data VALUES (82077, 0, 0, 0, 0, 347, 211);
INSERT INTO public.who_global_data VALUES (82078, 0, 0, 0, 0, 347, 60);
INSERT INTO public.who_global_data VALUES (82079, 0, 0, 0, 0, 347, 3);
INSERT INTO public.who_global_data VALUES (82080, 0, 0, 0, 0, 347, 11);
INSERT INTO public.who_global_data VALUES (82081, 0, 15, 0, 0, 347, 89);
INSERT INTO public.who_global_data VALUES (82082, 0, 0, 0, 0, 347, 24);
INSERT INTO public.who_global_data VALUES (82083, 0, 0, 0, 0, 347, 162);
INSERT INTO public.who_global_data VALUES (82084, 0, 0, 0, 0, 347, 100);
INSERT INTO public.who_global_data VALUES (82085, 0, 0, 0, 0, 347, 47);
INSERT INTO public.who_global_data VALUES (82086, 0, 0, 0, 0, 347, 29);
INSERT INTO public.who_global_data VALUES (82087, 0, 0, 0, 0, 347, 40);
INSERT INTO public.who_global_data VALUES (82088, 0, 0, 0, 0, 347, 222);
INSERT INTO public.who_global_data VALUES (82089, 0, 0, 0, 0, 347, 132);
INSERT INTO public.who_global_data VALUES (82090, 0, 0, 0, 0, 347, 130);
INSERT INTO public.who_global_data VALUES (82091, 0, 0, 0, 0, 347, 234);
INSERT INTO public.who_global_data VALUES (82092, 0, 0, 0, 0, 347, 23);
INSERT INTO public.who_global_data VALUES (82093, 0, 0, 0, 0, 347, 192);
INSERT INTO public.who_global_data VALUES (82094, 0, 0, 0, 0, 347, 69);
INSERT INTO public.who_global_data VALUES (82095, 0, 0, 0, 0, 347, 187);
INSERT INTO public.who_global_data VALUES (82096, 0, 0, 0, 0, 347, 230);
INSERT INTO public.who_global_data VALUES (82097, 0, 0, 0, 0, 347, 77);
INSERT INTO public.who_global_data VALUES (82098, 0, 0, 0, 0, 347, 9);
INSERT INTO public.who_global_data VALUES (82099, 0, 7, 0, 0, 347, 74);
INSERT INTO public.who_global_data VALUES (82100, 0, 0, 0, 0, 347, 224);
INSERT INTO public.who_global_data VALUES (82101, 34, 99, 3, 15, 347, 199);
INSERT INTO public.who_global_data VALUES (82102, 4, 9, 0, 0, 347, 190);
INSERT INTO public.who_global_data VALUES (82103, 0, 0, 0, 0, 347, 12);
INSERT INTO public.who_global_data VALUES (82104, 0, 0, 0, 0, 347, 104);
INSERT INTO public.who_global_data VALUES (82105, 0, 1, 0, 0, 347, 153);
INSERT INTO public.who_global_data VALUES (82106, 97, 229, 4, 6, 347, 91);
INSERT INTO public.who_global_data VALUES (82107, 0, 0, 0, 0, 347, 215);
INSERT INTO public.who_global_data VALUES (82108, 1, 161, 0, 1, 347, 84);
INSERT INTO public.who_global_data VALUES (82109, 0, 0, 0, 0, 347, 231);
INSERT INTO public.who_global_data VALUES (82110, 0, 0, 0, 0, 347, 196);
INSERT INTO public.who_global_data VALUES (82111, 0, 0, 0, 0, 347, 105);
INSERT INTO public.who_global_data VALUES (82112, 0, 0, 0, 0, 347, 122);
INSERT INTO public.who_global_data VALUES (82113, 0, 0, 0, 0, 347, 159);
INSERT INTO public.who_global_data VALUES (82114, 0, 0, 0, 0, 347, 75);
INSERT INTO public.who_global_data VALUES (82115, 4, 13, 0, 0, 347, 27);
INSERT INTO public.who_global_data VALUES (82116, 0, 0, 0, 0, 347, 54);
INSERT INTO public.who_global_data VALUES (82117, 0, 0, 0, 0, 347, 226);
INSERT INTO public.who_global_data VALUES (82118, 0, 0, 0, 0, 347, 79);
INSERT INTO public.who_global_data VALUES (82119, 0, 5, 0, 0, 347, 56);
INSERT INTO public.who_global_data VALUES (82120, 0, 0, 0, 0, 347, 117);
INSERT INTO public.who_global_data VALUES (82121, 0, 0, 0, 0, 347, 152);
INSERT INTO public.who_global_data VALUES (82122, 0, 0, 0, 0, 347, 16);
INSERT INTO public.who_global_data VALUES (82123, 0, 0, 0, 0, 347, 10);
INSERT INTO public.who_global_data VALUES (82124, 0, 0, 0, 0, 347, 201);
INSERT INTO public.who_global_data VALUES (82125, 0, 0, 0, 0, 347, 174);
INSERT INTO public.who_global_data VALUES (82126, 0, 0, 0, 0, 347, 119);
INSERT INTO public.who_global_data VALUES (82127, 0, 0, 0, 0, 347, 168);
INSERT INTO public.who_global_data VALUES (82128, 0, 26, 0, 0, 347, 99);
INSERT INTO public.who_global_data VALUES (82129, 0, 0, 0, 0, 347, 171);
INSERT INTO public.who_global_data VALUES (82130, 0, 0, 0, 0, 347, 87);
INSERT INTO public.who_global_data VALUES (82131, 0, 0, 0, 0, 347, 123);
INSERT INTO public.who_global_data VALUES (82132, 0, 0, 0, 0, 347, 151);
INSERT INTO public.who_global_data VALUES (82133, 0, 0, 0, 0, 347, 213);
INSERT INTO public.who_global_data VALUES (82134, 0, 0, 0, 0, 347, 118);
INSERT INTO public.who_global_data VALUES (82135, 0, 0, 0, 0, 347, 134);
INSERT INTO public.who_global_data VALUES (82136, 0, 0, 0, 0, 347, 65);
INSERT INTO public.who_global_data VALUES (82137, 0, 0, 0, 0, 347, 102);
INSERT INTO public.who_global_data VALUES (82138, 0, 0, 0, 0, 347, 223);
INSERT INTO public.who_global_data VALUES (82139, 0, 0, 0, 0, 347, 4);
INSERT INTO public.who_global_data VALUES (82140, 0, 0, 0, 0, 347, 146);
INSERT INTO public.who_global_data VALUES (82141, 0, 0, 0, 0, 347, 31);
INSERT INTO public.who_global_data VALUES (82142, 0, 0, 0, 0, 347, 127);
INSERT INTO public.who_global_data VALUES (82143, 0, 0, 0, 0, 347, 22);
INSERT INTO public.who_global_data VALUES (82144, 0, 0, 0, 0, 347, 115);
INSERT INTO public.who_global_data VALUES (82145, 0, 0, 0, 0, 347, 106);
INSERT INTO public.who_global_data VALUES (82146, 0, 0, 0, 0, 347, 90);
INSERT INTO public.who_global_data VALUES (82147, 0, 0, 0, 0, 347, 70);
INSERT INTO public.who_global_data VALUES (82148, 0, 5, 0, 0, 347, 46);
INSERT INTO public.who_global_data VALUES (82149, 0, 0, 0, 0, 347, 139);
INSERT INTO public.who_global_data VALUES (82150, 0, 0, 0, 0, 347, 42);
INSERT INTO public.who_global_data VALUES (82151, 0, 0, 0, 0, 347, 80);
INSERT INTO public.who_global_data VALUES (82152, 0, 0, 0, 0, 347, 203);
INSERT INTO public.who_global_data VALUES (82153, 0, 0, 0, 0, 347, 136);
INSERT INTO public.who_global_data VALUES (82154, 0, 0, 0, 0, 347, 63);
INSERT INTO public.who_global_data VALUES (82155, 0, 0, 0, 0, 347, 17);
INSERT INTO public.who_global_data VALUES (82156, 0, 0, 0, 0, 347, 172);
INSERT INTO public.who_global_data VALUES (82157, 0, 0, 0, 0, 347, 109);
INSERT INTO public.who_global_data VALUES (82158, 0, 0, 0, 0, 347, 200);
INSERT INTO public.who_global_data VALUES (82159, 0, 0, 0, 0, 347, 93);
INSERT INTO public.who_global_data VALUES (82160, 2, 8, 0, 0, 347, 5);
INSERT INTO public.who_global_data VALUES (82161, 0, 695, 1, 4, 347, 214);
INSERT INTO public.who_global_data VALUES (82162, 0, 0, 0, 0, 347, 204);
INSERT INTO public.who_global_data VALUES (82163, 0, 0, 0, 0, 347, 198);
INSERT INTO public.who_global_data VALUES (82164, 0, 0, 0, 0, 347, 173);
INSERT INTO public.who_global_data VALUES (82165, 0, 0, 0, 0, 347, 229);
INSERT INTO public.who_global_data VALUES (82166, 0, 0, 0, 0, 347, 76);
INSERT INTO public.who_global_data VALUES (82167, 0, 0, 0, 0, 347, 138);
INSERT INTO public.who_global_data VALUES (82168, 0, 7, 0, 1, 347, 98);
INSERT INTO public.who_global_data VALUES (82169, 0, 0, 0, 0, 347, 103);
INSERT INTO public.who_global_data VALUES (82170, 0, 0, 0, 0, 347, 225);
INSERT INTO public.who_global_data VALUES (82171, 0, 0, 0, 0, 347, 131);
INSERT INTO public.who_global_data VALUES (82172, 0, 0, 0, 0, 347, 235);
INSERT INTO public.who_global_data VALUES (82173, 0, 0, 0, 0, 347, 137);
INSERT INTO public.who_global_data VALUES (82174, 144, 981, 3, 10, 347, 81);
INSERT INTO public.who_global_data VALUES (82175, 0, 0, 0, 0, 347, 182);
INSERT INTO public.who_global_data VALUES (82176, 0, 0, 0, 0, 347, 145);
INSERT INTO public.who_global_data VALUES (82177, 0, 0, 0, 0, 347, 26);
INSERT INTO public.who_global_data VALUES (82178, 0, 2, 0, 0, 347, 170);
INSERT INTO public.who_global_data VALUES (82179, 0, 0, 0, 0, 347, 191);
INSERT INTO public.who_global_data VALUES (82180, 0, 0, 0, 0, 347, 221);
INSERT INTO public.who_global_data VALUES (82181, 0, 0, 0, 0, 347, 64);
INSERT INTO public.who_global_data VALUES (82182, 0, 0, 0, 0, 347, 116);
INSERT INTO public.who_global_data VALUES (82183, 0, 0, 0, 0, 347, 128);
INSERT INTO public.who_global_data VALUES (82184, 0, 0, 0, 0, 347, 6);
INSERT INTO public.who_global_data VALUES (82185, 0, 0, 0, 0, 347, 227);
INSERT INTO public.who_global_data VALUES (82186, 0, 0, 0, 0, 347, 68);
INSERT INTO public.who_global_data VALUES (82187, 0, 0, 0, 0, 347, 184);
INSERT INTO public.who_global_data VALUES (82188, 0, 0, 0, 0, 347, 82);
INSERT INTO public.who_global_data VALUES (82189, 0, 0, 0, 0, 347, 149);
INSERT INTO public.who_global_data VALUES (82190, 0, 0, 0, 0, 347, 197);
INSERT INTO public.who_global_data VALUES (82191, 0, 0, 0, 0, 347, 78);
INSERT INTO public.who_global_data VALUES (82192, 0, 0, 0, 0, 347, 233);
INSERT INTO public.who_global_data VALUES (82193, 0, 0, 0, 0, 347, 133);
INSERT INTO public.who_global_data VALUES (82194, 0, 0, 0, 0, 347, 35);
INSERT INTO public.who_global_data VALUES (82195, 0, 0, 0, 0, 347, 114);
INSERT INTO public.who_global_data VALUES (82196, 1, 95, 0, 0, 347, 237);
INSERT INTO public.who_global_data VALUES (82197, 0, 0, 0, 0, 347, 55);
INSERT INTO public.who_global_data VALUES (82198, 0, 0, 0, 0, 347, 176);
INSERT INTO public.who_global_data VALUES (82199, 0, 0, 0, 0, 347, 202);
INSERT INTO public.who_global_data VALUES (82200, 0, 0, 0, 0, 347, 155);
INSERT INTO public.who_global_data VALUES (82201, 0, 0, 0, 0, 347, 32);
INSERT INTO public.who_global_data VALUES (82202, 0, 0, 0, 0, 347, 220);
INSERT INTO public.who_global_data VALUES (82203, 0, 0, 0, 0, 347, 30);
INSERT INTO public.who_global_data VALUES (82204, 0, 0, 0, 0, 347, 147);
INSERT INTO public.who_global_data VALUES (82205, 2, 32, 0, 1, 347, 208);
INSERT INTO public.who_global_data VALUES (82206, 0, 5, 0, 0, 347, 45);
INSERT INTO public.who_global_data VALUES (82207, 0, 0, 0, 0, 347, 110);
INSERT INTO public.who_global_data VALUES (82208, 0, 0, 0, 0, 347, 88);
INSERT INTO public.who_global_data VALUES (82209, 0, 1, 0, 0, 347, 51);
INSERT INTO public.who_global_data VALUES (82210, 0, 1, 0, 0, 347, 209);
INSERT INTO public.who_global_data VALUES (82211, 0, 0, 0, 0, 347, 205);
INSERT INTO public.who_global_data VALUES (82212, 0, 0, 0, 0, 347, 18);
INSERT INTO public.who_global_data VALUES (82213, 2, 41, 0, 0, 347, 72);
INSERT INTO public.who_global_data VALUES (82214, 0, 11, 0, 0, 347, 44);
INSERT INTO public.who_global_data VALUES (82215, 0, 0, 0, 0, 347, 15);
INSERT INTO public.who_global_data VALUES (82216, 0, 0, 0, 0, 347, 25);
INSERT INTO public.who_global_data VALUES (82217, 0, 0, 0, 0, 347, 179);
INSERT INTO public.who_global_data VALUES (82218, 0, 0, 0, 0, 347, 34);
INSERT INTO public.who_global_data VALUES (82219, 0, 0, 0, 0, 347, 207);
INSERT INTO public.who_global_data VALUES (82220, 0, 0, 0, 0, 347, 166);
INSERT INTO public.who_global_data VALUES (82221, 0, 0, 0, 0, 347, 126);
INSERT INTO public.who_global_data VALUES (82222, 0, 0, 0, 0, 347, 97);
INSERT INTO public.who_global_data VALUES (82223, 0, 0, 0, 0, 347, 36);
INSERT INTO public.who_global_data VALUES (82224, 0, 0, 0, 0, 347, 125);
INSERT INTO public.who_global_data VALUES (82225, 0, 0, 0, 0, 347, 124);
INSERT INTO public.who_global_data VALUES (82226, 0, 0, 0, 0, 347, 185);
INSERT INTO public.who_global_data VALUES (82227, 0, 17, 0, 0, 347, 194);
INSERT INTO public.who_global_data VALUES (82228, 0, 0, 0, 0, 347, 144);
INSERT INTO public.who_global_data VALUES (82229, 0, 57, 0, 0, 347, 19);
INSERT INTO public.who_global_data VALUES (82230, 0, 0, 0, 0, 347, 217);
INSERT INTO public.who_global_data VALUES (82231, 0, 0, 0, 0, 347, 148);
INSERT INTO public.who_global_data VALUES (82232, 0, 0, 0, 0, 347, 86);
INSERT INTO public.who_global_data VALUES (82233, 0, 0, 0, 0, 347, 13);
INSERT INTO public.who_global_data VALUES (82234, 0, 0, 0, 0, 347, 157);
INSERT INTO public.who_global_data VALUES (82235, 0, 20, 0, 0, 347, 8);
INSERT INTO public.who_global_data VALUES (82236, 0, 0, 0, 0, 347, 73);
INSERT INTO public.who_global_data VALUES (82237, 0, 0, 0, 0, 347, 101);
INSERT INTO public.who_global_data VALUES (82238, 0, 0, 0, 0, 347, 165);
INSERT INTO public.who_global_data VALUES (82239, 0, 0, 0, 0, 347, 14);
INSERT INTO public.who_global_data VALUES (82240, 5, 5, 0, 0, 348, 193);
INSERT INTO public.who_global_data VALUES (82241, 0, 0, 0, 0, 348, 113);
INSERT INTO public.who_global_data VALUES (82242, 0, 0, 0, 0, 348, 143);
INSERT INTO public.who_global_data VALUES (82243, 0, 0, 0, 0, 348, 219);
INSERT INTO public.who_global_data VALUES (82244, 0, 0, 0, 0, 348, 186);
INSERT INTO public.who_global_data VALUES (82245, 0, 0, 0, 0, 348, 52);
INSERT INTO public.who_global_data VALUES (82246, 0, 0, 0, 0, 348, 180);
INSERT INTO public.who_global_data VALUES (82247, 0, 0, 0, 0, 348, 167);
INSERT INTO public.who_global_data VALUES (82248, 0, 0, 0, 0, 348, 154);
INSERT INTO public.who_global_data VALUES (82249, 0, 0, 0, 0, 348, 94);
INSERT INTO public.who_global_data VALUES (82250, 0, 0, 0, 0, 348, 66);
INSERT INTO public.who_global_data VALUES (82251, 0, 26, 0, 0, 348, 58);
INSERT INTO public.who_global_data VALUES (82252, 0, 0, 0, 0, 348, 163);
INSERT INTO public.who_global_data VALUES (82253, 0, 0, 0, 0, 348, 37);
INSERT INTO public.who_global_data VALUES (82254, 0, 0, 0, 0, 348, 142);
INSERT INTO public.who_global_data VALUES (82255, 6, 6, 0, 0, 348, 83);
INSERT INTO public.who_global_data VALUES (82256, 0, 0, 0, 0, 348, 228);
INSERT INTO public.who_global_data VALUES (82257, 0, 0, 0, 0, 348, 188);
INSERT INTO public.who_global_data VALUES (82258, 0, 0, 0, 0, 348, 62);
INSERT INTO public.who_global_data VALUES (82259, 0, 1, 0, 0, 348, 160);
INSERT INTO public.who_global_data VALUES (82260, 0, 0, 0, 0, 348, 50);
INSERT INTO public.who_global_data VALUES (82261, 0, 0, 0, 0, 348, 33);
INSERT INTO public.who_global_data VALUES (82262, 0, 0, 0, 0, 348, 183);
INSERT INTO public.who_global_data VALUES (82263, 0, 0, 0, 0, 348, 92);
INSERT INTO public.who_global_data VALUES (82264, 0, 0, 0, 0, 348, 158);
INSERT INTO public.who_global_data VALUES (82265, 0, 0, 0, 0, 348, 67);
INSERT INTO public.who_global_data VALUES (82266, 0, 0, 0, 0, 348, 57);
INSERT INTO public.who_global_data VALUES (82267, 0, 0, 0, 0, 348, 38);
INSERT INTO public.who_global_data VALUES (82268, 0, 0, 0, 0, 348, 141);
INSERT INTO public.who_global_data VALUES (82269, 0, 0, 0, 0, 348, 178);
INSERT INTO public.who_global_data VALUES (82270, 0, 0, 0, 0, 348, 108);
INSERT INTO public.who_global_data VALUES (82271, 0, 0, 0, 0, 348, 39);
INSERT INTO public.who_global_data VALUES (82272, 0, 0, 0, 0, 348, 2);
INSERT INTO public.who_global_data VALUES (82273, 0, 0, 0, 0, 348, 195);
INSERT INTO public.who_global_data VALUES (82274, 0, 0, 0, 0, 348, 107);
INSERT INTO public.who_global_data VALUES (82275, 0, 5, 0, 0, 348, 161);
INSERT INTO public.who_global_data VALUES (82276, 0, 0, 0, 0, 348, 212);
INSERT INTO public.who_global_data VALUES (82277, 1, 14, 0, 0, 348, 181);
INSERT INTO public.who_global_data VALUES (82278, 0, 0, 0, 0, 348, 53);
INSERT INTO public.who_global_data VALUES (82279, 0, 0, 0, 0, 348, 164);
INSERT INTO public.who_global_data VALUES (82280, 0, 0, 0, 0, 348, 140);
INSERT INTO public.who_global_data VALUES (82281, 0, 0, 0, 0, 348, 20);
INSERT INTO public.who_global_data VALUES (82282, 221, 77266, 150, 2595, 348, 112);
INSERT INTO public.who_global_data VALUES (82283, 0, 0, 0, 0, 348, 111);
INSERT INTO public.who_global_data VALUES (82284, 0, 0, 0, 0, 348, 71);
INSERT INTO public.who_global_data VALUES (82285, 0, 0, 0, 0, 348, 218);
INSERT INTO public.who_global_data VALUES (82286, 0, 0, 0, 0, 348, 43);
INSERT INTO public.who_global_data VALUES (82287, 0, 0, 0, 0, 348, 49);
INSERT INTO public.who_global_data VALUES (82288, 0, 0, 0, 0, 348, 1);
INSERT INTO public.who_global_data VALUES (82289, 0, 0, 0, 0, 348, 48);
INSERT INTO public.who_global_data VALUES (82290, 0, 0, 0, 0, 348, 232);
INSERT INTO public.who_global_data VALUES (82291, 0, 0, 0, 0, 348, 175);
INSERT INTO public.who_global_data VALUES (82292, 0, 0, 0, 0, 348, 21);
INSERT INTO public.who_global_data VALUES (82293, 0, 0, 0, 0, 348, 156);
INSERT INTO public.who_global_data VALUES (82294, 0, 0, 0, 0, 348, 95);
INSERT INTO public.who_global_data VALUES (82295, 0, 0, 0, 0, 348, 177);
INSERT INTO public.who_global_data VALUES (82296, 0, 0, 0, 0, 348, 210);
INSERT INTO public.who_global_data VALUES (82297, 0, 0, 0, 0, 348, 120);
INSERT INTO public.who_global_data VALUES (82298, 0, 0, 0, 0, 348, 135);
INSERT INTO public.who_global_data VALUES (82299, 0, 0, 0, 0, 348, 206);
INSERT INTO public.who_global_data VALUES (82300, 0, 0, 0, 0, 348, 189);
INSERT INTO public.who_global_data VALUES (82301, 0, 5, 0, 0, 348, 129);
INSERT INTO public.who_global_data VALUES (82302, 0, 0, 0, 0, 348, 121);
INSERT INTO public.who_global_data VALUES (82303, 0, 0, 0, 0, 348, 59);
INSERT INTO public.who_global_data VALUES (82304, 0, 0, 0, 0, 348, 96);
INSERT INTO public.who_global_data VALUES (82305, 0, 0, 0, 0, 348, 41);
INSERT INTO public.who_global_data VALUES (82306, 0, 0, 0, 0, 348, 216);
INSERT INTO public.who_global_data VALUES (82307, 0, 0, 0, 0, 348, 236);
INSERT INTO public.who_global_data VALUES (82308, 0, 0, 0, 0, 348, 150);
INSERT INTO public.who_global_data VALUES (82309, 0, 0, 0, 0, 348, 61);
INSERT INTO public.who_global_data VALUES (82310, 0, 0, 0, 0, 348, 7);
INSERT INTO public.who_global_data VALUES (82311, 0, 1, 0, 0, 348, 169);
INSERT INTO public.who_global_data VALUES (82312, 0, 12, 0, 1, 348, 28);
INSERT INTO public.who_global_data VALUES (82313, 0, 0, 0, 0, 348, 85);
INSERT INTO public.who_global_data VALUES (82314, 0, 0, 0, 0, 348, 211);
INSERT INTO public.who_global_data VALUES (82315, 0, 0, 0, 0, 348, 60);
INSERT INTO public.who_global_data VALUES (82316, 0, 0, 0, 0, 348, 3);
INSERT INTO public.who_global_data VALUES (82317, 0, 0, 0, 0, 348, 11);
INSERT INTO public.who_global_data VALUES (82318, 0, 15, 0, 0, 348, 89);
INSERT INTO public.who_global_data VALUES (82319, 0, 0, 0, 0, 348, 24);
INSERT INTO public.who_global_data VALUES (82320, 0, 0, 0, 0, 348, 162);
INSERT INTO public.who_global_data VALUES (82321, 0, 0, 0, 0, 348, 100);
INSERT INTO public.who_global_data VALUES (82322, 0, 0, 0, 0, 348, 47);
INSERT INTO public.who_global_data VALUES (82323, 0, 0, 0, 0, 348, 29);
INSERT INTO public.who_global_data VALUES (82324, 0, 0, 0, 0, 348, 40);
INSERT INTO public.who_global_data VALUES (82325, 0, 0, 0, 0, 348, 222);
INSERT INTO public.who_global_data VALUES (82326, 0, 0, 0, 0, 348, 132);
INSERT INTO public.who_global_data VALUES (82327, 0, 0, 0, 0, 348, 130);
INSERT INTO public.who_global_data VALUES (82328, 0, 0, 0, 0, 348, 234);
INSERT INTO public.who_global_data VALUES (82329, 0, 0, 0, 0, 348, 23);
INSERT INTO public.who_global_data VALUES (82330, 0, 0, 0, 0, 348, 192);
INSERT INTO public.who_global_data VALUES (82331, 0, 0, 0, 0, 348, 69);
INSERT INTO public.who_global_data VALUES (82332, 0, 0, 0, 0, 348, 187);
INSERT INTO public.who_global_data VALUES (82333, 0, 0, 0, 0, 348, 230);
INSERT INTO public.who_global_data VALUES (82334, 0, 0, 0, 0, 348, 77);
INSERT INTO public.who_global_data VALUES (82335, 0, 0, 0, 0, 348, 9);
INSERT INTO public.who_global_data VALUES (82336, 0, 7, 0, 0, 348, 74);
INSERT INTO public.who_global_data VALUES (82337, 0, 0, 0, 0, 348, 224);
INSERT INTO public.who_global_data VALUES (82338, 18, 65, 4, 12, 348, 199);
INSERT INTO public.who_global_data VALUES (82339, 5, 5, 0, 0, 348, 190);
INSERT INTO public.who_global_data VALUES (82340, 0, 0, 0, 0, 348, 12);
INSERT INTO public.who_global_data VALUES (82341, 0, 0, 0, 0, 348, 104);
INSERT INTO public.who_global_data VALUES (82342, 0, 1, 0, 0, 348, 153);
INSERT INTO public.who_global_data VALUES (82343, 53, 132, 0, 2, 348, 91);
INSERT INTO public.who_global_data VALUES (82344, 0, 0, 0, 0, 348, 215);
INSERT INTO public.who_global_data VALUES (82345, 12, 160, 0, 1, 348, 84);
INSERT INTO public.who_global_data VALUES (82346, 0, 0, 0, 0, 348, 231);
INSERT INTO public.who_global_data VALUES (82347, 0, 0, 0, 0, 348, 196);
INSERT INTO public.who_global_data VALUES (82348, 0, 0, 0, 0, 348, 105);
INSERT INTO public.who_global_data VALUES (82349, 0, 0, 0, 0, 348, 122);
INSERT INTO public.who_global_data VALUES (82350, 0, 0, 0, 0, 348, 159);
INSERT INTO public.who_global_data VALUES (82351, 0, 0, 0, 0, 348, 75);
INSERT INTO public.who_global_data VALUES (82352, 9, 9, 0, 0, 348, 27);
INSERT INTO public.who_global_data VALUES (82353, 0, 0, 0, 0, 348, 54);
INSERT INTO public.who_global_data VALUES (82354, 0, 0, 0, 0, 348, 226);
INSERT INTO public.who_global_data VALUES (82355, 0, 0, 0, 0, 348, 79);
INSERT INTO public.who_global_data VALUES (82356, 0, 5, 0, 0, 348, 56);
INSERT INTO public.who_global_data VALUES (82357, 0, 0, 0, 0, 348, 117);
INSERT INTO public.who_global_data VALUES (82358, 0, 0, 0, 0, 348, 152);
INSERT INTO public.who_global_data VALUES (82359, 0, 0, 0, 0, 348, 16);
INSERT INTO public.who_global_data VALUES (82360, 0, 0, 0, 0, 348, 10);
INSERT INTO public.who_global_data VALUES (82361, 0, 0, 0, 0, 348, 201);
INSERT INTO public.who_global_data VALUES (82362, 0, 0, 0, 0, 348, 174);
INSERT INTO public.who_global_data VALUES (82363, 0, 0, 0, 0, 348, 119);
INSERT INTO public.who_global_data VALUES (82364, 0, 0, 0, 0, 348, 168);
INSERT INTO public.who_global_data VALUES (82365, 0, 26, 0, 0, 348, 99);
INSERT INTO public.who_global_data VALUES (82366, 0, 0, 0, 0, 348, 171);
INSERT INTO public.who_global_data VALUES (82367, 0, 0, 0, 0, 348, 87);
INSERT INTO public.who_global_data VALUES (82368, 0, 0, 0, 0, 348, 123);
INSERT INTO public.who_global_data VALUES (82369, 0, 0, 0, 0, 348, 151);
INSERT INTO public.who_global_data VALUES (82370, 0, 0, 0, 0, 348, 213);
INSERT INTO public.who_global_data VALUES (82371, 0, 0, 0, 0, 348, 118);
INSERT INTO public.who_global_data VALUES (82372, 0, 0, 0, 0, 348, 134);
INSERT INTO public.who_global_data VALUES (82373, 0, 0, 0, 0, 348, 65);
INSERT INTO public.who_global_data VALUES (82374, 0, 0, 0, 0, 348, 102);
INSERT INTO public.who_global_data VALUES (82375, 0, 0, 0, 0, 348, 223);
INSERT INTO public.who_global_data VALUES (82376, 0, 0, 0, 0, 348, 4);
INSERT INTO public.who_global_data VALUES (82377, 0, 0, 0, 0, 348, 146);
INSERT INTO public.who_global_data VALUES (82378, 0, 0, 0, 0, 348, 31);
INSERT INTO public.who_global_data VALUES (82379, 0, 0, 0, 0, 348, 127);
INSERT INTO public.who_global_data VALUES (82380, 0, 0, 0, 0, 348, 22);
INSERT INTO public.who_global_data VALUES (82381, 0, 0, 0, 0, 348, 115);
INSERT INTO public.who_global_data VALUES (82382, 0, 0, 0, 0, 348, 106);
INSERT INTO public.who_global_data VALUES (82383, 0, 0, 0, 0, 348, 90);
INSERT INTO public.who_global_data VALUES (82384, 0, 0, 0, 0, 348, 70);
INSERT INTO public.who_global_data VALUES (82385, 0, 5, 0, 0, 348, 46);
INSERT INTO public.who_global_data VALUES (82386, 0, 0, 0, 0, 348, 139);
INSERT INTO public.who_global_data VALUES (82387, 0, 0, 0, 0, 348, 42);
INSERT INTO public.who_global_data VALUES (82388, 0, 0, 0, 0, 348, 80);
INSERT INTO public.who_global_data VALUES (82389, 0, 0, 0, 0, 348, 203);
INSERT INTO public.who_global_data VALUES (82390, 0, 0, 0, 0, 348, 136);
INSERT INTO public.who_global_data VALUES (82391, 0, 0, 0, 0, 348, 63);
INSERT INTO public.who_global_data VALUES (82392, 0, 0, 0, 0, 348, 17);
INSERT INTO public.who_global_data VALUES (82393, 0, 0, 0, 0, 348, 172);
INSERT INTO public.who_global_data VALUES (82394, 0, 0, 0, 0, 348, 109);
INSERT INTO public.who_global_data VALUES (82395, 0, 0, 0, 0, 348, 200);
INSERT INTO public.who_global_data VALUES (82396, 0, 0, 0, 0, 348, 93);
INSERT INTO public.who_global_data VALUES (82397, 6, 6, 0, 0, 348, 5);
INSERT INTO public.who_global_data VALUES (82398, 0, 695, 0, 3, 348, 214);
INSERT INTO public.who_global_data VALUES (82399, 0, 0, 0, 0, 348, 204);
INSERT INTO public.who_global_data VALUES (82400, 0, 0, 0, 0, 348, 198);
INSERT INTO public.who_global_data VALUES (82401, 0, 0, 0, 0, 348, 173);
INSERT INTO public.who_global_data VALUES (82402, 0, 0, 0, 0, 348, 229);
INSERT INTO public.who_global_data VALUES (82403, 0, 0, 0, 0, 348, 76);
INSERT INTO public.who_global_data VALUES (82404, 0, 0, 0, 0, 348, 138);
INSERT INTO public.who_global_data VALUES (82405, 0, 7, 0, 1, 348, 98);
INSERT INTO public.who_global_data VALUES (82406, 0, 0, 0, 0, 348, 103);
INSERT INTO public.who_global_data VALUES (82407, 0, 0, 0, 0, 348, 225);
INSERT INTO public.who_global_data VALUES (82408, 0, 0, 0, 0, 348, 131);
INSERT INTO public.who_global_data VALUES (82409, 0, 0, 0, 0, 348, 235);
INSERT INTO public.who_global_data VALUES (82410, 0, 0, 0, 0, 348, 137);
INSERT INTO public.who_global_data VALUES (82411, 231, 837, 5, 7, 348, 81);
INSERT INTO public.who_global_data VALUES (82412, 0, 0, 0, 0, 348, 182);
INSERT INTO public.who_global_data VALUES (82413, 0, 0, 0, 0, 348, 145);
INSERT INTO public.who_global_data VALUES (82414, 0, 0, 0, 0, 348, 26);
INSERT INTO public.who_global_data VALUES (82415, 0, 2, 0, 0, 348, 170);
INSERT INTO public.who_global_data VALUES (82416, 0, 0, 0, 0, 348, 191);
INSERT INTO public.who_global_data VALUES (82417, 0, 0, 0, 0, 348, 221);
INSERT INTO public.who_global_data VALUES (82418, 0, 0, 0, 0, 348, 64);
INSERT INTO public.who_global_data VALUES (82419, 0, 0, 0, 0, 348, 116);
INSERT INTO public.who_global_data VALUES (82420, 0, 0, 0, 0, 348, 128);
INSERT INTO public.who_global_data VALUES (82421, 0, 0, 0, 0, 348, 6);
INSERT INTO public.who_global_data VALUES (82422, 0, 0, 0, 0, 348, 227);
INSERT INTO public.who_global_data VALUES (82423, 0, 0, 0, 0, 348, 68);
INSERT INTO public.who_global_data VALUES (82424, 0, 0, 0, 0, 348, 184);
INSERT INTO public.who_global_data VALUES (82425, 0, 0, 0, 0, 348, 82);
INSERT INTO public.who_global_data VALUES (82426, 0, 0, 0, 0, 348, 149);
INSERT INTO public.who_global_data VALUES (82427, 0, 0, 0, 0, 348, 197);
INSERT INTO public.who_global_data VALUES (82428, 0, 0, 0, 0, 348, 78);
INSERT INTO public.who_global_data VALUES (82429, 0, 0, 0, 0, 348, 233);
INSERT INTO public.who_global_data VALUES (82430, 0, 0, 0, 0, 348, 133);
INSERT INTO public.who_global_data VALUES (82431, 0, 0, 0, 0, 348, 35);
INSERT INTO public.who_global_data VALUES (82432, 0, 0, 0, 0, 348, 114);
INSERT INTO public.who_global_data VALUES (82433, 1, 94, 0, 0, 348, 237);
INSERT INTO public.who_global_data VALUES (82434, 0, 0, 0, 0, 348, 55);
INSERT INTO public.who_global_data VALUES (82435, 0, 0, 0, 0, 348, 176);
INSERT INTO public.who_global_data VALUES (82436, 0, 0, 0, 0, 348, 202);
INSERT INTO public.who_global_data VALUES (82437, 0, 0, 0, 0, 348, 155);
INSERT INTO public.who_global_data VALUES (82438, 0, 0, 0, 0, 348, 32);
INSERT INTO public.who_global_data VALUES (82439, 0, 0, 0, 0, 348, 220);
INSERT INTO public.who_global_data VALUES (82440, 0, 0, 0, 0, 348, 30);
INSERT INTO public.who_global_data VALUES (82441, 0, 0, 0, 0, 348, 147);
INSERT INTO public.who_global_data VALUES (82442, 1, 30, 0, 1, 348, 208);
INSERT INTO public.who_global_data VALUES (82443, 0, 5, 0, 0, 348, 45);
INSERT INTO public.who_global_data VALUES (82444, 0, 0, 0, 0, 348, 110);
INSERT INTO public.who_global_data VALUES (82445, 0, 0, 0, 0, 348, 88);
INSERT INTO public.who_global_data VALUES (82446, 0, 1, 0, 0, 348, 51);
INSERT INTO public.who_global_data VALUES (82447, 1, 1, 0, 0, 348, 209);
INSERT INTO public.who_global_data VALUES (82448, 0, 0, 0, 0, 348, 205);
INSERT INTO public.who_global_data VALUES (82449, 0, 0, 0, 0, 348, 18);
INSERT INTO public.who_global_data VALUES (82450, 0, 39, 0, 0, 348, 72);
INSERT INTO public.who_global_data VALUES (82451, 0, 11, 0, 0, 348, 44);
INSERT INTO public.who_global_data VALUES (82452, 0, 0, 0, 0, 348, 15);
INSERT INTO public.who_global_data VALUES (82453, 0, 0, 0, 0, 348, 25);
INSERT INTO public.who_global_data VALUES (82454, 0, 0, 0, 0, 348, 179);
INSERT INTO public.who_global_data VALUES (82455, 0, 0, 0, 0, 348, 34);
INSERT INTO public.who_global_data VALUES (82456, 0, 0, 0, 0, 348, 207);
INSERT INTO public.who_global_data VALUES (82457, 0, 0, 0, 0, 348, 166);
INSERT INTO public.who_global_data VALUES (82458, 0, 0, 0, 0, 348, 126);
INSERT INTO public.who_global_data VALUES (82459, 0, 0, 0, 0, 348, 97);
INSERT INTO public.who_global_data VALUES (82460, 0, 0, 0, 0, 348, 36);
INSERT INTO public.who_global_data VALUES (82461, 0, 0, 0, 0, 348, 125);
INSERT INTO public.who_global_data VALUES (82462, 0, 0, 0, 0, 348, 124);
INSERT INTO public.who_global_data VALUES (82463, 0, 0, 0, 0, 348, 185);
INSERT INTO public.who_global_data VALUES (82464, 0, 17, 0, 0, 348, 194);
INSERT INTO public.who_global_data VALUES (82465, 0, 0, 0, 0, 348, 144);
INSERT INTO public.who_global_data VALUES (82466, 18, 57, 0, 0, 348, 19);
INSERT INTO public.who_global_data VALUES (82467, 0, 0, 0, 0, 348, 217);
INSERT INTO public.who_global_data VALUES (82468, 0, 0, 0, 0, 348, 148);
INSERT INTO public.who_global_data VALUES (82469, 0, 0, 0, 0, 348, 86);
INSERT INTO public.who_global_data VALUES (82470, 0, 0, 0, 0, 348, 13);
INSERT INTO public.who_global_data VALUES (82471, 0, 0, 0, 0, 348, 157);
INSERT INTO public.who_global_data VALUES (82472, 0, 20, 0, 0, 348, 8);
INSERT INTO public.who_global_data VALUES (82473, 0, 0, 0, 0, 348, 73);
INSERT INTO public.who_global_data VALUES (82474, 0, 0, 0, 0, 348, 101);
INSERT INTO public.who_global_data VALUES (82475, 0, 0, 0, 0, 348, 165);
INSERT INTO public.who_global_data VALUES (82476, 0, 0, 0, 0, 348, 14);
INSERT INTO public.who_global_data VALUES (82477, 0, 0, 0, 0, 349, 193);
INSERT INTO public.who_global_data VALUES (82478, 0, 0, 0, 0, 349, 113);
INSERT INTO public.who_global_data VALUES (82479, 0, 0, 0, 0, 349, 143);
INSERT INTO public.who_global_data VALUES (82480, 0, 0, 0, 0, 349, 219);
INSERT INTO public.who_global_data VALUES (82481, 0, 0, 0, 0, 349, 186);
INSERT INTO public.who_global_data VALUES (82482, 0, 0, 0, 0, 349, 52);
INSERT INTO public.who_global_data VALUES (82483, 0, 0, 0, 0, 349, 180);
INSERT INTO public.who_global_data VALUES (82484, 0, 0, 0, 0, 349, 167);
INSERT INTO public.who_global_data VALUES (82485, 0, 0, 0, 0, 349, 154);
INSERT INTO public.who_global_data VALUES (82486, 0, 0, 0, 0, 349, 94);
INSERT INTO public.who_global_data VALUES (82487, 0, 0, 0, 0, 349, 66);
INSERT INTO public.who_global_data VALUES (82488, 1, 26, 0, 0, 349, 58);
INSERT INTO public.who_global_data VALUES (82489, 0, 0, 0, 0, 349, 163);
INSERT INTO public.who_global_data VALUES (82490, 0, 0, 0, 0, 349, 37);
INSERT INTO public.who_global_data VALUES (82491, 0, 0, 0, 0, 349, 142);
INSERT INTO public.who_global_data VALUES (82492, 0, 0, 0, 0, 349, 83);
INSERT INTO public.who_global_data VALUES (82493, 0, 0, 0, 0, 349, 228);
INSERT INTO public.who_global_data VALUES (82494, 0, 0, 0, 0, 349, 188);
INSERT INTO public.who_global_data VALUES (82495, 0, 0, 0, 0, 349, 62);
INSERT INTO public.who_global_data VALUES (82496, 0, 1, 0, 0, 349, 160);
INSERT INTO public.who_global_data VALUES (82497, 0, 0, 0, 0, 349, 50);
INSERT INTO public.who_global_data VALUES (82498, 0, 0, 0, 0, 349, 33);
INSERT INTO public.who_global_data VALUES (82499, 0, 0, 0, 0, 349, 183);
INSERT INTO public.who_global_data VALUES (82500, 0, 0, 0, 0, 349, 92);
INSERT INTO public.who_global_data VALUES (82501, 0, 0, 0, 0, 349, 158);
INSERT INTO public.who_global_data VALUES (82502, 0, 0, 0, 0, 349, 67);
INSERT INTO public.who_global_data VALUES (82503, 0, 0, 0, 0, 349, 57);
INSERT INTO public.who_global_data VALUES (82504, 0, 0, 0, 0, 349, 38);
INSERT INTO public.who_global_data VALUES (82505, 0, 0, 0, 0, 349, 141);
INSERT INTO public.who_global_data VALUES (82506, 0, 0, 0, 0, 349, 178);
INSERT INTO public.who_global_data VALUES (82507, 0, 0, 0, 0, 349, 108);
INSERT INTO public.who_global_data VALUES (82508, 0, 0, 0, 0, 349, 39);
INSERT INTO public.who_global_data VALUES (82509, 0, 0, 0, 0, 349, 2);
INSERT INTO public.who_global_data VALUES (82510, 0, 0, 0, 0, 349, 195);
INSERT INTO public.who_global_data VALUES (82511, 0, 0, 0, 0, 349, 107);
INSERT INTO public.who_global_data VALUES (82512, 0, 5, 0, 0, 349, 161);
INSERT INTO public.who_global_data VALUES (82513, 0, 0, 0, 0, 349, 212);
INSERT INTO public.who_global_data VALUES (82514, 0, 13, 0, 0, 349, 181);
INSERT INTO public.who_global_data VALUES (82515, 0, 0, 0, 0, 349, 53);
INSERT INTO public.who_global_data VALUES (82516, 0, 0, 0, 0, 349, 164);
INSERT INTO public.who_global_data VALUES (82517, 0, 0, 0, 0, 349, 140);
INSERT INTO public.who_global_data VALUES (82518, 0, 0, 0, 0, 349, 20);
INSERT INTO public.who_global_data VALUES (82519, 649, 77045, 97, 2445, 349, 112);
INSERT INTO public.who_global_data VALUES (82520, 0, 0, 0, 0, 349, 111);
INSERT INTO public.who_global_data VALUES (82521, 0, 0, 0, 0, 349, 71);
INSERT INTO public.who_global_data VALUES (82522, 0, 0, 0, 0, 349, 218);
INSERT INTO public.who_global_data VALUES (82523, 0, 0, 0, 0, 349, 43);
INSERT INTO public.who_global_data VALUES (82524, 0, 0, 0, 0, 349, 49);
INSERT INTO public.who_global_data VALUES (82525, 0, 0, 0, 0, 349, 1);
INSERT INTO public.who_global_data VALUES (82526, 0, 0, 0, 0, 349, 48);
INSERT INTO public.who_global_data VALUES (82527, 0, 0, 0, 0, 349, 232);
INSERT INTO public.who_global_data VALUES (82528, 0, 0, 0, 0, 349, 175);
INSERT INTO public.who_global_data VALUES (82529, 0, 0, 0, 0, 349, 21);
INSERT INTO public.who_global_data VALUES (82530, 0, 0, 0, 0, 349, 156);
INSERT INTO public.who_global_data VALUES (82531, 0, 0, 0, 0, 349, 95);
INSERT INTO public.who_global_data VALUES (82532, 0, 0, 0, 0, 349, 177);
INSERT INTO public.who_global_data VALUES (82533, 0, 0, 0, 0, 349, 210);
INSERT INTO public.who_global_data VALUES (82534, 0, 0, 0, 0, 349, 120);
INSERT INTO public.who_global_data VALUES (82535, 0, 0, 0, 0, 349, 135);
INSERT INTO public.who_global_data VALUES (82536, 0, 0, 0, 0, 349, 206);
INSERT INTO public.who_global_data VALUES (82537, 0, 0, 0, 0, 349, 189);
INSERT INTO public.who_global_data VALUES (82538, 0, 5, 0, 0, 349, 129);
INSERT INTO public.who_global_data VALUES (82539, 0, 0, 0, 0, 349, 121);
INSERT INTO public.who_global_data VALUES (82540, 0, 0, 0, 0, 349, 59);
INSERT INTO public.who_global_data VALUES (82541, 0, 0, 0, 0, 349, 96);
INSERT INTO public.who_global_data VALUES (82542, 0, 0, 0, 0, 349, 41);
INSERT INTO public.who_global_data VALUES (82543, 0, 0, 0, 0, 349, 216);
INSERT INTO public.who_global_data VALUES (82544, 0, 0, 0, 0, 349, 236);
INSERT INTO public.who_global_data VALUES (82545, 0, 0, 0, 0, 349, 150);
INSERT INTO public.who_global_data VALUES (82546, 0, 0, 0, 0, 349, 61);
INSERT INTO public.who_global_data VALUES (82547, 0, 0, 0, 0, 349, 7);
INSERT INTO public.who_global_data VALUES (82548, 0, 1, 0, 0, 349, 169);
INSERT INTO public.who_global_data VALUES (82549, 0, 12, 0, 1, 349, 28);
INSERT INTO public.who_global_data VALUES (82550, 0, 0, 0, 0, 349, 85);
INSERT INTO public.who_global_data VALUES (82551, 0, 0, 0, 0, 349, 211);
INSERT INTO public.who_global_data VALUES (82552, 0, 0, 0, 0, 349, 60);
INSERT INTO public.who_global_data VALUES (82553, 0, 0, 0, 0, 349, 3);
INSERT INTO public.who_global_data VALUES (82554, 0, 0, 0, 0, 349, 11);
INSERT INTO public.who_global_data VALUES (82555, 0, 15, 0, 0, 349, 89);
INSERT INTO public.who_global_data VALUES (82556, 0, 0, 0, 0, 349, 24);
INSERT INTO public.who_global_data VALUES (82557, 0, 0, 0, 0, 349, 162);
INSERT INTO public.who_global_data VALUES (82558, 0, 0, 0, 0, 349, 100);
INSERT INTO public.who_global_data VALUES (82559, 0, 0, 0, 0, 349, 47);
INSERT INTO public.who_global_data VALUES (82560, 0, 0, 0, 0, 349, 29);
INSERT INTO public.who_global_data VALUES (82561, 0, 0, 0, 0, 349, 40);
INSERT INTO public.who_global_data VALUES (82562, 0, 0, 0, 0, 349, 222);
INSERT INTO public.who_global_data VALUES (82563, 0, 0, 0, 0, 349, 132);
INSERT INTO public.who_global_data VALUES (82564, 0, 0, 0, 0, 349, 130);
INSERT INTO public.who_global_data VALUES (82565, 0, 0, 0, 0, 349, 234);
INSERT INTO public.who_global_data VALUES (82566, 0, 0, 0, 0, 349, 23);
INSERT INTO public.who_global_data VALUES (82567, 0, 0, 0, 0, 349, 192);
INSERT INTO public.who_global_data VALUES (82568, 0, 0, 0, 0, 349, 69);
INSERT INTO public.who_global_data VALUES (82569, 0, 0, 0, 0, 349, 187);
INSERT INTO public.who_global_data VALUES (82570, 0, 0, 0, 0, 349, 230);
INSERT INTO public.who_global_data VALUES (82571, 0, 0, 0, 0, 349, 77);
INSERT INTO public.who_global_data VALUES (82572, 0, 0, 0, 0, 349, 9);
INSERT INTO public.who_global_data VALUES (82573, 0, 7, 0, 0, 349, 74);
INSERT INTO public.who_global_data VALUES (82574, 0, 0, 0, 0, 349, 224);
INSERT INTO public.who_global_data VALUES (82575, 15, 47, 3, 8, 349, 199);
INSERT INTO public.who_global_data VALUES (82576, 0, 0, 0, 0, 349, 190);
INSERT INTO public.who_global_data VALUES (82577, 0, 0, 0, 0, 349, 12);
INSERT INTO public.who_global_data VALUES (82578, 0, 0, 0, 0, 349, 104);
INSERT INTO public.who_global_data VALUES (82579, 0, 1, 0, 0, 349, 153);
INSERT INTO public.who_global_data VALUES (82580, 62, 79, 2, 2, 349, 91);
INSERT INTO public.who_global_data VALUES (82581, 0, 0, 0, 0, 349, 215);
INSERT INTO public.who_global_data VALUES (82582, 12, 148, 0, 1, 349, 84);
INSERT INTO public.who_global_data VALUES (82583, 0, 0, 0, 0, 349, 231);
INSERT INTO public.who_global_data VALUES (82584, 0, 0, 0, 0, 349, 196);
INSERT INTO public.who_global_data VALUES (82585, 0, 0, 0, 0, 349, 105);
INSERT INTO public.who_global_data VALUES (82586, 0, 0, 0, 0, 349, 122);
INSERT INTO public.who_global_data VALUES (82587, 0, 0, 0, 0, 349, 159);
INSERT INTO public.who_global_data VALUES (82588, 0, 0, 0, 0, 349, 75);
INSERT INTO public.who_global_data VALUES (82589, 0, 0, 0, 0, 349, 27);
INSERT INTO public.who_global_data VALUES (82590, 0, 0, 0, 0, 349, 54);
INSERT INTO public.who_global_data VALUES (82591, 0, 0, 0, 0, 349, 226);
INSERT INTO public.who_global_data VALUES (82592, 0, 0, 0, 0, 349, 79);
INSERT INTO public.who_global_data VALUES (82593, 0, 5, 0, 0, 349, 56);
INSERT INTO public.who_global_data VALUES (82594, 0, 0, 0, 0, 349, 117);
INSERT INTO public.who_global_data VALUES (82595, 0, 0, 0, 0, 349, 152);
INSERT INTO public.who_global_data VALUES (82596, 0, 0, 0, 0, 349, 16);
INSERT INTO public.who_global_data VALUES (82597, 0, 0, 0, 0, 349, 10);
INSERT INTO public.who_global_data VALUES (82598, 0, 0, 0, 0, 349, 201);
INSERT INTO public.who_global_data VALUES (82599, 0, 0, 0, 0, 349, 174);
INSERT INTO public.who_global_data VALUES (82600, 0, 0, 0, 0, 349, 119);
INSERT INTO public.who_global_data VALUES (82601, 0, 0, 0, 0, 349, 168);
INSERT INTO public.who_global_data VALUES (82602, 0, 26, 0, 0, 349, 99);
INSERT INTO public.who_global_data VALUES (82603, 0, 0, 0, 0, 349, 171);
INSERT INTO public.who_global_data VALUES (82604, 0, 0, 0, 0, 349, 87);
INSERT INTO public.who_global_data VALUES (82605, 0, 0, 0, 0, 349, 123);
INSERT INTO public.who_global_data VALUES (82606, 0, 0, 0, 0, 349, 151);
INSERT INTO public.who_global_data VALUES (82607, 0, 0, 0, 0, 349, 213);
INSERT INTO public.who_global_data VALUES (82608, 0, 0, 0, 0, 349, 118);
INSERT INTO public.who_global_data VALUES (82609, 0, 0, 0, 0, 349, 134);
INSERT INTO public.who_global_data VALUES (82610, 0, 0, 0, 0, 349, 65);
INSERT INTO public.who_global_data VALUES (82611, 0, 0, 0, 0, 349, 102);
INSERT INTO public.who_global_data VALUES (82612, 0, 0, 0, 0, 349, 223);
INSERT INTO public.who_global_data VALUES (82613, 0, 0, 0, 0, 349, 4);
INSERT INTO public.who_global_data VALUES (82614, 0, 0, 0, 0, 349, 146);
INSERT INTO public.who_global_data VALUES (82615, 0, 0, 0, 0, 349, 31);
INSERT INTO public.who_global_data VALUES (82616, 0, 0, 0, 0, 349, 127);
INSERT INTO public.who_global_data VALUES (82617, 0, 0, 0, 0, 349, 22);
INSERT INTO public.who_global_data VALUES (82618, 0, 0, 0, 0, 349, 115);
INSERT INTO public.who_global_data VALUES (82619, 0, 0, 0, 0, 349, 106);
INSERT INTO public.who_global_data VALUES (82620, 0, 0, 0, 0, 349, 90);
INSERT INTO public.who_global_data VALUES (82621, 0, 0, 0, 0, 349, 70);
INSERT INTO public.who_global_data VALUES (82622, 0, 5, 0, 0, 349, 46);
INSERT INTO public.who_global_data VALUES (82623, 0, 0, 0, 0, 349, 139);
INSERT INTO public.who_global_data VALUES (82624, 0, 0, 0, 0, 349, 42);
INSERT INTO public.who_global_data VALUES (82625, 0, 0, 0, 0, 349, 80);
INSERT INTO public.who_global_data VALUES (82626, 0, 0, 0, 0, 349, 203);
INSERT INTO public.who_global_data VALUES (82627, 0, 0, 0, 0, 349, 136);
INSERT INTO public.who_global_data VALUES (82628, 0, 0, 0, 0, 349, 63);
INSERT INTO public.who_global_data VALUES (82629, 0, 0, 0, 0, 349, 17);
INSERT INTO public.who_global_data VALUES (82630, 0, 0, 0, 0, 349, 172);
INSERT INTO public.who_global_data VALUES (82631, 0, 0, 0, 0, 349, 109);
INSERT INTO public.who_global_data VALUES (82632, 0, 0, 0, 0, 349, 200);
INSERT INTO public.who_global_data VALUES (82633, 0, 0, 0, 0, 349, 93);
INSERT INTO public.who_global_data VALUES (82634, 0, 0, 0, 0, 349, 5);
INSERT INTO public.who_global_data VALUES (82635, 57, 695, 1, 3, 349, 214);
INSERT INTO public.who_global_data VALUES (82636, 0, 0, 0, 0, 349, 204);
INSERT INTO public.who_global_data VALUES (82637, 0, 0, 0, 0, 349, 198);
INSERT INTO public.who_global_data VALUES (82638, 0, 0, 0, 0, 349, 173);
INSERT INTO public.who_global_data VALUES (82639, 0, 0, 0, 0, 349, 229);
INSERT INTO public.who_global_data VALUES (82640, 0, 0, 0, 0, 349, 76);
INSERT INTO public.who_global_data VALUES (82641, 0, 0, 0, 0, 349, 138);
INSERT INTO public.who_global_data VALUES (82642, 0, 7, 0, 1, 349, 98);
INSERT INTO public.who_global_data VALUES (82643, 0, 0, 0, 0, 349, 103);
INSERT INTO public.who_global_data VALUES (82644, 0, 0, 0, 0, 349, 225);
INSERT INTO public.who_global_data VALUES (82645, 0, 0, 0, 0, 349, 131);
INSERT INTO public.who_global_data VALUES (82646, 0, 0, 0, 0, 349, 235);
INSERT INTO public.who_global_data VALUES (82647, 0, 0, 0, 0, 349, 137);
INSERT INTO public.who_global_data VALUES (82648, 169, 606, 0, 2, 349, 81);
INSERT INTO public.who_global_data VALUES (82649, 0, 0, 0, 0, 349, 182);
INSERT INTO public.who_global_data VALUES (82650, 0, 0, 0, 0, 349, 145);
INSERT INTO public.who_global_data VALUES (82651, 0, 0, 0, 0, 349, 26);
INSERT INTO public.who_global_data VALUES (82652, 0, 2, 0, 0, 349, 170);
INSERT INTO public.who_global_data VALUES (82653, 0, 0, 0, 0, 349, 191);
INSERT INTO public.who_global_data VALUES (82654, 0, 0, 0, 0, 349, 221);
INSERT INTO public.who_global_data VALUES (82655, 0, 0, 0, 0, 349, 64);
INSERT INTO public.who_global_data VALUES (82656, 0, 0, 0, 0, 349, 116);
INSERT INTO public.who_global_data VALUES (82657, 0, 0, 0, 0, 349, 128);
INSERT INTO public.who_global_data VALUES (82658, 0, 0, 0, 0, 349, 6);
INSERT INTO public.who_global_data VALUES (82659, 0, 0, 0, 0, 349, 227);
INSERT INTO public.who_global_data VALUES (82660, 0, 0, 0, 0, 349, 68);
INSERT INTO public.who_global_data VALUES (82661, 0, 0, 0, 0, 349, 184);
INSERT INTO public.who_global_data VALUES (82662, 0, 0, 0, 0, 349, 82);
INSERT INTO public.who_global_data VALUES (82663, 0, 0, 0, 0, 349, 149);
INSERT INTO public.who_global_data VALUES (82664, 0, 0, 0, 0, 349, 197);
INSERT INTO public.who_global_data VALUES (82665, 0, 0, 0, 0, 349, 78);
INSERT INTO public.who_global_data VALUES (82666, 0, 0, 0, 0, 349, 233);
INSERT INTO public.who_global_data VALUES (82667, 0, 0, 0, 0, 349, 133);
INSERT INTO public.who_global_data VALUES (82668, 0, 0, 0, 0, 349, 35);
INSERT INTO public.who_global_data VALUES (82669, 0, 0, 0, 0, 349, 114);
INSERT INTO public.who_global_data VALUES (82670, 0, 93, 0, 0, 349, 237);
INSERT INTO public.who_global_data VALUES (82671, 0, 0, 0, 0, 349, 55);
INSERT INTO public.who_global_data VALUES (82672, 0, 0, 0, 0, 349, 176);
INSERT INTO public.who_global_data VALUES (82673, 0, 0, 0, 0, 349, 202);
INSERT INTO public.who_global_data VALUES (82674, 0, 0, 0, 0, 349, 155);
INSERT INTO public.who_global_data VALUES (82675, 0, 0, 0, 0, 349, 32);
INSERT INTO public.who_global_data VALUES (82676, 0, 0, 0, 0, 349, 220);
INSERT INTO public.who_global_data VALUES (82677, 0, 0, 0, 0, 349, 30);
INSERT INTO public.who_global_data VALUES (82678, 0, 0, 0, 0, 349, 147);
INSERT INTO public.who_global_data VALUES (82679, 0, 29, 0, 1, 349, 208);
INSERT INTO public.who_global_data VALUES (82680, 0, 5, 0, 0, 349, 45);
INSERT INTO public.who_global_data VALUES (82681, 0, 0, 0, 0, 349, 110);
INSERT INTO public.who_global_data VALUES (82682, 0, 0, 0, 0, 349, 88);
INSERT INTO public.who_global_data VALUES (82683, 0, 1, 0, 0, 349, 51);
INSERT INTO public.who_global_data VALUES (82684, 0, 0, 0, 0, 349, 209);
INSERT INTO public.who_global_data VALUES (82685, 0, 0, 0, 0, 349, 205);
INSERT INTO public.who_global_data VALUES (82686, 0, 0, 0, 0, 349, 18);
INSERT INTO public.who_global_data VALUES (82687, 0, 39, 0, 0, 349, 72);
INSERT INTO public.who_global_data VALUES (82688, 1, 11, 0, 0, 349, 44);
INSERT INTO public.who_global_data VALUES (82689, 0, 0, 0, 0, 349, 15);
INSERT INTO public.who_global_data VALUES (82690, 0, 0, 0, 0, 349, 25);
INSERT INTO public.who_global_data VALUES (82691, 0, 0, 0, 0, 349, 179);
INSERT INTO public.who_global_data VALUES (82692, 0, 0, 0, 0, 349, 34);
INSERT INTO public.who_global_data VALUES (82693, 0, 0, 0, 0, 349, 207);
INSERT INTO public.who_global_data VALUES (82694, 0, 0, 0, 0, 349, 166);
INSERT INTO public.who_global_data VALUES (82695, 0, 0, 0, 0, 349, 126);
INSERT INTO public.who_global_data VALUES (82696, 0, 0, 0, 0, 349, 97);
INSERT INTO public.who_global_data VALUES (82697, 0, 0, 0, 0, 349, 36);
INSERT INTO public.who_global_data VALUES (82698, 0, 0, 0, 0, 349, 125);
INSERT INTO public.who_global_data VALUES (82699, 0, 0, 0, 0, 349, 124);
INSERT INTO public.who_global_data VALUES (82700, 0, 0, 0, 0, 349, 185);
INSERT INTO public.who_global_data VALUES (82701, 0, 17, 0, 0, 349, 194);
INSERT INTO public.who_global_data VALUES (82702, 0, 0, 0, 0, 349, 144);
INSERT INTO public.who_global_data VALUES (82703, 0, 39, 0, 0, 349, 19);
INSERT INTO public.who_global_data VALUES (82704, 0, 0, 0, 0, 349, 217);
INSERT INTO public.who_global_data VALUES (82705, 0, 0, 0, 0, 349, 148);
INSERT INTO public.who_global_data VALUES (82706, 0, 0, 0, 0, 349, 86);
INSERT INTO public.who_global_data VALUES (82707, 0, 0, 0, 0, 349, 13);
INSERT INTO public.who_global_data VALUES (82708, 0, 0, 0, 0, 349, 157);
INSERT INTO public.who_global_data VALUES (82709, 0, 20, 0, 0, 349, 8);
INSERT INTO public.who_global_data VALUES (82710, 0, 0, 0, 0, 349, 73);
INSERT INTO public.who_global_data VALUES (82711, 0, 0, 0, 0, 349, 101);
INSERT INTO public.who_global_data VALUES (82712, 0, 0, 0, 0, 349, 165);
INSERT INTO public.who_global_data VALUES (82713, 0, 0, 0, 0, 349, 14);
INSERT INTO public.who_global_data VALUES (82714, 0, 0, 0, 0, 350, 193);
INSERT INTO public.who_global_data VALUES (82715, 0, 0, 0, 0, 350, 113);
INSERT INTO public.who_global_data VALUES (82716, 0, 0, 0, 0, 350, 143);
INSERT INTO public.who_global_data VALUES (82717, 0, 0, 0, 0, 350, 219);
INSERT INTO public.who_global_data VALUES (82718, 0, 0, 0, 0, 350, 186);
INSERT INTO public.who_global_data VALUES (82719, 0, 0, 0, 0, 350, 52);
INSERT INTO public.who_global_data VALUES (82720, 0, 0, 0, 0, 350, 180);
INSERT INTO public.who_global_data VALUES (82721, 0, 0, 0, 0, 350, 167);
INSERT INTO public.who_global_data VALUES (82722, 0, 0, 0, 0, 350, 154);
INSERT INTO public.who_global_data VALUES (82723, 0, 0, 0, 0, 350, 94);
INSERT INTO public.who_global_data VALUES (82724, 0, 0, 0, 0, 350, 66);
INSERT INTO public.who_global_data VALUES (82725, 4, 25, 0, 0, 350, 58);
INSERT INTO public.who_global_data VALUES (82726, 0, 0, 0, 0, 350, 163);
INSERT INTO public.who_global_data VALUES (82727, 0, 0, 0, 0, 350, 37);
INSERT INTO public.who_global_data VALUES (82728, 0, 0, 0, 0, 350, 142);
INSERT INTO public.who_global_data VALUES (82729, 0, 0, 0, 0, 350, 83);
INSERT INTO public.who_global_data VALUES (82730, 0, 0, 0, 0, 350, 228);
INSERT INTO public.who_global_data VALUES (82731, 0, 0, 0, 0, 350, 188);
INSERT INTO public.who_global_data VALUES (82732, 0, 0, 0, 0, 350, 62);
INSERT INTO public.who_global_data VALUES (82733, 0, 1, 0, 0, 350, 160);
INSERT INTO public.who_global_data VALUES (82734, 0, 0, 0, 0, 350, 50);
INSERT INTO public.who_global_data VALUES (82735, 0, 0, 0, 0, 350, 33);
INSERT INTO public.who_global_data VALUES (82736, 0, 0, 0, 0, 350, 183);
INSERT INTO public.who_global_data VALUES (82737, 0, 0, 0, 0, 350, 92);
INSERT INTO public.who_global_data VALUES (82738, 0, 0, 0, 0, 350, 158);
INSERT INTO public.who_global_data VALUES (82739, 0, 0, 0, 0, 350, 67);
INSERT INTO public.who_global_data VALUES (82740, 0, 0, 0, 0, 350, 57);
INSERT INTO public.who_global_data VALUES (82741, 0, 0, 0, 0, 350, 38);
INSERT INTO public.who_global_data VALUES (82742, 0, 0, 0, 0, 350, 141);
INSERT INTO public.who_global_data VALUES (82743, 0, 0, 0, 0, 350, 178);
INSERT INTO public.who_global_data VALUES (82744, 0, 0, 0, 0, 350, 108);
INSERT INTO public.who_global_data VALUES (82745, 0, 0, 0, 0, 350, 39);
INSERT INTO public.who_global_data VALUES (82746, 0, 0, 0, 0, 350, 2);
INSERT INTO public.who_global_data VALUES (82747, 0, 0, 0, 0, 350, 195);
INSERT INTO public.who_global_data VALUES (82748, 0, 0, 0, 0, 350, 107);
INSERT INTO public.who_global_data VALUES (82749, 0, 5, 0, 0, 350, 161);
INSERT INTO public.who_global_data VALUES (82750, 0, 0, 0, 0, 350, 212);
INSERT INTO public.who_global_data VALUES (82751, 1, 13, 0, 0, 350, 181);
INSERT INTO public.who_global_data VALUES (82752, 0, 0, 0, 0, 350, 53);
INSERT INTO public.who_global_data VALUES (82753, 0, 0, 0, 0, 350, 164);
INSERT INTO public.who_global_data VALUES (82754, 0, 0, 0, 0, 350, 140);
INSERT INTO public.who_global_data VALUES (82755, 0, 0, 0, 0, 350, 20);
INSERT INTO public.who_global_data VALUES (82756, 825, 76396, 109, 2348, 350, 112);
INSERT INTO public.who_global_data VALUES (82757, 0, 0, 0, 0, 350, 111);
INSERT INTO public.who_global_data VALUES (82758, 0, 0, 0, 0, 350, 71);
INSERT INTO public.who_global_data VALUES (82759, 0, 0, 0, 0, 350, 218);
INSERT INTO public.who_global_data VALUES (82760, 0, 0, 0, 0, 350, 43);
INSERT INTO public.who_global_data VALUES (82761, 0, 0, 0, 0, 350, 49);
INSERT INTO public.who_global_data VALUES (82762, 0, 0, 0, 0, 350, 1);
INSERT INTO public.who_global_data VALUES (82763, 0, 0, 0, 0, 350, 48);
INSERT INTO public.who_global_data VALUES (82764, 0, 0, 0, 0, 350, 232);
INSERT INTO public.who_global_data VALUES (82765, 0, 0, 0, 0, 350, 175);
INSERT INTO public.who_global_data VALUES (82766, 0, 0, 0, 0, 350, 21);
INSERT INTO public.who_global_data VALUES (82767, 0, 0, 0, 0, 350, 156);
INSERT INTO public.who_global_data VALUES (82768, 0, 0, 0, 0, 350, 95);
INSERT INTO public.who_global_data VALUES (82769, 0, 0, 0, 0, 350, 177);
INSERT INTO public.who_global_data VALUES (82770, 0, 0, 0, 0, 350, 210);
INSERT INTO public.who_global_data VALUES (82771, 0, 0, 0, 0, 350, 120);
INSERT INTO public.who_global_data VALUES (82772, 0, 0, 0, 0, 350, 135);
INSERT INTO public.who_global_data VALUES (82773, 0, 0, 0, 0, 350, 206);
INSERT INTO public.who_global_data VALUES (82774, 0, 0, 0, 0, 350, 189);
INSERT INTO public.who_global_data VALUES (82775, 0, 5, 0, 0, 350, 129);
INSERT INTO public.who_global_data VALUES (82776, 0, 0, 0, 0, 350, 121);
INSERT INTO public.who_global_data VALUES (82777, 0, 0, 0, 0, 350, 59);
INSERT INTO public.who_global_data VALUES (82778, 0, 0, 0, 0, 350, 96);
INSERT INTO public.who_global_data VALUES (82779, 0, 0, 0, 0, 350, 41);
INSERT INTO public.who_global_data VALUES (82780, 0, 0, 0, 0, 350, 216);
INSERT INTO public.who_global_data VALUES (82781, 0, 0, 0, 0, 350, 236);
INSERT INTO public.who_global_data VALUES (82782, 0, 0, 0, 0, 350, 150);
INSERT INTO public.who_global_data VALUES (82783, 0, 0, 0, 0, 350, 61);
INSERT INTO public.who_global_data VALUES (82784, 0, 0, 0, 0, 350, 7);
INSERT INTO public.who_global_data VALUES (82785, 0, 1, 0, 0, 350, 169);
INSERT INTO public.who_global_data VALUES (82786, 0, 12, 0, 1, 350, 28);
INSERT INTO public.who_global_data VALUES (82787, 0, 0, 0, 0, 350, 85);
INSERT INTO public.who_global_data VALUES (82788, 0, 0, 0, 0, 350, 211);
INSERT INTO public.who_global_data VALUES (82789, 0, 0, 0, 0, 350, 60);
INSERT INTO public.who_global_data VALUES (82790, 0, 0, 0, 0, 350, 3);
INSERT INTO public.who_global_data VALUES (82791, 0, 0, 0, 0, 350, 11);
INSERT INTO public.who_global_data VALUES (82792, 0, 15, 0, 0, 350, 89);
INSERT INTO public.who_global_data VALUES (82793, 0, 0, 0, 0, 350, 24);
INSERT INTO public.who_global_data VALUES (82794, 0, 0, 0, 0, 350, 162);
INSERT INTO public.who_global_data VALUES (82795, 0, 0, 0, 0, 350, 100);
INSERT INTO public.who_global_data VALUES (82796, 0, 0, 0, 0, 350, 47);
INSERT INTO public.who_global_data VALUES (82797, 0, 0, 0, 0, 350, 29);
INSERT INTO public.who_global_data VALUES (82798, 0, 0, 0, 0, 350, 40);
INSERT INTO public.who_global_data VALUES (82799, 0, 0, 0, 0, 350, 222);
INSERT INTO public.who_global_data VALUES (82800, 0, 0, 0, 0, 350, 132);
INSERT INTO public.who_global_data VALUES (82801, 0, 0, 0, 0, 350, 130);
INSERT INTO public.who_global_data VALUES (82802, 0, 0, 0, 0, 350, 234);
INSERT INTO public.who_global_data VALUES (82803, 0, 0, 0, 0, 350, 23);
INSERT INTO public.who_global_data VALUES (82804, 0, 0, 0, 0, 350, 192);
INSERT INTO public.who_global_data VALUES (82805, 0, 0, 0, 0, 350, 69);
INSERT INTO public.who_global_data VALUES (82806, 0, 0, 0, 0, 350, 187);
INSERT INTO public.who_global_data VALUES (82807, 0, 0, 0, 0, 350, 230);
INSERT INTO public.who_global_data VALUES (82808, 0, 0, 0, 0, 350, 77);
INSERT INTO public.who_global_data VALUES (82809, 0, 0, 0, 0, 350, 9);
INSERT INTO public.who_global_data VALUES (82810, 0, 7, 0, 0, 350, 74);
INSERT INTO public.who_global_data VALUES (82811, 0, 0, 0, 0, 350, 224);
INSERT INTO public.who_global_data VALUES (82812, 10, 32, 1, 5, 350, 199);
INSERT INTO public.who_global_data VALUES (82813, 0, 0, 0, 0, 350, 190);
INSERT INTO public.who_global_data VALUES (82814, 0, 0, 0, 0, 350, 12);
INSERT INTO public.who_global_data VALUES (82815, 0, 0, 0, 0, 350, 104);
INSERT INTO public.who_global_data VALUES (82816, 0, 1, 0, 0, 350, 153);
INSERT INTO public.who_global_data VALUES (82817, 14, 17, 0, 0, 350, 91);
INSERT INTO public.who_global_data VALUES (82818, 0, 0, 0, 0, 350, 215);
INSERT INTO public.who_global_data VALUES (82819, 27, 136, 0, 1, 350, 84);
INSERT INTO public.who_global_data VALUES (82820, 0, 0, 0, 0, 350, 231);
INSERT INTO public.who_global_data VALUES (82821, 0, 0, 0, 0, 350, 196);
INSERT INTO public.who_global_data VALUES (82822, 0, 0, 0, 0, 350, 105);
INSERT INTO public.who_global_data VALUES (82823, 0, 0, 0, 0, 350, 122);
INSERT INTO public.who_global_data VALUES (82824, 0, 0, 0, 0, 350, 159);
INSERT INTO public.who_global_data VALUES (82825, 0, 0, 0, 0, 350, 75);
INSERT INTO public.who_global_data VALUES (82826, 0, 0, 0, 0, 350, 27);
INSERT INTO public.who_global_data VALUES (82827, 0, 0, 0, 0, 350, 54);
INSERT INTO public.who_global_data VALUES (82828, 0, 0, 0, 0, 350, 226);
INSERT INTO public.who_global_data VALUES (82829, 0, 0, 0, 0, 350, 79);
INSERT INTO public.who_global_data VALUES (82830, 0, 5, 0, 0, 350, 56);
INSERT INTO public.who_global_data VALUES (82831, 0, 0, 0, 0, 350, 117);
INSERT INTO public.who_global_data VALUES (82832, 0, 0, 0, 0, 350, 152);
INSERT INTO public.who_global_data VALUES (82833, 0, 0, 0, 0, 350, 16);
INSERT INTO public.who_global_data VALUES (82834, 0, 0, 0, 0, 350, 10);
INSERT INTO public.who_global_data VALUES (82835, 0, 0, 0, 0, 350, 201);
INSERT INTO public.who_global_data VALUES (82836, 0, 0, 0, 0, 350, 174);
INSERT INTO public.who_global_data VALUES (82837, 0, 0, 0, 0, 350, 119);
INSERT INTO public.who_global_data VALUES (82838, 0, 0, 0, 0, 350, 168);
INSERT INTO public.who_global_data VALUES (82839, 0, 26, 0, 0, 350, 99);
INSERT INTO public.who_global_data VALUES (82840, 0, 0, 0, 0, 350, 171);
INSERT INTO public.who_global_data VALUES (82841, 0, 0, 0, 0, 350, 87);
INSERT INTO public.who_global_data VALUES (82842, 0, 0, 0, 0, 350, 123);
INSERT INTO public.who_global_data VALUES (82843, 0, 0, 0, 0, 350, 151);
INSERT INTO public.who_global_data VALUES (82844, 0, 0, 0, 0, 350, 213);
INSERT INTO public.who_global_data VALUES (82845, 0, 0, 0, 0, 350, 118);
INSERT INTO public.who_global_data VALUES (82846, 0, 0, 0, 0, 350, 134);
INSERT INTO public.who_global_data VALUES (82847, 0, 0, 0, 0, 350, 65);
INSERT INTO public.who_global_data VALUES (82848, 0, 0, 0, 0, 350, 102);
INSERT INTO public.who_global_data VALUES (82849, 0, 0, 0, 0, 350, 223);
INSERT INTO public.who_global_data VALUES (82850, 0, 0, 0, 0, 350, 4);
INSERT INTO public.who_global_data VALUES (82851, 0, 0, 0, 0, 350, 146);
INSERT INTO public.who_global_data VALUES (82852, 0, 0, 0, 0, 350, 31);
INSERT INTO public.who_global_data VALUES (82853, 0, 0, 0, 0, 350, 127);
INSERT INTO public.who_global_data VALUES (82854, 0, 0, 0, 0, 350, 22);
INSERT INTO public.who_global_data VALUES (82855, 0, 0, 0, 0, 350, 115);
INSERT INTO public.who_global_data VALUES (82856, 0, 0, 0, 0, 350, 106);
INSERT INTO public.who_global_data VALUES (82857, 0, 0, 0, 0, 350, 90);
INSERT INTO public.who_global_data VALUES (82858, 0, 0, 0, 0, 350, 70);
INSERT INTO public.who_global_data VALUES (82859, 0, 5, 0, 0, 350, 46);
INSERT INTO public.who_global_data VALUES (82860, 0, 0, 0, 0, 350, 139);
INSERT INTO public.who_global_data VALUES (82861, 0, 0, 0, 0, 350, 42);
INSERT INTO public.who_global_data VALUES (82862, 0, 0, 0, 0, 350, 80);
INSERT INTO public.who_global_data VALUES (82863, 0, 0, 0, 0, 350, 203);
INSERT INTO public.who_global_data VALUES (82864, 0, 0, 0, 0, 350, 136);
INSERT INTO public.who_global_data VALUES (82865, 0, 0, 0, 0, 350, 63);
INSERT INTO public.who_global_data VALUES (82866, 0, 0, 0, 0, 350, 17);
INSERT INTO public.who_global_data VALUES (82867, 0, 0, 0, 0, 350, 172);
INSERT INTO public.who_global_data VALUES (82868, 0, 0, 0, 0, 350, 109);
INSERT INTO public.who_global_data VALUES (82869, 0, 0, 0, 0, 350, 200);
INSERT INTO public.who_global_data VALUES (82870, 0, 0, 0, 0, 350, 93);
INSERT INTO public.who_global_data VALUES (82871, 0, 0, 0, 0, 350, 5);
INSERT INTO public.who_global_data VALUES (82872, 0, 638, 0, 2, 350, 214);
INSERT INTO public.who_global_data VALUES (82873, 0, 0, 0, 0, 350, 204);
INSERT INTO public.who_global_data VALUES (82874, 0, 0, 0, 0, 350, 198);
INSERT INTO public.who_global_data VALUES (82875, 0, 0, 0, 0, 350, 173);
INSERT INTO public.who_global_data VALUES (82876, 0, 0, 0, 0, 350, 229);
INSERT INTO public.who_global_data VALUES (82877, 0, 0, 0, 0, 350, 76);
INSERT INTO public.who_global_data VALUES (82878, 0, 0, 0, 0, 350, 138);
INSERT INTO public.who_global_data VALUES (82879, 0, 7, 0, 1, 350, 98);
INSERT INTO public.who_global_data VALUES (82880, 0, 0, 0, 0, 350, 103);
INSERT INTO public.who_global_data VALUES (82881, 0, 0, 0, 0, 350, 225);
INSERT INTO public.who_global_data VALUES (82882, 0, 0, 0, 0, 350, 131);
INSERT INTO public.who_global_data VALUES (82883, 0, 0, 0, 0, 350, 235);
INSERT INTO public.who_global_data VALUES (82884, 0, 0, 0, 0, 350, 137);
INSERT INTO public.who_global_data VALUES (82885, 229, 437, 1, 2, 350, 81);
INSERT INTO public.who_global_data VALUES (82886, 0, 0, 0, 0, 350, 182);
INSERT INTO public.who_global_data VALUES (82887, 0, 0, 0, 0, 350, 145);
INSERT INTO public.who_global_data VALUES (82888, 0, 0, 0, 0, 350, 26);
INSERT INTO public.who_global_data VALUES (82889, 0, 2, 0, 0, 350, 170);
INSERT INTO public.who_global_data VALUES (82890, 0, 0, 0, 0, 350, 191);
INSERT INTO public.who_global_data VALUES (82891, 0, 0, 0, 0, 350, 221);
INSERT INTO public.who_global_data VALUES (82892, 0, 0, 0, 0, 350, 64);
INSERT INTO public.who_global_data VALUES (82893, 0, 0, 0, 0, 350, 116);
INSERT INTO public.who_global_data VALUES (82894, 0, 0, 0, 0, 350, 128);
INSERT INTO public.who_global_data VALUES (82895, 0, 0, 0, 0, 350, 6);
INSERT INTO public.who_global_data VALUES (82896, 0, 0, 0, 0, 350, 227);
INSERT INTO public.who_global_data VALUES (82897, 0, 0, 0, 0, 350, 68);
INSERT INTO public.who_global_data VALUES (82898, 0, 0, 0, 0, 350, 184);
INSERT INTO public.who_global_data VALUES (82899, 0, 0, 0, 0, 350, 82);
INSERT INTO public.who_global_data VALUES (82900, 0, 0, 0, 0, 350, 149);
INSERT INTO public.who_global_data VALUES (82901, 0, 0, 0, 0, 350, 197);
INSERT INTO public.who_global_data VALUES (82902, 0, 0, 0, 0, 350, 78);
INSERT INTO public.who_global_data VALUES (82903, 0, 0, 0, 0, 350, 233);
INSERT INTO public.who_global_data VALUES (82904, 0, 0, 0, 0, 350, 133);
INSERT INTO public.who_global_data VALUES (82905, 0, 0, 0, 0, 350, 35);
INSERT INTO public.who_global_data VALUES (82906, 0, 0, 0, 0, 350, 114);
INSERT INTO public.who_global_data VALUES (82907, 3, 93, 0, 0, 350, 237);
INSERT INTO public.who_global_data VALUES (82908, 0, 0, 0, 0, 350, 55);
INSERT INTO public.who_global_data VALUES (82909, 0, 0, 0, 0, 350, 176);
INSERT INTO public.who_global_data VALUES (82910, 0, 0, 0, 0, 350, 202);
INSERT INTO public.who_global_data VALUES (82911, 0, 0, 0, 0, 350, 155);
INSERT INTO public.who_global_data VALUES (82912, 0, 0, 0, 0, 350, 32);
INSERT INTO public.who_global_data VALUES (82913, 0, 0, 0, 0, 350, 220);
INSERT INTO public.who_global_data VALUES (82914, 0, 0, 0, 0, 350, 30);
INSERT INTO public.who_global_data VALUES (82915, 0, 0, 0, 0, 350, 147);
INSERT INTO public.who_global_data VALUES (82916, 0, 29, 0, 1, 350, 208);
INSERT INTO public.who_global_data VALUES (82917, 0, 5, 0, 0, 350, 45);
INSERT INTO public.who_global_data VALUES (82918, 0, 0, 0, 0, 350, 110);
INSERT INTO public.who_global_data VALUES (82919, 0, 0, 0, 0, 350, 88);
INSERT INTO public.who_global_data VALUES (82920, 0, 1, 0, 0, 350, 51);
INSERT INTO public.who_global_data VALUES (82921, 0, 0, 0, 0, 350, 209);
INSERT INTO public.who_global_data VALUES (82922, 0, 0, 0, 0, 350, 205);
INSERT INTO public.who_global_data VALUES (82923, 0, 0, 0, 0, 350, 18);
INSERT INTO public.who_global_data VALUES (82924, 0, 39, 0, 0, 350, 72);
INSERT INTO public.who_global_data VALUES (82925, 0, 10, 0, 0, 350, 44);
INSERT INTO public.who_global_data VALUES (82926, 0, 0, 0, 0, 350, 15);
INSERT INTO public.who_global_data VALUES (82927, 0, 0, 0, 0, 350, 25);
INSERT INTO public.who_global_data VALUES (82928, 0, 0, 0, 0, 350, 179);
INSERT INTO public.who_global_data VALUES (82929, 0, 0, 0, 0, 350, 34);
INSERT INTO public.who_global_data VALUES (82930, 0, 0, 0, 0, 350, 207);
INSERT INTO public.who_global_data VALUES (82931, 0, 0, 0, 0, 350, 166);
INSERT INTO public.who_global_data VALUES (82932, 0, 0, 0, 0, 350, 126);
INSERT INTO public.who_global_data VALUES (82933, 0, 0, 0, 0, 350, 97);
INSERT INTO public.who_global_data VALUES (82934, 0, 0, 0, 0, 350, 36);
INSERT INTO public.who_global_data VALUES (82935, 0, 0, 0, 0, 350, 125);
INSERT INTO public.who_global_data VALUES (82936, 0, 0, 0, 0, 350, 124);
INSERT INTO public.who_global_data VALUES (82937, 0, 0, 0, 0, 350, 185);
INSERT INTO public.who_global_data VALUES (82938, 2, 17, 0, 0, 350, 194);
INSERT INTO public.who_global_data VALUES (82939, 0, 0, 0, 0, 350, 144);
INSERT INTO public.who_global_data VALUES (82940, 1, 39, 0, 0, 350, 19);
INSERT INTO public.who_global_data VALUES (82941, 0, 0, 0, 0, 350, 217);
INSERT INTO public.who_global_data VALUES (82942, 0, 0, 0, 0, 350, 148);
INSERT INTO public.who_global_data VALUES (82943, 0, 0, 0, 0, 350, 86);
INSERT INTO public.who_global_data VALUES (82944, 0, 0, 0, 0, 350, 13);
INSERT INTO public.who_global_data VALUES (82945, 0, 0, 0, 0, 350, 157);
INSERT INTO public.who_global_data VALUES (82946, 0, 20, 0, 0, 350, 8);
INSERT INTO public.who_global_data VALUES (82947, 0, 0, 0, 0, 350, 73);
INSERT INTO public.who_global_data VALUES (82948, 0, 0, 0, 0, 350, 101);
INSERT INTO public.who_global_data VALUES (82949, 0, 0, 0, 0, 350, 165);
INSERT INTO public.who_global_data VALUES (82950, 0, 0, 0, 0, 350, 14);
INSERT INTO public.who_global_data VALUES (82951, 0, 0, 0, 0, 351, 193);
INSERT INTO public.who_global_data VALUES (82952, 0, 0, 0, 0, 351, 113);
INSERT INTO public.who_global_data VALUES (82953, 0, 0, 0, 0, 351, 143);
INSERT INTO public.who_global_data VALUES (82954, 0, 0, 0, 0, 351, 219);
INSERT INTO public.who_global_data VALUES (82955, 0, 0, 0, 0, 351, 186);
INSERT INTO public.who_global_data VALUES (82956, 0, 0, 0, 0, 351, 52);
INSERT INTO public.who_global_data VALUES (82957, 0, 0, 0, 0, 351, 180);
INSERT INTO public.who_global_data VALUES (82958, 0, 0, 0, 0, 351, 167);
INSERT INTO public.who_global_data VALUES (82959, 0, 0, 0, 0, 351, 154);
INSERT INTO public.who_global_data VALUES (82960, 0, 0, 0, 0, 351, 94);
INSERT INTO public.who_global_data VALUES (82961, 0, 0, 0, 0, 351, 66);
INSERT INTO public.who_global_data VALUES (82962, 2, 21, 0, 0, 351, 58);
INSERT INTO public.who_global_data VALUES (82963, 0, 0, 0, 0, 351, 163);
INSERT INTO public.who_global_data VALUES (82964, 0, 0, 0, 0, 351, 37);
INSERT INTO public.who_global_data VALUES (82965, 0, 0, 0, 0, 351, 142);
INSERT INTO public.who_global_data VALUES (82966, 0, 0, 0, 0, 351, 83);
INSERT INTO public.who_global_data VALUES (82967, 0, 0, 0, 0, 351, 228);
INSERT INTO public.who_global_data VALUES (82968, 0, 0, 0, 0, 351, 188);
INSERT INTO public.who_global_data VALUES (82969, 0, 0, 0, 0, 351, 62);
INSERT INTO public.who_global_data VALUES (82970, 0, 1, 0, 0, 351, 160);
INSERT INTO public.who_global_data VALUES (82971, 0, 0, 0, 0, 351, 50);
INSERT INTO public.who_global_data VALUES (82972, 0, 0, 0, 0, 351, 33);
INSERT INTO public.who_global_data VALUES (82973, 0, 0, 0, 0, 351, 183);
INSERT INTO public.who_global_data VALUES (82974, 0, 0, 0, 0, 351, 92);
INSERT INTO public.who_global_data VALUES (82975, 0, 0, 0, 0, 351, 158);
INSERT INTO public.who_global_data VALUES (82976, 0, 0, 0, 0, 351, 67);
INSERT INTO public.who_global_data VALUES (82977, 0, 0, 0, 0, 351, 57);
INSERT INTO public.who_global_data VALUES (82978, 0, 0, 0, 0, 351, 38);
INSERT INTO public.who_global_data VALUES (82979, 0, 0, 0, 0, 351, 141);
INSERT INTO public.who_global_data VALUES (82980, 0, 0, 0, 0, 351, 178);
INSERT INTO public.who_global_data VALUES (82981, 0, 0, 0, 0, 351, 108);
INSERT INTO public.who_global_data VALUES (82982, 0, 0, 0, 0, 351, 39);
INSERT INTO public.who_global_data VALUES (82983, 0, 0, 0, 0, 351, 2);
INSERT INTO public.who_global_data VALUES (82984, 0, 0, 0, 0, 351, 195);
INSERT INTO public.who_global_data VALUES (82985, 0, 0, 0, 0, 351, 107);
INSERT INTO public.who_global_data VALUES (82986, 0, 5, 0, 0, 351, 161);
INSERT INTO public.who_global_data VALUES (82987, 0, 0, 0, 0, 351, 212);
INSERT INTO public.who_global_data VALUES (82988, 0, 12, 0, 0, 351, 181);
INSERT INTO public.who_global_data VALUES (82989, 0, 0, 0, 0, 351, 53);
INSERT INTO public.who_global_data VALUES (82990, 0, 0, 0, 0, 351, 164);
INSERT INTO public.who_global_data VALUES (82991, 0, 0, 0, 0, 351, 140);
INSERT INTO public.who_global_data VALUES (82992, 0, 0, 0, 0, 351, 20);
INSERT INTO public.who_global_data VALUES (82993, 892, 75571, 118, 2239, 351, 112);
INSERT INTO public.who_global_data VALUES (82994, 0, 0, 0, 0, 351, 111);
INSERT INTO public.who_global_data VALUES (82995, 0, 0, 0, 0, 351, 71);
INSERT INTO public.who_global_data VALUES (82996, 0, 0, 0, 0, 351, 218);
INSERT INTO public.who_global_data VALUES (82997, 0, 0, 0, 0, 351, 43);
INSERT INTO public.who_global_data VALUES (82998, 0, 0, 0, 0, 351, 49);
INSERT INTO public.who_global_data VALUES (82999, 0, 0, 0, 0, 351, 1);
INSERT INTO public.who_global_data VALUES (83000, 0, 0, 0, 0, 351, 48);
INSERT INTO public.who_global_data VALUES (83001, 0, 0, 0, 0, 351, 232);
INSERT INTO public.who_global_data VALUES (83002, 0, 0, 0, 0, 351, 175);
INSERT INTO public.who_global_data VALUES (83003, 0, 0, 0, 0, 351, 21);
INSERT INTO public.who_global_data VALUES (83004, 0, 0, 0, 0, 351, 156);
INSERT INTO public.who_global_data VALUES (83005, 0, 0, 0, 0, 351, 95);
INSERT INTO public.who_global_data VALUES (83006, 0, 0, 0, 0, 351, 177);
INSERT INTO public.who_global_data VALUES (83007, 0, 0, 0, 0, 351, 210);
INSERT INTO public.who_global_data VALUES (83008, 0, 0, 0, 0, 351, 120);
INSERT INTO public.who_global_data VALUES (83009, 0, 0, 0, 0, 351, 135);
INSERT INTO public.who_global_data VALUES (83010, 0, 0, 0, 0, 351, 206);
INSERT INTO public.who_global_data VALUES (83011, 0, 0, 0, 0, 351, 189);
INSERT INTO public.who_global_data VALUES (83012, 0, 5, 0, 0, 351, 129);
INSERT INTO public.who_global_data VALUES (83013, 0, 0, 0, 0, 351, 121);
INSERT INTO public.who_global_data VALUES (83014, 0, 0, 0, 0, 351, 59);
INSERT INTO public.who_global_data VALUES (83015, 0, 0, 0, 0, 351, 96);
INSERT INTO public.who_global_data VALUES (83016, 0, 0, 0, 0, 351, 41);
INSERT INTO public.who_global_data VALUES (83017, 0, 0, 0, 0, 351, 216);
INSERT INTO public.who_global_data VALUES (83018, 0, 0, 0, 0, 351, 236);
INSERT INTO public.who_global_data VALUES (83019, 0, 0, 0, 0, 351, 150);
INSERT INTO public.who_global_data VALUES (83020, 0, 0, 0, 0, 351, 61);
INSERT INTO public.who_global_data VALUES (83021, 0, 0, 0, 0, 351, 7);
INSERT INTO public.who_global_data VALUES (83022, 0, 1, 0, 0, 351, 169);
INSERT INTO public.who_global_data VALUES (83023, 0, 12, 0, 1, 351, 28);
INSERT INTO public.who_global_data VALUES (83024, 0, 0, 0, 0, 351, 85);
INSERT INTO public.who_global_data VALUES (83025, 0, 0, 0, 0, 351, 211);
INSERT INTO public.who_global_data VALUES (83026, 0, 0, 0, 0, 351, 60);
INSERT INTO public.who_global_data VALUES (83027, 0, 0, 0, 0, 351, 3);
INSERT INTO public.who_global_data VALUES (83028, 0, 0, 0, 0, 351, 11);
INSERT INTO public.who_global_data VALUES (83029, 0, 15, 0, 0, 351, 89);
INSERT INTO public.who_global_data VALUES (83030, 0, 0, 0, 0, 351, 24);
INSERT INTO public.who_global_data VALUES (83031, 0, 0, 0, 0, 351, 162);
INSERT INTO public.who_global_data VALUES (83032, 0, 0, 0, 0, 351, 100);
INSERT INTO public.who_global_data VALUES (83033, 0, 0, 0, 0, 351, 47);
INSERT INTO public.who_global_data VALUES (83034, 0, 0, 0, 0, 351, 29);
INSERT INTO public.who_global_data VALUES (83035, 0, 0, 0, 0, 351, 40);
INSERT INTO public.who_global_data VALUES (83036, 0, 0, 0, 0, 351, 222);
INSERT INTO public.who_global_data VALUES (83037, 0, 0, 0, 0, 351, 132);
INSERT INTO public.who_global_data VALUES (83038, 0, 0, 0, 0, 351, 130);
INSERT INTO public.who_global_data VALUES (83039, 0, 0, 0, 0, 351, 234);
INSERT INTO public.who_global_data VALUES (83040, 0, 0, 0, 0, 351, 23);
INSERT INTO public.who_global_data VALUES (83041, 0, 0, 0, 0, 351, 192);
INSERT INTO public.who_global_data VALUES (83042, 0, 0, 0, 0, 351, 69);
INSERT INTO public.who_global_data VALUES (83043, 0, 0, 0, 0, 351, 187);
INSERT INTO public.who_global_data VALUES (83044, 0, 0, 0, 0, 351, 230);
INSERT INTO public.who_global_data VALUES (83045, 0, 0, 0, 0, 351, 77);
INSERT INTO public.who_global_data VALUES (83046, 0, 0, 0, 0, 351, 9);
INSERT INTO public.who_global_data VALUES (83047, 0, 7, 0, 0, 351, 74);
INSERT INTO public.who_global_data VALUES (83048, 0, 0, 0, 0, 351, 224);
INSERT INTO public.who_global_data VALUES (83049, 13, 22, 2, 4, 351, 199);
INSERT INTO public.who_global_data VALUES (83050, 0, 0, 0, 0, 351, 190);
INSERT INTO public.who_global_data VALUES (83051, 0, 0, 0, 0, 351, 12);
INSERT INTO public.who_global_data VALUES (83052, 0, 0, 0, 0, 351, 104);
INSERT INTO public.who_global_data VALUES (83053, 1, 1, 0, 0, 351, 153);
INSERT INTO public.who_global_data VALUES (83054, 0, 3, 0, 0, 351, 91);
INSERT INTO public.who_global_data VALUES (83055, 0, 0, 0, 0, 351, 215);
INSERT INTO public.who_global_data VALUES (83056, 12, 109, 0, 1, 351, 84);
INSERT INTO public.who_global_data VALUES (83057, 0, 0, 0, 0, 351, 231);
INSERT INTO public.who_global_data VALUES (83058, 0, 0, 0, 0, 351, 196);
INSERT INTO public.who_global_data VALUES (83059, 0, 0, 0, 0, 351, 105);
INSERT INTO public.who_global_data VALUES (83060, 0, 0, 0, 0, 351, 122);
INSERT INTO public.who_global_data VALUES (83061, 0, 0, 0, 0, 351, 159);
INSERT INTO public.who_global_data VALUES (83062, 0, 0, 0, 0, 351, 75);
INSERT INTO public.who_global_data VALUES (83063, 0, 0, 0, 0, 351, 27);
INSERT INTO public.who_global_data VALUES (83064, 0, 0, 0, 0, 351, 54);
INSERT INTO public.who_global_data VALUES (83065, 0, 0, 0, 0, 351, 226);
INSERT INTO public.who_global_data VALUES (83066, 0, 0, 0, 0, 351, 79);
INSERT INTO public.who_global_data VALUES (83067, 5, 5, 0, 0, 351, 56);
INSERT INTO public.who_global_data VALUES (83068, 0, 0, 0, 0, 351, 117);
INSERT INTO public.who_global_data VALUES (83069, 0, 0, 0, 0, 351, 152);
INSERT INTO public.who_global_data VALUES (83070, 0, 0, 0, 0, 351, 16);
INSERT INTO public.who_global_data VALUES (83071, 0, 0, 0, 0, 351, 10);
INSERT INTO public.who_global_data VALUES (83072, 0, 0, 0, 0, 351, 201);
INSERT INTO public.who_global_data VALUES (83073, 0, 0, 0, 0, 351, 174);
INSERT INTO public.who_global_data VALUES (83074, 0, 0, 0, 0, 351, 119);
INSERT INTO public.who_global_data VALUES (83075, 0, 0, 0, 0, 351, 168);
INSERT INTO public.who_global_data VALUES (83076, 0, 26, 0, 0, 351, 99);
INSERT INTO public.who_global_data VALUES (83077, 0, 0, 0, 0, 351, 171);
INSERT INTO public.who_global_data VALUES (83078, 0, 0, 0, 0, 351, 87);
INSERT INTO public.who_global_data VALUES (83079, 0, 0, 0, 0, 351, 123);
INSERT INTO public.who_global_data VALUES (83080, 0, 0, 0, 0, 351, 151);
INSERT INTO public.who_global_data VALUES (83081, 0, 0, 0, 0, 351, 213);
INSERT INTO public.who_global_data VALUES (83082, 0, 0, 0, 0, 351, 118);
INSERT INTO public.who_global_data VALUES (83083, 0, 0, 0, 0, 351, 134);
INSERT INTO public.who_global_data VALUES (83084, 0, 0, 0, 0, 351, 65);
INSERT INTO public.who_global_data VALUES (83085, 0, 0, 0, 0, 351, 102);
INSERT INTO public.who_global_data VALUES (83086, 0, 0, 0, 0, 351, 223);
INSERT INTO public.who_global_data VALUES (83087, 0, 0, 0, 0, 351, 4);
INSERT INTO public.who_global_data VALUES (83088, 0, 0, 0, 0, 351, 146);
INSERT INTO public.who_global_data VALUES (83089, 0, 0, 0, 0, 351, 31);
INSERT INTO public.who_global_data VALUES (83090, 0, 0, 0, 0, 351, 127);
INSERT INTO public.who_global_data VALUES (83091, 0, 0, 0, 0, 351, 22);
INSERT INTO public.who_global_data VALUES (83092, 0, 0, 0, 0, 351, 115);
INSERT INTO public.who_global_data VALUES (83093, 0, 0, 0, 0, 351, 106);
INSERT INTO public.who_global_data VALUES (83094, 0, 0, 0, 0, 351, 90);
INSERT INTO public.who_global_data VALUES (83095, 0, 0, 0, 0, 351, 70);
INSERT INTO public.who_global_data VALUES (83096, 0, 5, 0, 0, 351, 46);
INSERT INTO public.who_global_data VALUES (83097, 0, 0, 0, 0, 351, 139);
INSERT INTO public.who_global_data VALUES (83098, 0, 0, 0, 0, 351, 42);
INSERT INTO public.who_global_data VALUES (83099, 0, 0, 0, 0, 351, 80);
INSERT INTO public.who_global_data VALUES (83100, 0, 0, 0, 0, 351, 203);
INSERT INTO public.who_global_data VALUES (83101, 0, 0, 0, 0, 351, 136);
INSERT INTO public.who_global_data VALUES (83102, 0, 0, 0, 0, 351, 63);
INSERT INTO public.who_global_data VALUES (83103, 0, 0, 0, 0, 351, 17);
INSERT INTO public.who_global_data VALUES (83104, 0, 0, 0, 0, 351, 172);
INSERT INTO public.who_global_data VALUES (83105, 0, 0, 0, 0, 351, 109);
INSERT INTO public.who_global_data VALUES (83106, 0, 0, 0, 0, 351, 200);
INSERT INTO public.who_global_data VALUES (83107, 0, 0, 0, 0, 351, 93);
INSERT INTO public.who_global_data VALUES (83108, 0, 0, 0, 0, 351, 5);
INSERT INTO public.who_global_data VALUES (83109, 0, 638, 0, 2, 351, 214);
INSERT INTO public.who_global_data VALUES (83110, 0, 0, 0, 0, 351, 204);
INSERT INTO public.who_global_data VALUES (83111, 0, 0, 0, 0, 351, 198);
INSERT INTO public.who_global_data VALUES (83112, 0, 0, 0, 0, 351, 173);
INSERT INTO public.who_global_data VALUES (83113, 0, 0, 0, 0, 351, 229);
INSERT INTO public.who_global_data VALUES (83114, 0, 0, 0, 0, 351, 76);
INSERT INTO public.who_global_data VALUES (83115, 0, 0, 0, 0, 351, 138);
INSERT INTO public.who_global_data VALUES (83116, 0, 7, 0, 1, 351, 98);
INSERT INTO public.who_global_data VALUES (83117, 0, 0, 0, 0, 351, 103);
INSERT INTO public.who_global_data VALUES (83118, 0, 0, 0, 0, 351, 225);
INSERT INTO public.who_global_data VALUES (83119, 0, 0, 0, 0, 351, 131);
INSERT INTO public.who_global_data VALUES (83120, 0, 0, 0, 0, 351, 235);
INSERT INTO public.who_global_data VALUES (83121, 0, 0, 0, 0, 351, 137);
INSERT INTO public.who_global_data VALUES (83122, 100, 208, 0, 1, 351, 81);
INSERT INTO public.who_global_data VALUES (83123, 0, 0, 0, 0, 351, 182);
INSERT INTO public.who_global_data VALUES (83124, 0, 0, 0, 0, 351, 145);
INSERT INTO public.who_global_data VALUES (83125, 0, 0, 0, 0, 351, 26);
INSERT INTO public.who_global_data VALUES (83126, 0, 2, 0, 0, 351, 170);
INSERT INTO public.who_global_data VALUES (83127, 0, 0, 0, 0, 351, 191);
INSERT INTO public.who_global_data VALUES (83128, 0, 0, 0, 0, 351, 221);
INSERT INTO public.who_global_data VALUES (83129, 0, 0, 0, 0, 351, 64);
INSERT INTO public.who_global_data VALUES (83130, 0, 0, 0, 0, 351, 116);
INSERT INTO public.who_global_data VALUES (83131, 0, 0, 0, 0, 351, 128);
INSERT INTO public.who_global_data VALUES (83132, 0, 0, 0, 0, 351, 6);
INSERT INTO public.who_global_data VALUES (83133, 0, 0, 0, 0, 351, 227);
INSERT INTO public.who_global_data VALUES (83134, 0, 0, 0, 0, 351, 68);
INSERT INTO public.who_global_data VALUES (83135, 0, 0, 0, 0, 351, 184);
INSERT INTO public.who_global_data VALUES (83136, 0, 0, 0, 0, 351, 82);
INSERT INTO public.who_global_data VALUES (83137, 0, 0, 0, 0, 351, 149);
INSERT INTO public.who_global_data VALUES (83138, 0, 0, 0, 0, 351, 197);
INSERT INTO public.who_global_data VALUES (83139, 0, 0, 0, 0, 351, 78);
INSERT INTO public.who_global_data VALUES (83140, 0, 0, 0, 0, 351, 233);
INSERT INTO public.who_global_data VALUES (83141, 0, 0, 0, 0, 351, 133);
INSERT INTO public.who_global_data VALUES (83142, 0, 0, 0, 0, 351, 35);
INSERT INTO public.who_global_data VALUES (83143, 0, 0, 0, 0, 351, 114);
INSERT INTO public.who_global_data VALUES (83144, 1, 90, 0, 0, 351, 237);
INSERT INTO public.who_global_data VALUES (83145, 0, 0, 0, 0, 351, 55);
INSERT INTO public.who_global_data VALUES (83146, 0, 0, 0, 0, 351, 176);
INSERT INTO public.who_global_data VALUES (83147, 0, 0, 0, 0, 351, 202);
INSERT INTO public.who_global_data VALUES (83148, 0, 0, 0, 0, 351, 155);
INSERT INTO public.who_global_data VALUES (83149, 0, 0, 0, 0, 351, 32);
INSERT INTO public.who_global_data VALUES (83150, 0, 0, 0, 0, 351, 220);
INSERT INTO public.who_global_data VALUES (83151, 0, 0, 0, 0, 351, 30);
INSERT INTO public.who_global_data VALUES (83152, 0, 0, 0, 0, 351, 147);
INSERT INTO public.who_global_data VALUES (83153, 0, 29, 0, 1, 351, 208);
INSERT INTO public.who_global_data VALUES (83154, 0, 5, 0, 0, 351, 45);
INSERT INTO public.who_global_data VALUES (83155, 0, 0, 0, 0, 351, 110);
INSERT INTO public.who_global_data VALUES (83156, 0, 0, 0, 0, 351, 88);
INSERT INTO public.who_global_data VALUES (83157, 0, 1, 0, 0, 351, 51);
INSERT INTO public.who_global_data VALUES (83158, 0, 0, 0, 0, 351, 209);
INSERT INTO public.who_global_data VALUES (83159, 0, 0, 0, 0, 351, 205);
INSERT INTO public.who_global_data VALUES (83160, 0, 0, 0, 0, 351, 18);
INSERT INTO public.who_global_data VALUES (83161, 0, 39, 0, 0, 351, 72);
INSERT INTO public.who_global_data VALUES (83162, 0, 10, 0, 0, 351, 44);
INSERT INTO public.who_global_data VALUES (83163, 0, 0, 0, 0, 351, 15);
INSERT INTO public.who_global_data VALUES (83164, 0, 0, 0, 0, 351, 25);
INSERT INTO public.who_global_data VALUES (83165, 0, 0, 0, 0, 351, 179);
INSERT INTO public.who_global_data VALUES (83166, 0, 0, 0, 0, 351, 34);
INSERT INTO public.who_global_data VALUES (83167, 0, 0, 0, 0, 351, 207);
INSERT INTO public.who_global_data VALUES (83168, 0, 0, 0, 0, 351, 166);
INSERT INTO public.who_global_data VALUES (83169, 0, 0, 0, 0, 351, 126);
INSERT INTO public.who_global_data VALUES (83170, 0, 0, 0, 0, 351, 97);
INSERT INTO public.who_global_data VALUES (83171, 0, 0, 0, 0, 351, 36);
INSERT INTO public.who_global_data VALUES (83172, 0, 0, 0, 0, 351, 125);
INSERT INTO public.who_global_data VALUES (83173, 0, 0, 0, 0, 351, 124);
INSERT INTO public.who_global_data VALUES (83174, 0, 0, 0, 0, 351, 185);
INSERT INTO public.who_global_data VALUES (83175, 2, 15, 0, 0, 351, 194);
INSERT INTO public.who_global_data VALUES (83176, 0, 0, 0, 0, 351, 144);
INSERT INTO public.who_global_data VALUES (83177, 19, 38, 0, 0, 351, 19);
INSERT INTO public.who_global_data VALUES (83178, 0, 0, 0, 0, 351, 217);
INSERT INTO public.who_global_data VALUES (83179, 0, 0, 0, 0, 351, 148);
INSERT INTO public.who_global_data VALUES (83180, 0, 0, 0, 0, 351, 86);
INSERT INTO public.who_global_data VALUES (83181, 0, 0, 0, 0, 351, 13);
INSERT INTO public.who_global_data VALUES (83182, 0, 0, 0, 0, 351, 157);
INSERT INTO public.who_global_data VALUES (83183, 0, 20, 0, 0, 351, 8);
INSERT INTO public.who_global_data VALUES (83184, 0, 0, 0, 0, 351, 73);
INSERT INTO public.who_global_data VALUES (83185, 0, 0, 0, 0, 351, 101);
INSERT INTO public.who_global_data VALUES (83186, 0, 0, 0, 0, 351, 165);
INSERT INTO public.who_global_data VALUES (83187, 0, 0, 0, 0, 351, 14);
INSERT INTO public.who_global_data VALUES (83188, 0, 0, 0, 0, 352, 193);
INSERT INTO public.who_global_data VALUES (83189, 0, 0, 0, 0, 352, 113);
INSERT INTO public.who_global_data VALUES (83190, 0, 0, 0, 0, 352, 143);
INSERT INTO public.who_global_data VALUES (83191, 0, 0, 0, 0, 352, 219);
INSERT INTO public.who_global_data VALUES (83192, 0, 0, 0, 0, 352, 186);
INSERT INTO public.who_global_data VALUES (83193, 0, 0, 0, 0, 352, 52);
INSERT INTO public.who_global_data VALUES (83194, 0, 0, 0, 0, 352, 180);
INSERT INTO public.who_global_data VALUES (83195, 0, 0, 0, 0, 352, 167);
INSERT INTO public.who_global_data VALUES (83196, 0, 0, 0, 0, 352, 154);
INSERT INTO public.who_global_data VALUES (83197, 0, 0, 0, 0, 352, 94);
INSERT INTO public.who_global_data VALUES (83198, 0, 0, 0, 0, 352, 66);
INSERT INTO public.who_global_data VALUES (83199, 0, 19, 0, 0, 352, 58);
INSERT INTO public.who_global_data VALUES (83200, 0, 0, 0, 0, 352, 163);
INSERT INTO public.who_global_data VALUES (83201, 0, 0, 0, 0, 352, 37);
INSERT INTO public.who_global_data VALUES (83202, 0, 0, 0, 0, 352, 142);
INSERT INTO public.who_global_data VALUES (83203, 0, 0, 0, 0, 352, 83);
INSERT INTO public.who_global_data VALUES (83204, 0, 0, 0, 0, 352, 228);
INSERT INTO public.who_global_data VALUES (83205, 0, 0, 0, 0, 352, 188);
INSERT INTO public.who_global_data VALUES (83206, 0, 0, 0, 0, 352, 62);
INSERT INTO public.who_global_data VALUES (83207, 0, 1, 0, 0, 352, 160);
INSERT INTO public.who_global_data VALUES (83208, 0, 0, 0, 0, 352, 50);
INSERT INTO public.who_global_data VALUES (83209, 0, 0, 0, 0, 352, 33);
INSERT INTO public.who_global_data VALUES (83210, 0, 0, 0, 0, 352, 183);
INSERT INTO public.who_global_data VALUES (83211, 0, 0, 0, 0, 352, 92);
INSERT INTO public.who_global_data VALUES (83212, 0, 0, 0, 0, 352, 158);
INSERT INTO public.who_global_data VALUES (83213, 0, 0, 0, 0, 352, 67);
INSERT INTO public.who_global_data VALUES (83214, 0, 0, 0, 0, 352, 57);
INSERT INTO public.who_global_data VALUES (83215, 0, 0, 0, 0, 352, 38);
INSERT INTO public.who_global_data VALUES (83216, 0, 0, 0, 0, 352, 141);
INSERT INTO public.who_global_data VALUES (83217, 0, 0, 0, 0, 352, 178);
INSERT INTO public.who_global_data VALUES (83218, 0, 0, 0, 0, 352, 108);
INSERT INTO public.who_global_data VALUES (83219, 0, 0, 0, 0, 352, 39);
INSERT INTO public.who_global_data VALUES (83220, 0, 0, 0, 0, 352, 2);
INSERT INTO public.who_global_data VALUES (83221, 0, 0, 0, 0, 352, 195);
INSERT INTO public.who_global_data VALUES (83222, 0, 0, 0, 0, 352, 107);
INSERT INTO public.who_global_data VALUES (83223, 0, 5, 0, 0, 352, 161);
INSERT INTO public.who_global_data VALUES (83224, 0, 0, 0, 0, 352, 212);
INSERT INTO public.who_global_data VALUES (83225, 0, 12, 0, 0, 352, 181);
INSERT INTO public.who_global_data VALUES (83226, 0, 0, 0, 0, 352, 53);
INSERT INTO public.who_global_data VALUES (83227, 0, 0, 0, 0, 352, 164);
INSERT INTO public.who_global_data VALUES (83228, 0, 0, 0, 0, 352, 140);
INSERT INTO public.who_global_data VALUES (83229, 0, 0, 0, 0, 352, 20);
INSERT INTO public.who_global_data VALUES (83230, 396, 74679, 115, 2121, 352, 112);
INSERT INTO public.who_global_data VALUES (83231, 0, 0, 0, 0, 352, 111);
INSERT INTO public.who_global_data VALUES (83232, 0, 0, 0, 0, 352, 71);
INSERT INTO public.who_global_data VALUES (83233, 0, 0, 0, 0, 352, 218);
INSERT INTO public.who_global_data VALUES (83234, 0, 0, 0, 0, 352, 43);
INSERT INTO public.who_global_data VALUES (83235, 0, 0, 0, 0, 352, 49);
INSERT INTO public.who_global_data VALUES (83236, 0, 0, 0, 0, 352, 1);
INSERT INTO public.who_global_data VALUES (83237, 0, 0, 0, 0, 352, 48);
INSERT INTO public.who_global_data VALUES (83238, 0, 0, 0, 0, 352, 232);
INSERT INTO public.who_global_data VALUES (83239, 0, 0, 0, 0, 352, 175);
INSERT INTO public.who_global_data VALUES (83240, 0, 0, 0, 0, 352, 21);
INSERT INTO public.who_global_data VALUES (83241, 0, 0, 0, 0, 352, 156);
INSERT INTO public.who_global_data VALUES (83242, 0, 0, 0, 0, 352, 95);
INSERT INTO public.who_global_data VALUES (83243, 0, 0, 0, 0, 352, 177);
INSERT INTO public.who_global_data VALUES (83244, 0, 0, 0, 0, 352, 210);
INSERT INTO public.who_global_data VALUES (83245, 0, 0, 0, 0, 352, 120);
INSERT INTO public.who_global_data VALUES (83246, 0, 0, 0, 0, 352, 135);
INSERT INTO public.who_global_data VALUES (83247, 0, 0, 0, 0, 352, 206);
INSERT INTO public.who_global_data VALUES (83248, 0, 0, 0, 0, 352, 189);
INSERT INTO public.who_global_data VALUES (83249, 0, 5, 0, 0, 352, 129);
INSERT INTO public.who_global_data VALUES (83250, 0, 0, 0, 0, 352, 121);
INSERT INTO public.who_global_data VALUES (83251, 0, 0, 0, 0, 352, 59);
INSERT INTO public.who_global_data VALUES (83252, 0, 0, 0, 0, 352, 96);
INSERT INTO public.who_global_data VALUES (83253, 0, 0, 0, 0, 352, 41);
INSERT INTO public.who_global_data VALUES (83254, 0, 0, 0, 0, 352, 216);
INSERT INTO public.who_global_data VALUES (83255, 0, 0, 0, 0, 352, 236);
INSERT INTO public.who_global_data VALUES (83256, 0, 0, 0, 0, 352, 150);
INSERT INTO public.who_global_data VALUES (83257, 0, 0, 0, 0, 352, 61);
INSERT INTO public.who_global_data VALUES (83258, 0, 0, 0, 0, 352, 7);
INSERT INTO public.who_global_data VALUES (83259, 0, 1, 0, 0, 352, 169);
INSERT INTO public.who_global_data VALUES (83260, 0, 12, 0, 1, 352, 28);
INSERT INTO public.who_global_data VALUES (83261, 0, 0, 0, 0, 352, 85);
INSERT INTO public.who_global_data VALUES (83262, 0, 0, 0, 0, 352, 211);
INSERT INTO public.who_global_data VALUES (83263, 0, 0, 0, 0, 352, 60);
INSERT INTO public.who_global_data VALUES (83264, 0, 0, 0, 0, 352, 3);
INSERT INTO public.who_global_data VALUES (83265, 0, 0, 0, 0, 352, 11);
INSERT INTO public.who_global_data VALUES (83266, 0, 15, 0, 0, 352, 89);
INSERT INTO public.who_global_data VALUES (83267, 0, 0, 0, 0, 352, 24);
INSERT INTO public.who_global_data VALUES (83268, 0, 0, 0, 0, 352, 162);
INSERT INTO public.who_global_data VALUES (83269, 0, 0, 0, 0, 352, 100);
INSERT INTO public.who_global_data VALUES (83270, 0, 0, 0, 0, 352, 47);
INSERT INTO public.who_global_data VALUES (83271, 0, 0, 0, 0, 352, 29);
INSERT INTO public.who_global_data VALUES (83272, 0, 0, 0, 0, 352, 40);
INSERT INTO public.who_global_data VALUES (83273, 0, 0, 0, 0, 352, 222);
INSERT INTO public.who_global_data VALUES (83274, 0, 0, 0, 0, 352, 132);
INSERT INTO public.who_global_data VALUES (83275, 0, 0, 0, 0, 352, 130);
INSERT INTO public.who_global_data VALUES (83276, 0, 0, 0, 0, 352, 234);
INSERT INTO public.who_global_data VALUES (83277, 0, 0, 0, 0, 352, 23);
INSERT INTO public.who_global_data VALUES (83278, 0, 0, 0, 0, 352, 192);
INSERT INTO public.who_global_data VALUES (83279, 0, 0, 0, 0, 352, 69);
INSERT INTO public.who_global_data VALUES (83280, 0, 0, 0, 0, 352, 187);
INSERT INTO public.who_global_data VALUES (83281, 0, 0, 0, 0, 352, 230);
INSERT INTO public.who_global_data VALUES (83282, 0, 0, 0, 0, 352, 77);
INSERT INTO public.who_global_data VALUES (83283, 0, 0, 0, 0, 352, 9);
INSERT INTO public.who_global_data VALUES (83284, 0, 7, 0, 0, 352, 74);
INSERT INTO public.who_global_data VALUES (83285, 0, 0, 0, 0, 352, 224);
INSERT INTO public.who_global_data VALUES (83286, 3, 9, 0, 2, 352, 199);
INSERT INTO public.who_global_data VALUES (83287, 0, 0, 0, 0, 352, 190);
INSERT INTO public.who_global_data VALUES (83288, 0, 0, 0, 0, 352, 12);
INSERT INTO public.who_global_data VALUES (83289, 0, 0, 0, 0, 352, 104);
INSERT INTO public.who_global_data VALUES (83290, 0, 0, 0, 0, 352, 153);
INSERT INTO public.who_global_data VALUES (83291, 0, 3, 0, 0, 352, 91);
INSERT INTO public.who_global_data VALUES (83292, 0, 0, 0, 0, 352, 215);
INSERT INTO public.who_global_data VALUES (83293, 20, 97, 0, 1, 352, 84);
INSERT INTO public.who_global_data VALUES (83294, 0, 0, 0, 0, 352, 231);
INSERT INTO public.who_global_data VALUES (83295, 0, 0, 0, 0, 352, 196);
INSERT INTO public.who_global_data VALUES (83296, 0, 0, 0, 0, 352, 105);
INSERT INTO public.who_global_data VALUES (83297, 0, 0, 0, 0, 352, 122);
INSERT INTO public.who_global_data VALUES (83298, 0, 0, 0, 0, 352, 159);
INSERT INTO public.who_global_data VALUES (83299, 0, 0, 0, 0, 352, 75);
INSERT INTO public.who_global_data VALUES (83300, 0, 0, 0, 0, 352, 27);
INSERT INTO public.who_global_data VALUES (83301, 0, 0, 0, 0, 352, 54);
INSERT INTO public.who_global_data VALUES (83302, 0, 0, 0, 0, 352, 226);
INSERT INTO public.who_global_data VALUES (83303, 0, 0, 0, 0, 352, 79);
INSERT INTO public.who_global_data VALUES (83304, 0, 0, 0, 0, 352, 56);
INSERT INTO public.who_global_data VALUES (83305, 0, 0, 0, 0, 352, 117);
INSERT INTO public.who_global_data VALUES (83306, 0, 0, 0, 0, 352, 152);
INSERT INTO public.who_global_data VALUES (83307, 0, 0, 0, 0, 352, 16);
INSERT INTO public.who_global_data VALUES (83308, 0, 0, 0, 0, 352, 10);
INSERT INTO public.who_global_data VALUES (83309, 0, 0, 0, 0, 352, 201);
INSERT INTO public.who_global_data VALUES (83310, 0, 0, 0, 0, 352, 174);
INSERT INTO public.who_global_data VALUES (83311, 0, 0, 0, 0, 352, 119);
INSERT INTO public.who_global_data VALUES (83312, 0, 0, 0, 0, 352, 168);
INSERT INTO public.who_global_data VALUES (83313, 0, 26, 0, 0, 352, 99);
INSERT INTO public.who_global_data VALUES (83314, 0, 0, 0, 0, 352, 171);
INSERT INTO public.who_global_data VALUES (83315, 0, 0, 0, 0, 352, 87);
INSERT INTO public.who_global_data VALUES (83316, 0, 0, 0, 0, 352, 123);
INSERT INTO public.who_global_data VALUES (83317, 0, 0, 0, 0, 352, 151);
INSERT INTO public.who_global_data VALUES (83318, 0, 0, 0, 0, 352, 213);
INSERT INTO public.who_global_data VALUES (83319, 0, 0, 0, 0, 352, 118);
INSERT INTO public.who_global_data VALUES (83320, 0, 0, 0, 0, 352, 134);
INSERT INTO public.who_global_data VALUES (83321, 0, 0, 0, 0, 352, 65);
INSERT INTO public.who_global_data VALUES (83322, 0, 0, 0, 0, 352, 102);
INSERT INTO public.who_global_data VALUES (83323, 0, 0, 0, 0, 352, 223);
INSERT INTO public.who_global_data VALUES (83324, 0, 0, 0, 0, 352, 4);
INSERT INTO public.who_global_data VALUES (83325, 0, 0, 0, 0, 352, 146);
INSERT INTO public.who_global_data VALUES (83326, 0, 0, 0, 0, 352, 31);
INSERT INTO public.who_global_data VALUES (83327, 0, 0, 0, 0, 352, 127);
INSERT INTO public.who_global_data VALUES (83328, 0, 0, 0, 0, 352, 22);
INSERT INTO public.who_global_data VALUES (83329, 0, 0, 0, 0, 352, 115);
INSERT INTO public.who_global_data VALUES (83330, 0, 0, 0, 0, 352, 106);
INSERT INTO public.who_global_data VALUES (83331, 0, 0, 0, 0, 352, 90);
INSERT INTO public.who_global_data VALUES (83332, 0, 0, 0, 0, 352, 70);
INSERT INTO public.who_global_data VALUES (83333, 0, 5, 0, 0, 352, 46);
INSERT INTO public.who_global_data VALUES (83334, 0, 0, 0, 0, 352, 139);
INSERT INTO public.who_global_data VALUES (83335, 0, 0, 0, 0, 352, 42);
INSERT INTO public.who_global_data VALUES (83336, 0, 0, 0, 0, 352, 80);
INSERT INTO public.who_global_data VALUES (83337, 0, 0, 0, 0, 352, 203);
INSERT INTO public.who_global_data VALUES (83338, 0, 0, 0, 0, 352, 136);
INSERT INTO public.who_global_data VALUES (83339, 0, 0, 0, 0, 352, 63);
INSERT INTO public.who_global_data VALUES (83340, 0, 0, 0, 0, 352, 17);
INSERT INTO public.who_global_data VALUES (83341, 0, 0, 0, 0, 352, 172);
INSERT INTO public.who_global_data VALUES (83342, 0, 0, 0, 0, 352, 109);
INSERT INTO public.who_global_data VALUES (83343, 0, 0, 0, 0, 352, 200);
INSERT INTO public.who_global_data VALUES (83344, 0, 0, 0, 0, 352, 93);
INSERT INTO public.who_global_data VALUES (83345, 0, 0, 0, 0, 352, 5);
INSERT INTO public.who_global_data VALUES (83346, 13, 638, 2, 2, 352, 214);
INSERT INTO public.who_global_data VALUES (83347, 0, 0, 0, 0, 352, 204);
INSERT INTO public.who_global_data VALUES (83348, 0, 0, 0, 0, 352, 198);
INSERT INTO public.who_global_data VALUES (83349, 0, 0, 0, 0, 352, 173);
INSERT INTO public.who_global_data VALUES (83350, 0, 0, 0, 0, 352, 229);
INSERT INTO public.who_global_data VALUES (83351, 0, 0, 0, 0, 352, 76);
INSERT INTO public.who_global_data VALUES (83352, 0, 0, 0, 0, 352, 138);
INSERT INTO public.who_global_data VALUES (83353, 0, 7, 0, 1, 352, 98);
INSERT INTO public.who_global_data VALUES (83354, 0, 0, 0, 0, 352, 103);
INSERT INTO public.who_global_data VALUES (83355, 0, 0, 0, 0, 352, 225);
INSERT INTO public.who_global_data VALUES (83356, 0, 0, 0, 0, 352, 131);
INSERT INTO public.who_global_data VALUES (83357, 0, 0, 0, 0, 352, 235);
INSERT INTO public.who_global_data VALUES (83358, 0, 0, 0, 0, 352, 137);
INSERT INTO public.who_global_data VALUES (83359, 53, 108, 1, 1, 352, 81);
INSERT INTO public.who_global_data VALUES (83360, 0, 0, 0, 0, 352, 182);
INSERT INTO public.who_global_data VALUES (83361, 0, 0, 0, 0, 352, 145);
INSERT INTO public.who_global_data VALUES (83362, 0, 0, 0, 0, 352, 26);
INSERT INTO public.who_global_data VALUES (83363, 0, 2, 0, 0, 352, 170);
INSERT INTO public.who_global_data VALUES (83364, 0, 0, 0, 0, 352, 191);
INSERT INTO public.who_global_data VALUES (83365, 0, 0, 0, 0, 352, 221);
INSERT INTO public.who_global_data VALUES (83366, 0, 0, 0, 0, 352, 64);
INSERT INTO public.who_global_data VALUES (83367, 0, 0, 0, 0, 352, 116);
INSERT INTO public.who_global_data VALUES (83368, 0, 0, 0, 0, 352, 128);
INSERT INTO public.who_global_data VALUES (83369, 0, 0, 0, 0, 352, 6);
INSERT INTO public.who_global_data VALUES (83370, 0, 0, 0, 0, 352, 227);
INSERT INTO public.who_global_data VALUES (83371, 0, 0, 0, 0, 352, 68);
INSERT INTO public.who_global_data VALUES (83372, 0, 0, 0, 0, 352, 184);
INSERT INTO public.who_global_data VALUES (83373, 0, 0, 0, 0, 352, 82);
INSERT INTO public.who_global_data VALUES (83374, 0, 0, 0, 0, 352, 149);
INSERT INTO public.who_global_data VALUES (83375, 0, 0, 0, 0, 352, 197);
INSERT INTO public.who_global_data VALUES (83376, 0, 0, 0, 0, 352, 78);
INSERT INTO public.who_global_data VALUES (83377, 0, 0, 0, 0, 352, 233);
INSERT INTO public.who_global_data VALUES (83378, 0, 0, 0, 0, 352, 133);
INSERT INTO public.who_global_data VALUES (83379, 0, 0, 0, 0, 352, 35);
INSERT INTO public.who_global_data VALUES (83380, 0, 0, 0, 0, 352, 114);
INSERT INTO public.who_global_data VALUES (83381, 1, 89, 0, 0, 352, 237);
INSERT INTO public.who_global_data VALUES (83382, 0, 0, 0, 0, 352, 55);
INSERT INTO public.who_global_data VALUES (83383, 0, 0, 0, 0, 352, 176);
INSERT INTO public.who_global_data VALUES (83384, 0, 0, 0, 0, 352, 202);
INSERT INTO public.who_global_data VALUES (83385, 0, 0, 0, 0, 352, 155);
INSERT INTO public.who_global_data VALUES (83386, 0, 0, 0, 0, 352, 32);
INSERT INTO public.who_global_data VALUES (83387, 0, 0, 0, 0, 352, 220);
INSERT INTO public.who_global_data VALUES (83388, 0, 0, 0, 0, 352, 30);
INSERT INTO public.who_global_data VALUES (83389, 0, 0, 0, 0, 352, 147);
INSERT INTO public.who_global_data VALUES (83390, 0, 29, 0, 1, 352, 208);
INSERT INTO public.who_global_data VALUES (83391, 0, 5, 0, 0, 352, 45);
INSERT INTO public.who_global_data VALUES (83392, 0, 0, 0, 0, 352, 110);
INSERT INTO public.who_global_data VALUES (83393, 0, 0, 0, 0, 352, 88);
INSERT INTO public.who_global_data VALUES (83394, 0, 1, 0, 0, 352, 51);
INSERT INTO public.who_global_data VALUES (83395, 0, 0, 0, 0, 352, 209);
INSERT INTO public.who_global_data VALUES (83396, 0, 0, 0, 0, 352, 205);
INSERT INTO public.who_global_data VALUES (83397, 0, 0, 0, 0, 352, 18);
INSERT INTO public.who_global_data VALUES (83398, 0, 39, 0, 0, 352, 72);
INSERT INTO public.who_global_data VALUES (83399, 0, 10, 0, 0, 352, 44);
INSERT INTO public.who_global_data VALUES (83400, 0, 0, 0, 0, 352, 15);
INSERT INTO public.who_global_data VALUES (83401, 0, 0, 0, 0, 352, 25);
INSERT INTO public.who_global_data VALUES (83402, 0, 0, 0, 0, 352, 179);
INSERT INTO public.who_global_data VALUES (83403, 0, 0, 0, 0, 352, 34);
INSERT INTO public.who_global_data VALUES (83404, 0, 0, 0, 0, 352, 207);
INSERT INTO public.who_global_data VALUES (83405, 0, 0, 0, 0, 352, 166);
INSERT INTO public.who_global_data VALUES (83406, 0, 0, 0, 0, 352, 126);
INSERT INTO public.who_global_data VALUES (83407, 0, 0, 0, 0, 352, 97);
INSERT INTO public.who_global_data VALUES (83408, 0, 0, 0, 0, 352, 36);
INSERT INTO public.who_global_data VALUES (83409, 0, 0, 0, 0, 352, 125);
INSERT INTO public.who_global_data VALUES (83410, 0, 0, 0, 0, 352, 124);
INSERT INTO public.who_global_data VALUES (83411, 0, 0, 0, 0, 352, 185);
INSERT INTO public.who_global_data VALUES (83412, 0, 13, 0, 0, 352, 194);
INSERT INTO public.who_global_data VALUES (83413, 0, 0, 0, 0, 352, 144);
INSERT INTO public.who_global_data VALUES (83414, 0, 19, 0, 0, 352, 19);
INSERT INTO public.who_global_data VALUES (83415, 0, 0, 0, 0, 352, 217);
INSERT INTO public.who_global_data VALUES (83416, 0, 0, 0, 0, 352, 148);
INSERT INTO public.who_global_data VALUES (83417, 0, 0, 0, 0, 352, 86);
INSERT INTO public.who_global_data VALUES (83418, 0, 0, 0, 0, 352, 13);
INSERT INTO public.who_global_data VALUES (83419, 0, 0, 0, 0, 352, 157);
INSERT INTO public.who_global_data VALUES (83420, 0, 20, 0, 0, 352, 8);
INSERT INTO public.who_global_data VALUES (83421, 0, 0, 0, 0, 352, 73);
INSERT INTO public.who_global_data VALUES (83422, 0, 0, 0, 0, 352, 101);
INSERT INTO public.who_global_data VALUES (83423, 0, 0, 0, 0, 352, 165);
INSERT INTO public.who_global_data VALUES (83424, 0, 0, 0, 0, 352, 14);
INSERT INTO public.who_global_data VALUES (83425, 0, 0, 0, 0, 353, 193);
INSERT INTO public.who_global_data VALUES (83426, 0, 0, 0, 0, 353, 113);
INSERT INTO public.who_global_data VALUES (83427, 0, 0, 0, 0, 353, 143);
INSERT INTO public.who_global_data VALUES (83428, 0, 0, 0, 0, 353, 219);
INSERT INTO public.who_global_data VALUES (83429, 0, 0, 0, 0, 353, 186);
INSERT INTO public.who_global_data VALUES (83430, 0, 0, 0, 0, 353, 52);
INSERT INTO public.who_global_data VALUES (83431, 0, 0, 0, 0, 353, 180);
INSERT INTO public.who_global_data VALUES (83432, 0, 0, 0, 0, 353, 167);
INSERT INTO public.who_global_data VALUES (83433, 0, 0, 0, 0, 353, 154);
INSERT INTO public.who_global_data VALUES (83434, 0, 0, 0, 0, 353, 94);
INSERT INTO public.who_global_data VALUES (83435, 0, 0, 0, 0, 353, 66);
INSERT INTO public.who_global_data VALUES (83436, 0, 19, 0, 0, 353, 58);
INSERT INTO public.who_global_data VALUES (83437, 0, 0, 0, 0, 353, 163);
INSERT INTO public.who_global_data VALUES (83438, 0, 0, 0, 0, 353, 37);
INSERT INTO public.who_global_data VALUES (83439, 0, 0, 0, 0, 353, 142);
INSERT INTO public.who_global_data VALUES (83440, 0, 0, 0, 0, 353, 83);
INSERT INTO public.who_global_data VALUES (83441, 0, 0, 0, 0, 353, 228);
INSERT INTO public.who_global_data VALUES (83442, 0, 0, 0, 0, 353, 188);
INSERT INTO public.who_global_data VALUES (83443, 0, 0, 0, 0, 353, 62);
INSERT INTO public.who_global_data VALUES (83444, 0, 1, 0, 0, 353, 160);
INSERT INTO public.who_global_data VALUES (83445, 0, 0, 0, 0, 353, 50);
INSERT INTO public.who_global_data VALUES (83446, 0, 0, 0, 0, 353, 33);
INSERT INTO public.who_global_data VALUES (83447, 0, 0, 0, 0, 353, 183);
INSERT INTO public.who_global_data VALUES (83448, 0, 0, 0, 0, 353, 92);
INSERT INTO public.who_global_data VALUES (83449, 0, 0, 0, 0, 353, 158);
INSERT INTO public.who_global_data VALUES (83450, 0, 0, 0, 0, 353, 67);
INSERT INTO public.who_global_data VALUES (83451, 0, 0, 0, 0, 353, 57);
INSERT INTO public.who_global_data VALUES (83452, 0, 0, 0, 0, 353, 38);
INSERT INTO public.who_global_data VALUES (83453, 0, 0, 0, 0, 353, 141);
INSERT INTO public.who_global_data VALUES (83454, 0, 0, 0, 0, 353, 178);
INSERT INTO public.who_global_data VALUES (83455, 0, 0, 0, 0, 353, 108);
INSERT INTO public.who_global_data VALUES (83456, 0, 0, 0, 0, 353, 39);
INSERT INTO public.who_global_data VALUES (83457, 0, 0, 0, 0, 353, 2);
INSERT INTO public.who_global_data VALUES (83458, 0, 0, 0, 0, 353, 195);
INSERT INTO public.who_global_data VALUES (83459, 0, 0, 0, 0, 353, 107);
INSERT INTO public.who_global_data VALUES (83460, 0, 5, 0, 0, 353, 161);
INSERT INTO public.who_global_data VALUES (83461, 0, 0, 0, 0, 353, 212);
INSERT INTO public.who_global_data VALUES (83462, 0, 12, 0, 0, 353, 181);
INSERT INTO public.who_global_data VALUES (83463, 0, 0, 0, 0, 353, 53);
INSERT INTO public.who_global_data VALUES (83464, 0, 0, 0, 0, 353, 164);
INSERT INTO public.who_global_data VALUES (83465, 0, 0, 0, 0, 353, 140);
INSERT INTO public.who_global_data VALUES (83466, 0, 0, 0, 0, 353, 20);
INSERT INTO public.who_global_data VALUES (83467, 1751, 74283, 136, 2006, 353, 112);
INSERT INTO public.who_global_data VALUES (83468, 0, 0, 0, 0, 353, 111);
INSERT INTO public.who_global_data VALUES (83469, 0, 0, 0, 0, 353, 71);
INSERT INTO public.who_global_data VALUES (83470, 0, 0, 0, 0, 353, 218);
INSERT INTO public.who_global_data VALUES (83471, 0, 0, 0, 0, 353, 43);
INSERT INTO public.who_global_data VALUES (83472, 0, 0, 0, 0, 353, 49);
INSERT INTO public.who_global_data VALUES (83473, 0, 0, 0, 0, 353, 1);
INSERT INTO public.who_global_data VALUES (83474, 0, 0, 0, 0, 353, 48);
INSERT INTO public.who_global_data VALUES (83475, 0, 0, 0, 0, 353, 232);
INSERT INTO public.who_global_data VALUES (83476, 0, 0, 0, 0, 353, 175);
INSERT INTO public.who_global_data VALUES (83477, 0, 0, 0, 0, 353, 21);
INSERT INTO public.who_global_data VALUES (83478, 0, 0, 0, 0, 353, 156);
INSERT INTO public.who_global_data VALUES (83479, 0, 0, 0, 0, 353, 95);
INSERT INTO public.who_global_data VALUES (83480, 0, 0, 0, 0, 353, 177);
INSERT INTO public.who_global_data VALUES (83481, 0, 0, 0, 0, 353, 210);
INSERT INTO public.who_global_data VALUES (83482, 0, 0, 0, 0, 353, 120);
INSERT INTO public.who_global_data VALUES (83483, 0, 0, 0, 0, 353, 135);
INSERT INTO public.who_global_data VALUES (83484, 0, 0, 0, 0, 353, 206);
INSERT INTO public.who_global_data VALUES (83485, 0, 0, 0, 0, 353, 189);
INSERT INTO public.who_global_data VALUES (83486, 0, 5, 0, 0, 353, 129);
INSERT INTO public.who_global_data VALUES (83487, 0, 0, 0, 0, 353, 121);
INSERT INTO public.who_global_data VALUES (83488, 0, 0, 0, 0, 353, 59);
INSERT INTO public.who_global_data VALUES (83489, 0, 0, 0, 0, 353, 96);
INSERT INTO public.who_global_data VALUES (83490, 0, 0, 0, 0, 353, 41);
INSERT INTO public.who_global_data VALUES (83491, 0, 0, 0, 0, 353, 216);
INSERT INTO public.who_global_data VALUES (83492, 0, 0, 0, 0, 353, 236);
INSERT INTO public.who_global_data VALUES (83493, 0, 0, 0, 0, 353, 150);
INSERT INTO public.who_global_data VALUES (83494, 0, 0, 0, 0, 353, 61);
INSERT INTO public.who_global_data VALUES (83495, 0, 0, 0, 0, 353, 7);
INSERT INTO public.who_global_data VALUES (83496, 0, 1, 0, 0, 353, 169);
INSERT INTO public.who_global_data VALUES (83497, 0, 12, 0, 1, 353, 28);
INSERT INTO public.who_global_data VALUES (83498, 0, 0, 0, 0, 353, 85);
INSERT INTO public.who_global_data VALUES (83499, 0, 0, 0, 0, 353, 211);
INSERT INTO public.who_global_data VALUES (83500, 0, 0, 0, 0, 353, 60);
INSERT INTO public.who_global_data VALUES (83501, 0, 0, 0, 0, 353, 3);
INSERT INTO public.who_global_data VALUES (83502, 0, 0, 0, 0, 353, 11);
INSERT INTO public.who_global_data VALUES (83503, 0, 15, 0, 0, 353, 89);
INSERT INTO public.who_global_data VALUES (83504, 0, 0, 0, 0, 353, 24);
INSERT INTO public.who_global_data VALUES (83505, 0, 0, 0, 0, 353, 162);
INSERT INTO public.who_global_data VALUES (83506, 0, 0, 0, 0, 353, 100);
INSERT INTO public.who_global_data VALUES (83507, 0, 0, 0, 0, 353, 47);
INSERT INTO public.who_global_data VALUES (83508, 0, 0, 0, 0, 353, 29);
INSERT INTO public.who_global_data VALUES (83509, 0, 0, 0, 0, 353, 40);
INSERT INTO public.who_global_data VALUES (83510, 0, 0, 0, 0, 353, 222);
INSERT INTO public.who_global_data VALUES (83511, 0, 0, 0, 0, 353, 132);
INSERT INTO public.who_global_data VALUES (83512, 0, 0, 0, 0, 353, 130);
INSERT INTO public.who_global_data VALUES (83513, 0, 0, 0, 0, 353, 234);
INSERT INTO public.who_global_data VALUES (83514, 0, 0, 0, 0, 353, 23);
INSERT INTO public.who_global_data VALUES (83515, 0, 0, 0, 0, 353, 192);
INSERT INTO public.who_global_data VALUES (83516, 0, 0, 0, 0, 353, 69);
INSERT INTO public.who_global_data VALUES (83517, 0, 0, 0, 0, 353, 187);
INSERT INTO public.who_global_data VALUES (83518, 0, 0, 0, 0, 353, 230);
INSERT INTO public.who_global_data VALUES (83519, 0, 0, 0, 0, 353, 77);
INSERT INTO public.who_global_data VALUES (83520, 0, 0, 0, 0, 353, 9);
INSERT INTO public.who_global_data VALUES (83521, 0, 7, 0, 0, 353, 74);
INSERT INTO public.who_global_data VALUES (83522, 0, 0, 0, 0, 353, 224);
INSERT INTO public.who_global_data VALUES (83523, 6, 6, 2, 2, 353, 199);
INSERT INTO public.who_global_data VALUES (83524, 0, 0, 0, 0, 353, 190);
INSERT INTO public.who_global_data VALUES (83525, 0, 0, 0, 0, 353, 12);
INSERT INTO public.who_global_data VALUES (83526, 0, 0, 0, 0, 353, 104);
INSERT INTO public.who_global_data VALUES (83527, 0, 0, 0, 0, 353, 153);
INSERT INTO public.who_global_data VALUES (83528, 0, 3, 0, 0, 353, 91);
INSERT INTO public.who_global_data VALUES (83529, 0, 0, 0, 0, 353, 215);
INSERT INTO public.who_global_data VALUES (83530, 1, 77, 0, 1, 353, 84);
INSERT INTO public.who_global_data VALUES (83531, 0, 0, 0, 0, 353, 231);
INSERT INTO public.who_global_data VALUES (83532, 0, 0, 0, 0, 353, 196);
INSERT INTO public.who_global_data VALUES (83533, 0, 0, 0, 0, 353, 105);
INSERT INTO public.who_global_data VALUES (83534, 0, 0, 0, 0, 353, 122);
INSERT INTO public.who_global_data VALUES (83535, 0, 0, 0, 0, 353, 159);
INSERT INTO public.who_global_data VALUES (83536, 0, 0, 0, 0, 353, 75);
INSERT INTO public.who_global_data VALUES (83537, 0, 0, 0, 0, 353, 27);
INSERT INTO public.who_global_data VALUES (83538, 0, 0, 0, 0, 353, 54);
INSERT INTO public.who_global_data VALUES (83539, 0, 0, 0, 0, 353, 226);
INSERT INTO public.who_global_data VALUES (83540, 0, 0, 0, 0, 353, 79);
INSERT INTO public.who_global_data VALUES (83541, 0, 0, 0, 0, 353, 56);
INSERT INTO public.who_global_data VALUES (83542, 0, 0, 0, 0, 353, 117);
INSERT INTO public.who_global_data VALUES (83543, 0, 0, 0, 0, 353, 152);
INSERT INTO public.who_global_data VALUES (83544, 0, 0, 0, 0, 353, 16);
INSERT INTO public.who_global_data VALUES (83545, 0, 0, 0, 0, 353, 10);
INSERT INTO public.who_global_data VALUES (83546, 0, 0, 0, 0, 353, 201);
INSERT INTO public.who_global_data VALUES (83547, 0, 0, 0, 0, 353, 174);
INSERT INTO public.who_global_data VALUES (83548, 0, 0, 0, 0, 353, 119);
INSERT INTO public.who_global_data VALUES (83549, 0, 0, 0, 0, 353, 168);
INSERT INTO public.who_global_data VALUES (83550, 0, 26, 0, 0, 353, 99);
INSERT INTO public.who_global_data VALUES (83551, 0, 0, 0, 0, 353, 171);
INSERT INTO public.who_global_data VALUES (83552, 0, 0, 0, 0, 353, 87);
INSERT INTO public.who_global_data VALUES (83553, 0, 0, 0, 0, 353, 123);
INSERT INTO public.who_global_data VALUES (83554, 0, 0, 0, 0, 353, 151);
INSERT INTO public.who_global_data VALUES (83555, 0, 0, 0, 0, 353, 213);
INSERT INTO public.who_global_data VALUES (83556, 0, 0, 0, 0, 353, 118);
INSERT INTO public.who_global_data VALUES (83557, 0, 0, 0, 0, 353, 134);
INSERT INTO public.who_global_data VALUES (83558, 0, 0, 0, 0, 353, 65);
INSERT INTO public.who_global_data VALUES (83559, 0, 0, 0, 0, 353, 102);
INSERT INTO public.who_global_data VALUES (83560, 0, 0, 0, 0, 353, 223);
INSERT INTO public.who_global_data VALUES (83561, 0, 0, 0, 0, 353, 4);
INSERT INTO public.who_global_data VALUES (83562, 0, 0, 0, 0, 353, 146);
INSERT INTO public.who_global_data VALUES (83563, 0, 0, 0, 0, 353, 31);
INSERT INTO public.who_global_data VALUES (83564, 0, 0, 0, 0, 353, 127);
INSERT INTO public.who_global_data VALUES (83565, 0, 0, 0, 0, 353, 22);
INSERT INTO public.who_global_data VALUES (83566, 0, 0, 0, 0, 353, 115);
INSERT INTO public.who_global_data VALUES (83567, 0, 0, 0, 0, 353, 106);
INSERT INTO public.who_global_data VALUES (83568, 0, 0, 0, 0, 353, 90);
INSERT INTO public.who_global_data VALUES (83569, 0, 0, 0, 0, 353, 70);
INSERT INTO public.who_global_data VALUES (83570, 0, 5, 0, 0, 353, 46);
INSERT INTO public.who_global_data VALUES (83571, 0, 0, 0, 0, 353, 139);
INSERT INTO public.who_global_data VALUES (83572, 0, 0, 0, 0, 353, 42);
INSERT INTO public.who_global_data VALUES (83573, 0, 0, 0, 0, 353, 80);
INSERT INTO public.who_global_data VALUES (83574, 0, 0, 0, 0, 353, 203);
INSERT INTO public.who_global_data VALUES (83575, 0, 0, 0, 0, 353, 136);
INSERT INTO public.who_global_data VALUES (83576, 0, 0, 0, 0, 353, 63);
INSERT INTO public.who_global_data VALUES (83577, 0, 0, 0, 0, 353, 17);
INSERT INTO public.who_global_data VALUES (83578, 0, 0, 0, 0, 353, 172);
INSERT INTO public.who_global_data VALUES (83579, 0, 0, 0, 0, 353, 109);
INSERT INTO public.who_global_data VALUES (83580, 0, 0, 0, 0, 353, 200);
INSERT INTO public.who_global_data VALUES (83581, 0, 0, 0, 0, 353, 93);
INSERT INTO public.who_global_data VALUES (83582, 0, 0, 0, 0, 353, 5);
INSERT INTO public.who_global_data VALUES (83583, 79, 625, 0, 0, 353, 214);
INSERT INTO public.who_global_data VALUES (83584, 0, 0, 0, 0, 353, 204);
INSERT INTO public.who_global_data VALUES (83585, 0, 0, 0, 0, 353, 198);
INSERT INTO public.who_global_data VALUES (83586, 0, 0, 0, 0, 353, 173);
INSERT INTO public.who_global_data VALUES (83587, 0, 0, 0, 0, 353, 229);
INSERT INTO public.who_global_data VALUES (83588, 0, 0, 0, 0, 353, 76);
INSERT INTO public.who_global_data VALUES (83589, 0, 0, 0, 0, 353, 138);
INSERT INTO public.who_global_data VALUES (83590, 0, 7, 0, 1, 353, 98);
INSERT INTO public.who_global_data VALUES (83591, 0, 0, 0, 0, 353, 103);
INSERT INTO public.who_global_data VALUES (83592, 0, 0, 0, 0, 353, 225);
INSERT INTO public.who_global_data VALUES (83593, 0, 0, 0, 0, 353, 131);
INSERT INTO public.who_global_data VALUES (83594, 0, 0, 0, 0, 353, 235);
INSERT INTO public.who_global_data VALUES (83595, 0, 0, 0, 0, 353, 137);
INSERT INTO public.who_global_data VALUES (83596, 20, 55, 0, 0, 353, 81);
INSERT INTO public.who_global_data VALUES (83597, 0, 0, 0, 0, 353, 182);
INSERT INTO public.who_global_data VALUES (83598, 0, 0, 0, 0, 353, 145);
INSERT INTO public.who_global_data VALUES (83599, 0, 0, 0, 0, 353, 26);
INSERT INTO public.who_global_data VALUES (83600, 0, 2, 0, 0, 353, 170);
INSERT INTO public.who_global_data VALUES (83601, 0, 0, 0, 0, 353, 191);
INSERT INTO public.who_global_data VALUES (83602, 0, 0, 0, 0, 353, 221);
INSERT INTO public.who_global_data VALUES (83603, 0, 0, 0, 0, 353, 64);
INSERT INTO public.who_global_data VALUES (83604, 0, 0, 0, 0, 353, 116);
INSERT INTO public.who_global_data VALUES (83605, 0, 0, 0, 0, 353, 128);
INSERT INTO public.who_global_data VALUES (83606, 0, 0, 0, 0, 353, 6);
INSERT INTO public.who_global_data VALUES (83607, 0, 0, 0, 0, 353, 227);
INSERT INTO public.who_global_data VALUES (83608, 0, 0, 0, 0, 353, 68);
INSERT INTO public.who_global_data VALUES (83609, 0, 0, 0, 0, 353, 184);
INSERT INTO public.who_global_data VALUES (83610, 0, 0, 0, 0, 353, 82);
INSERT INTO public.who_global_data VALUES (83611, 0, 0, 0, 0, 353, 149);
INSERT INTO public.who_global_data VALUES (83612, 0, 0, 0, 0, 353, 197);
INSERT INTO public.who_global_data VALUES (83613, 0, 0, 0, 0, 353, 78);
INSERT INTO public.who_global_data VALUES (83614, 0, 0, 0, 0, 353, 233);
INSERT INTO public.who_global_data VALUES (83615, 0, 0, 0, 0, 353, 133);
INSERT INTO public.who_global_data VALUES (83616, 0, 0, 0, 0, 353, 35);
INSERT INTO public.who_global_data VALUES (83617, 0, 0, 0, 0, 353, 114);
INSERT INTO public.who_global_data VALUES (83618, 3, 88, 0, 0, 353, 237);
INSERT INTO public.who_global_data VALUES (83619, 0, 0, 0, 0, 353, 55);
INSERT INTO public.who_global_data VALUES (83620, 0, 0, 0, 0, 353, 176);
INSERT INTO public.who_global_data VALUES (83621, 0, 0, 0, 0, 353, 202);
INSERT INTO public.who_global_data VALUES (83622, 0, 0, 0, 0, 353, 155);
INSERT INTO public.who_global_data VALUES (83623, 0, 0, 0, 0, 353, 32);
INSERT INTO public.who_global_data VALUES (83624, 0, 0, 0, 0, 353, 220);
INSERT INTO public.who_global_data VALUES (83625, 0, 0, 0, 0, 353, 30);
INSERT INTO public.who_global_data VALUES (83626, 0, 0, 0, 0, 353, 147);
INSERT INTO public.who_global_data VALUES (83627, 0, 29, 0, 1, 353, 208);
INSERT INTO public.who_global_data VALUES (83628, 0, 5, 0, 0, 353, 45);
INSERT INTO public.who_global_data VALUES (83629, 0, 0, 0, 0, 353, 110);
INSERT INTO public.who_global_data VALUES (83630, 0, 0, 0, 0, 353, 88);
INSERT INTO public.who_global_data VALUES (83631, 0, 1, 0, 0, 353, 51);
INSERT INTO public.who_global_data VALUES (83632, 0, 0, 0, 0, 353, 209);
INSERT INTO public.who_global_data VALUES (83633, 0, 0, 0, 0, 353, 205);
INSERT INTO public.who_global_data VALUES (83634, 0, 0, 0, 0, 353, 18);
INSERT INTO public.who_global_data VALUES (83635, 0, 39, 0, 0, 353, 72);
INSERT INTO public.who_global_data VALUES (83636, 0, 10, 0, 0, 353, 44);
INSERT INTO public.who_global_data VALUES (83637, 0, 0, 0, 0, 353, 15);
INSERT INTO public.who_global_data VALUES (83638, 0, 0, 0, 0, 353, 25);
INSERT INTO public.who_global_data VALUES (83639, 0, 0, 0, 0, 353, 179);
INSERT INTO public.who_global_data VALUES (83640, 0, 0, 0, 0, 353, 34);
INSERT INTO public.who_global_data VALUES (83641, 0, 0, 0, 0, 353, 207);
INSERT INTO public.who_global_data VALUES (83642, 0, 0, 0, 0, 353, 166);
INSERT INTO public.who_global_data VALUES (83643, 0, 0, 0, 0, 353, 126);
INSERT INTO public.who_global_data VALUES (83644, 0, 0, 0, 0, 353, 97);
INSERT INTO public.who_global_data VALUES (83645, 0, 0, 0, 0, 353, 36);
INSERT INTO public.who_global_data VALUES (83646, 0, 0, 0, 0, 353, 125);
INSERT INTO public.who_global_data VALUES (83647, 0, 0, 0, 0, 353, 124);
INSERT INTO public.who_global_data VALUES (83648, 0, 0, 0, 0, 353, 185);
INSERT INTO public.who_global_data VALUES (83649, 0, 13, 0, 0, 353, 194);
INSERT INTO public.who_global_data VALUES (83650, 0, 0, 0, 0, 353, 144);
INSERT INTO public.who_global_data VALUES (83651, 0, 19, 0, 0, 353, 19);
INSERT INTO public.who_global_data VALUES (83652, 0, 0, 0, 0, 353, 217);
INSERT INTO public.who_global_data VALUES (83653, 0, 0, 0, 0, 353, 148);
INSERT INTO public.who_global_data VALUES (83654, 0, 0, 0, 0, 353, 86);
INSERT INTO public.who_global_data VALUES (83655, 0, 0, 0, 0, 353, 13);
INSERT INTO public.who_global_data VALUES (83656, 0, 0, 0, 0, 353, 157);
INSERT INTO public.who_global_data VALUES (83657, 0, 20, 0, 0, 353, 8);
INSERT INTO public.who_global_data VALUES (83658, 0, 0, 0, 0, 353, 73);
INSERT INTO public.who_global_data VALUES (83659, 0, 0, 0, 0, 353, 101);
INSERT INTO public.who_global_data VALUES (83660, 0, 0, 0, 0, 353, 165);
INSERT INTO public.who_global_data VALUES (83661, 0, 0, 0, 0, 353, 14);
INSERT INTO public.who_global_data VALUES (83662, 0, 0, 0, 0, 354, 193);
INSERT INTO public.who_global_data VALUES (83663, 0, 0, 0, 0, 354, 113);
INSERT INTO public.who_global_data VALUES (83664, 0, 0, 0, 0, 354, 143);
INSERT INTO public.who_global_data VALUES (83665, 0, 0, 0, 0, 354, 219);
INSERT INTO public.who_global_data VALUES (83666, 0, 0, 0, 0, 354, 186);
INSERT INTO public.who_global_data VALUES (83667, 0, 0, 0, 0, 354, 52);
INSERT INTO public.who_global_data VALUES (83668, 0, 0, 0, 0, 354, 180);
INSERT INTO public.who_global_data VALUES (83669, 0, 0, 0, 0, 354, 167);
INSERT INTO public.who_global_data VALUES (83670, 0, 0, 0, 0, 354, 154);
INSERT INTO public.who_global_data VALUES (83671, 0, 0, 0, 0, 354, 94);
INSERT INTO public.who_global_data VALUES (83672, 0, 0, 0, 0, 354, 66);
INSERT INTO public.who_global_data VALUES (83673, 0, 19, 0, 0, 354, 58);
INSERT INTO public.who_global_data VALUES (83674, 0, 0, 0, 0, 354, 163);
INSERT INTO public.who_global_data VALUES (83675, 0, 0, 0, 0, 354, 37);
INSERT INTO public.who_global_data VALUES (83676, 0, 0, 0, 0, 354, 142);
INSERT INTO public.who_global_data VALUES (83677, 0, 0, 0, 0, 354, 83);
INSERT INTO public.who_global_data VALUES (83678, 0, 0, 0, 0, 354, 228);
INSERT INTO public.who_global_data VALUES (83679, 0, 0, 0, 0, 354, 188);
INSERT INTO public.who_global_data VALUES (83680, 0, 0, 0, 0, 354, 62);
INSERT INTO public.who_global_data VALUES (83681, 0, 1, 0, 0, 354, 160);
INSERT INTO public.who_global_data VALUES (83682, 0, 0, 0, 0, 354, 50);
INSERT INTO public.who_global_data VALUES (83683, 0, 0, 0, 0, 354, 33);
INSERT INTO public.who_global_data VALUES (83684, 0, 0, 0, 0, 354, 183);
INSERT INTO public.who_global_data VALUES (83685, 0, 0, 0, 0, 354, 92);
INSERT INTO public.who_global_data VALUES (83686, 0, 0, 0, 0, 354, 158);
INSERT INTO public.who_global_data VALUES (83687, 0, 0, 0, 0, 354, 67);
INSERT INTO public.who_global_data VALUES (83688, 0, 0, 0, 0, 354, 57);
INSERT INTO public.who_global_data VALUES (83689, 0, 0, 0, 0, 354, 38);
INSERT INTO public.who_global_data VALUES (83690, 0, 0, 0, 0, 354, 141);
INSERT INTO public.who_global_data VALUES (83691, 0, 0, 0, 0, 354, 178);
INSERT INTO public.who_global_data VALUES (83692, 0, 0, 0, 0, 354, 108);
INSERT INTO public.who_global_data VALUES (83693, 0, 0, 0, 0, 354, 39);
INSERT INTO public.who_global_data VALUES (83694, 0, 0, 0, 0, 354, 2);
INSERT INTO public.who_global_data VALUES (83695, 0, 0, 0, 0, 354, 195);
INSERT INTO public.who_global_data VALUES (83696, 0, 0, 0, 0, 354, 107);
INSERT INTO public.who_global_data VALUES (83697, 0, 5, 0, 0, 354, 161);
INSERT INTO public.who_global_data VALUES (83698, 0, 0, 0, 0, 354, 212);
INSERT INTO public.who_global_data VALUES (83699, 0, 12, 0, 0, 354, 181);
INSERT INTO public.who_global_data VALUES (83700, 0, 0, 0, 0, 354, 53);
INSERT INTO public.who_global_data VALUES (83701, 0, 0, 0, 0, 354, 164);
INSERT INTO public.who_global_data VALUES (83702, 0, 0, 0, 0, 354, 140);
INSERT INTO public.who_global_data VALUES (83703, 0, 0, 0, 0, 354, 20);
INSERT INTO public.who_global_data VALUES (83704, 1893, 72532, 98, 1870, 354, 112);
INSERT INTO public.who_global_data VALUES (83705, 0, 0, 0, 0, 354, 111);
INSERT INTO public.who_global_data VALUES (83706, 0, 0, 0, 0, 354, 71);
INSERT INTO public.who_global_data VALUES (83707, 0, 0, 0, 0, 354, 218);
INSERT INTO public.who_global_data VALUES (83708, 0, 0, 0, 0, 354, 43);
INSERT INTO public.who_global_data VALUES (83709, 0, 0, 0, 0, 354, 49);
INSERT INTO public.who_global_data VALUES (83710, 0, 0, 0, 0, 354, 1);
INSERT INTO public.who_global_data VALUES (83711, 0, 0, 0, 0, 354, 48);
INSERT INTO public.who_global_data VALUES (83712, 0, 0, 0, 0, 354, 232);
INSERT INTO public.who_global_data VALUES (83713, 0, 0, 0, 0, 354, 175);
INSERT INTO public.who_global_data VALUES (83714, 0, 0, 0, 0, 354, 21);
INSERT INTO public.who_global_data VALUES (83715, 0, 0, 0, 0, 354, 156);
INSERT INTO public.who_global_data VALUES (83716, 0, 0, 0, 0, 354, 95);
INSERT INTO public.who_global_data VALUES (83717, 0, 0, 0, 0, 354, 177);
INSERT INTO public.who_global_data VALUES (83718, 0, 0, 0, 0, 354, 210);
INSERT INTO public.who_global_data VALUES (83719, 0, 0, 0, 0, 354, 120);
INSERT INTO public.who_global_data VALUES (83720, 0, 0, 0, 0, 354, 135);
INSERT INTO public.who_global_data VALUES (83721, 0, 0, 0, 0, 354, 206);
INSERT INTO public.who_global_data VALUES (83722, 0, 0, 0, 0, 354, 189);
INSERT INTO public.who_global_data VALUES (83723, 0, 5, 0, 0, 354, 129);
INSERT INTO public.who_global_data VALUES (83724, 0, 0, 0, 0, 354, 121);
INSERT INTO public.who_global_data VALUES (83725, 0, 0, 0, 0, 354, 59);
INSERT INTO public.who_global_data VALUES (83726, 0, 0, 0, 0, 354, 96);
INSERT INTO public.who_global_data VALUES (83727, 0, 0, 0, 0, 354, 41);
INSERT INTO public.who_global_data VALUES (83728, 0, 0, 0, 0, 354, 216);
INSERT INTO public.who_global_data VALUES (83729, 0, 0, 0, 0, 354, 236);
INSERT INTO public.who_global_data VALUES (83730, 0, 0, 0, 0, 354, 150);
INSERT INTO public.who_global_data VALUES (83731, 0, 0, 0, 0, 354, 61);
INSERT INTO public.who_global_data VALUES (83732, 0, 0, 0, 0, 354, 7);
INSERT INTO public.who_global_data VALUES (83733, 0, 1, 0, 0, 354, 169);
INSERT INTO public.who_global_data VALUES (83734, 0, 12, 0, 1, 354, 28);
INSERT INTO public.who_global_data VALUES (83735, 0, 0, 0, 0, 354, 85);
INSERT INTO public.who_global_data VALUES (83736, 0, 0, 0, 0, 354, 211);
INSERT INTO public.who_global_data VALUES (83737, 0, 0, 0, 0, 354, 60);
INSERT INTO public.who_global_data VALUES (83738, 0, 0, 0, 0, 354, 3);
INSERT INTO public.who_global_data VALUES (83739, 0, 0, 0, 0, 354, 11);
INSERT INTO public.who_global_data VALUES (83740, 0, 15, 0, 0, 354, 89);
INSERT INTO public.who_global_data VALUES (83741, 0, 0, 0, 0, 354, 24);
INSERT INTO public.who_global_data VALUES (83742, 0, 0, 0, 0, 354, 162);
INSERT INTO public.who_global_data VALUES (83743, 0, 0, 0, 0, 354, 100);
INSERT INTO public.who_global_data VALUES (83744, 0, 0, 0, 0, 354, 47);
INSERT INTO public.who_global_data VALUES (83745, 0, 0, 0, 0, 354, 29);
INSERT INTO public.who_global_data VALUES (83746, 0, 0, 0, 0, 354, 40);
INSERT INTO public.who_global_data VALUES (83747, 0, 0, 0, 0, 354, 222);
INSERT INTO public.who_global_data VALUES (83748, 0, 0, 0, 0, 354, 132);
INSERT INTO public.who_global_data VALUES (83749, 0, 0, 0, 0, 354, 130);
INSERT INTO public.who_global_data VALUES (83750, 0, 0, 0, 0, 354, 234);
INSERT INTO public.who_global_data VALUES (83751, 0, 0, 0, 0, 354, 23);
INSERT INTO public.who_global_data VALUES (83752, 0, 0, 0, 0, 354, 192);
INSERT INTO public.who_global_data VALUES (83753, 0, 0, 0, 0, 354, 69);
INSERT INTO public.who_global_data VALUES (83754, 0, 0, 0, 0, 354, 187);
INSERT INTO public.who_global_data VALUES (83755, 0, 0, 0, 0, 354, 230);
INSERT INTO public.who_global_data VALUES (83756, 0, 0, 0, 0, 354, 77);
INSERT INTO public.who_global_data VALUES (83757, 0, 0, 0, 0, 354, 9);
INSERT INTO public.who_global_data VALUES (83758, 0, 7, 0, 0, 354, 74);
INSERT INTO public.who_global_data VALUES (83759, 0, 0, 0, 0, 354, 224);
INSERT INTO public.who_global_data VALUES (83760, 0, 0, 0, 0, 354, 199);
INSERT INTO public.who_global_data VALUES (83761, 0, 0, 0, 0, 354, 190);
INSERT INTO public.who_global_data VALUES (83762, 0, 0, 0, 0, 354, 12);
INSERT INTO public.who_global_data VALUES (83763, 0, 0, 0, 0, 354, 104);
INSERT INTO public.who_global_data VALUES (83764, 0, 0, 0, 0, 354, 153);
INSERT INTO public.who_global_data VALUES (83765, 0, 3, 0, 0, 354, 91);
INSERT INTO public.who_global_data VALUES (83766, 0, 0, 0, 0, 354, 215);
INSERT INTO public.who_global_data VALUES (83767, 7, 76, 0, 1, 354, 84);
INSERT INTO public.who_global_data VALUES (83768, 0, 0, 0, 0, 354, 231);
INSERT INTO public.who_global_data VALUES (83769, 0, 0, 0, 0, 354, 196);
INSERT INTO public.who_global_data VALUES (83770, 0, 0, 0, 0, 354, 105);
INSERT INTO public.who_global_data VALUES (83771, 0, 0, 0, 0, 354, 122);
INSERT INTO public.who_global_data VALUES (83772, 0, 0, 0, 0, 354, 159);
INSERT INTO public.who_global_data VALUES (83773, 0, 0, 0, 0, 354, 75);
INSERT INTO public.who_global_data VALUES (83774, 0, 0, 0, 0, 354, 27);
INSERT INTO public.who_global_data VALUES (83775, 0, 0, 0, 0, 354, 54);
INSERT INTO public.who_global_data VALUES (83776, 0, 0, 0, 0, 354, 226);
INSERT INTO public.who_global_data VALUES (83777, 0, 0, 0, 0, 354, 79);
INSERT INTO public.who_global_data VALUES (83778, 0, 0, 0, 0, 354, 56);
INSERT INTO public.who_global_data VALUES (83779, 0, 0, 0, 0, 354, 117);
INSERT INTO public.who_global_data VALUES (83780, 0, 0, 0, 0, 354, 152);
INSERT INTO public.who_global_data VALUES (83781, 0, 0, 0, 0, 354, 16);
INSERT INTO public.who_global_data VALUES (83782, 0, 0, 0, 0, 354, 10);
INSERT INTO public.who_global_data VALUES (83783, 0, 0, 0, 0, 354, 201);
INSERT INTO public.who_global_data VALUES (83784, 0, 0, 0, 0, 354, 174);
INSERT INTO public.who_global_data VALUES (83785, 0, 0, 0, 0, 354, 119);
INSERT INTO public.who_global_data VALUES (83786, 0, 0, 0, 0, 354, 168);
INSERT INTO public.who_global_data VALUES (83787, 0, 26, 0, 0, 354, 99);
INSERT INTO public.who_global_data VALUES (83788, 0, 0, 0, 0, 354, 171);
INSERT INTO public.who_global_data VALUES (83789, 0, 0, 0, 0, 354, 87);
INSERT INTO public.who_global_data VALUES (83790, 0, 0, 0, 0, 354, 123);
INSERT INTO public.who_global_data VALUES (83791, 0, 0, 0, 0, 354, 151);
INSERT INTO public.who_global_data VALUES (83792, 0, 0, 0, 0, 354, 213);
INSERT INTO public.who_global_data VALUES (83793, 0, 0, 0, 0, 354, 118);
INSERT INTO public.who_global_data VALUES (83794, 0, 0, 0, 0, 354, 134);
INSERT INTO public.who_global_data VALUES (83795, 0, 0, 0, 0, 354, 65);
INSERT INTO public.who_global_data VALUES (83796, 0, 0, 0, 0, 354, 102);
INSERT INTO public.who_global_data VALUES (83797, 0, 0, 0, 0, 354, 223);
INSERT INTO public.who_global_data VALUES (83798, 0, 0, 0, 0, 354, 4);
INSERT INTO public.who_global_data VALUES (83799, 0, 0, 0, 0, 354, 146);
INSERT INTO public.who_global_data VALUES (83800, 0, 0, 0, 0, 354, 31);
INSERT INTO public.who_global_data VALUES (83801, 0, 0, 0, 0, 354, 127);
INSERT INTO public.who_global_data VALUES (83802, 0, 0, 0, 0, 354, 22);
INSERT INTO public.who_global_data VALUES (83803, 0, 0, 0, 0, 354, 115);
INSERT INTO public.who_global_data VALUES (83804, 0, 0, 0, 0, 354, 106);
INSERT INTO public.who_global_data VALUES (83805, 0, 0, 0, 0, 354, 90);
INSERT INTO public.who_global_data VALUES (83806, 0, 0, 0, 0, 354, 70);
INSERT INTO public.who_global_data VALUES (83807, 0, 5, 0, 0, 354, 46);
INSERT INTO public.who_global_data VALUES (83808, 0, 0, 0, 0, 354, 139);
INSERT INTO public.who_global_data VALUES (83809, 0, 0, 0, 0, 354, 42);
INSERT INTO public.who_global_data VALUES (83810, 0, 0, 0, 0, 354, 80);
INSERT INTO public.who_global_data VALUES (83811, 0, 0, 0, 0, 354, 203);
INSERT INTO public.who_global_data VALUES (83812, 0, 0, 0, 0, 354, 136);
INSERT INTO public.who_global_data VALUES (83813, 0, 0, 0, 0, 354, 63);
INSERT INTO public.who_global_data VALUES (83814, 0, 0, 0, 0, 354, 17);
INSERT INTO public.who_global_data VALUES (83815, 0, 0, 0, 0, 354, 172);
INSERT INTO public.who_global_data VALUES (83816, 0, 0, 0, 0, 354, 109);
INSERT INTO public.who_global_data VALUES (83817, 0, 0, 0, 0, 354, 200);
INSERT INTO public.who_global_data VALUES (83818, 0, 0, 0, 0, 354, 93);
INSERT INTO public.who_global_data VALUES (83819, 0, 0, 0, 0, 354, 5);
INSERT INTO public.who_global_data VALUES (83820, 88, 546, 0, 0, 354, 214);
INSERT INTO public.who_global_data VALUES (83821, 0, 0, 0, 0, 354, 204);
INSERT INTO public.who_global_data VALUES (83822, 0, 0, 0, 0, 354, 198);
INSERT INTO public.who_global_data VALUES (83823, 0, 0, 0, 0, 354, 173);
INSERT INTO public.who_global_data VALUES (83824, 0, 0, 0, 0, 354, 229);
INSERT INTO public.who_global_data VALUES (83825, 0, 0, 0, 0, 354, 76);
INSERT INTO public.who_global_data VALUES (83826, 0, 0, 0, 0, 354, 138);
INSERT INTO public.who_global_data VALUES (83827, 0, 7, 0, 1, 354, 98);
INSERT INTO public.who_global_data VALUES (83828, 0, 0, 0, 0, 354, 103);
INSERT INTO public.who_global_data VALUES (83829, 0, 0, 0, 0, 354, 225);
INSERT INTO public.who_global_data VALUES (83830, 0, 0, 0, 0, 354, 131);
INSERT INTO public.who_global_data VALUES (83831, 0, 0, 0, 0, 354, 235);
INSERT INTO public.who_global_data VALUES (83832, 0, 0, 0, 0, 354, 137);
INSERT INTO public.who_global_data VALUES (83833, 1, 35, 0, 0, 354, 81);
INSERT INTO public.who_global_data VALUES (83834, 0, 0, 0, 0, 354, 182);
INSERT INTO public.who_global_data VALUES (83835, 0, 0, 0, 0, 354, 145);
INSERT INTO public.who_global_data VALUES (83836, 0, 0, 0, 0, 354, 26);
INSERT INTO public.who_global_data VALUES (83837, 0, 2, 0, 0, 354, 170);
INSERT INTO public.who_global_data VALUES (83838, 0, 0, 0, 0, 354, 191);
INSERT INTO public.who_global_data VALUES (83839, 0, 0, 0, 0, 354, 221);
INSERT INTO public.who_global_data VALUES (83840, 0, 0, 0, 0, 354, 64);
INSERT INTO public.who_global_data VALUES (83841, 0, 0, 0, 0, 354, 116);
INSERT INTO public.who_global_data VALUES (83842, 0, 0, 0, 0, 354, 128);
INSERT INTO public.who_global_data VALUES (83843, 0, 0, 0, 0, 354, 6);
INSERT INTO public.who_global_data VALUES (83844, 0, 0, 0, 0, 354, 227);
INSERT INTO public.who_global_data VALUES (83845, 0, 0, 0, 0, 354, 68);
INSERT INTO public.who_global_data VALUES (83846, 0, 0, 0, 0, 354, 184);
INSERT INTO public.who_global_data VALUES (83847, 0, 0, 0, 0, 354, 82);
INSERT INTO public.who_global_data VALUES (83848, 0, 0, 0, 0, 354, 149);
INSERT INTO public.who_global_data VALUES (83849, 0, 0, 0, 0, 354, 197);
INSERT INTO public.who_global_data VALUES (83850, 0, 0, 0, 0, 354, 78);
INSERT INTO public.who_global_data VALUES (83851, 0, 0, 0, 0, 354, 233);
INSERT INTO public.who_global_data VALUES (83852, 0, 0, 0, 0, 354, 133);
INSERT INTO public.who_global_data VALUES (83853, 0, 0, 0, 0, 354, 35);
INSERT INTO public.who_global_data VALUES (83854, 0, 0, 0, 0, 354, 114);
INSERT INTO public.who_global_data VALUES (83855, 4, 85, 0, 0, 354, 237);
INSERT INTO public.who_global_data VALUES (83856, 0, 0, 0, 0, 354, 55);
INSERT INTO public.who_global_data VALUES (83857, 0, 0, 0, 0, 354, 176);
INSERT INTO public.who_global_data VALUES (83858, 0, 0, 0, 0, 354, 202);
INSERT INTO public.who_global_data VALUES (83859, 0, 0, 0, 0, 354, 155);
INSERT INTO public.who_global_data VALUES (83860, 0, 0, 0, 0, 354, 32);
INSERT INTO public.who_global_data VALUES (83861, 0, 0, 0, 0, 354, 220);
INSERT INTO public.who_global_data VALUES (83862, 0, 0, 0, 0, 354, 30);
INSERT INTO public.who_global_data VALUES (83863, 0, 0, 0, 0, 354, 147);
INSERT INTO public.who_global_data VALUES (83864, 0, 29, 0, 1, 354, 208);
INSERT INTO public.who_global_data VALUES (83865, 0, 5, 0, 0, 354, 45);
INSERT INTO public.who_global_data VALUES (83866, 0, 0, 0, 0, 354, 110);
INSERT INTO public.who_global_data VALUES (83867, 0, 0, 0, 0, 354, 88);
INSERT INTO public.who_global_data VALUES (83868, 0, 1, 0, 0, 354, 51);
INSERT INTO public.who_global_data VALUES (83869, 0, 0, 0, 0, 354, 209);
INSERT INTO public.who_global_data VALUES (83870, 0, 0, 0, 0, 354, 205);
INSERT INTO public.who_global_data VALUES (83871, 0, 0, 0, 0, 354, 18);
INSERT INTO public.who_global_data VALUES (83872, 0, 39, 0, 0, 354, 72);
INSERT INTO public.who_global_data VALUES (83873, 0, 10, 0, 0, 354, 44);
INSERT INTO public.who_global_data VALUES (83874, 0, 0, 0, 0, 354, 15);
INSERT INTO public.who_global_data VALUES (83875, 0, 0, 0, 0, 354, 25);
INSERT INTO public.who_global_data VALUES (83876, 0, 0, 0, 0, 354, 179);
INSERT INTO public.who_global_data VALUES (83877, 0, 0, 0, 0, 354, 34);
INSERT INTO public.who_global_data VALUES (83878, 0, 0, 0, 0, 354, 207);
INSERT INTO public.who_global_data VALUES (83879, 0, 0, 0, 0, 354, 166);
INSERT INTO public.who_global_data VALUES (83880, 0, 0, 0, 0, 354, 126);
INSERT INTO public.who_global_data VALUES (83881, 0, 0, 0, 0, 354, 97);
INSERT INTO public.who_global_data VALUES (83882, 0, 0, 0, 0, 354, 36);
INSERT INTO public.who_global_data VALUES (83883, 0, 0, 0, 0, 354, 125);
INSERT INTO public.who_global_data VALUES (83884, 0, 0, 0, 0, 354, 124);
INSERT INTO public.who_global_data VALUES (83885, 0, 0, 0, 0, 354, 185);
INSERT INTO public.who_global_data VALUES (83886, 0, 13, 0, 0, 354, 194);
INSERT INTO public.who_global_data VALUES (83887, 0, 0, 0, 0, 354, 144);
INSERT INTO public.who_global_data VALUES (83888, 0, 19, 0, 0, 354, 19);
INSERT INTO public.who_global_data VALUES (83889, 0, 0, 0, 0, 354, 217);
INSERT INTO public.who_global_data VALUES (83890, 0, 0, 0, 0, 354, 148);
INSERT INTO public.who_global_data VALUES (83891, 0, 0, 0, 0, 354, 86);
INSERT INTO public.who_global_data VALUES (83892, 0, 0, 0, 0, 354, 13);
INSERT INTO public.who_global_data VALUES (83893, 0, 0, 0, 0, 354, 157);
INSERT INTO public.who_global_data VALUES (83894, 0, 20, 0, 0, 354, 8);
INSERT INTO public.who_global_data VALUES (83895, 0, 0, 0, 0, 354, 73);
INSERT INTO public.who_global_data VALUES (83896, 0, 0, 0, 0, 354, 101);
INSERT INTO public.who_global_data VALUES (83897, 0, 0, 0, 0, 354, 165);
INSERT INTO public.who_global_data VALUES (83898, 0, 0, 0, 0, 354, 14);
INSERT INTO public.who_global_data VALUES (83899, 0, 0, 0, 0, 355, 193);
INSERT INTO public.who_global_data VALUES (83900, 0, 0, 0, 0, 355, 113);
INSERT INTO public.who_global_data VALUES (83901, 0, 0, 0, 0, 355, 143);
INSERT INTO public.who_global_data VALUES (83902, 0, 0, 0, 0, 355, 219);
INSERT INTO public.who_global_data VALUES (83903, 0, 0, 0, 0, 355, 186);
INSERT INTO public.who_global_data VALUES (83904, 0, 0, 0, 0, 355, 52);
INSERT INTO public.who_global_data VALUES (83905, 0, 0, 0, 0, 355, 180);
INSERT INTO public.who_global_data VALUES (83906, 0, 0, 0, 0, 355, 167);
INSERT INTO public.who_global_data VALUES (83907, 0, 0, 0, 0, 355, 154);
INSERT INTO public.who_global_data VALUES (83908, 0, 0, 0, 0, 355, 94);
INSERT INTO public.who_global_data VALUES (83909, 0, 0, 0, 0, 355, 66);
INSERT INTO public.who_global_data VALUES (83910, 0, 19, 0, 0, 355, 58);
INSERT INTO public.who_global_data VALUES (83911, 0, 0, 0, 0, 355, 163);
INSERT INTO public.who_global_data VALUES (83912, 0, 0, 0, 0, 355, 37);
INSERT INTO public.who_global_data VALUES (83913, 0, 0, 0, 0, 355, 142);
INSERT INTO public.who_global_data VALUES (83914, 0, 0, 0, 0, 355, 83);
INSERT INTO public.who_global_data VALUES (83915, 0, 0, 0, 0, 355, 228);
INSERT INTO public.who_global_data VALUES (83916, 0, 0, 0, 0, 355, 188);
INSERT INTO public.who_global_data VALUES (83917, 0, 0, 0, 0, 355, 62);
INSERT INTO public.who_global_data VALUES (83918, 0, 1, 0, 0, 355, 160);
INSERT INTO public.who_global_data VALUES (83919, 0, 0, 0, 0, 355, 50);
INSERT INTO public.who_global_data VALUES (83920, 0, 0, 0, 0, 355, 33);
INSERT INTO public.who_global_data VALUES (83921, 0, 0, 0, 0, 355, 183);
INSERT INTO public.who_global_data VALUES (83922, 0, 0, 0, 0, 355, 92);
INSERT INTO public.who_global_data VALUES (83923, 0, 0, 0, 0, 355, 158);
INSERT INTO public.who_global_data VALUES (83924, 0, 0, 0, 0, 355, 67);
INSERT INTO public.who_global_data VALUES (83925, 0, 0, 0, 0, 355, 57);
INSERT INTO public.who_global_data VALUES (83926, 0, 0, 0, 0, 355, 38);
INSERT INTO public.who_global_data VALUES (83927, 0, 0, 0, 0, 355, 141);
INSERT INTO public.who_global_data VALUES (83928, 0, 0, 0, 0, 355, 178);
INSERT INTO public.who_global_data VALUES (83929, 0, 0, 0, 0, 355, 108);
INSERT INTO public.who_global_data VALUES (83930, 0, 0, 0, 0, 355, 39);
INSERT INTO public.who_global_data VALUES (83931, 0, 0, 0, 0, 355, 2);
INSERT INTO public.who_global_data VALUES (83932, 0, 0, 0, 0, 355, 195);
INSERT INTO public.who_global_data VALUES (83933, 0, 0, 0, 0, 355, 107);
INSERT INTO public.who_global_data VALUES (83934, 0, 5, 0, 0, 355, 161);
INSERT INTO public.who_global_data VALUES (83935, 0, 0, 0, 0, 355, 212);
INSERT INTO public.who_global_data VALUES (83936, 1, 12, 0, 0, 355, 181);
INSERT INTO public.who_global_data VALUES (83937, 0, 0, 0, 0, 355, 53);
INSERT INTO public.who_global_data VALUES (83938, 0, 0, 0, 0, 355, 164);
INSERT INTO public.who_global_data VALUES (83939, 0, 0, 0, 0, 355, 140);
INSERT INTO public.who_global_data VALUES (83940, 0, 0, 0, 0, 355, 20);
INSERT INTO public.who_global_data VALUES (83941, 2051, 70639, 106, 1772, 355, 112);
INSERT INTO public.who_global_data VALUES (83942, 0, 0, 0, 0, 355, 111);
INSERT INTO public.who_global_data VALUES (83943, 0, 0, 0, 0, 355, 71);
INSERT INTO public.who_global_data VALUES (83944, 0, 0, 0, 0, 355, 218);
INSERT INTO public.who_global_data VALUES (83945, 0, 0, 0, 0, 355, 43);
INSERT INTO public.who_global_data VALUES (83946, 0, 0, 0, 0, 355, 49);
INSERT INTO public.who_global_data VALUES (83947, 0, 0, 0, 0, 355, 1);
INSERT INTO public.who_global_data VALUES (83948, 0, 0, 0, 0, 355, 48);
INSERT INTO public.who_global_data VALUES (83949, 0, 0, 0, 0, 355, 232);
INSERT INTO public.who_global_data VALUES (83950, 0, 0, 0, 0, 355, 175);
INSERT INTO public.who_global_data VALUES (83951, 0, 0, 0, 0, 355, 21);
INSERT INTO public.who_global_data VALUES (83952, 0, 0, 0, 0, 355, 156);
INSERT INTO public.who_global_data VALUES (83953, 0, 0, 0, 0, 355, 95);
INSERT INTO public.who_global_data VALUES (83954, 0, 0, 0, 0, 355, 177);
INSERT INTO public.who_global_data VALUES (83955, 0, 0, 0, 0, 355, 210);
INSERT INTO public.who_global_data VALUES (83956, 0, 0, 0, 0, 355, 120);
INSERT INTO public.who_global_data VALUES (83957, 0, 0, 0, 0, 355, 135);
INSERT INTO public.who_global_data VALUES (83958, 0, 0, 0, 0, 355, 206);
INSERT INTO public.who_global_data VALUES (83959, 0, 0, 0, 0, 355, 189);
INSERT INTO public.who_global_data VALUES (83960, 0, 5, 0, 0, 355, 129);
INSERT INTO public.who_global_data VALUES (83961, 0, 0, 0, 0, 355, 121);
INSERT INTO public.who_global_data VALUES (83962, 0, 0, 0, 0, 355, 59);
INSERT INTO public.who_global_data VALUES (83963, 0, 0, 0, 0, 355, 96);
INSERT INTO public.who_global_data VALUES (83964, 0, 0, 0, 0, 355, 41);
INSERT INTO public.who_global_data VALUES (83965, 0, 0, 0, 0, 355, 216);
INSERT INTO public.who_global_data VALUES (83966, 0, 0, 0, 0, 355, 236);
INSERT INTO public.who_global_data VALUES (83967, 0, 0, 0, 0, 355, 150);
INSERT INTO public.who_global_data VALUES (83968, 0, 0, 0, 0, 355, 61);
INSERT INTO public.who_global_data VALUES (83969, 0, 0, 0, 0, 355, 7);
INSERT INTO public.who_global_data VALUES (83970, 0, 1, 0, 0, 355, 169);
INSERT INTO public.who_global_data VALUES (83971, 1, 12, 0, 1, 355, 28);
INSERT INTO public.who_global_data VALUES (83972, 0, 0, 0, 0, 355, 85);
INSERT INTO public.who_global_data VALUES (83973, 0, 0, 0, 0, 355, 211);
INSERT INTO public.who_global_data VALUES (83974, 0, 0, 0, 0, 355, 60);
INSERT INTO public.who_global_data VALUES (83975, 0, 0, 0, 0, 355, 3);
INSERT INTO public.who_global_data VALUES (83976, 0, 0, 0, 0, 355, 11);
INSERT INTO public.who_global_data VALUES (83977, 0, 15, 0, 0, 355, 89);
INSERT INTO public.who_global_data VALUES (83978, 0, 0, 0, 0, 355, 24);
INSERT INTO public.who_global_data VALUES (83979, 0, 0, 0, 0, 355, 162);
INSERT INTO public.who_global_data VALUES (83980, 0, 0, 0, 0, 355, 100);
INSERT INTO public.who_global_data VALUES (83981, 0, 0, 0, 0, 355, 47);
INSERT INTO public.who_global_data VALUES (83982, 0, 0, 0, 0, 355, 29);
INSERT INTO public.who_global_data VALUES (83983, 0, 0, 0, 0, 355, 40);
INSERT INTO public.who_global_data VALUES (83984, 0, 0, 0, 0, 355, 222);
INSERT INTO public.who_global_data VALUES (83985, 0, 0, 0, 0, 355, 132);
INSERT INTO public.who_global_data VALUES (83986, 0, 0, 0, 0, 355, 130);
INSERT INTO public.who_global_data VALUES (83987, 0, 0, 0, 0, 355, 234);
INSERT INTO public.who_global_data VALUES (83988, 0, 0, 0, 0, 355, 23);
INSERT INTO public.who_global_data VALUES (83989, 0, 0, 0, 0, 355, 192);
INSERT INTO public.who_global_data VALUES (83990, 0, 0, 0, 0, 355, 69);
INSERT INTO public.who_global_data VALUES (83991, 0, 0, 0, 0, 355, 187);
INSERT INTO public.who_global_data VALUES (83992, 0, 0, 0, 0, 355, 230);
INSERT INTO public.who_global_data VALUES (83993, 0, 0, 0, 0, 355, 77);
INSERT INTO public.who_global_data VALUES (83994, 0, 0, 0, 0, 355, 9);
INSERT INTO public.who_global_data VALUES (83995, 0, 7, 0, 0, 355, 74);
INSERT INTO public.who_global_data VALUES (83996, 0, 0, 0, 0, 355, 224);
INSERT INTO public.who_global_data VALUES (83997, 0, 0, 0, 0, 355, 199);
INSERT INTO public.who_global_data VALUES (83998, 0, 0, 0, 0, 355, 190);
INSERT INTO public.who_global_data VALUES (83999, 0, 0, 0, 0, 355, 12);
INSERT INTO public.who_global_data VALUES (84000, 0, 0, 0, 0, 355, 104);
INSERT INTO public.who_global_data VALUES (84001, 0, 0, 0, 0, 355, 153);
INSERT INTO public.who_global_data VALUES (84002, 0, 3, 0, 0, 355, 91);
INSERT INTO public.who_global_data VALUES (84003, 0, 0, 0, 0, 355, 215);
INSERT INTO public.who_global_data VALUES (84004, 6, 69, 0, 1, 355, 84);
INSERT INTO public.who_global_data VALUES (84005, 0, 0, 0, 0, 355, 231);
INSERT INTO public.who_global_data VALUES (84006, 0, 0, 0, 0, 355, 196);
INSERT INTO public.who_global_data VALUES (84007, 0, 0, 0, 0, 355, 105);
INSERT INTO public.who_global_data VALUES (84008, 0, 0, 0, 0, 355, 122);
INSERT INTO public.who_global_data VALUES (84009, 0, 0, 0, 0, 355, 159);
INSERT INTO public.who_global_data VALUES (84010, 0, 0, 0, 0, 355, 75);
INSERT INTO public.who_global_data VALUES (84011, 0, 0, 0, 0, 355, 27);
INSERT INTO public.who_global_data VALUES (84012, 0, 0, 0, 0, 355, 54);
INSERT INTO public.who_global_data VALUES (84013, 0, 0, 0, 0, 355, 226);
INSERT INTO public.who_global_data VALUES (84014, 0, 0, 0, 0, 355, 79);
INSERT INTO public.who_global_data VALUES (84015, 0, 0, 0, 0, 355, 56);
INSERT INTO public.who_global_data VALUES (84016, 0, 0, 0, 0, 355, 117);
INSERT INTO public.who_global_data VALUES (84017, 0, 0, 0, 0, 355, 152);
INSERT INTO public.who_global_data VALUES (84018, 0, 0, 0, 0, 355, 16);
INSERT INTO public.who_global_data VALUES (84019, 0, 0, 0, 0, 355, 10);
INSERT INTO public.who_global_data VALUES (84020, 0, 0, 0, 0, 355, 201);
INSERT INTO public.who_global_data VALUES (84021, 0, 0, 0, 0, 355, 174);
INSERT INTO public.who_global_data VALUES (84022, 0, 0, 0, 0, 355, 119);
INSERT INTO public.who_global_data VALUES (84023, 0, 0, 0, 0, 355, 168);
INSERT INTO public.who_global_data VALUES (84024, 0, 26, 0, 0, 355, 99);
INSERT INTO public.who_global_data VALUES (84025, 0, 0, 0, 0, 355, 171);
INSERT INTO public.who_global_data VALUES (84026, 0, 0, 0, 0, 355, 87);
INSERT INTO public.who_global_data VALUES (84027, 0, 0, 0, 0, 355, 123);
INSERT INTO public.who_global_data VALUES (84028, 0, 0, 0, 0, 355, 151);
INSERT INTO public.who_global_data VALUES (84029, 0, 0, 0, 0, 355, 213);
INSERT INTO public.who_global_data VALUES (84030, 0, 0, 0, 0, 355, 118);
INSERT INTO public.who_global_data VALUES (84031, 0, 0, 0, 0, 355, 134);
INSERT INTO public.who_global_data VALUES (84032, 0, 0, 0, 0, 355, 65);
INSERT INTO public.who_global_data VALUES (84033, 0, 0, 0, 0, 355, 102);
INSERT INTO public.who_global_data VALUES (84034, 0, 0, 0, 0, 355, 223);
INSERT INTO public.who_global_data VALUES (84035, 0, 0, 0, 0, 355, 4);
INSERT INTO public.who_global_data VALUES (84036, 0, 0, 0, 0, 355, 146);
INSERT INTO public.who_global_data VALUES (84037, 0, 0, 0, 0, 355, 31);
INSERT INTO public.who_global_data VALUES (84038, 0, 0, 0, 0, 355, 127);
INSERT INTO public.who_global_data VALUES (84039, 0, 0, 0, 0, 355, 22);
INSERT INTO public.who_global_data VALUES (84040, 0, 0, 0, 0, 355, 115);
INSERT INTO public.who_global_data VALUES (84041, 0, 0, 0, 0, 355, 106);
INSERT INTO public.who_global_data VALUES (84042, 0, 0, 0, 0, 355, 90);
INSERT INTO public.who_global_data VALUES (84043, 0, 0, 0, 0, 355, 70);
INSERT INTO public.who_global_data VALUES (84044, 0, 5, 0, 0, 355, 46);
INSERT INTO public.who_global_data VALUES (84045, 0, 0, 0, 0, 355, 139);
INSERT INTO public.who_global_data VALUES (84046, 0, 0, 0, 0, 355, 42);
INSERT INTO public.who_global_data VALUES (84047, 0, 0, 0, 0, 355, 80);
INSERT INTO public.who_global_data VALUES (84048, 0, 0, 0, 0, 355, 203);
INSERT INTO public.who_global_data VALUES (84049, 0, 0, 0, 0, 355, 136);
INSERT INTO public.who_global_data VALUES (84050, 0, 0, 0, 0, 355, 63);
INSERT INTO public.who_global_data VALUES (84051, 0, 0, 0, 0, 355, 17);
INSERT INTO public.who_global_data VALUES (84052, 0, 0, 0, 0, 355, 172);
INSERT INTO public.who_global_data VALUES (84053, 0, 0, 0, 0, 355, 109);
INSERT INTO public.who_global_data VALUES (84054, 0, 0, 0, 0, 355, 200);
INSERT INTO public.who_global_data VALUES (84055, 0, 0, 0, 0, 355, 93);
INSERT INTO public.who_global_data VALUES (84056, 0, 0, 0, 0, 355, 5);
INSERT INTO public.who_global_data VALUES (84057, 99, 458, 0, 0, 355, 214);
INSERT INTO public.who_global_data VALUES (84058, 0, 0, 0, 0, 355, 204);
INSERT INTO public.who_global_data VALUES (84059, 0, 0, 0, 0, 355, 198);
INSERT INTO public.who_global_data VALUES (84060, 0, 0, 0, 0, 355, 173);
INSERT INTO public.who_global_data VALUES (84061, 0, 0, 0, 0, 355, 229);
INSERT INTO public.who_global_data VALUES (84062, 0, 0, 0, 0, 355, 76);
INSERT INTO public.who_global_data VALUES (84063, 0, 0, 0, 0, 355, 138);
INSERT INTO public.who_global_data VALUES (84064, 0, 7, 0, 1, 355, 98);
INSERT INTO public.who_global_data VALUES (84065, 0, 0, 0, 0, 355, 103);
INSERT INTO public.who_global_data VALUES (84066, 0, 0, 0, 0, 355, 225);
INSERT INTO public.who_global_data VALUES (84067, 0, 0, 0, 0, 355, 131);
INSERT INTO public.who_global_data VALUES (84068, 0, 0, 0, 0, 355, 235);
INSERT INTO public.who_global_data VALUES (84069, 0, 0, 0, 0, 355, 137);
INSERT INTO public.who_global_data VALUES (84070, 1, 34, 0, 0, 355, 81);
INSERT INTO public.who_global_data VALUES (84071, 0, 0, 0, 0, 355, 182);
INSERT INTO public.who_global_data VALUES (84072, 0, 0, 0, 0, 355, 145);
INSERT INTO public.who_global_data VALUES (84073, 0, 0, 0, 0, 355, 26);
INSERT INTO public.who_global_data VALUES (84074, 0, 2, 0, 0, 355, 170);
INSERT INTO public.who_global_data VALUES (84075, 0, 0, 0, 0, 355, 191);
INSERT INTO public.who_global_data VALUES (84076, 0, 0, 0, 0, 355, 221);
INSERT INTO public.who_global_data VALUES (84077, 0, 0, 0, 0, 355, 64);
INSERT INTO public.who_global_data VALUES (84078, 0, 0, 0, 0, 355, 116);
INSERT INTO public.who_global_data VALUES (84079, 0, 0, 0, 0, 355, 128);
INSERT INTO public.who_global_data VALUES (84080, 0, 0, 0, 0, 355, 6);
INSERT INTO public.who_global_data VALUES (84081, 0, 0, 0, 0, 355, 227);
INSERT INTO public.who_global_data VALUES (84082, 0, 0, 0, 0, 355, 68);
INSERT INTO public.who_global_data VALUES (84083, 0, 0, 0, 0, 355, 184);
INSERT INTO public.who_global_data VALUES (84084, 0, 0, 0, 0, 355, 82);
INSERT INTO public.who_global_data VALUES (84085, 0, 0, 0, 0, 355, 149);
INSERT INTO public.who_global_data VALUES (84086, 0, 0, 0, 0, 355, 197);
INSERT INTO public.who_global_data VALUES (84087, 0, 0, 0, 0, 355, 78);
INSERT INTO public.who_global_data VALUES (84088, 0, 0, 0, 0, 355, 233);
INSERT INTO public.who_global_data VALUES (84089, 0, 0, 0, 0, 355, 133);
INSERT INTO public.who_global_data VALUES (84090, 0, 0, 0, 0, 355, 35);
INSERT INTO public.who_global_data VALUES (84091, 0, 0, 0, 0, 355, 114);
INSERT INTO public.who_global_data VALUES (84092, 2, 81, 0, 0, 355, 237);
INSERT INTO public.who_global_data VALUES (84093, 0, 0, 0, 0, 355, 55);
INSERT INTO public.who_global_data VALUES (84094, 0, 0, 0, 0, 355, 176);
INSERT INTO public.who_global_data VALUES (84095, 0, 0, 0, 0, 355, 202);
INSERT INTO public.who_global_data VALUES (84096, 0, 0, 0, 0, 355, 155);
INSERT INTO public.who_global_data VALUES (84097, 0, 0, 0, 0, 355, 32);
INSERT INTO public.who_global_data VALUES (84098, 0, 0, 0, 0, 355, 220);
INSERT INTO public.who_global_data VALUES (84099, 0, 0, 0, 0, 355, 30);
INSERT INTO public.who_global_data VALUES (84100, 0, 0, 0, 0, 355, 147);
INSERT INTO public.who_global_data VALUES (84101, 0, 29, 0, 1, 355, 208);
INSERT INTO public.who_global_data VALUES (84102, 0, 5, 0, 0, 355, 45);
INSERT INTO public.who_global_data VALUES (84103, 0, 0, 0, 0, 355, 110);
INSERT INTO public.who_global_data VALUES (84104, 0, 0, 0, 0, 355, 88);
INSERT INTO public.who_global_data VALUES (84105, 0, 1, 0, 0, 355, 51);
INSERT INTO public.who_global_data VALUES (84106, 0, 0, 0, 0, 355, 209);
INSERT INTO public.who_global_data VALUES (84107, 0, 0, 0, 0, 355, 205);
INSERT INTO public.who_global_data VALUES (84108, 0, 0, 0, 0, 355, 18);
INSERT INTO public.who_global_data VALUES (84109, 1, 39, 0, 0, 355, 72);
INSERT INTO public.who_global_data VALUES (84110, 0, 10, 0, 0, 355, 44);
INSERT INTO public.who_global_data VALUES (84111, 0, 0, 0, 0, 355, 15);
INSERT INTO public.who_global_data VALUES (84112, 0, 0, 0, 0, 355, 25);
INSERT INTO public.who_global_data VALUES (84113, 0, 0, 0, 0, 355, 179);
INSERT INTO public.who_global_data VALUES (84114, 0, 0, 0, 0, 355, 34);
INSERT INTO public.who_global_data VALUES (84115, 0, 0, 0, 0, 355, 207);
INSERT INTO public.who_global_data VALUES (84116, 0, 0, 0, 0, 355, 166);
INSERT INTO public.who_global_data VALUES (84117, 0, 0, 0, 0, 355, 126);
INSERT INTO public.who_global_data VALUES (84118, 0, 0, 0, 0, 355, 97);
INSERT INTO public.who_global_data VALUES (84119, 0, 0, 0, 0, 355, 36);
INSERT INTO public.who_global_data VALUES (84120, 0, 0, 0, 0, 355, 125);
INSERT INTO public.who_global_data VALUES (84121, 0, 0, 0, 0, 355, 124);
INSERT INTO public.who_global_data VALUES (84122, 0, 0, 0, 0, 355, 185);
INSERT INTO public.who_global_data VALUES (84123, 0, 13, 0, 0, 355, 194);
INSERT INTO public.who_global_data VALUES (84124, 0, 0, 0, 0, 355, 144);
INSERT INTO public.who_global_data VALUES (84125, 0, 19, 0, 0, 355, 19);
INSERT INTO public.who_global_data VALUES (84126, 0, 0, 0, 0, 355, 217);
INSERT INTO public.who_global_data VALUES (84127, 0, 0, 0, 0, 355, 148);
INSERT INTO public.who_global_data VALUES (84128, 0, 0, 0, 0, 355, 86);
INSERT INTO public.who_global_data VALUES (84129, 0, 0, 0, 0, 355, 13);
INSERT INTO public.who_global_data VALUES (84130, 0, 0, 0, 0, 355, 157);
INSERT INTO public.who_global_data VALUES (84131, 0, 20, 0, 0, 355, 8);
INSERT INTO public.who_global_data VALUES (84132, 0, 0, 0, 0, 355, 73);
INSERT INTO public.who_global_data VALUES (84133, 0, 0, 0, 0, 355, 101);
INSERT INTO public.who_global_data VALUES (84134, 0, 0, 0, 0, 355, 165);
INSERT INTO public.who_global_data VALUES (84135, 0, 0, 0, 0, 355, 14);
INSERT INTO public.who_global_data VALUES (84136, 0, 0, 0, 0, 356, 193);
INSERT INTO public.who_global_data VALUES (84137, 0, 0, 0, 0, 356, 113);
INSERT INTO public.who_global_data VALUES (84138, 0, 0, 0, 0, 356, 143);
INSERT INTO public.who_global_data VALUES (84139, 0, 0, 0, 0, 356, 219);
INSERT INTO public.who_global_data VALUES (84140, 0, 0, 0, 0, 356, 186);
INSERT INTO public.who_global_data VALUES (84141, 0, 0, 0, 0, 356, 52);
INSERT INTO public.who_global_data VALUES (84142, 0, 0, 0, 0, 356, 180);
INSERT INTO public.who_global_data VALUES (84143, 0, 0, 0, 0, 356, 167);
INSERT INTO public.who_global_data VALUES (84144, 0, 0, 0, 0, 356, 154);
INSERT INTO public.who_global_data VALUES (84145, 0, 0, 0, 0, 356, 94);
INSERT INTO public.who_global_data VALUES (84146, 0, 0, 0, 0, 356, 66);
INSERT INTO public.who_global_data VALUES (84147, 0, 19, 0, 0, 356, 58);
INSERT INTO public.who_global_data VALUES (84148, 0, 0, 0, 0, 356, 163);
INSERT INTO public.who_global_data VALUES (84149, 0, 0, 0, 0, 356, 37);
INSERT INTO public.who_global_data VALUES (84150, 0, 0, 0, 0, 356, 142);
INSERT INTO public.who_global_data VALUES (84151, 0, 0, 0, 0, 356, 83);
INSERT INTO public.who_global_data VALUES (84152, 0, 0, 0, 0, 356, 228);
INSERT INTO public.who_global_data VALUES (84153, 0, 0, 0, 0, 356, 188);
INSERT INTO public.who_global_data VALUES (84154, 0, 0, 0, 0, 356, 62);
INSERT INTO public.who_global_data VALUES (84155, 0, 1, 0, 0, 356, 160);
INSERT INTO public.who_global_data VALUES (84156, 0, 0, 0, 0, 356, 50);
INSERT INTO public.who_global_data VALUES (84157, 0, 0, 0, 0, 356, 33);
INSERT INTO public.who_global_data VALUES (84158, 0, 0, 0, 0, 356, 183);
INSERT INTO public.who_global_data VALUES (84159, 0, 0, 0, 0, 356, 92);
INSERT INTO public.who_global_data VALUES (84160, 0, 0, 0, 0, 356, 158);
INSERT INTO public.who_global_data VALUES (84161, 0, 0, 0, 0, 356, 67);
INSERT INTO public.who_global_data VALUES (84162, 0, 0, 0, 0, 356, 57);
INSERT INTO public.who_global_data VALUES (84163, 0, 0, 0, 0, 356, 38);
INSERT INTO public.who_global_data VALUES (84164, 0, 0, 0, 0, 356, 141);
INSERT INTO public.who_global_data VALUES (84165, 0, 0, 0, 0, 356, 178);
INSERT INTO public.who_global_data VALUES (84166, 0, 0, 0, 0, 356, 108);
INSERT INTO public.who_global_data VALUES (84167, 0, 0, 0, 0, 356, 39);
INSERT INTO public.who_global_data VALUES (84168, 0, 0, 0, 0, 356, 2);
INSERT INTO public.who_global_data VALUES (84169, 0, 0, 0, 0, 356, 195);
INSERT INTO public.who_global_data VALUES (84170, 0, 0, 0, 0, 356, 107);
INSERT INTO public.who_global_data VALUES (84171, 0, 5, 0, 0, 356, 161);
INSERT INTO public.who_global_data VALUES (84172, 0, 0, 0, 0, 356, 212);
INSERT INTO public.who_global_data VALUES (84173, 0, 11, 0, 0, 356, 181);
INSERT INTO public.who_global_data VALUES (84174, 0, 0, 0, 0, 356, 53);
INSERT INTO public.who_global_data VALUES (84175, 0, 0, 0, 0, 356, 164);
INSERT INTO public.who_global_data VALUES (84176, 0, 0, 0, 0, 356, 140);
INSERT INTO public.who_global_data VALUES (84177, 0, 0, 0, 0, 356, 20);
INSERT INTO public.who_global_data VALUES (84178, 2008, 68588, 142, 1666, 356, 112);
INSERT INTO public.who_global_data VALUES (84179, 0, 0, 0, 0, 356, 111);
INSERT INTO public.who_global_data VALUES (84180, 0, 0, 0, 0, 356, 71);
INSERT INTO public.who_global_data VALUES (84181, 0, 0, 0, 0, 356, 218);
INSERT INTO public.who_global_data VALUES (84182, 0, 0, 0, 0, 356, 43);
INSERT INTO public.who_global_data VALUES (84183, 0, 0, 0, 0, 356, 49);
INSERT INTO public.who_global_data VALUES (84184, 0, 0, 0, 0, 356, 1);
INSERT INTO public.who_global_data VALUES (84185, 0, 0, 0, 0, 356, 48);
INSERT INTO public.who_global_data VALUES (84186, 0, 0, 0, 0, 356, 232);
INSERT INTO public.who_global_data VALUES (84187, 0, 0, 0, 0, 356, 175);
INSERT INTO public.who_global_data VALUES (84188, 0, 0, 0, 0, 356, 21);
INSERT INTO public.who_global_data VALUES (84189, 0, 0, 0, 0, 356, 156);
INSERT INTO public.who_global_data VALUES (84190, 0, 0, 0, 0, 356, 95);
INSERT INTO public.who_global_data VALUES (84191, 0, 0, 0, 0, 356, 177);
INSERT INTO public.who_global_data VALUES (84192, 0, 0, 0, 0, 356, 210);
INSERT INTO public.who_global_data VALUES (84193, 0, 0, 0, 0, 356, 120);
INSERT INTO public.who_global_data VALUES (84194, 0, 0, 0, 0, 356, 135);
INSERT INTO public.who_global_data VALUES (84195, 0, 0, 0, 0, 356, 206);
INSERT INTO public.who_global_data VALUES (84196, 0, 0, 0, 0, 356, 189);
INSERT INTO public.who_global_data VALUES (84197, 0, 5, 0, 0, 356, 129);
INSERT INTO public.who_global_data VALUES (84198, 0, 0, 0, 0, 356, 121);
INSERT INTO public.who_global_data VALUES (84199, 0, 0, 0, 0, 356, 59);
INSERT INTO public.who_global_data VALUES (84200, 0, 0, 0, 0, 356, 96);
INSERT INTO public.who_global_data VALUES (84201, 0, 0, 0, 0, 356, 41);
INSERT INTO public.who_global_data VALUES (84202, 0, 0, 0, 0, 356, 216);
INSERT INTO public.who_global_data VALUES (84203, 0, 0, 0, 0, 356, 236);
INSERT INTO public.who_global_data VALUES (84204, 0, 0, 0, 0, 356, 150);
INSERT INTO public.who_global_data VALUES (84205, 0, 0, 0, 0, 356, 61);
INSERT INTO public.who_global_data VALUES (84206, 0, 0, 0, 0, 356, 7);
INSERT INTO public.who_global_data VALUES (84207, 0, 1, 0, 0, 356, 169);
INSERT INTO public.who_global_data VALUES (84208, 0, 11, 0, 1, 356, 28);
INSERT INTO public.who_global_data VALUES (84209, 0, 0, 0, 0, 356, 85);
INSERT INTO public.who_global_data VALUES (84210, 0, 0, 0, 0, 356, 211);
INSERT INTO public.who_global_data VALUES (84211, 0, 0, 0, 0, 356, 60);
INSERT INTO public.who_global_data VALUES (84212, 0, 0, 0, 0, 356, 3);
INSERT INTO public.who_global_data VALUES (84213, 0, 0, 0, 0, 356, 11);
INSERT INTO public.who_global_data VALUES (84214, 0, 15, 0, 0, 356, 89);
INSERT INTO public.who_global_data VALUES (84215, 0, 0, 0, 0, 356, 24);
INSERT INTO public.who_global_data VALUES (84216, 0, 0, 0, 0, 356, 162);
INSERT INTO public.who_global_data VALUES (84217, 0, 0, 0, 0, 356, 100);
INSERT INTO public.who_global_data VALUES (84218, 0, 0, 0, 0, 356, 47);
INSERT INTO public.who_global_data VALUES (84219, 0, 0, 0, 0, 356, 29);
INSERT INTO public.who_global_data VALUES (84220, 0, 0, 0, 0, 356, 40);
INSERT INTO public.who_global_data VALUES (84221, 0, 0, 0, 0, 356, 222);
INSERT INTO public.who_global_data VALUES (84222, 0, 0, 0, 0, 356, 132);
INSERT INTO public.who_global_data VALUES (84223, 0, 0, 0, 0, 356, 130);
INSERT INTO public.who_global_data VALUES (84224, 0, 0, 0, 0, 356, 234);
INSERT INTO public.who_global_data VALUES (84225, 0, 0, 0, 0, 356, 23);
INSERT INTO public.who_global_data VALUES (84226, 0, 0, 0, 0, 356, 192);
INSERT INTO public.who_global_data VALUES (84227, 0, 0, 0, 0, 356, 69);
INSERT INTO public.who_global_data VALUES (84228, 0, 0, 0, 0, 356, 187);
INSERT INTO public.who_global_data VALUES (84229, 0, 0, 0, 0, 356, 230);
INSERT INTO public.who_global_data VALUES (84230, 0, 0, 0, 0, 356, 77);
INSERT INTO public.who_global_data VALUES (84231, 0, 0, 0, 0, 356, 9);
INSERT INTO public.who_global_data VALUES (84232, 0, 7, 0, 0, 356, 74);
INSERT INTO public.who_global_data VALUES (84233, 0, 0, 0, 0, 356, 224);
INSERT INTO public.who_global_data VALUES (84234, 0, 0, 0, 0, 356, 199);
INSERT INTO public.who_global_data VALUES (84235, 0, 0, 0, 0, 356, 190);
INSERT INTO public.who_global_data VALUES (84236, 0, 0, 0, 0, 356, 12);
INSERT INTO public.who_global_data VALUES (84237, 0, 0, 0, 0, 356, 104);
INSERT INTO public.who_global_data VALUES (84238, 0, 0, 0, 0, 356, 153);
INSERT INTO public.who_global_data VALUES (84239, 0, 3, 0, 0, 356, 91);
INSERT INTO public.who_global_data VALUES (84240, 0, 0, 0, 0, 356, 215);
INSERT INTO public.who_global_data VALUES (84241, 6, 63, 0, 1, 356, 84);
INSERT INTO public.who_global_data VALUES (84242, 0, 0, 0, 0, 356, 231);
INSERT INTO public.who_global_data VALUES (84243, 0, 0, 0, 0, 356, 196);
INSERT INTO public.who_global_data VALUES (84244, 0, 0, 0, 0, 356, 105);
INSERT INTO public.who_global_data VALUES (84245, 0, 0, 0, 0, 356, 122);
INSERT INTO public.who_global_data VALUES (84246, 0, 0, 0, 0, 356, 159);
INSERT INTO public.who_global_data VALUES (84247, 0, 0, 0, 0, 356, 75);
INSERT INTO public.who_global_data VALUES (84248, 0, 0, 0, 0, 356, 27);
INSERT INTO public.who_global_data VALUES (84249, 0, 0, 0, 0, 356, 54);
INSERT INTO public.who_global_data VALUES (84250, 0, 0, 0, 0, 356, 226);
INSERT INTO public.who_global_data VALUES (84251, 0, 0, 0, 0, 356, 79);
INSERT INTO public.who_global_data VALUES (84252, 0, 0, 0, 0, 356, 56);
INSERT INTO public.who_global_data VALUES (84253, 0, 0, 0, 0, 356, 117);
INSERT INTO public.who_global_data VALUES (84254, 0, 0, 0, 0, 356, 152);
INSERT INTO public.who_global_data VALUES (84255, 0, 0, 0, 0, 356, 16);
INSERT INTO public.who_global_data VALUES (84256, 0, 0, 0, 0, 356, 10);
INSERT INTO public.who_global_data VALUES (84257, 0, 0, 0, 0, 356, 201);
INSERT INTO public.who_global_data VALUES (84258, 0, 0, 0, 0, 356, 174);
INSERT INTO public.who_global_data VALUES (84259, 0, 0, 0, 0, 356, 119);
INSERT INTO public.who_global_data VALUES (84260, 0, 0, 0, 0, 356, 168);
INSERT INTO public.who_global_data VALUES (84261, 0, 26, 0, 0, 356, 99);
INSERT INTO public.who_global_data VALUES (84262, 0, 0, 0, 0, 356, 171);
INSERT INTO public.who_global_data VALUES (84263, 0, 0, 0, 0, 356, 87);
INSERT INTO public.who_global_data VALUES (84264, 0, 0, 0, 0, 356, 123);
INSERT INTO public.who_global_data VALUES (84265, 0, 0, 0, 0, 356, 151);
INSERT INTO public.who_global_data VALUES (84266, 0, 0, 0, 0, 356, 213);
INSERT INTO public.who_global_data VALUES (84267, 0, 0, 0, 0, 356, 118);
INSERT INTO public.who_global_data VALUES (84268, 0, 0, 0, 0, 356, 134);
INSERT INTO public.who_global_data VALUES (84269, 0, 0, 0, 0, 356, 65);
INSERT INTO public.who_global_data VALUES (84270, 0, 0, 0, 0, 356, 102);
INSERT INTO public.who_global_data VALUES (84271, 0, 0, 0, 0, 356, 223);
INSERT INTO public.who_global_data VALUES (84272, 0, 0, 0, 0, 356, 4);
INSERT INTO public.who_global_data VALUES (84273, 0, 0, 0, 0, 356, 146);
INSERT INTO public.who_global_data VALUES (84274, 0, 0, 0, 0, 356, 31);
INSERT INTO public.who_global_data VALUES (84275, 0, 0, 0, 0, 356, 127);
INSERT INTO public.who_global_data VALUES (84276, 0, 0, 0, 0, 356, 22);
INSERT INTO public.who_global_data VALUES (84277, 0, 0, 0, 0, 356, 115);
INSERT INTO public.who_global_data VALUES (84278, 0, 0, 0, 0, 356, 106);
INSERT INTO public.who_global_data VALUES (84279, 0, 0, 0, 0, 356, 90);
INSERT INTO public.who_global_data VALUES (84280, 0, 0, 0, 0, 356, 70);
INSERT INTO public.who_global_data VALUES (84281, 0, 5, 0, 0, 356, 46);
INSERT INTO public.who_global_data VALUES (84282, 0, 0, 0, 0, 356, 139);
INSERT INTO public.who_global_data VALUES (84283, 0, 0, 0, 0, 356, 42);
INSERT INTO public.who_global_data VALUES (84284, 0, 0, 0, 0, 356, 80);
INSERT INTO public.who_global_data VALUES (84285, 0, 0, 0, 0, 356, 203);
INSERT INTO public.who_global_data VALUES (84286, 0, 0, 0, 0, 356, 136);
INSERT INTO public.who_global_data VALUES (84287, 0, 0, 0, 0, 356, 63);
INSERT INTO public.who_global_data VALUES (84288, 0, 0, 0, 0, 356, 17);
INSERT INTO public.who_global_data VALUES (84289, 0, 0, 0, 0, 356, 172);
INSERT INTO public.who_global_data VALUES (84290, 0, 0, 0, 0, 356, 109);
INSERT INTO public.who_global_data VALUES (84291, 0, 0, 0, 0, 356, 200);
INSERT INTO public.who_global_data VALUES (84292, 0, 0, 0, 0, 356, 93);
INSERT INTO public.who_global_data VALUES (84293, 0, 0, 0, 0, 356, 5);
INSERT INTO public.who_global_data VALUES (84294, 70, 359, 0, 0, 356, 214);
INSERT INTO public.who_global_data VALUES (84295, 0, 0, 0, 0, 356, 204);
INSERT INTO public.who_global_data VALUES (84296, 0, 0, 0, 0, 356, 198);
INSERT INTO public.who_global_data VALUES (84297, 0, 0, 0, 0, 356, 173);
INSERT INTO public.who_global_data VALUES (84298, 0, 0, 0, 0, 356, 229);
INSERT INTO public.who_global_data VALUES (84299, 0, 0, 0, 0, 356, 76);
INSERT INTO public.who_global_data VALUES (84300, 0, 0, 0, 0, 356, 138);
INSERT INTO public.who_global_data VALUES (84301, 0, 7, 0, 1, 356, 98);
INSERT INTO public.who_global_data VALUES (84302, 0, 0, 0, 0, 356, 103);
INSERT INTO public.who_global_data VALUES (84303, 0, 0, 0, 0, 356, 225);
INSERT INTO public.who_global_data VALUES (84304, 0, 0, 0, 0, 356, 131);
INSERT INTO public.who_global_data VALUES (84305, 0, 0, 0, 0, 356, 235);
INSERT INTO public.who_global_data VALUES (84306, 0, 0, 0, 0, 356, 137);
INSERT INTO public.who_global_data VALUES (84307, 1, 33, 0, 0, 356, 81);
INSERT INTO public.who_global_data VALUES (84308, 0, 0, 0, 0, 356, 182);
INSERT INTO public.who_global_data VALUES (84309, 0, 0, 0, 0, 356, 145);
INSERT INTO public.who_global_data VALUES (84310, 0, 0, 0, 0, 356, 26);
INSERT INTO public.who_global_data VALUES (84311, 0, 2, 0, 0, 356, 170);
INSERT INTO public.who_global_data VALUES (84312, 0, 0, 0, 0, 356, 191);
INSERT INTO public.who_global_data VALUES (84313, 0, 0, 0, 0, 356, 221);
INSERT INTO public.who_global_data VALUES (84314, 0, 0, 0, 0, 356, 64);
INSERT INTO public.who_global_data VALUES (84315, 0, 0, 0, 0, 356, 116);
INSERT INTO public.who_global_data VALUES (84316, 0, 0, 0, 0, 356, 128);
INSERT INTO public.who_global_data VALUES (84317, 0, 0, 0, 0, 356, 6);
INSERT INTO public.who_global_data VALUES (84318, 0, 0, 0, 0, 356, 227);
INSERT INTO public.who_global_data VALUES (84319, 0, 0, 0, 0, 356, 68);
INSERT INTO public.who_global_data VALUES (84320, 0, 0, 0, 0, 356, 184);
INSERT INTO public.who_global_data VALUES (84321, 0, 0, 0, 0, 356, 82);
INSERT INTO public.who_global_data VALUES (84322, 0, 0, 0, 0, 356, 149);
INSERT INTO public.who_global_data VALUES (84323, 0, 0, 0, 0, 356, 197);
INSERT INTO public.who_global_data VALUES (84324, 0, 0, 0, 0, 356, 78);
INSERT INTO public.who_global_data VALUES (84325, 0, 0, 0, 0, 356, 233);
INSERT INTO public.who_global_data VALUES (84326, 0, 0, 0, 0, 356, 133);
INSERT INTO public.who_global_data VALUES (84327, 0, 0, 0, 0, 356, 35);
INSERT INTO public.who_global_data VALUES (84328, 0, 0, 0, 0, 356, 114);
INSERT INTO public.who_global_data VALUES (84329, 3, 79, 0, 0, 356, 237);
INSERT INTO public.who_global_data VALUES (84330, 0, 0, 0, 0, 356, 55);
INSERT INTO public.who_global_data VALUES (84331, 0, 0, 0, 0, 356, 176);
INSERT INTO public.who_global_data VALUES (84332, 0, 0, 0, 0, 356, 202);
INSERT INTO public.who_global_data VALUES (84333, 0, 0, 0, 0, 356, 155);
INSERT INTO public.who_global_data VALUES (84334, 0, 0, 0, 0, 356, 32);
INSERT INTO public.who_global_data VALUES (84335, 0, 0, 0, 0, 356, 220);
INSERT INTO public.who_global_data VALUES (84336, 0, 0, 0, 0, 356, 30);
INSERT INTO public.who_global_data VALUES (84337, 0, 0, 0, 0, 356, 147);
INSERT INTO public.who_global_data VALUES (84338, 0, 29, 0, 1, 356, 208);
INSERT INTO public.who_global_data VALUES (84339, 0, 5, 0, 0, 356, 45);
INSERT INTO public.who_global_data VALUES (84340, 0, 0, 0, 0, 356, 110);
INSERT INTO public.who_global_data VALUES (84341, 0, 0, 0, 0, 356, 88);
INSERT INTO public.who_global_data VALUES (84342, 0, 1, 0, 0, 356, 51);
INSERT INTO public.who_global_data VALUES (84343, 0, 0, 0, 0, 356, 209);
INSERT INTO public.who_global_data VALUES (84344, 0, 0, 0, 0, 356, 205);
INSERT INTO public.who_global_data VALUES (84345, 0, 0, 0, 0, 356, 18);
INSERT INTO public.who_global_data VALUES (84346, 0, 38, 0, 0, 356, 72);
INSERT INTO public.who_global_data VALUES (84347, 0, 10, 0, 0, 356, 44);
INSERT INTO public.who_global_data VALUES (84348, 0, 0, 0, 0, 356, 15);
INSERT INTO public.who_global_data VALUES (84349, 0, 0, 0, 0, 356, 25);
INSERT INTO public.who_global_data VALUES (84350, 0, 0, 0, 0, 356, 179);
INSERT INTO public.who_global_data VALUES (84351, 0, 0, 0, 0, 356, 34);
INSERT INTO public.who_global_data VALUES (84352, 0, 0, 0, 0, 356, 207);
INSERT INTO public.who_global_data VALUES (84353, 0, 0, 0, 0, 356, 166);
INSERT INTO public.who_global_data VALUES (84354, 0, 0, 0, 0, 356, 126);
INSERT INTO public.who_global_data VALUES (84355, 0, 0, 0, 0, 356, 97);
INSERT INTO public.who_global_data VALUES (84356, 0, 0, 0, 0, 356, 36);
INSERT INTO public.who_global_data VALUES (84357, 0, 0, 0, 0, 356, 125);
INSERT INTO public.who_global_data VALUES (84358, 0, 0, 0, 0, 356, 124);
INSERT INTO public.who_global_data VALUES (84359, 0, 0, 0, 0, 356, 185);
INSERT INTO public.who_global_data VALUES (84360, 1, 13, 0, 0, 356, 194);
INSERT INTO public.who_global_data VALUES (84361, 0, 0, 0, 0, 356, 144);
INSERT INTO public.who_global_data VALUES (84362, 0, 19, 0, 0, 356, 19);
INSERT INTO public.who_global_data VALUES (84363, 0, 0, 0, 0, 356, 217);
INSERT INTO public.who_global_data VALUES (84364, 0, 0, 0, 0, 356, 148);
INSERT INTO public.who_global_data VALUES (84365, 0, 0, 0, 0, 356, 86);
INSERT INTO public.who_global_data VALUES (84366, 0, 0, 0, 0, 356, 13);
INSERT INTO public.who_global_data VALUES (84367, 0, 0, 0, 0, 356, 157);
INSERT INTO public.who_global_data VALUES (84368, 0, 20, 0, 0, 356, 8);
INSERT INTO public.who_global_data VALUES (84369, 0, 0, 0, 0, 356, 73);
INSERT INTO public.who_global_data VALUES (84370, 0, 0, 0, 0, 356, 101);
INSERT INTO public.who_global_data VALUES (84371, 0, 0, 0, 0, 356, 165);
INSERT INTO public.who_global_data VALUES (84372, 0, 0, 0, 0, 356, 14);
INSERT INTO public.who_global_data VALUES (84373, 0, 0, 0, 0, 357, 193);
INSERT INTO public.who_global_data VALUES (84374, 0, 0, 0, 0, 357, 113);
INSERT INTO public.who_global_data VALUES (84375, 0, 0, 0, 0, 357, 143);
INSERT INTO public.who_global_data VALUES (84376, 0, 0, 0, 0, 357, 219);
INSERT INTO public.who_global_data VALUES (84377, 0, 0, 0, 0, 357, 186);
INSERT INTO public.who_global_data VALUES (84378, 0, 0, 0, 0, 357, 52);
INSERT INTO public.who_global_data VALUES (84379, 0, 0, 0, 0, 357, 180);
INSERT INTO public.who_global_data VALUES (84380, 0, 0, 0, 0, 357, 167);
INSERT INTO public.who_global_data VALUES (84381, 0, 0, 0, 0, 357, 154);
INSERT INTO public.who_global_data VALUES (84382, 0, 0, 0, 0, 357, 94);
INSERT INTO public.who_global_data VALUES (84383, 0, 0, 0, 0, 357, 66);
INSERT INTO public.who_global_data VALUES (84384, 0, 19, 0, 0, 357, 58);
INSERT INTO public.who_global_data VALUES (84385, 0, 0, 0, 0, 357, 163);
INSERT INTO public.who_global_data VALUES (84386, 0, 0, 0, 0, 357, 37);
INSERT INTO public.who_global_data VALUES (84387, 0, 0, 0, 0, 357, 142);
INSERT INTO public.who_global_data VALUES (84388, 0, 0, 0, 0, 357, 83);
INSERT INTO public.who_global_data VALUES (84389, 0, 0, 0, 0, 357, 228);
INSERT INTO public.who_global_data VALUES (84390, 0, 0, 0, 0, 357, 188);
INSERT INTO public.who_global_data VALUES (84391, 0, 0, 0, 0, 357, 62);
INSERT INTO public.who_global_data VALUES (84392, 0, 1, 0, 0, 357, 160);
INSERT INTO public.who_global_data VALUES (84393, 0, 0, 0, 0, 357, 50);
INSERT INTO public.who_global_data VALUES (84394, 0, 0, 0, 0, 357, 33);
INSERT INTO public.who_global_data VALUES (84395, 0, 0, 0, 0, 357, 183);
INSERT INTO public.who_global_data VALUES (84396, 0, 0, 0, 0, 357, 92);
INSERT INTO public.who_global_data VALUES (84397, 0, 0, 0, 0, 357, 158);
INSERT INTO public.who_global_data VALUES (84398, 0, 0, 0, 0, 357, 67);
INSERT INTO public.who_global_data VALUES (84399, 0, 0, 0, 0, 357, 57);
INSERT INTO public.who_global_data VALUES (84400, 0, 0, 0, 0, 357, 38);
INSERT INTO public.who_global_data VALUES (84401, 0, 0, 0, 0, 357, 141);
INSERT INTO public.who_global_data VALUES (84402, 0, 0, 0, 0, 357, 178);
INSERT INTO public.who_global_data VALUES (84403, 0, 0, 0, 0, 357, 108);
INSERT INTO public.who_global_data VALUES (84404, 0, 0, 0, 0, 357, 39);
INSERT INTO public.who_global_data VALUES (84405, 0, 0, 0, 0, 357, 2);
INSERT INTO public.who_global_data VALUES (84406, 0, 0, 0, 0, 357, 195);
INSERT INTO public.who_global_data VALUES (84407, 0, 0, 0, 0, 357, 107);
INSERT INTO public.who_global_data VALUES (84408, 0, 5, 0, 0, 357, 161);
INSERT INTO public.who_global_data VALUES (84409, 0, 0, 0, 0, 357, 212);
INSERT INTO public.who_global_data VALUES (84410, 0, 11, 0, 0, 357, 181);
INSERT INTO public.who_global_data VALUES (84411, 0, 0, 0, 0, 357, 53);
INSERT INTO public.who_global_data VALUES (84412, 0, 0, 0, 0, 357, 164);
INSERT INTO public.who_global_data VALUES (84413, 0, 0, 0, 0, 357, 140);
INSERT INTO public.who_global_data VALUES (84414, 0, 0, 0, 0, 357, 20);
INSERT INTO public.who_global_data VALUES (84415, 2644, 66580, 143, 1524, 357, 112);
INSERT INTO public.who_global_data VALUES (84416, 0, 0, 0, 0, 357, 111);
INSERT INTO public.who_global_data VALUES (84417, 0, 0, 0, 0, 357, 71);
INSERT INTO public.who_global_data VALUES (84418, 0, 0, 0, 0, 357, 218);
INSERT INTO public.who_global_data VALUES (84419, 0, 0, 0, 0, 357, 43);
INSERT INTO public.who_global_data VALUES (84420, 0, 0, 0, 0, 357, 49);
INSERT INTO public.who_global_data VALUES (84421, 0, 0, 0, 0, 357, 1);
INSERT INTO public.who_global_data VALUES (84422, 0, 0, 0, 0, 357, 48);
INSERT INTO public.who_global_data VALUES (84423, 0, 0, 0, 0, 357, 232);
INSERT INTO public.who_global_data VALUES (84424, 0, 0, 0, 0, 357, 175);
INSERT INTO public.who_global_data VALUES (84425, 0, 0, 0, 0, 357, 21);
INSERT INTO public.who_global_data VALUES (84426, 0, 0, 0, 0, 357, 156);
INSERT INTO public.who_global_data VALUES (84427, 0, 0, 0, 0, 357, 95);
INSERT INTO public.who_global_data VALUES (84428, 0, 0, 0, 0, 357, 177);
INSERT INTO public.who_global_data VALUES (84429, 0, 0, 0, 0, 357, 210);
INSERT INTO public.who_global_data VALUES (84430, 0, 0, 0, 0, 357, 120);
INSERT INTO public.who_global_data VALUES (84431, 0, 0, 0, 0, 357, 135);
INSERT INTO public.who_global_data VALUES (84432, 0, 0, 0, 0, 357, 206);
INSERT INTO public.who_global_data VALUES (84433, 0, 0, 0, 0, 357, 189);
INSERT INTO public.who_global_data VALUES (84434, 0, 5, 0, 0, 357, 129);
INSERT INTO public.who_global_data VALUES (84435, 0, 0, 0, 0, 357, 121);
INSERT INTO public.who_global_data VALUES (84436, 0, 0, 0, 0, 357, 59);
INSERT INTO public.who_global_data VALUES (84437, 0, 0, 0, 0, 357, 96);
INSERT INTO public.who_global_data VALUES (84438, 0, 0, 0, 0, 357, 41);
INSERT INTO public.who_global_data VALUES (84439, 0, 0, 0, 0, 357, 216);
INSERT INTO public.who_global_data VALUES (84440, 0, 0, 0, 0, 357, 236);
INSERT INTO public.who_global_data VALUES (84441, 0, 0, 0, 0, 357, 150);
INSERT INTO public.who_global_data VALUES (84442, 0, 0, 0, 0, 357, 61);
INSERT INTO public.who_global_data VALUES (84443, 0, 0, 0, 0, 357, 7);
INSERT INTO public.who_global_data VALUES (84444, 0, 1, 0, 0, 357, 169);
INSERT INTO public.who_global_data VALUES (84445, 0, 11, 1, 1, 357, 28);
INSERT INTO public.who_global_data VALUES (84446, 0, 0, 0, 0, 357, 85);
INSERT INTO public.who_global_data VALUES (84447, 0, 0, 0, 0, 357, 211);
INSERT INTO public.who_global_data VALUES (84448, 0, 0, 0, 0, 357, 60);
INSERT INTO public.who_global_data VALUES (84449, 0, 0, 0, 0, 357, 3);
INSERT INTO public.who_global_data VALUES (84450, 0, 0, 0, 0, 357, 11);
INSERT INTO public.who_global_data VALUES (84451, 0, 15, 0, 0, 357, 89);
INSERT INTO public.who_global_data VALUES (84452, 0, 0, 0, 0, 357, 24);
INSERT INTO public.who_global_data VALUES (84453, 0, 0, 0, 0, 357, 162);
INSERT INTO public.who_global_data VALUES (84454, 0, 0, 0, 0, 357, 100);
INSERT INTO public.who_global_data VALUES (84455, 0, 0, 0, 0, 357, 47);
INSERT INTO public.who_global_data VALUES (84456, 0, 0, 0, 0, 357, 29);
INSERT INTO public.who_global_data VALUES (84457, 0, 0, 0, 0, 357, 40);
INSERT INTO public.who_global_data VALUES (84458, 0, 0, 0, 0, 357, 222);
INSERT INTO public.who_global_data VALUES (84459, 0, 0, 0, 0, 357, 132);
INSERT INTO public.who_global_data VALUES (84460, 0, 0, 0, 0, 357, 130);
INSERT INTO public.who_global_data VALUES (84461, 0, 0, 0, 0, 357, 234);
INSERT INTO public.who_global_data VALUES (84462, 0, 0, 0, 0, 357, 23);
INSERT INTO public.who_global_data VALUES (84463, 0, 0, 0, 0, 357, 192);
INSERT INTO public.who_global_data VALUES (84464, 0, 0, 0, 0, 357, 69);
INSERT INTO public.who_global_data VALUES (84465, 0, 0, 0, 0, 357, 187);
INSERT INTO public.who_global_data VALUES (84466, 0, 0, 0, 0, 357, 230);
INSERT INTO public.who_global_data VALUES (84467, 0, 0, 0, 0, 357, 77);
INSERT INTO public.who_global_data VALUES (84468, 0, 0, 0, 0, 357, 9);
INSERT INTO public.who_global_data VALUES (84469, 0, 7, 0, 0, 357, 74);
INSERT INTO public.who_global_data VALUES (84470, 0, 0, 0, 0, 357, 224);
INSERT INTO public.who_global_data VALUES (84471, 0, 0, 0, 0, 357, 199);
INSERT INTO public.who_global_data VALUES (84472, 0, 0, 0, 0, 357, 190);
INSERT INTO public.who_global_data VALUES (84473, 0, 0, 0, 0, 357, 12);
INSERT INTO public.who_global_data VALUES (84474, 0, 0, 0, 0, 357, 104);
INSERT INTO public.who_global_data VALUES (84475, 0, 0, 0, 0, 357, 153);
INSERT INTO public.who_global_data VALUES (84476, 0, 3, 0, 0, 357, 91);
INSERT INTO public.who_global_data VALUES (84477, 0, 0, 0, 0, 357, 215);
INSERT INTO public.who_global_data VALUES (84478, 12, 57, 0, 1, 357, 84);
INSERT INTO public.who_global_data VALUES (84479, 0, 0, 0, 0, 357, 231);
INSERT INTO public.who_global_data VALUES (84480, 0, 0, 0, 0, 357, 196);
INSERT INTO public.who_global_data VALUES (84481, 0, 0, 0, 0, 357, 105);
INSERT INTO public.who_global_data VALUES (84482, 0, 0, 0, 0, 357, 122);
INSERT INTO public.who_global_data VALUES (84483, 0, 0, 0, 0, 357, 159);
INSERT INTO public.who_global_data VALUES (84484, 0, 0, 0, 0, 357, 75);
INSERT INTO public.who_global_data VALUES (84485, 0, 0, 0, 0, 357, 27);
INSERT INTO public.who_global_data VALUES (84486, 0, 0, 0, 0, 357, 54);
INSERT INTO public.who_global_data VALUES (84487, 0, 0, 0, 0, 357, 226);
INSERT INTO public.who_global_data VALUES (84488, 0, 0, 0, 0, 357, 79);
INSERT INTO public.who_global_data VALUES (84489, 0, 0, 0, 0, 357, 56);
INSERT INTO public.who_global_data VALUES (84490, 0, 0, 0, 0, 357, 117);
INSERT INTO public.who_global_data VALUES (84491, 0, 0, 0, 0, 357, 152);
INSERT INTO public.who_global_data VALUES (84492, 0, 0, 0, 0, 357, 16);
INSERT INTO public.who_global_data VALUES (84493, 0, 0, 0, 0, 357, 10);
INSERT INTO public.who_global_data VALUES (84494, 0, 0, 0, 0, 357, 201);
INSERT INTO public.who_global_data VALUES (84495, 0, 0, 0, 0, 357, 174);
INSERT INTO public.who_global_data VALUES (84496, 0, 0, 0, 0, 357, 119);
INSERT INTO public.who_global_data VALUES (84497, 0, 0, 0, 0, 357, 168);
INSERT INTO public.who_global_data VALUES (84498, 3, 26, 0, 0, 357, 99);
INSERT INTO public.who_global_data VALUES (84499, 0, 0, 0, 0, 357, 171);
INSERT INTO public.who_global_data VALUES (84500, 0, 0, 0, 0, 357, 87);
INSERT INTO public.who_global_data VALUES (84501, 0, 0, 0, 0, 357, 123);
INSERT INTO public.who_global_data VALUES (84502, 0, 0, 0, 0, 357, 151);
INSERT INTO public.who_global_data VALUES (84503, 0, 0, 0, 0, 357, 213);
INSERT INTO public.who_global_data VALUES (84504, 0, 0, 0, 0, 357, 118);
INSERT INTO public.who_global_data VALUES (84505, 0, 0, 0, 0, 357, 134);
INSERT INTO public.who_global_data VALUES (84506, 0, 0, 0, 0, 357, 65);
INSERT INTO public.who_global_data VALUES (84507, 0, 0, 0, 0, 357, 102);
INSERT INTO public.who_global_data VALUES (84508, 0, 0, 0, 0, 357, 223);
INSERT INTO public.who_global_data VALUES (84509, 0, 0, 0, 0, 357, 4);
INSERT INTO public.who_global_data VALUES (84510, 0, 0, 0, 0, 357, 146);
INSERT INTO public.who_global_data VALUES (84511, 0, 0, 0, 0, 357, 31);
INSERT INTO public.who_global_data VALUES (84512, 0, 0, 0, 0, 357, 127);
INSERT INTO public.who_global_data VALUES (84513, 0, 0, 0, 0, 357, 22);
INSERT INTO public.who_global_data VALUES (84514, 0, 0, 0, 0, 357, 115);
INSERT INTO public.who_global_data VALUES (84515, 0, 0, 0, 0, 357, 106);
INSERT INTO public.who_global_data VALUES (84516, 0, 0, 0, 0, 357, 90);
INSERT INTO public.who_global_data VALUES (84517, 0, 0, 0, 0, 357, 70);
INSERT INTO public.who_global_data VALUES (84518, 0, 5, 0, 0, 357, 46);
INSERT INTO public.who_global_data VALUES (84519, 0, 0, 0, 0, 357, 139);
INSERT INTO public.who_global_data VALUES (84520, 0, 0, 0, 0, 357, 42);
INSERT INTO public.who_global_data VALUES (84521, 0, 0, 0, 0, 357, 80);
INSERT INTO public.who_global_data VALUES (84522, 0, 0, 0, 0, 357, 203);
INSERT INTO public.who_global_data VALUES (84523, 0, 0, 0, 0, 357, 136);
INSERT INTO public.who_global_data VALUES (84524, 0, 0, 0, 0, 357, 63);
INSERT INTO public.who_global_data VALUES (84525, 0, 0, 0, 0, 357, 17);
INSERT INTO public.who_global_data VALUES (84526, 0, 0, 0, 0, 357, 172);
INSERT INTO public.who_global_data VALUES (84527, 0, 0, 0, 0, 357, 109);
INSERT INTO public.who_global_data VALUES (84528, 0, 0, 0, 0, 357, 200);
INSERT INTO public.who_global_data VALUES (84529, 0, 0, 0, 0, 357, 93);
INSERT INTO public.who_global_data VALUES (84530, 0, 0, 0, 0, 357, 5);
INSERT INTO public.who_global_data VALUES (84531, 67, 289, 0, 0, 357, 214);
INSERT INTO public.who_global_data VALUES (84532, 0, 0, 0, 0, 357, 204);
INSERT INTO public.who_global_data VALUES (84533, 0, 0, 0, 0, 357, 198);
INSERT INTO public.who_global_data VALUES (84534, 0, 0, 0, 0, 357, 173);
INSERT INTO public.who_global_data VALUES (84535, 0, 0, 0, 0, 357, 229);
INSERT INTO public.who_global_data VALUES (84536, 0, 0, 0, 0, 357, 76);
INSERT INTO public.who_global_data VALUES (84537, 0, 0, 0, 0, 357, 138);
INSERT INTO public.who_global_data VALUES (84538, 0, 7, 0, 1, 357, 98);
INSERT INTO public.who_global_data VALUES (84539, 0, 0, 0, 0, 357, 103);
INSERT INTO public.who_global_data VALUES (84540, 0, 0, 0, 0, 357, 225);
INSERT INTO public.who_global_data VALUES (84541, 0, 0, 0, 0, 357, 131);
INSERT INTO public.who_global_data VALUES (84542, 0, 0, 0, 0, 357, 235);
INSERT INTO public.who_global_data VALUES (84543, 0, 0, 0, 0, 357, 137);
INSERT INTO public.who_global_data VALUES (84544, 0, 32, 0, 0, 357, 81);
INSERT INTO public.who_global_data VALUES (84545, 0, 0, 0, 0, 357, 182);
INSERT INTO public.who_global_data VALUES (84546, 0, 0, 0, 0, 357, 145);
INSERT INTO public.who_global_data VALUES (84547, 0, 0, 0, 0, 357, 26);
INSERT INTO public.who_global_data VALUES (84548, 0, 2, 0, 0, 357, 170);
INSERT INTO public.who_global_data VALUES (84549, 0, 0, 0, 0, 357, 191);
INSERT INTO public.who_global_data VALUES (84550, 0, 0, 0, 0, 357, 221);
INSERT INTO public.who_global_data VALUES (84551, 0, 0, 0, 0, 357, 64);
INSERT INTO public.who_global_data VALUES (84552, 0, 0, 0, 0, 357, 116);
INSERT INTO public.who_global_data VALUES (84553, 0, 0, 0, 0, 357, 128);
INSERT INTO public.who_global_data VALUES (84554, 0, 0, 0, 0, 357, 6);
INSERT INTO public.who_global_data VALUES (84555, 0, 0, 0, 0, 357, 227);
INSERT INTO public.who_global_data VALUES (84556, 0, 0, 0, 0, 357, 68);
INSERT INTO public.who_global_data VALUES (84557, 0, 0, 0, 0, 357, 184);
INSERT INTO public.who_global_data VALUES (84558, 0, 0, 0, 0, 357, 82);
INSERT INTO public.who_global_data VALUES (84559, 0, 0, 0, 0, 357, 149);
INSERT INTO public.who_global_data VALUES (84560, 0, 0, 0, 0, 357, 197);
INSERT INTO public.who_global_data VALUES (84561, 0, 0, 0, 0, 357, 78);
INSERT INTO public.who_global_data VALUES (84562, 0, 0, 0, 0, 357, 233);
INSERT INTO public.who_global_data VALUES (84563, 0, 0, 0, 0, 357, 133);
INSERT INTO public.who_global_data VALUES (84564, 0, 0, 0, 0, 357, 35);
INSERT INTO public.who_global_data VALUES (84565, 0, 0, 0, 0, 357, 114);
INSERT INTO public.who_global_data VALUES (84566, 5, 76, 0, 0, 357, 237);
INSERT INTO public.who_global_data VALUES (84567, 0, 0, 0, 0, 357, 55);
INSERT INTO public.who_global_data VALUES (84568, 0, 0, 0, 0, 357, 176);
INSERT INTO public.who_global_data VALUES (84569, 0, 0, 0, 0, 357, 202);
INSERT INTO public.who_global_data VALUES (84570, 0, 0, 0, 0, 357, 155);
INSERT INTO public.who_global_data VALUES (84571, 0, 0, 0, 0, 357, 32);
INSERT INTO public.who_global_data VALUES (84572, 0, 0, 0, 0, 357, 220);
INSERT INTO public.who_global_data VALUES (84573, 0, 0, 0, 0, 357, 30);
INSERT INTO public.who_global_data VALUES (84574, 0, 0, 0, 0, 357, 147);
INSERT INTO public.who_global_data VALUES (84575, 0, 29, 0, 1, 357, 208);
INSERT INTO public.who_global_data VALUES (84576, 0, 5, 0, 0, 357, 45);
INSERT INTO public.who_global_data VALUES (84577, 0, 0, 0, 0, 357, 110);
INSERT INTO public.who_global_data VALUES (84578, 0, 0, 0, 0, 357, 88);
INSERT INTO public.who_global_data VALUES (84579, 0, 1, 0, 0, 357, 51);
INSERT INTO public.who_global_data VALUES (84580, 0, 0, 0, 0, 357, 209);
INSERT INTO public.who_global_data VALUES (84581, 0, 0, 0, 0, 357, 205);
INSERT INTO public.who_global_data VALUES (84582, 0, 0, 0, 0, 357, 18);
INSERT INTO public.who_global_data VALUES (84583, 1, 38, 0, 0, 357, 72);
INSERT INTO public.who_global_data VALUES (84584, 0, 10, 0, 0, 357, 44);
INSERT INTO public.who_global_data VALUES (84585, 0, 0, 0, 0, 357, 15);
INSERT INTO public.who_global_data VALUES (84586, 0, 0, 0, 0, 357, 25);
INSERT INTO public.who_global_data VALUES (84587, 0, 0, 0, 0, 357, 179);
INSERT INTO public.who_global_data VALUES (84588, 0, 0, 0, 0, 357, 34);
INSERT INTO public.who_global_data VALUES (84589, 0, 0, 0, 0, 357, 207);
INSERT INTO public.who_global_data VALUES (84590, 0, 0, 0, 0, 357, 166);
INSERT INTO public.who_global_data VALUES (84591, 0, 0, 0, 0, 357, 126);
INSERT INTO public.who_global_data VALUES (84592, 0, 0, 0, 0, 357, 97);
INSERT INTO public.who_global_data VALUES (84593, 0, 0, 0, 0, 357, 36);
INSERT INTO public.who_global_data VALUES (84594, 0, 0, 0, 0, 357, 125);
INSERT INTO public.who_global_data VALUES (84595, 0, 0, 0, 0, 357, 124);
INSERT INTO public.who_global_data VALUES (84596, 0, 0, 0, 0, 357, 185);
INSERT INTO public.who_global_data VALUES (84597, 0, 12, 0, 0, 357, 194);
INSERT INTO public.who_global_data VALUES (84598, 0, 0, 0, 0, 357, 144);
INSERT INTO public.who_global_data VALUES (84599, 0, 19, 0, 0, 357, 19);
INSERT INTO public.who_global_data VALUES (84600, 0, 0, 0, 0, 357, 217);
INSERT INTO public.who_global_data VALUES (84601, 0, 0, 0, 0, 357, 148);
INSERT INTO public.who_global_data VALUES (84602, 0, 0, 0, 0, 357, 86);
INSERT INTO public.who_global_data VALUES (84603, 0, 0, 0, 0, 357, 13);
INSERT INTO public.who_global_data VALUES (84604, 0, 0, 0, 0, 357, 157);
INSERT INTO public.who_global_data VALUES (84605, 0, 20, 0, 0, 357, 8);
INSERT INTO public.who_global_data VALUES (84606, 0, 0, 0, 0, 357, 73);
INSERT INTO public.who_global_data VALUES (84607, 0, 0, 0, 0, 357, 101);
INSERT INTO public.who_global_data VALUES (84608, 0, 0, 0, 0, 357, 165);
INSERT INTO public.who_global_data VALUES (84609, 0, 0, 0, 0, 357, 14);
INSERT INTO public.who_global_data VALUES (84610, 0, 0, 0, 0, 358, 193);
INSERT INTO public.who_global_data VALUES (84611, 0, 0, 0, 0, 358, 113);
INSERT INTO public.who_global_data VALUES (84612, 0, 0, 0, 0, 358, 143);
INSERT INTO public.who_global_data VALUES (84613, 0, 0, 0, 0, 358, 219);
INSERT INTO public.who_global_data VALUES (84614, 0, 0, 0, 0, 358, 186);
INSERT INTO public.who_global_data VALUES (84615, 0, 0, 0, 0, 358, 52);
INSERT INTO public.who_global_data VALUES (84616, 0, 0, 0, 0, 358, 180);
INSERT INTO public.who_global_data VALUES (84617, 0, 0, 0, 0, 358, 167);
INSERT INTO public.who_global_data VALUES (84618, 0, 0, 0, 0, 358, 154);
INSERT INTO public.who_global_data VALUES (84619, 0, 0, 0, 0, 358, 94);
INSERT INTO public.who_global_data VALUES (84620, 0, 0, 0, 0, 358, 66);
INSERT INTO public.who_global_data VALUES (84621, 0, 19, 0, 0, 358, 58);
INSERT INTO public.who_global_data VALUES (84622, 0, 0, 0, 0, 358, 163);
INSERT INTO public.who_global_data VALUES (84623, 0, 0, 0, 0, 358, 37);
INSERT INTO public.who_global_data VALUES (84624, 0, 0, 0, 0, 358, 142);
INSERT INTO public.who_global_data VALUES (84625, 0, 0, 0, 0, 358, 83);
INSERT INTO public.who_global_data VALUES (84626, 0, 0, 0, 0, 358, 228);
INSERT INTO public.who_global_data VALUES (84627, 0, 0, 0, 0, 358, 188);
INSERT INTO public.who_global_data VALUES (84628, 0, 0, 0, 0, 358, 62);
INSERT INTO public.who_global_data VALUES (84629, 0, 1, 0, 0, 358, 160);
INSERT INTO public.who_global_data VALUES (84630, 0, 0, 0, 0, 358, 50);
INSERT INTO public.who_global_data VALUES (84631, 0, 0, 0, 0, 358, 33);
INSERT INTO public.who_global_data VALUES (84632, 0, 0, 0, 0, 358, 183);
INSERT INTO public.who_global_data VALUES (84633, 0, 0, 0, 0, 358, 92);
INSERT INTO public.who_global_data VALUES (84634, 0, 0, 0, 0, 358, 158);
INSERT INTO public.who_global_data VALUES (84635, 0, 0, 0, 0, 358, 67);
INSERT INTO public.who_global_data VALUES (84636, 0, 0, 0, 0, 358, 57);
INSERT INTO public.who_global_data VALUES (84637, 0, 0, 0, 0, 358, 38);
INSERT INTO public.who_global_data VALUES (84638, 0, 0, 0, 0, 358, 141);
INSERT INTO public.who_global_data VALUES (84639, 0, 0, 0, 0, 358, 178);
INSERT INTO public.who_global_data VALUES (84640, 0, 0, 0, 0, 358, 108);
INSERT INTO public.who_global_data VALUES (84641, 0, 0, 0, 0, 358, 39);
INSERT INTO public.who_global_data VALUES (84642, 0, 0, 0, 0, 358, 2);
INSERT INTO public.who_global_data VALUES (84643, 0, 0, 0, 0, 358, 195);
INSERT INTO public.who_global_data VALUES (84644, 0, 0, 0, 0, 358, 107);
INSERT INTO public.who_global_data VALUES (84645, 0, 5, 0, 0, 358, 161);
INSERT INTO public.who_global_data VALUES (84646, 0, 0, 0, 0, 358, 212);
INSERT INTO public.who_global_data VALUES (84647, 0, 11, 0, 0, 358, 181);
INSERT INTO public.who_global_data VALUES (84648, 0, 0, 0, 0, 358, 53);
INSERT INTO public.who_global_data VALUES (84649, 0, 0, 0, 0, 358, 164);
INSERT INTO public.who_global_data VALUES (84650, 0, 0, 0, 0, 358, 140);
INSERT INTO public.who_global_data VALUES (84651, 0, 0, 0, 0, 358, 20);
INSERT INTO public.who_global_data VALUES (84652, 4050, 63936, 13, 1381, 358, 112);
INSERT INTO public.who_global_data VALUES (84653, 0, 0, 0, 0, 358, 111);
INSERT INTO public.who_global_data VALUES (84654, 0, 0, 0, 0, 358, 71);
INSERT INTO public.who_global_data VALUES (84655, 0, 0, 0, 0, 358, 218);
INSERT INTO public.who_global_data VALUES (84656, 0, 0, 0, 0, 358, 43);
INSERT INTO public.who_global_data VALUES (84657, 0, 0, 0, 0, 358, 49);
INSERT INTO public.who_global_data VALUES (84658, 0, 0, 0, 0, 358, 1);
INSERT INTO public.who_global_data VALUES (84659, 0, 0, 0, 0, 358, 48);
INSERT INTO public.who_global_data VALUES (84660, 0, 0, 0, 0, 358, 232);
INSERT INTO public.who_global_data VALUES (84661, 0, 0, 0, 0, 358, 175);
INSERT INTO public.who_global_data VALUES (84662, 0, 0, 0, 0, 358, 21);
INSERT INTO public.who_global_data VALUES (84663, 0, 0, 0, 0, 358, 156);
INSERT INTO public.who_global_data VALUES (84664, 0, 0, 0, 0, 358, 95);
INSERT INTO public.who_global_data VALUES (84665, 0, 0, 0, 0, 358, 177);
INSERT INTO public.who_global_data VALUES (84666, 0, 0, 0, 0, 358, 210);
INSERT INTO public.who_global_data VALUES (84667, 0, 0, 0, 0, 358, 120);
INSERT INTO public.who_global_data VALUES (84668, 0, 0, 0, 0, 358, 135);
INSERT INTO public.who_global_data VALUES (84669, 0, 0, 0, 0, 358, 206);
INSERT INTO public.who_global_data VALUES (84670, 0, 0, 0, 0, 358, 189);
INSERT INTO public.who_global_data VALUES (84671, 5, 5, 0, 0, 358, 129);
INSERT INTO public.who_global_data VALUES (84672, 0, 0, 0, 0, 358, 121);
INSERT INTO public.who_global_data VALUES (84673, 0, 0, 0, 0, 358, 59);
INSERT INTO public.who_global_data VALUES (84674, 0, 0, 0, 0, 358, 96);
INSERT INTO public.who_global_data VALUES (84675, 0, 0, 0, 0, 358, 41);
INSERT INTO public.who_global_data VALUES (84676, 0, 0, 0, 0, 358, 216);
INSERT INTO public.who_global_data VALUES (84677, 0, 0, 0, 0, 358, 236);
INSERT INTO public.who_global_data VALUES (84678, 0, 0, 0, 0, 358, 150);
INSERT INTO public.who_global_data VALUES (84679, 0, 0, 0, 0, 358, 61);
INSERT INTO public.who_global_data VALUES (84680, 0, 0, 0, 0, 358, 7);
INSERT INTO public.who_global_data VALUES (84681, 0, 1, 0, 0, 358, 169);
INSERT INTO public.who_global_data VALUES (84682, 0, 11, 0, 0, 358, 28);
INSERT INTO public.who_global_data VALUES (84683, 0, 0, 0, 0, 358, 85);
INSERT INTO public.who_global_data VALUES (84684, 0, 0, 0, 0, 358, 211);
INSERT INTO public.who_global_data VALUES (84685, 0, 0, 0, 0, 358, 60);
INSERT INTO public.who_global_data VALUES (84686, 0, 0, 0, 0, 358, 3);
INSERT INTO public.who_global_data VALUES (84687, 0, 0, 0, 0, 358, 11);
INSERT INTO public.who_global_data VALUES (84688, 0, 15, 0, 0, 358, 89);
INSERT INTO public.who_global_data VALUES (84689, 0, 0, 0, 0, 358, 24);
INSERT INTO public.who_global_data VALUES (84690, 0, 0, 0, 0, 358, 162);
INSERT INTO public.who_global_data VALUES (84691, 0, 0, 0, 0, 358, 100);
INSERT INTO public.who_global_data VALUES (84692, 0, 0, 0, 0, 358, 47);
INSERT INTO public.who_global_data VALUES (84693, 0, 0, 0, 0, 358, 29);
INSERT INTO public.who_global_data VALUES (84694, 0, 0, 0, 0, 358, 40);
INSERT INTO public.who_global_data VALUES (84695, 0, 0, 0, 0, 358, 222);
INSERT INTO public.who_global_data VALUES (84696, 0, 0, 0, 0, 358, 132);
INSERT INTO public.who_global_data VALUES (84697, 0, 0, 0, 0, 358, 130);
INSERT INTO public.who_global_data VALUES (84698, 0, 0, 0, 0, 358, 234);
INSERT INTO public.who_global_data VALUES (84699, 0, 0, 0, 0, 358, 23);
INSERT INTO public.who_global_data VALUES (84700, 0, 0, 0, 0, 358, 192);
INSERT INTO public.who_global_data VALUES (84701, 0, 0, 0, 0, 358, 69);
INSERT INTO public.who_global_data VALUES (84702, 0, 0, 0, 0, 358, 187);
INSERT INTO public.who_global_data VALUES (84703, 0, 0, 0, 0, 358, 230);
INSERT INTO public.who_global_data VALUES (84704, 0, 0, 0, 0, 358, 77);
INSERT INTO public.who_global_data VALUES (84705, 0, 0, 0, 0, 358, 9);
INSERT INTO public.who_global_data VALUES (84706, 0, 7, 0, 0, 358, 74);
INSERT INTO public.who_global_data VALUES (84707, 0, 0, 0, 0, 358, 224);
INSERT INTO public.who_global_data VALUES (84708, 0, 0, 0, 0, 358, 199);
INSERT INTO public.who_global_data VALUES (84709, 0, 0, 0, 0, 358, 190);
INSERT INTO public.who_global_data VALUES (84710, 0, 0, 0, 0, 358, 12);
INSERT INTO public.who_global_data VALUES (84711, 0, 0, 0, 0, 358, 104);
INSERT INTO public.who_global_data VALUES (84712, 0, 0, 0, 0, 358, 153);
INSERT INTO public.who_global_data VALUES (84713, 0, 3, 0, 0, 358, 91);
INSERT INTO public.who_global_data VALUES (84714, 0, 0, 0, 0, 358, 215);
INSERT INTO public.who_global_data VALUES (84715, 8, 45, 0, 1, 358, 84);
INSERT INTO public.who_global_data VALUES (84716, 0, 0, 0, 0, 358, 231);
INSERT INTO public.who_global_data VALUES (84717, 0, 0, 0, 0, 358, 196);
INSERT INTO public.who_global_data VALUES (84718, 0, 0, 0, 0, 358, 105);
INSERT INTO public.who_global_data VALUES (84719, 0, 0, 0, 0, 358, 122);
INSERT INTO public.who_global_data VALUES (84720, 0, 0, 0, 0, 358, 159);
INSERT INTO public.who_global_data VALUES (84721, 0, 0, 0, 0, 358, 75);
INSERT INTO public.who_global_data VALUES (84722, 0, 0, 0, 0, 358, 27);
INSERT INTO public.who_global_data VALUES (84723, 0, 0, 0, 0, 358, 54);
INSERT INTO public.who_global_data VALUES (84724, 0, 0, 0, 0, 358, 226);
INSERT INTO public.who_global_data VALUES (84725, 0, 0, 0, 0, 358, 79);
INSERT INTO public.who_global_data VALUES (84726, 0, 0, 0, 0, 358, 56);
INSERT INTO public.who_global_data VALUES (84727, 0, 0, 0, 0, 358, 117);
INSERT INTO public.who_global_data VALUES (84728, 0, 0, 0, 0, 358, 152);
INSERT INTO public.who_global_data VALUES (84729, 0, 0, 0, 0, 358, 16);
INSERT INTO public.who_global_data VALUES (84730, 0, 0, 0, 0, 358, 10);
INSERT INTO public.who_global_data VALUES (84731, 0, 0, 0, 0, 358, 201);
INSERT INTO public.who_global_data VALUES (84732, 0, 0, 0, 0, 358, 174);
INSERT INTO public.who_global_data VALUES (84733, 0, 0, 0, 0, 358, 119);
INSERT INTO public.who_global_data VALUES (84734, 0, 0, 0, 0, 358, 168);
INSERT INTO public.who_global_data VALUES (84735, 0, 23, 0, 0, 358, 99);
INSERT INTO public.who_global_data VALUES (84736, 0, 0, 0, 0, 358, 171);
INSERT INTO public.who_global_data VALUES (84737, 0, 0, 0, 0, 358, 87);
INSERT INTO public.who_global_data VALUES (84738, 0, 0, 0, 0, 358, 123);
INSERT INTO public.who_global_data VALUES (84739, 0, 0, 0, 0, 358, 151);
INSERT INTO public.who_global_data VALUES (84740, 0, 0, 0, 0, 358, 213);
INSERT INTO public.who_global_data VALUES (84741, 0, 0, 0, 0, 358, 118);
INSERT INTO public.who_global_data VALUES (84742, 0, 0, 0, 0, 358, 134);
INSERT INTO public.who_global_data VALUES (84743, 0, 0, 0, 0, 358, 65);
INSERT INTO public.who_global_data VALUES (84744, 0, 0, 0, 0, 358, 102);
INSERT INTO public.who_global_data VALUES (84745, 0, 0, 0, 0, 358, 223);
INSERT INTO public.who_global_data VALUES (84746, 0, 0, 0, 0, 358, 4);
INSERT INTO public.who_global_data VALUES (84747, 0, 0, 0, 0, 358, 146);
INSERT INTO public.who_global_data VALUES (84748, 0, 0, 0, 0, 358, 31);
INSERT INTO public.who_global_data VALUES (84749, 0, 0, 0, 0, 358, 127);
INSERT INTO public.who_global_data VALUES (84750, 0, 0, 0, 0, 358, 22);
INSERT INTO public.who_global_data VALUES (84751, 0, 0, 0, 0, 358, 115);
INSERT INTO public.who_global_data VALUES (84752, 0, 0, 0, 0, 358, 106);
INSERT INTO public.who_global_data VALUES (84753, 0, 0, 0, 0, 358, 90);
INSERT INTO public.who_global_data VALUES (84754, 0, 0, 0, 0, 358, 70);
INSERT INTO public.who_global_data VALUES (84755, 0, 5, 0, 0, 358, 46);
INSERT INTO public.who_global_data VALUES (84756, 0, 0, 0, 0, 358, 139);
INSERT INTO public.who_global_data VALUES (84757, 0, 0, 0, 0, 358, 42);
INSERT INTO public.who_global_data VALUES (84758, 0, 0, 0, 0, 358, 80);
INSERT INTO public.who_global_data VALUES (84759, 0, 0, 0, 0, 358, 203);
INSERT INTO public.who_global_data VALUES (84760, 0, 0, 0, 0, 358, 136);
INSERT INTO public.who_global_data VALUES (84761, 0, 0, 0, 0, 358, 63);
INSERT INTO public.who_global_data VALUES (84762, 0, 0, 0, 0, 358, 17);
INSERT INTO public.who_global_data VALUES (84763, 0, 0, 0, 0, 358, 172);
INSERT INTO public.who_global_data VALUES (84764, 0, 0, 0, 0, 358, 109);
INSERT INTO public.who_global_data VALUES (84765, 0, 0, 0, 0, 358, 200);
INSERT INTO public.who_global_data VALUES (84766, 0, 0, 0, 0, 358, 93);
INSERT INTO public.who_global_data VALUES (84767, 0, 0, 0, 0, 358, 5);
INSERT INTO public.who_global_data VALUES (84768, 0, 222, 0, 0, 358, 214);
INSERT INTO public.who_global_data VALUES (84769, 0, 0, 0, 0, 358, 204);
INSERT INTO public.who_global_data VALUES (84770, 0, 0, 0, 0, 358, 198);
INSERT INTO public.who_global_data VALUES (84771, 0, 0, 0, 0, 358, 173);
INSERT INTO public.who_global_data VALUES (84772, 0, 0, 0, 0, 358, 229);
INSERT INTO public.who_global_data VALUES (84773, 0, 0, 0, 0, 358, 76);
INSERT INTO public.who_global_data VALUES (84774, 0, 0, 0, 0, 358, 138);
INSERT INTO public.who_global_data VALUES (84775, 0, 7, 0, 1, 358, 98);
INSERT INTO public.who_global_data VALUES (84776, 0, 0, 0, 0, 358, 103);
INSERT INTO public.who_global_data VALUES (84777, 0, 0, 0, 0, 358, 225);
INSERT INTO public.who_global_data VALUES (84778, 0, 0, 0, 0, 358, 131);
INSERT INTO public.who_global_data VALUES (84779, 0, 0, 0, 0, 358, 235);
INSERT INTO public.who_global_data VALUES (84780, 0, 0, 0, 0, 358, 137);
INSERT INTO public.who_global_data VALUES (84781, 0, 32, 0, 0, 358, 81);
INSERT INTO public.who_global_data VALUES (84782, 0, 0, 0, 0, 358, 182);
INSERT INTO public.who_global_data VALUES (84783, 0, 0, 0, 0, 358, 145);
INSERT INTO public.who_global_data VALUES (84784, 0, 0, 0, 0, 358, 26);
INSERT INTO public.who_global_data VALUES (84785, 0, 2, 0, 0, 358, 170);
INSERT INTO public.who_global_data VALUES (84786, 0, 0, 0, 0, 358, 191);
INSERT INTO public.who_global_data VALUES (84787, 0, 0, 0, 0, 358, 221);
INSERT INTO public.who_global_data VALUES (84788, 0, 0, 0, 0, 358, 64);
INSERT INTO public.who_global_data VALUES (84789, 0, 0, 0, 0, 358, 116);
INSERT INTO public.who_global_data VALUES (84790, 0, 0, 0, 0, 358, 128);
INSERT INTO public.who_global_data VALUES (84791, 0, 0, 0, 0, 358, 6);
INSERT INTO public.who_global_data VALUES (84792, 0, 0, 0, 0, 358, 227);
INSERT INTO public.who_global_data VALUES (84793, 0, 0, 0, 0, 358, 68);
INSERT INTO public.who_global_data VALUES (84794, 0, 0, 0, 0, 358, 184);
INSERT INTO public.who_global_data VALUES (84795, 0, 0, 0, 0, 358, 82);
INSERT INTO public.who_global_data VALUES (84796, 0, 0, 0, 0, 358, 149);
INSERT INTO public.who_global_data VALUES (84797, 0, 0, 0, 0, 358, 197);
INSERT INTO public.who_global_data VALUES (84798, 0, 0, 0, 0, 358, 78);
INSERT INTO public.who_global_data VALUES (84799, 0, 0, 0, 0, 358, 233);
INSERT INTO public.who_global_data VALUES (84800, 0, 0, 0, 0, 358, 133);
INSERT INTO public.who_global_data VALUES (84801, 0, 0, 0, 0, 358, 35);
INSERT INTO public.who_global_data VALUES (84802, 0, 0, 0, 0, 358, 114);
INSERT INTO public.who_global_data VALUES (84803, 9, 71, 0, 0, 358, 237);
INSERT INTO public.who_global_data VALUES (84804, 0, 0, 0, 0, 358, 55);
INSERT INTO public.who_global_data VALUES (84805, 0, 0, 0, 0, 358, 176);
INSERT INTO public.who_global_data VALUES (84806, 0, 0, 0, 0, 358, 202);
INSERT INTO public.who_global_data VALUES (84807, 0, 0, 0, 0, 358, 155);
INSERT INTO public.who_global_data VALUES (84808, 0, 0, 0, 0, 358, 32);
INSERT INTO public.who_global_data VALUES (84809, 0, 0, 0, 0, 358, 220);
INSERT INTO public.who_global_data VALUES (84810, 0, 0, 0, 0, 358, 30);
INSERT INTO public.who_global_data VALUES (84811, 0, 0, 0, 0, 358, 147);
INSERT INTO public.who_global_data VALUES (84812, 5, 29, 0, 1, 358, 208);
INSERT INTO public.who_global_data VALUES (84813, 0, 5, 0, 0, 358, 45);
INSERT INTO public.who_global_data VALUES (84814, 0, 0, 0, 0, 358, 110);
INSERT INTO public.who_global_data VALUES (84815, 0, 0, 0, 0, 358, 88);
INSERT INTO public.who_global_data VALUES (84816, 0, 1, 0, 0, 358, 51);
INSERT INTO public.who_global_data VALUES (84817, 0, 0, 0, 0, 358, 209);
INSERT INTO public.who_global_data VALUES (84818, 0, 0, 0, 0, 358, 205);
INSERT INTO public.who_global_data VALUES (84819, 0, 0, 0, 0, 358, 18);
INSERT INTO public.who_global_data VALUES (84820, 0, 37, 0, 0, 358, 72);
INSERT INTO public.who_global_data VALUES (84821, 0, 10, 0, 0, 358, 44);
INSERT INTO public.who_global_data VALUES (84822, 0, 0, 0, 0, 358, 15);
INSERT INTO public.who_global_data VALUES (84823, 0, 0, 0, 0, 358, 25);
INSERT INTO public.who_global_data VALUES (84824, 0, 0, 0, 0, 358, 179);
INSERT INTO public.who_global_data VALUES (84825, 0, 0, 0, 0, 358, 34);
INSERT INTO public.who_global_data VALUES (84826, 0, 0, 0, 0, 358, 207);
INSERT INTO public.who_global_data VALUES (84827, 0, 0, 0, 0, 358, 166);
INSERT INTO public.who_global_data VALUES (84828, 0, 0, 0, 0, 358, 126);
INSERT INTO public.who_global_data VALUES (84829, 0, 0, 0, 0, 358, 97);
INSERT INTO public.who_global_data VALUES (84830, 0, 0, 0, 0, 358, 36);
INSERT INTO public.who_global_data VALUES (84831, 0, 0, 0, 0, 358, 125);
INSERT INTO public.who_global_data VALUES (84832, 0, 0, 0, 0, 358, 124);
INSERT INTO public.who_global_data VALUES (84833, 0, 0, 0, 0, 358, 185);
INSERT INTO public.who_global_data VALUES (84834, 0, 12, 0, 0, 358, 194);
INSERT INTO public.who_global_data VALUES (84835, 0, 0, 0, 0, 358, 144);
INSERT INTO public.who_global_data VALUES (84836, 0, 19, 0, 0, 358, 19);
INSERT INTO public.who_global_data VALUES (84837, 0, 0, 0, 0, 358, 217);
INSERT INTO public.who_global_data VALUES (84838, 0, 0, 0, 0, 358, 148);
INSERT INTO public.who_global_data VALUES (84839, 0, 0, 0, 0, 358, 86);
INSERT INTO public.who_global_data VALUES (84840, 0, 0, 0, 0, 358, 13);
INSERT INTO public.who_global_data VALUES (84841, 0, 0, 0, 0, 358, 157);
INSERT INTO public.who_global_data VALUES (84842, 0, 20, 0, 0, 358, 8);
INSERT INTO public.who_global_data VALUES (84843, 0, 0, 0, 0, 358, 73);
INSERT INTO public.who_global_data VALUES (84844, 0, 0, 0, 0, 358, 101);
INSERT INTO public.who_global_data VALUES (84845, 0, 0, 0, 0, 358, 165);
INSERT INTO public.who_global_data VALUES (84846, 0, 0, 0, 0, 358, 14);
INSERT INTO public.who_global_data VALUES (84847, 0, 0, 0, 0, 359, 193);
INSERT INTO public.who_global_data VALUES (84848, 0, 0, 0, 0, 359, 113);
INSERT INTO public.who_global_data VALUES (84849, 0, 0, 0, 0, 359, 143);
INSERT INTO public.who_global_data VALUES (84850, 0, 0, 0, 0, 359, 219);
INSERT INTO public.who_global_data VALUES (84851, 0, 0, 0, 0, 359, 186);
INSERT INTO public.who_global_data VALUES (84852, 0, 0, 0, 0, 359, 52);
INSERT INTO public.who_global_data VALUES (84853, 0, 0, 0, 0, 359, 180);
INSERT INTO public.who_global_data VALUES (84854, 0, 0, 0, 0, 359, 167);
INSERT INTO public.who_global_data VALUES (84855, 0, 0, 0, 0, 359, 154);
INSERT INTO public.who_global_data VALUES (84856, 0, 0, 0, 0, 359, 94);
INSERT INTO public.who_global_data VALUES (84857, 0, 0, 0, 0, 359, 66);
INSERT INTO public.who_global_data VALUES (84858, 0, 19, 0, 0, 359, 58);
INSERT INTO public.who_global_data VALUES (84859, 0, 0, 0, 0, 359, 163);
INSERT INTO public.who_global_data VALUES (84860, 0, 0, 0, 0, 359, 37);
INSERT INTO public.who_global_data VALUES (84861, 0, 0, 0, 0, 359, 142);
INSERT INTO public.who_global_data VALUES (84862, 0, 0, 0, 0, 359, 83);
INSERT INTO public.who_global_data VALUES (84863, 0, 0, 0, 0, 359, 228);
INSERT INTO public.who_global_data VALUES (84864, 0, 0, 0, 0, 359, 188);
INSERT INTO public.who_global_data VALUES (84865, 0, 0, 0, 0, 359, 62);
INSERT INTO public.who_global_data VALUES (84866, 0, 1, 0, 0, 359, 160);
INSERT INTO public.who_global_data VALUES (84867, 0, 0, 0, 0, 359, 50);
INSERT INTO public.who_global_data VALUES (84868, 0, 0, 0, 0, 359, 33);
INSERT INTO public.who_global_data VALUES (84869, 0, 0, 0, 0, 359, 183);
INSERT INTO public.who_global_data VALUES (84870, 0, 0, 0, 0, 359, 92);
INSERT INTO public.who_global_data VALUES (84871, 0, 0, 0, 0, 359, 158);
INSERT INTO public.who_global_data VALUES (84872, 0, 0, 0, 0, 359, 67);
INSERT INTO public.who_global_data VALUES (84873, 0, 0, 0, 0, 359, 57);
INSERT INTO public.who_global_data VALUES (84874, 0, 0, 0, 0, 359, 38);
INSERT INTO public.who_global_data VALUES (84875, 0, 0, 0, 0, 359, 141);
INSERT INTO public.who_global_data VALUES (84876, 0, 0, 0, 0, 359, 178);
INSERT INTO public.who_global_data VALUES (84877, 0, 0, 0, 0, 359, 108);
INSERT INTO public.who_global_data VALUES (84878, 0, 0, 0, 0, 359, 39);
INSERT INTO public.who_global_data VALUES (84879, 0, 0, 0, 0, 359, 2);
INSERT INTO public.who_global_data VALUES (84880, 0, 0, 0, 0, 359, 195);
INSERT INTO public.who_global_data VALUES (84881, 0, 0, 0, 0, 359, 107);
INSERT INTO public.who_global_data VALUES (84882, 0, 5, 0, 0, 359, 161);
INSERT INTO public.who_global_data VALUES (84883, 0, 0, 0, 0, 359, 212);
INSERT INTO public.who_global_data VALUES (84884, 0, 11, 0, 0, 359, 181);
INSERT INTO public.who_global_data VALUES (84885, 0, 0, 0, 0, 359, 53);
INSERT INTO public.who_global_data VALUES (84886, 0, 0, 0, 0, 359, 164);
INSERT INTO public.who_global_data VALUES (84887, 0, 0, 0, 0, 359, 140);
INSERT INTO public.who_global_data VALUES (84888, 0, 0, 0, 0, 359, 20);
INSERT INTO public.who_global_data VALUES (84889, 15152, 59886, 254, 1368, 359, 112);
INSERT INTO public.who_global_data VALUES (84890, 0, 0, 0, 0, 359, 111);
INSERT INTO public.who_global_data VALUES (84891, 0, 0, 0, 0, 359, 71);
INSERT INTO public.who_global_data VALUES (84892, 0, 0, 0, 0, 359, 218);
INSERT INTO public.who_global_data VALUES (84893, 0, 0, 0, 0, 359, 43);
INSERT INTO public.who_global_data VALUES (84894, 0, 0, 0, 0, 359, 49);
INSERT INTO public.who_global_data VALUES (84895, 0, 0, 0, 0, 359, 1);
INSERT INTO public.who_global_data VALUES (84896, 0, 0, 0, 0, 359, 48);
INSERT INTO public.who_global_data VALUES (84897, 0, 0, 0, 0, 359, 232);
INSERT INTO public.who_global_data VALUES (84898, 0, 0, 0, 0, 359, 175);
INSERT INTO public.who_global_data VALUES (84899, 0, 0, 0, 0, 359, 21);
INSERT INTO public.who_global_data VALUES (84900, 0, 0, 0, 0, 359, 156);
INSERT INTO public.who_global_data VALUES (84901, 0, 0, 0, 0, 359, 95);
INSERT INTO public.who_global_data VALUES (84902, 0, 0, 0, 0, 359, 177);
INSERT INTO public.who_global_data VALUES (84903, 0, 0, 0, 0, 359, 210);
INSERT INTO public.who_global_data VALUES (84904, 0, 0, 0, 0, 359, 120);
INSERT INTO public.who_global_data VALUES (84905, 0, 0, 0, 0, 359, 135);
INSERT INTO public.who_global_data VALUES (84906, 0, 0, 0, 0, 359, 206);
INSERT INTO public.who_global_data VALUES (84907, 0, 0, 0, 0, 359, 189);
INSERT INTO public.who_global_data VALUES (84908, 0, 0, 0, 0, 359, 129);
INSERT INTO public.who_global_data VALUES (84909, 0, 0, 0, 0, 359, 121);
INSERT INTO public.who_global_data VALUES (84910, 0, 0, 0, 0, 359, 59);
INSERT INTO public.who_global_data VALUES (84911, 0, 0, 0, 0, 359, 96);
INSERT INTO public.who_global_data VALUES (84912, 0, 0, 0, 0, 359, 41);
INSERT INTO public.who_global_data VALUES (84913, 0, 0, 0, 0, 359, 216);
INSERT INTO public.who_global_data VALUES (84914, 0, 0, 0, 0, 359, 236);
INSERT INTO public.who_global_data VALUES (84915, 0, 0, 0, 0, 359, 150);
INSERT INTO public.who_global_data VALUES (84916, 0, 0, 0, 0, 359, 61);
INSERT INTO public.who_global_data VALUES (84917, 0, 0, 0, 0, 359, 7);
INSERT INTO public.who_global_data VALUES (84918, 0, 1, 0, 0, 359, 169);
INSERT INTO public.who_global_data VALUES (84919, 0, 11, 0, 0, 359, 28);
INSERT INTO public.who_global_data VALUES (84920, 0, 0, 0, 0, 359, 85);
INSERT INTO public.who_global_data VALUES (84921, 0, 0, 0, 0, 359, 211);
INSERT INTO public.who_global_data VALUES (84922, 0, 0, 0, 0, 359, 60);
INSERT INTO public.who_global_data VALUES (84923, 0, 0, 0, 0, 359, 3);
INSERT INTO public.who_global_data VALUES (84924, 0, 0, 0, 0, 359, 11);
INSERT INTO public.who_global_data VALUES (84925, 0, 15, 0, 0, 359, 89);
INSERT INTO public.who_global_data VALUES (84926, 0, 0, 0, 0, 359, 24);
INSERT INTO public.who_global_data VALUES (84927, 0, 0, 0, 0, 359, 162);
INSERT INTO public.who_global_data VALUES (84928, 0, 0, 0, 0, 359, 100);
INSERT INTO public.who_global_data VALUES (84929, 0, 0, 0, 0, 359, 47);
INSERT INTO public.who_global_data VALUES (84930, 0, 0, 0, 0, 359, 29);
INSERT INTO public.who_global_data VALUES (84931, 0, 0, 0, 0, 359, 40);
INSERT INTO public.who_global_data VALUES (84932, 0, 0, 0, 0, 359, 222);
INSERT INTO public.who_global_data VALUES (84933, 0, 0, 0, 0, 359, 132);
INSERT INTO public.who_global_data VALUES (84934, 0, 0, 0, 0, 359, 130);
INSERT INTO public.who_global_data VALUES (84935, 0, 0, 0, 0, 359, 234);
INSERT INTO public.who_global_data VALUES (84936, 0, 0, 0, 0, 359, 23);
INSERT INTO public.who_global_data VALUES (84937, 0, 0, 0, 0, 359, 192);
INSERT INTO public.who_global_data VALUES (84938, 0, 0, 0, 0, 359, 69);
INSERT INTO public.who_global_data VALUES (84939, 0, 0, 0, 0, 359, 187);
INSERT INTO public.who_global_data VALUES (84940, 0, 0, 0, 0, 359, 230);
INSERT INTO public.who_global_data VALUES (84941, 0, 0, 0, 0, 359, 77);
INSERT INTO public.who_global_data VALUES (84942, 0, 0, 0, 0, 359, 9);
INSERT INTO public.who_global_data VALUES (84943, 0, 7, 0, 0, 359, 74);
INSERT INTO public.who_global_data VALUES (84944, 0, 0, 0, 0, 359, 224);
INSERT INTO public.who_global_data VALUES (84945, 0, 0, 0, 0, 359, 199);
INSERT INTO public.who_global_data VALUES (84946, 0, 0, 0, 0, 359, 190);
INSERT INTO public.who_global_data VALUES (84947, 0, 0, 0, 0, 359, 12);
INSERT INTO public.who_global_data VALUES (84948, 0, 0, 0, 0, 359, 104);
INSERT INTO public.who_global_data VALUES (84949, 0, 0, 0, 0, 359, 153);
INSERT INTO public.who_global_data VALUES (84950, 0, 3, 0, 0, 359, 91);
INSERT INTO public.who_global_data VALUES (84951, 0, 0, 0, 0, 359, 215);
INSERT INTO public.who_global_data VALUES (84952, 4, 37, 1, 1, 359, 84);
INSERT INTO public.who_global_data VALUES (84953, 0, 0, 0, 0, 359, 231);
INSERT INTO public.who_global_data VALUES (84954, 0, 0, 0, 0, 359, 196);
INSERT INTO public.who_global_data VALUES (84955, 0, 0, 0, 0, 359, 105);
INSERT INTO public.who_global_data VALUES (84956, 0, 0, 0, 0, 359, 122);
INSERT INTO public.who_global_data VALUES (84957, 0, 0, 0, 0, 359, 159);
INSERT INTO public.who_global_data VALUES (84958, 0, 0, 0, 0, 359, 75);
INSERT INTO public.who_global_data VALUES (84959, 0, 0, 0, 0, 359, 27);
INSERT INTO public.who_global_data VALUES (84960, 0, 0, 0, 0, 359, 54);
INSERT INTO public.who_global_data VALUES (84961, 0, 0, 0, 0, 359, 226);
INSERT INTO public.who_global_data VALUES (84962, 0, 0, 0, 0, 359, 79);
INSERT INTO public.who_global_data VALUES (84963, 0, 0, 0, 0, 359, 56);
INSERT INTO public.who_global_data VALUES (84964, 0, 0, 0, 0, 359, 117);
INSERT INTO public.who_global_data VALUES (84965, 0, 0, 0, 0, 359, 152);
INSERT INTO public.who_global_data VALUES (84966, 0, 0, 0, 0, 359, 16);
INSERT INTO public.who_global_data VALUES (84967, 0, 0, 0, 0, 359, 10);
INSERT INTO public.who_global_data VALUES (84968, 0, 0, 0, 0, 359, 201);
INSERT INTO public.who_global_data VALUES (84969, 0, 0, 0, 0, 359, 174);
INSERT INTO public.who_global_data VALUES (84970, 0, 0, 0, 0, 359, 119);
INSERT INTO public.who_global_data VALUES (84971, 0, 0, 0, 0, 359, 168);
INSERT INTO public.who_global_data VALUES (84972, 1, 23, 0, 0, 359, 99);
INSERT INTO public.who_global_data VALUES (84973, 0, 0, 0, 0, 359, 171);
INSERT INTO public.who_global_data VALUES (84974, 0, 0, 0, 0, 359, 87);
INSERT INTO public.who_global_data VALUES (84975, 0, 0, 0, 0, 359, 123);
INSERT INTO public.who_global_data VALUES (84976, 0, 0, 0, 0, 359, 151);
INSERT INTO public.who_global_data VALUES (84977, 0, 0, 0, 0, 359, 213);
INSERT INTO public.who_global_data VALUES (84978, 0, 0, 0, 0, 359, 118);
INSERT INTO public.who_global_data VALUES (84979, 0, 0, 0, 0, 359, 134);
INSERT INTO public.who_global_data VALUES (84980, 0, 0, 0, 0, 359, 65);
INSERT INTO public.who_global_data VALUES (84981, 0, 0, 0, 0, 359, 102);
INSERT INTO public.who_global_data VALUES (84982, 0, 0, 0, 0, 359, 223);
INSERT INTO public.who_global_data VALUES (84983, 0, 0, 0, 0, 359, 4);
INSERT INTO public.who_global_data VALUES (84984, 0, 0, 0, 0, 359, 146);
INSERT INTO public.who_global_data VALUES (84985, 0, 0, 0, 0, 359, 31);
INSERT INTO public.who_global_data VALUES (84986, 0, 0, 0, 0, 359, 127);
INSERT INTO public.who_global_data VALUES (84987, 0, 0, 0, 0, 359, 22);
INSERT INTO public.who_global_data VALUES (84988, 0, 0, 0, 0, 359, 115);
INSERT INTO public.who_global_data VALUES (84989, 0, 0, 0, 0, 359, 106);
INSERT INTO public.who_global_data VALUES (84990, 0, 0, 0, 0, 359, 90);
INSERT INTO public.who_global_data VALUES (84991, 0, 0, 0, 0, 359, 70);
INSERT INTO public.who_global_data VALUES (84992, 0, 5, 0, 0, 359, 46);
INSERT INTO public.who_global_data VALUES (84993, 0, 0, 0, 0, 359, 139);
INSERT INTO public.who_global_data VALUES (84994, 0, 0, 0, 0, 359, 42);
INSERT INTO public.who_global_data VALUES (84995, 0, 0, 0, 0, 359, 80);
INSERT INTO public.who_global_data VALUES (84996, 0, 0, 0, 0, 359, 203);
INSERT INTO public.who_global_data VALUES (84997, 0, 0, 0, 0, 359, 136);
INSERT INTO public.who_global_data VALUES (84998, 0, 0, 0, 0, 359, 63);
INSERT INTO public.who_global_data VALUES (84999, 0, 0, 0, 0, 359, 17);
INSERT INTO public.who_global_data VALUES (85000, 0, 0, 0, 0, 359, 172);
INSERT INTO public.who_global_data VALUES (85001, 0, 0, 0, 0, 359, 109);
INSERT INTO public.who_global_data VALUES (85002, 0, 0, 0, 0, 359, 200);
INSERT INTO public.who_global_data VALUES (85003, 0, 0, 0, 0, 359, 93);
INSERT INTO public.who_global_data VALUES (85004, 0, 0, 0, 0, 359, 5);
INSERT INTO public.who_global_data VALUES (85005, 44, 222, 0, 0, 359, 214);
INSERT INTO public.who_global_data VALUES (85006, 0, 0, 0, 0, 359, 204);
INSERT INTO public.who_global_data VALUES (85007, 0, 0, 0, 0, 359, 198);
INSERT INTO public.who_global_data VALUES (85008, 0, 0, 0, 0, 359, 173);
INSERT INTO public.who_global_data VALUES (85009, 0, 0, 0, 0, 359, 229);
INSERT INTO public.who_global_data VALUES (85010, 0, 0, 0, 0, 359, 76);
INSERT INTO public.who_global_data VALUES (85011, 0, 0, 0, 0, 359, 138);
INSERT INTO public.who_global_data VALUES (85012, 0, 7, 0, 1, 359, 98);
INSERT INTO public.who_global_data VALUES (85013, 0, 0, 0, 0, 359, 103);
INSERT INTO public.who_global_data VALUES (85014, 0, 0, 0, 0, 359, 225);
INSERT INTO public.who_global_data VALUES (85015, 0, 0, 0, 0, 359, 131);
INSERT INTO public.who_global_data VALUES (85016, 0, 0, 0, 0, 359, 235);
INSERT INTO public.who_global_data VALUES (85017, 0, 0, 0, 0, 359, 137);
INSERT INTO public.who_global_data VALUES (85018, 0, 32, 0, 0, 359, 81);
INSERT INTO public.who_global_data VALUES (85019, 0, 0, 0, 0, 359, 182);
INSERT INTO public.who_global_data VALUES (85020, 0, 0, 0, 0, 359, 145);
INSERT INTO public.who_global_data VALUES (85021, 0, 0, 0, 0, 359, 26);
INSERT INTO public.who_global_data VALUES (85022, 0, 2, 0, 0, 359, 170);
INSERT INTO public.who_global_data VALUES (85023, 0, 0, 0, 0, 359, 191);
INSERT INTO public.who_global_data VALUES (85024, 0, 0, 0, 0, 359, 221);
INSERT INTO public.who_global_data VALUES (85025, 0, 0, 0, 0, 359, 64);
INSERT INTO public.who_global_data VALUES (85026, 0, 0, 0, 0, 359, 116);
INSERT INTO public.who_global_data VALUES (85027, 0, 0, 0, 0, 359, 128);
INSERT INTO public.who_global_data VALUES (85028, 0, 0, 0, 0, 359, 6);
INSERT INTO public.who_global_data VALUES (85029, 0, 0, 0, 0, 359, 227);
INSERT INTO public.who_global_data VALUES (85030, 0, 0, 0, 0, 359, 68);
INSERT INTO public.who_global_data VALUES (85031, 0, 0, 0, 0, 359, 184);
INSERT INTO public.who_global_data VALUES (85032, 0, 0, 0, 0, 359, 82);
INSERT INTO public.who_global_data VALUES (85033, 0, 0, 0, 0, 359, 149);
INSERT INTO public.who_global_data VALUES (85034, 0, 0, 0, 0, 359, 197);
INSERT INTO public.who_global_data VALUES (85035, 0, 0, 0, 0, 359, 78);
INSERT INTO public.who_global_data VALUES (85036, 0, 0, 0, 0, 359, 233);
INSERT INTO public.who_global_data VALUES (85037, 0, 0, 0, 0, 359, 133);
INSERT INTO public.who_global_data VALUES (85038, 0, 0, 0, 0, 359, 35);
INSERT INTO public.who_global_data VALUES (85039, 0, 0, 0, 0, 359, 114);
INSERT INTO public.who_global_data VALUES (85040, 8, 62, 0, 0, 359, 237);
INSERT INTO public.who_global_data VALUES (85041, 0, 0, 0, 0, 359, 55);
INSERT INTO public.who_global_data VALUES (85042, 0, 0, 0, 0, 359, 176);
INSERT INTO public.who_global_data VALUES (85043, 0, 0, 0, 0, 359, 202);
INSERT INTO public.who_global_data VALUES (85044, 0, 0, 0, 0, 359, 155);
INSERT INTO public.who_global_data VALUES (85045, 0, 0, 0, 0, 359, 32);
INSERT INTO public.who_global_data VALUES (85046, 0, 0, 0, 0, 359, 220);
INSERT INTO public.who_global_data VALUES (85047, 0, 0, 0, 0, 359, 30);
INSERT INTO public.who_global_data VALUES (85048, 0, 0, 0, 0, 359, 147);
INSERT INTO public.who_global_data VALUES (85049, 0, 24, 1, 1, 359, 208);
INSERT INTO public.who_global_data VALUES (85050, 0, 5, 0, 0, 359, 45);
INSERT INTO public.who_global_data VALUES (85051, 0, 0, 0, 0, 359, 110);
INSERT INTO public.who_global_data VALUES (85052, 0, 0, 0, 0, 359, 88);
INSERT INTO public.who_global_data VALUES (85053, 0, 1, 0, 0, 359, 51);
INSERT INTO public.who_global_data VALUES (85054, 0, 0, 0, 0, 359, 209);
INSERT INTO public.who_global_data VALUES (85055, 0, 0, 0, 0, 359, 205);
INSERT INTO public.who_global_data VALUES (85056, 0, 0, 0, 0, 359, 18);
INSERT INTO public.who_global_data VALUES (85057, 0, 37, 0, 0, 359, 72);
INSERT INTO public.who_global_data VALUES (85058, 1, 10, 0, 0, 359, 44);
INSERT INTO public.who_global_data VALUES (85059, 0, 0, 0, 0, 359, 15);
INSERT INTO public.who_global_data VALUES (85060, 0, 0, 0, 0, 359, 25);
INSERT INTO public.who_global_data VALUES (85061, 0, 0, 0, 0, 359, 179);
INSERT INTO public.who_global_data VALUES (85062, 0, 0, 0, 0, 359, 34);
INSERT INTO public.who_global_data VALUES (85063, 0, 0, 0, 0, 359, 207);
INSERT INTO public.who_global_data VALUES (85064, 0, 0, 0, 0, 359, 166);
INSERT INTO public.who_global_data VALUES (85065, 0, 0, 0, 0, 359, 126);
INSERT INTO public.who_global_data VALUES (85066, 0, 0, 0, 0, 359, 97);
INSERT INTO public.who_global_data VALUES (85067, 0, 0, 0, 0, 359, 36);
INSERT INTO public.who_global_data VALUES (85068, 0, 0, 0, 0, 359, 125);
INSERT INTO public.who_global_data VALUES (85069, 0, 0, 0, 0, 359, 124);
INSERT INTO public.who_global_data VALUES (85070, 0, 0, 0, 0, 359, 185);
INSERT INTO public.who_global_data VALUES (85071, 0, 12, 0, 0, 359, 194);
INSERT INTO public.who_global_data VALUES (85072, 0, 0, 0, 0, 359, 144);
INSERT INTO public.who_global_data VALUES (85073, 2, 19, 0, 0, 359, 19);
INSERT INTO public.who_global_data VALUES (85074, 0, 0, 0, 0, 359, 217);
INSERT INTO public.who_global_data VALUES (85075, 0, 0, 0, 0, 359, 148);
INSERT INTO public.who_global_data VALUES (85076, 0, 0, 0, 0, 359, 86);
INSERT INTO public.who_global_data VALUES (85077, 0, 0, 0, 0, 359, 13);
INSERT INTO public.who_global_data VALUES (85078, 0, 0, 0, 0, 359, 157);
INSERT INTO public.who_global_data VALUES (85079, 1, 20, 0, 0, 359, 8);
INSERT INTO public.who_global_data VALUES (85080, 0, 0, 0, 0, 359, 73);
INSERT INTO public.who_global_data VALUES (85081, 0, 0, 0, 0, 359, 101);
INSERT INTO public.who_global_data VALUES (85082, 0, 0, 0, 0, 359, 165);
INSERT INTO public.who_global_data VALUES (85083, 0, 0, 0, 0, 359, 14);
INSERT INTO public.who_global_data VALUES (85084, 0, 0, 0, 0, 360, 193);
INSERT INTO public.who_global_data VALUES (85085, 0, 0, 0, 0, 360, 113);
INSERT INTO public.who_global_data VALUES (85086, 0, 0, 0, 0, 360, 143);
INSERT INTO public.who_global_data VALUES (85087, 0, 0, 0, 0, 360, 219);
INSERT INTO public.who_global_data VALUES (85088, 0, 0, 0, 0, 360, 186);
INSERT INTO public.who_global_data VALUES (85089, 0, 0, 0, 0, 360, 52);
INSERT INTO public.who_global_data VALUES (85090, 0, 0, 0, 0, 360, 180);
INSERT INTO public.who_global_data VALUES (85091, 0, 0, 0, 0, 360, 167);
INSERT INTO public.who_global_data VALUES (85092, 0, 0, 0, 0, 360, 154);
INSERT INTO public.who_global_data VALUES (85093, 0, 0, 0, 0, 360, 94);
INSERT INTO public.who_global_data VALUES (85094, 0, 0, 0, 0, 360, 66);
INSERT INTO public.who_global_data VALUES (85095, 0, 19, 0, 0, 360, 58);
INSERT INTO public.who_global_data VALUES (85096, 0, 0, 0, 0, 360, 163);
INSERT INTO public.who_global_data VALUES (85097, 0, 0, 0, 0, 360, 37);
INSERT INTO public.who_global_data VALUES (85098, 0, 0, 0, 0, 360, 142);
INSERT INTO public.who_global_data VALUES (85099, 0, 0, 0, 0, 360, 83);
INSERT INTO public.who_global_data VALUES (85100, 0, 0, 0, 0, 360, 228);
INSERT INTO public.who_global_data VALUES (85101, 0, 0, 0, 0, 360, 188);
INSERT INTO public.who_global_data VALUES (85102, 0, 0, 0, 0, 360, 62);
INSERT INTO public.who_global_data VALUES (85103, 0, 1, 0, 0, 360, 160);
INSERT INTO public.who_global_data VALUES (85104, 0, 0, 0, 0, 360, 50);
INSERT INTO public.who_global_data VALUES (85105, 0, 0, 0, 0, 360, 33);
INSERT INTO public.who_global_data VALUES (85106, 0, 0, 0, 0, 360, 183);
INSERT INTO public.who_global_data VALUES (85107, 0, 0, 0, 0, 360, 92);
INSERT INTO public.who_global_data VALUES (85108, 0, 0, 0, 0, 360, 158);
INSERT INTO public.who_global_data VALUES (85109, 0, 0, 0, 0, 360, 67);
INSERT INTO public.who_global_data VALUES (85110, 0, 0, 0, 0, 360, 57);
INSERT INTO public.who_global_data VALUES (85111, 0, 0, 0, 0, 360, 38);
INSERT INTO public.who_global_data VALUES (85112, 0, 0, 0, 0, 360, 141);
INSERT INTO public.who_global_data VALUES (85113, 0, 0, 0, 0, 360, 178);
INSERT INTO public.who_global_data VALUES (85114, 0, 0, 0, 0, 360, 108);
INSERT INTO public.who_global_data VALUES (85115, 0, 0, 0, 0, 360, 39);
INSERT INTO public.who_global_data VALUES (85116, 0, 0, 0, 0, 360, 2);
INSERT INTO public.who_global_data VALUES (85117, 0, 0, 0, 0, 360, 195);
INSERT INTO public.who_global_data VALUES (85118, 0, 0, 0, 0, 360, 107);
INSERT INTO public.who_global_data VALUES (85119, 0, 5, 0, 0, 360, 161);
INSERT INTO public.who_global_data VALUES (85120, 0, 0, 0, 0, 360, 212);
INSERT INTO public.who_global_data VALUES (85121, 0, 11, 0, 0, 360, 181);
INSERT INTO public.who_global_data VALUES (85122, 0, 0, 0, 0, 360, 53);
INSERT INTO public.who_global_data VALUES (85123, 0, 0, 0, 0, 360, 164);
INSERT INTO public.who_global_data VALUES (85124, 0, 0, 0, 0, 360, 140);
INSERT INTO public.who_global_data VALUES (85125, 0, 0, 0, 0, 360, 20);
INSERT INTO public.who_global_data VALUES (85126, 2022, 44734, 97, 1114, 360, 112);
INSERT INTO public.who_global_data VALUES (85127, 0, 0, 0, 0, 360, 111);
INSERT INTO public.who_global_data VALUES (85128, 0, 0, 0, 0, 360, 71);
INSERT INTO public.who_global_data VALUES (85129, 0, 0, 0, 0, 360, 218);
INSERT INTO public.who_global_data VALUES (85130, 0, 0, 0, 0, 360, 43);
INSERT INTO public.who_global_data VALUES (85131, 0, 0, 0, 0, 360, 49);
INSERT INTO public.who_global_data VALUES (85132, 0, 0, 0, 0, 360, 1);
INSERT INTO public.who_global_data VALUES (85133, 0, 0, 0, 0, 360, 48);
INSERT INTO public.who_global_data VALUES (85134, 0, 0, 0, 0, 360, 232);
INSERT INTO public.who_global_data VALUES (85135, 0, 0, 0, 0, 360, 175);
INSERT INTO public.who_global_data VALUES (85136, 0, 0, 0, 0, 360, 21);
INSERT INTO public.who_global_data VALUES (85137, 0, 0, 0, 0, 360, 156);
INSERT INTO public.who_global_data VALUES (85138, 0, 0, 0, 0, 360, 95);
INSERT INTO public.who_global_data VALUES (85139, 0, 0, 0, 0, 360, 177);
INSERT INTO public.who_global_data VALUES (85140, 0, 0, 0, 0, 360, 210);
INSERT INTO public.who_global_data VALUES (85141, 0, 0, 0, 0, 360, 120);
INSERT INTO public.who_global_data VALUES (85142, 0, 0, 0, 0, 360, 135);
INSERT INTO public.who_global_data VALUES (85143, 0, 0, 0, 0, 360, 206);
INSERT INTO public.who_global_data VALUES (85144, 0, 0, 0, 0, 360, 189);
INSERT INTO public.who_global_data VALUES (85145, 0, 0, 0, 0, 360, 129);
INSERT INTO public.who_global_data VALUES (85146, 0, 0, 0, 0, 360, 121);
INSERT INTO public.who_global_data VALUES (85147, 0, 0, 0, 0, 360, 59);
INSERT INTO public.who_global_data VALUES (85148, 0, 0, 0, 0, 360, 96);
INSERT INTO public.who_global_data VALUES (85149, 0, 0, 0, 0, 360, 41);
INSERT INTO public.who_global_data VALUES (85150, 0, 0, 0, 0, 360, 216);
INSERT INTO public.who_global_data VALUES (85151, 0, 0, 0, 0, 360, 236);
INSERT INTO public.who_global_data VALUES (85152, 0, 0, 0, 0, 360, 150);
INSERT INTO public.who_global_data VALUES (85153, 0, 0, 0, 0, 360, 61);
INSERT INTO public.who_global_data VALUES (85154, 0, 0, 0, 0, 360, 7);
INSERT INTO public.who_global_data VALUES (85155, 0, 1, 0, 0, 360, 169);
INSERT INTO public.who_global_data VALUES (85156, 0, 11, 0, 0, 360, 28);
INSERT INTO public.who_global_data VALUES (85157, 0, 0, 0, 0, 360, 85);
INSERT INTO public.who_global_data VALUES (85158, 0, 0, 0, 0, 360, 211);
INSERT INTO public.who_global_data VALUES (85159, 0, 0, 0, 0, 360, 60);
INSERT INTO public.who_global_data VALUES (85160, 0, 0, 0, 0, 360, 3);
INSERT INTO public.who_global_data VALUES (85161, 0, 0, 0, 0, 360, 11);
INSERT INTO public.who_global_data VALUES (85162, 2, 15, 0, 0, 360, 89);
INSERT INTO public.who_global_data VALUES (85163, 0, 0, 0, 0, 360, 24);
INSERT INTO public.who_global_data VALUES (85164, 0, 0, 0, 0, 360, 162);
INSERT INTO public.who_global_data VALUES (85165, 0, 0, 0, 0, 360, 100);
INSERT INTO public.who_global_data VALUES (85166, 0, 0, 0, 0, 360, 47);
INSERT INTO public.who_global_data VALUES (85167, 0, 0, 0, 0, 360, 29);
INSERT INTO public.who_global_data VALUES (85168, 0, 0, 0, 0, 360, 40);
INSERT INTO public.who_global_data VALUES (85169, 0, 0, 0, 0, 360, 222);
INSERT INTO public.who_global_data VALUES (85170, 0, 0, 0, 0, 360, 132);
INSERT INTO public.who_global_data VALUES (85171, 0, 0, 0, 0, 360, 130);
INSERT INTO public.who_global_data VALUES (85172, 0, 0, 0, 0, 360, 234);
INSERT INTO public.who_global_data VALUES (85173, 0, 0, 0, 0, 360, 23);
INSERT INTO public.who_global_data VALUES (85174, 0, 0, 0, 0, 360, 192);
INSERT INTO public.who_global_data VALUES (85175, 0, 0, 0, 0, 360, 69);
INSERT INTO public.who_global_data VALUES (85176, 0, 0, 0, 0, 360, 187);
INSERT INTO public.who_global_data VALUES (85177, 0, 0, 0, 0, 360, 230);
INSERT INTO public.who_global_data VALUES (85178, 0, 0, 0, 0, 360, 77);
INSERT INTO public.who_global_data VALUES (85179, 0, 0, 0, 0, 360, 9);
INSERT INTO public.who_global_data VALUES (85180, 0, 7, 0, 0, 360, 74);
INSERT INTO public.who_global_data VALUES (85181, 0, 0, 0, 0, 360, 224);
INSERT INTO public.who_global_data VALUES (85182, 0, 0, 0, 0, 360, 199);
INSERT INTO public.who_global_data VALUES (85183, 0, 0, 0, 0, 360, 190);
INSERT INTO public.who_global_data VALUES (85184, 0, 0, 0, 0, 360, 12);
INSERT INTO public.who_global_data VALUES (85185, 0, 0, 0, 0, 360, 104);
INSERT INTO public.who_global_data VALUES (85186, 0, 0, 0, 0, 360, 153);
INSERT INTO public.who_global_data VALUES (85187, 0, 3, 0, 0, 360, 91);
INSERT INTO public.who_global_data VALUES (85188, 0, 0, 0, 0, 360, 215);
INSERT INTO public.who_global_data VALUES (85189, 1, 33, 0, 0, 360, 84);
INSERT INTO public.who_global_data VALUES (85190, 0, 0, 0, 0, 360, 231);
INSERT INTO public.who_global_data VALUES (85191, 0, 0, 0, 0, 360, 196);
INSERT INTO public.who_global_data VALUES (85192, 0, 0, 0, 0, 360, 105);
INSERT INTO public.who_global_data VALUES (85193, 0, 0, 0, 0, 360, 122);
INSERT INTO public.who_global_data VALUES (85194, 0, 0, 0, 0, 360, 159);
INSERT INTO public.who_global_data VALUES (85195, 0, 0, 0, 0, 360, 75);
INSERT INTO public.who_global_data VALUES (85196, 0, 0, 0, 0, 360, 27);
INSERT INTO public.who_global_data VALUES (85197, 0, 0, 0, 0, 360, 54);
INSERT INTO public.who_global_data VALUES (85198, 0, 0, 0, 0, 360, 226);
INSERT INTO public.who_global_data VALUES (85199, 0, 0, 0, 0, 360, 79);
INSERT INTO public.who_global_data VALUES (85200, 0, 0, 0, 0, 360, 56);
INSERT INTO public.who_global_data VALUES (85201, 0, 0, 0, 0, 360, 117);
INSERT INTO public.who_global_data VALUES (85202, 0, 0, 0, 0, 360, 152);
INSERT INTO public.who_global_data VALUES (85203, 0, 0, 0, 0, 360, 16);
INSERT INTO public.who_global_data VALUES (85204, 0, 0, 0, 0, 360, 10);
INSERT INTO public.who_global_data VALUES (85205, 0, 0, 0, 0, 360, 201);
INSERT INTO public.who_global_data VALUES (85206, 0, 0, 0, 0, 360, 174);
INSERT INTO public.who_global_data VALUES (85207, 0, 0, 0, 0, 360, 119);
INSERT INTO public.who_global_data VALUES (85208, 0, 0, 0, 0, 360, 168);
INSERT INTO public.who_global_data VALUES (85209, 0, 22, 0, 0, 360, 99);
INSERT INTO public.who_global_data VALUES (85210, 0, 0, 0, 0, 360, 171);
INSERT INTO public.who_global_data VALUES (85211, 0, 0, 0, 0, 360, 87);
INSERT INTO public.who_global_data VALUES (85212, 0, 0, 0, 0, 360, 123);
INSERT INTO public.who_global_data VALUES (85213, 0, 0, 0, 0, 360, 151);
INSERT INTO public.who_global_data VALUES (85214, 0, 0, 0, 0, 360, 213);
INSERT INTO public.who_global_data VALUES (85215, 0, 0, 0, 0, 360, 118);
INSERT INTO public.who_global_data VALUES (85216, 0, 0, 0, 0, 360, 134);
INSERT INTO public.who_global_data VALUES (85217, 0, 0, 0, 0, 360, 65);
INSERT INTO public.who_global_data VALUES (85218, 0, 0, 0, 0, 360, 102);
INSERT INTO public.who_global_data VALUES (85219, 0, 0, 0, 0, 360, 223);
INSERT INTO public.who_global_data VALUES (85220, 0, 0, 0, 0, 360, 4);
INSERT INTO public.who_global_data VALUES (85221, 0, 0, 0, 0, 360, 146);
INSERT INTO public.who_global_data VALUES (85222, 0, 0, 0, 0, 360, 31);
INSERT INTO public.who_global_data VALUES (85223, 0, 0, 0, 0, 360, 127);
INSERT INTO public.who_global_data VALUES (85224, 0, 0, 0, 0, 360, 22);
INSERT INTO public.who_global_data VALUES (85225, 0, 0, 0, 0, 360, 115);
INSERT INTO public.who_global_data VALUES (85226, 0, 0, 0, 0, 360, 106);
INSERT INTO public.who_global_data VALUES (85227, 0, 0, 0, 0, 360, 90);
INSERT INTO public.who_global_data VALUES (85228, 0, 0, 0, 0, 360, 70);
INSERT INTO public.who_global_data VALUES (85229, 0, 5, 0, 0, 360, 46);
INSERT INTO public.who_global_data VALUES (85230, 0, 0, 0, 0, 360, 139);
INSERT INTO public.who_global_data VALUES (85231, 0, 0, 0, 0, 360, 42);
INSERT INTO public.who_global_data VALUES (85232, 0, 0, 0, 0, 360, 80);
INSERT INTO public.who_global_data VALUES (85233, 0, 0, 0, 0, 360, 203);
INSERT INTO public.who_global_data VALUES (85234, 0, 0, 0, 0, 360, 136);
INSERT INTO public.who_global_data VALUES (85235, 0, 0, 0, 0, 360, 63);
INSERT INTO public.who_global_data VALUES (85236, 0, 0, 0, 0, 360, 17);
INSERT INTO public.who_global_data VALUES (85237, 0, 0, 0, 0, 360, 172);
INSERT INTO public.who_global_data VALUES (85238, 0, 0, 0, 0, 360, 109);
INSERT INTO public.who_global_data VALUES (85239, 0, 0, 0, 0, 360, 200);
INSERT INTO public.who_global_data VALUES (85240, 0, 0, 0, 0, 360, 93);
INSERT INTO public.who_global_data VALUES (85241, 0, 0, 0, 0, 360, 5);
INSERT INTO public.who_global_data VALUES (85242, 39, 178, 0, 0, 360, 214);
INSERT INTO public.who_global_data VALUES (85243, 0, 0, 0, 0, 360, 204);
INSERT INTO public.who_global_data VALUES (85244, 0, 0, 0, 0, 360, 198);
INSERT INTO public.who_global_data VALUES (85245, 0, 0, 0, 0, 360, 173);
INSERT INTO public.who_global_data VALUES (85246, 0, 0, 0, 0, 360, 229);
INSERT INTO public.who_global_data VALUES (85247, 0, 0, 0, 0, 360, 76);
INSERT INTO public.who_global_data VALUES (85248, 0, 0, 0, 0, 360, 138);
INSERT INTO public.who_global_data VALUES (85249, 0, 7, 0, 1, 360, 98);
INSERT INTO public.who_global_data VALUES (85250, 0, 0, 0, 0, 360, 103);
INSERT INTO public.who_global_data VALUES (85251, 0, 0, 0, 0, 360, 225);
INSERT INTO public.who_global_data VALUES (85252, 0, 0, 0, 0, 360, 131);
INSERT INTO public.who_global_data VALUES (85253, 0, 0, 0, 0, 360, 235);
INSERT INTO public.who_global_data VALUES (85254, 0, 0, 0, 0, 360, 137);
INSERT INTO public.who_global_data VALUES (85255, 0, 32, 0, 0, 360, 81);
INSERT INTO public.who_global_data VALUES (85256, 0, 0, 0, 0, 360, 182);
INSERT INTO public.who_global_data VALUES (85257, 0, 0, 0, 0, 360, 145);
INSERT INTO public.who_global_data VALUES (85258, 0, 0, 0, 0, 360, 26);
INSERT INTO public.who_global_data VALUES (85259, 0, 2, 0, 0, 360, 170);
INSERT INTO public.who_global_data VALUES (85260, 0, 0, 0, 0, 360, 191);
INSERT INTO public.who_global_data VALUES (85261, 0, 0, 0, 0, 360, 221);
INSERT INTO public.who_global_data VALUES (85262, 0, 0, 0, 0, 360, 64);
INSERT INTO public.who_global_data VALUES (85263, 0, 0, 0, 0, 360, 116);
INSERT INTO public.who_global_data VALUES (85264, 0, 0, 0, 0, 360, 128);
INSERT INTO public.who_global_data VALUES (85265, 0, 0, 0, 0, 360, 6);
INSERT INTO public.who_global_data VALUES (85266, 0, 0, 0, 0, 360, 227);
INSERT INTO public.who_global_data VALUES (85267, 0, 0, 0, 0, 360, 68);
INSERT INTO public.who_global_data VALUES (85268, 0, 0, 0, 0, 360, 184);
INSERT INTO public.who_global_data VALUES (85269, 0, 0, 0, 0, 360, 82);
INSERT INTO public.who_global_data VALUES (85270, 0, 0, 0, 0, 360, 149);
INSERT INTO public.who_global_data VALUES (85271, 0, 0, 0, 0, 360, 197);
INSERT INTO public.who_global_data VALUES (85272, 0, 0, 0, 0, 360, 78);
INSERT INTO public.who_global_data VALUES (85273, 0, 0, 0, 0, 360, 233);
INSERT INTO public.who_global_data VALUES (85274, 0, 0, 0, 0, 360, 133);
INSERT INTO public.who_global_data VALUES (85275, 0, 0, 0, 0, 360, 35);
INSERT INTO public.who_global_data VALUES (85276, 0, 0, 0, 0, 360, 114);
INSERT INTO public.who_global_data VALUES (85277, 3, 54, 0, 0, 360, 237);
INSERT INTO public.who_global_data VALUES (85278, 0, 0, 0, 0, 360, 55);
INSERT INTO public.who_global_data VALUES (85279, 0, 0, 0, 0, 360, 176);
INSERT INTO public.who_global_data VALUES (85280, 0, 0, 0, 0, 360, 202);
INSERT INTO public.who_global_data VALUES (85281, 0, 0, 0, 0, 360, 155);
INSERT INTO public.who_global_data VALUES (85282, 0, 0, 0, 0, 360, 32);
INSERT INTO public.who_global_data VALUES (85283, 0, 0, 0, 0, 360, 220);
INSERT INTO public.who_global_data VALUES (85284, 0, 0, 0, 0, 360, 30);
INSERT INTO public.who_global_data VALUES (85285, 0, 0, 0, 0, 360, 147);
INSERT INTO public.who_global_data VALUES (85286, 0, 24, 0, 0, 360, 208);
INSERT INTO public.who_global_data VALUES (85287, 0, 5, 0, 0, 360, 45);
INSERT INTO public.who_global_data VALUES (85288, 0, 0, 0, 0, 360, 110);
INSERT INTO public.who_global_data VALUES (85289, 0, 0, 0, 0, 360, 88);
INSERT INTO public.who_global_data VALUES (85290, 0, 1, 0, 0, 360, 51);
INSERT INTO public.who_global_data VALUES (85291, 0, 0, 0, 0, 360, 209);
INSERT INTO public.who_global_data VALUES (85292, 0, 0, 0, 0, 360, 205);
INSERT INTO public.who_global_data VALUES (85293, 0, 0, 0, 0, 360, 18);
INSERT INTO public.who_global_data VALUES (85294, 0, 37, 0, 0, 360, 72);
INSERT INTO public.who_global_data VALUES (85295, 0, 9, 0, 0, 360, 44);
INSERT INTO public.who_global_data VALUES (85296, 0, 0, 0, 0, 360, 15);
INSERT INTO public.who_global_data VALUES (85297, 0, 0, 0, 0, 360, 25);
INSERT INTO public.who_global_data VALUES (85298, 0, 0, 0, 0, 360, 179);
INSERT INTO public.who_global_data VALUES (85299, 0, 0, 0, 0, 360, 34);
INSERT INTO public.who_global_data VALUES (85300, 0, 0, 0, 0, 360, 207);
INSERT INTO public.who_global_data VALUES (85301, 0, 0, 0, 0, 360, 166);
INSERT INTO public.who_global_data VALUES (85302, 0, 0, 0, 0, 360, 126);
INSERT INTO public.who_global_data VALUES (85303, 0, 0, 0, 0, 360, 97);
INSERT INTO public.who_global_data VALUES (85304, 0, 0, 0, 0, 360, 36);
INSERT INTO public.who_global_data VALUES (85305, 0, 0, 0, 0, 360, 125);
INSERT INTO public.who_global_data VALUES (85306, 0, 0, 0, 0, 360, 124);
INSERT INTO public.who_global_data VALUES (85307, 0, 0, 0, 0, 360, 185);
INSERT INTO public.who_global_data VALUES (85308, 0, 12, 0, 0, 360, 194);
INSERT INTO public.who_global_data VALUES (85309, 0, 0, 0, 0, 360, 144);
INSERT INTO public.who_global_data VALUES (85310, 0, 17, 0, 0, 360, 19);
INSERT INTO public.who_global_data VALUES (85311, 0, 0, 0, 0, 360, 217);
INSERT INTO public.who_global_data VALUES (85312, 0, 0, 0, 0, 360, 148);
INSERT INTO public.who_global_data VALUES (85313, 0, 0, 0, 0, 360, 86);
INSERT INTO public.who_global_data VALUES (85314, 0, 0, 0, 0, 360, 13);
INSERT INTO public.who_global_data VALUES (85315, 0, 0, 0, 0, 360, 157);
INSERT INTO public.who_global_data VALUES (85316, 0, 19, 0, 0, 360, 8);
INSERT INTO public.who_global_data VALUES (85317, 0, 0, 0, 0, 360, 73);
INSERT INTO public.who_global_data VALUES (85318, 0, 0, 0, 0, 360, 101);
INSERT INTO public.who_global_data VALUES (85319, 0, 0, 0, 0, 360, 165);
INSERT INTO public.who_global_data VALUES (85320, 0, 0, 0, 0, 360, 14);
INSERT INTO public.who_global_data VALUES (85321, 0, 0, 0, 0, 361, 193);
INSERT INTO public.who_global_data VALUES (85322, 0, 0, 0, 0, 361, 113);
INSERT INTO public.who_global_data VALUES (85323, 0, 0, 0, 0, 361, 143);
INSERT INTO public.who_global_data VALUES (85324, 0, 0, 0, 0, 361, 219);
INSERT INTO public.who_global_data VALUES (85325, 0, 0, 0, 0, 361, 186);
INSERT INTO public.who_global_data VALUES (85326, 0, 0, 0, 0, 361, 52);
INSERT INTO public.who_global_data VALUES (85327, 0, 0, 0, 0, 361, 180);
INSERT INTO public.who_global_data VALUES (85328, 0, 0, 0, 0, 361, 167);
INSERT INTO public.who_global_data VALUES (85329, 0, 0, 0, 0, 361, 154);
INSERT INTO public.who_global_data VALUES (85330, 0, 0, 0, 0, 361, 94);
INSERT INTO public.who_global_data VALUES (85331, 0, 0, 0, 0, 361, 66);
INSERT INTO public.who_global_data VALUES (85332, 0, 19, 0, 0, 361, 58);
INSERT INTO public.who_global_data VALUES (85333, 0, 0, 0, 0, 361, 163);
INSERT INTO public.who_global_data VALUES (85334, 0, 0, 0, 0, 361, 37);
INSERT INTO public.who_global_data VALUES (85335, 0, 0, 0, 0, 361, 142);
INSERT INTO public.who_global_data VALUES (85336, 0, 0, 0, 0, 361, 83);
INSERT INTO public.who_global_data VALUES (85337, 0, 0, 0, 0, 361, 228);
INSERT INTO public.who_global_data VALUES (85338, 0, 0, 0, 0, 361, 188);
INSERT INTO public.who_global_data VALUES (85339, 0, 0, 0, 0, 361, 62);
INSERT INTO public.who_global_data VALUES (85340, 0, 1, 0, 0, 361, 160);
INSERT INTO public.who_global_data VALUES (85341, 0, 0, 0, 0, 361, 50);
INSERT INTO public.who_global_data VALUES (85342, 0, 0, 0, 0, 361, 33);
INSERT INTO public.who_global_data VALUES (85343, 0, 0, 0, 0, 361, 183);
INSERT INTO public.who_global_data VALUES (85344, 0, 0, 0, 0, 361, 92);
INSERT INTO public.who_global_data VALUES (85345, 0, 0, 0, 0, 361, 158);
INSERT INTO public.who_global_data VALUES (85346, 0, 0, 0, 0, 361, 67);
INSERT INTO public.who_global_data VALUES (85347, 0, 0, 0, 0, 361, 57);
INSERT INTO public.who_global_data VALUES (85348, 0, 0, 0, 0, 361, 38);
INSERT INTO public.who_global_data VALUES (85349, 0, 0, 0, 0, 361, 141);
INSERT INTO public.who_global_data VALUES (85350, 0, 0, 0, 0, 361, 178);
INSERT INTO public.who_global_data VALUES (85351, 0, 0, 0, 0, 361, 108);
INSERT INTO public.who_global_data VALUES (85352, 0, 0, 0, 0, 361, 39);
INSERT INTO public.who_global_data VALUES (85353, 0, 0, 0, 0, 361, 2);
INSERT INTO public.who_global_data VALUES (85354, 0, 0, 0, 0, 361, 195);
INSERT INTO public.who_global_data VALUES (85355, 0, 0, 0, 0, 361, 107);
INSERT INTO public.who_global_data VALUES (85356, 0, 5, 0, 0, 361, 161);
INSERT INTO public.who_global_data VALUES (85357, 0, 0, 0, 0, 361, 212);
INSERT INTO public.who_global_data VALUES (85358, 0, 11, 0, 0, 361, 181);
INSERT INTO public.who_global_data VALUES (85359, 0, 0, 0, 0, 361, 53);
INSERT INTO public.who_global_data VALUES (85360, 0, 0, 0, 0, 361, 164);
INSERT INTO public.who_global_data VALUES (85361, 0, 0, 0, 0, 361, 140);
INSERT INTO public.who_global_data VALUES (85362, 0, 0, 0, 0, 361, 20);
INSERT INTO public.who_global_data VALUES (85363, 2472, 42712, 108, 1017, 361, 112);
INSERT INTO public.who_global_data VALUES (85364, 0, 0, 0, 0, 361, 111);
INSERT INTO public.who_global_data VALUES (85365, 0, 0, 0, 0, 361, 71);
INSERT INTO public.who_global_data VALUES (85366, 0, 0, 0, 0, 361, 218);
INSERT INTO public.who_global_data VALUES (85367, 0, 0, 0, 0, 361, 43);
INSERT INTO public.who_global_data VALUES (85368, 0, 0, 0, 0, 361, 49);
INSERT INTO public.who_global_data VALUES (85369, 0, 0, 0, 0, 361, 1);
INSERT INTO public.who_global_data VALUES (85370, 0, 0, 0, 0, 361, 48);
INSERT INTO public.who_global_data VALUES (85371, 0, 0, 0, 0, 361, 232);
INSERT INTO public.who_global_data VALUES (85372, 0, 0, 0, 0, 361, 175);
INSERT INTO public.who_global_data VALUES (85373, 0, 0, 0, 0, 361, 21);
INSERT INTO public.who_global_data VALUES (85374, 0, 0, 0, 0, 361, 156);
INSERT INTO public.who_global_data VALUES (85375, 0, 0, 0, 0, 361, 95);
INSERT INTO public.who_global_data VALUES (85376, 0, 0, 0, 0, 361, 177);
INSERT INTO public.who_global_data VALUES (85377, 0, 0, 0, 0, 361, 210);
INSERT INTO public.who_global_data VALUES (85378, 0, 0, 0, 0, 361, 120);
INSERT INTO public.who_global_data VALUES (85379, 0, 0, 0, 0, 361, 135);
INSERT INTO public.who_global_data VALUES (85380, 0, 0, 0, 0, 361, 206);
INSERT INTO public.who_global_data VALUES (85381, 0, 0, 0, 0, 361, 189);
INSERT INTO public.who_global_data VALUES (85382, 0, 0, 0, 0, 361, 129);
INSERT INTO public.who_global_data VALUES (85383, 0, 0, 0, 0, 361, 121);
INSERT INTO public.who_global_data VALUES (85384, 0, 0, 0, 0, 361, 59);
INSERT INTO public.who_global_data VALUES (85385, 0, 0, 0, 0, 361, 96);
INSERT INTO public.who_global_data VALUES (85386, 0, 0, 0, 0, 361, 41);
INSERT INTO public.who_global_data VALUES (85387, 0, 0, 0, 0, 361, 216);
INSERT INTO public.who_global_data VALUES (85388, 0, 0, 0, 0, 361, 236);
INSERT INTO public.who_global_data VALUES (85389, 0, 0, 0, 0, 361, 150);
INSERT INTO public.who_global_data VALUES (85390, 0, 0, 0, 0, 361, 61);
INSERT INTO public.who_global_data VALUES (85391, 0, 0, 0, 0, 361, 7);
INSERT INTO public.who_global_data VALUES (85392, 0, 1, 0, 0, 361, 169);
INSERT INTO public.who_global_data VALUES (85393, 0, 11, 0, 0, 361, 28);
INSERT INTO public.who_global_data VALUES (85394, 0, 0, 0, 0, 361, 85);
INSERT INTO public.who_global_data VALUES (85395, 0, 0, 0, 0, 361, 211);
INSERT INTO public.who_global_data VALUES (85396, 0, 0, 0, 0, 361, 60);
INSERT INTO public.who_global_data VALUES (85397, 0, 0, 0, 0, 361, 3);
INSERT INTO public.who_global_data VALUES (85398, 0, 0, 0, 0, 361, 11);
INSERT INTO public.who_global_data VALUES (85399, 0, 13, 0, 0, 361, 89);
INSERT INTO public.who_global_data VALUES (85400, 0, 0, 0, 0, 361, 24);
INSERT INTO public.who_global_data VALUES (85401, 0, 0, 0, 0, 361, 162);
INSERT INTO public.who_global_data VALUES (85402, 0, 0, 0, 0, 361, 100);
INSERT INTO public.who_global_data VALUES (85403, 0, 0, 0, 0, 361, 47);
INSERT INTO public.who_global_data VALUES (85404, 0, 0, 0, 0, 361, 29);
INSERT INTO public.who_global_data VALUES (85405, 0, 0, 0, 0, 361, 40);
INSERT INTO public.who_global_data VALUES (85406, 0, 0, 0, 0, 361, 222);
INSERT INTO public.who_global_data VALUES (85407, 0, 0, 0, 0, 361, 132);
INSERT INTO public.who_global_data VALUES (85408, 0, 0, 0, 0, 361, 130);
INSERT INTO public.who_global_data VALUES (85409, 0, 0, 0, 0, 361, 234);
INSERT INTO public.who_global_data VALUES (85410, 0, 0, 0, 0, 361, 23);
INSERT INTO public.who_global_data VALUES (85411, 0, 0, 0, 0, 361, 192);
INSERT INTO public.who_global_data VALUES (85412, 0, 0, 0, 0, 361, 69);
INSERT INTO public.who_global_data VALUES (85413, 0, 0, 0, 0, 361, 187);
INSERT INTO public.who_global_data VALUES (85414, 0, 0, 0, 0, 361, 230);
INSERT INTO public.who_global_data VALUES (85415, 0, 0, 0, 0, 361, 77);
INSERT INTO public.who_global_data VALUES (85416, 0, 0, 0, 0, 361, 9);
INSERT INTO public.who_global_data VALUES (85417, 0, 7, 0, 0, 361, 74);
INSERT INTO public.who_global_data VALUES (85418, 0, 0, 0, 0, 361, 224);
INSERT INTO public.who_global_data VALUES (85419, 0, 0, 0, 0, 361, 199);
INSERT INTO public.who_global_data VALUES (85420, 0, 0, 0, 0, 361, 190);
INSERT INTO public.who_global_data VALUES (85421, 0, 0, 0, 0, 361, 12);
INSERT INTO public.who_global_data VALUES (85422, 0, 0, 0, 0, 361, 104);
INSERT INTO public.who_global_data VALUES (85423, 0, 0, 0, 0, 361, 153);
INSERT INTO public.who_global_data VALUES (85424, 0, 3, 0, 0, 361, 91);
INSERT INTO public.who_global_data VALUES (85425, 0, 0, 0, 0, 361, 215);
INSERT INTO public.who_global_data VALUES (85426, 2, 32, 0, 0, 361, 84);
INSERT INTO public.who_global_data VALUES (85427, 0, 0, 0, 0, 361, 231);
INSERT INTO public.who_global_data VALUES (85428, 0, 0, 0, 0, 361, 196);
INSERT INTO public.who_global_data VALUES (85429, 0, 0, 0, 0, 361, 105);
INSERT INTO public.who_global_data VALUES (85430, 0, 0, 0, 0, 361, 122);
INSERT INTO public.who_global_data VALUES (85431, 0, 0, 0, 0, 361, 159);
INSERT INTO public.who_global_data VALUES (85432, 0, 0, 0, 0, 361, 75);
INSERT INTO public.who_global_data VALUES (85433, 0, 0, 0, 0, 361, 27);
INSERT INTO public.who_global_data VALUES (85434, 0, 0, 0, 0, 361, 54);
INSERT INTO public.who_global_data VALUES (85435, 0, 0, 0, 0, 361, 226);
INSERT INTO public.who_global_data VALUES (85436, 0, 0, 0, 0, 361, 79);
INSERT INTO public.who_global_data VALUES (85437, 0, 0, 0, 0, 361, 56);
INSERT INTO public.who_global_data VALUES (85438, 0, 0, 0, 0, 361, 117);
INSERT INTO public.who_global_data VALUES (85439, 0, 0, 0, 0, 361, 152);
INSERT INTO public.who_global_data VALUES (85440, 0, 0, 0, 0, 361, 16);
INSERT INTO public.who_global_data VALUES (85441, 0, 0, 0, 0, 361, 10);
INSERT INTO public.who_global_data VALUES (85442, 0, 0, 0, 0, 361, 201);
INSERT INTO public.who_global_data VALUES (85443, 0, 0, 0, 0, 361, 174);
INSERT INTO public.who_global_data VALUES (85444, 0, 0, 0, 0, 361, 119);
INSERT INTO public.who_global_data VALUES (85445, 0, 0, 0, 0, 361, 168);
INSERT INTO public.who_global_data VALUES (85446, 0, 22, 0, 0, 361, 99);
INSERT INTO public.who_global_data VALUES (85447, 0, 0, 0, 0, 361, 171);
INSERT INTO public.who_global_data VALUES (85448, 0, 0, 0, 0, 361, 87);
INSERT INTO public.who_global_data VALUES (85449, 0, 0, 0, 0, 361, 123);
INSERT INTO public.who_global_data VALUES (85450, 0, 0, 0, 0, 361, 151);
INSERT INTO public.who_global_data VALUES (85451, 0, 0, 0, 0, 361, 213);
INSERT INTO public.who_global_data VALUES (85452, 0, 0, 0, 0, 361, 118);
INSERT INTO public.who_global_data VALUES (85453, 0, 0, 0, 0, 361, 134);
INSERT INTO public.who_global_data VALUES (85454, 0, 0, 0, 0, 361, 65);
INSERT INTO public.who_global_data VALUES (85455, 0, 0, 0, 0, 361, 102);
INSERT INTO public.who_global_data VALUES (85456, 0, 0, 0, 0, 361, 223);
INSERT INTO public.who_global_data VALUES (85457, 0, 0, 0, 0, 361, 4);
INSERT INTO public.who_global_data VALUES (85458, 0, 0, 0, 0, 361, 146);
INSERT INTO public.who_global_data VALUES (85459, 0, 0, 0, 0, 361, 31);
INSERT INTO public.who_global_data VALUES (85460, 0, 0, 0, 0, 361, 127);
INSERT INTO public.who_global_data VALUES (85461, 0, 0, 0, 0, 361, 22);
INSERT INTO public.who_global_data VALUES (85462, 0, 0, 0, 0, 361, 115);
INSERT INTO public.who_global_data VALUES (85463, 0, 0, 0, 0, 361, 106);
INSERT INTO public.who_global_data VALUES (85464, 0, 0, 0, 0, 361, 90);
INSERT INTO public.who_global_data VALUES (85465, 0, 0, 0, 0, 361, 70);
INSERT INTO public.who_global_data VALUES (85466, 0, 5, 0, 0, 361, 46);
INSERT INTO public.who_global_data VALUES (85467, 0, 0, 0, 0, 361, 139);
INSERT INTO public.who_global_data VALUES (85468, 0, 0, 0, 0, 361, 42);
INSERT INTO public.who_global_data VALUES (85469, 0, 0, 0, 0, 361, 80);
INSERT INTO public.who_global_data VALUES (85470, 0, 0, 0, 0, 361, 203);
INSERT INTO public.who_global_data VALUES (85471, 0, 0, 0, 0, 361, 136);
INSERT INTO public.who_global_data VALUES (85472, 0, 0, 0, 0, 361, 63);
INSERT INTO public.who_global_data VALUES (85473, 0, 0, 0, 0, 361, 17);
INSERT INTO public.who_global_data VALUES (85474, 0, 0, 0, 0, 361, 172);
INSERT INTO public.who_global_data VALUES (85475, 0, 0, 0, 0, 361, 109);
INSERT INTO public.who_global_data VALUES (85476, 0, 0, 0, 0, 361, 200);
INSERT INTO public.who_global_data VALUES (85477, 0, 0, 0, 0, 361, 93);
INSERT INTO public.who_global_data VALUES (85478, 0, 0, 0, 0, 361, 5);
INSERT INTO public.who_global_data VALUES (85479, 0, 139, 0, 0, 361, 214);
INSERT INTO public.who_global_data VALUES (85480, 0, 0, 0, 0, 361, 204);
INSERT INTO public.who_global_data VALUES (85481, 0, 0, 0, 0, 361, 198);
INSERT INTO public.who_global_data VALUES (85482, 0, 0, 0, 0, 361, 173);
INSERT INTO public.who_global_data VALUES (85483, 0, 0, 0, 0, 361, 229);
INSERT INTO public.who_global_data VALUES (85484, 0, 0, 0, 0, 361, 76);
INSERT INTO public.who_global_data VALUES (85485, 0, 0, 0, 0, 361, 138);
INSERT INTO public.who_global_data VALUES (85486, 0, 7, 0, 1, 361, 98);
INSERT INTO public.who_global_data VALUES (85487, 0, 0, 0, 0, 361, 103);
INSERT INTO public.who_global_data VALUES (85488, 0, 0, 0, 0, 361, 225);
INSERT INTO public.who_global_data VALUES (85489, 0, 0, 0, 0, 361, 131);
INSERT INTO public.who_global_data VALUES (85490, 0, 0, 0, 0, 361, 235);
INSERT INTO public.who_global_data VALUES (85491, 0, 0, 0, 0, 361, 137);
INSERT INTO public.who_global_data VALUES (85492, 1, 32, 0, 0, 361, 81);
INSERT INTO public.who_global_data VALUES (85493, 0, 0, 0, 0, 361, 182);
INSERT INTO public.who_global_data VALUES (85494, 0, 0, 0, 0, 361, 145);
INSERT INTO public.who_global_data VALUES (85495, 0, 0, 0, 0, 361, 26);
INSERT INTO public.who_global_data VALUES (85496, 0, 2, 0, 0, 361, 170);
INSERT INTO public.who_global_data VALUES (85497, 0, 0, 0, 0, 361, 191);
INSERT INTO public.who_global_data VALUES (85498, 0, 0, 0, 0, 361, 221);
INSERT INTO public.who_global_data VALUES (85499, 0, 0, 0, 0, 361, 64);
INSERT INTO public.who_global_data VALUES (85500, 0, 0, 0, 0, 361, 116);
INSERT INTO public.who_global_data VALUES (85501, 0, 0, 0, 0, 361, 128);
INSERT INTO public.who_global_data VALUES (85502, 0, 0, 0, 0, 361, 6);
INSERT INTO public.who_global_data VALUES (85503, 0, 0, 0, 0, 361, 227);
INSERT INTO public.who_global_data VALUES (85504, 0, 0, 0, 0, 361, 68);
INSERT INTO public.who_global_data VALUES (85505, 0, 0, 0, 0, 361, 184);
INSERT INTO public.who_global_data VALUES (85506, 0, 0, 0, 0, 361, 82);
INSERT INTO public.who_global_data VALUES (85507, 0, 0, 0, 0, 361, 149);
INSERT INTO public.who_global_data VALUES (85508, 0, 0, 0, 0, 361, 197);
INSERT INTO public.who_global_data VALUES (85509, 0, 0, 0, 0, 361, 78);
INSERT INTO public.who_global_data VALUES (85510, 0, 0, 0, 0, 361, 233);
INSERT INTO public.who_global_data VALUES (85511, 0, 0, 0, 0, 361, 133);
INSERT INTO public.who_global_data VALUES (85512, 0, 0, 0, 0, 361, 35);
INSERT INTO public.who_global_data VALUES (85513, 0, 0, 0, 0, 361, 114);
INSERT INTO public.who_global_data VALUES (85514, 2, 51, 0, 0, 361, 237);
INSERT INTO public.who_global_data VALUES (85515, 0, 0, 0, 0, 361, 55);
INSERT INTO public.who_global_data VALUES (85516, 0, 0, 0, 0, 361, 176);
INSERT INTO public.who_global_data VALUES (85517, 0, 0, 0, 0, 361, 202);
INSERT INTO public.who_global_data VALUES (85518, 0, 0, 0, 0, 361, 155);
INSERT INTO public.who_global_data VALUES (85519, 0, 0, 0, 0, 361, 32);
INSERT INTO public.who_global_data VALUES (85520, 0, 0, 0, 0, 361, 220);
INSERT INTO public.who_global_data VALUES (85521, 0, 0, 0, 0, 361, 30);
INSERT INTO public.who_global_data VALUES (85522, 0, 0, 0, 0, 361, 147);
INSERT INTO public.who_global_data VALUES (85523, 1, 24, 0, 0, 361, 208);
INSERT INTO public.who_global_data VALUES (85524, 0, 5, 0, 0, 361, 45);
INSERT INTO public.who_global_data VALUES (85525, 0, 0, 0, 0, 361, 110);
INSERT INTO public.who_global_data VALUES (85526, 0, 0, 0, 0, 361, 88);
INSERT INTO public.who_global_data VALUES (85527, 0, 1, 0, 0, 361, 51);
INSERT INTO public.who_global_data VALUES (85528, 0, 0, 0, 0, 361, 209);
INSERT INTO public.who_global_data VALUES (85529, 0, 0, 0, 0, 361, 205);
INSERT INTO public.who_global_data VALUES (85530, 0, 0, 0, 0, 361, 18);
INSERT INTO public.who_global_data VALUES (85531, 1, 37, 0, 0, 361, 72);
INSERT INTO public.who_global_data VALUES (85532, 1, 9, 0, 0, 361, 44);
INSERT INTO public.who_global_data VALUES (85533, 0, 0, 0, 0, 361, 15);
INSERT INTO public.who_global_data VALUES (85534, 0, 0, 0, 0, 361, 25);
INSERT INTO public.who_global_data VALUES (85535, 0, 0, 0, 0, 361, 179);
INSERT INTO public.who_global_data VALUES (85536, 0, 0, 0, 0, 361, 34);
INSERT INTO public.who_global_data VALUES (85537, 0, 0, 0, 0, 361, 207);
INSERT INTO public.who_global_data VALUES (85538, 0, 0, 0, 0, 361, 166);
INSERT INTO public.who_global_data VALUES (85539, 0, 0, 0, 0, 361, 126);
INSERT INTO public.who_global_data VALUES (85540, 0, 0, 0, 0, 361, 97);
INSERT INTO public.who_global_data VALUES (85541, 0, 0, 0, 0, 361, 36);
INSERT INTO public.who_global_data VALUES (85542, 0, 0, 0, 0, 361, 125);
INSERT INTO public.who_global_data VALUES (85543, 0, 0, 0, 0, 361, 124);
INSERT INTO public.who_global_data VALUES (85544, 0, 0, 0, 0, 361, 185);
INSERT INTO public.who_global_data VALUES (85545, 0, 12, 0, 0, 361, 194);
INSERT INTO public.who_global_data VALUES (85546, 0, 0, 0, 0, 361, 144);
INSERT INTO public.who_global_data VALUES (85547, 1, 17, 0, 0, 361, 19);
INSERT INTO public.who_global_data VALUES (85548, 0, 0, 0, 0, 361, 217);
INSERT INTO public.who_global_data VALUES (85549, 0, 0, 0, 0, 361, 148);
INSERT INTO public.who_global_data VALUES (85550, 0, 0, 0, 0, 361, 86);
INSERT INTO public.who_global_data VALUES (85551, 0, 0, 0, 0, 361, 13);
INSERT INTO public.who_global_data VALUES (85552, 0, 0, 0, 0, 361, 157);
INSERT INTO public.who_global_data VALUES (85553, 1, 19, 0, 0, 361, 8);
INSERT INTO public.who_global_data VALUES (85554, 0, 0, 0, 0, 361, 73);
INSERT INTO public.who_global_data VALUES (85555, 0, 0, 0, 0, 361, 101);
INSERT INTO public.who_global_data VALUES (85556, 0, 0, 0, 0, 361, 165);
INSERT INTO public.who_global_data VALUES (85557, 0, 0, 0, 0, 361, 14);
INSERT INTO public.who_global_data VALUES (85558, 0, 0, 0, 0, 362, 193);
INSERT INTO public.who_global_data VALUES (85559, 0, 0, 0, 0, 362, 113);
INSERT INTO public.who_global_data VALUES (85560, 0, 0, 0, 0, 362, 143);
INSERT INTO public.who_global_data VALUES (85561, 0, 0, 0, 0, 362, 219);
INSERT INTO public.who_global_data VALUES (85562, 0, 0, 0, 0, 362, 186);
INSERT INTO public.who_global_data VALUES (85563, 0, 0, 0, 0, 362, 52);
INSERT INTO public.who_global_data VALUES (85564, 0, 0, 0, 0, 362, 180);
INSERT INTO public.who_global_data VALUES (85565, 0, 0, 0, 0, 362, 167);
INSERT INTO public.who_global_data VALUES (85566, 0, 0, 0, 0, 362, 154);
INSERT INTO public.who_global_data VALUES (85567, 0, 0, 0, 0, 362, 94);
INSERT INTO public.who_global_data VALUES (85568, 0, 0, 0, 0, 362, 66);
INSERT INTO public.who_global_data VALUES (85569, 0, 19, 0, 0, 362, 58);
INSERT INTO public.who_global_data VALUES (85570, 0, 0, 0, 0, 362, 163);
INSERT INTO public.who_global_data VALUES (85571, 0, 0, 0, 0, 362, 37);
INSERT INTO public.who_global_data VALUES (85572, 0, 0, 0, 0, 362, 142);
INSERT INTO public.who_global_data VALUES (85573, 0, 0, 0, 0, 362, 83);
INSERT INTO public.who_global_data VALUES (85574, 0, 0, 0, 0, 362, 228);
INSERT INTO public.who_global_data VALUES (85575, 0, 0, 0, 0, 362, 188);
INSERT INTO public.who_global_data VALUES (85576, 0, 0, 0, 0, 362, 62);
INSERT INTO public.who_global_data VALUES (85577, 0, 1, 0, 0, 362, 160);
INSERT INTO public.who_global_data VALUES (85578, 0, 0, 0, 0, 362, 50);
INSERT INTO public.who_global_data VALUES (85579, 0, 0, 0, 0, 362, 33);
INSERT INTO public.who_global_data VALUES (85580, 0, 0, 0, 0, 362, 183);
INSERT INTO public.who_global_data VALUES (85581, 0, 0, 0, 0, 362, 92);
INSERT INTO public.who_global_data VALUES (85582, 0, 0, 0, 0, 362, 158);
INSERT INTO public.who_global_data VALUES (85583, 0, 0, 0, 0, 362, 67);
INSERT INTO public.who_global_data VALUES (85584, 0, 0, 0, 0, 362, 57);
INSERT INTO public.who_global_data VALUES (85585, 0, 0, 0, 0, 362, 38);
INSERT INTO public.who_global_data VALUES (85586, 0, 0, 0, 0, 362, 141);
INSERT INTO public.who_global_data VALUES (85587, 0, 0, 0, 0, 362, 178);
INSERT INTO public.who_global_data VALUES (85588, 0, 0, 0, 0, 362, 108);
INSERT INTO public.who_global_data VALUES (85589, 0, 0, 0, 0, 362, 39);
INSERT INTO public.who_global_data VALUES (85590, 0, 0, 0, 0, 362, 2);
INSERT INTO public.who_global_data VALUES (85591, 0, 0, 0, 0, 362, 195);
INSERT INTO public.who_global_data VALUES (85592, 0, 0, 0, 0, 362, 107);
INSERT INTO public.who_global_data VALUES (85593, 0, 5, 0, 0, 362, 161);
INSERT INTO public.who_global_data VALUES (85594, 0, 0, 0, 0, 362, 212);
INSERT INTO public.who_global_data VALUES (85595, 0, 11, 0, 0, 362, 181);
INSERT INTO public.who_global_data VALUES (85596, 0, 0, 0, 0, 362, 53);
INSERT INTO public.who_global_data VALUES (85597, 0, 0, 0, 0, 362, 164);
INSERT INTO public.who_global_data VALUES (85598, 0, 0, 0, 0, 362, 140);
INSERT INTO public.who_global_data VALUES (85599, 0, 0, 0, 0, 362, 20);
INSERT INTO public.who_global_data VALUES (85600, 2985, 40240, 97, 909, 362, 112);
INSERT INTO public.who_global_data VALUES (85601, 0, 0, 0, 0, 362, 111);
INSERT INTO public.who_global_data VALUES (85602, 0, 0, 0, 0, 362, 71);
INSERT INTO public.who_global_data VALUES (85603, 0, 0, 0, 0, 362, 218);
INSERT INTO public.who_global_data VALUES (85604, 0, 0, 0, 0, 362, 43);
INSERT INTO public.who_global_data VALUES (85605, 0, 0, 0, 0, 362, 49);
INSERT INTO public.who_global_data VALUES (85606, 0, 0, 0, 0, 362, 1);
INSERT INTO public.who_global_data VALUES (85607, 0, 0, 0, 0, 362, 48);
INSERT INTO public.who_global_data VALUES (85608, 0, 0, 0, 0, 362, 232);
INSERT INTO public.who_global_data VALUES (85609, 0, 0, 0, 0, 362, 175);
INSERT INTO public.who_global_data VALUES (85610, 0, 0, 0, 0, 362, 21);
INSERT INTO public.who_global_data VALUES (85611, 0, 0, 0, 0, 362, 156);
INSERT INTO public.who_global_data VALUES (85612, 0, 0, 0, 0, 362, 95);
INSERT INTO public.who_global_data VALUES (85613, 0, 0, 0, 0, 362, 177);
INSERT INTO public.who_global_data VALUES (85614, 0, 0, 0, 0, 362, 210);
INSERT INTO public.who_global_data VALUES (85615, 0, 0, 0, 0, 362, 120);
INSERT INTO public.who_global_data VALUES (85616, 0, 0, 0, 0, 362, 135);
INSERT INTO public.who_global_data VALUES (85617, 0, 0, 0, 0, 362, 206);
INSERT INTO public.who_global_data VALUES (85618, 0, 0, 0, 0, 362, 189);
INSERT INTO public.who_global_data VALUES (85619, 0, 0, 0, 0, 362, 129);
INSERT INTO public.who_global_data VALUES (85620, 0, 0, 0, 0, 362, 121);
INSERT INTO public.who_global_data VALUES (85621, 0, 0, 0, 0, 362, 59);
INSERT INTO public.who_global_data VALUES (85622, 0, 0, 0, 0, 362, 96);
INSERT INTO public.who_global_data VALUES (85623, 0, 0, 0, 0, 362, 41);
INSERT INTO public.who_global_data VALUES (85624, 0, 0, 0, 0, 362, 216);
INSERT INTO public.who_global_data VALUES (85625, 0, 0, 0, 0, 362, 236);
INSERT INTO public.who_global_data VALUES (85626, 0, 0, 0, 0, 362, 150);
INSERT INTO public.who_global_data VALUES (85627, 0, 0, 0, 0, 362, 61);
INSERT INTO public.who_global_data VALUES (85628, 0, 0, 0, 0, 362, 7);
INSERT INTO public.who_global_data VALUES (85629, 0, 1, 0, 0, 362, 169);
INSERT INTO public.who_global_data VALUES (85630, 0, 11, 0, 0, 362, 28);
INSERT INTO public.who_global_data VALUES (85631, 0, 0, 0, 0, 362, 85);
INSERT INTO public.who_global_data VALUES (85632, 0, 0, 0, 0, 362, 211);
INSERT INTO public.who_global_data VALUES (85633, 0, 0, 0, 0, 362, 60);
INSERT INTO public.who_global_data VALUES (85634, 0, 0, 0, 0, 362, 3);
INSERT INTO public.who_global_data VALUES (85635, 0, 0, 0, 0, 362, 11);
INSERT INTO public.who_global_data VALUES (85636, 0, 13, 0, 0, 362, 89);
INSERT INTO public.who_global_data VALUES (85637, 0, 0, 0, 0, 362, 24);
INSERT INTO public.who_global_data VALUES (85638, 0, 0, 0, 0, 362, 162);
INSERT INTO public.who_global_data VALUES (85639, 0, 0, 0, 0, 362, 100);
INSERT INTO public.who_global_data VALUES (85640, 0, 0, 0, 0, 362, 47);
INSERT INTO public.who_global_data VALUES (85641, 0, 0, 0, 0, 362, 29);
INSERT INTO public.who_global_data VALUES (85642, 0, 0, 0, 0, 362, 40);
INSERT INTO public.who_global_data VALUES (85643, 0, 0, 0, 0, 362, 222);
INSERT INTO public.who_global_data VALUES (85644, 0, 0, 0, 0, 362, 132);
INSERT INTO public.who_global_data VALUES (85645, 0, 0, 0, 0, 362, 130);
INSERT INTO public.who_global_data VALUES (85646, 0, 0, 0, 0, 362, 234);
INSERT INTO public.who_global_data VALUES (85647, 0, 0, 0, 0, 362, 23);
INSERT INTO public.who_global_data VALUES (85648, 0, 0, 0, 0, 362, 192);
INSERT INTO public.who_global_data VALUES (85649, 0, 0, 0, 0, 362, 69);
INSERT INTO public.who_global_data VALUES (85650, 0, 0, 0, 0, 362, 187);
INSERT INTO public.who_global_data VALUES (85651, 0, 0, 0, 0, 362, 230);
INSERT INTO public.who_global_data VALUES (85652, 0, 0, 0, 0, 362, 77);
INSERT INTO public.who_global_data VALUES (85653, 0, 0, 0, 0, 362, 9);
INSERT INTO public.who_global_data VALUES (85654, 0, 7, 0, 0, 362, 74);
INSERT INTO public.who_global_data VALUES (85655, 0, 0, 0, 0, 362, 224);
INSERT INTO public.who_global_data VALUES (85656, 0, 0, 0, 0, 362, 199);
INSERT INTO public.who_global_data VALUES (85657, 0, 0, 0, 0, 362, 190);
INSERT INTO public.who_global_data VALUES (85658, 0, 0, 0, 0, 362, 12);
INSERT INTO public.who_global_data VALUES (85659, 0, 0, 0, 0, 362, 104);
INSERT INTO public.who_global_data VALUES (85660, 0, 0, 0, 0, 362, 153);
INSERT INTO public.who_global_data VALUES (85661, 0, 3, 0, 0, 362, 91);
INSERT INTO public.who_global_data VALUES (85662, 0, 0, 0, 0, 362, 215);
INSERT INTO public.who_global_data VALUES (85663, 0, 30, 0, 0, 362, 84);
INSERT INTO public.who_global_data VALUES (85664, 0, 0, 0, 0, 362, 231);
INSERT INTO public.who_global_data VALUES (85665, 0, 0, 0, 0, 362, 196);
INSERT INTO public.who_global_data VALUES (85666, 0, 0, 0, 0, 362, 105);
INSERT INTO public.who_global_data VALUES (85667, 0, 0, 0, 0, 362, 122);
INSERT INTO public.who_global_data VALUES (85668, 0, 0, 0, 0, 362, 159);
INSERT INTO public.who_global_data VALUES (85669, 0, 0, 0, 0, 362, 75);
INSERT INTO public.who_global_data VALUES (85670, 0, 0, 0, 0, 362, 27);
INSERT INTO public.who_global_data VALUES (85671, 0, 0, 0, 0, 362, 54);
INSERT INTO public.who_global_data VALUES (85672, 0, 0, 0, 0, 362, 226);
INSERT INTO public.who_global_data VALUES (85673, 0, 0, 0, 0, 362, 79);
INSERT INTO public.who_global_data VALUES (85674, 0, 0, 0, 0, 362, 56);
INSERT INTO public.who_global_data VALUES (85675, 0, 0, 0, 0, 362, 117);
INSERT INTO public.who_global_data VALUES (85676, 0, 0, 0, 0, 362, 152);
INSERT INTO public.who_global_data VALUES (85677, 0, 0, 0, 0, 362, 16);
INSERT INTO public.who_global_data VALUES (85678, 0, 0, 0, 0, 362, 10);
INSERT INTO public.who_global_data VALUES (85679, 0, 0, 0, 0, 362, 201);
INSERT INTO public.who_global_data VALUES (85680, 0, 0, 0, 0, 362, 174);
INSERT INTO public.who_global_data VALUES (85681, 0, 0, 0, 0, 362, 119);
INSERT INTO public.who_global_data VALUES (85682, 0, 0, 0, 0, 362, 168);
INSERT INTO public.who_global_data VALUES (85683, 1, 22, 0, 0, 362, 99);
INSERT INTO public.who_global_data VALUES (85684, 0, 0, 0, 0, 362, 171);
INSERT INTO public.who_global_data VALUES (85685, 0, 0, 0, 0, 362, 87);
INSERT INTO public.who_global_data VALUES (85686, 0, 0, 0, 0, 362, 123);
INSERT INTO public.who_global_data VALUES (85687, 0, 0, 0, 0, 362, 151);
INSERT INTO public.who_global_data VALUES (85688, 0, 0, 0, 0, 362, 213);
INSERT INTO public.who_global_data VALUES (85689, 0, 0, 0, 0, 362, 118);
INSERT INTO public.who_global_data VALUES (85690, 0, 0, 0, 0, 362, 134);
INSERT INTO public.who_global_data VALUES (85691, 0, 0, 0, 0, 362, 65);
INSERT INTO public.who_global_data VALUES (85692, 0, 0, 0, 0, 362, 102);
INSERT INTO public.who_global_data VALUES (85693, 0, 0, 0, 0, 362, 223);
INSERT INTO public.who_global_data VALUES (85694, 0, 0, 0, 0, 362, 4);
INSERT INTO public.who_global_data VALUES (85695, 0, 0, 0, 0, 362, 146);
INSERT INTO public.who_global_data VALUES (85696, 0, 0, 0, 0, 362, 31);
INSERT INTO public.who_global_data VALUES (85697, 0, 0, 0, 0, 362, 127);
INSERT INTO public.who_global_data VALUES (85698, 0, 0, 0, 0, 362, 22);
INSERT INTO public.who_global_data VALUES (85699, 0, 0, 0, 0, 362, 115);
INSERT INTO public.who_global_data VALUES (85700, 0, 0, 0, 0, 362, 106);
INSERT INTO public.who_global_data VALUES (85701, 0, 0, 0, 0, 362, 90);
INSERT INTO public.who_global_data VALUES (85702, 0, 0, 0, 0, 362, 70);
INSERT INTO public.who_global_data VALUES (85703, 0, 5, 0, 0, 362, 46);
INSERT INTO public.who_global_data VALUES (85704, 0, 0, 0, 0, 362, 139);
INSERT INTO public.who_global_data VALUES (85705, 0, 0, 0, 0, 362, 42);
INSERT INTO public.who_global_data VALUES (85706, 0, 0, 0, 0, 362, 80);
INSERT INTO public.who_global_data VALUES (85707, 0, 0, 0, 0, 362, 203);
INSERT INTO public.who_global_data VALUES (85708, 0, 0, 0, 0, 362, 136);
INSERT INTO public.who_global_data VALUES (85709, 0, 0, 0, 0, 362, 63);
INSERT INTO public.who_global_data VALUES (85710, 0, 0, 0, 0, 362, 17);
INSERT INTO public.who_global_data VALUES (85711, 0, 0, 0, 0, 362, 172);
INSERT INTO public.who_global_data VALUES (85712, 0, 0, 0, 0, 362, 109);
INSERT INTO public.who_global_data VALUES (85713, 0, 0, 0, 0, 362, 200);
INSERT INTO public.who_global_data VALUES (85714, 0, 0, 0, 0, 362, 93);
INSERT INTO public.who_global_data VALUES (85715, 0, 0, 0, 0, 362, 5);
INSERT INTO public.who_global_data VALUES (85716, 65, 139, 0, 0, 362, 214);
INSERT INTO public.who_global_data VALUES (85717, 0, 0, 0, 0, 362, 204);
INSERT INTO public.who_global_data VALUES (85718, 0, 0, 0, 0, 362, 198);
INSERT INTO public.who_global_data VALUES (85719, 0, 0, 0, 0, 362, 173);
INSERT INTO public.who_global_data VALUES (85720, 0, 0, 0, 0, 362, 229);
INSERT INTO public.who_global_data VALUES (85721, 0, 0, 0, 0, 362, 76);
INSERT INTO public.who_global_data VALUES (85722, 0, 0, 0, 0, 362, 138);
INSERT INTO public.who_global_data VALUES (85723, 0, 7, 0, 1, 362, 98);
INSERT INTO public.who_global_data VALUES (85724, 0, 0, 0, 0, 362, 103);
INSERT INTO public.who_global_data VALUES (85725, 0, 0, 0, 0, 362, 225);
INSERT INTO public.who_global_data VALUES (85726, 0, 0, 0, 0, 362, 131);
INSERT INTO public.who_global_data VALUES (85727, 0, 0, 0, 0, 362, 235);
INSERT INTO public.who_global_data VALUES (85728, 0, 0, 0, 0, 362, 137);
INSERT INTO public.who_global_data VALUES (85729, 0, 31, 0, 0, 362, 81);
INSERT INTO public.who_global_data VALUES (85730, 0, 0, 0, 0, 362, 182);
INSERT INTO public.who_global_data VALUES (85731, 0, 0, 0, 0, 362, 145);
INSERT INTO public.who_global_data VALUES (85732, 0, 0, 0, 0, 362, 26);
INSERT INTO public.who_global_data VALUES (85733, 0, 2, 0, 0, 362, 170);
INSERT INTO public.who_global_data VALUES (85734, 0, 0, 0, 0, 362, 191);
INSERT INTO public.who_global_data VALUES (85735, 0, 0, 0, 0, 362, 221);
INSERT INTO public.who_global_data VALUES (85736, 0, 0, 0, 0, 362, 64);
INSERT INTO public.who_global_data VALUES (85737, 0, 0, 0, 0, 362, 116);
INSERT INTO public.who_global_data VALUES (85738, 0, 0, 0, 0, 362, 128);
INSERT INTO public.who_global_data VALUES (85739, 0, 0, 0, 0, 362, 6);
INSERT INTO public.who_global_data VALUES (85740, 0, 0, 0, 0, 362, 227);
INSERT INTO public.who_global_data VALUES (85741, 0, 0, 0, 0, 362, 68);
INSERT INTO public.who_global_data VALUES (85742, 0, 0, 0, 0, 362, 184);
INSERT INTO public.who_global_data VALUES (85743, 0, 0, 0, 0, 362, 82);
INSERT INTO public.who_global_data VALUES (85744, 0, 0, 0, 0, 362, 149);
INSERT INTO public.who_global_data VALUES (85745, 0, 0, 0, 0, 362, 197);
INSERT INTO public.who_global_data VALUES (85746, 0, 0, 0, 0, 362, 78);
INSERT INTO public.who_global_data VALUES (85747, 0, 0, 0, 0, 362, 233);
INSERT INTO public.who_global_data VALUES (85748, 0, 0, 0, 0, 362, 133);
INSERT INTO public.who_global_data VALUES (85749, 0, 0, 0, 0, 362, 35);
INSERT INTO public.who_global_data VALUES (85750, 0, 0, 0, 0, 362, 114);
INSERT INTO public.who_global_data VALUES (85751, 2, 49, 0, 0, 362, 237);
INSERT INTO public.who_global_data VALUES (85752, 0, 0, 0, 0, 362, 55);
INSERT INTO public.who_global_data VALUES (85753, 0, 0, 0, 0, 362, 176);
INSERT INTO public.who_global_data VALUES (85754, 0, 0, 0, 0, 362, 202);
INSERT INTO public.who_global_data VALUES (85755, 0, 0, 0, 0, 362, 155);
INSERT INTO public.who_global_data VALUES (85756, 0, 0, 0, 0, 362, 32);
INSERT INTO public.who_global_data VALUES (85757, 0, 0, 0, 0, 362, 220);
INSERT INTO public.who_global_data VALUES (85758, 0, 0, 0, 0, 362, 30);
INSERT INTO public.who_global_data VALUES (85759, 0, 0, 0, 0, 362, 147);
INSERT INTO public.who_global_data VALUES (85760, 0, 23, 0, 0, 362, 208);
INSERT INTO public.who_global_data VALUES (85761, 0, 5, 0, 0, 362, 45);
INSERT INTO public.who_global_data VALUES (85762, 0, 0, 0, 0, 362, 110);
INSERT INTO public.who_global_data VALUES (85763, 0, 0, 0, 0, 362, 88);
INSERT INTO public.who_global_data VALUES (85764, 0, 1, 0, 0, 362, 51);
INSERT INTO public.who_global_data VALUES (85765, 0, 0, 0, 0, 362, 209);
INSERT INTO public.who_global_data VALUES (85766, 0, 0, 0, 0, 362, 205);
INSERT INTO public.who_global_data VALUES (85767, 0, 0, 0, 0, 362, 18);
INSERT INTO public.who_global_data VALUES (85768, 0, 36, 0, 0, 362, 72);
INSERT INTO public.who_global_data VALUES (85769, 4, 8, 0, 0, 362, 44);
INSERT INTO public.who_global_data VALUES (85770, 0, 0, 0, 0, 362, 15);
INSERT INTO public.who_global_data VALUES (85771, 0, 0, 0, 0, 362, 25);
INSERT INTO public.who_global_data VALUES (85772, 0, 0, 0, 0, 362, 179);
INSERT INTO public.who_global_data VALUES (85773, 0, 0, 0, 0, 362, 34);
INSERT INTO public.who_global_data VALUES (85774, 0, 0, 0, 0, 362, 207);
INSERT INTO public.who_global_data VALUES (85775, 0, 0, 0, 0, 362, 166);
INSERT INTO public.who_global_data VALUES (85776, 0, 0, 0, 0, 362, 126);
INSERT INTO public.who_global_data VALUES (85777, 0, 0, 0, 0, 362, 97);
INSERT INTO public.who_global_data VALUES (85778, 0, 0, 0, 0, 362, 36);
INSERT INTO public.who_global_data VALUES (85779, 0, 0, 0, 0, 362, 125);
INSERT INTO public.who_global_data VALUES (85780, 0, 0, 0, 0, 362, 124);
INSERT INTO public.who_global_data VALUES (85781, 0, 0, 0, 0, 362, 185);
INSERT INTO public.who_global_data VALUES (85782, 1, 12, 0, 0, 362, 194);
INSERT INTO public.who_global_data VALUES (85783, 0, 0, 0, 0, 362, 144);
INSERT INTO public.who_global_data VALUES (85784, 0, 16, 0, 0, 362, 19);
INSERT INTO public.who_global_data VALUES (85785, 0, 0, 0, 0, 362, 217);
INSERT INTO public.who_global_data VALUES (85786, 0, 0, 0, 0, 362, 148);
INSERT INTO public.who_global_data VALUES (85787, 0, 0, 0, 0, 362, 86);
INSERT INTO public.who_global_data VALUES (85788, 0, 0, 0, 0, 362, 13);
INSERT INTO public.who_global_data VALUES (85789, 0, 0, 0, 0, 362, 157);
INSERT INTO public.who_global_data VALUES (85790, 0, 18, 0, 0, 362, 8);
INSERT INTO public.who_global_data VALUES (85791, 0, 0, 0, 0, 362, 73);
INSERT INTO public.who_global_data VALUES (85792, 0, 0, 0, 0, 362, 101);
INSERT INTO public.who_global_data VALUES (85793, 0, 0, 0, 0, 362, 165);
INSERT INTO public.who_global_data VALUES (85794, 0, 0, 0, 0, 362, 14);
INSERT INTO public.who_global_data VALUES (85795, 0, 0, 0, 0, 363, 193);
INSERT INTO public.who_global_data VALUES (85796, 0, 0, 0, 0, 363, 113);
INSERT INTO public.who_global_data VALUES (85797, 0, 0, 0, 0, 363, 143);
INSERT INTO public.who_global_data VALUES (85798, 0, 0, 0, 0, 363, 219);
INSERT INTO public.who_global_data VALUES (85799, 0, 0, 0, 0, 363, 186);
INSERT INTO public.who_global_data VALUES (85800, 0, 0, 0, 0, 363, 52);
INSERT INTO public.who_global_data VALUES (85801, 0, 0, 0, 0, 363, 180);
INSERT INTO public.who_global_data VALUES (85802, 0, 0, 0, 0, 363, 167);
INSERT INTO public.who_global_data VALUES (85803, 0, 0, 0, 0, 363, 154);
INSERT INTO public.who_global_data VALUES (85804, 0, 0, 0, 0, 363, 94);
INSERT INTO public.who_global_data VALUES (85805, 0, 0, 0, 0, 363, 66);
INSERT INTO public.who_global_data VALUES (85806, 0, 19, 0, 0, 363, 58);
INSERT INTO public.who_global_data VALUES (85807, 0, 0, 0, 0, 363, 163);
INSERT INTO public.who_global_data VALUES (85808, 0, 0, 0, 0, 363, 37);
INSERT INTO public.who_global_data VALUES (85809, 0, 0, 0, 0, 363, 142);
INSERT INTO public.who_global_data VALUES (85810, 0, 0, 0, 0, 363, 83);
INSERT INTO public.who_global_data VALUES (85811, 0, 0, 0, 0, 363, 228);
INSERT INTO public.who_global_data VALUES (85812, 0, 0, 0, 0, 363, 188);
INSERT INTO public.who_global_data VALUES (85813, 0, 0, 0, 0, 363, 62);
INSERT INTO public.who_global_data VALUES (85814, 0, 1, 0, 0, 363, 160);
INSERT INTO public.who_global_data VALUES (85815, 0, 0, 0, 0, 363, 50);
INSERT INTO public.who_global_data VALUES (85816, 0, 0, 0, 0, 363, 33);
INSERT INTO public.who_global_data VALUES (85817, 0, 0, 0, 0, 363, 183);
INSERT INTO public.who_global_data VALUES (85818, 0, 0, 0, 0, 363, 92);
INSERT INTO public.who_global_data VALUES (85819, 0, 0, 0, 0, 363, 158);
INSERT INTO public.who_global_data VALUES (85820, 0, 0, 0, 0, 363, 67);
INSERT INTO public.who_global_data VALUES (85821, 0, 0, 0, 0, 363, 57);
INSERT INTO public.who_global_data VALUES (85822, 0, 0, 0, 0, 363, 38);
INSERT INTO public.who_global_data VALUES (85823, 0, 0, 0, 0, 363, 141);
INSERT INTO public.who_global_data VALUES (85824, 0, 0, 0, 0, 363, 178);
INSERT INTO public.who_global_data VALUES (85825, 0, 0, 0, 0, 363, 108);
INSERT INTO public.who_global_data VALUES (85826, 0, 0, 0, 0, 363, 39);
INSERT INTO public.who_global_data VALUES (85827, 0, 0, 0, 0, 363, 2);
INSERT INTO public.who_global_data VALUES (85828, 0, 0, 0, 0, 363, 195);
INSERT INTO public.who_global_data VALUES (85829, 0, 0, 0, 0, 363, 107);
INSERT INTO public.who_global_data VALUES (85830, 0, 5, 0, 0, 363, 161);
INSERT INTO public.who_global_data VALUES (85831, 0, 0, 0, 0, 363, 212);
INSERT INTO public.who_global_data VALUES (85832, 0, 11, 0, 0, 363, 181);
INSERT INTO public.who_global_data VALUES (85833, 0, 0, 0, 0, 363, 53);
INSERT INTO public.who_global_data VALUES (85834, 0, 0, 0, 0, 363, 164);
INSERT INTO public.who_global_data VALUES (85835, 0, 0, 0, 0, 363, 140);
INSERT INTO public.who_global_data VALUES (85836, 0, 0, 0, 0, 363, 20);
INSERT INTO public.who_global_data VALUES (85837, 2653, 37255, 89, 812, 363, 112);
INSERT INTO public.who_global_data VALUES (85838, 0, 0, 0, 0, 363, 111);
INSERT INTO public.who_global_data VALUES (85839, 0, 0, 0, 0, 363, 71);
INSERT INTO public.who_global_data VALUES (85840, 0, 0, 0, 0, 363, 218);
INSERT INTO public.who_global_data VALUES (85841, 0, 0, 0, 0, 363, 43);
INSERT INTO public.who_global_data VALUES (85842, 0, 0, 0, 0, 363, 49);
INSERT INTO public.who_global_data VALUES (85843, 0, 0, 0, 0, 363, 1);
INSERT INTO public.who_global_data VALUES (85844, 0, 0, 0, 0, 363, 48);
INSERT INTO public.who_global_data VALUES (85845, 0, 0, 0, 0, 363, 232);
INSERT INTO public.who_global_data VALUES (85846, 0, 0, 0, 0, 363, 175);
INSERT INTO public.who_global_data VALUES (85847, 0, 0, 0, 0, 363, 21);
INSERT INTO public.who_global_data VALUES (85848, 0, 0, 0, 0, 363, 156);
INSERT INTO public.who_global_data VALUES (85849, 0, 0, 0, 0, 363, 95);
INSERT INTO public.who_global_data VALUES (85850, 0, 0, 0, 0, 363, 177);
INSERT INTO public.who_global_data VALUES (85851, 0, 0, 0, 0, 363, 210);
INSERT INTO public.who_global_data VALUES (85852, 0, 0, 0, 0, 363, 120);
INSERT INTO public.who_global_data VALUES (85853, 0, 0, 0, 0, 363, 135);
INSERT INTO public.who_global_data VALUES (85854, 0, 0, 0, 0, 363, 206);
INSERT INTO public.who_global_data VALUES (85855, 0, 0, 0, 0, 363, 189);
INSERT INTO public.who_global_data VALUES (85856, 0, 0, 0, 0, 363, 129);
INSERT INTO public.who_global_data VALUES (85857, 0, 0, 0, 0, 363, 121);
INSERT INTO public.who_global_data VALUES (85858, 0, 0, 0, 0, 363, 59);
INSERT INTO public.who_global_data VALUES (85859, 0, 0, 0, 0, 363, 96);
INSERT INTO public.who_global_data VALUES (85860, 0, 0, 0, 0, 363, 41);
INSERT INTO public.who_global_data VALUES (85861, 0, 0, 0, 0, 363, 216);
INSERT INTO public.who_global_data VALUES (85862, 0, 0, 0, 0, 363, 236);
INSERT INTO public.who_global_data VALUES (85863, 0, 0, 0, 0, 363, 150);
INSERT INTO public.who_global_data VALUES (85864, 0, 0, 0, 0, 363, 61);
INSERT INTO public.who_global_data VALUES (85865, 0, 0, 0, 0, 363, 7);
INSERT INTO public.who_global_data VALUES (85866, 0, 1, 0, 0, 363, 169);
INSERT INTO public.who_global_data VALUES (85867, 0, 11, 0, 0, 363, 28);
INSERT INTO public.who_global_data VALUES (85868, 0, 0, 0, 0, 363, 85);
INSERT INTO public.who_global_data VALUES (85869, 0, 0, 0, 0, 363, 211);
INSERT INTO public.who_global_data VALUES (85870, 0, 0, 0, 0, 363, 60);
INSERT INTO public.who_global_data VALUES (85871, 0, 0, 0, 0, 363, 3);
INSERT INTO public.who_global_data VALUES (85872, 0, 0, 0, 0, 363, 11);
INSERT INTO public.who_global_data VALUES (85873, 0, 13, 0, 0, 363, 89);
INSERT INTO public.who_global_data VALUES (85874, 0, 0, 0, 0, 363, 24);
INSERT INTO public.who_global_data VALUES (85875, 0, 0, 0, 0, 363, 162);
INSERT INTO public.who_global_data VALUES (85876, 0, 0, 0, 0, 363, 100);
INSERT INTO public.who_global_data VALUES (85877, 0, 0, 0, 0, 363, 47);
INSERT INTO public.who_global_data VALUES (85878, 0, 0, 0, 0, 363, 29);
INSERT INTO public.who_global_data VALUES (85879, 0, 0, 0, 0, 363, 40);
INSERT INTO public.who_global_data VALUES (85880, 0, 0, 0, 0, 363, 222);
INSERT INTO public.who_global_data VALUES (85881, 0, 0, 0, 0, 363, 132);
INSERT INTO public.who_global_data VALUES (85882, 0, 0, 0, 0, 363, 130);
INSERT INTO public.who_global_data VALUES (85883, 0, 0, 0, 0, 363, 234);
INSERT INTO public.who_global_data VALUES (85884, 0, 0, 0, 0, 363, 23);
INSERT INTO public.who_global_data VALUES (85885, 0, 0, 0, 0, 363, 192);
INSERT INTO public.who_global_data VALUES (85886, 0, 0, 0, 0, 363, 69);
INSERT INTO public.who_global_data VALUES (85887, 0, 0, 0, 0, 363, 187);
INSERT INTO public.who_global_data VALUES (85888, 0, 0, 0, 0, 363, 230);
INSERT INTO public.who_global_data VALUES (85889, 0, 0, 0, 0, 363, 77);
INSERT INTO public.who_global_data VALUES (85890, 0, 0, 0, 0, 363, 9);
INSERT INTO public.who_global_data VALUES (85891, 0, 7, 0, 0, 363, 74);
INSERT INTO public.who_global_data VALUES (85892, 0, 0, 0, 0, 363, 224);
INSERT INTO public.who_global_data VALUES (85893, 0, 0, 0, 0, 363, 199);
INSERT INTO public.who_global_data VALUES (85894, 0, 0, 0, 0, 363, 190);
INSERT INTO public.who_global_data VALUES (85895, 0, 0, 0, 0, 363, 12);
INSERT INTO public.who_global_data VALUES (85896, 0, 0, 0, 0, 363, 104);
INSERT INTO public.who_global_data VALUES (85897, 0, 0, 0, 0, 363, 153);
INSERT INTO public.who_global_data VALUES (85898, 0, 3, 0, 0, 363, 91);
INSERT INTO public.who_global_data VALUES (85899, 0, 0, 0, 0, 363, 215);
INSERT INTO public.who_global_data VALUES (85900, 1, 30, 0, 0, 363, 84);
INSERT INTO public.who_global_data VALUES (85901, 0, 0, 0, 0, 363, 231);
INSERT INTO public.who_global_data VALUES (85902, 0, 0, 0, 0, 363, 196);
INSERT INTO public.who_global_data VALUES (85903, 0, 0, 0, 0, 363, 105);
INSERT INTO public.who_global_data VALUES (85904, 0, 0, 0, 0, 363, 122);
INSERT INTO public.who_global_data VALUES (85905, 0, 0, 0, 0, 363, 159);
INSERT INTO public.who_global_data VALUES (85906, 0, 0, 0, 0, 363, 75);
INSERT INTO public.who_global_data VALUES (85907, 0, 0, 0, 0, 363, 27);
INSERT INTO public.who_global_data VALUES (85908, 0, 0, 0, 0, 363, 54);
INSERT INTO public.who_global_data VALUES (85909, 0, 0, 0, 0, 363, 226);
INSERT INTO public.who_global_data VALUES (85910, 0, 0, 0, 0, 363, 79);
INSERT INTO public.who_global_data VALUES (85911, 0, 0, 0, 0, 363, 56);
INSERT INTO public.who_global_data VALUES (85912, 0, 0, 0, 0, 363, 117);
INSERT INTO public.who_global_data VALUES (85913, 0, 0, 0, 0, 363, 152);
INSERT INTO public.who_global_data VALUES (85914, 0, 0, 0, 0, 363, 16);
INSERT INTO public.who_global_data VALUES (85915, 0, 0, 0, 0, 363, 10);
INSERT INTO public.who_global_data VALUES (85916, 0, 0, 0, 0, 363, 201);
INSERT INTO public.who_global_data VALUES (85917, 0, 0, 0, 0, 363, 174);
INSERT INTO public.who_global_data VALUES (85918, 0, 0, 0, 0, 363, 119);
INSERT INTO public.who_global_data VALUES (85919, 0, 0, 0, 0, 363, 168);
INSERT INTO public.who_global_data VALUES (85920, 1, 21, 0, 0, 363, 99);
INSERT INTO public.who_global_data VALUES (85921, 0, 0, 0, 0, 363, 171);
INSERT INTO public.who_global_data VALUES (85922, 0, 0, 0, 0, 363, 87);
INSERT INTO public.who_global_data VALUES (85923, 0, 0, 0, 0, 363, 123);
INSERT INTO public.who_global_data VALUES (85924, 0, 0, 0, 0, 363, 151);
INSERT INTO public.who_global_data VALUES (85925, 0, 0, 0, 0, 363, 213);
INSERT INTO public.who_global_data VALUES (85926, 0, 0, 0, 0, 363, 118);
INSERT INTO public.who_global_data VALUES (85927, 0, 0, 0, 0, 363, 134);
INSERT INTO public.who_global_data VALUES (85928, 0, 0, 0, 0, 363, 65);
INSERT INTO public.who_global_data VALUES (85929, 0, 0, 0, 0, 363, 102);
INSERT INTO public.who_global_data VALUES (85930, 0, 0, 0, 0, 363, 223);
INSERT INTO public.who_global_data VALUES (85931, 0, 0, 0, 0, 363, 4);
INSERT INTO public.who_global_data VALUES (85932, 0, 0, 0, 0, 363, 146);
INSERT INTO public.who_global_data VALUES (85933, 0, 0, 0, 0, 363, 31);
INSERT INTO public.who_global_data VALUES (85934, 0, 0, 0, 0, 363, 127);
INSERT INTO public.who_global_data VALUES (85935, 0, 0, 0, 0, 363, 22);
INSERT INTO public.who_global_data VALUES (85936, 0, 0, 0, 0, 363, 115);
INSERT INTO public.who_global_data VALUES (85937, 0, 0, 0, 0, 363, 106);
INSERT INTO public.who_global_data VALUES (85938, 0, 0, 0, 0, 363, 90);
INSERT INTO public.who_global_data VALUES (85939, 0, 0, 0, 0, 363, 70);
INSERT INTO public.who_global_data VALUES (85940, 0, 5, 0, 0, 363, 46);
INSERT INTO public.who_global_data VALUES (85941, 0, 0, 0, 0, 363, 139);
INSERT INTO public.who_global_data VALUES (85942, 0, 0, 0, 0, 363, 42);
INSERT INTO public.who_global_data VALUES (85943, 0, 0, 0, 0, 363, 80);
INSERT INTO public.who_global_data VALUES (85944, 0, 0, 0, 0, 363, 203);
INSERT INTO public.who_global_data VALUES (85945, 0, 0, 0, 0, 363, 136);
INSERT INTO public.who_global_data VALUES (85946, 0, 0, 0, 0, 363, 63);
INSERT INTO public.who_global_data VALUES (85947, 0, 0, 0, 0, 363, 17);
INSERT INTO public.who_global_data VALUES (85948, 0, 0, 0, 0, 363, 172);
INSERT INTO public.who_global_data VALUES (85949, 0, 0, 0, 0, 363, 109);
INSERT INTO public.who_global_data VALUES (85950, 0, 0, 0, 0, 363, 200);
INSERT INTO public.who_global_data VALUES (85951, 0, 0, 0, 0, 363, 93);
INSERT INTO public.who_global_data VALUES (85952, 0, 0, 0, 0, 363, 5);
INSERT INTO public.who_global_data VALUES (85953, 6, 74, 0, 0, 363, 214);
INSERT INTO public.who_global_data VALUES (85954, 0, 0, 0, 0, 363, 204);
INSERT INTO public.who_global_data VALUES (85955, 0, 0, 0, 0, 363, 198);
INSERT INTO public.who_global_data VALUES (85956, 0, 0, 0, 0, 363, 173);
INSERT INTO public.who_global_data VALUES (85957, 0, 0, 0, 0, 363, 229);
INSERT INTO public.who_global_data VALUES (85958, 0, 0, 0, 0, 363, 76);
INSERT INTO public.who_global_data VALUES (85959, 0, 0, 0, 0, 363, 138);
INSERT INTO public.who_global_data VALUES (85960, 0, 7, 0, 1, 363, 98);
INSERT INTO public.who_global_data VALUES (85961, 0, 0, 0, 0, 363, 103);
INSERT INTO public.who_global_data VALUES (85962, 0, 0, 0, 0, 363, 225);
INSERT INTO public.who_global_data VALUES (85963, 0, 0, 0, 0, 363, 131);
INSERT INTO public.who_global_data VALUES (85964, 0, 0, 0, 0, 363, 235);
INSERT INTO public.who_global_data VALUES (85965, 0, 0, 0, 0, 363, 137);
INSERT INTO public.who_global_data VALUES (85966, 3, 31, 0, 0, 363, 81);
INSERT INTO public.who_global_data VALUES (85967, 0, 0, 0, 0, 363, 182);
INSERT INTO public.who_global_data VALUES (85968, 0, 0, 0, 0, 363, 145);
INSERT INTO public.who_global_data VALUES (85969, 0, 0, 0, 0, 363, 26);
INSERT INTO public.who_global_data VALUES (85970, 0, 2, 0, 0, 363, 170);
INSERT INTO public.who_global_data VALUES (85971, 0, 0, 0, 0, 363, 191);
INSERT INTO public.who_global_data VALUES (85972, 0, 0, 0, 0, 363, 221);
INSERT INTO public.who_global_data VALUES (85973, 0, 0, 0, 0, 363, 64);
INSERT INTO public.who_global_data VALUES (85974, 0, 0, 0, 0, 363, 116);
INSERT INTO public.who_global_data VALUES (85975, 0, 0, 0, 0, 363, 128);
INSERT INTO public.who_global_data VALUES (85976, 0, 0, 0, 0, 363, 6);
INSERT INTO public.who_global_data VALUES (85977, 0, 0, 0, 0, 363, 227);
INSERT INTO public.who_global_data VALUES (85978, 0, 0, 0, 0, 363, 68);
INSERT INTO public.who_global_data VALUES (85979, 0, 0, 0, 0, 363, 184);
INSERT INTO public.who_global_data VALUES (85980, 0, 0, 0, 0, 363, 82);
INSERT INTO public.who_global_data VALUES (85981, 0, 0, 0, 0, 363, 149);
INSERT INTO public.who_global_data VALUES (85982, 0, 0, 0, 0, 363, 197);
INSERT INTO public.who_global_data VALUES (85983, 0, 0, 0, 0, 363, 78);
INSERT INTO public.who_global_data VALUES (85984, 0, 0, 0, 0, 363, 233);
INSERT INTO public.who_global_data VALUES (85985, 0, 0, 0, 0, 363, 133);
INSERT INTO public.who_global_data VALUES (85986, 0, 0, 0, 0, 363, 35);
INSERT INTO public.who_global_data VALUES (85987, 0, 0, 0, 0, 363, 114);
INSERT INTO public.who_global_data VALUES (85988, 3, 47, 0, 0, 363, 237);
INSERT INTO public.who_global_data VALUES (85989, 0, 0, 0, 0, 363, 55);
INSERT INTO public.who_global_data VALUES (85990, 0, 0, 0, 0, 363, 176);
INSERT INTO public.who_global_data VALUES (85991, 0, 0, 0, 0, 363, 202);
INSERT INTO public.who_global_data VALUES (85992, 0, 0, 0, 0, 363, 155);
INSERT INTO public.who_global_data VALUES (85993, 0, 0, 0, 0, 363, 32);
INSERT INTO public.who_global_data VALUES (85994, 0, 0, 0, 0, 363, 220);
INSERT INTO public.who_global_data VALUES (85995, 0, 0, 0, 0, 363, 30);
INSERT INTO public.who_global_data VALUES (85996, 0, 0, 0, 0, 363, 147);
INSERT INTO public.who_global_data VALUES (85997, 0, 23, 0, 0, 363, 208);
INSERT INTO public.who_global_data VALUES (85998, 0, 5, 0, 0, 363, 45);
INSERT INTO public.who_global_data VALUES (85999, 0, 0, 0, 0, 363, 110);
INSERT INTO public.who_global_data VALUES (86000, 0, 0, 0, 0, 363, 88);
INSERT INTO public.who_global_data VALUES (86001, 0, 1, 0, 0, 363, 51);
INSERT INTO public.who_global_data VALUES (86002, 0, 0, 0, 0, 363, 209);
INSERT INTO public.who_global_data VALUES (86003, 0, 0, 0, 0, 363, 205);
INSERT INTO public.who_global_data VALUES (86004, 0, 0, 0, 0, 363, 18);
INSERT INTO public.who_global_data VALUES (86005, 0, 36, 0, 0, 363, 72);
INSERT INTO public.who_global_data VALUES (86006, 0, 4, 0, 0, 363, 44);
INSERT INTO public.who_global_data VALUES (86007, 0, 0, 0, 0, 363, 15);
INSERT INTO public.who_global_data VALUES (86008, 0, 0, 0, 0, 363, 25);
INSERT INTO public.who_global_data VALUES (86009, 0, 0, 0, 0, 363, 179);
INSERT INTO public.who_global_data VALUES (86010, 0, 0, 0, 0, 363, 34);
INSERT INTO public.who_global_data VALUES (86011, 0, 0, 0, 0, 363, 207);
INSERT INTO public.who_global_data VALUES (86012, 0, 0, 0, 0, 363, 166);
INSERT INTO public.who_global_data VALUES (86013, 0, 0, 0, 0, 363, 126);
INSERT INTO public.who_global_data VALUES (86014, 0, 0, 0, 0, 363, 97);
INSERT INTO public.who_global_data VALUES (86015, 0, 0, 0, 0, 363, 36);
INSERT INTO public.who_global_data VALUES (86016, 0, 0, 0, 0, 363, 125);
INSERT INTO public.who_global_data VALUES (86017, 0, 0, 0, 0, 363, 124);
INSERT INTO public.who_global_data VALUES (86018, 0, 0, 0, 0, 363, 185);
INSERT INTO public.who_global_data VALUES (86019, 0, 11, 0, 0, 363, 194);
INSERT INTO public.who_global_data VALUES (86020, 0, 0, 0, 0, 363, 144);
INSERT INTO public.who_global_data VALUES (86021, 0, 16, 0, 0, 363, 19);
INSERT INTO public.who_global_data VALUES (86022, 0, 0, 0, 0, 363, 217);
INSERT INTO public.who_global_data VALUES (86023, 0, 0, 0, 0, 363, 148);
INSERT INTO public.who_global_data VALUES (86024, 0, 0, 0, 0, 363, 86);
INSERT INTO public.who_global_data VALUES (86025, 0, 0, 0, 0, 363, 13);
INSERT INTO public.who_global_data VALUES (86026, 0, 0, 0, 0, 363, 157);
INSERT INTO public.who_global_data VALUES (86027, 1, 18, 0, 0, 363, 8);
INSERT INTO public.who_global_data VALUES (86028, 0, 0, 0, 0, 363, 73);
INSERT INTO public.who_global_data VALUES (86029, 0, 0, 0, 0, 363, 101);
INSERT INTO public.who_global_data VALUES (86030, 0, 0, 0, 0, 363, 165);
INSERT INTO public.who_global_data VALUES (86031, 0, 0, 0, 0, 363, 14);
INSERT INTO public.who_global_data VALUES (86032, 0, 0, 0, 0, 364, 193);
INSERT INTO public.who_global_data VALUES (86033, 0, 0, 0, 0, 364, 113);
INSERT INTO public.who_global_data VALUES (86034, 0, 0, 0, 0, 364, 143);
INSERT INTO public.who_global_data VALUES (86035, 0, 0, 0, 0, 364, 219);
INSERT INTO public.who_global_data VALUES (86036, 0, 0, 0, 0, 364, 186);
INSERT INTO public.who_global_data VALUES (86037, 0, 0, 0, 0, 364, 52);
INSERT INTO public.who_global_data VALUES (86038, 0, 0, 0, 0, 364, 180);
INSERT INTO public.who_global_data VALUES (86039, 0, 0, 0, 0, 364, 167);
INSERT INTO public.who_global_data VALUES (86040, 0, 0, 0, 0, 364, 154);
INSERT INTO public.who_global_data VALUES (86041, 0, 0, 0, 0, 364, 94);
INSERT INTO public.who_global_data VALUES (86042, 0, 0, 0, 0, 364, 66);
INSERT INTO public.who_global_data VALUES (86043, 0, 19, 0, 0, 364, 58);
INSERT INTO public.who_global_data VALUES (86044, 0, 0, 0, 0, 364, 163);
INSERT INTO public.who_global_data VALUES (86045, 0, 0, 0, 0, 364, 37);
INSERT INTO public.who_global_data VALUES (86046, 0, 0, 0, 0, 364, 142);
INSERT INTO public.who_global_data VALUES (86047, 0, 0, 0, 0, 364, 83);
INSERT INTO public.who_global_data VALUES (86048, 0, 0, 0, 0, 364, 228);
INSERT INTO public.who_global_data VALUES (86049, 0, 0, 0, 0, 364, 188);
INSERT INTO public.who_global_data VALUES (86050, 0, 0, 0, 0, 364, 62);
INSERT INTO public.who_global_data VALUES (86051, 0, 1, 0, 0, 364, 160);
INSERT INTO public.who_global_data VALUES (86052, 0, 0, 0, 0, 364, 50);
INSERT INTO public.who_global_data VALUES (86053, 0, 0, 0, 0, 364, 33);
INSERT INTO public.who_global_data VALUES (86054, 0, 0, 0, 0, 364, 183);
INSERT INTO public.who_global_data VALUES (86055, 0, 0, 0, 0, 364, 92);
INSERT INTO public.who_global_data VALUES (86056, 0, 0, 0, 0, 364, 158);
INSERT INTO public.who_global_data VALUES (86057, 0, 0, 0, 0, 364, 67);
INSERT INTO public.who_global_data VALUES (86058, 0, 0, 0, 0, 364, 57);
INSERT INTO public.who_global_data VALUES (86059, 0, 0, 0, 0, 364, 38);
INSERT INTO public.who_global_data VALUES (86060, 0, 0, 0, 0, 364, 141);
INSERT INTO public.who_global_data VALUES (86061, 0, 0, 0, 0, 364, 178);
INSERT INTO public.who_global_data VALUES (86062, 0, 0, 0, 0, 364, 108);
INSERT INTO public.who_global_data VALUES (86063, 0, 0, 0, 0, 364, 39);
INSERT INTO public.who_global_data VALUES (86064, 0, 0, 0, 0, 364, 2);
INSERT INTO public.who_global_data VALUES (86065, 0, 0, 0, 0, 364, 195);
INSERT INTO public.who_global_data VALUES (86066, 0, 0, 0, 0, 364, 107);
INSERT INTO public.who_global_data VALUES (86067, 0, 5, 0, 0, 364, 161);
INSERT INTO public.who_global_data VALUES (86068, 0, 0, 0, 0, 364, 212);
INSERT INTO public.who_global_data VALUES (86069, 0, 11, 0, 0, 364, 181);
INSERT INTO public.who_global_data VALUES (86070, 0, 0, 0, 0, 364, 53);
INSERT INTO public.who_global_data VALUES (86071, 0, 0, 0, 0, 364, 164);
INSERT INTO public.who_global_data VALUES (86072, 0, 0, 0, 0, 364, 140);
INSERT INTO public.who_global_data VALUES (86073, 0, 0, 0, 0, 364, 20);
INSERT INTO public.who_global_data VALUES (86074, 3387, 34602, 86, 723, 364, 112);
INSERT INTO public.who_global_data VALUES (86075, 0, 0, 0, 0, 364, 111);
INSERT INTO public.who_global_data VALUES (86076, 0, 0, 0, 0, 364, 71);
INSERT INTO public.who_global_data VALUES (86077, 0, 0, 0, 0, 364, 218);
INSERT INTO public.who_global_data VALUES (86078, 0, 0, 0, 0, 364, 43);
INSERT INTO public.who_global_data VALUES (86079, 0, 0, 0, 0, 364, 49);
INSERT INTO public.who_global_data VALUES (86080, 0, 0, 0, 0, 364, 1);
INSERT INTO public.who_global_data VALUES (86081, 0, 0, 0, 0, 364, 48);
INSERT INTO public.who_global_data VALUES (86082, 0, 0, 0, 0, 364, 232);
INSERT INTO public.who_global_data VALUES (86083, 0, 0, 0, 0, 364, 175);
INSERT INTO public.who_global_data VALUES (86084, 0, 0, 0, 0, 364, 21);
INSERT INTO public.who_global_data VALUES (86085, 0, 0, 0, 0, 364, 156);
INSERT INTO public.who_global_data VALUES (86086, 0, 0, 0, 0, 364, 95);
INSERT INTO public.who_global_data VALUES (86087, 0, 0, 0, 0, 364, 177);
INSERT INTO public.who_global_data VALUES (86088, 0, 0, 0, 0, 364, 210);
INSERT INTO public.who_global_data VALUES (86089, 0, 0, 0, 0, 364, 120);
INSERT INTO public.who_global_data VALUES (86090, 0, 0, 0, 0, 364, 135);
INSERT INTO public.who_global_data VALUES (86091, 0, 0, 0, 0, 364, 206);
INSERT INTO public.who_global_data VALUES (86092, 0, 0, 0, 0, 364, 189);
INSERT INTO public.who_global_data VALUES (86093, 0, 0, 0, 0, 364, 129);
INSERT INTO public.who_global_data VALUES (86094, 0, 0, 0, 0, 364, 121);
INSERT INTO public.who_global_data VALUES (86095, 0, 0, 0, 0, 364, 59);
INSERT INTO public.who_global_data VALUES (86096, 0, 0, 0, 0, 364, 96);
INSERT INTO public.who_global_data VALUES (86097, 0, 0, 0, 0, 364, 41);
INSERT INTO public.who_global_data VALUES (86098, 0, 0, 0, 0, 364, 216);
INSERT INTO public.who_global_data VALUES (86099, 0, 0, 0, 0, 364, 236);
INSERT INTO public.who_global_data VALUES (86100, 0, 0, 0, 0, 364, 150);
INSERT INTO public.who_global_data VALUES (86101, 0, 0, 0, 0, 364, 61);
INSERT INTO public.who_global_data VALUES (86102, 0, 0, 0, 0, 364, 7);
INSERT INTO public.who_global_data VALUES (86103, 0, 1, 0, 0, 364, 169);
INSERT INTO public.who_global_data VALUES (86104, 5, 11, 0, 0, 364, 28);
INSERT INTO public.who_global_data VALUES (86105, 0, 0, 0, 0, 364, 85);
INSERT INTO public.who_global_data VALUES (86106, 0, 0, 0, 0, 364, 211);
INSERT INTO public.who_global_data VALUES (86107, 0, 0, 0, 0, 364, 60);
INSERT INTO public.who_global_data VALUES (86108, 0, 0, 0, 0, 364, 3);
INSERT INTO public.who_global_data VALUES (86109, 0, 0, 0, 0, 364, 11);
INSERT INTO public.who_global_data VALUES (86110, 1, 13, 0, 0, 364, 89);
INSERT INTO public.who_global_data VALUES (86111, 0, 0, 0, 0, 364, 24);
INSERT INTO public.who_global_data VALUES (86112, 0, 0, 0, 0, 364, 162);
INSERT INTO public.who_global_data VALUES (86113, 0, 0, 0, 0, 364, 100);
INSERT INTO public.who_global_data VALUES (86114, 0, 0, 0, 0, 364, 47);
INSERT INTO public.who_global_data VALUES (86115, 0, 0, 0, 0, 364, 29);
INSERT INTO public.who_global_data VALUES (86116, 0, 0, 0, 0, 364, 40);
INSERT INTO public.who_global_data VALUES (86117, 0, 0, 0, 0, 364, 222);
INSERT INTO public.who_global_data VALUES (86118, 0, 0, 0, 0, 364, 132);
INSERT INTO public.who_global_data VALUES (86119, 0, 0, 0, 0, 364, 130);
INSERT INTO public.who_global_data VALUES (86120, 0, 0, 0, 0, 364, 234);
INSERT INTO public.who_global_data VALUES (86121, 0, 0, 0, 0, 364, 23);
INSERT INTO public.who_global_data VALUES (86122, 0, 0, 0, 0, 364, 192);
INSERT INTO public.who_global_data VALUES (86123, 0, 0, 0, 0, 364, 69);
INSERT INTO public.who_global_data VALUES (86124, 0, 0, 0, 0, 364, 187);
INSERT INTO public.who_global_data VALUES (86125, 0, 0, 0, 0, 364, 230);
INSERT INTO public.who_global_data VALUES (86126, 0, 0, 0, 0, 364, 77);
INSERT INTO public.who_global_data VALUES (86127, 0, 0, 0, 0, 364, 9);
INSERT INTO public.who_global_data VALUES (86128, 0, 7, 0, 0, 364, 74);
INSERT INTO public.who_global_data VALUES (86129, 0, 0, 0, 0, 364, 224);
INSERT INTO public.who_global_data VALUES (86130, 0, 0, 0, 0, 364, 199);
INSERT INTO public.who_global_data VALUES (86131, 0, 0, 0, 0, 364, 190);
INSERT INTO public.who_global_data VALUES (86132, 0, 0, 0, 0, 364, 12);
INSERT INTO public.who_global_data VALUES (86133, 0, 0, 0, 0, 364, 104);
INSERT INTO public.who_global_data VALUES (86134, 0, 0, 0, 0, 364, 153);
INSERT INTO public.who_global_data VALUES (86135, 0, 3, 0, 0, 364, 91);
INSERT INTO public.who_global_data VALUES (86136, 0, 0, 0, 0, 364, 215);
INSERT INTO public.who_global_data VALUES (86137, 0, 29, 0, 0, 364, 84);
INSERT INTO public.who_global_data VALUES (86138, 0, 0, 0, 0, 364, 231);
INSERT INTO public.who_global_data VALUES (86139, 0, 0, 0, 0, 364, 196);
INSERT INTO public.who_global_data VALUES (86140, 0, 0, 0, 0, 364, 105);
INSERT INTO public.who_global_data VALUES (86141, 0, 0, 0, 0, 364, 122);
INSERT INTO public.who_global_data VALUES (86142, 0, 0, 0, 0, 364, 159);
INSERT INTO public.who_global_data VALUES (86143, 0, 0, 0, 0, 364, 75);
INSERT INTO public.who_global_data VALUES (86144, 0, 0, 0, 0, 364, 27);
INSERT INTO public.who_global_data VALUES (86145, 0, 0, 0, 0, 364, 54);
INSERT INTO public.who_global_data VALUES (86146, 0, 0, 0, 0, 364, 226);
INSERT INTO public.who_global_data VALUES (86147, 0, 0, 0, 0, 364, 79);
INSERT INTO public.who_global_data VALUES (86148, 0, 0, 0, 0, 364, 56);
INSERT INTO public.who_global_data VALUES (86149, 0, 0, 0, 0, 364, 117);
INSERT INTO public.who_global_data VALUES (86150, 0, 0, 0, 0, 364, 152);
INSERT INTO public.who_global_data VALUES (86151, 0, 0, 0, 0, 364, 16);
INSERT INTO public.who_global_data VALUES (86152, 0, 0, 0, 0, 364, 10);
INSERT INTO public.who_global_data VALUES (86153, 0, 0, 0, 0, 364, 201);
INSERT INTO public.who_global_data VALUES (86154, 0, 0, 0, 0, 364, 174);
INSERT INTO public.who_global_data VALUES (86155, 0, 0, 0, 0, 364, 119);
INSERT INTO public.who_global_data VALUES (86156, 0, 0, 0, 0, 364, 168);
INSERT INTO public.who_global_data VALUES (86157, 1, 20, 0, 0, 364, 99);
INSERT INTO public.who_global_data VALUES (86158, 0, 0, 0, 0, 364, 171);
INSERT INTO public.who_global_data VALUES (86159, 0, 0, 0, 0, 364, 87);
INSERT INTO public.who_global_data VALUES (86160, 0, 0, 0, 0, 364, 123);
INSERT INTO public.who_global_data VALUES (86161, 0, 0, 0, 0, 364, 151);
INSERT INTO public.who_global_data VALUES (86162, 0, 0, 0, 0, 364, 213);
INSERT INTO public.who_global_data VALUES (86163, 0, 0, 0, 0, 364, 118);
INSERT INTO public.who_global_data VALUES (86164, 0, 0, 0, 0, 364, 134);
INSERT INTO public.who_global_data VALUES (86165, 0, 0, 0, 0, 364, 65);
INSERT INTO public.who_global_data VALUES (86166, 0, 0, 0, 0, 364, 102);
INSERT INTO public.who_global_data VALUES (86167, 0, 0, 0, 0, 364, 223);
INSERT INTO public.who_global_data VALUES (86168, 0, 0, 0, 0, 364, 4);
INSERT INTO public.who_global_data VALUES (86169, 0, 0, 0, 0, 364, 146);
INSERT INTO public.who_global_data VALUES (86170, 0, 0, 0, 0, 364, 31);
INSERT INTO public.who_global_data VALUES (86171, 0, 0, 0, 0, 364, 127);
INSERT INTO public.who_global_data VALUES (86172, 0, 0, 0, 0, 364, 22);
INSERT INTO public.who_global_data VALUES (86173, 0, 0, 0, 0, 364, 115);
INSERT INTO public.who_global_data VALUES (86174, 0, 0, 0, 0, 364, 106);
INSERT INTO public.who_global_data VALUES (86175, 0, 0, 0, 0, 364, 90);
INSERT INTO public.who_global_data VALUES (86176, 0, 0, 0, 0, 364, 70);
INSERT INTO public.who_global_data VALUES (86177, 0, 5, 0, 0, 364, 46);
INSERT INTO public.who_global_data VALUES (86178, 0, 0, 0, 0, 364, 139);
INSERT INTO public.who_global_data VALUES (86179, 0, 0, 0, 0, 364, 42);
INSERT INTO public.who_global_data VALUES (86180, 0, 0, 0, 0, 364, 80);
INSERT INTO public.who_global_data VALUES (86181, 0, 0, 0, 0, 364, 203);
INSERT INTO public.who_global_data VALUES (86182, 0, 0, 0, 0, 364, 136);
INSERT INTO public.who_global_data VALUES (86183, 0, 0, 0, 0, 364, 63);
INSERT INTO public.who_global_data VALUES (86184, 0, 0, 0, 0, 364, 17);
INSERT INTO public.who_global_data VALUES (86185, 0, 0, 0, 0, 364, 172);
INSERT INTO public.who_global_data VALUES (86186, 0, 0, 0, 0, 364, 109);
INSERT INTO public.who_global_data VALUES (86187, 0, 0, 0, 0, 364, 200);
INSERT INTO public.who_global_data VALUES (86188, 0, 0, 0, 0, 364, 93);
INSERT INTO public.who_global_data VALUES (86189, 0, 0, 0, 0, 364, 5);
INSERT INTO public.who_global_data VALUES (86190, 3, 68, 0, 0, 364, 214);
INSERT INTO public.who_global_data VALUES (86191, 0, 0, 0, 0, 364, 204);
INSERT INTO public.who_global_data VALUES (86192, 0, 0, 0, 0, 364, 198);
INSERT INTO public.who_global_data VALUES (86193, 0, 0, 0, 0, 364, 173);
INSERT INTO public.who_global_data VALUES (86194, 0, 0, 0, 0, 364, 229);
INSERT INTO public.who_global_data VALUES (86195, 0, 0, 0, 0, 364, 76);
INSERT INTO public.who_global_data VALUES (86196, 0, 0, 0, 0, 364, 138);
INSERT INTO public.who_global_data VALUES (86197, 0, 7, 0, 1, 364, 98);
INSERT INTO public.who_global_data VALUES (86198, 0, 0, 0, 0, 364, 103);
INSERT INTO public.who_global_data VALUES (86199, 0, 0, 0, 0, 364, 225);
INSERT INTO public.who_global_data VALUES (86200, 0, 0, 0, 0, 364, 131);
INSERT INTO public.who_global_data VALUES (86201, 0, 0, 0, 0, 364, 235);
INSERT INTO public.who_global_data VALUES (86202, 0, 0, 0, 0, 364, 137);
INSERT INTO public.who_global_data VALUES (86203, 0, 28, 0, 0, 364, 81);
INSERT INTO public.who_global_data VALUES (86204, 0, 0, 0, 0, 364, 182);
INSERT INTO public.who_global_data VALUES (86205, 0, 0, 0, 0, 364, 145);
INSERT INTO public.who_global_data VALUES (86206, 0, 0, 0, 0, 364, 26);
INSERT INTO public.who_global_data VALUES (86207, 0, 2, 0, 0, 364, 170);
INSERT INTO public.who_global_data VALUES (86208, 0, 0, 0, 0, 364, 191);
INSERT INTO public.who_global_data VALUES (86209, 0, 0, 0, 0, 364, 221);
INSERT INTO public.who_global_data VALUES (86210, 0, 0, 0, 0, 364, 64);
INSERT INTO public.who_global_data VALUES (86211, 0, 0, 0, 0, 364, 116);
INSERT INTO public.who_global_data VALUES (86212, 0, 0, 0, 0, 364, 128);
INSERT INTO public.who_global_data VALUES (86213, 0, 0, 0, 0, 364, 6);
INSERT INTO public.who_global_data VALUES (86214, 0, 0, 0, 0, 364, 227);
INSERT INTO public.who_global_data VALUES (86215, 0, 0, 0, 0, 364, 68);
INSERT INTO public.who_global_data VALUES (86216, 0, 0, 0, 0, 364, 184);
INSERT INTO public.who_global_data VALUES (86217, 0, 0, 0, 0, 364, 82);
INSERT INTO public.who_global_data VALUES (86218, 0, 0, 0, 0, 364, 149);
INSERT INTO public.who_global_data VALUES (86219, 0, 0, 0, 0, 364, 197);
INSERT INTO public.who_global_data VALUES (86220, 0, 0, 0, 0, 364, 78);
INSERT INTO public.who_global_data VALUES (86221, 0, 0, 0, 0, 364, 233);
INSERT INTO public.who_global_data VALUES (86222, 0, 0, 0, 0, 364, 133);
INSERT INTO public.who_global_data VALUES (86223, 0, 0, 0, 0, 364, 35);
INSERT INTO public.who_global_data VALUES (86224, 0, 0, 0, 0, 364, 114);
INSERT INTO public.who_global_data VALUES (86225, 7, 44, 0, 0, 364, 237);
INSERT INTO public.who_global_data VALUES (86226, 0, 0, 0, 0, 364, 55);
INSERT INTO public.who_global_data VALUES (86227, 0, 0, 0, 0, 364, 176);
INSERT INTO public.who_global_data VALUES (86228, 0, 0, 0, 0, 364, 202);
INSERT INTO public.who_global_data VALUES (86229, 0, 0, 0, 0, 364, 155);
INSERT INTO public.who_global_data VALUES (86230, 0, 0, 0, 0, 364, 32);
INSERT INTO public.who_global_data VALUES (86231, 0, 0, 0, 0, 364, 220);
INSERT INTO public.who_global_data VALUES (86232, 0, 0, 0, 0, 364, 30);
INSERT INTO public.who_global_data VALUES (86233, 0, 0, 0, 0, 364, 147);
INSERT INTO public.who_global_data VALUES (86234, 0, 23, 0, 0, 364, 208);
INSERT INTO public.who_global_data VALUES (86235, 0, 5, 0, 0, 364, 45);
INSERT INTO public.who_global_data VALUES (86236, 0, 0, 0, 0, 364, 110);
INSERT INTO public.who_global_data VALUES (86237, 0, 0, 0, 0, 364, 88);
INSERT INTO public.who_global_data VALUES (86238, 0, 1, 0, 0, 364, 51);
INSERT INTO public.who_global_data VALUES (86239, 0, 0, 0, 0, 364, 209);
INSERT INTO public.who_global_data VALUES (86240, 0, 0, 0, 0, 364, 205);
INSERT INTO public.who_global_data VALUES (86241, 0, 0, 0, 0, 364, 18);
INSERT INTO public.who_global_data VALUES (86242, 7, 36, 0, 0, 364, 72);
INSERT INTO public.who_global_data VALUES (86243, 0, 4, 0, 0, 364, 44);
INSERT INTO public.who_global_data VALUES (86244, 0, 0, 0, 0, 364, 15);
INSERT INTO public.who_global_data VALUES (86245, 0, 0, 0, 0, 364, 25);
INSERT INTO public.who_global_data VALUES (86246, 0, 0, 0, 0, 364, 179);
INSERT INTO public.who_global_data VALUES (86247, 0, 0, 0, 0, 364, 34);
INSERT INTO public.who_global_data VALUES (86248, 0, 0, 0, 0, 364, 207);
INSERT INTO public.who_global_data VALUES (86249, 0, 0, 0, 0, 364, 166);
INSERT INTO public.who_global_data VALUES (86250, 0, 0, 0, 0, 364, 126);
INSERT INTO public.who_global_data VALUES (86251, 0, 0, 0, 0, 364, 97);
INSERT INTO public.who_global_data VALUES (86252, 0, 0, 0, 0, 364, 36);
INSERT INTO public.who_global_data VALUES (86253, 0, 0, 0, 0, 364, 125);
INSERT INTO public.who_global_data VALUES (86254, 0, 0, 0, 0, 364, 124);
INSERT INTO public.who_global_data VALUES (86255, 0, 0, 0, 0, 364, 185);
INSERT INTO public.who_global_data VALUES (86256, 2, 11, 0, 0, 364, 194);
INSERT INTO public.who_global_data VALUES (86257, 0, 0, 0, 0, 364, 144);
INSERT INTO public.who_global_data VALUES (86258, 0, 16, 0, 0, 364, 19);
INSERT INTO public.who_global_data VALUES (86259, 0, 0, 0, 0, 364, 217);
INSERT INTO public.who_global_data VALUES (86260, 0, 0, 0, 0, 364, 148);
INSERT INTO public.who_global_data VALUES (86261, 0, 0, 0, 0, 364, 86);
INSERT INTO public.who_global_data VALUES (86262, 0, 0, 0, 0, 364, 13);
INSERT INTO public.who_global_data VALUES (86263, 0, 0, 0, 0, 364, 157);
INSERT INTO public.who_global_data VALUES (86264, 1, 17, 0, 0, 364, 8);
INSERT INTO public.who_global_data VALUES (86265, 0, 0, 0, 0, 364, 73);
INSERT INTO public.who_global_data VALUES (86266, 0, 0, 0, 0, 364, 101);
INSERT INTO public.who_global_data VALUES (86267, 0, 0, 0, 0, 364, 165);
INSERT INTO public.who_global_data VALUES (86268, 0, 0, 0, 0, 364, 14);
INSERT INTO public.who_global_data VALUES (86269, 0, 0, 0, 0, 365, 193);
INSERT INTO public.who_global_data VALUES (86270, 0, 0, 0, 0, 365, 113);
INSERT INTO public.who_global_data VALUES (86271, 0, 0, 0, 0, 365, 143);
INSERT INTO public.who_global_data VALUES (86272, 0, 0, 0, 0, 365, 219);
INSERT INTO public.who_global_data VALUES (86273, 0, 0, 0, 0, 365, 186);
INSERT INTO public.who_global_data VALUES (86274, 0, 0, 0, 0, 365, 52);
INSERT INTO public.who_global_data VALUES (86275, 0, 0, 0, 0, 365, 180);
INSERT INTO public.who_global_data VALUES (86276, 0, 0, 0, 0, 365, 167);
INSERT INTO public.who_global_data VALUES (86277, 0, 0, 0, 0, 365, 154);
INSERT INTO public.who_global_data VALUES (86278, 0, 0, 0, 0, 365, 94);
INSERT INTO public.who_global_data VALUES (86279, 0, 0, 0, 0, 365, 66);
INSERT INTO public.who_global_data VALUES (86280, 0, 19, 0, 0, 365, 58);
INSERT INTO public.who_global_data VALUES (86281, 0, 0, 0, 0, 365, 163);
INSERT INTO public.who_global_data VALUES (86282, 0, 0, 0, 0, 365, 37);
INSERT INTO public.who_global_data VALUES (86283, 0, 0, 0, 0, 365, 142);
INSERT INTO public.who_global_data VALUES (86284, 0, 0, 0, 0, 365, 83);
INSERT INTO public.who_global_data VALUES (86285, 0, 0, 0, 0, 365, 228);
INSERT INTO public.who_global_data VALUES (86286, 0, 0, 0, 0, 365, 188);
INSERT INTO public.who_global_data VALUES (86287, 0, 0, 0, 0, 365, 62);
INSERT INTO public.who_global_data VALUES (86288, 0, 1, 0, 0, 365, 160);
INSERT INTO public.who_global_data VALUES (86289, 0, 0, 0, 0, 365, 50);
INSERT INTO public.who_global_data VALUES (86290, 0, 0, 0, 0, 365, 33);
INSERT INTO public.who_global_data VALUES (86291, 0, 0, 0, 0, 365, 183);
INSERT INTO public.who_global_data VALUES (86292, 0, 0, 0, 0, 365, 92);
INSERT INTO public.who_global_data VALUES (86293, 0, 0, 0, 0, 365, 158);
INSERT INTO public.who_global_data VALUES (86294, 0, 0, 0, 0, 365, 67);
INSERT INTO public.who_global_data VALUES (86295, 0, 0, 0, 0, 365, 57);
INSERT INTO public.who_global_data VALUES (86296, 0, 0, 0, 0, 365, 38);
INSERT INTO public.who_global_data VALUES (86297, 0, 0, 0, 0, 365, 141);
INSERT INTO public.who_global_data VALUES (86298, 0, 0, 0, 0, 365, 178);
INSERT INTO public.who_global_data VALUES (86299, 0, 0, 0, 0, 365, 108);
INSERT INTO public.who_global_data VALUES (86300, 0, 0, 0, 0, 365, 39);
INSERT INTO public.who_global_data VALUES (86301, 0, 0, 0, 0, 365, 2);
INSERT INTO public.who_global_data VALUES (86302, 0, 0, 0, 0, 365, 195);
INSERT INTO public.who_global_data VALUES (86303, 0, 0, 0, 0, 365, 107);
INSERT INTO public.who_global_data VALUES (86304, 0, 5, 0, 0, 365, 161);
INSERT INTO public.who_global_data VALUES (86305, 0, 0, 0, 0, 365, 212);
INSERT INTO public.who_global_data VALUES (86306, 2, 11, 0, 0, 365, 181);
INSERT INTO public.who_global_data VALUES (86307, 0, 0, 0, 0, 365, 53);
INSERT INTO public.who_global_data VALUES (86308, 0, 0, 0, 0, 365, 164);
INSERT INTO public.who_global_data VALUES (86309, 0, 0, 0, 0, 365, 140);
INSERT INTO public.who_global_data VALUES (86310, 0, 0, 0, 0, 365, 20);
INSERT INTO public.who_global_data VALUES (86311, 3151, 31215, 73, 637, 365, 112);
INSERT INTO public.who_global_data VALUES (86312, 0, 0, 0, 0, 365, 111);
INSERT INTO public.who_global_data VALUES (86313, 0, 0, 0, 0, 365, 71);
INSERT INTO public.who_global_data VALUES (86314, 0, 0, 0, 0, 365, 218);
INSERT INTO public.who_global_data VALUES (86315, 0, 0, 0, 0, 365, 43);
INSERT INTO public.who_global_data VALUES (86316, 0, 0, 0, 0, 365, 49);
INSERT INTO public.who_global_data VALUES (86317, 0, 0, 0, 0, 365, 1);
INSERT INTO public.who_global_data VALUES (86318, 0, 0, 0, 0, 365, 48);
INSERT INTO public.who_global_data VALUES (86319, 0, 0, 0, 0, 365, 232);
INSERT INTO public.who_global_data VALUES (86320, 0, 0, 0, 0, 365, 175);
INSERT INTO public.who_global_data VALUES (86321, 0, 0, 0, 0, 365, 21);
INSERT INTO public.who_global_data VALUES (86322, 0, 0, 0, 0, 365, 156);
INSERT INTO public.who_global_data VALUES (86323, 0, 0, 0, 0, 365, 95);
INSERT INTO public.who_global_data VALUES (86324, 0, 0, 0, 0, 365, 177);
INSERT INTO public.who_global_data VALUES (86325, 0, 0, 0, 0, 365, 210);
INSERT INTO public.who_global_data VALUES (86326, 0, 0, 0, 0, 365, 120);
INSERT INTO public.who_global_data VALUES (86327, 0, 0, 0, 0, 365, 135);
INSERT INTO public.who_global_data VALUES (86328, 0, 0, 0, 0, 365, 206);
INSERT INTO public.who_global_data VALUES (86329, 0, 0, 0, 0, 365, 189);
INSERT INTO public.who_global_data VALUES (86330, 0, 0, 0, 0, 365, 129);
INSERT INTO public.who_global_data VALUES (86331, 0, 0, 0, 0, 365, 121);
INSERT INTO public.who_global_data VALUES (86332, 0, 0, 0, 0, 365, 59);
INSERT INTO public.who_global_data VALUES (86333, 0, 0, 0, 0, 365, 96);
INSERT INTO public.who_global_data VALUES (86334, 0, 0, 0, 0, 365, 41);
INSERT INTO public.who_global_data VALUES (86335, 0, 0, 0, 0, 365, 216);
INSERT INTO public.who_global_data VALUES (86336, 0, 0, 0, 0, 365, 236);
INSERT INTO public.who_global_data VALUES (86337, 0, 0, 0, 0, 365, 150);
INSERT INTO public.who_global_data VALUES (86338, 0, 0, 0, 0, 365, 61);
INSERT INTO public.who_global_data VALUES (86339, 0, 0, 0, 0, 365, 7);
INSERT INTO public.who_global_data VALUES (86340, 0, 1, 0, 0, 365, 169);
INSERT INTO public.who_global_data VALUES (86341, 0, 6, 0, 0, 365, 28);
INSERT INTO public.who_global_data VALUES (86342, 0, 0, 0, 0, 365, 85);
INSERT INTO public.who_global_data VALUES (86343, 0, 0, 0, 0, 365, 211);
INSERT INTO public.who_global_data VALUES (86344, 0, 0, 0, 0, 365, 60);
INSERT INTO public.who_global_data VALUES (86345, 0, 0, 0, 0, 365, 3);
INSERT INTO public.who_global_data VALUES (86346, 0, 0, 0, 0, 365, 11);
INSERT INTO public.who_global_data VALUES (86347, 1, 12, 0, 0, 365, 89);
INSERT INTO public.who_global_data VALUES (86348, 0, 0, 0, 0, 365, 24);
INSERT INTO public.who_global_data VALUES (86349, 0, 0, 0, 0, 365, 162);
INSERT INTO public.who_global_data VALUES (86350, 0, 0, 0, 0, 365, 100);
INSERT INTO public.who_global_data VALUES (86351, 0, 0, 0, 0, 365, 47);
INSERT INTO public.who_global_data VALUES (86352, 0, 0, 0, 0, 365, 29);
INSERT INTO public.who_global_data VALUES (86353, 0, 0, 0, 0, 365, 40);
INSERT INTO public.who_global_data VALUES (86354, 0, 0, 0, 0, 365, 222);
INSERT INTO public.who_global_data VALUES (86355, 0, 0, 0, 0, 365, 132);
INSERT INTO public.who_global_data VALUES (86356, 0, 0, 0, 0, 365, 130);
INSERT INTO public.who_global_data VALUES (86357, 0, 0, 0, 0, 365, 234);
INSERT INTO public.who_global_data VALUES (86358, 0, 0, 0, 0, 365, 23);
INSERT INTO public.who_global_data VALUES (86359, 0, 0, 0, 0, 365, 192);
INSERT INTO public.who_global_data VALUES (86360, 0, 0, 0, 0, 365, 69);
INSERT INTO public.who_global_data VALUES (86361, 0, 0, 0, 0, 365, 187);
INSERT INTO public.who_global_data VALUES (86362, 0, 0, 0, 0, 365, 230);
INSERT INTO public.who_global_data VALUES (86363, 0, 0, 0, 0, 365, 77);
INSERT INTO public.who_global_data VALUES (86364, 0, 0, 0, 0, 365, 9);
INSERT INTO public.who_global_data VALUES (86365, 0, 7, 0, 0, 365, 74);
INSERT INTO public.who_global_data VALUES (86366, 0, 0, 0, 0, 365, 224);
INSERT INTO public.who_global_data VALUES (86367, 0, 0, 0, 0, 365, 199);
INSERT INTO public.who_global_data VALUES (86368, 0, 0, 0, 0, 365, 190);
INSERT INTO public.who_global_data VALUES (86369, 0, 0, 0, 0, 365, 12);
INSERT INTO public.who_global_data VALUES (86370, 0, 0, 0, 0, 365, 104);
INSERT INTO public.who_global_data VALUES (86371, 0, 0, 0, 0, 365, 153);
INSERT INTO public.who_global_data VALUES (86372, 0, 3, 0, 0, 365, 91);
INSERT INTO public.who_global_data VALUES (86373, 0, 0, 0, 0, 365, 215);
INSERT INTO public.who_global_data VALUES (86374, 0, 29, 0, 0, 365, 84);
INSERT INTO public.who_global_data VALUES (86375, 0, 0, 0, 0, 365, 231);
INSERT INTO public.who_global_data VALUES (86376, 0, 0, 0, 0, 365, 196);
INSERT INTO public.who_global_data VALUES (86377, 0, 0, 0, 0, 365, 105);
INSERT INTO public.who_global_data VALUES (86378, 0, 0, 0, 0, 365, 122);
INSERT INTO public.who_global_data VALUES (86379, 0, 0, 0, 0, 365, 159);
INSERT INTO public.who_global_data VALUES (86380, 0, 0, 0, 0, 365, 75);
INSERT INTO public.who_global_data VALUES (86381, 0, 0, 0, 0, 365, 27);
INSERT INTO public.who_global_data VALUES (86382, 0, 0, 0, 0, 365, 54);
INSERT INTO public.who_global_data VALUES (86383, 0, 0, 0, 0, 365, 226);
INSERT INTO public.who_global_data VALUES (86384, 0, 0, 0, 0, 365, 79);
INSERT INTO public.who_global_data VALUES (86385, 0, 0, 0, 0, 365, 56);
INSERT INTO public.who_global_data VALUES (86386, 0, 0, 0, 0, 365, 117);
INSERT INTO public.who_global_data VALUES (86387, 0, 0, 0, 0, 365, 152);
INSERT INTO public.who_global_data VALUES (86388, 0, 0, 0, 0, 365, 16);
INSERT INTO public.who_global_data VALUES (86389, 0, 0, 0, 0, 365, 10);
INSERT INTO public.who_global_data VALUES (86390, 0, 0, 0, 0, 365, 201);
INSERT INTO public.who_global_data VALUES (86391, 0, 0, 0, 0, 365, 174);
INSERT INTO public.who_global_data VALUES (86392, 0, 0, 0, 0, 365, 119);
INSERT INTO public.who_global_data VALUES (86393, 0, 0, 0, 0, 365, 168);
INSERT INTO public.who_global_data VALUES (86394, 1, 19, 0, 0, 365, 99);
INSERT INTO public.who_global_data VALUES (86395, 0, 0, 0, 0, 365, 171);
INSERT INTO public.who_global_data VALUES (86396, 0, 0, 0, 0, 365, 87);
INSERT INTO public.who_global_data VALUES (86397, 0, 0, 0, 0, 365, 123);
INSERT INTO public.who_global_data VALUES (86398, 0, 0, 0, 0, 365, 151);
INSERT INTO public.who_global_data VALUES (86399, 0, 0, 0, 0, 365, 213);
INSERT INTO public.who_global_data VALUES (86400, 0, 0, 0, 0, 365, 118);
INSERT INTO public.who_global_data VALUES (86401, 0, 0, 0, 0, 365, 134);
INSERT INTO public.who_global_data VALUES (86402, 0, 0, 0, 0, 365, 65);
INSERT INTO public.who_global_data VALUES (86403, 0, 0, 0, 0, 365, 102);
INSERT INTO public.who_global_data VALUES (86404, 0, 0, 0, 0, 365, 223);
INSERT INTO public.who_global_data VALUES (86405, 0, 0, 0, 0, 365, 4);
INSERT INTO public.who_global_data VALUES (86406, 0, 0, 0, 0, 365, 146);
INSERT INTO public.who_global_data VALUES (86407, 0, 0, 0, 0, 365, 31);
INSERT INTO public.who_global_data VALUES (86408, 0, 0, 0, 0, 365, 127);
INSERT INTO public.who_global_data VALUES (86409, 0, 0, 0, 0, 365, 22);
INSERT INTO public.who_global_data VALUES (86410, 0, 0, 0, 0, 365, 115);
INSERT INTO public.who_global_data VALUES (86411, 0, 0, 0, 0, 365, 106);
INSERT INTO public.who_global_data VALUES (86412, 0, 0, 0, 0, 365, 90);
INSERT INTO public.who_global_data VALUES (86413, 0, 0, 0, 0, 365, 70);
INSERT INTO public.who_global_data VALUES (86414, 0, 5, 0, 0, 365, 46);
INSERT INTO public.who_global_data VALUES (86415, 0, 0, 0, 0, 365, 139);
INSERT INTO public.who_global_data VALUES (86416, 0, 0, 0, 0, 365, 42);
INSERT INTO public.who_global_data VALUES (86417, 0, 0, 0, 0, 365, 80);
INSERT INTO public.who_global_data VALUES (86418, 0, 0, 0, 0, 365, 203);
INSERT INTO public.who_global_data VALUES (86419, 0, 0, 0, 0, 365, 136);
INSERT INTO public.who_global_data VALUES (86420, 0, 0, 0, 0, 365, 63);
INSERT INTO public.who_global_data VALUES (86421, 0, 0, 0, 0, 365, 17);
INSERT INTO public.who_global_data VALUES (86422, 0, 0, 0, 0, 365, 172);
INSERT INTO public.who_global_data VALUES (86423, 0, 0, 0, 0, 365, 109);
INSERT INTO public.who_global_data VALUES (86424, 0, 0, 0, 0, 365, 200);
INSERT INTO public.who_global_data VALUES (86425, 0, 0, 0, 0, 365, 93);
INSERT INTO public.who_global_data VALUES (86426, 0, 0, 0, 0, 365, 5);
INSERT INTO public.who_global_data VALUES (86427, 41, 65, 0, 0, 365, 214);
INSERT INTO public.who_global_data VALUES (86428, 0, 0, 0, 0, 365, 204);
INSERT INTO public.who_global_data VALUES (86429, 0, 0, 0, 0, 365, 198);
INSERT INTO public.who_global_data VALUES (86430, 0, 0, 0, 0, 365, 173);
INSERT INTO public.who_global_data VALUES (86431, 0, 0, 0, 0, 365, 229);
INSERT INTO public.who_global_data VALUES (86432, 0, 0, 0, 0, 365, 76);
INSERT INTO public.who_global_data VALUES (86433, 0, 0, 0, 0, 365, 138);
INSERT INTO public.who_global_data VALUES (86434, 0, 7, 0, 1, 365, 98);
INSERT INTO public.who_global_data VALUES (86435, 0, 0, 0, 0, 365, 103);
INSERT INTO public.who_global_data VALUES (86436, 0, 0, 0, 0, 365, 225);
INSERT INTO public.who_global_data VALUES (86437, 0, 0, 0, 0, 365, 131);
INSERT INTO public.who_global_data VALUES (86438, 0, 0, 0, 0, 365, 235);
INSERT INTO public.who_global_data VALUES (86439, 0, 0, 0, 0, 365, 137);
INSERT INTO public.who_global_data VALUES (86440, 1, 28, 0, 0, 365, 81);
INSERT INTO public.who_global_data VALUES (86441, 0, 0, 0, 0, 365, 182);
INSERT INTO public.who_global_data VALUES (86442, 0, 0, 0, 0, 365, 145);
INSERT INTO public.who_global_data VALUES (86443, 0, 0, 0, 0, 365, 26);
INSERT INTO public.who_global_data VALUES (86444, 0, 2, 0, 0, 365, 170);
INSERT INTO public.who_global_data VALUES (86445, 0, 0, 0, 0, 365, 191);
INSERT INTO public.who_global_data VALUES (86446, 0, 0, 0, 0, 365, 221);
INSERT INTO public.who_global_data VALUES (86447, 0, 0, 0, 0, 365, 64);
INSERT INTO public.who_global_data VALUES (86448, 0, 0, 0, 0, 365, 116);
INSERT INTO public.who_global_data VALUES (86449, 0, 0, 0, 0, 365, 128);
INSERT INTO public.who_global_data VALUES (86450, 0, 0, 0, 0, 365, 6);
INSERT INTO public.who_global_data VALUES (86451, 0, 0, 0, 0, 365, 227);
INSERT INTO public.who_global_data VALUES (86452, 0, 0, 0, 0, 365, 68);
INSERT INTO public.who_global_data VALUES (86453, 0, 0, 0, 0, 365, 184);
INSERT INTO public.who_global_data VALUES (86454, 0, 0, 0, 0, 365, 82);
INSERT INTO public.who_global_data VALUES (86455, 0, 0, 0, 0, 365, 149);
INSERT INTO public.who_global_data VALUES (86456, 0, 0, 0, 0, 365, 197);
INSERT INTO public.who_global_data VALUES (86457, 0, 0, 0, 0, 365, 78);
INSERT INTO public.who_global_data VALUES (86458, 0, 0, 0, 0, 365, 233);
INSERT INTO public.who_global_data VALUES (86459, 0, 0, 0, 0, 365, 133);
INSERT INTO public.who_global_data VALUES (86460, 0, 0, 0, 0, 365, 35);
INSERT INTO public.who_global_data VALUES (86461, 0, 0, 0, 0, 365, 114);
INSERT INTO public.who_global_data VALUES (86462, 3, 37, 0, 0, 365, 237);
INSERT INTO public.who_global_data VALUES (86463, 0, 0, 0, 0, 365, 55);
INSERT INTO public.who_global_data VALUES (86464, 0, 0, 0, 0, 365, 176);
INSERT INTO public.who_global_data VALUES (86465, 0, 0, 0, 0, 365, 202);
INSERT INTO public.who_global_data VALUES (86466, 0, 0, 0, 0, 365, 155);
INSERT INTO public.who_global_data VALUES (86467, 0, 0, 0, 0, 365, 32);
INSERT INTO public.who_global_data VALUES (86468, 0, 0, 0, 0, 365, 220);
INSERT INTO public.who_global_data VALUES (86469, 0, 0, 0, 0, 365, 30);
INSERT INTO public.who_global_data VALUES (86470, 0, 0, 0, 0, 365, 147);
INSERT INTO public.who_global_data VALUES (86471, 0, 23, 0, 0, 365, 208);
INSERT INTO public.who_global_data VALUES (86472, 0, 5, 0, 0, 365, 45);
INSERT INTO public.who_global_data VALUES (86473, 0, 0, 0, 0, 365, 110);
INSERT INTO public.who_global_data VALUES (86474, 0, 0, 0, 0, 365, 88);
INSERT INTO public.who_global_data VALUES (86475, 0, 1, 0, 0, 365, 51);
INSERT INTO public.who_global_data VALUES (86476, 0, 0, 0, 0, 365, 209);
INSERT INTO public.who_global_data VALUES (86477, 0, 0, 0, 0, 365, 205);
INSERT INTO public.who_global_data VALUES (86478, 0, 0, 0, 0, 365, 18);
INSERT INTO public.who_global_data VALUES (86479, 0, 29, 0, 0, 365, 72);
INSERT INTO public.who_global_data VALUES (86480, 1, 4, 0, 0, 365, 44);
INSERT INTO public.who_global_data VALUES (86481, 0, 0, 0, 0, 365, 15);
INSERT INTO public.who_global_data VALUES (86482, 0, 0, 0, 0, 365, 25);
INSERT INTO public.who_global_data VALUES (86483, 0, 0, 0, 0, 365, 179);
INSERT INTO public.who_global_data VALUES (86484, 0, 0, 0, 0, 365, 34);
INSERT INTO public.who_global_data VALUES (86485, 0, 0, 0, 0, 365, 207);
INSERT INTO public.who_global_data VALUES (86486, 0, 0, 0, 0, 365, 166);
INSERT INTO public.who_global_data VALUES (86487, 0, 0, 0, 0, 365, 126);
INSERT INTO public.who_global_data VALUES (86488, 0, 0, 0, 0, 365, 97);
INSERT INTO public.who_global_data VALUES (86489, 0, 0, 0, 0, 365, 36);
INSERT INTO public.who_global_data VALUES (86490, 0, 0, 0, 0, 365, 125);
INSERT INTO public.who_global_data VALUES (86491, 0, 0, 0, 0, 365, 124);
INSERT INTO public.who_global_data VALUES (86492, 0, 0, 0, 0, 365, 185);
INSERT INTO public.who_global_data VALUES (86493, 0, 9, 0, 0, 365, 194);
INSERT INTO public.who_global_data VALUES (86494, 0, 0, 0, 0, 365, 144);
INSERT INTO public.who_global_data VALUES (86495, 0, 16, 0, 0, 365, 19);
INSERT INTO public.who_global_data VALUES (86496, 0, 0, 0, 0, 365, 217);
INSERT INTO public.who_global_data VALUES (86497, 0, 0, 0, 0, 365, 148);
INSERT INTO public.who_global_data VALUES (86498, 0, 0, 0, 0, 365, 86);
INSERT INTO public.who_global_data VALUES (86499, 0, 0, 0, 0, 365, 13);
INSERT INTO public.who_global_data VALUES (86500, 0, 0, 0, 0, 365, 157);
INSERT INTO public.who_global_data VALUES (86501, 0, 16, 0, 0, 365, 8);
INSERT INTO public.who_global_data VALUES (86502, 0, 0, 0, 0, 365, 73);
INSERT INTO public.who_global_data VALUES (86503, 0, 0, 0, 0, 365, 101);
INSERT INTO public.who_global_data VALUES (86504, 0, 0, 0, 0, 365, 165);
INSERT INTO public.who_global_data VALUES (86505, 0, 0, 0, 0, 365, 14);
INSERT INTO public.who_global_data VALUES (86506, 0, 0, 0, 0, 366, 193);
INSERT INTO public.who_global_data VALUES (86507, 0, 0, 0, 0, 366, 113);
INSERT INTO public.who_global_data VALUES (86508, 0, 0, 0, 0, 366, 143);
INSERT INTO public.who_global_data VALUES (86509, 0, 0, 0, 0, 366, 219);
INSERT INTO public.who_global_data VALUES (86510, 0, 0, 0, 0, 366, 186);
INSERT INTO public.who_global_data VALUES (86511, 0, 0, 0, 0, 366, 52);
INSERT INTO public.who_global_data VALUES (86512, 0, 0, 0, 0, 366, 180);
INSERT INTO public.who_global_data VALUES (86513, 0, 0, 0, 0, 366, 167);
INSERT INTO public.who_global_data VALUES (86514, 0, 0, 0, 0, 366, 154);
INSERT INTO public.who_global_data VALUES (86515, 0, 0, 0, 0, 366, 94);
INSERT INTO public.who_global_data VALUES (86516, 0, 0, 0, 0, 366, 66);
INSERT INTO public.who_global_data VALUES (86517, 1, 19, 0, 0, 366, 58);
INSERT INTO public.who_global_data VALUES (86518, 0, 0, 0, 0, 366, 163);
INSERT INTO public.who_global_data VALUES (86519, 0, 0, 0, 0, 366, 37);
INSERT INTO public.who_global_data VALUES (86520, 0, 0, 0, 0, 366, 142);
INSERT INTO public.who_global_data VALUES (86521, 0, 0, 0, 0, 366, 83);
INSERT INTO public.who_global_data VALUES (86522, 0, 0, 0, 0, 366, 228);
INSERT INTO public.who_global_data VALUES (86523, 0, 0, 0, 0, 366, 188);
INSERT INTO public.who_global_data VALUES (86524, 0, 0, 0, 0, 366, 62);
INSERT INTO public.who_global_data VALUES (86525, 0, 1, 0, 0, 366, 160);
INSERT INTO public.who_global_data VALUES (86526, 0, 0, 0, 0, 366, 50);
INSERT INTO public.who_global_data VALUES (86527, 0, 0, 0, 0, 366, 33);
INSERT INTO public.who_global_data VALUES (86528, 0, 0, 0, 0, 366, 183);
INSERT INTO public.who_global_data VALUES (86529, 0, 0, 0, 0, 366, 92);
INSERT INTO public.who_global_data VALUES (86530, 0, 0, 0, 0, 366, 158);
INSERT INTO public.who_global_data VALUES (86531, 0, 0, 0, 0, 366, 67);
INSERT INTO public.who_global_data VALUES (86532, 0, 0, 0, 0, 366, 57);
INSERT INTO public.who_global_data VALUES (86533, 0, 0, 0, 0, 366, 38);
INSERT INTO public.who_global_data VALUES (86534, 0, 0, 0, 0, 366, 141);
INSERT INTO public.who_global_data VALUES (86535, 0, 0, 0, 0, 366, 178);
INSERT INTO public.who_global_data VALUES (86536, 0, 0, 0, 0, 366, 108);
INSERT INTO public.who_global_data VALUES (86537, 0, 0, 0, 0, 366, 39);
INSERT INTO public.who_global_data VALUES (86538, 0, 0, 0, 0, 366, 2);
INSERT INTO public.who_global_data VALUES (86539, 0, 0, 0, 0, 366, 195);
INSERT INTO public.who_global_data VALUES (86540, 0, 0, 0, 0, 366, 107);
INSERT INTO public.who_global_data VALUES (86541, 0, 5, 0, 0, 366, 161);
INSERT INTO public.who_global_data VALUES (86542, 0, 0, 0, 0, 366, 212);
INSERT INTO public.who_global_data VALUES (86543, 0, 9, 0, 0, 366, 181);
INSERT INTO public.who_global_data VALUES (86544, 0, 0, 0, 0, 366, 53);
INSERT INTO public.who_global_data VALUES (86545, 0, 0, 0, 0, 366, 164);
INSERT INTO public.who_global_data VALUES (86546, 0, 0, 0, 0, 366, 140);
INSERT INTO public.who_global_data VALUES (86547, 0, 0, 0, 0, 366, 20);
INSERT INTO public.who_global_data VALUES (86548, 3697, 28064, 73, 564, 366, 112);
INSERT INTO public.who_global_data VALUES (86549, 0, 0, 0, 0, 366, 111);
INSERT INTO public.who_global_data VALUES (86550, 0, 0, 0, 0, 366, 71);
INSERT INTO public.who_global_data VALUES (86551, 0, 0, 0, 0, 366, 218);
INSERT INTO public.who_global_data VALUES (86552, 0, 0, 0, 0, 366, 43);
INSERT INTO public.who_global_data VALUES (86553, 0, 0, 0, 0, 366, 49);
INSERT INTO public.who_global_data VALUES (86554, 0, 0, 0, 0, 366, 1);
INSERT INTO public.who_global_data VALUES (86555, 0, 0, 0, 0, 366, 48);
INSERT INTO public.who_global_data VALUES (86556, 0, 0, 0, 0, 366, 232);
INSERT INTO public.who_global_data VALUES (86557, 0, 0, 0, 0, 366, 175);
INSERT INTO public.who_global_data VALUES (86558, 0, 0, 0, 0, 366, 21);
INSERT INTO public.who_global_data VALUES (86559, 0, 0, 0, 0, 366, 156);
INSERT INTO public.who_global_data VALUES (86560, 0, 0, 0, 0, 366, 95);
INSERT INTO public.who_global_data VALUES (86561, 0, 0, 0, 0, 366, 177);
INSERT INTO public.who_global_data VALUES (86562, 0, 0, 0, 0, 366, 210);
INSERT INTO public.who_global_data VALUES (86563, 0, 0, 0, 0, 366, 120);
INSERT INTO public.who_global_data VALUES (86564, 0, 0, 0, 0, 366, 135);
INSERT INTO public.who_global_data VALUES (86565, 0, 0, 0, 0, 366, 206);
INSERT INTO public.who_global_data VALUES (86566, 0, 0, 0, 0, 366, 189);
INSERT INTO public.who_global_data VALUES (86567, 0, 0, 0, 0, 366, 129);
INSERT INTO public.who_global_data VALUES (86568, 0, 0, 0, 0, 366, 121);
INSERT INTO public.who_global_data VALUES (86569, 0, 0, 0, 0, 366, 59);
INSERT INTO public.who_global_data VALUES (86570, 0, 0, 0, 0, 366, 96);
INSERT INTO public.who_global_data VALUES (86571, 0, 0, 0, 0, 366, 41);
INSERT INTO public.who_global_data VALUES (86572, 0, 0, 0, 0, 366, 216);
INSERT INTO public.who_global_data VALUES (86573, 0, 0, 0, 0, 366, 236);
INSERT INTO public.who_global_data VALUES (86574, 0, 0, 0, 0, 366, 150);
INSERT INTO public.who_global_data VALUES (86575, 0, 0, 0, 0, 366, 61);
INSERT INTO public.who_global_data VALUES (86576, 0, 0, 0, 0, 366, 7);
INSERT INTO public.who_global_data VALUES (86577, 0, 1, 0, 0, 366, 169);
INSERT INTO public.who_global_data VALUES (86578, 0, 6, 0, 0, 366, 28);
INSERT INTO public.who_global_data VALUES (86579, 0, 0, 0, 0, 366, 85);
INSERT INTO public.who_global_data VALUES (86580, 0, 0, 0, 0, 366, 211);
INSERT INTO public.who_global_data VALUES (86581, 0, 0, 0, 0, 366, 60);
INSERT INTO public.who_global_data VALUES (86582, 0, 0, 0, 0, 366, 3);
INSERT INTO public.who_global_data VALUES (86583, 0, 0, 0, 0, 366, 11);
INSERT INTO public.who_global_data VALUES (86584, 0, 11, 0, 0, 366, 89);
INSERT INTO public.who_global_data VALUES (86585, 0, 0, 0, 0, 366, 24);
INSERT INTO public.who_global_data VALUES (86586, 0, 0, 0, 0, 366, 162);
INSERT INTO public.who_global_data VALUES (86587, 0, 0, 0, 0, 366, 100);
INSERT INTO public.who_global_data VALUES (86588, 0, 0, 0, 0, 366, 47);
INSERT INTO public.who_global_data VALUES (86589, 0, 0, 0, 0, 366, 29);
INSERT INTO public.who_global_data VALUES (86590, 0, 0, 0, 0, 366, 40);
INSERT INTO public.who_global_data VALUES (86591, 0, 0, 0, 0, 366, 222);
INSERT INTO public.who_global_data VALUES (86592, 0, 0, 0, 0, 366, 132);
INSERT INTO public.who_global_data VALUES (86593, 0, 0, 0, 0, 366, 130);
INSERT INTO public.who_global_data VALUES (86594, 0, 0, 0, 0, 366, 234);
INSERT INTO public.who_global_data VALUES (86595, 0, 0, 0, 0, 366, 23);
INSERT INTO public.who_global_data VALUES (86596, 0, 0, 0, 0, 366, 192);
INSERT INTO public.who_global_data VALUES (86597, 0, 0, 0, 0, 366, 69);
INSERT INTO public.who_global_data VALUES (86598, 0, 0, 0, 0, 366, 187);
INSERT INTO public.who_global_data VALUES (86599, 0, 0, 0, 0, 366, 230);
INSERT INTO public.who_global_data VALUES (86600, 0, 0, 0, 0, 366, 77);
INSERT INTO public.who_global_data VALUES (86601, 0, 0, 0, 0, 366, 9);
INSERT INTO public.who_global_data VALUES (86602, 0, 7, 0, 0, 366, 74);
INSERT INTO public.who_global_data VALUES (86603, 0, 0, 0, 0, 366, 224);
INSERT INTO public.who_global_data VALUES (86604, 0, 0, 0, 0, 366, 199);
INSERT INTO public.who_global_data VALUES (86605, 0, 0, 0, 0, 366, 190);
INSERT INTO public.who_global_data VALUES (86606, 0, 0, 0, 0, 366, 12);
INSERT INTO public.who_global_data VALUES (86607, 0, 0, 0, 0, 366, 104);
INSERT INTO public.who_global_data VALUES (86608, 0, 0, 0, 0, 366, 153);
INSERT INTO public.who_global_data VALUES (86609, 0, 3, 0, 0, 366, 91);
INSERT INTO public.who_global_data VALUES (86610, 0, 0, 0, 0, 366, 215);
INSERT INTO public.who_global_data VALUES (86611, 0, 29, 0, 0, 366, 84);
INSERT INTO public.who_global_data VALUES (86612, 0, 0, 0, 0, 366, 231);
INSERT INTO public.who_global_data VALUES (86613, 0, 0, 0, 0, 366, 196);
INSERT INTO public.who_global_data VALUES (86614, 0, 0, 0, 0, 366, 105);
INSERT INTO public.who_global_data VALUES (86615, 0, 0, 0, 0, 366, 122);
INSERT INTO public.who_global_data VALUES (86616, 0, 0, 0, 0, 366, 159);
INSERT INTO public.who_global_data VALUES (86617, 0, 0, 0, 0, 366, 75);
INSERT INTO public.who_global_data VALUES (86618, 0, 0, 0, 0, 366, 27);
INSERT INTO public.who_global_data VALUES (86619, 0, 0, 0, 0, 366, 54);
INSERT INTO public.who_global_data VALUES (86620, 0, 0, 0, 0, 366, 226);
INSERT INTO public.who_global_data VALUES (86621, 0, 0, 0, 0, 366, 79);
INSERT INTO public.who_global_data VALUES (86622, 0, 0, 0, 0, 366, 56);
INSERT INTO public.who_global_data VALUES (86623, 0, 0, 0, 0, 366, 117);
INSERT INTO public.who_global_data VALUES (86624, 0, 0, 0, 0, 366, 152);
INSERT INTO public.who_global_data VALUES (86625, 0, 0, 0, 0, 366, 16);
INSERT INTO public.who_global_data VALUES (86626, 0, 0, 0, 0, 366, 10);
INSERT INTO public.who_global_data VALUES (86627, 0, 0, 0, 0, 366, 201);
INSERT INTO public.who_global_data VALUES (86628, 0, 0, 0, 0, 366, 174);
INSERT INTO public.who_global_data VALUES (86629, 0, 0, 0, 0, 366, 119);
INSERT INTO public.who_global_data VALUES (86630, 0, 0, 0, 0, 366, 168);
INSERT INTO public.who_global_data VALUES (86631, 2, 18, 0, 0, 366, 99);
INSERT INTO public.who_global_data VALUES (86632, 0, 0, 0, 0, 366, 171);
INSERT INTO public.who_global_data VALUES (86633, 0, 0, 0, 0, 366, 87);
INSERT INTO public.who_global_data VALUES (86634, 0, 0, 0, 0, 366, 123);
INSERT INTO public.who_global_data VALUES (86635, 0, 0, 0, 0, 366, 151);
INSERT INTO public.who_global_data VALUES (86636, 0, 0, 0, 0, 366, 213);
INSERT INTO public.who_global_data VALUES (86637, 0, 0, 0, 0, 366, 118);
INSERT INTO public.who_global_data VALUES (86638, 0, 0, 0, 0, 366, 134);
INSERT INTO public.who_global_data VALUES (86639, 0, 0, 0, 0, 366, 65);
INSERT INTO public.who_global_data VALUES (86640, 0, 0, 0, 0, 366, 102);
INSERT INTO public.who_global_data VALUES (86641, 0, 0, 0, 0, 366, 223);
INSERT INTO public.who_global_data VALUES (86642, 0, 0, 0, 0, 366, 4);
INSERT INTO public.who_global_data VALUES (86643, 0, 0, 0, 0, 366, 146);
INSERT INTO public.who_global_data VALUES (86644, 0, 0, 0, 0, 366, 31);
INSERT INTO public.who_global_data VALUES (86645, 0, 0, 0, 0, 366, 127);
INSERT INTO public.who_global_data VALUES (86646, 0, 0, 0, 0, 366, 22);
INSERT INTO public.who_global_data VALUES (86647, 0, 0, 0, 0, 366, 115);
INSERT INTO public.who_global_data VALUES (86648, 0, 0, 0, 0, 366, 106);
INSERT INTO public.who_global_data VALUES (86649, 0, 0, 0, 0, 366, 90);
INSERT INTO public.who_global_data VALUES (86650, 0, 0, 0, 0, 366, 70);
INSERT INTO public.who_global_data VALUES (86651, 0, 5, 0, 0, 366, 46);
INSERT INTO public.who_global_data VALUES (86652, 0, 0, 0, 0, 366, 139);
INSERT INTO public.who_global_data VALUES (86653, 0, 0, 0, 0, 366, 42);
INSERT INTO public.who_global_data VALUES (86654, 0, 0, 0, 0, 366, 80);
INSERT INTO public.who_global_data VALUES (86655, 0, 0, 0, 0, 366, 203);
INSERT INTO public.who_global_data VALUES (86656, 0, 0, 0, 0, 366, 136);
INSERT INTO public.who_global_data VALUES (86657, 0, 0, 0, 0, 366, 63);
INSERT INTO public.who_global_data VALUES (86658, 0, 0, 0, 0, 366, 17);
INSERT INTO public.who_global_data VALUES (86659, 0, 0, 0, 0, 366, 172);
INSERT INTO public.who_global_data VALUES (86660, 0, 0, 0, 0, 366, 109);
INSERT INTO public.who_global_data VALUES (86661, 0, 0, 0, 0, 366, 200);
INSERT INTO public.who_global_data VALUES (86662, 0, 0, 0, 0, 366, 93);
INSERT INTO public.who_global_data VALUES (86663, 0, 0, 0, 0, 366, 5);
INSERT INTO public.who_global_data VALUES (86664, 10, 24, 0, 0, 366, 214);
INSERT INTO public.who_global_data VALUES (86665, 0, 0, 0, 0, 366, 204);
INSERT INTO public.who_global_data VALUES (86666, 0, 0, 0, 0, 366, 198);
INSERT INTO public.who_global_data VALUES (86667, 0, 0, 0, 0, 366, 173);
INSERT INTO public.who_global_data VALUES (86668, 0, 0, 0, 0, 366, 229);
INSERT INTO public.who_global_data VALUES (86669, 0, 0, 0, 0, 366, 76);
INSERT INTO public.who_global_data VALUES (86670, 0, 0, 0, 0, 366, 138);
INSERT INTO public.who_global_data VALUES (86671, 0, 7, 0, 1, 366, 98);
INSERT INTO public.who_global_data VALUES (86672, 0, 0, 0, 0, 366, 103);
INSERT INTO public.who_global_data VALUES (86673, 0, 0, 0, 0, 366, 225);
INSERT INTO public.who_global_data VALUES (86674, 0, 0, 0, 0, 366, 131);
INSERT INTO public.who_global_data VALUES (86675, 0, 0, 0, 0, 366, 235);
INSERT INTO public.who_global_data VALUES (86676, 0, 0, 0, 0, 366, 137);
INSERT INTO public.who_global_data VALUES (86677, 5, 27, 0, 0, 366, 81);
INSERT INTO public.who_global_data VALUES (86678, 0, 0, 0, 0, 366, 182);
INSERT INTO public.who_global_data VALUES (86679, 0, 0, 0, 0, 366, 145);
INSERT INTO public.who_global_data VALUES (86680, 0, 0, 0, 0, 366, 26);
INSERT INTO public.who_global_data VALUES (86681, 0, 2, 0, 0, 366, 170);
INSERT INTO public.who_global_data VALUES (86682, 0, 0, 0, 0, 366, 191);
INSERT INTO public.who_global_data VALUES (86683, 0, 0, 0, 0, 366, 221);
INSERT INTO public.who_global_data VALUES (86684, 0, 0, 0, 0, 366, 64);
INSERT INTO public.who_global_data VALUES (86685, 0, 0, 0, 0, 366, 116);
INSERT INTO public.who_global_data VALUES (86686, 0, 0, 0, 0, 366, 128);
INSERT INTO public.who_global_data VALUES (86687, 0, 0, 0, 0, 366, 6);
INSERT INTO public.who_global_data VALUES (86688, 0, 0, 0, 0, 366, 227);
INSERT INTO public.who_global_data VALUES (86689, 0, 0, 0, 0, 366, 68);
INSERT INTO public.who_global_data VALUES (86690, 0, 0, 0, 0, 366, 184);
INSERT INTO public.who_global_data VALUES (86691, 0, 0, 0, 0, 366, 82);
INSERT INTO public.who_global_data VALUES (86692, 0, 0, 0, 0, 366, 149);
INSERT INTO public.who_global_data VALUES (86693, 0, 0, 0, 0, 366, 197);
INSERT INTO public.who_global_data VALUES (86694, 0, 0, 0, 0, 366, 78);
INSERT INTO public.who_global_data VALUES (86695, 0, 0, 0, 0, 366, 233);
INSERT INTO public.who_global_data VALUES (86696, 0, 0, 0, 0, 366, 133);
INSERT INTO public.who_global_data VALUES (86697, 0, 0, 0, 0, 366, 35);
INSERT INTO public.who_global_data VALUES (86698, 0, 0, 0, 0, 366, 114);
INSERT INTO public.who_global_data VALUES (86699, 2, 34, 0, 0, 366, 237);
INSERT INTO public.who_global_data VALUES (86700, 0, 0, 0, 0, 366, 55);
INSERT INTO public.who_global_data VALUES (86701, 0, 0, 0, 0, 366, 176);
INSERT INTO public.who_global_data VALUES (86702, 0, 0, 0, 0, 366, 202);
INSERT INTO public.who_global_data VALUES (86703, 0, 0, 0, 0, 366, 155);
INSERT INTO public.who_global_data VALUES (86704, 0, 0, 0, 0, 366, 32);
INSERT INTO public.who_global_data VALUES (86705, 0, 0, 0, 0, 366, 220);
INSERT INTO public.who_global_data VALUES (86706, 0, 0, 0, 0, 366, 30);
INSERT INTO public.who_global_data VALUES (86707, 0, 0, 0, 0, 366, 147);
INSERT INTO public.who_global_data VALUES (86708, 0, 23, 0, 0, 366, 208);
INSERT INTO public.who_global_data VALUES (86709, 0, 5, 0, 0, 366, 45);
INSERT INTO public.who_global_data VALUES (86710, 0, 0, 0, 0, 366, 110);
INSERT INTO public.who_global_data VALUES (86711, 0, 0, 0, 0, 366, 88);
INSERT INTO public.who_global_data VALUES (86712, 0, 1, 0, 0, 366, 51);
INSERT INTO public.who_global_data VALUES (86713, 0, 0, 0, 0, 366, 209);
INSERT INTO public.who_global_data VALUES (86714, 0, 0, 0, 0, 366, 205);
INSERT INTO public.who_global_data VALUES (86715, 0, 0, 0, 0, 366, 18);
INSERT INTO public.who_global_data VALUES (86716, 0, 29, 0, 0, 366, 72);
INSERT INTO public.who_global_data VALUES (86717, 0, 3, 0, 0, 366, 44);
INSERT INTO public.who_global_data VALUES (86718, 0, 0, 0, 0, 366, 15);
INSERT INTO public.who_global_data VALUES (86719, 0, 0, 0, 0, 366, 25);
INSERT INTO public.who_global_data VALUES (86720, 0, 0, 0, 0, 366, 179);
INSERT INTO public.who_global_data VALUES (86721, 0, 0, 0, 0, 366, 34);
INSERT INTO public.who_global_data VALUES (86722, 0, 0, 0, 0, 366, 207);
INSERT INTO public.who_global_data VALUES (86723, 0, 0, 0, 0, 366, 166);
INSERT INTO public.who_global_data VALUES (86724, 0, 0, 0, 0, 366, 126);
INSERT INTO public.who_global_data VALUES (86725, 0, 0, 0, 0, 366, 97);
INSERT INTO public.who_global_data VALUES (86726, 0, 0, 0, 0, 366, 36);
INSERT INTO public.who_global_data VALUES (86727, 0, 0, 0, 0, 366, 125);
INSERT INTO public.who_global_data VALUES (86728, 0, 0, 0, 0, 366, 124);
INSERT INTO public.who_global_data VALUES (86729, 0, 0, 0, 0, 366, 185);
INSERT INTO public.who_global_data VALUES (86730, 0, 9, 0, 0, 366, 194);
INSERT INTO public.who_global_data VALUES (86731, 0, 0, 0, 0, 366, 144);
INSERT INTO public.who_global_data VALUES (86732, 1, 16, 0, 0, 366, 19);
INSERT INTO public.who_global_data VALUES (86733, 0, 0, 0, 0, 366, 217);
INSERT INTO public.who_global_data VALUES (86734, 0, 0, 0, 0, 366, 148);
INSERT INTO public.who_global_data VALUES (86735, 0, 0, 0, 0, 366, 86);
INSERT INTO public.who_global_data VALUES (86736, 0, 0, 0, 0, 366, 13);
INSERT INTO public.who_global_data VALUES (86737, 0, 0, 0, 0, 366, 157);
INSERT INTO public.who_global_data VALUES (86738, 2, 16, 0, 0, 366, 8);
INSERT INTO public.who_global_data VALUES (86739, 0, 0, 0, 0, 366, 73);
INSERT INTO public.who_global_data VALUES (86740, 0, 0, 0, 0, 366, 101);
INSERT INTO public.who_global_data VALUES (86741, 0, 0, 0, 0, 366, 165);
INSERT INTO public.who_global_data VALUES (86742, 0, 0, 0, 0, 366, 14);
INSERT INTO public.who_global_data VALUES (86743, 0, 0, 0, 0, 367, 193);
INSERT INTO public.who_global_data VALUES (86744, 0, 0, 0, 0, 367, 113);
INSERT INTO public.who_global_data VALUES (86745, 0, 0, 0, 0, 367, 143);
INSERT INTO public.who_global_data VALUES (86746, 0, 0, 0, 0, 367, 219);
INSERT INTO public.who_global_data VALUES (86747, 0, 0, 0, 0, 367, 186);
INSERT INTO public.who_global_data VALUES (86748, 0, 0, 0, 0, 367, 52);
INSERT INTO public.who_global_data VALUES (86749, 0, 0, 0, 0, 367, 180);
INSERT INTO public.who_global_data VALUES (86750, 0, 0, 0, 0, 367, 167);
INSERT INTO public.who_global_data VALUES (86751, 0, 0, 0, 0, 367, 154);
INSERT INTO public.who_global_data VALUES (86752, 0, 0, 0, 0, 367, 94);
INSERT INTO public.who_global_data VALUES (86753, 0, 0, 0, 0, 367, 66);
INSERT INTO public.who_global_data VALUES (86754, 1, 18, 0, 0, 367, 58);
INSERT INTO public.who_global_data VALUES (86755, 0, 0, 0, 0, 367, 163);
INSERT INTO public.who_global_data VALUES (86756, 0, 0, 0, 0, 367, 37);
INSERT INTO public.who_global_data VALUES (86757, 0, 0, 0, 0, 367, 142);
INSERT INTO public.who_global_data VALUES (86758, 0, 0, 0, 0, 367, 83);
INSERT INTO public.who_global_data VALUES (86759, 0, 0, 0, 0, 367, 228);
INSERT INTO public.who_global_data VALUES (86760, 0, 0, 0, 0, 367, 188);
INSERT INTO public.who_global_data VALUES (86761, 0, 0, 0, 0, 367, 62);
INSERT INTO public.who_global_data VALUES (86762, 0, 1, 0, 0, 367, 160);
INSERT INTO public.who_global_data VALUES (86763, 0, 0, 0, 0, 367, 50);
INSERT INTO public.who_global_data VALUES (86764, 0, 0, 0, 0, 367, 33);
INSERT INTO public.who_global_data VALUES (86765, 0, 0, 0, 0, 367, 183);
INSERT INTO public.who_global_data VALUES (86766, 0, 0, 0, 0, 367, 92);
INSERT INTO public.who_global_data VALUES (86767, 0, 0, 0, 0, 367, 158);
INSERT INTO public.who_global_data VALUES (86768, 0, 0, 0, 0, 367, 67);
INSERT INTO public.who_global_data VALUES (86769, 0, 0, 0, 0, 367, 57);
INSERT INTO public.who_global_data VALUES (86770, 0, 0, 0, 0, 367, 38);
INSERT INTO public.who_global_data VALUES (86771, 0, 0, 0, 0, 367, 141);
INSERT INTO public.who_global_data VALUES (86772, 0, 0, 0, 0, 367, 178);
INSERT INTO public.who_global_data VALUES (86773, 0, 0, 0, 0, 367, 108);
INSERT INTO public.who_global_data VALUES (86774, 0, 0, 0, 0, 367, 39);
INSERT INTO public.who_global_data VALUES (86775, 0, 0, 0, 0, 367, 2);
INSERT INTO public.who_global_data VALUES (86776, 0, 0, 0, 0, 367, 195);
INSERT INTO public.who_global_data VALUES (86777, 0, 0, 0, 0, 367, 107);
INSERT INTO public.who_global_data VALUES (86778, 0, 5, 0, 0, 367, 161);
INSERT INTO public.who_global_data VALUES (86779, 0, 0, 0, 0, 367, 212);
INSERT INTO public.who_global_data VALUES (86780, 1, 9, 0, 0, 367, 181);
INSERT INTO public.who_global_data VALUES (86781, 0, 0, 0, 0, 367, 53);
INSERT INTO public.who_global_data VALUES (86782, 0, 0, 0, 0, 367, 164);
INSERT INTO public.who_global_data VALUES (86783, 0, 0, 0, 0, 367, 140);
INSERT INTO public.who_global_data VALUES (86784, 0, 0, 0, 0, 367, 20);
INSERT INTO public.who_global_data VALUES (86785, 3892, 24367, 66, 491, 367, 112);
INSERT INTO public.who_global_data VALUES (86786, 0, 0, 0, 0, 367, 111);
INSERT INTO public.who_global_data VALUES (86787, 0, 0, 0, 0, 367, 71);
INSERT INTO public.who_global_data VALUES (86788, 0, 0, 0, 0, 367, 218);
INSERT INTO public.who_global_data VALUES (86789, 0, 0, 0, 0, 367, 43);
INSERT INTO public.who_global_data VALUES (86790, 0, 0, 0, 0, 367, 49);
INSERT INTO public.who_global_data VALUES (86791, 0, 0, 0, 0, 367, 1);
INSERT INTO public.who_global_data VALUES (86792, 0, 0, 0, 0, 367, 48);
INSERT INTO public.who_global_data VALUES (86793, 0, 0, 0, 0, 367, 232);
INSERT INTO public.who_global_data VALUES (86794, 0, 0, 0, 0, 367, 175);
INSERT INTO public.who_global_data VALUES (86795, 0, 0, 0, 0, 367, 21);
INSERT INTO public.who_global_data VALUES (86796, 0, 0, 0, 0, 367, 156);
INSERT INTO public.who_global_data VALUES (86797, 0, 0, 0, 0, 367, 95);
INSERT INTO public.who_global_data VALUES (86798, 0, 0, 0, 0, 367, 177);
INSERT INTO public.who_global_data VALUES (86799, 0, 0, 0, 0, 367, 210);
INSERT INTO public.who_global_data VALUES (86800, 0, 0, 0, 0, 367, 120);
INSERT INTO public.who_global_data VALUES (86801, 0, 0, 0, 0, 367, 135);
INSERT INTO public.who_global_data VALUES (86802, 0, 0, 0, 0, 367, 206);
INSERT INTO public.who_global_data VALUES (86803, 0, 0, 0, 0, 367, 189);
INSERT INTO public.who_global_data VALUES (86804, 0, 0, 0, 0, 367, 129);
INSERT INTO public.who_global_data VALUES (86805, 0, 0, 0, 0, 367, 121);
INSERT INTO public.who_global_data VALUES (86806, 0, 0, 0, 0, 367, 59);
INSERT INTO public.who_global_data VALUES (86807, 0, 0, 0, 0, 367, 96);
INSERT INTO public.who_global_data VALUES (86808, 0, 0, 0, 0, 367, 41);
INSERT INTO public.who_global_data VALUES (86809, 0, 0, 0, 0, 367, 216);
INSERT INTO public.who_global_data VALUES (86810, 0, 0, 0, 0, 367, 236);
INSERT INTO public.who_global_data VALUES (86811, 0, 0, 0, 0, 367, 150);
INSERT INTO public.who_global_data VALUES (86812, 0, 0, 0, 0, 367, 61);
INSERT INTO public.who_global_data VALUES (86813, 0, 0, 0, 0, 367, 7);
INSERT INTO public.who_global_data VALUES (86814, 0, 1, 0, 0, 367, 169);
INSERT INTO public.who_global_data VALUES (86815, 0, 6, 0, 0, 367, 28);
INSERT INTO public.who_global_data VALUES (86816, 0, 0, 0, 0, 367, 85);
INSERT INTO public.who_global_data VALUES (86817, 0, 0, 0, 0, 367, 211);
INSERT INTO public.who_global_data VALUES (86818, 0, 0, 0, 0, 367, 60);
INSERT INTO public.who_global_data VALUES (86819, 0, 0, 0, 0, 367, 3);
INSERT INTO public.who_global_data VALUES (86820, 0, 0, 0, 0, 367, 11);
INSERT INTO public.who_global_data VALUES (86821, 0, 11, 0, 0, 367, 89);
INSERT INTO public.who_global_data VALUES (86822, 0, 0, 0, 0, 367, 24);
INSERT INTO public.who_global_data VALUES (86823, 0, 0, 0, 0, 367, 162);
INSERT INTO public.who_global_data VALUES (86824, 0, 0, 0, 0, 367, 100);
INSERT INTO public.who_global_data VALUES (86825, 0, 0, 0, 0, 367, 47);
INSERT INTO public.who_global_data VALUES (86826, 0, 0, 0, 0, 367, 29);
INSERT INTO public.who_global_data VALUES (86827, 0, 0, 0, 0, 367, 40);
INSERT INTO public.who_global_data VALUES (86828, 0, 0, 0, 0, 367, 222);
INSERT INTO public.who_global_data VALUES (86829, 0, 0, 0, 0, 367, 132);
INSERT INTO public.who_global_data VALUES (86830, 0, 0, 0, 0, 367, 130);
INSERT INTO public.who_global_data VALUES (86831, 0, 0, 0, 0, 367, 234);
INSERT INTO public.who_global_data VALUES (86832, 0, 0, 0, 0, 367, 23);
INSERT INTO public.who_global_data VALUES (86833, 0, 0, 0, 0, 367, 192);
INSERT INTO public.who_global_data VALUES (86834, 0, 0, 0, 0, 367, 69);
INSERT INTO public.who_global_data VALUES (86835, 0, 0, 0, 0, 367, 187);
INSERT INTO public.who_global_data VALUES (86836, 0, 0, 0, 0, 367, 230);
INSERT INTO public.who_global_data VALUES (86837, 0, 0, 0, 0, 367, 77);
INSERT INTO public.who_global_data VALUES (86838, 0, 0, 0, 0, 367, 9);
INSERT INTO public.who_global_data VALUES (86839, 0, 7, 0, 0, 367, 74);
INSERT INTO public.who_global_data VALUES (86840, 0, 0, 0, 0, 367, 224);
INSERT INTO public.who_global_data VALUES (86841, 0, 0, 0, 0, 367, 199);
INSERT INTO public.who_global_data VALUES (86842, 0, 0, 0, 0, 367, 190);
INSERT INTO public.who_global_data VALUES (86843, 0, 0, 0, 0, 367, 12);
INSERT INTO public.who_global_data VALUES (86844, 0, 0, 0, 0, 367, 104);
INSERT INTO public.who_global_data VALUES (86845, 0, 0, 0, 0, 367, 153);
INSERT INTO public.who_global_data VALUES (86846, 0, 3, 0, 0, 367, 91);
INSERT INTO public.who_global_data VALUES (86847, 0, 0, 0, 0, 367, 215);
INSERT INTO public.who_global_data VALUES (86848, 2, 29, 0, 0, 367, 84);
INSERT INTO public.who_global_data VALUES (86849, 0, 0, 0, 0, 367, 231);
INSERT INTO public.who_global_data VALUES (86850, 0, 0, 0, 0, 367, 196);
INSERT INTO public.who_global_data VALUES (86851, 0, 0, 0, 0, 367, 105);
INSERT INTO public.who_global_data VALUES (86852, 0, 0, 0, 0, 367, 122);
INSERT INTO public.who_global_data VALUES (86853, 0, 0, 0, 0, 367, 159);
INSERT INTO public.who_global_data VALUES (86854, 0, 0, 0, 0, 367, 75);
INSERT INTO public.who_global_data VALUES (86855, 0, 0, 0, 0, 367, 27);
INSERT INTO public.who_global_data VALUES (86856, 0, 0, 0, 0, 367, 54);
INSERT INTO public.who_global_data VALUES (86857, 0, 0, 0, 0, 367, 226);
INSERT INTO public.who_global_data VALUES (86858, 0, 0, 0, 0, 367, 79);
INSERT INTO public.who_global_data VALUES (86859, 0, 0, 0, 0, 367, 56);
INSERT INTO public.who_global_data VALUES (86860, 0, 0, 0, 0, 367, 117);
INSERT INTO public.who_global_data VALUES (86861, 0, 0, 0, 0, 367, 152);
INSERT INTO public.who_global_data VALUES (86862, 0, 0, 0, 0, 367, 16);
INSERT INTO public.who_global_data VALUES (86863, 0, 0, 0, 0, 367, 10);
INSERT INTO public.who_global_data VALUES (86864, 0, 0, 0, 0, 367, 201);
INSERT INTO public.who_global_data VALUES (86865, 0, 0, 0, 0, 367, 174);
INSERT INTO public.who_global_data VALUES (86866, 0, 0, 0, 0, 367, 119);
INSERT INTO public.who_global_data VALUES (86867, 0, 0, 0, 0, 367, 168);
INSERT INTO public.who_global_data VALUES (86868, 2, 16, 0, 0, 367, 99);
INSERT INTO public.who_global_data VALUES (86869, 0, 0, 0, 0, 367, 171);
INSERT INTO public.who_global_data VALUES (86870, 0, 0, 0, 0, 367, 87);
INSERT INTO public.who_global_data VALUES (86871, 0, 0, 0, 0, 367, 123);
INSERT INTO public.who_global_data VALUES (86872, 0, 0, 0, 0, 367, 151);
INSERT INTO public.who_global_data VALUES (86873, 0, 0, 0, 0, 367, 213);
INSERT INTO public.who_global_data VALUES (86874, 0, 0, 0, 0, 367, 118);
INSERT INTO public.who_global_data VALUES (86875, 0, 0, 0, 0, 367, 134);
INSERT INTO public.who_global_data VALUES (86876, 0, 0, 0, 0, 367, 65);
INSERT INTO public.who_global_data VALUES (86877, 0, 0, 0, 0, 367, 102);
INSERT INTO public.who_global_data VALUES (86878, 0, 0, 0, 0, 367, 223);
INSERT INTO public.who_global_data VALUES (86879, 0, 0, 0, 0, 367, 4);
INSERT INTO public.who_global_data VALUES (86880, 0, 0, 0, 0, 367, 146);
INSERT INTO public.who_global_data VALUES (86881, 0, 0, 0, 0, 367, 31);
INSERT INTO public.who_global_data VALUES (86882, 0, 0, 0, 0, 367, 127);
INSERT INTO public.who_global_data VALUES (86883, 0, 0, 0, 0, 367, 22);
INSERT INTO public.who_global_data VALUES (86884, 0, 0, 0, 0, 367, 115);
INSERT INTO public.who_global_data VALUES (86885, 0, 0, 0, 0, 367, 106);
INSERT INTO public.who_global_data VALUES (86886, 0, 0, 0, 0, 367, 90);
INSERT INTO public.who_global_data VALUES (86887, 0, 0, 0, 0, 367, 70);
INSERT INTO public.who_global_data VALUES (86888, 0, 5, 0, 0, 367, 46);
INSERT INTO public.who_global_data VALUES (86889, 0, 0, 0, 0, 367, 139);
INSERT INTO public.who_global_data VALUES (86890, 0, 0, 0, 0, 367, 42);
INSERT INTO public.who_global_data VALUES (86891, 0, 0, 0, 0, 367, 80);
INSERT INTO public.who_global_data VALUES (86892, 0, 0, 0, 0, 367, 203);
INSERT INTO public.who_global_data VALUES (86893, 0, 0, 0, 0, 367, 136);
INSERT INTO public.who_global_data VALUES (86894, 0, 0, 0, 0, 367, 63);
INSERT INTO public.who_global_data VALUES (86895, 0, 0, 0, 0, 367, 17);
INSERT INTO public.who_global_data VALUES (86896, 0, 0, 0, 0, 367, 172);
INSERT INTO public.who_global_data VALUES (86897, 0, 0, 0, 0, 367, 109);
INSERT INTO public.who_global_data VALUES (86898, 0, 0, 0, 0, 367, 200);
INSERT INTO public.who_global_data VALUES (86899, 0, 0, 0, 0, 367, 93);
INSERT INTO public.who_global_data VALUES (86900, 0, 0, 0, 0, 367, 5);
INSERT INTO public.who_global_data VALUES (86901, 14, 14, 0, 0, 367, 214);
INSERT INTO public.who_global_data VALUES (86902, 0, 0, 0, 0, 367, 204);
INSERT INTO public.who_global_data VALUES (86903, 0, 0, 0, 0, 367, 198);
INSERT INTO public.who_global_data VALUES (86904, 0, 0, 0, 0, 367, 173);
INSERT INTO public.who_global_data VALUES (86905, 0, 0, 0, 0, 367, 229);
INSERT INTO public.who_global_data VALUES (86906, 0, 0, 0, 0, 367, 76);
INSERT INTO public.who_global_data VALUES (86907, 0, 0, 0, 0, 367, 138);
INSERT INTO public.who_global_data VALUES (86908, 0, 7, 0, 1, 367, 98);
INSERT INTO public.who_global_data VALUES (86909, 0, 0, 0, 0, 367, 103);
INSERT INTO public.who_global_data VALUES (86910, 0, 0, 0, 0, 367, 225);
INSERT INTO public.who_global_data VALUES (86911, 0, 0, 0, 0, 367, 131);
INSERT INTO public.who_global_data VALUES (86912, 0, 0, 0, 0, 367, 235);
INSERT INTO public.who_global_data VALUES (86913, 0, 0, 0, 0, 367, 137);
INSERT INTO public.who_global_data VALUES (86914, 2, 22, 0, 0, 367, 81);
INSERT INTO public.who_global_data VALUES (86915, 0, 0, 0, 0, 367, 182);
INSERT INTO public.who_global_data VALUES (86916, 0, 0, 0, 0, 367, 145);
INSERT INTO public.who_global_data VALUES (86917, 0, 0, 0, 0, 367, 26);
INSERT INTO public.who_global_data VALUES (86918, 0, 2, 0, 0, 367, 170);
INSERT INTO public.who_global_data VALUES (86919, 0, 0, 0, 0, 367, 191);
INSERT INTO public.who_global_data VALUES (86920, 0, 0, 0, 0, 367, 221);
INSERT INTO public.who_global_data VALUES (86921, 0, 0, 0, 0, 367, 64);
INSERT INTO public.who_global_data VALUES (86922, 0, 0, 0, 0, 367, 116);
INSERT INTO public.who_global_data VALUES (86923, 0, 0, 0, 0, 367, 128);
INSERT INTO public.who_global_data VALUES (86924, 0, 0, 0, 0, 367, 6);
INSERT INTO public.who_global_data VALUES (86925, 0, 0, 0, 0, 367, 227);
INSERT INTO public.who_global_data VALUES (86926, 0, 0, 0, 0, 367, 68);
INSERT INTO public.who_global_data VALUES (86927, 0, 0, 0, 0, 367, 184);
INSERT INTO public.who_global_data VALUES (86928, 0, 0, 0, 0, 367, 82);
INSERT INTO public.who_global_data VALUES (86929, 0, 0, 0, 0, 367, 149);
INSERT INTO public.who_global_data VALUES (86930, 0, 0, 0, 0, 367, 197);
INSERT INTO public.who_global_data VALUES (86931, 0, 0, 0, 0, 367, 78);
INSERT INTO public.who_global_data VALUES (86932, 0, 0, 0, 0, 367, 233);
INSERT INTO public.who_global_data VALUES (86933, 0, 0, 0, 0, 367, 133);
INSERT INTO public.who_global_data VALUES (86934, 0, 0, 0, 0, 367, 35);
INSERT INTO public.who_global_data VALUES (86935, 0, 0, 0, 0, 367, 114);
INSERT INTO public.who_global_data VALUES (86936, 4, 32, 0, 0, 367, 237);
INSERT INTO public.who_global_data VALUES (86937, 0, 0, 0, 0, 367, 55);
INSERT INTO public.who_global_data VALUES (86938, 0, 0, 0, 0, 367, 176);
INSERT INTO public.who_global_data VALUES (86939, 0, 0, 0, 0, 367, 202);
INSERT INTO public.who_global_data VALUES (86940, 0, 0, 0, 0, 367, 155);
INSERT INTO public.who_global_data VALUES (86941, 0, 0, 0, 0, 367, 32);
INSERT INTO public.who_global_data VALUES (86942, 0, 0, 0, 0, 367, 220);
INSERT INTO public.who_global_data VALUES (86943, 0, 0, 0, 0, 367, 30);
INSERT INTO public.who_global_data VALUES (86944, 0, 0, 0, 0, 367, 147);
INSERT INTO public.who_global_data VALUES (86945, 0, 23, 0, 0, 367, 208);
INSERT INTO public.who_global_data VALUES (86946, 0, 5, 0, 0, 367, 45);
INSERT INTO public.who_global_data VALUES (86947, 0, 0, 0, 0, 367, 110);
INSERT INTO public.who_global_data VALUES (86948, 0, 0, 0, 0, 367, 88);
INSERT INTO public.who_global_data VALUES (86949, 0, 1, 0, 0, 367, 51);
INSERT INTO public.who_global_data VALUES (86950, 0, 0, 0, 0, 367, 209);
INSERT INTO public.who_global_data VALUES (86951, 0, 0, 0, 0, 367, 205);
INSERT INTO public.who_global_data VALUES (86952, 0, 0, 0, 0, 367, 18);
INSERT INTO public.who_global_data VALUES (86953, 0, 29, 0, 0, 367, 72);
INSERT INTO public.who_global_data VALUES (86954, 1, 3, 0, 0, 367, 44);
INSERT INTO public.who_global_data VALUES (86955, 0, 0, 0, 0, 367, 15);
INSERT INTO public.who_global_data VALUES (86956, 0, 0, 0, 0, 367, 25);
INSERT INTO public.who_global_data VALUES (86957, 0, 0, 0, 0, 367, 179);
INSERT INTO public.who_global_data VALUES (86958, 0, 0, 0, 0, 367, 34);
INSERT INTO public.who_global_data VALUES (86959, 0, 0, 0, 0, 367, 207);
INSERT INTO public.who_global_data VALUES (86960, 0, 0, 0, 0, 367, 166);
INSERT INTO public.who_global_data VALUES (86961, 0, 0, 0, 0, 367, 126);
INSERT INTO public.who_global_data VALUES (86962, 0, 0, 0, 0, 367, 97);
INSERT INTO public.who_global_data VALUES (86963, 0, 0, 0, 0, 367, 36);
INSERT INTO public.who_global_data VALUES (86964, 0, 0, 0, 0, 367, 125);
INSERT INTO public.who_global_data VALUES (86965, 0, 0, 0, 0, 367, 124);
INSERT INTO public.who_global_data VALUES (86966, 0, 0, 0, 0, 367, 185);
INSERT INTO public.who_global_data VALUES (86967, 0, 9, 0, 0, 367, 194);
INSERT INTO public.who_global_data VALUES (86968, 0, 0, 0, 0, 367, 144);
INSERT INTO public.who_global_data VALUES (86969, 0, 15, 0, 0, 367, 19);
INSERT INTO public.who_global_data VALUES (86970, 0, 0, 0, 0, 367, 217);
INSERT INTO public.who_global_data VALUES (86971, 0, 0, 0, 0, 367, 148);
INSERT INTO public.who_global_data VALUES (86972, 0, 0, 0, 0, 367, 86);
INSERT INTO public.who_global_data VALUES (86973, 0, 0, 0, 0, 367, 13);
INSERT INTO public.who_global_data VALUES (86974, 0, 0, 0, 0, 367, 157);
INSERT INTO public.who_global_data VALUES (86975, 0, 14, 0, 0, 367, 8);
INSERT INTO public.who_global_data VALUES (86976, 0, 0, 0, 0, 367, 73);
INSERT INTO public.who_global_data VALUES (86977, 0, 0, 0, 0, 367, 101);
INSERT INTO public.who_global_data VALUES (86978, 0, 0, 0, 0, 367, 165);
INSERT INTO public.who_global_data VALUES (86979, 0, 0, 0, 0, 367, 14);
INSERT INTO public.who_global_data VALUES (86980, 0, 0, 0, 0, 368, 193);
INSERT INTO public.who_global_data VALUES (86981, 0, 0, 0, 0, 368, 113);
INSERT INTO public.who_global_data VALUES (86982, 0, 0, 0, 0, 368, 143);
INSERT INTO public.who_global_data VALUES (86983, 0, 0, 0, 0, 368, 219);
INSERT INTO public.who_global_data VALUES (86984, 0, 0, 0, 0, 368, 186);
INSERT INTO public.who_global_data VALUES (86985, 0, 0, 0, 0, 368, 52);
INSERT INTO public.who_global_data VALUES (86986, 0, 0, 0, 0, 368, 180);
INSERT INTO public.who_global_data VALUES (86987, 0, 0, 0, 0, 368, 167);
INSERT INTO public.who_global_data VALUES (86988, 0, 0, 0, 0, 368, 154);
INSERT INTO public.who_global_data VALUES (86989, 0, 0, 0, 0, 368, 94);
INSERT INTO public.who_global_data VALUES (86990, 0, 0, 0, 0, 368, 66);
INSERT INTO public.who_global_data VALUES (86991, 1, 17, 0, 0, 368, 58);
INSERT INTO public.who_global_data VALUES (86992, 0, 0, 0, 0, 368, 163);
INSERT INTO public.who_global_data VALUES (86993, 0, 0, 0, 0, 368, 37);
INSERT INTO public.who_global_data VALUES (86994, 0, 0, 0, 0, 368, 142);
INSERT INTO public.who_global_data VALUES (86995, 0, 0, 0, 0, 368, 83);
INSERT INTO public.who_global_data VALUES (86996, 0, 0, 0, 0, 368, 228);
INSERT INTO public.who_global_data VALUES (86997, 0, 0, 0, 0, 368, 188);
INSERT INTO public.who_global_data VALUES (86998, 0, 0, 0, 0, 368, 62);
INSERT INTO public.who_global_data VALUES (86999, 1, 1, 0, 0, 368, 160);
INSERT INTO public.who_global_data VALUES (87000, 0, 0, 0, 0, 368, 50);
INSERT INTO public.who_global_data VALUES (87001, 0, 0, 0, 0, 368, 33);
INSERT INTO public.who_global_data VALUES (87002, 0, 0, 0, 0, 368, 183);
INSERT INTO public.who_global_data VALUES (87003, 0, 0, 0, 0, 368, 92);
INSERT INTO public.who_global_data VALUES (87004, 0, 0, 0, 0, 368, 158);
INSERT INTO public.who_global_data VALUES (87005, 0, 0, 0, 0, 368, 67);
INSERT INTO public.who_global_data VALUES (87006, 0, 0, 0, 0, 368, 57);
INSERT INTO public.who_global_data VALUES (87007, 0, 0, 0, 0, 368, 38);
INSERT INTO public.who_global_data VALUES (87008, 0, 0, 0, 0, 368, 141);
INSERT INTO public.who_global_data VALUES (87009, 0, 0, 0, 0, 368, 178);
INSERT INTO public.who_global_data VALUES (87010, 0, 0, 0, 0, 368, 108);
INSERT INTO public.who_global_data VALUES (87011, 0, 0, 0, 0, 368, 39);
INSERT INTO public.who_global_data VALUES (87012, 0, 0, 0, 0, 368, 2);
INSERT INTO public.who_global_data VALUES (87013, 0, 0, 0, 0, 368, 195);
INSERT INTO public.who_global_data VALUES (87014, 0, 0, 0, 0, 368, 107);
INSERT INTO public.who_global_data VALUES (87015, 0, 5, 0, 0, 368, 161);
INSERT INTO public.who_global_data VALUES (87016, 0, 0, 0, 0, 368, 212);
INSERT INTO public.who_global_data VALUES (87017, 0, 8, 0, 0, 368, 181);
INSERT INTO public.who_global_data VALUES (87018, 0, 0, 0, 0, 368, 53);
INSERT INTO public.who_global_data VALUES (87019, 0, 0, 0, 0, 368, 164);
INSERT INTO public.who_global_data VALUES (87020, 0, 0, 0, 0, 368, 140);
INSERT INTO public.who_global_data VALUES (87021, 0, 0, 0, 0, 368, 20);
INSERT INTO public.who_global_data VALUES (87022, 3233, 20475, 64, 425, 368, 112);
INSERT INTO public.who_global_data VALUES (87023, 0, 0, 0, 0, 368, 111);
INSERT INTO public.who_global_data VALUES (87024, 0, 0, 0, 0, 368, 71);
INSERT INTO public.who_global_data VALUES (87025, 0, 0, 0, 0, 368, 218);
INSERT INTO public.who_global_data VALUES (87026, 0, 0, 0, 0, 368, 43);
INSERT INTO public.who_global_data VALUES (87027, 0, 0, 0, 0, 368, 49);
INSERT INTO public.who_global_data VALUES (87028, 0, 0, 0, 0, 368, 1);
INSERT INTO public.who_global_data VALUES (87029, 0, 0, 0, 0, 368, 48);
INSERT INTO public.who_global_data VALUES (87030, 0, 0, 0, 0, 368, 232);
INSERT INTO public.who_global_data VALUES (87031, 0, 0, 0, 0, 368, 175);
INSERT INTO public.who_global_data VALUES (87032, 0, 0, 0, 0, 368, 21);
INSERT INTO public.who_global_data VALUES (87033, 0, 0, 0, 0, 368, 156);
INSERT INTO public.who_global_data VALUES (87034, 0, 0, 0, 0, 368, 95);
INSERT INTO public.who_global_data VALUES (87035, 0, 0, 0, 0, 368, 177);
INSERT INTO public.who_global_data VALUES (87036, 0, 0, 0, 0, 368, 210);
INSERT INTO public.who_global_data VALUES (87037, 0, 0, 0, 0, 368, 120);
INSERT INTO public.who_global_data VALUES (87038, 0, 0, 0, 0, 368, 135);
INSERT INTO public.who_global_data VALUES (87039, 0, 0, 0, 0, 368, 206);
INSERT INTO public.who_global_data VALUES (87040, 0, 0, 0, 0, 368, 189);
INSERT INTO public.who_global_data VALUES (87041, 0, 0, 0, 0, 368, 129);
INSERT INTO public.who_global_data VALUES (87042, 0, 0, 0, 0, 368, 121);
INSERT INTO public.who_global_data VALUES (87043, 0, 0, 0, 0, 368, 59);
INSERT INTO public.who_global_data VALUES (87044, 0, 0, 0, 0, 368, 96);
INSERT INTO public.who_global_data VALUES (87045, 0, 0, 0, 0, 368, 41);
INSERT INTO public.who_global_data VALUES (87046, 0, 0, 0, 0, 368, 216);
INSERT INTO public.who_global_data VALUES (87047, 0, 0, 0, 0, 368, 236);
INSERT INTO public.who_global_data VALUES (87048, 0, 0, 0, 0, 368, 150);
INSERT INTO public.who_global_data VALUES (87049, 0, 0, 0, 0, 368, 61);
INSERT INTO public.who_global_data VALUES (87050, 0, 0, 0, 0, 368, 7);
INSERT INTO public.who_global_data VALUES (87051, 0, 1, 0, 0, 368, 169);
INSERT INTO public.who_global_data VALUES (87052, 0, 6, 0, 0, 368, 28);
INSERT INTO public.who_global_data VALUES (87053, 0, 0, 0, 0, 368, 85);
INSERT INTO public.who_global_data VALUES (87054, 0, 0, 0, 0, 368, 211);
INSERT INTO public.who_global_data VALUES (87055, 0, 0, 0, 0, 368, 60);
INSERT INTO public.who_global_data VALUES (87056, 0, 0, 0, 0, 368, 3);
INSERT INTO public.who_global_data VALUES (87057, 0, 0, 0, 0, 368, 11);
INSERT INTO public.who_global_data VALUES (87058, 2, 11, 0, 0, 368, 89);
INSERT INTO public.who_global_data VALUES (87059, 0, 0, 0, 0, 368, 24);
INSERT INTO public.who_global_data VALUES (87060, 0, 0, 0, 0, 368, 162);
INSERT INTO public.who_global_data VALUES (87061, 0, 0, 0, 0, 368, 100);
INSERT INTO public.who_global_data VALUES (87062, 0, 0, 0, 0, 368, 47);
INSERT INTO public.who_global_data VALUES (87063, 0, 0, 0, 0, 368, 29);
INSERT INTO public.who_global_data VALUES (87064, 0, 0, 0, 0, 368, 40);
INSERT INTO public.who_global_data VALUES (87065, 0, 0, 0, 0, 368, 222);
INSERT INTO public.who_global_data VALUES (87066, 0, 0, 0, 0, 368, 132);
INSERT INTO public.who_global_data VALUES (87067, 0, 0, 0, 0, 368, 130);
INSERT INTO public.who_global_data VALUES (87068, 0, 0, 0, 0, 368, 234);
INSERT INTO public.who_global_data VALUES (87069, 0, 0, 0, 0, 368, 23);
INSERT INTO public.who_global_data VALUES (87070, 0, 0, 0, 0, 368, 192);
INSERT INTO public.who_global_data VALUES (87071, 0, 0, 0, 0, 368, 69);
INSERT INTO public.who_global_data VALUES (87072, 0, 0, 0, 0, 368, 187);
INSERT INTO public.who_global_data VALUES (87073, 0, 0, 0, 0, 368, 230);
INSERT INTO public.who_global_data VALUES (87074, 0, 0, 0, 0, 368, 77);
INSERT INTO public.who_global_data VALUES (87075, 0, 0, 0, 0, 368, 9);
INSERT INTO public.who_global_data VALUES (87076, 0, 7, 0, 0, 368, 74);
INSERT INTO public.who_global_data VALUES (87077, 0, 0, 0, 0, 368, 224);
INSERT INTO public.who_global_data VALUES (87078, 0, 0, 0, 0, 368, 199);
INSERT INTO public.who_global_data VALUES (87079, 0, 0, 0, 0, 368, 190);
INSERT INTO public.who_global_data VALUES (87080, 0, 0, 0, 0, 368, 12);
INSERT INTO public.who_global_data VALUES (87081, 0, 0, 0, 0, 368, 104);
INSERT INTO public.who_global_data VALUES (87082, 0, 0, 0, 0, 368, 153);
INSERT INTO public.who_global_data VALUES (87083, 0, 3, 0, 0, 368, 91);
INSERT INTO public.who_global_data VALUES (87084, 0, 0, 0, 0, 368, 215);
INSERT INTO public.who_global_data VALUES (87085, 3, 27, 0, 0, 368, 84);
INSERT INTO public.who_global_data VALUES (87086, 0, 0, 0, 0, 368, 231);
INSERT INTO public.who_global_data VALUES (87087, 0, 0, 0, 0, 368, 196);
INSERT INTO public.who_global_data VALUES (87088, 0, 0, 0, 0, 368, 105);
INSERT INTO public.who_global_data VALUES (87089, 0, 0, 0, 0, 368, 122);
INSERT INTO public.who_global_data VALUES (87090, 0, 0, 0, 0, 368, 159);
INSERT INTO public.who_global_data VALUES (87091, 0, 0, 0, 0, 368, 75);
INSERT INTO public.who_global_data VALUES (87092, 0, 0, 0, 0, 368, 27);
INSERT INTO public.who_global_data VALUES (87093, 0, 0, 0, 0, 368, 54);
INSERT INTO public.who_global_data VALUES (87094, 0, 0, 0, 0, 368, 226);
INSERT INTO public.who_global_data VALUES (87095, 0, 0, 0, 0, 368, 79);
INSERT INTO public.who_global_data VALUES (87096, 0, 0, 0, 0, 368, 56);
INSERT INTO public.who_global_data VALUES (87097, 0, 0, 0, 0, 368, 117);
INSERT INTO public.who_global_data VALUES (87098, 0, 0, 0, 0, 368, 152);
INSERT INTO public.who_global_data VALUES (87099, 0, 0, 0, 0, 368, 16);
INSERT INTO public.who_global_data VALUES (87100, 0, 0, 0, 0, 368, 10);
INSERT INTO public.who_global_data VALUES (87101, 0, 0, 0, 0, 368, 201);
INSERT INTO public.who_global_data VALUES (87102, 0, 0, 0, 0, 368, 174);
INSERT INTO public.who_global_data VALUES (87103, 0, 0, 0, 0, 368, 119);
INSERT INTO public.who_global_data VALUES (87104, 0, 0, 0, 0, 368, 168);
INSERT INTO public.who_global_data VALUES (87105, 2, 14, 0, 0, 368, 99);
INSERT INTO public.who_global_data VALUES (87106, 0, 0, 0, 0, 368, 171);
INSERT INTO public.who_global_data VALUES (87107, 0, 0, 0, 0, 368, 87);
INSERT INTO public.who_global_data VALUES (87108, 0, 0, 0, 0, 368, 123);
INSERT INTO public.who_global_data VALUES (87109, 0, 0, 0, 0, 368, 151);
INSERT INTO public.who_global_data VALUES (87110, 0, 0, 0, 0, 368, 213);
INSERT INTO public.who_global_data VALUES (87111, 0, 0, 0, 0, 368, 118);
INSERT INTO public.who_global_data VALUES (87112, 0, 0, 0, 0, 368, 134);
INSERT INTO public.who_global_data VALUES (87113, 0, 0, 0, 0, 368, 65);
INSERT INTO public.who_global_data VALUES (87114, 0, 0, 0, 0, 368, 102);
INSERT INTO public.who_global_data VALUES (87115, 0, 0, 0, 0, 368, 223);
INSERT INTO public.who_global_data VALUES (87116, 0, 0, 0, 0, 368, 4);
INSERT INTO public.who_global_data VALUES (87117, 0, 0, 0, 0, 368, 146);
INSERT INTO public.who_global_data VALUES (87118, 0, 0, 0, 0, 368, 31);
INSERT INTO public.who_global_data VALUES (87119, 0, 0, 0, 0, 368, 127);
INSERT INTO public.who_global_data VALUES (87120, 0, 0, 0, 0, 368, 22);
INSERT INTO public.who_global_data VALUES (87121, 0, 0, 0, 0, 368, 115);
INSERT INTO public.who_global_data VALUES (87122, 0, 0, 0, 0, 368, 106);
INSERT INTO public.who_global_data VALUES (87123, 0, 0, 0, 0, 368, 90);
INSERT INTO public.who_global_data VALUES (87124, 0, 0, 0, 0, 368, 70);
INSERT INTO public.who_global_data VALUES (87125, 0, 5, 0, 0, 368, 46);
INSERT INTO public.who_global_data VALUES (87126, 0, 0, 0, 0, 368, 139);
INSERT INTO public.who_global_data VALUES (87127, 0, 0, 0, 0, 368, 42);
INSERT INTO public.who_global_data VALUES (87128, 0, 0, 0, 0, 368, 80);
INSERT INTO public.who_global_data VALUES (87129, 0, 0, 0, 0, 368, 203);
INSERT INTO public.who_global_data VALUES (87130, 0, 0, 0, 0, 368, 136);
INSERT INTO public.who_global_data VALUES (87131, 0, 0, 0, 0, 368, 63);
INSERT INTO public.who_global_data VALUES (87132, 0, 0, 0, 0, 368, 17);
INSERT INTO public.who_global_data VALUES (87133, 0, 0, 0, 0, 368, 172);
INSERT INTO public.who_global_data VALUES (87134, 0, 0, 0, 0, 368, 109);
INSERT INTO public.who_global_data VALUES (87135, 0, 0, 0, 0, 368, 200);
INSERT INTO public.who_global_data VALUES (87136, 0, 0, 0, 0, 368, 93);
INSERT INTO public.who_global_data VALUES (87137, 0, 0, 0, 0, 368, 5);
INSERT INTO public.who_global_data VALUES (87138, 0, 0, 0, 0, 368, 214);
INSERT INTO public.who_global_data VALUES (87139, 0, 0, 0, 0, 368, 204);
INSERT INTO public.who_global_data VALUES (87140, 0, 0, 0, 0, 368, 198);
INSERT INTO public.who_global_data VALUES (87141, 0, 0, 0, 0, 368, 173);
INSERT INTO public.who_global_data VALUES (87142, 0, 0, 0, 0, 368, 229);
INSERT INTO public.who_global_data VALUES (87143, 0, 0, 0, 0, 368, 76);
INSERT INTO public.who_global_data VALUES (87144, 0, 0, 0, 0, 368, 138);
INSERT INTO public.who_global_data VALUES (87145, 1, 7, 0, 1, 368, 98);
INSERT INTO public.who_global_data VALUES (87146, 0, 0, 0, 0, 368, 103);
INSERT INTO public.who_global_data VALUES (87147, 0, 0, 0, 0, 368, 225);
INSERT INTO public.who_global_data VALUES (87148, 0, 0, 0, 0, 368, 131);
INSERT INTO public.who_global_data VALUES (87149, 0, 0, 0, 0, 368, 235);
INSERT INTO public.who_global_data VALUES (87150, 0, 0, 0, 0, 368, 137);
INSERT INTO public.who_global_data VALUES (87151, 1, 20, 0, 0, 368, 81);
INSERT INTO public.who_global_data VALUES (87152, 0, 0, 0, 0, 368, 182);
INSERT INTO public.who_global_data VALUES (87153, 0, 0, 0, 0, 368, 145);
INSERT INTO public.who_global_data VALUES (87154, 0, 0, 0, 0, 368, 26);
INSERT INTO public.who_global_data VALUES (87155, 0, 2, 0, 0, 368, 170);
INSERT INTO public.who_global_data VALUES (87156, 0, 0, 0, 0, 368, 191);
INSERT INTO public.who_global_data VALUES (87157, 0, 0, 0, 0, 368, 221);
INSERT INTO public.who_global_data VALUES (87158, 0, 0, 0, 0, 368, 64);
INSERT INTO public.who_global_data VALUES (87159, 0, 0, 0, 0, 368, 116);
INSERT INTO public.who_global_data VALUES (87160, 0, 0, 0, 0, 368, 128);
INSERT INTO public.who_global_data VALUES (87161, 0, 0, 0, 0, 368, 6);
INSERT INTO public.who_global_data VALUES (87162, 0, 0, 0, 0, 368, 227);
INSERT INTO public.who_global_data VALUES (87163, 0, 0, 0, 0, 368, 68);
INSERT INTO public.who_global_data VALUES (87164, 0, 0, 0, 0, 368, 184);
INSERT INTO public.who_global_data VALUES (87165, 0, 0, 0, 0, 368, 82);
INSERT INTO public.who_global_data VALUES (87166, 0, 0, 0, 0, 368, 149);
INSERT INTO public.who_global_data VALUES (87167, 0, 0, 0, 0, 368, 197);
INSERT INTO public.who_global_data VALUES (87168, 0, 0, 0, 0, 368, 78);
INSERT INTO public.who_global_data VALUES (87169, 0, 0, 0, 0, 368, 233);
INSERT INTO public.who_global_data VALUES (87170, 0, 0, 0, 0, 368, 133);
INSERT INTO public.who_global_data VALUES (87171, 0, 0, 0, 0, 368, 35);
INSERT INTO public.who_global_data VALUES (87172, 0, 0, 0, 0, 368, 114);
INSERT INTO public.who_global_data VALUES (87173, 6, 28, 0, 0, 368, 237);
INSERT INTO public.who_global_data VALUES (87174, 0, 0, 0, 0, 368, 55);
INSERT INTO public.who_global_data VALUES (87175, 0, 0, 0, 0, 368, 176);
INSERT INTO public.who_global_data VALUES (87176, 0, 0, 0, 0, 368, 202);
INSERT INTO public.who_global_data VALUES (87177, 0, 0, 0, 0, 368, 155);
INSERT INTO public.who_global_data VALUES (87178, 0, 0, 0, 0, 368, 32);
INSERT INTO public.who_global_data VALUES (87179, 0, 0, 0, 0, 368, 220);
INSERT INTO public.who_global_data VALUES (87180, 0, 0, 0, 0, 368, 30);
INSERT INTO public.who_global_data VALUES (87181, 0, 0, 0, 0, 368, 147);
INSERT INTO public.who_global_data VALUES (87182, 0, 23, 0, 0, 368, 208);
INSERT INTO public.who_global_data VALUES (87183, 0, 5, 0, 0, 368, 45);
INSERT INTO public.who_global_data VALUES (87184, 0, 0, 0, 0, 368, 110);
INSERT INTO public.who_global_data VALUES (87185, 0, 0, 0, 0, 368, 88);
INSERT INTO public.who_global_data VALUES (87186, 0, 1, 0, 0, 368, 51);
INSERT INTO public.who_global_data VALUES (87187, 0, 0, 0, 0, 368, 209);
INSERT INTO public.who_global_data VALUES (87188, 0, 0, 0, 0, 368, 205);
INSERT INTO public.who_global_data VALUES (87189, 0, 0, 0, 0, 368, 18);
INSERT INTO public.who_global_data VALUES (87190, 6, 29, 0, 0, 368, 72);
INSERT INTO public.who_global_data VALUES (87191, 0, 2, 0, 0, 368, 44);
INSERT INTO public.who_global_data VALUES (87192, 0, 0, 0, 0, 368, 15);
INSERT INTO public.who_global_data VALUES (87193, 0, 0, 0, 0, 368, 25);
INSERT INTO public.who_global_data VALUES (87194, 0, 0, 0, 0, 368, 179);
INSERT INTO public.who_global_data VALUES (87195, 0, 0, 0, 0, 368, 34);
INSERT INTO public.who_global_data VALUES (87196, 0, 0, 0, 0, 368, 207);
INSERT INTO public.who_global_data VALUES (87197, 0, 0, 0, 0, 368, 166);
INSERT INTO public.who_global_data VALUES (87198, 0, 0, 0, 0, 368, 126);
INSERT INTO public.who_global_data VALUES (87199, 0, 0, 0, 0, 368, 97);
INSERT INTO public.who_global_data VALUES (87200, 0, 0, 0, 0, 368, 36);
INSERT INTO public.who_global_data VALUES (87201, 0, 0, 0, 0, 368, 125);
INSERT INTO public.who_global_data VALUES (87202, 0, 0, 0, 0, 368, 124);
INSERT INTO public.who_global_data VALUES (87203, 0, 0, 0, 0, 368, 185);
INSERT INTO public.who_global_data VALUES (87204, 0, 9, 0, 0, 368, 194);
INSERT INTO public.who_global_data VALUES (87205, 0, 0, 0, 0, 368, 144);
INSERT INTO public.who_global_data VALUES (87206, 0, 15, 0, 0, 368, 19);
INSERT INTO public.who_global_data VALUES (87207, 0, 0, 0, 0, 368, 217);
INSERT INTO public.who_global_data VALUES (87208, 0, 0, 0, 0, 368, 148);
INSERT INTO public.who_global_data VALUES (87209, 0, 0, 0, 0, 368, 86);
INSERT INTO public.who_global_data VALUES (87210, 0, 0, 0, 0, 368, 13);
INSERT INTO public.who_global_data VALUES (87211, 0, 0, 0, 0, 368, 157);
INSERT INTO public.who_global_data VALUES (87212, 2, 14, 0, 0, 368, 8);
INSERT INTO public.who_global_data VALUES (87213, 0, 0, 0, 0, 368, 73);
INSERT INTO public.who_global_data VALUES (87214, 0, 0, 0, 0, 368, 101);
INSERT INTO public.who_global_data VALUES (87215, 0, 0, 0, 0, 368, 165);
INSERT INTO public.who_global_data VALUES (87216, 0, 0, 0, 0, 368, 14);
INSERT INTO public.who_global_data VALUES (87217, 0, 0, 0, 0, 369, 193);
INSERT INTO public.who_global_data VALUES (87218, 0, 0, 0, 0, 369, 113);
INSERT INTO public.who_global_data VALUES (87219, 0, 0, 0, 0, 369, 143);
INSERT INTO public.who_global_data VALUES (87220, 0, 0, 0, 0, 369, 219);
INSERT INTO public.who_global_data VALUES (87221, 0, 0, 0, 0, 369, 186);
INSERT INTO public.who_global_data VALUES (87222, 0, 0, 0, 0, 369, 52);
INSERT INTO public.who_global_data VALUES (87223, 0, 0, 0, 0, 369, 180);
INSERT INTO public.who_global_data VALUES (87224, 0, 0, 0, 0, 369, 167);
INSERT INTO public.who_global_data VALUES (87225, 0, 0, 0, 0, 369, 154);
INSERT INTO public.who_global_data VALUES (87226, 0, 0, 0, 0, 369, 94);
INSERT INTO public.who_global_data VALUES (87227, 0, 0, 0, 0, 369, 66);
INSERT INTO public.who_global_data VALUES (87228, 0, 16, 0, 0, 369, 58);
INSERT INTO public.who_global_data VALUES (87229, 0, 0, 0, 0, 369, 163);
INSERT INTO public.who_global_data VALUES (87230, 0, 0, 0, 0, 369, 37);
INSERT INTO public.who_global_data VALUES (87231, 0, 0, 0, 0, 369, 142);
INSERT INTO public.who_global_data VALUES (87232, 0, 0, 0, 0, 369, 83);
INSERT INTO public.who_global_data VALUES (87233, 0, 0, 0, 0, 369, 228);
INSERT INTO public.who_global_data VALUES (87234, 0, 0, 0, 0, 369, 188);
INSERT INTO public.who_global_data VALUES (87235, 0, 0, 0, 0, 369, 62);
INSERT INTO public.who_global_data VALUES (87236, 0, 0, 0, 0, 369, 160);
INSERT INTO public.who_global_data VALUES (87237, 0, 0, 0, 0, 369, 50);
INSERT INTO public.who_global_data VALUES (87238, 0, 0, 0, 0, 369, 33);
INSERT INTO public.who_global_data VALUES (87239, 0, 0, 0, 0, 369, 183);
INSERT INTO public.who_global_data VALUES (87240, 0, 0, 0, 0, 369, 92);
INSERT INTO public.who_global_data VALUES (87241, 0, 0, 0, 0, 369, 158);
INSERT INTO public.who_global_data VALUES (87242, 0, 0, 0, 0, 369, 67);
INSERT INTO public.who_global_data VALUES (87243, 0, 0, 0, 0, 369, 57);
INSERT INTO public.who_global_data VALUES (87244, 0, 0, 0, 0, 369, 38);
INSERT INTO public.who_global_data VALUES (87245, 0, 0, 0, 0, 369, 141);
INSERT INTO public.who_global_data VALUES (87246, 0, 0, 0, 0, 369, 178);
INSERT INTO public.who_global_data VALUES (87247, 0, 0, 0, 0, 369, 108);
INSERT INTO public.who_global_data VALUES (87248, 0, 0, 0, 0, 369, 39);
INSERT INTO public.who_global_data VALUES (87249, 0, 0, 0, 0, 369, 2);
INSERT INTO public.who_global_data VALUES (87250, 0, 0, 0, 0, 369, 195);
INSERT INTO public.who_global_data VALUES (87251, 0, 0, 0, 0, 369, 107);
INSERT INTO public.who_global_data VALUES (87252, 0, 5, 0, 0, 369, 161);
INSERT INTO public.who_global_data VALUES (87253, 0, 0, 0, 0, 369, 212);
INSERT INTO public.who_global_data VALUES (87254, 0, 8, 0, 0, 369, 181);
INSERT INTO public.who_global_data VALUES (87255, 0, 0, 0, 0, 369, 53);
INSERT INTO public.who_global_data VALUES (87256, 0, 0, 0, 0, 369, 164);
INSERT INTO public.who_global_data VALUES (87257, 0, 0, 0, 0, 369, 140);
INSERT INTO public.who_global_data VALUES (87258, 0, 0, 0, 0, 369, 20);
INSERT INTO public.who_global_data VALUES (87259, 2827, 17242, 57, 361, 369, 112);
INSERT INTO public.who_global_data VALUES (87260, 0, 0, 0, 0, 369, 111);
INSERT INTO public.who_global_data VALUES (87261, 0, 0, 0, 0, 369, 71);
INSERT INTO public.who_global_data VALUES (87262, 0, 0, 0, 0, 369, 218);
INSERT INTO public.who_global_data VALUES (87263, 0, 0, 0, 0, 369, 43);
INSERT INTO public.who_global_data VALUES (87264, 0, 0, 0, 0, 369, 49);
INSERT INTO public.who_global_data VALUES (87265, 0, 0, 0, 0, 369, 1);
INSERT INTO public.who_global_data VALUES (87266, 0, 0, 0, 0, 369, 48);
INSERT INTO public.who_global_data VALUES (87267, 0, 0, 0, 0, 369, 232);
INSERT INTO public.who_global_data VALUES (87268, 0, 0, 0, 0, 369, 175);
INSERT INTO public.who_global_data VALUES (87269, 0, 0, 0, 0, 369, 21);
INSERT INTO public.who_global_data VALUES (87270, 0, 0, 0, 0, 369, 156);
INSERT INTO public.who_global_data VALUES (87271, 0, 0, 0, 0, 369, 95);
INSERT INTO public.who_global_data VALUES (87272, 0, 0, 0, 0, 369, 177);
INSERT INTO public.who_global_data VALUES (87273, 0, 0, 0, 0, 369, 210);
INSERT INTO public.who_global_data VALUES (87274, 0, 0, 0, 0, 369, 120);
INSERT INTO public.who_global_data VALUES (87275, 0, 0, 0, 0, 369, 135);
INSERT INTO public.who_global_data VALUES (87276, 0, 0, 0, 0, 369, 206);
INSERT INTO public.who_global_data VALUES (87277, 0, 0, 0, 0, 369, 189);
INSERT INTO public.who_global_data VALUES (87278, 0, 0, 0, 0, 369, 129);
INSERT INTO public.who_global_data VALUES (87279, 0, 0, 0, 0, 369, 121);
INSERT INTO public.who_global_data VALUES (87280, 0, 0, 0, 0, 369, 59);
INSERT INTO public.who_global_data VALUES (87281, 0, 0, 0, 0, 369, 96);
INSERT INTO public.who_global_data VALUES (87282, 0, 0, 0, 0, 369, 41);
INSERT INTO public.who_global_data VALUES (87283, 0, 0, 0, 0, 369, 216);
INSERT INTO public.who_global_data VALUES (87284, 0, 0, 0, 0, 369, 236);
INSERT INTO public.who_global_data VALUES (87285, 0, 0, 0, 0, 369, 150);
INSERT INTO public.who_global_data VALUES (87286, 0, 0, 0, 0, 369, 61);
INSERT INTO public.who_global_data VALUES (87287, 0, 0, 0, 0, 369, 7);
INSERT INTO public.who_global_data VALUES (87288, 0, 1, 0, 0, 369, 169);
INSERT INTO public.who_global_data VALUES (87289, 0, 6, 0, 0, 369, 28);
INSERT INTO public.who_global_data VALUES (87290, 0, 0, 0, 0, 369, 85);
INSERT INTO public.who_global_data VALUES (87291, 0, 0, 0, 0, 369, 211);
INSERT INTO public.who_global_data VALUES (87292, 0, 0, 0, 0, 369, 60);
INSERT INTO public.who_global_data VALUES (87293, 0, 0, 0, 0, 369, 3);
INSERT INTO public.who_global_data VALUES (87294, 0, 0, 0, 0, 369, 11);
INSERT INTO public.who_global_data VALUES (87295, 1, 9, 0, 0, 369, 89);
INSERT INTO public.who_global_data VALUES (87296, 0, 0, 0, 0, 369, 24);
INSERT INTO public.who_global_data VALUES (87297, 0, 0, 0, 0, 369, 162);
INSERT INTO public.who_global_data VALUES (87298, 0, 0, 0, 0, 369, 100);
INSERT INTO public.who_global_data VALUES (87299, 0, 0, 0, 0, 369, 47);
INSERT INTO public.who_global_data VALUES (87300, 0, 0, 0, 0, 369, 29);
INSERT INTO public.who_global_data VALUES (87301, 0, 0, 0, 0, 369, 40);
INSERT INTO public.who_global_data VALUES (87302, 0, 0, 0, 0, 369, 222);
INSERT INTO public.who_global_data VALUES (87303, 0, 0, 0, 0, 369, 132);
INSERT INTO public.who_global_data VALUES (87304, 0, 0, 0, 0, 369, 130);
INSERT INTO public.who_global_data VALUES (87305, 0, 0, 0, 0, 369, 234);
INSERT INTO public.who_global_data VALUES (87306, 0, 0, 0, 0, 369, 23);
INSERT INTO public.who_global_data VALUES (87307, 0, 0, 0, 0, 369, 192);
INSERT INTO public.who_global_data VALUES (87308, 0, 0, 0, 0, 369, 69);
INSERT INTO public.who_global_data VALUES (87309, 0, 0, 0, 0, 369, 187);
INSERT INTO public.who_global_data VALUES (87310, 0, 0, 0, 0, 369, 230);
INSERT INTO public.who_global_data VALUES (87311, 0, 0, 0, 0, 369, 77);
INSERT INTO public.who_global_data VALUES (87312, 0, 0, 0, 0, 369, 9);
INSERT INTO public.who_global_data VALUES (87313, 1, 7, 0, 0, 369, 74);
INSERT INTO public.who_global_data VALUES (87314, 0, 0, 0, 0, 369, 224);
INSERT INTO public.who_global_data VALUES (87315, 0, 0, 0, 0, 369, 199);
INSERT INTO public.who_global_data VALUES (87316, 0, 0, 0, 0, 369, 190);
INSERT INTO public.who_global_data VALUES (87317, 0, 0, 0, 0, 369, 12);
INSERT INTO public.who_global_data VALUES (87318, 0, 0, 0, 0, 369, 104);
INSERT INTO public.who_global_data VALUES (87319, 0, 0, 0, 0, 369, 153);
INSERT INTO public.who_global_data VALUES (87320, 0, 3, 0, 0, 369, 91);
INSERT INTO public.who_global_data VALUES (87321, 0, 0, 0, 0, 369, 215);
INSERT INTO public.who_global_data VALUES (87322, 0, 24, 0, 0, 369, 84);
INSERT INTO public.who_global_data VALUES (87323, 0, 0, 0, 0, 369, 231);
INSERT INTO public.who_global_data VALUES (87324, 0, 0, 0, 0, 369, 196);
INSERT INTO public.who_global_data VALUES (87325, 0, 0, 0, 0, 369, 105);
INSERT INTO public.who_global_data VALUES (87326, 0, 0, 0, 0, 369, 122);
INSERT INTO public.who_global_data VALUES (87327, 0, 0, 0, 0, 369, 159);
INSERT INTO public.who_global_data VALUES (87328, 0, 0, 0, 0, 369, 75);
INSERT INTO public.who_global_data VALUES (87329, 0, 0, 0, 0, 369, 27);
INSERT INTO public.who_global_data VALUES (87330, 0, 0, 0, 0, 369, 54);
INSERT INTO public.who_global_data VALUES (87331, 0, 0, 0, 0, 369, 226);
INSERT INTO public.who_global_data VALUES (87332, 0, 0, 0, 0, 369, 79);
INSERT INTO public.who_global_data VALUES (87333, 0, 0, 0, 0, 369, 56);
INSERT INTO public.who_global_data VALUES (87334, 0, 0, 0, 0, 369, 117);
INSERT INTO public.who_global_data VALUES (87335, 0, 0, 0, 0, 369, 152);
INSERT INTO public.who_global_data VALUES (87336, 0, 0, 0, 0, 369, 16);
INSERT INTO public.who_global_data VALUES (87337, 0, 0, 0, 0, 369, 10);
INSERT INTO public.who_global_data VALUES (87338, 0, 0, 0, 0, 369, 201);
INSERT INTO public.who_global_data VALUES (87339, 0, 0, 0, 0, 369, 174);
INSERT INTO public.who_global_data VALUES (87340, 0, 0, 0, 0, 369, 119);
INSERT INTO public.who_global_data VALUES (87341, 0, 0, 0, 0, 369, 168);
INSERT INTO public.who_global_data VALUES (87342, 0, 12, 0, 0, 369, 99);
INSERT INTO public.who_global_data VALUES (87343, 0, 0, 0, 0, 369, 171);
INSERT INTO public.who_global_data VALUES (87344, 0, 0, 0, 0, 369, 87);
INSERT INTO public.who_global_data VALUES (87345, 0, 0, 0, 0, 369, 123);
INSERT INTO public.who_global_data VALUES (87346, 0, 0, 0, 0, 369, 151);
INSERT INTO public.who_global_data VALUES (87347, 0, 0, 0, 0, 369, 213);
INSERT INTO public.who_global_data VALUES (87348, 0, 0, 0, 0, 369, 118);
INSERT INTO public.who_global_data VALUES (87349, 0, 0, 0, 0, 369, 134);
INSERT INTO public.who_global_data VALUES (87350, 0, 0, 0, 0, 369, 65);
INSERT INTO public.who_global_data VALUES (87351, 0, 0, 0, 0, 369, 102);
INSERT INTO public.who_global_data VALUES (87352, 0, 0, 0, 0, 369, 223);
INSERT INTO public.who_global_data VALUES (87353, 0, 0, 0, 0, 369, 4);
INSERT INTO public.who_global_data VALUES (87354, 0, 0, 0, 0, 369, 146);
INSERT INTO public.who_global_data VALUES (87355, 0, 0, 0, 0, 369, 31);
INSERT INTO public.who_global_data VALUES (87356, 0, 0, 0, 0, 369, 127);
INSERT INTO public.who_global_data VALUES (87357, 0, 0, 0, 0, 369, 22);
INSERT INTO public.who_global_data VALUES (87358, 0, 0, 0, 0, 369, 115);
INSERT INTO public.who_global_data VALUES (87359, 0, 0, 0, 0, 369, 106);
INSERT INTO public.who_global_data VALUES (87360, 0, 0, 0, 0, 369, 90);
INSERT INTO public.who_global_data VALUES (87361, 0, 0, 0, 0, 369, 70);
INSERT INTO public.who_global_data VALUES (87362, 0, 5, 0, 0, 369, 46);
INSERT INTO public.who_global_data VALUES (87363, 0, 0, 0, 0, 369, 139);
INSERT INTO public.who_global_data VALUES (87364, 0, 0, 0, 0, 369, 42);
INSERT INTO public.who_global_data VALUES (87365, 0, 0, 0, 0, 369, 80);
INSERT INTO public.who_global_data VALUES (87366, 0, 0, 0, 0, 369, 203);
INSERT INTO public.who_global_data VALUES (87367, 0, 0, 0, 0, 369, 136);
INSERT INTO public.who_global_data VALUES (87368, 0, 0, 0, 0, 369, 63);
INSERT INTO public.who_global_data VALUES (87369, 0, 0, 0, 0, 369, 17);
INSERT INTO public.who_global_data VALUES (87370, 0, 0, 0, 0, 369, 172);
INSERT INTO public.who_global_data VALUES (87371, 0, 0, 0, 0, 369, 109);
INSERT INTO public.who_global_data VALUES (87372, 0, 0, 0, 0, 369, 200);
INSERT INTO public.who_global_data VALUES (87373, 0, 0, 0, 0, 369, 93);
INSERT INTO public.who_global_data VALUES (87374, 0, 0, 0, 0, 369, 5);
INSERT INTO public.who_global_data VALUES (87375, 0, 0, 0, 0, 369, 214);
INSERT INTO public.who_global_data VALUES (87376, 0, 0, 0, 0, 369, 204);
INSERT INTO public.who_global_data VALUES (87377, 0, 0, 0, 0, 369, 198);
INSERT INTO public.who_global_data VALUES (87378, 0, 0, 0, 0, 369, 173);
INSERT INTO public.who_global_data VALUES (87379, 0, 0, 0, 0, 369, 229);
INSERT INTO public.who_global_data VALUES (87380, 0, 0, 0, 0, 369, 76);
INSERT INTO public.who_global_data VALUES (87381, 0, 0, 0, 0, 369, 138);
INSERT INTO public.who_global_data VALUES (87382, 0, 6, 0, 1, 369, 98);
INSERT INTO public.who_global_data VALUES (87383, 0, 0, 0, 0, 369, 103);
INSERT INTO public.who_global_data VALUES (87384, 0, 0, 0, 0, 369, 225);
INSERT INTO public.who_global_data VALUES (87385, 0, 0, 0, 0, 369, 131);
INSERT INTO public.who_global_data VALUES (87386, 0, 0, 0, 0, 369, 235);
INSERT INTO public.who_global_data VALUES (87387, 0, 0, 0, 0, 369, 137);
INSERT INTO public.who_global_data VALUES (87388, 0, 19, 0, 0, 369, 81);
INSERT INTO public.who_global_data VALUES (87389, 0, 0, 0, 0, 369, 182);
INSERT INTO public.who_global_data VALUES (87390, 0, 0, 0, 0, 369, 145);
INSERT INTO public.who_global_data VALUES (87391, 0, 0, 0, 0, 369, 26);
INSERT INTO public.who_global_data VALUES (87392, 0, 2, 0, 0, 369, 170);
INSERT INTO public.who_global_data VALUES (87393, 0, 0, 0, 0, 369, 191);
INSERT INTO public.who_global_data VALUES (87394, 0, 0, 0, 0, 369, 221);
INSERT INTO public.who_global_data VALUES (87395, 0, 0, 0, 0, 369, 64);
INSERT INTO public.who_global_data VALUES (87396, 0, 0, 0, 0, 369, 116);
INSERT INTO public.who_global_data VALUES (87397, 0, 0, 0, 0, 369, 128);
INSERT INTO public.who_global_data VALUES (87398, 0, 0, 0, 0, 369, 6);
INSERT INTO public.who_global_data VALUES (87399, 0, 0, 0, 0, 369, 227);
INSERT INTO public.who_global_data VALUES (87400, 0, 0, 0, 0, 369, 68);
INSERT INTO public.who_global_data VALUES (87401, 0, 0, 0, 0, 369, 184);
INSERT INTO public.who_global_data VALUES (87402, 0, 0, 0, 0, 369, 82);
INSERT INTO public.who_global_data VALUES (87403, 0, 0, 0, 0, 369, 149);
INSERT INTO public.who_global_data VALUES (87404, 0, 0, 0, 0, 369, 197);
INSERT INTO public.who_global_data VALUES (87405, 0, 0, 0, 0, 369, 78);
INSERT INTO public.who_global_data VALUES (87406, 0, 0, 0, 0, 369, 233);
INSERT INTO public.who_global_data VALUES (87407, 0, 0, 0, 0, 369, 133);
INSERT INTO public.who_global_data VALUES (87408, 0, 0, 0, 0, 369, 35);
INSERT INTO public.who_global_data VALUES (87409, 0, 0, 0, 0, 369, 114);
INSERT INTO public.who_global_data VALUES (87410, 0, 22, 0, 0, 369, 237);
INSERT INTO public.who_global_data VALUES (87411, 0, 0, 0, 0, 369, 55);
INSERT INTO public.who_global_data VALUES (87412, 0, 0, 0, 0, 369, 176);
INSERT INTO public.who_global_data VALUES (87413, 0, 0, 0, 0, 369, 202);
INSERT INTO public.who_global_data VALUES (87414, 0, 0, 0, 0, 369, 155);
INSERT INTO public.who_global_data VALUES (87415, 0, 0, 0, 0, 369, 32);
INSERT INTO public.who_global_data VALUES (87416, 0, 0, 0, 0, 369, 220);
INSERT INTO public.who_global_data VALUES (87417, 0, 0, 0, 0, 369, 30);
INSERT INTO public.who_global_data VALUES (87418, 0, 0, 0, 0, 369, 147);
INSERT INTO public.who_global_data VALUES (87419, 0, 23, 0, 0, 369, 208);
INSERT INTO public.who_global_data VALUES (87420, 0, 5, 0, 0, 369, 45);
INSERT INTO public.who_global_data VALUES (87421, 0, 0, 0, 0, 369, 110);
INSERT INTO public.who_global_data VALUES (87422, 0, 0, 0, 0, 369, 88);
INSERT INTO public.who_global_data VALUES (87423, 0, 1, 0, 0, 369, 51);
INSERT INTO public.who_global_data VALUES (87424, 0, 0, 0, 0, 369, 209);
INSERT INTO public.who_global_data VALUES (87425, 0, 0, 0, 0, 369, 205);
INSERT INTO public.who_global_data VALUES (87426, 0, 0, 0, 0, 369, 18);
INSERT INTO public.who_global_data VALUES (87427, 0, 23, 0, 0, 369, 72);
INSERT INTO public.who_global_data VALUES (87428, 0, 2, 0, 0, 369, 44);
INSERT INTO public.who_global_data VALUES (87429, 0, 0, 0, 0, 369, 15);
INSERT INTO public.who_global_data VALUES (87430, 0, 0, 0, 0, 369, 25);
INSERT INTO public.who_global_data VALUES (87431, 0, 0, 0, 0, 369, 179);
INSERT INTO public.who_global_data VALUES (87432, 0, 0, 0, 0, 369, 34);
INSERT INTO public.who_global_data VALUES (87433, 0, 0, 0, 0, 369, 207);
INSERT INTO public.who_global_data VALUES (87434, 0, 0, 0, 0, 369, 166);
INSERT INTO public.who_global_data VALUES (87435, 0, 0, 0, 0, 369, 126);
INSERT INTO public.who_global_data VALUES (87436, 0, 0, 0, 0, 369, 97);
INSERT INTO public.who_global_data VALUES (87437, 0, 0, 0, 0, 369, 36);
INSERT INTO public.who_global_data VALUES (87438, 0, 0, 0, 0, 369, 125);
INSERT INTO public.who_global_data VALUES (87439, 0, 0, 0, 0, 369, 124);
INSERT INTO public.who_global_data VALUES (87440, 0, 0, 0, 0, 369, 185);
INSERT INTO public.who_global_data VALUES (87441, 0, 9, 0, 0, 369, 194);
INSERT INTO public.who_global_data VALUES (87442, 0, 0, 0, 0, 369, 144);
INSERT INTO public.who_global_data VALUES (87443, 3, 15, 0, 0, 369, 19);
INSERT INTO public.who_global_data VALUES (87444, 0, 0, 0, 0, 369, 217);
INSERT INTO public.who_global_data VALUES (87445, 0, 0, 0, 0, 369, 148);
INSERT INTO public.who_global_data VALUES (87446, 0, 0, 0, 0, 369, 86);
INSERT INTO public.who_global_data VALUES (87447, 0, 0, 0, 0, 369, 13);
INSERT INTO public.who_global_data VALUES (87448, 0, 0, 0, 0, 369, 157);
INSERT INTO public.who_global_data VALUES (87449, 1, 12, 0, 0, 369, 8);
INSERT INTO public.who_global_data VALUES (87450, 0, 0, 0, 0, 369, 73);
INSERT INTO public.who_global_data VALUES (87451, 0, 0, 0, 0, 369, 101);
INSERT INTO public.who_global_data VALUES (87452, 0, 0, 0, 0, 369, 165);
INSERT INTO public.who_global_data VALUES (87453, 0, 0, 0, 0, 369, 14);
INSERT INTO public.who_global_data VALUES (87454, 0, 0, 0, 0, 370, 193);
INSERT INTO public.who_global_data VALUES (87455, 0, 0, 0, 0, 370, 113);
INSERT INTO public.who_global_data VALUES (87456, 0, 0, 0, 0, 370, 143);
INSERT INTO public.who_global_data VALUES (87457, 0, 0, 0, 0, 370, 219);
INSERT INTO public.who_global_data VALUES (87458, 0, 0, 0, 0, 370, 186);
INSERT INTO public.who_global_data VALUES (87459, 0, 0, 0, 0, 370, 52);
INSERT INTO public.who_global_data VALUES (87460, 0, 0, 0, 0, 370, 180);
INSERT INTO public.who_global_data VALUES (87461, 0, 0, 0, 0, 370, 167);
INSERT INTO public.who_global_data VALUES (87462, 0, 0, 0, 0, 370, 154);
INSERT INTO public.who_global_data VALUES (87463, 0, 0, 0, 0, 370, 94);
INSERT INTO public.who_global_data VALUES (87464, 0, 0, 0, 0, 370, 66);
INSERT INTO public.who_global_data VALUES (87465, 0, 16, 0, 0, 370, 58);
INSERT INTO public.who_global_data VALUES (87466, 0, 0, 0, 0, 370, 163);
INSERT INTO public.who_global_data VALUES (87467, 0, 0, 0, 0, 370, 37);
INSERT INTO public.who_global_data VALUES (87468, 0, 0, 0, 0, 370, 142);
INSERT INTO public.who_global_data VALUES (87469, 0, 0, 0, 0, 370, 83);
INSERT INTO public.who_global_data VALUES (87470, 0, 0, 0, 0, 370, 228);
INSERT INTO public.who_global_data VALUES (87471, 0, 0, 0, 0, 370, 188);
INSERT INTO public.who_global_data VALUES (87472, 0, 0, 0, 0, 370, 62);
INSERT INTO public.who_global_data VALUES (87473, 0, 0, 0, 0, 370, 160);
INSERT INTO public.who_global_data VALUES (87474, 0, 0, 0, 0, 370, 50);
INSERT INTO public.who_global_data VALUES (87475, 0, 0, 0, 0, 370, 33);
INSERT INTO public.who_global_data VALUES (87476, 0, 0, 0, 0, 370, 183);
INSERT INTO public.who_global_data VALUES (87477, 0, 0, 0, 0, 370, 92);
INSERT INTO public.who_global_data VALUES (87478, 0, 0, 0, 0, 370, 158);
INSERT INTO public.who_global_data VALUES (87479, 0, 0, 0, 0, 370, 67);
INSERT INTO public.who_global_data VALUES (87480, 0, 0, 0, 0, 370, 57);
INSERT INTO public.who_global_data VALUES (87481, 0, 0, 0, 0, 370, 38);
INSERT INTO public.who_global_data VALUES (87482, 0, 0, 0, 0, 370, 141);
INSERT INTO public.who_global_data VALUES (87483, 0, 0, 0, 0, 370, 178);
INSERT INTO public.who_global_data VALUES (87484, 0, 0, 0, 0, 370, 108);
INSERT INTO public.who_global_data VALUES (87485, 0, 0, 0, 0, 370, 39);
INSERT INTO public.who_global_data VALUES (87486, 0, 0, 0, 0, 370, 2);
INSERT INTO public.who_global_data VALUES (87487, 0, 0, 0, 0, 370, 195);
INSERT INTO public.who_global_data VALUES (87488, 0, 0, 0, 0, 370, 107);
INSERT INTO public.who_global_data VALUES (87489, 0, 5, 0, 0, 370, 161);
INSERT INTO public.who_global_data VALUES (87490, 0, 0, 0, 0, 370, 212);
INSERT INTO public.who_global_data VALUES (87491, 0, 8, 0, 0, 370, 181);
INSERT INTO public.who_global_data VALUES (87492, 0, 0, 0, 0, 370, 53);
INSERT INTO public.who_global_data VALUES (87493, 0, 0, 0, 0, 370, 164);
INSERT INTO public.who_global_data VALUES (87494, 0, 0, 0, 0, 370, 140);
INSERT INTO public.who_global_data VALUES (87495, 0, 0, 0, 0, 370, 20);
INSERT INTO public.who_global_data VALUES (87496, 2590, 14415, 45, 304, 370, 112);
INSERT INTO public.who_global_data VALUES (87497, 0, 0, 0, 0, 370, 111);
INSERT INTO public.who_global_data VALUES (87498, 0, 0, 0, 0, 370, 71);
INSERT INTO public.who_global_data VALUES (87499, 0, 0, 0, 0, 370, 218);
INSERT INTO public.who_global_data VALUES (87500, 0, 0, 0, 0, 370, 43);
INSERT INTO public.who_global_data VALUES (87501, 0, 0, 0, 0, 370, 49);
INSERT INTO public.who_global_data VALUES (87502, 0, 0, 0, 0, 370, 1);
INSERT INTO public.who_global_data VALUES (87503, 0, 0, 0, 0, 370, 48);
INSERT INTO public.who_global_data VALUES (87504, 0, 0, 0, 0, 370, 232);
INSERT INTO public.who_global_data VALUES (87505, 0, 0, 0, 0, 370, 175);
INSERT INTO public.who_global_data VALUES (87506, 0, 0, 0, 0, 370, 21);
INSERT INTO public.who_global_data VALUES (87507, 0, 0, 0, 0, 370, 156);
INSERT INTO public.who_global_data VALUES (87508, 0, 0, 0, 0, 370, 95);
INSERT INTO public.who_global_data VALUES (87509, 0, 0, 0, 0, 370, 177);
INSERT INTO public.who_global_data VALUES (87510, 0, 0, 0, 0, 370, 210);
INSERT INTO public.who_global_data VALUES (87511, 0, 0, 0, 0, 370, 120);
INSERT INTO public.who_global_data VALUES (87512, 0, 0, 0, 0, 370, 135);
INSERT INTO public.who_global_data VALUES (87513, 0, 0, 0, 0, 370, 206);
INSERT INTO public.who_global_data VALUES (87514, 0, 0, 0, 0, 370, 189);
INSERT INTO public.who_global_data VALUES (87515, 0, 0, 0, 0, 370, 129);
INSERT INTO public.who_global_data VALUES (87516, 0, 0, 0, 0, 370, 121);
INSERT INTO public.who_global_data VALUES (87517, 0, 0, 0, 0, 370, 59);
INSERT INTO public.who_global_data VALUES (87518, 0, 0, 0, 0, 370, 96);
INSERT INTO public.who_global_data VALUES (87519, 0, 0, 0, 0, 370, 41);
INSERT INTO public.who_global_data VALUES (87520, 0, 0, 0, 0, 370, 216);
INSERT INTO public.who_global_data VALUES (87521, 0, 0, 0, 0, 370, 236);
INSERT INTO public.who_global_data VALUES (87522, 0, 0, 0, 0, 370, 150);
INSERT INTO public.who_global_data VALUES (87523, 0, 0, 0, 0, 370, 61);
INSERT INTO public.who_global_data VALUES (87524, 0, 0, 0, 0, 370, 7);
INSERT INTO public.who_global_data VALUES (87525, 0, 1, 0, 0, 370, 169);
INSERT INTO public.who_global_data VALUES (87526, 0, 6, 0, 0, 370, 28);
INSERT INTO public.who_global_data VALUES (87527, 0, 0, 0, 0, 370, 85);
INSERT INTO public.who_global_data VALUES (87528, 0, 0, 0, 0, 370, 211);
INSERT INTO public.who_global_data VALUES (87529, 0, 0, 0, 0, 370, 60);
INSERT INTO public.who_global_data VALUES (87530, 0, 0, 0, 0, 370, 3);
INSERT INTO public.who_global_data VALUES (87531, 0, 0, 0, 0, 370, 11);
INSERT INTO public.who_global_data VALUES (87532, 1, 8, 0, 0, 370, 89);
INSERT INTO public.who_global_data VALUES (87533, 0, 0, 0, 0, 370, 24);
INSERT INTO public.who_global_data VALUES (87534, 0, 0, 0, 0, 370, 162);
INSERT INTO public.who_global_data VALUES (87535, 0, 0, 0, 0, 370, 100);
INSERT INTO public.who_global_data VALUES (87536, 0, 0, 0, 0, 370, 47);
INSERT INTO public.who_global_data VALUES (87537, 0, 0, 0, 0, 370, 29);
INSERT INTO public.who_global_data VALUES (87538, 0, 0, 0, 0, 370, 40);
INSERT INTO public.who_global_data VALUES (87539, 0, 0, 0, 0, 370, 222);
INSERT INTO public.who_global_data VALUES (87540, 0, 0, 0, 0, 370, 132);
INSERT INTO public.who_global_data VALUES (87541, 0, 0, 0, 0, 370, 130);
INSERT INTO public.who_global_data VALUES (87542, 0, 0, 0, 0, 370, 234);
INSERT INTO public.who_global_data VALUES (87543, 0, 0, 0, 0, 370, 23);
INSERT INTO public.who_global_data VALUES (87544, 0, 0, 0, 0, 370, 192);
INSERT INTO public.who_global_data VALUES (87545, 0, 0, 0, 0, 370, 69);
INSERT INTO public.who_global_data VALUES (87546, 0, 0, 0, 0, 370, 187);
INSERT INTO public.who_global_data VALUES (87547, 0, 0, 0, 0, 370, 230);
INSERT INTO public.who_global_data VALUES (87548, 0, 0, 0, 0, 370, 77);
INSERT INTO public.who_global_data VALUES (87549, 0, 0, 0, 0, 370, 9);
INSERT INTO public.who_global_data VALUES (87550, 1, 6, 0, 0, 370, 74);
INSERT INTO public.who_global_data VALUES (87551, 0, 0, 0, 0, 370, 224);
INSERT INTO public.who_global_data VALUES (87552, 0, 0, 0, 0, 370, 199);
INSERT INTO public.who_global_data VALUES (87553, 0, 0, 0, 0, 370, 190);
INSERT INTO public.who_global_data VALUES (87554, 0, 0, 0, 0, 370, 12);
INSERT INTO public.who_global_data VALUES (87555, 0, 0, 0, 0, 370, 104);
INSERT INTO public.who_global_data VALUES (87556, 0, 0, 0, 0, 370, 153);
INSERT INTO public.who_global_data VALUES (87557, 0, 3, 0, 0, 370, 91);
INSERT INTO public.who_global_data VALUES (87558, 0, 0, 0, 0, 370, 215);
INSERT INTO public.who_global_data VALUES (87559, 0, 24, 0, 0, 370, 84);
INSERT INTO public.who_global_data VALUES (87560, 0, 0, 0, 0, 370, 231);
INSERT INTO public.who_global_data VALUES (87561, 0, 0, 0, 0, 370, 196);
INSERT INTO public.who_global_data VALUES (87562, 0, 0, 0, 0, 370, 105);
INSERT INTO public.who_global_data VALUES (87563, 0, 0, 0, 0, 370, 122);
INSERT INTO public.who_global_data VALUES (87564, 0, 0, 0, 0, 370, 159);
INSERT INTO public.who_global_data VALUES (87565, 0, 0, 0, 0, 370, 75);
INSERT INTO public.who_global_data VALUES (87566, 0, 0, 0, 0, 370, 27);
INSERT INTO public.who_global_data VALUES (87567, 0, 0, 0, 0, 370, 54);
INSERT INTO public.who_global_data VALUES (87568, 0, 0, 0, 0, 370, 226);
INSERT INTO public.who_global_data VALUES (87569, 0, 0, 0, 0, 370, 79);
INSERT INTO public.who_global_data VALUES (87570, 0, 0, 0, 0, 370, 56);
INSERT INTO public.who_global_data VALUES (87571, 0, 0, 0, 0, 370, 117);
INSERT INTO public.who_global_data VALUES (87572, 0, 0, 0, 0, 370, 152);
INSERT INTO public.who_global_data VALUES (87573, 0, 0, 0, 0, 370, 16);
INSERT INTO public.who_global_data VALUES (87574, 0, 0, 0, 0, 370, 10);
INSERT INTO public.who_global_data VALUES (87575, 0, 0, 0, 0, 370, 201);
INSERT INTO public.who_global_data VALUES (87576, 0, 0, 0, 0, 370, 174);
INSERT INTO public.who_global_data VALUES (87577, 0, 0, 0, 0, 370, 119);
INSERT INTO public.who_global_data VALUES (87578, 0, 0, 0, 0, 370, 168);
INSERT INTO public.who_global_data VALUES (87579, 0, 12, 0, 0, 370, 99);
INSERT INTO public.who_global_data VALUES (87580, 0, 0, 0, 0, 370, 171);
INSERT INTO public.who_global_data VALUES (87581, 0, 0, 0, 0, 370, 87);
INSERT INTO public.who_global_data VALUES (87582, 0, 0, 0, 0, 370, 123);
INSERT INTO public.who_global_data VALUES (87583, 0, 0, 0, 0, 370, 151);
INSERT INTO public.who_global_data VALUES (87584, 0, 0, 0, 0, 370, 213);
INSERT INTO public.who_global_data VALUES (87585, 0, 0, 0, 0, 370, 118);
INSERT INTO public.who_global_data VALUES (87586, 0, 0, 0, 0, 370, 134);
INSERT INTO public.who_global_data VALUES (87587, 0, 0, 0, 0, 370, 65);
INSERT INTO public.who_global_data VALUES (87588, 0, 0, 0, 0, 370, 102);
INSERT INTO public.who_global_data VALUES (87589, 0, 0, 0, 0, 370, 223);
INSERT INTO public.who_global_data VALUES (87590, 0, 0, 0, 0, 370, 4);
INSERT INTO public.who_global_data VALUES (87591, 0, 0, 0, 0, 370, 146);
INSERT INTO public.who_global_data VALUES (87592, 0, 0, 0, 0, 370, 31);
INSERT INTO public.who_global_data VALUES (87593, 0, 0, 0, 0, 370, 127);
INSERT INTO public.who_global_data VALUES (87594, 0, 0, 0, 0, 370, 22);
INSERT INTO public.who_global_data VALUES (87595, 0, 0, 0, 0, 370, 115);
INSERT INTO public.who_global_data VALUES (87596, 0, 0, 0, 0, 370, 106);
INSERT INTO public.who_global_data VALUES (87597, 0, 0, 0, 0, 370, 90);
INSERT INTO public.who_global_data VALUES (87598, 0, 0, 0, 0, 370, 70);
INSERT INTO public.who_global_data VALUES (87599, 0, 5, 0, 0, 370, 46);
INSERT INTO public.who_global_data VALUES (87600, 0, 0, 0, 0, 370, 139);
INSERT INTO public.who_global_data VALUES (87601, 0, 0, 0, 0, 370, 42);
INSERT INTO public.who_global_data VALUES (87602, 0, 0, 0, 0, 370, 80);
INSERT INTO public.who_global_data VALUES (87603, 0, 0, 0, 0, 370, 203);
INSERT INTO public.who_global_data VALUES (87604, 0, 0, 0, 0, 370, 136);
INSERT INTO public.who_global_data VALUES (87605, 0, 0, 0, 0, 370, 63);
INSERT INTO public.who_global_data VALUES (87606, 0, 0, 0, 0, 370, 17);
INSERT INTO public.who_global_data VALUES (87607, 0, 0, 0, 0, 370, 172);
INSERT INTO public.who_global_data VALUES (87608, 0, 0, 0, 0, 370, 109);
INSERT INTO public.who_global_data VALUES (87609, 0, 0, 0, 0, 370, 200);
INSERT INTO public.who_global_data VALUES (87610, 0, 0, 0, 0, 370, 93);
INSERT INTO public.who_global_data VALUES (87611, 0, 0, 0, 0, 370, 5);
INSERT INTO public.who_global_data VALUES (87612, 0, 0, 0, 0, 370, 214);
INSERT INTO public.who_global_data VALUES (87613, 0, 0, 0, 0, 370, 204);
INSERT INTO public.who_global_data VALUES (87614, 0, 0, 0, 0, 370, 198);
INSERT INTO public.who_global_data VALUES (87615, 0, 0, 0, 0, 370, 173);
INSERT INTO public.who_global_data VALUES (87616, 0, 0, 0, 0, 370, 229);
INSERT INTO public.who_global_data VALUES (87617, 0, 0, 0, 0, 370, 76);
INSERT INTO public.who_global_data VALUES (87618, 0, 0, 0, 0, 370, 138);
INSERT INTO public.who_global_data VALUES (87619, 0, 6, 1, 1, 370, 98);
INSERT INTO public.who_global_data VALUES (87620, 0, 0, 0, 0, 370, 103);
INSERT INTO public.who_global_data VALUES (87621, 0, 0, 0, 0, 370, 225);
INSERT INTO public.who_global_data VALUES (87622, 0, 0, 0, 0, 370, 131);
INSERT INTO public.who_global_data VALUES (87623, 0, 0, 0, 0, 370, 235);
INSERT INTO public.who_global_data VALUES (87624, 0, 0, 0, 0, 370, 137);
INSERT INTO public.who_global_data VALUES (87625, 3, 19, 0, 0, 370, 81);
INSERT INTO public.who_global_data VALUES (87626, 0, 0, 0, 0, 370, 182);
INSERT INTO public.who_global_data VALUES (87627, 0, 0, 0, 0, 370, 145);
INSERT INTO public.who_global_data VALUES (87628, 0, 0, 0, 0, 370, 26);
INSERT INTO public.who_global_data VALUES (87629, 0, 2, 0, 0, 370, 170);
INSERT INTO public.who_global_data VALUES (87630, 0, 0, 0, 0, 370, 191);
INSERT INTO public.who_global_data VALUES (87631, 0, 0, 0, 0, 370, 221);
INSERT INTO public.who_global_data VALUES (87632, 0, 0, 0, 0, 370, 64);
INSERT INTO public.who_global_data VALUES (87633, 0, 0, 0, 0, 370, 116);
INSERT INTO public.who_global_data VALUES (87634, 0, 0, 0, 0, 370, 128);
INSERT INTO public.who_global_data VALUES (87635, 0, 0, 0, 0, 370, 6);
INSERT INTO public.who_global_data VALUES (87636, 0, 0, 0, 0, 370, 227);
INSERT INTO public.who_global_data VALUES (87637, 0, 0, 0, 0, 370, 68);
INSERT INTO public.who_global_data VALUES (87638, 0, 0, 0, 0, 370, 184);
INSERT INTO public.who_global_data VALUES (87639, 0, 0, 0, 0, 370, 82);
INSERT INTO public.who_global_data VALUES (87640, 0, 0, 0, 0, 370, 149);
INSERT INTO public.who_global_data VALUES (87641, 0, 0, 0, 0, 370, 197);
INSERT INTO public.who_global_data VALUES (87642, 0, 0, 0, 0, 370, 78);
INSERT INTO public.who_global_data VALUES (87643, 0, 0, 0, 0, 370, 233);
INSERT INTO public.who_global_data VALUES (87644, 0, 0, 0, 0, 370, 133);
INSERT INTO public.who_global_data VALUES (87645, 0, 0, 0, 0, 370, 35);
INSERT INTO public.who_global_data VALUES (87646, 0, 0, 0, 0, 370, 114);
INSERT INTO public.who_global_data VALUES (87647, 0, 22, 0, 0, 370, 237);
INSERT INTO public.who_global_data VALUES (87648, 0, 0, 0, 0, 370, 55);
INSERT INTO public.who_global_data VALUES (87649, 0, 0, 0, 0, 370, 176);
INSERT INTO public.who_global_data VALUES (87650, 0, 0, 0, 0, 370, 202);
INSERT INTO public.who_global_data VALUES (87651, 0, 0, 0, 0, 370, 155);
INSERT INTO public.who_global_data VALUES (87652, 0, 0, 0, 0, 370, 32);
INSERT INTO public.who_global_data VALUES (87653, 0, 0, 0, 0, 370, 220);
INSERT INTO public.who_global_data VALUES (87654, 0, 0, 0, 0, 370, 30);
INSERT INTO public.who_global_data VALUES (87655, 0, 0, 0, 0, 370, 147);
INSERT INTO public.who_global_data VALUES (87656, 23, 23, 0, 0, 370, 208);
INSERT INTO public.who_global_data VALUES (87657, 0, 5, 0, 0, 370, 45);
INSERT INTO public.who_global_data VALUES (87658, 0, 0, 0, 0, 370, 110);
INSERT INTO public.who_global_data VALUES (87659, 0, 0, 0, 0, 370, 88);
INSERT INTO public.who_global_data VALUES (87660, 0, 1, 0, 0, 370, 51);
INSERT INTO public.who_global_data VALUES (87661, 0, 0, 0, 0, 370, 209);
INSERT INTO public.who_global_data VALUES (87662, 0, 0, 0, 0, 370, 205);
INSERT INTO public.who_global_data VALUES (87663, 0, 0, 0, 0, 370, 18);
INSERT INTO public.who_global_data VALUES (87664, 0, 23, 0, 0, 370, 72);
INSERT INTO public.who_global_data VALUES (87665, 0, 2, 0, 0, 370, 44);
INSERT INTO public.who_global_data VALUES (87666, 0, 0, 0, 0, 370, 15);
INSERT INTO public.who_global_data VALUES (87667, 0, 0, 0, 0, 370, 25);
INSERT INTO public.who_global_data VALUES (87668, 0, 0, 0, 0, 370, 179);
INSERT INTO public.who_global_data VALUES (87669, 0, 0, 0, 0, 370, 34);
INSERT INTO public.who_global_data VALUES (87670, 0, 0, 0, 0, 370, 207);
INSERT INTO public.who_global_data VALUES (87671, 0, 0, 0, 0, 370, 166);
INSERT INTO public.who_global_data VALUES (87672, 0, 0, 0, 0, 370, 126);
INSERT INTO public.who_global_data VALUES (87673, 0, 0, 0, 0, 370, 97);
INSERT INTO public.who_global_data VALUES (87674, 0, 0, 0, 0, 370, 36);
INSERT INTO public.who_global_data VALUES (87675, 0, 0, 0, 0, 370, 125);
INSERT INTO public.who_global_data VALUES (87676, 0, 0, 0, 0, 370, 124);
INSERT INTO public.who_global_data VALUES (87677, 0, 0, 0, 0, 370, 185);
INSERT INTO public.who_global_data VALUES (87678, 0, 9, 0, 0, 370, 194);
INSERT INTO public.who_global_data VALUES (87679, 0, 0, 0, 0, 370, 144);
INSERT INTO public.who_global_data VALUES (87680, 0, 12, 0, 0, 370, 19);
INSERT INTO public.who_global_data VALUES (87681, 0, 0, 0, 0, 370, 217);
INSERT INTO public.who_global_data VALUES (87682, 0, 0, 0, 0, 370, 148);
INSERT INTO public.who_global_data VALUES (87683, 0, 0, 0, 0, 370, 86);
INSERT INTO public.who_global_data VALUES (87684, 0, 0, 0, 0, 370, 13);
INSERT INTO public.who_global_data VALUES (87685, 0, 0, 0, 0, 370, 157);
INSERT INTO public.who_global_data VALUES (87686, 1, 11, 0, 0, 370, 8);
INSERT INTO public.who_global_data VALUES (87687, 0, 0, 0, 0, 370, 73);
INSERT INTO public.who_global_data VALUES (87688, 0, 0, 0, 0, 370, 101);
INSERT INTO public.who_global_data VALUES (87689, 0, 0, 0, 0, 370, 165);
INSERT INTO public.who_global_data VALUES (87690, 0, 0, 0, 0, 370, 14);
INSERT INTO public.who_global_data VALUES (87691, 0, 0, 0, 0, 371, 193);
INSERT INTO public.who_global_data VALUES (87692, 0, 0, 0, 0, 371, 113);
INSERT INTO public.who_global_data VALUES (87693, 0, 0, 0, 0, 371, 143);
INSERT INTO public.who_global_data VALUES (87694, 0, 0, 0, 0, 371, 219);
INSERT INTO public.who_global_data VALUES (87695, 0, 0, 0, 0, 371, 186);
INSERT INTO public.who_global_data VALUES (87696, 0, 0, 0, 0, 371, 52);
INSERT INTO public.who_global_data VALUES (87697, 0, 0, 0, 0, 371, 180);
INSERT INTO public.who_global_data VALUES (87698, 0, 0, 0, 0, 371, 167);
INSERT INTO public.who_global_data VALUES (87699, 0, 0, 0, 0, 371, 154);
INSERT INTO public.who_global_data VALUES (87700, 0, 0, 0, 0, 371, 94);
INSERT INTO public.who_global_data VALUES (87701, 0, 0, 0, 0, 371, 66);
INSERT INTO public.who_global_data VALUES (87702, 3, 16, 0, 0, 371, 58);
INSERT INTO public.who_global_data VALUES (87703, 0, 0, 0, 0, 371, 163);
INSERT INTO public.who_global_data VALUES (87704, 0, 0, 0, 0, 371, 37);
INSERT INTO public.who_global_data VALUES (87705, 0, 0, 0, 0, 371, 142);
INSERT INTO public.who_global_data VALUES (87706, 0, 0, 0, 0, 371, 83);
INSERT INTO public.who_global_data VALUES (87707, 0, 0, 0, 0, 371, 228);
INSERT INTO public.who_global_data VALUES (87708, 0, 0, 0, 0, 371, 188);
INSERT INTO public.who_global_data VALUES (87709, 0, 0, 0, 0, 371, 62);
INSERT INTO public.who_global_data VALUES (87710, 0, 0, 0, 0, 371, 160);
INSERT INTO public.who_global_data VALUES (87711, 0, 0, 0, 0, 371, 50);
INSERT INTO public.who_global_data VALUES (87712, 0, 0, 0, 0, 371, 33);
INSERT INTO public.who_global_data VALUES (87713, 0, 0, 0, 0, 371, 183);
INSERT INTO public.who_global_data VALUES (87714, 0, 0, 0, 0, 371, 92);
INSERT INTO public.who_global_data VALUES (87715, 0, 0, 0, 0, 371, 158);
INSERT INTO public.who_global_data VALUES (87716, 0, 0, 0, 0, 371, 67);
INSERT INTO public.who_global_data VALUES (87717, 0, 0, 0, 0, 371, 57);
INSERT INTO public.who_global_data VALUES (87718, 0, 0, 0, 0, 371, 38);
INSERT INTO public.who_global_data VALUES (87719, 0, 0, 0, 0, 371, 141);
INSERT INTO public.who_global_data VALUES (87720, 0, 0, 0, 0, 371, 178);
INSERT INTO public.who_global_data VALUES (87721, 0, 0, 0, 0, 371, 108);
INSERT INTO public.who_global_data VALUES (87722, 0, 0, 0, 0, 371, 39);
INSERT INTO public.who_global_data VALUES (87723, 0, 0, 0, 0, 371, 2);
INSERT INTO public.who_global_data VALUES (87724, 0, 0, 0, 0, 371, 195);
INSERT INTO public.who_global_data VALUES (87725, 0, 0, 0, 0, 371, 107);
INSERT INTO public.who_global_data VALUES (87726, 0, 5, 0, 0, 371, 161);
INSERT INTO public.who_global_data VALUES (87727, 0, 0, 0, 0, 371, 212);
INSERT INTO public.who_global_data VALUES (87728, 0, 8, 0, 0, 371, 181);
INSERT INTO public.who_global_data VALUES (87729, 0, 0, 0, 0, 371, 53);
INSERT INTO public.who_global_data VALUES (87730, 0, 0, 0, 0, 371, 164);
INSERT INTO public.who_global_data VALUES (87731, 0, 0, 0, 0, 371, 140);
INSERT INTO public.who_global_data VALUES (87732, 0, 0, 0, 0, 371, 20);
INSERT INTO public.who_global_data VALUES (87733, 2101, 11825, 46, 259, 371, 112);
INSERT INTO public.who_global_data VALUES (87734, 0, 0, 0, 0, 371, 111);
INSERT INTO public.who_global_data VALUES (87735, 0, 0, 0, 0, 371, 71);
INSERT INTO public.who_global_data VALUES (87736, 0, 0, 0, 0, 371, 218);
INSERT INTO public.who_global_data VALUES (87737, 0, 0, 0, 0, 371, 43);
INSERT INTO public.who_global_data VALUES (87738, 0, 0, 0, 0, 371, 49);
INSERT INTO public.who_global_data VALUES (87739, 0, 0, 0, 0, 371, 1);
INSERT INTO public.who_global_data VALUES (87740, 0, 0, 0, 0, 371, 48);
INSERT INTO public.who_global_data VALUES (87741, 0, 0, 0, 0, 371, 232);
INSERT INTO public.who_global_data VALUES (87742, 0, 0, 0, 0, 371, 175);
INSERT INTO public.who_global_data VALUES (87743, 0, 0, 0, 0, 371, 21);
INSERT INTO public.who_global_data VALUES (87744, 0, 0, 0, 0, 371, 156);
INSERT INTO public.who_global_data VALUES (87745, 0, 0, 0, 0, 371, 95);
INSERT INTO public.who_global_data VALUES (87746, 0, 0, 0, 0, 371, 177);
INSERT INTO public.who_global_data VALUES (87747, 0, 0, 0, 0, 371, 210);
INSERT INTO public.who_global_data VALUES (87748, 0, 0, 0, 0, 371, 120);
INSERT INTO public.who_global_data VALUES (87749, 0, 0, 0, 0, 371, 135);
INSERT INTO public.who_global_data VALUES (87750, 0, 0, 0, 0, 371, 206);
INSERT INTO public.who_global_data VALUES (87751, 0, 0, 0, 0, 371, 189);
INSERT INTO public.who_global_data VALUES (87752, 0, 0, 0, 0, 371, 129);
INSERT INTO public.who_global_data VALUES (87753, 0, 0, 0, 0, 371, 121);
INSERT INTO public.who_global_data VALUES (87754, 0, 0, 0, 0, 371, 59);
INSERT INTO public.who_global_data VALUES (87755, 0, 0, 0, 0, 371, 96);
INSERT INTO public.who_global_data VALUES (87756, 0, 0, 0, 0, 371, 41);
INSERT INTO public.who_global_data VALUES (87757, 0, 0, 0, 0, 371, 216);
INSERT INTO public.who_global_data VALUES (87758, 0, 0, 0, 0, 371, 236);
INSERT INTO public.who_global_data VALUES (87759, 0, 0, 0, 0, 371, 150);
INSERT INTO public.who_global_data VALUES (87760, 0, 0, 0, 0, 371, 61);
INSERT INTO public.who_global_data VALUES (87761, 0, 0, 0, 0, 371, 7);
INSERT INTO public.who_global_data VALUES (87762, 0, 1, 0, 0, 371, 169);
INSERT INTO public.who_global_data VALUES (87763, 0, 6, 0, 0, 371, 28);
INSERT INTO public.who_global_data VALUES (87764, 0, 0, 0, 0, 371, 85);
INSERT INTO public.who_global_data VALUES (87765, 0, 0, 0, 0, 371, 211);
INSERT INTO public.who_global_data VALUES (87766, 0, 0, 0, 0, 371, 60);
INSERT INTO public.who_global_data VALUES (87767, 0, 0, 0, 0, 371, 3);
INSERT INTO public.who_global_data VALUES (87768, 0, 0, 0, 0, 371, 11);
INSERT INTO public.who_global_data VALUES (87769, 2, 7, 0, 0, 371, 89);
INSERT INTO public.who_global_data VALUES (87770, 0, 0, 0, 0, 371, 24);
INSERT INTO public.who_global_data VALUES (87771, 0, 0, 0, 0, 371, 162);
INSERT INTO public.who_global_data VALUES (87772, 0, 0, 0, 0, 371, 100);
INSERT INTO public.who_global_data VALUES (87773, 0, 0, 0, 0, 371, 47);
INSERT INTO public.who_global_data VALUES (87774, 0, 0, 0, 0, 371, 29);
INSERT INTO public.who_global_data VALUES (87775, 0, 0, 0, 0, 371, 40);
INSERT INTO public.who_global_data VALUES (87776, 0, 0, 0, 0, 371, 222);
INSERT INTO public.who_global_data VALUES (87777, 0, 0, 0, 0, 371, 132);
INSERT INTO public.who_global_data VALUES (87778, 0, 0, 0, 0, 371, 130);
INSERT INTO public.who_global_data VALUES (87779, 0, 0, 0, 0, 371, 234);
INSERT INTO public.who_global_data VALUES (87780, 0, 0, 0, 0, 371, 23);
INSERT INTO public.who_global_data VALUES (87781, 0, 0, 0, 0, 371, 192);
INSERT INTO public.who_global_data VALUES (87782, 0, 0, 0, 0, 371, 69);
INSERT INTO public.who_global_data VALUES (87783, 0, 0, 0, 0, 371, 187);
INSERT INTO public.who_global_data VALUES (87784, 0, 0, 0, 0, 371, 230);
INSERT INTO public.who_global_data VALUES (87785, 0, 0, 0, 0, 371, 77);
INSERT INTO public.who_global_data VALUES (87786, 0, 0, 0, 0, 371, 9);
INSERT INTO public.who_global_data VALUES (87787, 0, 5, 0, 0, 371, 74);
INSERT INTO public.who_global_data VALUES (87788, 0, 0, 0, 0, 371, 224);
INSERT INTO public.who_global_data VALUES (87789, 0, 0, 0, 0, 371, 199);
INSERT INTO public.who_global_data VALUES (87790, 0, 0, 0, 0, 371, 190);
INSERT INTO public.who_global_data VALUES (87791, 0, 0, 0, 0, 371, 12);
INSERT INTO public.who_global_data VALUES (87792, 0, 0, 0, 0, 371, 104);
INSERT INTO public.who_global_data VALUES (87793, 0, 0, 0, 0, 371, 153);
INSERT INTO public.who_global_data VALUES (87794, 0, 3, 0, 0, 371, 91);
INSERT INTO public.who_global_data VALUES (87795, 0, 0, 0, 0, 371, 215);
INSERT INTO public.who_global_data VALUES (87796, 3, 24, 0, 0, 371, 84);
INSERT INTO public.who_global_data VALUES (87797, 0, 0, 0, 0, 371, 231);
INSERT INTO public.who_global_data VALUES (87798, 0, 0, 0, 0, 371, 196);
INSERT INTO public.who_global_data VALUES (87799, 0, 0, 0, 0, 371, 105);
INSERT INTO public.who_global_data VALUES (87800, 0, 0, 0, 0, 371, 122);
INSERT INTO public.who_global_data VALUES (87801, 0, 0, 0, 0, 371, 159);
INSERT INTO public.who_global_data VALUES (87802, 0, 0, 0, 0, 371, 75);
INSERT INTO public.who_global_data VALUES (87803, 0, 0, 0, 0, 371, 27);
INSERT INTO public.who_global_data VALUES (87804, 0, 0, 0, 0, 371, 54);
INSERT INTO public.who_global_data VALUES (87805, 0, 0, 0, 0, 371, 226);
INSERT INTO public.who_global_data VALUES (87806, 0, 0, 0, 0, 371, 79);
INSERT INTO public.who_global_data VALUES (87807, 0, 0, 0, 0, 371, 56);
INSERT INTO public.who_global_data VALUES (87808, 0, 0, 0, 0, 371, 117);
INSERT INTO public.who_global_data VALUES (87809, 0, 0, 0, 0, 371, 152);
INSERT INTO public.who_global_data VALUES (87810, 0, 0, 0, 0, 371, 16);
INSERT INTO public.who_global_data VALUES (87811, 0, 0, 0, 0, 371, 10);
INSERT INTO public.who_global_data VALUES (87812, 0, 0, 0, 0, 371, 201);
INSERT INTO public.who_global_data VALUES (87813, 0, 0, 0, 0, 371, 174);
INSERT INTO public.who_global_data VALUES (87814, 0, 0, 0, 0, 371, 119);
INSERT INTO public.who_global_data VALUES (87815, 0, 0, 0, 0, 371, 168);
INSERT INTO public.who_global_data VALUES (87816, 0, 12, 0, 0, 371, 99);
INSERT INTO public.who_global_data VALUES (87817, 0, 0, 0, 0, 371, 171);
INSERT INTO public.who_global_data VALUES (87818, 0, 0, 0, 0, 371, 87);
INSERT INTO public.who_global_data VALUES (87819, 0, 0, 0, 0, 371, 123);
INSERT INTO public.who_global_data VALUES (87820, 0, 0, 0, 0, 371, 151);
INSERT INTO public.who_global_data VALUES (87821, 0, 0, 0, 0, 371, 213);
INSERT INTO public.who_global_data VALUES (87822, 0, 0, 0, 0, 371, 118);
INSERT INTO public.who_global_data VALUES (87823, 0, 0, 0, 0, 371, 134);
INSERT INTO public.who_global_data VALUES (87824, 0, 0, 0, 0, 371, 65);
INSERT INTO public.who_global_data VALUES (87825, 0, 0, 0, 0, 371, 102);
INSERT INTO public.who_global_data VALUES (87826, 0, 0, 0, 0, 371, 223);
INSERT INTO public.who_global_data VALUES (87827, 0, 0, 0, 0, 371, 4);
INSERT INTO public.who_global_data VALUES (87828, 0, 0, 0, 0, 371, 146);
INSERT INTO public.who_global_data VALUES (87829, 0, 0, 0, 0, 371, 31);
INSERT INTO public.who_global_data VALUES (87830, 0, 0, 0, 0, 371, 127);
INSERT INTO public.who_global_data VALUES (87831, 0, 0, 0, 0, 371, 22);
INSERT INTO public.who_global_data VALUES (87832, 0, 0, 0, 0, 371, 115);
INSERT INTO public.who_global_data VALUES (87833, 0, 0, 0, 0, 371, 106);
INSERT INTO public.who_global_data VALUES (87834, 0, 0, 0, 0, 371, 90);
INSERT INTO public.who_global_data VALUES (87835, 0, 0, 0, 0, 371, 70);
INSERT INTO public.who_global_data VALUES (87836, 0, 5, 0, 0, 371, 46);
INSERT INTO public.who_global_data VALUES (87837, 0, 0, 0, 0, 371, 139);
INSERT INTO public.who_global_data VALUES (87838, 0, 0, 0, 0, 371, 42);
INSERT INTO public.who_global_data VALUES (87839, 0, 0, 0, 0, 371, 80);
INSERT INTO public.who_global_data VALUES (87840, 0, 0, 0, 0, 371, 203);
INSERT INTO public.who_global_data VALUES (87841, 0, 0, 0, 0, 371, 136);
INSERT INTO public.who_global_data VALUES (87842, 0, 0, 0, 0, 371, 63);
INSERT INTO public.who_global_data VALUES (87843, 0, 0, 0, 0, 371, 17);
INSERT INTO public.who_global_data VALUES (87844, 0, 0, 0, 0, 371, 172);
INSERT INTO public.who_global_data VALUES (87845, 0, 0, 0, 0, 371, 109);
INSERT INTO public.who_global_data VALUES (87846, 0, 0, 0, 0, 371, 200);
INSERT INTO public.who_global_data VALUES (87847, 0, 0, 0, 0, 371, 93);
INSERT INTO public.who_global_data VALUES (87848, 0, 0, 0, 0, 371, 5);
INSERT INTO public.who_global_data VALUES (87849, 0, 0, 0, 0, 371, 214);
INSERT INTO public.who_global_data VALUES (87850, 0, 0, 0, 0, 371, 204);
INSERT INTO public.who_global_data VALUES (87851, 0, 0, 0, 0, 371, 198);
INSERT INTO public.who_global_data VALUES (87852, 0, 0, 0, 0, 371, 173);
INSERT INTO public.who_global_data VALUES (87853, 0, 0, 0, 0, 371, 229);
INSERT INTO public.who_global_data VALUES (87854, 0, 0, 0, 0, 371, 76);
INSERT INTO public.who_global_data VALUES (87855, 0, 0, 0, 0, 371, 138);
INSERT INTO public.who_global_data VALUES (87856, 1, 6, 0, 0, 371, 98);
INSERT INTO public.who_global_data VALUES (87857, 0, 0, 0, 0, 371, 103);
INSERT INTO public.who_global_data VALUES (87858, 0, 0, 0, 0, 371, 225);
INSERT INTO public.who_global_data VALUES (87859, 0, 0, 0, 0, 371, 131);
INSERT INTO public.who_global_data VALUES (87860, 0, 0, 0, 0, 371, 235);
INSERT INTO public.who_global_data VALUES (87861, 0, 0, 0, 0, 371, 137);
INSERT INTO public.who_global_data VALUES (87862, 1, 16, 0, 0, 371, 81);
INSERT INTO public.who_global_data VALUES (87863, 0, 0, 0, 0, 371, 182);
INSERT INTO public.who_global_data VALUES (87864, 0, 0, 0, 0, 371, 145);
INSERT INTO public.who_global_data VALUES (87865, 0, 0, 0, 0, 371, 26);
INSERT INTO public.who_global_data VALUES (87866, 0, 2, 0, 0, 371, 170);
INSERT INTO public.who_global_data VALUES (87867, 0, 0, 0, 0, 371, 191);
INSERT INTO public.who_global_data VALUES (87868, 0, 0, 0, 0, 371, 221);
INSERT INTO public.who_global_data VALUES (87869, 0, 0, 0, 0, 371, 64);
INSERT INTO public.who_global_data VALUES (87870, 0, 0, 0, 0, 371, 116);
INSERT INTO public.who_global_data VALUES (87871, 0, 0, 0, 0, 371, 128);
INSERT INTO public.who_global_data VALUES (87872, 0, 0, 0, 0, 371, 6);
INSERT INTO public.who_global_data VALUES (87873, 0, 0, 0, 0, 371, 227);
INSERT INTO public.who_global_data VALUES (87874, 0, 0, 0, 0, 371, 68);
INSERT INTO public.who_global_data VALUES (87875, 0, 0, 0, 0, 371, 184);
INSERT INTO public.who_global_data VALUES (87876, 0, 0, 0, 0, 371, 82);
INSERT INTO public.who_global_data VALUES (87877, 0, 0, 0, 0, 371, 149);
INSERT INTO public.who_global_data VALUES (87878, 0, 0, 0, 0, 371, 197);
INSERT INTO public.who_global_data VALUES (87879, 0, 0, 0, 0, 371, 78);
INSERT INTO public.who_global_data VALUES (87880, 0, 0, 0, 0, 371, 233);
INSERT INTO public.who_global_data VALUES (87881, 0, 0, 0, 0, 371, 133);
INSERT INTO public.who_global_data VALUES (87882, 0, 0, 0, 0, 371, 35);
INSERT INTO public.who_global_data VALUES (87883, 0, 0, 0, 0, 371, 114);
INSERT INTO public.who_global_data VALUES (87884, 2, 22, 0, 0, 371, 237);
INSERT INTO public.who_global_data VALUES (87885, 0, 0, 0, 0, 371, 55);
INSERT INTO public.who_global_data VALUES (87886, 0, 0, 0, 0, 371, 176);
INSERT INTO public.who_global_data VALUES (87887, 0, 0, 0, 0, 371, 202);
INSERT INTO public.who_global_data VALUES (87888, 0, 0, 0, 0, 371, 155);
INSERT INTO public.who_global_data VALUES (87889, 0, 0, 0, 0, 371, 32);
INSERT INTO public.who_global_data VALUES (87890, 0, 0, 0, 0, 371, 220);
INSERT INTO public.who_global_data VALUES (87891, 0, 0, 0, 0, 371, 30);
INSERT INTO public.who_global_data VALUES (87892, 0, 0, 0, 0, 371, 147);
INSERT INTO public.who_global_data VALUES (87893, 0, 0, 0, 0, 371, 208);
INSERT INTO public.who_global_data VALUES (87894, 0, 5, 0, 0, 371, 45);
INSERT INTO public.who_global_data VALUES (87895, 0, 0, 0, 0, 371, 110);
INSERT INTO public.who_global_data VALUES (87896, 0, 0, 0, 0, 371, 88);
INSERT INTO public.who_global_data VALUES (87897, 1, 1, 0, 0, 371, 51);
INSERT INTO public.who_global_data VALUES (87898, 0, 0, 0, 0, 371, 209);
INSERT INTO public.who_global_data VALUES (87899, 0, 0, 0, 0, 371, 205);
INSERT INTO public.who_global_data VALUES (87900, 0, 0, 0, 0, 371, 18);
INSERT INTO public.who_global_data VALUES (87901, 0, 23, 0, 0, 371, 72);
INSERT INTO public.who_global_data VALUES (87902, 2, 2, 0, 0, 371, 44);
INSERT INTO public.who_global_data VALUES (87903, 0, 0, 0, 0, 371, 15);
INSERT INTO public.who_global_data VALUES (87904, 0, 0, 0, 0, 371, 25);
INSERT INTO public.who_global_data VALUES (87905, 0, 0, 0, 0, 371, 179);
INSERT INTO public.who_global_data VALUES (87906, 0, 0, 0, 0, 371, 34);
INSERT INTO public.who_global_data VALUES (87907, 0, 0, 0, 0, 371, 207);
INSERT INTO public.who_global_data VALUES (87908, 0, 0, 0, 0, 371, 166);
INSERT INTO public.who_global_data VALUES (87909, 0, 0, 0, 0, 371, 126);
INSERT INTO public.who_global_data VALUES (87910, 0, 0, 0, 0, 371, 97);
INSERT INTO public.who_global_data VALUES (87911, 0, 0, 0, 0, 371, 36);
INSERT INTO public.who_global_data VALUES (87912, 0, 0, 0, 0, 371, 125);
INSERT INTO public.who_global_data VALUES (87913, 0, 0, 0, 0, 371, 124);
INSERT INTO public.who_global_data VALUES (87914, 0, 0, 0, 0, 371, 185);
INSERT INTO public.who_global_data VALUES (87915, 1, 9, 0, 0, 371, 194);
INSERT INTO public.who_global_data VALUES (87916, 0, 0, 0, 0, 371, 144);
INSERT INTO public.who_global_data VALUES (87917, 1, 12, 0, 0, 371, 19);
INSERT INTO public.who_global_data VALUES (87918, 0, 0, 0, 0, 371, 217);
INSERT INTO public.who_global_data VALUES (87919, 0, 0, 0, 0, 371, 148);
INSERT INTO public.who_global_data VALUES (87920, 0, 0, 0, 0, 371, 86);
INSERT INTO public.who_global_data VALUES (87921, 0, 0, 0, 0, 371, 13);
INSERT INTO public.who_global_data VALUES (87922, 0, 0, 0, 0, 371, 157);
INSERT INTO public.who_global_data VALUES (87923, 1, 10, 0, 0, 371, 8);
INSERT INTO public.who_global_data VALUES (87924, 0, 0, 0, 0, 371, 73);
INSERT INTO public.who_global_data VALUES (87925, 0, 0, 0, 0, 371, 101);
INSERT INTO public.who_global_data VALUES (87926, 0, 0, 0, 0, 371, 165);
INSERT INTO public.who_global_data VALUES (87927, 0, 0, 0, 0, 371, 14);
INSERT INTO public.who_global_data VALUES (87928, 0, 0, 0, 0, 372, 193);
INSERT INTO public.who_global_data VALUES (87929, 0, 0, 0, 0, 372, 113);
INSERT INTO public.who_global_data VALUES (87930, 0, 0, 0, 0, 372, 143);
INSERT INTO public.who_global_data VALUES (87931, 0, 0, 0, 0, 372, 219);
INSERT INTO public.who_global_data VALUES (87932, 0, 0, 0, 0, 372, 186);
INSERT INTO public.who_global_data VALUES (87933, 0, 0, 0, 0, 372, 52);
INSERT INTO public.who_global_data VALUES (87934, 0, 0, 0, 0, 372, 180);
INSERT INTO public.who_global_data VALUES (87935, 0, 0, 0, 0, 372, 167);
INSERT INTO public.who_global_data VALUES (87936, 0, 0, 0, 0, 372, 154);
INSERT INTO public.who_global_data VALUES (87937, 0, 0, 0, 0, 372, 94);
INSERT INTO public.who_global_data VALUES (87938, 0, 0, 0, 0, 372, 66);
INSERT INTO public.who_global_data VALUES (87939, 0, 13, 0, 0, 372, 58);
INSERT INTO public.who_global_data VALUES (87940, 0, 0, 0, 0, 372, 163);
INSERT INTO public.who_global_data VALUES (87941, 0, 0, 0, 0, 372, 37);
INSERT INTO public.who_global_data VALUES (87942, 0, 0, 0, 0, 372, 142);
INSERT INTO public.who_global_data VALUES (87943, 0, 0, 0, 0, 372, 83);
INSERT INTO public.who_global_data VALUES (87944, 0, 0, 0, 0, 372, 228);
INSERT INTO public.who_global_data VALUES (87945, 0, 0, 0, 0, 372, 188);
INSERT INTO public.who_global_data VALUES (87946, 0, 0, 0, 0, 372, 62);
INSERT INTO public.who_global_data VALUES (87947, 0, 0, 0, 0, 372, 160);
INSERT INTO public.who_global_data VALUES (87948, 0, 0, 0, 0, 372, 50);
INSERT INTO public.who_global_data VALUES (87949, 0, 0, 0, 0, 372, 33);
INSERT INTO public.who_global_data VALUES (87950, 0, 0, 0, 0, 372, 183);
INSERT INTO public.who_global_data VALUES (87951, 0, 0, 0, 0, 372, 92);
INSERT INTO public.who_global_data VALUES (87952, 0, 0, 0, 0, 372, 158);
INSERT INTO public.who_global_data VALUES (87953, 0, 0, 0, 0, 372, 67);
INSERT INTO public.who_global_data VALUES (87954, 0, 0, 0, 0, 372, 57);
INSERT INTO public.who_global_data VALUES (87955, 0, 0, 0, 0, 372, 38);
INSERT INTO public.who_global_data VALUES (87956, 0, 0, 0, 0, 372, 141);
INSERT INTO public.who_global_data VALUES (87957, 0, 0, 0, 0, 372, 178);
INSERT INTO public.who_global_data VALUES (87958, 0, 0, 0, 0, 372, 108);
INSERT INTO public.who_global_data VALUES (87959, 0, 0, 0, 0, 372, 39);
INSERT INTO public.who_global_data VALUES (87960, 0, 0, 0, 0, 372, 2);
INSERT INTO public.who_global_data VALUES (87961, 0, 0, 0, 0, 372, 195);
INSERT INTO public.who_global_data VALUES (87962, 0, 0, 0, 0, 372, 107);
INSERT INTO public.who_global_data VALUES (87963, 0, 5, 0, 0, 372, 161);
INSERT INTO public.who_global_data VALUES (87964, 0, 0, 0, 0, 372, 212);
INSERT INTO public.who_global_data VALUES (87965, 1, 8, 0, 0, 372, 181);
INSERT INTO public.who_global_data VALUES (87966, 0, 0, 0, 0, 372, 53);
INSERT INTO public.who_global_data VALUES (87967, 0, 0, 0, 0, 372, 164);
INSERT INTO public.who_global_data VALUES (87968, 0, 0, 0, 0, 372, 140);
INSERT INTO public.who_global_data VALUES (87969, 0, 0, 0, 0, 372, 20);
INSERT INTO public.who_global_data VALUES (87970, 1984, 9724, 43, 213, 372, 112);
INSERT INTO public.who_global_data VALUES (87971, 0, 0, 0, 0, 372, 111);
INSERT INTO public.who_global_data VALUES (87972, 0, 0, 0, 0, 372, 71);
INSERT INTO public.who_global_data VALUES (87973, 0, 0, 0, 0, 372, 218);
INSERT INTO public.who_global_data VALUES (87974, 0, 0, 0, 0, 372, 43);
INSERT INTO public.who_global_data VALUES (87975, 0, 0, 0, 0, 372, 49);
INSERT INTO public.who_global_data VALUES (87976, 0, 0, 0, 0, 372, 1);
INSERT INTO public.who_global_data VALUES (87977, 0, 0, 0, 0, 372, 48);
INSERT INTO public.who_global_data VALUES (87978, 0, 0, 0, 0, 372, 232);
INSERT INTO public.who_global_data VALUES (87979, 0, 0, 0, 0, 372, 175);
INSERT INTO public.who_global_data VALUES (87980, 0, 0, 0, 0, 372, 21);
INSERT INTO public.who_global_data VALUES (87981, 0, 0, 0, 0, 372, 156);
INSERT INTO public.who_global_data VALUES (87982, 0, 0, 0, 0, 372, 95);
INSERT INTO public.who_global_data VALUES (87983, 0, 0, 0, 0, 372, 177);
INSERT INTO public.who_global_data VALUES (87984, 0, 0, 0, 0, 372, 210);
INSERT INTO public.who_global_data VALUES (87985, 0, 0, 0, 0, 372, 120);
INSERT INTO public.who_global_data VALUES (87986, 0, 0, 0, 0, 372, 135);
INSERT INTO public.who_global_data VALUES (87987, 0, 0, 0, 0, 372, 206);
INSERT INTO public.who_global_data VALUES (87988, 0, 0, 0, 0, 372, 189);
INSERT INTO public.who_global_data VALUES (87989, 0, 0, 0, 0, 372, 129);
INSERT INTO public.who_global_data VALUES (87990, 0, 0, 0, 0, 372, 121);
INSERT INTO public.who_global_data VALUES (87991, 0, 0, 0, 0, 372, 59);
INSERT INTO public.who_global_data VALUES (87992, 0, 0, 0, 0, 372, 96);
INSERT INTO public.who_global_data VALUES (87993, 0, 0, 0, 0, 372, 41);
INSERT INTO public.who_global_data VALUES (87994, 0, 0, 0, 0, 372, 216);
INSERT INTO public.who_global_data VALUES (87995, 0, 0, 0, 0, 372, 236);
INSERT INTO public.who_global_data VALUES (87996, 0, 0, 0, 0, 372, 150);
INSERT INTO public.who_global_data VALUES (87997, 0, 0, 0, 0, 372, 61);
INSERT INTO public.who_global_data VALUES (87998, 0, 0, 0, 0, 372, 7);
INSERT INTO public.who_global_data VALUES (87999, 0, 1, 0, 0, 372, 169);
INSERT INTO public.who_global_data VALUES (88000, 1, 6, 0, 0, 372, 28);
INSERT INTO public.who_global_data VALUES (88001, 0, 0, 0, 0, 372, 85);
INSERT INTO public.who_global_data VALUES (88002, 0, 0, 0, 0, 372, 211);
INSERT INTO public.who_global_data VALUES (88003, 0, 0, 0, 0, 372, 60);
INSERT INTO public.who_global_data VALUES (88004, 0, 0, 0, 0, 372, 3);
INSERT INTO public.who_global_data VALUES (88005, 0, 0, 0, 0, 372, 11);
INSERT INTO public.who_global_data VALUES (88006, 1, 5, 0, 0, 372, 89);
INSERT INTO public.who_global_data VALUES (88007, 0, 0, 0, 0, 372, 24);
INSERT INTO public.who_global_data VALUES (88008, 0, 0, 0, 0, 372, 162);
INSERT INTO public.who_global_data VALUES (88009, 0, 0, 0, 0, 372, 100);
INSERT INTO public.who_global_data VALUES (88010, 0, 0, 0, 0, 372, 47);
INSERT INTO public.who_global_data VALUES (88011, 0, 0, 0, 0, 372, 29);
INSERT INTO public.who_global_data VALUES (88012, 0, 0, 0, 0, 372, 40);
INSERT INTO public.who_global_data VALUES (88013, 0, 0, 0, 0, 372, 222);
INSERT INTO public.who_global_data VALUES (88014, 0, 0, 0, 0, 372, 132);
INSERT INTO public.who_global_data VALUES (88015, 0, 0, 0, 0, 372, 130);
INSERT INTO public.who_global_data VALUES (88016, 0, 0, 0, 0, 372, 234);
INSERT INTO public.who_global_data VALUES (88017, 0, 0, 0, 0, 372, 23);
INSERT INTO public.who_global_data VALUES (88018, 0, 0, 0, 0, 372, 192);
INSERT INTO public.who_global_data VALUES (88019, 0, 0, 0, 0, 372, 69);
INSERT INTO public.who_global_data VALUES (88020, 0, 0, 0, 0, 372, 187);
INSERT INTO public.who_global_data VALUES (88021, 0, 0, 0, 0, 372, 230);
INSERT INTO public.who_global_data VALUES (88022, 0, 0, 0, 0, 372, 77);
INSERT INTO public.who_global_data VALUES (88023, 0, 0, 0, 0, 372, 9);
INSERT INTO public.who_global_data VALUES (88024, 0, 5, 0, 0, 372, 74);
INSERT INTO public.who_global_data VALUES (88025, 0, 0, 0, 0, 372, 224);
INSERT INTO public.who_global_data VALUES (88026, 0, 0, 0, 0, 372, 199);
INSERT INTO public.who_global_data VALUES (88027, 0, 0, 0, 0, 372, 190);
INSERT INTO public.who_global_data VALUES (88028, 0, 0, 0, 0, 372, 12);
INSERT INTO public.who_global_data VALUES (88029, 0, 0, 0, 0, 372, 104);
INSERT INTO public.who_global_data VALUES (88030, 0, 0, 0, 0, 372, 153);
INSERT INTO public.who_global_data VALUES (88031, 1, 3, 0, 0, 372, 91);
INSERT INTO public.who_global_data VALUES (88032, 0, 0, 0, 0, 372, 215);
INSERT INTO public.who_global_data VALUES (88033, 7, 21, 0, 0, 372, 84);
INSERT INTO public.who_global_data VALUES (88034, 0, 0, 0, 0, 372, 231);
INSERT INTO public.who_global_data VALUES (88035, 0, 0, 0, 0, 372, 196);
INSERT INTO public.who_global_data VALUES (88036, 0, 0, 0, 0, 372, 105);
INSERT INTO public.who_global_data VALUES (88037, 0, 0, 0, 0, 372, 122);
INSERT INTO public.who_global_data VALUES (88038, 0, 0, 0, 0, 372, 159);
INSERT INTO public.who_global_data VALUES (88039, 0, 0, 0, 0, 372, 75);
INSERT INTO public.who_global_data VALUES (88040, 0, 0, 0, 0, 372, 27);
INSERT INTO public.who_global_data VALUES (88041, 0, 0, 0, 0, 372, 54);
INSERT INTO public.who_global_data VALUES (88042, 0, 0, 0, 0, 372, 226);
INSERT INTO public.who_global_data VALUES (88043, 0, 0, 0, 0, 372, 79);
INSERT INTO public.who_global_data VALUES (88044, 0, 0, 0, 0, 372, 56);
INSERT INTO public.who_global_data VALUES (88045, 0, 0, 0, 0, 372, 117);
INSERT INTO public.who_global_data VALUES (88046, 0, 0, 0, 0, 372, 152);
INSERT INTO public.who_global_data VALUES (88047, 0, 0, 0, 0, 372, 16);
INSERT INTO public.who_global_data VALUES (88048, 0, 0, 0, 0, 372, 10);
INSERT INTO public.who_global_data VALUES (88049, 0, 0, 0, 0, 372, 201);
INSERT INTO public.who_global_data VALUES (88050, 0, 0, 0, 0, 372, 174);
INSERT INTO public.who_global_data VALUES (88051, 0, 0, 0, 0, 372, 119);
INSERT INTO public.who_global_data VALUES (88052, 0, 0, 0, 0, 372, 168);
INSERT INTO public.who_global_data VALUES (88053, 0, 12, 0, 0, 372, 99);
INSERT INTO public.who_global_data VALUES (88054, 0, 0, 0, 0, 372, 171);
INSERT INTO public.who_global_data VALUES (88055, 0, 0, 0, 0, 372, 87);
INSERT INTO public.who_global_data VALUES (88056, 0, 0, 0, 0, 372, 123);
INSERT INTO public.who_global_data VALUES (88057, 0, 0, 0, 0, 372, 151);
INSERT INTO public.who_global_data VALUES (88058, 0, 0, 0, 0, 372, 213);
INSERT INTO public.who_global_data VALUES (88059, 0, 0, 0, 0, 372, 118);
INSERT INTO public.who_global_data VALUES (88060, 0, 0, 0, 0, 372, 134);
INSERT INTO public.who_global_data VALUES (88061, 0, 0, 0, 0, 372, 65);
INSERT INTO public.who_global_data VALUES (88062, 0, 0, 0, 0, 372, 102);
INSERT INTO public.who_global_data VALUES (88063, 0, 0, 0, 0, 372, 223);
INSERT INTO public.who_global_data VALUES (88064, 0, 0, 0, 0, 372, 4);
INSERT INTO public.who_global_data VALUES (88065, 0, 0, 0, 0, 372, 146);
INSERT INTO public.who_global_data VALUES (88066, 0, 0, 0, 0, 372, 31);
INSERT INTO public.who_global_data VALUES (88067, 0, 0, 0, 0, 372, 127);
INSERT INTO public.who_global_data VALUES (88068, 0, 0, 0, 0, 372, 22);
INSERT INTO public.who_global_data VALUES (88069, 0, 0, 0, 0, 372, 115);
INSERT INTO public.who_global_data VALUES (88070, 0, 0, 0, 0, 372, 106);
INSERT INTO public.who_global_data VALUES (88071, 0, 0, 0, 0, 372, 90);
INSERT INTO public.who_global_data VALUES (88072, 0, 0, 0, 0, 372, 70);
INSERT INTO public.who_global_data VALUES (88073, 0, 5, 0, 0, 372, 46);
INSERT INTO public.who_global_data VALUES (88074, 0, 0, 0, 0, 372, 139);
INSERT INTO public.who_global_data VALUES (88075, 0, 0, 0, 0, 372, 42);
INSERT INTO public.who_global_data VALUES (88076, 0, 0, 0, 0, 372, 80);
INSERT INTO public.who_global_data VALUES (88077, 0, 0, 0, 0, 372, 203);
INSERT INTO public.who_global_data VALUES (88078, 0, 0, 0, 0, 372, 136);
INSERT INTO public.who_global_data VALUES (88079, 0, 0, 0, 0, 372, 63);
INSERT INTO public.who_global_data VALUES (88080, 0, 0, 0, 0, 372, 17);
INSERT INTO public.who_global_data VALUES (88081, 0, 0, 0, 0, 372, 172);
INSERT INTO public.who_global_data VALUES (88082, 0, 0, 0, 0, 372, 109);
INSERT INTO public.who_global_data VALUES (88083, 0, 0, 0, 0, 372, 200);
INSERT INTO public.who_global_data VALUES (88084, 0, 0, 0, 0, 372, 93);
INSERT INTO public.who_global_data VALUES (88085, 0, 0, 0, 0, 372, 5);
INSERT INTO public.who_global_data VALUES (88086, 0, 0, 0, 0, 372, 214);
INSERT INTO public.who_global_data VALUES (88087, 0, 0, 0, 0, 372, 204);
INSERT INTO public.who_global_data VALUES (88088, 0, 0, 0, 0, 372, 198);
INSERT INTO public.who_global_data VALUES (88089, 0, 0, 0, 0, 372, 173);
INSERT INTO public.who_global_data VALUES (88090, 0, 0, 0, 0, 372, 229);
INSERT INTO public.who_global_data VALUES (88091, 0, 0, 0, 0, 372, 76);
INSERT INTO public.who_global_data VALUES (88092, 0, 0, 0, 0, 372, 138);
INSERT INTO public.who_global_data VALUES (88093, 0, 5, 0, 0, 372, 98);
INSERT INTO public.who_global_data VALUES (88094, 0, 0, 0, 0, 372, 103);
INSERT INTO public.who_global_data VALUES (88095, 0, 0, 0, 0, 372, 225);
INSERT INTO public.who_global_data VALUES (88096, 0, 0, 0, 0, 372, 131);
INSERT INTO public.who_global_data VALUES (88097, 0, 0, 0, 0, 372, 235);
INSERT INTO public.who_global_data VALUES (88098, 0, 0, 0, 0, 372, 137);
INSERT INTO public.who_global_data VALUES (88099, 5, 15, 0, 0, 372, 81);
INSERT INTO public.who_global_data VALUES (88100, 0, 0, 0, 0, 372, 182);
INSERT INTO public.who_global_data VALUES (88101, 0, 0, 0, 0, 372, 145);
INSERT INTO public.who_global_data VALUES (88102, 0, 0, 0, 0, 372, 26);
INSERT INTO public.who_global_data VALUES (88103, 2, 2, 0, 0, 372, 170);
INSERT INTO public.who_global_data VALUES (88104, 0, 0, 0, 0, 372, 191);
INSERT INTO public.who_global_data VALUES (88105, 0, 0, 0, 0, 372, 221);
INSERT INTO public.who_global_data VALUES (88106, 0, 0, 0, 0, 372, 64);
INSERT INTO public.who_global_data VALUES (88107, 0, 0, 0, 0, 372, 116);
INSERT INTO public.who_global_data VALUES (88108, 0, 0, 0, 0, 372, 128);
INSERT INTO public.who_global_data VALUES (88109, 0, 0, 0, 0, 372, 6);
INSERT INTO public.who_global_data VALUES (88110, 0, 0, 0, 0, 372, 227);
INSERT INTO public.who_global_data VALUES (88111, 0, 0, 0, 0, 372, 68);
INSERT INTO public.who_global_data VALUES (88112, 0, 0, 0, 0, 372, 184);
INSERT INTO public.who_global_data VALUES (88113, 0, 0, 0, 0, 372, 82);
INSERT INTO public.who_global_data VALUES (88114, 0, 0, 0, 0, 372, 149);
INSERT INTO public.who_global_data VALUES (88115, 0, 0, 0, 0, 372, 197);
INSERT INTO public.who_global_data VALUES (88116, 0, 0, 0, 0, 372, 78);
INSERT INTO public.who_global_data VALUES (88117, 0, 0, 0, 0, 372, 233);
INSERT INTO public.who_global_data VALUES (88118, 0, 0, 0, 0, 372, 133);
INSERT INTO public.who_global_data VALUES (88119, 0, 0, 0, 0, 372, 35);
INSERT INTO public.who_global_data VALUES (88120, 0, 0, 0, 0, 372, 114);
INSERT INTO public.who_global_data VALUES (88121, 3, 20, 0, 0, 372, 237);
INSERT INTO public.who_global_data VALUES (88122, 0, 0, 0, 0, 372, 55);
INSERT INTO public.who_global_data VALUES (88123, 0, 0, 0, 0, 372, 176);
INSERT INTO public.who_global_data VALUES (88124, 0, 0, 0, 0, 372, 202);
INSERT INTO public.who_global_data VALUES (88125, 0, 0, 0, 0, 372, 155);
INSERT INTO public.who_global_data VALUES (88126, 0, 0, 0, 0, 372, 32);
INSERT INTO public.who_global_data VALUES (88127, 0, 0, 0, 0, 372, 220);
INSERT INTO public.who_global_data VALUES (88128, 0, 0, 0, 0, 372, 30);
INSERT INTO public.who_global_data VALUES (88129, 0, 0, 0, 0, 372, 147);
INSERT INTO public.who_global_data VALUES (88130, 0, 0, 0, 0, 372, 208);
INSERT INTO public.who_global_data VALUES (88131, 0, 5, 0, 0, 372, 45);
INSERT INTO public.who_global_data VALUES (88132, 0, 0, 0, 0, 372, 110);
INSERT INTO public.who_global_data VALUES (88133, 0, 0, 0, 0, 372, 88);
INSERT INTO public.who_global_data VALUES (88134, 0, 0, 0, 0, 372, 51);
INSERT INTO public.who_global_data VALUES (88135, 0, 0, 0, 0, 372, 209);
INSERT INTO public.who_global_data VALUES (88136, 0, 0, 0, 0, 372, 205);
INSERT INTO public.who_global_data VALUES (88137, 0, 0, 0, 0, 372, 18);
INSERT INTO public.who_global_data VALUES (88138, 5, 23, 0, 0, 372, 72);
INSERT INTO public.who_global_data VALUES (88139, 0, 0, 0, 0, 372, 44);
INSERT INTO public.who_global_data VALUES (88140, 0, 0, 0, 0, 372, 15);
INSERT INTO public.who_global_data VALUES (88141, 0, 0, 0, 0, 372, 25);
INSERT INTO public.who_global_data VALUES (88142, 0, 0, 0, 0, 372, 179);
INSERT INTO public.who_global_data VALUES (88143, 0, 0, 0, 0, 372, 34);
INSERT INTO public.who_global_data VALUES (88144, 0, 0, 0, 0, 372, 207);
INSERT INTO public.who_global_data VALUES (88145, 0, 0, 0, 0, 372, 166);
INSERT INTO public.who_global_data VALUES (88146, 0, 0, 0, 0, 372, 126);
INSERT INTO public.who_global_data VALUES (88147, 0, 0, 0, 0, 372, 97);
INSERT INTO public.who_global_data VALUES (88148, 0, 0, 0, 0, 372, 36);
INSERT INTO public.who_global_data VALUES (88149, 0, 0, 0, 0, 372, 125);
INSERT INTO public.who_global_data VALUES (88150, 0, 0, 0, 0, 372, 124);
INSERT INTO public.who_global_data VALUES (88151, 0, 0, 0, 0, 372, 185);
INSERT INTO public.who_global_data VALUES (88152, 0, 8, 0, 0, 372, 194);
INSERT INTO public.who_global_data VALUES (88153, 0, 0, 0, 0, 372, 144);
INSERT INTO public.who_global_data VALUES (88154, 1, 11, 0, 0, 372, 19);
INSERT INTO public.who_global_data VALUES (88155, 0, 0, 0, 0, 372, 217);
INSERT INTO public.who_global_data VALUES (88156, 0, 0, 0, 0, 372, 148);
INSERT INTO public.who_global_data VALUES (88157, 0, 0, 0, 0, 372, 86);
INSERT INTO public.who_global_data VALUES (88158, 0, 0, 0, 0, 372, 13);
INSERT INTO public.who_global_data VALUES (88159, 0, 0, 0, 0, 372, 157);
INSERT INTO public.who_global_data VALUES (88160, 0, 9, 0, 0, 372, 8);
INSERT INTO public.who_global_data VALUES (88161, 0, 0, 0, 0, 372, 73);
INSERT INTO public.who_global_data VALUES (88162, 0, 0, 0, 0, 372, 101);
INSERT INTO public.who_global_data VALUES (88163, 0, 0, 0, 0, 372, 165);
INSERT INTO public.who_global_data VALUES (88164, 0, 0, 0, 0, 372, 14);
INSERT INTO public.who_global_data VALUES (88165, 0, 0, 0, 0, 373, 193);
INSERT INTO public.who_global_data VALUES (88166, 0, 0, 0, 0, 373, 113);
INSERT INTO public.who_global_data VALUES (88167, 0, 0, 0, 0, 373, 143);
INSERT INTO public.who_global_data VALUES (88168, 0, 0, 0, 0, 373, 219);
INSERT INTO public.who_global_data VALUES (88169, 0, 0, 0, 0, 373, 186);
INSERT INTO public.who_global_data VALUES (88170, 0, 0, 0, 0, 373, 52);
INSERT INTO public.who_global_data VALUES (88171, 0, 0, 0, 0, 373, 180);
INSERT INTO public.who_global_data VALUES (88172, 0, 0, 0, 0, 373, 167);
INSERT INTO public.who_global_data VALUES (88173, 0, 0, 0, 0, 373, 154);
INSERT INTO public.who_global_data VALUES (88174, 0, 0, 0, 0, 373, 94);
INSERT INTO public.who_global_data VALUES (88175, 0, 0, 0, 0, 373, 66);
INSERT INTO public.who_global_data VALUES (88176, 2, 13, 0, 0, 373, 58);
INSERT INTO public.who_global_data VALUES (88177, 0, 0, 0, 0, 373, 163);
INSERT INTO public.who_global_data VALUES (88178, 0, 0, 0, 0, 373, 37);
INSERT INTO public.who_global_data VALUES (88179, 0, 0, 0, 0, 373, 142);
INSERT INTO public.who_global_data VALUES (88180, 0, 0, 0, 0, 373, 83);
INSERT INTO public.who_global_data VALUES (88181, 0, 0, 0, 0, 373, 228);
INSERT INTO public.who_global_data VALUES (88182, 0, 0, 0, 0, 373, 188);
INSERT INTO public.who_global_data VALUES (88183, 0, 0, 0, 0, 373, 62);
INSERT INTO public.who_global_data VALUES (88184, 0, 0, 0, 0, 373, 160);
INSERT INTO public.who_global_data VALUES (88185, 0, 0, 0, 0, 373, 50);
INSERT INTO public.who_global_data VALUES (88186, 0, 0, 0, 0, 373, 33);
INSERT INTO public.who_global_data VALUES (88187, 0, 0, 0, 0, 373, 183);
INSERT INTO public.who_global_data VALUES (88188, 0, 0, 0, 0, 373, 92);
INSERT INTO public.who_global_data VALUES (88189, 0, 0, 0, 0, 373, 158);
INSERT INTO public.who_global_data VALUES (88190, 0, 0, 0, 0, 373, 67);
INSERT INTO public.who_global_data VALUES (88191, 0, 0, 0, 0, 373, 57);
INSERT INTO public.who_global_data VALUES (88192, 0, 0, 0, 0, 373, 38);
INSERT INTO public.who_global_data VALUES (88193, 0, 0, 0, 0, 373, 141);
INSERT INTO public.who_global_data VALUES (88194, 0, 0, 0, 0, 373, 178);
INSERT INTO public.who_global_data VALUES (88195, 0, 0, 0, 0, 373, 108);
INSERT INTO public.who_global_data VALUES (88196, 0, 0, 0, 0, 373, 39);
INSERT INTO public.who_global_data VALUES (88197, 0, 0, 0, 0, 373, 2);
INSERT INTO public.who_global_data VALUES (88198, 0, 0, 0, 0, 373, 195);
INSERT INTO public.who_global_data VALUES (88199, 0, 0, 0, 0, 373, 107);
INSERT INTO public.who_global_data VALUES (88200, 0, 5, 0, 0, 373, 161);
INSERT INTO public.who_global_data VALUES (88201, 0, 0, 0, 0, 373, 212);
INSERT INTO public.who_global_data VALUES (88202, 0, 7, 0, 0, 373, 181);
INSERT INTO public.who_global_data VALUES (88203, 0, 0, 0, 0, 373, 53);
INSERT INTO public.who_global_data VALUES (88204, 0, 0, 0, 0, 373, 164);
INSERT INTO public.who_global_data VALUES (88205, 0, 0, 0, 0, 373, 140);
INSERT INTO public.who_global_data VALUES (88206, 0, 0, 0, 0, 373, 20);
INSERT INTO public.who_global_data VALUES (88207, 1741, 7740, 38, 170, 373, 112);
INSERT INTO public.who_global_data VALUES (88208, 0, 0, 0, 0, 373, 111);
INSERT INTO public.who_global_data VALUES (88209, 0, 0, 0, 0, 373, 71);
INSERT INTO public.who_global_data VALUES (88210, 0, 0, 0, 0, 373, 218);
INSERT INTO public.who_global_data VALUES (88211, 0, 0, 0, 0, 373, 43);
INSERT INTO public.who_global_data VALUES (88212, 0, 0, 0, 0, 373, 49);
INSERT INTO public.who_global_data VALUES (88213, 0, 0, 0, 0, 373, 1);
INSERT INTO public.who_global_data VALUES (88214, 0, 0, 0, 0, 373, 48);
INSERT INTO public.who_global_data VALUES (88215, 0, 0, 0, 0, 373, 232);
INSERT INTO public.who_global_data VALUES (88216, 0, 0, 0, 0, 373, 175);
INSERT INTO public.who_global_data VALUES (88217, 0, 0, 0, 0, 373, 21);
INSERT INTO public.who_global_data VALUES (88218, 0, 0, 0, 0, 373, 156);
INSERT INTO public.who_global_data VALUES (88219, 0, 0, 0, 0, 373, 95);
INSERT INTO public.who_global_data VALUES (88220, 0, 0, 0, 0, 373, 177);
INSERT INTO public.who_global_data VALUES (88221, 0, 0, 0, 0, 373, 210);
INSERT INTO public.who_global_data VALUES (88222, 0, 0, 0, 0, 373, 120);
INSERT INTO public.who_global_data VALUES (88223, 0, 0, 0, 0, 373, 135);
INSERT INTO public.who_global_data VALUES (88224, 0, 0, 0, 0, 373, 206);
INSERT INTO public.who_global_data VALUES (88225, 0, 0, 0, 0, 373, 189);
INSERT INTO public.who_global_data VALUES (88226, 0, 0, 0, 0, 373, 129);
INSERT INTO public.who_global_data VALUES (88227, 0, 0, 0, 0, 373, 121);
INSERT INTO public.who_global_data VALUES (88228, 0, 0, 0, 0, 373, 59);
INSERT INTO public.who_global_data VALUES (88229, 0, 0, 0, 0, 373, 96);
INSERT INTO public.who_global_data VALUES (88230, 0, 0, 0, 0, 373, 41);
INSERT INTO public.who_global_data VALUES (88231, 0, 0, 0, 0, 373, 216);
INSERT INTO public.who_global_data VALUES (88232, 0, 0, 0, 0, 373, 236);
INSERT INTO public.who_global_data VALUES (88233, 0, 0, 0, 0, 373, 150);
INSERT INTO public.who_global_data VALUES (88234, 0, 0, 0, 0, 373, 61);
INSERT INTO public.who_global_data VALUES (88235, 0, 0, 0, 0, 373, 7);
INSERT INTO public.who_global_data VALUES (88236, 0, 1, 0, 0, 373, 169);
INSERT INTO public.who_global_data VALUES (88237, 1, 5, 0, 0, 373, 28);
INSERT INTO public.who_global_data VALUES (88238, 0, 0, 0, 0, 373, 85);
INSERT INTO public.who_global_data VALUES (88239, 0, 0, 0, 0, 373, 211);
INSERT INTO public.who_global_data VALUES (88240, 0, 0, 0, 0, 373, 60);
INSERT INTO public.who_global_data VALUES (88241, 0, 0, 0, 0, 373, 3);
INSERT INTO public.who_global_data VALUES (88242, 0, 0, 0, 0, 373, 11);
INSERT INTO public.who_global_data VALUES (88243, 0, 4, 0, 0, 373, 89);
INSERT INTO public.who_global_data VALUES (88244, 0, 0, 0, 0, 373, 24);
INSERT INTO public.who_global_data VALUES (88245, 0, 0, 0, 0, 373, 162);
INSERT INTO public.who_global_data VALUES (88246, 0, 0, 0, 0, 373, 100);
INSERT INTO public.who_global_data VALUES (88247, 0, 0, 0, 0, 373, 47);
INSERT INTO public.who_global_data VALUES (88248, 0, 0, 0, 0, 373, 29);
INSERT INTO public.who_global_data VALUES (88249, 0, 0, 0, 0, 373, 40);
INSERT INTO public.who_global_data VALUES (88250, 0, 0, 0, 0, 373, 222);
INSERT INTO public.who_global_data VALUES (88251, 0, 0, 0, 0, 373, 132);
INSERT INTO public.who_global_data VALUES (88252, 0, 0, 0, 0, 373, 130);
INSERT INTO public.who_global_data VALUES (88253, 0, 0, 0, 0, 373, 234);
INSERT INTO public.who_global_data VALUES (88254, 0, 0, 0, 0, 373, 23);
INSERT INTO public.who_global_data VALUES (88255, 0, 0, 0, 0, 373, 192);
INSERT INTO public.who_global_data VALUES (88256, 0, 0, 0, 0, 373, 69);
INSERT INTO public.who_global_data VALUES (88257, 0, 0, 0, 0, 373, 187);
INSERT INTO public.who_global_data VALUES (88258, 0, 0, 0, 0, 373, 230);
INSERT INTO public.who_global_data VALUES (88259, 0, 0, 0, 0, 373, 77);
INSERT INTO public.who_global_data VALUES (88260, 0, 0, 0, 0, 373, 9);
INSERT INTO public.who_global_data VALUES (88261, 5, 5, 0, 0, 373, 74);
INSERT INTO public.who_global_data VALUES (88262, 0, 0, 0, 0, 373, 224);
INSERT INTO public.who_global_data VALUES (88263, 0, 0, 0, 0, 373, 199);
INSERT INTO public.who_global_data VALUES (88264, 0, 0, 0, 0, 373, 190);
INSERT INTO public.who_global_data VALUES (88265, 0, 0, 0, 0, 373, 12);
INSERT INTO public.who_global_data VALUES (88266, 0, 0, 0, 0, 373, 104);
INSERT INTO public.who_global_data VALUES (88267, 0, 0, 0, 0, 373, 153);
INSERT INTO public.who_global_data VALUES (88268, 0, 2, 0, 0, 373, 91);
INSERT INTO public.who_global_data VALUES (88269, 0, 0, 0, 0, 373, 215);
INSERT INTO public.who_global_data VALUES (88270, 6, 14, 0, 0, 373, 84);
INSERT INTO public.who_global_data VALUES (88271, 0, 0, 0, 0, 373, 231);
INSERT INTO public.who_global_data VALUES (88272, 0, 0, 0, 0, 373, 196);
INSERT INTO public.who_global_data VALUES (88273, 0, 0, 0, 0, 373, 105);
INSERT INTO public.who_global_data VALUES (88274, 0, 0, 0, 0, 373, 122);
INSERT INTO public.who_global_data VALUES (88275, 0, 0, 0, 0, 373, 159);
INSERT INTO public.who_global_data VALUES (88276, 0, 0, 0, 0, 373, 75);
INSERT INTO public.who_global_data VALUES (88277, 0, 0, 0, 0, 373, 27);
INSERT INTO public.who_global_data VALUES (88278, 0, 0, 0, 0, 373, 54);
INSERT INTO public.who_global_data VALUES (88279, 0, 0, 0, 0, 373, 226);
INSERT INTO public.who_global_data VALUES (88280, 0, 0, 0, 0, 373, 79);
INSERT INTO public.who_global_data VALUES (88281, 0, 0, 0, 0, 373, 56);
INSERT INTO public.who_global_data VALUES (88282, 0, 0, 0, 0, 373, 117);
INSERT INTO public.who_global_data VALUES (88283, 0, 0, 0, 0, 373, 152);
INSERT INTO public.who_global_data VALUES (88284, 0, 0, 0, 0, 373, 16);
INSERT INTO public.who_global_data VALUES (88285, 0, 0, 0, 0, 373, 10);
INSERT INTO public.who_global_data VALUES (88286, 0, 0, 0, 0, 373, 201);
INSERT INTO public.who_global_data VALUES (88287, 0, 0, 0, 0, 373, 174);
INSERT INTO public.who_global_data VALUES (88288, 0, 0, 0, 0, 373, 119);
INSERT INTO public.who_global_data VALUES (88289, 0, 0, 0, 0, 373, 168);
INSERT INTO public.who_global_data VALUES (88290, 1, 12, 0, 0, 373, 99);
INSERT INTO public.who_global_data VALUES (88291, 0, 0, 0, 0, 373, 171);
INSERT INTO public.who_global_data VALUES (88292, 0, 0, 0, 0, 373, 87);
INSERT INTO public.who_global_data VALUES (88293, 0, 0, 0, 0, 373, 123);
INSERT INTO public.who_global_data VALUES (88294, 0, 0, 0, 0, 373, 151);
INSERT INTO public.who_global_data VALUES (88295, 0, 0, 0, 0, 373, 213);
INSERT INTO public.who_global_data VALUES (88296, 0, 0, 0, 0, 373, 118);
INSERT INTO public.who_global_data VALUES (88297, 0, 0, 0, 0, 373, 134);
INSERT INTO public.who_global_data VALUES (88298, 0, 0, 0, 0, 373, 65);
INSERT INTO public.who_global_data VALUES (88299, 0, 0, 0, 0, 373, 102);
INSERT INTO public.who_global_data VALUES (88300, 0, 0, 0, 0, 373, 223);
INSERT INTO public.who_global_data VALUES (88301, 0, 0, 0, 0, 373, 4);
INSERT INTO public.who_global_data VALUES (88302, 0, 0, 0, 0, 373, 146);
INSERT INTO public.who_global_data VALUES (88303, 0, 0, 0, 0, 373, 31);
INSERT INTO public.who_global_data VALUES (88304, 0, 0, 0, 0, 373, 127);
INSERT INTO public.who_global_data VALUES (88305, 0, 0, 0, 0, 373, 22);
INSERT INTO public.who_global_data VALUES (88306, 0, 0, 0, 0, 373, 115);
INSERT INTO public.who_global_data VALUES (88307, 0, 0, 0, 0, 373, 106);
INSERT INTO public.who_global_data VALUES (88308, 0, 0, 0, 0, 373, 90);
INSERT INTO public.who_global_data VALUES (88309, 0, 0, 0, 0, 373, 70);
INSERT INTO public.who_global_data VALUES (88310, 0, 5, 0, 0, 373, 46);
INSERT INTO public.who_global_data VALUES (88311, 0, 0, 0, 0, 373, 139);
INSERT INTO public.who_global_data VALUES (88312, 0, 0, 0, 0, 373, 42);
INSERT INTO public.who_global_data VALUES (88313, 0, 0, 0, 0, 373, 80);
INSERT INTO public.who_global_data VALUES (88314, 0, 0, 0, 0, 373, 203);
INSERT INTO public.who_global_data VALUES (88315, 0, 0, 0, 0, 373, 136);
INSERT INTO public.who_global_data VALUES (88316, 0, 0, 0, 0, 373, 63);
INSERT INTO public.who_global_data VALUES (88317, 0, 0, 0, 0, 373, 17);
INSERT INTO public.who_global_data VALUES (88318, 0, 0, 0, 0, 373, 172);
INSERT INTO public.who_global_data VALUES (88319, 0, 0, 0, 0, 373, 109);
INSERT INTO public.who_global_data VALUES (88320, 0, 0, 0, 0, 373, 200);
INSERT INTO public.who_global_data VALUES (88321, 0, 0, 0, 0, 373, 93);
INSERT INTO public.who_global_data VALUES (88322, 0, 0, 0, 0, 373, 5);
INSERT INTO public.who_global_data VALUES (88323, 0, 0, 0, 0, 373, 214);
INSERT INTO public.who_global_data VALUES (88324, 0, 0, 0, 0, 373, 204);
INSERT INTO public.who_global_data VALUES (88325, 0, 0, 0, 0, 373, 198);
INSERT INTO public.who_global_data VALUES (88326, 0, 0, 0, 0, 373, 173);
INSERT INTO public.who_global_data VALUES (88327, 0, 0, 0, 0, 373, 229);
INSERT INTO public.who_global_data VALUES (88328, 0, 0, 0, 0, 373, 76);
INSERT INTO public.who_global_data VALUES (88329, 0, 0, 0, 0, 373, 138);
INSERT INTO public.who_global_data VALUES (88330, 5, 5, 0, 0, 373, 98);
INSERT INTO public.who_global_data VALUES (88331, 0, 0, 0, 0, 373, 103);
INSERT INTO public.who_global_data VALUES (88332, 0, 0, 0, 0, 373, 225);
INSERT INTO public.who_global_data VALUES (88333, 0, 0, 0, 0, 373, 131);
INSERT INTO public.who_global_data VALUES (88334, 0, 0, 0, 0, 373, 235);
INSERT INTO public.who_global_data VALUES (88335, 0, 0, 0, 0, 373, 137);
INSERT INTO public.who_global_data VALUES (88336, 2, 10, 0, 0, 373, 81);
INSERT INTO public.who_global_data VALUES (88337, 0, 0, 0, 0, 373, 182);
INSERT INTO public.who_global_data VALUES (88338, 0, 0, 0, 0, 373, 145);
INSERT INTO public.who_global_data VALUES (88339, 0, 0, 0, 0, 373, 26);
INSERT INTO public.who_global_data VALUES (88340, 0, 0, 0, 0, 373, 170);
INSERT INTO public.who_global_data VALUES (88341, 0, 0, 0, 0, 373, 191);
INSERT INTO public.who_global_data VALUES (88342, 0, 0, 0, 0, 373, 221);
INSERT INTO public.who_global_data VALUES (88343, 0, 0, 0, 0, 373, 64);
INSERT INTO public.who_global_data VALUES (88344, 0, 0, 0, 0, 373, 116);
INSERT INTO public.who_global_data VALUES (88345, 0, 0, 0, 0, 373, 128);
INSERT INTO public.who_global_data VALUES (88346, 0, 0, 0, 0, 373, 6);
INSERT INTO public.who_global_data VALUES (88347, 0, 0, 0, 0, 373, 227);
INSERT INTO public.who_global_data VALUES (88348, 0, 0, 0, 0, 373, 68);
INSERT INTO public.who_global_data VALUES (88349, 0, 0, 0, 0, 373, 184);
INSERT INTO public.who_global_data VALUES (88350, 0, 0, 0, 0, 373, 82);
INSERT INTO public.who_global_data VALUES (88351, 0, 0, 0, 0, 373, 149);
INSERT INTO public.who_global_data VALUES (88352, 0, 0, 0, 0, 373, 197);
INSERT INTO public.who_global_data VALUES (88353, 0, 0, 0, 0, 373, 78);
INSERT INTO public.who_global_data VALUES (88354, 0, 0, 0, 0, 373, 233);
INSERT INTO public.who_global_data VALUES (88355, 0, 0, 0, 0, 373, 133);
INSERT INTO public.who_global_data VALUES (88356, 0, 0, 0, 0, 373, 35);
INSERT INTO public.who_global_data VALUES (88357, 0, 0, 0, 0, 373, 114);
INSERT INTO public.who_global_data VALUES (88358, 3, 17, 0, 0, 373, 237);
INSERT INTO public.who_global_data VALUES (88359, 0, 0, 0, 0, 373, 55);
INSERT INTO public.who_global_data VALUES (88360, 0, 0, 0, 0, 373, 176);
INSERT INTO public.who_global_data VALUES (88361, 0, 0, 0, 0, 373, 202);
INSERT INTO public.who_global_data VALUES (88362, 0, 0, 0, 0, 373, 155);
INSERT INTO public.who_global_data VALUES (88363, 0, 0, 0, 0, 373, 32);
INSERT INTO public.who_global_data VALUES (88364, 0, 0, 0, 0, 373, 220);
INSERT INTO public.who_global_data VALUES (88365, 0, 0, 0, 0, 373, 30);
INSERT INTO public.who_global_data VALUES (88366, 0, 0, 0, 0, 373, 147);
INSERT INTO public.who_global_data VALUES (88367, 0, 0, 0, 0, 373, 208);
INSERT INTO public.who_global_data VALUES (88368, 0, 5, 0, 0, 373, 45);
INSERT INTO public.who_global_data VALUES (88369, 0, 0, 0, 0, 373, 110);
INSERT INTO public.who_global_data VALUES (88370, 0, 0, 0, 0, 373, 88);
INSERT INTO public.who_global_data VALUES (88371, 0, 0, 0, 0, 373, 51);
INSERT INTO public.who_global_data VALUES (88372, 0, 0, 0, 0, 373, 209);
INSERT INTO public.who_global_data VALUES (88373, 0, 0, 0, 0, 373, 205);
INSERT INTO public.who_global_data VALUES (88374, 0, 0, 0, 0, 373, 18);
INSERT INTO public.who_global_data VALUES (88375, 0, 18, 0, 0, 373, 72);
INSERT INTO public.who_global_data VALUES (88376, 0, 0, 0, 0, 373, 44);
INSERT INTO public.who_global_data VALUES (88377, 0, 0, 0, 0, 373, 15);
INSERT INTO public.who_global_data VALUES (88378, 0, 0, 0, 0, 373, 25);
INSERT INTO public.who_global_data VALUES (88379, 0, 0, 0, 0, 373, 179);
INSERT INTO public.who_global_data VALUES (88380, 0, 0, 0, 0, 373, 34);
INSERT INTO public.who_global_data VALUES (88381, 0, 0, 0, 0, 373, 207);
INSERT INTO public.who_global_data VALUES (88382, 0, 0, 0, 0, 373, 166);
INSERT INTO public.who_global_data VALUES (88383, 0, 0, 0, 0, 373, 126);
INSERT INTO public.who_global_data VALUES (88384, 0, 0, 0, 0, 373, 97);
INSERT INTO public.who_global_data VALUES (88385, 0, 0, 0, 0, 373, 36);
INSERT INTO public.who_global_data VALUES (88386, 0, 0, 0, 0, 373, 125);
INSERT INTO public.who_global_data VALUES (88387, 0, 0, 0, 0, 373, 124);
INSERT INTO public.who_global_data VALUES (88388, 0, 0, 0, 0, 373, 185);
INSERT INTO public.who_global_data VALUES (88389, 0, 8, 0, 0, 373, 194);
INSERT INTO public.who_global_data VALUES (88390, 0, 0, 0, 0, 373, 144);
INSERT INTO public.who_global_data VALUES (88391, 1, 10, 0, 0, 373, 19);
INSERT INTO public.who_global_data VALUES (88392, 0, 0, 0, 0, 373, 217);
INSERT INTO public.who_global_data VALUES (88393, 0, 0, 0, 0, 373, 148);
INSERT INTO public.who_global_data VALUES (88394, 0, 0, 0, 0, 373, 86);
INSERT INTO public.who_global_data VALUES (88395, 0, 0, 0, 0, 373, 13);
INSERT INTO public.who_global_data VALUES (88396, 0, 0, 0, 0, 373, 157);
INSERT INTO public.who_global_data VALUES (88397, 3, 9, 0, 0, 373, 8);
INSERT INTO public.who_global_data VALUES (88398, 0, 0, 0, 0, 373, 73);
INSERT INTO public.who_global_data VALUES (88399, 0, 0, 0, 0, 373, 101);
INSERT INTO public.who_global_data VALUES (88400, 0, 0, 0, 0, 373, 165);
INSERT INTO public.who_global_data VALUES (88401, 0, 0, 0, 0, 373, 14);
INSERT INTO public.who_global_data VALUES (88402, 0, 0, 0, 0, 374, 193);
INSERT INTO public.who_global_data VALUES (88403, 0, 0, 0, 0, 374, 113);
INSERT INTO public.who_global_data VALUES (88404, 0, 0, 0, 0, 374, 143);
INSERT INTO public.who_global_data VALUES (88405, 0, 0, 0, 0, 374, 219);
INSERT INTO public.who_global_data VALUES (88406, 0, 0, 0, 0, 374, 186);
INSERT INTO public.who_global_data VALUES (88407, 0, 0, 0, 0, 374, 52);
INSERT INTO public.who_global_data VALUES (88408, 0, 0, 0, 0, 374, 180);
INSERT INTO public.who_global_data VALUES (88409, 0, 0, 0, 0, 374, 167);
INSERT INTO public.who_global_data VALUES (88410, 0, 0, 0, 0, 374, 154);
INSERT INTO public.who_global_data VALUES (88411, 0, 0, 0, 0, 374, 94);
INSERT INTO public.who_global_data VALUES (88412, 0, 0, 0, 0, 374, 66);
INSERT INTO public.who_global_data VALUES (88413, 2, 11, 0, 0, 374, 58);
INSERT INTO public.who_global_data VALUES (88414, 0, 0, 0, 0, 374, 163);
INSERT INTO public.who_global_data VALUES (88415, 0, 0, 0, 0, 374, 37);
INSERT INTO public.who_global_data VALUES (88416, 0, 0, 0, 0, 374, 142);
INSERT INTO public.who_global_data VALUES (88417, 0, 0, 0, 0, 374, 83);
INSERT INTO public.who_global_data VALUES (88418, 0, 0, 0, 0, 374, 228);
INSERT INTO public.who_global_data VALUES (88419, 0, 0, 0, 0, 374, 188);
INSERT INTO public.who_global_data VALUES (88420, 0, 0, 0, 0, 374, 62);
INSERT INTO public.who_global_data VALUES (88421, 0, 0, 0, 0, 374, 160);
INSERT INTO public.who_global_data VALUES (88422, 0, 0, 0, 0, 374, 50);
INSERT INTO public.who_global_data VALUES (88423, 0, 0, 0, 0, 374, 33);
INSERT INTO public.who_global_data VALUES (88424, 0, 0, 0, 0, 374, 183);
INSERT INTO public.who_global_data VALUES (88425, 0, 0, 0, 0, 374, 92);
INSERT INTO public.who_global_data VALUES (88426, 0, 0, 0, 0, 374, 158);
INSERT INTO public.who_global_data VALUES (88427, 0, 0, 0, 0, 374, 67);
INSERT INTO public.who_global_data VALUES (88428, 0, 0, 0, 0, 374, 57);
INSERT INTO public.who_global_data VALUES (88429, 0, 0, 0, 0, 374, 38);
INSERT INTO public.who_global_data VALUES (88430, 0, 0, 0, 0, 374, 141);
INSERT INTO public.who_global_data VALUES (88431, 0, 0, 0, 0, 374, 178);
INSERT INTO public.who_global_data VALUES (88432, 0, 0, 0, 0, 374, 108);
INSERT INTO public.who_global_data VALUES (88433, 0, 0, 0, 0, 374, 39);
INSERT INTO public.who_global_data VALUES (88434, 0, 0, 0, 0, 374, 2);
INSERT INTO public.who_global_data VALUES (88435, 0, 0, 0, 0, 374, 195);
INSERT INTO public.who_global_data VALUES (88436, 0, 0, 0, 0, 374, 107);
INSERT INTO public.who_global_data VALUES (88437, 0, 5, 0, 0, 374, 161);
INSERT INTO public.who_global_data VALUES (88438, 0, 0, 0, 0, 374, 212);
INSERT INTO public.who_global_data VALUES (88439, 0, 7, 0, 0, 374, 181);
INSERT INTO public.who_global_data VALUES (88440, 0, 0, 0, 0, 374, 53);
INSERT INTO public.who_global_data VALUES (88441, 0, 0, 0, 0, 374, 164);
INSERT INTO public.who_global_data VALUES (88442, 0, 0, 0, 0, 374, 140);
INSERT INTO public.who_global_data VALUES (88443, 0, 0, 0, 0, 374, 20);
INSERT INTO public.who_global_data VALUES (88444, 1462, 5999, 26, 132, 374, 112);
INSERT INTO public.who_global_data VALUES (88445, 0, 0, 0, 0, 374, 111);
INSERT INTO public.who_global_data VALUES (88446, 0, 0, 0, 0, 374, 71);
INSERT INTO public.who_global_data VALUES (88447, 0, 0, 0, 0, 374, 218);
INSERT INTO public.who_global_data VALUES (88448, 0, 0, 0, 0, 374, 43);
INSERT INTO public.who_global_data VALUES (88449, 0, 0, 0, 0, 374, 49);
INSERT INTO public.who_global_data VALUES (88450, 0, 0, 0, 0, 374, 1);
INSERT INTO public.who_global_data VALUES (88451, 0, 0, 0, 0, 374, 48);
INSERT INTO public.who_global_data VALUES (88452, 0, 0, 0, 0, 374, 232);
INSERT INTO public.who_global_data VALUES (88453, 0, 0, 0, 0, 374, 175);
INSERT INTO public.who_global_data VALUES (88454, 0, 0, 0, 0, 374, 21);
INSERT INTO public.who_global_data VALUES (88455, 0, 0, 0, 0, 374, 156);
INSERT INTO public.who_global_data VALUES (88456, 0, 0, 0, 0, 374, 95);
INSERT INTO public.who_global_data VALUES (88457, 0, 0, 0, 0, 374, 177);
INSERT INTO public.who_global_data VALUES (88458, 0, 0, 0, 0, 374, 210);
INSERT INTO public.who_global_data VALUES (88459, 0, 0, 0, 0, 374, 120);
INSERT INTO public.who_global_data VALUES (88460, 0, 0, 0, 0, 374, 135);
INSERT INTO public.who_global_data VALUES (88461, 0, 0, 0, 0, 374, 206);
INSERT INTO public.who_global_data VALUES (88462, 0, 0, 0, 0, 374, 189);
INSERT INTO public.who_global_data VALUES (88463, 0, 0, 0, 0, 374, 129);
INSERT INTO public.who_global_data VALUES (88464, 0, 0, 0, 0, 374, 121);
INSERT INTO public.who_global_data VALUES (88465, 0, 0, 0, 0, 374, 59);
INSERT INTO public.who_global_data VALUES (88466, 0, 0, 0, 0, 374, 96);
INSERT INTO public.who_global_data VALUES (88467, 0, 0, 0, 0, 374, 41);
INSERT INTO public.who_global_data VALUES (88468, 0, 0, 0, 0, 374, 216);
INSERT INTO public.who_global_data VALUES (88469, 0, 0, 0, 0, 374, 236);
INSERT INTO public.who_global_data VALUES (88470, 0, 0, 0, 0, 374, 150);
INSERT INTO public.who_global_data VALUES (88471, 0, 0, 0, 0, 374, 61);
INSERT INTO public.who_global_data VALUES (88472, 0, 0, 0, 0, 374, 7);
INSERT INTO public.who_global_data VALUES (88473, 1, 1, 0, 0, 374, 169);
INSERT INTO public.who_global_data VALUES (88474, 1, 4, 0, 0, 374, 28);
INSERT INTO public.who_global_data VALUES (88475, 0, 0, 0, 0, 374, 85);
INSERT INTO public.who_global_data VALUES (88476, 0, 0, 0, 0, 374, 211);
INSERT INTO public.who_global_data VALUES (88477, 0, 0, 0, 0, 374, 60);
INSERT INTO public.who_global_data VALUES (88478, 0, 0, 0, 0, 374, 3);
INSERT INTO public.who_global_data VALUES (88479, 0, 0, 0, 0, 374, 11);
INSERT INTO public.who_global_data VALUES (88480, 3, 4, 0, 0, 374, 89);
INSERT INTO public.who_global_data VALUES (88481, 0, 0, 0, 0, 374, 24);
INSERT INTO public.who_global_data VALUES (88482, 0, 0, 0, 0, 374, 162);
INSERT INTO public.who_global_data VALUES (88483, 0, 0, 0, 0, 374, 100);
INSERT INTO public.who_global_data VALUES (88484, 0, 0, 0, 0, 374, 47);
INSERT INTO public.who_global_data VALUES (88485, 0, 0, 0, 0, 374, 29);
INSERT INTO public.who_global_data VALUES (88486, 0, 0, 0, 0, 374, 40);
INSERT INTO public.who_global_data VALUES (88487, 0, 0, 0, 0, 374, 222);
INSERT INTO public.who_global_data VALUES (88488, 0, 0, 0, 0, 374, 132);
INSERT INTO public.who_global_data VALUES (88489, 0, 0, 0, 0, 374, 130);
INSERT INTO public.who_global_data VALUES (88490, 0, 0, 0, 0, 374, 234);
INSERT INTO public.who_global_data VALUES (88491, 0, 0, 0, 0, 374, 23);
INSERT INTO public.who_global_data VALUES (88492, 0, 0, 0, 0, 374, 192);
INSERT INTO public.who_global_data VALUES (88493, 0, 0, 0, 0, 374, 69);
INSERT INTO public.who_global_data VALUES (88494, 0, 0, 0, 0, 374, 187);
INSERT INTO public.who_global_data VALUES (88495, 0, 0, 0, 0, 374, 230);
INSERT INTO public.who_global_data VALUES (88496, 0, 0, 0, 0, 374, 77);
INSERT INTO public.who_global_data VALUES (88497, 0, 0, 0, 0, 374, 9);
INSERT INTO public.who_global_data VALUES (88498, 0, 0, 0, 0, 374, 74);
INSERT INTO public.who_global_data VALUES (88499, 0, 0, 0, 0, 374, 224);
INSERT INTO public.who_global_data VALUES (88500, 0, 0, 0, 0, 374, 199);
INSERT INTO public.who_global_data VALUES (88501, 0, 0, 0, 0, 374, 190);
INSERT INTO public.who_global_data VALUES (88502, 0, 0, 0, 0, 374, 12);
INSERT INTO public.who_global_data VALUES (88503, 0, 0, 0, 0, 374, 104);
INSERT INTO public.who_global_data VALUES (88504, 0, 0, 0, 0, 374, 153);
INSERT INTO public.who_global_data VALUES (88505, 2, 2, 0, 0, 374, 91);
INSERT INTO public.who_global_data VALUES (88506, 0, 0, 0, 0, 374, 215);
INSERT INTO public.who_global_data VALUES (88507, 0, 8, 0, 0, 374, 84);
INSERT INTO public.who_global_data VALUES (88508, 0, 0, 0, 0, 374, 231);
INSERT INTO public.who_global_data VALUES (88509, 0, 0, 0, 0, 374, 196);
INSERT INTO public.who_global_data VALUES (88510, 0, 0, 0, 0, 374, 105);
INSERT INTO public.who_global_data VALUES (88511, 0, 0, 0, 0, 374, 122);
INSERT INTO public.who_global_data VALUES (88512, 0, 0, 0, 0, 374, 159);
INSERT INTO public.who_global_data VALUES (88513, 0, 0, 0, 0, 374, 75);
INSERT INTO public.who_global_data VALUES (88514, 0, 0, 0, 0, 374, 27);
INSERT INTO public.who_global_data VALUES (88515, 0, 0, 0, 0, 374, 54);
INSERT INTO public.who_global_data VALUES (88516, 0, 0, 0, 0, 374, 226);
INSERT INTO public.who_global_data VALUES (88517, 0, 0, 0, 0, 374, 79);
INSERT INTO public.who_global_data VALUES (88518, 0, 0, 0, 0, 374, 56);
INSERT INTO public.who_global_data VALUES (88519, 0, 0, 0, 0, 374, 117);
INSERT INTO public.who_global_data VALUES (88520, 0, 0, 0, 0, 374, 152);
INSERT INTO public.who_global_data VALUES (88521, 0, 0, 0, 0, 374, 16);
INSERT INTO public.who_global_data VALUES (88522, 0, 0, 0, 0, 374, 10);
INSERT INTO public.who_global_data VALUES (88523, 0, 0, 0, 0, 374, 201);
INSERT INTO public.who_global_data VALUES (88524, 0, 0, 0, 0, 374, 174);
INSERT INTO public.who_global_data VALUES (88525, 0, 0, 0, 0, 374, 119);
INSERT INTO public.who_global_data VALUES (88526, 0, 0, 0, 0, 374, 168);
INSERT INTO public.who_global_data VALUES (88527, 3, 11, 0, 0, 374, 99);
INSERT INTO public.who_global_data VALUES (88528, 0, 0, 0, 0, 374, 171);
INSERT INTO public.who_global_data VALUES (88529, 0, 0, 0, 0, 374, 87);
INSERT INTO public.who_global_data VALUES (88530, 0, 0, 0, 0, 374, 123);
INSERT INTO public.who_global_data VALUES (88531, 0, 0, 0, 0, 374, 151);
INSERT INTO public.who_global_data VALUES (88532, 0, 0, 0, 0, 374, 213);
INSERT INTO public.who_global_data VALUES (88533, 0, 0, 0, 0, 374, 118);
INSERT INTO public.who_global_data VALUES (88534, 0, 0, 0, 0, 374, 134);
INSERT INTO public.who_global_data VALUES (88535, 0, 0, 0, 0, 374, 65);
INSERT INTO public.who_global_data VALUES (88536, 0, 0, 0, 0, 374, 102);
INSERT INTO public.who_global_data VALUES (88537, 0, 0, 0, 0, 374, 223);
INSERT INTO public.who_global_data VALUES (88538, 0, 0, 0, 0, 374, 4);
INSERT INTO public.who_global_data VALUES (88539, 0, 0, 0, 0, 374, 146);
INSERT INTO public.who_global_data VALUES (88540, 0, 0, 0, 0, 374, 31);
INSERT INTO public.who_global_data VALUES (88541, 0, 0, 0, 0, 374, 127);
INSERT INTO public.who_global_data VALUES (88542, 0, 0, 0, 0, 374, 22);
INSERT INTO public.who_global_data VALUES (88543, 0, 0, 0, 0, 374, 115);
INSERT INTO public.who_global_data VALUES (88544, 0, 0, 0, 0, 374, 106);
INSERT INTO public.who_global_data VALUES (88545, 0, 0, 0, 0, 374, 90);
INSERT INTO public.who_global_data VALUES (88546, 0, 0, 0, 0, 374, 70);
INSERT INTO public.who_global_data VALUES (88547, 0, 5, 0, 0, 374, 46);
INSERT INTO public.who_global_data VALUES (88548, 0, 0, 0, 0, 374, 139);
INSERT INTO public.who_global_data VALUES (88549, 0, 0, 0, 0, 374, 42);
INSERT INTO public.who_global_data VALUES (88550, 0, 0, 0, 0, 374, 80);
INSERT INTO public.who_global_data VALUES (88551, 0, 0, 0, 0, 374, 203);
INSERT INTO public.who_global_data VALUES (88552, 0, 0, 0, 0, 374, 136);
INSERT INTO public.who_global_data VALUES (88553, 0, 0, 0, 0, 374, 63);
INSERT INTO public.who_global_data VALUES (88554, 0, 0, 0, 0, 374, 17);
INSERT INTO public.who_global_data VALUES (88555, 0, 0, 0, 0, 374, 172);
INSERT INTO public.who_global_data VALUES (88556, 0, 0, 0, 0, 374, 109);
INSERT INTO public.who_global_data VALUES (88557, 0, 0, 0, 0, 374, 200);
INSERT INTO public.who_global_data VALUES (88558, 0, 0, 0, 0, 374, 93);
INSERT INTO public.who_global_data VALUES (88559, 0, 0, 0, 0, 374, 5);
INSERT INTO public.who_global_data VALUES (88560, 0, 0, 0, 0, 374, 214);
INSERT INTO public.who_global_data VALUES (88561, 0, 0, 0, 0, 374, 204);
INSERT INTO public.who_global_data VALUES (88562, 0, 0, 0, 0, 374, 198);
INSERT INTO public.who_global_data VALUES (88563, 0, 0, 0, 0, 374, 173);
INSERT INTO public.who_global_data VALUES (88564, 0, 0, 0, 0, 374, 229);
INSERT INTO public.who_global_data VALUES (88565, 0, 0, 0, 0, 374, 76);
INSERT INTO public.who_global_data VALUES (88566, 0, 0, 0, 0, 374, 138);
INSERT INTO public.who_global_data VALUES (88567, 0, 0, 0, 0, 374, 98);
INSERT INTO public.who_global_data VALUES (88568, 0, 0, 0, 0, 374, 103);
INSERT INTO public.who_global_data VALUES (88569, 0, 0, 0, 0, 374, 225);
INSERT INTO public.who_global_data VALUES (88570, 0, 0, 0, 0, 374, 131);
INSERT INTO public.who_global_data VALUES (88571, 0, 0, 0, 0, 374, 235);
INSERT INTO public.who_global_data VALUES (88572, 0, 0, 0, 0, 374, 137);
INSERT INTO public.who_global_data VALUES (88573, 0, 8, 0, 0, 374, 81);
INSERT INTO public.who_global_data VALUES (88574, 0, 0, 0, 0, 374, 182);
INSERT INTO public.who_global_data VALUES (88575, 0, 0, 0, 0, 374, 145);
INSERT INTO public.who_global_data VALUES (88576, 0, 0, 0, 0, 374, 26);
INSERT INTO public.who_global_data VALUES (88577, 0, 0, 0, 0, 374, 170);
INSERT INTO public.who_global_data VALUES (88578, 0, 0, 0, 0, 374, 191);
INSERT INTO public.who_global_data VALUES (88579, 0, 0, 0, 0, 374, 221);
INSERT INTO public.who_global_data VALUES (88580, 0, 0, 0, 0, 374, 64);
INSERT INTO public.who_global_data VALUES (88581, 0, 0, 0, 0, 374, 116);
INSERT INTO public.who_global_data VALUES (88582, 0, 0, 0, 0, 374, 128);
INSERT INTO public.who_global_data VALUES (88583, 0, 0, 0, 0, 374, 6);
INSERT INTO public.who_global_data VALUES (88584, 0, 0, 0, 0, 374, 227);
INSERT INTO public.who_global_data VALUES (88585, 0, 0, 0, 0, 374, 68);
INSERT INTO public.who_global_data VALUES (88586, 0, 0, 0, 0, 374, 184);
INSERT INTO public.who_global_data VALUES (88587, 0, 0, 0, 0, 374, 82);
INSERT INTO public.who_global_data VALUES (88588, 0, 0, 0, 0, 374, 149);
INSERT INTO public.who_global_data VALUES (88589, 0, 0, 0, 0, 374, 197);
INSERT INTO public.who_global_data VALUES (88590, 0, 0, 0, 0, 374, 78);
INSERT INTO public.who_global_data VALUES (88591, 0, 0, 0, 0, 374, 233);
INSERT INTO public.who_global_data VALUES (88592, 0, 0, 0, 0, 374, 133);
INSERT INTO public.who_global_data VALUES (88593, 0, 0, 0, 0, 374, 35);
INSERT INTO public.who_global_data VALUES (88594, 0, 0, 0, 0, 374, 114);
INSERT INTO public.who_global_data VALUES (88595, 3, 14, 0, 0, 374, 237);
INSERT INTO public.who_global_data VALUES (88596, 0, 0, 0, 0, 374, 55);
INSERT INTO public.who_global_data VALUES (88597, 0, 0, 0, 0, 374, 176);
INSERT INTO public.who_global_data VALUES (88598, 0, 0, 0, 0, 374, 202);
INSERT INTO public.who_global_data VALUES (88599, 0, 0, 0, 0, 374, 155);
INSERT INTO public.who_global_data VALUES (88600, 0, 0, 0, 0, 374, 32);
INSERT INTO public.who_global_data VALUES (88601, 0, 0, 0, 0, 374, 220);
INSERT INTO public.who_global_data VALUES (88602, 0, 0, 0, 0, 374, 30);
INSERT INTO public.who_global_data VALUES (88603, 0, 0, 0, 0, 374, 147);
INSERT INTO public.who_global_data VALUES (88604, 0, 0, 0, 0, 374, 208);
INSERT INTO public.who_global_data VALUES (88605, 0, 5, 0, 0, 374, 45);
INSERT INTO public.who_global_data VALUES (88606, 0, 0, 0, 0, 374, 110);
INSERT INTO public.who_global_data VALUES (88607, 0, 0, 0, 0, 374, 88);
INSERT INTO public.who_global_data VALUES (88608, 0, 0, 0, 0, 374, 51);
INSERT INTO public.who_global_data VALUES (88609, 0, 0, 0, 0, 374, 209);
INSERT INTO public.who_global_data VALUES (88610, 0, 0, 0, 0, 374, 205);
INSERT INTO public.who_global_data VALUES (88611, 0, 0, 0, 0, 374, 18);
INSERT INTO public.who_global_data VALUES (88612, 0, 18, 0, 0, 374, 72);
INSERT INTO public.who_global_data VALUES (88613, 0, 0, 0, 0, 374, 44);
INSERT INTO public.who_global_data VALUES (88614, 0, 0, 0, 0, 374, 15);
INSERT INTO public.who_global_data VALUES (88615, 0, 0, 0, 0, 374, 25);
INSERT INTO public.who_global_data VALUES (88616, 0, 0, 0, 0, 374, 179);
INSERT INTO public.who_global_data VALUES (88617, 0, 0, 0, 0, 374, 34);
INSERT INTO public.who_global_data VALUES (88618, 0, 0, 0, 0, 374, 207);
INSERT INTO public.who_global_data VALUES (88619, 0, 0, 0, 0, 374, 166);
INSERT INTO public.who_global_data VALUES (88620, 0, 0, 0, 0, 374, 126);
INSERT INTO public.who_global_data VALUES (88621, 0, 0, 0, 0, 374, 97);
INSERT INTO public.who_global_data VALUES (88622, 0, 0, 0, 0, 374, 36);
INSERT INTO public.who_global_data VALUES (88623, 0, 0, 0, 0, 374, 125);
INSERT INTO public.who_global_data VALUES (88624, 0, 0, 0, 0, 374, 124);
INSERT INTO public.who_global_data VALUES (88625, 0, 0, 0, 0, 374, 185);
INSERT INTO public.who_global_data VALUES (88626, 8, 8, 0, 0, 374, 194);
INSERT INTO public.who_global_data VALUES (88627, 0, 0, 0, 0, 374, 144);
INSERT INTO public.who_global_data VALUES (88628, 0, 9, 0, 0, 374, 19);
INSERT INTO public.who_global_data VALUES (88629, 0, 0, 0, 0, 374, 217);
INSERT INTO public.who_global_data VALUES (88630, 0, 0, 0, 0, 374, 148);
INSERT INTO public.who_global_data VALUES (88631, 0, 0, 0, 0, 374, 86);
INSERT INTO public.who_global_data VALUES (88632, 0, 0, 0, 0, 374, 13);
INSERT INTO public.who_global_data VALUES (88633, 0, 0, 0, 0, 374, 157);
INSERT INTO public.who_global_data VALUES (88634, 0, 6, 0, 0, 374, 8);
INSERT INTO public.who_global_data VALUES (88635, 0, 0, 0, 0, 374, 73);
INSERT INTO public.who_global_data VALUES (88636, 0, 0, 0, 0, 374, 101);
INSERT INTO public.who_global_data VALUES (88637, 0, 0, 0, 0, 374, 165);
INSERT INTO public.who_global_data VALUES (88638, 0, 0, 0, 0, 374, 14);
INSERT INTO public.who_global_data VALUES (88639, 0, 0, 0, 0, 375, 193);
INSERT INTO public.who_global_data VALUES (88640, 0, 0, 0, 0, 375, 113);
INSERT INTO public.who_global_data VALUES (88641, 0, 0, 0, 0, 375, 143);
INSERT INTO public.who_global_data VALUES (88642, 0, 0, 0, 0, 375, 219);
INSERT INTO public.who_global_data VALUES (88643, 0, 0, 0, 0, 375, 186);
INSERT INTO public.who_global_data VALUES (88644, 0, 0, 0, 0, 375, 52);
INSERT INTO public.who_global_data VALUES (88645, 0, 0, 0, 0, 375, 180);
INSERT INTO public.who_global_data VALUES (88646, 0, 0, 0, 0, 375, 167);
INSERT INTO public.who_global_data VALUES (88647, 0, 0, 0, 0, 375, 154);
INSERT INTO public.who_global_data VALUES (88648, 0, 0, 0, 0, 375, 94);
INSERT INTO public.who_global_data VALUES (88649, 0, 0, 0, 0, 375, 66);
INSERT INTO public.who_global_data VALUES (88650, 0, 9, 0, 0, 375, 58);
INSERT INTO public.who_global_data VALUES (88651, 0, 0, 0, 0, 375, 163);
INSERT INTO public.who_global_data VALUES (88652, 0, 0, 0, 0, 375, 37);
INSERT INTO public.who_global_data VALUES (88653, 0, 0, 0, 0, 375, 142);
INSERT INTO public.who_global_data VALUES (88654, 0, 0, 0, 0, 375, 83);
INSERT INTO public.who_global_data VALUES (88655, 0, 0, 0, 0, 375, 228);
INSERT INTO public.who_global_data VALUES (88656, 0, 0, 0, 0, 375, 188);
INSERT INTO public.who_global_data VALUES (88657, 0, 0, 0, 0, 375, 62);
INSERT INTO public.who_global_data VALUES (88658, 0, 0, 0, 0, 375, 160);
INSERT INTO public.who_global_data VALUES (88659, 0, 0, 0, 0, 375, 50);
INSERT INTO public.who_global_data VALUES (88660, 0, 0, 0, 0, 375, 33);
INSERT INTO public.who_global_data VALUES (88661, 0, 0, 0, 0, 375, 183);
INSERT INTO public.who_global_data VALUES (88662, 0, 0, 0, 0, 375, 92);
INSERT INTO public.who_global_data VALUES (88663, 0, 0, 0, 0, 375, 158);
INSERT INTO public.who_global_data VALUES (88664, 0, 0, 0, 0, 375, 67);
INSERT INTO public.who_global_data VALUES (88665, 0, 0, 0, 0, 375, 57);
INSERT INTO public.who_global_data VALUES (88666, 0, 0, 0, 0, 375, 38);
INSERT INTO public.who_global_data VALUES (88667, 0, 0, 0, 0, 375, 141);
INSERT INTO public.who_global_data VALUES (88668, 0, 0, 0, 0, 375, 178);
INSERT INTO public.who_global_data VALUES (88669, 0, 0, 0, 0, 375, 108);
INSERT INTO public.who_global_data VALUES (88670, 0, 0, 0, 0, 375, 39);
INSERT INTO public.who_global_data VALUES (88671, 0, 0, 0, 0, 375, 2);
INSERT INTO public.who_global_data VALUES (88672, 0, 0, 0, 0, 375, 195);
INSERT INTO public.who_global_data VALUES (88673, 0, 0, 0, 0, 375, 107);
INSERT INTO public.who_global_data VALUES (88674, 0, 5, 0, 0, 375, 161);
INSERT INTO public.who_global_data VALUES (88675, 0, 0, 0, 0, 375, 212);
INSERT INTO public.who_global_data VALUES (88676, 1, 7, 0, 0, 375, 181);
INSERT INTO public.who_global_data VALUES (88677, 0, 0, 0, 0, 375, 53);
INSERT INTO public.who_global_data VALUES (88678, 0, 0, 0, 0, 375, 164);
INSERT INTO public.who_global_data VALUES (88679, 0, 0, 0, 0, 375, 140);
INSERT INTO public.who_global_data VALUES (88680, 0, 0, 0, 0, 375, 20);
INSERT INTO public.who_global_data VALUES (88681, 1772, 4537, 26, 106, 375, 112);
INSERT INTO public.who_global_data VALUES (88682, 0, 0, 0, 0, 375, 111);
INSERT INTO public.who_global_data VALUES (88683, 0, 0, 0, 0, 375, 71);
INSERT INTO public.who_global_data VALUES (88684, 0, 0, 0, 0, 375, 218);
INSERT INTO public.who_global_data VALUES (88685, 0, 0, 0, 0, 375, 43);
INSERT INTO public.who_global_data VALUES (88686, 0, 0, 0, 0, 375, 49);
INSERT INTO public.who_global_data VALUES (88687, 0, 0, 0, 0, 375, 1);
INSERT INTO public.who_global_data VALUES (88688, 0, 0, 0, 0, 375, 48);
INSERT INTO public.who_global_data VALUES (88689, 0, 0, 0, 0, 375, 232);
INSERT INTO public.who_global_data VALUES (88690, 0, 0, 0, 0, 375, 175);
INSERT INTO public.who_global_data VALUES (88691, 0, 0, 0, 0, 375, 21);
INSERT INTO public.who_global_data VALUES (88692, 0, 0, 0, 0, 375, 156);
INSERT INTO public.who_global_data VALUES (88693, 0, 0, 0, 0, 375, 95);
INSERT INTO public.who_global_data VALUES (88694, 0, 0, 0, 0, 375, 177);
INSERT INTO public.who_global_data VALUES (88695, 0, 0, 0, 0, 375, 210);
INSERT INTO public.who_global_data VALUES (88696, 0, 0, 0, 0, 375, 120);
INSERT INTO public.who_global_data VALUES (88697, 0, 0, 0, 0, 375, 135);
INSERT INTO public.who_global_data VALUES (88698, 0, 0, 0, 0, 375, 206);
INSERT INTO public.who_global_data VALUES (88699, 0, 0, 0, 0, 375, 189);
INSERT INTO public.who_global_data VALUES (88700, 0, 0, 0, 0, 375, 129);
INSERT INTO public.who_global_data VALUES (88701, 0, 0, 0, 0, 375, 121);
INSERT INTO public.who_global_data VALUES (88702, 0, 0, 0, 0, 375, 59);
INSERT INTO public.who_global_data VALUES (88703, 0, 0, 0, 0, 375, 96);
INSERT INTO public.who_global_data VALUES (88704, 0, 0, 0, 0, 375, 41);
INSERT INTO public.who_global_data VALUES (88705, 0, 0, 0, 0, 375, 216);
INSERT INTO public.who_global_data VALUES (88706, 0, 0, 0, 0, 375, 236);
INSERT INTO public.who_global_data VALUES (88707, 0, 0, 0, 0, 375, 150);
INSERT INTO public.who_global_data VALUES (88708, 0, 0, 0, 0, 375, 61);
INSERT INTO public.who_global_data VALUES (88709, 0, 0, 0, 0, 375, 7);
INSERT INTO public.who_global_data VALUES (88710, 0, 0, 0, 0, 375, 169);
INSERT INTO public.who_global_data VALUES (88711, 0, 3, 0, 0, 375, 28);
INSERT INTO public.who_global_data VALUES (88712, 0, 0, 0, 0, 375, 85);
INSERT INTO public.who_global_data VALUES (88713, 0, 0, 0, 0, 375, 211);
INSERT INTO public.who_global_data VALUES (88714, 0, 0, 0, 0, 375, 60);
INSERT INTO public.who_global_data VALUES (88715, 0, 0, 0, 0, 375, 3);
INSERT INTO public.who_global_data VALUES (88716, 0, 0, 0, 0, 375, 11);
INSERT INTO public.who_global_data VALUES (88717, 1, 1, 0, 0, 375, 89);
INSERT INTO public.who_global_data VALUES (88718, 0, 0, 0, 0, 375, 24);
INSERT INTO public.who_global_data VALUES (88719, 0, 0, 0, 0, 375, 162);
INSERT INTO public.who_global_data VALUES (88720, 0, 0, 0, 0, 375, 100);
INSERT INTO public.who_global_data VALUES (88721, 0, 0, 0, 0, 375, 47);
INSERT INTO public.who_global_data VALUES (88722, 0, 0, 0, 0, 375, 29);
INSERT INTO public.who_global_data VALUES (88723, 0, 0, 0, 0, 375, 40);
INSERT INTO public.who_global_data VALUES (88724, 0, 0, 0, 0, 375, 222);
INSERT INTO public.who_global_data VALUES (88725, 0, 0, 0, 0, 375, 132);
INSERT INTO public.who_global_data VALUES (88726, 0, 0, 0, 0, 375, 130);
INSERT INTO public.who_global_data VALUES (88727, 0, 0, 0, 0, 375, 234);
INSERT INTO public.who_global_data VALUES (88728, 0, 0, 0, 0, 375, 23);
INSERT INTO public.who_global_data VALUES (88729, 0, 0, 0, 0, 375, 192);
INSERT INTO public.who_global_data VALUES (88730, 0, 0, 0, 0, 375, 69);
INSERT INTO public.who_global_data VALUES (88731, 0, 0, 0, 0, 375, 187);
INSERT INTO public.who_global_data VALUES (88732, 0, 0, 0, 0, 375, 230);
INSERT INTO public.who_global_data VALUES (88733, 0, 0, 0, 0, 375, 77);
INSERT INTO public.who_global_data VALUES (88734, 0, 0, 0, 0, 375, 9);
INSERT INTO public.who_global_data VALUES (88735, 0, 0, 0, 0, 375, 74);
INSERT INTO public.who_global_data VALUES (88736, 0, 0, 0, 0, 375, 224);
INSERT INTO public.who_global_data VALUES (88737, 0, 0, 0, 0, 375, 199);
INSERT INTO public.who_global_data VALUES (88738, 0, 0, 0, 0, 375, 190);
INSERT INTO public.who_global_data VALUES (88739, 0, 0, 0, 0, 375, 12);
INSERT INTO public.who_global_data VALUES (88740, 0, 0, 0, 0, 375, 104);
INSERT INTO public.who_global_data VALUES (88741, 0, 0, 0, 0, 375, 153);
INSERT INTO public.who_global_data VALUES (88742, 0, 0, 0, 0, 375, 91);
INSERT INTO public.who_global_data VALUES (88743, 0, 0, 0, 0, 375, 215);
INSERT INTO public.who_global_data VALUES (88744, 4, 8, 0, 0, 375, 84);
INSERT INTO public.who_global_data VALUES (88745, 0, 0, 0, 0, 375, 231);
INSERT INTO public.who_global_data VALUES (88746, 0, 0, 0, 0, 375, 196);
INSERT INTO public.who_global_data VALUES (88747, 0, 0, 0, 0, 375, 105);
INSERT INTO public.who_global_data VALUES (88748, 0, 0, 0, 0, 375, 122);
INSERT INTO public.who_global_data VALUES (88749, 0, 0, 0, 0, 375, 159);
INSERT INTO public.who_global_data VALUES (88750, 0, 0, 0, 0, 375, 75);
INSERT INTO public.who_global_data VALUES (88751, 0, 0, 0, 0, 375, 27);
INSERT INTO public.who_global_data VALUES (88752, 0, 0, 0, 0, 375, 54);
INSERT INTO public.who_global_data VALUES (88753, 0, 0, 0, 0, 375, 226);
INSERT INTO public.who_global_data VALUES (88754, 0, 0, 0, 0, 375, 79);
INSERT INTO public.who_global_data VALUES (88755, 0, 0, 0, 0, 375, 56);
INSERT INTO public.who_global_data VALUES (88756, 0, 0, 0, 0, 375, 117);
INSERT INTO public.who_global_data VALUES (88757, 0, 0, 0, 0, 375, 152);
INSERT INTO public.who_global_data VALUES (88758, 0, 0, 0, 0, 375, 16);
INSERT INTO public.who_global_data VALUES (88759, 0, 0, 0, 0, 375, 10);
INSERT INTO public.who_global_data VALUES (88760, 0, 0, 0, 0, 375, 201);
INSERT INTO public.who_global_data VALUES (88761, 0, 0, 0, 0, 375, 174);
INSERT INTO public.who_global_data VALUES (88762, 0, 0, 0, 0, 375, 119);
INSERT INTO public.who_global_data VALUES (88763, 0, 0, 0, 0, 375, 168);
INSERT INTO public.who_global_data VALUES (88764, 0, 8, 0, 0, 375, 99);
INSERT INTO public.who_global_data VALUES (88765, 0, 0, 0, 0, 375, 171);
INSERT INTO public.who_global_data VALUES (88766, 0, 0, 0, 0, 375, 87);
INSERT INTO public.who_global_data VALUES (88767, 0, 0, 0, 0, 375, 123);
INSERT INTO public.who_global_data VALUES (88768, 0, 0, 0, 0, 375, 151);
INSERT INTO public.who_global_data VALUES (88769, 0, 0, 0, 0, 375, 213);
INSERT INTO public.who_global_data VALUES (88770, 0, 0, 0, 0, 375, 118);
INSERT INTO public.who_global_data VALUES (88771, 0, 0, 0, 0, 375, 134);
INSERT INTO public.who_global_data VALUES (88772, 0, 0, 0, 0, 375, 65);
INSERT INTO public.who_global_data VALUES (88773, 0, 0, 0, 0, 375, 102);
INSERT INTO public.who_global_data VALUES (88774, 0, 0, 0, 0, 375, 223);
INSERT INTO public.who_global_data VALUES (88775, 0, 0, 0, 0, 375, 4);
INSERT INTO public.who_global_data VALUES (88776, 0, 0, 0, 0, 375, 146);
INSERT INTO public.who_global_data VALUES (88777, 0, 0, 0, 0, 375, 31);
INSERT INTO public.who_global_data VALUES (88778, 0, 0, 0, 0, 375, 127);
INSERT INTO public.who_global_data VALUES (88779, 0, 0, 0, 0, 375, 22);
INSERT INTO public.who_global_data VALUES (88780, 0, 0, 0, 0, 375, 115);
INSERT INTO public.who_global_data VALUES (88781, 0, 0, 0, 0, 375, 106);
INSERT INTO public.who_global_data VALUES (88782, 0, 0, 0, 0, 375, 90);
INSERT INTO public.who_global_data VALUES (88783, 0, 0, 0, 0, 375, 70);
INSERT INTO public.who_global_data VALUES (88784, 0, 5, 0, 0, 375, 46);
INSERT INTO public.who_global_data VALUES (88785, 0, 0, 0, 0, 375, 139);
INSERT INTO public.who_global_data VALUES (88786, 0, 0, 0, 0, 375, 42);
INSERT INTO public.who_global_data VALUES (88787, 0, 0, 0, 0, 375, 80);
INSERT INTO public.who_global_data VALUES (88788, 0, 0, 0, 0, 375, 203);
INSERT INTO public.who_global_data VALUES (88789, 0, 0, 0, 0, 375, 136);
INSERT INTO public.who_global_data VALUES (88790, 0, 0, 0, 0, 375, 63);
INSERT INTO public.who_global_data VALUES (88791, 0, 0, 0, 0, 375, 17);
INSERT INTO public.who_global_data VALUES (88792, 0, 0, 0, 0, 375, 172);
INSERT INTO public.who_global_data VALUES (88793, 0, 0, 0, 0, 375, 109);
INSERT INTO public.who_global_data VALUES (88794, 0, 0, 0, 0, 375, 200);
INSERT INTO public.who_global_data VALUES (88795, 0, 0, 0, 0, 375, 93);
INSERT INTO public.who_global_data VALUES (88796, 0, 0, 0, 0, 375, 5);
INSERT INTO public.who_global_data VALUES (88797, 0, 0, 0, 0, 375, 214);
INSERT INTO public.who_global_data VALUES (88798, 0, 0, 0, 0, 375, 204);
INSERT INTO public.who_global_data VALUES (88799, 0, 0, 0, 0, 375, 198);
INSERT INTO public.who_global_data VALUES (88800, 0, 0, 0, 0, 375, 173);
INSERT INTO public.who_global_data VALUES (88801, 0, 0, 0, 0, 375, 229);
INSERT INTO public.who_global_data VALUES (88802, 0, 0, 0, 0, 375, 76);
INSERT INTO public.who_global_data VALUES (88803, 0, 0, 0, 0, 375, 138);
INSERT INTO public.who_global_data VALUES (88804, 0, 0, 0, 0, 375, 98);
INSERT INTO public.who_global_data VALUES (88805, 0, 0, 0, 0, 375, 103);
INSERT INTO public.who_global_data VALUES (88806, 0, 0, 0, 0, 375, 225);
INSERT INTO public.who_global_data VALUES (88807, 0, 0, 0, 0, 375, 131);
INSERT INTO public.who_global_data VALUES (88808, 0, 0, 0, 0, 375, 235);
INSERT INTO public.who_global_data VALUES (88809, 0, 0, 0, 0, 375, 137);
INSERT INTO public.who_global_data VALUES (88810, 0, 8, 0, 0, 375, 81);
INSERT INTO public.who_global_data VALUES (88811, 0, 0, 0, 0, 375, 182);
INSERT INTO public.who_global_data VALUES (88812, 0, 0, 0, 0, 375, 145);
INSERT INTO public.who_global_data VALUES (88813, 0, 0, 0, 0, 375, 26);
INSERT INTO public.who_global_data VALUES (88814, 0, 0, 0, 0, 375, 170);
INSERT INTO public.who_global_data VALUES (88815, 0, 0, 0, 0, 375, 191);
INSERT INTO public.who_global_data VALUES (88816, 0, 0, 0, 0, 375, 221);
INSERT INTO public.who_global_data VALUES (88817, 0, 0, 0, 0, 375, 64);
INSERT INTO public.who_global_data VALUES (88818, 0, 0, 0, 0, 375, 116);
INSERT INTO public.who_global_data VALUES (88819, 0, 0, 0, 0, 375, 128);
INSERT INTO public.who_global_data VALUES (88820, 0, 0, 0, 0, 375, 6);
INSERT INTO public.who_global_data VALUES (88821, 0, 0, 0, 0, 375, 227);
INSERT INTO public.who_global_data VALUES (88822, 0, 0, 0, 0, 375, 68);
INSERT INTO public.who_global_data VALUES (88823, 0, 0, 0, 0, 375, 184);
INSERT INTO public.who_global_data VALUES (88824, 0, 0, 0, 0, 375, 82);
INSERT INTO public.who_global_data VALUES (88825, 0, 0, 0, 0, 375, 149);
INSERT INTO public.who_global_data VALUES (88826, 0, 0, 0, 0, 375, 197);
INSERT INTO public.who_global_data VALUES (88827, 0, 0, 0, 0, 375, 78);
INSERT INTO public.who_global_data VALUES (88828, 0, 0, 0, 0, 375, 233);
INSERT INTO public.who_global_data VALUES (88829, 0, 0, 0, 0, 375, 133);
INSERT INTO public.who_global_data VALUES (88830, 0, 0, 0, 0, 375, 35);
INSERT INTO public.who_global_data VALUES (88831, 0, 0, 0, 0, 375, 114);
INSERT INTO public.who_global_data VALUES (88832, 2, 11, 0, 0, 375, 237);
INSERT INTO public.who_global_data VALUES (88833, 0, 0, 0, 0, 375, 55);
INSERT INTO public.who_global_data VALUES (88834, 0, 0, 0, 0, 375, 176);
INSERT INTO public.who_global_data VALUES (88835, 0, 0, 0, 0, 375, 202);
INSERT INTO public.who_global_data VALUES (88836, 0, 0, 0, 0, 375, 155);
INSERT INTO public.who_global_data VALUES (88837, 0, 0, 0, 0, 375, 32);
INSERT INTO public.who_global_data VALUES (88838, 0, 0, 0, 0, 375, 220);
INSERT INTO public.who_global_data VALUES (88839, 0, 0, 0, 0, 375, 30);
INSERT INTO public.who_global_data VALUES (88840, 0, 0, 0, 0, 375, 147);
INSERT INTO public.who_global_data VALUES (88841, 0, 0, 0, 0, 375, 208);
INSERT INTO public.who_global_data VALUES (88842, 0, 5, 0, 0, 375, 45);
INSERT INTO public.who_global_data VALUES (88843, 0, 0, 0, 0, 375, 110);
INSERT INTO public.who_global_data VALUES (88844, 0, 0, 0, 0, 375, 88);
INSERT INTO public.who_global_data VALUES (88845, 0, 0, 0, 0, 375, 51);
INSERT INTO public.who_global_data VALUES (88846, 0, 0, 0, 0, 375, 209);
INSERT INTO public.who_global_data VALUES (88847, 0, 0, 0, 0, 375, 205);
INSERT INTO public.who_global_data VALUES (88848, 0, 0, 0, 0, 375, 18);
INSERT INTO public.who_global_data VALUES (88849, 6, 18, 0, 0, 375, 72);
INSERT INTO public.who_global_data VALUES (88850, 0, 0, 0, 0, 375, 44);
INSERT INTO public.who_global_data VALUES (88851, 0, 0, 0, 0, 375, 15);
INSERT INTO public.who_global_data VALUES (88852, 0, 0, 0, 0, 375, 25);
INSERT INTO public.who_global_data VALUES (88853, 0, 0, 0, 0, 375, 179);
INSERT INTO public.who_global_data VALUES (88854, 0, 0, 0, 0, 375, 34);
INSERT INTO public.who_global_data VALUES (88855, 0, 0, 0, 0, 375, 207);
INSERT INTO public.who_global_data VALUES (88856, 0, 0, 0, 0, 375, 166);
INSERT INTO public.who_global_data VALUES (88857, 0, 0, 0, 0, 375, 126);
INSERT INTO public.who_global_data VALUES (88858, 0, 0, 0, 0, 375, 97);
INSERT INTO public.who_global_data VALUES (88859, 0, 0, 0, 0, 375, 36);
INSERT INTO public.who_global_data VALUES (88860, 0, 0, 0, 0, 375, 125);
INSERT INTO public.who_global_data VALUES (88861, 0, 0, 0, 0, 375, 124);
INSERT INTO public.who_global_data VALUES (88862, 0, 0, 0, 0, 375, 185);
INSERT INTO public.who_global_data VALUES (88863, 0, 0, 0, 0, 375, 194);
INSERT INTO public.who_global_data VALUES (88864, 0, 0, 0, 0, 375, 144);
INSERT INTO public.who_global_data VALUES (88865, 0, 9, 0, 0, 375, 19);
INSERT INTO public.who_global_data VALUES (88866, 0, 0, 0, 0, 375, 217);
INSERT INTO public.who_global_data VALUES (88867, 0, 0, 0, 0, 375, 148);
INSERT INTO public.who_global_data VALUES (88868, 0, 0, 0, 0, 375, 86);
INSERT INTO public.who_global_data VALUES (88869, 0, 0, 0, 0, 375, 13);
INSERT INTO public.who_global_data VALUES (88870, 0, 0, 0, 0, 375, 157);
INSERT INTO public.who_global_data VALUES (88871, 0, 6, 0, 0, 375, 8);
INSERT INTO public.who_global_data VALUES (88872, 0, 0, 0, 0, 375, 73);
INSERT INTO public.who_global_data VALUES (88873, 0, 0, 0, 0, 375, 101);
INSERT INTO public.who_global_data VALUES (88874, 0, 0, 0, 0, 375, 165);
INSERT INTO public.who_global_data VALUES (88875, 0, 0, 0, 0, 375, 14);
INSERT INTO public.who_global_data VALUES (88876, 0, 0, 0, 0, 376, 193);
INSERT INTO public.who_global_data VALUES (88877, 0, 0, 0, 0, 376, 113);
INSERT INTO public.who_global_data VALUES (88878, 0, 0, 0, 0, 376, 143);
INSERT INTO public.who_global_data VALUES (88879, 0, 0, 0, 0, 376, 219);
INSERT INTO public.who_global_data VALUES (88880, 0, 0, 0, 0, 376, 186);
INSERT INTO public.who_global_data VALUES (88881, 0, 0, 0, 0, 376, 52);
INSERT INTO public.who_global_data VALUES (88882, 0, 0, 0, 0, 376, 180);
INSERT INTO public.who_global_data VALUES (88883, 0, 0, 0, 0, 376, 167);
INSERT INTO public.who_global_data VALUES (88884, 0, 0, 0, 0, 376, 154);
INSERT INTO public.who_global_data VALUES (88885, 0, 0, 0, 0, 376, 94);
INSERT INTO public.who_global_data VALUES (88886, 0, 0, 0, 0, 376, 66);
INSERT INTO public.who_global_data VALUES (88887, 1, 9, 0, 0, 376, 58);
INSERT INTO public.who_global_data VALUES (88888, 0, 0, 0, 0, 376, 163);
INSERT INTO public.who_global_data VALUES (88889, 0, 0, 0, 0, 376, 37);
INSERT INTO public.who_global_data VALUES (88890, 0, 0, 0, 0, 376, 142);
INSERT INTO public.who_global_data VALUES (88891, 0, 0, 0, 0, 376, 83);
INSERT INTO public.who_global_data VALUES (88892, 0, 0, 0, 0, 376, 228);
INSERT INTO public.who_global_data VALUES (88893, 0, 0, 0, 0, 376, 188);
INSERT INTO public.who_global_data VALUES (88894, 0, 0, 0, 0, 376, 62);
INSERT INTO public.who_global_data VALUES (88895, 0, 0, 0, 0, 376, 160);
INSERT INTO public.who_global_data VALUES (88896, 0, 0, 0, 0, 376, 50);
INSERT INTO public.who_global_data VALUES (88897, 0, 0, 0, 0, 376, 33);
INSERT INTO public.who_global_data VALUES (88898, 0, 0, 0, 0, 376, 183);
INSERT INTO public.who_global_data VALUES (88899, 0, 0, 0, 0, 376, 92);
INSERT INTO public.who_global_data VALUES (88900, 0, 0, 0, 0, 376, 158);
INSERT INTO public.who_global_data VALUES (88901, 0, 0, 0, 0, 376, 67);
INSERT INTO public.who_global_data VALUES (88902, 0, 0, 0, 0, 376, 57);
INSERT INTO public.who_global_data VALUES (88903, 0, 0, 0, 0, 376, 38);
INSERT INTO public.who_global_data VALUES (88904, 0, 0, 0, 0, 376, 141);
INSERT INTO public.who_global_data VALUES (88905, 0, 0, 0, 0, 376, 178);
INSERT INTO public.who_global_data VALUES (88906, 0, 0, 0, 0, 376, 108);
INSERT INTO public.who_global_data VALUES (88907, 0, 0, 0, 0, 376, 39);
INSERT INTO public.who_global_data VALUES (88908, 0, 0, 0, 0, 376, 2);
INSERT INTO public.who_global_data VALUES (88909, 0, 0, 0, 0, 376, 195);
INSERT INTO public.who_global_data VALUES (88910, 0, 0, 0, 0, 376, 107);
INSERT INTO public.who_global_data VALUES (88911, 5, 5, 0, 0, 376, 161);
INSERT INTO public.who_global_data VALUES (88912, 0, 0, 0, 0, 376, 212);
INSERT INTO public.who_global_data VALUES (88913, 1, 6, 0, 0, 376, 181);
INSERT INTO public.who_global_data VALUES (88914, 0, 0, 0, 0, 376, 53);
INSERT INTO public.who_global_data VALUES (88915, 0, 0, 0, 0, 376, 164);
INSERT INTO public.who_global_data VALUES (88916, 0, 0, 0, 0, 376, 140);
INSERT INTO public.who_global_data VALUES (88917, 0, 0, 0, 0, 376, 20);
INSERT INTO public.who_global_data VALUES (88918, 776, 2765, 24, 80, 376, 112);
INSERT INTO public.who_global_data VALUES (88919, 0, 0, 0, 0, 376, 111);
INSERT INTO public.who_global_data VALUES (88920, 0, 0, 0, 0, 376, 71);
INSERT INTO public.who_global_data VALUES (88921, 0, 0, 0, 0, 376, 218);
INSERT INTO public.who_global_data VALUES (88922, 0, 0, 0, 0, 376, 43);
INSERT INTO public.who_global_data VALUES (88923, 0, 0, 0, 0, 376, 49);
INSERT INTO public.who_global_data VALUES (88924, 0, 0, 0, 0, 376, 1);
INSERT INTO public.who_global_data VALUES (88925, 0, 0, 0, 0, 376, 48);
INSERT INTO public.who_global_data VALUES (88926, 0, 0, 0, 0, 376, 232);
INSERT INTO public.who_global_data VALUES (88927, 0, 0, 0, 0, 376, 175);
INSERT INTO public.who_global_data VALUES (88928, 0, 0, 0, 0, 376, 21);
INSERT INTO public.who_global_data VALUES (88929, 0, 0, 0, 0, 376, 156);
INSERT INTO public.who_global_data VALUES (88930, 0, 0, 0, 0, 376, 95);
INSERT INTO public.who_global_data VALUES (88931, 0, 0, 0, 0, 376, 177);
INSERT INTO public.who_global_data VALUES (88932, 0, 0, 0, 0, 376, 210);
INSERT INTO public.who_global_data VALUES (88933, 0, 0, 0, 0, 376, 120);
INSERT INTO public.who_global_data VALUES (88934, 0, 0, 0, 0, 376, 135);
INSERT INTO public.who_global_data VALUES (88935, 0, 0, 0, 0, 376, 206);
INSERT INTO public.who_global_data VALUES (88936, 0, 0, 0, 0, 376, 189);
INSERT INTO public.who_global_data VALUES (88937, 0, 0, 0, 0, 376, 129);
INSERT INTO public.who_global_data VALUES (88938, 0, 0, 0, 0, 376, 121);
INSERT INTO public.who_global_data VALUES (88939, 0, 0, 0, 0, 376, 59);
INSERT INTO public.who_global_data VALUES (88940, 0, 0, 0, 0, 376, 96);
INSERT INTO public.who_global_data VALUES (88941, 0, 0, 0, 0, 376, 41);
INSERT INTO public.who_global_data VALUES (88942, 0, 0, 0, 0, 376, 216);
INSERT INTO public.who_global_data VALUES (88943, 0, 0, 0, 0, 376, 236);
INSERT INTO public.who_global_data VALUES (88944, 0, 0, 0, 0, 376, 150);
INSERT INTO public.who_global_data VALUES (88945, 0, 0, 0, 0, 376, 61);
INSERT INTO public.who_global_data VALUES (88946, 0, 0, 0, 0, 376, 7);
INSERT INTO public.who_global_data VALUES (88947, 0, 0, 0, 0, 376, 169);
INSERT INTO public.who_global_data VALUES (88948, 0, 3, 0, 0, 376, 28);
INSERT INTO public.who_global_data VALUES (88949, 0, 0, 0, 0, 376, 85);
INSERT INTO public.who_global_data VALUES (88950, 0, 0, 0, 0, 376, 211);
INSERT INTO public.who_global_data VALUES (88951, 0, 0, 0, 0, 376, 60);
INSERT INTO public.who_global_data VALUES (88952, 0, 0, 0, 0, 376, 3);
INSERT INTO public.who_global_data VALUES (88953, 0, 0, 0, 0, 376, 11);
INSERT INTO public.who_global_data VALUES (88954, 0, 0, 0, 0, 376, 89);
INSERT INTO public.who_global_data VALUES (88955, 0, 0, 0, 0, 376, 24);
INSERT INTO public.who_global_data VALUES (88956, 0, 0, 0, 0, 376, 162);
INSERT INTO public.who_global_data VALUES (88957, 0, 0, 0, 0, 376, 100);
INSERT INTO public.who_global_data VALUES (88958, 0, 0, 0, 0, 376, 47);
INSERT INTO public.who_global_data VALUES (88959, 0, 0, 0, 0, 376, 29);
INSERT INTO public.who_global_data VALUES (88960, 0, 0, 0, 0, 376, 40);
INSERT INTO public.who_global_data VALUES (88961, 0, 0, 0, 0, 376, 222);
INSERT INTO public.who_global_data VALUES (88962, 0, 0, 0, 0, 376, 132);
INSERT INTO public.who_global_data VALUES (88963, 0, 0, 0, 0, 376, 130);
INSERT INTO public.who_global_data VALUES (88964, 0, 0, 0, 0, 376, 234);
INSERT INTO public.who_global_data VALUES (88965, 0, 0, 0, 0, 376, 23);
INSERT INTO public.who_global_data VALUES (88966, 0, 0, 0, 0, 376, 192);
INSERT INTO public.who_global_data VALUES (88967, 0, 0, 0, 0, 376, 69);
INSERT INTO public.who_global_data VALUES (88968, 0, 0, 0, 0, 376, 187);
INSERT INTO public.who_global_data VALUES (88969, 0, 0, 0, 0, 376, 230);
INSERT INTO public.who_global_data VALUES (88970, 0, 0, 0, 0, 376, 77);
INSERT INTO public.who_global_data VALUES (88971, 0, 0, 0, 0, 376, 9);
INSERT INTO public.who_global_data VALUES (88972, 0, 0, 0, 0, 376, 74);
INSERT INTO public.who_global_data VALUES (88973, 0, 0, 0, 0, 376, 224);
INSERT INTO public.who_global_data VALUES (88974, 0, 0, 0, 0, 376, 199);
INSERT INTO public.who_global_data VALUES (88975, 0, 0, 0, 0, 376, 190);
INSERT INTO public.who_global_data VALUES (88976, 0, 0, 0, 0, 376, 12);
INSERT INTO public.who_global_data VALUES (88977, 0, 0, 0, 0, 376, 104);
INSERT INTO public.who_global_data VALUES (88978, 0, 0, 0, 0, 376, 153);
INSERT INTO public.who_global_data VALUES (88979, 0, 0, 0, 0, 376, 91);
INSERT INTO public.who_global_data VALUES (88980, 0, 0, 0, 0, 376, 215);
INSERT INTO public.who_global_data VALUES (88981, 0, 4, 0, 0, 376, 84);
INSERT INTO public.who_global_data VALUES (88982, 0, 0, 0, 0, 376, 231);
INSERT INTO public.who_global_data VALUES (88983, 0, 0, 0, 0, 376, 196);
INSERT INTO public.who_global_data VALUES (88984, 0, 0, 0, 0, 376, 105);
INSERT INTO public.who_global_data VALUES (88985, 0, 0, 0, 0, 376, 122);
INSERT INTO public.who_global_data VALUES (88986, 0, 0, 0, 0, 376, 159);
INSERT INTO public.who_global_data VALUES (88987, 0, 0, 0, 0, 376, 75);
INSERT INTO public.who_global_data VALUES (88988, 0, 0, 0, 0, 376, 27);
INSERT INTO public.who_global_data VALUES (88989, 0, 0, 0, 0, 376, 54);
INSERT INTO public.who_global_data VALUES (88990, 0, 0, 0, 0, 376, 226);
INSERT INTO public.who_global_data VALUES (88991, 0, 0, 0, 0, 376, 79);
INSERT INTO public.who_global_data VALUES (88992, 0, 0, 0, 0, 376, 56);
INSERT INTO public.who_global_data VALUES (88993, 0, 0, 0, 0, 376, 117);
INSERT INTO public.who_global_data VALUES (88994, 0, 0, 0, 0, 376, 152);
INSERT INTO public.who_global_data VALUES (88995, 0, 0, 0, 0, 376, 16);
INSERT INTO public.who_global_data VALUES (88996, 0, 0, 0, 0, 376, 10);
INSERT INTO public.who_global_data VALUES (88997, 0, 0, 0, 0, 376, 201);
INSERT INTO public.who_global_data VALUES (88998, 0, 0, 0, 0, 376, 174);
INSERT INTO public.who_global_data VALUES (88999, 0, 0, 0, 0, 376, 119);
INSERT INTO public.who_global_data VALUES (89000, 0, 0, 0, 0, 376, 168);
INSERT INTO public.who_global_data VALUES (89001, 0, 8, 0, 0, 376, 99);
INSERT INTO public.who_global_data VALUES (89002, 0, 0, 0, 0, 376, 171);
INSERT INTO public.who_global_data VALUES (89003, 0, 0, 0, 0, 376, 87);
INSERT INTO public.who_global_data VALUES (89004, 0, 0, 0, 0, 376, 123);
INSERT INTO public.who_global_data VALUES (89005, 0, 0, 0, 0, 376, 151);
INSERT INTO public.who_global_data VALUES (89006, 0, 0, 0, 0, 376, 213);
INSERT INTO public.who_global_data VALUES (89007, 0, 0, 0, 0, 376, 118);
INSERT INTO public.who_global_data VALUES (89008, 0, 0, 0, 0, 376, 134);
INSERT INTO public.who_global_data VALUES (89009, 0, 0, 0, 0, 376, 65);
INSERT INTO public.who_global_data VALUES (89010, 0, 0, 0, 0, 376, 102);
INSERT INTO public.who_global_data VALUES (89011, 0, 0, 0, 0, 376, 223);
INSERT INTO public.who_global_data VALUES (89012, 0, 0, 0, 0, 376, 4);
INSERT INTO public.who_global_data VALUES (89013, 0, 0, 0, 0, 376, 146);
INSERT INTO public.who_global_data VALUES (89014, 0, 0, 0, 0, 376, 31);
INSERT INTO public.who_global_data VALUES (89015, 0, 0, 0, 0, 376, 127);
INSERT INTO public.who_global_data VALUES (89016, 0, 0, 0, 0, 376, 22);
INSERT INTO public.who_global_data VALUES (89017, 0, 0, 0, 0, 376, 115);
INSERT INTO public.who_global_data VALUES (89018, 0, 0, 0, 0, 376, 106);
INSERT INTO public.who_global_data VALUES (89019, 0, 0, 0, 0, 376, 90);
INSERT INTO public.who_global_data VALUES (89020, 0, 0, 0, 0, 376, 70);
INSERT INTO public.who_global_data VALUES (89021, 0, 5, 0, 0, 376, 46);
INSERT INTO public.who_global_data VALUES (89022, 0, 0, 0, 0, 376, 139);
INSERT INTO public.who_global_data VALUES (89023, 0, 0, 0, 0, 376, 42);
INSERT INTO public.who_global_data VALUES (89024, 0, 0, 0, 0, 376, 80);
INSERT INTO public.who_global_data VALUES (89025, 0, 0, 0, 0, 376, 203);
INSERT INTO public.who_global_data VALUES (89026, 0, 0, 0, 0, 376, 136);
INSERT INTO public.who_global_data VALUES (89027, 0, 0, 0, 0, 376, 63);
INSERT INTO public.who_global_data VALUES (89028, 0, 0, 0, 0, 376, 17);
INSERT INTO public.who_global_data VALUES (89029, 0, 0, 0, 0, 376, 172);
INSERT INTO public.who_global_data VALUES (89030, 0, 0, 0, 0, 376, 109);
INSERT INTO public.who_global_data VALUES (89031, 0, 0, 0, 0, 376, 200);
INSERT INTO public.who_global_data VALUES (89032, 0, 0, 0, 0, 376, 93);
INSERT INTO public.who_global_data VALUES (89033, 0, 0, 0, 0, 376, 5);
INSERT INTO public.who_global_data VALUES (89034, 0, 0, 0, 0, 376, 214);
INSERT INTO public.who_global_data VALUES (89035, 0, 0, 0, 0, 376, 204);
INSERT INTO public.who_global_data VALUES (89036, 0, 0, 0, 0, 376, 198);
INSERT INTO public.who_global_data VALUES (89037, 0, 0, 0, 0, 376, 173);
INSERT INTO public.who_global_data VALUES (89038, 0, 0, 0, 0, 376, 229);
INSERT INTO public.who_global_data VALUES (89039, 0, 0, 0, 0, 376, 76);
INSERT INTO public.who_global_data VALUES (89040, 0, 0, 0, 0, 376, 138);
INSERT INTO public.who_global_data VALUES (89041, 0, 0, 0, 0, 376, 98);
INSERT INTO public.who_global_data VALUES (89042, 0, 0, 0, 0, 376, 103);
INSERT INTO public.who_global_data VALUES (89043, 0, 0, 0, 0, 376, 225);
INSERT INTO public.who_global_data VALUES (89044, 0, 0, 0, 0, 376, 131);
INSERT INTO public.who_global_data VALUES (89045, 0, 0, 0, 0, 376, 235);
INSERT INTO public.who_global_data VALUES (89046, 0, 0, 0, 0, 376, 137);
INSERT INTO public.who_global_data VALUES (89047, 1, 8, 0, 0, 376, 81);
INSERT INTO public.who_global_data VALUES (89048, 0, 0, 0, 0, 376, 182);
INSERT INTO public.who_global_data VALUES (89049, 0, 0, 0, 0, 376, 145);
INSERT INTO public.who_global_data VALUES (89050, 0, 0, 0, 0, 376, 26);
INSERT INTO public.who_global_data VALUES (89051, 0, 0, 0, 0, 376, 170);
INSERT INTO public.who_global_data VALUES (89052, 0, 0, 0, 0, 376, 191);
INSERT INTO public.who_global_data VALUES (89053, 0, 0, 0, 0, 376, 221);
INSERT INTO public.who_global_data VALUES (89054, 0, 0, 0, 0, 376, 64);
INSERT INTO public.who_global_data VALUES (89055, 0, 0, 0, 0, 376, 116);
INSERT INTO public.who_global_data VALUES (89056, 0, 0, 0, 0, 376, 128);
INSERT INTO public.who_global_data VALUES (89057, 0, 0, 0, 0, 376, 6);
INSERT INTO public.who_global_data VALUES (89058, 0, 0, 0, 0, 376, 227);
INSERT INTO public.who_global_data VALUES (89059, 0, 0, 0, 0, 376, 68);
INSERT INTO public.who_global_data VALUES (89060, 0, 0, 0, 0, 376, 184);
INSERT INTO public.who_global_data VALUES (89061, 0, 0, 0, 0, 376, 82);
INSERT INTO public.who_global_data VALUES (89062, 0, 0, 0, 0, 376, 149);
INSERT INTO public.who_global_data VALUES (89063, 0, 0, 0, 0, 376, 197);
INSERT INTO public.who_global_data VALUES (89064, 0, 0, 0, 0, 376, 78);
INSERT INTO public.who_global_data VALUES (89065, 0, 0, 0, 0, 376, 233);
INSERT INTO public.who_global_data VALUES (89066, 0, 0, 0, 0, 376, 133);
INSERT INTO public.who_global_data VALUES (89067, 0, 0, 0, 0, 376, 35);
INSERT INTO public.who_global_data VALUES (89068, 0, 0, 0, 0, 376, 114);
INSERT INTO public.who_global_data VALUES (89069, 1, 9, 0, 0, 376, 237);
INSERT INTO public.who_global_data VALUES (89070, 0, 0, 0, 0, 376, 55);
INSERT INTO public.who_global_data VALUES (89071, 0, 0, 0, 0, 376, 176);
INSERT INTO public.who_global_data VALUES (89072, 0, 0, 0, 0, 376, 202);
INSERT INTO public.who_global_data VALUES (89073, 0, 0, 0, 0, 376, 155);
INSERT INTO public.who_global_data VALUES (89074, 0, 0, 0, 0, 376, 32);
INSERT INTO public.who_global_data VALUES (89075, 0, 0, 0, 0, 376, 220);
INSERT INTO public.who_global_data VALUES (89076, 0, 0, 0, 0, 376, 30);
INSERT INTO public.who_global_data VALUES (89077, 0, 0, 0, 0, 376, 147);
INSERT INTO public.who_global_data VALUES (89078, 0, 0, 0, 0, 376, 208);
INSERT INTO public.who_global_data VALUES (89079, 5, 5, 0, 0, 376, 45);
INSERT INTO public.who_global_data VALUES (89080, 0, 0, 0, 0, 376, 110);
INSERT INTO public.who_global_data VALUES (89081, 0, 0, 0, 0, 376, 88);
INSERT INTO public.who_global_data VALUES (89082, 0, 0, 0, 0, 376, 51);
INSERT INTO public.who_global_data VALUES (89083, 0, 0, 0, 0, 376, 209);
INSERT INTO public.who_global_data VALUES (89084, 0, 0, 0, 0, 376, 205);
INSERT INTO public.who_global_data VALUES (89085, 0, 0, 0, 0, 376, 18);
INSERT INTO public.who_global_data VALUES (89086, 3, 12, 0, 0, 376, 72);
INSERT INTO public.who_global_data VALUES (89087, 0, 0, 0, 0, 376, 44);
INSERT INTO public.who_global_data VALUES (89088, 0, 0, 0, 0, 376, 15);
INSERT INTO public.who_global_data VALUES (89089, 0, 0, 0, 0, 376, 25);
INSERT INTO public.who_global_data VALUES (89090, 0, 0, 0, 0, 376, 179);
INSERT INTO public.who_global_data VALUES (89091, 0, 0, 0, 0, 376, 34);
INSERT INTO public.who_global_data VALUES (89092, 0, 0, 0, 0, 376, 207);
INSERT INTO public.who_global_data VALUES (89093, 0, 0, 0, 0, 376, 166);
INSERT INTO public.who_global_data VALUES (89094, 0, 0, 0, 0, 376, 126);
INSERT INTO public.who_global_data VALUES (89095, 0, 0, 0, 0, 376, 97);
INSERT INTO public.who_global_data VALUES (89096, 0, 0, 0, 0, 376, 36);
INSERT INTO public.who_global_data VALUES (89097, 0, 0, 0, 0, 376, 125);
INSERT INTO public.who_global_data VALUES (89098, 0, 0, 0, 0, 376, 124);
INSERT INTO public.who_global_data VALUES (89099, 0, 0, 0, 0, 376, 185);
INSERT INTO public.who_global_data VALUES (89100, 0, 0, 0, 0, 376, 194);
INSERT INTO public.who_global_data VALUES (89101, 0, 0, 0, 0, 376, 144);
INSERT INTO public.who_global_data VALUES (89102, 0, 9, 0, 0, 376, 19);
INSERT INTO public.who_global_data VALUES (89103, 0, 0, 0, 0, 376, 217);
INSERT INTO public.who_global_data VALUES (89104, 0, 0, 0, 0, 376, 148);
INSERT INTO public.who_global_data VALUES (89105, 0, 0, 0, 0, 376, 86);
INSERT INTO public.who_global_data VALUES (89106, 0, 0, 0, 0, 376, 13);
INSERT INTO public.who_global_data VALUES (89107, 0, 0, 0, 0, 376, 157);
INSERT INTO public.who_global_data VALUES (89108, 0, 6, 0, 0, 376, 8);
INSERT INTO public.who_global_data VALUES (89109, 0, 0, 0, 0, 376, 73);
INSERT INTO public.who_global_data VALUES (89110, 0, 0, 0, 0, 376, 101);
INSERT INTO public.who_global_data VALUES (89111, 0, 0, 0, 0, 376, 165);
INSERT INTO public.who_global_data VALUES (89112, 0, 0, 0, 0, 376, 14);
INSERT INTO public.who_global_data VALUES (89113, 0, 0, 0, 0, 377, 193);
INSERT INTO public.who_global_data VALUES (89114, 0, 0, 0, 0, 377, 113);
INSERT INTO public.who_global_data VALUES (89115, 0, 0, 0, 0, 377, 143);
INSERT INTO public.who_global_data VALUES (89116, 0, 0, 0, 0, 377, 219);
INSERT INTO public.who_global_data VALUES (89117, 0, 0, 0, 0, 377, 186);
INSERT INTO public.who_global_data VALUES (89118, 0, 0, 0, 0, 377, 52);
INSERT INTO public.who_global_data VALUES (89119, 0, 0, 0, 0, 377, 180);
INSERT INTO public.who_global_data VALUES (89120, 0, 0, 0, 0, 377, 167);
INSERT INTO public.who_global_data VALUES (89121, 0, 0, 0, 0, 377, 154);
INSERT INTO public.who_global_data VALUES (89122, 0, 0, 0, 0, 377, 94);
INSERT INTO public.who_global_data VALUES (89123, 0, 0, 0, 0, 377, 66);
INSERT INTO public.who_global_data VALUES (89124, 1, 8, 0, 0, 377, 58);
INSERT INTO public.who_global_data VALUES (89125, 0, 0, 0, 0, 377, 163);
INSERT INTO public.who_global_data VALUES (89126, 0, 0, 0, 0, 377, 37);
INSERT INTO public.who_global_data VALUES (89127, 0, 0, 0, 0, 377, 142);
INSERT INTO public.who_global_data VALUES (89128, 0, 0, 0, 0, 377, 83);
INSERT INTO public.who_global_data VALUES (89129, 0, 0, 0, 0, 377, 228);
INSERT INTO public.who_global_data VALUES (89130, 0, 0, 0, 0, 377, 188);
INSERT INTO public.who_global_data VALUES (89131, 0, 0, 0, 0, 377, 62);
INSERT INTO public.who_global_data VALUES (89132, 0, 0, 0, 0, 377, 160);
INSERT INTO public.who_global_data VALUES (89133, 0, 0, 0, 0, 377, 50);
INSERT INTO public.who_global_data VALUES (89134, 0, 0, 0, 0, 377, 33);
INSERT INTO public.who_global_data VALUES (89135, 0, 0, 0, 0, 377, 183);
INSERT INTO public.who_global_data VALUES (89136, 0, 0, 0, 0, 377, 92);
INSERT INTO public.who_global_data VALUES (89137, 0, 0, 0, 0, 377, 158);
INSERT INTO public.who_global_data VALUES (89138, 0, 0, 0, 0, 377, 67);
INSERT INTO public.who_global_data VALUES (89139, 0, 0, 0, 0, 377, 57);
INSERT INTO public.who_global_data VALUES (89140, 0, 0, 0, 0, 377, 38);
INSERT INTO public.who_global_data VALUES (89141, 0, 0, 0, 0, 377, 141);
INSERT INTO public.who_global_data VALUES (89142, 0, 0, 0, 0, 377, 178);
INSERT INTO public.who_global_data VALUES (89143, 0, 0, 0, 0, 377, 108);
INSERT INTO public.who_global_data VALUES (89144, 0, 0, 0, 0, 377, 39);
INSERT INTO public.who_global_data VALUES (89145, 0, 0, 0, 0, 377, 2);
INSERT INTO public.who_global_data VALUES (89146, 0, 0, 0, 0, 377, 195);
INSERT INTO public.who_global_data VALUES (89147, 0, 0, 0, 0, 377, 107);
INSERT INTO public.who_global_data VALUES (89148, 0, 0, 0, 0, 377, 161);
INSERT INTO public.who_global_data VALUES (89149, 0, 0, 0, 0, 377, 212);
INSERT INTO public.who_global_data VALUES (89150, 5, 5, 0, 0, 377, 181);
INSERT INTO public.who_global_data VALUES (89151, 0, 0, 0, 0, 377, 53);
INSERT INTO public.who_global_data VALUES (89152, 0, 0, 0, 0, 377, 164);
INSERT INTO public.who_global_data VALUES (89153, 0, 0, 0, 0, 377, 140);
INSERT INTO public.who_global_data VALUES (89154, 0, 0, 0, 0, 377, 20);
INSERT INTO public.who_global_data VALUES (89155, 688, 1989, 15, 56, 377, 112);
INSERT INTO public.who_global_data VALUES (89156, 0, 0, 0, 0, 377, 111);
INSERT INTO public.who_global_data VALUES (89157, 0, 0, 0, 0, 377, 71);
INSERT INTO public.who_global_data VALUES (89158, 0, 0, 0, 0, 377, 218);
INSERT INTO public.who_global_data VALUES (89159, 0, 0, 0, 0, 377, 43);
INSERT INTO public.who_global_data VALUES (89160, 0, 0, 0, 0, 377, 49);
INSERT INTO public.who_global_data VALUES (89161, 0, 0, 0, 0, 377, 1);
INSERT INTO public.who_global_data VALUES (89162, 0, 0, 0, 0, 377, 48);
INSERT INTO public.who_global_data VALUES (89163, 0, 0, 0, 0, 377, 232);
INSERT INTO public.who_global_data VALUES (89164, 0, 0, 0, 0, 377, 175);
INSERT INTO public.who_global_data VALUES (89165, 0, 0, 0, 0, 377, 21);
INSERT INTO public.who_global_data VALUES (89166, 0, 0, 0, 0, 377, 156);
INSERT INTO public.who_global_data VALUES (89167, 0, 0, 0, 0, 377, 95);
INSERT INTO public.who_global_data VALUES (89168, 0, 0, 0, 0, 377, 177);
INSERT INTO public.who_global_data VALUES (89169, 0, 0, 0, 0, 377, 210);
INSERT INTO public.who_global_data VALUES (89170, 0, 0, 0, 0, 377, 120);
INSERT INTO public.who_global_data VALUES (89171, 0, 0, 0, 0, 377, 135);
INSERT INTO public.who_global_data VALUES (89172, 0, 0, 0, 0, 377, 206);
INSERT INTO public.who_global_data VALUES (89173, 0, 0, 0, 0, 377, 189);
INSERT INTO public.who_global_data VALUES (89174, 0, 0, 0, 0, 377, 129);
INSERT INTO public.who_global_data VALUES (89175, 0, 0, 0, 0, 377, 121);
INSERT INTO public.who_global_data VALUES (89176, 0, 0, 0, 0, 377, 59);
INSERT INTO public.who_global_data VALUES (89177, 0, 0, 0, 0, 377, 96);
INSERT INTO public.who_global_data VALUES (89178, 0, 0, 0, 0, 377, 41);
INSERT INTO public.who_global_data VALUES (89179, 0, 0, 0, 0, 377, 216);
INSERT INTO public.who_global_data VALUES (89180, 0, 0, 0, 0, 377, 236);
INSERT INTO public.who_global_data VALUES (89181, 0, 0, 0, 0, 377, 150);
INSERT INTO public.who_global_data VALUES (89182, 0, 0, 0, 0, 377, 61);
INSERT INTO public.who_global_data VALUES (89183, 0, 0, 0, 0, 377, 7);
INSERT INTO public.who_global_data VALUES (89184, 0, 0, 0, 0, 377, 169);
INSERT INTO public.who_global_data VALUES (89185, 0, 3, 0, 0, 377, 28);
INSERT INTO public.who_global_data VALUES (89186, 0, 0, 0, 0, 377, 85);
INSERT INTO public.who_global_data VALUES (89187, 0, 0, 0, 0, 377, 211);
INSERT INTO public.who_global_data VALUES (89188, 0, 0, 0, 0, 377, 60);
INSERT INTO public.who_global_data VALUES (89189, 0, 0, 0, 0, 377, 3);
INSERT INTO public.who_global_data VALUES (89190, 0, 0, 0, 0, 377, 11);
INSERT INTO public.who_global_data VALUES (89191, 0, 0, 0, 0, 377, 89);
INSERT INTO public.who_global_data VALUES (89192, 0, 0, 0, 0, 377, 24);
INSERT INTO public.who_global_data VALUES (89193, 0, 0, 0, 0, 377, 162);
INSERT INTO public.who_global_data VALUES (89194, 0, 0, 0, 0, 377, 100);
INSERT INTO public.who_global_data VALUES (89195, 0, 0, 0, 0, 377, 47);
INSERT INTO public.who_global_data VALUES (89196, 0, 0, 0, 0, 377, 29);
INSERT INTO public.who_global_data VALUES (89197, 0, 0, 0, 0, 377, 40);
INSERT INTO public.who_global_data VALUES (89198, 0, 0, 0, 0, 377, 222);
INSERT INTO public.who_global_data VALUES (89199, 0, 0, 0, 0, 377, 132);
INSERT INTO public.who_global_data VALUES (89200, 0, 0, 0, 0, 377, 130);
INSERT INTO public.who_global_data VALUES (89201, 0, 0, 0, 0, 377, 234);
INSERT INTO public.who_global_data VALUES (89202, 0, 0, 0, 0, 377, 23);
INSERT INTO public.who_global_data VALUES (89203, 0, 0, 0, 0, 377, 192);
INSERT INTO public.who_global_data VALUES (89204, 0, 0, 0, 0, 377, 69);
INSERT INTO public.who_global_data VALUES (89205, 0, 0, 0, 0, 377, 187);
INSERT INTO public.who_global_data VALUES (89206, 0, 0, 0, 0, 377, 230);
INSERT INTO public.who_global_data VALUES (89207, 0, 0, 0, 0, 377, 77);
INSERT INTO public.who_global_data VALUES (89208, 0, 0, 0, 0, 377, 9);
INSERT INTO public.who_global_data VALUES (89209, 0, 0, 0, 0, 377, 74);
INSERT INTO public.who_global_data VALUES (89210, 0, 0, 0, 0, 377, 224);
INSERT INTO public.who_global_data VALUES (89211, 0, 0, 0, 0, 377, 199);
INSERT INTO public.who_global_data VALUES (89212, 0, 0, 0, 0, 377, 190);
INSERT INTO public.who_global_data VALUES (89213, 0, 0, 0, 0, 377, 12);
INSERT INTO public.who_global_data VALUES (89214, 0, 0, 0, 0, 377, 104);
INSERT INTO public.who_global_data VALUES (89215, 0, 0, 0, 0, 377, 153);
INSERT INTO public.who_global_data VALUES (89216, 0, 0, 0, 0, 377, 91);
INSERT INTO public.who_global_data VALUES (89217, 0, 0, 0, 0, 377, 215);
INSERT INTO public.who_global_data VALUES (89218, 1, 4, 0, 0, 377, 84);
INSERT INTO public.who_global_data VALUES (89219, 0, 0, 0, 0, 377, 231);
INSERT INTO public.who_global_data VALUES (89220, 0, 0, 0, 0, 377, 196);
INSERT INTO public.who_global_data VALUES (89221, 0, 0, 0, 0, 377, 105);
INSERT INTO public.who_global_data VALUES (89222, 0, 0, 0, 0, 377, 122);
INSERT INTO public.who_global_data VALUES (89223, 0, 0, 0, 0, 377, 159);
INSERT INTO public.who_global_data VALUES (89224, 0, 0, 0, 0, 377, 75);
INSERT INTO public.who_global_data VALUES (89225, 0, 0, 0, 0, 377, 27);
INSERT INTO public.who_global_data VALUES (89226, 0, 0, 0, 0, 377, 54);
INSERT INTO public.who_global_data VALUES (89227, 0, 0, 0, 0, 377, 226);
INSERT INTO public.who_global_data VALUES (89228, 0, 0, 0, 0, 377, 79);
INSERT INTO public.who_global_data VALUES (89229, 0, 0, 0, 0, 377, 56);
INSERT INTO public.who_global_data VALUES (89230, 0, 0, 0, 0, 377, 117);
INSERT INTO public.who_global_data VALUES (89231, 0, 0, 0, 0, 377, 152);
INSERT INTO public.who_global_data VALUES (89232, 0, 0, 0, 0, 377, 16);
INSERT INTO public.who_global_data VALUES (89233, 0, 0, 0, 0, 377, 10);
INSERT INTO public.who_global_data VALUES (89234, 0, 0, 0, 0, 377, 201);
INSERT INTO public.who_global_data VALUES (89235, 0, 0, 0, 0, 377, 174);
INSERT INTO public.who_global_data VALUES (89236, 0, 0, 0, 0, 377, 119);
INSERT INTO public.who_global_data VALUES (89237, 0, 0, 0, 0, 377, 168);
INSERT INTO public.who_global_data VALUES (89238, 1, 8, 0, 0, 377, 99);
INSERT INTO public.who_global_data VALUES (89239, 0, 0, 0, 0, 377, 171);
INSERT INTO public.who_global_data VALUES (89240, 0, 0, 0, 0, 377, 87);
INSERT INTO public.who_global_data VALUES (89241, 0, 0, 0, 0, 377, 123);
INSERT INTO public.who_global_data VALUES (89242, 0, 0, 0, 0, 377, 151);
INSERT INTO public.who_global_data VALUES (89243, 0, 0, 0, 0, 377, 213);
INSERT INTO public.who_global_data VALUES (89244, 0, 0, 0, 0, 377, 118);
INSERT INTO public.who_global_data VALUES (89245, 0, 0, 0, 0, 377, 134);
INSERT INTO public.who_global_data VALUES (89246, 0, 0, 0, 0, 377, 65);
INSERT INTO public.who_global_data VALUES (89247, 0, 0, 0, 0, 377, 102);
INSERT INTO public.who_global_data VALUES (89248, 0, 0, 0, 0, 377, 223);
INSERT INTO public.who_global_data VALUES (89249, 0, 0, 0, 0, 377, 4);
INSERT INTO public.who_global_data VALUES (89250, 0, 0, 0, 0, 377, 146);
INSERT INTO public.who_global_data VALUES (89251, 0, 0, 0, 0, 377, 31);
INSERT INTO public.who_global_data VALUES (89252, 0, 0, 0, 0, 377, 127);
INSERT INTO public.who_global_data VALUES (89253, 0, 0, 0, 0, 377, 22);
INSERT INTO public.who_global_data VALUES (89254, 0, 0, 0, 0, 377, 115);
INSERT INTO public.who_global_data VALUES (89255, 0, 0, 0, 0, 377, 106);
INSERT INTO public.who_global_data VALUES (89256, 0, 0, 0, 0, 377, 90);
INSERT INTO public.who_global_data VALUES (89257, 0, 0, 0, 0, 377, 70);
INSERT INTO public.who_global_data VALUES (89258, 0, 5, 0, 0, 377, 46);
INSERT INTO public.who_global_data VALUES (89259, 0, 0, 0, 0, 377, 139);
INSERT INTO public.who_global_data VALUES (89260, 0, 0, 0, 0, 377, 42);
INSERT INTO public.who_global_data VALUES (89261, 0, 0, 0, 0, 377, 80);
INSERT INTO public.who_global_data VALUES (89262, 0, 0, 0, 0, 377, 203);
INSERT INTO public.who_global_data VALUES (89263, 0, 0, 0, 0, 377, 136);
INSERT INTO public.who_global_data VALUES (89264, 0, 0, 0, 0, 377, 63);
INSERT INTO public.who_global_data VALUES (89265, 0, 0, 0, 0, 377, 17);
INSERT INTO public.who_global_data VALUES (89266, 0, 0, 0, 0, 377, 172);
INSERT INTO public.who_global_data VALUES (89267, 0, 0, 0, 0, 377, 109);
INSERT INTO public.who_global_data VALUES (89268, 0, 0, 0, 0, 377, 200);
INSERT INTO public.who_global_data VALUES (89269, 0, 0, 0, 0, 377, 93);
INSERT INTO public.who_global_data VALUES (89270, 0, 0, 0, 0, 377, 5);
INSERT INTO public.who_global_data VALUES (89271, 0, 0, 0, 0, 377, 214);
INSERT INTO public.who_global_data VALUES (89272, 0, 0, 0, 0, 377, 204);
INSERT INTO public.who_global_data VALUES (89273, 0, 0, 0, 0, 377, 198);
INSERT INTO public.who_global_data VALUES (89274, 0, 0, 0, 0, 377, 173);
INSERT INTO public.who_global_data VALUES (89275, 0, 0, 0, 0, 377, 229);
INSERT INTO public.who_global_data VALUES (89276, 0, 0, 0, 0, 377, 76);
INSERT INTO public.who_global_data VALUES (89277, 0, 0, 0, 0, 377, 138);
INSERT INTO public.who_global_data VALUES (89278, 0, 0, 0, 0, 377, 98);
INSERT INTO public.who_global_data VALUES (89279, 0, 0, 0, 0, 377, 103);
INSERT INTO public.who_global_data VALUES (89280, 0, 0, 0, 0, 377, 225);
INSERT INTO public.who_global_data VALUES (89281, 0, 0, 0, 0, 377, 131);
INSERT INTO public.who_global_data VALUES (89282, 0, 0, 0, 0, 377, 235);
INSERT INTO public.who_global_data VALUES (89283, 0, 0, 0, 0, 377, 137);
INSERT INTO public.who_global_data VALUES (89284, 1, 7, 0, 0, 377, 81);
INSERT INTO public.who_global_data VALUES (89285, 0, 0, 0, 0, 377, 182);
INSERT INTO public.who_global_data VALUES (89286, 0, 0, 0, 0, 377, 145);
INSERT INTO public.who_global_data VALUES (89287, 0, 0, 0, 0, 377, 26);
INSERT INTO public.who_global_data VALUES (89288, 0, 0, 0, 0, 377, 170);
INSERT INTO public.who_global_data VALUES (89289, 0, 0, 0, 0, 377, 191);
INSERT INTO public.who_global_data VALUES (89290, 0, 0, 0, 0, 377, 221);
INSERT INTO public.who_global_data VALUES (89291, 0, 0, 0, 0, 377, 64);
INSERT INTO public.who_global_data VALUES (89292, 0, 0, 0, 0, 377, 116);
INSERT INTO public.who_global_data VALUES (89293, 0, 0, 0, 0, 377, 128);
INSERT INTO public.who_global_data VALUES (89294, 0, 0, 0, 0, 377, 6);
INSERT INTO public.who_global_data VALUES (89295, 0, 0, 0, 0, 377, 227);
INSERT INTO public.who_global_data VALUES (89296, 0, 0, 0, 0, 377, 68);
INSERT INTO public.who_global_data VALUES (89297, 0, 0, 0, 0, 377, 184);
INSERT INTO public.who_global_data VALUES (89298, 0, 0, 0, 0, 377, 82);
INSERT INTO public.who_global_data VALUES (89299, 0, 0, 0, 0, 377, 149);
INSERT INTO public.who_global_data VALUES (89300, 0, 0, 0, 0, 377, 197);
INSERT INTO public.who_global_data VALUES (89301, 0, 0, 0, 0, 377, 78);
INSERT INTO public.who_global_data VALUES (89302, 0, 0, 0, 0, 377, 233);
INSERT INTO public.who_global_data VALUES (89303, 0, 0, 0, 0, 377, 133);
INSERT INTO public.who_global_data VALUES (89304, 0, 0, 0, 0, 377, 35);
INSERT INTO public.who_global_data VALUES (89305, 0, 0, 0, 0, 377, 114);
INSERT INTO public.who_global_data VALUES (89306, 1, 8, 0, 0, 377, 237);
INSERT INTO public.who_global_data VALUES (89307, 0, 0, 0, 0, 377, 55);
INSERT INTO public.who_global_data VALUES (89308, 0, 0, 0, 0, 377, 176);
INSERT INTO public.who_global_data VALUES (89309, 0, 0, 0, 0, 377, 202);
INSERT INTO public.who_global_data VALUES (89310, 0, 0, 0, 0, 377, 155);
INSERT INTO public.who_global_data VALUES (89311, 0, 0, 0, 0, 377, 32);
INSERT INTO public.who_global_data VALUES (89312, 0, 0, 0, 0, 377, 220);
INSERT INTO public.who_global_data VALUES (89313, 0, 0, 0, 0, 377, 30);
INSERT INTO public.who_global_data VALUES (89314, 0, 0, 0, 0, 377, 147);
INSERT INTO public.who_global_data VALUES (89315, 0, 0, 0, 0, 377, 208);
INSERT INTO public.who_global_data VALUES (89316, 0, 0, 0, 0, 377, 45);
INSERT INTO public.who_global_data VALUES (89317, 0, 0, 0, 0, 377, 110);
INSERT INTO public.who_global_data VALUES (89318, 0, 0, 0, 0, 377, 88);
INSERT INTO public.who_global_data VALUES (89319, 0, 0, 0, 0, 377, 51);
INSERT INTO public.who_global_data VALUES (89320, 0, 0, 0, 0, 377, 209);
INSERT INTO public.who_global_data VALUES (89321, 0, 0, 0, 0, 377, 205);
INSERT INTO public.who_global_data VALUES (89322, 0, 0, 0, 0, 377, 18);
INSERT INTO public.who_global_data VALUES (89323, 1, 9, 0, 0, 377, 72);
INSERT INTO public.who_global_data VALUES (89324, 0, 0, 0, 0, 377, 44);
INSERT INTO public.who_global_data VALUES (89325, 0, 0, 0, 0, 377, 15);
INSERT INTO public.who_global_data VALUES (89326, 0, 0, 0, 0, 377, 25);
INSERT INTO public.who_global_data VALUES (89327, 0, 0, 0, 0, 377, 179);
INSERT INTO public.who_global_data VALUES (89328, 0, 0, 0, 0, 377, 34);
INSERT INTO public.who_global_data VALUES (89329, 0, 0, 0, 0, 377, 207);
INSERT INTO public.who_global_data VALUES (89330, 0, 0, 0, 0, 377, 166);
INSERT INTO public.who_global_data VALUES (89331, 0, 0, 0, 0, 377, 126);
INSERT INTO public.who_global_data VALUES (89332, 0, 0, 0, 0, 377, 97);
INSERT INTO public.who_global_data VALUES (89333, 0, 0, 0, 0, 377, 36);
INSERT INTO public.who_global_data VALUES (89334, 0, 0, 0, 0, 377, 125);
INSERT INTO public.who_global_data VALUES (89335, 0, 0, 0, 0, 377, 124);
INSERT INTO public.who_global_data VALUES (89336, 0, 0, 0, 0, 377, 185);
INSERT INTO public.who_global_data VALUES (89337, 0, 0, 0, 0, 377, 194);
INSERT INTO public.who_global_data VALUES (89338, 0, 0, 0, 0, 377, 144);
INSERT INTO public.who_global_data VALUES (89339, 3, 9, 0, 0, 377, 19);
INSERT INTO public.who_global_data VALUES (89340, 0, 0, 0, 0, 377, 217);
INSERT INTO public.who_global_data VALUES (89341, 0, 0, 0, 0, 377, 148);
INSERT INTO public.who_global_data VALUES (89342, 0, 0, 0, 0, 377, 86);
INSERT INTO public.who_global_data VALUES (89343, 0, 0, 0, 0, 377, 13);
INSERT INTO public.who_global_data VALUES (89344, 0, 0, 0, 0, 377, 157);
INSERT INTO public.who_global_data VALUES (89345, 0, 6, 0, 0, 377, 8);
INSERT INTO public.who_global_data VALUES (89346, 0, 0, 0, 0, 377, 73);
INSERT INTO public.who_global_data VALUES (89347, 0, 0, 0, 0, 377, 101);
INSERT INTO public.who_global_data VALUES (89348, 0, 0, 0, 0, 377, 165);
INSERT INTO public.who_global_data VALUES (89349, 0, 0, 0, 0, 377, 14);
INSERT INTO public.who_global_data VALUES (89350, 0, 0, 0, 0, 378, 193);
INSERT INTO public.who_global_data VALUES (89351, 0, 0, 0, 0, 378, 113);
INSERT INTO public.who_global_data VALUES (89352, 0, 0, 0, 0, 378, 143);
INSERT INTO public.who_global_data VALUES (89353, 0, 0, 0, 0, 378, 219);
INSERT INTO public.who_global_data VALUES (89354, 0, 0, 0, 0, 378, 186);
INSERT INTO public.who_global_data VALUES (89355, 0, 0, 0, 0, 378, 52);
INSERT INTO public.who_global_data VALUES (89356, 0, 0, 0, 0, 378, 180);
INSERT INTO public.who_global_data VALUES (89357, 0, 0, 0, 0, 378, 167);
INSERT INTO public.who_global_data VALUES (89358, 0, 0, 0, 0, 378, 154);
INSERT INTO public.who_global_data VALUES (89359, 0, 0, 0, 0, 378, 94);
INSERT INTO public.who_global_data VALUES (89360, 0, 0, 0, 0, 378, 66);
INSERT INTO public.who_global_data VALUES (89361, 7, 7, 0, 0, 378, 58);
INSERT INTO public.who_global_data VALUES (89362, 0, 0, 0, 0, 378, 163);
INSERT INTO public.who_global_data VALUES (89363, 0, 0, 0, 0, 378, 37);
INSERT INTO public.who_global_data VALUES (89364, 0, 0, 0, 0, 378, 142);
INSERT INTO public.who_global_data VALUES (89365, 0, 0, 0, 0, 378, 83);
INSERT INTO public.who_global_data VALUES (89366, 0, 0, 0, 0, 378, 228);
INSERT INTO public.who_global_data VALUES (89367, 0, 0, 0, 0, 378, 188);
INSERT INTO public.who_global_data VALUES (89368, 0, 0, 0, 0, 378, 62);
INSERT INTO public.who_global_data VALUES (89369, 0, 0, 0, 0, 378, 160);
INSERT INTO public.who_global_data VALUES (89370, 0, 0, 0, 0, 378, 50);
INSERT INTO public.who_global_data VALUES (89371, 0, 0, 0, 0, 378, 33);
INSERT INTO public.who_global_data VALUES (89372, 0, 0, 0, 0, 378, 183);
INSERT INTO public.who_global_data VALUES (89373, 0, 0, 0, 0, 378, 92);
INSERT INTO public.who_global_data VALUES (89374, 0, 0, 0, 0, 378, 158);
INSERT INTO public.who_global_data VALUES (89375, 0, 0, 0, 0, 378, 67);
INSERT INTO public.who_global_data VALUES (89376, 0, 0, 0, 0, 378, 57);
INSERT INTO public.who_global_data VALUES (89377, 0, 0, 0, 0, 378, 38);
INSERT INTO public.who_global_data VALUES (89378, 0, 0, 0, 0, 378, 141);
INSERT INTO public.who_global_data VALUES (89379, 0, 0, 0, 0, 378, 178);
INSERT INTO public.who_global_data VALUES (89380, 0, 0, 0, 0, 378, 108);
INSERT INTO public.who_global_data VALUES (89381, 0, 0, 0, 0, 378, 39);
INSERT INTO public.who_global_data VALUES (89382, 0, 0, 0, 0, 378, 2);
INSERT INTO public.who_global_data VALUES (89383, 0, 0, 0, 0, 378, 195);
INSERT INTO public.who_global_data VALUES (89384, 0, 0, 0, 0, 378, 107);
INSERT INTO public.who_global_data VALUES (89385, 0, 0, 0, 0, 378, 161);
INSERT INTO public.who_global_data VALUES (89386, 0, 0, 0, 0, 378, 212);
INSERT INTO public.who_global_data VALUES (89387, 0, 0, 0, 0, 378, 181);
INSERT INTO public.who_global_data VALUES (89388, 0, 0, 0, 0, 378, 53);
INSERT INTO public.who_global_data VALUES (89389, 0, 0, 0, 0, 378, 164);
INSERT INTO public.who_global_data VALUES (89390, 0, 0, 0, 0, 378, 140);
INSERT INTO public.who_global_data VALUES (89391, 0, 0, 0, 0, 378, 20);
INSERT INTO public.who_global_data VALUES (89392, 462, 1301, 16, 41, 378, 112);
INSERT INTO public.who_global_data VALUES (89393, 0, 0, 0, 0, 378, 111);
INSERT INTO public.who_global_data VALUES (89394, 0, 0, 0, 0, 378, 71);
INSERT INTO public.who_global_data VALUES (89395, 0, 0, 0, 0, 378, 218);
INSERT INTO public.who_global_data VALUES (89396, 0, 0, 0, 0, 378, 43);
INSERT INTO public.who_global_data VALUES (89397, 0, 0, 0, 0, 378, 49);
INSERT INTO public.who_global_data VALUES (89398, 0, 0, 0, 0, 378, 1);
INSERT INTO public.who_global_data VALUES (89399, 0, 0, 0, 0, 378, 48);
INSERT INTO public.who_global_data VALUES (89400, 0, 0, 0, 0, 378, 232);
INSERT INTO public.who_global_data VALUES (89401, 0, 0, 0, 0, 378, 175);
INSERT INTO public.who_global_data VALUES (89402, 0, 0, 0, 0, 378, 21);
INSERT INTO public.who_global_data VALUES (89403, 0, 0, 0, 0, 378, 156);
INSERT INTO public.who_global_data VALUES (89404, 0, 0, 0, 0, 378, 95);
INSERT INTO public.who_global_data VALUES (89405, 0, 0, 0, 0, 378, 177);
INSERT INTO public.who_global_data VALUES (89406, 0, 0, 0, 0, 378, 210);
INSERT INTO public.who_global_data VALUES (89407, 0, 0, 0, 0, 378, 120);
INSERT INTO public.who_global_data VALUES (89408, 0, 0, 0, 0, 378, 135);
INSERT INTO public.who_global_data VALUES (89409, 0, 0, 0, 0, 378, 206);
INSERT INTO public.who_global_data VALUES (89410, 0, 0, 0, 0, 378, 189);
INSERT INTO public.who_global_data VALUES (89411, 0, 0, 0, 0, 378, 129);
INSERT INTO public.who_global_data VALUES (89412, 0, 0, 0, 0, 378, 121);
INSERT INTO public.who_global_data VALUES (89413, 0, 0, 0, 0, 378, 59);
INSERT INTO public.who_global_data VALUES (89414, 0, 0, 0, 0, 378, 96);
INSERT INTO public.who_global_data VALUES (89415, 0, 0, 0, 0, 378, 41);
INSERT INTO public.who_global_data VALUES (89416, 0, 0, 0, 0, 378, 216);
INSERT INTO public.who_global_data VALUES (89417, 0, 0, 0, 0, 378, 236);
INSERT INTO public.who_global_data VALUES (89418, 0, 0, 0, 0, 378, 150);
INSERT INTO public.who_global_data VALUES (89419, 0, 0, 0, 0, 378, 61);
INSERT INTO public.who_global_data VALUES (89420, 0, 0, 0, 0, 378, 7);
INSERT INTO public.who_global_data VALUES (89421, 0, 0, 0, 0, 378, 169);
INSERT INTO public.who_global_data VALUES (89422, 0, 3, 0, 0, 378, 28);
INSERT INTO public.who_global_data VALUES (89423, 0, 0, 0, 0, 378, 85);
INSERT INTO public.who_global_data VALUES (89424, 0, 0, 0, 0, 378, 211);
INSERT INTO public.who_global_data VALUES (89425, 0, 0, 0, 0, 378, 60);
INSERT INTO public.who_global_data VALUES (89426, 0, 0, 0, 0, 378, 3);
INSERT INTO public.who_global_data VALUES (89427, 0, 0, 0, 0, 378, 11);
INSERT INTO public.who_global_data VALUES (89428, 0, 0, 0, 0, 378, 89);
INSERT INTO public.who_global_data VALUES (89429, 0, 0, 0, 0, 378, 24);
INSERT INTO public.who_global_data VALUES (89430, 0, 0, 0, 0, 378, 162);
INSERT INTO public.who_global_data VALUES (89431, 0, 0, 0, 0, 378, 100);
INSERT INTO public.who_global_data VALUES (89432, 0, 0, 0, 0, 378, 47);
INSERT INTO public.who_global_data VALUES (89433, 0, 0, 0, 0, 378, 29);
INSERT INTO public.who_global_data VALUES (89434, 0, 0, 0, 0, 378, 40);
INSERT INTO public.who_global_data VALUES (89435, 0, 0, 0, 0, 378, 222);
INSERT INTO public.who_global_data VALUES (89436, 0, 0, 0, 0, 378, 132);
INSERT INTO public.who_global_data VALUES (89437, 0, 0, 0, 0, 378, 130);
INSERT INTO public.who_global_data VALUES (89438, 0, 0, 0, 0, 378, 234);
INSERT INTO public.who_global_data VALUES (89439, 0, 0, 0, 0, 378, 23);
INSERT INTO public.who_global_data VALUES (89440, 0, 0, 0, 0, 378, 192);
INSERT INTO public.who_global_data VALUES (89441, 0, 0, 0, 0, 378, 69);
INSERT INTO public.who_global_data VALUES (89442, 0, 0, 0, 0, 378, 187);
INSERT INTO public.who_global_data VALUES (89443, 0, 0, 0, 0, 378, 230);
INSERT INTO public.who_global_data VALUES (89444, 0, 0, 0, 0, 378, 77);
INSERT INTO public.who_global_data VALUES (89445, 0, 0, 0, 0, 378, 9);
INSERT INTO public.who_global_data VALUES (89446, 0, 0, 0, 0, 378, 74);
INSERT INTO public.who_global_data VALUES (89447, 0, 0, 0, 0, 378, 224);
INSERT INTO public.who_global_data VALUES (89448, 0, 0, 0, 0, 378, 199);
INSERT INTO public.who_global_data VALUES (89449, 0, 0, 0, 0, 378, 190);
INSERT INTO public.who_global_data VALUES (89450, 0, 0, 0, 0, 378, 12);
INSERT INTO public.who_global_data VALUES (89451, 0, 0, 0, 0, 378, 104);
INSERT INTO public.who_global_data VALUES (89452, 0, 0, 0, 0, 378, 153);
INSERT INTO public.who_global_data VALUES (89453, 0, 0, 0, 0, 378, 91);
INSERT INTO public.who_global_data VALUES (89454, 0, 0, 0, 0, 378, 215);
INSERT INTO public.who_global_data VALUES (89455, 1, 3, 0, 0, 378, 84);
INSERT INTO public.who_global_data VALUES (89456, 0, 0, 0, 0, 378, 231);
INSERT INTO public.who_global_data VALUES (89457, 0, 0, 0, 0, 378, 196);
INSERT INTO public.who_global_data VALUES (89458, 0, 0, 0, 0, 378, 105);
INSERT INTO public.who_global_data VALUES (89459, 0, 0, 0, 0, 378, 122);
INSERT INTO public.who_global_data VALUES (89460, 0, 0, 0, 0, 378, 159);
INSERT INTO public.who_global_data VALUES (89461, 0, 0, 0, 0, 378, 75);
INSERT INTO public.who_global_data VALUES (89462, 0, 0, 0, 0, 378, 27);
INSERT INTO public.who_global_data VALUES (89463, 0, 0, 0, 0, 378, 54);
INSERT INTO public.who_global_data VALUES (89464, 0, 0, 0, 0, 378, 226);
INSERT INTO public.who_global_data VALUES (89465, 0, 0, 0, 0, 378, 79);
INSERT INTO public.who_global_data VALUES (89466, 0, 0, 0, 0, 378, 56);
INSERT INTO public.who_global_data VALUES (89467, 0, 0, 0, 0, 378, 117);
INSERT INTO public.who_global_data VALUES (89468, 0, 0, 0, 0, 378, 152);
INSERT INTO public.who_global_data VALUES (89469, 0, 0, 0, 0, 378, 16);
INSERT INTO public.who_global_data VALUES (89470, 0, 0, 0, 0, 378, 10);
INSERT INTO public.who_global_data VALUES (89471, 0, 0, 0, 0, 378, 201);
INSERT INTO public.who_global_data VALUES (89472, 0, 0, 0, 0, 378, 174);
INSERT INTO public.who_global_data VALUES (89473, 0, 0, 0, 0, 378, 119);
INSERT INTO public.who_global_data VALUES (89474, 0, 0, 0, 0, 378, 168);
INSERT INTO public.who_global_data VALUES (89475, 7, 7, 0, 0, 378, 99);
INSERT INTO public.who_global_data VALUES (89476, 0, 0, 0, 0, 378, 171);
INSERT INTO public.who_global_data VALUES (89477, 0, 0, 0, 0, 378, 87);
INSERT INTO public.who_global_data VALUES (89478, 0, 0, 0, 0, 378, 123);
INSERT INTO public.who_global_data VALUES (89479, 0, 0, 0, 0, 378, 151);
INSERT INTO public.who_global_data VALUES (89480, 0, 0, 0, 0, 378, 213);
INSERT INTO public.who_global_data VALUES (89481, 0, 0, 0, 0, 378, 118);
INSERT INTO public.who_global_data VALUES (89482, 0, 0, 0, 0, 378, 134);
INSERT INTO public.who_global_data VALUES (89483, 0, 0, 0, 0, 378, 65);
INSERT INTO public.who_global_data VALUES (89484, 0, 0, 0, 0, 378, 102);
INSERT INTO public.who_global_data VALUES (89485, 0, 0, 0, 0, 378, 223);
INSERT INTO public.who_global_data VALUES (89486, 0, 0, 0, 0, 378, 4);
INSERT INTO public.who_global_data VALUES (89487, 0, 0, 0, 0, 378, 146);
INSERT INTO public.who_global_data VALUES (89488, 0, 0, 0, 0, 378, 31);
INSERT INTO public.who_global_data VALUES (89489, 0, 0, 0, 0, 378, 127);
INSERT INTO public.who_global_data VALUES (89490, 0, 0, 0, 0, 378, 22);
INSERT INTO public.who_global_data VALUES (89491, 0, 0, 0, 0, 378, 115);
INSERT INTO public.who_global_data VALUES (89492, 0, 0, 0, 0, 378, 106);
INSERT INTO public.who_global_data VALUES (89493, 0, 0, 0, 0, 378, 90);
INSERT INTO public.who_global_data VALUES (89494, 0, 0, 0, 0, 378, 70);
INSERT INTO public.who_global_data VALUES (89495, 0, 5, 0, 0, 378, 46);
INSERT INTO public.who_global_data VALUES (89496, 0, 0, 0, 0, 378, 139);
INSERT INTO public.who_global_data VALUES (89497, 0, 0, 0, 0, 378, 42);
INSERT INTO public.who_global_data VALUES (89498, 0, 0, 0, 0, 378, 80);
INSERT INTO public.who_global_data VALUES (89499, 0, 0, 0, 0, 378, 203);
INSERT INTO public.who_global_data VALUES (89500, 0, 0, 0, 0, 378, 136);
INSERT INTO public.who_global_data VALUES (89501, 0, 0, 0, 0, 378, 63);
INSERT INTO public.who_global_data VALUES (89502, 0, 0, 0, 0, 378, 17);
INSERT INTO public.who_global_data VALUES (89503, 0, 0, 0, 0, 378, 172);
INSERT INTO public.who_global_data VALUES (89504, 0, 0, 0, 0, 378, 109);
INSERT INTO public.who_global_data VALUES (89505, 0, 0, 0, 0, 378, 200);
INSERT INTO public.who_global_data VALUES (89506, 0, 0, 0, 0, 378, 93);
INSERT INTO public.who_global_data VALUES (89507, 0, 0, 0, 0, 378, 5);
INSERT INTO public.who_global_data VALUES (89508, 0, 0, 0, 0, 378, 214);
INSERT INTO public.who_global_data VALUES (89509, 0, 0, 0, 0, 378, 204);
INSERT INTO public.who_global_data VALUES (89510, 0, 0, 0, 0, 378, 198);
INSERT INTO public.who_global_data VALUES (89511, 0, 0, 0, 0, 378, 173);
INSERT INTO public.who_global_data VALUES (89512, 0, 0, 0, 0, 378, 229);
INSERT INTO public.who_global_data VALUES (89513, 0, 0, 0, 0, 378, 76);
INSERT INTO public.who_global_data VALUES (89514, 0, 0, 0, 0, 378, 138);
INSERT INTO public.who_global_data VALUES (89515, 0, 0, 0, 0, 378, 98);
INSERT INTO public.who_global_data VALUES (89516, 0, 0, 0, 0, 378, 103);
INSERT INTO public.who_global_data VALUES (89517, 0, 0, 0, 0, 378, 225);
INSERT INTO public.who_global_data VALUES (89518, 0, 0, 0, 0, 378, 131);
INSERT INTO public.who_global_data VALUES (89519, 0, 0, 0, 0, 378, 235);
INSERT INTO public.who_global_data VALUES (89520, 0, 0, 0, 0, 378, 137);
INSERT INTO public.who_global_data VALUES (89521, 0, 6, 0, 0, 378, 81);
INSERT INTO public.who_global_data VALUES (89522, 0, 0, 0, 0, 378, 182);
INSERT INTO public.who_global_data VALUES (89523, 0, 0, 0, 0, 378, 145);
INSERT INTO public.who_global_data VALUES (89524, 0, 0, 0, 0, 378, 26);
INSERT INTO public.who_global_data VALUES (89525, 0, 0, 0, 0, 378, 170);
INSERT INTO public.who_global_data VALUES (89526, 0, 0, 0, 0, 378, 191);
INSERT INTO public.who_global_data VALUES (89527, 0, 0, 0, 0, 378, 221);
INSERT INTO public.who_global_data VALUES (89528, 0, 0, 0, 0, 378, 64);
INSERT INTO public.who_global_data VALUES (89529, 0, 0, 0, 0, 378, 116);
INSERT INTO public.who_global_data VALUES (89530, 0, 0, 0, 0, 378, 128);
INSERT INTO public.who_global_data VALUES (89531, 0, 0, 0, 0, 378, 6);
INSERT INTO public.who_global_data VALUES (89532, 0, 0, 0, 0, 378, 227);
INSERT INTO public.who_global_data VALUES (89533, 0, 0, 0, 0, 378, 68);
INSERT INTO public.who_global_data VALUES (89534, 0, 0, 0, 0, 378, 184);
INSERT INTO public.who_global_data VALUES (89535, 0, 0, 0, 0, 378, 82);
INSERT INTO public.who_global_data VALUES (89536, 0, 0, 0, 0, 378, 149);
INSERT INTO public.who_global_data VALUES (89537, 0, 0, 0, 0, 378, 197);
INSERT INTO public.who_global_data VALUES (89538, 0, 0, 0, 0, 378, 78);
INSERT INTO public.who_global_data VALUES (89539, 0, 0, 0, 0, 378, 233);
INSERT INTO public.who_global_data VALUES (89540, 0, 0, 0, 0, 378, 133);
INSERT INTO public.who_global_data VALUES (89541, 0, 0, 0, 0, 378, 35);
INSERT INTO public.who_global_data VALUES (89542, 0, 0, 0, 0, 378, 114);
INSERT INTO public.who_global_data VALUES (89543, 0, 7, 0, 0, 378, 237);
INSERT INTO public.who_global_data VALUES (89544, 0, 0, 0, 0, 378, 55);
INSERT INTO public.who_global_data VALUES (89545, 0, 0, 0, 0, 378, 176);
INSERT INTO public.who_global_data VALUES (89546, 0, 0, 0, 0, 378, 202);
INSERT INTO public.who_global_data VALUES (89547, 0, 0, 0, 0, 378, 155);
INSERT INTO public.who_global_data VALUES (89548, 0, 0, 0, 0, 378, 32);
INSERT INTO public.who_global_data VALUES (89549, 0, 0, 0, 0, 378, 220);
INSERT INTO public.who_global_data VALUES (89550, 0, 0, 0, 0, 378, 30);
INSERT INTO public.who_global_data VALUES (89551, 0, 0, 0, 0, 378, 147);
INSERT INTO public.who_global_data VALUES (89552, 0, 0, 0, 0, 378, 208);
INSERT INTO public.who_global_data VALUES (89553, 0, 0, 0, 0, 378, 45);
INSERT INTO public.who_global_data VALUES (89554, 0, 0, 0, 0, 378, 110);
INSERT INTO public.who_global_data VALUES (89555, 0, 0, 0, 0, 378, 88);
INSERT INTO public.who_global_data VALUES (89556, 0, 0, 0, 0, 378, 51);
INSERT INTO public.who_global_data VALUES (89557, 0, 0, 0, 0, 378, 209);
INSERT INTO public.who_global_data VALUES (89558, 0, 0, 0, 0, 378, 205);
INSERT INTO public.who_global_data VALUES (89559, 0, 0, 0, 0, 378, 18);
INSERT INTO public.who_global_data VALUES (89560, 0, 8, 0, 0, 378, 72);
INSERT INTO public.who_global_data VALUES (89561, 0, 0, 0, 0, 378, 44);
INSERT INTO public.who_global_data VALUES (89562, 0, 0, 0, 0, 378, 15);
INSERT INTO public.who_global_data VALUES (89563, 0, 0, 0, 0, 378, 25);
INSERT INTO public.who_global_data VALUES (89564, 0, 0, 0, 0, 378, 179);
INSERT INTO public.who_global_data VALUES (89565, 0, 0, 0, 0, 378, 34);
INSERT INTO public.who_global_data VALUES (89566, 0, 0, 0, 0, 378, 207);
INSERT INTO public.who_global_data VALUES (89567, 0, 0, 0, 0, 378, 166);
INSERT INTO public.who_global_data VALUES (89568, 0, 0, 0, 0, 378, 126);
INSERT INTO public.who_global_data VALUES (89569, 0, 0, 0, 0, 378, 97);
INSERT INTO public.who_global_data VALUES (89570, 0, 0, 0, 0, 378, 36);
INSERT INTO public.who_global_data VALUES (89571, 0, 0, 0, 0, 378, 125);
INSERT INTO public.who_global_data VALUES (89572, 0, 0, 0, 0, 378, 124);
INSERT INTO public.who_global_data VALUES (89573, 0, 0, 0, 0, 378, 185);
INSERT INTO public.who_global_data VALUES (89574, 0, 0, 0, 0, 378, 194);
INSERT INTO public.who_global_data VALUES (89575, 0, 0, 0, 0, 378, 144);
INSERT INTO public.who_global_data VALUES (89576, 0, 6, 0, 0, 378, 19);
INSERT INTO public.who_global_data VALUES (89577, 0, 0, 0, 0, 378, 217);
INSERT INTO public.who_global_data VALUES (89578, 0, 0, 0, 0, 378, 148);
INSERT INTO public.who_global_data VALUES (89579, 0, 0, 0, 0, 378, 86);
INSERT INTO public.who_global_data VALUES (89580, 0, 0, 0, 0, 378, 13);
INSERT INTO public.who_global_data VALUES (89581, 0, 0, 0, 0, 378, 157);
INSERT INTO public.who_global_data VALUES (89582, 0, 6, 0, 0, 378, 8);
INSERT INTO public.who_global_data VALUES (89583, 0, 0, 0, 0, 378, 73);
INSERT INTO public.who_global_data VALUES (89584, 0, 0, 0, 0, 378, 101);
INSERT INTO public.who_global_data VALUES (89585, 0, 0, 0, 0, 378, 165);
INSERT INTO public.who_global_data VALUES (89586, 0, 0, 0, 0, 378, 14);
INSERT INTO public.who_global_data VALUES (89587, 0, 0, 0, 0, 379, 193);
INSERT INTO public.who_global_data VALUES (89588, 0, 0, 0, 0, 379, 113);
INSERT INTO public.who_global_data VALUES (89589, 0, 0, 0, 0, 379, 143);
INSERT INTO public.who_global_data VALUES (89590, 0, 0, 0, 0, 379, 219);
INSERT INTO public.who_global_data VALUES (89591, 0, 0, 0, 0, 379, 186);
INSERT INTO public.who_global_data VALUES (89592, 0, 0, 0, 0, 379, 52);
INSERT INTO public.who_global_data VALUES (89593, 0, 0, 0, 0, 379, 180);
INSERT INTO public.who_global_data VALUES (89594, 0, 0, 0, 0, 379, 167);
INSERT INTO public.who_global_data VALUES (89595, 0, 0, 0, 0, 379, 154);
INSERT INTO public.who_global_data VALUES (89596, 0, 0, 0, 0, 379, 94);
INSERT INTO public.who_global_data VALUES (89597, 0, 0, 0, 0, 379, 66);
INSERT INTO public.who_global_data VALUES (89598, 0, 0, 0, 0, 379, 58);
INSERT INTO public.who_global_data VALUES (89599, 0, 0, 0, 0, 379, 163);
INSERT INTO public.who_global_data VALUES (89600, 0, 0, 0, 0, 379, 37);
INSERT INTO public.who_global_data VALUES (89601, 0, 0, 0, 0, 379, 142);
INSERT INTO public.who_global_data VALUES (89602, 0, 0, 0, 0, 379, 83);
INSERT INTO public.who_global_data VALUES (89603, 0, 0, 0, 0, 379, 228);
INSERT INTO public.who_global_data VALUES (89604, 0, 0, 0, 0, 379, 188);
INSERT INTO public.who_global_data VALUES (89605, 0, 0, 0, 0, 379, 62);
INSERT INTO public.who_global_data VALUES (89606, 0, 0, 0, 0, 379, 160);
INSERT INTO public.who_global_data VALUES (89607, 0, 0, 0, 0, 379, 50);
INSERT INTO public.who_global_data VALUES (89608, 0, 0, 0, 0, 379, 33);
INSERT INTO public.who_global_data VALUES (89609, 0, 0, 0, 0, 379, 183);
INSERT INTO public.who_global_data VALUES (89610, 0, 0, 0, 0, 379, 92);
INSERT INTO public.who_global_data VALUES (89611, 0, 0, 0, 0, 379, 158);
INSERT INTO public.who_global_data VALUES (89612, 0, 0, 0, 0, 379, 67);
INSERT INTO public.who_global_data VALUES (89613, 0, 0, 0, 0, 379, 57);
INSERT INTO public.who_global_data VALUES (89614, 0, 0, 0, 0, 379, 38);
INSERT INTO public.who_global_data VALUES (89615, 0, 0, 0, 0, 379, 141);
INSERT INTO public.who_global_data VALUES (89616, 0, 0, 0, 0, 379, 178);
INSERT INTO public.who_global_data VALUES (89617, 0, 0, 0, 0, 379, 108);
INSERT INTO public.who_global_data VALUES (89618, 0, 0, 0, 0, 379, 39);
INSERT INTO public.who_global_data VALUES (89619, 0, 0, 0, 0, 379, 2);
INSERT INTO public.who_global_data VALUES (89620, 0, 0, 0, 0, 379, 195);
INSERT INTO public.who_global_data VALUES (89621, 0, 0, 0, 0, 379, 107);
INSERT INTO public.who_global_data VALUES (89622, 0, 0, 0, 0, 379, 161);
INSERT INTO public.who_global_data VALUES (89623, 0, 0, 0, 0, 379, 212);
INSERT INTO public.who_global_data VALUES (89624, 0, 0, 0, 0, 379, 181);
INSERT INTO public.who_global_data VALUES (89625, 0, 0, 0, 0, 379, 53);
INSERT INTO public.who_global_data VALUES (89626, 0, 0, 0, 0, 379, 164);
INSERT INTO public.who_global_data VALUES (89627, 0, 0, 0, 0, 379, 140);
INSERT INTO public.who_global_data VALUES (89628, 0, 0, 0, 0, 379, 20);
INSERT INTO public.who_global_data VALUES (89629, 261, 839, 8, 25, 379, 112);
INSERT INTO public.who_global_data VALUES (89630, 0, 0, 0, 0, 379, 111);
INSERT INTO public.who_global_data VALUES (89631, 0, 0, 0, 0, 379, 71);
INSERT INTO public.who_global_data VALUES (89632, 0, 0, 0, 0, 379, 218);
INSERT INTO public.who_global_data VALUES (89633, 0, 0, 0, 0, 379, 43);
INSERT INTO public.who_global_data VALUES (89634, 0, 0, 0, 0, 379, 49);
INSERT INTO public.who_global_data VALUES (89635, 0, 0, 0, 0, 379, 1);
INSERT INTO public.who_global_data VALUES (89636, 0, 0, 0, 0, 379, 48);
INSERT INTO public.who_global_data VALUES (89637, 0, 0, 0, 0, 379, 232);
INSERT INTO public.who_global_data VALUES (89638, 0, 0, 0, 0, 379, 175);
INSERT INTO public.who_global_data VALUES (89639, 0, 0, 0, 0, 379, 21);
INSERT INTO public.who_global_data VALUES (89640, 0, 0, 0, 0, 379, 156);
INSERT INTO public.who_global_data VALUES (89641, 0, 0, 0, 0, 379, 95);
INSERT INTO public.who_global_data VALUES (89642, 0, 0, 0, 0, 379, 177);
INSERT INTO public.who_global_data VALUES (89643, 0, 0, 0, 0, 379, 210);
INSERT INTO public.who_global_data VALUES (89644, 0, 0, 0, 0, 379, 120);
INSERT INTO public.who_global_data VALUES (89645, 0, 0, 0, 0, 379, 135);
INSERT INTO public.who_global_data VALUES (89646, 0, 0, 0, 0, 379, 206);
INSERT INTO public.who_global_data VALUES (89647, 0, 0, 0, 0, 379, 189);
INSERT INTO public.who_global_data VALUES (89648, 0, 0, 0, 0, 379, 129);
INSERT INTO public.who_global_data VALUES (89649, 0, 0, 0, 0, 379, 121);
INSERT INTO public.who_global_data VALUES (89650, 0, 0, 0, 0, 379, 59);
INSERT INTO public.who_global_data VALUES (89651, 0, 0, 0, 0, 379, 96);
INSERT INTO public.who_global_data VALUES (89652, 0, 0, 0, 0, 379, 41);
INSERT INTO public.who_global_data VALUES (89653, 0, 0, 0, 0, 379, 216);
INSERT INTO public.who_global_data VALUES (89654, 0, 0, 0, 0, 379, 236);
INSERT INTO public.who_global_data VALUES (89655, 0, 0, 0, 0, 379, 150);
INSERT INTO public.who_global_data VALUES (89656, 0, 0, 0, 0, 379, 61);
INSERT INTO public.who_global_data VALUES (89657, 0, 0, 0, 0, 379, 7);
INSERT INTO public.who_global_data VALUES (89658, 0, 0, 0, 0, 379, 169);
INSERT INTO public.who_global_data VALUES (89659, 3, 3, 0, 0, 379, 28);
INSERT INTO public.who_global_data VALUES (89660, 0, 0, 0, 0, 379, 85);
INSERT INTO public.who_global_data VALUES (89661, 0, 0, 0, 0, 379, 211);
INSERT INTO public.who_global_data VALUES (89662, 0, 0, 0, 0, 379, 60);
INSERT INTO public.who_global_data VALUES (89663, 0, 0, 0, 0, 379, 3);
INSERT INTO public.who_global_data VALUES (89664, 0, 0, 0, 0, 379, 11);
INSERT INTO public.who_global_data VALUES (89665, 0, 0, 0, 0, 379, 89);
INSERT INTO public.who_global_data VALUES (89666, 0, 0, 0, 0, 379, 24);
INSERT INTO public.who_global_data VALUES (89667, 0, 0, 0, 0, 379, 162);
INSERT INTO public.who_global_data VALUES (89668, 0, 0, 0, 0, 379, 100);
INSERT INTO public.who_global_data VALUES (89669, 0, 0, 0, 0, 379, 47);
INSERT INTO public.who_global_data VALUES (89670, 0, 0, 0, 0, 379, 29);
INSERT INTO public.who_global_data VALUES (89671, 0, 0, 0, 0, 379, 40);
INSERT INTO public.who_global_data VALUES (89672, 0, 0, 0, 0, 379, 222);
INSERT INTO public.who_global_data VALUES (89673, 0, 0, 0, 0, 379, 132);
INSERT INTO public.who_global_data VALUES (89674, 0, 0, 0, 0, 379, 130);
INSERT INTO public.who_global_data VALUES (89675, 0, 0, 0, 0, 379, 234);
INSERT INTO public.who_global_data VALUES (89676, 0, 0, 0, 0, 379, 23);
INSERT INTO public.who_global_data VALUES (89677, 0, 0, 0, 0, 379, 192);
INSERT INTO public.who_global_data VALUES (89678, 0, 0, 0, 0, 379, 69);
INSERT INTO public.who_global_data VALUES (89679, 0, 0, 0, 0, 379, 187);
INSERT INTO public.who_global_data VALUES (89680, 0, 0, 0, 0, 379, 230);
INSERT INTO public.who_global_data VALUES (89681, 0, 0, 0, 0, 379, 77);
INSERT INTO public.who_global_data VALUES (89682, 0, 0, 0, 0, 379, 9);
INSERT INTO public.who_global_data VALUES (89683, 0, 0, 0, 0, 379, 74);
INSERT INTO public.who_global_data VALUES (89684, 0, 0, 0, 0, 379, 224);
INSERT INTO public.who_global_data VALUES (89685, 0, 0, 0, 0, 379, 199);
INSERT INTO public.who_global_data VALUES (89686, 0, 0, 0, 0, 379, 190);
INSERT INTO public.who_global_data VALUES (89687, 0, 0, 0, 0, 379, 12);
INSERT INTO public.who_global_data VALUES (89688, 0, 0, 0, 0, 379, 104);
INSERT INTO public.who_global_data VALUES (89689, 0, 0, 0, 0, 379, 153);
INSERT INTO public.who_global_data VALUES (89690, 0, 0, 0, 0, 379, 91);
INSERT INTO public.who_global_data VALUES (89691, 0, 0, 0, 0, 379, 215);
INSERT INTO public.who_global_data VALUES (89692, 1, 2, 0, 0, 379, 84);
INSERT INTO public.who_global_data VALUES (89693, 0, 0, 0, 0, 379, 231);
INSERT INTO public.who_global_data VALUES (89694, 0, 0, 0, 0, 379, 196);
INSERT INTO public.who_global_data VALUES (89695, 0, 0, 0, 0, 379, 105);
INSERT INTO public.who_global_data VALUES (89696, 0, 0, 0, 0, 379, 122);
INSERT INTO public.who_global_data VALUES (89697, 0, 0, 0, 0, 379, 159);
INSERT INTO public.who_global_data VALUES (89698, 0, 0, 0, 0, 379, 75);
INSERT INTO public.who_global_data VALUES (89699, 0, 0, 0, 0, 379, 27);
INSERT INTO public.who_global_data VALUES (89700, 0, 0, 0, 0, 379, 54);
INSERT INTO public.who_global_data VALUES (89701, 0, 0, 0, 0, 379, 226);
INSERT INTO public.who_global_data VALUES (89702, 0, 0, 0, 0, 379, 79);
INSERT INTO public.who_global_data VALUES (89703, 0, 0, 0, 0, 379, 56);
INSERT INTO public.who_global_data VALUES (89704, 0, 0, 0, 0, 379, 117);
INSERT INTO public.who_global_data VALUES (89705, 0, 0, 0, 0, 379, 152);
INSERT INTO public.who_global_data VALUES (89706, 0, 0, 0, 0, 379, 16);
INSERT INTO public.who_global_data VALUES (89707, 0, 0, 0, 0, 379, 10);
INSERT INTO public.who_global_data VALUES (89708, 0, 0, 0, 0, 379, 201);
INSERT INTO public.who_global_data VALUES (89709, 0, 0, 0, 0, 379, 174);
INSERT INTO public.who_global_data VALUES (89710, 0, 0, 0, 0, 379, 119);
INSERT INTO public.who_global_data VALUES (89711, 0, 0, 0, 0, 379, 168);
INSERT INTO public.who_global_data VALUES (89712, 0, 0, 0, 0, 379, 99);
INSERT INTO public.who_global_data VALUES (89713, 0, 0, 0, 0, 379, 171);
INSERT INTO public.who_global_data VALUES (89714, 0, 0, 0, 0, 379, 87);
INSERT INTO public.who_global_data VALUES (89715, 0, 0, 0, 0, 379, 123);
INSERT INTO public.who_global_data VALUES (89716, 0, 0, 0, 0, 379, 151);
INSERT INTO public.who_global_data VALUES (89717, 0, 0, 0, 0, 379, 213);
INSERT INTO public.who_global_data VALUES (89718, 0, 0, 0, 0, 379, 118);
INSERT INTO public.who_global_data VALUES (89719, 0, 0, 0, 0, 379, 134);
INSERT INTO public.who_global_data VALUES (89720, 0, 0, 0, 0, 379, 65);
INSERT INTO public.who_global_data VALUES (89721, 0, 0, 0, 0, 379, 102);
INSERT INTO public.who_global_data VALUES (89722, 0, 0, 0, 0, 379, 223);
INSERT INTO public.who_global_data VALUES (89723, 0, 0, 0, 0, 379, 4);
INSERT INTO public.who_global_data VALUES (89724, 0, 0, 0, 0, 379, 146);
INSERT INTO public.who_global_data VALUES (89725, 0, 0, 0, 0, 379, 31);
INSERT INTO public.who_global_data VALUES (89726, 0, 0, 0, 0, 379, 127);
INSERT INTO public.who_global_data VALUES (89727, 0, 0, 0, 0, 379, 22);
INSERT INTO public.who_global_data VALUES (89728, 0, 0, 0, 0, 379, 115);
INSERT INTO public.who_global_data VALUES (89729, 0, 0, 0, 0, 379, 106);
INSERT INTO public.who_global_data VALUES (89730, 0, 0, 0, 0, 379, 90);
INSERT INTO public.who_global_data VALUES (89731, 0, 0, 0, 0, 379, 70);
INSERT INTO public.who_global_data VALUES (89732, 0, 5, 0, 0, 379, 46);
INSERT INTO public.who_global_data VALUES (89733, 0, 0, 0, 0, 379, 139);
INSERT INTO public.who_global_data VALUES (89734, 0, 0, 0, 0, 379, 42);
INSERT INTO public.who_global_data VALUES (89735, 0, 0, 0, 0, 379, 80);
INSERT INTO public.who_global_data VALUES (89736, 0, 0, 0, 0, 379, 203);
INSERT INTO public.who_global_data VALUES (89737, 0, 0, 0, 0, 379, 136);
INSERT INTO public.who_global_data VALUES (89738, 0, 0, 0, 0, 379, 63);
INSERT INTO public.who_global_data VALUES (89739, 0, 0, 0, 0, 379, 17);
INSERT INTO public.who_global_data VALUES (89740, 0, 0, 0, 0, 379, 172);
INSERT INTO public.who_global_data VALUES (89741, 0, 0, 0, 0, 379, 109);
INSERT INTO public.who_global_data VALUES (89742, 0, 0, 0, 0, 379, 200);
INSERT INTO public.who_global_data VALUES (89743, 0, 0, 0, 0, 379, 93);
INSERT INTO public.who_global_data VALUES (89744, 0, 0, 0, 0, 379, 5);
INSERT INTO public.who_global_data VALUES (89745, 0, 0, 0, 0, 379, 214);
INSERT INTO public.who_global_data VALUES (89746, 0, 0, 0, 0, 379, 204);
INSERT INTO public.who_global_data VALUES (89747, 0, 0, 0, 0, 379, 198);
INSERT INTO public.who_global_data VALUES (89748, 0, 0, 0, 0, 379, 173);
INSERT INTO public.who_global_data VALUES (89749, 0, 0, 0, 0, 379, 229);
INSERT INTO public.who_global_data VALUES (89750, 0, 0, 0, 0, 379, 76);
INSERT INTO public.who_global_data VALUES (89751, 0, 0, 0, 0, 379, 138);
INSERT INTO public.who_global_data VALUES (89752, 0, 0, 0, 0, 379, 98);
INSERT INTO public.who_global_data VALUES (89753, 0, 0, 0, 0, 379, 103);
INSERT INTO public.who_global_data VALUES (89754, 0, 0, 0, 0, 379, 225);
INSERT INTO public.who_global_data VALUES (89755, 0, 0, 0, 0, 379, 131);
INSERT INTO public.who_global_data VALUES (89756, 0, 0, 0, 0, 379, 235);
INSERT INTO public.who_global_data VALUES (89757, 0, 0, 0, 0, 379, 137);
INSERT INTO public.who_global_data VALUES (89758, 1, 6, 0, 0, 379, 81);
INSERT INTO public.who_global_data VALUES (89759, 0, 0, 0, 0, 379, 182);
INSERT INTO public.who_global_data VALUES (89760, 0, 0, 0, 0, 379, 145);
INSERT INTO public.who_global_data VALUES (89761, 0, 0, 0, 0, 379, 26);
INSERT INTO public.who_global_data VALUES (89762, 0, 0, 0, 0, 379, 170);
INSERT INTO public.who_global_data VALUES (89763, 0, 0, 0, 0, 379, 191);
INSERT INTO public.who_global_data VALUES (89764, 0, 0, 0, 0, 379, 221);
INSERT INTO public.who_global_data VALUES (89765, 0, 0, 0, 0, 379, 64);
INSERT INTO public.who_global_data VALUES (89766, 0, 0, 0, 0, 379, 116);
INSERT INTO public.who_global_data VALUES (89767, 0, 0, 0, 0, 379, 128);
INSERT INTO public.who_global_data VALUES (89768, 0, 0, 0, 0, 379, 6);
INSERT INTO public.who_global_data VALUES (89769, 0, 0, 0, 0, 379, 227);
INSERT INTO public.who_global_data VALUES (89770, 0, 0, 0, 0, 379, 68);
INSERT INTO public.who_global_data VALUES (89771, 0, 0, 0, 0, 379, 184);
INSERT INTO public.who_global_data VALUES (89772, 0, 0, 0, 0, 379, 82);
INSERT INTO public.who_global_data VALUES (89773, 0, 0, 0, 0, 379, 149);
INSERT INTO public.who_global_data VALUES (89774, 0, 0, 0, 0, 379, 197);
INSERT INTO public.who_global_data VALUES (89775, 0, 0, 0, 0, 379, 78);
INSERT INTO public.who_global_data VALUES (89776, 0, 0, 0, 0, 379, 233);
INSERT INTO public.who_global_data VALUES (89777, 0, 0, 0, 0, 379, 133);
INSERT INTO public.who_global_data VALUES (89778, 0, 0, 0, 0, 379, 35);
INSERT INTO public.who_global_data VALUES (89779, 0, 0, 0, 0, 379, 114);
INSERT INTO public.who_global_data VALUES (89780, 2, 7, 0, 0, 379, 237);
INSERT INTO public.who_global_data VALUES (89781, 0, 0, 0, 0, 379, 55);
INSERT INTO public.who_global_data VALUES (89782, 0, 0, 0, 0, 379, 176);
INSERT INTO public.who_global_data VALUES (89783, 0, 0, 0, 0, 379, 202);
INSERT INTO public.who_global_data VALUES (89784, 0, 0, 0, 0, 379, 155);
INSERT INTO public.who_global_data VALUES (89785, 0, 0, 0, 0, 379, 32);
INSERT INTO public.who_global_data VALUES (89786, 0, 0, 0, 0, 379, 220);
INSERT INTO public.who_global_data VALUES (89787, 0, 0, 0, 0, 379, 30);
INSERT INTO public.who_global_data VALUES (89788, 0, 0, 0, 0, 379, 147);
INSERT INTO public.who_global_data VALUES (89789, 0, 0, 0, 0, 379, 208);
INSERT INTO public.who_global_data VALUES (89790, 0, 0, 0, 0, 379, 45);
INSERT INTO public.who_global_data VALUES (89791, 0, 0, 0, 0, 379, 110);
INSERT INTO public.who_global_data VALUES (89792, 0, 0, 0, 0, 379, 88);
INSERT INTO public.who_global_data VALUES (89793, 0, 0, 0, 0, 379, 51);
INSERT INTO public.who_global_data VALUES (89794, 0, 0, 0, 0, 379, 209);
INSERT INTO public.who_global_data VALUES (89795, 0, 0, 0, 0, 379, 205);
INSERT INTO public.who_global_data VALUES (89796, 0, 0, 0, 0, 379, 18);
INSERT INTO public.who_global_data VALUES (89797, 0, 8, 0, 0, 379, 72);
INSERT INTO public.who_global_data VALUES (89798, 0, 0, 0, 0, 379, 44);
INSERT INTO public.who_global_data VALUES (89799, 0, 0, 0, 0, 379, 15);
INSERT INTO public.who_global_data VALUES (89800, 0, 0, 0, 0, 379, 25);
INSERT INTO public.who_global_data VALUES (89801, 0, 0, 0, 0, 379, 179);
INSERT INTO public.who_global_data VALUES (89802, 0, 0, 0, 0, 379, 34);
INSERT INTO public.who_global_data VALUES (89803, 0, 0, 0, 0, 379, 207);
INSERT INTO public.who_global_data VALUES (89804, 0, 0, 0, 0, 379, 166);
INSERT INTO public.who_global_data VALUES (89805, 0, 0, 0, 0, 379, 126);
INSERT INTO public.who_global_data VALUES (89806, 0, 0, 0, 0, 379, 97);
INSERT INTO public.who_global_data VALUES (89807, 0, 0, 0, 0, 379, 36);
INSERT INTO public.who_global_data VALUES (89808, 0, 0, 0, 0, 379, 125);
INSERT INTO public.who_global_data VALUES (89809, 0, 0, 0, 0, 379, 124);
INSERT INTO public.who_global_data VALUES (89810, 0, 0, 0, 0, 379, 185);
INSERT INTO public.who_global_data VALUES (89811, 0, 0, 0, 0, 379, 194);
INSERT INTO public.who_global_data VALUES (89812, 0, 0, 0, 0, 379, 144);
INSERT INTO public.who_global_data VALUES (89813, 1, 6, 0, 0, 379, 19);
INSERT INTO public.who_global_data VALUES (89814, 0, 0, 0, 0, 379, 217);
INSERT INTO public.who_global_data VALUES (89815, 0, 0, 0, 0, 379, 148);
INSERT INTO public.who_global_data VALUES (89816, 0, 0, 0, 0, 379, 86);
INSERT INTO public.who_global_data VALUES (89817, 0, 0, 0, 0, 379, 13);
INSERT INTO public.who_global_data VALUES (89818, 0, 0, 0, 0, 379, 157);
INSERT INTO public.who_global_data VALUES (89819, 6, 6, 0, 0, 379, 8);
INSERT INTO public.who_global_data VALUES (89820, 0, 0, 0, 0, 379, 73);
INSERT INTO public.who_global_data VALUES (89821, 0, 0, 0, 0, 379, 101);
INSERT INTO public.who_global_data VALUES (89822, 0, 0, 0, 0, 379, 165);
INSERT INTO public.who_global_data VALUES (89823, 0, 0, 0, 0, 379, 14);
INSERT INTO public.who_global_data VALUES (89824, 0, 0, 0, 0, 380, 193);
INSERT INTO public.who_global_data VALUES (89825, 0, 0, 0, 0, 380, 113);
INSERT INTO public.who_global_data VALUES (89826, 0, 0, 0, 0, 380, 143);
INSERT INTO public.who_global_data VALUES (89827, 0, 0, 0, 0, 380, 219);
INSERT INTO public.who_global_data VALUES (89828, 0, 0, 0, 0, 380, 186);
INSERT INTO public.who_global_data VALUES (89829, 0, 0, 0, 0, 380, 52);
INSERT INTO public.who_global_data VALUES (89830, 0, 0, 0, 0, 380, 180);
INSERT INTO public.who_global_data VALUES (89831, 0, 0, 0, 0, 380, 167);
INSERT INTO public.who_global_data VALUES (89832, 0, 0, 0, 0, 380, 154);
INSERT INTO public.who_global_data VALUES (89833, 0, 0, 0, 0, 380, 94);
INSERT INTO public.who_global_data VALUES (89834, 0, 0, 0, 0, 380, 66);
INSERT INTO public.who_global_data VALUES (89835, 0, 0, 0, 0, 380, 58);
INSERT INTO public.who_global_data VALUES (89836, 0, 0, 0, 0, 380, 163);
INSERT INTO public.who_global_data VALUES (89837, 0, 0, 0, 0, 380, 37);
INSERT INTO public.who_global_data VALUES (89838, 0, 0, 0, 0, 380, 142);
INSERT INTO public.who_global_data VALUES (89839, 0, 0, 0, 0, 380, 83);
INSERT INTO public.who_global_data VALUES (89840, 0, 0, 0, 0, 380, 228);
INSERT INTO public.who_global_data VALUES (89841, 0, 0, 0, 0, 380, 188);
INSERT INTO public.who_global_data VALUES (89842, 0, 0, 0, 0, 380, 62);
INSERT INTO public.who_global_data VALUES (89843, 0, 0, 0, 0, 380, 160);
INSERT INTO public.who_global_data VALUES (89844, 0, 0, 0, 0, 380, 50);
INSERT INTO public.who_global_data VALUES (89845, 0, 0, 0, 0, 380, 33);
INSERT INTO public.who_global_data VALUES (89846, 0, 0, 0, 0, 380, 183);
INSERT INTO public.who_global_data VALUES (89847, 0, 0, 0, 0, 380, 92);
INSERT INTO public.who_global_data VALUES (89848, 0, 0, 0, 0, 380, 158);
INSERT INTO public.who_global_data VALUES (89849, 0, 0, 0, 0, 380, 67);
INSERT INTO public.who_global_data VALUES (89850, 0, 0, 0, 0, 380, 57);
INSERT INTO public.who_global_data VALUES (89851, 0, 0, 0, 0, 380, 38);
INSERT INTO public.who_global_data VALUES (89852, 0, 0, 0, 0, 380, 141);
INSERT INTO public.who_global_data VALUES (89853, 0, 0, 0, 0, 380, 178);
INSERT INTO public.who_global_data VALUES (89854, 0, 0, 0, 0, 380, 108);
INSERT INTO public.who_global_data VALUES (89855, 0, 0, 0, 0, 380, 39);
INSERT INTO public.who_global_data VALUES (89856, 0, 0, 0, 0, 380, 2);
INSERT INTO public.who_global_data VALUES (89857, 0, 0, 0, 0, 380, 195);
INSERT INTO public.who_global_data VALUES (89858, 0, 0, 0, 0, 380, 107);
INSERT INTO public.who_global_data VALUES (89859, 0, 0, 0, 0, 380, 161);
INSERT INTO public.who_global_data VALUES (89860, 0, 0, 0, 0, 380, 212);
INSERT INTO public.who_global_data VALUES (89861, 0, 0, 0, 0, 380, 181);
INSERT INTO public.who_global_data VALUES (89862, 0, 0, 0, 0, 380, 53);
INSERT INTO public.who_global_data VALUES (89863, 0, 0, 0, 0, 380, 164);
INSERT INTO public.who_global_data VALUES (89864, 0, 0, 0, 0, 380, 140);
INSERT INTO public.who_global_data VALUES (89865, 0, 0, 0, 0, 380, 20);
INSERT INTO public.who_global_data VALUES (89866, 131, 578, 8, 17, 380, 112);
INSERT INTO public.who_global_data VALUES (89867, 0, 0, 0, 0, 380, 111);
INSERT INTO public.who_global_data VALUES (89868, 0, 0, 0, 0, 380, 71);
INSERT INTO public.who_global_data VALUES (89869, 0, 0, 0, 0, 380, 218);
INSERT INTO public.who_global_data VALUES (89870, 0, 0, 0, 0, 380, 43);
INSERT INTO public.who_global_data VALUES (89871, 0, 0, 0, 0, 380, 49);
INSERT INTO public.who_global_data VALUES (89872, 0, 0, 0, 0, 380, 1);
INSERT INTO public.who_global_data VALUES (89873, 0, 0, 0, 0, 380, 48);
INSERT INTO public.who_global_data VALUES (89874, 0, 0, 0, 0, 380, 232);
INSERT INTO public.who_global_data VALUES (89875, 0, 0, 0, 0, 380, 175);
INSERT INTO public.who_global_data VALUES (89876, 0, 0, 0, 0, 380, 21);
INSERT INTO public.who_global_data VALUES (89877, 0, 0, 0, 0, 380, 156);
INSERT INTO public.who_global_data VALUES (89878, 0, 0, 0, 0, 380, 95);
INSERT INTO public.who_global_data VALUES (89879, 0, 0, 0, 0, 380, 177);
INSERT INTO public.who_global_data VALUES (89880, 0, 0, 0, 0, 380, 210);
INSERT INTO public.who_global_data VALUES (89881, 0, 0, 0, 0, 380, 120);
INSERT INTO public.who_global_data VALUES (89882, 0, 0, 0, 0, 380, 135);
INSERT INTO public.who_global_data VALUES (89883, 0, 0, 0, 0, 380, 206);
INSERT INTO public.who_global_data VALUES (89884, 0, 0, 0, 0, 380, 189);
INSERT INTO public.who_global_data VALUES (89885, 0, 0, 0, 0, 380, 129);
INSERT INTO public.who_global_data VALUES (89886, 0, 0, 0, 0, 380, 121);
INSERT INTO public.who_global_data VALUES (89887, 0, 0, 0, 0, 380, 59);
INSERT INTO public.who_global_data VALUES (89888, 0, 0, 0, 0, 380, 96);
INSERT INTO public.who_global_data VALUES (89889, 0, 0, 0, 0, 380, 41);
INSERT INTO public.who_global_data VALUES (89890, 0, 0, 0, 0, 380, 216);
INSERT INTO public.who_global_data VALUES (89891, 0, 0, 0, 0, 380, 236);
INSERT INTO public.who_global_data VALUES (89892, 0, 0, 0, 0, 380, 150);
INSERT INTO public.who_global_data VALUES (89893, 0, 0, 0, 0, 380, 61);
INSERT INTO public.who_global_data VALUES (89894, 0, 0, 0, 0, 380, 7);
INSERT INTO public.who_global_data VALUES (89895, 0, 0, 0, 0, 380, 169);
INSERT INTO public.who_global_data VALUES (89896, 0, 0, 0, 0, 380, 28);
INSERT INTO public.who_global_data VALUES (89897, 0, 0, 0, 0, 380, 85);
INSERT INTO public.who_global_data VALUES (89898, 0, 0, 0, 0, 380, 211);
INSERT INTO public.who_global_data VALUES (89899, 0, 0, 0, 0, 380, 60);
INSERT INTO public.who_global_data VALUES (89900, 0, 0, 0, 0, 380, 3);
INSERT INTO public.who_global_data VALUES (89901, 0, 0, 0, 0, 380, 11);
INSERT INTO public.who_global_data VALUES (89902, 0, 0, 0, 0, 380, 89);
INSERT INTO public.who_global_data VALUES (89903, 0, 0, 0, 0, 380, 24);
INSERT INTO public.who_global_data VALUES (89904, 0, 0, 0, 0, 380, 162);
INSERT INTO public.who_global_data VALUES (89905, 0, 0, 0, 0, 380, 100);
INSERT INTO public.who_global_data VALUES (89906, 0, 0, 0, 0, 380, 47);
INSERT INTO public.who_global_data VALUES (89907, 0, 0, 0, 0, 380, 29);
INSERT INTO public.who_global_data VALUES (89908, 0, 0, 0, 0, 380, 40);
INSERT INTO public.who_global_data VALUES (89909, 0, 0, 0, 0, 380, 222);
INSERT INTO public.who_global_data VALUES (89910, 0, 0, 0, 0, 380, 132);
INSERT INTO public.who_global_data VALUES (89911, 0, 0, 0, 0, 380, 130);
INSERT INTO public.who_global_data VALUES (89912, 0, 0, 0, 0, 380, 234);
INSERT INTO public.who_global_data VALUES (89913, 0, 0, 0, 0, 380, 23);
INSERT INTO public.who_global_data VALUES (89914, 0, 0, 0, 0, 380, 192);
INSERT INTO public.who_global_data VALUES (89915, 0, 0, 0, 0, 380, 69);
INSERT INTO public.who_global_data VALUES (89916, 0, 0, 0, 0, 380, 187);
INSERT INTO public.who_global_data VALUES (89917, 0, 0, 0, 0, 380, 230);
INSERT INTO public.who_global_data VALUES (89918, 0, 0, 0, 0, 380, 77);
INSERT INTO public.who_global_data VALUES (89919, 0, 0, 0, 0, 380, 9);
INSERT INTO public.who_global_data VALUES (89920, 0, 0, 0, 0, 380, 74);
INSERT INTO public.who_global_data VALUES (89921, 0, 0, 0, 0, 380, 224);
INSERT INTO public.who_global_data VALUES (89922, 0, 0, 0, 0, 380, 199);
INSERT INTO public.who_global_data VALUES (89923, 0, 0, 0, 0, 380, 190);
INSERT INTO public.who_global_data VALUES (89924, 0, 0, 0, 0, 380, 12);
INSERT INTO public.who_global_data VALUES (89925, 0, 0, 0, 0, 380, 104);
INSERT INTO public.who_global_data VALUES (89926, 0, 0, 0, 0, 380, 153);
INSERT INTO public.who_global_data VALUES (89927, 0, 0, 0, 0, 380, 91);
INSERT INTO public.who_global_data VALUES (89928, 0, 0, 0, 0, 380, 215);
INSERT INTO public.who_global_data VALUES (89929, 0, 1, 0, 0, 380, 84);
INSERT INTO public.who_global_data VALUES (89930, 0, 0, 0, 0, 380, 231);
INSERT INTO public.who_global_data VALUES (89931, 0, 0, 0, 0, 380, 196);
INSERT INTO public.who_global_data VALUES (89932, 0, 0, 0, 0, 380, 105);
INSERT INTO public.who_global_data VALUES (89933, 0, 0, 0, 0, 380, 122);
INSERT INTO public.who_global_data VALUES (89934, 0, 0, 0, 0, 380, 159);
INSERT INTO public.who_global_data VALUES (89935, 0, 0, 0, 0, 380, 75);
INSERT INTO public.who_global_data VALUES (89936, 0, 0, 0, 0, 380, 27);
INSERT INTO public.who_global_data VALUES (89937, 0, 0, 0, 0, 380, 54);
INSERT INTO public.who_global_data VALUES (89938, 0, 0, 0, 0, 380, 226);
INSERT INTO public.who_global_data VALUES (89939, 0, 0, 0, 0, 380, 79);
INSERT INTO public.who_global_data VALUES (89940, 0, 0, 0, 0, 380, 56);
INSERT INTO public.who_global_data VALUES (89941, 0, 0, 0, 0, 380, 117);
INSERT INTO public.who_global_data VALUES (89942, 0, 0, 0, 0, 380, 152);
INSERT INTO public.who_global_data VALUES (89943, 0, 0, 0, 0, 380, 16);
INSERT INTO public.who_global_data VALUES (89944, 0, 0, 0, 0, 380, 10);
INSERT INTO public.who_global_data VALUES (89945, 0, 0, 0, 0, 380, 201);
INSERT INTO public.who_global_data VALUES (89946, 0, 0, 0, 0, 380, 174);
INSERT INTO public.who_global_data VALUES (89947, 0, 0, 0, 0, 380, 119);
INSERT INTO public.who_global_data VALUES (89948, 0, 0, 0, 0, 380, 168);
INSERT INTO public.who_global_data VALUES (89949, 0, 0, 0, 0, 380, 99);
INSERT INTO public.who_global_data VALUES (89950, 0, 0, 0, 0, 380, 171);
INSERT INTO public.who_global_data VALUES (89951, 0, 0, 0, 0, 380, 87);
INSERT INTO public.who_global_data VALUES (89952, 0, 0, 0, 0, 380, 123);
INSERT INTO public.who_global_data VALUES (89953, 0, 0, 0, 0, 380, 151);
INSERT INTO public.who_global_data VALUES (89954, 0, 0, 0, 0, 380, 213);
INSERT INTO public.who_global_data VALUES (89955, 0, 0, 0, 0, 380, 118);
INSERT INTO public.who_global_data VALUES (89956, 0, 0, 0, 0, 380, 134);
INSERT INTO public.who_global_data VALUES (89957, 0, 0, 0, 0, 380, 65);
INSERT INTO public.who_global_data VALUES (89958, 0, 0, 0, 0, 380, 102);
INSERT INTO public.who_global_data VALUES (89959, 0, 0, 0, 0, 380, 223);
INSERT INTO public.who_global_data VALUES (89960, 0, 0, 0, 0, 380, 4);
INSERT INTO public.who_global_data VALUES (89961, 0, 0, 0, 0, 380, 146);
INSERT INTO public.who_global_data VALUES (89962, 0, 0, 0, 0, 380, 31);
INSERT INTO public.who_global_data VALUES (89963, 0, 0, 0, 0, 380, 127);
INSERT INTO public.who_global_data VALUES (89964, 0, 0, 0, 0, 380, 22);
INSERT INTO public.who_global_data VALUES (89965, 0, 0, 0, 0, 380, 115);
INSERT INTO public.who_global_data VALUES (89966, 0, 0, 0, 0, 380, 106);
INSERT INTO public.who_global_data VALUES (89967, 0, 0, 0, 0, 380, 90);
INSERT INTO public.who_global_data VALUES (89968, 0, 0, 0, 0, 380, 70);
INSERT INTO public.who_global_data VALUES (89969, 5, 5, 0, 0, 380, 46);
INSERT INTO public.who_global_data VALUES (89970, 0, 0, 0, 0, 380, 139);
INSERT INTO public.who_global_data VALUES (89971, 0, 0, 0, 0, 380, 42);
INSERT INTO public.who_global_data VALUES (89972, 0, 0, 0, 0, 380, 80);
INSERT INTO public.who_global_data VALUES (89973, 0, 0, 0, 0, 380, 203);
INSERT INTO public.who_global_data VALUES (89974, 0, 0, 0, 0, 380, 136);
INSERT INTO public.who_global_data VALUES (89975, 0, 0, 0, 0, 380, 63);
INSERT INTO public.who_global_data VALUES (89976, 0, 0, 0, 0, 380, 17);
INSERT INTO public.who_global_data VALUES (89977, 0, 0, 0, 0, 380, 172);
INSERT INTO public.who_global_data VALUES (89978, 0, 0, 0, 0, 380, 109);
INSERT INTO public.who_global_data VALUES (89979, 0, 0, 0, 0, 380, 200);
INSERT INTO public.who_global_data VALUES (89980, 0, 0, 0, 0, 380, 93);
INSERT INTO public.who_global_data VALUES (89981, 0, 0, 0, 0, 380, 5);
INSERT INTO public.who_global_data VALUES (89982, 0, 0, 0, 0, 380, 214);
INSERT INTO public.who_global_data VALUES (89983, 0, 0, 0, 0, 380, 204);
INSERT INTO public.who_global_data VALUES (89984, 0, 0, 0, 0, 380, 198);
INSERT INTO public.who_global_data VALUES (89985, 0, 0, 0, 0, 380, 173);
INSERT INTO public.who_global_data VALUES (89986, 0, 0, 0, 0, 380, 229);
INSERT INTO public.who_global_data VALUES (89987, 0, 0, 0, 0, 380, 76);
INSERT INTO public.who_global_data VALUES (89988, 0, 0, 0, 0, 380, 138);
INSERT INTO public.who_global_data VALUES (89989, 0, 0, 0, 0, 380, 98);
INSERT INTO public.who_global_data VALUES (89990, 0, 0, 0, 0, 380, 103);
INSERT INTO public.who_global_data VALUES (89991, 0, 0, 0, 0, 380, 225);
INSERT INTO public.who_global_data VALUES (89992, 0, 0, 0, 0, 380, 131);
INSERT INTO public.who_global_data VALUES (89993, 0, 0, 0, 0, 380, 235);
INSERT INTO public.who_global_data VALUES (89994, 0, 0, 0, 0, 380, 137);
INSERT INTO public.who_global_data VALUES (89995, 0, 5, 0, 0, 380, 81);
INSERT INTO public.who_global_data VALUES (89996, 0, 0, 0, 0, 380, 182);
INSERT INTO public.who_global_data VALUES (89997, 0, 0, 0, 0, 380, 145);
INSERT INTO public.who_global_data VALUES (89998, 0, 0, 0, 0, 380, 26);
INSERT INTO public.who_global_data VALUES (89999, 0, 0, 0, 0, 380, 170);
INSERT INTO public.who_global_data VALUES (90000, 0, 0, 0, 0, 380, 191);
INSERT INTO public.who_global_data VALUES (90001, 0, 0, 0, 0, 380, 221);
INSERT INTO public.who_global_data VALUES (90002, 0, 0, 0, 0, 380, 64);
INSERT INTO public.who_global_data VALUES (90003, 0, 0, 0, 0, 380, 116);
INSERT INTO public.who_global_data VALUES (90004, 0, 0, 0, 0, 380, 128);
INSERT INTO public.who_global_data VALUES (90005, 0, 0, 0, 0, 380, 6);
INSERT INTO public.who_global_data VALUES (90006, 0, 0, 0, 0, 380, 227);
INSERT INTO public.who_global_data VALUES (90007, 0, 0, 0, 0, 380, 68);
INSERT INTO public.who_global_data VALUES (90008, 0, 0, 0, 0, 380, 184);
INSERT INTO public.who_global_data VALUES (90009, 0, 0, 0, 0, 380, 82);
INSERT INTO public.who_global_data VALUES (90010, 0, 0, 0, 0, 380, 149);
INSERT INTO public.who_global_data VALUES (90011, 0, 0, 0, 0, 380, 197);
INSERT INTO public.who_global_data VALUES (90012, 0, 0, 0, 0, 380, 78);
INSERT INTO public.who_global_data VALUES (90013, 0, 0, 0, 0, 380, 233);
INSERT INTO public.who_global_data VALUES (90014, 0, 0, 0, 0, 380, 133);
INSERT INTO public.who_global_data VALUES (90015, 0, 0, 0, 0, 380, 35);
INSERT INTO public.who_global_data VALUES (90016, 0, 0, 0, 0, 380, 114);
INSERT INTO public.who_global_data VALUES (90017, 5, 5, 0, 0, 380, 237);
INSERT INTO public.who_global_data VALUES (90018, 0, 0, 0, 0, 380, 55);
INSERT INTO public.who_global_data VALUES (90019, 0, 0, 0, 0, 380, 176);
INSERT INTO public.who_global_data VALUES (90020, 0, 0, 0, 0, 380, 202);
INSERT INTO public.who_global_data VALUES (90021, 0, 0, 0, 0, 380, 155);
INSERT INTO public.who_global_data VALUES (90022, 0, 0, 0, 0, 380, 32);
INSERT INTO public.who_global_data VALUES (90023, 0, 0, 0, 0, 380, 220);
INSERT INTO public.who_global_data VALUES (90024, 0, 0, 0, 0, 380, 30);
INSERT INTO public.who_global_data VALUES (90025, 0, 0, 0, 0, 380, 147);
INSERT INTO public.who_global_data VALUES (90026, 0, 0, 0, 0, 380, 208);
INSERT INTO public.who_global_data VALUES (90027, 0, 0, 0, 0, 380, 45);
INSERT INTO public.who_global_data VALUES (90028, 0, 0, 0, 0, 380, 110);
INSERT INTO public.who_global_data VALUES (90029, 0, 0, 0, 0, 380, 88);
INSERT INTO public.who_global_data VALUES (90030, 0, 0, 0, 0, 380, 51);
INSERT INTO public.who_global_data VALUES (90031, 0, 0, 0, 0, 380, 209);
INSERT INTO public.who_global_data VALUES (90032, 0, 0, 0, 0, 380, 205);
INSERT INTO public.who_global_data VALUES (90033, 0, 0, 0, 0, 380, 18);
INSERT INTO public.who_global_data VALUES (90034, 0, 8, 0, 0, 380, 72);
INSERT INTO public.who_global_data VALUES (90035, 0, 0, 0, 0, 380, 44);
INSERT INTO public.who_global_data VALUES (90036, 0, 0, 0, 0, 380, 15);
INSERT INTO public.who_global_data VALUES (90037, 0, 0, 0, 0, 380, 25);
INSERT INTO public.who_global_data VALUES (90038, 0, 0, 0, 0, 380, 179);
INSERT INTO public.who_global_data VALUES (90039, 0, 0, 0, 0, 380, 34);
INSERT INTO public.who_global_data VALUES (90040, 0, 0, 0, 0, 380, 207);
INSERT INTO public.who_global_data VALUES (90041, 0, 0, 0, 0, 380, 166);
INSERT INTO public.who_global_data VALUES (90042, 0, 0, 0, 0, 380, 126);
INSERT INTO public.who_global_data VALUES (90043, 0, 0, 0, 0, 380, 97);
INSERT INTO public.who_global_data VALUES (90044, 0, 0, 0, 0, 380, 36);
INSERT INTO public.who_global_data VALUES (90045, 0, 0, 0, 0, 380, 125);
INSERT INTO public.who_global_data VALUES (90046, 0, 0, 0, 0, 380, 124);
INSERT INTO public.who_global_data VALUES (90047, 0, 0, 0, 0, 380, 185);
INSERT INTO public.who_global_data VALUES (90048, 0, 0, 0, 0, 380, 194);
INSERT INTO public.who_global_data VALUES (90049, 0, 0, 0, 0, 380, 144);
INSERT INTO public.who_global_data VALUES (90050, 0, 5, 0, 0, 380, 19);
INSERT INTO public.who_global_data VALUES (90051, 0, 0, 0, 0, 380, 217);
INSERT INTO public.who_global_data VALUES (90052, 0, 0, 0, 0, 380, 148);
INSERT INTO public.who_global_data VALUES (90053, 0, 0, 0, 0, 380, 86);
INSERT INTO public.who_global_data VALUES (90054, 0, 0, 0, 0, 380, 13);
INSERT INTO public.who_global_data VALUES (90055, 0, 0, 0, 0, 380, 157);
INSERT INTO public.who_global_data VALUES (90056, 0, 0, 0, 0, 380, 8);
INSERT INTO public.who_global_data VALUES (90057, 0, 0, 0, 0, 380, 73);
INSERT INTO public.who_global_data VALUES (90058, 0, 0, 0, 0, 380, 101);
INSERT INTO public.who_global_data VALUES (90059, 0, 0, 0, 0, 380, 165);
INSERT INTO public.who_global_data VALUES (90060, 0, 0, 0, 0, 380, 14);
INSERT INTO public.who_global_data VALUES (90061, 0, 0, 0, 0, 381, 193);
INSERT INTO public.who_global_data VALUES (90062, 0, 0, 0, 0, 381, 113);
INSERT INTO public.who_global_data VALUES (90063, 0, 0, 0, 0, 381, 143);
INSERT INTO public.who_global_data VALUES (90064, 0, 0, 0, 0, 381, 219);
INSERT INTO public.who_global_data VALUES (90065, 0, 0, 0, 0, 381, 186);
INSERT INTO public.who_global_data VALUES (90066, 0, 0, 0, 0, 381, 52);
INSERT INTO public.who_global_data VALUES (90067, 0, 0, 0, 0, 381, 180);
INSERT INTO public.who_global_data VALUES (90068, 0, 0, 0, 0, 381, 167);
INSERT INTO public.who_global_data VALUES (90069, 0, 0, 0, 0, 381, 154);
INSERT INTO public.who_global_data VALUES (90070, 0, 0, 0, 0, 381, 94);
INSERT INTO public.who_global_data VALUES (90071, 0, 0, 0, 0, 381, 66);
INSERT INTO public.who_global_data VALUES (90072, 0, 0, 0, 0, 381, 58);
INSERT INTO public.who_global_data VALUES (90073, 0, 0, 0, 0, 381, 163);
INSERT INTO public.who_global_data VALUES (90074, 0, 0, 0, 0, 381, 37);
INSERT INTO public.who_global_data VALUES (90075, 0, 0, 0, 0, 381, 142);
INSERT INTO public.who_global_data VALUES (90076, 0, 0, 0, 0, 381, 83);
INSERT INTO public.who_global_data VALUES (90077, 0, 0, 0, 0, 381, 228);
INSERT INTO public.who_global_data VALUES (90078, 0, 0, 0, 0, 381, 188);
INSERT INTO public.who_global_data VALUES (90079, 0, 0, 0, 0, 381, 62);
INSERT INTO public.who_global_data VALUES (90080, 0, 0, 0, 0, 381, 160);
INSERT INTO public.who_global_data VALUES (90081, 0, 0, 0, 0, 381, 50);
INSERT INTO public.who_global_data VALUES (90082, 0, 0, 0, 0, 381, 33);
INSERT INTO public.who_global_data VALUES (90083, 0, 0, 0, 0, 381, 183);
INSERT INTO public.who_global_data VALUES (90084, 0, 0, 0, 0, 381, 92);
INSERT INTO public.who_global_data VALUES (90085, 0, 0, 0, 0, 381, 158);
INSERT INTO public.who_global_data VALUES (90086, 0, 0, 0, 0, 381, 67);
INSERT INTO public.who_global_data VALUES (90087, 0, 0, 0, 0, 381, 57);
INSERT INTO public.who_global_data VALUES (90088, 0, 0, 0, 0, 381, 38);
INSERT INTO public.who_global_data VALUES (90089, 0, 0, 0, 0, 381, 141);
INSERT INTO public.who_global_data VALUES (90090, 0, 0, 0, 0, 381, 178);
INSERT INTO public.who_global_data VALUES (90091, 0, 0, 0, 0, 381, 108);
INSERT INTO public.who_global_data VALUES (90092, 0, 0, 0, 0, 381, 39);
INSERT INTO public.who_global_data VALUES (90093, 0, 0, 0, 0, 381, 2);
INSERT INTO public.who_global_data VALUES (90094, 0, 0, 0, 0, 381, 195);
INSERT INTO public.who_global_data VALUES (90095, 0, 0, 0, 0, 381, 107);
INSERT INTO public.who_global_data VALUES (90096, 0, 0, 0, 0, 381, 161);
INSERT INTO public.who_global_data VALUES (90097, 0, 0, 0, 0, 381, 212);
INSERT INTO public.who_global_data VALUES (90098, 0, 0, 0, 0, 381, 181);
INSERT INTO public.who_global_data VALUES (90099, 0, 0, 0, 0, 381, 53);
INSERT INTO public.who_global_data VALUES (90100, 0, 0, 0, 0, 381, 164);
INSERT INTO public.who_global_data VALUES (90101, 0, 0, 0, 0, 381, 140);
INSERT INTO public.who_global_data VALUES (90102, 0, 0, 0, 0, 381, 20);
INSERT INTO public.who_global_data VALUES (90103, 152, 447, 3, 9, 381, 112);
INSERT INTO public.who_global_data VALUES (90104, 0, 0, 0, 0, 381, 111);
INSERT INTO public.who_global_data VALUES (90105, 0, 0, 0, 0, 381, 71);
INSERT INTO public.who_global_data VALUES (90106, 0, 0, 0, 0, 381, 218);
INSERT INTO public.who_global_data VALUES (90107, 0, 0, 0, 0, 381, 43);
INSERT INTO public.who_global_data VALUES (90108, 0, 0, 0, 0, 381, 49);
INSERT INTO public.who_global_data VALUES (90109, 0, 0, 0, 0, 381, 1);
INSERT INTO public.who_global_data VALUES (90110, 0, 0, 0, 0, 381, 48);
INSERT INTO public.who_global_data VALUES (90111, 0, 0, 0, 0, 381, 232);
INSERT INTO public.who_global_data VALUES (90112, 0, 0, 0, 0, 381, 175);
INSERT INTO public.who_global_data VALUES (90113, 0, 0, 0, 0, 381, 21);
INSERT INTO public.who_global_data VALUES (90114, 0, 0, 0, 0, 381, 156);
INSERT INTO public.who_global_data VALUES (90115, 0, 0, 0, 0, 381, 95);
INSERT INTO public.who_global_data VALUES (90116, 0, 0, 0, 0, 381, 177);
INSERT INTO public.who_global_data VALUES (90117, 0, 0, 0, 0, 381, 210);
INSERT INTO public.who_global_data VALUES (90118, 0, 0, 0, 0, 381, 120);
INSERT INTO public.who_global_data VALUES (90119, 0, 0, 0, 0, 381, 135);
INSERT INTO public.who_global_data VALUES (90120, 0, 0, 0, 0, 381, 206);
INSERT INTO public.who_global_data VALUES (90121, 0, 0, 0, 0, 381, 189);
INSERT INTO public.who_global_data VALUES (90122, 0, 0, 0, 0, 381, 129);
INSERT INTO public.who_global_data VALUES (90123, 0, 0, 0, 0, 381, 121);
INSERT INTO public.who_global_data VALUES (90124, 0, 0, 0, 0, 381, 59);
INSERT INTO public.who_global_data VALUES (90125, 0, 0, 0, 0, 381, 96);
INSERT INTO public.who_global_data VALUES (90126, 0, 0, 0, 0, 381, 41);
INSERT INTO public.who_global_data VALUES (90127, 0, 0, 0, 0, 381, 216);
INSERT INTO public.who_global_data VALUES (90128, 0, 0, 0, 0, 381, 236);
INSERT INTO public.who_global_data VALUES (90129, 0, 0, 0, 0, 381, 150);
INSERT INTO public.who_global_data VALUES (90130, 0, 0, 0, 0, 381, 61);
INSERT INTO public.who_global_data VALUES (90131, 0, 0, 0, 0, 381, 7);
INSERT INTO public.who_global_data VALUES (90132, 0, 0, 0, 0, 381, 169);
INSERT INTO public.who_global_data VALUES (90133, 0, 0, 0, 0, 381, 28);
INSERT INTO public.who_global_data VALUES (90134, 0, 0, 0, 0, 381, 85);
INSERT INTO public.who_global_data VALUES (90135, 0, 0, 0, 0, 381, 211);
INSERT INTO public.who_global_data VALUES (90136, 0, 0, 0, 0, 381, 60);
INSERT INTO public.who_global_data VALUES (90137, 0, 0, 0, 0, 381, 3);
INSERT INTO public.who_global_data VALUES (90138, 0, 0, 0, 0, 381, 11);
INSERT INTO public.who_global_data VALUES (90139, 0, 0, 0, 0, 381, 89);
INSERT INTO public.who_global_data VALUES (90140, 0, 0, 0, 0, 381, 24);
INSERT INTO public.who_global_data VALUES (90141, 0, 0, 0, 0, 381, 162);
INSERT INTO public.who_global_data VALUES (90142, 0, 0, 0, 0, 381, 100);
INSERT INTO public.who_global_data VALUES (90143, 0, 0, 0, 0, 381, 47);
INSERT INTO public.who_global_data VALUES (90144, 0, 0, 0, 0, 381, 29);
INSERT INTO public.who_global_data VALUES (90145, 0, 0, 0, 0, 381, 40);
INSERT INTO public.who_global_data VALUES (90146, 0, 0, 0, 0, 381, 222);
INSERT INTO public.who_global_data VALUES (90147, 0, 0, 0, 0, 381, 132);
INSERT INTO public.who_global_data VALUES (90148, 0, 0, 0, 0, 381, 130);
INSERT INTO public.who_global_data VALUES (90149, 0, 0, 0, 0, 381, 234);
INSERT INTO public.who_global_data VALUES (90150, 0, 0, 0, 0, 381, 23);
INSERT INTO public.who_global_data VALUES (90151, 0, 0, 0, 0, 381, 192);
INSERT INTO public.who_global_data VALUES (90152, 0, 0, 0, 0, 381, 69);
INSERT INTO public.who_global_data VALUES (90153, 0, 0, 0, 0, 381, 187);
INSERT INTO public.who_global_data VALUES (90154, 0, 0, 0, 0, 381, 230);
INSERT INTO public.who_global_data VALUES (90155, 0, 0, 0, 0, 381, 77);
INSERT INTO public.who_global_data VALUES (90156, 0, 0, 0, 0, 381, 9);
INSERT INTO public.who_global_data VALUES (90157, 0, 0, 0, 0, 381, 74);
INSERT INTO public.who_global_data VALUES (90158, 0, 0, 0, 0, 381, 224);
INSERT INTO public.who_global_data VALUES (90159, 0, 0, 0, 0, 381, 199);
INSERT INTO public.who_global_data VALUES (90160, 0, 0, 0, 0, 381, 190);
INSERT INTO public.who_global_data VALUES (90161, 0, 0, 0, 0, 381, 12);
INSERT INTO public.who_global_data VALUES (90162, 0, 0, 0, 0, 381, 104);
INSERT INTO public.who_global_data VALUES (90163, 0, 0, 0, 0, 381, 153);
INSERT INTO public.who_global_data VALUES (90164, 0, 0, 0, 0, 381, 91);
INSERT INTO public.who_global_data VALUES (90165, 0, 0, 0, 0, 381, 215);
INSERT INTO public.who_global_data VALUES (90166, 0, 1, 0, 0, 381, 84);
INSERT INTO public.who_global_data VALUES (90167, 0, 0, 0, 0, 381, 231);
INSERT INTO public.who_global_data VALUES (90168, 0, 0, 0, 0, 381, 196);
INSERT INTO public.who_global_data VALUES (90169, 0, 0, 0, 0, 381, 105);
INSERT INTO public.who_global_data VALUES (90170, 0, 0, 0, 0, 381, 122);
INSERT INTO public.who_global_data VALUES (90171, 0, 0, 0, 0, 381, 159);
INSERT INTO public.who_global_data VALUES (90172, 0, 0, 0, 0, 381, 75);
INSERT INTO public.who_global_data VALUES (90173, 0, 0, 0, 0, 381, 27);
INSERT INTO public.who_global_data VALUES (90174, 0, 0, 0, 0, 381, 54);
INSERT INTO public.who_global_data VALUES (90175, 0, 0, 0, 0, 381, 226);
INSERT INTO public.who_global_data VALUES (90176, 0, 0, 0, 0, 381, 79);
INSERT INTO public.who_global_data VALUES (90177, 0, 0, 0, 0, 381, 56);
INSERT INTO public.who_global_data VALUES (90178, 0, 0, 0, 0, 381, 117);
INSERT INTO public.who_global_data VALUES (90179, 0, 0, 0, 0, 381, 152);
INSERT INTO public.who_global_data VALUES (90180, 0, 0, 0, 0, 381, 16);
INSERT INTO public.who_global_data VALUES (90181, 0, 0, 0, 0, 381, 10);
INSERT INTO public.who_global_data VALUES (90182, 0, 0, 0, 0, 381, 201);
INSERT INTO public.who_global_data VALUES (90183, 0, 0, 0, 0, 381, 174);
INSERT INTO public.who_global_data VALUES (90184, 0, 0, 0, 0, 381, 119);
INSERT INTO public.who_global_data VALUES (90185, 0, 0, 0, 0, 381, 168);
INSERT INTO public.who_global_data VALUES (90186, 0, 0, 0, 0, 381, 99);
INSERT INTO public.who_global_data VALUES (90187, 0, 0, 0, 0, 381, 171);
INSERT INTO public.who_global_data VALUES (90188, 0, 0, 0, 0, 381, 87);
INSERT INTO public.who_global_data VALUES (90189, 0, 0, 0, 0, 381, 123);
INSERT INTO public.who_global_data VALUES (90190, 0, 0, 0, 0, 381, 151);
INSERT INTO public.who_global_data VALUES (90191, 0, 0, 0, 0, 381, 213);
INSERT INTO public.who_global_data VALUES (90192, 0, 0, 0, 0, 381, 118);
INSERT INTO public.who_global_data VALUES (90193, 0, 0, 0, 0, 381, 134);
INSERT INTO public.who_global_data VALUES (90194, 0, 0, 0, 0, 381, 65);
INSERT INTO public.who_global_data VALUES (90195, 0, 0, 0, 0, 381, 102);
INSERT INTO public.who_global_data VALUES (90196, 0, 0, 0, 0, 381, 223);
INSERT INTO public.who_global_data VALUES (90197, 0, 0, 0, 0, 381, 4);
INSERT INTO public.who_global_data VALUES (90198, 0, 0, 0, 0, 381, 146);
INSERT INTO public.who_global_data VALUES (90199, 0, 0, 0, 0, 381, 31);
INSERT INTO public.who_global_data VALUES (90200, 0, 0, 0, 0, 381, 127);
INSERT INTO public.who_global_data VALUES (90201, 0, 0, 0, 0, 381, 22);
INSERT INTO public.who_global_data VALUES (90202, 0, 0, 0, 0, 381, 115);
INSERT INTO public.who_global_data VALUES (90203, 0, 0, 0, 0, 381, 106);
INSERT INTO public.who_global_data VALUES (90204, 0, 0, 0, 0, 381, 90);
INSERT INTO public.who_global_data VALUES (90205, 0, 0, 0, 0, 381, 70);
INSERT INTO public.who_global_data VALUES (90206, 0, 0, 0, 0, 381, 46);
INSERT INTO public.who_global_data VALUES (90207, 0, 0, 0, 0, 381, 139);
INSERT INTO public.who_global_data VALUES (90208, 0, 0, 0, 0, 381, 42);
INSERT INTO public.who_global_data VALUES (90209, 0, 0, 0, 0, 381, 80);
INSERT INTO public.who_global_data VALUES (90210, 0, 0, 0, 0, 381, 203);
INSERT INTO public.who_global_data VALUES (90211, 0, 0, 0, 0, 381, 136);
INSERT INTO public.who_global_data VALUES (90212, 0, 0, 0, 0, 381, 63);
INSERT INTO public.who_global_data VALUES (90213, 0, 0, 0, 0, 381, 17);
INSERT INTO public.who_global_data VALUES (90214, 0, 0, 0, 0, 381, 172);
INSERT INTO public.who_global_data VALUES (90215, 0, 0, 0, 0, 381, 109);
INSERT INTO public.who_global_data VALUES (90216, 0, 0, 0, 0, 381, 200);
INSERT INTO public.who_global_data VALUES (90217, 0, 0, 0, 0, 381, 93);
INSERT INTO public.who_global_data VALUES (90218, 0, 0, 0, 0, 381, 5);
INSERT INTO public.who_global_data VALUES (90219, 0, 0, 0, 0, 381, 214);
INSERT INTO public.who_global_data VALUES (90220, 0, 0, 0, 0, 381, 204);
INSERT INTO public.who_global_data VALUES (90221, 0, 0, 0, 0, 381, 198);
INSERT INTO public.who_global_data VALUES (90222, 0, 0, 0, 0, 381, 173);
INSERT INTO public.who_global_data VALUES (90223, 0, 0, 0, 0, 381, 229);
INSERT INTO public.who_global_data VALUES (90224, 0, 0, 0, 0, 381, 76);
INSERT INTO public.who_global_data VALUES (90225, 0, 0, 0, 0, 381, 138);
INSERT INTO public.who_global_data VALUES (90226, 0, 0, 0, 0, 381, 98);
INSERT INTO public.who_global_data VALUES (90227, 0, 0, 0, 0, 381, 103);
INSERT INTO public.who_global_data VALUES (90228, 0, 0, 0, 0, 381, 225);
INSERT INTO public.who_global_data VALUES (90229, 0, 0, 0, 0, 381, 131);
INSERT INTO public.who_global_data VALUES (90230, 0, 0, 0, 0, 381, 235);
INSERT INTO public.who_global_data VALUES (90231, 0, 0, 0, 0, 381, 137);
INSERT INTO public.who_global_data VALUES (90232, 0, 5, 0, 0, 381, 81);
INSERT INTO public.who_global_data VALUES (90233, 0, 0, 0, 0, 381, 182);
INSERT INTO public.who_global_data VALUES (90234, 0, 0, 0, 0, 381, 145);
INSERT INTO public.who_global_data VALUES (90235, 0, 0, 0, 0, 381, 26);
INSERT INTO public.who_global_data VALUES (90236, 0, 0, 0, 0, 381, 170);
INSERT INTO public.who_global_data VALUES (90237, 0, 0, 0, 0, 381, 191);
INSERT INTO public.who_global_data VALUES (90238, 0, 0, 0, 0, 381, 221);
INSERT INTO public.who_global_data VALUES (90239, 0, 0, 0, 0, 381, 64);
INSERT INTO public.who_global_data VALUES (90240, 0, 0, 0, 0, 381, 116);
INSERT INTO public.who_global_data VALUES (90241, 0, 0, 0, 0, 381, 128);
INSERT INTO public.who_global_data VALUES (90242, 0, 0, 0, 0, 381, 6);
INSERT INTO public.who_global_data VALUES (90243, 0, 0, 0, 0, 381, 227);
INSERT INTO public.who_global_data VALUES (90244, 0, 0, 0, 0, 381, 68);
INSERT INTO public.who_global_data VALUES (90245, 0, 0, 0, 0, 381, 184);
INSERT INTO public.who_global_data VALUES (90246, 0, 0, 0, 0, 381, 82);
INSERT INTO public.who_global_data VALUES (90247, 0, 0, 0, 0, 381, 149);
INSERT INTO public.who_global_data VALUES (90248, 0, 0, 0, 0, 381, 197);
INSERT INTO public.who_global_data VALUES (90249, 0, 0, 0, 0, 381, 78);
INSERT INTO public.who_global_data VALUES (90250, 0, 0, 0, 0, 381, 233);
INSERT INTO public.who_global_data VALUES (90251, 0, 0, 0, 0, 381, 133);
INSERT INTO public.who_global_data VALUES (90252, 0, 0, 0, 0, 381, 35);
INSERT INTO public.who_global_data VALUES (90253, 0, 0, 0, 0, 381, 114);
INSERT INTO public.who_global_data VALUES (90254, 0, 0, 0, 0, 381, 237);
INSERT INTO public.who_global_data VALUES (90255, 0, 0, 0, 0, 381, 55);
INSERT INTO public.who_global_data VALUES (90256, 0, 0, 0, 0, 381, 176);
INSERT INTO public.who_global_data VALUES (90257, 0, 0, 0, 0, 381, 202);
INSERT INTO public.who_global_data VALUES (90258, 0, 0, 0, 0, 381, 155);
INSERT INTO public.who_global_data VALUES (90259, 0, 0, 0, 0, 381, 32);
INSERT INTO public.who_global_data VALUES (90260, 0, 0, 0, 0, 381, 220);
INSERT INTO public.who_global_data VALUES (90261, 0, 0, 0, 0, 381, 30);
INSERT INTO public.who_global_data VALUES (90262, 0, 0, 0, 0, 381, 147);
INSERT INTO public.who_global_data VALUES (90263, 0, 0, 0, 0, 381, 208);
INSERT INTO public.who_global_data VALUES (90264, 0, 0, 0, 0, 381, 45);
INSERT INTO public.who_global_data VALUES (90265, 0, 0, 0, 0, 381, 110);
INSERT INTO public.who_global_data VALUES (90266, 0, 0, 0, 0, 381, 88);
INSERT INTO public.who_global_data VALUES (90267, 0, 0, 0, 0, 381, 51);
INSERT INTO public.who_global_data VALUES (90268, 0, 0, 0, 0, 381, 209);
INSERT INTO public.who_global_data VALUES (90269, 0, 0, 0, 0, 381, 205);
INSERT INTO public.who_global_data VALUES (90270, 0, 0, 0, 0, 381, 18);
INSERT INTO public.who_global_data VALUES (90271, 2, 8, 0, 0, 381, 72);
INSERT INTO public.who_global_data VALUES (90272, 0, 0, 0, 0, 381, 44);
INSERT INTO public.who_global_data VALUES (90273, 0, 0, 0, 0, 381, 15);
INSERT INTO public.who_global_data VALUES (90274, 0, 0, 0, 0, 381, 25);
INSERT INTO public.who_global_data VALUES (90275, 0, 0, 0, 0, 381, 179);
INSERT INTO public.who_global_data VALUES (90276, 0, 0, 0, 0, 381, 34);
INSERT INTO public.who_global_data VALUES (90277, 0, 0, 0, 0, 381, 207);
INSERT INTO public.who_global_data VALUES (90278, 0, 0, 0, 0, 381, 166);
INSERT INTO public.who_global_data VALUES (90279, 0, 0, 0, 0, 381, 126);
INSERT INTO public.who_global_data VALUES (90280, 0, 0, 0, 0, 381, 97);
INSERT INTO public.who_global_data VALUES (90281, 0, 0, 0, 0, 381, 36);
INSERT INTO public.who_global_data VALUES (90282, 0, 0, 0, 0, 381, 125);
INSERT INTO public.who_global_data VALUES (90283, 0, 0, 0, 0, 381, 124);
INSERT INTO public.who_global_data VALUES (90284, 0, 0, 0, 0, 381, 185);
INSERT INTO public.who_global_data VALUES (90285, 0, 0, 0, 0, 381, 194);
INSERT INTO public.who_global_data VALUES (90286, 0, 0, 0, 0, 381, 144);
INSERT INTO public.who_global_data VALUES (90287, 0, 5, 0, 0, 381, 19);
INSERT INTO public.who_global_data VALUES (90288, 0, 0, 0, 0, 381, 217);
INSERT INTO public.who_global_data VALUES (90289, 0, 0, 0, 0, 381, 148);
INSERT INTO public.who_global_data VALUES (90290, 0, 0, 0, 0, 381, 86);
INSERT INTO public.who_global_data VALUES (90291, 0, 0, 0, 0, 381, 13);
INSERT INTO public.who_global_data VALUES (90292, 0, 0, 0, 0, 381, 157);
INSERT INTO public.who_global_data VALUES (90293, 0, 0, 0, 0, 381, 8);
INSERT INTO public.who_global_data VALUES (90294, 0, 0, 0, 0, 381, 73);
INSERT INTO public.who_global_data VALUES (90295, 0, 0, 0, 0, 381, 101);
INSERT INTO public.who_global_data VALUES (90296, 0, 0, 0, 0, 381, 165);
INSERT INTO public.who_global_data VALUES (90297, 0, 0, 0, 0, 381, 14);
INSERT INTO public.who_global_data VALUES (90298, 0, 0, 0, 0, 382, 193);
INSERT INTO public.who_global_data VALUES (90299, 0, 0, 0, 0, 382, 113);
INSERT INTO public.who_global_data VALUES (90300, 0, 0, 0, 0, 382, 143);
INSERT INTO public.who_global_data VALUES (90301, 0, 0, 0, 0, 382, 219);
INSERT INTO public.who_global_data VALUES (90302, 0, 0, 0, 0, 382, 186);
INSERT INTO public.who_global_data VALUES (90303, 0, 0, 0, 0, 382, 52);
INSERT INTO public.who_global_data VALUES (90304, 0, 0, 0, 0, 382, 180);
INSERT INTO public.who_global_data VALUES (90305, 0, 0, 0, 0, 382, 167);
INSERT INTO public.who_global_data VALUES (90306, 0, 0, 0, 0, 382, 154);
INSERT INTO public.who_global_data VALUES (90307, 0, 0, 0, 0, 382, 94);
INSERT INTO public.who_global_data VALUES (90308, 0, 0, 0, 0, 382, 66);
INSERT INTO public.who_global_data VALUES (90309, 0, 0, 0, 0, 382, 58);
INSERT INTO public.who_global_data VALUES (90310, 0, 0, 0, 0, 382, 163);
INSERT INTO public.who_global_data VALUES (90311, 0, 0, 0, 0, 382, 37);
INSERT INTO public.who_global_data VALUES (90312, 0, 0, 0, 0, 382, 142);
INSERT INTO public.who_global_data VALUES (90313, 0, 0, 0, 0, 382, 83);
INSERT INTO public.who_global_data VALUES (90314, 0, 0, 0, 0, 382, 228);
INSERT INTO public.who_global_data VALUES (90315, 0, 0, 0, 0, 382, 188);
INSERT INTO public.who_global_data VALUES (90316, 0, 0, 0, 0, 382, 62);
INSERT INTO public.who_global_data VALUES (90317, 0, 0, 0, 0, 382, 160);
INSERT INTO public.who_global_data VALUES (90318, 0, 0, 0, 0, 382, 50);
INSERT INTO public.who_global_data VALUES (90319, 0, 0, 0, 0, 382, 33);
INSERT INTO public.who_global_data VALUES (90320, 0, 0, 0, 0, 382, 183);
INSERT INTO public.who_global_data VALUES (90321, 0, 0, 0, 0, 382, 92);
INSERT INTO public.who_global_data VALUES (90322, 0, 0, 0, 0, 382, 158);
INSERT INTO public.who_global_data VALUES (90323, 0, 0, 0, 0, 382, 67);
INSERT INTO public.who_global_data VALUES (90324, 0, 0, 0, 0, 382, 57);
INSERT INTO public.who_global_data VALUES (90325, 0, 0, 0, 0, 382, 38);
INSERT INTO public.who_global_data VALUES (90326, 0, 0, 0, 0, 382, 141);
INSERT INTO public.who_global_data VALUES (90327, 0, 0, 0, 0, 382, 178);
INSERT INTO public.who_global_data VALUES (90328, 0, 0, 0, 0, 382, 108);
INSERT INTO public.who_global_data VALUES (90329, 0, 0, 0, 0, 382, 39);
INSERT INTO public.who_global_data VALUES (90330, 0, 0, 0, 0, 382, 2);
INSERT INTO public.who_global_data VALUES (90331, 0, 0, 0, 0, 382, 195);
INSERT INTO public.who_global_data VALUES (90332, 0, 0, 0, 0, 382, 107);
INSERT INTO public.who_global_data VALUES (90333, 0, 0, 0, 0, 382, 161);
INSERT INTO public.who_global_data VALUES (90334, 0, 0, 0, 0, 382, 212);
INSERT INTO public.who_global_data VALUES (90335, 0, 0, 0, 0, 382, 181);
INSERT INTO public.who_global_data VALUES (90336, 0, 0, 0, 0, 382, 53);
INSERT INTO public.who_global_data VALUES (90337, 0, 0, 0, 0, 382, 164);
INSERT INTO public.who_global_data VALUES (90338, 0, 0, 0, 0, 382, 140);
INSERT INTO public.who_global_data VALUES (90339, 0, 0, 0, 0, 382, 20);
INSERT INTO public.who_global_data VALUES (90340, 93, 295, 2, 6, 382, 112);
INSERT INTO public.who_global_data VALUES (90341, 0, 0, 0, 0, 382, 111);
INSERT INTO public.who_global_data VALUES (90342, 0, 0, 0, 0, 382, 71);
INSERT INTO public.who_global_data VALUES (90343, 0, 0, 0, 0, 382, 218);
INSERT INTO public.who_global_data VALUES (90344, 0, 0, 0, 0, 382, 43);
INSERT INTO public.who_global_data VALUES (90345, 0, 0, 0, 0, 382, 49);
INSERT INTO public.who_global_data VALUES (90346, 0, 0, 0, 0, 382, 1);
INSERT INTO public.who_global_data VALUES (90347, 0, 0, 0, 0, 382, 48);
INSERT INTO public.who_global_data VALUES (90348, 0, 0, 0, 0, 382, 232);
INSERT INTO public.who_global_data VALUES (90349, 0, 0, 0, 0, 382, 175);
INSERT INTO public.who_global_data VALUES (90350, 0, 0, 0, 0, 382, 21);
INSERT INTO public.who_global_data VALUES (90351, 0, 0, 0, 0, 382, 156);
INSERT INTO public.who_global_data VALUES (90352, 0, 0, 0, 0, 382, 95);
INSERT INTO public.who_global_data VALUES (90353, 0, 0, 0, 0, 382, 177);
INSERT INTO public.who_global_data VALUES (90354, 0, 0, 0, 0, 382, 210);
INSERT INTO public.who_global_data VALUES (90355, 0, 0, 0, 0, 382, 120);
INSERT INTO public.who_global_data VALUES (90356, 0, 0, 0, 0, 382, 135);
INSERT INTO public.who_global_data VALUES (90357, 0, 0, 0, 0, 382, 206);
INSERT INTO public.who_global_data VALUES (90358, 0, 0, 0, 0, 382, 189);
INSERT INTO public.who_global_data VALUES (90359, 0, 0, 0, 0, 382, 129);
INSERT INTO public.who_global_data VALUES (90360, 0, 0, 0, 0, 382, 121);
INSERT INTO public.who_global_data VALUES (90361, 0, 0, 0, 0, 382, 59);
INSERT INTO public.who_global_data VALUES (90362, 0, 0, 0, 0, 382, 96);
INSERT INTO public.who_global_data VALUES (90363, 0, 0, 0, 0, 382, 41);
INSERT INTO public.who_global_data VALUES (90364, 0, 0, 0, 0, 382, 216);
INSERT INTO public.who_global_data VALUES (90365, 0, 0, 0, 0, 382, 236);
INSERT INTO public.who_global_data VALUES (90366, 0, 0, 0, 0, 382, 150);
INSERT INTO public.who_global_data VALUES (90367, 0, 0, 0, 0, 382, 61);
INSERT INTO public.who_global_data VALUES (90368, 0, 0, 0, 0, 382, 7);
INSERT INTO public.who_global_data VALUES (90369, 0, 0, 0, 0, 382, 169);
INSERT INTO public.who_global_data VALUES (90370, 0, 0, 0, 0, 382, 28);
INSERT INTO public.who_global_data VALUES (90371, 0, 0, 0, 0, 382, 85);
INSERT INTO public.who_global_data VALUES (90372, 0, 0, 0, 0, 382, 211);
INSERT INTO public.who_global_data VALUES (90373, 0, 0, 0, 0, 382, 60);
INSERT INTO public.who_global_data VALUES (90374, 0, 0, 0, 0, 382, 3);
INSERT INTO public.who_global_data VALUES (90375, 0, 0, 0, 0, 382, 11);
INSERT INTO public.who_global_data VALUES (90376, 0, 0, 0, 0, 382, 89);
INSERT INTO public.who_global_data VALUES (90377, 0, 0, 0, 0, 382, 24);
INSERT INTO public.who_global_data VALUES (90378, 0, 0, 0, 0, 382, 162);
INSERT INTO public.who_global_data VALUES (90379, 0, 0, 0, 0, 382, 100);
INSERT INTO public.who_global_data VALUES (90380, 0, 0, 0, 0, 382, 47);
INSERT INTO public.who_global_data VALUES (90381, 0, 0, 0, 0, 382, 29);
INSERT INTO public.who_global_data VALUES (90382, 0, 0, 0, 0, 382, 40);
INSERT INTO public.who_global_data VALUES (90383, 0, 0, 0, 0, 382, 222);
INSERT INTO public.who_global_data VALUES (90384, 0, 0, 0, 0, 382, 132);
INSERT INTO public.who_global_data VALUES (90385, 0, 0, 0, 0, 382, 130);
INSERT INTO public.who_global_data VALUES (90386, 0, 0, 0, 0, 382, 234);
INSERT INTO public.who_global_data VALUES (90387, 0, 0, 0, 0, 382, 23);
INSERT INTO public.who_global_data VALUES (90388, 0, 0, 0, 0, 382, 192);
INSERT INTO public.who_global_data VALUES (90389, 0, 0, 0, 0, 382, 69);
INSERT INTO public.who_global_data VALUES (90390, 0, 0, 0, 0, 382, 187);
INSERT INTO public.who_global_data VALUES (90391, 0, 0, 0, 0, 382, 230);
INSERT INTO public.who_global_data VALUES (90392, 0, 0, 0, 0, 382, 77);
INSERT INTO public.who_global_data VALUES (90393, 0, 0, 0, 0, 382, 9);
INSERT INTO public.who_global_data VALUES (90394, 0, 0, 0, 0, 382, 74);
INSERT INTO public.who_global_data VALUES (90395, 0, 0, 0, 0, 382, 224);
INSERT INTO public.who_global_data VALUES (90396, 0, 0, 0, 0, 382, 199);
INSERT INTO public.who_global_data VALUES (90397, 0, 0, 0, 0, 382, 190);
INSERT INTO public.who_global_data VALUES (90398, 0, 0, 0, 0, 382, 12);
INSERT INTO public.who_global_data VALUES (90399, 0, 0, 0, 0, 382, 104);
INSERT INTO public.who_global_data VALUES (90400, 0, 0, 0, 0, 382, 153);
INSERT INTO public.who_global_data VALUES (90401, 0, 0, 0, 0, 382, 91);
INSERT INTO public.who_global_data VALUES (90402, 0, 0, 0, 0, 382, 215);
INSERT INTO public.who_global_data VALUES (90403, 0, 1, 0, 0, 382, 84);
INSERT INTO public.who_global_data VALUES (90404, 0, 0, 0, 0, 382, 231);
INSERT INTO public.who_global_data VALUES (90405, 0, 0, 0, 0, 382, 196);
INSERT INTO public.who_global_data VALUES (90406, 0, 0, 0, 0, 382, 105);
INSERT INTO public.who_global_data VALUES (90407, 0, 0, 0, 0, 382, 122);
INSERT INTO public.who_global_data VALUES (90408, 0, 0, 0, 0, 382, 159);
INSERT INTO public.who_global_data VALUES (90409, 0, 0, 0, 0, 382, 75);
INSERT INTO public.who_global_data VALUES (90410, 0, 0, 0, 0, 382, 27);
INSERT INTO public.who_global_data VALUES (90411, 0, 0, 0, 0, 382, 54);
INSERT INTO public.who_global_data VALUES (90412, 0, 0, 0, 0, 382, 226);
INSERT INTO public.who_global_data VALUES (90413, 0, 0, 0, 0, 382, 79);
INSERT INTO public.who_global_data VALUES (90414, 0, 0, 0, 0, 382, 56);
INSERT INTO public.who_global_data VALUES (90415, 0, 0, 0, 0, 382, 117);
INSERT INTO public.who_global_data VALUES (90416, 0, 0, 0, 0, 382, 152);
INSERT INTO public.who_global_data VALUES (90417, 0, 0, 0, 0, 382, 16);
INSERT INTO public.who_global_data VALUES (90418, 0, 0, 0, 0, 382, 10);
INSERT INTO public.who_global_data VALUES (90419, 0, 0, 0, 0, 382, 201);
INSERT INTO public.who_global_data VALUES (90420, 0, 0, 0, 0, 382, 174);
INSERT INTO public.who_global_data VALUES (90421, 0, 0, 0, 0, 382, 119);
INSERT INTO public.who_global_data VALUES (90422, 0, 0, 0, 0, 382, 168);
INSERT INTO public.who_global_data VALUES (90423, 0, 0, 0, 0, 382, 99);
INSERT INTO public.who_global_data VALUES (90424, 0, 0, 0, 0, 382, 171);
INSERT INTO public.who_global_data VALUES (90425, 0, 0, 0, 0, 382, 87);
INSERT INTO public.who_global_data VALUES (90426, 0, 0, 0, 0, 382, 123);
INSERT INTO public.who_global_data VALUES (90427, 0, 0, 0, 0, 382, 151);
INSERT INTO public.who_global_data VALUES (90428, 0, 0, 0, 0, 382, 213);
INSERT INTO public.who_global_data VALUES (90429, 0, 0, 0, 0, 382, 118);
INSERT INTO public.who_global_data VALUES (90430, 0, 0, 0, 0, 382, 134);
INSERT INTO public.who_global_data VALUES (90431, 0, 0, 0, 0, 382, 65);
INSERT INTO public.who_global_data VALUES (90432, 0, 0, 0, 0, 382, 102);
INSERT INTO public.who_global_data VALUES (90433, 0, 0, 0, 0, 382, 223);
INSERT INTO public.who_global_data VALUES (90434, 0, 0, 0, 0, 382, 4);
INSERT INTO public.who_global_data VALUES (90435, 0, 0, 0, 0, 382, 146);
INSERT INTO public.who_global_data VALUES (90436, 0, 0, 0, 0, 382, 31);
INSERT INTO public.who_global_data VALUES (90437, 0, 0, 0, 0, 382, 127);
INSERT INTO public.who_global_data VALUES (90438, 0, 0, 0, 0, 382, 22);
INSERT INTO public.who_global_data VALUES (90439, 0, 0, 0, 0, 382, 115);
INSERT INTO public.who_global_data VALUES (90440, 0, 0, 0, 0, 382, 106);
INSERT INTO public.who_global_data VALUES (90441, 0, 0, 0, 0, 382, 90);
INSERT INTO public.who_global_data VALUES (90442, 0, 0, 0, 0, 382, 70);
INSERT INTO public.who_global_data VALUES (90443, 0, 0, 0, 0, 382, 46);
INSERT INTO public.who_global_data VALUES (90444, 0, 0, 0, 0, 382, 139);
INSERT INTO public.who_global_data VALUES (90445, 0, 0, 0, 0, 382, 42);
INSERT INTO public.who_global_data VALUES (90446, 0, 0, 0, 0, 382, 80);
INSERT INTO public.who_global_data VALUES (90447, 0, 0, 0, 0, 382, 203);
INSERT INTO public.who_global_data VALUES (90448, 0, 0, 0, 0, 382, 136);
INSERT INTO public.who_global_data VALUES (90449, 0, 0, 0, 0, 382, 63);
INSERT INTO public.who_global_data VALUES (90450, 0, 0, 0, 0, 382, 17);
INSERT INTO public.who_global_data VALUES (90451, 0, 0, 0, 0, 382, 172);
INSERT INTO public.who_global_data VALUES (90452, 0, 0, 0, 0, 382, 109);
INSERT INTO public.who_global_data VALUES (90453, 0, 0, 0, 0, 382, 200);
INSERT INTO public.who_global_data VALUES (90454, 0, 0, 0, 0, 382, 93);
INSERT INTO public.who_global_data VALUES (90455, 0, 0, 0, 0, 382, 5);
INSERT INTO public.who_global_data VALUES (90456, 0, 0, 0, 0, 382, 214);
INSERT INTO public.who_global_data VALUES (90457, 0, 0, 0, 0, 382, 204);
INSERT INTO public.who_global_data VALUES (90458, 0, 0, 0, 0, 382, 198);
INSERT INTO public.who_global_data VALUES (90459, 0, 0, 0, 0, 382, 173);
INSERT INTO public.who_global_data VALUES (90460, 0, 0, 0, 0, 382, 229);
INSERT INTO public.who_global_data VALUES (90461, 0, 0, 0, 0, 382, 76);
INSERT INTO public.who_global_data VALUES (90462, 0, 0, 0, 0, 382, 138);
INSERT INTO public.who_global_data VALUES (90463, 0, 0, 0, 0, 382, 98);
INSERT INTO public.who_global_data VALUES (90464, 0, 0, 0, 0, 382, 103);
INSERT INTO public.who_global_data VALUES (90465, 0, 0, 0, 0, 382, 225);
INSERT INTO public.who_global_data VALUES (90466, 0, 0, 0, 0, 382, 131);
INSERT INTO public.who_global_data VALUES (90467, 0, 0, 0, 0, 382, 235);
INSERT INTO public.who_global_data VALUES (90468, 0, 0, 0, 0, 382, 137);
INSERT INTO public.who_global_data VALUES (90469, 0, 5, 0, 0, 382, 81);
INSERT INTO public.who_global_data VALUES (90470, 0, 0, 0, 0, 382, 182);
INSERT INTO public.who_global_data VALUES (90471, 0, 0, 0, 0, 382, 145);
INSERT INTO public.who_global_data VALUES (90472, 0, 0, 0, 0, 382, 26);
INSERT INTO public.who_global_data VALUES (90473, 0, 0, 0, 0, 382, 170);
INSERT INTO public.who_global_data VALUES (90474, 0, 0, 0, 0, 382, 191);
INSERT INTO public.who_global_data VALUES (90475, 0, 0, 0, 0, 382, 221);
INSERT INTO public.who_global_data VALUES (90476, 0, 0, 0, 0, 382, 64);
INSERT INTO public.who_global_data VALUES (90477, 0, 0, 0, 0, 382, 116);
INSERT INTO public.who_global_data VALUES (90478, 0, 0, 0, 0, 382, 128);
INSERT INTO public.who_global_data VALUES (90479, 0, 0, 0, 0, 382, 6);
INSERT INTO public.who_global_data VALUES (90480, 0, 0, 0, 0, 382, 227);
INSERT INTO public.who_global_data VALUES (90481, 0, 0, 0, 0, 382, 68);
INSERT INTO public.who_global_data VALUES (90482, 0, 0, 0, 0, 382, 184);
INSERT INTO public.who_global_data VALUES (90483, 0, 0, 0, 0, 382, 82);
INSERT INTO public.who_global_data VALUES (90484, 0, 0, 0, 0, 382, 149);
INSERT INTO public.who_global_data VALUES (90485, 0, 0, 0, 0, 382, 197);
INSERT INTO public.who_global_data VALUES (90486, 0, 0, 0, 0, 382, 78);
INSERT INTO public.who_global_data VALUES (90487, 0, 0, 0, 0, 382, 233);
INSERT INTO public.who_global_data VALUES (90488, 0, 0, 0, 0, 382, 133);
INSERT INTO public.who_global_data VALUES (90489, 0, 0, 0, 0, 382, 35);
INSERT INTO public.who_global_data VALUES (90490, 0, 0, 0, 0, 382, 114);
INSERT INTO public.who_global_data VALUES (90491, 0, 0, 0, 0, 382, 237);
INSERT INTO public.who_global_data VALUES (90492, 0, 0, 0, 0, 382, 55);
INSERT INTO public.who_global_data VALUES (90493, 0, 0, 0, 0, 382, 176);
INSERT INTO public.who_global_data VALUES (90494, 0, 0, 0, 0, 382, 202);
INSERT INTO public.who_global_data VALUES (90495, 0, 0, 0, 0, 382, 155);
INSERT INTO public.who_global_data VALUES (90496, 0, 0, 0, 0, 382, 32);
INSERT INTO public.who_global_data VALUES (90497, 0, 0, 0, 0, 382, 220);
INSERT INTO public.who_global_data VALUES (90498, 0, 0, 0, 0, 382, 30);
INSERT INTO public.who_global_data VALUES (90499, 0, 0, 0, 0, 382, 147);
INSERT INTO public.who_global_data VALUES (90500, 0, 0, 0, 0, 382, 208);
INSERT INTO public.who_global_data VALUES (90501, 0, 0, 0, 0, 382, 45);
INSERT INTO public.who_global_data VALUES (90502, 0, 0, 0, 0, 382, 110);
INSERT INTO public.who_global_data VALUES (90503, 0, 0, 0, 0, 382, 88);
INSERT INTO public.who_global_data VALUES (90504, 0, 0, 0, 0, 382, 51);
INSERT INTO public.who_global_data VALUES (90505, 0, 0, 0, 0, 382, 209);
INSERT INTO public.who_global_data VALUES (90506, 0, 0, 0, 0, 382, 205);
INSERT INTO public.who_global_data VALUES (90507, 0, 0, 0, 0, 382, 18);
INSERT INTO public.who_global_data VALUES (90508, 0, 6, 0, 0, 382, 72);
INSERT INTO public.who_global_data VALUES (90509, 0, 0, 0, 0, 382, 44);
INSERT INTO public.who_global_data VALUES (90510, 0, 0, 0, 0, 382, 15);
INSERT INTO public.who_global_data VALUES (90511, 0, 0, 0, 0, 382, 25);
INSERT INTO public.who_global_data VALUES (90512, 0, 0, 0, 0, 382, 179);
INSERT INTO public.who_global_data VALUES (90513, 0, 0, 0, 0, 382, 34);
INSERT INTO public.who_global_data VALUES (90514, 0, 0, 0, 0, 382, 207);
INSERT INTO public.who_global_data VALUES (90515, 0, 0, 0, 0, 382, 166);
INSERT INTO public.who_global_data VALUES (90516, 0, 0, 0, 0, 382, 126);
INSERT INTO public.who_global_data VALUES (90517, 0, 0, 0, 0, 382, 97);
INSERT INTO public.who_global_data VALUES (90518, 0, 0, 0, 0, 382, 36);
INSERT INTO public.who_global_data VALUES (90519, 0, 0, 0, 0, 382, 125);
INSERT INTO public.who_global_data VALUES (90520, 0, 0, 0, 0, 382, 124);
INSERT INTO public.who_global_data VALUES (90521, 0, 0, 0, 0, 382, 185);
INSERT INTO public.who_global_data VALUES (90522, 0, 0, 0, 0, 382, 194);
INSERT INTO public.who_global_data VALUES (90523, 0, 0, 0, 0, 382, 144);
INSERT INTO public.who_global_data VALUES (90524, 0, 5, 0, 0, 382, 19);
INSERT INTO public.who_global_data VALUES (90525, 0, 0, 0, 0, 382, 217);
INSERT INTO public.who_global_data VALUES (90526, 0, 0, 0, 0, 382, 148);
INSERT INTO public.who_global_data VALUES (90527, 0, 0, 0, 0, 382, 86);
INSERT INTO public.who_global_data VALUES (90528, 0, 0, 0, 0, 382, 13);
INSERT INTO public.who_global_data VALUES (90529, 0, 0, 0, 0, 382, 157);
INSERT INTO public.who_global_data VALUES (90530, 0, 0, 0, 0, 382, 8);
INSERT INTO public.who_global_data VALUES (90531, 0, 0, 0, 0, 382, 73);
INSERT INTO public.who_global_data VALUES (90532, 0, 0, 0, 0, 382, 101);
INSERT INTO public.who_global_data VALUES (90533, 0, 0, 0, 0, 382, 165);
INSERT INTO public.who_global_data VALUES (90534, 0, 0, 0, 0, 382, 14);
INSERT INTO public.who_global_data VALUES (90535, 0, 0, 0, 0, 383, 193);
INSERT INTO public.who_global_data VALUES (90536, 0, 0, 0, 0, 383, 113);
INSERT INTO public.who_global_data VALUES (90537, 0, 0, 0, 0, 383, 143);
INSERT INTO public.who_global_data VALUES (90538, 0, 0, 0, 0, 383, 219);
INSERT INTO public.who_global_data VALUES (90539, 0, 0, 0, 0, 383, 186);
INSERT INTO public.who_global_data VALUES (90540, 0, 0, 0, 0, 383, 52);
INSERT INTO public.who_global_data VALUES (90541, 0, 0, 0, 0, 383, 180);
INSERT INTO public.who_global_data VALUES (90542, 0, 0, 0, 0, 383, 167);
INSERT INTO public.who_global_data VALUES (90543, 0, 0, 0, 0, 383, 154);
INSERT INTO public.who_global_data VALUES (90544, 0, 0, 0, 0, 383, 94);
INSERT INTO public.who_global_data VALUES (90545, 0, 0, 0, 0, 383, 66);
INSERT INTO public.who_global_data VALUES (90546, 0, 0, 0, 0, 383, 58);
INSERT INTO public.who_global_data VALUES (90547, 0, 0, 0, 0, 383, 163);
INSERT INTO public.who_global_data VALUES (90548, 0, 0, 0, 0, 383, 37);
INSERT INTO public.who_global_data VALUES (90549, 0, 0, 0, 0, 383, 142);
INSERT INTO public.who_global_data VALUES (90550, 0, 0, 0, 0, 383, 83);
INSERT INTO public.who_global_data VALUES (90551, 0, 0, 0, 0, 383, 228);
INSERT INTO public.who_global_data VALUES (90552, 0, 0, 0, 0, 383, 188);
INSERT INTO public.who_global_data VALUES (90553, 0, 0, 0, 0, 383, 62);
INSERT INTO public.who_global_data VALUES (90554, 0, 0, 0, 0, 383, 160);
INSERT INTO public.who_global_data VALUES (90555, 0, 0, 0, 0, 383, 50);
INSERT INTO public.who_global_data VALUES (90556, 0, 0, 0, 0, 383, 33);
INSERT INTO public.who_global_data VALUES (90557, 0, 0, 0, 0, 383, 183);
INSERT INTO public.who_global_data VALUES (90558, 0, 0, 0, 0, 383, 92);
INSERT INTO public.who_global_data VALUES (90559, 0, 0, 0, 0, 383, 158);
INSERT INTO public.who_global_data VALUES (90560, 0, 0, 0, 0, 383, 67);
INSERT INTO public.who_global_data VALUES (90561, 0, 0, 0, 0, 383, 57);
INSERT INTO public.who_global_data VALUES (90562, 0, 0, 0, 0, 383, 38);
INSERT INTO public.who_global_data VALUES (90563, 0, 0, 0, 0, 383, 141);
INSERT INTO public.who_global_data VALUES (90564, 0, 0, 0, 0, 383, 178);
INSERT INTO public.who_global_data VALUES (90565, 0, 0, 0, 0, 383, 108);
INSERT INTO public.who_global_data VALUES (90566, 0, 0, 0, 0, 383, 39);
INSERT INTO public.who_global_data VALUES (90567, 0, 0, 0, 0, 383, 2);
INSERT INTO public.who_global_data VALUES (90568, 0, 0, 0, 0, 383, 195);
INSERT INTO public.who_global_data VALUES (90569, 0, 0, 0, 0, 383, 107);
INSERT INTO public.who_global_data VALUES (90570, 0, 0, 0, 0, 383, 161);
INSERT INTO public.who_global_data VALUES (90571, 0, 0, 0, 0, 383, 212);
INSERT INTO public.who_global_data VALUES (90572, 0, 0, 0, 0, 383, 181);
INSERT INTO public.who_global_data VALUES (90573, 0, 0, 0, 0, 383, 53);
INSERT INTO public.who_global_data VALUES (90574, 0, 0, 0, 0, 383, 164);
INSERT INTO public.who_global_data VALUES (90575, 0, 0, 0, 0, 383, 140);
INSERT INTO public.who_global_data VALUES (90576, 0, 0, 0, 0, 383, 20);
INSERT INTO public.who_global_data VALUES (90577, 77, 202, 1, 4, 383, 112);
INSERT INTO public.who_global_data VALUES (90578, 0, 0, 0, 0, 383, 111);
INSERT INTO public.who_global_data VALUES (90579, 0, 0, 0, 0, 383, 71);
INSERT INTO public.who_global_data VALUES (90580, 0, 0, 0, 0, 383, 218);
INSERT INTO public.who_global_data VALUES (90581, 0, 0, 0, 0, 383, 43);
INSERT INTO public.who_global_data VALUES (90582, 0, 0, 0, 0, 383, 49);
INSERT INTO public.who_global_data VALUES (90583, 0, 0, 0, 0, 383, 1);
INSERT INTO public.who_global_data VALUES (90584, 0, 0, 0, 0, 383, 48);
INSERT INTO public.who_global_data VALUES (90585, 0, 0, 0, 0, 383, 232);
INSERT INTO public.who_global_data VALUES (90586, 0, 0, 0, 0, 383, 175);
INSERT INTO public.who_global_data VALUES (90587, 0, 0, 0, 0, 383, 21);
INSERT INTO public.who_global_data VALUES (90588, 0, 0, 0, 0, 383, 156);
INSERT INTO public.who_global_data VALUES (90589, 0, 0, 0, 0, 383, 95);
INSERT INTO public.who_global_data VALUES (90590, 0, 0, 0, 0, 383, 177);
INSERT INTO public.who_global_data VALUES (90591, 0, 0, 0, 0, 383, 210);
INSERT INTO public.who_global_data VALUES (90592, 0, 0, 0, 0, 383, 120);
INSERT INTO public.who_global_data VALUES (90593, 0, 0, 0, 0, 383, 135);
INSERT INTO public.who_global_data VALUES (90594, 0, 0, 0, 0, 383, 206);
INSERT INTO public.who_global_data VALUES (90595, 0, 0, 0, 0, 383, 189);
INSERT INTO public.who_global_data VALUES (90596, 0, 0, 0, 0, 383, 129);
INSERT INTO public.who_global_data VALUES (90597, 0, 0, 0, 0, 383, 121);
INSERT INTO public.who_global_data VALUES (90598, 0, 0, 0, 0, 383, 59);
INSERT INTO public.who_global_data VALUES (90599, 0, 0, 0, 0, 383, 96);
INSERT INTO public.who_global_data VALUES (90600, 0, 0, 0, 0, 383, 41);
INSERT INTO public.who_global_data VALUES (90601, 0, 0, 0, 0, 383, 216);
INSERT INTO public.who_global_data VALUES (90602, 0, 0, 0, 0, 383, 236);
INSERT INTO public.who_global_data VALUES (90603, 0, 0, 0, 0, 383, 150);
INSERT INTO public.who_global_data VALUES (90604, 0, 0, 0, 0, 383, 61);
INSERT INTO public.who_global_data VALUES (90605, 0, 0, 0, 0, 383, 7);
INSERT INTO public.who_global_data VALUES (90606, 0, 0, 0, 0, 383, 169);
INSERT INTO public.who_global_data VALUES (90607, 0, 0, 0, 0, 383, 28);
INSERT INTO public.who_global_data VALUES (90608, 0, 0, 0, 0, 383, 85);
INSERT INTO public.who_global_data VALUES (90609, 0, 0, 0, 0, 383, 211);
INSERT INTO public.who_global_data VALUES (90610, 0, 0, 0, 0, 383, 60);
INSERT INTO public.who_global_data VALUES (90611, 0, 0, 0, 0, 383, 3);
INSERT INTO public.who_global_data VALUES (90612, 0, 0, 0, 0, 383, 11);
INSERT INTO public.who_global_data VALUES (90613, 0, 0, 0, 0, 383, 89);
INSERT INTO public.who_global_data VALUES (90614, 0, 0, 0, 0, 383, 24);
INSERT INTO public.who_global_data VALUES (90615, 0, 0, 0, 0, 383, 162);
INSERT INTO public.who_global_data VALUES (90616, 0, 0, 0, 0, 383, 100);
INSERT INTO public.who_global_data VALUES (90617, 0, 0, 0, 0, 383, 47);
INSERT INTO public.who_global_data VALUES (90618, 0, 0, 0, 0, 383, 29);
INSERT INTO public.who_global_data VALUES (90619, 0, 0, 0, 0, 383, 40);
INSERT INTO public.who_global_data VALUES (90620, 0, 0, 0, 0, 383, 222);
INSERT INTO public.who_global_data VALUES (90621, 0, 0, 0, 0, 383, 132);
INSERT INTO public.who_global_data VALUES (90622, 0, 0, 0, 0, 383, 130);
INSERT INTO public.who_global_data VALUES (90623, 0, 0, 0, 0, 383, 234);
INSERT INTO public.who_global_data VALUES (90624, 0, 0, 0, 0, 383, 23);
INSERT INTO public.who_global_data VALUES (90625, 0, 0, 0, 0, 383, 192);
INSERT INTO public.who_global_data VALUES (90626, 0, 0, 0, 0, 383, 69);
INSERT INTO public.who_global_data VALUES (90627, 0, 0, 0, 0, 383, 187);
INSERT INTO public.who_global_data VALUES (90628, 0, 0, 0, 0, 383, 230);
INSERT INTO public.who_global_data VALUES (90629, 0, 0, 0, 0, 383, 77);
INSERT INTO public.who_global_data VALUES (90630, 0, 0, 0, 0, 383, 9);
INSERT INTO public.who_global_data VALUES (90631, 0, 0, 0, 0, 383, 74);
INSERT INTO public.who_global_data VALUES (90632, 0, 0, 0, 0, 383, 224);
INSERT INTO public.who_global_data VALUES (90633, 0, 0, 0, 0, 383, 199);
INSERT INTO public.who_global_data VALUES (90634, 0, 0, 0, 0, 383, 190);
INSERT INTO public.who_global_data VALUES (90635, 0, 0, 0, 0, 383, 12);
INSERT INTO public.who_global_data VALUES (90636, 0, 0, 0, 0, 383, 104);
INSERT INTO public.who_global_data VALUES (90637, 0, 0, 0, 0, 383, 153);
INSERT INTO public.who_global_data VALUES (90638, 0, 0, 0, 0, 383, 91);
INSERT INTO public.who_global_data VALUES (90639, 0, 0, 0, 0, 383, 215);
INSERT INTO public.who_global_data VALUES (90640, 0, 1, 0, 0, 383, 84);
INSERT INTO public.who_global_data VALUES (90641, 0, 0, 0, 0, 383, 231);
INSERT INTO public.who_global_data VALUES (90642, 0, 0, 0, 0, 383, 196);
INSERT INTO public.who_global_data VALUES (90643, 0, 0, 0, 0, 383, 105);
INSERT INTO public.who_global_data VALUES (90644, 0, 0, 0, 0, 383, 122);
INSERT INTO public.who_global_data VALUES (90645, 0, 0, 0, 0, 383, 159);
INSERT INTO public.who_global_data VALUES (90646, 0, 0, 0, 0, 383, 75);
INSERT INTO public.who_global_data VALUES (90647, 0, 0, 0, 0, 383, 27);
INSERT INTO public.who_global_data VALUES (90648, 0, 0, 0, 0, 383, 54);
INSERT INTO public.who_global_data VALUES (90649, 0, 0, 0, 0, 383, 226);
INSERT INTO public.who_global_data VALUES (90650, 0, 0, 0, 0, 383, 79);
INSERT INTO public.who_global_data VALUES (90651, 0, 0, 0, 0, 383, 56);
INSERT INTO public.who_global_data VALUES (90652, 0, 0, 0, 0, 383, 117);
INSERT INTO public.who_global_data VALUES (90653, 0, 0, 0, 0, 383, 152);
INSERT INTO public.who_global_data VALUES (90654, 0, 0, 0, 0, 383, 16);
INSERT INTO public.who_global_data VALUES (90655, 0, 0, 0, 0, 383, 10);
INSERT INTO public.who_global_data VALUES (90656, 0, 0, 0, 0, 383, 201);
INSERT INTO public.who_global_data VALUES (90657, 0, 0, 0, 0, 383, 174);
INSERT INTO public.who_global_data VALUES (90658, 0, 0, 0, 0, 383, 119);
INSERT INTO public.who_global_data VALUES (90659, 0, 0, 0, 0, 383, 168);
INSERT INTO public.who_global_data VALUES (90660, 0, 0, 0, 0, 383, 99);
INSERT INTO public.who_global_data VALUES (90661, 0, 0, 0, 0, 383, 171);
INSERT INTO public.who_global_data VALUES (90662, 0, 0, 0, 0, 383, 87);
INSERT INTO public.who_global_data VALUES (90663, 0, 0, 0, 0, 383, 123);
INSERT INTO public.who_global_data VALUES (90664, 0, 0, 0, 0, 383, 151);
INSERT INTO public.who_global_data VALUES (90665, 0, 0, 0, 0, 383, 213);
INSERT INTO public.who_global_data VALUES (90666, 0, 0, 0, 0, 383, 118);
INSERT INTO public.who_global_data VALUES (90667, 0, 0, 0, 0, 383, 134);
INSERT INTO public.who_global_data VALUES (90668, 0, 0, 0, 0, 383, 65);
INSERT INTO public.who_global_data VALUES (90669, 0, 0, 0, 0, 383, 102);
INSERT INTO public.who_global_data VALUES (90670, 0, 0, 0, 0, 383, 223);
INSERT INTO public.who_global_data VALUES (90671, 0, 0, 0, 0, 383, 4);
INSERT INTO public.who_global_data VALUES (90672, 0, 0, 0, 0, 383, 146);
INSERT INTO public.who_global_data VALUES (90673, 0, 0, 0, 0, 383, 31);
INSERT INTO public.who_global_data VALUES (90674, 0, 0, 0, 0, 383, 127);
INSERT INTO public.who_global_data VALUES (90675, 0, 0, 0, 0, 383, 22);
INSERT INTO public.who_global_data VALUES (90676, 0, 0, 0, 0, 383, 115);
INSERT INTO public.who_global_data VALUES (90677, 0, 0, 0, 0, 383, 106);
INSERT INTO public.who_global_data VALUES (90678, 0, 0, 0, 0, 383, 90);
INSERT INTO public.who_global_data VALUES (90679, 0, 0, 0, 0, 383, 70);
INSERT INTO public.who_global_data VALUES (90680, 0, 0, 0, 0, 383, 46);
INSERT INTO public.who_global_data VALUES (90681, 0, 0, 0, 0, 383, 139);
INSERT INTO public.who_global_data VALUES (90682, 0, 0, 0, 0, 383, 42);
INSERT INTO public.who_global_data VALUES (90683, 0, 0, 0, 0, 383, 80);
INSERT INTO public.who_global_data VALUES (90684, 0, 0, 0, 0, 383, 203);
INSERT INTO public.who_global_data VALUES (90685, 0, 0, 0, 0, 383, 136);
INSERT INTO public.who_global_data VALUES (90686, 0, 0, 0, 0, 383, 63);
INSERT INTO public.who_global_data VALUES (90687, 0, 0, 0, 0, 383, 17);
INSERT INTO public.who_global_data VALUES (90688, 0, 0, 0, 0, 383, 172);
INSERT INTO public.who_global_data VALUES (90689, 0, 0, 0, 0, 383, 109);
INSERT INTO public.who_global_data VALUES (90690, 0, 0, 0, 0, 383, 200);
INSERT INTO public.who_global_data VALUES (90691, 0, 0, 0, 0, 383, 93);
INSERT INTO public.who_global_data VALUES (90692, 0, 0, 0, 0, 383, 5);
INSERT INTO public.who_global_data VALUES (90693, 0, 0, 0, 0, 383, 214);
INSERT INTO public.who_global_data VALUES (90694, 0, 0, 0, 0, 383, 204);
INSERT INTO public.who_global_data VALUES (90695, 0, 0, 0, 0, 383, 198);
INSERT INTO public.who_global_data VALUES (90696, 0, 0, 0, 0, 383, 173);
INSERT INTO public.who_global_data VALUES (90697, 0, 0, 0, 0, 383, 229);
INSERT INTO public.who_global_data VALUES (90698, 0, 0, 0, 0, 383, 76);
INSERT INTO public.who_global_data VALUES (90699, 0, 0, 0, 0, 383, 138);
INSERT INTO public.who_global_data VALUES (90700, 0, 0, 0, 0, 383, 98);
INSERT INTO public.who_global_data VALUES (90701, 0, 0, 0, 0, 383, 103);
INSERT INTO public.who_global_data VALUES (90702, 0, 0, 0, 0, 383, 225);
INSERT INTO public.who_global_data VALUES (90703, 0, 0, 0, 0, 383, 131);
INSERT INTO public.who_global_data VALUES (90704, 0, 0, 0, 0, 383, 235);
INSERT INTO public.who_global_data VALUES (90705, 0, 0, 0, 0, 383, 137);
INSERT INTO public.who_global_data VALUES (90706, 0, 5, 0, 0, 383, 81);
INSERT INTO public.who_global_data VALUES (90707, 0, 0, 0, 0, 383, 182);
INSERT INTO public.who_global_data VALUES (90708, 0, 0, 0, 0, 383, 145);
INSERT INTO public.who_global_data VALUES (90709, 0, 0, 0, 0, 383, 26);
INSERT INTO public.who_global_data VALUES (90710, 0, 0, 0, 0, 383, 170);
INSERT INTO public.who_global_data VALUES (90711, 0, 0, 0, 0, 383, 191);
INSERT INTO public.who_global_data VALUES (90712, 0, 0, 0, 0, 383, 221);
INSERT INTO public.who_global_data VALUES (90713, 0, 0, 0, 0, 383, 64);
INSERT INTO public.who_global_data VALUES (90714, 0, 0, 0, 0, 383, 116);
INSERT INTO public.who_global_data VALUES (90715, 0, 0, 0, 0, 383, 128);
INSERT INTO public.who_global_data VALUES (90716, 0, 0, 0, 0, 383, 6);
INSERT INTO public.who_global_data VALUES (90717, 0, 0, 0, 0, 383, 227);
INSERT INTO public.who_global_data VALUES (90718, 0, 0, 0, 0, 383, 68);
INSERT INTO public.who_global_data VALUES (90719, 0, 0, 0, 0, 383, 184);
INSERT INTO public.who_global_data VALUES (90720, 0, 0, 0, 0, 383, 82);
INSERT INTO public.who_global_data VALUES (90721, 0, 0, 0, 0, 383, 149);
INSERT INTO public.who_global_data VALUES (90722, 0, 0, 0, 0, 383, 197);
INSERT INTO public.who_global_data VALUES (90723, 0, 0, 0, 0, 383, 78);
INSERT INTO public.who_global_data VALUES (90724, 0, 0, 0, 0, 383, 233);
INSERT INTO public.who_global_data VALUES (90725, 0, 0, 0, 0, 383, 133);
INSERT INTO public.who_global_data VALUES (90726, 0, 0, 0, 0, 383, 35);
INSERT INTO public.who_global_data VALUES (90727, 0, 0, 0, 0, 383, 114);
INSERT INTO public.who_global_data VALUES (90728, 0, 0, 0, 0, 383, 237);
INSERT INTO public.who_global_data VALUES (90729, 0, 0, 0, 0, 383, 55);
INSERT INTO public.who_global_data VALUES (90730, 0, 0, 0, 0, 383, 176);
INSERT INTO public.who_global_data VALUES (90731, 0, 0, 0, 0, 383, 202);
INSERT INTO public.who_global_data VALUES (90732, 0, 0, 0, 0, 383, 155);
INSERT INTO public.who_global_data VALUES (90733, 0, 0, 0, 0, 383, 32);
INSERT INTO public.who_global_data VALUES (90734, 0, 0, 0, 0, 383, 220);
INSERT INTO public.who_global_data VALUES (90735, 0, 0, 0, 0, 383, 30);
INSERT INTO public.who_global_data VALUES (90736, 0, 0, 0, 0, 383, 147);
INSERT INTO public.who_global_data VALUES (90737, 0, 0, 0, 0, 383, 208);
INSERT INTO public.who_global_data VALUES (90738, 0, 0, 0, 0, 383, 45);
INSERT INTO public.who_global_data VALUES (90739, 0, 0, 0, 0, 383, 110);
INSERT INTO public.who_global_data VALUES (90740, 0, 0, 0, 0, 383, 88);
INSERT INTO public.who_global_data VALUES (90741, 0, 0, 0, 0, 383, 51);
INSERT INTO public.who_global_data VALUES (90742, 0, 0, 0, 0, 383, 209);
INSERT INTO public.who_global_data VALUES (90743, 0, 0, 0, 0, 383, 205);
INSERT INTO public.who_global_data VALUES (90744, 0, 0, 0, 0, 383, 18);
INSERT INTO public.who_global_data VALUES (90745, 0, 6, 0, 0, 383, 72);
INSERT INTO public.who_global_data VALUES (90746, 0, 0, 0, 0, 383, 44);
INSERT INTO public.who_global_data VALUES (90747, 0, 0, 0, 0, 383, 15);
INSERT INTO public.who_global_data VALUES (90748, 0, 0, 0, 0, 383, 25);
INSERT INTO public.who_global_data VALUES (90749, 0, 0, 0, 0, 383, 179);
INSERT INTO public.who_global_data VALUES (90750, 0, 0, 0, 0, 383, 34);
INSERT INTO public.who_global_data VALUES (90751, 0, 0, 0, 0, 383, 207);
INSERT INTO public.who_global_data VALUES (90752, 0, 0, 0, 0, 383, 166);
INSERT INTO public.who_global_data VALUES (90753, 0, 0, 0, 0, 383, 126);
INSERT INTO public.who_global_data VALUES (90754, 0, 0, 0, 0, 383, 97);
INSERT INTO public.who_global_data VALUES (90755, 0, 0, 0, 0, 383, 36);
INSERT INTO public.who_global_data VALUES (90756, 0, 0, 0, 0, 383, 125);
INSERT INTO public.who_global_data VALUES (90757, 0, 0, 0, 0, 383, 124);
INSERT INTO public.who_global_data VALUES (90758, 0, 0, 0, 0, 383, 185);
INSERT INTO public.who_global_data VALUES (90759, 0, 0, 0, 0, 383, 194);
INSERT INTO public.who_global_data VALUES (90760, 0, 0, 0, 0, 383, 144);
INSERT INTO public.who_global_data VALUES (90761, 5, 5, 0, 0, 383, 19);
INSERT INTO public.who_global_data VALUES (90762, 0, 0, 0, 0, 383, 217);
INSERT INTO public.who_global_data VALUES (90763, 0, 0, 0, 0, 383, 148);
INSERT INTO public.who_global_data VALUES (90764, 0, 0, 0, 0, 383, 86);
INSERT INTO public.who_global_data VALUES (90765, 0, 0, 0, 0, 383, 13);
INSERT INTO public.who_global_data VALUES (90766, 0, 0, 0, 0, 383, 157);
INSERT INTO public.who_global_data VALUES (90767, 0, 0, 0, 0, 383, 8);
INSERT INTO public.who_global_data VALUES (90768, 0, 0, 0, 0, 383, 73);
INSERT INTO public.who_global_data VALUES (90769, 0, 0, 0, 0, 383, 101);
INSERT INTO public.who_global_data VALUES (90770, 0, 0, 0, 0, 383, 165);
INSERT INTO public.who_global_data VALUES (90771, 0, 0, 0, 0, 383, 14);
INSERT INTO public.who_global_data VALUES (90772, 0, 0, 0, 0, 384, 193);
INSERT INTO public.who_global_data VALUES (90773, 0, 0, 0, 0, 384, 113);
INSERT INTO public.who_global_data VALUES (90774, 0, 0, 0, 0, 384, 143);
INSERT INTO public.who_global_data VALUES (90775, 0, 0, 0, 0, 384, 219);
INSERT INTO public.who_global_data VALUES (90776, 0, 0, 0, 0, 384, 186);
INSERT INTO public.who_global_data VALUES (90777, 0, 0, 0, 0, 384, 52);
INSERT INTO public.who_global_data VALUES (90778, 0, 0, 0, 0, 384, 180);
INSERT INTO public.who_global_data VALUES (90779, 0, 0, 0, 0, 384, 167);
INSERT INTO public.who_global_data VALUES (90780, 0, 0, 0, 0, 384, 154);
INSERT INTO public.who_global_data VALUES (90781, 0, 0, 0, 0, 384, 94);
INSERT INTO public.who_global_data VALUES (90782, 0, 0, 0, 0, 384, 66);
INSERT INTO public.who_global_data VALUES (90783, 0, 0, 0, 0, 384, 58);
INSERT INTO public.who_global_data VALUES (90784, 0, 0, 0, 0, 384, 163);
INSERT INTO public.who_global_data VALUES (90785, 0, 0, 0, 0, 384, 37);
INSERT INTO public.who_global_data VALUES (90786, 0, 0, 0, 0, 384, 142);
INSERT INTO public.who_global_data VALUES (90787, 0, 0, 0, 0, 384, 83);
INSERT INTO public.who_global_data VALUES (90788, 0, 0, 0, 0, 384, 228);
INSERT INTO public.who_global_data VALUES (90789, 0, 0, 0, 0, 384, 188);
INSERT INTO public.who_global_data VALUES (90790, 0, 0, 0, 0, 384, 62);
INSERT INTO public.who_global_data VALUES (90791, 0, 0, 0, 0, 384, 160);
INSERT INTO public.who_global_data VALUES (90792, 0, 0, 0, 0, 384, 50);
INSERT INTO public.who_global_data VALUES (90793, 0, 0, 0, 0, 384, 33);
INSERT INTO public.who_global_data VALUES (90794, 0, 0, 0, 0, 384, 183);
INSERT INTO public.who_global_data VALUES (90795, 0, 0, 0, 0, 384, 92);
INSERT INTO public.who_global_data VALUES (90796, 0, 0, 0, 0, 384, 158);
INSERT INTO public.who_global_data VALUES (90797, 0, 0, 0, 0, 384, 67);
INSERT INTO public.who_global_data VALUES (90798, 0, 0, 0, 0, 384, 57);
INSERT INTO public.who_global_data VALUES (90799, 0, 0, 0, 0, 384, 38);
INSERT INTO public.who_global_data VALUES (90800, 0, 0, 0, 0, 384, 141);
INSERT INTO public.who_global_data VALUES (90801, 0, 0, 0, 0, 384, 178);
INSERT INTO public.who_global_data VALUES (90802, 0, 0, 0, 0, 384, 108);
INSERT INTO public.who_global_data VALUES (90803, 0, 0, 0, 0, 384, 39);
INSERT INTO public.who_global_data VALUES (90804, 0, 0, 0, 0, 384, 2);
INSERT INTO public.who_global_data VALUES (90805, 0, 0, 0, 0, 384, 195);
INSERT INTO public.who_global_data VALUES (90806, 0, 0, 0, 0, 384, 107);
INSERT INTO public.who_global_data VALUES (90807, 0, 0, 0, 0, 384, 161);
INSERT INTO public.who_global_data VALUES (90808, 0, 0, 0, 0, 384, 212);
INSERT INTO public.who_global_data VALUES (90809, 0, 0, 0, 0, 384, 181);
INSERT INTO public.who_global_data VALUES (90810, 0, 0, 0, 0, 384, 53);
INSERT INTO public.who_global_data VALUES (90811, 0, 0, 0, 0, 384, 164);
INSERT INTO public.who_global_data VALUES (90812, 0, 0, 0, 0, 384, 140);
INSERT INTO public.who_global_data VALUES (90813, 0, 0, 0, 0, 384, 20);
INSERT INTO public.who_global_data VALUES (90814, 59, 125, 1, 3, 384, 112);
INSERT INTO public.who_global_data VALUES (90815, 0, 0, 0, 0, 384, 111);
INSERT INTO public.who_global_data VALUES (90816, 0, 0, 0, 0, 384, 71);
INSERT INTO public.who_global_data VALUES (90817, 0, 0, 0, 0, 384, 218);
INSERT INTO public.who_global_data VALUES (90818, 0, 0, 0, 0, 384, 43);
INSERT INTO public.who_global_data VALUES (90819, 0, 0, 0, 0, 384, 49);
INSERT INTO public.who_global_data VALUES (90820, 0, 0, 0, 0, 384, 1);
INSERT INTO public.who_global_data VALUES (90821, 0, 0, 0, 0, 384, 48);
INSERT INTO public.who_global_data VALUES (90822, 0, 0, 0, 0, 384, 232);
INSERT INTO public.who_global_data VALUES (90823, 0, 0, 0, 0, 384, 175);
INSERT INTO public.who_global_data VALUES (90824, 0, 0, 0, 0, 384, 21);
INSERT INTO public.who_global_data VALUES (90825, 0, 0, 0, 0, 384, 156);
INSERT INTO public.who_global_data VALUES (90826, 0, 0, 0, 0, 384, 95);
INSERT INTO public.who_global_data VALUES (90827, 0, 0, 0, 0, 384, 177);
INSERT INTO public.who_global_data VALUES (90828, 0, 0, 0, 0, 384, 210);
INSERT INTO public.who_global_data VALUES (90829, 0, 0, 0, 0, 384, 120);
INSERT INTO public.who_global_data VALUES (90830, 0, 0, 0, 0, 384, 135);
INSERT INTO public.who_global_data VALUES (90831, 0, 0, 0, 0, 384, 206);
INSERT INTO public.who_global_data VALUES (90832, 0, 0, 0, 0, 384, 189);
INSERT INTO public.who_global_data VALUES (90833, 0, 0, 0, 0, 384, 129);
INSERT INTO public.who_global_data VALUES (90834, 0, 0, 0, 0, 384, 121);
INSERT INTO public.who_global_data VALUES (90835, 0, 0, 0, 0, 384, 59);
INSERT INTO public.who_global_data VALUES (90836, 0, 0, 0, 0, 384, 96);
INSERT INTO public.who_global_data VALUES (90837, 0, 0, 0, 0, 384, 41);
INSERT INTO public.who_global_data VALUES (90838, 0, 0, 0, 0, 384, 216);
INSERT INTO public.who_global_data VALUES (90839, 0, 0, 0, 0, 384, 236);
INSERT INTO public.who_global_data VALUES (90840, 0, 0, 0, 0, 384, 150);
INSERT INTO public.who_global_data VALUES (90841, 0, 0, 0, 0, 384, 61);
INSERT INTO public.who_global_data VALUES (90842, 0, 0, 0, 0, 384, 7);
INSERT INTO public.who_global_data VALUES (90843, 0, 0, 0, 0, 384, 169);
INSERT INTO public.who_global_data VALUES (90844, 0, 0, 0, 0, 384, 28);
INSERT INTO public.who_global_data VALUES (90845, 0, 0, 0, 0, 384, 85);
INSERT INTO public.who_global_data VALUES (90846, 0, 0, 0, 0, 384, 211);
INSERT INTO public.who_global_data VALUES (90847, 0, 0, 0, 0, 384, 60);
INSERT INTO public.who_global_data VALUES (90848, 0, 0, 0, 0, 384, 3);
INSERT INTO public.who_global_data VALUES (90849, 0, 0, 0, 0, 384, 11);
INSERT INTO public.who_global_data VALUES (90850, 0, 0, 0, 0, 384, 89);
INSERT INTO public.who_global_data VALUES (90851, 0, 0, 0, 0, 384, 24);
INSERT INTO public.who_global_data VALUES (90852, 0, 0, 0, 0, 384, 162);
INSERT INTO public.who_global_data VALUES (90853, 0, 0, 0, 0, 384, 100);
INSERT INTO public.who_global_data VALUES (90854, 0, 0, 0, 0, 384, 47);
INSERT INTO public.who_global_data VALUES (90855, 0, 0, 0, 0, 384, 29);
INSERT INTO public.who_global_data VALUES (90856, 0, 0, 0, 0, 384, 40);
INSERT INTO public.who_global_data VALUES (90857, 0, 0, 0, 0, 384, 222);
INSERT INTO public.who_global_data VALUES (90858, 0, 0, 0, 0, 384, 132);
INSERT INTO public.who_global_data VALUES (90859, 0, 0, 0, 0, 384, 130);
INSERT INTO public.who_global_data VALUES (90860, 0, 0, 0, 0, 384, 234);
INSERT INTO public.who_global_data VALUES (90861, 0, 0, 0, 0, 384, 23);
INSERT INTO public.who_global_data VALUES (90862, 0, 0, 0, 0, 384, 192);
INSERT INTO public.who_global_data VALUES (90863, 0, 0, 0, 0, 384, 69);
INSERT INTO public.who_global_data VALUES (90864, 0, 0, 0, 0, 384, 187);
INSERT INTO public.who_global_data VALUES (90865, 0, 0, 0, 0, 384, 230);
INSERT INTO public.who_global_data VALUES (90866, 0, 0, 0, 0, 384, 77);
INSERT INTO public.who_global_data VALUES (90867, 0, 0, 0, 0, 384, 9);
INSERT INTO public.who_global_data VALUES (90868, 0, 0, 0, 0, 384, 74);
INSERT INTO public.who_global_data VALUES (90869, 0, 0, 0, 0, 384, 224);
INSERT INTO public.who_global_data VALUES (90870, 0, 0, 0, 0, 384, 199);
INSERT INTO public.who_global_data VALUES (90871, 0, 0, 0, 0, 384, 190);
INSERT INTO public.who_global_data VALUES (90872, 0, 0, 0, 0, 384, 12);
INSERT INTO public.who_global_data VALUES (90873, 0, 0, 0, 0, 384, 104);
INSERT INTO public.who_global_data VALUES (90874, 0, 0, 0, 0, 384, 153);
INSERT INTO public.who_global_data VALUES (90875, 0, 0, 0, 0, 384, 91);
INSERT INTO public.who_global_data VALUES (90876, 0, 0, 0, 0, 384, 215);
INSERT INTO public.who_global_data VALUES (90877, 0, 1, 0, 0, 384, 84);
INSERT INTO public.who_global_data VALUES (90878, 0, 0, 0, 0, 384, 231);
INSERT INTO public.who_global_data VALUES (90879, 0, 0, 0, 0, 384, 196);
INSERT INTO public.who_global_data VALUES (90880, 0, 0, 0, 0, 384, 105);
INSERT INTO public.who_global_data VALUES (90881, 0, 0, 0, 0, 384, 122);
INSERT INTO public.who_global_data VALUES (90882, 0, 0, 0, 0, 384, 159);
INSERT INTO public.who_global_data VALUES (90883, 0, 0, 0, 0, 384, 75);
INSERT INTO public.who_global_data VALUES (90884, 0, 0, 0, 0, 384, 27);
INSERT INTO public.who_global_data VALUES (90885, 0, 0, 0, 0, 384, 54);
INSERT INTO public.who_global_data VALUES (90886, 0, 0, 0, 0, 384, 226);
INSERT INTO public.who_global_data VALUES (90887, 0, 0, 0, 0, 384, 79);
INSERT INTO public.who_global_data VALUES (90888, 0, 0, 0, 0, 384, 56);
INSERT INTO public.who_global_data VALUES (90889, 0, 0, 0, 0, 384, 117);
INSERT INTO public.who_global_data VALUES (90890, 0, 0, 0, 0, 384, 152);
INSERT INTO public.who_global_data VALUES (90891, 0, 0, 0, 0, 384, 16);
INSERT INTO public.who_global_data VALUES (90892, 0, 0, 0, 0, 384, 10);
INSERT INTO public.who_global_data VALUES (90893, 0, 0, 0, 0, 384, 201);
INSERT INTO public.who_global_data VALUES (90894, 0, 0, 0, 0, 384, 174);
INSERT INTO public.who_global_data VALUES (90895, 0, 0, 0, 0, 384, 119);
INSERT INTO public.who_global_data VALUES (90896, 0, 0, 0, 0, 384, 168);
INSERT INTO public.who_global_data VALUES (90897, 0, 0, 0, 0, 384, 99);
INSERT INTO public.who_global_data VALUES (90898, 0, 0, 0, 0, 384, 171);
INSERT INTO public.who_global_data VALUES (90899, 0, 0, 0, 0, 384, 87);
INSERT INTO public.who_global_data VALUES (90900, 0, 0, 0, 0, 384, 123);
INSERT INTO public.who_global_data VALUES (90901, 0, 0, 0, 0, 384, 151);
INSERT INTO public.who_global_data VALUES (90902, 0, 0, 0, 0, 384, 213);
INSERT INTO public.who_global_data VALUES (90903, 0, 0, 0, 0, 384, 118);
INSERT INTO public.who_global_data VALUES (90904, 0, 0, 0, 0, 384, 134);
INSERT INTO public.who_global_data VALUES (90905, 0, 0, 0, 0, 384, 65);
INSERT INTO public.who_global_data VALUES (90906, 0, 0, 0, 0, 384, 102);
INSERT INTO public.who_global_data VALUES (90907, 0, 0, 0, 0, 384, 223);
INSERT INTO public.who_global_data VALUES (90908, 0, 0, 0, 0, 384, 4);
INSERT INTO public.who_global_data VALUES (90909, 0, 0, 0, 0, 384, 146);
INSERT INTO public.who_global_data VALUES (90910, 0, 0, 0, 0, 384, 31);
INSERT INTO public.who_global_data VALUES (90911, 0, 0, 0, 0, 384, 127);
INSERT INTO public.who_global_data VALUES (90912, 0, 0, 0, 0, 384, 22);
INSERT INTO public.who_global_data VALUES (90913, 0, 0, 0, 0, 384, 115);
INSERT INTO public.who_global_data VALUES (90914, 0, 0, 0, 0, 384, 106);
INSERT INTO public.who_global_data VALUES (90915, 0, 0, 0, 0, 384, 90);
INSERT INTO public.who_global_data VALUES (90916, 0, 0, 0, 0, 384, 70);
INSERT INTO public.who_global_data VALUES (90917, 0, 0, 0, 0, 384, 46);
INSERT INTO public.who_global_data VALUES (90918, 0, 0, 0, 0, 384, 139);
INSERT INTO public.who_global_data VALUES (90919, 0, 0, 0, 0, 384, 42);
INSERT INTO public.who_global_data VALUES (90920, 0, 0, 0, 0, 384, 80);
INSERT INTO public.who_global_data VALUES (90921, 0, 0, 0, 0, 384, 203);
INSERT INTO public.who_global_data VALUES (90922, 0, 0, 0, 0, 384, 136);
INSERT INTO public.who_global_data VALUES (90923, 0, 0, 0, 0, 384, 63);
INSERT INTO public.who_global_data VALUES (90924, 0, 0, 0, 0, 384, 17);
INSERT INTO public.who_global_data VALUES (90925, 0, 0, 0, 0, 384, 172);
INSERT INTO public.who_global_data VALUES (90926, 0, 0, 0, 0, 384, 109);
INSERT INTO public.who_global_data VALUES (90927, 0, 0, 0, 0, 384, 200);
INSERT INTO public.who_global_data VALUES (90928, 0, 0, 0, 0, 384, 93);
INSERT INTO public.who_global_data VALUES (90929, 0, 0, 0, 0, 384, 5);
INSERT INTO public.who_global_data VALUES (90930, 0, 0, 0, 0, 384, 214);
INSERT INTO public.who_global_data VALUES (90931, 0, 0, 0, 0, 384, 204);
INSERT INTO public.who_global_data VALUES (90932, 0, 0, 0, 0, 384, 198);
INSERT INTO public.who_global_data VALUES (90933, 0, 0, 0, 0, 384, 173);
INSERT INTO public.who_global_data VALUES (90934, 0, 0, 0, 0, 384, 229);
INSERT INTO public.who_global_data VALUES (90935, 0, 0, 0, 0, 384, 76);
INSERT INTO public.who_global_data VALUES (90936, 0, 0, 0, 0, 384, 138);
INSERT INTO public.who_global_data VALUES (90937, 0, 0, 0, 0, 384, 98);
INSERT INTO public.who_global_data VALUES (90938, 0, 0, 0, 0, 384, 103);
INSERT INTO public.who_global_data VALUES (90939, 0, 0, 0, 0, 384, 225);
INSERT INTO public.who_global_data VALUES (90940, 0, 0, 0, 0, 384, 131);
INSERT INTO public.who_global_data VALUES (90941, 0, 0, 0, 0, 384, 235);
INSERT INTO public.who_global_data VALUES (90942, 0, 0, 0, 0, 384, 137);
INSERT INTO public.who_global_data VALUES (90943, 5, 5, 0, 0, 384, 81);
INSERT INTO public.who_global_data VALUES (90944, 0, 0, 0, 0, 384, 182);
INSERT INTO public.who_global_data VALUES (90945, 0, 0, 0, 0, 384, 145);
INSERT INTO public.who_global_data VALUES (90946, 0, 0, 0, 0, 384, 26);
INSERT INTO public.who_global_data VALUES (90947, 0, 0, 0, 0, 384, 170);
INSERT INTO public.who_global_data VALUES (90948, 0, 0, 0, 0, 384, 191);
INSERT INTO public.who_global_data VALUES (90949, 0, 0, 0, 0, 384, 221);
INSERT INTO public.who_global_data VALUES (90950, 0, 0, 0, 0, 384, 64);
INSERT INTO public.who_global_data VALUES (90951, 0, 0, 0, 0, 384, 116);
INSERT INTO public.who_global_data VALUES (90952, 0, 0, 0, 0, 384, 128);
INSERT INTO public.who_global_data VALUES (90953, 0, 0, 0, 0, 384, 6);
INSERT INTO public.who_global_data VALUES (90954, 0, 0, 0, 0, 384, 227);
INSERT INTO public.who_global_data VALUES (90955, 0, 0, 0, 0, 384, 68);
INSERT INTO public.who_global_data VALUES (90956, 0, 0, 0, 0, 384, 184);
INSERT INTO public.who_global_data VALUES (90957, 0, 0, 0, 0, 384, 82);
INSERT INTO public.who_global_data VALUES (90958, 0, 0, 0, 0, 384, 149);
INSERT INTO public.who_global_data VALUES (90959, 0, 0, 0, 0, 384, 197);
INSERT INTO public.who_global_data VALUES (90960, 0, 0, 0, 0, 384, 78);
INSERT INTO public.who_global_data VALUES (90961, 0, 0, 0, 0, 384, 233);
INSERT INTO public.who_global_data VALUES (90962, 0, 0, 0, 0, 384, 133);
INSERT INTO public.who_global_data VALUES (90963, 0, 0, 0, 0, 384, 35);
INSERT INTO public.who_global_data VALUES (90964, 0, 0, 0, 0, 384, 114);
INSERT INTO public.who_global_data VALUES (90965, 0, 0, 0, 0, 384, 237);
INSERT INTO public.who_global_data VALUES (90966, 0, 0, 0, 0, 384, 55);
INSERT INTO public.who_global_data VALUES (90967, 0, 0, 0, 0, 384, 176);
INSERT INTO public.who_global_data VALUES (90968, 0, 0, 0, 0, 384, 202);
INSERT INTO public.who_global_data VALUES (90969, 0, 0, 0, 0, 384, 155);
INSERT INTO public.who_global_data VALUES (90970, 0, 0, 0, 0, 384, 32);
INSERT INTO public.who_global_data VALUES (90971, 0, 0, 0, 0, 384, 220);
INSERT INTO public.who_global_data VALUES (90972, 0, 0, 0, 0, 384, 30);
INSERT INTO public.who_global_data VALUES (90973, 0, 0, 0, 0, 384, 147);
INSERT INTO public.who_global_data VALUES (90974, 0, 0, 0, 0, 384, 208);
INSERT INTO public.who_global_data VALUES (90975, 0, 0, 0, 0, 384, 45);
INSERT INTO public.who_global_data VALUES (90976, 0, 0, 0, 0, 384, 110);
INSERT INTO public.who_global_data VALUES (90977, 0, 0, 0, 0, 384, 88);
INSERT INTO public.who_global_data VALUES (90978, 0, 0, 0, 0, 384, 51);
INSERT INTO public.who_global_data VALUES (90979, 0, 0, 0, 0, 384, 209);
INSERT INTO public.who_global_data VALUES (90980, 0, 0, 0, 0, 384, 205);
INSERT INTO public.who_global_data VALUES (90981, 0, 0, 0, 0, 384, 18);
INSERT INTO public.who_global_data VALUES (90982, 0, 6, 0, 0, 384, 72);
INSERT INTO public.who_global_data VALUES (90983, 0, 0, 0, 0, 384, 44);
INSERT INTO public.who_global_data VALUES (90984, 0, 0, 0, 0, 384, 15);
INSERT INTO public.who_global_data VALUES (90985, 0, 0, 0, 0, 384, 25);
INSERT INTO public.who_global_data VALUES (90986, 0, 0, 0, 0, 384, 179);
INSERT INTO public.who_global_data VALUES (90987, 0, 0, 0, 0, 384, 34);
INSERT INTO public.who_global_data VALUES (90988, 0, 0, 0, 0, 384, 207);
INSERT INTO public.who_global_data VALUES (90989, 0, 0, 0, 0, 384, 166);
INSERT INTO public.who_global_data VALUES (90990, 0, 0, 0, 0, 384, 126);
INSERT INTO public.who_global_data VALUES (90991, 0, 0, 0, 0, 384, 97);
INSERT INTO public.who_global_data VALUES (90992, 0, 0, 0, 0, 384, 36);
INSERT INTO public.who_global_data VALUES (90993, 0, 0, 0, 0, 384, 125);
INSERT INTO public.who_global_data VALUES (90994, 0, 0, 0, 0, 384, 124);
INSERT INTO public.who_global_data VALUES (90995, 0, 0, 0, 0, 384, 185);
INSERT INTO public.who_global_data VALUES (90996, 0, 0, 0, 0, 384, 194);
INSERT INTO public.who_global_data VALUES (90997, 0, 0, 0, 0, 384, 144);
INSERT INTO public.who_global_data VALUES (90998, 0, 0, 0, 0, 384, 19);
INSERT INTO public.who_global_data VALUES (90999, 0, 0, 0, 0, 384, 217);
INSERT INTO public.who_global_data VALUES (91000, 0, 0, 0, 0, 384, 148);
INSERT INTO public.who_global_data VALUES (91001, 0, 0, 0, 0, 384, 86);
INSERT INTO public.who_global_data VALUES (91002, 0, 0, 0, 0, 384, 13);
INSERT INTO public.who_global_data VALUES (91003, 0, 0, 0, 0, 384, 157);
INSERT INTO public.who_global_data VALUES (91004, 0, 0, 0, 0, 384, 8);
INSERT INTO public.who_global_data VALUES (91005, 0, 0, 0, 0, 384, 73);
INSERT INTO public.who_global_data VALUES (91006, 0, 0, 0, 0, 384, 101);
INSERT INTO public.who_global_data VALUES (91007, 0, 0, 0, 0, 384, 165);
INSERT INTO public.who_global_data VALUES (91008, 0, 0, 0, 0, 384, 14);
INSERT INTO public.who_global_data VALUES (91009, 0, 0, 0, 0, 385, 193);
INSERT INTO public.who_global_data VALUES (91010, 0, 0, 0, 0, 385, 113);
INSERT INTO public.who_global_data VALUES (91011, 0, 0, 0, 0, 385, 143);
INSERT INTO public.who_global_data VALUES (91012, 0, 0, 0, 0, 385, 219);
INSERT INTO public.who_global_data VALUES (91013, 0, 0, 0, 0, 385, 186);
INSERT INTO public.who_global_data VALUES (91014, 0, 0, 0, 0, 385, 52);
INSERT INTO public.who_global_data VALUES (91015, 0, 0, 0, 0, 385, 180);
INSERT INTO public.who_global_data VALUES (91016, 0, 0, 0, 0, 385, 167);
INSERT INTO public.who_global_data VALUES (91017, 0, 0, 0, 0, 385, 154);
INSERT INTO public.who_global_data VALUES (91018, 0, 0, 0, 0, 385, 94);
INSERT INTO public.who_global_data VALUES (91019, 0, 0, 0, 0, 385, 66);
INSERT INTO public.who_global_data VALUES (91020, 0, 0, 0, 0, 385, 58);
INSERT INTO public.who_global_data VALUES (91021, 0, 0, 0, 0, 385, 163);
INSERT INTO public.who_global_data VALUES (91022, 0, 0, 0, 0, 385, 37);
INSERT INTO public.who_global_data VALUES (91023, 0, 0, 0, 0, 385, 142);
INSERT INTO public.who_global_data VALUES (91024, 0, 0, 0, 0, 385, 83);
INSERT INTO public.who_global_data VALUES (91025, 0, 0, 0, 0, 385, 228);
INSERT INTO public.who_global_data VALUES (91026, 0, 0, 0, 0, 385, 188);
INSERT INTO public.who_global_data VALUES (91027, 0, 0, 0, 0, 385, 62);
INSERT INTO public.who_global_data VALUES (91028, 0, 0, 0, 0, 385, 160);
INSERT INTO public.who_global_data VALUES (91029, 0, 0, 0, 0, 385, 50);
INSERT INTO public.who_global_data VALUES (91030, 0, 0, 0, 0, 385, 33);
INSERT INTO public.who_global_data VALUES (91031, 0, 0, 0, 0, 385, 183);
INSERT INTO public.who_global_data VALUES (91032, 0, 0, 0, 0, 385, 92);
INSERT INTO public.who_global_data VALUES (91033, 0, 0, 0, 0, 385, 158);
INSERT INTO public.who_global_data VALUES (91034, 0, 0, 0, 0, 385, 67);
INSERT INTO public.who_global_data VALUES (91035, 0, 0, 0, 0, 385, 57);
INSERT INTO public.who_global_data VALUES (91036, 0, 0, 0, 0, 385, 38);
INSERT INTO public.who_global_data VALUES (91037, 0, 0, 0, 0, 385, 141);
INSERT INTO public.who_global_data VALUES (91038, 0, 0, 0, 0, 385, 178);
INSERT INTO public.who_global_data VALUES (91039, 0, 0, 0, 0, 385, 108);
INSERT INTO public.who_global_data VALUES (91040, 0, 0, 0, 0, 385, 39);
INSERT INTO public.who_global_data VALUES (91041, 0, 0, 0, 0, 385, 2);
INSERT INTO public.who_global_data VALUES (91042, 0, 0, 0, 0, 385, 195);
INSERT INTO public.who_global_data VALUES (91043, 0, 0, 0, 0, 385, 107);
INSERT INTO public.who_global_data VALUES (91044, 0, 0, 0, 0, 385, 161);
INSERT INTO public.who_global_data VALUES (91045, 0, 0, 0, 0, 385, 212);
INSERT INTO public.who_global_data VALUES (91046, 0, 0, 0, 0, 385, 181);
INSERT INTO public.who_global_data VALUES (91047, 0, 0, 0, 0, 385, 53);
INSERT INTO public.who_global_data VALUES (91048, 0, 0, 0, 0, 385, 164);
INSERT INTO public.who_global_data VALUES (91049, 0, 0, 0, 0, 385, 140);
INSERT INTO public.who_global_data VALUES (91050, 0, 0, 0, 0, 385, 20);
INSERT INTO public.who_global_data VALUES (91051, 17, 66, 0, 2, 385, 112);
INSERT INTO public.who_global_data VALUES (91052, 0, 0, 0, 0, 385, 111);
INSERT INTO public.who_global_data VALUES (91053, 0, 0, 0, 0, 385, 71);
INSERT INTO public.who_global_data VALUES (91054, 0, 0, 0, 0, 385, 218);
INSERT INTO public.who_global_data VALUES (91055, 0, 0, 0, 0, 385, 43);
INSERT INTO public.who_global_data VALUES (91056, 0, 0, 0, 0, 385, 49);
INSERT INTO public.who_global_data VALUES (91057, 0, 0, 0, 0, 385, 1);
INSERT INTO public.who_global_data VALUES (91058, 0, 0, 0, 0, 385, 48);
INSERT INTO public.who_global_data VALUES (91059, 0, 0, 0, 0, 385, 232);
INSERT INTO public.who_global_data VALUES (91060, 0, 0, 0, 0, 385, 175);
INSERT INTO public.who_global_data VALUES (91061, 0, 0, 0, 0, 385, 21);
INSERT INTO public.who_global_data VALUES (91062, 0, 0, 0, 0, 385, 156);
INSERT INTO public.who_global_data VALUES (91063, 0, 0, 0, 0, 385, 95);
INSERT INTO public.who_global_data VALUES (91064, 0, 0, 0, 0, 385, 177);
INSERT INTO public.who_global_data VALUES (91065, 0, 0, 0, 0, 385, 210);
INSERT INTO public.who_global_data VALUES (91066, 0, 0, 0, 0, 385, 120);
INSERT INTO public.who_global_data VALUES (91067, 0, 0, 0, 0, 385, 135);
INSERT INTO public.who_global_data VALUES (91068, 0, 0, 0, 0, 385, 206);
INSERT INTO public.who_global_data VALUES (91069, 0, 0, 0, 0, 385, 189);
INSERT INTO public.who_global_data VALUES (91070, 0, 0, 0, 0, 385, 129);
INSERT INTO public.who_global_data VALUES (91071, 0, 0, 0, 0, 385, 121);
INSERT INTO public.who_global_data VALUES (91072, 0, 0, 0, 0, 385, 59);
INSERT INTO public.who_global_data VALUES (91073, 0, 0, 0, 0, 385, 96);
INSERT INTO public.who_global_data VALUES (91074, 0, 0, 0, 0, 385, 41);
INSERT INTO public.who_global_data VALUES (91075, 0, 0, 0, 0, 385, 216);
INSERT INTO public.who_global_data VALUES (91076, 0, 0, 0, 0, 385, 236);
INSERT INTO public.who_global_data VALUES (91077, 0, 0, 0, 0, 385, 150);
INSERT INTO public.who_global_data VALUES (91078, 0, 0, 0, 0, 385, 61);
INSERT INTO public.who_global_data VALUES (91079, 0, 0, 0, 0, 385, 7);
INSERT INTO public.who_global_data VALUES (91080, 0, 0, 0, 0, 385, 169);
INSERT INTO public.who_global_data VALUES (91081, 0, 0, 0, 0, 385, 28);
INSERT INTO public.who_global_data VALUES (91082, 0, 0, 0, 0, 385, 85);
INSERT INTO public.who_global_data VALUES (91083, 0, 0, 0, 0, 385, 211);
INSERT INTO public.who_global_data VALUES (91084, 0, 0, 0, 0, 385, 60);
INSERT INTO public.who_global_data VALUES (91085, 0, 0, 0, 0, 385, 3);
INSERT INTO public.who_global_data VALUES (91086, 0, 0, 0, 0, 385, 11);
INSERT INTO public.who_global_data VALUES (91087, 0, 0, 0, 0, 385, 89);
INSERT INTO public.who_global_data VALUES (91088, 0, 0, 0, 0, 385, 24);
INSERT INTO public.who_global_data VALUES (91089, 0, 0, 0, 0, 385, 162);
INSERT INTO public.who_global_data VALUES (91090, 0, 0, 0, 0, 385, 100);
INSERT INTO public.who_global_data VALUES (91091, 0, 0, 0, 0, 385, 47);
INSERT INTO public.who_global_data VALUES (91092, 0, 0, 0, 0, 385, 29);
INSERT INTO public.who_global_data VALUES (91093, 0, 0, 0, 0, 385, 40);
INSERT INTO public.who_global_data VALUES (91094, 0, 0, 0, 0, 385, 222);
INSERT INTO public.who_global_data VALUES (91095, 0, 0, 0, 0, 385, 132);
INSERT INTO public.who_global_data VALUES (91096, 0, 0, 0, 0, 385, 130);
INSERT INTO public.who_global_data VALUES (91097, 0, 0, 0, 0, 385, 234);
INSERT INTO public.who_global_data VALUES (91098, 0, 0, 0, 0, 385, 23);
INSERT INTO public.who_global_data VALUES (91099, 0, 0, 0, 0, 385, 192);
INSERT INTO public.who_global_data VALUES (91100, 0, 0, 0, 0, 385, 69);
INSERT INTO public.who_global_data VALUES (91101, 0, 0, 0, 0, 385, 187);
INSERT INTO public.who_global_data VALUES (91102, 0, 0, 0, 0, 385, 230);
INSERT INTO public.who_global_data VALUES (91103, 0, 0, 0, 0, 385, 77);
INSERT INTO public.who_global_data VALUES (91104, 0, 0, 0, 0, 385, 9);
INSERT INTO public.who_global_data VALUES (91105, 0, 0, 0, 0, 385, 74);
INSERT INTO public.who_global_data VALUES (91106, 0, 0, 0, 0, 385, 224);
INSERT INTO public.who_global_data VALUES (91107, 0, 0, 0, 0, 385, 199);
INSERT INTO public.who_global_data VALUES (91108, 0, 0, 0, 0, 385, 190);
INSERT INTO public.who_global_data VALUES (91109, 0, 0, 0, 0, 385, 12);
INSERT INTO public.who_global_data VALUES (91110, 0, 0, 0, 0, 385, 104);
INSERT INTO public.who_global_data VALUES (91111, 0, 0, 0, 0, 385, 153);
INSERT INTO public.who_global_data VALUES (91112, 0, 0, 0, 0, 385, 91);
INSERT INTO public.who_global_data VALUES (91113, 0, 0, 0, 0, 385, 215);
INSERT INTO public.who_global_data VALUES (91114, 0, 1, 0, 0, 385, 84);
INSERT INTO public.who_global_data VALUES (91115, 0, 0, 0, 0, 385, 231);
INSERT INTO public.who_global_data VALUES (91116, 0, 0, 0, 0, 385, 196);
INSERT INTO public.who_global_data VALUES (91117, 0, 0, 0, 0, 385, 105);
INSERT INTO public.who_global_data VALUES (91118, 0, 0, 0, 0, 385, 122);
INSERT INTO public.who_global_data VALUES (91119, 0, 0, 0, 0, 385, 159);
INSERT INTO public.who_global_data VALUES (91120, 0, 0, 0, 0, 385, 75);
INSERT INTO public.who_global_data VALUES (91121, 0, 0, 0, 0, 385, 27);
INSERT INTO public.who_global_data VALUES (91122, 0, 0, 0, 0, 385, 54);
INSERT INTO public.who_global_data VALUES (91123, 0, 0, 0, 0, 385, 226);
INSERT INTO public.who_global_data VALUES (91124, 0, 0, 0, 0, 385, 79);
INSERT INTO public.who_global_data VALUES (91125, 0, 0, 0, 0, 385, 56);
INSERT INTO public.who_global_data VALUES (91126, 0, 0, 0, 0, 385, 117);
INSERT INTO public.who_global_data VALUES (91127, 0, 0, 0, 0, 385, 152);
INSERT INTO public.who_global_data VALUES (91128, 0, 0, 0, 0, 385, 16);
INSERT INTO public.who_global_data VALUES (91129, 0, 0, 0, 0, 385, 10);
INSERT INTO public.who_global_data VALUES (91130, 0, 0, 0, 0, 385, 201);
INSERT INTO public.who_global_data VALUES (91131, 0, 0, 0, 0, 385, 174);
INSERT INTO public.who_global_data VALUES (91132, 0, 0, 0, 0, 385, 119);
INSERT INTO public.who_global_data VALUES (91133, 0, 0, 0, 0, 385, 168);
INSERT INTO public.who_global_data VALUES (91134, 0, 0, 0, 0, 385, 99);
INSERT INTO public.who_global_data VALUES (91135, 0, 0, 0, 0, 385, 171);
INSERT INTO public.who_global_data VALUES (91136, 0, 0, 0, 0, 385, 87);
INSERT INTO public.who_global_data VALUES (91137, 0, 0, 0, 0, 385, 123);
INSERT INTO public.who_global_data VALUES (91138, 0, 0, 0, 0, 385, 151);
INSERT INTO public.who_global_data VALUES (91139, 0, 0, 0, 0, 385, 213);
INSERT INTO public.who_global_data VALUES (91140, 0, 0, 0, 0, 385, 118);
INSERT INTO public.who_global_data VALUES (91141, 0, 0, 0, 0, 385, 134);
INSERT INTO public.who_global_data VALUES (91142, 0, 0, 0, 0, 385, 65);
INSERT INTO public.who_global_data VALUES (91143, 0, 0, 0, 0, 385, 102);
INSERT INTO public.who_global_data VALUES (91144, 0, 0, 0, 0, 385, 223);
INSERT INTO public.who_global_data VALUES (91145, 0, 0, 0, 0, 385, 4);
INSERT INTO public.who_global_data VALUES (91146, 0, 0, 0, 0, 385, 146);
INSERT INTO public.who_global_data VALUES (91147, 0, 0, 0, 0, 385, 31);
INSERT INTO public.who_global_data VALUES (91148, 0, 0, 0, 0, 385, 127);
INSERT INTO public.who_global_data VALUES (91149, 0, 0, 0, 0, 385, 22);
INSERT INTO public.who_global_data VALUES (91150, 0, 0, 0, 0, 385, 115);
INSERT INTO public.who_global_data VALUES (91151, 0, 0, 0, 0, 385, 106);
INSERT INTO public.who_global_data VALUES (91152, 0, 0, 0, 0, 385, 90);
INSERT INTO public.who_global_data VALUES (91153, 0, 0, 0, 0, 385, 70);
INSERT INTO public.who_global_data VALUES (91154, 0, 0, 0, 0, 385, 46);
INSERT INTO public.who_global_data VALUES (91155, 0, 0, 0, 0, 385, 139);
INSERT INTO public.who_global_data VALUES (91156, 0, 0, 0, 0, 385, 42);
INSERT INTO public.who_global_data VALUES (91157, 0, 0, 0, 0, 385, 80);
INSERT INTO public.who_global_data VALUES (91158, 0, 0, 0, 0, 385, 203);
INSERT INTO public.who_global_data VALUES (91159, 0, 0, 0, 0, 385, 136);
INSERT INTO public.who_global_data VALUES (91160, 0, 0, 0, 0, 385, 63);
INSERT INTO public.who_global_data VALUES (91161, 0, 0, 0, 0, 385, 17);
INSERT INTO public.who_global_data VALUES (91162, 0, 0, 0, 0, 385, 172);
INSERT INTO public.who_global_data VALUES (91163, 0, 0, 0, 0, 385, 109);
INSERT INTO public.who_global_data VALUES (91164, 0, 0, 0, 0, 385, 200);
INSERT INTO public.who_global_data VALUES (91165, 0, 0, 0, 0, 385, 93);
INSERT INTO public.who_global_data VALUES (91166, 0, 0, 0, 0, 385, 5);
INSERT INTO public.who_global_data VALUES (91167, 0, 0, 0, 0, 385, 214);
INSERT INTO public.who_global_data VALUES (91168, 0, 0, 0, 0, 385, 204);
INSERT INTO public.who_global_data VALUES (91169, 0, 0, 0, 0, 385, 198);
INSERT INTO public.who_global_data VALUES (91170, 0, 0, 0, 0, 385, 173);
INSERT INTO public.who_global_data VALUES (91171, 0, 0, 0, 0, 385, 229);
INSERT INTO public.who_global_data VALUES (91172, 0, 0, 0, 0, 385, 76);
INSERT INTO public.who_global_data VALUES (91173, 0, 0, 0, 0, 385, 138);
INSERT INTO public.who_global_data VALUES (91174, 0, 0, 0, 0, 385, 98);
INSERT INTO public.who_global_data VALUES (91175, 0, 0, 0, 0, 385, 103);
INSERT INTO public.who_global_data VALUES (91176, 0, 0, 0, 0, 385, 225);
INSERT INTO public.who_global_data VALUES (91177, 0, 0, 0, 0, 385, 131);
INSERT INTO public.who_global_data VALUES (91178, 0, 0, 0, 0, 385, 235);
INSERT INTO public.who_global_data VALUES (91179, 0, 0, 0, 0, 385, 137);
INSERT INTO public.who_global_data VALUES (91180, 0, 0, 0, 0, 385, 81);
INSERT INTO public.who_global_data VALUES (91181, 0, 0, 0, 0, 385, 182);
INSERT INTO public.who_global_data VALUES (91182, 0, 0, 0, 0, 385, 145);
INSERT INTO public.who_global_data VALUES (91183, 0, 0, 0, 0, 385, 26);
INSERT INTO public.who_global_data VALUES (91184, 0, 0, 0, 0, 385, 170);
INSERT INTO public.who_global_data VALUES (91185, 0, 0, 0, 0, 385, 191);
INSERT INTO public.who_global_data VALUES (91186, 0, 0, 0, 0, 385, 221);
INSERT INTO public.who_global_data VALUES (91187, 0, 0, 0, 0, 385, 64);
INSERT INTO public.who_global_data VALUES (91188, 0, 0, 0, 0, 385, 116);
INSERT INTO public.who_global_data VALUES (91189, 0, 0, 0, 0, 385, 128);
INSERT INTO public.who_global_data VALUES (91190, 0, 0, 0, 0, 385, 6);
INSERT INTO public.who_global_data VALUES (91191, 0, 0, 0, 0, 385, 227);
INSERT INTO public.who_global_data VALUES (91192, 0, 0, 0, 0, 385, 68);
INSERT INTO public.who_global_data VALUES (91193, 0, 0, 0, 0, 385, 184);
INSERT INTO public.who_global_data VALUES (91194, 0, 0, 0, 0, 385, 82);
INSERT INTO public.who_global_data VALUES (91195, 0, 0, 0, 0, 385, 149);
INSERT INTO public.who_global_data VALUES (91196, 0, 0, 0, 0, 385, 197);
INSERT INTO public.who_global_data VALUES (91197, 0, 0, 0, 0, 385, 78);
INSERT INTO public.who_global_data VALUES (91198, 0, 0, 0, 0, 385, 233);
INSERT INTO public.who_global_data VALUES (91199, 0, 0, 0, 0, 385, 133);
INSERT INTO public.who_global_data VALUES (91200, 0, 0, 0, 0, 385, 35);
INSERT INTO public.who_global_data VALUES (91201, 0, 0, 0, 0, 385, 114);
INSERT INTO public.who_global_data VALUES (91202, 0, 0, 0, 0, 385, 237);
INSERT INTO public.who_global_data VALUES (91203, 0, 0, 0, 0, 385, 55);
INSERT INTO public.who_global_data VALUES (91204, 0, 0, 0, 0, 385, 176);
INSERT INTO public.who_global_data VALUES (91205, 0, 0, 0, 0, 385, 202);
INSERT INTO public.who_global_data VALUES (91206, 0, 0, 0, 0, 385, 155);
INSERT INTO public.who_global_data VALUES (91207, 0, 0, 0, 0, 385, 32);
INSERT INTO public.who_global_data VALUES (91208, 0, 0, 0, 0, 385, 220);
INSERT INTO public.who_global_data VALUES (91209, 0, 0, 0, 0, 385, 30);
INSERT INTO public.who_global_data VALUES (91210, 0, 0, 0, 0, 385, 147);
INSERT INTO public.who_global_data VALUES (91211, 0, 0, 0, 0, 385, 208);
INSERT INTO public.who_global_data VALUES (91212, 0, 0, 0, 0, 385, 45);
INSERT INTO public.who_global_data VALUES (91213, 0, 0, 0, 0, 385, 110);
INSERT INTO public.who_global_data VALUES (91214, 0, 0, 0, 0, 385, 88);
INSERT INTO public.who_global_data VALUES (91215, 0, 0, 0, 0, 385, 51);
INSERT INTO public.who_global_data VALUES (91216, 0, 0, 0, 0, 385, 209);
INSERT INTO public.who_global_data VALUES (91217, 0, 0, 0, 0, 385, 205);
INSERT INTO public.who_global_data VALUES (91218, 0, 0, 0, 0, 385, 18);
INSERT INTO public.who_global_data VALUES (91219, 0, 6, 0, 0, 385, 72);
INSERT INTO public.who_global_data VALUES (91220, 0, 0, 0, 0, 385, 44);
INSERT INTO public.who_global_data VALUES (91221, 0, 0, 0, 0, 385, 15);
INSERT INTO public.who_global_data VALUES (91222, 0, 0, 0, 0, 385, 25);
INSERT INTO public.who_global_data VALUES (91223, 0, 0, 0, 0, 385, 179);
INSERT INTO public.who_global_data VALUES (91224, 0, 0, 0, 0, 385, 34);
INSERT INTO public.who_global_data VALUES (91225, 0, 0, 0, 0, 385, 207);
INSERT INTO public.who_global_data VALUES (91226, 0, 0, 0, 0, 385, 166);
INSERT INTO public.who_global_data VALUES (91227, 0, 0, 0, 0, 385, 126);
INSERT INTO public.who_global_data VALUES (91228, 0, 0, 0, 0, 385, 97);
INSERT INTO public.who_global_data VALUES (91229, 0, 0, 0, 0, 385, 36);
INSERT INTO public.who_global_data VALUES (91230, 0, 0, 0, 0, 385, 125);
INSERT INTO public.who_global_data VALUES (91231, 0, 0, 0, 0, 385, 124);
INSERT INTO public.who_global_data VALUES (91232, 0, 0, 0, 0, 385, 185);
INSERT INTO public.who_global_data VALUES (91233, 0, 0, 0, 0, 385, 194);
INSERT INTO public.who_global_data VALUES (91234, 0, 0, 0, 0, 385, 144);
INSERT INTO public.who_global_data VALUES (91235, 0, 0, 0, 0, 385, 19);
INSERT INTO public.who_global_data VALUES (91236, 0, 0, 0, 0, 385, 217);
INSERT INTO public.who_global_data VALUES (91237, 0, 0, 0, 0, 385, 148);
INSERT INTO public.who_global_data VALUES (91238, 0, 0, 0, 0, 385, 86);
INSERT INTO public.who_global_data VALUES (91239, 0, 0, 0, 0, 385, 13);
INSERT INTO public.who_global_data VALUES (91240, 0, 0, 0, 0, 385, 157);
INSERT INTO public.who_global_data VALUES (91241, 0, 0, 0, 0, 385, 8);
INSERT INTO public.who_global_data VALUES (91242, 0, 0, 0, 0, 385, 73);
INSERT INTO public.who_global_data VALUES (91243, 0, 0, 0, 0, 385, 101);
INSERT INTO public.who_global_data VALUES (91244, 0, 0, 0, 0, 385, 165);
INSERT INTO public.who_global_data VALUES (91245, 0, 0, 0, 0, 385, 14);
INSERT INTO public.who_global_data VALUES (91246, 0, 0, 0, 0, 386, 193);
INSERT INTO public.who_global_data VALUES (91247, 0, 0, 0, 0, 386, 113);
INSERT INTO public.who_global_data VALUES (91248, 0, 0, 0, 0, 386, 143);
INSERT INTO public.who_global_data VALUES (91249, 0, 0, 0, 0, 386, 219);
INSERT INTO public.who_global_data VALUES (91250, 0, 0, 0, 0, 386, 186);
INSERT INTO public.who_global_data VALUES (91251, 0, 0, 0, 0, 386, 52);
INSERT INTO public.who_global_data VALUES (91252, 0, 0, 0, 0, 386, 180);
INSERT INTO public.who_global_data VALUES (91253, 0, 0, 0, 0, 386, 167);
INSERT INTO public.who_global_data VALUES (91254, 0, 0, 0, 0, 386, 154);
INSERT INTO public.who_global_data VALUES (91255, 0, 0, 0, 0, 386, 94);
INSERT INTO public.who_global_data VALUES (91256, 0, 0, 0, 0, 386, 66);
INSERT INTO public.who_global_data VALUES (91257, 0, 0, 0, 0, 386, 58);
INSERT INTO public.who_global_data VALUES (91258, 0, 0, 0, 0, 386, 163);
INSERT INTO public.who_global_data VALUES (91259, 0, 0, 0, 0, 386, 37);
INSERT INTO public.who_global_data VALUES (91260, 0, 0, 0, 0, 386, 142);
INSERT INTO public.who_global_data VALUES (91261, 0, 0, 0, 0, 386, 83);
INSERT INTO public.who_global_data VALUES (91262, 0, 0, 0, 0, 386, 228);
INSERT INTO public.who_global_data VALUES (91263, 0, 0, 0, 0, 386, 188);
INSERT INTO public.who_global_data VALUES (91264, 0, 0, 0, 0, 386, 62);
INSERT INTO public.who_global_data VALUES (91265, 0, 0, 0, 0, 386, 160);
INSERT INTO public.who_global_data VALUES (91266, 0, 0, 0, 0, 386, 50);
INSERT INTO public.who_global_data VALUES (91267, 0, 0, 0, 0, 386, 33);
INSERT INTO public.who_global_data VALUES (91268, 0, 0, 0, 0, 386, 183);
INSERT INTO public.who_global_data VALUES (91269, 0, 0, 0, 0, 386, 92);
INSERT INTO public.who_global_data VALUES (91270, 0, 0, 0, 0, 386, 158);
INSERT INTO public.who_global_data VALUES (91271, 0, 0, 0, 0, 386, 67);
INSERT INTO public.who_global_data VALUES (91272, 0, 0, 0, 0, 386, 57);
INSERT INTO public.who_global_data VALUES (91273, 0, 0, 0, 0, 386, 38);
INSERT INTO public.who_global_data VALUES (91274, 0, 0, 0, 0, 386, 141);
INSERT INTO public.who_global_data VALUES (91275, 0, 0, 0, 0, 386, 178);
INSERT INTO public.who_global_data VALUES (91276, 0, 0, 0, 0, 386, 108);
INSERT INTO public.who_global_data VALUES (91277, 0, 0, 0, 0, 386, 39);
INSERT INTO public.who_global_data VALUES (91278, 0, 0, 0, 0, 386, 2);
INSERT INTO public.who_global_data VALUES (91279, 0, 0, 0, 0, 386, 195);
INSERT INTO public.who_global_data VALUES (91280, 0, 0, 0, 0, 386, 107);
INSERT INTO public.who_global_data VALUES (91281, 0, 0, 0, 0, 386, 161);
INSERT INTO public.who_global_data VALUES (91282, 0, 0, 0, 0, 386, 212);
INSERT INTO public.who_global_data VALUES (91283, 0, 0, 0, 0, 386, 181);
INSERT INTO public.who_global_data VALUES (91284, 0, 0, 0, 0, 386, 53);
INSERT INTO public.who_global_data VALUES (91285, 0, 0, 0, 0, 386, 164);
INSERT INTO public.who_global_data VALUES (91286, 0, 0, 0, 0, 386, 140);
INSERT INTO public.who_global_data VALUES (91287, 0, 0, 0, 0, 386, 20);
INSERT INTO public.who_global_data VALUES (91288, 4, 49, 1, 2, 386, 112);
INSERT INTO public.who_global_data VALUES (91289, 0, 0, 0, 0, 386, 111);
INSERT INTO public.who_global_data VALUES (91290, 0, 0, 0, 0, 386, 71);
INSERT INTO public.who_global_data VALUES (91291, 0, 0, 0, 0, 386, 218);
INSERT INTO public.who_global_data VALUES (91292, 0, 0, 0, 0, 386, 43);
INSERT INTO public.who_global_data VALUES (91293, 0, 0, 0, 0, 386, 49);
INSERT INTO public.who_global_data VALUES (91294, 0, 0, 0, 0, 386, 1);
INSERT INTO public.who_global_data VALUES (91295, 0, 0, 0, 0, 386, 48);
INSERT INTO public.who_global_data VALUES (91296, 0, 0, 0, 0, 386, 232);
INSERT INTO public.who_global_data VALUES (91297, 0, 0, 0, 0, 386, 175);
INSERT INTO public.who_global_data VALUES (91298, 0, 0, 0, 0, 386, 21);
INSERT INTO public.who_global_data VALUES (91299, 0, 0, 0, 0, 386, 156);
INSERT INTO public.who_global_data VALUES (91300, 0, 0, 0, 0, 386, 95);
INSERT INTO public.who_global_data VALUES (91301, 0, 0, 0, 0, 386, 177);
INSERT INTO public.who_global_data VALUES (91302, 0, 0, 0, 0, 386, 210);
INSERT INTO public.who_global_data VALUES (91303, 0, 0, 0, 0, 386, 120);
INSERT INTO public.who_global_data VALUES (91304, 0, 0, 0, 0, 386, 135);
INSERT INTO public.who_global_data VALUES (91305, 0, 0, 0, 0, 386, 206);
INSERT INTO public.who_global_data VALUES (91306, 0, 0, 0, 0, 386, 189);
INSERT INTO public.who_global_data VALUES (91307, 0, 0, 0, 0, 386, 129);
INSERT INTO public.who_global_data VALUES (91308, 0, 0, 0, 0, 386, 121);
INSERT INTO public.who_global_data VALUES (91309, 0, 0, 0, 0, 386, 59);
INSERT INTO public.who_global_data VALUES (91310, 0, 0, 0, 0, 386, 96);
INSERT INTO public.who_global_data VALUES (91311, 0, 0, 0, 0, 386, 41);
INSERT INTO public.who_global_data VALUES (91312, 0, 0, 0, 0, 386, 216);
INSERT INTO public.who_global_data VALUES (91313, 0, 0, 0, 0, 386, 236);
INSERT INTO public.who_global_data VALUES (91314, 0, 0, 0, 0, 386, 150);
INSERT INTO public.who_global_data VALUES (91315, 0, 0, 0, 0, 386, 61);
INSERT INTO public.who_global_data VALUES (91316, 0, 0, 0, 0, 386, 7);
INSERT INTO public.who_global_data VALUES (91317, 0, 0, 0, 0, 386, 169);
INSERT INTO public.who_global_data VALUES (91318, 0, 0, 0, 0, 386, 28);
INSERT INTO public.who_global_data VALUES (91319, 0, 0, 0, 0, 386, 85);
INSERT INTO public.who_global_data VALUES (91320, 0, 0, 0, 0, 386, 211);
INSERT INTO public.who_global_data VALUES (91321, 0, 0, 0, 0, 386, 60);
INSERT INTO public.who_global_data VALUES (91322, 0, 0, 0, 0, 386, 3);
INSERT INTO public.who_global_data VALUES (91323, 0, 0, 0, 0, 386, 11);
INSERT INTO public.who_global_data VALUES (91324, 0, 0, 0, 0, 386, 89);
INSERT INTO public.who_global_data VALUES (91325, 0, 0, 0, 0, 386, 24);
INSERT INTO public.who_global_data VALUES (91326, 0, 0, 0, 0, 386, 162);
INSERT INTO public.who_global_data VALUES (91327, 0, 0, 0, 0, 386, 100);
INSERT INTO public.who_global_data VALUES (91328, 0, 0, 0, 0, 386, 47);
INSERT INTO public.who_global_data VALUES (91329, 0, 0, 0, 0, 386, 29);
INSERT INTO public.who_global_data VALUES (91330, 0, 0, 0, 0, 386, 40);
INSERT INTO public.who_global_data VALUES (91331, 0, 0, 0, 0, 386, 222);
INSERT INTO public.who_global_data VALUES (91332, 0, 0, 0, 0, 386, 132);
INSERT INTO public.who_global_data VALUES (91333, 0, 0, 0, 0, 386, 130);
INSERT INTO public.who_global_data VALUES (91334, 0, 0, 0, 0, 386, 234);
INSERT INTO public.who_global_data VALUES (91335, 0, 0, 0, 0, 386, 23);
INSERT INTO public.who_global_data VALUES (91336, 0, 0, 0, 0, 386, 192);
INSERT INTO public.who_global_data VALUES (91337, 0, 0, 0, 0, 386, 69);
INSERT INTO public.who_global_data VALUES (91338, 0, 0, 0, 0, 386, 187);
INSERT INTO public.who_global_data VALUES (91339, 0, 0, 0, 0, 386, 230);
INSERT INTO public.who_global_data VALUES (91340, 0, 0, 0, 0, 386, 77);
INSERT INTO public.who_global_data VALUES (91341, 0, 0, 0, 0, 386, 9);
INSERT INTO public.who_global_data VALUES (91342, 0, 0, 0, 0, 386, 74);
INSERT INTO public.who_global_data VALUES (91343, 0, 0, 0, 0, 386, 224);
INSERT INTO public.who_global_data VALUES (91344, 0, 0, 0, 0, 386, 199);
INSERT INTO public.who_global_data VALUES (91345, 0, 0, 0, 0, 386, 190);
INSERT INTO public.who_global_data VALUES (91346, 0, 0, 0, 0, 386, 12);
INSERT INTO public.who_global_data VALUES (91347, 0, 0, 0, 0, 386, 104);
INSERT INTO public.who_global_data VALUES (91348, 0, 0, 0, 0, 386, 153);
INSERT INTO public.who_global_data VALUES (91349, 0, 0, 0, 0, 386, 91);
INSERT INTO public.who_global_data VALUES (91350, 0, 0, 0, 0, 386, 215);
INSERT INTO public.who_global_data VALUES (91351, 0, 1, 0, 0, 386, 84);
INSERT INTO public.who_global_data VALUES (91352, 0, 0, 0, 0, 386, 231);
INSERT INTO public.who_global_data VALUES (91353, 0, 0, 0, 0, 386, 196);
INSERT INTO public.who_global_data VALUES (91354, 0, 0, 0, 0, 386, 105);
INSERT INTO public.who_global_data VALUES (91355, 0, 0, 0, 0, 386, 122);
INSERT INTO public.who_global_data VALUES (91356, 0, 0, 0, 0, 386, 159);
INSERT INTO public.who_global_data VALUES (91357, 0, 0, 0, 0, 386, 75);
INSERT INTO public.who_global_data VALUES (91358, 0, 0, 0, 0, 386, 27);
INSERT INTO public.who_global_data VALUES (91359, 0, 0, 0, 0, 386, 54);
INSERT INTO public.who_global_data VALUES (91360, 0, 0, 0, 0, 386, 226);
INSERT INTO public.who_global_data VALUES (91361, 0, 0, 0, 0, 386, 79);
INSERT INTO public.who_global_data VALUES (91362, 0, 0, 0, 0, 386, 56);
INSERT INTO public.who_global_data VALUES (91363, 0, 0, 0, 0, 386, 117);
INSERT INTO public.who_global_data VALUES (91364, 0, 0, 0, 0, 386, 152);
INSERT INTO public.who_global_data VALUES (91365, 0, 0, 0, 0, 386, 16);
INSERT INTO public.who_global_data VALUES (91366, 0, 0, 0, 0, 386, 10);
INSERT INTO public.who_global_data VALUES (91367, 0, 0, 0, 0, 386, 201);
INSERT INTO public.who_global_data VALUES (91368, 0, 0, 0, 0, 386, 174);
INSERT INTO public.who_global_data VALUES (91369, 0, 0, 0, 0, 386, 119);
INSERT INTO public.who_global_data VALUES (91370, 0, 0, 0, 0, 386, 168);
INSERT INTO public.who_global_data VALUES (91371, 0, 0, 0, 0, 386, 99);
INSERT INTO public.who_global_data VALUES (91372, 0, 0, 0, 0, 386, 171);
INSERT INTO public.who_global_data VALUES (91373, 0, 0, 0, 0, 386, 87);
INSERT INTO public.who_global_data VALUES (91374, 0, 0, 0, 0, 386, 123);
INSERT INTO public.who_global_data VALUES (91375, 0, 0, 0, 0, 386, 151);
INSERT INTO public.who_global_data VALUES (91376, 0, 0, 0, 0, 386, 213);
INSERT INTO public.who_global_data VALUES (91377, 0, 0, 0, 0, 386, 118);
INSERT INTO public.who_global_data VALUES (91378, 0, 0, 0, 0, 386, 134);
INSERT INTO public.who_global_data VALUES (91379, 0, 0, 0, 0, 386, 65);
INSERT INTO public.who_global_data VALUES (91380, 0, 0, 0, 0, 386, 102);
INSERT INTO public.who_global_data VALUES (91381, 0, 0, 0, 0, 386, 223);
INSERT INTO public.who_global_data VALUES (91382, 0, 0, 0, 0, 386, 4);
INSERT INTO public.who_global_data VALUES (91383, 0, 0, 0, 0, 386, 146);
INSERT INTO public.who_global_data VALUES (91384, 0, 0, 0, 0, 386, 31);
INSERT INTO public.who_global_data VALUES (91385, 0, 0, 0, 0, 386, 127);
INSERT INTO public.who_global_data VALUES (91386, 0, 0, 0, 0, 386, 22);
INSERT INTO public.who_global_data VALUES (91387, 0, 0, 0, 0, 386, 115);
INSERT INTO public.who_global_data VALUES (91388, 0, 0, 0, 0, 386, 106);
INSERT INTO public.who_global_data VALUES (91389, 0, 0, 0, 0, 386, 90);
INSERT INTO public.who_global_data VALUES (91390, 0, 0, 0, 0, 386, 70);
INSERT INTO public.who_global_data VALUES (91391, 0, 0, 0, 0, 386, 46);
INSERT INTO public.who_global_data VALUES (91392, 0, 0, 0, 0, 386, 139);
INSERT INTO public.who_global_data VALUES (91393, 0, 0, 0, 0, 386, 42);
INSERT INTO public.who_global_data VALUES (91394, 0, 0, 0, 0, 386, 80);
INSERT INTO public.who_global_data VALUES (91395, 0, 0, 0, 0, 386, 203);
INSERT INTO public.who_global_data VALUES (91396, 0, 0, 0, 0, 386, 136);
INSERT INTO public.who_global_data VALUES (91397, 0, 0, 0, 0, 386, 63);
INSERT INTO public.who_global_data VALUES (91398, 0, 0, 0, 0, 386, 17);
INSERT INTO public.who_global_data VALUES (91399, 0, 0, 0, 0, 386, 172);
INSERT INTO public.who_global_data VALUES (91400, 0, 0, 0, 0, 386, 109);
INSERT INTO public.who_global_data VALUES (91401, 0, 0, 0, 0, 386, 200);
INSERT INTO public.who_global_data VALUES (91402, 0, 0, 0, 0, 386, 93);
INSERT INTO public.who_global_data VALUES (91403, 0, 0, 0, 0, 386, 5);
INSERT INTO public.who_global_data VALUES (91404, 0, 0, 0, 0, 386, 214);
INSERT INTO public.who_global_data VALUES (91405, 0, 0, 0, 0, 386, 204);
INSERT INTO public.who_global_data VALUES (91406, 0, 0, 0, 0, 386, 198);
INSERT INTO public.who_global_data VALUES (91407, 0, 0, 0, 0, 386, 173);
INSERT INTO public.who_global_data VALUES (91408, 0, 0, 0, 0, 386, 229);
INSERT INTO public.who_global_data VALUES (91409, 0, 0, 0, 0, 386, 76);
INSERT INTO public.who_global_data VALUES (91410, 0, 0, 0, 0, 386, 138);
INSERT INTO public.who_global_data VALUES (91411, 0, 0, 0, 0, 386, 98);
INSERT INTO public.who_global_data VALUES (91412, 0, 0, 0, 0, 386, 103);
INSERT INTO public.who_global_data VALUES (91413, 0, 0, 0, 0, 386, 225);
INSERT INTO public.who_global_data VALUES (91414, 0, 0, 0, 0, 386, 131);
INSERT INTO public.who_global_data VALUES (91415, 0, 0, 0, 0, 386, 235);
INSERT INTO public.who_global_data VALUES (91416, 0, 0, 0, 0, 386, 137);
INSERT INTO public.who_global_data VALUES (91417, 0, 0, 0, 0, 386, 81);
INSERT INTO public.who_global_data VALUES (91418, 0, 0, 0, 0, 386, 182);
INSERT INTO public.who_global_data VALUES (91419, 0, 0, 0, 0, 386, 145);
INSERT INTO public.who_global_data VALUES (91420, 0, 0, 0, 0, 386, 26);
INSERT INTO public.who_global_data VALUES (91421, 0, 0, 0, 0, 386, 170);
INSERT INTO public.who_global_data VALUES (91422, 0, 0, 0, 0, 386, 191);
INSERT INTO public.who_global_data VALUES (91423, 0, 0, 0, 0, 386, 221);
INSERT INTO public.who_global_data VALUES (91424, 0, 0, 0, 0, 386, 64);
INSERT INTO public.who_global_data VALUES (91425, 0, 0, 0, 0, 386, 116);
INSERT INTO public.who_global_data VALUES (91426, 0, 0, 0, 0, 386, 128);
INSERT INTO public.who_global_data VALUES (91427, 0, 0, 0, 0, 386, 6);
INSERT INTO public.who_global_data VALUES (91428, 0, 0, 0, 0, 386, 227);
INSERT INTO public.who_global_data VALUES (91429, 0, 0, 0, 0, 386, 68);
INSERT INTO public.who_global_data VALUES (91430, 0, 0, 0, 0, 386, 184);
INSERT INTO public.who_global_data VALUES (91431, 0, 0, 0, 0, 386, 82);
INSERT INTO public.who_global_data VALUES (91432, 0, 0, 0, 0, 386, 149);
INSERT INTO public.who_global_data VALUES (91433, 0, 0, 0, 0, 386, 197);
INSERT INTO public.who_global_data VALUES (91434, 0, 0, 0, 0, 386, 78);
INSERT INTO public.who_global_data VALUES (91435, 0, 0, 0, 0, 386, 233);
INSERT INTO public.who_global_data VALUES (91436, 0, 0, 0, 0, 386, 133);
INSERT INTO public.who_global_data VALUES (91437, 0, 0, 0, 0, 386, 35);
INSERT INTO public.who_global_data VALUES (91438, 0, 0, 0, 0, 386, 114);
INSERT INTO public.who_global_data VALUES (91439, 0, 0, 0, 0, 386, 237);
INSERT INTO public.who_global_data VALUES (91440, 0, 0, 0, 0, 386, 55);
INSERT INTO public.who_global_data VALUES (91441, 0, 0, 0, 0, 386, 176);
INSERT INTO public.who_global_data VALUES (91442, 0, 0, 0, 0, 386, 202);
INSERT INTO public.who_global_data VALUES (91443, 0, 0, 0, 0, 386, 155);
INSERT INTO public.who_global_data VALUES (91444, 0, 0, 0, 0, 386, 32);
INSERT INTO public.who_global_data VALUES (91445, 0, 0, 0, 0, 386, 220);
INSERT INTO public.who_global_data VALUES (91446, 0, 0, 0, 0, 386, 30);
INSERT INTO public.who_global_data VALUES (91447, 0, 0, 0, 0, 386, 147);
INSERT INTO public.who_global_data VALUES (91448, 0, 0, 0, 0, 386, 208);
INSERT INTO public.who_global_data VALUES (91449, 0, 0, 0, 0, 386, 45);
INSERT INTO public.who_global_data VALUES (91450, 0, 0, 0, 0, 386, 110);
INSERT INTO public.who_global_data VALUES (91451, 0, 0, 0, 0, 386, 88);
INSERT INTO public.who_global_data VALUES (91452, 0, 0, 0, 0, 386, 51);
INSERT INTO public.who_global_data VALUES (91453, 0, 0, 0, 0, 386, 209);
INSERT INTO public.who_global_data VALUES (91454, 0, 0, 0, 0, 386, 205);
INSERT INTO public.who_global_data VALUES (91455, 0, 0, 0, 0, 386, 18);
INSERT INTO public.who_global_data VALUES (91456, 1, 6, 0, 0, 386, 72);
INSERT INTO public.who_global_data VALUES (91457, 0, 0, 0, 0, 386, 44);
INSERT INTO public.who_global_data VALUES (91458, 0, 0, 0, 0, 386, 15);
INSERT INTO public.who_global_data VALUES (91459, 0, 0, 0, 0, 386, 25);
INSERT INTO public.who_global_data VALUES (91460, 0, 0, 0, 0, 386, 179);
INSERT INTO public.who_global_data VALUES (91461, 0, 0, 0, 0, 386, 34);
INSERT INTO public.who_global_data VALUES (91462, 0, 0, 0, 0, 386, 207);
INSERT INTO public.who_global_data VALUES (91463, 0, 0, 0, 0, 386, 166);
INSERT INTO public.who_global_data VALUES (91464, 0, 0, 0, 0, 386, 126);
INSERT INTO public.who_global_data VALUES (91465, 0, 0, 0, 0, 386, 97);
INSERT INTO public.who_global_data VALUES (91466, 0, 0, 0, 0, 386, 36);
INSERT INTO public.who_global_data VALUES (91467, 0, 0, 0, 0, 386, 125);
INSERT INTO public.who_global_data VALUES (91468, 0, 0, 0, 0, 386, 124);
INSERT INTO public.who_global_data VALUES (91469, 0, 0, 0, 0, 386, 185);
INSERT INTO public.who_global_data VALUES (91470, 0, 0, 0, 0, 386, 194);
INSERT INTO public.who_global_data VALUES (91471, 0, 0, 0, 0, 386, 144);
INSERT INTO public.who_global_data VALUES (91472, 0, 0, 0, 0, 386, 19);
INSERT INTO public.who_global_data VALUES (91473, 0, 0, 0, 0, 386, 217);
INSERT INTO public.who_global_data VALUES (91474, 0, 0, 0, 0, 386, 148);
INSERT INTO public.who_global_data VALUES (91475, 0, 0, 0, 0, 386, 86);
INSERT INTO public.who_global_data VALUES (91476, 0, 0, 0, 0, 386, 13);
INSERT INTO public.who_global_data VALUES (91477, 0, 0, 0, 0, 386, 157);
INSERT INTO public.who_global_data VALUES (91478, 0, 0, 0, 0, 386, 8);
INSERT INTO public.who_global_data VALUES (91479, 0, 0, 0, 0, 386, 73);
INSERT INTO public.who_global_data VALUES (91480, 0, 0, 0, 0, 386, 101);
INSERT INTO public.who_global_data VALUES (91481, 0, 0, 0, 0, 386, 165);
INSERT INTO public.who_global_data VALUES (91482, 0, 0, 0, 0, 386, 14);
INSERT INTO public.who_global_data VALUES (91483, 0, 0, 0, 0, 387, 193);
INSERT INTO public.who_global_data VALUES (91484, 0, 0, 0, 0, 387, 113);
INSERT INTO public.who_global_data VALUES (91485, 0, 0, 0, 0, 387, 143);
INSERT INTO public.who_global_data VALUES (91486, 0, 0, 0, 0, 387, 219);
INSERT INTO public.who_global_data VALUES (91487, 0, 0, 0, 0, 387, 186);
INSERT INTO public.who_global_data VALUES (91488, 0, 0, 0, 0, 387, 52);
INSERT INTO public.who_global_data VALUES (91489, 0, 0, 0, 0, 387, 180);
INSERT INTO public.who_global_data VALUES (91490, 0, 0, 0, 0, 387, 167);
INSERT INTO public.who_global_data VALUES (91491, 0, 0, 0, 0, 387, 154);
INSERT INTO public.who_global_data VALUES (91492, 0, 0, 0, 0, 387, 94);
INSERT INTO public.who_global_data VALUES (91493, 0, 0, 0, 0, 387, 66);
INSERT INTO public.who_global_data VALUES (91494, 0, 0, 0, 0, 387, 58);
INSERT INTO public.who_global_data VALUES (91495, 0, 0, 0, 0, 387, 163);
INSERT INTO public.who_global_data VALUES (91496, 0, 0, 0, 0, 387, 37);
INSERT INTO public.who_global_data VALUES (91497, 0, 0, 0, 0, 387, 142);
INSERT INTO public.who_global_data VALUES (91498, 0, 0, 0, 0, 387, 83);
INSERT INTO public.who_global_data VALUES (91499, 0, 0, 0, 0, 387, 228);
INSERT INTO public.who_global_data VALUES (91500, 0, 0, 0, 0, 387, 188);
INSERT INTO public.who_global_data VALUES (91501, 0, 0, 0, 0, 387, 62);
INSERT INTO public.who_global_data VALUES (91502, 0, 0, 0, 0, 387, 160);
INSERT INTO public.who_global_data VALUES (91503, 0, 0, 0, 0, 387, 50);
INSERT INTO public.who_global_data VALUES (91504, 0, 0, 0, 0, 387, 33);
INSERT INTO public.who_global_data VALUES (91505, 0, 0, 0, 0, 387, 183);
INSERT INTO public.who_global_data VALUES (91506, 0, 0, 0, 0, 387, 92);
INSERT INTO public.who_global_data VALUES (91507, 0, 0, 0, 0, 387, 158);
INSERT INTO public.who_global_data VALUES (91508, 0, 0, 0, 0, 387, 67);
INSERT INTO public.who_global_data VALUES (91509, 0, 0, 0, 0, 387, 57);
INSERT INTO public.who_global_data VALUES (91510, 0, 0, 0, 0, 387, 38);
INSERT INTO public.who_global_data VALUES (91511, 0, 0, 0, 0, 387, 141);
INSERT INTO public.who_global_data VALUES (91512, 0, 0, 0, 0, 387, 178);
INSERT INTO public.who_global_data VALUES (91513, 0, 0, 0, 0, 387, 108);
INSERT INTO public.who_global_data VALUES (91514, 0, 0, 0, 0, 387, 39);
INSERT INTO public.who_global_data VALUES (91515, 0, 0, 0, 0, 387, 2);
INSERT INTO public.who_global_data VALUES (91516, 0, 0, 0, 0, 387, 195);
INSERT INTO public.who_global_data VALUES (91517, 0, 0, 0, 0, 387, 107);
INSERT INTO public.who_global_data VALUES (91518, 0, 0, 0, 0, 387, 161);
INSERT INTO public.who_global_data VALUES (91519, 0, 0, 0, 0, 387, 212);
INSERT INTO public.who_global_data VALUES (91520, 0, 0, 0, 0, 387, 181);
INSERT INTO public.who_global_data VALUES (91521, 0, 0, 0, 0, 387, 53);
INSERT INTO public.who_global_data VALUES (91522, 0, 0, 0, 0, 387, 164);
INSERT INTO public.who_global_data VALUES (91523, 0, 0, 0, 0, 387, 140);
INSERT INTO public.who_global_data VALUES (91524, 0, 0, 0, 0, 387, 20);
INSERT INTO public.who_global_data VALUES (91525, 0, 45, 0, 1, 387, 112);
INSERT INTO public.who_global_data VALUES (91526, 0, 0, 0, 0, 387, 111);
INSERT INTO public.who_global_data VALUES (91527, 0, 0, 0, 0, 387, 71);
INSERT INTO public.who_global_data VALUES (91528, 0, 0, 0, 0, 387, 218);
INSERT INTO public.who_global_data VALUES (91529, 0, 0, 0, 0, 387, 43);
INSERT INTO public.who_global_data VALUES (91530, 0, 0, 0, 0, 387, 49);
INSERT INTO public.who_global_data VALUES (91531, 0, 0, 0, 0, 387, 1);
INSERT INTO public.who_global_data VALUES (91532, 0, 0, 0, 0, 387, 48);
INSERT INTO public.who_global_data VALUES (91533, 0, 0, 0, 0, 387, 232);
INSERT INTO public.who_global_data VALUES (91534, 0, 0, 0, 0, 387, 175);
INSERT INTO public.who_global_data VALUES (91535, 0, 0, 0, 0, 387, 21);
INSERT INTO public.who_global_data VALUES (91536, 0, 0, 0, 0, 387, 156);
INSERT INTO public.who_global_data VALUES (91537, 0, 0, 0, 0, 387, 95);
INSERT INTO public.who_global_data VALUES (91538, 0, 0, 0, 0, 387, 177);
INSERT INTO public.who_global_data VALUES (91539, 0, 0, 0, 0, 387, 210);
INSERT INTO public.who_global_data VALUES (91540, 0, 0, 0, 0, 387, 120);
INSERT INTO public.who_global_data VALUES (91541, 0, 0, 0, 0, 387, 135);
INSERT INTO public.who_global_data VALUES (91542, 0, 0, 0, 0, 387, 206);
INSERT INTO public.who_global_data VALUES (91543, 0, 0, 0, 0, 387, 189);
INSERT INTO public.who_global_data VALUES (91544, 0, 0, 0, 0, 387, 129);
INSERT INTO public.who_global_data VALUES (91545, 0, 0, 0, 0, 387, 121);
INSERT INTO public.who_global_data VALUES (91546, 0, 0, 0, 0, 387, 59);
INSERT INTO public.who_global_data VALUES (91547, 0, 0, 0, 0, 387, 96);
INSERT INTO public.who_global_data VALUES (91548, 0, 0, 0, 0, 387, 41);
INSERT INTO public.who_global_data VALUES (91549, 0, 0, 0, 0, 387, 216);
INSERT INTO public.who_global_data VALUES (91550, 0, 0, 0, 0, 387, 236);
INSERT INTO public.who_global_data VALUES (91551, 0, 0, 0, 0, 387, 150);
INSERT INTO public.who_global_data VALUES (91552, 0, 0, 0, 0, 387, 61);
INSERT INTO public.who_global_data VALUES (91553, 0, 0, 0, 0, 387, 7);
INSERT INTO public.who_global_data VALUES (91554, 0, 0, 0, 0, 387, 169);
INSERT INTO public.who_global_data VALUES (91555, 0, 0, 0, 0, 387, 28);
INSERT INTO public.who_global_data VALUES (91556, 0, 0, 0, 0, 387, 85);
INSERT INTO public.who_global_data VALUES (91557, 0, 0, 0, 0, 387, 211);
INSERT INTO public.who_global_data VALUES (91558, 0, 0, 0, 0, 387, 60);
INSERT INTO public.who_global_data VALUES (91559, 0, 0, 0, 0, 387, 3);
INSERT INTO public.who_global_data VALUES (91560, 0, 0, 0, 0, 387, 11);
INSERT INTO public.who_global_data VALUES (91561, 0, 0, 0, 0, 387, 89);
INSERT INTO public.who_global_data VALUES (91562, 0, 0, 0, 0, 387, 24);
INSERT INTO public.who_global_data VALUES (91563, 0, 0, 0, 0, 387, 162);
INSERT INTO public.who_global_data VALUES (91564, 0, 0, 0, 0, 387, 100);
INSERT INTO public.who_global_data VALUES (91565, 0, 0, 0, 0, 387, 47);
INSERT INTO public.who_global_data VALUES (91566, 0, 0, 0, 0, 387, 29);
INSERT INTO public.who_global_data VALUES (91567, 0, 0, 0, 0, 387, 40);
INSERT INTO public.who_global_data VALUES (91568, 0, 0, 0, 0, 387, 222);
INSERT INTO public.who_global_data VALUES (91569, 0, 0, 0, 0, 387, 132);
INSERT INTO public.who_global_data VALUES (91570, 0, 0, 0, 0, 387, 130);
INSERT INTO public.who_global_data VALUES (91571, 0, 0, 0, 0, 387, 234);
INSERT INTO public.who_global_data VALUES (91572, 0, 0, 0, 0, 387, 23);
INSERT INTO public.who_global_data VALUES (91573, 0, 0, 0, 0, 387, 192);
INSERT INTO public.who_global_data VALUES (91574, 0, 0, 0, 0, 387, 69);
INSERT INTO public.who_global_data VALUES (91575, 0, 0, 0, 0, 387, 187);
INSERT INTO public.who_global_data VALUES (91576, 0, 0, 0, 0, 387, 230);
INSERT INTO public.who_global_data VALUES (91577, 0, 0, 0, 0, 387, 77);
INSERT INTO public.who_global_data VALUES (91578, 0, 0, 0, 0, 387, 9);
INSERT INTO public.who_global_data VALUES (91579, 0, 0, 0, 0, 387, 74);
INSERT INTO public.who_global_data VALUES (91580, 0, 0, 0, 0, 387, 224);
INSERT INTO public.who_global_data VALUES (91581, 0, 0, 0, 0, 387, 199);
INSERT INTO public.who_global_data VALUES (91582, 0, 0, 0, 0, 387, 190);
INSERT INTO public.who_global_data VALUES (91583, 0, 0, 0, 0, 387, 12);
INSERT INTO public.who_global_data VALUES (91584, 0, 0, 0, 0, 387, 104);
INSERT INTO public.who_global_data VALUES (91585, 0, 0, 0, 0, 387, 153);
INSERT INTO public.who_global_data VALUES (91586, 0, 0, 0, 0, 387, 91);
INSERT INTO public.who_global_data VALUES (91587, 0, 0, 0, 0, 387, 215);
INSERT INTO public.who_global_data VALUES (91588, 0, 1, 0, 0, 387, 84);
INSERT INTO public.who_global_data VALUES (91589, 0, 0, 0, 0, 387, 231);
INSERT INTO public.who_global_data VALUES (91590, 0, 0, 0, 0, 387, 196);
INSERT INTO public.who_global_data VALUES (91591, 0, 0, 0, 0, 387, 105);
INSERT INTO public.who_global_data VALUES (91592, 0, 0, 0, 0, 387, 122);
INSERT INTO public.who_global_data VALUES (91593, 0, 0, 0, 0, 387, 159);
INSERT INTO public.who_global_data VALUES (91594, 0, 0, 0, 0, 387, 75);
INSERT INTO public.who_global_data VALUES (91595, 0, 0, 0, 0, 387, 27);
INSERT INTO public.who_global_data VALUES (91596, 0, 0, 0, 0, 387, 54);
INSERT INTO public.who_global_data VALUES (91597, 0, 0, 0, 0, 387, 226);
INSERT INTO public.who_global_data VALUES (91598, 0, 0, 0, 0, 387, 79);
INSERT INTO public.who_global_data VALUES (91599, 0, 0, 0, 0, 387, 56);
INSERT INTO public.who_global_data VALUES (91600, 0, 0, 0, 0, 387, 117);
INSERT INTO public.who_global_data VALUES (91601, 0, 0, 0, 0, 387, 152);
INSERT INTO public.who_global_data VALUES (91602, 0, 0, 0, 0, 387, 16);
INSERT INTO public.who_global_data VALUES (91603, 0, 0, 0, 0, 387, 10);
INSERT INTO public.who_global_data VALUES (91604, 0, 0, 0, 0, 387, 201);
INSERT INTO public.who_global_data VALUES (91605, 0, 0, 0, 0, 387, 174);
INSERT INTO public.who_global_data VALUES (91606, 0, 0, 0, 0, 387, 119);
INSERT INTO public.who_global_data VALUES (91607, 0, 0, 0, 0, 387, 168);
INSERT INTO public.who_global_data VALUES (91608, 0, 0, 0, 0, 387, 99);
INSERT INTO public.who_global_data VALUES (91609, 0, 0, 0, 0, 387, 171);
INSERT INTO public.who_global_data VALUES (91610, 0, 0, 0, 0, 387, 87);
INSERT INTO public.who_global_data VALUES (91611, 0, 0, 0, 0, 387, 123);
INSERT INTO public.who_global_data VALUES (91612, 0, 0, 0, 0, 387, 151);
INSERT INTO public.who_global_data VALUES (91613, 0, 0, 0, 0, 387, 213);
INSERT INTO public.who_global_data VALUES (91614, 0, 0, 0, 0, 387, 118);
INSERT INTO public.who_global_data VALUES (91615, 0, 0, 0, 0, 387, 134);
INSERT INTO public.who_global_data VALUES (91616, 0, 0, 0, 0, 387, 65);
INSERT INTO public.who_global_data VALUES (91617, 0, 0, 0, 0, 387, 102);
INSERT INTO public.who_global_data VALUES (91618, 0, 0, 0, 0, 387, 223);
INSERT INTO public.who_global_data VALUES (91619, 0, 0, 0, 0, 387, 4);
INSERT INTO public.who_global_data VALUES (91620, 0, 0, 0, 0, 387, 146);
INSERT INTO public.who_global_data VALUES (91621, 0, 0, 0, 0, 387, 31);
INSERT INTO public.who_global_data VALUES (91622, 0, 0, 0, 0, 387, 127);
INSERT INTO public.who_global_data VALUES (91623, 0, 0, 0, 0, 387, 22);
INSERT INTO public.who_global_data VALUES (91624, 0, 0, 0, 0, 387, 115);
INSERT INTO public.who_global_data VALUES (91625, 0, 0, 0, 0, 387, 106);
INSERT INTO public.who_global_data VALUES (91626, 0, 0, 0, 0, 387, 90);
INSERT INTO public.who_global_data VALUES (91627, 0, 0, 0, 0, 387, 70);
INSERT INTO public.who_global_data VALUES (91628, 0, 0, 0, 0, 387, 46);
INSERT INTO public.who_global_data VALUES (91629, 0, 0, 0, 0, 387, 139);
INSERT INTO public.who_global_data VALUES (91630, 0, 0, 0, 0, 387, 42);
INSERT INTO public.who_global_data VALUES (91631, 0, 0, 0, 0, 387, 80);
INSERT INTO public.who_global_data VALUES (91632, 0, 0, 0, 0, 387, 203);
INSERT INTO public.who_global_data VALUES (91633, 0, 0, 0, 0, 387, 136);
INSERT INTO public.who_global_data VALUES (91634, 0, 0, 0, 0, 387, 63);
INSERT INTO public.who_global_data VALUES (91635, 0, 0, 0, 0, 387, 17);
INSERT INTO public.who_global_data VALUES (91636, 0, 0, 0, 0, 387, 172);
INSERT INTO public.who_global_data VALUES (91637, 0, 0, 0, 0, 387, 109);
INSERT INTO public.who_global_data VALUES (91638, 0, 0, 0, 0, 387, 200);
INSERT INTO public.who_global_data VALUES (91639, 0, 0, 0, 0, 387, 93);
INSERT INTO public.who_global_data VALUES (91640, 0, 0, 0, 0, 387, 5);
INSERT INTO public.who_global_data VALUES (91641, 0, 0, 0, 0, 387, 214);
INSERT INTO public.who_global_data VALUES (91642, 0, 0, 0, 0, 387, 204);
INSERT INTO public.who_global_data VALUES (91643, 0, 0, 0, 0, 387, 198);
INSERT INTO public.who_global_data VALUES (91644, 0, 0, 0, 0, 387, 173);
INSERT INTO public.who_global_data VALUES (91645, 0, 0, 0, 0, 387, 229);
INSERT INTO public.who_global_data VALUES (91646, 0, 0, 0, 0, 387, 76);
INSERT INTO public.who_global_data VALUES (91647, 0, 0, 0, 0, 387, 138);
INSERT INTO public.who_global_data VALUES (91648, 0, 0, 0, 0, 387, 98);
INSERT INTO public.who_global_data VALUES (91649, 0, 0, 0, 0, 387, 103);
INSERT INTO public.who_global_data VALUES (91650, 0, 0, 0, 0, 387, 225);
INSERT INTO public.who_global_data VALUES (91651, 0, 0, 0, 0, 387, 131);
INSERT INTO public.who_global_data VALUES (91652, 0, 0, 0, 0, 387, 235);
INSERT INTO public.who_global_data VALUES (91653, 0, 0, 0, 0, 387, 137);
INSERT INTO public.who_global_data VALUES (91654, 0, 0, 0, 0, 387, 81);
INSERT INTO public.who_global_data VALUES (91655, 0, 0, 0, 0, 387, 182);
INSERT INTO public.who_global_data VALUES (91656, 0, 0, 0, 0, 387, 145);
INSERT INTO public.who_global_data VALUES (91657, 0, 0, 0, 0, 387, 26);
INSERT INTO public.who_global_data VALUES (91658, 0, 0, 0, 0, 387, 170);
INSERT INTO public.who_global_data VALUES (91659, 0, 0, 0, 0, 387, 191);
INSERT INTO public.who_global_data VALUES (91660, 0, 0, 0, 0, 387, 221);
INSERT INTO public.who_global_data VALUES (91661, 0, 0, 0, 0, 387, 64);
INSERT INTO public.who_global_data VALUES (91662, 0, 0, 0, 0, 387, 116);
INSERT INTO public.who_global_data VALUES (91663, 0, 0, 0, 0, 387, 128);
INSERT INTO public.who_global_data VALUES (91664, 0, 0, 0, 0, 387, 6);
INSERT INTO public.who_global_data VALUES (91665, 0, 0, 0, 0, 387, 227);
INSERT INTO public.who_global_data VALUES (91666, 0, 0, 0, 0, 387, 68);
INSERT INTO public.who_global_data VALUES (91667, 0, 0, 0, 0, 387, 184);
INSERT INTO public.who_global_data VALUES (91668, 0, 0, 0, 0, 387, 82);
INSERT INTO public.who_global_data VALUES (91669, 0, 0, 0, 0, 387, 149);
INSERT INTO public.who_global_data VALUES (91670, 0, 0, 0, 0, 387, 197);
INSERT INTO public.who_global_data VALUES (91671, 0, 0, 0, 0, 387, 78);
INSERT INTO public.who_global_data VALUES (91672, 0, 0, 0, 0, 387, 233);
INSERT INTO public.who_global_data VALUES (91673, 0, 0, 0, 0, 387, 133);
INSERT INTO public.who_global_data VALUES (91674, 0, 0, 0, 0, 387, 35);
INSERT INTO public.who_global_data VALUES (91675, 0, 0, 0, 0, 387, 114);
INSERT INTO public.who_global_data VALUES (91676, 0, 0, 0, 0, 387, 237);
INSERT INTO public.who_global_data VALUES (91677, 0, 0, 0, 0, 387, 55);
INSERT INTO public.who_global_data VALUES (91678, 0, 0, 0, 0, 387, 176);
INSERT INTO public.who_global_data VALUES (91679, 0, 0, 0, 0, 387, 202);
INSERT INTO public.who_global_data VALUES (91680, 0, 0, 0, 0, 387, 155);
INSERT INTO public.who_global_data VALUES (91681, 0, 0, 0, 0, 387, 32);
INSERT INTO public.who_global_data VALUES (91682, 0, 0, 0, 0, 387, 220);
INSERT INTO public.who_global_data VALUES (91683, 0, 0, 0, 0, 387, 30);
INSERT INTO public.who_global_data VALUES (91684, 0, 0, 0, 0, 387, 147);
INSERT INTO public.who_global_data VALUES (91685, 0, 0, 0, 0, 387, 208);
INSERT INTO public.who_global_data VALUES (91686, 0, 0, 0, 0, 387, 45);
INSERT INTO public.who_global_data VALUES (91687, 0, 0, 0, 0, 387, 110);
INSERT INTO public.who_global_data VALUES (91688, 0, 0, 0, 0, 387, 88);
INSERT INTO public.who_global_data VALUES (91689, 0, 0, 0, 0, 387, 51);
INSERT INTO public.who_global_data VALUES (91690, 0, 0, 0, 0, 387, 209);
INSERT INTO public.who_global_data VALUES (91691, 0, 0, 0, 0, 387, 205);
INSERT INTO public.who_global_data VALUES (91692, 0, 0, 0, 0, 387, 18);
INSERT INTO public.who_global_data VALUES (91693, 0, 5, 0, 0, 387, 72);
INSERT INTO public.who_global_data VALUES (91694, 0, 0, 0, 0, 387, 44);
INSERT INTO public.who_global_data VALUES (91695, 0, 0, 0, 0, 387, 15);
INSERT INTO public.who_global_data VALUES (91696, 0, 0, 0, 0, 387, 25);
INSERT INTO public.who_global_data VALUES (91697, 0, 0, 0, 0, 387, 179);
INSERT INTO public.who_global_data VALUES (91698, 0, 0, 0, 0, 387, 34);
INSERT INTO public.who_global_data VALUES (91699, 0, 0, 0, 0, 387, 207);
INSERT INTO public.who_global_data VALUES (91700, 0, 0, 0, 0, 387, 166);
INSERT INTO public.who_global_data VALUES (91701, 0, 0, 0, 0, 387, 126);
INSERT INTO public.who_global_data VALUES (91702, 0, 0, 0, 0, 387, 97);
INSERT INTO public.who_global_data VALUES (91703, 0, 0, 0, 0, 387, 36);
INSERT INTO public.who_global_data VALUES (91704, 0, 0, 0, 0, 387, 125);
INSERT INTO public.who_global_data VALUES (91705, 0, 0, 0, 0, 387, 124);
INSERT INTO public.who_global_data VALUES (91706, 0, 0, 0, 0, 387, 185);
INSERT INTO public.who_global_data VALUES (91707, 0, 0, 0, 0, 387, 194);
INSERT INTO public.who_global_data VALUES (91708, 0, 0, 0, 0, 387, 144);
INSERT INTO public.who_global_data VALUES (91709, 0, 0, 0, 0, 387, 19);
INSERT INTO public.who_global_data VALUES (91710, 0, 0, 0, 0, 387, 217);
INSERT INTO public.who_global_data VALUES (91711, 0, 0, 0, 0, 387, 148);
INSERT INTO public.who_global_data VALUES (91712, 0, 0, 0, 0, 387, 86);
INSERT INTO public.who_global_data VALUES (91713, 0, 0, 0, 0, 387, 13);
INSERT INTO public.who_global_data VALUES (91714, 0, 0, 0, 0, 387, 157);
INSERT INTO public.who_global_data VALUES (91715, 0, 0, 0, 0, 387, 8);
INSERT INTO public.who_global_data VALUES (91716, 0, 0, 0, 0, 387, 73);
INSERT INTO public.who_global_data VALUES (91717, 0, 0, 0, 0, 387, 101);
INSERT INTO public.who_global_data VALUES (91718, 0, 0, 0, 0, 387, 165);
INSERT INTO public.who_global_data VALUES (91719, 0, 0, 0, 0, 387, 14);
INSERT INTO public.who_global_data VALUES (91720, 0, 0, 0, 0, 388, 193);
INSERT INTO public.who_global_data VALUES (91721, 0, 0, 0, 0, 388, 113);
INSERT INTO public.who_global_data VALUES (91722, 0, 0, 0, 0, 388, 143);
INSERT INTO public.who_global_data VALUES (91723, 0, 0, 0, 0, 388, 219);
INSERT INTO public.who_global_data VALUES (91724, 0, 0, 0, 0, 388, 186);
INSERT INTO public.who_global_data VALUES (91725, 0, 0, 0, 0, 388, 52);
INSERT INTO public.who_global_data VALUES (91726, 0, 0, 0, 0, 388, 180);
INSERT INTO public.who_global_data VALUES (91727, 0, 0, 0, 0, 388, 167);
INSERT INTO public.who_global_data VALUES (91728, 0, 0, 0, 0, 388, 154);
INSERT INTO public.who_global_data VALUES (91729, 0, 0, 0, 0, 388, 94);
INSERT INTO public.who_global_data VALUES (91730, 0, 0, 0, 0, 388, 66);
INSERT INTO public.who_global_data VALUES (91731, 0, 0, 0, 0, 388, 58);
INSERT INTO public.who_global_data VALUES (91732, 0, 0, 0, 0, 388, 163);
INSERT INTO public.who_global_data VALUES (91733, 0, 0, 0, 0, 388, 37);
INSERT INTO public.who_global_data VALUES (91734, 0, 0, 0, 0, 388, 142);
INSERT INTO public.who_global_data VALUES (91735, 0, 0, 0, 0, 388, 83);
INSERT INTO public.who_global_data VALUES (91736, 0, 0, 0, 0, 388, 228);
INSERT INTO public.who_global_data VALUES (91737, 0, 0, 0, 0, 388, 188);
INSERT INTO public.who_global_data VALUES (91738, 0, 0, 0, 0, 388, 62);
INSERT INTO public.who_global_data VALUES (91739, 0, 0, 0, 0, 388, 160);
INSERT INTO public.who_global_data VALUES (91740, 0, 0, 0, 0, 388, 50);
INSERT INTO public.who_global_data VALUES (91741, 0, 0, 0, 0, 388, 33);
INSERT INTO public.who_global_data VALUES (91742, 0, 0, 0, 0, 388, 183);
INSERT INTO public.who_global_data VALUES (91743, 0, 0, 0, 0, 388, 92);
INSERT INTO public.who_global_data VALUES (91744, 0, 0, 0, 0, 388, 158);
INSERT INTO public.who_global_data VALUES (91745, 0, 0, 0, 0, 388, 67);
INSERT INTO public.who_global_data VALUES (91746, 0, 0, 0, 0, 388, 57);
INSERT INTO public.who_global_data VALUES (91747, 0, 0, 0, 0, 388, 38);
INSERT INTO public.who_global_data VALUES (91748, 0, 0, 0, 0, 388, 141);
INSERT INTO public.who_global_data VALUES (91749, 0, 0, 0, 0, 388, 178);
INSERT INTO public.who_global_data VALUES (91750, 0, 0, 0, 0, 388, 108);
INSERT INTO public.who_global_data VALUES (91751, 0, 0, 0, 0, 388, 39);
INSERT INTO public.who_global_data VALUES (91752, 0, 0, 0, 0, 388, 2);
INSERT INTO public.who_global_data VALUES (91753, 0, 0, 0, 0, 388, 195);
INSERT INTO public.who_global_data VALUES (91754, 0, 0, 0, 0, 388, 107);
INSERT INTO public.who_global_data VALUES (91755, 0, 0, 0, 0, 388, 161);
INSERT INTO public.who_global_data VALUES (91756, 0, 0, 0, 0, 388, 212);
INSERT INTO public.who_global_data VALUES (91757, 0, 0, 0, 0, 388, 181);
INSERT INTO public.who_global_data VALUES (91758, 0, 0, 0, 0, 388, 53);
INSERT INTO public.who_global_data VALUES (91759, 0, 0, 0, 0, 388, 164);
INSERT INTO public.who_global_data VALUES (91760, 0, 0, 0, 0, 388, 140);
INSERT INTO public.who_global_data VALUES (91761, 0, 0, 0, 0, 388, 20);
INSERT INTO public.who_global_data VALUES (91762, 0, 45, 0, 1, 388, 112);
INSERT INTO public.who_global_data VALUES (91763, 0, 0, 0, 0, 388, 111);
INSERT INTO public.who_global_data VALUES (91764, 0, 0, 0, 0, 388, 71);
INSERT INTO public.who_global_data VALUES (91765, 0, 0, 0, 0, 388, 218);
INSERT INTO public.who_global_data VALUES (91766, 0, 0, 0, 0, 388, 43);
INSERT INTO public.who_global_data VALUES (91767, 0, 0, 0, 0, 388, 49);
INSERT INTO public.who_global_data VALUES (91768, 0, 0, 0, 0, 388, 1);
INSERT INTO public.who_global_data VALUES (91769, 0, 0, 0, 0, 388, 48);
INSERT INTO public.who_global_data VALUES (91770, 0, 0, 0, 0, 388, 232);
INSERT INTO public.who_global_data VALUES (91771, 0, 0, 0, 0, 388, 175);
INSERT INTO public.who_global_data VALUES (91772, 0, 0, 0, 0, 388, 21);
INSERT INTO public.who_global_data VALUES (91773, 0, 0, 0, 0, 388, 156);
INSERT INTO public.who_global_data VALUES (91774, 0, 0, 0, 0, 388, 95);
INSERT INTO public.who_global_data VALUES (91775, 0, 0, 0, 0, 388, 177);
INSERT INTO public.who_global_data VALUES (91776, 0, 0, 0, 0, 388, 210);
INSERT INTO public.who_global_data VALUES (91777, 0, 0, 0, 0, 388, 120);
INSERT INTO public.who_global_data VALUES (91778, 0, 0, 0, 0, 388, 135);
INSERT INTO public.who_global_data VALUES (91779, 0, 0, 0, 0, 388, 206);
INSERT INTO public.who_global_data VALUES (91780, 0, 0, 0, 0, 388, 189);
INSERT INTO public.who_global_data VALUES (91781, 0, 0, 0, 0, 388, 129);
INSERT INTO public.who_global_data VALUES (91782, 0, 0, 0, 0, 388, 121);
INSERT INTO public.who_global_data VALUES (91783, 0, 0, 0, 0, 388, 59);
INSERT INTO public.who_global_data VALUES (91784, 0, 0, 0, 0, 388, 96);
INSERT INTO public.who_global_data VALUES (91785, 0, 0, 0, 0, 388, 41);
INSERT INTO public.who_global_data VALUES (91786, 0, 0, 0, 0, 388, 216);
INSERT INTO public.who_global_data VALUES (91787, 0, 0, 0, 0, 388, 236);
INSERT INTO public.who_global_data VALUES (91788, 0, 0, 0, 0, 388, 150);
INSERT INTO public.who_global_data VALUES (91789, 0, 0, 0, 0, 388, 61);
INSERT INTO public.who_global_data VALUES (91790, 0, 0, 0, 0, 388, 7);
INSERT INTO public.who_global_data VALUES (91791, 0, 0, 0, 0, 388, 169);
INSERT INTO public.who_global_data VALUES (91792, 0, 0, 0, 0, 388, 28);
INSERT INTO public.who_global_data VALUES (91793, 0, 0, 0, 0, 388, 85);
INSERT INTO public.who_global_data VALUES (91794, 0, 0, 0, 0, 388, 211);
INSERT INTO public.who_global_data VALUES (91795, 0, 0, 0, 0, 388, 60);
INSERT INTO public.who_global_data VALUES (91796, 0, 0, 0, 0, 388, 3);
INSERT INTO public.who_global_data VALUES (91797, 0, 0, 0, 0, 388, 11);
INSERT INTO public.who_global_data VALUES (91798, 0, 0, 0, 0, 388, 89);
INSERT INTO public.who_global_data VALUES (91799, 0, 0, 0, 0, 388, 24);
INSERT INTO public.who_global_data VALUES (91800, 0, 0, 0, 0, 388, 162);
INSERT INTO public.who_global_data VALUES (91801, 0, 0, 0, 0, 388, 100);
INSERT INTO public.who_global_data VALUES (91802, 0, 0, 0, 0, 388, 47);
INSERT INTO public.who_global_data VALUES (91803, 0, 0, 0, 0, 388, 29);
INSERT INTO public.who_global_data VALUES (91804, 0, 0, 0, 0, 388, 40);
INSERT INTO public.who_global_data VALUES (91805, 0, 0, 0, 0, 388, 222);
INSERT INTO public.who_global_data VALUES (91806, 0, 0, 0, 0, 388, 132);
INSERT INTO public.who_global_data VALUES (91807, 0, 0, 0, 0, 388, 130);
INSERT INTO public.who_global_data VALUES (91808, 0, 0, 0, 0, 388, 234);
INSERT INTO public.who_global_data VALUES (91809, 0, 0, 0, 0, 388, 23);
INSERT INTO public.who_global_data VALUES (91810, 0, 0, 0, 0, 388, 192);
INSERT INTO public.who_global_data VALUES (91811, 0, 0, 0, 0, 388, 69);
INSERT INTO public.who_global_data VALUES (91812, 0, 0, 0, 0, 388, 187);
INSERT INTO public.who_global_data VALUES (91813, 0, 0, 0, 0, 388, 230);
INSERT INTO public.who_global_data VALUES (91814, 0, 0, 0, 0, 388, 77);
INSERT INTO public.who_global_data VALUES (91815, 0, 0, 0, 0, 388, 9);
INSERT INTO public.who_global_data VALUES (91816, 0, 0, 0, 0, 388, 74);
INSERT INTO public.who_global_data VALUES (91817, 0, 0, 0, 0, 388, 224);
INSERT INTO public.who_global_data VALUES (91818, 0, 0, 0, 0, 388, 199);
INSERT INTO public.who_global_data VALUES (91819, 0, 0, 0, 0, 388, 190);
INSERT INTO public.who_global_data VALUES (91820, 0, 0, 0, 0, 388, 12);
INSERT INTO public.who_global_data VALUES (91821, 0, 0, 0, 0, 388, 104);
INSERT INTO public.who_global_data VALUES (91822, 0, 0, 0, 0, 388, 153);
INSERT INTO public.who_global_data VALUES (91823, 0, 0, 0, 0, 388, 91);
INSERT INTO public.who_global_data VALUES (91824, 0, 0, 0, 0, 388, 215);
INSERT INTO public.who_global_data VALUES (91825, 0, 1, 0, 0, 388, 84);
INSERT INTO public.who_global_data VALUES (91826, 0, 0, 0, 0, 388, 231);
INSERT INTO public.who_global_data VALUES (91827, 0, 0, 0, 0, 388, 196);
INSERT INTO public.who_global_data VALUES (91828, 0, 0, 0, 0, 388, 105);
INSERT INTO public.who_global_data VALUES (91829, 0, 0, 0, 0, 388, 122);
INSERT INTO public.who_global_data VALUES (91830, 0, 0, 0, 0, 388, 159);
INSERT INTO public.who_global_data VALUES (91831, 0, 0, 0, 0, 388, 75);
INSERT INTO public.who_global_data VALUES (91832, 0, 0, 0, 0, 388, 27);
INSERT INTO public.who_global_data VALUES (91833, 0, 0, 0, 0, 388, 54);
INSERT INTO public.who_global_data VALUES (91834, 0, 0, 0, 0, 388, 226);
INSERT INTO public.who_global_data VALUES (91835, 0, 0, 0, 0, 388, 79);
INSERT INTO public.who_global_data VALUES (91836, 0, 0, 0, 0, 388, 56);
INSERT INTO public.who_global_data VALUES (91837, 0, 0, 0, 0, 388, 117);
INSERT INTO public.who_global_data VALUES (91838, 0, 0, 0, 0, 388, 152);
INSERT INTO public.who_global_data VALUES (91839, 0, 0, 0, 0, 388, 16);
INSERT INTO public.who_global_data VALUES (91840, 0, 0, 0, 0, 388, 10);
INSERT INTO public.who_global_data VALUES (91841, 0, 0, 0, 0, 388, 201);
INSERT INTO public.who_global_data VALUES (91842, 0, 0, 0, 0, 388, 174);
INSERT INTO public.who_global_data VALUES (91843, 0, 0, 0, 0, 388, 119);
INSERT INTO public.who_global_data VALUES (91844, 0, 0, 0, 0, 388, 168);
INSERT INTO public.who_global_data VALUES (91845, 0, 0, 0, 0, 388, 99);
INSERT INTO public.who_global_data VALUES (91846, 0, 0, 0, 0, 388, 171);
INSERT INTO public.who_global_data VALUES (91847, 0, 0, 0, 0, 388, 87);
INSERT INTO public.who_global_data VALUES (91848, 0, 0, 0, 0, 388, 123);
INSERT INTO public.who_global_data VALUES (91849, 0, 0, 0, 0, 388, 151);
INSERT INTO public.who_global_data VALUES (91850, 0, 0, 0, 0, 388, 213);
INSERT INTO public.who_global_data VALUES (91851, 0, 0, 0, 0, 388, 118);
INSERT INTO public.who_global_data VALUES (91852, 0, 0, 0, 0, 388, 134);
INSERT INTO public.who_global_data VALUES (91853, 0, 0, 0, 0, 388, 65);
INSERT INTO public.who_global_data VALUES (91854, 0, 0, 0, 0, 388, 102);
INSERT INTO public.who_global_data VALUES (91855, 0, 0, 0, 0, 388, 223);
INSERT INTO public.who_global_data VALUES (91856, 0, 0, 0, 0, 388, 4);
INSERT INTO public.who_global_data VALUES (91857, 0, 0, 0, 0, 388, 146);
INSERT INTO public.who_global_data VALUES (91858, 0, 0, 0, 0, 388, 31);
INSERT INTO public.who_global_data VALUES (91859, 0, 0, 0, 0, 388, 127);
INSERT INTO public.who_global_data VALUES (91860, 0, 0, 0, 0, 388, 22);
INSERT INTO public.who_global_data VALUES (91861, 0, 0, 0, 0, 388, 115);
INSERT INTO public.who_global_data VALUES (91862, 0, 0, 0, 0, 388, 106);
INSERT INTO public.who_global_data VALUES (91863, 0, 0, 0, 0, 388, 90);
INSERT INTO public.who_global_data VALUES (91864, 0, 0, 0, 0, 388, 70);
INSERT INTO public.who_global_data VALUES (91865, 0, 0, 0, 0, 388, 46);
INSERT INTO public.who_global_data VALUES (91866, 0, 0, 0, 0, 388, 139);
INSERT INTO public.who_global_data VALUES (91867, 0, 0, 0, 0, 388, 42);
INSERT INTO public.who_global_data VALUES (91868, 0, 0, 0, 0, 388, 80);
INSERT INTO public.who_global_data VALUES (91869, 0, 0, 0, 0, 388, 203);
INSERT INTO public.who_global_data VALUES (91870, 0, 0, 0, 0, 388, 136);
INSERT INTO public.who_global_data VALUES (91871, 0, 0, 0, 0, 388, 63);
INSERT INTO public.who_global_data VALUES (91872, 0, 0, 0, 0, 388, 17);
INSERT INTO public.who_global_data VALUES (91873, 0, 0, 0, 0, 388, 172);
INSERT INTO public.who_global_data VALUES (91874, 0, 0, 0, 0, 388, 109);
INSERT INTO public.who_global_data VALUES (91875, 0, 0, 0, 0, 388, 200);
INSERT INTO public.who_global_data VALUES (91876, 0, 0, 0, 0, 388, 93);
INSERT INTO public.who_global_data VALUES (91877, 0, 0, 0, 0, 388, 5);
INSERT INTO public.who_global_data VALUES (91878, 0, 0, 0, 0, 388, 214);
INSERT INTO public.who_global_data VALUES (91879, 0, 0, 0, 0, 388, 204);
INSERT INTO public.who_global_data VALUES (91880, 0, 0, 0, 0, 388, 198);
INSERT INTO public.who_global_data VALUES (91881, 0, 0, 0, 0, 388, 173);
INSERT INTO public.who_global_data VALUES (91882, 0, 0, 0, 0, 388, 229);
INSERT INTO public.who_global_data VALUES (91883, 0, 0, 0, 0, 388, 76);
INSERT INTO public.who_global_data VALUES (91884, 0, 0, 0, 0, 388, 138);
INSERT INTO public.who_global_data VALUES (91885, 0, 0, 0, 0, 388, 98);
INSERT INTO public.who_global_data VALUES (91886, 0, 0, 0, 0, 388, 103);
INSERT INTO public.who_global_data VALUES (91887, 0, 0, 0, 0, 388, 225);
INSERT INTO public.who_global_data VALUES (91888, 0, 0, 0, 0, 388, 131);
INSERT INTO public.who_global_data VALUES (91889, 0, 0, 0, 0, 388, 235);
INSERT INTO public.who_global_data VALUES (91890, 0, 0, 0, 0, 388, 137);
INSERT INTO public.who_global_data VALUES (91891, 0, 0, 0, 0, 388, 81);
INSERT INTO public.who_global_data VALUES (91892, 0, 0, 0, 0, 388, 182);
INSERT INTO public.who_global_data VALUES (91893, 0, 0, 0, 0, 388, 145);
INSERT INTO public.who_global_data VALUES (91894, 0, 0, 0, 0, 388, 26);
INSERT INTO public.who_global_data VALUES (91895, 0, 0, 0, 0, 388, 170);
INSERT INTO public.who_global_data VALUES (91896, 0, 0, 0, 0, 388, 191);
INSERT INTO public.who_global_data VALUES (91897, 0, 0, 0, 0, 388, 221);
INSERT INTO public.who_global_data VALUES (91898, 0, 0, 0, 0, 388, 64);
INSERT INTO public.who_global_data VALUES (91899, 0, 0, 0, 0, 388, 116);
INSERT INTO public.who_global_data VALUES (91900, 0, 0, 0, 0, 388, 128);
INSERT INTO public.who_global_data VALUES (91901, 0, 0, 0, 0, 388, 6);
INSERT INTO public.who_global_data VALUES (91902, 0, 0, 0, 0, 388, 227);
INSERT INTO public.who_global_data VALUES (91903, 0, 0, 0, 0, 388, 68);
INSERT INTO public.who_global_data VALUES (91904, 0, 0, 0, 0, 388, 184);
INSERT INTO public.who_global_data VALUES (91905, 0, 0, 0, 0, 388, 82);
INSERT INTO public.who_global_data VALUES (91906, 0, 0, 0, 0, 388, 149);
INSERT INTO public.who_global_data VALUES (91907, 0, 0, 0, 0, 388, 197);
INSERT INTO public.who_global_data VALUES (91908, 0, 0, 0, 0, 388, 78);
INSERT INTO public.who_global_data VALUES (91909, 0, 0, 0, 0, 388, 233);
INSERT INTO public.who_global_data VALUES (91910, 0, 0, 0, 0, 388, 133);
INSERT INTO public.who_global_data VALUES (91911, 0, 0, 0, 0, 388, 35);
INSERT INTO public.who_global_data VALUES (91912, 0, 0, 0, 0, 388, 114);
INSERT INTO public.who_global_data VALUES (91913, 0, 0, 0, 0, 388, 237);
INSERT INTO public.who_global_data VALUES (91914, 0, 0, 0, 0, 388, 55);
INSERT INTO public.who_global_data VALUES (91915, 0, 0, 0, 0, 388, 176);
INSERT INTO public.who_global_data VALUES (91916, 0, 0, 0, 0, 388, 202);
INSERT INTO public.who_global_data VALUES (91917, 0, 0, 0, 0, 388, 155);
INSERT INTO public.who_global_data VALUES (91918, 0, 0, 0, 0, 388, 32);
INSERT INTO public.who_global_data VALUES (91919, 0, 0, 0, 0, 388, 220);
INSERT INTO public.who_global_data VALUES (91920, 0, 0, 0, 0, 388, 30);
INSERT INTO public.who_global_data VALUES (91921, 0, 0, 0, 0, 388, 147);
INSERT INTO public.who_global_data VALUES (91922, 0, 0, 0, 0, 388, 208);
INSERT INTO public.who_global_data VALUES (91923, 0, 0, 0, 0, 388, 45);
INSERT INTO public.who_global_data VALUES (91924, 0, 0, 0, 0, 388, 110);
INSERT INTO public.who_global_data VALUES (91925, 0, 0, 0, 0, 388, 88);
INSERT INTO public.who_global_data VALUES (91926, 0, 0, 0, 0, 388, 51);
INSERT INTO public.who_global_data VALUES (91927, 0, 0, 0, 0, 388, 209);
INSERT INTO public.who_global_data VALUES (91928, 0, 0, 0, 0, 388, 205);
INSERT INTO public.who_global_data VALUES (91929, 0, 0, 0, 0, 388, 18);
INSERT INTO public.who_global_data VALUES (91930, 0, 5, 0, 0, 388, 72);
INSERT INTO public.who_global_data VALUES (91931, 0, 0, 0, 0, 388, 44);
INSERT INTO public.who_global_data VALUES (91932, 0, 0, 0, 0, 388, 15);
INSERT INTO public.who_global_data VALUES (91933, 0, 0, 0, 0, 388, 25);
INSERT INTO public.who_global_data VALUES (91934, 0, 0, 0, 0, 388, 179);
INSERT INTO public.who_global_data VALUES (91935, 0, 0, 0, 0, 388, 34);
INSERT INTO public.who_global_data VALUES (91936, 0, 0, 0, 0, 388, 207);
INSERT INTO public.who_global_data VALUES (91937, 0, 0, 0, 0, 388, 166);
INSERT INTO public.who_global_data VALUES (91938, 0, 0, 0, 0, 388, 126);
INSERT INTO public.who_global_data VALUES (91939, 0, 0, 0, 0, 388, 97);
INSERT INTO public.who_global_data VALUES (91940, 0, 0, 0, 0, 388, 36);
INSERT INTO public.who_global_data VALUES (91941, 0, 0, 0, 0, 388, 125);
INSERT INTO public.who_global_data VALUES (91942, 0, 0, 0, 0, 388, 124);
INSERT INTO public.who_global_data VALUES (91943, 0, 0, 0, 0, 388, 185);
INSERT INTO public.who_global_data VALUES (91944, 0, 0, 0, 0, 388, 194);
INSERT INTO public.who_global_data VALUES (91945, 0, 0, 0, 0, 388, 144);
INSERT INTO public.who_global_data VALUES (91946, 0, 0, 0, 0, 388, 19);
INSERT INTO public.who_global_data VALUES (91947, 0, 0, 0, 0, 388, 217);
INSERT INTO public.who_global_data VALUES (91948, 0, 0, 0, 0, 388, 148);
INSERT INTO public.who_global_data VALUES (91949, 0, 0, 0, 0, 388, 86);
INSERT INTO public.who_global_data VALUES (91950, 0, 0, 0, 0, 388, 13);
INSERT INTO public.who_global_data VALUES (91951, 0, 0, 0, 0, 388, 157);
INSERT INTO public.who_global_data VALUES (91952, 0, 0, 0, 0, 388, 8);
INSERT INTO public.who_global_data VALUES (91953, 0, 0, 0, 0, 388, 73);
INSERT INTO public.who_global_data VALUES (91954, 0, 0, 0, 0, 388, 101);
INSERT INTO public.who_global_data VALUES (91955, 0, 0, 0, 0, 388, 165);
INSERT INTO public.who_global_data VALUES (91956, 0, 0, 0, 0, 388, 14);
INSERT INTO public.who_global_data VALUES (91957, 0, 0, 0, 0, 389, 193);
INSERT INTO public.who_global_data VALUES (91958, 0, 0, 0, 0, 389, 113);
INSERT INTO public.who_global_data VALUES (91959, 0, 0, 0, 0, 389, 143);
INSERT INTO public.who_global_data VALUES (91960, 0, 0, 0, 0, 389, 219);
INSERT INTO public.who_global_data VALUES (91961, 0, 0, 0, 0, 389, 186);
INSERT INTO public.who_global_data VALUES (91962, 0, 0, 0, 0, 389, 52);
INSERT INTO public.who_global_data VALUES (91963, 0, 0, 0, 0, 389, 180);
INSERT INTO public.who_global_data VALUES (91964, 0, 0, 0, 0, 389, 167);
INSERT INTO public.who_global_data VALUES (91965, 0, 0, 0, 0, 389, 154);
INSERT INTO public.who_global_data VALUES (91966, 0, 0, 0, 0, 389, 94);
INSERT INTO public.who_global_data VALUES (91967, 0, 0, 0, 0, 389, 66);
INSERT INTO public.who_global_data VALUES (91968, 0, 0, 0, 0, 389, 58);
INSERT INTO public.who_global_data VALUES (91969, 0, 0, 0, 0, 389, 163);
INSERT INTO public.who_global_data VALUES (91970, 0, 0, 0, 0, 389, 37);
INSERT INTO public.who_global_data VALUES (91971, 0, 0, 0, 0, 389, 142);
INSERT INTO public.who_global_data VALUES (91972, 0, 0, 0, 0, 389, 83);
INSERT INTO public.who_global_data VALUES (91973, 0, 0, 0, 0, 389, 228);
INSERT INTO public.who_global_data VALUES (91974, 0, 0, 0, 0, 389, 188);
INSERT INTO public.who_global_data VALUES (91975, 0, 0, 0, 0, 389, 62);
INSERT INTO public.who_global_data VALUES (91976, 0, 0, 0, 0, 389, 160);
INSERT INTO public.who_global_data VALUES (91977, 0, 0, 0, 0, 389, 50);
INSERT INTO public.who_global_data VALUES (91978, 0, 0, 0, 0, 389, 33);
INSERT INTO public.who_global_data VALUES (91979, 0, 0, 0, 0, 389, 183);
INSERT INTO public.who_global_data VALUES (91980, 0, 0, 0, 0, 389, 92);
INSERT INTO public.who_global_data VALUES (91981, 0, 0, 0, 0, 389, 158);
INSERT INTO public.who_global_data VALUES (91982, 0, 0, 0, 0, 389, 67);
INSERT INTO public.who_global_data VALUES (91983, 0, 0, 0, 0, 389, 57);
INSERT INTO public.who_global_data VALUES (91984, 0, 0, 0, 0, 389, 38);
INSERT INTO public.who_global_data VALUES (91985, 0, 0, 0, 0, 389, 141);
INSERT INTO public.who_global_data VALUES (91986, 0, 0, 0, 0, 389, 178);
INSERT INTO public.who_global_data VALUES (91987, 0, 0, 0, 0, 389, 108);
INSERT INTO public.who_global_data VALUES (91988, 0, 0, 0, 0, 389, 39);
INSERT INTO public.who_global_data VALUES (91989, 0, 0, 0, 0, 389, 2);
INSERT INTO public.who_global_data VALUES (91990, 0, 0, 0, 0, 389, 195);
INSERT INTO public.who_global_data VALUES (91991, 0, 0, 0, 0, 389, 107);
INSERT INTO public.who_global_data VALUES (91992, 0, 0, 0, 0, 389, 161);
INSERT INTO public.who_global_data VALUES (91993, 0, 0, 0, 0, 389, 212);
INSERT INTO public.who_global_data VALUES (91994, 0, 0, 0, 0, 389, 181);
INSERT INTO public.who_global_data VALUES (91995, 0, 0, 0, 0, 389, 53);
INSERT INTO public.who_global_data VALUES (91996, 0, 0, 0, 0, 389, 164);
INSERT INTO public.who_global_data VALUES (91997, 0, 0, 0, 0, 389, 140);
INSERT INTO public.who_global_data VALUES (91998, 0, 0, 0, 0, 389, 20);
INSERT INTO public.who_global_data VALUES (91999, 0, 45, 0, 1, 389, 112);
INSERT INTO public.who_global_data VALUES (92000, 0, 0, 0, 0, 389, 111);
INSERT INTO public.who_global_data VALUES (92001, 0, 0, 0, 0, 389, 71);
INSERT INTO public.who_global_data VALUES (92002, 0, 0, 0, 0, 389, 218);
INSERT INTO public.who_global_data VALUES (92003, 0, 0, 0, 0, 389, 43);
INSERT INTO public.who_global_data VALUES (92004, 0, 0, 0, 0, 389, 49);
INSERT INTO public.who_global_data VALUES (92005, 0, 0, 0, 0, 389, 1);
INSERT INTO public.who_global_data VALUES (92006, 0, 0, 0, 0, 389, 48);
INSERT INTO public.who_global_data VALUES (92007, 0, 0, 0, 0, 389, 232);
INSERT INTO public.who_global_data VALUES (92008, 0, 0, 0, 0, 389, 175);
INSERT INTO public.who_global_data VALUES (92009, 0, 0, 0, 0, 389, 21);
INSERT INTO public.who_global_data VALUES (92010, 0, 0, 0, 0, 389, 156);
INSERT INTO public.who_global_data VALUES (92011, 0, 0, 0, 0, 389, 95);
INSERT INTO public.who_global_data VALUES (92012, 0, 0, 0, 0, 389, 177);
INSERT INTO public.who_global_data VALUES (92013, 0, 0, 0, 0, 389, 210);
INSERT INTO public.who_global_data VALUES (92014, 0, 0, 0, 0, 389, 120);
INSERT INTO public.who_global_data VALUES (92015, 0, 0, 0, 0, 389, 135);
INSERT INTO public.who_global_data VALUES (92016, 0, 0, 0, 0, 389, 206);
INSERT INTO public.who_global_data VALUES (92017, 0, 0, 0, 0, 389, 189);
INSERT INTO public.who_global_data VALUES (92018, 0, 0, 0, 0, 389, 129);
INSERT INTO public.who_global_data VALUES (92019, 0, 0, 0, 0, 389, 121);
INSERT INTO public.who_global_data VALUES (92020, 0, 0, 0, 0, 389, 59);
INSERT INTO public.who_global_data VALUES (92021, 0, 0, 0, 0, 389, 96);
INSERT INTO public.who_global_data VALUES (92022, 0, 0, 0, 0, 389, 41);
INSERT INTO public.who_global_data VALUES (92023, 0, 0, 0, 0, 389, 216);
INSERT INTO public.who_global_data VALUES (92024, 0, 0, 0, 0, 389, 236);
INSERT INTO public.who_global_data VALUES (92025, 0, 0, 0, 0, 389, 150);
INSERT INTO public.who_global_data VALUES (92026, 0, 0, 0, 0, 389, 61);
INSERT INTO public.who_global_data VALUES (92027, 0, 0, 0, 0, 389, 7);
INSERT INTO public.who_global_data VALUES (92028, 0, 0, 0, 0, 389, 169);
INSERT INTO public.who_global_data VALUES (92029, 0, 0, 0, 0, 389, 28);
INSERT INTO public.who_global_data VALUES (92030, 0, 0, 0, 0, 389, 85);
INSERT INTO public.who_global_data VALUES (92031, 0, 0, 0, 0, 389, 211);
INSERT INTO public.who_global_data VALUES (92032, 0, 0, 0, 0, 389, 60);
INSERT INTO public.who_global_data VALUES (92033, 0, 0, 0, 0, 389, 3);
INSERT INTO public.who_global_data VALUES (92034, 0, 0, 0, 0, 389, 11);
INSERT INTO public.who_global_data VALUES (92035, 0, 0, 0, 0, 389, 89);
INSERT INTO public.who_global_data VALUES (92036, 0, 0, 0, 0, 389, 24);
INSERT INTO public.who_global_data VALUES (92037, 0, 0, 0, 0, 389, 162);
INSERT INTO public.who_global_data VALUES (92038, 0, 0, 0, 0, 389, 100);
INSERT INTO public.who_global_data VALUES (92039, 0, 0, 0, 0, 389, 47);
INSERT INTO public.who_global_data VALUES (92040, 0, 0, 0, 0, 389, 29);
INSERT INTO public.who_global_data VALUES (92041, 0, 0, 0, 0, 389, 40);
INSERT INTO public.who_global_data VALUES (92042, 0, 0, 0, 0, 389, 222);
INSERT INTO public.who_global_data VALUES (92043, 0, 0, 0, 0, 389, 132);
INSERT INTO public.who_global_data VALUES (92044, 0, 0, 0, 0, 389, 130);
INSERT INTO public.who_global_data VALUES (92045, 0, 0, 0, 0, 389, 234);
INSERT INTO public.who_global_data VALUES (92046, 0, 0, 0, 0, 389, 23);
INSERT INTO public.who_global_data VALUES (92047, 0, 0, 0, 0, 389, 192);
INSERT INTO public.who_global_data VALUES (92048, 0, 0, 0, 0, 389, 69);
INSERT INTO public.who_global_data VALUES (92049, 0, 0, 0, 0, 389, 187);
INSERT INTO public.who_global_data VALUES (92050, 0, 0, 0, 0, 389, 230);
INSERT INTO public.who_global_data VALUES (92051, 0, 0, 0, 0, 389, 77);
INSERT INTO public.who_global_data VALUES (92052, 0, 0, 0, 0, 389, 9);
INSERT INTO public.who_global_data VALUES (92053, 0, 0, 0, 0, 389, 74);
INSERT INTO public.who_global_data VALUES (92054, 0, 0, 0, 0, 389, 224);
INSERT INTO public.who_global_data VALUES (92055, 0, 0, 0, 0, 389, 199);
INSERT INTO public.who_global_data VALUES (92056, 0, 0, 0, 0, 389, 190);
INSERT INTO public.who_global_data VALUES (92057, 0, 0, 0, 0, 389, 12);
INSERT INTO public.who_global_data VALUES (92058, 0, 0, 0, 0, 389, 104);
INSERT INTO public.who_global_data VALUES (92059, 0, 0, 0, 0, 389, 153);
INSERT INTO public.who_global_data VALUES (92060, 0, 0, 0, 0, 389, 91);
INSERT INTO public.who_global_data VALUES (92061, 0, 0, 0, 0, 389, 215);
INSERT INTO public.who_global_data VALUES (92062, 1, 1, 0, 0, 389, 84);
INSERT INTO public.who_global_data VALUES (92063, 0, 0, 0, 0, 389, 231);
INSERT INTO public.who_global_data VALUES (92064, 0, 0, 0, 0, 389, 196);
INSERT INTO public.who_global_data VALUES (92065, 0, 0, 0, 0, 389, 105);
INSERT INTO public.who_global_data VALUES (92066, 0, 0, 0, 0, 389, 122);
INSERT INTO public.who_global_data VALUES (92067, 0, 0, 0, 0, 389, 159);
INSERT INTO public.who_global_data VALUES (92068, 0, 0, 0, 0, 389, 75);
INSERT INTO public.who_global_data VALUES (92069, 0, 0, 0, 0, 389, 27);
INSERT INTO public.who_global_data VALUES (92070, 0, 0, 0, 0, 389, 54);
INSERT INTO public.who_global_data VALUES (92071, 0, 0, 0, 0, 389, 226);
INSERT INTO public.who_global_data VALUES (92072, 0, 0, 0, 0, 389, 79);
INSERT INTO public.who_global_data VALUES (92073, 0, 0, 0, 0, 389, 56);
INSERT INTO public.who_global_data VALUES (92074, 0, 0, 0, 0, 389, 117);
INSERT INTO public.who_global_data VALUES (92075, 0, 0, 0, 0, 389, 152);
INSERT INTO public.who_global_data VALUES (92076, 0, 0, 0, 0, 389, 16);
INSERT INTO public.who_global_data VALUES (92077, 0, 0, 0, 0, 389, 10);
INSERT INTO public.who_global_data VALUES (92078, 0, 0, 0, 0, 389, 201);
INSERT INTO public.who_global_data VALUES (92079, 0, 0, 0, 0, 389, 174);
INSERT INTO public.who_global_data VALUES (92080, 0, 0, 0, 0, 389, 119);
INSERT INTO public.who_global_data VALUES (92081, 0, 0, 0, 0, 389, 168);
INSERT INTO public.who_global_data VALUES (92082, 0, 0, 0, 0, 389, 99);
INSERT INTO public.who_global_data VALUES (92083, 0, 0, 0, 0, 389, 171);
INSERT INTO public.who_global_data VALUES (92084, 0, 0, 0, 0, 389, 87);
INSERT INTO public.who_global_data VALUES (92085, 0, 0, 0, 0, 389, 123);
INSERT INTO public.who_global_data VALUES (92086, 0, 0, 0, 0, 389, 151);
INSERT INTO public.who_global_data VALUES (92087, 0, 0, 0, 0, 389, 213);
INSERT INTO public.who_global_data VALUES (92088, 0, 0, 0, 0, 389, 118);
INSERT INTO public.who_global_data VALUES (92089, 0, 0, 0, 0, 389, 134);
INSERT INTO public.who_global_data VALUES (92090, 0, 0, 0, 0, 389, 65);
INSERT INTO public.who_global_data VALUES (92091, 0, 0, 0, 0, 389, 102);
INSERT INTO public.who_global_data VALUES (92092, 0, 0, 0, 0, 389, 223);
INSERT INTO public.who_global_data VALUES (92093, 0, 0, 0, 0, 389, 4);
INSERT INTO public.who_global_data VALUES (92094, 0, 0, 0, 0, 389, 146);
INSERT INTO public.who_global_data VALUES (92095, 0, 0, 0, 0, 389, 31);
INSERT INTO public.who_global_data VALUES (92096, 0, 0, 0, 0, 389, 127);
INSERT INTO public.who_global_data VALUES (92097, 0, 0, 0, 0, 389, 22);
INSERT INTO public.who_global_data VALUES (92098, 0, 0, 0, 0, 389, 115);
INSERT INTO public.who_global_data VALUES (92099, 0, 0, 0, 0, 389, 106);
INSERT INTO public.who_global_data VALUES (92100, 0, 0, 0, 0, 389, 90);
INSERT INTO public.who_global_data VALUES (92101, 0, 0, 0, 0, 389, 70);
INSERT INTO public.who_global_data VALUES (92102, 0, 0, 0, 0, 389, 46);
INSERT INTO public.who_global_data VALUES (92103, 0, 0, 0, 0, 389, 139);
INSERT INTO public.who_global_data VALUES (92104, 0, 0, 0, 0, 389, 42);
INSERT INTO public.who_global_data VALUES (92105, 0, 0, 0, 0, 389, 80);
INSERT INTO public.who_global_data VALUES (92106, 0, 0, 0, 0, 389, 203);
INSERT INTO public.who_global_data VALUES (92107, 0, 0, 0, 0, 389, 136);
INSERT INTO public.who_global_data VALUES (92108, 0, 0, 0, 0, 389, 63);
INSERT INTO public.who_global_data VALUES (92109, 0, 0, 0, 0, 389, 17);
INSERT INTO public.who_global_data VALUES (92110, 0, 0, 0, 0, 389, 172);
INSERT INTO public.who_global_data VALUES (92111, 0, 0, 0, 0, 389, 109);
INSERT INTO public.who_global_data VALUES (92112, 0, 0, 0, 0, 389, 200);
INSERT INTO public.who_global_data VALUES (92113, 0, 0, 0, 0, 389, 93);
INSERT INTO public.who_global_data VALUES (92114, 0, 0, 0, 0, 389, 5);
INSERT INTO public.who_global_data VALUES (92115, 0, 0, 0, 0, 389, 214);
INSERT INTO public.who_global_data VALUES (92116, 0, 0, 0, 0, 389, 204);
INSERT INTO public.who_global_data VALUES (92117, 0, 0, 0, 0, 389, 198);
INSERT INTO public.who_global_data VALUES (92118, 0, 0, 0, 0, 389, 173);
INSERT INTO public.who_global_data VALUES (92119, 0, 0, 0, 0, 389, 229);
INSERT INTO public.who_global_data VALUES (92120, 0, 0, 0, 0, 389, 76);
INSERT INTO public.who_global_data VALUES (92121, 0, 0, 0, 0, 389, 138);
INSERT INTO public.who_global_data VALUES (92122, 0, 0, 0, 0, 389, 98);
INSERT INTO public.who_global_data VALUES (92123, 0, 0, 0, 0, 389, 103);
INSERT INTO public.who_global_data VALUES (92124, 0, 0, 0, 0, 389, 225);
INSERT INTO public.who_global_data VALUES (92125, 0, 0, 0, 0, 389, 131);
INSERT INTO public.who_global_data VALUES (92126, 0, 0, 0, 0, 389, 235);
INSERT INTO public.who_global_data VALUES (92127, 0, 0, 0, 0, 389, 137);
INSERT INTO public.who_global_data VALUES (92128, 0, 0, 0, 0, 389, 81);
INSERT INTO public.who_global_data VALUES (92129, 0, 0, 0, 0, 389, 182);
INSERT INTO public.who_global_data VALUES (92130, 0, 0, 0, 0, 389, 145);
INSERT INTO public.who_global_data VALUES (92131, 0, 0, 0, 0, 389, 26);
INSERT INTO public.who_global_data VALUES (92132, 0, 0, 0, 0, 389, 170);
INSERT INTO public.who_global_data VALUES (92133, 0, 0, 0, 0, 389, 191);
INSERT INTO public.who_global_data VALUES (92134, 0, 0, 0, 0, 389, 221);
INSERT INTO public.who_global_data VALUES (92135, 0, 0, 0, 0, 389, 64);
INSERT INTO public.who_global_data VALUES (92136, 0, 0, 0, 0, 389, 116);
INSERT INTO public.who_global_data VALUES (92137, 0, 0, 0, 0, 389, 128);
INSERT INTO public.who_global_data VALUES (92138, 0, 0, 0, 0, 389, 6);
INSERT INTO public.who_global_data VALUES (92139, 0, 0, 0, 0, 389, 227);
INSERT INTO public.who_global_data VALUES (92140, 0, 0, 0, 0, 389, 68);
INSERT INTO public.who_global_data VALUES (92141, 0, 0, 0, 0, 389, 184);
INSERT INTO public.who_global_data VALUES (92142, 0, 0, 0, 0, 389, 82);
INSERT INTO public.who_global_data VALUES (92143, 0, 0, 0, 0, 389, 149);
INSERT INTO public.who_global_data VALUES (92144, 0, 0, 0, 0, 389, 197);
INSERT INTO public.who_global_data VALUES (92145, 0, 0, 0, 0, 389, 78);
INSERT INTO public.who_global_data VALUES (92146, 0, 0, 0, 0, 389, 233);
INSERT INTO public.who_global_data VALUES (92147, 0, 0, 0, 0, 389, 133);
INSERT INTO public.who_global_data VALUES (92148, 0, 0, 0, 0, 389, 35);
INSERT INTO public.who_global_data VALUES (92149, 0, 0, 0, 0, 389, 114);
INSERT INTO public.who_global_data VALUES (92150, 0, 0, 0, 0, 389, 237);
INSERT INTO public.who_global_data VALUES (92151, 0, 0, 0, 0, 389, 55);
INSERT INTO public.who_global_data VALUES (92152, 0, 0, 0, 0, 389, 176);
INSERT INTO public.who_global_data VALUES (92153, 0, 0, 0, 0, 389, 202);
INSERT INTO public.who_global_data VALUES (92154, 0, 0, 0, 0, 389, 155);
INSERT INTO public.who_global_data VALUES (92155, 0, 0, 0, 0, 389, 32);
INSERT INTO public.who_global_data VALUES (92156, 0, 0, 0, 0, 389, 220);
INSERT INTO public.who_global_data VALUES (92157, 0, 0, 0, 0, 389, 30);
INSERT INTO public.who_global_data VALUES (92158, 0, 0, 0, 0, 389, 147);
INSERT INTO public.who_global_data VALUES (92159, 0, 0, 0, 0, 389, 208);
INSERT INTO public.who_global_data VALUES (92160, 0, 0, 0, 0, 389, 45);
INSERT INTO public.who_global_data VALUES (92161, 0, 0, 0, 0, 389, 110);
INSERT INTO public.who_global_data VALUES (92162, 0, 0, 0, 0, 389, 88);
INSERT INTO public.who_global_data VALUES (92163, 0, 0, 0, 0, 389, 51);
INSERT INTO public.who_global_data VALUES (92164, 0, 0, 0, 0, 389, 209);
INSERT INTO public.who_global_data VALUES (92165, 0, 0, 0, 0, 389, 205);
INSERT INTO public.who_global_data VALUES (92166, 0, 0, 0, 0, 389, 18);
INSERT INTO public.who_global_data VALUES (92167, 0, 5, 0, 0, 389, 72);
INSERT INTO public.who_global_data VALUES (92168, 0, 0, 0, 0, 389, 44);
INSERT INTO public.who_global_data VALUES (92169, 0, 0, 0, 0, 389, 15);
INSERT INTO public.who_global_data VALUES (92170, 0, 0, 0, 0, 389, 25);
INSERT INTO public.who_global_data VALUES (92171, 0, 0, 0, 0, 389, 179);
INSERT INTO public.who_global_data VALUES (92172, 0, 0, 0, 0, 389, 34);
INSERT INTO public.who_global_data VALUES (92173, 0, 0, 0, 0, 389, 207);
INSERT INTO public.who_global_data VALUES (92174, 0, 0, 0, 0, 389, 166);
INSERT INTO public.who_global_data VALUES (92175, 0, 0, 0, 0, 389, 126);
INSERT INTO public.who_global_data VALUES (92176, 0, 0, 0, 0, 389, 97);
INSERT INTO public.who_global_data VALUES (92177, 0, 0, 0, 0, 389, 36);
INSERT INTO public.who_global_data VALUES (92178, 0, 0, 0, 0, 389, 125);
INSERT INTO public.who_global_data VALUES (92179, 0, 0, 0, 0, 389, 124);
INSERT INTO public.who_global_data VALUES (92180, 0, 0, 0, 0, 389, 185);
INSERT INTO public.who_global_data VALUES (92181, 0, 0, 0, 0, 389, 194);
INSERT INTO public.who_global_data VALUES (92182, 0, 0, 0, 0, 389, 144);
INSERT INTO public.who_global_data VALUES (92183, 0, 0, 0, 0, 389, 19);
INSERT INTO public.who_global_data VALUES (92184, 0, 0, 0, 0, 389, 217);
INSERT INTO public.who_global_data VALUES (92185, 0, 0, 0, 0, 389, 148);
INSERT INTO public.who_global_data VALUES (92186, 0, 0, 0, 0, 389, 86);
INSERT INTO public.who_global_data VALUES (92187, 0, 0, 0, 0, 389, 13);
INSERT INTO public.who_global_data VALUES (92188, 0, 0, 0, 0, 389, 157);
INSERT INTO public.who_global_data VALUES (92189, 0, 0, 0, 0, 389, 8);
INSERT INTO public.who_global_data VALUES (92190, 0, 0, 0, 0, 389, 73);
INSERT INTO public.who_global_data VALUES (92191, 0, 0, 0, 0, 389, 101);
INSERT INTO public.who_global_data VALUES (92192, 0, 0, 0, 0, 389, 165);
INSERT INTO public.who_global_data VALUES (92193, 0, 0, 0, 0, 389, 14);
INSERT INTO public.who_global_data VALUES (92194, 0, 0, 0, 0, 390, 193);
INSERT INTO public.who_global_data VALUES (92195, 0, 0, 0, 0, 390, 113);
INSERT INTO public.who_global_data VALUES (92196, 0, 0, 0, 0, 390, 143);
INSERT INTO public.who_global_data VALUES (92197, 0, 0, 0, 0, 390, 219);
INSERT INTO public.who_global_data VALUES (92198, 0, 0, 0, 0, 390, 186);
INSERT INTO public.who_global_data VALUES (92199, 0, 0, 0, 0, 390, 52);
INSERT INTO public.who_global_data VALUES (92200, 0, 0, 0, 0, 390, 180);
INSERT INTO public.who_global_data VALUES (92201, 0, 0, 0, 0, 390, 167);
INSERT INTO public.who_global_data VALUES (92202, 0, 0, 0, 0, 390, 154);
INSERT INTO public.who_global_data VALUES (92203, 0, 0, 0, 0, 390, 94);
INSERT INTO public.who_global_data VALUES (92204, 0, 0, 0, 0, 390, 66);
INSERT INTO public.who_global_data VALUES (92205, 0, 0, 0, 0, 390, 58);
INSERT INTO public.who_global_data VALUES (92206, 0, 0, 0, 0, 390, 163);
INSERT INTO public.who_global_data VALUES (92207, 0, 0, 0, 0, 390, 37);
INSERT INTO public.who_global_data VALUES (92208, 0, 0, 0, 0, 390, 142);
INSERT INTO public.who_global_data VALUES (92209, 0, 0, 0, 0, 390, 83);
INSERT INTO public.who_global_data VALUES (92210, 0, 0, 0, 0, 390, 228);
INSERT INTO public.who_global_data VALUES (92211, 0, 0, 0, 0, 390, 188);
INSERT INTO public.who_global_data VALUES (92212, 0, 0, 0, 0, 390, 62);
INSERT INTO public.who_global_data VALUES (92213, 0, 0, 0, 0, 390, 160);
INSERT INTO public.who_global_data VALUES (92214, 0, 0, 0, 0, 390, 50);
INSERT INTO public.who_global_data VALUES (92215, 0, 0, 0, 0, 390, 33);
INSERT INTO public.who_global_data VALUES (92216, 0, 0, 0, 0, 390, 183);
INSERT INTO public.who_global_data VALUES (92217, 0, 0, 0, 0, 390, 92);
INSERT INTO public.who_global_data VALUES (92218, 0, 0, 0, 0, 390, 158);
INSERT INTO public.who_global_data VALUES (92219, 0, 0, 0, 0, 390, 67);
INSERT INTO public.who_global_data VALUES (92220, 0, 0, 0, 0, 390, 57);
INSERT INTO public.who_global_data VALUES (92221, 0, 0, 0, 0, 390, 38);
INSERT INTO public.who_global_data VALUES (92222, 0, 0, 0, 0, 390, 141);
INSERT INTO public.who_global_data VALUES (92223, 0, 0, 0, 0, 390, 178);
INSERT INTO public.who_global_data VALUES (92224, 0, 0, 0, 0, 390, 108);
INSERT INTO public.who_global_data VALUES (92225, 0, 0, 0, 0, 390, 39);
INSERT INTO public.who_global_data VALUES (92226, 0, 0, 0, 0, 390, 2);
INSERT INTO public.who_global_data VALUES (92227, 0, 0, 0, 0, 390, 195);
INSERT INTO public.who_global_data VALUES (92228, 0, 0, 0, 0, 390, 107);
INSERT INTO public.who_global_data VALUES (92229, 0, 0, 0, 0, 390, 161);
INSERT INTO public.who_global_data VALUES (92230, 0, 0, 0, 0, 390, 212);
INSERT INTO public.who_global_data VALUES (92231, 0, 0, 0, 0, 390, 181);
INSERT INTO public.who_global_data VALUES (92232, 0, 0, 0, 0, 390, 53);
INSERT INTO public.who_global_data VALUES (92233, 0, 0, 0, 0, 390, 164);
INSERT INTO public.who_global_data VALUES (92234, 0, 0, 0, 0, 390, 140);
INSERT INTO public.who_global_data VALUES (92235, 0, 0, 0, 0, 390, 20);
INSERT INTO public.who_global_data VALUES (92236, 0, 45, 0, 1, 390, 112);
INSERT INTO public.who_global_data VALUES (92237, 0, 0, 0, 0, 390, 111);
INSERT INTO public.who_global_data VALUES (92238, 0, 0, 0, 0, 390, 71);
INSERT INTO public.who_global_data VALUES (92239, 0, 0, 0, 0, 390, 218);
INSERT INTO public.who_global_data VALUES (92240, 0, 0, 0, 0, 390, 43);
INSERT INTO public.who_global_data VALUES (92241, 0, 0, 0, 0, 390, 49);
INSERT INTO public.who_global_data VALUES (92242, 0, 0, 0, 0, 390, 1);
INSERT INTO public.who_global_data VALUES (92243, 0, 0, 0, 0, 390, 48);
INSERT INTO public.who_global_data VALUES (92244, 0, 0, 0, 0, 390, 232);
INSERT INTO public.who_global_data VALUES (92245, 0, 0, 0, 0, 390, 175);
INSERT INTO public.who_global_data VALUES (92246, 0, 0, 0, 0, 390, 21);
INSERT INTO public.who_global_data VALUES (92247, 0, 0, 0, 0, 390, 156);
INSERT INTO public.who_global_data VALUES (92248, 0, 0, 0, 0, 390, 95);
INSERT INTO public.who_global_data VALUES (92249, 0, 0, 0, 0, 390, 177);
INSERT INTO public.who_global_data VALUES (92250, 0, 0, 0, 0, 390, 210);
INSERT INTO public.who_global_data VALUES (92251, 0, 0, 0, 0, 390, 120);
INSERT INTO public.who_global_data VALUES (92252, 0, 0, 0, 0, 390, 135);
INSERT INTO public.who_global_data VALUES (92253, 0, 0, 0, 0, 390, 206);
INSERT INTO public.who_global_data VALUES (92254, 0, 0, 0, 0, 390, 189);
INSERT INTO public.who_global_data VALUES (92255, 0, 0, 0, 0, 390, 129);
INSERT INTO public.who_global_data VALUES (92256, 0, 0, 0, 0, 390, 121);
INSERT INTO public.who_global_data VALUES (92257, 0, 0, 0, 0, 390, 59);
INSERT INTO public.who_global_data VALUES (92258, 0, 0, 0, 0, 390, 96);
INSERT INTO public.who_global_data VALUES (92259, 0, 0, 0, 0, 390, 41);
INSERT INTO public.who_global_data VALUES (92260, 0, 0, 0, 0, 390, 216);
INSERT INTO public.who_global_data VALUES (92261, 0, 0, 0, 0, 390, 236);
INSERT INTO public.who_global_data VALUES (92262, 0, 0, 0, 0, 390, 150);
INSERT INTO public.who_global_data VALUES (92263, 0, 0, 0, 0, 390, 61);
INSERT INTO public.who_global_data VALUES (92264, 0, 0, 0, 0, 390, 7);
INSERT INTO public.who_global_data VALUES (92265, 0, 0, 0, 0, 390, 169);
INSERT INTO public.who_global_data VALUES (92266, 0, 0, 0, 0, 390, 28);
INSERT INTO public.who_global_data VALUES (92267, 0, 0, 0, 0, 390, 85);
INSERT INTO public.who_global_data VALUES (92268, 0, 0, 0, 0, 390, 211);
INSERT INTO public.who_global_data VALUES (92269, 0, 0, 0, 0, 390, 60);
INSERT INTO public.who_global_data VALUES (92270, 0, 0, 0, 0, 390, 3);
INSERT INTO public.who_global_data VALUES (92271, 0, 0, 0, 0, 390, 11);
INSERT INTO public.who_global_data VALUES (92272, 0, 0, 0, 0, 390, 89);
INSERT INTO public.who_global_data VALUES (92273, 0, 0, 0, 0, 390, 24);
INSERT INTO public.who_global_data VALUES (92274, 0, 0, 0, 0, 390, 162);
INSERT INTO public.who_global_data VALUES (92275, 0, 0, 0, 0, 390, 100);
INSERT INTO public.who_global_data VALUES (92276, 0, 0, 0, 0, 390, 47);
INSERT INTO public.who_global_data VALUES (92277, 0, 0, 0, 0, 390, 29);
INSERT INTO public.who_global_data VALUES (92278, 0, 0, 0, 0, 390, 40);
INSERT INTO public.who_global_data VALUES (92279, 0, 0, 0, 0, 390, 222);
INSERT INTO public.who_global_data VALUES (92280, 0, 0, 0, 0, 390, 132);
INSERT INTO public.who_global_data VALUES (92281, 0, 0, 0, 0, 390, 130);
INSERT INTO public.who_global_data VALUES (92282, 0, 0, 0, 0, 390, 234);
INSERT INTO public.who_global_data VALUES (92283, 0, 0, 0, 0, 390, 23);
INSERT INTO public.who_global_data VALUES (92284, 0, 0, 0, 0, 390, 192);
INSERT INTO public.who_global_data VALUES (92285, 0, 0, 0, 0, 390, 69);
INSERT INTO public.who_global_data VALUES (92286, 0, 0, 0, 0, 390, 187);
INSERT INTO public.who_global_data VALUES (92287, 0, 0, 0, 0, 390, 230);
INSERT INTO public.who_global_data VALUES (92288, 0, 0, 0, 0, 390, 77);
INSERT INTO public.who_global_data VALUES (92289, 0, 0, 0, 0, 390, 9);
INSERT INTO public.who_global_data VALUES (92290, 0, 0, 0, 0, 390, 74);
INSERT INTO public.who_global_data VALUES (92291, 0, 0, 0, 0, 390, 224);
INSERT INTO public.who_global_data VALUES (92292, 0, 0, 0, 0, 390, 199);
INSERT INTO public.who_global_data VALUES (92293, 0, 0, 0, 0, 390, 190);
INSERT INTO public.who_global_data VALUES (92294, 0, 0, 0, 0, 390, 12);
INSERT INTO public.who_global_data VALUES (92295, 0, 0, 0, 0, 390, 104);
INSERT INTO public.who_global_data VALUES (92296, 0, 0, 0, 0, 390, 153);
INSERT INTO public.who_global_data VALUES (92297, 0, 0, 0, 0, 390, 91);
INSERT INTO public.who_global_data VALUES (92298, 0, 0, 0, 0, 390, 215);
INSERT INTO public.who_global_data VALUES (92299, 0, 0, 0, 0, 390, 84);
INSERT INTO public.who_global_data VALUES (92300, 0, 0, 0, 0, 390, 231);
INSERT INTO public.who_global_data VALUES (92301, 0, 0, 0, 0, 390, 196);
INSERT INTO public.who_global_data VALUES (92302, 0, 0, 0, 0, 390, 105);
INSERT INTO public.who_global_data VALUES (92303, 0, 0, 0, 0, 390, 122);
INSERT INTO public.who_global_data VALUES (92304, 0, 0, 0, 0, 390, 159);
INSERT INTO public.who_global_data VALUES (92305, 0, 0, 0, 0, 390, 75);
INSERT INTO public.who_global_data VALUES (92306, 0, 0, 0, 0, 390, 27);
INSERT INTO public.who_global_data VALUES (92307, 0, 0, 0, 0, 390, 54);
INSERT INTO public.who_global_data VALUES (92308, 0, 0, 0, 0, 390, 226);
INSERT INTO public.who_global_data VALUES (92309, 0, 0, 0, 0, 390, 79);
INSERT INTO public.who_global_data VALUES (92310, 0, 0, 0, 0, 390, 56);
INSERT INTO public.who_global_data VALUES (92311, 0, 0, 0, 0, 390, 117);
INSERT INTO public.who_global_data VALUES (92312, 0, 0, 0, 0, 390, 152);
INSERT INTO public.who_global_data VALUES (92313, 0, 0, 0, 0, 390, 16);
INSERT INTO public.who_global_data VALUES (92314, 0, 0, 0, 0, 390, 10);
INSERT INTO public.who_global_data VALUES (92315, 0, 0, 0, 0, 390, 201);
INSERT INTO public.who_global_data VALUES (92316, 0, 0, 0, 0, 390, 174);
INSERT INTO public.who_global_data VALUES (92317, 0, 0, 0, 0, 390, 119);
INSERT INTO public.who_global_data VALUES (92318, 0, 0, 0, 0, 390, 168);
INSERT INTO public.who_global_data VALUES (92319, 0, 0, 0, 0, 390, 99);
INSERT INTO public.who_global_data VALUES (92320, 0, 0, 0, 0, 390, 171);
INSERT INTO public.who_global_data VALUES (92321, 0, 0, 0, 0, 390, 87);
INSERT INTO public.who_global_data VALUES (92322, 0, 0, 0, 0, 390, 123);
INSERT INTO public.who_global_data VALUES (92323, 0, 0, 0, 0, 390, 151);
INSERT INTO public.who_global_data VALUES (92324, 0, 0, 0, 0, 390, 213);
INSERT INTO public.who_global_data VALUES (92325, 0, 0, 0, 0, 390, 118);
INSERT INTO public.who_global_data VALUES (92326, 0, 0, 0, 0, 390, 134);
INSERT INTO public.who_global_data VALUES (92327, 0, 0, 0, 0, 390, 65);
INSERT INTO public.who_global_data VALUES (92328, 0, 0, 0, 0, 390, 102);
INSERT INTO public.who_global_data VALUES (92329, 0, 0, 0, 0, 390, 223);
INSERT INTO public.who_global_data VALUES (92330, 0, 0, 0, 0, 390, 4);
INSERT INTO public.who_global_data VALUES (92331, 0, 0, 0, 0, 390, 146);
INSERT INTO public.who_global_data VALUES (92332, 0, 0, 0, 0, 390, 31);
INSERT INTO public.who_global_data VALUES (92333, 0, 0, 0, 0, 390, 127);
INSERT INTO public.who_global_data VALUES (92334, 0, 0, 0, 0, 390, 22);
INSERT INTO public.who_global_data VALUES (92335, 0, 0, 0, 0, 390, 115);
INSERT INTO public.who_global_data VALUES (92336, 0, 0, 0, 0, 390, 106);
INSERT INTO public.who_global_data VALUES (92337, 0, 0, 0, 0, 390, 90);
INSERT INTO public.who_global_data VALUES (92338, 0, 0, 0, 0, 390, 70);
INSERT INTO public.who_global_data VALUES (92339, 0, 0, 0, 0, 390, 46);
INSERT INTO public.who_global_data VALUES (92340, 0, 0, 0, 0, 390, 139);
INSERT INTO public.who_global_data VALUES (92341, 0, 0, 0, 0, 390, 42);
INSERT INTO public.who_global_data VALUES (92342, 0, 0, 0, 0, 390, 80);
INSERT INTO public.who_global_data VALUES (92343, 0, 0, 0, 0, 390, 203);
INSERT INTO public.who_global_data VALUES (92344, 0, 0, 0, 0, 390, 136);
INSERT INTO public.who_global_data VALUES (92345, 0, 0, 0, 0, 390, 63);
INSERT INTO public.who_global_data VALUES (92346, 0, 0, 0, 0, 390, 17);
INSERT INTO public.who_global_data VALUES (92347, 0, 0, 0, 0, 390, 172);
INSERT INTO public.who_global_data VALUES (92348, 0, 0, 0, 0, 390, 109);
INSERT INTO public.who_global_data VALUES (92349, 0, 0, 0, 0, 390, 200);
INSERT INTO public.who_global_data VALUES (92350, 0, 0, 0, 0, 390, 93);
INSERT INTO public.who_global_data VALUES (92351, 0, 0, 0, 0, 390, 5);
INSERT INTO public.who_global_data VALUES (92352, 0, 0, 0, 0, 390, 214);
INSERT INTO public.who_global_data VALUES (92353, 0, 0, 0, 0, 390, 204);
INSERT INTO public.who_global_data VALUES (92354, 0, 0, 0, 0, 390, 198);
INSERT INTO public.who_global_data VALUES (92355, 0, 0, 0, 0, 390, 173);
INSERT INTO public.who_global_data VALUES (92356, 0, 0, 0, 0, 390, 229);
INSERT INTO public.who_global_data VALUES (92357, 0, 0, 0, 0, 390, 76);
INSERT INTO public.who_global_data VALUES (92358, 0, 0, 0, 0, 390, 138);
INSERT INTO public.who_global_data VALUES (92359, 0, 0, 0, 0, 390, 98);
INSERT INTO public.who_global_data VALUES (92360, 0, 0, 0, 0, 390, 103);
INSERT INTO public.who_global_data VALUES (92361, 0, 0, 0, 0, 390, 225);
INSERT INTO public.who_global_data VALUES (92362, 0, 0, 0, 0, 390, 131);
INSERT INTO public.who_global_data VALUES (92363, 0, 0, 0, 0, 390, 235);
INSERT INTO public.who_global_data VALUES (92364, 0, 0, 0, 0, 390, 137);
INSERT INTO public.who_global_data VALUES (92365, 0, 0, 0, 0, 390, 81);
INSERT INTO public.who_global_data VALUES (92366, 0, 0, 0, 0, 390, 182);
INSERT INTO public.who_global_data VALUES (92367, 0, 0, 0, 0, 390, 145);
INSERT INTO public.who_global_data VALUES (92368, 0, 0, 0, 0, 390, 26);
INSERT INTO public.who_global_data VALUES (92369, 0, 0, 0, 0, 390, 170);
INSERT INTO public.who_global_data VALUES (92370, 0, 0, 0, 0, 390, 191);
INSERT INTO public.who_global_data VALUES (92371, 0, 0, 0, 0, 390, 221);
INSERT INTO public.who_global_data VALUES (92372, 0, 0, 0, 0, 390, 64);
INSERT INTO public.who_global_data VALUES (92373, 0, 0, 0, 0, 390, 116);
INSERT INTO public.who_global_data VALUES (92374, 0, 0, 0, 0, 390, 128);
INSERT INTO public.who_global_data VALUES (92375, 0, 0, 0, 0, 390, 6);
INSERT INTO public.who_global_data VALUES (92376, 0, 0, 0, 0, 390, 227);
INSERT INTO public.who_global_data VALUES (92377, 0, 0, 0, 0, 390, 68);
INSERT INTO public.who_global_data VALUES (92378, 0, 0, 0, 0, 390, 184);
INSERT INTO public.who_global_data VALUES (92379, 0, 0, 0, 0, 390, 82);
INSERT INTO public.who_global_data VALUES (92380, 0, 0, 0, 0, 390, 149);
INSERT INTO public.who_global_data VALUES (92381, 0, 0, 0, 0, 390, 197);
INSERT INTO public.who_global_data VALUES (92382, 0, 0, 0, 0, 390, 78);
INSERT INTO public.who_global_data VALUES (92383, 0, 0, 0, 0, 390, 233);
INSERT INTO public.who_global_data VALUES (92384, 0, 0, 0, 0, 390, 133);
INSERT INTO public.who_global_data VALUES (92385, 0, 0, 0, 0, 390, 35);
INSERT INTO public.who_global_data VALUES (92386, 0, 0, 0, 0, 390, 114);
INSERT INTO public.who_global_data VALUES (92387, 0, 0, 0, 0, 390, 237);
INSERT INTO public.who_global_data VALUES (92388, 0, 0, 0, 0, 390, 55);
INSERT INTO public.who_global_data VALUES (92389, 0, 0, 0, 0, 390, 176);
INSERT INTO public.who_global_data VALUES (92390, 0, 0, 0, 0, 390, 202);
INSERT INTO public.who_global_data VALUES (92391, 0, 0, 0, 0, 390, 155);
INSERT INTO public.who_global_data VALUES (92392, 0, 0, 0, 0, 390, 32);
INSERT INTO public.who_global_data VALUES (92393, 0, 0, 0, 0, 390, 220);
INSERT INTO public.who_global_data VALUES (92394, 0, 0, 0, 0, 390, 30);
INSERT INTO public.who_global_data VALUES (92395, 0, 0, 0, 0, 390, 147);
INSERT INTO public.who_global_data VALUES (92396, 0, 0, 0, 0, 390, 208);
INSERT INTO public.who_global_data VALUES (92397, 0, 0, 0, 0, 390, 45);
INSERT INTO public.who_global_data VALUES (92398, 0, 0, 0, 0, 390, 110);
INSERT INTO public.who_global_data VALUES (92399, 0, 0, 0, 0, 390, 88);
INSERT INTO public.who_global_data VALUES (92400, 0, 0, 0, 0, 390, 51);
INSERT INTO public.who_global_data VALUES (92401, 0, 0, 0, 0, 390, 209);
INSERT INTO public.who_global_data VALUES (92402, 0, 0, 0, 0, 390, 205);
INSERT INTO public.who_global_data VALUES (92403, 0, 0, 0, 0, 390, 18);
INSERT INTO public.who_global_data VALUES (92404, 5, 5, 0, 0, 390, 72);
INSERT INTO public.who_global_data VALUES (92405, 0, 0, 0, 0, 390, 44);
INSERT INTO public.who_global_data VALUES (92406, 0, 0, 0, 0, 390, 15);
INSERT INTO public.who_global_data VALUES (92407, 0, 0, 0, 0, 390, 25);
INSERT INTO public.who_global_data VALUES (92408, 0, 0, 0, 0, 390, 179);
INSERT INTO public.who_global_data VALUES (92409, 0, 0, 0, 0, 390, 34);
INSERT INTO public.who_global_data VALUES (92410, 0, 0, 0, 0, 390, 207);
INSERT INTO public.who_global_data VALUES (92411, 0, 0, 0, 0, 390, 166);
INSERT INTO public.who_global_data VALUES (92412, 0, 0, 0, 0, 390, 126);
INSERT INTO public.who_global_data VALUES (92413, 0, 0, 0, 0, 390, 97);
INSERT INTO public.who_global_data VALUES (92414, 0, 0, 0, 0, 390, 36);
INSERT INTO public.who_global_data VALUES (92415, 0, 0, 0, 0, 390, 125);
INSERT INTO public.who_global_data VALUES (92416, 0, 0, 0, 0, 390, 124);
INSERT INTO public.who_global_data VALUES (92417, 0, 0, 0, 0, 390, 185);
INSERT INTO public.who_global_data VALUES (92418, 0, 0, 0, 0, 390, 194);
INSERT INTO public.who_global_data VALUES (92419, 0, 0, 0, 0, 390, 144);
INSERT INTO public.who_global_data VALUES (92420, 0, 0, 0, 0, 390, 19);
INSERT INTO public.who_global_data VALUES (92421, 0, 0, 0, 0, 390, 217);
INSERT INTO public.who_global_data VALUES (92422, 0, 0, 0, 0, 390, 148);
INSERT INTO public.who_global_data VALUES (92423, 0, 0, 0, 0, 390, 86);
INSERT INTO public.who_global_data VALUES (92424, 0, 0, 0, 0, 390, 13);
INSERT INTO public.who_global_data VALUES (92425, 0, 0, 0, 0, 390, 157);
INSERT INTO public.who_global_data VALUES (92426, 0, 0, 0, 0, 390, 8);
INSERT INTO public.who_global_data VALUES (92427, 0, 0, 0, 0, 390, 73);
INSERT INTO public.who_global_data VALUES (92428, 0, 0, 0, 0, 390, 101);
INSERT INTO public.who_global_data VALUES (92429, 0, 0, 0, 0, 390, 165);
INSERT INTO public.who_global_data VALUES (92430, 0, 0, 0, 0, 390, 14);
INSERT INTO public.who_global_data VALUES (92431, 0, 0, 0, 0, 391, 193);
INSERT INTO public.who_global_data VALUES (92432, 0, 0, 0, 0, 391, 113);
INSERT INTO public.who_global_data VALUES (92433, 0, 0, 0, 0, 391, 143);
INSERT INTO public.who_global_data VALUES (92434, 0, 0, 0, 0, 391, 219);
INSERT INTO public.who_global_data VALUES (92435, 0, 0, 0, 0, 391, 186);
INSERT INTO public.who_global_data VALUES (92436, 0, 0, 0, 0, 391, 52);
INSERT INTO public.who_global_data VALUES (92437, 0, 0, 0, 0, 391, 180);
INSERT INTO public.who_global_data VALUES (92438, 0, 0, 0, 0, 391, 167);
INSERT INTO public.who_global_data VALUES (92439, 0, 0, 0, 0, 391, 154);
INSERT INTO public.who_global_data VALUES (92440, 0, 0, 0, 0, 391, 94);
INSERT INTO public.who_global_data VALUES (92441, 0, 0, 0, 0, 391, 66);
INSERT INTO public.who_global_data VALUES (92442, 0, 0, 0, 0, 391, 58);
INSERT INTO public.who_global_data VALUES (92443, 0, 0, 0, 0, 391, 163);
INSERT INTO public.who_global_data VALUES (92444, 0, 0, 0, 0, 391, 37);
INSERT INTO public.who_global_data VALUES (92445, 0, 0, 0, 0, 391, 142);
INSERT INTO public.who_global_data VALUES (92446, 0, 0, 0, 0, 391, 83);
INSERT INTO public.who_global_data VALUES (92447, 0, 0, 0, 0, 391, 228);
INSERT INTO public.who_global_data VALUES (92448, 0, 0, 0, 0, 391, 188);
INSERT INTO public.who_global_data VALUES (92449, 0, 0, 0, 0, 391, 62);
INSERT INTO public.who_global_data VALUES (92450, 0, 0, 0, 0, 391, 160);
INSERT INTO public.who_global_data VALUES (92451, 0, 0, 0, 0, 391, 50);
INSERT INTO public.who_global_data VALUES (92452, 0, 0, 0, 0, 391, 33);
INSERT INTO public.who_global_data VALUES (92453, 0, 0, 0, 0, 391, 183);
INSERT INTO public.who_global_data VALUES (92454, 0, 0, 0, 0, 391, 92);
INSERT INTO public.who_global_data VALUES (92455, 0, 0, 0, 0, 391, 158);
INSERT INTO public.who_global_data VALUES (92456, 0, 0, 0, 0, 391, 67);
INSERT INTO public.who_global_data VALUES (92457, 0, 0, 0, 0, 391, 57);
INSERT INTO public.who_global_data VALUES (92458, 0, 0, 0, 0, 391, 38);
INSERT INTO public.who_global_data VALUES (92459, 0, 0, 0, 0, 391, 141);
INSERT INTO public.who_global_data VALUES (92460, 0, 0, 0, 0, 391, 178);
INSERT INTO public.who_global_data VALUES (92461, 0, 0, 0, 0, 391, 108);
INSERT INTO public.who_global_data VALUES (92462, 0, 0, 0, 0, 391, 39);
INSERT INTO public.who_global_data VALUES (92463, 0, 0, 0, 0, 391, 2);
INSERT INTO public.who_global_data VALUES (92464, 0, 0, 0, 0, 391, 195);
INSERT INTO public.who_global_data VALUES (92465, 0, 0, 0, 0, 391, 107);
INSERT INTO public.who_global_data VALUES (92466, 0, 0, 0, 0, 391, 161);
INSERT INTO public.who_global_data VALUES (92467, 0, 0, 0, 0, 391, 212);
INSERT INTO public.who_global_data VALUES (92468, 0, 0, 0, 0, 391, 181);
INSERT INTO public.who_global_data VALUES (92469, 0, 0, 0, 0, 391, 53);
INSERT INTO public.who_global_data VALUES (92470, 0, 0, 0, 0, 391, 164);
INSERT INTO public.who_global_data VALUES (92471, 0, 0, 0, 0, 391, 140);
INSERT INTO public.who_global_data VALUES (92472, 0, 0, 0, 0, 391, 20);
INSERT INTO public.who_global_data VALUES (92473, 0, 45, 0, 1, 391, 112);
INSERT INTO public.who_global_data VALUES (92474, 0, 0, 0, 0, 391, 111);
INSERT INTO public.who_global_data VALUES (92475, 0, 0, 0, 0, 391, 71);
INSERT INTO public.who_global_data VALUES (92476, 0, 0, 0, 0, 391, 218);
INSERT INTO public.who_global_data VALUES (92477, 0, 0, 0, 0, 391, 43);
INSERT INTO public.who_global_data VALUES (92478, 0, 0, 0, 0, 391, 49);
INSERT INTO public.who_global_data VALUES (92479, 0, 0, 0, 0, 391, 1);
INSERT INTO public.who_global_data VALUES (92480, 0, 0, 0, 0, 391, 48);
INSERT INTO public.who_global_data VALUES (92481, 0, 0, 0, 0, 391, 232);
INSERT INTO public.who_global_data VALUES (92482, 0, 0, 0, 0, 391, 175);
INSERT INTO public.who_global_data VALUES (92483, 0, 0, 0, 0, 391, 21);
INSERT INTO public.who_global_data VALUES (92484, 0, 0, 0, 0, 391, 156);
INSERT INTO public.who_global_data VALUES (92485, 0, 0, 0, 0, 391, 95);
INSERT INTO public.who_global_data VALUES (92486, 0, 0, 0, 0, 391, 177);
INSERT INTO public.who_global_data VALUES (92487, 0, 0, 0, 0, 391, 210);
INSERT INTO public.who_global_data VALUES (92488, 0, 0, 0, 0, 391, 120);
INSERT INTO public.who_global_data VALUES (92489, 0, 0, 0, 0, 391, 135);
INSERT INTO public.who_global_data VALUES (92490, 0, 0, 0, 0, 391, 206);
INSERT INTO public.who_global_data VALUES (92491, 0, 0, 0, 0, 391, 189);
INSERT INTO public.who_global_data VALUES (92492, 0, 0, 0, 0, 391, 129);
INSERT INTO public.who_global_data VALUES (92493, 0, 0, 0, 0, 391, 121);
INSERT INTO public.who_global_data VALUES (92494, 0, 0, 0, 0, 391, 59);
INSERT INTO public.who_global_data VALUES (92495, 0, 0, 0, 0, 391, 96);
INSERT INTO public.who_global_data VALUES (92496, 0, 0, 0, 0, 391, 41);
INSERT INTO public.who_global_data VALUES (92497, 0, 0, 0, 0, 391, 216);
INSERT INTO public.who_global_data VALUES (92498, 0, 0, 0, 0, 391, 236);
INSERT INTO public.who_global_data VALUES (92499, 0, 0, 0, 0, 391, 150);
INSERT INTO public.who_global_data VALUES (92500, 0, 0, 0, 0, 391, 61);
INSERT INTO public.who_global_data VALUES (92501, 0, 0, 0, 0, 391, 7);
INSERT INTO public.who_global_data VALUES (92502, 0, 0, 0, 0, 391, 169);
INSERT INTO public.who_global_data VALUES (92503, 0, 0, 0, 0, 391, 28);
INSERT INTO public.who_global_data VALUES (92504, 0, 0, 0, 0, 391, 85);
INSERT INTO public.who_global_data VALUES (92505, 0, 0, 0, 0, 391, 211);
INSERT INTO public.who_global_data VALUES (92506, 0, 0, 0, 0, 391, 60);
INSERT INTO public.who_global_data VALUES (92507, 0, 0, 0, 0, 391, 3);
INSERT INTO public.who_global_data VALUES (92508, 0, 0, 0, 0, 391, 11);
INSERT INTO public.who_global_data VALUES (92509, 0, 0, 0, 0, 391, 89);
INSERT INTO public.who_global_data VALUES (92510, 0, 0, 0, 0, 391, 24);
INSERT INTO public.who_global_data VALUES (92511, 0, 0, 0, 0, 391, 162);
INSERT INTO public.who_global_data VALUES (92512, 0, 0, 0, 0, 391, 100);
INSERT INTO public.who_global_data VALUES (92513, 0, 0, 0, 0, 391, 47);
INSERT INTO public.who_global_data VALUES (92514, 0, 0, 0, 0, 391, 29);
INSERT INTO public.who_global_data VALUES (92515, 0, 0, 0, 0, 391, 40);
INSERT INTO public.who_global_data VALUES (92516, 0, 0, 0, 0, 391, 222);
INSERT INTO public.who_global_data VALUES (92517, 0, 0, 0, 0, 391, 132);
INSERT INTO public.who_global_data VALUES (92518, 0, 0, 0, 0, 391, 130);
INSERT INTO public.who_global_data VALUES (92519, 0, 0, 0, 0, 391, 234);
INSERT INTO public.who_global_data VALUES (92520, 0, 0, 0, 0, 391, 23);
INSERT INTO public.who_global_data VALUES (92521, 0, 0, 0, 0, 391, 192);
INSERT INTO public.who_global_data VALUES (92522, 0, 0, 0, 0, 391, 69);
INSERT INTO public.who_global_data VALUES (92523, 0, 0, 0, 0, 391, 187);
INSERT INTO public.who_global_data VALUES (92524, 0, 0, 0, 0, 391, 230);
INSERT INTO public.who_global_data VALUES (92525, 0, 0, 0, 0, 391, 77);
INSERT INTO public.who_global_data VALUES (92526, 0, 0, 0, 0, 391, 9);
INSERT INTO public.who_global_data VALUES (92527, 0, 0, 0, 0, 391, 74);
INSERT INTO public.who_global_data VALUES (92528, 0, 0, 0, 0, 391, 224);
INSERT INTO public.who_global_data VALUES (92529, 0, 0, 0, 0, 391, 199);
INSERT INTO public.who_global_data VALUES (92530, 0, 0, 0, 0, 391, 190);
INSERT INTO public.who_global_data VALUES (92531, 0, 0, 0, 0, 391, 12);
INSERT INTO public.who_global_data VALUES (92532, 0, 0, 0, 0, 391, 104);
INSERT INTO public.who_global_data VALUES (92533, 0, 0, 0, 0, 391, 153);
INSERT INTO public.who_global_data VALUES (92534, 0, 0, 0, 0, 391, 91);
INSERT INTO public.who_global_data VALUES (92535, 0, 0, 0, 0, 391, 215);
INSERT INTO public.who_global_data VALUES (92536, 0, 0, 0, 0, 391, 84);
INSERT INTO public.who_global_data VALUES (92537, 0, 0, 0, 0, 391, 231);
INSERT INTO public.who_global_data VALUES (92538, 0, 0, 0, 0, 391, 196);
INSERT INTO public.who_global_data VALUES (92539, 0, 0, 0, 0, 391, 105);
INSERT INTO public.who_global_data VALUES (92540, 0, 0, 0, 0, 391, 122);
INSERT INTO public.who_global_data VALUES (92541, 0, 0, 0, 0, 391, 159);
INSERT INTO public.who_global_data VALUES (92542, 0, 0, 0, 0, 391, 75);
INSERT INTO public.who_global_data VALUES (92543, 0, 0, 0, 0, 391, 27);
INSERT INTO public.who_global_data VALUES (92544, 0, 0, 0, 0, 391, 54);
INSERT INTO public.who_global_data VALUES (92545, 0, 0, 0, 0, 391, 226);
INSERT INTO public.who_global_data VALUES (92546, 0, 0, 0, 0, 391, 79);
INSERT INTO public.who_global_data VALUES (92547, 0, 0, 0, 0, 391, 56);
INSERT INTO public.who_global_data VALUES (92548, 0, 0, 0, 0, 391, 117);
INSERT INTO public.who_global_data VALUES (92549, 0, 0, 0, 0, 391, 152);
INSERT INTO public.who_global_data VALUES (92550, 0, 0, 0, 0, 391, 16);
INSERT INTO public.who_global_data VALUES (92551, 0, 0, 0, 0, 391, 10);
INSERT INTO public.who_global_data VALUES (92552, 0, 0, 0, 0, 391, 201);
INSERT INTO public.who_global_data VALUES (92553, 0, 0, 0, 0, 391, 174);
INSERT INTO public.who_global_data VALUES (92554, 0, 0, 0, 0, 391, 119);
INSERT INTO public.who_global_data VALUES (92555, 0, 0, 0, 0, 391, 168);
INSERT INTO public.who_global_data VALUES (92556, 0, 0, 0, 0, 391, 99);
INSERT INTO public.who_global_data VALUES (92557, 0, 0, 0, 0, 391, 171);
INSERT INTO public.who_global_data VALUES (92558, 0, 0, 0, 0, 391, 87);
INSERT INTO public.who_global_data VALUES (92559, 0, 0, 0, 0, 391, 123);
INSERT INTO public.who_global_data VALUES (92560, 0, 0, 0, 0, 391, 151);
INSERT INTO public.who_global_data VALUES (92561, 0, 0, 0, 0, 391, 213);
INSERT INTO public.who_global_data VALUES (92562, 0, 0, 0, 0, 391, 118);
INSERT INTO public.who_global_data VALUES (92563, 0, 0, 0, 0, 391, 134);
INSERT INTO public.who_global_data VALUES (92564, 0, 0, 0, 0, 391, 65);
INSERT INTO public.who_global_data VALUES (92565, 0, 0, 0, 0, 391, 102);
INSERT INTO public.who_global_data VALUES (92566, 0, 0, 0, 0, 391, 223);
INSERT INTO public.who_global_data VALUES (92567, 0, 0, 0, 0, 391, 4);
INSERT INTO public.who_global_data VALUES (92568, 0, 0, 0, 0, 391, 146);
INSERT INTO public.who_global_data VALUES (92569, 0, 0, 0, 0, 391, 31);
INSERT INTO public.who_global_data VALUES (92570, 0, 0, 0, 0, 391, 127);
INSERT INTO public.who_global_data VALUES (92571, 0, 0, 0, 0, 391, 22);
INSERT INTO public.who_global_data VALUES (92572, 0, 0, 0, 0, 391, 115);
INSERT INTO public.who_global_data VALUES (92573, 0, 0, 0, 0, 391, 106);
INSERT INTO public.who_global_data VALUES (92574, 0, 0, 0, 0, 391, 90);
INSERT INTO public.who_global_data VALUES (92575, 0, 0, 0, 0, 391, 70);
INSERT INTO public.who_global_data VALUES (92576, 0, 0, 0, 0, 391, 46);
INSERT INTO public.who_global_data VALUES (92577, 0, 0, 0, 0, 391, 139);
INSERT INTO public.who_global_data VALUES (92578, 0, 0, 0, 0, 391, 42);
INSERT INTO public.who_global_data VALUES (92579, 0, 0, 0, 0, 391, 80);
INSERT INTO public.who_global_data VALUES (92580, 0, 0, 0, 0, 391, 203);
INSERT INTO public.who_global_data VALUES (92581, 0, 0, 0, 0, 391, 136);
INSERT INTO public.who_global_data VALUES (92582, 0, 0, 0, 0, 391, 63);
INSERT INTO public.who_global_data VALUES (92583, 0, 0, 0, 0, 391, 17);
INSERT INTO public.who_global_data VALUES (92584, 0, 0, 0, 0, 391, 172);
INSERT INTO public.who_global_data VALUES (92585, 0, 0, 0, 0, 391, 109);
INSERT INTO public.who_global_data VALUES (92586, 0, 0, 0, 0, 391, 200);
INSERT INTO public.who_global_data VALUES (92587, 0, 0, 0, 0, 391, 93);
INSERT INTO public.who_global_data VALUES (92588, 0, 0, 0, 0, 391, 5);
INSERT INTO public.who_global_data VALUES (92589, 0, 0, 0, 0, 391, 214);
INSERT INTO public.who_global_data VALUES (92590, 0, 0, 0, 0, 391, 204);
INSERT INTO public.who_global_data VALUES (92591, 0, 0, 0, 0, 391, 198);
INSERT INTO public.who_global_data VALUES (92592, 0, 0, 0, 0, 391, 173);
INSERT INTO public.who_global_data VALUES (92593, 0, 0, 0, 0, 391, 229);
INSERT INTO public.who_global_data VALUES (92594, 0, 0, 0, 0, 391, 76);
INSERT INTO public.who_global_data VALUES (92595, 0, 0, 0, 0, 391, 138);
INSERT INTO public.who_global_data VALUES (92596, 0, 0, 0, 0, 391, 98);
INSERT INTO public.who_global_data VALUES (92597, 0, 0, 0, 0, 391, 103);
INSERT INTO public.who_global_data VALUES (92598, 0, 0, 0, 0, 391, 225);
INSERT INTO public.who_global_data VALUES (92599, 0, 0, 0, 0, 391, 131);
INSERT INTO public.who_global_data VALUES (92600, 0, 0, 0, 0, 391, 235);
INSERT INTO public.who_global_data VALUES (92601, 0, 0, 0, 0, 391, 137);
INSERT INTO public.who_global_data VALUES (92602, 0, 0, 0, 0, 391, 81);
INSERT INTO public.who_global_data VALUES (92603, 0, 0, 0, 0, 391, 182);
INSERT INTO public.who_global_data VALUES (92604, 0, 0, 0, 0, 391, 145);
INSERT INTO public.who_global_data VALUES (92605, 0, 0, 0, 0, 391, 26);
INSERT INTO public.who_global_data VALUES (92606, 0, 0, 0, 0, 391, 170);
INSERT INTO public.who_global_data VALUES (92607, 0, 0, 0, 0, 391, 191);
INSERT INTO public.who_global_data VALUES (92608, 0, 0, 0, 0, 391, 221);
INSERT INTO public.who_global_data VALUES (92609, 0, 0, 0, 0, 391, 64);
INSERT INTO public.who_global_data VALUES (92610, 0, 0, 0, 0, 391, 116);
INSERT INTO public.who_global_data VALUES (92611, 0, 0, 0, 0, 391, 128);
INSERT INTO public.who_global_data VALUES (92612, 0, 0, 0, 0, 391, 6);
INSERT INTO public.who_global_data VALUES (92613, 0, 0, 0, 0, 391, 227);
INSERT INTO public.who_global_data VALUES (92614, 0, 0, 0, 0, 391, 68);
INSERT INTO public.who_global_data VALUES (92615, 0, 0, 0, 0, 391, 184);
INSERT INTO public.who_global_data VALUES (92616, 0, 0, 0, 0, 391, 82);
INSERT INTO public.who_global_data VALUES (92617, 0, 0, 0, 0, 391, 149);
INSERT INTO public.who_global_data VALUES (92618, 0, 0, 0, 0, 391, 197);
INSERT INTO public.who_global_data VALUES (92619, 0, 0, 0, 0, 391, 78);
INSERT INTO public.who_global_data VALUES (92620, 0, 0, 0, 0, 391, 233);
INSERT INTO public.who_global_data VALUES (92621, 0, 0, 0, 0, 391, 133);
INSERT INTO public.who_global_data VALUES (92622, 0, 0, 0, 0, 391, 35);
INSERT INTO public.who_global_data VALUES (92623, 0, 0, 0, 0, 391, 114);
INSERT INTO public.who_global_data VALUES (92624, 0, 0, 0, 0, 391, 237);
INSERT INTO public.who_global_data VALUES (92625, 0, 0, 0, 0, 391, 55);
INSERT INTO public.who_global_data VALUES (92626, 0, 0, 0, 0, 391, 176);
INSERT INTO public.who_global_data VALUES (92627, 0, 0, 0, 0, 391, 202);
INSERT INTO public.who_global_data VALUES (92628, 0, 0, 0, 0, 391, 155);
INSERT INTO public.who_global_data VALUES (92629, 0, 0, 0, 0, 391, 32);
INSERT INTO public.who_global_data VALUES (92630, 0, 0, 0, 0, 391, 220);
INSERT INTO public.who_global_data VALUES (92631, 0, 0, 0, 0, 391, 30);
INSERT INTO public.who_global_data VALUES (92632, 0, 0, 0, 0, 391, 147);
INSERT INTO public.who_global_data VALUES (92633, 0, 0, 0, 0, 391, 208);
INSERT INTO public.who_global_data VALUES (92634, 0, 0, 0, 0, 391, 45);
INSERT INTO public.who_global_data VALUES (92635, 0, 0, 0, 0, 391, 110);
INSERT INTO public.who_global_data VALUES (92636, 0, 0, 0, 0, 391, 88);
INSERT INTO public.who_global_data VALUES (92637, 0, 0, 0, 0, 391, 51);
INSERT INTO public.who_global_data VALUES (92638, 0, 0, 0, 0, 391, 209);
INSERT INTO public.who_global_data VALUES (92639, 0, 0, 0, 0, 391, 205);
INSERT INTO public.who_global_data VALUES (92640, 0, 0, 0, 0, 391, 18);
INSERT INTO public.who_global_data VALUES (92641, 0, 0, 0, 0, 391, 72);
INSERT INTO public.who_global_data VALUES (92642, 0, 0, 0, 0, 391, 44);
INSERT INTO public.who_global_data VALUES (92643, 0, 0, 0, 0, 391, 15);
INSERT INTO public.who_global_data VALUES (92644, 0, 0, 0, 0, 391, 25);
INSERT INTO public.who_global_data VALUES (92645, 0, 0, 0, 0, 391, 179);
INSERT INTO public.who_global_data VALUES (92646, 0, 0, 0, 0, 391, 34);
INSERT INTO public.who_global_data VALUES (92647, 0, 0, 0, 0, 391, 207);
INSERT INTO public.who_global_data VALUES (92648, 0, 0, 0, 0, 391, 166);
INSERT INTO public.who_global_data VALUES (92649, 0, 0, 0, 0, 391, 126);
INSERT INTO public.who_global_data VALUES (92650, 0, 0, 0, 0, 391, 97);
INSERT INTO public.who_global_data VALUES (92651, 0, 0, 0, 0, 391, 36);
INSERT INTO public.who_global_data VALUES (92652, 0, 0, 0, 0, 391, 125);
INSERT INTO public.who_global_data VALUES (92653, 0, 0, 0, 0, 391, 124);
INSERT INTO public.who_global_data VALUES (92654, 0, 0, 0, 0, 391, 185);
INSERT INTO public.who_global_data VALUES (92655, 0, 0, 0, 0, 391, 194);
INSERT INTO public.who_global_data VALUES (92656, 0, 0, 0, 0, 391, 144);
INSERT INTO public.who_global_data VALUES (92657, 0, 0, 0, 0, 391, 19);
INSERT INTO public.who_global_data VALUES (92658, 0, 0, 0, 0, 391, 217);
INSERT INTO public.who_global_data VALUES (92659, 0, 0, 0, 0, 391, 148);
INSERT INTO public.who_global_data VALUES (92660, 0, 0, 0, 0, 391, 86);
INSERT INTO public.who_global_data VALUES (92661, 0, 0, 0, 0, 391, 13);
INSERT INTO public.who_global_data VALUES (92662, 0, 0, 0, 0, 391, 157);
INSERT INTO public.who_global_data VALUES (92663, 0, 0, 0, 0, 391, 8);
INSERT INTO public.who_global_data VALUES (92664, 0, 0, 0, 0, 391, 73);
INSERT INTO public.who_global_data VALUES (92665, 0, 0, 0, 0, 391, 101);
INSERT INTO public.who_global_data VALUES (92666, 0, 0, 0, 0, 391, 165);
INSERT INTO public.who_global_data VALUES (92667, 0, 0, 0, 0, 391, 14);
INSERT INTO public.who_global_data VALUES (92668, 0, 0, 0, 0, 392, 193);
INSERT INTO public.who_global_data VALUES (92669, 0, 0, 0, 0, 392, 113);
INSERT INTO public.who_global_data VALUES (92670, 0, 0, 0, 0, 392, 143);
INSERT INTO public.who_global_data VALUES (92671, 0, 0, 0, 0, 392, 219);
INSERT INTO public.who_global_data VALUES (92672, 0, 0, 0, 0, 392, 186);
INSERT INTO public.who_global_data VALUES (92673, 0, 0, 0, 0, 392, 52);
INSERT INTO public.who_global_data VALUES (92674, 0, 0, 0, 0, 392, 180);
INSERT INTO public.who_global_data VALUES (92675, 0, 0, 0, 0, 392, 167);
INSERT INTO public.who_global_data VALUES (92676, 0, 0, 0, 0, 392, 154);
INSERT INTO public.who_global_data VALUES (92677, 0, 0, 0, 0, 392, 94);
INSERT INTO public.who_global_data VALUES (92678, 0, 0, 0, 0, 392, 66);
INSERT INTO public.who_global_data VALUES (92679, 0, 0, 0, 0, 392, 58);
INSERT INTO public.who_global_data VALUES (92680, 0, 0, 0, 0, 392, 163);
INSERT INTO public.who_global_data VALUES (92681, 0, 0, 0, 0, 392, 37);
INSERT INTO public.who_global_data VALUES (92682, 0, 0, 0, 0, 392, 142);
INSERT INTO public.who_global_data VALUES (92683, 0, 0, 0, 0, 392, 83);
INSERT INTO public.who_global_data VALUES (92684, 0, 0, 0, 0, 392, 228);
INSERT INTO public.who_global_data VALUES (92685, 0, 0, 0, 0, 392, 188);
INSERT INTO public.who_global_data VALUES (92686, 0, 0, 0, 0, 392, 62);
INSERT INTO public.who_global_data VALUES (92687, 0, 0, 0, 0, 392, 160);
INSERT INTO public.who_global_data VALUES (92688, 0, 0, 0, 0, 392, 50);
INSERT INTO public.who_global_data VALUES (92689, 0, 0, 0, 0, 392, 33);
INSERT INTO public.who_global_data VALUES (92690, 0, 0, 0, 0, 392, 183);
INSERT INTO public.who_global_data VALUES (92691, 0, 0, 0, 0, 392, 92);
INSERT INTO public.who_global_data VALUES (92692, 0, 0, 0, 0, 392, 158);
INSERT INTO public.who_global_data VALUES (92693, 0, 0, 0, 0, 392, 67);
INSERT INTO public.who_global_data VALUES (92694, 0, 0, 0, 0, 392, 57);
INSERT INTO public.who_global_data VALUES (92695, 0, 0, 0, 0, 392, 38);
INSERT INTO public.who_global_data VALUES (92696, 0, 0, 0, 0, 392, 141);
INSERT INTO public.who_global_data VALUES (92697, 0, 0, 0, 0, 392, 178);
INSERT INTO public.who_global_data VALUES (92698, 0, 0, 0, 0, 392, 108);
INSERT INTO public.who_global_data VALUES (92699, 0, 0, 0, 0, 392, 39);
INSERT INTO public.who_global_data VALUES (92700, 0, 0, 0, 0, 392, 2);
INSERT INTO public.who_global_data VALUES (92701, 0, 0, 0, 0, 392, 195);
INSERT INTO public.who_global_data VALUES (92702, 0, 0, 0, 0, 392, 107);
INSERT INTO public.who_global_data VALUES (92703, 0, 0, 0, 0, 392, 161);
INSERT INTO public.who_global_data VALUES (92704, 0, 0, 0, 0, 392, 212);
INSERT INTO public.who_global_data VALUES (92705, 0, 0, 0, 0, 392, 181);
INSERT INTO public.who_global_data VALUES (92706, 0, 0, 0, 0, 392, 53);
INSERT INTO public.who_global_data VALUES (92707, 0, 0, 0, 0, 392, 164);
INSERT INTO public.who_global_data VALUES (92708, 0, 0, 0, 0, 392, 140);
INSERT INTO public.who_global_data VALUES (92709, 0, 0, 0, 0, 392, 20);
INSERT INTO public.who_global_data VALUES (92710, 41, 45, 1, 1, 392, 112);
INSERT INTO public.who_global_data VALUES (92711, 0, 0, 0, 0, 392, 111);
INSERT INTO public.who_global_data VALUES (92712, 0, 0, 0, 0, 392, 71);
INSERT INTO public.who_global_data VALUES (92713, 0, 0, 0, 0, 392, 218);
INSERT INTO public.who_global_data VALUES (92714, 0, 0, 0, 0, 392, 43);
INSERT INTO public.who_global_data VALUES (92715, 0, 0, 0, 0, 392, 49);
INSERT INTO public.who_global_data VALUES (92716, 0, 0, 0, 0, 392, 1);
INSERT INTO public.who_global_data VALUES (92717, 0, 0, 0, 0, 392, 48);
INSERT INTO public.who_global_data VALUES (92718, 0, 0, 0, 0, 392, 232);
INSERT INTO public.who_global_data VALUES (92719, 0, 0, 0, 0, 392, 175);
INSERT INTO public.who_global_data VALUES (92720, 0, 0, 0, 0, 392, 21);
INSERT INTO public.who_global_data VALUES (92721, 0, 0, 0, 0, 392, 156);
INSERT INTO public.who_global_data VALUES (92722, 0, 0, 0, 0, 392, 95);
INSERT INTO public.who_global_data VALUES (92723, 0, 0, 0, 0, 392, 177);
INSERT INTO public.who_global_data VALUES (92724, 0, 0, 0, 0, 392, 210);
INSERT INTO public.who_global_data VALUES (92725, 0, 0, 0, 0, 392, 120);
INSERT INTO public.who_global_data VALUES (92726, 0, 0, 0, 0, 392, 135);
INSERT INTO public.who_global_data VALUES (92727, 0, 0, 0, 0, 392, 206);
INSERT INTO public.who_global_data VALUES (92728, 0, 0, 0, 0, 392, 189);
INSERT INTO public.who_global_data VALUES (92729, 0, 0, 0, 0, 392, 129);
INSERT INTO public.who_global_data VALUES (92730, 0, 0, 0, 0, 392, 121);
INSERT INTO public.who_global_data VALUES (92731, 0, 0, 0, 0, 392, 59);
INSERT INTO public.who_global_data VALUES (92732, 0, 0, 0, 0, 392, 96);
INSERT INTO public.who_global_data VALUES (92733, 0, 0, 0, 0, 392, 41);
INSERT INTO public.who_global_data VALUES (92734, 0, 0, 0, 0, 392, 216);
INSERT INTO public.who_global_data VALUES (92735, 0, 0, 0, 0, 392, 236);
INSERT INTO public.who_global_data VALUES (92736, 0, 0, 0, 0, 392, 150);
INSERT INTO public.who_global_data VALUES (92737, 0, 0, 0, 0, 392, 61);
INSERT INTO public.who_global_data VALUES (92738, 0, 0, 0, 0, 392, 7);
INSERT INTO public.who_global_data VALUES (92739, 0, 0, 0, 0, 392, 169);
INSERT INTO public.who_global_data VALUES (92740, 0, 0, 0, 0, 392, 28);
INSERT INTO public.who_global_data VALUES (92741, 0, 0, 0, 0, 392, 85);
INSERT INTO public.who_global_data VALUES (92742, 0, 0, 0, 0, 392, 211);
INSERT INTO public.who_global_data VALUES (92743, 0, 0, 0, 0, 392, 60);
INSERT INTO public.who_global_data VALUES (92744, 0, 0, 0, 0, 392, 3);
INSERT INTO public.who_global_data VALUES (92745, 0, 0, 0, 0, 392, 11);
INSERT INTO public.who_global_data VALUES (92746, 0, 0, 0, 0, 392, 89);
INSERT INTO public.who_global_data VALUES (92747, 0, 0, 0, 0, 392, 24);
INSERT INTO public.who_global_data VALUES (92748, 0, 0, 0, 0, 392, 162);
INSERT INTO public.who_global_data VALUES (92749, 0, 0, 0, 0, 392, 100);
INSERT INTO public.who_global_data VALUES (92750, 0, 0, 0, 0, 392, 47);
INSERT INTO public.who_global_data VALUES (92751, 0, 0, 0, 0, 392, 29);
INSERT INTO public.who_global_data VALUES (92752, 0, 0, 0, 0, 392, 40);
INSERT INTO public.who_global_data VALUES (92753, 0, 0, 0, 0, 392, 222);
INSERT INTO public.who_global_data VALUES (92754, 0, 0, 0, 0, 392, 132);
INSERT INTO public.who_global_data VALUES (92755, 0, 0, 0, 0, 392, 130);
INSERT INTO public.who_global_data VALUES (92756, 0, 0, 0, 0, 392, 234);
INSERT INTO public.who_global_data VALUES (92757, 0, 0, 0, 0, 392, 23);
INSERT INTO public.who_global_data VALUES (92758, 0, 0, 0, 0, 392, 192);
INSERT INTO public.who_global_data VALUES (92759, 0, 0, 0, 0, 392, 69);
INSERT INTO public.who_global_data VALUES (92760, 0, 0, 0, 0, 392, 187);
INSERT INTO public.who_global_data VALUES (92761, 0, 0, 0, 0, 392, 230);
INSERT INTO public.who_global_data VALUES (92762, 0, 0, 0, 0, 392, 77);
INSERT INTO public.who_global_data VALUES (92763, 0, 0, 0, 0, 392, 9);
INSERT INTO public.who_global_data VALUES (92764, 0, 0, 0, 0, 392, 74);
INSERT INTO public.who_global_data VALUES (92765, 0, 0, 0, 0, 392, 224);
INSERT INTO public.who_global_data VALUES (92766, 0, 0, 0, 0, 392, 199);
INSERT INTO public.who_global_data VALUES (92767, 0, 0, 0, 0, 392, 190);
INSERT INTO public.who_global_data VALUES (92768, 0, 0, 0, 0, 392, 12);
INSERT INTO public.who_global_data VALUES (92769, 0, 0, 0, 0, 392, 104);
INSERT INTO public.who_global_data VALUES (92770, 0, 0, 0, 0, 392, 153);
INSERT INTO public.who_global_data VALUES (92771, 0, 0, 0, 0, 392, 91);
INSERT INTO public.who_global_data VALUES (92772, 0, 0, 0, 0, 392, 215);
INSERT INTO public.who_global_data VALUES (92773, 0, 0, 0, 0, 392, 84);
INSERT INTO public.who_global_data VALUES (92774, 0, 0, 0, 0, 392, 231);
INSERT INTO public.who_global_data VALUES (92775, 0, 0, 0, 0, 392, 196);
INSERT INTO public.who_global_data VALUES (92776, 0, 0, 0, 0, 392, 105);
INSERT INTO public.who_global_data VALUES (92777, 0, 0, 0, 0, 392, 122);
INSERT INTO public.who_global_data VALUES (92778, 0, 0, 0, 0, 392, 159);
INSERT INTO public.who_global_data VALUES (92779, 0, 0, 0, 0, 392, 75);
INSERT INTO public.who_global_data VALUES (92780, 0, 0, 0, 0, 392, 27);
INSERT INTO public.who_global_data VALUES (92781, 0, 0, 0, 0, 392, 54);
INSERT INTO public.who_global_data VALUES (92782, 0, 0, 0, 0, 392, 226);
INSERT INTO public.who_global_data VALUES (92783, 0, 0, 0, 0, 392, 79);
INSERT INTO public.who_global_data VALUES (92784, 0, 0, 0, 0, 392, 56);
INSERT INTO public.who_global_data VALUES (92785, 0, 0, 0, 0, 392, 117);
INSERT INTO public.who_global_data VALUES (92786, 0, 0, 0, 0, 392, 152);
INSERT INTO public.who_global_data VALUES (92787, 0, 0, 0, 0, 392, 16);
INSERT INTO public.who_global_data VALUES (92788, 0, 0, 0, 0, 392, 10);
INSERT INTO public.who_global_data VALUES (92789, 0, 0, 0, 0, 392, 201);
INSERT INTO public.who_global_data VALUES (92790, 0, 0, 0, 0, 392, 174);
INSERT INTO public.who_global_data VALUES (92791, 0, 0, 0, 0, 392, 119);
INSERT INTO public.who_global_data VALUES (92792, 0, 0, 0, 0, 392, 168);
INSERT INTO public.who_global_data VALUES (92793, 0, 0, 0, 0, 392, 99);
INSERT INTO public.who_global_data VALUES (92794, 0, 0, 0, 0, 392, 171);
INSERT INTO public.who_global_data VALUES (92795, 0, 0, 0, 0, 392, 87);
INSERT INTO public.who_global_data VALUES (92796, 0, 0, 0, 0, 392, 123);
INSERT INTO public.who_global_data VALUES (92797, 0, 0, 0, 0, 392, 151);
INSERT INTO public.who_global_data VALUES (92798, 0, 0, 0, 0, 392, 213);
INSERT INTO public.who_global_data VALUES (92799, 0, 0, 0, 0, 392, 118);
INSERT INTO public.who_global_data VALUES (92800, 0, 0, 0, 0, 392, 134);
INSERT INTO public.who_global_data VALUES (92801, 0, 0, 0, 0, 392, 65);
INSERT INTO public.who_global_data VALUES (92802, 0, 0, 0, 0, 392, 102);
INSERT INTO public.who_global_data VALUES (92803, 0, 0, 0, 0, 392, 223);
INSERT INTO public.who_global_data VALUES (92804, 0, 0, 0, 0, 392, 4);
INSERT INTO public.who_global_data VALUES (92805, 0, 0, 0, 0, 392, 146);
INSERT INTO public.who_global_data VALUES (92806, 0, 0, 0, 0, 392, 31);
INSERT INTO public.who_global_data VALUES (92807, 0, 0, 0, 0, 392, 127);
INSERT INTO public.who_global_data VALUES (92808, 0, 0, 0, 0, 392, 22);
INSERT INTO public.who_global_data VALUES (92809, 0, 0, 0, 0, 392, 115);
INSERT INTO public.who_global_data VALUES (92810, 0, 0, 0, 0, 392, 106);
INSERT INTO public.who_global_data VALUES (92811, 0, 0, 0, 0, 392, 90);
INSERT INTO public.who_global_data VALUES (92812, 0, 0, 0, 0, 392, 70);
INSERT INTO public.who_global_data VALUES (92813, 0, 0, 0, 0, 392, 46);
INSERT INTO public.who_global_data VALUES (92814, 0, 0, 0, 0, 392, 139);
INSERT INTO public.who_global_data VALUES (92815, 0, 0, 0, 0, 392, 42);
INSERT INTO public.who_global_data VALUES (92816, 0, 0, 0, 0, 392, 80);
INSERT INTO public.who_global_data VALUES (92817, 0, 0, 0, 0, 392, 203);
INSERT INTO public.who_global_data VALUES (92818, 0, 0, 0, 0, 392, 136);
INSERT INTO public.who_global_data VALUES (92819, 0, 0, 0, 0, 392, 63);
INSERT INTO public.who_global_data VALUES (92820, 0, 0, 0, 0, 392, 17);
INSERT INTO public.who_global_data VALUES (92821, 0, 0, 0, 0, 392, 172);
INSERT INTO public.who_global_data VALUES (92822, 0, 0, 0, 0, 392, 109);
INSERT INTO public.who_global_data VALUES (92823, 0, 0, 0, 0, 392, 200);
INSERT INTO public.who_global_data VALUES (92824, 0, 0, 0, 0, 392, 93);
INSERT INTO public.who_global_data VALUES (92825, 0, 0, 0, 0, 392, 5);
INSERT INTO public.who_global_data VALUES (92826, 0, 0, 0, 0, 392, 214);
INSERT INTO public.who_global_data VALUES (92827, 0, 0, 0, 0, 392, 204);
INSERT INTO public.who_global_data VALUES (92828, 0, 0, 0, 0, 392, 198);
INSERT INTO public.who_global_data VALUES (92829, 0, 0, 0, 0, 392, 173);
INSERT INTO public.who_global_data VALUES (92830, 0, 0, 0, 0, 392, 229);
INSERT INTO public.who_global_data VALUES (92831, 0, 0, 0, 0, 392, 76);
INSERT INTO public.who_global_data VALUES (92832, 0, 0, 0, 0, 392, 138);
INSERT INTO public.who_global_data VALUES (92833, 0, 0, 0, 0, 392, 98);
INSERT INTO public.who_global_data VALUES (92834, 0, 0, 0, 0, 392, 103);
INSERT INTO public.who_global_data VALUES (92835, 0, 0, 0, 0, 392, 225);
INSERT INTO public.who_global_data VALUES (92836, 0, 0, 0, 0, 392, 131);
INSERT INTO public.who_global_data VALUES (92837, 0, 0, 0, 0, 392, 235);
INSERT INTO public.who_global_data VALUES (92838, 0, 0, 0, 0, 392, 137);
INSERT INTO public.who_global_data VALUES (92839, 0, 0, 0, 0, 392, 81);
INSERT INTO public.who_global_data VALUES (92840, 0, 0, 0, 0, 392, 182);
INSERT INTO public.who_global_data VALUES (92841, 0, 0, 0, 0, 392, 145);
INSERT INTO public.who_global_data VALUES (92842, 0, 0, 0, 0, 392, 26);
INSERT INTO public.who_global_data VALUES (92843, 0, 0, 0, 0, 392, 170);
INSERT INTO public.who_global_data VALUES (92844, 0, 0, 0, 0, 392, 191);
INSERT INTO public.who_global_data VALUES (92845, 0, 0, 0, 0, 392, 221);
INSERT INTO public.who_global_data VALUES (92846, 0, 0, 0, 0, 392, 64);
INSERT INTO public.who_global_data VALUES (92847, 0, 0, 0, 0, 392, 116);
INSERT INTO public.who_global_data VALUES (92848, 0, 0, 0, 0, 392, 128);
INSERT INTO public.who_global_data VALUES (92849, 0, 0, 0, 0, 392, 6);
INSERT INTO public.who_global_data VALUES (92850, 0, 0, 0, 0, 392, 227);
INSERT INTO public.who_global_data VALUES (92851, 0, 0, 0, 0, 392, 68);
INSERT INTO public.who_global_data VALUES (92852, 0, 0, 0, 0, 392, 184);
INSERT INTO public.who_global_data VALUES (92853, 0, 0, 0, 0, 392, 82);
INSERT INTO public.who_global_data VALUES (92854, 0, 0, 0, 0, 392, 149);
INSERT INTO public.who_global_data VALUES (92855, 0, 0, 0, 0, 392, 197);
INSERT INTO public.who_global_data VALUES (92856, 0, 0, 0, 0, 392, 78);
INSERT INTO public.who_global_data VALUES (92857, 0, 0, 0, 0, 392, 233);
INSERT INTO public.who_global_data VALUES (92858, 0, 0, 0, 0, 392, 133);
INSERT INTO public.who_global_data VALUES (92859, 0, 0, 0, 0, 392, 35);
INSERT INTO public.who_global_data VALUES (92860, 0, 0, 0, 0, 392, 114);
INSERT INTO public.who_global_data VALUES (92861, 0, 0, 0, 0, 392, 237);
INSERT INTO public.who_global_data VALUES (92862, 0, 0, 0, 0, 392, 55);
INSERT INTO public.who_global_data VALUES (92863, 0, 0, 0, 0, 392, 176);
INSERT INTO public.who_global_data VALUES (92864, 0, 0, 0, 0, 392, 202);
INSERT INTO public.who_global_data VALUES (92865, 0, 0, 0, 0, 392, 155);
INSERT INTO public.who_global_data VALUES (92866, 0, 0, 0, 0, 392, 32);
INSERT INTO public.who_global_data VALUES (92867, 0, 0, 0, 0, 392, 220);
INSERT INTO public.who_global_data VALUES (92868, 0, 0, 0, 0, 392, 30);
INSERT INTO public.who_global_data VALUES (92869, 0, 0, 0, 0, 392, 147);
INSERT INTO public.who_global_data VALUES (92870, 0, 0, 0, 0, 392, 208);
INSERT INTO public.who_global_data VALUES (92871, 0, 0, 0, 0, 392, 45);
INSERT INTO public.who_global_data VALUES (92872, 0, 0, 0, 0, 392, 110);
INSERT INTO public.who_global_data VALUES (92873, 0, 0, 0, 0, 392, 88);
INSERT INTO public.who_global_data VALUES (92874, 0, 0, 0, 0, 392, 51);
INSERT INTO public.who_global_data VALUES (92875, 0, 0, 0, 0, 392, 209);
INSERT INTO public.who_global_data VALUES (92876, 0, 0, 0, 0, 392, 205);
INSERT INTO public.who_global_data VALUES (92877, 0, 0, 0, 0, 392, 18);
INSERT INTO public.who_global_data VALUES (92878, 0, 0, 0, 0, 392, 72);
INSERT INTO public.who_global_data VALUES (92879, 0, 0, 0, 0, 392, 44);
INSERT INTO public.who_global_data VALUES (92880, 0, 0, 0, 0, 392, 15);
INSERT INTO public.who_global_data VALUES (92881, 0, 0, 0, 0, 392, 25);
INSERT INTO public.who_global_data VALUES (92882, 0, 0, 0, 0, 392, 179);
INSERT INTO public.who_global_data VALUES (92883, 0, 0, 0, 0, 392, 34);
INSERT INTO public.who_global_data VALUES (92884, 0, 0, 0, 0, 392, 207);
INSERT INTO public.who_global_data VALUES (92885, 0, 0, 0, 0, 392, 166);
INSERT INTO public.who_global_data VALUES (92886, 0, 0, 0, 0, 392, 126);
INSERT INTO public.who_global_data VALUES (92887, 0, 0, 0, 0, 392, 97);
INSERT INTO public.who_global_data VALUES (92888, 0, 0, 0, 0, 392, 36);
INSERT INTO public.who_global_data VALUES (92889, 0, 0, 0, 0, 392, 125);
INSERT INTO public.who_global_data VALUES (92890, 0, 0, 0, 0, 392, 124);
INSERT INTO public.who_global_data VALUES (92891, 0, 0, 0, 0, 392, 185);
INSERT INTO public.who_global_data VALUES (92892, 0, 0, 0, 0, 392, 194);
INSERT INTO public.who_global_data VALUES (92893, 0, 0, 0, 0, 392, 144);
INSERT INTO public.who_global_data VALUES (92894, 0, 0, 0, 0, 392, 19);
INSERT INTO public.who_global_data VALUES (92895, 0, 0, 0, 0, 392, 217);
INSERT INTO public.who_global_data VALUES (92896, 0, 0, 0, 0, 392, 148);
INSERT INTO public.who_global_data VALUES (92897, 0, 0, 0, 0, 392, 86);
INSERT INTO public.who_global_data VALUES (92898, 0, 0, 0, 0, 392, 13);
INSERT INTO public.who_global_data VALUES (92899, 0, 0, 0, 0, 392, 157);
INSERT INTO public.who_global_data VALUES (92900, 0, 0, 0, 0, 392, 8);
INSERT INTO public.who_global_data VALUES (92901, 0, 0, 0, 0, 392, 73);
INSERT INTO public.who_global_data VALUES (92902, 0, 0, 0, 0, 392, 101);
INSERT INTO public.who_global_data VALUES (92903, 0, 0, 0, 0, 392, 165);
INSERT INTO public.who_global_data VALUES (92904, 0, 0, 0, 0, 392, 14);
INSERT INTO public.who_global_data VALUES (92905, 0, 0, 0, 0, 393, 193);
INSERT INTO public.who_global_data VALUES (92906, 0, 0, 0, 0, 393, 113);
INSERT INTO public.who_global_data VALUES (92907, 0, 0, 0, 0, 393, 143);
INSERT INTO public.who_global_data VALUES (92908, 0, 0, 0, 0, 393, 219);
INSERT INTO public.who_global_data VALUES (92909, 0, 0, 0, 0, 393, 186);
INSERT INTO public.who_global_data VALUES (92910, 0, 0, 0, 0, 393, 52);
INSERT INTO public.who_global_data VALUES (92911, 0, 0, 0, 0, 393, 180);
INSERT INTO public.who_global_data VALUES (92912, 0, 0, 0, 0, 393, 167);
INSERT INTO public.who_global_data VALUES (92913, 0, 0, 0, 0, 393, 154);
INSERT INTO public.who_global_data VALUES (92914, 0, 0, 0, 0, 393, 94);
INSERT INTO public.who_global_data VALUES (92915, 0, 0, 0, 0, 393, 66);
INSERT INTO public.who_global_data VALUES (92916, 0, 0, 0, 0, 393, 58);
INSERT INTO public.who_global_data VALUES (92917, 0, 0, 0, 0, 393, 163);
INSERT INTO public.who_global_data VALUES (92918, 0, 0, 0, 0, 393, 37);
INSERT INTO public.who_global_data VALUES (92919, 0, 0, 0, 0, 393, 142);
INSERT INTO public.who_global_data VALUES (92920, 0, 0, 0, 0, 393, 83);
INSERT INTO public.who_global_data VALUES (92921, 0, 0, 0, 0, 393, 228);
INSERT INTO public.who_global_data VALUES (92922, 0, 0, 0, 0, 393, 188);
INSERT INTO public.who_global_data VALUES (92923, 0, 0, 0, 0, 393, 62);
INSERT INTO public.who_global_data VALUES (92924, 0, 0, 0, 0, 393, 160);
INSERT INTO public.who_global_data VALUES (92925, 0, 0, 0, 0, 393, 50);
INSERT INTO public.who_global_data VALUES (92926, 0, 0, 0, 0, 393, 33);
INSERT INTO public.who_global_data VALUES (92927, 0, 0, 0, 0, 393, 183);
INSERT INTO public.who_global_data VALUES (92928, 0, 0, 0, 0, 393, 92);
INSERT INTO public.who_global_data VALUES (92929, 0, 0, 0, 0, 393, 158);
INSERT INTO public.who_global_data VALUES (92930, 0, 0, 0, 0, 393, 67);
INSERT INTO public.who_global_data VALUES (92931, 0, 0, 0, 0, 393, 57);
INSERT INTO public.who_global_data VALUES (92932, 0, 0, 0, 0, 393, 38);
INSERT INTO public.who_global_data VALUES (92933, 0, 0, 0, 0, 393, 141);
INSERT INTO public.who_global_data VALUES (92934, 0, 0, 0, 0, 393, 178);
INSERT INTO public.who_global_data VALUES (92935, 0, 0, 0, 0, 393, 108);
INSERT INTO public.who_global_data VALUES (92936, 0, 0, 0, 0, 393, 39);
INSERT INTO public.who_global_data VALUES (92937, 0, 0, 0, 0, 393, 2);
INSERT INTO public.who_global_data VALUES (92938, 0, 0, 0, 0, 393, 195);
INSERT INTO public.who_global_data VALUES (92939, 0, 0, 0, 0, 393, 107);
INSERT INTO public.who_global_data VALUES (92940, 0, 0, 0, 0, 393, 161);
INSERT INTO public.who_global_data VALUES (92941, 0, 0, 0, 0, 393, 212);
INSERT INTO public.who_global_data VALUES (92942, 0, 0, 0, 0, 393, 181);
INSERT INTO public.who_global_data VALUES (92943, 0, 0, 0, 0, 393, 53);
INSERT INTO public.who_global_data VALUES (92944, 0, 0, 0, 0, 393, 164);
INSERT INTO public.who_global_data VALUES (92945, 0, 0, 0, 0, 393, 140);
INSERT INTO public.who_global_data VALUES (92946, 0, 0, 0, 0, 393, 20);
INSERT INTO public.who_global_data VALUES (92947, 0, 4, 0, 0, 393, 112);
INSERT INTO public.who_global_data VALUES (92948, 0, 0, 0, 0, 393, 111);
INSERT INTO public.who_global_data VALUES (92949, 0, 0, 0, 0, 393, 71);
INSERT INTO public.who_global_data VALUES (92950, 0, 0, 0, 0, 393, 218);
INSERT INTO public.who_global_data VALUES (92951, 0, 0, 0, 0, 393, 43);
INSERT INTO public.who_global_data VALUES (92952, 0, 0, 0, 0, 393, 49);
INSERT INTO public.who_global_data VALUES (92953, 0, 0, 0, 0, 393, 1);
INSERT INTO public.who_global_data VALUES (92954, 0, 0, 0, 0, 393, 48);
INSERT INTO public.who_global_data VALUES (92955, 0, 0, 0, 0, 393, 232);
INSERT INTO public.who_global_data VALUES (92956, 0, 0, 0, 0, 393, 175);
INSERT INTO public.who_global_data VALUES (92957, 0, 0, 0, 0, 393, 21);
INSERT INTO public.who_global_data VALUES (92958, 0, 0, 0, 0, 393, 156);
INSERT INTO public.who_global_data VALUES (92959, 0, 0, 0, 0, 393, 95);
INSERT INTO public.who_global_data VALUES (92960, 0, 0, 0, 0, 393, 177);
INSERT INTO public.who_global_data VALUES (92961, 0, 0, 0, 0, 393, 210);
INSERT INTO public.who_global_data VALUES (92962, 0, 0, 0, 0, 393, 120);
INSERT INTO public.who_global_data VALUES (92963, 0, 0, 0, 0, 393, 135);
INSERT INTO public.who_global_data VALUES (92964, 0, 0, 0, 0, 393, 206);
INSERT INTO public.who_global_data VALUES (92965, 0, 0, 0, 0, 393, 189);
INSERT INTO public.who_global_data VALUES (92966, 0, 0, 0, 0, 393, 129);
INSERT INTO public.who_global_data VALUES (92967, 0, 0, 0, 0, 393, 121);
INSERT INTO public.who_global_data VALUES (92968, 0, 0, 0, 0, 393, 59);
INSERT INTO public.who_global_data VALUES (92969, 0, 0, 0, 0, 393, 96);
INSERT INTO public.who_global_data VALUES (92970, 0, 0, 0, 0, 393, 41);
INSERT INTO public.who_global_data VALUES (92971, 0, 0, 0, 0, 393, 216);
INSERT INTO public.who_global_data VALUES (92972, 0, 0, 0, 0, 393, 236);
INSERT INTO public.who_global_data VALUES (92973, 0, 0, 0, 0, 393, 150);
INSERT INTO public.who_global_data VALUES (92974, 0, 0, 0, 0, 393, 61);
INSERT INTO public.who_global_data VALUES (92975, 0, 0, 0, 0, 393, 7);
INSERT INTO public.who_global_data VALUES (92976, 0, 0, 0, 0, 393, 169);
INSERT INTO public.who_global_data VALUES (92977, 0, 0, 0, 0, 393, 28);
INSERT INTO public.who_global_data VALUES (92978, 0, 0, 0, 0, 393, 85);
INSERT INTO public.who_global_data VALUES (92979, 0, 0, 0, 0, 393, 211);
INSERT INTO public.who_global_data VALUES (92980, 0, 0, 0, 0, 393, 60);
INSERT INTO public.who_global_data VALUES (92981, 0, 0, 0, 0, 393, 3);
INSERT INTO public.who_global_data VALUES (92982, 0, 0, 0, 0, 393, 11);
INSERT INTO public.who_global_data VALUES (92983, 0, 0, 0, 0, 393, 89);
INSERT INTO public.who_global_data VALUES (92984, 0, 0, 0, 0, 393, 24);
INSERT INTO public.who_global_data VALUES (92985, 0, 0, 0, 0, 393, 162);
INSERT INTO public.who_global_data VALUES (92986, 0, 0, 0, 0, 393, 100);
INSERT INTO public.who_global_data VALUES (92987, 0, 0, 0, 0, 393, 47);
INSERT INTO public.who_global_data VALUES (92988, 0, 0, 0, 0, 393, 29);
INSERT INTO public.who_global_data VALUES (92989, 0, 0, 0, 0, 393, 40);
INSERT INTO public.who_global_data VALUES (92990, 0, 0, 0, 0, 393, 222);
INSERT INTO public.who_global_data VALUES (92991, 0, 0, 0, 0, 393, 132);
INSERT INTO public.who_global_data VALUES (92992, 0, 0, 0, 0, 393, 130);
INSERT INTO public.who_global_data VALUES (92993, 0, 0, 0, 0, 393, 234);
INSERT INTO public.who_global_data VALUES (92994, 0, 0, 0, 0, 393, 23);
INSERT INTO public.who_global_data VALUES (92995, 0, 0, 0, 0, 393, 192);
INSERT INTO public.who_global_data VALUES (92996, 0, 0, 0, 0, 393, 69);
INSERT INTO public.who_global_data VALUES (92997, 0, 0, 0, 0, 393, 187);
INSERT INTO public.who_global_data VALUES (92998, 0, 0, 0, 0, 393, 230);
INSERT INTO public.who_global_data VALUES (92999, 0, 0, 0, 0, 393, 77);
INSERT INTO public.who_global_data VALUES (93000, 0, 0, 0, 0, 393, 9);
INSERT INTO public.who_global_data VALUES (93001, 0, 0, 0, 0, 393, 74);
INSERT INTO public.who_global_data VALUES (93002, 0, 0, 0, 0, 393, 224);
INSERT INTO public.who_global_data VALUES (93003, 0, 0, 0, 0, 393, 199);
INSERT INTO public.who_global_data VALUES (93004, 0, 0, 0, 0, 393, 190);
INSERT INTO public.who_global_data VALUES (93005, 0, 0, 0, 0, 393, 12);
INSERT INTO public.who_global_data VALUES (93006, 0, 0, 0, 0, 393, 104);
INSERT INTO public.who_global_data VALUES (93007, 0, 0, 0, 0, 393, 153);
INSERT INTO public.who_global_data VALUES (93008, 0, 0, 0, 0, 393, 91);
INSERT INTO public.who_global_data VALUES (93009, 0, 0, 0, 0, 393, 215);
INSERT INTO public.who_global_data VALUES (93010, 0, 0, 0, 0, 393, 84);
INSERT INTO public.who_global_data VALUES (93011, 0, 0, 0, 0, 393, 231);
INSERT INTO public.who_global_data VALUES (93012, 0, 0, 0, 0, 393, 196);
INSERT INTO public.who_global_data VALUES (93013, 0, 0, 0, 0, 393, 105);
INSERT INTO public.who_global_data VALUES (93014, 0, 0, 0, 0, 393, 122);
INSERT INTO public.who_global_data VALUES (93015, 0, 0, 0, 0, 393, 159);
INSERT INTO public.who_global_data VALUES (93016, 0, 0, 0, 0, 393, 75);
INSERT INTO public.who_global_data VALUES (93017, 0, 0, 0, 0, 393, 27);
INSERT INTO public.who_global_data VALUES (93018, 0, 0, 0, 0, 393, 54);
INSERT INTO public.who_global_data VALUES (93019, 0, 0, 0, 0, 393, 226);
INSERT INTO public.who_global_data VALUES (93020, 0, 0, 0, 0, 393, 79);
INSERT INTO public.who_global_data VALUES (93021, 0, 0, 0, 0, 393, 56);
INSERT INTO public.who_global_data VALUES (93022, 0, 0, 0, 0, 393, 117);
INSERT INTO public.who_global_data VALUES (93023, 0, 0, 0, 0, 393, 152);
INSERT INTO public.who_global_data VALUES (93024, 0, 0, 0, 0, 393, 16);
INSERT INTO public.who_global_data VALUES (93025, 0, 0, 0, 0, 393, 10);
INSERT INTO public.who_global_data VALUES (93026, 0, 0, 0, 0, 393, 201);
INSERT INTO public.who_global_data VALUES (93027, 0, 0, 0, 0, 393, 174);
INSERT INTO public.who_global_data VALUES (93028, 0, 0, 0, 0, 393, 119);
INSERT INTO public.who_global_data VALUES (93029, 0, 0, 0, 0, 393, 168);
INSERT INTO public.who_global_data VALUES (93030, 0, 0, 0, 0, 393, 99);
INSERT INTO public.who_global_data VALUES (93031, 0, 0, 0, 0, 393, 171);
INSERT INTO public.who_global_data VALUES (93032, 0, 0, 0, 0, 393, 87);
INSERT INTO public.who_global_data VALUES (93033, 0, 0, 0, 0, 393, 123);
INSERT INTO public.who_global_data VALUES (93034, 0, 0, 0, 0, 393, 151);
INSERT INTO public.who_global_data VALUES (93035, 0, 0, 0, 0, 393, 213);
INSERT INTO public.who_global_data VALUES (93036, 0, 0, 0, 0, 393, 118);
INSERT INTO public.who_global_data VALUES (93037, 0, 0, 0, 0, 393, 134);
INSERT INTO public.who_global_data VALUES (93038, 0, 0, 0, 0, 393, 65);
INSERT INTO public.who_global_data VALUES (93039, 0, 0, 0, 0, 393, 102);
INSERT INTO public.who_global_data VALUES (93040, 0, 0, 0, 0, 393, 223);
INSERT INTO public.who_global_data VALUES (93041, 0, 0, 0, 0, 393, 4);
INSERT INTO public.who_global_data VALUES (93042, 0, 0, 0, 0, 393, 146);
INSERT INTO public.who_global_data VALUES (93043, 0, 0, 0, 0, 393, 31);
INSERT INTO public.who_global_data VALUES (93044, 0, 0, 0, 0, 393, 127);
INSERT INTO public.who_global_data VALUES (93045, 0, 0, 0, 0, 393, 22);
INSERT INTO public.who_global_data VALUES (93046, 0, 0, 0, 0, 393, 115);
INSERT INTO public.who_global_data VALUES (93047, 0, 0, 0, 0, 393, 106);
INSERT INTO public.who_global_data VALUES (93048, 0, 0, 0, 0, 393, 90);
INSERT INTO public.who_global_data VALUES (93049, 0, 0, 0, 0, 393, 70);
INSERT INTO public.who_global_data VALUES (93050, 0, 0, 0, 0, 393, 46);
INSERT INTO public.who_global_data VALUES (93051, 0, 0, 0, 0, 393, 139);
INSERT INTO public.who_global_data VALUES (93052, 0, 0, 0, 0, 393, 42);
INSERT INTO public.who_global_data VALUES (93053, 0, 0, 0, 0, 393, 80);
INSERT INTO public.who_global_data VALUES (93054, 0, 0, 0, 0, 393, 203);
INSERT INTO public.who_global_data VALUES (93055, 0, 0, 0, 0, 393, 136);
INSERT INTO public.who_global_data VALUES (93056, 0, 0, 0, 0, 393, 63);
INSERT INTO public.who_global_data VALUES (93057, 0, 0, 0, 0, 393, 17);
INSERT INTO public.who_global_data VALUES (93058, 0, 0, 0, 0, 393, 172);
INSERT INTO public.who_global_data VALUES (93059, 0, 0, 0, 0, 393, 109);
INSERT INTO public.who_global_data VALUES (93060, 0, 0, 0, 0, 393, 200);
INSERT INTO public.who_global_data VALUES (93061, 0, 0, 0, 0, 393, 93);
INSERT INTO public.who_global_data VALUES (93062, 0, 0, 0, 0, 393, 5);
INSERT INTO public.who_global_data VALUES (93063, 0, 0, 0, 0, 393, 214);
INSERT INTO public.who_global_data VALUES (93064, 0, 0, 0, 0, 393, 204);
INSERT INTO public.who_global_data VALUES (93065, 0, 0, 0, 0, 393, 198);
INSERT INTO public.who_global_data VALUES (93066, 0, 0, 0, 0, 393, 173);
INSERT INTO public.who_global_data VALUES (93067, 0, 0, 0, 0, 393, 229);
INSERT INTO public.who_global_data VALUES (93068, 0, 0, 0, 0, 393, 76);
INSERT INTO public.who_global_data VALUES (93069, 0, 0, 0, 0, 393, 138);
INSERT INTO public.who_global_data VALUES (93070, 0, 0, 0, 0, 393, 98);
INSERT INTO public.who_global_data VALUES (93071, 0, 0, 0, 0, 393, 103);
INSERT INTO public.who_global_data VALUES (93072, 0, 0, 0, 0, 393, 225);
INSERT INTO public.who_global_data VALUES (93073, 0, 0, 0, 0, 393, 131);
INSERT INTO public.who_global_data VALUES (93074, 0, 0, 0, 0, 393, 235);
INSERT INTO public.who_global_data VALUES (93075, 0, 0, 0, 0, 393, 137);
INSERT INTO public.who_global_data VALUES (93076, 0, 0, 0, 0, 393, 81);
INSERT INTO public.who_global_data VALUES (93077, 0, 0, 0, 0, 393, 182);
INSERT INTO public.who_global_data VALUES (93078, 0, 0, 0, 0, 393, 145);
INSERT INTO public.who_global_data VALUES (93079, 0, 0, 0, 0, 393, 26);
INSERT INTO public.who_global_data VALUES (93080, 0, 0, 0, 0, 393, 170);
INSERT INTO public.who_global_data VALUES (93081, 0, 0, 0, 0, 393, 191);
INSERT INTO public.who_global_data VALUES (93082, 0, 0, 0, 0, 393, 221);
INSERT INTO public.who_global_data VALUES (93083, 0, 0, 0, 0, 393, 64);
INSERT INTO public.who_global_data VALUES (93084, 0, 0, 0, 0, 393, 116);
INSERT INTO public.who_global_data VALUES (93085, 0, 0, 0, 0, 393, 128);
INSERT INTO public.who_global_data VALUES (93086, 0, 0, 0, 0, 393, 6);
INSERT INTO public.who_global_data VALUES (93087, 0, 0, 0, 0, 393, 227);
INSERT INTO public.who_global_data VALUES (93088, 0, 0, 0, 0, 393, 68);
INSERT INTO public.who_global_data VALUES (93089, 0, 0, 0, 0, 393, 184);
INSERT INTO public.who_global_data VALUES (93090, 0, 0, 0, 0, 393, 82);
INSERT INTO public.who_global_data VALUES (93091, 0, 0, 0, 0, 393, 149);
INSERT INTO public.who_global_data VALUES (93092, 0, 0, 0, 0, 393, 197);
INSERT INTO public.who_global_data VALUES (93093, 0, 0, 0, 0, 393, 78);
INSERT INTO public.who_global_data VALUES (93094, 0, 0, 0, 0, 393, 233);
INSERT INTO public.who_global_data VALUES (93095, 0, 0, 0, 0, 393, 133);
INSERT INTO public.who_global_data VALUES (93096, 0, 0, 0, 0, 393, 35);
INSERT INTO public.who_global_data VALUES (93097, 0, 0, 0, 0, 393, 114);
INSERT INTO public.who_global_data VALUES (93098, 0, 0, 0, 0, 393, 237);
INSERT INTO public.who_global_data VALUES (93099, 0, 0, 0, 0, 393, 55);
INSERT INTO public.who_global_data VALUES (93100, 0, 0, 0, 0, 393, 176);
INSERT INTO public.who_global_data VALUES (93101, 0, 0, 0, 0, 393, 202);
INSERT INTO public.who_global_data VALUES (93102, 0, 0, 0, 0, 393, 155);
INSERT INTO public.who_global_data VALUES (93103, 0, 0, 0, 0, 393, 32);
INSERT INTO public.who_global_data VALUES (93104, 0, 0, 0, 0, 393, 220);
INSERT INTO public.who_global_data VALUES (93105, 0, 0, 0, 0, 393, 30);
INSERT INTO public.who_global_data VALUES (93106, 0, 0, 0, 0, 393, 147);
INSERT INTO public.who_global_data VALUES (93107, 0, 0, 0, 0, 393, 208);
INSERT INTO public.who_global_data VALUES (93108, 0, 0, 0, 0, 393, 45);
INSERT INTO public.who_global_data VALUES (93109, 0, 0, 0, 0, 393, 110);
INSERT INTO public.who_global_data VALUES (93110, 0, 0, 0, 0, 393, 88);
INSERT INTO public.who_global_data VALUES (93111, 0, 0, 0, 0, 393, 51);
INSERT INTO public.who_global_data VALUES (93112, 0, 0, 0, 0, 393, 209);
INSERT INTO public.who_global_data VALUES (93113, 0, 0, 0, 0, 393, 205);
INSERT INTO public.who_global_data VALUES (93114, 0, 0, 0, 0, 393, 18);
INSERT INTO public.who_global_data VALUES (93115, 0, 0, 0, 0, 393, 72);
INSERT INTO public.who_global_data VALUES (93116, 0, 0, 0, 0, 393, 44);
INSERT INTO public.who_global_data VALUES (93117, 0, 0, 0, 0, 393, 15);
INSERT INTO public.who_global_data VALUES (93118, 0, 0, 0, 0, 393, 25);
INSERT INTO public.who_global_data VALUES (93119, 0, 0, 0, 0, 393, 179);
INSERT INTO public.who_global_data VALUES (93120, 0, 0, 0, 0, 393, 34);
INSERT INTO public.who_global_data VALUES (93121, 0, 0, 0, 0, 393, 207);
INSERT INTO public.who_global_data VALUES (93122, 0, 0, 0, 0, 393, 166);
INSERT INTO public.who_global_data VALUES (93123, 0, 0, 0, 0, 393, 126);
INSERT INTO public.who_global_data VALUES (93124, 0, 0, 0, 0, 393, 97);
INSERT INTO public.who_global_data VALUES (93125, 0, 0, 0, 0, 393, 36);
INSERT INTO public.who_global_data VALUES (93126, 0, 0, 0, 0, 393, 125);
INSERT INTO public.who_global_data VALUES (93127, 0, 0, 0, 0, 393, 124);
INSERT INTO public.who_global_data VALUES (93128, 0, 0, 0, 0, 393, 185);
INSERT INTO public.who_global_data VALUES (93129, 0, 0, 0, 0, 393, 194);
INSERT INTO public.who_global_data VALUES (93130, 0, 0, 0, 0, 393, 144);
INSERT INTO public.who_global_data VALUES (93131, 0, 0, 0, 0, 393, 19);
INSERT INTO public.who_global_data VALUES (93132, 0, 0, 0, 0, 393, 217);
INSERT INTO public.who_global_data VALUES (93133, 0, 0, 0, 0, 393, 148);
INSERT INTO public.who_global_data VALUES (93134, 0, 0, 0, 0, 393, 86);
INSERT INTO public.who_global_data VALUES (93135, 0, 0, 0, 0, 393, 13);
INSERT INTO public.who_global_data VALUES (93136, 0, 0, 0, 0, 393, 157);
INSERT INTO public.who_global_data VALUES (93137, 0, 0, 0, 0, 393, 8);
INSERT INTO public.who_global_data VALUES (93138, 0, 0, 0, 0, 393, 73);
INSERT INTO public.who_global_data VALUES (93139, 0, 0, 0, 0, 393, 101);
INSERT INTO public.who_global_data VALUES (93140, 0, 0, 0, 0, 393, 165);
INSERT INTO public.who_global_data VALUES (93141, 0, 0, 0, 0, 393, 14);
INSERT INTO public.who_global_data VALUES (93142, 0, 0, 0, 0, 394, 193);
INSERT INTO public.who_global_data VALUES (93143, 0, 0, 0, 0, 394, 113);
INSERT INTO public.who_global_data VALUES (93144, 0, 0, 0, 0, 394, 143);
INSERT INTO public.who_global_data VALUES (93145, 0, 0, 0, 0, 394, 219);
INSERT INTO public.who_global_data VALUES (93146, 0, 0, 0, 0, 394, 186);
INSERT INTO public.who_global_data VALUES (93147, 0, 0, 0, 0, 394, 52);
INSERT INTO public.who_global_data VALUES (93148, 0, 0, 0, 0, 394, 180);
INSERT INTO public.who_global_data VALUES (93149, 0, 0, 0, 0, 394, 167);
INSERT INTO public.who_global_data VALUES (93150, 0, 0, 0, 0, 394, 154);
INSERT INTO public.who_global_data VALUES (93151, 0, 0, 0, 0, 394, 94);
INSERT INTO public.who_global_data VALUES (93152, 0, 0, 0, 0, 394, 66);
INSERT INTO public.who_global_data VALUES (93153, 0, 0, 0, 0, 394, 58);
INSERT INTO public.who_global_data VALUES (93154, 0, 0, 0, 0, 394, 163);
INSERT INTO public.who_global_data VALUES (93155, 0, 0, 0, 0, 394, 37);
INSERT INTO public.who_global_data VALUES (93156, 0, 0, 0, 0, 394, 142);
INSERT INTO public.who_global_data VALUES (93157, 0, 0, 0, 0, 394, 83);
INSERT INTO public.who_global_data VALUES (93158, 0, 0, 0, 0, 394, 228);
INSERT INTO public.who_global_data VALUES (93159, 0, 0, 0, 0, 394, 188);
INSERT INTO public.who_global_data VALUES (93160, 0, 0, 0, 0, 394, 62);
INSERT INTO public.who_global_data VALUES (93161, 0, 0, 0, 0, 394, 160);
INSERT INTO public.who_global_data VALUES (93162, 0, 0, 0, 0, 394, 50);
INSERT INTO public.who_global_data VALUES (93163, 0, 0, 0, 0, 394, 33);
INSERT INTO public.who_global_data VALUES (93164, 0, 0, 0, 0, 394, 183);
INSERT INTO public.who_global_data VALUES (93165, 0, 0, 0, 0, 394, 92);
INSERT INTO public.who_global_data VALUES (93166, 0, 0, 0, 0, 394, 158);
INSERT INTO public.who_global_data VALUES (93167, 0, 0, 0, 0, 394, 67);
INSERT INTO public.who_global_data VALUES (93168, 0, 0, 0, 0, 394, 57);
INSERT INTO public.who_global_data VALUES (93169, 0, 0, 0, 0, 394, 38);
INSERT INTO public.who_global_data VALUES (93170, 0, 0, 0, 0, 394, 141);
INSERT INTO public.who_global_data VALUES (93171, 0, 0, 0, 0, 394, 178);
INSERT INTO public.who_global_data VALUES (93172, 0, 0, 0, 0, 394, 108);
INSERT INTO public.who_global_data VALUES (93173, 0, 0, 0, 0, 394, 39);
INSERT INTO public.who_global_data VALUES (93174, 0, 0, 0, 0, 394, 2);
INSERT INTO public.who_global_data VALUES (93175, 0, 0, 0, 0, 394, 195);
INSERT INTO public.who_global_data VALUES (93176, 0, 0, 0, 0, 394, 107);
INSERT INTO public.who_global_data VALUES (93177, 0, 0, 0, 0, 394, 161);
INSERT INTO public.who_global_data VALUES (93178, 0, 0, 0, 0, 394, 212);
INSERT INTO public.who_global_data VALUES (93179, 0, 0, 0, 0, 394, 181);
INSERT INTO public.who_global_data VALUES (93180, 0, 0, 0, 0, 394, 53);
INSERT INTO public.who_global_data VALUES (93181, 0, 0, 0, 0, 394, 164);
INSERT INTO public.who_global_data VALUES (93182, 0, 0, 0, 0, 394, 140);
INSERT INTO public.who_global_data VALUES (93183, 0, 0, 0, 0, 394, 20);
INSERT INTO public.who_global_data VALUES (93184, 0, 4, 0, 0, 394, 112);
INSERT INTO public.who_global_data VALUES (93185, 0, 0, 0, 0, 394, 111);
INSERT INTO public.who_global_data VALUES (93186, 0, 0, 0, 0, 394, 71);
INSERT INTO public.who_global_data VALUES (93187, 0, 0, 0, 0, 394, 218);
INSERT INTO public.who_global_data VALUES (93188, 0, 0, 0, 0, 394, 43);
INSERT INTO public.who_global_data VALUES (93189, 0, 0, 0, 0, 394, 49);
INSERT INTO public.who_global_data VALUES (93190, 0, 0, 0, 0, 394, 1);
INSERT INTO public.who_global_data VALUES (93191, 0, 0, 0, 0, 394, 48);
INSERT INTO public.who_global_data VALUES (93192, 0, 0, 0, 0, 394, 232);
INSERT INTO public.who_global_data VALUES (93193, 0, 0, 0, 0, 394, 175);
INSERT INTO public.who_global_data VALUES (93194, 0, 0, 0, 0, 394, 21);
INSERT INTO public.who_global_data VALUES (93195, 0, 0, 0, 0, 394, 156);
INSERT INTO public.who_global_data VALUES (93196, 0, 0, 0, 0, 394, 95);
INSERT INTO public.who_global_data VALUES (93197, 0, 0, 0, 0, 394, 177);
INSERT INTO public.who_global_data VALUES (93198, 0, 0, 0, 0, 394, 210);
INSERT INTO public.who_global_data VALUES (93199, 0, 0, 0, 0, 394, 120);
INSERT INTO public.who_global_data VALUES (93200, 0, 0, 0, 0, 394, 135);
INSERT INTO public.who_global_data VALUES (93201, 0, 0, 0, 0, 394, 206);
INSERT INTO public.who_global_data VALUES (93202, 0, 0, 0, 0, 394, 189);
INSERT INTO public.who_global_data VALUES (93203, 0, 0, 0, 0, 394, 129);
INSERT INTO public.who_global_data VALUES (93204, 0, 0, 0, 0, 394, 121);
INSERT INTO public.who_global_data VALUES (93205, 0, 0, 0, 0, 394, 59);
INSERT INTO public.who_global_data VALUES (93206, 0, 0, 0, 0, 394, 96);
INSERT INTO public.who_global_data VALUES (93207, 0, 0, 0, 0, 394, 41);
INSERT INTO public.who_global_data VALUES (93208, 0, 0, 0, 0, 394, 216);
INSERT INTO public.who_global_data VALUES (93209, 0, 0, 0, 0, 394, 236);
INSERT INTO public.who_global_data VALUES (93210, 0, 0, 0, 0, 394, 150);
INSERT INTO public.who_global_data VALUES (93211, 0, 0, 0, 0, 394, 61);
INSERT INTO public.who_global_data VALUES (93212, 0, 0, 0, 0, 394, 7);
INSERT INTO public.who_global_data VALUES (93213, 0, 0, 0, 0, 394, 169);
INSERT INTO public.who_global_data VALUES (93214, 0, 0, 0, 0, 394, 28);
INSERT INTO public.who_global_data VALUES (93215, 0, 0, 0, 0, 394, 85);
INSERT INTO public.who_global_data VALUES (93216, 0, 0, 0, 0, 394, 211);
INSERT INTO public.who_global_data VALUES (93217, 0, 0, 0, 0, 394, 60);
INSERT INTO public.who_global_data VALUES (93218, 0, 0, 0, 0, 394, 3);
INSERT INTO public.who_global_data VALUES (93219, 0, 0, 0, 0, 394, 11);
INSERT INTO public.who_global_data VALUES (93220, 0, 0, 0, 0, 394, 89);
INSERT INTO public.who_global_data VALUES (93221, 0, 0, 0, 0, 394, 24);
INSERT INTO public.who_global_data VALUES (93222, 0, 0, 0, 0, 394, 162);
INSERT INTO public.who_global_data VALUES (93223, 0, 0, 0, 0, 394, 100);
INSERT INTO public.who_global_data VALUES (93224, 0, 0, 0, 0, 394, 47);
INSERT INTO public.who_global_data VALUES (93225, 0, 0, 0, 0, 394, 29);
INSERT INTO public.who_global_data VALUES (93226, 0, 0, 0, 0, 394, 40);
INSERT INTO public.who_global_data VALUES (93227, 0, 0, 0, 0, 394, 222);
INSERT INTO public.who_global_data VALUES (93228, 0, 0, 0, 0, 394, 132);
INSERT INTO public.who_global_data VALUES (93229, 0, 0, 0, 0, 394, 130);
INSERT INTO public.who_global_data VALUES (93230, 0, 0, 0, 0, 394, 234);
INSERT INTO public.who_global_data VALUES (93231, 0, 0, 0, 0, 394, 23);
INSERT INTO public.who_global_data VALUES (93232, 0, 0, 0, 0, 394, 192);
INSERT INTO public.who_global_data VALUES (93233, 0, 0, 0, 0, 394, 69);
INSERT INTO public.who_global_data VALUES (93234, 0, 0, 0, 0, 394, 187);
INSERT INTO public.who_global_data VALUES (93235, 0, 0, 0, 0, 394, 230);
INSERT INTO public.who_global_data VALUES (93236, 0, 0, 0, 0, 394, 77);
INSERT INTO public.who_global_data VALUES (93237, 0, 0, 0, 0, 394, 9);
INSERT INTO public.who_global_data VALUES (93238, 0, 0, 0, 0, 394, 74);
INSERT INTO public.who_global_data VALUES (93239, 0, 0, 0, 0, 394, 224);
INSERT INTO public.who_global_data VALUES (93240, 0, 0, 0, 0, 394, 199);
INSERT INTO public.who_global_data VALUES (93241, 0, 0, 0, 0, 394, 190);
INSERT INTO public.who_global_data VALUES (93242, 0, 0, 0, 0, 394, 12);
INSERT INTO public.who_global_data VALUES (93243, 0, 0, 0, 0, 394, 104);
INSERT INTO public.who_global_data VALUES (93244, 0, 0, 0, 0, 394, 153);
INSERT INTO public.who_global_data VALUES (93245, 0, 0, 0, 0, 394, 91);
INSERT INTO public.who_global_data VALUES (93246, 0, 0, 0, 0, 394, 215);
INSERT INTO public.who_global_data VALUES (93247, 0, 0, 0, 0, 394, 84);
INSERT INTO public.who_global_data VALUES (93248, 0, 0, 0, 0, 394, 231);
INSERT INTO public.who_global_data VALUES (93249, 0, 0, 0, 0, 394, 196);
INSERT INTO public.who_global_data VALUES (93250, 0, 0, 0, 0, 394, 105);
INSERT INTO public.who_global_data VALUES (93251, 0, 0, 0, 0, 394, 122);
INSERT INTO public.who_global_data VALUES (93252, 0, 0, 0, 0, 394, 159);
INSERT INTO public.who_global_data VALUES (93253, 0, 0, 0, 0, 394, 75);
INSERT INTO public.who_global_data VALUES (93254, 0, 0, 0, 0, 394, 27);
INSERT INTO public.who_global_data VALUES (93255, 0, 0, 0, 0, 394, 54);
INSERT INTO public.who_global_data VALUES (93256, 0, 0, 0, 0, 394, 226);
INSERT INTO public.who_global_data VALUES (93257, 0, 0, 0, 0, 394, 79);
INSERT INTO public.who_global_data VALUES (93258, 0, 0, 0, 0, 394, 56);
INSERT INTO public.who_global_data VALUES (93259, 0, 0, 0, 0, 394, 117);
INSERT INTO public.who_global_data VALUES (93260, 0, 0, 0, 0, 394, 152);
INSERT INTO public.who_global_data VALUES (93261, 0, 0, 0, 0, 394, 16);
INSERT INTO public.who_global_data VALUES (93262, 0, 0, 0, 0, 394, 10);
INSERT INTO public.who_global_data VALUES (93263, 0, 0, 0, 0, 394, 201);
INSERT INTO public.who_global_data VALUES (93264, 0, 0, 0, 0, 394, 174);
INSERT INTO public.who_global_data VALUES (93265, 0, 0, 0, 0, 394, 119);
INSERT INTO public.who_global_data VALUES (93266, 0, 0, 0, 0, 394, 168);
INSERT INTO public.who_global_data VALUES (93267, 0, 0, 0, 0, 394, 99);
INSERT INTO public.who_global_data VALUES (93268, 0, 0, 0, 0, 394, 171);
INSERT INTO public.who_global_data VALUES (93269, 0, 0, 0, 0, 394, 87);
INSERT INTO public.who_global_data VALUES (93270, 0, 0, 0, 0, 394, 123);
INSERT INTO public.who_global_data VALUES (93271, 0, 0, 0, 0, 394, 151);
INSERT INTO public.who_global_data VALUES (93272, 0, 0, 0, 0, 394, 213);
INSERT INTO public.who_global_data VALUES (93273, 0, 0, 0, 0, 394, 118);
INSERT INTO public.who_global_data VALUES (93274, 0, 0, 0, 0, 394, 134);
INSERT INTO public.who_global_data VALUES (93275, 0, 0, 0, 0, 394, 65);
INSERT INTO public.who_global_data VALUES (93276, 0, 0, 0, 0, 394, 102);
INSERT INTO public.who_global_data VALUES (93277, 0, 0, 0, 0, 394, 223);
INSERT INTO public.who_global_data VALUES (93278, 0, 0, 0, 0, 394, 4);
INSERT INTO public.who_global_data VALUES (93279, 0, 0, 0, 0, 394, 146);
INSERT INTO public.who_global_data VALUES (93280, 0, 0, 0, 0, 394, 31);
INSERT INTO public.who_global_data VALUES (93281, 0, 0, 0, 0, 394, 127);
INSERT INTO public.who_global_data VALUES (93282, 0, 0, 0, 0, 394, 22);
INSERT INTO public.who_global_data VALUES (93283, 0, 0, 0, 0, 394, 115);
INSERT INTO public.who_global_data VALUES (93284, 0, 0, 0, 0, 394, 106);
INSERT INTO public.who_global_data VALUES (93285, 0, 0, 0, 0, 394, 90);
INSERT INTO public.who_global_data VALUES (93286, 0, 0, 0, 0, 394, 70);
INSERT INTO public.who_global_data VALUES (93287, 0, 0, 0, 0, 394, 46);
INSERT INTO public.who_global_data VALUES (93288, 0, 0, 0, 0, 394, 139);
INSERT INTO public.who_global_data VALUES (93289, 0, 0, 0, 0, 394, 42);
INSERT INTO public.who_global_data VALUES (93290, 0, 0, 0, 0, 394, 80);
INSERT INTO public.who_global_data VALUES (93291, 0, 0, 0, 0, 394, 203);
INSERT INTO public.who_global_data VALUES (93292, 0, 0, 0, 0, 394, 136);
INSERT INTO public.who_global_data VALUES (93293, 0, 0, 0, 0, 394, 63);
INSERT INTO public.who_global_data VALUES (93294, 0, 0, 0, 0, 394, 17);
INSERT INTO public.who_global_data VALUES (93295, 0, 0, 0, 0, 394, 172);
INSERT INTO public.who_global_data VALUES (93296, 0, 0, 0, 0, 394, 109);
INSERT INTO public.who_global_data VALUES (93297, 0, 0, 0, 0, 394, 200);
INSERT INTO public.who_global_data VALUES (93298, 0, 0, 0, 0, 394, 93);
INSERT INTO public.who_global_data VALUES (93299, 0, 0, 0, 0, 394, 5);
INSERT INTO public.who_global_data VALUES (93300, 0, 0, 0, 0, 394, 214);
INSERT INTO public.who_global_data VALUES (93301, 0, 0, 0, 0, 394, 204);
INSERT INTO public.who_global_data VALUES (93302, 0, 0, 0, 0, 394, 198);
INSERT INTO public.who_global_data VALUES (93303, 0, 0, 0, 0, 394, 173);
INSERT INTO public.who_global_data VALUES (93304, 0, 0, 0, 0, 394, 229);
INSERT INTO public.who_global_data VALUES (93305, 0, 0, 0, 0, 394, 76);
INSERT INTO public.who_global_data VALUES (93306, 0, 0, 0, 0, 394, 138);
INSERT INTO public.who_global_data VALUES (93307, 0, 0, 0, 0, 394, 98);
INSERT INTO public.who_global_data VALUES (93308, 0, 0, 0, 0, 394, 103);
INSERT INTO public.who_global_data VALUES (93309, 0, 0, 0, 0, 394, 225);
INSERT INTO public.who_global_data VALUES (93310, 0, 0, 0, 0, 394, 131);
INSERT INTO public.who_global_data VALUES (93311, 0, 0, 0, 0, 394, 235);
INSERT INTO public.who_global_data VALUES (93312, 0, 0, 0, 0, 394, 137);
INSERT INTO public.who_global_data VALUES (93313, 0, 0, 0, 0, 394, 81);
INSERT INTO public.who_global_data VALUES (93314, 0, 0, 0, 0, 394, 182);
INSERT INTO public.who_global_data VALUES (93315, 0, 0, 0, 0, 394, 145);
INSERT INTO public.who_global_data VALUES (93316, 0, 0, 0, 0, 394, 26);
INSERT INTO public.who_global_data VALUES (93317, 0, 0, 0, 0, 394, 170);
INSERT INTO public.who_global_data VALUES (93318, 0, 0, 0, 0, 394, 191);
INSERT INTO public.who_global_data VALUES (93319, 0, 0, 0, 0, 394, 221);
INSERT INTO public.who_global_data VALUES (93320, 0, 0, 0, 0, 394, 64);
INSERT INTO public.who_global_data VALUES (93321, 0, 0, 0, 0, 394, 116);
INSERT INTO public.who_global_data VALUES (93322, 0, 0, 0, 0, 394, 128);
INSERT INTO public.who_global_data VALUES (93323, 0, 0, 0, 0, 394, 6);
INSERT INTO public.who_global_data VALUES (93324, 0, 0, 0, 0, 394, 227);
INSERT INTO public.who_global_data VALUES (93325, 0, 0, 0, 0, 394, 68);
INSERT INTO public.who_global_data VALUES (93326, 0, 0, 0, 0, 394, 184);
INSERT INTO public.who_global_data VALUES (93327, 0, 0, 0, 0, 394, 82);
INSERT INTO public.who_global_data VALUES (93328, 0, 0, 0, 0, 394, 149);
INSERT INTO public.who_global_data VALUES (93329, 0, 0, 0, 0, 394, 197);
INSERT INTO public.who_global_data VALUES (93330, 0, 0, 0, 0, 394, 78);
INSERT INTO public.who_global_data VALUES (93331, 0, 0, 0, 0, 394, 233);
INSERT INTO public.who_global_data VALUES (93332, 0, 0, 0, 0, 394, 133);
INSERT INTO public.who_global_data VALUES (93333, 0, 0, 0, 0, 394, 35);
INSERT INTO public.who_global_data VALUES (93334, 0, 0, 0, 0, 394, 114);
INSERT INTO public.who_global_data VALUES (93335, 0, 0, 0, 0, 394, 237);
INSERT INTO public.who_global_data VALUES (93336, 0, 0, 0, 0, 394, 55);
INSERT INTO public.who_global_data VALUES (93337, 0, 0, 0, 0, 394, 176);
INSERT INTO public.who_global_data VALUES (93338, 0, 0, 0, 0, 394, 202);
INSERT INTO public.who_global_data VALUES (93339, 0, 0, 0, 0, 394, 155);
INSERT INTO public.who_global_data VALUES (93340, 0, 0, 0, 0, 394, 32);
INSERT INTO public.who_global_data VALUES (93341, 0, 0, 0, 0, 394, 220);
INSERT INTO public.who_global_data VALUES (93342, 0, 0, 0, 0, 394, 30);
INSERT INTO public.who_global_data VALUES (93343, 0, 0, 0, 0, 394, 147);
INSERT INTO public.who_global_data VALUES (93344, 0, 0, 0, 0, 394, 208);
INSERT INTO public.who_global_data VALUES (93345, 0, 0, 0, 0, 394, 45);
INSERT INTO public.who_global_data VALUES (93346, 0, 0, 0, 0, 394, 110);
INSERT INTO public.who_global_data VALUES (93347, 0, 0, 0, 0, 394, 88);
INSERT INTO public.who_global_data VALUES (93348, 0, 0, 0, 0, 394, 51);
INSERT INTO public.who_global_data VALUES (93349, 0, 0, 0, 0, 394, 209);
INSERT INTO public.who_global_data VALUES (93350, 0, 0, 0, 0, 394, 205);
INSERT INTO public.who_global_data VALUES (93351, 0, 0, 0, 0, 394, 18);
INSERT INTO public.who_global_data VALUES (93352, 0, 0, 0, 0, 394, 72);
INSERT INTO public.who_global_data VALUES (93353, 0, 0, 0, 0, 394, 44);
INSERT INTO public.who_global_data VALUES (93354, 0, 0, 0, 0, 394, 15);
INSERT INTO public.who_global_data VALUES (93355, 0, 0, 0, 0, 394, 25);
INSERT INTO public.who_global_data VALUES (93356, 0, 0, 0, 0, 394, 179);
INSERT INTO public.who_global_data VALUES (93357, 0, 0, 0, 0, 394, 34);
INSERT INTO public.who_global_data VALUES (93358, 0, 0, 0, 0, 394, 207);
INSERT INTO public.who_global_data VALUES (93359, 0, 0, 0, 0, 394, 166);
INSERT INTO public.who_global_data VALUES (93360, 0, 0, 0, 0, 394, 126);
INSERT INTO public.who_global_data VALUES (93361, 0, 0, 0, 0, 394, 97);
INSERT INTO public.who_global_data VALUES (93362, 0, 0, 0, 0, 394, 36);
INSERT INTO public.who_global_data VALUES (93363, 0, 0, 0, 0, 394, 125);
INSERT INTO public.who_global_data VALUES (93364, 0, 0, 0, 0, 394, 124);
INSERT INTO public.who_global_data VALUES (93365, 0, 0, 0, 0, 394, 185);
INSERT INTO public.who_global_data VALUES (93366, 0, 0, 0, 0, 394, 194);
INSERT INTO public.who_global_data VALUES (93367, 0, 0, 0, 0, 394, 144);
INSERT INTO public.who_global_data VALUES (93368, 0, 0, 0, 0, 394, 19);
INSERT INTO public.who_global_data VALUES (93369, 0, 0, 0, 0, 394, 217);
INSERT INTO public.who_global_data VALUES (93370, 0, 0, 0, 0, 394, 148);
INSERT INTO public.who_global_data VALUES (93371, 0, 0, 0, 0, 394, 86);
INSERT INTO public.who_global_data VALUES (93372, 0, 0, 0, 0, 394, 13);
INSERT INTO public.who_global_data VALUES (93373, 0, 0, 0, 0, 394, 157);
INSERT INTO public.who_global_data VALUES (93374, 0, 0, 0, 0, 394, 8);
INSERT INTO public.who_global_data VALUES (93375, 0, 0, 0, 0, 394, 73);
INSERT INTO public.who_global_data VALUES (93376, 0, 0, 0, 0, 394, 101);
INSERT INTO public.who_global_data VALUES (93377, 0, 0, 0, 0, 394, 165);
INSERT INTO public.who_global_data VALUES (93378, 0, 0, 0, 0, 394, 14);
INSERT INTO public.who_global_data VALUES (93379, 0, 0, 0, 0, 395, 193);
INSERT INTO public.who_global_data VALUES (93380, 0, 0, 0, 0, 395, 113);
INSERT INTO public.who_global_data VALUES (93381, 0, 0, 0, 0, 395, 143);
INSERT INTO public.who_global_data VALUES (93382, 0, 0, 0, 0, 395, 219);
INSERT INTO public.who_global_data VALUES (93383, 0, 0, 0, 0, 395, 186);
INSERT INTO public.who_global_data VALUES (93384, 0, 0, 0, 0, 395, 52);
INSERT INTO public.who_global_data VALUES (93385, 0, 0, 0, 0, 395, 180);
INSERT INTO public.who_global_data VALUES (93386, 0, 0, 0, 0, 395, 167);
INSERT INTO public.who_global_data VALUES (93387, 0, 0, 0, 0, 395, 154);
INSERT INTO public.who_global_data VALUES (93388, 0, 0, 0, 0, 395, 94);
INSERT INTO public.who_global_data VALUES (93389, 0, 0, 0, 0, 395, 66);
INSERT INTO public.who_global_data VALUES (93390, 0, 0, 0, 0, 395, 58);
INSERT INTO public.who_global_data VALUES (93391, 0, 0, 0, 0, 395, 163);
INSERT INTO public.who_global_data VALUES (93392, 0, 0, 0, 0, 395, 37);
INSERT INTO public.who_global_data VALUES (93393, 0, 0, 0, 0, 395, 142);
INSERT INTO public.who_global_data VALUES (93394, 0, 0, 0, 0, 395, 83);
INSERT INTO public.who_global_data VALUES (93395, 0, 0, 0, 0, 395, 228);
INSERT INTO public.who_global_data VALUES (93396, 0, 0, 0, 0, 395, 188);
INSERT INTO public.who_global_data VALUES (93397, 0, 0, 0, 0, 395, 62);
INSERT INTO public.who_global_data VALUES (93398, 0, 0, 0, 0, 395, 160);
INSERT INTO public.who_global_data VALUES (93399, 0, 0, 0, 0, 395, 50);
INSERT INTO public.who_global_data VALUES (93400, 0, 0, 0, 0, 395, 33);
INSERT INTO public.who_global_data VALUES (93401, 0, 0, 0, 0, 395, 183);
INSERT INTO public.who_global_data VALUES (93402, 0, 0, 0, 0, 395, 92);
INSERT INTO public.who_global_data VALUES (93403, 0, 0, 0, 0, 395, 158);
INSERT INTO public.who_global_data VALUES (93404, 0, 0, 0, 0, 395, 67);
INSERT INTO public.who_global_data VALUES (93405, 0, 0, 0, 0, 395, 57);
INSERT INTO public.who_global_data VALUES (93406, 0, 0, 0, 0, 395, 38);
INSERT INTO public.who_global_data VALUES (93407, 0, 0, 0, 0, 395, 141);
INSERT INTO public.who_global_data VALUES (93408, 0, 0, 0, 0, 395, 178);
INSERT INTO public.who_global_data VALUES (93409, 0, 0, 0, 0, 395, 108);
INSERT INTO public.who_global_data VALUES (93410, 0, 0, 0, 0, 395, 39);
INSERT INTO public.who_global_data VALUES (93411, 0, 0, 0, 0, 395, 2);
INSERT INTO public.who_global_data VALUES (93412, 0, 0, 0, 0, 395, 195);
INSERT INTO public.who_global_data VALUES (93413, 0, 0, 0, 0, 395, 107);
INSERT INTO public.who_global_data VALUES (93414, 0, 0, 0, 0, 395, 161);
INSERT INTO public.who_global_data VALUES (93415, 0, 0, 0, 0, 395, 212);
INSERT INTO public.who_global_data VALUES (93416, 0, 0, 0, 0, 395, 181);
INSERT INTO public.who_global_data VALUES (93417, 0, 0, 0, 0, 395, 53);
INSERT INTO public.who_global_data VALUES (93418, 0, 0, 0, 0, 395, 164);
INSERT INTO public.who_global_data VALUES (93419, 0, 0, 0, 0, 395, 140);
INSERT INTO public.who_global_data VALUES (93420, 0, 0, 0, 0, 395, 20);
INSERT INTO public.who_global_data VALUES (93421, 0, 4, 0, 0, 395, 112);
INSERT INTO public.who_global_data VALUES (93422, 0, 0, 0, 0, 395, 111);
INSERT INTO public.who_global_data VALUES (93423, 0, 0, 0, 0, 395, 71);
INSERT INTO public.who_global_data VALUES (93424, 0, 0, 0, 0, 395, 218);
INSERT INTO public.who_global_data VALUES (93425, 0, 0, 0, 0, 395, 43);
INSERT INTO public.who_global_data VALUES (93426, 0, 0, 0, 0, 395, 49);
INSERT INTO public.who_global_data VALUES (93427, 0, 0, 0, 0, 395, 1);
INSERT INTO public.who_global_data VALUES (93428, 0, 0, 0, 0, 395, 48);
INSERT INTO public.who_global_data VALUES (93429, 0, 0, 0, 0, 395, 232);
INSERT INTO public.who_global_data VALUES (93430, 0, 0, 0, 0, 395, 175);
INSERT INTO public.who_global_data VALUES (93431, 0, 0, 0, 0, 395, 21);
INSERT INTO public.who_global_data VALUES (93432, 0, 0, 0, 0, 395, 156);
INSERT INTO public.who_global_data VALUES (93433, 0, 0, 0, 0, 395, 95);
INSERT INTO public.who_global_data VALUES (93434, 0, 0, 0, 0, 395, 177);
INSERT INTO public.who_global_data VALUES (93435, 0, 0, 0, 0, 395, 210);
INSERT INTO public.who_global_data VALUES (93436, 0, 0, 0, 0, 395, 120);
INSERT INTO public.who_global_data VALUES (93437, 0, 0, 0, 0, 395, 135);
INSERT INTO public.who_global_data VALUES (93438, 0, 0, 0, 0, 395, 206);
INSERT INTO public.who_global_data VALUES (93439, 0, 0, 0, 0, 395, 189);
INSERT INTO public.who_global_data VALUES (93440, 0, 0, 0, 0, 395, 129);
INSERT INTO public.who_global_data VALUES (93441, 0, 0, 0, 0, 395, 121);
INSERT INTO public.who_global_data VALUES (93442, 0, 0, 0, 0, 395, 59);
INSERT INTO public.who_global_data VALUES (93443, 0, 0, 0, 0, 395, 96);
INSERT INTO public.who_global_data VALUES (93444, 0, 0, 0, 0, 395, 41);
INSERT INTO public.who_global_data VALUES (93445, 0, 0, 0, 0, 395, 216);
INSERT INTO public.who_global_data VALUES (93446, 0, 0, 0, 0, 395, 236);
INSERT INTO public.who_global_data VALUES (93447, 0, 0, 0, 0, 395, 150);
INSERT INTO public.who_global_data VALUES (93448, 0, 0, 0, 0, 395, 61);
INSERT INTO public.who_global_data VALUES (93449, 0, 0, 0, 0, 395, 7);
INSERT INTO public.who_global_data VALUES (93450, 0, 0, 0, 0, 395, 169);
INSERT INTO public.who_global_data VALUES (93451, 0, 0, 0, 0, 395, 28);
INSERT INTO public.who_global_data VALUES (93452, 0, 0, 0, 0, 395, 85);
INSERT INTO public.who_global_data VALUES (93453, 0, 0, 0, 0, 395, 211);
INSERT INTO public.who_global_data VALUES (93454, 0, 0, 0, 0, 395, 60);
INSERT INTO public.who_global_data VALUES (93455, 0, 0, 0, 0, 395, 3);
INSERT INTO public.who_global_data VALUES (93456, 0, 0, 0, 0, 395, 11);
INSERT INTO public.who_global_data VALUES (93457, 0, 0, 0, 0, 395, 89);
INSERT INTO public.who_global_data VALUES (93458, 0, 0, 0, 0, 395, 24);
INSERT INTO public.who_global_data VALUES (93459, 0, 0, 0, 0, 395, 162);
INSERT INTO public.who_global_data VALUES (93460, 0, 0, 0, 0, 395, 100);
INSERT INTO public.who_global_data VALUES (93461, 0, 0, 0, 0, 395, 47);
INSERT INTO public.who_global_data VALUES (93462, 0, 0, 0, 0, 395, 29);
INSERT INTO public.who_global_data VALUES (93463, 0, 0, 0, 0, 395, 40);
INSERT INTO public.who_global_data VALUES (93464, 0, 0, 0, 0, 395, 222);
INSERT INTO public.who_global_data VALUES (93465, 0, 0, 0, 0, 395, 132);
INSERT INTO public.who_global_data VALUES (93466, 0, 0, 0, 0, 395, 130);
INSERT INTO public.who_global_data VALUES (93467, 0, 0, 0, 0, 395, 234);
INSERT INTO public.who_global_data VALUES (93468, 0, 0, 0, 0, 395, 23);
INSERT INTO public.who_global_data VALUES (93469, 0, 0, 0, 0, 395, 192);
INSERT INTO public.who_global_data VALUES (93470, 0, 0, 0, 0, 395, 69);
INSERT INTO public.who_global_data VALUES (93471, 0, 0, 0, 0, 395, 187);
INSERT INTO public.who_global_data VALUES (93472, 0, 0, 0, 0, 395, 230);
INSERT INTO public.who_global_data VALUES (93473, 0, 0, 0, 0, 395, 77);
INSERT INTO public.who_global_data VALUES (93474, 0, 0, 0, 0, 395, 9);
INSERT INTO public.who_global_data VALUES (93475, 0, 0, 0, 0, 395, 74);
INSERT INTO public.who_global_data VALUES (93476, 0, 0, 0, 0, 395, 224);
INSERT INTO public.who_global_data VALUES (93477, 0, 0, 0, 0, 395, 199);
INSERT INTO public.who_global_data VALUES (93478, 0, 0, 0, 0, 395, 190);
INSERT INTO public.who_global_data VALUES (93479, 0, 0, 0, 0, 395, 12);
INSERT INTO public.who_global_data VALUES (93480, 0, 0, 0, 0, 395, 104);
INSERT INTO public.who_global_data VALUES (93481, 0, 0, 0, 0, 395, 153);
INSERT INTO public.who_global_data VALUES (93482, 0, 0, 0, 0, 395, 91);
INSERT INTO public.who_global_data VALUES (93483, 0, 0, 0, 0, 395, 215);
INSERT INTO public.who_global_data VALUES (93484, 0, 0, 0, 0, 395, 84);
INSERT INTO public.who_global_data VALUES (93485, 0, 0, 0, 0, 395, 231);
INSERT INTO public.who_global_data VALUES (93486, 0, 0, 0, 0, 395, 196);
INSERT INTO public.who_global_data VALUES (93487, 0, 0, 0, 0, 395, 105);
INSERT INTO public.who_global_data VALUES (93488, 0, 0, 0, 0, 395, 122);
INSERT INTO public.who_global_data VALUES (93489, 0, 0, 0, 0, 395, 159);
INSERT INTO public.who_global_data VALUES (93490, 0, 0, 0, 0, 395, 75);
INSERT INTO public.who_global_data VALUES (93491, 0, 0, 0, 0, 395, 27);
INSERT INTO public.who_global_data VALUES (93492, 0, 0, 0, 0, 395, 54);
INSERT INTO public.who_global_data VALUES (93493, 0, 0, 0, 0, 395, 226);
INSERT INTO public.who_global_data VALUES (93494, 0, 0, 0, 0, 395, 79);
INSERT INTO public.who_global_data VALUES (93495, 0, 0, 0, 0, 395, 56);
INSERT INTO public.who_global_data VALUES (93496, 0, 0, 0, 0, 395, 117);
INSERT INTO public.who_global_data VALUES (93497, 0, 0, 0, 0, 395, 152);
INSERT INTO public.who_global_data VALUES (93498, 0, 0, 0, 0, 395, 16);
INSERT INTO public.who_global_data VALUES (93499, 0, 0, 0, 0, 395, 10);
INSERT INTO public.who_global_data VALUES (93500, 0, 0, 0, 0, 395, 201);
INSERT INTO public.who_global_data VALUES (93501, 0, 0, 0, 0, 395, 174);
INSERT INTO public.who_global_data VALUES (93502, 0, 0, 0, 0, 395, 119);
INSERT INTO public.who_global_data VALUES (93503, 0, 0, 0, 0, 395, 168);
INSERT INTO public.who_global_data VALUES (93504, 0, 0, 0, 0, 395, 99);
INSERT INTO public.who_global_data VALUES (93505, 0, 0, 0, 0, 395, 171);
INSERT INTO public.who_global_data VALUES (93506, 0, 0, 0, 0, 395, 87);
INSERT INTO public.who_global_data VALUES (93507, 0, 0, 0, 0, 395, 123);
INSERT INTO public.who_global_data VALUES (93508, 0, 0, 0, 0, 395, 151);
INSERT INTO public.who_global_data VALUES (93509, 0, 0, 0, 0, 395, 213);
INSERT INTO public.who_global_data VALUES (93510, 0, 0, 0, 0, 395, 118);
INSERT INTO public.who_global_data VALUES (93511, 0, 0, 0, 0, 395, 134);
INSERT INTO public.who_global_data VALUES (93512, 0, 0, 0, 0, 395, 65);
INSERT INTO public.who_global_data VALUES (93513, 0, 0, 0, 0, 395, 102);
INSERT INTO public.who_global_data VALUES (93514, 0, 0, 0, 0, 395, 223);
INSERT INTO public.who_global_data VALUES (93515, 0, 0, 0, 0, 395, 4);
INSERT INTO public.who_global_data VALUES (93516, 0, 0, 0, 0, 395, 146);
INSERT INTO public.who_global_data VALUES (93517, 0, 0, 0, 0, 395, 31);
INSERT INTO public.who_global_data VALUES (93518, 0, 0, 0, 0, 395, 127);
INSERT INTO public.who_global_data VALUES (93519, 0, 0, 0, 0, 395, 22);
INSERT INTO public.who_global_data VALUES (93520, 0, 0, 0, 0, 395, 115);
INSERT INTO public.who_global_data VALUES (93521, 0, 0, 0, 0, 395, 106);
INSERT INTO public.who_global_data VALUES (93522, 0, 0, 0, 0, 395, 90);
INSERT INTO public.who_global_data VALUES (93523, 0, 0, 0, 0, 395, 70);
INSERT INTO public.who_global_data VALUES (93524, 0, 0, 0, 0, 395, 46);
INSERT INTO public.who_global_data VALUES (93525, 0, 0, 0, 0, 395, 139);
INSERT INTO public.who_global_data VALUES (93526, 0, 0, 0, 0, 395, 42);
INSERT INTO public.who_global_data VALUES (93527, 0, 0, 0, 0, 395, 80);
INSERT INTO public.who_global_data VALUES (93528, 0, 0, 0, 0, 395, 203);
INSERT INTO public.who_global_data VALUES (93529, 0, 0, 0, 0, 395, 136);
INSERT INTO public.who_global_data VALUES (93530, 0, 0, 0, 0, 395, 63);
INSERT INTO public.who_global_data VALUES (93531, 0, 0, 0, 0, 395, 17);
INSERT INTO public.who_global_data VALUES (93532, 0, 0, 0, 0, 395, 172);
INSERT INTO public.who_global_data VALUES (93533, 0, 0, 0, 0, 395, 109);
INSERT INTO public.who_global_data VALUES (93534, 0, 0, 0, 0, 395, 200);
INSERT INTO public.who_global_data VALUES (93535, 0, 0, 0, 0, 395, 93);
INSERT INTO public.who_global_data VALUES (93536, 0, 0, 0, 0, 395, 5);
INSERT INTO public.who_global_data VALUES (93537, 0, 0, 0, 0, 395, 214);
INSERT INTO public.who_global_data VALUES (93538, 0, 0, 0, 0, 395, 204);
INSERT INTO public.who_global_data VALUES (93539, 0, 0, 0, 0, 395, 198);
INSERT INTO public.who_global_data VALUES (93540, 0, 0, 0, 0, 395, 173);
INSERT INTO public.who_global_data VALUES (93541, 0, 0, 0, 0, 395, 229);
INSERT INTO public.who_global_data VALUES (93542, 0, 0, 0, 0, 395, 76);
INSERT INTO public.who_global_data VALUES (93543, 0, 0, 0, 0, 395, 138);
INSERT INTO public.who_global_data VALUES (93544, 0, 0, 0, 0, 395, 98);
INSERT INTO public.who_global_data VALUES (93545, 0, 0, 0, 0, 395, 103);
INSERT INTO public.who_global_data VALUES (93546, 0, 0, 0, 0, 395, 225);
INSERT INTO public.who_global_data VALUES (93547, 0, 0, 0, 0, 395, 131);
INSERT INTO public.who_global_data VALUES (93548, 0, 0, 0, 0, 395, 235);
INSERT INTO public.who_global_data VALUES (93549, 0, 0, 0, 0, 395, 137);
INSERT INTO public.who_global_data VALUES (93550, 0, 0, 0, 0, 395, 81);
INSERT INTO public.who_global_data VALUES (93551, 0, 0, 0, 0, 395, 182);
INSERT INTO public.who_global_data VALUES (93552, 0, 0, 0, 0, 395, 145);
INSERT INTO public.who_global_data VALUES (93553, 0, 0, 0, 0, 395, 26);
INSERT INTO public.who_global_data VALUES (93554, 0, 0, 0, 0, 395, 170);
INSERT INTO public.who_global_data VALUES (93555, 0, 0, 0, 0, 395, 191);
INSERT INTO public.who_global_data VALUES (93556, 0, 0, 0, 0, 395, 221);
INSERT INTO public.who_global_data VALUES (93557, 0, 0, 0, 0, 395, 64);
INSERT INTO public.who_global_data VALUES (93558, 0, 0, 0, 0, 395, 116);
INSERT INTO public.who_global_data VALUES (93559, 0, 0, 0, 0, 395, 128);
INSERT INTO public.who_global_data VALUES (93560, 0, 0, 0, 0, 395, 6);
INSERT INTO public.who_global_data VALUES (93561, 0, 0, 0, 0, 395, 227);
INSERT INTO public.who_global_data VALUES (93562, 0, 0, 0, 0, 395, 68);
INSERT INTO public.who_global_data VALUES (93563, 0, 0, 0, 0, 395, 184);
INSERT INTO public.who_global_data VALUES (93564, 0, 0, 0, 0, 395, 82);
INSERT INTO public.who_global_data VALUES (93565, 0, 0, 0, 0, 395, 149);
INSERT INTO public.who_global_data VALUES (93566, 0, 0, 0, 0, 395, 197);
INSERT INTO public.who_global_data VALUES (93567, 0, 0, 0, 0, 395, 78);
INSERT INTO public.who_global_data VALUES (93568, 0, 0, 0, 0, 395, 233);
INSERT INTO public.who_global_data VALUES (93569, 0, 0, 0, 0, 395, 133);
INSERT INTO public.who_global_data VALUES (93570, 0, 0, 0, 0, 395, 35);
INSERT INTO public.who_global_data VALUES (93571, 0, 0, 0, 0, 395, 114);
INSERT INTO public.who_global_data VALUES (93572, 0, 0, 0, 0, 395, 237);
INSERT INTO public.who_global_data VALUES (93573, 0, 0, 0, 0, 395, 55);
INSERT INTO public.who_global_data VALUES (93574, 0, 0, 0, 0, 395, 176);
INSERT INTO public.who_global_data VALUES (93575, 0, 0, 0, 0, 395, 202);
INSERT INTO public.who_global_data VALUES (93576, 0, 0, 0, 0, 395, 155);
INSERT INTO public.who_global_data VALUES (93577, 0, 0, 0, 0, 395, 32);
INSERT INTO public.who_global_data VALUES (93578, 0, 0, 0, 0, 395, 220);
INSERT INTO public.who_global_data VALUES (93579, 0, 0, 0, 0, 395, 30);
INSERT INTO public.who_global_data VALUES (93580, 0, 0, 0, 0, 395, 147);
INSERT INTO public.who_global_data VALUES (93581, 0, 0, 0, 0, 395, 208);
INSERT INTO public.who_global_data VALUES (93582, 0, 0, 0, 0, 395, 45);
INSERT INTO public.who_global_data VALUES (93583, 0, 0, 0, 0, 395, 110);
INSERT INTO public.who_global_data VALUES (93584, 0, 0, 0, 0, 395, 88);
INSERT INTO public.who_global_data VALUES (93585, 0, 0, 0, 0, 395, 51);
INSERT INTO public.who_global_data VALUES (93586, 0, 0, 0, 0, 395, 209);
INSERT INTO public.who_global_data VALUES (93587, 0, 0, 0, 0, 395, 205);
INSERT INTO public.who_global_data VALUES (93588, 0, 0, 0, 0, 395, 18);
INSERT INTO public.who_global_data VALUES (93589, 0, 0, 0, 0, 395, 72);
INSERT INTO public.who_global_data VALUES (93590, 0, 0, 0, 0, 395, 44);
INSERT INTO public.who_global_data VALUES (93591, 0, 0, 0, 0, 395, 15);
INSERT INTO public.who_global_data VALUES (93592, 0, 0, 0, 0, 395, 25);
INSERT INTO public.who_global_data VALUES (93593, 0, 0, 0, 0, 395, 179);
INSERT INTO public.who_global_data VALUES (93594, 0, 0, 0, 0, 395, 34);
INSERT INTO public.who_global_data VALUES (93595, 0, 0, 0, 0, 395, 207);
INSERT INTO public.who_global_data VALUES (93596, 0, 0, 0, 0, 395, 166);
INSERT INTO public.who_global_data VALUES (93597, 0, 0, 0, 0, 395, 126);
INSERT INTO public.who_global_data VALUES (93598, 0, 0, 0, 0, 395, 97);
INSERT INTO public.who_global_data VALUES (93599, 0, 0, 0, 0, 395, 36);
INSERT INTO public.who_global_data VALUES (93600, 0, 0, 0, 0, 395, 125);
INSERT INTO public.who_global_data VALUES (93601, 0, 0, 0, 0, 395, 124);
INSERT INTO public.who_global_data VALUES (93602, 0, 0, 0, 0, 395, 185);
INSERT INTO public.who_global_data VALUES (93603, 0, 0, 0, 0, 395, 194);
INSERT INTO public.who_global_data VALUES (93604, 0, 0, 0, 0, 395, 144);
INSERT INTO public.who_global_data VALUES (93605, 0, 0, 0, 0, 395, 19);
INSERT INTO public.who_global_data VALUES (93606, 0, 0, 0, 0, 395, 217);
INSERT INTO public.who_global_data VALUES (93607, 0, 0, 0, 0, 395, 148);
INSERT INTO public.who_global_data VALUES (93608, 0, 0, 0, 0, 395, 86);
INSERT INTO public.who_global_data VALUES (93609, 0, 0, 0, 0, 395, 13);
INSERT INTO public.who_global_data VALUES (93610, 0, 0, 0, 0, 395, 157);
INSERT INTO public.who_global_data VALUES (93611, 0, 0, 0, 0, 395, 8);
INSERT INTO public.who_global_data VALUES (93612, 0, 0, 0, 0, 395, 73);
INSERT INTO public.who_global_data VALUES (93613, 0, 0, 0, 0, 395, 101);
INSERT INTO public.who_global_data VALUES (93614, 0, 0, 0, 0, 395, 165);
INSERT INTO public.who_global_data VALUES (93615, 0, 0, 0, 0, 395, 14);
INSERT INTO public.who_global_data VALUES (93616, 0, 0, 0, 0, 396, 193);
INSERT INTO public.who_global_data VALUES (93617, 0, 0, 0, 0, 396, 113);
INSERT INTO public.who_global_data VALUES (93618, 0, 0, 0, 0, 396, 143);
INSERT INTO public.who_global_data VALUES (93619, 0, 0, 0, 0, 396, 219);
INSERT INTO public.who_global_data VALUES (93620, 0, 0, 0, 0, 396, 186);
INSERT INTO public.who_global_data VALUES (93621, 0, 0, 0, 0, 396, 52);
INSERT INTO public.who_global_data VALUES (93622, 0, 0, 0, 0, 396, 180);
INSERT INTO public.who_global_data VALUES (93623, 0, 0, 0, 0, 396, 167);
INSERT INTO public.who_global_data VALUES (93624, 0, 0, 0, 0, 396, 154);
INSERT INTO public.who_global_data VALUES (93625, 0, 0, 0, 0, 396, 94);
INSERT INTO public.who_global_data VALUES (93626, 0, 0, 0, 0, 396, 66);
INSERT INTO public.who_global_data VALUES (93627, 0, 0, 0, 0, 396, 58);
INSERT INTO public.who_global_data VALUES (93628, 0, 0, 0, 0, 396, 163);
INSERT INTO public.who_global_data VALUES (93629, 0, 0, 0, 0, 396, 37);
INSERT INTO public.who_global_data VALUES (93630, 0, 0, 0, 0, 396, 142);
INSERT INTO public.who_global_data VALUES (93631, 0, 0, 0, 0, 396, 83);
INSERT INTO public.who_global_data VALUES (93632, 0, 0, 0, 0, 396, 228);
INSERT INTO public.who_global_data VALUES (93633, 0, 0, 0, 0, 396, 188);
INSERT INTO public.who_global_data VALUES (93634, 0, 0, 0, 0, 396, 62);
INSERT INTO public.who_global_data VALUES (93635, 0, 0, 0, 0, 396, 160);
INSERT INTO public.who_global_data VALUES (93636, 0, 0, 0, 0, 396, 50);
INSERT INTO public.who_global_data VALUES (93637, 0, 0, 0, 0, 396, 33);
INSERT INTO public.who_global_data VALUES (93638, 0, 0, 0, 0, 396, 183);
INSERT INTO public.who_global_data VALUES (93639, 0, 0, 0, 0, 396, 92);
INSERT INTO public.who_global_data VALUES (93640, 0, 0, 0, 0, 396, 158);
INSERT INTO public.who_global_data VALUES (93641, 0, 0, 0, 0, 396, 67);
INSERT INTO public.who_global_data VALUES (93642, 0, 0, 0, 0, 396, 57);
INSERT INTO public.who_global_data VALUES (93643, 0, 0, 0, 0, 396, 38);
INSERT INTO public.who_global_data VALUES (93644, 0, 0, 0, 0, 396, 141);
INSERT INTO public.who_global_data VALUES (93645, 0, 0, 0, 0, 396, 178);
INSERT INTO public.who_global_data VALUES (93646, 0, 0, 0, 0, 396, 108);
INSERT INTO public.who_global_data VALUES (93647, 0, 0, 0, 0, 396, 39);
INSERT INTO public.who_global_data VALUES (93648, 0, 0, 0, 0, 396, 2);
INSERT INTO public.who_global_data VALUES (93649, 0, 0, 0, 0, 396, 195);
INSERT INTO public.who_global_data VALUES (93650, 0, 0, 0, 0, 396, 107);
INSERT INTO public.who_global_data VALUES (93651, 0, 0, 0, 0, 396, 161);
INSERT INTO public.who_global_data VALUES (93652, 0, 0, 0, 0, 396, 212);
INSERT INTO public.who_global_data VALUES (93653, 0, 0, 0, 0, 396, 181);
INSERT INTO public.who_global_data VALUES (93654, 0, 0, 0, 0, 396, 53);
INSERT INTO public.who_global_data VALUES (93655, 0, 0, 0, 0, 396, 164);
INSERT INTO public.who_global_data VALUES (93656, 0, 0, 0, 0, 396, 140);
INSERT INTO public.who_global_data VALUES (93657, 0, 0, 0, 0, 396, 20);
INSERT INTO public.who_global_data VALUES (93658, 0, 4, 0, 0, 396, 112);
INSERT INTO public.who_global_data VALUES (93659, 0, 0, 0, 0, 396, 111);
INSERT INTO public.who_global_data VALUES (93660, 0, 0, 0, 0, 396, 71);
INSERT INTO public.who_global_data VALUES (93661, 0, 0, 0, 0, 396, 218);
INSERT INTO public.who_global_data VALUES (93662, 0, 0, 0, 0, 396, 43);
INSERT INTO public.who_global_data VALUES (93663, 0, 0, 0, 0, 396, 49);
INSERT INTO public.who_global_data VALUES (93664, 0, 0, 0, 0, 396, 1);
INSERT INTO public.who_global_data VALUES (93665, 0, 0, 0, 0, 396, 48);
INSERT INTO public.who_global_data VALUES (93666, 0, 0, 0, 0, 396, 232);
INSERT INTO public.who_global_data VALUES (93667, 0, 0, 0, 0, 396, 175);
INSERT INTO public.who_global_data VALUES (93668, 0, 0, 0, 0, 396, 21);
INSERT INTO public.who_global_data VALUES (93669, 0, 0, 0, 0, 396, 156);
INSERT INTO public.who_global_data VALUES (93670, 0, 0, 0, 0, 396, 95);
INSERT INTO public.who_global_data VALUES (93671, 0, 0, 0, 0, 396, 177);
INSERT INTO public.who_global_data VALUES (93672, 0, 0, 0, 0, 396, 210);
INSERT INTO public.who_global_data VALUES (93673, 0, 0, 0, 0, 396, 120);
INSERT INTO public.who_global_data VALUES (93674, 0, 0, 0, 0, 396, 135);
INSERT INTO public.who_global_data VALUES (93675, 0, 0, 0, 0, 396, 206);
INSERT INTO public.who_global_data VALUES (93676, 0, 0, 0, 0, 396, 189);
INSERT INTO public.who_global_data VALUES (93677, 0, 0, 0, 0, 396, 129);
INSERT INTO public.who_global_data VALUES (93678, 0, 0, 0, 0, 396, 121);
INSERT INTO public.who_global_data VALUES (93679, 0, 0, 0, 0, 396, 59);
INSERT INTO public.who_global_data VALUES (93680, 0, 0, 0, 0, 396, 96);
INSERT INTO public.who_global_data VALUES (93681, 0, 0, 0, 0, 396, 41);
INSERT INTO public.who_global_data VALUES (93682, 0, 0, 0, 0, 396, 216);
INSERT INTO public.who_global_data VALUES (93683, 0, 0, 0, 0, 396, 236);
INSERT INTO public.who_global_data VALUES (93684, 0, 0, 0, 0, 396, 150);
INSERT INTO public.who_global_data VALUES (93685, 0, 0, 0, 0, 396, 61);
INSERT INTO public.who_global_data VALUES (93686, 0, 0, 0, 0, 396, 7);
INSERT INTO public.who_global_data VALUES (93687, 0, 0, 0, 0, 396, 169);
INSERT INTO public.who_global_data VALUES (93688, 0, 0, 0, 0, 396, 28);
INSERT INTO public.who_global_data VALUES (93689, 0, 0, 0, 0, 396, 85);
INSERT INTO public.who_global_data VALUES (93690, 0, 0, 0, 0, 396, 211);
INSERT INTO public.who_global_data VALUES (93691, 0, 0, 0, 0, 396, 60);
INSERT INTO public.who_global_data VALUES (93692, 0, 0, 0, 0, 396, 3);
INSERT INTO public.who_global_data VALUES (93693, 0, 0, 0, 0, 396, 11);
INSERT INTO public.who_global_data VALUES (93694, 0, 0, 0, 0, 396, 89);
INSERT INTO public.who_global_data VALUES (93695, 0, 0, 0, 0, 396, 24);
INSERT INTO public.who_global_data VALUES (93696, 0, 0, 0, 0, 396, 162);
INSERT INTO public.who_global_data VALUES (93697, 0, 0, 0, 0, 396, 100);
INSERT INTO public.who_global_data VALUES (93698, 0, 0, 0, 0, 396, 47);
INSERT INTO public.who_global_data VALUES (93699, 0, 0, 0, 0, 396, 29);
INSERT INTO public.who_global_data VALUES (93700, 0, 0, 0, 0, 396, 40);
INSERT INTO public.who_global_data VALUES (93701, 0, 0, 0, 0, 396, 222);
INSERT INTO public.who_global_data VALUES (93702, 0, 0, 0, 0, 396, 132);
INSERT INTO public.who_global_data VALUES (93703, 0, 0, 0, 0, 396, 130);
INSERT INTO public.who_global_data VALUES (93704, 0, 0, 0, 0, 396, 234);
INSERT INTO public.who_global_data VALUES (93705, 0, 0, 0, 0, 396, 23);
INSERT INTO public.who_global_data VALUES (93706, 0, 0, 0, 0, 396, 192);
INSERT INTO public.who_global_data VALUES (93707, 0, 0, 0, 0, 396, 69);
INSERT INTO public.who_global_data VALUES (93708, 0, 0, 0, 0, 396, 187);
INSERT INTO public.who_global_data VALUES (93709, 0, 0, 0, 0, 396, 230);
INSERT INTO public.who_global_data VALUES (93710, 0, 0, 0, 0, 396, 77);
INSERT INTO public.who_global_data VALUES (93711, 0, 0, 0, 0, 396, 9);
INSERT INTO public.who_global_data VALUES (93712, 0, 0, 0, 0, 396, 74);
INSERT INTO public.who_global_data VALUES (93713, 0, 0, 0, 0, 396, 224);
INSERT INTO public.who_global_data VALUES (93714, 0, 0, 0, 0, 396, 199);
INSERT INTO public.who_global_data VALUES (93715, 0, 0, 0, 0, 396, 190);
INSERT INTO public.who_global_data VALUES (93716, 0, 0, 0, 0, 396, 12);
INSERT INTO public.who_global_data VALUES (93717, 0, 0, 0, 0, 396, 104);
INSERT INTO public.who_global_data VALUES (93718, 0, 0, 0, 0, 396, 153);
INSERT INTO public.who_global_data VALUES (93719, 0, 0, 0, 0, 396, 91);
INSERT INTO public.who_global_data VALUES (93720, 0, 0, 0, 0, 396, 215);
INSERT INTO public.who_global_data VALUES (93721, 0, 0, 0, 0, 396, 84);
INSERT INTO public.who_global_data VALUES (93722, 0, 0, 0, 0, 396, 231);
INSERT INTO public.who_global_data VALUES (93723, 0, 0, 0, 0, 396, 196);
INSERT INTO public.who_global_data VALUES (93724, 0, 0, 0, 0, 396, 105);
INSERT INTO public.who_global_data VALUES (93725, 0, 0, 0, 0, 396, 122);
INSERT INTO public.who_global_data VALUES (93726, 0, 0, 0, 0, 396, 159);
INSERT INTO public.who_global_data VALUES (93727, 0, 0, 0, 0, 396, 75);
INSERT INTO public.who_global_data VALUES (93728, 0, 0, 0, 0, 396, 27);
INSERT INTO public.who_global_data VALUES (93729, 0, 0, 0, 0, 396, 54);
INSERT INTO public.who_global_data VALUES (93730, 0, 0, 0, 0, 396, 226);
INSERT INTO public.who_global_data VALUES (93731, 0, 0, 0, 0, 396, 79);
INSERT INTO public.who_global_data VALUES (93732, 0, 0, 0, 0, 396, 56);
INSERT INTO public.who_global_data VALUES (93733, 0, 0, 0, 0, 396, 117);
INSERT INTO public.who_global_data VALUES (93734, 0, 0, 0, 0, 396, 152);
INSERT INTO public.who_global_data VALUES (93735, 0, 0, 0, 0, 396, 16);
INSERT INTO public.who_global_data VALUES (93736, 0, 0, 0, 0, 396, 10);
INSERT INTO public.who_global_data VALUES (93737, 0, 0, 0, 0, 396, 201);
INSERT INTO public.who_global_data VALUES (93738, 0, 0, 0, 0, 396, 174);
INSERT INTO public.who_global_data VALUES (93739, 0, 0, 0, 0, 396, 119);
INSERT INTO public.who_global_data VALUES (93740, 0, 0, 0, 0, 396, 168);
INSERT INTO public.who_global_data VALUES (93741, 0, 0, 0, 0, 396, 99);
INSERT INTO public.who_global_data VALUES (93742, 0, 0, 0, 0, 396, 171);
INSERT INTO public.who_global_data VALUES (93743, 0, 0, 0, 0, 396, 87);
INSERT INTO public.who_global_data VALUES (93744, 0, 0, 0, 0, 396, 123);
INSERT INTO public.who_global_data VALUES (93745, 0, 0, 0, 0, 396, 151);
INSERT INTO public.who_global_data VALUES (93746, 0, 0, 0, 0, 396, 213);
INSERT INTO public.who_global_data VALUES (93747, 0, 0, 0, 0, 396, 118);
INSERT INTO public.who_global_data VALUES (93748, 0, 0, 0, 0, 396, 134);
INSERT INTO public.who_global_data VALUES (93749, 0, 0, 0, 0, 396, 65);
INSERT INTO public.who_global_data VALUES (93750, 0, 0, 0, 0, 396, 102);
INSERT INTO public.who_global_data VALUES (93751, 0, 0, 0, 0, 396, 223);
INSERT INTO public.who_global_data VALUES (93752, 0, 0, 0, 0, 396, 4);
INSERT INTO public.who_global_data VALUES (93753, 0, 0, 0, 0, 396, 146);
INSERT INTO public.who_global_data VALUES (93754, 0, 0, 0, 0, 396, 31);
INSERT INTO public.who_global_data VALUES (93755, 0, 0, 0, 0, 396, 127);
INSERT INTO public.who_global_data VALUES (93756, 0, 0, 0, 0, 396, 22);
INSERT INTO public.who_global_data VALUES (93757, 0, 0, 0, 0, 396, 115);
INSERT INTO public.who_global_data VALUES (93758, 0, 0, 0, 0, 396, 106);
INSERT INTO public.who_global_data VALUES (93759, 0, 0, 0, 0, 396, 90);
INSERT INTO public.who_global_data VALUES (93760, 0, 0, 0, 0, 396, 70);
INSERT INTO public.who_global_data VALUES (93761, 0, 0, 0, 0, 396, 46);
INSERT INTO public.who_global_data VALUES (93762, 0, 0, 0, 0, 396, 139);
INSERT INTO public.who_global_data VALUES (93763, 0, 0, 0, 0, 396, 42);
INSERT INTO public.who_global_data VALUES (93764, 0, 0, 0, 0, 396, 80);
INSERT INTO public.who_global_data VALUES (93765, 0, 0, 0, 0, 396, 203);
INSERT INTO public.who_global_data VALUES (93766, 0, 0, 0, 0, 396, 136);
INSERT INTO public.who_global_data VALUES (93767, 0, 0, 0, 0, 396, 63);
INSERT INTO public.who_global_data VALUES (93768, 0, 0, 0, 0, 396, 17);
INSERT INTO public.who_global_data VALUES (93769, 0, 0, 0, 0, 396, 172);
INSERT INTO public.who_global_data VALUES (93770, 0, 0, 0, 0, 396, 109);
INSERT INTO public.who_global_data VALUES (93771, 0, 0, 0, 0, 396, 200);
INSERT INTO public.who_global_data VALUES (93772, 0, 0, 0, 0, 396, 93);
INSERT INTO public.who_global_data VALUES (93773, 0, 0, 0, 0, 396, 5);
INSERT INTO public.who_global_data VALUES (93774, 0, 0, 0, 0, 396, 214);
INSERT INTO public.who_global_data VALUES (93775, 0, 0, 0, 0, 396, 204);
INSERT INTO public.who_global_data VALUES (93776, 0, 0, 0, 0, 396, 198);
INSERT INTO public.who_global_data VALUES (93777, 0, 0, 0, 0, 396, 173);
INSERT INTO public.who_global_data VALUES (93778, 0, 0, 0, 0, 396, 229);
INSERT INTO public.who_global_data VALUES (93779, 0, 0, 0, 0, 396, 76);
INSERT INTO public.who_global_data VALUES (93780, 0, 0, 0, 0, 396, 138);
INSERT INTO public.who_global_data VALUES (93781, 0, 0, 0, 0, 396, 98);
INSERT INTO public.who_global_data VALUES (93782, 0, 0, 0, 0, 396, 103);
INSERT INTO public.who_global_data VALUES (93783, 0, 0, 0, 0, 396, 225);
INSERT INTO public.who_global_data VALUES (93784, 0, 0, 0, 0, 396, 131);
INSERT INTO public.who_global_data VALUES (93785, 0, 0, 0, 0, 396, 235);
INSERT INTO public.who_global_data VALUES (93786, 0, 0, 0, 0, 396, 137);
INSERT INTO public.who_global_data VALUES (93787, 0, 0, 0, 0, 396, 81);
INSERT INTO public.who_global_data VALUES (93788, 0, 0, 0, 0, 396, 182);
INSERT INTO public.who_global_data VALUES (93789, 0, 0, 0, 0, 396, 145);
INSERT INTO public.who_global_data VALUES (93790, 0, 0, 0, 0, 396, 26);
INSERT INTO public.who_global_data VALUES (93791, 0, 0, 0, 0, 396, 170);
INSERT INTO public.who_global_data VALUES (93792, 0, 0, 0, 0, 396, 191);
INSERT INTO public.who_global_data VALUES (93793, 0, 0, 0, 0, 396, 221);
INSERT INTO public.who_global_data VALUES (93794, 0, 0, 0, 0, 396, 64);
INSERT INTO public.who_global_data VALUES (93795, 0, 0, 0, 0, 396, 116);
INSERT INTO public.who_global_data VALUES (93796, 0, 0, 0, 0, 396, 128);
INSERT INTO public.who_global_data VALUES (93797, 0, 0, 0, 0, 396, 6);
INSERT INTO public.who_global_data VALUES (93798, 0, 0, 0, 0, 396, 227);
INSERT INTO public.who_global_data VALUES (93799, 0, 0, 0, 0, 396, 68);
INSERT INTO public.who_global_data VALUES (93800, 0, 0, 0, 0, 396, 184);
INSERT INTO public.who_global_data VALUES (93801, 0, 0, 0, 0, 396, 82);
INSERT INTO public.who_global_data VALUES (93802, 0, 0, 0, 0, 396, 149);
INSERT INTO public.who_global_data VALUES (93803, 0, 0, 0, 0, 396, 197);
INSERT INTO public.who_global_data VALUES (93804, 0, 0, 0, 0, 396, 78);
INSERT INTO public.who_global_data VALUES (93805, 0, 0, 0, 0, 396, 233);
INSERT INTO public.who_global_data VALUES (93806, 0, 0, 0, 0, 396, 133);
INSERT INTO public.who_global_data VALUES (93807, 0, 0, 0, 0, 396, 35);
INSERT INTO public.who_global_data VALUES (93808, 0, 0, 0, 0, 396, 114);
INSERT INTO public.who_global_data VALUES (93809, 0, 0, 0, 0, 396, 237);
INSERT INTO public.who_global_data VALUES (93810, 0, 0, 0, 0, 396, 55);
INSERT INTO public.who_global_data VALUES (93811, 0, 0, 0, 0, 396, 176);
INSERT INTO public.who_global_data VALUES (93812, 0, 0, 0, 0, 396, 202);
INSERT INTO public.who_global_data VALUES (93813, 0, 0, 0, 0, 396, 155);
INSERT INTO public.who_global_data VALUES (93814, 0, 0, 0, 0, 396, 32);
INSERT INTO public.who_global_data VALUES (93815, 0, 0, 0, 0, 396, 220);
INSERT INTO public.who_global_data VALUES (93816, 0, 0, 0, 0, 396, 30);
INSERT INTO public.who_global_data VALUES (93817, 0, 0, 0, 0, 396, 147);
INSERT INTO public.who_global_data VALUES (93818, 0, 0, 0, 0, 396, 208);
INSERT INTO public.who_global_data VALUES (93819, 0, 0, 0, 0, 396, 45);
INSERT INTO public.who_global_data VALUES (93820, 0, 0, 0, 0, 396, 110);
INSERT INTO public.who_global_data VALUES (93821, 0, 0, 0, 0, 396, 88);
INSERT INTO public.who_global_data VALUES (93822, 0, 0, 0, 0, 396, 51);
INSERT INTO public.who_global_data VALUES (93823, 0, 0, 0, 0, 396, 209);
INSERT INTO public.who_global_data VALUES (93824, 0, 0, 0, 0, 396, 205);
INSERT INTO public.who_global_data VALUES (93825, 0, 0, 0, 0, 396, 18);
INSERT INTO public.who_global_data VALUES (93826, 0, 0, 0, 0, 396, 72);
INSERT INTO public.who_global_data VALUES (93827, 0, 0, 0, 0, 396, 44);
INSERT INTO public.who_global_data VALUES (93828, 0, 0, 0, 0, 396, 15);
INSERT INTO public.who_global_data VALUES (93829, 0, 0, 0, 0, 396, 25);
INSERT INTO public.who_global_data VALUES (93830, 0, 0, 0, 0, 396, 179);
INSERT INTO public.who_global_data VALUES (93831, 0, 0, 0, 0, 396, 34);
INSERT INTO public.who_global_data VALUES (93832, 0, 0, 0, 0, 396, 207);
INSERT INTO public.who_global_data VALUES (93833, 0, 0, 0, 0, 396, 166);
INSERT INTO public.who_global_data VALUES (93834, 0, 0, 0, 0, 396, 126);
INSERT INTO public.who_global_data VALUES (93835, 0, 0, 0, 0, 396, 97);
INSERT INTO public.who_global_data VALUES (93836, 0, 0, 0, 0, 396, 36);
INSERT INTO public.who_global_data VALUES (93837, 0, 0, 0, 0, 396, 125);
INSERT INTO public.who_global_data VALUES (93838, 0, 0, 0, 0, 396, 124);
INSERT INTO public.who_global_data VALUES (93839, 0, 0, 0, 0, 396, 185);
INSERT INTO public.who_global_data VALUES (93840, 0, 0, 0, 0, 396, 194);
INSERT INTO public.who_global_data VALUES (93841, 0, 0, 0, 0, 396, 144);
INSERT INTO public.who_global_data VALUES (93842, 0, 0, 0, 0, 396, 19);
INSERT INTO public.who_global_data VALUES (93843, 0, 0, 0, 0, 396, 217);
INSERT INTO public.who_global_data VALUES (93844, 0, 0, 0, 0, 396, 148);
INSERT INTO public.who_global_data VALUES (93845, 0, 0, 0, 0, 396, 86);
INSERT INTO public.who_global_data VALUES (93846, 0, 0, 0, 0, 396, 13);
INSERT INTO public.who_global_data VALUES (93847, 0, 0, 0, 0, 396, 157);
INSERT INTO public.who_global_data VALUES (93848, 0, 0, 0, 0, 396, 8);
INSERT INTO public.who_global_data VALUES (93849, 0, 0, 0, 0, 396, 73);
INSERT INTO public.who_global_data VALUES (93850, 0, 0, 0, 0, 396, 101);
INSERT INTO public.who_global_data VALUES (93851, 0, 0, 0, 0, 396, 165);
INSERT INTO public.who_global_data VALUES (93852, 0, 0, 0, 0, 396, 14);
INSERT INTO public.who_global_data VALUES (93853, 0, 0, 0, 0, 397, 193);
INSERT INTO public.who_global_data VALUES (93854, 0, 0, 0, 0, 397, 113);
INSERT INTO public.who_global_data VALUES (93855, 0, 0, 0, 0, 397, 143);
INSERT INTO public.who_global_data VALUES (93856, 0, 0, 0, 0, 397, 219);
INSERT INTO public.who_global_data VALUES (93857, 0, 0, 0, 0, 397, 186);
INSERT INTO public.who_global_data VALUES (93858, 0, 0, 0, 0, 397, 52);
INSERT INTO public.who_global_data VALUES (93859, 0, 0, 0, 0, 397, 180);
INSERT INTO public.who_global_data VALUES (93860, 0, 0, 0, 0, 397, 167);
INSERT INTO public.who_global_data VALUES (93861, 0, 0, 0, 0, 397, 154);
INSERT INTO public.who_global_data VALUES (93862, 0, 0, 0, 0, 397, 94);
INSERT INTO public.who_global_data VALUES (93863, 0, 0, 0, 0, 397, 66);
INSERT INTO public.who_global_data VALUES (93864, 0, 0, 0, 0, 397, 58);
INSERT INTO public.who_global_data VALUES (93865, 0, 0, 0, 0, 397, 163);
INSERT INTO public.who_global_data VALUES (93866, 0, 0, 0, 0, 397, 37);
INSERT INTO public.who_global_data VALUES (93867, 0, 0, 0, 0, 397, 142);
INSERT INTO public.who_global_data VALUES (93868, 0, 0, 0, 0, 397, 83);
INSERT INTO public.who_global_data VALUES (93869, 0, 0, 0, 0, 397, 228);
INSERT INTO public.who_global_data VALUES (93870, 0, 0, 0, 0, 397, 188);
INSERT INTO public.who_global_data VALUES (93871, 0, 0, 0, 0, 397, 62);
INSERT INTO public.who_global_data VALUES (93872, 0, 0, 0, 0, 397, 160);
INSERT INTO public.who_global_data VALUES (93873, 0, 0, 0, 0, 397, 50);
INSERT INTO public.who_global_data VALUES (93874, 0, 0, 0, 0, 397, 33);
INSERT INTO public.who_global_data VALUES (93875, 0, 0, 0, 0, 397, 183);
INSERT INTO public.who_global_data VALUES (93876, 0, 0, 0, 0, 397, 92);
INSERT INTO public.who_global_data VALUES (93877, 0, 0, 0, 0, 397, 158);
INSERT INTO public.who_global_data VALUES (93878, 0, 0, 0, 0, 397, 67);
INSERT INTO public.who_global_data VALUES (93879, 0, 0, 0, 0, 397, 57);
INSERT INTO public.who_global_data VALUES (93880, 0, 0, 0, 0, 397, 38);
INSERT INTO public.who_global_data VALUES (93881, 0, 0, 0, 0, 397, 141);
INSERT INTO public.who_global_data VALUES (93882, 0, 0, 0, 0, 397, 178);
INSERT INTO public.who_global_data VALUES (93883, 0, 0, 0, 0, 397, 108);
INSERT INTO public.who_global_data VALUES (93884, 0, 0, 0, 0, 397, 39);
INSERT INTO public.who_global_data VALUES (93885, 0, 0, 0, 0, 397, 2);
INSERT INTO public.who_global_data VALUES (93886, 0, 0, 0, 0, 397, 195);
INSERT INTO public.who_global_data VALUES (93887, 0, 0, 0, 0, 397, 107);
INSERT INTO public.who_global_data VALUES (93888, 0, 0, 0, 0, 397, 161);
INSERT INTO public.who_global_data VALUES (93889, 0, 0, 0, 0, 397, 212);
INSERT INTO public.who_global_data VALUES (93890, 0, 0, 0, 0, 397, 181);
INSERT INTO public.who_global_data VALUES (93891, 0, 0, 0, 0, 397, 53);
INSERT INTO public.who_global_data VALUES (93892, 0, 0, 0, 0, 397, 164);
INSERT INTO public.who_global_data VALUES (93893, 0, 0, 0, 0, 397, 140);
INSERT INTO public.who_global_data VALUES (93894, 0, 0, 0, 0, 397, 20);
INSERT INTO public.who_global_data VALUES (93895, 3, 4, 0, 0, 397, 112);
INSERT INTO public.who_global_data VALUES (93896, 0, 0, 0, 0, 397, 111);
INSERT INTO public.who_global_data VALUES (93897, 0, 0, 0, 0, 397, 71);
INSERT INTO public.who_global_data VALUES (93898, 0, 0, 0, 0, 397, 218);
INSERT INTO public.who_global_data VALUES (93899, 0, 0, 0, 0, 397, 43);
INSERT INTO public.who_global_data VALUES (93900, 0, 0, 0, 0, 397, 49);
INSERT INTO public.who_global_data VALUES (93901, 0, 0, 0, 0, 397, 1);
INSERT INTO public.who_global_data VALUES (93902, 0, 0, 0, 0, 397, 48);
INSERT INTO public.who_global_data VALUES (93903, 0, 0, 0, 0, 397, 232);
INSERT INTO public.who_global_data VALUES (93904, 0, 0, 0, 0, 397, 175);
INSERT INTO public.who_global_data VALUES (93905, 0, 0, 0, 0, 397, 21);
INSERT INTO public.who_global_data VALUES (93906, 0, 0, 0, 0, 397, 156);
INSERT INTO public.who_global_data VALUES (93907, 0, 0, 0, 0, 397, 95);
INSERT INTO public.who_global_data VALUES (93908, 0, 0, 0, 0, 397, 177);
INSERT INTO public.who_global_data VALUES (93909, 0, 0, 0, 0, 397, 210);
INSERT INTO public.who_global_data VALUES (93910, 0, 0, 0, 0, 397, 120);
INSERT INTO public.who_global_data VALUES (93911, 0, 0, 0, 0, 397, 135);
INSERT INTO public.who_global_data VALUES (93912, 0, 0, 0, 0, 397, 206);
INSERT INTO public.who_global_data VALUES (93913, 0, 0, 0, 0, 397, 189);
INSERT INTO public.who_global_data VALUES (93914, 0, 0, 0, 0, 397, 129);
INSERT INTO public.who_global_data VALUES (93915, 0, 0, 0, 0, 397, 121);
INSERT INTO public.who_global_data VALUES (93916, 0, 0, 0, 0, 397, 59);
INSERT INTO public.who_global_data VALUES (93917, 0, 0, 0, 0, 397, 96);
INSERT INTO public.who_global_data VALUES (93918, 0, 0, 0, 0, 397, 41);
INSERT INTO public.who_global_data VALUES (93919, 0, 0, 0, 0, 397, 216);
INSERT INTO public.who_global_data VALUES (93920, 0, 0, 0, 0, 397, 236);
INSERT INTO public.who_global_data VALUES (93921, 0, 0, 0, 0, 397, 150);
INSERT INTO public.who_global_data VALUES (93922, 0, 0, 0, 0, 397, 61);
INSERT INTO public.who_global_data VALUES (93923, 0, 0, 0, 0, 397, 7);
INSERT INTO public.who_global_data VALUES (93924, 0, 0, 0, 0, 397, 169);
INSERT INTO public.who_global_data VALUES (93925, 0, 0, 0, 0, 397, 28);
INSERT INTO public.who_global_data VALUES (93926, 0, 0, 0, 0, 397, 85);
INSERT INTO public.who_global_data VALUES (93927, 0, 0, 0, 0, 397, 211);
INSERT INTO public.who_global_data VALUES (93928, 0, 0, 0, 0, 397, 60);
INSERT INTO public.who_global_data VALUES (93929, 0, 0, 0, 0, 397, 3);
INSERT INTO public.who_global_data VALUES (93930, 0, 0, 0, 0, 397, 11);
INSERT INTO public.who_global_data VALUES (93931, 0, 0, 0, 0, 397, 89);
INSERT INTO public.who_global_data VALUES (93932, 0, 0, 0, 0, 397, 24);
INSERT INTO public.who_global_data VALUES (93933, 0, 0, 0, 0, 397, 162);
INSERT INTO public.who_global_data VALUES (93934, 0, 0, 0, 0, 397, 100);
INSERT INTO public.who_global_data VALUES (93935, 0, 0, 0, 0, 397, 47);
INSERT INTO public.who_global_data VALUES (93936, 0, 0, 0, 0, 397, 29);
INSERT INTO public.who_global_data VALUES (93937, 0, 0, 0, 0, 397, 40);
INSERT INTO public.who_global_data VALUES (93938, 0, 0, 0, 0, 397, 222);
INSERT INTO public.who_global_data VALUES (93939, 0, 0, 0, 0, 397, 132);
INSERT INTO public.who_global_data VALUES (93940, 0, 0, 0, 0, 397, 130);
INSERT INTO public.who_global_data VALUES (93941, 0, 0, 0, 0, 397, 234);
INSERT INTO public.who_global_data VALUES (93942, 0, 0, 0, 0, 397, 23);
INSERT INTO public.who_global_data VALUES (93943, 0, 0, 0, 0, 397, 192);
INSERT INTO public.who_global_data VALUES (93944, 0, 0, 0, 0, 397, 69);
INSERT INTO public.who_global_data VALUES (93945, 0, 0, 0, 0, 397, 187);
INSERT INTO public.who_global_data VALUES (93946, 0, 0, 0, 0, 397, 230);
INSERT INTO public.who_global_data VALUES (93947, 0, 0, 0, 0, 397, 77);
INSERT INTO public.who_global_data VALUES (93948, 0, 0, 0, 0, 397, 9);
INSERT INTO public.who_global_data VALUES (93949, 0, 0, 0, 0, 397, 74);
INSERT INTO public.who_global_data VALUES (93950, 0, 0, 0, 0, 397, 224);
INSERT INTO public.who_global_data VALUES (93951, 0, 0, 0, 0, 397, 199);
INSERT INTO public.who_global_data VALUES (93952, 0, 0, 0, 0, 397, 190);
INSERT INTO public.who_global_data VALUES (93953, 0, 0, 0, 0, 397, 12);
INSERT INTO public.who_global_data VALUES (93954, 0, 0, 0, 0, 397, 104);
INSERT INTO public.who_global_data VALUES (93955, 0, 0, 0, 0, 397, 153);
INSERT INTO public.who_global_data VALUES (93956, 0, 0, 0, 0, 397, 91);
INSERT INTO public.who_global_data VALUES (93957, 0, 0, 0, 0, 397, 215);
INSERT INTO public.who_global_data VALUES (93958, 0, 0, 0, 0, 397, 84);
INSERT INTO public.who_global_data VALUES (93959, 0, 0, 0, 0, 397, 231);
INSERT INTO public.who_global_data VALUES (93960, 0, 0, 0, 0, 397, 196);
INSERT INTO public.who_global_data VALUES (93961, 0, 0, 0, 0, 397, 105);
INSERT INTO public.who_global_data VALUES (93962, 0, 0, 0, 0, 397, 122);
INSERT INTO public.who_global_data VALUES (93963, 0, 0, 0, 0, 397, 159);
INSERT INTO public.who_global_data VALUES (93964, 0, 0, 0, 0, 397, 75);
INSERT INTO public.who_global_data VALUES (93965, 0, 0, 0, 0, 397, 27);
INSERT INTO public.who_global_data VALUES (93966, 0, 0, 0, 0, 397, 54);
INSERT INTO public.who_global_data VALUES (93967, 0, 0, 0, 0, 397, 226);
INSERT INTO public.who_global_data VALUES (93968, 0, 0, 0, 0, 397, 79);
INSERT INTO public.who_global_data VALUES (93969, 0, 0, 0, 0, 397, 56);
INSERT INTO public.who_global_data VALUES (93970, 0, 0, 0, 0, 397, 117);
INSERT INTO public.who_global_data VALUES (93971, 0, 0, 0, 0, 397, 152);
INSERT INTO public.who_global_data VALUES (93972, 0, 0, 0, 0, 397, 16);
INSERT INTO public.who_global_data VALUES (93973, 0, 0, 0, 0, 397, 10);
INSERT INTO public.who_global_data VALUES (93974, 0, 0, 0, 0, 397, 201);
INSERT INTO public.who_global_data VALUES (93975, 0, 0, 0, 0, 397, 174);
INSERT INTO public.who_global_data VALUES (93976, 0, 0, 0, 0, 397, 119);
INSERT INTO public.who_global_data VALUES (93977, 0, 0, 0, 0, 397, 168);
INSERT INTO public.who_global_data VALUES (93978, 0, 0, 0, 0, 397, 99);
INSERT INTO public.who_global_data VALUES (93979, 0, 0, 0, 0, 397, 171);
INSERT INTO public.who_global_data VALUES (93980, 0, 0, 0, 0, 397, 87);
INSERT INTO public.who_global_data VALUES (93981, 0, 0, 0, 0, 397, 123);
INSERT INTO public.who_global_data VALUES (93982, 0, 0, 0, 0, 397, 151);
INSERT INTO public.who_global_data VALUES (93983, 0, 0, 0, 0, 397, 213);
INSERT INTO public.who_global_data VALUES (93984, 0, 0, 0, 0, 397, 118);
INSERT INTO public.who_global_data VALUES (93985, 0, 0, 0, 0, 397, 134);
INSERT INTO public.who_global_data VALUES (93986, 0, 0, 0, 0, 397, 65);
INSERT INTO public.who_global_data VALUES (93987, 0, 0, 0, 0, 397, 102);
INSERT INTO public.who_global_data VALUES (93988, 0, 0, 0, 0, 397, 223);
INSERT INTO public.who_global_data VALUES (93989, 0, 0, 0, 0, 397, 4);
INSERT INTO public.who_global_data VALUES (93990, 0, 0, 0, 0, 397, 146);
INSERT INTO public.who_global_data VALUES (93991, 0, 0, 0, 0, 397, 31);
INSERT INTO public.who_global_data VALUES (93992, 0, 0, 0, 0, 397, 127);
INSERT INTO public.who_global_data VALUES (93993, 0, 0, 0, 0, 397, 22);
INSERT INTO public.who_global_data VALUES (93994, 0, 0, 0, 0, 397, 115);
INSERT INTO public.who_global_data VALUES (93995, 0, 0, 0, 0, 397, 106);
INSERT INTO public.who_global_data VALUES (93996, 0, 0, 0, 0, 397, 90);
INSERT INTO public.who_global_data VALUES (93997, 0, 0, 0, 0, 397, 70);
INSERT INTO public.who_global_data VALUES (93998, 0, 0, 0, 0, 397, 46);
INSERT INTO public.who_global_data VALUES (93999, 0, 0, 0, 0, 397, 139);
INSERT INTO public.who_global_data VALUES (94000, 0, 0, 0, 0, 397, 42);
INSERT INTO public.who_global_data VALUES (94001, 0, 0, 0, 0, 397, 80);
INSERT INTO public.who_global_data VALUES (94002, 0, 0, 0, 0, 397, 203);
INSERT INTO public.who_global_data VALUES (94003, 0, 0, 0, 0, 397, 136);
INSERT INTO public.who_global_data VALUES (94004, 0, 0, 0, 0, 397, 63);
INSERT INTO public.who_global_data VALUES (94005, 0, 0, 0, 0, 397, 17);
INSERT INTO public.who_global_data VALUES (94006, 0, 0, 0, 0, 397, 172);
INSERT INTO public.who_global_data VALUES (94007, 0, 0, 0, 0, 397, 109);
INSERT INTO public.who_global_data VALUES (94008, 0, 0, 0, 0, 397, 200);
INSERT INTO public.who_global_data VALUES (94009, 0, 0, 0, 0, 397, 93);
INSERT INTO public.who_global_data VALUES (94010, 0, 0, 0, 0, 397, 5);
INSERT INTO public.who_global_data VALUES (94011, 0, 0, 0, 0, 397, 214);
INSERT INTO public.who_global_data VALUES (94012, 0, 0, 0, 0, 397, 204);
INSERT INTO public.who_global_data VALUES (94013, 0, 0, 0, 0, 397, 198);
INSERT INTO public.who_global_data VALUES (94014, 0, 0, 0, 0, 397, 173);
INSERT INTO public.who_global_data VALUES (94015, 0, 0, 0, 0, 397, 229);
INSERT INTO public.who_global_data VALUES (94016, 0, 0, 0, 0, 397, 76);
INSERT INTO public.who_global_data VALUES (94017, 0, 0, 0, 0, 397, 138);
INSERT INTO public.who_global_data VALUES (94018, 0, 0, 0, 0, 397, 98);
INSERT INTO public.who_global_data VALUES (94019, 0, 0, 0, 0, 397, 103);
INSERT INTO public.who_global_data VALUES (94020, 0, 0, 0, 0, 397, 225);
INSERT INTO public.who_global_data VALUES (94021, 0, 0, 0, 0, 397, 131);
INSERT INTO public.who_global_data VALUES (94022, 0, 0, 0, 0, 397, 235);
INSERT INTO public.who_global_data VALUES (94023, 0, 0, 0, 0, 397, 137);
INSERT INTO public.who_global_data VALUES (94024, 0, 0, 0, 0, 397, 81);
INSERT INTO public.who_global_data VALUES (94025, 0, 0, 0, 0, 397, 182);
INSERT INTO public.who_global_data VALUES (94026, 0, 0, 0, 0, 397, 145);
INSERT INTO public.who_global_data VALUES (94027, 0, 0, 0, 0, 397, 26);
INSERT INTO public.who_global_data VALUES (94028, 0, 0, 0, 0, 397, 170);
INSERT INTO public.who_global_data VALUES (94029, 0, 0, 0, 0, 397, 191);
INSERT INTO public.who_global_data VALUES (94030, 0, 0, 0, 0, 397, 221);
INSERT INTO public.who_global_data VALUES (94031, 0, 0, 0, 0, 397, 64);
INSERT INTO public.who_global_data VALUES (94032, 0, 0, 0, 0, 397, 116);
INSERT INTO public.who_global_data VALUES (94033, 0, 0, 0, 0, 397, 128);
INSERT INTO public.who_global_data VALUES (94034, 0, 0, 0, 0, 397, 6);
INSERT INTO public.who_global_data VALUES (94035, 0, 0, 0, 0, 397, 227);
INSERT INTO public.who_global_data VALUES (94036, 0, 0, 0, 0, 397, 68);
INSERT INTO public.who_global_data VALUES (94037, 0, 0, 0, 0, 397, 184);
INSERT INTO public.who_global_data VALUES (94038, 0, 0, 0, 0, 397, 82);
INSERT INTO public.who_global_data VALUES (94039, 0, 0, 0, 0, 397, 149);
INSERT INTO public.who_global_data VALUES (94040, 0, 0, 0, 0, 397, 197);
INSERT INTO public.who_global_data VALUES (94041, 0, 0, 0, 0, 397, 78);
INSERT INTO public.who_global_data VALUES (94042, 0, 0, 0, 0, 397, 233);
INSERT INTO public.who_global_data VALUES (94043, 0, 0, 0, 0, 397, 133);
INSERT INTO public.who_global_data VALUES (94044, 0, 0, 0, 0, 397, 35);
INSERT INTO public.who_global_data VALUES (94045, 0, 0, 0, 0, 397, 114);
INSERT INTO public.who_global_data VALUES (94046, 0, 0, 0, 0, 397, 237);
INSERT INTO public.who_global_data VALUES (94047, 0, 0, 0, 0, 397, 55);
INSERT INTO public.who_global_data VALUES (94048, 0, 0, 0, 0, 397, 176);
INSERT INTO public.who_global_data VALUES (94049, 0, 0, 0, 0, 397, 202);
INSERT INTO public.who_global_data VALUES (94050, 0, 0, 0, 0, 397, 155);
INSERT INTO public.who_global_data VALUES (94051, 0, 0, 0, 0, 397, 32);
INSERT INTO public.who_global_data VALUES (94052, 0, 0, 0, 0, 397, 220);
INSERT INTO public.who_global_data VALUES (94053, 0, 0, 0, 0, 397, 30);
INSERT INTO public.who_global_data VALUES (94054, 0, 0, 0, 0, 397, 147);
INSERT INTO public.who_global_data VALUES (94055, 0, 0, 0, 0, 397, 208);
INSERT INTO public.who_global_data VALUES (94056, 0, 0, 0, 0, 397, 45);
INSERT INTO public.who_global_data VALUES (94057, 0, 0, 0, 0, 397, 110);
INSERT INTO public.who_global_data VALUES (94058, 0, 0, 0, 0, 397, 88);
INSERT INTO public.who_global_data VALUES (94059, 0, 0, 0, 0, 397, 51);
INSERT INTO public.who_global_data VALUES (94060, 0, 0, 0, 0, 397, 209);
INSERT INTO public.who_global_data VALUES (94061, 0, 0, 0, 0, 397, 205);
INSERT INTO public.who_global_data VALUES (94062, 0, 0, 0, 0, 397, 18);
INSERT INTO public.who_global_data VALUES (94063, 0, 0, 0, 0, 397, 72);
INSERT INTO public.who_global_data VALUES (94064, 0, 0, 0, 0, 397, 44);
INSERT INTO public.who_global_data VALUES (94065, 0, 0, 0, 0, 397, 15);
INSERT INTO public.who_global_data VALUES (94066, 0, 0, 0, 0, 397, 25);
INSERT INTO public.who_global_data VALUES (94067, 0, 0, 0, 0, 397, 179);
INSERT INTO public.who_global_data VALUES (94068, 0, 0, 0, 0, 397, 34);
INSERT INTO public.who_global_data VALUES (94069, 0, 0, 0, 0, 397, 207);
INSERT INTO public.who_global_data VALUES (94070, 0, 0, 0, 0, 397, 166);
INSERT INTO public.who_global_data VALUES (94071, 0, 0, 0, 0, 397, 126);
INSERT INTO public.who_global_data VALUES (94072, 0, 0, 0, 0, 397, 97);
INSERT INTO public.who_global_data VALUES (94073, 0, 0, 0, 0, 397, 36);
INSERT INTO public.who_global_data VALUES (94074, 0, 0, 0, 0, 397, 125);
INSERT INTO public.who_global_data VALUES (94075, 0, 0, 0, 0, 397, 124);
INSERT INTO public.who_global_data VALUES (94076, 0, 0, 0, 0, 397, 185);
INSERT INTO public.who_global_data VALUES (94077, 0, 0, 0, 0, 397, 194);
INSERT INTO public.who_global_data VALUES (94078, 0, 0, 0, 0, 397, 144);
INSERT INTO public.who_global_data VALUES (94079, 0, 0, 0, 0, 397, 19);
INSERT INTO public.who_global_data VALUES (94080, 0, 0, 0, 0, 397, 217);
INSERT INTO public.who_global_data VALUES (94081, 0, 0, 0, 0, 397, 148);
INSERT INTO public.who_global_data VALUES (94082, 0, 0, 0, 0, 397, 86);
INSERT INTO public.who_global_data VALUES (94083, 0, 0, 0, 0, 397, 13);
INSERT INTO public.who_global_data VALUES (94084, 0, 0, 0, 0, 397, 157);
INSERT INTO public.who_global_data VALUES (94085, 0, 0, 0, 0, 397, 8);
INSERT INTO public.who_global_data VALUES (94086, 0, 0, 0, 0, 397, 73);
INSERT INTO public.who_global_data VALUES (94087, 0, 0, 0, 0, 397, 101);
INSERT INTO public.who_global_data VALUES (94088, 0, 0, 0, 0, 397, 165);
INSERT INTO public.who_global_data VALUES (94089, 0, 0, 0, 0, 397, 14);
INSERT INTO public.who_global_data VALUES (94090, 0, 0, 0, 0, 398, 193);
INSERT INTO public.who_global_data VALUES (94091, 0, 0, 0, 0, 398, 113);
INSERT INTO public.who_global_data VALUES (94092, 0, 0, 0, 0, 398, 143);
INSERT INTO public.who_global_data VALUES (94093, 0, 0, 0, 0, 398, 219);
INSERT INTO public.who_global_data VALUES (94094, 0, 0, 0, 0, 398, 186);
INSERT INTO public.who_global_data VALUES (94095, 0, 0, 0, 0, 398, 52);
INSERT INTO public.who_global_data VALUES (94096, 0, 0, 0, 0, 398, 180);
INSERT INTO public.who_global_data VALUES (94097, 0, 0, 0, 0, 398, 167);
INSERT INTO public.who_global_data VALUES (94098, 0, 0, 0, 0, 398, 154);
INSERT INTO public.who_global_data VALUES (94099, 0, 0, 0, 0, 398, 94);
INSERT INTO public.who_global_data VALUES (94100, 0, 0, 0, 0, 398, 66);
INSERT INTO public.who_global_data VALUES (94101, 0, 0, 0, 0, 398, 58);
INSERT INTO public.who_global_data VALUES (94102, 0, 0, 0, 0, 398, 163);
INSERT INTO public.who_global_data VALUES (94103, 0, 0, 0, 0, 398, 37);
INSERT INTO public.who_global_data VALUES (94104, 0, 0, 0, 0, 398, 142);
INSERT INTO public.who_global_data VALUES (94105, 0, 0, 0, 0, 398, 83);
INSERT INTO public.who_global_data VALUES (94106, 0, 0, 0, 0, 398, 228);
INSERT INTO public.who_global_data VALUES (94107, 0, 0, 0, 0, 398, 188);
INSERT INTO public.who_global_data VALUES (94108, 0, 0, 0, 0, 398, 62);
INSERT INTO public.who_global_data VALUES (94109, 0, 0, 0, 0, 398, 160);
INSERT INTO public.who_global_data VALUES (94110, 0, 0, 0, 0, 398, 50);
INSERT INTO public.who_global_data VALUES (94111, 0, 0, 0, 0, 398, 33);
INSERT INTO public.who_global_data VALUES (94112, 0, 0, 0, 0, 398, 183);
INSERT INTO public.who_global_data VALUES (94113, 0, 0, 0, 0, 398, 92);
INSERT INTO public.who_global_data VALUES (94114, 0, 0, 0, 0, 398, 158);
INSERT INTO public.who_global_data VALUES (94115, 0, 0, 0, 0, 398, 67);
INSERT INTO public.who_global_data VALUES (94116, 0, 0, 0, 0, 398, 57);
INSERT INTO public.who_global_data VALUES (94117, 0, 0, 0, 0, 398, 38);
INSERT INTO public.who_global_data VALUES (94118, 0, 0, 0, 0, 398, 141);
INSERT INTO public.who_global_data VALUES (94119, 0, 0, 0, 0, 398, 178);
INSERT INTO public.who_global_data VALUES (94120, 0, 0, 0, 0, 398, 108);
INSERT INTO public.who_global_data VALUES (94121, 0, 0, 0, 0, 398, 39);
INSERT INTO public.who_global_data VALUES (94122, 0, 0, 0, 0, 398, 2);
INSERT INTO public.who_global_data VALUES (94123, 0, 0, 0, 0, 398, 195);
INSERT INTO public.who_global_data VALUES (94124, 0, 0, 0, 0, 398, 107);
INSERT INTO public.who_global_data VALUES (94125, 0, 0, 0, 0, 398, 161);
INSERT INTO public.who_global_data VALUES (94126, 0, 0, 0, 0, 398, 212);
INSERT INTO public.who_global_data VALUES (94127, 0, 0, 0, 0, 398, 181);
INSERT INTO public.who_global_data VALUES (94128, 0, 0, 0, 0, 398, 53);
INSERT INTO public.who_global_data VALUES (94129, 0, 0, 0, 0, 398, 164);
INSERT INTO public.who_global_data VALUES (94130, 0, 0, 0, 0, 398, 140);
INSERT INTO public.who_global_data VALUES (94131, 0, 0, 0, 0, 398, 20);
INSERT INTO public.who_global_data VALUES (94132, 0, 1, 0, 0, 398, 112);
INSERT INTO public.who_global_data VALUES (94133, 0, 0, 0, 0, 398, 111);
INSERT INTO public.who_global_data VALUES (94134, 0, 0, 0, 0, 398, 71);
INSERT INTO public.who_global_data VALUES (94135, 0, 0, 0, 0, 398, 218);
INSERT INTO public.who_global_data VALUES (94136, 0, 0, 0, 0, 398, 43);
INSERT INTO public.who_global_data VALUES (94137, 0, 0, 0, 0, 398, 49);
INSERT INTO public.who_global_data VALUES (94138, 0, 0, 0, 0, 398, 1);
INSERT INTO public.who_global_data VALUES (94139, 0, 0, 0, 0, 398, 48);
INSERT INTO public.who_global_data VALUES (94140, 0, 0, 0, 0, 398, 232);
INSERT INTO public.who_global_data VALUES (94141, 0, 0, 0, 0, 398, 175);
INSERT INTO public.who_global_data VALUES (94142, 0, 0, 0, 0, 398, 21);
INSERT INTO public.who_global_data VALUES (94143, 0, 0, 0, 0, 398, 156);
INSERT INTO public.who_global_data VALUES (94144, 0, 0, 0, 0, 398, 95);
INSERT INTO public.who_global_data VALUES (94145, 0, 0, 0, 0, 398, 177);
INSERT INTO public.who_global_data VALUES (94146, 0, 0, 0, 0, 398, 210);
INSERT INTO public.who_global_data VALUES (94147, 0, 0, 0, 0, 398, 120);
INSERT INTO public.who_global_data VALUES (94148, 0, 0, 0, 0, 398, 135);
INSERT INTO public.who_global_data VALUES (94149, 0, 0, 0, 0, 398, 206);
INSERT INTO public.who_global_data VALUES (94150, 0, 0, 0, 0, 398, 189);
INSERT INTO public.who_global_data VALUES (94151, 0, 0, 0, 0, 398, 129);
INSERT INTO public.who_global_data VALUES (94152, 0, 0, 0, 0, 398, 121);
INSERT INTO public.who_global_data VALUES (94153, 0, 0, 0, 0, 398, 59);
INSERT INTO public.who_global_data VALUES (94154, 0, 0, 0, 0, 398, 96);
INSERT INTO public.who_global_data VALUES (94155, 0, 0, 0, 0, 398, 41);
INSERT INTO public.who_global_data VALUES (94156, 0, 0, 0, 0, 398, 216);
INSERT INTO public.who_global_data VALUES (94157, 0, 0, 0, 0, 398, 236);
INSERT INTO public.who_global_data VALUES (94158, 0, 0, 0, 0, 398, 150);
INSERT INTO public.who_global_data VALUES (94159, 0, 0, 0, 0, 398, 61);
INSERT INTO public.who_global_data VALUES (94160, 0, 0, 0, 0, 398, 7);
INSERT INTO public.who_global_data VALUES (94161, 0, 0, 0, 0, 398, 169);
INSERT INTO public.who_global_data VALUES (94162, 0, 0, 0, 0, 398, 28);
INSERT INTO public.who_global_data VALUES (94163, 0, 0, 0, 0, 398, 85);
INSERT INTO public.who_global_data VALUES (94164, 0, 0, 0, 0, 398, 211);
INSERT INTO public.who_global_data VALUES (94165, 0, 0, 0, 0, 398, 60);
INSERT INTO public.who_global_data VALUES (94166, 0, 0, 0, 0, 398, 3);
INSERT INTO public.who_global_data VALUES (94167, 0, 0, 0, 0, 398, 11);
INSERT INTO public.who_global_data VALUES (94168, 0, 0, 0, 0, 398, 89);
INSERT INTO public.who_global_data VALUES (94169, 0, 0, 0, 0, 398, 24);
INSERT INTO public.who_global_data VALUES (94170, 0, 0, 0, 0, 398, 162);
INSERT INTO public.who_global_data VALUES (94171, 0, 0, 0, 0, 398, 100);
INSERT INTO public.who_global_data VALUES (94172, 0, 0, 0, 0, 398, 47);
INSERT INTO public.who_global_data VALUES (94173, 0, 0, 0, 0, 398, 29);
INSERT INTO public.who_global_data VALUES (94174, 0, 0, 0, 0, 398, 40);
INSERT INTO public.who_global_data VALUES (94175, 0, 0, 0, 0, 398, 222);
INSERT INTO public.who_global_data VALUES (94176, 0, 0, 0, 0, 398, 132);
INSERT INTO public.who_global_data VALUES (94177, 0, 0, 0, 0, 398, 130);
INSERT INTO public.who_global_data VALUES (94178, 0, 0, 0, 0, 398, 234);
INSERT INTO public.who_global_data VALUES (94179, 0, 0, 0, 0, 398, 23);
INSERT INTO public.who_global_data VALUES (94180, 0, 0, 0, 0, 398, 192);
INSERT INTO public.who_global_data VALUES (94181, 0, 0, 0, 0, 398, 69);
INSERT INTO public.who_global_data VALUES (94182, 0, 0, 0, 0, 398, 187);
INSERT INTO public.who_global_data VALUES (94183, 0, 0, 0, 0, 398, 230);
INSERT INTO public.who_global_data VALUES (94184, 0, 0, 0, 0, 398, 77);
INSERT INTO public.who_global_data VALUES (94185, 0, 0, 0, 0, 398, 9);
INSERT INTO public.who_global_data VALUES (94186, 0, 0, 0, 0, 398, 74);
INSERT INTO public.who_global_data VALUES (94187, 0, 0, 0, 0, 398, 224);
INSERT INTO public.who_global_data VALUES (94188, 0, 0, 0, 0, 398, 199);
INSERT INTO public.who_global_data VALUES (94189, 0, 0, 0, 0, 398, 190);
INSERT INTO public.who_global_data VALUES (94190, 0, 0, 0, 0, 398, 12);
INSERT INTO public.who_global_data VALUES (94191, 0, 0, 0, 0, 398, 104);
INSERT INTO public.who_global_data VALUES (94192, 0, 0, 0, 0, 398, 153);
INSERT INTO public.who_global_data VALUES (94193, 0, 0, 0, 0, 398, 91);
INSERT INTO public.who_global_data VALUES (94194, 0, 0, 0, 0, 398, 215);
INSERT INTO public.who_global_data VALUES (94195, 0, 0, 0, 0, 398, 84);
INSERT INTO public.who_global_data VALUES (94196, 0, 0, 0, 0, 398, 231);
INSERT INTO public.who_global_data VALUES (94197, 0, 0, 0, 0, 398, 196);
INSERT INTO public.who_global_data VALUES (94198, 0, 0, 0, 0, 398, 105);
INSERT INTO public.who_global_data VALUES (94199, 0, 0, 0, 0, 398, 122);
INSERT INTO public.who_global_data VALUES (94200, 0, 0, 0, 0, 398, 159);
INSERT INTO public.who_global_data VALUES (94201, 0, 0, 0, 0, 398, 75);
INSERT INTO public.who_global_data VALUES (94202, 0, 0, 0, 0, 398, 27);
INSERT INTO public.who_global_data VALUES (94203, 0, 0, 0, 0, 398, 54);
INSERT INTO public.who_global_data VALUES (94204, 0, 0, 0, 0, 398, 226);
INSERT INTO public.who_global_data VALUES (94205, 0, 0, 0, 0, 398, 79);
INSERT INTO public.who_global_data VALUES (94206, 0, 0, 0, 0, 398, 56);
INSERT INTO public.who_global_data VALUES (94207, 0, 0, 0, 0, 398, 117);
INSERT INTO public.who_global_data VALUES (94208, 0, 0, 0, 0, 398, 152);
INSERT INTO public.who_global_data VALUES (94209, 0, 0, 0, 0, 398, 16);
INSERT INTO public.who_global_data VALUES (94210, 0, 0, 0, 0, 398, 10);
INSERT INTO public.who_global_data VALUES (94211, 0, 0, 0, 0, 398, 201);
INSERT INTO public.who_global_data VALUES (94212, 0, 0, 0, 0, 398, 174);
INSERT INTO public.who_global_data VALUES (94213, 0, 0, 0, 0, 398, 119);
INSERT INTO public.who_global_data VALUES (94214, 0, 0, 0, 0, 398, 168);
INSERT INTO public.who_global_data VALUES (94215, 0, 0, 0, 0, 398, 99);
INSERT INTO public.who_global_data VALUES (94216, 0, 0, 0, 0, 398, 171);
INSERT INTO public.who_global_data VALUES (94217, 0, 0, 0, 0, 398, 87);
INSERT INTO public.who_global_data VALUES (94218, 0, 0, 0, 0, 398, 123);
INSERT INTO public.who_global_data VALUES (94219, 0, 0, 0, 0, 398, 151);
INSERT INTO public.who_global_data VALUES (94220, 0, 0, 0, 0, 398, 213);
INSERT INTO public.who_global_data VALUES (94221, 0, 0, 0, 0, 398, 118);
INSERT INTO public.who_global_data VALUES (94222, 0, 0, 0, 0, 398, 134);
INSERT INTO public.who_global_data VALUES (94223, 0, 0, 0, 0, 398, 65);
INSERT INTO public.who_global_data VALUES (94224, 0, 0, 0, 0, 398, 102);
INSERT INTO public.who_global_data VALUES (94225, 0, 0, 0, 0, 398, 223);
INSERT INTO public.who_global_data VALUES (94226, 0, 0, 0, 0, 398, 4);
INSERT INTO public.who_global_data VALUES (94227, 0, 0, 0, 0, 398, 146);
INSERT INTO public.who_global_data VALUES (94228, 0, 0, 0, 0, 398, 31);
INSERT INTO public.who_global_data VALUES (94229, 0, 0, 0, 0, 398, 127);
INSERT INTO public.who_global_data VALUES (94230, 0, 0, 0, 0, 398, 22);
INSERT INTO public.who_global_data VALUES (94231, 0, 0, 0, 0, 398, 115);
INSERT INTO public.who_global_data VALUES (94232, 0, 0, 0, 0, 398, 106);
INSERT INTO public.who_global_data VALUES (94233, 0, 0, 0, 0, 398, 90);
INSERT INTO public.who_global_data VALUES (94234, 0, 0, 0, 0, 398, 70);
INSERT INTO public.who_global_data VALUES (94235, 0, 0, 0, 0, 398, 46);
INSERT INTO public.who_global_data VALUES (94236, 0, 0, 0, 0, 398, 139);
INSERT INTO public.who_global_data VALUES (94237, 0, 0, 0, 0, 398, 42);
INSERT INTO public.who_global_data VALUES (94238, 0, 0, 0, 0, 398, 80);
INSERT INTO public.who_global_data VALUES (94239, 0, 0, 0, 0, 398, 203);
INSERT INTO public.who_global_data VALUES (94240, 0, 0, 0, 0, 398, 136);
INSERT INTO public.who_global_data VALUES (94241, 0, 0, 0, 0, 398, 63);
INSERT INTO public.who_global_data VALUES (94242, 0, 0, 0, 0, 398, 17);
INSERT INTO public.who_global_data VALUES (94243, 0, 0, 0, 0, 398, 172);
INSERT INTO public.who_global_data VALUES (94244, 0, 0, 0, 0, 398, 109);
INSERT INTO public.who_global_data VALUES (94245, 0, 0, 0, 0, 398, 200);
INSERT INTO public.who_global_data VALUES (94246, 0, 0, 0, 0, 398, 93);
INSERT INTO public.who_global_data VALUES (94247, 0, 0, 0, 0, 398, 5);
INSERT INTO public.who_global_data VALUES (94248, 0, 0, 0, 0, 398, 214);
INSERT INTO public.who_global_data VALUES (94249, 0, 0, 0, 0, 398, 204);
INSERT INTO public.who_global_data VALUES (94250, 0, 0, 0, 0, 398, 198);
INSERT INTO public.who_global_data VALUES (94251, 0, 0, 0, 0, 398, 173);
INSERT INTO public.who_global_data VALUES (94252, 0, 0, 0, 0, 398, 229);
INSERT INTO public.who_global_data VALUES (94253, 0, 0, 0, 0, 398, 76);
INSERT INTO public.who_global_data VALUES (94254, 0, 0, 0, 0, 398, 138);
INSERT INTO public.who_global_data VALUES (94255, 0, 0, 0, 0, 398, 98);
INSERT INTO public.who_global_data VALUES (94256, 0, 0, 0, 0, 398, 103);
INSERT INTO public.who_global_data VALUES (94257, 0, 0, 0, 0, 398, 225);
INSERT INTO public.who_global_data VALUES (94258, 0, 0, 0, 0, 398, 131);
INSERT INTO public.who_global_data VALUES (94259, 0, 0, 0, 0, 398, 235);
INSERT INTO public.who_global_data VALUES (94260, 0, 0, 0, 0, 398, 137);
INSERT INTO public.who_global_data VALUES (94261, 0, 0, 0, 0, 398, 81);
INSERT INTO public.who_global_data VALUES (94262, 0, 0, 0, 0, 398, 182);
INSERT INTO public.who_global_data VALUES (94263, 0, 0, 0, 0, 398, 145);
INSERT INTO public.who_global_data VALUES (94264, 0, 0, 0, 0, 398, 26);
INSERT INTO public.who_global_data VALUES (94265, 0, 0, 0, 0, 398, 170);
INSERT INTO public.who_global_data VALUES (94266, 0, 0, 0, 0, 398, 191);
INSERT INTO public.who_global_data VALUES (94267, 0, 0, 0, 0, 398, 221);
INSERT INTO public.who_global_data VALUES (94268, 0, 0, 0, 0, 398, 64);
INSERT INTO public.who_global_data VALUES (94269, 0, 0, 0, 0, 398, 116);
INSERT INTO public.who_global_data VALUES (94270, 0, 0, 0, 0, 398, 128);
INSERT INTO public.who_global_data VALUES (94271, 0, 0, 0, 0, 398, 6);
INSERT INTO public.who_global_data VALUES (94272, 0, 0, 0, 0, 398, 227);
INSERT INTO public.who_global_data VALUES (94273, 0, 0, 0, 0, 398, 68);
INSERT INTO public.who_global_data VALUES (94274, 0, 0, 0, 0, 398, 184);
INSERT INTO public.who_global_data VALUES (94275, 0, 0, 0, 0, 398, 82);
INSERT INTO public.who_global_data VALUES (94276, 0, 0, 0, 0, 398, 149);
INSERT INTO public.who_global_data VALUES (94277, 0, 0, 0, 0, 398, 197);
INSERT INTO public.who_global_data VALUES (94278, 0, 0, 0, 0, 398, 78);
INSERT INTO public.who_global_data VALUES (94279, 0, 0, 0, 0, 398, 233);
INSERT INTO public.who_global_data VALUES (94280, 0, 0, 0, 0, 398, 133);
INSERT INTO public.who_global_data VALUES (94281, 0, 0, 0, 0, 398, 35);
INSERT INTO public.who_global_data VALUES (94282, 0, 0, 0, 0, 398, 114);
INSERT INTO public.who_global_data VALUES (94283, 0, 0, 0, 0, 398, 237);
INSERT INTO public.who_global_data VALUES (94284, 0, 0, 0, 0, 398, 55);
INSERT INTO public.who_global_data VALUES (94285, 0, 0, 0, 0, 398, 176);
INSERT INTO public.who_global_data VALUES (94286, 0, 0, 0, 0, 398, 202);
INSERT INTO public.who_global_data VALUES (94287, 0, 0, 0, 0, 398, 155);
INSERT INTO public.who_global_data VALUES (94288, 0, 0, 0, 0, 398, 32);
INSERT INTO public.who_global_data VALUES (94289, 0, 0, 0, 0, 398, 220);
INSERT INTO public.who_global_data VALUES (94290, 0, 0, 0, 0, 398, 30);
INSERT INTO public.who_global_data VALUES (94291, 0, 0, 0, 0, 398, 147);
INSERT INTO public.who_global_data VALUES (94292, 0, 0, 0, 0, 398, 208);
INSERT INTO public.who_global_data VALUES (94293, 0, 0, 0, 0, 398, 45);
INSERT INTO public.who_global_data VALUES (94294, 0, 0, 0, 0, 398, 110);
INSERT INTO public.who_global_data VALUES (94295, 0, 0, 0, 0, 398, 88);
INSERT INTO public.who_global_data VALUES (94296, 0, 0, 0, 0, 398, 51);
INSERT INTO public.who_global_data VALUES (94297, 0, 0, 0, 0, 398, 209);
INSERT INTO public.who_global_data VALUES (94298, 0, 0, 0, 0, 398, 205);
INSERT INTO public.who_global_data VALUES (94299, 0, 0, 0, 0, 398, 18);
INSERT INTO public.who_global_data VALUES (94300, 0, 0, 0, 0, 398, 72);
INSERT INTO public.who_global_data VALUES (94301, 0, 0, 0, 0, 398, 44);
INSERT INTO public.who_global_data VALUES (94302, 0, 0, 0, 0, 398, 15);
INSERT INTO public.who_global_data VALUES (94303, 0, 0, 0, 0, 398, 25);
INSERT INTO public.who_global_data VALUES (94304, 0, 0, 0, 0, 398, 179);
INSERT INTO public.who_global_data VALUES (94305, 0, 0, 0, 0, 398, 34);
INSERT INTO public.who_global_data VALUES (94306, 0, 0, 0, 0, 398, 207);
INSERT INTO public.who_global_data VALUES (94307, 0, 0, 0, 0, 398, 166);
INSERT INTO public.who_global_data VALUES (94308, 0, 0, 0, 0, 398, 126);
INSERT INTO public.who_global_data VALUES (94309, 0, 0, 0, 0, 398, 97);
INSERT INTO public.who_global_data VALUES (94310, 0, 0, 0, 0, 398, 36);
INSERT INTO public.who_global_data VALUES (94311, 0, 0, 0, 0, 398, 125);
INSERT INTO public.who_global_data VALUES (94312, 0, 0, 0, 0, 398, 124);
INSERT INTO public.who_global_data VALUES (94313, 0, 0, 0, 0, 398, 185);
INSERT INTO public.who_global_data VALUES (94314, 0, 0, 0, 0, 398, 194);
INSERT INTO public.who_global_data VALUES (94315, 0, 0, 0, 0, 398, 144);
INSERT INTO public.who_global_data VALUES (94316, 0, 0, 0, 0, 398, 19);
INSERT INTO public.who_global_data VALUES (94317, 0, 0, 0, 0, 398, 217);
INSERT INTO public.who_global_data VALUES (94318, 0, 0, 0, 0, 398, 148);
INSERT INTO public.who_global_data VALUES (94319, 0, 0, 0, 0, 398, 86);
INSERT INTO public.who_global_data VALUES (94320, 0, 0, 0, 0, 398, 13);
INSERT INTO public.who_global_data VALUES (94321, 0, 0, 0, 0, 398, 157);
INSERT INTO public.who_global_data VALUES (94322, 0, 0, 0, 0, 398, 8);
INSERT INTO public.who_global_data VALUES (94323, 0, 0, 0, 0, 398, 73);
INSERT INTO public.who_global_data VALUES (94324, 0, 0, 0, 0, 398, 101);
INSERT INTO public.who_global_data VALUES (94325, 0, 0, 0, 0, 398, 165);
INSERT INTO public.who_global_data VALUES (94326, 0, 0, 0, 0, 398, 14);
INSERT INTO public.who_global_data VALUES (94327, 0, 0, 0, 0, 399, 193);
INSERT INTO public.who_global_data VALUES (94328, 0, 0, 0, 0, 399, 113);
INSERT INTO public.who_global_data VALUES (94329, 0, 0, 0, 0, 399, 143);
INSERT INTO public.who_global_data VALUES (94330, 0, 0, 0, 0, 399, 219);
INSERT INTO public.who_global_data VALUES (94331, 0, 0, 0, 0, 399, 186);
INSERT INTO public.who_global_data VALUES (94332, 0, 0, 0, 0, 399, 52);
INSERT INTO public.who_global_data VALUES (94333, 0, 0, 0, 0, 399, 180);
INSERT INTO public.who_global_data VALUES (94334, 0, 0, 0, 0, 399, 167);
INSERT INTO public.who_global_data VALUES (94335, 0, 0, 0, 0, 399, 154);
INSERT INTO public.who_global_data VALUES (94336, 0, 0, 0, 0, 399, 94);
INSERT INTO public.who_global_data VALUES (94337, 0, 0, 0, 0, 399, 66);
INSERT INTO public.who_global_data VALUES (94338, 0, 0, 0, 0, 399, 58);
INSERT INTO public.who_global_data VALUES (94339, 0, 0, 0, 0, 399, 163);
INSERT INTO public.who_global_data VALUES (94340, 0, 0, 0, 0, 399, 37);
INSERT INTO public.who_global_data VALUES (94341, 0, 0, 0, 0, 399, 142);
INSERT INTO public.who_global_data VALUES (94342, 0, 0, 0, 0, 399, 83);
INSERT INTO public.who_global_data VALUES (94343, 0, 0, 0, 0, 399, 228);
INSERT INTO public.who_global_data VALUES (94344, 0, 0, 0, 0, 399, 188);
INSERT INTO public.who_global_data VALUES (94345, 0, 0, 0, 0, 399, 62);
INSERT INTO public.who_global_data VALUES (94346, 0, 0, 0, 0, 399, 160);
INSERT INTO public.who_global_data VALUES (94347, 0, 0, 0, 0, 399, 50);
INSERT INTO public.who_global_data VALUES (94348, 0, 0, 0, 0, 399, 33);
INSERT INTO public.who_global_data VALUES (94349, 0, 0, 0, 0, 399, 183);
INSERT INTO public.who_global_data VALUES (94350, 0, 0, 0, 0, 399, 92);
INSERT INTO public.who_global_data VALUES (94351, 0, 0, 0, 0, 399, 158);
INSERT INTO public.who_global_data VALUES (94352, 0, 0, 0, 0, 399, 67);
INSERT INTO public.who_global_data VALUES (94353, 0, 0, 0, 0, 399, 57);
INSERT INTO public.who_global_data VALUES (94354, 0, 0, 0, 0, 399, 38);
INSERT INTO public.who_global_data VALUES (94355, 0, 0, 0, 0, 399, 141);
INSERT INTO public.who_global_data VALUES (94356, 0, 0, 0, 0, 399, 178);
INSERT INTO public.who_global_data VALUES (94357, 0, 0, 0, 0, 399, 108);
INSERT INTO public.who_global_data VALUES (94358, 0, 0, 0, 0, 399, 39);
INSERT INTO public.who_global_data VALUES (94359, 0, 0, 0, 0, 399, 2);
INSERT INTO public.who_global_data VALUES (94360, 0, 0, 0, 0, 399, 195);
INSERT INTO public.who_global_data VALUES (94361, 0, 0, 0, 0, 399, 107);
INSERT INTO public.who_global_data VALUES (94362, 0, 0, 0, 0, 399, 161);
INSERT INTO public.who_global_data VALUES (94363, 0, 0, 0, 0, 399, 212);
INSERT INTO public.who_global_data VALUES (94364, 0, 0, 0, 0, 399, 181);
INSERT INTO public.who_global_data VALUES (94365, 0, 0, 0, 0, 399, 53);
INSERT INTO public.who_global_data VALUES (94366, 0, 0, 0, 0, 399, 164);
INSERT INTO public.who_global_data VALUES (94367, 0, 0, 0, 0, 399, 140);
INSERT INTO public.who_global_data VALUES (94368, 0, 0, 0, 0, 399, 20);
INSERT INTO public.who_global_data VALUES (94369, 1, 1, 0, 0, 399, 112);
INSERT INTO public.who_global_data VALUES (94370, 0, 0, 0, 0, 399, 111);
INSERT INTO public.who_global_data VALUES (94371, 0, 0, 0, 0, 399, 71);
INSERT INTO public.who_global_data VALUES (94372, 0, 0, 0, 0, 399, 218);
INSERT INTO public.who_global_data VALUES (94373, 0, 0, 0, 0, 399, 43);
INSERT INTO public.who_global_data VALUES (94374, 0, 0, 0, 0, 399, 49);
INSERT INTO public.who_global_data VALUES (94375, 0, 0, 0, 0, 399, 1);
INSERT INTO public.who_global_data VALUES (94376, 0, 0, 0, 0, 399, 48);
INSERT INTO public.who_global_data VALUES (94377, 0, 0, 0, 0, 399, 232);
INSERT INTO public.who_global_data VALUES (94378, 0, 0, 0, 0, 399, 175);
INSERT INTO public.who_global_data VALUES (94379, 0, 0, 0, 0, 399, 21);
INSERT INTO public.who_global_data VALUES (94380, 0, 0, 0, 0, 399, 156);
INSERT INTO public.who_global_data VALUES (94381, 0, 0, 0, 0, 399, 95);
INSERT INTO public.who_global_data VALUES (94382, 0, 0, 0, 0, 399, 177);
INSERT INTO public.who_global_data VALUES (94383, 0, 0, 0, 0, 399, 210);
INSERT INTO public.who_global_data VALUES (94384, 0, 0, 0, 0, 399, 120);
INSERT INTO public.who_global_data VALUES (94385, 0, 0, 0, 0, 399, 135);
INSERT INTO public.who_global_data VALUES (94386, 0, 0, 0, 0, 399, 206);
INSERT INTO public.who_global_data VALUES (94387, 0, 0, 0, 0, 399, 189);
INSERT INTO public.who_global_data VALUES (94388, 0, 0, 0, 0, 399, 129);
INSERT INTO public.who_global_data VALUES (94389, 0, 0, 0, 0, 399, 121);
INSERT INTO public.who_global_data VALUES (94390, 0, 0, 0, 0, 399, 59);
INSERT INTO public.who_global_data VALUES (94391, 0, 0, 0, 0, 399, 96);
INSERT INTO public.who_global_data VALUES (94392, 0, 0, 0, 0, 399, 41);
INSERT INTO public.who_global_data VALUES (94393, 0, 0, 0, 0, 399, 216);
INSERT INTO public.who_global_data VALUES (94394, 0, 0, 0, 0, 399, 236);
INSERT INTO public.who_global_data VALUES (94395, 0, 0, 0, 0, 399, 150);
INSERT INTO public.who_global_data VALUES (94396, 0, 0, 0, 0, 399, 61);
INSERT INTO public.who_global_data VALUES (94397, 0, 0, 0, 0, 399, 7);
INSERT INTO public.who_global_data VALUES (94398, 0, 0, 0, 0, 399, 169);
INSERT INTO public.who_global_data VALUES (94399, 0, 0, 0, 0, 399, 28);
INSERT INTO public.who_global_data VALUES (94400, 0, 0, 0, 0, 399, 85);
INSERT INTO public.who_global_data VALUES (94401, 0, 0, 0, 0, 399, 211);
INSERT INTO public.who_global_data VALUES (94402, 0, 0, 0, 0, 399, 60);
INSERT INTO public.who_global_data VALUES (94403, 0, 0, 0, 0, 399, 3);
INSERT INTO public.who_global_data VALUES (94404, 0, 0, 0, 0, 399, 11);
INSERT INTO public.who_global_data VALUES (94405, 0, 0, 0, 0, 399, 89);
INSERT INTO public.who_global_data VALUES (94406, 0, 0, 0, 0, 399, 24);
INSERT INTO public.who_global_data VALUES (94407, 0, 0, 0, 0, 399, 162);
INSERT INTO public.who_global_data VALUES (94408, 0, 0, 0, 0, 399, 100);
INSERT INTO public.who_global_data VALUES (94409, 0, 0, 0, 0, 399, 47);
INSERT INTO public.who_global_data VALUES (94410, 0, 0, 0, 0, 399, 29);
INSERT INTO public.who_global_data VALUES (94411, 0, 0, 0, 0, 399, 40);
INSERT INTO public.who_global_data VALUES (94412, 0, 0, 0, 0, 399, 222);
INSERT INTO public.who_global_data VALUES (94413, 0, 0, 0, 0, 399, 132);
INSERT INTO public.who_global_data VALUES (94414, 0, 0, 0, 0, 399, 130);
INSERT INTO public.who_global_data VALUES (94415, 0, 0, 0, 0, 399, 234);
INSERT INTO public.who_global_data VALUES (94416, 0, 0, 0, 0, 399, 23);
INSERT INTO public.who_global_data VALUES (94417, 0, 0, 0, 0, 399, 192);
INSERT INTO public.who_global_data VALUES (94418, 0, 0, 0, 0, 399, 69);
INSERT INTO public.who_global_data VALUES (94419, 0, 0, 0, 0, 399, 187);
INSERT INTO public.who_global_data VALUES (94420, 0, 0, 0, 0, 399, 230);
INSERT INTO public.who_global_data VALUES (94421, 0, 0, 0, 0, 399, 77);
INSERT INTO public.who_global_data VALUES (94422, 0, 0, 0, 0, 399, 9);
INSERT INTO public.who_global_data VALUES (94423, 0, 0, 0, 0, 399, 74);
INSERT INTO public.who_global_data VALUES (94424, 0, 0, 0, 0, 399, 224);
INSERT INTO public.who_global_data VALUES (94425, 0, 0, 0, 0, 399, 199);
INSERT INTO public.who_global_data VALUES (94426, 0, 0, 0, 0, 399, 190);
INSERT INTO public.who_global_data VALUES (94427, 0, 0, 0, 0, 399, 12);
INSERT INTO public.who_global_data VALUES (94428, 0, 0, 0, 0, 399, 104);
INSERT INTO public.who_global_data VALUES (94429, 0, 0, 0, 0, 399, 153);
INSERT INTO public.who_global_data VALUES (94430, 0, 0, 0, 0, 399, 91);
INSERT INTO public.who_global_data VALUES (94431, 0, 0, 0, 0, 399, 215);
INSERT INTO public.who_global_data VALUES (94432, 0, 0, 0, 0, 399, 84);
INSERT INTO public.who_global_data VALUES (94433, 0, 0, 0, 0, 399, 231);
INSERT INTO public.who_global_data VALUES (94434, 0, 0, 0, 0, 399, 196);
INSERT INTO public.who_global_data VALUES (94435, 0, 0, 0, 0, 399, 105);
INSERT INTO public.who_global_data VALUES (94436, 0, 0, 0, 0, 399, 122);
INSERT INTO public.who_global_data VALUES (94437, 0, 0, 0, 0, 399, 159);
INSERT INTO public.who_global_data VALUES (94438, 0, 0, 0, 0, 399, 75);
INSERT INTO public.who_global_data VALUES (94439, 0, 0, 0, 0, 399, 27);
INSERT INTO public.who_global_data VALUES (94440, 0, 0, 0, 0, 399, 54);
INSERT INTO public.who_global_data VALUES (94441, 0, 0, 0, 0, 399, 226);
INSERT INTO public.who_global_data VALUES (94442, 0, 0, 0, 0, 399, 79);
INSERT INTO public.who_global_data VALUES (94443, 0, 0, 0, 0, 399, 56);
INSERT INTO public.who_global_data VALUES (94444, 0, 0, 0, 0, 399, 117);
INSERT INTO public.who_global_data VALUES (94445, 0, 0, 0, 0, 399, 152);
INSERT INTO public.who_global_data VALUES (94446, 0, 0, 0, 0, 399, 16);
INSERT INTO public.who_global_data VALUES (94447, 0, 0, 0, 0, 399, 10);
INSERT INTO public.who_global_data VALUES (94448, 0, 0, 0, 0, 399, 201);
INSERT INTO public.who_global_data VALUES (94449, 0, 0, 0, 0, 399, 174);
INSERT INTO public.who_global_data VALUES (94450, 0, 0, 0, 0, 399, 119);
INSERT INTO public.who_global_data VALUES (94451, 0, 0, 0, 0, 399, 168);
INSERT INTO public.who_global_data VALUES (94452, 0, 0, 0, 0, 399, 99);
INSERT INTO public.who_global_data VALUES (94453, 0, 0, 0, 0, 399, 171);
INSERT INTO public.who_global_data VALUES (94454, 0, 0, 0, 0, 399, 87);
INSERT INTO public.who_global_data VALUES (94455, 0, 0, 0, 0, 399, 123);
INSERT INTO public.who_global_data VALUES (94456, 0, 0, 0, 0, 399, 151);
INSERT INTO public.who_global_data VALUES (94457, 0, 0, 0, 0, 399, 213);
INSERT INTO public.who_global_data VALUES (94458, 0, 0, 0, 0, 399, 118);
INSERT INTO public.who_global_data VALUES (94459, 0, 0, 0, 0, 399, 134);
INSERT INTO public.who_global_data VALUES (94460, 0, 0, 0, 0, 399, 65);
INSERT INTO public.who_global_data VALUES (94461, 0, 0, 0, 0, 399, 102);
INSERT INTO public.who_global_data VALUES (94462, 0, 0, 0, 0, 399, 223);
INSERT INTO public.who_global_data VALUES (94463, 0, 0, 0, 0, 399, 4);
INSERT INTO public.who_global_data VALUES (94464, 0, 0, 0, 0, 399, 146);
INSERT INTO public.who_global_data VALUES (94465, 0, 0, 0, 0, 399, 31);
INSERT INTO public.who_global_data VALUES (94466, 0, 0, 0, 0, 399, 127);
INSERT INTO public.who_global_data VALUES (94467, 0, 0, 0, 0, 399, 22);
INSERT INTO public.who_global_data VALUES (94468, 0, 0, 0, 0, 399, 115);
INSERT INTO public.who_global_data VALUES (94469, 0, 0, 0, 0, 399, 106);
INSERT INTO public.who_global_data VALUES (94470, 0, 0, 0, 0, 399, 90);
INSERT INTO public.who_global_data VALUES (94471, 0, 0, 0, 0, 399, 70);
INSERT INTO public.who_global_data VALUES (94472, 0, 0, 0, 0, 399, 46);
INSERT INTO public.who_global_data VALUES (94473, 0, 0, 0, 0, 399, 139);
INSERT INTO public.who_global_data VALUES (94474, 0, 0, 0, 0, 399, 42);
INSERT INTO public.who_global_data VALUES (94475, 0, 0, 0, 0, 399, 80);
INSERT INTO public.who_global_data VALUES (94476, 0, 0, 0, 0, 399, 203);
INSERT INTO public.who_global_data VALUES (94477, 0, 0, 0, 0, 399, 136);
INSERT INTO public.who_global_data VALUES (94478, 0, 0, 0, 0, 399, 63);
INSERT INTO public.who_global_data VALUES (94479, 0, 0, 0, 0, 399, 17);
INSERT INTO public.who_global_data VALUES (94480, 0, 0, 0, 0, 399, 172);
INSERT INTO public.who_global_data VALUES (94481, 0, 0, 0, 0, 399, 109);
INSERT INTO public.who_global_data VALUES (94482, 0, 0, 0, 0, 399, 200);
INSERT INTO public.who_global_data VALUES (94483, 0, 0, 0, 0, 399, 93);
INSERT INTO public.who_global_data VALUES (94484, 0, 0, 0, 0, 399, 5);
INSERT INTO public.who_global_data VALUES (94485, 0, 0, 0, 0, 399, 214);
INSERT INTO public.who_global_data VALUES (94486, 0, 0, 0, 0, 399, 204);
INSERT INTO public.who_global_data VALUES (94487, 0, 0, 0, 0, 399, 198);
INSERT INTO public.who_global_data VALUES (94488, 0, 0, 0, 0, 399, 173);
INSERT INTO public.who_global_data VALUES (94489, 0, 0, 0, 0, 399, 229);
INSERT INTO public.who_global_data VALUES (94490, 0, 0, 0, 0, 399, 76);
INSERT INTO public.who_global_data VALUES (94491, 0, 0, 0, 0, 399, 138);
INSERT INTO public.who_global_data VALUES (94492, 0, 0, 0, 0, 399, 98);
INSERT INTO public.who_global_data VALUES (94493, 0, 0, 0, 0, 399, 103);
INSERT INTO public.who_global_data VALUES (94494, 0, 0, 0, 0, 399, 225);
INSERT INTO public.who_global_data VALUES (94495, 0, 0, 0, 0, 399, 131);
INSERT INTO public.who_global_data VALUES (94496, 0, 0, 0, 0, 399, 235);
INSERT INTO public.who_global_data VALUES (94497, 0, 0, 0, 0, 399, 137);
INSERT INTO public.who_global_data VALUES (94498, 0, 0, 0, 0, 399, 81);
INSERT INTO public.who_global_data VALUES (94499, 0, 0, 0, 0, 399, 182);
INSERT INTO public.who_global_data VALUES (94500, 0, 0, 0, 0, 399, 145);
INSERT INTO public.who_global_data VALUES (94501, 0, 0, 0, 0, 399, 26);
INSERT INTO public.who_global_data VALUES (94502, 0, 0, 0, 0, 399, 170);
INSERT INTO public.who_global_data VALUES (94503, 0, 0, 0, 0, 399, 191);
INSERT INTO public.who_global_data VALUES (94504, 0, 0, 0, 0, 399, 221);
INSERT INTO public.who_global_data VALUES (94505, 0, 0, 0, 0, 399, 64);
INSERT INTO public.who_global_data VALUES (94506, 0, 0, 0, 0, 399, 116);
INSERT INTO public.who_global_data VALUES (94507, 0, 0, 0, 0, 399, 128);
INSERT INTO public.who_global_data VALUES (94508, 0, 0, 0, 0, 399, 6);
INSERT INTO public.who_global_data VALUES (94509, 0, 0, 0, 0, 399, 227);
INSERT INTO public.who_global_data VALUES (94510, 0, 0, 0, 0, 399, 68);
INSERT INTO public.who_global_data VALUES (94511, 0, 0, 0, 0, 399, 184);
INSERT INTO public.who_global_data VALUES (94512, 0, 0, 0, 0, 399, 82);
INSERT INTO public.who_global_data VALUES (94513, 0, 0, 0, 0, 399, 149);
INSERT INTO public.who_global_data VALUES (94514, 0, 0, 0, 0, 399, 197);
INSERT INTO public.who_global_data VALUES (94515, 0, 0, 0, 0, 399, 78);
INSERT INTO public.who_global_data VALUES (94516, 0, 0, 0, 0, 399, 233);
INSERT INTO public.who_global_data VALUES (94517, 0, 0, 0, 0, 399, 133);
INSERT INTO public.who_global_data VALUES (94518, 0, 0, 0, 0, 399, 35);
INSERT INTO public.who_global_data VALUES (94519, 0, 0, 0, 0, 399, 114);
INSERT INTO public.who_global_data VALUES (94520, 0, 0, 0, 0, 399, 237);
INSERT INTO public.who_global_data VALUES (94521, 0, 0, 0, 0, 399, 55);
INSERT INTO public.who_global_data VALUES (94522, 0, 0, 0, 0, 399, 176);
INSERT INTO public.who_global_data VALUES (94523, 0, 0, 0, 0, 399, 202);
INSERT INTO public.who_global_data VALUES (94524, 0, 0, 0, 0, 399, 155);
INSERT INTO public.who_global_data VALUES (94525, 0, 0, 0, 0, 399, 32);
INSERT INTO public.who_global_data VALUES (94526, 0, 0, 0, 0, 399, 220);
INSERT INTO public.who_global_data VALUES (94527, 0, 0, 0, 0, 399, 30);
INSERT INTO public.who_global_data VALUES (94528, 0, 0, 0, 0, 399, 147);
INSERT INTO public.who_global_data VALUES (94529, 0, 0, 0, 0, 399, 208);
INSERT INTO public.who_global_data VALUES (94530, 0, 0, 0, 0, 399, 45);
INSERT INTO public.who_global_data VALUES (94531, 0, 0, 0, 0, 399, 110);
INSERT INTO public.who_global_data VALUES (94532, 0, 0, 0, 0, 399, 88);
INSERT INTO public.who_global_data VALUES (94533, 0, 0, 0, 0, 399, 51);
INSERT INTO public.who_global_data VALUES (94534, 0, 0, 0, 0, 399, 209);
INSERT INTO public.who_global_data VALUES (94535, 0, 0, 0, 0, 399, 205);
INSERT INTO public.who_global_data VALUES (94536, 0, 0, 0, 0, 399, 18);
INSERT INTO public.who_global_data VALUES (94537, 0, 0, 0, 0, 399, 72);
INSERT INTO public.who_global_data VALUES (94538, 0, 0, 0, 0, 399, 44);
INSERT INTO public.who_global_data VALUES (94539, 0, 0, 0, 0, 399, 15);
INSERT INTO public.who_global_data VALUES (94540, 0, 0, 0, 0, 399, 25);
INSERT INTO public.who_global_data VALUES (94541, 0, 0, 0, 0, 399, 179);
INSERT INTO public.who_global_data VALUES (94542, 0, 0, 0, 0, 399, 34);
INSERT INTO public.who_global_data VALUES (94543, 0, 0, 0, 0, 399, 207);
INSERT INTO public.who_global_data VALUES (94544, 0, 0, 0, 0, 399, 166);
INSERT INTO public.who_global_data VALUES (94545, 0, 0, 0, 0, 399, 126);
INSERT INTO public.who_global_data VALUES (94546, 0, 0, 0, 0, 399, 97);
INSERT INTO public.who_global_data VALUES (94547, 0, 0, 0, 0, 399, 36);
INSERT INTO public.who_global_data VALUES (94548, 0, 0, 0, 0, 399, 125);
INSERT INTO public.who_global_data VALUES (94549, 0, 0, 0, 0, 399, 124);
INSERT INTO public.who_global_data VALUES (94550, 0, 0, 0, 0, 399, 185);
INSERT INTO public.who_global_data VALUES (94551, 0, 0, 0, 0, 399, 194);
INSERT INTO public.who_global_data VALUES (94552, 0, 0, 0, 0, 399, 144);
INSERT INTO public.who_global_data VALUES (94553, 0, 0, 0, 0, 399, 19);
INSERT INTO public.who_global_data VALUES (94554, 0, 0, 0, 0, 399, 217);
INSERT INTO public.who_global_data VALUES (94555, 0, 0, 0, 0, 399, 148);
INSERT INTO public.who_global_data VALUES (94556, 0, 0, 0, 0, 399, 86);
INSERT INTO public.who_global_data VALUES (94557, 0, 0, 0, 0, 399, 13);
INSERT INTO public.who_global_data VALUES (94558, 0, 0, 0, 0, 399, 157);
INSERT INTO public.who_global_data VALUES (94559, 0, 0, 0, 0, 399, 8);
INSERT INTO public.who_global_data VALUES (94560, 0, 0, 0, 0, 399, 73);
INSERT INTO public.who_global_data VALUES (94561, 0, 0, 0, 0, 399, 101);
INSERT INTO public.who_global_data VALUES (94562, 0, 0, 0, 0, 399, 165);
INSERT INTO public.who_global_data VALUES (94563, 0, 0, 0, 0, 399, 14);
INSERT INTO public.who_global_data VALUES (94564, 0, 0, 0, 0, 400, 193);
INSERT INTO public.who_global_data VALUES (94565, 0, 0, 0, 0, 400, 113);
INSERT INTO public.who_global_data VALUES (94566, 0, 0, 0, 0, 400, 143);
INSERT INTO public.who_global_data VALUES (94567, 0, 0, 0, 0, 400, 219);
INSERT INTO public.who_global_data VALUES (94568, 0, 0, 0, 0, 400, 186);
INSERT INTO public.who_global_data VALUES (94569, 0, 0, 0, 0, 400, 52);
INSERT INTO public.who_global_data VALUES (94570, 0, 0, 0, 0, 400, 180);
INSERT INTO public.who_global_data VALUES (94571, 0, 0, 0, 0, 400, 167);
INSERT INTO public.who_global_data VALUES (94572, 0, 0, 0, 0, 400, 154);
INSERT INTO public.who_global_data VALUES (94573, 0, 0, 0, 0, 400, 94);
INSERT INTO public.who_global_data VALUES (94574, 0, 0, 0, 0, 400, 66);
INSERT INTO public.who_global_data VALUES (94575, 0, 0, 0, 0, 400, 58);
INSERT INTO public.who_global_data VALUES (94576, 0, 0, 0, 0, 400, 163);
INSERT INTO public.who_global_data VALUES (94577, 0, 0, 0, 0, 400, 37);
INSERT INTO public.who_global_data VALUES (94578, 0, 0, 0, 0, 400, 142);
INSERT INTO public.who_global_data VALUES (94579, 0, 0, 0, 0, 400, 83);
INSERT INTO public.who_global_data VALUES (94580, 0, 0, 0, 0, 400, 228);
INSERT INTO public.who_global_data VALUES (94581, 0, 0, 0, 0, 400, 188);
INSERT INTO public.who_global_data VALUES (94582, 0, 0, 0, 0, 400, 62);
INSERT INTO public.who_global_data VALUES (94583, 0, 0, 0, 0, 400, 160);
INSERT INTO public.who_global_data VALUES (94584, 0, 0, 0, 0, 400, 50);
INSERT INTO public.who_global_data VALUES (94585, 0, 0, 0, 0, 400, 33);
INSERT INTO public.who_global_data VALUES (94586, 0, 0, 0, 0, 400, 183);
INSERT INTO public.who_global_data VALUES (94587, 0, 0, 0, 0, 400, 92);
INSERT INTO public.who_global_data VALUES (94588, 0, 0, 0, 0, 400, 158);
INSERT INTO public.who_global_data VALUES (94589, 0, 0, 0, 0, 400, 67);
INSERT INTO public.who_global_data VALUES (94590, 0, 0, 0, 0, 400, 57);
INSERT INTO public.who_global_data VALUES (94591, 0, 0, 0, 0, 400, 38);
INSERT INTO public.who_global_data VALUES (94592, 0, 0, 0, 0, 400, 141);
INSERT INTO public.who_global_data VALUES (94593, 0, 0, 0, 0, 400, 178);
INSERT INTO public.who_global_data VALUES (94594, 0, 0, 0, 0, 400, 108);
INSERT INTO public.who_global_data VALUES (94595, 0, 0, 0, 0, 400, 39);
INSERT INTO public.who_global_data VALUES (94596, 0, 0, 0, 0, 400, 2);
INSERT INTO public.who_global_data VALUES (94597, 0, 0, 0, 0, 400, 195);
INSERT INTO public.who_global_data VALUES (94598, 0, 0, 0, 0, 400, 107);
INSERT INTO public.who_global_data VALUES (94599, 0, 0, 0, 0, 400, 161);
INSERT INTO public.who_global_data VALUES (94600, 0, 0, 0, 0, 400, 212);
INSERT INTO public.who_global_data VALUES (94601, 0, 0, 0, 0, 400, 181);
INSERT INTO public.who_global_data VALUES (94602, 0, 0, 0, 0, 400, 53);
INSERT INTO public.who_global_data VALUES (94603, 0, 0, 0, 0, 400, 164);
INSERT INTO public.who_global_data VALUES (94604, 0, 0, 0, 0, 400, 140);
INSERT INTO public.who_global_data VALUES (94605, 0, 0, 0, 0, 400, 20);
INSERT INTO public.who_global_data VALUES (94606, 0, 0, 0, 0, 400, 112);
INSERT INTO public.who_global_data VALUES (94607, 0, 0, 0, 0, 400, 111);
INSERT INTO public.who_global_data VALUES (94608, 0, 0, 0, 0, 400, 71);
INSERT INTO public.who_global_data VALUES (94609, 0, 0, 0, 0, 400, 218);
INSERT INTO public.who_global_data VALUES (94610, 0, 0, 0, 0, 400, 43);
INSERT INTO public.who_global_data VALUES (94611, 0, 0, 0, 0, 400, 49);
INSERT INTO public.who_global_data VALUES (94612, 0, 0, 0, 0, 400, 1);
INSERT INTO public.who_global_data VALUES (94613, 0, 0, 0, 0, 400, 48);
INSERT INTO public.who_global_data VALUES (94614, 0, 0, 0, 0, 400, 232);
INSERT INTO public.who_global_data VALUES (94615, 0, 0, 0, 0, 400, 175);
INSERT INTO public.who_global_data VALUES (94616, 0, 0, 0, 0, 400, 21);
INSERT INTO public.who_global_data VALUES (94617, 0, 0, 0, 0, 400, 156);
INSERT INTO public.who_global_data VALUES (94618, 0, 0, 0, 0, 400, 95);
INSERT INTO public.who_global_data VALUES (94619, 0, 0, 0, 0, 400, 177);
INSERT INTO public.who_global_data VALUES (94620, 0, 0, 0, 0, 400, 210);
INSERT INTO public.who_global_data VALUES (94621, 0, 0, 0, 0, 400, 120);
INSERT INTO public.who_global_data VALUES (94622, 0, 0, 0, 0, 400, 135);
INSERT INTO public.who_global_data VALUES (94623, 0, 0, 0, 0, 400, 206);
INSERT INTO public.who_global_data VALUES (94624, 0, 0, 0, 0, 400, 189);
INSERT INTO public.who_global_data VALUES (94625, 0, 0, 0, 0, 400, 129);
INSERT INTO public.who_global_data VALUES (94626, 0, 0, 0, 0, 400, 121);
INSERT INTO public.who_global_data VALUES (94627, 0, 0, 0, 0, 400, 59);
INSERT INTO public.who_global_data VALUES (94628, 0, 0, 0, 0, 400, 96);
INSERT INTO public.who_global_data VALUES (94629, 0, 0, 0, 0, 400, 41);
INSERT INTO public.who_global_data VALUES (94630, 0, 0, 0, 0, 400, 216);
INSERT INTO public.who_global_data VALUES (94631, 0, 0, 0, 0, 400, 236);
INSERT INTO public.who_global_data VALUES (94632, 0, 0, 0, 0, 400, 150);
INSERT INTO public.who_global_data VALUES (94633, 0, 0, 0, 0, 400, 61);
INSERT INTO public.who_global_data VALUES (94634, 0, 0, 0, 0, 400, 7);
INSERT INTO public.who_global_data VALUES (94635, 0, 0, 0, 0, 400, 169);
INSERT INTO public.who_global_data VALUES (94636, 0, 0, 0, 0, 400, 28);
INSERT INTO public.who_global_data VALUES (94637, 0, 0, 0, 0, 400, 85);
INSERT INTO public.who_global_data VALUES (94638, 0, 0, 0, 0, 400, 211);
INSERT INTO public.who_global_data VALUES (94639, 0, 0, 0, 0, 400, 60);
INSERT INTO public.who_global_data VALUES (94640, 0, 0, 0, 0, 400, 3);
INSERT INTO public.who_global_data VALUES (94641, 0, 0, 0, 0, 400, 11);
INSERT INTO public.who_global_data VALUES (94642, 0, 0, 0, 0, 400, 89);
INSERT INTO public.who_global_data VALUES (94643, 0, 0, 0, 0, 400, 24);
INSERT INTO public.who_global_data VALUES (94644, 0, 0, 0, 0, 400, 162);
INSERT INTO public.who_global_data VALUES (94645, 0, 0, 0, 0, 400, 100);
INSERT INTO public.who_global_data VALUES (94646, 0, 0, 0, 0, 400, 47);
INSERT INTO public.who_global_data VALUES (94647, 0, 0, 0, 0, 400, 29);
INSERT INTO public.who_global_data VALUES (94648, 0, 0, 0, 0, 400, 40);
INSERT INTO public.who_global_data VALUES (94649, 0, 0, 0, 0, 400, 222);
INSERT INTO public.who_global_data VALUES (94650, 0, 0, 0, 0, 400, 132);
INSERT INTO public.who_global_data VALUES (94651, 0, 0, 0, 0, 400, 130);
INSERT INTO public.who_global_data VALUES (94652, 0, 0, 0, 0, 400, 234);
INSERT INTO public.who_global_data VALUES (94653, 0, 0, 0, 0, 400, 23);
INSERT INTO public.who_global_data VALUES (94654, 0, 0, 0, 0, 400, 192);
INSERT INTO public.who_global_data VALUES (94655, 0, 0, 0, 0, 400, 69);
INSERT INTO public.who_global_data VALUES (94656, 0, 0, 0, 0, 400, 187);
INSERT INTO public.who_global_data VALUES (94657, 0, 0, 0, 0, 400, 230);
INSERT INTO public.who_global_data VALUES (94658, 0, 0, 0, 0, 400, 77);
INSERT INTO public.who_global_data VALUES (94659, 0, 0, 0, 0, 400, 9);
INSERT INTO public.who_global_data VALUES (94660, 0, 0, 0, 0, 400, 74);
INSERT INTO public.who_global_data VALUES (94661, 0, 0, 0, 0, 400, 224);
INSERT INTO public.who_global_data VALUES (94662, 0, 0, 0, 0, 400, 199);
INSERT INTO public.who_global_data VALUES (94663, 0, 0, 0, 0, 400, 190);
INSERT INTO public.who_global_data VALUES (94664, 0, 0, 0, 0, 400, 12);
INSERT INTO public.who_global_data VALUES (94665, 0, 0, 0, 0, 400, 104);
INSERT INTO public.who_global_data VALUES (94666, 0, 0, 0, 0, 400, 153);
INSERT INTO public.who_global_data VALUES (94667, 0, 0, 0, 0, 400, 91);
INSERT INTO public.who_global_data VALUES (94668, 0, 0, 0, 0, 400, 215);
INSERT INTO public.who_global_data VALUES (94669, 0, 0, 0, 0, 400, 84);
INSERT INTO public.who_global_data VALUES (94670, 0, 0, 0, 0, 400, 231);
INSERT INTO public.who_global_data VALUES (94671, 0, 0, 0, 0, 400, 196);
INSERT INTO public.who_global_data VALUES (94672, 0, 0, 0, 0, 400, 105);
INSERT INTO public.who_global_data VALUES (94673, 0, 0, 0, 0, 400, 122);
INSERT INTO public.who_global_data VALUES (94674, 0, 0, 0, 0, 400, 159);
INSERT INTO public.who_global_data VALUES (94675, 0, 0, 0, 0, 400, 75);
INSERT INTO public.who_global_data VALUES (94676, 0, 0, 0, 0, 400, 27);
INSERT INTO public.who_global_data VALUES (94677, 0, 0, 0, 0, 400, 54);
INSERT INTO public.who_global_data VALUES (94678, 0, 0, 0, 0, 400, 226);
INSERT INTO public.who_global_data VALUES (94679, 0, 0, 0, 0, 400, 79);
INSERT INTO public.who_global_data VALUES (94680, 0, 0, 0, 0, 400, 56);
INSERT INTO public.who_global_data VALUES (94681, 0, 0, 0, 0, 400, 117);
INSERT INTO public.who_global_data VALUES (94682, 0, 0, 0, 0, 400, 152);
INSERT INTO public.who_global_data VALUES (94683, 0, 0, 0, 0, 400, 16);
INSERT INTO public.who_global_data VALUES (94684, 0, 0, 0, 0, 400, 10);
INSERT INTO public.who_global_data VALUES (94685, 0, 0, 0, 0, 400, 201);
INSERT INTO public.who_global_data VALUES (94686, 0, 0, 0, 0, 400, 174);
INSERT INTO public.who_global_data VALUES (94687, 0, 0, 0, 0, 400, 119);
INSERT INTO public.who_global_data VALUES (94688, 0, 0, 0, 0, 400, 168);
INSERT INTO public.who_global_data VALUES (94689, 0, 0, 0, 0, 400, 99);
INSERT INTO public.who_global_data VALUES (94690, 0, 0, 0, 0, 400, 171);
INSERT INTO public.who_global_data VALUES (94691, 0, 0, 0, 0, 400, 87);
INSERT INTO public.who_global_data VALUES (94692, 0, 0, 0, 0, 400, 123);
INSERT INTO public.who_global_data VALUES (94693, 0, 0, 0, 0, 400, 151);
INSERT INTO public.who_global_data VALUES (94694, 0, 0, 0, 0, 400, 213);
INSERT INTO public.who_global_data VALUES (94695, 0, 0, 0, 0, 400, 118);
INSERT INTO public.who_global_data VALUES (94696, 0, 0, 0, 0, 400, 134);
INSERT INTO public.who_global_data VALUES (94697, 0, 0, 0, 0, 400, 65);
INSERT INTO public.who_global_data VALUES (94698, 0, 0, 0, 0, 400, 102);
INSERT INTO public.who_global_data VALUES (94699, 0, 0, 0, 0, 400, 223);
INSERT INTO public.who_global_data VALUES (94700, 0, 0, 0, 0, 400, 4);
INSERT INTO public.who_global_data VALUES (94701, 0, 0, 0, 0, 400, 146);
INSERT INTO public.who_global_data VALUES (94702, 0, 0, 0, 0, 400, 31);
INSERT INTO public.who_global_data VALUES (94703, 0, 0, 0, 0, 400, 127);
INSERT INTO public.who_global_data VALUES (94704, 0, 0, 0, 0, 400, 22);
INSERT INTO public.who_global_data VALUES (94705, 0, 0, 0, 0, 400, 115);
INSERT INTO public.who_global_data VALUES (94706, 0, 0, 0, 0, 400, 106);
INSERT INTO public.who_global_data VALUES (94707, 0, 0, 0, 0, 400, 90);
INSERT INTO public.who_global_data VALUES (94708, 0, 0, 0, 0, 400, 70);
INSERT INTO public.who_global_data VALUES (94709, 0, 0, 0, 0, 400, 46);
INSERT INTO public.who_global_data VALUES (94710, 0, 0, 0, 0, 400, 139);
INSERT INTO public.who_global_data VALUES (94711, 0, 0, 0, 0, 400, 42);
INSERT INTO public.who_global_data VALUES (94712, 0, 0, 0, 0, 400, 80);
INSERT INTO public.who_global_data VALUES (94713, 0, 0, 0, 0, 400, 203);
INSERT INTO public.who_global_data VALUES (94714, 0, 0, 0, 0, 400, 136);
INSERT INTO public.who_global_data VALUES (94715, 0, 0, 0, 0, 400, 63);
INSERT INTO public.who_global_data VALUES (94716, 0, 0, 0, 0, 400, 17);
INSERT INTO public.who_global_data VALUES (94717, 0, 0, 0, 0, 400, 172);
INSERT INTO public.who_global_data VALUES (94718, 0, 0, 0, 0, 400, 109);
INSERT INTO public.who_global_data VALUES (94719, 0, 0, 0, 0, 400, 200);
INSERT INTO public.who_global_data VALUES (94720, 0, 0, 0, 0, 400, 93);
INSERT INTO public.who_global_data VALUES (94721, 0, 0, 0, 0, 400, 5);
INSERT INTO public.who_global_data VALUES (94722, 0, 0, 0, 0, 400, 214);
INSERT INTO public.who_global_data VALUES (94723, 0, 0, 0, 0, 400, 204);
INSERT INTO public.who_global_data VALUES (94724, 0, 0, 0, 0, 400, 198);
INSERT INTO public.who_global_data VALUES (94725, 0, 0, 0, 0, 400, 173);
INSERT INTO public.who_global_data VALUES (94726, 0, 0, 0, 0, 400, 229);
INSERT INTO public.who_global_data VALUES (94727, 0, 0, 0, 0, 400, 76);
INSERT INTO public.who_global_data VALUES (94728, 0, 0, 0, 0, 400, 138);
INSERT INTO public.who_global_data VALUES (94729, 0, 0, 0, 0, 400, 98);
INSERT INTO public.who_global_data VALUES (94730, 0, 0, 0, 0, 400, 103);
INSERT INTO public.who_global_data VALUES (94731, 0, 0, 0, 0, 400, 225);
INSERT INTO public.who_global_data VALUES (94732, 0, 0, 0, 0, 400, 131);
INSERT INTO public.who_global_data VALUES (94733, 0, 0, 0, 0, 400, 235);
INSERT INTO public.who_global_data VALUES (94734, 0, 0, 0, 0, 400, 137);
INSERT INTO public.who_global_data VALUES (94735, 0, 0, 0, 0, 400, 81);
INSERT INTO public.who_global_data VALUES (94736, 0, 0, 0, 0, 400, 182);
INSERT INTO public.who_global_data VALUES (94737, 0, 0, 0, 0, 400, 145);
INSERT INTO public.who_global_data VALUES (94738, 0, 0, 0, 0, 400, 26);
INSERT INTO public.who_global_data VALUES (94739, 0, 0, 0, 0, 400, 170);
INSERT INTO public.who_global_data VALUES (94740, 0, 0, 0, 0, 400, 191);
INSERT INTO public.who_global_data VALUES (94741, 0, 0, 0, 0, 400, 221);
INSERT INTO public.who_global_data VALUES (94742, 0, 0, 0, 0, 400, 64);
INSERT INTO public.who_global_data VALUES (94743, 0, 0, 0, 0, 400, 116);
INSERT INTO public.who_global_data VALUES (94744, 0, 0, 0, 0, 400, 128);
INSERT INTO public.who_global_data VALUES (94745, 0, 0, 0, 0, 400, 6);
INSERT INTO public.who_global_data VALUES (94746, 0, 0, 0, 0, 400, 227);
INSERT INTO public.who_global_data VALUES (94747, 0, 0, 0, 0, 400, 68);
INSERT INTO public.who_global_data VALUES (94748, 0, 0, 0, 0, 400, 184);
INSERT INTO public.who_global_data VALUES (94749, 0, 0, 0, 0, 400, 82);
INSERT INTO public.who_global_data VALUES (94750, 0, 0, 0, 0, 400, 149);
INSERT INTO public.who_global_data VALUES (94751, 0, 0, 0, 0, 400, 197);
INSERT INTO public.who_global_data VALUES (94752, 0, 0, 0, 0, 400, 78);
INSERT INTO public.who_global_data VALUES (94753, 0, 0, 0, 0, 400, 233);
INSERT INTO public.who_global_data VALUES (94754, 0, 0, 0, 0, 400, 133);
INSERT INTO public.who_global_data VALUES (94755, 0, 0, 0, 0, 400, 35);
INSERT INTO public.who_global_data VALUES (94756, 0, 0, 0, 0, 400, 114);
INSERT INTO public.who_global_data VALUES (94757, 0, 0, 0, 0, 400, 237);
INSERT INTO public.who_global_data VALUES (94758, 0, 0, 0, 0, 400, 55);
INSERT INTO public.who_global_data VALUES (94759, 0, 0, 0, 0, 400, 176);
INSERT INTO public.who_global_data VALUES (94760, 0, 0, 0, 0, 400, 202);
INSERT INTO public.who_global_data VALUES (94761, 0, 0, 0, 0, 400, 155);
INSERT INTO public.who_global_data VALUES (94762, 0, 0, 0, 0, 400, 32);
INSERT INTO public.who_global_data VALUES (94763, 0, 0, 0, 0, 400, 220);
INSERT INTO public.who_global_data VALUES (94764, 0, 0, 0, 0, 400, 30);
INSERT INTO public.who_global_data VALUES (94765, 0, 0, 0, 0, 400, 147);
INSERT INTO public.who_global_data VALUES (94766, 0, 0, 0, 0, 400, 208);
INSERT INTO public.who_global_data VALUES (94767, 0, 0, 0, 0, 400, 45);
INSERT INTO public.who_global_data VALUES (94768, 0, 0, 0, 0, 400, 110);
INSERT INTO public.who_global_data VALUES (94769, 0, 0, 0, 0, 400, 88);
INSERT INTO public.who_global_data VALUES (94770, 0, 0, 0, 0, 400, 51);
INSERT INTO public.who_global_data VALUES (94771, 0, 0, 0, 0, 400, 209);
INSERT INTO public.who_global_data VALUES (94772, 0, 0, 0, 0, 400, 205);
INSERT INTO public.who_global_data VALUES (94773, 0, 0, 0, 0, 400, 18);
INSERT INTO public.who_global_data VALUES (94774, 0, 0, 0, 0, 400, 72);
INSERT INTO public.who_global_data VALUES (94775, 0, 0, 0, 0, 400, 44);
INSERT INTO public.who_global_data VALUES (94776, 0, 0, 0, 0, 400, 15);
INSERT INTO public.who_global_data VALUES (94777, 0, 0, 0, 0, 400, 25);
INSERT INTO public.who_global_data VALUES (94778, 0, 0, 0, 0, 400, 179);
INSERT INTO public.who_global_data VALUES (94779, 0, 0, 0, 0, 400, 34);
INSERT INTO public.who_global_data VALUES (94780, 0, 0, 0, 0, 400, 207);
INSERT INTO public.who_global_data VALUES (94781, 0, 0, 0, 0, 400, 166);
INSERT INTO public.who_global_data VALUES (94782, 0, 0, 0, 0, 400, 126);
INSERT INTO public.who_global_data VALUES (94783, 0, 0, 0, 0, 400, 97);
INSERT INTO public.who_global_data VALUES (94784, 0, 0, 0, 0, 400, 36);
INSERT INTO public.who_global_data VALUES (94785, 0, 0, 0, 0, 400, 125);
INSERT INTO public.who_global_data VALUES (94786, 0, 0, 0, 0, 400, 124);
INSERT INTO public.who_global_data VALUES (94787, 0, 0, 0, 0, 400, 185);
INSERT INTO public.who_global_data VALUES (94788, 0, 0, 0, 0, 400, 194);
INSERT INTO public.who_global_data VALUES (94789, 0, 0, 0, 0, 400, 144);
INSERT INTO public.who_global_data VALUES (94790, 0, 0, 0, 0, 400, 19);
INSERT INTO public.who_global_data VALUES (94791, 0, 0, 0, 0, 400, 217);
INSERT INTO public.who_global_data VALUES (94792, 0, 0, 0, 0, 400, 148);
INSERT INTO public.who_global_data VALUES (94793, 0, 0, 0, 0, 400, 86);
INSERT INTO public.who_global_data VALUES (94794, 0, 0, 0, 0, 400, 13);
INSERT INTO public.who_global_data VALUES (94795, 0, 0, 0, 0, 400, 157);
INSERT INTO public.who_global_data VALUES (94796, 0, 0, 0, 0, 400, 8);
INSERT INTO public.who_global_data VALUES (94797, 0, 0, 0, 0, 400, 73);
INSERT INTO public.who_global_data VALUES (94798, 0, 0, 0, 0, 400, 101);
INSERT INTO public.who_global_data VALUES (94799, 0, 0, 0, 0, 400, 165);
INSERT INTO public.who_global_data VALUES (94800, 0, 0, 0, 0, 400, 14);


--
-- Data for Name: who_global_data_import; Type: TABLE DATA; Schema: public; Owner: covid19data
--

INSERT INTO public.who_global_data_import VALUES (1, '2020-01-03', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2, '2020-01-04', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3, '2020-01-05', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4, '2020-01-06', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5, '2020-01-07', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6, '2020-01-08', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7, '2020-01-09', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8, '2020-01-10', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9, '2020-01-11', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10, '2020-01-12', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11, '2020-01-13', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12, '2020-01-14', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13, '2020-01-15', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14, '2020-01-16', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15, '2020-01-17', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16, '2020-01-18', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17, '2020-01-19', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18, '2020-01-20', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19, '2020-01-21', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20, '2020-01-22', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21, '2020-01-23', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22, '2020-01-24', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23, '2020-01-25', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24, '2020-01-26', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25, '2020-01-27', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26, '2020-01-28', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27, '2020-01-29', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28, '2020-01-30', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29, '2020-01-31', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30, '2020-02-01', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31, '2020-02-02', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32, '2020-02-03', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33, '2020-02-04', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34, '2020-02-05', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35, '2020-02-06', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36, '2020-02-07', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37, '2020-02-08', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38, '2020-02-09', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39, '2020-02-10', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40, '2020-02-11', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41, '2020-02-12', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42, '2020-02-13', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43, '2020-02-14', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44, '2020-02-15', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45, '2020-02-16', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46, '2020-02-17', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47, '2020-02-18', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48, '2020-02-19', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49, '2020-02-20', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50, '2020-02-21', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51, '2020-02-22', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52, '2020-02-23', 'AF', 'Afghanistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53, '2020-02-24', 'AF', 'Afghanistan', 'EMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54, '2020-02-25', 'AF', 'Afghanistan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55, '2020-02-26', 'AF', 'Afghanistan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56, '2020-02-27', 'AF', 'Afghanistan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57, '2020-02-28', 'AF', 'Afghanistan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58, '2020-02-29', 'AF', 'Afghanistan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59, '2020-03-01', 'AF', 'Afghanistan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60, '2020-03-02', 'AF', 'Afghanistan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61, '2020-03-03', 'AF', 'Afghanistan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62, '2020-03-04', 'AF', 'Afghanistan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63, '2020-03-05', 'AF', 'Afghanistan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64, '2020-03-06', 'AF', 'Afghanistan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65, '2020-03-07', 'AF', 'Afghanistan', 'EMRO', '3', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66, '2020-03-08', 'AF', 'Afghanistan', 'EMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67, '2020-03-09', 'AF', 'Afghanistan', 'EMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68, '2020-03-10', 'AF', 'Afghanistan', 'EMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69, '2020-03-11', 'AF', 'Afghanistan', 'EMRO', '3', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70, '2020-03-12', 'AF', 'Afghanistan', 'EMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71, '2020-03-13', 'AF', 'Afghanistan', 'EMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72, '2020-03-14', 'AF', 'Afghanistan', 'EMRO', '3', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73, '2020-03-15', 'AF', 'Afghanistan', 'EMRO', '6', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74, '2020-03-16', 'AF', 'Afghanistan', 'EMRO', '5', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75, '2020-03-17', 'AF', 'Afghanistan', 'EMRO', '1', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76, '2020-03-18', 'AF', 'Afghanistan', 'EMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77, '2020-03-19', 'AF', 'Afghanistan', 'EMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78, '2020-03-20', 'AF', 'Afghanistan', 'EMRO', '-2', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79, '2020-03-21', 'AF', 'Afghanistan', 'EMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80, '2020-03-22', 'AF', 'Afghanistan', 'EMRO', '10', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81, '2020-03-23', 'AF', 'Afghanistan', 'EMRO', '6', '40', '1', '1');
INSERT INTO public.who_global_data_import VALUES (82, '2020-03-24', 'AF', 'Afghanistan', 'EMRO', '2', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (83, '2020-03-25', 'AF', 'Afghanistan', 'EMRO', '32', '74', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84, '2020-03-26', 'AF', 'Afghanistan', 'EMRO', '6', '80', '1', '2');
INSERT INTO public.who_global_data_import VALUES (85, '2020-03-27', 'AF', 'Afghanistan', 'EMRO', '11', '91', '0', '2');
INSERT INTO public.who_global_data_import VALUES (86, '2020-03-28', 'AF', 'Afghanistan', 'EMRO', '15', '106', '1', '3');
INSERT INTO public.who_global_data_import VALUES (87, '2020-03-29', 'AF', 'Afghanistan', 'EMRO', '8', '114', '1', '4');
INSERT INTO public.who_global_data_import VALUES (88, '2020-03-30', 'AF', 'Afghanistan', 'EMRO', '0', '114', '0', '4');
INSERT INTO public.who_global_data_import VALUES (89, '2020-03-31', 'AF', 'Afghanistan', 'EMRO', '52', '166', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90, '2020-04-01', 'AF', 'Afghanistan', 'EMRO', '26', '192', '0', '4');
INSERT INTO public.who_global_data_import VALUES (91, '2020-04-02', 'AF', 'Afghanistan', 'EMRO', '43', '235', '0', '4');
INSERT INTO public.who_global_data_import VALUES (92, '2020-04-03', 'AF', 'Afghanistan', 'EMRO', '34', '269', '1', '5');
INSERT INTO public.who_global_data_import VALUES (93, '2020-04-04', 'AF', 'Afghanistan', 'EMRO', '1', '270', '0', '5');
INSERT INTO public.who_global_data_import VALUES (94, '2020-04-05', 'AF', 'Afghanistan', 'EMRO', '29', '299', '2', '7');
INSERT INTO public.who_global_data_import VALUES (95, '2020-04-06', 'AF', 'Afghanistan', 'EMRO', '38', '337', '0', '7');
INSERT INTO public.who_global_data_import VALUES (96, '2020-04-07', 'AF', 'Afghanistan', 'EMRO', '30', '367', '4', '11');
INSERT INTO public.who_global_data_import VALUES (97, '2020-04-08', 'AF', 'Afghanistan', 'EMRO', '56', '423', '3', '14');
INSERT INTO public.who_global_data_import VALUES (98, '2020-04-09', 'AF', 'Afghanistan', 'EMRO', '61', '484', '1', '15');
INSERT INTO public.who_global_data_import VALUES (99, '2020-04-10', 'AF', 'Afghanistan', 'EMRO', '37', '521', '0', '15');
INSERT INTO public.who_global_data_import VALUES (100, '2020-04-11', 'AF', 'Afghanistan', 'EMRO', '0', '521', '0', '15');
INSERT INTO public.who_global_data_import VALUES (101, '2020-04-12', 'AF', 'Afghanistan', 'EMRO', '34', '555', '3', '18');
INSERT INTO public.who_global_data_import VALUES (102, '2020-04-13', 'AF', 'Afghanistan', 'EMRO', '110', '665', '3', '21');
INSERT INTO public.who_global_data_import VALUES (103, '2020-04-14', 'AF', 'Afghanistan', 'EMRO', '49', '714', '2', '23');
INSERT INTO public.who_global_data_import VALUES (104, '2020-04-15', 'AF', 'Afghanistan', 'EMRO', '70', '784', '2', '25');
INSERT INTO public.who_global_data_import VALUES (105, '2020-04-16', 'AF', 'Afghanistan', 'EMRO', '10', '794', '4', '29');
INSERT INTO public.who_global_data_import VALUES (106, '2020-04-17', 'AF', 'Afghanistan', 'EMRO', '51', '845', '1', '30');
INSERT INTO public.who_global_data_import VALUES (107, '2020-04-18', 'AF', 'Afghanistan', 'EMRO', '63', '908', '0', '30');
INSERT INTO public.who_global_data_import VALUES (108, '2020-04-19', 'AF', 'Afghanistan', 'EMRO', '88', '996', '3', '33');
INSERT INTO public.who_global_data_import VALUES (109, '2020-04-20', 'AF', 'Afghanistan', 'EMRO', '0', '996', '0', '33');
INSERT INTO public.who_global_data_import VALUES (110, '2020-04-21', 'AF', 'Afghanistan', 'EMRO', '96', '1092', '3', '36');
INSERT INTO public.who_global_data_import VALUES (111, '2020-04-22', 'AF', 'Afghanistan', 'EMRO', '84', '1176', '4', '40');
INSERT INTO public.who_global_data_import VALUES (112, '2020-04-23', 'AF', 'Afghanistan', 'EMRO', '0', '1176', '0', '40');
INSERT INTO public.who_global_data_import VALUES (113, '2020-04-24', 'AF', 'Afghanistan', 'EMRO', '50', '1226', '0', '40');
INSERT INTO public.who_global_data_import VALUES (114, '2020-04-25', 'AF', 'Afghanistan', 'EMRO', '237', '1463', '7', '47');
INSERT INTO public.who_global_data_import VALUES (115, '2020-04-26', 'AF', 'Afghanistan', 'EMRO', '0', '1463', '2', '49');
INSERT INTO public.who_global_data_import VALUES (116, '2020-04-27', 'AF', 'Afghanistan', 'EMRO', '240', '1703', '8', '57');
INSERT INTO public.who_global_data_import VALUES (117, '2020-04-28', 'AF', 'Afghanistan', 'EMRO', '124', '1827', '3', '60');
INSERT INTO public.who_global_data_import VALUES (118, '2020-04-29', 'AF', 'Afghanistan', 'EMRO', '0', '1827', '0', '60');
INSERT INTO public.who_global_data_import VALUES (119, '2020-04-30', 'AF', 'Afghanistan', 'EMRO', '344', '2171', '4', '64');
INSERT INTO public.who_global_data_import VALUES (120, '2020-05-01', 'AF', 'Afghanistan', 'EMRO', '0', '2171', '0', '64');
INSERT INTO public.who_global_data_import VALUES (121, '2020-05-02', 'AF', 'Afghanistan', 'EMRO', '298', '2469', '8', '72');
INSERT INTO public.who_global_data_import VALUES (122, '2020-05-03', 'AF', 'Afghanistan', 'EMRO', '0', '2469', '0', '72');
INSERT INTO public.who_global_data_import VALUES (123, '2020-05-04', 'AF', 'Afghanistan', 'EMRO', '0', '2469', '0', '72');
INSERT INTO public.who_global_data_import VALUES (124, '2020-05-05', 'AF', 'Afghanistan', 'EMRO', '755', '3224', '23', '95');
INSERT INTO public.who_global_data_import VALUES (125, '2020-05-06', 'AF', 'Afghanistan', 'EMRO', '168', '3392', '9', '104');
INSERT INTO public.who_global_data_import VALUES (126, '2020-05-07', 'AF', 'Afghanistan', 'EMRO', '171', '3563', '1', '105');
INSERT INTO public.who_global_data_import VALUES (127, '2020-05-08', 'AF', 'Afghanistan', 'EMRO', '0', '3563', '0', '105');
INSERT INTO public.who_global_data_import VALUES (128, '2020-05-09', 'AF', 'Afghanistan', 'EMRO', '478', '4041', '10', '115');
INSERT INTO public.who_global_data_import VALUES (129, '2020-05-10', 'AF', 'Afghanistan', 'EMRO', '361', '4402', '4', '119');
INSERT INTO public.who_global_data_import VALUES (130, '2020-05-11', 'AF', 'Afghanistan', 'EMRO', '262', '4664', '2', '121');
INSERT INTO public.who_global_data_import VALUES (131, '2020-05-12', 'AF', 'Afghanistan', 'EMRO', '303', '4967', '6', '127');
INSERT INTO public.who_global_data_import VALUES (132, '2020-05-13', 'AF', 'Afghanistan', 'EMRO', '259', '5226', '3', '130');
INSERT INTO public.who_global_data_import VALUES (133, '2020-05-14', 'AF', 'Afghanistan', 'EMRO', '113', '5339', '6', '136');
INSERT INTO public.who_global_data_import VALUES (134, '2020-05-15', 'AF', 'Afghanistan', 'EMRO', '714', '6053', '17', '153');
INSERT INTO public.who_global_data_import VALUES (135, '2020-05-16', 'AF', 'Afghanistan', 'EMRO', '349', '6402', '15', '168');
INSERT INTO public.who_global_data_import VALUES (136, '2020-05-17', 'AF', 'Afghanistan', 'EMRO', '262', '6664', '1', '169');
INSERT INTO public.who_global_data_import VALUES (137, '2020-05-18', 'AF', 'Afghanistan', 'EMRO', '408', '7072', '4', '173');
INSERT INTO public.who_global_data_import VALUES (138, '2020-05-19', 'AF', 'Afghanistan', 'EMRO', '583', '7655', '4', '177');
INSERT INTO public.who_global_data_import VALUES (139, '2020-05-20', 'AF', 'Afghanistan', 'EMRO', '490', '8145', '10', '187');
INSERT INTO public.who_global_data_import VALUES (140, '2020-05-21', 'AF', 'Afghanistan', 'EMRO', '531', '8676', '6', '193');
INSERT INTO public.who_global_data_import VALUES (141, '2020-05-22', 'AF', 'Afghanistan', 'EMRO', '540', '9216', '12', '205');
INSERT INTO public.who_global_data_import VALUES (142, '2020-05-23', 'AF', 'Afghanistan', 'EMRO', '736', '9952', '10', '215');
INSERT INTO public.who_global_data_import VALUES (143, '2020-05-24', 'AF', 'Afghanistan', 'EMRO', '716', '10668', '7', '222');
INSERT INTO public.who_global_data_import VALUES (144, '2020-05-25', 'AF', 'Afghanistan', 'EMRO', '512', '11180', '1', '223');
INSERT INTO public.who_global_data_import VALUES (145, '2020-05-26', 'AF', 'Afghanistan', 'EMRO', '737', '11917', '1', '224');
INSERT INTO public.who_global_data_import VALUES (146, '2020-05-27', 'AF', 'Afghanistan', 'EMRO', '548', '12465', '6', '230');
INSERT INTO public.who_global_data_import VALUES (147, '2020-05-28', 'AF', 'Afghanistan', 'EMRO', '637', '13102', '9', '239');
INSERT INTO public.who_global_data_import VALUES (148, '2020-05-29', 'AF', 'Afghanistan', 'EMRO', '643', '13745', '11', '250');
INSERT INTO public.who_global_data_import VALUES (149, '2020-05-30', 'AF', 'Afghanistan', 'EMRO', '784', '14529', '2', '252');
INSERT INTO public.who_global_data_import VALUES (150, '2020-05-31', 'AF', 'Afghanistan', 'EMRO', '651', '15180', '2', '254');
INSERT INTO public.who_global_data_import VALUES (151, '2020-06-01', 'AF', 'Afghanistan', 'EMRO', '656', '15836', '15', '269');
INSERT INTO public.who_global_data_import VALUES (152, '2020-06-02', 'AF', 'Afghanistan', 'EMRO', '742', '16578', '5', '274');
INSERT INTO public.who_global_data_import VALUES (153, '2020-06-03', 'AF', 'Afghanistan', 'EMRO', '775', '17353', '24', '298');
INSERT INTO public.who_global_data_import VALUES (154, '2020-06-04', 'AF', 'Afghanistan', 'EMRO', '624', '17977', '5', '303');
INSERT INTO public.who_global_data_import VALUES (155, '2020-06-05', 'AF', 'Afghanistan', 'EMRO', '1078', '19055', '10', '313');
INSERT INTO public.who_global_data_import VALUES (156, '2020-06-06', 'AF', 'Afghanistan', 'EMRO', '582', '19637', '18', '331');
INSERT INTO public.who_global_data_import VALUES (157, '2020-06-07', 'AF', 'Afghanistan', 'EMRO', '791', '20428', '30', '361');
INSERT INTO public.who_global_data_import VALUES (158, '2020-06-08', 'AF', 'Afghanistan', 'EMRO', '575', '21003', '12', '373');
INSERT INTO public.who_global_data_import VALUES (159, '2020-06-09', 'AF', 'Afghanistan', 'EMRO', '305', '21308', '7', '380');
INSERT INTO public.who_global_data_import VALUES (160, '2020-06-10', 'AF', 'Afghanistan', 'EMRO', '920', '22228', '29', '409');
INSERT INTO public.who_global_data_import VALUES (161, '2020-06-11', 'AF', 'Afghanistan', 'EMRO', '748', '22976', '21', '430');
INSERT INTO public.who_global_data_import VALUES (162, '2020-06-12', 'AF', 'Afghanistan', 'EMRO', '656', '23632', '20', '450');
INSERT INTO public.who_global_data_import VALUES (163, '2020-06-13', 'AF', 'Afghanistan', 'EMRO', '556', '24188', '5', '455');
INSERT INTO public.who_global_data_import VALUES (164, '2020-06-14', 'AF', 'Afghanistan', 'EMRO', '664', '24852', '20', '475');
INSERT INTO public.who_global_data_import VALUES (165, '2020-06-15', 'AF', 'Afghanistan', 'EMRO', '761', '25613', '5', '480');
INSERT INTO public.who_global_data_import VALUES (166, '2020-06-16', 'AF', 'Afghanistan', 'EMRO', '106', '25719', '8', '488');
INSERT INTO public.who_global_data_import VALUES (167, '2020-06-17', 'AF', 'Afghanistan', 'EMRO', '1241', '26960', '20', '508');
INSERT INTO public.who_global_data_import VALUES (168, '2020-06-18', 'AF', 'Afghanistan', 'EMRO', '463', '27423', '42', '550');
INSERT INTO public.who_global_data_import VALUES (169, '2020-06-19', 'AF', 'Afghanistan', 'EMRO', '541', '27964', '2', '552');
INSERT INTO public.who_global_data_import VALUES (170, '2020-06-20', 'AF', 'Afghanistan', 'EMRO', '419', '28383', '0', '552');
INSERT INTO public.who_global_data_import VALUES (171, '2020-06-21', 'AF', 'Afghanistan', 'EMRO', '536', '28919', '33', '585');
INSERT INTO public.who_global_data_import VALUES (172, '2020-06-22', 'AF', 'Afghanistan', 'EMRO', '310', '29229', '17', '602');
INSERT INTO public.who_global_data_import VALUES (173, '2020-06-23', 'AF', 'Afghanistan', 'EMRO', '338', '29567', '20', '622');
INSERT INTO public.who_global_data_import VALUES (174, '2020-06-24', 'AF', 'Afghanistan', 'EMRO', '159', '29726', '21', '643');
INSERT INTO public.who_global_data_import VALUES (175, '2020-06-25', 'AF', 'Afghanistan', 'EMRO', '535', '30261', '36', '679');
INSERT INTO public.who_global_data_import VALUES (176, '2020-06-26', 'AF', 'Afghanistan', 'EMRO', '85', '30346', '5', '684');
INSERT INTO public.who_global_data_import VALUES (177, '2020-06-27', 'AF', 'Afghanistan', 'EMRO', '356', '30702', '23', '707');
INSERT INTO public.who_global_data_import VALUES (178, '2020-06-28', 'AF', 'Afghanistan', 'EMRO', '351', '31053', '26', '733');
INSERT INTO public.who_global_data_import VALUES (179, '2020-06-29', 'AF', 'Afghanistan', 'EMRO', '271', '31324', '4', '737');
INSERT INTO public.who_global_data_import VALUES (180, '2020-06-30', 'AF', 'Afghanistan', 'EMRO', '121', '31445', '2', '739');
INSERT INTO public.who_global_data_import VALUES (181, '2020-07-01', 'AF', 'Afghanistan', 'EMRO', '403', '31848', '39', '778');
INSERT INTO public.who_global_data_import VALUES (182, '2020-07-02', 'AF', 'Afghanistan', 'EMRO', '260', '32108', '33', '811');
INSERT INTO public.who_global_data_import VALUES (183, '2020-07-03', 'AF', 'Afghanistan', 'EMRO', '302', '32410', '12', '823');
INSERT INTO public.who_global_data_import VALUES (184, '2020-07-04', 'AF', 'Afghanistan', 'EMRO', '348', '32758', '7', '830');
INSERT INTO public.who_global_data_import VALUES (185, '2020-07-05', 'AF', 'Afghanistan', 'EMRO', '279', '33037', '38', '868');
INSERT INTO public.who_global_data_import VALUES (186, '2020-07-06', 'AF', 'Afghanistan', 'EMRO', '113', '33150', '23', '891');
INSERT INTO public.who_global_data_import VALUES (187, '2020-07-07', 'AF', 'Afghanistan', 'EMRO', '320', '33470', '33', '924');
INSERT INTO public.who_global_data_import VALUES (188, '2020-07-08', 'AF', 'Afghanistan', 'EMRO', '210', '33680', '16', '940');
INSERT INTO public.who_global_data_import VALUES (189, '2020-07-09', 'AF', 'Afghanistan', 'EMRO', '59', '33739', '1', '941');
INSERT INTO public.who_global_data_import VALUES (190, '2020-07-10', 'AF', 'Afghanistan', 'EMRO', '541', '34280', '34', '975');
INSERT INTO public.who_global_data_import VALUES (191, '2020-07-11', 'AF', 'Afghanistan', 'EMRO', '157', '34437', '4', '979');
INSERT INTO public.who_global_data_import VALUES (192, '2020-07-12', 'AF', 'Afghanistan', 'EMRO', '100', '34537', '35', '1014');
INSERT INTO public.who_global_data_import VALUES (193, '2020-07-13', 'AF', 'Afghanistan', 'EMRO', '4', '34541', '2', '1016');
INSERT INTO public.who_global_data_import VALUES (194, '2020-07-14', 'AF', 'Afghanistan', 'EMRO', '285', '34826', '33', '1049');
INSERT INTO public.who_global_data_import VALUES (195, '2020-07-15', 'AF', 'Afghanistan', 'EMRO', '200', '35026', '49', '1098');
INSERT INTO public.who_global_data_import VALUES (196, '2020-07-16', 'AF', 'Afghanistan', 'EMRO', '130', '35156', '19', '1117');
INSERT INTO public.who_global_data_import VALUES (197, '2020-07-17', 'AF', 'Afghanistan', 'EMRO', '159', '35315', '34', '1151');
INSERT INTO public.who_global_data_import VALUES (198, '2020-07-18', 'AF', 'Afghanistan', 'EMRO', '60', '35375', '0', '1151');
INSERT INTO public.who_global_data_import VALUES (199, '2020-07-19', 'AF', 'Afghanistan', 'EMRO', '186', '35561', '34', '1185');
INSERT INTO public.who_global_data_import VALUES (200, '2020-07-20', 'AF', 'Afghanistan', 'EMRO', '34', '35595', '2', '1187');
INSERT INTO public.who_global_data_import VALUES (201, '2020-07-21', 'AF', 'Afghanistan', 'EMRO', '106', '35701', '1', '1188');
INSERT INTO public.who_global_data_import VALUES (202, '2020-07-22', 'AF', 'Afghanistan', 'EMRO', '112', '35813', '6', '1194');
INSERT INTO public.who_global_data_import VALUES (203, '2020-07-23', 'AF', 'Afghanistan', 'EMRO', '188', '36001', '21', '1215');
INSERT INTO public.who_global_data_import VALUES (204, '2020-07-24', 'AF', 'Afghanistan', 'EMRO', '66', '36067', '14', '1229');
INSERT INTO public.who_global_data_import VALUES (205, '2020-07-25', 'AF', 'Afghanistan', 'EMRO', '55', '36122', '21', '1250');
INSERT INTO public.who_global_data_import VALUES (206, '2020-07-26', 'AF', 'Afghanistan', 'EMRO', '121', '36243', '13', '1263');
INSERT INTO public.who_global_data_import VALUES (207, '2020-07-27', 'AF', 'Afghanistan', 'EMRO', '106', '36349', '10', '1273');
INSERT INTO public.who_global_data_import VALUES (208, '2020-07-28', 'AF', 'Afghanistan', 'EMRO', '105', '36454', '1', '1274');
INSERT INTO public.who_global_data_import VALUES (209, '2020-07-29', 'AF', 'Afghanistan', 'EMRO', '103', '36557', '1', '1275');
INSERT INTO public.who_global_data_import VALUES (210, '2020-07-30', 'AF', 'Afghanistan', 'EMRO', '71', '36628', '0', '1275');
INSERT INTO public.who_global_data_import VALUES (211, '2020-07-31', 'AF', 'Afghanistan', 'EMRO', '0', '36628', '0', '1275');
INSERT INTO public.who_global_data_import VALUES (212, '2020-08-01', 'AF', 'Afghanistan', 'EMRO', '168', '36796', '12', '1287');
INSERT INTO public.who_global_data_import VALUES (213, '2020-08-02', 'AF', 'Afghanistan', 'EMRO', '0', '36796', '0', '1287');
INSERT INTO public.who_global_data_import VALUES (214, '2020-08-03', 'AF', 'Afghanistan', 'EMRO', '0', '36796', '0', '1287');
INSERT INTO public.who_global_data_import VALUES (215, '2020-08-04', 'AF', 'Afghanistan', 'EMRO', '37', '36833', '5', '1292');
INSERT INTO public.who_global_data_import VALUES (216, '2020-08-05', 'AF', 'Afghanistan', 'EMRO', '82', '36915', '6', '1298');
INSERT INTO public.who_global_data_import VALUES (217, '2020-08-06', 'AF', 'Afghanistan', 'EMRO', '67', '36982', '4', '1302');
INSERT INTO public.who_global_data_import VALUES (218, '2020-08-07', 'AF', 'Afghanistan', 'EMRO', '41', '37023', '0', '1302');
INSERT INTO public.who_global_data_import VALUES (219, '2020-08-08', 'AF', 'Afghanistan', 'EMRO', '78', '37101', '9', '1311');
INSERT INTO public.who_global_data_import VALUES (220, '2020-08-09', 'AF', 'Afghanistan', 'EMRO', '39', '37140', '5', '1316');
INSERT INTO public.who_global_data_import VALUES (221, '2020-08-10', 'AF', 'Afghanistan', 'EMRO', '0', '37140', '0', '1316');
INSERT INTO public.who_global_data_import VALUES (222, '2020-08-11', 'AF', 'Afghanistan', 'EMRO', '215', '37355', '32', '1348');
INSERT INTO public.who_global_data_import VALUES (223, '2020-08-12', 'AF', 'Afghanistan', 'EMRO', '76', '37431', '10', '1358');
INSERT INTO public.who_global_data_import VALUES (224, '2020-08-13', 'AF', 'Afghanistan', 'EMRO', '79', '37510', '9', '1367');
INSERT INTO public.who_global_data_import VALUES (225, '2020-08-14', 'AF', 'Afghanistan', 'EMRO', '7', '37517', '0', '1367');
INSERT INTO public.who_global_data_import VALUES (226, '2020-08-15', 'AF', 'Afghanistan', 'EMRO', '120', '37637', '7', '1374');
INSERT INTO public.who_global_data_import VALUES (227, '2020-08-16', 'AF', 'Afghanistan', 'EMRO', '45', '37682', '5', '1379');
INSERT INTO public.who_global_data_import VALUES (228, '2020-08-17', 'AF', 'Afghanistan', 'EMRO', '0', '37682', '0', '1379');
INSERT INTO public.who_global_data_import VALUES (229, '2020-08-18', 'AF', 'Afghanistan', 'EMRO', '3', '37685', '0', '1379');
INSERT INTO public.who_global_data_import VALUES (230, '2020-08-19', 'AF', 'Afghanistan', 'EMRO', '0', '37685', '0', '1379');
INSERT INTO public.who_global_data_import VALUES (231, '2020-08-20', 'AF', 'Afghanistan', 'EMRO', '160', '37845', '8', '1387');
INSERT INTO public.who_global_data_import VALUES (232, '2020-08-21', 'AF', 'Afghanistan', 'EMRO', '97', '37942', '2', '1389');
INSERT INTO public.who_global_data_import VALUES (233, '2020-08-22', 'AF', 'Afghanistan', 'EMRO', '38', '37980', '0', '1389');
INSERT INTO public.who_global_data_import VALUES (234, '2020-08-23', 'AF', 'Afghanistan', 'EMRO', '59', '38039', '0', '1389');
INSERT INTO public.who_global_data_import VALUES (235, '2020-08-24', 'AF', 'Afghanistan', 'EMRO', '46', '38085', '2', '1391');
INSERT INTO public.who_global_data_import VALUES (236, '2020-08-25', 'AF', 'Afghanistan', 'EMRO', '71', '38156', '10', '1401');
INSERT INTO public.who_global_data_import VALUES (237, '2020-08-26', 'AF', 'Afghanistan', 'EMRO', '43', '38199', '4', '1405');
INSERT INTO public.who_global_data_import VALUES (238, '2020-08-27', 'AF', 'Afghanistan', 'EMRO', '16', '38215', '0', '1405');
INSERT INTO public.who_global_data_import VALUES (239, '2020-08-28', 'AF', 'Afghanistan', 'EMRO', '11', '38226', '1', '1406');
INSERT INTO public.who_global_data_import VALUES (240, '2020-08-29', 'AF', 'Afghanistan', 'EMRO', '3', '38229', '0', '1406');
INSERT INTO public.who_global_data_import VALUES (241, '2020-08-30', 'AF', 'Afghanistan', 'EMRO', '0', '38229', '0', '1406');
INSERT INTO public.who_global_data_import VALUES (242, '2020-08-31', 'AF', 'Afghanistan', 'EMRO', '19', '38248', '0', '1406');
INSERT INTO public.who_global_data_import VALUES (243, '2020-09-01', 'AF', 'Afghanistan', 'EMRO', '34', '38282', '4', '1410');
INSERT INTO public.who_global_data_import VALUES (244, '2020-09-02', 'AF', 'Afghanistan', 'EMRO', '47', '38329', '3', '1413');
INSERT INTO public.who_global_data_import VALUES (245, '2020-09-03', 'AF', 'Afghanistan', 'EMRO', '45', '38374', '0', '1413');
INSERT INTO public.who_global_data_import VALUES (246, '2020-09-04', 'AF', 'Afghanistan', 'EMRO', '0', '38374', '0', '1413');
INSERT INTO public.who_global_data_import VALUES (247, '2020-09-05', 'AF', 'Afghanistan', 'EMRO', '16', '38390', '0', '1413');
INSERT INTO public.who_global_data_import VALUES (248, '2020-09-06', 'AF', 'Afghanistan', 'EMRO', '94', '38484', '3', '1416');
INSERT INTO public.who_global_data_import VALUES (249, '2020-09-07', 'AF', 'Afghanistan', 'EMRO', '96', '38580', '3', '1419');
INSERT INTO public.who_global_data_import VALUES (250, '2020-09-08', 'AF', 'Afghanistan', 'EMRO', '26', '38606', '3', '1422');
INSERT INTO public.who_global_data_import VALUES (251, '2020-09-09', 'AF', 'Afghanistan', 'EMRO', '24', '38630', '2', '1424');
INSERT INTO public.who_global_data_import VALUES (252, '2020-09-10', 'AF', 'Afghanistan', 'EMRO', '28', '38658', '0', '1424');
INSERT INTO public.who_global_data_import VALUES (253, '2020-09-11', 'AF', 'Afghanistan', 'EMRO', '34', '38692', '0', '1424');
INSERT INTO public.who_global_data_import VALUES (254, '2020-09-12', 'AF', 'Afghanistan', 'EMRO', '35', '38727', '0', '1424');
INSERT INTO public.who_global_data_import VALUES (255, '2020-09-13', 'AF', 'Afghanistan', 'EMRO', '75', '38802', '0', '1424');
INSERT INTO public.who_global_data_import VALUES (256, '2020-09-14', 'AF', 'Afghanistan', 'EMRO', '56', '38858', '5', '1429');
INSERT INTO public.who_global_data_import VALUES (257, '2020-09-15', 'AF', 'Afghanistan', 'EMRO', '43', '38901', '1', '1430');
INSERT INTO public.who_global_data_import VALUES (258, '2020-09-16', 'AF', 'Afghanistan', 'EMRO', '40', '38941', '10', '1440');
INSERT INTO public.who_global_data_import VALUES (259, '2020-09-17', 'AF', 'Afghanistan', 'EMRO', '17', '38958', '0', '1440');
INSERT INTO public.who_global_data_import VALUES (260, '2020-09-18', 'AF', 'Afghanistan', 'EMRO', '11', '38969', '1', '1441');
INSERT INTO public.who_global_data_import VALUES (261, '2020-09-19', 'AF', 'Afghanistan', 'EMRO', '36', '39005', '0', '1441');
INSERT INTO public.who_global_data_import VALUES (262, '2020-09-20', 'AF', 'Afghanistan', 'EMRO', '125', '39130', '4', '1445');
INSERT INTO public.who_global_data_import VALUES (263, '2020-09-21', 'AF', 'Afghanistan', 'EMRO', '30', '39160', '3', '1448');
INSERT INTO public.who_global_data_import VALUES (264, '2020-09-22', 'AF', 'Afghanistan', 'EMRO', '22', '39182', '1', '1449');
INSERT INTO public.who_global_data_import VALUES (265, '2020-09-23', 'AF', 'Afghanistan', 'EMRO', '49', '39231', '1', '1450');
INSERT INTO public.who_global_data_import VALUES (266, '2020-09-24', 'AF', 'Afghanistan', 'EMRO', '25', '39256', '5', '1455');
INSERT INTO public.who_global_data_import VALUES (267, '2020-09-25', 'AF', 'Afghanistan', 'EMRO', '16', '39272', '0', '1455');
INSERT INTO public.who_global_data_import VALUES (268, '2020-09-26', 'AF', 'Afghanistan', 'EMRO', '6', '39278', '2', '1457');
INSERT INTO public.who_global_data_import VALUES (269, '2020-09-27', 'AF', 'Afghanistan', 'EMRO', '35', '39313', '0', '1457');
INSERT INTO public.who_global_data_import VALUES (270, '2020-09-28', 'AF', 'Afghanistan', 'EMRO', '12', '39325', '3', '1460');
INSERT INTO public.who_global_data_import VALUES (271, '2020-09-29', 'AF', 'Afghanistan', 'EMRO', '15', '39340', '2', '1462');
INSERT INTO public.who_global_data_import VALUES (272, '2020-09-30', 'AF', 'Afghanistan', 'EMRO', '14', '39354', '0', '1462');
INSERT INTO public.who_global_data_import VALUES (273, '2020-10-01', 'AF', 'Afghanistan', 'EMRO', '17', '39371', '0', '1462');
INSERT INTO public.who_global_data_import VALUES (274, '2020-10-02', 'AF', 'Afghanistan', 'EMRO', '5', '39376', '0', '1462');
INSERT INTO public.who_global_data_import VALUES (275, '2020-10-03', 'AF', 'Afghanistan', 'EMRO', '7', '39383', '4', '1466');
INSERT INTO public.who_global_data_import VALUES (276, '2020-10-04', 'AF', 'Afghanistan', 'EMRO', '44', '39427', '0', '1466');
INSERT INTO public.who_global_data_import VALUES (277, '2020-10-05', 'AF', 'Afghanistan', 'EMRO', '81', '39508', '4', '1470');
INSERT INTO public.who_global_data_import VALUES (278, '2020-10-06', 'AF', 'Afghanistan', 'EMRO', '64', '39572', '1', '1471');
INSERT INTO public.who_global_data_import VALUES (279, '2020-10-07', 'AF', 'Afghanistan', 'EMRO', '62', '39634', '2', '1473');
INSERT INTO public.who_global_data_import VALUES (280, '2020-10-08', 'AF', 'Afghanistan', 'EMRO', '68', '39702', '1', '1474');
INSERT INTO public.who_global_data_import VALUES (281, '2020-10-09', 'AF', 'Afghanistan', 'EMRO', '77', '39779', '2', '1476');
INSERT INTO public.who_global_data_import VALUES (282, '2020-10-10', 'AF', 'Afghanistan', 'EMRO', '10', '39789', '1', '1477');
INSERT INTO public.who_global_data_import VALUES (283, '2020-10-11', 'AF', 'Afghanistan', 'EMRO', '96', '39885', '4', '1481');
INSERT INTO public.who_global_data_import VALUES (284, '2020-10-12', 'AF', 'Afghanistan', 'EMRO', '71', '39956', '2', '1483');
INSERT INTO public.who_global_data_import VALUES (285, '2020-10-13', 'AF', 'Afghanistan', 'EMRO', '58', '40014', '1', '1484');
INSERT INTO public.who_global_data_import VALUES (286, '2020-10-14', 'AF', 'Afghanistan', 'EMRO', '66', '40080', '1', '1485');
INSERT INTO public.who_global_data_import VALUES (287, '2020-10-15', 'AF', 'Afghanistan', 'EMRO', '32', '40112', '0', '1485');
INSERT INTO public.who_global_data_import VALUES (288, '2020-10-16', 'AF', 'Afghanistan', 'EMRO', '47', '40159', '4', '1489');
INSERT INTO public.who_global_data_import VALUES (289, '2020-10-17', 'AF', 'Afghanistan', 'EMRO', '68', '40227', '3', '1492');
INSERT INTO public.who_global_data_import VALUES (290, '2020-10-18', 'AF', 'Afghanistan', 'EMRO', '59', '40286', '4', '1496');
INSERT INTO public.who_global_data_import VALUES (291, '2020-10-19', 'AF', 'Afghanistan', 'EMRO', '87', '40373', '5', '1501');
INSERT INTO public.who_global_data_import VALUES (292, '2020-10-20', 'AF', 'Afghanistan', 'EMRO', '88', '40461', '2', '1503');
INSERT INTO public.who_global_data_import VALUES (293, '2020-10-21', 'AF', 'Afghanistan', 'EMRO', '0', '40461', '0', '1503');
INSERT INTO public.who_global_data_import VALUES (294, '2020-10-22', 'AF', 'Afghanistan', 'EMRO', '49', '40510', '0', '1503');
INSERT INTO public.who_global_data_import VALUES (295, '2020-10-23', 'AF', 'Afghanistan', 'EMRO', '116', '40626', '2', '1505');
INSERT INTO public.who_global_data_import VALUES (296, '2020-10-24', 'AF', 'Afghanistan', 'EMRO', '61', '40687', '2', '1507');
INSERT INTO public.who_global_data_import VALUES (297, '2020-10-25', 'AF', 'Afghanistan', 'EMRO', '81', '40768', '4', '1511');
INSERT INTO public.who_global_data_import VALUES (298, '2020-10-26', 'AF', 'Afghanistan', 'EMRO', '65', '40833', '3', '1514');
INSERT INTO public.who_global_data_import VALUES (299, '2020-10-27', 'AF', 'Afghanistan', 'EMRO', '104', '40937', '4', '1518');
INSERT INTO public.who_global_data_import VALUES (300, '2020-10-28', 'AF', 'Afghanistan', 'EMRO', '95', '41032', '5', '1523');
INSERT INTO public.who_global_data_import VALUES (301, '2020-10-29', 'AF', 'Afghanistan', 'EMRO', '113', '41145', '6', '1529');
INSERT INTO public.who_global_data_import VALUES (302, '2020-10-30', 'AF', 'Afghanistan', 'EMRO', '123', '41268', '3', '1532');
INSERT INTO public.who_global_data_import VALUES (303, '2020-10-31', 'AF', 'Afghanistan', 'EMRO', '66', '41334', '1', '1533');
INSERT INTO public.who_global_data_import VALUES (304, '2020-11-01', 'AF', 'Afghanistan', 'EMRO', '91', '41425', '3', '1536');
INSERT INTO public.who_global_data_import VALUES (305, '2020-11-02', 'AF', 'Afghanistan', 'EMRO', '76', '41501', '0', '1536');
INSERT INTO public.who_global_data_import VALUES (306, '2020-11-03', 'AF', 'Afghanistan', 'EMRO', '132', '41633', '5', '1541');
INSERT INTO public.who_global_data_import VALUES (307, '2020-11-04', 'AF', 'Afghanistan', 'EMRO', '95', '41728', '3', '1544');
INSERT INTO public.who_global_data_import VALUES (308, '2020-11-05', 'AF', 'Afghanistan', 'EMRO', '86', '41814', '4', '1548');
INSERT INTO public.who_global_data_import VALUES (309, '2020-11-06', 'AF', 'Afghanistan', 'EMRO', '121', '41935', '6', '1554');
INSERT INTO public.who_global_data_import VALUES (310, '2020-11-07', 'AF', 'Afghanistan', 'EMRO', '40', '41975', '0', '1554');
INSERT INTO public.who_global_data_import VALUES (311, '2020-11-08', 'AF', 'Afghanistan', 'EMRO', '58', '42033', '2', '1556');
INSERT INTO public.who_global_data_import VALUES (312, '2020-11-09', 'AF', 'Afghanistan', 'EMRO', '126', '42159', '6', '1562');
INSERT INTO public.who_global_data_import VALUES (313, '2020-11-10', 'AF', 'Afghanistan', 'EMRO', '138', '42297', '12', '1574');
INSERT INTO public.who_global_data_import VALUES (314, '2020-11-11', 'AF', 'Afghanistan', 'EMRO', '166', '42463', '3', '1577');
INSERT INTO public.who_global_data_import VALUES (315, '2020-11-12', 'AF', 'Afghanistan', 'EMRO', '146', '42609', '4', '1581');
INSERT INTO public.who_global_data_import VALUES (316, '2020-11-13', 'AF', 'Afghanistan', 'EMRO', '186', '42795', '10', '1591');
INSERT INTO public.who_global_data_import VALUES (317, '2020-11-14', 'AF', 'Afghanistan', 'EMRO', '174', '42969', '4', '1595');
INSERT INTO public.who_global_data_import VALUES (318, '2020-11-15', 'AF', 'Afghanistan', 'EMRO', '66', '43035', '10', '1605');
INSERT INTO public.who_global_data_import VALUES (319, '2020-11-16', 'AF', 'Afghanistan', 'EMRO', '205', '43240', '12', '1617');
INSERT INTO public.who_global_data_import VALUES (320, '2020-11-17', 'AF', 'Afghanistan', 'EMRO', '163', '43403', '9', '1626');
INSERT INTO public.who_global_data_import VALUES (321, '2020-11-18', 'AF', 'Afghanistan', 'EMRO', '225', '43628', '12', '1638');
INSERT INTO public.who_global_data_import VALUES (322, '2020-11-19', 'AF', 'Afghanistan', 'EMRO', '223', '43851', '7', '1645');
INSERT INTO public.who_global_data_import VALUES (323, '2020-11-20', 'AF', 'Afghanistan', 'EMRO', '377', '44228', '5', '1650');
INSERT INTO public.who_global_data_import VALUES (324, '2020-11-21', 'AF', 'Afghanistan', 'EMRO', '215', '44443', '11', '1661');
INSERT INTO public.who_global_data_import VALUES (325, '2020-11-22', 'AF', 'Afghanistan', 'EMRO', '60', '44503', '14', '1675');
INSERT INTO public.who_global_data_import VALUES (326, '2020-11-23', 'AF', 'Afghanistan', 'EMRO', '203', '44706', '12', '1687');
INSERT INTO public.who_global_data_import VALUES (327, '2020-11-24', 'AF', 'Afghanistan', 'EMRO', '282', '44988', '8', '1695');
INSERT INTO public.who_global_data_import VALUES (328, '2020-11-25', 'AF', 'Afghanistan', 'EMRO', '290', '45278', '17', '1712');
INSERT INTO public.who_global_data_import VALUES (329, '2020-11-26', 'AF', 'Afghanistan', 'EMRO', '212', '45490', '13', '1725');
INSERT INTO public.who_global_data_import VALUES (330, '2020-11-27', 'AF', 'Afghanistan', 'EMRO', '226', '45716', '12', '1737');
INSERT INTO public.who_global_data_import VALUES (331, '2020-11-28', 'AF', 'Afghanistan', 'EMRO', '123', '45839', '3', '1740');
INSERT INTO public.who_global_data_import VALUES (332, '2020-11-29', 'AF', 'Afghanistan', 'EMRO', '127', '45966', '12', '1752');
INSERT INTO public.who_global_data_import VALUES (333, '2020-11-30', 'AF', 'Afghanistan', 'EMRO', '249', '46215', '11', '1763');
INSERT INTO public.who_global_data_import VALUES (334, '2020-12-01', 'AF', 'Afghanistan', 'EMRO', '283', '46498', '11', '1774');
INSERT INTO public.who_global_data_import VALUES (335, '2020-12-02', 'AF', 'Afghanistan', 'EMRO', '219', '46717', '21', '1795');
INSERT INTO public.who_global_data_import VALUES (336, '2020-12-03', 'AF', 'Afghanistan', 'EMRO', '263', '46980', '27', '1822');
INSERT INTO public.who_global_data_import VALUES (337, '2020-12-04', 'AF', 'Afghanistan', 'EMRO', '278', '47258', '19', '1841');
INSERT INTO public.who_global_data_import VALUES (338, '2020-12-05', 'AF', 'Afghanistan', 'EMRO', '130', '47388', '6', '1847');
INSERT INTO public.who_global_data_import VALUES (339, '2020-12-06', 'AF', 'Afghanistan', 'EMRO', '253', '47641', '18', '1865');
INSERT INTO public.who_global_data_import VALUES (340, '2020-12-07', 'AF', 'Afghanistan', 'EMRO', '260', '47901', '10', '1875');
INSERT INTO public.who_global_data_import VALUES (341, '2020-12-08', 'AF', 'Afghanistan', 'EMRO', '235', '48136', '27', '1902');
INSERT INTO public.who_global_data_import VALUES (342, '2020-12-09', 'AF', 'Afghanistan', 'EMRO', '230', '48366', '6', '1908');
INSERT INTO public.who_global_data_import VALUES (343, '2020-12-10', 'AF', 'Afghanistan', 'EMRO', '174', '48540', '13', '1921');
INSERT INTO public.who_global_data_import VALUES (344, '2020-12-11', 'AF', 'Afghanistan', 'EMRO', '213', '48753', '18', '1939');
INSERT INTO public.who_global_data_import VALUES (345, '2020-12-12', 'AF', 'Afghanistan', 'EMRO', '73', '48826', '10', '1949');
INSERT INTO public.who_global_data_import VALUES (346, '2020-12-13', 'AF', 'Afghanistan', 'EMRO', '126', '48952', '11', '1960');
INSERT INTO public.who_global_data_import VALUES (347, '2020-12-14', 'AF', 'Afghanistan', 'EMRO', '321', '49273', '11', '1971');
INSERT INTO public.who_global_data_import VALUES (348, '2020-12-15', 'AF', 'Afghanistan', 'EMRO', '211', '49484', '4', '1975');
INSERT INTO public.who_global_data_import VALUES (349, '2020-12-16', 'AF', 'Afghanistan', 'EMRO', '219', '49703', '26', '2001');
INSERT INTO public.who_global_data_import VALUES (350, '2020-12-17', 'AF', 'Afghanistan', 'EMRO', '224', '49927', '16', '2017');
INSERT INTO public.who_global_data_import VALUES (351, '2020-12-18', 'AF', 'Afghanistan', 'EMRO', '275', '50202', '15', '2032');
INSERT INTO public.who_global_data_import VALUES (352, '2020-12-19', 'AF', 'Afghanistan', 'EMRO', '254', '50456', '5', '2037');
INSERT INTO public.who_global_data_import VALUES (353, '2020-12-20', 'AF', 'Afghanistan', 'EMRO', '80', '50536', '17', '2054');
INSERT INTO public.who_global_data_import VALUES (354, '2020-12-21', 'AF', 'Afghanistan', 'EMRO', '142', '50678', '20', '2074');
INSERT INTO public.who_global_data_import VALUES (355, '2020-12-22', 'AF', 'Afghanistan', 'EMRO', '210', '50888', '15', '2089');
INSERT INTO public.who_global_data_import VALUES (356, '2020-12-23', 'AF', 'Afghanistan', 'EMRO', '182', '51070', '16', '2105');
INSERT INTO public.who_global_data_import VALUES (357, '2020-12-24', 'AF', 'Afghanistan', 'EMRO', '287', '51357', '21', '2126');
INSERT INTO public.who_global_data_import VALUES (358, '2020-12-25', 'AF', 'Afghanistan', 'EMRO', '238', '51595', '9', '2135');
INSERT INTO public.who_global_data_import VALUES (359, '2020-12-26', 'AF', 'Afghanistan', 'EMRO', '169', '51764', '13', '2148');
INSERT INTO public.who_global_data_import VALUES (360, '2020-12-27', 'AF', 'Afghanistan', 'EMRO', '84', '51848', '10', '2158');
INSERT INTO public.who_global_data_import VALUES (361, '2020-12-28', 'AF', 'Afghanistan', 'EMRO', '159', '52007', '12', '2170');
INSERT INTO public.who_global_data_import VALUES (362, '2020-12-29', 'AF', 'Afghanistan', 'EMRO', '140', '52147', '12', '2182');
INSERT INTO public.who_global_data_import VALUES (363, '2020-12-30', 'AF', 'Afghanistan', 'EMRO', '183', '52330', '7', '2189');
INSERT INTO public.who_global_data_import VALUES (364, '2020-12-31', 'AF', 'Afghanistan', 'EMRO', '0', '52330', '0', '2189');
INSERT INTO public.who_global_data_import VALUES (365, '2021-01-01', 'AF', 'Afghanistan', 'EMRO', '183', '52513', '12', '2201');
INSERT INTO public.who_global_data_import VALUES (366, '2021-01-02', 'AF', 'Afghanistan', 'EMRO', '73', '52586', '10', '2211');
INSERT INTO public.who_global_data_import VALUES (367, '2021-01-03', 'AF', 'Afghanistan', 'EMRO', '123', '52709', '10', '2221');
INSERT INTO public.who_global_data_import VALUES (368, '2021-01-04', 'AF', 'Afghanistan', 'EMRO', '200', '52909', '9', '2230');
INSERT INTO public.who_global_data_import VALUES (369, '2021-01-05', 'AF', 'Afghanistan', 'EMRO', '102', '53011', '7', '2237');
INSERT INTO public.who_global_data_import VALUES (370, '2021-01-06', 'AF', 'Afghanistan', 'EMRO', '94', '53105', '7', '2244');
INSERT INTO public.who_global_data_import VALUES (371, '2021-01-07', 'AF', 'Afghanistan', 'EMRO', '102', '53207', '9', '2253');
INSERT INTO public.who_global_data_import VALUES (372, '2021-01-08', 'AF', 'Afghanistan', 'EMRO', '125', '53332', '4', '2257');
INSERT INTO public.who_global_data_import VALUES (373, '2021-01-09', 'AF', 'Afghanistan', 'EMRO', '68', '53400', '7', '2264');
INSERT INTO public.who_global_data_import VALUES (374, '2021-01-10', 'AF', 'Afghanistan', 'EMRO', '89', '53489', '13', '2277');
INSERT INTO public.who_global_data_import VALUES (375, '2021-01-11', 'AF', 'Afghanistan', 'EMRO', '49', '53538', '11', '2288');
INSERT INTO public.who_global_data_import VALUES (376, '2021-01-12', 'AF', 'Afghanistan', 'EMRO', '46', '53584', '13', '2301');
INSERT INTO public.who_global_data_import VALUES (377, '2021-01-13', 'AF', 'Afghanistan', 'EMRO', '106', '53690', '7', '2308');
INSERT INTO public.who_global_data_import VALUES (378, '2021-01-14', 'AF', 'Afghanistan', 'EMRO', '85', '53775', '6', '2314');
INSERT INTO public.who_global_data_import VALUES (379, '2021-01-15', 'AF', 'Afghanistan', 'EMRO', '56', '53831', '10', '2324');
INSERT INTO public.who_global_data_import VALUES (380, '2021-01-16', 'AF', 'Afghanistan', 'EMRO', '107', '53938', '12', '2336');
INSERT INTO public.who_global_data_import VALUES (381, '2021-01-17', 'AF', 'Afghanistan', 'EMRO', '46', '53984', '3', '2339');
INSERT INTO public.who_global_data_import VALUES (382, '2021-01-18', 'AF', 'Afghanistan', 'EMRO', '78', '54062', '4', '2343');
INSERT INTO public.who_global_data_import VALUES (383, '2021-01-19', 'AF', 'Afghanistan', 'EMRO', '79', '54141', '3', '2346');
INSERT INTO public.who_global_data_import VALUES (384, '2021-01-20', 'AF', 'Afghanistan', 'EMRO', '137', '54278', '8', '2354');
INSERT INTO public.who_global_data_import VALUES (385, '2021-01-21', 'AF', 'Afghanistan', 'EMRO', '125', '54403', '9', '2363');
INSERT INTO public.who_global_data_import VALUES (386, '2021-01-22', 'AF', 'Afghanistan', 'EMRO', '80', '54483', '7', '2370');
INSERT INTO public.who_global_data_import VALUES (387, '2021-01-23', 'AF', 'Afghanistan', 'EMRO', '76', '54559', '3', '2373');
INSERT INTO public.who_global_data_import VALUES (388, '2021-01-24', 'AF', 'Afghanistan', 'EMRO', '36', '54595', '5', '2378');
INSERT INTO public.who_global_data_import VALUES (389, '2021-01-25', 'AF', 'Afghanistan', 'EMRO', '77', '54672', '7', '2385');
INSERT INTO public.who_global_data_import VALUES (390, '2021-01-26', 'AF', 'Afghanistan', 'EMRO', '78', '54750', '4', '2389');
INSERT INTO public.who_global_data_import VALUES (391, '2021-01-27', 'AF', 'Afghanistan', 'EMRO', '104', '54854', '0', '2389');
INSERT INTO public.who_global_data_import VALUES (392, '2021-01-28', 'AF', 'Afghanistan', 'EMRO', '37', '54891', '8', '2397');
INSERT INTO public.who_global_data_import VALUES (393, '2021-01-29', 'AF', 'Afghanistan', 'EMRO', '48', '54939', '2', '2399');
INSERT INTO public.who_global_data_import VALUES (394, '2021-01-30', 'AF', 'Afghanistan', 'EMRO', '69', '55008', '1', '2400');
INSERT INTO public.who_global_data_import VALUES (395, '2021-01-31', 'AF', 'Afghanistan', 'EMRO', '15', '55023', '0', '2400');
INSERT INTO public.who_global_data_import VALUES (396, '2021-02-01', 'AF', 'Afghanistan', 'EMRO', '36', '55059', '4', '2404');
INSERT INTO public.who_global_data_import VALUES (397, '2021-02-02', 'AF', 'Afghanistan', 'EMRO', '62', '55121', '1', '2405');
INSERT INTO public.who_global_data_import VALUES (398, '2021-02-03', 'AF', 'Afghanistan', 'EMRO', '53', '55174', '1', '2406');
INSERT INTO public.who_global_data_import VALUES (399, '2021-02-04', 'AF', 'Afghanistan', 'EMRO', '57', '55231', '1', '2407');
INSERT INTO public.who_global_data_import VALUES (400, '2021-02-05', 'AF', 'Afghanistan', 'EMRO', '34', '55265', '0', '2407');
INSERT INTO public.who_global_data_import VALUES (401, '2020-01-03', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (402, '2020-01-04', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (403, '2020-01-05', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (404, '2020-01-06', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (405, '2020-01-07', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (406, '2020-01-08', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (407, '2020-01-09', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (408, '2020-01-10', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (409, '2020-01-11', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (410, '2020-01-12', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (411, '2020-01-13', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (412, '2020-01-14', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (413, '2020-01-15', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (414, '2020-01-16', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (415, '2020-01-17', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (416, '2020-01-18', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (417, '2020-01-19', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (418, '2020-01-20', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (419, '2020-01-21', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (420, '2020-01-22', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (421, '2020-01-23', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (422, '2020-01-24', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (423, '2020-01-25', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (424, '2020-01-26', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (425, '2020-01-27', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (426, '2020-01-28', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (427, '2020-01-29', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (428, '2020-01-30', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (429, '2020-01-31', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (430, '2020-02-01', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (431, '2020-02-02', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (432, '2020-02-03', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (433, '2020-02-04', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (434, '2020-02-05', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (435, '2020-02-06', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (436, '2020-02-07', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (437, '2020-02-08', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (438, '2020-02-09', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (439, '2020-02-10', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (440, '2020-02-11', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (441, '2020-02-12', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (442, '2020-02-13', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (443, '2020-02-14', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (444, '2020-02-15', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (445, '2020-02-16', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (446, '2020-02-17', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (447, '2020-02-18', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (448, '2020-02-19', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (449, '2020-02-20', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (450, '2020-02-21', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (451, '2020-02-22', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (452, '2020-02-23', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (453, '2020-02-24', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (454, '2020-02-25', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (455, '2020-02-26', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (456, '2020-02-27', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (457, '2020-02-28', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (458, '2020-02-29', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (459, '2020-03-01', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (460, '2020-03-02', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (461, '2020-03-03', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (462, '2020-03-04', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (463, '2020-03-05', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (464, '2020-03-06', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (465, '2020-03-07', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (466, '2020-03-08', 'AL', 'Albania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (467, '2020-03-09', 'AL', 'Albania', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (468, '2020-03-10', 'AL', 'Albania', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (469, '2020-03-11', 'AL', 'Albania', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (470, '2020-03-12', 'AL', 'Albania', 'EURO', '1', '3', '1', '1');
INSERT INTO public.who_global_data_import VALUES (471, '2020-03-13', 'AL', 'Albania', 'EURO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (472, '2020-03-14', 'AL', 'Albania', 'EURO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (473, '2020-03-15', 'AL', 'Albania', 'EURO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (474, '2020-03-16', 'AL', 'Albania', 'EURO', '2', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (475, '2020-03-17', 'AL', 'Albania', 'EURO', '9', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (476, '2020-03-18', 'AL', 'Albania', 'EURO', '4', '18', '0', '1');
INSERT INTO public.who_global_data_import VALUES (477, '2020-03-19', 'AL', 'Albania', 'EURO', '3', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (478, '2020-03-20', 'AL', 'Albania', 'EURO', '11', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (479, '2020-03-21', 'AL', 'Albania', 'EURO', '19', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (480, '2020-03-22', 'AL', 'Albania', 'EURO', '0', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (481, '2020-03-23', 'AL', 'Albania', 'EURO', '15', '66', '2', '3');
INSERT INTO public.who_global_data_import VALUES (482, '2020-03-24', 'AL', 'Albania', 'EURO', '19', '85', '1', '4');
INSERT INTO public.who_global_data_import VALUES (483, '2020-03-25', 'AL', 'Albania', 'EURO', '23', '108', '0', '4');
INSERT INTO public.who_global_data_import VALUES (484, '2020-03-26', 'AL', 'Albania', 'EURO', '28', '136', '1', '5');
INSERT INTO public.who_global_data_import VALUES (485, '2020-03-27', 'AL', 'Albania', 'EURO', '12', '148', '2', '7');
INSERT INTO public.who_global_data_import VALUES (486, '2020-03-28', 'AL', 'Albania', 'EURO', '11', '159', '1', '8');
INSERT INTO public.who_global_data_import VALUES (487, '2020-03-29', 'AL', 'Albania', 'EURO', '15', '174', '1', '9');
INSERT INTO public.who_global_data_import VALUES (488, '2020-03-30', 'AL', 'Albania', 'EURO', '11', '185', '1', '10');
INSERT INTO public.who_global_data_import VALUES (489, '2020-03-31', 'AL', 'Albania', 'EURO', '20', '205', '2', '12');
INSERT INTO public.who_global_data_import VALUES (490, '2020-04-01', 'AL', 'Albania', 'EURO', '34', '239', '2', '14');
INSERT INTO public.who_global_data_import VALUES (491, '2020-04-02', 'AL', 'Albania', 'EURO', '0', '239', '0', '14');
INSERT INTO public.who_global_data_import VALUES (492, '2020-04-03', 'AL', 'Albania', 'EURO', '0', '239', '1', '15');
INSERT INTO public.who_global_data_import VALUES (493, '2020-04-04', 'AL', 'Albania', 'EURO', '56', '295', '1', '16');
INSERT INTO public.who_global_data_import VALUES (494, '2020-04-05', 'AL', 'Albania', 'EURO', '0', '295', '1', '17');
INSERT INTO public.who_global_data_import VALUES (495, '2020-04-06', 'AL', 'Albania', 'EURO', '44', '339', '3', '20');
INSERT INTO public.who_global_data_import VALUES (496, '2020-04-07', 'AL', 'Albania', 'EURO', '0', '339', '1', '21');
INSERT INTO public.who_global_data_import VALUES (497, '2020-04-08', 'AL', 'Albania', 'EURO', '23', '362', '0', '21');
INSERT INTO public.who_global_data_import VALUES (498, '2020-04-09', 'AL', 'Albania', 'EURO', '9', '371', '0', '21');
INSERT INTO public.who_global_data_import VALUES (499, '2020-04-10', 'AL', 'Albania', 'EURO', '7', '378', '1', '22');
INSERT INTO public.who_global_data_import VALUES (500, '2020-04-11', 'AL', 'Albania', 'EURO', '0', '378', '0', '22');
INSERT INTO public.who_global_data_import VALUES (501, '2020-04-12', 'AL', 'Albania', 'EURO', '30', '408', '0', '22');
INSERT INTO public.who_global_data_import VALUES (502, '2020-04-13', 'AL', 'Albania', 'EURO', '0', '408', '0', '22');
INSERT INTO public.who_global_data_import VALUES (503, '2020-04-14', 'AL', 'Albania', 'EURO', '29', '437', '0', '22');
INSERT INTO public.who_global_data_import VALUES (504, '2020-04-15', 'AL', 'Albania', 'EURO', '0', '437', '1', '23');
INSERT INTO public.who_global_data_import VALUES (505, '2020-04-16', 'AL', 'Albania', 'EURO', '19', '456', '1', '24');
INSERT INTO public.who_global_data_import VALUES (506, '2020-04-17', 'AL', 'Albania', 'EURO', '24', '480', '1', '25');
INSERT INTO public.who_global_data_import VALUES (507, '2020-04-18', 'AL', 'Albania', 'EURO', '30', '510', '0', '25');
INSERT INTO public.who_global_data_import VALUES (508, '2020-04-19', 'AL', 'Albania', 'EURO', '0', '510', '0', '25');
INSERT INTO public.who_global_data_import VALUES (509, '2020-04-20', 'AL', 'Albania', 'EURO', '14', '524', '0', '25');
INSERT INTO public.who_global_data_import VALUES (510, '2020-04-21', 'AL', 'Albania', 'EURO', '47', '571', '0', '25');
INSERT INTO public.who_global_data_import VALUES (511, '2020-04-22', 'AL', 'Albania', 'EURO', '25', '596', '0', '25');
INSERT INTO public.who_global_data_import VALUES (512, '2020-04-23', 'AL', 'Albania', 'EURO', '0', '596', '1', '26');
INSERT INTO public.who_global_data_import VALUES (513, '2020-04-24', 'AL', 'Albania', 'EURO', '44', '640', '0', '26');
INSERT INTO public.who_global_data_import VALUES (514, '2020-04-25', 'AL', 'Albania', 'EURO', '0', '640', '0', '26');
INSERT INTO public.who_global_data_import VALUES (515, '2020-04-26', 'AL', 'Albania', 'EURO', '34', '674', '0', '26');
INSERT INTO public.who_global_data_import VALUES (516, '2020-04-27', 'AL', 'Albania', 'EURO', '14', '688', '1', '27');
INSERT INTO public.who_global_data_import VALUES (517, '2020-04-28', 'AL', 'Albania', 'EURO', '10', '698', '0', '27');
INSERT INTO public.who_global_data_import VALUES (518, '2020-04-29', 'AL', 'Albania', 'EURO', '30', '728', '2', '29');
INSERT INTO public.who_global_data_import VALUES (519, '2020-04-30', 'AL', 'Albania', 'EURO', '7', '735', '1', '30');
INSERT INTO public.who_global_data_import VALUES (520, '2020-05-01', 'AL', 'Albania', 'EURO', '0', '735', '0', '30');
INSERT INTO public.who_global_data_import VALUES (521, '2020-05-02', 'AL', 'Albania', 'EURO', '16', '751', '0', '30');
INSERT INTO public.who_global_data_import VALUES (522, '2020-05-03', 'AL', 'Albania', 'EURO', '6', '757', '0', '30');
INSERT INTO public.who_global_data_import VALUES (523, '2020-05-04', 'AL', 'Albania', 'EURO', '8', '765', '0', '30');
INSERT INTO public.who_global_data_import VALUES (524, '2020-05-05', 'AL', 'Albania', 'EURO', '17', '782', '0', '30');
INSERT INTO public.who_global_data_import VALUES (525, '2020-05-06', 'AL', 'Albania', 'EURO', '12', '794', '0', '30');
INSERT INTO public.who_global_data_import VALUES (526, '2020-05-07', 'AL', 'Albania', 'EURO', '0', '794', '0', '30');
INSERT INTO public.who_global_data_import VALUES (527, '2020-05-08', 'AL', 'Albania', 'EURO', '18', '812', '0', '30');
INSERT INTO public.who_global_data_import VALUES (528, '2020-05-09', 'AL', 'Albania', 'EURO', '6', '818', '0', '30');
INSERT INTO public.who_global_data_import VALUES (529, '2020-05-10', 'AL', 'Albania', 'EURO', '12', '830', '0', '30');
INSERT INTO public.who_global_data_import VALUES (530, '2020-05-11', 'AL', 'Albania', 'EURO', '0', '830', '0', '30');
INSERT INTO public.who_global_data_import VALUES (531, '2020-05-12', 'AL', 'Albania', 'EURO', '4', '834', '0', '30');
INSERT INTO public.who_global_data_import VALUES (532, '2020-05-13', 'AL', 'Albania', 'EURO', '4', '838', '0', '30');
INSERT INTO public.who_global_data_import VALUES (533, '2020-05-14', 'AL', 'Albania', 'EURO', '4', '842', '0', '30');
INSERT INTO public.who_global_data_import VALUES (534, '2020-05-15', 'AL', 'Albania', 'EURO', '18', '860', '0', '30');
INSERT INTO public.who_global_data_import VALUES (535, '2020-05-16', 'AL', 'Albania', 'EURO', '35', '895', '0', '30');
INSERT INTO public.who_global_data_import VALUES (536, '2020-05-17', 'AL', 'Albania', 'EURO', '13', '908', '0', '30');
INSERT INTO public.who_global_data_import VALUES (537, '2020-05-18', 'AL', 'Albania', 'EURO', '2', '910', '0', '30');
INSERT INTO public.who_global_data_import VALUES (538, '2020-05-19', 'AL', 'Albania', 'EURO', '0', '910', '0', '30');
INSERT INTO public.who_global_data_import VALUES (539, '2020-05-20', 'AL', 'Albania', 'EURO', '16', '926', '0', '30');
INSERT INTO public.who_global_data_import VALUES (540, '2020-05-21', 'AL', 'Albania', 'EURO', '5', '931', '0', '30');
INSERT INTO public.who_global_data_import VALUES (541, '2020-05-22', 'AL', 'Albania', 'EURO', '0', '931', '0', '30');
INSERT INTO public.who_global_data_import VALUES (542, '2020-05-23', 'AL', 'Albania', 'EURO', '12', '943', '0', '30');
INSERT INTO public.who_global_data_import VALUES (543, '2020-05-24', 'AL', 'Albania', 'EURO', '8', '951', '1', '31');
INSERT INTO public.who_global_data_import VALUES (544, '2020-05-25', 'AL', 'Albania', 'EURO', '15', '966', '0', '31');
INSERT INTO public.who_global_data_import VALUES (545, '2020-05-26', 'AL', 'Albania', 'EURO', '25', '991', '1', '32');
INSERT INTO public.who_global_data_import VALUES (546, '2020-05-27', 'AL', 'Albania', 'EURO', '21', '1012', '0', '32');
INSERT INTO public.who_global_data_import VALUES (547, '2020-05-28', 'AL', 'Albania', 'EURO', '26', '1038', '0', '32');
INSERT INTO public.who_global_data_import VALUES (548, '2020-05-29', 'AL', 'Albania', 'EURO', '23', '1061', '0', '32');
INSERT INTO public.who_global_data_import VALUES (549, '2020-05-30', 'AL', 'Albania', 'EURO', '23', '1084', '0', '32');
INSERT INTO public.who_global_data_import VALUES (550, '2020-05-31', 'AL', 'Albania', 'EURO', '14', '1098', '0', '32');
INSERT INTO public.who_global_data_import VALUES (551, '2020-06-01', 'AL', 'Albania', 'EURO', '7', '1105', '0', '32');
INSERT INTO public.who_global_data_import VALUES (552, '2020-06-02', 'AL', 'Albania', 'EURO', '36', '1141', '0', '32');
INSERT INTO public.who_global_data_import VALUES (553, '2020-06-03', 'AL', 'Albania', 'EURO', '20', '1161', '1', '33');
INSERT INTO public.who_global_data_import VALUES (554, '2020-06-04', 'AL', 'Albania', 'EURO', '36', '1197', '0', '33');
INSERT INTO public.who_global_data_import VALUES (555, '2020-06-05', 'AL', 'Albania', 'EURO', '15', '1212', '0', '33');
INSERT INTO public.who_global_data_import VALUES (556, '2020-06-06', 'AL', 'Albania', 'EURO', '20', '1232', '1', '34');
INSERT INTO public.who_global_data_import VALUES (557, '2020-06-07', 'AL', 'Albania', 'EURO', '14', '1246', '0', '34');
INSERT INTO public.who_global_data_import VALUES (558, '2020-06-08', 'AL', 'Albania', 'EURO', '17', '1263', '0', '34');
INSERT INTO public.who_global_data_import VALUES (559, '2020-06-09', 'AL', 'Albania', 'EURO', '36', '1299', '0', '34');
INSERT INTO public.who_global_data_import VALUES (560, '2020-06-10', 'AL', 'Albania', 'EURO', '42', '1341', '0', '34');
INSERT INTO public.who_global_data_import VALUES (561, '2020-06-11', 'AL', 'Albania', 'EURO', '44', '1385', '0', '34');
INSERT INTO public.who_global_data_import VALUES (562, '2020-06-12', 'AL', 'Albania', 'EURO', '31', '1416', '2', '36');
INSERT INTO public.who_global_data_import VALUES (563, '2020-06-13', 'AL', 'Albania', 'EURO', '48', '1464', '0', '36');
INSERT INTO public.who_global_data_import VALUES (564, '2020-06-14', 'AL', 'Albania', 'EURO', '57', '1521', '0', '36');
INSERT INTO public.who_global_data_import VALUES (565, '2020-06-15', 'AL', 'Albania', 'EURO', '69', '1590', '0', '36');
INSERT INTO public.who_global_data_import VALUES (566, '2020-06-16', 'AL', 'Albania', 'EURO', '82', '1672', '1', '37');
INSERT INTO public.who_global_data_import VALUES (567, '2020-06-17', 'AL', 'Albania', 'EURO', '50', '1722', '1', '38');
INSERT INTO public.who_global_data_import VALUES (568, '2020-06-18', 'AL', 'Albania', 'EURO', '66', '1788', '1', '39');
INSERT INTO public.who_global_data_import VALUES (569, '2020-06-19', 'AL', 'Albania', 'EURO', '50', '1838', '3', '42');
INSERT INTO public.who_global_data_import VALUES (570, '2020-06-20', 'AL', 'Albania', 'EURO', '0', '1838', '0', '42');
INSERT INTO public.who_global_data_import VALUES (571, '2020-06-21', 'AL', 'Albania', 'EURO', '53', '1891', '1', '43');
INSERT INTO public.who_global_data_import VALUES (572, '2020-06-22', 'AL', 'Albania', 'EURO', '104', '1995', '1', '44');
INSERT INTO public.who_global_data_import VALUES (573, '2020-06-23', 'AL', 'Albania', 'EURO', '52', '2047', '1', '45');
INSERT INTO public.who_global_data_import VALUES (574, '2020-06-24', 'AL', 'Albania', 'EURO', '67', '2114', '2', '47');
INSERT INTO public.who_global_data_import VALUES (575, '2020-06-25', 'AL', 'Albania', 'EURO', '78', '2192', '1', '48');
INSERT INTO public.who_global_data_import VALUES (576, '2020-06-26', 'AL', 'Albania', 'EURO', '77', '2269', '3', '51');
INSERT INTO public.who_global_data_import VALUES (577, '2020-06-27', 'AL', 'Albania', 'EURO', '61', '2330', '2', '53');
INSERT INTO public.who_global_data_import VALUES (578, '2020-06-28', 'AL', 'Albania', 'EURO', '72', '2402', '2', '55');
INSERT INTO public.who_global_data_import VALUES (579, '2020-06-29', 'AL', 'Albania', 'EURO', '64', '2466', '3', '58');
INSERT INTO public.who_global_data_import VALUES (580, '2020-06-30', 'AL', 'Albania', 'EURO', '69', '2535', '4', '62');
INSERT INTO public.who_global_data_import VALUES (581, '2020-07-01', 'AL', 'Albania', 'EURO', '45', '2580', '3', '65');
INSERT INTO public.who_global_data_import VALUES (582, '2020-07-02', 'AL', 'Albania', 'EURO', '82', '2662', '4', '69');
INSERT INTO public.who_global_data_import VALUES (583, '2020-07-03', 'AL', 'Albania', 'EURO', '90', '2752', '3', '72');
INSERT INTO public.who_global_data_import VALUES (584, '2020-07-04', 'AL', 'Albania', 'EURO', '67', '2819', '2', '74');
INSERT INTO public.who_global_data_import VALUES (585, '2020-07-05', 'AL', 'Albania', 'EURO', '74', '2893', '2', '76');
INSERT INTO public.who_global_data_import VALUES (586, '2020-07-06', 'AL', 'Albania', 'EURO', '71', '2964', '3', '79');
INSERT INTO public.who_global_data_import VALUES (587, '2020-07-07', 'AL', 'Albania', 'EURO', '74', '3038', '2', '81');
INSERT INTO public.who_global_data_import VALUES (588, '2020-07-08', 'AL', 'Albania', 'EURO', '68', '3106', '2', '83');
INSERT INTO public.who_global_data_import VALUES (589, '2020-07-09', 'AL', 'Albania', 'EURO', '82', '3188', '0', '83');
INSERT INTO public.who_global_data_import VALUES (590, '2020-07-10', 'AL', 'Albania', 'EURO', '90', '3278', '2', '85');
INSERT INTO public.who_global_data_import VALUES (591, '2020-07-11', 'AL', 'Albania', 'EURO', '93', '3371', '4', '89');
INSERT INTO public.who_global_data_import VALUES (592, '2020-07-12', 'AL', 'Albania', 'EURO', '83', '3454', '4', '93');
INSERT INTO public.who_global_data_import VALUES (593, '2020-07-13', 'AL', 'Albania', 'EURO', '117', '3571', '2', '95');
INSERT INTO public.who_global_data_import VALUES (594, '2020-07-14', 'AL', 'Albania', 'EURO', '96', '3667', '2', '97');
INSERT INTO public.who_global_data_import VALUES (595, '2020-07-15', 'AL', 'Albania', 'EURO', '85', '3752', '4', '101');
INSERT INTO public.who_global_data_import VALUES (596, '2020-07-16', 'AL', 'Albania', 'EURO', '99', '3851', '3', '104');
INSERT INTO public.who_global_data_import VALUES (597, '2020-07-17', 'AL', 'Albania', 'EURO', '55', '3906', '3', '107');
INSERT INTO public.who_global_data_import VALUES (598, '2020-07-18', 'AL', 'Albania', 'EURO', '0', '3906', '0', '107');
INSERT INTO public.who_global_data_import VALUES (599, '2020-07-19', 'AL', 'Albania', 'EURO', '102', '4008', '4', '111');
INSERT INTO public.who_global_data_import VALUES (600, '2020-07-20', 'AL', 'Albania', 'EURO', '82', '4090', '1', '112');
INSERT INTO public.who_global_data_import VALUES (601, '2020-07-21', 'AL', 'Albania', 'EURO', '81', '4171', '1', '113');
INSERT INTO public.who_global_data_import VALUES (602, '2020-07-22', 'AL', 'Albania', 'EURO', '119', '4290', '4', '117');
INSERT INTO public.who_global_data_import VALUES (603, '2020-07-23', 'AL', 'Albania', 'EURO', '68', '4358', '3', '120');
INSERT INTO public.who_global_data_import VALUES (604, '2020-07-24', 'AL', 'Albania', 'EURO', '108', '4466', '3', '123');
INSERT INTO public.who_global_data_import VALUES (605, '2020-07-25', 'AL', 'Albania', 'EURO', '104', '4570', '5', '128');
INSERT INTO public.who_global_data_import VALUES (606, '2020-07-26', 'AL', 'Albania', 'EURO', '67', '4637', '6', '134');
INSERT INTO public.who_global_data_import VALUES (607, '2020-07-27', 'AL', 'Albania', 'EURO', '126', '4763', '4', '138');
INSERT INTO public.who_global_data_import VALUES (608, '2020-07-28', 'AL', 'Albania', 'EURO', '117', '4880', '6', '144');
INSERT INTO public.who_global_data_import VALUES (609, '2020-07-29', 'AL', 'Albania', 'EURO', '117', '4997', '4', '148');
INSERT INTO public.who_global_data_import VALUES (610, '2020-07-30', 'AL', 'Albania', 'EURO', '108', '5105', '2', '150');
INSERT INTO public.who_global_data_import VALUES (611, '2020-07-31', 'AL', 'Albania', 'EURO', '92', '5197', '4', '154');
INSERT INTO public.who_global_data_import VALUES (612, '2020-08-01', 'AL', 'Albania', 'EURO', '79', '5276', '3', '157');
INSERT INTO public.who_global_data_import VALUES (613, '2020-08-02', 'AL', 'Albania', 'EURO', '120', '5396', '4', '161');
INSERT INTO public.who_global_data_import VALUES (614, '2020-08-03', 'AL', 'Albania', 'EURO', '123', '5519', '5', '166');
INSERT INTO public.who_global_data_import VALUES (615, '2020-08-04', 'AL', 'Albania', 'EURO', '101', '5620', '6', '172');
INSERT INTO public.who_global_data_import VALUES (616, '2020-08-05', 'AL', 'Albania', 'EURO', '130', '5750', '4', '176');
INSERT INTO public.who_global_data_import VALUES (617, '2020-08-06', 'AL', 'Albania', 'EURO', '139', '5889', '6', '182');
INSERT INTO public.who_global_data_import VALUES (618, '2020-08-07', 'AL', 'Albania', 'EURO', '127', '6016', '6', '188');
INSERT INTO public.who_global_data_import VALUES (619, '2020-08-08', 'AL', 'Albania', 'EURO', '135', '6151', '1', '189');
INSERT INTO public.who_global_data_import VALUES (620, '2020-08-09', 'AL', 'Albania', 'EURO', '124', '6275', '4', '193');
INSERT INTO public.who_global_data_import VALUES (621, '2020-08-10', 'AL', 'Albania', 'EURO', '136', '6411', '6', '199');
INSERT INTO public.who_global_data_import VALUES (622, '2020-08-11', 'AL', 'Albania', 'EURO', '125', '6536', '1', '200');
INSERT INTO public.who_global_data_import VALUES (623, '2020-08-12', 'AL', 'Albania', 'EURO', '140', '6676', '5', '205');
INSERT INTO public.who_global_data_import VALUES (624, '2020-08-13', 'AL', 'Albania', 'EURO', '141', '6817', '3', '208');
INSERT INTO public.who_global_data_import VALUES (625, '2020-08-14', 'AL', 'Albania', 'EURO', '154', '6971', '5', '213');
INSERT INTO public.who_global_data_import VALUES (626, '2020-08-15', 'AL', 'Albania', 'EURO', '146', '7117', '6', '219');
INSERT INTO public.who_global_data_import VALUES (627, '2020-08-16', 'AL', 'Albania', 'EURO', '143', '7260', '6', '225');
INSERT INTO public.who_global_data_import VALUES (628, '2020-08-17', 'AL', 'Albania', 'EURO', '120', '7380', '3', '228');
INSERT INTO public.who_global_data_import VALUES (629, '2020-08-18', 'AL', 'Albania', 'EURO', '119', '7499', '2', '230');
INSERT INTO public.who_global_data_import VALUES (630, '2020-08-19', 'AL', 'Albania', 'EURO', '155', '7654', '2', '232');
INSERT INTO public.who_global_data_import VALUES (631, '2020-08-20', 'AL', 'Albania', 'EURO', '158', '7812', '2', '234');
INSERT INTO public.who_global_data_import VALUES (632, '2020-08-21', 'AL', 'Albania', 'EURO', '155', '7967', '4', '238');
INSERT INTO public.who_global_data_import VALUES (633, '2020-08-22', 'AL', 'Albania', 'EURO', '152', '8119', '2', '240');
INSERT INTO public.who_global_data_import VALUES (634, '2020-08-23', 'AL', 'Albania', 'EURO', '156', '8275', '5', '245');
INSERT INTO public.who_global_data_import VALUES (635, '2020-08-24', 'AL', 'Albania', 'EURO', '152', '8427', '5', '250');
INSERT INTO public.who_global_data_import VALUES (636, '2020-08-25', 'AL', 'Albania', 'EURO', '178', '8605', '4', '254');
INSERT INTO public.who_global_data_import VALUES (637, '2020-08-26', 'AL', 'Albania', 'EURO', '154', '8759', '5', '259');
INSERT INTO public.who_global_data_import VALUES (638, '2020-08-27', 'AL', 'Albania', 'EURO', '168', '8927', '4', '263');
INSERT INTO public.who_global_data_import VALUES (639, '2020-08-28', 'AL', 'Albania', 'EURO', '156', '9083', '3', '266');
INSERT INTO public.who_global_data_import VALUES (640, '2020-08-29', 'AL', 'Albania', 'EURO', '112', '9195', '5', '271');
INSERT INTO public.who_global_data_import VALUES (641, '2020-08-30', 'AL', 'Albania', 'EURO', '84', '9279', '4', '275');
INSERT INTO public.who_global_data_import VALUES (642, '2020-08-31', 'AL', 'Albania', 'EURO', '101', '9380', '5', '280');
INSERT INTO public.who_global_data_import VALUES (643, '2020-09-01', 'AL', 'Albania', 'EURO', '133', '9513', '4', '284');
INSERT INTO public.who_global_data_import VALUES (644, '2020-09-02', 'AL', 'Albania', 'EURO', '93', '9606', '6', '290');
INSERT INTO public.who_global_data_import VALUES (645, '2020-09-03', 'AL', 'Albania', 'EURO', '122', '9728', '6', '296');
INSERT INTO public.who_global_data_import VALUES (646, '2020-09-04', 'AL', 'Albania', 'EURO', '116', '9844', '5', '301');
INSERT INTO public.who_global_data_import VALUES (647, '2020-09-05', 'AL', 'Albania', 'EURO', '123', '9967', '5', '306');
INSERT INTO public.who_global_data_import VALUES (648, '2020-09-06', 'AL', 'Albania', 'EURO', '135', '10102', '6', '312');
INSERT INTO public.who_global_data_import VALUES (649, '2020-09-07', 'AL', 'Albania', 'EURO', '153', '10255', '4', '316');
INSERT INTO public.who_global_data_import VALUES (650, '2020-09-08', 'AL', 'Albania', 'EURO', '151', '10406', '3', '319');
INSERT INTO public.who_global_data_import VALUES (651, '2020-09-09', 'AL', 'Albania', 'EURO', '147', '10553', '2', '321');
INSERT INTO public.who_global_data_import VALUES (652, '2020-09-10', 'AL', 'Albania', 'EURO', '151', '10704', '1', '322');
INSERT INTO public.who_global_data_import VALUES (653, '2020-09-11', 'AL', 'Albania', 'EURO', '156', '10860', '2', '324');
INSERT INTO public.who_global_data_import VALUES (654, '2020-09-12', 'AL', 'Albania', 'EURO', '161', '11021', '3', '327');
INSERT INTO public.who_global_data_import VALUES (655, '2020-09-13', 'AL', 'Albania', 'EURO', '164', '11185', '3', '330');
INSERT INTO public.who_global_data_import VALUES (656, '2020-09-14', 'AL', 'Albania', 'EURO', '168', '11353', '4', '334');
INSERT INTO public.who_global_data_import VALUES (657, '2020-09-15', 'AL', 'Albania', 'EURO', '167', '11520', '4', '338');
INSERT INTO public.who_global_data_import VALUES (658, '2020-09-16', 'AL', 'Albania', 'EURO', '152', '11672', '2', '340');
INSERT INTO public.who_global_data_import VALUES (659, '2020-09-17', 'AL', 'Albania', 'EURO', '144', '11816', '3', '343');
INSERT INTO public.who_global_data_import VALUES (660, '2020-09-18', 'AL', 'Albania', 'EURO', '132', '11948', '4', '347');
INSERT INTO public.who_global_data_import VALUES (661, '2020-09-19', 'AL', 'Albania', 'EURO', '125', '12073', '6', '353');
INSERT INTO public.who_global_data_import VALUES (662, '2020-09-20', 'AL', 'Albania', 'EURO', '153', '12226', '5', '358');
INSERT INTO public.who_global_data_import VALUES (663, '2020-09-21', 'AL', 'Albania', 'EURO', '159', '12385', '4', '362');
INSERT INTO public.who_global_data_import VALUES (664, '2020-09-22', 'AL', 'Albania', 'EURO', '150', '12535', '2', '364');
INSERT INTO public.who_global_data_import VALUES (665, '2020-09-23', 'AL', 'Albania', 'EURO', '131', '12666', '3', '367');
INSERT INTO public.who_global_data_import VALUES (666, '2020-09-24', 'AL', 'Albania', 'EURO', '121', '12787', '3', '370');
INSERT INTO public.who_global_data_import VALUES (667, '2020-09-25', 'AL', 'Albania', 'EURO', '134', '12921', '0', '370');
INSERT INTO public.who_global_data_import VALUES (668, '2020-09-26', 'AL', 'Albania', 'EURO', '124', '13045', '3', '373');
INSERT INTO public.who_global_data_import VALUES (669, '2020-09-27', 'AL', 'Albania', 'EURO', '108', '13153', '2', '375');
INSERT INTO public.who_global_data_import VALUES (670, '2020-09-28', 'AL', 'Albania', 'EURO', '106', '13259', '2', '377');
INSERT INTO public.who_global_data_import VALUES (671, '2020-09-29', 'AL', 'Albania', 'EURO', '132', '13391', '3', '380');
INSERT INTO public.who_global_data_import VALUES (672, '2020-09-30', 'AL', 'Albania', 'EURO', '127', '13518', '4', '384');
INSERT INTO public.who_global_data_import VALUES (673, '2020-10-01', 'AL', 'Albania', 'EURO', '131', '13649', '3', '387');
INSERT INTO public.who_global_data_import VALUES (674, '2020-10-02', 'AL', 'Albania', 'EURO', '157', '13806', '1', '388');
INSERT INTO public.who_global_data_import VALUES (675, '2020-10-03', 'AL', 'Albania', 'EURO', '159', '13965', '1', '389');
INSERT INTO public.who_global_data_import VALUES (676, '2020-10-04', 'AL', 'Albania', 'EURO', '152', '14117', '3', '392');
INSERT INTO public.who_global_data_import VALUES (677, '2020-10-05', 'AL', 'Albania', 'EURO', '149', '14266', '4', '396');
INSERT INTO public.who_global_data_import VALUES (678, '2020-10-06', 'AL', 'Albania', 'EURO', '144', '14410', '4', '400');
INSERT INTO public.who_global_data_import VALUES (679, '2020-10-07', 'AL', 'Albania', 'EURO', '158', '14568', '3', '403');
INSERT INTO public.who_global_data_import VALUES (680, '2020-10-08', 'AL', 'Albania', 'EURO', '162', '14730', '4', '407');
INSERT INTO public.who_global_data_import VALUES (681, '2020-10-09', 'AL', 'Albania', 'EURO', '169', '14899', '4', '411');
INSERT INTO public.who_global_data_import VALUES (682, '2020-10-10', 'AL', 'Albania', 'EURO', '167', '15066', '2', '413');
INSERT INTO public.who_global_data_import VALUES (683, '2020-10-11', 'AL', 'Albania', 'EURO', '165', '15231', '3', '416');
INSERT INTO public.who_global_data_import VALUES (684, '2020-10-12', 'AL', 'Albania', 'EURO', '168', '15399', '4', '420');
INSERT INTO public.who_global_data_import VALUES (685, '2020-10-13', 'AL', 'Albania', 'EURO', '171', '15570', '4', '424');
INSERT INTO public.who_global_data_import VALUES (686, '2020-10-14', 'AL', 'Albania', 'EURO', '182', '15752', '5', '429');
INSERT INTO public.who_global_data_import VALUES (687, '2020-10-15', 'AL', 'Albania', 'EURO', '203', '15955', '5', '434');
INSERT INTO public.who_global_data_import VALUES (688, '2020-10-16', 'AL', 'Albania', 'EURO', '257', '16212', '5', '439');
INSERT INTO public.who_global_data_import VALUES (689, '2020-10-17', 'AL', 'Albania', 'EURO', '289', '16501', '4', '443');
INSERT INTO public.who_global_data_import VALUES (690, '2020-10-18', 'AL', 'Albania', 'EURO', '273', '16774', '5', '448');
INSERT INTO public.who_global_data_import VALUES (691, '2020-10-19', 'AL', 'Albania', 'EURO', '281', '17055', '3', '451');
INSERT INTO public.who_global_data_import VALUES (692, '2020-10-20', 'AL', 'Albania', 'EURO', '295', '17350', '3', '454');
INSERT INTO public.who_global_data_import VALUES (693, '2020-10-21', 'AL', 'Albania', 'EURO', '301', '17651', '4', '458');
INSERT INTO public.who_global_data_import VALUES (694, '2020-10-22', 'AL', 'Albania', 'EURO', '297', '17948', '4', '462');
INSERT INTO public.who_global_data_import VALUES (695, '2020-10-23', 'AL', 'Albania', 'EURO', '302', '18250', '3', '465');
INSERT INTO public.who_global_data_import VALUES (696, '2020-10-24', 'AL', 'Albania', 'EURO', '306', '18556', '4', '469');
INSERT INTO public.who_global_data_import VALUES (697, '2020-10-25', 'AL', 'Albania', 'EURO', '302', '18858', '4', '473');
INSERT INTO public.who_global_data_import VALUES (698, '2020-10-26', 'AL', 'Albania', 'EURO', '299', '19157', '4', '477');
INSERT INTO public.who_global_data_import VALUES (699, '2020-10-27', 'AL', 'Albania', 'EURO', '288', '19445', '3', '480');
INSERT INTO public.who_global_data_import VALUES (700, '2020-10-28', 'AL', 'Albania', 'EURO', '284', '19729', '7', '487');
INSERT INTO public.who_global_data_import VALUES (701, '2020-10-29', 'AL', 'Albania', 'EURO', '311', '20040', '6', '493');
INSERT INTO public.who_global_data_import VALUES (702, '2020-10-30', 'AL', 'Albania', 'EURO', '275', '20315', '6', '499');
INSERT INTO public.who_global_data_import VALUES (703, '2020-10-31', 'AL', 'Albania', 'EURO', '319', '20634', '3', '502');
INSERT INTO public.who_global_data_import VALUES (704, '2020-11-01', 'AL', 'Albania', 'EURO', '241', '20875', '7', '509');
INSERT INTO public.who_global_data_import VALUES (705, '2020-11-02', 'AL', 'Albania', 'EURO', '327', '21202', '9', '518');
INSERT INTO public.who_global_data_import VALUES (706, '2020-11-03', 'AL', 'Albania', 'EURO', '321', '21523', '9', '527');
INSERT INTO public.who_global_data_import VALUES (707, '2020-11-04', 'AL', 'Albania', 'EURO', '381', '21904', '5', '532');
INSERT INTO public.who_global_data_import VALUES (708, '2020-11-05', 'AL', 'Albania', 'EURO', '396', '22300', '4', '536');
INSERT INTO public.who_global_data_import VALUES (709, '2020-11-06', 'AL', 'Albania', 'EURO', '421', '22721', '7', '543');
INSERT INTO public.who_global_data_import VALUES (710, '2020-11-07', 'AL', 'Albania', 'EURO', '489', '23210', '6', '549');
INSERT INTO public.who_global_data_import VALUES (711, '2020-11-08', 'AL', 'Albania', 'EURO', '495', '23705', '8', '557');
INSERT INTO public.who_global_data_import VALUES (712, '2020-11-09', 'AL', 'Albania', 'EURO', '501', '24206', '2', '559');
INSERT INTO public.who_global_data_import VALUES (713, '2020-11-10', 'AL', 'Albania', 'EURO', '525', '24731', '12', '571');
INSERT INTO public.who_global_data_import VALUES (714, '2020-11-11', 'AL', 'Albania', 'EURO', '563', '25294', '8', '579');
INSERT INTO public.who_global_data_import VALUES (715, '2020-11-12', 'AL', 'Albania', 'EURO', '507', '25801', '11', '590');
INSERT INTO public.who_global_data_import VALUES (716, '2020-11-13', 'AL', 'Albania', 'EURO', '410', '26211', '8', '598');
INSERT INTO public.who_global_data_import VALUES (717, '2020-11-14', 'AL', 'Albania', 'EURO', '490', '26701', '7', '605');
INSERT INTO public.who_global_data_import VALUES (718, '2020-11-15', 'AL', 'Albania', 'EURO', '532', '27233', '7', '612');
INSERT INTO public.who_global_data_import VALUES (719, '2020-11-16', 'AL', 'Albania', 'EURO', '597', '27830', '11', '623');
INSERT INTO public.who_global_data_import VALUES (720, '2020-11-17', 'AL', 'Albania', 'EURO', '602', '28432', '8', '631');
INSERT INTO public.who_global_data_import VALUES (721, '2020-11-18', 'AL', 'Albania', 'EURO', '694', '29126', '6', '637');
INSERT INTO public.who_global_data_import VALUES (722, '2020-11-19', 'AL', 'Albania', 'EURO', '711', '29837', '9', '646');
INSERT INTO public.who_global_data_import VALUES (723, '2020-11-20', 'AL', 'Albania', 'EURO', '786', '30623', '11', '657');
INSERT INTO public.who_global_data_import VALUES (724, '2020-11-21', 'AL', 'Albania', 'EURO', '836', '31459', '15', '672');
INSERT INTO public.who_global_data_import VALUES (725, '2020-11-22', 'AL', 'Albania', 'EURO', '737', '32196', '13', '685');
INSERT INTO public.who_global_data_import VALUES (726, '2020-11-23', 'AL', 'Albania', 'EURO', '565', '32761', '14', '699');
INSERT INTO public.who_global_data_import VALUES (727, '2020-11-24', 'AL', 'Albania', 'EURO', '795', '33556', '17', '716');
INSERT INTO public.who_global_data_import VALUES (728, '2020-11-25', 'AL', 'Albania', 'EURO', '744', '34300', '19', '735');
INSERT INTO public.who_global_data_import VALUES (729, '2020-11-26', 'AL', 'Albania', 'EURO', '644', '34944', '8', '743');
INSERT INTO public.who_global_data_import VALUES (730, '2020-11-27', 'AL', 'Albania', 'EURO', '656', '35600', '10', '753');
INSERT INTO public.who_global_data_import VALUES (731, '2020-11-28', 'AL', 'Albania', 'EURO', '645', '36245', '18', '771');
INSERT INTO public.who_global_data_import VALUES (732, '2020-11-29', 'AL', 'Albania', 'EURO', '545', '36790', '16', '787');
INSERT INTO public.who_global_data_import VALUES (733, '2020-11-30', 'AL', 'Albania', 'EURO', '835', '37625', '11', '798');
INSERT INTO public.who_global_data_import VALUES (734, '2020-12-01', 'AL', 'Albania', 'EURO', '557', '38182', '12', '810');
INSERT INTO public.who_global_data_import VALUES (735, '2020-12-02', 'AL', 'Albania', 'EURO', '832', '39014', '12', '822');
INSERT INTO public.who_global_data_import VALUES (736, '2020-12-03', 'AL', 'Albania', 'EURO', '705', '39719', '17', '839');
INSERT INTO public.who_global_data_import VALUES (737, '2020-12-04', 'AL', 'Albania', 'EURO', '782', '40501', '13', '852');
INSERT INTO public.who_global_data_import VALUES (738, '2020-12-05', 'AL', 'Albania', 'EURO', '801', '41302', '18', '870');
INSERT INTO public.who_global_data_import VALUES (739, '2020-12-06', 'AL', 'Albania', 'EURO', '846', '42148', '19', '889');
INSERT INTO public.who_global_data_import VALUES (740, '2020-12-07', 'AL', 'Albania', 'EURO', '840', '42988', '16', '905');
INSERT INTO public.who_global_data_import VALUES (741, '2020-12-08', 'AL', 'Albania', 'EURO', '695', '43683', '17', '922');
INSERT INTO public.who_global_data_import VALUES (742, '2020-12-09', 'AL', 'Albania', 'EURO', '753', '44436', '14', '936');
INSERT INTO public.who_global_data_import VALUES (743, '2020-12-10', 'AL', 'Albania', 'EURO', '752', '45188', '15', '951');
INSERT INTO public.who_global_data_import VALUES (744, '2020-12-11', 'AL', 'Albania', 'EURO', '873', '46061', '14', '965');
INSERT INTO public.who_global_data_import VALUES (745, '2020-12-12', 'AL', 'Albania', 'EURO', '802', '46863', '12', '977');
INSERT INTO public.who_global_data_import VALUES (746, '2020-12-13', 'AL', 'Albania', 'EURO', '879', '47742', '12', '989');
INSERT INTO public.who_global_data_import VALUES (747, '2020-12-14', 'AL', 'Albania', 'EURO', '788', '48530', '14', '1003');
INSERT INTO public.who_global_data_import VALUES (748, '2020-12-15', 'AL', 'Albania', 'EURO', '661', '49191', '13', '1016');
INSERT INTO public.who_global_data_import VALUES (749, '2020-12-16', 'AL', 'Albania', 'EURO', '809', '50000', '12', '1028');
INSERT INTO public.who_global_data_import VALUES (750, '2020-12-17', 'AL', 'Albania', 'EURO', '637', '50637', '12', '1040');
INSERT INTO public.who_global_data_import VALUES (751, '2020-12-18', 'AL', 'Albania', 'EURO', '787', '51424', '15', '1055');
INSERT INTO public.who_global_data_import VALUES (752, '2020-12-19', 'AL', 'Albania', 'EURO', '580', '52004', '11', '1066');
INSERT INTO public.who_global_data_import VALUES (753, '2020-12-20', 'AL', 'Albania', 'EURO', '538', '52542', '8', '1074');
INSERT INTO public.who_global_data_import VALUES (754, '2020-12-21', 'AL', 'Albania', 'EURO', '461', '53003', '14', '1088');
INSERT INTO public.who_global_data_import VALUES (755, '2020-12-22', 'AL', 'Albania', 'EURO', '422', '53425', '10', '1098');
INSERT INTO public.who_global_data_import VALUES (756, '2020-12-23', 'AL', 'Albania', 'EURO', '389', '53814', '13', '1111');
INSERT INTO public.who_global_data_import VALUES (757, '2020-12-24', 'AL', 'Albania', 'EURO', '503', '54317', '6', '1117');
INSERT INTO public.who_global_data_import VALUES (758, '2020-12-25', 'AL', 'Albania', 'EURO', '510', '54827', '8', '1125');
INSERT INTO public.who_global_data_import VALUES (759, '2020-12-26', 'AL', 'Albania', 'EURO', '553', '55380', '9', '1134');
INSERT INTO public.who_global_data_import VALUES (760, '2020-12-27', 'AL', 'Albania', 'EURO', '375', '55755', '9', '1143');
INSERT INTO public.who_global_data_import VALUES (761, '2020-12-28', 'AL', 'Albania', 'EURO', '499', '56254', '10', '1153');
INSERT INTO public.who_global_data_import VALUES (762, '2020-12-29', 'AL', 'Albania', 'EURO', '318', '56572', '11', '1164');
INSERT INTO public.who_global_data_import VALUES (763, '2020-12-30', 'AL', 'Albania', 'EURO', '574', '57146', '6', '1170');
INSERT INTO public.who_global_data_import VALUES (764, '2020-12-31', 'AL', 'Albania', 'EURO', '581', '57727', '4', '1174');
INSERT INTO public.who_global_data_import VALUES (765, '2021-01-01', 'AL', 'Albania', 'EURO', '589', '58316', '7', '1181');
INSERT INTO public.who_global_data_import VALUES (766, '2021-01-02', 'AL', 'Albania', 'EURO', '407', '58723', '5', '1186');
INSERT INTO public.who_global_data_import VALUES (767, '2021-01-03', 'AL', 'Albania', 'EURO', '268', '58991', '4', '1190');
INSERT INTO public.who_global_data_import VALUES (768, '2021-01-04', 'AL', 'Albania', 'EURO', '447', '59438', '3', '1193');
INSERT INTO public.who_global_data_import VALUES (769, '2021-01-05', 'AL', 'Albania', 'EURO', '185', '59623', '6', '1199');
INSERT INTO public.who_global_data_import VALUES (770, '2021-01-06', 'AL', 'Albania', 'EURO', '660', '60283', '11', '1210');
INSERT INTO public.who_global_data_import VALUES (771, '2021-01-07', 'AL', 'Albania', 'EURO', '725', '61008', '7', '1217');
INSERT INTO public.who_global_data_import VALUES (772, '2021-01-08', 'AL', 'Albania', 'EURO', '697', '61705', '6', '1223');
INSERT INTO public.who_global_data_import VALUES (773, '2021-01-09', 'AL', 'Albania', 'EURO', '673', '62378', '7', '1230');
INSERT INTO public.who_global_data_import VALUES (774, '2021-01-10', 'AL', 'Albania', 'EURO', '655', '63033', '3', '1233');
INSERT INTO public.who_global_data_import VALUES (775, '2021-01-11', 'AL', 'Albania', 'EURO', '562', '63595', '8', '1241');
INSERT INTO public.who_global_data_import VALUES (776, '2021-01-12', 'AL', 'Albania', 'EURO', '376', '63971', '6', '1247');
INSERT INTO public.who_global_data_import VALUES (777, '2021-01-13', 'AL', 'Albania', 'EURO', '656', '64627', '5', '1252');
INSERT INTO public.who_global_data_import VALUES (778, '2021-01-14', 'AL', 'Albania', 'EURO', '707', '65334', '4', '1256');
INSERT INTO public.who_global_data_import VALUES (779, '2021-01-15', 'AL', 'Albania', 'EURO', '660', '65994', '5', '1261');
INSERT INTO public.who_global_data_import VALUES (780, '2021-01-16', 'AL', 'Albania', 'EURO', '641', '66635', '4', '1265');
INSERT INTO public.who_global_data_import VALUES (781, '2021-01-17', 'AL', 'Albania', 'EURO', '581', '67216', '5', '1270');
INSERT INTO public.who_global_data_import VALUES (782, '2021-01-18', 'AL', 'Albania', 'EURO', '474', '67690', '7', '1277');
INSERT INTO public.who_global_data_import VALUES (783, '2021-01-19', 'AL', 'Albania', 'EURO', '292', '67982', '4', '1281');
INSERT INTO public.who_global_data_import VALUES (784, '2021-01-20', 'AL', 'Albania', 'EURO', '586', '68568', '6', '1287');
INSERT INTO public.who_global_data_import VALUES (785, '2021-01-21', 'AL', 'Albania', 'EURO', '670', '69238', '4', '1291');
INSERT INTO public.who_global_data_import VALUES (786, '2021-01-22', 'AL', 'Albania', 'EURO', '678', '69916', '5', '1296');
INSERT INTO public.who_global_data_import VALUES (787, '2021-01-23', 'AL', 'Albania', 'EURO', '739', '70655', '7', '1303');
INSERT INTO public.who_global_data_import VALUES (788, '2021-01-24', 'AL', 'Albania', 'EURO', '786', '71441', '7', '1310');
INSERT INTO public.who_global_data_import VALUES (789, '2021-01-25', 'AL', 'Albania', 'EURO', '833', '72274', '5', '1315');
INSERT INTO public.who_global_data_import VALUES (790, '2021-01-26', 'AL', 'Albania', 'EURO', '538', '72812', '9', '1324');
INSERT INTO public.who_global_data_import VALUES (791, '2021-01-27', 'AL', 'Albania', 'EURO', '879', '73691', '8', '1332');
INSERT INTO public.who_global_data_import VALUES (792, '2021-01-28', 'AL', 'Albania', 'EURO', '876', '74567', '7', '1339');
INSERT INTO public.who_global_data_import VALUES (793, '2021-01-29', 'AL', 'Albania', 'EURO', '887', '75454', '11', '1350');
INSERT INTO public.who_global_data_import VALUES (794, '2021-01-30', 'AL', 'Albania', 'EURO', '896', '76350', '8', '1358');
INSERT INTO public.who_global_data_import VALUES (795, '2021-01-31', 'AL', 'Albania', 'EURO', '901', '77251', '11', '1369');
INSERT INTO public.who_global_data_import VALUES (796, '2021-02-01', 'AL', 'Albania', 'EURO', '876', '78127', '11', '1380');
INSERT INTO public.who_global_data_import VALUES (797, '2021-02-02', 'AL', 'Albania', 'EURO', '865', '78992', '13', '1393');
INSERT INTO public.who_global_data_import VALUES (798, '2021-02-03', 'AL', 'Albania', 'EURO', '942', '79934', '5', '1398');
INSERT INTO public.who_global_data_import VALUES (799, '2021-02-04', 'AL', 'Albania', 'EURO', '1007', '80941', '6', '1404');
INSERT INTO public.who_global_data_import VALUES (800, '2021-02-05', 'AL', 'Albania', 'EURO', '1052', '81993', '14', '1418');
INSERT INTO public.who_global_data_import VALUES (801, '2020-01-03', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (802, '2020-01-04', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (803, '2020-01-05', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (804, '2020-01-06', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (805, '2020-01-07', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (806, '2020-01-08', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (807, '2020-01-09', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (808, '2020-01-10', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (809, '2020-01-11', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (810, '2020-01-12', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (811, '2020-01-13', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (812, '2020-01-14', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (813, '2020-01-15', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (814, '2020-01-16', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (815, '2020-01-17', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (816, '2020-01-18', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (817, '2020-01-19', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (818, '2020-01-20', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (819, '2020-01-21', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (820, '2020-01-22', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (821, '2020-01-23', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (822, '2020-01-24', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (823, '2020-01-25', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (824, '2020-01-26', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (825, '2020-01-27', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (826, '2020-01-28', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (827, '2020-01-29', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (828, '2020-01-30', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (829, '2020-01-31', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (830, '2020-02-01', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (831, '2020-02-02', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (832, '2020-02-03', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (833, '2020-02-04', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (834, '2020-02-05', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (835, '2020-02-06', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (836, '2020-02-07', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (837, '2020-02-08', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (838, '2020-02-09', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (839, '2020-02-10', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (840, '2020-02-11', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (841, '2020-02-12', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (842, '2020-02-13', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (843, '2020-02-14', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (844, '2020-02-15', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (845, '2020-02-16', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (846, '2020-02-17', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (847, '2020-02-18', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (848, '2020-02-19', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (849, '2020-02-20', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (850, '2020-02-21', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (851, '2020-02-22', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (852, '2020-02-23', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (853, '2020-02-24', 'DZ', 'Algeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (854, '2020-02-25', 'DZ', 'Algeria', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (855, '2020-02-26', 'DZ', 'Algeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (856, '2020-02-27', 'DZ', 'Algeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (857, '2020-02-28', 'DZ', 'Algeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (858, '2020-02-29', 'DZ', 'Algeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (859, '2020-03-01', 'DZ', 'Algeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (860, '2020-03-02', 'DZ', 'Algeria', 'AFRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (861, '2020-03-03', 'DZ', 'Algeria', 'AFRO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (862, '2020-03-04', 'DZ', 'Algeria', 'AFRO', '7', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (863, '2020-03-05', 'DZ', 'Algeria', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (864, '2020-03-06', 'DZ', 'Algeria', 'AFRO', '5', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (865, '2020-03-07', 'DZ', 'Algeria', 'AFRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (866, '2020-03-08', 'DZ', 'Algeria', 'AFRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (867, '2020-03-09', 'DZ', 'Algeria', 'AFRO', '3', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (868, '2020-03-10', 'DZ', 'Algeria', 'AFRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (869, '2020-03-11', 'DZ', 'Algeria', 'AFRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (870, '2020-03-12', 'DZ', 'Algeria', 'AFRO', '5', '29', '1', '1');
INSERT INTO public.who_global_data_import VALUES (871, '2020-03-13', 'DZ', 'Algeria', 'AFRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (872, '2020-03-14', 'DZ', 'Algeria', 'AFRO', '12', '41', '1', '2');
INSERT INTO public.who_global_data_import VALUES (873, '2020-03-15', 'DZ', 'Algeria', 'AFRO', '12', '53', '1', '3');
INSERT INTO public.who_global_data_import VALUES (874, '2020-03-16', 'DZ', 'Algeria', 'AFRO', '0', '53', '1', '4');
INSERT INTO public.who_global_data_import VALUES (875, '2020-03-17', 'DZ', 'Algeria', 'AFRO', '11', '64', '0', '4');
INSERT INTO public.who_global_data_import VALUES (876, '2020-03-18', 'DZ', 'Algeria', 'AFRO', '12', '76', '2', '6');
INSERT INTO public.who_global_data_import VALUES (877, '2020-03-19', 'DZ', 'Algeria', 'AFRO', '10', '86', '1', '7');
INSERT INTO public.who_global_data_import VALUES (878, '2020-03-20', 'DZ', 'Algeria', 'AFRO', '8', '94', '3', '10');
INSERT INTO public.who_global_data_import VALUES (879, '2020-03-21', 'DZ', 'Algeria', 'AFRO', '0', '94', '5', '15');
INSERT INTO public.who_global_data_import VALUES (880, '2020-03-22', 'DZ', 'Algeria', 'AFRO', '45', '139', '0', '15');
INSERT INTO public.who_global_data_import VALUES (881, '2020-03-23', 'DZ', 'Algeria', 'AFRO', '62', '201', '2', '17');
INSERT INTO public.who_global_data_import VALUES (882, '2020-03-24', 'DZ', 'Algeria', 'AFRO', '30', '231', '0', '17');
INSERT INTO public.who_global_data_import VALUES (883, '2020-03-25', 'DZ', 'Algeria', 'AFRO', '33', '264', '0', '17');
INSERT INTO public.who_global_data_import VALUES (884, '2020-03-26', 'DZ', 'Algeria', 'AFRO', '0', '264', '0', '17');
INSERT INTO public.who_global_data_import VALUES (885, '2020-03-27', 'DZ', 'Algeria', 'AFRO', '41', '305', '4', '21');
INSERT INTO public.who_global_data_import VALUES (886, '2020-03-28', 'DZ', 'Algeria', 'AFRO', '62', '367', '4', '25');
INSERT INTO public.who_global_data_import VALUES (887, '2020-03-29', 'DZ', 'Algeria', 'AFRO', '42', '409', '1', '26');
INSERT INTO public.who_global_data_import VALUES (888, '2020-03-30', 'DZ', 'Algeria', 'AFRO', '45', '454', '3', '29');
INSERT INTO public.who_global_data_import VALUES (889, '2020-03-31', 'DZ', 'Algeria', 'AFRO', '57', '511', '2', '31');
INSERT INTO public.who_global_data_import VALUES (890, '2020-04-01', 'DZ', 'Algeria', 'AFRO', '73', '584', '4', '35');
INSERT INTO public.who_global_data_import VALUES (891, '2020-04-02', 'DZ', 'Algeria', 'AFRO', '263', '847', '23', '58');
INSERT INTO public.who_global_data_import VALUES (892, '2020-04-03', 'DZ', 'Algeria', 'AFRO', '139', '986', '25', '83');
INSERT INTO public.who_global_data_import VALUES (893, '2020-04-04', 'DZ', 'Algeria', 'AFRO', '185', '1171', '22', '105');
INSERT INTO public.who_global_data_import VALUES (894, '2020-04-05', 'DZ', 'Algeria', 'AFRO', '80', '1251', '25', '130');
INSERT INTO public.who_global_data_import VALUES (895, '2020-04-06', 'DZ', 'Algeria', 'AFRO', '0', '1251', '0', '130');
INSERT INTO public.who_global_data_import VALUES (896, '2020-04-07', 'DZ', 'Algeria', 'AFRO', '172', '1423', '43', '173');
INSERT INTO public.who_global_data_import VALUES (897, '2020-04-08', 'DZ', 'Algeria', 'AFRO', '45', '1468', '21', '194');
INSERT INTO public.who_global_data_import VALUES (898, '2020-04-09', 'DZ', 'Algeria', 'AFRO', '104', '1572', '11', '205');
INSERT INTO public.who_global_data_import VALUES (899, '2020-04-10', 'DZ', 'Algeria', 'AFRO', '94', '1666', '30', '235');
INSERT INTO public.who_global_data_import VALUES (900, '2020-04-11', 'DZ', 'Algeria', 'AFRO', '95', '1761', '21', '256');
INSERT INTO public.who_global_data_import VALUES (901, '2020-04-12', 'DZ', 'Algeria', 'AFRO', '64', '1825', '19', '275');
INSERT INTO public.who_global_data_import VALUES (902, '2020-04-13', 'DZ', 'Algeria', 'AFRO', '89', '1914', '18', '293');
INSERT INTO public.who_global_data_import VALUES (903, '2020-04-14', 'DZ', 'Algeria', 'AFRO', '69', '1983', '20', '313');
INSERT INTO public.who_global_data_import VALUES (904, '2020-04-15', 'DZ', 'Algeria', 'AFRO', '87', '2070', '13', '326');
INSERT INTO public.who_global_data_import VALUES (905, '2020-04-16', 'DZ', 'Algeria', 'AFRO', '90', '2160', '10', '336');
INSERT INTO public.who_global_data_import VALUES (906, '2020-04-17', 'DZ', 'Algeria', 'AFRO', '108', '2268', '12', '348');
INSERT INTO public.who_global_data_import VALUES (907, '2020-04-18', 'DZ', 'Algeria', 'AFRO', '150', '2418', '16', '364');
INSERT INTO public.who_global_data_import VALUES (908, '2020-04-19', 'DZ', 'Algeria', 'AFRO', '116', '2534', '3', '367');
INSERT INTO public.who_global_data_import VALUES (909, '2020-04-20', 'DZ', 'Algeria', 'AFRO', '95', '2629', '8', '375');
INSERT INTO public.who_global_data_import VALUES (910, '2020-04-21', 'DZ', 'Algeria', 'AFRO', '89', '2718', '9', '384');
INSERT INTO public.who_global_data_import VALUES (911, '2020-04-22', 'DZ', 'Algeria', 'AFRO', '93', '2811', '8', '392');
INSERT INTO public.who_global_data_import VALUES (912, '2020-04-23', 'DZ', 'Algeria', 'AFRO', '99', '2910', '10', '402');
INSERT INTO public.who_global_data_import VALUES (913, '2020-04-24', 'DZ', 'Algeria', 'AFRO', '97', '3007', '5', '407');
INSERT INTO public.who_global_data_import VALUES (914, '2020-04-25', 'DZ', 'Algeria', 'AFRO', '120', '3127', '8', '415');
INSERT INTO public.who_global_data_import VALUES (915, '2020-04-26', 'DZ', 'Algeria', 'AFRO', '129', '3256', '4', '419');
INSERT INTO public.who_global_data_import VALUES (916, '2020-04-27', 'DZ', 'Algeria', 'AFRO', '126', '3382', '6', '425');
INSERT INTO public.who_global_data_import VALUES (917, '2020-04-28', 'DZ', 'Algeria', 'AFRO', '135', '3517', '7', '432');
INSERT INTO public.who_global_data_import VALUES (918, '2020-04-29', 'DZ', 'Algeria', 'AFRO', '132', '3649', '5', '437');
INSERT INTO public.who_global_data_import VALUES (919, '2020-04-30', 'DZ', 'Algeria', 'AFRO', '199', '3848', '7', '444');
INSERT INTO public.who_global_data_import VALUES (920, '2020-05-01', 'DZ', 'Algeria', 'AFRO', '158', '4006', '6', '450');
INSERT INTO public.who_global_data_import VALUES (921, '2020-05-02', 'DZ', 'Algeria', 'AFRO', '148', '4154', '3', '453');
INSERT INTO public.who_global_data_import VALUES (922, '2020-05-03', 'DZ', 'Algeria', 'AFRO', '141', '4295', '6', '459');
INSERT INTO public.who_global_data_import VALUES (923, '2020-05-04', 'DZ', 'Algeria', 'AFRO', '179', '4474', '4', '463');
INSERT INTO public.who_global_data_import VALUES (924, '2020-05-05', 'DZ', 'Algeria', 'AFRO', '174', '4648', '2', '465');
INSERT INTO public.who_global_data_import VALUES (925, '2020-05-06', 'DZ', 'Algeria', 'AFRO', '190', '4838', '5', '470');
INSERT INTO public.who_global_data_import VALUES (926, '2020-05-07', 'DZ', 'Algeria', 'AFRO', '159', '4997', '6', '476');
INSERT INTO public.who_global_data_import VALUES (927, '2020-05-08', 'DZ', 'Algeria', 'AFRO', '185', '5182', '7', '483');
INSERT INTO public.who_global_data_import VALUES (928, '2020-05-09', 'DZ', 'Algeria', 'AFRO', '187', '5369', '5', '488');
INSERT INTO public.who_global_data_import VALUES (929, '2020-05-10', 'DZ', 'Algeria', 'AFRO', '189', '5558', '6', '494');
INSERT INTO public.who_global_data_import VALUES (930, '2020-05-11', 'DZ', 'Algeria', 'AFRO', '165', '5723', '8', '502');
INSERT INTO public.who_global_data_import VALUES (931, '2020-05-12', 'DZ', 'Algeria', 'AFRO', '168', '5891', '5', '507');
INSERT INTO public.who_global_data_import VALUES (932, '2020-05-13', 'DZ', 'Algeria', 'AFRO', '176', '6067', '8', '515');
INSERT INTO public.who_global_data_import VALUES (933, '2020-05-14', 'DZ', 'Algeria', 'AFRO', '186', '6253', '7', '522');
INSERT INTO public.who_global_data_import VALUES (934, '2020-05-15', 'DZ', 'Algeria', 'AFRO', '189', '6442', '7', '529');
INSERT INTO public.who_global_data_import VALUES (935, '2020-05-16', 'DZ', 'Algeria', 'AFRO', '188', '6630', '7', '536');
INSERT INTO public.who_global_data_import VALUES (936, '2020-05-17', 'DZ', 'Algeria', 'AFRO', '191', '6821', '6', '542');
INSERT INTO public.who_global_data_import VALUES (937, '2020-05-18', 'DZ', 'Algeria', 'AFRO', '198', '7019', '6', '548');
INSERT INTO public.who_global_data_import VALUES (938, '2020-05-19', 'DZ', 'Algeria', 'AFRO', '182', '7201', '7', '555');
INSERT INTO public.who_global_data_import VALUES (939, '2020-05-20', 'DZ', 'Algeria', 'AFRO', '176', '7377', '6', '561');
INSERT INTO public.who_global_data_import VALUES (940, '2020-05-21', 'DZ', 'Algeria', 'AFRO', '165', '7542', '7', '568');
INSERT INTO public.who_global_data_import VALUES (941, '2020-05-22', 'DZ', 'Algeria', 'AFRO', '186', '7728', '7', '575');
INSERT INTO public.who_global_data_import VALUES (942, '2020-05-23', 'DZ', 'Algeria', 'AFRO', '190', '7918', '7', '582');
INSERT INTO public.who_global_data_import VALUES (943, '2020-05-24', 'DZ', 'Algeria', 'AFRO', '195', '8113', '10', '592');
INSERT INTO public.who_global_data_import VALUES (944, '2020-05-25', 'DZ', 'Algeria', 'AFRO', '193', '8306', '8', '600');
INSERT INTO public.who_global_data_import VALUES (945, '2020-05-26', 'DZ', 'Algeria', 'AFRO', '197', '8503', '9', '609');
INSERT INTO public.who_global_data_import VALUES (946, '2020-05-27', 'DZ', 'Algeria', 'AFRO', '194', '8697', '8', '617');
INSERT INTO public.who_global_data_import VALUES (947, '2020-05-28', 'DZ', 'Algeria', 'AFRO', '160', '8857', '6', '623');
INSERT INTO public.who_global_data_import VALUES (948, '2020-05-29', 'DZ', 'Algeria', 'AFRO', '140', '8997', '7', '630');
INSERT INTO public.who_global_data_import VALUES (949, '2020-05-30', 'DZ', 'Algeria', 'AFRO', '137', '9134', '8', '638');
INSERT INTO public.who_global_data_import VALUES (950, '2020-05-31', 'DZ', 'Algeria', 'AFRO', '133', '9267', '8', '646');
INSERT INTO public.who_global_data_import VALUES (951, '2020-06-01', 'DZ', 'Algeria', 'AFRO', '127', '9394', '7', '653');
INSERT INTO public.who_global_data_import VALUES (952, '2020-06-02', 'DZ', 'Algeria', 'AFRO', '119', '9513', '8', '661');
INSERT INTO public.who_global_data_import VALUES (953, '2020-06-03', 'DZ', 'Algeria', 'AFRO', '113', '9626', '6', '667');
INSERT INTO public.who_global_data_import VALUES (954, '2020-06-04', 'DZ', 'Algeria', 'AFRO', '107', '9733', '6', '673');
INSERT INTO public.who_global_data_import VALUES (955, '2020-06-05', 'DZ', 'Algeria', 'AFRO', '98', '9831', '8', '681');
INSERT INTO public.who_global_data_import VALUES (956, '2020-06-06', 'DZ', 'Algeria', 'AFRO', '104', '9935', '9', '690');
INSERT INTO public.who_global_data_import VALUES (957, '2020-06-07', 'DZ', 'Algeria', 'AFRO', '115', '10050', '8', '698');
INSERT INTO public.who_global_data_import VALUES (958, '2020-06-08', 'DZ', 'Algeria', 'AFRO', '104', '10154', '9', '707');
INSERT INTO public.who_global_data_import VALUES (959, '2020-06-09', 'DZ', 'Algeria', 'AFRO', '111', '10265', '8', '715');
INSERT INTO public.who_global_data_import VALUES (960, '2020-06-10', 'DZ', 'Algeria', 'AFRO', '117', '10382', '9', '724');
INSERT INTO public.who_global_data_import VALUES (961, '2020-06-11', 'DZ', 'Algeria', 'AFRO', '102', '10484', '8', '732');
INSERT INTO public.who_global_data_import VALUES (962, '2020-06-12', 'DZ', 'Algeria', 'AFRO', '105', '10589', '9', '741');
INSERT INTO public.who_global_data_import VALUES (963, '2020-06-13', 'DZ', 'Algeria', 'AFRO', '109', '10698', '10', '751');
INSERT INTO public.who_global_data_import VALUES (964, '2020-06-14', 'DZ', 'Algeria', 'AFRO', '112', '10810', '9', '760');
INSERT INTO public.who_global_data_import VALUES (965, '2020-06-15', 'DZ', 'Algeria', 'AFRO', '109', '10919', '7', '767');
INSERT INTO public.who_global_data_import VALUES (966, '2020-06-16', 'DZ', 'Algeria', 'AFRO', '112', '11031', '10', '777');
INSERT INTO public.who_global_data_import VALUES (967, '2020-06-17', 'DZ', 'Algeria', 'AFRO', '116', '11147', '11', '788');
INSERT INTO public.who_global_data_import VALUES (968, '2020-06-18', 'DZ', 'Algeria', 'AFRO', '121', '11268', '11', '799');
INSERT INTO public.who_global_data_import VALUES (969, '2020-06-19', 'DZ', 'Algeria', 'AFRO', '117', '11385', '12', '811');
INSERT INTO public.who_global_data_import VALUES (970, '2020-06-20', 'DZ', 'Algeria', 'AFRO', '119', '11504', '14', '825');
INSERT INTO public.who_global_data_import VALUES (971, '2020-06-21', 'DZ', 'Algeria', 'AFRO', '127', '11631', '12', '837');
INSERT INTO public.who_global_data_import VALUES (972, '2020-06-22', 'DZ', 'Algeria', 'AFRO', '140', '11771', '8', '845');
INSERT INTO public.who_global_data_import VALUES (973, '2020-06-23', 'DZ', 'Algeria', 'AFRO', '149', '11920', '7', '852');
INSERT INTO public.who_global_data_import VALUES (974, '2020-06-24', 'DZ', 'Algeria', 'AFRO', '156', '12076', '9', '861');
INSERT INTO public.who_global_data_import VALUES (975, '2020-06-25', 'DZ', 'Algeria', 'AFRO', '172', '12248', '8', '869');
INSERT INTO public.who_global_data_import VALUES (976, '2020-06-26', 'DZ', 'Algeria', 'AFRO', '197', '12445', '9', '878');
INSERT INTO public.who_global_data_import VALUES (977, '2020-06-27', 'DZ', 'Algeria', 'AFRO', '240', '12685', '7', '885');
INSERT INTO public.who_global_data_import VALUES (978, '2020-06-28', 'DZ', 'Algeria', 'AFRO', '283', '12968', '7', '892');
INSERT INTO public.who_global_data_import VALUES (979, '2020-06-29', 'DZ', 'Algeria', 'AFRO', '305', '13273', '5', '897');
INSERT INTO public.who_global_data_import VALUES (980, '2020-06-30', 'DZ', 'Algeria', 'AFRO', '298', '13571', '8', '905');
INSERT INTO public.who_global_data_import VALUES (981, '2020-07-01', 'DZ', 'Algeria', 'AFRO', '336', '13907', '7', '912');
INSERT INTO public.who_global_data_import VALUES (982, '2020-07-02', 'DZ', 'Algeria', 'AFRO', '365', '14272', '8', '920');
INSERT INTO public.who_global_data_import VALUES (983, '2020-07-03', 'DZ', 'Algeria', 'AFRO', '385', '14657', '8', '928');
INSERT INTO public.who_global_data_import VALUES (984, '2020-07-04', 'DZ', 'Algeria', 'AFRO', '413', '15070', '9', '937');
INSERT INTO public.who_global_data_import VALUES (985, '2020-07-05', 'DZ', 'Algeria', 'AFRO', '430', '15500', '9', '946');
INSERT INTO public.who_global_data_import VALUES (986, '2020-07-06', 'DZ', 'Algeria', 'AFRO', '441', '15941', '6', '952');
INSERT INTO public.who_global_data_import VALUES (987, '2020-07-07', 'DZ', 'Algeria', 'AFRO', '463', '16404', '7', '959');
INSERT INTO public.who_global_data_import VALUES (988, '2020-07-08', 'DZ', 'Algeria', 'AFRO', '475', '16879', '9', '968');
INSERT INTO public.who_global_data_import VALUES (989, '2020-07-09', 'DZ', 'Algeria', 'AFRO', '469', '17348', '10', '978');
INSERT INTO public.who_global_data_import VALUES (990, '2020-07-10', 'DZ', 'Algeria', 'AFRO', '460', '17808', '10', '988');
INSERT INTO public.who_global_data_import VALUES (991, '2020-07-11', 'DZ', 'Algeria', 'AFRO', '434', '18242', '8', '996');
INSERT INTO public.who_global_data_import VALUES (992, '2020-07-12', 'DZ', 'Algeria', 'AFRO', '470', '18712', '8', '1004');
INSERT INTO public.who_global_data_import VALUES (993, '2020-07-13', 'DZ', 'Algeria', 'AFRO', '483', '19195', '7', '1011');
INSERT INTO public.who_global_data_import VALUES (994, '2020-07-14', 'DZ', 'Algeria', 'AFRO', '494', '19689', '7', '1018');
INSERT INTO public.who_global_data_import VALUES (995, '2020-07-15', 'DZ', 'Algeria', 'AFRO', '527', '20216', '10', '1028');
INSERT INTO public.who_global_data_import VALUES (996, '2020-07-16', 'DZ', 'Algeria', 'AFRO', '554', '20770', '12', '1040');
INSERT INTO public.who_global_data_import VALUES (997, '2020-07-17', 'DZ', 'Algeria', 'AFRO', '585', '21355', '12', '1052');
INSERT INTO public.who_global_data_import VALUES (998, '2020-07-18', 'DZ', 'Algeria', 'AFRO', '593', '21948', '5', '1057');
INSERT INTO public.who_global_data_import VALUES (999, '2020-07-19', 'DZ', 'Algeria', 'AFRO', '601', '22549', '11', '1068');
INSERT INTO public.who_global_data_import VALUES (1000, '2020-07-20', 'DZ', 'Algeria', 'AFRO', '535', '23084', '10', '1078');
INSERT INTO public.who_global_data_import VALUES (1001, '2020-07-21', 'DZ', 'Algeria', 'AFRO', '607', '23691', '9', '1087');
INSERT INTO public.who_global_data_import VALUES (1002, '2020-07-22', 'DZ', 'Algeria', 'AFRO', '587', '24278', '13', '1100');
INSERT INTO public.who_global_data_import VALUES (1003, '2020-07-23', 'DZ', 'Algeria', 'AFRO', '594', '24872', '11', '1111');
INSERT INTO public.who_global_data_import VALUES (1004, '2020-07-24', 'DZ', 'Algeria', 'AFRO', '612', '25484', '13', '1124');
INSERT INTO public.who_global_data_import VALUES (1005, '2020-07-25', 'DZ', 'Algeria', 'AFRO', '675', '26159', '12', '1136');
INSERT INTO public.who_global_data_import VALUES (1006, '2020-07-26', 'DZ', 'Algeria', 'AFRO', '0', '26159', '0', '1136');
INSERT INTO public.who_global_data_import VALUES (1007, '2020-07-27', 'DZ', 'Algeria', 'AFRO', '1198', '27357', '19', '1155');
INSERT INTO public.who_global_data_import VALUES (1008, '2020-07-28', 'DZ', 'Algeria', 'AFRO', '616', '27973', '8', '1163');
INSERT INTO public.who_global_data_import VALUES (1009, '2020-07-29', 'DZ', 'Algeria', 'AFRO', '642', '28615', '11', '1174');
INSERT INTO public.who_global_data_import VALUES (1010, '2020-07-30', 'DZ', 'Algeria', 'AFRO', '614', '29229', '12', '1186');
INSERT INTO public.who_global_data_import VALUES (1011, '2020-07-31', 'DZ', 'Algeria', 'AFRO', '602', '29831', '14', '1200');
INSERT INTO public.who_global_data_import VALUES (1012, '2020-08-01', 'DZ', 'Algeria', 'AFRO', '563', '30394', '10', '1210');
INSERT INTO public.who_global_data_import VALUES (1013, '2020-08-02', 'DZ', 'Algeria', 'AFRO', '556', '30950', '13', '1223');
INSERT INTO public.who_global_data_import VALUES (1014, '2020-08-03', 'DZ', 'Algeria', 'AFRO', '515', '31465', '8', '1231');
INSERT INTO public.who_global_data_import VALUES (1015, '2020-08-04', 'DZ', 'Algeria', 'AFRO', '507', '31972', '-2', '1229');
INSERT INTO public.who_global_data_import VALUES (1016, '2020-08-05', 'DZ', 'Algeria', 'AFRO', '532', '32504', '19', '1248');
INSERT INTO public.who_global_data_import VALUES (1017, '2020-08-06', 'DZ', 'Algeria', 'AFRO', '551', '33055', '13', '1261');
INSERT INTO public.who_global_data_import VALUES (1018, '2020-08-07', 'DZ', 'Algeria', 'AFRO', '571', '33626', '12', '1273');
INSERT INTO public.who_global_data_import VALUES (1019, '2020-08-08', 'DZ', 'Algeria', 'AFRO', '529', '34155', '9', '1282');
INSERT INTO public.who_global_data_import VALUES (1020, '2020-08-09', 'DZ', 'Algeria', 'AFRO', '538', '34693', '11', '1293');
INSERT INTO public.who_global_data_import VALUES (1021, '2020-08-10', 'DZ', 'Algeria', 'AFRO', '521', '35214', '9', '1302');
INSERT INTO public.who_global_data_import VALUES (1022, '2020-08-11', 'DZ', 'Algeria', 'AFRO', '498', '35712', '10', '1312');
INSERT INTO public.who_global_data_import VALUES (1023, '2020-08-12', 'DZ', 'Algeria', 'AFRO', '492', '36204', '10', '1322');
INSERT INTO public.who_global_data_import VALUES (1024, '2020-08-13', 'DZ', 'Algeria', 'AFRO', '495', '36699', '11', '1333');
INSERT INTO public.who_global_data_import VALUES (1025, '2020-08-14', 'DZ', 'Algeria', 'AFRO', '488', '37187', '8', '1341');
INSERT INTO public.who_global_data_import VALUES (1026, '2020-08-15', 'DZ', 'Algeria', 'AFRO', '477', '37664', '10', '1351');
INSERT INTO public.who_global_data_import VALUES (1027, '2020-08-16', 'DZ', 'Algeria', 'AFRO', '469', '38133', '9', '1360');
INSERT INTO public.who_global_data_import VALUES (1028, '2020-08-17', 'DZ', 'Algeria', 'AFRO', '450', '38583', '10', '1370');
INSERT INTO public.who_global_data_import VALUES (1029, '2020-08-18', 'DZ', 'Algeria', 'AFRO', '442', '39025', '9', '1379');
INSERT INTO public.who_global_data_import VALUES (1030, '2020-08-19', 'DZ', 'Algeria', 'AFRO', '0', '39025', '0', '1379');
INSERT INTO public.who_global_data_import VALUES (1031, '2020-08-20', 'DZ', 'Algeria', 'AFRO', '822', '39847', '23', '1402');
INSERT INTO public.who_global_data_import VALUES (1032, '2020-08-21', 'DZ', 'Algeria', 'AFRO', '411', '40258', '9', '1411');
INSERT INTO public.who_global_data_import VALUES (1033, '2020-08-22', 'DZ', 'Algeria', 'AFRO', '0', '40258', '0', '1411');
INSERT INTO public.who_global_data_import VALUES (1034, '2020-08-23', 'DZ', 'Algeria', 'AFRO', '810', '41068', '13', '1424');
INSERT INTO public.who_global_data_import VALUES (1035, '2020-08-24', 'DZ', 'Algeria', 'AFRO', '392', '41460', '1', '1425');
INSERT INTO public.who_global_data_import VALUES (1036, '2020-08-25', 'DZ', 'Algeria', 'AFRO', '398', '41858', '21', '1446');
INSERT INTO public.who_global_data_import VALUES (1037, '2020-08-26', 'DZ', 'Algeria', 'AFRO', '370', '42228', '10', '1456');
INSERT INTO public.who_global_data_import VALUES (1038, '2020-08-27', 'DZ', 'Algeria', 'AFRO', '391', '42619', '9', '1465');
INSERT INTO public.who_global_data_import VALUES (1039, '2020-08-28', 'DZ', 'Algeria', 'AFRO', '397', '43016', '10', '1475');
INSERT INTO public.who_global_data_import VALUES (1040, '2020-08-29', 'DZ', 'Algeria', 'AFRO', '387', '43403', '8', '1483');
INSERT INTO public.who_global_data_import VALUES (1041, '2020-08-30', 'DZ', 'Algeria', 'AFRO', '379', '43782', '8', '1491');
INSERT INTO public.who_global_data_import VALUES (1042, '2020-08-31', 'DZ', 'Algeria', 'AFRO', '364', '44146', '10', '1501');
INSERT INTO public.who_global_data_import VALUES (1043, '2020-09-01', 'DZ', 'Algeria', 'AFRO', '348', '44494', '9', '1510');
INSERT INTO public.who_global_data_import VALUES (1044, '2020-09-02', 'DZ', 'Algeria', 'AFRO', '339', '44833', '8', '1518');
INSERT INTO public.who_global_data_import VALUES (1045, '2020-09-03', 'DZ', 'Algeria', 'AFRO', '325', '45158', '7', '1525');
INSERT INTO public.who_global_data_import VALUES (1046, '2020-09-04', 'DZ', 'Algeria', 'AFRO', '311', '45469', '6', '1531');
INSERT INTO public.who_global_data_import VALUES (1047, '2020-09-05', 'DZ', 'Algeria', 'AFRO', '304', '45773', '8', '1539');
INSERT INTO public.who_global_data_import VALUES (1048, '2020-09-06', 'DZ', 'Algeria', 'AFRO', '298', '46071', '10', '1549');
INSERT INTO public.who_global_data_import VALUES (1049, '2020-09-07', 'DZ', 'Algeria', 'AFRO', '293', '46364', '7', '1556');
INSERT INTO public.who_global_data_import VALUES (1050, '2020-09-08', 'DZ', 'Algeria', 'AFRO', '289', '46653', '6', '1562');
INSERT INTO public.who_global_data_import VALUES (1051, '2020-09-09', 'DZ', 'Algeria', 'AFRO', '285', '46938', '9', '1571');
INSERT INTO public.who_global_data_import VALUES (1052, '2020-09-10', 'DZ', 'Algeria', 'AFRO', '278', '47216', '10', '1581');
INSERT INTO public.who_global_data_import VALUES (1053, '2020-09-11', 'DZ', 'Algeria', 'AFRO', '272', '47488', '10', '1591');
INSERT INTO public.who_global_data_import VALUES (1054, '2020-09-12', 'DZ', 'Algeria', 'AFRO', '264', '47752', '8', '1599');
INSERT INTO public.who_global_data_import VALUES (1055, '2020-09-13', 'DZ', 'Algeria', 'AFRO', '255', '48007', '6', '1605');
INSERT INTO public.who_global_data_import VALUES (1056, '2020-09-14', 'DZ', 'Algeria', 'AFRO', '0', '48007', '0', '1605');
INSERT INTO public.who_global_data_import VALUES (1057, '2020-09-15', 'DZ', 'Algeria', 'AFRO', '489', '48496', '15', '1620');
INSERT INTO public.who_global_data_import VALUES (1058, '2020-09-16', 'DZ', 'Algeria', 'AFRO', '238', '48734', '12', '1632');
INSERT INTO public.who_global_data_import VALUES (1059, '2020-09-17', 'DZ', 'Algeria', 'AFRO', '232', '48966', '13', '1645');
INSERT INTO public.who_global_data_import VALUES (1060, '2020-09-18', 'DZ', 'Algeria', 'AFRO', '228', '49194', '9', '1654');
INSERT INTO public.who_global_data_import VALUES (1061, '2020-09-19', 'DZ', 'Algeria', 'AFRO', '219', '49413', '5', '1659');
INSERT INTO public.who_global_data_import VALUES (1062, '2020-09-20', 'DZ', 'Algeria', 'AFRO', '210', '49623', '6', '1665');
INSERT INTO public.who_global_data_import VALUES (1063, '2020-09-21', 'DZ', 'Algeria', 'AFRO', '203', '49826', '7', '1672');
INSERT INTO public.who_global_data_import VALUES (1064, '2020-09-22', 'DZ', 'Algeria', 'AFRO', '197', '50023', '7', '1679');
INSERT INTO public.who_global_data_import VALUES (1065, '2020-09-23', 'DZ', 'Algeria', 'AFRO', '191', '50214', '10', '1689');
INSERT INTO public.who_global_data_import VALUES (1066, '2020-09-24', 'DZ', 'Algeria', 'AFRO', '186', '50400', '9', '1698');
INSERT INTO public.who_global_data_import VALUES (1067, '2020-09-25', 'DZ', 'Algeria', 'AFRO', '0', '50400', '0', '1698');
INSERT INTO public.who_global_data_import VALUES (1068, '2020-09-26', 'DZ', 'Algeria', 'AFRO', '354', '50754', '9', '1707');
INSERT INTO public.who_global_data_import VALUES (1069, '2020-09-27', 'DZ', 'Algeria', 'AFRO', '160', '50914', '4', '1711');
INSERT INTO public.who_global_data_import VALUES (1070, '2020-09-28', 'DZ', 'Algeria', 'AFRO', '153', '51067', '3', '1714');
INSERT INTO public.who_global_data_import VALUES (1071, '2020-09-29', 'DZ', 'Algeria', 'AFRO', '146', '51213', '5', '1719');
INSERT INTO public.who_global_data_import VALUES (1072, '2020-09-30', 'DZ', 'Algeria', 'AFRO', '155', '51368', '7', '1726');
INSERT INTO public.who_global_data_import VALUES (1073, '2020-10-01', 'DZ', 'Algeria', 'AFRO', '162', '51530', '10', '1736');
INSERT INTO public.who_global_data_import VALUES (1074, '2020-10-02', 'DZ', 'Algeria', 'AFRO', '160', '51690', '5', '1741');
INSERT INTO public.who_global_data_import VALUES (1075, '2020-10-03', 'DZ', 'Algeria', 'AFRO', '157', '51847', '8', '1749');
INSERT INTO public.who_global_data_import VALUES (1076, '2020-10-04', 'DZ', 'Algeria', 'AFRO', '148', '51995', '7', '1756');
INSERT INTO public.who_global_data_import VALUES (1077, '2020-10-05', 'DZ', 'Algeria', 'AFRO', '141', '52136', '4', '1760');
INSERT INTO public.who_global_data_import VALUES (1078, '2020-10-06', 'DZ', 'Algeria', 'AFRO', '134', '52270', '8', '1768');
INSERT INTO public.who_global_data_import VALUES (1079, '2020-10-07', 'DZ', 'Algeria', 'AFRO', '129', '52399', '5', '1773');
INSERT INTO public.who_global_data_import VALUES (1080, '2020-10-08', 'DZ', 'Algeria', 'AFRO', '121', '52520', '6', '1779');
INSERT INTO public.who_global_data_import VALUES (1081, '2020-10-09', 'DZ', 'Algeria', 'AFRO', '138', '52658', '4', '1783');
INSERT INTO public.who_global_data_import VALUES (1082, '2020-10-10', 'DZ', 'Algeria', 'AFRO', '146', '52804', '6', '1789');
INSERT INTO public.who_global_data_import VALUES (1083, '2020-10-11', 'DZ', 'Algeria', 'AFRO', '136', '52940', '6', '1795');
INSERT INTO public.who_global_data_import VALUES (1084, '2020-10-12', 'DZ', 'Algeria', 'AFRO', '132', '53072', '6', '1801');
INSERT INTO public.who_global_data_import VALUES (1085, '2020-10-13', 'DZ', 'Algeria', 'AFRO', '153', '53225', '8', '1809');
INSERT INTO public.who_global_data_import VALUES (1086, '2020-10-14', 'DZ', 'Algeria', 'AFRO', '174', '53399', '9', '1818');
INSERT INTO public.who_global_data_import VALUES (1087, '2020-10-15', 'DZ', 'Algeria', 'AFRO', '0', '53399', '0', '1818');
INSERT INTO public.who_global_data_import VALUES (1088, '2020-10-16', 'DZ', 'Algeria', 'AFRO', '378', '53777', '18', '1836');
INSERT INTO public.who_global_data_import VALUES (1089, '2020-10-17', 'DZ', 'Algeria', 'AFRO', '221', '53998', '5', '1841');
INSERT INTO public.who_global_data_import VALUES (1090, '2020-10-18', 'DZ', 'Algeria', 'AFRO', '205', '54203', '5', '1846');
INSERT INTO public.who_global_data_import VALUES (1091, '2020-10-19', 'DZ', 'Algeria', 'AFRO', '199', '54402', '10', '1856');
INSERT INTO public.who_global_data_import VALUES (1092, '2020-10-20', 'DZ', 'Algeria', 'AFRO', '214', '54616', '9', '1865');
INSERT INTO public.who_global_data_import VALUES (1093, '2020-10-21', 'DZ', 'Algeria', 'AFRO', '223', '54839', '8', '1873');
INSERT INTO public.who_global_data_import VALUES (1094, '2020-10-22', 'DZ', 'Algeria', 'AFRO', '252', '55091', '7', '1880');
INSERT INTO public.who_global_data_import VALUES (1095, '2020-10-23', 'DZ', 'Algeria', 'AFRO', '266', '55357', '8', '1888');
INSERT INTO public.who_global_data_import VALUES (1096, '2020-10-24', 'DZ', 'Algeria', 'AFRO', '273', '55630', '9', '1897');
INSERT INTO public.who_global_data_import VALUES (1097, '2020-10-25', 'DZ', 'Algeria', 'AFRO', '0', '55630', '0', '1897');
INSERT INTO public.who_global_data_import VALUES (1098, '2020-10-26', 'DZ', 'Algeria', 'AFRO', '0', '55630', '0', '1897');
INSERT INTO public.who_global_data_import VALUES (1099, '2020-10-27', 'DZ', 'Algeria', 'AFRO', '0', '55630', '0', '1897');
INSERT INTO public.who_global_data_import VALUES (1100, '2020-10-28', 'DZ', 'Algeria', 'AFRO', '789', '56419', '25', '1922');
INSERT INTO public.who_global_data_import VALUES (1101, '2020-10-29', 'DZ', 'Algeria', 'AFRO', '287', '56706', '9', '1931');
INSERT INTO public.who_global_data_import VALUES (1102, '2020-10-30', 'DZ', 'Algeria', 'AFRO', '320', '57026', '10', '1941');
INSERT INTO public.who_global_data_import VALUES (1103, '2020-10-31', 'DZ', 'Algeria', 'AFRO', '306', '57332', '8', '1949');
INSERT INTO public.who_global_data_import VALUES (1104, '2020-11-01', 'DZ', 'Algeria', 'AFRO', '319', '57651', '7', '1956');
INSERT INTO public.who_global_data_import VALUES (1105, '2020-11-02', 'DZ', 'Algeria', 'AFRO', '291', '57942', '8', '1964');
INSERT INTO public.who_global_data_import VALUES (1106, '2020-11-03', 'DZ', 'Algeria', 'AFRO', '0', '57942', '0', '1964');
INSERT INTO public.who_global_data_import VALUES (1107, '2020-11-04', 'DZ', 'Algeria', 'AFRO', '0', '57942', '0', '1964');
INSERT INTO public.who_global_data_import VALUES (1108, '2020-11-05', 'DZ', 'Algeria', 'AFRO', '0', '57942', '0', '1964');
INSERT INTO public.who_global_data_import VALUES (1109, '2020-11-06', 'DZ', 'Algeria', 'AFRO', '330', '58272', '9', '1973');
INSERT INTO public.who_global_data_import VALUES (1110, '2020-11-07', 'DZ', 'Algeria', 'AFRO', '1897', '60169', '38', '2011');
INSERT INTO public.who_global_data_import VALUES (1111, '2020-11-08', 'DZ', 'Algeria', 'AFRO', '0', '60169', '0', '2011');
INSERT INTO public.who_global_data_import VALUES (1112, '2020-11-09', 'DZ', 'Algeria', 'AFRO', '0', '60169', '0', '2011');
INSERT INTO public.who_global_data_import VALUES (1113, '2020-11-10', 'DZ', 'Algeria', 'AFRO', '2524', '62693', '51', '2062');
INSERT INTO public.who_global_data_import VALUES (1114, '2020-11-11', 'DZ', 'Algeria', 'AFRO', '753', '63446', '15', '2077');
INSERT INTO public.who_global_data_import VALUES (1115, '2020-11-12', 'DZ', 'Algeria', 'AFRO', '811', '64257', '16', '2093');
INSERT INTO public.who_global_data_import VALUES (1116, '2020-11-13', 'DZ', 'Algeria', 'AFRO', '851', '65108', '18', '2111');
INSERT INTO public.who_global_data_import VALUES (1117, '2020-11-14', 'DZ', 'Algeria', 'AFRO', '867', '65975', '14', '2125');
INSERT INTO public.who_global_data_import VALUES (1118, '2020-11-15', 'DZ', 'Algeria', 'AFRO', '0', '65975', '0', '2125');
INSERT INTO public.who_global_data_import VALUES (1119, '2020-11-16', 'DZ', 'Algeria', 'AFRO', '1704', '67679', '29', '2154');
INSERT INTO public.who_global_data_import VALUES (1120, '2020-11-17', 'DZ', 'Algeria', 'AFRO', '910', '68589', '14', '2168');
INSERT INTO public.who_global_data_import VALUES (1121, '2020-11-18', 'DZ', 'Algeria', 'AFRO', '1002', '69591', '18', '2186');
INSERT INTO public.who_global_data_import VALUES (1122, '2020-11-19', 'DZ', 'Algeria', 'AFRO', '1038', '70629', '20', '2206');
INSERT INTO public.who_global_data_import VALUES (1123, '2020-11-20', 'DZ', 'Algeria', 'AFRO', '1023', '71652', '18', '2224');
INSERT INTO public.who_global_data_import VALUES (1124, '2020-11-21', 'DZ', 'Algeria', 'AFRO', '1103', '72755', '15', '2239');
INSERT INTO public.who_global_data_import VALUES (1125, '2020-11-22', 'DZ', 'Algeria', 'AFRO', '1019', '73774', '19', '2258');
INSERT INTO public.who_global_data_import VALUES (1126, '2020-11-23', 'DZ', 'Algeria', 'AFRO', '1088', '74862', '17', '2275');
INSERT INTO public.who_global_data_import VALUES (1127, '2020-11-24', 'DZ', 'Algeria', 'AFRO', '1005', '75867', '19', '2294');
INSERT INTO public.who_global_data_import VALUES (1128, '2020-11-25', 'DZ', 'Algeria', 'AFRO', '1133', '77000', '15', '2309');
INSERT INTO public.who_global_data_import VALUES (1129, '2020-11-26', 'DZ', 'Algeria', 'AFRO', '1025', '78025', '20', '2329');
INSERT INTO public.who_global_data_import VALUES (1130, '2020-11-27', 'DZ', 'Algeria', 'AFRO', '1085', '79110', '23', '2352');
INSERT INTO public.who_global_data_import VALUES (1131, '2020-11-28', 'DZ', 'Algeria', 'AFRO', '1058', '80168', '20', '2372');
INSERT INTO public.who_global_data_import VALUES (1132, '2020-11-29', 'DZ', 'Algeria', 'AFRO', '1044', '81212', '21', '2393');
INSERT INTO public.who_global_data_import VALUES (1133, '2020-11-30', 'DZ', 'Algeria', 'AFRO', '0', '81212', '0', '2393');
INSERT INTO public.who_global_data_import VALUES (1134, '2020-12-01', 'DZ', 'Algeria', 'AFRO', '1987', '83199', '38', '2431');
INSERT INTO public.who_global_data_import VALUES (1135, '2020-12-02', 'DZ', 'Algeria', 'AFRO', '953', '84152', '16', '2447');
INSERT INTO public.who_global_data_import VALUES (1136, '2020-12-03', 'DZ', 'Algeria', 'AFRO', '932', '85084', '17', '2464');
INSERT INTO public.who_global_data_import VALUES (1137, '2020-12-04', 'DZ', 'Algeria', 'AFRO', '843', '85927', '16', '2480');
INSERT INTO public.who_global_data_import VALUES (1138, '2020-12-05', 'DZ', 'Algeria', 'AFRO', '803', '86730', '12', '2492');
INSERT INTO public.who_global_data_import VALUES (1139, '2020-12-06', 'DZ', 'Algeria', 'AFRO', '772', '87502', '9', '2501');
INSERT INTO public.who_global_data_import VALUES (1140, '2020-12-07', 'DZ', 'Algeria', 'AFRO', '750', '88252', '15', '2516');
INSERT INTO public.who_global_data_import VALUES (1141, '2020-12-08', 'DZ', 'Algeria', 'AFRO', '573', '88825', '11', '2527');
INSERT INTO public.who_global_data_import VALUES (1142, '2020-12-09', 'DZ', 'Algeria', 'AFRO', '591', '89416', '12', '2539');
INSERT INTO public.who_global_data_import VALUES (1143, '2020-12-10', 'DZ', 'Algeria', 'AFRO', '598', '90014', '15', '2554');
INSERT INTO public.who_global_data_import VALUES (1144, '2020-12-11', 'DZ', 'Algeria', 'AFRO', '565', '90579', '10', '2564');
INSERT INTO public.who_global_data_import VALUES (1145, '2020-12-12', 'DZ', 'Algeria', 'AFRO', '542', '91121', '11', '2575');
INSERT INTO public.who_global_data_import VALUES (1146, '2020-12-13', 'DZ', 'Algeria', 'AFRO', '517', '91638', '9', '2584');
INSERT INTO public.who_global_data_import VALUES (1147, '2020-12-14', 'DZ', 'Algeria', 'AFRO', '464', '92102', '12', '2596');
INSERT INTO public.who_global_data_import VALUES (1148, '2020-12-15', 'DZ', 'Algeria', 'AFRO', '495', '92597', '13', '2609');
INSERT INTO public.who_global_data_import VALUES (1149, '2020-12-16', 'DZ', 'Algeria', 'AFRO', '468', '93065', '14', '2623');
INSERT INTO public.who_global_data_import VALUES (1150, '2020-12-17', 'DZ', 'Algeria', 'AFRO', '442', '93507', '8', '2631');
INSERT INTO public.who_global_data_import VALUES (1151, '2020-12-18', 'DZ', 'Algeria', 'AFRO', '426', '93933', '9', '2640');
INSERT INTO public.who_global_data_import VALUES (1152, '2020-12-19', 'DZ', 'Algeria', 'AFRO', '438', '94371', '7', '2647');
INSERT INTO public.who_global_data_import VALUES (1153, '2020-12-20', 'DZ', 'Algeria', 'AFRO', '410', '94781', '12', '2659');
INSERT INTO public.who_global_data_import VALUES (1154, '2020-12-21', 'DZ', 'Algeria', 'AFRO', '422', '95203', '7', '2666');
INSERT INTO public.who_global_data_import VALUES (1155, '2020-12-22', 'DZ', 'Algeria', 'AFRO', '456', '95659', '9', '2675');
INSERT INTO public.who_global_data_import VALUES (1156, '2020-12-23', 'DZ', 'Algeria', 'AFRO', '410', '96069', '12', '2687');
INSERT INTO public.who_global_data_import VALUES (1157, '2020-12-24', 'DZ', 'Algeria', 'AFRO', '480', '96549', '9', '2696');
INSERT INTO public.who_global_data_import VALUES (1158, '2020-12-25', 'DZ', 'Algeria', 'AFRO', '458', '97007', '9', '2705');
INSERT INTO public.who_global_data_import VALUES (1159, '2020-12-26', 'DZ', 'Algeria', 'AFRO', '434', '97441', '11', '2716');
INSERT INTO public.who_global_data_import VALUES (1160, '2020-12-27', 'DZ', 'Algeria', 'AFRO', '416', '97857', '6', '2722');
INSERT INTO public.who_global_data_import VALUES (1161, '2020-12-28', 'DZ', 'Algeria', 'AFRO', '392', '98249', '6', '2728');
INSERT INTO public.who_global_data_import VALUES (1162, '2020-12-29', 'DZ', 'Algeria', 'AFRO', '0', '98249', '0', '2728');
INSERT INTO public.who_global_data_import VALUES (1163, '2020-12-30', 'DZ', 'Algeria', 'AFRO', '357', '98606', '8', '2736');
INSERT INTO public.who_global_data_import VALUES (1164, '2020-12-31', 'DZ', 'Algeria', 'AFRO', '705', '99311', '15', '2751');
INSERT INTO public.who_global_data_import VALUES (1165, '2021-01-01', 'DZ', 'Algeria', 'AFRO', '299', '99610', '5', '2756');
INSERT INTO public.who_global_data_import VALUES (1166, '2021-01-02', 'DZ', 'Algeria', 'AFRO', '0', '99610', '0', '2756');
INSERT INTO public.who_global_data_import VALUES (1167, '2021-01-03', 'DZ', 'Algeria', 'AFRO', '549', '100159', '13', '2769');
INSERT INTO public.who_global_data_import VALUES (1168, '2021-01-04', 'DZ', 'Algeria', 'AFRO', '0', '100159', '0', '2769');
INSERT INTO public.who_global_data_import VALUES (1169, '2021-01-05', 'DZ', 'Algeria', 'AFRO', '486', '100645', '8', '2777');
INSERT INTO public.who_global_data_import VALUES (1170, '2021-01-06', 'DZ', 'Algeria', 'AFRO', '0', '100645', '0', '2777');
INSERT INTO public.who_global_data_import VALUES (1171, '2021-01-07', 'DZ', 'Algeria', 'AFRO', '475', '101120', '9', '2786');
INSERT INTO public.who_global_data_import VALUES (1172, '2021-01-08', 'DZ', 'Algeria', 'AFRO', '0', '101120', '0', '2786');
INSERT INTO public.who_global_data_import VALUES (1173, '2021-01-09', 'DZ', 'Algeria', 'AFRO', '537', '101657', '12', '2798');
INSERT INTO public.who_global_data_import VALUES (1174, '2021-01-10', 'DZ', 'Algeria', 'AFRO', '256', '101913', '5', '2803');
INSERT INTO public.who_global_data_import VALUES (1175, '2021-01-11', 'DZ', 'Algeria', 'AFRO', '231', '102144', '4', '2807');
INSERT INTO public.who_global_data_import VALUES (1176, '2021-01-12', 'DZ', 'Algeria', 'AFRO', '225', '102369', '5', '2812');
INSERT INTO public.who_global_data_import VALUES (1177, '2021-01-13', 'DZ', 'Algeria', 'AFRO', '272', '102641', '4', '2816');
INSERT INTO public.who_global_data_import VALUES (1178, '2021-01-14', 'DZ', 'Algeria', 'AFRO', '0', '102641', '0', '2816');
INSERT INTO public.who_global_data_import VALUES (1179, '2021-01-15', 'DZ', 'Algeria', 'AFRO', '219', '102860', '3', '2819');
INSERT INTO public.who_global_data_import VALUES (1180, '2021-01-16', 'DZ', 'Algeria', 'AFRO', '0', '102860', '0', '2819');
INSERT INTO public.who_global_data_import VALUES (1181, '2021-01-17', 'DZ', 'Algeria', 'AFRO', '751', '103611', '12', '2831');
INSERT INTO public.who_global_data_import VALUES (1182, '2021-01-18', 'DZ', 'Algeria', 'AFRO', '222', '103833', '10', '2841');
INSERT INTO public.who_global_data_import VALUES (1183, '2021-01-19', 'DZ', 'Algeria', 'AFRO', '259', '104092', '4', '2845');
INSERT INTO public.who_global_data_import VALUES (1184, '2021-01-20', 'DZ', 'Algeria', 'AFRO', '249', '104341', '3', '2848');
INSERT INTO public.who_global_data_import VALUES (1185, '2021-01-21', 'DZ', 'Algeria', 'AFRO', '265', '104606', '6', '2854');
INSERT INTO public.who_global_data_import VALUES (1186, '2021-01-22', 'DZ', 'Algeria', 'AFRO', '246', '104852', '0', '2854');
INSERT INTO public.who_global_data_import VALUES (1187, '2021-01-23', 'DZ', 'Algeria', 'AFRO', '272', '105124', '2', '2856');
INSERT INTO public.who_global_data_import VALUES (1188, '2021-01-24', 'DZ', 'Algeria', 'AFRO', '245', '105369', '5', '2861');
INSERT INTO public.who_global_data_import VALUES (1189, '2021-01-25', 'DZ', 'Algeria', 'AFRO', '227', '105596', '2', '2863');
INSERT INTO public.who_global_data_import VALUES (1190, '2021-01-26', 'DZ', 'Algeria', 'AFRO', '258', '105854', '3', '2866');
INSERT INTO public.who_global_data_import VALUES (1191, '2021-01-27', 'DZ', 'Algeria', 'AFRO', '243', '106097', '5', '2871');
INSERT INTO public.who_global_data_import VALUES (1192, '2021-01-28', 'DZ', 'Algeria', 'AFRO', '262', '106359', '6', '2877');
INSERT INTO public.who_global_data_import VALUES (1193, '2021-01-29', 'DZ', 'Algeria', 'AFRO', '251', '106610', '4', '2881');
INSERT INTO public.who_global_data_import VALUES (1194, '2021-01-30', 'DZ', 'Algeria', 'AFRO', '277', '106887', '3', '2884');
INSERT INTO public.who_global_data_import VALUES (1195, '2021-01-31', 'DZ', 'Algeria', 'AFRO', '235', '107122', '4', '2888');
INSERT INTO public.who_global_data_import VALUES (1196, '2021-02-01', 'DZ', 'Algeria', 'AFRO', '217', '107339', '3', '2891');
INSERT INTO public.who_global_data_import VALUES (1197, '2021-02-02', 'DZ', 'Algeria', 'AFRO', '239', '107578', '3', '2894');
INSERT INTO public.who_global_data_import VALUES (1198, '2021-02-03', 'DZ', 'Algeria', 'AFRO', '263', '107841', '4', '2898');
INSERT INTO public.who_global_data_import VALUES (1199, '2021-02-04', 'DZ', 'Algeria', 'AFRO', '275', '108116', '2', '2900');
INSERT INTO public.who_global_data_import VALUES (1200, '2021-02-05', 'DZ', 'Algeria', 'AFRO', '265', '108381', '4', '2904');
INSERT INTO public.who_global_data_import VALUES (1201, '2020-01-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1202, '2020-01-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1203, '2020-01-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1204, '2020-01-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1205, '2020-01-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1206, '2020-01-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1207, '2020-01-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1208, '2020-01-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1209, '2020-01-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1210, '2020-01-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1211, '2020-01-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1212, '2020-01-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1213, '2020-01-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1214, '2020-01-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1215, '2020-01-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1216, '2020-01-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1217, '2020-01-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1218, '2020-01-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1219, '2020-01-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1220, '2020-01-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1221, '2020-01-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1222, '2020-01-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1223, '2020-01-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1224, '2020-01-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1225, '2020-01-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1226, '2020-01-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1227, '2020-01-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1228, '2020-01-30', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1229, '2020-01-31', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1230, '2020-02-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1231, '2020-02-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1232, '2020-02-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1233, '2020-02-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1234, '2020-02-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1235, '2020-02-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1236, '2020-02-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1237, '2020-02-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1238, '2020-02-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1239, '2020-02-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1240, '2020-02-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1241, '2020-02-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1242, '2020-02-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1243, '2020-02-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1244, '2020-02-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1245, '2020-02-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1246, '2020-02-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1247, '2020-02-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1248, '2020-02-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1249, '2020-02-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1250, '2020-02-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1251, '2020-02-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1252, '2020-02-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1253, '2020-02-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1254, '2020-02-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1255, '2020-02-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1256, '2020-02-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1257, '2020-02-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1258, '2020-02-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1259, '2020-03-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1260, '2020-03-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1261, '2020-03-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1262, '2020-03-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1263, '2020-03-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1264, '2020-03-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1265, '2020-03-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1266, '2020-03-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1267, '2020-03-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1268, '2020-03-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1269, '2020-03-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1270, '2020-03-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1271, '2020-03-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1272, '2020-03-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1273, '2020-03-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1274, '2020-03-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1275, '2020-03-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1276, '2020-03-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1277, '2020-03-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1278, '2020-03-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1279, '2020-03-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1280, '2020-03-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1281, '2020-03-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1282, '2020-03-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1283, '2020-03-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1284, '2020-03-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1285, '2020-03-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1286, '2020-03-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1287, '2020-03-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1288, '2020-03-30', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1289, '2020-03-31', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1290, '2020-04-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1291, '2020-04-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1292, '2020-04-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1293, '2020-04-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1294, '2020-04-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1295, '2020-04-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1296, '2020-04-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1297, '2020-04-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1298, '2020-04-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1299, '2020-04-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1300, '2020-04-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1301, '2020-04-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1302, '2020-04-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1303, '2020-04-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1304, '2020-04-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1305, '2020-04-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1306, '2020-04-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1307, '2020-04-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1308, '2020-04-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1309, '2020-04-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1310, '2020-04-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1311, '2020-04-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1312, '2020-04-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1313, '2020-04-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1314, '2020-04-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1315, '2020-04-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1316, '2020-04-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1317, '2020-04-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1318, '2020-04-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1319, '2020-04-30', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1320, '2020-05-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1321, '2020-05-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1322, '2020-05-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1323, '2020-05-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1324, '2020-05-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1325, '2020-05-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1326, '2020-05-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1327, '2020-05-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1328, '2020-05-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1329, '2020-05-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1330, '2020-05-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1331, '2020-05-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1332, '2020-05-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1333, '2020-05-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1334, '2020-05-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1335, '2020-05-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1336, '2020-05-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1337, '2020-05-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1338, '2020-05-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1339, '2020-05-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1340, '2020-05-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1341, '2020-05-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1342, '2020-05-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1343, '2020-05-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1344, '2020-05-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1345, '2020-05-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1346, '2020-05-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1347, '2020-05-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1348, '2020-05-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1349, '2020-05-30', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1350, '2020-05-31', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1351, '2020-06-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1352, '2020-06-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1353, '2020-06-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1354, '2020-06-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1355, '2020-06-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1356, '2020-06-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1357, '2020-06-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1358, '2020-06-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1359, '2020-06-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1360, '2020-06-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1361, '2020-06-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1362, '2020-06-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1363, '2020-06-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1364, '2020-06-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1365, '2020-06-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1366, '2020-06-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1367, '2020-06-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1368, '2020-06-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1369, '2020-06-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1370, '2020-06-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1371, '2020-06-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1372, '2020-06-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1373, '2020-06-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1374, '2020-06-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1375, '2020-06-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1376, '2020-06-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1377, '2020-06-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1378, '2020-06-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1379, '2020-06-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1380, '2020-06-30', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1381, '2020-07-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1382, '2020-07-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1383, '2020-07-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1384, '2020-07-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1385, '2020-07-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1386, '2020-07-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1387, '2020-07-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1388, '2020-07-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1389, '2020-07-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1390, '2020-07-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1391, '2020-07-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1392, '2020-07-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1393, '2020-07-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1394, '2020-07-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1395, '2020-07-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1396, '2020-07-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1397, '2020-07-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1398, '2020-07-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1399, '2020-07-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1400, '2020-07-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1401, '2020-07-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1402, '2020-07-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1403, '2020-07-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1404, '2020-07-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1405, '2020-07-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1406, '2020-07-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1407, '2020-07-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1408, '2020-07-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1409, '2020-07-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1410, '2020-07-30', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1411, '2020-07-31', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1412, '2020-08-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1413, '2020-08-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1414, '2020-08-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1415, '2020-08-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1416, '2020-08-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1417, '2020-08-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1418, '2020-08-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1419, '2020-08-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1420, '2020-08-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1421, '2020-08-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1422, '2020-08-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1423, '2020-08-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1424, '2020-08-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1425, '2020-08-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1426, '2020-08-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1427, '2020-08-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1428, '2020-08-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1429, '2020-08-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1430, '2020-08-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1431, '2020-08-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1432, '2020-08-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1433, '2020-08-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1434, '2020-08-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1435, '2020-08-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1436, '2020-08-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1437, '2020-08-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1438, '2020-08-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1439, '2020-08-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1440, '2020-08-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1441, '2020-08-30', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1442, '2020-08-31', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1443, '2020-09-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1444, '2020-09-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1445, '2020-09-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1446, '2020-09-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1447, '2020-09-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1448, '2020-09-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1449, '2020-09-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1450, '2020-09-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1451, '2020-09-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1452, '2020-09-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1453, '2020-09-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1454, '2020-09-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1455, '2020-09-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1456, '2020-09-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1457, '2020-09-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1458, '2020-09-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1459, '2020-09-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1460, '2020-09-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1461, '2020-09-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1462, '2020-09-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1463, '2020-09-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1464, '2020-09-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1465, '2020-09-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1466, '2020-09-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1467, '2020-09-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1468, '2020-09-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1469, '2020-09-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1470, '2020-09-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1471, '2020-09-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1472, '2020-09-30', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1473, '2020-10-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1474, '2020-10-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1475, '2020-10-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1476, '2020-10-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1477, '2020-10-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1478, '2020-10-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1479, '2020-10-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1480, '2020-10-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1481, '2020-10-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1482, '2020-10-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1483, '2020-10-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1484, '2020-10-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1485, '2020-10-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1486, '2020-10-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1487, '2020-10-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1488, '2020-10-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1489, '2020-10-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1490, '2020-10-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1491, '2020-10-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1492, '2020-10-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1493, '2020-10-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1494, '2020-10-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1495, '2020-10-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1496, '2020-10-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1497, '2020-10-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1498, '2020-10-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1499, '2020-10-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1500, '2020-10-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1501, '2020-10-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1502, '2020-10-30', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1503, '2020-10-31', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1504, '2020-11-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1505, '2020-11-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1506, '2020-11-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1507, '2020-11-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1508, '2020-11-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1509, '2020-11-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1510, '2020-11-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1511, '2020-11-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1512, '2020-11-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1513, '2020-11-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1514, '2020-11-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1515, '2020-11-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1516, '2020-11-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1517, '2020-11-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1518, '2020-11-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1519, '2020-11-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1520, '2020-11-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1521, '2020-11-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1522, '2020-11-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1523, '2020-11-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1524, '2020-11-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1525, '2020-11-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1526, '2020-11-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1527, '2020-11-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1528, '2020-11-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1529, '2020-11-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1530, '2020-11-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1531, '2020-11-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1532, '2020-11-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1533, '2020-11-30', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1534, '2020-12-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1535, '2020-12-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1536, '2020-12-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1537, '2020-12-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1538, '2020-12-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1539, '2020-12-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1540, '2020-12-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1541, '2020-12-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1542, '2020-12-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1543, '2020-12-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1544, '2020-12-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1545, '2020-12-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1546, '2020-12-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1547, '2020-12-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1548, '2020-12-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1549, '2020-12-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1550, '2020-12-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1551, '2020-12-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1552, '2020-12-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1553, '2020-12-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1554, '2020-12-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1555, '2020-12-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1556, '2020-12-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1557, '2020-12-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1558, '2020-12-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1559, '2020-12-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1560, '2020-12-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1561, '2020-12-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1562, '2020-12-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1563, '2020-12-30', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1564, '2020-12-31', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1565, '2021-01-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1566, '2021-01-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1567, '2021-01-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1568, '2021-01-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1569, '2021-01-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1570, '2021-01-06', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1571, '2021-01-07', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1572, '2021-01-08', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1573, '2021-01-09', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1574, '2021-01-10', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1575, '2021-01-11', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1576, '2021-01-12', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1577, '2021-01-13', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1578, '2021-01-14', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1579, '2021-01-15', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1580, '2021-01-16', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1581, '2021-01-17', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1582, '2021-01-18', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1583, '2021-01-19', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1584, '2021-01-20', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1585, '2021-01-21', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1586, '2021-01-22', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1587, '2021-01-23', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1588, '2021-01-24', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1589, '2021-01-25', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1590, '2021-01-26', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1591, '2021-01-27', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1592, '2021-01-28', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1593, '2021-01-29', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1594, '2021-01-30', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1595, '2021-01-31', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1596, '2021-02-01', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1597, '2021-02-02', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1598, '2021-02-03', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1599, '2021-02-04', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1600, '2021-02-05', 'AS', 'American Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1601, '2020-01-03', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1602, '2020-01-04', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1603, '2020-01-05', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1604, '2020-01-06', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1605, '2020-01-07', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1606, '2020-01-08', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1607, '2020-01-09', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1608, '2020-01-10', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1609, '2020-01-11', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1610, '2020-01-12', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1611, '2020-01-13', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1612, '2020-01-14', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1613, '2020-01-15', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1614, '2020-01-16', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1615, '2020-01-17', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1616, '2020-01-18', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1617, '2020-01-19', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1618, '2020-01-20', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1619, '2020-01-21', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1620, '2020-01-22', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1621, '2020-01-23', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1622, '2020-01-24', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1623, '2020-01-25', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1624, '2020-01-26', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1625, '2020-01-27', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1626, '2020-01-28', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1627, '2020-01-29', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1628, '2020-01-30', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1629, '2020-01-31', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1630, '2020-02-01', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1631, '2020-02-02', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1632, '2020-02-03', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1633, '2020-02-04', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1634, '2020-02-05', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1635, '2020-02-06', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1636, '2020-02-07', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1637, '2020-02-08', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1638, '2020-02-09', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1639, '2020-02-10', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1640, '2020-02-11', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1641, '2020-02-12', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1642, '2020-02-13', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1643, '2020-02-14', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1644, '2020-02-15', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1645, '2020-02-16', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1646, '2020-02-17', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1647, '2020-02-18', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1648, '2020-02-19', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1649, '2020-02-20', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1650, '2020-02-21', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1651, '2020-02-22', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1652, '2020-02-23', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1653, '2020-02-24', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1654, '2020-02-25', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1655, '2020-02-26', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1656, '2020-02-27', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1657, '2020-02-28', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1658, '2020-02-29', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1659, '2020-03-01', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1660, '2020-03-02', 'AD', 'Andorra', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1661, '2020-03-03', 'AD', 'Andorra', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1662, '2020-03-04', 'AD', 'Andorra', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1663, '2020-03-05', 'AD', 'Andorra', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1664, '2020-03-06', 'AD', 'Andorra', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1665, '2020-03-07', 'AD', 'Andorra', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1666, '2020-03-08', 'AD', 'Andorra', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1667, '2020-03-09', 'AD', 'Andorra', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1668, '2020-03-10', 'AD', 'Andorra', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1669, '2020-03-11', 'AD', 'Andorra', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1670, '2020-03-12', 'AD', 'Andorra', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1671, '2020-03-13', 'AD', 'Andorra', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1672, '2020-03-14', 'AD', 'Andorra', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1673, '2020-03-15', 'AD', 'Andorra', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1674, '2020-03-16', 'AD', 'Andorra', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1675, '2020-03-17', 'AD', 'Andorra', 'EURO', '12', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1676, '2020-03-18', 'AD', 'Andorra', 'EURO', '25', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1677, '2020-03-19', 'AD', 'Andorra', 'EURO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1678, '2020-03-20', 'AD', 'Andorra', 'EURO', '36', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1679, '2020-03-21', 'AD', 'Andorra', 'EURO', '19', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (1680, '2020-03-22', 'AD', 'Andorra', 'EURO', '39', '133', '1', '1');
INSERT INTO public.who_global_data_import VALUES (1681, '2020-03-23', 'AD', 'Andorra', 'EURO', '1', '134', '0', '1');
INSERT INTO public.who_global_data_import VALUES (1682, '2020-03-24', 'AD', 'Andorra', 'EURO', '31', '165', '0', '1');
INSERT INTO public.who_global_data_import VALUES (1683, '2020-03-25', 'AD', 'Andorra', 'EURO', '48', '213', '2', '3');
INSERT INTO public.who_global_data_import VALUES (1684, '2020-03-26', 'AD', 'Andorra', 'EURO', '18', '231', '0', '3');
INSERT INTO public.who_global_data_import VALUES (1685, '2020-03-27', 'AD', 'Andorra', 'EURO', '58', '289', '0', '3');
INSERT INTO public.who_global_data_import VALUES (1686, '2020-03-28', 'AD', 'Andorra', 'EURO', '32', '321', '1', '4');
INSERT INTO public.who_global_data_import VALUES (1687, '2020-03-29', 'AD', 'Andorra', 'EURO', '20', '341', '2', '6');
INSERT INTO public.who_global_data_import VALUES (1688, '2020-03-30', 'AD', 'Andorra', 'EURO', '29', '370', '2', '8');
INSERT INTO public.who_global_data_import VALUES (1689, '2020-03-31', 'AD', 'Andorra', 'EURO', '6', '376', '4', '12');
INSERT INTO public.who_global_data_import VALUES (1690, '2020-04-01', 'AD', 'Andorra', 'EURO', '20', '396', '1', '13');
INSERT INTO public.who_global_data_import VALUES (1691, '2020-04-02', 'AD', 'Andorra', 'EURO', '0', '396', '0', '13');
INSERT INTO public.who_global_data_import VALUES (1692, '2020-04-03', 'AD', 'Andorra', 'EURO', '33', '429', '2', '15');
INSERT INTO public.who_global_data_import VALUES (1693, '2020-04-04', 'AD', 'Andorra', 'EURO', '13', '442', '1', '16');
INSERT INTO public.who_global_data_import VALUES (1694, '2020-04-05', 'AD', 'Andorra', 'EURO', '24', '466', '1', '17');
INSERT INTO public.who_global_data_import VALUES (1695, '2020-04-06', 'AD', 'Andorra', 'EURO', '57', '523', '0', '17');
INSERT INTO public.who_global_data_import VALUES (1696, '2020-04-07', 'AD', 'Andorra', 'EURO', '17', '540', '4', '21');
INSERT INTO public.who_global_data_import VALUES (1697, '2020-04-08', 'AD', 'Andorra', 'EURO', '11', '551', '1', '22');
INSERT INTO public.who_global_data_import VALUES (1698, '2020-04-09', 'AD', 'Andorra', 'EURO', '15', '566', '2', '24');
INSERT INTO public.who_global_data_import VALUES (1699, '2020-04-10', 'AD', 'Andorra', 'EURO', '23', '589', '2', '26');
INSERT INTO public.who_global_data_import VALUES (1700, '2020-04-11', 'AD', 'Andorra', 'EURO', '13', '602', '0', '26');
INSERT INTO public.who_global_data_import VALUES (1701, '2020-04-12', 'AD', 'Andorra', 'EURO', '20', '622', '2', '28');
INSERT INTO public.who_global_data_import VALUES (1702, '2020-04-13', 'AD', 'Andorra', 'EURO', '17', '639', '1', '29');
INSERT INTO public.who_global_data_import VALUES (1703, '2020-04-14', 'AD', 'Andorra', 'EURO', '12', '651', '0', '29');
INSERT INTO public.who_global_data_import VALUES (1704, '2020-04-15', 'AD', 'Andorra', 'EURO', '8', '659', '2', '31');
INSERT INTO public.who_global_data_import VALUES (1705, '2020-04-16', 'AD', 'Andorra', 'EURO', '14', '673', '2', '33');
INSERT INTO public.who_global_data_import VALUES (1706, '2020-04-17', 'AD', 'Andorra', 'EURO', '21', '694', '1', '34');
INSERT INTO public.who_global_data_import VALUES (1707, '2020-04-18', 'AD', 'Andorra', 'EURO', '9', '703', '1', '35');
INSERT INTO public.who_global_data_import VALUES (1708, '2020-04-19', 'AD', 'Andorra', 'EURO', '1', '704', '0', '35');
INSERT INTO public.who_global_data_import VALUES (1709, '2020-04-20', 'AD', 'Andorra', 'EURO', '13', '717', '1', '36');
INSERT INTO public.who_global_data_import VALUES (1710, '2020-04-21', 'AD', 'Andorra', 'EURO', '1', '718', '0', '36');
INSERT INTO public.who_global_data_import VALUES (1711, '2020-04-22', 'AD', 'Andorra', 'EURO', '5', '723', '1', '37');
INSERT INTO public.who_global_data_import VALUES (1712, '2020-04-23', 'AD', 'Andorra', 'EURO', '1', '724', '0', '37');
INSERT INTO public.who_global_data_import VALUES (1713, '2020-04-24', 'AD', 'Andorra', 'EURO', '2', '726', '1', '38');
INSERT INTO public.who_global_data_import VALUES (1714, '2020-04-25', 'AD', 'Andorra', 'EURO', '7', '733', '2', '40');
INSERT INTO public.who_global_data_import VALUES (1715, '2020-04-26', 'AD', 'Andorra', 'EURO', '5', '738', '0', '40');
INSERT INTO public.who_global_data_import VALUES (1716, '2020-04-27', 'AD', 'Andorra', 'EURO', '2', '740', '0', '40');
INSERT INTO public.who_global_data_import VALUES (1717, '2020-04-28', 'AD', 'Andorra', 'EURO', '1', '741', '1', '41');
INSERT INTO public.who_global_data_import VALUES (1718, '2020-04-29', 'AD', 'Andorra', 'EURO', '1', '742', '1', '42');
INSERT INTO public.who_global_data_import VALUES (1719, '2020-04-30', 'AD', 'Andorra', 'EURO', '2', '744', '0', '42');
INSERT INTO public.who_global_data_import VALUES (1720, '2020-05-01', 'AD', 'Andorra', 'EURO', '2', '746', '0', '42');
INSERT INTO public.who_global_data_import VALUES (1721, '2020-05-02', 'AD', 'Andorra', 'EURO', '0', '746', '1', '43');
INSERT INTO public.who_global_data_import VALUES (1722, '2020-05-03', 'AD', 'Andorra', 'EURO', '1', '747', '1', '44');
INSERT INTO public.who_global_data_import VALUES (1723, '2020-05-04', 'AD', 'Andorra', 'EURO', '2', '749', '1', '45');
INSERT INTO public.who_global_data_import VALUES (1724, '2020-05-05', 'AD', 'Andorra', 'EURO', '2', '751', '0', '45');
INSERT INTO public.who_global_data_import VALUES (1725, '2020-05-06', 'AD', 'Andorra', 'EURO', '0', '751', '1', '46');
INSERT INTO public.who_global_data_import VALUES (1726, '2020-05-07', 'AD', 'Andorra', 'EURO', '1', '752', '1', '47');
INSERT INTO public.who_global_data_import VALUES (1727, '2020-05-08', 'AD', 'Andorra', 'EURO', '0', '752', '0', '47');
INSERT INTO public.who_global_data_import VALUES (1728, '2020-05-09', 'AD', 'Andorra', 'EURO', '2', '754', '0', '47');
INSERT INTO public.who_global_data_import VALUES (1729, '2020-05-10', 'AD', 'Andorra', 'EURO', '0', '754', '1', '48');
INSERT INTO public.who_global_data_import VALUES (1730, '2020-05-11', 'AD', 'Andorra', 'EURO', '2', '756', '0', '48');
INSERT INTO public.who_global_data_import VALUES (1731, '2020-05-12', 'AD', 'Andorra', 'EURO', '0', '756', '0', '48');
INSERT INTO public.who_global_data_import VALUES (1732, '2020-05-13', 'AD', 'Andorra', 'EURO', '3', '759', '0', '48');
INSERT INTO public.who_global_data_import VALUES (1733, '2020-05-14', 'AD', 'Andorra', 'EURO', '2', '761', '1', '49');
INSERT INTO public.who_global_data_import VALUES (1734, '2020-05-15', 'AD', 'Andorra', 'EURO', '0', '761', '0', '49');
INSERT INTO public.who_global_data_import VALUES (1735, '2020-05-16', 'AD', 'Andorra', 'EURO', '0', '761', '0', '49');
INSERT INTO public.who_global_data_import VALUES (1736, '2020-05-17', 'AD', 'Andorra', 'EURO', '0', '761', '2', '51');
INSERT INTO public.who_global_data_import VALUES (1737, '2020-05-18', 'AD', 'Andorra', 'EURO', '0', '761', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1738, '2020-05-19', 'AD', 'Andorra', 'EURO', '0', '761', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1739, '2020-05-20', 'AD', 'Andorra', 'EURO', '0', '761', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1740, '2020-05-21', 'AD', 'Andorra', 'EURO', '1', '762', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1741, '2020-05-22', 'AD', 'Andorra', 'EURO', '0', '762', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1742, '2020-05-23', 'AD', 'Andorra', 'EURO', '0', '762', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1743, '2020-05-24', 'AD', 'Andorra', 'EURO', '1', '763', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1744, '2020-05-25', 'AD', 'Andorra', 'EURO', '0', '763', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1745, '2020-05-26', 'AD', 'Andorra', 'EURO', '0', '763', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1746, '2020-05-27', 'AD', 'Andorra', 'EURO', '0', '763', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1747, '2020-05-28', 'AD', 'Andorra', 'EURO', '0', '763', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1748, '2020-05-29', 'AD', 'Andorra', 'EURO', '1', '764', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1749, '2020-05-30', 'AD', 'Andorra', 'EURO', '0', '764', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1750, '2020-05-31', 'AD', 'Andorra', 'EURO', '0', '764', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1751, '2020-06-01', 'AD', 'Andorra', 'EURO', '0', '764', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1752, '2020-06-02', 'AD', 'Andorra', 'EURO', '1', '765', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1753, '2020-06-03', 'AD', 'Andorra', 'EURO', '79', '844', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1754, '2020-06-04', 'AD', 'Andorra', 'EURO', '7', '851', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1755, '2020-06-05', 'AD', 'Andorra', 'EURO', '1', '852', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1756, '2020-06-06', 'AD', 'Andorra', 'EURO', '0', '852', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1757, '2020-06-07', 'AD', 'Andorra', 'EURO', '0', '852', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1758, '2020-06-08', 'AD', 'Andorra', 'EURO', '0', '852', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1759, '2020-06-09', 'AD', 'Andorra', 'EURO', '0', '852', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1760, '2020-06-10', 'AD', 'Andorra', 'EURO', '0', '852', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1761, '2020-06-11', 'AD', 'Andorra', 'EURO', '0', '852', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1762, '2020-06-12', 'AD', 'Andorra', 'EURO', '0', '852', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1763, '2020-06-13', 'AD', 'Andorra', 'EURO', '1', '853', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1764, '2020-06-14', 'AD', 'Andorra', 'EURO', '0', '853', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1765, '2020-06-15', 'AD', 'Andorra', 'EURO', '0', '853', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1766, '2020-06-16', 'AD', 'Andorra', 'EURO', '0', '853', '0', '51');
INSERT INTO public.who_global_data_import VALUES (1767, '2020-06-17', 'AD', 'Andorra', 'EURO', '1', '854', '1', '52');
INSERT INTO public.who_global_data_import VALUES (1768, '2020-06-18', 'AD', 'Andorra', 'EURO', '0', '854', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1769, '2020-06-19', 'AD', 'Andorra', 'EURO', '1', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1770, '2020-06-20', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1771, '2020-06-21', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1772, '2020-06-22', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1773, '2020-06-23', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1774, '2020-06-24', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1775, '2020-06-25', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1776, '2020-06-26', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1777, '2020-06-27', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1778, '2020-06-28', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1779, '2020-06-29', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1780, '2020-06-30', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1781, '2020-07-01', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1782, '2020-07-02', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1783, '2020-07-03', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1784, '2020-07-04', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1785, '2020-07-05', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1786, '2020-07-06', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1787, '2020-07-07', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1788, '2020-07-08', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1789, '2020-07-09', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1790, '2020-07-10', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1791, '2020-07-11', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1792, '2020-07-12', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1793, '2020-07-13', 'AD', 'Andorra', 'EURO', '0', '855', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1794, '2020-07-14', 'AD', 'Andorra', 'EURO', '3', '858', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1795, '2020-07-15', 'AD', 'Andorra', 'EURO', '3', '861', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1796, '2020-07-16', 'AD', 'Andorra', 'EURO', '1', '862', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1797, '2020-07-17', 'AD', 'Andorra', 'EURO', '15', '877', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1798, '2020-07-18', 'AD', 'Andorra', 'EURO', '3', '880', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1799, '2020-07-19', 'AD', 'Andorra', 'EURO', '0', '880', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1800, '2020-07-20', 'AD', 'Andorra', 'EURO', '0', '880', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1801, '2020-07-21', 'AD', 'Andorra', 'EURO', '4', '884', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1802, '2020-07-22', 'AD', 'Andorra', 'EURO', '0', '884', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1803, '2020-07-23', 'AD', 'Andorra', 'EURO', '5', '889', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1804, '2020-07-24', 'AD', 'Andorra', 'EURO', '0', '889', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1805, '2020-07-25', 'AD', 'Andorra', 'EURO', '8', '897', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1806, '2020-07-26', 'AD', 'Andorra', 'EURO', '0', '897', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1807, '2020-07-27', 'AD', 'Andorra', 'EURO', '7', '904', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1808, '2020-07-28', 'AD', 'Andorra', 'EURO', '3', '907', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1809, '2020-07-29', 'AD', 'Andorra', 'EURO', '4', '911', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1810, '2020-07-30', 'AD', 'Andorra', 'EURO', '7', '918', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1811, '2020-07-31', 'AD', 'Andorra', 'EURO', '4', '922', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1812, '2020-08-01', 'AD', 'Andorra', 'EURO', '3', '925', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1813, '2020-08-02', 'AD', 'Andorra', 'EURO', '5', '930', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1814, '2020-08-03', 'AD', 'Andorra', 'EURO', '6', '936', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1815, '2020-08-04', 'AD', 'Andorra', 'EURO', '1', '937', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1816, '2020-08-05', 'AD', 'Andorra', 'EURO', '2', '939', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1817, '2020-08-06', 'AD', 'Andorra', 'EURO', '0', '939', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1818, '2020-08-07', 'AD', 'Andorra', 'EURO', '6', '945', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1819, '2020-08-08', 'AD', 'Andorra', 'EURO', '11', '956', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1820, '2020-08-09', 'AD', 'Andorra', 'EURO', '0', '956', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1821, '2020-08-10', 'AD', 'Andorra', 'EURO', '0', '956', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1822, '2020-08-11', 'AD', 'Andorra', 'EURO', '7', '963', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1823, '2020-08-12', 'AD', 'Andorra', 'EURO', '10', '973', '0', '52');
INSERT INTO public.who_global_data_import VALUES (1824, '2020-08-13', 'AD', 'Andorra', 'EURO', '4', '977', '1', '53');
INSERT INTO public.who_global_data_import VALUES (1825, '2020-08-14', 'AD', 'Andorra', 'EURO', '4', '981', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1826, '2020-08-15', 'AD', 'Andorra', 'EURO', '8', '989', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1827, '2020-08-16', 'AD', 'Andorra', 'EURO', '8', '997', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1828, '2020-08-17', 'AD', 'Andorra', 'EURO', '0', '997', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1829, '2020-08-18', 'AD', 'Andorra', 'EURO', '8', '1005', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1830, '2020-08-19', 'AD', 'Andorra', 'EURO', '7', '1012', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1831, '2020-08-20', 'AD', 'Andorra', 'EURO', '12', '1024', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1832, '2020-08-21', 'AD', 'Andorra', 'EURO', '12', '1036', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1833, '2020-08-22', 'AD', 'Andorra', 'EURO', '11', '1047', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1834, '2020-08-23', 'AD', 'Andorra', 'EURO', '0', '1047', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1835, '2020-08-24', 'AD', 'Andorra', 'EURO', '0', '1047', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1836, '2020-08-25', 'AD', 'Andorra', 'EURO', '13', '1060', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1837, '2020-08-26', 'AD', 'Andorra', 'EURO', '0', '1060', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1838, '2020-08-27', 'AD', 'Andorra', 'EURO', '38', '1098', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1839, '2020-08-28', 'AD', 'Andorra', 'EURO', '13', '1111', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1840, '2020-08-29', 'AD', 'Andorra', 'EURO', '13', '1124', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1841, '2020-08-30', 'AD', 'Andorra', 'EURO', '0', '1124', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1842, '2020-08-31', 'AD', 'Andorra', 'EURO', '0', '1124', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1843, '2020-09-01', 'AD', 'Andorra', 'EURO', '52', '1176', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1844, '2020-09-02', 'AD', 'Andorra', 'EURO', '8', '1184', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1845, '2020-09-03', 'AD', 'Andorra', 'EURO', '15', '1199', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1846, '2020-09-04', 'AD', 'Andorra', 'EURO', '9', '1208', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1847, '2020-09-05', 'AD', 'Andorra', 'EURO', '7', '1215', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1848, '2020-09-06', 'AD', 'Andorra', 'EURO', '0', '1215', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1849, '2020-09-07', 'AD', 'Andorra', 'EURO', '0', '1215', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1850, '2020-09-08', 'AD', 'Andorra', 'EURO', '46', '1261', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1851, '2020-09-09', 'AD', 'Andorra', 'EURO', '0', '1261', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1852, '2020-09-10', 'AD', 'Andorra', 'EURO', '40', '1301', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1853, '2020-09-11', 'AD', 'Andorra', 'EURO', '0', '1301', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1854, '2020-09-12', 'AD', 'Andorra', 'EURO', '43', '1344', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1855, '2020-09-13', 'AD', 'Andorra', 'EURO', '0', '1344', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1856, '2020-09-14', 'AD', 'Andorra', 'EURO', '0', '1344', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1857, '2020-09-15', 'AD', 'Andorra', 'EURO', '94', '1438', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1858, '2020-09-16', 'AD', 'Andorra', 'EURO', '0', '1438', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1859, '2020-09-17', 'AD', 'Andorra', 'EURO', '45', '1483', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1860, '2020-09-18', 'AD', 'Andorra', 'EURO', '0', '1483', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1861, '2020-09-19', 'AD', 'Andorra', 'EURO', '81', '1564', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1862, '2020-09-20', 'AD', 'Andorra', 'EURO', '0', '1564', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1863, '2020-09-21', 'AD', 'Andorra', 'EURO', '0', '1564', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1864, '2020-09-22', 'AD', 'Andorra', 'EURO', '117', '1681', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1865, '2020-09-23', 'AD', 'Andorra', 'EURO', '0', '1681', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1866, '2020-09-24', 'AD', 'Andorra', 'EURO', '72', '1753', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1867, '2020-09-25', 'AD', 'Andorra', 'EURO', '0', '1753', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1868, '2020-09-26', 'AD', 'Andorra', 'EURO', '83', '1836', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1869, '2020-09-27', 'AD', 'Andorra', 'EURO', '0', '1836', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1870, '2020-09-28', 'AD', 'Andorra', 'EURO', '0', '1836', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1871, '2020-09-29', 'AD', 'Andorra', 'EURO', '130', '1966', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1872, '2020-09-30', 'AD', 'Andorra', 'EURO', '0', '1966', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1873, '2020-10-01', 'AD', 'Andorra', 'EURO', '84', '2050', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1874, '2020-10-02', 'AD', 'Andorra', 'EURO', '0', '2050', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1875, '2020-10-03', 'AD', 'Andorra', 'EURO', '60', '2110', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1876, '2020-10-04', 'AD', 'Andorra', 'EURO', '0', '2110', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1877, '2020-10-05', 'AD', 'Andorra', 'EURO', '0', '2110', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1878, '2020-10-06', 'AD', 'Andorra', 'EURO', '260', '2370', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1879, '2020-10-07', 'AD', 'Andorra', 'EURO', '0', '2370', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1880, '2020-10-08', 'AD', 'Andorra', 'EURO', '198', '2568', '0', '53');
INSERT INTO public.who_global_data_import VALUES (1881, '2020-10-09', 'AD', 'Andorra', 'EURO', '0', '2568', '1', '54');
INSERT INTO public.who_global_data_import VALUES (1882, '2020-10-10', 'AD', 'Andorra', 'EURO', '128', '2696', '1', '55');
INSERT INTO public.who_global_data_import VALUES (1883, '2020-10-11', 'AD', 'Andorra', 'EURO', '0', '2696', '0', '55');
INSERT INTO public.who_global_data_import VALUES (1884, '2020-10-12', 'AD', 'Andorra', 'EURO', '0', '2696', '0', '55');
INSERT INTO public.who_global_data_import VALUES (1885, '2020-10-13', 'AD', 'Andorra', 'EURO', '299', '2995', '2', '57');
INSERT INTO public.who_global_data_import VALUES (1886, '2020-10-14', 'AD', 'Andorra', 'EURO', '0', '2995', '0', '57');
INSERT INTO public.who_global_data_import VALUES (1887, '2020-10-15', 'AD', 'Andorra', 'EURO', '195', '3190', '2', '59');
INSERT INTO public.who_global_data_import VALUES (1888, '2020-10-16', 'AD', 'Andorra', 'EURO', '0', '3190', '0', '59');
INSERT INTO public.who_global_data_import VALUES (1889, '2020-10-17', 'AD', 'Andorra', 'EURO', '187', '3377', '0', '59');
INSERT INTO public.who_global_data_import VALUES (1890, '2020-10-18', 'AD', 'Andorra', 'EURO', '0', '3377', '0', '59');
INSERT INTO public.who_global_data_import VALUES (1891, '2020-10-19', 'AD', 'Andorra', 'EURO', '0', '3377', '0', '59');
INSERT INTO public.who_global_data_import VALUES (1892, '2020-10-20', 'AD', 'Andorra', 'EURO', '246', '3623', '3', '62');
INSERT INTO public.who_global_data_import VALUES (1893, '2020-10-21', 'AD', 'Andorra', 'EURO', '0', '3623', '0', '62');
INSERT INTO public.who_global_data_import VALUES (1894, '2020-10-22', 'AD', 'Andorra', 'EURO', '188', '3811', '1', '63');
INSERT INTO public.who_global_data_import VALUES (1895, '2020-10-23', 'AD', 'Andorra', 'EURO', '0', '3811', '0', '63');
INSERT INTO public.who_global_data_import VALUES (1896, '2020-10-24', 'AD', 'Andorra', 'EURO', '227', '4038', '6', '69');
INSERT INTO public.who_global_data_import VALUES (1897, '2020-10-25', 'AD', 'Andorra', 'EURO', '0', '4038', '0', '69');
INSERT INTO public.who_global_data_import VALUES (1898, '2020-10-26', 'AD', 'Andorra', 'EURO', '0', '4038', '0', '69');
INSERT INTO public.who_global_data_import VALUES (1899, '2020-10-27', 'AD', 'Andorra', 'EURO', '287', '4325', '3', '72');
INSERT INTO public.who_global_data_import VALUES (1900, '2020-10-28', 'AD', 'Andorra', 'EURO', '85', '4410', '0', '72');
INSERT INTO public.who_global_data_import VALUES (1901, '2020-10-29', 'AD', 'Andorra', 'EURO', '107', '4517', '0', '72');
INSERT INTO public.who_global_data_import VALUES (1902, '2020-10-30', 'AD', 'Andorra', 'EURO', '50', '4567', '1', '73');
INSERT INTO public.who_global_data_import VALUES (1903, '2020-10-31', 'AD', 'Andorra', 'EURO', '98', '4665', '2', '75');
INSERT INTO public.who_global_data_import VALUES (1904, '2020-11-01', 'AD', 'Andorra', 'EURO', '91', '4756', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1905, '2020-11-02', 'AD', 'Andorra', 'EURO', '69', '4825', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1906, '2020-11-03', 'AD', 'Andorra', 'EURO', '63', '4888', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1907, '2020-11-04', 'AD', 'Andorra', 'EURO', '22', '4910', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1908, '2020-11-05', 'AD', 'Andorra', 'EURO', '135', '5045', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1909, '2020-11-06', 'AD', 'Andorra', 'EURO', '90', '5135', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1910, '2020-11-07', 'AD', 'Andorra', 'EURO', '0', '5135', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1911, '2020-11-08', 'AD', 'Andorra', 'EURO', '184', '5319', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1912, '2020-11-09', 'AD', 'Andorra', 'EURO', '64', '5383', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1913, '2020-11-10', 'AD', 'Andorra', 'EURO', '54', '5437', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1914, '2020-11-11', 'AD', 'Andorra', 'EURO', '40', '5477', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1915, '2020-11-12', 'AD', 'Andorra', 'EURO', '90', '5567', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1916, '2020-11-13', 'AD', 'Andorra', 'EURO', '49', '5616', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1917, '2020-11-14', 'AD', 'Andorra', 'EURO', '109', '5725', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1918, '2020-11-15', 'AD', 'Andorra', 'EURO', '0', '5725', '0', '75');
INSERT INTO public.who_global_data_import VALUES (1919, '2020-11-16', 'AD', 'Andorra', 'EURO', '147', '5872', '1', '76');
INSERT INTO public.who_global_data_import VALUES (1920, '2020-11-17', 'AD', 'Andorra', 'EURO', '42', '5914', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1921, '2020-11-18', 'AD', 'Andorra', 'EURO', '37', '5951', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1922, '2020-11-19', 'AD', 'Andorra', 'EURO', '67', '6018', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1923, '2020-11-20', 'AD', 'Andorra', 'EURO', '48', '6066', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1924, '2020-11-21', 'AD', 'Andorra', 'EURO', '76', '6142', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1925, '2020-11-22', 'AD', 'Andorra', 'EURO', '65', '6207', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1926, '2020-11-23', 'AD', 'Andorra', 'EURO', '49', '6256', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1927, '2020-11-24', 'AD', 'Andorra', 'EURO', '48', '6304', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1928, '2020-11-25', 'AD', 'Andorra', 'EURO', '47', '6351', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1929, '2020-11-26', 'AD', 'Andorra', 'EURO', '77', '6428', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1930, '2020-11-27', 'AD', 'Andorra', 'EURO', '106', '6534', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1931, '2020-11-28', 'AD', 'Andorra', 'EURO', '76', '6610', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1932, '2020-11-29', 'AD', 'Andorra', 'EURO', '0', '6610', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1933, '2020-11-30', 'AD', 'Andorra', 'EURO', '102', '6712', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1934, '2020-12-01', 'AD', 'Andorra', 'EURO', '33', '6745', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1935, '2020-12-02', 'AD', 'Andorra', 'EURO', '45', '6790', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1936, '2020-12-03', 'AD', 'Andorra', 'EURO', '52', '6842', '0', '76');
INSERT INTO public.who_global_data_import VALUES (1937, '2020-12-04', 'AD', 'Andorra', 'EURO', '62', '6904', '1', '77');
INSERT INTO public.who_global_data_import VALUES (1938, '2020-12-05', 'AD', 'Andorra', 'EURO', '51', '6955', '0', '77');
INSERT INTO public.who_global_data_import VALUES (1939, '2020-12-06', 'AD', 'Andorra', 'EURO', '50', '7005', '1', '78');
INSERT INTO public.who_global_data_import VALUES (1940, '2020-12-07', 'AD', 'Andorra', 'EURO', '45', '7050', '0', '78');
INSERT INTO public.who_global_data_import VALUES (1941, '2020-12-08', 'AD', 'Andorra', 'EURO', '34', '7084', '0', '78');
INSERT INTO public.who_global_data_import VALUES (1942, '2020-12-09', 'AD', 'Andorra', 'EURO', '43', '7127', '0', '78');
INSERT INTO public.who_global_data_import VALUES (1943, '2020-12-10', 'AD', 'Andorra', 'EURO', '35', '7162', '0', '78');
INSERT INTO public.who_global_data_import VALUES (1944, '2020-12-11', 'AD', 'Andorra', 'EURO', '28', '7190', '0', '78');
INSERT INTO public.who_global_data_import VALUES (1945, '2020-12-12', 'AD', 'Andorra', 'EURO', '46', '7236', '0', '78');
INSERT INTO public.who_global_data_import VALUES (1946, '2020-12-13', 'AD', 'Andorra', 'EURO', '52', '7288', '0', '78');
INSERT INTO public.who_global_data_import VALUES (1947, '2020-12-14', 'AD', 'Andorra', 'EURO', '50', '7338', '1', '79');
INSERT INTO public.who_global_data_import VALUES (1948, '2020-12-15', 'AD', 'Andorra', 'EURO', '44', '7382', '0', '79');
INSERT INTO public.who_global_data_import VALUES (1949, '2020-12-16', 'AD', 'Andorra', 'EURO', '32', '7414', '0', '79');
INSERT INTO public.who_global_data_import VALUES (1950, '2020-12-17', 'AD', 'Andorra', 'EURO', '32', '7446', '0', '79');
INSERT INTO public.who_global_data_import VALUES (1951, '2020-12-18', 'AD', 'Andorra', 'EURO', '20', '7466', '0', '79');
INSERT INTO public.who_global_data_import VALUES (1952, '2020-12-19', 'AD', 'Andorra', 'EURO', '53', '7519', '1', '80');
INSERT INTO public.who_global_data_import VALUES (1953, '2020-12-20', 'AD', 'Andorra', 'EURO', '41', '7560', '0', '80');
INSERT INTO public.who_global_data_import VALUES (1954, '2020-12-21', 'AD', 'Andorra', 'EURO', '17', '7577', '1', '81');
INSERT INTO public.who_global_data_import VALUES (1955, '2020-12-22', 'AD', 'Andorra', 'EURO', '25', '7602', '0', '81');
INSERT INTO public.who_global_data_import VALUES (1956, '2020-12-23', 'AD', 'Andorra', 'EURO', '31', '7633', '1', '82');
INSERT INTO public.who_global_data_import VALUES (1957, '2020-12-24', 'AD', 'Andorra', 'EURO', '36', '7669', '0', '82');
INSERT INTO public.who_global_data_import VALUES (1958, '2020-12-25', 'AD', 'Andorra', 'EURO', '30', '7699', '1', '83');
INSERT INTO public.who_global_data_import VALUES (1959, '2020-12-26', 'AD', 'Andorra', 'EURO', '57', '7756', '0', '83');
INSERT INTO public.who_global_data_import VALUES (1960, '2020-12-27', 'AD', 'Andorra', 'EURO', '50', '7806', '0', '83');
INSERT INTO public.who_global_data_import VALUES (1961, '2020-12-28', 'AD', 'Andorra', 'EURO', '15', '7821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (1962, '2020-12-29', 'AD', 'Andorra', 'EURO', '54', '7875', '0', '83');
INSERT INTO public.who_global_data_import VALUES (1963, '2020-12-30', 'AD', 'Andorra', 'EURO', '44', '7919', '1', '84');
INSERT INTO public.who_global_data_import VALUES (1964, '2020-12-31', 'AD', 'Andorra', 'EURO', '64', '7983', '0', '84');
INSERT INTO public.who_global_data_import VALUES (1965, '2021-01-01', 'AD', 'Andorra', 'EURO', '66', '8049', '0', '84');
INSERT INTO public.who_global_data_import VALUES (1966, '2021-01-02', 'AD', 'Andorra', 'EURO', '68', '8117', '0', '84');
INSERT INTO public.who_global_data_import VALUES (1967, '2021-01-03', 'AD', 'Andorra', 'EURO', '49', '8166', '0', '84');
INSERT INTO public.who_global_data_import VALUES (1968, '2021-01-04', 'AD', 'Andorra', 'EURO', '26', '8192', '0', '84');
INSERT INTO public.who_global_data_import VALUES (1969, '2021-01-05', 'AD', 'Andorra', 'EURO', '57', '8249', '0', '84');
INSERT INTO public.who_global_data_import VALUES (1970, '2021-01-06', 'AD', 'Andorra', 'EURO', '59', '8308', '0', '84');
INSERT INTO public.who_global_data_import VALUES (1971, '2021-01-07', 'AD', 'Andorra', 'EURO', '40', '8348', '0', '84');
INSERT INTO public.who_global_data_import VALUES (1972, '2021-01-08', 'AD', 'Andorra', 'EURO', '0', '8348', '0', '84');
INSERT INTO public.who_global_data_import VALUES (1973, '2021-01-09', 'AD', 'Andorra', 'EURO', '141', '8489', '0', '84');
INSERT INTO public.who_global_data_import VALUES (1974, '2021-01-10', 'AD', 'Andorra', 'EURO', '97', '8586', '1', '85');
INSERT INTO public.who_global_data_import VALUES (1975, '2021-01-11', 'AD', 'Andorra', 'EURO', '0', '8586', '0', '85');
INSERT INTO public.who_global_data_import VALUES (1976, '2021-01-12', 'AD', 'Andorra', 'EURO', '96', '8682', '1', '86');
INSERT INTO public.who_global_data_import VALUES (1977, '2021-01-13', 'AD', 'Andorra', 'EURO', '63', '8745', '1', '87');
INSERT INTO public.who_global_data_import VALUES (1978, '2021-01-14', 'AD', 'Andorra', 'EURO', '73', '8818', '0', '87');
INSERT INTO public.who_global_data_import VALUES (1979, '2021-01-15', 'AD', 'Andorra', 'EURO', '50', '8868', '1', '88');
INSERT INTO public.who_global_data_import VALUES (1980, '2021-01-16', 'AD', 'Andorra', 'EURO', '78', '8946', '0', '88');
INSERT INTO public.who_global_data_import VALUES (1981, '2021-01-17', 'AD', 'Andorra', 'EURO', '92', '9038', '3', '91');
INSERT INTO public.who_global_data_import VALUES (1982, '2021-01-18', 'AD', 'Andorra', 'EURO', '0', '9038', '0', '91');
INSERT INTO public.who_global_data_import VALUES (1983, '2021-01-19', 'AD', 'Andorra', 'EURO', '45', '9083', '0', '91');
INSERT INTO public.who_global_data_import VALUES (1984, '2021-01-20', 'AD', 'Andorra', 'EURO', '111', '9194', '1', '92');
INSERT INTO public.who_global_data_import VALUES (1985, '2021-01-21', 'AD', 'Andorra', 'EURO', '114', '9308', '0', '92');
INSERT INTO public.who_global_data_import VALUES (1986, '2021-01-22', 'AD', 'Andorra', 'EURO', '71', '9379', '1', '93');
INSERT INTO public.who_global_data_import VALUES (1987, '2021-01-23', 'AD', 'Andorra', 'EURO', '37', '9416', '0', '93');
INSERT INTO public.who_global_data_import VALUES (1988, '2021-01-24', 'AD', 'Andorra', 'EURO', '83', '9499', '3', '96');
INSERT INTO public.who_global_data_import VALUES (1989, '2021-01-25', 'AD', 'Andorra', 'EURO', '50', '9549', '0', '96');
INSERT INTO public.who_global_data_import VALUES (1990, '2021-01-26', 'AD', 'Andorra', 'EURO', '47', '9596', '1', '97');
INSERT INTO public.who_global_data_import VALUES (1991, '2021-01-27', 'AD', 'Andorra', 'EURO', '42', '9638', '0', '97');
INSERT INTO public.who_global_data_import VALUES (1992, '2021-01-28', 'AD', 'Andorra', 'EURO', '78', '9716', '1', '98');
INSERT INTO public.who_global_data_import VALUES (1993, '2021-01-29', 'AD', 'Andorra', 'EURO', '63', '9779', '2', '100');
INSERT INTO public.who_global_data_import VALUES (1994, '2021-01-30', 'AD', 'Andorra', 'EURO', '58', '9837', '0', '100');
INSERT INTO public.who_global_data_import VALUES (1995, '2021-01-31', 'AD', 'Andorra', 'EURO', '48', '9885', '1', '101');
INSERT INTO public.who_global_data_import VALUES (1996, '2021-02-01', 'AD', 'Andorra', 'EURO', '52', '9937', '0', '101');
INSERT INTO public.who_global_data_import VALUES (1997, '2021-02-02', 'AD', 'Andorra', 'EURO', '35', '9972', '0', '101');
INSERT INTO public.who_global_data_import VALUES (1998, '2021-02-03', 'AD', 'Andorra', 'EURO', '45', '10017', '1', '102');
INSERT INTO public.who_global_data_import VALUES (1999, '2021-02-04', 'AD', 'Andorra', 'EURO', '53', '10070', '1', '103');
INSERT INTO public.who_global_data_import VALUES (2000, '2021-02-05', 'AD', 'Andorra', 'EURO', '67', '10137', '0', '103');
INSERT INTO public.who_global_data_import VALUES (2001, '2020-01-03', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2002, '2020-01-04', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2003, '2020-01-05', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2004, '2020-01-06', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2005, '2020-01-07', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2006, '2020-01-08', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2007, '2020-01-09', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2008, '2020-01-10', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2009, '2020-01-11', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2010, '2020-01-12', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2011, '2020-01-13', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2012, '2020-01-14', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2013, '2020-01-15', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2014, '2020-01-16', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2015, '2020-01-17', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2016, '2020-01-18', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2017, '2020-01-19', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2018, '2020-01-20', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2019, '2020-01-21', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2020, '2020-01-22', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2021, '2020-01-23', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2022, '2020-01-24', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2023, '2020-01-25', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2024, '2020-01-26', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2025, '2020-01-27', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2026, '2020-01-28', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2027, '2020-01-29', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2028, '2020-01-30', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2029, '2020-01-31', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2030, '2020-02-01', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2031, '2020-02-02', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2032, '2020-02-03', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2033, '2020-02-04', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2034, '2020-02-05', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2035, '2020-02-06', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2036, '2020-02-07', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2037, '2020-02-08', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2038, '2020-02-09', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2039, '2020-02-10', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2040, '2020-02-11', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2041, '2020-02-12', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2042, '2020-02-13', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2043, '2020-02-14', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2044, '2020-02-15', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2045, '2020-02-16', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2046, '2020-02-17', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2047, '2020-02-18', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2048, '2020-02-19', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2049, '2020-02-20', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2050, '2020-02-21', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2051, '2020-02-22', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2052, '2020-02-23', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2053, '2020-02-24', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2054, '2020-02-25', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2055, '2020-02-26', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2056, '2020-02-27', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2057, '2020-02-28', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2058, '2020-02-29', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2059, '2020-03-01', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2060, '2020-03-02', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2061, '2020-03-03', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2062, '2020-03-04', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2063, '2020-03-05', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2064, '2020-03-06', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2065, '2020-03-07', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2066, '2020-03-08', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2067, '2020-03-09', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2068, '2020-03-10', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2069, '2020-03-11', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2070, '2020-03-12', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2071, '2020-03-13', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2072, '2020-03-14', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2073, '2020-03-15', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2074, '2020-03-16', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2075, '2020-03-17', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2076, '2020-03-18', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2077, '2020-03-19', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2078, '2020-03-20', 'AO', 'Angola', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2079, '2020-03-21', 'AO', 'Angola', 'AFRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2080, '2020-03-22', 'AO', 'Angola', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2081, '2020-03-23', 'AO', 'Angola', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2082, '2020-03-24', 'AO', 'Angola', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2083, '2020-03-25', 'AO', 'Angola', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2084, '2020-03-26', 'AO', 'Angola', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2085, '2020-03-27', 'AO', 'Angola', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2086, '2020-03-28', 'AO', 'Angola', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2087, '2020-03-29', 'AO', 'Angola', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2088, '2020-03-30', 'AO', 'Angola', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2089, '2020-03-31', 'AO', 'Angola', 'AFRO', '5', '7', '1', '1');
INSERT INTO public.who_global_data_import VALUES (2090, '2020-04-01', 'AO', 'Angola', 'AFRO', '0', '7', '1', '2');
INSERT INTO public.who_global_data_import VALUES (2091, '2020-04-02', 'AO', 'Angola', 'AFRO', '1', '8', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2092, '2020-04-03', 'AO', 'Angola', 'AFRO', '0', '8', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2093, '2020-04-04', 'AO', 'Angola', 'AFRO', '2', '10', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2094, '2020-04-05', 'AO', 'Angola', 'AFRO', '0', '10', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2095, '2020-04-06', 'AO', 'Angola', 'AFRO', '4', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2096, '2020-04-07', 'AO', 'Angola', 'AFRO', '2', '16', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2097, '2020-04-08', 'AO', 'Angola', 'AFRO', '1', '17', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2098, '2020-04-09', 'AO', 'Angola', 'AFRO', '2', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2099, '2020-04-10', 'AO', 'Angola', 'AFRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2100, '2020-04-11', 'AO', 'Angola', 'AFRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2101, '2020-04-12', 'AO', 'Angola', 'AFRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2102, '2020-04-13', 'AO', 'Angola', 'AFRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2103, '2020-04-14', 'AO', 'Angola', 'AFRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2104, '2020-04-15', 'AO', 'Angola', 'AFRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2105, '2020-04-16', 'AO', 'Angola', 'AFRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2106, '2020-04-17', 'AO', 'Angola', 'AFRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2107, '2020-04-18', 'AO', 'Angola', 'AFRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2108, '2020-04-19', 'AO', 'Angola', 'AFRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2109, '2020-04-20', 'AO', 'Angola', 'AFRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2110, '2020-04-21', 'AO', 'Angola', 'AFRO', '5', '24', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2111, '2020-04-22', 'AO', 'Angola', 'AFRO', '0', '24', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2112, '2020-04-23', 'AO', 'Angola', 'AFRO', '0', '24', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2113, '2020-04-24', 'AO', 'Angola', 'AFRO', '1', '25', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2114, '2020-04-25', 'AO', 'Angola', 'AFRO', '0', '25', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2115, '2020-04-26', 'AO', 'Angola', 'AFRO', '0', '25', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2116, '2020-04-27', 'AO', 'Angola', 'AFRO', '1', '26', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2117, '2020-04-28', 'AO', 'Angola', 'AFRO', '1', '27', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2118, '2020-04-29', 'AO', 'Angola', 'AFRO', '0', '27', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2119, '2020-04-30', 'AO', 'Angola', 'AFRO', '0', '27', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2120, '2020-05-01', 'AO', 'Angola', 'AFRO', '0', '27', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2121, '2020-05-02', 'AO', 'Angola', 'AFRO', '2', '29', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2122, '2020-05-03', 'AO', 'Angola', 'AFRO', '6', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2123, '2020-05-04', 'AO', 'Angola', 'AFRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2124, '2020-05-05', 'AO', 'Angola', 'AFRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2125, '2020-05-06', 'AO', 'Angola', 'AFRO', '1', '36', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2126, '2020-05-07', 'AO', 'Angola', 'AFRO', '0', '36', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2127, '2020-05-08', 'AO', 'Angola', 'AFRO', '0', '36', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2128, '2020-05-09', 'AO', 'Angola', 'AFRO', '0', '36', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2129, '2020-05-10', 'AO', 'Angola', 'AFRO', '7', '43', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2130, '2020-05-11', 'AO', 'Angola', 'AFRO', '2', '45', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2131, '2020-05-12', 'AO', 'Angola', 'AFRO', '0', '45', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2132, '2020-05-13', 'AO', 'Angola', 'AFRO', '0', '45', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2133, '2020-05-14', 'AO', 'Angola', 'AFRO', '0', '45', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2134, '2020-05-15', 'AO', 'Angola', 'AFRO', '3', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2135, '2020-05-16', 'AO', 'Angola', 'AFRO', '0', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2136, '2020-05-17', 'AO', 'Angola', 'AFRO', '0', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2137, '2020-05-18', 'AO', 'Angola', 'AFRO', '0', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2138, '2020-05-19', 'AO', 'Angola', 'AFRO', '2', '50', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2139, '2020-05-20', 'AO', 'Angola', 'AFRO', '2', '52', '1', '3');
INSERT INTO public.who_global_data_import VALUES (2140, '2020-05-21', 'AO', 'Angola', 'AFRO', '6', '58', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2141, '2020-05-22', 'AO', 'Angola', 'AFRO', '2', '60', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2142, '2020-05-23', 'AO', 'Angola', 'AFRO', '0', '60', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2143, '2020-05-24', 'AO', 'Angola', 'AFRO', '0', '60', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2144, '2020-05-25', 'AO', 'Angola', 'AFRO', '9', '69', '1', '4');
INSERT INTO public.who_global_data_import VALUES (2145, '2020-05-26', 'AO', 'Angola', 'AFRO', '0', '69', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2146, '2020-05-27', 'AO', 'Angola', 'AFRO', '2', '71', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2147, '2020-05-28', 'AO', 'Angola', 'AFRO', '0', '71', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2148, '2020-05-29', 'AO', 'Angola', 'AFRO', '2', '73', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2149, '2020-05-30', 'AO', 'Angola', 'AFRO', '8', '81', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2150, '2020-05-31', 'AO', 'Angola', 'AFRO', '3', '84', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2151, '2020-06-01', 'AO', 'Angola', 'AFRO', '2', '86', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2152, '2020-06-02', 'AO', 'Angola', 'AFRO', '0', '86', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2153, '2020-06-03', 'AO', 'Angola', 'AFRO', '0', '86', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2154, '2020-06-04', 'AO', 'Angola', 'AFRO', '0', '86', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2155, '2020-06-05', 'AO', 'Angola', 'AFRO', '0', '86', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2156, '2020-06-06', 'AO', 'Angola', 'AFRO', '0', '86', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2157, '2020-06-07', 'AO', 'Angola', 'AFRO', '0', '86', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2158, '2020-06-08', 'AO', 'Angola', 'AFRO', '5', '91', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2159, '2020-06-09', 'AO', 'Angola', 'AFRO', '1', '92', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2160, '2020-06-10', 'AO', 'Angola', 'AFRO', '4', '96', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2161, '2020-06-11', 'AO', 'Angola', 'AFRO', '17', '113', '0', '4');
INSERT INTO public.who_global_data_import VALUES (2162, '2020-06-12', 'AO', 'Angola', 'AFRO', '5', '118', '1', '5');
INSERT INTO public.who_global_data_import VALUES (2163, '2020-06-13', 'AO', 'Angola', 'AFRO', '12', '130', '0', '5');
INSERT INTO public.who_global_data_import VALUES (2164, '2020-06-14', 'AO', 'Angola', 'AFRO', '8', '138', '1', '6');
INSERT INTO public.who_global_data_import VALUES (2165, '2020-06-15', 'AO', 'Angola', 'AFRO', '2', '140', '0', '6');
INSERT INTO public.who_global_data_import VALUES (2166, '2020-06-16', 'AO', 'Angola', 'AFRO', '2', '142', '0', '6');
INSERT INTO public.who_global_data_import VALUES (2167, '2020-06-17', 'AO', 'Angola', 'AFRO', '0', '142', '0', '6');
INSERT INTO public.who_global_data_import VALUES (2168, '2020-06-18', 'AO', 'Angola', 'AFRO', '13', '155', '1', '7');
INSERT INTO public.who_global_data_import VALUES (2169, '2020-06-19', 'AO', 'Angola', 'AFRO', '11', '166', '1', '8');
INSERT INTO public.who_global_data_import VALUES (2170, '2020-06-20', 'AO', 'Angola', 'AFRO', '0', '166', '0', '8');
INSERT INTO public.who_global_data_import VALUES (2171, '2020-06-21', 'AO', 'Angola', 'AFRO', '6', '172', '0', '8');
INSERT INTO public.who_global_data_import VALUES (2172, '2020-06-22', 'AO', 'Angola', 'AFRO', '4', '176', '1', '9');
INSERT INTO public.who_global_data_import VALUES (2173, '2020-06-23', 'AO', 'Angola', 'AFRO', '7', '183', '0', '9');
INSERT INTO public.who_global_data_import VALUES (2174, '2020-06-24', 'AO', 'Angola', 'AFRO', '6', '189', '1', '10');
INSERT INTO public.who_global_data_import VALUES (2175, '2020-06-25', 'AO', 'Angola', 'AFRO', '8', '197', '0', '10');
INSERT INTO public.who_global_data_import VALUES (2176, '2020-06-26', 'AO', 'Angola', 'AFRO', '15', '212', '0', '10');
INSERT INTO public.who_global_data_import VALUES (2177, '2020-06-27', 'AO', 'Angola', 'AFRO', '0', '212', '0', '10');
INSERT INTO public.who_global_data_import VALUES (2178, '2020-06-28', 'AO', 'Angola', 'AFRO', '47', '259', '0', '10');
INSERT INTO public.who_global_data_import VALUES (2179, '2020-06-29', 'AO', 'Angola', 'AFRO', '8', '267', '1', '11');
INSERT INTO public.who_global_data_import VALUES (2180, '2020-06-30', 'AO', 'Angola', 'AFRO', '9', '276', '0', '11');
INSERT INTO public.who_global_data_import VALUES (2181, '2020-07-01', 'AO', 'Angola', 'AFRO', '8', '284', '2', '13');
INSERT INTO public.who_global_data_import VALUES (2182, '2020-07-02', 'AO', 'Angola', 'AFRO', '7', '291', '2', '15');
INSERT INTO public.who_global_data_import VALUES (2183, '2020-07-03', 'AO', 'Angola', 'AFRO', '24', '315', '2', '17');
INSERT INTO public.who_global_data_import VALUES (2184, '2020-07-04', 'AO', 'Angola', 'AFRO', '13', '328', '1', '18');
INSERT INTO public.who_global_data_import VALUES (2185, '2020-07-05', 'AO', 'Angola', 'AFRO', '18', '346', '1', '19');
INSERT INTO public.who_global_data_import VALUES (2186, '2020-07-06', 'AO', 'Angola', 'AFRO', '7', '353', '0', '19');
INSERT INTO public.who_global_data_import VALUES (2187, '2020-07-07', 'AO', 'Angola', 'AFRO', '0', '353', '0', '19');
INSERT INTO public.who_global_data_import VALUES (2188, '2020-07-08', 'AO', 'Angola', 'AFRO', '33', '386', '2', '21');
INSERT INTO public.who_global_data_import VALUES (2189, '2020-07-09', 'AO', 'Angola', 'AFRO', '10', '396', '1', '22');
INSERT INTO public.who_global_data_import VALUES (2190, '2020-07-10', 'AO', 'Angola', 'AFRO', '62', '458', '1', '23');
INSERT INTO public.who_global_data_import VALUES (2191, '2020-07-11', 'AO', 'Angola', 'AFRO', '4', '462', '0', '23');
INSERT INTO public.who_global_data_import VALUES (2192, '2020-07-12', 'AO', 'Angola', 'AFRO', '21', '483', '2', '25');
INSERT INTO public.who_global_data_import VALUES (2193, '2020-07-13', 'AO', 'Angola', 'AFRO', '23', '506', '1', '26');
INSERT INTO public.who_global_data_import VALUES (2194, '2020-07-14', 'AO', 'Angola', 'AFRO', '19', '525', '0', '26');
INSERT INTO public.who_global_data_import VALUES (2195, '2020-07-15', 'AO', 'Angola', 'AFRO', '16', '541', '0', '26');
INSERT INTO public.who_global_data_import VALUES (2196, '2020-07-16', 'AO', 'Angola', 'AFRO', '35', '576', '1', '27');
INSERT INTO public.who_global_data_import VALUES (2197, '2020-07-17', 'AO', 'Angola', 'AFRO', '31', '607', '1', '28');
INSERT INTO public.who_global_data_import VALUES (2198, '2020-07-18', 'AO', 'Angola', 'AFRO', '31', '638', '1', '29');
INSERT INTO public.who_global_data_import VALUES (2199, '2020-07-19', 'AO', 'Angola', 'AFRO', '49', '687', '0', '29');
INSERT INTO public.who_global_data_import VALUES (2200, '2020-07-20', 'AO', 'Angola', 'AFRO', '18', '705', '0', '29');
INSERT INTO public.who_global_data_import VALUES (2201, '2020-07-21', 'AO', 'Angola', 'AFRO', '44', '749', '0', '29');
INSERT INTO public.who_global_data_import VALUES (2202, '2020-07-22', 'AO', 'Angola', 'AFRO', '30', '779', '1', '30');
INSERT INTO public.who_global_data_import VALUES (2203, '2020-07-23', 'AO', 'Angola', 'AFRO', '33', '812', '3', '33');
INSERT INTO public.who_global_data_import VALUES (2204, '2020-07-24', 'AO', 'Angola', 'AFRO', '39', '851', '0', '33');
INSERT INTO public.who_global_data_import VALUES (2205, '2020-07-25', 'AO', 'Angola', 'AFRO', '29', '880', '2', '35');
INSERT INTO public.who_global_data_import VALUES (2206, '2020-07-26', 'AO', 'Angola', 'AFRO', '36', '916', '4', '39');
INSERT INTO public.who_global_data_import VALUES (2207, '2020-07-27', 'AO', 'Angola', 'AFRO', '16', '932', '1', '40');
INSERT INTO public.who_global_data_import VALUES (2208, '2020-07-28', 'AO', 'Angola', 'AFRO', '18', '950', '1', '41');
INSERT INTO public.who_global_data_import VALUES (2209, '2020-07-29', 'AO', 'Angola', 'AFRO', '50', '1000', '6', '47');
INSERT INTO public.who_global_data_import VALUES (2210, '2020-07-30', 'AO', 'Angola', 'AFRO', '78', '1078', '1', '48');
INSERT INTO public.who_global_data_import VALUES (2211, '2020-07-31', 'AO', 'Angola', 'AFRO', '31', '1109', '3', '51');
INSERT INTO public.who_global_data_import VALUES (2212, '2020-08-01', 'AO', 'Angola', 'AFRO', '0', '1109', '0', '51');
INSERT INTO public.who_global_data_import VALUES (2213, '2020-08-02', 'AO', 'Angola', 'AFRO', '39', '1148', '1', '52');
INSERT INTO public.who_global_data_import VALUES (2214, '2020-08-03', 'AO', 'Angola', 'AFRO', '16', '1164', '2', '54');
INSERT INTO public.who_global_data_import VALUES (2215, '2020-08-04', 'AO', 'Angola', 'AFRO', '116', '1280', '4', '58');
INSERT INTO public.who_global_data_import VALUES (2216, '2020-08-05', 'AO', 'Angola', 'AFRO', '64', '1344', '1', '59');
INSERT INTO public.who_global_data_import VALUES (2217, '2020-08-06', 'AO', 'Angola', 'AFRO', '51', '1395', '3', '62');
INSERT INTO public.who_global_data_import VALUES (2218, '2020-08-07', 'AO', 'Angola', 'AFRO', '88', '1483', '2', '64');
INSERT INTO public.who_global_data_import VALUES (2219, '2020-08-08', 'AO', 'Angola', 'AFRO', '55', '1538', '3', '67');
INSERT INTO public.who_global_data_import VALUES (2220, '2020-08-09', 'AO', 'Angola', 'AFRO', '34', '1572', '3', '70');
INSERT INTO public.who_global_data_import VALUES (2221, '2020-08-10', 'AO', 'Angola', 'AFRO', '100', '1672', '5', '75');
INSERT INTO public.who_global_data_import VALUES (2222, '2020-08-11', 'AO', 'Angola', 'AFRO', '7', '1679', '3', '78');
INSERT INTO public.who_global_data_import VALUES (2223, '2020-08-12', 'AO', 'Angola', 'AFRO', '56', '1735', '2', '80');
INSERT INTO public.who_global_data_import VALUES (2224, '2020-08-13', 'AO', 'Angola', 'AFRO', '27', '1762', '0', '80');
INSERT INTO public.who_global_data_import VALUES (2225, '2020-08-14', 'AO', 'Angola', 'AFRO', '53', '1815', '3', '83');
INSERT INTO public.who_global_data_import VALUES (2226, '2020-08-15', 'AO', 'Angola', 'AFRO', '37', '1852', '3', '86');
INSERT INTO public.who_global_data_import VALUES (2227, '2020-08-16', 'AO', 'Angola', 'AFRO', '27', '1879', '0', '86');
INSERT INTO public.who_global_data_import VALUES (2228, '2020-08-17', 'AO', 'Angola', 'AFRO', '27', '1906', '2', '88');
INSERT INTO public.who_global_data_import VALUES (2229, '2020-08-18', 'AO', 'Angola', 'AFRO', '29', '1935', '0', '88');
INSERT INTO public.who_global_data_import VALUES (2230, '2020-08-19', 'AO', 'Angola', 'AFRO', '31', '1966', '2', '90');
INSERT INTO public.who_global_data_import VALUES (2231, '2020-08-20', 'AO', 'Angola', 'AFRO', '49', '2015', '2', '92');
INSERT INTO public.who_global_data_import VALUES (2232, '2020-08-21', 'AO', 'Angola', 'AFRO', '29', '2044', '1', '93');
INSERT INTO public.who_global_data_import VALUES (2233, '2020-08-22', 'AO', 'Angola', 'AFRO', '24', '2068', '1', '94');
INSERT INTO public.who_global_data_import VALUES (2234, '2020-08-23', 'AO', 'Angola', 'AFRO', '66', '2134', '0', '94');
INSERT INTO public.who_global_data_import VALUES (2235, '2020-08-24', 'AO', 'Angola', 'AFRO', '37', '2171', '2', '96');
INSERT INTO public.who_global_data_import VALUES (2236, '2020-08-25', 'AO', 'Angola', 'AFRO', '51', '2222', '4', '100');
INSERT INTO public.who_global_data_import VALUES (2237, '2020-08-26', 'AO', 'Angola', 'AFRO', '61', '2283', '2', '102');
INSERT INTO public.who_global_data_import VALUES (2238, '2020-08-27', 'AO', 'Angola', 'AFRO', '49', '2332', '1', '103');
INSERT INTO public.who_global_data_import VALUES (2239, '2020-08-28', 'AO', 'Angola', 'AFRO', '83', '2415', '2', '105');
INSERT INTO public.who_global_data_import VALUES (2240, '2020-08-29', 'AO', 'Angola', 'AFRO', '56', '2471', '1', '106');
INSERT INTO public.who_global_data_import VALUES (2241, '2020-08-30', 'AO', 'Angola', 'AFRO', '80', '2551', '1', '107');
INSERT INTO public.who_global_data_import VALUES (2242, '2020-08-31', 'AO', 'Angola', 'AFRO', '73', '2624', '0', '107');
INSERT INTO public.who_global_data_import VALUES (2243, '2020-09-01', 'AO', 'Angola', 'AFRO', '30', '2654', '1', '108');
INSERT INTO public.who_global_data_import VALUES (2244, '2020-09-02', 'AO', 'Angola', 'AFRO', '75', '2729', '1', '109');
INSERT INTO public.who_global_data_import VALUES (2245, '2020-09-03', 'AO', 'Angola', 'AFRO', '48', '2777', '3', '112');
INSERT INTO public.who_global_data_import VALUES (2246, '2020-09-04', 'AO', 'Angola', 'AFRO', '28', '2805', '1', '113');
INSERT INTO public.who_global_data_import VALUES (2247, '2020-09-05', 'AO', 'Angola', 'AFRO', '71', '2876', '2', '115');
INSERT INTO public.who_global_data_import VALUES (2248, '2020-09-06', 'AO', 'Angola', 'AFRO', '59', '2935', '2', '117');
INSERT INTO public.who_global_data_import VALUES (2249, '2020-09-07', 'AO', 'Angola', 'AFRO', '30', '2965', '0', '117');
INSERT INTO public.who_global_data_import VALUES (2250, '2020-09-08', 'AO', 'Angola', 'AFRO', '16', '2981', '3', '120');
INSERT INTO public.who_global_data_import VALUES (2251, '2020-09-09', 'AO', 'Angola', 'AFRO', '52', '3033', '4', '124');
INSERT INTO public.who_global_data_import VALUES (2252, '2020-09-10', 'AO', 'Angola', 'AFRO', '59', '3092', '2', '126');
INSERT INTO public.who_global_data_import VALUES (2253, '2020-09-11', 'AO', 'Angola', 'AFRO', '125', '3217', '4', '130');
INSERT INTO public.who_global_data_import VALUES (2254, '2020-09-12', 'AO', 'Angola', 'AFRO', '62', '3279', '1', '131');
INSERT INTO public.who_global_data_import VALUES (2255, '2020-09-13', 'AO', 'Angola', 'AFRO', '56', '3335', '1', '132');
INSERT INTO public.who_global_data_import VALUES (2256, '2020-09-14', 'AO', 'Angola', 'AFRO', '53', '3388', '2', '134');
INSERT INTO public.who_global_data_import VALUES (2257, '2020-09-15', 'AO', 'Angola', 'AFRO', '51', '3439', '0', '134');
INSERT INTO public.who_global_data_import VALUES (2258, '2020-09-16', 'AO', 'Angola', 'AFRO', '130', '3569', '5', '139');
INSERT INTO public.who_global_data_import VALUES (2259, '2020-09-17', 'AO', 'Angola', 'AFRO', '106', '3675', '4', '143');
INSERT INTO public.who_global_data_import VALUES (2260, '2020-09-18', 'AO', 'Angola', 'AFRO', '114', '3789', '1', '144');
INSERT INTO public.who_global_data_import VALUES (2261, '2020-09-19', 'AO', 'Angola', 'AFRO', '59', '3848', '3', '147');
INSERT INTO public.who_global_data_import VALUES (2262, '2020-09-20', 'AO', 'Angola', 'AFRO', '53', '3901', '0', '147');
INSERT INTO public.who_global_data_import VALUES (2263, '2020-09-21', 'AO', 'Angola', 'AFRO', '90', '3991', '5', '152');
INSERT INTO public.who_global_data_import VALUES (2264, '2020-09-22', 'AO', 'Angola', 'AFRO', '0', '3991', '0', '152');
INSERT INTO public.who_global_data_import VALUES (2265, '2020-09-23', 'AO', 'Angola', 'AFRO', '245', '4236', '3', '155');
INSERT INTO public.who_global_data_import VALUES (2266, '2020-09-24', 'AO', 'Angola', 'AFRO', '127', '4363', '4', '159');
INSERT INTO public.who_global_data_import VALUES (2267, '2020-09-25', 'AO', 'Angola', 'AFRO', '112', '4475', '3', '162');
INSERT INTO public.who_global_data_import VALUES (2268, '2020-09-26', 'AO', 'Angola', 'AFRO', '115', '4590', '5', '167');
INSERT INTO public.who_global_data_import VALUES (2269, '2020-09-27', 'AO', 'Angola', 'AFRO', '82', '4672', '4', '171');
INSERT INTO public.who_global_data_import VALUES (2270, '2020-09-28', 'AO', 'Angola', 'AFRO', '46', '4718', '3', '174');
INSERT INTO public.who_global_data_import VALUES (2271, '2020-09-29', 'AO', 'Angola', 'AFRO', '79', '4797', '2', '176');
INSERT INTO public.who_global_data_import VALUES (2272, '2020-09-30', 'AO', 'Angola', 'AFRO', '108', '4905', '3', '179');
INSERT INTO public.who_global_data_import VALUES (2273, '2020-10-01', 'AO', 'Angola', 'AFRO', '67', '4972', '4', '183');
INSERT INTO public.who_global_data_import VALUES (2274, '2020-10-02', 'AO', 'Angola', 'AFRO', '142', '5114', '2', '185');
INSERT INTO public.who_global_data_import VALUES (2275, '2020-10-03', 'AO', 'Angola', 'AFRO', '97', '5211', '4', '189');
INSERT INTO public.who_global_data_import VALUES (2276, '2020-10-04', 'AO', 'Angola', 'AFRO', '159', '5370', '0', '189');
INSERT INTO public.who_global_data_import VALUES (2277, '2020-10-05', 'AO', 'Angola', 'AFRO', '0', '5370', '-4', '185');
INSERT INTO public.who_global_data_import VALUES (2278, '2020-10-06', 'AO', 'Angola', 'AFRO', '160', '5530', '7', '192');
INSERT INTO public.who_global_data_import VALUES (2279, '2020-10-07', 'AO', 'Angola', 'AFRO', '0', '5530', '0', '192');
INSERT INTO public.who_global_data_import VALUES (2280, '2020-10-08', 'AO', 'Angola', 'AFRO', '333', '5863', '14', '206');
INSERT INTO public.who_global_data_import VALUES (2281, '2020-10-09', 'AO', 'Angola', 'AFRO', '95', '5958', '2', '208');
INSERT INTO public.who_global_data_import VALUES (2282, '2020-10-10', 'AO', 'Angola', 'AFRO', '73', '6031', '4', '212');
INSERT INTO public.who_global_data_import VALUES (2283, '2020-10-11', 'AO', 'Angola', 'AFRO', '215', '6246', '6', '218');
INSERT INTO public.who_global_data_import VALUES (2284, '2020-10-12', 'AO', 'Angola', 'AFRO', '120', '6366', '0', '218');
INSERT INTO public.who_global_data_import VALUES (2285, '2020-10-13', 'AO', 'Angola', 'AFRO', '122', '6488', '1', '219');
INSERT INTO public.who_global_data_import VALUES (2286, '2020-10-14', 'AO', 'Angola', 'AFRO', '192', '6680', '3', '222');
INSERT INTO public.who_global_data_import VALUES (2287, '2020-10-15', 'AO', 'Angola', 'AFRO', '166', '6846', '5', '227');
INSERT INTO public.who_global_data_import VALUES (2288, '2020-10-16', 'AO', 'Angola', 'AFRO', '250', '7096', '1', '228');
INSERT INTO public.who_global_data_import VALUES (2289, '2020-10-17', 'AO', 'Angola', 'AFRO', '126', '7222', '6', '234');
INSERT INTO public.who_global_data_import VALUES (2290, '2020-10-18', 'AO', 'Angola', 'AFRO', '240', '7462', '7', '241');
INSERT INTO public.who_global_data_import VALUES (2291, '2020-10-19', 'AO', 'Angola', 'AFRO', '160', '7622', '6', '247');
INSERT INTO public.who_global_data_import VALUES (2292, '2020-10-20', 'AO', 'Angola', 'AFRO', '207', '7829', '1', '248');
INSERT INTO public.who_global_data_import VALUES (2293, '2020-10-21', 'AO', 'Angola', 'AFRO', '220', '8049', '3', '251');
INSERT INTO public.who_global_data_import VALUES (2294, '2020-10-22', 'AO', 'Angola', 'AFRO', '289', '8338', '4', '255');
INSERT INTO public.who_global_data_import VALUES (2295, '2020-10-23', 'AO', 'Angola', 'AFRO', '244', '8582', '5', '260');
INSERT INTO public.who_global_data_import VALUES (2296, '2020-10-24', 'AO', 'Angola', 'AFRO', '247', '8829', '5', '265');
INSERT INTO public.who_global_data_import VALUES (2297, '2020-10-25', 'AO', 'Angola', 'AFRO', '197', '9026', '2', '267');
INSERT INTO public.who_global_data_import VALUES (2298, '2020-10-26', 'AO', 'Angola', 'AFRO', '355', '9381', '1', '268');
INSERT INTO public.who_global_data_import VALUES (2299, '2020-10-27', 'AO', 'Angola', 'AFRO', '263', '9644', '2', '270');
INSERT INTO public.who_global_data_import VALUES (2300, '2020-10-28', 'AO', 'Angola', 'AFRO', '227', '9871', '1', '271');
INSERT INTO public.who_global_data_import VALUES (2301, '2020-10-29', 'AO', 'Angola', 'AFRO', '203', '10074', '4', '275');
INSERT INTO public.who_global_data_import VALUES (2302, '2020-10-30', 'AO', 'Angola', 'AFRO', '195', '10269', '0', '275');
INSERT INTO public.who_global_data_import VALUES (2303, '2020-10-31', 'AO', 'Angola', 'AFRO', '289', '10558', '4', '279');
INSERT INTO public.who_global_data_import VALUES (2304, '2020-11-01', 'AO', 'Angola', 'AFRO', '247', '10805', '5', '284');
INSERT INTO public.who_global_data_import VALUES (2305, '2020-11-02', 'AO', 'Angola', 'AFRO', '230', '11035', '2', '286');
INSERT INTO public.who_global_data_import VALUES (2306, '2020-11-03', 'AO', 'Angola', 'AFRO', '193', '11228', '3', '289');
INSERT INTO public.who_global_data_import VALUES (2307, '2020-11-04', 'AO', 'Angola', 'AFRO', '349', '11577', '2', '291');
INSERT INTO public.who_global_data_import VALUES (2308, '2020-11-05', 'AO', 'Angola', 'AFRO', '236', '11813', '5', '296');
INSERT INTO public.who_global_data_import VALUES (2309, '2020-11-06', 'AO', 'Angola', 'AFRO', '289', '12102', '3', '299');
INSERT INTO public.who_global_data_import VALUES (2310, '2020-11-07', 'AO', 'Angola', 'AFRO', '121', '12223', '1', '300');
INSERT INTO public.who_global_data_import VALUES (2311, '2020-11-08', 'AO', 'Angola', 'AFRO', '112', '12335', '3', '303');
INSERT INTO public.who_global_data_import VALUES (2312, '2020-11-09', 'AO', 'Angola', 'AFRO', '98', '12433', '4', '307');
INSERT INTO public.who_global_data_import VALUES (2313, '2020-11-10', 'AO', 'Angola', 'AFRO', '247', '12680', '1', '308');
INSERT INTO public.who_global_data_import VALUES (2314, '2020-11-11', 'AO', 'Angola', 'AFRO', '136', '12816', '0', '308');
INSERT INTO public.who_global_data_import VALUES (2315, '2020-11-12', 'AO', 'Angola', 'AFRO', '137', '12953', '4', '312');
INSERT INTO public.who_global_data_import VALUES (2316, '2020-11-13', 'AO', 'Angola', 'AFRO', '104', '13057', '3', '315');
INSERT INTO public.who_global_data_import VALUES (2317, '2020-11-14', 'AO', 'Angola', 'AFRO', '171', '13228', '2', '317');
INSERT INTO public.who_global_data_import VALUES (2318, '2020-11-15', 'AO', 'Angola', 'AFRO', '146', '13374', '5', '322');
INSERT INTO public.who_global_data_import VALUES (2319, '2020-11-16', 'AO', 'Angola', 'AFRO', '77', '13451', '0', '322');
INSERT INTO public.who_global_data_import VALUES (2320, '2020-11-17', 'AO', 'Angola', 'AFRO', '164', '13615', '2', '324');
INSERT INTO public.who_global_data_import VALUES (2321, '2020-11-18', 'AO', 'Angola', 'AFRO', '203', '13818', '4', '328');
INSERT INTO public.who_global_data_import VALUES (2322, '2020-11-19', 'AO', 'Angola', 'AFRO', '104', '13922', '4', '332');
INSERT INTO public.who_global_data_import VALUES (2323, '2020-11-20', 'AO', 'Angola', 'AFRO', '212', '14134', '1', '333');
INSERT INTO public.who_global_data_import VALUES (2324, '2020-11-21', 'AO', 'Angola', 'AFRO', '133', '14267', '1', '334');
INSERT INTO public.who_global_data_import VALUES (2325, '2020-11-22', 'AO', 'Angola', 'AFRO', '146', '14413', '2', '336');
INSERT INTO public.who_global_data_import VALUES (2326, '2020-11-23', 'AO', 'Angola', 'AFRO', '80', '14493', '1', '337');
INSERT INTO public.who_global_data_import VALUES (2327, '2020-11-24', 'AO', 'Angola', 'AFRO', '141', '14634', '0', '337');
INSERT INTO public.who_global_data_import VALUES (2328, '2020-11-25', 'AO', 'Angola', 'AFRO', '108', '14742', '1', '338');
INSERT INTO public.who_global_data_import VALUES (2329, '2020-11-26', 'AO', 'Angola', 'AFRO', '79', '14821', '2', '340');
INSERT INTO public.who_global_data_import VALUES (2330, '2020-11-27', 'AO', 'Angola', 'AFRO', '99', '14920', '1', '341');
INSERT INTO public.who_global_data_import VALUES (2331, '2020-11-28', 'AO', 'Angola', 'AFRO', '88', '15008', '1', '342');
INSERT INTO public.who_global_data_import VALUES (2332, '2020-11-29', 'AO', 'Angola', 'AFRO', '79', '15087', '3', '345');
INSERT INTO public.who_global_data_import VALUES (2333, '2020-11-30', 'AO', 'Angola', 'AFRO', '16', '15103', '1', '346');
INSERT INTO public.who_global_data_import VALUES (2334, '2020-12-01', 'AO', 'Angola', 'AFRO', '36', '15139', '2', '348');
INSERT INTO public.who_global_data_import VALUES (2335, '2020-12-02', 'AO', 'Angola', 'AFRO', '112', '15251', '2', '350');
INSERT INTO public.who_global_data_import VALUES (2336, '2020-12-03', 'AO', 'Angola', 'AFRO', '68', '15319', '1', '351');
INSERT INTO public.who_global_data_import VALUES (2337, '2020-12-04', 'AO', 'Angola', 'AFRO', '42', '15361', '1', '352');
INSERT INTO public.who_global_data_import VALUES (2338, '2020-12-05', 'AO', 'Angola', 'AFRO', '132', '15493', '1', '353');
INSERT INTO public.who_global_data_import VALUES (2339, '2020-12-06', 'AO', 'Angola', 'AFRO', '43', '15536', '1', '354');
INSERT INTO public.who_global_data_import VALUES (2340, '2020-12-07', 'AO', 'Angola', 'AFRO', '0', '15536', '0', '354');
INSERT INTO public.who_global_data_import VALUES (2341, '2020-12-08', 'AO', 'Angola', 'AFRO', '112', '15648', '0', '354');
INSERT INTO public.who_global_data_import VALUES (2342, '2020-12-09', 'AO', 'Angola', 'AFRO', '81', '15729', '1', '355');
INSERT INTO public.who_global_data_import VALUES (2343, '2020-12-10', 'AO', 'Angola', 'AFRO', '75', '15804', '3', '358');
INSERT INTO public.who_global_data_import VALUES (2344, '2020-12-11', 'AO', 'Angola', 'AFRO', '121', '15925', '4', '362');
INSERT INTO public.who_global_data_import VALUES (2345, '2020-12-12', 'AO', 'Angola', 'AFRO', '136', '16061', '3', '365');
INSERT INTO public.who_global_data_import VALUES (2346, '2020-12-13', 'AO', 'Angola', 'AFRO', '100', '16161', '1', '366');
INSERT INTO public.who_global_data_import VALUES (2347, '2020-12-14', 'AO', 'Angola', 'AFRO', '27', '16188', '5', '371');
INSERT INTO public.who_global_data_import VALUES (2348, '2020-12-15', 'AO', 'Angola', 'AFRO', '89', '16277', '1', '372');
INSERT INTO public.who_global_data_import VALUES (2349, '2020-12-16', 'AO', 'Angola', 'AFRO', '85', '16362', '0', '372');
INSERT INTO public.who_global_data_import VALUES (2350, '2020-12-17', 'AO', 'Angola', 'AFRO', '45', '16407', '7', '379');
INSERT INTO public.who_global_data_import VALUES (2351, '2020-12-18', 'AO', 'Angola', 'AFRO', '77', '16484', '3', '382');
INSERT INTO public.who_global_data_import VALUES (2352, '2020-12-19', 'AO', 'Angola', 'AFRO', '78', '16562', '2', '384');
INSERT INTO public.who_global_data_import VALUES (2353, '2020-12-20', 'AO', 'Angola', 'AFRO', '64', '16626', '2', '386');
INSERT INTO public.who_global_data_import VALUES (2354, '2020-12-21', 'AO', 'Angola', 'AFRO', '18', '16644', '1', '387');
INSERT INTO public.who_global_data_import VALUES (2355, '2020-12-22', 'AO', 'Angola', 'AFRO', '42', '16686', '3', '390');
INSERT INTO public.who_global_data_import VALUES (2356, '2020-12-23', 'AO', 'Angola', 'AFRO', '116', '16802', '3', '393');
INSERT INTO public.who_global_data_import VALUES (2357, '2020-12-24', 'AO', 'Angola', 'AFRO', '129', '16931', '1', '394');
INSERT INTO public.who_global_data_import VALUES (2358, '2020-12-25', 'AO', 'Angola', 'AFRO', '98', '17029', '1', '395');
INSERT INTO public.who_global_data_import VALUES (2359, '2020-12-26', 'AO', 'Angola', 'AFRO', '70', '17099', '1', '396');
INSERT INTO public.who_global_data_import VALUES (2360, '2020-12-27', 'AO', 'Angola', 'AFRO', '50', '17149', '3', '399');
INSERT INTO public.who_global_data_import VALUES (2361, '2020-12-28', 'AO', 'Angola', 'AFRO', '91', '17240', '0', '399');
INSERT INTO public.who_global_data_import VALUES (2362, '2020-12-29', 'AO', 'Angola', 'AFRO', '0', '17240', '0', '399');
INSERT INTO public.who_global_data_import VALUES (2363, '2020-12-30', 'AO', 'Angola', 'AFRO', '131', '17371', '0', '399');
INSERT INTO public.who_global_data_import VALUES (2364, '2020-12-31', 'AO', 'Angola', 'AFRO', '0', '17371', '0', '399');
INSERT INTO public.who_global_data_import VALUES (2365, '2021-01-01', 'AO', 'Angola', 'AFRO', '182', '17553', '6', '405');
INSERT INTO public.who_global_data_import VALUES (2366, '2021-01-02', 'AO', 'Angola', 'AFRO', '0', '17553', '0', '405');
INSERT INTO public.who_global_data_import VALUES (2367, '2021-01-03', 'AO', 'Angola', 'AFRO', '55', '17608', '2', '407');
INSERT INTO public.who_global_data_import VALUES (2368, '2021-01-04', 'AO', 'Angola', 'AFRO', '34', '17642', '1', '408');
INSERT INTO public.who_global_data_import VALUES (2369, '2021-01-05', 'AO', 'Angola', 'AFRO', '42', '17684', '0', '408');
INSERT INTO public.who_global_data_import VALUES (2370, '2021-01-06', 'AO', 'Angola', 'AFRO', '0', '17684', '0', '408');
INSERT INTO public.who_global_data_import VALUES (2371, '2021-01-07', 'AO', 'Angola', 'AFRO', '180', '17864', '5', '413');
INSERT INTO public.who_global_data_import VALUES (2372, '2021-01-08', 'AO', 'Angola', 'AFRO', '110', '17974', '0', '413');
INSERT INTO public.who_global_data_import VALUES (2373, '2021-01-09', 'AO', 'Angola', 'AFRO', '92', '18066', '2', '415');
INSERT INTO public.who_global_data_import VALUES (2374, '2021-01-10', 'AO', 'Angola', 'AFRO', '90', '18156', '1', '416');
INSERT INTO public.who_global_data_import VALUES (2375, '2021-01-11', 'AO', 'Angola', 'AFRO', '37', '18193', '0', '416');
INSERT INTO public.who_global_data_import VALUES (2376, '2021-01-12', 'AO', 'Angola', 'AFRO', '61', '18254', '4', '420');
INSERT INTO public.who_global_data_import VALUES (2377, '2021-01-13', 'AO', 'Angola', 'AFRO', '89', '18343', '2', '422');
INSERT INTO public.who_global_data_import VALUES (2378, '2021-01-14', 'AO', 'Angola', 'AFRO', '82', '18425', '2', '424');
INSERT INTO public.who_global_data_import VALUES (2379, '2021-01-15', 'AO', 'Angola', 'AFRO', '188', '18613', '1', '425');
INSERT INTO public.who_global_data_import VALUES (2380, '2021-01-16', 'AO', 'Angola', 'AFRO', '0', '18613', '0', '425');
INSERT INTO public.who_global_data_import VALUES (2381, '2021-01-17', 'AO', 'Angola', 'AFRO', '152', '18765', '6', '431');
INSERT INTO public.who_global_data_import VALUES (2382, '2021-01-18', 'AO', 'Angola', 'AFRO', '110', '18875', '5', '436');
INSERT INTO public.who_global_data_import VALUES (2383, '2021-01-19', 'AO', 'Angola', 'AFRO', '51', '18926', '3', '439');
INSERT INTO public.who_global_data_import VALUES (2384, '2021-01-20', 'AO', 'Angola', 'AFRO', '85', '19011', '3', '442');
INSERT INTO public.who_global_data_import VALUES (2385, '2021-01-21', 'AO', 'Angola', 'AFRO', '82', '19093', '2', '444');
INSERT INTO public.who_global_data_import VALUES (2386, '2021-01-22', 'AO', 'Angola', 'AFRO', '84', '19177', '4', '448');
INSERT INTO public.who_global_data_import VALUES (2387, '2021-01-23', 'AO', 'Angola', 'AFRO', '92', '19269', '4', '452');
INSERT INTO public.who_global_data_import VALUES (2388, '2021-01-24', 'AO', 'Angola', 'AFRO', '98', '19367', '5', '457');
INSERT INTO public.who_global_data_import VALUES (2389, '2021-01-25', 'AO', 'Angola', 'AFRO', '32', '19399', '2', '459');
INSERT INTO public.who_global_data_import VALUES (2390, '2021-01-26', 'AO', 'Angola', 'AFRO', '77', '19476', '2', '461');
INSERT INTO public.who_global_data_import VALUES (2391, '2021-01-27', 'AO', 'Angola', 'AFRO', '77', '19553', '1', '462');
INSERT INTO public.who_global_data_import VALUES (2392, '2021-01-28', 'AO', 'Angola', 'AFRO', '27', '19580', '0', '462');
INSERT INTO public.who_global_data_import VALUES (2393, '2021-01-29', 'AO', 'Angola', 'AFRO', '92', '19672', '2', '464');
INSERT INTO public.who_global_data_import VALUES (2394, '2021-01-30', 'AO', 'Angola', 'AFRO', '51', '19723', '0', '464');
INSERT INTO public.who_global_data_import VALUES (2395, '2021-01-31', 'AO', 'Angola', 'AFRO', '59', '19782', '0', '464');
INSERT INTO public.who_global_data_import VALUES (2396, '2021-02-01', 'AO', 'Angola', 'AFRO', '14', '19796', '2', '466');
INSERT INTO public.who_global_data_import VALUES (2397, '2021-02-02', 'AO', 'Angola', 'AFRO', '33', '19829', '0', '466');
INSERT INTO public.who_global_data_import VALUES (2398, '2021-02-03', 'AO', 'Angola', 'AFRO', '71', '19900', '2', '468');
INSERT INTO public.who_global_data_import VALUES (2399, '2021-02-04', 'AO', 'Angola', 'AFRO', '37', '19937', '2', '470');
INSERT INTO public.who_global_data_import VALUES (2400, '2021-02-05', 'AO', 'Angola', 'AFRO', '59', '19996', '3', '473');
INSERT INTO public.who_global_data_import VALUES (2401, '2020-01-03', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2402, '2020-01-04', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2403, '2020-01-05', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2404, '2020-01-06', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2405, '2020-01-07', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2406, '2020-01-08', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2407, '2020-01-09', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2408, '2020-01-10', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2409, '2020-01-11', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2410, '2020-01-12', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2411, '2020-01-13', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2412, '2020-01-14', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2413, '2020-01-15', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2414, '2020-01-16', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2415, '2020-01-17', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2416, '2020-01-18', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2417, '2020-01-19', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2418, '2020-01-20', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2419, '2020-01-21', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2420, '2020-01-22', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2421, '2020-01-23', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2422, '2020-01-24', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2423, '2020-01-25', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2424, '2020-01-26', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2425, '2020-01-27', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2426, '2020-01-28', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2427, '2020-01-29', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2428, '2020-01-30', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2429, '2020-01-31', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2430, '2020-02-01', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2431, '2020-02-02', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2432, '2020-02-03', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2433, '2020-02-04', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2434, '2020-02-05', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2435, '2020-02-06', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2436, '2020-02-07', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2437, '2020-02-08', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2438, '2020-02-09', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2439, '2020-02-10', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2440, '2020-02-11', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2441, '2020-02-12', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2442, '2020-02-13', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2443, '2020-02-14', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2444, '2020-02-15', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2445, '2020-02-16', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2446, '2020-02-17', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2447, '2020-02-18', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2448, '2020-02-19', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2449, '2020-02-20', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2450, '2020-02-21', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2451, '2020-02-22', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2452, '2020-02-23', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2453, '2020-02-24', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2454, '2020-02-25', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2455, '2020-02-26', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2456, '2020-02-27', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2457, '2020-02-28', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2458, '2020-02-29', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2459, '2020-03-01', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2460, '2020-03-02', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2461, '2020-03-03', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2462, '2020-03-04', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2463, '2020-03-05', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2464, '2020-03-06', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2465, '2020-03-07', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2466, '2020-03-08', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2467, '2020-03-09', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2468, '2020-03-10', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2469, '2020-03-11', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2470, '2020-03-12', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2471, '2020-03-13', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2472, '2020-03-14', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2473, '2020-03-15', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2474, '2020-03-16', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2475, '2020-03-17', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2476, '2020-03-18', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2477, '2020-03-19', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2478, '2020-03-20', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2479, '2020-03-21', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2480, '2020-03-22', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2481, '2020-03-23', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2482, '2020-03-24', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2483, '2020-03-25', 'AI', 'Anguilla', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2484, '2020-03-26', 'AI', 'Anguilla', 'AMRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2485, '2020-03-27', 'AI', 'Anguilla', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2486, '2020-03-28', 'AI', 'Anguilla', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2487, '2020-03-29', 'AI', 'Anguilla', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2488, '2020-03-30', 'AI', 'Anguilla', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2489, '2020-03-31', 'AI', 'Anguilla', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2490, '2020-04-01', 'AI', 'Anguilla', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2491, '2020-04-02', 'AI', 'Anguilla', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2492, '2020-04-03', 'AI', 'Anguilla', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2493, '2020-04-04', 'AI', 'Anguilla', 'AMRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2494, '2020-04-05', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2495, '2020-04-06', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2496, '2020-04-07', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2497, '2020-04-08', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2498, '2020-04-09', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2499, '2020-04-10', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2500, '2020-04-11', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2501, '2020-04-12', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2502, '2020-04-13', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2503, '2020-04-14', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2504, '2020-04-15', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2505, '2020-04-16', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2506, '2020-04-17', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2507, '2020-04-18', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2508, '2020-04-19', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2509, '2020-04-20', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2510, '2020-04-21', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2511, '2020-04-22', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2512, '2020-04-23', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2513, '2020-04-24', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2514, '2020-04-25', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2515, '2020-04-26', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2516, '2020-04-27', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2517, '2020-04-28', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2518, '2020-04-29', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2519, '2020-04-30', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2520, '2020-05-01', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2521, '2020-05-02', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2522, '2020-05-03', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2523, '2020-05-04', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2524, '2020-05-05', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2525, '2020-05-06', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2526, '2020-05-07', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2527, '2020-05-08', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2528, '2020-05-09', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2529, '2020-05-10', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2530, '2020-05-11', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2531, '2020-05-12', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2532, '2020-05-13', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2533, '2020-05-14', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2534, '2020-05-15', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2535, '2020-05-16', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2536, '2020-05-17', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2537, '2020-05-18', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2538, '2020-05-19', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2539, '2020-05-20', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2540, '2020-05-21', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2541, '2020-05-22', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2542, '2020-05-23', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2543, '2020-05-24', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2544, '2020-05-25', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2545, '2020-05-26', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2546, '2020-05-27', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2547, '2020-05-28', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2548, '2020-05-29', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2549, '2020-05-30', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2550, '2020-05-31', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2551, '2020-06-01', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2552, '2020-06-02', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2553, '2020-06-03', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2554, '2020-06-04', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2555, '2020-06-05', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2556, '2020-06-06', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2557, '2020-06-07', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2558, '2020-06-08', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2559, '2020-06-09', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2560, '2020-06-10', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2561, '2020-06-11', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2562, '2020-06-12', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2563, '2020-06-13', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2564, '2020-06-14', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2565, '2020-06-15', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2566, '2020-06-16', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2567, '2020-06-17', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2568, '2020-06-18', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2569, '2020-06-19', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2570, '2020-06-20', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2571, '2020-06-21', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2572, '2020-06-22', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2573, '2020-06-23', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2574, '2020-06-24', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2575, '2020-06-25', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2576, '2020-06-26', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2577, '2020-06-27', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2578, '2020-06-28', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2579, '2020-06-29', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2580, '2020-06-30', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2581, '2020-07-01', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2582, '2020-07-02', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2583, '2020-07-03', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2584, '2020-07-04', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2585, '2020-07-05', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2586, '2020-07-06', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2587, '2020-07-07', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2588, '2020-07-08', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2589, '2020-07-09', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2590, '2020-07-10', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2591, '2020-07-11', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2592, '2020-07-12', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2593, '2020-07-13', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2594, '2020-07-14', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2595, '2020-07-15', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2596, '2020-07-16', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2597, '2020-07-17', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2598, '2020-07-18', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2599, '2020-07-19', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2600, '2020-07-20', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2601, '2020-07-21', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2602, '2020-07-22', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2603, '2020-07-23', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2604, '2020-07-24', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2605, '2020-07-25', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2606, '2020-07-26', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2607, '2020-07-27', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2608, '2020-07-28', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2609, '2020-07-29', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2610, '2020-07-30', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2611, '2020-07-31', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2612, '2020-08-01', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2613, '2020-08-02', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2614, '2020-08-03', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2615, '2020-08-04', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2616, '2020-08-05', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2617, '2020-08-06', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2618, '2020-08-07', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2619, '2020-08-08', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2620, '2020-08-09', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2621, '2020-08-10', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2622, '2020-08-11', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2623, '2020-08-12', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2624, '2020-08-13', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2625, '2020-08-14', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2626, '2020-08-15', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2627, '2020-08-16', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2628, '2020-08-17', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2629, '2020-08-18', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2630, '2020-08-19', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2631, '2020-08-20', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2632, '2020-08-21', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2633, '2020-08-22', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2634, '2020-08-23', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2635, '2020-08-24', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2636, '2020-08-25', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2637, '2020-08-26', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2638, '2020-08-27', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2639, '2020-08-28', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2640, '2020-08-29', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2641, '2020-08-30', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2642, '2020-08-31', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2643, '2020-09-01', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2644, '2020-09-02', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2645, '2020-09-03', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2646, '2020-09-04', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2647, '2020-09-05', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2648, '2020-09-06', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2649, '2020-09-07', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2650, '2020-09-08', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2651, '2020-09-09', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2652, '2020-09-10', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2653, '2020-09-11', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2654, '2020-09-12', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2655, '2020-09-13', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2656, '2020-09-14', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2657, '2020-09-15', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2658, '2020-09-16', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2659, '2020-09-17', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2660, '2020-09-18', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2661, '2020-09-19', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2662, '2020-09-20', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2663, '2020-09-21', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2664, '2020-09-22', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2665, '2020-09-23', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2666, '2020-09-24', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2667, '2020-09-25', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2668, '2020-09-26', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2669, '2020-09-27', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2670, '2020-09-28', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2671, '2020-09-29', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2672, '2020-09-30', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2673, '2020-10-01', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2674, '2020-10-02', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2675, '2020-10-03', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2676, '2020-10-04', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2677, '2020-10-05', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2678, '2020-10-06', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2679, '2020-10-07', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2680, '2020-10-08', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2681, '2020-10-09', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2682, '2020-10-10', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2683, '2020-10-11', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2684, '2020-10-12', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2685, '2020-10-13', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2686, '2020-10-14', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2687, '2020-10-15', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2688, '2020-10-16', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2689, '2020-10-17', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2690, '2020-10-18', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2691, '2020-10-19', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2692, '2020-10-20', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2693, '2020-10-21', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2694, '2020-10-22', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2695, '2020-10-23', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2696, '2020-10-24', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2697, '2020-10-25', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2698, '2020-10-26', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2699, '2020-10-27', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2700, '2020-10-28', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2701, '2020-10-29', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2702, '2020-10-30', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2703, '2020-10-31', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2704, '2020-11-01', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2705, '2020-11-02', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2706, '2020-11-03', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2707, '2020-11-04', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2708, '2020-11-05', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2709, '2020-11-06', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2710, '2020-11-07', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2711, '2020-11-08', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2712, '2020-11-09', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2713, '2020-11-10', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2714, '2020-11-11', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2715, '2020-11-12', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2716, '2020-11-13', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2717, '2020-11-14', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2718, '2020-11-15', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2719, '2020-11-16', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2720, '2020-11-17', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2721, '2020-11-18', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2722, '2020-11-19', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2723, '2020-11-20', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2724, '2020-11-21', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2725, '2020-11-22', 'AI', 'Anguilla', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2726, '2020-11-23', 'AI', 'Anguilla', 'AMRO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2727, '2020-11-24', 'AI', 'Anguilla', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2728, '2020-11-25', 'AI', 'Anguilla', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2729, '2020-11-26', 'AI', 'Anguilla', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2730, '2020-11-27', 'AI', 'Anguilla', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2731, '2020-11-28', 'AI', 'Anguilla', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2732, '2020-11-29', 'AI', 'Anguilla', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2733, '2020-11-30', 'AI', 'Anguilla', 'AMRO', '2', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2734, '2020-12-01', 'AI', 'Anguilla', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2735, '2020-12-02', 'AI', 'Anguilla', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2736, '2020-12-03', 'AI', 'Anguilla', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2737, '2020-12-04', 'AI', 'Anguilla', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2738, '2020-12-05', 'AI', 'Anguilla', 'AMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2739, '2020-12-06', 'AI', 'Anguilla', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2740, '2020-12-07', 'AI', 'Anguilla', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2741, '2020-12-08', 'AI', 'Anguilla', 'AMRO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2742, '2020-12-09', 'AI', 'Anguilla', 'AMRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2743, '2020-12-10', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2744, '2020-12-11', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2745, '2020-12-12', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2746, '2020-12-13', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2747, '2020-12-14', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2748, '2020-12-15', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2749, '2020-12-16', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2750, '2020-12-17', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2751, '2020-12-18', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2752, '2020-12-19', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2753, '2020-12-20', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2754, '2020-12-21', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2755, '2020-12-22', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2756, '2020-12-23', 'AI', 'Anguilla', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2757, '2020-12-24', 'AI', 'Anguilla', 'AMRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2758, '2020-12-25', 'AI', 'Anguilla', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2759, '2020-12-26', 'AI', 'Anguilla', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2760, '2020-12-27', 'AI', 'Anguilla', 'AMRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2761, '2020-12-28', 'AI', 'Anguilla', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2762, '2020-12-29', 'AI', 'Anguilla', 'AMRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2763, '2020-12-30', 'AI', 'Anguilla', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2764, '2020-12-31', 'AI', 'Anguilla', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2765, '2021-01-01', 'AI', 'Anguilla', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2766, '2021-01-02', 'AI', 'Anguilla', 'AMRO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2767, '2021-01-03', 'AI', 'Anguilla', 'AMRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2768, '2021-01-04', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2769, '2021-01-05', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2770, '2021-01-06', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2771, '2021-01-07', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2772, '2021-01-08', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2773, '2021-01-09', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2774, '2021-01-10', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2775, '2021-01-11', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2776, '2021-01-12', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2777, '2021-01-13', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2778, '2021-01-14', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2779, '2021-01-15', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2780, '2021-01-16', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2781, '2021-01-17', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2782, '2021-01-18', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2783, '2021-01-19', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2784, '2021-01-20', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2785, '2021-01-21', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2786, '2021-01-22', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2787, '2021-01-23', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2788, '2021-01-24', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2789, '2021-01-25', 'AI', 'Anguilla', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2790, '2021-01-26', 'AI', 'Anguilla', 'AMRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2791, '2021-01-27', 'AI', 'Anguilla', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2792, '2021-01-28', 'AI', 'Anguilla', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2793, '2021-01-29', 'AI', 'Anguilla', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2794, '2021-01-30', 'AI', 'Anguilla', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2795, '2021-01-31', 'AI', 'Anguilla', 'AMRO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2796, '2021-02-01', 'AI', 'Anguilla', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2797, '2021-02-02', 'AI', 'Anguilla', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2798, '2021-02-03', 'AI', 'Anguilla', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2799, '2021-02-04', 'AI', 'Anguilla', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2800, '2021-02-05', 'AI', 'Anguilla', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2801, '2020-01-03', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2802, '2020-01-04', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2803, '2020-01-05', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2804, '2020-01-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2805, '2020-01-07', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2806, '2020-01-08', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2807, '2020-01-09', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2808, '2020-01-10', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2809, '2020-01-11', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2810, '2020-01-12', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2811, '2020-01-13', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2812, '2020-01-14', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2813, '2020-01-15', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2814, '2020-01-16', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2815, '2020-01-17', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2816, '2020-01-18', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2817, '2020-01-19', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2818, '2020-01-20', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2819, '2020-01-21', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2820, '2020-01-22', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2821, '2020-01-23', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2822, '2020-01-24', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2823, '2020-01-25', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2824, '2020-01-26', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2825, '2020-01-27', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2826, '2020-01-28', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2827, '2020-01-29', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2828, '2020-01-30', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2829, '2020-01-31', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2830, '2020-02-01', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2831, '2020-02-02', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2832, '2020-02-03', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2833, '2020-02-04', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2834, '2020-02-05', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2835, '2020-02-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2836, '2020-02-07', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2837, '2020-02-08', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2838, '2020-02-09', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2839, '2020-02-10', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2840, '2020-02-11', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2841, '2020-02-12', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2842, '2020-02-13', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2843, '2020-02-14', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2844, '2020-02-15', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2845, '2020-02-16', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2846, '2020-02-17', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2847, '2020-02-18', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2848, '2020-02-19', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2849, '2020-02-20', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2850, '2020-02-21', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2851, '2020-02-22', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2852, '2020-02-23', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2853, '2020-02-24', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2854, '2020-02-25', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2855, '2020-02-26', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2856, '2020-02-27', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2857, '2020-02-28', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2858, '2020-02-29', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2859, '2020-03-01', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2860, '2020-03-02', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2861, '2020-03-03', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2862, '2020-03-04', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2863, '2020-03-05', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2864, '2020-03-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2865, '2020-03-07', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2866, '2020-03-08', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2867, '2020-03-09', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2868, '2020-03-10', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2869, '2020-03-11', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2870, '2020-03-12', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2871, '2020-03-13', 'AG', 'Antigua and Barbuda', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2872, '2020-03-14', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2873, '2020-03-15', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2874, '2020-03-16', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2875, '2020-03-17', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2876, '2020-03-18', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2877, '2020-03-19', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2878, '2020-03-20', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2879, '2020-03-21', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2880, '2020-03-22', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2881, '2020-03-23', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2882, '2020-03-24', 'AG', 'Antigua and Barbuda', 'AMRO', '-2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2883, '2020-03-25', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2884, '2020-03-26', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2885, '2020-03-27', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2886, '2020-03-28', 'AG', 'Antigua and Barbuda', 'AMRO', '4', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2887, '2020-03-29', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2888, '2020-03-30', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2889, '2020-03-31', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2890, '2020-04-01', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2891, '2020-04-02', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2892, '2020-04-03', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2893, '2020-04-04', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2894, '2020-04-05', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2895, '2020-04-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2896, '2020-04-07', 'AG', 'Antigua and Barbuda', 'AMRO', '8', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2897, '2020-04-08', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (2898, '2020-04-09', 'AG', 'Antigua and Barbuda', 'AMRO', '4', '19', '2', '2');
INSERT INTO public.who_global_data_import VALUES (2899, '2020-04-10', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2900, '2020-04-11', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2901, '2020-04-12', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '21', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2902, '2020-04-13', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '21', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2903, '2020-04-14', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2904, '2020-04-15', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2905, '2020-04-16', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2906, '2020-04-17', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2907, '2020-04-18', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2908, '2020-04-19', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (2909, '2020-04-20', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '23', '1', '3');
INSERT INTO public.who_global_data_import VALUES (2910, '2020-04-21', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '23', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2911, '2020-04-22', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '23', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2912, '2020-04-23', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2913, '2020-04-24', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2914, '2020-04-25', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2915, '2020-04-26', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2916, '2020-04-27', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2917, '2020-04-28', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2918, '2020-04-29', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2919, '2020-04-30', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2920, '2020-05-01', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2921, '2020-05-02', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2922, '2020-05-03', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2923, '2020-05-04', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2924, '2020-05-05', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2925, '2020-05-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2926, '2020-05-07', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2927, '2020-05-08', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2928, '2020-05-09', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2929, '2020-05-10', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2930, '2020-05-11', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2931, '2020-05-12', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2932, '2020-05-13', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2933, '2020-05-14', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2934, '2020-05-15', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2935, '2020-05-16', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2936, '2020-05-17', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2937, '2020-05-18', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2938, '2020-05-19', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2939, '2020-05-20', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2940, '2020-05-21', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2941, '2020-05-22', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2942, '2020-05-23', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2943, '2020-05-24', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2944, '2020-05-25', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2945, '2020-05-26', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2946, '2020-05-27', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2947, '2020-05-28', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2948, '2020-05-29', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2949, '2020-05-30', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2950, '2020-05-31', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2951, '2020-06-01', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2952, '2020-06-02', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2953, '2020-06-03', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2954, '2020-06-04', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2955, '2020-06-05', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2956, '2020-06-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2957, '2020-06-07', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2958, '2020-06-08', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2959, '2020-06-09', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2960, '2020-06-10', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2961, '2020-06-11', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2962, '2020-06-12', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2963, '2020-06-13', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2964, '2020-06-14', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2965, '2020-06-15', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2966, '2020-06-16', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2967, '2020-06-17', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2968, '2020-06-18', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2969, '2020-06-19', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2970, '2020-06-20', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2971, '2020-06-21', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2972, '2020-06-22', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2973, '2020-06-23', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2974, '2020-06-24', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2975, '2020-06-25', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2976, '2020-06-26', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2977, '2020-06-27', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2978, '2020-06-28', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '26', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2979, '2020-06-29', 'AG', 'Antigua and Barbuda', 'AMRO', '39', '65', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2980, '2020-06-30', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '65', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2981, '2020-07-01', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '66', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2982, '2020-07-02', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '66', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2983, '2020-07-03', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '68', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2984, '2020-07-04', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '68', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2985, '2020-07-05', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '68', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2986, '2020-07-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '68', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2987, '2020-07-07', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '68', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2988, '2020-07-08', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '70', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2989, '2020-07-09', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '70', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2990, '2020-07-10', 'AG', 'Antigua and Barbuda', 'AMRO', '3', '73', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2991, '2020-07-11', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '73', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2992, '2020-07-12', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '74', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2993, '2020-07-13', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '74', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2994, '2020-07-14', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '74', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2995, '2020-07-15', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '74', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2996, '2020-07-16', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '74', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2997, '2020-07-17', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '74', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2998, '2020-07-18', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '74', '0', '3');
INSERT INTO public.who_global_data_import VALUES (2999, '2020-07-19', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '76', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3000, '2020-07-20', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '76', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3001, '2020-07-21', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '76', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3002, '2020-07-22', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '76', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3003, '2020-07-23', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '76', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3004, '2020-07-24', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '76', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3005, '2020-07-25', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '76', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3006, '2020-07-26', 'AG', 'Antigua and Barbuda', 'AMRO', '6', '82', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3007, '2020-07-27', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '82', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3008, '2020-07-28', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '82', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3009, '2020-07-29', 'AG', 'Antigua and Barbuda', 'AMRO', '4', '86', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3010, '2020-07-30', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '86', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3011, '2020-07-31', 'AG', 'Antigua and Barbuda', 'AMRO', '5', '91', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3012, '2020-08-01', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '91', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3013, '2020-08-02', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '91', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3014, '2020-08-03', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '91', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3015, '2020-08-04', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '91', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3016, '2020-08-05', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '92', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3017, '2020-08-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '92', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3018, '2020-08-07', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '92', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3019, '2020-08-08', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '92', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3020, '2020-08-09', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '92', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3021, '2020-08-10', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '92', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3022, '2020-08-11', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '92', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3023, '2020-08-12', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '92', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3024, '2020-08-13', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '92', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3025, '2020-08-14', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '92', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3026, '2020-08-15', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '93', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3027, '2020-08-16', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '93', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3028, '2020-08-17', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '93', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3029, '2020-08-18', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '93', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3030, '2020-08-19', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '93', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3031, '2020-08-20', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3032, '2020-08-21', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3033, '2020-08-22', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3034, '2020-08-23', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3035, '2020-08-24', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3036, '2020-08-25', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3037, '2020-08-26', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3038, '2020-08-27', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3039, '2020-08-28', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3040, '2020-08-29', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3041, '2020-08-30', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3042, '2020-08-31', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3043, '2020-09-01', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3044, '2020-09-02', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3045, '2020-09-03', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '94', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3046, '2020-09-04', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3047, '2020-09-05', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3048, '2020-09-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3049, '2020-09-07', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3050, '2020-09-08', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3051, '2020-09-09', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3052, '2020-09-10', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3053, '2020-09-11', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3054, '2020-09-12', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3055, '2020-09-13', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3056, '2020-09-14', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3057, '2020-09-15', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3058, '2020-09-16', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3059, '2020-09-17', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3060, '2020-09-18', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3061, '2020-09-19', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3062, '2020-09-20', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3063, '2020-09-21', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '96', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3064, '2020-09-22', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '96', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3065, '2020-09-23', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '96', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3066, '2020-09-24', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '97', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3067, '2020-09-25', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '97', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3068, '2020-09-26', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '98', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3069, '2020-09-27', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '98', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3070, '2020-09-28', 'AG', 'Antigua and Barbuda', 'AMRO', '3', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3071, '2020-09-29', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3072, '2020-09-30', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3073, '2020-10-01', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3074, '2020-10-02', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3075, '2020-10-03', 'AG', 'Antigua and Barbuda', 'AMRO', '5', '106', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3076, '2020-10-04', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '106', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3077, '2020-10-05', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '107', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3078, '2020-10-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '107', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3079, '2020-10-07', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '107', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3080, '2020-10-08', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '108', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3081, '2020-10-09', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '108', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3082, '2020-10-10', 'AG', 'Antigua and Barbuda', 'AMRO', '3', '111', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3083, '2020-10-11', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '111', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3084, '2020-10-12', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '111', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3085, '2020-10-13', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '111', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3086, '2020-10-14', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '111', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3087, '2020-10-15', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '112', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3088, '2020-10-16', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '112', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3089, '2020-10-17', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '112', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3090, '2020-10-18', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '113', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3091, '2020-10-19', 'AG', 'Antigua and Barbuda', 'AMRO', '6', '119', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3092, '2020-10-20', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '119', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3093, '2020-10-21', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '119', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3094, '2020-10-22', 'AG', 'Antigua and Barbuda', 'AMRO', '3', '122', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3095, '2020-10-23', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '122', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3096, '2020-10-24', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '122', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3097, '2020-10-25', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '122', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3098, '2020-10-26', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '124', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3099, '2020-10-27', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '124', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3100, '2020-10-28', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '124', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3101, '2020-10-29', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '124', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3102, '2020-10-30', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '124', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3103, '2020-10-31', 'AG', 'Antigua and Barbuda', 'AMRO', '3', '127', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3104, '2020-11-01', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '127', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3105, '2020-11-02', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '128', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3106, '2020-11-03', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '128', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3107, '2020-11-04', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '128', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3108, '2020-11-05', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '130', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3109, '2020-11-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '130', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3110, '2020-11-07', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '130', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3111, '2020-11-08', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '130', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3112, '2020-11-09', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3113, '2020-11-10', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3114, '2020-11-11', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3115, '2020-11-12', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3116, '2020-11-13', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3117, '2020-11-14', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '133', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3118, '2020-11-15', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '133', '1', '4');
INSERT INTO public.who_global_data_import VALUES (3119, '2020-11-16', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '134', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3120, '2020-11-17', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '134', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3121, '2020-11-18', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '134', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3122, '2020-11-19', 'AG', 'Antigua and Barbuda', 'AMRO', '4', '138', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3123, '2020-11-20', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '139', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3124, '2020-11-21', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '139', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3125, '2020-11-22', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '139', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3126, '2020-11-23', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '139', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3127, '2020-11-24', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '139', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3128, '2020-11-25', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '139', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3129, '2020-11-26', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '140', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3130, '2020-11-27', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '140', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3131, '2020-11-28', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '141', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3132, '2020-11-29', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '141', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3133, '2020-11-30', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '141', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3134, '2020-12-01', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '141', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3135, '2020-12-02', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '141', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3136, '2020-12-03', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '142', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3137, '2020-12-04', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '144', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3138, '2020-12-05', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '144', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3139, '2020-12-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '144', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3140, '2020-12-07', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '144', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3141, '2020-12-08', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '146', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3142, '2020-12-09', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '146', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3143, '2020-12-10', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '146', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3144, '2020-12-11', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '146', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3145, '2020-12-12', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '147', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3146, '2020-12-13', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '147', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3147, '2020-12-14', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '148', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3148, '2020-12-15', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '148', '1', '5');
INSERT INTO public.who_global_data_import VALUES (3149, '2020-12-16', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '148', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3150, '2020-12-17', 'AG', 'Antigua and Barbuda', 'AMRO', '3', '151', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3151, '2020-12-18', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '151', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3152, '2020-12-19', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '151', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3153, '2020-12-20', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '152', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3154, '2020-12-21', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '152', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3155, '2020-12-22', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '153', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3156, '2020-12-23', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '153', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3157, '2020-12-24', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '153', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3158, '2020-12-25', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '154', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3159, '2020-12-26', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '154', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3160, '2020-12-27', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '155', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3161, '2020-12-28', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '155', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3162, '2020-12-29', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '155', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3163, '2020-12-30', 'AG', 'Antigua and Barbuda', 'AMRO', '3', '158', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3164, '2020-12-31', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '158', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3165, '2021-01-01', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '159', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3166, '2021-01-02', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '159', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3167, '2021-01-03', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '159', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3168, '2021-01-04', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '159', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3169, '2021-01-05', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '160', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3170, '2021-01-06', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '160', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3171, '2021-01-07', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '160', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3172, '2021-01-08', 'AG', 'Antigua and Barbuda', 'AMRO', '3', '163', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3173, '2021-01-09', 'AG', 'Antigua and Barbuda', 'AMRO', '4', '167', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3174, '2021-01-10', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '169', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3175, '2021-01-11', 'AG', 'Antigua and Barbuda', 'AMRO', '7', '176', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3176, '2021-01-12', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '176', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3177, '2021-01-13', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '176', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3178, '2021-01-14', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '176', '0', '5');
INSERT INTO public.who_global_data_import VALUES (3179, '2021-01-15', 'AG', 'Antigua and Barbuda', 'AMRO', '8', '184', '1', '6');
INSERT INTO public.who_global_data_import VALUES (3180, '2021-01-16', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '184', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3181, '2021-01-17', 'AG', 'Antigua and Barbuda', 'AMRO', '3', '187', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3182, '2021-01-18', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '187', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3183, '2021-01-19', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '189', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3184, '2021-01-20', 'AG', 'Antigua and Barbuda', 'AMRO', '1', '190', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3185, '2021-01-21', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '190', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3186, '2021-01-22', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '190', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3187, '2021-01-23', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '192', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3188, '2021-01-24', 'AG', 'Antigua and Barbuda', 'AMRO', '3', '195', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3189, '2021-01-25', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '195', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3190, '2021-01-26', 'AG', 'Antigua and Barbuda', 'AMRO', '6', '201', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3191, '2021-01-27', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '201', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3192, '2021-01-28', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '201', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3193, '2021-01-29', 'AG', 'Antigua and Barbuda', 'AMRO', '14', '215', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3194, '2021-01-30', 'AG', 'Antigua and Barbuda', 'AMRO', '3', '218', '0', '6');
INSERT INTO public.who_global_data_import VALUES (3195, '2021-01-31', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '218', '1', '7');
INSERT INTO public.who_global_data_import VALUES (3196, '2021-02-01', 'AG', 'Antigua and Barbuda', 'AMRO', '2', '220', '0', '7');
INSERT INTO public.who_global_data_import VALUES (3197, '2021-02-02', 'AG', 'Antigua and Barbuda', 'AMRO', '14', '234', '0', '7');
INSERT INTO public.who_global_data_import VALUES (3198, '2021-02-03', 'AG', 'Antigua and Barbuda', 'AMRO', '0', '234', '0', '7');
INSERT INTO public.who_global_data_import VALUES (3199, '2021-02-04', 'AG', 'Antigua and Barbuda', 'AMRO', '15', '249', '0', '7');
INSERT INTO public.who_global_data_import VALUES (3200, '2021-02-05', 'AG', 'Antigua and Barbuda', 'AMRO', '19', '268', '0', '7');
INSERT INTO public.who_global_data_import VALUES (3201, '2020-01-03', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3202, '2020-01-04', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3203, '2020-01-05', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3204, '2020-01-06', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3205, '2020-01-07', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3206, '2020-01-08', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3207, '2020-01-09', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3208, '2020-01-10', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3209, '2020-01-11', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3210, '2020-01-12', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3211, '2020-01-13', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3212, '2020-01-14', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3213, '2020-01-15', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3214, '2020-01-16', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3215, '2020-01-17', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3216, '2020-01-18', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3217, '2020-01-19', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3218, '2020-01-20', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3219, '2020-01-21', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3220, '2020-01-22', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3221, '2020-01-23', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3222, '2020-01-24', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3223, '2020-01-25', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3224, '2020-01-26', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3225, '2020-01-27', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3226, '2020-01-28', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3227, '2020-01-29', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3228, '2020-01-30', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3229, '2020-01-31', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3230, '2020-02-01', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3231, '2020-02-02', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3232, '2020-02-03', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3233, '2020-02-04', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3234, '2020-02-05', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3235, '2020-02-06', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3236, '2020-02-07', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3237, '2020-02-08', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3238, '2020-02-09', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3239, '2020-02-10', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3240, '2020-02-11', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3241, '2020-02-12', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3242, '2020-02-13', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3243, '2020-02-14', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3244, '2020-02-15', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3245, '2020-02-16', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3246, '2020-02-17', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3247, '2020-02-18', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3248, '2020-02-19', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3249, '2020-02-20', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3250, '2020-02-21', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3251, '2020-02-22', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3252, '2020-02-23', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3253, '2020-02-24', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3254, '2020-02-25', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3255, '2020-02-26', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3256, '2020-02-27', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3257, '2020-02-28', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3258, '2020-02-29', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3259, '2020-03-01', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3260, '2020-03-02', 'AR', 'Argentina', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3261, '2020-03-03', 'AR', 'Argentina', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3262, '2020-03-04', 'AR', 'Argentina', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3263, '2020-03-05', 'AR', 'Argentina', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3264, '2020-03-06', 'AR', 'Argentina', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3265, '2020-03-07', 'AR', 'Argentina', 'AMRO', '7', '13', '1', '1');
INSERT INTO public.who_global_data_import VALUES (3266, '2020-03-08', 'AR', 'Argentina', 'AMRO', '3', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (3267, '2020-03-09', 'AR', 'Argentina', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (3268, '2020-03-10', 'AR', 'Argentina', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (3269, '2020-03-11', 'AR', 'Argentina', 'AMRO', '5', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (3270, '2020-03-12', 'AR', 'Argentina', 'AMRO', '2', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (3271, '2020-03-13', 'AR', 'Argentina', 'AMRO', '12', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (3272, '2020-03-14', 'AR', 'Argentina', 'AMRO', '14', '49', '1', '2');
INSERT INTO public.who_global_data_import VALUES (3273, '2020-03-15', 'AR', 'Argentina', 'AMRO', '0', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (3274, '2020-03-16', 'AR', 'Argentina', 'AMRO', '11', '60', '0', '2');
INSERT INTO public.who_global_data_import VALUES (3275, '2020-03-17', 'AR', 'Argentina', 'AMRO', '9', '69', '0', '2');
INSERT INTO public.who_global_data_import VALUES (3276, '2020-03-18', 'AR', 'Argentina', 'AMRO', '32', '101', '0', '2');
INSERT INTO public.who_global_data_import VALUES (3277, '2020-03-19', 'AR', 'Argentina', 'AMRO', '0', '101', '0', '2');
INSERT INTO public.who_global_data_import VALUES (3278, '2020-03-20', 'AR', 'Argentina', 'AMRO', '27', '128', '1', '3');
INSERT INTO public.who_global_data_import VALUES (3279, '2020-03-21', 'AR', 'Argentina', 'AMRO', '30', '158', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3280, '2020-03-22', 'AR', 'Argentina', 'AMRO', '0', '158', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3281, '2020-03-23', 'AR', 'Argentina', 'AMRO', '67', '225', '1', '4');
INSERT INTO public.who_global_data_import VALUES (3282, '2020-03-24', 'AR', 'Argentina', 'AMRO', '76', '301', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3283, '2020-03-25', 'AR', 'Argentina', 'AMRO', '0', '301', '0', '4');
INSERT INTO public.who_global_data_import VALUES (3284, '2020-03-26', 'AR', 'Argentina', 'AMRO', '201', '502', '4', '8');
INSERT INTO public.who_global_data_import VALUES (3285, '2020-03-27', 'AR', 'Argentina', 'AMRO', '0', '502', '0', '8');
INSERT INTO public.who_global_data_import VALUES (3286, '2020-03-28', 'AR', 'Argentina', 'AMRO', '87', '589', '4', '12');
INSERT INTO public.who_global_data_import VALUES (3287, '2020-03-29', 'AR', 'Argentina', 'AMRO', '101', '690', '5', '17');
INSERT INTO public.who_global_data_import VALUES (3288, '2020-03-30', 'AR', 'Argentina', 'AMRO', '55', '745', '2', '19');
INSERT INTO public.who_global_data_import VALUES (3289, '2020-03-31', 'AR', 'Argentina', 'AMRO', '75', '820', '1', '20');
INSERT INTO public.who_global_data_import VALUES (3290, '2020-04-01', 'AR', 'Argentina', 'AMRO', '146', '966', '4', '24');
INSERT INTO public.who_global_data_import VALUES (3291, '2020-04-02', 'AR', 'Argentina', 'AMRO', '88', '1054', '3', '27');
INSERT INTO public.who_global_data_import VALUES (3292, '2020-04-03', 'AR', 'Argentina', 'AMRO', '79', '1133', '4', '31');
INSERT INTO public.who_global_data_import VALUES (3293, '2020-04-04', 'AR', 'Argentina', 'AMRO', '132', '1265', '6', '37');
INSERT INTO public.who_global_data_import VALUES (3294, '2020-04-05', 'AR', 'Argentina', 'AMRO', '88', '1353', '5', '42');
INSERT INTO public.who_global_data_import VALUES (3295, '2020-04-06', 'AR', 'Argentina', 'AMRO', '98', '1451', '2', '44');
INSERT INTO public.who_global_data_import VALUES (3296, '2020-04-07', 'AR', 'Argentina', 'AMRO', '103', '1554', '2', '46');
INSERT INTO public.who_global_data_import VALUES (3297, '2020-04-08', 'AR', 'Argentina', 'AMRO', '74', '1628', '7', '53');
INSERT INTO public.who_global_data_import VALUES (3298, '2020-04-09', 'AR', 'Argentina', 'AMRO', '87', '1715', '7', '60');
INSERT INTO public.who_global_data_import VALUES (3299, '2020-04-10', 'AR', 'Argentina', 'AMRO', '80', '1795', '7', '67');
INSERT INTO public.who_global_data_import VALUES (3300, '2020-04-11', 'AR', 'Argentina', 'AMRO', '134', '1929', '12', '79');
INSERT INTO public.who_global_data_import VALUES (3301, '2020-04-12', 'AR', 'Argentina', 'AMRO', '46', '1975', '3', '82');
INSERT INTO public.who_global_data_import VALUES (3302, '2020-04-13', 'AR', 'Argentina', 'AMRO', '0', '1975', '0', '82');
INSERT INTO public.who_global_data_import VALUES (3303, '2020-04-14', 'AR', 'Argentina', 'AMRO', '277', '2252', '13', '95');
INSERT INTO public.who_global_data_import VALUES (3304, '2020-04-15', 'AR', 'Argentina', 'AMRO', '84', '2336', '6', '101');
INSERT INTO public.who_global_data_import VALUES (3305, '2020-04-16', 'AR', 'Argentina', 'AMRO', '141', '2477', '7', '108');
INSERT INTO public.who_global_data_import VALUES (3306, '2020-04-17', 'AR', 'Argentina', 'AMRO', '121', '2598', '7', '115');
INSERT INTO public.who_global_data_import VALUES (3307, '2020-04-18', 'AR', 'Argentina', 'AMRO', '96', '2694', '7', '122');
INSERT INTO public.who_global_data_import VALUES (3308, '2020-04-19', 'AR', 'Argentina', 'AMRO', '90', '2784', '7', '129');
INSERT INTO public.who_global_data_import VALUES (3309, '2020-04-20', 'AR', 'Argentina', 'AMRO', '55', '2839', '3', '132');
INSERT INTO public.who_global_data_import VALUES (3310, '2020-04-21', 'AR', 'Argentina', 'AMRO', '121', '2960', '4', '136');
INSERT INTO public.who_global_data_import VALUES (3311, '2020-04-22', 'AR', 'Argentina', 'AMRO', '113', '3073', '9', '145');
INSERT INTO public.who_global_data_import VALUES (3312, '2020-04-23', 'AR', 'Argentina', 'AMRO', '124', '3197', '7', '152');
INSERT INTO public.who_global_data_import VALUES (3313, '2020-04-24', 'AR', 'Argentina', 'AMRO', '143', '3340', '7', '159');
INSERT INTO public.who_global_data_import VALUES (3314, '2020-04-25', 'AR', 'Argentina', 'AMRO', '139', '3479', '8', '167');
INSERT INTO public.who_global_data_import VALUES (3315, '2020-04-26', 'AR', 'Argentina', 'AMRO', '222', '3701', '12', '179');
INSERT INTO public.who_global_data_import VALUES (3316, '2020-04-27', 'AR', 'Argentina', 'AMRO', '137', '3838', '0', '179');
INSERT INTO public.who_global_data_import VALUES (3317, '2020-04-28', 'AR', 'Argentina', 'AMRO', '54', '3892', '13', '192');
INSERT INTO public.who_global_data_import VALUES (3318, '2020-04-29', 'AR', 'Argentina', 'AMRO', '127', '4019', '5', '197');
INSERT INTO public.who_global_data_import VALUES (3319, '2020-04-30', 'AR', 'Argentina', 'AMRO', '182', '4201', '10', '207');
INSERT INTO public.who_global_data_import VALUES (3320, '2020-05-01', 'AR', 'Argentina', 'AMRO', '103', '4304', '8', '215');
INSERT INTO public.who_global_data_import VALUES (3321, '2020-05-02', 'AR', 'Argentina', 'AMRO', '172', '4476', '5', '220');
INSERT INTO public.who_global_data_import VALUES (3322, '2020-05-03', 'AR', 'Argentina', 'AMRO', '56', '4532', '9', '229');
INSERT INTO public.who_global_data_import VALUES (3323, '2020-05-04', 'AR', 'Argentina', 'AMRO', '149', '4681', '12', '241');
INSERT INTO public.who_global_data_import VALUES (3324, '2020-05-05', 'AR', 'Argentina', 'AMRO', '118', '4799', '9', '250');
INSERT INTO public.who_global_data_import VALUES (3325, '2020-05-06', 'AR', 'Argentina', 'AMRO', '123', '4922', '12', '262');
INSERT INTO public.who_global_data_import VALUES (3326, '2020-05-07', 'AR', 'Argentina', 'AMRO', '154', '5076', '2', '264');
INSERT INTO public.who_global_data_import VALUES (3327, '2020-05-08', 'AR', 'Argentina', 'AMRO', '229', '5305', '11', '275');
INSERT INTO public.who_global_data_import VALUES (3328, '2020-05-09', 'AR', 'Argentina', 'AMRO', '225', '5530', '14', '289');
INSERT INTO public.who_global_data_import VALUES (3329, '2020-05-10', 'AR', 'Argentina', 'AMRO', '150', '5680', '8', '297');
INSERT INTO public.who_global_data_import VALUES (3330, '2020-05-11', 'AR', 'Argentina', 'AMRO', '244', '5924', '3', '300');
INSERT INTO public.who_global_data_import VALUES (3331, '2020-05-12', 'AR', 'Argentina', 'AMRO', '110', '6034', '5', '305');
INSERT INTO public.who_global_data_import VALUES (3332, '2020-05-13', 'AR', 'Argentina', 'AMRO', '244', '6278', '12', '317');
INSERT INTO public.who_global_data_import VALUES (3333, '2020-05-14', 'AR', 'Argentina', 'AMRO', '285', '6563', '4', '321');
INSERT INTO public.who_global_data_import VALUES (3334, '2020-05-15', 'AR', 'Argentina', 'AMRO', '410', '6973', '24', '345');
INSERT INTO public.who_global_data_import VALUES (3335, '2020-05-16', 'AR', 'Argentina', 'AMRO', '161', '7134', '8', '353');
INSERT INTO public.who_global_data_import VALUES (3336, '2020-05-17', 'AR', 'Argentina', 'AMRO', '345', '7479', '10', '363');
INSERT INTO public.who_global_data_import VALUES (3337, '2020-05-18', 'AR', 'Argentina', 'AMRO', '326', '7805', '3', '366');
INSERT INTO public.who_global_data_import VALUES (3338, '2020-05-19', 'AR', 'Argentina', 'AMRO', '263', '8068', '7', '373');
INSERT INTO public.who_global_data_import VALUES (3339, '2020-05-20', 'AR', 'Argentina', 'AMRO', '303', '8371', '9', '382');
INSERT INTO public.who_global_data_import VALUES (3340, '2020-05-21', 'AR', 'Argentina', 'AMRO', '438', '8809', '11', '393');
INSERT INTO public.who_global_data_import VALUES (3341, '2020-05-22', 'AR', 'Argentina', 'AMRO', '474', '9283', '10', '403');
INSERT INTO public.who_global_data_import VALUES (3342, '2020-05-23', 'AR', 'Argentina', 'AMRO', '648', '9931', '16', '419');
INSERT INTO public.who_global_data_import VALUES (3343, '2020-05-24', 'AR', 'Argentina', 'AMRO', '718', '10649', '20', '439');
INSERT INTO public.who_global_data_import VALUES (3344, '2020-05-25', 'AR', 'Argentina', 'AMRO', '704', '11353', '6', '445');
INSERT INTO public.who_global_data_import VALUES (3345, '2020-05-26', 'AR', 'Argentina', 'AMRO', '723', '12076', '7', '452');
INSERT INTO public.who_global_data_import VALUES (3346, '2020-05-27', 'AR', 'Argentina', 'AMRO', '552', '12628', '19', '471');
INSERT INTO public.who_global_data_import VALUES (3347, '2020-05-28', 'AR', 'Argentina', 'AMRO', '600', '13228', '21', '492');
INSERT INTO public.who_global_data_import VALUES (3348, '2020-05-29', 'AR', 'Argentina', 'AMRO', '705', '13933', '9', '501');
INSERT INTO public.who_global_data_import VALUES (3349, '2020-05-30', 'AR', 'Argentina', 'AMRO', '769', '14702', '9', '510');
INSERT INTO public.who_global_data_import VALUES (3350, '2020-05-31', 'AR', 'Argentina', 'AMRO', '0', '14702', '0', '510');
INSERT INTO public.who_global_data_import VALUES (3351, '2020-06-01', 'AR', 'Argentina', 'AMRO', '1512', '16214', '20', '530');
INSERT INTO public.who_global_data_import VALUES (3352, '2020-06-02', 'AR', 'Argentina', 'AMRO', '637', '16851', '11', '541');
INSERT INTO public.who_global_data_import VALUES (3353, '2020-06-03', 'AR', 'Argentina', 'AMRO', '564', '17415', '19', '560');
INSERT INTO public.who_global_data_import VALUES (3354, '2020-06-04', 'AR', 'Argentina', 'AMRO', '904', '18319', '10', '570');
INSERT INTO public.who_global_data_import VALUES (3355, '2020-06-05', 'AR', 'Argentina', 'AMRO', '949', '19268', '18', '588');
INSERT INTO public.who_global_data_import VALUES (3356, '2020-06-06', 'AR', 'Argentina', 'AMRO', '929', '20197', '27', '615');
INSERT INTO public.who_global_data_import VALUES (3357, '2020-06-07', 'AR', 'Argentina', 'AMRO', '840', '21037', '27', '642');
INSERT INTO public.who_global_data_import VALUES (3358, '2020-06-08', 'AR', 'Argentina', 'AMRO', '983', '22020', '14', '656');
INSERT INTO public.who_global_data_import VALUES (3359, '2020-06-09', 'AR', 'Argentina', 'AMRO', '774', '22794', '14', '670');
INSERT INTO public.who_global_data_import VALUES (3360, '2020-06-10', 'AR', 'Argentina', 'AMRO', '826', '23620', '28', '698');
INSERT INTO public.who_global_data_import VALUES (3361, '2020-06-11', 'AR', 'Argentina', 'AMRO', '1141', '24761', '19', '717');
INSERT INTO public.who_global_data_import VALUES (3362, '2020-06-12', 'AR', 'Argentina', 'AMRO', '1226', '25987', '24', '741');
INSERT INTO public.who_global_data_import VALUES (3363, '2020-06-13', 'AR', 'Argentina', 'AMRO', '1386', '27373', '31', '772');
INSERT INTO public.who_global_data_import VALUES (3364, '2020-06-14', 'AR', 'Argentina', 'AMRO', '1391', '28764', '30', '802');
INSERT INTO public.who_global_data_import VALUES (3365, '2020-06-15', 'AR', 'Argentina', 'AMRO', '1531', '30295', '17', '819');
INSERT INTO public.who_global_data_import VALUES (3366, '2020-06-16', 'AR', 'Argentina', 'AMRO', '1282', '31577', '23', '842');
INSERT INTO public.who_global_data_import VALUES (3367, '2020-06-17', 'AR', 'Argentina', 'AMRO', '1208', '32785', '20', '862');
INSERT INTO public.who_global_data_import VALUES (3368, '2020-06-18', 'AR', 'Argentina', 'AMRO', '1374', '34159', '24', '886');
INSERT INTO public.who_global_data_import VALUES (3369, '2020-06-19', 'AR', 'Argentina', 'AMRO', '1393', '35552', '43', '929');
INSERT INTO public.who_global_data_import VALUES (3370, '2020-06-20', 'AR', 'Argentina', 'AMRO', '1958', '37510', '25', '954');
INSERT INTO public.who_global_data_import VALUES (3371, '2020-06-21', 'AR', 'Argentina', 'AMRO', '2060', '39570', '25', '979');
INSERT INTO public.who_global_data_import VALUES (3372, '2020-06-22', 'AR', 'Argentina', 'AMRO', '1634', '41204', '13', '992');
INSERT INTO public.who_global_data_import VALUES (3373, '2020-06-23', 'AR', 'Argentina', 'AMRO', '1581', '42785', '24', '1016');
INSERT INTO public.who_global_data_import VALUES (3374, '2020-06-24', 'AR', 'Argentina', 'AMRO', '2146', '44931', '33', '1049');
INSERT INTO public.who_global_data_import VALUES (3375, '2020-06-25', 'AR', 'Argentina', 'AMRO', '2285', '47216', '36', '1085');
INSERT INTO public.who_global_data_import VALUES (3376, '2020-06-26', 'AR', 'Argentina', 'AMRO', '2635', '49851', '39', '1124');
INSERT INTO public.who_global_data_import VALUES (3377, '2020-06-27', 'AR', 'Argentina', 'AMRO', '2606', '52457', '43', '1167');
INSERT INTO public.who_global_data_import VALUES (3378, '2020-06-28', 'AR', 'Argentina', 'AMRO', '2886', '55343', '25', '1192');
INSERT INTO public.who_global_data_import VALUES (3379, '2020-06-29', 'AR', 'Argentina', 'AMRO', '2401', '57744', '25', '1217');
INSERT INTO public.who_global_data_import VALUES (3380, '2020-06-30', 'AR', 'Argentina', 'AMRO', '2189', '59933', '28', '1245');
INSERT INTO public.who_global_data_import VALUES (3381, '2020-07-01', 'AR', 'Argentina', 'AMRO', '2335', '62268', '38', '1283');
INSERT INTO public.who_global_data_import VALUES (3382, '2020-07-02', 'AR', 'Argentina', 'AMRO', '2262', '64530', '27', '1310');
INSERT INTO public.who_global_data_import VALUES (3383, '2020-07-03', 'AR', 'Argentina', 'AMRO', '2667', '67197', '53', '1363');
INSERT INTO public.who_global_data_import VALUES (3384, '2020-07-04', 'AR', 'Argentina', 'AMRO', '2744', '69941', '40', '1403');
INSERT INTO public.who_global_data_import VALUES (3385, '2020-07-05', 'AR', 'Argentina', 'AMRO', '2845', '72786', '50', '1453');
INSERT INTO public.who_global_data_import VALUES (3386, '2020-07-06', 'AR', 'Argentina', 'AMRO', '2590', '75376', '37', '1490');
INSERT INTO public.who_global_data_import VALUES (3387, '2020-07-07', 'AR', 'Argentina', 'AMRO', '2439', '77815', '33', '1523');
INSERT INTO public.who_global_data_import VALUES (3388, '2020-07-08', 'AR', 'Argentina', 'AMRO', '2632', '80447', '79', '1602');
INSERT INTO public.who_global_data_import VALUES (3389, '2020-07-09', 'AR', 'Argentina', 'AMRO', '2979', '83426', '52', '1654');
INSERT INTO public.who_global_data_import VALUES (3390, '2020-07-10', 'AR', 'Argentina', 'AMRO', '3604', '87030', '53', '1707');
INSERT INTO public.who_global_data_import VALUES (3391, '2020-07-11', 'AR', 'Argentina', 'AMRO', '3663', '90693', '42', '1749');
INSERT INTO public.who_global_data_import VALUES (3392, '2020-07-12', 'AR', 'Argentina', 'AMRO', '3367', '94060', '38', '1787');
INSERT INTO public.who_global_data_import VALUES (3393, '2020-07-13', 'AR', 'Argentina', 'AMRO', '3449', '97509', '31', '1818');
INSERT INTO public.who_global_data_import VALUES (3394, '2020-07-14', 'AR', 'Argentina', 'AMRO', '2657', '100166', '41', '1859');
INSERT INTO public.who_global_data_import VALUES (3395, '2020-07-15', 'AR', 'Argentina', 'AMRO', '3099', '103265', '67', '1926');
INSERT INTO public.who_global_data_import VALUES (3396, '2020-07-16', 'AR', 'Argentina', 'AMRO', '3645', '106910', '61', '1987');
INSERT INTO public.who_global_data_import VALUES (3397, '2020-07-17', 'AR', 'Argentina', 'AMRO', '4250', '111160', '85', '2072');
INSERT INTO public.who_global_data_import VALUES (3398, '2020-07-18', 'AR', 'Argentina', 'AMRO', '3623', '114783', '61', '2133');
INSERT INTO public.who_global_data_import VALUES (3399, '2020-07-19', 'AR', 'Argentina', 'AMRO', '4518', '119301', '71', '2204');
INSERT INTO public.who_global_data_import VALUES (3400, '2020-07-20', 'AR', 'Argentina', 'AMRO', '3223', '122524', '42', '2246');
INSERT INTO public.who_global_data_import VALUES (3401, '2020-07-21', 'AR', 'Argentina', 'AMRO', '4231', '126755', '35', '2281');
INSERT INTO public.who_global_data_import VALUES (3402, '2020-07-22', 'AR', 'Argentina', 'AMRO', '4019', '130774', '145', '2426');
INSERT INTO public.who_global_data_import VALUES (3403, '2020-07-23', 'AR', 'Argentina', 'AMRO', '5344', '136118', '80', '2506');
INSERT INTO public.who_global_data_import VALUES (3404, '2020-07-24', 'AR', 'Argentina', 'AMRO', '5782', '141900', '111', '2617');
INSERT INTO public.who_global_data_import VALUES (3405, '2020-07-25', 'AR', 'Argentina', 'AMRO', '6127', '148027', '105', '2722');
INSERT INTO public.who_global_data_import VALUES (3406, '2020-07-26', 'AR', 'Argentina', 'AMRO', '5493', '153520', '125', '2847');
INSERT INTO public.who_global_data_import VALUES (3407, '2020-07-27', 'AR', 'Argentina', 'AMRO', '4801', '158321', '66', '2913');
INSERT INTO public.who_global_data_import VALUES (3408, '2020-07-28', 'AR', 'Argentina', 'AMRO', '4205', '162526', '43', '2956');
INSERT INTO public.who_global_data_import VALUES (3409, '2020-07-29', 'AR', 'Argentina', 'AMRO', '4890', '167416', '126', '3082');
INSERT INTO public.who_global_data_import VALUES (3410, '2020-07-30', 'AR', 'Argentina', 'AMRO', '5939', '173355', '118', '3200');
INSERT INTO public.who_global_data_import VALUES (3411, '2020-07-31', 'AR', 'Argentina', 'AMRO', '5641', '178996', '111', '3311');
INSERT INTO public.who_global_data_import VALUES (3412, '2020-08-01', 'AR', 'Argentina', 'AMRO', '6377', '185373', '155', '3466');
INSERT INTO public.who_global_data_import VALUES (3413, '2020-08-02', 'AR', 'Argentina', 'AMRO', '5929', '191302', '77', '3543');
INSERT INTO public.who_global_data_import VALUES (3414, '2020-08-03', 'AR', 'Argentina', 'AMRO', '5241', '196543', '69', '3612');
INSERT INTO public.who_global_data_import VALUES (3415, '2020-08-04', 'AR', 'Argentina', 'AMRO', '5376', '201919', '55', '3667');
INSERT INTO public.who_global_data_import VALUES (3416, '2020-08-05', 'AR', 'Argentina', 'AMRO', '4824', '206743', '196', '3863');
INSERT INTO public.who_global_data_import VALUES (3417, '2020-08-06', 'AR', 'Argentina', 'AMRO', '6792', '213535', '146', '4009');
INSERT INTO public.who_global_data_import VALUES (3418, '2020-08-07', 'AR', 'Argentina', 'AMRO', '7147', '220682', '126', '4135');
INSERT INTO public.who_global_data_import VALUES (3419, '2020-08-08', 'AR', 'Argentina', 'AMRO', '7513', '228195', '156', '4291');
INSERT INTO public.who_global_data_import VALUES (3420, '2020-08-09', 'AR', 'Argentina', 'AMRO', '7482', '235677', '159', '4450');
INSERT INTO public.who_global_data_import VALUES (3421, '2020-08-10', 'AR', 'Argentina', 'AMRO', '6134', '241811', '106', '4556');
INSERT INTO public.who_global_data_import VALUES (3422, '2020-08-11', 'AR', 'Argentina', 'AMRO', '4688', '246499', '78', '4634');
INSERT INTO public.who_global_data_import VALUES (3423, '2020-08-12', 'AR', 'Argentina', 'AMRO', '7369', '253868', '151', '4785');
INSERT INTO public.who_global_data_import VALUES (3424, '2020-08-13', 'AR', 'Argentina', 'AMRO', '7043', '260911', '303', '5088');
INSERT INTO public.who_global_data_import VALUES (3425, '2020-08-14', 'AR', 'Argentina', 'AMRO', '7663', '268574', '158', '5246');
INSERT INTO public.who_global_data_import VALUES (3426, '2020-08-15', 'AR', 'Argentina', 'AMRO', '7498', '276072', '182', '5428');
INSERT INTO public.who_global_data_import VALUES (3427, '2020-08-16', 'AR', 'Argentina', 'AMRO', '6365', '282437', '137', '5565');
INSERT INTO public.who_global_data_import VALUES (3428, '2020-08-17', 'AR', 'Argentina', 'AMRO', '6663', '289100', '92', '5657');
INSERT INTO public.who_global_data_import VALUES (3429, '2020-08-18', 'AR', 'Argentina', 'AMRO', '5469', '294569', '93', '5750');
INSERT INTO public.who_global_data_import VALUES (3430, '2020-08-19', 'AR', 'Argentina', 'AMRO', '4557', '299126', '127', '5877');
INSERT INTO public.who_global_data_import VALUES (3431, '2020-08-20', 'AR', 'Argentina', 'AMRO', '6840', '305966', '237', '6114');
INSERT INTO public.who_global_data_import VALUES (3432, '2020-08-21', 'AR', 'Argentina', 'AMRO', '6693', '312659', '292', '6406');
INSERT INTO public.who_global_data_import VALUES (3433, '2020-08-22', 'AR', 'Argentina', 'AMRO', '8225', '320884', '161', '6567');
INSERT INTO public.who_global_data_import VALUES (3434, '2020-08-23', 'AR', 'Argentina', 'AMRO', '8159', '329043', '228', '6795');
INSERT INTO public.who_global_data_import VALUES (3435, '2020-08-24', 'AR', 'Argentina', 'AMRO', '7759', '336802', '152', '6947');
INSERT INTO public.who_global_data_import VALUES (3436, '2020-08-25', 'AR', 'Argentina', 'AMRO', '5352', '342154', '132', '7079');
INSERT INTO public.who_global_data_import VALUES (3437, '2020-08-26', 'AR', 'Argentina', 'AMRO', '8713', '350867', '323', '7402');
INSERT INTO public.who_global_data_import VALUES (3438, '2020-08-27', 'AR', 'Argentina', 'AMRO', '8771', '359638', '259', '7661');
INSERT INTO public.who_global_data_import VALUES (3439, '2020-08-28', 'AR', 'Argentina', 'AMRO', '10550', '370188', '283', '7944');
INSERT INTO public.who_global_data_import VALUES (3440, '2020-08-29', 'AR', 'Argentina', 'AMRO', '10104', '380292', '185', '8129');
INSERT INTO public.who_global_data_import VALUES (3441, '2020-08-30', 'AR', 'Argentina', 'AMRO', '11717', '392009', '176', '8305');
INSERT INTO public.who_global_data_import VALUES (3442, '2020-08-31', 'AR', 'Argentina', 'AMRO', '9230', '401239', '96', '8401');
INSERT INTO public.who_global_data_import VALUES (3443, '2020-09-01', 'AR', 'Argentina', 'AMRO', '7187', '408426', '97', '8498');
INSERT INTO public.who_global_data_import VALUES (3444, '2020-09-02', 'AR', 'Argentina', 'AMRO', '9309', '417735', '232', '8730');
INSERT INTO public.who_global_data_import VALUES (3445, '2020-09-03', 'AR', 'Argentina', 'AMRO', '10504', '428239', '241', '8971');
INSERT INTO public.who_global_data_import VALUES (3446, '2020-09-04', 'AR', 'Argentina', 'AMRO', '10933', '439172', '184', '9155');
INSERT INTO public.who_global_data_import VALUES (3447, '2020-09-05', 'AR', 'Argentina', 'AMRO', '12026', '451198', '313', '9468');
INSERT INTO public.who_global_data_import VALUES (3448, '2020-09-06', 'AR', 'Argentina', 'AMRO', '10684', '461882', '217', '9685');
INSERT INTO public.who_global_data_import VALUES (3449, '2020-09-07', 'AR', 'Argentina', 'AMRO', '9924', '471806', '122', '9807');
INSERT INTO public.who_global_data_import VALUES (3450, '2020-09-08', 'AR', 'Argentina', 'AMRO', '6986', '478792', '105', '9912');
INSERT INTO public.who_global_data_import VALUES (3451, '2020-09-09', 'AR', 'Argentina', 'AMRO', '9215', '488007', '267', '10179');
INSERT INTO public.who_global_data_import VALUES (3452, '2020-09-10', 'AR', 'Argentina', 'AMRO', '12027', '500034', '278', '10457');
INSERT INTO public.who_global_data_import VALUES (3453, '2020-09-11', 'AR', 'Argentina', 'AMRO', '12259', '512293', '256', '10713');
INSERT INTO public.who_global_data_import VALUES (3454, '2020-09-12', 'AR', 'Argentina', 'AMRO', '11905', '524198', '281', '10994');
INSERT INTO public.who_global_data_import VALUES (3455, '2020-09-13', 'AR', 'Argentina', 'AMRO', '11507', '535705', '212', '11206');
INSERT INTO public.who_global_data_import VALUES (3456, '2020-09-14', 'AR', 'Argentina', 'AMRO', '10776', '546481', '101', '11307');
INSERT INTO public.who_global_data_import VALUES (3457, '2020-09-15', 'AR', 'Argentina', 'AMRO', '9056', '555537', '105', '11412');
INSERT INTO public.who_global_data_import VALUES (3458, '2020-09-16', 'AR', 'Argentina', 'AMRO', '9909', '565446', '298', '11710');
INSERT INTO public.who_global_data_import VALUES (3459, '2020-09-17', 'AR', 'Argentina', 'AMRO', '11892', '577338', '200', '11910');
INSERT INTO public.who_global_data_import VALUES (3460, '2020-09-18', 'AR', 'Argentina', 'AMRO', '11674', '589012', '319', '12229');
INSERT INTO public.who_global_data_import VALUES (3461, '2020-09-19', 'AR', 'Argentina', 'AMRO', '12701', '601713', '262', '12491');
INSERT INTO public.who_global_data_import VALUES (3462, '2020-09-20', 'AR', 'Argentina', 'AMRO', '11945', '613658', '214', '12705');
INSERT INTO public.who_global_data_import VALUES (3463, '2020-09-21', 'AR', 'Argentina', 'AMRO', '9276', '622934', '204', '12909');
INSERT INTO public.who_global_data_import VALUES (3464, '2020-09-22', 'AR', 'Argentina', 'AMRO', '8431', '631365', '144', '13053');
INSERT INTO public.who_global_data_import VALUES (3465, '2020-09-23', 'AR', 'Argentina', 'AMRO', '8782', '640147', '429', '13482');
INSERT INTO public.who_global_data_import VALUES (3466, '2020-09-24', 'AR', 'Argentina', 'AMRO', '12027', '652174', '470', '13952');
INSERT INTO public.who_global_data_import VALUES (3467, '2020-09-25', 'AR', 'Argentina', 'AMRO', '12625', '664799', '424', '14376');
INSERT INTO public.who_global_data_import VALUES (3468, '2020-09-26', 'AR', 'Argentina', 'AMRO', '13467', '678266', '390', '14766');
INSERT INTO public.who_global_data_import VALUES (3469, '2020-09-27', 'AR', 'Argentina', 'AMRO', '12969', '691235', '442', '15208');
INSERT INTO public.who_global_data_import VALUES (3470, '2020-09-28', 'AR', 'Argentina', 'AMRO', '11249', '702484', '335', '15543');
INSERT INTO public.who_global_data_import VALUES (3471, '2020-09-29', 'AR', 'Argentina', 'AMRO', '8841', '711325', '206', '15749');
INSERT INTO public.who_global_data_import VALUES (3472, '2020-09-30', 'AR', 'Argentina', 'AMRO', '11807', '723132', '364', '16113');
INSERT INTO public.who_global_data_import VALUES (3473, '2020-10-01', 'AR', 'Argentina', 'AMRO', '13477', '736609', '406', '16519');
INSERT INTO public.who_global_data_import VALUES (3474, '2020-10-02', 'AR', 'Argentina', 'AMRO', '14392', '751001', '418', '16937');
INSERT INTO public.who_global_data_import VALUES (3475, '2020-10-03', 'AR', 'Argentina', 'AMRO', '14001', '765002', '3351', '20288');
INSERT INTO public.who_global_data_import VALUES (3476, '2020-10-04', 'AR', 'Argentina', 'AMRO', '14687', '779689', '311', '20599');
INSERT INTO public.who_global_data_import VALUES (3477, '2020-10-05', 'AR', 'Argentina', 'AMRO', '11129', '790818', '196', '20795');
INSERT INTO public.who_global_data_import VALUES (3478, '2020-10-06', 'AR', 'Argentina', 'AMRO', '7668', '798486', '223', '21018');
INSERT INTO public.who_global_data_import VALUES (3479, '2020-10-07', 'AR', 'Argentina', 'AMRO', '11242', '809728', '450', '21468');
INSERT INTO public.who_global_data_import VALUES (3480, '2020-10-08', 'AR', 'Argentina', 'AMRO', '14740', '824468', '359', '21827');
INSERT INTO public.who_global_data_import VALUES (3481, '2020-10-09', 'AR', 'Argentina', 'AMRO', '16447', '840915', '399', '22226');
INSERT INTO public.who_global_data_import VALUES (3482, '2020-10-10', 'AR', 'Argentina', 'AMRO', '15454', '856369', '484', '22710');
INSERT INTO public.who_global_data_import VALUES (3483, '2020-10-11', 'AR', 'Argentina', 'AMRO', '15099', '871468', '515', '23225');
INSERT INTO public.who_global_data_import VALUES (3484, '2020-10-12', 'AR', 'Argentina', 'AMRO', '12414', '883882', '356', '23581');
INSERT INTO public.who_global_data_import VALUES (3485, '2020-10-13', 'AR', 'Argentina', 'AMRO', '10324', '894206', '287', '23868');
INSERT INTO public.who_global_data_import VALUES (3486, '2020-10-14', 'AR', 'Argentina', 'AMRO', '9524', '903730', '318', '24186');
INSERT INTO public.who_global_data_import VALUES (3487, '2020-10-15', 'AR', 'Argentina', 'AMRO', '13305', '917035', '386', '24572');
INSERT INTO public.who_global_data_import VALUES (3488, '2020-10-16', 'AR', 'Argentina', 'AMRO', '14932', '931967', '349', '24921');
INSERT INTO public.who_global_data_import VALUES (3489, '2020-10-17', 'AR', 'Argentina', 'AMRO', '17096', '949063', '421', '25342');
INSERT INTO public.who_global_data_import VALUES (3490, '2020-10-18', 'AR', 'Argentina', 'AMRO', '16546', '965609', '381', '25723');
INSERT INTO public.who_global_data_import VALUES (3491, '2020-10-19', 'AR', 'Argentina', 'AMRO', '13510', '979119', '384', '26107');
INSERT INTO public.who_global_data_import VALUES (3492, '2020-10-20', 'AR', 'Argentina', 'AMRO', '10561', '989680', '160', '26267');
INSERT INTO public.who_global_data_import VALUES (3493, '2020-10-21', 'AR', 'Argentina', 'AMRO', '12982', '1002662', '449', '26716');
INSERT INTO public.who_global_data_import VALUES (3494, '2020-10-22', 'AR', 'Argentina', 'AMRO', '18735', '1021397', '459', '27175');
INSERT INTO public.who_global_data_import VALUES (3495, '2020-10-23', 'AR', 'Argentina', 'AMRO', '15928', '1037325', '344', '27519');
INSERT INTO public.who_global_data_import VALUES (3496, '2020-10-24', 'AR', 'Argentina', 'AMRO', '16325', '1053650', '438', '27957');
INSERT INTO public.who_global_data_import VALUES (3497, '2020-10-25', 'AR', 'Argentina', 'AMRO', '15718', '1069368', '381', '28338');
INSERT INTO public.who_global_data_import VALUES (3498, '2020-10-26', 'AR', 'Argentina', 'AMRO', '11968', '1081336', '275', '28613');
INSERT INTO public.who_global_data_import VALUES (3499, '2020-10-27', 'AR', 'Argentina', 'AMRO', '9253', '1090589', '283', '28896');
INSERT INTO public.who_global_data_import VALUES (3500, '2020-10-28', 'AR', 'Argentina', 'AMRO', '11712', '1102301', '405', '29301');
INSERT INTO public.who_global_data_import VALUES (3501, '2020-10-29', 'AR', 'Argentina', 'AMRO', '14308', '1116609', '429', '29730');
INSERT INTO public.who_global_data_import VALUES (3502, '2020-10-30', 'AR', 'Argentina', 'AMRO', '13924', '1130533', '341', '30071');
INSERT INTO public.who_global_data_import VALUES (3503, '2020-10-31', 'AR', 'Argentina', 'AMRO', '13267', '1143800', '371', '30442');
INSERT INTO public.who_global_data_import VALUES (3504, '2020-11-01', 'AR', 'Argentina', 'AMRO', '13379', '1157179', '350', '30792');
INSERT INTO public.who_global_data_import VALUES (3505, '2020-11-02', 'AR', 'Argentina', 'AMRO', '9745', '1166924', '210', '31002');
INSERT INTO public.who_global_data_import VALUES (3506, '2020-11-03', 'AR', 'Argentina', 'AMRO', '6609', '1173533', '138', '31140');
INSERT INTO public.who_global_data_import VALUES (3507, '2020-11-04', 'AR', 'Argentina', 'AMRO', '9598', '1183131', '483', '31623');
INSERT INTO public.who_global_data_import VALUES (3508, '2020-11-05', 'AR', 'Argentina', 'AMRO', '13281', '1196412', '429', '32052');
INSERT INTO public.who_global_data_import VALUES (3509, '2020-11-06', 'AR', 'Argentina', 'AMRO', '9516', '1205928', '468', '32520');
INSERT INTO public.who_global_data_import VALUES (3510, '2020-11-07', 'AR', 'Argentina', 'AMRO', '11100', '1217028', '246', '32766');
INSERT INTO public.who_global_data_import VALUES (3511, '2020-11-08', 'AR', 'Argentina', 'AMRO', '11786', '1228814', '370', '33136');
INSERT INTO public.who_global_data_import VALUES (3512, '2020-11-09', 'AR', 'Argentina', 'AMRO', '8037', '1236851', '212', '33348');
INSERT INTO public.who_global_data_import VALUES (3513, '2020-11-10', 'AR', 'Argentina', 'AMRO', '5331', '1242182', '212', '33560');
INSERT INTO public.who_global_data_import VALUES (3514, '2020-11-11', 'AR', 'Argentina', 'AMRO', '8317', '1250499', '347', '33907');
INSERT INTO public.who_global_data_import VALUES (3515, '2020-11-12', 'AR', 'Argentina', 'AMRO', '11977', '1262476', '276', '34183');
INSERT INTO public.who_global_data_import VALUES (3516, '2020-11-13', 'AR', 'Argentina', 'AMRO', '10880', '1273356', '348', '34531');
INSERT INTO public.who_global_data_import VALUES (3517, '2020-11-14', 'AR', 'Argentina', 'AMRO', '11163', '1284519', '251', '34782');
INSERT INTO public.who_global_data_import VALUES (3518, '2020-11-15', 'AR', 'Argentina', 'AMRO', '11859', '1296378', '263', '35045');
INSERT INTO public.who_global_data_import VALUES (3519, '2020-11-16', 'AR', 'Argentina', 'AMRO', '8468', '1304846', '262', '35307');
INSERT INTO public.who_global_data_import VALUES (3520, '2020-11-17', 'AR', 'Argentina', 'AMRO', '5645', '1310491', '129', '35436');
INSERT INTO public.who_global_data_import VALUES (3521, '2020-11-18', 'AR', 'Argentina', 'AMRO', '7893', '1318384', '291', '35727');
INSERT INTO public.who_global_data_import VALUES (3522, '2020-11-19', 'AR', 'Argentina', 'AMRO', '10621', '1329005', '379', '36106');
INSERT INTO public.who_global_data_import VALUES (3523, '2020-11-20', 'AR', 'Argentina', 'AMRO', '10332', '1339337', '241', '36347');
INSERT INTO public.who_global_data_import VALUES (3524, '2020-11-21', 'AR', 'Argentina', 'AMRO', '10097', '1349434', '185', '36532');
INSERT INTO public.who_global_data_import VALUES (3525, '2020-11-22', 'AR', 'Argentina', 'AMRO', '9608', '1359042', '258', '36790');
INSERT INTO public.who_global_data_import VALUES (3526, '2020-11-23', 'AR', 'Argentina', 'AMRO', '7140', '1366182', '212', '37002');
INSERT INTO public.who_global_data_import VALUES (3527, '2020-11-24', 'AR', 'Argentina', 'AMRO', '4184', '1370366', '0', '37002');
INSERT INTO public.who_global_data_import VALUES (3528, '2020-11-25', 'AR', 'Argentina', 'AMRO', '4265', '1374631', '120', '37122');
INSERT INTO public.who_global_data_import VALUES (3529, '2020-11-26', 'AR', 'Argentina', 'AMRO', '7164', '1381795', '310', '37432');
INSERT INTO public.who_global_data_import VALUES (3530, '2020-11-27', 'AR', 'Argentina', 'AMRO', '8593', '1390388', '282', '37714');
INSERT INTO public.who_global_data_import VALUES (3531, '2020-11-28', 'AR', 'Argentina', 'AMRO', '9043', '1399431', '227', '37941');
INSERT INTO public.who_global_data_import VALUES (3532, '2020-11-29', 'AR', 'Argentina', 'AMRO', '7846', '1407277', '275', '38216');
INSERT INTO public.who_global_data_import VALUES (3533, '2020-11-30', 'AR', 'Argentina', 'AMRO', '6098', '1413375', '106', '38322');
INSERT INTO public.who_global_data_import VALUES (3534, '2020-12-01', 'AR', 'Argentina', 'AMRO', '5432', '1418807', '151', '38473');
INSERT INTO public.who_global_data_import VALUES (3535, '2020-12-02', 'AR', 'Argentina', 'AMRO', '5726', '1424533', '257', '38730');
INSERT INTO public.who_global_data_import VALUES (3536, '2020-12-03', 'AR', 'Argentina', 'AMRO', '8037', '1432570', '198', '38928');
INSERT INTO public.who_global_data_import VALUES (3537, '2020-12-04', 'AR', 'Argentina', 'AMRO', '7533', '1440103', '228', '39156');
INSERT INTO public.who_global_data_import VALUES (3538, '2020-12-05', 'AR', 'Argentina', 'AMRO', '7629', '1447732', '149', '39305');
INSERT INTO public.who_global_data_import VALUES (3539, '2020-12-06', 'AR', 'Argentina', 'AMRO', '6899', '1454631', '207', '39512');
INSERT INTO public.who_global_data_import VALUES (3540, '2020-12-07', 'AR', 'Argentina', 'AMRO', '5201', '1459832', '120', '39632');
INSERT INTO public.who_global_data_import VALUES (3541, '2020-12-08', 'AR', 'Argentina', 'AMRO', '3278', '1463110', '138', '39770');
INSERT INTO public.who_global_data_import VALUES (3542, '2020-12-09', 'AR', 'Argentina', 'AMRO', '3199', '1466309', '118', '39888');
INSERT INTO public.who_global_data_import VALUES (3543, '2020-12-10', 'AR', 'Argentina', 'AMRO', '3610', '1469919', '121', '40009');
INSERT INTO public.who_global_data_import VALUES (3544, '2020-12-11', 'AR', 'Argentina', 'AMRO', '5303', '1475222', '213', '40222');
INSERT INTO public.who_global_data_import VALUES (3545, '2020-12-12', 'AR', 'Argentina', 'AMRO', '8154', '1483376', '220', '40442');
INSERT INTO public.who_global_data_import VALUES (3546, '2020-12-13', 'AR', 'Argentina', 'AMRO', '5952', '1489328', '164', '40606');
INSERT INTO public.who_global_data_import VALUES (3547, '2020-12-14', 'AR', 'Argentina', 'AMRO', '5274', '1494602', '62', '40668');
INSERT INTO public.who_global_data_import VALUES (3548, '2020-12-15', 'AR', 'Argentina', 'AMRO', '3558', '1498160', '98', '40766');
INSERT INTO public.who_global_data_import VALUES (3549, '2020-12-16', 'AR', 'Argentina', 'AMRO', '5062', '1503222', '275', '41041');
INSERT INTO public.who_global_data_import VALUES (3550, '2020-12-17', 'AR', 'Argentina', 'AMRO', '6981', '1510203', '163', '41204');
INSERT INTO public.who_global_data_import VALUES (3551, '2020-12-18', 'AR', 'Argentina', 'AMRO', '6843', '1517046', '161', '41365');
INSERT INTO public.who_global_data_import VALUES (3552, '2020-12-19', 'AR', 'Argentina', 'AMRO', '7326', '1524372', '169', '41534');
INSERT INTO public.who_global_data_import VALUES (3553, '2020-12-20', 'AR', 'Argentina', 'AMRO', '7002', '1531374', '138', '41672');
INSERT INTO public.who_global_data_import VALUES (3554, '2020-12-21', 'AR', 'Argentina', 'AMRO', '5795', '1537169', '91', '41763');
INSERT INTO public.who_global_data_import VALUES (3555, '2020-12-22', 'AR', 'Argentina', 'AMRO', '4116', '1541285', '50', '41813');
INSERT INTO public.who_global_data_import VALUES (3556, '2020-12-23', 'AR', 'Argentina', 'AMRO', '5853', '1547138', '184', '41997');
INSERT INTO public.who_global_data_import VALUES (3557, '2020-12-24', 'AR', 'Argentina', 'AMRO', '8141', '1555279', '257', '42254');
INSERT INTO public.who_global_data_import VALUES (3558, '2020-12-25', 'AR', 'Argentina', 'AMRO', '8586', '1563865', '60', '42314');
INSERT INTO public.who_global_data_import VALUES (3559, '2020-12-26', 'AR', 'Argentina', 'AMRO', '7815', '1571680', '78', '42392');
INSERT INTO public.who_global_data_import VALUES (3560, '2020-12-27', 'AR', 'Argentina', 'AMRO', '2874', '1574554', '30', '42422');
INSERT INTO public.who_global_data_import VALUES (3561, '2020-12-28', 'AR', 'Argentina', 'AMRO', '3713', '1578267', '79', '42501');
INSERT INTO public.who_global_data_import VALUES (3562, '2020-12-29', 'AR', 'Argentina', 'AMRO', '5660', '1583927', '149', '42650');
INSERT INTO public.who_global_data_import VALUES (3563, '2020-12-30', 'AR', 'Argentina', 'AMRO', '6586', '1590513', '218', '42868');
INSERT INTO public.who_global_data_import VALUES (3564, '2020-12-31', 'AR', 'Argentina', 'AMRO', '11650', '1602163', '150', '43018');
INSERT INTO public.who_global_data_import VALUES (3565, '2021-01-01', 'AR', 'Argentina', 'AMRO', '11765', '1613928', '145', '43163');
INSERT INTO public.who_global_data_import VALUES (3566, '2021-01-02', 'AR', 'Argentina', 'AMRO', '11586', '1625514', '82', '43245');
INSERT INTO public.who_global_data_import VALUES (3567, '2021-01-03', 'AR', 'Argentina', 'AMRO', '4080', '1629594', '74', '43319');
INSERT INTO public.who_global_data_import VALUES (3568, '2021-01-04', 'AR', 'Argentina', 'AMRO', '5240', '1634834', '56', '43375');
INSERT INTO public.who_global_data_import VALUES (3569, '2021-01-05', 'AR', 'Argentina', 'AMRO', '5884', '1640718', '107', '43482');
INSERT INTO public.who_global_data_import VALUES (3570, '2021-01-06', 'AR', 'Argentina', 'AMRO', '8222', '1648940', '152', '43634');
INSERT INTO public.who_global_data_import VALUES (3571, '2021-01-07', 'AR', 'Argentina', 'AMRO', '13790', '1662730', '151', '43785');
INSERT INTO public.who_global_data_import VALUES (3572, '2021-01-08', 'AR', 'Argentina', 'AMRO', '13441', '1676171', '191', '43976');
INSERT INTO public.who_global_data_import VALUES (3573, '2021-01-09', 'AR', 'Argentina', 'AMRO', '13835', '1690006', '146', '44122');
INSERT INTO public.who_global_data_import VALUES (3574, '2021-01-10', 'AR', 'Argentina', 'AMRO', '13346', '1703352', '151', '44273');
INSERT INTO public.who_global_data_import VALUES (3575, '2021-01-11', 'AR', 'Argentina', 'AMRO', '11057', '1714409', '144', '44417');
INSERT INTO public.who_global_data_import VALUES (3576, '2021-01-12', 'AR', 'Argentina', 'AMRO', '7808', '1722217', '78', '44495');
INSERT INTO public.who_global_data_import VALUES (3577, '2021-01-13', 'AR', 'Argentina', 'AMRO', '8704', '1730921', '159', '44654');
INSERT INTO public.who_global_data_import VALUES (3578, '2021-01-14', 'AR', 'Argentina', 'AMRO', '13783', '1744704', '194', '44848');
INSERT INTO public.who_global_data_import VALUES (3579, '2021-01-15', 'AR', 'Argentina', 'AMRO', '12725', '1757429', '135', '44983');
INSERT INTO public.who_global_data_import VALUES (3580, '2021-01-16', 'AR', 'Argentina', 'AMRO', '13286', '1770715', '142', '45125');
INSERT INTO public.who_global_data_import VALUES (3581, '2021-01-17', 'AR', 'Argentina', 'AMRO', '12332', '1783047', '102', '45227');
INSERT INTO public.who_global_data_import VALUES (3582, '2021-01-18', 'AR', 'Argentina', 'AMRO', '8932', '1791979', '68', '45295');
INSERT INTO public.who_global_data_import VALUES (3583, '2021-01-19', 'AR', 'Argentina', 'AMRO', '7264', '1799243', '112', '45407');
INSERT INTO public.who_global_data_import VALUES (3584, '2021-01-20', 'AR', 'Argentina', 'AMRO', '8185', '1807428', '425', '45832');
INSERT INTO public.who_global_data_import VALUES (3585, '2021-01-21', 'AR', 'Argentina', 'AMRO', '12141', '1819569', '234', '46066');
INSERT INTO public.who_global_data_import VALUES (3586, '2021-01-22', 'AR', 'Argentina', 'AMRO', '12112', '1831681', '150', '46216');
INSERT INTO public.who_global_data_import VALUES (3587, '2021-01-23', 'AR', 'Argentina', 'AMRO', '11396', '1843077', '139', '46355');
INSERT INTO public.who_global_data_import VALUES (3588, '2021-01-24', 'AR', 'Argentina', 'AMRO', '10753', '1853830', '220', '46575');
INSERT INTO public.who_global_data_import VALUES (3589, '2021-01-25', 'AR', 'Argentina', 'AMRO', '8362', '1862192', '162', '46737');
INSERT INTO public.who_global_data_import VALUES (3590, '2021-01-26', 'AR', 'Argentina', 'AMRO', '5031', '1867223', '90', '46827');
INSERT INTO public.who_global_data_import VALUES (3591, '2021-01-27', 'AR', 'Argentina', 'AMRO', '7578', '1874801', '207', '47034');
INSERT INTO public.who_global_data_import VALUES (3592, '2021-01-28', 'AR', 'Argentina', 'AMRO', '10409', '1885210', '219', '47253');
INSERT INTO public.who_global_data_import VALUES (3593, '2021-01-29', 'AR', 'Argentina', 'AMRO', '10843', '1896053', '182', '47435');
INSERT INTO public.who_global_data_import VALUES (3594, '2021-01-30', 'AR', 'Argentina', 'AMRO', '9471', '1905524', '166', '47601');
INSERT INTO public.who_global_data_import VALUES (3595, '2021-01-31', 'AR', 'Argentina', 'AMRO', '9838', '1915362', '174', '47775');
INSERT INTO public.who_global_data_import VALUES (3596, '2021-02-01', 'AR', 'Argentina', 'AMRO', '6902', '1922264', '156', '47931');
INSERT INTO public.who_global_data_import VALUES (3597, '2021-02-02', 'AR', 'Argentina', 'AMRO', '4975', '1927239', '43', '47974');
INSERT INTO public.who_global_data_import VALUES (3598, '2021-02-03', 'AR', 'Argentina', 'AMRO', '6614', '1933853', '275', '48249');
INSERT INTO public.who_global_data_import VALUES (3599, '2021-02-04', 'AR', 'Argentina', 'AMRO', '9695', '1943548', '177', '48426');
INSERT INTO public.who_global_data_import VALUES (3600, '2021-02-05', 'AR', 'Argentina', 'AMRO', '9196', '1952744', '113', '48539');
INSERT INTO public.who_global_data_import VALUES (3601, '2020-01-03', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3602, '2020-01-04', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3603, '2020-01-05', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3604, '2020-01-06', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3605, '2020-01-07', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3606, '2020-01-08', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3607, '2020-01-09', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3608, '2020-01-10', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3609, '2020-01-11', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3610, '2020-01-12', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3611, '2020-01-13', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3612, '2020-01-14', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3613, '2020-01-15', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3614, '2020-01-16', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3615, '2020-01-17', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3616, '2020-01-18', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3617, '2020-01-19', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3618, '2020-01-20', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3619, '2020-01-21', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3620, '2020-01-22', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3621, '2020-01-23', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3622, '2020-01-24', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3623, '2020-01-25', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3624, '2020-01-26', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3625, '2020-01-27', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3626, '2020-01-28', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3627, '2020-01-29', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3628, '2020-01-30', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3629, '2020-01-31', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3630, '2020-02-01', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3631, '2020-02-02', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3632, '2020-02-03', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3633, '2020-02-04', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3634, '2020-02-05', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3635, '2020-02-06', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3636, '2020-02-07', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3637, '2020-02-08', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3638, '2020-02-09', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3639, '2020-02-10', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3640, '2020-02-11', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3641, '2020-02-12', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3642, '2020-02-13', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3643, '2020-02-14', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3644, '2020-02-15', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3645, '2020-02-16', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3646, '2020-02-17', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3647, '2020-02-18', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3648, '2020-02-19', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3649, '2020-02-20', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3650, '2020-02-21', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3651, '2020-02-22', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3652, '2020-02-23', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3653, '2020-02-24', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3654, '2020-02-25', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3655, '2020-02-26', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3656, '2020-02-27', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3657, '2020-02-28', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3658, '2020-02-29', 'AM', 'Armenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3659, '2020-03-01', 'AM', 'Armenia', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3660, '2020-03-02', 'AM', 'Armenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3661, '2020-03-03', 'AM', 'Armenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3662, '2020-03-04', 'AM', 'Armenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3663, '2020-03-05', 'AM', 'Armenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3664, '2020-03-06', 'AM', 'Armenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3665, '2020-03-07', 'AM', 'Armenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3666, '2020-03-08', 'AM', 'Armenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3667, '2020-03-09', 'AM', 'Armenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3668, '2020-03-10', 'AM', 'Armenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3669, '2020-03-11', 'AM', 'Armenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3670, '2020-03-12', 'AM', 'Armenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3671, '2020-03-13', 'AM', 'Armenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3672, '2020-03-14', 'AM', 'Armenia', 'EURO', '7', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3673, '2020-03-15', 'AM', 'Armenia', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3674, '2020-03-16', 'AM', 'Armenia', 'EURO', '18', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3675, '2020-03-17', 'AM', 'Armenia', 'EURO', '4', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3676, '2020-03-18', 'AM', 'Armenia', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3677, '2020-03-19', 'AM', 'Armenia', 'EURO', '31', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3678, '2020-03-20', 'AM', 'Armenia', 'EURO', '31', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3679, '2020-03-21', 'AM', 'Armenia', 'EURO', '21', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3680, '2020-03-22', 'AM', 'Armenia', 'EURO', '24', '137', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3681, '2020-03-23', 'AM', 'Armenia', 'EURO', '30', '167', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3682, '2020-03-24', 'AM', 'Armenia', 'EURO', '4', '171', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3683, '2020-03-25', 'AM', 'Armenia', 'EURO', '41', '212', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3684, '2020-03-26', 'AM', 'Armenia', 'EURO', '30', '242', '0', '0');
INSERT INTO public.who_global_data_import VALUES (3685, '2020-03-27', 'AM', 'Armenia', 'EURO', '25', '267', '1', '1');
INSERT INTO public.who_global_data_import VALUES (3686, '2020-03-28', 'AM', 'Armenia', 'EURO', '39', '306', '0', '1');
INSERT INTO public.who_global_data_import VALUES (3687, '2020-03-29', 'AM', 'Armenia', 'EURO', '43', '349', '0', '1');
INSERT INTO public.who_global_data_import VALUES (3688, '2020-03-30', 'AM', 'Armenia', 'EURO', '52', '401', '2', '3');
INSERT INTO public.who_global_data_import VALUES (3689, '2020-03-31', 'AM', 'Armenia', 'EURO', '58', '459', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3690, '2020-04-01', 'AM', 'Armenia', 'EURO', '50', '509', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3691, '2020-04-02', 'AM', 'Armenia', 'EURO', '39', '548', '0', '3');
INSERT INTO public.who_global_data_import VALUES (3692, '2020-04-03', 'AM', 'Armenia', 'EURO', '92', '640', '1', '4');
INSERT INTO public.who_global_data_import VALUES (3693, '2020-04-04', 'AM', 'Armenia', 'EURO', '72', '712', '3', '7');
INSERT INTO public.who_global_data_import VALUES (3694, '2020-04-05', 'AM', 'Armenia', 'EURO', '34', '746', '0', '7');
INSERT INTO public.who_global_data_import VALUES (3695, '2020-04-06', 'AM', 'Armenia', 'EURO', '52', '798', '0', '7');
INSERT INTO public.who_global_data_import VALUES (3696, '2020-04-07', 'AM', 'Armenia', 'EURO', '11', '809', '1', '8');
INSERT INTO public.who_global_data_import VALUES (3697, '2020-04-08', 'AM', 'Armenia', 'EURO', '20', '829', '0', '8');
INSERT INTO public.who_global_data_import VALUES (3698, '2020-04-09', 'AM', 'Armenia', 'EURO', '28', '857', '1', '9');
INSERT INTO public.who_global_data_import VALUES (3699, '2020-04-10', 'AM', 'Armenia', 'EURO', '40', '897', '1', '10');
INSERT INTO public.who_global_data_import VALUES (3700, '2020-04-11', 'AM', 'Armenia', 'EURO', '16', '913', '1', '11');
INSERT INTO public.who_global_data_import VALUES (3701, '2020-04-12', 'AM', 'Armenia', 'EURO', '30', '943', '2', '13');
INSERT INTO public.who_global_data_import VALUES (3702, '2020-04-13', 'AM', 'Armenia', 'EURO', '46', '989', '0', '13');
INSERT INTO public.who_global_data_import VALUES (3703, '2020-04-14', 'AM', 'Armenia', 'EURO', '26', '1015', '1', '14');
INSERT INTO public.who_global_data_import VALUES (3704, '2020-04-15', 'AM', 'Armenia', 'EURO', '28', '1043', '2', '16');
INSERT INTO public.who_global_data_import VALUES (3705, '2020-04-16', 'AM', 'Armenia', 'EURO', '44', '1087', '1', '17');
INSERT INTO public.who_global_data_import VALUES (3706, '2020-04-17', 'AM', 'Armenia', 'EURO', '48', '1135', '1', '18');
INSERT INTO public.who_global_data_import VALUES (3707, '2020-04-18', 'AM', 'Armenia', 'EURO', '42', '1177', '1', '19');
INSERT INTO public.who_global_data_import VALUES (3708, '2020-04-19', 'AM', 'Armenia', 'EURO', '47', '1224', '1', '20');
INSERT INTO public.who_global_data_import VALUES (3709, '2020-04-20', 'AM', 'Armenia', 'EURO', '43', '1267', '0', '20');
INSERT INTO public.who_global_data_import VALUES (3710, '2020-04-21', 'AM', 'Armenia', 'EURO', '48', '1315', '2', '22');
INSERT INTO public.who_global_data_import VALUES (3711, '2020-04-22', 'AM', 'Armenia', 'EURO', '62', '1377', '2', '24');
INSERT INTO public.who_global_data_import VALUES (3712, '2020-04-23', 'AM', 'Armenia', 'EURO', '72', '1449', '0', '24');
INSERT INTO public.who_global_data_import VALUES (3713, '2020-04-24', 'AM', 'Armenia', 'EURO', '50', '1499', '0', '24');
INSERT INTO public.who_global_data_import VALUES (3714, '2020-04-25', 'AM', 'Armenia', 'EURO', '73', '1572', '3', '27');
INSERT INTO public.who_global_data_import VALUES (3715, '2020-04-26', 'AM', 'Armenia', 'EURO', '81', '1653', '1', '28');
INSERT INTO public.who_global_data_import VALUES (3716, '2020-04-27', 'AM', 'Armenia', 'EURO', '69', '1722', '0', '28');
INSERT INTO public.who_global_data_import VALUES (3717, '2020-04-28', 'AM', 'Armenia', 'EURO', '62', '1784', '1', '29');
INSERT INTO public.who_global_data_import VALUES (3718, '2020-04-29', 'AM', 'Armenia', 'EURO', '59', '1843', '1', '30');
INSERT INTO public.who_global_data_import VALUES (3719, '2020-04-30', 'AM', 'Armenia', 'EURO', '65', '1908', '0', '30');
INSERT INTO public.who_global_data_import VALUES (3720, '2020-05-01', 'AM', 'Armenia', 'EURO', '134', '2042', '2', '32');
INSERT INTO public.who_global_data_import VALUES (3721, '2020-05-02', 'AM', 'Armenia', 'EURO', '82', '2124', '1', '33');
INSERT INTO public.who_global_data_import VALUES (3722, '2020-05-03', 'AM', 'Armenia', 'EURO', '125', '2249', '0', '33');
INSERT INTO public.who_global_data_import VALUES (3723, '2020-05-04', 'AM', 'Armenia', 'EURO', '113', '2362', '2', '35');
INSERT INTO public.who_global_data_import VALUES (3724, '2020-05-05', 'AM', 'Armenia', 'EURO', '121', '2483', '4', '39');
INSERT INTO public.who_global_data_import VALUES (3725, '2020-05-06', 'AM', 'Armenia', 'EURO', '112', '2595', '1', '40');
INSERT INTO public.who_global_data_import VALUES (3726, '2020-05-07', 'AM', 'Armenia', 'EURO', '163', '2758', '0', '40');
INSERT INTO public.who_global_data_import VALUES (3727, '2020-05-08', 'AM', 'Armenia', 'EURO', '102', '2860', '2', '42');
INSERT INTO public.who_global_data_import VALUES (3728, '2020-05-09', 'AM', 'Armenia', 'EURO', '145', '3005', '1', '43');
INSERT INTO public.who_global_data_import VALUES (3729, '2020-05-10', 'AM', 'Armenia', 'EURO', '146', '3151', '1', '44');
INSERT INTO public.who_global_data_import VALUES (3730, '2020-05-11', 'AM', 'Armenia', 'EURO', '138', '3289', '1', '45');
INSERT INTO public.who_global_data_import VALUES (3731, '2020-05-12', 'AM', 'Armenia', 'EURO', '79', '3368', '1', '46');
INSERT INTO public.who_global_data_import VALUES (3732, '2020-05-13', 'AM', 'Armenia', 'EURO', '146', '3514', '1', '47');
INSERT INTO public.who_global_data_import VALUES (3733, '2020-05-14', 'AM', 'Armenia', 'EURO', '180', '3694', '1', '48');
INSERT INTO public.who_global_data_import VALUES (3734, '2020-05-15', 'AM', 'Armenia', 'EURO', '142', '3836', '1', '49');
INSERT INTO public.who_global_data_import VALUES (3735, '2020-05-16', 'AM', 'Armenia', 'EURO', '184', '4020', '3', '52');
INSERT INTO public.who_global_data_import VALUES (3736, '2020-05-17', 'AM', 'Armenia', 'EURO', '239', '4259', '3', '55');
INSERT INTO public.who_global_data_import VALUES (3737, '2020-05-18', 'AM', 'Armenia', 'EURO', '189', '4448', '5', '60');
INSERT INTO public.who_global_data_import VALUES (3738, '2020-05-19', 'AM', 'Armenia', 'EURO', '351', '4799', '1', '61');
INSERT INTO public.who_global_data_import VALUES (3739, '2020-05-20', 'AM', 'Armenia', 'EURO', '218', '5017', '3', '64');
INSERT INTO public.who_global_data_import VALUES (3740, '2020-05-21', 'AM', 'Armenia', 'EURO', '230', '5247', '3', '67');
INSERT INTO public.who_global_data_import VALUES (3741, '2020-05-22', 'AM', 'Armenia', 'EURO', '335', '5582', '3', '70');
INSERT INTO public.who_global_data_import VALUES (3742, '2020-05-23', 'AM', 'Armenia', 'EURO', '322', '5904', '4', '74');
INSERT INTO public.who_global_data_import VALUES (3743, '2020-05-24', 'AM', 'Armenia', 'EURO', '374', '6278', '3', '77');
INSERT INTO public.who_global_data_import VALUES (3744, '2020-05-25', 'AM', 'Armenia', 'EURO', '359', '6637', '4', '81');
INSERT INTO public.who_global_data_import VALUES (3745, '2020-05-26', 'AM', 'Armenia', 'EURO', '452', '7089', '6', '87');
INSERT INTO public.who_global_data_import VALUES (3746, '2020-05-27', 'AM', 'Armenia', 'EURO', '289', '7378', '4', '91');
INSERT INTO public.who_global_data_import VALUES (3747, '2020-05-28', 'AM', 'Armenia', 'EURO', '372', '7750', '7', '98');
INSERT INTO public.who_global_data_import VALUES (3748, '2020-05-29', 'AM', 'Armenia', 'EURO', '442', '8192', '15', '113');
INSERT INTO public.who_global_data_import VALUES (3749, '2020-05-30', 'AM', 'Armenia', 'EURO', '460', '8652', '7', '120');
INSERT INTO public.who_global_data_import VALUES (3750, '2020-05-31', 'AM', 'Armenia', 'EURO', '251', '8903', '7', '127');
INSERT INTO public.who_global_data_import VALUES (3751, '2020-06-01', 'AM', 'Armenia', 'EURO', '355', '9258', '4', '131');
INSERT INTO public.who_global_data_import VALUES (3752, '2020-06-02', 'AM', 'Armenia', 'EURO', '210', '9468', '8', '139');
INSERT INTO public.who_global_data_import VALUES (3753, '2020-06-03', 'AM', 'Armenia', 'EURO', '517', '9985', '19', '158');
INSERT INTO public.who_global_data_import VALUES (3754, '2020-06-04', 'AM', 'Armenia', 'EURO', '515', '10500', '12', '170');
INSERT INTO public.who_global_data_import VALUES (3755, '2020-06-05', 'AM', 'Armenia', 'EURO', '697', '11197', '6', '176');
INSERT INTO public.who_global_data_import VALUES (3756, '2020-06-06', 'AM', 'Armenia', 'EURO', '596', '11793', '7', '183');
INSERT INTO public.who_global_data_import VALUES (3757, '2020-06-07', 'AM', 'Armenia', 'EURO', '547', '12340', '7', '190');
INSERT INTO public.who_global_data_import VALUES (3758, '2020-06-08', 'AM', 'Armenia', 'EURO', '766', '13106', '10', '200');
INSERT INTO public.who_global_data_import VALUES (3759, '2020-06-09', 'AM', 'Armenia', 'EURO', '195', '13301', '11', '211');
INSERT INTO public.who_global_data_import VALUES (3760, '2020-06-10', 'AM', 'Armenia', 'EURO', '350', '13651', '6', '217');
INSERT INTO public.who_global_data_import VALUES (3761, '2020-06-11', 'AM', 'Armenia', 'EURO', '428', '14079', '10', '227');
INSERT INTO public.who_global_data_import VALUES (3762, '2020-06-12', 'AM', 'Armenia', 'EURO', '566', '14645', '18', '245');
INSERT INTO public.who_global_data_import VALUES (3763, '2020-06-13', 'AM', 'Armenia', 'EURO', '612', '15257', '13', '258');
INSERT INTO public.who_global_data_import VALUES (3764, '2020-06-14', 'AM', 'Armenia', 'EURO', '723', '15980', '6', '264');
INSERT INTO public.who_global_data_import VALUES (3765, '2020-06-15', 'AM', 'Armenia', 'EURO', '397', '16377', '16', '280');
INSERT INTO public.who_global_data_import VALUES (3766, '2020-06-16', 'AM', 'Armenia', 'EURO', '425', '16802', '8', '288');
INSERT INTO public.who_global_data_import VALUES (3767, '2020-06-17', 'AM', 'Armenia', 'EURO', '544', '17346', '9', '297');
INSERT INTO public.who_global_data_import VALUES (3768, '2020-06-18', 'AM', 'Armenia', 'EURO', '665', '18011', '7', '304');
INSERT INTO public.who_global_data_import VALUES (3769, '2020-06-19', 'AM', 'Armenia', 'EURO', '459', '18470', '10', '314');
INSERT INTO public.who_global_data_import VALUES (3770, '2020-06-20', 'AM', 'Armenia', 'EURO', '551', '19021', '13', '327');
INSERT INTO public.who_global_data_import VALUES (3771, '2020-06-21', 'AM', 'Armenia', 'EURO', '560', '19581', '18', '345');
INSERT INTO public.who_global_data_import VALUES (3772, '2020-06-22', 'AM', 'Armenia', 'EURO', '320', '19901', '10', '355');
INSERT INTO public.who_global_data_import VALUES (3773, '2020-06-23', 'AM', 'Armenia', 'EURO', '418', '20319', '12', '367');
INSERT INTO public.who_global_data_import VALUES (3774, '2020-06-24', 'AM', 'Armenia', 'EURO', '711', '21030', '14', '381');
INSERT INTO public.who_global_data_import VALUES (3775, '2020-06-25', 'AM', 'Armenia', 'EURO', '771', '21801', '11', '392');
INSERT INTO public.who_global_data_import VALUES (3776, '2020-06-26', 'AM', 'Armenia', 'EURO', '759', '22560', '13', '405');
INSERT INTO public.who_global_data_import VALUES (3777, '2020-06-27', 'AM', 'Armenia', 'EURO', '662', '23222', '10', '415');
INSERT INTO public.who_global_data_import VALUES (3778, '2020-06-28', 'AM', 'Armenia', 'EURO', '736', '23958', '6', '421');
INSERT INTO public.who_global_data_import VALUES (3779, '2020-06-29', 'AM', 'Armenia', 'EURO', '482', '24440', '7', '428');
INSERT INTO public.who_global_data_import VALUES (3780, '2020-06-30', 'AM', 'Armenia', 'EURO', '415', '24855', '10', '438');
INSERT INTO public.who_global_data_import VALUES (3781, '2020-07-01', 'AM', 'Armenia', 'EURO', '523', '25378', '10', '448');
INSERT INTO public.who_global_data_import VALUES (3782, '2020-07-02', 'AM', 'Armenia', 'EURO', '593', '25971', '6', '454');
INSERT INTO public.who_global_data_import VALUES (3783, '2020-07-03', 'AM', 'Armenia', 'EURO', '662', '26633', '10', '464');
INSERT INTO public.who_global_data_import VALUES (3784, '2020-07-04', 'AM', 'Armenia', 'EURO', '580', '27213', '8', '472');
INSERT INTO public.who_global_data_import VALUES (3785, '2020-07-05', 'AM', 'Armenia', 'EURO', '706', '27919', '7', '479');
INSERT INTO public.who_global_data_import VALUES (3786, '2020-07-06', 'AM', 'Armenia', 'EURO', '330', '28249', '7', '486');
INSERT INTO public.who_global_data_import VALUES (3787, '2020-07-07', 'AM', 'Armenia', 'EURO', '349', '28598', '12', '498');
INSERT INTO public.who_global_data_import VALUES (3788, '2020-07-08', 'AM', 'Armenia', 'EURO', '535', '29133', '18', '516');
INSERT INTO public.who_global_data_import VALUES (3789, '2020-07-09', 'AM', 'Armenia', 'EURO', '526', '29659', '14', '530');
INSERT INTO public.who_global_data_import VALUES (3790, '2020-07-10', 'AM', 'Armenia', 'EURO', '557', '30216', '11', '541');
INSERT INTO public.who_global_data_import VALUES (3791, '2020-07-11', 'AM', 'Armenia', 'EURO', '489', '30705', '13', '554');
INSERT INTO public.who_global_data_import VALUES (3792, '2020-07-12', 'AM', 'Armenia', 'EURO', '577', '31282', '6', '560');
INSERT INTO public.who_global_data_import VALUES (3793, '2020-07-13', 'AM', 'Armenia', 'EURO', '182', '31464', '8', '568');
INSERT INTO public.who_global_data_import VALUES (3794, '2020-07-14', 'AM', 'Armenia', 'EURO', '339', '31803', '8', '576');
INSERT INTO public.who_global_data_import VALUES (3795, '2020-07-15', 'AM', 'Armenia', 'EURO', '515', '32318', '11', '587');
INSERT INTO public.who_global_data_import VALUES (3796, '2020-07-16', 'AM', 'Armenia', 'EURO', '554', '32872', '15', '602');
INSERT INTO public.who_global_data_import VALUES (3797, '2020-07-17', 'AM', 'Armenia', 'EURO', '442', '33314', '13', '615');
INSERT INTO public.who_global_data_import VALUES (3798, '2020-07-18', 'AM', 'Armenia', 'EURO', '461', '33775', '11', '626');
INSERT INTO public.who_global_data_import VALUES (3799, '2020-07-19', 'AM', 'Armenia', 'EURO', '415', '34190', '10', '636');
INSERT INTO public.who_global_data_import VALUES (3800, '2020-07-20', 'AM', 'Armenia', 'EURO', '104', '34294', '9', '645');
INSERT INTO public.who_global_data_import VALUES (3801, '2020-07-21', 'AM', 'Armenia', 'EURO', '273', '34567', '12', '657');
INSERT INTO public.who_global_data_import VALUES (3802, '2020-07-22', 'AM', 'Armenia', 'EURO', '439', '35006', '16', '673');
INSERT INTO public.who_global_data_import VALUES (3803, '2020-07-23', 'AM', 'Armenia', 'EURO', '469', '35475', '10', '683');
INSERT INTO public.who_global_data_import VALUES (3804, '2020-07-24', 'AM', 'Armenia', 'EURO', '451', '35926', '4', '687');
INSERT INTO public.who_global_data_import VALUES (3805, '2020-07-25', 'AM', 'Armenia', 'EURO', '383', '36309', '8', '695');
INSERT INTO public.who_global_data_import VALUES (3806, '2020-07-26', 'AM', 'Armenia', 'EURO', '321', '36630', '5', '700');
INSERT INTO public.who_global_data_import VALUES (3807, '2020-07-27', 'AM', 'Armenia', 'EURO', '73', '36703', '6', '706');
INSERT INTO public.who_global_data_import VALUES (3808, '2020-07-28', 'AM', 'Armenia', 'EURO', '239', '36942', '8', '714');
INSERT INTO public.who_global_data_import VALUES (3809, '2020-07-29', 'AM', 'Armenia', 'EURO', '308', '37250', '4', '718');
INSERT INTO public.who_global_data_import VALUES (3810, '2020-07-30', 'AM', 'Armenia', 'EURO', '259', '37509', '5', '723');
INSERT INTO public.who_global_data_import VALUES (3811, '2020-07-31', 'AM', 'Armenia', 'EURO', '354', '37863', '10', '733');
INSERT INTO public.who_global_data_import VALUES (3812, '2020-08-01', 'AM', 'Armenia', 'EURO', '291', '38154', '11', '744');
INSERT INTO public.who_global_data_import VALUES (3813, '2020-08-02', 'AM', 'Armenia', 'EURO', '209', '38363', '5', '749');
INSERT INTO public.who_global_data_import VALUES (3814, '2020-08-03', 'AM', 'Armenia', 'EURO', '52', '38415', '8', '757');
INSERT INTO public.who_global_data_import VALUES (3815, '2020-08-04', 'AM', 'Armenia', 'EURO', '196', '38611', '6', '763');
INSERT INTO public.who_global_data_import VALUES (3816, '2020-08-05', 'AM', 'Armenia', 'EURO', '288', '38899', '2', '765');
INSERT INTO public.who_global_data_import VALUES (3817, '2020-08-06', 'AM', 'Armenia', 'EURO', '233', '39132', '2', '767');
INSERT INTO public.who_global_data_import VALUES (3818, '2020-08-07', 'AM', 'Armenia', 'EURO', '166', '39298', '5', '772');
INSERT INTO public.who_global_data_import VALUES (3819, '2020-08-08', 'AM', 'Armenia', 'EURO', '200', '39498', '8', '780');
INSERT INTO public.who_global_data_import VALUES (3820, '2020-08-09', 'AM', 'Armenia', 'EURO', '225', '39723', '6', '786');
INSERT INTO public.who_global_data_import VALUES (3821, '2020-08-10', 'AM', 'Armenia', 'EURO', '23', '39746', '5', '791');
INSERT INTO public.who_global_data_import VALUES (3822, '2020-08-11', 'AM', 'Armenia', 'EURO', '160', '39906', '7', '798');
INSERT INTO public.who_global_data_import VALUES (3823, '2020-08-12', 'AM', 'Armenia', 'EURO', '201', '40107', '3', '801');
INSERT INTO public.who_global_data_import VALUES (3824, '2020-08-13', 'AM', 'Armenia', 'EURO', '229', '40336', '3', '804');
INSERT INTO public.who_global_data_import VALUES (3825, '2020-08-14', 'AM', 'Armenia', 'EURO', '276', '40612', '5', '809');
INSERT INTO public.who_global_data_import VALUES (3826, '2020-08-15', 'AM', 'Armenia', 'EURO', '196', '40808', '3', '812');
INSERT INTO public.who_global_data_import VALUES (3827, '2020-08-16', 'AM', 'Armenia', 'EURO', '168', '40976', '1', '813');
INSERT INTO public.who_global_data_import VALUES (3828, '2020-08-17', 'AM', 'Armenia', 'EURO', '38', '41014', '6', '819');
INSERT INTO public.who_global_data_import VALUES (3829, '2020-08-18', 'AM', 'Armenia', 'EURO', '145', '41159', '8', '827');
INSERT INTO public.who_global_data_import VALUES (3830, '2020-08-19', 'AM', 'Armenia', 'EURO', '210', '41369', '1', '828');
INSERT INTO public.who_global_data_import VALUES (3831, '2020-08-20', 'AM', 'Armenia', 'EURO', '263', '41632', '3', '831');
INSERT INTO public.who_global_data_import VALUES (3832, '2020-08-21', 'AM', 'Armenia', 'EURO', '158', '41790', '6', '837');
INSERT INTO public.who_global_data_import VALUES (3833, '2020-08-22', 'AM', 'Armenia', 'EURO', '139', '41929', '8', '845');
INSERT INTO public.who_global_data_import VALUES (3834, '2020-08-23', 'AM', 'Armenia', 'EURO', '176', '42105', '2', '847');
INSERT INTO public.who_global_data_import VALUES (3835, '2020-08-24', 'AM', 'Armenia', 'EURO', '33', '42138', '2', '849');
INSERT INTO public.who_global_data_import VALUES (3836, '2020-08-25', 'AM', 'Armenia', 'EURO', '111', '42249', '4', '853');
INSERT INTO public.who_global_data_import VALUES (3837, '2020-08-26', 'AM', 'Armenia', 'EURO', '131', '42380', '3', '856');
INSERT INTO public.who_global_data_import VALUES (3838, '2020-08-27', 'AM', 'Armenia', 'EURO', '203', '42583', '3', '859');
INSERT INTO public.who_global_data_import VALUES (3839, '2020-08-28', 'AM', 'Armenia', 'EURO', '181', '42764', '5', '864');
INSERT INTO public.who_global_data_import VALUES (3840, '2020-08-29', 'AM', 'Armenia', 'EURO', '175', '42939', '3', '867');
INSERT INTO public.who_global_data_import VALUES (3841, '2020-08-30', 'AM', 'Armenia', 'EURO', '124', '43063', '5', '872');
INSERT INTO public.who_global_data_import VALUES (3842, '2020-08-31', 'AM', 'Armenia', 'EURO', '31', '43094', '2', '874');
INSERT INTO public.who_global_data_import VALUES (3843, '2020-09-01', 'AM', 'Armenia', 'EURO', '97', '43191', '2', '876');
INSERT INTO public.who_global_data_import VALUES (3844, '2020-09-02', 'AM', 'Armenia', 'EURO', '197', '43388', '3', '879');
INSERT INTO public.who_global_data_import VALUES (3845, '2020-09-03', 'AM', 'Armenia', 'EURO', '196', '43584', '3', '882');
INSERT INTO public.who_global_data_import VALUES (3846, '2020-09-04', 'AM', 'Armenia', 'EURO', '190', '43774', '4', '886');
INSERT INTO public.who_global_data_import VALUES (3847, '2020-09-05', 'AM', 'Armenia', 'EURO', '188', '43962', '4', '890');
INSERT INTO public.who_global_data_import VALUES (3848, '2020-09-06', 'AM', 'Armenia', 'EURO', '134', '44096', '2', '892');
INSERT INTO public.who_global_data_import VALUES (3849, '2020-09-07', 'AM', 'Armenia', 'EURO', '62', '44158', '3', '895');
INSERT INTO public.who_global_data_import VALUES (3850, '2020-09-08', 'AM', 'Armenia', 'EURO', '108', '44266', '3', '898');
INSERT INTO public.who_global_data_import VALUES (3851, '2020-09-09', 'AM', 'Armenia', 'EURO', '199', '44465', '2', '900');
INSERT INTO public.who_global_data_import VALUES (3852, '2020-09-10', 'AM', 'Armenia', 'EURO', '174', '44639', '1', '901');
INSERT INTO public.who_global_data_import VALUES (3853, '2020-09-11', 'AM', 'Armenia', 'EURO', '177', '44816', '3', '904');
INSERT INTO public.who_global_data_import VALUES (3854, '2020-09-12', 'AM', 'Armenia', 'EURO', '172', '44988', '2', '906');
INSERT INTO public.who_global_data_import VALUES (3855, '2020-09-13', 'AM', 'Armenia', 'EURO', '187', '45175', '5', '911');
INSERT INTO public.who_global_data_import VALUES (3856, '2020-09-14', 'AM', 'Armenia', 'EURO', '107', '45282', '3', '914');
INSERT INTO public.who_global_data_import VALUES (3857, '2020-09-15', 'AM', 'Armenia', 'EURO', '150', '45432', '1', '915');
INSERT INTO public.who_global_data_import VALUES (3858, '2020-09-16', 'AM', 'Armenia', 'EURO', '257', '45689', '3', '918');
INSERT INTO public.who_global_data_import VALUES (3859, '2020-09-17', 'AM', 'Armenia', 'EURO', '295', '45984', '2', '920');
INSERT INTO public.who_global_data_import VALUES (3860, '2020-09-18', 'AM', 'Armenia', 'EURO', '239', '46223', '1', '921');
INSERT INTO public.who_global_data_import VALUES (3861, '2020-09-19', 'AM', 'Armenia', 'EURO', '244', '46467', '2', '923');
INSERT INTO public.who_global_data_import VALUES (3862, '2020-09-20', 'AM', 'Armenia', 'EURO', '277', '46744', '2', '925');
INSERT INTO public.who_global_data_import VALUES (3863, '2020-09-21', 'AM', 'Armenia', 'EURO', '121', '46865', '6', '931');
INSERT INTO public.who_global_data_import VALUES (3864, '2020-09-22', 'AM', 'Armenia', 'EURO', '115', '46980', '2', '933');
INSERT INTO public.who_global_data_import VALUES (3865, '2020-09-23', 'AM', 'Armenia', 'EURO', '210', '47190', '4', '937');
INSERT INTO public.who_global_data_import VALUES (3866, '2020-09-24', 'AM', 'Armenia', 'EURO', '374', '47564', '3', '940');
INSERT INTO public.who_global_data_import VALUES (3867, '2020-09-25', 'AM', 'Armenia', 'EURO', '392', '47956', '2', '942');
INSERT INTO public.who_global_data_import VALUES (3868, '2020-09-26', 'AM', 'Armenia', 'EURO', '429', '48385', '1', '943');
INSERT INTO public.who_global_data_import VALUES (3869, '2020-09-27', 'AM', 'Armenia', 'EURO', '328', '48713', '3', '946');
INSERT INTO public.who_global_data_import VALUES (3870, '2020-09-28', 'AM', 'Armenia', 'EURO', '174', '48887', '6', '952');
INSERT INTO public.who_global_data_import VALUES (3871, '2020-09-29', 'AM', 'Armenia', 'EURO', '327', '49214', '1', '953');
INSERT INTO public.who_global_data_import VALUES (3872, '2020-09-30', 'AM', 'Armenia', 'EURO', '458', '49672', '1', '954');
INSERT INTO public.who_global_data_import VALUES (3873, '2020-10-01', 'AM', 'Armenia', 'EURO', '491', '50163', '4', '958');
INSERT INTO public.who_global_data_import VALUES (3874, '2020-10-02', 'AM', 'Armenia', 'EURO', '532', '50695', '3', '961');
INSERT INTO public.who_global_data_import VALUES (3875, '2020-10-03', 'AM', 'Armenia', 'EURO', '543', '51238', '6', '967');
INSERT INTO public.who_global_data_import VALUES (3876, '2020-10-04', 'AM', 'Armenia', 'EURO', '571', '51809', '5', '972');
INSERT INTO public.who_global_data_import VALUES (3877, '2020-10-05', 'AM', 'Armenia', 'EURO', '181', '51990', '7', '979');
INSERT INTO public.who_global_data_import VALUES (3878, '2020-10-06', 'AM', 'Armenia', 'EURO', '406', '52396', '6', '985');
INSERT INTO public.who_global_data_import VALUES (3879, '2020-10-07', 'AM', 'Armenia', 'EURO', '672', '53068', '5', '990');
INSERT INTO public.who_global_data_import VALUES (3880, '2020-10-08', 'AM', 'Armenia', 'EURO', '718', '53786', '9', '999');
INSERT INTO public.who_global_data_import VALUES (3881, '2020-10-09', 'AM', 'Armenia', 'EURO', '614', '54400', '6', '1005');
INSERT INTO public.who_global_data_import VALUES (3882, '2020-10-10', 'AM', 'Armenia', 'EURO', '649', '55049', '6', '1011');
INSERT INTO public.who_global_data_import VALUES (3883, '2020-10-11', 'AM', 'Armenia', 'EURO', '715', '55764', '4', '1015');
INSERT INTO public.who_global_data_import VALUES (3884, '2020-10-12', 'AM', 'Armenia', 'EURO', '370', '56134', '6', '1021');
INSERT INTO public.who_global_data_import VALUES (3885, '2020-10-13', 'AM', 'Armenia', 'EURO', '745', '56879', '6', '1027');
INSERT INTO public.who_global_data_import VALUES (3886, '2020-10-14', 'AM', 'Armenia', 'EURO', '1058', '57937', '7', '1034');
INSERT INTO public.who_global_data_import VALUES (3887, '2020-10-15', 'AM', 'Armenia', 'EURO', '1371', '59308', '7', '1041');
INSERT INTO public.who_global_data_import VALUES (3888, '2020-10-16', 'AM', 'Armenia', 'EURO', '1465', '60773', '10', '1051');
INSERT INTO public.who_global_data_import VALUES (3889, '2020-10-17', 'AM', 'Armenia', 'EURO', '1540', '62313', '11', '1062');
INSERT INTO public.who_global_data_import VALUES (3890, '2020-10-18', 'AM', 'Armenia', 'EURO', '1694', '64007', '14', '1076');
INSERT INTO public.who_global_data_import VALUES (3891, '2020-10-19', 'AM', 'Armenia', 'EURO', '766', '64773', '10', '1086');
INSERT INTO public.who_global_data_import VALUES (3892, '2020-10-20', 'AM', 'Armenia', 'EURO', '1234', '66007', '10', '1096');
INSERT INTO public.who_global_data_import VALUES (3893, '2020-10-21', 'AM', 'Armenia', 'EURO', '1836', '67843', '20', '1116');
INSERT INTO public.who_global_data_import VALUES (3894, '2020-10-22', 'AM', 'Armenia', 'EURO', '2306', '70149', '10', '1126');
INSERT INTO public.who_global_data_import VALUES (3895, '2020-10-23', 'AM', 'Armenia', 'EURO', '2474', '72623', '14', '1140');
INSERT INTO public.who_global_data_import VALUES (3896, '2020-10-24', 'AM', 'Armenia', 'EURO', '2213', '74836', '12', '1152');
INSERT INTO public.who_global_data_import VALUES (3897, '2020-10-25', 'AM', 'Armenia', 'EURO', '2314', '77150', '23', '1175');
INSERT INTO public.who_global_data_import VALUES (3898, '2020-10-26', 'AM', 'Armenia', 'EURO', '973', '78123', '16', '1191');
INSERT INTO public.who_global_data_import VALUES (3899, '2020-10-27', 'AM', 'Armenia', 'EURO', '1600', '79723', '26', '1217');
INSERT INTO public.who_global_data_import VALUES (3900, '2020-10-28', 'AM', 'Armenia', 'EURO', '2241', '81964', '21', '1238');
INSERT INTO public.who_global_data_import VALUES (3901, '2020-10-29', 'AM', 'Armenia', 'EURO', '2383', '84347', '29', '1267');
INSERT INTO public.who_global_data_import VALUES (3902, '2020-10-30', 'AM', 'Armenia', 'EURO', '2398', '86745', '28', '1295');
INSERT INTO public.who_global_data_import VALUES (3903, '2020-10-31', 'AM', 'Armenia', 'EURO', '2381', '89126', '41', '1336');
INSERT INTO public.who_global_data_import VALUES (3904, '2020-11-01', 'AM', 'Armenia', 'EURO', '2441', '91567', '22', '1358');
INSERT INTO public.who_global_data_import VALUES (3905, '2020-11-02', 'AM', 'Armenia', 'EURO', '1194', '92761', '28', '1386');
INSERT INTO public.who_global_data_import VALUES (3906, '2020-11-03', 'AM', 'Armenia', 'EURO', '1328', '94089', '22', '1408');
INSERT INTO public.who_global_data_import VALUES (3907, '2020-11-04', 'AM', 'Armenia', 'EURO', '2374', '96463', '35', '1443');
INSERT INTO public.who_global_data_import VALUES (3908, '2020-11-05', 'AM', 'Armenia', 'EURO', '2413', '98876', '28', '1471');
INSERT INTO public.who_global_data_import VALUES (3909, '2020-11-06', 'AM', 'Armenia', 'EURO', '2210', '101086', '30', '1501');
INSERT INTO public.who_global_data_import VALUES (3910, '2020-11-07', 'AM', 'Armenia', 'EURO', '2476', '103562', '27', '1528');
INSERT INTO public.who_global_data_import VALUES (3911, '2020-11-08', 'AM', 'Armenia', 'EURO', '2175', '105737', '26', '1554');
INSERT INTO public.who_global_data_import VALUES (3912, '2020-11-09', 'AM', 'Armenia', 'EURO', '1042', '106779', '21', '1575');
INSERT INTO public.who_global_data_import VALUES (3913, '2020-11-10', 'AM', 'Armenia', 'EURO', '1221', '108000', '29', '1604');
INSERT INTO public.who_global_data_import VALUES (3914, '2020-11-11', 'AM', 'Armenia', 'EURO', '1861', '109861', '27', '1631');
INSERT INTO public.who_global_data_import VALUES (3915, '2020-11-12', 'AM', 'Armenia', 'EURO', '2132', '111993', '32', '1663');
INSERT INTO public.who_global_data_import VALUES (3916, '2020-11-13', 'AM', 'Armenia', 'EURO', '1703', '113696', '29', '1692');
INSERT INTO public.who_global_data_import VALUES (3917, '2020-11-14', 'AM', 'Armenia', 'EURO', '1472', '115168', '41', '1733');
INSERT INTO public.who_global_data_import VALUES (3918, '2020-11-15', 'AM', 'Armenia', 'EURO', '1482', '116650', '25', '1758');
INSERT INTO public.who_global_data_import VALUES (3919, '2020-11-16', 'AM', 'Armenia', 'EURO', '549', '117199', '25', '1783');
INSERT INTO public.who_global_data_import VALUES (3920, '2020-11-17', 'AM', 'Armenia', 'EURO', '984', '118183', '23', '1806');
INSERT INTO public.who_global_data_import VALUES (3921, '2020-11-18', 'AM', 'Armenia', 'EURO', '1589', '119772', '28', '1834');
INSERT INTO public.who_global_data_import VALUES (3922, '2020-11-19', 'AM', 'Armenia', 'EURO', '1520', '121292', '31', '1865');
INSERT INTO public.who_global_data_import VALUES (3923, '2020-11-20', 'AM', 'Armenia', 'EURO', '1667', '122959', '30', '1895');
INSERT INTO public.who_global_data_import VALUES (3924, '2020-11-21', 'AM', 'Armenia', 'EURO', '1193', '124152', '31', '1926');
INSERT INTO public.who_global_data_import VALUES (3925, '2020-11-22', 'AM', 'Armenia', 'EURO', '1385', '125537', '21', '1947');
INSERT INTO public.who_global_data_import VALUES (3926, '2020-11-23', 'AM', 'Armenia', 'EURO', '485', '126022', '24', '1971');
INSERT INTO public.who_global_data_import VALUES (3927, '2020-11-24', 'AM', 'Armenia', 'EURO', '813', '126835', '26', '1997');
INSERT INTO public.who_global_data_import VALUES (3928, '2020-11-25', 'AM', 'Armenia', 'EURO', '1563', '128398', '38', '2035');
INSERT INTO public.who_global_data_import VALUES (3929, '2020-11-26', 'AM', 'Armenia', 'EURO', '1785', '130183', '28', '2063');
INSERT INTO public.who_global_data_import VALUES (3930, '2020-11-27', 'AM', 'Armenia', 'EURO', '1476', '131659', '22', '2085');
INSERT INTO public.who_global_data_import VALUES (3931, '2020-11-28', 'AM', 'Armenia', 'EURO', '1248', '132907', '31', '2116');
INSERT INTO public.who_global_data_import VALUES (3932, '2020-11-29', 'AM', 'Armenia', 'EURO', '1174', '134081', '21', '2137');
INSERT INTO public.who_global_data_import VALUES (3933, '2020-11-30', 'AM', 'Armenia', 'EURO', '356', '134437', '22', '2159');
INSERT INTO public.who_global_data_import VALUES (3934, '2020-12-01', 'AM', 'Armenia', 'EURO', '843', '135280', '29', '2188');
INSERT INTO public.who_global_data_import VALUES (3935, '2020-12-02', 'AM', 'Armenia', 'EURO', '1264', '136544', '35', '2223');
INSERT INTO public.who_global_data_import VALUES (3936, '2020-12-03', 'AM', 'Armenia', 'EURO', '1277', '137821', '26', '2249');
INSERT INTO public.who_global_data_import VALUES (3937, '2020-12-04', 'AM', 'Armenia', 'EURO', '1184', '139005', '23', '2272');
INSERT INTO public.who_global_data_import VALUES (3938, '2020-12-05', 'AM', 'Armenia', 'EURO', '1267', '140272', '32', '2304');
INSERT INTO public.who_global_data_import VALUES (3939, '2020-12-06', 'AM', 'Armenia', 'EURO', '978', '141250', '17', '2321');
INSERT INTO public.who_global_data_import VALUES (3940, '2020-12-07', 'AM', 'Armenia', 'EURO', '407', '141657', '18', '2339');
INSERT INTO public.who_global_data_import VALUES (3941, '2020-12-08', 'AM', 'Armenia', 'EURO', '584', '142241', '28', '2367');
INSERT INTO public.who_global_data_import VALUES (3942, '2020-12-09', 'AM', 'Armenia', 'EURO', '1138', '143379', '21', '2388');
INSERT INTO public.who_global_data_import VALUES (3943, '2020-12-10', 'AM', 'Armenia', 'EURO', '1174', '144553', '23', '2411');
INSERT INTO public.who_global_data_import VALUES (3944, '2020-12-11', 'AM', 'Armenia', 'EURO', '1077', '145630', '29', '2440');
INSERT INTO public.who_global_data_import VALUES (3945, '2020-12-12', 'AM', 'Armenia', 'EURO', '995', '146625', '17', '2457');
INSERT INTO public.who_global_data_import VALUES (3946, '2020-12-13', 'AM', 'Armenia', 'EURO', '1013', '147638', '24', '2481');
INSERT INTO public.who_global_data_import VALUES (3947, '2020-12-14', 'AM', 'Armenia', 'EURO', '357', '147995', '17', '2498');
INSERT INTO public.who_global_data_import VALUES (3948, '2020-12-15', 'AM', 'Armenia', 'EURO', '438', '148433', '26', '2524');
INSERT INTO public.who_global_data_import VALUES (3949, '2020-12-16', 'AM', 'Armenia', 'EURO', '1098', '149531', '27', '2551');
INSERT INTO public.who_global_data_import VALUES (3950, '2020-12-17', 'AM', 'Armenia', 'EURO', '1174', '150705', '25', '2576');
INSERT INTO public.who_global_data_import VALUES (3951, '2020-12-18', 'AM', 'Armenia', 'EURO', '861', '151566', '15', '2591');
INSERT INTO public.who_global_data_import VALUES (3952, '2020-12-19', 'AM', 'Armenia', 'EURO', '920', '152486', '20', '2611');
INSERT INTO public.who_global_data_import VALUES (3953, '2020-12-20', 'AM', 'Armenia', 'EURO', '652', '153138', '14', '2625');
INSERT INTO public.who_global_data_import VALUES (3954, '2020-12-21', 'AM', 'Armenia', 'EURO', '240', '153378', '26', '2651');
INSERT INTO public.who_global_data_import VALUES (3955, '2020-12-22', 'AM', 'Armenia', 'EURO', '537', '153915', '17', '2668');
INSERT INTO public.who_global_data_import VALUES (3956, '2020-12-23', 'AM', 'Armenia', 'EURO', '838', '154753', '18', '2686');
INSERT INTO public.who_global_data_import VALUES (3957, '2020-12-24', 'AM', 'Armenia', 'EURO', '702', '155455', '23', '2709');
INSERT INTO public.who_global_data_import VALUES (3958, '2020-12-25', 'AM', 'Armenia', 'EURO', '621', '156076', '19', '2728');
INSERT INTO public.who_global_data_import VALUES (3959, '2020-12-26', 'AM', 'Armenia', 'EURO', '586', '156662', '19', '2747');
INSERT INTO public.who_global_data_import VALUES (3960, '2020-12-27', 'AM', 'Armenia', 'EURO', '485', '157147', '16', '2763');
INSERT INTO public.who_global_data_import VALUES (3961, '2020-12-28', 'AM', 'Armenia', 'EURO', '114', '157261', '7', '2770');
INSERT INTO public.who_global_data_import VALUES (3962, '2020-12-29', 'AM', 'Armenia', 'EURO', '348', '157609', '22', '2792');
INSERT INTO public.who_global_data_import VALUES (3963, '2020-12-30', 'AM', 'Armenia', 'EURO', '0', '157609', '0', '2792');
INSERT INTO public.who_global_data_import VALUES (3964, '2020-12-31', 'AM', 'Armenia', 'EURO', '582', '158191', '10', '2802');
INSERT INTO public.who_global_data_import VALUES (3965, '2021-01-01', 'AM', 'Armenia', 'EURO', '531', '158722', '16', '2818');
INSERT INTO public.who_global_data_import VALUES (3966, '2021-01-02', 'AM', 'Armenia', 'EURO', '1016', '159738', '10', '2828');
INSERT INTO public.who_global_data_import VALUES (3967, '2021-01-03', 'AM', 'Armenia', 'EURO', '289', '160027', '22', '2850');
INSERT INTO public.who_global_data_import VALUES (3968, '2021-01-04', 'AM', 'Armenia', 'EURO', '193', '160220', '14', '2864');
INSERT INTO public.who_global_data_import VALUES (3969, '2021-01-05', 'AM', 'Armenia', 'EURO', '324', '160544', '14', '2878');
INSERT INTO public.who_global_data_import VALUES (3970, '2021-01-06', 'AM', 'Armenia', 'EURO', '309', '160853', '12', '2890');
INSERT INTO public.who_global_data_import VALUES (3971, '2021-01-07', 'AM', 'Armenia', 'EURO', '201', '161054', '11', '2901');
INSERT INTO public.who_global_data_import VALUES (3972, '2021-01-08', 'AM', 'Armenia', 'EURO', '361', '161415', '7', '2908');
INSERT INTO public.who_global_data_import VALUES (3973, '2021-01-09', 'AM', 'Armenia', 'EURO', '379', '161794', '14', '2922');
INSERT INTO public.who_global_data_import VALUES (3974, '2021-01-10', 'AM', 'Armenia', 'EURO', '337', '162131', '7', '2929');
INSERT INTO public.who_global_data_import VALUES (3975, '2021-01-11', 'AM', 'Armenia', 'EURO', '757', '162888', '2', '2931');
INSERT INTO public.who_global_data_import VALUES (3976, '2021-01-12', 'AM', 'Armenia', 'EURO', '0', '162888', '0', '2931');
INSERT INTO public.who_global_data_import VALUES (3977, '2021-01-13', 'AM', 'Armenia', 'EURO', '240', '163128', '20', '2951');
INSERT INTO public.who_global_data_import VALUES (3978, '2021-01-14', 'AM', 'Armenia', 'EURO', '448', '163576', '12', '2963');
INSERT INTO public.who_global_data_import VALUES (3979, '2021-01-15', 'AM', 'Armenia', 'EURO', '396', '163972', '11', '2974');
INSERT INTO public.who_global_data_import VALUES (3980, '2021-01-16', 'AM', 'Armenia', 'EURO', '263', '164235', '13', '2987');
INSERT INTO public.who_global_data_import VALUES (3981, '2021-01-17', 'AM', 'Armenia', 'EURO', '351', '164586', '5', '2992');
INSERT INTO public.who_global_data_import VALUES (3982, '2021-01-18', 'AM', 'Armenia', 'EURO', '90', '164676', '6', '2998');
INSERT INTO public.who_global_data_import VALUES (3983, '2021-01-19', 'AM', 'Armenia', 'EURO', '236', '164912', '9', '3007');
INSERT INTO public.who_global_data_import VALUES (3984, '2021-01-20', 'AM', 'Armenia', 'EURO', '309', '165221', '9', '3016');
INSERT INTO public.who_global_data_import VALUES (3985, '2021-01-21', 'AM', 'Armenia', 'EURO', '307', '165528', '5', '3021');
INSERT INTO public.who_global_data_import VALUES (3986, '2021-01-22', 'AM', 'Armenia', 'EURO', '183', '165711', '9', '3030');
INSERT INTO public.who_global_data_import VALUES (3987, '2021-01-23', 'AM', 'Armenia', 'EURO', '198', '165909', '4', '3034');
INSERT INTO public.who_global_data_import VALUES (3988, '2021-01-24', 'AM', 'Armenia', 'EURO', '127', '166036', '5', '3039');
INSERT INTO public.who_global_data_import VALUES (3989, '2021-01-25', 'AM', 'Armenia', 'EURO', '58', '166094', '8', '3047');
INSERT INTO public.who_global_data_import VALUES (3990, '2021-01-26', 'AM', 'Armenia', 'EURO', '138', '166232', '5', '3052');
INSERT INTO public.who_global_data_import VALUES (3991, '2021-01-27', 'AM', 'Armenia', 'EURO', '195', '166427', '4', '3056');
INSERT INTO public.who_global_data_import VALUES (3992, '2021-01-28', 'AM', 'Armenia', 'EURO', '242', '166669', '11', '3067');
INSERT INTO public.who_global_data_import VALUES (3993, '2021-01-29', 'AM', 'Armenia', 'EURO', '59', '166728', '2', '3069');
INSERT INTO public.who_global_data_import VALUES (3994, '2021-01-30', 'AM', 'Armenia', 'EURO', '173', '166901', '2', '3071');
INSERT INTO public.who_global_data_import VALUES (3995, '2021-01-31', 'AM', 'Armenia', 'EURO', '125', '167026', '9', '3080');
INSERT INTO public.who_global_data_import VALUES (3996, '2021-02-01', 'AM', 'Armenia', 'EURO', '62', '167088', '4', '3084');
INSERT INTO public.who_global_data_import VALUES (3997, '2021-02-02', 'AM', 'Armenia', 'EURO', '143', '167231', '5', '3089');
INSERT INTO public.who_global_data_import VALUES (3998, '2021-02-03', 'AM', 'Armenia', 'EURO', '190', '167421', '7', '3096');
INSERT INTO public.who_global_data_import VALUES (3999, '2021-02-04', 'AM', 'Armenia', 'EURO', '147', '167568', '11', '3107');
INSERT INTO public.who_global_data_import VALUES (4000, '2021-02-05', 'AM', 'Armenia', 'EURO', '158', '167726', '2', '3109');
INSERT INTO public.who_global_data_import VALUES (4001, '2020-01-03', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4002, '2020-01-04', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4003, '2020-01-05', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4004, '2020-01-06', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4005, '2020-01-07', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4006, '2020-01-08', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4007, '2020-01-09', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4008, '2020-01-10', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4009, '2020-01-11', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4010, '2020-01-12', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4011, '2020-01-13', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4012, '2020-01-14', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4013, '2020-01-15', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4014, '2020-01-16', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4015, '2020-01-17', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4016, '2020-01-18', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4017, '2020-01-19', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4018, '2020-01-20', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4019, '2020-01-21', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4020, '2020-01-22', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4021, '2020-01-23', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4022, '2020-01-24', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4023, '2020-01-25', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4024, '2020-01-26', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4025, '2020-01-27', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4026, '2020-01-28', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4027, '2020-01-29', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4028, '2020-01-30', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4029, '2020-01-31', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4030, '2020-02-01', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4031, '2020-02-02', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4032, '2020-02-03', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4033, '2020-02-04', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4034, '2020-02-05', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4035, '2020-02-06', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4036, '2020-02-07', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4037, '2020-02-08', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4038, '2020-02-09', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4039, '2020-02-10', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4040, '2020-02-11', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4041, '2020-02-12', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4042, '2020-02-13', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4043, '2020-02-14', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4044, '2020-02-15', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4045, '2020-02-16', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4046, '2020-02-17', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4047, '2020-02-18', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4048, '2020-02-19', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4049, '2020-02-20', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4050, '2020-02-21', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4051, '2020-02-22', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4052, '2020-02-23', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4053, '2020-02-24', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4054, '2020-02-25', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4055, '2020-02-26', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4056, '2020-02-27', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4057, '2020-02-28', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4058, '2020-02-29', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4059, '2020-03-01', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4060, '2020-03-02', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4061, '2020-03-03', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4062, '2020-03-04', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4063, '2020-03-05', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4064, '2020-03-06', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4065, '2020-03-07', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4066, '2020-03-08', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4067, '2020-03-09', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4068, '2020-03-10', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4069, '2020-03-11', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4070, '2020-03-12', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4071, '2020-03-13', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4072, '2020-03-14', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4073, '2020-03-15', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4074, '2020-03-16', 'AW', 'Aruba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4075, '2020-03-17', 'AW', 'Aruba', 'AMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4076, '2020-03-18', 'AW', 'Aruba', 'AMRO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4077, '2020-03-19', 'AW', 'Aruba', 'AMRO', '-3', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4078, '2020-03-20', 'AW', 'Aruba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4079, '2020-03-21', 'AW', 'Aruba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4080, '2020-03-22', 'AW', 'Aruba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4081, '2020-03-23', 'AW', 'Aruba', 'AMRO', '3', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4082, '2020-03-24', 'AW', 'Aruba', 'AMRO', '4', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4083, '2020-03-25', 'AW', 'Aruba', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4084, '2020-03-26', 'AW', 'Aruba', 'AMRO', '7', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4085, '2020-03-27', 'AW', 'Aruba', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4086, '2020-03-28', 'AW', 'Aruba', 'AMRO', '9', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4087, '2020-03-29', 'AW', 'Aruba', 'AMRO', '18', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4088, '2020-03-30', 'AW', 'Aruba', 'AMRO', '0', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4089, '2020-03-31', 'AW', 'Aruba', 'AMRO', '4', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4090, '2020-04-01', 'AW', 'Aruba', 'AMRO', '5', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4091, '2020-04-02', 'AW', 'Aruba', 'AMRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4092, '2020-04-03', 'AW', 'Aruba', 'AMRO', '5', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4093, '2020-04-04', 'AW', 'Aruba', 'AMRO', '2', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4094, '2020-04-05', 'AW', 'Aruba', 'AMRO', '2', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4095, '2020-04-06', 'AW', 'Aruba', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4096, '2020-04-07', 'AW', 'Aruba', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4097, '2020-04-08', 'AW', 'Aruba', 'AMRO', '7', '71', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4098, '2020-04-09', 'AW', 'Aruba', 'AMRO', '3', '74', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4099, '2020-04-10', 'AW', 'Aruba', 'AMRO', '8', '82', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4100, '2020-04-11', 'AW', 'Aruba', 'AMRO', '4', '86', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4101, '2020-04-12', 'AW', 'Aruba', 'AMRO', '6', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4102, '2020-04-13', 'AW', 'Aruba', 'AMRO', '0', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4103, '2020-04-14', 'AW', 'Aruba', 'AMRO', '0', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4104, '2020-04-15', 'AW', 'Aruba', 'AMRO', '0', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4105, '2020-04-16', 'AW', 'Aruba', 'AMRO', '1', '93', '1', '1');
INSERT INTO public.who_global_data_import VALUES (4106, '2020-04-17', 'AW', 'Aruba', 'AMRO', '2', '95', '1', '2');
INSERT INTO public.who_global_data_import VALUES (4107, '2020-04-18', 'AW', 'Aruba', 'AMRO', '1', '96', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4108, '2020-04-19', 'AW', 'Aruba', 'AMRO', '0', '96', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4109, '2020-04-20', 'AW', 'Aruba', 'AMRO', '1', '97', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4110, '2020-04-21', 'AW', 'Aruba', 'AMRO', '0', '97', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4111, '2020-04-22', 'AW', 'Aruba', 'AMRO', '0', '97', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4112, '2020-04-23', 'AW', 'Aruba', 'AMRO', '3', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4113, '2020-04-24', 'AW', 'Aruba', 'AMRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4114, '2020-04-25', 'AW', 'Aruba', 'AMRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4115, '2020-04-26', 'AW', 'Aruba', 'AMRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4116, '2020-04-27', 'AW', 'Aruba', 'AMRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4117, '2020-04-28', 'AW', 'Aruba', 'AMRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4118, '2020-04-29', 'AW', 'Aruba', 'AMRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4119, '2020-04-30', 'AW', 'Aruba', 'AMRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4120, '2020-05-01', 'AW', 'Aruba', 'AMRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4121, '2020-05-02', 'AW', 'Aruba', 'AMRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4122, '2020-05-03', 'AW', 'Aruba', 'AMRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4123, '2020-05-04', 'AW', 'Aruba', 'AMRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4124, '2020-05-05', 'AW', 'Aruba', 'AMRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4125, '2020-05-06', 'AW', 'Aruba', 'AMRO', '1', '101', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4126, '2020-05-07', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4127, '2020-05-08', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4128, '2020-05-09', 'AW', 'Aruba', 'AMRO', '0', '101', '1', '3');
INSERT INTO public.who_global_data_import VALUES (4129, '2020-05-10', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4130, '2020-05-11', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4131, '2020-05-12', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4132, '2020-05-13', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4133, '2020-05-14', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4134, '2020-05-15', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4135, '2020-05-16', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4136, '2020-05-17', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4137, '2020-05-18', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4138, '2020-05-19', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4139, '2020-05-20', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4140, '2020-05-21', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4141, '2020-05-22', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4142, '2020-05-23', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4143, '2020-05-24', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4144, '2020-05-25', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4145, '2020-05-26', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4146, '2020-05-27', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4147, '2020-05-28', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4148, '2020-05-29', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4149, '2020-05-30', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4150, '2020-05-31', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4151, '2020-06-01', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4152, '2020-06-02', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4153, '2020-06-03', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4154, '2020-06-04', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4155, '2020-06-05', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4156, '2020-06-06', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4157, '2020-06-07', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4158, '2020-06-08', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4159, '2020-06-09', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4160, '2020-06-10', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4161, '2020-06-11', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4162, '2020-06-12', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4163, '2020-06-13', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4164, '2020-06-14', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4165, '2020-06-15', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4166, '2020-06-16', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4167, '2020-06-17', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4168, '2020-06-18', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4169, '2020-06-19', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4170, '2020-06-20', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4171, '2020-06-21', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4172, '2020-06-22', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4173, '2020-06-23', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4174, '2020-06-24', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4175, '2020-06-25', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4176, '2020-06-26', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4177, '2020-06-27', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4178, '2020-06-28', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4179, '2020-06-29', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4180, '2020-06-30', 'AW', 'Aruba', 'AMRO', '0', '101', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4181, '2020-07-01', 'AW', 'Aruba', 'AMRO', '2', '103', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4182, '2020-07-02', 'AW', 'Aruba', 'AMRO', '0', '103', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4183, '2020-07-03', 'AW', 'Aruba', 'AMRO', '0', '103', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4184, '2020-07-04', 'AW', 'Aruba', 'AMRO', '1', '104', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4185, '2020-07-05', 'AW', 'Aruba', 'AMRO', '0', '104', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4186, '2020-07-06', 'AW', 'Aruba', 'AMRO', '0', '104', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4187, '2020-07-07', 'AW', 'Aruba', 'AMRO', '1', '105', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4188, '2020-07-08', 'AW', 'Aruba', 'AMRO', '0', '105', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4189, '2020-07-09', 'AW', 'Aruba', 'AMRO', '0', '105', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4190, '2020-07-10', 'AW', 'Aruba', 'AMRO', '0', '105', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4191, '2020-07-11', 'AW', 'Aruba', 'AMRO', '0', '105', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4192, '2020-07-12', 'AW', 'Aruba', 'AMRO', '0', '105', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4193, '2020-07-13', 'AW', 'Aruba', 'AMRO', '0', '105', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4194, '2020-07-14', 'AW', 'Aruba', 'AMRO', '0', '105', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4195, '2020-07-15', 'AW', 'Aruba', 'AMRO', '0', '105', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4196, '2020-07-16', 'AW', 'Aruba', 'AMRO', '1', '106', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4197, '2020-07-17', 'AW', 'Aruba', 'AMRO', '0', '106', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4198, '2020-07-18', 'AW', 'Aruba', 'AMRO', '2', '108', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4199, '2020-07-19', 'AW', 'Aruba', 'AMRO', '0', '108', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4200, '2020-07-20', 'AW', 'Aruba', 'AMRO', '0', '108', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4201, '2020-07-21', 'AW', 'Aruba', 'AMRO', '5', '113', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4202, '2020-07-22', 'AW', 'Aruba', 'AMRO', '2', '115', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4203, '2020-07-23', 'AW', 'Aruba', 'AMRO', '2', '117', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4204, '2020-07-24', 'AW', 'Aruba', 'AMRO', '0', '117', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4205, '2020-07-25', 'AW', 'Aruba', 'AMRO', '0', '117', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4206, '2020-07-26', 'AW', 'Aruba', 'AMRO', '0', '117', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4207, '2020-07-27', 'AW', 'Aruba', 'AMRO', '0', '117', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4208, '2020-07-28', 'AW', 'Aruba', 'AMRO', '2', '119', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4209, '2020-07-29', 'AW', 'Aruba', 'AMRO', '0', '119', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4210, '2020-07-30', 'AW', 'Aruba', 'AMRO', '0', '119', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4211, '2020-07-31', 'AW', 'Aruba', 'AMRO', '0', '119', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4212, '2020-08-01', 'AW', 'Aruba', 'AMRO', '1', '120', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4213, '2020-08-02', 'AW', 'Aruba', 'AMRO', '0', '120', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4214, '2020-08-03', 'AW', 'Aruba', 'AMRO', '0', '120', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4215, '2020-08-04', 'AW', 'Aruba', 'AMRO', '2', '122', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4216, '2020-08-05', 'AW', 'Aruba', 'AMRO', '2', '124', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4217, '2020-08-06', 'AW', 'Aruba', 'AMRO', '8', '132', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4218, '2020-08-07', 'AW', 'Aruba', 'AMRO', '39', '171', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4219, '2020-08-08', 'AW', 'Aruba', 'AMRO', '92', '263', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4220, '2020-08-09', 'AW', 'Aruba', 'AMRO', '0', '263', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4221, '2020-08-10', 'AW', 'Aruba', 'AMRO', '0', '263', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4222, '2020-08-11', 'AW', 'Aruba', 'AMRO', '300', '563', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4223, '2020-08-12', 'AW', 'Aruba', 'AMRO', '67', '630', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4224, '2020-08-13', 'AW', 'Aruba', 'AMRO', '87', '717', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4225, '2020-08-14', 'AW', 'Aruba', 'AMRO', '81', '798', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4226, '2020-08-15', 'AW', 'Aruba', 'AMRO', '96', '894', '1', '4');
INSERT INTO public.who_global_data_import VALUES (4227, '2020-08-16', 'AW', 'Aruba', 'AMRO', '0', '894', '0', '4');
INSERT INTO public.who_global_data_import VALUES (4228, '2020-08-17', 'AW', 'Aruba', 'AMRO', '0', '894', '0', '4');
INSERT INTO public.who_global_data_import VALUES (4229, '2020-08-18', 'AW', 'Aruba', 'AMRO', '208', '1102', '0', '4');
INSERT INTO public.who_global_data_import VALUES (4230, '2020-08-19', 'AW', 'Aruba', 'AMRO', '19', '1121', '0', '4');
INSERT INTO public.who_global_data_import VALUES (4231, '2020-08-20', 'AW', 'Aruba', 'AMRO', '84', '1205', '0', '4');
INSERT INTO public.who_global_data_import VALUES (4232, '2020-08-21', 'AW', 'Aruba', 'AMRO', '91', '1296', '1', '5');
INSERT INTO public.who_global_data_import VALUES (4233, '2020-08-22', 'AW', 'Aruba', 'AMRO', '91', '1387', '1', '6');
INSERT INTO public.who_global_data_import VALUES (4234, '2020-08-23', 'AW', 'Aruba', 'AMRO', '0', '1387', '0', '6');
INSERT INTO public.who_global_data_import VALUES (4235, '2020-08-24', 'AW', 'Aruba', 'AMRO', '0', '1387', '0', '6');
INSERT INTO public.who_global_data_import VALUES (4236, '2020-08-25', 'AW', 'Aruba', 'AMRO', '181', '1568', '1', '7');
INSERT INTO public.who_global_data_import VALUES (4237, '2020-08-26', 'AW', 'Aruba', 'AMRO', '60', '1628', '0', '7');
INSERT INTO public.who_global_data_import VALUES (4238, '2020-08-27', 'AW', 'Aruba', 'AMRO', '42', '1670', '1', '8');
INSERT INTO public.who_global_data_import VALUES (4239, '2020-08-28', 'AW', 'Aruba', 'AMRO', '90', '1760', '0', '8');
INSERT INTO public.who_global_data_import VALUES (4240, '2020-08-29', 'AW', 'Aruba', 'AMRO', '88', '1848', '0', '8');
INSERT INTO public.who_global_data_import VALUES (4241, '2020-08-30', 'AW', 'Aruba', 'AMRO', '0', '1848', '0', '8');
INSERT INTO public.who_global_data_import VALUES (4242, '2020-08-31', 'AW', 'Aruba', 'AMRO', '0', '1848', '0', '8');
INSERT INTO public.who_global_data_import VALUES (4243, '2020-09-01', 'AW', 'Aruba', 'AMRO', '149', '1997', '2', '10');
INSERT INTO public.who_global_data_import VALUES (4244, '2020-09-02', 'AW', 'Aruba', 'AMRO', '9', '2006', '0', '10');
INSERT INTO public.who_global_data_import VALUES (4245, '2020-09-03', 'AW', 'Aruba', 'AMRO', '98', '2104', '0', '10');
INSERT INTO public.who_global_data_import VALUES (4246, '2020-09-04', 'AW', 'Aruba', 'AMRO', '107', '2211', '2', '12');
INSERT INTO public.who_global_data_import VALUES (4247, '2020-09-05', 'AW', 'Aruba', 'AMRO', '81', '2292', '1', '13');
INSERT INTO public.who_global_data_import VALUES (4248, '2020-09-06', 'AW', 'Aruba', 'AMRO', '0', '2292', '0', '13');
INSERT INTO public.who_global_data_import VALUES (4249, '2020-09-07', 'AW', 'Aruba', 'AMRO', '0', '2292', '0', '13');
INSERT INTO public.who_global_data_import VALUES (4250, '2020-09-08', 'AW', 'Aruba', 'AMRO', '157', '2449', '1', '14');
INSERT INTO public.who_global_data_import VALUES (4251, '2020-09-09', 'AW', 'Aruba', 'AMRO', '33', '2482', '1', '15');
INSERT INTO public.who_global_data_import VALUES (4252, '2020-09-10', 'AW', 'Aruba', 'AMRO', '107', '2589', '0', '15');
INSERT INTO public.who_global_data_import VALUES (4253, '2020-09-11', 'AW', 'Aruba', 'AMRO', '141', '2730', '0', '15');
INSERT INTO public.who_global_data_import VALUES (4254, '2020-09-12', 'AW', 'Aruba', 'AMRO', '89', '2819', '1', '16');
INSERT INTO public.who_global_data_import VALUES (4255, '2020-09-13', 'AW', 'Aruba', 'AMRO', '0', '2819', '0', '16');
INSERT INTO public.who_global_data_import VALUES (4256, '2020-09-14', 'AW', 'Aruba', 'AMRO', '0', '2819', '0', '16');
INSERT INTO public.who_global_data_import VALUES (4257, '2020-09-15', 'AW', 'Aruba', 'AMRO', '227', '3046', '2', '18');
INSERT INTO public.who_global_data_import VALUES (4258, '2020-09-16', 'AW', 'Aruba', 'AMRO', '14', '3060', '2', '20');
INSERT INTO public.who_global_data_import VALUES (4259, '2020-09-17', 'AW', 'Aruba', 'AMRO', '92', '3152', '2', '22');
INSERT INTO public.who_global_data_import VALUES (4260, '2020-09-18', 'AW', 'Aruba', 'AMRO', '176', '3328', '0', '22');
INSERT INTO public.who_global_data_import VALUES (4261, '2020-09-19', 'AW', 'Aruba', 'AMRO', '54', '3382', '1', '23');
INSERT INTO public.who_global_data_import VALUES (4262, '2020-09-20', 'AW', 'Aruba', 'AMRO', '0', '3382', '0', '23');
INSERT INTO public.who_global_data_import VALUES (4263, '2020-09-21', 'AW', 'Aruba', 'AMRO', '0', '3382', '0', '23');
INSERT INTO public.who_global_data_import VALUES (4264, '2020-09-22', 'AW', 'Aruba', 'AMRO', '169', '3551', '0', '23');
INSERT INTO public.who_global_data_import VALUES (4265, '2020-09-23', 'AW', 'Aruba', 'AMRO', '36', '3587', '1', '24');
INSERT INTO public.who_global_data_import VALUES (4266, '2020-09-24', 'AW', 'Aruba', 'AMRO', '78', '3665', '1', '25');
INSERT INTO public.who_global_data_import VALUES (4267, '2020-09-25', 'AW', 'Aruba', 'AMRO', '56', '3721', '0', '25');
INSERT INTO public.who_global_data_import VALUES (4268, '2020-09-26', 'AW', 'Aruba', 'AMRO', '35', '3756', '0', '25');
INSERT INTO public.who_global_data_import VALUES (4269, '2020-09-27', 'AW', 'Aruba', 'AMRO', '0', '3756', '0', '25');
INSERT INTO public.who_global_data_import VALUES (4270, '2020-09-28', 'AW', 'Aruba', 'AMRO', '0', '3756', '0', '25');
INSERT INTO public.who_global_data_import VALUES (4271, '2020-09-29', 'AW', 'Aruba', 'AMRO', '88', '3844', '0', '25');
INSERT INTO public.who_global_data_import VALUES (4272, '2020-09-30', 'AW', 'Aruba', 'AMRO', '28', '3872', '0', '25');
INSERT INTO public.who_global_data_import VALUES (4273, '2020-10-01', 'AW', 'Aruba', 'AMRO', '62', '3934', '1', '26');
INSERT INTO public.who_global_data_import VALUES (4274, '2020-10-02', 'AW', 'Aruba', 'AMRO', '29', '3963', '1', '27');
INSERT INTO public.who_global_data_import VALUES (4275, '2020-10-03', 'AW', 'Aruba', 'AMRO', '35', '3998', '0', '27');
INSERT INTO public.who_global_data_import VALUES (4276, '2020-10-04', 'AW', 'Aruba', 'AMRO', '0', '3998', '0', '27');
INSERT INTO public.who_global_data_import VALUES (4277, '2020-10-05', 'AW', 'Aruba', 'AMRO', '0', '3998', '0', '27');
INSERT INTO public.who_global_data_import VALUES (4278, '2020-10-06', 'AW', 'Aruba', 'AMRO', '81', '4079', '3', '30');
INSERT INTO public.who_global_data_import VALUES (4279, '2020-10-07', 'AW', 'Aruba', 'AMRO', '15', '4094', '1', '31');
INSERT INTO public.who_global_data_import VALUES (4280, '2020-10-08', 'AW', 'Aruba', 'AMRO', '14', '4108', '0', '31');
INSERT INTO public.who_global_data_import VALUES (4281, '2020-10-09', 'AW', 'Aruba', 'AMRO', '25', '4133', '0', '31');
INSERT INTO public.who_global_data_import VALUES (4282, '2020-10-10', 'AW', 'Aruba', 'AMRO', '17', '4150', '0', '31');
INSERT INTO public.who_global_data_import VALUES (4283, '2020-10-11', 'AW', 'Aruba', 'AMRO', '0', '4150', '0', '31');
INSERT INTO public.who_global_data_import VALUES (4284, '2020-10-12', 'AW', 'Aruba', 'AMRO', '0', '4150', '0', '31');
INSERT INTO public.who_global_data_import VALUES (4285, '2020-10-13', 'AW', 'Aruba', 'AMRO', '44', '4194', '1', '32');
INSERT INTO public.who_global_data_import VALUES (4286, '2020-10-14', 'AW', 'Aruba', 'AMRO', '3', '4197', '0', '32');
INSERT INTO public.who_global_data_import VALUES (4287, '2020-10-15', 'AW', 'Aruba', 'AMRO', '32', '4229', '0', '32');
INSERT INTO public.who_global_data_import VALUES (4288, '2020-10-16', 'AW', 'Aruba', 'AMRO', '26', '4255', '0', '32');
INSERT INTO public.who_global_data_import VALUES (4289, '2020-10-17', 'AW', 'Aruba', 'AMRO', '30', '4285', '0', '32');
INSERT INTO public.who_global_data_import VALUES (4290, '2020-10-18', 'AW', 'Aruba', 'AMRO', '0', '4285', '0', '32');
INSERT INTO public.who_global_data_import VALUES (4291, '2020-10-19', 'AW', 'Aruba', 'AMRO', '0', '4285', '0', '32');
INSERT INTO public.who_global_data_import VALUES (4292, '2020-10-20', 'AW', 'Aruba', 'AMRO', '37', '4322', '2', '34');
INSERT INTO public.who_global_data_import VALUES (4293, '2020-10-21', 'AW', 'Aruba', 'AMRO', '12', '4334', '0', '34');
INSERT INTO public.who_global_data_import VALUES (4294, '2020-10-22', 'AW', 'Aruba', 'AMRO', '21', '4355', '0', '34');
INSERT INTO public.who_global_data_import VALUES (4295, '2020-10-23', 'AW', 'Aruba', 'AMRO', '14', '4369', '1', '35');
INSERT INTO public.who_global_data_import VALUES (4296, '2020-10-24', 'AW', 'Aruba', 'AMRO', '20', '4389', '1', '36');
INSERT INTO public.who_global_data_import VALUES (4297, '2020-10-25', 'AW', 'Aruba', 'AMRO', '0', '4389', '0', '36');
INSERT INTO public.who_global_data_import VALUES (4298, '2020-10-26', 'AW', 'Aruba', 'AMRO', '0', '4389', '0', '36');
INSERT INTO public.who_global_data_import VALUES (4299, '2020-10-27', 'AW', 'Aruba', 'AMRO', '31', '4420', '0', '36');
INSERT INTO public.who_global_data_import VALUES (4300, '2020-10-28', 'AW', 'Aruba', 'AMRO', '2', '4422', '0', '36');
INSERT INTO public.who_global_data_import VALUES (4301, '2020-10-29', 'AW', 'Aruba', 'AMRO', '15', '4437', '0', '36');
INSERT INTO public.who_global_data_import VALUES (4302, '2020-10-30', 'AW', 'Aruba', 'AMRO', '18', '4455', '1', '37');
INSERT INTO public.who_global_data_import VALUES (4303, '2020-10-31', 'AW', 'Aruba', 'AMRO', '17', '4472', '0', '37');
INSERT INTO public.who_global_data_import VALUES (4304, '2020-11-01', 'AW', 'Aruba', 'AMRO', '0', '4472', '0', '37');
INSERT INTO public.who_global_data_import VALUES (4305, '2020-11-02', 'AW', 'Aruba', 'AMRO', '0', '4472', '0', '37');
INSERT INTO public.who_global_data_import VALUES (4306, '2020-11-03', 'AW', 'Aruba', 'AMRO', '47', '4519', '1', '38');
INSERT INTO public.who_global_data_import VALUES (4307, '2020-11-04', 'AW', 'Aruba', 'AMRO', '5', '4524', '0', '38');
INSERT INTO public.who_global_data_import VALUES (4308, '2020-11-05', 'AW', 'Aruba', 'AMRO', '14', '4538', '0', '38');
INSERT INTO public.who_global_data_import VALUES (4309, '2020-11-06', 'AW', 'Aruba', 'AMRO', '15', '4553', '1', '39');
INSERT INTO public.who_global_data_import VALUES (4310, '2020-11-07', 'AW', 'Aruba', 'AMRO', '11', '4564', '0', '39');
INSERT INTO public.who_global_data_import VALUES (4311, '2020-11-08', 'AW', 'Aruba', 'AMRO', '0', '4564', '0', '39');
INSERT INTO public.who_global_data_import VALUES (4312, '2020-11-09', 'AW', 'Aruba', 'AMRO', '0', '4564', '0', '39');
INSERT INTO public.who_global_data_import VALUES (4313, '2020-11-10', 'AW', 'Aruba', 'AMRO', '36', '4600', '1', '40');
INSERT INTO public.who_global_data_import VALUES (4314, '2020-11-11', 'AW', 'Aruba', 'AMRO', '6', '4606', '1', '41');
INSERT INTO public.who_global_data_import VALUES (4315, '2020-11-12', 'AW', 'Aruba', 'AMRO', '16', '4622', '1', '42');
INSERT INTO public.who_global_data_import VALUES (4316, '2020-11-13', 'AW', 'Aruba', 'AMRO', '9', '4631', '1', '43');
INSERT INTO public.who_global_data_import VALUES (4317, '2020-11-14', 'AW', 'Aruba', 'AMRO', '8', '4639', '0', '43');
INSERT INTO public.who_global_data_import VALUES (4318, '2020-11-15', 'AW', 'Aruba', 'AMRO', '0', '4639', '0', '43');
INSERT INTO public.who_global_data_import VALUES (4319, '2020-11-16', 'AW', 'Aruba', 'AMRO', '0', '4639', '0', '43');
INSERT INTO public.who_global_data_import VALUES (4320, '2020-11-17', 'AW', 'Aruba', 'AMRO', '23', '4662', '1', '44');
INSERT INTO public.who_global_data_import VALUES (4321, '2020-11-18', 'AW', 'Aruba', 'AMRO', '6', '4668', '0', '44');
INSERT INTO public.who_global_data_import VALUES (4322, '2020-11-19', 'AW', 'Aruba', 'AMRO', '8', '4676', '0', '44');
INSERT INTO public.who_global_data_import VALUES (4323, '2020-11-20', 'AW', 'Aruba', 'AMRO', '9', '4685', '1', '45');
INSERT INTO public.who_global_data_import VALUES (4324, '2020-11-21', 'AW', 'Aruba', 'AMRO', '8', '4693', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4325, '2020-11-22', 'AW', 'Aruba', 'AMRO', '0', '4693', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4326, '2020-11-23', 'AW', 'Aruba', 'AMRO', '0', '4693', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4327, '2020-11-24', 'AW', 'Aruba', 'AMRO', '38', '4731', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4328, '2020-11-25', 'AW', 'Aruba', 'AMRO', '6', '4737', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4329, '2020-11-26', 'AW', 'Aruba', 'AMRO', '14', '4751', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4330, '2020-11-27', 'AW', 'Aruba', 'AMRO', '27', '4778', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4331, '2020-11-28', 'AW', 'Aruba', 'AMRO', '13', '4791', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4332, '2020-11-29', 'AW', 'Aruba', 'AMRO', '0', '4791', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4333, '2020-11-30', 'AW', 'Aruba', 'AMRO', '0', '4791', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4334, '2020-12-01', 'AW', 'Aruba', 'AMRO', '47', '4838', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4335, '2020-12-02', 'AW', 'Aruba', 'AMRO', '7', '4845', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4336, '2020-12-03', 'AW', 'Aruba', 'AMRO', '27', '4872', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4337, '2020-12-04', 'AW', 'Aruba', 'AMRO', '30', '4902', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4338, '2020-12-05', 'AW', 'Aruba', 'AMRO', '21', '4923', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4339, '2020-12-06', 'AW', 'Aruba', 'AMRO', '0', '4923', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4340, '2020-12-07', 'AW', 'Aruba', 'AMRO', '0', '4923', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4341, '2020-12-08', 'AW', 'Aruba', 'AMRO', '42', '4965', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4342, '2020-12-09', 'AW', 'Aruba', 'AMRO', '1', '4966', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4343, '2020-12-10', 'AW', 'Aruba', 'AMRO', '18', '4984', '0', '45');
INSERT INTO public.who_global_data_import VALUES (4344, '2020-12-11', 'AW', 'Aruba', 'AMRO', '12', '4996', '1', '46');
INSERT INTO public.who_global_data_import VALUES (4345, '2020-12-12', 'AW', 'Aruba', 'AMRO', '15', '5011', '0', '46');
INSERT INTO public.who_global_data_import VALUES (4346, '2020-12-13', 'AW', 'Aruba', 'AMRO', '0', '5011', '0', '46');
INSERT INTO public.who_global_data_import VALUES (4347, '2020-12-14', 'AW', 'Aruba', 'AMRO', '0', '5011', '0', '46');
INSERT INTO public.who_global_data_import VALUES (4348, '2020-12-15', 'AW', 'Aruba', 'AMRO', '38', '5049', '0', '46');
INSERT INTO public.who_global_data_import VALUES (4349, '2020-12-16', 'AW', 'Aruba', 'AMRO', '7', '5056', '0', '46');
INSERT INTO public.who_global_data_import VALUES (4350, '2020-12-17', 'AW', 'Aruba', 'AMRO', '23', '5079', '0', '46');
INSERT INTO public.who_global_data_import VALUES (4351, '2020-12-18', 'AW', 'Aruba', 'AMRO', '27', '5106', '1', '47');
INSERT INTO public.who_global_data_import VALUES (4352, '2020-12-19', 'AW', 'Aruba', 'AMRO', '18', '5124', '0', '47');
INSERT INTO public.who_global_data_import VALUES (4353, '2020-12-20', 'AW', 'Aruba', 'AMRO', '0', '5124', '0', '47');
INSERT INTO public.who_global_data_import VALUES (4354, '2020-12-21', 'AW', 'Aruba', 'AMRO', '0', '5124', '0', '47');
INSERT INTO public.who_global_data_import VALUES (4355, '2020-12-22', 'AW', 'Aruba', 'AMRO', '39', '5163', '0', '47');
INSERT INTO public.who_global_data_import VALUES (4356, '2020-12-23', 'AW', 'Aruba', 'AMRO', '13', '5176', '0', '47');
INSERT INTO public.who_global_data_import VALUES (4357, '2020-12-24', 'AW', 'Aruba', 'AMRO', '23', '5199', '0', '47');
INSERT INTO public.who_global_data_import VALUES (4358, '2020-12-25', 'AW', 'Aruba', 'AMRO', '29', '5228', '0', '47');
INSERT INTO public.who_global_data_import VALUES (4359, '2020-12-26', 'AW', 'Aruba', 'AMRO', '0', '5228', '0', '47');
INSERT INTO public.who_global_data_import VALUES (4360, '2020-12-27', 'AW', 'Aruba', 'AMRO', '0', '5228', '0', '47');
INSERT INTO public.who_global_data_import VALUES (4361, '2020-12-28', 'AW', 'Aruba', 'AMRO', '0', '5228', '0', '47');
INSERT INTO public.who_global_data_import VALUES (4362, '2020-12-29', 'AW', 'Aruba', 'AMRO', '77', '5305', '2', '49');
INSERT INTO public.who_global_data_import VALUES (4363, '2020-12-30', 'AW', 'Aruba', 'AMRO', '18', '5323', '0', '49');
INSERT INTO public.who_global_data_import VALUES (4364, '2020-12-31', 'AW', 'Aruba', 'AMRO', '50', '5373', '0', '49');
INSERT INTO public.who_global_data_import VALUES (4365, '2021-01-01', 'AW', 'Aruba', 'AMRO', '69', '5442', '0', '49');
INSERT INTO public.who_global_data_import VALUES (4366, '2021-01-02', 'AW', 'Aruba', 'AMRO', '0', '5442', '0', '49');
INSERT INTO public.who_global_data_import VALUES (4367, '2021-01-03', 'AW', 'Aruba', 'AMRO', '0', '5442', '0', '49');
INSERT INTO public.who_global_data_import VALUES (4368, '2021-01-04', 'AW', 'Aruba', 'AMRO', '0', '5442', '0', '49');
INSERT INTO public.who_global_data_import VALUES (4369, '2021-01-05', 'AW', 'Aruba', 'AMRO', '122', '5564', '0', '49');
INSERT INTO public.who_global_data_import VALUES (4370, '2021-01-06', 'AW', 'Aruba', 'AMRO', '42', '5606', '0', '49');
INSERT INTO public.who_global_data_import VALUES (4371, '2021-01-07', 'AW', 'Aruba', 'AMRO', '110', '5716', '1', '50');
INSERT INTO public.who_global_data_import VALUES (4372, '2021-01-08', 'AW', 'Aruba', 'AMRO', '95', '5811', '0', '50');
INSERT INTO public.who_global_data_import VALUES (4373, '2021-01-09', 'AW', 'Aruba', 'AMRO', '72', '5883', '0', '50');
INSERT INTO public.who_global_data_import VALUES (4374, '2021-01-10', 'AW', 'Aruba', 'AMRO', '0', '5883', '0', '50');
INSERT INTO public.who_global_data_import VALUES (4375, '2021-01-11', 'AW', 'Aruba', 'AMRO', '0', '5883', '0', '50');
INSERT INTO public.who_global_data_import VALUES (4376, '2021-01-12', 'AW', 'Aruba', 'AMRO', '159', '6042', '1', '51');
INSERT INTO public.who_global_data_import VALUES (4377, '2021-01-13', 'AW', 'Aruba', 'AMRO', '26', '6068', '1', '52');
INSERT INTO public.who_global_data_import VALUES (4378, '2021-01-14', 'AW', 'Aruba', 'AMRO', '86', '6154', '0', '52');
INSERT INTO public.who_global_data_import VALUES (4379, '2021-01-15', 'AW', 'Aruba', 'AMRO', '74', '6228', '0', '52');
INSERT INTO public.who_global_data_import VALUES (4380, '2021-01-16', 'AW', 'Aruba', 'AMRO', '68', '6296', '0', '52');
INSERT INTO public.who_global_data_import VALUES (4381, '2021-01-17', 'AW', 'Aruba', 'AMRO', '0', '6296', '0', '52');
INSERT INTO public.who_global_data_import VALUES (4382, '2021-01-18', 'AW', 'Aruba', 'AMRO', '0', '6296', '0', '52');
INSERT INTO public.who_global_data_import VALUES (4383, '2021-01-19', 'AW', 'Aruba', 'AMRO', '139', '6435', '0', '52');
INSERT INTO public.who_global_data_import VALUES (4384, '2021-01-20', 'AW', 'Aruba', 'AMRO', '16', '6451', '0', '52');
INSERT INTO public.who_global_data_import VALUES (4385, '2021-01-21', 'AW', 'Aruba', 'AMRO', '72', '6523', '0', '52');
INSERT INTO public.who_global_data_import VALUES (4386, '2021-01-22', 'AW', 'Aruba', 'AMRO', '39', '6562', '0', '52');
INSERT INTO public.who_global_data_import VALUES (4387, '2021-01-23', 'AW', 'Aruba', 'AMRO', '61', '6623', '0', '52');
INSERT INTO public.who_global_data_import VALUES (4388, '2021-01-24', 'AW', 'Aruba', 'AMRO', '0', '6623', '0', '52');
INSERT INTO public.who_global_data_import VALUES (4389, '2021-01-25', 'AW', 'Aruba', 'AMRO', '0', '6623', '0', '52');
INSERT INTO public.who_global_data_import VALUES (4390, '2021-01-26', 'AW', 'Aruba', 'AMRO', '100', '6723', '4', '56');
INSERT INTO public.who_global_data_import VALUES (4391, '2021-01-27', 'AW', 'Aruba', 'AMRO', '19', '6742', '1', '57');
INSERT INTO public.who_global_data_import VALUES (4392, '2021-01-28', 'AW', 'Aruba', 'AMRO', '26', '6768', '0', '57');
INSERT INTO public.who_global_data_import VALUES (4393, '2021-01-29', 'AW', 'Aruba', 'AMRO', '41', '6809', '1', '58');
INSERT INTO public.who_global_data_import VALUES (4394, '2021-01-30', 'AW', 'Aruba', 'AMRO', '49', '6858', '0', '58');
INSERT INTO public.who_global_data_import VALUES (4395, '2021-01-31', 'AW', 'Aruba', 'AMRO', '0', '6858', '0', '58');
INSERT INTO public.who_global_data_import VALUES (4396, '2021-02-01', 'AW', 'Aruba', 'AMRO', '0', '6858', '0', '58');
INSERT INTO public.who_global_data_import VALUES (4397, '2021-02-02', 'AW', 'Aruba', 'AMRO', '108', '6966', '1', '59');
INSERT INTO public.who_global_data_import VALUES (4398, '2021-02-03', 'AW', 'Aruba', 'AMRO', '20', '6986', '0', '59');
INSERT INTO public.who_global_data_import VALUES (4399, '2021-02-04', 'AW', 'Aruba', 'AMRO', '42', '7028', '0', '59');
INSERT INTO public.who_global_data_import VALUES (4400, '2021-02-05', 'AW', 'Aruba', 'AMRO', '55', '7083', '2', '61');
INSERT INTO public.who_global_data_import VALUES (4401, '2020-01-03', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4402, '2020-01-04', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4403, '2020-01-05', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4404, '2020-01-06', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4405, '2020-01-07', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4406, '2020-01-08', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4407, '2020-01-09', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4408, '2020-01-10', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4409, '2020-01-11', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4410, '2020-01-12', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4411, '2020-01-13', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4412, '2020-01-14', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4413, '2020-01-15', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4414, '2020-01-16', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4415, '2020-01-17', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4416, '2020-01-18', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4417, '2020-01-19', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4418, '2020-01-20', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4419, '2020-01-21', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4420, '2020-01-22', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4421, '2020-01-23', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4422, '2020-01-24', 'AU', 'Australia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4423, '2020-01-25', 'AU', 'Australia', 'WPRO', '7', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4424, '2020-01-26', 'AU', 'Australia', 'WPRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4425, '2020-01-27', 'AU', 'Australia', 'WPRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4426, '2020-01-28', 'AU', 'Australia', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4427, '2020-01-29', 'AU', 'Australia', 'WPRO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4428, '2020-01-30', 'AU', 'Australia', 'WPRO', '2', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4429, '2020-01-31', 'AU', 'Australia', 'WPRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4430, '2020-02-01', 'AU', 'Australia', 'WPRO', '3', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4431, '2020-02-02', 'AU', 'Australia', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4432, '2020-02-03', 'AU', 'Australia', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4433, '2020-02-04', 'AU', 'Australia', 'WPRO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4434, '2020-02-05', 'AU', 'Australia', 'WPRO', '1', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4435, '2020-02-06', 'AU', 'Australia', 'WPRO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4436, '2020-02-07', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4437, '2020-02-08', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4438, '2020-02-09', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4439, '2020-02-10', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4440, '2020-02-11', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4441, '2020-02-12', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4442, '2020-02-13', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4443, '2020-02-14', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4444, '2020-02-15', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4445, '2020-02-16', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4446, '2020-02-17', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4447, '2020-02-18', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4448, '2020-02-19', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4449, '2020-02-20', 'AU', 'Australia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4450, '2020-02-21', 'AU', 'Australia', 'WPRO', '2', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4451, '2020-02-22', 'AU', 'Australia', 'WPRO', '4', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4452, '2020-02-23', 'AU', 'Australia', 'WPRO', '1', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4453, '2020-02-24', 'AU', 'Australia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4454, '2020-02-25', 'AU', 'Australia', 'WPRO', '1', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4455, '2020-02-26', 'AU', 'Australia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4456, '2020-02-27', 'AU', 'Australia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4457, '2020-02-28', 'AU', 'Australia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4458, '2020-02-29', 'AU', 'Australia', 'WPRO', '2', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4459, '2020-03-01', 'AU', 'Australia', 'WPRO', '2', '31', '1', '1');
INSERT INTO public.who_global_data_import VALUES (4460, '2020-03-02', 'AU', 'Australia', 'WPRO', '6', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (4461, '2020-03-03', 'AU', 'Australia', 'WPRO', '0', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (4462, '2020-03-04', 'AU', 'Australia', 'WPRO', '0', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (4463, '2020-03-05', 'AU', 'Australia', 'WPRO', '10', '47', '0', '1');
INSERT INTO public.who_global_data_import VALUES (4464, '2020-03-06', 'AU', 'Australia', 'WPRO', '19', '66', '1', '2');
INSERT INTO public.who_global_data_import VALUES (4465, '2020-03-07', 'AU', 'Australia', 'WPRO', '8', '74', '0', '2');
INSERT INTO public.who_global_data_import VALUES (4466, '2020-03-08', 'AU', 'Australia', 'WPRO', '7', '81', '1', '3');
INSERT INTO public.who_global_data_import VALUES (4467, '2020-03-09', 'AU', 'Australia', 'WPRO', '15', '96', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4468, '2020-03-10', 'AU', 'Australia', 'WPRO', '0', '96', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4469, '2020-03-11', 'AU', 'Australia', 'WPRO', '30', '126', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4470, '2020-03-12', 'AU', 'Australia', 'WPRO', '18', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4471, '2020-03-13', 'AU', 'Australia', 'WPRO', '49', '193', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4472, '2020-03-14', 'AU', 'Australia', 'WPRO', '8', '201', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4473, '2020-03-15', 'AU', 'Australia', 'WPRO', '101', '302', '2', '5');
INSERT INTO public.who_global_data_import VALUES (4474, '2020-03-16', 'AU', 'Australia', 'WPRO', '38', '340', '0', '5');
INSERT INTO public.who_global_data_import VALUES (4475, '2020-03-17', 'AU', 'Australia', 'WPRO', '78', '418', '0', '5');
INSERT INTO public.who_global_data_import VALUES (4476, '2020-03-18', 'AU', 'Australia', 'WPRO', '96', '514', '1', '6');
INSERT INTO public.who_global_data_import VALUES (4477, '2020-03-19', 'AU', 'Australia', 'WPRO', '195', '709', '0', '6');
INSERT INTO public.who_global_data_import VALUES (4478, '2020-03-20', 'AU', 'Australia', 'WPRO', '164', '873', '1', '7');
INSERT INTO public.who_global_data_import VALUES (4479, '2020-03-21', 'AU', 'Australia', 'WPRO', '208', '1081', '0', '7');
INSERT INTO public.who_global_data_import VALUES (4480, '2020-03-22', 'AU', 'Australia', 'WPRO', '17', '1098', '0', '7');
INSERT INTO public.who_global_data_import VALUES (4481, '2020-03-23', 'AU', 'Australia', 'WPRO', '611', '1709', '0', '7');
INSERT INTO public.who_global_data_import VALUES (4482, '2020-03-24', 'AU', 'Australia', 'WPRO', '427', '2136', '1', '8');
INSERT INTO public.who_global_data_import VALUES (4483, '2020-03-25', 'AU', 'Australia', 'WPRO', '287', '2423', '0', '8');
INSERT INTO public.who_global_data_import VALUES (4484, '2020-03-26', 'AU', 'Australia', 'WPRO', '376', '2799', '3', '11');
INSERT INTO public.who_global_data_import VALUES (4485, '2020-03-27', 'AU', 'Australia', 'WPRO', '186', '2985', '2', '13');
INSERT INTO public.who_global_data_import VALUES (4486, '2020-03-28', 'AU', 'Australia', 'WPRO', '650', '3635', '1', '14');
INSERT INTO public.who_global_data_import VALUES (4487, '2020-03-29', 'AU', 'Australia', 'WPRO', '331', '3966', '2', '16');
INSERT INTO public.who_global_data_import VALUES (4488, '2020-03-30', 'AU', 'Australia', 'WPRO', '279', '4245', '2', '18');
INSERT INTO public.who_global_data_import VALUES (4489, '2020-03-31', 'AU', 'Australia', 'WPRO', '312', '4557', '1', '19');
INSERT INTO public.who_global_data_import VALUES (4490, '2020-04-01', 'AU', 'Australia', 'WPRO', '303', '4860', '1', '20');
INSERT INTO public.who_global_data_import VALUES (4491, '2020-04-02', 'AU', 'Australia', 'WPRO', '116', '4976', '1', '21');
INSERT INTO public.who_global_data_import VALUES (4492, '2020-04-03', 'AU', 'Australia', 'WPRO', '374', '5350', '5', '26');
INSERT INTO public.who_global_data_import VALUES (4493, '2020-04-04', 'AU', 'Australia', 'WPRO', '104', '5454', '2', '28');
INSERT INTO public.who_global_data_import VALUES (4494, '2020-04-05', 'AU', 'Australia', 'WPRO', '181', '5635', '6', '34');
INSERT INTO public.who_global_data_import VALUES (4495, '2020-04-06', 'AU', 'Australia', 'WPRO', '160', '5795', '5', '39');
INSERT INTO public.who_global_data_import VALUES (4496, '2020-04-07', 'AU', 'Australia', 'WPRO', '49', '5844', '3', '42');
INSERT INTO public.who_global_data_import VALUES (4497, '2020-04-08', 'AU', 'Australia', 'WPRO', '112', '5956', '3', '45');
INSERT INTO public.who_global_data_import VALUES (4498, '2020-04-09', 'AU', 'Australia', 'WPRO', '96', '6052', '5', '50');
INSERT INTO public.who_global_data_import VALUES (4499, '2020-04-10', 'AU', 'Australia', 'WPRO', '100', '6152', '2', '52');
INSERT INTO public.who_global_data_import VALUES (4500, '2020-04-11', 'AU', 'Australia', 'WPRO', '137', '6289', '4', '56');
INSERT INTO public.who_global_data_import VALUES (4501, '2020-04-12', 'AU', 'Australia', 'WPRO', '24', '6313', '3', '59');
INSERT INTO public.who_global_data_import VALUES (4502, '2020-04-13', 'AU', 'Australia', 'WPRO', '9', '6322', '2', '61');
INSERT INTO public.who_global_data_import VALUES (4503, '2020-04-14', 'AU', 'Australia', 'WPRO', '44', '6366', '0', '61');
INSERT INTO public.who_global_data_import VALUES (4504, '2020-04-15', 'AU', 'Australia', 'WPRO', '50', '6416', '0', '61');
INSERT INTO public.who_global_data_import VALUES (4505, '2020-04-16', 'AU', 'Australia', 'WPRO', '42', '6458', '2', '63');
INSERT INTO public.who_global_data_import VALUES (4506, '2020-04-17', 'AU', 'Australia', 'WPRO', '10', '6468', '0', '63');
INSERT INTO public.who_global_data_import VALUES (4507, '2020-04-18', 'AU', 'Australia', 'WPRO', '65', '6533', '4', '67');
INSERT INTO public.who_global_data_import VALUES (4508, '2020-04-19', 'AU', 'Australia', 'WPRO', '73', '6606', '3', '70');
INSERT INTO public.who_global_data_import VALUES (4509, '2020-04-20', 'AU', 'Australia', 'WPRO', '6', '6612', '0', '70');
INSERT INTO public.who_global_data_import VALUES (4510, '2020-04-21', 'AU', 'Australia', 'WPRO', '13', '6625', '1', '71');
INSERT INTO public.who_global_data_import VALUES (4511, '2020-04-22', 'AU', 'Australia', 'WPRO', '22', '6647', '3', '74');
INSERT INTO public.who_global_data_import VALUES (4512, '2020-04-23', 'AU', 'Australia', 'WPRO', '14', '6661', '1', '75');
INSERT INTO public.who_global_data_import VALUES (4513, '2020-04-24', 'AU', 'Australia', 'WPRO', '6', '6667', '1', '76');
INSERT INTO public.who_global_data_import VALUES (4514, '2020-04-25', 'AU', 'Australia', 'WPRO', '20', '6687', '3', '79');
INSERT INTO public.who_global_data_import VALUES (4515, '2020-04-26', 'AU', 'Australia', 'WPRO', '16', '6703', '2', '81');
INSERT INTO public.who_global_data_import VALUES (4516, '2020-04-27', 'AU', 'Australia', 'WPRO', '10', '6713', '2', '83');
INSERT INTO public.who_global_data_import VALUES (4517, '2020-04-28', 'AU', 'Australia', 'WPRO', '12', '6725', '1', '84');
INSERT INTO public.who_global_data_import VALUES (4518, '2020-04-29', 'AU', 'Australia', 'WPRO', '13', '6738', '4', '88');
INSERT INTO public.who_global_data_import VALUES (4519, '2020-04-30', 'AU', 'Australia', 'WPRO', '8', '6746', '2', '90');
INSERT INTO public.who_global_data_import VALUES (4520, '2020-05-01', 'AU', 'Australia', 'WPRO', '16', '6762', '2', '92');
INSERT INTO public.who_global_data_import VALUES (4521, '2020-05-02', 'AU', 'Australia', 'WPRO', '5', '6767', '1', '93');
INSERT INTO public.who_global_data_import VALUES (4522, '2020-05-03', 'AU', 'Australia', 'WPRO', '16', '6783', '0', '93');
INSERT INTO public.who_global_data_import VALUES (4523, '2020-05-04', 'AU', 'Australia', 'WPRO', '18', '6801', '2', '95');
INSERT INTO public.who_global_data_import VALUES (4524, '2020-05-05', 'AU', 'Australia', 'WPRO', '24', '6825', '0', '95');
INSERT INTO public.who_global_data_import VALUES (4525, '2020-05-06', 'AU', 'Australia', 'WPRO', '24', '6849', '1', '96');
INSERT INTO public.who_global_data_import VALUES (4526, '2020-05-07', 'AU', 'Australia', 'WPRO', '26', '6875', '1', '97');
INSERT INTO public.who_global_data_import VALUES (4527, '2020-05-08', 'AU', 'Australia', 'WPRO', '21', '6896', '0', '97');
INSERT INTO public.who_global_data_import VALUES (4528, '2020-05-09', 'AU', 'Australia', 'WPRO', '18', '6914', '0', '97');
INSERT INTO public.who_global_data_import VALUES (4529, '2020-05-10', 'AU', 'Australia', 'WPRO', '15', '6929', '0', '97');
INSERT INTO public.who_global_data_import VALUES (4530, '2020-05-11', 'AU', 'Australia', 'WPRO', '12', '6941', '0', '97');
INSERT INTO public.who_global_data_import VALUES (4531, '2020-05-12', 'AU', 'Australia', 'WPRO', '7', '6948', '0', '97');
INSERT INTO public.who_global_data_import VALUES (4532, '2020-05-13', 'AU', 'Australia', 'WPRO', '16', '6964', '0', '97');
INSERT INTO public.who_global_data_import VALUES (4533, '2020-05-14', 'AU', 'Australia', 'WPRO', '11', '6975', '1', '98');
INSERT INTO public.who_global_data_import VALUES (4534, '2020-05-15', 'AU', 'Australia', 'WPRO', '14', '6989', '0', '98');
INSERT INTO public.who_global_data_import VALUES (4535, '2020-05-16', 'AU', 'Australia', 'WPRO', '30', '7019', '0', '98');
INSERT INTO public.who_global_data_import VALUES (4536, '2020-05-17', 'AU', 'Australia', 'WPRO', '17', '7036', '0', '98');
INSERT INTO public.who_global_data_import VALUES (4537, '2020-05-18', 'AU', 'Australia', 'WPRO', '9', '7045', '0', '98');
INSERT INTO public.who_global_data_import VALUES (4538, '2020-05-19', 'AU', 'Australia', 'WPRO', '15', '7060', '1', '99');
INSERT INTO public.who_global_data_import VALUES (4539, '2020-05-20', 'AU', 'Australia', 'WPRO', '8', '7068', '0', '99');
INSERT INTO public.who_global_data_import VALUES (4540, '2020-05-21', 'AU', 'Australia', 'WPRO', '11', '7079', '1', '100');
INSERT INTO public.who_global_data_import VALUES (4541, '2020-05-22', 'AU', 'Australia', 'WPRO', '2', '7081', '0', '100');
INSERT INTO public.who_global_data_import VALUES (4542, '2020-05-23', 'AU', 'Australia', 'WPRO', '14', '7095', '1', '101');
INSERT INTO public.who_global_data_import VALUES (4543, '2020-05-24', 'AU', 'Australia', 'WPRO', '11', '7106', '1', '102');
INSERT INTO public.who_global_data_import VALUES (4544, '2020-05-25', 'AU', 'Australia', 'WPRO', '3', '7109', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4545, '2020-05-26', 'AU', 'Australia', 'WPRO', '9', '7118', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4546, '2020-05-27', 'AU', 'Australia', 'WPRO', '15', '7133', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4547, '2020-05-28', 'AU', 'Australia', 'WPRO', '6', '7139', '1', '103');
INSERT INTO public.who_global_data_import VALUES (4548, '2020-05-29', 'AU', 'Australia', 'WPRO', '11', '7150', '0', '103');
INSERT INTO public.who_global_data_import VALUES (4549, '2020-05-30', 'AU', 'Australia', 'WPRO', '23', '7173', '0', '103');
INSERT INTO public.who_global_data_import VALUES (4550, '2020-05-31', 'AU', 'Australia', 'WPRO', '12', '7185', '0', '103');
INSERT INTO public.who_global_data_import VALUES (4551, '2020-06-01', 'AU', 'Australia', 'WPRO', '10', '7195', '0', '103');
INSERT INTO public.who_global_data_import VALUES (4552, '2020-06-02', 'AU', 'Australia', 'WPRO', '9', '7204', '0', '103');
INSERT INTO public.who_global_data_import VALUES (4553, '2020-06-03', 'AU', 'Australia', 'WPRO', '17', '7221', '0', '103');
INSERT INTO public.who_global_data_import VALUES (4554, '2020-06-04', 'AU', 'Australia', 'WPRO', '8', '7229', '-1', '102');
INSERT INTO public.who_global_data_import VALUES (4555, '2020-06-05', 'AU', 'Australia', 'WPRO', '11', '7240', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4556, '2020-06-06', 'AU', 'Australia', 'WPRO', '11', '7251', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4557, '2020-06-07', 'AU', 'Australia', 'WPRO', '4', '7255', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4558, '2020-06-08', 'AU', 'Australia', 'WPRO', '5', '7260', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4559, '2020-06-09', 'AU', 'Australia', 'WPRO', '5', '7265', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4560, '2020-06-10', 'AU', 'Australia', 'WPRO', '2', '7267', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4561, '2020-06-11', 'AU', 'Australia', 'WPRO', '0', '7267', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4562, '2020-06-12', 'AU', 'Australia', 'WPRO', '18', '7285', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4563, '2020-06-13', 'AU', 'Australia', 'WPRO', '5', '7290', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4564, '2020-06-14', 'AU', 'Australia', 'WPRO', '12', '7302', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4565, '2020-06-15', 'AU', 'Australia', 'WPRO', '18', '7320', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4566, '2020-06-16', 'AU', 'Australia', 'WPRO', '15', '7335', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4567, '2020-06-17', 'AU', 'Australia', 'WPRO', '12', '7347', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4568, '2020-06-18', 'AU', 'Australia', 'WPRO', '23', '7370', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4569, '2020-06-19', 'AU', 'Australia', 'WPRO', '21', '7391', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4570, '2020-06-20', 'AU', 'Australia', 'WPRO', '18', '7409', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4571, '2020-06-21', 'AU', 'Australia', 'WPRO', '27', '7436', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4572, '2020-06-22', 'AU', 'Australia', 'WPRO', '25', '7461', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4573, '2020-06-23', 'AU', 'Australia', 'WPRO', '13', '7474', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4574, '2020-06-24', 'AU', 'Australia', 'WPRO', '18', '7492', '0', '102');
INSERT INTO public.who_global_data_import VALUES (4575, '2020-06-25', 'AU', 'Australia', 'WPRO', '29', '7521', '1', '103');
INSERT INTO public.who_global_data_import VALUES (4576, '2020-06-26', 'AU', 'Australia', 'WPRO', '37', '7558', '1', '104');
INSERT INTO public.who_global_data_import VALUES (4577, '2020-06-27', 'AU', 'Australia', 'WPRO', '37', '7595', '0', '104');
INSERT INTO public.who_global_data_import VALUES (4578, '2020-06-28', 'AU', 'Australia', 'WPRO', '46', '7641', '0', '104');
INSERT INTO public.who_global_data_import VALUES (4579, '2020-06-29', 'AU', 'Australia', 'WPRO', '45', '7686', '0', '104');
INSERT INTO public.who_global_data_import VALUES (4580, '2020-06-30', 'AU', 'Australia', 'WPRO', '81', '7767', '0', '104');
INSERT INTO public.who_global_data_import VALUES (4581, '2020-07-01', 'AU', 'Australia', 'WPRO', '67', '7834', '0', '104');
INSERT INTO public.who_global_data_import VALUES (4582, '2020-07-02', 'AU', 'Australia', 'WPRO', '86', '7920', '0', '104');
INSERT INTO public.who_global_data_import VALUES (4583, '2020-07-03', 'AU', 'Australia', 'WPRO', '81', '8001', '0', '104');
INSERT INTO public.who_global_data_import VALUES (4584, '2020-07-04', 'AU', 'Australia', 'WPRO', '254', '8255', '0', '104');
INSERT INTO public.who_global_data_import VALUES (4585, '2020-07-05', 'AU', 'Australia', 'WPRO', '107', '8362', '0', '104');
INSERT INTO public.who_global_data_import VALUES (4586, '2020-07-06', 'AU', 'Australia', 'WPRO', '87', '8449', '0', '104');
INSERT INTO public.who_global_data_import VALUES (4587, '2020-07-07', 'AU', 'Australia', 'WPRO', '137', '8586', '2', '106');
INSERT INTO public.who_global_data_import VALUES (4588, '2020-07-08', 'AU', 'Australia', 'WPRO', '169', '8755', '0', '106');
INSERT INTO public.who_global_data_import VALUES (4589, '2020-07-09', 'AU', 'Australia', 'WPRO', '131', '8886', '0', '106');
INSERT INTO public.who_global_data_import VALUES (4590, '2020-07-10', 'AU', 'Australia', 'WPRO', '173', '9059', '0', '106');
INSERT INTO public.who_global_data_import VALUES (4591, '2020-07-11', 'AU', 'Australia', 'WPRO', '300', '9359', '0', '106');
INSERT INTO public.who_global_data_import VALUES (4592, '2020-07-12', 'AU', 'Australia', 'WPRO', '194', '9553', '1', '107');
INSERT INTO public.who_global_data_import VALUES (4593, '2020-07-13', 'AU', 'Australia', 'WPRO', '244', '9797', '1', '108');
INSERT INTO public.who_global_data_import VALUES (4594, '2020-07-14', 'AU', 'Australia', 'WPRO', '183', '9980', '0', '108');
INSERT INTO public.who_global_data_import VALUES (4595, '2020-07-15', 'AU', 'Australia', 'WPRO', '271', '10251', '0', '108');
INSERT INTO public.who_global_data_import VALUES (4596, '2020-07-16', 'AU', 'Australia', 'WPRO', '244', '10495', '3', '111');
INSERT INTO public.who_global_data_import VALUES (4597, '2020-07-17', 'AU', 'Australia', 'WPRO', '315', '10810', '2', '113');
INSERT INTO public.who_global_data_import VALUES (4598, '2020-07-18', 'AU', 'Australia', 'WPRO', '425', '11235', '3', '116');
INSERT INTO public.who_global_data_import VALUES (4599, '2020-07-19', 'AU', 'Australia', 'WPRO', '206', '11441', '2', '118');
INSERT INTO public.who_global_data_import VALUES (4600, '2020-07-20', 'AU', 'Australia', 'WPRO', '361', '11802', '4', '122');
INSERT INTO public.who_global_data_import VALUES (4601, '2020-07-21', 'AU', 'Australia', 'WPRO', '267', '12069', '1', '123');
INSERT INTO public.who_global_data_import VALUES (4602, '2020-07-22', 'AU', 'Australia', 'WPRO', '359', '12428', '3', '126');
INSERT INTO public.who_global_data_import VALUES (4603, '2020-07-23', 'AU', 'Australia', 'WPRO', '468', '12896', '2', '128');
INSERT INTO public.who_global_data_import VALUES (4604, '2020-07-24', 'AU', 'Australia', 'WPRO', '410', '13306', '5', '133');
INSERT INTO public.who_global_data_import VALUES (4605, '2020-07-25', 'AU', 'Australia', 'WPRO', '289', '13595', '6', '139');
INSERT INTO public.who_global_data_import VALUES (4606, '2020-07-26', 'AU', 'Australia', 'WPRO', '355', '13950', '6', '145');
INSERT INTO public.who_global_data_import VALUES (4607, '2020-07-27', 'AU', 'Australia', 'WPRO', '453', '14403', '10', '155');
INSERT INTO public.who_global_data_import VALUES (4608, '2020-07-28', 'AU', 'Australia', 'WPRO', '532', '14935', '6', '161');
INSERT INTO public.who_global_data_import VALUES (4609, '2020-07-29', 'AU', 'Australia', 'WPRO', '369', '15304', '6', '167');
INSERT INTO public.who_global_data_import VALUES (4610, '2020-07-30', 'AU', 'Australia', 'WPRO', '278', '15582', '9', '176');
INSERT INTO public.who_global_data_import VALUES (4611, '2020-07-31', 'AU', 'Australia', 'WPRO', '721', '16303', '13', '189');
INSERT INTO public.who_global_data_import VALUES (4612, '2020-08-01', 'AU', 'Australia', 'WPRO', '602', '16905', '7', '196');
INSERT INTO public.who_global_data_import VALUES (4613, '2020-08-02', 'AU', 'Australia', 'WPRO', '377', '17282', '4', '200');
INSERT INTO public.who_global_data_import VALUES (4614, '2020-08-03', 'AU', 'Australia', 'WPRO', '641', '17923', '8', '208');
INSERT INTO public.who_global_data_import VALUES (4615, '2020-08-04', 'AU', 'Australia', 'WPRO', '395', '18318', '13', '221');
INSERT INTO public.who_global_data_import VALUES (4616, '2020-08-05', 'AU', 'Australia', 'WPRO', '411', '18729', '11', '232');
INSERT INTO public.who_global_data_import VALUES (4617, '2020-08-06', 'AU', 'Australia', 'WPRO', '715', '19444', '15', '247');
INSERT INTO public.who_global_data_import VALUES (4618, '2020-08-07', 'AU', 'Australia', 'WPRO', '418', '19862', '8', '255');
INSERT INTO public.who_global_data_import VALUES (4619, '2020-08-08', 'AU', 'Australia', 'WPRO', '410', '20272', '11', '266');
INSERT INTO public.who_global_data_import VALUES (4620, '2020-08-09', 'AU', 'Australia', 'WPRO', '426', '20698', '12', '278');
INSERT INTO public.who_global_data_import VALUES (4621, '2020-08-10', 'AU', 'Australia', 'WPRO', '386', '21084', '17', '295');
INSERT INTO public.who_global_data_import VALUES (4622, '2020-08-11', 'AU', 'Australia', 'WPRO', '313', '21397', '18', '313');
INSERT INTO public.who_global_data_import VALUES (4623, '2020-08-12', 'AU', 'Australia', 'WPRO', '316', '21713', '18', '331');
INSERT INTO public.who_global_data_import VALUES (4624, '2020-08-13', 'AU', 'Australia', 'WPRO', '414', '22127', '21', '352');
INSERT INTO public.who_global_data_import VALUES (4625, '2020-08-14', 'AU', 'Australia', 'WPRO', '231', '22358', '9', '361');
INSERT INTO public.who_global_data_import VALUES (4626, '2020-08-15', 'AU', 'Australia', 'WPRO', '385', '22743', '14', '375');
INSERT INTO public.who_global_data_import VALUES (4627, '2020-08-16', 'AU', 'Australia', 'WPRO', '292', '23035', '4', '379');
INSERT INTO public.who_global_data_import VALUES (4628, '2020-08-17', 'AU', 'Australia', 'WPRO', '253', '23288', '17', '396');
INSERT INTO public.who_global_data_import VALUES (4629, '2020-08-18', 'AU', 'Australia', 'WPRO', '271', '23559', '25', '421');
INSERT INTO public.who_global_data_import VALUES (4630, '2020-08-19', 'AU', 'Australia', 'WPRO', '214', '23773', '17', '438');
INSERT INTO public.who_global_data_import VALUES (4631, '2020-08-20', 'AU', 'Australia', 'WPRO', '220', '23993', '12', '450');
INSERT INTO public.who_global_data_import VALUES (4632, '2020-08-21', 'AU', 'Australia', 'WPRO', '243', '24236', '13', '463');
INSERT INTO public.who_global_data_import VALUES (4633, '2020-08-22', 'AU', 'Australia', 'WPRO', '171', '24407', '9', '472');
INSERT INTO public.who_global_data_import VALUES (4634, '2020-08-23', 'AU', 'Australia', 'WPRO', '195', '24602', '13', '485');
INSERT INTO public.who_global_data_import VALUES (4635, '2020-08-24', 'AU', 'Australia', 'WPRO', '210', '24812', '17', '502');
INSERT INTO public.who_global_data_import VALUES (4636, '2020-08-25', 'AU', 'Australia', 'WPRO', '104', '24916', '15', '517');
INSERT INTO public.who_global_data_import VALUES (4637, '2020-08-26', 'AU', 'Australia', 'WPRO', '137', '25053', '8', '525');
INSERT INTO public.who_global_data_import VALUES (4638, '2020-08-27', 'AU', 'Australia', 'WPRO', '152', '25205', '24', '549');
INSERT INTO public.who_global_data_import VALUES (4639, '2020-08-28', 'AU', 'Australia', 'WPRO', '117', '25322', '23', '572');
INSERT INTO public.who_global_data_import VALUES (4640, '2020-08-29', 'AU', 'Australia', 'WPRO', '126', '25448', '11', '583');
INSERT INTO public.who_global_data_import VALUES (4641, '2020-08-30', 'AU', 'Australia', 'WPRO', '99', '25547', '17', '600');
INSERT INTO public.who_global_data_import VALUES (4642, '2020-08-31', 'AU', 'Australia', 'WPRO', '123', '25670', '11', '611');
INSERT INTO public.who_global_data_import VALUES (4643, '2020-09-01', 'AU', 'Australia', 'WPRO', '76', '25746', '41', '652');
INSERT INTO public.who_global_data_import VALUES (4644, '2020-09-02', 'AU', 'Australia', 'WPRO', '73', '25819', '5', '657');
INSERT INTO public.who_global_data_import VALUES (4645, '2020-09-03', 'AU', 'Australia', 'WPRO', '104', '25923', '6', '663');
INSERT INTO public.who_global_data_import VALUES (4646, '2020-09-04', 'AU', 'Australia', 'WPRO', '126', '26049', '15', '678');
INSERT INTO public.who_global_data_import VALUES (4647, '2020-09-05', 'AU', 'Australia', 'WPRO', '87', '26136', '59', '737');
INSERT INTO public.who_global_data_import VALUES (4648, '2020-09-06', 'AU', 'Australia', 'WPRO', '71', '26207', '11', '748');
INSERT INTO public.who_global_data_import VALUES (4649, '2020-09-07', 'AU', 'Australia', 'WPRO', '72', '26279', '5', '753');
INSERT INTO public.who_global_data_import VALUES (4650, '2020-09-08', 'AU', 'Australia', 'WPRO', '43', '26322', '9', '762');
INSERT INTO public.who_global_data_import VALUES (4651, '2020-09-09', 'AU', 'Australia', 'WPRO', '52', '26374', '8', '770');
INSERT INTO public.who_global_data_import VALUES (4652, '2020-09-10', 'AU', 'Australia', 'WPRO', '91', '26465', '11', '781');
INSERT INTO public.who_global_data_import VALUES (4653, '2020-09-11', 'AU', 'Australia', 'WPRO', '48', '26513', '7', '788');
INSERT INTO public.who_global_data_import VALUES (4654, '2020-09-12', 'AU', 'Australia', 'WPRO', '52', '26565', '9', '797');
INSERT INTO public.who_global_data_import VALUES (4655, '2020-09-13', 'AU', 'Australia', 'WPRO', '42', '26607', '6', '803');
INSERT INTO public.who_global_data_import VALUES (4656, '2020-09-14', 'AU', 'Australia', 'WPRO', '44', '26651', '7', '810');
INSERT INTO public.who_global_data_import VALUES (4657, '2020-09-15', 'AU', 'Australia', 'WPRO', '41', '26692', '6', '816');
INSERT INTO public.who_global_data_import VALUES (4658, '2020-09-16', 'AU', 'Australia', 'WPRO', '46', '26738', '0', '816');
INSERT INTO public.who_global_data_import VALUES (4659, '2020-09-17', 'AU', 'Australia', 'WPRO', '41', '26779', '8', '824');
INSERT INTO public.who_global_data_import VALUES (4660, '2020-09-18', 'AU', 'Australia', 'WPRO', '34', '26813', '8', '832');
INSERT INTO public.who_global_data_import VALUES (4661, '2020-09-19', 'AU', 'Australia', 'WPRO', '48', '26861', '5', '837');
INSERT INTO public.who_global_data_import VALUES (4662, '2020-09-20', 'AU', 'Australia', 'WPRO', '24', '26885', '7', '844');
INSERT INTO public.who_global_data_import VALUES (4663, '2020-09-21', 'AU', 'Australia', 'WPRO', '13', '26898', '5', '849');
INSERT INTO public.who_global_data_import VALUES (4664, '2020-09-22', 'AU', 'Australia', 'WPRO', '14', '26912', '2', '851');
INSERT INTO public.who_global_data_import VALUES (4665, '2020-09-23', 'AU', 'Australia', 'WPRO', '30', '26942', '3', '854');
INSERT INTO public.who_global_data_import VALUES (4666, '2020-09-24', 'AU', 'Australia', 'WPRO', '31', '26973', '5', '859');
INSERT INTO public.who_global_data_import VALUES (4667, '2020-09-25', 'AU', 'Australia', 'WPRO', '10', '26983', '2', '861');
INSERT INTO public.who_global_data_import VALUES (4668, '2020-09-26', 'AU', 'Australia', 'WPRO', '17', '27000', '8', '869');
INSERT INTO public.who_global_data_import VALUES (4669, '2020-09-27', 'AU', 'Australia', 'WPRO', '16', '27016', '1', '870');
INSERT INTO public.who_global_data_import VALUES (4670, '2020-09-28', 'AU', 'Australia', 'WPRO', '24', '27040', '2', '872');
INSERT INTO public.who_global_data_import VALUES (4671, '2020-09-29', 'AU', 'Australia', 'WPRO', '4', '27044', '3', '875');
INSERT INTO public.who_global_data_import VALUES (4672, '2020-09-30', 'AU', 'Australia', 'WPRO', '19', '27063', '7', '882');
INSERT INTO public.who_global_data_import VALUES (4673, '2020-10-01', 'AU', 'Australia', 'WPRO', '15', '27078', '4', '886');
INSERT INTO public.who_global_data_import VALUES (4674, '2020-10-02', 'AU', 'Australia', 'WPRO', '18', '27096', '2', '888');
INSERT INTO public.who_global_data_import VALUES (4675, '2020-10-03', 'AU', 'Australia', 'WPRO', '17', '27113', '2', '890');
INSERT INTO public.who_global_data_import VALUES (4676, '2020-10-04', 'AU', 'Australia', 'WPRO', '8', '27121', '3', '893');
INSERT INTO public.who_global_data_import VALUES (4677, '2020-10-05', 'AU', 'Australia', 'WPRO', '15', '27136', '1', '894');
INSERT INTO public.who_global_data_import VALUES (4678, '2020-10-06', 'AU', 'Australia', 'WPRO', '13', '27149', '0', '894');
INSERT INTO public.who_global_data_import VALUES (4679, '2020-10-07', 'AU', 'Australia', 'WPRO', '25', '27174', '1', '895');
INSERT INTO public.who_global_data_import VALUES (4680, '2020-10-08', 'AU', 'Australia', 'WPRO', '8', '27182', '2', '897');
INSERT INTO public.who_global_data_import VALUES (4681, '2020-10-09', 'AU', 'Australia', 'WPRO', '24', '27206', '0', '897');
INSERT INTO public.who_global_data_import VALUES (4682, '2020-10-10', 'AU', 'Australia', 'WPRO', '23', '27229', '0', '897');
INSERT INTO public.who_global_data_import VALUES (4683, '2020-10-11', 'AU', 'Australia', 'WPRO', '15', '27244', '0', '897');
INSERT INTO public.who_global_data_import VALUES (4684, '2020-10-12', 'AU', 'Australia', 'WPRO', '20', '27264', '1', '898');
INSERT INTO public.who_global_data_import VALUES (4685, '2020-10-13', 'AU', 'Australia', 'WPRO', '22', '27286', '0', '898');
INSERT INTO public.who_global_data_import VALUES (4686, '2020-10-14', 'AU', 'Australia', 'WPRO', '31', '27317', '1', '899');
INSERT INTO public.who_global_data_import VALUES (4687, '2020-10-15', 'AU', 'Australia', 'WPRO', '24', '27341', '5', '904');
INSERT INTO public.who_global_data_import VALUES (4688, '2020-10-16', 'AU', 'Australia', 'WPRO', '21', '27362', '0', '904');
INSERT INTO public.who_global_data_import VALUES (4689, '2020-10-17', 'AU', 'Australia', 'WPRO', '9', '27371', '0', '904');
INSERT INTO public.who_global_data_import VALUES (4690, '2020-10-18', 'AU', 'Australia', 'WPRO', '12', '27383', '0', '904');
INSERT INTO public.who_global_data_import VALUES (4691, '2020-10-19', 'AU', 'Australia', 'WPRO', '7', '27390', '0', '904');
INSERT INTO public.who_global_data_import VALUES (4692, '2020-10-20', 'AU', 'Australia', 'WPRO', '9', '27399', '1', '905');
INSERT INTO public.who_global_data_import VALUES (4693, '2020-10-21', 'AU', 'Australia', 'WPRO', '31', '27430', '0', '905');
INSERT INTO public.who_global_data_import VALUES (4694, '2020-10-22', 'AU', 'Australia', 'WPRO', '14', '27444', '0', '905');
INSERT INTO public.who_global_data_import VALUES (4695, '2020-10-23', 'AU', 'Australia', 'WPRO', '22', '27466', '0', '905');
INSERT INTO public.who_global_data_import VALUES (4696, '2020-10-24', 'AU', 'Australia', 'WPRO', '18', '27484', '0', '905');
INSERT INTO public.who_global_data_import VALUES (4697, '2020-10-25', 'AU', 'Australia', 'WPRO', '15', '27499', '0', '905');
INSERT INTO public.who_global_data_import VALUES (4698, '2020-10-26', 'AU', 'Australia', 'WPRO', '21', '27520', '0', '905');
INSERT INTO public.who_global_data_import VALUES (4699, '2020-10-27', 'AU', 'Australia', 'WPRO', '7', '27527', '0', '905');
INSERT INTO public.who_global_data_import VALUES (4700, '2020-10-28', 'AU', 'Australia', 'WPRO', '14', '27541', '0', '905');
INSERT INTO public.who_global_data_import VALUES (4701, '2020-10-29', 'AU', 'Australia', 'WPRO', '13', '27554', '2', '907');
INSERT INTO public.who_global_data_import VALUES (4702, '2020-10-30', 'AU', 'Australia', 'WPRO', '15', '27569', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4703, '2020-10-31', 'AU', 'Australia', 'WPRO', '13', '27582', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4704, '2020-11-01', 'AU', 'Australia', 'WPRO', '8', '27590', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4705, '2020-11-02', 'AU', 'Australia', 'WPRO', '5', '27595', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4706, '2020-11-03', 'AU', 'Australia', 'WPRO', '7', '27602', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4707, '2020-11-04', 'AU', 'Australia', 'WPRO', '8', '27610', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4708, '2020-11-05', 'AU', 'Australia', 'WPRO', '12', '27622', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4709, '2020-11-06', 'AU', 'Australia', 'WPRO', '11', '27633', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4710, '2020-11-07', 'AU', 'Australia', 'WPRO', '12', '27645', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4711, '2020-11-08', 'AU', 'Australia', 'WPRO', '7', '27652', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4712, '2020-11-09', 'AU', 'Australia', 'WPRO', '6', '27658', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4713, '2020-11-10', 'AU', 'Australia', 'WPRO', '10', '27668', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4714, '2020-11-11', 'AU', 'Australia', 'WPRO', '10', '27678', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4715, '2020-11-12', 'AU', 'Australia', 'WPRO', '8', '27686', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4716, '2020-11-13', 'AU', 'Australia', 'WPRO', '12', '27698', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4717, '2020-11-14', 'AU', 'Australia', 'WPRO', '5', '27703', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4718, '2020-11-15', 'AU', 'Australia', 'WPRO', '8', '27711', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4719, '2020-11-16', 'AU', 'Australia', 'WPRO', '14', '27725', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4720, '2020-11-17', 'AU', 'Australia', 'WPRO', '25', '27750', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4721, '2020-11-18', 'AU', 'Australia', 'WPRO', '6', '27756', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4722, '2020-11-19', 'AU', 'Australia', 'WPRO', '21', '27777', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4723, '2020-11-20', 'AU', 'Australia', 'WPRO', '7', '27784', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4724, '2020-11-21', 'AU', 'Australia', 'WPRO', '5', '27789', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4725, '2020-11-22', 'AU', 'Australia', 'WPRO', '18', '27807', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4726, '2020-11-23', 'AU', 'Australia', 'WPRO', '14', '27821', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4727, '2020-11-24', 'AU', 'Australia', 'WPRO', '14', '27835', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4728, '2020-11-25', 'AU', 'Australia', 'WPRO', '13', '27848', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4729, '2020-11-26', 'AU', 'Australia', 'WPRO', '6', '27854', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4730, '2020-11-27', 'AU', 'Australia', 'WPRO', '13', '27867', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4731, '2020-11-28', 'AU', 'Australia', 'WPRO', '7', '27874', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4732, '2020-11-29', 'AU', 'Australia', 'WPRO', '11', '27885', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4733, '2020-11-30', 'AU', 'Australia', 'WPRO', '8', '27893', '0', '907');
INSERT INTO public.who_global_data_import VALUES (4734, '2020-12-01', 'AU', 'Australia', 'WPRO', '11', '27904', '1', '908');
INSERT INTO public.who_global_data_import VALUES (4735, '2020-12-02', 'AU', 'Australia', 'WPRO', '8', '27912', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4736, '2020-12-03', 'AU', 'Australia', 'WPRO', '11', '27923', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4737, '2020-12-04', 'AU', 'Australia', 'WPRO', '16', '27939', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4738, '2020-12-05', 'AU', 'Australia', 'WPRO', '10', '27949', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4739, '2020-12-06', 'AU', 'Australia', 'WPRO', '7', '27956', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4740, '2020-12-07', 'AU', 'Australia', 'WPRO', '9', '27965', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4741, '2020-12-08', 'AU', 'Australia', 'WPRO', '7', '27972', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4742, '2020-12-09', 'AU', 'Australia', 'WPRO', '15', '27987', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4743, '2020-12-10', 'AU', 'Australia', 'WPRO', '6', '27993', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4744, '2020-12-11', 'AU', 'Australia', 'WPRO', '7', '28000', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4745, '2020-12-12', 'AU', 'Australia', 'WPRO', '12', '28012', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4746, '2020-12-13', 'AU', 'Australia', 'WPRO', '13', '28025', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4747, '2020-12-14', 'AU', 'Australia', 'WPRO', '6', '28031', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4748, '2020-12-15', 'AU', 'Australia', 'WPRO', '8', '28039', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4749, '2020-12-16', 'AU', 'Australia', 'WPRO', '8', '28047', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4750, '2020-12-17', 'AU', 'Australia', 'WPRO', '12', '28059', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4751, '2020-12-18', 'AU', 'Australia', 'WPRO', '13', '28072', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4752, '2020-12-19', 'AU', 'Australia', 'WPRO', '22', '28094', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4753, '2020-12-20', 'AU', 'Australia', 'WPRO', '34', '28128', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4754, '2020-12-21', 'AU', 'Australia', 'WPRO', '43', '28171', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4755, '2020-12-22', 'AU', 'Australia', 'WPRO', '27', '28198', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4756, '2020-12-23', 'AU', 'Australia', 'WPRO', '21', '28219', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4757, '2020-12-24', 'AU', 'Australia', 'WPRO', '19', '28238', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4758, '2020-12-25', 'AU', 'Australia', 'WPRO', '24', '28262', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4759, '2020-12-26', 'AU', 'Australia', 'WPRO', '0', '28262', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4760, '2020-12-27', 'AU', 'Australia', 'WPRO', '34', '28296', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4761, '2020-12-28', 'AU', 'Australia', 'WPRO', '16', '28312', '0', '908');
INSERT INTO public.who_global_data_import VALUES (4762, '2020-12-29', 'AU', 'Australia', 'WPRO', '25', '28337', '1', '909');
INSERT INTO public.who_global_data_import VALUES (4763, '2020-12-30', 'AU', 'Australia', 'WPRO', '13', '28350', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4764, '2020-12-31', 'AU', 'Australia', 'WPRO', '31', '28381', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4765, '2021-01-01', 'AU', 'Australia', 'WPRO', '27', '28408', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4766, '2021-01-02', 'AU', 'Australia', 'WPRO', '19', '28427', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4767, '2021-01-03', 'AU', 'Australia', 'WPRO', '35', '28462', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4768, '2021-01-04', 'AU', 'Australia', 'WPRO', '21', '28483', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4769, '2021-01-05', 'AU', 'Australia', 'WPRO', '21', '28504', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4770, '2021-01-06', 'AU', 'Australia', 'WPRO', '15', '28519', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4771, '2021-01-07', 'AU', 'Australia', 'WPRO', '17', '28536', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4772, '2021-01-08', 'AU', 'Australia', 'WPRO', '11', '28547', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4773, '2021-01-09', 'AU', 'Australia', 'WPRO', '24', '28571', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4774, '2021-01-10', 'AU', 'Australia', 'WPRO', '11', '28582', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4775, '2021-01-11', 'AU', 'Australia', 'WPRO', '13', '28595', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4776, '2021-01-12', 'AU', 'Australia', 'WPRO', '19', '28614', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4777, '2021-01-13', 'AU', 'Australia', 'WPRO', '20', '28634', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4778, '2021-01-14', 'AU', 'Australia', 'WPRO', '16', '28650', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4779, '2021-01-15', 'AU', 'Australia', 'WPRO', '8', '28658', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4780, '2021-01-16', 'AU', 'Australia', 'WPRO', '11', '28669', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4781, '2021-01-17', 'AU', 'Australia', 'WPRO', '20', '28689', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4782, '2021-01-18', 'AU', 'Australia', 'WPRO', '19', '28708', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4783, '2021-01-19', 'AU', 'Australia', 'WPRO', '13', '28721', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4784, '2021-01-20', 'AU', 'Australia', 'WPRO', '9', '28730', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4785, '2021-01-21', 'AU', 'Australia', 'WPRO', '10', '28740', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4786, '2021-01-22', 'AU', 'Australia', 'WPRO', '10', '28750', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4787, '2021-01-23', 'AU', 'Australia', 'WPRO', '5', '28755', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4788, '2021-01-24', 'AU', 'Australia', 'WPRO', '6', '28761', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4789, '2021-01-25', 'AU', 'Australia', 'WPRO', '5', '28766', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4790, '2021-01-26', 'AU', 'Australia', 'WPRO', '11', '28777', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4791, '2021-01-27', 'AU', 'Australia', 'WPRO', '3', '28780', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4792, '2021-01-28', 'AU', 'Australia', 'WPRO', '6', '28786', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4793, '2021-01-29', 'AU', 'Australia', 'WPRO', '8', '28794', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4794, '2021-01-30', 'AU', 'Australia', 'WPRO', '6', '28800', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4795, '2021-01-31', 'AU', 'Australia', 'WPRO', '6', '28806', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4796, '2021-02-01', 'AU', 'Australia', 'WPRO', '5', '28811', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4797, '2021-02-02', 'AU', 'Australia', 'WPRO', '7', '28818', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4798, '2021-02-03', 'AU', 'Australia', 'WPRO', '6', '28824', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4799, '2021-02-04', 'AU', 'Australia', 'WPRO', '5', '28829', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4800, '2021-02-05', 'AU', 'Australia', 'WPRO', '9', '28838', '0', '909');
INSERT INTO public.who_global_data_import VALUES (4801, '2020-01-03', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4802, '2020-01-04', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4803, '2020-01-05', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4804, '2020-01-06', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4805, '2020-01-07', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4806, '2020-01-08', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4807, '2020-01-09', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4808, '2020-01-10', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4809, '2020-01-11', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4810, '2020-01-12', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4811, '2020-01-13', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4812, '2020-01-14', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4813, '2020-01-15', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4814, '2020-01-16', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4815, '2020-01-17', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4816, '2020-01-18', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4817, '2020-01-19', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4818, '2020-01-20', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4819, '2020-01-21', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4820, '2020-01-22', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4821, '2020-01-23', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4822, '2020-01-24', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4823, '2020-01-25', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4824, '2020-01-26', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4825, '2020-01-27', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4826, '2020-01-28', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4827, '2020-01-29', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4828, '2020-01-30', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4829, '2020-01-31', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4830, '2020-02-01', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4831, '2020-02-02', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4832, '2020-02-03', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4833, '2020-02-04', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4834, '2020-02-05', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4835, '2020-02-06', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4836, '2020-02-07', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4837, '2020-02-08', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4838, '2020-02-09', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4839, '2020-02-10', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4840, '2020-02-11', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4841, '2020-02-12', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4842, '2020-02-13', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4843, '2020-02-14', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4844, '2020-02-15', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4845, '2020-02-16', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4846, '2020-02-17', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4847, '2020-02-18', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4848, '2020-02-19', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4849, '2020-02-20', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4850, '2020-02-21', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4851, '2020-02-22', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4852, '2020-02-23', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4853, '2020-02-24', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4854, '2020-02-25', 'AT', 'Austria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4855, '2020-02-26', 'AT', 'Austria', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4856, '2020-02-27', 'AT', 'Austria', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4857, '2020-02-28', 'AT', 'Austria', 'EURO', '3', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4858, '2020-02-29', 'AT', 'Austria', 'EURO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4859, '2020-03-01', 'AT', 'Austria', 'EURO', '3', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4860, '2020-03-02', 'AT', 'Austria', 'EURO', '4', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4861, '2020-03-03', 'AT', 'Austria', 'EURO', '4', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4862, '2020-03-04', 'AT', 'Austria', 'EURO', '6', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4863, '2020-03-05', 'AT', 'Austria', 'EURO', '5', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4864, '2020-03-06', 'AT', 'Austria', 'EURO', '12', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4865, '2020-03-07', 'AT', 'Austria', 'EURO', '33', '74', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4866, '2020-03-08', 'AT', 'Austria', 'EURO', '25', '99', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4867, '2020-03-09', 'AT', 'Austria', 'EURO', '3', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4868, '2020-03-10', 'AT', 'Austria', 'EURO', '29', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4869, '2020-03-11', 'AT', 'Austria', 'EURO', '51', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4870, '2020-03-12', 'AT', 'Austria', 'EURO', '64', '246', '0', '0');
INSERT INTO public.who_global_data_import VALUES (4871, '2020-03-13', 'AT', 'Austria', 'EURO', '115', '361', '1', '1');
INSERT INTO public.who_global_data_import VALUES (4872, '2020-03-14', 'AT', 'Austria', 'EURO', '143', '504', '0', '1');
INSERT INTO public.who_global_data_import VALUES (4873, '2020-03-15', 'AT', 'Austria', 'EURO', '151', '655', '0', '1');
INSERT INTO public.who_global_data_import VALUES (4874, '2020-03-16', 'AT', 'Austria', 'EURO', '205', '860', '0', '1');
INSERT INTO public.who_global_data_import VALUES (4875, '2020-03-17', 'AT', 'Austria', 'EURO', '156', '1016', '2', '3');
INSERT INTO public.who_global_data_import VALUES (4876, '2020-03-18', 'AT', 'Austria', 'EURO', '316', '1332', '0', '3');
INSERT INTO public.who_global_data_import VALUES (4877, '2020-03-19', 'AT', 'Austria', 'EURO', '314', '1646', '1', '4');
INSERT INTO public.who_global_data_import VALUES (4878, '2020-03-20', 'AT', 'Austria', 'EURO', '550', '2196', '2', '6');
INSERT INTO public.who_global_data_import VALUES (4879, '2020-03-21', 'AT', 'Austria', 'EURO', '453', '2649', '0', '6');
INSERT INTO public.who_global_data_import VALUES (4880, '2020-03-22', 'AT', 'Austria', 'EURO', '375', '3024', '2', '8');
INSERT INTO public.who_global_data_import VALUES (4881, '2020-03-23', 'AT', 'Austria', 'EURO', '607', '3631', '8', '16');
INSERT INTO public.who_global_data_import VALUES (4882, '2020-03-24', 'AT', 'Austria', 'EURO', '855', '4486', '9', '25');
INSERT INTO public.who_global_data_import VALUES (4883, '2020-03-25', 'AT', 'Austria', 'EURO', '796', '5282', '5', '30');
INSERT INTO public.who_global_data_import VALUES (4884, '2020-03-26', 'AT', 'Austria', 'EURO', '606', '5888', '4', '34');
INSERT INTO public.who_global_data_import VALUES (4885, '2020-03-27', 'AT', 'Austria', 'EURO', '1141', '7029', '18', '52');
INSERT INTO public.who_global_data_import VALUES (4886, '2020-03-28', 'AT', 'Austria', 'EURO', '668', '7697', '16', '68');
INSERT INTO public.who_global_data_import VALUES (4887, '2020-03-29', 'AT', 'Austria', 'EURO', '594', '8291', '0', '68');
INSERT INTO public.who_global_data_import VALUES (4888, '2020-03-30', 'AT', 'Austria', 'EURO', '522', '8813', '18', '86');
INSERT INTO public.who_global_data_import VALUES (4889, '2020-03-31', 'AT', 'Austria', 'EURO', '805', '9618', '22', '108');
INSERT INTO public.who_global_data_import VALUES (4890, '2020-04-01', 'AT', 'Austria', 'EURO', '564', '10182', '20', '128');
INSERT INTO public.who_global_data_import VALUES (4891, '2020-04-02', 'AT', 'Austria', 'EURO', '529', '10711', '18', '146');
INSERT INTO public.who_global_data_import VALUES (4892, '2020-04-03', 'AT', 'Austria', 'EURO', '418', '11129', '12', '158');
INSERT INTO public.who_global_data_import VALUES (4893, '2020-04-04', 'AT', 'Austria', 'EURO', '396', '11525', '10', '168');
INSERT INTO public.who_global_data_import VALUES (4894, '2020-04-05', 'AT', 'Austria', 'EURO', '241', '11766', '18', '186');
INSERT INTO public.who_global_data_import VALUES (4895, '2020-04-06', 'AT', 'Austria', 'EURO', '217', '11983', '18', '204');
INSERT INTO public.who_global_data_import VALUES (4896, '2020-04-07', 'AT', 'Austria', 'EURO', '314', '12297', '16', '220');
INSERT INTO public.who_global_data_import VALUES (4897, '2020-04-08', 'AT', 'Austria', 'EURO', '343', '12640', '23', '243');
INSERT INTO public.who_global_data_import VALUES (4898, '2020-04-09', 'AT', 'Austria', 'EURO', '329', '12969', '30', '273');
INSERT INTO public.who_global_data_import VALUES (4899, '2020-04-10', 'AT', 'Austria', 'EURO', '279', '13248', '22', '295');
INSERT INTO public.who_global_data_import VALUES (4900, '2020-04-11', 'AT', 'Austria', 'EURO', '312', '13560', '24', '319');
INSERT INTO public.who_global_data_import VALUES (4901, '2020-04-12', 'AT', 'Austria', 'EURO', '247', '13807', '18', '337');
INSERT INTO public.who_global_data_import VALUES (4902, '2020-04-13', 'AT', 'Austria', 'EURO', '130', '13937', '13', '350');
INSERT INTO public.who_global_data_import VALUES (4903, '2020-04-14', 'AT', 'Austria', 'EURO', '106', '14043', '18', '368');
INSERT INTO public.who_global_data_import VALUES (4904, '2020-04-15', 'AT', 'Austria', 'EURO', '191', '14234', '16', '384');
INSERT INTO public.who_global_data_import VALUES (4905, '2020-04-16', 'AT', 'Austria', 'EURO', '136', '14370', '9', '393');
INSERT INTO public.who_global_data_import VALUES (4906, '2020-04-17', 'AT', 'Austria', 'EURO', '78', '14448', '17', '410');
INSERT INTO public.who_global_data_import VALUES (4907, '2020-04-18', 'AT', 'Austria', 'EURO', '155', '14603', '21', '431');
INSERT INTO public.who_global_data_import VALUES (4908, '2020-04-19', 'AT', 'Austria', 'EURO', '59', '14662', '12', '443');
INSERT INTO public.who_global_data_import VALUES (4909, '2020-04-20', 'AT', 'Austria', 'EURO', '48', '14710', '9', '452');
INSERT INTO public.who_global_data_import VALUES (4910, '2020-04-21', 'AT', 'Austria', 'EURO', '73', '14783', '10', '462');
INSERT INTO public.who_global_data_import VALUES (4911, '2020-04-22', 'AT', 'Austria', 'EURO', '50', '14833', '1', '463');
INSERT INTO public.who_global_data_import VALUES (4912, '2020-04-23', 'AT', 'Austria', 'EURO', '91', '14924', '31', '494');
INSERT INTO public.who_global_data_import VALUES (4913, '2020-04-24', 'AT', 'Austria', 'EURO', '61', '14985', '14', '508');
INSERT INTO public.who_global_data_import VALUES (4914, '2020-04-25', 'AT', 'Austria', 'EURO', '83', '15068', '5', '513');
INSERT INTO public.who_global_data_import VALUES (4915, '2020-04-26', 'AT', 'Austria', 'EURO', '66', '15134', '23', '536');
INSERT INTO public.who_global_data_import VALUES (4916, '2020-04-27', 'AT', 'Austria', 'EURO', '55', '15189', '6', '542');
INSERT INTO public.who_global_data_import VALUES (4917, '2020-04-28', 'AT', 'Austria', 'EURO', '67', '15256', '7', '549');
INSERT INTO public.who_global_data_import VALUES (4918, '2020-04-29', 'AT', 'Austria', 'EURO', '58', '15314', '20', '569');
INSERT INTO public.who_global_data_import VALUES (4919, '2020-04-30', 'AT', 'Austria', 'EURO', '50', '15364', '11', '580');
INSERT INTO public.who_global_data_import VALUES (4920, '2020-05-01', 'AT', 'Austria', 'EURO', '60', '15424', '4', '584');
INSERT INTO public.who_global_data_import VALUES (4921, '2020-05-02', 'AT', 'Austria', 'EURO', '34', '15458', '5', '589');
INSERT INTO public.who_global_data_import VALUES (4922, '2020-05-03', 'AT', 'Austria', 'EURO', '12', '15470', '7', '596');
INSERT INTO public.who_global_data_import VALUES (4923, '2020-05-04', 'AT', 'Austria', 'EURO', '68', '15538', '2', '598');
INSERT INTO public.who_global_data_import VALUES (4924, '2020-05-05', 'AT', 'Austria', 'EURO', '31', '15569', '2', '600');
INSERT INTO public.who_global_data_import VALUES (4925, '2020-05-06', 'AT', 'Austria', 'EURO', '17', '15586', '6', '606');
INSERT INTO public.who_global_data_import VALUES (4926, '2020-05-07', 'AT', 'Austria', 'EURO', '65', '15651', '2', '608');
INSERT INTO public.who_global_data_import VALUES (4927, '2020-05-08', 'AT', 'Austria', 'EURO', '22', '15673', '1', '609');
INSERT INTO public.who_global_data_import VALUES (4928, '2020-05-09', 'AT', 'Austria', 'EURO', '62', '15735', '5', '614');
INSERT INTO public.who_global_data_import VALUES (4929, '2020-05-10', 'AT', 'Austria', 'EURO', '42', '15777', '1', '615');
INSERT INTO public.who_global_data_import VALUES (4930, '2020-05-11', 'AT', 'Austria', 'EURO', '10', '15787', '3', '618');
INSERT INTO public.who_global_data_import VALUES (4931, '2020-05-12', 'AT', 'Austria', 'EURO', '87', '15874', '2', '620');
INSERT INTO public.who_global_data_import VALUES (4932, '2020-05-13', 'AT', 'Austria', 'EURO', '36', '15910', '3', '623');
INSERT INTO public.who_global_data_import VALUES (4933, '2020-05-14', 'AT', 'Austria', 'EURO', '54', '15964', '1', '624');
INSERT INTO public.who_global_data_import VALUES (4934, '2020-05-15', 'AT', 'Austria', 'EURO', '41', '16005', '2', '626');
INSERT INTO public.who_global_data_import VALUES (4935, '2020-05-16', 'AT', 'Austria', 'EURO', '63', '16068', '2', '628');
INSERT INTO public.who_global_data_import VALUES (4936, '2020-05-17', 'AT', 'Austria', 'EURO', '72', '16140', '0', '628');
INSERT INTO public.who_global_data_import VALUES (4937, '2020-05-18', 'AT', 'Austria', 'EURO', '14', '16154', '1', '629');
INSERT INTO public.who_global_data_import VALUES (4938, '2020-05-19', 'AT', 'Austria', 'EURO', '25', '16179', '0', '629');
INSERT INTO public.who_global_data_import VALUES (4939, '2020-05-20', 'AT', 'Austria', 'EURO', '78', '16257', '3', '632');
INSERT INTO public.who_global_data_import VALUES (4940, '2020-05-21', 'AT', 'Austria', 'EURO', '18', '16275', '1', '633');
INSERT INTO public.who_global_data_import VALUES (4941, '2020-05-22', 'AT', 'Austria', 'EURO', '57', '16332', '0', '633');
INSERT INTO public.who_global_data_import VALUES (4942, '2020-05-23', 'AT', 'Austria', 'EURO', '29', '16361', '2', '635');
INSERT INTO public.who_global_data_import VALUES (4943, '2020-05-24', 'AT', 'Austria', 'EURO', '46', '16407', '4', '639');
INSERT INTO public.who_global_data_import VALUES (4944, '2020-05-25', 'AT', 'Austria', 'EURO', '32', '16439', '1', '640');
INSERT INTO public.who_global_data_import VALUES (4945, '2020-05-26', 'AT', 'Austria', 'EURO', '20', '16459', '1', '641');
INSERT INTO public.who_global_data_import VALUES (4946, '2020-05-27', 'AT', 'Austria', 'EURO', '38', '16497', '2', '643');
INSERT INTO public.who_global_data_import VALUES (4947, '2020-05-28', 'AT', 'Austria', 'EURO', '18', '16515', '2', '645');
INSERT INTO public.who_global_data_import VALUES (4948, '2020-05-29', 'AT', 'Austria', 'EURO', '28', '16543', '23', '668');
INSERT INTO public.who_global_data_import VALUES (4949, '2020-05-30', 'AT', 'Austria', 'EURO', '51', '16594', '0', '668');
INSERT INTO public.who_global_data_import VALUES (4950, '2020-05-31', 'AT', 'Austria', 'EURO', '44', '16638', '0', '668');
INSERT INTO public.who_global_data_import VALUES (4951, '2020-06-01', 'AT', 'Austria', 'EURO', '4', '16642', '0', '668');
INSERT INTO public.who_global_data_import VALUES (4952, '2020-06-02', 'AT', 'Austria', 'EURO', '21', '16663', '0', '668');
INSERT INTO public.who_global_data_import VALUES (4953, '2020-06-03', 'AT', 'Austria', 'EURO', '11', '16674', '1', '669');
INSERT INTO public.who_global_data_import VALUES (4954, '2020-06-04', 'AT', 'Austria', 'EURO', '31', '16705', '1', '670');
INSERT INTO public.who_global_data_import VALUES (4955, '2020-06-05', 'AT', 'Austria', 'EURO', '36', '16741', '0', '670');
INSERT INTO public.who_global_data_import VALUES (4956, '2020-06-06', 'AT', 'Austria', 'EURO', '62', '16803', '2', '672');
INSERT INTO public.who_global_data_import VALUES (4957, '2020-06-07', 'AT', 'Austria', 'EURO', '19', '16822', '0', '672');
INSERT INTO public.who_global_data_import VALUES (4958, '2020-06-08', 'AT', 'Austria', 'EURO', '46', '16868', '0', '672');
INSERT INTO public.who_global_data_import VALUES (4959, '2020-06-09', 'AT', 'Austria', 'EURO', '21', '16889', '0', '672');
INSERT INTO public.who_global_data_import VALUES (4960, '2020-06-10', 'AT', 'Austria', 'EURO', '13', '16902', '0', '672');
INSERT INTO public.who_global_data_import VALUES (4961, '2020-06-11', 'AT', 'Austria', 'EURO', '34', '16936', '1', '673');
INSERT INTO public.who_global_data_import VALUES (4962, '2020-06-12', 'AT', 'Austria', 'EURO', '28', '16964', '1', '674');
INSERT INTO public.who_global_data_import VALUES (4963, '2020-06-13', 'AT', 'Austria', 'EURO', '30', '16994', '1', '675');
INSERT INTO public.who_global_data_import VALUES (4964, '2020-06-14', 'AT', 'Austria', 'EURO', '20', '17014', '2', '677');
INSERT INTO public.who_global_data_import VALUES (4965, '2020-06-15', 'AT', 'Austria', 'EURO', '24', '17038', '0', '677');
INSERT INTO public.who_global_data_import VALUES (4966, '2020-06-16', 'AT', 'Austria', 'EURO', '27', '17065', '1', '678');
INSERT INTO public.who_global_data_import VALUES (4967, '2020-06-17', 'AT', 'Austria', 'EURO', '33', '17098', '3', '681');
INSERT INTO public.who_global_data_import VALUES (4968, '2020-06-18', 'AT', 'Austria', 'EURO', '17', '17115', '6', '687');
INSERT INTO public.who_global_data_import VALUES (4969, '2020-06-19', 'AT', 'Austria', 'EURO', '40', '17155', '1', '688');
INSERT INTO public.who_global_data_import VALUES (4970, '2020-06-20', 'AT', 'Austria', 'EURO', '30', '17185', '0', '688');
INSERT INTO public.who_global_data_import VALUES (4971, '2020-06-21', 'AT', 'Austria', 'EURO', '62', '17247', '0', '688');
INSERT INTO public.who_global_data_import VALUES (4972, '2020-06-22', 'AT', 'Austria', 'EURO', '38', '17285', '2', '690');
INSERT INTO public.who_global_data_import VALUES (4973, '2020-06-23', 'AT', 'Austria', 'EURO', '35', '17320', '0', '690');
INSERT INTO public.who_global_data_import VALUES (4974, '2020-06-24', 'AT', 'Austria', 'EURO', '31', '17351', '3', '693');
INSERT INTO public.who_global_data_import VALUES (4975, '2020-06-25', 'AT', 'Austria', 'EURO', '33', '17384', '0', '693');
INSERT INTO public.who_global_data_import VALUES (4976, '2020-06-26', 'AT', 'Austria', 'EURO', '47', '17431', '5', '698');
INSERT INTO public.who_global_data_import VALUES (4977, '2020-06-27', 'AT', 'Austria', 'EURO', '67', '17498', '0', '698');
INSERT INTO public.who_global_data_import VALUES (4978, '2020-06-28', 'AT', 'Austria', 'EURO', '64', '17562', '2', '700');
INSERT INTO public.who_global_data_import VALUES (4979, '2020-06-29', 'AT', 'Austria', 'EURO', '63', '17625', '2', '702');
INSERT INTO public.who_global_data_import VALUES (4980, '2020-06-30', 'AT', 'Austria', 'EURO', '41', '17666', '1', '703');
INSERT INTO public.who_global_data_import VALUES (4981, '2020-07-01', 'AT', 'Austria', 'EURO', '111', '17777', '2', '705');
INSERT INTO public.who_global_data_import VALUES (4982, '2020-07-02', 'AT', 'Austria', 'EURO', '37', '17814', '0', '705');
INSERT INTO public.who_global_data_import VALUES (4983, '2020-07-03', 'AT', 'Austria', 'EURO', '138', '17952', '0', '705');
INSERT INTO public.who_global_data_import VALUES (4984, '2020-07-04', 'AT', 'Austria', 'EURO', '121', '18073', '0', '705');
INSERT INTO public.who_global_data_import VALUES (4985, '2020-07-05', 'AT', 'Austria', 'EURO', '123', '18196', '0', '705');
INSERT INTO public.who_global_data_import VALUES (4986, '2020-07-06', 'AT', 'Austria', 'EURO', '73', '18269', '1', '706');
INSERT INTO public.who_global_data_import VALUES (4987, '2020-07-07', 'AT', 'Austria', 'EURO', '57', '18326', '0', '706');
INSERT INTO public.who_global_data_import VALUES (4988, '2020-07-08', 'AT', 'Austria', 'EURO', '89', '18415', '0', '706');
INSERT INTO public.who_global_data_import VALUES (4989, '2020-07-09', 'AT', 'Austria', 'EURO', '101', '18516', '0', '706');
INSERT INTO public.who_global_data_import VALUES (4990, '2020-07-10', 'AT', 'Austria', 'EURO', '97', '18613', '0', '706');
INSERT INTO public.who_global_data_import VALUES (4991, '2020-07-11', 'AT', 'Austria', 'EURO', '74', '18687', '0', '706');
INSERT INTO public.who_global_data_import VALUES (4992, '2020-07-12', 'AT', 'Austria', 'EURO', '108', '18795', '0', '706');
INSERT INTO public.who_global_data_import VALUES (4993, '2020-07-13', 'AT', 'Austria', 'EURO', '52', '18847', '2', '708');
INSERT INTO public.who_global_data_import VALUES (4994, '2020-07-14', 'AT', 'Austria', 'EURO', '12', '18859', '0', '708');
INSERT INTO public.who_global_data_import VALUES (4995, '2020-07-15', 'AT', 'Austria', 'EURO', '201', '19060', '1', '709');
INSERT INTO public.who_global_data_import VALUES (4996, '2020-07-16', 'AT', 'Austria', 'EURO', '55', '19115', '1', '710');
INSERT INTO public.who_global_data_import VALUES (4997, '2020-07-17', 'AT', 'Austria', 'EURO', '153', '19268', '0', '710');
INSERT INTO public.who_global_data_import VALUES (4998, '2020-07-18', 'AT', 'Austria', 'EURO', '138', '19406', '0', '710');
INSERT INTO public.who_global_data_import VALUES (4999, '2020-07-19', 'AT', 'Austria', 'EURO', '102', '19508', '0', '710');
INSERT INTO public.who_global_data_import VALUES (5000, '2020-07-20', 'AT', 'Austria', 'EURO', '63', '19571', '0', '710');
INSERT INTO public.who_global_data_import VALUES (5001, '2020-07-21', 'AT', 'Austria', 'EURO', '108', '19679', '0', '710');
INSERT INTO public.who_global_data_import VALUES (5002, '2020-07-22', 'AT', 'Austria', 'EURO', '139', '19818', '0', '710');
INSERT INTO public.who_global_data_import VALUES (5003, '2020-07-23', 'AT', 'Austria', 'EURO', '140', '19958', '1', '711');
INSERT INTO public.who_global_data_import VALUES (5004, '2020-07-24', 'AT', 'Austria', 'EURO', '164', '20122', '0', '711');
INSERT INTO public.who_global_data_import VALUES (5005, '2020-07-25', 'AT', 'Austria', 'EURO', '107', '20229', '0', '711');
INSERT INTO public.who_global_data_import VALUES (5006, '2020-07-26', 'AT', 'Austria', 'EURO', '120', '20349', '1', '712');
INSERT INTO public.who_global_data_import VALUES (5007, '2020-07-27', 'AT', 'Austria', 'EURO', '137', '20486', '0', '712');
INSERT INTO public.who_global_data_import VALUES (5008, '2020-07-28', 'AT', 'Austria', 'EURO', '64', '20550', '1', '713');
INSERT INTO public.who_global_data_import VALUES (5009, '2020-07-29', 'AT', 'Austria', 'EURO', '132', '20682', '0', '713');
INSERT INTO public.who_global_data_import VALUES (5010, '2020-07-30', 'AT', 'Austria', 'EURO', '164', '20846', '3', '716');
INSERT INTO public.who_global_data_import VALUES (5011, '2020-07-31', 'AT', 'Austria', 'EURO', '163', '21009', '2', '718');
INSERT INTO public.who_global_data_import VALUES (5012, '2020-08-01', 'AT', 'Austria', 'EURO', '89', '21098', '0', '718');
INSERT INTO public.who_global_data_import VALUES (5013, '2020-08-02', 'AT', 'Austria', 'EURO', '126', '21224', '0', '718');
INSERT INTO public.who_global_data_import VALUES (5014, '2020-08-03', 'AT', 'Austria', 'EURO', '85', '21309', '0', '718');
INSERT INTO public.who_global_data_import VALUES (5015, '2020-08-04', 'AT', 'Austria', 'EURO', '32', '21341', '0', '718');
INSERT INTO public.who_global_data_import VALUES (5016, '2020-08-05', 'AT', 'Austria', 'EURO', '131', '21472', '1', '719');
INSERT INTO public.who_global_data_import VALUES (5017, '2020-08-06', 'AT', 'Austria', 'EURO', '103', '21575', '0', '719');
INSERT INTO public.who_global_data_import VALUES (5018, '2020-08-07', 'AT', 'Austria', 'EURO', '114', '21689', '0', '719');
INSERT INTO public.who_global_data_import VALUES (5019, '2020-08-08', 'AT', 'Austria', 'EURO', '130', '21819', '1', '720');
INSERT INTO public.who_global_data_import VALUES (5020, '2020-08-09', 'AT', 'Austria', 'EURO', '116', '21935', '1', '721');
INSERT INTO public.who_global_data_import VALUES (5021, '2020-08-10', 'AT', 'Austria', 'EURO', '76', '22011', '0', '721');
INSERT INTO public.who_global_data_import VALUES (5022, '2020-08-11', 'AT', 'Austria', 'EURO', '111', '22122', '2', '723');
INSERT INTO public.who_global_data_import VALUES (5023, '2020-08-12', 'AT', 'Austria', 'EURO', '138', '22260', '0', '723');
INSERT INTO public.who_global_data_import VALUES (5024, '2020-08-13', 'AT', 'Austria', 'EURO', '241', '22501', '1', '724');
INSERT INTO public.who_global_data_import VALUES (5025, '2020-08-14', 'AT', 'Austria', 'EURO', '229', '22730', '1', '725');
INSERT INTO public.who_global_data_import VALUES (5026, '2020-08-15', 'AT', 'Austria', 'EURO', '221', '22951', '0', '725');
INSERT INTO public.who_global_data_import VALUES (5027, '2020-08-16', 'AT', 'Austria', 'EURO', '260', '23211', '3', '728');
INSERT INTO public.who_global_data_import VALUES (5028, '2020-08-17', 'AT', 'Austria', 'EURO', '162', '23373', '0', '728');
INSERT INTO public.who_global_data_import VALUES (5029, '2020-08-18', 'AT', 'Austria', 'EURO', '344', '23717', '1', '729');
INSERT INTO public.who_global_data_import VALUES (5030, '2020-08-19', 'AT', 'Austria', 'EURO', '158', '23875', '0', '729');
INSERT INTO public.who_global_data_import VALUES (5031, '2020-08-20', 'AT', 'Austria', 'EURO', '425', '24300', '0', '729');
INSERT INTO public.who_global_data_import VALUES (5032, '2020-08-21', 'AT', 'Austria', 'EURO', '308', '24608', '0', '729');
INSERT INTO public.who_global_data_import VALUES (5033, '2020-08-22', 'AT', 'Austria', 'EURO', '275', '24883', '1', '730');
INSERT INTO public.who_global_data_import VALUES (5034, '2020-08-23', 'AT', 'Austria', 'EURO', '216', '25099', '2', '732');
INSERT INTO public.who_global_data_import VALUES (5035, '2020-08-24', 'AT', 'Austria', 'EURO', '140', '25239', '0', '732');
INSERT INTO public.who_global_data_import VALUES (5036, '2020-08-25', 'AT', 'Austria', 'EURO', '308', '25547', '1', '733');
INSERT INTO public.who_global_data_import VALUES (5037, '2020-08-26', 'AT', 'Austria', 'EURO', '291', '25838', '0', '733');
INSERT INTO public.who_global_data_import VALUES (5038, '2020-08-27', 'AT', 'Austria', 'EURO', '316', '26154', '0', '733');
INSERT INTO public.who_global_data_import VALUES (5039, '2020-08-28', 'AT', 'Austria', 'EURO', '227', '26381', '0', '733');
INSERT INTO public.who_global_data_import VALUES (5040, '2020-08-29', 'AT', 'Austria', 'EURO', '382', '26763', '0', '733');
INSERT INTO public.who_global_data_import VALUES (5041, '2020-08-30', 'AT', 'Austria', 'EURO', '174', '26937', '0', '733');
INSERT INTO public.who_global_data_import VALUES (5042, '2020-08-31', 'AT', 'Austria', 'EURO', '281', '27218', '0', '733');
INSERT INTO public.who_global_data_import VALUES (5043, '2020-09-01', 'AT', 'Austria', 'EURO', '186', '27404', '0', '733');
INSERT INTO public.who_global_data_import VALUES (5044, '2020-09-02', 'AT', 'Austria', 'EURO', '337', '27741', '1', '734');
INSERT INTO public.who_global_data_import VALUES (5045, '2020-09-03', 'AT', 'Austria', 'EURO', '442', '28183', '0', '734');
INSERT INTO public.who_global_data_import VALUES (5046, '2020-09-04', 'AT', 'Austria', 'EURO', '312', '28495', '1', '735');
INSERT INTO public.who_global_data_import VALUES (5047, '2020-09-05', 'AT', 'Austria', 'EURO', '271', '28766', '0', '735');
INSERT INTO public.who_global_data_import VALUES (5048, '2020-09-06', 'AT', 'Austria', 'EURO', '208', '28974', '0', '735');
INSERT INTO public.who_global_data_import VALUES (5049, '2020-09-07', 'AT', 'Austria', 'EURO', '220', '29194', '1', '736');
INSERT INTO public.who_global_data_import VALUES (5050, '2020-09-08', 'AT', 'Austria', 'EURO', '511', '29705', '10', '746');
INSERT INTO public.who_global_data_import VALUES (5051, '2020-09-09', 'AT', 'Austria', 'EURO', '495', '30200', '1', '747');
INSERT INTO public.who_global_data_import VALUES (5052, '2020-09-10', 'AT', 'Austria', 'EURO', '754', '30954', '0', '747');
INSERT INTO public.who_global_data_import VALUES (5053, '2020-09-11', 'AT', 'Austria', 'EURO', '497', '31451', '1', '748');
INSERT INTO public.who_global_data_import VALUES (5054, '2020-09-12', 'AT', 'Austria', 'EURO', '1005', '32456', '2', '750');
INSERT INTO public.who_global_data_import VALUES (5055, '2020-09-13', 'AT', 'Austria', 'EURO', '495', '32951', '4', '754');
INSERT INTO public.who_global_data_import VALUES (5056, '2020-09-14', 'AT', 'Austria', 'EURO', '384', '33335', '2', '756');
INSERT INTO public.who_global_data_import VALUES (5057, '2020-09-15', 'AT', 'Austria', 'EURO', '549', '33884', '1', '757');
INSERT INTO public.who_global_data_import VALUES (5058, '2020-09-16', 'AT', 'Austria', 'EURO', '860', '34744', '0', '757');
INSERT INTO public.who_global_data_import VALUES (5059, '2020-09-17', 'AT', 'Austria', 'EURO', '704', '35448', '1', '758');
INSERT INTO public.who_global_data_import VALUES (5060, '2020-09-18', 'AT', 'Austria', 'EURO', '922', '36370', '0', '758');
INSERT INTO public.who_global_data_import VALUES (5061, '2020-09-19', 'AT', 'Austria', 'EURO', '821', '37191', '5', '763');
INSERT INTO public.who_global_data_import VALUES (5062, '2020-09-20', 'AT', 'Austria', 'EURO', '757', '37948', '2', '765');
INSERT INTO public.who_global_data_import VALUES (5063, '2020-09-21', 'AT', 'Austria', 'EURO', '609', '38557', '1', '766');
INSERT INTO public.who_global_data_import VALUES (5064, '2020-09-22', 'AT', 'Austria', 'EURO', '593', '39150', '1', '767');
INSERT INTO public.who_global_data_import VALUES (5065, '2020-09-23', 'AT', 'Austria', 'EURO', '747', '39897', '4', '771');
INSERT INTO public.who_global_data_import VALUES (5066, '2020-09-24', 'AT', 'Austria', 'EURO', '661', '40558', '6', '777');
INSERT INTO public.who_global_data_import VALUES (5067, '2020-09-25', 'AT', 'Austria', 'EURO', '688', '41246', '6', '783');
INSERT INTO public.who_global_data_import VALUES (5068, '2020-09-26', 'AT', 'Austria', 'EURO', '1071', '42317', '3', '786');
INSERT INTO public.who_global_data_import VALUES (5069, '2020-09-27', 'AT', 'Austria', 'EURO', '623', '42940', '1', '787');
INSERT INTO public.who_global_data_import VALUES (5070, '2020-09-28', 'AT', 'Austria', 'EURO', '526', '43466', '0', '787');
INSERT INTO public.who_global_data_import VALUES (5071, '2020-09-29', 'AT', 'Austria', 'EURO', '419', '43885', '3', '790');
INSERT INTO public.who_global_data_import VALUES (5072, '2020-09-30', 'AT', 'Austria', 'EURO', '722', '44607', '6', '796');
INSERT INTO public.who_global_data_import VALUES (5073, '2020-10-01', 'AT', 'Austria', 'EURO', '1146', '45753', '3', '799');
INSERT INTO public.who_global_data_import VALUES (5074, '2020-10-02', 'AT', 'Austria', 'EURO', '564', '46317', '3', '802');
INSERT INTO public.who_global_data_import VALUES (5075, '2020-10-03', 'AT', 'Austria', 'EURO', '872', '47189', '1', '803');
INSERT INTO public.who_global_data_import VALUES (5076, '2020-10-04', 'AT', 'Austria', 'EURO', '830', '48019', '6', '809');
INSERT INTO public.who_global_data_import VALUES (5077, '2020-10-05', 'AT', 'Austria', 'EURO', '599', '48618', '4', '813');
INSERT INTO public.who_global_data_import VALUES (5078, '2020-10-06', 'AT', 'Austria', 'EURO', '1268', '49886', '5', '818');
INSERT INTO public.who_global_data_import VALUES (5079, '2020-10-07', 'AT', 'Austria', 'EURO', '549', '50435', '22', '840');
INSERT INTO public.who_global_data_import VALUES (5080, '2020-10-08', 'AT', 'Austria', 'EURO', '947', '51382', '4', '844');
INSERT INTO public.who_global_data_import VALUES (5081, '2020-10-09', 'AT', 'Austria', 'EURO', '1221', '52603', '9', '853');
INSERT INTO public.who_global_data_import VALUES (5082, '2020-10-10', 'AT', 'Austria', 'EURO', '1181', '53784', '4', '857');
INSERT INTO public.who_global_data_import VALUES (5083, '2020-10-11', 'AT', 'Austria', 'EURO', '901', '54685', '1', '858');
INSERT INTO public.who_global_data_import VALUES (5084, '2020-10-12', 'AT', 'Austria', 'EURO', '1298', '55983', '6', '864');
INSERT INTO public.who_global_data_import VALUES (5085, '2020-10-13', 'AT', 'Austria', 'EURO', '608', '56591', '5', '869');
INSERT INTO public.who_global_data_import VALUES (5086, '2020-10-14', 'AT', 'Austria', 'EURO', '1171', '57762', '10', '879');
INSERT INTO public.who_global_data_import VALUES (5087, '2020-10-15', 'AT', 'Austria', 'EURO', '1606', '59368', '9', '888');
INSERT INTO public.who_global_data_import VALUES (5088, '2020-10-16', 'AT', 'Austria', 'EURO', '1396', '60764', '6', '894');
INSERT INTO public.who_global_data_import VALUES (5089, '2020-10-17', 'AT', 'Austria', 'EURO', '1691', '62455', '7', '901');
INSERT INTO public.who_global_data_import VALUES (5090, '2020-10-18', 'AT', 'Austria', 'EURO', '2040', '64495', '6', '907');
INSERT INTO public.who_global_data_import VALUES (5091, '2020-10-19', 'AT', 'Austria', 'EURO', '1062', '65557', '3', '910');
INSERT INTO public.who_global_data_import VALUES (5092, '2020-10-20', 'AT', 'Austria', 'EURO', '1054', '66611', '9', '919');
INSERT INTO public.who_global_data_import VALUES (5093, '2020-10-21', 'AT', 'Austria', 'EURO', '1803', '68414', '8', '927');
INSERT INTO public.who_global_data_import VALUES (5094, '2020-10-22', 'AT', 'Austria', 'EURO', '2355', '70769', '13', '940');
INSERT INTO public.who_global_data_import VALUES (5095, '2020-10-23', 'AT', 'Austria', 'EURO', '2570', '73339', '17', '957');
INSERT INTO public.who_global_data_import VALUES (5096, '2020-10-24', 'AT', 'Austria', 'EURO', '3442', '76781', '15', '972');
INSERT INTO public.who_global_data_import VALUES (5097, '2020-10-25', 'AT', 'Austria', 'EURO', '2989', '79770', '6', '978');
INSERT INTO public.who_global_data_import VALUES (5098, '2020-10-26', 'AT', 'Austria', 'EURO', '2766', '82536', '6', '984');
INSERT INTO public.who_global_data_import VALUES (5099, '2020-10-27', 'AT', 'Austria', 'EURO', '2512', '85048', '4', '988');
INSERT INTO public.who_global_data_import VALUES (5100, '2020-10-28', 'AT', 'Austria', 'EURO', '2698', '87746', '18', '1006');
INSERT INTO public.who_global_data_import VALUES (5101, '2020-10-29', 'AT', 'Austria', 'EURO', '4149', '91895', '34', '1040');
INSERT INTO public.who_global_data_import VALUES (5102, '2020-10-30', 'AT', 'Austria', 'EURO', '4305', '96200', '24', '1064');
INSERT INTO public.who_global_data_import VALUES (5103, '2020-10-31', 'AT', 'Austria', 'EURO', '5243', '101443', '15', '1079');
INSERT INTO public.who_global_data_import VALUES (5104, '2020-11-01', 'AT', 'Austria', 'EURO', '5141', '106584', '18', '1097');
INSERT INTO public.who_global_data_import VALUES (5105, '2020-11-02', 'AT', 'Austria', 'EURO', '4526', '111110', '17', '1114');
INSERT INTO public.who_global_data_import VALUES (5106, '2020-11-03', 'AT', 'Austria', 'EURO', '3160', '114270', '21', '1135');
INSERT INTO public.who_global_data_import VALUES (5107, '2020-11-04', 'AT', 'Austria', 'EURO', '4445', '118715', '34', '1169');
INSERT INTO public.who_global_data_import VALUES (5108, '2020-11-05', 'AT', 'Austria', 'EURO', '6514', '125229', '35', '1204');
INSERT INTO public.who_global_data_import VALUES (5109, '2020-11-06', 'AT', 'Austria', 'EURO', '7051', '132280', '47', '1251');
INSERT INTO public.who_global_data_import VALUES (5110, '2020-11-07', 'AT', 'Austria', 'EURO', '6324', '138604', '44', '1295');
INSERT INTO public.who_global_data_import VALUES (5111, '2020-11-08', 'AT', 'Austria', 'EURO', '7898', '146502', '23', '1318');
INSERT INTO public.who_global_data_import VALUES (5112, '2020-11-09', 'AT', 'Austria', 'EURO', '6006', '152508', '17', '1335');
INSERT INTO public.who_global_data_import VALUES (5113, '2020-11-10', 'AT', 'Austria', 'EURO', '5704', '158212', '48', '1383');
INSERT INTO public.who_global_data_import VALUES (5114, '2020-11-11', 'AT', 'Austria', 'EURO', '3839', '162051', '35', '1418');
INSERT INTO public.who_global_data_import VALUES (5115, '2020-11-12', 'AT', 'Austria', 'EURO', '9643', '171694', '55', '1473');
INSERT INTO public.who_global_data_import VALUES (5116, '2020-11-13', 'AT', 'Austria', 'EURO', '10368', '182062', '37', '1510');
INSERT INTO public.who_global_data_import VALUES (5117, '2020-11-14', 'AT', 'Austria', 'EURO', '8962', '191024', '64', '1574');
INSERT INTO public.who_global_data_import VALUES (5118, '2020-11-15', 'AT', 'Austria', 'EURO', '7192', '198216', '55', '1629');
INSERT INTO public.who_global_data_import VALUES (5119, '2020-11-16', 'AT', 'Austria', 'EURO', '5278', '203494', '50', '1679');
INSERT INTO public.who_global_data_import VALUES (5120, '2020-11-17', 'AT', 'Austria', 'EURO', '4304', '207798', '62', '1741');
INSERT INTO public.who_global_data_import VALUES (5121, '2020-11-18', 'AT', 'Austria', 'EURO', '5664', '213462', '74', '1815');
INSERT INTO public.who_global_data_import VALUES (5122, '2020-11-19', 'AT', 'Austria', 'EURO', '7766', '221228', '113', '1928');
INSERT INTO public.who_global_data_import VALUES (5123, '2020-11-20', 'AT', 'Austria', 'EURO', '6830', '228058', '90', '2018');
INSERT INTO public.who_global_data_import VALUES (5124, '2020-11-21', 'AT', 'Austria', 'EURO', '6612', '234670', '79', '2097');
INSERT INTO public.who_global_data_import VALUES (5125, '2020-11-22', 'AT', 'Austria', 'EURO', '6239', '240909', '58', '2155');
INSERT INTO public.who_global_data_import VALUES (5126, '2020-11-23', 'AT', 'Austria', 'EURO', '5215', '246124', '44', '2199');
INSERT INTO public.who_global_data_import VALUES (5127, '2020-11-24', 'AT', 'Austria', 'EURO', '3090', '249214', '94', '2293');
INSERT INTO public.who_global_data_import VALUES (5128, '2020-11-25', 'AT', 'Austria', 'EURO', '4135', '253349', '115', '2408');
INSERT INTO public.who_global_data_import VALUES (5129, '2020-11-26', 'AT', 'Austria', 'EURO', '5896', '259245', '94', '2502');
INSERT INTO public.who_global_data_import VALUES (5130, '2020-11-27', 'AT', 'Austria', 'EURO', '5447', '264692', '114', '2616');
INSERT INTO public.who_global_data_import VALUES (5131, '2020-11-28', 'AT', 'Austria', 'EURO', '4818', '269510', '148', '2764');
INSERT INTO public.who_global_data_import VALUES (5132, '2020-11-29', 'AT', 'Austria', 'EURO', '4765', '274275', '58', '2822');
INSERT INTO public.who_global_data_import VALUES (5133, '2020-11-30', 'AT', 'Austria', 'EURO', '3907', '278182', '82', '2904');
INSERT INTO public.who_global_data_import VALUES (5134, '2020-12-01', 'AT', 'Austria', 'EURO', '2348', '280530', '79', '2983');
INSERT INTO public.who_global_data_import VALUES (5135, '2020-12-02', 'AT', 'Austria', 'EURO', '3464', '283994', '213', '3196');
INSERT INTO public.who_global_data_import VALUES (5136, '2020-12-03', 'AT', 'Austria', 'EURO', '3660', '287654', '133', '3329');
INSERT INTO public.who_global_data_import VALUES (5137, '2020-12-04', 'AT', 'Austria', 'EURO', '3783', '291437', '118', '3447');
INSERT INTO public.who_global_data_import VALUES (5138, '2020-12-05', 'AT', 'Austria', 'EURO', '3634', '295071', '140', '3587');
INSERT INTO public.who_global_data_import VALUES (5139, '2020-12-06', 'AT', 'Austria', 'EURO', '3160', '298231', '87', '3674');
INSERT INTO public.who_global_data_import VALUES (5140, '2020-12-07', 'AT', 'Austria', 'EURO', '2745', '300976', '58', '3732');
INSERT INTO public.who_global_data_import VALUES (5141, '2020-12-08', 'AT', 'Austria', 'EURO', '2181', '303157', '95', '3827');
INSERT INTO public.who_global_data_import VALUES (5142, '2020-12-09', 'AT', 'Austria', 'EURO', '2531', '305688', '80', '3907');
INSERT INTO public.who_global_data_import VALUES (5143, '2020-12-10', 'AT', 'Austria', 'EURO', '2913', '308601', '126', '4033');
INSERT INTO public.who_global_data_import VALUES (5144, '2020-12-11', 'AT', 'Austria', 'EURO', '2466', '311067', '125', '4158');
INSERT INTO public.who_global_data_import VALUES (5145, '2020-12-12', 'AT', 'Austria', 'EURO', '3026', '314093', '101', '4259');
INSERT INTO public.who_global_data_import VALUES (5146, '2020-12-13', 'AT', 'Austria', 'EURO', '2938', '317031', '96', '4355');
INSERT INTO public.who_global_data_import VALUES (5147, '2020-12-14', 'AT', 'Austria', 'EURO', '3005', '320036', '45', '4400');
INSERT INTO public.who_global_data_import VALUES (5148, '2020-12-15', 'AT', 'Austria', 'EURO', '2521', '322557', '110', '4510');
INSERT INTO public.who_global_data_import VALUES (5149, '2020-12-16', 'AT', 'Austria', 'EURO', '2954', '325511', '141', '4651');
INSERT INTO public.who_global_data_import VALUES (5150, '2020-12-17', 'AT', 'Austria', 'EURO', '2766', '328277', '127', '4778');
INSERT INTO public.who_global_data_import VALUES (5151, '2020-12-18', 'AT', 'Austria', 'EURO', '2180', '330457', '108', '4886');
INSERT INTO public.who_global_data_import VALUES (5152, '2020-12-19', 'AT', 'Austria', 'EURO', '1914', '332371', '131', '5017');
INSERT INTO public.who_global_data_import VALUES (5153, '2020-12-20', 'AT', 'Austria', 'EURO', '2258', '334629', '110', '5127');
INSERT INTO public.who_global_data_import VALUES (5154, '2020-12-21', 'AT', 'Austria', 'EURO', '1593', '336222', '89', '5216');
INSERT INTO public.who_global_data_import VALUES (5155, '2020-12-22', 'AT', 'Austria', 'EURO', '1218', '337440', '140', '5356');
INSERT INTO public.who_global_data_import VALUES (5156, '2020-12-23', 'AT', 'Austria', 'EURO', '2493', '339933', '114', '5470');
INSERT INTO public.who_global_data_import VALUES (5157, '2020-12-24', 'AT', 'Austria', 'EURO', '2600', '342533', '141', '5611');
INSERT INTO public.who_global_data_import VALUES (5158, '2020-12-25', 'AT', 'Austria', 'EURO', '2818', '345351', '61', '5672');
INSERT INTO public.who_global_data_import VALUES (5159, '2020-12-26', 'AT', 'Austria', 'EURO', '1750', '347101', '38', '5710');
INSERT INTO public.who_global_data_import VALUES (5160, '2020-12-27', 'AT', 'Austria', 'EURO', '1258', '348359', '42', '5752');
INSERT INTO public.who_global_data_import VALUES (5161, '2020-12-28', 'AT', 'Austria', 'EURO', '1376', '349735', '42', '5794');
INSERT INTO public.who_global_data_import VALUES (5162, '2020-12-29', 'AT', 'Austria', 'EURO', '1651', '351386', '78', '5872');
INSERT INTO public.who_global_data_import VALUES (5163, '2020-12-30', 'AT', 'Austria', 'EURO', '1836', '353222', '133', '6005');
INSERT INTO public.who_global_data_import VALUES (5164, '2020-12-31', 'AT', 'Austria', 'EURO', '3129', '356351', '81', '6086');
INSERT INTO public.who_global_data_import VALUES (5165, '2021-01-01', 'AT', 'Austria', 'EURO', '3011', '359362', '45', '6131');
INSERT INTO public.who_global_data_import VALUES (5166, '2021-01-02', 'AT', 'Austria', 'EURO', '2110', '361472', '46', '6177');
INSERT INTO public.who_global_data_import VALUES (5167, '2021-01-03', 'AT', 'Austria', 'EURO', '1491', '362963', '37', '6214');
INSERT INTO public.who_global_data_import VALUES (5168, '2021-01-04', 'AT', 'Austria', 'EURO', '1611', '364574', '39', '6253');
INSERT INTO public.who_global_data_import VALUES (5169, '2021-01-05', 'AT', 'Austria', 'EURO', '1951', '366525', '73', '6326');
INSERT INTO public.who_global_data_import VALUES (5170, '2021-01-06', 'AT', 'Austria', 'EURO', '2255', '368780', '77', '6403');
INSERT INTO public.who_global_data_import VALUES (5171, '2021-01-07', 'AT', 'Austria', 'EURO', '2877', '371657', '51', '6454');
INSERT INTO public.who_global_data_import VALUES (5172, '2021-01-08', 'AT', 'Austria', 'EURO', '2006', '373663', '50', '6504');
INSERT INTO public.who_global_data_import VALUES (5173, '2021-01-09', 'AT', 'Austria', 'EURO', '2001', '375664', '68', '6572');
INSERT INTO public.who_global_data_import VALUES (5174, '2021-01-10', 'AT', 'Austria', 'EURO', '2446', '378110', '42', '6614');
INSERT INTO public.who_global_data_import VALUES (5175, '2021-01-11', 'AT', 'Austria', 'EURO', '1597', '379707', '17', '6631');
INSERT INTO public.who_global_data_import VALUES (5176, '2021-01-12', 'AT', 'Austria', 'EURO', '1328', '381035', '71', '6702');
INSERT INTO public.who_global_data_import VALUES (5177, '2021-01-13', 'AT', 'Austria', 'EURO', '1728', '382763', '80', '6782');
INSERT INTO public.who_global_data_import VALUES (5178, '2021-01-14', 'AT', 'Austria', 'EURO', '2246', '385009', '44', '6826');
INSERT INTO public.who_global_data_import VALUES (5179, '2021-01-15', 'AT', 'Austria', 'EURO', '1514', '386523', '54', '6880');
INSERT INTO public.who_global_data_import VALUES (5180, '2021-01-16', 'AT', 'Austria', 'EURO', '1472', '387995', '51', '6931');
INSERT INTO public.who_global_data_import VALUES (5181, '2021-01-17', 'AT', 'Austria', 'EURO', '1757', '389752', '33', '6964');
INSERT INTO public.who_global_data_import VALUES (5182, '2021-01-18', 'AT', 'Austria', 'EURO', '1361', '391113', '50', '7014');
INSERT INTO public.who_global_data_import VALUES (5183, '2021-01-19', 'AT', 'Austria', 'EURO', '868', '391981', '55', '7069');
INSERT INTO public.who_global_data_import VALUES (5184, '2021-01-20', 'AT', 'Austria', 'EURO', '1463', '393444', '58', '7127');
INSERT INTO public.who_global_data_import VALUES (5185, '2021-01-21', 'AT', 'Austria', 'EURO', '1634', '395078', '38', '7165');
INSERT INTO public.who_global_data_import VALUES (5186, '2021-01-22', 'AT', 'Austria', 'EURO', '1779', '396857', '57', '7222');
INSERT INTO public.who_global_data_import VALUES (5187, '2021-01-23', 'AT', 'Austria', 'EURO', '1779', '398636', '66', '7288');
INSERT INTO public.who_global_data_import VALUES (5188, '2021-01-24', 'AT', 'Austria', 'EURO', '1551', '400187', '30', '7318');
INSERT INTO public.who_global_data_import VALUES (5189, '2021-01-25', 'AT', 'Austria', 'EURO', '1347', '401534', '44', '7362');
INSERT INTO public.who_global_data_import VALUES (5190, '2021-01-26', 'AT', 'Austria', 'EURO', '944', '402478', '54', '7416');
INSERT INTO public.who_global_data_import VALUES (5191, '2021-01-27', 'AT', 'Austria', 'EURO', '1445', '403923', '46', '7462');
INSERT INTO public.who_global_data_import VALUES (5192, '2021-01-28', 'AT', 'Austria', 'EURO', '1606', '405529', '53', '7515');
INSERT INTO public.who_global_data_import VALUES (5193, '2021-01-29', 'AT', 'Austria', 'EURO', '1238', '406767', '43', '7558');
INSERT INTO public.who_global_data_import VALUES (5194, '2021-01-30', 'AT', 'Austria', 'EURO', '1606', '408373', '47', '7605');
INSERT INTO public.who_global_data_import VALUES (5195, '2021-01-31', 'AT', 'Austria', 'EURO', '1519', '409892', '31', '7636');
INSERT INTO public.who_global_data_import VALUES (5196, '2021-02-01', 'AT', 'Austria', 'EURO', '1093', '410985', '17', '7653');
INSERT INTO public.who_global_data_import VALUES (5197, '2021-02-02', 'AT', 'Austria', 'EURO', '936', '411921', '57', '7710');
INSERT INTO public.who_global_data_import VALUES (5198, '2021-02-03', 'AT', 'Austria', 'EURO', '1318', '413239', '39', '7749');
INSERT INTO public.who_global_data_import VALUES (5199, '2021-02-04', 'AT', 'Austria', 'EURO', '1686', '414925', '51', '7800');
INSERT INTO public.who_global_data_import VALUES (5200, '2021-02-05', 'AT', 'Austria', 'EURO', '1444', '416369', '28', '7828');
INSERT INTO public.who_global_data_import VALUES (5201, '2020-01-03', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5202, '2020-01-04', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5203, '2020-01-05', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5204, '2020-01-06', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5205, '2020-01-07', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5206, '2020-01-08', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5207, '2020-01-09', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5208, '2020-01-10', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5209, '2020-01-11', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5210, '2020-01-12', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5211, '2020-01-13', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5212, '2020-01-14', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5213, '2020-01-15', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5214, '2020-01-16', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5215, '2020-01-17', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5216, '2020-01-18', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5217, '2020-01-19', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5218, '2020-01-20', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5219, '2020-01-21', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5220, '2020-01-22', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5221, '2020-01-23', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5222, '2020-01-24', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5223, '2020-01-25', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5224, '2020-01-26', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5225, '2020-01-27', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5226, '2020-01-28', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5227, '2020-01-29', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5228, '2020-01-30', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5229, '2020-01-31', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5230, '2020-02-01', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5231, '2020-02-02', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5232, '2020-02-03', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5233, '2020-02-04', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5234, '2020-02-05', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5235, '2020-02-06', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5236, '2020-02-07', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5237, '2020-02-08', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5238, '2020-02-09', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5239, '2020-02-10', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5240, '2020-02-11', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5241, '2020-02-12', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5242, '2020-02-13', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5243, '2020-02-14', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5244, '2020-02-15', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5245, '2020-02-16', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5246, '2020-02-17', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5247, '2020-02-18', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5248, '2020-02-19', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5249, '2020-02-20', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5250, '2020-02-21', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5251, '2020-02-22', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5252, '2020-02-23', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5253, '2020-02-24', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5254, '2020-02-25', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5255, '2020-02-26', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5256, '2020-02-27', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5257, '2020-02-28', 'AZ', 'Azerbaijan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5258, '2020-02-29', 'AZ', 'Azerbaijan', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5259, '2020-03-01', 'AZ', 'Azerbaijan', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5260, '2020-03-02', 'AZ', 'Azerbaijan', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5261, '2020-03-03', 'AZ', 'Azerbaijan', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5262, '2020-03-04', 'AZ', 'Azerbaijan', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5263, '2020-03-05', 'AZ', 'Azerbaijan', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5264, '2020-03-06', 'AZ', 'Azerbaijan', 'EURO', '3', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5265, '2020-03-07', 'AZ', 'Azerbaijan', 'EURO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5266, '2020-03-08', 'AZ', 'Azerbaijan', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5267, '2020-03-09', 'AZ', 'Azerbaijan', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5268, '2020-03-10', 'AZ', 'Azerbaijan', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5269, '2020-03-11', 'AZ', 'Azerbaijan', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5270, '2020-03-12', 'AZ', 'Azerbaijan', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5271, '2020-03-13', 'AZ', 'Azerbaijan', 'EURO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5272, '2020-03-14', 'AZ', 'Azerbaijan', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5273, '2020-03-15', 'AZ', 'Azerbaijan', 'EURO', '8', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5274, '2020-03-16', 'AZ', 'Azerbaijan', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5275, '2020-03-17', 'AZ', 'Azerbaijan', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5276, '2020-03-18', 'AZ', 'Azerbaijan', 'EURO', '9', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5277, '2020-03-19', 'AZ', 'Azerbaijan', 'EURO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5278, '2020-03-20', 'AZ', 'Azerbaijan', 'EURO', '6', '34', '1', '1');
INSERT INTO public.who_global_data_import VALUES (5279, '2020-03-21', 'AZ', 'Azerbaijan', 'EURO', '19', '53', '0', '1');
INSERT INTO public.who_global_data_import VALUES (5280, '2020-03-22', 'AZ', 'Azerbaijan', 'EURO', '0', '53', '0', '1');
INSERT INTO public.who_global_data_import VALUES (5281, '2020-03-23', 'AZ', 'Azerbaijan', 'EURO', '19', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (5282, '2020-03-24', 'AZ', 'Azerbaijan', 'EURO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (5283, '2020-03-25', 'AZ', 'Azerbaijan', 'EURO', '15', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (5284, '2020-03-26', 'AZ', 'Azerbaijan', 'EURO', '6', '93', '1', '2');
INSERT INTO public.who_global_data_import VALUES (5285, '2020-03-27', 'AZ', 'Azerbaijan', 'EURO', '29', '122', '1', '3');
INSERT INTO public.who_global_data_import VALUES (5286, '2020-03-28', 'AZ', 'Azerbaijan', 'EURO', '25', '147', '0', '3');
INSERT INTO public.who_global_data_import VALUES (5287, '2020-03-29', 'AZ', 'Azerbaijan', 'EURO', '17', '164', '1', '4');
INSERT INTO public.who_global_data_import VALUES (5288, '2020-03-30', 'AZ', 'Azerbaijan', 'EURO', '26', '190', '0', '4');
INSERT INTO public.who_global_data_import VALUES (5289, '2020-03-31', 'AZ', 'Azerbaijan', 'EURO', '83', '273', '0', '4');
INSERT INTO public.who_global_data_import VALUES (5290, '2020-04-01', 'AZ', 'Azerbaijan', 'EURO', '25', '298', '1', '5');
INSERT INTO public.who_global_data_import VALUES (5291, '2020-04-02', 'AZ', 'Azerbaijan', 'EURO', '61', '359', '0', '5');
INSERT INTO public.who_global_data_import VALUES (5292, '2020-04-03', 'AZ', 'Azerbaijan', 'EURO', '41', '400', '0', '5');
INSERT INTO public.who_global_data_import VALUES (5293, '2020-04-04', 'AZ', 'Azerbaijan', 'EURO', '43', '443', '0', '5');
INSERT INTO public.who_global_data_import VALUES (5294, '2020-04-05', 'AZ', 'Azerbaijan', 'EURO', '69', '512', '0', '5');
INSERT INTO public.who_global_data_import VALUES (5295, '2020-04-06', 'AZ', 'Azerbaijan', 'EURO', '72', '584', '0', '5');
INSERT INTO public.who_global_data_import VALUES (5296, '2020-04-07', 'AZ', 'Azerbaijan', 'EURO', '57', '641', '2', '7');
INSERT INTO public.who_global_data_import VALUES (5297, '2020-04-08', 'AZ', 'Azerbaijan', 'EURO', '76', '717', '1', '8');
INSERT INTO public.who_global_data_import VALUES (5298, '2020-04-09', 'AZ', 'Azerbaijan', 'EURO', '105', '822', '0', '8');
INSERT INTO public.who_global_data_import VALUES (5299, '2020-04-10', 'AZ', 'Azerbaijan', 'EURO', '104', '926', '1', '9');
INSERT INTO public.who_global_data_import VALUES (5300, '2020-04-11', 'AZ', 'Azerbaijan', 'EURO', '65', '991', '1', '10');
INSERT INTO public.who_global_data_import VALUES (5301, '2020-04-12', 'AZ', 'Azerbaijan', 'EURO', '67', '1058', '1', '11');
INSERT INTO public.who_global_data_import VALUES (5302, '2020-04-13', 'AZ', 'Azerbaijan', 'EURO', '40', '1098', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5303, '2020-04-14', 'AZ', 'Azerbaijan', 'EURO', '50', '1148', '1', '12');
INSERT INTO public.who_global_data_import VALUES (5304, '2020-04-15', 'AZ', 'Azerbaijan', 'EURO', '49', '1197', '1', '13');
INSERT INTO public.who_global_data_import VALUES (5305, '2020-04-16', 'AZ', 'Azerbaijan', 'EURO', '56', '1253', '0', '13');
INSERT INTO public.who_global_data_import VALUES (5306, '2020-04-17', 'AZ', 'Azerbaijan', 'EURO', '30', '1283', '2', '15');
INSERT INTO public.who_global_data_import VALUES (5307, '2020-04-18', 'AZ', 'Azerbaijan', 'EURO', '57', '1340', '0', '15');
INSERT INTO public.who_global_data_import VALUES (5308, '2020-04-19', 'AZ', 'Azerbaijan', 'EURO', '33', '1373', '3', '18');
INSERT INTO public.who_global_data_import VALUES (5309, '2020-04-20', 'AZ', 'Azerbaijan', 'EURO', '25', '1398', '1', '19');
INSERT INTO public.who_global_data_import VALUES (5310, '2020-04-21', 'AZ', 'Azerbaijan', 'EURO', '38', '1436', '0', '19');
INSERT INTO public.who_global_data_import VALUES (5311, '2020-04-22', 'AZ', 'Azerbaijan', 'EURO', '44', '1480', '1', '20');
INSERT INTO public.who_global_data_import VALUES (5312, '2020-04-23', 'AZ', 'Azerbaijan', 'EURO', '38', '1518', '0', '20');
INSERT INTO public.who_global_data_import VALUES (5313, '2020-04-24', 'AZ', 'Azerbaijan', 'EURO', '30', '1548', '0', '20');
INSERT INTO public.who_global_data_import VALUES (5314, '2020-04-25', 'AZ', 'Azerbaijan', 'EURO', '44', '1592', '1', '21');
INSERT INTO public.who_global_data_import VALUES (5315, '2020-04-26', 'AZ', 'Azerbaijan', 'EURO', '25', '1617', '0', '21');
INSERT INTO public.who_global_data_import VALUES (5316, '2020-04-27', 'AZ', 'Azerbaijan', 'EURO', '28', '1645', '0', '21');
INSERT INTO public.who_global_data_import VALUES (5317, '2020-04-28', 'AZ', 'Azerbaijan', 'EURO', '33', '1678', '1', '22');
INSERT INTO public.who_global_data_import VALUES (5318, '2020-04-29', 'AZ', 'Azerbaijan', 'EURO', '39', '1717', '0', '22');
INSERT INTO public.who_global_data_import VALUES (5319, '2020-04-30', 'AZ', 'Azerbaijan', 'EURO', '49', '1766', '1', '23');
INSERT INTO public.who_global_data_import VALUES (5320, '2020-05-01', 'AZ', 'Azerbaijan', 'EURO', '38', '1804', '1', '24');
INSERT INTO public.who_global_data_import VALUES (5321, '2020-05-02', 'AZ', 'Azerbaijan', 'EURO', '50', '1854', '1', '25');
INSERT INTO public.who_global_data_import VALUES (5322, '2020-05-03', 'AZ', 'Azerbaijan', 'EURO', '40', '1894', '0', '25');
INSERT INTO public.who_global_data_import VALUES (5323, '2020-05-04', 'AZ', 'Azerbaijan', 'EURO', '38', '1932', '0', '25');
INSERT INTO public.who_global_data_import VALUES (5324, '2020-05-05', 'AZ', 'Azerbaijan', 'EURO', '52', '1984', '1', '26');
INSERT INTO public.who_global_data_import VALUES (5325, '2020-05-06', 'AZ', 'Azerbaijan', 'EURO', '76', '2060', '0', '26');
INSERT INTO public.who_global_data_import VALUES (5326, '2020-05-07', 'AZ', 'Azerbaijan', 'EURO', '67', '2127', '2', '28');
INSERT INTO public.who_global_data_import VALUES (5327, '2020-05-08', 'AZ', 'Azerbaijan', 'EURO', '77', '2204', '0', '28');
INSERT INTO public.who_global_data_import VALUES (5328, '2020-05-09', 'AZ', 'Azerbaijan', 'EURO', '75', '2279', '0', '28');
INSERT INTO public.who_global_data_import VALUES (5329, '2020-05-10', 'AZ', 'Azerbaijan', 'EURO', '143', '2422', '3', '31');
INSERT INTO public.who_global_data_import VALUES (5330, '2020-05-11', 'AZ', 'Azerbaijan', 'EURO', '97', '2519', '1', '32');
INSERT INTO public.who_global_data_import VALUES (5331, '2020-05-12', 'AZ', 'Azerbaijan', 'EURO', '70', '2589', '0', '32');
INSERT INTO public.who_global_data_import VALUES (5332, '2020-05-13', 'AZ', 'Azerbaijan', 'EURO', '104', '2693', '1', '33');
INSERT INTO public.who_global_data_import VALUES (5333, '2020-05-14', 'AZ', 'Azerbaijan', 'EURO', '65', '2758', '2', '35');
INSERT INTO public.who_global_data_import VALUES (5334, '2020-05-15', 'AZ', 'Azerbaijan', 'EURO', '121', '2879', '0', '35');
INSERT INTO public.who_global_data_import VALUES (5335, '2020-05-16', 'AZ', 'Azerbaijan', 'EURO', '101', '2980', '1', '36');
INSERT INTO public.who_global_data_import VALUES (5336, '2020-05-17', 'AZ', 'Azerbaijan', 'EURO', '158', '3138', '0', '36');
INSERT INTO public.who_global_data_import VALUES (5337, '2020-05-18', 'AZ', 'Azerbaijan', 'EURO', '136', '3274', '3', '39');
INSERT INTO public.who_global_data_import VALUES (5338, '2020-05-19', 'AZ', 'Azerbaijan', 'EURO', '113', '3387', '1', '40');
INSERT INTO public.who_global_data_import VALUES (5339, '2020-05-20', 'AZ', 'Azerbaijan', 'EURO', '131', '3518', '1', '41');
INSERT INTO public.who_global_data_import VALUES (5340, '2020-05-21', 'AZ', 'Azerbaijan', 'EURO', '113', '3631', '2', '43');
INSERT INTO public.who_global_data_import VALUES (5341, '2020-05-22', 'AZ', 'Azerbaijan', 'EURO', '118', '3749', '1', '44');
INSERT INTO public.who_global_data_import VALUES (5342, '2020-05-23', 'AZ', 'Azerbaijan', 'EURO', '106', '3855', '2', '46');
INSERT INTO public.who_global_data_import VALUES (5343, '2020-05-24', 'AZ', 'Azerbaijan', 'EURO', '127', '3982', '3', '49');
INSERT INTO public.who_global_data_import VALUES (5344, '2020-05-25', 'AZ', 'Azerbaijan', 'EURO', '140', '4122', '0', '49');
INSERT INTO public.who_global_data_import VALUES (5345, '2020-05-26', 'AZ', 'Azerbaijan', 'EURO', '149', '4271', '2', '51');
INSERT INTO public.who_global_data_import VALUES (5346, '2020-05-27', 'AZ', 'Azerbaijan', 'EURO', '132', '4403', '1', '52');
INSERT INTO public.who_global_data_import VALUES (5347, '2020-05-28', 'AZ', 'Azerbaijan', 'EURO', '165', '4568', '2', '54');
INSERT INTO public.who_global_data_import VALUES (5348, '2020-05-29', 'AZ', 'Azerbaijan', 'EURO', '191', '4759', '2', '56');
INSERT INTO public.who_global_data_import VALUES (5349, '2020-05-30', 'AZ', 'Azerbaijan', 'EURO', '230', '4989', '2', '58');
INSERT INTO public.who_global_data_import VALUES (5350, '2020-05-31', 'AZ', 'Azerbaijan', 'EURO', '257', '5246', '3', '61');
INSERT INTO public.who_global_data_import VALUES (5351, '2020-06-01', 'AZ', 'Azerbaijan', 'EURO', '248', '5494', '2', '63');
INSERT INTO public.who_global_data_import VALUES (5352, '2020-06-02', 'AZ', 'Azerbaijan', 'EURO', '168', '5662', '5', '68');
INSERT INTO public.who_global_data_import VALUES (5353, '2020-06-03', 'AZ', 'Azerbaijan', 'EURO', '273', '5935', '3', '71');
INSERT INTO public.who_global_data_import VALUES (5354, '2020-06-04', 'AZ', 'Azerbaijan', 'EURO', '325', '6260', '5', '76');
INSERT INTO public.who_global_data_import VALUES (5355, '2020-06-05', 'AZ', 'Azerbaijan', 'EURO', '262', '6522', '2', '78');
INSERT INTO public.who_global_data_import VALUES (5356, '2020-06-06', 'AZ', 'Azerbaijan', 'EURO', '338', '6860', '4', '82');
INSERT INTO public.who_global_data_import VALUES (5357, '2020-06-07', 'AZ', 'Azerbaijan', 'EURO', '379', '7239', '2', '84');
INSERT INTO public.who_global_data_import VALUES (5358, '2020-06-08', 'AZ', 'Azerbaijan', 'EURO', '314', '7553', '4', '88');
INSERT INTO public.who_global_data_import VALUES (5359, '2020-06-09', 'AZ', 'Azerbaijan', 'EURO', '323', '7876', '5', '93');
INSERT INTO public.who_global_data_import VALUES (5360, '2020-06-10', 'AZ', 'Azerbaijan', 'EURO', '315', '8191', '5', '98');
INSERT INTO public.who_global_data_import VALUES (5361, '2020-06-11', 'AZ', 'Azerbaijan', 'EURO', '339', '8530', '4', '102');
INSERT INTO public.who_global_data_import VALUES (5362, '2020-06-12', 'AZ', 'Azerbaijan', 'EURO', '352', '8882', '6', '108');
INSERT INTO public.who_global_data_import VALUES (5363, '2020-06-13', 'AZ', 'Azerbaijan', 'EURO', '336', '9218', '5', '113');
INSERT INTO public.who_global_data_import VALUES (5364, '2020-06-14', 'AZ', 'Azerbaijan', 'EURO', '352', '9570', '2', '115');
INSERT INTO public.who_global_data_import VALUES (5365, '2020-06-15', 'AZ', 'Azerbaijan', 'EURO', '387', '9957', '4', '119');
INSERT INTO public.who_global_data_import VALUES (5366, '2020-06-16', 'AZ', 'Azerbaijan', 'EURO', '367', '10324', '3', '122');
INSERT INTO public.who_global_data_import VALUES (5367, '2020-06-17', 'AZ', 'Azerbaijan', 'EURO', '338', '10662', '4', '126');
INSERT INTO public.who_global_data_import VALUES (5368, '2020-06-18', 'AZ', 'Azerbaijan', 'EURO', '329', '10991', '7', '133');
INSERT INTO public.who_global_data_import VALUES (5369, '2020-06-19', 'AZ', 'Azerbaijan', 'EURO', '338', '11329', '6', '139');
INSERT INTO public.who_global_data_import VALUES (5370, '2020-06-20', 'AZ', 'Azerbaijan', 'EURO', '438', '11767', '4', '143');
INSERT INTO public.who_global_data_import VALUES (5371, '2020-06-21', 'AZ', 'Azerbaijan', 'EURO', '471', '12238', '5', '148');
INSERT INTO public.who_global_data_import VALUES (5372, '2020-06-22', 'AZ', 'Azerbaijan', 'EURO', '491', '12729', '6', '154');
INSERT INTO public.who_global_data_import VALUES (5373, '2020-06-23', 'AZ', 'Azerbaijan', 'EURO', '478', '13207', '7', '161');
INSERT INTO public.who_global_data_import VALUES (5374, '2020-06-24', 'AZ', 'Azerbaijan', 'EURO', '508', '13715', '6', '167');
INSERT INTO public.who_global_data_import VALUES (5375, '2020-06-25', 'AZ', 'Azerbaijan', 'EURO', '590', '14305', '7', '174');
INSERT INTO public.who_global_data_import VALUES (5376, '2020-06-26', 'AZ', 'Azerbaijan', 'EURO', '547', '14852', '6', '180');
INSERT INTO public.who_global_data_import VALUES (5377, '2020-06-27', 'AZ', 'Azerbaijan', 'EURO', '517', '15369', '7', '187');
INSERT INTO public.who_global_data_import VALUES (5378, '2020-06-28', 'AZ', 'Azerbaijan', 'EURO', '521', '15890', '6', '193');
INSERT INTO public.who_global_data_import VALUES (5379, '2020-06-29', 'AZ', 'Azerbaijan', 'EURO', '534', '16424', '5', '198');
INSERT INTO public.who_global_data_import VALUES (5380, '2020-06-30', 'AZ', 'Azerbaijan', 'EURO', '544', '16968', '8', '206');
INSERT INTO public.who_global_data_import VALUES (5381, '2020-07-01', 'AZ', 'Azerbaijan', 'EURO', '556', '17524', '7', '213');
INSERT INTO public.who_global_data_import VALUES (5382, '2020-07-02', 'AZ', 'Azerbaijan', 'EURO', '588', '18112', '7', '220');
INSERT INTO public.who_global_data_import VALUES (5383, '2020-07-03', 'AZ', 'Azerbaijan', 'EURO', '572', '18684', '8', '228');
INSERT INTO public.who_global_data_import VALUES (5384, '2020-07-04', 'AZ', 'Azerbaijan', 'EURO', '583', '19267', '7', '235');
INSERT INTO public.who_global_data_import VALUES (5385, '2020-07-05', 'AZ', 'Azerbaijan', 'EURO', '534', '19801', '6', '241');
INSERT INTO public.who_global_data_import VALUES (5386, '2020-07-06', 'AZ', 'Azerbaijan', 'EURO', '523', '20324', '9', '250');
INSERT INTO public.who_global_data_import VALUES (5387, '2020-07-07', 'AZ', 'Azerbaijan', 'EURO', '513', '20837', '8', '258');
INSERT INTO public.who_global_data_import VALUES (5388, '2020-07-08', 'AZ', 'Azerbaijan', 'EURO', '537', '21374', '7', '265');
INSERT INTO public.who_global_data_import VALUES (5389, '2020-07-09', 'AZ', 'Azerbaijan', 'EURO', '542', '21916', '9', '274');
INSERT INTO public.who_global_data_import VALUES (5390, '2020-07-10', 'AZ', 'Azerbaijan', 'EURO', '548', '22464', '10', '284');
INSERT INTO public.who_global_data_import VALUES (5391, '2020-07-11', 'AZ', 'Azerbaijan', 'EURO', '526', '22990', '8', '292');
INSERT INTO public.who_global_data_import VALUES (5392, '2020-07-12', 'AZ', 'Azerbaijan', 'EURO', '531', '23521', '6', '298');
INSERT INTO public.who_global_data_import VALUES (5393, '2020-07-13', 'AZ', 'Azerbaijan', 'EURO', '520', '24041', '8', '306');
INSERT INTO public.who_global_data_import VALUES (5394, '2020-07-14', 'AZ', 'Azerbaijan', 'EURO', '529', '24570', '7', '313');
INSERT INTO public.who_global_data_import VALUES (5395, '2020-07-15', 'AZ', 'Azerbaijan', 'EURO', '543', '25113', '6', '319');
INSERT INTO public.who_global_data_import VALUES (5396, '2020-07-16', 'AZ', 'Azerbaijan', 'EURO', '559', '25672', '7', '326');
INSERT INTO public.who_global_data_import VALUES (5397, '2020-07-17', 'AZ', 'Azerbaijan', 'EURO', '493', '26165', '8', '334');
INSERT INTO public.who_global_data_import VALUES (5398, '2020-07-18', 'AZ', 'Azerbaijan', 'EURO', '471', '26636', '7', '341');
INSERT INTO public.who_global_data_import VALUES (5399, '2020-07-19', 'AZ', 'Azerbaijan', 'EURO', '497', '27133', '8', '349');
INSERT INTO public.who_global_data_import VALUES (5400, '2020-07-20', 'AZ', 'Azerbaijan', 'EURO', '388', '27521', '5', '354');
INSERT INTO public.who_global_data_import VALUES (5401, '2020-07-21', 'AZ', 'Azerbaijan', 'EURO', '369', '27890', '9', '363');
INSERT INTO public.who_global_data_import VALUES (5402, '2020-07-22', 'AZ', 'Azerbaijan', 'EURO', '352', '28242', '13', '376');
INSERT INTO public.who_global_data_import VALUES (5403, '2020-07-23', 'AZ', 'Azerbaijan', 'EURO', '391', '28633', '9', '385');
INSERT INTO public.who_global_data_import VALUES (5404, '2020-07-24', 'AZ', 'Azerbaijan', 'EURO', '347', '28980', '6', '391');
INSERT INTO public.who_global_data_import VALUES (5405, '2020-07-25', 'AZ', 'Azerbaijan', 'EURO', '332', '29312', '9', '400');
INSERT INTO public.who_global_data_import VALUES (5406, '2020-07-26', 'AZ', 'Azerbaijan', 'EURO', '321', '29633', '8', '408');
INSERT INTO public.who_global_data_import VALUES (5407, '2020-07-27', 'AZ', 'Azerbaijan', 'EURO', '417', '30050', '9', '417');
INSERT INTO public.who_global_data_import VALUES (5408, '2020-07-28', 'AZ', 'Azerbaijan', 'EURO', '396', '30446', '6', '423');
INSERT INTO public.who_global_data_import VALUES (5409, '2020-07-29', 'AZ', 'Azerbaijan', 'EURO', '412', '30858', '7', '430');
INSERT INTO public.who_global_data_import VALUES (5410, '2020-07-30', 'AZ', 'Azerbaijan', 'EURO', '363', '31221', '8', '438');
INSERT INTO public.who_global_data_import VALUES (5411, '2020-07-31', 'AZ', 'Azerbaijan', 'EURO', '339', '31560', '3', '441');
INSERT INTO public.who_global_data_import VALUES (5412, '2020-08-01', 'AZ', 'Azerbaijan', 'EURO', '318', '31878', '7', '448');
INSERT INTO public.who_global_data_import VALUES (5413, '2020-08-02', 'AZ', 'Azerbaijan', 'EURO', '279', '32157', '6', '454');
INSERT INTO public.who_global_data_import VALUES (5414, '2020-08-03', 'AZ', 'Azerbaijan', 'EURO', '286', '32443', '8', '462');
INSERT INTO public.who_global_data_import VALUES (5415, '2020-08-04', 'AZ', 'Azerbaijan', 'EURO', '241', '32684', '6', '468');
INSERT INTO public.who_global_data_import VALUES (5416, '2020-08-05', 'AZ', 'Azerbaijan', 'EURO', '226', '32910', '5', '473');
INSERT INTO public.who_global_data_import VALUES (5417, '2020-08-06', 'AZ', 'Azerbaijan', 'EURO', '193', '33103', '3', '476');
INSERT INTO public.who_global_data_import VALUES (5418, '2020-08-07', 'AZ', 'Azerbaijan', 'EURO', '144', '33247', '3', '479');
INSERT INTO public.who_global_data_import VALUES (5419, '2020-08-08', 'AZ', 'Azerbaijan', 'EURO', '129', '33376', '4', '483');
INSERT INTO public.who_global_data_import VALUES (5420, '2020-08-09', 'AZ', 'Azerbaijan', 'EURO', '105', '33481', '5', '488');
INSERT INTO public.who_global_data_import VALUES (5421, '2020-08-10', 'AZ', 'Azerbaijan', 'EURO', '87', '33568', '2', '490');
INSERT INTO public.who_global_data_import VALUES (5422, '2020-08-11', 'AZ', 'Azerbaijan', 'EURO', '79', '33647', '2', '492');
INSERT INTO public.who_global_data_import VALUES (5423, '2020-08-12', 'AZ', 'Azerbaijan', 'EURO', '84', '33731', '3', '495');
INSERT INTO public.who_global_data_import VALUES (5424, '2020-08-13', 'AZ', 'Azerbaijan', 'EURO', '93', '33824', '2', '497');
INSERT INTO public.who_global_data_import VALUES (5425, '2020-08-14', 'AZ', 'Azerbaijan', 'EURO', '91', '33915', '3', '500');
INSERT INTO public.who_global_data_import VALUES (5426, '2020-08-15', 'AZ', 'Azerbaijan', 'EURO', '103', '34018', '4', '504');
INSERT INTO public.who_global_data_import VALUES (5427, '2020-08-16', 'AZ', 'Azerbaijan', 'EURO', '89', '34107', '2', '506');
INSERT INTO public.who_global_data_import VALUES (5428, '2020-08-17', 'AZ', 'Azerbaijan', 'EURO', '112', '34219', '0', '506');
INSERT INTO public.who_global_data_import VALUES (5429, '2020-08-18', 'AZ', 'Azerbaijan', 'EURO', '124', '34343', '2', '508');
INSERT INTO public.who_global_data_import VALUES (5430, '2020-08-19', 'AZ', 'Azerbaijan', 'EURO', '131', '34474', '1', '509');
INSERT INTO public.who_global_data_import VALUES (5431, '2020-08-20', 'AZ', 'Azerbaijan', 'EURO', '146', '34620', '1', '510');
INSERT INTO public.who_global_data_import VALUES (5432, '2020-08-21', 'AZ', 'Azerbaijan', 'EURO', '139', '34759', '0', '510');
INSERT INTO public.who_global_data_import VALUES (5433, '2020-08-22', 'AZ', 'Azerbaijan', 'EURO', '162', '34921', '2', '512');
INSERT INTO public.who_global_data_import VALUES (5434, '2020-08-23', 'AZ', 'Azerbaijan', 'EURO', '184', '35105', '3', '515');
INSERT INTO public.who_global_data_import VALUES (5435, '2020-08-24', 'AZ', 'Azerbaijan', 'EURO', '169', '35274', '3', '518');
INSERT INTO public.who_global_data_import VALUES (5436, '2020-08-25', 'AZ', 'Azerbaijan', 'EURO', '152', '35426', '1', '519');
INSERT INTO public.who_global_data_import VALUES (5437, '2020-08-26', 'AZ', 'Azerbaijan', 'EURO', '133', '35559', '2', '521');
INSERT INTO public.who_global_data_import VALUES (5438, '2020-08-27', 'AZ', 'Azerbaijan', 'EURO', '148', '35707', '1', '522');
INSERT INTO public.who_global_data_import VALUES (5439, '2020-08-28', 'AZ', 'Azerbaijan', 'EURO', '137', '35844', '2', '524');
INSERT INTO public.who_global_data_import VALUES (5440, '2020-08-29', 'AZ', 'Azerbaijan', 'EURO', '142', '35986', '3', '527');
INSERT INTO public.who_global_data_import VALUES (5441, '2020-08-30', 'AZ', 'Azerbaijan', 'EURO', '188', '36174', '2', '529');
INSERT INTO public.who_global_data_import VALUES (5442, '2020-08-31', 'AZ', 'Azerbaijan', 'EURO', '135', '36309', '2', '531');
INSERT INTO public.who_global_data_import VALUES (5443, '2020-09-01', 'AZ', 'Azerbaijan', 'EURO', '126', '36435', '3', '534');
INSERT INTO public.who_global_data_import VALUES (5444, '2020-09-02', 'AZ', 'Azerbaijan', 'EURO', '143', '36578', '2', '536');
INSERT INTO public.who_global_data_import VALUES (5445, '2020-09-03', 'AZ', 'Azerbaijan', 'EURO', '154', '36732', '2', '538');
INSERT INTO public.who_global_data_import VALUES (5446, '2020-09-04', 'AZ', 'Azerbaijan', 'EURO', '167', '36899', '3', '541');
INSERT INTO public.who_global_data_import VALUES (5447, '2020-09-05', 'AZ', 'Azerbaijan', 'EURO', '132', '37031', '2', '543');
INSERT INTO public.who_global_data_import VALUES (5448, '2020-09-06', 'AZ', 'Azerbaijan', 'EURO', '161', '37192', '2', '545');
INSERT INTO public.who_global_data_import VALUES (5449, '2020-09-07', 'AZ', 'Azerbaijan', 'EURO', '137', '37329', '3', '548');
INSERT INTO public.who_global_data_import VALUES (5450, '2020-09-08', 'AZ', 'Azerbaijan', 'EURO', '89', '37418', '3', '551');
INSERT INTO public.who_global_data_import VALUES (5451, '2020-09-09', 'AZ', 'Azerbaijan', 'EURO', '139', '37557', '1', '552');
INSERT INTO public.who_global_data_import VALUES (5452, '2020-09-10', 'AZ', 'Azerbaijan', 'EURO', '175', '37732', '3', '555');
INSERT INTO public.who_global_data_import VALUES (5453, '2020-09-11', 'AZ', 'Azerbaijan', 'EURO', '142', '37874', '1', '556');
INSERT INTO public.who_global_data_import VALUES (5454, '2020-09-12', 'AZ', 'Azerbaijan', 'EURO', '163', '38037', '1', '557');
INSERT INTO public.who_global_data_import VALUES (5455, '2020-09-13', 'AZ', 'Azerbaijan', 'EURO', '135', '38172', '2', '559');
INSERT INTO public.who_global_data_import VALUES (5456, '2020-09-14', 'AZ', 'Azerbaijan', 'EURO', '155', '38327', '3', '562');
INSERT INTO public.who_global_data_import VALUES (5457, '2020-09-15', 'AZ', 'Azerbaijan', 'EURO', '76', '38403', '2', '564');
INSERT INTO public.who_global_data_import VALUES (5458, '2020-09-16', 'AZ', 'Azerbaijan', 'EURO', '114', '38517', '2', '566');
INSERT INTO public.who_global_data_import VALUES (5459, '2020-09-17', 'AZ', 'Azerbaijan', 'EURO', '141', '38658', '3', '569');
INSERT INTO public.who_global_data_import VALUES (5460, '2020-09-18', 'AZ', 'Azerbaijan', 'EURO', '119', '38777', '2', '571');
INSERT INTO public.who_global_data_import VALUES (5461, '2020-09-19', 'AZ', 'Azerbaijan', 'EURO', '117', '38894', '1', '572');
INSERT INTO public.who_global_data_import VALUES (5462, '2020-09-20', 'AZ', 'Azerbaijan', 'EURO', '148', '39042', '2', '574');
INSERT INTO public.who_global_data_import VALUES (5463, '2020-09-21', 'AZ', 'Azerbaijan', 'EURO', '146', '39188', '1', '575');
INSERT INTO public.who_global_data_import VALUES (5464, '2020-09-22', 'AZ', 'Azerbaijan', 'EURO', '92', '39280', '1', '576');
INSERT INTO public.who_global_data_import VALUES (5465, '2020-09-23', 'AZ', 'Azerbaijan', 'EURO', '98', '39378', '2', '578');
INSERT INTO public.who_global_data_import VALUES (5466, '2020-09-24', 'AZ', 'Azerbaijan', 'EURO', '146', '39524', '2', '580');
INSERT INTO public.who_global_data_import VALUES (5467, '2020-09-25', 'AZ', 'Azerbaijan', 'EURO', '162', '39686', '1', '581');
INSERT INTO public.who_global_data_import VALUES (5468, '2020-09-26', 'AZ', 'Azerbaijan', 'EURO', '101', '39787', '2', '583');
INSERT INTO public.who_global_data_import VALUES (5469, '2020-09-27', 'AZ', 'Azerbaijan', 'EURO', '108', '39895', '2', '585');
INSERT INTO public.who_global_data_import VALUES (5470, '2020-09-28', 'AZ', 'Azerbaijan', 'EURO', '128', '40023', '1', '586');
INSERT INTO public.who_global_data_import VALUES (5471, '2020-09-29', 'AZ', 'Azerbaijan', 'EURO', '38', '40061', '2', '588');
INSERT INTO public.who_global_data_import VALUES (5472, '2020-09-30', 'AZ', 'Azerbaijan', 'EURO', '58', '40119', '2', '590');
INSERT INTO public.who_global_data_import VALUES (5473, '2020-10-01', 'AZ', 'Azerbaijan', 'EURO', '110', '40229', '1', '591');
INSERT INTO public.who_global_data_import VALUES (5474, '2020-10-02', 'AZ', 'Azerbaijan', 'EURO', '80', '40309', '2', '593');
INSERT INTO public.who_global_data_import VALUES (5475, '2020-10-03', 'AZ', 'Azerbaijan', 'EURO', '144', '40453', '1', '594');
INSERT INTO public.who_global_data_import VALUES (5476, '2020-10-04', 'AZ', 'Azerbaijan', 'EURO', '108', '40561', '1', '595');
INSERT INTO public.who_global_data_import VALUES (5477, '2020-10-05', 'AZ', 'Azerbaijan', 'EURO', '130', '40691', '1', '596');
INSERT INTO public.who_global_data_import VALUES (5478, '2020-10-06', 'AZ', 'Azerbaijan', 'EURO', '97', '40788', '2', '598');
INSERT INTO public.who_global_data_import VALUES (5479, '2020-10-07', 'AZ', 'Azerbaijan', 'EURO', '143', '40931', '2', '600');
INSERT INTO public.who_global_data_import VALUES (5480, '2020-10-08', 'AZ', 'Azerbaijan', 'EURO', '182', '41113', '2', '602');
INSERT INTO public.who_global_data_import VALUES (5481, '2020-10-09', 'AZ', 'Azerbaijan', 'EURO', '191', '41304', '1', '603');
INSERT INTO public.who_global_data_import VALUES (5482, '2020-10-10', 'AZ', 'Azerbaijan', 'EURO', '215', '41519', '2', '605');
INSERT INTO public.who_global_data_import VALUES (5483, '2020-10-11', 'AZ', 'Azerbaijan', 'EURO', '233', '41752', '3', '608');
INSERT INTO public.who_global_data_import VALUES (5484, '2020-10-12', 'AZ', 'Azerbaijan', 'EURO', '230', '41982', '1', '609');
INSERT INTO public.who_global_data_import VALUES (5485, '2020-10-13', 'AZ', 'Azerbaijan', 'EURO', '122', '42104', '0', '609');
INSERT INTO public.who_global_data_import VALUES (5486, '2020-10-14', 'AZ', 'Azerbaijan', 'EURO', '277', '42381', '3', '612');
INSERT INTO public.who_global_data_import VALUES (5487, '2020-10-15', 'AZ', 'Azerbaijan', 'EURO', '369', '42750', '4', '616');
INSERT INTO public.who_global_data_import VALUES (5488, '2020-10-16', 'AZ', 'Azerbaijan', 'EURO', '530', '43280', '3', '619');
INSERT INTO public.who_global_data_import VALUES (5489, '2020-10-17', 'AZ', 'Azerbaijan', 'EURO', '509', '43789', '2', '621');
INSERT INTO public.who_global_data_import VALUES (5490, '2020-10-18', 'AZ', 'Azerbaijan', 'EURO', '528', '44317', '2', '623');
INSERT INTO public.who_global_data_import VALUES (5491, '2020-10-19', 'AZ', 'Azerbaijan', 'EURO', '647', '44964', '3', '626');
INSERT INTO public.who_global_data_import VALUES (5492, '2020-10-20', 'AZ', 'Azerbaijan', 'EURO', '331', '45295', '4', '630');
INSERT INTO public.who_global_data_import VALUES (5493, '2020-10-21', 'AZ', 'Azerbaijan', 'EURO', '584', '45879', '5', '635');
INSERT INTO public.who_global_data_import VALUES (5494, '2020-10-22', 'AZ', 'Azerbaijan', 'EURO', '714', '46593', '7', '642');
INSERT INTO public.who_global_data_import VALUES (5495, '2020-10-23', 'AZ', 'Azerbaijan', 'EURO', '825', '47418', '6', '648');
INSERT INTO public.who_global_data_import VALUES (5496, '2020-10-24', 'AZ', 'Azerbaijan', 'EURO', '803', '48221', '8', '656');
INSERT INTO public.who_global_data_import VALUES (5497, '2020-10-25', 'AZ', 'Azerbaijan', 'EURO', '792', '49013', '8', '664');
INSERT INTO public.who_global_data_import VALUES (5498, '2020-10-26', 'AZ', 'Azerbaijan', 'EURO', '946', '49959', '7', '671');
INSERT INTO public.who_global_data_import VALUES (5499, '2020-10-27', 'AZ', 'Azerbaijan', 'EURO', '527', '50486', '8', '679');
INSERT INTO public.who_global_data_import VALUES (5500, '2020-10-28', 'AZ', 'Azerbaijan', 'EURO', '663', '51149', '9', '688');
INSERT INTO public.who_global_data_import VALUES (5501, '2020-10-29', 'AZ', 'Azerbaijan', 'EURO', '988', '52137', '11', '699');
INSERT INTO public.who_global_data_import VALUES (5502, '2020-10-30', 'AZ', 'Azerbaijan', 'EURO', '1015', '53152', '9', '708');
INSERT INTO public.who_global_data_import VALUES (5503, '2020-10-31', 'AZ', 'Azerbaijan', 'EURO', '1022', '54174', '10', '718');
INSERT INTO public.who_global_data_import VALUES (5504, '2020-11-01', 'AZ', 'Azerbaijan', 'EURO', '1095', '55269', '12', '730');
INSERT INTO public.who_global_data_import VALUES (5505, '2020-11-02', 'AZ', 'Azerbaijan', 'EURO', '1175', '56444', '10', '740');
INSERT INTO public.who_global_data_import VALUES (5506, '2020-11-03', 'AZ', 'Azerbaijan', 'EURO', '596', '57040', '13', '753');
INSERT INTO public.who_global_data_import VALUES (5507, '2020-11-04', 'AZ', 'Azerbaijan', 'EURO', '1242', '58282', '15', '768');
INSERT INTO public.who_global_data_import VALUES (5508, '2020-11-05', 'AZ', 'Azerbaijan', 'EURO', '1227', '59509', '12', '780');
INSERT INTO public.who_global_data_import VALUES (5509, '2020-11-06', 'AZ', 'Azerbaijan', 'EURO', '1364', '60873', '14', '794');
INSERT INTO public.who_global_data_import VALUES (5510, '2020-11-07', 'AZ', 'Azerbaijan', 'EURO', '1465', '62338', '17', '811');
INSERT INTO public.who_global_data_import VALUES (5511, '2020-11-08', 'AZ', 'Azerbaijan', 'EURO', '1410', '63748', '13', '824');
INSERT INTO public.who_global_data_import VALUES (5512, '2020-11-09', 'AZ', 'Azerbaijan', 'EURO', '1663', '65411', '16', '840');
INSERT INTO public.who_global_data_import VALUES (5513, '2020-11-10', 'AZ', 'Azerbaijan', 'EURO', '635', '66046', '12', '852');
INSERT INTO public.who_global_data_import VALUES (5514, '2020-11-11', 'AZ', 'Azerbaijan', 'EURO', '1346', '67392', '15', '867');
INSERT INTO public.who_global_data_import VALUES (5515, '2020-11-12', 'AZ', 'Azerbaijan', 'EURO', '1202', '68594', '18', '885');
INSERT INTO public.who_global_data_import VALUES (5516, '2020-11-13', 'AZ', 'Azerbaijan', 'EURO', '1622', '70216', '20', '905');
INSERT INTO public.who_global_data_import VALUES (5517, '2020-11-14', 'AZ', 'Azerbaijan', 'EURO', '1364', '71580', '22', '927');
INSERT INTO public.who_global_data_import VALUES (5518, '2020-11-15', 'AZ', 'Azerbaijan', 'EURO', '1849', '73429', '19', '946');
INSERT INTO public.who_global_data_import VALUES (5519, '2020-11-16', 'AZ', 'Azerbaijan', 'EURO', '2259', '75688', '21', '967');
INSERT INTO public.who_global_data_import VALUES (5520, '2020-11-17', 'AZ', 'Azerbaijan', 'EURO', '1395', '77083', '18', '985');
INSERT INTO public.who_global_data_import VALUES (5521, '2020-11-18', 'AZ', 'Azerbaijan', 'EURO', '2075', '79158', '20', '1005');
INSERT INTO public.who_global_data_import VALUES (5522, '2020-11-19', 'AZ', 'Azerbaijan', 'EURO', '2239', '81397', '25', '1030');
INSERT INTO public.who_global_data_import VALUES (5523, '2020-11-20', 'AZ', 'Azerbaijan', 'EURO', '2597', '83994', '23', '1053');
INSERT INTO public.who_global_data_import VALUES (5524, '2020-11-21', 'AZ', 'Azerbaijan', 'EURO', '3169', '87163', '26', '1079');
INSERT INTO public.who_global_data_import VALUES (5525, '2020-11-22', 'AZ', 'Azerbaijan', 'EURO', '2735', '89898', '28', '1107');
INSERT INTO public.who_global_data_import VALUES (5526, '2020-11-23', 'AZ', 'Azerbaijan', 'EURO', '3196', '93094', '24', '1131');
INSERT INTO public.who_global_data_import VALUES (5527, '2020-11-24', 'AZ', 'Azerbaijan', 'EURO', '2187', '95281', '29', '1160');
INSERT INTO public.who_global_data_import VALUES (5528, '2020-11-25', 'AZ', 'Azerbaijan', 'EURO', '3646', '98927', '34', '1194');
INSERT INTO public.who_global_data_import VALUES (5529, '2020-11-26', 'AZ', 'Azerbaijan', 'EURO', '3469', '102396', '30', '1224');
INSERT INTO public.who_global_data_import VALUES (5530, '2020-11-27', 'AZ', 'Azerbaijan', 'EURO', '3705', '106101', '32', '1256');
INSERT INTO public.who_global_data_import VALUES (5531, '2020-11-28', 'AZ', 'Azerbaijan', 'EURO', '3712', '109813', '35', '1291');
INSERT INTO public.who_global_data_import VALUES (5532, '2020-11-29', 'AZ', 'Azerbaijan', 'EURO', '4212', '114025', '32', '1323');
INSERT INTO public.who_global_data_import VALUES (5533, '2020-11-30', 'AZ', 'Azerbaijan', 'EURO', '4170', '118195', '38', '1361');
INSERT INTO public.who_global_data_import VALUES (5534, '2020-12-01', 'AZ', 'Azerbaijan', 'EURO', '2981', '121176', '31', '1392');
INSERT INTO public.who_global_data_import VALUES (5535, '2020-12-02', 'AZ', 'Azerbaijan', 'EURO', '4426', '125602', '41', '1433');
INSERT INTO public.who_global_data_import VALUES (5536, '2020-12-03', 'AZ', 'Azerbaijan', 'EURO', '3942', '129544', '37', '1470');
INSERT INTO public.who_global_data_import VALUES (5537, '2020-12-04', 'AZ', 'Azerbaijan', 'EURO', '4189', '133733', '40', '1510');
INSERT INTO public.who_global_data_import VALUES (5538, '2020-12-05', 'AZ', 'Azerbaijan', 'EURO', '4267', '138000', '41', '1551');
INSERT INTO public.who_global_data_import VALUES (5539, '2020-12-06', 'AZ', 'Azerbaijan', 'EURO', '4323', '142323', '42', '1593');
INSERT INTO public.who_global_data_import VALUES (5540, '2020-12-07', 'AZ', 'Azerbaijan', 'EURO', '4356', '146679', '39', '1632');
INSERT INTO public.who_global_data_import VALUES (5541, '2020-12-08', 'AZ', 'Azerbaijan', 'EURO', '3086', '149765', '43', '1675');
INSERT INTO public.who_global_data_import VALUES (5542, '2020-12-09', 'AZ', 'Azerbaijan', 'EURO', '4387', '154152', '38', '1713');
INSERT INTO public.who_global_data_import VALUES (5543, '2020-12-10', 'AZ', 'Azerbaijan', 'EURO', '4403', '158555', '42', '1755');
INSERT INTO public.who_global_data_import VALUES (5544, '2020-12-11', 'AZ', 'Azerbaijan', 'EURO', '4219', '162774', '38', '1793');
INSERT INTO public.who_global_data_import VALUES (5545, '2020-12-12', 'AZ', 'Azerbaijan', 'EURO', '4381', '167155', '47', '1840');
INSERT INTO public.who_global_data_import VALUES (5546, '2020-12-13', 'AZ', 'Azerbaijan', 'EURO', '4268', '171423', '43', '1883');
INSERT INTO public.who_global_data_import VALUES (5547, '2020-12-14', 'AZ', 'Azerbaijan', 'EURO', '4451', '175874', '39', '1922');
INSERT INTO public.who_global_data_import VALUES (5548, '2020-12-15', 'AZ', 'Azerbaijan', 'EURO', '3112', '178986', '44', '1966');
INSERT INTO public.who_global_data_import VALUES (5549, '2020-12-16', 'AZ', 'Azerbaijan', 'EURO', '4273', '183259', '41', '2007');
INSERT INTO public.who_global_data_import VALUES (5550, '2020-12-17', 'AZ', 'Azerbaijan', 'EURO', '4077', '187336', '43', '2050');
INSERT INTO public.who_global_data_import VALUES (5551, '2020-12-18', 'AZ', 'Azerbaijan', 'EURO', '4124', '191460', '38', '2088');
INSERT INTO public.who_global_data_import VALUES (5552, '2020-12-19', 'AZ', 'Azerbaijan', 'EURO', '3962', '195422', '45', '2133');
INSERT INTO public.who_global_data_import VALUES (5553, '2020-12-20', 'AZ', 'Azerbaijan', 'EURO', '3705', '199127', '42', '2175');
INSERT INTO public.who_global_data_import VALUES (5554, '2020-12-21', 'AZ', 'Azerbaijan', 'EURO', '2961', '202088', '35', '2210');
INSERT INTO public.who_global_data_import VALUES (5555, '2020-12-22', 'AZ', 'Azerbaijan', 'EURO', '1505', '203593', '43', '2253');
INSERT INTO public.who_global_data_import VALUES (5556, '2020-12-23', 'AZ', 'Azerbaijan', 'EURO', '2284', '205877', '41', '2294');
INSERT INTO public.who_global_data_import VALUES (5557, '2020-12-24', 'AZ', 'Azerbaijan', 'EURO', '2334', '208211', '46', '2340');
INSERT INTO public.who_global_data_import VALUES (5558, '2020-12-25', 'AZ', 'Azerbaijan', 'EURO', '1850', '210061', '40', '2380');
INSERT INTO public.who_global_data_import VALUES (5559, '2020-12-26', 'AZ', 'Azerbaijan', 'EURO', '1703', '211764', '36', '2416');
INSERT INTO public.who_global_data_import VALUES (5560, '2020-12-27', 'AZ', 'Azerbaijan', 'EURO', '1428', '213192', '38', '2454');
INSERT INTO public.who_global_data_import VALUES (5561, '2020-12-28', 'AZ', 'Azerbaijan', 'EURO', '1519', '214711', '45', '2499');
INSERT INTO public.who_global_data_import VALUES (5562, '2020-12-29', 'AZ', 'Azerbaijan', 'EURO', '772', '215483', '39', '2538');
INSERT INTO public.who_global_data_import VALUES (5563, '2020-12-30', 'AZ', 'Azerbaijan', 'EURO', '1101', '216584', '37', '2575');
INSERT INTO public.who_global_data_import VALUES (5564, '2020-12-31', 'AZ', 'Azerbaijan', 'EURO', '1052', '217636', '34', '2609');
INSERT INTO public.who_global_data_import VALUES (5565, '2021-01-01', 'AZ', 'Azerbaijan', 'EURO', '1064', '218700', '32', '2641');
INSERT INTO public.who_global_data_import VALUES (5566, '2021-01-02', 'AZ', 'Azerbaijan', 'EURO', '341', '219041', '29', '2670');
INSERT INTO public.who_global_data_import VALUES (5567, '2021-01-03', 'AZ', 'Azerbaijan', 'EURO', '421', '219462', '33', '2703');
INSERT INTO public.who_global_data_import VALUES (5568, '2021-01-04', 'AZ', 'Azerbaijan', 'EURO', '803', '220265', '30', '2733');
INSERT INTO public.who_global_data_import VALUES (5569, '2021-01-05', 'AZ', 'Azerbaijan', 'EURO', '334', '220599', '28', '2761');
INSERT INTO public.who_global_data_import VALUES (5570, '2021-01-06', 'AZ', 'Azerbaijan', 'EURO', '802', '221401', '31', '2792');
INSERT INTO public.who_global_data_import VALUES (5571, '2021-01-07', 'AZ', 'Azerbaijan', 'EURO', '799', '222200', '26', '2818');
INSERT INTO public.who_global_data_import VALUES (5572, '2021-01-08', 'AZ', 'Azerbaijan', 'EURO', '685', '222885', '27', '2845');
INSERT INTO public.who_global_data_import VALUES (5573, '2021-01-09', 'AZ', 'Azerbaijan', 'EURO', '532', '223417', '24', '2869');
INSERT INTO public.who_global_data_import VALUES (5574, '2021-01-10', 'AZ', 'Azerbaijan', 'EURO', '633', '224050', '21', '2890');
INSERT INTO public.who_global_data_import VALUES (5575, '2021-01-11', 'AZ', 'Azerbaijan', 'EURO', '601', '224651', '19', '2909');
INSERT INTO public.who_global_data_import VALUES (5576, '2021-01-12', 'AZ', 'Azerbaijan', 'EURO', '176', '224827', '17', '2926');
INSERT INTO public.who_global_data_import VALUES (5577, '2021-01-13', 'AZ', 'Azerbaijan', 'EURO', '519', '225346', '15', '2941');
INSERT INTO public.who_global_data_import VALUES (5578, '2021-01-14', 'AZ', 'Azerbaijan', 'EURO', '474', '225820', '16', '2957');
INSERT INTO public.who_global_data_import VALUES (5579, '2021-01-15', 'AZ', 'Azerbaijan', 'EURO', '380', '226200', '14', '2971');
INSERT INTO public.who_global_data_import VALUES (5580, '2021-01-16', 'AZ', 'Azerbaijan', 'EURO', '349', '226549', '12', '2983');
INSERT INTO public.who_global_data_import VALUES (5581, '2021-01-17', 'AZ', 'Azerbaijan', 'EURO', '402', '226951', '15', '2998');
INSERT INTO public.who_global_data_import VALUES (5582, '2021-01-18', 'AZ', 'Azerbaijan', 'EURO', '322', '227273', '11', '3009');
INSERT INTO public.who_global_data_import VALUES (5583, '2021-01-19', 'AZ', 'Azerbaijan', 'EURO', '118', '227391', '13', '3022');
INSERT INTO public.who_global_data_import VALUES (5584, '2021-01-20', 'AZ', 'Azerbaijan', 'EURO', '305', '227696', '10', '3032');
INSERT INTO public.who_global_data_import VALUES (5585, '2021-01-21', 'AZ', 'Azerbaijan', 'EURO', '332', '228028', '12', '3044');
INSERT INTO public.who_global_data_import VALUES (5586, '2021-01-22', 'AZ', 'Azerbaijan', 'EURO', '218', '228246', '9', '3053');
INSERT INTO public.who_global_data_import VALUES (5587, '2021-01-23', 'AZ', 'Azerbaijan', 'EURO', '280', '228526', '11', '3064');
INSERT INTO public.who_global_data_import VALUES (5588, '2021-01-24', 'AZ', 'Azerbaijan', 'EURO', '162', '228688', '8', '3072');
INSERT INTO public.who_global_data_import VALUES (5589, '2021-01-25', 'AZ', 'Azerbaijan', 'EURO', '287', '228975', '10', '3082');
INSERT INTO public.who_global_data_import VALUES (5590, '2021-01-26', 'AZ', 'Azerbaijan', 'EURO', '57', '229032', '11', '3093');
INSERT INTO public.who_global_data_import VALUES (5591, '2021-01-27', 'AZ', 'Azerbaijan', 'EURO', '326', '229358', '7', '3100');
INSERT INTO public.who_global_data_import VALUES (5592, '2021-01-28', 'AZ', 'Azerbaijan', 'EURO', '226', '229584', '5', '3105');
INSERT INTO public.who_global_data_import VALUES (5593, '2021-01-29', 'AZ', 'Azerbaijan', 'EURO', '209', '229793', '8', '3113');
INSERT INTO public.who_global_data_import VALUES (5594, '2021-01-30', 'AZ', 'Azerbaijan', 'EURO', '142', '229935', '6', '3119');
INSERT INTO public.who_global_data_import VALUES (5595, '2021-01-31', 'AZ', 'Azerbaijan', 'EURO', '131', '230066', '7', '3126');
INSERT INTO public.who_global_data_import VALUES (5596, '2021-02-01', 'AZ', 'Azerbaijan', 'EURO', '153', '230219', '6', '3132');
INSERT INTO public.who_global_data_import VALUES (5597, '2021-02-02', 'AZ', 'Azerbaijan', 'EURO', '77', '230296', '4', '3136');
INSERT INTO public.who_global_data_import VALUES (5598, '2021-02-03', 'AZ', 'Azerbaijan', 'EURO', '159', '230455', '5', '3141');
INSERT INTO public.who_global_data_import VALUES (5599, '2021-02-04', 'AZ', 'Azerbaijan', 'EURO', '162', '230617', '4', '3145');
INSERT INTO public.who_global_data_import VALUES (5600, '2021-02-05', 'AZ', 'Azerbaijan', 'EURO', '152', '230769', '3', '3148');
INSERT INTO public.who_global_data_import VALUES (5601, '2020-01-03', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5602, '2020-01-04', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5603, '2020-01-05', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5604, '2020-01-06', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5605, '2020-01-07', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5606, '2020-01-08', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5607, '2020-01-09', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5608, '2020-01-10', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5609, '2020-01-11', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5610, '2020-01-12', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5611, '2020-01-13', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5612, '2020-01-14', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5613, '2020-01-15', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5614, '2020-01-16', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5615, '2020-01-17', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5616, '2020-01-18', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5617, '2020-01-19', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5618, '2020-01-20', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5619, '2020-01-21', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5620, '2020-01-22', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5621, '2020-01-23', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5622, '2020-01-24', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5623, '2020-01-25', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5624, '2020-01-26', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5625, '2020-01-27', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5626, '2020-01-28', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5627, '2020-01-29', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5628, '2020-01-30', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5629, '2020-01-31', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5630, '2020-02-01', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5631, '2020-02-02', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5632, '2020-02-03', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5633, '2020-02-04', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5634, '2020-02-05', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5635, '2020-02-06', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5636, '2020-02-07', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5637, '2020-02-08', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5638, '2020-02-09', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5639, '2020-02-10', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5640, '2020-02-11', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5641, '2020-02-12', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5642, '2020-02-13', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5643, '2020-02-14', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5644, '2020-02-15', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5645, '2020-02-16', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5646, '2020-02-17', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5647, '2020-02-18', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5648, '2020-02-19', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5649, '2020-02-20', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5650, '2020-02-21', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5651, '2020-02-22', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5652, '2020-02-23', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5653, '2020-02-24', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5654, '2020-02-25', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5655, '2020-02-26', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5656, '2020-02-27', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5657, '2020-02-28', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5658, '2020-02-29', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5659, '2020-03-01', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5660, '2020-03-02', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5661, '2020-03-03', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5662, '2020-03-04', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5663, '2020-03-05', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5664, '2020-03-06', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5665, '2020-03-07', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5666, '2020-03-08', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5667, '2020-03-09', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5668, '2020-03-10', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5669, '2020-03-11', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5670, '2020-03-12', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5671, '2020-03-13', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5672, '2020-03-14', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5673, '2020-03-15', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5674, '2020-03-16', 'BS', 'Bahamas', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5675, '2020-03-17', 'BS', 'Bahamas', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5676, '2020-03-18', 'BS', 'Bahamas', 'AMRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5677, '2020-03-19', 'BS', 'Bahamas', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5678, '2020-03-20', 'BS', 'Bahamas', 'AMRO', '-3', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5679, '2020-03-21', 'BS', 'Bahamas', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5680, '2020-03-22', 'BS', 'Bahamas', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5681, '2020-03-23', 'BS', 'Bahamas', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5682, '2020-03-24', 'BS', 'Bahamas', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5683, '2020-03-25', 'BS', 'Bahamas', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5684, '2020-03-26', 'BS', 'Bahamas', 'AMRO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5685, '2020-03-27', 'BS', 'Bahamas', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5686, '2020-03-28', 'BS', 'Bahamas', 'AMRO', '4', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5687, '2020-03-29', 'BS', 'Bahamas', 'AMRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5688, '2020-03-30', 'BS', 'Bahamas', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5689, '2020-03-31', 'BS', 'Bahamas', 'AMRO', '4', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5690, '2020-04-01', 'BS', 'Bahamas', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5691, '2020-04-02', 'BS', 'Bahamas', 'AMRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (5692, '2020-04-03', 'BS', 'Bahamas', 'AMRO', '6', '21', '1', '1');
INSERT INTO public.who_global_data_import VALUES (5693, '2020-04-04', 'BS', 'Bahamas', 'AMRO', '3', '24', '2', '3');
INSERT INTO public.who_global_data_import VALUES (5694, '2020-04-05', 'BS', 'Bahamas', 'AMRO', '0', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (5695, '2020-04-06', 'BS', 'Bahamas', 'AMRO', '4', '28', '1', '4');
INSERT INTO public.who_global_data_import VALUES (5696, '2020-04-07', 'BS', 'Bahamas', 'AMRO', '1', '29', '1', '5');
INSERT INTO public.who_global_data_import VALUES (5697, '2020-04-08', 'BS', 'Bahamas', 'AMRO', '4', '33', '0', '5');
INSERT INTO public.who_global_data_import VALUES (5698, '2020-04-09', 'BS', 'Bahamas', 'AMRO', '3', '36', '1', '6');
INSERT INTO public.who_global_data_import VALUES (5699, '2020-04-10', 'BS', 'Bahamas', 'AMRO', '4', '40', '1', '7');
INSERT INTO public.who_global_data_import VALUES (5700, '2020-04-11', 'BS', 'Bahamas', 'AMRO', '1', '41', '1', '8');
INSERT INTO public.who_global_data_import VALUES (5701, '2020-04-12', 'BS', 'Bahamas', 'AMRO', '1', '42', '0', '8');
INSERT INTO public.who_global_data_import VALUES (5702, '2020-04-13', 'BS', 'Bahamas', 'AMRO', '0', '42', '0', '8');
INSERT INTO public.who_global_data_import VALUES (5703, '2020-04-14', 'BS', 'Bahamas', 'AMRO', '5', '47', '0', '8');
INSERT INTO public.who_global_data_import VALUES (5704, '2020-04-15', 'BS', 'Bahamas', 'AMRO', '2', '49', '0', '8');
INSERT INTO public.who_global_data_import VALUES (5705, '2020-04-16', 'BS', 'Bahamas', 'AMRO', '0', '49', '0', '8');
INSERT INTO public.who_global_data_import VALUES (5706, '2020-04-17', 'BS', 'Bahamas', 'AMRO', '4', '53', '0', '8');
INSERT INTO public.who_global_data_import VALUES (5707, '2020-04-18', 'BS', 'Bahamas', 'AMRO', '1', '54', '1', '9');
INSERT INTO public.who_global_data_import VALUES (5708, '2020-04-19', 'BS', 'Bahamas', 'AMRO', '0', '54', '0', '9');
INSERT INTO public.who_global_data_import VALUES (5709, '2020-04-20', 'BS', 'Bahamas', 'AMRO', '4', '58', '0', '9');
INSERT INTO public.who_global_data_import VALUES (5710, '2020-04-21', 'BS', 'Bahamas', 'AMRO', '2', '60', '0', '9');
INSERT INTO public.who_global_data_import VALUES (5711, '2020-04-22', 'BS', 'Bahamas', 'AMRO', '4', '64', '0', '9');
INSERT INTO public.who_global_data_import VALUES (5712, '2020-04-23', 'BS', 'Bahamas', 'AMRO', '1', '65', '0', '9');
INSERT INTO public.who_global_data_import VALUES (5713, '2020-04-24', 'BS', 'Bahamas', 'AMRO', '5', '70', '0', '9');
INSERT INTO public.who_global_data_import VALUES (5714, '2020-04-25', 'BS', 'Bahamas', 'AMRO', '2', '72', '2', '11');
INSERT INTO public.who_global_data_import VALUES (5715, '2020-04-26', 'BS', 'Bahamas', 'AMRO', '0', '72', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5716, '2020-04-27', 'BS', 'Bahamas', 'AMRO', '6', '78', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5717, '2020-04-28', 'BS', 'Bahamas', 'AMRO', '2', '80', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5718, '2020-04-29', 'BS', 'Bahamas', 'AMRO', '0', '80', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5719, '2020-04-30', 'BS', 'Bahamas', 'AMRO', '0', '80', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5720, '2020-05-01', 'BS', 'Bahamas', 'AMRO', '0', '80', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5721, '2020-05-02', 'BS', 'Bahamas', 'AMRO', '1', '81', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5722, '2020-05-03', 'BS', 'Bahamas', 'AMRO', '1', '82', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5723, '2020-05-04', 'BS', 'Bahamas', 'AMRO', '0', '82', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5724, '2020-05-05', 'BS', 'Bahamas', 'AMRO', '1', '83', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5725, '2020-05-06', 'BS', 'Bahamas', 'AMRO', '1', '84', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5726, '2020-05-07', 'BS', 'Bahamas', 'AMRO', '5', '89', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5727, '2020-05-08', 'BS', 'Bahamas', 'AMRO', '3', '92', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5728, '2020-05-09', 'BS', 'Bahamas', 'AMRO', '0', '92', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5729, '2020-05-10', 'BS', 'Bahamas', 'AMRO', '0', '92', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5730, '2020-05-11', 'BS', 'Bahamas', 'AMRO', '0', '92', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5731, '2020-05-12', 'BS', 'Bahamas', 'AMRO', '0', '92', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5732, '2020-05-13', 'BS', 'Bahamas', 'AMRO', '1', '93', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5733, '2020-05-14', 'BS', 'Bahamas', 'AMRO', '0', '93', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5734, '2020-05-15', 'BS', 'Bahamas', 'AMRO', '1', '94', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5735, '2020-05-16', 'BS', 'Bahamas', 'AMRO', '2', '96', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5736, '2020-05-17', 'BS', 'Bahamas', 'AMRO', '0', '96', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5737, '2020-05-18', 'BS', 'Bahamas', 'AMRO', '0', '96', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5738, '2020-05-19', 'BS', 'Bahamas', 'AMRO', '0', '96', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5739, '2020-05-20', 'BS', 'Bahamas', 'AMRO', '0', '96', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5740, '2020-05-21', 'BS', 'Bahamas', 'AMRO', '0', '96', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5741, '2020-05-22', 'BS', 'Bahamas', 'AMRO', '1', '97', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5742, '2020-05-23', 'BS', 'Bahamas', 'AMRO', '0', '97', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5743, '2020-05-24', 'BS', 'Bahamas', 'AMRO', '0', '97', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5744, '2020-05-25', 'BS', 'Bahamas', 'AMRO', '3', '100', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5745, '2020-05-26', 'BS', 'Bahamas', 'AMRO', '0', '100', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5746, '2020-05-27', 'BS', 'Bahamas', 'AMRO', '0', '100', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5747, '2020-05-28', 'BS', 'Bahamas', 'AMRO', '0', '100', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5748, '2020-05-29', 'BS', 'Bahamas', 'AMRO', '0', '100', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5749, '2020-05-30', 'BS', 'Bahamas', 'AMRO', '1', '101', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5750, '2020-05-31', 'BS', 'Bahamas', 'AMRO', '0', '101', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5751, '2020-06-01', 'BS', 'Bahamas', 'AMRO', '0', '101', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5752, '2020-06-02', 'BS', 'Bahamas', 'AMRO', '1', '102', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5753, '2020-06-03', 'BS', 'Bahamas', 'AMRO', '0', '102', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5754, '2020-06-04', 'BS', 'Bahamas', 'AMRO', '0', '102', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5755, '2020-06-05', 'BS', 'Bahamas', 'AMRO', '0', '102', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5756, '2020-06-06', 'BS', 'Bahamas', 'AMRO', '0', '102', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5757, '2020-06-07', 'BS', 'Bahamas', 'AMRO', '1', '103', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5758, '2020-06-08', 'BS', 'Bahamas', 'AMRO', '0', '103', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5759, '2020-06-09', 'BS', 'Bahamas', 'AMRO', '0', '103', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5760, '2020-06-10', 'BS', 'Bahamas', 'AMRO', '0', '103', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5761, '2020-06-11', 'BS', 'Bahamas', 'AMRO', '0', '103', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5762, '2020-06-12', 'BS', 'Bahamas', 'AMRO', '0', '103', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5763, '2020-06-13', 'BS', 'Bahamas', 'AMRO', '0', '103', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5764, '2020-06-14', 'BS', 'Bahamas', 'AMRO', '0', '103', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5765, '2020-06-15', 'BS', 'Bahamas', 'AMRO', '0', '103', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5766, '2020-06-16', 'BS', 'Bahamas', 'AMRO', '1', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5767, '2020-06-17', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5768, '2020-06-18', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5769, '2020-06-19', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5770, '2020-06-20', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5771, '2020-06-21', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5772, '2020-06-22', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5773, '2020-06-23', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5774, '2020-06-24', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5775, '2020-06-25', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5776, '2020-06-26', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5777, '2020-06-27', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5778, '2020-06-28', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5779, '2020-06-29', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5780, '2020-06-30', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5781, '2020-07-01', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5782, '2020-07-02', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5783, '2020-07-03', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5784, '2020-07-04', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5785, '2020-07-05', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5786, '2020-07-06', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5787, '2020-07-07', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5788, '2020-07-08', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5789, '2020-07-09', 'BS', 'Bahamas', 'AMRO', '0', '104', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5790, '2020-07-10', 'BS', 'Bahamas', 'AMRO', '2', '106', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5791, '2020-07-11', 'BS', 'Bahamas', 'AMRO', '1', '107', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5792, '2020-07-12', 'BS', 'Bahamas', 'AMRO', '1', '108', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5793, '2020-07-13', 'BS', 'Bahamas', 'AMRO', '3', '111', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5794, '2020-07-14', 'BS', 'Bahamas', 'AMRO', '0', '111', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5795, '2020-07-15', 'BS', 'Bahamas', 'AMRO', '2', '113', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5796, '2020-07-16', 'BS', 'Bahamas', 'AMRO', '3', '116', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5797, '2020-07-17', 'BS', 'Bahamas', 'AMRO', '3', '119', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5798, '2020-07-18', 'BS', 'Bahamas', 'AMRO', '5', '124', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5799, '2020-07-19', 'BS', 'Bahamas', 'AMRO', '5', '129', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5800, '2020-07-20', 'BS', 'Bahamas', 'AMRO', '9', '138', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5801, '2020-07-21', 'BS', 'Bahamas', 'AMRO', '15', '153', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5802, '2020-07-22', 'BS', 'Bahamas', 'AMRO', '21', '174', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5803, '2020-07-23', 'BS', 'Bahamas', 'AMRO', '20', '194', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5804, '2020-07-24', 'BS', 'Bahamas', 'AMRO', '25', '219', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5805, '2020-07-25', 'BS', 'Bahamas', 'AMRO', '55', '274', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5806, '2020-07-26', 'BS', 'Bahamas', 'AMRO', '42', '316', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5807, '2020-07-27', 'BS', 'Bahamas', 'AMRO', '10', '326', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5808, '2020-07-28', 'BS', 'Bahamas', 'AMRO', '16', '342', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5809, '2020-07-29', 'BS', 'Bahamas', 'AMRO', '40', '382', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5810, '2020-07-30', 'BS', 'Bahamas', 'AMRO', '65', '447', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5811, '2020-07-31', 'BS', 'Bahamas', 'AMRO', '37', '484', '0', '11');
INSERT INTO public.who_global_data_import VALUES (5812, '2020-08-01', 'BS', 'Bahamas', 'AMRO', '24', '508', '3', '14');
INSERT INTO public.who_global_data_import VALUES (5813, '2020-08-02', 'BS', 'Bahamas', 'AMRO', '0', '508', '0', '14');
INSERT INTO public.who_global_data_import VALUES (5814, '2020-08-03', 'BS', 'Bahamas', 'AMRO', '66', '574', '0', '14');
INSERT INTO public.who_global_data_import VALUES (5815, '2020-08-04', 'BS', 'Bahamas', 'AMRO', '74', '648', '0', '14');
INSERT INTO public.who_global_data_import VALUES (5816, '2020-08-05', 'BS', 'Bahamas', 'AMRO', '31', '679', '0', '14');
INSERT INTO public.who_global_data_import VALUES (5817, '2020-08-06', 'BS', 'Bahamas', 'AMRO', '36', '715', '0', '14');
INSERT INTO public.who_global_data_import VALUES (5818, '2020-08-07', 'BS', 'Bahamas', 'AMRO', '36', '751', '0', '14');
INSERT INTO public.who_global_data_import VALUES (5819, '2020-08-08', 'BS', 'Bahamas', 'AMRO', '10', '761', '0', '14');
INSERT INTO public.who_global_data_import VALUES (5820, '2020-08-09', 'BS', 'Bahamas', 'AMRO', '69', '830', '0', '14');
INSERT INTO public.who_global_data_import VALUES (5821, '2020-08-10', 'BS', 'Bahamas', 'AMRO', '48', '878', '0', '14');
INSERT INTO public.who_global_data_import VALUES (5822, '2020-08-11', 'BS', 'Bahamas', 'AMRO', '20', '898', '1', '15');
INSERT INTO public.who_global_data_import VALUES (5823, '2020-08-12', 'BS', 'Bahamas', 'AMRO', '47', '945', '0', '15');
INSERT INTO public.who_global_data_import VALUES (5824, '2020-08-13', 'BS', 'Bahamas', 'AMRO', '44', '989', '0', '15');
INSERT INTO public.who_global_data_import VALUES (5825, '2020-08-14', 'BS', 'Bahamas', 'AMRO', '47', '1036', '0', '15');
INSERT INTO public.who_global_data_import VALUES (5826, '2020-08-15', 'BS', 'Bahamas', 'AMRO', '53', '1089', '0', '15');
INSERT INTO public.who_global_data_import VALUES (5827, '2020-08-16', 'BS', 'Bahamas', 'AMRO', '30', '1119', '2', '17');
INSERT INTO public.who_global_data_import VALUES (5828, '2020-08-17', 'BS', 'Bahamas', 'AMRO', '133', '1252', '0', '17');
INSERT INTO public.who_global_data_import VALUES (5829, '2020-08-18', 'BS', 'Bahamas', 'AMRO', '63', '1315', '1', '18');
INSERT INTO public.who_global_data_import VALUES (5830, '2020-08-19', 'BS', 'Bahamas', 'AMRO', '14', '1329', '1', '19');
INSERT INTO public.who_global_data_import VALUES (5831, '2020-08-20', 'BS', 'Bahamas', 'AMRO', '95', '1424', '1', '20');
INSERT INTO public.who_global_data_import VALUES (5832, '2020-08-21', 'BS', 'Bahamas', 'AMRO', '107', '1531', '2', '22');
INSERT INTO public.who_global_data_import VALUES (5833, '2020-08-22', 'BS', 'Bahamas', 'AMRO', '79', '1610', '1', '23');
INSERT INTO public.who_global_data_import VALUES (5834, '2020-08-23', 'BS', 'Bahamas', 'AMRO', '93', '1703', '4', '27');
INSERT INTO public.who_global_data_import VALUES (5835, '2020-08-24', 'BS', 'Bahamas', 'AMRO', '62', '1765', '2', '29');
INSERT INTO public.who_global_data_import VALUES (5836, '2020-08-25', 'BS', 'Bahamas', 'AMRO', '0', '1765', '0', '29');
INSERT INTO public.who_global_data_import VALUES (5837, '2020-08-26', 'BS', 'Bahamas', 'AMRO', '33', '1798', '17', '46');
INSERT INTO public.who_global_data_import VALUES (5838, '2020-08-27', 'BS', 'Bahamas', 'AMRO', '15', '1813', '2', '48');
INSERT INTO public.who_global_data_import VALUES (5839, '2020-08-28', 'BS', 'Bahamas', 'AMRO', '110', '1923', '0', '48');
INSERT INTO public.who_global_data_import VALUES (5840, '2020-08-29', 'BS', 'Bahamas', 'AMRO', '97', '2020', '2', '50');
INSERT INTO public.who_global_data_import VALUES (5841, '2020-08-30', 'BS', 'Bahamas', 'AMRO', '37', '2057', '-10', '40');
INSERT INTO public.who_global_data_import VALUES (5842, '2020-08-31', 'BS', 'Bahamas', 'AMRO', '78', '2135', '3', '43');
INSERT INTO public.who_global_data_import VALUES (5843, '2020-09-01', 'BS', 'Bahamas', 'AMRO', '32', '2167', '0', '43');
INSERT INTO public.who_global_data_import VALUES (5844, '2020-09-02', 'BS', 'Bahamas', 'AMRO', '50', '2217', '1', '44');
INSERT INTO public.who_global_data_import VALUES (5845, '2020-09-03', 'BS', 'Bahamas', 'AMRO', '59', '2276', '2', '46');
INSERT INTO public.who_global_data_import VALUES (5846, '2020-09-04', 'BS', 'Bahamas', 'AMRO', '61', '2337', '1', '47');
INSERT INTO public.who_global_data_import VALUES (5847, '2020-09-05', 'BS', 'Bahamas', 'AMRO', '49', '2386', '3', '50');
INSERT INTO public.who_global_data_import VALUES (5848, '2020-09-06', 'BS', 'Bahamas', 'AMRO', '90', '2476', '5', '55');
INSERT INTO public.who_global_data_import VALUES (5849, '2020-09-07', 'BS', 'Bahamas', 'AMRO', '0', '2476', '0', '55');
INSERT INTO public.who_global_data_import VALUES (5850, '2020-09-08', 'BS', 'Bahamas', 'AMRO', '70', '2546', '3', '58');
INSERT INTO public.who_global_data_import VALUES (5851, '2020-09-09', 'BS', 'Bahamas', 'AMRO', '39', '2585', '1', '59');
INSERT INTO public.who_global_data_import VALUES (5852, '2020-09-10', 'BS', 'Bahamas', 'AMRO', '72', '2657', '4', '63');
INSERT INTO public.who_global_data_import VALUES (5853, '2020-09-11', 'BS', 'Bahamas', 'AMRO', '64', '2721', '0', '63');
INSERT INTO public.who_global_data_import VALUES (5854, '2020-09-12', 'BS', 'Bahamas', 'AMRO', '93', '2814', '2', '65');
INSERT INTO public.who_global_data_import VALUES (5855, '2020-09-13', 'BS', 'Bahamas', 'AMRO', '60', '2874', '2', '67');
INSERT INTO public.who_global_data_import VALUES (5856, '2020-09-14', 'BS', 'Bahamas', 'AMRO', '54', '2928', '0', '67');
INSERT INTO public.who_global_data_import VALUES (5857, '2020-09-15', 'BS', 'Bahamas', 'AMRO', '46', '2974', '0', '67');
INSERT INTO public.who_global_data_import VALUES (5858, '2020-09-16', 'BS', 'Bahamas', 'AMRO', '34', '3008', '1', '68');
INSERT INTO public.who_global_data_import VALUES (5859, '2020-09-17', 'BS', 'Bahamas', 'AMRO', '24', '3032', '1', '69');
INSERT INTO public.who_global_data_import VALUES (5860, '2020-09-18', 'BS', 'Bahamas', 'AMRO', '55', '3087', '0', '69');
INSERT INTO public.who_global_data_import VALUES (5861, '2020-09-19', 'BS', 'Bahamas', 'AMRO', '90', '3177', '0', '69');
INSERT INTO public.who_global_data_import VALUES (5862, '2020-09-20', 'BS', 'Bahamas', 'AMRO', '0', '3177', '0', '69');
INSERT INTO public.who_global_data_import VALUES (5863, '2020-09-21', 'BS', 'Bahamas', 'AMRO', '138', '3315', '5', '74');
INSERT INTO public.who_global_data_import VALUES (5864, '2020-09-22', 'BS', 'Bahamas', 'AMRO', '55', '3370', '0', '74');
INSERT INTO public.who_global_data_import VALUES (5865, '2020-09-23', 'BS', 'Bahamas', 'AMRO', '48', '3418', '1', '75');
INSERT INTO public.who_global_data_import VALUES (5866, '2020-09-24', 'BS', 'Bahamas', 'AMRO', '49', '3467', '2', '77');
INSERT INTO public.who_global_data_import VALUES (5867, '2020-09-25', 'BS', 'Bahamas', 'AMRO', '151', '3618', '3', '80');
INSERT INTO public.who_global_data_import VALUES (5868, '2020-09-26', 'BS', 'Bahamas', 'AMRO', '81', '3699', '6', '86');
INSERT INTO public.who_global_data_import VALUES (5869, '2020-09-27', 'BS', 'Bahamas', 'AMRO', '91', '3790', '3', '89');
INSERT INTO public.who_global_data_import VALUES (5870, '2020-09-28', 'BS', 'Bahamas', 'AMRO', '48', '3838', '0', '89');
INSERT INTO public.who_global_data_import VALUES (5871, '2020-09-29', 'BS', 'Bahamas', 'AMRO', '0', '3838', '0', '89');
INSERT INTO public.who_global_data_import VALUES (5872, '2020-09-30', 'BS', 'Bahamas', 'AMRO', '65', '3903', '2', '91');
INSERT INTO public.who_global_data_import VALUES (5873, '2020-10-01', 'BS', 'Bahamas', 'AMRO', '119', '4022', '4', '95');
INSERT INTO public.who_global_data_import VALUES (5874, '2020-10-02', 'BS', 'Bahamas', 'AMRO', '101', '4123', '1', '96');
INSERT INTO public.who_global_data_import VALUES (5875, '2020-10-03', 'BS', 'Bahamas', 'AMRO', '97', '4220', '0', '96');
INSERT INTO public.who_global_data_import VALUES (5876, '2020-10-04', 'BS', 'Bahamas', 'AMRO', '112', '4332', '0', '96');
INSERT INTO public.who_global_data_import VALUES (5877, '2020-10-05', 'BS', 'Bahamas', 'AMRO', '77', '4409', '0', '96');
INSERT INTO public.who_global_data_import VALUES (5878, '2020-10-06', 'BS', 'Bahamas', 'AMRO', '43', '4452', '0', '96');
INSERT INTO public.who_global_data_import VALUES (5879, '2020-10-07', 'BS', 'Bahamas', 'AMRO', '107', '4559', '4', '100');
INSERT INTO public.who_global_data_import VALUES (5880, '2020-10-08', 'BS', 'Bahamas', 'AMRO', '73', '4632', '2', '102');
INSERT INTO public.who_global_data_import VALUES (5881, '2020-10-09', 'BS', 'Bahamas', 'AMRO', '81', '4713', '0', '102');
INSERT INTO public.who_global_data_import VALUES (5882, '2020-10-10', 'BS', 'Bahamas', 'AMRO', '151', '4864', '0', '102');
INSERT INTO public.who_global_data_import VALUES (5883, '2020-10-11', 'BS', 'Bahamas', 'AMRO', '91', '4955', '4', '106');
INSERT INTO public.who_global_data_import VALUES (5884, '2020-10-12', 'BS', 'Bahamas', 'AMRO', '68', '5023', '0', '106');
INSERT INTO public.who_global_data_import VALUES (5885, '2020-10-13', 'BS', 'Bahamas', 'AMRO', '55', '5078', '1', '107');
INSERT INTO public.who_global_data_import VALUES (5886, '2020-10-14', 'BS', 'Bahamas', 'AMRO', '85', '5163', '1', '108');
INSERT INTO public.who_global_data_import VALUES (5887, '2020-10-15', 'BS', 'Bahamas', 'AMRO', '28', '5191', '1', '109');
INSERT INTO public.who_global_data_import VALUES (5888, '2020-10-16', 'BS', 'Bahamas', 'AMRO', '194', '5385', '3', '112');
INSERT INTO public.who_global_data_import VALUES (5889, '2020-10-17', 'BS', 'Bahamas', 'AMRO', '132', '5517', '2', '114');
INSERT INTO public.who_global_data_import VALUES (5890, '2020-10-18', 'BS', 'Bahamas', 'AMRO', '111', '5628', '2', '116');
INSERT INTO public.who_global_data_import VALUES (5891, '2020-10-19', 'BS', 'Bahamas', 'AMRO', '75', '5703', '6', '122');
INSERT INTO public.who_global_data_import VALUES (5892, '2020-10-20', 'BS', 'Bahamas', 'AMRO', '70', '5773', '1', '123');
INSERT INTO public.who_global_data_import VALUES (5893, '2020-10-21', 'BS', 'Bahamas', 'AMRO', '150', '5923', '1', '124');
INSERT INTO public.who_global_data_import VALUES (5894, '2020-10-22', 'BS', 'Bahamas', 'AMRO', '128', '6051', '3', '127');
INSERT INTO public.who_global_data_import VALUES (5895, '2020-10-23', 'BS', 'Bahamas', 'AMRO', '84', '6135', '3', '130');
INSERT INTO public.who_global_data_import VALUES (5896, '2020-10-24', 'BS', 'Bahamas', 'AMRO', '133', '6268', '0', '130');
INSERT INTO public.who_global_data_import VALUES (5897, '2020-10-25', 'BS', 'Bahamas', 'AMRO', '0', '6268', '0', '130');
INSERT INTO public.who_global_data_import VALUES (5898, '2020-10-26', 'BS', 'Bahamas', 'AMRO', '142', '6410', '2', '132');
INSERT INTO public.who_global_data_import VALUES (5899, '2020-10-27', 'BS', 'Bahamas', 'AMRO', '56', '6466', '0', '132');
INSERT INTO public.who_global_data_import VALUES (5900, '2020-10-28', 'BS', 'Bahamas', 'AMRO', '36', '6502', '4', '136');
INSERT INTO public.who_global_data_import VALUES (5901, '2020-10-29', 'BS', 'Bahamas', 'AMRO', '47', '6549', '0', '136');
INSERT INTO public.who_global_data_import VALUES (5902, '2020-10-30', 'BS', 'Bahamas', 'AMRO', '58', '6607', '2', '138');
INSERT INTO public.who_global_data_import VALUES (5903, '2020-10-31', 'BS', 'Bahamas', 'AMRO', '37', '6644', '4', '142');
INSERT INTO public.who_global_data_import VALUES (5904, '2020-11-01', 'BS', 'Bahamas', 'AMRO', '0', '6644', '0', '142');
INSERT INTO public.who_global_data_import VALUES (5905, '2020-11-02', 'BS', 'Bahamas', 'AMRO', '91', '6735', '4', '146');
INSERT INTO public.who_global_data_import VALUES (5906, '2020-11-03', 'BS', 'Bahamas', 'AMRO', '24', '6759', '2', '148');
INSERT INTO public.who_global_data_import VALUES (5907, '2020-11-04', 'BS', 'Bahamas', 'AMRO', '31', '6790', '1', '149');
INSERT INTO public.who_global_data_import VALUES (5908, '2020-11-05', 'BS', 'Bahamas', 'AMRO', '53', '6843', '1', '150');
INSERT INTO public.who_global_data_import VALUES (5909, '2020-11-06', 'BS', 'Bahamas', 'AMRO', '39', '6882', '0', '150');
INSERT INTO public.who_global_data_import VALUES (5910, '2020-11-07', 'BS', 'Bahamas', 'AMRO', '34', '6916', '1', '151');
INSERT INTO public.who_global_data_import VALUES (5911, '2020-11-08', 'BS', 'Bahamas', 'AMRO', '0', '6916', '0', '151');
INSERT INTO public.who_global_data_import VALUES (5912, '2020-11-09', 'BS', 'Bahamas', 'AMRO', '31', '6947', '1', '152');
INSERT INTO public.who_global_data_import VALUES (5913, '2020-11-10', 'BS', 'Bahamas', 'AMRO', '37', '6984', '2', '154');
INSERT INTO public.who_global_data_import VALUES (5914, '2020-11-11', 'BS', 'Bahamas', 'AMRO', '28', '7012', '0', '154');
INSERT INTO public.who_global_data_import VALUES (5915, '2020-11-12', 'BS', 'Bahamas', 'AMRO', '48', '7060', '0', '154');
INSERT INTO public.who_global_data_import VALUES (5916, '2020-11-13', 'BS', 'Bahamas', 'AMRO', '64', '7124', '1', '155');
INSERT INTO public.who_global_data_import VALUES (5917, '2020-11-14', 'BS', 'Bahamas', 'AMRO', '39', '7163', '0', '155');
INSERT INTO public.who_global_data_import VALUES (5918, '2020-11-15', 'BS', 'Bahamas', 'AMRO', '0', '7163', '0', '155');
INSERT INTO public.who_global_data_import VALUES (5919, '2020-11-16', 'BS', 'Bahamas', 'AMRO', '0', '7163', '0', '155');
INSERT INTO public.who_global_data_import VALUES (5920, '2020-11-17', 'BS', 'Bahamas', 'AMRO', '93', '7256', '8', '163');
INSERT INTO public.who_global_data_import VALUES (5921, '2020-11-18', 'BS', 'Bahamas', 'AMRO', '56', '7312', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5922, '2020-11-19', 'BS', 'Bahamas', 'AMRO', '11', '7323', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5923, '2020-11-20', 'BS', 'Bahamas', 'AMRO', '25', '7348', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5924, '2020-11-21', 'BS', 'Bahamas', 'AMRO', '19', '7367', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5925, '2020-11-22', 'BS', 'Bahamas', 'AMRO', '0', '7367', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5926, '2020-11-23', 'BS', 'Bahamas', 'AMRO', '46', '7413', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5927, '2020-11-24', 'BS', 'Bahamas', 'AMRO', '18', '7431', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5928, '2020-11-25', 'BS', 'Bahamas', 'AMRO', '29', '7460', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5929, '2020-11-26', 'BS', 'Bahamas', 'AMRO', '9', '7469', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5930, '2020-11-27', 'BS', 'Bahamas', 'AMRO', '13', '7482', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5931, '2020-11-28', 'BS', 'Bahamas', 'AMRO', '14', '7496', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5932, '2020-11-29', 'BS', 'Bahamas', 'AMRO', '0', '7496', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5933, '2020-11-30', 'BS', 'Bahamas', 'AMRO', '7', '7503', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5934, '2020-12-01', 'BS', 'Bahamas', 'AMRO', '14', '7517', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5935, '2020-12-02', 'BS', 'Bahamas', 'AMRO', '24', '7541', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5936, '2020-12-03', 'BS', 'Bahamas', 'AMRO', '2', '7543', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5937, '2020-12-04', 'BS', 'Bahamas', 'AMRO', '6', '7549', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5938, '2020-12-05', 'BS', 'Bahamas', 'AMRO', '16', '7565', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5939, '2020-12-06', 'BS', 'Bahamas', 'AMRO', '5', '7570', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5940, '2020-12-07', 'BS', 'Bahamas', 'AMRO', '5', '7575', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5941, '2020-12-08', 'BS', 'Bahamas', 'AMRO', '4', '7579', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5942, '2020-12-09', 'BS', 'Bahamas', 'AMRO', '1', '7580', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5943, '2020-12-10', 'BS', 'Bahamas', 'AMRO', '5', '7585', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5944, '2020-12-11', 'BS', 'Bahamas', 'AMRO', '38', '7623', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5945, '2020-12-12', 'BS', 'Bahamas', 'AMRO', '0', '7623', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5946, '2020-12-13', 'BS', 'Bahamas', 'AMRO', '36', '7659', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5947, '2020-12-14', 'BS', 'Bahamas', 'AMRO', '15', '7674', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5948, '2020-12-15', 'BS', 'Bahamas', 'AMRO', '16', '7690', '0', '163');
INSERT INTO public.who_global_data_import VALUES (5949, '2020-12-16', 'BS', 'Bahamas', 'AMRO', '8', '7698', '1', '164');
INSERT INTO public.who_global_data_import VALUES (5950, '2020-12-17', 'BS', 'Bahamas', 'AMRO', '16', '7714', '0', '164');
INSERT INTO public.who_global_data_import VALUES (5951, '2020-12-18', 'BS', 'Bahamas', 'AMRO', '11', '7725', '0', '164');
INSERT INTO public.who_global_data_import VALUES (5952, '2020-12-19', 'BS', 'Bahamas', 'AMRO', '8', '7733', '0', '164');
INSERT INTO public.who_global_data_import VALUES (5953, '2020-12-20', 'BS', 'Bahamas', 'AMRO', '0', '7733', '0', '164');
INSERT INTO public.who_global_data_import VALUES (5954, '2020-12-21', 'BS', 'Bahamas', 'AMRO', '32', '7765', '0', '164');
INSERT INTO public.who_global_data_import VALUES (5955, '2020-12-22', 'BS', 'Bahamas', 'AMRO', '3', '7768', '0', '164');
INSERT INTO public.who_global_data_import VALUES (5956, '2020-12-23', 'BS', 'Bahamas', 'AMRO', '4', '7772', '5', '169');
INSERT INTO public.who_global_data_import VALUES (5957, '2020-12-24', 'BS', 'Bahamas', 'AMRO', '6', '7778', '0', '169');
INSERT INTO public.who_global_data_import VALUES (5958, '2020-12-25', 'BS', 'Bahamas', 'AMRO', '10', '7788', '0', '169');
INSERT INTO public.who_global_data_import VALUES (5959, '2020-12-26', 'BS', 'Bahamas', 'AMRO', '0', '7788', '0', '169');
INSERT INTO public.who_global_data_import VALUES (5960, '2020-12-27', 'BS', 'Bahamas', 'AMRO', '0', '7788', '0', '169');
INSERT INTO public.who_global_data_import VALUES (5961, '2020-12-28', 'BS', 'Bahamas', 'AMRO', '0', '7788', '0', '169');
INSERT INTO public.who_global_data_import VALUES (5962, '2020-12-29', 'BS', 'Bahamas', 'AMRO', '46', '7834', '1', '170');
INSERT INTO public.who_global_data_import VALUES (5963, '2020-12-30', 'BS', 'Bahamas', 'AMRO', '12', '7846', '0', '170');
INSERT INTO public.who_global_data_import VALUES (5964, '2020-12-31', 'BS', 'Bahamas', 'AMRO', '11', '7857', '0', '170');
INSERT INTO public.who_global_data_import VALUES (5965, '2021-01-01', 'BS', 'Bahamas', 'AMRO', '14', '7871', '0', '170');
INSERT INTO public.who_global_data_import VALUES (5966, '2021-01-02', 'BS', 'Bahamas', 'AMRO', '16', '7887', '1', '171');
INSERT INTO public.who_global_data_import VALUES (5967, '2021-01-03', 'BS', 'Bahamas', 'AMRO', '12', '7899', '0', '171');
INSERT INTO public.who_global_data_import VALUES (5968, '2021-01-04', 'BS', 'Bahamas', 'AMRO', '15', '7914', '4', '175');
INSERT INTO public.who_global_data_import VALUES (5969, '2021-01-05', 'BS', 'Bahamas', 'AMRO', '10', '7924', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5970, '2021-01-06', 'BS', 'Bahamas', 'AMRO', '4', '7928', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5971, '2021-01-07', 'BS', 'Bahamas', 'AMRO', '17', '7945', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5972, '2021-01-08', 'BS', 'Bahamas', 'AMRO', '14', '7959', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5973, '2021-01-09', 'BS', 'Bahamas', 'AMRO', '10', '7969', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5974, '2021-01-10', 'BS', 'Bahamas', 'AMRO', '8', '7977', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5975, '2021-01-11', 'BS', 'Bahamas', 'AMRO', '18', '7995', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5976, '2021-01-12', 'BS', 'Bahamas', 'AMRO', '9', '8004', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5977, '2021-01-13', 'BS', 'Bahamas', 'AMRO', '0', '8004', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5978, '2021-01-14', 'BS', 'Bahamas', 'AMRO', '0', '8004', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5979, '2021-01-15', 'BS', 'Bahamas', 'AMRO', '17', '8021', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5980, '2021-01-16', 'BS', 'Bahamas', 'AMRO', '11', '8032', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5981, '2021-01-17', 'BS', 'Bahamas', 'AMRO', '0', '8032', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5982, '2021-01-18', 'BS', 'Bahamas', 'AMRO', '0', '8032', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5983, '2021-01-19', 'BS', 'Bahamas', 'AMRO', '35', '8067', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5984, '2021-01-20', 'BS', 'Bahamas', 'AMRO', '1', '8068', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5985, '2021-01-21', 'BS', 'Bahamas', 'AMRO', '7', '8075', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5986, '2021-01-22', 'BS', 'Bahamas', 'AMRO', '13', '8088', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5987, '2021-01-23', 'BS', 'Bahamas', 'AMRO', '13', '8101', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5988, '2021-01-24', 'BS', 'Bahamas', 'AMRO', '9', '8110', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5989, '2021-01-25', 'BS', 'Bahamas', 'AMRO', '17', '8127', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5990, '2021-01-26', 'BS', 'Bahamas', 'AMRO', '6', '8133', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5991, '2021-01-27', 'BS', 'Bahamas', 'AMRO', '7', '8140', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5992, '2021-01-28', 'BS', 'Bahamas', 'AMRO', '21', '8161', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5993, '2021-01-29', 'BS', 'Bahamas', 'AMRO', '6', '8167', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5994, '2021-01-30', 'BS', 'Bahamas', 'AMRO', '0', '8167', '0', '175');
INSERT INTO public.who_global_data_import VALUES (5995, '2021-01-31', 'BS', 'Bahamas', 'AMRO', '7', '8174', '1', '176');
INSERT INTO public.who_global_data_import VALUES (5996, '2021-02-01', 'BS', 'Bahamas', 'AMRO', '9', '8183', '0', '176');
INSERT INTO public.who_global_data_import VALUES (5997, '2021-02-02', 'BS', 'Bahamas', 'AMRO', '24', '8207', '0', '176');
INSERT INTO public.who_global_data_import VALUES (5998, '2021-02-03', 'BS', 'Bahamas', 'AMRO', '18', '8225', '0', '176');
INSERT INTO public.who_global_data_import VALUES (5999, '2021-02-04', 'BS', 'Bahamas', 'AMRO', '6', '8231', '0', '176');
INSERT INTO public.who_global_data_import VALUES (6000, '2021-02-05', 'BS', 'Bahamas', 'AMRO', '16', '8247', '0', '176');
INSERT INTO public.who_global_data_import VALUES (6001, '2020-01-03', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6002, '2020-01-04', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6003, '2020-01-05', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6004, '2020-01-06', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6005, '2020-01-07', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6006, '2020-01-08', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6007, '2020-01-09', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6008, '2020-01-10', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6009, '2020-01-11', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6010, '2020-01-12', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6011, '2020-01-13', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6012, '2020-01-14', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6013, '2020-01-15', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6014, '2020-01-16', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6015, '2020-01-17', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6016, '2020-01-18', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6017, '2020-01-19', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6018, '2020-01-20', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6019, '2020-01-21', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6020, '2020-01-22', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6021, '2020-01-23', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6022, '2020-01-24', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6023, '2020-01-25', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6024, '2020-01-26', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6025, '2020-01-27', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6026, '2020-01-28', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6027, '2020-01-29', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6028, '2020-01-30', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6029, '2020-01-31', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6030, '2020-02-01', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6031, '2020-02-02', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6032, '2020-02-03', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6033, '2020-02-04', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6034, '2020-02-05', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6035, '2020-02-06', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6036, '2020-02-07', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6037, '2020-02-08', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6038, '2020-02-09', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6039, '2020-02-10', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6040, '2020-02-11', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6041, '2020-02-12', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6042, '2020-02-13', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6043, '2020-02-14', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6044, '2020-02-15', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6045, '2020-02-16', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6046, '2020-02-17', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6047, '2020-02-18', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6048, '2020-02-19', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6049, '2020-02-20', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6050, '2020-02-21', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6051, '2020-02-22', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6052, '2020-02-23', 'BH', 'Bahrain', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6053, '2020-02-24', 'BH', 'Bahrain', 'EMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6054, '2020-02-25', 'BH', 'Bahrain', 'EMRO', '15', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6055, '2020-02-26', 'BH', 'Bahrain', 'EMRO', '16', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6056, '2020-02-27', 'BH', 'Bahrain', 'EMRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6057, '2020-02-28', 'BH', 'Bahrain', 'EMRO', '5', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6058, '2020-02-29', 'BH', 'Bahrain', 'EMRO', '2', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6059, '2020-03-01', 'BH', 'Bahrain', 'EMRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6060, '2020-03-02', 'BH', 'Bahrain', 'EMRO', '9', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6061, '2020-03-03', 'BH', 'Bahrain', 'EMRO', '0', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6062, '2020-03-04', 'BH', 'Bahrain', 'EMRO', '0', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6063, '2020-03-05', 'BH', 'Bahrain', 'EMRO', '0', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6064, '2020-03-06', 'BH', 'Bahrain', 'EMRO', '0', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6065, '2020-03-07', 'BH', 'Bahrain', 'EMRO', '7', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6066, '2020-03-08', 'BH', 'Bahrain', 'EMRO', '23', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6067, '2020-03-09', 'BH', 'Bahrain', 'EMRO', '16', '99', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6068, '2020-03-10', 'BH', 'Bahrain', 'EMRO', '15', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6069, '2020-03-11', 'BH', 'Bahrain', 'EMRO', '79', '193', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6070, '2020-03-12', 'BH', 'Bahrain', 'EMRO', '6', '199', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6071, '2020-03-13', 'BH', 'Bahrain', 'EMRO', '0', '199', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6072, '2020-03-14', 'BH', 'Bahrain', 'EMRO', '16', '215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6073, '2020-03-15', 'BH', 'Bahrain', 'EMRO', '3', '218', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6074, '2020-03-16', 'BH', 'Bahrain', 'EMRO', '7', '225', '1', '1');
INSERT INTO public.who_global_data_import VALUES (6075, '2020-03-17', 'BH', 'Bahrain', 'EMRO', '16', '241', '0', '1');
INSERT INTO public.who_global_data_import VALUES (6076, '2020-03-18', 'BH', 'Bahrain', 'EMRO', '19', '260', '0', '1');
INSERT INTO public.who_global_data_import VALUES (6077, '2020-03-19', 'BH', 'Bahrain', 'EMRO', '13', '273', '0', '1');
INSERT INTO public.who_global_data_import VALUES (6078, '2020-03-20', 'BH', 'Bahrain', 'EMRO', '12', '285', '0', '1');
INSERT INTO public.who_global_data_import VALUES (6079, '2020-03-21', 'BH', 'Bahrain', 'EMRO', '21', '306', '0', '1');
INSERT INTO public.who_global_data_import VALUES (6080, '2020-03-22', 'BH', 'Bahrain', 'EMRO', '28', '334', '1', '2');
INSERT INTO public.who_global_data_import VALUES (6081, '2020-03-23', 'BH', 'Bahrain', 'EMRO', '5', '339', '0', '2');
INSERT INTO public.who_global_data_import VALUES (6082, '2020-03-24', 'BH', 'Bahrain', 'EMRO', '51', '390', '1', '3');
INSERT INTO public.who_global_data_import VALUES (6083, '2020-03-25', 'BH', 'Bahrain', 'EMRO', '29', '419', '0', '3');
INSERT INTO public.who_global_data_import VALUES (6084, '2020-03-26', 'BH', 'Bahrain', 'EMRO', '38', '457', '1', '4');
INSERT INTO public.who_global_data_import VALUES (6085, '2020-03-27', 'BH', 'Bahrain', 'EMRO', '9', '466', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6086, '2020-03-28', 'BH', 'Bahrain', 'EMRO', '7', '473', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6087, '2020-03-29', 'BH', 'Bahrain', 'EMRO', '26', '499', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6088, '2020-03-30', 'BH', 'Bahrain', 'EMRO', '16', '515', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6089, '2020-03-31', 'BH', 'Bahrain', 'EMRO', '52', '567', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6090, '2020-04-01', 'BH', 'Bahrain', 'EMRO', '2', '569', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6091, '2020-04-02', 'BH', 'Bahrain', 'EMRO', '66', '635', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6092, '2020-04-03', 'BH', 'Bahrain', 'EMRO', '37', '672', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6093, '2020-04-04', 'BH', 'Bahrain', 'EMRO', '16', '688', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6094, '2020-04-05', 'BH', 'Bahrain', 'EMRO', '10', '698', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6095, '2020-04-06', 'BH', 'Bahrain', 'EMRO', '25', '723', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6096, '2020-04-07', 'BH', 'Bahrain', 'EMRO', '88', '811', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6097, '2020-04-08', 'BH', 'Bahrain', 'EMRO', '10', '821', '1', '5');
INSERT INTO public.who_global_data_import VALUES (6098, '2020-04-09', 'BH', 'Bahrain', 'EMRO', '34', '855', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6099, '2020-04-10', 'BH', 'Bahrain', 'EMRO', '58', '913', '1', '6');
INSERT INTO public.who_global_data_import VALUES (6100, '2020-04-11', 'BH', 'Bahrain', 'EMRO', '103', '1016', '0', '6');
INSERT INTO public.who_global_data_import VALUES (6101, '2020-04-12', 'BH', 'Bahrain', 'EMRO', '71', '1087', '0', '6');
INSERT INTO public.who_global_data_import VALUES (6102, '2020-04-13', 'BH', 'Bahrain', 'EMRO', '261', '1348', '0', '6');
INSERT INTO public.who_global_data_import VALUES (6103, '2020-04-14', 'BH', 'Bahrain', 'EMRO', '180', '1528', '1', '7');
INSERT INTO public.who_global_data_import VALUES (6104, '2020-04-15', 'BH', 'Bahrain', 'EMRO', '143', '1671', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6105, '2020-04-16', 'BH', 'Bahrain', 'EMRO', '27', '1698', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6106, '2020-04-17', 'BH', 'Bahrain', 'EMRO', '42', '1740', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6107, '2020-04-18', 'BH', 'Bahrain', 'EMRO', '27', '1767', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6108, '2020-04-19', 'BH', 'Bahrain', 'EMRO', '106', '1873', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6109, '2020-04-20', 'BH', 'Bahrain', 'EMRO', '22', '1895', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6110, '2020-04-21', 'BH', 'Bahrain', 'EMRO', '57', '1952', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6111, '2020-04-22', 'BH', 'Bahrain', 'EMRO', '55', '2007', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6112, '2020-04-23', 'BH', 'Bahrain', 'EMRO', '91', '2098', '1', '8');
INSERT INTO public.who_global_data_import VALUES (6113, '2020-04-24', 'BH', 'Bahrain', 'EMRO', '408', '2506', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6114, '2020-04-25', 'BH', 'Bahrain', 'EMRO', '82', '2588', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6115, '2020-04-26', 'BH', 'Bahrain', 'EMRO', '45', '2633', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6116, '2020-04-27', 'BH', 'Bahrain', 'EMRO', '75', '2708', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6117, '2020-04-28', 'BH', 'Bahrain', 'EMRO', '102', '2810', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6118, '2020-04-29', 'BH', 'Bahrain', 'EMRO', '59', '2869', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6119, '2020-04-30', 'BH', 'Bahrain', 'EMRO', '168', '3037', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6120, '2020-05-01', 'BH', 'Bahrain', 'EMRO', '132', '3169', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6121, '2020-05-02', 'BH', 'Bahrain', 'EMRO', '104', '3273', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6122, '2020-05-03', 'BH', 'Bahrain', 'EMRO', '83', '3356', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6123, '2020-05-04', 'BH', 'Bahrain', 'EMRO', '108', '3464', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6124, '2020-05-05', 'BH', 'Bahrain', 'EMRO', '215', '3679', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6125, '2020-05-06', 'BH', 'Bahrain', 'EMRO', '163', '3842', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6126, '2020-05-07', 'BH', 'Bahrain', 'EMRO', '289', '4131', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6127, '2020-05-08', 'BH', 'Bahrain', 'EMRO', '273', '4404', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6128, '2020-05-09', 'BH', 'Bahrain', 'EMRO', '191', '4595', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6129, '2020-05-10', 'BH', 'Bahrain', 'EMRO', '261', '4856', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6130, '2020-05-11', 'BH', 'Bahrain', 'EMRO', '301', '5157', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6131, '2020-05-12', 'BH', 'Bahrain', 'EMRO', '252', '5409', '1', '9');
INSERT INTO public.who_global_data_import VALUES (6132, '2020-05-13', 'BH', 'Bahrain', 'EMRO', '371', '5780', '0', '9');
INSERT INTO public.who_global_data_import VALUES (6133, '2020-05-14', 'BH', 'Bahrain', 'EMRO', '289', '6069', '1', '10');
INSERT INTO public.who_global_data_import VALUES (6134, '2020-05-15', 'BH', 'Bahrain', 'EMRO', '349', '6418', '0', '10');
INSERT INTO public.who_global_data_import VALUES (6135, '2020-05-16', 'BH', 'Bahrain', 'EMRO', '237', '6655', '2', '12');
INSERT INTO public.who_global_data_import VALUES (6136, '2020-05-17', 'BH', 'Bahrain', 'EMRO', '275', '6930', '0', '12');
INSERT INTO public.who_global_data_import VALUES (6137, '2020-05-18', 'BH', 'Bahrain', 'EMRO', '226', '7156', '0', '12');
INSERT INTO public.who_global_data_import VALUES (6138, '2020-05-19', 'BH', 'Bahrain', 'EMRO', '218', '7374', '0', '12');
INSERT INTO public.who_global_data_import VALUES (6139, '2020-05-20', 'BH', 'Bahrain', 'EMRO', '158', '7532', '0', '12');
INSERT INTO public.who_global_data_import VALUES (6140, '2020-05-21', 'BH', 'Bahrain', 'EMRO', '507', '8039', '0', '12');
INSERT INTO public.who_global_data_import VALUES (6141, '2020-05-22', 'BH', 'Bahrain', 'EMRO', '135', '8174', '0', '12');
INSERT INTO public.who_global_data_import VALUES (6142, '2020-05-23', 'BH', 'Bahrain', 'EMRO', '240', '8414', '0', '12');
INSERT INTO public.who_global_data_import VALUES (6143, '2020-05-24', 'BH', 'Bahrain', 'EMRO', '388', '8802', '1', '13');
INSERT INTO public.who_global_data_import VALUES (6144, '2020-05-25', 'BH', 'Bahrain', 'EMRO', '336', '9138', '0', '13');
INSERT INTO public.who_global_data_import VALUES (6145, '2020-05-26', 'BH', 'Bahrain', 'EMRO', '33', '9171', '1', '14');
INSERT INTO public.who_global_data_import VALUES (6146, '2020-05-27', 'BH', 'Bahrain', 'EMRO', '195', '9366', '0', '14');
INSERT INTO public.who_global_data_import VALUES (6147, '2020-05-28', 'BH', 'Bahrain', 'EMRO', '326', '9692', '1', '15');
INSERT INTO public.who_global_data_import VALUES (6148, '2020-05-29', 'BH', 'Bahrain', 'EMRO', '360', '10052', '0', '15');
INSERT INTO public.who_global_data_import VALUES (6149, '2020-05-30', 'BH', 'Bahrain', 'EMRO', '397', '10449', '0', '15');
INSERT INTO public.who_global_data_import VALUES (6150, '2020-05-31', 'BH', 'Bahrain', 'EMRO', '344', '10793', '2', '17');
INSERT INTO public.who_global_data_import VALUES (6151, '2020-06-01', 'BH', 'Bahrain', 'EMRO', '605', '11398', '2', '19');
INSERT INTO public.who_global_data_import VALUES (6152, '2020-06-02', 'BH', 'Bahrain', 'EMRO', '473', '11871', '0', '19');
INSERT INTO public.who_global_data_import VALUES (6153, '2020-06-03', 'BH', 'Bahrain', 'EMRO', '440', '12311', '0', '19');
INSERT INTO public.who_global_data_import VALUES (6154, '2020-06-04', 'BH', 'Bahrain', 'EMRO', '504', '12815', '1', '20');
INSERT INTO public.who_global_data_import VALUES (6155, '2020-06-05', 'BH', 'Bahrain', 'EMRO', '481', '13296', '1', '21');
INSERT INTO public.who_global_data_import VALUES (6156, '2020-06-06', 'BH', 'Bahrain', 'EMRO', '539', '13835', '1', '22');
INSERT INTO public.who_global_data_import VALUES (6157, '2020-06-07', 'BH', 'Bahrain', 'EMRO', '548', '14383', '2', '24');
INSERT INTO public.who_global_data_import VALUES (6158, '2020-06-08', 'BH', 'Bahrain', 'EMRO', '379', '14762', '2', '26');
INSERT INTO public.who_global_data_import VALUES (6159, '2020-06-09', 'BH', 'Bahrain', 'EMRO', '654', '15416', '1', '27');
INSERT INTO public.who_global_data_import VALUES (6160, '2020-06-10', 'BH', 'Bahrain', 'EMRO', '783', '16199', '2', '29');
INSERT INTO public.who_global_data_import VALUES (6161, '2020-06-11', 'BH', 'Bahrain', 'EMRO', '468', '16667', '3', '32');
INSERT INTO public.who_global_data_import VALUES (6162, '2020-06-12', 'BH', 'Bahrain', 'EMRO', '602', '17269', '4', '36');
INSERT INTO public.who_global_data_import VALUES (6163, '2020-06-13', 'BH', 'Bahrain', 'EMRO', '444', '17713', '0', '36');
INSERT INTO public.who_global_data_import VALUES (6164, '2020-06-14', 'BH', 'Bahrain', 'EMRO', '514', '18227', '3', '39');
INSERT INTO public.who_global_data_import VALUES (6165, '2020-06-15', 'BH', 'Bahrain', 'EMRO', '317', '18544', '4', '43');
INSERT INTO public.who_global_data_import VALUES (6166, '2020-06-16', 'BH', 'Bahrain', 'EMRO', '469', '19013', '3', '46');
INSERT INTO public.who_global_data_import VALUES (6167, '2020-06-17', 'BH', 'Bahrain', 'EMRO', '540', '19553', '1', '47');
INSERT INTO public.who_global_data_import VALUES (6168, '2020-06-18', 'BH', 'Bahrain', 'EMRO', '408', '19961', '2', '49');
INSERT INTO public.who_global_data_import VALUES (6169, '2020-06-19', 'BH', 'Bahrain', 'EMRO', '469', '20430', '6', '55');
INSERT INTO public.who_global_data_import VALUES (6170, '2020-06-20', 'BH', 'Bahrain', 'EMRO', '486', '20916', '2', '57');
INSERT INTO public.who_global_data_import VALUES (6171, '2020-06-21', 'BH', 'Bahrain', 'EMRO', '415', '21331', '3', '60');
INSERT INTO public.who_global_data_import VALUES (6172, '2020-06-22', 'BH', 'Bahrain', 'EMRO', '433', '21764', '3', '63');
INSERT INTO public.who_global_data_import VALUES (6173, '2020-06-23', 'BH', 'Bahrain', 'EMRO', '643', '22407', '2', '65');
INSERT INTO public.who_global_data_import VALUES (6174, '2020-06-24', 'BH', 'Bahrain', 'EMRO', '655', '23062', '2', '67');
INSERT INTO public.who_global_data_import VALUES (6175, '2020-06-25', 'BH', 'Bahrain', 'EMRO', '508', '23570', '2', '69');
INSERT INTO public.who_global_data_import VALUES (6176, '2020-06-26', 'BH', 'Bahrain', 'EMRO', '511', '24081', '2', '71');
INSERT INTO public.who_global_data_import VALUES (6177, '2020-06-27', 'BH', 'Bahrain', 'EMRO', '724', '24805', '2', '73');
INSERT INTO public.who_global_data_import VALUES (6178, '2020-06-28', 'BH', 'Bahrain', 'EMRO', '462', '25267', '5', '78');
INSERT INTO public.who_global_data_import VALUES (6179, '2020-06-29', 'BH', 'Bahrain', 'EMRO', '438', '25705', '5', '83');
INSERT INTO public.who_global_data_import VALUES (6180, '2020-06-30', 'BH', 'Bahrain', 'EMRO', '534', '26239', '1', '84');
INSERT INTO public.who_global_data_import VALUES (6181, '2020-07-01', 'BH', 'Bahrain', 'EMRO', '519', '26758', '3', '87');
INSERT INTO public.who_global_data_import VALUES (6182, '2020-07-02', 'BH', 'Bahrain', 'EMRO', '656', '27414', '5', '92');
INSERT INTO public.who_global_data_import VALUES (6183, '2020-07-03', 'BH', 'Bahrain', 'EMRO', '423', '27837', '2', '94');
INSERT INTO public.who_global_data_import VALUES (6184, '2020-07-04', 'BH', 'Bahrain', 'EMRO', '573', '28410', '1', '95');
INSERT INTO public.who_global_data_import VALUES (6185, '2020-07-05', 'BH', 'Bahrain', 'EMRO', '447', '28857', '1', '96');
INSERT INTO public.who_global_data_import VALUES (6186, '2020-07-06', 'BH', 'Bahrain', 'EMRO', '510', '29367', '1', '97');
INSERT INTO public.who_global_data_import VALUES (6187, '2020-07-07', 'BH', 'Bahrain', 'EMRO', '454', '29821', '1', '98');
INSERT INTO public.who_global_data_import VALUES (6188, '2020-07-08', 'BH', 'Bahrain', 'EMRO', '500', '30321', '0', '98');
INSERT INTO public.who_global_data_import VALUES (6189, '2020-07-09', 'BH', 'Bahrain', 'EMRO', '610', '30931', '0', '98');
INSERT INTO public.who_global_data_import VALUES (6190, '2020-07-10', 'BH', 'Bahrain', 'EMRO', '597', '31528', '5', '103');
INSERT INTO public.who_global_data_import VALUES (6191, '2020-07-11', 'BH', 'Bahrain', 'EMRO', '511', '32039', '1', '104');
INSERT INTO public.who_global_data_import VALUES (6192, '2020-07-12', 'BH', 'Bahrain', 'EMRO', '431', '32470', '0', '104');
INSERT INTO public.who_global_data_import VALUES (6193, '2020-07-13', 'BH', 'Bahrain', 'EMRO', '471', '32941', '4', '108');
INSERT INTO public.who_global_data_import VALUES (6194, '2020-07-14', 'BH', 'Bahrain', 'EMRO', '535', '33476', '1', '109');
INSERT INTO public.who_global_data_import VALUES (6195, '2020-07-15', 'BH', 'Bahrain', 'EMRO', '602', '34078', '2', '111');
INSERT INTO public.who_global_data_import VALUES (6196, '2020-07-16', 'BH', 'Bahrain', 'EMRO', '482', '34560', '6', '117');
INSERT INTO public.who_global_data_import VALUES (6197, '2020-07-17', 'BH', 'Bahrain', 'EMRO', '524', '35084', '4', '121');
INSERT INTO public.who_global_data_import VALUES (6198, '2020-07-18', 'BH', 'Bahrain', 'EMRO', '389', '35473', '3', '124');
INSERT INTO public.who_global_data_import VALUES (6199, '2020-07-19', 'BH', 'Bahrain', 'EMRO', '531', '36004', '0', '124');
INSERT INTO public.who_global_data_import VALUES (6200, '2020-07-20', 'BH', 'Bahrain', 'EMRO', '418', '36422', '2', '126');
INSERT INTO public.who_global_data_import VALUES (6201, '2020-07-21', 'BH', 'Bahrain', 'EMRO', '514', '36936', '2', '128');
INSERT INTO public.who_global_data_import VALUES (6202, '2020-07-22', 'BH', 'Bahrain', 'EMRO', '380', '37316', '1', '129');
INSERT INTO public.who_global_data_import VALUES (6203, '2020-07-23', 'BH', 'Bahrain', 'EMRO', '321', '37637', '1', '130');
INSERT INTO public.who_global_data_import VALUES (6204, '2020-07-24', 'BH', 'Bahrain', 'EMRO', '359', '37996', '4', '134');
INSERT INTO public.who_global_data_import VALUES (6205, '2020-07-25', 'BH', 'Bahrain', 'EMRO', '462', '38458', '2', '136');
INSERT INTO public.who_global_data_import VALUES (6206, '2020-07-26', 'BH', 'Bahrain', 'EMRO', '289', '38747', '1', '137');
INSERT INTO public.who_global_data_import VALUES (6207, '2020-07-27', 'BH', 'Bahrain', 'EMRO', '384', '39131', '4', '141');
INSERT INTO public.who_global_data_import VALUES (6208, '2020-07-28', 'BH', 'Bahrain', 'EMRO', '351', '39482', '0', '141');
INSERT INTO public.who_global_data_import VALUES (6209, '2020-07-29', 'BH', 'Bahrain', 'EMRO', '439', '39921', '0', '141');
INSERT INTO public.who_global_data_import VALUES (6210, '2020-07-30', 'BH', 'Bahrain', 'EMRO', '390', '40311', '3', '144');
INSERT INTO public.who_global_data_import VALUES (6211, '2020-07-31', 'BH', 'Bahrain', 'EMRO', '444', '40755', '2', '146');
INSERT INTO public.who_global_data_import VALUES (6212, '2020-08-01', 'BH', 'Bahrain', 'EMRO', '227', '40982', '1', '147');
INSERT INTO public.who_global_data_import VALUES (6213, '2020-08-02', 'BH', 'Bahrain', 'EMRO', '208', '41190', '0', '147');
INSERT INTO public.who_global_data_import VALUES (6214, '2020-08-03', 'BH', 'Bahrain', 'EMRO', '346', '41536', '0', '147');
INSERT INTO public.who_global_data_import VALUES (6215, '2020-08-04', 'BH', 'Bahrain', 'EMRO', '299', '41835', '3', '150');
INSERT INTO public.who_global_data_import VALUES (6216, '2020-08-05', 'BH', 'Bahrain', 'EMRO', '297', '42132', '2', '152');
INSERT INTO public.who_global_data_import VALUES (6217, '2020-08-06', 'BH', 'Bahrain', 'EMRO', '382', '42514', '4', '156');
INSERT INTO public.who_global_data_import VALUES (6218, '2020-08-07', 'BH', 'Bahrain', 'EMRO', '375', '42889', '0', '156');
INSERT INTO public.who_global_data_import VALUES (6219, '2020-08-08', 'BH', 'Bahrain', 'EMRO', '418', '43307', '3', '159');
INSERT INTO public.who_global_data_import VALUES (6220, '2020-08-09', 'BH', 'Bahrain', 'EMRO', '322', '43629', '2', '161');
INSERT INTO public.who_global_data_import VALUES (6221, '2020-08-10', 'BH', 'Bahrain', 'EMRO', '382', '44011', '1', '162');
INSERT INTO public.who_global_data_import VALUES (6222, '2020-08-11', 'BH', 'Bahrain', 'EMRO', '386', '44397', '1', '163');
INSERT INTO public.who_global_data_import VALUES (6223, '2020-08-12', 'BH', 'Bahrain', 'EMRO', '407', '44804', '2', '165');
INSERT INTO public.who_global_data_import VALUES (6224, '2020-08-13', 'BH', 'Bahrain', 'EMRO', '460', '45264', '1', '166');
INSERT INTO public.who_global_data_import VALUES (6225, '2020-08-14', 'BH', 'Bahrain', 'EMRO', '462', '45726', '1', '167');
INSERT INTO public.who_global_data_import VALUES (6226, '2020-08-15', 'BH', 'Bahrain', 'EMRO', '326', '46052', '1', '168');
INSERT INTO public.who_global_data_import VALUES (6227, '2020-08-16', 'BH', 'Bahrain', 'EMRO', '378', '46430', '2', '170');
INSERT INTO public.who_global_data_import VALUES (6228, '2020-08-17', 'BH', 'Bahrain', 'EMRO', '405', '46835', '0', '170');
INSERT INTO public.who_global_data_import VALUES (6229, '2020-08-18', 'BH', 'Bahrain', 'EMRO', '350', '47185', '3', '173');
INSERT INTO public.who_global_data_import VALUES (6230, '2020-08-19', 'BH', 'Bahrain', 'EMRO', '396', '47581', '2', '175');
INSERT INTO public.who_global_data_import VALUES (6231, '2020-08-20', 'BH', 'Bahrain', 'EMRO', '369', '47950', '3', '178');
INSERT INTO public.who_global_data_import VALUES (6232, '2020-08-21', 'BH', 'Bahrain', 'EMRO', '353', '48303', '1', '179');
INSERT INTO public.who_global_data_import VALUES (6233, '2020-08-22', 'BH', 'Bahrain', 'EMRO', '358', '48661', '2', '181');
INSERT INTO public.who_global_data_import VALUES (6234, '2020-08-23', 'BH', 'Bahrain', 'EMRO', '377', '49038', '2', '183');
INSERT INTO public.who_global_data_import VALUES (6235, '2020-08-24', 'BH', 'Bahrain', 'EMRO', '292', '49330', '1', '184');
INSERT INTO public.who_global_data_import VALUES (6236, '2020-08-25', 'BH', 'Bahrain', 'EMRO', '389', '49719', '1', '185');
INSERT INTO public.who_global_data_import VALUES (6237, '2020-08-26', 'BH', 'Bahrain', 'EMRO', '357', '50076', '1', '186');
INSERT INTO public.who_global_data_import VALUES (6238, '2020-08-27', 'BH', 'Bahrain', 'EMRO', '317', '50393', '0', '186');
INSERT INTO public.who_global_data_import VALUES (6239, '2020-08-28', 'BH', 'Bahrain', 'EMRO', '363', '50756', '2', '188');
INSERT INTO public.who_global_data_import VALUES (6240, '2020-08-29', 'BH', 'Bahrain', 'EMRO', '357', '51113', '1', '189');
INSERT INTO public.who_global_data_import VALUES (6241, '2020-08-30', 'BH', 'Bahrain', 'EMRO', '278', '51391', '0', '189');
INSERT INTO public.who_global_data_import VALUES (6242, '2020-08-31', 'BH', 'Bahrain', 'EMRO', '183', '51574', '0', '189');
INSERT INTO public.who_global_data_import VALUES (6243, '2020-09-01', 'BH', 'Bahrain', 'EMRO', '398', '51972', '1', '190');
INSERT INTO public.who_global_data_import VALUES (6244, '2020-09-02', 'BH', 'Bahrain', 'EMRO', '468', '52440', '0', '190');
INSERT INTO public.who_global_data_import VALUES (6245, '2020-09-03', 'BH', 'Bahrain', 'EMRO', '367', '52807', '0', '190');
INSERT INTO public.who_global_data_import VALUES (6246, '2020-09-04', 'BH', 'Bahrain', 'EMRO', '626', '53433', '0', '190');
INSERT INTO public.who_global_data_import VALUES (6247, '2020-09-05', 'BH', 'Bahrain', 'EMRO', '662', '54095', '5', '195');
INSERT INTO public.who_global_data_import VALUES (6248, '2020-09-06', 'BH', 'Bahrain', 'EMRO', '676', '54771', '1', '196');
INSERT INTO public.who_global_data_import VALUES (6249, '2020-09-07', 'BH', 'Bahrain', 'EMRO', '644', '55415', '3', '199');
INSERT INTO public.who_global_data_import VALUES (6250, '2020-09-08', 'BH', 'Bahrain', 'EMRO', '661', '56076', '1', '200');
INSERT INTO public.who_global_data_import VALUES (6251, '2020-09-09', 'BH', 'Bahrain', 'EMRO', '702', '56778', '2', '202');
INSERT INTO public.who_global_data_import VALUES (6252, '2020-09-10', 'BH', 'Bahrain', 'EMRO', '672', '57450', '1', '203');
INSERT INTO public.who_global_data_import VALUES (6253, '2020-09-11', 'BH', 'Bahrain', 'EMRO', '757', '58207', '4', '207');
INSERT INTO public.who_global_data_import VALUES (6254, '2020-09-12', 'BH', 'Bahrain', 'EMRO', '632', '58839', '1', '208');
INSERT INTO public.who_global_data_import VALUES (6255, '2020-09-13', 'BH', 'Bahrain', 'EMRO', '747', '59586', '4', '212');
INSERT INTO public.who_global_data_import VALUES (6256, '2020-09-14', 'BH', 'Bahrain', 'EMRO', '721', '60307', '1', '213');
INSERT INTO public.who_global_data_import VALUES (6257, '2020-09-15', 'BH', 'Bahrain', 'EMRO', '658', '60965', '0', '213');
INSERT INTO public.who_global_data_import VALUES (6258, '2020-09-16', 'BH', 'Bahrain', 'EMRO', '678', '61643', '0', '213');
INSERT INTO public.who_global_data_import VALUES (6259, '2020-09-17', 'BH', 'Bahrain', 'EMRO', '841', '62484', '3', '216');
INSERT INTO public.who_global_data_import VALUES (6260, '2020-09-18', 'BH', 'Bahrain', 'EMRO', '705', '63189', '1', '217');
INSERT INTO public.who_global_data_import VALUES (6261, '2020-09-19', 'BH', 'Bahrain', 'EMRO', '690', '63879', '3', '220');
INSERT INTO public.who_global_data_import VALUES (6262, '2020-09-20', 'BH', 'Bahrain', 'EMRO', '620', '64499', '1', '221');
INSERT INTO public.who_global_data_import VALUES (6263, '2020-09-21', 'BH', 'Bahrain', 'EMRO', '540', '65039', '0', '221');
INSERT INTO public.who_global_data_import VALUES (6264, '2020-09-22', 'BH', 'Bahrain', 'EMRO', '713', '65752', '3', '224');
INSERT INTO public.who_global_data_import VALUES (6265, '2020-09-23', 'BH', 'Bahrain', 'EMRO', '650', '66402', '3', '227');
INSERT INTO public.who_global_data_import VALUES (6266, '2020-09-24', 'BH', 'Bahrain', 'EMRO', '612', '67014', '4', '231');
INSERT INTO public.who_global_data_import VALUES (6267, '2020-09-25', 'BH', 'Bahrain', 'EMRO', '687', '67701', '0', '231');
INSERT INTO public.who_global_data_import VALUES (6268, '2020-09-26', 'BH', 'Bahrain', 'EMRO', '489', '68190', '5', '236');
INSERT INTO public.who_global_data_import VALUES (6269, '2020-09-27', 'BH', 'Bahrain', 'EMRO', '585', '68775', '3', '239');
INSERT INTO public.who_global_data_import VALUES (6270, '2020-09-28', 'BH', 'Bahrain', 'EMRO', '586', '69361', '3', '242');
INSERT INTO public.who_global_data_import VALUES (6271, '2020-09-29', 'BH', 'Bahrain', 'EMRO', '487', '69848', '3', '245');
INSERT INTO public.who_global_data_import VALUES (6272, '2020-09-30', 'BH', 'Bahrain', 'EMRO', '574', '70422', '1', '246');
INSERT INTO public.who_global_data_import VALUES (6273, '2020-10-01', 'BH', 'Bahrain', 'EMRO', '442', '70864', '5', '251');
INSERT INTO public.who_global_data_import VALUES (6274, '2020-10-02', 'BH', 'Bahrain', 'EMRO', '510', '71374', '3', '254');
INSERT INTO public.who_global_data_import VALUES (6275, '2020-10-03', 'BH', 'Bahrain', 'EMRO', '429', '71803', '1', '255');
INSERT INTO public.who_global_data_import VALUES (6276, '2020-10-04', 'BH', 'Bahrain', 'EMRO', '507', '72310', '3', '258');
INSERT INTO public.who_global_data_import VALUES (6277, '2020-10-05', 'BH', 'Bahrain', 'EMRO', '352', '72662', '2', '260');
INSERT INTO public.who_global_data_import VALUES (6278, '2020-10-06', 'BH', 'Bahrain', 'EMRO', '454', '73116', '1', '261');
INSERT INTO public.who_global_data_import VALUES (6279, '2020-10-07', 'BH', 'Bahrain', 'EMRO', '360', '73476', '1', '262');
INSERT INTO public.who_global_data_import VALUES (6280, '2020-10-08', 'BH', 'Bahrain', 'EMRO', '456', '73932', '0', '262');
INSERT INTO public.who_global_data_import VALUES (6281, '2020-10-09', 'BH', 'Bahrain', 'EMRO', '490', '74422', '2', '264');
INSERT INTO public.who_global_data_import VALUES (6282, '2020-10-10', 'BH', 'Bahrain', 'EMRO', '438', '74860', '7', '271');
INSERT INTO public.who_global_data_import VALUES (6283, '2020-10-11', 'BH', 'Bahrain', 'EMRO', '427', '75287', '2', '273');
INSERT INTO public.who_global_data_import VALUES (6284, '2020-10-12', 'BH', 'Bahrain', 'EMRO', '327', '75614', '2', '275');
INSERT INTO public.who_global_data_import VALUES (6285, '2020-10-13', 'BH', 'Bahrain', 'EMRO', '334', '75948', '5', '280');
INSERT INTO public.who_global_data_import VALUES (6286, '2020-10-14', 'BH', 'Bahrain', 'EMRO', '324', '76272', '5', '285');
INSERT INTO public.who_global_data_import VALUES (6287, '2020-10-15', 'BH', 'Bahrain', 'EMRO', '349', '76621', '2', '287');
INSERT INTO public.who_global_data_import VALUES (6288, '2020-10-16', 'BH', 'Bahrain', 'EMRO', '333', '76954', '2', '289');
INSERT INTO public.who_global_data_import VALUES (6289, '2020-10-17', 'BH', 'Bahrain', 'EMRO', '371', '77325', '3', '292');
INSERT INTO public.who_global_data_import VALUES (6290, '2020-10-18', 'BH', 'Bahrain', 'EMRO', '246', '77571', '1', '293');
INSERT INTO public.who_global_data_import VALUES (6291, '2020-10-19', 'BH', 'Bahrain', 'EMRO', '331', '77902', '7', '300');
INSERT INTO public.who_global_data_import VALUES (6292, '2020-10-20', 'BH', 'Bahrain', 'EMRO', '322', '78224', '2', '302');
INSERT INTO public.who_global_data_import VALUES (6293, '2020-10-21', 'BH', 'Bahrain', 'EMRO', '309', '78533', '3', '305');
INSERT INTO public.who_global_data_import VALUES (6294, '2020-10-22', 'BH', 'Bahrain', 'EMRO', '374', '78907', '3', '308');
INSERT INTO public.who_global_data_import VALUES (6295, '2020-10-23', 'BH', 'Bahrain', 'EMRO', '304', '79211', '0', '308');
INSERT INTO public.who_global_data_import VALUES (6296, '2020-10-24', 'BH', 'Bahrain', 'EMRO', '363', '79574', '3', '311');
INSERT INTO public.who_global_data_import VALUES (6297, '2020-10-25', 'BH', 'Bahrain', 'EMRO', '401', '79975', '1', '312');
INSERT INTO public.who_global_data_import VALUES (6298, '2020-10-26', 'BH', 'Bahrain', 'EMRO', '280', '80255', '0', '312');
INSERT INTO public.who_global_data_import VALUES (6299, '2020-10-27', 'BH', 'Bahrain', 'EMRO', '278', '80533', '4', '316');
INSERT INTO public.who_global_data_import VALUES (6300, '2020-10-28', 'BH', 'Bahrain', 'EMRO', '232', '80765', '0', '316');
INSERT INTO public.who_global_data_import VALUES (6301, '2020-10-29', 'BH', 'Bahrain', 'EMRO', '257', '81022', '1', '317');
INSERT INTO public.who_global_data_import VALUES (6302, '2020-10-30', 'BH', 'Bahrain', 'EMRO', '240', '81262', '0', '317');
INSERT INTO public.who_global_data_import VALUES (6303, '2020-10-31', 'BH', 'Bahrain', 'EMRO', '204', '81466', '2', '319');
INSERT INTO public.who_global_data_import VALUES (6304, '2020-11-01', 'BH', 'Bahrain', 'EMRO', '179', '81645', '2', '321');
INSERT INTO public.who_global_data_import VALUES (6305, '2020-11-02', 'BH', 'Bahrain', 'EMRO', '278', '81923', '0', '321');
INSERT INTO public.who_global_data_import VALUES (6306, '2020-11-03', 'BH', 'Bahrain', 'EMRO', '210', '82133', '1', '322');
INSERT INTO public.who_global_data_import VALUES (6307, '2020-11-04', 'BH', 'Bahrain', 'EMRO', '230', '82363', '2', '324');
INSERT INTO public.who_global_data_import VALUES (6308, '2020-11-05', 'BH', 'Bahrain', 'EMRO', '261', '82624', '3', '327');
INSERT INTO public.who_global_data_import VALUES (6309, '2020-11-06', 'BH', 'Bahrain', 'EMRO', '162', '82786', '1', '328');
INSERT INTO public.who_global_data_import VALUES (6310, '2020-11-07', 'BH', 'Bahrain', 'EMRO', '237', '83023', '0', '328');
INSERT INTO public.who_global_data_import VALUES (6311, '2020-11-08', 'BH', 'Bahrain', 'EMRO', '241', '83264', '1', '329');
INSERT INTO public.who_global_data_import VALUES (6312, '2020-11-09', 'BH', 'Bahrain', 'EMRO', '192', '83456', '0', '329');
INSERT INTO public.who_global_data_import VALUES (6313, '2020-11-10', 'BH', 'Bahrain', 'EMRO', '176', '83632', '0', '329');
INSERT INTO public.who_global_data_import VALUES (6314, '2020-11-11', 'BH', 'Bahrain', 'EMRO', '179', '83811', '2', '331');
INSERT INTO public.who_global_data_import VALUES (6315, '2020-11-12', 'BH', 'Bahrain', 'EMRO', '231', '84042', '1', '332');
INSERT INTO public.who_global_data_import VALUES (6316, '2020-11-13', 'BH', 'Bahrain', 'EMRO', '150', '84192', '0', '332');
INSERT INTO public.who_global_data_import VALUES (6317, '2020-11-14', 'BH', 'Bahrain', 'EMRO', '157', '84349', '0', '332');
INSERT INTO public.who_global_data_import VALUES (6318, '2020-11-15', 'BH', 'Bahrain', 'EMRO', '174', '84523', '1', '333');
INSERT INTO public.who_global_data_import VALUES (6319, '2020-11-16', 'BH', 'Bahrain', 'EMRO', '180', '84703', '1', '334');
INSERT INTO public.who_global_data_import VALUES (6320, '2020-11-17', 'BH', 'Bahrain', 'EMRO', '179', '84882', '3', '337');
INSERT INTO public.who_global_data_import VALUES (6321, '2020-11-18', 'BH', 'Bahrain', 'EMRO', '126', '85008', '0', '337');
INSERT INTO public.who_global_data_import VALUES (6322, '2020-11-19', 'BH', 'Bahrain', 'EMRO', '174', '85182', '0', '337');
INSERT INTO public.who_global_data_import VALUES (6323, '2020-11-20', 'BH', 'Bahrain', 'EMRO', '135', '85317', '0', '337');
INSERT INTO public.who_global_data_import VALUES (6324, '2020-11-21', 'BH', 'Bahrain', 'EMRO', '150', '85467', '1', '338');
INSERT INTO public.who_global_data_import VALUES (6325, '2020-11-22', 'BH', 'Bahrain', 'EMRO', '124', '85591', '0', '338');
INSERT INTO public.who_global_data_import VALUES (6326, '2020-11-23', 'BH', 'Bahrain', 'EMRO', '114', '85705', '0', '338');
INSERT INTO public.who_global_data_import VALUES (6327, '2020-11-24', 'BH', 'Bahrain', 'EMRO', '181', '85886', '1', '339');
INSERT INTO public.who_global_data_import VALUES (6328, '2020-11-25', 'BH', 'Bahrain', 'EMRO', '130', '86016', '1', '340');
INSERT INTO public.who_global_data_import VALUES (6329, '2020-11-26', 'BH', 'Bahrain', 'EMRO', '169', '86185', '0', '340');
INSERT INTO public.who_global_data_import VALUES (6330, '2020-11-27', 'BH', 'Bahrain', 'EMRO', '162', '86347', '1', '341');
INSERT INTO public.who_global_data_import VALUES (6331, '2020-11-28', 'BH', 'Bahrain', 'EMRO', '168', '86515', '0', '341');
INSERT INTO public.who_global_data_import VALUES (6332, '2020-11-29', 'BH', 'Bahrain', 'EMRO', '130', '86645', '0', '341');
INSERT INTO public.who_global_data_import VALUES (6333, '2020-11-30', 'BH', 'Bahrain', 'EMRO', '142', '86787', '0', '341');
INSERT INTO public.who_global_data_import VALUES (6334, '2020-12-01', 'BH', 'Bahrain', 'EMRO', '169', '86956', '0', '341');
INSERT INTO public.who_global_data_import VALUES (6335, '2020-12-02', 'BH', 'Bahrain', 'EMRO', '181', '87137', '0', '341');
INSERT INTO public.who_global_data_import VALUES (6336, '2020-12-03', 'BH', 'Bahrain', 'EMRO', '133', '87270', '0', '341');
INSERT INTO public.who_global_data_import VALUES (6337, '2020-12-04', 'BH', 'Bahrain', 'EMRO', '162', '87432', '0', '341');
INSERT INTO public.who_global_data_import VALUES (6338, '2020-12-05', 'BH', 'Bahrain', 'EMRO', '167', '87599', '0', '341');
INSERT INTO public.who_global_data_import VALUES (6339, '2020-12-06', 'BH', 'Bahrain', 'EMRO', '132', '87731', '0', '341');
INSERT INTO public.who_global_data_import VALUES (6340, '2020-12-07', 'BH', 'Bahrain', 'EMRO', '198', '87929', '0', '341');
INSERT INTO public.who_global_data_import VALUES (6341, '2020-12-08', 'BH', 'Bahrain', 'EMRO', '181', '88110', '0', '341');
INSERT INTO public.who_global_data_import VALUES (6342, '2020-12-09', 'BH', 'Bahrain', 'EMRO', '183', '88293', '2', '343');
INSERT INTO public.who_global_data_import VALUES (6343, '2020-12-10', 'BH', 'Bahrain', 'EMRO', '201', '88494', '4', '347');
INSERT INTO public.who_global_data_import VALUES (6344, '2020-12-11', 'BH', 'Bahrain', 'EMRO', '137', '88631', '0', '347');
INSERT INTO public.who_global_data_import VALUES (6345, '2020-12-12', 'BH', 'Bahrain', 'EMRO', '188', '88819', '0', '347');
INSERT INTO public.who_global_data_import VALUES (6346, '2020-12-13', 'BH', 'Bahrain', 'EMRO', '145', '88964', '1', '348');
INSERT INTO public.who_global_data_import VALUES (6347, '2020-12-14', 'BH', 'Bahrain', 'EMRO', '178', '89142', '0', '348');
INSERT INTO public.who_global_data_import VALUES (6348, '2020-12-15', 'BH', 'Bahrain', 'EMRO', '125', '89267', '0', '348');
INSERT INTO public.who_global_data_import VALUES (6349, '2020-12-16', 'BH', 'Bahrain', 'EMRO', '177', '89444', '0', '348');
INSERT INTO public.who_global_data_import VALUES (6350, '2020-12-17', 'BH', 'Bahrain', 'EMRO', '156', '89600', '1', '349');
INSERT INTO public.who_global_data_import VALUES (6351, '2020-12-18', 'BH', 'Bahrain', 'EMRO', '143', '89743', '0', '349');
INSERT INTO public.who_global_data_import VALUES (6352, '2020-12-19', 'BH', 'Bahrain', 'EMRO', '140', '89883', '0', '349');
INSERT INTO public.who_global_data_import VALUES (6353, '2020-12-20', 'BH', 'Bahrain', 'EMRO', '179', '90062', '0', '349');
INSERT INTO public.who_global_data_import VALUES (6354, '2020-12-21', 'BH', 'Bahrain', 'EMRO', '220', '90282', '0', '349');
INSERT INTO public.who_global_data_import VALUES (6355, '2020-12-22', 'BH', 'Bahrain', 'EMRO', '168', '90450', '1', '350');
INSERT INTO public.who_global_data_import VALUES (6356, '2020-12-23', 'BH', 'Bahrain', 'EMRO', '184', '90634', '0', '350');
INSERT INTO public.who_global_data_import VALUES (6357, '2020-12-24', 'BH', 'Bahrain', 'EMRO', '183', '90817', '0', '350');
INSERT INTO public.who_global_data_import VALUES (6358, '2020-12-25', 'BH', 'Bahrain', 'EMRO', '253', '91070', '0', '350');
INSERT INTO public.who_global_data_import VALUES (6359, '2020-12-26', 'BH', 'Bahrain', 'EMRO', '234', '91304', '1', '351');
INSERT INTO public.who_global_data_import VALUES (6360, '2020-12-27', 'BH', 'Bahrain', 'EMRO', '214', '91518', '0', '351');
INSERT INTO public.who_global_data_import VALUES (6361, '2020-12-28', 'BH', 'Bahrain', 'EMRO', '215', '91733', '0', '351');
INSERT INTO public.who_global_data_import VALUES (6362, '2020-12-29', 'BH', 'Bahrain', 'EMRO', '202', '91935', '0', '351');
INSERT INTO public.who_global_data_import VALUES (6363, '2020-12-30', 'BH', 'Bahrain', 'EMRO', '234', '92169', '0', '351');
INSERT INTO public.who_global_data_import VALUES (6364, '2020-12-31', 'BH', 'Bahrain', 'EMRO', '256', '92425', '1', '352');
INSERT INTO public.who_global_data_import VALUES (6365, '2021-01-01', 'BH', 'Bahrain', 'EMRO', '250', '92675', '0', '352');
INSERT INTO public.who_global_data_import VALUES (6366, '2021-01-02', 'BH', 'Bahrain', 'EMRO', '238', '92913', '0', '352');
INSERT INTO public.who_global_data_import VALUES (6367, '2021-01-03', 'BH', 'Bahrain', 'EMRO', '271', '93184', '0', '352');
INSERT INTO public.who_global_data_import VALUES (6368, '2021-01-04', 'BH', 'Bahrain', 'EMRO', '294', '93478', '0', '352');
INSERT INTO public.who_global_data_import VALUES (6369, '2021-01-05', 'BH', 'Bahrain', 'EMRO', '288', '93766', '0', '352');
INSERT INTO public.who_global_data_import VALUES (6370, '2021-01-06', 'BH', 'Bahrain', 'EMRO', '229', '93995', '0', '352');
INSERT INTO public.who_global_data_import VALUES (6371, '2021-01-07', 'BH', 'Bahrain', 'EMRO', '289', '94284', '1', '353');
INSERT INTO public.who_global_data_import VALUES (6372, '2021-01-08', 'BH', 'Bahrain', 'EMRO', '349', '94633', '0', '353');
INSERT INTO public.who_global_data_import VALUES (6373, '2021-01-09', 'BH', 'Bahrain', 'EMRO', '397', '95030', '1', '354');
INSERT INTO public.who_global_data_import VALUES (6374, '2021-01-10', 'BH', 'Bahrain', 'EMRO', '287', '95317', '1', '355');
INSERT INTO public.who_global_data_import VALUES (6375, '2021-01-11', 'BH', 'Bahrain', 'EMRO', '241', '95558', '1', '356');
INSERT INTO public.who_global_data_import VALUES (6376, '2021-01-12', 'BH', 'Bahrain', 'EMRO', '321', '95879', '0', '356');
INSERT INTO public.who_global_data_import VALUES (6377, '2021-01-13', 'BH', 'Bahrain', 'EMRO', '316', '96195', '0', '356');
INSERT INTO public.who_global_data_import VALUES (6378, '2021-01-14', 'BH', 'Bahrain', 'EMRO', '275', '96470', '0', '356');
INSERT INTO public.who_global_data_import VALUES (6379, '2021-01-15', 'BH', 'Bahrain', 'EMRO', '342', '96812', '0', '356');
INSERT INTO public.who_global_data_import VALUES (6380, '2021-01-16', 'BH', 'Bahrain', 'EMRO', '209', '97021', '1', '357');
INSERT INTO public.who_global_data_import VALUES (6381, '2021-01-17', 'BH', 'Bahrain', 'EMRO', '247', '97268', '1', '358');
INSERT INTO public.who_global_data_import VALUES (6382, '2021-01-18', 'BH', 'Bahrain', 'EMRO', '339', '97607', '2', '360');
INSERT INTO public.who_global_data_import VALUES (6383, '2021-01-19', 'BH', 'Bahrain', 'EMRO', '333', '97940', '0', '360');
INSERT INTO public.who_global_data_import VALUES (6384, '2021-01-20', 'BH', 'Bahrain', 'EMRO', '320', '98260', '2', '362');
INSERT INTO public.who_global_data_import VALUES (6385, '2021-01-21', 'BH', 'Bahrain', 'EMRO', '313', '98573', '4', '366');
INSERT INTO public.who_global_data_import VALUES (6386, '2021-01-22', 'BH', 'Bahrain', 'EMRO', '305', '98878', '0', '366');
INSERT INTO public.who_global_data_import VALUES (6387, '2021-01-23', 'BH', 'Bahrain', 'EMRO', '332', '99210', '0', '366');
INSERT INTO public.who_global_data_import VALUES (6388, '2021-01-24', 'BH', 'Bahrain', 'EMRO', '246', '99456', '1', '367');
INSERT INTO public.who_global_data_import VALUES (6389, '2021-01-25', 'BH', 'Bahrain', 'EMRO', '361', '99817', '0', '367');
INSERT INTO public.who_global_data_import VALUES (6390, '2021-01-26', 'BH', 'Bahrain', 'EMRO', '413', '100230', '2', '369');
INSERT INTO public.who_global_data_import VALUES (6391, '2021-01-27', 'BH', 'Bahrain', 'EMRO', '459', '100689', '1', '370');
INSERT INTO public.who_global_data_import VALUES (6392, '2021-01-28', 'BH', 'Bahrain', 'EMRO', '427', '101116', '1', '371');
INSERT INTO public.who_global_data_import VALUES (6393, '2021-01-29', 'BH', 'Bahrain', 'EMRO', '387', '101503', '1', '372');
INSERT INTO public.who_global_data_import VALUES (6394, '2021-01-30', 'BH', 'Bahrain', 'EMRO', '468', '101971', '0', '372');
INSERT INTO public.who_global_data_import VALUES (6395, '2021-01-31', 'BH', 'Bahrain', 'EMRO', '655', '102626', '0', '372');
INSERT INTO public.who_global_data_import VALUES (6396, '2021-02-01', 'BH', 'Bahrain', 'EMRO', '431', '103057', '3', '375');
INSERT INTO public.who_global_data_import VALUES (6397, '2021-02-02', 'BH', 'Bahrain', 'EMRO', '525', '103582', '1', '376');
INSERT INTO public.who_global_data_import VALUES (6398, '2021-02-03', 'BH', 'Bahrain', 'EMRO', '657', '104239', '0', '376');
INSERT INTO public.who_global_data_import VALUES (6399, '2021-02-04', 'BH', 'Bahrain', 'EMRO', '553', '104792', '0', '376');
INSERT INTO public.who_global_data_import VALUES (6400, '2021-02-05', 'BH', 'Bahrain', 'EMRO', '704', '105496', '1', '377');
INSERT INTO public.who_global_data_import VALUES (6401, '2020-01-03', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6402, '2020-01-04', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6403, '2020-01-05', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6404, '2020-01-06', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6405, '2020-01-07', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6406, '2020-01-08', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6407, '2020-01-09', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6408, '2020-01-10', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6409, '2020-01-11', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6410, '2020-01-12', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6411, '2020-01-13', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6412, '2020-01-14', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6413, '2020-01-15', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6414, '2020-01-16', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6415, '2020-01-17', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6416, '2020-01-18', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6417, '2020-01-19', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6418, '2020-01-20', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6419, '2020-01-21', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6420, '2020-01-22', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6421, '2020-01-23', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6422, '2020-01-24', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6423, '2020-01-25', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6424, '2020-01-26', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6425, '2020-01-27', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6426, '2020-01-28', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6427, '2020-01-29', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6428, '2020-01-30', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6429, '2020-01-31', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6430, '2020-02-01', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6431, '2020-02-02', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6432, '2020-02-03', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6433, '2020-02-04', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6434, '2020-02-05', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6435, '2020-02-06', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6436, '2020-02-07', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6437, '2020-02-08', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6438, '2020-02-09', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6439, '2020-02-10', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6440, '2020-02-11', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6441, '2020-02-12', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6442, '2020-02-13', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6443, '2020-02-14', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6444, '2020-02-15', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6445, '2020-02-16', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6446, '2020-02-17', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6447, '2020-02-18', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6448, '2020-02-19', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6449, '2020-02-20', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6450, '2020-02-21', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6451, '2020-02-22', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6452, '2020-02-23', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6453, '2020-02-24', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6454, '2020-02-25', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6455, '2020-02-26', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6456, '2020-02-27', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6457, '2020-02-28', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6458, '2020-02-29', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6459, '2020-03-01', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6460, '2020-03-02', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6461, '2020-03-03', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6462, '2020-03-04', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6463, '2020-03-05', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6464, '2020-03-06', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6465, '2020-03-07', 'BD', 'Bangladesh', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6466, '2020-03-08', 'BD', 'Bangladesh', 'SEARO', '7', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6467, '2020-03-09', 'BD', 'Bangladesh', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6468, '2020-03-10', 'BD', 'Bangladesh', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6469, '2020-03-11', 'BD', 'Bangladesh', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6470, '2020-03-12', 'BD', 'Bangladesh', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6471, '2020-03-13', 'BD', 'Bangladesh', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6472, '2020-03-14', 'BD', 'Bangladesh', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6473, '2020-03-15', 'BD', 'Bangladesh', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6474, '2020-03-16', 'BD', 'Bangladesh', 'SEARO', '5', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6475, '2020-03-17', 'BD', 'Bangladesh', 'SEARO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6476, '2020-03-18', 'BD', 'Bangladesh', 'SEARO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6477, '2020-03-19', 'BD', 'Bangladesh', 'SEARO', '3', '17', '1', '1');
INSERT INTO public.who_global_data_import VALUES (6478, '2020-03-20', 'BD', 'Bangladesh', 'SEARO', '0', '17', '0', '1');
INSERT INTO public.who_global_data_import VALUES (6479, '2020-03-21', 'BD', 'Bangladesh', 'SEARO', '7', '24', '1', '2');
INSERT INTO public.who_global_data_import VALUES (6480, '2020-03-22', 'BD', 'Bangladesh', 'SEARO', '0', '24', '0', '2');
INSERT INTO public.who_global_data_import VALUES (6481, '2020-03-23', 'BD', 'Bangladesh', 'SEARO', '3', '27', '0', '2');
INSERT INTO public.who_global_data_import VALUES (6482, '2020-03-24', 'BD', 'Bangladesh', 'SEARO', '12', '39', '2', '4');
INSERT INTO public.who_global_data_import VALUES (6483, '2020-03-25', 'BD', 'Bangladesh', 'SEARO', '0', '39', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6484, '2020-03-26', 'BD', 'Bangladesh', 'SEARO', '5', '44', '1', '5');
INSERT INTO public.who_global_data_import VALUES (6485, '2020-03-27', 'BD', 'Bangladesh', 'SEARO', '4', '48', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6486, '2020-03-28', 'BD', 'Bangladesh', 'SEARO', '0', '48', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6487, '2020-03-29', 'BD', 'Bangladesh', 'SEARO', '0', '48', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6488, '2020-03-30', 'BD', 'Bangladesh', 'SEARO', '1', '49', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6489, '2020-03-31', 'BD', 'Bangladesh', 'SEARO', '0', '49', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6490, '2020-04-01', 'BD', 'Bangladesh', 'SEARO', '5', '54', '1', '6');
INSERT INTO public.who_global_data_import VALUES (6491, '2020-04-02', 'BD', 'Bangladesh', 'SEARO', '2', '56', '0', '6');
INSERT INTO public.who_global_data_import VALUES (6492, '2020-04-03', 'BD', 'Bangladesh', 'SEARO', '5', '61', '0', '6');
INSERT INTO public.who_global_data_import VALUES (6493, '2020-04-04', 'BD', 'Bangladesh', 'SEARO', '9', '70', '2', '8');
INSERT INTO public.who_global_data_import VALUES (6494, '2020-04-05', 'BD', 'Bangladesh', 'SEARO', '18', '88', '0', '8');
INSERT INTO public.who_global_data_import VALUES (6495, '2020-04-06', 'BD', 'Bangladesh', 'SEARO', '35', '123', '4', '12');
INSERT INTO public.who_global_data_import VALUES (6496, '2020-04-07', 'BD', 'Bangladesh', 'SEARO', '41', '164', '5', '17');
INSERT INTO public.who_global_data_import VALUES (6497, '2020-04-08', 'BD', 'Bangladesh', 'SEARO', '54', '218', '3', '20');
INSERT INTO public.who_global_data_import VALUES (6498, '2020-04-09', 'BD', 'Bangladesh', 'SEARO', '112', '330', '1', '21');
INSERT INTO public.who_global_data_import VALUES (6499, '2020-04-10', 'BD', 'Bangladesh', 'SEARO', '94', '424', '6', '27');
INSERT INTO public.who_global_data_import VALUES (6500, '2020-04-11', 'BD', 'Bangladesh', 'SEARO', '58', '482', '3', '30');
INSERT INTO public.who_global_data_import VALUES (6501, '2020-04-12', 'BD', 'Bangladesh', 'SEARO', '139', '621', '4', '34');
INSERT INTO public.who_global_data_import VALUES (6502, '2020-04-13', 'BD', 'Bangladesh', 'SEARO', '182', '803', '5', '39');
INSERT INTO public.who_global_data_import VALUES (6503, '2020-04-14', 'BD', 'Bangladesh', 'SEARO', '209', '1012', '7', '46');
INSERT INTO public.who_global_data_import VALUES (6504, '2020-04-15', 'BD', 'Bangladesh', 'SEARO', '219', '1231', '4', '50');
INSERT INTO public.who_global_data_import VALUES (6505, '2020-04-16', 'BD', 'Bangladesh', 'SEARO', '341', '1572', '10', '60');
INSERT INTO public.who_global_data_import VALUES (6506, '2020-04-17', 'BD', 'Bangladesh', 'SEARO', '266', '1838', '15', '75');
INSERT INTO public.who_global_data_import VALUES (6507, '2020-04-18', 'BD', 'Bangladesh', 'SEARO', '306', '2144', '9', '84');
INSERT INTO public.who_global_data_import VALUES (6508, '2020-04-19', 'BD', 'Bangladesh', 'SEARO', '312', '2456', '7', '91');
INSERT INTO public.who_global_data_import VALUES (6509, '2020-04-20', 'BD', 'Bangladesh', 'SEARO', '492', '2948', '10', '101');
INSERT INTO public.who_global_data_import VALUES (6510, '2020-04-21', 'BD', 'Bangladesh', 'SEARO', '434', '3382', '9', '110');
INSERT INTO public.who_global_data_import VALUES (6511, '2020-04-22', 'BD', 'Bangladesh', 'SEARO', '390', '3772', '10', '120');
INSERT INTO public.who_global_data_import VALUES (6512, '2020-04-23', 'BD', 'Bangladesh', 'SEARO', '414', '4186', '7', '127');
INSERT INTO public.who_global_data_import VALUES (6513, '2020-04-24', 'BD', 'Bangladesh', 'SEARO', '503', '4689', '4', '131');
INSERT INTO public.who_global_data_import VALUES (6514, '2020-04-25', 'BD', 'Bangladesh', 'SEARO', '309', '4998', '9', '140');
INSERT INTO public.who_global_data_import VALUES (6515, '2020-04-26', 'BD', 'Bangladesh', 'SEARO', '418', '5416', '5', '145');
INSERT INTO public.who_global_data_import VALUES (6516, '2020-04-27', 'BD', 'Bangladesh', 'SEARO', '497', '5913', '7', '152');
INSERT INTO public.who_global_data_import VALUES (6517, '2020-04-28', 'BD', 'Bangladesh', 'SEARO', '549', '6462', '3', '155');
INSERT INTO public.who_global_data_import VALUES (6518, '2020-04-29', 'BD', 'Bangladesh', 'SEARO', '641', '7103', '8', '163');
INSERT INTO public.who_global_data_import VALUES (6519, '2020-04-30', 'BD', 'Bangladesh', 'SEARO', '564', '7667', '5', '168');
INSERT INTO public.who_global_data_import VALUES (6520, '2020-05-01', 'BD', 'Bangladesh', 'SEARO', '571', '8238', '2', '170');
INSERT INTO public.who_global_data_import VALUES (6521, '2020-05-02', 'BD', 'Bangladesh', 'SEARO', '552', '8790', '5', '175');
INSERT INTO public.who_global_data_import VALUES (6522, '2020-05-03', 'BD', 'Bangladesh', 'SEARO', '665', '9455', '2', '177');
INSERT INTO public.who_global_data_import VALUES (6523, '2020-05-04', 'BD', 'Bangladesh', 'SEARO', '688', '10143', '5', '182');
INSERT INTO public.who_global_data_import VALUES (6524, '2020-05-05', 'BD', 'Bangladesh', 'SEARO', '786', '10929', '1', '183');
INSERT INTO public.who_global_data_import VALUES (6525, '2020-05-06', 'BD', 'Bangladesh', 'SEARO', '790', '11719', '3', '186');
INSERT INTO public.who_global_data_import VALUES (6526, '2020-05-07', 'BD', 'Bangladesh', 'SEARO', '706', '12425', '0', '186');
INSERT INTO public.who_global_data_import VALUES (6527, '2020-05-08', 'BD', 'Bangladesh', 'SEARO', '709', '13134', '20', '206');
INSERT INTO public.who_global_data_import VALUES (6528, '2020-05-09', 'BD', 'Bangladesh', 'SEARO', '636', '13770', '8', '214');
INSERT INTO public.who_global_data_import VALUES (6529, '2020-05-10', 'BD', 'Bangladesh', 'SEARO', '887', '14657', '14', '228');
INSERT INTO public.who_global_data_import VALUES (6530, '2020-05-11', 'BD', 'Bangladesh', 'SEARO', '1034', '15691', '11', '239');
INSERT INTO public.who_global_data_import VALUES (6531, '2020-05-12', 'BD', 'Bangladesh', 'SEARO', '969', '16660', '11', '250');
INSERT INTO public.who_global_data_import VALUES (6532, '2020-05-13', 'BD', 'Bangladesh', 'SEARO', '1162', '17822', '19', '269');
INSERT INTO public.who_global_data_import VALUES (6533, '2020-05-14', 'BD', 'Bangladesh', 'SEARO', '1041', '18863', '14', '283');
INSERT INTO public.who_global_data_import VALUES (6534, '2020-05-15', 'BD', 'Bangladesh', 'SEARO', '1202', '20065', '15', '298');
INSERT INTO public.who_global_data_import VALUES (6535, '2020-05-16', 'BD', 'Bangladesh', 'SEARO', '930', '20995', '16', '314');
INSERT INTO public.who_global_data_import VALUES (6536, '2020-05-17', 'BD', 'Bangladesh', 'SEARO', '0', '20995', '0', '314');
INSERT INTO public.who_global_data_import VALUES (6537, '2020-05-18', 'BD', 'Bangladesh', 'SEARO', '2875', '23870', '35', '349');
INSERT INTO public.who_global_data_import VALUES (6538, '2020-05-19', 'BD', 'Bangladesh', 'SEARO', '1251', '25121', '21', '370');
INSERT INTO public.who_global_data_import VALUES (6539, '2020-05-20', 'BD', 'Bangladesh', 'SEARO', '1617', '26738', '16', '386');
INSERT INTO public.who_global_data_import VALUES (6540, '2020-05-21', 'BD', 'Bangladesh', 'SEARO', '1773', '28511', '22', '408');
INSERT INTO public.who_global_data_import VALUES (6541, '2020-05-22', 'BD', 'Bangladesh', 'SEARO', '1694', '30205', '24', '432');
INSERT INTO public.who_global_data_import VALUES (6542, '2020-05-23', 'BD', 'Bangladesh', 'SEARO', '1873', '32078', '20', '452');
INSERT INTO public.who_global_data_import VALUES (6543, '2020-05-24', 'BD', 'Bangladesh', 'SEARO', '1532', '33610', '28', '480');
INSERT INTO public.who_global_data_import VALUES (6544, '2020-05-25', 'BD', 'Bangladesh', 'SEARO', '1975', '35585', '21', '501');
INSERT INTO public.who_global_data_import VALUES (6545, '2020-05-26', 'BD', 'Bangladesh', 'SEARO', '1166', '36751', '21', '522');
INSERT INTO public.who_global_data_import VALUES (6546, '2020-05-27', 'BD', 'Bangladesh', 'SEARO', '1541', '38292', '22', '544');
INSERT INTO public.who_global_data_import VALUES (6547, '2020-05-28', 'BD', 'Bangladesh', 'SEARO', '2029', '40321', '15', '559');
INSERT INTO public.who_global_data_import VALUES (6548, '2020-05-29', 'BD', 'Bangladesh', 'SEARO', '2523', '42844', '23', '582');
INSERT INTO public.who_global_data_import VALUES (6549, '2020-05-30', 'BD', 'Bangladesh', 'SEARO', '1764', '44608', '28', '610');
INSERT INTO public.who_global_data_import VALUES (6550, '2020-05-31', 'BD', 'Bangladesh', 'SEARO', '2545', '47153', '40', '650');
INSERT INTO public.who_global_data_import VALUES (6551, '2020-06-01', 'BD', 'Bangladesh', 'SEARO', '0', '47153', '0', '650');
INSERT INTO public.who_global_data_import VALUES (6552, '2020-06-02', 'BD', 'Bangladesh', 'SEARO', '2381', '49534', '22', '672');
INSERT INTO public.who_global_data_import VALUES (6553, '2020-06-03', 'BD', 'Bangladesh', 'SEARO', '2911', '52445', '37', '709');
INSERT INTO public.who_global_data_import VALUES (6554, '2020-06-04', 'BD', 'Bangladesh', 'SEARO', '2695', '55140', '37', '746');
INSERT INTO public.who_global_data_import VALUES (6555, '2020-06-05', 'BD', 'Bangladesh', 'SEARO', '2423', '57563', '35', '781');
INSERT INTO public.who_global_data_import VALUES (6556, '2020-06-06', 'BD', 'Bangladesh', 'SEARO', '2828', '60391', '30', '811');
INSERT INTO public.who_global_data_import VALUES (6557, '2020-06-07', 'BD', 'Bangladesh', 'SEARO', '2635', '63026', '35', '846');
INSERT INTO public.who_global_data_import VALUES (6558, '2020-06-08', 'BD', 'Bangladesh', 'SEARO', '2743', '65769', '42', '888');
INSERT INTO public.who_global_data_import VALUES (6559, '2020-06-09', 'BD', 'Bangladesh', 'SEARO', '2735', '68504', '42', '930');
INSERT INTO public.who_global_data_import VALUES (6560, '2020-06-10', 'BD', 'Bangladesh', 'SEARO', '3171', '71675', '45', '975');
INSERT INTO public.who_global_data_import VALUES (6561, '2020-06-11', 'BD', 'Bangladesh', 'SEARO', '3190', '74865', '37', '1012');
INSERT INTO public.who_global_data_import VALUES (6562, '2020-06-12', 'BD', 'Bangladesh', 'SEARO', '3187', '78052', '37', '1049');
INSERT INTO public.who_global_data_import VALUES (6563, '2020-06-13', 'BD', 'Bangladesh', 'SEARO', '3471', '81523', '46', '1095');
INSERT INTO public.who_global_data_import VALUES (6564, '2020-06-14', 'BD', 'Bangladesh', 'SEARO', '2856', '84379', '44', '1139');
INSERT INTO public.who_global_data_import VALUES (6565, '2020-06-15', 'BD', 'Bangladesh', 'SEARO', '3141', '87520', '32', '1171');
INSERT INTO public.who_global_data_import VALUES (6566, '2020-06-16', 'BD', 'Bangladesh', 'SEARO', '3099', '90619', '38', '1209');
INSERT INTO public.who_global_data_import VALUES (6567, '2020-06-17', 'BD', 'Bangladesh', 'SEARO', '3862', '94481', '53', '1262');
INSERT INTO public.who_global_data_import VALUES (6568, '2020-06-18', 'BD', 'Bangladesh', 'SEARO', '4008', '98489', '43', '1305');
INSERT INTO public.who_global_data_import VALUES (6569, '2020-06-19', 'BD', 'Bangladesh', 'SEARO', '3803', '102292', '38', '1343');
INSERT INTO public.who_global_data_import VALUES (6570, '2020-06-20', 'BD', 'Bangladesh', 'SEARO', '3243', '105535', '45', '1388');
INSERT INTO public.who_global_data_import VALUES (6571, '2020-06-21', 'BD', 'Bangladesh', 'SEARO', '3240', '108775', '37', '1425');
INSERT INTO public.who_global_data_import VALUES (6572, '2020-06-22', 'BD', 'Bangladesh', 'SEARO', '3531', '112306', '39', '1464');
INSERT INTO public.who_global_data_import VALUES (6573, '2020-06-23', 'BD', 'Bangladesh', 'SEARO', '3480', '115786', '38', '1502');
INSERT INTO public.who_global_data_import VALUES (6574, '2020-06-24', 'BD', 'Bangladesh', 'SEARO', '3412', '119198', '43', '1545');
INSERT INTO public.who_global_data_import VALUES (6575, '2020-06-25', 'BD', 'Bangladesh', 'SEARO', '3462', '122660', '37', '1582');
INSERT INTO public.who_global_data_import VALUES (6576, '2020-06-26', 'BD', 'Bangladesh', 'SEARO', '3946', '126606', '39', '1621');
INSERT INTO public.who_global_data_import VALUES (6577, '2020-06-27', 'BD', 'Bangladesh', 'SEARO', '3868', '130474', '40', '1661');
INSERT INTO public.who_global_data_import VALUES (6578, '2020-06-28', 'BD', 'Bangladesh', 'SEARO', '3504', '133978', '34', '1695');
INSERT INTO public.who_global_data_import VALUES (6579, '2020-06-29', 'BD', 'Bangladesh', 'SEARO', '3809', '137787', '43', '1738');
INSERT INTO public.who_global_data_import VALUES (6580, '2020-06-30', 'BD', 'Bangladesh', 'SEARO', '4014', '141801', '45', '1783');
INSERT INTO public.who_global_data_import VALUES (6581, '2020-07-01', 'BD', 'Bangladesh', 'SEARO', '3682', '145483', '64', '1847');
INSERT INTO public.who_global_data_import VALUES (6582, '2020-07-02', 'BD', 'Bangladesh', 'SEARO', '3775', '149258', '41', '1888');
INSERT INTO public.who_global_data_import VALUES (6583, '2020-07-03', 'BD', 'Bangladesh', 'SEARO', '4019', '153277', '38', '1926');
INSERT INTO public.who_global_data_import VALUES (6584, '2020-07-04', 'BD', 'Bangladesh', 'SEARO', '3114', '156391', '42', '1968');
INSERT INTO public.who_global_data_import VALUES (6585, '2020-07-05', 'BD', 'Bangladesh', 'SEARO', '3288', '159679', '29', '1997');
INSERT INTO public.who_global_data_import VALUES (6586, '2020-07-06', 'BD', 'Bangladesh', 'SEARO', '2738', '162417', '55', '2052');
INSERT INTO public.who_global_data_import VALUES (6587, '2020-07-07', 'BD', 'Bangladesh', 'SEARO', '3201', '165618', '44', '2096');
INSERT INTO public.who_global_data_import VALUES (6588, '2020-07-08', 'BD', 'Bangladesh', 'SEARO', '3027', '168645', '55', '2151');
INSERT INTO public.who_global_data_import VALUES (6589, '2020-07-09', 'BD', 'Bangladesh', 'SEARO', '3489', '172134', '46', '2197');
INSERT INTO public.who_global_data_import VALUES (6590, '2020-07-10', 'BD', 'Bangladesh', 'SEARO', '3360', '175494', '41', '2238');
INSERT INTO public.who_global_data_import VALUES (6591, '2020-07-11', 'BD', 'Bangladesh', 'SEARO', '2949', '178443', '37', '2275');
INSERT INTO public.who_global_data_import VALUES (6592, '2020-07-12', 'BD', 'Bangladesh', 'SEARO', '2686', '181129', '30', '2305');
INSERT INTO public.who_global_data_import VALUES (6593, '2020-07-13', 'BD', 'Bangladesh', 'SEARO', '2666', '183795', '47', '2352');
INSERT INTO public.who_global_data_import VALUES (6594, '2020-07-14', 'BD', 'Bangladesh', 'SEARO', '3099', '186894', '39', '2391');
INSERT INTO public.who_global_data_import VALUES (6595, '2020-07-15', 'BD', 'Bangladesh', 'SEARO', '3163', '190057', '33', '2424');
INSERT INTO public.who_global_data_import VALUES (6596, '2020-07-16', 'BD', 'Bangladesh', 'SEARO', '3533', '193590', '33', '2457');
INSERT INTO public.who_global_data_import VALUES (6597, '2020-07-17', 'BD', 'Bangladesh', 'SEARO', '2733', '196323', '39', '2496');
INSERT INTO public.who_global_data_import VALUES (6598, '2020-07-18', 'BD', 'Bangladesh', 'SEARO', '3034', '199357', '51', '2547');
INSERT INTO public.who_global_data_import VALUES (6599, '2020-07-19', 'BD', 'Bangladesh', 'SEARO', '2709', '202066', '34', '2581');
INSERT INTO public.who_global_data_import VALUES (6600, '2020-07-20', 'BD', 'Bangladesh', 'SEARO', '2459', '204525', '37', '2618');
INSERT INTO public.who_global_data_import VALUES (6601, '2020-07-21', 'BD', 'Bangladesh', 'SEARO', '2928', '207453', '50', '2668');
INSERT INTO public.who_global_data_import VALUES (6602, '2020-07-22', 'BD', 'Bangladesh', 'SEARO', '3057', '210510', '41', '2709');
INSERT INTO public.who_global_data_import VALUES (6603, '2020-07-23', 'BD', 'Bangladesh', 'SEARO', '2744', '213254', '42', '2751');
INSERT INTO public.who_global_data_import VALUES (6604, '2020-07-24', 'BD', 'Bangladesh', 'SEARO', '2856', '216110', '50', '2801');
INSERT INTO public.who_global_data_import VALUES (6605, '2020-07-25', 'BD', 'Bangladesh', 'SEARO', '2548', '218658', '35', '2836');
INSERT INTO public.who_global_data_import VALUES (6606, '2020-07-26', 'BD', 'Bangladesh', 'SEARO', '2520', '221178', '38', '2874');
INSERT INTO public.who_global_data_import VALUES (6607, '2020-07-27', 'BD', 'Bangladesh', 'SEARO', '2275', '223453', '54', '2928');
INSERT INTO public.who_global_data_import VALUES (6608, '2020-07-28', 'BD', 'Bangladesh', 'SEARO', '2772', '226225', '37', '2965');
INSERT INTO public.who_global_data_import VALUES (6609, '2020-07-29', 'BD', 'Bangladesh', 'SEARO', '2960', '229185', '35', '3000');
INSERT INTO public.who_global_data_import VALUES (6610, '2020-07-30', 'BD', 'Bangladesh', 'SEARO', '3009', '232194', '35', '3035');
INSERT INTO public.who_global_data_import VALUES (6611, '2020-07-31', 'BD', 'Bangladesh', 'SEARO', '2695', '234889', '48', '3083');
INSERT INTO public.who_global_data_import VALUES (6612, '2020-08-01', 'BD', 'Bangladesh', 'SEARO', '2772', '237661', '28', '3111');
INSERT INTO public.who_global_data_import VALUES (6613, '2020-08-02', 'BD', 'Bangladesh', 'SEARO', '2199', '239860', '21', '3132');
INSERT INTO public.who_global_data_import VALUES (6614, '2020-08-03', 'BD', 'Bangladesh', 'SEARO', '886', '240746', '22', '3154');
INSERT INTO public.who_global_data_import VALUES (6615, '2020-08-04', 'BD', 'Bangladesh', 'SEARO', '1356', '242102', '30', '3184');
INSERT INTO public.who_global_data_import VALUES (6616, '2020-08-05', 'BD', 'Bangladesh', 'SEARO', '1918', '244020', '50', '3234');
INSERT INTO public.who_global_data_import VALUES (6617, '2020-08-06', 'BD', 'Bangladesh', 'SEARO', '2654', '246674', '33', '3267');
INSERT INTO public.who_global_data_import VALUES (6618, '2020-08-07', 'BD', 'Bangladesh', 'SEARO', '2977', '249651', '39', '3306');
INSERT INTO public.who_global_data_import VALUES (6619, '2020-08-08', 'BD', 'Bangladesh', 'SEARO', '2851', '252502', '27', '3333');
INSERT INTO public.who_global_data_import VALUES (6620, '2020-08-09', 'BD', 'Bangladesh', 'SEARO', '2611', '255113', '32', '3365');
INSERT INTO public.who_global_data_import VALUES (6621, '2020-08-10', 'BD', 'Bangladesh', 'SEARO', '2487', '257600', '34', '3399');
INSERT INTO public.who_global_data_import VALUES (6622, '2020-08-11', 'BD', 'Bangladesh', 'SEARO', '2907', '260507', '39', '3438');
INSERT INTO public.who_global_data_import VALUES (6623, '2020-08-12', 'BD', 'Bangladesh', 'SEARO', '2996', '263503', '33', '3471');
INSERT INTO public.who_global_data_import VALUES (6624, '2020-08-13', 'BD', 'Bangladesh', 'SEARO', '2995', '266498', '42', '3513');
INSERT INTO public.who_global_data_import VALUES (6625, '2020-08-14', 'BD', 'Bangladesh', 'SEARO', '2617', '269115', '44', '3557');
INSERT INTO public.who_global_data_import VALUES (6626, '2020-08-15', 'BD', 'Bangladesh', 'SEARO', '2766', '271881', '34', '3591');
INSERT INTO public.who_global_data_import VALUES (6627, '2020-08-16', 'BD', 'Bangladesh', 'SEARO', '2644', '274525', '34', '3625');
INSERT INTO public.who_global_data_import VALUES (6628, '2020-08-17', 'BD', 'Bangladesh', 'SEARO', '2024', '276549', '32', '3657');
INSERT INTO public.who_global_data_import VALUES (6629, '2020-08-18', 'BD', 'Bangladesh', 'SEARO', '2595', '279144', '37', '3694');
INSERT INTO public.who_global_data_import VALUES (6630, '2020-08-19', 'BD', 'Bangladesh', 'SEARO', '3200', '282344', '46', '3740');
INSERT INTO public.who_global_data_import VALUES (6631, '2020-08-20', 'BD', 'Bangladesh', 'SEARO', '2747', '285091', '41', '3781');
INSERT INTO public.who_global_data_import VALUES (6632, '2020-08-21', 'BD', 'Bangladesh', 'SEARO', '2868', '287959', '41', '3822');
INSERT INTO public.who_global_data_import VALUES (6633, '2020-08-22', 'BD', 'Bangladesh', 'SEARO', '2401', '290360', '39', '3861');
INSERT INTO public.who_global_data_import VALUES (6634, '2020-08-23', 'BD', 'Bangladesh', 'SEARO', '2265', '292625', '46', '3907');
INSERT INTO public.who_global_data_import VALUES (6635, '2020-08-24', 'BD', 'Bangladesh', 'SEARO', '1973', '294598', '34', '3941');
INSERT INTO public.who_global_data_import VALUES (6636, '2020-08-25', 'BD', 'Bangladesh', 'SEARO', '2485', '297083', '42', '3983');
INSERT INTO public.who_global_data_import VALUES (6637, '2020-08-26', 'BD', 'Bangladesh', 'SEARO', '2545', '299628', '45', '4028');
INSERT INTO public.who_global_data_import VALUES (6638, '2020-08-27', 'BD', 'Bangladesh', 'SEARO', '2519', '302147', '54', '4082');
INSERT INTO public.who_global_data_import VALUES (6639, '2020-08-28', 'BD', 'Bangladesh', 'SEARO', '2436', '304583', '45', '4127');
INSERT INTO public.who_global_data_import VALUES (6640, '2020-08-29', 'BD', 'Bangladesh', 'SEARO', '2211', '306794', '47', '4174');
INSERT INTO public.who_global_data_import VALUES (6641, '2020-08-30', 'BD', 'Bangladesh', 'SEARO', '2131', '308925', '32', '4206');
INSERT INTO public.who_global_data_import VALUES (6642, '2020-08-31', 'BD', 'Bangladesh', 'SEARO', '1897', '310822', '42', '4248');
INSERT INTO public.who_global_data_import VALUES (6643, '2020-09-01', 'BD', 'Bangladesh', 'SEARO', '2174', '312996', '33', '4281');
INSERT INTO public.who_global_data_import VALUES (6644, '2020-09-02', 'BD', 'Bangladesh', 'SEARO', '1950', '314946', '35', '4316');
INSERT INTO public.who_global_data_import VALUES (6645, '2020-09-03', 'BD', 'Bangladesh', 'SEARO', '2582', '317528', '35', '4351');
INSERT INTO public.who_global_data_import VALUES (6646, '2020-09-04', 'BD', 'Bangladesh', 'SEARO', '2158', '319686', '32', '4383');
INSERT INTO public.who_global_data_import VALUES (6647, '2020-09-05', 'BD', 'Bangladesh', 'SEARO', '1929', '321615', '29', '4412');
INSERT INTO public.who_global_data_import VALUES (6648, '2020-09-06', 'BD', 'Bangladesh', 'SEARO', '1950', '323565', '35', '4447');
INSERT INTO public.who_global_data_import VALUES (6649, '2020-09-07', 'BD', 'Bangladesh', 'SEARO', '1592', '325157', '32', '4479');
INSERT INTO public.who_global_data_import VALUES (6650, '2020-09-08', 'BD', 'Bangladesh', 'SEARO', '2202', '327359', '37', '4516');
INSERT INTO public.who_global_data_import VALUES (6651, '2020-09-09', 'BD', 'Bangladesh', 'SEARO', '1892', '329251', '36', '4552');
INSERT INTO public.who_global_data_import VALUES (6652, '2020-09-10', 'BD', 'Bangladesh', 'SEARO', '1827', '331078', '41', '4593');
INSERT INTO public.who_global_data_import VALUES (6653, '2020-09-11', 'BD', 'Bangladesh', 'SEARO', '1892', '332970', '41', '4634');
INSERT INTO public.who_global_data_import VALUES (6654, '2020-09-12', 'BD', 'Bangladesh', 'SEARO', '1792', '334762', '34', '4668');
INSERT INTO public.who_global_data_import VALUES (6655, '2020-09-13', 'BD', 'Bangladesh', 'SEARO', '1282', '336044', '34', '4702');
INSERT INTO public.who_global_data_import VALUES (6656, '2020-09-14', 'BD', 'Bangladesh', 'SEARO', '1476', '337520', '31', '4733');
INSERT INTO public.who_global_data_import VALUES (6657, '2020-09-15', 'BD', 'Bangladesh', 'SEARO', '1812', '339332', '26', '4759');
INSERT INTO public.who_global_data_import VALUES (6658, '2020-09-16', 'BD', 'Bangladesh', 'SEARO', '1724', '341056', '43', '4802');
INSERT INTO public.who_global_data_import VALUES (6659, '2020-09-17', 'BD', 'Bangladesh', 'SEARO', '1615', '342671', '21', '4823');
INSERT INTO public.who_global_data_import VALUES (6660, '2020-09-18', 'BD', 'Bangladesh', 'SEARO', '1593', '344264', '36', '4859');
INSERT INTO public.who_global_data_import VALUES (6661, '2020-09-19', 'BD', 'Bangladesh', 'SEARO', '1541', '345805', '22', '4881');
INSERT INTO public.who_global_data_import VALUES (6662, '2020-09-20', 'BD', 'Bangladesh', 'SEARO', '1567', '347372', '32', '4913');
INSERT INTO public.who_global_data_import VALUES (6663, '2020-09-21', 'BD', 'Bangladesh', 'SEARO', '1544', '348916', '26', '4939');
INSERT INTO public.who_global_data_import VALUES (6664, '2020-09-22', 'BD', 'Bangladesh', 'SEARO', '1705', '350621', '40', '4979');
INSERT INTO public.who_global_data_import VALUES (6665, '2020-09-23', 'BD', 'Bangladesh', 'SEARO', '1557', '352178', '28', '5007');
INSERT INTO public.who_global_data_import VALUES (6666, '2020-09-24', 'BD', 'Bangladesh', 'SEARO', '1666', '353844', '37', '5044');
INSERT INTO public.who_global_data_import VALUES (6667, '2020-09-25', 'BD', 'Bangladesh', 'SEARO', '1540', '355384', '28', '5072');
INSERT INTO public.who_global_data_import VALUES (6668, '2020-09-26', 'BD', 'Bangladesh', 'SEARO', '1383', '356767', '21', '5093');
INSERT INTO public.who_global_data_import VALUES (6669, '2020-09-27', 'BD', 'Bangladesh', 'SEARO', '1106', '357873', '36', '5129');
INSERT INTO public.who_global_data_import VALUES (6670, '2020-09-28', 'BD', 'Bangladesh', 'SEARO', '1275', '359148', '32', '5161');
INSERT INTO public.who_global_data_import VALUES (6671, '2020-09-29', 'BD', 'Bangladesh', 'SEARO', '1407', '360555', '32', '5193');
INSERT INTO public.who_global_data_import VALUES (6672, '2020-09-30', 'BD', 'Bangladesh', 'SEARO', '1488', '362043', '26', '5219');
INSERT INTO public.who_global_data_import VALUES (6673, '2020-10-01', 'BD', 'Bangladesh', 'SEARO', '1436', '363479', '32', '5251');
INSERT INTO public.who_global_data_import VALUES (6674, '2020-10-02', 'BD', 'Bangladesh', 'SEARO', '1508', '364987', '21', '5272');
INSERT INTO public.who_global_data_import VALUES (6675, '2020-10-03', 'BD', 'Bangladesh', 'SEARO', '1396', '366383', '33', '5305');
INSERT INTO public.who_global_data_import VALUES (6676, '2020-10-04', 'BD', 'Bangladesh', 'SEARO', '1182', '367565', '20', '5325');
INSERT INTO public.who_global_data_import VALUES (6677, '2020-10-05', 'BD', 'Bangladesh', 'SEARO', '1125', '368690', '23', '5348');
INSERT INTO public.who_global_data_import VALUES (6678, '2020-10-06', 'BD', 'Bangladesh', 'SEARO', '1442', '370132', '27', '5375');
INSERT INTO public.who_global_data_import VALUES (6679, '2020-10-07', 'BD', 'Bangladesh', 'SEARO', '1499', '371631', '30', '5405');
INSERT INTO public.who_global_data_import VALUES (6680, '2020-10-08', 'BD', 'Bangladesh', 'SEARO', '1520', '373151', '35', '5440');
INSERT INTO public.who_global_data_import VALUES (6681, '2020-10-09', 'BD', 'Bangladesh', 'SEARO', '1441', '374592', '20', '5460');
INSERT INTO public.who_global_data_import VALUES (6682, '2020-10-10', 'BD', 'Bangladesh', 'SEARO', '1278', '375870', '17', '5477');
INSERT INTO public.who_global_data_import VALUES (6683, '2020-10-11', 'BD', 'Bangladesh', 'SEARO', '1203', '377073', '23', '5500');
INSERT INTO public.who_global_data_import VALUES (6684, '2020-10-12', 'BD', 'Bangladesh', 'SEARO', '1193', '378266', '24', '5524');
INSERT INTO public.who_global_data_import VALUES (6685, '2020-10-13', 'BD', 'Bangladesh', 'SEARO', '1472', '379738', '31', '5555');
INSERT INTO public.who_global_data_import VALUES (6686, '2020-10-14', 'BD', 'Bangladesh', 'SEARO', '1537', '381275', '22', '5577');
INSERT INTO public.who_global_data_import VALUES (6687, '2020-10-15', 'BD', 'Bangladesh', 'SEARO', '1684', '382959', '16', '5593');
INSERT INTO public.who_global_data_import VALUES (6688, '2020-10-16', 'BD', 'Bangladesh', 'SEARO', '1600', '384559', '15', '5608');
INSERT INTO public.who_global_data_import VALUES (6689, '2020-10-17', 'BD', 'Bangladesh', 'SEARO', '1527', '386086', '15', '5623');
INSERT INTO public.who_global_data_import VALUES (6690, '2020-10-18', 'BD', 'Bangladesh', 'SEARO', '1209', '387295', '23', '5646');
INSERT INTO public.who_global_data_import VALUES (6691, '2020-10-19', 'BD', 'Bangladesh', 'SEARO', '1274', '388569', '14', '5660');
INSERT INTO public.who_global_data_import VALUES (6692, '2020-10-20', 'BD', 'Bangladesh', 'SEARO', '1637', '390206', '21', '5681');
INSERT INTO public.who_global_data_import VALUES (6693, '2020-10-21', 'BD', 'Bangladesh', 'SEARO', '1380', '391586', '18', '5699');
INSERT INTO public.who_global_data_import VALUES (6694, '2020-10-22', 'BD', 'Bangladesh', 'SEARO', '1545', '393131', '24', '5723');
INSERT INTO public.who_global_data_import VALUES (6695, '2020-10-23', 'BD', 'Bangladesh', 'SEARO', '1696', '394827', '24', '5747');
INSERT INTO public.who_global_data_import VALUES (6696, '2020-10-24', 'BD', 'Bangladesh', 'SEARO', '1586', '396413', '14', '5761');
INSERT INTO public.who_global_data_import VALUES (6697, '2020-10-25', 'BD', 'Bangladesh', 'SEARO', '1094', '397507', '19', '5780');
INSERT INTO public.who_global_data_import VALUES (6698, '2020-10-26', 'BD', 'Bangladesh', 'SEARO', '1308', '398815', '23', '5803');
INSERT INTO public.who_global_data_import VALUES (6699, '2020-10-27', 'BD', 'Bangladesh', 'SEARO', '1436', '400251', '15', '5818');
INSERT INTO public.who_global_data_import VALUES (6700, '2020-10-28', 'BD', 'Bangladesh', 'SEARO', '1335', '401586', '20', '5838');
INSERT INTO public.who_global_data_import VALUES (6701, '2020-10-29', 'BD', 'Bangladesh', 'SEARO', '1493', '403079', '23', '5861');
INSERT INTO public.who_global_data_import VALUES (6702, '2020-10-30', 'BD', 'Bangladesh', 'SEARO', '1681', '404760', '25', '5886');
INSERT INTO public.who_global_data_import VALUES (6703, '2020-10-31', 'BD', 'Bangladesh', 'SEARO', '1604', '406364', '19', '5905');
INSERT INTO public.who_global_data_import VALUES (6704, '2020-11-01', 'BD', 'Bangladesh', 'SEARO', '1320', '407684', '18', '5923');
INSERT INTO public.who_global_data_import VALUES (6705, '2020-11-02', 'BD', 'Bangladesh', 'SEARO', '1568', '409252', '18', '5941');
INSERT INTO public.who_global_data_import VALUES (6706, '2020-11-03', 'BD', 'Bangladesh', 'SEARO', '1736', '410988', '25', '5966');
INSERT INTO public.who_global_data_import VALUES (6707, '2020-11-04', 'BD', 'Bangladesh', 'SEARO', '1659', '412647', '17', '5983');
INSERT INTO public.who_global_data_import VALUES (6708, '2020-11-05', 'BD', 'Bangladesh', 'SEARO', '1517', '414164', '21', '6004');
INSERT INTO public.who_global_data_import VALUES (6709, '2020-11-06', 'BD', 'Bangladesh', 'SEARO', '1842', '416006', '17', '6021');
INSERT INTO public.who_global_data_import VALUES (6710, '2020-11-07', 'BD', 'Bangladesh', 'SEARO', '1469', '417475', '15', '6036');
INSERT INTO public.who_global_data_import VALUES (6711, '2020-11-08', 'BD', 'Bangladesh', 'SEARO', '1289', '418764', '13', '6049');
INSERT INTO public.who_global_data_import VALUES (6712, '2020-11-09', 'BD', 'Bangladesh', 'SEARO', '1474', '420238', '18', '6067');
INSERT INTO public.who_global_data_import VALUES (6713, '2020-11-10', 'BD', 'Bangladesh', 'SEARO', '1683', '421921', '25', '6092');
INSERT INTO public.who_global_data_import VALUES (6714, '2020-11-11', 'BD', 'Bangladesh', 'SEARO', '1699', '423620', '16', '6108');
INSERT INTO public.who_global_data_import VALUES (6715, '2020-11-12', 'BD', 'Bangladesh', 'SEARO', '1733', '425353', '19', '6127');
INSERT INTO public.who_global_data_import VALUES (6716, '2020-11-13', 'BD', 'Bangladesh', 'SEARO', '1845', '427198', '13', '6140');
INSERT INTO public.who_global_data_import VALUES (6717, '2020-11-14', 'BD', 'Bangladesh', 'SEARO', '1767', '428965', '19', '6159');
INSERT INTO public.who_global_data_import VALUES (6718, '2020-11-15', 'BD', 'Bangladesh', 'SEARO', '1531', '430496', '14', '6173');
INSERT INTO public.who_global_data_import VALUES (6719, '2020-11-16', 'BD', 'Bangladesh', 'SEARO', '1837', '432333', '21', '6194');
INSERT INTO public.who_global_data_import VALUES (6720, '2020-11-17', 'BD', 'Bangladesh', 'SEARO', '2139', '434472', '21', '6215');
INSERT INTO public.who_global_data_import VALUES (6721, '2020-11-18', 'BD', 'Bangladesh', 'SEARO', '2212', '436684', '39', '6254');
INSERT INTO public.who_global_data_import VALUES (6722, '2020-11-19', 'BD', 'Bangladesh', 'SEARO', '2111', '438795', '21', '6275');
INSERT INTO public.who_global_data_import VALUES (6723, '2020-11-20', 'BD', 'Bangladesh', 'SEARO', '2364', '441159', '30', '6305');
INSERT INTO public.who_global_data_import VALUES (6724, '2020-11-21', 'BD', 'Bangladesh', 'SEARO', '2275', '443434', '17', '6322');
INSERT INTO public.who_global_data_import VALUES (6725, '2020-11-22', 'BD', 'Bangladesh', 'SEARO', '1847', '445281', '28', '6350');
INSERT INTO public.who_global_data_import VALUES (6726, '2020-11-23', 'BD', 'Bangladesh', 'SEARO', '2060', '447341', '38', '6388');
INSERT INTO public.who_global_data_import VALUES (6727, '2020-11-24', 'BD', 'Bangladesh', 'SEARO', '2419', '449760', '28', '6416');
INSERT INTO public.who_global_data_import VALUES (6728, '2020-11-25', 'BD', 'Bangladesh', 'SEARO', '2230', '451990', '32', '6448');
INSERT INTO public.who_global_data_import VALUES (6729, '2020-11-26', 'BD', 'Bangladesh', 'SEARO', '2156', '454146', '39', '6487');
INSERT INTO public.who_global_data_import VALUES (6730, '2020-11-27', 'BD', 'Bangladesh', 'SEARO', '2292', '456438', '37', '6524');
INSERT INTO public.who_global_data_import VALUES (6731, '2020-11-28', 'BD', 'Bangladesh', 'SEARO', '2273', '458711', '20', '6544');
INSERT INTO public.who_global_data_import VALUES (6732, '2020-11-29', 'BD', 'Bangladesh', 'SEARO', '1908', '460619', '36', '6580');
INSERT INTO public.who_global_data_import VALUES (6733, '2020-11-30', 'BD', 'Bangladesh', 'SEARO', '1788', '462407', '29', '6609');
INSERT INTO public.who_global_data_import VALUES (6734, '2020-12-01', 'BD', 'Bangladesh', 'SEARO', '2525', '464932', '35', '6644');
INSERT INTO public.who_global_data_import VALUES (6735, '2020-12-02', 'BD', 'Bangladesh', 'SEARO', '2293', '467225', '31', '6675');
INSERT INTO public.who_global_data_import VALUES (6736, '2020-12-03', 'BD', 'Bangladesh', 'SEARO', '2198', '469423', '38', '6713');
INSERT INTO public.who_global_data_import VALUES (6737, '2020-12-04', 'BD', 'Bangladesh', 'SEARO', '2316', '471739', '35', '6748');
INSERT INTO public.who_global_data_import VALUES (6738, '2020-12-05', 'BD', 'Bangladesh', 'SEARO', '2252', '473991', '24', '6772');
INSERT INTO public.who_global_data_import VALUES (6739, '2020-12-06', 'BD', 'Bangladesh', 'SEARO', '1888', '475879', '35', '6807');
INSERT INTO public.who_global_data_import VALUES (6740, '2020-12-07', 'BD', 'Bangladesh', 'SEARO', '1666', '477545', '31', '6838');
INSERT INTO public.who_global_data_import VALUES (6741, '2020-12-08', 'BD', 'Bangladesh', 'SEARO', '2198', '479743', '36', '6874');
INSERT INTO public.who_global_data_import VALUES (6742, '2020-12-09', 'BD', 'Bangladesh', 'SEARO', '2202', '481945', '32', '6906');
INSERT INTO public.who_global_data_import VALUES (6743, '2020-12-10', 'BD', 'Bangladesh', 'SEARO', '2159', '484104', '24', '6930');
INSERT INTO public.who_global_data_import VALUES (6744, '2020-12-11', 'BD', 'Bangladesh', 'SEARO', '1861', '485965', '37', '6967');
INSERT INTO public.who_global_data_import VALUES (6745, '2020-12-12', 'BD', 'Bangladesh', 'SEARO', '1884', '487849', '19', '6986');
INSERT INTO public.who_global_data_import VALUES (6746, '2020-12-13', 'BD', 'Bangladesh', 'SEARO', '1329', '489178', '34', '7020');
INSERT INTO public.who_global_data_import VALUES (6747, '2020-12-14', 'BD', 'Bangladesh', 'SEARO', '1355', '490533', '32', '7052');
INSERT INTO public.who_global_data_import VALUES (6748, '2020-12-15', 'BD', 'Bangladesh', 'SEARO', '1799', '492332', '37', '7089');
INSERT INTO public.who_global_data_import VALUES (6749, '2020-12-16', 'BD', 'Bangladesh', 'SEARO', '1877', '494209', '40', '7129');
INSERT INTO public.who_global_data_import VALUES (6750, '2020-12-17', 'BD', 'Bangladesh', 'SEARO', '1632', '495841', '27', '7156');
INSERT INTO public.who_global_data_import VALUES (6751, '2020-12-18', 'BD', 'Bangladesh', 'SEARO', '1134', '496975', '36', '7192');
INSERT INTO public.who_global_data_import VALUES (6752, '2020-12-19', 'BD', 'Bangladesh', 'SEARO', '1318', '498293', '25', '7217');
INSERT INTO public.who_global_data_import VALUES (6753, '2020-12-20', 'BD', 'Bangladesh', 'SEARO', '1267', '499560', '25', '7242');
INSERT INTO public.who_global_data_import VALUES (6754, '2020-12-21', 'BD', 'Bangladesh', 'SEARO', '1153', '500713', '38', '7280');
INSERT INTO public.who_global_data_import VALUES (6755, '2020-12-22', 'BD', 'Bangladesh', 'SEARO', '1470', '502183', '32', '7312');
INSERT INTO public.who_global_data_import VALUES (6756, '2020-12-23', 'BD', 'Bangladesh', 'SEARO', '1318', '503501', '17', '7329');
INSERT INTO public.who_global_data_import VALUES (6757, '2020-12-24', 'BD', 'Bangladesh', 'SEARO', '1367', '504868', '30', '7359');
INSERT INTO public.who_global_data_import VALUES (6758, '2020-12-25', 'BD', 'Bangladesh', 'SEARO', '1234', '506102', '19', '7378');
INSERT INTO public.who_global_data_import VALUES (6759, '2020-12-26', 'BD', 'Bangladesh', 'SEARO', '1163', '507265', '20', '7398');
INSERT INTO public.who_global_data_import VALUES (6760, '2020-12-27', 'BD', 'Bangladesh', 'SEARO', '834', '508099', '30', '7428');
INSERT INTO public.who_global_data_import VALUES (6761, '2020-12-28', 'BD', 'Bangladesh', 'SEARO', '1049', '509148', '24', '7452');
INSERT INTO public.who_global_data_import VALUES (6762, '2020-12-29', 'BD', 'Bangladesh', 'SEARO', '932', '510080', '27', '7479');
INSERT INTO public.who_global_data_import VALUES (6763, '2020-12-30', 'BD', 'Bangladesh', 'SEARO', '1181', '511261', '30', '7509');
INSERT INTO public.who_global_data_import VALUES (6764, '2020-12-31', 'BD', 'Bangladesh', 'SEARO', '1235', '512496', '22', '7531');
INSERT INTO public.who_global_data_import VALUES (6765, '2021-01-01', 'BD', 'Bangladesh', 'SEARO', '1014', '513510', '28', '7559');
INSERT INTO public.who_global_data_import VALUES (6766, '2021-01-02', 'BD', 'Bangladesh', 'SEARO', '990', '514500', '17', '7576');
INSERT INTO public.who_global_data_import VALUES (6767, '2021-01-03', 'BD', 'Bangladesh', 'SEARO', '684', '515184', '23', '7599');
INSERT INTO public.who_global_data_import VALUES (6768, '2021-01-04', 'BD', 'Bangladesh', 'SEARO', '835', '516019', '27', '7626');
INSERT INTO public.who_global_data_import VALUES (6769, '2021-01-05', 'BD', 'Bangladesh', 'SEARO', '910', '516929', '24', '7650');
INSERT INTO public.who_global_data_import VALUES (6770, '2021-01-06', 'BD', 'Bangladesh', 'SEARO', '991', '517920', '20', '7670');
INSERT INTO public.who_global_data_import VALUES (6771, '2021-01-07', 'BD', 'Bangladesh', 'SEARO', '978', '518898', '17', '7687');
INSERT INTO public.who_global_data_import VALUES (6772, '2021-01-08', 'BD', 'Bangladesh', 'SEARO', '1007', '519905', '31', '7718');
INSERT INTO public.who_global_data_import VALUES (6773, '2021-01-09', 'BD', 'Bangladesh', 'SEARO', '785', '520690', '16', '7734');
INSERT INTO public.who_global_data_import VALUES (6774, '2021-01-10', 'BD', 'Bangladesh', 'SEARO', '692', '521382', '22', '7756');
INSERT INTO public.who_global_data_import VALUES (6775, '2021-01-11', 'BD', 'Bangladesh', 'SEARO', '1071', '522453', '25', '7781');
INSERT INTO public.who_global_data_import VALUES (6776, '2021-01-12', 'BD', 'Bangladesh', 'SEARO', '849', '523302', '22', '7803');
INSERT INTO public.who_global_data_import VALUES (6777, '2021-01-13', 'BD', 'Bangladesh', 'SEARO', '718', '524020', '16', '7819');
INSERT INTO public.who_global_data_import VALUES (6778, '2021-01-14', 'BD', 'Bangladesh', 'SEARO', '890', '524910', '14', '7833');
INSERT INTO public.who_global_data_import VALUES (6779, '2021-01-15', 'BD', 'Bangladesh', 'SEARO', '813', '525723', '16', '7849');
INSERT INTO public.who_global_data_import VALUES (6780, '2021-01-16', 'BD', 'Bangladesh', 'SEARO', '762', '526485', '13', '7862');
INSERT INTO public.who_global_data_import VALUES (6781, '2021-01-17', 'BD', 'Bangladesh', 'SEARO', '578', '527063', '21', '7883');
INSERT INTO public.who_global_data_import VALUES (6782, '2021-01-18', 'BD', 'Bangladesh', 'SEARO', '569', '527632', '23', '7906');
INSERT INTO public.who_global_data_import VALUES (6783, '2021-01-19', 'BD', 'Bangladesh', 'SEARO', '697', '528329', '16', '7922');
INSERT INTO public.who_global_data_import VALUES (6784, '2021-01-20', 'BD', 'Bangladesh', 'SEARO', '702', '529031', '20', '7942');
INSERT INTO public.who_global_data_import VALUES (6785, '2021-01-21', 'BD', 'Bangladesh', 'SEARO', '656', '529687', '8', '7950');
INSERT INTO public.who_global_data_import VALUES (6786, '2021-01-22', 'BD', 'Bangladesh', 'SEARO', '584', '530271', '16', '7966');
INSERT INTO public.who_global_data_import VALUES (6787, '2021-01-23', 'BD', 'Bangladesh', 'SEARO', '619', '530890', '15', '7981');
INSERT INTO public.who_global_data_import VALUES (6788, '2021-01-24', 'BD', 'Bangladesh', 'SEARO', '436', '531326', '22', '8003');
INSERT INTO public.who_global_data_import VALUES (6789, '2021-01-25', 'BD', 'Bangladesh', 'SEARO', '473', '531799', '20', '8023');
INSERT INTO public.who_global_data_import VALUES (6790, '2021-01-26', 'BD', 'Bangladesh', 'SEARO', '602', '532401', '18', '8041');
INSERT INTO public.who_global_data_import VALUES (6791, '2021-01-27', 'BD', 'Bangladesh', 'SEARO', '515', '532916', '14', '8055');
INSERT INTO public.who_global_data_import VALUES (6792, '2021-01-28', 'BD', 'Bangladesh', 'SEARO', '528', '533444', '17', '8072');
INSERT INTO public.who_global_data_import VALUES (6793, '2021-01-29', 'BD', 'Bangladesh', 'SEARO', '509', '533953', '15', '8087');
INSERT INTO public.who_global_data_import VALUES (6794, '2021-01-30', 'BD', 'Bangladesh', 'SEARO', '454', '534407', '7', '8094');
INSERT INTO public.who_global_data_import VALUES (6795, '2021-01-31', 'BD', 'Bangladesh', 'SEARO', '363', '534770', '17', '8111');
INSERT INTO public.who_global_data_import VALUES (6796, '2021-02-01', 'BD', 'Bangladesh', 'SEARO', '369', '535139', '16', '8127');
INSERT INTO public.who_global_data_import VALUES (6797, '2021-02-02', 'BD', 'Bangladesh', 'SEARO', '443', '535582', '10', '8137');
INSERT INTO public.who_global_data_import VALUES (6798, '2021-02-03', 'BD', 'Bangladesh', 'SEARO', '525', '536107', '12', '8149');
INSERT INTO public.who_global_data_import VALUES (6799, '2021-02-04', 'BD', 'Bangladesh', 'SEARO', '438', '536545', '13', '8162');
INSERT INTO public.who_global_data_import VALUES (6800, '2021-02-05', 'BD', 'Bangladesh', 'SEARO', '485', '537030', '13', '8175');
INSERT INTO public.who_global_data_import VALUES (6801, '2020-01-03', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6802, '2020-01-04', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6803, '2020-01-05', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6804, '2020-01-06', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6805, '2020-01-07', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6806, '2020-01-08', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6807, '2020-01-09', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6808, '2020-01-10', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6809, '2020-01-11', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6810, '2020-01-12', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6811, '2020-01-13', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6812, '2020-01-14', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6813, '2020-01-15', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6814, '2020-01-16', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6815, '2020-01-17', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6816, '2020-01-18', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6817, '2020-01-19', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6818, '2020-01-20', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6819, '2020-01-21', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6820, '2020-01-22', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6821, '2020-01-23', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6822, '2020-01-24', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6823, '2020-01-25', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6824, '2020-01-26', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6825, '2020-01-27', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6826, '2020-01-28', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6827, '2020-01-29', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6828, '2020-01-30', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6829, '2020-01-31', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6830, '2020-02-01', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6831, '2020-02-02', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6832, '2020-02-03', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6833, '2020-02-04', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6834, '2020-02-05', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6835, '2020-02-06', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6836, '2020-02-07', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6837, '2020-02-08', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6838, '2020-02-09', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6839, '2020-02-10', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6840, '2020-02-11', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6841, '2020-02-12', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6842, '2020-02-13', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6843, '2020-02-14', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6844, '2020-02-15', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6845, '2020-02-16', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6846, '2020-02-17', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6847, '2020-02-18', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6848, '2020-02-19', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6849, '2020-02-20', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6850, '2020-02-21', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6851, '2020-02-22', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6852, '2020-02-23', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6853, '2020-02-24', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6854, '2020-02-25', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6855, '2020-02-26', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6856, '2020-02-27', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6857, '2020-02-28', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6858, '2020-02-29', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6859, '2020-03-01', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6860, '2020-03-02', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6861, '2020-03-03', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6862, '2020-03-04', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6863, '2020-03-05', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6864, '2020-03-06', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6865, '2020-03-07', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6866, '2020-03-08', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6867, '2020-03-09', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6868, '2020-03-10', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6869, '2020-03-11', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6870, '2020-03-12', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6871, '2020-03-13', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6872, '2020-03-14', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6873, '2020-03-15', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6874, '2020-03-16', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6875, '2020-03-17', 'BB', 'Barbados', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6876, '2020-03-18', 'BB', 'Barbados', 'AMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6877, '2020-03-19', 'BB', 'Barbados', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6878, '2020-03-20', 'BB', 'Barbados', 'AMRO', '-1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6879, '2020-03-21', 'BB', 'Barbados', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6880, '2020-03-22', 'BB', 'Barbados', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6881, '2020-03-23', 'BB', 'Barbados', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6882, '2020-03-24', 'BB', 'Barbados', 'AMRO', '13', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6883, '2020-03-25', 'BB', 'Barbados', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6884, '2020-03-26', 'BB', 'Barbados', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6885, '2020-03-27', 'BB', 'Barbados', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6886, '2020-03-28', 'BB', 'Barbados', 'AMRO', '6', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6887, '2020-03-29', 'BB', 'Barbados', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6888, '2020-03-30', 'BB', 'Barbados', 'AMRO', '2', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6889, '2020-03-31', 'BB', 'Barbados', 'AMRO', '7', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6890, '2020-04-01', 'BB', 'Barbados', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6891, '2020-04-02', 'BB', 'Barbados', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6892, '2020-04-03', 'BB', 'Barbados', 'AMRO', '12', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6893, '2020-04-04', 'BB', 'Barbados', 'AMRO', '0', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6894, '2020-04-05', 'BB', 'Barbados', 'AMRO', '6', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6895, '2020-04-06', 'BB', 'Barbados', 'AMRO', '0', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (6896, '2020-04-07', 'BB', 'Barbados', 'AMRO', '5', '56', '1', '1');
INSERT INTO public.who_global_data_import VALUES (6897, '2020-04-08', 'BB', 'Barbados', 'AMRO', '4', '60', '1', '2');
INSERT INTO public.who_global_data_import VALUES (6898, '2020-04-09', 'BB', 'Barbados', 'AMRO', '3', '63', '1', '3');
INSERT INTO public.who_global_data_import VALUES (6899, '2020-04-10', 'BB', 'Barbados', 'AMRO', '0', '63', '0', '3');
INSERT INTO public.who_global_data_import VALUES (6900, '2020-04-11', 'BB', 'Barbados', 'AMRO', '3', '66', '1', '4');
INSERT INTO public.who_global_data_import VALUES (6901, '2020-04-12', 'BB', 'Barbados', 'AMRO', '1', '67', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6902, '2020-04-13', 'BB', 'Barbados', 'AMRO', '1', '68', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6903, '2020-04-14', 'BB', 'Barbados', 'AMRO', '3', '71', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6904, '2020-04-15', 'BB', 'Barbados', 'AMRO', '1', '72', '0', '4');
INSERT INTO public.who_global_data_import VALUES (6905, '2020-04-16', 'BB', 'Barbados', 'AMRO', '1', '73', '1', '5');
INSERT INTO public.who_global_data_import VALUES (6906, '2020-04-17', 'BB', 'Barbados', 'AMRO', '2', '75', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6907, '2020-04-18', 'BB', 'Barbados', 'AMRO', '0', '75', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6908, '2020-04-19', 'BB', 'Barbados', 'AMRO', '0', '75', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6909, '2020-04-20', 'BB', 'Barbados', 'AMRO', '0', '75', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6910, '2020-04-21', 'BB', 'Barbados', 'AMRO', '0', '75', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6911, '2020-04-22', 'BB', 'Barbados', 'AMRO', '0', '75', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6912, '2020-04-23', 'BB', 'Barbados', 'AMRO', '0', '75', '0', '5');
INSERT INTO public.who_global_data_import VALUES (6913, '2020-04-24', 'BB', 'Barbados', 'AMRO', '1', '76', '1', '6');
INSERT INTO public.who_global_data_import VALUES (6914, '2020-04-25', 'BB', 'Barbados', 'AMRO', '0', '76', '0', '6');
INSERT INTO public.who_global_data_import VALUES (6915, '2020-04-26', 'BB', 'Barbados', 'AMRO', '1', '77', '0', '6');
INSERT INTO public.who_global_data_import VALUES (6916, '2020-04-27', 'BB', 'Barbados', 'AMRO', '2', '79', '0', '6');
INSERT INTO public.who_global_data_import VALUES (6917, '2020-04-28', 'BB', 'Barbados', 'AMRO', '0', '79', '0', '6');
INSERT INTO public.who_global_data_import VALUES (6918, '2020-04-29', 'BB', 'Barbados', 'AMRO', '1', '80', '0', '6');
INSERT INTO public.who_global_data_import VALUES (6919, '2020-04-30', 'BB', 'Barbados', 'AMRO', '0', '80', '0', '6');
INSERT INTO public.who_global_data_import VALUES (6920, '2020-05-01', 'BB', 'Barbados', 'AMRO', '0', '80', '1', '7');
INSERT INTO public.who_global_data_import VALUES (6921, '2020-05-02', 'BB', 'Barbados', 'AMRO', '1', '81', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6922, '2020-05-03', 'BB', 'Barbados', 'AMRO', '0', '81', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6923, '2020-05-04', 'BB', 'Barbados', 'AMRO', '0', '81', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6924, '2020-05-05', 'BB', 'Barbados', 'AMRO', '1', '82', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6925, '2020-05-06', 'BB', 'Barbados', 'AMRO', '0', '82', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6926, '2020-05-07', 'BB', 'Barbados', 'AMRO', '0', '82', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6927, '2020-05-08', 'BB', 'Barbados', 'AMRO', '0', '82', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6928, '2020-05-09', 'BB', 'Barbados', 'AMRO', '0', '82', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6929, '2020-05-10', 'BB', 'Barbados', 'AMRO', '0', '82', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6930, '2020-05-11', 'BB', 'Barbados', 'AMRO', '2', '84', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6931, '2020-05-12', 'BB', 'Barbados', 'AMRO', '0', '84', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6932, '2020-05-13', 'BB', 'Barbados', 'AMRO', '0', '84', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6933, '2020-05-14', 'BB', 'Barbados', 'AMRO', '1', '85', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6934, '2020-05-15', 'BB', 'Barbados', 'AMRO', '0', '85', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6935, '2020-05-16', 'BB', 'Barbados', 'AMRO', '0', '85', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6936, '2020-05-17', 'BB', 'Barbados', 'AMRO', '0', '85', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6937, '2020-05-18', 'BB', 'Barbados', 'AMRO', '1', '86', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6938, '2020-05-19', 'BB', 'Barbados', 'AMRO', '2', '88', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6939, '2020-05-20', 'BB', 'Barbados', 'AMRO', '0', '88', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6940, '2020-05-21', 'BB', 'Barbados', 'AMRO', '2', '90', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6941, '2020-05-22', 'BB', 'Barbados', 'AMRO', '0', '90', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6942, '2020-05-23', 'BB', 'Barbados', 'AMRO', '0', '90', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6943, '2020-05-24', 'BB', 'Barbados', 'AMRO', '0', '90', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6944, '2020-05-25', 'BB', 'Barbados', 'AMRO', '2', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6945, '2020-05-26', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6946, '2020-05-27', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6947, '2020-05-28', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6948, '2020-05-29', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6949, '2020-05-30', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6950, '2020-05-31', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6951, '2020-06-01', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6952, '2020-06-02', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6953, '2020-06-03', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6954, '2020-06-04', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6955, '2020-06-05', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6956, '2020-06-06', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6957, '2020-06-07', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6958, '2020-06-08', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6959, '2020-06-09', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6960, '2020-06-10', 'BB', 'Barbados', 'AMRO', '0', '92', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6961, '2020-06-11', 'BB', 'Barbados', 'AMRO', '4', '96', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6962, '2020-06-12', 'BB', 'Barbados', 'AMRO', '0', '96', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6963, '2020-06-13', 'BB', 'Barbados', 'AMRO', '0', '96', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6964, '2020-06-14', 'BB', 'Barbados', 'AMRO', '0', '96', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6965, '2020-06-15', 'BB', 'Barbados', 'AMRO', '0', '96', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6966, '2020-06-16', 'BB', 'Barbados', 'AMRO', '1', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6967, '2020-06-17', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6968, '2020-06-18', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6969, '2020-06-19', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6970, '2020-06-20', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6971, '2020-06-21', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6972, '2020-06-22', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6973, '2020-06-23', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6974, '2020-06-24', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6975, '2020-06-25', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6976, '2020-06-26', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6977, '2020-06-27', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6978, '2020-06-28', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6979, '2020-06-29', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6980, '2020-06-30', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6981, '2020-07-01', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6982, '2020-07-02', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6983, '2020-07-03', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6984, '2020-07-04', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6985, '2020-07-05', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6986, '2020-07-06', 'BB', 'Barbados', 'AMRO', '0', '97', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6987, '2020-07-07', 'BB', 'Barbados', 'AMRO', '1', '98', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6988, '2020-07-08', 'BB', 'Barbados', 'AMRO', '0', '98', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6989, '2020-07-09', 'BB', 'Barbados', 'AMRO', '0', '98', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6990, '2020-07-10', 'BB', 'Barbados', 'AMRO', '0', '98', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6991, '2020-07-11', 'BB', 'Barbados', 'AMRO', '0', '98', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6992, '2020-07-12', 'BB', 'Barbados', 'AMRO', '0', '98', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6993, '2020-07-13', 'BB', 'Barbados', 'AMRO', '5', '103', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6994, '2020-07-14', 'BB', 'Barbados', 'AMRO', '0', '103', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6995, '2020-07-15', 'BB', 'Barbados', 'AMRO', '0', '103', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6996, '2020-07-16', 'BB', 'Barbados', 'AMRO', '0', '103', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6997, '2020-07-17', 'BB', 'Barbados', 'AMRO', '1', '104', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6998, '2020-07-18', 'BB', 'Barbados', 'AMRO', '0', '104', '0', '7');
INSERT INTO public.who_global_data_import VALUES (6999, '2020-07-19', 'BB', 'Barbados', 'AMRO', '0', '104', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7000, '2020-07-20', 'BB', 'Barbados', 'AMRO', '1', '105', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7001, '2020-07-21', 'BB', 'Barbados', 'AMRO', '0', '105', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7002, '2020-07-22', 'BB', 'Barbados', 'AMRO', '1', '106', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7003, '2020-07-23', 'BB', 'Barbados', 'AMRO', '0', '106', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7004, '2020-07-24', 'BB', 'Barbados', 'AMRO', '0', '106', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7005, '2020-07-25', 'BB', 'Barbados', 'AMRO', '0', '106', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7006, '2020-07-26', 'BB', 'Barbados', 'AMRO', '2', '108', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7007, '2020-07-27', 'BB', 'Barbados', 'AMRO', '0', '108', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7008, '2020-07-28', 'BB', 'Barbados', 'AMRO', '2', '110', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7009, '2020-07-29', 'BB', 'Barbados', 'AMRO', '0', '110', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7010, '2020-07-30', 'BB', 'Barbados', 'AMRO', '0', '110', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7011, '2020-07-31', 'BB', 'Barbados', 'AMRO', '0', '110', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7012, '2020-08-01', 'BB', 'Barbados', 'AMRO', '0', '110', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7013, '2020-08-02', 'BB', 'Barbados', 'AMRO', '0', '110', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7014, '2020-08-03', 'BB', 'Barbados', 'AMRO', '12', '122', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7015, '2020-08-04', 'BB', 'Barbados', 'AMRO', '10', '132', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7016, '2020-08-05', 'BB', 'Barbados', 'AMRO', '0', '132', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7017, '2020-08-06', 'BB', 'Barbados', 'AMRO', '1', '133', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7018, '2020-08-07', 'BB', 'Barbados', 'AMRO', '0', '133', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7019, '2020-08-08', 'BB', 'Barbados', 'AMRO', '0', '133', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7020, '2020-08-09', 'BB', 'Barbados', 'AMRO', '5', '138', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7021, '2020-08-10', 'BB', 'Barbados', 'AMRO', '4', '142', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7022, '2020-08-11', 'BB', 'Barbados', 'AMRO', '0', '142', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7023, '2020-08-12', 'BB', 'Barbados', 'AMRO', '1', '143', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7024, '2020-08-13', 'BB', 'Barbados', 'AMRO', '0', '143', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7025, '2020-08-14', 'BB', 'Barbados', 'AMRO', '1', '144', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7026, '2020-08-15', 'BB', 'Barbados', 'AMRO', '0', '144', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7027, '2020-08-16', 'BB', 'Barbados', 'AMRO', '4', '148', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7028, '2020-08-17', 'BB', 'Barbados', 'AMRO', '3', '151', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7029, '2020-08-18', 'BB', 'Barbados', 'AMRO', '1', '152', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7030, '2020-08-19', 'BB', 'Barbados', 'AMRO', '0', '152', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7031, '2020-08-20', 'BB', 'Barbados', 'AMRO', '3', '155', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7032, '2020-08-21', 'BB', 'Barbados', 'AMRO', '0', '155', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7033, '2020-08-22', 'BB', 'Barbados', 'AMRO', '2', '157', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7034, '2020-08-23', 'BB', 'Barbados', 'AMRO', '0', '157', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7035, '2020-08-24', 'BB', 'Barbados', 'AMRO', '4', '161', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7036, '2020-08-25', 'BB', 'Barbados', 'AMRO', '0', '161', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7037, '2020-08-26', 'BB', 'Barbados', 'AMRO', '0', '161', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7038, '2020-08-27', 'BB', 'Barbados', 'AMRO', '3', '164', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7039, '2020-08-28', 'BB', 'Barbados', 'AMRO', '1', '165', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7040, '2020-08-29', 'BB', 'Barbados', 'AMRO', '0', '165', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7041, '2020-08-30', 'BB', 'Barbados', 'AMRO', '1', '166', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7042, '2020-08-31', 'BB', 'Barbados', 'AMRO', '7', '173', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7043, '2020-09-01', 'BB', 'Barbados', 'AMRO', '0', '173', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7044, '2020-09-02', 'BB', 'Barbados', 'AMRO', '1', '174', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7045, '2020-09-03', 'BB', 'Barbados', 'AMRO', '2', '176', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7046, '2020-09-04', 'BB', 'Barbados', 'AMRO', '1', '177', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7047, '2020-09-05', 'BB', 'Barbados', 'AMRO', '0', '177', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7048, '2020-09-06', 'BB', 'Barbados', 'AMRO', '1', '178', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7049, '2020-09-07', 'BB', 'Barbados', 'AMRO', '1', '179', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7050, '2020-09-08', 'BB', 'Barbados', 'AMRO', '0', '179', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7051, '2020-09-09', 'BB', 'Barbados', 'AMRO', '1', '180', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7052, '2020-09-10', 'BB', 'Barbados', 'AMRO', '0', '180', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7053, '2020-09-11', 'BB', 'Barbados', 'AMRO', '0', '180', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7054, '2020-09-12', 'BB', 'Barbados', 'AMRO', '0', '180', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7055, '2020-09-13', 'BB', 'Barbados', 'AMRO', '0', '180', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7056, '2020-09-14', 'BB', 'Barbados', 'AMRO', '1', '181', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7057, '2020-09-15', 'BB', 'Barbados', 'AMRO', '2', '183', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7058, '2020-09-16', 'BB', 'Barbados', 'AMRO', '0', '183', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7059, '2020-09-17', 'BB', 'Barbados', 'AMRO', '1', '184', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7060, '2020-09-18', 'BB', 'Barbados', 'AMRO', '1', '185', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7061, '2020-09-19', 'BB', 'Barbados', 'AMRO', '0', '185', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7062, '2020-09-20', 'BB', 'Barbados', 'AMRO', '0', '185', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7063, '2020-09-21', 'BB', 'Barbados', 'AMRO', '0', '185', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7064, '2020-09-22', 'BB', 'Barbados', 'AMRO', '4', '189', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7065, '2020-09-23', 'BB', 'Barbados', 'AMRO', '0', '189', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7066, '2020-09-24', 'BB', 'Barbados', 'AMRO', '0', '189', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7067, '2020-09-25', 'BB', 'Barbados', 'AMRO', '0', '189', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7068, '2020-09-26', 'BB', 'Barbados', 'AMRO', '0', '189', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7069, '2020-09-27', 'BB', 'Barbados', 'AMRO', '1', '190', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7070, '2020-09-28', 'BB', 'Barbados', 'AMRO', '0', '190', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7071, '2020-09-29', 'BB', 'Barbados', 'AMRO', '0', '190', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7072, '2020-09-30', 'BB', 'Barbados', 'AMRO', '0', '190', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7073, '2020-10-01', 'BB', 'Barbados', 'AMRO', '0', '190', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7074, '2020-10-02', 'BB', 'Barbados', 'AMRO', '0', '190', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7075, '2020-10-03', 'BB', 'Barbados', 'AMRO', '3', '193', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7076, '2020-10-04', 'BB', 'Barbados', 'AMRO', '3', '196', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7077, '2020-10-05', 'BB', 'Barbados', 'AMRO', '0', '196', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7078, '2020-10-06', 'BB', 'Barbados', 'AMRO', '3', '199', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7079, '2020-10-07', 'BB', 'Barbados', 'AMRO', '1', '200', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7080, '2020-10-08', 'BB', 'Barbados', 'AMRO', '3', '203', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7081, '2020-10-09', 'BB', 'Barbados', 'AMRO', '0', '203', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7082, '2020-10-10', 'BB', 'Barbados', 'AMRO', '0', '203', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7083, '2020-10-11', 'BB', 'Barbados', 'AMRO', '2', '205', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7084, '2020-10-12', 'BB', 'Barbados', 'AMRO', '1', '206', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7085, '2020-10-13', 'BB', 'Barbados', 'AMRO', '2', '208', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7086, '2020-10-14', 'BB', 'Barbados', 'AMRO', '0', '208', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7087, '2020-10-15', 'BB', 'Barbados', 'AMRO', '2', '210', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7088, '2020-10-16', 'BB', 'Barbados', 'AMRO', '5', '215', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7089, '2020-10-17', 'BB', 'Barbados', 'AMRO', '3', '218', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7090, '2020-10-18', 'BB', 'Barbados', 'AMRO', '1', '219', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7091, '2020-10-19', 'BB', 'Barbados', 'AMRO', '0', '219', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7092, '2020-10-20', 'BB', 'Barbados', 'AMRO', '3', '222', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7093, '2020-10-21', 'BB', 'Barbados', 'AMRO', '0', '222', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7094, '2020-10-22', 'BB', 'Barbados', 'AMRO', '0', '222', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7095, '2020-10-23', 'BB', 'Barbados', 'AMRO', '2', '224', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7096, '2020-10-24', 'BB', 'Barbados', 'AMRO', '0', '224', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7097, '2020-10-25', 'BB', 'Barbados', 'AMRO', '3', '227', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7098, '2020-10-26', 'BB', 'Barbados', 'AMRO', '3', '230', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7099, '2020-10-27', 'BB', 'Barbados', 'AMRO', '3', '233', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7100, '2020-10-28', 'BB', 'Barbados', 'AMRO', '0', '233', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7101, '2020-10-29', 'BB', 'Barbados', 'AMRO', '0', '233', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7102, '2020-10-30', 'BB', 'Barbados', 'AMRO', '2', '235', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7103, '2020-10-31', 'BB', 'Barbados', 'AMRO', '1', '236', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7104, '2020-11-01', 'BB', 'Barbados', 'AMRO', '0', '236', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7105, '2020-11-02', 'BB', 'Barbados', 'AMRO', '1', '237', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7106, '2020-11-03', 'BB', 'Barbados', 'AMRO', '0', '237', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7107, '2020-11-04', 'BB', 'Barbados', 'AMRO', '1', '238', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7108, '2020-11-05', 'BB', 'Barbados', 'AMRO', '0', '238', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7109, '2020-11-06', 'BB', 'Barbados', 'AMRO', '1', '239', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7110, '2020-11-07', 'BB', 'Barbados', 'AMRO', '0', '239', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7111, '2020-11-08', 'BB', 'Barbados', 'AMRO', '3', '242', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7112, '2020-11-09', 'BB', 'Barbados', 'AMRO', '1', '243', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7113, '2020-11-10', 'BB', 'Barbados', 'AMRO', '0', '243', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7114, '2020-11-11', 'BB', 'Barbados', 'AMRO', '0', '243', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7115, '2020-11-12', 'BB', 'Barbados', 'AMRO', '0', '243', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7116, '2020-11-13', 'BB', 'Barbados', 'AMRO', '6', '249', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7117, '2020-11-14', 'BB', 'Barbados', 'AMRO', '0', '249', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7118, '2020-11-15', 'BB', 'Barbados', 'AMRO', '0', '249', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7119, '2020-11-16', 'BB', 'Barbados', 'AMRO', '0', '249', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7120, '2020-11-17', 'BB', 'Barbados', 'AMRO', '1', '250', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7121, '2020-11-18', 'BB', 'Barbados', 'AMRO', '0', '250', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7122, '2020-11-19', 'BB', 'Barbados', 'AMRO', '0', '250', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7123, '2020-11-20', 'BB', 'Barbados', 'AMRO', '3', '253', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7124, '2020-11-21', 'BB', 'Barbados', 'AMRO', '0', '253', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7125, '2020-11-22', 'BB', 'Barbados', 'AMRO', '2', '255', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7126, '2020-11-23', 'BB', 'Barbados', 'AMRO', '4', '259', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7127, '2020-11-24', 'BB', 'Barbados', 'AMRO', '0', '259', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7128, '2020-11-25', 'BB', 'Barbados', 'AMRO', '1', '260', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7129, '2020-11-26', 'BB', 'Barbados', 'AMRO', '2', '262', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7130, '2020-11-27', 'BB', 'Barbados', 'AMRO', '4', '266', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7131, '2020-11-28', 'BB', 'Barbados', 'AMRO', '4', '270', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7132, '2020-11-29', 'BB', 'Barbados', 'AMRO', '0', '270', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7133, '2020-11-30', 'BB', 'Barbados', 'AMRO', '5', '275', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7134, '2020-12-01', 'BB', 'Barbados', 'AMRO', '1', '276', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7135, '2020-12-02', 'BB', 'Barbados', 'AMRO', '2', '278', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7136, '2020-12-03', 'BB', 'Barbados', 'AMRO', '0', '278', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7137, '2020-12-04', 'BB', 'Barbados', 'AMRO', '1', '279', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7138, '2020-12-05', 'BB', 'Barbados', 'AMRO', '2', '281', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7139, '2020-12-06', 'BB', 'Barbados', 'AMRO', '4', '285', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7140, '2020-12-07', 'BB', 'Barbados', 'AMRO', '0', '285', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7141, '2020-12-08', 'BB', 'Barbados', 'AMRO', '2', '287', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7142, '2020-12-09', 'BB', 'Barbados', 'AMRO', '2', '289', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7143, '2020-12-10', 'BB', 'Barbados', 'AMRO', '1', '290', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7144, '2020-12-11', 'BB', 'Barbados', 'AMRO', '0', '290', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7145, '2020-12-12', 'BB', 'Barbados', 'AMRO', '1', '291', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7146, '2020-12-13', 'BB', 'Barbados', 'AMRO', '1', '292', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7147, '2020-12-14', 'BB', 'Barbados', 'AMRO', '0', '292', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7148, '2020-12-15', 'BB', 'Barbados', 'AMRO', '4', '296', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7149, '2020-12-16', 'BB', 'Barbados', 'AMRO', '1', '297', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7150, '2020-12-17', 'BB', 'Barbados', 'AMRO', '4', '301', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7151, '2020-12-18', 'BB', 'Barbados', 'AMRO', '0', '301', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7152, '2020-12-19', 'BB', 'Barbados', 'AMRO', '4', '305', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7153, '2020-12-20', 'BB', 'Barbados', 'AMRO', '2', '307', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7154, '2020-12-21', 'BB', 'Barbados', 'AMRO', '0', '307', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7155, '2020-12-22', 'BB', 'Barbados', 'AMRO', '14', '321', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7156, '2020-12-23', 'BB', 'Barbados', 'AMRO', '1', '322', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7157, '2020-12-24', 'BB', 'Barbados', 'AMRO', '5', '327', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7158, '2020-12-25', 'BB', 'Barbados', 'AMRO', '2', '329', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7159, '2020-12-26', 'BB', 'Barbados', 'AMRO', '16', '345', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7160, '2020-12-27', 'BB', 'Barbados', 'AMRO', '2', '347', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7161, '2020-12-28', 'BB', 'Barbados', 'AMRO', '9', '356', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7162, '2020-12-29', 'BB', 'Barbados', 'AMRO', '0', '356', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7163, '2020-12-30', 'BB', 'Barbados', 'AMRO', '9', '365', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7164, '2020-12-31', 'BB', 'Barbados', 'AMRO', '7', '372', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7165, '2021-01-01', 'BB', 'Barbados', 'AMRO', '0', '372', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7166, '2021-01-02', 'BB', 'Barbados', 'AMRO', '11', '383', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7167, '2021-01-03', 'BB', 'Barbados', 'AMRO', '12', '395', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7168, '2021-01-04', 'BB', 'Barbados', 'AMRO', '0', '395', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7169, '2021-01-05', 'BB', 'Barbados', 'AMRO', '211', '606', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7170, '2021-01-06', 'BB', 'Barbados', 'AMRO', '37', '643', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7171, '2021-01-07', 'BB', 'Barbados', 'AMRO', '49', '692', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7172, '2021-01-08', 'BB', 'Barbados', 'AMRO', '51', '743', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7173, '2021-01-09', 'BB', 'Barbados', 'AMRO', '37', '780', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7174, '2021-01-10', 'BB', 'Barbados', 'AMRO', '28', '808', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7175, '2021-01-11', 'BB', 'Barbados', 'AMRO', '70', '878', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7176, '2021-01-12', 'BB', 'Barbados', 'AMRO', '0', '878', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7177, '2021-01-13', 'BB', 'Barbados', 'AMRO', '6', '884', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7178, '2021-01-14', 'BB', 'Barbados', 'AMRO', '84', '968', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7179, '2021-01-15', 'BB', 'Barbados', 'AMRO', '39', '1007', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7180, '2021-01-16', 'BB', 'Barbados', 'AMRO', '29', '1036', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7181, '2021-01-17', 'BB', 'Barbados', 'AMRO', '0', '1036', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7182, '2021-01-18', 'BB', 'Barbados', 'AMRO', '59', '1095', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7183, '2021-01-19', 'BB', 'Barbados', 'AMRO', '0', '1095', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7184, '2021-01-20', 'BB', 'Barbados', 'AMRO', '0', '1095', '0', '7');
INSERT INTO public.who_global_data_import VALUES (7185, '2021-01-21', 'BB', 'Barbados', 'AMRO', '61', '1156', '2', '9');
INSERT INTO public.who_global_data_import VALUES (7186, '2021-01-22', 'BB', 'Barbados', 'AMRO', '0', '1156', '0', '9');
INSERT INTO public.who_global_data_import VALUES (7187, '2021-01-23', 'BB', 'Barbados', 'AMRO', '0', '1156', '0', '9');
INSERT INTO public.who_global_data_import VALUES (7188, '2021-01-24', 'BB', 'Barbados', 'AMRO', '87', '1243', '0', '9');
INSERT INTO public.who_global_data_import VALUES (7189, '2021-01-25', 'BB', 'Barbados', 'AMRO', '98', '1341', '0', '9');
INSERT INTO public.who_global_data_import VALUES (7190, '2021-01-26', 'BB', 'Barbados', 'AMRO', '46', '1387', '1', '10');
INSERT INTO public.who_global_data_import VALUES (7191, '2021-01-27', 'BB', 'Barbados', 'AMRO', '14', '1401', '0', '10');
INSERT INTO public.who_global_data_import VALUES (7192, '2021-01-28', 'BB', 'Barbados', 'AMRO', '26', '1427', '0', '10');
INSERT INTO public.who_global_data_import VALUES (7193, '2021-01-29', 'BB', 'Barbados', 'AMRO', '16', '1443', '1', '11');
INSERT INTO public.who_global_data_import VALUES (7194, '2021-01-30', 'BB', 'Barbados', 'AMRO', '4', '1447', '0', '11');
INSERT INTO public.who_global_data_import VALUES (7195, '2021-01-31', 'BB', 'Barbados', 'AMRO', '51', '1498', '1', '12');
INSERT INTO public.who_global_data_import VALUES (7196, '2021-02-01', 'BB', 'Barbados', 'AMRO', '47', '1545', '0', '12');
INSERT INTO public.who_global_data_import VALUES (7197, '2021-02-02', 'BB', 'Barbados', 'AMRO', '0', '1545', '2', '14');
INSERT INTO public.who_global_data_import VALUES (7198, '2021-02-03', 'BB', 'Barbados', 'AMRO', '13', '1558', '0', '14');
INSERT INTO public.who_global_data_import VALUES (7199, '2021-02-04', 'BB', 'Barbados', 'AMRO', '28', '1586', '0', '14');
INSERT INTO public.who_global_data_import VALUES (7200, '2021-02-05', 'BB', 'Barbados', 'AMRO', '25', '1611', '1', '15');
INSERT INTO public.who_global_data_import VALUES (7201, '2020-01-03', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7202, '2020-01-04', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7203, '2020-01-05', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7204, '2020-01-06', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7205, '2020-01-07', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7206, '2020-01-08', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7207, '2020-01-09', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7208, '2020-01-10', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7209, '2020-01-11', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7210, '2020-01-12', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7211, '2020-01-13', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7212, '2020-01-14', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7213, '2020-01-15', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7214, '2020-01-16', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7215, '2020-01-17', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7216, '2020-01-18', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7217, '2020-01-19', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7218, '2020-01-20', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7219, '2020-01-21', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7220, '2020-01-22', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7221, '2020-01-23', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7222, '2020-01-24', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7223, '2020-01-25', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7224, '2020-01-26', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7225, '2020-01-27', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7226, '2020-01-28', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7227, '2020-01-29', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7228, '2020-01-30', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7229, '2020-01-31', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7230, '2020-02-01', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7231, '2020-02-02', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7232, '2020-02-03', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7233, '2020-02-04', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7234, '2020-02-05', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7235, '2020-02-06', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7236, '2020-02-07', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7237, '2020-02-08', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7238, '2020-02-09', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7239, '2020-02-10', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7240, '2020-02-11', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7241, '2020-02-12', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7242, '2020-02-13', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7243, '2020-02-14', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7244, '2020-02-15', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7245, '2020-02-16', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7246, '2020-02-17', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7247, '2020-02-18', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7248, '2020-02-19', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7249, '2020-02-20', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7250, '2020-02-21', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7251, '2020-02-22', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7252, '2020-02-23', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7253, '2020-02-24', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7254, '2020-02-25', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7255, '2020-02-26', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7256, '2020-02-27', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7257, '2020-02-28', 'BY', 'Belarus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7258, '2020-02-29', 'BY', 'Belarus', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7259, '2020-03-01', 'BY', 'Belarus', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7260, '2020-03-02', 'BY', 'Belarus', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7261, '2020-03-03', 'BY', 'Belarus', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7262, '2020-03-04', 'BY', 'Belarus', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7263, '2020-03-05', 'BY', 'Belarus', 'EURO', '5', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7264, '2020-03-06', 'BY', 'Belarus', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7265, '2020-03-07', 'BY', 'Belarus', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7266, '2020-03-08', 'BY', 'Belarus', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7267, '2020-03-09', 'BY', 'Belarus', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7268, '2020-03-10', 'BY', 'Belarus', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7269, '2020-03-11', 'BY', 'Belarus', 'EURO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7270, '2020-03-12', 'BY', 'Belarus', 'EURO', '3', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7271, '2020-03-13', 'BY', 'Belarus', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7272, '2020-03-14', 'BY', 'Belarus', 'EURO', '9', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7273, '2020-03-15', 'BY', 'Belarus', 'EURO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7274, '2020-03-16', 'BY', 'Belarus', 'EURO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7275, '2020-03-17', 'BY', 'Belarus', 'EURO', '15', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7276, '2020-03-18', 'BY', 'Belarus', 'EURO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7277, '2020-03-19', 'BY', 'Belarus', 'EURO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7278, '2020-03-20', 'BY', 'Belarus', 'EURO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7279, '2020-03-21', 'BY', 'Belarus', 'EURO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7280, '2020-03-22', 'BY', 'Belarus', 'EURO', '40', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7281, '2020-03-23', 'BY', 'Belarus', 'EURO', '5', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7282, '2020-03-24', 'BY', 'Belarus', 'EURO', '0', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7283, '2020-03-25', 'BY', 'Belarus', 'EURO', '0', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7284, '2020-03-26', 'BY', 'Belarus', 'EURO', '5', '86', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7285, '2020-03-27', 'BY', 'Belarus', 'EURO', '8', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7286, '2020-03-28', 'BY', 'Belarus', 'EURO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7287, '2020-03-29', 'BY', 'Belarus', 'EURO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7288, '2020-03-30', 'BY', 'Belarus', 'EURO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7289, '2020-03-31', 'BY', 'Belarus', 'EURO', '58', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7290, '2020-04-01', 'BY', 'Belarus', 'EURO', '40', '192', '2', '2');
INSERT INTO public.who_global_data_import VALUES (7291, '2020-04-02', 'BY', 'Belarus', 'EURO', '0', '192', '0', '2');
INSERT INTO public.who_global_data_import VALUES (7292, '2020-04-03', 'BY', 'Belarus', 'EURO', '62', '254', '2', '4');
INSERT INTO public.who_global_data_import VALUES (7293, '2020-04-04', 'BY', 'Belarus', 'EURO', '0', '254', '0', '4');
INSERT INTO public.who_global_data_import VALUES (7294, '2020-04-05', 'BY', 'Belarus', 'EURO', '186', '440', '0', '4');
INSERT INTO public.who_global_data_import VALUES (7295, '2020-04-06', 'BY', 'Belarus', 'EURO', '122', '562', '4', '8');
INSERT INTO public.who_global_data_import VALUES (7296, '2020-04-07', 'BY', 'Belarus', 'EURO', '138', '700', '5', '13');
INSERT INTO public.who_global_data_import VALUES (7297, '2020-04-08', 'BY', 'Belarus', 'EURO', '161', '861', '0', '13');
INSERT INTO public.who_global_data_import VALUES (7298, '2020-04-09', 'BY', 'Belarus', 'EURO', '205', '1066', '0', '13');
INSERT INTO public.who_global_data_import VALUES (7299, '2020-04-10', 'BY', 'Belarus', 'EURO', '0', '1066', '0', '13');
INSERT INTO public.who_global_data_import VALUES (7300, '2020-04-11', 'BY', 'Belarus', 'EURO', '915', '1981', '6', '19');
INSERT INTO public.who_global_data_import VALUES (7301, '2020-04-12', 'BY', 'Belarus', 'EURO', '245', '2226', '4', '23');
INSERT INTO public.who_global_data_import VALUES (7302, '2020-04-13', 'BY', 'Belarus', 'EURO', '352', '2578', '3', '26');
INSERT INTO public.who_global_data_import VALUES (7303, '2020-04-14', 'BY', 'Belarus', 'EURO', '341', '2919', '3', '29');
INSERT INTO public.who_global_data_import VALUES (7304, '2020-04-15', 'BY', 'Belarus', 'EURO', '362', '3281', '4', '33');
INSERT INTO public.who_global_data_import VALUES (7305, '2020-04-16', 'BY', 'Belarus', 'EURO', '447', '3728', '3', '36');
INSERT INTO public.who_global_data_import VALUES (7306, '2020-04-17', 'BY', 'Belarus', 'EURO', '476', '4204', '4', '40');
INSERT INTO public.who_global_data_import VALUES (7307, '2020-04-18', 'BY', 'Belarus', 'EURO', '575', '4779', '3', '43');
INSERT INTO public.who_global_data_import VALUES (7308, '2020-04-19', 'BY', 'Belarus', 'EURO', '510', '5289', '2', '45');
INSERT INTO public.who_global_data_import VALUES (7309, '2020-04-20', 'BY', 'Belarus', 'EURO', '518', '5807', '2', '47');
INSERT INTO public.who_global_data_import VALUES (7310, '2020-04-21', 'BY', 'Belarus', 'EURO', '457', '6264', '4', '51');
INSERT INTO public.who_global_data_import VALUES (7311, '2020-04-22', 'BY', 'Belarus', 'EURO', '459', '6723', '4', '55');
INSERT INTO public.who_global_data_import VALUES (7312, '2020-04-23', 'BY', 'Belarus', 'EURO', '558', '7281', '5', '60');
INSERT INTO public.who_global_data_import VALUES (7313, '2020-04-24', 'BY', 'Belarus', 'EURO', '741', '8022', '0', '60');
INSERT INTO public.who_global_data_import VALUES (7314, '2020-04-25', 'BY', 'Belarus', 'EURO', '751', '8773', '3', '63');
INSERT INTO public.who_global_data_import VALUES (7315, '2020-04-26', 'BY', 'Belarus', 'EURO', '817', '9590', '4', '67');
INSERT INTO public.who_global_data_import VALUES (7316, '2020-04-27', 'BY', 'Belarus', 'EURO', '873', '10463', '5', '72');
INSERT INTO public.who_global_data_import VALUES (7317, '2020-04-28', 'BY', 'Belarus', 'EURO', '1745', '12208', '7', '79');
INSERT INTO public.who_global_data_import VALUES (7318, '2020-04-29', 'BY', 'Belarus', 'EURO', '0', '12208', '0', '79');
INSERT INTO public.who_global_data_import VALUES (7319, '2020-04-30', 'BY', 'Belarus', 'EURO', '973', '13181', '5', '84');
INSERT INTO public.who_global_data_import VALUES (7320, '2020-05-01', 'BY', 'Belarus', 'EURO', '846', '14027', '5', '89');
INSERT INTO public.who_global_data_import VALUES (7321, '2020-05-02', 'BY', 'Belarus', 'EURO', '890', '14917', '4', '93');
INSERT INTO public.who_global_data_import VALUES (7322, '2020-05-03', 'BY', 'Belarus', 'EURO', '911', '15828', '4', '97');
INSERT INTO public.who_global_data_import VALUES (7323, '2020-05-04', 'BY', 'Belarus', 'EURO', '1661', '17489', '6', '103');
INSERT INTO public.who_global_data_import VALUES (7324, '2020-05-05', 'BY', 'Belarus', 'EURO', '0', '17489', '0', '103');
INSERT INTO public.who_global_data_import VALUES (7325, '2020-05-06', 'BY', 'Belarus', 'EURO', '1766', '19255', '9', '112');
INSERT INTO public.who_global_data_import VALUES (7326, '2020-05-07', 'BY', 'Belarus', 'EURO', '0', '19255', '0', '112');
INSERT INTO public.who_global_data_import VALUES (7327, '2020-05-08', 'BY', 'Belarus', 'EURO', '913', '20168', '4', '116');
INSERT INTO public.who_global_data_import VALUES (7328, '2020-05-09', 'BY', 'Belarus', 'EURO', '933', '21101', '5', '121');
INSERT INTO public.who_global_data_import VALUES (7329, '2020-05-10', 'BY', 'Belarus', 'EURO', '1872', '22973', '10', '131');
INSERT INTO public.who_global_data_import VALUES (7330, '2020-05-11', 'BY', 'Belarus', 'EURO', '933', '23906', '4', '135');
INSERT INTO public.who_global_data_import VALUES (7331, '2020-05-12', 'BY', 'Belarus', 'EURO', '0', '23906', '0', '135');
INSERT INTO public.who_global_data_import VALUES (7332, '2020-05-13', 'BY', 'Belarus', 'EURO', '1934', '25840', '14', '149');
INSERT INTO public.who_global_data_import VALUES (7333, '2020-05-14', 'BY', 'Belarus', 'EURO', '0', '25840', '0', '149');
INSERT INTO public.who_global_data_import VALUES (7334, '2020-05-15', 'BY', 'Belarus', 'EURO', '932', '26772', '2', '151');
INSERT INTO public.who_global_data_import VALUES (7335, '2020-05-16', 'BY', 'Belarus', 'EURO', '958', '27730', '5', '156');
INSERT INTO public.who_global_data_import VALUES (7336, '2020-05-17', 'BY', 'Belarus', 'EURO', '951', '28681', '4', '160');
INSERT INTO public.who_global_data_import VALUES (7337, '2020-05-18', 'BY', 'Belarus', 'EURO', '969', '29650', '5', '165');
INSERT INTO public.who_global_data_import VALUES (7338, '2020-05-19', 'BY', 'Belarus', 'EURO', '922', '30572', '6', '171');
INSERT INTO public.who_global_data_import VALUES (7339, '2020-05-20', 'BY', 'Belarus', 'EURO', '936', '31508', '4', '175');
INSERT INTO public.who_global_data_import VALUES (7340, '2020-05-21', 'BY', 'Belarus', 'EURO', '1863', '33371', '10', '185');
INSERT INTO public.who_global_data_import VALUES (7341, '2020-05-22', 'BY', 'Belarus', 'EURO', '932', '34303', '5', '190');
INSERT INTO public.who_global_data_import VALUES (7342, '2020-05-23', 'BY', 'Belarus', 'EURO', '0', '34303', '0', '190');
INSERT INTO public.who_global_data_import VALUES (7343, '2020-05-24', 'BY', 'Belarus', 'EURO', '941', '35244', '4', '194');
INSERT INTO public.who_global_data_import VALUES (7344, '2020-05-25', 'BY', 'Belarus', 'EURO', '954', '36198', '5', '199');
INSERT INTO public.who_global_data_import VALUES (7345, '2020-05-26', 'BY', 'Belarus', 'EURO', '946', '37144', '5', '204');
INSERT INTO public.who_global_data_import VALUES (7346, '2020-05-27', 'BY', 'Belarus', 'EURO', '915', '38059', '4', '208');
INSERT INTO public.who_global_data_import VALUES (7347, '2020-05-28', 'BY', 'Belarus', 'EURO', '897', '38956', '6', '214');
INSERT INTO public.who_global_data_import VALUES (7348, '2020-05-29', 'BY', 'Belarus', 'EURO', '902', '39858', '5', '219');
INSERT INTO public.who_global_data_import VALUES (7349, '2020-05-30', 'BY', 'Belarus', 'EURO', '906', '40764', '5', '224');
INSERT INTO public.who_global_data_import VALUES (7350, '2020-05-31', 'BY', 'Belarus', 'EURO', '894', '41658', '5', '229');
INSERT INTO public.who_global_data_import VALUES (7351, '2020-06-01', 'BY', 'Belarus', 'EURO', '898', '42556', '6', '235');
INSERT INTO public.who_global_data_import VALUES (7352, '2020-06-02', 'BY', 'Belarus', 'EURO', '847', '43403', '5', '240');
INSERT INTO public.who_global_data_import VALUES (7353, '2020-06-03', 'BY', 'Belarus', 'EURO', '852', '44255', '3', '243');
INSERT INTO public.who_global_data_import VALUES (7354, '2020-06-04', 'BY', 'Belarus', 'EURO', '861', '45116', '5', '248');
INSERT INTO public.who_global_data_import VALUES (7355, '2020-06-05', 'BY', 'Belarus', 'EURO', '865', '45981', '5', '253');
INSERT INTO public.who_global_data_import VALUES (7356, '2020-06-06', 'BY', 'Belarus', 'EURO', '887', '46868', '6', '259');
INSERT INTO public.who_global_data_import VALUES (7357, '2020-06-07', 'BY', 'Belarus', 'EURO', '0', '46868', '0', '259');
INSERT INTO public.who_global_data_import VALUES (7358, '2020-06-08', 'BY', 'Belarus', 'EURO', '1762', '48630', '10', '269');
INSERT INTO public.who_global_data_import VALUES (7359, '2020-06-09', 'BY', 'Belarus', 'EURO', '823', '49453', '7', '276');
INSERT INTO public.who_global_data_import VALUES (7360, '2020-06-10', 'BY', 'Belarus', 'EURO', '812', '50265', '6', '282');
INSERT INTO public.who_global_data_import VALUES (7361, '2020-06-11', 'BY', 'Belarus', 'EURO', '801', '51066', '6', '288');
INSERT INTO public.who_global_data_import VALUES (7362, '2020-06-12', 'BY', 'Belarus', 'EURO', '750', '51816', '5', '293');
INSERT INTO public.who_global_data_import VALUES (7363, '2020-06-13', 'BY', 'Belarus', 'EURO', '704', '52520', '5', '298');
INSERT INTO public.who_global_data_import VALUES (7364, '2020-06-14', 'BY', 'Belarus', 'EURO', '721', '53241', '5', '303');
INSERT INTO public.who_global_data_import VALUES (7365, '2020-06-15', 'BY', 'Belarus', 'EURO', '732', '53973', '5', '308');
INSERT INTO public.who_global_data_import VALUES (7366, '2020-06-16', 'BY', 'Belarus', 'EURO', '707', '54680', '4', '312');
INSERT INTO public.who_global_data_import VALUES (7367, '2020-06-17', 'BY', 'Belarus', 'EURO', '689', '55369', '6', '318');
INSERT INTO public.who_global_data_import VALUES (7368, '2020-06-18', 'BY', 'Belarus', 'EURO', '663', '56032', '6', '324');
INSERT INTO public.who_global_data_import VALUES (7369, '2020-06-19', 'BY', 'Belarus', 'EURO', '625', '56657', '7', '331');
INSERT INTO public.who_global_data_import VALUES (7370, '2020-06-20', 'BY', 'Belarus', 'EURO', '676', '57333', '6', '337');
INSERT INTO public.who_global_data_import VALUES (7371, '2020-06-21', 'BY', 'Belarus', 'EURO', '603', '57936', '6', '343');
INSERT INTO public.who_global_data_import VALUES (7372, '2020-06-22', 'BY', 'Belarus', 'EURO', '569', '58505', '3', '346');
INSERT INTO public.who_global_data_import VALUES (7373, '2020-06-23', 'BY', 'Belarus', 'EURO', '518', '59023', '5', '351');
INSERT INTO public.who_global_data_import VALUES (7374, '2020-06-24', 'BY', 'Belarus', 'EURO', '464', '59487', '6', '357');
INSERT INTO public.who_global_data_import VALUES (7375, '2020-06-25', 'BY', 'Belarus', 'EURO', '458', '59945', '5', '362');
INSERT INTO public.who_global_data_import VALUES (7376, '2020-06-26', 'BY', 'Belarus', 'EURO', '437', '60382', '5', '367');
INSERT INTO public.who_global_data_import VALUES (7377, '2020-06-27', 'BY', 'Belarus', 'EURO', '331', '60713', '6', '373');
INSERT INTO public.who_global_data_import VALUES (7378, '2020-06-28', 'BY', 'Belarus', 'EURO', '382', '61095', '4', '377');
INSERT INTO public.who_global_data_import VALUES (7379, '2020-06-29', 'BY', 'Belarus', 'EURO', '380', '61475', '6', '383');
INSERT INTO public.who_global_data_import VALUES (7380, '2020-06-30', 'BY', 'Belarus', 'EURO', '315', '61790', '4', '387');
INSERT INTO public.who_global_data_import VALUES (7381, '2020-07-01', 'BY', 'Belarus', 'EURO', '328', '62118', '5', '392');
INSERT INTO public.who_global_data_import VALUES (7382, '2020-07-02', 'BY', 'Belarus', 'EURO', '306', '62424', '6', '398');
INSERT INTO public.who_global_data_import VALUES (7383, '2020-07-03', 'BY', 'Belarus', 'EURO', '274', '62698', '7', '405');
INSERT INTO public.who_global_data_import VALUES (7384, '2020-07-04', 'BY', 'Belarus', 'EURO', '299', '62997', '7', '412');
INSERT INTO public.who_global_data_import VALUES (7385, '2020-07-05', 'BY', 'Belarus', 'EURO', '273', '63270', '6', '418');
INSERT INTO public.who_global_data_import VALUES (7386, '2020-07-06', 'BY', 'Belarus', 'EURO', '284', '63554', '5', '423');
INSERT INTO public.who_global_data_import VALUES (7387, '2020-07-07', 'BY', 'Belarus', 'EURO', '250', '63804', '6', '429');
INSERT INTO public.who_global_data_import VALUES (7388, '2020-07-08', 'BY', 'Belarus', 'EURO', '199', '64003', '7', '436');
INSERT INTO public.who_global_data_import VALUES (7389, '2020-07-09', 'BY', 'Belarus', 'EURO', '221', '64224', '7', '443');
INSERT INTO public.who_global_data_import VALUES (7390, '2020-07-10', 'BY', 'Belarus', 'EURO', '187', '64411', '6', '449');
INSERT INTO public.who_global_data_import VALUES (7391, '2020-07-11', 'BY', 'Belarus', 'EURO', '193', '64604', '5', '454');
INSERT INTO public.who_global_data_import VALUES (7392, '2020-07-12', 'BY', 'Belarus', 'EURO', '160', '64764', '5', '459');
INSERT INTO public.who_global_data_import VALUES (7393, '2020-07-13', 'BY', 'Belarus', 'EURO', '168', '64932', '5', '464');
INSERT INTO public.who_global_data_import VALUES (7394, '2020-07-14', 'BY', 'Belarus', 'EURO', '182', '65114', '4', '468');
INSERT INTO public.who_global_data_import VALUES (7395, '2020-07-15', 'BY', 'Belarus', 'EURO', '155', '65269', '6', '474');
INSERT INTO public.who_global_data_import VALUES (7396, '2020-07-16', 'BY', 'Belarus', 'EURO', '174', '65443', '6', '480');
INSERT INTO public.who_global_data_import VALUES (7397, '2020-07-17', 'BY', 'Belarus', 'EURO', '180', '65623', '5', '485');
INSERT INTO public.who_global_data_import VALUES (7398, '2020-07-18', 'BY', 'Belarus', 'EURO', '159', '65782', '6', '491');
INSERT INTO public.who_global_data_import VALUES (7399, '2020-07-19', 'BY', 'Belarus', 'EURO', '171', '65953', '4', '495');
INSERT INTO public.who_global_data_import VALUES (7400, '2020-07-20', 'BY', 'Belarus', 'EURO', '142', '66095', '4', '499');
INSERT INTO public.who_global_data_import VALUES (7401, '2020-07-21', 'BY', 'Belarus', 'EURO', '118', '66213', '4', '503');
INSERT INTO public.who_global_data_import VALUES (7402, '2020-07-22', 'BY', 'Belarus', 'EURO', '135', '66348', '4', '507');
INSERT INTO public.who_global_data_import VALUES (7403, '2020-07-23', 'BY', 'Belarus', 'EURO', '173', '66521', '6', '513');
INSERT INTO public.who_global_data_import VALUES (7404, '2020-07-24', 'BY', 'Belarus', 'EURO', '167', '66688', '6', '519');
INSERT INTO public.who_global_data_import VALUES (7405, '2020-07-25', 'BY', 'Belarus', 'EURO', '158', '66846', '5', '524');
INSERT INTO public.who_global_data_import VALUES (7406, '2020-07-26', 'BY', 'Belarus', 'EURO', '156', '67002', '6', '530');
INSERT INTO public.who_global_data_import VALUES (7407, '2020-07-27', 'BY', 'Belarus', 'EURO', '130', '67132', '4', '534');
INSERT INTO public.who_global_data_import VALUES (7408, '2020-07-28', 'BY', 'Belarus', 'EURO', '234', '67366', '9', '543');
INSERT INTO public.who_global_data_import VALUES (7409, '2020-07-29', 'BY', 'Belarus', 'EURO', '152', '67518', '5', '548');
INSERT INTO public.who_global_data_import VALUES (7410, '2020-07-30', 'BY', 'Belarus', 'EURO', '147', '67665', '5', '553');
INSERT INTO public.who_global_data_import VALUES (7411, '2020-07-31', 'BY', 'Belarus', 'EURO', '143', '67808', '6', '559');
INSERT INTO public.who_global_data_import VALUES (7412, '2020-08-01', 'BY', 'Belarus', 'EURO', '0', '67808', '0', '559');
INSERT INTO public.who_global_data_import VALUES (7413, '2020-08-02', 'BY', 'Belarus', 'EURO', '138', '67946', '4', '563');
INSERT INTO public.who_global_data_import VALUES (7414, '2020-08-03', 'BY', 'Belarus', 'EURO', '121', '68067', '4', '567');
INSERT INTO public.who_global_data_import VALUES (7415, '2020-08-04', 'BY', 'Belarus', 'EURO', '99', '68166', '4', '571');
INSERT INTO public.who_global_data_import VALUES (7416, '2020-08-05', 'BY', 'Belarus', 'EURO', '84', '68250', '3', '574');
INSERT INTO public.who_global_data_import VALUES (7417, '2020-08-06', 'BY', 'Belarus', 'EURO', '126', '68376', '3', '577');
INSERT INTO public.who_global_data_import VALUES (7418, '2020-08-07', 'BY', 'Belarus', 'EURO', '127', '68503', '3', '580');
INSERT INTO public.who_global_data_import VALUES (7419, '2020-08-08', 'BY', 'Belarus', 'EURO', '111', '68614', '3', '583');
INSERT INTO public.who_global_data_import VALUES (7420, '2020-08-09', 'BY', 'Belarus', 'EURO', '124', '68738', '2', '585');
INSERT INTO public.who_global_data_import VALUES (7421, '2020-08-10', 'BY', 'Belarus', 'EURO', '112', '68850', '2', '587');
INSERT INTO public.who_global_data_import VALUES (7422, '2020-08-11', 'BY', 'Belarus', 'EURO', '97', '68947', '2', '589');
INSERT INTO public.who_global_data_import VALUES (7423, '2020-08-12', 'BY', 'Belarus', 'EURO', '58', '69005', '3', '592');
INSERT INTO public.who_global_data_import VALUES (7424, '2020-08-13', 'BY', 'Belarus', 'EURO', '97', '69102', '3', '595');
INSERT INTO public.who_global_data_import VALUES (7425, '2020-08-14', 'BY', 'Belarus', 'EURO', '101', '69203', '4', '599');
INSERT INTO public.who_global_data_import VALUES (7426, '2020-08-15', 'BY', 'Belarus', 'EURO', '105', '69308', '4', '603');
INSERT INTO public.who_global_data_import VALUES (7427, '2020-08-16', 'BY', 'Belarus', 'EURO', '116', '69424', '4', '607');
INSERT INTO public.who_global_data_import VALUES (7428, '2020-08-17', 'BY', 'Belarus', 'EURO', '92', '69516', '3', '610');
INSERT INTO public.who_global_data_import VALUES (7429, '2020-08-18', 'BY', 'Belarus', 'EURO', '73', '69589', '3', '613');
INSERT INTO public.who_global_data_import VALUES (7430, '2020-08-19', 'BY', 'Belarus', 'EURO', '84', '69673', '4', '617');
INSERT INTO public.who_global_data_import VALUES (7431, '2020-08-20', 'BY', 'Belarus', 'EURO', '128', '69801', '5', '622');
INSERT INTO public.who_global_data_import VALUES (7432, '2020-08-21', 'BY', 'Belarus', 'EURO', '149', '69950', '5', '627');
INSERT INTO public.who_global_data_import VALUES (7433, '2020-08-22', 'BY', 'Belarus', 'EURO', '161', '70111', '5', '632');
INSERT INTO public.who_global_data_import VALUES (7434, '2020-08-23', 'BY', 'Belarus', 'EURO', '174', '70285', '5', '637');
INSERT INTO public.who_global_data_import VALUES (7435, '2020-08-24', 'BY', 'Belarus', 'EURO', '183', '70468', '5', '642');
INSERT INTO public.who_global_data_import VALUES (7436, '2020-08-25', 'BY', 'Belarus', 'EURO', '177', '70645', '4', '646');
INSERT INTO public.who_global_data_import VALUES (7437, '2020-08-26', 'BY', 'Belarus', 'EURO', '82', '70727', '6', '652');
INSERT INTO public.who_global_data_import VALUES (7438, '2020-08-27', 'BY', 'Belarus', 'EURO', '247', '70974', '5', '657');
INSERT INTO public.who_global_data_import VALUES (7439, '2020-08-28', 'BY', 'Belarus', 'EURO', '191', '71165', '5', '662');
INSERT INTO public.who_global_data_import VALUES (7440, '2020-08-29', 'BY', 'Belarus', 'EURO', '181', '71346', '5', '667');
INSERT INTO public.who_global_data_import VALUES (7441, '2020-08-30', 'BY', 'Belarus', 'EURO', '177', '71523', '4', '671');
INSERT INTO public.who_global_data_import VALUES (7442, '2020-08-31', 'BY', 'Belarus', 'EURO', '164', '71687', '5', '676');
INSERT INTO public.who_global_data_import VALUES (7443, '2020-09-01', 'BY', 'Belarus', 'EURO', '156', '71843', '5', '681');
INSERT INTO public.who_global_data_import VALUES (7444, '2020-09-02', 'BY', 'Belarus', 'EURO', '119', '71962', '5', '686');
INSERT INTO public.who_global_data_import VALUES (7445, '2020-09-03', 'BY', 'Belarus', 'EURO', '179', '72141', '5', '691');
INSERT INTO public.who_global_data_import VALUES (7446, '2020-09-04', 'BY', 'Belarus', 'EURO', '161', '72302', '5', '696');
INSERT INTO public.who_global_data_import VALUES (7447, '2020-09-05', 'BY', 'Belarus', 'EURO', '183', '72485', '5', '701');
INSERT INTO public.who_global_data_import VALUES (7448, '2020-09-06', 'BY', 'Belarus', 'EURO', '178', '72663', '4', '705');
INSERT INTO public.who_global_data_import VALUES (7449, '2020-09-07', 'BY', 'Belarus', 'EURO', '196', '72859', '6', '711');
INSERT INTO public.who_global_data_import VALUES (7450, '2020-09-08', 'BY', 'Belarus', 'EURO', '172', '73031', '5', '716');
INSERT INTO public.who_global_data_import VALUES (7451, '2020-09-09', 'BY', 'Belarus', 'EURO', '177', '73208', '5', '721');
INSERT INTO public.who_global_data_import VALUES (7452, '2020-09-10', 'BY', 'Belarus', 'EURO', '194', '73402', '5', '726');
INSERT INTO public.who_global_data_import VALUES (7453, '2020-09-11', 'BY', 'Belarus', 'EURO', '189', '73591', '6', '732');
INSERT INTO public.who_global_data_import VALUES (7454, '2020-09-12', 'BY', 'Belarus', 'EURO', '193', '73784', '6', '738');
INSERT INTO public.who_global_data_import VALUES (7455, '2020-09-13', 'BY', 'Belarus', 'EURO', '191', '73975', '6', '744');
INSERT INTO public.who_global_data_import VALUES (7456, '2020-09-14', 'BY', 'Belarus', 'EURO', '198', '74173', '6', '750');
INSERT INTO public.who_global_data_import VALUES (7457, '2020-09-15', 'BY', 'Belarus', 'EURO', '187', '74360', '6', '756');
INSERT INTO public.who_global_data_import VALUES (7458, '2020-09-16', 'BY', 'Belarus', 'EURO', '192', '74552', '5', '761');
INSERT INTO public.who_global_data_import VALUES (7459, '2020-09-17', 'BY', 'Belarus', 'EURO', '211', '74763', '6', '767');
INSERT INTO public.who_global_data_import VALUES (7460, '2020-09-18', 'BY', 'Belarus', 'EURO', '224', '74987', '4', '771');
INSERT INTO public.who_global_data_import VALUES (7461, '2020-09-19', 'BY', 'Belarus', 'EURO', '243', '75230', '2', '773');
INSERT INTO public.who_global_data_import VALUES (7462, '2020-09-20', 'BY', 'Belarus', 'EURO', '231', '75461', '3', '776');
INSERT INTO public.who_global_data_import VALUES (7463, '2020-09-21', 'BY', 'Belarus', 'EURO', '213', '75674', '4', '780');
INSERT INTO public.who_global_data_import VALUES (7464, '2020-09-22', 'BY', 'Belarus', 'EURO', '224', '75898', '5', '785');
INSERT INTO public.who_global_data_import VALUES (7465, '2020-09-23', 'BY', 'Belarus', 'EURO', '206', '76104', '6', '791');
INSERT INTO public.who_global_data_import VALUES (7466, '2020-09-24', 'BY', 'Belarus', 'EURO', '253', '76357', '5', '796');
INSERT INTO public.who_global_data_import VALUES (7467, '2020-09-25', 'BY', 'Belarus', 'EURO', '294', '76651', '6', '802');
INSERT INTO public.who_global_data_import VALUES (7468, '2020-09-26', 'BY', 'Belarus', 'EURO', '306', '76957', '5', '807');
INSERT INTO public.who_global_data_import VALUES (7469, '2020-09-27', 'BY', 'Belarus', 'EURO', '332', '77289', '6', '813');
INSERT INTO public.who_global_data_import VALUES (7470, '2020-09-28', 'BY', 'Belarus', 'EURO', '320', '77609', '5', '818');
INSERT INTO public.who_global_data_import VALUES (7471, '2020-09-29', 'BY', 'Belarus', 'EURO', '337', '77946', '4', '822');
INSERT INTO public.who_global_data_import VALUES (7472, '2020-09-30', 'BY', 'Belarus', 'EURO', '314', '78260', '6', '828');
INSERT INTO public.who_global_data_import VALUES (7473, '2020-10-01', 'BY', 'Belarus', 'EURO', '371', '78631', '5', '833');
INSERT INTO public.who_global_data_import VALUES (7474, '2020-10-02', 'BY', 'Belarus', 'EURO', '388', '79019', '6', '839');
INSERT INTO public.who_global_data_import VALUES (7475, '2020-10-03', 'BY', 'Belarus', 'EURO', '402', '79421', '5', '844');
INSERT INTO public.who_global_data_import VALUES (7476, '2020-10-04', 'BY', 'Belarus', 'EURO', '431', '79852', '7', '851');
INSERT INTO public.who_global_data_import VALUES (7477, '2020-10-05', 'BY', 'Belarus', 'EURO', '443', '80295', '6', '857');
INSERT INTO public.who_global_data_import VALUES (7478, '2020-10-06', 'BY', 'Belarus', 'EURO', '401', '80696', '5', '862');
INSERT INTO public.who_global_data_import VALUES (7479, '2020-10-07', 'BY', 'Belarus', 'EURO', '394', '81090', '6', '868');
INSERT INTO public.who_global_data_import VALUES (7480, '2020-10-08', 'BY', 'Belarus', 'EURO', '415', '81505', '6', '874');
INSERT INTO public.who_global_data_import VALUES (7481, '2020-10-09', 'BY', 'Belarus', 'EURO', '477', '81982', '6', '880');
INSERT INTO public.who_global_data_import VALUES (7482, '2020-10-10', 'BY', 'Belarus', 'EURO', '489', '82471', '5', '885');
INSERT INTO public.who_global_data_import VALUES (7483, '2020-10-11', 'BY', 'Belarus', 'EURO', '552', '83023', '6', '891');
INSERT INTO public.who_global_data_import VALUES (7484, '2020-10-12', 'BY', 'Belarus', 'EURO', '511', '83534', '5', '896');
INSERT INTO public.who_global_data_import VALUES (7485, '2020-10-13', 'BY', 'Belarus', 'EURO', '464', '83998', '5', '901');
INSERT INTO public.who_global_data_import VALUES (7486, '2020-10-14', 'BY', 'Belarus', 'EURO', '526', '84524', '5', '906');
INSERT INTO public.who_global_data_import VALUES (7487, '2020-10-15', 'BY', 'Belarus', 'EURO', '597', '85121', '5', '911');
INSERT INTO public.who_global_data_import VALUES (7488, '2020-10-16', 'BY', 'Belarus', 'EURO', '613', '85734', '5', '916');
INSERT INTO public.who_global_data_import VALUES (7489, '2020-10-17', 'BY', 'Belarus', 'EURO', '658', '86392', '5', '921');
INSERT INTO public.who_global_data_import VALUES (7490, '2020-10-18', 'BY', 'Belarus', 'EURO', '671', '87063', '4', '925');
INSERT INTO public.who_global_data_import VALUES (7491, '2020-10-19', 'BY', 'Belarus', 'EURO', '635', '87698', '4', '929');
INSERT INTO public.who_global_data_import VALUES (7492, '2020-10-20', 'BY', 'Belarus', 'EURO', '592', '88290', '4', '933');
INSERT INTO public.who_global_data_import VALUES (7493, '2020-10-21', 'BY', 'Belarus', 'EURO', '619', '88909', '4', '937');
INSERT INTO public.who_global_data_import VALUES (7494, '2020-10-22', 'BY', 'Belarus', 'EURO', '733', '89642', '4', '941');
INSERT INTO public.who_global_data_import VALUES (7495, '2020-10-23', 'BY', 'Belarus', 'EURO', '738', '90380', '4', '945');
INSERT INTO public.who_global_data_import VALUES (7496, '2020-10-24', 'BY', 'Belarus', 'EURO', '787', '91167', '0', '945');
INSERT INTO public.who_global_data_import VALUES (7497, '2020-10-25', 'BY', 'Belarus', 'EURO', '0', '91167', '0', '945');
INSERT INTO public.who_global_data_import VALUES (7498, '2020-10-26', 'BY', 'Belarus', 'EURO', '1656', '92823', '12', '957');
INSERT INTO public.who_global_data_import VALUES (7499, '2020-10-27', 'BY', 'Belarus', 'EURO', '884', '93707', '4', '961');
INSERT INTO public.who_global_data_import VALUES (7500, '2020-10-28', 'BY', 'Belarus', 'EURO', '902', '94609', '4', '965');
INSERT INTO public.who_global_data_import VALUES (7501, '2020-10-29', 'BY', 'Belarus', 'EURO', '936', '95545', '4', '969');
INSERT INTO public.who_global_data_import VALUES (7502, '2020-10-30', 'BY', 'Belarus', 'EURO', '984', '96529', '4', '973');
INSERT INTO public.who_global_data_import VALUES (7503, '2020-10-31', 'BY', 'Belarus', 'EURO', '970', '97499', '4', '977');
INSERT INTO public.who_global_data_import VALUES (7504, '2020-11-01', 'BY', 'Belarus', 'EURO', '1960', '99459', '8', '985');
INSERT INTO public.who_global_data_import VALUES (7505, '2020-11-02', 'BY', 'Belarus', 'EURO', '0', '99459', '0', '985');
INSERT INTO public.who_global_data_import VALUES (7506, '2020-11-03', 'BY', 'Belarus', 'EURO', '941', '100400', '4', '989');
INSERT INTO public.who_global_data_import VALUES (7507, '2020-11-04', 'BY', 'Belarus', 'EURO', '929', '101329', '3', '992');
INSERT INTO public.who_global_data_import VALUES (7508, '2020-11-05', 'BY', 'Belarus', 'EURO', '984', '102313', '3', '995');
INSERT INTO public.who_global_data_import VALUES (7509, '2020-11-06', 'BY', 'Belarus', 'EURO', '982', '103295', '3', '998');
INSERT INTO public.who_global_data_import VALUES (7510, '2020-11-07', 'BY', 'Belarus', 'EURO', '1988', '105283', '6', '1004');
INSERT INTO public.who_global_data_import VALUES (7511, '2020-11-08', 'BY', 'Belarus', 'EURO', '0', '105283', '0', '1004');
INSERT INTO public.who_global_data_import VALUES (7512, '2020-11-09', 'BY', 'Belarus', 'EURO', '996', '106279', '3', '1007');
INSERT INTO public.who_global_data_import VALUES (7513, '2020-11-10', 'BY', 'Belarus', 'EURO', '983', '107262', '4', '1011');
INSERT INTO public.who_global_data_import VALUES (7514, '2020-11-11', 'BY', 'Belarus', 'EURO', '1038', '108300', '5', '1016');
INSERT INTO public.who_global_data_import VALUES (7515, '2020-11-12', 'BY', 'Belarus', 'EURO', '1057', '109357', '6', '1022');
INSERT INTO public.who_global_data_import VALUES (7516, '2020-11-13', 'BY', 'Belarus', 'EURO', '1098', '110455', '5', '1027');
INSERT INTO public.who_global_data_import VALUES (7517, '2020-11-14', 'BY', 'Belarus', 'EURO', '1167', '111622', '6', '1033');
INSERT INTO public.who_global_data_import VALUES (7518, '2020-11-15', 'BY', 'Belarus', 'EURO', '1248', '112870', '6', '1039');
INSERT INTO public.who_global_data_import VALUES (7519, '2020-11-16', 'BY', 'Belarus', 'EURO', '1315', '114185', '7', '1046');
INSERT INTO public.who_global_data_import VALUES (7520, '2020-11-17', 'BY', 'Belarus', 'EURO', '1263', '115448', '7', '1053');
INSERT INTO public.who_global_data_import VALUES (7521, '2020-11-18', 'BY', 'Belarus', 'EURO', '1251', '116699', '7', '1060');
INSERT INTO public.who_global_data_import VALUES (7522, '2020-11-19', 'BY', 'Belarus', 'EURO', '1309', '118008', '7', '1067');
INSERT INTO public.who_global_data_import VALUES (7523, '2020-11-20', 'BY', 'Belarus', 'EURO', '1382', '119390', '7', '1074');
INSERT INTO public.who_global_data_import VALUES (7524, '2020-11-21', 'BY', 'Belarus', 'EURO', '1457', '120847', '7', '1081');
INSERT INTO public.who_global_data_import VALUES (7525, '2020-11-22', 'BY', 'Belarus', 'EURO', '1588', '122435', '8', '1089');
INSERT INTO public.who_global_data_import VALUES (7526, '2020-11-23', 'BY', 'Belarus', 'EURO', '1564', '123999', '7', '1096');
INSERT INTO public.who_global_data_import VALUES (7527, '2020-11-24', 'BY', 'Belarus', 'EURO', '1483', '125482', '8', '1104');
INSERT INTO public.who_global_data_import VALUES (7528, '2020-11-25', 'BY', 'Belarus', 'EURO', '1471', '126953', '8', '1112');
INSERT INTO public.who_global_data_import VALUES (7529, '2020-11-26', 'BY', 'Belarus', 'EURO', '1496', '128449', '7', '1119');
INSERT INTO public.who_global_data_import VALUES (7530, '2020-11-27', 'BY', 'Belarus', 'EURO', '1563', '130012', '9', '1128');
INSERT INTO public.who_global_data_import VALUES (7531, '2020-11-28', 'BY', 'Belarus', 'EURO', '1621', '131633', '8', '1136');
INSERT INTO public.who_global_data_import VALUES (7532, '2020-11-29', 'BY', 'Belarus', 'EURO', '1691', '133324', '7', '1143');
INSERT INTO public.who_global_data_import VALUES (7533, '2020-11-30', 'BY', 'Belarus', 'EURO', '1684', '135008', '8', '1151');
INSERT INTO public.who_global_data_import VALUES (7534, '2020-12-01', 'BY', 'Belarus', 'EURO', '1639', '136647', '7', '1158');
INSERT INTO public.who_global_data_import VALUES (7535, '2020-12-02', 'BY', 'Belarus', 'EURO', '1572', '138219', '8', '1166');
INSERT INTO public.who_global_data_import VALUES (7536, '2020-12-03', 'BY', 'Belarus', 'EURO', '1689', '139908', '8', '1174');
INSERT INTO public.who_global_data_import VALUES (7537, '2020-12-04', 'BY', 'Belarus', 'EURO', '1701', '141609', '7', '1181');
INSERT INTO public.who_global_data_import VALUES (7538, '2020-12-05', 'BY', 'Belarus', 'EURO', '1774', '143383', '9', '1190');
INSERT INTO public.who_global_data_import VALUES (7539, '2020-12-06', 'BY', 'Belarus', 'EURO', '1896', '145279', '8', '1198');
INSERT INTO public.who_global_data_import VALUES (7540, '2020-12-07', 'BY', 'Belarus', 'EURO', '1878', '147157', '9', '1207');
INSERT INTO public.who_global_data_import VALUES (7541, '2020-12-08', 'BY', 'Belarus', 'EURO', '1796', '148953', '8', '1215');
INSERT INTO public.who_global_data_import VALUES (7542, '2020-12-09', 'BY', 'Belarus', 'EURO', '1649', '150602', '7', '1222');
INSERT INTO public.who_global_data_import VALUES (7543, '2020-12-10', 'BY', 'Belarus', 'EURO', '1851', '152453', '8', '1230');
INSERT INTO public.who_global_data_import VALUES (7544, '2020-12-11', 'BY', 'Belarus', 'EURO', '1939', '154392', '8', '1238');
INSERT INTO public.who_global_data_import VALUES (7545, '2020-12-12', 'BY', 'Belarus', 'EURO', '1967', '156359', '8', '1246');
INSERT INTO public.who_global_data_import VALUES (7546, '2020-12-13', 'BY', 'Belarus', 'EURO', '1975', '158334', '8', '1254');
INSERT INTO public.who_global_data_import VALUES (7547, '2020-12-14', 'BY', 'Belarus', 'EURO', '1961', '160295', '9', '1263');
INSERT INTO public.who_global_data_import VALUES (7548, '2020-12-15', 'BY', 'Belarus', 'EURO', '1853', '162148', '10', '1273');
INSERT INTO public.who_global_data_import VALUES (7549, '2020-12-16', 'BY', 'Belarus', 'EURO', '1911', '164059', '9', '1282');
INSERT INTO public.who_global_data_import VALUES (7550, '2020-12-17', 'BY', 'Belarus', 'EURO', '1838', '165897', '9', '1291');
INSERT INTO public.who_global_data_import VALUES (7551, '2020-12-18', 'BY', 'Belarus', 'EURO', '1834', '167731', '8', '1299');
INSERT INTO public.who_global_data_import VALUES (7552, '2020-12-19', 'BY', 'Belarus', 'EURO', '1917', '169648', '9', '1308');
INSERT INTO public.who_global_data_import VALUES (7553, '2020-12-20', 'BY', 'Belarus', 'EURO', '1931', '171579', '8', '1316');
INSERT INTO public.who_global_data_import VALUES (7554, '2020-12-21', 'BY', 'Belarus', 'EURO', '1944', '173523', '8', '1324');
INSERT INTO public.who_global_data_import VALUES (7555, '2020-12-22', 'BY', 'Belarus', 'EURO', '1893', '175416', '9', '1333');
INSERT INTO public.who_global_data_import VALUES (7556, '2020-12-23', 'BY', 'Belarus', 'EURO', '1858', '177274', '8', '1341');
INSERT INTO public.who_global_data_import VALUES (7557, '2020-12-24', 'BY', 'Belarus', 'EURO', '1922', '179196', '8', '1349');
INSERT INTO public.who_global_data_import VALUES (7558, '2020-12-25', 'BY', 'Belarus', 'EURO', '1917', '181113', '9', '1358');
INSERT INTO public.who_global_data_import VALUES (7559, '2020-12-26', 'BY', 'Belarus', 'EURO', '1893', '183006', '9', '1367');
INSERT INTO public.who_global_data_import VALUES (7560, '2020-12-27', 'BY', 'Belarus', 'EURO', '1916', '184922', '9', '1376');
INSERT INTO public.who_global_data_import VALUES (7561, '2020-12-28', 'BY', 'Belarus', 'EURO', '1825', '186747', '9', '1385');
INSERT INTO public.who_global_data_import VALUES (7562, '2020-12-29', 'BY', 'Belarus', 'EURO', '1841', '188588', '9', '1394');
INSERT INTO public.who_global_data_import VALUES (7563, '2020-12-30', 'BY', 'Belarus', 'EURO', '1816', '190404', '10', '1404');
INSERT INTO public.who_global_data_import VALUES (7564, '2020-12-31', 'BY', 'Belarus', 'EURO', '1957', '192361', '10', '1414');
INSERT INTO public.who_global_data_import VALUES (7565, '2021-01-01', 'BY', 'Belarus', 'EURO', '1923', '194284', '10', '1424');
INSERT INTO public.who_global_data_import VALUES (7566, '2021-01-02', 'BY', 'Belarus', 'EURO', '1939', '196223', '9', '1433');
INSERT INTO public.who_global_data_import VALUES (7567, '2021-01-03', 'BY', 'Belarus', 'EURO', '1902', '198125', '9', '1442');
INSERT INTO public.who_global_data_import VALUES (7568, '2021-01-04', 'BY', 'Belarus', 'EURO', '1837', '199962', '9', '1451');
INSERT INTO public.who_global_data_import VALUES (7569, '2021-01-05', 'BY', 'Belarus', 'EURO', '1869', '201831', '10', '1461');
INSERT INTO public.who_global_data_import VALUES (7570, '2021-01-06', 'BY', 'Belarus', 'EURO', '1273', '203104', '10', '1471');
INSERT INTO public.who_global_data_import VALUES (7571, '2021-01-07', 'BY', 'Belarus', 'EURO', '1854', '204958', '9', '1480');
INSERT INTO public.who_global_data_import VALUES (7572, '2021-01-08', 'BY', 'Belarus', 'EURO', '1838', '206796', '9', '1489');
INSERT INTO public.who_global_data_import VALUES (7573, '2021-01-09', 'BY', 'Belarus', 'EURO', '1805', '208601', '9', '1498');
INSERT INTO public.who_global_data_import VALUES (7574, '2021-01-10', 'BY', 'Belarus', 'EURO', '1767', '210368', '9', '1507');
INSERT INTO public.who_global_data_import VALUES (7575, '2021-01-11', 'BY', 'Belarus', 'EURO', '1833', '212201', '10', '1517');
INSERT INTO public.who_global_data_import VALUES (7576, '2021-01-12', 'BY', 'Belarus', 'EURO', '1792', '213993', '9', '1526');
INSERT INTO public.who_global_data_import VALUES (7577, '2021-01-13', 'BY', 'Belarus', 'EURO', '1731', '215724', '9', '1535');
INSERT INTO public.who_global_data_import VALUES (7578, '2021-01-14', 'BY', 'Belarus', 'EURO', '1972', '217696', '9', '1544');
INSERT INTO public.who_global_data_import VALUES (7579, '2021-01-15', 'BY', 'Belarus', 'EURO', '1967', '219663', '10', '1554');
INSERT INTO public.who_global_data_import VALUES (7580, '2021-01-16', 'BY', 'Belarus', 'EURO', '1941', '221604', '10', '1564');
INSERT INTO public.who_global_data_import VALUES (7581, '2021-01-17', 'BY', 'Belarus', 'EURO', '1933', '223537', '9', '1573');
INSERT INTO public.who_global_data_import VALUES (7582, '2021-01-18', 'BY', 'Belarus', 'EURO', '1924', '225461', '9', '1582');
INSERT INTO public.who_global_data_import VALUES (7583, '2021-01-19', 'BY', 'Belarus', 'EURO', '1899', '227360', '9', '1591');
INSERT INTO public.who_global_data_import VALUES (7584, '2021-01-20', 'BY', 'Belarus', 'EURO', '1356', '228716', '10', '1601');
INSERT INTO public.who_global_data_import VALUES (7585, '2021-01-21', 'BY', 'Belarus', 'EURO', '1778', '230494', '9', '1610');
INSERT INTO public.who_global_data_import VALUES (7586, '2021-01-22', 'BY', 'Belarus', 'EURO', '1804', '232298', '9', '1619');
INSERT INTO public.who_global_data_import VALUES (7587, '2021-01-23', 'BY', 'Belarus', 'EURO', '1813', '234111', '9', '1628');
INSERT INTO public.who_global_data_import VALUES (7588, '2021-01-24', 'BY', 'Belarus', 'EURO', '1748', '235859', '11', '1639');
INSERT INTO public.who_global_data_import VALUES (7589, '2021-01-25', 'BY', 'Belarus', 'EURO', '1752', '237611', '10', '1649');
INSERT INTO public.who_global_data_import VALUES (7590, '2021-01-26', 'BY', 'Belarus', 'EURO', '1024', '238635', '9', '1658');
INSERT INTO public.who_global_data_import VALUES (7591, '2021-01-27', 'BY', 'Belarus', 'EURO', '847', '239482', '10', '1668');
INSERT INTO public.who_global_data_import VALUES (7592, '2021-01-28', 'BY', 'Belarus', 'EURO', '1651', '241133', '10', '1678');
INSERT INTO public.who_global_data_import VALUES (7593, '2021-01-29', 'BY', 'Belarus', 'EURO', '1718', '242851', '10', '1688');
INSERT INTO public.who_global_data_import VALUES (7594, '2021-01-30', 'BY', 'Belarus', 'EURO', '1867', '244718', '10', '1698');
INSERT INTO public.who_global_data_import VALUES (7595, '2021-01-31', 'BY', 'Belarus', 'EURO', '1852', '246570', '10', '1708');
INSERT INTO public.who_global_data_import VALUES (7596, '2021-02-01', 'BY', 'Belarus', 'EURO', '1766', '248336', '10', '1718');
INSERT INTO public.who_global_data_import VALUES (7597, '2021-02-02', 'BY', 'Belarus', 'EURO', '959', '249295', '10', '1728');
INSERT INTO public.who_global_data_import VALUES (7598, '2021-02-03', 'BY', 'Belarus', 'EURO', '699', '249994', '9', '1737');
INSERT INTO public.who_global_data_import VALUES (7599, '2021-02-04', 'BY', 'Belarus', 'EURO', '1711', '251705', '9', '1746');
INSERT INTO public.who_global_data_import VALUES (7600, '2021-02-05', 'BY', 'Belarus', 'EURO', '1708', '253413', '9', '1755');
INSERT INTO public.who_global_data_import VALUES (7601, '2020-01-03', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7602, '2020-01-04', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7603, '2020-01-05', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7604, '2020-01-06', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7605, '2020-01-07', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7606, '2020-01-08', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7607, '2020-01-09', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7608, '2020-01-10', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7609, '2020-01-11', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7610, '2020-01-12', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7611, '2020-01-13', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7612, '2020-01-14', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7613, '2020-01-15', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7614, '2020-01-16', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7615, '2020-01-17', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7616, '2020-01-18', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7617, '2020-01-19', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7618, '2020-01-20', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7619, '2020-01-21', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7620, '2020-01-22', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7621, '2020-01-23', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7622, '2020-01-24', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7623, '2020-01-25', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7624, '2020-01-26', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7625, '2020-01-27', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7626, '2020-01-28', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7627, '2020-01-29', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7628, '2020-01-30', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7629, '2020-01-31', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7630, '2020-02-01', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7631, '2020-02-02', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7632, '2020-02-03', 'BE', 'Belgium', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7633, '2020-02-04', 'BE', 'Belgium', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7634, '2020-02-05', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7635, '2020-02-06', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7636, '2020-02-07', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7637, '2020-02-08', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7638, '2020-02-09', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7639, '2020-02-10', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7640, '2020-02-11', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7641, '2020-02-12', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7642, '2020-02-13', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7643, '2020-02-14', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7644, '2020-02-15', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7645, '2020-02-16', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7646, '2020-02-17', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7647, '2020-02-18', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7648, '2020-02-19', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7649, '2020-02-20', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7650, '2020-02-21', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7651, '2020-02-22', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7652, '2020-02-23', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7653, '2020-02-24', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7654, '2020-02-25', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7655, '2020-02-26', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7656, '2020-02-27', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7657, '2020-02-28', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7658, '2020-02-29', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7659, '2020-03-01', 'BE', 'Belgium', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7660, '2020-03-02', 'BE', 'Belgium', 'EURO', '18', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7661, '2020-03-03', 'BE', 'Belgium', 'EURO', '19', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7662, '2020-03-04', 'BE', 'Belgium', 'EURO', '34', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7663, '2020-03-05', 'BE', 'Belgium', 'EURO', '53', '125', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7664, '2020-03-06', 'BE', 'Belgium', 'EURO', '81', '206', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7665, '2020-03-07', 'BE', 'Belgium', 'EURO', '110', '316', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7666, '2020-03-08', 'BE', 'Belgium', 'EURO', '27', '343', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7667, '2020-03-09', 'BE', 'Belgium', 'EURO', '64', '407', '0', '0');
INSERT INTO public.who_global_data_import VALUES (7668, '2020-03-10', 'BE', 'Belgium', 'EURO', '94', '501', '1', '1');
INSERT INTO public.who_global_data_import VALUES (7669, '2020-03-11', 'BE', 'Belgium', 'EURO', '99', '600', '0', '1');
INSERT INTO public.who_global_data_import VALUES (7670, '2020-03-12', 'BE', 'Belgium', 'EURO', '274', '874', '7', '8');
INSERT INTO public.who_global_data_import VALUES (7671, '2020-03-13', 'BE', 'Belgium', 'EURO', '250', '1124', '1', '9');
INSERT INTO public.who_global_data_import VALUES (7672, '2020-03-14', 'BE', 'Belgium', 'EURO', '338', '1462', '3', '12');
INSERT INTO public.who_global_data_import VALUES (7673, '2020-03-15', 'BE', 'Belgium', 'EURO', '179', '1641', '5', '17');
INSERT INTO public.who_global_data_import VALUES (7674, '2020-03-16', 'BE', 'Belgium', 'EURO', '214', '1855', '5', '22');
INSERT INTO public.who_global_data_import VALUES (7675, '2020-03-17', 'BE', 'Belgium', 'EURO', '387', '2242', '12', '34');
INSERT INTO public.who_global_data_import VALUES (7676, '2020-03-18', 'BE', 'Belgium', 'EURO', '422', '2664', '10', '44');
INSERT INTO public.who_global_data_import VALUES (7677, '2020-03-19', 'BE', 'Belgium', 'EURO', '534', '3198', '22', '66');
INSERT INTO public.who_global_data_import VALUES (7678, '2020-03-20', 'BE', 'Belgium', 'EURO', '713', '3911', '33', '99');
INSERT INTO public.who_global_data_import VALUES (7679, '2020-03-21', 'BE', 'Belgium', 'EURO', '662', '4573', '35', '134');
INSERT INTO public.who_global_data_import VALUES (7680, '2020-03-22', 'BE', 'Belgium', 'EURO', '469', '5042', '39', '173');
INSERT INTO public.who_global_data_import VALUES (7681, '2020-03-23', 'BE', 'Belgium', 'EURO', '486', '5528', '47', '220');
INSERT INTO public.who_global_data_import VALUES (7682, '2020-03-24', 'BE', 'Belgium', 'EURO', '1328', '6856', '78', '298');
INSERT INTO public.who_global_data_import VALUES (7683, '2020-03-25', 'BE', 'Belgium', 'EURO', '1195', '8051', '77', '375');
INSERT INTO public.who_global_data_import VALUES (7684, '2020-03-26', 'BE', 'Belgium', 'EURO', '1199', '9250', '107', '482');
INSERT INTO public.who_global_data_import VALUES (7685, '2020-03-27', 'BE', 'Belgium', 'EURO', '1363', '10613', '102', '584');
INSERT INTO public.who_global_data_import VALUES (7686, '2020-03-28', 'BE', 'Belgium', 'EURO', '1518', '12131', '128', '712');
INSERT INTO public.who_global_data_import VALUES (7687, '2020-03-29', 'BE', 'Belgium', 'EURO', '844', '12975', '141', '853');
INSERT INTO public.who_global_data_import VALUES (7688, '2020-03-30', 'BE', 'Belgium', 'EURO', '683', '13658', '149', '1002');
INSERT INTO public.who_global_data_import VALUES (7689, '2020-03-31', 'BE', 'Belgium', 'EURO', '1738', '15396', '170', '1172');
INSERT INTO public.who_global_data_import VALUES (7690, '2020-04-01', 'BE', 'Belgium', 'EURO', '1681', '17077', '208', '1380');
INSERT INTO public.who_global_data_import VALUES (7691, '2020-04-02', 'BE', 'Belgium', 'EURO', '1516', '18593', '233', '1613');
INSERT INTO public.who_global_data_import VALUES (7692, '2020-04-03', 'BE', 'Belgium', 'EURO', '1478', '20071', '219', '1832');
INSERT INTO public.who_global_data_import VALUES (7693, '2020-04-04', 'BE', 'Belgium', 'EURO', '1694', '21765', '236', '2068');
INSERT INTO public.who_global_data_import VALUES (7694, '2020-04-05', 'BE', 'Belgium', 'EURO', '922', '22687', '271', '2339');
INSERT INTO public.who_global_data_import VALUES (7695, '2020-04-06', 'BE', 'Belgium', 'EURO', '665', '23352', '247', '2586');
INSERT INTO public.who_global_data_import VALUES (7696, '2020-04-07', 'BE', 'Belgium', 'EURO', '1934', '25286', '257', '2843');
INSERT INTO public.who_global_data_import VALUES (7697, '2020-04-08', 'BE', 'Belgium', 'EURO', '1515', '26801', '277', '3120');
INSERT INTO public.who_global_data_import VALUES (7698, '2020-04-09', 'BE', 'Belgium', 'EURO', '1598', '28399', '322', '3442');
INSERT INTO public.who_global_data_import VALUES (7699, '2020-04-10', 'BE', 'Belgium', 'EURO', '2239', '30638', '272', '3714');
INSERT INTO public.who_global_data_import VALUES (7700, '2020-04-11', 'BE', 'Belgium', 'EURO', '2336', '32974', '302', '4016');
INSERT INTO public.who_global_data_import VALUES (7701, '2020-04-12', 'BE', 'Belgium', 'EURO', '1029', '34003', '284', '4300');
INSERT INTO public.who_global_data_import VALUES (7702, '2020-04-13', 'BE', 'Belgium', 'EURO', '524', '34527', '265', '4565');
INSERT INTO public.who_global_data_import VALUES (7703, '2020-04-14', 'BE', 'Belgium', 'EURO', '537', '35064', '277', '4842');
INSERT INTO public.who_global_data_import VALUES (7704, '2020-04-15', 'BE', 'Belgium', 'EURO', '1560', '36624', '261', '5103');
INSERT INTO public.who_global_data_import VALUES (7705, '2020-04-16', 'BE', 'Belgium', 'EURO', '1633', '38257', '280', '5383');
INSERT INTO public.who_global_data_import VALUES (7706, '2020-04-17', 'BE', 'Belgium', 'EURO', '1674', '39931', '246', '5629');
INSERT INTO public.who_global_data_import VALUES (7707, '2020-04-18', 'BE', 'Belgium', 'EURO', '1394', '41325', '205', '5834');
INSERT INTO public.who_global_data_import VALUES (7708, '2020-04-19', 'BE', 'Belgium', 'EURO', '722', '42047', '208', '6042');
INSERT INTO public.who_global_data_import VALUES (7709, '2020-04-20', 'BE', 'Belgium', 'EURO', '443', '42490', '190', '6232');
INSERT INTO public.who_global_data_import VALUES (7710, '2020-04-21', 'BE', 'Belgium', 'EURO', '1276', '43766', '206', '6438');
INSERT INTO public.who_global_data_import VALUES (7711, '2020-04-22', 'BE', 'Belgium', 'EURO', '1270', '45036', '203', '6641');
INSERT INTO public.who_global_data_import VALUES (7712, '2020-04-23', 'BE', 'Belgium', 'EURO', '777', '45813', '181', '6822');
INSERT INTO public.who_global_data_import VALUES (7713, '2020-04-24', 'BE', 'Belgium', 'EURO', '976', '46789', '155', '6977');
INSERT INTO public.who_global_data_import VALUES (7714, '2020-04-25', 'BE', 'Belgium', 'EURO', '811', '47600', '155', '7132');
INSERT INTO public.who_global_data_import VALUES (7715, '2020-04-26', 'BE', 'Belgium', 'EURO', '388', '47988', '142', '7274');
INSERT INTO public.who_global_data_import VALUES (7716, '2020-04-27', 'BE', 'Belgium', 'EURO', '205', '48193', '153', '7427');
INSERT INTO public.who_global_data_import VALUES (7717, '2020-04-28', 'BE', 'Belgium', 'EURO', '755', '48948', '134', '7561');
INSERT INTO public.who_global_data_import VALUES (7718, '2020-04-29', 'BE', 'Belgium', 'EURO', '569', '49517', '110', '7671');
INSERT INTO public.who_global_data_import VALUES (7719, '2020-04-30', 'BE', 'Belgium', 'EURO', '522', '50039', '106', '7777');
INSERT INTO public.who_global_data_import VALUES (7720, '2020-05-01', 'BE', 'Belgium', 'EURO', '586', '50625', '87', '7864');
INSERT INTO public.who_global_data_import VALUES (7721, '2020-05-02', 'BE', 'Belgium', 'EURO', '237', '50862', '93', '7957');
INSERT INTO public.who_global_data_import VALUES (7722, '2020-05-03', 'BE', 'Belgium', 'EURO', '286', '51148', '75', '8032');
INSERT INTO public.who_global_data_import VALUES (7723, '2020-05-04', 'BE', 'Belgium', 'EURO', '140', '51288', '93', '8125');
INSERT INTO public.who_global_data_import VALUES (7724, '2020-05-05', 'BE', 'Belgium', 'EURO', '670', '51958', '93', '8218');
INSERT INTO public.who_global_data_import VALUES (7725, '2020-05-06', 'BE', 'Belgium', 'EURO', '546', '52504', '81', '8299');
INSERT INTO public.who_global_data_import VALUES (7726, '2020-05-07', 'BE', 'Belgium', 'EURO', '552', '53056', '75', '8374');
INSERT INTO public.who_global_data_import VALUES (7727, '2020-05-08', 'BE', 'Belgium', 'EURO', '442', '53498', '70', '8444');
INSERT INTO public.who_global_data_import VALUES (7728, '2020-05-09', 'BE', 'Belgium', 'EURO', '483', '53981', '73', '8517');
INSERT INTO public.who_global_data_import VALUES (7729, '2020-05-10', 'BE', 'Belgium', 'EURO', '240', '54221', '71', '8588');
INSERT INTO public.who_global_data_import VALUES (7730, '2020-05-11', 'BE', 'Belgium', 'EURO', '118', '54339', '72', '8660');
INSERT INTO public.who_global_data_import VALUES (7731, '2020-05-12', 'BE', 'Belgium', 'EURO', '476', '54815', '65', '8725');
INSERT INTO public.who_global_data_import VALUES (7732, '2020-05-13', 'BE', 'Belgium', 'EURO', '395', '55210', '45', '8770');
INSERT INTO public.who_global_data_import VALUES (7733, '2020-05-14', 'BE', 'Belgium', 'EURO', '321', '55531', '56', '8826');
INSERT INTO public.who_global_data_import VALUES (7734, '2020-05-15', 'BE', 'Belgium', 'EURO', '305', '55836', '43', '8869');
INSERT INTO public.who_global_data_import VALUES (7735, '2020-05-16', 'BE', 'Belgium', 'EURO', '346', '56182', '45', '8914');
INSERT INTO public.who_global_data_import VALUES (7736, '2020-05-17', 'BE', 'Belgium', 'EURO', '147', '56329', '29', '8943');
INSERT INTO public.who_global_data_import VALUES (7737, '2020-05-18', 'BE', 'Belgium', 'EURO', '81', '56410', '31', '8974');
INSERT INTO public.who_global_data_import VALUES (7738, '2020-05-19', 'BE', 'Belgium', 'EURO', '317', '56727', '35', '9009');
INSERT INTO public.who_global_data_import VALUES (7739, '2020-05-20', 'BE', 'Belgium', 'EURO', '292', '57019', '32', '9041');
INSERT INTO public.who_global_data_import VALUES (7740, '2020-05-21', 'BE', 'Belgium', 'EURO', '385', '57404', '30', '9071');
INSERT INTO public.who_global_data_import VALUES (7741, '2020-05-22', 'BE', 'Belgium', 'EURO', '70', '57474', '34', '9105');
INSERT INTO public.who_global_data_import VALUES (7742, '2020-05-23', 'BE', 'Belgium', 'EURO', '248', '57722', '41', '9146');
INSERT INTO public.who_global_data_import VALUES (7743, '2020-05-24', 'BE', 'Belgium', 'EURO', '123', '57845', '25', '9171');
INSERT INTO public.who_global_data_import VALUES (7744, '2020-05-25', 'BE', 'Belgium', 'EURO', '75', '57920', '33', '9204');
INSERT INTO public.who_global_data_import VALUES (7745, '2020-05-26', 'BE', 'Belgium', 'EURO', '314', '58234', '26', '9230');
INSERT INTO public.who_global_data_import VALUES (7746, '2020-05-27', 'BE', 'Belgium', 'EURO', '202', '58436', '24', '9254');
INSERT INTO public.who_global_data_import VALUES (7747, '2020-05-28', 'BE', 'Belgium', 'EURO', '182', '58618', '24', '9278');
INSERT INTO public.who_global_data_import VALUES (7748, '2020-05-29', 'BE', 'Belgium', 'EURO', '171', '58789', '26', '9304');
INSERT INTO public.who_global_data_import VALUES (7749, '2020-05-30', 'BE', 'Belgium', 'EURO', '165', '58954', '16', '9320');
INSERT INTO public.who_global_data_import VALUES (7750, '2020-05-31', 'BE', 'Belgium', 'EURO', '61', '59015', '22', '9342');
INSERT INTO public.who_global_data_import VALUES (7751, '2020-06-01', 'BE', 'Belgium', 'EURO', '49', '59064', '22', '9364');
INSERT INTO public.who_global_data_import VALUES (7752, '2020-06-02', 'BE', 'Belgium', 'EURO', '59', '59123', '21', '9385');
INSERT INTO public.who_global_data_import VALUES (7753, '2020-06-03', 'BE', 'Belgium', 'EURO', '181', '59304', '23', '9408');
INSERT INTO public.who_global_data_import VALUES (7754, '2020-06-04', 'BE', 'Belgium', 'EURO', '159', '59463', '20', '9428');
INSERT INTO public.who_global_data_import VALUES (7755, '2020-06-05', 'BE', 'Belgium', 'EURO', '172', '59635', '14', '9442');
INSERT INTO public.who_global_data_import VALUES (7756, '2020-06-06', 'BE', 'Belgium', 'EURO', '154', '59789', '12', '9454');
INSERT INTO public.who_global_data_import VALUES (7757, '2020-06-07', 'BE', 'Belgium', 'EURO', '69', '59858', '11', '9465');
INSERT INTO public.who_global_data_import VALUES (7758, '2020-06-08', 'BE', 'Belgium', 'EURO', '53', '59911', '12', '9477');
INSERT INTO public.who_global_data_import VALUES (7759, '2020-06-09', 'BE', 'Belgium', 'EURO', '152', '60063', '9', '9486');
INSERT INTO public.who_global_data_import VALUES (7760, '2020-06-10', 'BE', 'Belgium', 'EURO', '145', '60208', '12', '9498');
INSERT INTO public.who_global_data_import VALUES (7761, '2020-06-11', 'BE', 'Belgium', 'EURO', '119', '60327', '12', '9510');
INSERT INTO public.who_global_data_import VALUES (7762, '2020-06-12', 'BE', 'Belgium', 'EURO', '95', '60422', '7', '9517');
INSERT INTO public.who_global_data_import VALUES (7763, '2020-06-13', 'BE', 'Belgium', 'EURO', '89', '60511', '10', '9527');
INSERT INTO public.who_global_data_import VALUES (7764, '2020-06-14', 'BE', 'Belgium', 'EURO', '49', '60560', '5', '9532');
INSERT INTO public.who_global_data_import VALUES (7765, '2020-06-15', 'BE', 'Belgium', 'EURO', '22', '60582', '3', '9535');
INSERT INTO public.who_global_data_import VALUES (7766, '2020-06-16', 'BE', 'Belgium', 'EURO', '147', '60729', '8', '9543');
INSERT INTO public.who_global_data_import VALUES (7767, '2020-06-17', 'BE', 'Belgium', 'EURO', '99', '60828', '7', '9550');
INSERT INTO public.who_global_data_import VALUES (7768, '2020-06-18', 'BE', 'Belgium', 'EURO', '123', '60951', '7', '9557');
INSERT INTO public.who_global_data_import VALUES (7769, '2020-06-19', 'BE', 'Belgium', 'EURO', '108', '61059', '5', '9562');
INSERT INTO public.who_global_data_import VALUES (7770, '2020-06-20', 'BE', 'Belgium', 'EURO', '121', '61180', '4', '9566');
INSERT INTO public.who_global_data_import VALUES (7771, '2020-06-21', 'BE', 'Belgium', 'EURO', '50', '61230', '3', '9569');
INSERT INTO public.who_global_data_import VALUES (7772, '2020-06-22', 'BE', 'Belgium', 'EURO', '20', '61250', '9', '9578');
INSERT INTO public.who_global_data_import VALUES (7773, '2020-06-23', 'BE', 'Belgium', 'EURO', '143', '61393', '12', '9590');
INSERT INTO public.who_global_data_import VALUES (7774, '2020-06-24', 'BE', 'Belgium', 'EURO', '110', '61503', '4', '9594');
INSERT INTO public.who_global_data_import VALUES (7775, '2020-06-25', 'BE', 'Belgium', 'EURO', '100', '61603', '3', '9597');
INSERT INTO public.who_global_data_import VALUES (7776, '2020-06-26', 'BE', 'Belgium', 'EURO', '76', '61679', '5', '9602');
INSERT INTO public.who_global_data_import VALUES (7777, '2020-06-27', 'BE', 'Belgium', 'EURO', '113', '61792', '2', '9604');
INSERT INTO public.who_global_data_import VALUES (7778, '2020-06-28', 'BE', 'Belgium', 'EURO', '41', '61833', '8', '9612');
INSERT INTO public.who_global_data_import VALUES (7779, '2020-06-29', 'BE', 'Belgium', 'EURO', '24', '61857', '5', '9617');
INSERT INTO public.who_global_data_import VALUES (7780, '2020-06-30', 'BE', 'Belgium', 'EURO', '127', '61984', '3', '9620');
INSERT INTO public.who_global_data_import VALUES (7781, '2020-07-01', 'BE', 'Belgium', 'EURO', '100', '62084', '8', '9628');
INSERT INTO public.who_global_data_import VALUES (7782, '2020-07-02', 'BE', 'Belgium', 'EURO', '135', '62219', '2', '9630');
INSERT INTO public.who_global_data_import VALUES (7783, '2020-07-03', 'BE', 'Belgium', 'EURO', '93', '62312', '5', '9635');
INSERT INTO public.who_global_data_import VALUES (7784, '2020-07-04', 'BE', 'Belgium', 'EURO', '94', '62406', '2', '9637');
INSERT INTO public.who_global_data_import VALUES (7785, '2020-07-05', 'BE', 'Belgium', 'EURO', '64', '62470', '3', '9640');
INSERT INTO public.who_global_data_import VALUES (7786, '2020-07-06', 'BE', 'Belgium', 'EURO', '24', '62494', '2', '9642');
INSERT INTO public.who_global_data_import VALUES (7787, '2020-07-07', 'BE', 'Belgium', 'EURO', '112', '62606', '1', '9643');
INSERT INTO public.who_global_data_import VALUES (7788, '2020-07-08', 'BE', 'Belgium', 'EURO', '99', '62705', '3', '9646');
INSERT INTO public.who_global_data_import VALUES (7789, '2020-07-09', 'BE', 'Belgium', 'EURO', '137', '62842', '1', '9647');
INSERT INTO public.who_global_data_import VALUES (7790, '2020-07-10', 'BE', 'Belgium', 'EURO', '124', '62966', '2', '9649');
INSERT INTO public.who_global_data_import VALUES (7791, '2020-07-11', 'BE', 'Belgium', 'EURO', '127', '63093', '0', '9649');
INSERT INTO public.who_global_data_import VALUES (7792, '2020-07-12', 'BE', 'Belgium', 'EURO', '62', '63155', '2', '9651');
INSERT INTO public.who_global_data_import VALUES (7793, '2020-07-13', 'BE', 'Belgium', 'EURO', '43', '63198', '4', '9655');
INSERT INTO public.who_global_data_import VALUES (7794, '2020-07-14', 'BE', 'Belgium', 'EURO', '224', '63422', '0', '9655');
INSERT INTO public.who_global_data_import VALUES (7795, '2020-07-15', 'BE', 'Belgium', 'EURO', '207', '63629', '3', '9658');
INSERT INTO public.who_global_data_import VALUES (7796, '2020-07-16', 'BE', 'Belgium', 'EURO', '260', '63889', '5', '9663');
INSERT INTO public.who_global_data_import VALUES (7797, '2020-07-17', 'BE', 'Belgium', 'EURO', '226', '64115', '5', '9668');
INSERT INTO public.who_global_data_import VALUES (7798, '2020-07-18', 'BE', 'Belgium', 'EURO', '274', '64389', '2', '9670');
INSERT INTO public.who_global_data_import VALUES (7799, '2020-07-19', 'BE', 'Belgium', 'EURO', '130', '64519', '3', '9673');
INSERT INTO public.who_global_data_import VALUES (7800, '2020-07-20', 'BE', 'Belgium', 'EURO', '64', '64583', '1', '9674');
INSERT INTO public.who_global_data_import VALUES (7801, '2020-07-21', 'BE', 'Belgium', 'EURO', '443', '65026', '2', '9676');
INSERT INTO public.who_global_data_import VALUES (7802, '2020-07-22', 'BE', 'Belgium', 'EURO', '145', '65171', '1', '9677');
INSERT INTO public.who_global_data_import VALUES (7803, '2020-07-23', 'BE', 'Belgium', 'EURO', '553', '65724', '2', '9679');
INSERT INTO public.who_global_data_import VALUES (7804, '2020-07-24', 'BE', 'Belgium', 'EURO', '439', '66163', '2', '9681');
INSERT INTO public.who_global_data_import VALUES (7805, '2020-07-25', 'BE', 'Belgium', 'EURO', '496', '66659', '5', '9686');
INSERT INTO public.who_global_data_import VALUES (7806, '2020-07-26', 'BE', 'Belgium', 'EURO', '229', '66888', '1', '9687');
INSERT INTO public.who_global_data_import VALUES (7807, '2020-07-27', 'BE', 'Belgium', 'EURO', '184', '67072', '2', '9689');
INSERT INTO public.who_global_data_import VALUES (7808, '2020-07-28', 'BE', 'Belgium', 'EURO', '595', '67667', '4', '9693');
INSERT INTO public.who_global_data_import VALUES (7809, '2020-07-29', 'BE', 'Belgium', 'EURO', '685', '68352', '1', '9694');
INSERT INTO public.who_global_data_import VALUES (7810, '2020-07-30', 'BE', 'Belgium', 'EURO', '703', '69055', '3', '9697');
INSERT INTO public.who_global_data_import VALUES (7811, '2020-07-31', 'BE', 'Belgium', 'EURO', '635', '69690', '2', '9699');
INSERT INTO public.who_global_data_import VALUES (7812, '2020-08-01', 'BE', 'Belgium', 'EURO', '684', '70374', '3', '9702');
INSERT INTO public.who_global_data_import VALUES (7813, '2020-08-02', 'BE', 'Belgium', 'EURO', '309', '70683', '2', '9704');
INSERT INTO public.who_global_data_import VALUES (7814, '2020-08-03', 'BE', 'Belgium', 'EURO', '148', '70831', '5', '9709');
INSERT INTO public.who_global_data_import VALUES (7815, '2020-08-04', 'BE', 'Belgium', 'EURO', '794', '71625', '3', '9712');
INSERT INTO public.who_global_data_import VALUES (7816, '2020-08-05', 'BE', 'Belgium', 'EURO', '813', '72438', '5', '9717');
INSERT INTO public.who_global_data_import VALUES (7817, '2020-08-06', 'BE', 'Belgium', 'EURO', '767', '73205', '5', '9722');
INSERT INTO public.who_global_data_import VALUES (7818, '2020-08-07', 'BE', 'Belgium', 'EURO', '769', '73974', '4', '9726');
INSERT INTO public.who_global_data_import VALUES (7819, '2020-08-08', 'BE', 'Belgium', 'EURO', '771', '74745', '6', '9732');
INSERT INTO public.who_global_data_import VALUES (7820, '2020-08-09', 'BE', 'Belgium', 'EURO', '304', '75049', '2', '9734');
INSERT INTO public.who_global_data_import VALUES (7821, '2020-08-10', 'BE', 'Belgium', 'EURO', '122', '75171', '5', '9739');
INSERT INTO public.who_global_data_import VALUES (7822, '2020-08-11', 'BE', 'Belgium', 'EURO', '873', '76044', '11', '9750');
INSERT INTO public.who_global_data_import VALUES (7823, '2020-08-12', 'BE', 'Belgium', 'EURO', '718', '76762', '13', '9763');
INSERT INTO public.who_global_data_import VALUES (7824, '2020-08-13', 'BE', 'Belgium', 'EURO', '609', '77371', '11', '9774');
INSERT INTO public.who_global_data_import VALUES (7825, '2020-08-14', 'BE', 'Belgium', 'EURO', '669', '78040', '12', '9786');
INSERT INTO public.who_global_data_import VALUES (7826, '2020-08-15', 'BE', 'Belgium', 'EURO', '587', '78627', '12', '9798');
INSERT INTO public.who_global_data_import VALUES (7827, '2020-08-16', 'BE', 'Belgium', 'EURO', '163', '78790', '9', '9807');
INSERT INTO public.who_global_data_import VALUES (7828, '2020-08-17', 'BE', 'Belgium', 'EURO', '132', '78922', '7', '9814');
INSERT INTO public.who_global_data_import VALUES (7829, '2020-08-18', 'BE', 'Belgium', 'EURO', '707', '79629', '7', '9821');
INSERT INTO public.who_global_data_import VALUES (7830, '2020-08-19', 'BE', 'Belgium', 'EURO', '725', '80354', '11', '9832');
INSERT INTO public.who_global_data_import VALUES (7831, '2020-08-20', 'BE', 'Belgium', 'EURO', '612', '80966', '9', '9841');
INSERT INTO public.who_global_data_import VALUES (7832, '2020-08-21', 'BE', 'Belgium', 'EURO', '581', '81547', '4', '9845');
INSERT INTO public.who_global_data_import VALUES (7833, '2020-08-22', 'BE', 'Belgium', 'EURO', '510', '82057', '3', '9848');
INSERT INTO public.who_global_data_import VALUES (7834, '2020-08-23', 'BE', 'Belgium', 'EURO', '203', '82260', '5', '9853');
INSERT INTO public.who_global_data_import VALUES (7835, '2020-08-24', 'BE', 'Belgium', 'EURO', '115', '82375', '3', '9856');
INSERT INTO public.who_global_data_import VALUES (7836, '2020-08-25', 'BE', 'Belgium', 'EURO', '607', '82982', '5', '9861');
INSERT INTO public.who_global_data_import VALUES (7837, '2020-08-26', 'BE', 'Belgium', 'EURO', '527', '83509', '5', '9866');
INSERT INTO public.who_global_data_import VALUES (7838, '2020-08-27', 'BE', 'Belgium', 'EURO', '526', '84035', '4', '9870');
INSERT INTO public.who_global_data_import VALUES (7839, '2020-08-28', 'BE', 'Belgium', 'EURO', '535', '84570', '3', '9873');
INSERT INTO public.who_global_data_import VALUES (7840, '2020-08-29', 'BE', 'Belgium', 'EURO', '614', '85184', '4', '9877');
INSERT INTO public.who_global_data_import VALUES (7841, '2020-08-30', 'BE', 'Belgium', 'EURO', '195', '85379', '6', '9883');
INSERT INTO public.who_global_data_import VALUES (7842, '2020-08-31', 'BE', 'Belgium', 'EURO', '117', '85496', '1', '9884');
INSERT INTO public.who_global_data_import VALUES (7843, '2020-09-01', 'BE', 'Belgium', 'EURO', '634', '86130', '3', '9887');
INSERT INTO public.who_global_data_import VALUES (7844, '2020-09-02', 'BE', 'Belgium', 'EURO', '565', '86695', '3', '9890');
INSERT INTO public.who_global_data_import VALUES (7845, '2020-09-03', 'BE', 'Belgium', 'EURO', '574', '87269', '2', '9892');
INSERT INTO public.who_global_data_import VALUES (7846, '2020-09-04', 'BE', 'Belgium', 'EURO', '677', '87946', '4', '9896');
INSERT INTO public.who_global_data_import VALUES (7847, '2020-09-05', 'BE', 'Belgium', 'EURO', '728', '88674', '2', '9898');
INSERT INTO public.who_global_data_import VALUES (7848, '2020-09-06', 'BE', 'Belgium', 'EURO', '322', '88996', '1', '9899');
INSERT INTO public.who_global_data_import VALUES (7849, '2020-09-07', 'BE', 'Belgium', 'EURO', '155', '89151', '2', '9901');
INSERT INTO public.who_global_data_import VALUES (7850, '2020-09-08', 'BE', 'Belgium', 'EURO', '918', '90069', '4', '9905');
INSERT INTO public.who_global_data_import VALUES (7851, '2020-09-09', 'BE', 'Belgium', 'EURO', '871', '90940', '3', '9908');
INSERT INTO public.who_global_data_import VALUES (7852, '2020-09-10', 'BE', 'Belgium', 'EURO', '1024', '91964', '2', '9910');
INSERT INTO public.who_global_data_import VALUES (7853, '2020-09-11', 'BE', 'Belgium', 'EURO', '1143', '93107', '3', '9913');
INSERT INTO public.who_global_data_import VALUES (7854, '2020-09-12', 'BE', 'Belgium', 'EURO', '1284', '94391', '5', '9918');
INSERT INTO public.who_global_data_import VALUES (7855, '2020-09-13', 'BE', 'Belgium', 'EURO', '617', '95008', '1', '9919');
INSERT INTO public.who_global_data_import VALUES (7856, '2020-09-14', 'BE', 'Belgium', 'EURO', '301', '95309', '1', '9920');
INSERT INTO public.who_global_data_import VALUES (7857, '2020-09-15', 'BE', 'Belgium', 'EURO', '1724', '97033', '4', '9924');
INSERT INTO public.who_global_data_import VALUES (7858, '2020-09-16', 'BE', 'Belgium', 'EURO', '1628', '98661', '3', '9927');
INSERT INTO public.who_global_data_import VALUES (7859, '2020-09-17', 'BE', 'Belgium', 'EURO', '1942', '100603', '2', '9929');
INSERT INTO public.who_global_data_import VALUES (7860, '2020-09-18', 'BE', 'Belgium', 'EURO', '1750', '102353', '1', '9930');
INSERT INTO public.who_global_data_import VALUES (7861, '2020-09-19', 'BE', 'Belgium', 'EURO', '1709', '104062', '6', '9936');
INSERT INTO public.who_global_data_import VALUES (7862, '2020-09-20', 'BE', 'Belgium', 'EURO', '894', '104956', '8', '9944');
INSERT INTO public.who_global_data_import VALUES (7863, '2020-09-21', 'BE', 'Belgium', 'EURO', '461', '105417', '3', '9947');
INSERT INTO public.who_global_data_import VALUES (7864, '2020-09-22', 'BE', 'Belgium', 'EURO', '2202', '107619', '3', '9950');
INSERT INTO public.who_global_data_import VALUES (7865, '2020-09-23', 'BE', 'Belgium', 'EURO', '2074', '109693', '1', '9951');
INSERT INTO public.who_global_data_import VALUES (7866, '2020-09-24', 'BE', 'Belgium', 'EURO', '2096', '111789', '8', '9959');
INSERT INTO public.who_global_data_import VALUES (7867, '2020-09-25', 'BE', 'Belgium', 'EURO', '1795', '113584', '4', '9963');
INSERT INTO public.who_global_data_import VALUES (7868, '2020-09-26', 'BE', 'Belgium', 'EURO', '1623', '115207', '5', '9968');
INSERT INTO public.who_global_data_import VALUES (7869, '2020-09-27', 'BE', 'Belgium', 'EURO', '944', '116151', '6', '9974');
INSERT INTO public.who_global_data_import VALUES (7870, '2020-09-28', 'BE', 'Belgium', 'EURO', '540', '116691', '12', '9986');
INSERT INTO public.who_global_data_import VALUES (7871, '2020-09-29', 'BE', 'Belgium', 'EURO', '2782', '119473', '13', '9999');
INSERT INTO public.who_global_data_import VALUES (7872, '2020-09-30', 'BE', 'Belgium', 'EURO', '2984', '122457', '10', '10009');
INSERT INTO public.who_global_data_import VALUES (7873, '2020-10-01', 'BE', 'Belgium', 'EURO', '3243', '125700', '6', '10015');
INSERT INTO public.who_global_data_import VALUES (7874, '2020-10-02', 'BE', 'Belgium', 'EURO', '3410', '129110', '15', '10030');
INSERT INTO public.who_global_data_import VALUES (7875, '2020-10-03', 'BE', 'Belgium', 'EURO', '3721', '132831', '11', '10041');
INSERT INTO public.who_global_data_import VALUES (7876, '2020-10-04', 'BE', 'Belgium', 'EURO', '1709', '134540', '15', '10056');
INSERT INTO public.who_global_data_import VALUES (7877, '2020-10-05', 'BE', 'Belgium', 'EURO', '1035', '135575', '14', '10070');
INSERT INTO public.who_global_data_import VALUES (7878, '2020-10-06', 'BE', 'Belgium', 'EURO', '5249', '140824', '14', '10084');
INSERT INTO public.who_global_data_import VALUES (7879, '2020-10-07', 'BE', 'Belgium', 'EURO', '5687', '146511', '18', '10102');
INSERT INTO public.who_global_data_import VALUES (7880, '2020-10-08', 'BE', 'Belgium', 'EURO', '6803', '153314', '20', '10122');
INSERT INTO public.who_global_data_import VALUES (7881, '2020-10-09', 'BE', 'Belgium', 'EURO', '6588', '159902', '20', '10142');
INSERT INTO public.who_global_data_import VALUES (7882, '2020-10-10', 'BE', 'Belgium', 'EURO', '7790', '167692', '19', '10161');
INSERT INTO public.who_global_data_import VALUES (7883, '2020-10-11', 'BE', 'Belgium', 'EURO', '4310', '172002', '22', '10183');
INSERT INTO public.who_global_data_import VALUES (7884, '2020-10-12', 'BE', 'Belgium', 'EURO', '2403', '174405', '26', '10209');
INSERT INTO public.who_global_data_import VALUES (7885, '2020-10-13', 'BE', 'Belgium', 'EURO', '9736', '184141', '36', '10245');
INSERT INTO public.who_global_data_import VALUES (7886, '2020-10-14', 'BE', 'Belgium', 'EURO', '12578', '196719', '34', '10279');
INSERT INTO public.who_global_data_import VALUES (7887, '2020-10-15', 'BE', 'Belgium', 'EURO', '12303', '209022', '41', '10320');
INSERT INTO public.who_global_data_import VALUES (7888, '2020-10-16', 'BE', 'Belgium', 'EURO', '11818', '220840', '35', '10355');
INSERT INTO public.who_global_data_import VALUES (7889, '2020-10-17', 'BE', 'Belgium', 'EURO', '13477', '234317', '36', '10391');
INSERT INTO public.who_global_data_import VALUES (7890, '2020-10-18', 'BE', 'Belgium', 'EURO', '7995', '242312', '23', '10414');
INSERT INTO public.who_global_data_import VALUES (7891, '2020-10-19', 'BE', 'Belgium', 'EURO', '4289', '246601', '31', '10445');
INSERT INTO public.who_global_data_import VALUES (7892, '2020-10-20', 'BE', 'Belgium', 'EURO', '15561', '262162', '52', '10497');
INSERT INTO public.who_global_data_import VALUES (7893, '2020-10-21', 'BE', 'Belgium', 'EURO', '19265', '281427', '52', '10549');
INSERT INTO public.who_global_data_import VALUES (7894, '2020-10-22', 'BE', 'Belgium', 'EURO', '17487', '298914', '61', '10610');
INSERT INTO public.who_global_data_import VALUES (7895, '2020-10-23', 'BE', 'Belgium', 'EURO', '17687', '316601', '55', '10665');
INSERT INTO public.who_global_data_import VALUES (7896, '2020-10-24', 'BE', 'Belgium', 'EURO', '18877', '335478', '93', '10758');
INSERT INTO public.who_global_data_import VALUES (7897, '2020-10-25', 'BE', 'Belgium', 'EURO', '11557', '347035', '94', '10852');
INSERT INTO public.who_global_data_import VALUES (7898, '2020-10-26', 'BE', 'Belgium', 'EURO', '4895', '351930', '95', '10947');
INSERT INTO public.who_global_data_import VALUES (7899, '2020-10-27', 'BE', 'Belgium', 'EURO', '19868', '371798', '121', '11068');
INSERT INTO public.who_global_data_import VALUES (7900, '2020-10-28', 'BE', 'Belgium', 'EURO', '22210', '394008', '130', '11198');
INSERT INTO public.who_global_data_import VALUES (7901, '2020-10-29', 'BE', 'Belgium', 'EURO', '17998', '412006', '142', '11340');
INSERT INTO public.who_global_data_import VALUES (7902, '2020-10-30', 'BE', 'Belgium', 'EURO', '15090', '427096', '140', '11480');
INSERT INTO public.who_global_data_import VALUES (7903, '2020-10-31', 'BE', 'Belgium', 'EURO', '15403', '442499', '184', '11664');
INSERT INTO public.who_global_data_import VALUES (7904, '2020-11-01', 'BE', 'Belgium', 'EURO', '6308', '448807', '176', '11840');
INSERT INTO public.who_global_data_import VALUES (7905, '2020-11-02', 'BE', 'Belgium', 'EURO', '2667', '451474', '163', '12003');
INSERT INTO public.who_global_data_import VALUES (7906, '2020-11-03', 'BE', 'Belgium', 'EURO', '13858', '465332', '207', '12210');
INSERT INTO public.who_global_data_import VALUES (7907, '2020-11-04', 'BE', 'Belgium', 'EURO', '12103', '477435', '173', '12383');
INSERT INTO public.who_global_data_import VALUES (7908, '2020-11-05', 'BE', 'Belgium', 'EURO', '9230', '486665', '196', '12579');
INSERT INTO public.who_global_data_import VALUES (7909, '2020-11-06', 'BE', 'Belgium', 'EURO', '7660', '494325', '207', '12786');
INSERT INTO public.who_global_data_import VALUES (7910, '2020-11-07', 'BE', 'Belgium', 'EURO', '6648', '500973', '211', '12997');
INSERT INTO public.who_global_data_import VALUES (7911, '2020-11-08', 'BE', 'Belgium', 'EURO', '3046', '504019', '208', '13205');
INSERT INTO public.who_global_data_import VALUES (7912, '2020-11-09', 'BE', 'Belgium', 'EURO', '1449', '505468', '209', '13414');
INSERT INTO public.who_global_data_import VALUES (7913, '2020-11-10', 'BE', 'Belgium', 'EURO', '8636', '514104', '194', '13608');
INSERT INTO public.who_global_data_import VALUES (7914, '2020-11-11', 'BE', 'Belgium', 'EURO', '7701', '521805', '217', '13825');
INSERT INTO public.who_global_data_import VALUES (7915, '2020-11-12', 'BE', 'Belgium', 'EURO', '2004', '523809', '194', '14019');
INSERT INTO public.who_global_data_import VALUES (7916, '2020-11-13', 'BE', 'Belgium', 'EURO', '6482', '530291', '172', '14191');
INSERT INTO public.who_global_data_import VALUES (7917, '2020-11-14', 'BE', 'Belgium', 'EURO', '5711', '536002', '183', '14374');
INSERT INTO public.who_global_data_import VALUES (7918, '2020-11-15', 'BE', 'Belgium', 'EURO', '2371', '538373', '176', '14550');
INSERT INTO public.who_global_data_import VALUES (7919, '2020-11-16', 'BE', 'Belgium', 'EURO', '1057', '539430', '192', '14742');
INSERT INTO public.who_global_data_import VALUES (7920, '2020-11-17', 'BE', 'Belgium', 'EURO', '5821', '545251', '194', '14936');
INSERT INTO public.who_global_data_import VALUES (7921, '2020-11-18', 'BE', 'Belgium', 'EURO', '4829', '550080', '156', '15092');
INSERT INTO public.who_global_data_import VALUES (7922, '2020-11-19', 'BE', 'Belgium', 'EURO', '3703', '553783', '158', '15250');
INSERT INTO public.who_global_data_import VALUES (7923, '2020-11-20', 'BE', 'Belgium', 'EURO', '3019', '556802', '172', '15422');
INSERT INTO public.who_global_data_import VALUES (7924, '2020-11-21', 'BE', 'Belgium', 'EURO', '3082', '559884', '169', '15591');
INSERT INTO public.who_global_data_import VALUES (7925, '2020-11-22', 'BE', 'Belgium', 'EURO', '1263', '561147', '139', '15730');
INSERT INTO public.who_global_data_import VALUES (7926, '2020-11-23', 'BE', 'Belgium', 'EURO', '589', '561736', '135', '15865');
INSERT INTO public.who_global_data_import VALUES (7927, '2020-11-24', 'BE', 'Belgium', 'EURO', '3958', '565694', '139', '16004');
INSERT INTO public.who_global_data_import VALUES (7928, '2020-11-25', 'BE', 'Belgium', 'EURO', '2877', '568571', '121', '16125');
INSERT INTO public.who_global_data_import VALUES (7929, '2020-11-26', 'BE', 'Belgium', 'EURO', '2683', '571254', '138', '16263');
INSERT INTO public.who_global_data_import VALUES (7930, '2020-11-27', 'BE', 'Belgium', 'EURO', '2428', '573682', '118', '16381');
INSERT INTO public.who_global_data_import VALUES (7931, '2020-11-28', 'BE', 'Belgium', 'EURO', '2741', '576423', '125', '16506');
INSERT INTO public.who_global_data_import VALUES (7932, '2020-11-29', 'BE', 'Belgium', 'EURO', '1006', '577429', '115', '16621');
INSERT INTO public.who_global_data_import VALUES (7933, '2020-11-30', 'BE', 'Belgium', 'EURO', '560', '577989', '118', '16739');
INSERT INTO public.who_global_data_import VALUES (7934, '2020-12-01', 'BE', 'Belgium', 'EURO', '3304', '581293', '99', '16838');
INSERT INTO public.who_global_data_import VALUES (7935, '2020-12-02', 'BE', 'Belgium', 'EURO', '2698', '583991', '109', '16947');
INSERT INTO public.who_global_data_import VALUES (7936, '2020-12-03', 'BE', 'Belgium', 'EURO', '2618', '586609', '117', '17064');
INSERT INTO public.who_global_data_import VALUES (7937, '2020-12-04', 'BE', 'Belgium', 'EURO', '2386', '588995', '94', '17158');
INSERT INTO public.who_global_data_import VALUES (7938, '2020-12-05', 'BE', 'Belgium', 'EURO', '2567', '591562', '109', '17267');
INSERT INTO public.who_global_data_import VALUES (7939, '2020-12-06', 'BE', 'Belgium', 'EURO', '1101', '592663', '87', '17354');
INSERT INTO public.who_global_data_import VALUES (7940, '2020-12-07', 'BE', 'Belgium', 'EURO', '601', '593264', '84', '17438');
INSERT INTO public.who_global_data_import VALUES (7941, '2020-12-08', 'BE', 'Belgium', 'EURO', '3371', '596635', '97', '17535');
INSERT INTO public.who_global_data_import VALUES (7942, '2020-12-09', 'BE', 'Belgium', 'EURO', '2723', '599358', '94', '17629');
INSERT INTO public.who_global_data_import VALUES (7943, '2020-12-10', 'BE', 'Belgium', 'EURO', '2769', '602127', '88', '17717');
INSERT INTO public.who_global_data_import VALUES (7944, '2020-12-11', 'BE', 'Belgium', 'EURO', '2675', '604802', '94', '17811');
INSERT INTO public.who_global_data_import VALUES (7945, '2020-12-12', 'BE', 'Belgium', 'EURO', '2918', '607720', '114', '17925');
INSERT INTO public.who_global_data_import VALUES (7946, '2020-12-13', 'BE', 'Belgium', 'EURO', '1595', '609315', '87', '18012');
INSERT INTO public.who_global_data_import VALUES (7947, '2020-12-14', 'BE', 'Belgium', 'EURO', '742', '610057', '92', '18104');
INSERT INTO public.who_global_data_import VALUES (7948, '2020-12-15', 'BE', 'Belgium', 'EURO', '3843', '613900', '100', '18204');
INSERT INTO public.who_global_data_import VALUES (7949, '2020-12-16', 'BE', 'Belgium', 'EURO', '3239', '617139', '103', '18307');
INSERT INTO public.who_global_data_import VALUES (7950, '2020-12-17', 'BE', 'Belgium', 'EURO', '2856', '619995', '97', '18404');
INSERT INTO public.who_global_data_import VALUES (7951, '2020-12-18', 'BE', 'Belgium', 'EURO', '2794', '622789', '89', '18493');
INSERT INTO public.who_global_data_import VALUES (7952, '2020-12-19', 'BE', 'Belgium', 'EURO', '2835', '625624', '83', '18576');
INSERT INTO public.who_global_data_import VALUES (7953, '2020-12-20', 'BE', 'Belgium', 'EURO', '1461', '627085', '93', '18669');
INSERT INTO public.who_global_data_import VALUES (7954, '2020-12-21', 'BE', 'Belgium', 'EURO', '655', '627740', '89', '18758');
INSERT INTO public.who_global_data_import VALUES (7955, '2020-12-22', 'BE', 'Belgium', 'EURO', '3395', '631135', '69', '18827');
INSERT INTO public.who_global_data_import VALUES (7956, '2020-12-23', 'BE', 'Belgium', 'EURO', '2707', '633842', '102', '18929');
INSERT INTO public.who_global_data_import VALUES (7957, '2020-12-24', 'BE', 'Belgium', 'EURO', '2462', '636304', '92', '19021');
INSERT INTO public.who_global_data_import VALUES (7958, '2020-12-25', 'BE', 'Belgium', 'EURO', '1783', '638087', '81', '19102');
INSERT INTO public.who_global_data_import VALUES (7959, '2020-12-26', 'BE', 'Belgium', 'EURO', '520', '638607', '67', '19169');
INSERT INTO public.who_global_data_import VALUES (7960, '2020-12-27', 'BE', 'Belgium', 'EURO', '1159', '639766', '62', '19231');
INSERT INTO public.who_global_data_import VALUES (7961, '2020-12-28', 'BE', 'Belgium', 'EURO', '558', '640324', '61', '19292');
INSERT INTO public.who_global_data_import VALUES (7962, '2020-12-29', 'BE', 'Belgium', 'EURO', '2749', '643073', '63', '19355');
INSERT INTO public.who_global_data_import VALUES (7963, '2020-12-30', 'BE', 'Belgium', 'EURO', '2420', '645493', '76', '19431');
INSERT INTO public.who_global_data_import VALUES (7964, '2020-12-31', 'BE', 'Belgium', 'EURO', '2081', '647574', '74', '19505');
INSERT INTO public.who_global_data_import VALUES (7965, '2021-01-01', 'BE', 'Belgium', 'EURO', '1721', '649295', '87', '19592');
INSERT INTO public.who_global_data_import VALUES (7966, '2021-01-02', 'BE', 'Belgium', 'EURO', '471', '649766', '50', '19642');
INSERT INTO public.who_global_data_import VALUES (7967, '2021-01-03', 'BE', 'Belgium', 'EURO', '1120', '650886', '64', '19706');
INSERT INTO public.who_global_data_import VALUES (7968, '2021-01-04', 'BE', 'Belgium', 'EURO', '821', '651707', '42', '19748');
INSERT INTO public.who_global_data_import VALUES (7969, '2021-01-05', 'BE', 'Belgium', 'EURO', '3121', '654828', '59', '19807');
INSERT INTO public.who_global_data_import VALUES (7970, '2021-01-06', 'BE', 'Belgium', 'EURO', '2823', '657651', '63', '19870');
INSERT INTO public.who_global_data_import VALUES (7971, '2021-01-07', 'BE', 'Belgium', 'EURO', '2518', '660169', '54', '19924');
INSERT INTO public.who_global_data_import VALUES (7972, '2021-01-08', 'BE', 'Belgium', 'EURO', '1979', '662148', '53', '19977');
INSERT INTO public.who_global_data_import VALUES (7973, '2021-01-09', 'BE', 'Belgium', 'EURO', '2015', '664163', '48', '20025');
INSERT INTO public.who_global_data_import VALUES (7974, '2021-01-10', 'BE', 'Belgium', 'EURO', '1393', '665556', '51', '20076');
INSERT INTO public.who_global_data_import VALUES (7975, '2021-01-11', 'BE', 'Belgium', 'EURO', '857', '666413', '56', '20132');
INSERT INTO public.who_global_data_import VALUES (7976, '2021-01-12', 'BE', 'Belgium', 'EURO', '3081', '669494', '53', '20185');
INSERT INTO public.who_global_data_import VALUES (7977, '2021-01-13', 'BE', 'Belgium', 'EURO', '2485', '671979', '51', '20236');
INSERT INTO public.who_global_data_import VALUES (7978, '2021-01-14', 'BE', 'Belgium', 'EURO', '2217', '674196', '42', '20278');
INSERT INTO public.who_global_data_import VALUES (7979, '2021-01-15', 'BE', 'Belgium', 'EURO', '2105', '676301', '61', '20339');
INSERT INTO public.who_global_data_import VALUES (7980, '2021-01-16', 'BE', 'Belgium', 'EURO', '2063', '678364', '48', '20387');
INSERT INTO public.who_global_data_import VALUES (7981, '2021-01-17', 'BE', 'Belgium', 'EURO', '1175', '679539', '45', '20432');
INSERT INTO public.who_global_data_import VALUES (7982, '2021-01-18', 'BE', 'Belgium', 'EURO', '721', '680260', '44', '20476');
INSERT INTO public.who_global_data_import VALUES (7983, '2021-01-19', 'BE', 'Belgium', 'EURO', '3041', '683301', '57', '20533');
INSERT INTO public.who_global_data_import VALUES (7984, '2021-01-20', 'BE', 'Belgium', 'EURO', '2485', '685786', '60', '20593');
INSERT INTO public.who_global_data_import VALUES (7985, '2021-01-21', 'BE', 'Belgium', 'EURO', '2540', '688326', '49', '20642');
INSERT INTO public.who_global_data_import VALUES (7986, '2021-01-22', 'BE', 'Belgium', 'EURO', '2380', '690706', '51', '20693');
INSERT INTO public.who_global_data_import VALUES (7987, '2021-01-23', 'BE', 'Belgium', 'EURO', '2575', '693281', '50', '20743');
INSERT INTO public.who_global_data_import VALUES (7988, '2021-01-24', 'BE', 'Belgium', 'EURO', '1395', '694676', '67', '20810');
INSERT INTO public.who_global_data_import VALUES (7989, '2021-01-25', 'BE', 'Belgium', 'EURO', '817', '695493', '39', '20849');
INSERT INTO public.who_global_data_import VALUES (7990, '2021-01-26', 'BE', 'Belgium', 'EURO', '3419', '698912', '44', '20893');
INSERT INTO public.who_global_data_import VALUES (7991, '2021-01-27', 'BE', 'Belgium', 'EURO', '2723', '701635', '52', '20945');
INSERT INTO public.who_global_data_import VALUES (7992, '2021-01-28', 'BE', 'Belgium', 'EURO', '2466', '704101', '41', '20986');
INSERT INTO public.who_global_data_import VALUES (7993, '2021-01-29', 'BE', 'Belgium', 'EURO', '2498', '706599', '54', '21040');
INSERT INTO public.who_global_data_import VALUES (7994, '2021-01-30', 'BE', 'Belgium', 'EURO', '3026', '709625', '43', '21083');
INSERT INTO public.who_global_data_import VALUES (7995, '2021-01-31', 'BE', 'Belgium', 'EURO', '1568', '711193', '28', '21111');
INSERT INTO public.who_global_data_import VALUES (7996, '2021-02-01', 'BE', 'Belgium', 'EURO', '855', '712048', '32', '21143');
INSERT INTO public.who_global_data_import VALUES (7997, '2021-02-02', 'BE', 'Belgium', 'EURO', '3308', '715356', '35', '21178');
INSERT INTO public.who_global_data_import VALUES (7998, '2021-02-03', 'BE', 'Belgium', 'EURO', '2439', '717795', '50', '21228');
INSERT INTO public.who_global_data_import VALUES (7999, '2021-02-04', 'BE', 'Belgium', 'EURO', '1052', '718847', '32', '21260');
INSERT INTO public.who_global_data_import VALUES (8000, '2021-02-05', 'BE', 'Belgium', 'EURO', '0', '718847', '0', '21260');
INSERT INTO public.who_global_data_import VALUES (8001, '2020-01-03', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8002, '2020-01-04', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8003, '2020-01-05', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8004, '2020-01-06', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8005, '2020-01-07', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8006, '2020-01-08', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8007, '2020-01-09', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8008, '2020-01-10', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8009, '2020-01-11', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8010, '2020-01-12', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8011, '2020-01-13', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8012, '2020-01-14', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8013, '2020-01-15', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8014, '2020-01-16', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8015, '2020-01-17', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8016, '2020-01-18', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8017, '2020-01-19', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8018, '2020-01-20', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8019, '2020-01-21', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8020, '2020-01-22', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8021, '2020-01-23', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8022, '2020-01-24', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8023, '2020-01-25', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8024, '2020-01-26', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8025, '2020-01-27', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8026, '2020-01-28', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8027, '2020-01-29', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8028, '2020-01-30', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8029, '2020-01-31', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8030, '2020-02-01', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8031, '2020-02-02', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8032, '2020-02-03', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8033, '2020-02-04', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8034, '2020-02-05', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8035, '2020-02-06', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8036, '2020-02-07', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8037, '2020-02-08', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8038, '2020-02-09', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8039, '2020-02-10', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8040, '2020-02-11', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8041, '2020-02-12', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8042, '2020-02-13', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8043, '2020-02-14', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8044, '2020-02-15', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8045, '2020-02-16', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8046, '2020-02-17', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8047, '2020-02-18', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8048, '2020-02-19', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8049, '2020-02-20', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8050, '2020-02-21', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8051, '2020-02-22', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8052, '2020-02-23', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8053, '2020-02-24', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8054, '2020-02-25', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8055, '2020-02-26', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8056, '2020-02-27', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8057, '2020-02-28', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8058, '2020-02-29', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8059, '2020-03-01', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8060, '2020-03-02', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8061, '2020-03-03', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8062, '2020-03-04', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8063, '2020-03-05', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8064, '2020-03-06', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8065, '2020-03-07', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8066, '2020-03-08', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8067, '2020-03-09', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8068, '2020-03-10', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8069, '2020-03-11', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8070, '2020-03-12', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8071, '2020-03-13', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8072, '2020-03-14', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8073, '2020-03-15', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8074, '2020-03-16', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8075, '2020-03-17', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8076, '2020-03-18', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8077, '2020-03-19', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8078, '2020-03-20', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8079, '2020-03-21', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8080, '2020-03-22', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8081, '2020-03-23', 'BZ', 'Belize', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8082, '2020-03-24', 'BZ', 'Belize', 'AMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8083, '2020-03-25', 'BZ', 'Belize', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8084, '2020-03-26', 'BZ', 'Belize', 'AMRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8085, '2020-03-27', 'BZ', 'Belize', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8086, '2020-03-28', 'BZ', 'Belize', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8087, '2020-03-29', 'BZ', 'Belize', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8088, '2020-03-30', 'BZ', 'Belize', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8089, '2020-03-31', 'BZ', 'Belize', 'AMRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8090, '2020-04-01', 'BZ', 'Belize', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8091, '2020-04-02', 'BZ', 'Belize', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8092, '2020-04-03', 'BZ', 'Belize', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8093, '2020-04-04', 'BZ', 'Belize', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8094, '2020-04-05', 'BZ', 'Belize', 'AMRO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8095, '2020-04-06', 'BZ', 'Belize', 'AMRO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8096, '2020-04-07', 'BZ', 'Belize', 'AMRO', '2', '7', '1', '1');
INSERT INTO public.who_global_data_import VALUES (8097, '2020-04-08', 'BZ', 'Belize', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8098, '2020-04-09', 'BZ', 'Belize', 'AMRO', '1', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8099, '2020-04-10', 'BZ', 'Belize', 'AMRO', '1', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8100, '2020-04-11', 'BZ', 'Belize', 'AMRO', '1', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8101, '2020-04-12', 'BZ', 'Belize', 'AMRO', '0', '10', '1', '2');
INSERT INTO public.who_global_data_import VALUES (8102, '2020-04-13', 'BZ', 'Belize', 'AMRO', '3', '13', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8103, '2020-04-14', 'BZ', 'Belize', 'AMRO', '1', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8104, '2020-04-15', 'BZ', 'Belize', 'AMRO', '4', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8105, '2020-04-16', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8106, '2020-04-17', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8107, '2020-04-18', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8108, '2020-04-19', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8109, '2020-04-20', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8110, '2020-04-21', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8111, '2020-04-22', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8112, '2020-04-23', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8113, '2020-04-24', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8114, '2020-04-25', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8115, '2020-04-26', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8116, '2020-04-27', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8117, '2020-04-28', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8118, '2020-04-29', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8119, '2020-04-30', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8120, '2020-05-01', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8121, '2020-05-02', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8122, '2020-05-03', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8123, '2020-05-04', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8124, '2020-05-05', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8125, '2020-05-06', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8126, '2020-05-07', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8127, '2020-05-08', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8128, '2020-05-09', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8129, '2020-05-10', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8130, '2020-05-11', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8131, '2020-05-12', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8132, '2020-05-13', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8133, '2020-05-14', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8134, '2020-05-15', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8135, '2020-05-16', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8136, '2020-05-17', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8137, '2020-05-18', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8138, '2020-05-19', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8139, '2020-05-20', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8140, '2020-05-21', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8141, '2020-05-22', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8142, '2020-05-23', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8143, '2020-05-24', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8144, '2020-05-25', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8145, '2020-05-26', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8146, '2020-05-27', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8147, '2020-05-28', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8148, '2020-05-29', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8149, '2020-05-30', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8150, '2020-05-31', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8151, '2020-06-01', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8152, '2020-06-02', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8153, '2020-06-03', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8154, '2020-06-04', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8155, '2020-06-05', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8156, '2020-06-06', 'BZ', 'Belize', 'AMRO', '0', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8157, '2020-06-07', 'BZ', 'Belize', 'AMRO', '1', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8158, '2020-06-08', 'BZ', 'Belize', 'AMRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8159, '2020-06-09', 'BZ', 'Belize', 'AMRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8160, '2020-06-10', 'BZ', 'Belize', 'AMRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8161, '2020-06-11', 'BZ', 'Belize', 'AMRO', '1', '20', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8162, '2020-06-12', 'BZ', 'Belize', 'AMRO', '0', '20', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8163, '2020-06-13', 'BZ', 'Belize', 'AMRO', '0', '20', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8164, '2020-06-14', 'BZ', 'Belize', 'AMRO', '0', '20', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8165, '2020-06-15', 'BZ', 'Belize', 'AMRO', '1', '21', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8166, '2020-06-16', 'BZ', 'Belize', 'AMRO', '0', '21', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8167, '2020-06-17', 'BZ', 'Belize', 'AMRO', '0', '21', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8168, '2020-06-18', 'BZ', 'Belize', 'AMRO', '1', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8169, '2020-06-19', 'BZ', 'Belize', 'AMRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8170, '2020-06-20', 'BZ', 'Belize', 'AMRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8171, '2020-06-21', 'BZ', 'Belize', 'AMRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8172, '2020-06-22', 'BZ', 'Belize', 'AMRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8173, '2020-06-23', 'BZ', 'Belize', 'AMRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8174, '2020-06-24', 'BZ', 'Belize', 'AMRO', '1', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8175, '2020-06-25', 'BZ', 'Belize', 'AMRO', '0', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8176, '2020-06-26', 'BZ', 'Belize', 'AMRO', '0', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8177, '2020-06-27', 'BZ', 'Belize', 'AMRO', '0', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8178, '2020-06-28', 'BZ', 'Belize', 'AMRO', '1', '24', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8179, '2020-06-29', 'BZ', 'Belize', 'AMRO', '0', '24', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8180, '2020-06-30', 'BZ', 'Belize', 'AMRO', '0', '24', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8181, '2020-07-01', 'BZ', 'Belize', 'AMRO', '0', '24', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8182, '2020-07-02', 'BZ', 'Belize', 'AMRO', '4', '28', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8183, '2020-07-03', 'BZ', 'Belize', 'AMRO', '0', '28', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8184, '2020-07-04', 'BZ', 'Belize', 'AMRO', '0', '28', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8185, '2020-07-05', 'BZ', 'Belize', 'AMRO', '2', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8186, '2020-07-06', 'BZ', 'Belize', 'AMRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8187, '2020-07-07', 'BZ', 'Belize', 'AMRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8188, '2020-07-08', 'BZ', 'Belize', 'AMRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8189, '2020-07-09', 'BZ', 'Belize', 'AMRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8190, '2020-07-10', 'BZ', 'Belize', 'AMRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8191, '2020-07-11', 'BZ', 'Belize', 'AMRO', '3', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8192, '2020-07-12', 'BZ', 'Belize', 'AMRO', '4', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8193, '2020-07-13', 'BZ', 'Belize', 'AMRO', '0', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8194, '2020-07-14', 'BZ', 'Belize', 'AMRO', '0', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8195, '2020-07-15', 'BZ', 'Belize', 'AMRO', '0', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8196, '2020-07-16', 'BZ', 'Belize', 'AMRO', '2', '39', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8197, '2020-07-17', 'BZ', 'Belize', 'AMRO', '0', '39', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8198, '2020-07-18', 'BZ', 'Belize', 'AMRO', '1', '40', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8199, '2020-07-19', 'BZ', 'Belize', 'AMRO', '0', '40', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8200, '2020-07-20', 'BZ', 'Belize', 'AMRO', '0', '40', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8201, '2020-07-21', 'BZ', 'Belize', 'AMRO', '0', '40', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8202, '2020-07-22', 'BZ', 'Belize', 'AMRO', '2', '42', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8203, '2020-07-23', 'BZ', 'Belize', 'AMRO', '1', '43', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8204, '2020-07-24', 'BZ', 'Belize', 'AMRO', '0', '43', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8205, '2020-07-25', 'BZ', 'Belize', 'AMRO', '4', '47', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8206, '2020-07-26', 'BZ', 'Belize', 'AMRO', '1', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8207, '2020-07-27', 'BZ', 'Belize', 'AMRO', '0', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8208, '2020-07-28', 'BZ', 'Belize', 'AMRO', '0', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8209, '2020-07-29', 'BZ', 'Belize', 'AMRO', '0', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8210, '2020-07-30', 'BZ', 'Belize', 'AMRO', '0', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8211, '2020-07-31', 'BZ', 'Belize', 'AMRO', '0', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8212, '2020-08-01', 'BZ', 'Belize', 'AMRO', '0', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8213, '2020-08-02', 'BZ', 'Belize', 'AMRO', '0', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8214, '2020-08-03', 'BZ', 'Belize', 'AMRO', '8', '56', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8215, '2020-08-04', 'BZ', 'Belize', 'AMRO', '1', '57', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8216, '2020-08-05', 'BZ', 'Belize', 'AMRO', '0', '57', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8217, '2020-08-06', 'BZ', 'Belize', 'AMRO', '10', '67', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8218, '2020-08-07', 'BZ', 'Belize', 'AMRO', '19', '86', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8219, '2020-08-08', 'BZ', 'Belize', 'AMRO', '28', '114', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8220, '2020-08-09', 'BZ', 'Belize', 'AMRO', '32', '146', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8221, '2020-08-10', 'BZ', 'Belize', 'AMRO', '7', '153', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8222, '2020-08-11', 'BZ', 'Belize', 'AMRO', '1', '154', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8223, '2020-08-12', 'BZ', 'Belize', 'AMRO', '23', '177', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8224, '2020-08-13', 'BZ', 'Belize', 'AMRO', '33', '210', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8225, '2020-08-14', 'BZ', 'Belize', 'AMRO', '86', '296', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8226, '2020-08-15', 'BZ', 'Belize', 'AMRO', '60', '356', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8227, '2020-08-16', 'BZ', 'Belize', 'AMRO', '32', '388', '1', '3');
INSERT INTO public.who_global_data_import VALUES (8228, '2020-08-17', 'BZ', 'Belize', 'AMRO', '64', '452', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8229, '2020-08-18', 'BZ', 'Belize', 'AMRO', '0', '452', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8230, '2020-08-19', 'BZ', 'Belize', 'AMRO', '23', '475', '1', '4');
INSERT INTO public.who_global_data_import VALUES (8231, '2020-08-20', 'BZ', 'Belize', 'AMRO', '78', '553', '0', '4');
INSERT INTO public.who_global_data_import VALUES (8232, '2020-08-21', 'BZ', 'Belize', 'AMRO', '0', '553', '1', '5');
INSERT INTO public.who_global_data_import VALUES (8233, '2020-08-22', 'BZ', 'Belize', 'AMRO', '52', '605', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8234, '2020-08-23', 'BZ', 'Belize', 'AMRO', '43', '648', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8235, '2020-08-24', 'BZ', 'Belize', 'AMRO', '20', '668', '1', '6');
INSERT INTO public.who_global_data_import VALUES (8236, '2020-08-25', 'BZ', 'Belize', 'AMRO', '18', '686', '0', '6');
INSERT INTO public.who_global_data_import VALUES (8237, '2020-08-26', 'BZ', 'Belize', 'AMRO', '27', '713', '4', '10');
INSERT INTO public.who_global_data_import VALUES (8238, '2020-08-27', 'BZ', 'Belize', 'AMRO', '17', '730', '0', '10');
INSERT INTO public.who_global_data_import VALUES (8239, '2020-08-28', 'BZ', 'Belize', 'AMRO', '30', '760', '1', '11');
INSERT INTO public.who_global_data_import VALUES (8240, '2020-08-29', 'BZ', 'Belize', 'AMRO', '58', '818', '1', '12');
INSERT INTO public.who_global_data_import VALUES (8241, '2020-08-30', 'BZ', 'Belize', 'AMRO', '52', '870', '0', '12');
INSERT INTO public.who_global_data_import VALUES (8242, '2020-08-31', 'BZ', 'Belize', 'AMRO', '94', '964', '1', '13');
INSERT INTO public.who_global_data_import VALUES (8243, '2020-09-01', 'BZ', 'Belize', 'AMRO', '29', '993', '0', '13');
INSERT INTO public.who_global_data_import VALUES (8244, '2020-09-02', 'BZ', 'Belize', 'AMRO', '14', '1007', '0', '13');
INSERT INTO public.who_global_data_import VALUES (8245, '2020-09-03', 'BZ', 'Belize', 'AMRO', '43', '1050', '0', '13');
INSERT INTO public.who_global_data_import VALUES (8246, '2020-09-04', 'BZ', 'Belize', 'AMRO', '51', '1101', '0', '13');
INSERT INTO public.who_global_data_import VALUES (8247, '2020-09-05', 'BZ', 'Belize', 'AMRO', '17', '1118', '0', '13');
INSERT INTO public.who_global_data_import VALUES (8248, '2020-09-06', 'BZ', 'Belize', 'AMRO', '34', '1152', '2', '15');
INSERT INTO public.who_global_data_import VALUES (8249, '2020-09-07', 'BZ', 'Belize', 'AMRO', '42', '1194', '0', '15');
INSERT INTO public.who_global_data_import VALUES (8250, '2020-09-08', 'BZ', 'Belize', 'AMRO', '67', '1261', '0', '15');
INSERT INTO public.who_global_data_import VALUES (8251, '2020-09-09', 'BZ', 'Belize', 'AMRO', '46', '1307', '1', '16');
INSERT INTO public.who_global_data_import VALUES (8252, '2020-09-10', 'BZ', 'Belize', 'AMRO', '54', '1361', '0', '16');
INSERT INTO public.who_global_data_import VALUES (8253, '2020-09-11', 'BZ', 'Belize', 'AMRO', '4', '1365', '2', '18');
INSERT INTO public.who_global_data_import VALUES (8254, '2020-09-12', 'BZ', 'Belize', 'AMRO', '34', '1399', '1', '19');
INSERT INTO public.who_global_data_import VALUES (8255, '2020-09-13', 'BZ', 'Belize', 'AMRO', '36', '1435', '0', '19');
INSERT INTO public.who_global_data_import VALUES (8256, '2020-09-14', 'BZ', 'Belize', 'AMRO', '23', '1458', '0', '19');
INSERT INTO public.who_global_data_import VALUES (8257, '2020-09-15', 'BZ', 'Belize', 'AMRO', '22', '1480', '0', '19');
INSERT INTO public.who_global_data_import VALUES (8258, '2020-09-16', 'BZ', 'Belize', 'AMRO', '21', '1501', '0', '19');
INSERT INTO public.who_global_data_import VALUES (8259, '2020-09-17', 'BZ', 'Belize', 'AMRO', '27', '1528', '0', '19');
INSERT INTO public.who_global_data_import VALUES (8260, '2020-09-18', 'BZ', 'Belize', 'AMRO', '8', '1536', '0', '19');
INSERT INTO public.who_global_data_import VALUES (8261, '2020-09-19', 'BZ', 'Belize', 'AMRO', '31', '1567', '0', '19');
INSERT INTO public.who_global_data_import VALUES (8262, '2020-09-20', 'BZ', 'Belize', 'AMRO', '23', '1590', '1', '20');
INSERT INTO public.who_global_data_import VALUES (8263, '2020-09-21', 'BZ', 'Belize', 'AMRO', '16', '1606', '0', '20');
INSERT INTO public.who_global_data_import VALUES (8264, '2020-09-22', 'BZ', 'Belize', 'AMRO', '21', '1627', '1', '21');
INSERT INTO public.who_global_data_import VALUES (8265, '2020-09-23', 'BZ', 'Belize', 'AMRO', '8', '1635', '0', '21');
INSERT INTO public.who_global_data_import VALUES (8266, '2020-09-24', 'BZ', 'Belize', 'AMRO', '34', '1669', '0', '21');
INSERT INTO public.who_global_data_import VALUES (8267, '2020-09-25', 'BZ', 'Belize', 'AMRO', '37', '1706', '1', '22');
INSERT INTO public.who_global_data_import VALUES (8268, '2020-09-26', 'BZ', 'Belize', 'AMRO', '52', '1758', '0', '22');
INSERT INTO public.who_global_data_import VALUES (8269, '2020-09-27', 'BZ', 'Belize', 'AMRO', '50', '1808', '1', '23');
INSERT INTO public.who_global_data_import VALUES (8270, '2020-09-28', 'BZ', 'Belize', 'AMRO', '17', '1825', '1', '24');
INSERT INTO public.who_global_data_import VALUES (8271, '2020-09-29', 'BZ', 'Belize', 'AMRO', '29', '1854', '0', '24');
INSERT INTO public.who_global_data_import VALUES (8272, '2020-09-30', 'BZ', 'Belize', 'AMRO', '37', '1891', '0', '24');
INSERT INTO public.who_global_data_import VALUES (8273, '2020-10-01', 'BZ', 'Belize', 'AMRO', '52', '1943', '2', '26');
INSERT INTO public.who_global_data_import VALUES (8274, '2020-10-02', 'BZ', 'Belize', 'AMRO', '49', '1992', '1', '27');
INSERT INTO public.who_global_data_import VALUES (8275, '2020-10-03', 'BZ', 'Belize', 'AMRO', '34', '2026', '0', '27');
INSERT INTO public.who_global_data_import VALUES (8276, '2020-10-04', 'BZ', 'Belize', 'AMRO', '54', '2080', '1', '28');
INSERT INTO public.who_global_data_import VALUES (8277, '2020-10-05', 'BZ', 'Belize', 'AMRO', '51', '2131', '1', '29');
INSERT INTO public.who_global_data_import VALUES (8278, '2020-10-06', 'BZ', 'Belize', 'AMRO', '65', '2196', '1', '30');
INSERT INTO public.who_global_data_import VALUES (8279, '2020-10-07', 'BZ', 'Belize', 'AMRO', '8', '2204', '0', '30');
INSERT INTO public.who_global_data_import VALUES (8280, '2020-10-08', 'BZ', 'Belize', 'AMRO', '39', '2243', '4', '34');
INSERT INTO public.who_global_data_import VALUES (8281, '2020-10-09', 'BZ', 'Belize', 'AMRO', '67', '2310', '0', '34');
INSERT INTO public.who_global_data_import VALUES (8282, '2020-10-10', 'BZ', 'Belize', 'AMRO', '63', '2373', '0', '34');
INSERT INTO public.who_global_data_import VALUES (8283, '2020-10-11', 'BZ', 'Belize', 'AMRO', '54', '2427', '1', '35');
INSERT INTO public.who_global_data_import VALUES (8284, '2020-10-12', 'BZ', 'Belize', 'AMRO', '69', '2496', '1', '36');
INSERT INTO public.who_global_data_import VALUES (8285, '2020-10-13', 'BZ', 'Belize', 'AMRO', '35', '2531', '1', '37');
INSERT INTO public.who_global_data_import VALUES (8286, '2020-10-14', 'BZ', 'Belize', 'AMRO', '38', '2569', '0', '37');
INSERT INTO public.who_global_data_import VALUES (8287, '2020-10-15', 'BZ', 'Belize', 'AMRO', '16', '2585', '2', '39');
INSERT INTO public.who_global_data_import VALUES (8288, '2020-10-16', 'BZ', 'Belize', 'AMRO', '34', '2619', '1', '40');
INSERT INTO public.who_global_data_import VALUES (8289, '2020-10-17', 'BZ', 'Belize', 'AMRO', '63', '2682', '1', '41');
INSERT INTO public.who_global_data_import VALUES (8290, '2020-10-18', 'BZ', 'Belize', 'AMRO', '46', '2728', '2', '43');
INSERT INTO public.who_global_data_import VALUES (8291, '2020-10-19', 'BZ', 'Belize', 'AMRO', '47', '2775', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8292, '2020-10-20', 'BZ', 'Belize', 'AMRO', '38', '2813', '1', '44');
INSERT INTO public.who_global_data_import VALUES (8293, '2020-10-21', 'BZ', 'Belize', 'AMRO', '20', '2833', '1', '45');
INSERT INTO public.who_global_data_import VALUES (8294, '2020-10-22', 'BZ', 'Belize', 'AMRO', '53', '2886', '0', '45');
INSERT INTO public.who_global_data_import VALUES (8295, '2020-10-23', 'BZ', 'Belize', 'AMRO', '51', '2937', '1', '46');
INSERT INTO public.who_global_data_import VALUES (8296, '2020-10-24', 'BZ', 'Belize', 'AMRO', '58', '2995', '0', '46');
INSERT INTO public.who_global_data_import VALUES (8297, '2020-10-25', 'BZ', 'Belize', 'AMRO', '55', '3050', '1', '47');
INSERT INTO public.who_global_data_import VALUES (8298, '2020-10-26', 'BZ', 'Belize', 'AMRO', '56', '3106', '1', '48');
INSERT INTO public.who_global_data_import VALUES (8299, '2020-10-27', 'BZ', 'Belize', 'AMRO', '39', '3145', '2', '50');
INSERT INTO public.who_global_data_import VALUES (8408, '2020-01-10', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8300, '2020-10-28', 'BZ', 'Belize', 'AMRO', '55', '3200', '1', '51');
INSERT INTO public.who_global_data_import VALUES (8301, '2020-10-29', 'BZ', 'Belize', 'AMRO', '32', '3232', '0', '51');
INSERT INTO public.who_global_data_import VALUES (8302, '2020-10-30', 'BZ', 'Belize', 'AMRO', '29', '3261', '1', '52');
INSERT INTO public.who_global_data_import VALUES (8303, '2020-10-31', 'BZ', 'Belize', 'AMRO', '121', '3382', '4', '56');
INSERT INTO public.who_global_data_import VALUES (8304, '2020-11-01', 'BZ', 'Belize', 'AMRO', '80', '3462', '2', '58');
INSERT INTO public.who_global_data_import VALUES (8305, '2020-11-02', 'BZ', 'Belize', 'AMRO', '25', '3487', '1', '59');
INSERT INTO public.who_global_data_import VALUES (8306, '2020-11-03', 'BZ', 'Belize', 'AMRO', '90', '3577', '0', '59');
INSERT INTO public.who_global_data_import VALUES (8307, '2020-11-04', 'BZ', 'Belize', 'AMRO', '47', '3624', '0', '59');
INSERT INTO public.who_global_data_import VALUES (8308, '2020-11-05', 'BZ', 'Belize', 'AMRO', '166', '3790', '2', '61');
INSERT INTO public.who_global_data_import VALUES (8309, '2020-11-06', 'BZ', 'Belize', 'AMRO', '115', '3905', '3', '64');
INSERT INTO public.who_global_data_import VALUES (8310, '2020-11-07', 'BZ', 'Belize', 'AMRO', '72', '3977', '2', '66');
INSERT INTO public.who_global_data_import VALUES (8311, '2020-11-08', 'BZ', 'Belize', 'AMRO', '39', '4016', '1', '67');
INSERT INTO public.who_global_data_import VALUES (8312, '2020-11-09', 'BZ', 'Belize', 'AMRO', '60', '4076', '1', '68');
INSERT INTO public.who_global_data_import VALUES (8313, '2020-11-10', 'BZ', 'Belize', 'AMRO', '100', '4176', '2', '70');
INSERT INTO public.who_global_data_import VALUES (8314, '2020-11-11', 'BZ', 'Belize', 'AMRO', '54', '4230', '1', '71');
INSERT INTO public.who_global_data_import VALUES (8315, '2020-11-12', 'BZ', 'Belize', 'AMRO', '184', '4414', '2', '73');
INSERT INTO public.who_global_data_import VALUES (8316, '2020-11-13', 'BZ', 'Belize', 'AMRO', '106', '4520', '2', '75');
INSERT INTO public.who_global_data_import VALUES (8317, '2020-11-14', 'BZ', 'Belize', 'AMRO', '76', '4596', '0', '75');
INSERT INTO public.who_global_data_import VALUES (8318, '2020-11-15', 'BZ', 'Belize', 'AMRO', '119', '4715', '10', '85');
INSERT INTO public.who_global_data_import VALUES (8319, '2020-11-16', 'BZ', 'Belize', 'AMRO', '68', '4783', '3', '88');
INSERT INTO public.who_global_data_import VALUES (8320, '2020-11-17', 'BZ', 'Belize', 'AMRO', '78', '4861', '2', '90');
INSERT INTO public.who_global_data_import VALUES (8321, '2020-11-18', 'BZ', 'Belize', 'AMRO', '22', '4883', '4', '94');
INSERT INTO public.who_global_data_import VALUES (8322, '2020-11-19', 'BZ', 'Belize', 'AMRO', '37', '4920', '2', '96');
INSERT INTO public.who_global_data_import VALUES (8323, '2020-11-20', 'BZ', 'Belize', 'AMRO', '38', '4958', '4', '100');
INSERT INTO public.who_global_data_import VALUES (8324, '2020-11-21', 'BZ', 'Belize', 'AMRO', '60', '5018', '2', '102');
INSERT INTO public.who_global_data_import VALUES (8325, '2020-11-22', 'BZ', 'Belize', 'AMRO', '38', '5056', '5', '107');
INSERT INTO public.who_global_data_import VALUES (8326, '2020-11-23', 'BZ', 'Belize', 'AMRO', '54', '5110', '5', '112');
INSERT INTO public.who_global_data_import VALUES (8327, '2020-11-24', 'BZ', 'Belize', 'AMRO', '73', '5183', '4', '116');
INSERT INTO public.who_global_data_import VALUES (8328, '2020-11-25', 'BZ', 'Belize', 'AMRO', '66', '5249', '4', '120');
INSERT INTO public.who_global_data_import VALUES (8329, '2020-11-26', 'BZ', 'Belize', 'AMRO', '86', '5335', '5', '125');
INSERT INTO public.who_global_data_import VALUES (8330, '2020-11-27', 'BZ', 'Belize', 'AMRO', '88', '5423', '4', '129');
INSERT INTO public.who_global_data_import VALUES (8331, '2020-11-28', 'BZ', 'Belize', 'AMRO', '92', '5515', '2', '131');
INSERT INTO public.who_global_data_import VALUES (8332, '2020-11-29', 'BZ', 'Belize', 'AMRO', '72', '5587', '10', '141');
INSERT INTO public.who_global_data_import VALUES (8333, '2020-11-30', 'BZ', 'Belize', 'AMRO', '60', '5647', '3', '144');
INSERT INTO public.who_global_data_import VALUES (8334, '2020-12-01', 'BZ', 'Belize', 'AMRO', '96', '5743', '3', '147');
INSERT INTO public.who_global_data_import VALUES (8335, '2020-12-02', 'BZ', 'Belize', 'AMRO', '111', '5854', '1', '148');
INSERT INTO public.who_global_data_import VALUES (8336, '2020-12-03', 'BZ', 'Belize', 'AMRO', '0', '5854', '0', '148');
INSERT INTO public.who_global_data_import VALUES (8337, '2020-12-04', 'BZ', 'Belize', 'AMRO', '1141', '6995', '12', '160');
INSERT INTO public.who_global_data_import VALUES (8338, '2020-12-05', 'BZ', 'Belize', 'AMRO', '241', '7236', '4', '164');
INSERT INTO public.who_global_data_import VALUES (8339, '2020-12-06', 'BZ', 'Belize', 'AMRO', '147', '7383', '6', '170');
INSERT INTO public.who_global_data_import VALUES (8340, '2020-12-07', 'BZ', 'Belize', 'AMRO', '218', '7601', '2', '172');
INSERT INTO public.who_global_data_import VALUES (8341, '2020-12-08', 'BZ', 'Belize', 'AMRO', '168', '7769', '1', '173');
INSERT INTO public.who_global_data_import VALUES (8342, '2020-12-09', 'BZ', 'Belize', 'AMRO', '184', '7953', '3', '176');
INSERT INTO public.who_global_data_import VALUES (8343, '2020-12-10', 'BZ', 'Belize', 'AMRO', '60', '8013', '3', '179');
INSERT INTO public.who_global_data_import VALUES (8344, '2020-12-11', 'BZ', 'Belize', 'AMRO', '506', '8519', '4', '183');
INSERT INTO public.who_global_data_import VALUES (8345, '2020-12-12', 'BZ', 'Belize', 'AMRO', '286', '8805', '0', '183');
INSERT INTO public.who_global_data_import VALUES (8346, '2020-12-13', 'BZ', 'Belize', 'AMRO', '160', '8965', '2', '185');
INSERT INTO public.who_global_data_import VALUES (8347, '2020-12-14', 'BZ', 'Belize', 'AMRO', '208', '9173', '7', '192');
INSERT INTO public.who_global_data_import VALUES (8348, '2020-12-15', 'BZ', 'Belize', 'AMRO', '122', '9295', '3', '195');
INSERT INTO public.who_global_data_import VALUES (8349, '2020-12-16', 'BZ', 'Belize', 'AMRO', '82', '9377', '2', '197');
INSERT INTO public.who_global_data_import VALUES (8350, '2020-12-17', 'BZ', 'Belize', 'AMRO', '134', '9511', '14', '211');
INSERT INTO public.who_global_data_import VALUES (8351, '2020-12-18', 'BZ', 'Belize', 'AMRO', '161', '9672', '1', '212');
INSERT INTO public.who_global_data_import VALUES (8352, '2020-12-19', 'BZ', 'Belize', 'AMRO', '119', '9791', '1', '213');
INSERT INTO public.who_global_data_import VALUES (8353, '2020-12-20', 'BZ', 'Belize', 'AMRO', '138', '9929', '2', '215');
INSERT INTO public.who_global_data_import VALUES (8354, '2020-12-21', 'BZ', 'Belize', 'AMRO', '94', '10023', '1', '216');
INSERT INTO public.who_global_data_import VALUES (8355, '2020-12-22', 'BZ', 'Belize', 'AMRO', '72', '10095', '4', '220');
INSERT INTO public.who_global_data_import VALUES (8356, '2020-12-23', 'BZ', 'Belize', 'AMRO', '50', '10145', '4', '224');
INSERT INTO public.who_global_data_import VALUES (8357, '2020-12-24', 'BZ', 'Belize', 'AMRO', '112', '10257', '2', '226');
INSERT INTO public.who_global_data_import VALUES (8358, '2020-12-25', 'BZ', 'Belize', 'AMRO', '113', '10370', '0', '226');
INSERT INTO public.who_global_data_import VALUES (8359, '2020-12-26', 'BZ', 'Belize', 'AMRO', '120', '10490', '2', '228');
INSERT INTO public.who_global_data_import VALUES (8360, '2020-12-27', 'BZ', 'Belize', 'AMRO', '0', '10490', '0', '228');
INSERT INTO public.who_global_data_import VALUES (8361, '2020-12-28', 'BZ', 'Belize', 'AMRO', '0', '10490', '0', '228');
INSERT INTO public.who_global_data_import VALUES (8362, '2020-12-29', 'BZ', 'Belize', 'AMRO', '71', '10561', '5', '233');
INSERT INTO public.who_global_data_import VALUES (8363, '2020-12-30', 'BZ', 'Belize', 'AMRO', '30', '10591', '3', '236');
INSERT INTO public.who_global_data_import VALUES (8364, '2020-12-31', 'BZ', 'Belize', 'AMRO', '77', '10668', '5', '241');
INSERT INTO public.who_global_data_import VALUES (8365, '2021-01-01', 'BZ', 'Belize', 'AMRO', '56', '10724', '1', '242');
INSERT INTO public.who_global_data_import VALUES (8366, '2021-01-02', 'BZ', 'Belize', 'AMRO', '52', '10776', '6', '248');
INSERT INTO public.who_global_data_import VALUES (8367, '2021-01-03', 'BZ', 'Belize', 'AMRO', '31', '10807', '1', '249');
INSERT INTO public.who_global_data_import VALUES (8368, '2021-01-04', 'BZ', 'Belize', 'AMRO', '0', '10807', '0', '249');
INSERT INTO public.who_global_data_import VALUES (8369, '2021-01-05', 'BZ', 'Belize', 'AMRO', '94', '10901', '1', '250');
INSERT INTO public.who_global_data_import VALUES (8370, '2021-01-06', 'BZ', 'Belize', 'AMRO', '37', '10938', '7', '257');
INSERT INTO public.who_global_data_import VALUES (8371, '2021-01-07', 'BZ', 'Belize', 'AMRO', '80', '11018', '1', '258');
INSERT INTO public.who_global_data_import VALUES (8372, '2021-01-08', 'BZ', 'Belize', 'AMRO', '90', '11108', '2', '260');
INSERT INTO public.who_global_data_import VALUES (8373, '2021-01-09', 'BZ', 'Belize', 'AMRO', '44', '11152', '7', '267');
INSERT INTO public.who_global_data_import VALUES (8374, '2021-01-10', 'BZ', 'Belize', 'AMRO', '50', '11202', '4', '271');
INSERT INTO public.who_global_data_import VALUES (8375, '2021-01-11', 'BZ', 'Belize', 'AMRO', '64', '11266', '0', '271');
INSERT INTO public.who_global_data_import VALUES (8376, '2021-01-12', 'BZ', 'Belize', 'AMRO', '37', '11303', '3', '274');
INSERT INTO public.who_global_data_import VALUES (8377, '2021-01-13', 'BZ', 'Belize', 'AMRO', '29', '11332', '1', '275');
INSERT INTO public.who_global_data_import VALUES (8378, '2021-01-14', 'BZ', 'Belize', 'AMRO', '34', '11366', '2', '277');
INSERT INTO public.who_global_data_import VALUES (8379, '2021-01-15', 'BZ', 'Belize', 'AMRO', '53', '11419', '1', '278');
INSERT INTO public.who_global_data_import VALUES (8380, '2021-01-16', 'BZ', 'Belize', 'AMRO', '37', '11456', '2', '280');
INSERT INTO public.who_global_data_import VALUES (8381, '2021-01-17', 'BZ', 'Belize', 'AMRO', '73', '11529', '1', '281');
INSERT INTO public.who_global_data_import VALUES (8382, '2021-01-18', 'BZ', 'Belize', 'AMRO', '0', '11529', '0', '281');
INSERT INTO public.who_global_data_import VALUES (8383, '2021-01-19', 'BZ', 'Belize', 'AMRO', '51', '11580', '0', '281');
INSERT INTO public.who_global_data_import VALUES (8384, '2021-01-20', 'BZ', 'Belize', 'AMRO', '12', '11592', '1', '282');
INSERT INTO public.who_global_data_import VALUES (8385, '2021-01-21', 'BZ', 'Belize', 'AMRO', '23', '11615', '1', '283');
INSERT INTO public.who_global_data_import VALUES (8386, '2021-01-22', 'BZ', 'Belize', 'AMRO', '27', '11642', '3', '286');
INSERT INTO public.who_global_data_import VALUES (8387, '2021-01-23', 'BZ', 'Belize', 'AMRO', '34', '11676', '3', '289');
INSERT INTO public.who_global_data_import VALUES (8388, '2021-01-24', 'BZ', 'Belize', 'AMRO', '24', '11700', '1', '290');
INSERT INTO public.who_global_data_import VALUES (8389, '2021-01-25', 'BZ', 'Belize', 'AMRO', '22', '11722', '0', '290');
INSERT INTO public.who_global_data_import VALUES (8390, '2021-01-26', 'BZ', 'Belize', 'AMRO', '28', '11750', '0', '290');
INSERT INTO public.who_global_data_import VALUES (8391, '2021-01-27', 'BZ', 'Belize', 'AMRO', '20', '11770', '3', '293');
INSERT INTO public.who_global_data_import VALUES (8392, '2021-01-28', 'BZ', 'Belize', 'AMRO', '18', '11788', '0', '293');
INSERT INTO public.who_global_data_import VALUES (8393, '2021-01-29', 'BZ', 'Belize', 'AMRO', '28', '11816', '1', '294');
INSERT INTO public.who_global_data_import VALUES (8394, '2021-01-30', 'BZ', 'Belize', 'AMRO', '29', '11845', '4', '298');
INSERT INTO public.who_global_data_import VALUES (8395, '2021-01-31', 'BZ', 'Belize', 'AMRO', '32', '11877', '3', '301');
INSERT INTO public.who_global_data_import VALUES (8396, '2021-02-01', 'BZ', 'Belize', 'AMRO', '31', '11908', '0', '301');
INSERT INTO public.who_global_data_import VALUES (8397, '2021-02-02', 'BZ', 'Belize', 'AMRO', '0', '11908', '0', '301');
INSERT INTO public.who_global_data_import VALUES (8398, '2021-02-03', 'BZ', 'Belize', 'AMRO', '37', '11945', '1', '302');
INSERT INTO public.who_global_data_import VALUES (8399, '2021-02-04', 'BZ', 'Belize', 'AMRO', '12', '11957', '1', '303');
INSERT INTO public.who_global_data_import VALUES (8400, '2021-02-05', 'BZ', 'Belize', 'AMRO', '21', '11978', '3', '306');
INSERT INTO public.who_global_data_import VALUES (8401, '2020-01-03', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8402, '2020-01-04', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8403, '2020-01-05', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8404, '2020-01-06', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8405, '2020-01-07', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8406, '2020-01-08', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8407, '2020-01-09', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8409, '2020-01-11', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8410, '2020-01-12', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8411, '2020-01-13', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8412, '2020-01-14', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8413, '2020-01-15', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8414, '2020-01-16', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8415, '2020-01-17', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8416, '2020-01-18', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8417, '2020-01-19', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8418, '2020-01-20', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8419, '2020-01-21', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8420, '2020-01-22', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8421, '2020-01-23', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8422, '2020-01-24', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8423, '2020-01-25', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8424, '2020-01-26', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8425, '2020-01-27', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8426, '2020-01-28', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8427, '2020-01-29', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8428, '2020-01-30', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8429, '2020-01-31', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8430, '2020-02-01', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8431, '2020-02-02', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8432, '2020-02-03', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8433, '2020-02-04', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8434, '2020-02-05', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8435, '2020-02-06', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8436, '2020-02-07', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8437, '2020-02-08', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8438, '2020-02-09', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8439, '2020-02-10', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8440, '2020-02-11', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8441, '2020-02-12', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8442, '2020-02-13', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8443, '2020-02-14', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8444, '2020-02-15', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8445, '2020-02-16', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8446, '2020-02-17', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8447, '2020-02-18', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8448, '2020-02-19', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8449, '2020-02-20', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8450, '2020-02-21', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8451, '2020-02-22', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8452, '2020-02-23', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8453, '2020-02-24', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8454, '2020-02-25', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8455, '2020-02-26', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8456, '2020-02-27', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8457, '2020-02-28', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8458, '2020-02-29', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8459, '2020-03-01', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8460, '2020-03-02', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8461, '2020-03-03', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8462, '2020-03-04', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8463, '2020-03-05', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8464, '2020-03-06', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8465, '2020-03-07', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8466, '2020-03-08', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8467, '2020-03-09', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8468, '2020-03-10', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8469, '2020-03-11', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8470, '2020-03-12', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8471, '2020-03-13', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8472, '2020-03-14', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8473, '2020-03-15', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8474, '2020-03-16', 'BJ', 'Benin', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8475, '2020-03-17', 'BJ', 'Benin', 'AFRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8476, '2020-03-18', 'BJ', 'Benin', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8477, '2020-03-19', 'BJ', 'Benin', 'AFRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8478, '2020-03-20', 'BJ', 'Benin', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8479, '2020-03-21', 'BJ', 'Benin', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8480, '2020-03-22', 'BJ', 'Benin', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8481, '2020-03-23', 'BJ', 'Benin', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8482, '2020-03-24', 'BJ', 'Benin', 'AFRO', '3', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8483, '2020-03-25', 'BJ', 'Benin', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8484, '2020-03-26', 'BJ', 'Benin', 'AFRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8485, '2020-03-27', 'BJ', 'Benin', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8486, '2020-03-28', 'BJ', 'Benin', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8487, '2020-03-29', 'BJ', 'Benin', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8488, '2020-03-30', 'BJ', 'Benin', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8489, '2020-03-31', 'BJ', 'Benin', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8490, '2020-04-01', 'BJ', 'Benin', 'AFRO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8491, '2020-04-02', 'BJ', 'Benin', 'AFRO', '4', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8492, '2020-04-03', 'BJ', 'Benin', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8493, '2020-04-04', 'BJ', 'Benin', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8494, '2020-04-05', 'BJ', 'Benin', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8495, '2020-04-06', 'BJ', 'Benin', 'AFRO', '9', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8496, '2020-04-07', 'BJ', 'Benin', 'AFRO', '1', '23', '1', '1');
INSERT INTO public.who_global_data_import VALUES (8497, '2020-04-08', 'BJ', 'Benin', 'AFRO', '3', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8498, '2020-04-09', 'BJ', 'Benin', 'AFRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8499, '2020-04-10', 'BJ', 'Benin', 'AFRO', '4', '30', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8500, '2020-04-11', 'BJ', 'Benin', 'AFRO', '0', '30', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8501, '2020-04-12', 'BJ', 'Benin', 'AFRO', '5', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8502, '2020-04-13', 'BJ', 'Benin', 'AFRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8503, '2020-04-14', 'BJ', 'Benin', 'AFRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8504, '2020-04-15', 'BJ', 'Benin', 'AFRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8505, '2020-04-16', 'BJ', 'Benin', 'AFRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8506, '2020-04-17', 'BJ', 'Benin', 'AFRO', '2', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8507, '2020-04-18', 'BJ', 'Benin', 'AFRO', '0', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8508, '2020-04-19', 'BJ', 'Benin', 'AFRO', '0', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8509, '2020-04-20', 'BJ', 'Benin', 'AFRO', '0', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8510, '2020-04-21', 'BJ', 'Benin', 'AFRO', '17', '54', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8511, '2020-04-22', 'BJ', 'Benin', 'AFRO', '0', '54', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8512, '2020-04-23', 'BJ', 'Benin', 'AFRO', '0', '54', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8513, '2020-04-24', 'BJ', 'Benin', 'AFRO', '4', '58', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8514, '2020-04-25', 'BJ', 'Benin', 'AFRO', '0', '58', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8515, '2020-04-26', 'BJ', 'Benin', 'AFRO', '0', '58', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8516, '2020-04-27', 'BJ', 'Benin', 'AFRO', '6', '64', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8517, '2020-04-28', 'BJ', 'Benin', 'AFRO', '0', '64', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8518, '2020-04-29', 'BJ', 'Benin', 'AFRO', '0', '64', '0', '1');
INSERT INTO public.who_global_data_import VALUES (8519, '2020-04-30', 'BJ', 'Benin', 'AFRO', '5', '69', '1', '2');
INSERT INTO public.who_global_data_import VALUES (8520, '2020-05-01', 'BJ', 'Benin', 'AFRO', '15', '84', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8521, '2020-05-02', 'BJ', 'Benin', 'AFRO', '6', '90', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8522, '2020-05-03', 'BJ', 'Benin', 'AFRO', '0', '90', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8523, '2020-05-04', 'BJ', 'Benin', 'AFRO', '0', '90', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8524, '2020-05-05', 'BJ', 'Benin', 'AFRO', '6', '96', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8525, '2020-05-06', 'BJ', 'Benin', 'AFRO', '6', '102', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8526, '2020-05-07', 'BJ', 'Benin', 'AFRO', '0', '102', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8527, '2020-05-08', 'BJ', 'Benin', 'AFRO', '38', '140', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8528, '2020-05-09', 'BJ', 'Benin', 'AFRO', '102', '242', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8529, '2020-05-10', 'BJ', 'Benin', 'AFRO', '42', '284', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8530, '2020-05-11', 'BJ', 'Benin', 'AFRO', '35', '319', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8531, '2020-05-12', 'BJ', 'Benin', 'AFRO', '0', '319', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8532, '2020-05-13', 'BJ', 'Benin', 'AFRO', '8', '327', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8533, '2020-05-14', 'BJ', 'Benin', 'AFRO', '0', '327', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8534, '2020-05-15', 'BJ', 'Benin', 'AFRO', '12', '339', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8535, '2020-05-16', 'BJ', 'Benin', 'AFRO', '0', '339', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8536, '2020-05-17', 'BJ', 'Benin', 'AFRO', '0', '339', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8537, '2020-05-18', 'BJ', 'Benin', 'AFRO', '0', '339', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8538, '2020-05-19', 'BJ', 'Benin', 'AFRO', '-210', '129', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8539, '2020-05-20', 'BJ', 'Benin', 'AFRO', '1', '130', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8540, '2020-05-21', 'BJ', 'Benin', 'AFRO', '0', '130', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8541, '2020-05-22', 'BJ', 'Benin', 'AFRO', '5', '135', '1', '3');
INSERT INTO public.who_global_data_import VALUES (8542, '2020-05-23', 'BJ', 'Benin', 'AFRO', '0', '135', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8543, '2020-05-24', 'BJ', 'Benin', 'AFRO', '0', '135', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8544, '2020-05-25', 'BJ', 'Benin', 'AFRO', '56', '191', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8545, '2020-05-26', 'BJ', 'Benin', 'AFRO', '0', '191', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8546, '2020-05-27', 'BJ', 'Benin', 'AFRO', '17', '208', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8547, '2020-05-28', 'BJ', 'Benin', 'AFRO', '2', '210', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8548, '2020-05-29', 'BJ', 'Benin', 'AFRO', '8', '218', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8549, '2020-05-30', 'BJ', 'Benin', 'AFRO', '0', '218', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8550, '2020-05-31', 'BJ', 'Benin', 'AFRO', '14', '232', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8551, '2020-06-01', 'BJ', 'Benin', 'AFRO', '0', '232', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8552, '2020-06-02', 'BJ', 'Benin', 'AFRO', '11', '243', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8553, '2020-06-03', 'BJ', 'Benin', 'AFRO', '1', '244', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8554, '2020-06-04', 'BJ', 'Benin', 'AFRO', '0', '244', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8555, '2020-06-05', 'BJ', 'Benin', 'AFRO', '17', '261', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8556, '2020-06-06', 'BJ', 'Benin', 'AFRO', '0', '261', '0', '3');
INSERT INTO public.who_global_data_import VALUES (8557, '2020-06-07', 'BJ', 'Benin', 'AFRO', '7', '268', '1', '4');
INSERT INTO public.who_global_data_import VALUES (8558, '2020-06-08', 'BJ', 'Benin', 'AFRO', '0', '268', '0', '4');
INSERT INTO public.who_global_data_import VALUES (8559, '2020-06-09', 'BJ', 'Benin', 'AFRO', '37', '305', '0', '4');
INSERT INTO public.who_global_data_import VALUES (8560, '2020-06-10', 'BJ', 'Benin', 'AFRO', '34', '339', '0', '4');
INSERT INTO public.who_global_data_import VALUES (8561, '2020-06-11', 'BJ', 'Benin', 'AFRO', '0', '339', '0', '4');
INSERT INTO public.who_global_data_import VALUES (8562, '2020-06-12', 'BJ', 'Benin', 'AFRO', '51', '390', '1', '5');
INSERT INTO public.who_global_data_import VALUES (8563, '2020-06-13', 'BJ', 'Benin', 'AFRO', '22', '412', '1', '6');
INSERT INTO public.who_global_data_import VALUES (8564, '2020-06-14', 'BJ', 'Benin', 'AFRO', '0', '412', '0', '6');
INSERT INTO public.who_global_data_import VALUES (8565, '2020-06-15', 'BJ', 'Benin', 'AFRO', '58', '470', '1', '7');
INSERT INTO public.who_global_data_import VALUES (8566, '2020-06-16', 'BJ', 'Benin', 'AFRO', '13', '483', '2', '9');
INSERT INTO public.who_global_data_import VALUES (8567, '2020-06-17', 'BJ', 'Benin', 'AFRO', '49', '532', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8568, '2020-06-18', 'BJ', 'Benin', 'AFRO', '40', '572', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8569, '2020-06-19', 'BJ', 'Benin', 'AFRO', '25', '597', '2', '11');
INSERT INTO public.who_global_data_import VALUES (8570, '2020-06-20', 'BJ', 'Benin', 'AFRO', '53', '650', '0', '11');
INSERT INTO public.who_global_data_import VALUES (8571, '2020-06-21', 'BJ', 'Benin', 'AFRO', '0', '650', '0', '11');
INSERT INTO public.who_global_data_import VALUES (8572, '2020-06-22', 'BJ', 'Benin', 'AFRO', '115', '765', '2', '13');
INSERT INTO public.who_global_data_import VALUES (8573, '2020-06-23', 'BJ', 'Benin', 'AFRO', '42', '807', '0', '13');
INSERT INTO public.who_global_data_import VALUES (8574, '2020-06-24', 'BJ', 'Benin', 'AFRO', '43', '850', '0', '13');
INSERT INTO public.who_global_data_import VALUES (8575, '2020-06-25', 'BJ', 'Benin', 'AFRO', '52', '902', '0', '13');
INSERT INTO public.who_global_data_import VALUES (8576, '2020-06-26', 'BJ', 'Benin', 'AFRO', '115', '1017', '1', '14');
INSERT INTO public.who_global_data_import VALUES (8577, '2020-06-27', 'BJ', 'Benin', 'AFRO', '36', '1053', '0', '14');
INSERT INTO public.who_global_data_import VALUES (8578, '2020-06-28', 'BJ', 'Benin', 'AFRO', '71', '1124', '0', '14');
INSERT INTO public.who_global_data_import VALUES (8579, '2020-06-29', 'BJ', 'Benin', 'AFRO', '25', '1149', '2', '16');
INSERT INTO public.who_global_data_import VALUES (8580, '2020-06-30', 'BJ', 'Benin', 'AFRO', '38', '1187', '3', '19');
INSERT INTO public.who_global_data_import VALUES (8581, '2020-07-01', 'BJ', 'Benin', 'AFRO', '12', '1199', '2', '21');
INSERT INTO public.who_global_data_import VALUES (8582, '2020-07-02', 'BJ', 'Benin', 'AFRO', '0', '1199', '0', '21');
INSERT INTO public.who_global_data_import VALUES (8583, '2020-07-03', 'BJ', 'Benin', 'AFRO', '0', '1199', '0', '21');
INSERT INTO public.who_global_data_import VALUES (8584, '2020-07-04', 'BJ', 'Benin', 'AFRO', '0', '1199', '0', '21');
INSERT INTO public.who_global_data_import VALUES (8585, '2020-07-05', 'BJ', 'Benin', 'AFRO', '0', '1199', '0', '21');
INSERT INTO public.who_global_data_import VALUES (8586, '2020-07-06', 'BJ', 'Benin', 'AFRO', '0', '1199', '0', '21');
INSERT INTO public.who_global_data_import VALUES (8587, '2020-07-07', 'BJ', 'Benin', 'AFRO', '0', '1199', '0', '21');
INSERT INTO public.who_global_data_import VALUES (8588, '2020-07-08', 'BJ', 'Benin', 'AFRO', '86', '1285', '2', '23');
INSERT INTO public.who_global_data_import VALUES (8589, '2020-07-09', 'BJ', 'Benin', 'AFRO', '0', '1285', '0', '23');
INSERT INTO public.who_global_data_import VALUES (8590, '2020-07-10', 'BJ', 'Benin', 'AFRO', '0', '1285', '0', '23');
INSERT INTO public.who_global_data_import VALUES (8591, '2020-07-11', 'BJ', 'Benin', 'AFRO', '0', '1285', '0', '23');
INSERT INTO public.who_global_data_import VALUES (8592, '2020-07-12', 'BJ', 'Benin', 'AFRO', '93', '1378', '3', '26');
INSERT INTO public.who_global_data_import VALUES (8593, '2020-07-13', 'BJ', 'Benin', 'AFRO', '0', '1378', '0', '26');
INSERT INTO public.who_global_data_import VALUES (8594, '2020-07-14', 'BJ', 'Benin', 'AFRO', '0', '1378', '0', '26');
INSERT INTO public.who_global_data_import VALUES (8595, '2020-07-15', 'BJ', 'Benin', 'AFRO', '85', '1463', '2', '28');
INSERT INTO public.who_global_data_import VALUES (8596, '2020-07-16', 'BJ', 'Benin', 'AFRO', '0', '1463', '0', '28');
INSERT INTO public.who_global_data_import VALUES (8597, '2020-07-17', 'BJ', 'Benin', 'AFRO', '0', '1463', '0', '28');
INSERT INTO public.who_global_data_import VALUES (8598, '2020-07-18', 'BJ', 'Benin', 'AFRO', '139', '1602', '3', '31');
INSERT INTO public.who_global_data_import VALUES (8599, '2020-07-19', 'BJ', 'Benin', 'AFRO', '0', '1602', '0', '31');
INSERT INTO public.who_global_data_import VALUES (8600, '2020-07-20', 'BJ', 'Benin', 'AFRO', '0', '1602', '0', '31');
INSERT INTO public.who_global_data_import VALUES (8601, '2020-07-21', 'BJ', 'Benin', 'AFRO', '0', '1602', '0', '31');
INSERT INTO public.who_global_data_import VALUES (8602, '2020-07-22', 'BJ', 'Benin', 'AFRO', '88', '1690', '3', '34');
INSERT INTO public.who_global_data_import VALUES (8603, '2020-07-23', 'BJ', 'Benin', 'AFRO', '0', '1690', '0', '34');
INSERT INTO public.who_global_data_import VALUES (8604, '2020-07-24', 'BJ', 'Benin', 'AFRO', '4', '1694', '0', '34');
INSERT INTO public.who_global_data_import VALUES (8605, '2020-07-25', 'BJ', 'Benin', 'AFRO', '0', '1694', '0', '34');
INSERT INTO public.who_global_data_import VALUES (8606, '2020-07-26', 'BJ', 'Benin', 'AFRO', '0', '1694', '0', '34');
INSERT INTO public.who_global_data_import VALUES (8607, '2020-07-27', 'BJ', 'Benin', 'AFRO', '76', '1770', '1', '35');
INSERT INTO public.who_global_data_import VALUES (8608, '2020-07-28', 'BJ', 'Benin', 'AFRO', '0', '1770', '0', '35');
INSERT INTO public.who_global_data_import VALUES (8609, '2020-07-29', 'BJ', 'Benin', 'AFRO', '35', '1805', '1', '36');
INSERT INTO public.who_global_data_import VALUES (8610, '2020-07-30', 'BJ', 'Benin', 'AFRO', '0', '1805', '0', '36');
INSERT INTO public.who_global_data_import VALUES (8611, '2020-07-31', 'BJ', 'Benin', 'AFRO', '0', '1805', '0', '36');
INSERT INTO public.who_global_data_import VALUES (8612, '2020-08-01', 'BJ', 'Benin', 'AFRO', '0', '1805', '0', '36');
INSERT INTO public.who_global_data_import VALUES (8613, '2020-08-02', 'BJ', 'Benin', 'AFRO', '0', '1805', '0', '36');
INSERT INTO public.who_global_data_import VALUES (8614, '2020-08-03', 'BJ', 'Benin', 'AFRO', '0', '1805', '0', '36');
INSERT INTO public.who_global_data_import VALUES (8615, '2020-08-04', 'BJ', 'Benin', 'AFRO', '109', '1914', '2', '38');
INSERT INTO public.who_global_data_import VALUES (8616, '2020-08-05', 'BJ', 'Benin', 'AFRO', '22', '1936', '0', '38');
INSERT INTO public.who_global_data_import VALUES (8617, '2020-08-06', 'BJ', 'Benin', 'AFRO', '0', '1936', '0', '38');
INSERT INTO public.who_global_data_import VALUES (8618, '2020-08-07', 'BJ', 'Benin', 'AFRO', '0', '1936', '0', '38');
INSERT INTO public.who_global_data_import VALUES (8619, '2020-08-08', 'BJ', 'Benin', 'AFRO', '0', '1936', '0', '38');
INSERT INTO public.who_global_data_import VALUES (8620, '2020-08-09', 'BJ', 'Benin', 'AFRO', '0', '1936', '0', '38');
INSERT INTO public.who_global_data_import VALUES (8621, '2020-08-10', 'BJ', 'Benin', 'AFRO', '0', '1936', '0', '38');
INSERT INTO public.who_global_data_import VALUES (8622, '2020-08-11', 'BJ', 'Benin', 'AFRO', '65', '2001', '0', '38');
INSERT INTO public.who_global_data_import VALUES (8623, '2020-08-12', 'BJ', 'Benin', 'AFRO', '13', '2014', '0', '38');
INSERT INTO public.who_global_data_import VALUES (8624, '2020-08-13', 'BJ', 'Benin', 'AFRO', '0', '2014', '0', '38');
INSERT INTO public.who_global_data_import VALUES (8625, '2020-08-14', 'BJ', 'Benin', 'AFRO', '0', '2014', '0', '38');
INSERT INTO public.who_global_data_import VALUES (8626, '2020-08-15', 'BJ', 'Benin', 'AFRO', '0', '2014', '0', '38');
INSERT INTO public.who_global_data_import VALUES (8627, '2020-08-16', 'BJ', 'Benin', 'AFRO', '49', '2063', '1', '39');
INSERT INTO public.who_global_data_import VALUES (8628, '2020-08-17', 'BJ', 'Benin', 'AFRO', '0', '2063', '0', '39');
INSERT INTO public.who_global_data_import VALUES (8629, '2020-08-18', 'BJ', 'Benin', 'AFRO', '0', '2063', '0', '39');
INSERT INTO public.who_global_data_import VALUES (8630, '2020-08-19', 'BJ', 'Benin', 'AFRO', '32', '2095', '0', '39');
INSERT INTO public.who_global_data_import VALUES (8631, '2020-08-20', 'BJ', 'Benin', 'AFRO', '0', '2095', '0', '39');
INSERT INTO public.who_global_data_import VALUES (8632, '2020-08-21', 'BJ', 'Benin', 'AFRO', '0', '2095', '0', '39');
INSERT INTO public.who_global_data_import VALUES (8633, '2020-08-22', 'BJ', 'Benin', 'AFRO', '20', '2115', '0', '39');
INSERT INTO public.who_global_data_import VALUES (8634, '2020-08-23', 'BJ', 'Benin', 'AFRO', '0', '2115', '0', '39');
INSERT INTO public.who_global_data_import VALUES (8635, '2020-08-24', 'BJ', 'Benin', 'AFRO', '0', '2115', '0', '39');
INSERT INTO public.who_global_data_import VALUES (8636, '2020-08-25', 'BJ', 'Benin', 'AFRO', '0', '2115', '0', '39');
INSERT INTO public.who_global_data_import VALUES (8637, '2020-08-26', 'BJ', 'Benin', 'AFRO', '30', '2145', '1', '40');
INSERT INTO public.who_global_data_import VALUES (8638, '2020-08-27', 'BJ', 'Benin', 'AFRO', '0', '2145', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8639, '2020-08-28', 'BJ', 'Benin', 'AFRO', '0', '2145', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8640, '2020-08-29', 'BJ', 'Benin', 'AFRO', '0', '2145', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8641, '2020-08-30', 'BJ', 'Benin', 'AFRO', '0', '2145', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8642, '2020-08-31', 'BJ', 'Benin', 'AFRO', '0', '2145', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8643, '2020-09-01', 'BJ', 'Benin', 'AFRO', '0', '2145', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8644, '2020-09-02', 'BJ', 'Benin', 'AFRO', '49', '2194', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8645, '2020-09-03', 'BJ', 'Benin', 'AFRO', '0', '2194', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8646, '2020-09-04', 'BJ', 'Benin', 'AFRO', '0', '2194', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8647, '2020-09-05', 'BJ', 'Benin', 'AFRO', '19', '2213', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8648, '2020-09-06', 'BJ', 'Benin', 'AFRO', '0', '2213', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8649, '2020-09-07', 'BJ', 'Benin', 'AFRO', '0', '2213', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8650, '2020-09-08', 'BJ', 'Benin', 'AFRO', '0', '2213', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8651, '2020-09-09', 'BJ', 'Benin', 'AFRO', '29', '2242', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8652, '2020-09-10', 'BJ', 'Benin', 'AFRO', '0', '2242', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8653, '2020-09-11', 'BJ', 'Benin', 'AFRO', '0', '2242', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8654, '2020-09-12', 'BJ', 'Benin', 'AFRO', '0', '2242', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8655, '2020-09-13', 'BJ', 'Benin', 'AFRO', '0', '2242', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8656, '2020-09-14', 'BJ', 'Benin', 'AFRO', '25', '2267', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8657, '2020-09-15', 'BJ', 'Benin', 'AFRO', '0', '2267', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8658, '2020-09-16', 'BJ', 'Benin', 'AFRO', '13', '2280', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8659, '2020-09-17', 'BJ', 'Benin', 'AFRO', '0', '2280', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8660, '2020-09-18', 'BJ', 'Benin', 'AFRO', '0', '2280', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8661, '2020-09-19', 'BJ', 'Benin', 'AFRO', '0', '2280', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8662, '2020-09-20', 'BJ', 'Benin', 'AFRO', '0', '2280', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8663, '2020-09-21', 'BJ', 'Benin', 'AFRO', '0', '2280', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8664, '2020-09-22', 'BJ', 'Benin', 'AFRO', '14', '2294', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8665, '2020-09-23', 'BJ', 'Benin', 'AFRO', '31', '2325', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8666, '2020-09-24', 'BJ', 'Benin', 'AFRO', '0', '2325', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8667, '2020-09-25', 'BJ', 'Benin', 'AFRO', '0', '2325', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8668, '2020-09-26', 'BJ', 'Benin', 'AFRO', '0', '2325', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8669, '2020-09-27', 'BJ', 'Benin', 'AFRO', '0', '2325', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8670, '2020-09-28', 'BJ', 'Benin', 'AFRO', '15', '2340', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8671, '2020-09-29', 'BJ', 'Benin', 'AFRO', '0', '2340', '0', '40');
INSERT INTO public.who_global_data_import VALUES (8672, '2020-09-30', 'BJ', 'Benin', 'AFRO', '17', '2357', '1', '41');
INSERT INTO public.who_global_data_import VALUES (8673, '2020-10-01', 'BJ', 'Benin', 'AFRO', '0', '2357', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8674, '2020-10-02', 'BJ', 'Benin', 'AFRO', '0', '2357', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8675, '2020-10-03', 'BJ', 'Benin', 'AFRO', '0', '2357', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8676, '2020-10-04', 'BJ', 'Benin', 'AFRO', '0', '2357', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8677, '2020-10-05', 'BJ', 'Benin', 'AFRO', '0', '2357', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8678, '2020-10-06', 'BJ', 'Benin', 'AFRO', '0', '2357', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8679, '2020-10-07', 'BJ', 'Benin', 'AFRO', '54', '2411', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8680, '2020-10-08', 'BJ', 'Benin', 'AFRO', '0', '2411', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8681, '2020-10-09', 'BJ', 'Benin', 'AFRO', '0', '2411', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8682, '2020-10-10', 'BJ', 'Benin', 'AFRO', '0', '2411', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8683, '2020-10-11', 'BJ', 'Benin', 'AFRO', '0', '2411', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8684, '2020-10-12', 'BJ', 'Benin', 'AFRO', '0', '2411', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8685, '2020-10-13', 'BJ', 'Benin', 'AFRO', '0', '2411', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8686, '2020-10-14', 'BJ', 'Benin', 'AFRO', '85', '2496', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8687, '2020-10-15', 'BJ', 'Benin', 'AFRO', '0', '2496', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8688, '2020-10-16', 'BJ', 'Benin', 'AFRO', '0', '2496', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8689, '2020-10-17', 'BJ', 'Benin', 'AFRO', '0', '2496', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8690, '2020-10-18', 'BJ', 'Benin', 'AFRO', '0', '2496', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8691, '2020-10-19', 'BJ', 'Benin', 'AFRO', '0', '2496', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8692, '2020-10-20', 'BJ', 'Benin', 'AFRO', '0', '2496', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8693, '2020-10-21', 'BJ', 'Benin', 'AFRO', '61', '2557', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8694, '2020-10-22', 'BJ', 'Benin', 'AFRO', '0', '2557', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8695, '2020-10-23', 'BJ', 'Benin', 'AFRO', '0', '2557', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8696, '2020-10-24', 'BJ', 'Benin', 'AFRO', '0', '2557', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8697, '2020-10-25', 'BJ', 'Benin', 'AFRO', '0', '2557', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8698, '2020-10-26', 'BJ', 'Benin', 'AFRO', '0', '2557', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8699, '2020-10-27', 'BJ', 'Benin', 'AFRO', '0', '2557', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8700, '2020-10-28', 'BJ', 'Benin', 'AFRO', '86', '2643', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8701, '2020-10-29', 'BJ', 'Benin', 'AFRO', '0', '2643', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8702, '2020-10-30', 'BJ', 'Benin', 'AFRO', '0', '2643', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8703, '2020-10-31', 'BJ', 'Benin', 'AFRO', '0', '2643', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8704, '2020-11-01', 'BJ', 'Benin', 'AFRO', '0', '2643', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8705, '2020-11-02', 'BJ', 'Benin', 'AFRO', '40', '2683', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8706, '2020-11-03', 'BJ', 'Benin', 'AFRO', '0', '2683', '0', '41');
INSERT INTO public.who_global_data_import VALUES (8707, '2020-11-04', 'BJ', 'Benin', 'AFRO', '62', '2745', '2', '43');
INSERT INTO public.who_global_data_import VALUES (8708, '2020-11-05', 'BJ', 'Benin', 'AFRO', '0', '2745', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8709, '2020-11-06', 'BJ', 'Benin', 'AFRO', '0', '2745', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8710, '2020-11-07', 'BJ', 'Benin', 'AFRO', '0', '2745', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8711, '2020-11-08', 'BJ', 'Benin', 'AFRO', '0', '2745', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8712, '2020-11-09', 'BJ', 'Benin', 'AFRO', '0', '2745', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8713, '2020-11-10', 'BJ', 'Benin', 'AFRO', '36', '2781', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8714, '2020-11-11', 'BJ', 'Benin', 'AFRO', '63', '2844', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8715, '2020-11-12', 'BJ', 'Benin', 'AFRO', '0', '2844', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8716, '2020-11-13', 'BJ', 'Benin', 'AFRO', '0', '2844', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8717, '2020-11-14', 'BJ', 'Benin', 'AFRO', '0', '2844', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8718, '2020-11-15', 'BJ', 'Benin', 'AFRO', '0', '2844', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8719, '2020-11-16', 'BJ', 'Benin', 'AFRO', '0', '2844', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8720, '2020-11-17', 'BJ', 'Benin', 'AFRO', '40', '2884', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8721, '2020-11-18', 'BJ', 'Benin', 'AFRO', '32', '2916', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8722, '2020-11-19', 'BJ', 'Benin', 'AFRO', '0', '2916', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8723, '2020-11-20', 'BJ', 'Benin', 'AFRO', '0', '2916', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8724, '2020-11-21', 'BJ', 'Benin', 'AFRO', '0', '2916', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8725, '2020-11-22', 'BJ', 'Benin', 'AFRO', '0', '2916', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8726, '2020-11-23', 'BJ', 'Benin', 'AFRO', '0', '2916', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8727, '2020-11-24', 'BJ', 'Benin', 'AFRO', '0', '2916', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8728, '2020-11-25', 'BJ', 'Benin', 'AFRO', '58', '2974', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8729, '2020-11-26', 'BJ', 'Benin', 'AFRO', '0', '2974', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8730, '2020-11-27', 'BJ', 'Benin', 'AFRO', '0', '2974', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8731, '2020-11-28', 'BJ', 'Benin', 'AFRO', '0', '2974', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8732, '2020-11-29', 'BJ', 'Benin', 'AFRO', '0', '2974', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8733, '2020-11-30', 'BJ', 'Benin', 'AFRO', '0', '2974', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8734, '2020-12-01', 'BJ', 'Benin', 'AFRO', '41', '3015', '0', '43');
INSERT INTO public.who_global_data_import VALUES (8735, '2020-12-02', 'BJ', 'Benin', 'AFRO', '40', '3055', '1', '44');
INSERT INTO public.who_global_data_import VALUES (8736, '2020-12-03', 'BJ', 'Benin', 'AFRO', '0', '3055', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8737, '2020-12-04', 'BJ', 'Benin', 'AFRO', '0', '3055', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8738, '2020-12-05', 'BJ', 'Benin', 'AFRO', '0', '3055', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8739, '2020-12-06', 'BJ', 'Benin', 'AFRO', '0', '3055', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8740, '2020-12-07', 'BJ', 'Benin', 'AFRO', '0', '3055', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8741, '2020-12-08', 'BJ', 'Benin', 'AFRO', '18', '3073', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8742, '2020-12-09', 'BJ', 'Benin', 'AFRO', '17', '3090', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8743, '2020-12-10', 'BJ', 'Benin', 'AFRO', '0', '3090', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8744, '2020-12-11', 'BJ', 'Benin', 'AFRO', '0', '3090', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8745, '2020-12-12', 'BJ', 'Benin', 'AFRO', '0', '3090', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8746, '2020-12-13', 'BJ', 'Benin', 'AFRO', '0', '3090', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8747, '2020-12-14', 'BJ', 'Benin', 'AFRO', '0', '3090', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8748, '2020-12-15', 'BJ', 'Benin', 'AFRO', '0', '3090', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8749, '2020-12-16', 'BJ', 'Benin', 'AFRO', '62', '3152', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8750, '2020-12-17', 'BJ', 'Benin', 'AFRO', '0', '3152', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8751, '2020-12-18', 'BJ', 'Benin', 'AFRO', '0', '3152', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8752, '2020-12-19', 'BJ', 'Benin', 'AFRO', '0', '3152', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8753, '2020-12-20', 'BJ', 'Benin', 'AFRO', '0', '3152', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8754, '2020-12-21', 'BJ', 'Benin', 'AFRO', '15', '3167', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8755, '2020-12-22', 'BJ', 'Benin', 'AFRO', '0', '3167', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8756, '2020-12-23', 'BJ', 'Benin', 'AFRO', '38', '3205', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8757, '2020-12-24', 'BJ', 'Benin', 'AFRO', '0', '3205', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8758, '2020-12-25', 'BJ', 'Benin', 'AFRO', '0', '3205', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8759, '2020-12-26', 'BJ', 'Benin', 'AFRO', '0', '3205', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8760, '2020-12-27', 'BJ', 'Benin', 'AFRO', '0', '3205', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8761, '2020-12-28', 'BJ', 'Benin', 'AFRO', '0', '3205', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8762, '2020-12-29', 'BJ', 'Benin', 'AFRO', '0', '3205', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8763, '2020-12-30', 'BJ', 'Benin', 'AFRO', '46', '3251', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8764, '2020-12-31', 'BJ', 'Benin', 'AFRO', '0', '3251', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8765, '2021-01-01', 'BJ', 'Benin', 'AFRO', '0', '3251', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8766, '2021-01-02', 'BJ', 'Benin', 'AFRO', '0', '3251', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8767, '2021-01-03', 'BJ', 'Benin', 'AFRO', '0', '3251', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8768, '2021-01-04', 'BJ', 'Benin', 'AFRO', '0', '3251', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8769, '2021-01-05', 'BJ', 'Benin', 'AFRO', '0', '3251', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8770, '2021-01-06', 'BJ', 'Benin', 'AFRO', '53', '3304', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8771, '2021-01-07', 'BJ', 'Benin', 'AFRO', '0', '3304', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8772, '2021-01-08', 'BJ', 'Benin', 'AFRO', '0', '3304', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8773, '2021-01-09', 'BJ', 'Benin', 'AFRO', '0', '3304', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8774, '2021-01-10', 'BJ', 'Benin', 'AFRO', '0', '3304', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8775, '2021-01-11', 'BJ', 'Benin', 'AFRO', '0', '3304', '0', '44');
INSERT INTO public.who_global_data_import VALUES (8776, '2021-01-12', 'BJ', 'Benin', 'AFRO', '59', '3363', '2', '46');
INSERT INTO public.who_global_data_import VALUES (8777, '2021-01-13', 'BJ', 'Benin', 'AFRO', '50', '3413', '0', '46');
INSERT INTO public.who_global_data_import VALUES (8778, '2021-01-14', 'BJ', 'Benin', 'AFRO', '0', '3413', '0', '46');
INSERT INTO public.who_global_data_import VALUES (8779, '2021-01-15', 'BJ', 'Benin', 'AFRO', '0', '3413', '0', '46');
INSERT INTO public.who_global_data_import VALUES (8780, '2021-01-16', 'BJ', 'Benin', 'AFRO', '0', '3413', '0', '46');
INSERT INTO public.who_global_data_import VALUES (8781, '2021-01-17', 'BJ', 'Benin', 'AFRO', '0', '3413', '0', '46');
INSERT INTO public.who_global_data_import VALUES (8782, '2021-01-18', 'BJ', 'Benin', 'AFRO', '0', '3413', '0', '46');
INSERT INTO public.who_global_data_import VALUES (8783, '2021-01-19', 'BJ', 'Benin', 'AFRO', '0', '3413', '0', '46');
INSERT INTO public.who_global_data_import VALUES (8784, '2021-01-20', 'BJ', 'Benin', 'AFRO', '169', '3582', '2', '48');
INSERT INTO public.who_global_data_import VALUES (8785, '2021-01-21', 'BJ', 'Benin', 'AFRO', '0', '3582', '0', '48');
INSERT INTO public.who_global_data_import VALUES (8786, '2021-01-22', 'BJ', 'Benin', 'AFRO', '0', '3582', '0', '48');
INSERT INTO public.who_global_data_import VALUES (8787, '2021-01-23', 'BJ', 'Benin', 'AFRO', '61', '3643', '0', '48');
INSERT INTO public.who_global_data_import VALUES (8788, '2021-01-24', 'BJ', 'Benin', 'AFRO', '0', '3643', '0', '48');
INSERT INTO public.who_global_data_import VALUES (8789, '2021-01-25', 'BJ', 'Benin', 'AFRO', '0', '3643', '0', '48');
INSERT INTO public.who_global_data_import VALUES (8790, '2021-01-26', 'BJ', 'Benin', 'AFRO', '0', '3643', '0', '48');
INSERT INTO public.who_global_data_import VALUES (8791, '2021-01-27', 'BJ', 'Benin', 'AFRO', '143', '3786', '0', '48');
INSERT INTO public.who_global_data_import VALUES (8792, '2021-01-28', 'BJ', 'Benin', 'AFRO', '0', '3786', '0', '48');
INSERT INTO public.who_global_data_import VALUES (8793, '2021-01-29', 'BJ', 'Benin', 'AFRO', '0', '3786', '0', '48');
INSERT INTO public.who_global_data_import VALUES (8794, '2021-01-30', 'BJ', 'Benin', 'AFRO', '0', '3786', '0', '48');
INSERT INTO public.who_global_data_import VALUES (8795, '2021-01-31', 'BJ', 'Benin', 'AFRO', '0', '3786', '0', '48');
INSERT INTO public.who_global_data_import VALUES (8796, '2021-02-01', 'BJ', 'Benin', 'AFRO', '107', '3893', '4', '52');
INSERT INTO public.who_global_data_import VALUES (8797, '2021-02-02', 'BJ', 'Benin', 'AFRO', '0', '3893', '0', '52');
INSERT INTO public.who_global_data_import VALUES (8798, '2021-02-03', 'BJ', 'Benin', 'AFRO', '226', '4119', '2', '54');
INSERT INTO public.who_global_data_import VALUES (8799, '2021-02-04', 'BJ', 'Benin', 'AFRO', '0', '4119', '0', '54');
INSERT INTO public.who_global_data_import VALUES (8800, '2021-02-05', 'BJ', 'Benin', 'AFRO', '0', '4119', '0', '54');
INSERT INTO public.who_global_data_import VALUES (8801, '2020-01-03', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8802, '2020-01-04', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8803, '2020-01-05', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8804, '2020-01-06', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8805, '2020-01-07', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8806, '2020-01-08', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8807, '2020-01-09', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8808, '2020-01-10', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8809, '2020-01-11', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8810, '2020-01-12', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8811, '2020-01-13', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8812, '2020-01-14', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8813, '2020-01-15', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8814, '2020-01-16', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8815, '2020-01-17', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8816, '2020-01-18', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8817, '2020-01-19', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8818, '2020-01-20', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8819, '2020-01-21', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8820, '2020-01-22', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8821, '2020-01-23', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8822, '2020-01-24', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8823, '2020-01-25', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8824, '2020-01-26', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8825, '2020-01-27', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8826, '2020-01-28', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8827, '2020-01-29', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8828, '2020-01-30', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8829, '2020-01-31', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8830, '2020-02-01', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8831, '2020-02-02', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8832, '2020-02-03', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8833, '2020-02-04', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8834, '2020-02-05', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8835, '2020-02-06', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8836, '2020-02-07', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8837, '2020-02-08', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8838, '2020-02-09', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8839, '2020-02-10', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8840, '2020-02-11', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8841, '2020-02-12', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8842, '2020-02-13', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8843, '2020-02-14', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8844, '2020-02-15', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8845, '2020-02-16', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8846, '2020-02-17', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8847, '2020-02-18', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8848, '2020-02-19', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8849, '2020-02-20', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8850, '2020-02-21', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8851, '2020-02-22', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8852, '2020-02-23', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8853, '2020-02-24', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8854, '2020-02-25', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8855, '2020-02-26', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8856, '2020-02-27', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8857, '2020-02-28', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8858, '2020-02-29', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8859, '2020-03-01', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8860, '2020-03-02', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8861, '2020-03-03', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8862, '2020-03-04', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8863, '2020-03-05', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8864, '2020-03-06', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8865, '2020-03-07', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8866, '2020-03-08', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8867, '2020-03-09', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8868, '2020-03-10', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8869, '2020-03-11', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8870, '2020-03-12', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8871, '2020-03-13', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8872, '2020-03-14', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8873, '2020-03-15', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8874, '2020-03-16', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8875, '2020-03-17', 'BM', 'Bermuda', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8876, '2020-03-18', 'BM', 'Bermuda', 'AMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8877, '2020-03-19', 'BM', 'Bermuda', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8878, '2020-03-20', 'BM', 'Bermuda', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8879, '2020-03-21', 'BM', 'Bermuda', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8880, '2020-03-22', 'BM', 'Bermuda', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8881, '2020-03-23', 'BM', 'Bermuda', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8882, '2020-03-24', 'BM', 'Bermuda', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8883, '2020-03-25', 'BM', 'Bermuda', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8884, '2020-03-26', 'BM', 'Bermuda', 'AMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8885, '2020-03-27', 'BM', 'Bermuda', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8886, '2020-03-28', 'BM', 'Bermuda', 'AMRO', '8', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8887, '2020-03-29', 'BM', 'Bermuda', 'AMRO', '2', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8888, '2020-03-30', 'BM', 'Bermuda', 'AMRO', '5', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8889, '2020-03-31', 'BM', 'Bermuda', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8890, '2020-04-01', 'BM', 'Bermuda', 'AMRO', '5', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8891, '2020-04-02', 'BM', 'Bermuda', 'AMRO', '5', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8892, '2020-04-03', 'BM', 'Bermuda', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8893, '2020-04-04', 'BM', 'Bermuda', 'AMRO', '3', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8894, '2020-04-05', 'BM', 'Bermuda', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8895, '2020-04-06', 'BM', 'Bermuda', 'AMRO', '2', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8896, '2020-04-07', 'BM', 'Bermuda', 'AMRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (8897, '2020-04-08', 'BM', 'Bermuda', 'AMRO', '2', '39', '2', '2');
INSERT INTO public.who_global_data_import VALUES (8898, '2020-04-09', 'BM', 'Bermuda', 'AMRO', '0', '39', '0', '2');
INSERT INTO public.who_global_data_import VALUES (8899, '2020-04-10', 'BM', 'Bermuda', 'AMRO', '0', '39', '1', '3');
INSERT INTO public.who_global_data_import VALUES (8900, '2020-04-11', 'BM', 'Bermuda', 'AMRO', '9', '48', '1', '4');
INSERT INTO public.who_global_data_import VALUES (8901, '2020-04-12', 'BM', 'Bermuda', 'AMRO', '0', '48', '0', '4');
INSERT INTO public.who_global_data_import VALUES (8902, '2020-04-13', 'BM', 'Bermuda', 'AMRO', '2', '50', '0', '4');
INSERT INTO public.who_global_data_import VALUES (8903, '2020-04-14', 'BM', 'Bermuda', 'AMRO', '7', '57', '0', '4');
INSERT INTO public.who_global_data_import VALUES (8904, '2020-04-15', 'BM', 'Bermuda', 'AMRO', '0', '57', '1', '5');
INSERT INTO public.who_global_data_import VALUES (8905, '2020-04-16', 'BM', 'Bermuda', 'AMRO', '0', '57', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8906, '2020-04-17', 'BM', 'Bermuda', 'AMRO', '24', '81', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8907, '2020-04-18', 'BM', 'Bermuda', 'AMRO', '2', '83', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8908, '2020-04-19', 'BM', 'Bermuda', 'AMRO', '0', '83', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8909, '2020-04-20', 'BM', 'Bermuda', 'AMRO', '3', '86', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8910, '2020-04-21', 'BM', 'Bermuda', 'AMRO', '0', '86', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8911, '2020-04-22', 'BM', 'Bermuda', 'AMRO', '0', '86', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8912, '2020-04-23', 'BM', 'Bermuda', 'AMRO', '12', '98', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8913, '2020-04-24', 'BM', 'Bermuda', 'AMRO', '1', '99', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8914, '2020-04-25', 'BM', 'Bermuda', 'AMRO', '0', '99', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8915, '2020-04-26', 'BM', 'Bermuda', 'AMRO', '0', '99', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8916, '2020-04-27', 'BM', 'Bermuda', 'AMRO', '10', '109', '0', '5');
INSERT INTO public.who_global_data_import VALUES (8917, '2020-04-28', 'BM', 'Bermuda', 'AMRO', '0', '109', '1', '6');
INSERT INTO public.who_global_data_import VALUES (8918, '2020-04-29', 'BM', 'Bermuda', 'AMRO', '1', '110', '0', '6');
INSERT INTO public.who_global_data_import VALUES (8919, '2020-04-30', 'BM', 'Bermuda', 'AMRO', '1', '111', '0', '6');
INSERT INTO public.who_global_data_import VALUES (8920, '2020-05-01', 'BM', 'Bermuda', 'AMRO', '0', '111', '0', '6');
INSERT INTO public.who_global_data_import VALUES (8921, '2020-05-02', 'BM', 'Bermuda', 'AMRO', '3', '114', '0', '6');
INSERT INTO public.who_global_data_import VALUES (8922, '2020-05-03', 'BM', 'Bermuda', 'AMRO', '0', '114', '0', '6');
INSERT INTO public.who_global_data_import VALUES (8923, '2020-05-04', 'BM', 'Bermuda', 'AMRO', '1', '115', '1', '7');
INSERT INTO public.who_global_data_import VALUES (8924, '2020-05-05', 'BM', 'Bermuda', 'AMRO', '0', '115', '0', '7');
INSERT INTO public.who_global_data_import VALUES (8925, '2020-05-06', 'BM', 'Bermuda', 'AMRO', '0', '115', '0', '7');
INSERT INTO public.who_global_data_import VALUES (8926, '2020-05-07', 'BM', 'Bermuda', 'AMRO', '0', '115', '0', '7');
INSERT INTO public.who_global_data_import VALUES (8927, '2020-05-08', 'BM', 'Bermuda', 'AMRO', '3', '118', '0', '7');
INSERT INTO public.who_global_data_import VALUES (8928, '2020-05-09', 'BM', 'Bermuda', 'AMRO', '0', '118', '0', '7');
INSERT INTO public.who_global_data_import VALUES (8929, '2020-05-10', 'BM', 'Bermuda', 'AMRO', '0', '118', '0', '7');
INSERT INTO public.who_global_data_import VALUES (8930, '2020-05-11', 'BM', 'Bermuda', 'AMRO', '0', '118', '0', '7');
INSERT INTO public.who_global_data_import VALUES (8931, '2020-05-12', 'BM', 'Bermuda', 'AMRO', '0', '118', '0', '7');
INSERT INTO public.who_global_data_import VALUES (8932, '2020-05-13', 'BM', 'Bermuda', 'AMRO', '1', '119', '1', '8');
INSERT INTO public.who_global_data_import VALUES (8933, '2020-05-14', 'BM', 'Bermuda', 'AMRO', '2', '121', '0', '8');
INSERT INTO public.who_global_data_import VALUES (8934, '2020-05-15', 'BM', 'Bermuda', 'AMRO', '0', '121', '0', '8');
INSERT INTO public.who_global_data_import VALUES (8935, '2020-05-16', 'BM', 'Bermuda', 'AMRO', '1', '122', '1', '9');
INSERT INTO public.who_global_data_import VALUES (8936, '2020-05-17', 'BM', 'Bermuda', 'AMRO', '1', '123', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8937, '2020-05-18', 'BM', 'Bermuda', 'AMRO', '0', '123', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8938, '2020-05-19', 'BM', 'Bermuda', 'AMRO', '0', '123', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8939, '2020-05-20', 'BM', 'Bermuda', 'AMRO', '2', '125', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8940, '2020-05-21', 'BM', 'Bermuda', 'AMRO', '0', '125', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8941, '2020-05-22', 'BM', 'Bermuda', 'AMRO', '0', '125', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8942, '2020-05-23', 'BM', 'Bermuda', 'AMRO', '0', '125', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8943, '2020-05-24', 'BM', 'Bermuda', 'AMRO', '3', '128', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8944, '2020-05-25', 'BM', 'Bermuda', 'AMRO', '5', '133', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8945, '2020-05-26', 'BM', 'Bermuda', 'AMRO', '0', '133', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8946, '2020-05-27', 'BM', 'Bermuda', 'AMRO', '0', '133', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8947, '2020-05-28', 'BM', 'Bermuda', 'AMRO', '6', '139', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8948, '2020-05-29', 'BM', 'Bermuda', 'AMRO', '0', '139', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8949, '2020-05-30', 'BM', 'Bermuda', 'AMRO', '1', '140', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8950, '2020-05-31', 'BM', 'Bermuda', 'AMRO', '0', '140', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8951, '2020-06-01', 'BM', 'Bermuda', 'AMRO', '0', '140', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8952, '2020-06-02', 'BM', 'Bermuda', 'AMRO', '0', '140', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8953, '2020-06-03', 'BM', 'Bermuda', 'AMRO', '1', '141', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8954, '2020-06-04', 'BM', 'Bermuda', 'AMRO', '0', '141', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8955, '2020-06-05', 'BM', 'Bermuda', 'AMRO', '0', '141', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8956, '2020-06-06', 'BM', 'Bermuda', 'AMRO', '0', '141', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8957, '2020-06-07', 'BM', 'Bermuda', 'AMRO', '0', '141', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8958, '2020-06-08', 'BM', 'Bermuda', 'AMRO', '0', '141', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8959, '2020-06-09', 'BM', 'Bermuda', 'AMRO', '0', '141', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8960, '2020-06-10', 'BM', 'Bermuda', 'AMRO', '0', '141', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8961, '2020-06-11', 'BM', 'Bermuda', 'AMRO', '0', '141', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8962, '2020-06-12', 'BM', 'Bermuda', 'AMRO', '0', '141', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8963, '2020-06-13', 'BM', 'Bermuda', 'AMRO', '0', '141', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8964, '2020-06-14', 'BM', 'Bermuda', 'AMRO', '1', '142', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8965, '2020-06-15', 'BM', 'Bermuda', 'AMRO', '2', '144', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8966, '2020-06-16', 'BM', 'Bermuda', 'AMRO', '0', '144', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8967, '2020-06-17', 'BM', 'Bermuda', 'AMRO', '0', '144', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8968, '2020-06-18', 'BM', 'Bermuda', 'AMRO', '0', '144', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8969, '2020-06-19', 'BM', 'Bermuda', 'AMRO', '0', '144', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8970, '2020-06-20', 'BM', 'Bermuda', 'AMRO', '0', '144', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8971, '2020-06-21', 'BM', 'Bermuda', 'AMRO', '2', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8972, '2020-06-22', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8973, '2020-06-23', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8974, '2020-06-24', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8975, '2020-06-25', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8976, '2020-06-26', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8977, '2020-06-27', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8978, '2020-06-28', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8979, '2020-06-29', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8980, '2020-06-30', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8981, '2020-07-01', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8982, '2020-07-02', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8983, '2020-07-03', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8984, '2020-07-04', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8985, '2020-07-05', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8986, '2020-07-06', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8987, '2020-07-07', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8988, '2020-07-08', 'BM', 'Bermuda', 'AMRO', '0', '146', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8989, '2020-07-09', 'BM', 'Bermuda', 'AMRO', '3', '149', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8990, '2020-07-10', 'BM', 'Bermuda', 'AMRO', '0', '149', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8991, '2020-07-11', 'BM', 'Bermuda', 'AMRO', '0', '149', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8992, '2020-07-12', 'BM', 'Bermuda', 'AMRO', '1', '150', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8993, '2020-07-13', 'BM', 'Bermuda', 'AMRO', '0', '150', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8994, '2020-07-14', 'BM', 'Bermuda', 'AMRO', '0', '150', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8995, '2020-07-15', 'BM', 'Bermuda', 'AMRO', '0', '150', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8996, '2020-07-16', 'BM', 'Bermuda', 'AMRO', '0', '150', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8997, '2020-07-17', 'BM', 'Bermuda', 'AMRO', '0', '150', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8998, '2020-07-18', 'BM', 'Bermuda', 'AMRO', '2', '152', '0', '9');
INSERT INTO public.who_global_data_import VALUES (8999, '2020-07-19', 'BM', 'Bermuda', 'AMRO', '0', '152', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9000, '2020-07-20', 'BM', 'Bermuda', 'AMRO', '1', '153', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9001, '2020-07-21', 'BM', 'Bermuda', 'AMRO', '0', '153', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9002, '2020-07-22', 'BM', 'Bermuda', 'AMRO', '0', '153', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9003, '2020-07-23', 'BM', 'Bermuda', 'AMRO', '0', '153', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9004, '2020-07-24', 'BM', 'Bermuda', 'AMRO', '0', '153', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9005, '2020-07-25', 'BM', 'Bermuda', 'AMRO', '0', '153', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9006, '2020-07-26', 'BM', 'Bermuda', 'AMRO', '0', '153', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9007, '2020-07-27', 'BM', 'Bermuda', 'AMRO', '1', '154', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9008, '2020-07-28', 'BM', 'Bermuda', 'AMRO', '0', '154', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9009, '2020-07-29', 'BM', 'Bermuda', 'AMRO', '0', '154', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9010, '2020-07-30', 'BM', 'Bermuda', 'AMRO', '2', '156', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9011, '2020-07-31', 'BM', 'Bermuda', 'AMRO', '0', '156', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9012, '2020-08-01', 'BM', 'Bermuda', 'AMRO', '0', '156', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9013, '2020-08-02', 'BM', 'Bermuda', 'AMRO', '0', '156', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9014, '2020-08-03', 'BM', 'Bermuda', 'AMRO', '0', '156', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9015, '2020-08-04', 'BM', 'Bermuda', 'AMRO', '1', '157', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9016, '2020-08-05', 'BM', 'Bermuda', 'AMRO', '0', '157', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9017, '2020-08-06', 'BM', 'Bermuda', 'AMRO', '0', '157', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9018, '2020-08-07', 'BM', 'Bermuda', 'AMRO', '0', '157', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9019, '2020-08-08', 'BM', 'Bermuda', 'AMRO', '0', '157', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9020, '2020-08-09', 'BM', 'Bermuda', 'AMRO', '1', '158', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9021, '2020-08-10', 'BM', 'Bermuda', 'AMRO', '0', '158', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9022, '2020-08-11', 'BM', 'Bermuda', 'AMRO', '0', '158', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9023, '2020-08-12', 'BM', 'Bermuda', 'AMRO', '1', '159', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9024, '2020-08-13', 'BM', 'Bermuda', 'AMRO', '0', '159', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9025, '2020-08-14', 'BM', 'Bermuda', 'AMRO', '0', '159', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9026, '2020-08-15', 'BM', 'Bermuda', 'AMRO', '0', '159', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9027, '2020-08-16', 'BM', 'Bermuda', 'AMRO', '0', '159', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9028, '2020-08-17', 'BM', 'Bermuda', 'AMRO', '3', '162', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9029, '2020-08-18', 'BM', 'Bermuda', 'AMRO', '0', '162', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9030, '2020-08-19', 'BM', 'Bermuda', 'AMRO', '4', '166', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9031, '2020-08-20', 'BM', 'Bermuda', 'AMRO', '0', '166', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9032, '2020-08-21', 'BM', 'Bermuda', 'AMRO', '0', '166', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9033, '2020-08-22', 'BM', 'Bermuda', 'AMRO', '0', '166', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9034, '2020-08-23', 'BM', 'Bermuda', 'AMRO', '1', '167', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9035, '2020-08-24', 'BM', 'Bermuda', 'AMRO', '0', '167', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9036, '2020-08-25', 'BM', 'Bermuda', 'AMRO', '0', '167', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9037, '2020-08-26', 'BM', 'Bermuda', 'AMRO', '1', '168', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9038, '2020-08-27', 'BM', 'Bermuda', 'AMRO', '0', '168', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9039, '2020-08-28', 'BM', 'Bermuda', 'AMRO', '0', '168', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9040, '2020-08-29', 'BM', 'Bermuda', 'AMRO', '0', '168', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9041, '2020-08-30', 'BM', 'Bermuda', 'AMRO', '0', '168', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9042, '2020-08-31', 'BM', 'Bermuda', 'AMRO', '1', '169', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9043, '2020-09-01', 'BM', 'Bermuda', 'AMRO', '0', '169', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9044, '2020-09-02', 'BM', 'Bermuda', 'AMRO', '3', '172', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9045, '2020-09-03', 'BM', 'Bermuda', 'AMRO', '0', '172', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9046, '2020-09-04', 'BM', 'Bermuda', 'AMRO', '0', '172', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9047, '2020-09-05', 'BM', 'Bermuda', 'AMRO', '2', '174', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9048, '2020-09-06', 'BM', 'Bermuda', 'AMRO', '1', '175', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9049, '2020-09-07', 'BM', 'Bermuda', 'AMRO', '0', '175', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9050, '2020-09-08', 'BM', 'Bermuda', 'AMRO', '0', '175', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9051, '2020-09-09', 'BM', 'Bermuda', 'AMRO', '0', '175', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9052, '2020-09-10', 'BM', 'Bermuda', 'AMRO', '2', '177', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9053, '2020-09-11', 'BM', 'Bermuda', 'AMRO', '0', '177', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9054, '2020-09-12', 'BM', 'Bermuda', 'AMRO', '0', '177', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9055, '2020-09-13', 'BM', 'Bermuda', 'AMRO', '0', '177', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9056, '2020-09-14', 'BM', 'Bermuda', 'AMRO', '0', '177', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9057, '2020-09-15', 'BM', 'Bermuda', 'AMRO', '0', '177', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9058, '2020-09-16', 'BM', 'Bermuda', 'AMRO', '0', '177', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9059, '2020-09-17', 'BM', 'Bermuda', 'AMRO', '0', '177', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9060, '2020-09-18', 'BM', 'Bermuda', 'AMRO', '1', '178', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9061, '2020-09-19', 'BM', 'Bermuda', 'AMRO', '0', '178', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9062, '2020-09-20', 'BM', 'Bermuda', 'AMRO', '0', '178', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9063, '2020-09-21', 'BM', 'Bermuda', 'AMRO', '2', '180', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9064, '2020-09-22', 'BM', 'Bermuda', 'AMRO', '0', '180', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9065, '2020-09-23', 'BM', 'Bermuda', 'AMRO', '0', '180', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9066, '2020-09-24', 'BM', 'Bermuda', 'AMRO', '0', '180', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9067, '2020-09-25', 'BM', 'Bermuda', 'AMRO', '1', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9068, '2020-09-26', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9069, '2020-09-27', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9070, '2020-09-28', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9071, '2020-09-29', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9072, '2020-09-30', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9073, '2020-10-01', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9074, '2020-10-02', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9075, '2020-10-03', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9076, '2020-10-04', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9077, '2020-10-05', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9078, '2020-10-06', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9079, '2020-10-07', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9080, '2020-10-08', 'BM', 'Bermuda', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9081, '2020-10-09', 'BM', 'Bermuda', 'AMRO', '1', '182', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9082, '2020-10-10', 'BM', 'Bermuda', 'AMRO', '2', '184', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9083, '2020-10-11', 'BM', 'Bermuda', 'AMRO', '0', '184', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9084, '2020-10-12', 'BM', 'Bermuda', 'AMRO', '0', '184', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9085, '2020-10-13', 'BM', 'Bermuda', 'AMRO', '0', '184', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9086, '2020-10-14', 'BM', 'Bermuda', 'AMRO', '0', '184', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9087, '2020-10-15', 'BM', 'Bermuda', 'AMRO', '1', '185', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9088, '2020-10-16', 'BM', 'Bermuda', 'AMRO', '0', '185', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9089, '2020-10-17', 'BM', 'Bermuda', 'AMRO', '0', '185', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9090, '2020-10-18', 'BM', 'Bermuda', 'AMRO', '0', '185', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9091, '2020-10-19', 'BM', 'Bermuda', 'AMRO', '0', '185', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9092, '2020-10-20', 'BM', 'Bermuda', 'AMRO', '0', '185', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9093, '2020-10-21', 'BM', 'Bermuda', 'AMRO', '3', '188', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9094, '2020-10-22', 'BM', 'Bermuda', 'AMRO', '0', '188', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9095, '2020-10-23', 'BM', 'Bermuda', 'AMRO', '0', '188', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9096, '2020-10-24', 'BM', 'Bermuda', 'AMRO', '2', '190', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9097, '2020-10-25', 'BM', 'Bermuda', 'AMRO', '0', '190', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9098, '2020-10-26', 'BM', 'Bermuda', 'AMRO', '0', '190', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9099, '2020-10-27', 'BM', 'Bermuda', 'AMRO', '0', '190', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9100, '2020-10-28', 'BM', 'Bermuda', 'AMRO', '3', '193', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9101, '2020-10-29', 'BM', 'Bermuda', 'AMRO', '1', '194', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9102, '2020-10-30', 'BM', 'Bermuda', 'AMRO', '4', '198', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9103, '2020-10-31', 'BM', 'Bermuda', 'AMRO', '1', '199', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9104, '2020-11-01', 'BM', 'Bermuda', 'AMRO', '0', '199', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9105, '2020-11-02', 'BM', 'Bermuda', 'AMRO', '0', '199', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9106, '2020-11-03', 'BM', 'Bermuda', 'AMRO', '7', '206', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9107, '2020-11-04', 'BM', 'Bermuda', 'AMRO', '0', '206', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9108, '2020-11-05', 'BM', 'Bermuda', 'AMRO', '0', '206', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9109, '2020-11-06', 'BM', 'Bermuda', 'AMRO', '0', '206', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9110, '2020-11-07', 'BM', 'Bermuda', 'AMRO', '1', '207', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9111, '2020-11-08', 'BM', 'Bermuda', 'AMRO', '2', '209', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9112, '2020-11-09', 'BM', 'Bermuda', 'AMRO', '0', '209', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9113, '2020-11-10', 'BM', 'Bermuda', 'AMRO', '5', '214', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9114, '2020-11-11', 'BM', 'Bermuda', 'AMRO', '0', '214', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9115, '2020-11-12', 'BM', 'Bermuda', 'AMRO', '1', '215', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9116, '2020-11-13', 'BM', 'Bermuda', 'AMRO', '5', '220', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9117, '2020-11-14', 'BM', 'Bermuda', 'AMRO', '2', '222', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9118, '2020-11-15', 'BM', 'Bermuda', 'AMRO', '0', '222', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9119, '2020-11-16', 'BM', 'Bermuda', 'AMRO', '0', '222', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9120, '2020-11-17', 'BM', 'Bermuda', 'AMRO', '0', '222', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9121, '2020-11-18', 'BM', 'Bermuda', 'AMRO', '1', '223', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9122, '2020-11-19', 'BM', 'Bermuda', 'AMRO', '0', '223', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9123, '2020-11-20', 'BM', 'Bermuda', 'AMRO', '1', '224', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9124, '2020-11-21', 'BM', 'Bermuda', 'AMRO', '3', '227', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9125, '2020-11-22', 'BM', 'Bermuda', 'AMRO', '0', '227', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9126, '2020-11-23', 'BM', 'Bermuda', 'AMRO', '0', '227', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9127, '2020-11-24', 'BM', 'Bermuda', 'AMRO', '0', '227', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9128, '2020-11-25', 'BM', 'Bermuda', 'AMRO', '8', '235', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9129, '2020-11-26', 'BM', 'Bermuda', 'AMRO', '4', '239', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9130, '2020-11-27', 'BM', 'Bermuda', 'AMRO', '2', '241', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9131, '2020-11-28', 'BM', 'Bermuda', 'AMRO', '1', '242', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9132, '2020-11-29', 'BM', 'Bermuda', 'AMRO', '5', '247', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9133, '2020-11-30', 'BM', 'Bermuda', 'AMRO', '4', '251', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9134, '2020-12-01', 'BM', 'Bermuda', 'AMRO', '9', '260', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9135, '2020-12-02', 'BM', 'Bermuda', 'AMRO', '0', '260', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9136, '2020-12-03', 'BM', 'Bermuda', 'AMRO', '7', '267', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9137, '2020-12-04', 'BM', 'Bermuda', 'AMRO', '5', '272', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9138, '2020-12-05', 'BM', 'Bermuda', 'AMRO', '6', '278', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9139, '2020-12-06', 'BM', 'Bermuda', 'AMRO', '10', '288', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9140, '2020-12-07', 'BM', 'Bermuda', 'AMRO', '0', '288', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9141, '2020-12-08', 'BM', 'Bermuda', 'AMRO', '18', '306', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9142, '2020-12-09', 'BM', 'Bermuda', 'AMRO', '0', '306', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9143, '2020-12-10', 'BM', 'Bermuda', 'AMRO', '34', '340', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9144, '2020-12-11', 'BM', 'Bermuda', 'AMRO', '24', '364', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9145, '2020-12-12', 'BM', 'Bermuda', 'AMRO', '0', '364', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9146, '2020-12-13', 'BM', 'Bermuda', 'AMRO', '27', '391', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9147, '2020-12-14', 'BM', 'Bermuda', 'AMRO', '0', '391', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9148, '2020-12-15', 'BM', 'Bermuda', 'AMRO', '40', '431', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9149, '2020-12-16', 'BM', 'Bermuda', 'AMRO', '25', '456', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9150, '2020-12-17', 'BM', 'Bermuda', 'AMRO', '11', '467', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9151, '2020-12-18', 'BM', 'Bermuda', 'AMRO', '18', '485', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9152, '2020-12-19', 'BM', 'Bermuda', 'AMRO', '12', '497', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9153, '2020-12-20', 'BM', 'Bermuda', 'AMRO', '19', '516', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9154, '2020-12-21', 'BM', 'Bermuda', 'AMRO', '11', '527', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9155, '2020-12-22', 'BM', 'Bermuda', 'AMRO', '0', '527', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9156, '2020-12-23', 'BM', 'Bermuda', 'AMRO', '20', '547', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9157, '2020-12-24', 'BM', 'Bermuda', 'AMRO', '6', '553', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9158, '2020-12-25', 'BM', 'Bermuda', 'AMRO', '8', '561', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9159, '2020-12-26', 'BM', 'Bermuda', 'AMRO', '0', '561', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9160, '2020-12-27', 'BM', 'Bermuda', 'AMRO', '0', '561', '0', '9');
INSERT INTO public.who_global_data_import VALUES (9161, '2020-12-28', 'BM', 'Bermuda', 'AMRO', '20', '581', '1', '10');
INSERT INTO public.who_global_data_import VALUES (9162, '2020-12-29', 'BM', 'Bermuda', 'AMRO', '0', '581', '0', '10');
INSERT INTO public.who_global_data_import VALUES (9163, '2020-12-30', 'BM', 'Bermuda', 'AMRO', '0', '581', '0', '10');
INSERT INTO public.who_global_data_import VALUES (9164, '2020-12-31', 'BM', 'Bermuda', 'AMRO', '14', '595', '0', '10');
INSERT INTO public.who_global_data_import VALUES (9165, '2021-01-01', 'BM', 'Bermuda', 'AMRO', '9', '604', '0', '10');
INSERT INTO public.who_global_data_import VALUES (9166, '2021-01-02', 'BM', 'Bermuda', 'AMRO', '0', '604', '0', '10');
INSERT INTO public.who_global_data_import VALUES (9167, '2021-01-03', 'BM', 'Bermuda', 'AMRO', '0', '604', '0', '10');
INSERT INTO public.who_global_data_import VALUES (9168, '2021-01-04', 'BM', 'Bermuda', 'AMRO', '18', '622', '0', '10');
INSERT INTO public.who_global_data_import VALUES (9169, '2021-01-05', 'BM', 'Bermuda', 'AMRO', '0', '622', '0', '10');
INSERT INTO public.who_global_data_import VALUES (9170, '2021-01-06', 'BM', 'Bermuda', 'AMRO', '2', '624', '0', '10');
INSERT INTO public.who_global_data_import VALUES (9171, '2021-01-07', 'BM', 'Bermuda', 'AMRO', '8', '632', '1', '11');
INSERT INTO public.who_global_data_import VALUES (9172, '2021-01-08', 'BM', 'Bermuda', 'AMRO', '4', '636', '0', '11');
INSERT INTO public.who_global_data_import VALUES (9173, '2021-01-09', 'BM', 'Bermuda', 'AMRO', '5', '641', '1', '12');
INSERT INTO public.who_global_data_import VALUES (9174, '2021-01-10', 'BM', 'Bermuda', 'AMRO', '5', '646', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9175, '2021-01-11', 'BM', 'Bermuda', 'AMRO', '6', '652', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9176, '2021-01-12', 'BM', 'Bermuda', 'AMRO', '0', '652', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9177, '2021-01-13', 'BM', 'Bermuda', 'AMRO', '4', '656', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9178, '2021-01-14', 'BM', 'Bermuda', 'AMRO', '5', '661', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9179, '2021-01-15', 'BM', 'Bermuda', 'AMRO', '3', '664', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9180, '2021-01-16', 'BM', 'Bermuda', 'AMRO', '3', '667', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9181, '2021-01-17', 'BM', 'Bermuda', 'AMRO', '3', '670', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9182, '2021-01-18', 'BM', 'Bermuda', 'AMRO', '0', '670', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9183, '2021-01-19', 'BM', 'Bermuda', 'AMRO', '0', '670', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9184, '2021-01-20', 'BM', 'Bermuda', 'AMRO', '13', '683', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9185, '2021-01-21', 'BM', 'Bermuda', 'AMRO', '1', '684', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9186, '2021-01-22', 'BM', 'Bermuda', 'AMRO', '0', '684', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9187, '2021-01-23', 'BM', 'Bermuda', 'AMRO', '2', '686', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9188, '2021-01-24', 'BM', 'Bermuda', 'AMRO', '0', '686', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9189, '2021-01-25', 'BM', 'Bermuda', 'AMRO', '0', '686', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9190, '2021-01-26', 'BM', 'Bermuda', 'AMRO', '0', '686', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9191, '2021-01-27', 'BM', 'Bermuda', 'AMRO', '0', '686', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9192, '2021-01-28', 'BM', 'Bermuda', 'AMRO', '2', '688', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9193, '2021-01-29', 'BM', 'Bermuda', 'AMRO', '1', '689', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9194, '2021-01-30', 'BM', 'Bermuda', 'AMRO', '1', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9195, '2021-01-31', 'BM', 'Bermuda', 'AMRO', '1', '691', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9196, '2021-02-01', 'BM', 'Bermuda', 'AMRO', '0', '691', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9197, '2021-02-02', 'BM', 'Bermuda', 'AMRO', '0', '691', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9198, '2021-02-03', 'BM', 'Bermuda', 'AMRO', '1', '692', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9199, '2021-02-04', 'BM', 'Bermuda', 'AMRO', '0', '692', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9200, '2021-02-05', 'BM', 'Bermuda', 'AMRO', '0', '692', '0', '12');
INSERT INTO public.who_global_data_import VALUES (9201, '2020-01-03', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9202, '2020-01-04', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9203, '2020-01-05', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9204, '2020-01-06', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9205, '2020-01-07', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9206, '2020-01-08', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9207, '2020-01-09', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9208, '2020-01-10', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9209, '2020-01-11', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9210, '2020-01-12', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9211, '2020-01-13', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9212, '2020-01-14', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9213, '2020-01-15', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9214, '2020-01-16', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9215, '2020-01-17', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9216, '2020-01-18', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9217, '2020-01-19', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9218, '2020-01-20', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9219, '2020-01-21', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9220, '2020-01-22', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9221, '2020-01-23', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9222, '2020-01-24', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9223, '2020-01-25', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9224, '2020-01-26', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9225, '2020-01-27', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9226, '2020-01-28', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9227, '2020-01-29', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9228, '2020-01-30', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9229, '2020-01-31', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9230, '2020-02-01', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9231, '2020-02-02', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9232, '2020-02-03', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9233, '2020-02-04', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9234, '2020-02-05', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9235, '2020-02-06', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9236, '2020-02-07', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9237, '2020-02-08', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9238, '2020-02-09', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9239, '2020-02-10', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9240, '2020-02-11', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9241, '2020-02-12', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9242, '2020-02-13', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9243, '2020-02-14', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9244, '2020-02-15', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9245, '2020-02-16', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9246, '2020-02-17', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9247, '2020-02-18', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9248, '2020-02-19', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9249, '2020-02-20', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9250, '2020-02-21', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9251, '2020-02-22', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9252, '2020-02-23', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9253, '2020-02-24', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9254, '2020-02-25', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9255, '2020-02-26', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9256, '2020-02-27', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9257, '2020-02-28', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9258, '2020-02-29', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9259, '2020-03-01', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9260, '2020-03-02', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9261, '2020-03-03', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9262, '2020-03-04', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9263, '2020-03-05', 'BT', 'Bhutan', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9264, '2020-03-06', 'BT', 'Bhutan', 'SEARO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9265, '2020-03-07', 'BT', 'Bhutan', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9266, '2020-03-08', 'BT', 'Bhutan', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9267, '2020-03-09', 'BT', 'Bhutan', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9268, '2020-03-10', 'BT', 'Bhutan', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9269, '2020-03-11', 'BT', 'Bhutan', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9270, '2020-03-12', 'BT', 'Bhutan', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9271, '2020-03-13', 'BT', 'Bhutan', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9272, '2020-03-14', 'BT', 'Bhutan', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9273, '2020-03-15', 'BT', 'Bhutan', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9274, '2020-03-16', 'BT', 'Bhutan', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9275, '2020-03-17', 'BT', 'Bhutan', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9276, '2020-03-18', 'BT', 'Bhutan', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9277, '2020-03-19', 'BT', 'Bhutan', 'SEARO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9278, '2020-03-20', 'BT', 'Bhutan', 'SEARO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9279, '2020-03-21', 'BT', 'Bhutan', 'SEARO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9280, '2020-03-22', 'BT', 'Bhutan', 'SEARO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9281, '2020-03-23', 'BT', 'Bhutan', 'SEARO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9282, '2020-03-24', 'BT', 'Bhutan', 'SEARO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9283, '2020-03-25', 'BT', 'Bhutan', 'SEARO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9284, '2020-03-26', 'BT', 'Bhutan', 'SEARO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9285, '2020-03-27', 'BT', 'Bhutan', 'SEARO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9286, '2020-03-28', 'BT', 'Bhutan', 'SEARO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9287, '2020-03-29', 'BT', 'Bhutan', 'SEARO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9288, '2020-03-30', 'BT', 'Bhutan', 'SEARO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9289, '2020-03-31', 'BT', 'Bhutan', 'SEARO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9290, '2020-04-01', 'BT', 'Bhutan', 'SEARO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9291, '2020-04-02', 'BT', 'Bhutan', 'SEARO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9292, '2020-04-03', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9293, '2020-04-04', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9294, '2020-04-05', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9295, '2020-04-06', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9296, '2020-04-07', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9297, '2020-04-08', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9298, '2020-04-09', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9299, '2020-04-10', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9300, '2020-04-11', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9301, '2020-04-12', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9302, '2020-04-13', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9303, '2020-04-14', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9304, '2020-04-15', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9305, '2020-04-16', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9306, '2020-04-17', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9307, '2020-04-18', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9308, '2020-04-19', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9309, '2020-04-20', 'BT', 'Bhutan', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9310, '2020-04-21', 'BT', 'Bhutan', 'SEARO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9311, '2020-04-22', 'BT', 'Bhutan', 'SEARO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9312, '2020-04-23', 'BT', 'Bhutan', 'SEARO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9313, '2020-04-24', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9314, '2020-04-25', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9315, '2020-04-26', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9316, '2020-04-27', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9317, '2020-04-28', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9318, '2020-04-29', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9319, '2020-04-30', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9320, '2020-05-01', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9321, '2020-05-02', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9322, '2020-05-03', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9323, '2020-05-04', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9324, '2020-05-05', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9325, '2020-05-06', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9326, '2020-05-07', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9327, '2020-05-08', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9328, '2020-05-09', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9329, '2020-05-10', 'BT', 'Bhutan', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9330, '2020-05-11', 'BT', 'Bhutan', 'SEARO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9331, '2020-05-12', 'BT', 'Bhutan', 'SEARO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9332, '2020-05-13', 'BT', 'Bhutan', 'SEARO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9333, '2020-05-14', 'BT', 'Bhutan', 'SEARO', '4', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9334, '2020-05-15', 'BT', 'Bhutan', 'SEARO', '5', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9335, '2020-05-16', 'BT', 'Bhutan', 'SEARO', '1', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9336, '2020-05-17', 'BT', 'Bhutan', 'SEARO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9337, '2020-05-18', 'BT', 'Bhutan', 'SEARO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9338, '2020-05-19', 'BT', 'Bhutan', 'SEARO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9339, '2020-05-20', 'BT', 'Bhutan', 'SEARO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9340, '2020-05-21', 'BT', 'Bhutan', 'SEARO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9341, '2020-05-22', 'BT', 'Bhutan', 'SEARO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9342, '2020-05-23', 'BT', 'Bhutan', 'SEARO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9343, '2020-05-24', 'BT', 'Bhutan', 'SEARO', '3', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9344, '2020-05-25', 'BT', 'Bhutan', 'SEARO', '3', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9345, '2020-05-26', 'BT', 'Bhutan', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9346, '2020-05-27', 'BT', 'Bhutan', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9347, '2020-05-28', 'BT', 'Bhutan', 'SEARO', '1', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9348, '2020-05-29', 'BT', 'Bhutan', 'SEARO', '3', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9349, '2020-05-30', 'BT', 'Bhutan', 'SEARO', '2', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9350, '2020-05-31', 'BT', 'Bhutan', 'SEARO', '10', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9351, '2020-06-01', 'BT', 'Bhutan', 'SEARO', '0', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9352, '2020-06-02', 'BT', 'Bhutan', 'SEARO', '4', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9353, '2020-06-03', 'BT', 'Bhutan', 'SEARO', '0', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9354, '2020-06-04', 'BT', 'Bhutan', 'SEARO', '0', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9355, '2020-06-05', 'BT', 'Bhutan', 'SEARO', '0', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9356, '2020-06-06', 'BT', 'Bhutan', 'SEARO', '1', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9357, '2020-06-07', 'BT', 'Bhutan', 'SEARO', '0', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9358, '2020-06-08', 'BT', 'Bhutan', 'SEARO', '11', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9359, '2020-06-09', 'BT', 'Bhutan', 'SEARO', '0', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9360, '2020-06-10', 'BT', 'Bhutan', 'SEARO', '0', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9361, '2020-06-11', 'BT', 'Bhutan', 'SEARO', '3', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9362, '2020-06-12', 'BT', 'Bhutan', 'SEARO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9363, '2020-06-13', 'BT', 'Bhutan', 'SEARO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9364, '2020-06-14', 'BT', 'Bhutan', 'SEARO', '4', '66', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9365, '2020-06-15', 'BT', 'Bhutan', 'SEARO', '0', '66', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9366, '2020-06-16', 'BT', 'Bhutan', 'SEARO', '1', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9367, '2020-06-17', 'BT', 'Bhutan', 'SEARO', '0', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9368, '2020-06-18', 'BT', 'Bhutan', 'SEARO', '0', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9369, '2020-06-19', 'BT', 'Bhutan', 'SEARO', '0', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9370, '2020-06-20', 'BT', 'Bhutan', 'SEARO', '1', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9371, '2020-06-21', 'BT', 'Bhutan', 'SEARO', '0', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9372, '2020-06-22', 'BT', 'Bhutan', 'SEARO', '0', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9373, '2020-06-23', 'BT', 'Bhutan', 'SEARO', '1', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9374, '2020-06-24', 'BT', 'Bhutan', 'SEARO', '1', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9375, '2020-06-25', 'BT', 'Bhutan', 'SEARO', '0', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9376, '2020-06-26', 'BT', 'Bhutan', 'SEARO', '0', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9377, '2020-06-27', 'BT', 'Bhutan', 'SEARO', '0', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9378, '2020-06-28', 'BT', 'Bhutan', 'SEARO', '6', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9379, '2020-06-29', 'BT', 'Bhutan', 'SEARO', '0', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9380, '2020-06-30', 'BT', 'Bhutan', 'SEARO', '1', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9381, '2020-07-01', 'BT', 'Bhutan', 'SEARO', '0', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9382, '2020-07-02', 'BT', 'Bhutan', 'SEARO', '0', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9383, '2020-07-03', 'BT', 'Bhutan', 'SEARO', '0', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9384, '2020-07-04', 'BT', 'Bhutan', 'SEARO', '1', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9385, '2020-07-05', 'BT', 'Bhutan', 'SEARO', '0', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9386, '2020-07-06', 'BT', 'Bhutan', 'SEARO', '2', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9387, '2020-07-07', 'BT', 'Bhutan', 'SEARO', '0', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9388, '2020-07-08', 'BT', 'Bhutan', 'SEARO', '0', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9389, '2020-07-09', 'BT', 'Bhutan', 'SEARO', '0', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9390, '2020-07-10', 'BT', 'Bhutan', 'SEARO', '0', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9391, '2020-07-11', 'BT', 'Bhutan', 'SEARO', '2', '82', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9392, '2020-07-12', 'BT', 'Bhutan', 'SEARO', '0', '82', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9393, '2020-07-13', 'BT', 'Bhutan', 'SEARO', '2', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9394, '2020-07-14', 'BT', 'Bhutan', 'SEARO', '0', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9395, '2020-07-15', 'BT', 'Bhutan', 'SEARO', '0', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9396, '2020-07-16', 'BT', 'Bhutan', 'SEARO', '0', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9397, '2020-07-17', 'BT', 'Bhutan', 'SEARO', '2', '86', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9398, '2020-07-18', 'BT', 'Bhutan', 'SEARO', '1', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9399, '2020-07-19', 'BT', 'Bhutan', 'SEARO', '0', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9400, '2020-07-20', 'BT', 'Bhutan', 'SEARO', '2', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9401, '2020-07-21', 'BT', 'Bhutan', 'SEARO', '1', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9402, '2020-07-22', 'BT', 'Bhutan', 'SEARO', '2', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9403, '2020-07-23', 'BT', 'Bhutan', 'SEARO', '0', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9404, '2020-07-24', 'BT', 'Bhutan', 'SEARO', '0', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9405, '2020-07-25', 'BT', 'Bhutan', 'SEARO', '0', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9406, '2020-07-26', 'BT', 'Bhutan', 'SEARO', '1', '93', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9407, '2020-07-27', 'BT', 'Bhutan', 'SEARO', '2', '95', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9408, '2020-07-28', 'BT', 'Bhutan', 'SEARO', '4', '99', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9409, '2020-07-29', 'BT', 'Bhutan', 'SEARO', '0', '99', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9410, '2020-07-30', 'BT', 'Bhutan', 'SEARO', '2', '101', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9411, '2020-07-31', 'BT', 'Bhutan', 'SEARO', '0', '101', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9412, '2020-08-01', 'BT', 'Bhutan', 'SEARO', '0', '101', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9413, '2020-08-02', 'BT', 'Bhutan', 'SEARO', '1', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9414, '2020-08-03', 'BT', 'Bhutan', 'SEARO', '1', '103', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9415, '2020-08-04', 'BT', 'Bhutan', 'SEARO', '0', '103', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9416, '2020-08-05', 'BT', 'Bhutan', 'SEARO', '2', '105', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9417, '2020-08-06', 'BT', 'Bhutan', 'SEARO', '0', '105', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9418, '2020-08-07', 'BT', 'Bhutan', 'SEARO', '3', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9419, '2020-08-08', 'BT', 'Bhutan', 'SEARO', '0', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9420, '2020-08-09', 'BT', 'Bhutan', 'SEARO', '0', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9421, '2020-08-10', 'BT', 'Bhutan', 'SEARO', '2', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9422, '2020-08-11', 'BT', 'Bhutan', 'SEARO', '3', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9423, '2020-08-12', 'BT', 'Bhutan', 'SEARO', '0', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9424, '2020-08-13', 'BT', 'Bhutan', 'SEARO', '15', '128', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9425, '2020-08-14', 'BT', 'Bhutan', 'SEARO', '3', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9426, '2020-08-15', 'BT', 'Bhutan', 'SEARO', '2', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9427, '2020-08-16', 'BT', 'Bhutan', 'SEARO', '0', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9428, '2020-08-17', 'BT', 'Bhutan', 'SEARO', '8', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9429, '2020-08-18', 'BT', 'Bhutan', 'SEARO', '5', '146', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9430, '2020-08-19', 'BT', 'Bhutan', 'SEARO', '1', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9431, '2020-08-20', 'BT', 'Bhutan', 'SEARO', '3', '150', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9432, '2020-08-21', 'BT', 'Bhutan', 'SEARO', '3', '153', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9433, '2020-08-22', 'BT', 'Bhutan', 'SEARO', '1', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9434, '2020-08-23', 'BT', 'Bhutan', 'SEARO', '1', '155', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9435, '2020-08-24', 'BT', 'Bhutan', 'SEARO', '0', '155', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9436, '2020-08-25', 'BT', 'Bhutan', 'SEARO', '1', '156', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9437, '2020-08-26', 'BT', 'Bhutan', 'SEARO', '17', '173', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9438, '2020-08-27', 'BT', 'Bhutan', 'SEARO', '10', '183', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9439, '2020-08-28', 'BT', 'Bhutan', 'SEARO', '1', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9440, '2020-08-29', 'BT', 'Bhutan', 'SEARO', '11', '195', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9441, '2020-08-30', 'BT', 'Bhutan', 'SEARO', '0', '195', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9442, '2020-08-31', 'BT', 'Bhutan', 'SEARO', '29', '224', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9443, '2020-09-01', 'BT', 'Bhutan', 'SEARO', '1', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9444, '2020-09-02', 'BT', 'Bhutan', 'SEARO', '2', '227', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9445, '2020-09-03', 'BT', 'Bhutan', 'SEARO', '0', '227', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9446, '2020-09-04', 'BT', 'Bhutan', 'SEARO', '0', '227', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9447, '2020-09-05', 'BT', 'Bhutan', 'SEARO', '1', '228', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9448, '2020-09-06', 'BT', 'Bhutan', 'SEARO', '0', '228', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9449, '2020-09-07', 'BT', 'Bhutan', 'SEARO', '2', '230', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9450, '2020-09-08', 'BT', 'Bhutan', 'SEARO', '3', '233', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9451, '2020-09-09', 'BT', 'Bhutan', 'SEARO', '1', '234', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9452, '2020-09-10', 'BT', 'Bhutan', 'SEARO', '0', '234', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9453, '2020-09-11', 'BT', 'Bhutan', 'SEARO', '4', '238', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9454, '2020-09-12', 'BT', 'Bhutan', 'SEARO', '3', '241', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9455, '2020-09-13', 'BT', 'Bhutan', 'SEARO', '3', '244', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9456, '2020-09-14', 'BT', 'Bhutan', 'SEARO', '1', '245', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9457, '2020-09-15', 'BT', 'Bhutan', 'SEARO', '1', '246', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9458, '2020-09-16', 'BT', 'Bhutan', 'SEARO', '0', '246', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9459, '2020-09-17', 'BT', 'Bhutan', 'SEARO', '0', '246', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9460, '2020-09-18', 'BT', 'Bhutan', 'SEARO', '6', '252', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9461, '2020-09-19', 'BT', 'Bhutan', 'SEARO', '6', '258', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9462, '2020-09-20', 'BT', 'Bhutan', 'SEARO', '1', '259', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9463, '2020-09-21', 'BT', 'Bhutan', 'SEARO', '2', '261', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9464, '2020-09-22', 'BT', 'Bhutan', 'SEARO', '0', '261', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9465, '2020-09-23', 'BT', 'Bhutan', 'SEARO', '0', '261', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9466, '2020-09-24', 'BT', 'Bhutan', 'SEARO', '0', '261', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9467, '2020-09-25', 'BT', 'Bhutan', 'SEARO', '2', '263', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9468, '2020-09-26', 'BT', 'Bhutan', 'SEARO', '0', '263', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9469, '2020-09-27', 'BT', 'Bhutan', 'SEARO', '8', '271', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9470, '2020-09-28', 'BT', 'Bhutan', 'SEARO', '2', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9471, '2020-09-29', 'BT', 'Bhutan', 'SEARO', '7', '280', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9472, '2020-09-30', 'BT', 'Bhutan', 'SEARO', '1', '281', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9473, '2020-10-01', 'BT', 'Bhutan', 'SEARO', '1', '282', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9474, '2020-10-02', 'BT', 'Bhutan', 'SEARO', '0', '282', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9475, '2020-10-03', 'BT', 'Bhutan', 'SEARO', '1', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9476, '2020-10-04', 'BT', 'Bhutan', 'SEARO', '0', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9477, '2020-10-05', 'BT', 'Bhutan', 'SEARO', '15', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9478, '2020-10-06', 'BT', 'Bhutan', 'SEARO', '1', '299', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9479, '2020-10-07', 'BT', 'Bhutan', 'SEARO', '1', '300', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9480, '2020-10-08', 'BT', 'Bhutan', 'SEARO', '4', '304', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9481, '2020-10-09', 'BT', 'Bhutan', 'SEARO', '0', '304', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9482, '2020-10-10', 'BT', 'Bhutan', 'SEARO', '2', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9483, '2020-10-11', 'BT', 'Bhutan', 'SEARO', '0', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9484, '2020-10-12', 'BT', 'Bhutan', 'SEARO', '3', '309', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9485, '2020-10-13', 'BT', 'Bhutan', 'SEARO', '0', '309', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9486, '2020-10-14', 'BT', 'Bhutan', 'SEARO', '4', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9487, '2020-10-15', 'BT', 'Bhutan', 'SEARO', '3', '316', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9488, '2020-10-16', 'BT', 'Bhutan', 'SEARO', '0', '316', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9489, '2020-10-17', 'BT', 'Bhutan', 'SEARO', '0', '316', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9490, '2020-10-18', 'BT', 'Bhutan', 'SEARO', '9', '325', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9491, '2020-10-19', 'BT', 'Bhutan', 'SEARO', '2', '327', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9492, '2020-10-20', 'BT', 'Bhutan', 'SEARO', '3', '330', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9493, '2020-10-21', 'BT', 'Bhutan', 'SEARO', '1', '331', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9494, '2020-10-22', 'BT', 'Bhutan', 'SEARO', '1', '332', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9495, '2020-10-23', 'BT', 'Bhutan', 'SEARO', '4', '336', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9496, '2020-10-24', 'BT', 'Bhutan', 'SEARO', '0', '336', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9497, '2020-10-25', 'BT', 'Bhutan', 'SEARO', '4', '340', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9498, '2020-10-26', 'BT', 'Bhutan', 'SEARO', '2', '342', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9499, '2020-10-27', 'BT', 'Bhutan', 'SEARO', '0', '342', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9500, '2020-10-28', 'BT', 'Bhutan', 'SEARO', '3', '345', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9501, '2020-10-29', 'BT', 'Bhutan', 'SEARO', '1', '346', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9502, '2020-10-30', 'BT', 'Bhutan', 'SEARO', '0', '346', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9503, '2020-10-31', 'BT', 'Bhutan', 'SEARO', '2', '348', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9504, '2020-11-01', 'BT', 'Bhutan', 'SEARO', '1', '349', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9505, '2020-11-02', 'BT', 'Bhutan', 'SEARO', '5', '354', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9506, '2020-11-03', 'BT', 'Bhutan', 'SEARO', '2', '356', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9507, '2020-11-04', 'BT', 'Bhutan', 'SEARO', '2', '358', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9508, '2020-11-05', 'BT', 'Bhutan', 'SEARO', '0', '358', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9509, '2020-11-06', 'BT', 'Bhutan', 'SEARO', '0', '358', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9510, '2020-11-07', 'BT', 'Bhutan', 'SEARO', '0', '358', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9511, '2020-11-08', 'BT', 'Bhutan', 'SEARO', '1', '359', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9512, '2020-11-09', 'BT', 'Bhutan', 'SEARO', '0', '359', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9513, '2020-11-10', 'BT', 'Bhutan', 'SEARO', '5', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9514, '2020-11-11', 'BT', 'Bhutan', 'SEARO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9515, '2020-11-12', 'BT', 'Bhutan', 'SEARO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9516, '2020-11-13', 'BT', 'Bhutan', 'SEARO', '5', '369', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9517, '2020-11-14', 'BT', 'Bhutan', 'SEARO', '0', '369', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9518, '2020-11-15', 'BT', 'Bhutan', 'SEARO', '6', '375', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9519, '2020-11-16', 'BT', 'Bhutan', 'SEARO', '0', '375', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9520, '2020-11-17', 'BT', 'Bhutan', 'SEARO', '2', '377', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9521, '2020-11-18', 'BT', 'Bhutan', 'SEARO', '1', '378', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9522, '2020-11-19', 'BT', 'Bhutan', 'SEARO', '0', '378', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9523, '2020-11-20', 'BT', 'Bhutan', 'SEARO', '0', '378', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9524, '2020-11-21', 'BT', 'Bhutan', 'SEARO', '0', '378', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9525, '2020-11-22', 'BT', 'Bhutan', 'SEARO', '1', '379', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9526, '2020-11-23', 'BT', 'Bhutan', 'SEARO', '3', '382', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9527, '2020-11-24', 'BT', 'Bhutan', 'SEARO', '4', '386', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9528, '2020-11-25', 'BT', 'Bhutan', 'SEARO', '0', '386', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9529, '2020-11-26', 'BT', 'Bhutan', 'SEARO', '0', '386', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9530, '2020-11-27', 'BT', 'Bhutan', 'SEARO', '3', '389', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9531, '2020-11-28', 'BT', 'Bhutan', 'SEARO', '6', '395', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9532, '2020-11-29', 'BT', 'Bhutan', 'SEARO', '1', '396', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9533, '2020-11-30', 'BT', 'Bhutan', 'SEARO', '0', '396', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9534, '2020-12-01', 'BT', 'Bhutan', 'SEARO', '14', '410', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9535, '2020-12-02', 'BT', 'Bhutan', 'SEARO', '4', '414', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9536, '2020-12-03', 'BT', 'Bhutan', 'SEARO', '1', '415', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9537, '2020-12-04', 'BT', 'Bhutan', 'SEARO', '3', '418', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9538, '2020-12-05', 'BT', 'Bhutan', 'SEARO', '6', '424', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9539, '2020-12-06', 'BT', 'Bhutan', 'SEARO', '2', '426', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9540, '2020-12-07', 'BT', 'Bhutan', 'SEARO', '4', '430', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9541, '2020-12-08', 'BT', 'Bhutan', 'SEARO', '2', '432', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9542, '2020-12-09', 'BT', 'Bhutan', 'SEARO', '1', '433', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9543, '2020-12-10', 'BT', 'Bhutan', 'SEARO', '0', '433', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9544, '2020-12-11', 'BT', 'Bhutan', 'SEARO', '1', '434', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9545, '2020-12-12', 'BT', 'Bhutan', 'SEARO', '2', '436', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9546, '2020-12-13', 'BT', 'Bhutan', 'SEARO', '1', '437', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9547, '2020-12-14', 'BT', 'Bhutan', 'SEARO', '1', '438', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9548, '2020-12-15', 'BT', 'Bhutan', 'SEARO', '0', '438', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9549, '2020-12-16', 'BT', 'Bhutan', 'SEARO', '1', '439', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9550, '2020-12-17', 'BT', 'Bhutan', 'SEARO', '1', '440', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9551, '2020-12-18', 'BT', 'Bhutan', 'SEARO', '2', '442', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9552, '2020-12-19', 'BT', 'Bhutan', 'SEARO', '1', '443', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9553, '2020-12-20', 'BT', 'Bhutan', 'SEARO', '3', '446', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9554, '2020-12-21', 'BT', 'Bhutan', 'SEARO', '21', '467', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9555, '2020-12-22', 'BT', 'Bhutan', 'SEARO', '12', '479', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9556, '2020-12-23', 'BT', 'Bhutan', 'SEARO', '3', '482', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9557, '2020-12-24', 'BT', 'Bhutan', 'SEARO', '37', '519', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9558, '2020-12-25', 'BT', 'Bhutan', 'SEARO', '22', '541', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9559, '2020-12-26', 'BT', 'Bhutan', 'SEARO', '35', '576', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9560, '2020-12-27', 'BT', 'Bhutan', 'SEARO', '21', '597', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9561, '2020-12-28', 'BT', 'Bhutan', 'SEARO', '26', '623', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9562, '2020-12-29', 'BT', 'Bhutan', 'SEARO', '0', '623', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9563, '2020-12-30', 'BT', 'Bhutan', 'SEARO', '13', '636', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9564, '2020-12-31', 'BT', 'Bhutan', 'SEARO', '19', '655', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9565, '2021-01-01', 'BT', 'Bhutan', 'SEARO', '15', '670', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9566, '2021-01-02', 'BT', 'Bhutan', 'SEARO', '19', '689', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9567, '2021-01-03', 'BT', 'Bhutan', 'SEARO', '21', '710', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9568, '2021-01-04', 'BT', 'Bhutan', 'SEARO', '6', '716', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9569, '2021-01-05', 'BT', 'Bhutan', 'SEARO', '18', '734', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9570, '2021-01-06', 'BT', 'Bhutan', 'SEARO', '0', '734', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9571, '2021-01-07', 'BT', 'Bhutan', 'SEARO', '21', '755', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9572, '2021-01-08', 'BT', 'Bhutan', 'SEARO', '12', '767', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9573, '2021-01-09', 'BT', 'Bhutan', 'SEARO', '4', '771', '1', '1');
INSERT INTO public.who_global_data_import VALUES (9574, '2021-01-10', 'BT', 'Bhutan', 'SEARO', '39', '810', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9575, '2021-01-11', 'BT', 'Bhutan', 'SEARO', '3', '813', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9576, '2021-01-12', 'BT', 'Bhutan', 'SEARO', '12', '825', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9577, '2021-01-13', 'BT', 'Bhutan', 'SEARO', '6', '831', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9578, '2021-01-14', 'BT', 'Bhutan', 'SEARO', '2', '833', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9579, '2021-01-15', 'BT', 'Bhutan', 'SEARO', '1', '834', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9580, '2021-01-16', 'BT', 'Bhutan', 'SEARO', '3', '837', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9581, '2021-01-17', 'BT', 'Bhutan', 'SEARO', '5', '842', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9582, '2021-01-18', 'BT', 'Bhutan', 'SEARO', '0', '842', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9583, '2021-01-19', 'BT', 'Bhutan', 'SEARO', '1', '843', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9584, '2021-01-20', 'BT', 'Bhutan', 'SEARO', '5', '848', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9585, '2021-01-21', 'BT', 'Bhutan', 'SEARO', '2', '850', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9586, '2021-01-22', 'BT', 'Bhutan', 'SEARO', '1', '851', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9587, '2021-01-23', 'BT', 'Bhutan', 'SEARO', '0', '851', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9588, '2021-01-24', 'BT', 'Bhutan', 'SEARO', '3', '854', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9589, '2021-01-25', 'BT', 'Bhutan', 'SEARO', '1', '855', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9590, '2021-01-26', 'BT', 'Bhutan', 'SEARO', '1', '856', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9591, '2021-01-27', 'BT', 'Bhutan', 'SEARO', '0', '856', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9592, '2021-01-28', 'BT', 'Bhutan', 'SEARO', '0', '856', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9593, '2021-01-29', 'BT', 'Bhutan', 'SEARO', '1', '857', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9594, '2021-01-30', 'BT', 'Bhutan', 'SEARO', '1', '858', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9595, '2021-01-31', 'BT', 'Bhutan', 'SEARO', '0', '858', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9596, '2021-02-01', 'BT', 'Bhutan', 'SEARO', '1', '859', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9597, '2021-02-02', 'BT', 'Bhutan', 'SEARO', '0', '859', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9598, '2021-02-03', 'BT', 'Bhutan', 'SEARO', '0', '859', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9599, '2021-02-04', 'BT', 'Bhutan', 'SEARO', '0', '859', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9600, '2021-02-05', 'BT', 'Bhutan', 'SEARO', '0', '859', '0', '1');
INSERT INTO public.who_global_data_import VALUES (9601, '2020-01-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9602, '2020-01-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9603, '2020-01-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9604, '2020-01-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9605, '2020-01-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9606, '2020-01-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9607, '2020-01-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9608, '2020-01-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9609, '2020-01-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9610, '2020-01-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9611, '2020-01-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9612, '2020-01-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9613, '2020-01-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9614, '2020-01-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9615, '2020-01-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9616, '2020-01-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9617, '2020-01-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9618, '2020-01-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9619, '2020-01-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9620, '2020-01-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9621, '2020-01-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9622, '2020-01-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9623, '2020-01-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9624, '2020-01-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9625, '2020-01-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9626, '2020-01-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9627, '2020-01-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9628, '2020-01-30', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9629, '2020-01-31', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9630, '2020-02-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9631, '2020-02-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9632, '2020-02-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9633, '2020-02-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9634, '2020-02-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9635, '2020-02-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9636, '2020-02-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9637, '2020-02-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9638, '2020-02-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9639, '2020-02-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9640, '2020-02-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9641, '2020-02-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9642, '2020-02-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9643, '2020-02-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9644, '2020-02-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9645, '2020-02-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9646, '2020-02-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9647, '2020-02-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9648, '2020-02-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9649, '2020-02-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9650, '2020-02-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9651, '2020-02-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9652, '2020-02-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9653, '2020-02-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9654, '2020-02-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9655, '2020-02-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9656, '2020-02-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9657, '2020-02-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9658, '2020-02-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9659, '2020-03-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9660, '2020-03-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9661, '2020-03-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9662, '2020-03-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9663, '2020-03-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9664, '2020-03-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9665, '2020-03-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9666, '2020-03-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9667, '2020-03-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9668, '2020-03-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9669, '2020-03-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9670, '2020-03-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9671, '2020-03-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9672, '2020-03-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9673, '2020-03-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9674, '2020-03-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '8', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9675, '2020-03-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9676, '2020-03-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9677, '2020-03-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '-1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9678, '2020-03-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9679, '2020-03-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '3', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9680, '2020-03-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9681, '2020-03-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '5', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9682, '2020-03-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '4', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9683, '2020-03-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9684, '2020-03-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '11', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9685, '2020-03-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9686, '2020-03-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '22', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9687, '2020-03-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '13', '74', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9688, '2020-03-30', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '74', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9689, '2020-03-31', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '23', '97', '5', '5');
INSERT INTO public.who_global_data_import VALUES (9690, '2020-04-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '10', '107', '1', '6');
INSERT INTO public.who_global_data_import VALUES (9691, '2020-04-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '8', '115', '1', '7');
INSERT INTO public.who_global_data_import VALUES (9692, '2020-04-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '8', '123', '1', '8');
INSERT INTO public.who_global_data_import VALUES (9693, '2020-04-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '9', '132', '1', '9');
INSERT INTO public.who_global_data_import VALUES (9694, '2020-04-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '7', '139', '1', '10');
INSERT INTO public.who_global_data_import VALUES (9695, '2020-04-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '18', '157', '0', '10');
INSERT INTO public.who_global_data_import VALUES (9696, '2020-04-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '26', '183', '1', '11');
INSERT INTO public.who_global_data_import VALUES (9697, '2020-04-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '11', '194', '3', '14');
INSERT INTO public.who_global_data_import VALUES (9698, '2020-04-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '16', '210', '1', '15');
INSERT INTO public.who_global_data_import VALUES (9699, '2020-04-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '54', '264', '3', '18');
INSERT INTO public.who_global_data_import VALUES (9700, '2020-04-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '4', '268', '1', '19');
INSERT INTO public.who_global_data_import VALUES (9701, '2020-04-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '7', '275', '1', '20');
INSERT INTO public.who_global_data_import VALUES (9702, '2020-04-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '25', '300', '4', '24');
INSERT INTO public.who_global_data_import VALUES (9703, '2020-04-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '30', '330', '3', '27');
INSERT INTO public.who_global_data_import VALUES (9704, '2020-04-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '24', '354', '1', '28');
INSERT INTO public.who_global_data_import VALUES (9705, '2020-04-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '43', '397', '0', '28');
INSERT INTO public.who_global_data_import VALUES (9706, '2020-04-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '44', '441', '1', '29');
INSERT INTO public.who_global_data_import VALUES (9707, '2020-04-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '24', '465', '2', '31');
INSERT INTO public.who_global_data_import VALUES (9708, '2020-04-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '28', '493', '0', '31');
INSERT INTO public.who_global_data_import VALUES (9709, '2020-04-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '27', '520', '1', '32');
INSERT INTO public.who_global_data_import VALUES (9710, '2020-04-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '44', '564', '1', '33');
INSERT INTO public.who_global_data_import VALUES (9711, '2020-04-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '34', '598', '1', '34');
INSERT INTO public.who_global_data_import VALUES (9712, '2020-04-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '11', '609', '3', '37');
INSERT INTO public.who_global_data_import VALUES (9713, '2020-04-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '63', '672', '3', '40');
INSERT INTO public.who_global_data_import VALUES (9714, '2020-04-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '31', '703', '3', '43');
INSERT INTO public.who_global_data_import VALUES (9715, '2020-04-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '104', '807', '1', '44');
INSERT INTO public.who_global_data_import VALUES (9716, '2020-04-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '59', '866', '2', '46');
INSERT INTO public.who_global_data_import VALUES (9717, '2020-04-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '84', '950', '4', '50');
INSERT INTO public.who_global_data_import VALUES (9718, '2020-04-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '64', '1014', '3', '53');
INSERT INTO public.who_global_data_import VALUES (9719, '2020-04-30', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '39', '1053', '2', '55');
INSERT INTO public.who_global_data_import VALUES (9720, '2020-05-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '57', '1110', '4', '59');
INSERT INTO public.who_global_data_import VALUES (9721, '2020-05-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '57', '1167', '3', '62');
INSERT INTO public.who_global_data_import VALUES (9722, '2020-05-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '62', '1229', '4', '66');
INSERT INTO public.who_global_data_import VALUES (9723, '2020-05-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '241', '1470', '5', '71');
INSERT INTO public.who_global_data_import VALUES (9724, '2020-05-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '124', '1594', '5', '76');
INSERT INTO public.who_global_data_import VALUES (9725, '2020-05-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '87', '1681', '6', '82');
INSERT INTO public.who_global_data_import VALUES (9726, '2020-05-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '121', '1802', '4', '86');
INSERT INTO public.who_global_data_import VALUES (9727, '2020-05-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '84', '1886', '5', '91');
INSERT INTO public.who_global_data_import VALUES (9728, '2020-05-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '195', '2081', '11', '102');
INSERT INTO public.who_global_data_import VALUES (9729, '2020-05-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '185', '2266', '4', '106');
INSERT INTO public.who_global_data_import VALUES (9730, '2020-05-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '171', '2437', '8', '114');
INSERT INTO public.who_global_data_import VALUES (9731, '2020-05-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '119', '2556', '4', '118');
INSERT INTO public.who_global_data_import VALUES (9732, '2020-05-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '275', '2831', '4', '122');
INSERT INTO public.who_global_data_import VALUES (9733, '2020-05-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '133', '2964', '6', '128');
INSERT INTO public.who_global_data_import VALUES (9734, '2020-05-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '184', '3148', '14', '142');
INSERT INTO public.who_global_data_import VALUES (9735, '2020-05-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '224', '3372', '10', '152');
INSERT INTO public.who_global_data_import VALUES (9736, '2020-05-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '205', '3577', '12', '164');
INSERT INTO public.who_global_data_import VALUES (9737, '2020-05-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '249', '3826', '1', '165');
INSERT INTO public.who_global_data_import VALUES (9738, '2020-05-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '262', '4088', '4', '169');
INSERT INTO public.who_global_data_import VALUES (9739, '2020-05-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '175', '4263', '5', '174');
INSERT INTO public.who_global_data_import VALUES (9740, '2020-05-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '218', '4481', '15', '189');
INSERT INTO public.who_global_data_import VALUES (9741, '2020-05-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '438', '4919', '10', '199');
INSERT INTO public.who_global_data_import VALUES (9742, '2020-05-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '268', '5187', '16', '215');
INSERT INTO public.who_global_data_import VALUES (9743, '2020-05-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '392', '5579', '15', '230');
INSERT INTO public.who_global_data_import VALUES (9744, '2020-05-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '336', '5915', '10', '240');
INSERT INTO public.who_global_data_import VALUES (9745, '2020-05-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '348', '6263', '10', '250');
INSERT INTO public.who_global_data_import VALUES (9746, '2020-05-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '397', '6660', '11', '261');
INSERT INTO public.who_global_data_import VALUES (9747, '2020-05-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '476', '7136', '13', '274');
INSERT INTO public.who_global_data_import VALUES (9748, '2020-05-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '632', '7768', '6', '280');
INSERT INTO public.who_global_data_import VALUES (9749, '2020-05-30', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '619', '8387', '13', '293');
INSERT INTO public.who_global_data_import VALUES (9750, '2020-05-31', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '344', '8731', '7', '300');
INSERT INTO public.who_global_data_import VALUES (9751, '2020-06-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '861', '9592', '10', '310');
INSERT INTO public.who_global_data_import VALUES (9752, '2020-06-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '390', '9982', '3', '313');
INSERT INTO public.who_global_data_import VALUES (9753, '2020-06-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '549', '10531', '30', '343');
INSERT INTO public.who_global_data_import VALUES (9754, '2020-06-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '460', '10991', '33', '376');
INSERT INTO public.who_global_data_import VALUES (9755, '2020-06-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '647', '11638', '24', '400');
INSERT INTO public.who_global_data_import VALUES (9756, '2020-06-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '607', '12245', '15', '415');
INSERT INTO public.who_global_data_import VALUES (9757, '2020-06-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '483', '12728', '12', '427');
INSERT INTO public.who_global_data_import VALUES (9758, '2020-06-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '630', '13358', '27', '454');
INSERT INTO public.who_global_data_import VALUES (9759, '2020-06-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '285', '13643', '11', '465');
INSERT INTO public.who_global_data_import VALUES (9760, '2020-06-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '306', '13949', '10', '475');
INSERT INTO public.who_global_data_import VALUES (9761, '2020-06-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '695', '14644', '12', '487');
INSERT INTO public.who_global_data_import VALUES (9762, '2020-06-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '637', '15281', '25', '512');
INSERT INTO public.who_global_data_import VALUES (9763, '2020-06-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '884', '16165', '21', '533');
INSERT INTO public.who_global_data_import VALUES (9764, '2020-06-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '764', '16929', '26', '559');
INSERT INTO public.who_global_data_import VALUES (9765, '2020-06-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '913', '17842', '26', '585');
INSERT INTO public.who_global_data_import VALUES (9766, '2020-06-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '617', '18459', '26', '611');
INSERT INTO public.who_global_data_import VALUES (9767, '2020-06-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '614', '19073', '21', '632');
INSERT INTO public.who_global_data_import VALUES (9768, '2020-06-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '810', '19883', '27', '659');
INSERT INTO public.who_global_data_import VALUES (9769, '2020-06-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '802', '20685', '20', '679');
INSERT INTO public.who_global_data_import VALUES (9770, '2020-06-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '814', '21499', '18', '697');
INSERT INTO public.who_global_data_import VALUES (9771, '2020-06-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '977', '22476', '18', '715');
INSERT INTO public.who_global_data_import VALUES (9772, '2020-06-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1036', '23512', '25', '740');
INSERT INTO public.who_global_data_import VALUES (9773, '2020-06-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '876', '24388', '33', '773');
INSERT INTO public.who_global_data_import VALUES (9774, '2020-06-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1105', '25493', '47', '820');
INSERT INTO public.who_global_data_import VALUES (9775, '2020-06-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '896', '26389', '26', '846');
INSERT INTO public.who_global_data_import VALUES (9776, '2020-06-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1098', '27487', '30', '876');
INSERT INTO public.who_global_data_import VALUES (9777, '2020-06-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1016', '28503', '37', '913');
INSERT INTO public.who_global_data_import VALUES (9778, '2020-06-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '920', '29423', '21', '934');
INSERT INTO public.who_global_data_import VALUES (9779, '2020-06-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1253', '30676', '36', '970');
INSERT INTO public.who_global_data_import VALUES (9780, '2020-06-30', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '848', '31524', '44', '1014');
INSERT INTO public.who_global_data_import VALUES (9781, '2020-07-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '601', '32125', '57', '1071');
INSERT INTO public.who_global_data_import VALUES (9782, '2020-07-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1094', '33219', '52', '1123');
INSERT INTO public.who_global_data_import VALUES (9783, '2020-07-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1008', '34227', '78', '1201');
INSERT INTO public.who_global_data_import VALUES (9784, '2020-07-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1301', '35528', '70', '1271');
INSERT INTO public.who_global_data_import VALUES (9785, '2020-07-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1290', '36818', '49', '1320');
INSERT INTO public.who_global_data_import VALUES (9786, '2020-07-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1253', '38071', '58', '1378');
INSERT INTO public.who_global_data_import VALUES (9787, '2020-07-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1226', '39297', '56', '1434');
INSERT INTO public.who_global_data_import VALUES (9788, '2020-07-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1212', '40509', '42', '1476');
INSERT INTO public.who_global_data_import VALUES (9789, '2020-07-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1036', '41545', '54', '1530');
INSERT INTO public.who_global_data_import VALUES (9790, '2020-07-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1439', '42984', '47', '1577');
INSERT INTO public.who_global_data_import VALUES (9791, '2020-07-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1129', '44113', '61', '1638');
INSERT INTO public.who_global_data_import VALUES (9792, '2020-07-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1452', '45565', '64', '1702');
INSERT INTO public.who_global_data_import VALUES (9793, '2020-07-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1635', '47200', '52', '1754');
INSERT INTO public.who_global_data_import VALUES (9794, '2020-07-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '987', '48187', '53', '1807');
INSERT INTO public.who_global_data_import VALUES (9795, '2020-07-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1063', '49250', '59', '1866');
INSERT INTO public.who_global_data_import VALUES (9796, '2020-07-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1617', '50867', '32', '1898');
INSERT INTO public.who_global_data_import VALUES (9797, '2020-07-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1351', '52218', '44', '1942');
INSERT INTO public.who_global_data_import VALUES (9798, '2020-07-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1938', '54156', '42', '1984');
INSERT INTO public.who_global_data_import VALUES (9799, '2020-07-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1946', '56102', '65', '2049');
INSERT INTO public.who_global_data_import VALUES (9800, '2020-07-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2036', '58138', '57', '2106');
INSERT INTO public.who_global_data_import VALUES (9801, '2020-07-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1444', '59582', '45', '2151');
INSERT INTO public.who_global_data_import VALUES (9802, '2020-07-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1409', '60991', '67', '2218');
INSERT INTO public.who_global_data_import VALUES (9803, '2020-07-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1366', '62357', '55', '2273');
INSERT INTO public.who_global_data_import VALUES (9804, '2020-07-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1778', '64135', '55', '2328');
INSERT INTO public.who_global_data_import VALUES (9805, '2020-07-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1117', '65252', '79', '2407');
INSERT INTO public.who_global_data_import VALUES (9806, '2020-07-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1204', '66456', '66', '2473');
INSERT INTO public.who_global_data_import VALUES (9807, '2020-07-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1825', '68281', '62', '2535');
INSERT INTO public.who_global_data_import VALUES (9808, '2020-07-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1148', '69429', '48', '2583');
INSERT INTO public.who_global_data_import VALUES (9809, '2020-07-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1752', '71181', '64', '2647');
INSERT INTO public.who_global_data_import VALUES (9810, '2020-07-30', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1146', '72327', '73', '2720');
INSERT INTO public.who_global_data_import VALUES (9811, '2020-07-31', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1207', '73534', '88', '2808');
INSERT INTO public.who_global_data_import VALUES (9812, '2020-08-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1700', '75234', '86', '2894');
INSERT INTO public.who_global_data_import VALUES (9813, '2020-08-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1555', '76789', '83', '2977');
INSERT INTO public.who_global_data_import VALUES (9814, '2020-08-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2004', '78793', '87', '3064');
INSERT INTO public.who_global_data_import VALUES (9815, '2020-08-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1360', '80153', '89', '3153');
INSERT INTO public.who_global_data_import VALUES (9816, '2020-08-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1693', '81846', '75', '3228');
INSERT INTO public.who_global_data_import VALUES (9817, '2020-08-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1515', '83361', '92', '3320');
INSERT INTO public.who_global_data_import VALUES (9818, '2020-08-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1780', '85141', '65', '3385');
INSERT INTO public.who_global_data_import VALUES (9819, '2020-08-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1282', '86423', '80', '3465');
INSERT INTO public.who_global_data_import VALUES (9820, '2020-08-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1468', '87891', '59', '3524');
INSERT INTO public.who_global_data_import VALUES (9821, '2020-08-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1164', '89055', '63', '3587');
INSERT INTO public.who_global_data_import VALUES (9822, '2020-08-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '944', '89999', '53', '3640');
INSERT INTO public.who_global_data_import VALUES (9823, '2020-08-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1636', '91635', '72', '3712');
INSERT INTO public.who_global_data_import VALUES (9824, '2020-08-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1693', '93328', '49', '3761');
INSERT INTO public.who_global_data_import VALUES (9825, '2020-08-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1743', '95071', '66', '3827');
INSERT INTO public.who_global_data_import VALUES (9826, '2020-08-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1388', '96459', '57', '3884');
INSERT INTO public.who_global_data_import VALUES (9827, '2020-08-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1491', '97950', '55', '3939');
INSERT INTO public.who_global_data_import VALUES (9828, '2020-08-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1196', '99146', '64', '4003');
INSERT INTO public.who_global_data_import VALUES (9829, '2020-08-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1198', '100344', '45', '4048');
INSERT INTO public.who_global_data_import VALUES (9830, '2020-08-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '879', '101223', '75', '4123');
INSERT INTO public.who_global_data_import VALUES (9831, '2020-08-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1796', '103019', '49', '4172');
INSERT INTO public.who_global_data_import VALUES (9832, '2020-08-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2031', '105050', '61', '4233');
INSERT INTO public.who_global_data_import VALUES (9833, '2020-08-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1015', '106065', '72', '4305');
INSERT INTO public.who_global_data_import VALUES (9834, '2020-08-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1370', '107435', '61', '4366');
INSERT INTO public.who_global_data_import VALUES (9835, '2020-08-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '992', '108427', '76', '4442');
INSERT INTO public.who_global_data_import VALUES (9836, '2020-08-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '722', '109149', '67', '4509');
INSERT INTO public.who_global_data_import VALUES (9837, '2020-08-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '999', '110148', '69', '4578');
INSERT INTO public.who_global_data_import VALUES (9838, '2020-08-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '851', '110999', '86', '4664');
INSERT INTO public.who_global_data_import VALUES (9839, '2020-08-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1095', '112094', '62', '4726');
INSERT INTO public.who_global_data_import VALUES (9840, '2020-08-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1035', '113129', '65', '4791');
INSERT INTO public.who_global_data_import VALUES (9841, '2020-08-30', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1280', '114409', '55', '4846');
INSERT INTO public.who_global_data_import VALUES (9842, '2020-08-31', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '945', '115354', '92', '4938');
INSERT INTO public.who_global_data_import VALUES (9843, '2020-09-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '614', '115968', '28', '4966');
INSERT INTO public.who_global_data_import VALUES (9844, '2020-09-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '630', '116598', '61', '5027');
INSERT INTO public.who_global_data_import VALUES (9845, '2020-09-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '669', '117267', '74', '5101');
INSERT INTO public.who_global_data_import VALUES (9846, '2020-09-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '661', '117928', '102', '5203');
INSERT INTO public.who_global_data_import VALUES (9847, '2020-09-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '853', '118781', '85', '5288');
INSERT INTO public.who_global_data_import VALUES (9848, '2020-09-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '799', '119580', '55', '5343');
INSERT INTO public.who_global_data_import VALUES (9849, '2020-09-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '661', '120241', '55', '5398');
INSERT INTO public.who_global_data_import VALUES (9850, '2020-09-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '528', '120769', '1610', '7008');
INSERT INTO public.who_global_data_import VALUES (9851, '2020-09-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '835', '121604', '46', '7054');
INSERT INTO public.who_global_data_import VALUES (9852, '2020-09-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '704', '122308', '43', '7097');
INSERT INTO public.who_global_data_import VALUES (9853, '2020-09-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1037', '123345', '49', '7146');
INSERT INTO public.who_global_data_import VALUES (9854, '2020-09-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '860', '124205', '47', '7193');
INSERT INTO public.who_global_data_import VALUES (9855, '2020-09-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '967', '125172', '57', '7250');
INSERT INTO public.who_global_data_import VALUES (9856, '2020-09-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '810', '125982', '47', '7297');
INSERT INTO public.who_global_data_import VALUES (9857, '2020-09-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '809', '126791', '47', '7344');
INSERT INTO public.who_global_data_import VALUES (9858, '2020-09-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '828', '127619', '50', '7394');
INSERT INTO public.who_global_data_import VALUES (9859, '2020-09-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '667', '128286', '53', '7447');
INSERT INTO public.who_global_data_import VALUES (9860, '2020-09-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '586', '128872', '31', '7478');
INSERT INTO public.who_global_data_import VALUES (9861, '2020-09-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '547', '129419', '33', '7511');
INSERT INTO public.who_global_data_import VALUES (9862, '2020-09-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '632', '130051', '39', '7550');
INSERT INTO public.who_global_data_import VALUES (9863, '2020-09-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '419', '130470', '36', '7586');
INSERT INTO public.who_global_data_import VALUES (9864, '2020-09-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '206', '130676', '31', '7617');
INSERT INTO public.who_global_data_import VALUES (9865, '2020-09-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '310', '130986', '37', '7654');
INSERT INTO public.who_global_data_import VALUES (9866, '2020-09-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '467', '131453', '39', '7693');
INSERT INTO public.who_global_data_import VALUES (9867, '2020-09-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '537', '131990', '38', '7731');
INSERT INTO public.who_global_data_import VALUES (9868, '2020-09-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '628', '132618', '34', '7765');
INSERT INTO public.who_global_data_import VALUES (10030, '2020-02-01', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9869, '2020-09-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '604', '133222', '35', '7800');
INSERT INTO public.who_global_data_import VALUES (9870, '2020-09-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '370', '133592', '28', '7828');
INSERT INTO public.who_global_data_import VALUES (9871, '2020-09-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '309', '133901', '30', '7858');
INSERT INTO public.who_global_data_import VALUES (9872, '2020-09-30', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '322', '134223', '42', '7900');
INSERT INTO public.who_global_data_import VALUES (9873, '2020-10-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '418', '134641', '31', '7931');
INSERT INTO public.who_global_data_import VALUES (9874, '2020-10-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '670', '135311', '34', '7965');
INSERT INTO public.who_global_data_import VALUES (9875, '2020-10-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '405', '135716', '36', '8001');
INSERT INTO public.who_global_data_import VALUES (9876, '2020-10-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '503', '136219', '44', '8045');
INSERT INTO public.who_global_data_import VALUES (9877, '2020-10-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '350', '136569', '28', '8073');
INSERT INTO public.who_global_data_import VALUES (9878, '2020-10-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '299', '136868', '28', '8101');
INSERT INTO public.who_global_data_import VALUES (9879, '2020-10-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '239', '137107', '28', '8129');
INSERT INTO public.who_global_data_import VALUES (9880, '2020-10-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '361', '137468', '27', '8156');
INSERT INTO public.who_global_data_import VALUES (9881, '2020-10-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '238', '137706', '36', '8192');
INSERT INTO public.who_global_data_import VALUES (9882, '2020-10-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '263', '137969', '36', '8228');
INSERT INTO public.who_global_data_import VALUES (9883, '2020-10-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '257', '138226', '34', '8262');
INSERT INTO public.who_global_data_import VALUES (9884, '2020-10-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '237', '138463', '30', '8292');
INSERT INTO public.who_global_data_import VALUES (9885, '2020-10-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '111', '138574', '16', '8308');
INSERT INTO public.who_global_data_import VALUES (9886, '2020-10-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '121', '138695', '18', '8326');
INSERT INTO public.who_global_data_import VALUES (9887, '2020-10-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '227', '138922', '25', '8351');
INSERT INTO public.who_global_data_import VALUES (9888, '2020-10-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '219', '139141', '26', '8377');
INSERT INTO public.who_global_data_import VALUES (9889, '2020-10-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '178', '139319', '30', '8407');
INSERT INTO public.who_global_data_import VALUES (9890, '2020-10-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '243', '139562', '32', '8439');
INSERT INTO public.who_global_data_import VALUES (9891, '2020-10-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '148', '139710', '24', '8463');
INSERT INTO public.who_global_data_import VALUES (9892, '2020-10-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '61', '139771', '18', '8481');
INSERT INTO public.who_global_data_import VALUES (9893, '2020-10-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '119', '139890', '21', '8502');
INSERT INTO public.who_global_data_import VALUES (9894, '2020-10-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '147', '140037', '24', '8526');
INSERT INTO public.who_global_data_import VALUES (9895, '2020-10-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '191', '140228', '32', '8558');
INSERT INTO public.who_global_data_import VALUES (9896, '2020-10-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '217', '140445', '26', '8584');
INSERT INTO public.who_global_data_import VALUES (9897, '2020-10-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '167', '140612', '24', '8608');
INSERT INTO public.who_global_data_import VALUES (9898, '2020-10-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '167', '140779', '19', '8627');
INSERT INTO public.who_global_data_import VALUES (9899, '2020-10-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '74', '140853', '18', '8645');
INSERT INTO public.who_global_data_import VALUES (9900, '2020-10-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '99', '140952', '13', '8658');
INSERT INTO public.who_global_data_import VALUES (9901, '2020-10-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '172', '141124', '14', '8672');
INSERT INTO public.who_global_data_import VALUES (9902, '2020-10-30', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '197', '141321', '22', '8694');
INSERT INTO public.who_global_data_import VALUES (9903, '2020-10-31', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '163', '141484', '11', '8705');
INSERT INTO public.who_global_data_import VALUES (9904, '2020-11-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '147', '141631', '10', '8715');
INSERT INTO public.who_global_data_import VALUES (9905, '2020-11-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '126', '141757', '10', '8725');
INSERT INTO public.who_global_data_import VALUES (9906, '2020-11-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '76', '141833', '6', '8731');
INSERT INTO public.who_global_data_import VALUES (9907, '2020-11-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '34', '141867', '10', '8741');
INSERT INTO public.who_global_data_import VALUES (9908, '2020-11-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '69', '141936', '10', '8751');
INSERT INTO public.who_global_data_import VALUES (9909, '2020-11-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '126', '142062', '7', '8758');
INSERT INTO public.who_global_data_import VALUES (9910, '2020-11-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '139', '142201', '10', '8768');
INSERT INTO public.who_global_data_import VALUES (9911, '2020-11-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '142', '142343', '13', '8781');
INSERT INTO public.who_global_data_import VALUES (9912, '2020-11-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '84', '142427', '9', '8790');
INSERT INTO public.who_global_data_import VALUES (9913, '2020-11-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '48', '142475', '5', '8795');
INSERT INTO public.who_global_data_import VALUES (9914, '2020-11-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '86', '142561', '7', '8802');
INSERT INTO public.who_global_data_import VALUES (9915, '2020-11-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '103', '142664', '6', '8808');
INSERT INTO public.who_global_data_import VALUES (9916, '2020-11-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '112', '142776', '10', '8818');
INSERT INTO public.who_global_data_import VALUES (9917, '2020-11-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '113', '142889', '7', '8825');
INSERT INTO public.who_global_data_import VALUES (9918, '2020-11-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '180', '143069', '10', '8835');
INSERT INTO public.who_global_data_import VALUES (9919, '2020-11-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '112', '143181', '6', '8841');
INSERT INTO public.who_global_data_import VALUES (9920, '2020-11-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '65', '143246', '8', '8849');
INSERT INTO public.who_global_data_import VALUES (9921, '2020-11-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '125', '143371', '10', '8859');
INSERT INTO public.who_global_data_import VALUES (9922, '2020-11-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '102', '143473', '7', '8866');
INSERT INTO public.who_global_data_import VALUES (9923, '2020-11-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '96', '143569', '9', '8875');
INSERT INTO public.who_global_data_import VALUES (9924, '2020-11-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '187', '143756', '14', '8889');
INSERT INTO public.who_global_data_import VALUES (9925, '2020-11-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '98', '143854', '11', '8900');
INSERT INTO public.who_global_data_import VALUES (9926, '2020-11-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '68', '143922', '4', '8904');
INSERT INTO public.who_global_data_import VALUES (9927, '2020-11-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '56', '143978', '3', '8907');
INSERT INTO public.who_global_data_import VALUES (9928, '2020-11-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '56', '144034', '9', '8916');
INSERT INTO public.who_global_data_import VALUES (9929, '2020-11-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '113', '144147', '12', '8928');
INSERT INTO public.who_global_data_import VALUES (9930, '2020-11-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '129', '144276', '5', '8933');
INSERT INTO public.who_global_data_import VALUES (9931, '2020-11-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '114', '144390', '6', '8939');
INSERT INTO public.who_global_data_import VALUES (9932, '2020-11-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '104', '144494', '4', '8943');
INSERT INTO public.who_global_data_import VALUES (9933, '2020-11-30', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '98', '144592', '6', '8949');
INSERT INTO public.who_global_data_import VALUES (9934, '2020-12-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '30', '144622', '3', '8952');
INSERT INTO public.who_global_data_import VALUES (9935, '2020-12-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '86', '144708', '5', '8957');
INSERT INTO public.who_global_data_import VALUES (9936, '2020-12-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '102', '144810', '6', '8963');
INSERT INTO public.who_global_data_import VALUES (9937, '2020-12-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '184', '144994', '9', '8972');
INSERT INTO public.who_global_data_import VALUES (9938, '2020-12-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '192', '145186', '10', '8982');
INSERT INTO public.who_global_data_import VALUES (9939, '2020-12-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '139', '145325', '5', '8987');
INSERT INTO public.who_global_data_import VALUES (9940, '2020-12-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '167', '145492', '5', '8992');
INSERT INTO public.who_global_data_import VALUES (9941, '2020-12-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '68', '145560', '3', '8995');
INSERT INTO public.who_global_data_import VALUES (9942, '2020-12-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '97', '145657', '2', '8997');
INSERT INTO public.who_global_data_import VALUES (9943, '2020-12-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '189', '145846', '5', '9002');
INSERT INTO public.who_global_data_import VALUES (10031, '2020-02-02', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (9944, '2020-12-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '214', '146060', '2', '9004');
INSERT INTO public.who_global_data_import VALUES (9945, '2020-12-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '325', '146385', '4', '9008');
INSERT INTO public.who_global_data_import VALUES (9946, '2020-12-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '312', '146697', '5', '9013');
INSERT INTO public.who_global_data_import VALUES (9947, '2020-12-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '333', '147030', '1', '9014');
INSERT INTO public.who_global_data_import VALUES (9948, '2020-12-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '120', '147150', '4', '9018');
INSERT INTO public.who_global_data_import VALUES (9949, '2020-12-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '195', '147345', '6', '9024');
INSERT INTO public.who_global_data_import VALUES (9950, '2020-12-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '371', '147716', '2', '9026');
INSERT INTO public.who_global_data_import VALUES (9951, '2020-12-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '498', '148214', '3', '9029');
INSERT INTO public.who_global_data_import VALUES (9952, '2020-12-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '451', '148665', '2', '9031');
INSERT INTO public.who_global_data_import VALUES (9953, '2020-12-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '484', '149149', '2', '9033');
INSERT INTO public.who_global_data_import VALUES (9954, '2020-12-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '621', '149770', '2', '9035');
INSERT INTO public.who_global_data_import VALUES (9955, '2020-12-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '253', '150023', '1', '9036');
INSERT INTO public.who_global_data_import VALUES (9956, '2020-12-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '362', '150385', '7', '9043');
INSERT INTO public.who_global_data_import VALUES (9957, '2020-12-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '674', '151059', '9', '9052');
INSERT INTO public.who_global_data_import VALUES (9958, '2020-12-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1005', '152064', '13', '9065');
INSERT INTO public.who_global_data_import VALUES (9959, '2020-12-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1057', '153121', '11', '9076');
INSERT INTO public.who_global_data_import VALUES (9960, '2020-12-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '469', '153590', '7', '9083');
INSERT INTO public.who_global_data_import VALUES (9961, '2020-12-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '759', '154349', '10', '9093');
INSERT INTO public.who_global_data_import VALUES (9962, '2020-12-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '494', '154843', '5', '9098');
INSERT INTO public.who_global_data_import VALUES (9963, '2020-12-30', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '751', '155594', '8', '9106');
INSERT INTO public.who_global_data_import VALUES (9964, '2020-12-31', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1293', '156887', '29', '9135');
INSERT INTO public.who_global_data_import VALUES (9965, '2021-01-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1485', '158372', '14', '9149');
INSERT INTO public.who_global_data_import VALUES (9966, '2021-01-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1752', '160124', '16', '9165');
INSERT INTO public.who_global_data_import VALUES (9967, '2021-01-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1931', '162055', '21', '9186');
INSERT INTO public.who_global_data_import VALUES (9968, '2021-01-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '0', '162055', '0', '9186');
INSERT INTO public.who_global_data_import VALUES (9969, '2021-01-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '606', '162661', '15', '9201');
INSERT INTO public.who_global_data_import VALUES (9970, '2021-01-06', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1010', '163671', '18', '9219');
INSERT INTO public.who_global_data_import VALUES (9971, '2021-01-07', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1597', '165268', '22', '9241');
INSERT INTO public.who_global_data_import VALUES (9972, '2021-01-08', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1713', '166981', '46', '9287');
INSERT INTO public.who_global_data_import VALUES (9973, '2021-01-09', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1910', '168891', '17', '9304');
INSERT INTO public.who_global_data_import VALUES (9974, '2021-01-10', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2263', '171154', '24', '9328');
INSERT INTO public.who_global_data_import VALUES (9975, '2021-01-11', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1644', '172798', '23', '9351');
INSERT INTO public.who_global_data_import VALUES (9976, '2021-01-12', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1098', '173896', '25', '9376');
INSERT INTO public.who_global_data_import VALUES (9977, '2021-01-13', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1392', '175288', '39', '9415');
INSERT INTO public.who_global_data_import VALUES (9978, '2021-01-14', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1473', '176761', '39', '9454');
INSERT INTO public.who_global_data_import VALUES (9979, '2021-01-15', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2057', '178818', '39', '9493');
INSERT INTO public.who_global_data_import VALUES (9980, '2021-01-16', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2198', '181016', '37', '9530');
INSERT INTO public.who_global_data_import VALUES (9981, '2021-01-17', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2573', '183589', '41', '9571');
INSERT INTO public.who_global_data_import VALUES (9982, '2021-01-18', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2091', '185680', '25', '9596');
INSERT INTO public.who_global_data_import VALUES (9983, '2021-01-19', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1503', '187183', '40', '9636');
INSERT INTO public.who_global_data_import VALUES (9984, '2021-01-20', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1550', '188733', '44', '9680');
INSERT INTO public.who_global_data_import VALUES (9985, '2021-01-21', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2357', '191090', '42', '9722');
INSERT INTO public.who_global_data_import VALUES (9986, '2021-01-22', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2655', '193745', '42', '9764');
INSERT INTO public.who_global_data_import VALUES (9987, '2021-01-23', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2648', '196393', '54', '9818');
INSERT INTO public.who_global_data_import VALUES (9988, '2021-01-24', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1864', '198257', '53', '9871');
INSERT INTO public.who_global_data_import VALUES (9989, '2021-01-25', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1732', '199989', '56', '9927');
INSERT INTO public.who_global_data_import VALUES (9990, '2021-01-26', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1048', '201037', '58', '9985');
INSERT INTO public.who_global_data_import VALUES (9991, '2021-01-27', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1781', '202818', '66', '10051');
INSERT INTO public.who_global_data_import VALUES (9992, '2021-01-28', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2390', '205208', '54', '10105');
INSERT INTO public.who_global_data_import VALUES (9993, '2021-01-29', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2866', '208074', '62', '10167');
INSERT INTO public.who_global_data_import VALUES (9994, '2021-01-30', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2652', '210726', '59', '10226');
INSERT INTO public.who_global_data_import VALUES (9995, '2021-01-31', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2666', '213392', '0', '10226');
INSERT INTO public.who_global_data_import VALUES (9996, '2021-02-01', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2005', '215397', '104', '10330');
INSERT INTO public.who_global_data_import VALUES (9997, '2021-02-02', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1438', '216835', '49', '10379');
INSERT INTO public.who_global_data_import VALUES (9998, '2021-02-03', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '1464', '218299', '60', '10439');
INSERT INTO public.who_global_data_import VALUES (9999, '2021-02-04', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2127', '220426', '74', '10513');
INSERT INTO public.who_global_data_import VALUES (10000, '2021-02-05', 'BO', 'Bolivia (Plurinational State of)', 'AMRO', '2021', '222447', '58', '10571');
INSERT INTO public.who_global_data_import VALUES (10001, '2020-01-03', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10002, '2020-01-04', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10003, '2020-01-05', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10004, '2020-01-06', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10005, '2020-01-07', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10006, '2020-01-08', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10007, '2020-01-09', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10008, '2020-01-10', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10009, '2020-01-11', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10010, '2020-01-12', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10011, '2020-01-13', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10012, '2020-01-14', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10013, '2020-01-15', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10014, '2020-01-16', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10015, '2020-01-17', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10016, '2020-01-18', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10017, '2020-01-19', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10018, '2020-01-20', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10019, '2020-01-21', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10020, '2020-01-22', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10021, '2020-01-23', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10022, '2020-01-24', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10023, '2020-01-25', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10024, '2020-01-26', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10025, '2020-01-27', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10026, '2020-01-28', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10027, '2020-01-29', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10028, '2020-01-30', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10029, '2020-01-31', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10032, '2020-02-03', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10033, '2020-02-04', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10034, '2020-02-05', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10035, '2020-02-06', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10036, '2020-02-07', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10037, '2020-02-08', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10038, '2020-02-09', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10039, '2020-02-10', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10040, '2020-02-11', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10041, '2020-02-12', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10042, '2020-02-13', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10043, '2020-02-14', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10044, '2020-02-15', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10045, '2020-02-16', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10046, '2020-02-17', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10047, '2020-02-18', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10048, '2020-02-19', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10049, '2020-02-20', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10050, '2020-02-21', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10051, '2020-02-22', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10052, '2020-02-23', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10053, '2020-02-24', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10054, '2020-02-25', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10055, '2020-02-26', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10056, '2020-02-27', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10057, '2020-02-28', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10058, '2020-02-29', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10059, '2020-03-01', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10060, '2020-03-02', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10061, '2020-03-03', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10062, '2020-03-04', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10063, '2020-03-05', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10064, '2020-03-06', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10065, '2020-03-07', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10066, '2020-03-08', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10067, '2020-03-09', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10068, '2020-03-10', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10069, '2020-03-11', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10070, '2020-03-12', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10071, '2020-03-13', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10072, '2020-03-14', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10073, '2020-03-15', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10074, '2020-03-16', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10075, '2020-03-17', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10076, '2020-03-18', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10077, '2020-03-19', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10078, '2020-03-20', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10079, '2020-03-21', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10080, '2020-03-22', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10081, '2020-03-23', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10082, '2020-03-24', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10083, '2020-03-25', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10084, '2020-03-26', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10085, '2020-03-27', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10086, '2020-03-28', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10087, '2020-03-29', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10088, '2020-03-30', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10089, '2020-03-31', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10090, '2020-04-01', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10091, '2020-04-02', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10092, '2020-04-03', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10093, '2020-04-04', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10094, '2020-04-05', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10095, '2020-04-06', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10096, '2020-04-07', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10097, '2020-04-08', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10098, '2020-04-09', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10099, '2020-04-10', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10100, '2020-04-11', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10101, '2020-04-12', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10102, '2020-04-13', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10103, '2020-04-14', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10104, '2020-04-15', 'XA', 'Bonaire', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10105, '2020-04-16', 'XA', 'Bonaire', 'AMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10106, '2020-04-17', 'XA', 'Bonaire', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10107, '2020-04-18', 'XA', 'Bonaire', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10108, '2020-04-19', 'XA', 'Bonaire', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10109, '2020-04-20', 'XA', 'Bonaire', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10110, '2020-04-21', 'XA', 'Bonaire', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10111, '2020-04-22', 'XA', 'Bonaire', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10112, '2020-04-23', 'XA', 'Bonaire', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10113, '2020-04-24', 'XA', 'Bonaire', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10114, '2020-04-25', 'XA', 'Bonaire', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10115, '2020-04-26', 'XA', 'Bonaire', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10116, '2020-04-27', 'XA', 'Bonaire', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10117, '2020-04-28', 'XA', 'Bonaire', 'AMRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10118, '2020-04-29', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10119, '2020-04-30', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10120, '2020-05-01', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10121, '2020-05-02', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10122, '2020-05-03', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10123, '2020-05-04', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10124, '2020-05-05', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10125, '2020-05-06', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10126, '2020-05-07', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10127, '2020-05-08', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10128, '2020-05-09', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10129, '2020-05-10', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10130, '2020-05-11', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10131, '2020-05-12', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10132, '2020-05-13', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10133, '2020-05-14', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10134, '2020-05-15', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10135, '2020-05-16', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10136, '2020-05-17', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10137, '2020-05-18', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10138, '2020-05-19', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10139, '2020-05-20', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10140, '2020-05-21', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10141, '2020-05-22', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10142, '2020-05-23', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10143, '2020-05-24', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10144, '2020-05-25', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10145, '2020-05-26', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10146, '2020-05-27', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10147, '2020-05-28', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10148, '2020-05-29', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10149, '2020-05-30', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10150, '2020-05-31', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10151, '2020-06-01', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10152, '2020-06-02', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10153, '2020-06-03', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10154, '2020-06-04', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10155, '2020-06-05', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10156, '2020-06-06', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10157, '2020-06-07', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10158, '2020-06-08', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10159, '2020-06-09', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10160, '2020-06-10', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10161, '2020-06-11', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10162, '2020-06-12', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10163, '2020-06-13', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10164, '2020-06-14', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10165, '2020-06-15', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10166, '2020-06-16', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10167, '2020-06-17', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10168, '2020-06-18', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10169, '2020-06-19', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10170, '2020-06-20', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10171, '2020-06-21', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10172, '2020-06-22', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10173, '2020-06-23', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10174, '2020-06-24', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10175, '2020-06-25', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10176, '2020-06-26', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10177, '2020-06-27', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10178, '2020-06-28', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10179, '2020-06-29', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10180, '2020-06-30', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10181, '2020-07-01', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10182, '2020-07-02', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10183, '2020-07-03', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10184, '2020-07-04', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10185, '2020-07-05', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10186, '2020-07-06', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10187, '2020-07-07', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10188, '2020-07-08', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10189, '2020-07-09', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10190, '2020-07-10', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10191, '2020-07-11', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10192, '2020-07-12', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10193, '2020-07-13', 'XA', 'Bonaire', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10194, '2020-07-14', 'XA', 'Bonaire', 'AMRO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10195, '2020-07-15', 'XA', 'Bonaire', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10196, '2020-07-16', 'XA', 'Bonaire', 'AMRO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10197, '2020-07-17', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10198, '2020-07-18', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10199, '2020-07-19', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10200, '2020-07-20', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10201, '2020-07-21', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10202, '2020-07-22', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10203, '2020-07-23', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10204, '2020-07-24', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10205, '2020-07-25', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10206, '2020-07-26', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10207, '2020-07-27', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10208, '2020-07-28', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10209, '2020-07-29', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10210, '2020-07-30', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10211, '2020-07-31', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10212, '2020-08-01', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10213, '2020-08-02', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10214, '2020-08-03', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10215, '2020-08-04', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10216, '2020-08-05', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10217, '2020-08-06', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10218, '2020-08-07', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10219, '2020-08-08', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10220, '2020-08-09', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10221, '2020-08-10', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10222, '2020-08-11', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10223, '2020-08-12', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10224, '2020-08-13', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10225, '2020-08-14', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10226, '2020-08-15', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10227, '2020-08-16', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10228, '2020-08-17', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10229, '2020-08-18', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10230, '2020-08-19', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10231, '2020-08-20', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10232, '2020-08-21', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10233, '2020-08-22', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10234, '2020-08-23', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10235, '2020-08-24', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10236, '2020-08-25', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10237, '2020-08-26', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10238, '2020-08-27', 'XA', 'Bonaire', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10239, '2020-08-28', 'XA', 'Bonaire', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10240, '2020-08-29', 'XA', 'Bonaire', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10241, '2020-08-30', 'XA', 'Bonaire', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10242, '2020-08-31', 'XA', 'Bonaire', 'AMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10243, '2020-09-01', 'XA', 'Bonaire', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10244, '2020-09-02', 'XA', 'Bonaire', 'AMRO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10245, '2020-09-03', 'XA', 'Bonaire', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10246, '2020-09-04', 'XA', 'Bonaire', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10247, '2020-09-05', 'XA', 'Bonaire', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10248, '2020-09-06', 'XA', 'Bonaire', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10249, '2020-09-07', 'XA', 'Bonaire', 'AMRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10250, '2020-09-08', 'XA', 'Bonaire', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10251, '2020-09-09', 'XA', 'Bonaire', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10252, '2020-09-10', 'XA', 'Bonaire', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10253, '2020-09-11', 'XA', 'Bonaire', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10254, '2020-09-12', 'XA', 'Bonaire', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10255, '2020-09-13', 'XA', 'Bonaire', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10256, '2020-09-14', 'XA', 'Bonaire', 'AMRO', '1', '11', '1', '1');
INSERT INTO public.who_global_data_import VALUES (10257, '2020-09-15', 'XA', 'Bonaire', 'AMRO', '1', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10258, '2020-09-16', 'XA', 'Bonaire', 'AMRO', '4', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10259, '2020-09-17', 'XA', 'Bonaire', 'AMRO', '4', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10260, '2020-09-18', 'XA', 'Bonaire', 'AMRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10261, '2020-09-19', 'XA', 'Bonaire', 'AMRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10262, '2020-09-20', 'XA', 'Bonaire', 'AMRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10263, '2020-09-21', 'XA', 'Bonaire', 'AMRO', '20', '40', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10264, '2020-09-22', 'XA', 'Bonaire', 'AMRO', '7', '47', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10265, '2020-09-23', 'XA', 'Bonaire', 'AMRO', '5', '52', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10266, '2020-09-24', 'XA', 'Bonaire', 'AMRO', '8', '60', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10267, '2020-09-25', 'XA', 'Bonaire', 'AMRO', '7', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10268, '2020-09-26', 'XA', 'Bonaire', 'AMRO', '0', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10269, '2020-09-27', 'XA', 'Bonaire', 'AMRO', '0', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10270, '2020-09-28', 'XA', 'Bonaire', 'AMRO', '21', '88', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10271, '2020-09-29', 'XA', 'Bonaire', 'AMRO', '9', '97', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10272, '2020-09-30', 'XA', 'Bonaire', 'AMRO', '1', '98', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10273, '2020-10-01', 'XA', 'Bonaire', 'AMRO', '5', '103', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10274, '2020-10-02', 'XA', 'Bonaire', 'AMRO', '0', '103', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10275, '2020-10-03', 'XA', 'Bonaire', 'AMRO', '0', '103', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10276, '2020-10-04', 'XA', 'Bonaire', 'AMRO', '0', '103', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10277, '2020-10-05', 'XA', 'Bonaire', 'AMRO', '10', '113', '1', '2');
INSERT INTO public.who_global_data_import VALUES (10278, '2020-10-06', 'XA', 'Bonaire', 'AMRO', '10', '123', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10279, '2020-10-07', 'XA', 'Bonaire', 'AMRO', '4', '127', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10280, '2020-10-08', 'XA', 'Bonaire', 'AMRO', '2', '129', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10281, '2020-10-09', 'XA', 'Bonaire', 'AMRO', '1', '130', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10282, '2020-10-10', 'XA', 'Bonaire', 'AMRO', '0', '130', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10283, '2020-10-11', 'XA', 'Bonaire', 'AMRO', '0', '130', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10284, '2020-10-12', 'XA', 'Bonaire', 'AMRO', '1', '131', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10285, '2020-10-13', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10286, '2020-10-14', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10287, '2020-10-15', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10288, '2020-10-16', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10289, '2020-10-17', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10290, '2020-10-18', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '2');
INSERT INTO public.who_global_data_import VALUES (10291, '2020-10-19', 'XA', 'Bonaire', 'AMRO', '0', '131', '1', '3');
INSERT INTO public.who_global_data_import VALUES (10292, '2020-10-20', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10293, '2020-10-21', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10294, '2020-10-22', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10295, '2020-10-23', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10296, '2020-10-24', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10297, '2020-10-25', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10298, '2020-10-26', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10299, '2020-10-27', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10300, '2020-10-28', 'XA', 'Bonaire', 'AMRO', '0', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10301, '2020-10-29', 'XA', 'Bonaire', 'AMRO', '3', '134', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10302, '2020-10-30', 'XA', 'Bonaire', 'AMRO', '0', '134', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10303, '2020-10-31', 'XA', 'Bonaire', 'AMRO', '0', '134', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10304, '2020-11-01', 'XA', 'Bonaire', 'AMRO', '0', '134', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10305, '2020-11-02', 'XA', 'Bonaire', 'AMRO', '0', '134', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10306, '2020-11-03', 'XA', 'Bonaire', 'AMRO', '0', '134', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10307, '2020-11-04', 'XA', 'Bonaire', 'AMRO', '0', '134', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10308, '2020-11-05', 'XA', 'Bonaire', 'AMRO', '0', '134', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10309, '2020-11-06', 'XA', 'Bonaire', 'AMRO', '1', '135', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10310, '2020-11-07', 'XA', 'Bonaire', 'AMRO', '0', '135', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10311, '2020-11-08', 'XA', 'Bonaire', 'AMRO', '0', '135', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10312, '2020-11-09', 'XA', 'Bonaire', 'AMRO', '0', '135', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10313, '2020-11-10', 'XA', 'Bonaire', 'AMRO', '0', '135', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10314, '2020-11-11', 'XA', 'Bonaire', 'AMRO', '0', '135', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10315, '2020-11-12', 'XA', 'Bonaire', 'AMRO', '1', '136', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10316, '2020-11-13', 'XA', 'Bonaire', 'AMRO', '0', '136', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10317, '2020-11-14', 'XA', 'Bonaire', 'AMRO', '0', '136', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10318, '2020-11-15', 'XA', 'Bonaire', 'AMRO', '0', '136', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10319, '2020-11-16', 'XA', 'Bonaire', 'AMRO', '0', '136', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10320, '2020-11-17', 'XA', 'Bonaire', 'AMRO', '2', '138', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10321, '2020-11-18', 'XA', 'Bonaire', 'AMRO', '0', '138', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10322, '2020-11-19', 'XA', 'Bonaire', 'AMRO', '1', '139', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10323, '2020-11-20', 'XA', 'Bonaire', 'AMRO', '0', '139', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10324, '2020-11-21', 'XA', 'Bonaire', 'AMRO', '0', '139', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10325, '2020-11-22', 'XA', 'Bonaire', 'AMRO', '0', '139', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10326, '2020-11-23', 'XA', 'Bonaire', 'AMRO', '0', '139', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10327, '2020-11-24', 'XA', 'Bonaire', 'AMRO', '3', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10328, '2020-11-25', 'XA', 'Bonaire', 'AMRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10329, '2020-11-26', 'XA', 'Bonaire', 'AMRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10330, '2020-11-27', 'XA', 'Bonaire', 'AMRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10331, '2020-11-28', 'XA', 'Bonaire', 'AMRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10332, '2020-11-29', 'XA', 'Bonaire', 'AMRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10333, '2020-11-30', 'XA', 'Bonaire', 'AMRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10334, '2020-12-01', 'XA', 'Bonaire', 'AMRO', '1', '143', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10335, '2020-12-02', 'XA', 'Bonaire', 'AMRO', '0', '143', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10336, '2020-12-03', 'XA', 'Bonaire', 'AMRO', '1', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10337, '2020-12-04', 'XA', 'Bonaire', 'AMRO', '1', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10338, '2020-12-05', 'XA', 'Bonaire', 'AMRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10339, '2020-12-06', 'XA', 'Bonaire', 'AMRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10340, '2020-12-07', 'XA', 'Bonaire', 'AMRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10341, '2020-12-08', 'XA', 'Bonaire', 'AMRO', '1', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10342, '2020-12-09', 'XA', 'Bonaire', 'AMRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10343, '2020-12-10', 'XA', 'Bonaire', 'AMRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10344, '2020-12-11', 'XA', 'Bonaire', 'AMRO', '3', '149', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10345, '2020-12-12', 'XA', 'Bonaire', 'AMRO', '1', '150', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10346, '2020-12-13', 'XA', 'Bonaire', 'AMRO', '0', '150', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10347, '2020-12-14', 'XA', 'Bonaire', 'AMRO', '0', '150', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10348, '2020-12-15', 'XA', 'Bonaire', 'AMRO', '4', '154', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10349, '2020-12-16', 'XA', 'Bonaire', 'AMRO', '0', '154', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10350, '2020-12-17', 'XA', 'Bonaire', 'AMRO', '0', '154', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10351, '2020-12-18', 'XA', 'Bonaire', 'AMRO', '0', '154', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10352, '2020-12-19', 'XA', 'Bonaire', 'AMRO', '0', '154', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10353, '2020-12-20', 'XA', 'Bonaire', 'AMRO', '0', '154', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10354, '2020-12-21', 'XA', 'Bonaire', 'AMRO', '0', '154', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10355, '2020-12-22', 'XA', 'Bonaire', 'AMRO', '1', '155', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10356, '2020-12-23', 'XA', 'Bonaire', 'AMRO', '0', '155', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10357, '2020-12-24', 'XA', 'Bonaire', 'AMRO', '1', '156', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10358, '2020-12-25', 'XA', 'Bonaire', 'AMRO', '2', '158', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10359, '2020-12-26', 'XA', 'Bonaire', 'AMRO', '0', '158', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10360, '2020-12-27', 'XA', 'Bonaire', 'AMRO', '0', '158', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10361, '2020-12-28', 'XA', 'Bonaire', 'AMRO', '0', '158', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10362, '2020-12-29', 'XA', 'Bonaire', 'AMRO', '1', '159', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10363, '2020-12-30', 'XA', 'Bonaire', 'AMRO', '0', '159', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10364, '2020-12-31', 'XA', 'Bonaire', 'AMRO', '3', '162', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10365, '2021-01-01', 'XA', 'Bonaire', 'AMRO', '3', '165', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10366, '2021-01-02', 'XA', 'Bonaire', 'AMRO', '0', '165', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10367, '2021-01-03', 'XA', 'Bonaire', 'AMRO', '0', '165', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10368, '2021-01-04', 'XA', 'Bonaire', 'AMRO', '0', '165', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10369, '2021-01-05', 'XA', 'Bonaire', 'AMRO', '52', '217', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10370, '2021-01-06', 'XA', 'Bonaire', 'AMRO', '8', '225', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10371, '2021-01-07', 'XA', 'Bonaire', 'AMRO', '12', '237', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10372, '2021-01-08', 'XA', 'Bonaire', 'AMRO', '12', '249', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10373, '2021-01-09', 'XA', 'Bonaire', 'AMRO', '5', '254', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10374, '2021-01-10', 'XA', 'Bonaire', 'AMRO', '0', '254', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10375, '2021-01-11', 'XA', 'Bonaire', 'AMRO', '0', '254', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10376, '2021-01-12', 'XA', 'Bonaire', 'AMRO', '31', '285', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10377, '2021-01-13', 'XA', 'Bonaire', 'AMRO', '25', '310', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10378, '2021-01-14', 'XA', 'Bonaire', 'AMRO', '5', '315', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10379, '2021-01-15', 'XA', 'Bonaire', 'AMRO', '3', '318', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10380, '2021-01-16', 'XA', 'Bonaire', 'AMRO', '11', '329', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10381, '2021-01-17', 'XA', 'Bonaire', 'AMRO', '0', '329', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10382, '2021-01-18', 'XA', 'Bonaire', 'AMRO', '0', '329', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10383, '2021-01-19', 'XA', 'Bonaire', 'AMRO', '11', '340', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10384, '2021-01-20', 'XA', 'Bonaire', 'AMRO', '6', '346', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10385, '2021-01-21', 'XA', 'Bonaire', 'AMRO', '2', '348', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10386, '2021-01-22', 'XA', 'Bonaire', 'AMRO', '1', '349', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10387, '2021-01-23', 'XA', 'Bonaire', 'AMRO', '1', '350', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10388, '2021-01-24', 'XA', 'Bonaire', 'AMRO', '0', '350', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10389, '2021-01-25', 'XA', 'Bonaire', 'AMRO', '0', '350', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10390, '2021-01-26', 'XA', 'Bonaire', 'AMRO', '4', '354', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10391, '2021-01-27', 'XA', 'Bonaire', 'AMRO', '2', '356', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10392, '2021-01-28', 'XA', 'Bonaire', 'AMRO', '4', '360', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10393, '2021-01-29', 'XA', 'Bonaire', 'AMRO', '2', '362', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10394, '2021-01-30', 'XA', 'Bonaire', 'AMRO', '0', '362', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10395, '2021-01-31', 'XA', 'Bonaire', 'AMRO', '0', '362', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10396, '2021-02-01', 'XA', 'Bonaire', 'AMRO', '0', '362', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10397, '2021-02-02', 'XA', 'Bonaire', 'AMRO', '4', '366', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10398, '2021-02-03', 'XA', 'Bonaire', 'AMRO', '0', '366', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10399, '2021-02-04', 'XA', 'Bonaire', 'AMRO', '0', '366', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10400, '2021-02-05', 'XA', 'Bonaire', 'AMRO', '0', '366', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10401, '2020-01-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10402, '2020-01-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10403, '2020-01-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10404, '2020-01-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10405, '2020-01-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10406, '2020-01-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10407, '2020-01-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10408, '2020-01-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10409, '2020-01-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10410, '2020-01-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10411, '2020-01-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10412, '2020-01-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10413, '2020-01-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10414, '2020-01-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10415, '2020-01-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10416, '2020-01-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10417, '2020-01-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10418, '2020-01-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10419, '2020-01-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10420, '2020-01-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10421, '2020-01-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10422, '2020-01-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10423, '2020-01-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10424, '2020-01-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10425, '2020-01-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10426, '2020-01-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10427, '2020-01-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10428, '2020-01-30', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10429, '2020-01-31', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10430, '2020-02-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10431, '2020-02-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10432, '2020-02-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10433, '2020-02-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10434, '2020-02-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10435, '2020-02-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10436, '2020-02-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10437, '2020-02-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10438, '2020-02-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10439, '2020-02-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10440, '2020-02-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10441, '2020-02-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10442, '2020-02-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10443, '2020-02-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10444, '2020-02-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10445, '2020-02-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10446, '2020-02-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10447, '2020-02-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10448, '2020-02-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10449, '2020-02-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10450, '2020-02-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10451, '2020-02-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10452, '2020-02-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10453, '2020-02-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10454, '2020-02-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10455, '2020-02-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10456, '2020-02-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10457, '2020-02-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10458, '2020-02-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10459, '2020-03-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10460, '2020-03-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10461, '2020-03-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10462, '2020-03-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10463, '2020-03-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10464, '2020-03-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10465, '2020-03-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10466, '2020-03-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10467, '2020-03-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10468, '2020-03-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10469, '2020-03-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10470, '2020-03-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '3', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10471, '2020-03-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10472, '2020-03-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '8', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10473, '2020-03-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10474, '2020-03-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '5', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10475, '2020-03-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10476, '2020-03-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '2', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10477, '2020-03-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '14', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10478, '2020-03-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '9', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10479, '2020-03-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '48', '92', '1', '1');
INSERT INTO public.who_global_data_import VALUES (10480, '2020-03-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '33', '125', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10481, '2020-03-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '6', '131', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10482, '2020-03-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '33', '164', '1', '2');
INSERT INTO public.who_global_data_import VALUES (10483, '2020-03-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '9', '173', '1', '3');
INSERT INTO public.who_global_data_import VALUES (10484, '2020-03-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '40', '213', '0', '3');
INSERT INTO public.who_global_data_import VALUES (10485, '2020-03-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '20', '233', '1', '4');
INSERT INTO public.who_global_data_import VALUES (10486, '2020-03-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '36', '269', '2', '6');
INSERT INTO public.who_global_data_import VALUES (10487, '2020-03-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '56', '325', '0', '6');
INSERT INTO public.who_global_data_import VALUES (10488, '2020-03-30', 'BA', 'Bosnia and Herzegovina', 'EURO', '34', '359', '3', '9');
INSERT INTO public.who_global_data_import VALUES (10489, '2020-03-31', 'BA', 'Bosnia and Herzegovina', 'EURO', '54', '413', '3', '12');
INSERT INTO public.who_global_data_import VALUES (10490, '2020-04-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '51', '464', '1', '13');
INSERT INTO public.who_global_data_import VALUES (10491, '2020-04-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '464', '0', '13');
INSERT INTO public.who_global_data_import VALUES (10492, '2020-04-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '57', '521', '3', '16');
INSERT INTO public.who_global_data_import VALUES (10493, '2020-04-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '65', '586', '2', '18');
INSERT INTO public.who_global_data_import VALUES (10494, '2020-04-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '46', '632', '3', '21');
INSERT INTO public.who_global_data_import VALUES (10495, '2020-04-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '30', '662', '0', '21');
INSERT INTO public.who_global_data_import VALUES (10496, '2020-04-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '33', '695', '7', '28');
INSERT INTO public.who_global_data_import VALUES (10497, '2020-04-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '86', '781', '4', '32');
INSERT INTO public.who_global_data_import VALUES (10498, '2020-04-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '35', '816', '3', '35');
INSERT INTO public.who_global_data_import VALUES (10499, '2020-04-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '59', '875', '1', '36');
INSERT INTO public.who_global_data_import VALUES (10500, '2020-04-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '26', '901', '1', '37');
INSERT INTO public.who_global_data_import VALUES (10501, '2020-04-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '47', '948', '0', '37');
INSERT INTO public.who_global_data_import VALUES (10502, '2020-04-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '59', '1007', '1', '38');
INSERT INTO public.who_global_data_import VALUES (10503, '2020-04-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '27', '1034', '0', '38');
INSERT INTO public.who_global_data_import VALUES (10504, '2020-04-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '52', '1086', '2', '40');
INSERT INTO public.who_global_data_import VALUES (10505, '2020-04-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '30', '1116', '1', '41');
INSERT INTO public.who_global_data_import VALUES (10506, '2020-04-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '53', '1169', '1', '42');
INSERT INTO public.who_global_data_import VALUES (10507, '2020-04-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '41', '1210', '2', '44');
INSERT INTO public.who_global_data_import VALUES (10508, '2020-04-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '58', '1268', '2', '46');
INSERT INTO public.who_global_data_import VALUES (10509, '2020-04-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '18', '1286', '0', '46');
INSERT INTO public.who_global_data_import VALUES (10510, '2020-04-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '14', '1300', '3', '49');
INSERT INTO public.who_global_data_import VALUES (10511, '2020-04-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '40', '1340', '1', '50');
INSERT INTO public.who_global_data_import VALUES (10512, '2020-04-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '27', '1367', '2', '52');
INSERT INTO public.who_global_data_import VALUES (10513, '2020-04-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '46', '1413', '1', '53');
INSERT INTO public.who_global_data_import VALUES (10514, '2020-04-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '15', '1428', '1', '54');
INSERT INTO public.who_global_data_import VALUES (10515, '2020-04-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '57', '1485', '2', '56');
INSERT INTO public.who_global_data_import VALUES (10516, '2020-04-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '31', '1516', '2', '58');
INSERT INTO public.who_global_data_import VALUES (10517, '2020-04-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '48', '1564', '2', '60');
INSERT INTO public.who_global_data_import VALUES (10518, '2020-04-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '24', '1588', '2', '62');
INSERT INTO public.who_global_data_import VALUES (10519, '2020-04-30', 'BA', 'Bosnia and Herzegovina', 'EURO', '101', '1689', '2', '64');
INSERT INTO public.who_global_data_import VALUES (10520, '2020-05-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '93', '1782', '5', '69');
INSERT INTO public.who_global_data_import VALUES (10521, '2020-05-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '58', '1840', '2', '71');
INSERT INTO public.who_global_data_import VALUES (10522, '2020-05-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '1840', '0', '71');
INSERT INTO public.who_global_data_import VALUES (10523, '2020-05-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '17', '1857', '5', '76');
INSERT INTO public.who_global_data_import VALUES (10524, '2020-05-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '69', '1926', '1', '77');
INSERT INTO public.who_global_data_import VALUES (10525, '2020-05-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '42', '1968', '5', '82');
INSERT INTO public.who_global_data_import VALUES (10526, '2020-05-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '49', '2017', '5', '87');
INSERT INTO public.who_global_data_import VALUES (10527, '2020-05-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '10', '2027', '2', '89');
INSERT INTO public.who_global_data_import VALUES (10528, '2020-05-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '43', '2070', '8', '97');
INSERT INTO public.who_global_data_import VALUES (10529, '2020-05-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '2070', '0', '97');
INSERT INTO public.who_global_data_import VALUES (10530, '2020-05-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '28', '2098', '6', '103');
INSERT INTO public.who_global_data_import VALUES (10531, '2020-05-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '44', '2142', '9', '112');
INSERT INTO public.who_global_data_import VALUES (10532, '2020-05-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '20', '2162', '4', '116');
INSERT INTO public.who_global_data_import VALUES (10533, '2020-05-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '19', '2181', '3', '119');
INSERT INTO public.who_global_data_import VALUES (10534, '2020-05-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '35', '2216', '4', '123');
INSERT INTO public.who_global_data_import VALUES (10535, '2020-05-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '21', '2237', '4', '127');
INSERT INTO public.who_global_data_import VALUES (10536, '2020-05-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '28', '2265', '4', '131');
INSERT INTO public.who_global_data_import VALUES (10537, '2020-05-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '24', '2289', '1', '132');
INSERT INTO public.who_global_data_import VALUES (10538, '2020-05-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '14', '2303', '0', '132');
INSERT INTO public.who_global_data_import VALUES (10539, '2020-05-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '16', '2319', '1', '133');
INSERT INTO public.who_global_data_import VALUES (10540, '2020-05-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '15', '2334', '2', '135');
INSERT INTO public.who_global_data_import VALUES (10541, '2020-05-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '18', '2352', '4', '139');
INSERT INTO public.who_global_data_import VALUES (10542, '2020-05-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '19', '2371', '1', '140');
INSERT INTO public.who_global_data_import VALUES (10543, '2020-05-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '2371', '0', '140');
INSERT INTO public.who_global_data_import VALUES (10544, '2020-05-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '20', '2391', '1', '141');
INSERT INTO public.who_global_data_import VALUES (10545, '2020-05-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '14', '2405', '4', '145');
INSERT INTO public.who_global_data_import VALUES (10546, '2020-05-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '10', '2415', '4', '149');
INSERT INTO public.who_global_data_import VALUES (10547, '2020-05-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '2415', '0', '149');
INSERT INTO public.who_global_data_import VALUES (10548, '2020-05-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '47', '2462', '3', '152');
INSERT INTO public.who_global_data_import VALUES (10549, '2020-05-30', 'BA', 'Bosnia and Herzegovina', 'EURO', '22', '2484', '0', '152');
INSERT INTO public.who_global_data_import VALUES (10550, '2020-05-31', 'BA', 'Bosnia and Herzegovina', 'EURO', '9', '2493', '0', '152');
INSERT INTO public.who_global_data_import VALUES (10551, '2020-06-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '16', '2509', '0', '152');
INSERT INTO public.who_global_data_import VALUES (10552, '2020-06-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '14', '2523', '1', '153');
INSERT INTO public.who_global_data_import VALUES (10553, '2020-06-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '11', '2534', '3', '156');
INSERT INTO public.who_global_data_import VALUES (10554, '2020-06-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '16', '2550', '0', '156');
INSERT INTO public.who_global_data_import VALUES (10555, '2020-06-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '43', '2593', '2', '158');
INSERT INTO public.who_global_data_import VALUES (10556, '2020-06-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '12', '2605', '0', '158');
INSERT INTO public.who_global_data_import VALUES (10557, '2020-06-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '40', '2645', '0', '158');
INSERT INTO public.who_global_data_import VALUES (10558, '2020-06-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '28', '2673', '1', '159');
INSERT INTO public.who_global_data_import VALUES (10559, '2020-06-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '30', '2703', '0', '159');
INSERT INTO public.who_global_data_import VALUES (10560, '2020-06-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '24', '2727', '0', '159');
INSERT INTO public.who_global_data_import VALUES (10561, '2020-06-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '49', '2776', '1', '160');
INSERT INTO public.who_global_data_import VALUES (10562, '2020-06-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '55', '2831', '0', '160');
INSERT INTO public.who_global_data_import VALUES (10563, '2020-06-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '61', '2892', '2', '162');
INSERT INTO public.who_global_data_import VALUES (10564, '2020-06-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '2892', '0', '162');
INSERT INTO public.who_global_data_import VALUES (10565, '2020-06-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '109', '3001', '1', '163');
INSERT INTO public.who_global_data_import VALUES (10566, '2020-06-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '38', '3039', '1', '164');
INSERT INTO public.who_global_data_import VALUES (10567, '2020-06-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '45', '3084', '3', '167');
INSERT INTO public.who_global_data_import VALUES (10568, '2020-06-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '60', '3144', '0', '167');
INSERT INTO public.who_global_data_import VALUES (10569, '2020-06-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '58', '3202', '0', '167');
INSERT INTO public.who_global_data_import VALUES (10570, '2020-06-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '86', '3288', '1', '168');
INSERT INTO public.who_global_data_import VALUES (10571, '2020-06-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '66', '3354', '1', '169');
INSERT INTO public.who_global_data_import VALUES (10572, '2020-06-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '77', '3431', '0', '169');
INSERT INTO public.who_global_data_import VALUES (10573, '2020-06-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '93', '3524', '1', '170');
INSERT INTO public.who_global_data_import VALUES (10574, '2020-06-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '63', '3587', '1', '171');
INSERT INTO public.who_global_data_import VALUES (10575, '2020-06-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '88', '3675', '1', '172');
INSERT INTO public.who_global_data_import VALUES (10576, '2020-06-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '119', '3794', '2', '174');
INSERT INTO public.who_global_data_import VALUES (10577, '2020-06-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '140', '3934', '3', '177');
INSERT INTO public.who_global_data_import VALUES (10578, '2020-06-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '173', '4107', '2', '179');
INSERT INTO public.who_global_data_import VALUES (10579, '2020-06-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '108', '4215', '3', '182');
INSERT INTO public.who_global_data_import VALUES (10580, '2020-06-30', 'BA', 'Bosnia and Herzegovina', 'EURO', '128', '4343', '1', '183');
INSERT INTO public.who_global_data_import VALUES (10581, '2020-07-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '110', '4453', '2', '185');
INSERT INTO public.who_global_data_import VALUES (10582, '2020-07-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '153', '4606', '2', '187');
INSERT INTO public.who_global_data_import VALUES (10583, '2020-07-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '182', '4788', '1', '188');
INSERT INTO public.who_global_data_import VALUES (10584, '2020-07-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '172', '4960', '2', '190');
INSERT INTO public.who_global_data_import VALUES (10585, '2020-07-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '289', '5249', '0', '190');
INSERT INTO public.who_global_data_import VALUES (10586, '2020-07-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '144', '5393', '3', '193');
INSERT INTO public.who_global_data_import VALUES (10587, '2020-07-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '64', '5457', '3', '196');
INSERT INTO public.who_global_data_import VALUES (10588, '2020-07-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '161', '5618', '10', '206');
INSERT INTO public.who_global_data_import VALUES (10589, '2020-07-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '250', '5868', '1', '207');
INSERT INTO public.who_global_data_import VALUES (10590, '2020-07-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '219', '6087', '6', '213');
INSERT INTO public.who_global_data_import VALUES (10591, '2020-07-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '315', '6402', '2', '215');
INSERT INTO public.who_global_data_import VALUES (10592, '2020-07-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '318', '6720', '3', '218');
INSERT INTO public.who_global_data_import VALUES (10593, '2020-07-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '164', '6884', '2', '220');
INSERT INTO public.who_global_data_import VALUES (10594, '2020-07-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '95', '6979', '4', '224');
INSERT INTO public.who_global_data_import VALUES (10595, '2020-07-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '197', '7176', '5', '229');
INSERT INTO public.who_global_data_import VALUES (10596, '2020-07-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '231', '7407', '4', '233');
INSERT INTO public.who_global_data_import VALUES (10597, '2020-07-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '274', '7681', '6', '239');
INSERT INTO public.who_global_data_import VALUES (10598, '2020-07-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '227', '7908', '4', '243');
INSERT INTO public.who_global_data_import VALUES (10599, '2020-07-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '256', '8164', '2', '245');
INSERT INTO public.who_global_data_import VALUES (10600, '2020-07-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '288', '8452', '5', '250');
INSERT INTO public.who_global_data_import VALUES (10601, '2020-07-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '139', '8591', '6', '256');
INSERT INTO public.who_global_data_import VALUES (10602, '2020-07-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '195', '8786', '5', '261');
INSERT INTO public.who_global_data_import VALUES (10603, '2020-07-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '330', '9116', '6', '267');
INSERT INTO public.who_global_data_import VALUES (10604, '2020-07-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '344', '9460', '5', '272');
INSERT INTO public.who_global_data_import VALUES (10605, '2020-07-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '304', '9764', '6', '278');
INSERT INTO public.who_global_data_import VALUES (10606, '2020-07-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '305', '10069', '5', '283');
INSERT INTO public.who_global_data_import VALUES (10607, '2020-07-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '263', '10332', '2', '285');
INSERT INTO public.who_global_data_import VALUES (10608, '2020-07-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '183', '10515', '7', '292');
INSERT INTO public.who_global_data_import VALUES (10609, '2020-07-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '232', '10747', '3', '295');
INSERT INTO public.who_global_data_import VALUES (10610, '2020-07-30', 'BA', 'Bosnia and Herzegovina', 'EURO', '382', '11129', '17', '312');
INSERT INTO public.who_global_data_import VALUES (10611, '2020-07-31', 'BA', 'Bosnia and Herzegovina', 'EURO', '313', '11442', '12', '324');
INSERT INTO public.who_global_data_import VALUES (10612, '2020-08-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '11442', '0', '324');
INSERT INTO public.who_global_data_import VALUES (10613, '2020-08-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '666', '12108', '19', '343');
INSERT INTO public.who_global_data_import VALUES (10614, '2020-08-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '188', '12296', '4', '347');
INSERT INTO public.who_global_data_import VALUES (10615, '2020-08-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '181', '12477', '11', '358');
INSERT INTO public.who_global_data_import VALUES (10616, '2020-08-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '381', '12858', '10', '368');
INSERT INTO public.who_global_data_import VALUES (10617, '2020-08-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '288', '13146', '6', '374');
INSERT INTO public.who_global_data_import VALUES (10618, '2020-08-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '251', '13397', '5', '379');
INSERT INTO public.who_global_data_import VALUES (10619, '2020-08-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '287', '13684', '9', '388');
INSERT INTO public.who_global_data_import VALUES (10620, '2020-08-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '405', '14089', '8', '396');
INSERT INTO public.who_global_data_import VALUES (10621, '2020-08-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '236', '14325', '6', '402');
INSERT INTO public.who_global_data_import VALUES (10622, '2020-08-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '173', '14498', '18', '420');
INSERT INTO public.who_global_data_import VALUES (10623, '2020-08-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '208', '14706', '22', '442');
INSERT INTO public.who_global_data_import VALUES (10624, '2020-08-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '254', '14960', '6', '448');
INSERT INTO public.who_global_data_import VALUES (10625, '2020-08-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '227', '15187', '5', '453');
INSERT INTO public.who_global_data_import VALUES (10626, '2020-08-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '347', '15534', '11', '464');
INSERT INTO public.who_global_data_import VALUES (10627, '2020-08-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '268', '15802', '2', '466');
INSERT INTO public.who_global_data_import VALUES (10628, '2020-08-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '233', '16035', '9', '475');
INSERT INTO public.who_global_data_import VALUES (10629, '2020-08-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '102', '16137', '6', '481');
INSERT INTO public.who_global_data_import VALUES (10630, '2020-08-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '210', '16347', '9', '490');
INSERT INTO public.who_global_data_import VALUES (10631, '2020-08-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '344', '16691', '12', '502');
INSERT INTO public.who_global_data_import VALUES (10632, '2020-08-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '335', '17026', '8', '510');
INSERT INTO public.who_global_data_import VALUES (10633, '2020-08-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '366', '17392', '10', '520');
INSERT INTO public.who_global_data_import VALUES (10634, '2020-08-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '320', '17712', '6', '526');
INSERT INTO public.who_global_data_import VALUES (10635, '2020-08-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '188', '17900', '3', '529');
INSERT INTO public.who_global_data_import VALUES (10636, '2020-08-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '127', '18027', '11', '540');
INSERT INTO public.who_global_data_import VALUES (10637, '2020-08-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '297', '18324', '14', '554');
INSERT INTO public.who_global_data_import VALUES (10638, '2020-08-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '284', '18608', '11', '565');
INSERT INTO public.who_global_data_import VALUES (10639, '2020-08-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '310', '18918', '11', '576');
INSERT INTO public.who_global_data_import VALUES (10640, '2020-08-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '294', '19212', '9', '585');
INSERT INTO public.who_global_data_import VALUES (10641, '2020-08-30', 'BA', 'Bosnia and Herzegovina', 'EURO', '334', '19546', '3', '588');
INSERT INTO public.who_global_data_import VALUES (10642, '2020-08-31', 'BA', 'Bosnia and Herzegovina', 'EURO', '243', '19789', '4', '592');
INSERT INTO public.who_global_data_import VALUES (10643, '2020-09-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '231', '20020', '11', '603');
INSERT INTO public.who_global_data_import VALUES (10644, '2020-09-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '271', '20291', '11', '614');
INSERT INTO public.who_global_data_import VALUES (10645, '2020-09-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '283', '20574', '7', '621');
INSERT INTO public.who_global_data_import VALUES (10646, '2020-09-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '287', '20861', '9', '630');
INSERT INTO public.who_global_data_import VALUES (10647, '2020-09-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '337', '21198', '2', '632');
INSERT INTO public.who_global_data_import VALUES (10648, '2020-09-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '236', '21434', '12', '644');
INSERT INTO public.who_global_data_import VALUES (10649, '2020-09-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '122', '21556', '4', '648');
INSERT INTO public.who_global_data_import VALUES (10650, '2020-09-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '100', '21656', '9', '657');
INSERT INTO public.who_global_data_import VALUES (10651, '2020-09-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '303', '21959', '5', '662');
INSERT INTO public.who_global_data_import VALUES (10652, '2020-09-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '295', '22254', '6', '668');
INSERT INTO public.who_global_data_import VALUES (10653, '2020-09-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '285', '22539', '5', '673');
INSERT INTO public.who_global_data_import VALUES (10830, '2020-02-01', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10654, '2020-09-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '290', '22829', '6', '679');
INSERT INTO public.who_global_data_import VALUES (10655, '2020-09-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '305', '23134', '4', '683');
INSERT INTO public.who_global_data_import VALUES (10656, '2020-09-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '328', '23462', '6', '689');
INSERT INTO public.who_global_data_import VALUES (10657, '2020-09-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '168', '23630', '9', '698');
INSERT INTO public.who_global_data_import VALUES (10658, '2020-09-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '294', '23924', '20', '718');
INSERT INTO public.who_global_data_import VALUES (10659, '2020-09-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '282', '24206', '11', '729');
INSERT INTO public.who_global_data_import VALUES (10660, '2020-09-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '394', '24600', '12', '741');
INSERT INTO public.who_global_data_import VALUES (10661, '2020-09-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '292', '24892', '5', '746');
INSERT INTO public.who_global_data_import VALUES (10662, '2020-09-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '320', '25212', '6', '752');
INSERT INTO public.who_global_data_import VALUES (10663, '2020-09-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '212', '25424', '5', '757');
INSERT INTO public.who_global_data_import VALUES (10664, '2020-09-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '92', '25516', '6', '763');
INSERT INTO public.who_global_data_import VALUES (10665, '2020-09-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '216', '25732', '8', '771');
INSERT INTO public.who_global_data_import VALUES (10666, '2020-09-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '344', '26076', '12', '783');
INSERT INTO public.who_global_data_import VALUES (10667, '2020-09-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '237', '26313', '12', '795');
INSERT INTO public.who_global_data_import VALUES (10668, '2020-09-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '247', '26560', '6', '801');
INSERT INTO public.who_global_data_import VALUES (10669, '2020-09-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '235', '26795', '7', '808');
INSERT INTO public.who_global_data_import VALUES (10670, '2020-09-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '122', '26917', '2', '810');
INSERT INTO public.who_global_data_import VALUES (10671, '2020-09-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '80', '26997', '12', '822');
INSERT INTO public.who_global_data_import VALUES (10672, '2020-09-30', 'BA', 'Bosnia and Herzegovina', 'EURO', '225', '27222', '14', '836');
INSERT INTO public.who_global_data_import VALUES (10673, '2020-10-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '243', '27465', '13', '849');
INSERT INTO public.who_global_data_import VALUES (10674, '2020-10-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '280', '27745', '5', '854');
INSERT INTO public.who_global_data_import VALUES (10675, '2020-10-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '226', '27971', '10', '864');
INSERT INTO public.who_global_data_import VALUES (10676, '2020-10-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '263', '28234', '6', '870');
INSERT INTO public.who_global_data_import VALUES (10677, '2020-10-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '68', '28302', '2', '872');
INSERT INTO public.who_global_data_import VALUES (10678, '2020-10-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '144', '28446', '9', '881');
INSERT INTO public.who_global_data_import VALUES (10679, '2020-10-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '261', '28707', '15', '896');
INSERT INTO public.who_global_data_import VALUES (10680, '2020-10-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '364', '29071', '5', '901');
INSERT INTO public.who_global_data_import VALUES (10681, '2020-10-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '454', '29525', '5', '906');
INSERT INTO public.who_global_data_import VALUES (10682, '2020-10-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '390', '29915', '13', '919');
INSERT INTO public.who_global_data_import VALUES (10683, '2020-10-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '428', '30343', '1', '920');
INSERT INTO public.who_global_data_import VALUES (10684, '2020-10-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '302', '30645', '1', '921');
INSERT INTO public.who_global_data_import VALUES (10685, '2020-10-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '189', '30834', '9', '930');
INSERT INTO public.who_global_data_import VALUES (10686, '2020-10-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '339', '31173', '13', '943');
INSERT INTO public.who_global_data_import VALUES (10687, '2020-10-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '479', '31652', '12', '955');
INSERT INTO public.who_global_data_import VALUES (10688, '2020-10-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '578', '32230', '15', '970');
INSERT INTO public.who_global_data_import VALUES (10689, '2020-10-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '618', '32848', '8', '978');
INSERT INTO public.who_global_data_import VALUES (10690, '2020-10-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '713', '33561', '2', '980');
INSERT INTO public.who_global_data_import VALUES (10691, '2020-10-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '559', '34120', '4', '984');
INSERT INTO public.who_global_data_import VALUES (10692, '2020-10-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '545', '34665', '13', '997');
INSERT INTO public.who_global_data_import VALUES (10693, '2020-10-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '726', '35391', '20', '1017');
INSERT INTO public.who_global_data_import VALUES (10694, '2020-10-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '928', '36319', '14', '1031');
INSERT INTO public.who_global_data_import VALUES (10695, '2020-10-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '1003', '37322', '20', '1051');
INSERT INTO public.who_global_data_import VALUES (10696, '2020-10-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '1178', '38500', '14', '1065');
INSERT INTO public.who_global_data_import VALUES (10697, '2020-10-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '1258', '39758', '10', '1075');
INSERT INTO public.who_global_data_import VALUES (10698, '2020-10-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '1136', '40894', '11', '1086');
INSERT INTO public.who_global_data_import VALUES (10699, '2020-10-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '722', '41616', '18', '1104');
INSERT INTO public.who_global_data_import VALUES (10700, '2020-10-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '1558', '43174', '21', '1125');
INSERT INTO public.who_global_data_import VALUES (10701, '2020-10-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '1584', '44758', '36', '1161');
INSERT INTO public.who_global_data_import VALUES (10702, '2020-10-30', 'BA', 'Bosnia and Herzegovina', 'EURO', '1910', '46668', '21', '1182');
INSERT INTO public.who_global_data_import VALUES (10703, '2020-10-31', 'BA', 'Bosnia and Herzegovina', 'EURO', '1485', '48153', '30', '1212');
INSERT INTO public.who_global_data_import VALUES (10704, '2020-11-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '1937', '50090', '22', '1234');
INSERT INTO public.who_global_data_import VALUES (10705, '2020-11-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '1415', '51505', '14', '1248');
INSERT INTO public.who_global_data_import VALUES (10706, '2020-11-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '764', '52269', '32', '1280');
INSERT INTO public.who_global_data_import VALUES (10707, '2020-11-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '1580', '53849', '38', '1318');
INSERT INTO public.who_global_data_import VALUES (10708, '2020-11-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '1753', '55602', '41', '1359');
INSERT INTO public.who_global_data_import VALUES (10709, '2020-11-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '1919', '57521', '43', '1402');
INSERT INTO public.who_global_data_import VALUES (10710, '2020-11-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '1907', '59428', '55', '1457');
INSERT INTO public.who_global_data_import VALUES (10711, '2020-11-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '1784', '61212', '33', '1490');
INSERT INTO public.who_global_data_import VALUES (10712, '2020-11-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '1211', '62423', '20', '1510');
INSERT INTO public.who_global_data_import VALUES (10713, '2020-11-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '997', '63420', '73', '1583');
INSERT INTO public.who_global_data_import VALUES (10714, '2020-11-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '1605', '65025', '46', '1629');
INSERT INTO public.who_global_data_import VALUES (10715, '2020-11-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '1540', '66565', '72', '1701');
INSERT INTO public.who_global_data_import VALUES (10716, '2020-11-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '1728', '68293', '49', '1750');
INSERT INTO public.who_global_data_import VALUES (10717, '2020-11-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '1332', '69625', '58', '1808');
INSERT INTO public.who_global_data_import VALUES (10718, '2020-11-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '1275', '70900', '49', '1857');
INSERT INTO public.who_global_data_import VALUES (10719, '2020-11-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '1059', '71959', '41', '1898');
INSERT INTO public.who_global_data_import VALUES (10720, '2020-11-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '730', '72689', '75', '1973');
INSERT INTO public.who_global_data_import VALUES (10721, '2020-11-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '1255', '73944', '69', '2042');
INSERT INTO public.who_global_data_import VALUES (10722, '2020-11-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '1633', '75577', '47', '2089');
INSERT INTO public.who_global_data_import VALUES (10723, '2020-11-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '1180', '76757', '64', '2153');
INSERT INTO public.who_global_data_import VALUES (10724, '2020-11-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '1237', '77994', '56', '2209');
INSERT INTO public.who_global_data_import VALUES (10725, '2020-11-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '1315', '79309', '37', '2246');
INSERT INTO public.who_global_data_import VALUES (10726, '2020-11-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '698', '80007', '30', '2276');
INSERT INTO public.who_global_data_import VALUES (10727, '2020-11-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '546', '80553', '66', '2342');
INSERT INTO public.who_global_data_import VALUES (10728, '2020-11-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '1186', '81739', '52', '2394');
INSERT INTO public.who_global_data_import VALUES (10729, '2020-11-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '1589', '83328', '35', '2429');
INSERT INTO public.who_global_data_import VALUES (10730, '2020-11-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '924', '84252', '51', '2480');
INSERT INTO public.who_global_data_import VALUES (10731, '2020-11-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '1179', '85431', '62', '2542');
INSERT INTO public.who_global_data_import VALUES (10732, '2020-11-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '1279', '86710', '34', '2576');
INSERT INTO public.who_global_data_import VALUES (10733, '2020-11-30', 'BA', 'Bosnia and Herzegovina', 'EURO', '664', '87374', '44', '2620');
INSERT INTO public.who_global_data_import VALUES (10734, '2020-12-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '527', '87901', '61', '2681');
INSERT INTO public.who_global_data_import VALUES (10735, '2020-12-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '1184', '89085', '46', '2727');
INSERT INTO public.who_global_data_import VALUES (10736, '2020-12-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '1293', '90378', '46', '2773');
INSERT INTO public.who_global_data_import VALUES (10737, '2020-12-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '1161', '91539', '39', '2812');
INSERT INTO public.who_global_data_import VALUES (10738, '2020-12-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '1254', '92793', '53', '2865');
INSERT INTO public.who_global_data_import VALUES (10831, '2020-02-02', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10739, '2020-12-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '975', '93768', '57', '2922');
INSERT INTO public.who_global_data_import VALUES (10740, '2020-12-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '739', '94507', '30', '2952');
INSERT INTO public.who_global_data_import VALUES (10741, '2020-12-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '437', '94944', '60', '3012');
INSERT INTO public.who_global_data_import VALUES (10742, '2020-12-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '1077', '96021', '69', '3081');
INSERT INTO public.who_global_data_import VALUES (10743, '2020-12-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '1296', '97317', '70', '3151');
INSERT INTO public.who_global_data_import VALUES (10744, '2020-12-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '1286', '98603', '48', '3199');
INSERT INTO public.who_global_data_import VALUES (10745, '2020-12-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '0', '98603', '0', '3199');
INSERT INTO public.who_global_data_import VALUES (10746, '2020-12-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '1703', '100306', '99', '3298');
INSERT INTO public.who_global_data_import VALUES (10747, '2020-12-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '811', '101117', '38', '3336');
INSERT INTO public.who_global_data_import VALUES (10748, '2020-12-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '344', '101461', '55', '3391');
INSERT INTO public.who_global_data_import VALUES (10749, '2020-12-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '869', '102330', '66', '3457');
INSERT INTO public.who_global_data_import VALUES (10750, '2020-12-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '902', '103232', '54', '3511');
INSERT INTO public.who_global_data_import VALUES (10751, '2020-12-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '865', '104097', '38', '3549');
INSERT INTO public.who_global_data_import VALUES (10752, '2020-12-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '784', '104881', '34', '3583');
INSERT INTO public.who_global_data_import VALUES (10753, '2020-12-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '643', '105524', '42', '3625');
INSERT INTO public.who_global_data_import VALUES (10754, '2020-12-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '482', '106006', '28', '3653');
INSERT INTO public.who_global_data_import VALUES (10755, '2020-12-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '216', '106222', '53', '3706');
INSERT INTO public.who_global_data_import VALUES (10756, '2020-12-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '764', '106986', '86', '3792');
INSERT INTO public.who_global_data_import VALUES (10757, '2020-12-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '584', '107570', '46', '3838');
INSERT INTO public.who_global_data_import VALUES (10758, '2020-12-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '728', '108298', '40', '3878');
INSERT INTO public.who_global_data_import VALUES (10759, '2020-12-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '593', '108891', '23', '3901');
INSERT INTO public.who_global_data_import VALUES (10760, '2020-12-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '439', '109330', '22', '3923');
INSERT INTO public.who_global_data_import VALUES (10761, '2020-12-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '361', '109691', '30', '3953');
INSERT INTO public.who_global_data_import VALUES (10762, '2020-12-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '220', '109911', '23', '3976');
INSERT INTO public.who_global_data_import VALUES (10763, '2020-12-30', 'BA', 'Bosnia and Herzegovina', 'EURO', '543', '110454', '48', '4024');
INSERT INTO public.who_global_data_import VALUES (10764, '2020-12-31', 'BA', 'Bosnia and Herzegovina', 'EURO', '531', '110985', '26', '4050');
INSERT INTO public.who_global_data_import VALUES (10765, '2021-01-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '658', '111643', '22', '4072');
INSERT INTO public.who_global_data_import VALUES (10766, '2021-01-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '500', '112143', '14', '4086');
INSERT INTO public.who_global_data_import VALUES (10767, '2021-01-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '202', '112345', '14', '4100');
INSERT INTO public.who_global_data_import VALUES (10768, '2021-01-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '300', '112645', '31', '4131');
INSERT INTO public.who_global_data_import VALUES (10769, '2021-01-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '183', '112828', '48', '4179');
INSERT INTO public.who_global_data_import VALUES (10770, '2021-01-06', 'BA', 'Bosnia and Herzegovina', 'EURO', '564', '113392', '32', '4211');
INSERT INTO public.who_global_data_import VALUES (10771, '2021-01-07', 'BA', 'Bosnia and Herzegovina', 'EURO', '760', '114152', '37', '4248');
INSERT INTO public.who_global_data_import VALUES (10772, '2021-01-08', 'BA', 'Bosnia and Herzegovina', 'EURO', '250', '114402', '16', '4264');
INSERT INTO public.who_global_data_import VALUES (10773, '2021-01-09', 'BA', 'Bosnia and Herzegovina', 'EURO', '518', '114920', '21', '4285');
INSERT INTO public.who_global_data_import VALUES (10774, '2021-01-10', 'BA', 'Bosnia and Herzegovina', 'EURO', '459', '115379', '20', '4305');
INSERT INTO public.who_global_data_import VALUES (10775, '2021-01-11', 'BA', 'Bosnia and Herzegovina', 'EURO', '256', '115635', '25', '4330');
INSERT INTO public.who_global_data_import VALUES (10776, '2021-01-12', 'BA', 'Bosnia and Herzegovina', 'EURO', '123', '115758', '28', '4358');
INSERT INTO public.who_global_data_import VALUES (10777, '2021-01-13', 'BA', 'Bosnia and Herzegovina', 'EURO', '442', '116200', '15', '4373');
INSERT INTO public.who_global_data_import VALUES (10778, '2021-01-14', 'BA', 'Bosnia and Herzegovina', 'EURO', '468', '116668', '26', '4399');
INSERT INTO public.who_global_data_import VALUES (10779, '2021-01-15', 'BA', 'Bosnia and Herzegovina', 'EURO', '343', '117011', '12', '4411');
INSERT INTO public.who_global_data_import VALUES (10780, '2021-01-16', 'BA', 'Bosnia and Herzegovina', 'EURO', '320', '117331', '18', '4429');
INSERT INTO public.who_global_data_import VALUES (10781, '2021-01-17', 'BA', 'Bosnia and Herzegovina', 'EURO', '462', '117793', '20', '4449');
INSERT INTO public.who_global_data_import VALUES (10782, '2021-01-18', 'BA', 'Bosnia and Herzegovina', 'EURO', '180', '117973', '23', '4472');
INSERT INTO public.who_global_data_import VALUES (10783, '2021-01-19', 'BA', 'Bosnia and Herzegovina', 'EURO', '110', '118083', '14', '4486');
INSERT INTO public.who_global_data_import VALUES (10784, '2021-01-20', 'BA', 'Bosnia and Herzegovina', 'EURO', '300', '118383', '23', '4509');
INSERT INTO public.who_global_data_import VALUES (10785, '2021-01-21', 'BA', 'Bosnia and Herzegovina', 'EURO', '334', '118717', '12', '4521');
INSERT INTO public.who_global_data_import VALUES (10786, '2021-01-22', 'BA', 'Bosnia and Herzegovina', 'EURO', '489', '119206', '15', '4536');
INSERT INTO public.who_global_data_import VALUES (10787, '2021-01-23', 'BA', 'Bosnia and Herzegovina', 'EURO', '214', '119420', '19', '4555');
INSERT INTO public.who_global_data_import VALUES (10788, '2021-01-24', 'BA', 'Bosnia and Herzegovina', 'EURO', '420', '119840', '14', '4569');
INSERT INTO public.who_global_data_import VALUES (10789, '2021-01-25', 'BA', 'Bosnia and Herzegovina', 'EURO', '203', '120043', '5', '4574');
INSERT INTO public.who_global_data_import VALUES (10790, '2021-01-26', 'BA', 'Bosnia and Herzegovina', 'EURO', '100', '120143', '19', '4593');
INSERT INTO public.who_global_data_import VALUES (10791, '2021-01-27', 'BA', 'Bosnia and Herzegovina', 'EURO', '389', '120532', '28', '4621');
INSERT INTO public.who_global_data_import VALUES (10792, '2021-01-28', 'BA', 'Bosnia and Herzegovina', 'EURO', '332', '120864', '22', '4643');
INSERT INTO public.who_global_data_import VALUES (10793, '2021-01-29', 'BA', 'Bosnia and Herzegovina', 'EURO', '330', '121194', '16', '4659');
INSERT INTO public.who_global_data_import VALUES (10794, '2021-01-30', 'BA', 'Bosnia and Herzegovina', 'EURO', '303', '121497', '20', '4679');
INSERT INTO public.who_global_data_import VALUES (10795, '2021-01-31', 'BA', 'Bosnia and Herzegovina', 'EURO', '394', '121891', '17', '4696');
INSERT INTO public.who_global_data_import VALUES (10796, '2021-02-01', 'BA', 'Bosnia and Herzegovina', 'EURO', '195', '122086', '9', '4705');
INSERT INTO public.who_global_data_import VALUES (10797, '2021-02-02', 'BA', 'Bosnia and Herzegovina', 'EURO', '113', '122199', '19', '4724');
INSERT INTO public.who_global_data_import VALUES (10798, '2021-02-03', 'BA', 'Bosnia and Herzegovina', 'EURO', '262', '122461', '13', '4737');
INSERT INTO public.who_global_data_import VALUES (10799, '2021-02-04', 'BA', 'Bosnia and Herzegovina', 'EURO', '367', '122828', '8', '4745');
INSERT INTO public.who_global_data_import VALUES (10800, '2021-02-05', 'BA', 'Bosnia and Herzegovina', 'EURO', '314', '123142', '16', '4761');
INSERT INTO public.who_global_data_import VALUES (10801, '2020-01-03', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10802, '2020-01-04', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10803, '2020-01-05', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10804, '2020-01-06', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10805, '2020-01-07', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10806, '2020-01-08', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10807, '2020-01-09', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10808, '2020-01-10', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10809, '2020-01-11', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10810, '2020-01-12', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10811, '2020-01-13', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10812, '2020-01-14', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10813, '2020-01-15', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10814, '2020-01-16', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10815, '2020-01-17', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10816, '2020-01-18', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10817, '2020-01-19', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10818, '2020-01-20', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10819, '2020-01-21', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10820, '2020-01-22', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10821, '2020-01-23', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10822, '2020-01-24', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10823, '2020-01-25', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10824, '2020-01-26', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10825, '2020-01-27', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10826, '2020-01-28', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10827, '2020-01-29', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10828, '2020-01-30', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10829, '2020-01-31', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10832, '2020-02-03', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10833, '2020-02-04', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10834, '2020-02-05', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10835, '2020-02-06', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10836, '2020-02-07', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10837, '2020-02-08', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10838, '2020-02-09', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10839, '2020-02-10', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10840, '2020-02-11', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10841, '2020-02-12', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10842, '2020-02-13', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10843, '2020-02-14', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10844, '2020-02-15', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10845, '2020-02-16', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10846, '2020-02-17', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10847, '2020-02-18', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10848, '2020-02-19', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10849, '2020-02-20', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10850, '2020-02-21', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10851, '2020-02-22', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10852, '2020-02-23', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10853, '2020-02-24', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10854, '2020-02-25', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10855, '2020-02-26', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10856, '2020-02-27', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10857, '2020-02-28', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10858, '2020-02-29', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10859, '2020-03-01', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10860, '2020-03-02', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10861, '2020-03-03', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10862, '2020-03-04', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10863, '2020-03-05', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10864, '2020-03-06', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10865, '2020-03-07', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10866, '2020-03-08', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10867, '2020-03-09', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10868, '2020-03-10', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10869, '2020-03-11', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10870, '2020-03-12', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10871, '2020-03-13', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10872, '2020-03-14', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10873, '2020-03-15', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10874, '2020-03-16', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10875, '2020-03-17', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10876, '2020-03-18', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10877, '2020-03-19', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10878, '2020-03-20', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10879, '2020-03-21', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10880, '2020-03-22', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10881, '2020-03-23', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10882, '2020-03-24', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10883, '2020-03-25', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10884, '2020-03-26', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10885, '2020-03-27', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10886, '2020-03-28', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10887, '2020-03-29', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10888, '2020-03-30', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10889, '2020-03-31', 'BW', 'Botswana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10890, '2020-04-01', 'BW', 'Botswana', 'AFRO', '3', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (10891, '2020-04-02', 'BW', 'Botswana', 'AFRO', '0', '3', '1', '1');
INSERT INTO public.who_global_data_import VALUES (10892, '2020-04-03', 'BW', 'Botswana', 'AFRO', '1', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10893, '2020-04-04', 'BW', 'Botswana', 'AFRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10894, '2020-04-05', 'BW', 'Botswana', 'AFRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10895, '2020-04-06', 'BW', 'Botswana', 'AFRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10896, '2020-04-07', 'BW', 'Botswana', 'AFRO', '2', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10897, '2020-04-08', 'BW', 'Botswana', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10898, '2020-04-09', 'BW', 'Botswana', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10899, '2020-04-10', 'BW', 'Botswana', 'AFRO', '7', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10900, '2020-04-11', 'BW', 'Botswana', 'AFRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10901, '2020-04-12', 'BW', 'Botswana', 'AFRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10902, '2020-04-13', 'BW', 'Botswana', 'AFRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10903, '2020-04-14', 'BW', 'Botswana', 'AFRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10904, '2020-04-15', 'BW', 'Botswana', 'AFRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10905, '2020-04-16', 'BW', 'Botswana', 'AFRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10906, '2020-04-17', 'BW', 'Botswana', 'AFRO', '2', '15', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10907, '2020-04-18', 'BW', 'Botswana', 'AFRO', '0', '15', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10908, '2020-04-19', 'BW', 'Botswana', 'AFRO', '0', '15', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10909, '2020-04-20', 'BW', 'Botswana', 'AFRO', '5', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10910, '2020-04-21', 'BW', 'Botswana', 'AFRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10911, '2020-04-22', 'BW', 'Botswana', 'AFRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10912, '2020-04-23', 'BW', 'Botswana', 'AFRO', '2', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10913, '2020-04-24', 'BW', 'Botswana', 'AFRO', '0', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10914, '2020-04-25', 'BW', 'Botswana', 'AFRO', '0', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10915, '2020-04-26', 'BW', 'Botswana', 'AFRO', '0', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10916, '2020-04-27', 'BW', 'Botswana', 'AFRO', '0', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10917, '2020-04-28', 'BW', 'Botswana', 'AFRO', '0', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10918, '2020-04-29', 'BW', 'Botswana', 'AFRO', '1', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10919, '2020-04-30', 'BW', 'Botswana', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10920, '2020-05-01', 'BW', 'Botswana', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10921, '2020-05-02', 'BW', 'Botswana', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10922, '2020-05-03', 'BW', 'Botswana', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10923, '2020-05-04', 'BW', 'Botswana', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10924, '2020-05-05', 'BW', 'Botswana', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10925, '2020-05-06', 'BW', 'Botswana', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10926, '2020-05-07', 'BW', 'Botswana', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10927, '2020-05-08', 'BW', 'Botswana', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10928, '2020-05-09', 'BW', 'Botswana', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10929, '2020-05-10', 'BW', 'Botswana', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10930, '2020-05-11', 'BW', 'Botswana', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10931, '2020-05-12', 'BW', 'Botswana', 'AFRO', '1', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10932, '2020-05-13', 'BW', 'Botswana', 'AFRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10933, '2020-05-14', 'BW', 'Botswana', 'AFRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10934, '2020-05-15', 'BW', 'Botswana', 'AFRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10935, '2020-05-16', 'BW', 'Botswana', 'AFRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10936, '2020-05-17', 'BW', 'Botswana', 'AFRO', '1', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10937, '2020-05-18', 'BW', 'Botswana', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10938, '2020-05-19', 'BW', 'Botswana', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10939, '2020-05-20', 'BW', 'Botswana', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10940, '2020-05-21', 'BW', 'Botswana', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10941, '2020-05-22', 'BW', 'Botswana', 'AFRO', '4', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10942, '2020-05-23', 'BW', 'Botswana', 'AFRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10943, '2020-05-24', 'BW', 'Botswana', 'AFRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10944, '2020-05-25', 'BW', 'Botswana', 'AFRO', '6', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10945, '2020-05-26', 'BW', 'Botswana', 'AFRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10946, '2020-05-27', 'BW', 'Botswana', 'AFRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10947, '2020-05-28', 'BW', 'Botswana', 'AFRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10948, '2020-05-29', 'BW', 'Botswana', 'AFRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10949, '2020-05-30', 'BW', 'Botswana', 'AFRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10950, '2020-05-31', 'BW', 'Botswana', 'AFRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10951, '2020-06-01', 'BW', 'Botswana', 'AFRO', '3', '38', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10952, '2020-06-02', 'BW', 'Botswana', 'AFRO', '0', '38', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10953, '2020-06-03', 'BW', 'Botswana', 'AFRO', '2', '40', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10954, '2020-06-04', 'BW', 'Botswana', 'AFRO', '0', '40', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10955, '2020-06-05', 'BW', 'Botswana', 'AFRO', '0', '40', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10956, '2020-06-06', 'BW', 'Botswana', 'AFRO', '0', '40', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10957, '2020-06-07', 'BW', 'Botswana', 'AFRO', '0', '40', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10958, '2020-06-08', 'BW', 'Botswana', 'AFRO', '0', '40', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10959, '2020-06-09', 'BW', 'Botswana', 'AFRO', '2', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10960, '2020-06-10', 'BW', 'Botswana', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10961, '2020-06-11', 'BW', 'Botswana', 'AFRO', '6', '48', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10962, '2020-06-12', 'BW', 'Botswana', 'AFRO', '0', '48', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10963, '2020-06-13', 'BW', 'Botswana', 'AFRO', '12', '60', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10964, '2020-06-14', 'BW', 'Botswana', 'AFRO', '0', '60', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10965, '2020-06-15', 'BW', 'Botswana', 'AFRO', '0', '60', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10966, '2020-06-16', 'BW', 'Botswana', 'AFRO', '0', '60', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10967, '2020-06-17', 'BW', 'Botswana', 'AFRO', '0', '60', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10968, '2020-06-18', 'BW', 'Botswana', 'AFRO', '19', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10969, '2020-06-19', 'BW', 'Botswana', 'AFRO', '0', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10970, '2020-06-20', 'BW', 'Botswana', 'AFRO', '10', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10971, '2020-06-21', 'BW', 'Botswana', 'AFRO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10972, '2020-06-22', 'BW', 'Botswana', 'AFRO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10973, '2020-06-23', 'BW', 'Botswana', 'AFRO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10974, '2020-06-24', 'BW', 'Botswana', 'AFRO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10975, '2020-06-25', 'BW', 'Botswana', 'AFRO', '36', '125', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10976, '2020-06-26', 'BW', 'Botswana', 'AFRO', '0', '125', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10977, '2020-06-27', 'BW', 'Botswana', 'AFRO', '0', '125', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10978, '2020-06-28', 'BW', 'Botswana', 'AFRO', '0', '125', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10979, '2020-06-29', 'BW', 'Botswana', 'AFRO', '50', '175', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10980, '2020-06-30', 'BW', 'Botswana', 'AFRO', '0', '175', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10981, '2020-07-01', 'BW', 'Botswana', 'AFRO', '52', '227', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10982, '2020-07-02', 'BW', 'Botswana', 'AFRO', '0', '227', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10983, '2020-07-03', 'BW', 'Botswana', 'AFRO', '0', '227', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10984, '2020-07-04', 'BW', 'Botswana', 'AFRO', '48', '275', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10985, '2020-07-05', 'BW', 'Botswana', 'AFRO', '0', '275', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10986, '2020-07-06', 'BW', 'Botswana', 'AFRO', '0', '275', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10987, '2020-07-07', 'BW', 'Botswana', 'AFRO', '39', '314', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10988, '2020-07-08', 'BW', 'Botswana', 'AFRO', '0', '314', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10989, '2020-07-09', 'BW', 'Botswana', 'AFRO', '0', '314', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10990, '2020-07-10', 'BW', 'Botswana', 'AFRO', '0', '314', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10991, '2020-07-11', 'BW', 'Botswana', 'AFRO', '0', '314', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10992, '2020-07-12', 'BW', 'Botswana', 'AFRO', '0', '314', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10993, '2020-07-13', 'BW', 'Botswana', 'AFRO', '85', '399', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10994, '2020-07-14', 'BW', 'Botswana', 'AFRO', '0', '399', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10995, '2020-07-15', 'BW', 'Botswana', 'AFRO', '0', '399', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10996, '2020-07-16', 'BW', 'Botswana', 'AFRO', '0', '399', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10997, '2020-07-17', 'BW', 'Botswana', 'AFRO', '123', '522', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10998, '2020-07-18', 'BW', 'Botswana', 'AFRO', '0', '522', '0', '1');
INSERT INTO public.who_global_data_import VALUES (10999, '2020-07-19', 'BW', 'Botswana', 'AFRO', '0', '522', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11000, '2020-07-20', 'BW', 'Botswana', 'AFRO', '0', '522', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11001, '2020-07-21', 'BW', 'Botswana', 'AFRO', '0', '522', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11002, '2020-07-22', 'BW', 'Botswana', 'AFRO', '0', '522', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11003, '2020-07-23', 'BW', 'Botswana', 'AFRO', '100', '622', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11004, '2020-07-24', 'BW', 'Botswana', 'AFRO', '0', '622', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11005, '2020-07-25', 'BW', 'Botswana', 'AFRO', '64', '686', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11006, '2020-07-26', 'BW', 'Botswana', 'AFRO', '0', '686', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11007, '2020-07-27', 'BW', 'Botswana', 'AFRO', '0', '686', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11008, '2020-07-28', 'BW', 'Botswana', 'AFRO', '53', '739', '1', '2');
INSERT INTO public.who_global_data_import VALUES (11009, '2020-07-29', 'BW', 'Botswana', 'AFRO', '0', '739', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11010, '2020-07-30', 'BW', 'Botswana', 'AFRO', '65', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11011, '2020-07-31', 'BW', 'Botswana', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11012, '2020-08-01', 'BW', 'Botswana', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11013, '2020-08-02', 'BW', 'Botswana', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11014, '2020-08-03', 'BW', 'Botswana', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11015, '2020-08-04', 'BW', 'Botswana', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11016, '2020-08-05', 'BW', 'Botswana', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11017, '2020-08-06', 'BW', 'Botswana', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11018, '2020-08-07', 'BW', 'Botswana', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11019, '2020-08-08', 'BW', 'Botswana', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11020, '2020-08-09', 'BW', 'Botswana', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11021, '2020-08-10', 'BW', 'Botswana', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11022, '2020-08-11', 'BW', 'Botswana', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11023, '2020-08-12', 'BW', 'Botswana', 'AFRO', '262', '1066', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11024, '2020-08-13', 'BW', 'Botswana', 'AFRO', '0', '1066', '0', '2');
INSERT INTO public.who_global_data_import VALUES (11025, '2020-08-14', 'BW', 'Botswana', 'AFRO', '148', '1214', '1', '3');
INSERT INTO public.who_global_data_import VALUES (11026, '2020-08-15', 'BW', 'Botswana', 'AFRO', '0', '1214', '0', '3');
INSERT INTO public.who_global_data_import VALUES (11027, '2020-08-16', 'BW', 'Botswana', 'AFRO', '0', '1214', '0', '3');
INSERT INTO public.who_global_data_import VALUES (11028, '2020-08-17', 'BW', 'Botswana', 'AFRO', '0', '1214', '0', '3');
INSERT INTO public.who_global_data_import VALUES (11029, '2020-08-18', 'BW', 'Botswana', 'AFRO', '94', '1308', '0', '3');
INSERT INTO public.who_global_data_import VALUES (11030, '2020-08-19', 'BW', 'Botswana', 'AFRO', '0', '1308', '0', '3');
INSERT INTO public.who_global_data_import VALUES (11031, '2020-08-20', 'BW', 'Botswana', 'AFRO', '0', '1308', '0', '3');
INSERT INTO public.who_global_data_import VALUES (11032, '2020-08-21', 'BW', 'Botswana', 'AFRO', '0', '1308', '0', '3');
INSERT INTO public.who_global_data_import VALUES (11033, '2020-08-22', 'BW', 'Botswana', 'AFRO', '0', '1308', '0', '3');
INSERT INTO public.who_global_data_import VALUES (11034, '2020-08-23', 'BW', 'Botswana', 'AFRO', '0', '1308', '0', '3');
INSERT INTO public.who_global_data_import VALUES (11035, '2020-08-24', 'BW', 'Botswana', 'AFRO', '0', '1308', '0', '3');
INSERT INTO public.who_global_data_import VALUES (11036, '2020-08-25', 'BW', 'Botswana', 'AFRO', '254', '1562', '0', '3');
INSERT INTO public.who_global_data_import VALUES (11037, '2020-08-26', 'BW', 'Botswana', 'AFRO', '0', '1562', '0', '3');
INSERT INTO public.who_global_data_import VALUES (11038, '2020-08-27', 'BW', 'Botswana', 'AFRO', '71', '1633', '3', '6');
INSERT INTO public.who_global_data_import VALUES (11039, '2020-08-28', 'BW', 'Botswana', 'AFRO', '0', '1633', '0', '6');
INSERT INTO public.who_global_data_import VALUES (11040, '2020-08-29', 'BW', 'Botswana', 'AFRO', '0', '1633', '0', '6');
INSERT INTO public.who_global_data_import VALUES (11041, '2020-08-30', 'BW', 'Botswana', 'AFRO', '0', '1633', '0', '6');
INSERT INTO public.who_global_data_import VALUES (11042, '2020-08-31', 'BW', 'Botswana', 'AFRO', '0', '1633', '0', '6');
INSERT INTO public.who_global_data_import VALUES (11043, '2020-09-01', 'BW', 'Botswana', 'AFRO', '91', '1724', '0', '6');
INSERT INTO public.who_global_data_import VALUES (11044, '2020-09-02', 'BW', 'Botswana', 'AFRO', '0', '1724', '0', '6');
INSERT INTO public.who_global_data_import VALUES (11045, '2020-09-03', 'BW', 'Botswana', 'AFRO', '0', '1724', '0', '6');
INSERT INTO public.who_global_data_import VALUES (11046, '2020-09-04', 'BW', 'Botswana', 'AFRO', '0', '1724', '0', '6');
INSERT INTO public.who_global_data_import VALUES (11047, '2020-09-05', 'BW', 'Botswana', 'AFRO', '278', '2002', '2', '8');
INSERT INTO public.who_global_data_import VALUES (11048, '2020-09-06', 'BW', 'Botswana', 'AFRO', '0', '2002', '0', '8');
INSERT INTO public.who_global_data_import VALUES (11049, '2020-09-07', 'BW', 'Botswana', 'AFRO', '0', '2002', '0', '8');
INSERT INTO public.who_global_data_import VALUES (11050, '2020-09-08', 'BW', 'Botswana', 'AFRO', '124', '2126', '1', '9');
INSERT INTO public.who_global_data_import VALUES (11051, '2020-09-09', 'BW', 'Botswana', 'AFRO', '0', '2126', '0', '9');
INSERT INTO public.who_global_data_import VALUES (11052, '2020-09-10', 'BW', 'Botswana', 'AFRO', '0', '2126', '0', '9');
INSERT INTO public.who_global_data_import VALUES (11053, '2020-09-11', 'BW', 'Botswana', 'AFRO', '0', '2126', '0', '9');
INSERT INTO public.who_global_data_import VALUES (11054, '2020-09-12', 'BW', 'Botswana', 'AFRO', '0', '2126', '0', '9');
INSERT INTO public.who_global_data_import VALUES (11055, '2020-09-13', 'BW', 'Botswana', 'AFRO', '126', '2252', '1', '10');
INSERT INTO public.who_global_data_import VALUES (11056, '2020-09-14', 'BW', 'Botswana', 'AFRO', '0', '2252', '0', '10');
INSERT INTO public.who_global_data_import VALUES (11057, '2020-09-15', 'BW', 'Botswana', 'AFRO', '0', '2252', '0', '10');
INSERT INTO public.who_global_data_import VALUES (11058, '2020-09-16', 'BW', 'Botswana', 'AFRO', '211', '2463', '1', '11');
INSERT INTO public.who_global_data_import VALUES (11059, '2020-09-17', 'BW', 'Botswana', 'AFRO', '0', '2463', '0', '11');
INSERT INTO public.who_global_data_import VALUES (11060, '2020-09-18', 'BW', 'Botswana', 'AFRO', '104', '2567', '2', '13');
INSERT INTO public.who_global_data_import VALUES (11061, '2020-09-19', 'BW', 'Botswana', 'AFRO', '0', '2567', '0', '13');
INSERT INTO public.who_global_data_import VALUES (11062, '2020-09-20', 'BW', 'Botswana', 'AFRO', '0', '2567', '0', '13');
INSERT INTO public.who_global_data_import VALUES (11063, '2020-09-21', 'BW', 'Botswana', 'AFRO', '0', '2567', '0', '13');
INSERT INTO public.who_global_data_import VALUES (11064, '2020-09-22', 'BW', 'Botswana', 'AFRO', '0', '2567', '0', '13');
INSERT INTO public.who_global_data_import VALUES (11065, '2020-09-23', 'BW', 'Botswana', 'AFRO', '0', '2567', '0', '13');
INSERT INTO public.who_global_data_import VALUES (11066, '2020-09-24', 'BW', 'Botswana', 'AFRO', '0', '2567', '0', '13');
INSERT INTO public.who_global_data_import VALUES (11067, '2020-09-25', 'BW', 'Botswana', 'AFRO', '354', '2921', '0', '13');
INSERT INTO public.who_global_data_import VALUES (11068, '2020-09-26', 'BW', 'Botswana', 'AFRO', '0', '2921', '0', '13');
INSERT INTO public.who_global_data_import VALUES (11069, '2020-09-27', 'BW', 'Botswana', 'AFRO', '0', '2921', '0', '13');
INSERT INTO public.who_global_data_import VALUES (11070, '2020-09-28', 'BW', 'Botswana', 'AFRO', '0', '2921', '0', '13');
INSERT INTO public.who_global_data_import VALUES (11071, '2020-09-29', 'BW', 'Botswana', 'AFRO', '251', '3172', '3', '16');
INSERT INTO public.who_global_data_import VALUES (11072, '2020-09-30', 'BW', 'Botswana', 'AFRO', '0', '3172', '0', '16');
INSERT INTO public.who_global_data_import VALUES (11073, '2020-10-01', 'BW', 'Botswana', 'AFRO', '0', '3172', '0', '16');
INSERT INTO public.who_global_data_import VALUES (11074, '2020-10-02', 'BW', 'Botswana', 'AFRO', '0', '3172', '0', '16');
INSERT INTO public.who_global_data_import VALUES (11075, '2020-10-03', 'BW', 'Botswana', 'AFRO', '0', '3172', '0', '16');
INSERT INTO public.who_global_data_import VALUES (11076, '2020-10-04', 'BW', 'Botswana', 'AFRO', '0', '3172', '0', '16');
INSERT INTO public.who_global_data_import VALUES (11077, '2020-10-05', 'BW', 'Botswana', 'AFRO', '0', '3172', '0', '16');
INSERT INTO public.who_global_data_import VALUES (11078, '2020-10-06', 'BW', 'Botswana', 'AFRO', '0', '3172', '0', '16');
INSERT INTO public.who_global_data_import VALUES (11079, '2020-10-07', 'BW', 'Botswana', 'AFRO', '0', '3172', '0', '16');
INSERT INTO public.who_global_data_import VALUES (11080, '2020-10-08', 'BW', 'Botswana', 'AFRO', '0', '3172', '0', '16');
INSERT INTO public.who_global_data_import VALUES (11081, '2020-10-09', 'BW', 'Botswana', 'AFRO', '47', '3219', '2', '18');
INSERT INTO public.who_global_data_import VALUES (11082, '2020-10-10', 'BW', 'Botswana', 'AFRO', '0', '3219', '0', '18');
INSERT INTO public.who_global_data_import VALUES (11083, '2020-10-11', 'BW', 'Botswana', 'AFRO', '0', '3219', '0', '18');
INSERT INTO public.who_global_data_import VALUES (11084, '2020-10-12', 'BW', 'Botswana', 'AFRO', '0', '3219', '0', '18');
INSERT INTO public.who_global_data_import VALUES (11085, '2020-10-13', 'BW', 'Botswana', 'AFRO', '1820', '5039', '2', '20');
INSERT INTO public.who_global_data_import VALUES (11086, '2020-10-14', 'BW', 'Botswana', 'AFRO', '0', '5039', '0', '20');
INSERT INTO public.who_global_data_import VALUES (11087, '2020-10-15', 'BW', 'Botswana', 'AFRO', '0', '5039', '0', '20');
INSERT INTO public.who_global_data_import VALUES (11088, '2020-10-16', 'BW', 'Botswana', 'AFRO', '203', '5242', '0', '20');
INSERT INTO public.who_global_data_import VALUES (11089, '2020-10-17', 'BW', 'Botswana', 'AFRO', '0', '5242', '0', '20');
INSERT INTO public.who_global_data_import VALUES (11090, '2020-10-18', 'BW', 'Botswana', 'AFRO', '0', '5242', '0', '20');
INSERT INTO public.who_global_data_import VALUES (11091, '2020-10-19', 'BW', 'Botswana', 'AFRO', '0', '5242', '0', '20');
INSERT INTO public.who_global_data_import VALUES (11092, '2020-10-20', 'BW', 'Botswana', 'AFRO', '0', '5242', '0', '20');
INSERT INTO public.who_global_data_import VALUES (11093, '2020-10-21', 'BW', 'Botswana', 'AFRO', '367', '5609', '1', '21');
INSERT INTO public.who_global_data_import VALUES (11094, '2020-10-22', 'BW', 'Botswana', 'AFRO', '0', '5609', '0', '21');
INSERT INTO public.who_global_data_import VALUES (11095, '2020-10-23', 'BW', 'Botswana', 'AFRO', '0', '5609', '0', '21');
INSERT INTO public.who_global_data_import VALUES (11096, '2020-10-24', 'BW', 'Botswana', 'AFRO', '314', '5923', '0', '21');
INSERT INTO public.who_global_data_import VALUES (11097, '2020-10-25', 'BW', 'Botswana', 'AFRO', '0', '5923', '0', '21');
INSERT INTO public.who_global_data_import VALUES (11098, '2020-10-26', 'BW', 'Botswana', 'AFRO', '0', '5923', '0', '21');
INSERT INTO public.who_global_data_import VALUES (11099, '2020-10-27', 'BW', 'Botswana', 'AFRO', '0', '5923', '0', '21');
INSERT INTO public.who_global_data_import VALUES (11100, '2020-10-28', 'BW', 'Botswana', 'AFRO', '360', '6283', '0', '21');
INSERT INTO public.who_global_data_import VALUES (11101, '2020-10-29', 'BW', 'Botswana', 'AFRO', '0', '6283', '0', '21');
INSERT INTO public.who_global_data_import VALUES (11102, '2020-10-30', 'BW', 'Botswana', 'AFRO', '359', '6642', '3', '24');
INSERT INTO public.who_global_data_import VALUES (11103, '2020-10-31', 'BW', 'Botswana', 'AFRO', '0', '6642', '0', '24');
INSERT INTO public.who_global_data_import VALUES (11104, '2020-11-01', 'BW', 'Botswana', 'AFRO', '0', '6642', '0', '24');
INSERT INTO public.who_global_data_import VALUES (11105, '2020-11-02', 'BW', 'Botswana', 'AFRO', '0', '6642', '0', '24');
INSERT INTO public.who_global_data_import VALUES (11106, '2020-11-03', 'BW', 'Botswana', 'AFRO', '0', '6642', '0', '24');
INSERT INTO public.who_global_data_import VALUES (11107, '2020-11-04', 'BW', 'Botswana', 'AFRO', '0', '6642', '0', '24');
INSERT INTO public.who_global_data_import VALUES (11108, '2020-11-05', 'BW', 'Botswana', 'AFRO', '0', '6642', '0', '24');
INSERT INTO public.who_global_data_import VALUES (11109, '2020-11-06', 'BW', 'Botswana', 'AFRO', '1193', '7835', '3', '27');
INSERT INTO public.who_global_data_import VALUES (11110, '2020-11-07', 'BW', 'Botswana', 'AFRO', '0', '7835', '0', '27');
INSERT INTO public.who_global_data_import VALUES (11111, '2020-11-08', 'BW', 'Botswana', 'AFRO', '0', '7835', '0', '27');
INSERT INTO public.who_global_data_import VALUES (11112, '2020-11-09', 'BW', 'Botswana', 'AFRO', '0', '7835', '0', '27');
INSERT INTO public.who_global_data_import VALUES (11113, '2020-11-10', 'BW', 'Botswana', 'AFRO', '0', '7835', '0', '27');
INSERT INTO public.who_global_data_import VALUES (11114, '2020-11-11', 'BW', 'Botswana', 'AFRO', '0', '7835', '0', '27');
INSERT INTO public.who_global_data_import VALUES (11115, '2020-11-12', 'BW', 'Botswana', 'AFRO', '0', '7835', '0', '27');
INSERT INTO public.who_global_data_import VALUES (11116, '2020-11-13', 'BW', 'Botswana', 'AFRO', '0', '7835', '0', '27');
INSERT INTO public.who_global_data_import VALUES (11117, '2020-11-14', 'BW', 'Botswana', 'AFRO', '390', '8225', '0', '27');
INSERT INTO public.who_global_data_import VALUES (11118, '2020-11-15', 'BW', 'Botswana', 'AFRO', '0', '8225', '0', '27');
INSERT INTO public.who_global_data_import VALUES (11119, '2020-11-16', 'BW', 'Botswana', 'AFRO', '0', '8225', '0', '27');
INSERT INTO public.who_global_data_import VALUES (11120, '2020-11-17', 'BW', 'Botswana', 'AFRO', '0', '8225', '0', '27');
INSERT INTO public.who_global_data_import VALUES (11121, '2020-11-18', 'BW', 'Botswana', 'AFRO', '878', '9103', '2', '29');
INSERT INTO public.who_global_data_import VALUES (11122, '2020-11-19', 'BW', 'Botswana', 'AFRO', '0', '9103', '0', '29');
INSERT INTO public.who_global_data_import VALUES (11123, '2020-11-20', 'BW', 'Botswana', 'AFRO', '491', '9594', '2', '31');
INSERT INTO public.who_global_data_import VALUES (11124, '2020-11-21', 'BW', 'Botswana', 'AFRO', '0', '9594', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11125, '2020-11-22', 'BW', 'Botswana', 'AFRO', '0', '9594', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11126, '2020-11-23', 'BW', 'Botswana', 'AFRO', '0', '9594', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11127, '2020-11-24', 'BW', 'Botswana', 'AFRO', '0', '9594', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11128, '2020-11-25', 'BW', 'Botswana', 'AFRO', '398', '9992', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11129, '2020-11-26', 'BW', 'Botswana', 'AFRO', '0', '9992', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11130, '2020-11-27', 'BW', 'Botswana', 'AFRO', '0', '9992', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11131, '2020-11-28', 'BW', 'Botswana', 'AFRO', '0', '9992', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11132, '2020-11-29', 'BW', 'Botswana', 'AFRO', '0', '9992', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11133, '2020-11-30', 'BW', 'Botswana', 'AFRO', '0', '9992', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11134, '2020-12-01', 'BW', 'Botswana', 'AFRO', '0', '9992', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11135, '2020-12-02', 'BW', 'Botswana', 'AFRO', '0', '9992', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11136, '2020-12-03', 'BW', 'Botswana', 'AFRO', '0', '9992', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11137, '2020-12-04', 'BW', 'Botswana', 'AFRO', '0', '9992', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11138, '2020-12-05', 'BW', 'Botswana', 'AFRO', '0', '9992', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11139, '2020-12-06', 'BW', 'Botswana', 'AFRO', '0', '9992', '0', '31');
INSERT INTO public.who_global_data_import VALUES (11140, '2020-12-07', 'BW', 'Botswana', 'AFRO', '1225', '11217', '3', '34');
INSERT INTO public.who_global_data_import VALUES (11141, '2020-12-08', 'BW', 'Botswana', 'AFRO', '314', '11531', '0', '34');
INSERT INTO public.who_global_data_import VALUES (11142, '2020-12-09', 'BW', 'Botswana', 'AFRO', '527', '12058', '0', '34');
INSERT INTO public.who_global_data_import VALUES (11143, '2020-12-10', 'BW', 'Botswana', 'AFRO', '0', '12058', '0', '34');
INSERT INTO public.who_global_data_import VALUES (11144, '2020-12-11', 'BW', 'Botswana', 'AFRO', '0', '12058', '0', '34');
INSERT INTO public.who_global_data_import VALUES (11145, '2020-12-12', 'BW', 'Botswana', 'AFRO', '443', '12501', '3', '37');
INSERT INTO public.who_global_data_import VALUES (11146, '2020-12-13', 'BW', 'Botswana', 'AFRO', '0', '12501', '0', '37');
INSERT INTO public.who_global_data_import VALUES (11147, '2020-12-14', 'BW', 'Botswana', 'AFRO', '0', '12501', '0', '37');
INSERT INTO public.who_global_data_import VALUES (11148, '2020-12-15', 'BW', 'Botswana', 'AFRO', '0', '12501', '0', '37');
INSERT INTO public.who_global_data_import VALUES (11149, '2020-12-16', 'BW', 'Botswana', 'AFRO', '372', '12873', '1', '38');
INSERT INTO public.who_global_data_import VALUES (11150, '2020-12-17', 'BW', 'Botswana', 'AFRO', '0', '12873', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11151, '2020-12-18', 'BW', 'Botswana', 'AFRO', '0', '12873', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11152, '2020-12-19', 'BW', 'Botswana', 'AFRO', '0', '12873', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11153, '2020-12-20', 'BW', 'Botswana', 'AFRO', '0', '12873', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11154, '2020-12-21', 'BW', 'Botswana', 'AFRO', '0', '12873', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11155, '2020-12-22', 'BW', 'Botswana', 'AFRO', '480', '13353', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11156, '2020-12-23', 'BW', 'Botswana', 'AFRO', '0', '13353', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11157, '2020-12-24', 'BW', 'Botswana', 'AFRO', '0', '13353', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11158, '2020-12-25', 'BW', 'Botswana', 'AFRO', '269', '13622', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11159, '2020-12-26', 'BW', 'Botswana', 'AFRO', '0', '13622', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11160, '2020-12-27', 'BW', 'Botswana', 'AFRO', '0', '13622', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11161, '2020-12-28', 'BW', 'Botswana', 'AFRO', '0', '13622', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11162, '2020-12-29', 'BW', 'Botswana', 'AFRO', '0', '13622', '0', '38');
INSERT INTO public.who_global_data_import VALUES (11163, '2020-12-30', 'BW', 'Botswana', 'AFRO', '403', '14025', '2', '40');
INSERT INTO public.who_global_data_import VALUES (11164, '2020-12-31', 'BW', 'Botswana', 'AFRO', '0', '14025', '0', '40');
INSERT INTO public.who_global_data_import VALUES (11165, '2021-01-01', 'BW', 'Botswana', 'AFRO', '0', '14025', '0', '40');
INSERT INTO public.who_global_data_import VALUES (11166, '2021-01-02', 'BW', 'Botswana', 'AFRO', '0', '14025', '0', '40');
INSERT INTO public.who_global_data_import VALUES (11167, '2021-01-03', 'BW', 'Botswana', 'AFRO', '780', '14805', '2', '42');
INSERT INTO public.who_global_data_import VALUES (11168, '2021-01-04', 'BW', 'Botswana', 'AFRO', '0', '14805', '0', '42');
INSERT INTO public.who_global_data_import VALUES (11169, '2021-01-05', 'BW', 'Botswana', 'AFRO', '0', '14805', '0', '42');
INSERT INTO public.who_global_data_import VALUES (11170, '2021-01-06', 'BW', 'Botswana', 'AFRO', '0', '14805', '0', '42');
INSERT INTO public.who_global_data_import VALUES (11171, '2021-01-07', 'BW', 'Botswana', 'AFRO', '0', '14805', '0', '42');
INSERT INTO public.who_global_data_import VALUES (11172, '2021-01-08', 'BW', 'Botswana', 'AFRO', '635', '15440', '3', '45');
INSERT INTO public.who_global_data_import VALUES (11173, '2021-01-09', 'BW', 'Botswana', 'AFRO', '611', '16051', '3', '48');
INSERT INTO public.who_global_data_import VALUES (11174, '2021-01-10', 'BW', 'Botswana', 'AFRO', '0', '16051', '0', '48');
INSERT INTO public.who_global_data_import VALUES (11175, '2021-01-11', 'BW', 'Botswana', 'AFRO', '0', '16051', '0', '48');
INSERT INTO public.who_global_data_import VALUES (11176, '2021-01-12', 'BW', 'Botswana', 'AFRO', '0', '16051', '0', '48');
INSERT INTO public.who_global_data_import VALUES (11177, '2021-01-13', 'BW', 'Botswana', 'AFRO', '0', '16051', '0', '48');
INSERT INTO public.who_global_data_import VALUES (11178, '2021-01-14', 'BW', 'Botswana', 'AFRO', '0', '16051', '0', '48');
INSERT INTO public.who_global_data_import VALUES (11179, '2021-01-15', 'BW', 'Botswana', 'AFRO', '0', '16051', '0', '48');
INSERT INTO public.who_global_data_import VALUES (11180, '2021-01-16', 'BW', 'Botswana', 'AFRO', '0', '16051', '0', '48');
INSERT INTO public.who_global_data_import VALUES (11181, '2021-01-17', 'BW', 'Botswana', 'AFRO', '0', '16051', '0', '48');
INSERT INTO public.who_global_data_import VALUES (11182, '2021-01-18', 'BW', 'Botswana', 'AFRO', '597', '16648', '23', '71');
INSERT INTO public.who_global_data_import VALUES (11183, '2021-01-19', 'BW', 'Botswana', 'AFRO', '1982', '18630', '17', '88');
INSERT INTO public.who_global_data_import VALUES (11184, '2021-01-20', 'BW', 'Botswana', 'AFRO', '0', '18630', '0', '88');
INSERT INTO public.who_global_data_import VALUES (11185, '2021-01-21', 'BW', 'Botswana', 'AFRO', '0', '18630', '0', '88');
INSERT INTO public.who_global_data_import VALUES (11186, '2021-01-22', 'BW', 'Botswana', 'AFRO', '0', '18630', '0', '88');
INSERT INTO public.who_global_data_import VALUES (11187, '2021-01-23', 'BW', 'Botswana', 'AFRO', '0', '18630', '0', '88');
INSERT INTO public.who_global_data_import VALUES (11188, '2021-01-24', 'BW', 'Botswana', 'AFRO', '0', '18630', '0', '88');
INSERT INTO public.who_global_data_import VALUES (11189, '2021-01-25', 'BW', 'Botswana', 'AFRO', '0', '18630', '0', '88');
INSERT INTO public.who_global_data_import VALUES (11190, '2021-01-26', 'BW', 'Botswana', 'AFRO', '1024', '19654', '17', '105');
INSERT INTO public.who_global_data_import VALUES (11191, '2021-01-27', 'BW', 'Botswana', 'AFRO', '1004', '20658', '19', '124');
INSERT INTO public.who_global_data_import VALUES (11192, '2021-01-28', 'BW', 'Botswana', 'AFRO', '0', '20658', '0', '124');
INSERT INTO public.who_global_data_import VALUES (11193, '2021-01-29', 'BW', 'Botswana', 'AFRO', '0', '20658', '0', '124');
INSERT INTO public.who_global_data_import VALUES (11194, '2021-01-30', 'BW', 'Botswana', 'AFRO', '635', '21293', '10', '134');
INSERT INTO public.who_global_data_import VALUES (11195, '2021-01-31', 'BW', 'Botswana', 'AFRO', '0', '21293', '0', '134');
INSERT INTO public.who_global_data_import VALUES (11196, '2021-02-01', 'BW', 'Botswana', 'AFRO', '0', '21293', '0', '134');
INSERT INTO public.who_global_data_import VALUES (11197, '2021-02-02', 'BW', 'Botswana', 'AFRO', '0', '21293', '0', '134');
INSERT INTO public.who_global_data_import VALUES (11198, '2021-02-03', 'BW', 'Botswana', 'AFRO', '0', '21293', '14', '148');
INSERT INTO public.who_global_data_import VALUES (11199, '2021-02-04', 'BW', 'Botswana', 'AFRO', '1445', '22738', '0', '148');
INSERT INTO public.who_global_data_import VALUES (11200, '2021-02-05', 'BW', 'Botswana', 'AFRO', '0', '22738', '0', '148');
INSERT INTO public.who_global_data_import VALUES (11201, '2020-01-03', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11202, '2020-01-04', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11203, '2020-01-05', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11204, '2020-01-06', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11205, '2020-01-07', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11206, '2020-01-08', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11207, '2020-01-09', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11208, '2020-01-10', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11209, '2020-01-11', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11210, '2020-01-12', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11211, '2020-01-13', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11212, '2020-01-14', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11213, '2020-01-15', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11214, '2020-01-16', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11215, '2020-01-17', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11216, '2020-01-18', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11217, '2020-01-19', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11218, '2020-01-20', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11219, '2020-01-21', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11220, '2020-01-22', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11221, '2020-01-23', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11222, '2020-01-24', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11223, '2020-01-25', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11224, '2020-01-26', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11225, '2020-01-27', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11226, '2020-01-28', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11227, '2020-01-29', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11228, '2020-01-30', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11229, '2020-01-31', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11230, '2020-02-01', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11231, '2020-02-02', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11232, '2020-02-03', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11233, '2020-02-04', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11234, '2020-02-05', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11235, '2020-02-06', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11236, '2020-02-07', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11237, '2020-02-08', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11238, '2020-02-09', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11239, '2020-02-10', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11240, '2020-02-11', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11241, '2020-02-12', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11242, '2020-02-13', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11243, '2020-02-14', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11244, '2020-02-15', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11245, '2020-02-16', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11246, '2020-02-17', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11247, '2020-02-18', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11248, '2020-02-19', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11249, '2020-02-20', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11250, '2020-02-21', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11251, '2020-02-22', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11252, '2020-02-23', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11253, '2020-02-24', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11254, '2020-02-25', 'BR', 'Brazil', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11255, '2020-02-26', 'BR', 'Brazil', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11256, '2020-02-27', 'BR', 'Brazil', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11257, '2020-02-28', 'BR', 'Brazil', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11258, '2020-02-29', 'BR', 'Brazil', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11259, '2020-03-01', 'BR', 'Brazil', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11260, '2020-03-02', 'BR', 'Brazil', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11261, '2020-03-03', 'BR', 'Brazil', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11262, '2020-03-04', 'BR', 'Brazil', 'AMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11263, '2020-03-05', 'BR', 'Brazil', 'AMRO', '4', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11264, '2020-03-06', 'BR', 'Brazil', 'AMRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11265, '2020-03-07', 'BR', 'Brazil', 'AMRO', '11', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11266, '2020-03-08', 'BR', 'Brazil', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11267, '2020-03-09', 'BR', 'Brazil', 'AMRO', '6', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11268, '2020-03-10', 'BR', 'Brazil', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11269, '2020-03-11', 'BR', 'Brazil', 'AMRO', '9', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11270, '2020-03-12', 'BR', 'Brazil', 'AMRO', '18', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11271, '2020-03-13', 'BR', 'Brazil', 'AMRO', '46', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11272, '2020-03-14', 'BR', 'Brazil', 'AMRO', '23', '125', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11273, '2020-03-15', 'BR', 'Brazil', 'AMRO', '0', '125', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11274, '2020-03-16', 'BR', 'Brazil', 'AMRO', '79', '204', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11275, '2020-03-17', 'BR', 'Brazil', 'AMRO', '34', '238', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11276, '2020-03-18', 'BR', 'Brazil', 'AMRO', '57', '295', '1', '1');
INSERT INTO public.who_global_data_import VALUES (11277, '2020-03-19', 'BR', 'Brazil', 'AMRO', '133', '428', '3', '4');
INSERT INTO public.who_global_data_import VALUES (11278, '2020-03-20', 'BR', 'Brazil', 'AMRO', '193', '621', '0', '4');
INSERT INTO public.who_global_data_import VALUES (11279, '2020-03-21', 'BR', 'Brazil', 'AMRO', '283', '904', '7', '11');
INSERT INTO public.who_global_data_import VALUES (11280, '2020-03-22', 'BR', 'Brazil', 'AMRO', '0', '904', '0', '11');
INSERT INTO public.who_global_data_import VALUES (11281, '2020-03-23', 'BR', 'Brazil', 'AMRO', '0', '904', '0', '11');
INSERT INTO public.who_global_data_import VALUES (11282, '2020-03-24', 'BR', 'Brazil', 'AMRO', '1297', '2201', '35', '46');
INSERT INTO public.who_global_data_import VALUES (11283, '2020-03-25', 'BR', 'Brazil', 'AMRO', '0', '2201', '0', '46');
INSERT INTO public.who_global_data_import VALUES (11284, '2020-03-26', 'BR', 'Brazil', 'AMRO', '232', '2433', '11', '57');
INSERT INTO public.who_global_data_import VALUES (11285, '2020-03-27', 'BR', 'Brazil', 'AMRO', '0', '2433', '0', '57');
INSERT INTO public.who_global_data_import VALUES (11286, '2020-03-28', 'BR', 'Brazil', 'AMRO', '482', '2915', '20', '77');
INSERT INTO public.who_global_data_import VALUES (11287, '2020-03-29', 'BR', 'Brazil', 'AMRO', '502', '3417', '15', '92');
INSERT INTO public.who_global_data_import VALUES (11288, '2020-03-30', 'BR', 'Brazil', 'AMRO', '487', '3904', '22', '114');
INSERT INTO public.who_global_data_import VALUES (11289, '2020-03-31', 'BR', 'Brazil', 'AMRO', '352', '4256', '22', '136');
INSERT INTO public.who_global_data_import VALUES (11290, '2020-04-01', 'BR', 'Brazil', 'AMRO', '323', '4579', '23', '159');
INSERT INTO public.who_global_data_import VALUES (11291, '2020-04-02', 'BR', 'Brazil', 'AMRO', '1138', '5717', '42', '201');
INSERT INTO public.who_global_data_import VALUES (11292, '2020-04-03', 'BR', 'Brazil', 'AMRO', '1119', '6836', '40', '241');
INSERT INTO public.who_global_data_import VALUES (11293, '2020-04-04', 'BR', 'Brazil', 'AMRO', '1074', '7910', '58', '299');
INSERT INTO public.who_global_data_import VALUES (11294, '2020-04-05', 'BR', 'Brazil', 'AMRO', '1146', '9056', '60', '359');
INSERT INTO public.who_global_data_import VALUES (11295, '2020-04-06', 'BR', 'Brazil', 'AMRO', '1222', '10278', '73', '432');
INSERT INTO public.who_global_data_import VALUES (11296, '2020-04-07', 'BR', 'Brazil', 'AMRO', '852', '11130', '54', '486');
INSERT INTO public.who_global_data_import VALUES (11297, '2020-04-08', 'BR', 'Brazil', 'AMRO', '926', '12056', '67', '553');
INSERT INTO public.who_global_data_import VALUES (11298, '2020-04-09', 'BR', 'Brazil', 'AMRO', '1661', '13717', '114', '667');
INSERT INTO public.who_global_data_import VALUES (11299, '2020-04-10', 'BR', 'Brazil', 'AMRO', '2210', '15927', '133', '800');
INSERT INTO public.who_global_data_import VALUES (11300, '2020-04-11', 'BR', 'Brazil', 'AMRO', '1930', '17857', '141', '941');
INSERT INTO public.who_global_data_import VALUES (11301, '2020-04-12', 'BR', 'Brazil', 'AMRO', '1781', '19638', '115', '1056');
INSERT INTO public.who_global_data_import VALUES (11302, '2020-04-13', 'BR', 'Brazil', 'AMRO', '1089', '20727', '68', '1124');
INSERT INTO public.who_global_data_import VALUES (11303, '2020-04-14', 'BR', 'Brazil', 'AMRO', '1442', '22169', '99', '1223');
INSERT INTO public.who_global_data_import VALUES (11304, '2020-04-15', 'BR', 'Brazil', 'AMRO', '1261', '23430', '105', '1328');
INSERT INTO public.who_global_data_import VALUES (11305, '2020-04-16', 'BR', 'Brazil', 'AMRO', '1832', '25262', '204', '1532');
INSERT INTO public.who_global_data_import VALUES (11306, '2020-04-17', 'BR', 'Brazil', 'AMRO', '3058', '28320', '204', '1736');
INSERT INTO public.who_global_data_import VALUES (11307, '2020-04-18', 'BR', 'Brazil', 'AMRO', '2105', '30425', '188', '1924');
INSERT INTO public.who_global_data_import VALUES (11308, '2020-04-19', 'BR', 'Brazil', 'AMRO', '3257', '33682', '217', '2141');
INSERT INTO public.who_global_data_import VALUES (11309, '2020-04-20', 'BR', 'Brazil', 'AMRO', '2917', '36599', '206', '2347');
INSERT INTO public.who_global_data_import VALUES (11310, '2020-04-21', 'BR', 'Brazil', 'AMRO', '2055', '38654', '115', '2462');
INSERT INTO public.who_global_data_import VALUES (11311, '2020-04-22', 'BR', 'Brazil', 'AMRO', '1927', '40581', '113', '2575');
INSERT INTO public.who_global_data_import VALUES (11312, '2020-04-23', 'BR', 'Brazil', 'AMRO', '2498', '43079', '166', '2741');
INSERT INTO public.who_global_data_import VALUES (11313, '2020-04-24', 'BR', 'Brazil', 'AMRO', '2678', '45757', '165', '2906');
INSERT INTO public.who_global_data_import VALUES (11314, '2020-04-25', 'BR', 'Brazil', 'AMRO', '3735', '49492', '407', '3313');
INSERT INTO public.who_global_data_import VALUES (11315, '2020-04-26', 'BR', 'Brazil', 'AMRO', '3503', '52995', '357', '3670');
INSERT INTO public.who_global_data_import VALUES (11316, '2020-04-27', 'BR', 'Brazil', 'AMRO', '5514', '58509', '346', '4016');
INSERT INTO public.who_global_data_import VALUES (11317, '2020-04-28', 'BR', 'Brazil', 'AMRO', '3379', '61888', '189', '4205');
INSERT INTO public.who_global_data_import VALUES (11318, '2020-04-29', 'BR', 'Brazil', 'AMRO', '4613', '66501', '338', '4543');
INSERT INTO public.who_global_data_import VALUES (11319, '2020-04-30', 'BR', 'Brazil', 'AMRO', '5385', '71886', '474', '5017');
INSERT INTO public.who_global_data_import VALUES (11320, '2020-05-01', 'BR', 'Brazil', 'AMRO', '6276', '78162', '449', '5466');
INSERT INTO public.who_global_data_import VALUES (11321, '2020-05-02', 'BR', 'Brazil', 'AMRO', '7218', '85380', '435', '5901');
INSERT INTO public.who_global_data_import VALUES (11322, '2020-05-03', 'BR', 'Brazil', 'AMRO', '6209', '91589', '428', '6329');
INSERT INTO public.who_global_data_import VALUES (11323, '2020-05-04', 'BR', 'Brazil', 'AMRO', '4970', '96559', '421', '6750');
INSERT INTO public.who_global_data_import VALUES (11324, '2020-05-05', 'BR', 'Brazil', 'AMRO', '4588', '101147', '275', '7025');
INSERT INTO public.who_global_data_import VALUES (11325, '2020-05-06', 'BR', 'Brazil', 'AMRO', '6633', '107780', '296', '7321');
INSERT INTO public.who_global_data_import VALUES (11326, '2020-05-07', 'BR', 'Brazil', 'AMRO', '6935', '114715', '600', '7921');
INSERT INTO public.who_global_data_import VALUES (11327, '2020-05-08', 'BR', 'Brazil', 'AMRO', '10503', '125218', '615', '8536');
INSERT INTO public.who_global_data_import VALUES (11328, '2020-05-09', 'BR', 'Brazil', 'AMRO', '9888', '135106', '610', '9146');
INSERT INTO public.who_global_data_import VALUES (11329, '2020-05-10', 'BR', 'Brazil', 'AMRO', '10222', '145328', '751', '9897');
INSERT INTO public.who_global_data_import VALUES (11330, '2020-05-11', 'BR', 'Brazil', 'AMRO', '10611', '155939', '730', '10627');
INSERT INTO public.who_global_data_import VALUES (11331, '2020-05-12', 'BR', 'Brazil', 'AMRO', '6760', '162699', '496', '11123');
INSERT INTO public.who_global_data_import VALUES (11332, '2020-05-13', 'BR', 'Brazil', 'AMRO', '5632', '168331', '396', '11519');
INSERT INTO public.who_global_data_import VALUES (11333, '2020-05-14', 'BR', 'Brazil', 'AMRO', '9258', '177589', '881', '12400');
INSERT INTO public.who_global_data_import VALUES (11334, '2020-05-15', 'BR', 'Brazil', 'AMRO', '11385', '188974', '749', '13149');
INSERT INTO public.who_global_data_import VALUES (11335, '2020-05-16', 'BR', 'Brazil', 'AMRO', '13944', '202918', '844', '13993');
INSERT INTO public.who_global_data_import VALUES (11336, '2020-05-17', 'BR', 'Brazil', 'AMRO', '15305', '218223', '824', '14817');
INSERT INTO public.who_global_data_import VALUES (11337, '2020-05-18', 'BR', 'Brazil', 'AMRO', '14919', '233142', '816', '15633');
INSERT INTO public.who_global_data_import VALUES (11338, '2020-05-19', 'BR', 'Brazil', 'AMRO', '7938', '241080', '485', '16118');
INSERT INTO public.who_global_data_import VALUES (11339, '2020-05-20', 'BR', 'Brazil', 'AMRO', '13140', '254220', '674', '16792');
INSERT INTO public.who_global_data_import VALUES (11340, '2020-05-21', 'BR', 'Brazil', 'AMRO', '17408', '271628', '1179', '17971');
INSERT INTO public.who_global_data_import VALUES (11341, '2020-05-22', 'BR', 'Brazil', 'AMRO', '19951', '291579', '888', '18859');
INSERT INTO public.who_global_data_import VALUES (11342, '2020-05-23', 'BR', 'Brazil', 'AMRO', '18508', '310087', '1188', '20047');
INSERT INTO public.who_global_data_import VALUES (11343, '2020-05-24', 'BR', 'Brazil', 'AMRO', '20803', '330890', '1001', '21048');
INSERT INTO public.who_global_data_import VALUES (11344, '2020-05-25', 'BR', 'Brazil', 'AMRO', '16508', '347398', '965', '22013');
INSERT INTO public.who_global_data_import VALUES (11345, '2020-05-26', 'BR', 'Brazil', 'AMRO', '15813', '363211', '653', '22666');
INSERT INTO public.who_global_data_import VALUES (11346, '2020-05-27', 'BR', 'Brazil', 'AMRO', '11687', '374898', '807', '23473');
INSERT INTO public.who_global_data_import VALUES (11347, '2020-05-28', 'BR', 'Brazil', 'AMRO', '16324', '391222', '1039', '24512');
INSERT INTO public.who_global_data_import VALUES (11348, '2020-05-29', 'BR', 'Brazil', 'AMRO', '20599', '411821', '1086', '25598');
INSERT INTO public.who_global_data_import VALUES (11349, '2020-05-30', 'BR', 'Brazil', 'AMRO', '26417', '438238', '1156', '26754');
INSERT INTO public.who_global_data_import VALUES (11350, '2020-05-31', 'BR', 'Brazil', 'AMRO', '26928', '465166', '1124', '27878');
INSERT INTO public.who_global_data_import VALUES (11351, '2020-06-01', 'BR', 'Brazil', 'AMRO', '33274', '498440', '956', '28834');
INSERT INTO public.who_global_data_import VALUES (11352, '2020-06-02', 'BR', 'Brazil', 'AMRO', '16409', '514849', '480', '29314');
INSERT INTO public.who_global_data_import VALUES (11353, '2020-06-03', 'BR', 'Brazil', 'AMRO', '11598', '526447', '623', '29937');
INSERT INTO public.who_global_data_import VALUES (11354, '2020-06-04', 'BR', 'Brazil', 'AMRO', '28936', '555383', '1262', '31199');
INSERT INTO public.who_global_data_import VALUES (11355, '2020-06-05', 'BR', 'Brazil', 'AMRO', '28633', '584016', '1349', '32548');
INSERT INTO public.who_global_data_import VALUES (11356, '2020-06-06', 'BR', 'Brazil', 'AMRO', '30925', '614941', '1473', '34021');
INSERT INTO public.who_global_data_import VALUES (11357, '2020-06-07', 'BR', 'Brazil', 'AMRO', '30830', '645771', '1005', '35026');
INSERT INTO public.who_global_data_import VALUES (11358, '2020-06-08', 'BR', 'Brazil', 'AMRO', '27075', '672846', '904', '35930');
INSERT INTO public.who_global_data_import VALUES (11359, '2020-06-09', 'BR', 'Brazil', 'AMRO', '18912', '691758', '525', '36455');
INSERT INTO public.who_global_data_import VALUES (11360, '2020-06-10', 'BR', 'Brazil', 'AMRO', '15654', '707412', '679', '37134');
INSERT INTO public.who_global_data_import VALUES (11361, '2020-06-11', 'BR', 'Brazil', 'AMRO', '32091', '739503', '1272', '38406');
INSERT INTO public.who_global_data_import VALUES (11362, '2020-06-12', 'BR', 'Brazil', 'AMRO', '32913', '772416', '1274', '39680');
INSERT INTO public.who_global_data_import VALUES (11363, '2020-06-13', 'BR', 'Brazil', 'AMRO', '30412', '802828', '1239', '40919');
INSERT INTO public.who_global_data_import VALUES (11364, '2020-06-14', 'BR', 'Brazil', 'AMRO', '25982', '828810', '909', '41828');
INSERT INTO public.who_global_data_import VALUES (11365, '2020-06-15', 'BR', 'Brazil', 'AMRO', '21704', '850514', '892', '42720');
INSERT INTO public.who_global_data_import VALUES (11366, '2020-06-16', 'BR', 'Brazil', 'AMRO', '17110', '867624', '612', '43332');
INSERT INTO public.who_global_data_import VALUES (11367, '2020-06-17', 'BR', 'Brazil', 'AMRO', '20647', '888271', '627', '43959');
INSERT INTO public.who_global_data_import VALUES (11368, '2020-06-18', 'BR', 'Brazil', 'AMRO', '34918', '923189', '1282', '45241');
INSERT INTO public.who_global_data_import VALUES (11369, '2020-06-19', 'BR', 'Brazil', 'AMRO', '32188', '955377', '1269', '46510');
INSERT INTO public.who_global_data_import VALUES (11370, '2020-06-20', 'BR', 'Brazil', 'AMRO', '22765', '978142', '1238', '47748');
INSERT INTO public.who_global_data_import VALUES (11371, '2020-06-21', 'BR', 'Brazil', 'AMRO', '54771', '1032913', '1206', '48954');
INSERT INTO public.who_global_data_import VALUES (11372, '2020-06-22', 'BR', 'Brazil', 'AMRO', '34666', '1067579', '1022', '49976');
INSERT INTO public.who_global_data_import VALUES (11373, '2020-06-23', 'BR', 'Brazil', 'AMRO', '17459', '1085038', '641', '50617');
INSERT INTO public.who_global_data_import VALUES (11374, '2020-06-24', 'BR', 'Brazil', 'AMRO', '21432', '1106470', '654', '51271');
INSERT INTO public.who_global_data_import VALUES (11375, '2020-06-25', 'BR', 'Brazil', 'AMRO', '39436', '1145906', '1374', '52645');
INSERT INTO public.who_global_data_import VALUES (11376, '2020-06-26', 'BR', 'Brazil', 'AMRO', '42725', '1188631', '1185', '53830');
INSERT INTO public.who_global_data_import VALUES (11377, '2020-06-27', 'BR', 'Brazil', 'AMRO', '39483', '1228114', '1141', '54971');
INSERT INTO public.who_global_data_import VALUES (11378, '2020-06-28', 'BR', 'Brazil', 'AMRO', '46860', '1274974', '990', '55961');
INSERT INTO public.who_global_data_import VALUES (11379, '2020-06-29', 'BR', 'Brazil', 'AMRO', '38693', '1313667', '1109', '57070');
INSERT INTO public.who_global_data_import VALUES (11380, '2020-06-30', 'BR', 'Brazil', 'AMRO', '30476', '1344143', '552', '57622');
INSERT INTO public.who_global_data_import VALUES (11381, '2020-07-01', 'BR', 'Brazil', 'AMRO', '24052', '1368195', '692', '58314');
INSERT INTO public.who_global_data_import VALUES (11382, '2020-07-02', 'BR', 'Brazil', 'AMRO', '33846', '1402041', '1280', '59594');
INSERT INTO public.who_global_data_import VALUES (11383, '2020-07-03', 'BR', 'Brazil', 'AMRO', '46712', '1448753', '1038', '60632');
INSERT INTO public.who_global_data_import VALUES (11384, '2020-07-04', 'BR', 'Brazil', 'AMRO', '48105', '1496858', '1252', '61884');
INSERT INTO public.who_global_data_import VALUES (11385, '2020-07-05', 'BR', 'Brazil', 'AMRO', '42223', '1539081', '1290', '63174');
INSERT INTO public.who_global_data_import VALUES (11386, '2020-07-06', 'BR', 'Brazil', 'AMRO', '37923', '1577004', '1091', '64265');
INSERT INTO public.who_global_data_import VALUES (11387, '2020-07-07', 'BR', 'Brazil', 'AMRO', '26051', '1603055', '602', '64867');
INSERT INTO public.who_global_data_import VALUES (11388, '2020-07-08', 'BR', 'Brazil', 'AMRO', '20229', '1623284', '620', '65487');
INSERT INTO public.who_global_data_import VALUES (11389, '2020-07-09', 'BR', 'Brazil', 'AMRO', '45305', '1668589', '1254', '66741');
INSERT INTO public.who_global_data_import VALUES (11390, '2020-07-10', 'BR', 'Brazil', 'AMRO', '44571', '1713160', '1223', '67964');
INSERT INTO public.who_global_data_import VALUES (11391, '2020-07-11', 'BR', 'Brazil', 'AMRO', '42619', '1755779', '1220', '69184');
INSERT INTO public.who_global_data_import VALUES (11392, '2020-07-12', 'BR', 'Brazil', 'AMRO', '45048', '1800827', '1214', '70398');
INSERT INTO public.who_global_data_import VALUES (11393, '2020-07-13', 'BR', 'Brazil', 'AMRO', '39023', '1839850', '1071', '71469');
INSERT INTO public.who_global_data_import VALUES (11394, '2020-07-14', 'BR', 'Brazil', 'AMRO', '24831', '1864681', '631', '72100');
INSERT INTO public.who_global_data_import VALUES (11395, '2020-07-15', 'BR', 'Brazil', 'AMRO', '20286', '1884967', '733', '72833');
INSERT INTO public.who_global_data_import VALUES (11396, '2020-07-16', 'BR', 'Brazil', 'AMRO', '41857', '1926824', '1300', '74133');
INSERT INTO public.who_global_data_import VALUES (11397, '2020-07-17', 'BR', 'Brazil', 'AMRO', '39924', '1966748', '1233', '75366');
INSERT INTO public.who_global_data_import VALUES (11398, '2020-07-18', 'BR', 'Brazil', 'AMRO', '45403', '2012151', '1322', '76688');
INSERT INTO public.who_global_data_import VALUES (11399, '2020-07-19', 'BR', 'Brazil', 'AMRO', '34177', '2046328', '1163', '77851');
INSERT INTO public.who_global_data_import VALUES (11400, '2020-07-20', 'BR', 'Brazil', 'AMRO', '28532', '2074860', '921', '78772');
INSERT INTO public.who_global_data_import VALUES (11401, '2020-07-21', 'BR', 'Brazil', 'AMRO', '23529', '2098389', '716', '79488');
INSERT INTO public.who_global_data_import VALUES (11402, '2020-07-22', 'BR', 'Brazil', 'AMRO', '20257', '2118646', '632', '80120');
INSERT INTO public.who_global_data_import VALUES (11403, '2020-07-23', 'BR', 'Brazil', 'AMRO', '41008', '2159654', '1367', '81487');
INSERT INTO public.who_global_data_import VALUES (11404, '2020-07-24', 'BR', 'Brazil', 'AMRO', '67860', '2227514', '1284', '82771');
INSERT INTO public.who_global_data_import VALUES (11405, '2020-07-25', 'BR', 'Brazil', 'AMRO', '59961', '2287475', '1311', '84082');
INSERT INTO public.who_global_data_import VALUES (11406, '2020-07-26', 'BR', 'Brazil', 'AMRO', '55891', '2343366', '1156', '85238');
INSERT INTO public.who_global_data_import VALUES (11407, '2020-07-27', 'BR', 'Brazil', 'AMRO', '51147', '2394513', '1211', '86449');
INSERT INTO public.who_global_data_import VALUES (11408, '2020-07-28', 'BR', 'Brazil', 'AMRO', '24578', '2419091', '555', '87004');
INSERT INTO public.who_global_data_import VALUES (11409, '2020-07-29', 'BR', 'Brazil', 'AMRO', '23284', '2442375', '614', '87618');
INSERT INTO public.who_global_data_import VALUES (11410, '2020-07-30', 'BR', 'Brazil', 'AMRO', '40816', '2483191', '921', '88539');
INSERT INTO public.who_global_data_import VALUES (11411, '2020-07-31', 'BR', 'Brazil', 'AMRO', '69074', '2552265', '1595', '90134');
INSERT INTO public.who_global_data_import VALUES (11412, '2020-08-01', 'BR', 'Brazil', 'AMRO', '57837', '2610102', '1129', '91263');
INSERT INTO public.who_global_data_import VALUES (11413, '2020-08-02', 'BR', 'Brazil', 'AMRO', '52383', '2662485', '1212', '92475');
INSERT INTO public.who_global_data_import VALUES (11414, '2020-08-03', 'BR', 'Brazil', 'AMRO', '45392', '2707877', '1088', '93563');
INSERT INTO public.who_global_data_import VALUES (11415, '2020-08-04', 'BR', 'Brazil', 'AMRO', '25800', '2733677', '541', '94104');
INSERT INTO public.who_global_data_import VALUES (11416, '2020-08-05', 'BR', 'Brazil', 'AMRO', '16641', '2750318', '561', '94665');
INSERT INTO public.who_global_data_import VALUES (11417, '2020-08-06', 'BR', 'Brazil', 'AMRO', '51603', '2801921', '1154', '95819');
INSERT INTO public.who_global_data_import VALUES (11418, '2020-08-07', 'BR', 'Brazil', 'AMRO', '57152', '2859073', '1437', '97256');
INSERT INTO public.who_global_data_import VALUES (11419, '2020-08-08', 'BR', 'Brazil', 'AMRO', '53139', '2912212', '1237', '98493');
INSERT INTO public.who_global_data_import VALUES (11420, '2020-08-09', 'BR', 'Brazil', 'AMRO', '50230', '2962442', '1079', '99572');
INSERT INTO public.who_global_data_import VALUES (11421, '2020-08-10', 'BR', 'Brazil', 'AMRO', '49970', '3012412', '905', '100477');
INSERT INTO public.who_global_data_import VALUES (11422, '2020-08-11', 'BR', 'Brazil', 'AMRO', '23010', '3035422', '572', '101049');
INSERT INTO public.who_global_data_import VALUES (11423, '2020-08-12', 'BR', 'Brazil', 'AMRO', '22048', '3057470', '703', '101752');
INSERT INTO public.who_global_data_import VALUES (11424, '2020-08-13', 'BR', 'Brazil', 'AMRO', '52160', '3109630', '1274', '103026');
INSERT INTO public.who_global_data_import VALUES (11425, '2020-08-14', 'BR', 'Brazil', 'AMRO', '55155', '3164785', '1175', '104201');
INSERT INTO public.who_global_data_import VALUES (11426, '2020-08-15', 'BR', 'Brazil', 'AMRO', '60091', '3224876', '1262', '105463');
INSERT INTO public.who_global_data_import VALUES (11427, '2020-08-16', 'BR', 'Brazil', 'AMRO', '50644', '3275520', '1060', '106523');
INSERT INTO public.who_global_data_import VALUES (11428, '2020-08-17', 'BR', 'Brazil', 'AMRO', '41576', '3317096', '709', '107232');
INSERT INTO public.who_global_data_import VALUES (11429, '2020-08-18', 'BR', 'Brazil', 'AMRO', '23101', '3340197', '620', '107852');
INSERT INTO public.who_global_data_import VALUES (11430, '2020-08-19', 'BR', 'Brazil', 'AMRO', '19373', '3359570', '684', '108536');
INSERT INTO public.who_global_data_import VALUES (11431, '2020-08-20', 'BR', 'Brazil', 'AMRO', '47784', '3407354', '1352', '109888');
INSERT INTO public.who_global_data_import VALUES (11432, '2020-08-21', 'BR', 'Brazil', 'AMRO', '49298', '3456652', '1212', '111100');
INSERT INTO public.who_global_data_import VALUES (11433, '2020-08-22', 'BR', 'Brazil', 'AMRO', '45323', '3501975', '1204', '112304');
INSERT INTO public.who_global_data_import VALUES (11434, '2020-08-23', 'BR', 'Brazil', 'AMRO', '30355', '3532330', '1054', '113358');
INSERT INTO public.who_global_data_import VALUES (11435, '2020-08-24', 'BR', 'Brazil', 'AMRO', '50032', '3582362', '892', '114250');
INSERT INTO public.who_global_data_import VALUES (11436, '2020-08-25', 'BR', 'Brazil', 'AMRO', '23421', '3605783', '494', '114744');
INSERT INTO public.who_global_data_import VALUES (11437, '2020-08-26', 'BR', 'Brazil', 'AMRO', '17078', '3622861', '565', '115309');
INSERT INTO public.who_global_data_import VALUES (11438, '2020-08-27', 'BR', 'Brazil', 'AMRO', '47134', '3669995', '1271', '116580');
INSERT INTO public.who_global_data_import VALUES (11439, '2020-08-28', 'BR', 'Brazil', 'AMRO', '47161', '3717156', '1085', '117665');
INSERT INTO public.who_global_data_import VALUES (11440, '2020-08-29', 'BR', 'Brazil', 'AMRO', '44235', '3761391', '984', '118649');
INSERT INTO public.who_global_data_import VALUES (11441, '2020-08-30', 'BR', 'Brazil', 'AMRO', '43412', '3804803', '855', '119504');
INSERT INTO public.who_global_data_import VALUES (11442, '2020-08-31', 'BR', 'Brazil', 'AMRO', '41350', '3846153', '958', '120462');
INSERT INTO public.who_global_data_import VALUES (11443, '2020-09-01', 'BR', 'Brazil', 'AMRO', '16158', '3862311', '366', '120828');
INSERT INTO public.who_global_data_import VALUES (11444, '2020-09-02', 'BR', 'Brazil', 'AMRO', '45961', '3908272', '553', '121381');
INSERT INTO public.who_global_data_import VALUES (11445, '2020-09-03', 'BR', 'Brazil', 'AMRO', '42659', '3950931', '1215', '122596');
INSERT INTO public.who_global_data_import VALUES (11446, '2020-09-04', 'BR', 'Brazil', 'AMRO', '46934', '3997865', '1184', '123780');
INSERT INTO public.who_global_data_import VALUES (11447, '2020-09-05', 'BR', 'Brazil', 'AMRO', '43773', '4041638', '834', '124614');
INSERT INTO public.who_global_data_import VALUES (11448, '2020-09-06', 'BR', 'Brazil', 'AMRO', '51194', '4092832', '907', '125521');
INSERT INTO public.who_global_data_import VALUES (11449, '2020-09-07', 'BR', 'Brazil', 'AMRO', '30168', '4123000', '682', '126203');
INSERT INTO public.who_global_data_import VALUES (11450, '2020-09-08', 'BR', 'Brazil', 'AMRO', '14521', '4137521', '447', '126650');
INSERT INTO public.who_global_data_import VALUES (11451, '2020-09-09', 'BR', 'Brazil', 'AMRO', '10273', '4147794', '310', '126960');
INSERT INTO public.who_global_data_import VALUES (11452, '2020-09-10', 'BR', 'Brazil', 'AMRO', '14279', '4162073', '504', '127464');
INSERT INTO public.who_global_data_import VALUES (11453, '2020-09-11', 'BR', 'Brazil', 'AMRO', '35816', '4197889', '1075', '128539');
INSERT INTO public.who_global_data_import VALUES (11454, '2020-09-12', 'BR', 'Brazil', 'AMRO', '40557', '4238446', '983', '129522');
INSERT INTO public.who_global_data_import VALUES (11455, '2020-09-13', 'BR', 'Brazil', 'AMRO', '43718', '4282164', '874', '130396');
INSERT INTO public.who_global_data_import VALUES (11456, '2020-09-14', 'BR', 'Brazil', 'AMRO', '33523', '4315687', '814', '131210');
INSERT INTO public.who_global_data_import VALUES (11457, '2020-09-15', 'BR', 'Brazil', 'AMRO', '14768', '4330455', '415', '131625');
INSERT INTO public.who_global_data_import VALUES (11458, '2020-09-16', 'BR', 'Brazil', 'AMRO', '15155', '4345610', '381', '132006');
INSERT INTO public.who_global_data_import VALUES (11459, '2020-09-17', 'BR', 'Brazil', 'AMRO', '36653', '4382263', '1113', '133119');
INSERT INTO public.who_global_data_import VALUES (11460, '2020-09-18', 'BR', 'Brazil', 'AMRO', '36820', '4419083', '987', '134106');
INSERT INTO public.who_global_data_import VALUES (11461, '2020-09-19', 'BR', 'Brazil', 'AMRO', '36303', '4455386', '829', '134935');
INSERT INTO public.who_global_data_import VALUES (11462, '2020-09-20', 'BR', 'Brazil', 'AMRO', '39797', '4495183', '858', '135793');
INSERT INTO public.who_global_data_import VALUES (11463, '2020-09-21', 'BR', 'Brazil', 'AMRO', '33057', '4528240', '739', '136532');
INSERT INTO public.who_global_data_import VALUES (11464, '2020-09-22', 'BR', 'Brazil', 'AMRO', '16389', '4544629', '363', '136895');
INSERT INTO public.who_global_data_import VALUES (11465, '2020-09-23', 'BR', 'Brazil', 'AMRO', '13439', '4558068', '377', '137272');
INSERT INTO public.who_global_data_import VALUES (11466, '2020-09-24', 'BR', 'Brazil', 'AMRO', '33536', '4591604', '836', '138108');
INSERT INTO public.who_global_data_import VALUES (11467, '2020-09-25', 'BR', 'Brazil', 'AMRO', '33281', '4624885', '869', '138977');
INSERT INTO public.who_global_data_import VALUES (11468, '2020-09-26', 'BR', 'Brazil', 'AMRO', '32817', '4657702', '831', '139808');
INSERT INTO public.who_global_data_import VALUES (11469, '2020-09-27', 'BR', 'Brazil', 'AMRO', '31911', '4689613', '729', '140537');
INSERT INTO public.who_global_data_import VALUES (11470, '2020-09-28', 'BR', 'Brazil', 'AMRO', '28378', '4717991', '869', '141406');
INSERT INTO public.who_global_data_import VALUES (11471, '2020-09-29', 'BR', 'Brazil', 'AMRO', '14318', '4732309', '335', '141741');
INSERT INTO public.who_global_data_import VALUES (11472, '2020-09-30', 'BR', 'Brazil', 'AMRO', '13155', '4745464', '317', '142058');
INSERT INTO public.who_global_data_import VALUES (11473, '2020-10-01', 'BR', 'Brazil', 'AMRO', '32058', '4777522', '863', '142921');
INSERT INTO public.who_global_data_import VALUES (11474, '2020-10-02', 'BR', 'Brazil', 'AMRO', '33413', '4810935', '1031', '143952');
INSERT INTO public.who_global_data_import VALUES (11475, '2020-10-03', 'BR', 'Brazil', 'AMRO', '36157', '4847092', '728', '144680');
INSERT INTO public.who_global_data_import VALUES (11476, '2020-10-04', 'BR', 'Brazil', 'AMRO', '33431', '4880523', '708', '145388');
INSERT INTO public.who_global_data_import VALUES (11477, '2020-10-05', 'BR', 'Brazil', 'AMRO', '26310', '4906833', '599', '145987');
INSERT INTO public.who_global_data_import VALUES (11478, '2020-10-06', 'BR', 'Brazil', 'AMRO', '8456', '4915289', '365', '146352');
INSERT INTO public.who_global_data_import VALUES (11479, '2020-10-07', 'BR', 'Brazil', 'AMRO', '11946', '4927235', '323', '146675');
INSERT INTO public.who_global_data_import VALUES (11480, '2020-10-08', 'BR', 'Brazil', 'AMRO', '41906', '4969141', '819', '147494');
INSERT INTO public.who_global_data_import VALUES (11481, '2020-10-09', 'BR', 'Brazil', 'AMRO', '31553', '5000694', '734', '148228');
INSERT INTO public.who_global_data_import VALUES (11482, '2020-10-10', 'BR', 'Brazil', 'AMRO', '27750', '5028444', '729', '148957');
INSERT INTO public.who_global_data_import VALUES (11483, '2020-10-11', 'BR', 'Brazil', 'AMRO', '27444', '5055888', '682', '149639');
INSERT INTO public.who_global_data_import VALUES (11484, '2020-10-12', 'BR', 'Brazil', 'AMRO', '26749', '5082637', '559', '150198');
INSERT INTO public.who_global_data_import VALUES (11485, '2020-10-13', 'BR', 'Brazil', 'AMRO', '12342', '5094979', '290', '150488');
INSERT INTO public.who_global_data_import VALUES (11486, '2020-10-14', 'BR', 'Brazil', 'AMRO', '8429', '5103408', '201', '150689');
INSERT INTO public.who_global_data_import VALUES (11487, '2020-10-15', 'BR', 'Brazil', 'AMRO', '10220', '5113628', '309', '150998');
INSERT INTO public.who_global_data_import VALUES (11488, '2020-10-16', 'BR', 'Brazil', 'AMRO', '27235', '5140863', '749', '151747');
INSERT INTO public.who_global_data_import VALUES (11489, '2020-10-17', 'BR', 'Brazil', 'AMRO', '28523', '5169386', '713', '152460');
INSERT INTO public.who_global_data_import VALUES (11490, '2020-10-18', 'BR', 'Brazil', 'AMRO', '30914', '5200300', '754', '153214');
INSERT INTO public.who_global_data_import VALUES (11491, '2020-10-19', 'BR', 'Brazil', 'AMRO', '24062', '5224362', '461', '153675');
INSERT INTO public.who_global_data_import VALUES (11492, '2020-10-20', 'BR', 'Brazil', 'AMRO', '10982', '5235344', '230', '153905');
INSERT INTO public.who_global_data_import VALUES (11493, '2020-10-21', 'BR', 'Brazil', 'AMRO', '15383', '5250727', '271', '154176');
INSERT INTO public.who_global_data_import VALUES (11494, '2020-10-22', 'BR', 'Brazil', 'AMRO', '23227', '5273954', '661', '154837');
INSERT INTO public.who_global_data_import VALUES (11495, '2020-10-23', 'BR', 'Brazil', 'AMRO', '24818', '5298772', '566', '155403');
INSERT INTO public.who_global_data_import VALUES (11496, '2020-10-24', 'BR', 'Brazil', 'AMRO', '24858', '5323630', '497', '155900');
INSERT INTO public.who_global_data_import VALUES (11497, '2020-10-25', 'BR', 'Brazil', 'AMRO', '30026', '5353656', '571', '156471');
INSERT INTO public.who_global_data_import VALUES (11498, '2020-10-26', 'BR', 'Brazil', 'AMRO', '26979', '5380635', '432', '156903');
INSERT INTO public.who_global_data_import VALUES (11499, '2020-10-27', 'BR', 'Brazil', 'AMRO', '13493', '5394128', '231', '157134');
INSERT INTO public.who_global_data_import VALUES (11500, '2020-10-28', 'BR', 'Brazil', 'AMRO', '15726', '5409854', '263', '157397');
INSERT INTO public.who_global_data_import VALUES (11501, '2020-10-29', 'BR', 'Brazil', 'AMRO', '29787', '5439641', '549', '157946');
INSERT INTO public.who_global_data_import VALUES (11502, '2020-10-30', 'BR', 'Brazil', 'AMRO', '28629', '5468270', '510', '158456');
INSERT INTO public.who_global_data_import VALUES (11503, '2020-10-31', 'BR', 'Brazil', 'AMRO', '26106', '5494376', '513', '158969');
INSERT INTO public.who_global_data_import VALUES (11504, '2020-11-01', 'BR', 'Brazil', 'AMRO', '22282', '5516658', '508', '159477');
INSERT INTO public.who_global_data_import VALUES (11505, '2020-11-02', 'BR', 'Brazil', 'AMRO', '18947', '5535605', '407', '159884');
INSERT INTO public.who_global_data_import VALUES (11506, '2020-11-03', 'BR', 'Brazil', 'AMRO', '10100', '5545705', '190', '160074');
INSERT INTO public.who_global_data_import VALUES (11507, '2020-11-04', 'BR', 'Brazil', 'AMRO', '8501', '5554206', '179', '160253');
INSERT INTO public.who_global_data_import VALUES (11508, '2020-11-05', 'BR', 'Brazil', 'AMRO', '11843', '5566049', '243', '160496');
INSERT INTO public.who_global_data_import VALUES (11509, '2020-11-06', 'BR', 'Brazil', 'AMRO', '23976', '5590025', '610', '161106');
INSERT INTO public.who_global_data_import VALUES (11510, '2020-11-07', 'BR', 'Brazil', 'AMRO', '22294', '5612319', '630', '161736');
INSERT INTO public.who_global_data_import VALUES (11511, '2020-11-08', 'BR', 'Brazil', 'AMRO', '18862', '5631181', '279', '162015');
INSERT INTO public.who_global_data_import VALUES (11512, '2020-11-09', 'BR', 'Brazil', 'AMRO', '22380', '5653561', '254', '162269');
INSERT INTO public.who_global_data_import VALUES (11513, '2020-11-10', 'BR', 'Brazil', 'AMRO', '10554', '5664115', '128', '162397');
INSERT INTO public.who_global_data_import VALUES (11514, '2020-11-11', 'BR', 'Brazil', 'AMRO', '10917', '5675032', '231', '162628');
INSERT INTO public.who_global_data_import VALUES (11515, '2020-11-12', 'BR', 'Brazil', 'AMRO', '25012', '5700044', '201', '162829');
INSERT INTO public.who_global_data_import VALUES (11516, '2020-11-13', 'BR', 'Brazil', 'AMRO', '48331', '5748375', '544', '163373');
INSERT INTO public.who_global_data_import VALUES (11517, '2020-11-14', 'BR', 'Brazil', 'AMRO', '33207', '5781582', '908', '164281');
INSERT INTO public.who_global_data_import VALUES (11518, '2020-11-15', 'BR', 'Brazil', 'AMRO', '29070', '5810652', '456', '164737');
INSERT INTO public.who_global_data_import VALUES (11519, '2020-11-16', 'BR', 'Brazil', 'AMRO', '38307', '5848959', '921', '165658');
INSERT INTO public.who_global_data_import VALUES (11520, '2020-11-17', 'BR', 'Brazil', 'AMRO', '14134', '5863093', '140', '165798');
INSERT INTO public.who_global_data_import VALUES (11521, '2020-11-18', 'BR', 'Brazil', 'AMRO', '13371', '5876464', '216', '166014');
INSERT INTO public.who_global_data_import VALUES (11522, '2020-11-19', 'BR', 'Brazil', 'AMRO', '35294', '5911758', '685', '166699');
INSERT INTO public.who_global_data_import VALUES (11523, '2020-11-20', 'BR', 'Brazil', 'AMRO', '34091', '5945849', '756', '167455');
INSERT INTO public.who_global_data_import VALUES (11524, '2020-11-21', 'BR', 'Brazil', 'AMRO', '35918', '5981767', '606', '168061');
INSERT INTO public.who_global_data_import VALUES (11525, '2020-11-22', 'BR', 'Brazil', 'AMRO', '38397', '6020164', '552', '168613');
INSERT INTO public.who_global_data_import VALUES (11526, '2020-11-23', 'BR', 'Brazil', 'AMRO', '32622', '6052786', '376', '168989');
INSERT INTO public.who_global_data_import VALUES (11527, '2020-11-24', 'BR', 'Brazil', 'AMRO', '18615', '6071401', '194', '169183');
INSERT INTO public.who_global_data_import VALUES (11528, '2020-11-25', 'BR', 'Brazil', 'AMRO', '16207', '6087608', '302', '169485');
INSERT INTO public.who_global_data_import VALUES (11529, '2020-11-26', 'BR', 'Brazil', 'AMRO', '31100', '6118708', '630', '170115');
INSERT INTO public.who_global_data_import VALUES (11530, '2020-11-27', 'BR', 'Brazil', 'AMRO', '47898', '6166606', '654', '170769');
INSERT INTO public.who_global_data_import VALUES (11531, '2020-11-28', 'BR', 'Brazil', 'AMRO', '37614', '6204220', '691', '171460');
INSERT INTO public.who_global_data_import VALUES (11532, '2020-11-29', 'BR', 'Brazil', 'AMRO', '34130', '6238350', '514', '171974');
INSERT INTO public.who_global_data_import VALUES (11533, '2020-11-30', 'BR', 'Brazil', 'AMRO', '51922', '6290272', '587', '172561');
INSERT INTO public.who_global_data_import VALUES (11534, '2020-12-01', 'BR', 'Brazil', 'AMRO', '24468', '6314740', '272', '172833');
INSERT INTO public.who_global_data_import VALUES (11535, '2020-12-02', 'BR', 'Brazil', 'AMRO', '21138', '6335878', '287', '173120');
INSERT INTO public.who_global_data_import VALUES (11536, '2020-12-03', 'BR', 'Brazil', 'AMRO', '50909', '6386787', '697', '173817');
INSERT INTO public.who_global_data_import VALUES (11537, '2020-12-04', 'BR', 'Brazil', 'AMRO', '49863', '6436650', '698', '174515');
INSERT INTO public.who_global_data_import VALUES (11538, '2020-12-05', 'BR', 'Brazil', 'AMRO', '50434', '6487084', '755', '175270');
INSERT INTO public.who_global_data_import VALUES (11539, '2020-12-06', 'BR', 'Brazil', 'AMRO', '46884', '6533968', '694', '175964');
INSERT INTO public.who_global_data_import VALUES (11540, '2020-12-07', 'BR', 'Brazil', 'AMRO', '43209', '6577177', '664', '176628');
INSERT INTO public.who_global_data_import VALUES (11541, '2020-12-08', 'BR', 'Brazil', 'AMRO', '26363', '6603540', '313', '176941');
INSERT INTO public.who_global_data_import VALUES (11542, '2020-12-09', 'BR', 'Brazil', 'AMRO', '20371', '6623911', '376', '177317');
INSERT INTO public.who_global_data_import VALUES (11543, '2020-12-10', 'BR', 'Brazil', 'AMRO', '51088', '6674999', '842', '178159');
INSERT INTO public.who_global_data_import VALUES (11544, '2020-12-11', 'BR', 'Brazil', 'AMRO', '53453', '6728452', '836', '178995');
INSERT INTO public.who_global_data_import VALUES (11545, '2020-12-12', 'BR', 'Brazil', 'AMRO', '53347', '6781799', '770', '179765');
INSERT INTO public.who_global_data_import VALUES (11546, '2020-12-13', 'BR', 'Brazil', 'AMRO', '54428', '6836227', '672', '180437');
INSERT INTO public.who_global_data_import VALUES (11547, '2020-12-14', 'BR', 'Brazil', 'AMRO', '43900', '6880127', '686', '181123');
INSERT INTO public.who_global_data_import VALUES (11548, '2020-12-15', 'BR', 'Brazil', 'AMRO', '21825', '6901952', '279', '181402');
INSERT INTO public.who_global_data_import VALUES (11549, '2020-12-16', 'BR', 'Brazil', 'AMRO', '25193', '6927145', '433', '181835');
INSERT INTO public.who_global_data_import VALUES (11550, '2020-12-17', 'BR', 'Brazil', 'AMRO', '42889', '6970034', '964', '182799');
INSERT INTO public.who_global_data_import VALUES (11551, '2020-12-18', 'BR', 'Brazil', 'AMRO', '70574', '7040608', '936', '183735');
INSERT INTO public.who_global_data_import VALUES (11552, '2020-12-19', 'BR', 'Brazil', 'AMRO', '69826', '7110434', '1092', '184827');
INSERT INTO public.who_global_data_import VALUES (11553, '2020-12-20', 'BR', 'Brazil', 'AMRO', '52544', '7162978', '823', '185650');
INSERT INTO public.who_global_data_import VALUES (11554, '2020-12-21', 'BR', 'Brazil', 'AMRO', '50177', '7213155', '706', '186356');
INSERT INTO public.who_global_data_import VALUES (11555, '2020-12-22', 'BR', 'Brazil', 'AMRO', '25445', '7238600', '408', '186764');
INSERT INTO public.who_global_data_import VALUES (11556, '2020-12-23', 'BR', 'Brazil', 'AMRO', '25019', '7263619', '527', '187291');
INSERT INTO public.who_global_data_import VALUES (11557, '2020-12-24', 'BR', 'Brazil', 'AMRO', '55202', '7318821', '968', '188259');
INSERT INTO public.who_global_data_import VALUES (11558, '2020-12-25', 'BR', 'Brazil', 'AMRO', '46696', '7365517', '961', '189220');
INSERT INTO public.who_global_data_import VALUES (11559, '2020-12-26', 'BR', 'Brazil', 'AMRO', '60076', '7425593', '786', '190006');
INSERT INTO public.who_global_data_import VALUES (11560, '2020-12-27', 'BR', 'Brazil', 'AMRO', '22967', '7448560', '482', '190488');
INSERT INTO public.who_global_data_import VALUES (11561, '2020-12-28', 'BR', 'Brazil', 'AMRO', '17246', '7465806', '307', '190795');
INSERT INTO public.who_global_data_import VALUES (11562, '2020-12-29', 'BR', 'Brazil', 'AMRO', '18479', '7484285', '344', '191139');
INSERT INTO public.who_global_data_import VALUES (11563, '2020-12-30', 'BR', 'Brazil', 'AMRO', '20548', '7504833', '431', '191570');
INSERT INTO public.who_global_data_import VALUES (11564, '2020-12-31', 'BR', 'Brazil', 'AMRO', '58718', '7563551', '1111', '192681');
INSERT INTO public.who_global_data_import VALUES (11565, '2021-01-01', 'BR', 'Brazil', 'AMRO', '55649', '7619200', '1194', '193875');
INSERT INTO public.who_global_data_import VALUES (11566, '2021-01-02', 'BR', 'Brazil', 'AMRO', '56773', '7675973', '1074', '194949');
INSERT INTO public.who_global_data_import VALUES (11567, '2021-01-03', 'BR', 'Brazil', 'AMRO', '24605', '7700578', '462', '195411');
INSERT INTO public.who_global_data_import VALUES (11568, '2021-01-04', 'BR', 'Brazil', 'AMRO', '15827', '7716405', '314', '195725');
INSERT INTO public.who_global_data_import VALUES (11569, '2021-01-05', 'BR', 'Brazil', 'AMRO', '17341', '7733746', '293', '196018');
INSERT INTO public.who_global_data_import VALUES (11570, '2021-01-06', 'BR', 'Brazil', 'AMRO', '20006', '7753752', '543', '196561');
INSERT INTO public.who_global_data_import VALUES (11571, '2021-01-07', 'BR', 'Brazil', 'AMRO', '56648', '7810400', '1171', '197732');
INSERT INTO public.who_global_data_import VALUES (11572, '2021-01-08', 'BR', 'Brazil', 'AMRO', '63430', '7873830', '1242', '198974');
INSERT INTO public.who_global_data_import VALUES (11573, '2021-01-09', 'BR', 'Brazil', 'AMRO', '87843', '7961673', '1524', '200498');
INSERT INTO public.who_global_data_import VALUES (11574, '2021-01-10', 'BR', 'Brazil', 'AMRO', '52035', '8013708', '962', '201460');
INSERT INTO public.who_global_data_import VALUES (11575, '2021-01-11', 'BR', 'Brazil', 'AMRO', '62290', '8075998', '1171', '202631');
INSERT INTO public.who_global_data_import VALUES (11576, '2021-01-12', 'BR', 'Brazil', 'AMRO', '29792', '8105790', '469', '203100');
INSERT INTO public.who_global_data_import VALUES (11577, '2021-01-13', 'BR', 'Brazil', 'AMRO', '25822', '8131612', '480', '203580');
INSERT INTO public.who_global_data_import VALUES (11578, '2021-01-14', 'BR', 'Brazil', 'AMRO', '64025', '8195637', '1110', '204690');
INSERT INTO public.who_global_data_import VALUES (11579, '2021-01-15', 'BR', 'Brazil', 'AMRO', '60899', '8256536', '1274', '205964');
INSERT INTO public.who_global_data_import VALUES (11580, '2021-01-16', 'BR', 'Brazil', 'AMRO', '67758', '8324294', '1131', '207095');
INSERT INTO public.who_global_data_import VALUES (11581, '2021-01-17', 'BR', 'Brazil', 'AMRO', '69198', '8393492', '1151', '208246');
INSERT INTO public.who_global_data_import VALUES (11582, '2021-01-18', 'BR', 'Brazil', 'AMRO', '61567', '8455059', '1050', '209296');
INSERT INTO public.who_global_data_import VALUES (11583, '2021-01-19', 'BR', 'Brazil', 'AMRO', '33040', '8488099', '551', '209847');
INSERT INTO public.who_global_data_import VALUES (11584, '2021-01-20', 'BR', 'Brazil', 'AMRO', '23671', '8511770', '452', '210299');
INSERT INTO public.who_global_data_import VALUES (11585, '2021-01-21', 'BR', 'Brazil', 'AMRO', '62094', '8573864', '1192', '211491');
INSERT INTO public.who_global_data_import VALUES (11586, '2021-01-22', 'BR', 'Brazil', 'AMRO', '64385', '8638249', '1340', '212831');
INSERT INTO public.who_global_data_import VALUES (11587, '2021-01-23', 'BR', 'Brazil', 'AMRO', '59119', '8697368', '1316', '214147');
INSERT INTO public.who_global_data_import VALUES (11588, '2021-01-24', 'BR', 'Brazil', 'AMRO', '56552', '8753920', '1096', '215243');
INSERT INTO public.who_global_data_import VALUES (11589, '2021-01-25', 'BR', 'Brazil', 'AMRO', '62334', '8816254', '1202', '216445');
INSERT INTO public.who_global_data_import VALUES (11590, '2021-01-26', 'BR', 'Brazil', 'AMRO', '28323', '8844577', '592', '217037');
INSERT INTO public.who_global_data_import VALUES (11591, '2021-01-27', 'BR', 'Brazil', 'AMRO', '26816', '8871393', '627', '217664');
INSERT INTO public.who_global_data_import VALUES (11592, '2021-01-28', 'BR', 'Brazil', 'AMRO', '61963', '8933356', '1214', '218878');
INSERT INTO public.who_global_data_import VALUES (11593, '2021-01-29', 'BR', 'Brazil', 'AMRO', '63520', '8996876', '1283', '220161');
INSERT INTO public.who_global_data_import VALUES (11594, '2021-01-30', 'BR', 'Brazil', 'AMRO', '61811', '9058687', '1386', '221547');
INSERT INTO public.who_global_data_import VALUES (11595, '2021-01-31', 'BR', 'Brazil', 'AMRO', '59826', '9118513', '1119', '222666');
INSERT INTO public.who_global_data_import VALUES (11596, '2021-02-01', 'BR', 'Brazil', 'AMRO', '58462', '9176975', '1279', '223945');
INSERT INTO public.who_global_data_import VALUES (11597, '2021-02-02', 'BR', 'Brazil', 'AMRO', '27756', '9204731', '559', '224504');
INSERT INTO public.who_global_data_import VALUES (11598, '2021-02-03', 'BR', 'Brazil', 'AMRO', '24591', '9229322', '595', '225099');
INSERT INTO public.who_global_data_import VALUES (11599, '2021-02-04', 'BR', 'Brazil', 'AMRO', '54096', '9283418', '1210', '226309');
INSERT INTO public.who_global_data_import VALUES (11600, '2021-02-05', 'BR', 'Brazil', 'AMRO', '56002', '9339420', '1254', '227563');
INSERT INTO public.who_global_data_import VALUES (11601, '2020-01-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11602, '2020-01-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11603, '2020-01-05', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11604, '2020-01-06', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11605, '2020-01-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11606, '2020-01-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11607, '2020-01-09', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11608, '2020-01-10', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11609, '2020-01-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11610, '2020-01-12', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11611, '2020-01-13', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11612, '2020-01-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11613, '2020-01-15', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11614, '2020-01-16', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11615, '2020-01-17', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11616, '2020-01-18', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11617, '2020-01-19', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11618, '2020-01-20', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11619, '2020-01-21', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11620, '2020-01-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11621, '2020-01-23', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11622, '2020-01-24', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11623, '2020-01-25', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11624, '2020-01-26', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11625, '2020-01-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11626, '2020-01-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11627, '2020-01-29', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11628, '2020-01-30', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11629, '2020-01-31', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11630, '2020-02-01', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11631, '2020-02-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11632, '2020-02-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11633, '2020-02-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11634, '2020-02-05', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11635, '2020-02-06', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11636, '2020-02-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11637, '2020-02-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11638, '2020-02-09', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11639, '2020-02-10', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11640, '2020-02-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11641, '2020-02-12', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11642, '2020-02-13', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11643, '2020-02-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11644, '2020-02-15', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11645, '2020-02-16', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11646, '2020-02-17', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11647, '2020-02-18', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11648, '2020-02-19', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11649, '2020-02-20', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11650, '2020-02-21', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11651, '2020-02-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11652, '2020-02-23', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11653, '2020-02-24', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11654, '2020-02-25', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11655, '2020-02-26', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11656, '2020-02-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11657, '2020-02-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11658, '2020-02-29', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11659, '2020-03-01', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11660, '2020-03-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11661, '2020-03-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11662, '2020-03-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11663, '2020-03-05', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11664, '2020-03-06', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11665, '2020-03-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11666, '2020-03-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11667, '2020-03-09', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11668, '2020-03-10', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11669, '2020-03-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11670, '2020-03-12', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11671, '2020-03-13', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11672, '2020-03-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11673, '2020-03-15', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11674, '2020-03-16', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11675, '2020-03-17', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11676, '2020-03-18', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11677, '2020-03-19', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11678, '2020-03-20', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11679, '2020-03-21', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11680, '2020-03-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11681, '2020-03-23', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11682, '2020-03-24', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11683, '2020-03-25', 'VG', 'British Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11684, '2020-03-26', 'VG', 'British Virgin Islands', 'AMRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11685, '2020-03-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11686, '2020-03-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11687, '2020-03-29', 'VG', 'British Virgin Islands', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11688, '2020-03-30', 'VG', 'British Virgin Islands', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11689, '2020-03-31', 'VG', 'British Virgin Islands', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11690, '2020-04-01', 'VG', 'British Virgin Islands', 'AMRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11691, '2020-04-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11692, '2020-04-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11693, '2020-04-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11694, '2020-04-05', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11695, '2020-04-06', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11696, '2020-04-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11697, '2020-04-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11698, '2020-04-09', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11699, '2020-04-10', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11700, '2020-04-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11701, '2020-04-12', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11702, '2020-04-13', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11703, '2020-04-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11704, '2020-04-15', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11705, '2020-04-16', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11706, '2020-04-17', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11707, '2020-04-18', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11708, '2020-04-19', 'VG', 'British Virgin Islands', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (11709, '2020-04-20', 'VG', 'British Virgin Islands', 'AMRO', '1', '4', '1', '1');
INSERT INTO public.who_global_data_import VALUES (11710, '2020-04-21', 'VG', 'British Virgin Islands', 'AMRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11711, '2020-04-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11712, '2020-04-23', 'VG', 'British Virgin Islands', 'AMRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11713, '2020-04-24', 'VG', 'British Virgin Islands', 'AMRO', '1', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11714, '2020-04-25', 'VG', 'British Virgin Islands', 'AMRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11715, '2020-04-26', 'VG', 'British Virgin Islands', 'AMRO', '1', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11716, '2020-04-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11717, '2020-04-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11718, '2020-04-29', 'VG', 'British Virgin Islands', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11719, '2020-04-30', 'VG', 'British Virgin Islands', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11720, '2020-05-01', 'VG', 'British Virgin Islands', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11721, '2020-05-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11722, '2020-05-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11723, '2020-05-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11724, '2020-05-05', 'VG', 'British Virgin Islands', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11725, '2020-05-06', 'VG', 'British Virgin Islands', 'AMRO', '1', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11726, '2020-05-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11727, '2020-05-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11728, '2020-05-09', 'VG', 'British Virgin Islands', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11729, '2020-05-10', 'VG', 'British Virgin Islands', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11730, '2020-05-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11731, '2020-05-12', 'VG', 'British Virgin Islands', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11732, '2020-05-13', 'VG', 'British Virgin Islands', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11733, '2020-05-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11734, '2020-05-15', 'VG', 'British Virgin Islands', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11735, '2020-05-16', 'VG', 'British Virgin Islands', 'AMRO', '1', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11736, '2020-05-17', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11737, '2020-05-18', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11738, '2020-05-19', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11739, '2020-05-20', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11740, '2020-05-21', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11741, '2020-05-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11742, '2020-05-23', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11743, '2020-05-24', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11744, '2020-05-25', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11745, '2020-05-26', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11746, '2020-05-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11747, '2020-05-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11748, '2020-05-29', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11749, '2020-05-30', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11750, '2020-05-31', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11751, '2020-06-01', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11752, '2020-06-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11753, '2020-06-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11754, '2020-06-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11755, '2020-06-05', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11756, '2020-06-06', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11757, '2020-06-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11758, '2020-06-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11759, '2020-06-09', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11760, '2020-06-10', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11761, '2020-06-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11762, '2020-06-12', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11763, '2020-06-13', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11764, '2020-06-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11765, '2020-06-15', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11766, '2020-06-16', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11767, '2020-06-17', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11768, '2020-06-18', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11769, '2020-06-19', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11770, '2020-06-20', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11771, '2020-06-21', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11772, '2020-06-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11773, '2020-06-23', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11774, '2020-06-24', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11775, '2020-06-25', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11776, '2020-06-26', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11777, '2020-06-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11778, '2020-06-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11779, '2020-06-29', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11780, '2020-06-30', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11781, '2020-07-01', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11782, '2020-07-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11783, '2020-07-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11784, '2020-07-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11785, '2020-07-05', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11786, '2020-07-06', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11787, '2020-07-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11788, '2020-07-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11789, '2020-07-09', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11790, '2020-07-10', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11791, '2020-07-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11792, '2020-07-12', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11793, '2020-07-13', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11794, '2020-07-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11795, '2020-07-15', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11796, '2020-07-16', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11797, '2020-07-17', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11798, '2020-07-18', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11799, '2020-07-19', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11800, '2020-07-20', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11801, '2020-07-21', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11802, '2020-07-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11803, '2020-07-23', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11804, '2020-07-24', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11805, '2020-07-25', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11806, '2020-07-26', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11807, '2020-07-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11808, '2020-07-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11809, '2020-07-29', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11810, '2020-07-30', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11811, '2020-07-31', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11812, '2020-08-01', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11813, '2020-08-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11814, '2020-08-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11815, '2020-08-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11816, '2020-08-05', 'VG', 'British Virgin Islands', 'AMRO', '1', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11817, '2020-08-06', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11818, '2020-08-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11819, '2020-08-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11820, '2020-08-09', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11821, '2020-08-10', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11822, '2020-08-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11823, '2020-08-12', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11824, '2020-08-13', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11825, '2020-08-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11826, '2020-08-15', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11827, '2020-08-16', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11828, '2020-08-17', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11829, '2020-08-18', 'VG', 'British Virgin Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11830, '2020-08-19', 'VG', 'British Virgin Islands', 'AMRO', '2', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11831, '2020-08-20', 'VG', 'British Virgin Islands', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11832, '2020-08-21', 'VG', 'British Virgin Islands', 'AMRO', '1', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11833, '2020-08-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11834, '2020-08-23', 'VG', 'British Virgin Islands', 'AMRO', '9', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11835, '2020-08-24', 'VG', 'British Virgin Islands', 'AMRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11836, '2020-08-25', 'VG', 'British Virgin Islands', 'AMRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11837, '2020-08-26', 'VG', 'British Virgin Islands', 'AMRO', '5', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11838, '2020-08-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11839, '2020-08-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11840, '2020-08-29', 'VG', 'British Virgin Islands', 'AMRO', '9', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11841, '2020-08-30', 'VG', 'British Virgin Islands', 'AMRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11842, '2020-08-31', 'VG', 'British Virgin Islands', 'AMRO', '2', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11843, '2020-09-01', 'VG', 'British Virgin Islands', 'AMRO', '10', '47', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11844, '2020-09-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '47', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11845, '2020-09-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '47', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11846, '2020-09-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '47', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11847, '2020-09-05', 'VG', 'British Virgin Islands', 'AMRO', '16', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11848, '2020-09-06', 'VG', 'British Virgin Islands', 'AMRO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11849, '2020-09-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11850, '2020-09-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11851, '2020-09-09', 'VG', 'British Virgin Islands', 'AMRO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11852, '2020-09-10', 'VG', 'British Virgin Islands', 'AMRO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11853, '2020-09-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11854, '2020-09-12', 'VG', 'British Virgin Islands', 'AMRO', '1', '64', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11855, '2020-09-13', 'VG', 'British Virgin Islands', 'AMRO', '2', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11856, '2020-09-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11857, '2020-09-15', 'VG', 'British Virgin Islands', 'AMRO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11858, '2020-09-16', 'VG', 'British Virgin Islands', 'AMRO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11859, '2020-09-17', 'VG', 'British Virgin Islands', 'AMRO', '3', '69', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11860, '2020-09-18', 'VG', 'British Virgin Islands', 'AMRO', '0', '69', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11861, '2020-09-19', 'VG', 'British Virgin Islands', 'AMRO', '0', '69', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11862, '2020-09-20', 'VG', 'British Virgin Islands', 'AMRO', '2', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11863, '2020-09-21', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11864, '2020-09-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11865, '2020-09-23', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11866, '2020-09-24', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11867, '2020-09-25', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11868, '2020-09-26', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11869, '2020-09-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11870, '2020-09-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11871, '2020-09-29', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11872, '2020-09-30', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11873, '2020-10-01', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11874, '2020-10-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11875, '2020-10-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11876, '2020-10-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11877, '2020-10-05', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11878, '2020-10-06', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11879, '2020-10-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11880, '2020-10-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11881, '2020-10-09', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11882, '2020-10-10', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11883, '2020-10-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11884, '2020-10-12', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11885, '2020-10-13', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11886, '2020-10-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11887, '2020-10-15', 'VG', 'British Virgin Islands', 'AMRO', '1', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11888, '2020-10-16', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11889, '2020-10-17', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11890, '2020-10-18', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11891, '2020-10-19', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11892, '2020-10-20', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11893, '2020-10-21', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11894, '2020-10-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11895, '2020-10-23', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11896, '2020-10-24', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11897, '2020-10-25', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11898, '2020-10-26', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11899, '2020-10-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11900, '2020-10-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11901, '2020-10-29', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11902, '2020-10-30', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11903, '2020-10-31', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11904, '2020-11-01', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11905, '2020-11-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11906, '2020-11-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11907, '2020-11-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11908, '2020-11-05', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11909, '2020-11-06', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11910, '2020-11-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11911, '2020-11-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11912, '2020-11-09', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11913, '2020-11-10', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11914, '2020-11-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11915, '2020-11-12', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11916, '2020-11-13', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11917, '2020-11-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11918, '2020-11-15', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11919, '2020-11-16', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11920, '2020-11-17', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11921, '2020-11-18', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11922, '2020-11-19', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11923, '2020-11-20', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11924, '2020-11-21', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11925, '2020-11-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11926, '2020-11-23', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11927, '2020-11-24', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11928, '2020-11-25', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11929, '2020-11-26', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11930, '2020-11-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11931, '2020-11-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11932, '2020-11-29', 'VG', 'British Virgin Islands', 'AMRO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11933, '2020-11-30', 'VG', 'British Virgin Islands', 'AMRO', '1', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11934, '2020-12-01', 'VG', 'British Virgin Islands', 'AMRO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11935, '2020-12-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11936, '2020-12-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11937, '2020-12-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11938, '2020-12-05', 'VG', 'British Virgin Islands', 'AMRO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11939, '2020-12-06', 'VG', 'British Virgin Islands', 'AMRO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11940, '2020-12-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11941, '2020-12-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11942, '2020-12-09', 'VG', 'British Virgin Islands', 'AMRO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11943, '2020-12-10', 'VG', 'British Virgin Islands', 'AMRO', '2', '75', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11944, '2020-12-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '75', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11945, '2020-12-12', 'VG', 'British Virgin Islands', 'AMRO', '1', '76', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11946, '2020-12-13', 'VG', 'British Virgin Islands', 'AMRO', '0', '76', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11947, '2020-12-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '76', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11948, '2020-12-15', 'VG', 'British Virgin Islands', 'AMRO', '0', '76', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11949, '2020-12-16', 'VG', 'British Virgin Islands', 'AMRO', '4', '80', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11950, '2020-12-17', 'VG', 'British Virgin Islands', 'AMRO', '0', '80', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11951, '2020-12-18', 'VG', 'British Virgin Islands', 'AMRO', '3', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11952, '2020-12-19', 'VG', 'British Virgin Islands', 'AMRO', '3', '86', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11953, '2020-12-20', 'VG', 'British Virgin Islands', 'AMRO', '0', '86', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11954, '2020-12-21', 'VG', 'British Virgin Islands', 'AMRO', '0', '86', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11955, '2020-12-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '86', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11956, '2020-12-23', 'VG', 'British Virgin Islands', 'AMRO', '0', '86', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11957, '2020-12-24', 'VG', 'British Virgin Islands', 'AMRO', '0', '86', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11958, '2020-12-25', 'VG', 'British Virgin Islands', 'AMRO', '7', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11959, '2020-12-26', 'VG', 'British Virgin Islands', 'AMRO', '0', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11960, '2020-12-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11961, '2020-12-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11962, '2020-12-29', 'VG', 'British Virgin Islands', 'AMRO', '0', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11963, '2020-12-30', 'VG', 'British Virgin Islands', 'AMRO', '0', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11964, '2020-12-31', 'VG', 'British Virgin Islands', 'AMRO', '0', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11965, '2021-01-01', 'VG', 'British Virgin Islands', 'AMRO', '0', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11966, '2021-01-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11967, '2021-01-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11968, '2021-01-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11969, '2021-01-05', 'VG', 'British Virgin Islands', 'AMRO', '4', '97', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11970, '2021-01-06', 'VG', 'British Virgin Islands', 'AMRO', '10', '107', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11971, '2021-01-07', 'VG', 'British Virgin Islands', 'AMRO', '0', '107', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11972, '2021-01-08', 'VG', 'British Virgin Islands', 'AMRO', '0', '107', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11973, '2021-01-09', 'VG', 'British Virgin Islands', 'AMRO', '7', '114', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11974, '2021-01-10', 'VG', 'British Virgin Islands', 'AMRO', '0', '114', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11975, '2021-01-11', 'VG', 'British Virgin Islands', 'AMRO', '0', '114', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11976, '2021-01-12', 'VG', 'British Virgin Islands', 'AMRO', '0', '114', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11977, '2021-01-13', 'VG', 'British Virgin Islands', 'AMRO', '0', '114', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11978, '2021-01-14', 'VG', 'British Virgin Islands', 'AMRO', '0', '114', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11979, '2021-01-15', 'VG', 'British Virgin Islands', 'AMRO', '0', '114', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11980, '2021-01-16', 'VG', 'British Virgin Islands', 'AMRO', '7', '121', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11981, '2021-01-17', 'VG', 'British Virgin Islands', 'AMRO', '0', '121', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11982, '2021-01-18', 'VG', 'British Virgin Islands', 'AMRO', '0', '121', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11983, '2021-01-19', 'VG', 'British Virgin Islands', 'AMRO', '0', '121', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11984, '2021-01-20', 'VG', 'British Virgin Islands', 'AMRO', '0', '121', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11985, '2021-01-21', 'VG', 'British Virgin Islands', 'AMRO', '0', '121', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11986, '2021-01-22', 'VG', 'British Virgin Islands', 'AMRO', '0', '121', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11987, '2021-01-23', 'VG', 'British Virgin Islands', 'AMRO', '0', '121', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11988, '2021-01-24', 'VG', 'British Virgin Islands', 'AMRO', '16', '137', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11989, '2021-01-25', 'VG', 'British Virgin Islands', 'AMRO', '0', '137', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11990, '2021-01-26', 'VG', 'British Virgin Islands', 'AMRO', '0', '137', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11991, '2021-01-27', 'VG', 'British Virgin Islands', 'AMRO', '0', '137', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11992, '2021-01-28', 'VG', 'British Virgin Islands', 'AMRO', '0', '137', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11993, '2021-01-29', 'VG', 'British Virgin Islands', 'AMRO', '0', '137', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11994, '2021-01-30', 'VG', 'British Virgin Islands', 'AMRO', '4', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11995, '2021-01-31', 'VG', 'British Virgin Islands', 'AMRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11996, '2021-02-01', 'VG', 'British Virgin Islands', 'AMRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11997, '2021-02-02', 'VG', 'British Virgin Islands', 'AMRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11998, '2021-02-03', 'VG', 'British Virgin Islands', 'AMRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (11999, '2021-02-04', 'VG', 'British Virgin Islands', 'AMRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12000, '2021-02-05', 'VG', 'British Virgin Islands', 'AMRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12001, '2020-01-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12002, '2020-01-04', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12003, '2020-01-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12004, '2020-01-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12005, '2020-01-07', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12006, '2020-01-08', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12007, '2020-01-09', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12008, '2020-01-10', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12009, '2020-01-11', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12010, '2020-01-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12011, '2020-01-13', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12012, '2020-01-14', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12013, '2020-01-15', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12014, '2020-01-16', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12015, '2020-01-17', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12016, '2020-01-18', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12017, '2020-01-19', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12018, '2020-01-20', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12019, '2020-01-21', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12020, '2020-01-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12021, '2020-01-23', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12022, '2020-01-24', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12023, '2020-01-25', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12024, '2020-01-26', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12025, '2020-01-27', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12026, '2020-01-28', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12027, '2020-01-29', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12028, '2020-01-30', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12029, '2020-01-31', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12030, '2020-02-01', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12031, '2020-02-02', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12032, '2020-02-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12033, '2020-02-04', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12034, '2020-02-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12035, '2020-02-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12036, '2020-02-07', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12037, '2020-02-08', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12038, '2020-02-09', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12039, '2020-02-10', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12040, '2020-02-11', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12041, '2020-02-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12042, '2020-02-13', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12043, '2020-02-14', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12044, '2020-02-15', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12045, '2020-02-16', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12046, '2020-02-17', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12047, '2020-02-18', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12048, '2020-02-19', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12049, '2020-02-20', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12050, '2020-02-21', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12051, '2020-02-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12052, '2020-02-23', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12053, '2020-02-24', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12054, '2020-02-25', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12055, '2020-02-26', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12056, '2020-02-27', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12057, '2020-02-28', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12058, '2020-02-29', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12059, '2020-03-01', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12060, '2020-03-02', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12061, '2020-03-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12062, '2020-03-04', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12063, '2020-03-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12064, '2020-03-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12065, '2020-03-07', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12066, '2020-03-08', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12067, '2020-03-09', 'BN', 'Brunei Darussalam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12068, '2020-03-10', 'BN', 'Brunei Darussalam', 'WPRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12069, '2020-03-11', 'BN', 'Brunei Darussalam', 'WPRO', '11', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12070, '2020-03-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12071, '2020-03-13', 'BN', 'Brunei Darussalam', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12072, '2020-03-14', 'BN', 'Brunei Darussalam', 'WPRO', '13', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12073, '2020-03-15', 'BN', 'Brunei Darussalam', 'WPRO', '15', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12074, '2020-03-16', 'BN', 'Brunei Darussalam', 'WPRO', '10', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12075, '2020-03-17', 'BN', 'Brunei Darussalam', 'WPRO', '4', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12076, '2020-03-18', 'BN', 'Brunei Darussalam', 'WPRO', '2', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12077, '2020-03-19', 'BN', 'Brunei Darussalam', 'WPRO', '13', '73', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12078, '2020-03-20', 'BN', 'Brunei Darussalam', 'WPRO', '5', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12079, '2020-03-21', 'BN', 'Brunei Darussalam', 'WPRO', '5', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12080, '2020-03-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12081, '2020-03-23', 'BN', 'Brunei Darussalam', 'WPRO', '5', '88', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12082, '2020-03-24', 'BN', 'Brunei Darussalam', 'WPRO', '3', '91', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12083, '2020-03-25', 'BN', 'Brunei Darussalam', 'WPRO', '13', '104', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12084, '2020-03-26', 'BN', 'Brunei Darussalam', 'WPRO', '5', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12085, '2020-03-27', 'BN', 'Brunei Darussalam', 'WPRO', '5', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12086, '2020-03-28', 'BN', 'Brunei Darussalam', 'WPRO', '1', '115', '1', '1');
INSERT INTO public.who_global_data_import VALUES (12087, '2020-03-29', 'BN', 'Brunei Darussalam', 'WPRO', '5', '120', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12088, '2020-03-30', 'BN', 'Brunei Darussalam', 'WPRO', '6', '126', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12089, '2020-03-31', 'BN', 'Brunei Darussalam', 'WPRO', '1', '127', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12090, '2020-04-01', 'BN', 'Brunei Darussalam', 'WPRO', '2', '129', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12091, '2020-04-02', 'BN', 'Brunei Darussalam', 'WPRO', '2', '131', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12092, '2020-04-03', 'BN', 'Brunei Darussalam', 'WPRO', '2', '133', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12093, '2020-04-04', 'BN', 'Brunei Darussalam', 'WPRO', '1', '134', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12094, '2020-04-05', 'BN', 'Brunei Darussalam', 'WPRO', '1', '135', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12095, '2020-04-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '135', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12096, '2020-04-07', 'BN', 'Brunei Darussalam', 'WPRO', '0', '135', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12097, '2020-04-08', 'BN', 'Brunei Darussalam', 'WPRO', '0', '135', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12098, '2020-04-09', 'BN', 'Brunei Darussalam', 'WPRO', '0', '135', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12099, '2020-04-10', 'BN', 'Brunei Darussalam', 'WPRO', '0', '135', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12100, '2020-04-11', 'BN', 'Brunei Darussalam', 'WPRO', '1', '136', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12101, '2020-04-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '136', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12102, '2020-04-13', 'BN', 'Brunei Darussalam', 'WPRO', '0', '136', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12103, '2020-04-14', 'BN', 'Brunei Darussalam', 'WPRO', '0', '136', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12104, '2020-04-15', 'BN', 'Brunei Darussalam', 'WPRO', '0', '136', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12105, '2020-04-16', 'BN', 'Brunei Darussalam', 'WPRO', '0', '136', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12106, '2020-04-17', 'BN', 'Brunei Darussalam', 'WPRO', '0', '136', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12107, '2020-04-18', 'BN', 'Brunei Darussalam', 'WPRO', '0', '136', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12108, '2020-04-19', 'BN', 'Brunei Darussalam', 'WPRO', '1', '137', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12109, '2020-04-20', 'BN', 'Brunei Darussalam', 'WPRO', '1', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12110, '2020-04-21', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12111, '2020-04-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12112, '2020-04-23', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12113, '2020-04-24', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12114, '2020-04-25', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12115, '2020-04-26', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12116, '2020-04-27', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12117, '2020-04-28', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12118, '2020-04-29', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12119, '2020-04-30', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12120, '2020-05-01', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12121, '2020-05-02', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12122, '2020-05-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12123, '2020-05-04', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12124, '2020-05-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12125, '2020-05-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12126, '2020-05-07', 'BN', 'Brunei Darussalam', 'WPRO', '1', '139', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12127, '2020-05-08', 'BN', 'Brunei Darussalam', 'WPRO', '2', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12128, '2020-05-09', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12129, '2020-05-10', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12130, '2020-05-11', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12131, '2020-05-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12132, '2020-05-13', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12133, '2020-05-14', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12134, '2020-05-15', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12135, '2020-05-16', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12136, '2020-05-17', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12137, '2020-05-18', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12138, '2020-05-19', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12139, '2020-05-20', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12140, '2020-05-21', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12141, '2020-05-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12142, '2020-05-23', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12143, '2020-05-24', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12144, '2020-05-25', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12145, '2020-05-26', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12146, '2020-05-27', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12147, '2020-05-28', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '1', '2');
INSERT INTO public.who_global_data_import VALUES (12148, '2020-05-29', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12149, '2020-05-30', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12150, '2020-05-31', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12151, '2020-06-01', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12152, '2020-06-02', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12153, '2020-06-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12154, '2020-06-04', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12155, '2020-06-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12156, '2020-06-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12157, '2020-06-07', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12158, '2020-06-08', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12159, '2020-06-09', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12160, '2020-06-10', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12161, '2020-06-11', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12162, '2020-06-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12163, '2020-06-13', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12164, '2020-06-14', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12165, '2020-06-15', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12166, '2020-06-16', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12167, '2020-06-17', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '1', '3');
INSERT INTO public.who_global_data_import VALUES (12168, '2020-06-18', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12169, '2020-06-19', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12170, '2020-06-20', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12171, '2020-06-21', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12172, '2020-06-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12173, '2020-06-23', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12174, '2020-06-24', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12175, '2020-06-25', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12176, '2020-06-26', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12177, '2020-06-27', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12178, '2020-06-28', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12179, '2020-06-29', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12180, '2020-06-30', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12181, '2020-07-01', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12182, '2020-07-02', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12183, '2020-07-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12184, '2020-07-04', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12185, '2020-07-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12186, '2020-07-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12187, '2020-07-07', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12188, '2020-07-08', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12189, '2020-07-09', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12190, '2020-07-10', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12191, '2020-07-11', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12192, '2020-07-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12193, '2020-07-13', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12194, '2020-07-14', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12195, '2020-07-15', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12196, '2020-07-16', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12197, '2020-07-17', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12198, '2020-07-18', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12199, '2020-07-19', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12200, '2020-07-20', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12201, '2020-07-21', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12202, '2020-07-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12203, '2020-07-23', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12204, '2020-07-24', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12205, '2020-07-25', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12206, '2020-07-26', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12207, '2020-07-27', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12208, '2020-07-28', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12209, '2020-07-29', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12210, '2020-07-30', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12211, '2020-07-31', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12212, '2020-08-01', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12213, '2020-08-02', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12214, '2020-08-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12215, '2020-08-04', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12216, '2020-08-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12217, '2020-08-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12218, '2020-08-07', 'BN', 'Brunei Darussalam', 'WPRO', '0', '141', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12219, '2020-08-08', 'BN', 'Brunei Darussalam', 'WPRO', '1', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12220, '2020-08-09', 'BN', 'Brunei Darussalam', 'WPRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12221, '2020-08-10', 'BN', 'Brunei Darussalam', 'WPRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12222, '2020-08-11', 'BN', 'Brunei Darussalam', 'WPRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12223, '2020-08-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12224, '2020-08-13', 'BN', 'Brunei Darussalam', 'WPRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12225, '2020-08-14', 'BN', 'Brunei Darussalam', 'WPRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12226, '2020-08-15', 'BN', 'Brunei Darussalam', 'WPRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12227, '2020-08-16', 'BN', 'Brunei Darussalam', 'WPRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12228, '2020-08-17', 'BN', 'Brunei Darussalam', 'WPRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12229, '2020-08-18', 'BN', 'Brunei Darussalam', 'WPRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12230, '2020-08-19', 'BN', 'Brunei Darussalam', 'WPRO', '0', '142', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12231, '2020-08-20', 'BN', 'Brunei Darussalam', 'WPRO', '1', '143', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12232, '2020-08-21', 'BN', 'Brunei Darussalam', 'WPRO', '0', '143', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12233, '2020-08-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '143', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12234, '2020-08-23', 'BN', 'Brunei Darussalam', 'WPRO', '0', '143', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12235, '2020-08-24', 'BN', 'Brunei Darussalam', 'WPRO', '0', '143', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12236, '2020-08-25', 'BN', 'Brunei Darussalam', 'WPRO', '0', '143', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12237, '2020-08-26', 'BN', 'Brunei Darussalam', 'WPRO', '1', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12238, '2020-08-27', 'BN', 'Brunei Darussalam', 'WPRO', '0', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12239, '2020-08-28', 'BN', 'Brunei Darussalam', 'WPRO', '0', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12240, '2020-08-29', 'BN', 'Brunei Darussalam', 'WPRO', '0', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12241, '2020-08-30', 'BN', 'Brunei Darussalam', 'WPRO', '0', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12242, '2020-08-31', 'BN', 'Brunei Darussalam', 'WPRO', '0', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12243, '2020-09-01', 'BN', 'Brunei Darussalam', 'WPRO', '0', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12244, '2020-09-02', 'BN', 'Brunei Darussalam', 'WPRO', '0', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12245, '2020-09-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12246, '2020-09-04', 'BN', 'Brunei Darussalam', 'WPRO', '1', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12247, '2020-09-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12248, '2020-09-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12249, '2020-09-07', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12250, '2020-09-08', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12251, '2020-09-09', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12252, '2020-09-10', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12253, '2020-09-11', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12254, '2020-09-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12255, '2020-09-13', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12256, '2020-09-14', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12257, '2020-09-15', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12258, '2020-09-16', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12259, '2020-09-17', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12260, '2020-09-18', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12261, '2020-09-19', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12262, '2020-09-20', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12263, '2020-09-21', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12264, '2020-09-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12265, '2020-09-23', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12266, '2020-09-24', 'BN', 'Brunei Darussalam', 'WPRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12267, '2020-09-25', 'BN', 'Brunei Darussalam', 'WPRO', '1', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12268, '2020-09-26', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12269, '2020-09-27', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12270, '2020-09-28', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12271, '2020-09-29', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12272, '2020-09-30', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12273, '2020-10-01', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12274, '2020-10-02', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12275, '2020-10-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12276, '2020-10-04', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12277, '2020-10-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12278, '2020-10-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12279, '2020-10-07', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12280, '2020-10-08', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12281, '2020-10-09', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12282, '2020-10-10', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12283, '2020-10-11', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12284, '2020-10-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12285, '2020-10-13', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12286, '2020-10-14', 'BN', 'Brunei Darussalam', 'WPRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12287, '2020-10-15', 'BN', 'Brunei Darussalam', 'WPRO', '1', '147', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12288, '2020-10-16', 'BN', 'Brunei Darussalam', 'WPRO', '0', '147', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12289, '2020-10-17', 'BN', 'Brunei Darussalam', 'WPRO', '0', '147', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12290, '2020-10-18', 'BN', 'Brunei Darussalam', 'WPRO', '0', '147', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12291, '2020-10-19', 'BN', 'Brunei Darussalam', 'WPRO', '0', '147', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12292, '2020-10-20', 'BN', 'Brunei Darussalam', 'WPRO', '0', '147', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12293, '2020-10-21', 'BN', 'Brunei Darussalam', 'WPRO', '0', '147', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12294, '2020-10-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '147', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12295, '2020-10-23', 'BN', 'Brunei Darussalam', 'WPRO', '1', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12296, '2020-10-24', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12297, '2020-10-25', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12298, '2020-10-26', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12299, '2020-10-27', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12300, '2020-10-28', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12301, '2020-10-29', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12302, '2020-10-30', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12303, '2020-10-31', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12304, '2020-11-01', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12305, '2020-11-02', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12306, '2020-11-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12307, '2020-11-04', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12308, '2020-11-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12309, '2020-11-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12310, '2020-11-07', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12311, '2020-11-08', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12312, '2020-11-09', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12313, '2020-11-10', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12314, '2020-11-11', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12315, '2020-11-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12316, '2020-11-13', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12317, '2020-11-14', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12318, '2020-11-15', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12319, '2020-11-16', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12320, '2020-11-17', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12321, '2020-11-18', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12322, '2020-11-19', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12323, '2020-11-20', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12324, '2020-11-21', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12325, '2020-11-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12326, '2020-11-23', 'BN', 'Brunei Darussalam', 'WPRO', '0', '148', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12327, '2020-11-24', 'BN', 'Brunei Darussalam', 'WPRO', '1', '149', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12328, '2020-11-25', 'BN', 'Brunei Darussalam', 'WPRO', '1', '150', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12329, '2020-11-26', 'BN', 'Brunei Darussalam', 'WPRO', '0', '150', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12330, '2020-11-27', 'BN', 'Brunei Darussalam', 'WPRO', '0', '150', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12331, '2020-11-28', 'BN', 'Brunei Darussalam', 'WPRO', '0', '150', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12332, '2020-11-29', 'BN', 'Brunei Darussalam', 'WPRO', '0', '150', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12333, '2020-11-30', 'BN', 'Brunei Darussalam', 'WPRO', '0', '150', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12334, '2020-12-01', 'BN', 'Brunei Darussalam', 'WPRO', '0', '150', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12335, '2020-12-02', 'BN', 'Brunei Darussalam', 'WPRO', '1', '151', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12336, '2020-12-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '151', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12337, '2020-12-04', 'BN', 'Brunei Darussalam', 'WPRO', '0', '151', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12338, '2020-12-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '151', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12339, '2020-12-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '151', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12340, '2020-12-07', 'BN', 'Brunei Darussalam', 'WPRO', '0', '151', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12341, '2020-12-08', 'BN', 'Brunei Darussalam', 'WPRO', '0', '151', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12342, '2020-12-09', 'BN', 'Brunei Darussalam', 'WPRO', '1', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12343, '2020-12-10', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12344, '2020-12-11', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12345, '2020-12-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12346, '2020-12-13', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12347, '2020-12-14', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12348, '2020-12-15', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12349, '2020-12-16', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12350, '2020-12-17', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12351, '2020-12-18', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12352, '2020-12-19', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12353, '2020-12-20', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12354, '2020-12-21', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12355, '2020-12-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12356, '2020-12-23', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12357, '2020-12-24', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12358, '2020-12-25', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12359, '2020-12-26', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12360, '2020-12-27', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12361, '2020-12-28', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12362, '2020-12-29', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12363, '2020-12-30', 'BN', 'Brunei Darussalam', 'WPRO', '0', '152', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12364, '2020-12-31', 'BN', 'Brunei Darussalam', 'WPRO', '5', '157', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12365, '2021-01-01', 'BN', 'Brunei Darussalam', 'WPRO', '0', '157', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12366, '2021-01-02', 'BN', 'Brunei Darussalam', 'WPRO', '0', '157', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12367, '2021-01-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '157', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12368, '2021-01-04', 'BN', 'Brunei Darussalam', 'WPRO', '15', '172', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12369, '2021-01-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '172', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12370, '2021-01-06', 'BN', 'Brunei Darussalam', 'WPRO', '0', '172', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12371, '2021-01-07', 'BN', 'Brunei Darussalam', 'WPRO', '0', '172', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12372, '2021-01-08', 'BN', 'Brunei Darussalam', 'WPRO', '1', '173', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12373, '2021-01-09', 'BN', 'Brunei Darussalam', 'WPRO', '0', '173', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12374, '2021-01-10', 'BN', 'Brunei Darussalam', 'WPRO', '0', '173', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12375, '2021-01-11', 'BN', 'Brunei Darussalam', 'WPRO', '0', '173', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12376, '2021-01-12', 'BN', 'Brunei Darussalam', 'WPRO', '0', '173', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12377, '2021-01-13', 'BN', 'Brunei Darussalam', 'WPRO', '1', '174', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12378, '2021-01-14', 'BN', 'Brunei Darussalam', 'WPRO', '0', '174', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12379, '2021-01-15', 'BN', 'Brunei Darussalam', 'WPRO', '0', '174', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12380, '2021-01-16', 'BN', 'Brunei Darussalam', 'WPRO', '0', '174', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12381, '2021-01-17', 'BN', 'Brunei Darussalam', 'WPRO', '0', '174', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12382, '2021-01-18', 'BN', 'Brunei Darussalam', 'WPRO', '0', '174', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12383, '2021-01-19', 'BN', 'Brunei Darussalam', 'WPRO', '0', '174', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12384, '2021-01-20', 'BN', 'Brunei Darussalam', 'WPRO', '0', '174', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12385, '2021-01-21', 'BN', 'Brunei Darussalam', 'WPRO', '0', '174', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12386, '2021-01-22', 'BN', 'Brunei Darussalam', 'WPRO', '0', '174', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12387, '2021-01-23', 'BN', 'Brunei Darussalam', 'WPRO', '1', '175', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12388, '2021-01-24', 'BN', 'Brunei Darussalam', 'WPRO', '0', '175', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12389, '2021-01-25', 'BN', 'Brunei Darussalam', 'WPRO', '0', '175', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12390, '2021-01-26', 'BN', 'Brunei Darussalam', 'WPRO', '0', '175', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12391, '2021-01-27', 'BN', 'Brunei Darussalam', 'WPRO', '1', '176', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12392, '2021-01-28', 'BN', 'Brunei Darussalam', 'WPRO', '0', '176', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12393, '2021-01-29', 'BN', 'Brunei Darussalam', 'WPRO', '4', '180', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12394, '2021-01-30', 'BN', 'Brunei Darussalam', 'WPRO', '0', '180', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12395, '2021-01-31', 'BN', 'Brunei Darussalam', 'WPRO', '0', '180', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12396, '2021-02-01', 'BN', 'Brunei Darussalam', 'WPRO', '0', '180', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12397, '2021-02-02', 'BN', 'Brunei Darussalam', 'WPRO', '0', '180', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12398, '2021-02-03', 'BN', 'Brunei Darussalam', 'WPRO', '0', '180', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12399, '2021-02-04', 'BN', 'Brunei Darussalam', 'WPRO', '0', '180', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12400, '2021-02-05', 'BN', 'Brunei Darussalam', 'WPRO', '0', '180', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12401, '2020-01-03', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12402, '2020-01-04', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12403, '2020-01-05', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12404, '2020-01-06', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12405, '2020-01-07', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12406, '2020-01-08', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12407, '2020-01-09', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12408, '2020-01-10', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12409, '2020-01-11', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12410, '2020-01-12', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12411, '2020-01-13', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12412, '2020-01-14', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12413, '2020-01-15', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12414, '2020-01-16', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12415, '2020-01-17', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12416, '2020-01-18', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12417, '2020-01-19', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12418, '2020-01-20', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12419, '2020-01-21', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12420, '2020-01-22', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12421, '2020-01-23', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12422, '2020-01-24', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12423, '2020-01-25', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12424, '2020-01-26', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12425, '2020-01-27', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12426, '2020-01-28', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12427, '2020-01-29', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12428, '2020-01-30', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12429, '2020-01-31', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12430, '2020-02-01', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12431, '2020-02-02', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12432, '2020-02-03', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12433, '2020-02-04', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12434, '2020-02-05', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12435, '2020-02-06', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12436, '2020-02-07', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12437, '2020-02-08', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12438, '2020-02-09', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12439, '2020-02-10', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12440, '2020-02-11', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12441, '2020-02-12', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12442, '2020-02-13', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12443, '2020-02-14', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12444, '2020-02-15', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12445, '2020-02-16', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12446, '2020-02-17', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12447, '2020-02-18', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12448, '2020-02-19', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12449, '2020-02-20', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12450, '2020-02-21', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12451, '2020-02-22', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12452, '2020-02-23', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12453, '2020-02-24', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12454, '2020-02-25', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12455, '2020-02-26', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12456, '2020-02-27', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12457, '2020-02-28', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12458, '2020-02-29', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12459, '2020-03-01', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12460, '2020-03-02', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12461, '2020-03-03', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12462, '2020-03-04', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12463, '2020-03-05', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12464, '2020-03-06', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12465, '2020-03-07', 'BG', 'Bulgaria', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12466, '2020-03-08', 'BG', 'Bulgaria', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12467, '2020-03-09', 'BG', 'Bulgaria', 'EURO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12468, '2020-03-10', 'BG', 'Bulgaria', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12469, '2020-03-11', 'BG', 'Bulgaria', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12470, '2020-03-12', 'BG', 'Bulgaria', 'EURO', '3', '7', '1', '1');
INSERT INTO public.who_global_data_import VALUES (12471, '2020-03-13', 'BG', 'Bulgaria', 'EURO', '16', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12472, '2020-03-14', 'BG', 'Bulgaria', 'EURO', '8', '31', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12473, '2020-03-15', 'BG', 'Bulgaria', 'EURO', '10', '41', '1', '2');
INSERT INTO public.who_global_data_import VALUES (12474, '2020-03-16', 'BG', 'Bulgaria', 'EURO', '10', '51', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12475, '2020-03-17', 'BG', 'Bulgaria', 'EURO', '11', '62', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12476, '2020-03-18', 'BG', 'Bulgaria', 'EURO', '19', '81', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12477, '2020-03-19', 'BG', 'Bulgaria', 'EURO', '11', '92', '0', '2');
INSERT INTO public.who_global_data_import VALUES (12478, '2020-03-20', 'BG', 'Bulgaria', 'EURO', '13', '105', '1', '3');
INSERT INTO public.who_global_data_import VALUES (12479, '2020-03-21', 'BG', 'Bulgaria', 'EURO', '22', '127', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12480, '2020-03-22', 'BG', 'Bulgaria', 'EURO', '36', '163', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12481, '2020-03-23', 'BG', 'Bulgaria', 'EURO', '22', '185', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12482, '2020-03-24', 'BG', 'Bulgaria', 'EURO', '16', '201', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12483, '2020-03-25', 'BG', 'Bulgaria', 'EURO', '19', '220', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12484, '2020-03-26', 'BG', 'Bulgaria', 'EURO', '22', '242', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12485, '2020-03-27', 'BG', 'Bulgaria', 'EURO', '22', '264', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12486, '2020-03-28', 'BG', 'Bulgaria', 'EURO', '29', '293', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12487, '2020-03-29', 'BG', 'Bulgaria', 'EURO', '38', '331', '4', '7');
INSERT INTO public.who_global_data_import VALUES (12488, '2020-03-30', 'BG', 'Bulgaria', 'EURO', '15', '346', '1', '8');
INSERT INTO public.who_global_data_import VALUES (12489, '2020-03-31', 'BG', 'Bulgaria', 'EURO', '13', '359', '0', '8');
INSERT INTO public.who_global_data_import VALUES (12490, '2020-04-01', 'BG', 'Bulgaria', 'EURO', '40', '399', '0', '8');
INSERT INTO public.who_global_data_import VALUES (12491, '2020-04-02', 'BG', 'Bulgaria', 'EURO', '23', '422', '2', '10');
INSERT INTO public.who_global_data_import VALUES (12492, '2020-04-03', 'BG', 'Bulgaria', 'EURO', '35', '457', '0', '10');
INSERT INTO public.who_global_data_import VALUES (12493, '2020-04-04', 'BG', 'Bulgaria', 'EURO', '28', '485', '4', '14');
INSERT INTO public.who_global_data_import VALUES (12494, '2020-04-05', 'BG', 'Bulgaria', 'EURO', '18', '503', '3', '17');
INSERT INTO public.who_global_data_import VALUES (12495, '2020-04-06', 'BG', 'Bulgaria', 'EURO', '28', '531', '3', '20');
INSERT INTO public.who_global_data_import VALUES (12496, '2020-04-07', 'BG', 'Bulgaria', 'EURO', '18', '549', '2', '22');
INSERT INTO public.who_global_data_import VALUES (12497, '2020-04-08', 'BG', 'Bulgaria', 'EURO', '28', '577', '1', '23');
INSERT INTO public.who_global_data_import VALUES (12498, '2020-04-09', 'BG', 'Bulgaria', 'EURO', '16', '593', '1', '24');
INSERT INTO public.who_global_data_import VALUES (12499, '2020-04-10', 'BG', 'Bulgaria', 'EURO', '31', '624', '0', '24');
INSERT INTO public.who_global_data_import VALUES (12500, '2020-04-11', 'BG', 'Bulgaria', 'EURO', '11', '635', '1', '25');
INSERT INTO public.who_global_data_import VALUES (12501, '2020-04-12', 'BG', 'Bulgaria', 'EURO', '26', '661', '3', '28');
INSERT INTO public.who_global_data_import VALUES (12502, '2020-04-13', 'BG', 'Bulgaria', 'EURO', '14', '675', '1', '29');
INSERT INTO public.who_global_data_import VALUES (12503, '2020-04-14', 'BG', 'Bulgaria', 'EURO', '10', '685', '3', '32');
INSERT INTO public.who_global_data_import VALUES (12504, '2020-04-15', 'BG', 'Bulgaria', 'EURO', '28', '713', '3', '35');
INSERT INTO public.who_global_data_import VALUES (12505, '2020-04-16', 'BG', 'Bulgaria', 'EURO', '34', '747', '1', '36');
INSERT INTO public.who_global_data_import VALUES (12506, '2020-04-17', 'BG', 'Bulgaria', 'EURO', '53', '800', '2', '38');
INSERT INTO public.who_global_data_import VALUES (12507, '2020-04-18', 'BG', 'Bulgaria', 'EURO', '46', '846', '3', '41');
INSERT INTO public.who_global_data_import VALUES (12508, '2020-04-19', 'BG', 'Bulgaria', 'EURO', '32', '878', '0', '41');
INSERT INTO public.who_global_data_import VALUES (12509, '2020-04-20', 'BG', 'Bulgaria', 'EURO', '37', '915', '2', '43');
INSERT INTO public.who_global_data_import VALUES (12510, '2020-04-21', 'BG', 'Bulgaria', 'EURO', '14', '929', '0', '43');
INSERT INTO public.who_global_data_import VALUES (12511, '2020-04-22', 'BG', 'Bulgaria', 'EURO', '46', '975', '2', '45');
INSERT INTO public.who_global_data_import VALUES (12512, '2020-04-23', 'BG', 'Bulgaria', 'EURO', '49', '1024', '4', '49');
INSERT INTO public.who_global_data_import VALUES (12513, '2020-04-24', 'BG', 'Bulgaria', 'EURO', '73', '1097', '3', '52');
INSERT INTO public.who_global_data_import VALUES (12514, '2020-04-25', 'BG', 'Bulgaria', 'EURO', '91', '1188', '2', '54');
INSERT INTO public.who_global_data_import VALUES (12515, '2020-04-26', 'BG', 'Bulgaria', 'EURO', '59', '1247', '1', '55');
INSERT INTO public.who_global_data_import VALUES (12516, '2020-04-27', 'BG', 'Bulgaria', 'EURO', '53', '1300', '1', '56');
INSERT INTO public.who_global_data_import VALUES (12517, '2020-04-28', 'BG', 'Bulgaria', 'EURO', '63', '1363', '2', '58');
INSERT INTO public.who_global_data_import VALUES (12518, '2020-04-29', 'BG', 'Bulgaria', 'EURO', '36', '1399', '0', '58');
INSERT INTO public.who_global_data_import VALUES (12519, '2020-04-30', 'BG', 'Bulgaria', 'EURO', '48', '1447', '6', '64');
INSERT INTO public.who_global_data_import VALUES (12520, '2020-05-01', 'BG', 'Bulgaria', 'EURO', '59', '1506', '2', '66');
INSERT INTO public.who_global_data_import VALUES (12521, '2020-05-02', 'BG', 'Bulgaria', 'EURO', '82', '1588', '3', '69');
INSERT INTO public.who_global_data_import VALUES (12522, '2020-05-03', 'BG', 'Bulgaria', 'EURO', '6', '1594', '3', '72');
INSERT INTO public.who_global_data_import VALUES (12523, '2020-05-04', 'BG', 'Bulgaria', 'EURO', '24', '1618', '1', '73');
INSERT INTO public.who_global_data_import VALUES (12524, '2020-05-05', 'BG', 'Bulgaria', 'EURO', '34', '1652', '5', '78');
INSERT INTO public.who_global_data_import VALUES (12525, '2020-05-06', 'BG', 'Bulgaria', 'EURO', '37', '1689', '0', '78');
INSERT INTO public.who_global_data_import VALUES (12526, '2020-05-07', 'BG', 'Bulgaria', 'EURO', '89', '1778', '6', '84');
INSERT INTO public.who_global_data_import VALUES (12527, '2020-05-08', 'BG', 'Bulgaria', 'EURO', '51', '1829', '0', '84');
INSERT INTO public.who_global_data_import VALUES (12528, '2020-05-09', 'BG', 'Bulgaria', 'EURO', '82', '1911', '4', '88');
INSERT INTO public.who_global_data_import VALUES (12529, '2020-05-10', 'BG', 'Bulgaria', 'EURO', '44', '1955', '2', '90');
INSERT INTO public.who_global_data_import VALUES (12530, '2020-05-11', 'BG', 'Bulgaria', 'EURO', '10', '1965', '1', '91');
INSERT INTO public.who_global_data_import VALUES (12531, '2020-05-12', 'BG', 'Bulgaria', 'EURO', '25', '1990', '2', '93');
INSERT INTO public.who_global_data_import VALUES (12532, '2020-05-13', 'BG', 'Bulgaria', 'EURO', '33', '2023', '2', '95');
INSERT INTO public.who_global_data_import VALUES (12533, '2020-05-14', 'BG', 'Bulgaria', 'EURO', '46', '2069', '1', '96');
INSERT INTO public.who_global_data_import VALUES (12534, '2020-05-15', 'BG', 'Bulgaria', 'EURO', '31', '2100', '3', '99');
INSERT INTO public.who_global_data_import VALUES (12535, '2020-05-16', 'BG', 'Bulgaria', 'EURO', '38', '2138', '3', '102');
INSERT INTO public.who_global_data_import VALUES (12536, '2020-05-17', 'BG', 'Bulgaria', 'EURO', '73', '2211', '6', '108');
INSERT INTO public.who_global_data_import VALUES (12537, '2020-05-18', 'BG', 'Bulgaria', 'EURO', '24', '2235', '2', '110');
INSERT INTO public.who_global_data_import VALUES (12538, '2020-05-19', 'BG', 'Bulgaria', 'EURO', '24', '2259', '2', '112');
INSERT INTO public.who_global_data_import VALUES (12539, '2020-05-20', 'BG', 'Bulgaria', 'EURO', '33', '2292', '4', '116');
INSERT INTO public.who_global_data_import VALUES (12540, '2020-05-21', 'BG', 'Bulgaria', 'EURO', '39', '2331', '4', '120');
INSERT INTO public.who_global_data_import VALUES (12541, '2020-05-22', 'BG', 'Bulgaria', 'EURO', '41', '2372', '5', '125');
INSERT INTO public.who_global_data_import VALUES (12542, '2020-05-23', 'BG', 'Bulgaria', 'EURO', '36', '2408', '1', '126');
INSERT INTO public.who_global_data_import VALUES (12543, '2020-05-24', 'BG', 'Bulgaria', 'EURO', '0', '2408', '0', '126');
INSERT INTO public.who_global_data_import VALUES (12544, '2020-05-25', 'BG', 'Bulgaria', 'EURO', '25', '2433', '4', '130');
INSERT INTO public.who_global_data_import VALUES (12545, '2020-05-26', 'BG', 'Bulgaria', 'EURO', '0', '2433', '0', '130');
INSERT INTO public.who_global_data_import VALUES (12546, '2020-05-27', 'BG', 'Bulgaria', 'EURO', '27', '2460', '3', '133');
INSERT INTO public.who_global_data_import VALUES (12547, '2020-05-28', 'BG', 'Bulgaria', 'EURO', '0', '2460', '0', '133');
INSERT INTO public.who_global_data_import VALUES (12548, '2020-05-29', 'BG', 'Bulgaria', 'EURO', '25', '2485', '3', '136');
INSERT INTO public.who_global_data_import VALUES (12549, '2020-05-30', 'BG', 'Bulgaria', 'EURO', '14', '2499', '3', '139');
INSERT INTO public.who_global_data_import VALUES (12550, '2020-05-31', 'BG', 'Bulgaria', 'EURO', '14', '2513', '1', '140');
INSERT INTO public.who_global_data_import VALUES (12551, '2020-06-01', 'BG', 'Bulgaria', 'EURO', '0', '2513', '0', '140');
INSERT INTO public.who_global_data_import VALUES (12552, '2020-06-02', 'BG', 'Bulgaria', 'EURO', '0', '2513', '4', '144');
INSERT INTO public.who_global_data_import VALUES (12553, '2020-06-03', 'BG', 'Bulgaria', 'EURO', '25', '2538', '0', '144');
INSERT INTO public.who_global_data_import VALUES (12554, '2020-06-04', 'BG', 'Bulgaria', 'EURO', '47', '2585', '3', '147');
INSERT INTO public.who_global_data_import VALUES (12555, '2020-06-05', 'BG', 'Bulgaria', 'EURO', '0', '2585', '0', '147');
INSERT INTO public.who_global_data_import VALUES (12556, '2020-06-06', 'BG', 'Bulgaria', 'EURO', '83', '2668', '13', '160');
INSERT INTO public.who_global_data_import VALUES (12557, '2020-06-07', 'BG', 'Bulgaria', 'EURO', '43', '2711', '0', '160');
INSERT INTO public.who_global_data_import VALUES (12558, '2020-06-08', 'BG', 'Bulgaria', 'EURO', '16', '2727', '0', '160');
INSERT INTO public.who_global_data_import VALUES (12559, '2020-06-09', 'BG', 'Bulgaria', 'EURO', '83', '2810', '4', '164');
INSERT INTO public.who_global_data_import VALUES (12560, '2020-06-10', 'BG', 'Bulgaria', 'EURO', '79', '2889', '3', '167');
INSERT INTO public.who_global_data_import VALUES (12561, '2020-06-11', 'BG', 'Bulgaria', 'EURO', '104', '2993', '0', '167');
INSERT INTO public.who_global_data_import VALUES (12562, '2020-06-12', 'BG', 'Bulgaria', 'EURO', '93', '3086', '1', '168');
INSERT INTO public.who_global_data_import VALUES (12563, '2020-06-13', 'BG', 'Bulgaria', 'EURO', '105', '3191', '4', '172');
INSERT INTO public.who_global_data_import VALUES (12564, '2020-06-14', 'BG', 'Bulgaria', 'EURO', '75', '3266', '0', '172');
INSERT INTO public.who_global_data_import VALUES (12565, '2020-06-15', 'BG', 'Bulgaria', 'EURO', '24', '3290', '2', '174');
INSERT INTO public.who_global_data_import VALUES (12566, '2020-06-16', 'BG', 'Bulgaria', 'EURO', '51', '3341', '2', '176');
INSERT INTO public.who_global_data_import VALUES (12567, '2020-06-17', 'BG', 'Bulgaria', 'EURO', '112', '3453', '5', '181');
INSERT INTO public.who_global_data_import VALUES (12568, '2020-06-18', 'BG', 'Bulgaria', 'EURO', '89', '3542', '3', '184');
INSERT INTO public.who_global_data_import VALUES (12569, '2020-06-19', 'BG', 'Bulgaria', 'EURO', '132', '3674', '6', '190');
INSERT INTO public.who_global_data_import VALUES (12570, '2020-06-20', 'BG', 'Bulgaria', 'EURO', '81', '3755', '3', '193');
INSERT INTO public.who_global_data_import VALUES (12571, '2020-06-21', 'BG', 'Bulgaria', 'EURO', '117', '3872', '6', '199');
INSERT INTO public.who_global_data_import VALUES (12572, '2020-06-22', 'BG', 'Bulgaria', 'EURO', '33', '3905', '0', '199');
INSERT INTO public.who_global_data_import VALUES (12573, '2020-06-23', 'BG', 'Bulgaria', 'EURO', '79', '3984', '8', '207');
INSERT INTO public.who_global_data_import VALUES (12574, '2020-06-24', 'BG', 'Bulgaria', 'EURO', '130', '4114', '1', '208');
INSERT INTO public.who_global_data_import VALUES (12575, '2020-06-25', 'BG', 'Bulgaria', 'EURO', '128', '4242', '1', '209');
INSERT INTO public.who_global_data_import VALUES (12576, '2020-06-26', 'BG', 'Bulgaria', 'EURO', '166', '4408', '2', '211');
INSERT INTO public.who_global_data_import VALUES (12577, '2020-06-27', 'BG', 'Bulgaria', 'EURO', '105', '4513', '4', '215');
INSERT INTO public.who_global_data_import VALUES (12578, '2020-06-28', 'BG', 'Bulgaria', 'EURO', '112', '4625', '1', '216');
INSERT INTO public.who_global_data_import VALUES (12579, '2020-06-29', 'BG', 'Bulgaria', 'EURO', '66', '4691', '3', '219');
INSERT INTO public.who_global_data_import VALUES (12580, '2020-06-30', 'BG', 'Bulgaria', 'EURO', '140', '4831', '4', '223');
INSERT INTO public.who_global_data_import VALUES (12581, '2020-07-01', 'BG', 'Bulgaria', 'EURO', '158', '4989', '7', '230');
INSERT INTO public.who_global_data_import VALUES (12582, '2020-07-02', 'BG', 'Bulgaria', 'EURO', '165', '5154', '2', '232');
INSERT INTO public.who_global_data_import VALUES (12583, '2020-07-03', 'BG', 'Bulgaria', 'EURO', '161', '5315', '0', '232');
INSERT INTO public.who_global_data_import VALUES (12584, '2020-07-04', 'BG', 'Bulgaria', 'EURO', '182', '5497', '7', '239');
INSERT INTO public.who_global_data_import VALUES (12585, '2020-07-05', 'BG', 'Bulgaria', 'EURO', '180', '5677', '2', '241');
INSERT INTO public.who_global_data_import VALUES (12586, '2020-07-06', 'BG', 'Bulgaria', 'EURO', '63', '5740', '5', '246');
INSERT INTO public.who_global_data_import VALUES (12587, '2020-07-07', 'BG', 'Bulgaria', 'EURO', '174', '5914', '4', '250');
INSERT INTO public.who_global_data_import VALUES (12588, '2020-07-08', 'BG', 'Bulgaria', 'EURO', '188', '6102', '4', '254');
INSERT INTO public.who_global_data_import VALUES (12589, '2020-07-09', 'BG', 'Bulgaria', 'EURO', '240', '6342', '5', '259');
INSERT INTO public.who_global_data_import VALUES (12590, '2020-07-10', 'BG', 'Bulgaria', 'EURO', '330', '6672', '3', '262');
INSERT INTO public.who_global_data_import VALUES (12591, '2020-07-11', 'BG', 'Bulgaria', 'EURO', '292', '6964', '0', '262');
INSERT INTO public.who_global_data_import VALUES (12592, '2020-07-12', 'BG', 'Bulgaria', 'EURO', '211', '7175', '0', '262');
INSERT INTO public.who_global_data_import VALUES (12593, '2020-07-13', 'BG', 'Bulgaria', 'EURO', '77', '7252', '6', '268');
INSERT INTO public.who_global_data_import VALUES (12594, '2020-07-14', 'BG', 'Bulgaria', 'EURO', '159', '7411', '8', '276');
INSERT INTO public.who_global_data_import VALUES (12595, '2020-07-15', 'BG', 'Bulgaria', 'EURO', '234', '7645', '7', '283');
INSERT INTO public.who_global_data_import VALUES (12596, '2020-07-16', 'BG', 'Bulgaria', 'EURO', '232', '7877', '6', '289');
INSERT INTO public.who_global_data_import VALUES (12597, '2020-07-17', 'BG', 'Bulgaria', 'EURO', '267', '8144', '4', '293');
INSERT INTO public.who_global_data_import VALUES (12598, '2020-07-18', 'BG', 'Bulgaria', 'EURO', '298', '8442', '4', '297');
INSERT INTO public.who_global_data_import VALUES (12599, '2020-07-19', 'BG', 'Bulgaria', 'EURO', '196', '8638', '2', '299');
INSERT INTO public.who_global_data_import VALUES (12600, '2020-07-20', 'BG', 'Bulgaria', 'EURO', '95', '8733', '1', '300');
INSERT INTO public.who_global_data_import VALUES (12601, '2020-07-21', 'BG', 'Bulgaria', 'EURO', '196', '8929', '8', '308');
INSERT INTO public.who_global_data_import VALUES (12602, '2020-07-22', 'BG', 'Bulgaria', 'EURO', '325', '9254', '5', '313');
INSERT INTO public.who_global_data_import VALUES (12603, '2020-07-23', 'BG', 'Bulgaria', 'EURO', '330', '9584', '8', '321');
INSERT INTO public.who_global_data_import VALUES (12604, '2020-07-24', 'BG', 'Bulgaria', 'EURO', '269', '9853', '8', '329');
INSERT INTO public.who_global_data_import VALUES (12605, '2020-07-25', 'BG', 'Bulgaria', 'EURO', '270', '10123', '8', '337');
INSERT INTO public.who_global_data_import VALUES (12606, '2020-07-26', 'BG', 'Bulgaria', 'EURO', '189', '10312', '1', '338');
INSERT INTO public.who_global_data_import VALUES (12607, '2020-07-27', 'BG', 'Bulgaria', 'EURO', '115', '10427', '2', '340');
INSERT INTO public.who_global_data_import VALUES (12608, '2020-07-28', 'BG', 'Bulgaria', 'EURO', '194', '10621', '7', '347');
INSERT INTO public.who_global_data_import VALUES (12609, '2020-07-29', 'BG', 'Bulgaria', 'EURO', '250', '10871', '8', '355');
INSERT INTO public.who_global_data_import VALUES (12610, '2020-07-30', 'BG', 'Bulgaria', 'EURO', '284', '11155', '13', '368');
INSERT INTO public.who_global_data_import VALUES (12611, '2020-07-31', 'BG', 'Bulgaria', 'EURO', '265', '11420', '6', '374');
INSERT INTO public.who_global_data_import VALUES (12612, '2020-08-01', 'BG', 'Bulgaria', 'EURO', '270', '11690', '9', '383');
INSERT INTO public.who_global_data_import VALUES (12613, '2020-08-02', 'BG', 'Bulgaria', 'EURO', '146', '11836', '2', '385');
INSERT INTO public.who_global_data_import VALUES (12614, '2020-08-03', 'BG', 'Bulgaria', 'EURO', '119', '11955', '3', '388');
INSERT INTO public.who_global_data_import VALUES (12615, '2020-08-04', 'BG', 'Bulgaria', 'EURO', '0', '11955', '0', '388');
INSERT INTO public.who_global_data_import VALUES (12616, '2020-08-05', 'BG', 'Bulgaria', 'EURO', '204', '12159', '16', '404');
INSERT INTO public.who_global_data_import VALUES (12617, '2020-08-06', 'BG', 'Bulgaria', 'EURO', '255', '12414', '11', '415');
INSERT INTO public.who_global_data_import VALUES (12618, '2020-08-07', 'BG', 'Bulgaria', 'EURO', '303', '12717', '9', '424');
INSERT INTO public.who_global_data_import VALUES (12619, '2020-08-08', 'BG', 'Bulgaria', 'EURO', '297', '13014', '11', '435');
INSERT INTO public.who_global_data_import VALUES (12620, '2020-08-09', 'BG', 'Bulgaria', 'EURO', '329', '13343', '10', '445');
INSERT INTO public.who_global_data_import VALUES (12621, '2020-08-10', 'BG', 'Bulgaria', 'EURO', '53', '13396', '2', '447');
INSERT INTO public.who_global_data_import VALUES (12622, '2020-08-11', 'BG', 'Bulgaria', 'EURO', '116', '13512', '12', '459');
INSERT INTO public.who_global_data_import VALUES (12623, '2020-08-12', 'BG', 'Bulgaria', 'EURO', '210', '13722', '12', '471');
INSERT INTO public.who_global_data_import VALUES (12624, '2020-08-13', 'BG', 'Bulgaria', 'EURO', '171', '13893', '11', '482');
INSERT INTO public.who_global_data_import VALUES (12625, '2020-08-14', 'BG', 'Bulgaria', 'EURO', '176', '14069', '2', '484');
INSERT INTO public.who_global_data_import VALUES (12626, '2020-08-15', 'BG', 'Bulgaria', 'EURO', '174', '14243', '8', '492');
INSERT INTO public.who_global_data_import VALUES (12627, '2020-08-16', 'BG', 'Bulgaria', 'EURO', '90', '14333', '3', '495');
INSERT INTO public.who_global_data_import VALUES (12628, '2020-08-17', 'BG', 'Bulgaria', 'EURO', '32', '14365', '3', '498');
INSERT INTO public.who_global_data_import VALUES (12629, '2020-08-18', 'BG', 'Bulgaria', 'EURO', '135', '14500', '14', '512');
INSERT INTO public.who_global_data_import VALUES (12630, '2020-08-19', 'BG', 'Bulgaria', 'EURO', '169', '14669', '7', '519');
INSERT INTO public.who_global_data_import VALUES (12631, '2020-08-20', 'BG', 'Bulgaria', 'EURO', '151', '14820', '8', '527');
INSERT INTO public.who_global_data_import VALUES (12632, '2020-08-21', 'BG', 'Bulgaria', 'EURO', '142', '14962', '5', '532');
INSERT INTO public.who_global_data_import VALUES (12633, '2020-08-22', 'BG', 'Bulgaria', 'EURO', '169', '15131', '7', '539');
INSERT INTO public.who_global_data_import VALUES (12634, '2020-08-23', 'BG', 'Bulgaria', 'EURO', '96', '15227', '6', '545');
INSERT INTO public.who_global_data_import VALUES (12635, '2020-08-24', 'BG', 'Bulgaria', 'EURO', '60', '15287', '0', '545');
INSERT INTO public.who_global_data_import VALUES (12636, '2020-08-25', 'BG', 'Bulgaria', 'EURO', '99', '15386', '18', '563');
INSERT INTO public.who_global_data_import VALUES (12637, '2020-08-26', 'BG', 'Bulgaria', 'EURO', '203', '15589', '9', '572');
INSERT INTO public.who_global_data_import VALUES (12638, '2020-08-27', 'BG', 'Bulgaria', 'EURO', '162', '15751', '14', '586');
INSERT INTO public.who_global_data_import VALUES (12639, '2020-08-28', 'BG', 'Bulgaria', 'EURO', '157', '15908', '8', '594');
INSERT INTO public.who_global_data_import VALUES (12640, '2020-08-29', 'BG', 'Bulgaria', 'EURO', '157', '16065', '9', '603');
INSERT INTO public.who_global_data_import VALUES (12641, '2020-08-30', 'BG', 'Bulgaria', 'EURO', '99', '16164', '2', '605');
INSERT INTO public.who_global_data_import VALUES (12642, '2020-08-31', 'BG', 'Bulgaria', 'EURO', '26', '16190', '8', '613');
INSERT INTO public.who_global_data_import VALUES (12643, '2020-09-01', 'BG', 'Bulgaria', 'EURO', '76', '16266', '16', '629');
INSERT INTO public.who_global_data_import VALUES (12644, '2020-09-02', 'BG', 'Bulgaria', 'EURO', '0', '16266', '0', '629');
INSERT INTO public.who_global_data_import VALUES (12645, '2020-09-03', 'BG', 'Bulgaria', 'EURO', '188', '16454', '13', '642');
INSERT INTO public.who_global_data_import VALUES (12646, '2020-09-04', 'BG', 'Bulgaria', 'EURO', '163', '16617', '6', '648');
INSERT INTO public.who_global_data_import VALUES (12647, '2020-09-05', 'BG', 'Bulgaria', 'EURO', '158', '16775', '10', '658');
INSERT INTO public.who_global_data_import VALUES (12648, '2020-09-06', 'BG', 'Bulgaria', 'EURO', '179', '16954', '7', '665');
INSERT INTO public.who_global_data_import VALUES (12649, '2020-09-07', 'BG', 'Bulgaria', 'EURO', '96', '17050', '6', '671');
INSERT INTO public.who_global_data_import VALUES (12650, '2020-09-08', 'BG', 'Bulgaria', 'EURO', '96', '17146', '6', '677');
INSERT INTO public.who_global_data_import VALUES (12651, '2020-09-09', 'BG', 'Bulgaria', 'EURO', '167', '17313', '15', '692');
INSERT INTO public.who_global_data_import VALUES (12652, '2020-09-10', 'BG', 'Bulgaria', 'EURO', '122', '17435', '10', '702');
INSERT INTO public.who_global_data_import VALUES (12653, '2020-09-11', 'BG', 'Bulgaria', 'EURO', '163', '17598', '4', '706');
INSERT INTO public.who_global_data_import VALUES (12654, '2020-09-12', 'BG', 'Bulgaria', 'EURO', '201', '17799', '7', '713');
INSERT INTO public.who_global_data_import VALUES (12655, '2020-09-13', 'BG', 'Bulgaria', 'EURO', '92', '17891', '4', '717');
INSERT INTO public.who_global_data_import VALUES (12656, '2020-09-14', 'BG', 'Bulgaria', 'EURO', '27', '17918', '3', '720');
INSERT INTO public.who_global_data_import VALUES (12657, '2020-09-15', 'BG', 'Bulgaria', 'EURO', '143', '18061', '10', '730');
INSERT INTO public.who_global_data_import VALUES (12658, '2020-09-16', 'BG', 'Bulgaria', 'EURO', '155', '18216', '6', '736');
INSERT INTO public.who_global_data_import VALUES (12659, '2020-09-17', 'BG', 'Bulgaria', 'EURO', '174', '18390', '8', '744');
INSERT INTO public.who_global_data_import VALUES (12660, '2020-09-18', 'BG', 'Bulgaria', 'EURO', '154', '18544', '0', '744');
INSERT INTO public.who_global_data_import VALUES (12661, '2020-09-19', 'BG', 'Bulgaria', 'EURO', '189', '18733', '9', '753');
INSERT INTO public.who_global_data_import VALUES (12662, '2020-09-20', 'BG', 'Bulgaria', 'EURO', '86', '18819', '2', '755');
INSERT INTO public.who_global_data_import VALUES (13289, '2020-03-31', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12663, '2020-09-21', 'BG', 'Bulgaria', 'EURO', '44', '18863', '6', '761');
INSERT INTO public.who_global_data_import VALUES (12664, '2020-09-22', 'BG', 'Bulgaria', 'EURO', '151', '19014', '4', '765');
INSERT INTO public.who_global_data_import VALUES (12665, '2020-09-23', 'BG', 'Bulgaria', 'EURO', '109', '19123', '2', '767');
INSERT INTO public.who_global_data_import VALUES (12666, '2020-09-24', 'BG', 'Bulgaria', 'EURO', '160', '19283', '12', '779');
INSERT INTO public.who_global_data_import VALUES (12667, '2020-09-25', 'BG', 'Bulgaria', 'EURO', '290', '19573', '6', '785');
INSERT INTO public.who_global_data_import VALUES (12668, '2020-09-26', 'BG', 'Bulgaria', 'EURO', '255', '19828', '4', '789');
INSERT INTO public.who_global_data_import VALUES (12669, '2020-09-27', 'BG', 'Bulgaria', 'EURO', '169', '19997', '0', '789');
INSERT INTO public.who_global_data_import VALUES (12670, '2020-09-28', 'BG', 'Bulgaria', 'EURO', '58', '20055', '7', '796');
INSERT INTO public.who_global_data_import VALUES (12671, '2020-09-29', 'BG', 'Bulgaria', 'EURO', '216', '20271', '11', '807');
INSERT INTO public.who_global_data_import VALUES (12672, '2020-09-30', 'BG', 'Bulgaria', 'EURO', '276', '20547', '7', '814');
INSERT INTO public.who_global_data_import VALUES (12673, '2020-10-01', 'BG', 'Bulgaria', 'EURO', '286', '20833', '11', '825');
INSERT INTO public.who_global_data_import VALUES (12674, '2020-10-02', 'BG', 'Bulgaria', 'EURO', '263', '21096', '7', '832');
INSERT INTO public.who_global_data_import VALUES (12675, '2020-10-03', 'BG', 'Bulgaria', 'EURO', '240', '21336', '6', '838');
INSERT INTO public.who_global_data_import VALUES (12676, '2020-10-04', 'BG', 'Bulgaria', 'EURO', '182', '21518', '3', '841');
INSERT INTO public.who_global_data_import VALUES (12677, '2020-10-05', 'BG', 'Bulgaria', 'EURO', '69', '21587', '3', '844');
INSERT INTO public.who_global_data_import VALUES (12678, '2020-10-06', 'BG', 'Bulgaria', 'EURO', '283', '21870', '10', '854');
INSERT INTO public.who_global_data_import VALUES (12679, '2020-10-07', 'BG', 'Bulgaria', 'EURO', '436', '22306', '8', '862');
INSERT INTO public.who_global_data_import VALUES (12680, '2020-10-08', 'BG', 'Bulgaria', 'EURO', '437', '22743', '11', '873');
INSERT INTO public.who_global_data_import VALUES (12681, '2020-10-09', 'BG', 'Bulgaria', 'EURO', '516', '23259', '7', '880');
INSERT INTO public.who_global_data_import VALUES (12682, '2020-10-10', 'BG', 'Bulgaria', 'EURO', '612', '23871', '7', '887');
INSERT INTO public.who_global_data_import VALUES (12683, '2020-10-11', 'BG', 'Bulgaria', 'EURO', '0', '23871', '0', '887');
INSERT INTO public.who_global_data_import VALUES (12684, '2020-10-12', 'BG', 'Bulgaria', 'EURO', '531', '24402', '5', '892');
INSERT INTO public.who_global_data_import VALUES (12685, '2020-10-13', 'BG', 'Bulgaria', 'EURO', '587', '24989', '23', '915');
INSERT INTO public.who_global_data_import VALUES (12686, '2020-10-14', 'BG', 'Bulgaria', 'EURO', '785', '25774', '8', '923');
INSERT INTO public.who_global_data_import VALUES (12687, '2020-10-15', 'BG', 'Bulgaria', 'EURO', '819', '26593', '6', '929');
INSERT INTO public.who_global_data_import VALUES (12688, '2020-10-16', 'BG', 'Bulgaria', 'EURO', '914', '27507', '15', '944');
INSERT INTO public.who_global_data_import VALUES (12689, '2020-10-17', 'BG', 'Bulgaria', 'EURO', '998', '28505', '14', '958');
INSERT INTO public.who_global_data_import VALUES (12690, '2020-10-18', 'BG', 'Bulgaria', 'EURO', '603', '29108', '10', '968');
INSERT INTO public.who_global_data_import VALUES (12691, '2020-10-19', 'BG', 'Bulgaria', 'EURO', '395', '29503', '18', '986');
INSERT INTO public.who_global_data_import VALUES (12692, '2020-10-20', 'BG', 'Bulgaria', 'EURO', '1024', '30527', '22', '1008');
INSERT INTO public.who_global_data_import VALUES (12693, '2020-10-21', 'BG', 'Bulgaria', 'EURO', '1336', '31863', '11', '1019');
INSERT INTO public.who_global_data_import VALUES (12694, '2020-10-22', 'BG', 'Bulgaria', 'EURO', '1472', '33335', '29', '1048');
INSERT INTO public.who_global_data_import VALUES (12695, '2020-10-23', 'BG', 'Bulgaria', 'EURO', '1595', '34930', '16', '1064');
INSERT INTO public.who_global_data_import VALUES (12696, '2020-10-24', 'BG', 'Bulgaria', 'EURO', '1589', '36519', '13', '1077');
INSERT INTO public.who_global_data_import VALUES (12697, '2020-10-25', 'BG', 'Bulgaria', 'EURO', '1043', '37562', '7', '1084');
INSERT INTO public.who_global_data_import VALUES (12698, '2020-10-26', 'BG', 'Bulgaria', 'EURO', '327', '37889', '10', '1094');
INSERT INTO public.who_global_data_import VALUES (12699, '2020-10-27', 'BG', 'Bulgaria', 'EURO', '2243', '40132', '42', '1136');
INSERT INTO public.who_global_data_import VALUES (12700, '2020-10-28', 'BG', 'Bulgaria', 'EURO', '2569', '42701', '25', '1161');
INSERT INTO public.who_global_data_import VALUES (12701, '2020-10-29', 'BG', 'Bulgaria', 'EURO', '2760', '45461', '36', '1197');
INSERT INTO public.who_global_data_import VALUES (12702, '2020-10-30', 'BG', 'Bulgaria', 'EURO', '2689', '48150', '28', '1225');
INSERT INTO public.who_global_data_import VALUES (12703, '2020-10-31', 'BG', 'Bulgaria', 'EURO', '2891', '51041', '29', '1254');
INSERT INTO public.who_global_data_import VALUES (12704, '2020-11-01', 'BG', 'Bulgaria', 'EURO', '1803', '52844', '25', '1279');
INSERT INTO public.who_global_data_import VALUES (12705, '2020-11-02', 'BG', 'Bulgaria', 'EURO', '1225', '54069', '19', '1298');
INSERT INTO public.who_global_data_import VALUES (12706, '2020-11-03', 'BG', 'Bulgaria', 'EURO', '2427', '56496', '51', '1349');
INSERT INTO public.who_global_data_import VALUES (12707, '2020-11-04', 'BG', 'Bulgaria', 'EURO', '4041', '60537', '63', '1412');
INSERT INTO public.who_global_data_import VALUES (12708, '2020-11-05', 'BG', 'Bulgaria', 'EURO', '4054', '64591', '54', '1466');
INSERT INTO public.who_global_data_import VALUES (12709, '2020-11-06', 'BG', 'Bulgaria', 'EURO', '3754', '68345', '52', '1518');
INSERT INTO public.who_global_data_import VALUES (12710, '2020-11-07', 'BG', 'Bulgaria', 'EURO', '3839', '72184', '58', '1576');
INSERT INTO public.who_global_data_import VALUES (12711, '2020-11-08', 'BG', 'Bulgaria', 'EURO', '2301', '74485', '56', '1632');
INSERT INTO public.who_global_data_import VALUES (12712, '2020-11-09', 'BG', 'Bulgaria', 'EURO', '675', '75160', '33', '1665');
INSERT INTO public.who_global_data_import VALUES (12713, '2020-11-10', 'BG', 'Bulgaria', 'EURO', '3816', '78976', '106', '1771');
INSERT INTO public.who_global_data_import VALUES (12714, '2020-11-11', 'BG', 'Bulgaria', 'EURO', '4390', '83366', '80', '1851');
INSERT INTO public.who_global_data_import VALUES (12715, '2020-11-12', 'BG', 'Bulgaria', 'EURO', '3945', '87311', '47', '1898');
INSERT INTO public.who_global_data_import VALUES (12716, '2020-11-13', 'BG', 'Bulgaria', 'EURO', '3414', '90725', '72', '1970');
INSERT INTO public.who_global_data_import VALUES (12717, '2020-11-14', 'BG', 'Bulgaria', 'EURO', '4212', '94937', '85', '2055');
INSERT INTO public.who_global_data_import VALUES (12718, '2020-11-15', 'BG', 'Bulgaria', 'EURO', '2498', '97435', '36', '2091');
INSERT INTO public.who_global_data_import VALUES (12719, '2020-11-16', 'BG', 'Bulgaria', 'EURO', '816', '98251', '39', '2130');
INSERT INTO public.who_global_data_import VALUES (12720, '2020-11-17', 'BG', 'Bulgaria', 'EURO', '3519', '101770', '152', '2282');
INSERT INTO public.who_global_data_import VALUES (12721, '2020-11-18', 'BG', 'Bulgaria', 'EURO', '4828', '106598', '131', '2413');
INSERT INTO public.who_global_data_import VALUES (12722, '2020-11-19', 'BG', 'Bulgaria', 'EURO', '3938', '110536', '117', '2530');
INSERT INTO public.who_global_data_import VALUES (12723, '2020-11-20', 'BG', 'Bulgaria', 'EURO', '3899', '114435', '119', '2649');
INSERT INTO public.who_global_data_import VALUES (12724, '2020-11-21', 'BG', 'Bulgaria', 'EURO', '3983', '118418', '129', '2778');
INSERT INTO public.who_global_data_import VALUES (12725, '2020-11-22', 'BG', 'Bulgaria', 'EURO', '2279', '120697', '42', '2820');
INSERT INTO public.who_global_data_import VALUES (12726, '2020-11-23', 'BG', 'Bulgaria', 'EURO', '1123', '121820', '60', '2880');
INSERT INTO public.who_global_data_import VALUES (12727, '2020-11-24', 'BG', 'Bulgaria', 'EURO', '3146', '124966', '189', '3069');
INSERT INTO public.who_global_data_import VALUES (12728, '2020-11-25', 'BG', 'Bulgaria', 'EURO', '4382', '129348', '157', '3226');
INSERT INTO public.who_global_data_import VALUES (12729, '2020-11-26', 'BG', 'Bulgaria', 'EURO', '3712', '133060', '141', '3367');
INSERT INTO public.who_global_data_import VALUES (12730, '2020-11-27', 'BG', 'Bulgaria', 'EURO', '3568', '136628', '162', '3529');
INSERT INTO public.who_global_data_import VALUES (12731, '2020-11-28', 'BG', 'Bulgaria', 'EURO', '3327', '139955', '151', '3680');
INSERT INTO public.who_global_data_import VALUES (12732, '2020-11-29', 'BG', 'Bulgaria', 'EURO', '1792', '141747', '69', '3749');
INSERT INTO public.who_global_data_import VALUES (12733, '2020-11-30', 'BG', 'Bulgaria', 'EURO', '739', '142486', '65', '3814');
INSERT INTO public.who_global_data_import VALUES (12734, '2020-12-01', 'BG', 'Bulgaria', 'EURO', '2814', '145300', '221', '4035');
INSERT INTO public.who_global_data_import VALUES (12735, '2020-12-02', 'BG', 'Bulgaria', 'EURO', '3475', '148775', '153', '4188');
INSERT INTO public.who_global_data_import VALUES (12736, '2020-12-03', 'BG', 'Bulgaria', 'EURO', '3138', '151913', '159', '4347');
INSERT INTO public.who_global_data_import VALUES (12737, '2020-12-04', 'BG', 'Bulgaria', 'EURO', '3280', '155193', '156', '4503');
INSERT INTO public.who_global_data_import VALUES (12738, '2020-12-05', 'BG', 'Bulgaria', 'EURO', '3614', '158807', '147', '4650');
INSERT INTO public.who_global_data_import VALUES (12739, '2020-12-06', 'BG', 'Bulgaria', 'EURO', '2037', '160844', '79', '4729');
INSERT INTO public.who_global_data_import VALUES (12740, '2020-12-07', 'BG', 'Bulgaria', 'EURO', '577', '161421', '68', '4797');
INSERT INTO public.who_global_data_import VALUES (12741, '2020-12-08', 'BG', 'Bulgaria', 'EURO', '2764', '164185', '213', '5010');
INSERT INTO public.who_global_data_import VALUES (12742, '2020-12-09', 'BG', 'Bulgaria', 'EURO', '3980', '168165', '146', '5156');
INSERT INTO public.who_global_data_import VALUES (12743, '2020-12-10', 'BG', 'Bulgaria', 'EURO', '3328', '171493', '127', '5283');
INSERT INTO public.who_global_data_import VALUES (12744, '2020-12-11', 'BG', 'Bulgaria', 'EURO', '3075', '174568', '122', '5405');
INSERT INTO public.who_global_data_import VALUES (12745, '2020-12-12', 'BG', 'Bulgaria', 'EURO', '3097', '177665', '157', '5562');
INSERT INTO public.who_global_data_import VALUES (12746, '2020-12-13', 'BG', 'Bulgaria', 'EURO', '1287', '178952', '64', '5626');
INSERT INTO public.who_global_data_import VALUES (12747, '2020-12-14', 'BG', 'Bulgaria', 'EURO', '497', '179449', '62', '5688');
INSERT INTO public.who_global_data_import VALUES (12748, '2020-12-15', 'BG', 'Bulgaria', 'EURO', '2095', '181544', '150', '5838');
INSERT INTO public.who_global_data_import VALUES (12749, '2020-12-16', 'BG', 'Bulgaria', 'EURO', '2743', '184287', '167', '6005');
INSERT INTO public.who_global_data_import VALUES (12750, '2020-12-17', 'BG', 'Bulgaria', 'EURO', '1959', '186246', '191', '6196');
INSERT INTO public.who_global_data_import VALUES (12751, '2020-12-18', 'BG', 'Bulgaria', 'EURO', '2042', '188288', '143', '6339');
INSERT INTO public.who_global_data_import VALUES (12752, '2020-12-19', 'BG', 'Bulgaria', 'EURO', '1739', '190027', '157', '6496');
INSERT INTO public.who_global_data_import VALUES (12753, '2020-12-20', 'BG', 'Bulgaria', 'EURO', '1002', '191029', '55', '6551');
INSERT INTO public.who_global_data_import VALUES (12754, '2020-12-21', 'BG', 'Bulgaria', 'EURO', '166', '191195', '58', '6609');
INSERT INTO public.who_global_data_import VALUES (12755, '2020-12-22', 'BG', 'Bulgaria', 'EURO', '1277', '192472', '156', '6765');
INSERT INTO public.who_global_data_import VALUES (12756, '2020-12-23', 'BG', 'Bulgaria', 'EURO', '1799', '194271', '114', '6879');
INSERT INTO public.who_global_data_import VALUES (12757, '2020-12-24', 'BG', 'Bulgaria', 'EURO', '1615', '195886', '99', '6978');
INSERT INTO public.who_global_data_import VALUES (12758, '2020-12-25', 'BG', 'Bulgaria', 'EURO', '772', '196658', '45', '7023');
INSERT INTO public.who_global_data_import VALUES (12759, '2020-12-26', 'BG', 'Bulgaria', 'EURO', '257', '196915', '50', '7073');
INSERT INTO public.who_global_data_import VALUES (12760, '2020-12-27', 'BG', 'Bulgaria', 'EURO', '469', '197384', '50', '7123');
INSERT INTO public.who_global_data_import VALUES (12761, '2020-12-28', 'BG', 'Bulgaria', 'EURO', '332', '197716', '41', '7164');
INSERT INTO public.who_global_data_import VALUES (12762, '2020-12-29', 'BG', 'Bulgaria', 'EURO', '337', '198053', '87', '7251');
INSERT INTO public.who_global_data_import VALUES (12763, '2020-12-30', 'BG', 'Bulgaria', 'EURO', '1438', '199491', '154', '7405');
INSERT INTO public.who_global_data_import VALUES (12764, '2020-12-31', 'BG', 'Bulgaria', 'EURO', '1729', '201220', '110', '7515');
INSERT INTO public.who_global_data_import VALUES (12765, '2021-01-01', 'BG', 'Bulgaria', 'EURO', '1046', '202266', '61', '7576');
INSERT INTO public.who_global_data_import VALUES (12766, '2021-01-02', 'BG', 'Bulgaria', 'EURO', '274', '202540', '28', '7604');
INSERT INTO public.who_global_data_import VALUES (12767, '2021-01-03', 'BG', 'Bulgaria', 'EURO', '340', '202880', '40', '7644');
INSERT INTO public.who_global_data_import VALUES (12768, '2021-01-04', 'BG', 'Bulgaria', 'EURO', '171', '203051', '34', '7678');
INSERT INTO public.who_global_data_import VALUES (12769, '2021-01-05', 'BG', 'Bulgaria', 'EURO', '1029', '204080', '157', '7835');
INSERT INTO public.who_global_data_import VALUES (12770, '2021-01-06', 'BG', 'Bulgaria', 'EURO', '1310', '205390', '67', '7902');
INSERT INTO public.who_global_data_import VALUES (12771, '2021-01-07', 'BG', 'Bulgaria', 'EURO', '1002', '206392', '59', '7961');
INSERT INTO public.who_global_data_import VALUES (12772, '2021-01-08', 'BG', 'Bulgaria', 'EURO', '867', '207259', '56', '8017');
INSERT INTO public.who_global_data_import VALUES (12773, '2021-01-09', 'BG', 'Bulgaria', 'EURO', '753', '208012', '61', '8078');
INSERT INTO public.who_global_data_import VALUES (12774, '2021-01-10', 'BG', 'Bulgaria', 'EURO', '394', '208406', '19', '8097');
INSERT INTO public.who_global_data_import VALUES (12775, '2021-01-11', 'BG', 'Bulgaria', 'EURO', '105', '208511', '29', '8126');
INSERT INTO public.who_global_data_import VALUES (12776, '2021-01-12', 'BG', 'Bulgaria', 'EURO', '620', '209131', '106', '8232');
INSERT INTO public.who_global_data_import VALUES (12777, '2021-01-13', 'BG', 'Bulgaria', 'EURO', '750', '209881', '47', '8279');
INSERT INTO public.who_global_data_import VALUES (12778, '2021-01-14', 'BG', 'Bulgaria', 'EURO', '535', '210416', '70', '8349');
INSERT INTO public.who_global_data_import VALUES (12779, '2021-01-15', 'BG', 'Bulgaria', 'EURO', '535', '210951', '47', '8396');
INSERT INTO public.who_global_data_import VALUES (12780, '2021-01-16', 'BG', 'Bulgaria', 'EURO', '552', '211503', '61', '8457');
INSERT INTO public.who_global_data_import VALUES (12781, '2021-01-17', 'BG', 'Bulgaria', 'EURO', '233', '211736', '17', '8474');
INSERT INTO public.who_global_data_import VALUES (12782, '2021-01-18', 'BG', 'Bulgaria', 'EURO', '77', '211813', '9', '8483');
INSERT INTO public.who_global_data_import VALUES (12783, '2021-01-19', 'BG', 'Bulgaria', 'EURO', '570', '212383', '82', '8565');
INSERT INTO public.who_global_data_import VALUES (12784, '2021-01-20', 'BG', 'Bulgaria', 'EURO', '544', '212927', '49', '8614');
INSERT INTO public.who_global_data_import VALUES (12785, '2021-01-21', 'BG', 'Bulgaria', 'EURO', '482', '213409', '37', '8651');
INSERT INTO public.who_global_data_import VALUES (12786, '2021-01-22', 'BG', 'Bulgaria', 'EURO', '455', '213864', '90', '8741');
INSERT INTO public.who_global_data_import VALUES (12787, '2021-01-23', 'BG', 'Bulgaria', 'EURO', '566', '214430', '58', '8799');
INSERT INTO public.who_global_data_import VALUES (12788, '2021-01-24', 'BG', 'Bulgaria', 'EURO', '266', '214696', '12', '8811');
INSERT INTO public.who_global_data_import VALUES (12789, '2021-01-25', 'BG', 'Bulgaria', 'EURO', '121', '214817', '9', '8820');
INSERT INTO public.who_global_data_import VALUES (12790, '2021-01-26', 'BG', 'Bulgaria', 'EURO', '772', '215589', '60', '8880');
INSERT INTO public.who_global_data_import VALUES (12791, '2021-01-27', 'BG', 'Bulgaria', 'EURO', '827', '216416', '36', '8916');
INSERT INTO public.who_global_data_import VALUES (12792, '2021-01-28', 'BG', 'Bulgaria', 'EURO', '598', '217014', '28', '8944');
INSERT INTO public.who_global_data_import VALUES (12793, '2021-01-29', 'BG', 'Bulgaria', 'EURO', '560', '217574', '29', '8973');
INSERT INTO public.who_global_data_import VALUES (12794, '2021-01-30', 'BG', 'Bulgaria', 'EURO', '695', '218269', '35', '9008');
INSERT INTO public.who_global_data_import VALUES (12795, '2021-01-31', 'BG', 'Bulgaria', 'EURO', '349', '218618', '20', '9028');
INSERT INTO public.who_global_data_import VALUES (12796, '2021-02-01', 'BG', 'Bulgaria', 'EURO', '130', '218748', '17', '9045');
INSERT INTO public.who_global_data_import VALUES (12797, '2021-02-02', 'BG', 'Bulgaria', 'EURO', '832', '219580', '97', '9142');
INSERT INTO public.who_global_data_import VALUES (12798, '2021-02-03', 'BG', 'Bulgaria', 'EURO', '967', '220547', '36', '9178');
INSERT INTO public.who_global_data_import VALUES (12799, '2021-02-04', 'BG', 'Bulgaria', 'EURO', '719', '221266', '40', '9218');
INSERT INTO public.who_global_data_import VALUES (12800, '2021-02-05', 'BG', 'Bulgaria', 'EURO', '883', '222149', '54', '9272');
INSERT INTO public.who_global_data_import VALUES (12801, '2020-01-03', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12802, '2020-01-04', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12803, '2020-01-05', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12804, '2020-01-06', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12805, '2020-01-07', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12806, '2020-01-08', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12807, '2020-01-09', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12808, '2020-01-10', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12809, '2020-01-11', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12810, '2020-01-12', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12811, '2020-01-13', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12812, '2020-01-14', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12813, '2020-01-15', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12814, '2020-01-16', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12815, '2020-01-17', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12816, '2020-01-18', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12817, '2020-01-19', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12818, '2020-01-20', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12819, '2020-01-21', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12820, '2020-01-22', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12821, '2020-01-23', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12822, '2020-01-24', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12823, '2020-01-25', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12824, '2020-01-26', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12825, '2020-01-27', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12826, '2020-01-28', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12827, '2020-01-29', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12828, '2020-01-30', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12829, '2020-01-31', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12830, '2020-02-01', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12831, '2020-02-02', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12832, '2020-02-03', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12833, '2020-02-04', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12834, '2020-02-05', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12835, '2020-02-06', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12836, '2020-02-07', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12837, '2020-02-08', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12838, '2020-02-09', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12839, '2020-02-10', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12840, '2020-02-11', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12841, '2020-02-12', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12842, '2020-02-13', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12843, '2020-02-14', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12844, '2020-02-15', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12845, '2020-02-16', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12846, '2020-02-17', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12847, '2020-02-18', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12848, '2020-02-19', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12849, '2020-02-20', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12850, '2020-02-21', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12851, '2020-02-22', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12852, '2020-02-23', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12853, '2020-02-24', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12854, '2020-02-25', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12855, '2020-02-26', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12856, '2020-02-27', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12857, '2020-02-28', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12858, '2020-02-29', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12859, '2020-03-01', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12860, '2020-03-02', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12861, '2020-03-03', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12862, '2020-03-04', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12863, '2020-03-05', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12864, '2020-03-06', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12865, '2020-03-07', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12866, '2020-03-08', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12867, '2020-03-09', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12868, '2020-03-10', 'BF', 'Burkina Faso', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12869, '2020-03-11', 'BF', 'Burkina Faso', 'AFRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12870, '2020-03-12', 'BF', 'Burkina Faso', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12871, '2020-03-13', 'BF', 'Burkina Faso', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12872, '2020-03-14', 'BF', 'Burkina Faso', 'AFRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12873, '2020-03-15', 'BF', 'Burkina Faso', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12874, '2020-03-16', 'BF', 'Burkina Faso', 'AFRO', '12', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12875, '2020-03-17', 'BF', 'Burkina Faso', 'AFRO', '5', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (12876, '2020-03-18', 'BF', 'Burkina Faso', 'AFRO', '6', '30', '1', '1');
INSERT INTO public.who_global_data_import VALUES (12877, '2020-03-19', 'BF', 'Burkina Faso', 'AFRO', '14', '44', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12878, '2020-03-20', 'BF', 'Burkina Faso', 'AFRO', '0', '44', '0', '1');
INSERT INTO public.who_global_data_import VALUES (12879, '2020-03-21', 'BF', 'Burkina Faso', 'AFRO', '28', '72', '2', '3');
INSERT INTO public.who_global_data_import VALUES (12880, '2020-03-22', 'BF', 'Burkina Faso', 'AFRO', '3', '75', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12881, '2020-03-23', 'BF', 'Burkina Faso', 'AFRO', '0', '75', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12882, '2020-03-24', 'BF', 'Burkina Faso', 'AFRO', '24', '99', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12883, '2020-03-25', 'BF', 'Burkina Faso', 'AFRO', '15', '114', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12884, '2020-03-26', 'BF', 'Burkina Faso', 'AFRO', '32', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12885, '2020-03-27', 'BF', 'Burkina Faso', 'AFRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12886, '2020-03-28', 'BF', 'Burkina Faso', 'AFRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12887, '2020-03-29', 'BF', 'Burkina Faso', 'AFRO', '0', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (12888, '2020-03-30', 'BF', 'Burkina Faso', 'AFRO', '76', '222', '9', '12');
INSERT INTO public.who_global_data_import VALUES (12889, '2020-03-31', 'BF', 'Burkina Faso', 'AFRO', '24', '246', '0', '12');
INSERT INTO public.who_global_data_import VALUES (12890, '2020-04-01', 'BF', 'Burkina Faso', 'AFRO', '15', '261', '2', '14');
INSERT INTO public.who_global_data_import VALUES (12891, '2020-04-02', 'BF', 'Burkina Faso', 'AFRO', '0', '261', '0', '14');
INSERT INTO public.who_global_data_import VALUES (12892, '2020-04-03', 'BF', 'Burkina Faso', 'AFRO', '0', '261', '1', '15');
INSERT INTO public.who_global_data_import VALUES (12893, '2020-04-04', 'BF', 'Burkina Faso', 'AFRO', '41', '302', '0', '15');
INSERT INTO public.who_global_data_import VALUES (12894, '2020-04-05', 'BF', 'Burkina Faso', 'AFRO', '0', '302', '0', '15');
INSERT INTO public.who_global_data_import VALUES (12895, '2020-04-06', 'BF', 'Burkina Faso', 'AFRO', '43', '345', '2', '17');
INSERT INTO public.who_global_data_import VALUES (12896, '2020-04-07', 'BF', 'Burkina Faso', 'AFRO', '0', '345', '0', '17');
INSERT INTO public.who_global_data_import VALUES (12897, '2020-04-08', 'BF', 'Burkina Faso', 'AFRO', '39', '384', '1', '18');
INSERT INTO public.who_global_data_import VALUES (12898, '2020-04-09', 'BF', 'Burkina Faso', 'AFRO', '0', '384', '1', '19');
INSERT INTO public.who_global_data_import VALUES (12899, '2020-04-10', 'BF', 'Burkina Faso', 'AFRO', '30', '414', '0', '19');
INSERT INTO public.who_global_data_import VALUES (12900, '2020-04-11', 'BF', 'Burkina Faso', 'AFRO', '29', '443', '0', '19');
INSERT INTO public.who_global_data_import VALUES (12901, '2020-04-12', 'BF', 'Burkina Faso', 'AFRO', '0', '443', '0', '19');
INSERT INTO public.who_global_data_import VALUES (12902, '2020-04-13', 'BF', 'Burkina Faso', 'AFRO', '0', '443', '0', '19');
INSERT INTO public.who_global_data_import VALUES (12903, '2020-04-14', 'BF', 'Burkina Faso', 'AFRO', '54', '497', '8', '27');
INSERT INTO public.who_global_data_import VALUES (12904, '2020-04-15', 'BF', 'Burkina Faso', 'AFRO', '18', '515', '1', '28');
INSERT INTO public.who_global_data_import VALUES (12905, '2020-04-16', 'BF', 'Burkina Faso', 'AFRO', '13', '528', '0', '28');
INSERT INTO public.who_global_data_import VALUES (12906, '2020-04-17', 'BF', 'Burkina Faso', 'AFRO', '15', '543', '4', '32');
INSERT INTO public.who_global_data_import VALUES (12907, '2020-04-18', 'BF', 'Burkina Faso', 'AFRO', '4', '547', '0', '32');
INSERT INTO public.who_global_data_import VALUES (12908, '2020-04-19', 'BF', 'Burkina Faso', 'AFRO', '0', '547', '0', '32');
INSERT INTO public.who_global_data_import VALUES (12909, '2020-04-20', 'BF', 'Burkina Faso', 'AFRO', '18', '565', '4', '36');
INSERT INTO public.who_global_data_import VALUES (12910, '2020-04-21', 'BF', 'Burkina Faso', 'AFRO', '11', '576', '0', '36');
INSERT INTO public.who_global_data_import VALUES (12911, '2020-04-22', 'BF', 'Burkina Faso', 'AFRO', '5', '581', '2', '38');
INSERT INTO public.who_global_data_import VALUES (12912, '2020-04-23', 'BF', 'Burkina Faso', 'AFRO', '19', '600', '0', '38');
INSERT INTO public.who_global_data_import VALUES (12913, '2020-04-24', 'BF', 'Burkina Faso', 'AFRO', '0', '600', '0', '38');
INSERT INTO public.who_global_data_import VALUES (12914, '2020-04-25', 'BF', 'Burkina Faso', 'AFRO', '16', '616', '3', '41');
INSERT INTO public.who_global_data_import VALUES (12915, '2020-04-26', 'BF', 'Burkina Faso', 'AFRO', '13', '629', '0', '41');
INSERT INTO public.who_global_data_import VALUES (12916, '2020-04-27', 'BF', 'Burkina Faso', 'AFRO', '3', '632', '1', '42');
INSERT INTO public.who_global_data_import VALUES (12917, '2020-04-28', 'BF', 'Burkina Faso', 'AFRO', '0', '632', '0', '42');
INSERT INTO public.who_global_data_import VALUES (12918, '2020-04-29', 'BF', 'Burkina Faso', 'AFRO', '6', '638', '0', '42');
INSERT INTO public.who_global_data_import VALUES (12919, '2020-04-30', 'BF', 'Burkina Faso', 'AFRO', '0', '638', '0', '42');
INSERT INTO public.who_global_data_import VALUES (12920, '2020-05-01', 'BF', 'Burkina Faso', 'AFRO', '7', '645', '1', '43');
INSERT INTO public.who_global_data_import VALUES (12921, '2020-05-02', 'BF', 'Burkina Faso', 'AFRO', '4', '649', '1', '44');
INSERT INTO public.who_global_data_import VALUES (12922, '2020-05-03', 'BF', 'Burkina Faso', 'AFRO', '3', '652', '0', '44');
INSERT INTO public.who_global_data_import VALUES (12923, '2020-05-04', 'BF', 'Burkina Faso', 'AFRO', '10', '662', '1', '45');
INSERT INTO public.who_global_data_import VALUES (12924, '2020-05-05', 'BF', 'Burkina Faso', 'AFRO', '10', '672', '1', '46');
INSERT INTO public.who_global_data_import VALUES (12925, '2020-05-06', 'BF', 'Burkina Faso', 'AFRO', '17', '689', '2', '48');
INSERT INTO public.who_global_data_import VALUES (12926, '2020-05-07', 'BF', 'Burkina Faso', 'AFRO', '40', '729', '0', '48');
INSERT INTO public.who_global_data_import VALUES (12927, '2020-05-08', 'BF', 'Burkina Faso', 'AFRO', '7', '736', '0', '48');
INSERT INTO public.who_global_data_import VALUES (12928, '2020-05-09', 'BF', 'Burkina Faso', 'AFRO', '0', '736', '0', '48');
INSERT INTO public.who_global_data_import VALUES (12929, '2020-05-10', 'BF', 'Burkina Faso', 'AFRO', '12', '748', '0', '48');
INSERT INTO public.who_global_data_import VALUES (12930, '2020-05-11', 'BF', 'Burkina Faso', 'AFRO', '3', '751', '1', '49');
INSERT INTO public.who_global_data_import VALUES (12931, '2020-05-12', 'BF', 'Burkina Faso', 'AFRO', '9', '760', '1', '50');
INSERT INTO public.who_global_data_import VALUES (12932, '2020-05-13', 'BF', 'Burkina Faso', 'AFRO', '6', '766', '1', '51');
INSERT INTO public.who_global_data_import VALUES (12933, '2020-05-14', 'BF', 'Burkina Faso', 'AFRO', '7', '773', '0', '51');
INSERT INTO public.who_global_data_import VALUES (12934, '2020-05-15', 'BF', 'Burkina Faso', 'AFRO', '0', '773', '0', '51');
INSERT INTO public.who_global_data_import VALUES (12935, '2020-05-16', 'BF', 'Burkina Faso', 'AFRO', '7', '780', '0', '51');
INSERT INTO public.who_global_data_import VALUES (12936, '2020-05-17', 'BF', 'Burkina Faso', 'AFRO', '2', '782', '0', '51');
INSERT INTO public.who_global_data_import VALUES (12937, '2020-05-18', 'BF', 'Burkina Faso', 'AFRO', '14', '796', '0', '51');
INSERT INTO public.who_global_data_import VALUES (12938, '2020-05-19', 'BF', 'Burkina Faso', 'AFRO', '0', '796', '0', '51');
INSERT INTO public.who_global_data_import VALUES (12939, '2020-05-20', 'BF', 'Burkina Faso', 'AFRO', '10', '806', '1', '52');
INSERT INTO public.who_global_data_import VALUES (12940, '2020-05-21', 'BF', 'Burkina Faso', 'AFRO', '3', '809', '0', '52');
INSERT INTO public.who_global_data_import VALUES (12941, '2020-05-22', 'BF', 'Burkina Faso', 'AFRO', '3', '812', '0', '52');
INSERT INTO public.who_global_data_import VALUES (12942, '2020-05-23', 'BF', 'Burkina Faso', 'AFRO', '2', '814', '0', '52');
INSERT INTO public.who_global_data_import VALUES (12943, '2020-05-24', 'BF', 'Burkina Faso', 'AFRO', '17', '831', '0', '52');
INSERT INTO public.who_global_data_import VALUES (12944, '2020-05-25', 'BF', 'Burkina Faso', 'AFRO', '1', '832', '0', '52');
INSERT INTO public.who_global_data_import VALUES (12945, '2020-05-26', 'BF', 'Burkina Faso', 'AFRO', '9', '841', '0', '52');
INSERT INTO public.who_global_data_import VALUES (12946, '2020-05-27', 'BF', 'Burkina Faso', 'AFRO', '4', '845', '1', '53');
INSERT INTO public.who_global_data_import VALUES (12947, '2020-05-28', 'BF', 'Burkina Faso', 'AFRO', '0', '845', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12948, '2020-05-29', 'BF', 'Burkina Faso', 'AFRO', '2', '847', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12949, '2020-05-30', 'BF', 'Burkina Faso', 'AFRO', '0', '847', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12950, '2020-05-31', 'BF', 'Burkina Faso', 'AFRO', '6', '853', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12951, '2020-06-01', 'BF', 'Burkina Faso', 'AFRO', '28', '881', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12952, '2020-06-02', 'BF', 'Burkina Faso', 'AFRO', '2', '883', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12953, '2020-06-03', 'BF', 'Burkina Faso', 'AFRO', '1', '884', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12954, '2020-06-04', 'BF', 'Burkina Faso', 'AFRO', '0', '884', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12955, '2020-06-05', 'BF', 'Burkina Faso', 'AFRO', '1', '885', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12956, '2020-06-06', 'BF', 'Burkina Faso', 'AFRO', '0', '885', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12957, '2020-06-07', 'BF', 'Burkina Faso', 'AFRO', '3', '888', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12958, '2020-06-08', 'BF', 'Burkina Faso', 'AFRO', '0', '888', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12959, '2020-06-09', 'BF', 'Burkina Faso', 'AFRO', '2', '890', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12960, '2020-06-10', 'BF', 'Burkina Faso', 'AFRO', '1', '891', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12961, '2020-06-11', 'BF', 'Burkina Faso', 'AFRO', '0', '891', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12962, '2020-06-12', 'BF', 'Burkina Faso', 'AFRO', '0', '891', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12963, '2020-06-13', 'BF', 'Burkina Faso', 'AFRO', '1', '892', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12964, '2020-06-14', 'BF', 'Burkina Faso', 'AFRO', '0', '892', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12965, '2020-06-15', 'BF', 'Burkina Faso', 'AFRO', '2', '894', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12966, '2020-06-16', 'BF', 'Burkina Faso', 'AFRO', '0', '894', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12967, '2020-06-17', 'BF', 'Burkina Faso', 'AFRO', '1', '895', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12968, '2020-06-18', 'BF', 'Burkina Faso', 'AFRO', '4', '899', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12969, '2020-06-19', 'BF', 'Burkina Faso', 'AFRO', '0', '899', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12970, '2020-06-20', 'BF', 'Burkina Faso', 'AFRO', '2', '901', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12971, '2020-06-21', 'BF', 'Burkina Faso', 'AFRO', '0', '901', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12972, '2020-06-22', 'BF', 'Burkina Faso', 'AFRO', '0', '901', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12973, '2020-06-23', 'BF', 'Burkina Faso', 'AFRO', '2', '903', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12974, '2020-06-24', 'BF', 'Burkina Faso', 'AFRO', '0', '903', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12975, '2020-06-25', 'BF', 'Burkina Faso', 'AFRO', '31', '934', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12976, '2020-06-26', 'BF', 'Burkina Faso', 'AFRO', '0', '934', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12977, '2020-06-27', 'BF', 'Burkina Faso', 'AFRO', '0', '934', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12978, '2020-06-28', 'BF', 'Burkina Faso', 'AFRO', '20', '954', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12979, '2020-06-29', 'BF', 'Burkina Faso', 'AFRO', '5', '959', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12980, '2020-06-30', 'BF', 'Burkina Faso', 'AFRO', '0', '959', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12981, '2020-07-01', 'BF', 'Burkina Faso', 'AFRO', '3', '962', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12982, '2020-07-02', 'BF', 'Burkina Faso', 'AFRO', '0', '962', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12983, '2020-07-03', 'BF', 'Burkina Faso', 'AFRO', '5', '967', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12984, '2020-07-04', 'BF', 'Burkina Faso', 'AFRO', '13', '980', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12985, '2020-07-05', 'BF', 'Burkina Faso', 'AFRO', '7', '987', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12986, '2020-07-06', 'BF', 'Burkina Faso', 'AFRO', '13', '1000', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12987, '2020-07-07', 'BF', 'Burkina Faso', 'AFRO', '0', '1000', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12988, '2020-07-08', 'BF', 'Burkina Faso', 'AFRO', '3', '1003', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12989, '2020-07-09', 'BF', 'Burkina Faso', 'AFRO', '0', '1003', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12990, '2020-07-10', 'BF', 'Burkina Faso', 'AFRO', '2', '1005', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12991, '2020-07-11', 'BF', 'Burkina Faso', 'AFRO', '15', '1020', '1', '54');
INSERT INTO public.who_global_data_import VALUES (12992, '2020-07-12', 'BF', 'Burkina Faso', 'AFRO', '0', '1020', '0', '54');
INSERT INTO public.who_global_data_import VALUES (12993, '2020-07-13', 'BF', 'Burkina Faso', 'AFRO', '13', '1033', '-1', '53');
INSERT INTO public.who_global_data_import VALUES (12994, '2020-07-14', 'BF', 'Burkina Faso', 'AFRO', '3', '1036', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12995, '2020-07-15', 'BF', 'Burkina Faso', 'AFRO', '1', '1037', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12996, '2020-07-16', 'BF', 'Burkina Faso', 'AFRO', '1', '1038', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12997, '2020-07-17', 'BF', 'Burkina Faso', 'AFRO', '0', '1038', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12998, '2020-07-18', 'BF', 'Burkina Faso', 'AFRO', '7', '1045', '0', '53');
INSERT INTO public.who_global_data_import VALUES (12999, '2020-07-19', 'BF', 'Burkina Faso', 'AFRO', '2', '1047', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13000, '2020-07-20', 'BF', 'Burkina Faso', 'AFRO', '18', '1065', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13001, '2020-07-21', 'BF', 'Burkina Faso', 'AFRO', '0', '1065', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13002, '2020-07-22', 'BF', 'Burkina Faso', 'AFRO', '0', '1065', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13003, '2020-07-23', 'BF', 'Burkina Faso', 'AFRO', '1', '1066', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13004, '2020-07-24', 'BF', 'Burkina Faso', 'AFRO', '4', '1070', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13005, '2020-07-25', 'BF', 'Burkina Faso', 'AFRO', '5', '1075', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13006, '2020-07-26', 'BF', 'Burkina Faso', 'AFRO', '6', '1081', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13007, '2020-07-27', 'BF', 'Burkina Faso', 'AFRO', '5', '1086', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13008, '2020-07-28', 'BF', 'Burkina Faso', 'AFRO', '14', '1100', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13009, '2020-07-29', 'BF', 'Burkina Faso', 'AFRO', '5', '1105', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13010, '2020-07-30', 'BF', 'Burkina Faso', 'AFRO', '1', '1106', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13011, '2020-07-31', 'BF', 'Burkina Faso', 'AFRO', '11', '1117', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13012, '2020-08-01', 'BF', 'Burkina Faso', 'AFRO', '21', '1138', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13013, '2020-08-02', 'BF', 'Burkina Faso', 'AFRO', '5', '1143', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13014, '2020-08-03', 'BF', 'Burkina Faso', 'AFRO', '6', '1149', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13015, '2020-08-04', 'BF', 'Burkina Faso', 'AFRO', '1', '1150', '0', '53');
INSERT INTO public.who_global_data_import VALUES (13016, '2020-08-05', 'BF', 'Burkina Faso', 'AFRO', '3', '1153', '1', '54');
INSERT INTO public.who_global_data_import VALUES (13017, '2020-08-06', 'BF', 'Burkina Faso', 'AFRO', '3', '1156', '0', '54');
INSERT INTO public.who_global_data_import VALUES (13018, '2020-08-07', 'BF', 'Burkina Faso', 'AFRO', '2', '1158', '0', '54');
INSERT INTO public.who_global_data_import VALUES (13019, '2020-08-08', 'BF', 'Burkina Faso', 'AFRO', '4', '1162', '0', '54');
INSERT INTO public.who_global_data_import VALUES (13020, '2020-08-09', 'BF', 'Burkina Faso', 'AFRO', '13', '1175', '0', '54');
INSERT INTO public.who_global_data_import VALUES (13021, '2020-08-10', 'BF', 'Burkina Faso', 'AFRO', '5', '1180', '0', '54');
INSERT INTO public.who_global_data_import VALUES (13022, '2020-08-11', 'BF', 'Burkina Faso', 'AFRO', '24', '1204', '0', '54');
INSERT INTO public.who_global_data_import VALUES (13023, '2020-08-12', 'BF', 'Burkina Faso', 'AFRO', '7', '1211', '0', '54');
INSERT INTO public.who_global_data_import VALUES (13024, '2020-08-13', 'BF', 'Burkina Faso', 'AFRO', '2', '1213', '0', '54');
INSERT INTO public.who_global_data_import VALUES (13025, '2020-08-14', 'BF', 'Burkina Faso', 'AFRO', '15', '1228', '0', '54');
INSERT INTO public.who_global_data_import VALUES (13026, '2020-08-15', 'BF', 'Burkina Faso', 'AFRO', '10', '1238', '0', '54');
INSERT INTO public.who_global_data_import VALUES (13027, '2020-08-16', 'BF', 'Burkina Faso', 'AFRO', '2', '1240', '0', '54');
INSERT INTO public.who_global_data_import VALUES (13028, '2020-08-17', 'BF', 'Burkina Faso', 'AFRO', '9', '1249', '0', '54');
INSERT INTO public.who_global_data_import VALUES (13029, '2020-08-18', 'BF', 'Burkina Faso', 'AFRO', '18', '1267', '1', '55');
INSERT INTO public.who_global_data_import VALUES (13030, '2020-08-19', 'BF', 'Burkina Faso', 'AFRO', '13', '1280', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13031, '2020-08-20', 'BF', 'Burkina Faso', 'AFRO', '5', '1285', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13032, '2020-08-21', 'BF', 'Burkina Faso', 'AFRO', '7', '1292', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13033, '2020-08-22', 'BF', 'Burkina Faso', 'AFRO', '5', '1297', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13034, '2020-08-23', 'BF', 'Burkina Faso', 'AFRO', '0', '1297', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13035, '2020-08-24', 'BF', 'Burkina Faso', 'AFRO', '31', '1328', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13036, '2020-08-25', 'BF', 'Burkina Faso', 'AFRO', '0', '1328', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13037, '2020-08-26', 'BF', 'Burkina Faso', 'AFRO', '10', '1338', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13038, '2020-08-27', 'BF', 'Burkina Faso', 'AFRO', '14', '1352', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13039, '2020-08-28', 'BF', 'Burkina Faso', 'AFRO', '0', '1352', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13040, '2020-08-29', 'BF', 'Burkina Faso', 'AFRO', '5', '1357', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13041, '2020-08-30', 'BF', 'Burkina Faso', 'AFRO', '0', '1357', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13042, '2020-08-31', 'BF', 'Burkina Faso', 'AFRO', '11', '1368', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13043, '2020-09-01', 'BF', 'Burkina Faso', 'AFRO', '0', '1368', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13044, '2020-09-02', 'BF', 'Burkina Faso', 'AFRO', '2', '1370', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13045, '2020-09-03', 'BF', 'Burkina Faso', 'AFRO', '5', '1375', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13046, '2020-09-04', 'BF', 'Burkina Faso', 'AFRO', '3', '1378', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13047, '2020-09-05', 'BF', 'Burkina Faso', 'AFRO', '8', '1386', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13048, '2020-09-06', 'BF', 'Burkina Faso', 'AFRO', '22', '1408', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13049, '2020-09-07', 'BF', 'Burkina Faso', 'AFRO', '39', '1447', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13050, '2020-09-08', 'BF', 'Burkina Faso', 'AFRO', '5', '1452', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13051, '2020-09-09', 'BF', 'Burkina Faso', 'AFRO', '11', '1463', '1', '56');
INSERT INTO public.who_global_data_import VALUES (13052, '2020-09-10', 'BF', 'Burkina Faso', 'AFRO', '3', '1466', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13053, '2020-09-11', 'BF', 'Burkina Faso', 'AFRO', '10', '1476', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13054, '2020-09-12', 'BF', 'Burkina Faso', 'AFRO', '10', '1486', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13055, '2020-09-13', 'BF', 'Burkina Faso', 'AFRO', '13', '1499', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13056, '2020-09-14', 'BF', 'Burkina Faso', 'AFRO', '0', '1499', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13057, '2020-09-15', 'BF', 'Burkina Faso', 'AFRO', '193', '1692', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13058, '2020-09-16', 'BF', 'Burkina Faso', 'AFRO', '25', '1717', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13059, '2020-09-17', 'BF', 'Burkina Faso', 'AFRO', '16', '1733', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13060, '2020-09-18', 'BF', 'Burkina Faso', 'AFRO', '15', '1748', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13061, '2020-09-19', 'BF', 'Burkina Faso', 'AFRO', '19', '1767', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13062, '2020-09-20', 'BF', 'Burkina Faso', 'AFRO', '30', '1797', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13063, '2020-09-21', 'BF', 'Burkina Faso', 'AFRO', '19', '1816', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13064, '2020-09-22', 'BF', 'Burkina Faso', 'AFRO', '80', '1896', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13065, '2020-09-23', 'BF', 'Burkina Faso', 'AFRO', '0', '1896', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13066, '2020-09-24', 'BF', 'Burkina Faso', 'AFRO', '11', '1907', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13067, '2020-09-25', 'BF', 'Burkina Faso', 'AFRO', '22', '1929', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13068, '2020-09-26', 'BF', 'Burkina Faso', 'AFRO', '0', '1929', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13069, '2020-09-27', 'BF', 'Burkina Faso', 'AFRO', '0', '1929', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13070, '2020-09-28', 'BF', 'Burkina Faso', 'AFRO', '0', '1929', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13071, '2020-09-29', 'BF', 'Burkina Faso', 'AFRO', '0', '1929', '0', '56');
INSERT INTO public.who_global_data_import VALUES (13072, '2020-09-30', 'BF', 'Burkina Faso', 'AFRO', '99', '2028', '1', '57');
INSERT INTO public.who_global_data_import VALUES (13073, '2020-10-01', 'BF', 'Burkina Faso', 'AFRO', '0', '2028', '0', '57');
INSERT INTO public.who_global_data_import VALUES (13074, '2020-10-02', 'BF', 'Burkina Faso', 'AFRO', '28', '2056', '1', '58');
INSERT INTO public.who_global_data_import VALUES (13075, '2020-10-03', 'BF', 'Burkina Faso', 'AFRO', '32', '2088', '0', '58');
INSERT INTO public.who_global_data_import VALUES (13076, '2020-10-04', 'BF', 'Burkina Faso', 'AFRO', '0', '2088', '0', '58');
INSERT INTO public.who_global_data_import VALUES (13077, '2020-10-05', 'BF', 'Burkina Faso', 'AFRO', '66', '2154', '1', '59');
INSERT INTO public.who_global_data_import VALUES (13078, '2020-10-06', 'BF', 'Burkina Faso', 'AFRO', '13', '2167', '0', '59');
INSERT INTO public.who_global_data_import VALUES (13079, '2020-10-07', 'BF', 'Burkina Faso', 'AFRO', '0', '2167', '0', '59');
INSERT INTO public.who_global_data_import VALUES (13080, '2020-10-08', 'BF', 'Burkina Faso', 'AFRO', '30', '2197', '0', '59');
INSERT INTO public.who_global_data_import VALUES (13081, '2020-10-09', 'BF', 'Burkina Faso', 'AFRO', '25', '2222', '0', '59');
INSERT INTO public.who_global_data_import VALUES (13082, '2020-10-10', 'BF', 'Burkina Faso', 'AFRO', '19', '2241', '1', '60');
INSERT INTO public.who_global_data_import VALUES (13083, '2020-10-11', 'BF', 'Burkina Faso', 'AFRO', '0', '2241', '0', '60');
INSERT INTO public.who_global_data_import VALUES (13084, '2020-10-12', 'BF', 'Burkina Faso', 'AFRO', '0', '2241', '0', '60');
INSERT INTO public.who_global_data_import VALUES (13085, '2020-10-13', 'BF', 'Burkina Faso', 'AFRO', '39', '2280', '3', '63');
INSERT INTO public.who_global_data_import VALUES (13086, '2020-10-14', 'BF', 'Burkina Faso', 'AFRO', '0', '2280', '0', '63');
INSERT INTO public.who_global_data_import VALUES (13087, '2020-10-15', 'BF', 'Burkina Faso', 'AFRO', '14', '2294', '0', '63');
INSERT INTO public.who_global_data_import VALUES (13088, '2020-10-16', 'BF', 'Burkina Faso', 'AFRO', '41', '2335', '2', '65');
INSERT INTO public.who_global_data_import VALUES (13089, '2020-10-17', 'BF', 'Burkina Faso', 'AFRO', '8', '2343', '0', '65');
INSERT INTO public.who_global_data_import VALUES (13090, '2020-10-18', 'BF', 'Burkina Faso', 'AFRO', '31', '2374', '0', '65');
INSERT INTO public.who_global_data_import VALUES (13091, '2020-10-19', 'BF', 'Burkina Faso', 'AFRO', '7', '2381', '0', '65');
INSERT INTO public.who_global_data_import VALUES (13092, '2020-10-20', 'BF', 'Burkina Faso', 'AFRO', '6', '2387', '0', '65');
INSERT INTO public.who_global_data_import VALUES (13093, '2020-10-21', 'BF', 'Burkina Faso', 'AFRO', '19', '2406', '0', '65');
INSERT INTO public.who_global_data_import VALUES (13094, '2020-10-22', 'BF', 'Burkina Faso', 'AFRO', '0', '2406', '0', '65');
INSERT INTO public.who_global_data_import VALUES (13095, '2020-10-23', 'BF', 'Burkina Faso', 'AFRO', '15', '2421', '0', '65');
INSERT INTO public.who_global_data_import VALUES (13096, '2020-10-24', 'BF', 'Burkina Faso', 'AFRO', '12', '2433', '0', '65');
INSERT INTO public.who_global_data_import VALUES (13097, '2020-10-25', 'BF', 'Burkina Faso', 'AFRO', '11', '2444', '0', '65');
INSERT INTO public.who_global_data_import VALUES (13098, '2020-10-26', 'BF', 'Burkina Faso', 'AFRO', '7', '2451', '0', '65');
INSERT INTO public.who_global_data_import VALUES (13099, '2020-10-27', 'BF', 'Burkina Faso', 'AFRO', '8', '2459', '2', '67');
INSERT INTO public.who_global_data_import VALUES (13100, '2020-10-28', 'BF', 'Burkina Faso', 'AFRO', '7', '2466', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13101, '2020-10-29', 'BF', 'Burkina Faso', 'AFRO', '0', '2466', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13102, '2020-10-30', 'BF', 'Burkina Faso', 'AFRO', '11', '2477', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13103, '2020-10-31', 'BF', 'Burkina Faso', 'AFRO', '0', '2477', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13104, '2020-11-01', 'BF', 'Burkina Faso', 'AFRO', '23', '2500', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13105, '2020-11-02', 'BF', 'Burkina Faso', 'AFRO', '0', '2500', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13106, '2020-11-03', 'BF', 'Burkina Faso', 'AFRO', '17', '2517', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13107, '2020-11-04', 'BF', 'Burkina Faso', 'AFRO', '13', '2530', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13108, '2020-11-05', 'BF', 'Burkina Faso', 'AFRO', '9', '2539', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13109, '2020-11-06', 'BF', 'Burkina Faso', 'AFRO', '11', '2550', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13110, '2020-11-07', 'BF', 'Burkina Faso', 'AFRO', '12', '2562', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13111, '2020-11-08', 'BF', 'Burkina Faso', 'AFRO', '3', '2565', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13112, '2020-11-09', 'BF', 'Burkina Faso', 'AFRO', '4', '2569', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13113, '2020-11-10', 'BF', 'Burkina Faso', 'AFRO', '12', '2581', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13114, '2020-11-11', 'BF', 'Burkina Faso', 'AFRO', '1', '2582', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13115, '2020-11-12', 'BF', 'Burkina Faso', 'AFRO', '4', '2586', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13116, '2020-11-13', 'BF', 'Burkina Faso', 'AFRO', '0', '2586', '0', '67');
INSERT INTO public.who_global_data_import VALUES (13117, '2020-11-14', 'BF', 'Burkina Faso', 'AFRO', '23', '2609', '1', '68');
INSERT INTO public.who_global_data_import VALUES (13118, '2020-11-15', 'BF', 'Burkina Faso', 'AFRO', '26', '2635', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13119, '2020-11-16', 'BF', 'Burkina Faso', 'AFRO', '6', '2641', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13120, '2020-11-17', 'BF', 'Burkina Faso', 'AFRO', '11', '2652', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13121, '2020-11-18', 'BF', 'Burkina Faso', 'AFRO', '0', '2652', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13122, '2020-11-19', 'BF', 'Burkina Faso', 'AFRO', '18', '2670', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13123, '2020-11-20', 'BF', 'Burkina Faso', 'AFRO', '16', '2686', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13124, '2020-11-21', 'BF', 'Burkina Faso', 'AFRO', '0', '2686', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13125, '2020-11-22', 'BF', 'Burkina Faso', 'AFRO', '17', '2703', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13126, '2020-11-23', 'BF', 'Burkina Faso', 'AFRO', '32', '2735', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13127, '2020-11-24', 'BF', 'Burkina Faso', 'AFRO', '19', '2754', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13128, '2020-11-25', 'BF', 'Burkina Faso', 'AFRO', '3', '2757', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13129, '2020-11-26', 'BF', 'Burkina Faso', 'AFRO', '20', '2777', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13130, '2020-11-27', 'BF', 'Burkina Faso', 'AFRO', '0', '2777', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13131, '2020-11-28', 'BF', 'Burkina Faso', 'AFRO', '39', '2816', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13132, '2020-11-29', 'BF', 'Burkina Faso', 'AFRO', '0', '2816', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13133, '2020-11-30', 'BF', 'Burkina Faso', 'AFRO', '40', '2856', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13134, '2020-12-01', 'BF', 'Burkina Faso', 'AFRO', '30', '2886', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13135, '2020-12-02', 'BF', 'Burkina Faso', 'AFRO', '45', '2931', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13136, '2020-12-03', 'BF', 'Burkina Faso', 'AFRO', '79', '3010', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13137, '2020-12-04', 'BF', 'Burkina Faso', 'AFRO', '52', '3062', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13138, '2020-12-05', 'BF', 'Burkina Faso', 'AFRO', '29', '3091', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13139, '2020-12-06', 'BF', 'Burkina Faso', 'AFRO', '65', '3156', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13140, '2020-12-07', 'BF', 'Burkina Faso', 'AFRO', '56', '3212', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13141, '2020-12-08', 'BF', 'Burkina Faso', 'AFRO', '103', '3315', '0', '68');
INSERT INTO public.who_global_data_import VALUES (13142, '2020-12-09', 'BF', 'Burkina Faso', 'AFRO', '154', '3469', '1', '69');
INSERT INTO public.who_global_data_import VALUES (13143, '2020-12-10', 'BF', 'Burkina Faso', 'AFRO', '0', '3469', '0', '69');
INSERT INTO public.who_global_data_import VALUES (13144, '2020-12-11', 'BF', 'Burkina Faso', 'AFRO', '110', '3579', '0', '69');
INSERT INTO public.who_global_data_import VALUES (13145, '2020-12-12', 'BF', 'Burkina Faso', 'AFRO', '0', '3579', '0', '69');
INSERT INTO public.who_global_data_import VALUES (13146, '2020-12-13', 'BF', 'Burkina Faso', 'AFRO', '315', '3894', '2', '71');
INSERT INTO public.who_global_data_import VALUES (13147, '2020-12-14', 'BF', 'Burkina Faso', 'AFRO', '136', '4030', '0', '71');
INSERT INTO public.who_global_data_import VALUES (13148, '2020-12-15', 'BF', 'Burkina Faso', 'AFRO', '179', '4209', '0', '71');
INSERT INTO public.who_global_data_import VALUES (13149, '2020-12-16', 'BF', 'Burkina Faso', 'AFRO', '91', '4300', '2', '73');
INSERT INTO public.who_global_data_import VALUES (13150, '2020-12-17', 'BF', 'Burkina Faso', 'AFRO', '149', '4449', '0', '73');
INSERT INTO public.who_global_data_import VALUES (13151, '2020-12-18', 'BF', 'Burkina Faso', 'AFRO', '162', '4611', '0', '73');
INSERT INTO public.who_global_data_import VALUES (13152, '2020-12-19', 'BF', 'Burkina Faso', 'AFRO', '221', '4832', '1', '74');
INSERT INTO public.who_global_data_import VALUES (13153, '2020-12-20', 'BF', 'Burkina Faso', 'AFRO', '122', '4954', '0', '74');
INSERT INTO public.who_global_data_import VALUES (13154, '2020-12-21', 'BF', 'Burkina Faso', 'AFRO', '206', '5160', '2', '76');
INSERT INTO public.who_global_data_import VALUES (13155, '2020-12-22', 'BF', 'Burkina Faso', 'AFRO', '141', '5301', '0', '76');
INSERT INTO public.who_global_data_import VALUES (13156, '2020-12-23', 'BF', 'Burkina Faso', 'AFRO', '160', '5461', '1', '77');
INSERT INTO public.who_global_data_import VALUES (13157, '2020-12-24', 'BF', 'Burkina Faso', 'AFRO', '188', '5649', '0', '77');
INSERT INTO public.who_global_data_import VALUES (13158, '2020-12-25', 'BF', 'Burkina Faso', 'AFRO', '292', '5941', '0', '77');
INSERT INTO public.who_global_data_import VALUES (13159, '2020-12-26', 'BF', 'Burkina Faso', 'AFRO', '193', '6134', '0', '77');
INSERT INTO public.who_global_data_import VALUES (13160, '2020-12-27', 'BF', 'Burkina Faso', 'AFRO', '121', '6255', '0', '77');
INSERT INTO public.who_global_data_import VALUES (13161, '2020-12-28', 'BF', 'Burkina Faso', 'AFRO', '89', '6344', '1', '78');
INSERT INTO public.who_global_data_import VALUES (13162, '2020-12-29', 'BF', 'Burkina Faso', 'AFRO', '0', '6344', '0', '78');
INSERT INTO public.who_global_data_import VALUES (13163, '2020-12-30', 'BF', 'Burkina Faso', 'AFRO', '193', '6537', '4', '82');
INSERT INTO public.who_global_data_import VALUES (13164, '2020-12-31', 'BF', 'Burkina Faso', 'AFRO', '0', '6537', '0', '82');
INSERT INTO public.who_global_data_import VALUES (13165, '2021-01-01', 'BF', 'Burkina Faso', 'AFRO', '170', '6707', '3', '85');
INSERT INTO public.who_global_data_import VALUES (13166, '2021-01-02', 'BF', 'Burkina Faso', 'AFRO', '0', '6707', '0', '85');
INSERT INTO public.who_global_data_import VALUES (13167, '2021-01-03', 'BF', 'Burkina Faso', 'AFRO', '233', '6940', '1', '86');
INSERT INTO public.who_global_data_import VALUES (13168, '2021-01-04', 'BF', 'Burkina Faso', 'AFRO', '111', '7051', '0', '86');
INSERT INTO public.who_global_data_import VALUES (13169, '2021-01-05', 'BF', 'Burkina Faso', 'AFRO', '75', '7126', '0', '86');
INSERT INTO public.who_global_data_import VALUES (13170, '2021-01-06', 'BF', 'Burkina Faso', 'AFRO', '0', '7126', '0', '86');
INSERT INTO public.who_global_data_import VALUES (13171, '2021-01-07', 'BF', 'Burkina Faso', 'AFRO', '437', '7563', '3', '89');
INSERT INTO public.who_global_data_import VALUES (13172, '2021-01-08', 'BF', 'Burkina Faso', 'AFRO', '150', '7713', '0', '89');
INSERT INTO public.who_global_data_import VALUES (13173, '2021-01-09', 'BF', 'Burkina Faso', 'AFRO', '153', '7866', '0', '89');
INSERT INTO public.who_global_data_import VALUES (13174, '2021-01-10', 'BF', 'Burkina Faso', 'AFRO', '0', '7866', '0', '89');
INSERT INTO public.who_global_data_import VALUES (13175, '2021-01-11', 'BF', 'Burkina Faso', 'AFRO', '216', '8082', '0', '89');
INSERT INTO public.who_global_data_import VALUES (13176, '2021-01-12', 'BF', 'Burkina Faso', 'AFRO', '197', '8279', '0', '89');
INSERT INTO public.who_global_data_import VALUES (13177, '2021-01-13', 'BF', 'Burkina Faso', 'AFRO', '184', '8463', '3', '92');
INSERT INTO public.who_global_data_import VALUES (13178, '2021-01-14', 'BF', 'Burkina Faso', 'AFRO', '83', '8546', '1', '93');
INSERT INTO public.who_global_data_import VALUES (13179, '2021-01-15', 'BF', 'Burkina Faso', 'AFRO', '263', '8809', '4', '97');
INSERT INTO public.who_global_data_import VALUES (13180, '2021-01-16', 'BF', 'Burkina Faso', 'AFRO', '0', '8809', '0', '97');
INSERT INTO public.who_global_data_import VALUES (13181, '2021-01-17', 'BF', 'Burkina Faso', 'AFRO', '191', '9000', '4', '101');
INSERT INTO public.who_global_data_import VALUES (13182, '2021-01-18', 'BF', 'Burkina Faso', 'AFRO', '188', '9188', '1', '102');
INSERT INTO public.who_global_data_import VALUES (13183, '2021-01-19', 'BF', 'Burkina Faso', 'AFRO', '164', '9352', '3', '105');
INSERT INTO public.who_global_data_import VALUES (13184, '2021-01-20', 'BF', 'Burkina Faso', 'AFRO', '0', '9352', '0', '105');
INSERT INTO public.who_global_data_import VALUES (13185, '2021-01-21', 'BF', 'Burkina Faso', 'AFRO', '201', '9553', '1', '106');
INSERT INTO public.who_global_data_import VALUES (13186, '2021-01-22', 'BF', 'Burkina Faso', 'AFRO', '166', '9719', '0', '106');
INSERT INTO public.who_global_data_import VALUES (13187, '2021-01-23', 'BF', 'Burkina Faso', 'AFRO', '138', '9857', '1', '107');
INSERT INTO public.who_global_data_import VALUES (13188, '2021-01-24', 'BF', 'Burkina Faso', 'AFRO', '110', '9967', '2', '109');
INSERT INTO public.who_global_data_import VALUES (13189, '2021-01-25', 'BF', 'Burkina Faso', 'AFRO', '71', '10038', '3', '112');
INSERT INTO public.who_global_data_import VALUES (13190, '2021-01-26', 'BF', 'Burkina Faso', 'AFRO', '65', '10103', '5', '117');
INSERT INTO public.who_global_data_import VALUES (13191, '2021-01-27', 'BF', 'Burkina Faso', 'AFRO', '54', '10157', '1', '118');
INSERT INTO public.who_global_data_import VALUES (13192, '2021-01-28', 'BF', 'Burkina Faso', 'AFRO', '60', '10217', '2', '120');
INSERT INTO public.who_global_data_import VALUES (13193, '2021-01-29', 'BF', 'Burkina Faso', 'AFRO', '160', '10377', '0', '120');
INSERT INTO public.who_global_data_import VALUES (13194, '2021-01-30', 'BF', 'Burkina Faso', 'AFRO', '46', '10423', '0', '120');
INSERT INTO public.who_global_data_import VALUES (13195, '2021-01-31', 'BF', 'Burkina Faso', 'AFRO', '157', '10580', '0', '120');
INSERT INTO public.who_global_data_import VALUES (13196, '2021-02-01', 'BF', 'Burkina Faso', 'AFRO', '102', '10682', '0', '120');
INSERT INTO public.who_global_data_import VALUES (13197, '2021-02-02', 'BF', 'Burkina Faso', 'AFRO', '86', '10768', '1', '121');
INSERT INTO public.who_global_data_import VALUES (13198, '2021-02-03', 'BF', 'Burkina Faso', 'AFRO', '136', '10904', '5', '126');
INSERT INTO public.who_global_data_import VALUES (13199, '2021-02-04', 'BF', 'Burkina Faso', 'AFRO', '54', '10958', '1', '127');
INSERT INTO public.who_global_data_import VALUES (13200, '2021-02-05', 'BF', 'Burkina Faso', 'AFRO', '95', '11053', '5', '132');
INSERT INTO public.who_global_data_import VALUES (13201, '2020-01-03', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13202, '2020-01-04', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13203, '2020-01-05', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13204, '2020-01-06', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13205, '2020-01-07', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13206, '2020-01-08', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13207, '2020-01-09', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13208, '2020-01-10', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13209, '2020-01-11', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13210, '2020-01-12', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13211, '2020-01-13', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13212, '2020-01-14', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13213, '2020-01-15', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13214, '2020-01-16', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13215, '2020-01-17', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13216, '2020-01-18', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13217, '2020-01-19', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13218, '2020-01-20', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13219, '2020-01-21', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13220, '2020-01-22', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13221, '2020-01-23', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13222, '2020-01-24', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13223, '2020-01-25', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13224, '2020-01-26', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13225, '2020-01-27', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13226, '2020-01-28', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13227, '2020-01-29', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13228, '2020-01-30', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13229, '2020-01-31', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13230, '2020-02-01', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13231, '2020-02-02', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13232, '2020-02-03', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13233, '2020-02-04', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13234, '2020-02-05', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13235, '2020-02-06', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13236, '2020-02-07', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13237, '2020-02-08', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13238, '2020-02-09', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13239, '2020-02-10', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13240, '2020-02-11', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13241, '2020-02-12', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13242, '2020-02-13', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13243, '2020-02-14', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13244, '2020-02-15', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13245, '2020-02-16', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13246, '2020-02-17', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13247, '2020-02-18', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13248, '2020-02-19', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13249, '2020-02-20', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13250, '2020-02-21', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13251, '2020-02-22', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13252, '2020-02-23', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13253, '2020-02-24', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13254, '2020-02-25', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13255, '2020-02-26', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13256, '2020-02-27', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13257, '2020-02-28', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13258, '2020-02-29', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13259, '2020-03-01', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13260, '2020-03-02', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13261, '2020-03-03', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13262, '2020-03-04', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13263, '2020-03-05', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13264, '2020-03-06', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13265, '2020-03-07', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13266, '2020-03-08', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13267, '2020-03-09', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13268, '2020-03-10', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13269, '2020-03-11', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13270, '2020-03-12', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13271, '2020-03-13', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13272, '2020-03-14', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13273, '2020-03-15', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13274, '2020-03-16', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13275, '2020-03-17', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13276, '2020-03-18', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13277, '2020-03-19', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13278, '2020-03-20', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13279, '2020-03-21', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13280, '2020-03-22', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13281, '2020-03-23', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13282, '2020-03-24', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13283, '2020-03-25', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13284, '2020-03-26', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13285, '2020-03-27', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13286, '2020-03-28', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13287, '2020-03-29', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13288, '2020-03-30', 'BI', 'Burundi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13290, '2020-04-01', 'BI', 'Burundi', 'AFRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13291, '2020-04-02', 'BI', 'Burundi', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13292, '2020-04-03', 'BI', 'Burundi', 'AFRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13293, '2020-04-04', 'BI', 'Burundi', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13294, '2020-04-05', 'BI', 'Burundi', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13295, '2020-04-06', 'BI', 'Burundi', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13296, '2020-04-07', 'BI', 'Burundi', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13297, '2020-04-08', 'BI', 'Burundi', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13298, '2020-04-09', 'BI', 'Burundi', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13299, '2020-04-10', 'BI', 'Burundi', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13300, '2020-04-11', 'BI', 'Burundi', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13301, '2020-04-12', 'BI', 'Burundi', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13302, '2020-04-13', 'BI', 'Burundi', 'AFRO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13303, '2020-04-14', 'BI', 'Burundi', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13304, '2020-04-15', 'BI', 'Burundi', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13305, '2020-04-16', 'BI', 'Burundi', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13306, '2020-04-17', 'BI', 'Burundi', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13307, '2020-04-18', 'BI', 'Burundi', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13308, '2020-04-19', 'BI', 'Burundi', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13309, '2020-04-20', 'BI', 'Burundi', 'AFRO', '1', '6', '1', '1');
INSERT INTO public.who_global_data_import VALUES (13310, '2020-04-21', 'BI', 'Burundi', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13311, '2020-04-22', 'BI', 'Burundi', 'AFRO', '5', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13312, '2020-04-23', 'BI', 'Burundi', 'AFRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13313, '2020-04-24', 'BI', 'Burundi', 'AFRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13314, '2020-04-25', 'BI', 'Burundi', 'AFRO', '1', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13315, '2020-04-26', 'BI', 'Burundi', 'AFRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13316, '2020-04-27', 'BI', 'Burundi', 'AFRO', '3', '15', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13317, '2020-04-28', 'BI', 'Burundi', 'AFRO', '0', '15', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13318, '2020-04-29', 'BI', 'Burundi', 'AFRO', '0', '15', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13319, '2020-04-30', 'BI', 'Burundi', 'AFRO', '0', '15', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13320, '2020-05-01', 'BI', 'Burundi', 'AFRO', '0', '15', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13321, '2020-05-02', 'BI', 'Burundi', 'AFRO', '0', '15', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13322, '2020-05-03', 'BI', 'Burundi', 'AFRO', '4', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13323, '2020-05-04', 'BI', 'Burundi', 'AFRO', '0', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13324, '2020-05-05', 'BI', 'Burundi', 'AFRO', '0', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13325, '2020-05-06', 'BI', 'Burundi', 'AFRO', '0', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13326, '2020-05-07', 'BI', 'Burundi', 'AFRO', '0', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13327, '2020-05-08', 'BI', 'Burundi', 'AFRO', '0', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13328, '2020-05-09', 'BI', 'Burundi', 'AFRO', '0', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13329, '2020-05-10', 'BI', 'Burundi', 'AFRO', '0', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13330, '2020-05-11', 'BI', 'Burundi', 'AFRO', '0', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13331, '2020-05-12', 'BI', 'Burundi', 'AFRO', '0', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13332, '2020-05-13', 'BI', 'Burundi', 'AFRO', '8', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13333, '2020-05-14', 'BI', 'Burundi', 'AFRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13334, '2020-05-15', 'BI', 'Burundi', 'AFRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13335, '2020-05-16', 'BI', 'Burundi', 'AFRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13336, '2020-05-17', 'BI', 'Burundi', 'AFRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13337, '2020-05-18', 'BI', 'Burundi', 'AFRO', '15', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13338, '2020-05-19', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13339, '2020-05-20', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13340, '2020-05-21', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13341, '2020-05-22', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13342, '2020-05-23', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13343, '2020-05-24', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13344, '2020-05-25', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13345, '2020-05-26', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13346, '2020-05-27', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13347, '2020-05-28', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13348, '2020-05-29', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13349, '2020-05-30', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13350, '2020-05-31', 'BI', 'Burundi', 'AFRO', '0', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13351, '2020-06-01', 'BI', 'Burundi', 'AFRO', '21', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13352, '2020-06-02', 'BI', 'Burundi', 'AFRO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13353, '2020-06-03', 'BI', 'Burundi', 'AFRO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13354, '2020-06-04', 'BI', 'Burundi', 'AFRO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13355, '2020-06-05', 'BI', 'Burundi', 'AFRO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13356, '2020-06-06', 'BI', 'Burundi', 'AFRO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13357, '2020-06-07', 'BI', 'Burundi', 'AFRO', '20', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13358, '2020-06-08', 'BI', 'Burundi', 'AFRO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13359, '2020-06-09', 'BI', 'Burundi', 'AFRO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13360, '2020-06-10', 'BI', 'Burundi', 'AFRO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13361, '2020-06-11', 'BI', 'Burundi', 'AFRO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13362, '2020-06-12', 'BI', 'Burundi', 'AFRO', '11', '94', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13363, '2020-06-13', 'BI', 'Burundi', 'AFRO', '0', '94', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13364, '2020-06-14', 'BI', 'Burundi', 'AFRO', '0', '94', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13365, '2020-06-15', 'BI', 'Burundi', 'AFRO', '0', '94', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13366, '2020-06-16', 'BI', 'Burundi', 'AFRO', '10', '104', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13367, '2020-06-17', 'BI', 'Burundi', 'AFRO', '0', '104', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13368, '2020-06-18', 'BI', 'Burundi', 'AFRO', '0', '104', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13369, '2020-06-19', 'BI', 'Burundi', 'AFRO', '0', '104', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13370, '2020-06-20', 'BI', 'Burundi', 'AFRO', '0', '104', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13371, '2020-06-21', 'BI', 'Burundi', 'AFRO', '40', '144', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13372, '2020-06-22', 'BI', 'Burundi', 'AFRO', '0', '144', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13373, '2020-06-23', 'BI', 'Burundi', 'AFRO', '0', '144', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13374, '2020-06-24', 'BI', 'Burundi', 'AFRO', '0', '144', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13375, '2020-06-25', 'BI', 'Burundi', 'AFRO', '0', '144', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13376, '2020-06-26', 'BI', 'Burundi', 'AFRO', '0', '144', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13377, '2020-06-27', 'BI', 'Burundi', 'AFRO', '0', '144', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13378, '2020-06-28', 'BI', 'Burundi', 'AFRO', '0', '144', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13379, '2020-06-29', 'BI', 'Burundi', 'AFRO', '26', '170', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13380, '2020-06-30', 'BI', 'Burundi', 'AFRO', '0', '170', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13381, '2020-07-01', 'BI', 'Burundi', 'AFRO', '0', '170', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13382, '2020-07-02', 'BI', 'Burundi', 'AFRO', '0', '170', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13383, '2020-07-03', 'BI', 'Burundi', 'AFRO', '0', '170', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13384, '2020-07-04', 'BI', 'Burundi', 'AFRO', '21', '191', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13385, '2020-07-05', 'BI', 'Burundi', 'AFRO', '0', '191', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13386, '2020-07-06', 'BI', 'Burundi', 'AFRO', '0', '191', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13387, '2020-07-07', 'BI', 'Burundi', 'AFRO', '0', '191', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13388, '2020-07-08', 'BI', 'Burundi', 'AFRO', '0', '191', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13389, '2020-07-09', 'BI', 'Burundi', 'AFRO', '28', '219', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13390, '2020-07-10', 'BI', 'Burundi', 'AFRO', '0', '219', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13391, '2020-07-11', 'BI', 'Burundi', 'AFRO', '31', '250', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13392, '2020-07-12', 'BI', 'Burundi', 'AFRO', '0', '250', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13393, '2020-07-13', 'BI', 'Burundi', 'AFRO', '8', '258', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13394, '2020-07-14', 'BI', 'Burundi', 'AFRO', '11', '269', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13395, '2020-07-15', 'BI', 'Burundi', 'AFRO', '0', '269', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13396, '2020-07-16', 'BI', 'Burundi', 'AFRO', '34', '303', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13397, '2020-07-17', 'BI', 'Burundi', 'AFRO', '7', '310', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13398, '2020-07-18', 'BI', 'Burundi', 'AFRO', '0', '310', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13399, '2020-07-19', 'BI', 'Burundi', 'AFRO', '0', '310', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13400, '2020-07-20', 'BI', 'Burundi', 'AFRO', '12', '322', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13401, '2020-07-21', 'BI', 'Burundi', 'AFRO', '6', '328', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13402, '2020-07-22', 'BI', 'Burundi', 'AFRO', '0', '328', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13403, '2020-07-23', 'BI', 'Burundi', 'AFRO', '10', '338', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13404, '2020-07-24', 'BI', 'Burundi', 'AFRO', '7', '345', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13405, '2020-07-25', 'BI', 'Burundi', 'AFRO', '0', '345', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13406, '2020-07-26', 'BI', 'Burundi', 'AFRO', '0', '345', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13407, '2020-07-27', 'BI', 'Burundi', 'AFRO', '16', '361', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13408, '2020-07-28', 'BI', 'Burundi', 'AFRO', '17', '378', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13409, '2020-07-29', 'BI', 'Burundi', 'AFRO', '0', '378', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13410, '2020-07-30', 'BI', 'Burundi', 'AFRO', '0', '378', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13411, '2020-07-31', 'BI', 'Burundi', 'AFRO', '9', '387', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13412, '2020-08-01', 'BI', 'Burundi', 'AFRO', '0', '387', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13413, '2020-08-02', 'BI', 'Burundi', 'AFRO', '0', '387', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13414, '2020-08-03', 'BI', 'Burundi', 'AFRO', '8', '395', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13415, '2020-08-04', 'BI', 'Burundi', 'AFRO', '0', '395', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13416, '2020-08-05', 'BI', 'Burundi', 'AFRO', '0', '395', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13417, '2020-08-06', 'BI', 'Burundi', 'AFRO', '5', '400', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13418, '2020-08-07', 'BI', 'Burundi', 'AFRO', '1', '401', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13419, '2020-08-08', 'BI', 'Burundi', 'AFRO', '0', '401', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13420, '2020-08-09', 'BI', 'Burundi', 'AFRO', '4', '405', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13421, '2020-08-10', 'BI', 'Burundi', 'AFRO', '3', '408', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13422, '2020-08-11', 'BI', 'Burundi', 'AFRO', '0', '408', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13423, '2020-08-12', 'BI', 'Burundi', 'AFRO', '1', '409', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13424, '2020-08-13', 'BI', 'Burundi', 'AFRO', '1', '410', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13425, '2020-08-14', 'BI', 'Burundi', 'AFRO', '2', '412', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13426, '2020-08-15', 'BI', 'Burundi', 'AFRO', '0', '412', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13427, '2020-08-16', 'BI', 'Burundi', 'AFRO', '1', '413', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13428, '2020-08-17', 'BI', 'Burundi', 'AFRO', '0', '413', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13429, '2020-08-18', 'BI', 'Burundi', 'AFRO', '3', '416', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13430, '2020-08-19', 'BI', 'Burundi', 'AFRO', '6', '422', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13431, '2020-08-20', 'BI', 'Burundi', 'AFRO', '0', '422', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13432, '2020-08-21', 'BI', 'Burundi', 'AFRO', '4', '426', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13433, '2020-08-22', 'BI', 'Burundi', 'AFRO', '3', '429', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13434, '2020-08-23', 'BI', 'Burundi', 'AFRO', '1', '430', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13435, '2020-08-24', 'BI', 'Burundi', 'AFRO', '0', '430', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13436, '2020-08-25', 'BI', 'Burundi', 'AFRO', '0', '430', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13437, '2020-08-26', 'BI', 'Burundi', 'AFRO', '0', '430', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13438, '2020-08-27', 'BI', 'Burundi', 'AFRO', '1', '431', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13439, '2020-08-28', 'BI', 'Burundi', 'AFRO', '2', '433', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13440, '2020-08-29', 'BI', 'Burundi', 'AFRO', '6', '439', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13441, '2020-08-30', 'BI', 'Burundi', 'AFRO', '6', '445', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13442, '2020-08-31', 'BI', 'Burundi', 'AFRO', '0', '445', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13443, '2020-09-01', 'BI', 'Burundi', 'AFRO', '0', '445', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13444, '2020-09-02', 'BI', 'Burundi', 'AFRO', '3', '448', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13445, '2020-09-03', 'BI', 'Burundi', 'AFRO', '0', '448', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13446, '2020-09-04', 'BI', 'Burundi', 'AFRO', '3', '451', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13447, '2020-09-05', 'BI', 'Burundi', 'AFRO', '9', '460', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13448, '2020-09-06', 'BI', 'Burundi', 'AFRO', '2', '462', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13449, '2020-09-07', 'BI', 'Burundi', 'AFRO', '0', '462', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13450, '2020-09-08', 'BI', 'Burundi', 'AFRO', '4', '466', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13451, '2020-09-09', 'BI', 'Burundi', 'AFRO', '0', '466', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13452, '2020-09-10', 'BI', 'Burundi', 'AFRO', '3', '469', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13453, '2020-09-11', 'BI', 'Burundi', 'AFRO', '0', '469', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13454, '2020-09-12', 'BI', 'Burundi', 'AFRO', '2', '471', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13455, '2020-09-13', 'BI', 'Burundi', 'AFRO', '1', '472', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13456, '2020-09-14', 'BI', 'Burundi', 'AFRO', '0', '472', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13457, '2020-09-15', 'BI', 'Burundi', 'AFRO', '0', '472', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13458, '2020-09-16', 'BI', 'Burundi', 'AFRO', '0', '472', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13459, '2020-09-17', 'BI', 'Burundi', 'AFRO', '1', '473', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13460, '2020-09-18', 'BI', 'Burundi', 'AFRO', '0', '473', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13461, '2020-09-19', 'BI', 'Burundi', 'AFRO', '0', '473', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13462, '2020-09-20', 'BI', 'Burundi', 'AFRO', '0', '473', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13463, '2020-09-21', 'BI', 'Burundi', 'AFRO', '1', '474', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13464, '2020-09-22', 'BI', 'Burundi', 'AFRO', '0', '474', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13465, '2020-09-23', 'BI', 'Burundi', 'AFRO', '2', '476', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13466, '2020-09-24', 'BI', 'Burundi', 'AFRO', '1', '477', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13467, '2020-09-25', 'BI', 'Burundi', 'AFRO', '6', '483', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13468, '2020-09-26', 'BI', 'Burundi', 'AFRO', '1', '484', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13469, '2020-09-27', 'BI', 'Burundi', 'AFRO', '0', '484', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13470, '2020-09-28', 'BI', 'Burundi', 'AFRO', '18', '502', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13471, '2020-09-29', 'BI', 'Burundi', 'AFRO', '4', '506', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13472, '2020-09-30', 'BI', 'Burundi', 'AFRO', '2', '508', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13473, '2020-10-01', 'BI', 'Burundi', 'AFRO', '2', '510', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13474, '2020-10-02', 'BI', 'Burundi', 'AFRO', '3', '513', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13475, '2020-10-03', 'BI', 'Burundi', 'AFRO', '0', '513', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13476, '2020-10-04', 'BI', 'Burundi', 'AFRO', '0', '513', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13477, '2020-10-05', 'BI', 'Burundi', 'AFRO', '1', '514', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13478, '2020-10-06', 'BI', 'Burundi', 'AFRO', '0', '514', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13479, '2020-10-07', 'BI', 'Burundi', 'AFRO', '1', '515', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13480, '2020-10-08', 'BI', 'Burundi', 'AFRO', '0', '515', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13481, '2020-10-09', 'BI', 'Burundi', 'AFRO', '0', '515', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13482, '2020-10-10', 'BI', 'Burundi', 'AFRO', '2', '517', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13483, '2020-10-11', 'BI', 'Burundi', 'AFRO', '7', '524', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13484, '2020-10-12', 'BI', 'Burundi', 'AFRO', '1', '525', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13485, '2020-10-13', 'BI', 'Burundi', 'AFRO', '4', '529', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13486, '2020-10-14', 'BI', 'Burundi', 'AFRO', '0', '529', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13487, '2020-10-15', 'BI', 'Burundi', 'AFRO', '0', '529', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13488, '2020-10-16', 'BI', 'Burundi', 'AFRO', '2', '531', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13489, '2020-10-17', 'BI', 'Burundi', 'AFRO', '5', '536', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13490, '2020-10-18', 'BI', 'Burundi', 'AFRO', '6', '542', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13491, '2020-10-19', 'BI', 'Burundi', 'AFRO', '7', '549', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13492, '2020-10-20', 'BI', 'Burundi', 'AFRO', '1', '550', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13493, '2020-10-21', 'BI', 'Burundi', 'AFRO', '0', '550', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13494, '2020-10-22', 'BI', 'Burundi', 'AFRO', '1', '551', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13495, '2020-10-23', 'BI', 'Burundi', 'AFRO', '2', '553', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13496, '2020-10-24', 'BI', 'Burundi', 'AFRO', '2', '555', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13497, '2020-10-25', 'BI', 'Burundi', 'AFRO', '1', '556', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13498, '2020-10-26', 'BI', 'Burundi', 'AFRO', '1', '557', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13499, '2020-10-27', 'BI', 'Burundi', 'AFRO', '1', '558', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13500, '2020-10-28', 'BI', 'Burundi', 'AFRO', '1', '559', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13501, '2020-10-29', 'BI', 'Burundi', 'AFRO', '1', '560', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13502, '2020-10-30', 'BI', 'Burundi', 'AFRO', '22', '582', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13503, '2020-10-31', 'BI', 'Burundi', 'AFRO', '3', '585', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13504, '2020-11-01', 'BI', 'Burundi', 'AFRO', '4', '589', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13505, '2020-11-02', 'BI', 'Burundi', 'AFRO', '0', '589', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13506, '2020-11-03', 'BI', 'Burundi', 'AFRO', '8', '597', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13507, '2020-11-04', 'BI', 'Burundi', 'AFRO', '9', '606', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13508, '2020-11-05', 'BI', 'Burundi', 'AFRO', '-6', '600', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13509, '2020-11-06', 'BI', 'Burundi', 'AFRO', '5', '605', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13510, '2020-11-07', 'BI', 'Burundi', 'AFRO', '7', '612', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13511, '2020-11-08', 'BI', 'Burundi', 'AFRO', '2', '614', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13512, '2020-11-09', 'BI', 'Burundi', 'AFRO', '0', '614', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13513, '2020-11-10', 'BI', 'Burundi', 'AFRO', '1', '615', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13514, '2020-11-11', 'BI', 'Burundi', 'AFRO', '5', '620', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13515, '2020-11-12', 'BI', 'Burundi', 'AFRO', '3', '623', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13516, '2020-11-13', 'BI', 'Burundi', 'AFRO', '1', '624', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13517, '2020-11-14', 'BI', 'Burundi', 'AFRO', '3', '627', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13518, '2020-11-15', 'BI', 'Burundi', 'AFRO', '1', '628', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13519, '2020-11-16', 'BI', 'Burundi', 'AFRO', '2', '630', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13520, '2020-11-17', 'BI', 'Burundi', 'AFRO', '1', '631', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13521, '2020-11-18', 'BI', 'Burundi', 'AFRO', '11', '642', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13522, '2020-11-19', 'BI', 'Burundi', 'AFRO', '0', '642', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13523, '2020-11-20', 'BI', 'Burundi', 'AFRO', '7', '649', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13524, '2020-11-21', 'BI', 'Burundi', 'AFRO', '7', '656', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13525, '2020-11-22', 'BI', 'Burundi', 'AFRO', '6', '662', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13526, '2020-11-23', 'BI', 'Burundi', 'AFRO', '2', '664', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13527, '2020-11-24', 'BI', 'Burundi', 'AFRO', '9', '673', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13528, '2020-11-25', 'BI', 'Burundi', 'AFRO', '0', '673', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13529, '2020-11-26', 'BI', 'Burundi', 'AFRO', '4', '677', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13530, '2020-11-27', 'BI', 'Burundi', 'AFRO', '4', '681', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13531, '2020-11-28', 'BI', 'Burundi', 'AFRO', '0', '681', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13532, '2020-11-29', 'BI', 'Burundi', 'AFRO', '0', '681', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13533, '2020-11-30', 'BI', 'Burundi', 'AFRO', '7', '688', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13534, '2020-12-01', 'BI', 'Burundi', 'AFRO', '1', '689', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13535, '2020-12-02', 'BI', 'Burundi', 'AFRO', '0', '689', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13536, '2020-12-03', 'BI', 'Burundi', 'AFRO', '3', '692', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13537, '2020-12-04', 'BI', 'Burundi', 'AFRO', '0', '692', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13538, '2020-12-05', 'BI', 'Burundi', 'AFRO', '2', '694', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13539, '2020-12-06', 'BI', 'Burundi', 'AFRO', '0', '694', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13540, '2020-12-07', 'BI', 'Burundi', 'AFRO', '4', '698', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13541, '2020-12-08', 'BI', 'Burundi', 'AFRO', '18', '716', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13542, '2020-12-09', 'BI', 'Burundi', 'AFRO', '4', '720', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13543, '2020-12-10', 'BI', 'Burundi', 'AFRO', '1', '721', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13544, '2020-12-11', 'BI', 'Burundi', 'AFRO', '2', '723', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13545, '2020-12-12', 'BI', 'Burundi', 'AFRO', '5', '728', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13546, '2020-12-13', 'BI', 'Burundi', 'AFRO', '1', '729', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13547, '2020-12-14', 'BI', 'Burundi', 'AFRO', '0', '729', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13548, '2020-12-15', 'BI', 'Burundi', 'AFRO', '6', '735', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13549, '2020-12-16', 'BI', 'Burundi', 'AFRO', '6', '741', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13550, '2020-12-17', 'BI', 'Burundi', 'AFRO', '10', '751', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13551, '2020-12-18', 'BI', 'Burundi', 'AFRO', '5', '756', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13552, '2020-12-19', 'BI', 'Burundi', 'AFRO', '5', '761', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13553, '2020-12-20', 'BI', 'Burundi', 'AFRO', '0', '761', '1', '2');
INSERT INTO public.who_global_data_import VALUES (13554, '2020-12-21', 'BI', 'Burundi', 'AFRO', '1', '762', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13555, '2020-12-22', 'BI', 'Burundi', 'AFRO', '0', '762', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13556, '2020-12-23', 'BI', 'Burundi', 'AFRO', '11', '773', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13557, '2020-12-24', 'BI', 'Burundi', 'AFRO', '0', '773', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13558, '2020-12-25', 'BI', 'Burundi', 'AFRO', '13', '786', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13559, '2020-12-26', 'BI', 'Burundi', 'AFRO', '0', '786', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13560, '2020-12-27', 'BI', 'Burundi', 'AFRO', '18', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13561, '2020-12-28', 'BI', 'Burundi', 'AFRO', '0', '804', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13562, '2020-12-29', 'BI', 'Burundi', 'AFRO', '5', '809', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13563, '2020-12-30', 'BI', 'Burundi', 'AFRO', '0', '809', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13564, '2020-12-31', 'BI', 'Burundi', 'AFRO', '9', '818', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13565, '2021-01-01', 'BI', 'Burundi', 'AFRO', '4', '822', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13566, '2021-01-02', 'BI', 'Burundi', 'AFRO', '0', '822', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13567, '2021-01-03', 'BI', 'Burundi', 'AFRO', '11', '833', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13568, '2021-01-04', 'BI', 'Burundi', 'AFRO', '9', '842', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13569, '2021-01-05', 'BI', 'Burundi', 'AFRO', '0', '842', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13570, '2021-01-06', 'BI', 'Burundi', 'AFRO', '0', '842', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13571, '2021-01-07', 'BI', 'Burundi', 'AFRO', '43', '885', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13572, '2021-01-08', 'BI', 'Burundi', 'AFRO', '0', '885', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13573, '2021-01-09', 'BI', 'Burundi', 'AFRO', '0', '885', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13574, '2021-01-10', 'BI', 'Burundi', 'AFRO', '101', '986', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13575, '2021-01-11', 'BI', 'Burundi', 'AFRO', '33', '1019', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13576, '2021-01-12', 'BI', 'Burundi', 'AFRO', '0', '1019', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13577, '2021-01-13', 'BI', 'Burundi', 'AFRO', '43', '1062', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13578, '2021-01-14', 'BI', 'Burundi', 'AFRO', '41', '1103', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13579, '2021-01-15', 'BI', 'Burundi', 'AFRO', '47', '1150', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13580, '2021-01-16', 'BI', 'Burundi', 'AFRO', '35', '1185', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13581, '2021-01-17', 'BI', 'Burundi', 'AFRO', '51', '1236', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13582, '2021-01-18', 'BI', 'Burundi', 'AFRO', '9', '1245', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13583, '2021-01-19', 'BI', 'Burundi', 'AFRO', '8', '1253', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13584, '2021-01-20', 'BI', 'Burundi', 'AFRO', '69', '1322', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13585, '2021-01-21', 'BI', 'Burundi', 'AFRO', '36', '1358', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13586, '2021-01-22', 'BI', 'Burundi', 'AFRO', '22', '1380', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13587, '2021-01-23', 'BI', 'Burundi', 'AFRO', '58', '1438', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13588, '2021-01-24', 'BI', 'Burundi', 'AFRO', '34', '1472', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13589, '2021-01-25', 'BI', 'Burundi', 'AFRO', '7', '1479', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13590, '2021-01-26', 'BI', 'Burundi', 'AFRO', '2', '1481', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13591, '2021-01-27', 'BI', 'Burundi', 'AFRO', '61', '1542', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13592, '2021-01-28', 'BI', 'Burundi', 'AFRO', '42', '1584', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13593, '2021-01-29', 'BI', 'Burundi', 'AFRO', '20', '1604', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13594, '2021-01-30', 'BI', 'Burundi', 'AFRO', '9', '1613', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13595, '2021-01-31', 'BI', 'Burundi', 'AFRO', '19', '1632', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13596, '2021-02-01', 'BI', 'Burundi', 'AFRO', '3', '1635', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13597, '2021-02-02', 'BI', 'Burundi', 'AFRO', '6', '1641', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13598, '2021-02-03', 'BI', 'Burundi', 'AFRO', '23', '1664', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13599, '2021-02-04', 'BI', 'Burundi', 'AFRO', '22', '1686', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13600, '2021-02-05', 'BI', 'Burundi', 'AFRO', '12', '1698', '1', '3');
INSERT INTO public.who_global_data_import VALUES (13601, '2020-01-03', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13602, '2020-01-04', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13603, '2020-01-05', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13604, '2020-01-06', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13605, '2020-01-07', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13606, '2020-01-08', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13607, '2020-01-09', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13608, '2020-01-10', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13609, '2020-01-11', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13610, '2020-01-12', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13611, '2020-01-13', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13612, '2020-01-14', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13613, '2020-01-15', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13614, '2020-01-16', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13615, '2020-01-17', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13616, '2020-01-18', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13617, '2020-01-19', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13618, '2020-01-20', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13619, '2020-01-21', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13620, '2020-01-22', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13621, '2020-01-23', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13622, '2020-01-24', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13623, '2020-01-25', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13624, '2020-01-26', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13625, '2020-01-27', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13626, '2020-01-28', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13627, '2020-01-29', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13628, '2020-01-30', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13629, '2020-01-31', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13630, '2020-02-01', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13631, '2020-02-02', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13632, '2020-02-03', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13633, '2020-02-04', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13634, '2020-02-05', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13635, '2020-02-06', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13636, '2020-02-07', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13637, '2020-02-08', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13638, '2020-02-09', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13639, '2020-02-10', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13640, '2020-02-11', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13641, '2020-02-12', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13642, '2020-02-13', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13643, '2020-02-14', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13644, '2020-02-15', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13645, '2020-02-16', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13646, '2020-02-17', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13647, '2020-02-18', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13648, '2020-02-19', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13649, '2020-02-20', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13650, '2020-02-21', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13651, '2020-02-22', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13652, '2020-02-23', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13653, '2020-02-24', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13654, '2020-02-25', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13655, '2020-02-26', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13656, '2020-02-27', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13657, '2020-02-28', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13658, '2020-02-29', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13659, '2020-03-01', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13660, '2020-03-02', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13661, '2020-03-03', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13662, '2020-03-04', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13663, '2020-03-05', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13664, '2020-03-06', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13665, '2020-03-07', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13666, '2020-03-08', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13667, '2020-03-09', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13668, '2020-03-10', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13669, '2020-03-11', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13670, '2020-03-12', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13671, '2020-03-13', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13672, '2020-03-14', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13673, '2020-03-15', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13674, '2020-03-16', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13675, '2020-03-17', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13676, '2020-03-18', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13677, '2020-03-19', 'CV', 'Cabo Verde', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13678, '2020-03-20', 'CV', 'Cabo Verde', 'AFRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13679, '2020-03-21', 'CV', 'Cabo Verde', 'AFRO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13680, '2020-03-22', 'CV', 'Cabo Verde', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13681, '2020-03-23', 'CV', 'Cabo Verde', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13682, '2020-03-24', 'CV', 'Cabo Verde', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13683, '2020-03-25', 'CV', 'Cabo Verde', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13684, '2020-03-26', 'CV', 'Cabo Verde', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13685, '2020-03-27', 'CV', 'Cabo Verde', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (13686, '2020-03-28', 'CV', 'Cabo Verde', 'AFRO', '2', '5', '1', '1');
INSERT INTO public.who_global_data_import VALUES (13687, '2020-03-29', 'CV', 'Cabo Verde', 'AFRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13688, '2020-03-30', 'CV', 'Cabo Verde', 'AFRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13689, '2020-03-31', 'CV', 'Cabo Verde', 'AFRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13690, '2020-04-01', 'CV', 'Cabo Verde', 'AFRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13691, '2020-04-02', 'CV', 'Cabo Verde', 'AFRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13692, '2020-04-03', 'CV', 'Cabo Verde', 'AFRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13693, '2020-04-04', 'CV', 'Cabo Verde', 'AFRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13694, '2020-04-05', 'CV', 'Cabo Verde', 'AFRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13695, '2020-04-06', 'CV', 'Cabo Verde', 'AFRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13696, '2020-04-07', 'CV', 'Cabo Verde', 'AFRO', '2', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13697, '2020-04-08', 'CV', 'Cabo Verde', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13698, '2020-04-09', 'CV', 'Cabo Verde', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13699, '2020-04-10', 'CV', 'Cabo Verde', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13700, '2020-04-11', 'CV', 'Cabo Verde', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13701, '2020-04-12', 'CV', 'Cabo Verde', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13702, '2020-04-13', 'CV', 'Cabo Verde', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13703, '2020-04-14', 'CV', 'Cabo Verde', 'AFRO', '3', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13704, '2020-04-15', 'CV', 'Cabo Verde', 'AFRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13705, '2020-04-16', 'CV', 'Cabo Verde', 'AFRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13706, '2020-04-17', 'CV', 'Cabo Verde', 'AFRO', '45', '55', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13707, '2020-04-18', 'CV', 'Cabo Verde', 'AFRO', '0', '55', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13708, '2020-04-19', 'CV', 'Cabo Verde', 'AFRO', '0', '55', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13709, '2020-04-20', 'CV', 'Cabo Verde', 'AFRO', '0', '55', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13710, '2020-04-21', 'CV', 'Cabo Verde', 'AFRO', '0', '55', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13711, '2020-04-22', 'CV', 'Cabo Verde', 'AFRO', '12', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13712, '2020-04-23', 'CV', 'Cabo Verde', 'AFRO', '0', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13713, '2020-04-24', 'CV', 'Cabo Verde', 'AFRO', '0', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13714, '2020-04-25', 'CV', 'Cabo Verde', 'AFRO', '21', '88', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13715, '2020-04-26', 'CV', 'Cabo Verde', 'AFRO', '2', '90', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13716, '2020-04-27', 'CV', 'Cabo Verde', 'AFRO', '16', '106', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13717, '2020-04-28', 'CV', 'Cabo Verde', 'AFRO', '0', '106', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13718, '2020-04-29', 'CV', 'Cabo Verde', 'AFRO', '7', '113', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13719, '2020-04-30', 'CV', 'Cabo Verde', 'AFRO', '0', '113', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13720, '2020-05-01', 'CV', 'Cabo Verde', 'AFRO', '8', '121', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13721, '2020-05-02', 'CV', 'Cabo Verde', 'AFRO', '0', '121', '0', '1');
INSERT INTO public.who_global_data_import VALUES (13722, '2020-05-03', 'CV', 'Cabo Verde', 'AFRO', '31', '152', '1', '2');
INSERT INTO public.who_global_data_import VALUES (13723, '2020-05-04', 'CV', 'Cabo Verde', 'AFRO', '13', '165', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13724, '2020-05-05', 'CV', 'Cabo Verde', 'AFRO', '0', '165', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13725, '2020-05-06', 'CV', 'Cabo Verde', 'AFRO', '21', '186', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13726, '2020-05-07', 'CV', 'Cabo Verde', 'AFRO', '5', '191', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13727, '2020-05-08', 'CV', 'Cabo Verde', 'AFRO', '27', '218', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13728, '2020-05-09', 'CV', 'Cabo Verde', 'AFRO', '12', '230', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13729, '2020-05-10', 'CV', 'Cabo Verde', 'AFRO', '6', '236', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13730, '2020-05-11', 'CV', 'Cabo Verde', 'AFRO', '10', '246', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13731, '2020-05-12', 'CV', 'Cabo Verde', 'AFRO', '14', '260', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13732, '2020-05-13', 'CV', 'Cabo Verde', 'AFRO', '10', '270', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13733, '2020-05-14', 'CV', 'Cabo Verde', 'AFRO', '19', '289', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13734, '2020-05-15', 'CV', 'Cabo Verde', 'AFRO', '26', '315', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13735, '2020-05-16', 'CV', 'Cabo Verde', 'AFRO', '11', '326', '0', '2');
INSERT INTO public.who_global_data_import VALUES (13736, '2020-05-17', 'CV', 'Cabo Verde', 'AFRO', '2', '328', '1', '3');
INSERT INTO public.who_global_data_import VALUES (13737, '2020-05-18', 'CV', 'Cabo Verde', 'AFRO', '0', '328', '0', '3');
INSERT INTO public.who_global_data_import VALUES (13738, '2020-05-19', 'CV', 'Cabo Verde', 'AFRO', '0', '328', '0', '3');
INSERT INTO public.who_global_data_import VALUES (13739, '2020-05-20', 'CV', 'Cabo Verde', 'AFRO', '7', '335', '0', '3');
INSERT INTO public.who_global_data_import VALUES (13740, '2020-05-21', 'CV', 'Cabo Verde', 'AFRO', '14', '349', '0', '3');
INSERT INTO public.who_global_data_import VALUES (13741, '2020-05-22', 'CV', 'Cabo Verde', 'AFRO', '7', '356', '0', '3');
INSERT INTO public.who_global_data_import VALUES (13742, '2020-05-23', 'CV', 'Cabo Verde', 'AFRO', '6', '362', '0', '3');
INSERT INTO public.who_global_data_import VALUES (13743, '2020-05-24', 'CV', 'Cabo Verde', 'AFRO', '9', '371', '0', '3');
INSERT INTO public.who_global_data_import VALUES (13744, '2020-05-25', 'CV', 'Cabo Verde', 'AFRO', '9', '380', '0', '3');
INSERT INTO public.who_global_data_import VALUES (13745, '2020-05-26', 'CV', 'Cabo Verde', 'AFRO', '10', '390', '0', '3');
INSERT INTO public.who_global_data_import VALUES (13746, '2020-05-27', 'CV', 'Cabo Verde', 'AFRO', '0', '390', '1', '4');
INSERT INTO public.who_global_data_import VALUES (13747, '2020-05-28', 'CV', 'Cabo Verde', 'AFRO', '0', '390', '0', '4');
INSERT INTO public.who_global_data_import VALUES (13748, '2020-05-29', 'CV', 'Cabo Verde', 'AFRO', '0', '390', '0', '4');
INSERT INTO public.who_global_data_import VALUES (13749, '2020-05-30', 'CV', 'Cabo Verde', 'AFRO', '15', '405', '0', '4');
INSERT INTO public.who_global_data_import VALUES (13750, '2020-05-31', 'CV', 'Cabo Verde', 'AFRO', '16', '421', '0', '4');
INSERT INTO public.who_global_data_import VALUES (13751, '2020-06-01', 'CV', 'Cabo Verde', 'AFRO', '14', '435', '0', '4');
INSERT INTO public.who_global_data_import VALUES (13752, '2020-06-02', 'CV', 'Cabo Verde', 'AFRO', '23', '458', '0', '4');
INSERT INTO public.who_global_data_import VALUES (13753, '2020-06-03', 'CV', 'Cabo Verde', 'AFRO', '8', '466', '1', '5');
INSERT INTO public.who_global_data_import VALUES (13754, '2020-06-04', 'CV', 'Cabo Verde', 'AFRO', '11', '477', '0', '5');
INSERT INTO public.who_global_data_import VALUES (13755, '2020-06-05', 'CV', 'Cabo Verde', 'AFRO', '25', '502', '0', '5');
INSERT INTO public.who_global_data_import VALUES (13756, '2020-06-06', 'CV', 'Cabo Verde', 'AFRO', '34', '536', '0', '5');
INSERT INTO public.who_global_data_import VALUES (13757, '2020-06-07', 'CV', 'Cabo Verde', 'AFRO', '6', '542', '0', '5');
INSERT INTO public.who_global_data_import VALUES (13758, '2020-06-08', 'CV', 'Cabo Verde', 'AFRO', '12', '554', '0', '5');
INSERT INTO public.who_global_data_import VALUES (13759, '2020-06-09', 'CV', 'Cabo Verde', 'AFRO', '13', '567', '0', '5');
INSERT INTO public.who_global_data_import VALUES (13760, '2020-06-10', 'CV', 'Cabo Verde', 'AFRO', '18', '585', '0', '5');
INSERT INTO public.who_global_data_import VALUES (13761, '2020-06-11', 'CV', 'Cabo Verde', 'AFRO', '31', '616', '0', '5');
INSERT INTO public.who_global_data_import VALUES (13762, '2020-06-12', 'CV', 'Cabo Verde', 'AFRO', '41', '657', '1', '6');
INSERT INTO public.who_global_data_import VALUES (13763, '2020-06-13', 'CV', 'Cabo Verde', 'AFRO', '40', '697', '0', '6');
INSERT INTO public.who_global_data_import VALUES (13764, '2020-06-14', 'CV', 'Cabo Verde', 'AFRO', '29', '726', '0', '6');
INSERT INTO public.who_global_data_import VALUES (13765, '2020-06-15', 'CV', 'Cabo Verde', 'AFRO', '24', '750', '0', '6');
INSERT INTO public.who_global_data_import VALUES (13766, '2020-06-16', 'CV', 'Cabo Verde', 'AFRO', '10', '760', '1', '7');
INSERT INTO public.who_global_data_import VALUES (13767, '2020-06-17', 'CV', 'Cabo Verde', 'AFRO', '21', '781', '0', '7');
INSERT INTO public.who_global_data_import VALUES (13768, '2020-06-18', 'CV', 'Cabo Verde', 'AFRO', '11', '792', '0', '7');
INSERT INTO public.who_global_data_import VALUES (13769, '2020-06-19', 'CV', 'Cabo Verde', 'AFRO', '31', '823', '0', '7');
INSERT INTO public.who_global_data_import VALUES (13770, '2020-06-20', 'CV', 'Cabo Verde', 'AFRO', '25', '848', '1', '8');
INSERT INTO public.who_global_data_import VALUES (13771, '2020-06-21', 'CV', 'Cabo Verde', 'AFRO', '15', '863', '0', '8');
INSERT INTO public.who_global_data_import VALUES (13772, '2020-06-22', 'CV', 'Cabo Verde', 'AFRO', '27', '890', '0', '8');
INSERT INTO public.who_global_data_import VALUES (13773, '2020-06-23', 'CV', 'Cabo Verde', 'AFRO', '54', '944', '0', '8');
INSERT INTO public.who_global_data_import VALUES (13774, '2020-06-24', 'CV', 'Cabo Verde', 'AFRO', '39', '983', '0', '8');
INSERT INTO public.who_global_data_import VALUES (13775, '2020-06-25', 'CV', 'Cabo Verde', 'AFRO', '16', '999', '0', '8');
INSERT INTO public.who_global_data_import VALUES (13776, '2020-06-26', 'CV', 'Cabo Verde', 'AFRO', '4', '1003', '0', '8');
INSERT INTO public.who_global_data_import VALUES (13777, '2020-06-27', 'CV', 'Cabo Verde', 'AFRO', '24', '1027', '2', '10');
INSERT INTO public.who_global_data_import VALUES (13778, '2020-06-28', 'CV', 'Cabo Verde', 'AFRO', '64', '1091', '2', '12');
INSERT INTO public.who_global_data_import VALUES (13779, '2020-06-29', 'CV', 'Cabo Verde', 'AFRO', '64', '1155', '0', '12');
INSERT INTO public.who_global_data_import VALUES (13780, '2020-06-30', 'CV', 'Cabo Verde', 'AFRO', '10', '1165', '0', '12');
INSERT INTO public.who_global_data_import VALUES (13781, '2020-07-01', 'CV', 'Cabo Verde', 'AFRO', '62', '1227', '3', '15');
INSERT INTO public.who_global_data_import VALUES (13782, '2020-07-02', 'CV', 'Cabo Verde', 'AFRO', '40', '1267', '0', '15');
INSERT INTO public.who_global_data_import VALUES (13783, '2020-07-03', 'CV', 'Cabo Verde', 'AFRO', '34', '1301', '0', '15');
INSERT INTO public.who_global_data_import VALUES (13784, '2020-07-04', 'CV', 'Cabo Verde', 'AFRO', '81', '1382', '0', '15');
INSERT INTO public.who_global_data_import VALUES (13785, '2020-07-05', 'CV', 'Cabo Verde', 'AFRO', '38', '1420', '1', '16');
INSERT INTO public.who_global_data_import VALUES (13786, '2020-07-06', 'CV', 'Cabo Verde', 'AFRO', '31', '1451', '1', '17');
INSERT INTO public.who_global_data_import VALUES (13787, '2020-07-07', 'CV', 'Cabo Verde', 'AFRO', '12', '1463', '0', '17');
INSERT INTO public.who_global_data_import VALUES (13788, '2020-07-08', 'CV', 'Cabo Verde', 'AFRO', '36', '1499', '1', '18');
INSERT INTO public.who_global_data_import VALUES (13789, '2020-07-09', 'CV', 'Cabo Verde', 'AFRO', '43', '1542', '0', '18');
INSERT INTO public.who_global_data_import VALUES (13790, '2020-07-10', 'CV', 'Cabo Verde', 'AFRO', '11', '1553', '1', '19');
INSERT INTO public.who_global_data_import VALUES (13791, '2020-07-11', 'CV', 'Cabo Verde', 'AFRO', '38', '1591', '0', '19');
INSERT INTO public.who_global_data_import VALUES (13792, '2020-07-12', 'CV', 'Cabo Verde', 'AFRO', '32', '1623', '0', '19');
INSERT INTO public.who_global_data_import VALUES (13793, '2020-07-13', 'CV', 'Cabo Verde', 'AFRO', '75', '1698', '0', '19');
INSERT INTO public.who_global_data_import VALUES (13794, '2020-07-14', 'CV', 'Cabo Verde', 'AFRO', '24', '1722', '0', '19');
INSERT INTO public.who_global_data_import VALUES (13795, '2020-07-15', 'CV', 'Cabo Verde', 'AFRO', '58', '1780', '0', '19');
INSERT INTO public.who_global_data_import VALUES (13796, '2020-07-16', 'CV', 'Cabo Verde', 'AFRO', '57', '1837', '0', '19');
INSERT INTO public.who_global_data_import VALUES (13797, '2020-07-17', 'CV', 'Cabo Verde', 'AFRO', '57', '1894', '0', '19');
INSERT INTO public.who_global_data_import VALUES (13798, '2020-07-18', 'CV', 'Cabo Verde', 'AFRO', '45', '1939', '1', '20');
INSERT INTO public.who_global_data_import VALUES (13799, '2020-07-19', 'CV', 'Cabo Verde', 'AFRO', '75', '2014', '1', '21');
INSERT INTO public.who_global_data_import VALUES (13800, '2020-07-20', 'CV', 'Cabo Verde', 'AFRO', '29', '2043', '0', '21');
INSERT INTO public.who_global_data_import VALUES (13801, '2020-07-21', 'CV', 'Cabo Verde', 'AFRO', '28', '2071', '0', '21');
INSERT INTO public.who_global_data_import VALUES (13802, '2020-07-22', 'CV', 'Cabo Verde', 'AFRO', '36', '2107', '0', '21');
INSERT INTO public.who_global_data_import VALUES (13803, '2020-07-23', 'CV', 'Cabo Verde', 'AFRO', '47', '2154', '0', '21');
INSERT INTO public.who_global_data_import VALUES (13804, '2020-07-24', 'CV', 'Cabo Verde', 'AFRO', '36', '2190', '0', '21');
INSERT INTO public.who_global_data_import VALUES (13805, '2020-07-25', 'CV', 'Cabo Verde', 'AFRO', '30', '2220', '1', '22');
INSERT INTO public.who_global_data_import VALUES (13806, '2020-07-26', 'CV', 'Cabo Verde', 'AFRO', '38', '2258', '0', '22');
INSERT INTO public.who_global_data_import VALUES (13807, '2020-07-27', 'CV', 'Cabo Verde', 'AFRO', '49', '2307', '0', '22');
INSERT INTO public.who_global_data_import VALUES (13808, '2020-07-28', 'CV', 'Cabo Verde', 'AFRO', '21', '2328', '0', '22');
INSERT INTO public.who_global_data_import VALUES (13809, '2020-07-29', 'CV', 'Cabo Verde', 'AFRO', '26', '2354', '0', '22');
INSERT INTO public.who_global_data_import VALUES (13810, '2020-07-30', 'CV', 'Cabo Verde', 'AFRO', '19', '2373', '1', '23');
INSERT INTO public.who_global_data_import VALUES (13811, '2020-07-31', 'CV', 'Cabo Verde', 'AFRO', '45', '2418', '0', '23');
INSERT INTO public.who_global_data_import VALUES (13812, '2020-08-01', 'CV', 'Cabo Verde', 'AFRO', '33', '2451', '0', '23');
INSERT INTO public.who_global_data_import VALUES (13813, '2020-08-02', 'CV', 'Cabo Verde', 'AFRO', '29', '2480', '1', '24');
INSERT INTO public.who_global_data_import VALUES (13814, '2020-08-03', 'CV', 'Cabo Verde', 'AFRO', '67', '2547', '0', '24');
INSERT INTO public.who_global_data_import VALUES (13815, '2020-08-04', 'CV', 'Cabo Verde', 'AFRO', '36', '2583', '1', '25');
INSERT INTO public.who_global_data_import VALUES (13816, '2020-08-05', 'CV', 'Cabo Verde', 'AFRO', '48', '2631', '1', '26');
INSERT INTO public.who_global_data_import VALUES (13817, '2020-08-06', 'CV', 'Cabo Verde', 'AFRO', '58', '2689', '1', '27');
INSERT INTO public.who_global_data_import VALUES (13818, '2020-08-07', 'CV', 'Cabo Verde', 'AFRO', '45', '2734', '0', '27');
INSERT INTO public.who_global_data_import VALUES (13819, '2020-08-08', 'CV', 'Cabo Verde', 'AFRO', '46', '2780', '2', '29');
INSERT INTO public.who_global_data_import VALUES (13820, '2020-08-09', 'CV', 'Cabo Verde', 'AFRO', '55', '2835', '3', '32');
INSERT INTO public.who_global_data_import VALUES (13821, '2020-08-10', 'CV', 'Cabo Verde', 'AFRO', '23', '2858', '0', '32');
INSERT INTO public.who_global_data_import VALUES (13822, '2020-08-11', 'CV', 'Cabo Verde', 'AFRO', '25', '2883', '0', '32');
INSERT INTO public.who_global_data_import VALUES (13823, '2020-08-12', 'CV', 'Cabo Verde', 'AFRO', '37', '2920', '1', '33');
INSERT INTO public.who_global_data_import VALUES (13824, '2020-08-13', 'CV', 'Cabo Verde', 'AFRO', '80', '3000', '0', '33');
INSERT INTO public.who_global_data_import VALUES (13825, '2020-08-14', 'CV', 'Cabo Verde', 'AFRO', '73', '3073', '0', '33');
INSERT INTO public.who_global_data_import VALUES (13826, '2020-08-15', 'CV', 'Cabo Verde', 'AFRO', '63', '3136', '0', '33');
INSERT INTO public.who_global_data_import VALUES (13827, '2020-08-16', 'CV', 'Cabo Verde', 'AFRO', '27', '3163', '1', '34');
INSERT INTO public.who_global_data_import VALUES (13828, '2020-08-17', 'CV', 'Cabo Verde', 'AFRO', '16', '3179', '1', '35');
INSERT INTO public.who_global_data_import VALUES (13829, '2020-08-18', 'CV', 'Cabo Verde', 'AFRO', '24', '3203', '1', '36');
INSERT INTO public.who_global_data_import VALUES (13830, '2020-08-19', 'CV', 'Cabo Verde', 'AFRO', '50', '3253', '0', '36');
INSERT INTO public.who_global_data_import VALUES (13831, '2020-08-20', 'CV', 'Cabo Verde', 'AFRO', '68', '3321', '0', '36');
INSERT INTO public.who_global_data_import VALUES (13832, '2020-08-21', 'CV', 'Cabo Verde', 'AFRO', '47', '3368', '1', '37');
INSERT INTO public.who_global_data_import VALUES (13833, '2020-08-22', 'CV', 'Cabo Verde', 'AFRO', '44', '3412', '0', '37');
INSERT INTO public.who_global_data_import VALUES (13834, '2020-08-23', 'CV', 'Cabo Verde', 'AFRO', '43', '3455', '0', '37');
INSERT INTO public.who_global_data_import VALUES (13835, '2020-08-24', 'CV', 'Cabo Verde', 'AFRO', '54', '3509', '0', '37');
INSERT INTO public.who_global_data_import VALUES (13836, '2020-08-25', 'CV', 'Cabo Verde', 'AFRO', '23', '3532', '0', '37');
INSERT INTO public.who_global_data_import VALUES (13837, '2020-08-26', 'CV', 'Cabo Verde', 'AFRO', '36', '3568', '0', '37');
INSERT INTO public.who_global_data_import VALUES (13838, '2020-08-27', 'CV', 'Cabo Verde', 'AFRO', '62', '3630', '1', '38');
INSERT INTO public.who_global_data_import VALUES (13839, '2020-08-28', 'CV', 'Cabo Verde', 'AFRO', '69', '3699', '0', '38');
INSERT INTO public.who_global_data_import VALUES (13840, '2020-08-29', 'CV', 'Cabo Verde', 'AFRO', '46', '3745', '0', '38');
INSERT INTO public.who_global_data_import VALUES (13841, '2020-08-30', 'CV', 'Cabo Verde', 'AFRO', '33', '3778', '1', '39');
INSERT INTO public.who_global_data_import VALUES (13842, '2020-08-31', 'CV', 'Cabo Verde', 'AFRO', '74', '3852', '1', '40');
INSERT INTO public.who_global_data_import VALUES (13843, '2020-09-01', 'CV', 'Cabo Verde', 'AFRO', '32', '3884', '0', '40');
INSERT INTO public.who_global_data_import VALUES (13844, '2020-09-02', 'CV', 'Cabo Verde', 'AFRO', '86', '3970', '0', '40');
INSERT INTO public.who_global_data_import VALUES (13845, '2020-09-03', 'CV', 'Cabo Verde', 'AFRO', '78', '4048', '1', '41');
INSERT INTO public.who_global_data_import VALUES (13846, '2020-09-04', 'CV', 'Cabo Verde', 'AFRO', '77', '4125', '0', '41');
INSERT INTO public.who_global_data_import VALUES (13847, '2020-09-05', 'CV', 'Cabo Verde', 'AFRO', '75', '4200', '0', '41');
INSERT INTO public.who_global_data_import VALUES (13848, '2020-09-06', 'CV', 'Cabo Verde', 'AFRO', '75', '4275', '1', '42');
INSERT INTO public.who_global_data_import VALUES (13849, '2020-09-07', 'CV', 'Cabo Verde', 'AFRO', '55', '4330', '0', '42');
INSERT INTO public.who_global_data_import VALUES (13850, '2020-09-08', 'CV', 'Cabo Verde', 'AFRO', '28', '4358', '0', '42');
INSERT INTO public.who_global_data_import VALUES (13851, '2020-09-09', 'CV', 'Cabo Verde', 'AFRO', '42', '4400', '0', '42');
INSERT INTO public.who_global_data_import VALUES (13852, '2020-09-10', 'CV', 'Cabo Verde', 'AFRO', '73', '4473', '1', '43');
INSERT INTO public.who_global_data_import VALUES (13853, '2020-09-11', 'CV', 'Cabo Verde', 'AFRO', '84', '4557', '0', '43');
INSERT INTO public.who_global_data_import VALUES (13854, '2020-09-12', 'CV', 'Cabo Verde', 'AFRO', '94', '4651', '1', '44');
INSERT INTO public.who_global_data_import VALUES (13855, '2020-09-13', 'CV', 'Cabo Verde', 'AFRO', '60', '4711', '0', '44');
INSERT INTO public.who_global_data_import VALUES (13856, '2020-09-14', 'CV', 'Cabo Verde', 'AFRO', '102', '4813', '0', '44');
INSERT INTO public.who_global_data_import VALUES (13857, '2020-09-15', 'CV', 'Cabo Verde', 'AFRO', '26', '4839', '1', '45');
INSERT INTO public.who_global_data_import VALUES (13858, '2020-09-16', 'CV', 'Cabo Verde', 'AFRO', '65', '4904', '1', '46');
INSERT INTO public.who_global_data_import VALUES (13859, '2020-09-17', 'CV', 'Cabo Verde', 'AFRO', '74', '4978', '1', '47');
INSERT INTO public.who_global_data_import VALUES (13860, '2020-09-18', 'CV', 'Cabo Verde', 'AFRO', '85', '5063', '2', '49');
INSERT INTO public.who_global_data_import VALUES (13861, '2020-09-19', 'CV', 'Cabo Verde', 'AFRO', '78', '5141', '1', '50');
INSERT INTO public.who_global_data_import VALUES (13862, '2020-09-20', 'CV', 'Cabo Verde', 'AFRO', '45', '5186', '0', '50');
INSERT INTO public.who_global_data_import VALUES (13863, '2020-09-21', 'CV', 'Cabo Verde', 'AFRO', '71', '5257', '1', '51');
INSERT INTO public.who_global_data_import VALUES (13864, '2020-09-22', 'CV', 'Cabo Verde', 'AFRO', '24', '5281', '1', '52');
INSERT INTO public.who_global_data_import VALUES (13865, '2020-09-23', 'CV', 'Cabo Verde', 'AFRO', '56', '5337', '0', '52');
INSERT INTO public.who_global_data_import VALUES (13866, '2020-09-24', 'CV', 'Cabo Verde', 'AFRO', '75', '5412', '2', '54');
INSERT INTO public.who_global_data_import VALUES (13867, '2020-09-25', 'CV', 'Cabo Verde', 'AFRO', '67', '5479', '1', '55');
INSERT INTO public.who_global_data_import VALUES (13868, '2020-09-26', 'CV', 'Cabo Verde', 'AFRO', '149', '5628', '0', '55');
INSERT INTO public.who_global_data_import VALUES (13869, '2020-09-27', 'CV', 'Cabo Verde', 'AFRO', '73', '5701', '1', '56');
INSERT INTO public.who_global_data_import VALUES (13870, '2020-09-28', 'CV', 'Cabo Verde', 'AFRO', '70', '5771', '1', '57');
INSERT INTO public.who_global_data_import VALUES (13871, '2020-09-29', 'CV', 'Cabo Verde', 'AFRO', '46', '5817', '2', '59');
INSERT INTO public.who_global_data_import VALUES (13872, '2020-09-30', 'CV', 'Cabo Verde', 'AFRO', '83', '5900', '0', '59');
INSERT INTO public.who_global_data_import VALUES (13873, '2020-10-01', 'CV', 'Cabo Verde', 'AFRO', '124', '6024', '1', '60');
INSERT INTO public.who_global_data_import VALUES (13874, '2020-10-02', 'CV', 'Cabo Verde', 'AFRO', '102', '6126', '1', '61');
INSERT INTO public.who_global_data_import VALUES (13875, '2020-10-03', 'CV', 'Cabo Verde', 'AFRO', '79', '6205', '1', '62');
INSERT INTO public.who_global_data_import VALUES (13876, '2020-10-04', 'CV', 'Cabo Verde', 'AFRO', '91', '6296', '0', '62');
INSERT INTO public.who_global_data_import VALUES (13877, '2020-10-05', 'CV', 'Cabo Verde', 'AFRO', '64', '6360', '3', '65');
INSERT INTO public.who_global_data_import VALUES (13878, '2020-10-06', 'CV', 'Cabo Verde', 'AFRO', '73', '6433', '3', '68');
INSERT INTO public.who_global_data_import VALUES (13879, '2020-10-07', 'CV', 'Cabo Verde', 'AFRO', '85', '6518', '1', '69');
INSERT INTO public.who_global_data_import VALUES (13880, '2020-10-08', 'CV', 'Cabo Verde', 'AFRO', '106', '6624', '2', '71');
INSERT INTO public.who_global_data_import VALUES (13881, '2020-10-09', 'CV', 'Cabo Verde', 'AFRO', '93', '6717', '0', '71');
INSERT INTO public.who_global_data_import VALUES (13882, '2020-10-10', 'CV', 'Cabo Verde', 'AFRO', '92', '6809', '2', '73');
INSERT INTO public.who_global_data_import VALUES (13883, '2020-10-11', 'CV', 'Cabo Verde', 'AFRO', '104', '6913', '1', '74');
INSERT INTO public.who_global_data_import VALUES (13884, '2020-10-12', 'CV', 'Cabo Verde', 'AFRO', '159', '7072', '1', '75');
INSERT INTO public.who_global_data_import VALUES (13885, '2020-10-13', 'CV', 'Cabo Verde', 'AFRO', '83', '7155', '0', '75');
INSERT INTO public.who_global_data_import VALUES (13886, '2020-10-14', 'CV', 'Cabo Verde', 'AFRO', '99', '7254', '2', '77');
INSERT INTO public.who_global_data_import VALUES (13887, '2020-10-15', 'CV', 'Cabo Verde', 'AFRO', '117', '7371', '2', '79');
INSERT INTO public.who_global_data_import VALUES (13888, '2020-10-16', 'CV', 'Cabo Verde', 'AFRO', '73', '7444', '0', '79');
INSERT INTO public.who_global_data_import VALUES (13889, '2020-10-17', 'CV', 'Cabo Verde', 'AFRO', '82', '7526', '3', '82');
INSERT INTO public.who_global_data_import VALUES (13890, '2020-10-18', 'CV', 'Cabo Verde', 'AFRO', '112', '7638', '3', '85');
INSERT INTO public.who_global_data_import VALUES (13891, '2020-10-19', 'CV', 'Cabo Verde', 'AFRO', '114', '7752', '1', '86');
INSERT INTO public.who_global_data_import VALUES (13892, '2020-10-20', 'CV', 'Cabo Verde', 'AFRO', '48', '7800', '1', '87');
INSERT INTO public.who_global_data_import VALUES (13893, '2020-10-21', 'CV', 'Cabo Verde', 'AFRO', '101', '7901', '0', '87');
INSERT INTO public.who_global_data_import VALUES (13894, '2020-10-22', 'CV', 'Cabo Verde', 'AFRO', '132', '8033', '3', '90');
INSERT INTO public.who_global_data_import VALUES (13895, '2020-10-23', 'CV', 'Cabo Verde', 'AFRO', '89', '8122', '1', '91');
INSERT INTO public.who_global_data_import VALUES (13896, '2020-10-24', 'CV', 'Cabo Verde', 'AFRO', '76', '8198', '3', '94');
INSERT INTO public.who_global_data_import VALUES (13897, '2020-10-25', 'CV', 'Cabo Verde', 'AFRO', '124', '8322', '0', '94');
INSERT INTO public.who_global_data_import VALUES (13898, '2020-10-26', 'CV', 'Cabo Verde', 'AFRO', '74', '8396', '0', '94');
INSERT INTO public.who_global_data_import VALUES (13899, '2020-10-27', 'CV', 'Cabo Verde', 'AFRO', '27', '8423', '0', '94');
INSERT INTO public.who_global_data_import VALUES (13900, '2020-10-28', 'CV', 'Cabo Verde', 'AFRO', '49', '8472', '0', '94');
INSERT INTO public.who_global_data_import VALUES (13901, '2020-10-29', 'CV', 'Cabo Verde', 'AFRO', '76', '8548', '0', '94');
INSERT INTO public.who_global_data_import VALUES (13902, '2020-10-30', 'CV', 'Cabo Verde', 'AFRO', '55', '8603', '1', '95');
INSERT INTO public.who_global_data_import VALUES (13903, '2020-10-31', 'CV', 'Cabo Verde', 'AFRO', '91', '8694', '0', '95');
INSERT INTO public.who_global_data_import VALUES (13904, '2020-11-01', 'CV', 'Cabo Verde', 'AFRO', '99', '8793', '0', '95');
INSERT INTO public.who_global_data_import VALUES (13905, '2020-11-02', 'CV', 'Cabo Verde', 'AFRO', '55', '8848', '0', '95');
INSERT INTO public.who_global_data_import VALUES (13906, '2020-11-03', 'CV', 'Cabo Verde', 'AFRO', '34', '8882', '0', '95');
INSERT INTO public.who_global_data_import VALUES (13907, '2020-11-04', 'CV', 'Cabo Verde', 'AFRO', '62', '8944', '0', '95');
INSERT INTO public.who_global_data_import VALUES (13908, '2020-11-05', 'CV', 'Cabo Verde', 'AFRO', '109', '9053', '0', '95');
INSERT INTO public.who_global_data_import VALUES (13909, '2020-11-06', 'CV', 'Cabo Verde', 'AFRO', '96', '9149', '2', '97');
INSERT INTO public.who_global_data_import VALUES (13910, '2020-11-07', 'CV', 'Cabo Verde', 'AFRO', '75', '9224', '3', '100');
INSERT INTO public.who_global_data_import VALUES (13911, '2020-11-08', 'CV', 'Cabo Verde', 'AFRO', '67', '9291', '0', '100');
INSERT INTO public.who_global_data_import VALUES (13912, '2020-11-09', 'CV', 'Cabo Verde', 'AFRO', '78', '9369', '0', '100');
INSERT INTO public.who_global_data_import VALUES (13913, '2020-11-10', 'CV', 'Cabo Verde', 'AFRO', '50', '9419', '0', '100');
INSERT INTO public.who_global_data_import VALUES (13914, '2020-11-11', 'CV', 'Cabo Verde', 'AFRO', '80', '9499', '1', '101');
INSERT INTO public.who_global_data_import VALUES (13915, '2020-11-12', 'CV', 'Cabo Verde', 'AFRO', '61', '9560', '1', '102');
INSERT INTO public.who_global_data_import VALUES (13916, '2020-11-13', 'CV', 'Cabo Verde', 'AFRO', '134', '9694', '0', '102');
INSERT INTO public.who_global_data_import VALUES (13917, '2020-11-14', 'CV', 'Cabo Verde', 'AFRO', '47', '9741', '0', '102');
INSERT INTO public.who_global_data_import VALUES (13918, '2020-11-15', 'CV', 'Cabo Verde', 'AFRO', '39', '9780', '0', '102');
INSERT INTO public.who_global_data_import VALUES (13919, '2020-11-16', 'CV', 'Cabo Verde', 'AFRO', '42', '9822', '1', '103');
INSERT INTO public.who_global_data_import VALUES (13920, '2020-11-17', 'CV', 'Cabo Verde', 'AFRO', '18', '9840', '0', '103');
INSERT INTO public.who_global_data_import VALUES (13921, '2020-11-18', 'CV', 'Cabo Verde', 'AFRO', '120', '9960', '0', '103');
INSERT INTO public.who_global_data_import VALUES (13922, '2020-11-19', 'CV', 'Cabo Verde', 'AFRO', '40', '10000', '1', '104');
INSERT INTO public.who_global_data_import VALUES (13923, '2020-11-20', 'CV', 'Cabo Verde', 'AFRO', '82', '10082', '0', '104');
INSERT INTO public.who_global_data_import VALUES (13924, '2020-11-21', 'CV', 'Cabo Verde', 'AFRO', '70', '10152', '0', '104');
INSERT INTO public.who_global_data_import VALUES (13925, '2020-11-22', 'CV', 'Cabo Verde', 'AFRO', '82', '10234', '0', '104');
INSERT INTO public.who_global_data_import VALUES (13926, '2020-11-23', 'CV', 'Cabo Verde', 'AFRO', '42', '10276', '0', '104');
INSERT INTO public.who_global_data_import VALUES (13927, '2020-11-24', 'CV', 'Cabo Verde', 'AFRO', '26', '10302', '0', '104');
INSERT INTO public.who_global_data_import VALUES (13928, '2020-11-25', 'CV', 'Cabo Verde', 'AFRO', '98', '10400', '0', '104');
INSERT INTO public.who_global_data_import VALUES (13929, '2020-11-26', 'CV', 'Cabo Verde', 'AFRO', '126', '10526', '0', '104');
INSERT INTO public.who_global_data_import VALUES (13930, '2020-11-27', 'CV', 'Cabo Verde', 'AFRO', '0', '10526', '0', '104');
INSERT INTO public.who_global_data_import VALUES (13931, '2020-11-28', 'CV', 'Cabo Verde', 'AFRO', '0', '10526', '0', '104');
INSERT INTO public.who_global_data_import VALUES (13932, '2020-11-29', 'CV', 'Cabo Verde', 'AFRO', '0', '10526', '0', '104');
INSERT INTO public.who_global_data_import VALUES (13933, '2020-11-30', 'CV', 'Cabo Verde', 'AFRO', '0', '10526', '0', '104');
INSERT INTO public.who_global_data_import VALUES (13934, '2020-12-01', 'CV', 'Cabo Verde', 'AFRO', '0', '10526', '0', '104');
INSERT INTO public.who_global_data_import VALUES (13935, '2020-12-02', 'CV', 'Cabo Verde', 'AFRO', '100', '10626', '1', '105');
INSERT INTO public.who_global_data_import VALUES (13936, '2020-12-03', 'CV', 'Cabo Verde', 'AFRO', '0', '10626', '0', '105');
INSERT INTO public.who_global_data_import VALUES (13937, '2020-12-04', 'CV', 'Cabo Verde', 'AFRO', '0', '10626', '0', '105');
INSERT INTO public.who_global_data_import VALUES (13938, '2020-12-05', 'CV', 'Cabo Verde', 'AFRO', '0', '10626', '0', '105');
INSERT INTO public.who_global_data_import VALUES (13939, '2020-12-06', 'CV', 'Cabo Verde', 'AFRO', '0', '10626', '0', '105');
INSERT INTO public.who_global_data_import VALUES (13940, '2020-12-07', 'CV', 'Cabo Verde', 'AFRO', '0', '10626', '0', '105');
INSERT INTO public.who_global_data_import VALUES (13941, '2020-12-08', 'CV', 'Cabo Verde', 'AFRO', '0', '10626', '0', '105');
INSERT INTO public.who_global_data_import VALUES (13942, '2020-12-09', 'CV', 'Cabo Verde', 'AFRO', '0', '10626', '0', '105');
INSERT INTO public.who_global_data_import VALUES (13943, '2020-12-10', 'CV', 'Cabo Verde', 'AFRO', '0', '10626', '0', '105');
INSERT INTO public.who_global_data_import VALUES (13944, '2020-12-11', 'CV', 'Cabo Verde', 'AFRO', '0', '10626', '0', '105');
INSERT INTO public.who_global_data_import VALUES (13945, '2020-12-12', 'CV', 'Cabo Verde', 'AFRO', '636', '11262', '5', '110');
INSERT INTO public.who_global_data_import VALUES (13946, '2020-12-13', 'CV', 'Cabo Verde', 'AFRO', '40', '11302', '0', '110');
INSERT INTO public.who_global_data_import VALUES (13947, '2020-12-14', 'CV', 'Cabo Verde', 'AFRO', '55', '11357', '0', '110');
INSERT INTO public.who_global_data_import VALUES (13948, '2020-12-15', 'CV', 'Cabo Verde', 'AFRO', '4', '11361', '0', '110');
INSERT INTO public.who_global_data_import VALUES (13949, '2020-12-16', 'CV', 'Cabo Verde', 'AFRO', '34', '11395', '0', '110');
INSERT INTO public.who_global_data_import VALUES (13950, '2020-12-17', 'CV', 'Cabo Verde', 'AFRO', '63', '11458', '0', '110');
INSERT INTO public.who_global_data_import VALUES (13951, '2020-12-18', 'CV', 'Cabo Verde', 'AFRO', '44', '11502', '0', '110');
INSERT INTO public.who_global_data_import VALUES (13952, '2020-12-19', 'CV', 'Cabo Verde', 'AFRO', '24', '11526', '0', '110');
INSERT INTO public.who_global_data_import VALUES (13953, '2020-12-20', 'CV', 'Cabo Verde', 'AFRO', '41', '11567', '1', '111');
INSERT INTO public.who_global_data_import VALUES (13954, '2020-12-21', 'CV', 'Cabo Verde', 'AFRO', '12', '11579', '0', '111');
INSERT INTO public.who_global_data_import VALUES (13955, '2020-12-22', 'CV', 'Cabo Verde', 'AFRO', '21', '11600', '0', '111');
INSERT INTO public.who_global_data_import VALUES (13956, '2020-12-23', 'CV', 'Cabo Verde', 'AFRO', '36', '11636', '1', '112');
INSERT INTO public.who_global_data_import VALUES (13957, '2020-12-24', 'CV', 'Cabo Verde', 'AFRO', '32', '11668', '0', '112');
INSERT INTO public.who_global_data_import VALUES (13958, '2020-12-25', 'CV', 'Cabo Verde', 'AFRO', '0', '11668', '0', '112');
INSERT INTO public.who_global_data_import VALUES (13959, '2020-12-26', 'CV', 'Cabo Verde', 'AFRO', '28', '11696', '0', '112');
INSERT INTO public.who_global_data_import VALUES (13960, '2020-12-27', 'CV', 'Cabo Verde', 'AFRO', '2', '11698', '0', '112');
INSERT INTO public.who_global_data_import VALUES (13961, '2020-12-28', 'CV', 'Cabo Verde', 'AFRO', '16', '11714', '0', '112');
INSERT INTO public.who_global_data_import VALUES (13962, '2020-12-29', 'CV', 'Cabo Verde', 'AFRO', '9', '11723', '0', '112');
INSERT INTO public.who_global_data_import VALUES (13963, '2020-12-30', 'CV', 'Cabo Verde', 'AFRO', '29', '11752', '0', '112');
INSERT INTO public.who_global_data_import VALUES (13964, '2020-12-31', 'CV', 'Cabo Verde', 'AFRO', '41', '11793', '0', '112');
INSERT INTO public.who_global_data_import VALUES (13965, '2021-01-01', 'CV', 'Cabo Verde', 'AFRO', '47', '11840', '1', '113');
INSERT INTO public.who_global_data_import VALUES (13966, '2021-01-02', 'CV', 'Cabo Verde', 'AFRO', '0', '11840', '0', '113');
INSERT INTO public.who_global_data_import VALUES (13967, '2021-01-03', 'CV', 'Cabo Verde', 'AFRO', '43', '11883', '0', '113');
INSERT INTO public.who_global_data_import VALUES (13968, '2021-01-04', 'CV', 'Cabo Verde', 'AFRO', '37', '11920', '0', '113');
INSERT INTO public.who_global_data_import VALUES (13969, '2021-01-05', 'CV', 'Cabo Verde', 'AFRO', '29', '11949', '0', '113');
INSERT INTO public.who_global_data_import VALUES (13970, '2021-01-06', 'CV', 'Cabo Verde', 'AFRO', '34', '11983', '0', '113');
INSERT INTO public.who_global_data_import VALUES (13971, '2021-01-07', 'CV', 'Cabo Verde', 'AFRO', '69', '12052', '0', '113');
INSERT INTO public.who_global_data_import VALUES (13972, '2021-01-08', 'CV', 'Cabo Verde', 'AFRO', '94', '12146', '0', '113');
INSERT INTO public.who_global_data_import VALUES (13973, '2021-01-09', 'CV', 'Cabo Verde', 'AFRO', '91', '12237', '1', '114');
INSERT INTO public.who_global_data_import VALUES (13974, '2021-01-10', 'CV', 'Cabo Verde', 'AFRO', '0', '12237', '0', '114');
INSERT INTO public.who_global_data_import VALUES (13975, '2021-01-11', 'CV', 'Cabo Verde', 'AFRO', '155', '12392', '0', '114');
INSERT INTO public.who_global_data_import VALUES (13976, '2021-01-12', 'CV', 'Cabo Verde', 'AFRO', '41', '12433', '1', '115');
INSERT INTO public.who_global_data_import VALUES (13977, '2021-01-13', 'CV', 'Cabo Verde', 'AFRO', '73', '12506', '0', '115');
INSERT INTO public.who_global_data_import VALUES (13978, '2021-01-14', 'CV', 'Cabo Verde', 'AFRO', '86', '12592', '0', '115');
INSERT INTO public.who_global_data_import VALUES (13979, '2021-01-15', 'CV', 'Cabo Verde', 'AFRO', '72', '12664', '0', '115');
INSERT INTO public.who_global_data_import VALUES (13980, '2021-01-16', 'CV', 'Cabo Verde', 'AFRO', '112', '12776', '3', '118');
INSERT INTO public.who_global_data_import VALUES (13981, '2021-01-17', 'CV', 'Cabo Verde', 'AFRO', '125', '12901', '1', '119');
INSERT INTO public.who_global_data_import VALUES (13982, '2021-01-18', 'CV', 'Cabo Verde', 'AFRO', '92', '12993', '0', '119');
INSERT INTO public.who_global_data_import VALUES (13983, '2021-01-19', 'CV', 'Cabo Verde', 'AFRO', '53', '13046', '1', '120');
INSERT INTO public.who_global_data_import VALUES (13984, '2021-01-20', 'CV', 'Cabo Verde', 'AFRO', '93', '13139', '0', '120');
INSERT INTO public.who_global_data_import VALUES (13985, '2021-01-21', 'CV', 'Cabo Verde', 'AFRO', '85', '13224', '1', '121');
INSERT INTO public.who_global_data_import VALUES (13986, '2021-01-22', 'CV', 'Cabo Verde', 'AFRO', '83', '13307', '1', '122');
INSERT INTO public.who_global_data_import VALUES (13987, '2021-01-23', 'CV', 'Cabo Verde', 'AFRO', '74', '13381', '0', '122');
INSERT INTO public.who_global_data_import VALUES (13988, '2021-01-24', 'CV', 'Cabo Verde', 'AFRO', '33', '13414', '2', '124');
INSERT INTO public.who_global_data_import VALUES (13989, '2021-01-25', 'CV', 'Cabo Verde', 'AFRO', '75', '13489', '3', '127');
INSERT INTO public.who_global_data_import VALUES (13990, '2021-01-26', 'CV', 'Cabo Verde', 'AFRO', '68', '13557', '0', '127');
INSERT INTO public.who_global_data_import VALUES (13991, '2021-01-27', 'CV', 'Cabo Verde', 'AFRO', '62', '13619', '2', '129');
INSERT INTO public.who_global_data_import VALUES (13992, '2021-01-28', 'CV', 'Cabo Verde', 'AFRO', '103', '13722', '0', '129');
INSERT INTO public.who_global_data_import VALUES (13993, '2021-01-29', 'CV', 'Cabo Verde', 'AFRO', '62', '13784', '2', '131');
INSERT INTO public.who_global_data_import VALUES (13994, '2021-01-30', 'CV', 'Cabo Verde', 'AFRO', '113', '13897', '0', '131');
INSERT INTO public.who_global_data_import VALUES (13995, '2021-01-31', 'CV', 'Cabo Verde', 'AFRO', '84', '13981', '2', '133');
INSERT INTO public.who_global_data_import VALUES (13996, '2021-02-01', 'CV', 'Cabo Verde', 'AFRO', '89', '14070', '1', '134');
INSERT INTO public.who_global_data_import VALUES (13997, '2021-02-02', 'CV', 'Cabo Verde', 'AFRO', '28', '14098', '0', '134');
INSERT INTO public.who_global_data_import VALUES (13998, '2021-02-03', 'CV', 'Cabo Verde', 'AFRO', '54', '14152', '0', '134');
INSERT INTO public.who_global_data_import VALUES (13999, '2021-02-04', 'CV', 'Cabo Verde', 'AFRO', '0', '14152', '0', '134');
INSERT INTO public.who_global_data_import VALUES (14000, '2021-02-05', 'CV', 'Cabo Verde', 'AFRO', '138', '14290', '1', '135');
INSERT INTO public.who_global_data_import VALUES (14001, '2020-01-03', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14002, '2020-01-04', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14003, '2020-01-05', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14004, '2020-01-06', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14005, '2020-01-07', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14006, '2020-01-08', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14007, '2020-01-09', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14008, '2020-01-10', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14009, '2020-01-11', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14010, '2020-01-12', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14011, '2020-01-13', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14012, '2020-01-14', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14013, '2020-01-15', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14014, '2020-01-16', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14015, '2020-01-17', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14016, '2020-01-18', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14017, '2020-01-19', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14018, '2020-01-20', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14019, '2020-01-21', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14020, '2020-01-22', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14021, '2020-01-23', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14022, '2020-01-24', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14023, '2020-01-25', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14024, '2020-01-26', 'KH', 'Cambodia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14025, '2020-01-27', 'KH', 'Cambodia', 'WPRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14026, '2020-01-28', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14027, '2020-01-29', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14028, '2020-01-30', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14029, '2020-01-31', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14030, '2020-02-01', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14031, '2020-02-02', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14032, '2020-02-03', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14033, '2020-02-04', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14034, '2020-02-05', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14035, '2020-02-06', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14036, '2020-02-07', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14037, '2020-02-08', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14038, '2020-02-09', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14039, '2020-02-10', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14040, '2020-02-11', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14041, '2020-02-12', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14042, '2020-02-13', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14043, '2020-02-14', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14044, '2020-02-15', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14045, '2020-02-16', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14046, '2020-02-17', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14047, '2020-02-18', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14048, '2020-02-19', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14049, '2020-02-20', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14050, '2020-02-21', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14051, '2020-02-22', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14052, '2020-02-23', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14053, '2020-02-24', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14054, '2020-02-25', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14055, '2020-02-26', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14056, '2020-02-27', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14057, '2020-02-28', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14058, '2020-02-29', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14059, '2020-03-01', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14060, '2020-03-02', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14061, '2020-03-03', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14062, '2020-03-04', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14063, '2020-03-05', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14064, '2020-03-06', 'KH', 'Cambodia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14065, '2020-03-07', 'KH', 'Cambodia', 'WPRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14066, '2020-03-08', 'KH', 'Cambodia', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14067, '2020-03-09', 'KH', 'Cambodia', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14068, '2020-03-10', 'KH', 'Cambodia', 'WPRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14069, '2020-03-11', 'KH', 'Cambodia', 'WPRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14070, '2020-03-12', 'KH', 'Cambodia', 'WPRO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14071, '2020-03-13', 'KH', 'Cambodia', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14072, '2020-03-14', 'KH', 'Cambodia', 'WPRO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14073, '2020-03-15', 'KH', 'Cambodia', 'WPRO', '5', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14074, '2020-03-16', 'KH', 'Cambodia', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14075, '2020-03-17', 'KH', 'Cambodia', 'WPRO', '12', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14076, '2020-03-18', 'KH', 'Cambodia', 'WPRO', '11', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14077, '2020-03-19', 'KH', 'Cambodia', 'WPRO', '8', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14078, '2020-03-20', 'KH', 'Cambodia', 'WPRO', '4', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14079, '2020-03-21', 'KH', 'Cambodia', 'WPRO', '2', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14080, '2020-03-22', 'KH', 'Cambodia', 'WPRO', '0', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14081, '2020-03-23', 'KH', 'Cambodia', 'WPRO', '33', '86', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14082, '2020-03-24', 'KH', 'Cambodia', 'WPRO', '1', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14083, '2020-03-25', 'KH', 'Cambodia', 'WPRO', '4', '91', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14084, '2020-03-26', 'KH', 'Cambodia', 'WPRO', '5', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14085, '2020-03-27', 'KH', 'Cambodia', 'WPRO', '2', '98', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14086, '2020-03-28', 'KH', 'Cambodia', 'WPRO', '4', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14087, '2020-03-29', 'KH', 'Cambodia', 'WPRO', '0', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14088, '2020-03-30', 'KH', 'Cambodia', 'WPRO', '5', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14089, '2020-03-31', 'KH', 'Cambodia', 'WPRO', '0', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14090, '2020-04-01', 'KH', 'Cambodia', 'WPRO', '2', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14091, '2020-04-02', 'KH', 'Cambodia', 'WPRO', '0', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14092, '2020-04-03', 'KH', 'Cambodia', 'WPRO', '1', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14093, '2020-04-04', 'KH', 'Cambodia', 'WPRO', '4', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14094, '2020-04-05', 'KH', 'Cambodia', 'WPRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14095, '2020-04-06', 'KH', 'Cambodia', 'WPRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14096, '2020-04-07', 'KH', 'Cambodia', 'WPRO', '1', '115', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14097, '2020-04-08', 'KH', 'Cambodia', 'WPRO', '2', '117', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14098, '2020-04-09', 'KH', 'Cambodia', 'WPRO', '0', '117', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14099, '2020-04-10', 'KH', 'Cambodia', 'WPRO', '1', '118', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14100, '2020-04-11', 'KH', 'Cambodia', 'WPRO', '2', '120', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14101, '2020-04-12', 'KH', 'Cambodia', 'WPRO', '2', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14102, '2020-04-13', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14103, '2020-04-14', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14104, '2020-04-15', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14105, '2020-04-16', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14106, '2020-04-17', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14107, '2020-04-18', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14108, '2020-04-19', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14109, '2020-04-20', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14110, '2020-04-21', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14111, '2020-04-22', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14112, '2020-04-23', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14113, '2020-04-24', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14114, '2020-04-25', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14115, '2020-04-26', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14116, '2020-04-27', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14117, '2020-04-28', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14118, '2020-04-29', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14119, '2020-04-30', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14120, '2020-05-01', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14121, '2020-05-02', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14122, '2020-05-03', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14123, '2020-05-04', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14124, '2020-05-05', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14125, '2020-05-06', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14126, '2020-05-07', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14127, '2020-05-08', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14128, '2020-05-09', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14129, '2020-05-10', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14130, '2020-05-11', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14131, '2020-05-12', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14132, '2020-05-13', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14133, '2020-05-14', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14134, '2020-05-15', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14135, '2020-05-16', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14136, '2020-05-17', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14137, '2020-05-18', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14138, '2020-05-19', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14139, '2020-05-20', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14140, '2020-05-21', 'KH', 'Cambodia', 'WPRO', '0', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14141, '2020-05-22', 'KH', 'Cambodia', 'WPRO', '1', '123', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14142, '2020-05-23', 'KH', 'Cambodia', 'WPRO', '1', '124', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14143, '2020-05-24', 'KH', 'Cambodia', 'WPRO', '0', '124', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14144, '2020-05-25', 'KH', 'Cambodia', 'WPRO', '0', '124', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14145, '2020-05-26', 'KH', 'Cambodia', 'WPRO', '0', '124', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14146, '2020-05-27', 'KH', 'Cambodia', 'WPRO', '0', '124', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14147, '2020-05-28', 'KH', 'Cambodia', 'WPRO', '0', '124', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14148, '2020-05-29', 'KH', 'Cambodia', 'WPRO', '0', '124', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14149, '2020-05-30', 'KH', 'Cambodia', 'WPRO', '1', '125', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14150, '2020-05-31', 'KH', 'Cambodia', 'WPRO', '0', '125', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14151, '2020-06-01', 'KH', 'Cambodia', 'WPRO', '0', '125', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14152, '2020-06-02', 'KH', 'Cambodia', 'WPRO', '0', '125', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14153, '2020-06-03', 'KH', 'Cambodia', 'WPRO', '0', '125', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14154, '2020-06-04', 'KH', 'Cambodia', 'WPRO', '0', '125', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14155, '2020-06-05', 'KH', 'Cambodia', 'WPRO', '0', '125', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14156, '2020-06-06', 'KH', 'Cambodia', 'WPRO', '0', '125', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14157, '2020-06-07', 'KH', 'Cambodia', 'WPRO', '1', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14158, '2020-06-08', 'KH', 'Cambodia', 'WPRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14159, '2020-06-09', 'KH', 'Cambodia', 'WPRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14160, '2020-06-10', 'KH', 'Cambodia', 'WPRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14161, '2020-06-11', 'KH', 'Cambodia', 'WPRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14162, '2020-06-12', 'KH', 'Cambodia', 'WPRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14163, '2020-06-13', 'KH', 'Cambodia', 'WPRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14164, '2020-06-14', 'KH', 'Cambodia', 'WPRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14165, '2020-06-15', 'KH', 'Cambodia', 'WPRO', '2', '128', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14166, '2020-06-16', 'KH', 'Cambodia', 'WPRO', '0', '128', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14167, '2020-06-17', 'KH', 'Cambodia', 'WPRO', '0', '128', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14168, '2020-06-18', 'KH', 'Cambodia', 'WPRO', '1', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14169, '2020-06-19', 'KH', 'Cambodia', 'WPRO', '0', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14170, '2020-06-20', 'KH', 'Cambodia', 'WPRO', '0', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14171, '2020-06-21', 'KH', 'Cambodia', 'WPRO', '0', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14172, '2020-06-22', 'KH', 'Cambodia', 'WPRO', '0', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14173, '2020-06-23', 'KH', 'Cambodia', 'WPRO', '0', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14174, '2020-06-24', 'KH', 'Cambodia', 'WPRO', '1', '130', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14175, '2020-06-25', 'KH', 'Cambodia', 'WPRO', '0', '130', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14176, '2020-06-26', 'KH', 'Cambodia', 'WPRO', '0', '130', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14177, '2020-06-27', 'KH', 'Cambodia', 'WPRO', '9', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14178, '2020-06-28', 'KH', 'Cambodia', 'WPRO', '0', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14179, '2020-06-29', 'KH', 'Cambodia', 'WPRO', '2', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14180, '2020-06-30', 'KH', 'Cambodia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14181, '2020-07-01', 'KH', 'Cambodia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14182, '2020-07-02', 'KH', 'Cambodia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14183, '2020-07-03', 'KH', 'Cambodia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14184, '2020-07-04', 'KH', 'Cambodia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14185, '2020-07-05', 'KH', 'Cambodia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14186, '2020-07-06', 'KH', 'Cambodia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14187, '2020-07-07', 'KH', 'Cambodia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14188, '2020-07-08', 'KH', 'Cambodia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14189, '2020-07-09', 'KH', 'Cambodia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14190, '2020-07-10', 'KH', 'Cambodia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14191, '2020-07-11', 'KH', 'Cambodia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14192, '2020-07-12', 'KH', 'Cambodia', 'WPRO', '15', '156', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14193, '2020-07-13', 'KH', 'Cambodia', 'WPRO', '0', '156', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14194, '2020-07-14', 'KH', 'Cambodia', 'WPRO', '9', '165', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14195, '2020-07-15', 'KH', 'Cambodia', 'WPRO', '0', '165', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14196, '2020-07-16', 'KH', 'Cambodia', 'WPRO', '1', '166', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14197, '2020-07-17', 'KH', 'Cambodia', 'WPRO', '0', '166', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14198, '2020-07-18', 'KH', 'Cambodia', 'WPRO', '5', '171', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14199, '2020-07-19', 'KH', 'Cambodia', 'WPRO', '0', '171', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14200, '2020-07-20', 'KH', 'Cambodia', 'WPRO', '0', '171', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14201, '2020-07-21', 'KH', 'Cambodia', 'WPRO', '0', '171', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14202, '2020-07-22', 'KH', 'Cambodia', 'WPRO', '26', '197', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14203, '2020-07-23', 'KH', 'Cambodia', 'WPRO', '1', '198', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14204, '2020-07-24', 'KH', 'Cambodia', 'WPRO', '4', '202', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14205, '2020-07-25', 'KH', 'Cambodia', 'WPRO', '0', '202', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14206, '2020-07-26', 'KH', 'Cambodia', 'WPRO', '23', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14207, '2020-07-27', 'KH', 'Cambodia', 'WPRO', '0', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14208, '2020-07-28', 'KH', 'Cambodia', 'WPRO', '1', '226', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14209, '2020-07-29', 'KH', 'Cambodia', 'WPRO', '0', '226', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14210, '2020-07-30', 'KH', 'Cambodia', 'WPRO', '8', '234', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14211, '2020-07-31', 'KH', 'Cambodia', 'WPRO', '0', '234', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14212, '2020-08-01', 'KH', 'Cambodia', 'WPRO', '5', '239', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14213, '2020-08-02', 'KH', 'Cambodia', 'WPRO', '1', '240', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14214, '2020-08-03', 'KH', 'Cambodia', 'WPRO', '0', '240', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14215, '2020-08-04', 'KH', 'Cambodia', 'WPRO', '1', '241', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14216, '2020-08-05', 'KH', 'Cambodia', 'WPRO', '2', '243', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14217, '2020-08-06', 'KH', 'Cambodia', 'WPRO', '0', '243', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14218, '2020-08-07', 'KH', 'Cambodia', 'WPRO', '0', '243', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14219, '2020-08-08', 'KH', 'Cambodia', 'WPRO', '3', '246', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14220, '2020-08-09', 'KH', 'Cambodia', 'WPRO', '2', '248', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14221, '2020-08-10', 'KH', 'Cambodia', 'WPRO', '3', '251', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14222, '2020-08-11', 'KH', 'Cambodia', 'WPRO', '15', '266', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14223, '2020-08-12', 'KH', 'Cambodia', 'WPRO', '2', '268', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14224, '2020-08-13', 'KH', 'Cambodia', 'WPRO', '4', '272', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14225, '2020-08-14', 'KH', 'Cambodia', 'WPRO', '1', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14226, '2020-08-15', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14227, '2020-08-16', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14228, '2020-08-17', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14229, '2020-08-18', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14230, '2020-08-19', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14231, '2020-08-20', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14232, '2020-08-21', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14233, '2020-08-22', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14234, '2020-08-23', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14235, '2020-08-24', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14236, '2020-08-25', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14237, '2020-08-26', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14238, '2020-08-27', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14239, '2020-08-28', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14240, '2020-08-29', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14241, '2020-08-30', 'KH', 'Cambodia', 'WPRO', '0', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14242, '2020-08-31', 'KH', 'Cambodia', 'WPRO', '1', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14243, '2020-09-01', 'KH', 'Cambodia', 'WPRO', '0', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14244, '2020-09-02', 'KH', 'Cambodia', 'WPRO', '0', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14245, '2020-09-03', 'KH', 'Cambodia', 'WPRO', '0', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14246, '2020-09-04', 'KH', 'Cambodia', 'WPRO', '0', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14247, '2020-09-05', 'KH', 'Cambodia', 'WPRO', '0', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14248, '2020-09-06', 'KH', 'Cambodia', 'WPRO', '0', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14249, '2020-09-07', 'KH', 'Cambodia', 'WPRO', '0', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14250, '2020-09-08', 'KH', 'Cambodia', 'WPRO', '0', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14251, '2020-09-09', 'KH', 'Cambodia', 'WPRO', '0', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14252, '2020-09-10', 'KH', 'Cambodia', 'WPRO', '0', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14253, '2020-09-11', 'KH', 'Cambodia', 'WPRO', '0', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14254, '2020-09-12', 'KH', 'Cambodia', 'WPRO', '0', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14255, '2020-09-13', 'KH', 'Cambodia', 'WPRO', '1', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14256, '2020-09-14', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14257, '2020-09-15', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14258, '2020-09-16', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14259, '2020-09-17', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14260, '2020-09-18', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14261, '2020-09-19', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14262, '2020-09-20', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14263, '2020-09-21', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14264, '2020-09-22', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14265, '2020-09-23', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14266, '2020-09-24', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14267, '2020-09-25', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14268, '2020-09-26', 'KH', 'Cambodia', 'WPRO', '0', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14269, '2020-09-27', 'KH', 'Cambodia', 'WPRO', '1', '276', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14270, '2020-09-28', 'KH', 'Cambodia', 'WPRO', '0', '276', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14271, '2020-09-29', 'KH', 'Cambodia', 'WPRO', '1', '277', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14272, '2020-09-30', 'KH', 'Cambodia', 'WPRO', '0', '277', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14273, '2020-10-01', 'KH', 'Cambodia', 'WPRO', '0', '277', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14274, '2020-10-02', 'KH', 'Cambodia', 'WPRO', '1', '278', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14275, '2020-10-03', 'KH', 'Cambodia', 'WPRO', '0', '278', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14276, '2020-10-04', 'KH', 'Cambodia', 'WPRO', '0', '278', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14277, '2020-10-05', 'KH', 'Cambodia', 'WPRO', '2', '280', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14278, '2020-10-06', 'KH', 'Cambodia', 'WPRO', '0', '280', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14279, '2020-10-07', 'KH', 'Cambodia', 'WPRO', '0', '280', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14280, '2020-10-08', 'KH', 'Cambodia', 'WPRO', '1', '281', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14281, '2020-10-09', 'KH', 'Cambodia', 'WPRO', '1', '282', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14282, '2020-10-10', 'KH', 'Cambodia', 'WPRO', '1', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14283, '2020-10-11', 'KH', 'Cambodia', 'WPRO', '0', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14284, '2020-10-12', 'KH', 'Cambodia', 'WPRO', '0', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14285, '2020-10-13', 'KH', 'Cambodia', 'WPRO', '0', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14286, '2020-10-14', 'KH', 'Cambodia', 'WPRO', '0', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14287, '2020-10-15', 'KH', 'Cambodia', 'WPRO', '0', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14288, '2020-10-16', 'KH', 'Cambodia', 'WPRO', '0', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14289, '2020-10-17', 'KH', 'Cambodia', 'WPRO', '0', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14290, '2020-10-18', 'KH', 'Cambodia', 'WPRO', '0', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14291, '2020-10-19', 'KH', 'Cambodia', 'WPRO', '0', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14292, '2020-10-20', 'KH', 'Cambodia', 'WPRO', '2', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14293, '2020-10-21', 'KH', 'Cambodia', 'WPRO', '1', '286', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14294, '2020-10-22', 'KH', 'Cambodia', 'WPRO', '0', '286', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14295, '2020-10-23', 'KH', 'Cambodia', 'WPRO', '0', '286', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14296, '2020-10-24', 'KH', 'Cambodia', 'WPRO', '1', '287', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14297, '2020-10-25', 'KH', 'Cambodia', 'WPRO', '0', '287', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14298, '2020-10-26', 'KH', 'Cambodia', 'WPRO', '0', '287', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14299, '2020-10-27', 'KH', 'Cambodia', 'WPRO', '1', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14300, '2020-10-28', 'KH', 'Cambodia', 'WPRO', '2', '290', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14301, '2020-10-29', 'KH', 'Cambodia', 'WPRO', '0', '290', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14302, '2020-10-30', 'KH', 'Cambodia', 'WPRO', '1', '291', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14303, '2020-10-31', 'KH', 'Cambodia', 'WPRO', '0', '291', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14304, '2020-11-01', 'KH', 'Cambodia', 'WPRO', '0', '291', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14305, '2020-11-02', 'KH', 'Cambodia', 'WPRO', '1', '292', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14306, '2020-11-03', 'KH', 'Cambodia', 'WPRO', '0', '292', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14307, '2020-11-04', 'KH', 'Cambodia', 'WPRO', '0', '292', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14308, '2020-11-05', 'KH', 'Cambodia', 'WPRO', '0', '292', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14309, '2020-11-06', 'KH', 'Cambodia', 'WPRO', '0', '292', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14310, '2020-11-07', 'KH', 'Cambodia', 'WPRO', '2', '294', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14311, '2020-11-08', 'KH', 'Cambodia', 'WPRO', '1', '295', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14312, '2020-11-09', 'KH', 'Cambodia', 'WPRO', '2', '297', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14313, '2020-11-10', 'KH', 'Cambodia', 'WPRO', '3', '300', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14314, '2020-11-11', 'KH', 'Cambodia', 'WPRO', '1', '301', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14315, '2020-11-12', 'KH', 'Cambodia', 'WPRO', '0', '301', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14316, '2020-11-13', 'KH', 'Cambodia', 'WPRO', '0', '301', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14317, '2020-11-14', 'KH', 'Cambodia', 'WPRO', '1', '302', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14318, '2020-11-15', 'KH', 'Cambodia', 'WPRO', '0', '302', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14319, '2020-11-16', 'KH', 'Cambodia', 'WPRO', '0', '302', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14320, '2020-11-17', 'KH', 'Cambodia', 'WPRO', '1', '303', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14321, '2020-11-18', 'KH', 'Cambodia', 'WPRO', '1', '304', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14322, '2020-11-19', 'KH', 'Cambodia', 'WPRO', '0', '304', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14323, '2020-11-20', 'KH', 'Cambodia', 'WPRO', '0', '304', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14324, '2020-11-21', 'KH', 'Cambodia', 'WPRO', '1', '305', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14325, '2020-11-22', 'KH', 'Cambodia', 'WPRO', '1', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14326, '2020-11-23', 'KH', 'Cambodia', 'WPRO', '0', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14327, '2020-11-24', 'KH', 'Cambodia', 'WPRO', '0', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14328, '2020-11-25', 'KH', 'Cambodia', 'WPRO', '1', '307', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14329, '2020-11-26', 'KH', 'Cambodia', 'WPRO', '0', '307', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14330, '2020-11-27', 'KH', 'Cambodia', 'WPRO', '0', '307', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14331, '2020-11-28', 'KH', 'Cambodia', 'WPRO', '1', '308', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14332, '2020-11-29', 'KH', 'Cambodia', 'WPRO', '7', '315', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14333, '2020-11-30', 'KH', 'Cambodia', 'WPRO', '8', '323', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14334, '2020-12-01', 'KH', 'Cambodia', 'WPRO', '3', '326', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14335, '2020-12-02', 'KH', 'Cambodia', 'WPRO', '3', '329', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14336, '2020-12-03', 'KH', 'Cambodia', 'WPRO', '2', '331', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14337, '2020-12-04', 'KH', 'Cambodia', 'WPRO', '4', '335', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14338, '2020-12-05', 'KH', 'Cambodia', 'WPRO', '10', '345', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14339, '2020-12-06', 'KH', 'Cambodia', 'WPRO', '1', '346', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14340, '2020-12-07', 'KH', 'Cambodia', 'WPRO', '2', '348', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14341, '2020-12-08', 'KH', 'Cambodia', 'WPRO', '2', '350', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14342, '2020-12-09', 'KH', 'Cambodia', 'WPRO', '4', '354', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14343, '2020-12-10', 'KH', 'Cambodia', 'WPRO', '2', '356', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14344, '2020-12-11', 'KH', 'Cambodia', 'WPRO', '1', '357', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14345, '2020-12-12', 'KH', 'Cambodia', 'WPRO', '0', '357', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14346, '2020-12-13', 'KH', 'Cambodia', 'WPRO', '2', '359', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14347, '2020-12-14', 'KH', 'Cambodia', 'WPRO', '0', '359', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14348, '2020-12-15', 'KH', 'Cambodia', 'WPRO', '3', '362', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14349, '2020-12-16', 'KH', 'Cambodia', 'WPRO', '0', '362', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14350, '2020-12-17', 'KH', 'Cambodia', 'WPRO', '0', '362', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14351, '2020-12-18', 'KH', 'Cambodia', 'WPRO', '0', '362', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14352, '2020-12-19', 'KH', 'Cambodia', 'WPRO', '0', '362', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14353, '2020-12-20', 'KH', 'Cambodia', 'WPRO', '0', '362', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14354, '2020-12-21', 'KH', 'Cambodia', 'WPRO', '1', '363', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14355, '2020-12-22', 'KH', 'Cambodia', 'WPRO', '0', '363', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14356, '2020-12-23', 'KH', 'Cambodia', 'WPRO', '0', '363', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14357, '2020-12-24', 'KH', 'Cambodia', 'WPRO', '0', '363', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14358, '2020-12-25', 'KH', 'Cambodia', 'WPRO', '0', '363', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14359, '2020-12-26', 'KH', 'Cambodia', 'WPRO', '0', '363', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14360, '2020-12-27', 'KH', 'Cambodia', 'WPRO', '1', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14361, '2020-12-28', 'KH', 'Cambodia', 'WPRO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14362, '2020-12-29', 'KH', 'Cambodia', 'WPRO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14363, '2020-12-30', 'KH', 'Cambodia', 'WPRO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14364, '2020-12-31', 'KH', 'Cambodia', 'WPRO', '2', '366', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14365, '2021-01-01', 'KH', 'Cambodia', 'WPRO', '12', '378', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14366, '2021-01-02', 'KH', 'Cambodia', 'WPRO', '1', '379', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14367, '2021-01-03', 'KH', 'Cambodia', 'WPRO', '2', '381', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14368, '2021-01-04', 'KH', 'Cambodia', 'WPRO', '1', '382', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14369, '2021-01-05', 'KH', 'Cambodia', 'WPRO', '0', '382', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14370, '2021-01-06', 'KH', 'Cambodia', 'WPRO', '1', '383', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14371, '2021-01-07', 'KH', 'Cambodia', 'WPRO', '2', '385', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14372, '2021-01-08', 'KH', 'Cambodia', 'WPRO', '1', '386', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14373, '2021-01-09', 'KH', 'Cambodia', 'WPRO', '1', '387', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14374, '2021-01-10', 'KH', 'Cambodia', 'WPRO', '4', '391', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14375, '2021-01-11', 'KH', 'Cambodia', 'WPRO', '1', '392', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14376, '2021-01-12', 'KH', 'Cambodia', 'WPRO', '0', '392', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14377, '2021-01-13', 'KH', 'Cambodia', 'WPRO', '6', '398', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14378, '2021-01-14', 'KH', 'Cambodia', 'WPRO', '13', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14379, '2021-01-15', 'KH', 'Cambodia', 'WPRO', '15', '426', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14380, '2021-01-16', 'KH', 'Cambodia', 'WPRO', '10', '436', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14381, '2021-01-17', 'KH', 'Cambodia', 'WPRO', '3', '439', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14382, '2021-01-18', 'KH', 'Cambodia', 'WPRO', '0', '439', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14383, '2021-01-19', 'KH', 'Cambodia', 'WPRO', '2', '441', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14384, '2021-01-20', 'KH', 'Cambodia', 'WPRO', '7', '448', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14385, '2021-01-21', 'KH', 'Cambodia', 'WPRO', '5', '453', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14386, '2021-01-22', 'KH', 'Cambodia', 'WPRO', '3', '456', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14387, '2021-01-23', 'KH', 'Cambodia', 'WPRO', '0', '456', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14388, '2021-01-24', 'KH', 'Cambodia', 'WPRO', '2', '458', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14389, '2021-01-25', 'KH', 'Cambodia', 'WPRO', '0', '458', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14390, '2021-01-26', 'KH', 'Cambodia', 'WPRO', '2', '460', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14391, '2021-01-27', 'KH', 'Cambodia', 'WPRO', '0', '460', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14392, '2021-01-28', 'KH', 'Cambodia', 'WPRO', '1', '461', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14393, '2021-01-29', 'KH', 'Cambodia', 'WPRO', '2', '463', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14394, '2021-01-30', 'KH', 'Cambodia', 'WPRO', '1', '464', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14395, '2021-01-31', 'KH', 'Cambodia', 'WPRO', '1', '465', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14396, '2021-02-01', 'KH', 'Cambodia', 'WPRO', '1', '466', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14397, '2021-02-02', 'KH', 'Cambodia', 'WPRO', '0', '466', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14398, '2021-02-03', 'KH', 'Cambodia', 'WPRO', '0', '466', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14399, '2021-02-04', 'KH', 'Cambodia', 'WPRO', '1', '467', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14400, '2021-02-05', 'KH', 'Cambodia', 'WPRO', '3', '470', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14401, '2020-01-03', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14402, '2020-01-04', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14403, '2020-01-05', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14404, '2020-01-06', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14405, '2020-01-07', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14406, '2020-01-08', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14407, '2020-01-09', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14408, '2020-01-10', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14409, '2020-01-11', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14410, '2020-01-12', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14411, '2020-01-13', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14412, '2020-01-14', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14413, '2020-01-15', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14414, '2020-01-16', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14415, '2020-01-17', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14416, '2020-01-18', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14417, '2020-01-19', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14418, '2020-01-20', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14419, '2020-01-21', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14420, '2020-01-22', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14421, '2020-01-23', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14422, '2020-01-24', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14423, '2020-01-25', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14424, '2020-01-26', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14425, '2020-01-27', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14426, '2020-01-28', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14427, '2020-01-29', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14428, '2020-01-30', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14429, '2020-01-31', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14430, '2020-02-01', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14431, '2020-02-02', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14432, '2020-02-03', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14433, '2020-02-04', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14434, '2020-02-05', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14435, '2020-02-06', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14436, '2020-02-07', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14437, '2020-02-08', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14438, '2020-02-09', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14439, '2020-02-10', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14440, '2020-02-11', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14441, '2020-02-12', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14442, '2020-02-13', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14443, '2020-02-14', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14444, '2020-02-15', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14445, '2020-02-16', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14446, '2020-02-17', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14447, '2020-02-18', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14448, '2020-02-19', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14449, '2020-02-20', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14450, '2020-02-21', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14451, '2020-02-22', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14452, '2020-02-23', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14453, '2020-02-24', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14454, '2020-02-25', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14455, '2020-02-26', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14456, '2020-02-27', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14457, '2020-02-28', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14458, '2020-02-29', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14459, '2020-03-01', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14460, '2020-03-02', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14461, '2020-03-03', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14462, '2020-03-04', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14463, '2020-03-05', 'CM', 'Cameroon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14464, '2020-03-06', 'CM', 'Cameroon', 'AFRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14465, '2020-03-07', 'CM', 'Cameroon', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14466, '2020-03-08', 'CM', 'Cameroon', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14467, '2020-03-09', 'CM', 'Cameroon', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14468, '2020-03-10', 'CM', 'Cameroon', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14469, '2020-03-11', 'CM', 'Cameroon', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14470, '2020-03-12', 'CM', 'Cameroon', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14471, '2020-03-13', 'CM', 'Cameroon', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14472, '2020-03-14', 'CM', 'Cameroon', 'AFRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14473, '2020-03-15', 'CM', 'Cameroon', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14474, '2020-03-16', 'CM', 'Cameroon', 'AFRO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14475, '2020-03-17', 'CM', 'Cameroon', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14476, '2020-03-18', 'CM', 'Cameroon', 'AFRO', '5', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14477, '2020-03-19', 'CM', 'Cameroon', 'AFRO', '5', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14478, '2020-03-20', 'CM', 'Cameroon', 'AFRO', '3', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14479, '2020-03-21', 'CM', 'Cameroon', 'AFRO', '5', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14480, '2020-03-22', 'CM', 'Cameroon', 'AFRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14481, '2020-03-23', 'CM', 'Cameroon', 'AFRO', '13', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14482, '2020-03-24', 'CM', 'Cameroon', 'AFRO', '30', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14483, '2020-03-25', 'CM', 'Cameroon', 'AFRO', '0', '70', '1', '1');
INSERT INTO public.who_global_data_import VALUES (14484, '2020-03-26', 'CM', 'Cameroon', 'AFRO', '5', '75', '0', '1');
INSERT INTO public.who_global_data_import VALUES (14485, '2020-03-27', 'CM', 'Cameroon', 'AFRO', '0', '75', '0', '1');
INSERT INTO public.who_global_data_import VALUES (14486, '2020-03-28', 'CM', 'Cameroon', 'AFRO', '0', '75', '0', '1');
INSERT INTO public.who_global_data_import VALUES (14487, '2020-03-29', 'CM', 'Cameroon', 'AFRO', '16', '91', '1', '2');
INSERT INTO public.who_global_data_import VALUES (14488, '2020-03-30', 'CM', 'Cameroon', 'AFRO', '22', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (14489, '2020-03-31', 'CM', 'Cameroon', 'AFRO', '26', '139', '4', '6');
INSERT INTO public.who_global_data_import VALUES (14490, '2020-04-01', 'CM', 'Cameroon', 'AFRO', '0', '139', '0', '6');
INSERT INTO public.who_global_data_import VALUES (14491, '2020-04-02', 'CM', 'Cameroon', 'AFRO', '0', '139', '0', '6');
INSERT INTO public.who_global_data_import VALUES (14492, '2020-04-03', 'CM', 'Cameroon', 'AFRO', '107', '246', '1', '7');
INSERT INTO public.who_global_data_import VALUES (14493, '2020-04-04', 'CM', 'Cameroon', 'AFRO', '263', '509', '1', '8');
INSERT INTO public.who_global_data_import VALUES (14494, '2020-04-05', 'CM', 'Cameroon', 'AFRO', '46', '555', '1', '9');
INSERT INTO public.who_global_data_import VALUES (14495, '2020-04-06', 'CM', 'Cameroon', 'AFRO', '0', '555', '0', '9');
INSERT INTO public.who_global_data_import VALUES (14496, '2020-04-07', 'CM', 'Cameroon', 'AFRO', '0', '555', '0', '9');
INSERT INTO public.who_global_data_import VALUES (14497, '2020-04-08', 'CM', 'Cameroon', 'AFRO', '0', '555', '0', '9');
INSERT INTO public.who_global_data_import VALUES (14498, '2020-04-09', 'CM', 'Cameroon', 'AFRO', '175', '730', '1', '10');
INSERT INTO public.who_global_data_import VALUES (14499, '2020-04-10', 'CM', 'Cameroon', 'AFRO', '0', '730', '0', '10');
INSERT INTO public.who_global_data_import VALUES (14500, '2020-04-11', 'CM', 'Cameroon', 'AFRO', '73', '803', '0', '10');
INSERT INTO public.who_global_data_import VALUES (14501, '2020-04-12', 'CM', 'Cameroon', 'AFRO', '0', '803', '0', '10');
INSERT INTO public.who_global_data_import VALUES (14502, '2020-04-13', 'CM', 'Cameroon', 'AFRO', '0', '803', '0', '10');
INSERT INTO public.who_global_data_import VALUES (14503, '2020-04-14', 'CM', 'Cameroon', 'AFRO', '0', '803', '0', '10');
INSERT INTO public.who_global_data_import VALUES (14504, '2020-04-15', 'CM', 'Cameroon', 'AFRO', '52', '855', '5', '15');
INSERT INTO public.who_global_data_import VALUES (14505, '2020-04-16', 'CM', 'Cameroon', 'AFRO', '0', '855', '2', '17');
INSERT INTO public.who_global_data_import VALUES (14506, '2020-04-17', 'CM', 'Cameroon', 'AFRO', '0', '855', '0', '17');
INSERT INTO public.who_global_data_import VALUES (14507, '2020-04-18', 'CM', 'Cameroon', 'AFRO', '161', '1016', '4', '21');
INSERT INTO public.who_global_data_import VALUES (14508, '2020-04-19', 'CM', 'Cameroon', 'AFRO', '0', '1016', '0', '21');
INSERT INTO public.who_global_data_import VALUES (14509, '2020-04-20', 'CM', 'Cameroon', 'AFRO', '0', '1016', '0', '21');
INSERT INTO public.who_global_data_import VALUES (14510, '2020-04-21', 'CM', 'Cameroon', 'AFRO', '147', '1163', '21', '42');
INSERT INTO public.who_global_data_import VALUES (14511, '2020-04-22', 'CM', 'Cameroon', 'AFRO', '0', '1163', '1', '43');
INSERT INTO public.who_global_data_import VALUES (14512, '2020-04-23', 'CM', 'Cameroon', 'AFRO', '0', '1163', '0', '43');
INSERT INTO public.who_global_data_import VALUES (14513, '2020-04-24', 'CM', 'Cameroon', 'AFRO', '238', '1401', '6', '49');
INSERT INTO public.who_global_data_import VALUES (14514, '2020-04-25', 'CM', 'Cameroon', 'AFRO', '2', '1403', '0', '49');
INSERT INTO public.who_global_data_import VALUES (14515, '2020-04-26', 'CM', 'Cameroon', 'AFRO', '115', '1518', '4', '53');
INSERT INTO public.who_global_data_import VALUES (14516, '2020-04-27', 'CM', 'Cameroon', 'AFRO', '103', '1621', '3', '56');
INSERT INTO public.who_global_data_import VALUES (14517, '2020-04-28', 'CM', 'Cameroon', 'AFRO', '0', '1621', '0', '56');
INSERT INTO public.who_global_data_import VALUES (14518, '2020-04-29', 'CM', 'Cameroon', 'AFRO', '84', '1705', '2', '58');
INSERT INTO public.who_global_data_import VALUES (14519, '2020-04-30', 'CM', 'Cameroon', 'AFRO', '101', '1806', '1', '59');
INSERT INTO public.who_global_data_import VALUES (14520, '2020-05-01', 'CM', 'Cameroon', 'AFRO', '26', '1832', '2', '61');
INSERT INTO public.who_global_data_import VALUES (14521, '2020-05-02', 'CM', 'Cameroon', 'AFRO', '237', '2069', '0', '61');
INSERT INTO public.who_global_data_import VALUES (14522, '2020-05-03', 'CM', 'Cameroon', 'AFRO', '8', '2077', '3', '64');
INSERT INTO public.who_global_data_import VALUES (14523, '2020-05-04', 'CM', 'Cameroon', 'AFRO', '0', '2077', '0', '64');
INSERT INTO public.who_global_data_import VALUES (14524, '2020-05-05', 'CM', 'Cameroon', 'AFRO', '0', '2077', '0', '64');
INSERT INTO public.who_global_data_import VALUES (14525, '2020-05-06', 'CM', 'Cameroon', 'AFRO', '188', '2265', '44', '108');
INSERT INTO public.who_global_data_import VALUES (14526, '2020-05-07', 'CM', 'Cameroon', 'AFRO', '0', '2265', '0', '108');
INSERT INTO public.who_global_data_import VALUES (14527, '2020-05-08', 'CM', 'Cameroon', 'AFRO', '0', '2265', '0', '108');
INSERT INTO public.who_global_data_import VALUES (14528, '2020-05-09', 'CM', 'Cameroon', 'AFRO', '0', '2265', '0', '108');
INSERT INTO public.who_global_data_import VALUES (14529, '2020-05-10', 'CM', 'Cameroon', 'AFRO', '70', '2335', '2', '110');
INSERT INTO public.who_global_data_import VALUES (14530, '2020-05-11', 'CM', 'Cameroon', 'AFRO', '244', '2579', '4', '114');
INSERT INTO public.who_global_data_import VALUES (14531, '2020-05-12', 'CM', 'Cameroon', 'AFRO', '0', '2579', '0', '114');
INSERT INTO public.who_global_data_import VALUES (14532, '2020-05-13', 'CM', 'Cameroon', 'AFRO', '110', '2689', '11', '125');
INSERT INTO public.who_global_data_import VALUES (14533, '2020-05-14', 'CM', 'Cameroon', 'AFRO', '111', '2800', '11', '136');
INSERT INTO public.who_global_data_import VALUES (14534, '2020-05-15', 'CM', 'Cameroon', 'AFRO', '154', '2954', '3', '139');
INSERT INTO public.who_global_data_import VALUES (14535, '2020-05-16', 'CM', 'Cameroon', 'AFRO', '93', '3047', '0', '139');
INSERT INTO public.who_global_data_import VALUES (14536, '2020-05-17', 'CM', 'Cameroon', 'AFRO', '0', '3047', '0', '139');
INSERT INTO public.who_global_data_import VALUES (14537, '2020-05-18', 'CM', 'Cameroon', 'AFRO', '0', '3047', '0', '139');
INSERT INTO public.who_global_data_import VALUES (14538, '2020-05-19', 'CM', 'Cameroon', 'AFRO', '482', '3529', '1', '140');
INSERT INTO public.who_global_data_import VALUES (14539, '2020-05-20', 'CM', 'Cameroon', 'AFRO', '0', '3529', '0', '140');
INSERT INTO public.who_global_data_import VALUES (14540, '2020-05-21', 'CM', 'Cameroon', 'AFRO', '204', '3733', '6', '146');
INSERT INTO public.who_global_data_import VALUES (14541, '2020-05-22', 'CM', 'Cameroon', 'AFRO', '555', '4288', '10', '156');
INSERT INTO public.who_global_data_import VALUES (14542, '2020-05-23', 'CM', 'Cameroon', 'AFRO', '112', '4400', '3', '159');
INSERT INTO public.who_global_data_import VALUES (14543, '2020-05-24', 'CM', 'Cameroon', 'AFRO', '0', '4400', '0', '159');
INSERT INTO public.who_global_data_import VALUES (14544, '2020-05-25', 'CM', 'Cameroon', 'AFRO', '0', '4400', '0', '159');
INSERT INTO public.who_global_data_import VALUES (14545, '2020-05-26', 'CM', 'Cameroon', 'AFRO', '490', '4890', '6', '165');
INSERT INTO public.who_global_data_import VALUES (14546, '2020-05-27', 'CM', 'Cameroon', 'AFRO', '546', '5436', '12', '177');
INSERT INTO public.who_global_data_import VALUES (14547, '2020-05-28', 'CM', 'Cameroon', 'AFRO', '0', '5436', '0', '177');
INSERT INTO public.who_global_data_import VALUES (14548, '2020-05-29', 'CM', 'Cameroon', 'AFRO', '0', '5436', '0', '177');
INSERT INTO public.who_global_data_import VALUES (14549, '2020-05-30', 'CM', 'Cameroon', 'AFRO', '0', '5436', '0', '177');
INSERT INTO public.who_global_data_import VALUES (14550, '2020-05-31', 'CM', 'Cameroon', 'AFRO', '223', '5659', '8', '185');
INSERT INTO public.who_global_data_import VALUES (14551, '2020-06-01', 'CM', 'Cameroon', 'AFRO', '245', '5904', '6', '191');
INSERT INTO public.who_global_data_import VALUES (14552, '2020-06-02', 'CM', 'Cameroon', 'AFRO', '493', '6397', '8', '199');
INSERT INTO public.who_global_data_import VALUES (14553, '2020-06-03', 'CM', 'Cameroon', 'AFRO', '188', '6585', '1', '200');
INSERT INTO public.who_global_data_import VALUES (14554, '2020-06-04', 'CM', 'Cameroon', 'AFRO', '167', '6752', '0', '200');
INSERT INTO public.who_global_data_import VALUES (14555, '2020-06-05', 'CM', 'Cameroon', 'AFRO', '37', '6789', '3', '203');
INSERT INTO public.who_global_data_import VALUES (14556, '2020-06-06', 'CM', 'Cameroon', 'AFRO', '603', '7392', '2', '205');
INSERT INTO public.who_global_data_import VALUES (14557, '2020-06-07', 'CM', 'Cameroon', 'AFRO', '207', '7599', '7', '212');
INSERT INTO public.who_global_data_import VALUES (14558, '2020-06-08', 'CM', 'Cameroon', 'AFRO', '261', '7860', '3', '215');
INSERT INTO public.who_global_data_import VALUES (14559, '2020-06-09', 'CM', 'Cameroon', 'AFRO', '200', '8060', '0', '215');
INSERT INTO public.who_global_data_import VALUES (14560, '2020-06-10', 'CM', 'Cameroon', 'AFRO', '252', '8312', '0', '215');
INSERT INTO public.who_global_data_import VALUES (14561, '2020-06-11', 'CM', 'Cameroon', 'AFRO', '369', '8681', '0', '215');
INSERT INTO public.who_global_data_import VALUES (14562, '2020-06-12', 'CM', 'Cameroon', 'AFRO', '0', '8681', '0', '215');
INSERT INTO public.who_global_data_import VALUES (14563, '2020-06-13', 'CM', 'Cameroon', 'AFRO', '62', '8743', '55', '270');
INSERT INTO public.who_global_data_import VALUES (14564, '2020-06-14', 'CM', 'Cameroon', 'AFRO', '0', '8743', '0', '270');
INSERT INTO public.who_global_data_import VALUES (14565, '2020-06-15', 'CM', 'Cameroon', 'AFRO', '829', '9572', '5', '275');
INSERT INTO public.who_global_data_import VALUES (14566, '2020-06-16', 'CM', 'Cameroon', 'AFRO', '292', '9864', '1', '276');
INSERT INTO public.who_global_data_import VALUES (14567, '2020-06-17', 'CM', 'Cameroon', 'AFRO', '0', '9864', '0', '276');
INSERT INTO public.who_global_data_import VALUES (14568, '2020-06-18', 'CM', 'Cameroon', 'AFRO', '0', '9864', '0', '276');
INSERT INTO public.who_global_data_import VALUES (14569, '2020-06-19', 'CM', 'Cameroon', 'AFRO', '0', '9864', '0', '276');
INSERT INTO public.who_global_data_import VALUES (14570, '2020-06-20', 'CM', 'Cameroon', 'AFRO', '774', '10638', '6', '282');
INSERT INTO public.who_global_data_import VALUES (14571, '2020-06-21', 'CM', 'Cameroon', 'AFRO', '0', '10638', '0', '282');
INSERT INTO public.who_global_data_import VALUES (14572, '2020-06-22', 'CM', 'Cameroon', 'AFRO', '643', '11281', '18', '300');
INSERT INTO public.who_global_data_import VALUES (14573, '2020-06-23', 'CM', 'Cameroon', 'AFRO', '611', '11892', '3', '303');
INSERT INTO public.who_global_data_import VALUES (14574, '2020-06-24', 'CM', 'Cameroon', 'AFRO', '149', '12041', '5', '308');
INSERT INTO public.who_global_data_import VALUES (14575, '2020-06-25', 'CM', 'Cameroon', 'AFRO', '229', '12270', '5', '313');
INSERT INTO public.who_global_data_import VALUES (14576, '2020-06-26', 'CM', 'Cameroon', 'AFRO', '322', '12592', '0', '313');
INSERT INTO public.who_global_data_import VALUES (14577, '2020-06-27', 'CM', 'Cameroon', 'AFRO', '0', '12592', '0', '313');
INSERT INTO public.who_global_data_import VALUES (14578, '2020-06-28', 'CM', 'Cameroon', 'AFRO', '0', '12592', '0', '313');
INSERT INTO public.who_global_data_import VALUES (14579, '2020-06-29', 'CM', 'Cameroon', 'AFRO', '0', '12592', '0', '313');
INSERT INTO public.who_global_data_import VALUES (14580, '2020-06-30', 'CM', 'Cameroon', 'AFRO', '0', '12592', '0', '313');
INSERT INTO public.who_global_data_import VALUES (14581, '2020-07-01', 'CM', 'Cameroon', 'AFRO', '0', '12592', '0', '313');
INSERT INTO public.who_global_data_import VALUES (14582, '2020-07-02', 'CM', 'Cameroon', 'AFRO', '0', '12592', '0', '313');
INSERT INTO public.who_global_data_import VALUES (14583, '2020-07-03', 'CM', 'Cameroon', 'AFRO', '0', '12592', '0', '313');
INSERT INTO public.who_global_data_import VALUES (14584, '2020-07-04', 'CM', 'Cameroon', 'AFRO', '0', '12592', '0', '313');
INSERT INTO public.who_global_data_import VALUES (14585, '2020-07-05', 'CM', 'Cameroon', 'AFRO', '0', '12592', '0', '313');
INSERT INTO public.who_global_data_import VALUES (14586, '2020-07-06', 'CM', 'Cameroon', 'AFRO', '1445', '14037', '17', '330');
INSERT INTO public.who_global_data_import VALUES (14587, '2020-07-07', 'CM', 'Cameroon', 'AFRO', '487', '14524', '12', '342');
INSERT INTO public.who_global_data_import VALUES (14588, '2020-07-08', 'CM', 'Cameroon', 'AFRO', '392', '14916', '17', '359');
INSERT INTO public.who_global_data_import VALUES (14589, '2020-07-09', 'CM', 'Cameroon', 'AFRO', '0', '14916', '0', '359');
INSERT INTO public.who_global_data_import VALUES (14590, '2020-07-10', 'CM', 'Cameroon', 'AFRO', '0', '14916', '0', '359');
INSERT INTO public.who_global_data_import VALUES (14591, '2020-07-11', 'CM', 'Cameroon', 'AFRO', '0', '14916', '0', '359');
INSERT INTO public.who_global_data_import VALUES (14592, '2020-07-12', 'CM', 'Cameroon', 'AFRO', '0', '14916', '0', '359');
INSERT INTO public.who_global_data_import VALUES (14593, '2020-07-13', 'CM', 'Cameroon', 'AFRO', '257', '15173', '0', '359');
INSERT INTO public.who_global_data_import VALUES (14594, '2020-07-14', 'CM', 'Cameroon', 'AFRO', '0', '15173', '0', '359');
INSERT INTO public.who_global_data_import VALUES (14595, '2020-07-15', 'CM', 'Cameroon', 'AFRO', '0', '15173', '0', '359');
INSERT INTO public.who_global_data_import VALUES (14596, '2020-07-16', 'CM', 'Cameroon', 'AFRO', '884', '16057', '10', '369');
INSERT INTO public.who_global_data_import VALUES (14597, '2020-07-17', 'CM', 'Cameroon', 'AFRO', '0', '16057', '0', '369');
INSERT INTO public.who_global_data_import VALUES (14598, '2020-07-18', 'CM', 'Cameroon', 'AFRO', '100', '16157', '4', '373');
INSERT INTO public.who_global_data_import VALUES (14599, '2020-07-19', 'CM', 'Cameroon', 'AFRO', '0', '16157', '0', '373');
INSERT INTO public.who_global_data_import VALUES (14600, '2020-07-20', 'CM', 'Cameroon', 'AFRO', '0', '16157', '0', '373');
INSERT INTO public.who_global_data_import VALUES (14601, '2020-07-21', 'CM', 'Cameroon', 'AFRO', '365', '16522', '9', '382');
INSERT INTO public.who_global_data_import VALUES (14602, '2020-07-22', 'CM', 'Cameroon', 'AFRO', '0', '16522', '0', '382');
INSERT INTO public.who_global_data_import VALUES (14603, '2020-07-23', 'CM', 'Cameroon', 'AFRO', '0', '16522', '0', '382');
INSERT INTO public.who_global_data_import VALUES (14604, '2020-07-24', 'CM', 'Cameroon', 'AFRO', '0', '16522', '0', '382');
INSERT INTO public.who_global_data_import VALUES (14605, '2020-07-25', 'CM', 'Cameroon', 'AFRO', '186', '16708', '3', '385');
INSERT INTO public.who_global_data_import VALUES (14606, '2020-07-26', 'CM', 'Cameroon', 'AFRO', '0', '16708', '0', '385');
INSERT INTO public.who_global_data_import VALUES (14607, '2020-07-27', 'CM', 'Cameroon', 'AFRO', '402', '17110', '6', '391');
INSERT INTO public.who_global_data_import VALUES (14608, '2020-07-28', 'CM', 'Cameroon', 'AFRO', '69', '17179', '0', '391');
INSERT INTO public.who_global_data_import VALUES (14609, '2020-07-29', 'CM', 'Cameroon', 'AFRO', '0', '17179', '0', '391');
INSERT INTO public.who_global_data_import VALUES (14610, '2020-07-30', 'CM', 'Cameroon', 'AFRO', '76', '17255', '0', '391');
INSERT INTO public.who_global_data_import VALUES (14611, '2020-07-31', 'CM', 'Cameroon', 'AFRO', '0', '17255', '0', '391');
INSERT INTO public.who_global_data_import VALUES (14612, '2020-08-01', 'CM', 'Cameroon', 'AFRO', '0', '17255', '0', '391');
INSERT INTO public.who_global_data_import VALUES (14613, '2020-08-02', 'CM', 'Cameroon', 'AFRO', '0', '17255', '0', '391');
INSERT INTO public.who_global_data_import VALUES (14614, '2020-08-03', 'CM', 'Cameroon', 'AFRO', '0', '17255', '0', '391');
INSERT INTO public.who_global_data_import VALUES (14615, '2020-08-04', 'CM', 'Cameroon', 'AFRO', '463', '17718', '0', '391');
INSERT INTO public.who_global_data_import VALUES (14616, '2020-08-05', 'CM', 'Cameroon', 'AFRO', '0', '17718', '0', '391');
INSERT INTO public.who_global_data_import VALUES (14617, '2020-08-06', 'CM', 'Cameroon', 'AFRO', '0', '17718', '0', '391');
INSERT INTO public.who_global_data_import VALUES (14618, '2020-08-07', 'CM', 'Cameroon', 'AFRO', '0', '17718', '0', '391');
INSERT INTO public.who_global_data_import VALUES (14619, '2020-08-08', 'CM', 'Cameroon', 'AFRO', '324', '18042', '4', '395');
INSERT INTO public.who_global_data_import VALUES (14620, '2020-08-09', 'CM', 'Cameroon', 'AFRO', '0', '18042', '0', '395');
INSERT INTO public.who_global_data_import VALUES (14621, '2020-08-10', 'CM', 'Cameroon', 'AFRO', '0', '18042', '0', '395');
INSERT INTO public.who_global_data_import VALUES (14622, '2020-08-11', 'CM', 'Cameroon', 'AFRO', '171', '18213', '3', '398');
INSERT INTO public.who_global_data_import VALUES (14623, '2020-08-12', 'CM', 'Cameroon', 'AFRO', '50', '18263', '3', '401');
INSERT INTO public.who_global_data_import VALUES (14624, '2020-08-13', 'CM', 'Cameroon', 'AFRO', '45', '18308', '0', '401');
INSERT INTO public.who_global_data_import VALUES (14625, '2020-08-14', 'CM', 'Cameroon', 'AFRO', '161', '18469', '0', '401');
INSERT INTO public.who_global_data_import VALUES (14626, '2020-08-15', 'CM', 'Cameroon', 'AFRO', '0', '18469', '0', '401');
INSERT INTO public.who_global_data_import VALUES (14627, '2020-08-16', 'CM', 'Cameroon', 'AFRO', '0', '18469', '0', '401');
INSERT INTO public.who_global_data_import VALUES (14628, '2020-08-17', 'CM', 'Cameroon', 'AFRO', '113', '18582', '2', '403');
INSERT INTO public.who_global_data_import VALUES (14629, '2020-08-18', 'CM', 'Cameroon', 'AFRO', '17', '18599', '3', '406');
INSERT INTO public.who_global_data_import VALUES (14630, '2020-08-19', 'CM', 'Cameroon', 'AFRO', '25', '18624', '0', '406');
INSERT INTO public.who_global_data_import VALUES (14631, '2020-08-20', 'CM', 'Cameroon', 'AFRO', '138', '18762', '2', '408');
INSERT INTO public.who_global_data_import VALUES (14632, '2020-08-21', 'CM', 'Cameroon', 'AFRO', '0', '18762', '0', '408');
INSERT INTO public.who_global_data_import VALUES (14633, '2020-08-22', 'CM', 'Cameroon', 'AFRO', '0', '18762', '0', '408');
INSERT INTO public.who_global_data_import VALUES (14634, '2020-08-23', 'CM', 'Cameroon', 'AFRO', '0', '18762', '0', '408');
INSERT INTO public.who_global_data_import VALUES (14635, '2020-08-24', 'CM', 'Cameroon', 'AFRO', '0', '18762', '0', '408');
INSERT INTO public.who_global_data_import VALUES (14636, '2020-08-25', 'CM', 'Cameroon', 'AFRO', '211', '18973', '2', '410');
INSERT INTO public.who_global_data_import VALUES (14637, '2020-08-26', 'CM', 'Cameroon', 'AFRO', '0', '18973', '0', '410');
INSERT INTO public.who_global_data_import VALUES (14638, '2020-08-27', 'CM', 'Cameroon', 'AFRO', '0', '18973', '0', '410');
INSERT INTO public.who_global_data_import VALUES (14639, '2020-08-28', 'CM', 'Cameroon', 'AFRO', '0', '18973', '0', '410');
INSERT INTO public.who_global_data_import VALUES (14640, '2020-08-29', 'CM', 'Cameroon', 'AFRO', '169', '19142', '1', '411');
INSERT INTO public.who_global_data_import VALUES (14641, '2020-08-30', 'CM', 'Cameroon', 'AFRO', '0', '19142', '0', '411');
INSERT INTO public.who_global_data_import VALUES (14642, '2020-08-31', 'CM', 'Cameroon', 'AFRO', '0', '19142', '0', '411');
INSERT INTO public.who_global_data_import VALUES (14643, '2020-09-01', 'CM', 'Cameroon', 'AFRO', '267', '19409', '3', '414');
INSERT INTO public.who_global_data_import VALUES (14644, '2020-09-02', 'CM', 'Cameroon', 'AFRO', '51', '19460', '1', '415');
INSERT INTO public.who_global_data_import VALUES (14645, '2020-09-03', 'CM', 'Cameroon', 'AFRO', '0', '19460', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14646, '2020-09-04', 'CM', 'Cameroon', 'AFRO', '144', '19604', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14647, '2020-09-05', 'CM', 'Cameroon', 'AFRO', '0', '19604', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14648, '2020-09-06', 'CM', 'Cameroon', 'AFRO', '0', '19604', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14649, '2020-09-07', 'CM', 'Cameroon', 'AFRO', '0', '19604', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14650, '2020-09-08', 'CM', 'Cameroon', 'AFRO', '244', '19848', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14651, '2020-09-09', 'CM', 'Cameroon', 'AFRO', '0', '19848', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14652, '2020-09-10', 'CM', 'Cameroon', 'AFRO', '0', '19848', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14653, '2020-09-11', 'CM', 'Cameroon', 'AFRO', '161', '20009', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14654, '2020-09-12', 'CM', 'Cameroon', 'AFRO', '0', '20009', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14655, '2020-09-13', 'CM', 'Cameroon', 'AFRO', '158', '20167', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14656, '2020-09-14', 'CM', 'Cameroon', 'AFRO', '61', '20228', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14657, '2020-09-15', 'CM', 'Cameroon', 'AFRO', '43', '20271', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14658, '2020-09-16', 'CM', 'Cameroon', 'AFRO', '32', '20303', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14659, '2020-09-17', 'CM', 'Cameroon', 'AFRO', '0', '20303', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14660, '2020-09-18', 'CM', 'Cameroon', 'AFRO', '0', '20303', '0', '415');
INSERT INTO public.who_global_data_import VALUES (14661, '2020-09-19', 'CM', 'Cameroon', 'AFRO', '128', '20431', '1', '416');
INSERT INTO public.who_global_data_import VALUES (14662, '2020-09-20', 'CM', 'Cameroon', 'AFRO', '0', '20431', '0', '416');
INSERT INTO public.who_global_data_import VALUES (14663, '2020-09-21', 'CM', 'Cameroon', 'AFRO', '167', '20598', '0', '416');
INSERT INTO public.who_global_data_import VALUES (14664, '2020-09-22', 'CM', 'Cameroon', 'AFRO', '0', '20598', '0', '416');
INSERT INTO public.who_global_data_import VALUES (14665, '2020-09-23', 'CM', 'Cameroon', 'AFRO', '92', '20690', '0', '416');
INSERT INTO public.who_global_data_import VALUES (14666, '2020-09-24', 'CM', 'Cameroon', 'AFRO', '0', '20690', '0', '416');
INSERT INTO public.who_global_data_import VALUES (14667, '2020-09-25', 'CM', 'Cameroon', 'AFRO', '0', '20690', '0', '416');
INSERT INTO public.who_global_data_import VALUES (14668, '2020-09-26', 'CM', 'Cameroon', 'AFRO', '45', '20735', '2', '418');
INSERT INTO public.who_global_data_import VALUES (14669, '2020-09-27', 'CM', 'Cameroon', 'AFRO', '0', '20735', '0', '418');
INSERT INTO public.who_global_data_import VALUES (14670, '2020-09-28', 'CM', 'Cameroon', 'AFRO', '103', '20838', '0', '418');
INSERT INTO public.who_global_data_import VALUES (14671, '2020-09-29', 'CM', 'Cameroon', 'AFRO', '0', '20838', '0', '418');
INSERT INTO public.who_global_data_import VALUES (14672, '2020-09-30', 'CM', 'Cameroon', 'AFRO', '0', '20838', '0', '418');
INSERT INTO public.who_global_data_import VALUES (14673, '2020-10-01', 'CM', 'Cameroon', 'AFRO', '0', '20838', '0', '418');
INSERT INTO public.who_global_data_import VALUES (14674, '2020-10-02', 'CM', 'Cameroon', 'AFRO', '0', '20838', '0', '418');
INSERT INTO public.who_global_data_import VALUES (14675, '2020-10-03', 'CM', 'Cameroon', 'AFRO', '0', '20838', '0', '418');
INSERT INTO public.who_global_data_import VALUES (14676, '2020-10-04', 'CM', 'Cameroon', 'AFRO', '0', '20838', '0', '418');
INSERT INTO public.who_global_data_import VALUES (14677, '2020-10-05', 'CM', 'Cameroon', 'AFRO', '37', '20875', '0', '418');
INSERT INTO public.who_global_data_import VALUES (14678, '2020-10-06', 'CM', 'Cameroon', 'AFRO', '49', '20924', '2', '420');
INSERT INTO public.who_global_data_import VALUES (14679, '2020-10-07', 'CM', 'Cameroon', 'AFRO', '0', '20924', '0', '420');
INSERT INTO public.who_global_data_import VALUES (14680, '2020-10-08', 'CM', 'Cameroon', 'AFRO', '236', '21160', '0', '420');
INSERT INTO public.who_global_data_import VALUES (14681, '2020-10-09', 'CM', 'Cameroon', 'AFRO', '0', '21160', '0', '420');
INSERT INTO public.who_global_data_import VALUES (14682, '2020-10-10', 'CM', 'Cameroon', 'AFRO', '0', '21160', '0', '420');
INSERT INTO public.who_global_data_import VALUES (14683, '2020-10-11', 'CM', 'Cameroon', 'AFRO', '0', '21160', '0', '420');
INSERT INTO public.who_global_data_import VALUES (14684, '2020-10-12', 'CM', 'Cameroon', 'AFRO', '0', '21160', '0', '420');
INSERT INTO public.who_global_data_import VALUES (14685, '2020-10-13', 'CM', 'Cameroon', 'AFRO', '173', '21333', '3', '423');
INSERT INTO public.who_global_data_import VALUES (14686, '2020-10-14', 'CM', 'Cameroon', 'AFRO', '108', '21441', '0', '423');
INSERT INTO public.who_global_data_import VALUES (14687, '2020-10-15', 'CM', 'Cameroon', 'AFRO', '0', '21441', '0', '423');
INSERT INTO public.who_global_data_import VALUES (14688, '2020-10-16', 'CM', 'Cameroon', 'AFRO', '0', '21441', '0', '423');
INSERT INTO public.who_global_data_import VALUES (14689, '2020-10-17', 'CM', 'Cameroon', 'AFRO', '0', '21441', '0', '423');
INSERT INTO public.who_global_data_import VALUES (14690, '2020-10-18', 'CM', 'Cameroon', 'AFRO', '0', '21441', '0', '423');
INSERT INTO public.who_global_data_import VALUES (14691, '2020-10-19', 'CM', 'Cameroon', 'AFRO', '65', '21506', '1', '424');
INSERT INTO public.who_global_data_import VALUES (14692, '2020-10-20', 'CM', 'Cameroon', 'AFRO', '64', '21570', '1', '425');
INSERT INTO public.who_global_data_import VALUES (14693, '2020-10-21', 'CM', 'Cameroon', 'AFRO', '0', '21570', '0', '425');
INSERT INTO public.who_global_data_import VALUES (14694, '2020-10-22', 'CM', 'Cameroon', 'AFRO', '0', '21570', '0', '425');
INSERT INTO public.who_global_data_import VALUES (14695, '2020-10-23', 'CM', 'Cameroon', 'AFRO', '0', '21570', '0', '425');
INSERT INTO public.who_global_data_import VALUES (14696, '2020-10-24', 'CM', 'Cameroon', 'AFRO', '0', '21570', '0', '425');
INSERT INTO public.who_global_data_import VALUES (14697, '2020-10-25', 'CM', 'Cameroon', 'AFRO', '0', '21570', '0', '425');
INSERT INTO public.who_global_data_import VALUES (14698, '2020-10-26', 'CM', 'Cameroon', 'AFRO', '223', '21793', '1', '426');
INSERT INTO public.who_global_data_import VALUES (14699, '2020-10-27', 'CM', 'Cameroon', 'AFRO', '0', '21793', '0', '426');
INSERT INTO public.who_global_data_import VALUES (14700, '2020-10-28', 'CM', 'Cameroon', 'AFRO', '0', '21793', '0', '426');
INSERT INTO public.who_global_data_import VALUES (14701, '2020-10-29', 'CM', 'Cameroon', 'AFRO', '0', '21793', '0', '426');
INSERT INTO public.who_global_data_import VALUES (14702, '2020-10-30', 'CM', 'Cameroon', 'AFRO', '0', '21793', '0', '426');
INSERT INTO public.who_global_data_import VALUES (14703, '2020-10-31', 'CM', 'Cameroon', 'AFRO', '0', '21793', '0', '426');
INSERT INTO public.who_global_data_import VALUES (14704, '2020-11-01', 'CM', 'Cameroon', 'AFRO', '0', '21793', '0', '426');
INSERT INTO public.who_global_data_import VALUES (14705, '2020-11-02', 'CM', 'Cameroon', 'AFRO', '0', '21793', '0', '426');
INSERT INTO public.who_global_data_import VALUES (14706, '2020-11-03', 'CM', 'Cameroon', 'AFRO', '310', '22103', '3', '429');
INSERT INTO public.who_global_data_import VALUES (14707, '2020-11-04', 'CM', 'Cameroon', 'AFRO', '0', '22103', '0', '429');
INSERT INTO public.who_global_data_import VALUES (14708, '2020-11-05', 'CM', 'Cameroon', 'AFRO', '0', '22103', '0', '429');
INSERT INTO public.who_global_data_import VALUES (14709, '2020-11-06', 'CM', 'Cameroon', 'AFRO', '0', '22103', '0', '429');
INSERT INTO public.who_global_data_import VALUES (14710, '2020-11-07', 'CM', 'Cameroon', 'AFRO', '239', '22342', '0', '429');
INSERT INTO public.who_global_data_import VALUES (14711, '2020-11-08', 'CM', 'Cameroon', 'AFRO', '0', '22342', '0', '429');
INSERT INTO public.who_global_data_import VALUES (14712, '2020-11-09', 'CM', 'Cameroon', 'AFRO', '0', '22342', '0', '429');
INSERT INTO public.who_global_data_import VALUES (14713, '2020-11-10', 'CM', 'Cameroon', 'AFRO', '38', '22380', '2', '431');
INSERT INTO public.who_global_data_import VALUES (14714, '2020-11-11', 'CM', 'Cameroon', 'AFRO', '110', '22490', '2', '433');
INSERT INTO public.who_global_data_import VALUES (14715, '2020-11-12', 'CM', 'Cameroon', 'AFRO', '0', '22490', '0', '433');
INSERT INTO public.who_global_data_import VALUES (14716, '2020-11-13', 'CM', 'Cameroon', 'AFRO', '93', '22583', '0', '433');
INSERT INTO public.who_global_data_import VALUES (14717, '2020-11-14', 'CM', 'Cameroon', 'AFRO', '109', '22692', '0', '433');
INSERT INTO public.who_global_data_import VALUES (14718, '2020-11-15', 'CM', 'Cameroon', 'AFRO', '0', '22692', '0', '433');
INSERT INTO public.who_global_data_import VALUES (14719, '2020-11-16', 'CM', 'Cameroon', 'AFRO', '0', '22692', '0', '433');
INSERT INTO public.who_global_data_import VALUES (14720, '2020-11-17', 'CM', 'Cameroon', 'AFRO', '204', '22896', '0', '433');
INSERT INTO public.who_global_data_import VALUES (14721, '2020-11-18', 'CM', 'Cameroon', 'AFRO', '0', '22896', '0', '433');
INSERT INTO public.who_global_data_import VALUES (14722, '2020-11-19', 'CM', 'Cameroon', 'AFRO', '0', '22896', '0', '433');
INSERT INTO public.who_global_data_import VALUES (14723, '2020-11-20', 'CM', 'Cameroon', 'AFRO', '632', '23528', '2', '435');
INSERT INTO public.who_global_data_import VALUES (14724, '2020-11-21', 'CM', 'Cameroon', 'AFRO', '0', '23528', '0', '435');
INSERT INTO public.who_global_data_import VALUES (14725, '2020-11-22', 'CM', 'Cameroon', 'AFRO', '0', '23528', '0', '435');
INSERT INTO public.who_global_data_import VALUES (14726, '2020-11-23', 'CM', 'Cameroon', 'AFRO', '314', '23842', '0', '435');
INSERT INTO public.who_global_data_import VALUES (14727, '2020-11-24', 'CM', 'Cameroon', 'AFRO', '27', '23869', '1', '436');
INSERT INTO public.who_global_data_import VALUES (14728, '2020-11-25', 'CM', 'Cameroon', 'AFRO', '46', '23915', '1', '437');
INSERT INTO public.who_global_data_import VALUES (14729, '2020-11-26', 'CM', 'Cameroon', 'AFRO', '107', '24022', '0', '437');
INSERT INTO public.who_global_data_import VALUES (14730, '2020-11-27', 'CM', 'Cameroon', 'AFRO', '95', '24117', '0', '437');
INSERT INTO public.who_global_data_import VALUES (14731, '2020-11-28', 'CM', 'Cameroon', 'AFRO', '0', '24117', '0', '437');
INSERT INTO public.who_global_data_import VALUES (14732, '2020-11-29', 'CM', 'Cameroon', 'AFRO', '0', '24117', '0', '437');
INSERT INTO public.who_global_data_import VALUES (14733, '2020-11-30', 'CM', 'Cameroon', 'AFRO', '328', '24445', '0', '437');
INSERT INTO public.who_global_data_import VALUES (14734, '2020-12-01', 'CM', 'Cameroon', 'AFRO', '42', '24487', '4', '441');
INSERT INTO public.who_global_data_import VALUES (14735, '2020-12-02', 'CM', 'Cameroon', 'AFRO', '0', '24487', '0', '441');
INSERT INTO public.who_global_data_import VALUES (14736, '2020-12-03', 'CM', 'Cameroon', 'AFRO', '0', '24487', '0', '441');
INSERT INTO public.who_global_data_import VALUES (14737, '2020-12-04', 'CM', 'Cameroon', 'AFRO', '265', '24752', '2', '443');
INSERT INTO public.who_global_data_import VALUES (14738, '2020-12-05', 'CM', 'Cameroon', 'AFRO', '0', '24752', '0', '443');
INSERT INTO public.who_global_data_import VALUES (14739, '2020-12-06', 'CM', 'Cameroon', 'AFRO', '0', '24752', '0', '443');
INSERT INTO public.who_global_data_import VALUES (14740, '2020-12-07', 'CM', 'Cameroon', 'AFRO', '0', '24752', '0', '443');
INSERT INTO public.who_global_data_import VALUES (14741, '2020-12-08', 'CM', 'Cameroon', 'AFRO', '0', '24752', '0', '443');
INSERT INTO public.who_global_data_import VALUES (14742, '2020-12-09', 'CM', 'Cameroon', 'AFRO', '211', '24963', '0', '443');
INSERT INTO public.who_global_data_import VALUES (14743, '2020-12-10', 'CM', 'Cameroon', 'AFRO', '180', '25143', '0', '443');
INSERT INTO public.who_global_data_import VALUES (14744, '2020-12-11', 'CM', 'Cameroon', 'AFRO', '0', '25143', '0', '443');
INSERT INTO public.who_global_data_import VALUES (14745, '2020-12-12', 'CM', 'Cameroon', 'AFRO', '0', '25143', '0', '443');
INSERT INTO public.who_global_data_import VALUES (14746, '2020-12-13', 'CM', 'Cameroon', 'AFRO', '0', '25143', '0', '443');
INSERT INTO public.who_global_data_import VALUES (14747, '2020-12-14', 'CM', 'Cameroon', 'AFRO', '71', '25214', '0', '443');
INSERT INTO public.who_global_data_import VALUES (14748, '2020-12-15', 'CM', 'Cameroon', 'AFRO', '145', '25359', '2', '445');
INSERT INTO public.who_global_data_import VALUES (14749, '2020-12-16', 'CM', 'Cameroon', 'AFRO', '113', '25472', '0', '445');
INSERT INTO public.who_global_data_import VALUES (14750, '2020-12-17', 'CM', 'Cameroon', 'AFRO', '0', '25472', '0', '445');
INSERT INTO public.who_global_data_import VALUES (14751, '2020-12-18', 'CM', 'Cameroon', 'AFRO', '0', '25472', '0', '445');
INSERT INTO public.who_global_data_import VALUES (14752, '2020-12-19', 'CM', 'Cameroon', 'AFRO', '252', '25724', '0', '445');
INSERT INTO public.who_global_data_import VALUES (14753, '2020-12-20', 'CM', 'Cameroon', 'AFRO', '125', '25849', '3', '448');
INSERT INTO public.who_global_data_import VALUES (14754, '2020-12-21', 'CM', 'Cameroon', 'AFRO', '0', '25849', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14755, '2020-12-22', 'CM', 'Cameroon', 'AFRO', '0', '25849', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14756, '2020-12-23', 'CM', 'Cameroon', 'AFRO', '0', '25849', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14757, '2020-12-24', 'CM', 'Cameroon', 'AFRO', '0', '25849', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14758, '2020-12-25', 'CM', 'Cameroon', 'AFRO', '0', '25849', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14759, '2020-12-26', 'CM', 'Cameroon', 'AFRO', '0', '25849', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14760, '2020-12-27', 'CM', 'Cameroon', 'AFRO', '428', '26277', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14761, '2020-12-28', 'CM', 'Cameroon', 'AFRO', '0', '26277', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14762, '2020-12-29', 'CM', 'Cameroon', 'AFRO', '0', '26277', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14763, '2020-12-30', 'CM', 'Cameroon', 'AFRO', '0', '26277', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14764, '2020-12-31', 'CM', 'Cameroon', 'AFRO', '0', '26277', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14765, '2021-01-01', 'CM', 'Cameroon', 'AFRO', '571', '26848', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14766, '2021-01-02', 'CM', 'Cameroon', 'AFRO', '0', '26848', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14767, '2021-01-03', 'CM', 'Cameroon', 'AFRO', '0', '26848', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14768, '2021-01-04', 'CM', 'Cameroon', 'AFRO', '0', '26848', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14769, '2021-01-05', 'CM', 'Cameroon', 'AFRO', '0', '26848', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14770, '2021-01-06', 'CM', 'Cameroon', 'AFRO', '0', '26848', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14771, '2021-01-07', 'CM', 'Cameroon', 'AFRO', '0', '26848', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14772, '2021-01-08', 'CM', 'Cameroon', 'AFRO', '0', '26848', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14773, '2021-01-09', 'CM', 'Cameroon', 'AFRO', '0', '26848', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14774, '2021-01-10', 'CM', 'Cameroon', 'AFRO', '0', '26848', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14775, '2021-01-11', 'CM', 'Cameroon', 'AFRO', '0', '26848', '0', '448');
INSERT INTO public.who_global_data_import VALUES (14776, '2021-01-12', 'CM', 'Cameroon', 'AFRO', '488', '27336', '3', '451');
INSERT INTO public.who_global_data_import VALUES (14777, '2021-01-13', 'CM', 'Cameroon', 'AFRO', '0', '27336', '0', '451');
INSERT INTO public.who_global_data_import VALUES (14778, '2021-01-14', 'CM', 'Cameroon', 'AFRO', '0', '27336', '0', '451');
INSERT INTO public.who_global_data_import VALUES (14779, '2021-01-15', 'CM', 'Cameroon', 'AFRO', '0', '27336', '0', '451');
INSERT INTO public.who_global_data_import VALUES (14780, '2021-01-16', 'CM', 'Cameroon', 'AFRO', '0', '27336', '0', '451');
INSERT INTO public.who_global_data_import VALUES (14781, '2021-01-17', 'CM', 'Cameroon', 'AFRO', '0', '27336', '0', '451');
INSERT INTO public.who_global_data_import VALUES (14782, '2021-01-18', 'CM', 'Cameroon', 'AFRO', '674', '28010', '4', '455');
INSERT INTO public.who_global_data_import VALUES (14783, '2021-01-19', 'CM', 'Cameroon', 'AFRO', '0', '28010', '0', '455');
INSERT INTO public.who_global_data_import VALUES (14784, '2021-01-20', 'CM', 'Cameroon', 'AFRO', '0', '28010', '0', '455');
INSERT INTO public.who_global_data_import VALUES (14785, '2021-01-21', 'CM', 'Cameroon', 'AFRO', '0', '28010', '0', '455');
INSERT INTO public.who_global_data_import VALUES (14786, '2021-01-22', 'CM', 'Cameroon', 'AFRO', '0', '28010', '0', '455');
INSERT INTO public.who_global_data_import VALUES (14787, '2021-01-23', 'CM', 'Cameroon', 'AFRO', '0', '28010', '0', '455');
INSERT INTO public.who_global_data_import VALUES (14788, '2021-01-24', 'CM', 'Cameroon', 'AFRO', '1607', '29617', '7', '462');
INSERT INTO public.who_global_data_import VALUES (14789, '2021-01-25', 'CM', 'Cameroon', 'AFRO', '0', '29617', '0', '462');
INSERT INTO public.who_global_data_import VALUES (14790, '2021-01-26', 'CM', 'Cameroon', 'AFRO', '0', '29617', '0', '462');
INSERT INTO public.who_global_data_import VALUES (14791, '2021-01-27', 'CM', 'Cameroon', 'AFRO', '0', '29617', '0', '462');
INSERT INTO public.who_global_data_import VALUES (14792, '2021-01-28', 'CM', 'Cameroon', 'AFRO', '0', '29617', '0', '462');
INSERT INTO public.who_global_data_import VALUES (14793, '2021-01-29', 'CM', 'Cameroon', 'AFRO', '0', '29617', '0', '462');
INSERT INTO public.who_global_data_import VALUES (14794, '2021-01-30', 'CM', 'Cameroon', 'AFRO', '0', '29617', '0', '462');
INSERT INTO public.who_global_data_import VALUES (14795, '2021-01-31', 'CM', 'Cameroon', 'AFRO', '0', '29617', '0', '462');
INSERT INTO public.who_global_data_import VALUES (14796, '2021-02-01', 'CM', 'Cameroon', 'AFRO', '0', '29617', '0', '462');
INSERT INTO public.who_global_data_import VALUES (14797, '2021-02-02', 'CM', 'Cameroon', 'AFRO', '696', '30313', '12', '474');
INSERT INTO public.who_global_data_import VALUES (14798, '2021-02-03', 'CM', 'Cameroon', 'AFRO', '0', '30313', '0', '474');
INSERT INTO public.who_global_data_import VALUES (14799, '2021-02-04', 'CM', 'Cameroon', 'AFRO', '0', '30313', '0', '474');
INSERT INTO public.who_global_data_import VALUES (14800, '2021-02-05', 'CM', 'Cameroon', 'AFRO', '0', '30313', '0', '474');
INSERT INTO public.who_global_data_import VALUES (14801, '2020-01-03', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14802, '2020-01-04', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14803, '2020-01-05', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14804, '2020-01-06', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14805, '2020-01-07', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14806, '2020-01-08', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14807, '2020-01-09', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14808, '2020-01-10', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14809, '2020-01-11', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14810, '2020-01-12', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14811, '2020-01-13', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14812, '2020-01-14', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14813, '2020-01-15', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14814, '2020-01-16', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14815, '2020-01-17', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14816, '2020-01-18', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14817, '2020-01-19', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14818, '2020-01-20', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14819, '2020-01-21', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14820, '2020-01-22', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14821, '2020-01-23', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14822, '2020-01-24', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14823, '2020-01-25', 'CA', 'Canada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14824, '2020-01-26', 'CA', 'Canada', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14825, '2020-01-27', 'CA', 'Canada', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14826, '2020-01-28', 'CA', 'Canada', 'AMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14827, '2020-01-29', 'CA', 'Canada', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14828, '2020-01-30', 'CA', 'Canada', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14829, '2020-01-31', 'CA', 'Canada', 'AMRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14830, '2020-02-01', 'CA', 'Canada', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14831, '2020-02-02', 'CA', 'Canada', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14832, '2020-02-03', 'CA', 'Canada', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14833, '2020-02-04', 'CA', 'Canada', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14834, '2020-02-05', 'CA', 'Canada', 'AMRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14835, '2020-02-06', 'CA', 'Canada', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14836, '2020-02-07', 'CA', 'Canada', 'AMRO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14837, '2020-02-08', 'CA', 'Canada', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14838, '2020-02-09', 'CA', 'Canada', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14839, '2020-02-10', 'CA', 'Canada', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14840, '2020-02-11', 'CA', 'Canada', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14841, '2020-02-12', 'CA', 'Canada', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14842, '2020-02-13', 'CA', 'Canada', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14843, '2020-02-14', 'CA', 'Canada', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14844, '2020-02-15', 'CA', 'Canada', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14845, '2020-02-16', 'CA', 'Canada', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14846, '2020-02-17', 'CA', 'Canada', 'AMRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14847, '2020-02-18', 'CA', 'Canada', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14848, '2020-02-19', 'CA', 'Canada', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14849, '2020-02-20', 'CA', 'Canada', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14850, '2020-02-21', 'CA', 'Canada', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14851, '2020-02-22', 'CA', 'Canada', 'AMRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14852, '2020-02-23', 'CA', 'Canada', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14853, '2020-02-24', 'CA', 'Canada', 'AMRO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14854, '2020-02-25', 'CA', 'Canada', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14855, '2020-02-26', 'CA', 'Canada', 'AMRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14856, '2020-02-27', 'CA', 'Canada', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14857, '2020-02-28', 'CA', 'Canada', 'AMRO', '3', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14858, '2020-02-29', 'CA', 'Canada', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14859, '2020-03-01', 'CA', 'Canada', 'AMRO', '5', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14860, '2020-03-02', 'CA', 'Canada', 'AMRO', '8', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14861, '2020-03-03', 'CA', 'Canada', 'AMRO', '3', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14862, '2020-03-04', 'CA', 'Canada', 'AMRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14863, '2020-03-05', 'CA', 'Canada', 'AMRO', '15', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14864, '2020-03-06', 'CA', 'Canada', 'AMRO', '4', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14865, '2020-03-07', 'CA', 'Canada', 'AMRO', '8', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14866, '2020-03-08', 'CA', 'Canada', 'AMRO', '3', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14867, '2020-03-09', 'CA', 'Canada', 'AMRO', '12', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14868, '2020-03-10', 'CA', 'Canada', 'AMRO', '5', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14869, '2020-03-11', 'CA', 'Canada', 'AMRO', '16', '97', '1', '1');
INSERT INTO public.who_global_data_import VALUES (14870, '2020-03-12', 'CA', 'Canada', 'AMRO', '0', '97', '0', '1');
INSERT INTO public.who_global_data_import VALUES (14871, '2020-03-13', 'CA', 'Canada', 'AMRO', '59', '156', '0', '1');
INSERT INTO public.who_global_data_import VALUES (14872, '2020-03-14', 'CA', 'Canada', 'AMRO', '24', '180', '0', '1');
INSERT INTO public.who_global_data_import VALUES (14873, '2020-03-15', 'CA', 'Canada', 'AMRO', '128', '308', '0', '1');
INSERT INTO public.who_global_data_import VALUES (14874, '2020-03-16', 'CA', 'Canada', 'AMRO', '0', '308', '0', '1');
INSERT INTO public.who_global_data_import VALUES (14875, '2020-03-17', 'CA', 'Canada', 'AMRO', '120', '428', '0', '1');
INSERT INTO public.who_global_data_import VALUES (14876, '2020-03-18', 'CA', 'Canada', 'AMRO', '145', '573', '8', '9');
INSERT INTO public.who_global_data_import VALUES (14877, '2020-03-19', 'CA', 'Canada', 'AMRO', '163', '736', '0', '9');
INSERT INTO public.who_global_data_import VALUES (14878, '2020-03-20', 'CA', 'Canada', 'AMRO', '110', '846', '0', '9');
INSERT INTO public.who_global_data_import VALUES (14879, '2020-03-21', 'CA', 'Canada', 'AMRO', '202', '1048', '4', '13');
INSERT INTO public.who_global_data_import VALUES (14880, '2020-03-22', 'CA', 'Canada', 'AMRO', '0', '1048', '0', '13');
INSERT INTO public.who_global_data_import VALUES (14881, '2020-03-23', 'CA', 'Canada', 'AMRO', '336', '1384', '6', '19');
INSERT INTO public.who_global_data_import VALUES (14882, '2020-03-24', 'CA', 'Canada', 'AMRO', '355', '1739', '6', '25');
INSERT INTO public.who_global_data_import VALUES (14883, '2020-03-25', 'CA', 'Canada', 'AMRO', '0', '1739', '0', '25');
INSERT INTO public.who_global_data_import VALUES (14884, '2020-03-26', 'CA', 'Canada', 'AMRO', '1816', '3555', '10', '35');
INSERT INTO public.who_global_data_import VALUES (14885, '2020-03-27', 'CA', 'Canada', 'AMRO', '0', '3555', '0', '35');
INSERT INTO public.who_global_data_import VALUES (14886, '2020-03-28', 'CA', 'Canada', 'AMRO', '463', '4018', '4', '39');
INSERT INTO public.who_global_data_import VALUES (14887, '2020-03-29', 'CA', 'Canada', 'AMRO', '739', '4757', '16', '55');
INSERT INTO public.who_global_data_import VALUES (14888, '2020-03-30', 'CA', 'Canada', 'AMRO', '898', '5655', '6', '61');
INSERT INTO public.who_global_data_import VALUES (14889, '2020-03-31', 'CA', 'Canada', 'AMRO', '662', '6317', '5', '66');
INSERT INTO public.who_global_data_import VALUES (14890, '2020-04-01', 'CA', 'Canada', 'AMRO', '1378', '7695', '23', '89');
INSERT INTO public.who_global_data_import VALUES (14891, '2020-04-02', 'CA', 'Canada', 'AMRO', '1310', '9005', '16', '105');
INSERT INTO public.who_global_data_import VALUES (14892, '2020-04-03', 'CA', 'Canada', 'AMRO', '1109', '10114', '22', '127');
INSERT INTO public.who_global_data_import VALUES (14893, '2020-04-04', 'CA', 'Canada', 'AMRO', '1618', '11732', '25', '152');
INSERT INTO public.who_global_data_import VALUES (14894, '2020-04-05', 'CA', 'Canada', 'AMRO', '1206', '12938', '62', '214');
INSERT INTO public.who_global_data_import VALUES (14895, '2020-04-06', 'CA', 'Canada', 'AMRO', '966', '13904', '17', '231');
INSERT INTO public.who_global_data_import VALUES (14896, '2020-04-07', 'CA', 'Canada', 'AMRO', '1902', '15806', '62', '293');
INSERT INTO public.who_global_data_import VALUES (14897, '2020-04-08', 'CA', 'Canada', 'AMRO', '1243', '17049', '52', '345');
INSERT INTO public.who_global_data_import VALUES (14898, '2020-04-09', 'CA', 'Canada', 'AMRO', '1384', '18433', '56', '401');
INSERT INTO public.who_global_data_import VALUES (14899, '2020-04-10', 'CA', 'Canada', 'AMRO', '1326', '19759', '60', '461');
INSERT INTO public.who_global_data_import VALUES (14900, '2020-04-11', 'CA', 'Canada', 'AMRO', '1467', '21226', '70', '531');
INSERT INTO public.who_global_data_import VALUES (14901, '2020-04-12', 'CA', 'Canada', 'AMRO', '1318', '22544', '69', '600');
INSERT INTO public.who_global_data_import VALUES (14902, '2020-04-13', 'CA', 'Canada', 'AMRO', '1158', '23702', '74', '674');
INSERT INTO public.who_global_data_import VALUES (14903, '2020-04-14', 'CA', 'Canada', 'AMRO', '1084', '24786', '60', '734');
INSERT INTO public.who_global_data_import VALUES (14904, '2020-04-15', 'CA', 'Canada', 'AMRO', '1360', '26146', '89', '823');
INSERT INTO public.who_global_data_import VALUES (14905, '2020-04-16', 'CA', 'Canada', 'AMRO', '1394', '27540', '131', '954');
INSERT INTO public.who_global_data_import VALUES (14906, '2020-04-17', 'CA', 'Canada', 'AMRO', '1344', '28884', '94', '1048');
INSERT INTO public.who_global_data_import VALUES (14907, '2020-04-18', 'CA', 'Canada', 'AMRO', '1775', '30659', '202', '1250');
INSERT INTO public.who_global_data_import VALUES (14908, '2020-04-19', 'CA', 'Canada', 'AMRO', '1741', '32400', '96', '1346');
INSERT INTO public.who_global_data_import VALUES (14909, '2020-04-20', 'CA', 'Canada', 'AMRO', '1509', '33909', '160', '1506');
INSERT INTO public.who_global_data_import VALUES (14910, '2020-04-21', 'CA', 'Canada', 'AMRO', '1474', '35383', '105', '1611');
INSERT INTO public.who_global_data_import VALUES (14911, '2020-04-22', 'CA', 'Canada', 'AMRO', '1991', '37374', '117', '1728');
INSERT INTO public.who_global_data_import VALUES (14912, '2020-04-23', 'CA', 'Canada', 'AMRO', '1549', '38923', '143', '1871');
INSERT INTO public.who_global_data_import VALUES (14913, '2020-04-24', 'CA', 'Canada', 'AMRO', '1890', '40813', '157', '2028');
INSERT INTO public.who_global_data_import VALUES (14914, '2020-04-25', 'CA', 'Canada', 'AMRO', '1926', '42739', '169', '2197');
INSERT INTO public.who_global_data_import VALUES (14915, '2020-04-26', 'CA', 'Canada', 'AMRO', '1614', '44353', '153', '2350');
INSERT INTO public.who_global_data_import VALUES (14916, '2020-04-27', 'CA', 'Canada', 'AMRO', '1425', '45778', '139', '2489');
INSERT INTO public.who_global_data_import VALUES (14917, '2020-04-28', 'CA', 'Canada', 'AMRO', '1538', '47316', '128', '2617');
INSERT INTO public.who_global_data_import VALUES (16117, '2020-04-28', 'TD', 'Chad', 'AFRO', '0', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (14918, '2020-04-29', 'CA', 'Canada', 'AMRO', '1698', '49014', '149', '2766');
INSERT INTO public.who_global_data_import VALUES (14919, '2020-04-30', 'CA', 'Canada', 'AMRO', '1349', '50363', '138', '2904');
INSERT INTO public.who_global_data_import VALUES (14920, '2020-05-01', 'CA', 'Canada', 'AMRO', '1693', '52056', '178', '3082');
INSERT INTO public.who_global_data_import VALUES (14921, '2020-05-02', 'CA', 'Canada', 'AMRO', '1601', '53657', '141', '3223');
INSERT INTO public.who_global_data_import VALUES (14922, '2020-05-03', 'CA', 'Canada', 'AMRO', '1915', '55572', '223', '3446');
INSERT INTO public.who_global_data_import VALUES (14923, '2020-05-04', 'CA', 'Canada', 'AMRO', '3793', '59365', '235', '3681');
INSERT INTO public.who_global_data_import VALUES (14924, '2020-05-05', 'CA', 'Canada', 'AMRO', '479', '59844', '85', '3766');
INSERT INTO public.who_global_data_import VALUES (14925, '2020-05-06', 'CA', 'Canada', 'AMRO', '1315', '61159', '149', '3915');
INSERT INTO public.who_global_data_import VALUES (14926, '2020-05-07', 'CA', 'Canada', 'AMRO', '1299', '62458', '196', '4111');
INSERT INTO public.who_global_data_import VALUES (14927, '2020-05-08', 'CA', 'Canada', 'AMRO', '1437', '63895', '169', '4280');
INSERT INTO public.who_global_data_import VALUES (14928, '2020-05-09', 'CA', 'Canada', 'AMRO', '1504', '65399', '191', '4471');
INSERT INTO public.who_global_data_import VALUES (14929, '2020-05-10', 'CA', 'Canada', 'AMRO', '1381', '66780', '157', '4628');
INSERT INTO public.who_global_data_import VALUES (14930, '2020-05-11', 'CA', 'Canada', 'AMRO', '1216', '67996', '100', '4728');
INSERT INTO public.who_global_data_import VALUES (14931, '2020-05-12', 'CA', 'Canada', 'AMRO', '1160', '69156', '178', '4906');
INSERT INTO public.who_global_data_import VALUES (14932, '2020-05-13', 'CA', 'Canada', 'AMRO', '1186', '70342', '143', '5049');
INSERT INTO public.who_global_data_import VALUES (14933, '2020-05-14', 'CA', 'Canada', 'AMRO', '1144', '71486', '160', '5209');
INSERT INTO public.who_global_data_import VALUES (14934, '2020-05-15', 'CA', 'Canada', 'AMRO', '1050', '72536', '128', '5337');
INSERT INTO public.who_global_data_import VALUES (14935, '2020-05-16', 'CA', 'Canada', 'AMRO', '1293', '73829', '162', '5499');
INSERT INTO public.who_global_data_import VALUES (14936, '2020-05-17', 'CA', 'Canada', 'AMRO', '1164', '74993', '96', '5595');
INSERT INTO public.who_global_data_import VALUES (14937, '2020-05-18', 'CA', 'Canada', 'AMRO', '1211', '76204', '107', '5702');
INSERT INTO public.who_global_data_import VALUES (14938, '2020-05-19', 'CA', 'Canada', 'AMRO', '1102', '77306', '103', '5805');
INSERT INTO public.who_global_data_import VALUES (14939, '2020-05-20', 'CA', 'Canada', 'AMRO', '1193', '78499', '52', '5857');
INSERT INTO public.who_global_data_import VALUES (14940, '2020-05-21', 'CA', 'Canada', 'AMRO', '1003', '79502', '98', '5955');
INSERT INTO public.who_global_data_import VALUES (14941, '2020-05-22', 'CA', 'Canada', 'AMRO', '1053', '80555', '107', '6062');
INSERT INTO public.who_global_data_import VALUES (14942, '2020-05-23', 'CA', 'Canada', 'AMRO', '1210', '81765', '118', '6180');
INSERT INTO public.who_global_data_import VALUES (14943, '2020-05-24', 'CA', 'Canada', 'AMRO', '1127', '82892', '97', '6277');
INSERT INTO public.who_global_data_import VALUES (14944, '2020-05-25', 'CA', 'Canada', 'AMRO', '1189', '84081', '103', '6380');
INSERT INTO public.who_global_data_import VALUES (14945, '2020-05-26', 'CA', 'Canada', 'AMRO', '1022', '85103', '73', '6453');
INSERT INTO public.who_global_data_import VALUES (14946, '2020-05-27', 'CA', 'Canada', 'AMRO', '895', '85998', '113', '6566');
INSERT INTO public.who_global_data_import VALUES (14947, '2020-05-28', 'CA', 'Canada', 'AMRO', '941', '86939', '105', '6671');
INSERT INTO public.who_global_data_import VALUES (14948, '2020-05-29', 'CA', 'Canada', 'AMRO', '963', '87902', '128', '6799');
INSERT INTO public.who_global_data_import VALUES (14949, '2020-05-30', 'CA', 'Canada', 'AMRO', '954', '88856', '119', '6918');
INSERT INTO public.who_global_data_import VALUES (14950, '2020-05-31', 'CA', 'Canada', 'AMRO', '885', '89741', '78', '6996');
INSERT INTO public.who_global_data_import VALUES (14951, '2020-06-01', 'CA', 'Canada', 'AMRO', '775', '90516', '96', '7092');
INSERT INTO public.who_global_data_import VALUES (14952, '2020-06-02', 'CA', 'Canada', 'AMRO', '835', '91351', '213', '7305');
INSERT INTO public.who_global_data_import VALUES (14953, '2020-06-03', 'CA', 'Canada', 'AMRO', '800', '92151', '39', '7344');
INSERT INTO public.who_global_data_import VALUES (14954, '2020-06-04', 'CA', 'Canada', 'AMRO', '597', '92748', '70', '7414');
INSERT INTO public.who_global_data_import VALUES (14955, '2020-06-05', 'CA', 'Canada', 'AMRO', '693', '93441', '129', '7543');
INSERT INTO public.who_global_data_import VALUES (14956, '2020-06-06', 'CA', 'Canada', 'AMRO', '629', '94070', '109', '7652');
INSERT INTO public.who_global_data_import VALUES (14957, '2020-06-07', 'CA', 'Canada', 'AMRO', '265', '94335', '51', '7703');
INSERT INTO public.who_global_data_import VALUES (14958, '2020-06-08', 'CA', 'Canada', 'AMRO', '722', '95057', '70', '7773');
INSERT INTO public.who_global_data_import VALUES (14959, '2020-06-09', 'CA', 'Canada', 'AMRO', '642', '95699', '27', '7800');
INSERT INTO public.who_global_data_import VALUES (14960, '2020-06-10', 'CA', 'Canada', 'AMRO', '545', '96244', '35', '7835');
INSERT INTO public.who_global_data_import VALUES (14961, '2020-06-11', 'CA', 'Canada', 'AMRO', '409', '96653', '62', '7897');
INSERT INTO public.who_global_data_import VALUES (14962, '2020-06-12', 'CA', 'Canada', 'AMRO', '472', '97125', '63', '7960');
INSERT INTO public.who_global_data_import VALUES (14963, '2020-06-13', 'CA', 'Canada', 'AMRO', '405', '97530', '34', '7994');
INSERT INTO public.who_global_data_import VALUES (14964, '2020-06-14', 'CA', 'Canada', 'AMRO', '413', '97943', '55', '8049');
INSERT INTO public.who_global_data_import VALUES (14965, '2020-06-15', 'CA', 'Canada', 'AMRO', '467', '98410', '58', '8107');
INSERT INTO public.who_global_data_import VALUES (14966, '2020-06-16', 'CA', 'Canada', 'AMRO', '377', '98787', '39', '8146');
INSERT INTO public.who_global_data_import VALUES (14967, '2020-06-17', 'CA', 'Canada', 'AMRO', '360', '99147', '29', '8175');
INSERT INTO public.who_global_data_import VALUES (14968, '2020-06-18', 'CA', 'Canada', 'AMRO', '320', '99467', '38', '8213');
INSERT INTO public.who_global_data_import VALUES (14969, '2020-06-19', 'CA', 'Canada', 'AMRO', '386', '99853', '41', '8254');
INSERT INTO public.who_global_data_import VALUES (14970, '2020-06-20', 'CA', 'Canada', 'AMRO', '367', '100220', '46', '8300');
INSERT INTO public.who_global_data_import VALUES (14971, '2020-06-21', 'CA', 'Canada', 'AMRO', '409', '100629', '46', '8346');
INSERT INTO public.who_global_data_import VALUES (14972, '2020-06-22', 'CA', 'Canada', 'AMRO', '390', '101019', '64', '8410');
INSERT INTO public.who_global_data_import VALUES (14973, '2020-06-23', 'CA', 'Canada', 'AMRO', '318', '101337', '20', '8430');
INSERT INTO public.who_global_data_import VALUES (14974, '2020-06-24', 'CA', 'Canada', 'AMRO', '300', '101637', '6', '8436');
INSERT INTO public.who_global_data_import VALUES (14975, '2020-06-25', 'CA', 'Canada', 'AMRO', '326', '101963', '18', '8454');
INSERT INTO public.who_global_data_import VALUES (14976, '2020-06-26', 'CA', 'Canada', 'AMRO', '279', '102242', '30', '8484');
INSERT INTO public.who_global_data_import VALUES (14977, '2020-06-27', 'CA', 'Canada', 'AMRO', '380', '102622', '20', '8504');
INSERT INTO public.who_global_data_import VALUES (14978, '2020-06-28', 'CA', 'Canada', 'AMRO', '172', '102794', '4', '8508');
INSERT INTO public.who_global_data_import VALUES (14979, '2020-06-29', 'CA', 'Canada', 'AMRO', '238', '103032', '8', '8516');
INSERT INTO public.who_global_data_import VALUES (14980, '2020-06-30', 'CA', 'Canada', 'AMRO', '218', '103250', '6', '8522');
INSERT INTO public.who_global_data_import VALUES (14981, '2020-07-01', 'CA', 'Canada', 'AMRO', '668', '103918', '44', '8566');
INSERT INTO public.who_global_data_import VALUES (14982, '2020-07-02', 'CA', 'Canada', 'AMRO', '286', '104204', '25', '8591');
INSERT INTO public.who_global_data_import VALUES (14983, '2020-07-03', 'CA', 'Canada', 'AMRO', '0', '104204', '0', '8591');
INSERT INTO public.who_global_data_import VALUES (14984, '2020-07-04', 'CA', 'Canada', 'AMRO', '568', '104772', '51', '8642');
INSERT INTO public.who_global_data_import VALUES (14985, '2020-07-05', 'CA', 'Canada', 'AMRO', '319', '105091', '21', '8663');
INSERT INTO public.who_global_data_import VALUES (14986, '2020-07-06', 'CA', 'Canada', 'AMRO', '226', '105317', '11', '8674');
INSERT INTO public.who_global_data_import VALUES (14987, '2020-07-07', 'CA', 'Canada', 'AMRO', '219', '105536', '10', '8684');
INSERT INTO public.who_global_data_import VALUES (14988, '2020-07-08', 'CA', 'Canada', 'AMRO', '399', '105935', '9', '8693');
INSERT INTO public.who_global_data_import VALUES (14989, '2020-07-09', 'CA', 'Canada', 'AMRO', '232', '106167', '18', '8711');
INSERT INTO public.who_global_data_import VALUES (14990, '2020-07-10', 'CA', 'Canada', 'AMRO', '267', '106434', '26', '8737');
INSERT INTO public.who_global_data_import VALUES (14991, '2020-07-11', 'CA', 'Canada', 'AMRO', '371', '106805', '12', '8749');
INSERT INTO public.who_global_data_import VALUES (14992, '2020-07-12', 'CA', 'Canada', 'AMRO', '321', '107126', '10', '8759');
INSERT INTO public.who_global_data_import VALUES (14993, '2020-07-13', 'CA', 'Canada', 'AMRO', '221', '107347', '14', '8773');
INSERT INTO public.who_global_data_import VALUES (14994, '2020-07-14', 'CA', 'Canada', 'AMRO', '243', '107590', '10', '8783');
INSERT INTO public.who_global_data_import VALUES (14995, '2020-07-15', 'CA', 'Canada', 'AMRO', '565', '108155', '7', '8790');
INSERT INTO public.who_global_data_import VALUES (14996, '2020-07-16', 'CA', 'Canada', 'AMRO', '331', '108486', '8', '8798');
INSERT INTO public.who_global_data_import VALUES (14997, '2020-07-17', 'CA', 'Canada', 'AMRO', '343', '108829', '12', '8810');
INSERT INTO public.who_global_data_import VALUES (14998, '2020-07-18', 'CA', 'Canada', 'AMRO', '435', '109264', '17', '8827');
INSERT INTO public.who_global_data_import VALUES (14999, '2020-07-19', 'CA', 'Canada', 'AMRO', '405', '109669', '12', '8839');
INSERT INTO public.who_global_data_import VALUES (15000, '2020-07-20', 'CA', 'Canada', 'AMRO', '330', '109999', '9', '8848');
INSERT INTO public.who_global_data_import VALUES (15001, '2020-07-21', 'CA', 'Canada', 'AMRO', '339', '110338', '4', '8852');
INSERT INTO public.who_global_data_import VALUES (15002, '2020-07-22', 'CA', 'Canada', 'AMRO', '786', '111124', '6', '8858');
INSERT INTO public.who_global_data_import VALUES (15003, '2020-07-23', 'CA', 'Canada', 'AMRO', '573', '111697', '4', '8862');
INSERT INTO public.who_global_data_import VALUES (15004, '2020-07-24', 'CA', 'Canada', 'AMRO', '543', '112240', '8', '8870');
INSERT INTO public.who_global_data_import VALUES (15005, '2020-07-25', 'CA', 'Canada', 'AMRO', '432', '112672', '4', '8874');
INSERT INTO public.who_global_data_import VALUES (15006, '2020-07-26', 'CA', 'Canada', 'AMRO', '534', '113206', '7', '8881');
INSERT INTO public.who_global_data_import VALUES (15007, '2020-07-27', 'CA', 'Canada', 'AMRO', '350', '113556', '4', '8885');
INSERT INTO public.who_global_data_import VALUES (15008, '2020-07-28', 'CA', 'Canada', 'AMRO', '355', '113911', '5', '8890');
INSERT INTO public.who_global_data_import VALUES (15009, '2020-07-29', 'CA', 'Canada', 'AMRO', '686', '114597', '11', '8901');
INSERT INTO public.who_global_data_import VALUES (15010, '2020-07-30', 'CA', 'Canada', 'AMRO', '397', '114994', '11', '8912');
INSERT INTO public.who_global_data_import VALUES (15011, '2020-07-31', 'CA', 'Canada', 'AMRO', '476', '115470', '5', '8917');
INSERT INTO public.who_global_data_import VALUES (15012, '2020-08-01', 'CA', 'Canada', 'AMRO', '329', '115799', '12', '8929');
INSERT INTO public.who_global_data_import VALUES (15013, '2020-08-02', 'CA', 'Canada', 'AMRO', '513', '116312', '6', '8935');
INSERT INTO public.who_global_data_import VALUES (15014, '2020-08-03', 'CA', 'Canada', 'AMRO', '287', '116599', '6', '8941');
INSERT INTO public.who_global_data_import VALUES (15015, '2020-08-04', 'CA', 'Canada', 'AMRO', '285', '116884', '4', '8945');
INSERT INTO public.who_global_data_import VALUES (15016, '2020-08-05', 'CA', 'Canada', 'AMRO', '147', '117031', '2', '8947');
INSERT INTO public.who_global_data_import VALUES (15017, '2020-08-06', 'CA', 'Canada', 'AMRO', '761', '117792', '11', '8958');
INSERT INTO public.who_global_data_import VALUES (15018, '2020-08-07', 'CA', 'Canada', 'AMRO', '395', '118187', '4', '8962');
INSERT INTO public.who_global_data_import VALUES (15019, '2020-08-08', 'CA', 'Canada', 'AMRO', '374', '118561', '4', '8966');
INSERT INTO public.who_global_data_import VALUES (15020, '2020-08-09', 'CA', 'Canada', 'AMRO', '424', '118985', '4', '8970');
INSERT INTO public.who_global_data_import VALUES (15021, '2020-08-10', 'CA', 'Canada', 'AMRO', '236', '119221', '6', '8976');
INSERT INTO public.who_global_data_import VALUES (15022, '2020-08-11', 'CA', 'Canada', 'AMRO', '230', '119451', '5', '8981');
INSERT INTO public.who_global_data_import VALUES (15023, '2020-08-12', 'CA', 'Canada', 'AMRO', '681', '120132', '6', '8987');
INSERT INTO public.who_global_data_import VALUES (15024, '2020-08-13', 'CA', 'Canada', 'AMRO', '289', '120421', '4', '8991');
INSERT INTO public.who_global_data_import VALUES (15025, '2020-08-14', 'CA', 'Canada', 'AMRO', '423', '120844', '15', '9006');
INSERT INTO public.who_global_data_import VALUES (15026, '2020-08-15', 'CA', 'Canada', 'AMRO', '390', '121234', '9', '9015');
INSERT INTO public.who_global_data_import VALUES (15027, '2020-08-16', 'CA', 'Canada', 'AMRO', '418', '121652', '5', '9020');
INSERT INTO public.who_global_data_import VALUES (15028, '2020-08-17', 'CA', 'Canada', 'AMRO', '237', '121889', '4', '9024');
INSERT INTO public.who_global_data_import VALUES (15029, '2020-08-18', 'CA', 'Canada', 'AMRO', '198', '122087', '2', '9026');
INSERT INTO public.who_global_data_import VALUES (15030, '2020-08-19', 'CA', 'Canada', 'AMRO', '785', '122872', '6', '9032');
INSERT INTO public.who_global_data_import VALUES (15031, '2020-08-20', 'CA', 'Canada', 'AMRO', '282', '123154', '13', '9045');
INSERT INTO public.who_global_data_import VALUES (15032, '2020-08-21', 'CA', 'Canada', 'AMRO', '336', '123490', '4', '9049');
INSERT INTO public.who_global_data_import VALUES (15033, '2020-08-22', 'CA', 'Canada', 'AMRO', '383', '123873', '5', '9054');
INSERT INTO public.who_global_data_import VALUES (15034, '2020-08-23', 'CA', 'Canada', 'AMRO', '499', '124372', '10', '9064');
INSERT INTO public.who_global_data_import VALUES (15035, '2020-08-24', 'CA', 'Canada', 'AMRO', '257', '124629', '7', '9071');
INSERT INTO public.who_global_data_import VALUES (15036, '2020-08-25', 'CA', 'Canada', 'AMRO', '267', '124896', '2', '9073');
INSERT INTO public.who_global_data_import VALUES (15037, '2020-08-26', 'CA', 'Canada', 'AMRO', '751', '125647', '10', '9083');
INSERT INTO public.who_global_data_import VALUES (15038, '2020-08-27', 'CA', 'Canada', 'AMRO', '322', '125969', '7', '9090');
INSERT INTO public.who_global_data_import VALUES (15039, '2020-08-28', 'CA', 'Canada', 'AMRO', '448', '126417', '4', '9094');
INSERT INTO public.who_global_data_import VALUES (15040, '2020-08-29', 'CA', 'Canada', 'AMRO', '431', '126848', '8', '9102');
INSERT INTO public.who_global_data_import VALUES (15041, '2020-08-30', 'CA', 'Canada', 'AMRO', '510', '127358', '6', '9108');
INSERT INTO public.who_global_data_import VALUES (15042, '2020-08-31', 'CA', 'Canada', 'AMRO', '315', '127673', '5', '9113');
INSERT INTO public.who_global_data_import VALUES (15043, '2020-09-01', 'CA', 'Canada', 'AMRO', '267', '127940', '4', '9117');
INSERT INTO public.who_global_data_import VALUES (15044, '2020-09-02', 'CA', 'Canada', 'AMRO', '1008', '128948', '9', '9126');
INSERT INTO public.who_global_data_import VALUES (15045, '2020-09-03', 'CA', 'Canada', 'AMRO', '477', '129425', '6', '9132');
INSERT INTO public.who_global_data_import VALUES (15046, '2020-09-04', 'CA', 'Canada', 'AMRO', '498', '129923', '3', '9135');
INSERT INTO public.who_global_data_import VALUES (15047, '2020-09-05', 'CA', 'Canada', 'AMRO', '570', '130493', '6', '9141');
INSERT INTO public.who_global_data_import VALUES (15048, '2020-09-06', 'CA', 'Canada', 'AMRO', '631', '131124', '0', '9141');
INSERT INTO public.who_global_data_import VALUES (15049, '2020-09-07', 'CA', 'Canada', 'AMRO', '371', '131495', '2', '9143');
INSERT INTO public.who_global_data_import VALUES (15050, '2020-09-08', 'CA', 'Canada', 'AMRO', '400', '131895', '2', '9145');
INSERT INTO public.who_global_data_import VALUES (15051, '2020-09-09', 'CA', 'Canada', 'AMRO', '247', '132142', '1', '9146');
INSERT INTO public.who_global_data_import VALUES (15052, '2020-09-10', 'CA', 'Canada', 'AMRO', '1606', '133748', '7', '9153');
INSERT INTO public.who_global_data_import VALUES (15053, '2020-09-11', 'CA', 'Canada', 'AMRO', '546', '134294', '2', '9155');
INSERT INTO public.who_global_data_import VALUES (15054, '2020-09-12', 'CA', 'Canada', 'AMRO', '630', '134924', '8', '9163');
INSERT INTO public.who_global_data_import VALUES (15055, '2020-09-13', 'CA', 'Canada', 'AMRO', '702', '135626', '0', '9163');
INSERT INTO public.who_global_data_import VALUES (15056, '2020-09-14', 'CA', 'Canada', 'AMRO', '515', '136141', '7', '9170');
INSERT INTO public.who_global_data_import VALUES (15057, '2020-09-15', 'CA', 'Canada', 'AMRO', '518', '136659', '1', '9171');
INSERT INTO public.who_global_data_import VALUES (15058, '2020-09-16', 'CA', 'Canada', 'AMRO', '1351', '138010', '8', '9179');
INSERT INTO public.who_global_data_import VALUES (15059, '2020-09-17', 'CA', 'Canada', 'AMRO', '793', '138803', '9', '9188');
INSERT INTO public.who_global_data_import VALUES (15060, '2020-09-18', 'CA', 'Canada', 'AMRO', '944', '139747', '5', '9193');
INSERT INTO public.who_global_data_import VALUES (15061, '2020-09-19', 'CA', 'Canada', 'AMRO', '1120', '140867', '7', '9200');
INSERT INTO public.who_global_data_import VALUES (15062, '2020-09-20', 'CA', 'Canada', 'AMRO', '1044', '141911', '5', '9205');
INSERT INTO public.who_global_data_import VALUES (15063, '2020-09-21', 'CA', 'Canada', 'AMRO', '863', '142774', '6', '9211');
INSERT INTO public.who_global_data_import VALUES (15064, '2020-09-22', 'CA', 'Canada', 'AMRO', '875', '143649', '6', '9217');
INSERT INTO public.who_global_data_import VALUES (15065, '2020-09-23', 'CA', 'Canada', 'AMRO', '1766', '145415', '11', '9228');
INSERT INTO public.who_global_data_import VALUES (15066, '2020-09-24', 'CA', 'Canada', 'AMRO', '1248', '146663', '6', '9234');
INSERT INTO public.who_global_data_import VALUES (15067, '2020-09-25', 'CA', 'Canada', 'AMRO', '1090', '147753', '9', '9243');
INSERT INTO public.who_global_data_import VALUES (15068, '2020-09-26', 'CA', 'Canada', 'AMRO', '1341', '149094', '6', '9249');
INSERT INTO public.who_global_data_import VALUES (15069, '2020-09-27', 'CA', 'Canada', 'AMRO', '1362', '150456', '6', '9255');
INSERT INTO public.who_global_data_import VALUES (15070, '2020-09-28', 'CA', 'Canada', 'AMRO', '1215', '151671', '7', '9262');
INSERT INTO public.who_global_data_import VALUES (15071, '2020-09-29', 'CA', 'Canada', 'AMRO', '1454', '153125', '6', '9268');
INSERT INTO public.who_global_data_import VALUES (15072, '2020-09-30', 'CA', 'Canada', 'AMRO', '2176', '155301', '10', '9278');
INSERT INTO public.who_global_data_import VALUES (15073, '2020-10-01', 'CA', 'Canada', 'AMRO', '1660', '156961', '13', '9291');
INSERT INTO public.who_global_data_import VALUES (15074, '2020-10-02', 'CA', 'Canada', 'AMRO', '1797', '158758', '6', '9297');
INSERT INTO public.who_global_data_import VALUES (15075, '2020-10-03', 'CA', 'Canada', 'AMRO', '1777', '160535', '22', '9319');
INSERT INTO public.who_global_data_import VALUES (15076, '2020-10-04', 'CA', 'Canada', 'AMRO', '2124', '162659', '90', '9409');
INSERT INTO public.who_global_data_import VALUES (15077, '2020-10-05', 'CA', 'Canada', 'AMRO', '1812', '164471', '53', '9462');
INSERT INTO public.who_global_data_import VALUES (15078, '2020-10-06', 'CA', 'Canada', 'AMRO', '1685', '166156', '19', '9481');
INSERT INTO public.who_global_data_import VALUES (15079, '2020-10-07', 'CA', 'Canada', 'AMRO', '2804', '168960', '23', '9504');
INSERT INTO public.who_global_data_import VALUES (15080, '2020-10-08', 'CA', 'Canada', 'AMRO', '2363', '171323', '26', '9530');
INSERT INTO public.who_global_data_import VALUES (15081, '2020-10-09', 'CA', 'Canada', 'AMRO', '1800', '173123', '11', '9541');
INSERT INTO public.who_global_data_import VALUES (15082, '2020-10-10', 'CA', 'Canada', 'AMRO', '2436', '175559', '16', '9557');
INSERT INTO public.who_global_data_import VALUES (15083, '2020-10-11', 'CA', 'Canada', 'AMRO', '2558', '178117', '28', '9585');
INSERT INTO public.who_global_data_import VALUES (15084, '2020-10-12', 'CA', 'Canada', 'AMRO', '2062', '180179', '23', '9608');
INSERT INTO public.who_global_data_import VALUES (15085, '2020-10-13', 'CA', 'Canada', 'AMRO', '1685', '181864', '5', '9613');
INSERT INTO public.who_global_data_import VALUES (15086, '2020-10-14', 'CA', 'Canada', 'AMRO', '975', '182839', '14', '9627');
INSERT INTO public.who_global_data_import VALUES (15087, '2020-10-15', 'CA', 'Canada', 'AMRO', '4042', '186881', '27', '9654');
INSERT INTO public.who_global_data_import VALUES (15088, '2020-10-16', 'CA', 'Canada', 'AMRO', '2506', '189387', '10', '9664');
INSERT INTO public.who_global_data_import VALUES (15089, '2020-10-17', 'CA', 'Canada', 'AMRO', '2345', '191732', '35', '9699');
INSERT INTO public.who_global_data_import VALUES (15090, '2020-10-18', 'CA', 'Canada', 'AMRO', '2374', '194106', '23', '9722');
INSERT INTO public.who_global_data_import VALUES (15091, '2020-10-19', 'CA', 'Canada', 'AMRO', '2215', '196321', '24', '9746');
INSERT INTO public.who_global_data_import VALUES (15092, '2020-10-20', 'CA', 'Canada', 'AMRO', '1827', '198148', '14', '9760');
INSERT INTO public.who_global_data_import VALUES (15093, '2020-10-21', 'CA', 'Canada', 'AMRO', '3289', '201437', '18', '9778');
INSERT INTO public.who_global_data_import VALUES (15094, '2020-10-22', 'CA', 'Canada', 'AMRO', '2251', '203688', '16', '9794');
INSERT INTO public.who_global_data_import VALUES (15095, '2020-10-23', 'CA', 'Canada', 'AMRO', '2672', '206360', '35', '9829');
INSERT INTO public.who_global_data_import VALUES (15096, '2020-10-24', 'CA', 'Canada', 'AMRO', '2788', '209148', '33', '9862');
INSERT INTO public.who_global_data_import VALUES (15097, '2020-10-25', 'CA', 'Canada', 'AMRO', '2584', '211732', '26', '9888');
INSERT INTO public.who_global_data_import VALUES (15098, '2020-10-26', 'CA', 'Canada', 'AMRO', '2227', '213959', '34', '9922');
INSERT INTO public.who_global_data_import VALUES (15099, '2020-10-27', 'CA', 'Canada', 'AMRO', '2145', '216104', '24', '9946');
INSERT INTO public.who_global_data_import VALUES (15100, '2020-10-28', 'CA', 'Canada', 'AMRO', '4109', '220213', '27', '9973');
INSERT INTO public.who_global_data_import VALUES (15101, '2020-10-29', 'CA', 'Canada', 'AMRO', '2674', '222887', '28', '10001');
INSERT INTO public.who_global_data_import VALUES (15102, '2020-10-30', 'CA', 'Canada', 'AMRO', '2699', '225586', '31', '10032');
INSERT INTO public.who_global_data_import VALUES (15103, '2020-10-31', 'CA', 'Canada', 'AMRO', '2956', '228542', '42', '10074');
INSERT INTO public.who_global_data_import VALUES (15104, '2020-11-01', 'CA', 'Canada', 'AMRO', '3457', '231999', '36', '10110');
INSERT INTO public.who_global_data_import VALUES (15105, '2020-11-02', 'CA', 'Canada', 'AMRO', '2512', '234511', '26', '10136');
INSERT INTO public.who_global_data_import VALUES (15106, '2020-11-03', 'CA', 'Canada', 'AMRO', '2330', '236841', '43', '10179');
INSERT INTO public.who_global_data_import VALUES (15107, '2020-11-04', 'CA', 'Canada', 'AMRO', '3422', '240263', '29', '10208');
INSERT INTO public.who_global_data_import VALUES (15108, '2020-11-05', 'CA', 'Canada', 'AMRO', '4672', '244935', '71', '10279');
INSERT INTO public.who_global_data_import VALUES (15109, '2020-11-06', 'CA', 'Canada', 'AMRO', '2768', '247703', '52', '10331');
INSERT INTO public.who_global_data_import VALUES (15110, '2020-11-07', 'CA', 'Canada', 'AMRO', '3635', '251338', '50', '10381');
INSERT INTO public.who_global_data_import VALUES (15111, '2020-11-08', 'CA', 'Canada', 'AMRO', '4471', '255809', '55', '10436');
INSERT INTO public.who_global_data_import VALUES (15112, '2020-11-09', 'CA', 'Canada', 'AMRO', '4246', '260055', '54', '10490');
INSERT INTO public.who_global_data_import VALUES (15113, '2020-11-10', 'CA', 'Canada', 'AMRO', '4058', '264113', '32', '10522');
INSERT INTO public.who_global_data_import VALUES (15114, '2020-11-11', 'CA', 'Canada', 'AMRO', '4622', '268735', '42', '10564');
INSERT INTO public.who_global_data_import VALUES (15115, '2020-11-12', 'CA', 'Canada', 'AMRO', '4302', '273037', '68', '10632');
INSERT INTO public.who_global_data_import VALUES (15116, '2020-11-13', 'CA', 'Canada', 'AMRO', '4024', '277061', '53', '10685');
INSERT INTO public.who_global_data_import VALUES (15117, '2020-11-14', 'CA', 'Canada', 'AMRO', '5516', '282577', '83', '10768');
INSERT INTO public.who_global_data_import VALUES (15118, '2020-11-15', 'CA', 'Canada', 'AMRO', '4741', '287318', '60', '10828');
INSERT INTO public.who_global_data_import VALUES (15119, '2020-11-16', 'CA', 'Canada', 'AMRO', '4613', '291931', '63', '10891');
INSERT INTO public.who_global_data_import VALUES (15120, '2020-11-17', 'CA', 'Canada', 'AMRO', '4146', '296077', '62', '10953');
INSERT INTO public.who_global_data_import VALUES (15121, '2020-11-18', 'CA', 'Canada', 'AMRO', '6115', '302192', '74', '11027');
INSERT INTO public.who_global_data_import VALUES (15122, '2020-11-19', 'CA', 'Canada', 'AMRO', '4276', '306468', '59', '11086');
INSERT INTO public.who_global_data_import VALUES (15123, '2020-11-20', 'CA', 'Canada', 'AMRO', '4641', '311109', '100', '11186');
INSERT INTO public.who_global_data_import VALUES (15124, '2020-11-21', 'CA', 'Canada', 'AMRO', '4642', '315751', '79', '11265');
INSERT INTO public.who_global_data_import VALUES (15125, '2020-11-22', 'CA', 'Canada', 'AMRO', '4968', '320719', '69', '11334');
INSERT INTO public.who_global_data_import VALUES (15126, '2020-11-23', 'CA', 'Canada', 'AMRO', '4992', '325711', '72', '11406');
INSERT INTO public.who_global_data_import VALUES (15127, '2020-11-24', 'CA', 'Canada', 'AMRO', '4792', '330503', '49', '11455');
INSERT INTO public.who_global_data_import VALUES (15128, '2020-11-25', 'CA', 'Canada', 'AMRO', '7052', '337555', '66', '11521');
INSERT INTO public.who_global_data_import VALUES (15129, '2020-11-26', 'CA', 'Canada', 'AMRO', '4889', '342444', '97', '11618');
INSERT INTO public.who_global_data_import VALUES (15130, '2020-11-27', 'CA', 'Canada', 'AMRO', '5022', '347466', '92', '11710');
INSERT INTO public.who_global_data_import VALUES (15131, '2020-11-28', 'CA', 'Canada', 'AMRO', '5631', '353097', '89', '11799');
INSERT INTO public.who_global_data_import VALUES (15132, '2020-11-29', 'CA', 'Canada', 'AMRO', '5967', '359064', '95', '11894');
INSERT INTO public.who_global_data_import VALUES (15133, '2020-11-30', 'CA', 'Canada', 'AMRO', '5746', '364810', '82', '11976');
INSERT INTO public.who_global_data_import VALUES (15134, '2020-12-01', 'CA', 'Canada', 'AMRO', '5468', '370278', '56', '12032');
INSERT INTO public.who_global_data_import VALUES (15135, '2020-12-02', 'CA', 'Canada', 'AMRO', '7861', '378139', '98', '12130');
INSERT INTO public.who_global_data_import VALUES (15136, '2020-12-03', 'CA', 'Canada', 'AMRO', '5329', '383468', '81', '12211');
INSERT INTO public.who_global_data_import VALUES (15137, '2020-12-04', 'CA', 'Canada', 'AMRO', '6307', '389775', '114', '12325');
INSERT INTO public.who_global_data_import VALUES (15138, '2020-12-05', 'CA', 'Canada', 'AMRO', '6495', '396270', '82', '12407');
INSERT INTO public.who_global_data_import VALUES (15139, '2020-12-06', 'CA', 'Canada', 'AMRO', '6299', '402569', '89', '12496');
INSERT INTO public.who_global_data_import VALUES (15140, '2020-12-07', 'CA', 'Canada', 'AMRO', '6352', '408921', '93', '12589');
INSERT INTO public.who_global_data_import VALUES (15141, '2020-12-08', 'CA', 'Canada', 'AMRO', '6261', '415182', '76', '12665');
INSERT INTO public.who_global_data_import VALUES (15142, '2020-12-09', 'CA', 'Canada', 'AMRO', '7872', '423054', '112', '12777');
INSERT INTO public.who_global_data_import VALUES (15143, '2020-12-10', 'CA', 'Canada', 'AMRO', '5981', '429035', '90', '12867');
INSERT INTO public.who_global_data_import VALUES (15144, '2020-12-11', 'CA', 'Canada', 'AMRO', '6295', '435330', '116', '12983');
INSERT INTO public.who_global_data_import VALUES (15145, '2020-12-12', 'CA', 'Canada', 'AMRO', '6739', '442069', '126', '13109');
INSERT INTO public.who_global_data_import VALUES (15146, '2020-12-13', 'CA', 'Canada', 'AMRO', '6772', '448841', '142', '13251');
INSERT INTO public.who_global_data_import VALUES (15147, '2020-12-14', 'CA', 'Canada', 'AMRO', '6011', '454852', '99', '13350');
INSERT INTO public.who_global_data_import VALUES (15148, '2020-12-15', 'CA', 'Canada', 'AMRO', '5891', '460743', '81', '13431');
INSERT INTO public.who_global_data_import VALUES (15149, '2020-12-16', 'CA', 'Canada', 'AMRO', '8119', '468862', '122', '13553');
INSERT INTO public.who_global_data_import VALUES (15150, '2020-12-17', 'CA', 'Canada', 'AMRO', '6352', '475214', '106', '13659');
INSERT INTO public.who_global_data_import VALUES (15151, '2020-12-18', 'CA', 'Canada', 'AMRO', '6416', '481630', '140', '13799');
INSERT INTO public.who_global_data_import VALUES (15152, '2020-12-19', 'CA', 'Canada', 'AMRO', '7008', '488638', '117', '13916');
INSERT INTO public.who_global_data_import VALUES (15153, '2020-12-20', 'CA', 'Canada', 'AMRO', '6708', '495346', '124', '14040');
INSERT INTO public.who_global_data_import VALUES (15154, '2020-12-21', 'CA', 'Canada', 'AMRO', '6248', '501594', '114', '14154');
INSERT INTO public.who_global_data_import VALUES (15155, '2020-12-22', 'CA', 'Canada', 'AMRO', '6201', '507795', '74', '14228');
INSERT INTO public.who_global_data_import VALUES (15156, '2020-12-23', 'CA', 'Canada', 'AMRO', '7519', '515314', '104', '14332');
INSERT INTO public.who_global_data_import VALUES (15157, '2020-12-24', 'CA', 'Canada', 'AMRO', '6195', '521509', '93', '14425');
INSERT INTO public.who_global_data_import VALUES (15158, '2020-12-25', 'CA', 'Canada', 'AMRO', '6845', '528354', '172', '14597');
INSERT INTO public.who_global_data_import VALUES (15159, '2020-12-26', 'CA', 'Canada', 'AMRO', '6889', '535243', '123', '14720');
INSERT INTO public.who_global_data_import VALUES (15160, '2020-12-27', 'CA', 'Canada', 'AMRO', '1430', '536673', '0', '14720');
INSERT INTO public.who_global_data_import VALUES (15161, '2020-12-28', 'CA', 'Canada', 'AMRO', '9827', '546500', '179', '14899');
INSERT INTO public.who_global_data_import VALUES (15162, '2020-12-29', 'CA', 'Canada', 'AMRO', '6774', '553274', '209', '15108');
INSERT INTO public.who_global_data_import VALUES (15163, '2020-12-30', 'CA', 'Canada', 'AMRO', '5790', '559064', '114', '15222');
INSERT INTO public.who_global_data_import VALUES (15164, '2020-12-31', 'CA', 'Canada', 'AMRO', '6442', '565506', '156', '15378');
INSERT INTO public.who_global_data_import VALUES (15165, '2021-01-01', 'CA', 'Canada', 'AMRO', '7476', '572982', '94', '15472');
INSERT INTO public.who_global_data_import VALUES (15166, '2021-01-02', 'CA', 'Canada', 'AMRO', '8420', '581402', '133', '15605');
INSERT INTO public.who_global_data_import VALUES (15167, '2021-01-03', 'CA', 'Canada', 'AMRO', '6875', '588277', '136', '15741');
INSERT INTO public.who_global_data_import VALUES (15168, '2021-01-04', 'CA', 'Canada', 'AMRO', '6808', '595085', '83', '15824');
INSERT INTO public.who_global_data_import VALUES (15169, '2021-01-05', 'CA', 'Canada', 'AMRO', '6578', '601663', '41', '15865');
INSERT INTO public.who_global_data_import VALUES (15170, '2021-01-06', 'CA', 'Canada', 'AMRO', '9761', '611424', '209', '16074');
INSERT INTO public.who_global_data_import VALUES (15171, '2021-01-07', 'CA', 'Canada', 'AMRO', '7222', '618646', '159', '16233');
INSERT INTO public.who_global_data_import VALUES (15172, '2021-01-08', 'CA', 'Canada', 'AMRO', '8153', '626799', '136', '16369');
INSERT INTO public.who_global_data_import VALUES (15173, '2021-01-09', 'CA', 'Canada', 'AMRO', '8335', '635134', '210', '16579');
INSERT INTO public.who_global_data_import VALUES (15174, '2021-01-10', 'CA', 'Canada', 'AMRO', '9214', '644348', '128', '16707');
INSERT INTO public.who_global_data_import VALUES (15175, '2021-01-11', 'CA', 'Canada', 'AMRO', '8125', '652473', '126', '16833');
INSERT INTO public.who_global_data_import VALUES (15176, '2021-01-12', 'CA', 'Canada', 'AMRO', '7816', '660289', '117', '16950');
INSERT INTO public.who_global_data_import VALUES (15177, '2021-01-13', 'CA', 'Canada', 'AMRO', '7892', '668181', '136', '17086');
INSERT INTO public.who_global_data_import VALUES (15178, '2021-01-14', 'CA', 'Canada', 'AMRO', '6292', '674473', '147', '17233');
INSERT INTO public.who_global_data_import VALUES (15179, '2021-01-15', 'CA', 'Canada', 'AMRO', '6855', '681328', '150', '17383');
INSERT INTO public.who_global_data_import VALUES (15180, '2021-01-16', 'CA', 'Canada', 'AMRO', '7563', '688891', '155', '17538');
INSERT INTO public.who_global_data_import VALUES (15181, '2021-01-17', 'CA', 'Canada', 'AMRO', '6816', '695707', '191', '17729');
INSERT INTO public.who_global_data_import VALUES (15182, '2021-01-18', 'CA', 'Canada', 'AMRO', '6476', '702183', '136', '17865');
INSERT INTO public.who_global_data_import VALUES (15183, '2021-01-19', 'CA', 'Canada', 'AMRO', '6436', '708619', '149', '18014');
INSERT INTO public.who_global_data_import VALUES (15184, '2021-01-20', 'CA', 'Canada', 'AMRO', '6453', '715072', '106', '18120');
INSERT INTO public.who_global_data_import VALUES (15185, '2021-01-21', 'CA', 'Canada', 'AMRO', '4679', '719751', '146', '18266');
INSERT INTO public.who_global_data_import VALUES (15186, '2021-01-22', 'CA', 'Canada', 'AMRO', '5744', '725495', '196', '18462');
INSERT INTO public.who_global_data_import VALUES (15187, '2021-01-23', 'CA', 'Canada', 'AMRO', '5955', '731450', '160', '18622');
INSERT INTO public.who_global_data_import VALUES (15188, '2021-01-24', 'CA', 'Canada', 'AMRO', '5957', '737407', '206', '18828');
INSERT INTO public.who_global_data_import VALUES (15189, '2021-01-25', 'CA', 'Canada', 'AMRO', '5124', '742531', '146', '18974');
INSERT INTO public.who_global_data_import VALUES (15190, '2021-01-26', 'CA', 'Canada', 'AMRO', '4852', '747383', '120', '19094');
INSERT INTO public.who_global_data_import VALUES (15191, '2021-01-27', 'CA', 'Canada', 'AMRO', '5628', '753011', '144', '19238');
INSERT INTO public.who_global_data_import VALUES (15192, '2021-01-28', 'CA', 'Canada', 'AMRO', '4011', '757022', '165', '19403');
INSERT INTO public.who_global_data_import VALUES (15193, '2021-01-29', 'CA', 'Canada', 'AMRO', '4204', '761226', '130', '19533');
INSERT INTO public.who_global_data_import VALUES (15194, '2021-01-30', 'CA', 'Canada', 'AMRO', '4877', '766103', '131', '19664');
INSERT INTO public.who_global_data_import VALUES (15195, '2021-01-31', 'CA', 'Canada', 'AMRO', '4690', '770793', '137', '19801');
INSERT INTO public.who_global_data_import VALUES (15196, '2021-02-01', 'CA', 'Canada', 'AMRO', '4255', '775048', '141', '19942');
INSERT INTO public.who_global_data_import VALUES (15197, '2021-02-02', 'CA', 'Canada', 'AMRO', '3924', '778972', '90', '20032');
INSERT INTO public.who_global_data_import VALUES (15198, '2021-02-03', 'CA', 'Canada', 'AMRO', '4617', '783589', '104', '20136');
INSERT INTO public.who_global_data_import VALUES (15199, '2021-02-04', 'CA', 'Canada', 'AMRO', '2828', '786417', '77', '20213');
INSERT INTO public.who_global_data_import VALUES (15200, '2021-02-05', 'CA', 'Canada', 'AMRO', '3234', '789651', '142', '20355');
INSERT INTO public.who_global_data_import VALUES (15201, '2020-01-03', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15202, '2020-01-04', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15203, '2020-01-05', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15204, '2020-01-06', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15205, '2020-01-07', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15206, '2020-01-08', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15207, '2020-01-09', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15208, '2020-01-10', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15209, '2020-01-11', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15210, '2020-01-12', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15211, '2020-01-13', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15212, '2020-01-14', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15213, '2020-01-15', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15214, '2020-01-16', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15215, '2020-01-17', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15216, '2020-01-18', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15217, '2020-01-19', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15218, '2020-01-20', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15219, '2020-01-21', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15220, '2020-01-22', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15221, '2020-01-23', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15222, '2020-01-24', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15223, '2020-01-25', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15224, '2020-01-26', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15225, '2020-01-27', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15226, '2020-01-28', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15227, '2020-01-29', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15228, '2020-01-30', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15229, '2020-01-31', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15230, '2020-02-01', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15231, '2020-02-02', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15232, '2020-02-03', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15233, '2020-02-04', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15234, '2020-02-05', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15235, '2020-02-06', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15236, '2020-02-07', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15237, '2020-02-08', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15238, '2020-02-09', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15239, '2020-02-10', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15240, '2020-02-11', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15241, '2020-02-12', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15242, '2020-02-13', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15243, '2020-02-14', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15244, '2020-02-15', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15245, '2020-02-16', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15246, '2020-02-17', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15247, '2020-02-18', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15248, '2020-02-19', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15249, '2020-02-20', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15250, '2020-02-21', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15251, '2020-02-22', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15252, '2020-02-23', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15253, '2020-02-24', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15254, '2020-02-25', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15255, '2020-02-26', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15256, '2020-02-27', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15257, '2020-02-28', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15258, '2020-02-29', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15259, '2020-03-01', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15260, '2020-03-02', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15261, '2020-03-03', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15262, '2020-03-04', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15263, '2020-03-05', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15264, '2020-03-06', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15265, '2020-03-07', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15266, '2020-03-08', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15267, '2020-03-09', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15268, '2020-03-10', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15269, '2020-03-11', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15270, '2020-03-12', 'KY', 'Cayman Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15271, '2020-03-13', 'KY', 'Cayman Islands', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15272, '2020-03-14', 'KY', 'Cayman Islands', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15273, '2020-03-15', 'KY', 'Cayman Islands', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15274, '2020-03-16', 'KY', 'Cayman Islands', 'AMRO', '0', '5', '1', '1');
INSERT INTO public.who_global_data_import VALUES (15275, '2020-03-17', 'KY', 'Cayman Islands', 'AMRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15276, '2020-03-18', 'KY', 'Cayman Islands', 'AMRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15277, '2020-03-19', 'KY', 'Cayman Islands', 'AMRO', '-2', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15278, '2020-03-20', 'KY', 'Cayman Islands', 'AMRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15279, '2020-03-21', 'KY', 'Cayman Islands', 'AMRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15280, '2020-03-22', 'KY', 'Cayman Islands', 'AMRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15281, '2020-03-23', 'KY', 'Cayman Islands', 'AMRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15282, '2020-03-24', 'KY', 'Cayman Islands', 'AMRO', '2', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15283, '2020-03-25', 'KY', 'Cayman Islands', 'AMRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15284, '2020-03-26', 'KY', 'Cayman Islands', 'AMRO', '3', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15285, '2020-03-27', 'KY', 'Cayman Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15286, '2020-03-28', 'KY', 'Cayman Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15287, '2020-03-29', 'KY', 'Cayman Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15288, '2020-03-30', 'KY', 'Cayman Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15289, '2020-03-31', 'KY', 'Cayman Islands', 'AMRO', '4', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15290, '2020-04-01', 'KY', 'Cayman Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15291, '2020-04-02', 'KY', 'Cayman Islands', 'AMRO', '2', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15292, '2020-04-03', 'KY', 'Cayman Islands', 'AMRO', '8', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15293, '2020-04-04', 'KY', 'Cayman Islands', 'AMRO', '6', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15294, '2020-04-05', 'KY', 'Cayman Islands', 'AMRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15295, '2020-04-06', 'KY', 'Cayman Islands', 'AMRO', '7', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15296, '2020-04-07', 'KY', 'Cayman Islands', 'AMRO', '4', '39', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15297, '2020-04-08', 'KY', 'Cayman Islands', 'AMRO', '0', '39', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15298, '2020-04-09', 'KY', 'Cayman Islands', 'AMRO', '6', '45', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15299, '2020-04-10', 'KY', 'Cayman Islands', 'AMRO', '0', '45', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15300, '2020-04-11', 'KY', 'Cayman Islands', 'AMRO', '0', '45', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15301, '2020-04-12', 'KY', 'Cayman Islands', 'AMRO', '0', '45', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15302, '2020-04-13', 'KY', 'Cayman Islands', 'AMRO', '8', '53', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15303, '2020-04-14', 'KY', 'Cayman Islands', 'AMRO', '0', '53', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15304, '2020-04-15', 'KY', 'Cayman Islands', 'AMRO', '1', '54', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15305, '2020-04-16', 'KY', 'Cayman Islands', 'AMRO', '0', '54', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15306, '2020-04-17', 'KY', 'Cayman Islands', 'AMRO', '6', '60', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15307, '2020-04-18', 'KY', 'Cayman Islands', 'AMRO', '1', '61', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15308, '2020-04-19', 'KY', 'Cayman Islands', 'AMRO', '0', '61', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15309, '2020-04-20', 'KY', 'Cayman Islands', 'AMRO', '0', '61', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15310, '2020-04-21', 'KY', 'Cayman Islands', 'AMRO', '0', '61', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15311, '2020-04-22', 'KY', 'Cayman Islands', 'AMRO', '5', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15312, '2020-04-23', 'KY', 'Cayman Islands', 'AMRO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15313, '2020-04-24', 'KY', 'Cayman Islands', 'AMRO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15314, '2020-04-25', 'KY', 'Cayman Islands', 'AMRO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15315, '2020-04-26', 'KY', 'Cayman Islands', 'AMRO', '4', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15316, '2020-04-27', 'KY', 'Cayman Islands', 'AMRO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15317, '2020-04-28', 'KY', 'Cayman Islands', 'AMRO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15318, '2020-04-29', 'KY', 'Cayman Islands', 'AMRO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15319, '2020-04-30', 'KY', 'Cayman Islands', 'AMRO', '3', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15320, '2020-05-01', 'KY', 'Cayman Islands', 'AMRO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15321, '2020-05-02', 'KY', 'Cayman Islands', 'AMRO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15322, '2020-05-03', 'KY', 'Cayman Islands', 'AMRO', '1', '74', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15323, '2020-05-04', 'KY', 'Cayman Islands', 'AMRO', '0', '74', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15324, '2020-05-05', 'KY', 'Cayman Islands', 'AMRO', '0', '74', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15325, '2020-05-06', 'KY', 'Cayman Islands', 'AMRO', '1', '75', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15326, '2020-05-07', 'KY', 'Cayman Islands', 'AMRO', '3', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15327, '2020-05-08', 'KY', 'Cayman Islands', 'AMRO', '0', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15328, '2020-05-09', 'KY', 'Cayman Islands', 'AMRO', '2', '80', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15329, '2020-05-10', 'KY', 'Cayman Islands', 'AMRO', '1', '81', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15330, '2020-05-11', 'KY', 'Cayman Islands', 'AMRO', '0', '81', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15331, '2020-05-12', 'KY', 'Cayman Islands', 'AMRO', '0', '81', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15332, '2020-05-13', 'KY', 'Cayman Islands', 'AMRO', '3', '84', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15333, '2020-05-14', 'KY', 'Cayman Islands', 'AMRO', '1', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15334, '2020-05-15', 'KY', 'Cayman Islands', 'AMRO', '1', '86', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15335, '2020-05-16', 'KY', 'Cayman Islands', 'AMRO', '7', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15336, '2020-05-17', 'KY', 'Cayman Islands', 'AMRO', '1', '94', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15337, '2020-05-18', 'KY', 'Cayman Islands', 'AMRO', '0', '94', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15338, '2020-05-19', 'KY', 'Cayman Islands', 'AMRO', '0', '94', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15339, '2020-05-20', 'KY', 'Cayman Islands', 'AMRO', '0', '94', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15340, '2020-05-21', 'KY', 'Cayman Islands', 'AMRO', '17', '111', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15341, '2020-05-22', 'KY', 'Cayman Islands', 'AMRO', '0', '111', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15342, '2020-05-23', 'KY', 'Cayman Islands', 'AMRO', '10', '121', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15343, '2020-05-24', 'KY', 'Cayman Islands', 'AMRO', '8', '129', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15344, '2020-05-25', 'KY', 'Cayman Islands', 'AMRO', '0', '129', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15345, '2020-05-26', 'KY', 'Cayman Islands', 'AMRO', '0', '129', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15346, '2020-05-27', 'KY', 'Cayman Islands', 'AMRO', '5', '134', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15347, '2020-05-28', 'KY', 'Cayman Islands', 'AMRO', '3', '137', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15348, '2020-05-29', 'KY', 'Cayman Islands', 'AMRO', '3', '140', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15349, '2020-05-30', 'KY', 'Cayman Islands', 'AMRO', '0', '140', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15350, '2020-05-31', 'KY', 'Cayman Islands', 'AMRO', '1', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15351, '2020-06-01', 'KY', 'Cayman Islands', 'AMRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15352, '2020-06-02', 'KY', 'Cayman Islands', 'AMRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15353, '2020-06-03', 'KY', 'Cayman Islands', 'AMRO', '9', '150', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15354, '2020-06-04', 'KY', 'Cayman Islands', 'AMRO', '1', '151', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15355, '2020-06-05', 'KY', 'Cayman Islands', 'AMRO', '5', '156', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15356, '2020-06-06', 'KY', 'Cayman Islands', 'AMRO', '4', '160', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15357, '2020-06-07', 'KY', 'Cayman Islands', 'AMRO', '4', '164', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15358, '2020-06-08', 'KY', 'Cayman Islands', 'AMRO', '0', '164', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15359, '2020-06-09', 'KY', 'Cayman Islands', 'AMRO', '0', '164', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15360, '2020-06-10', 'KY', 'Cayman Islands', 'AMRO', '7', '171', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15361, '2020-06-11', 'KY', 'Cayman Islands', 'AMRO', '5', '176', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15362, '2020-06-12', 'KY', 'Cayman Islands', 'AMRO', '4', '180', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15363, '2020-06-13', 'KY', 'Cayman Islands', 'AMRO', '6', '186', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15364, '2020-06-14', 'KY', 'Cayman Islands', 'AMRO', '1', '187', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15365, '2020-06-15', 'KY', 'Cayman Islands', 'AMRO', '0', '187', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15366, '2020-06-16', 'KY', 'Cayman Islands', 'AMRO', '0', '187', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15367, '2020-06-17', 'KY', 'Cayman Islands', 'AMRO', '0', '187', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15368, '2020-06-18', 'KY', 'Cayman Islands', 'AMRO', '6', '193', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15369, '2020-06-19', 'KY', 'Cayman Islands', 'AMRO', '0', '193', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15370, '2020-06-20', 'KY', 'Cayman Islands', 'AMRO', '0', '193', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15371, '2020-06-21', 'KY', 'Cayman Islands', 'AMRO', '2', '195', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15372, '2020-06-22', 'KY', 'Cayman Islands', 'AMRO', '0', '195', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15373, '2020-06-23', 'KY', 'Cayman Islands', 'AMRO', '0', '195', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15374, '2020-06-24', 'KY', 'Cayman Islands', 'AMRO', '0', '195', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15375, '2020-06-25', 'KY', 'Cayman Islands', 'AMRO', '0', '195', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15376, '2020-06-26', 'KY', 'Cayman Islands', 'AMRO', '1', '196', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15377, '2020-06-27', 'KY', 'Cayman Islands', 'AMRO', '0', '196', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15378, '2020-06-28', 'KY', 'Cayman Islands', 'AMRO', '0', '196', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15379, '2020-06-29', 'KY', 'Cayman Islands', 'AMRO', '0', '196', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15380, '2020-06-30', 'KY', 'Cayman Islands', 'AMRO', '0', '196', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15381, '2020-07-01', 'KY', 'Cayman Islands', 'AMRO', '3', '199', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15382, '2020-07-02', 'KY', 'Cayman Islands', 'AMRO', '1', '200', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15383, '2020-07-03', 'KY', 'Cayman Islands', 'AMRO', '1', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15384, '2020-07-04', 'KY', 'Cayman Islands', 'AMRO', '0', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15385, '2020-07-05', 'KY', 'Cayman Islands', 'AMRO', '0', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15386, '2020-07-06', 'KY', 'Cayman Islands', 'AMRO', '0', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15387, '2020-07-07', 'KY', 'Cayman Islands', 'AMRO', '0', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15388, '2020-07-08', 'KY', 'Cayman Islands', 'AMRO', '0', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15389, '2020-07-09', 'KY', 'Cayman Islands', 'AMRO', '0', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15390, '2020-07-10', 'KY', 'Cayman Islands', 'AMRO', '0', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15391, '2020-07-11', 'KY', 'Cayman Islands', 'AMRO', '0', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15392, '2020-07-12', 'KY', 'Cayman Islands', 'AMRO', '0', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15393, '2020-07-13', 'KY', 'Cayman Islands', 'AMRO', '0', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15394, '2020-07-14', 'KY', 'Cayman Islands', 'AMRO', '0', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15395, '2020-07-15', 'KY', 'Cayman Islands', 'AMRO', '2', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15396, '2020-07-16', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15397, '2020-07-17', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15398, '2020-07-18', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15399, '2020-07-19', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15400, '2020-07-20', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15401, '2020-07-21', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15402, '2020-07-22', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15403, '2020-07-23', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15404, '2020-07-24', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15405, '2020-07-25', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15406, '2020-07-26', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15407, '2020-07-27', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15408, '2020-07-28', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15409, '2020-07-29', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15410, '2020-07-30', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15411, '2020-07-31', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15412, '2020-08-01', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15413, '2020-08-02', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15414, '2020-08-03', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15415, '2020-08-04', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15416, '2020-08-05', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15417, '2020-08-06', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15418, '2020-08-07', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15419, '2020-08-08', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15420, '2020-08-09', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15421, '2020-08-10', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15422, '2020-08-11', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15423, '2020-08-12', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15424, '2020-08-13', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15425, '2020-08-14', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15426, '2020-08-15', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15427, '2020-08-16', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15428, '2020-08-17', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15429, '2020-08-18', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15430, '2020-08-19', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15431, '2020-08-20', 'KY', 'Cayman Islands', 'AMRO', '0', '203', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15432, '2020-08-21', 'KY', 'Cayman Islands', 'AMRO', '2', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15433, '2020-08-22', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15434, '2020-08-23', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15435, '2020-08-24', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15436, '2020-08-25', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15437, '2020-08-26', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15438, '2020-08-27', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15439, '2020-08-28', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15440, '2020-08-29', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15441, '2020-08-30', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15442, '2020-08-31', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15443, '2020-09-01', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15444, '2020-09-02', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15445, '2020-09-03', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15446, '2020-09-04', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15447, '2020-09-05', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15448, '2020-09-06', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15449, '2020-09-07', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15450, '2020-09-08', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15451, '2020-09-09', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15452, '2020-09-10', 'KY', 'Cayman Islands', 'AMRO', '0', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15453, '2020-09-11', 'KY', 'Cayman Islands', 'AMRO', '2', '207', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15454, '2020-09-12', 'KY', 'Cayman Islands', 'AMRO', '1', '208', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15455, '2020-09-13', 'KY', 'Cayman Islands', 'AMRO', '0', '208', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15456, '2020-09-14', 'KY', 'Cayman Islands', 'AMRO', '0', '208', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15457, '2020-09-15', 'KY', 'Cayman Islands', 'AMRO', '0', '208', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15458, '2020-09-16', 'KY', 'Cayman Islands', 'AMRO', '0', '208', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15459, '2020-09-17', 'KY', 'Cayman Islands', 'AMRO', '0', '208', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15460, '2020-09-18', 'KY', 'Cayman Islands', 'AMRO', '0', '208', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15461, '2020-09-19', 'KY', 'Cayman Islands', 'AMRO', '0', '208', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15462, '2020-09-20', 'KY', 'Cayman Islands', 'AMRO', '0', '208', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15463, '2020-09-21', 'KY', 'Cayman Islands', 'AMRO', '0', '208', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15464, '2020-09-22', 'KY', 'Cayman Islands', 'AMRO', '1', '209', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15465, '2020-09-23', 'KY', 'Cayman Islands', 'AMRO', '1', '210', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15466, '2020-09-24', 'KY', 'Cayman Islands', 'AMRO', '0', '210', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15467, '2020-09-25', 'KY', 'Cayman Islands', 'AMRO', '0', '210', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15468, '2020-09-26', 'KY', 'Cayman Islands', 'AMRO', '0', '210', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15469, '2020-09-27', 'KY', 'Cayman Islands', 'AMRO', '0', '210', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15470, '2020-09-28', 'KY', 'Cayman Islands', 'AMRO', '0', '210', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15471, '2020-09-29', 'KY', 'Cayman Islands', 'AMRO', '0', '210', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15472, '2020-09-30', 'KY', 'Cayman Islands', 'AMRO', '1', '211', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15473, '2020-10-01', 'KY', 'Cayman Islands', 'AMRO', '0', '211', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15474, '2020-10-02', 'KY', 'Cayman Islands', 'AMRO', '0', '211', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15475, '2020-10-03', 'KY', 'Cayman Islands', 'AMRO', '0', '211', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15476, '2020-10-04', 'KY', 'Cayman Islands', 'AMRO', '2', '213', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15477, '2020-10-05', 'KY', 'Cayman Islands', 'AMRO', '0', '213', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15478, '2020-10-06', 'KY', 'Cayman Islands', 'AMRO', '0', '213', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15479, '2020-10-07', 'KY', 'Cayman Islands', 'AMRO', '0', '213', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15480, '2020-10-08', 'KY', 'Cayman Islands', 'AMRO', '0', '213', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15481, '2020-10-09', 'KY', 'Cayman Islands', 'AMRO', '0', '213', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15482, '2020-10-10', 'KY', 'Cayman Islands', 'AMRO', '1', '214', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15483, '2020-10-11', 'KY', 'Cayman Islands', 'AMRO', '6', '220', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15484, '2020-10-12', 'KY', 'Cayman Islands', 'AMRO', '1', '221', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15485, '2020-10-13', 'KY', 'Cayman Islands', 'AMRO', '0', '221', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15486, '2020-10-14', 'KY', 'Cayman Islands', 'AMRO', '0', '221', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15487, '2020-10-15', 'KY', 'Cayman Islands', 'AMRO', '0', '221', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15488, '2020-10-16', 'KY', 'Cayman Islands', 'AMRO', '4', '225', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15489, '2020-10-17', 'KY', 'Cayman Islands', 'AMRO', '0', '225', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15490, '2020-10-18', 'KY', 'Cayman Islands', 'AMRO', '8', '233', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15491, '2020-10-19', 'KY', 'Cayman Islands', 'AMRO', '0', '233', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15492, '2020-10-20', 'KY', 'Cayman Islands', 'AMRO', '0', '233', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15493, '2020-10-21', 'KY', 'Cayman Islands', 'AMRO', '2', '235', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15494, '2020-10-22', 'KY', 'Cayman Islands', 'AMRO', '0', '235', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15495, '2020-10-23', 'KY', 'Cayman Islands', 'AMRO', '1', '236', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15496, '2020-10-24', 'KY', 'Cayman Islands', 'AMRO', '0', '236', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15497, '2020-10-25', 'KY', 'Cayman Islands', 'AMRO', '3', '239', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15498, '2020-10-26', 'KY', 'Cayman Islands', 'AMRO', '0', '239', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15499, '2020-10-27', 'KY', 'Cayman Islands', 'AMRO', '0', '239', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15500, '2020-10-28', 'KY', 'Cayman Islands', 'AMRO', '0', '239', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15501, '2020-10-29', 'KY', 'Cayman Islands', 'AMRO', '0', '239', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15502, '2020-10-30', 'KY', 'Cayman Islands', 'AMRO', '0', '239', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15503, '2020-10-31', 'KY', 'Cayman Islands', 'AMRO', '1', '240', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15504, '2020-11-01', 'KY', 'Cayman Islands', 'AMRO', '0', '240', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15505, '2020-11-02', 'KY', 'Cayman Islands', 'AMRO', '0', '240', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15506, '2020-11-03', 'KY', 'Cayman Islands', 'AMRO', '0', '240', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15507, '2020-11-04', 'KY', 'Cayman Islands', 'AMRO', '2', '242', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15508, '2020-11-05', 'KY', 'Cayman Islands', 'AMRO', '0', '242', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15509, '2020-11-06', 'KY', 'Cayman Islands', 'AMRO', '2', '244', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15510, '2020-11-07', 'KY', 'Cayman Islands', 'AMRO', '1', '245', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15511, '2020-11-08', 'KY', 'Cayman Islands', 'AMRO', '5', '250', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15512, '2020-11-09', 'KY', 'Cayman Islands', 'AMRO', '0', '250', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15513, '2020-11-10', 'KY', 'Cayman Islands', 'AMRO', '0', '250', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15514, '2020-11-11', 'KY', 'Cayman Islands', 'AMRO', '3', '253', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15515, '2020-11-12', 'KY', 'Cayman Islands', 'AMRO', '0', '253', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15516, '2020-11-13', 'KY', 'Cayman Islands', 'AMRO', '0', '253', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15517, '2020-11-14', 'KY', 'Cayman Islands', 'AMRO', '1', '254', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15518, '2020-11-15', 'KY', 'Cayman Islands', 'AMRO', '0', '254', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15519, '2020-11-16', 'KY', 'Cayman Islands', 'AMRO', '0', '254', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15520, '2020-11-17', 'KY', 'Cayman Islands', 'AMRO', '0', '254', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15521, '2020-11-18', 'KY', 'Cayman Islands', 'AMRO', '3', '257', '1', '2');
INSERT INTO public.who_global_data_import VALUES (15522, '2020-11-19', 'KY', 'Cayman Islands', 'AMRO', '0', '257', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15523, '2020-11-20', 'KY', 'Cayman Islands', 'AMRO', '1', '258', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15524, '2020-11-21', 'KY', 'Cayman Islands', 'AMRO', '1', '259', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15525, '2020-11-22', 'KY', 'Cayman Islands', 'AMRO', '2', '261', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15526, '2020-11-23', 'KY', 'Cayman Islands', 'AMRO', '0', '261', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15527, '2020-11-24', 'KY', 'Cayman Islands', 'AMRO', '0', '261', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15528, '2020-11-25', 'KY', 'Cayman Islands', 'AMRO', '4', '265', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15529, '2020-11-26', 'KY', 'Cayman Islands', 'AMRO', '1', '266', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15530, '2020-11-27', 'KY', 'Cayman Islands', 'AMRO', '3', '269', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15531, '2020-11-28', 'KY', 'Cayman Islands', 'AMRO', '0', '269', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15532, '2020-11-29', 'KY', 'Cayman Islands', 'AMRO', '5', '274', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15533, '2020-11-30', 'KY', 'Cayman Islands', 'AMRO', '0', '274', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15534, '2020-12-01', 'KY', 'Cayman Islands', 'AMRO', '0', '274', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15535, '2020-12-02', 'KY', 'Cayman Islands', 'AMRO', '8', '282', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15536, '2020-12-03', 'KY', 'Cayman Islands', 'AMRO', '3', '285', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15537, '2020-12-04', 'KY', 'Cayman Islands', 'AMRO', '0', '285', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15538, '2020-12-05', 'KY', 'Cayman Islands', 'AMRO', '3', '288', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15539, '2020-12-06', 'KY', 'Cayman Islands', 'AMRO', '0', '288', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15540, '2020-12-07', 'KY', 'Cayman Islands', 'AMRO', '0', '288', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15541, '2020-12-08', 'KY', 'Cayman Islands', 'AMRO', '2', '290', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15542, '2020-12-09', 'KY', 'Cayman Islands', 'AMRO', '0', '290', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15543, '2020-12-10', 'KY', 'Cayman Islands', 'AMRO', '1', '291', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15544, '2020-12-11', 'KY', 'Cayman Islands', 'AMRO', '1', '292', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15545, '2020-12-12', 'KY', 'Cayman Islands', 'AMRO', '6', '298', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15546, '2020-12-13', 'KY', 'Cayman Islands', 'AMRO', '0', '298', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15547, '2020-12-14', 'KY', 'Cayman Islands', 'AMRO', '0', '298', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15548, '2020-12-15', 'KY', 'Cayman Islands', 'AMRO', '0', '298', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15549, '2020-12-16', 'KY', 'Cayman Islands', 'AMRO', '4', '302', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15550, '2020-12-17', 'KY', 'Cayman Islands', 'AMRO', '0', '302', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15551, '2020-12-18', 'KY', 'Cayman Islands', 'AMRO', '6', '308', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15552, '2020-12-19', 'KY', 'Cayman Islands', 'AMRO', '3', '311', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15553, '2020-12-20', 'KY', 'Cayman Islands', 'AMRO', '0', '311', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15554, '2020-12-21', 'KY', 'Cayman Islands', 'AMRO', '0', '311', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15555, '2020-12-22', 'KY', 'Cayman Islands', 'AMRO', '5', '316', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15556, '2020-12-23', 'KY', 'Cayman Islands', 'AMRO', '0', '316', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15557, '2020-12-24', 'KY', 'Cayman Islands', 'AMRO', '0', '316', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15558, '2020-12-25', 'KY', 'Cayman Islands', 'AMRO', '1', '317', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15559, '2020-12-26', 'KY', 'Cayman Islands', 'AMRO', '1', '318', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15560, '2020-12-27', 'KY', 'Cayman Islands', 'AMRO', '0', '318', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15561, '2020-12-28', 'KY', 'Cayman Islands', 'AMRO', '0', '318', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15562, '2020-12-29', 'KY', 'Cayman Islands', 'AMRO', '0', '318', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15563, '2020-12-30', 'KY', 'Cayman Islands', 'AMRO', '0', '318', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15564, '2020-12-31', 'KY', 'Cayman Islands', 'AMRO', '8', '326', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15565, '2021-01-01', 'KY', 'Cayman Islands', 'AMRO', '4', '330', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15566, '2021-01-02', 'KY', 'Cayman Islands', 'AMRO', '8', '338', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15567, '2021-01-03', 'KY', 'Cayman Islands', 'AMRO', '0', '338', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15568, '2021-01-04', 'KY', 'Cayman Islands', 'AMRO', '0', '338', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15569, '2021-01-05', 'KY', 'Cayman Islands', 'AMRO', '0', '338', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15570, '2021-01-06', 'KY', 'Cayman Islands', 'AMRO', '9', '347', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15571, '2021-01-07', 'KY', 'Cayman Islands', 'AMRO', '3', '350', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15572, '2021-01-08', 'KY', 'Cayman Islands', 'AMRO', '6', '356', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15573, '2021-01-09', 'KY', 'Cayman Islands', 'AMRO', '3', '359', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15574, '2021-01-10', 'KY', 'Cayman Islands', 'AMRO', '0', '359', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15575, '2021-01-11', 'KY', 'Cayman Islands', 'AMRO', '0', '359', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15576, '2021-01-12', 'KY', 'Cayman Islands', 'AMRO', '0', '359', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15577, '2021-01-13', 'KY', 'Cayman Islands', 'AMRO', '3', '362', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15578, '2021-01-14', 'KY', 'Cayman Islands', 'AMRO', '0', '362', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15579, '2021-01-15', 'KY', 'Cayman Islands', 'AMRO', '5', '367', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15580, '2021-01-16', 'KY', 'Cayman Islands', 'AMRO', '1', '368', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15581, '2021-01-17', 'KY', 'Cayman Islands', 'AMRO', '6', '374', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15582, '2021-01-18', 'KY', 'Cayman Islands', 'AMRO', '0', '374', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15583, '2021-01-19', 'KY', 'Cayman Islands', 'AMRO', '0', '374', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15584, '2021-01-20', 'KY', 'Cayman Islands', 'AMRO', '6', '380', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15585, '2021-01-21', 'KY', 'Cayman Islands', 'AMRO', '1', '381', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15586, '2021-01-22', 'KY', 'Cayman Islands', 'AMRO', '0', '381', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15587, '2021-01-23', 'KY', 'Cayman Islands', 'AMRO', '1', '382', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15588, '2021-01-24', 'KY', 'Cayman Islands', 'AMRO', '1', '383', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15589, '2021-01-25', 'KY', 'Cayman Islands', 'AMRO', '0', '383', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15590, '2021-01-26', 'KY', 'Cayman Islands', 'AMRO', '0', '383', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15591, '2021-01-27', 'KY', 'Cayman Islands', 'AMRO', '0', '383', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15592, '2021-01-28', 'KY', 'Cayman Islands', 'AMRO', '1', '384', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15593, '2021-01-29', 'KY', 'Cayman Islands', 'AMRO', '1', '385', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15594, '2021-01-30', 'KY', 'Cayman Islands', 'AMRO', '2', '387', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15595, '2021-01-31', 'KY', 'Cayman Islands', 'AMRO', '3', '390', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15596, '2021-02-01', 'KY', 'Cayman Islands', 'AMRO', '0', '390', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15597, '2021-02-02', 'KY', 'Cayman Islands', 'AMRO', '0', '390', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15598, '2021-02-03', 'KY', 'Cayman Islands', 'AMRO', '8', '398', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15599, '2021-02-04', 'KY', 'Cayman Islands', 'AMRO', '2', '400', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15600, '2021-02-05', 'KY', 'Cayman Islands', 'AMRO', '0', '400', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15601, '2020-01-03', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15602, '2020-01-04', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15603, '2020-01-05', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15604, '2020-01-06', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15605, '2020-01-07', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15606, '2020-01-08', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15607, '2020-01-09', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15608, '2020-01-10', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15609, '2020-01-11', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15610, '2020-01-12', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15611, '2020-01-13', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15612, '2020-01-14', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15613, '2020-01-15', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15614, '2020-01-16', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15615, '2020-01-17', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15616, '2020-01-18', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15617, '2020-01-19', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15618, '2020-01-20', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15619, '2020-01-21', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15620, '2020-01-22', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15621, '2020-01-23', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15622, '2020-01-24', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15623, '2020-01-25', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15624, '2020-01-26', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15625, '2020-01-27', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15626, '2020-01-28', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15627, '2020-01-29', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15628, '2020-01-30', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15629, '2020-01-31', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15630, '2020-02-01', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15631, '2020-02-02', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15632, '2020-02-03', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15633, '2020-02-04', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15634, '2020-02-05', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15635, '2020-02-06', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15636, '2020-02-07', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15637, '2020-02-08', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15638, '2020-02-09', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15639, '2020-02-10', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15640, '2020-02-11', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15641, '2020-02-12', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15642, '2020-02-13', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15643, '2020-02-14', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15644, '2020-02-15', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15645, '2020-02-16', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15646, '2020-02-17', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15647, '2020-02-18', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15648, '2020-02-19', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15649, '2020-02-20', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15650, '2020-02-21', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15651, '2020-02-22', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15652, '2020-02-23', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15653, '2020-02-24', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15654, '2020-02-25', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15655, '2020-02-26', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15656, '2020-02-27', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15657, '2020-02-28', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15658, '2020-02-29', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15659, '2020-03-01', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15660, '2020-03-02', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15661, '2020-03-03', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15662, '2020-03-04', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15663, '2020-03-05', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15664, '2020-03-06', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15665, '2020-03-07', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15666, '2020-03-08', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15667, '2020-03-09', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15668, '2020-03-10', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15669, '2020-03-11', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15670, '2020-03-12', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15671, '2020-03-13', 'CF', 'Central African Republic', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15672, '2020-03-14', 'CF', 'Central African Republic', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15673, '2020-03-15', 'CF', 'Central African Republic', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15674, '2020-03-16', 'CF', 'Central African Republic', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15675, '2020-03-17', 'CF', 'Central African Republic', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15676, '2020-03-18', 'CF', 'Central African Republic', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15677, '2020-03-19', 'CF', 'Central African Republic', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15678, '2020-03-20', 'CF', 'Central African Republic', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15679, '2020-03-21', 'CF', 'Central African Republic', 'AFRO', '-2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15680, '2020-03-22', 'CF', 'Central African Republic', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15681, '2020-03-23', 'CF', 'Central African Republic', 'AFRO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15682, '2020-03-24', 'CF', 'Central African Republic', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15683, '2020-03-25', 'CF', 'Central African Republic', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15684, '2020-03-26', 'CF', 'Central African Republic', 'AFRO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15685, '2020-03-27', 'CF', 'Central African Republic', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15686, '2020-03-28', 'CF', 'Central African Republic', 'AFRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15687, '2020-03-29', 'CF', 'Central African Republic', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15688, '2020-03-30', 'CF', 'Central African Republic', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15689, '2020-03-31', 'CF', 'Central African Republic', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15690, '2020-04-01', 'CF', 'Central African Republic', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15691, '2020-04-02', 'CF', 'Central African Republic', 'AFRO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15692, '2020-04-03', 'CF', 'Central African Republic', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15693, '2020-04-04', 'CF', 'Central African Republic', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15694, '2020-04-05', 'CF', 'Central African Republic', 'AFRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15695, '2020-04-06', 'CF', 'Central African Republic', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15696, '2020-04-07', 'CF', 'Central African Republic', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15697, '2020-04-08', 'CF', 'Central African Republic', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15698, '2020-04-09', 'CF', 'Central African Republic', 'AFRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15699, '2020-04-10', 'CF', 'Central African Republic', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15700, '2020-04-11', 'CF', 'Central African Republic', 'AFRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15701, '2020-04-12', 'CF', 'Central African Republic', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15702, '2020-04-13', 'CF', 'Central African Republic', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15703, '2020-04-14', 'CF', 'Central African Republic', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15704, '2020-04-15', 'CF', 'Central African Republic', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15705, '2020-04-16', 'CF', 'Central African Republic', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15706, '2020-04-17', 'CF', 'Central African Republic', 'AFRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15707, '2020-04-18', 'CF', 'Central African Republic', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15708, '2020-04-19', 'CF', 'Central African Republic', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15709, '2020-04-20', 'CF', 'Central African Republic', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15710, '2020-04-21', 'CF', 'Central African Republic', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15711, '2020-04-22', 'CF', 'Central African Republic', 'AFRO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15712, '2020-04-23', 'CF', 'Central African Republic', 'AFRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15713, '2020-04-24', 'CF', 'Central African Republic', 'AFRO', '2', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15714, '2020-04-25', 'CF', 'Central African Republic', 'AFRO', '3', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15715, '2020-04-26', 'CF', 'Central African Republic', 'AFRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15716, '2020-04-27', 'CF', 'Central African Republic', 'AFRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15717, '2020-04-28', 'CF', 'Central African Republic', 'AFRO', '23', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15718, '2020-04-29', 'CF', 'Central African Republic', 'AFRO', '8', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15719, '2020-04-30', 'CF', 'Central African Republic', 'AFRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15720, '2020-05-01', 'CF', 'Central African Republic', 'AFRO', '14', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15721, '2020-05-02', 'CF', 'Central African Republic', 'AFRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15722, '2020-05-03', 'CF', 'Central African Republic', 'AFRO', '8', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15723, '2020-05-04', 'CF', 'Central African Republic', 'AFRO', '0', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15724, '2020-05-05', 'CF', 'Central African Republic', 'AFRO', '22', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15725, '2020-05-06', 'CF', 'Central African Republic', 'AFRO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15726, '2020-05-07', 'CF', 'Central African Republic', 'AFRO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15727, '2020-05-08', 'CF', 'Central African Republic', 'AFRO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15728, '2020-05-09', 'CF', 'Central African Republic', 'AFRO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15729, '2020-05-10', 'CF', 'Central African Republic', 'AFRO', '49', '143', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15730, '2020-05-11', 'CF', 'Central African Republic', 'AFRO', '36', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15731, '2020-05-12', 'CF', 'Central African Republic', 'AFRO', '0', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15732, '2020-05-13', 'CF', 'Central African Republic', 'AFRO', '0', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15733, '2020-05-14', 'CF', 'Central African Republic', 'AFRO', '8', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15734, '2020-05-15', 'CF', 'Central African Republic', 'AFRO', '34', '221', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15735, '2020-05-16', 'CF', 'Central African Republic', 'AFRO', '80', '301', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15736, '2020-05-17', 'CF', 'Central African Republic', 'AFRO', '0', '301', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15737, '2020-05-18', 'CF', 'Central African Republic', 'AFRO', '26', '327', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15738, '2020-05-19', 'CF', 'Central African Republic', 'AFRO', '9', '336', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15739, '2020-05-20', 'CF', 'Central African Republic', 'AFRO', '75', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15740, '2020-05-21', 'CF', 'Central African Republic', 'AFRO', '0', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15741, '2020-05-22', 'CF', 'Central African Republic', 'AFRO', '25', '436', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15742, '2020-05-23', 'CF', 'Central African Republic', 'AFRO', '43', '479', '0', '0');
INSERT INTO public.who_global_data_import VALUES (15743, '2020-05-24', 'CF', 'Central African Republic', 'AFRO', '73', '552', '1', '1');
INSERT INTO public.who_global_data_import VALUES (15744, '2020-05-25', 'CF', 'Central African Republic', 'AFRO', '52', '604', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15745, '2020-05-26', 'CF', 'Central African Republic', 'AFRO', '48', '652', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15746, '2020-05-27', 'CF', 'Central African Republic', 'AFRO', '0', '652', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15747, '2020-05-28', 'CF', 'Central African Republic', 'AFRO', '49', '701', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15748, '2020-05-29', 'CF', 'Central African Republic', 'AFRO', '54', '755', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15749, '2020-05-30', 'CF', 'Central African Republic', 'AFRO', '119', '874', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15750, '2020-05-31', 'CF', 'Central African Republic', 'AFRO', '0', '874', '0', '1');
INSERT INTO public.who_global_data_import VALUES (15751, '2020-06-01', 'CF', 'Central African Republic', 'AFRO', '137', '1011', '1', '2');
INSERT INTO public.who_global_data_import VALUES (15752, '2020-06-02', 'CF', 'Central African Republic', 'AFRO', '58', '1069', '2', '4');
INSERT INTO public.who_global_data_import VALUES (15753, '2020-06-03', 'CF', 'Central African Republic', 'AFRO', '0', '1069', '0', '4');
INSERT INTO public.who_global_data_import VALUES (15754, '2020-06-04', 'CF', 'Central African Republic', 'AFRO', '120', '1189', '0', '4');
INSERT INTO public.who_global_data_import VALUES (15755, '2020-06-05', 'CF', 'Central African Republic', 'AFRO', '99', '1288', '0', '4');
INSERT INTO public.who_global_data_import VALUES (15756, '2020-06-06', 'CF', 'Central African Republic', 'AFRO', '163', '1451', '0', '4');
INSERT INTO public.who_global_data_import VALUES (15757, '2020-06-07', 'CF', 'Central African Republic', 'AFRO', '119', '1570', '1', '5');
INSERT INTO public.who_global_data_import VALUES (15758, '2020-06-08', 'CF', 'Central African Republic', 'AFRO', '64', '1634', '0', '5');
INSERT INTO public.who_global_data_import VALUES (15759, '2020-06-09', 'CF', 'Central African Republic', 'AFRO', '216', '1850', '0', '5');
INSERT INTO public.who_global_data_import VALUES (15760, '2020-06-10', 'CF', 'Central African Republic', 'AFRO', '0', '1850', '0', '5');
INSERT INTO public.who_global_data_import VALUES (15761, '2020-06-11', 'CF', 'Central African Republic', 'AFRO', '38', '1888', '0', '5');
INSERT INTO public.who_global_data_import VALUES (15762, '2020-06-12', 'CF', 'Central African Republic', 'AFRO', '156', '2044', '0', '5');
INSERT INTO public.who_global_data_import VALUES (15763, '2020-06-13', 'CF', 'Central African Republic', 'AFRO', '13', '2057', '2', '7');
INSERT INTO public.who_global_data_import VALUES (15764, '2020-06-14', 'CF', 'Central African Republic', 'AFRO', '0', '2057', '0', '7');
INSERT INTO public.who_global_data_import VALUES (15765, '2020-06-15', 'CF', 'Central African Republic', 'AFRO', '165', '2222', '0', '7');
INSERT INTO public.who_global_data_import VALUES (15766, '2020-06-16', 'CF', 'Central African Republic', 'AFRO', '0', '2222', '0', '7');
INSERT INTO public.who_global_data_import VALUES (15767, '2020-06-17', 'CF', 'Central African Republic', 'AFRO', '188', '2410', '7', '14');
INSERT INTO public.who_global_data_import VALUES (15768, '2020-06-18', 'CF', 'Central African Republic', 'AFRO', '154', '2564', '4', '18');
INSERT INTO public.who_global_data_import VALUES (15769, '2020-06-19', 'CF', 'Central African Republic', 'AFRO', '41', '2605', '1', '19');
INSERT INTO public.who_global_data_import VALUES (15770, '2020-06-20', 'CF', 'Central African Republic', 'AFRO', '0', '2605', '0', '19');
INSERT INTO public.who_global_data_import VALUES (15771, '2020-06-21', 'CF', 'Central African Republic', 'AFRO', '203', '2808', '4', '23');
INSERT INTO public.who_global_data_import VALUES (15772, '2020-06-22', 'CF', 'Central African Republic', 'AFRO', '0', '2808', '0', '23');
INSERT INTO public.who_global_data_import VALUES (15773, '2020-06-23', 'CF', 'Central African Republic', 'AFRO', '155', '2963', '7', '30');
INSERT INTO public.who_global_data_import VALUES (15774, '2020-06-24', 'CF', 'Central African Republic', 'AFRO', '88', '3051', '7', '37');
INSERT INTO public.who_global_data_import VALUES (15775, '2020-06-25', 'CF', 'Central African Republic', 'AFRO', '0', '3051', '0', '37');
INSERT INTO public.who_global_data_import VALUES (15776, '2020-06-26', 'CF', 'Central African Republic', 'AFRO', '193', '3244', '3', '40');
INSERT INTO public.who_global_data_import VALUES (15777, '2020-06-27', 'CF', 'Central African Republic', 'AFRO', '96', '3340', '0', '40');
INSERT INTO public.who_global_data_import VALUES (15778, '2020-06-28', 'CF', 'Central African Republic', 'AFRO', '0', '3340', '0', '40');
INSERT INTO public.who_global_data_import VALUES (15779, '2020-06-29', 'CF', 'Central African Republic', 'AFRO', '89', '3429', '5', '45');
INSERT INTO public.who_global_data_import VALUES (15780, '2020-06-30', 'CF', 'Central African Republic', 'AFRO', '184', '3613', '2', '47');
INSERT INTO public.who_global_data_import VALUES (15781, '2020-07-01', 'CF', 'Central African Republic', 'AFRO', '132', '3745', '0', '47');
INSERT INTO public.who_global_data_import VALUES (15782, '2020-07-02', 'CF', 'Central African Republic', 'AFRO', '0', '3745', '0', '47');
INSERT INTO public.who_global_data_import VALUES (15783, '2020-07-03', 'CF', 'Central African Republic', 'AFRO', '43', '3788', '0', '47');
INSERT INTO public.who_global_data_import VALUES (15784, '2020-07-04', 'CF', 'Central African Republic', 'AFRO', '130', '3918', '1', '48');
INSERT INTO public.who_global_data_import VALUES (15785, '2020-07-05', 'CF', 'Central African Republic', 'AFRO', '51', '3969', '0', '48');
INSERT INTO public.who_global_data_import VALUES (15786, '2020-07-06', 'CF', 'Central African Republic', 'AFRO', '0', '3969', '0', '48');
INSERT INTO public.who_global_data_import VALUES (15787, '2020-07-07', 'CF', 'Central African Republic', 'AFRO', '64', '4033', '4', '52');
INSERT INTO public.who_global_data_import VALUES (15788, '2020-07-08', 'CF', 'Central African Republic', 'AFRO', '38', '4071', '0', '52');
INSERT INTO public.who_global_data_import VALUES (15789, '2020-07-09', 'CF', 'Central African Republic', 'AFRO', '38', '4109', '0', '52');
INSERT INTO public.who_global_data_import VALUES (15790, '2020-07-10', 'CF', 'Central African Republic', 'AFRO', '91', '4200', '0', '52');
INSERT INTO public.who_global_data_import VALUES (15791, '2020-07-11', 'CF', 'Central African Republic', 'AFRO', '0', '4200', '0', '52');
INSERT INTO public.who_global_data_import VALUES (15792, '2020-07-12', 'CF', 'Central African Republic', 'AFRO', '88', '4288', '1', '53');
INSERT INTO public.who_global_data_import VALUES (15793, '2020-07-13', 'CF', 'Central African Republic', 'AFRO', '0', '4288', '0', '53');
INSERT INTO public.who_global_data_import VALUES (15794, '2020-07-14', 'CF', 'Central African Republic', 'AFRO', '33', '4321', '0', '53');
INSERT INTO public.who_global_data_import VALUES (15795, '2020-07-15', 'CF', 'Central African Republic', 'AFRO', '0', '4321', '0', '53');
INSERT INTO public.who_global_data_import VALUES (15796, '2020-07-16', 'CF', 'Central African Republic', 'AFRO', '41', '4362', '0', '53');
INSERT INTO public.who_global_data_import VALUES (15797, '2020-07-17', 'CF', 'Central African Republic', 'AFRO', '11', '4373', '0', '53');
INSERT INTO public.who_global_data_import VALUES (15798, '2020-07-18', 'CF', 'Central African Republic', 'AFRO', '16', '4389', '0', '53');
INSERT INTO public.who_global_data_import VALUES (15799, '2020-07-19', 'CF', 'Central African Republic', 'AFRO', '96', '4485', '2', '55');
INSERT INTO public.who_global_data_import VALUES (15800, '2020-07-20', 'CF', 'Central African Republic', 'AFRO', '0', '4485', '0', '55');
INSERT INTO public.who_global_data_import VALUES (15801, '2020-07-21', 'CF', 'Central African Republic', 'AFRO', '0', '4485', '0', '55');
INSERT INTO public.who_global_data_import VALUES (15802, '2020-07-22', 'CF', 'Central African Republic', 'AFRO', '76', '4561', '0', '55');
INSERT INTO public.who_global_data_import VALUES (15803, '2020-07-23', 'CF', 'Central African Republic', 'AFRO', '13', '4574', '2', '57');
INSERT INTO public.who_global_data_import VALUES (15804, '2020-07-24', 'CF', 'Central African Republic', 'AFRO', '16', '4590', '1', '58');
INSERT INTO public.who_global_data_import VALUES (15805, '2020-07-25', 'CF', 'Central African Republic', 'AFRO', '3', '4593', '1', '59');
INSERT INTO public.who_global_data_import VALUES (15806, '2020-07-26', 'CF', 'Central African Republic', 'AFRO', '5', '4598', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15807, '2020-07-27', 'CF', 'Central African Republic', 'AFRO', '0', '4598', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15808, '2020-07-28', 'CF', 'Central African Republic', 'AFRO', '1', '4599', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15809, '2020-07-29', 'CF', 'Central African Republic', 'AFRO', '0', '4599', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15810, '2020-07-30', 'CF', 'Central African Republic', 'AFRO', '6', '4605', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15811, '2020-07-31', 'CF', 'Central African Republic', 'AFRO', '0', '4605', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15812, '2020-08-01', 'CF', 'Central African Republic', 'AFRO', '3', '4608', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15813, '2020-08-02', 'CF', 'Central African Republic', 'AFRO', '6', '4614', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15814, '2020-08-03', 'CF', 'Central African Republic', 'AFRO', '0', '4614', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15815, '2020-08-04', 'CF', 'Central African Republic', 'AFRO', '0', '4614', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15816, '2020-08-05', 'CF', 'Central African Republic', 'AFRO', '4', '4618', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15817, '2020-08-06', 'CF', 'Central African Republic', 'AFRO', '0', '4618', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15818, '2020-08-07', 'CF', 'Central African Republic', 'AFRO', '2', '4620', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15819, '2020-08-08', 'CF', 'Central African Republic', 'AFRO', '21', '4641', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15820, '2020-08-09', 'CF', 'Central African Republic', 'AFRO', '0', '4641', '0', '59');
INSERT INTO public.who_global_data_import VALUES (15821, '2020-08-10', 'CF', 'Central African Republic', 'AFRO', '0', '4641', '1', '60');
INSERT INTO public.who_global_data_import VALUES (16118, '2020-04-29', 'TD', 'Chad', 'AFRO', '6', '52', '2', '2');
INSERT INTO public.who_global_data_import VALUES (15822, '2020-08-11', 'CF', 'Central African Republic', 'AFRO', '0', '4641', '0', '60');
INSERT INTO public.who_global_data_import VALUES (15823, '2020-08-12', 'CF', 'Central African Republic', 'AFRO', '6', '4647', '1', '61');
INSERT INTO public.who_global_data_import VALUES (15824, '2020-08-13', 'CF', 'Central African Republic', 'AFRO', '5', '4652', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15825, '2020-08-14', 'CF', 'Central African Republic', 'AFRO', '0', '4652', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15826, '2020-08-15', 'CF', 'Central African Republic', 'AFRO', '0', '4652', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15827, '2020-08-16', 'CF', 'Central African Republic', 'AFRO', '0', '4652', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15828, '2020-08-17', 'CF', 'Central African Republic', 'AFRO', '0', '4652', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15829, '2020-08-18', 'CF', 'Central African Republic', 'AFRO', '15', '4667', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15830, '2020-08-19', 'CF', 'Central African Republic', 'AFRO', '12', '4679', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15831, '2020-08-20', 'CF', 'Central African Republic', 'AFRO', '0', '4679', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15832, '2020-08-21', 'CF', 'Central African Republic', 'AFRO', '0', '4679', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15833, '2020-08-22', 'CF', 'Central African Republic', 'AFRO', '0', '4679', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15834, '2020-08-23', 'CF', 'Central African Republic', 'AFRO', '0', '4679', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15835, '2020-08-24', 'CF', 'Central African Republic', 'AFRO', '0', '4679', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15836, '2020-08-25', 'CF', 'Central African Republic', 'AFRO', '0', '4679', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15837, '2020-08-26', 'CF', 'Central African Republic', 'AFRO', '12', '4691', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15838, '2020-08-27', 'CF', 'Central African Republic', 'AFRO', '7', '4698', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15839, '2020-08-28', 'CF', 'Central African Republic', 'AFRO', '0', '4698', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15840, '2020-08-29', 'CF', 'Central African Republic', 'AFRO', '2', '4700', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15841, '2020-08-30', 'CF', 'Central African Republic', 'AFRO', '0', '4700', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15842, '2020-08-31', 'CF', 'Central African Republic', 'AFRO', '0', '4700', '0', '61');
INSERT INTO public.who_global_data_import VALUES (15843, '2020-09-01', 'CF', 'Central African Republic', 'AFRO', '11', '4711', '1', '62');
INSERT INTO public.who_global_data_import VALUES (15844, '2020-09-02', 'CF', 'Central African Republic', 'AFRO', '0', '4711', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15845, '2020-09-03', 'CF', 'Central African Republic', 'AFRO', '1', '4712', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15846, '2020-09-04', 'CF', 'Central African Republic', 'AFRO', '17', '4729', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15847, '2020-09-05', 'CF', 'Central African Republic', 'AFRO', '0', '4729', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15848, '2020-09-06', 'CF', 'Central African Republic', 'AFRO', '0', '4729', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15849, '2020-09-07', 'CF', 'Central African Republic', 'AFRO', '0', '4729', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15850, '2020-09-08', 'CF', 'Central African Republic', 'AFRO', '0', '4729', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15851, '2020-09-09', 'CF', 'Central African Republic', 'AFRO', '7', '4736', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15852, '2020-09-10', 'CF', 'Central African Republic', 'AFRO', '0', '4736', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15853, '2020-09-11', 'CF', 'Central African Republic', 'AFRO', '11', '4747', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15854, '2020-09-12', 'CF', 'Central African Republic', 'AFRO', '2', '4749', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15855, '2020-09-13', 'CF', 'Central African Republic', 'AFRO', '0', '4749', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15856, '2020-09-14', 'CF', 'Central African Republic', 'AFRO', '0', '4749', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15857, '2020-09-15', 'CF', 'Central African Republic', 'AFRO', '23', '4772', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15858, '2020-09-16', 'CF', 'Central African Republic', 'AFRO', '0', '4772', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15859, '2020-09-17', 'CF', 'Central African Republic', 'AFRO', '10', '4782', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15860, '2020-09-18', 'CF', 'Central African Republic', 'AFRO', '4', '4786', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15861, '2020-09-19', 'CF', 'Central African Republic', 'AFRO', '0', '4786', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15862, '2020-09-20', 'CF', 'Central African Republic', 'AFRO', '7', '4793', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15863, '2020-09-21', 'CF', 'Central African Republic', 'AFRO', '0', '4793', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15864, '2020-09-22', 'CF', 'Central African Republic', 'AFRO', '9', '4802', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15865, '2020-09-23', 'CF', 'Central African Republic', 'AFRO', '0', '4802', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15866, '2020-09-24', 'CF', 'Central African Republic', 'AFRO', '2', '4804', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15867, '2020-09-25', 'CF', 'Central African Republic', 'AFRO', '0', '4804', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15868, '2020-09-26', 'CF', 'Central African Republic', 'AFRO', '2', '4806', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15869, '2020-09-27', 'CF', 'Central African Republic', 'AFRO', '0', '4806', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15870, '2020-09-28', 'CF', 'Central African Republic', 'AFRO', '0', '4806', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15871, '2020-09-29', 'CF', 'Central African Republic', 'AFRO', '19', '4825', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15872, '2020-09-30', 'CF', 'Central African Republic', 'AFRO', '4', '4829', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15873, '2020-10-01', 'CF', 'Central African Republic', 'AFRO', '0', '4829', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15874, '2020-10-02', 'CF', 'Central African Republic', 'AFRO', '0', '4829', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15875, '2020-10-03', 'CF', 'Central African Republic', 'AFRO', '16', '4845', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15876, '2020-10-04', 'CF', 'Central African Republic', 'AFRO', '0', '4845', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15877, '2020-10-05', 'CF', 'Central African Republic', 'AFRO', '0', '4845', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15878, '2020-10-06', 'CF', 'Central African Republic', 'AFRO', '5', '4850', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15879, '2020-10-07', 'CF', 'Central African Republic', 'AFRO', '3', '4853', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15880, '2020-10-08', 'CF', 'Central African Republic', 'AFRO', '0', '4853', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15881, '2020-10-09', 'CF', 'Central African Republic', 'AFRO', '0', '4853', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15882, '2020-10-10', 'CF', 'Central African Republic', 'AFRO', '1', '4854', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15883, '2020-10-11', 'CF', 'Central African Republic', 'AFRO', '0', '4854', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15884, '2020-10-12', 'CF', 'Central African Republic', 'AFRO', '0', '4854', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15885, '2020-10-13', 'CF', 'Central African Republic', 'AFRO', '1', '4855', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15886, '2020-10-14', 'CF', 'Central African Republic', 'AFRO', '0', '4855', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15887, '2020-10-15', 'CF', 'Central African Republic', 'AFRO', '0', '4855', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15888, '2020-10-16', 'CF', 'Central African Republic', 'AFRO', '0', '4855', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15889, '2020-10-17', 'CF', 'Central African Republic', 'AFRO', '0', '4855', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15890, '2020-10-18', 'CF', 'Central African Republic', 'AFRO', '0', '4855', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15891, '2020-10-19', 'CF', 'Central African Republic', 'AFRO', '1', '4856', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15892, '2020-10-20', 'CF', 'Central African Republic', 'AFRO', '2', '4858', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15893, '2020-10-21', 'CF', 'Central African Republic', 'AFRO', '0', '4858', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15894, '2020-10-22', 'CF', 'Central African Republic', 'AFRO', '4', '4862', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15895, '2020-10-23', 'CF', 'Central African Republic', 'AFRO', '0', '4862', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15896, '2020-10-24', 'CF', 'Central African Republic', 'AFRO', '0', '4862', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15897, '2020-10-25', 'CF', 'Central African Republic', 'AFRO', '0', '4862', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15898, '2020-10-26', 'CF', 'Central African Republic', 'AFRO', '1', '4863', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15899, '2020-10-27', 'CF', 'Central African Republic', 'AFRO', '0', '4863', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15900, '2020-10-28', 'CF', 'Central African Republic', 'AFRO', '0', '4863', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15901, '2020-10-29', 'CF', 'Central African Republic', 'AFRO', '0', '4863', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15902, '2020-10-30', 'CF', 'Central African Republic', 'AFRO', '3', '4866', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15903, '2020-10-31', 'CF', 'Central African Republic', 'AFRO', '0', '4866', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15904, '2020-11-01', 'CF', 'Central African Republic', 'AFRO', '0', '4866', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15905, '2020-11-02', 'CF', 'Central African Republic', 'AFRO', '0', '4866', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15906, '2020-11-03', 'CF', 'Central African Republic', 'AFRO', '0', '4866', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15907, '2020-11-04', 'CF', 'Central African Republic', 'AFRO', '0', '4866', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15908, '2020-11-05', 'CF', 'Central African Republic', 'AFRO', '0', '4866', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15909, '2020-11-06', 'CF', 'Central African Republic', 'AFRO', '0', '4866', '0', '62');
INSERT INTO public.who_global_data_import VALUES (16119, '2020-04-30', 'TD', 'Chad', 'AFRO', '0', '52', '0', '2');
INSERT INTO public.who_global_data_import VALUES (15910, '2020-11-07', 'CF', 'Central African Republic', 'AFRO', '13', '4879', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15911, '2020-11-08', 'CF', 'Central African Republic', 'AFRO', '0', '4879', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15912, '2020-11-09', 'CF', 'Central African Republic', 'AFRO', '1', '4880', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15913, '2020-11-10', 'CF', 'Central African Republic', 'AFRO', '4', '4884', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15914, '2020-11-11', 'CF', 'Central African Republic', 'AFRO', '0', '4884', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15915, '2020-11-12', 'CF', 'Central African Republic', 'AFRO', '4', '4888', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15916, '2020-11-13', 'CF', 'Central African Republic', 'AFRO', '0', '4888', '0', '62');
INSERT INTO public.who_global_data_import VALUES (15917, '2020-11-14', 'CF', 'Central African Republic', 'AFRO', '8', '4896', '1', '63');
INSERT INTO public.who_global_data_import VALUES (15918, '2020-11-15', 'CF', 'Central African Republic', 'AFRO', '4', '4900', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15919, '2020-11-16', 'CF', 'Central African Republic', 'AFRO', '0', '4900', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15920, '2020-11-17', 'CF', 'Central African Republic', 'AFRO', '0', '4900', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15921, '2020-11-18', 'CF', 'Central African Republic', 'AFRO', '0', '4900', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15922, '2020-11-19', 'CF', 'Central African Republic', 'AFRO', '7', '4907', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15923, '2020-11-20', 'CF', 'Central African Republic', 'AFRO', '4', '4911', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15924, '2020-11-21', 'CF', 'Central African Republic', 'AFRO', '0', '4911', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15925, '2020-11-22', 'CF', 'Central African Republic', 'AFRO', '0', '4911', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15926, '2020-11-23', 'CF', 'Central African Republic', 'AFRO', '0', '4911', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15927, '2020-11-24', 'CF', 'Central African Republic', 'AFRO', '0', '4911', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15928, '2020-11-25', 'CF', 'Central African Republic', 'AFRO', '0', '4911', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15929, '2020-11-26', 'CF', 'Central African Republic', 'AFRO', '2', '4913', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15930, '2020-11-27', 'CF', 'Central African Republic', 'AFRO', '0', '4913', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15931, '2020-11-28', 'CF', 'Central African Republic', 'AFRO', '0', '4913', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15932, '2020-11-29', 'CF', 'Central African Republic', 'AFRO', '0', '4913', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15933, '2020-11-30', 'CF', 'Central African Republic', 'AFRO', '0', '4913', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15934, '2020-12-01', 'CF', 'Central African Republic', 'AFRO', '5', '4918', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15935, '2020-12-02', 'CF', 'Central African Republic', 'AFRO', '0', '4918', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15936, '2020-12-03', 'CF', 'Central African Republic', 'AFRO', '0', '4918', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15937, '2020-12-04', 'CF', 'Central African Republic', 'AFRO', '0', '4918', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15938, '2020-12-05', 'CF', 'Central African Republic', 'AFRO', '4', '4922', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15939, '2020-12-06', 'CF', 'Central African Republic', 'AFRO', '0', '4922', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15940, '2020-12-07', 'CF', 'Central African Republic', 'AFRO', '0', '4922', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15941, '2020-12-08', 'CF', 'Central African Republic', 'AFRO', '5', '4927', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15942, '2020-12-09', 'CF', 'Central African Republic', 'AFRO', '0', '4927', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15943, '2020-12-10', 'CF', 'Central African Republic', 'AFRO', '5', '4932', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15944, '2020-12-11', 'CF', 'Central African Republic', 'AFRO', '4', '4936', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15945, '2020-12-12', 'CF', 'Central African Republic', 'AFRO', '0', '4936', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15946, '2020-12-13', 'CF', 'Central African Republic', 'AFRO', '0', '4936', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15947, '2020-12-14', 'CF', 'Central African Republic', 'AFRO', '0', '4936', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15948, '2020-12-15', 'CF', 'Central African Republic', 'AFRO', '0', '4936', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15949, '2020-12-16', 'CF', 'Central African Republic', 'AFRO', '0', '4936', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15950, '2020-12-17', 'CF', 'Central African Republic', 'AFRO', '0', '4936', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15951, '2020-12-18', 'CF', 'Central African Republic', 'AFRO', '0', '4936', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15952, '2020-12-19', 'CF', 'Central African Republic', 'AFRO', '0', '4936', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15953, '2020-12-20', 'CF', 'Central African Republic', 'AFRO', '0', '4936', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15954, '2020-12-21', 'CF', 'Central African Republic', 'AFRO', '2', '4938', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15955, '2020-12-22', 'CF', 'Central African Republic', 'AFRO', '10', '4948', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15956, '2020-12-23', 'CF', 'Central African Republic', 'AFRO', '0', '4948', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15957, '2020-12-24', 'CF', 'Central African Republic', 'AFRO', '0', '4948', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15958, '2020-12-25', 'CF', 'Central African Republic', 'AFRO', '0', '4948', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15959, '2020-12-26', 'CF', 'Central African Republic', 'AFRO', '0', '4948', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15960, '2020-12-27', 'CF', 'Central African Republic', 'AFRO', '0', '4948', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15961, '2020-12-28', 'CF', 'Central African Republic', 'AFRO', '0', '4948', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15962, '2020-12-29', 'CF', 'Central African Republic', 'AFRO', '13', '4961', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15963, '2020-12-30', 'CF', 'Central African Republic', 'AFRO', '2', '4963', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15964, '2020-12-31', 'CF', 'Central African Republic', 'AFRO', '0', '4963', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15965, '2021-01-01', 'CF', 'Central African Republic', 'AFRO', '0', '4963', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15966, '2021-01-02', 'CF', 'Central African Republic', 'AFRO', '0', '4963', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15967, '2021-01-03', 'CF', 'Central African Republic', 'AFRO', '0', '4963', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15968, '2021-01-04', 'CF', 'Central African Republic', 'AFRO', '0', '4963', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15969, '2021-01-05', 'CF', 'Central African Republic', 'AFRO', '0', '4963', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15970, '2021-01-06', 'CF', 'Central African Republic', 'AFRO', '0', '4963', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15971, '2021-01-07', 'CF', 'Central African Republic', 'AFRO', '6', '4969', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15972, '2021-01-08', 'CF', 'Central African Republic', 'AFRO', '0', '4969', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15973, '2021-01-09', 'CF', 'Central African Republic', 'AFRO', '0', '4969', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15974, '2021-01-10', 'CF', 'Central African Republic', 'AFRO', '4', '4973', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15975, '2021-01-11', 'CF', 'Central African Republic', 'AFRO', '0', '4973', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15976, '2021-01-12', 'CF', 'Central African Republic', 'AFRO', '0', '4973', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15977, '2021-01-13', 'CF', 'Central African Republic', 'AFRO', '0', '4973', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15978, '2021-01-14', 'CF', 'Central African Republic', 'AFRO', '0', '4973', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15979, '2021-01-15', 'CF', 'Central African Republic', 'AFRO', '0', '4973', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15980, '2021-01-16', 'CF', 'Central African Republic', 'AFRO', '0', '4973', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15981, '2021-01-17', 'CF', 'Central African Republic', 'AFRO', '0', '4973', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15982, '2021-01-18', 'CF', 'Central African Republic', 'AFRO', '0', '4973', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15983, '2021-01-19', 'CF', 'Central African Republic', 'AFRO', '0', '4973', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15984, '2021-01-20', 'CF', 'Central African Republic', 'AFRO', '1', '4974', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15985, '2021-01-21', 'CF', 'Central African Republic', 'AFRO', '0', '4974', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15986, '2021-01-22', 'CF', 'Central African Republic', 'AFRO', '0', '4974', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15987, '2021-01-23', 'CF', 'Central African Republic', 'AFRO', '0', '4974', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15988, '2021-01-24', 'CF', 'Central African Republic', 'AFRO', '6', '4980', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15989, '2021-01-25', 'CF', 'Central African Republic', 'AFRO', '0', '4980', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15990, '2021-01-26', 'CF', 'Central African Republic', 'AFRO', '0', '4980', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15991, '2021-01-27', 'CF', 'Central African Republic', 'AFRO', '1', '4981', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15992, '2021-01-28', 'CF', 'Central African Republic', 'AFRO', '0', '4981', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15993, '2021-01-29', 'CF', 'Central African Republic', 'AFRO', '0', '4981', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15994, '2021-01-30', 'CF', 'Central African Republic', 'AFRO', '0', '4981', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15995, '2021-01-31', 'CF', 'Central African Republic', 'AFRO', '0', '4981', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15996, '2021-02-01', 'CF', 'Central African Republic', 'AFRO', '8', '4989', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15997, '2021-02-02', 'CF', 'Central African Republic', 'AFRO', '0', '4989', '0', '63');
INSERT INTO public.who_global_data_import VALUES (16120, '2020-05-01', 'TD', 'Chad', 'AFRO', '21', '73', '1', '3');
INSERT INTO public.who_global_data_import VALUES (15998, '2021-02-03', 'CF', 'Central African Republic', 'AFRO', '0', '4989', '0', '63');
INSERT INTO public.who_global_data_import VALUES (15999, '2021-02-04', 'CF', 'Central African Republic', 'AFRO', '0', '4989', '0', '63');
INSERT INTO public.who_global_data_import VALUES (16000, '2021-02-05', 'CF', 'Central African Republic', 'AFRO', '0', '4989', '0', '63');
INSERT INTO public.who_global_data_import VALUES (16001, '2020-01-03', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16002, '2020-01-04', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16003, '2020-01-05', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16004, '2020-01-06', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16005, '2020-01-07', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16006, '2020-01-08', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16007, '2020-01-09', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16008, '2020-01-10', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16009, '2020-01-11', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16010, '2020-01-12', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16011, '2020-01-13', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16012, '2020-01-14', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16013, '2020-01-15', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16014, '2020-01-16', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16015, '2020-01-17', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16016, '2020-01-18', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16017, '2020-01-19', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16018, '2020-01-20', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16019, '2020-01-21', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16020, '2020-01-22', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16021, '2020-01-23', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16022, '2020-01-24', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16023, '2020-01-25', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16024, '2020-01-26', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16025, '2020-01-27', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16026, '2020-01-28', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16027, '2020-01-29', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16028, '2020-01-30', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16029, '2020-01-31', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16030, '2020-02-01', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16031, '2020-02-02', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16032, '2020-02-03', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16033, '2020-02-04', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16034, '2020-02-05', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16035, '2020-02-06', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16036, '2020-02-07', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16037, '2020-02-08', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16038, '2020-02-09', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16039, '2020-02-10', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16040, '2020-02-11', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16041, '2020-02-12', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16042, '2020-02-13', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16043, '2020-02-14', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16044, '2020-02-15', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16045, '2020-02-16', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16046, '2020-02-17', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16047, '2020-02-18', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16048, '2020-02-19', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16049, '2020-02-20', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16050, '2020-02-21', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16051, '2020-02-22', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16052, '2020-02-23', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16053, '2020-02-24', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16054, '2020-02-25', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16055, '2020-02-26', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16056, '2020-02-27', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16057, '2020-02-28', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16058, '2020-02-29', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16059, '2020-03-01', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16060, '2020-03-02', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16061, '2020-03-03', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16062, '2020-03-04', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16063, '2020-03-05', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16064, '2020-03-06', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16065, '2020-03-07', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16066, '2020-03-08', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16067, '2020-03-09', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16068, '2020-03-10', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16069, '2020-03-11', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16070, '2020-03-12', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16071, '2020-03-13', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16072, '2020-03-14', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16073, '2020-03-15', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16074, '2020-03-16', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16075, '2020-03-17', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16076, '2020-03-18', 'TD', 'Chad', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16077, '2020-03-19', 'TD', 'Chad', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16078, '2020-03-20', 'TD', 'Chad', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16079, '2020-03-21', 'TD', 'Chad', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16080, '2020-03-22', 'TD', 'Chad', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16081, '2020-03-23', 'TD', 'Chad', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16082, '2020-03-24', 'TD', 'Chad', 'AFRO', '-2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16083, '2020-03-25', 'TD', 'Chad', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16084, '2020-03-26', 'TD', 'Chad', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16085, '2020-03-27', 'TD', 'Chad', 'AFRO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16086, '2020-03-28', 'TD', 'Chad', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16087, '2020-03-29', 'TD', 'Chad', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16088, '2020-03-30', 'TD', 'Chad', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16089, '2020-03-31', 'TD', 'Chad', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16090, '2020-04-01', 'TD', 'Chad', 'AFRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16091, '2020-04-02', 'TD', 'Chad', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16092, '2020-04-03', 'TD', 'Chad', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16093, '2020-04-04', 'TD', 'Chad', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16094, '2020-04-05', 'TD', 'Chad', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16095, '2020-04-06', 'TD', 'Chad', 'AFRO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16096, '2020-04-07', 'TD', 'Chad', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16097, '2020-04-08', 'TD', 'Chad', 'AFRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16098, '2020-04-09', 'TD', 'Chad', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16099, '2020-04-10', 'TD', 'Chad', 'AFRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16100, '2020-04-11', 'TD', 'Chad', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16101, '2020-04-12', 'TD', 'Chad', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16102, '2020-04-13', 'TD', 'Chad', 'AFRO', '7', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16103, '2020-04-14', 'TD', 'Chad', 'AFRO', '5', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16104, '2020-04-15', 'TD', 'Chad', 'AFRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16105, '2020-04-16', 'TD', 'Chad', 'AFRO', '4', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16106, '2020-04-17', 'TD', 'Chad', 'AFRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16107, '2020-04-18', 'TD', 'Chad', 'AFRO', '6', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16108, '2020-04-19', 'TD', 'Chad', 'AFRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16109, '2020-04-20', 'TD', 'Chad', 'AFRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16110, '2020-04-21', 'TD', 'Chad', 'AFRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16111, '2020-04-22', 'TD', 'Chad', 'AFRO', '1', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16112, '2020-04-23', 'TD', 'Chad', 'AFRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16113, '2020-04-24', 'TD', 'Chad', 'AFRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16114, '2020-04-25', 'TD', 'Chad', 'AFRO', '6', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16115, '2020-04-26', 'TD', 'Chad', 'AFRO', '6', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16116, '2020-04-27', 'TD', 'Chad', 'AFRO', '0', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16121, '2020-05-02', 'TD', 'Chad', 'AFRO', '0', '73', '2', '5');
INSERT INTO public.who_global_data_import VALUES (16122, '2020-05-03', 'TD', 'Chad', 'AFRO', '44', '117', '5', '10');
INSERT INTO public.who_global_data_import VALUES (16123, '2020-05-04', 'TD', 'Chad', 'AFRO', '0', '117', '0', '10');
INSERT INTO public.who_global_data_import VALUES (16124, '2020-05-05', 'TD', 'Chad', 'AFRO', '0', '117', '0', '10');
INSERT INTO public.who_global_data_import VALUES (16125, '2020-05-06', 'TD', 'Chad', 'AFRO', '53', '170', '7', '17');
INSERT INTO public.who_global_data_import VALUES (16126, '2020-05-07', 'TD', 'Chad', 'AFRO', '0', '170', '0', '17');
INSERT INTO public.who_global_data_import VALUES (16127, '2020-05-08', 'TD', 'Chad', 'AFRO', '83', '253', '10', '27');
INSERT INTO public.who_global_data_import VALUES (16128, '2020-05-09', 'TD', 'Chad', 'AFRO', '7', '260', '1', '28');
INSERT INTO public.who_global_data_import VALUES (16129, '2020-05-10', 'TD', 'Chad', 'AFRO', '62', '322', '3', '31');
INSERT INTO public.who_global_data_import VALUES (16130, '2020-05-11', 'TD', 'Chad', 'AFRO', '0', '322', '0', '31');
INSERT INTO public.who_global_data_import VALUES (16131, '2020-05-12', 'TD', 'Chad', 'AFRO', '0', '322', '0', '31');
INSERT INTO public.who_global_data_import VALUES (16132, '2020-05-13', 'TD', 'Chad', 'AFRO', '35', '357', '9', '40');
INSERT INTO public.who_global_data_import VALUES (16133, '2020-05-14', 'TD', 'Chad', 'AFRO', '15', '372', '2', '42');
INSERT INTO public.who_global_data_import VALUES (16134, '2020-05-15', 'TD', 'Chad', 'AFRO', '27', '399', '4', '46');
INSERT INTO public.who_global_data_import VALUES (16135, '2020-05-16', 'TD', 'Chad', 'AFRO', '29', '428', '2', '48');
INSERT INTO public.who_global_data_import VALUES (16136, '2020-05-17', 'TD', 'Chad', 'AFRO', '46', '474', '2', '50');
INSERT INTO public.who_global_data_import VALUES (16137, '2020-05-18', 'TD', 'Chad', 'AFRO', '29', '503', '3', '53');
INSERT INTO public.who_global_data_import VALUES (16138, '2020-05-19', 'TD', 'Chad', 'AFRO', '16', '519', '1', '54');
INSERT INTO public.who_global_data_import VALUES (16139, '2020-05-20', 'TD', 'Chad', 'AFRO', '26', '545', '2', '56');
INSERT INTO public.who_global_data_import VALUES (16140, '2020-05-21', 'TD', 'Chad', 'AFRO', '20', '565', '1', '57');
INSERT INTO public.who_global_data_import VALUES (16141, '2020-05-22', 'TD', 'Chad', 'AFRO', '23', '588', '1', '58');
INSERT INTO public.who_global_data_import VALUES (16142, '2020-05-23', 'TD', 'Chad', 'AFRO', '23', '611', '1', '59');
INSERT INTO public.who_global_data_import VALUES (16143, '2020-05-24', 'TD', 'Chad', 'AFRO', '37', '648', '1', '60');
INSERT INTO public.who_global_data_import VALUES (16144, '2020-05-25', 'TD', 'Chad', 'AFRO', '27', '675', '0', '60');
INSERT INTO public.who_global_data_import VALUES (16145, '2020-05-26', 'TD', 'Chad', 'AFRO', '12', '687', '1', '61');
INSERT INTO public.who_global_data_import VALUES (16146, '2020-05-27', 'TD', 'Chad', 'AFRO', '13', '700', '1', '62');
INSERT INTO public.who_global_data_import VALUES (16147, '2020-05-28', 'TD', 'Chad', 'AFRO', '15', '715', '2', '64');
INSERT INTO public.who_global_data_import VALUES (16148, '2020-05-29', 'TD', 'Chad', 'AFRO', '11', '726', '1', '65');
INSERT INTO public.who_global_data_import VALUES (16149, '2020-05-30', 'TD', 'Chad', 'AFRO', '33', '759', '0', '65');
INSERT INTO public.who_global_data_import VALUES (16150, '2020-05-31', 'TD', 'Chad', 'AFRO', '0', '759', '0', '65');
INSERT INTO public.who_global_data_import VALUES (16151, '2020-06-01', 'TD', 'Chad', 'AFRO', '19', '778', '0', '65');
INSERT INTO public.who_global_data_import VALUES (16152, '2020-06-02', 'TD', 'Chad', 'AFRO', '12', '790', '1', '66');
INSERT INTO public.who_global_data_import VALUES (16153, '2020-06-03', 'TD', 'Chad', 'AFRO', '13', '803', '0', '66');
INSERT INTO public.who_global_data_import VALUES (16154, '2020-06-04', 'TD', 'Chad', 'AFRO', '17', '820', '0', '66');
INSERT INTO public.who_global_data_import VALUES (16155, '2020-06-05', 'TD', 'Chad', 'AFRO', '8', '828', '0', '66');
INSERT INTO public.who_global_data_import VALUES (16156, '2020-06-06', 'TD', 'Chad', 'AFRO', '8', '836', '2', '68');
INSERT INTO public.who_global_data_import VALUES (16157, '2020-06-07', 'TD', 'Chad', 'AFRO', '0', '836', '1', '69');
INSERT INTO public.who_global_data_import VALUES (16158, '2020-06-08', 'TD', 'Chad', 'AFRO', '1', '837', '0', '69');
INSERT INTO public.who_global_data_import VALUES (16159, '2020-06-09', 'TD', 'Chad', 'AFRO', '2', '839', '1', '70');
INSERT INTO public.who_global_data_import VALUES (16160, '2020-06-10', 'TD', 'Chad', 'AFRO', '5', '844', '1', '71');
INSERT INTO public.who_global_data_import VALUES (16161, '2020-06-11', 'TD', 'Chad', 'AFRO', '2', '846', '1', '72');
INSERT INTO public.who_global_data_import VALUES (16162, '2020-06-12', 'TD', 'Chad', 'AFRO', '2', '848', '0', '72');
INSERT INTO public.who_global_data_import VALUES (16163, '2020-06-13', 'TD', 'Chad', 'AFRO', '0', '848', '0', '72');
INSERT INTO public.who_global_data_import VALUES (16164, '2020-06-14', 'TD', 'Chad', 'AFRO', '0', '848', '0', '72');
INSERT INTO public.who_global_data_import VALUES (16165, '2020-06-15', 'TD', 'Chad', 'AFRO', '2', '850', '1', '73');
INSERT INTO public.who_global_data_import VALUES (16166, '2020-06-16', 'TD', 'Chad', 'AFRO', '0', '850', '0', '73');
INSERT INTO public.who_global_data_import VALUES (16167, '2020-06-17', 'TD', 'Chad', 'AFRO', '3', '853', '1', '74');
INSERT INTO public.who_global_data_import VALUES (16168, '2020-06-18', 'TD', 'Chad', 'AFRO', '1', '854', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16169, '2020-06-19', 'TD', 'Chad', 'AFRO', '0', '854', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16170, '2020-06-20', 'TD', 'Chad', 'AFRO', '4', '858', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16171, '2020-06-21', 'TD', 'Chad', 'AFRO', '0', '858', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16172, '2020-06-22', 'TD', 'Chad', 'AFRO', '0', '858', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16173, '2020-06-23', 'TD', 'Chad', 'AFRO', '0', '858', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16174, '2020-06-24', 'TD', 'Chad', 'AFRO', '2', '860', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16175, '2020-06-25', 'TD', 'Chad', 'AFRO', '0', '860', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16176, '2020-06-26', 'TD', 'Chad', 'AFRO', '3', '863', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16177, '2020-06-27', 'TD', 'Chad', 'AFRO', '2', '865', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16178, '2020-06-28', 'TD', 'Chad', 'AFRO', '0', '865', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16179, '2020-06-29', 'TD', 'Chad', 'AFRO', '1', '866', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16180, '2020-06-30', 'TD', 'Chad', 'AFRO', '0', '866', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16181, '2020-07-01', 'TD', 'Chad', 'AFRO', '0', '866', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16182, '2020-07-02', 'TD', 'Chad', 'AFRO', '0', '866', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16183, '2020-07-03', 'TD', 'Chad', 'AFRO', '2', '868', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16184, '2020-07-04', 'TD', 'Chad', 'AFRO', '3', '871', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16185, '2020-07-05', 'TD', 'Chad', 'AFRO', '0', '871', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16186, '2020-07-06', 'TD', 'Chad', 'AFRO', '1', '872', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16187, '2020-07-07', 'TD', 'Chad', 'AFRO', '0', '872', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16188, '2020-07-08', 'TD', 'Chad', 'AFRO', '1', '873', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16189, '2020-07-09', 'TD', 'Chad', 'AFRO', '0', '873', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16190, '2020-07-10', 'TD', 'Chad', 'AFRO', '0', '873', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16191, '2020-07-11', 'TD', 'Chad', 'AFRO', '1', '874', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16192, '2020-07-12', 'TD', 'Chad', 'AFRO', '0', '874', '0', '74');
INSERT INTO public.who_global_data_import VALUES (16193, '2020-07-13', 'TD', 'Chad', 'AFRO', '6', '880', '1', '75');
INSERT INTO public.who_global_data_import VALUES (16194, '2020-07-14', 'TD', 'Chad', 'AFRO', '0', '880', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16195, '2020-07-15', 'TD', 'Chad', 'AFRO', '4', '884', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16196, '2020-07-16', 'TD', 'Chad', 'AFRO', '1', '885', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16197, '2020-07-17', 'TD', 'Chad', 'AFRO', '1', '886', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16198, '2020-07-18', 'TD', 'Chad', 'AFRO', '1', '887', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16199, '2020-07-19', 'TD', 'Chad', 'AFRO', '2', '889', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16200, '2020-07-20', 'TD', 'Chad', 'AFRO', '0', '889', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16201, '2020-07-21', 'TD', 'Chad', 'AFRO', '0', '889', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16202, '2020-07-22', 'TD', 'Chad', 'AFRO', '0', '889', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16203, '2020-07-23', 'TD', 'Chad', 'AFRO', '0', '889', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16204, '2020-07-24', 'TD', 'Chad', 'AFRO', '26', '915', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16205, '2020-07-25', 'TD', 'Chad', 'AFRO', '0', '915', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16206, '2020-07-26', 'TD', 'Chad', 'AFRO', '0', '915', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16207, '2020-07-27', 'TD', 'Chad', 'AFRO', '0', '915', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16208, '2020-07-28', 'TD', 'Chad', 'AFRO', '7', '922', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16209, '2020-07-29', 'TD', 'Chad', 'AFRO', '4', '926', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16210, '2020-07-30', 'TD', 'Chad', 'AFRO', '0', '926', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16211, '2020-07-31', 'TD', 'Chad', 'AFRO', '9', '935', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16212, '2020-08-01', 'TD', 'Chad', 'AFRO', '1', '936', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16213, '2020-08-02', 'TD', 'Chad', 'AFRO', '0', '936', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16214, '2020-08-03', 'TD', 'Chad', 'AFRO', '0', '936', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16215, '2020-08-04', 'TD', 'Chad', 'AFRO', '0', '936', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16216, '2020-08-05', 'TD', 'Chad', 'AFRO', '2', '938', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16217, '2020-08-06', 'TD', 'Chad', 'AFRO', '1', '939', '0', '75');
INSERT INTO public.who_global_data_import VALUES (16218, '2020-08-07', 'TD', 'Chad', 'AFRO', '3', '942', '1', '76');
INSERT INTO public.who_global_data_import VALUES (16219, '2020-08-08', 'TD', 'Chad', 'AFRO', '0', '942', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16220, '2020-08-09', 'TD', 'Chad', 'AFRO', '0', '942', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16221, '2020-08-10', 'TD', 'Chad', 'AFRO', '2', '944', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16222, '2020-08-11', 'TD', 'Chad', 'AFRO', '1', '945', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16223, '2020-08-12', 'TD', 'Chad', 'AFRO', '1', '946', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16224, '2020-08-13', 'TD', 'Chad', 'AFRO', '3', '949', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16225, '2020-08-14', 'TD', 'Chad', 'AFRO', '0', '949', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16226, '2020-08-15', 'TD', 'Chad', 'AFRO', '2', '951', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16227, '2020-08-16', 'TD', 'Chad', 'AFRO', '1', '952', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16228, '2020-08-17', 'TD', 'Chad', 'AFRO', '4', '956', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16229, '2020-08-18', 'TD', 'Chad', 'AFRO', '3', '959', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16230, '2020-08-19', 'TD', 'Chad', 'AFRO', '11', '970', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16231, '2020-08-20', 'TD', 'Chad', 'AFRO', '1', '971', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16232, '2020-08-21', 'TD', 'Chad', 'AFRO', '1', '972', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16233, '2020-08-22', 'TD', 'Chad', 'AFRO', '9', '981', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16234, '2020-08-23', 'TD', 'Chad', 'AFRO', '1', '982', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16235, '2020-08-24', 'TD', 'Chad', 'AFRO', '4', '986', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16236, '2020-08-25', 'TD', 'Chad', 'AFRO', '1', '987', '0', '76');
INSERT INTO public.who_global_data_import VALUES (16237, '2020-08-26', 'TD', 'Chad', 'AFRO', '8', '995', '1', '77');
INSERT INTO public.who_global_data_import VALUES (16238, '2020-08-27', 'TD', 'Chad', 'AFRO', '3', '998', '0', '77');
INSERT INTO public.who_global_data_import VALUES (16239, '2020-08-28', 'TD', 'Chad', 'AFRO', '6', '1004', '0', '77');
INSERT INTO public.who_global_data_import VALUES (16240, '2020-08-29', 'TD', 'Chad', 'AFRO', '4', '1008', '0', '77');
INSERT INTO public.who_global_data_import VALUES (16241, '2020-08-30', 'TD', 'Chad', 'AFRO', '0', '1008', '0', '77');
INSERT INTO public.who_global_data_import VALUES (16242, '2020-08-31', 'TD', 'Chad', 'AFRO', '4', '1012', '0', '77');
INSERT INTO public.who_global_data_import VALUES (16243, '2020-09-01', 'TD', 'Chad', 'AFRO', '1', '1013', '0', '77');
INSERT INTO public.who_global_data_import VALUES (16244, '2020-09-02', 'TD', 'Chad', 'AFRO', '4', '1017', '0', '77');
INSERT INTO public.who_global_data_import VALUES (16245, '2020-09-03', 'TD', 'Chad', 'AFRO', '0', '1017', '0', '77');
INSERT INTO public.who_global_data_import VALUES (16246, '2020-09-04', 'TD', 'Chad', 'AFRO', '1', '1018', '0', '77');
INSERT INTO public.who_global_data_import VALUES (16247, '2020-09-05', 'TD', 'Chad', 'AFRO', '5', '1023', '0', '77');
INSERT INTO public.who_global_data_import VALUES (16248, '2020-09-06', 'TD', 'Chad', 'AFRO', '11', '1034', '0', '77');
INSERT INTO public.who_global_data_import VALUES (16249, '2020-09-07', 'TD', 'Chad', 'AFRO', '5', '1039', '2', '79');
INSERT INTO public.who_global_data_import VALUES (16250, '2020-09-08', 'TD', 'Chad', 'AFRO', '1', '1040', '0', '79');
INSERT INTO public.who_global_data_import VALUES (16251, '2020-09-09', 'TD', 'Chad', 'AFRO', '5', '1045', '0', '79');
INSERT INTO public.who_global_data_import VALUES (16252, '2020-09-10', 'TD', 'Chad', 'AFRO', '3', '1048', '0', '79');
INSERT INTO public.who_global_data_import VALUES (16253, '2020-09-11', 'TD', 'Chad', 'AFRO', '3', '1051', '0', '79');
INSERT INTO public.who_global_data_import VALUES (16254, '2020-09-12', 'TD', 'Chad', 'AFRO', '30', '1081', '0', '79');
INSERT INTO public.who_global_data_import VALUES (16255, '2020-09-13', 'TD', 'Chad', 'AFRO', '2', '1083', '1', '80');
INSERT INTO public.who_global_data_import VALUES (16256, '2020-09-14', 'TD', 'Chad', 'AFRO', '1', '1084', '0', '80');
INSERT INTO public.who_global_data_import VALUES (16257, '2020-09-15', 'TD', 'Chad', 'AFRO', '1', '1085', '1', '81');
INSERT INTO public.who_global_data_import VALUES (16258, '2020-09-16', 'TD', 'Chad', 'AFRO', '2', '1087', '0', '81');
INSERT INTO public.who_global_data_import VALUES (16259, '2020-09-17', 'TD', 'Chad', 'AFRO', '3', '1090', '0', '81');
INSERT INTO public.who_global_data_import VALUES (16260, '2020-09-18', 'TD', 'Chad', 'AFRO', '25', '1115', '0', '81');
INSERT INTO public.who_global_data_import VALUES (16261, '2020-09-19', 'TD', 'Chad', 'AFRO', '32', '1147', '0', '81');
INSERT INTO public.who_global_data_import VALUES (16262, '2020-09-20', 'TD', 'Chad', 'AFRO', '2', '1149', '0', '81');
INSERT INTO public.who_global_data_import VALUES (16263, '2020-09-21', 'TD', 'Chad', 'AFRO', '2', '1151', '0', '81');
INSERT INTO public.who_global_data_import VALUES (16264, '2020-09-22', 'TD', 'Chad', 'AFRO', '2', '1153', '0', '81');
INSERT INTO public.who_global_data_import VALUES (16265, '2020-09-23', 'TD', 'Chad', 'AFRO', '2', '1155', '0', '81');
INSERT INTO public.who_global_data_import VALUES (16266, '2020-09-24', 'TD', 'Chad', 'AFRO', '9', '1164', '1', '82');
INSERT INTO public.who_global_data_import VALUES (16267, '2020-09-25', 'TD', 'Chad', 'AFRO', '7', '1171', '0', '82');
INSERT INTO public.who_global_data_import VALUES (16268, '2020-09-26', 'TD', 'Chad', 'AFRO', '4', '1175', '1', '83');
INSERT INTO public.who_global_data_import VALUES (16269, '2020-09-27', 'TD', 'Chad', 'AFRO', '2', '1177', '0', '83');
INSERT INTO public.who_global_data_import VALUES (16270, '2020-09-28', 'TD', 'Chad', 'AFRO', '1', '1178', '1', '84');
INSERT INTO public.who_global_data_import VALUES (16271, '2020-09-29', 'TD', 'Chad', 'AFRO', '7', '1185', '1', '85');
INSERT INTO public.who_global_data_import VALUES (16272, '2020-09-30', 'TD', 'Chad', 'AFRO', '8', '1193', '0', '85');
INSERT INTO public.who_global_data_import VALUES (16273, '2020-10-01', 'TD', 'Chad', 'AFRO', '7', '1200', '0', '85');
INSERT INTO public.who_global_data_import VALUES (16274, '2020-10-02', 'TD', 'Chad', 'AFRO', '3', '1203', '0', '85');
INSERT INTO public.who_global_data_import VALUES (16275, '2020-10-03', 'TD', 'Chad', 'AFRO', '8', '1211', '0', '85');
INSERT INTO public.who_global_data_import VALUES (16276, '2020-10-04', 'TD', 'Chad', 'AFRO', '0', '1211', '0', '85');
INSERT INTO public.who_global_data_import VALUES (16277, '2020-10-05', 'TD', 'Chad', 'AFRO', '6', '1217', '1', '86');
INSERT INTO public.who_global_data_import VALUES (16278, '2020-10-06', 'TD', 'Chad', 'AFRO', '6', '1223', '0', '86');
INSERT INTO public.who_global_data_import VALUES (16279, '2020-10-07', 'TD', 'Chad', 'AFRO', '15', '1238', '2', '88');
INSERT INTO public.who_global_data_import VALUES (16280, '2020-10-08', 'TD', 'Chad', 'AFRO', '13', '1251', '1', '89');
INSERT INTO public.who_global_data_import VALUES (16281, '2020-10-09', 'TD', 'Chad', 'AFRO', '11', '1262', '0', '89');
INSERT INTO public.who_global_data_import VALUES (16282, '2020-10-10', 'TD', 'Chad', 'AFRO', '12', '1274', '1', '90');
INSERT INTO public.who_global_data_import VALUES (16283, '2020-10-11', 'TD', 'Chad', 'AFRO', '17', '1291', '2', '92');
INSERT INTO public.who_global_data_import VALUES (16284, '2020-10-12', 'TD', 'Chad', 'AFRO', '13', '1304', '0', '92');
INSERT INTO public.who_global_data_import VALUES (16285, '2020-10-13', 'TD', 'Chad', 'AFRO', '4', '1308', '0', '92');
INSERT INTO public.who_global_data_import VALUES (16286, '2020-10-14', 'TD', 'Chad', 'AFRO', '13', '1321', '0', '92');
INSERT INTO public.who_global_data_import VALUES (16287, '2020-10-15', 'TD', 'Chad', 'AFRO', '8', '1329', '0', '92');
INSERT INTO public.who_global_data_import VALUES (16288, '2020-10-16', 'TD', 'Chad', 'AFRO', '21', '1350', '0', '92');
INSERT INTO public.who_global_data_import VALUES (16289, '2020-10-17', 'TD', 'Chad', 'AFRO', '11', '1361', '1', '93');
INSERT INTO public.who_global_data_import VALUES (16290, '2020-10-18', 'TD', 'Chad', 'AFRO', '4', '1365', '0', '93');
INSERT INTO public.who_global_data_import VALUES (16291, '2020-10-19', 'TD', 'Chad', 'AFRO', '14', '1379', '0', '93');
INSERT INTO public.who_global_data_import VALUES (16292, '2020-10-20', 'TD', 'Chad', 'AFRO', '11', '1390', '0', '93');
INSERT INTO public.who_global_data_import VALUES (16293, '2020-10-21', 'TD', 'Chad', 'AFRO', '9', '1399', '0', '93');
INSERT INTO public.who_global_data_import VALUES (16294, '2020-10-22', 'TD', 'Chad', 'AFRO', '5', '1404', '3', '96');
INSERT INTO public.who_global_data_import VALUES (16295, '2020-10-23', 'TD', 'Chad', 'AFRO', '6', '1410', '0', '96');
INSERT INTO public.who_global_data_import VALUES (16296, '2020-10-24', 'TD', 'Chad', 'AFRO', '13', '1423', '0', '96');
INSERT INTO public.who_global_data_import VALUES (16297, '2020-10-25', 'TD', 'Chad', 'AFRO', '11', '1434', '0', '96');
INSERT INTO public.who_global_data_import VALUES (16298, '2020-10-26', 'TD', 'Chad', 'AFRO', '3', '1437', '0', '96');
INSERT INTO public.who_global_data_import VALUES (16299, '2020-10-27', 'TD', 'Chad', 'AFRO', '4', '1441', '0', '96');
INSERT INTO public.who_global_data_import VALUES (16300, '2020-10-28', 'TD', 'Chad', 'AFRO', '19', '1460', '0', '96');
INSERT INTO public.who_global_data_import VALUES (16301, '2020-10-29', 'TD', 'Chad', 'AFRO', '8', '1468', '1', '97');
INSERT INTO public.who_global_data_import VALUES (16302, '2020-10-30', 'TD', 'Chad', 'AFRO', '5', '1473', '0', '97');
INSERT INTO public.who_global_data_import VALUES (16303, '2020-10-31', 'TD', 'Chad', 'AFRO', '10', '1483', '1', '98');
INSERT INTO public.who_global_data_import VALUES (16304, '2020-11-01', 'TD', 'Chad', 'AFRO', '0', '1483', '0', '98');
INSERT INTO public.who_global_data_import VALUES (16305, '2020-11-02', 'TD', 'Chad', 'AFRO', '15', '1498', '0', '98');
INSERT INTO public.who_global_data_import VALUES (16306, '2020-11-03', 'TD', 'Chad', 'AFRO', '1', '1499', '0', '98');
INSERT INTO public.who_global_data_import VALUES (16307, '2020-11-04', 'TD', 'Chad', 'AFRO', '14', '1513', '0', '98');
INSERT INTO public.who_global_data_import VALUES (16308, '2020-11-05', 'TD', 'Chad', 'AFRO', '4', '1517', '1', '99');
INSERT INTO public.who_global_data_import VALUES (16309, '2020-11-06', 'TD', 'Chad', 'AFRO', '12', '1529', '0', '99');
INSERT INTO public.who_global_data_import VALUES (16310, '2020-11-07', 'TD', 'Chad', 'AFRO', '9', '1538', '0', '99');
INSERT INTO public.who_global_data_import VALUES (16311, '2020-11-08', 'TD', 'Chad', 'AFRO', '5', '1543', '0', '99');
INSERT INTO public.who_global_data_import VALUES (16312, '2020-11-09', 'TD', 'Chad', 'AFRO', '4', '1547', '0', '99');
INSERT INTO public.who_global_data_import VALUES (16313, '2020-11-10', 'TD', 'Chad', 'AFRO', '4', '1551', '0', '99');
INSERT INTO public.who_global_data_import VALUES (16314, '2020-11-11', 'TD', 'Chad', 'AFRO', '10', '1561', '0', '99');
INSERT INTO public.who_global_data_import VALUES (16315, '2020-11-12', 'TD', 'Chad', 'AFRO', '4', '1565', '0', '99');
INSERT INTO public.who_global_data_import VALUES (16316, '2020-11-13', 'TD', 'Chad', 'AFRO', '13', '1578', '1', '100');
INSERT INTO public.who_global_data_import VALUES (16317, '2020-11-14', 'TD', 'Chad', 'AFRO', '11', '1589', '0', '100');
INSERT INTO public.who_global_data_import VALUES (16318, '2020-11-15', 'TD', 'Chad', 'AFRO', '2', '1591', '0', '100');
INSERT INTO public.who_global_data_import VALUES (16319, '2020-11-16', 'TD', 'Chad', 'AFRO', '6', '1597', '1', '101');
INSERT INTO public.who_global_data_import VALUES (16320, '2020-11-17', 'TD', 'Chad', 'AFRO', '6', '1603', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16321, '2020-11-18', 'TD', 'Chad', 'AFRO', '5', '1608', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16322, '2020-11-19', 'TD', 'Chad', 'AFRO', '8', '1616', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16323, '2020-11-20', 'TD', 'Chad', 'AFRO', '4', '1620', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16324, '2020-11-21', 'TD', 'Chad', 'AFRO', '6', '1626', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16325, '2020-11-22', 'TD', 'Chad', 'AFRO', '7', '1633', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16326, '2020-11-23', 'TD', 'Chad', 'AFRO', '9', '1642', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16327, '2020-11-24', 'TD', 'Chad', 'AFRO', '6', '1648', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16328, '2020-11-25', 'TD', 'Chad', 'AFRO', '1', '1649', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16329, '2020-11-26', 'TD', 'Chad', 'AFRO', '6', '1655', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16330, '2020-11-27', 'TD', 'Chad', 'AFRO', '6', '1661', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16331, '2020-11-28', 'TD', 'Chad', 'AFRO', '2', '1663', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16332, '2020-11-29', 'TD', 'Chad', 'AFRO', '0', '1663', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16333, '2020-11-30', 'TD', 'Chad', 'AFRO', '19', '1682', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16334, '2020-12-01', 'TD', 'Chad', 'AFRO', '6', '1688', '0', '101');
INSERT INTO public.who_global_data_import VALUES (16335, '2020-12-02', 'TD', 'Chad', 'AFRO', '12', '1700', '1', '102');
INSERT INTO public.who_global_data_import VALUES (16336, '2020-12-03', 'TD', 'Chad', 'AFRO', '5', '1705', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16337, '2020-12-04', 'TD', 'Chad', 'AFRO', '3', '1708', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16338, '2020-12-05', 'TD', 'Chad', 'AFRO', '11', '1719', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16339, '2020-12-06', 'TD', 'Chad', 'AFRO', '3', '1722', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16340, '2020-12-07', 'TD', 'Chad', 'AFRO', '3', '1725', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16341, '2020-12-08', 'TD', 'Chad', 'AFRO', '3', '1728', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16342, '2020-12-09', 'TD', 'Chad', 'AFRO', '0', '1728', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16343, '2020-12-10', 'TD', 'Chad', 'AFRO', '4', '1732', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16344, '2020-12-11', 'TD', 'Chad', 'AFRO', '7', '1739', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16345, '2020-12-12', 'TD', 'Chad', 'AFRO', '0', '1739', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16346, '2020-12-13', 'TD', 'Chad', 'AFRO', '0', '1739', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16347, '2020-12-14', 'TD', 'Chad', 'AFRO', '31', '1770', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16348, '2020-12-15', 'TD', 'Chad', 'AFRO', '1', '1771', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16349, '2020-12-16', 'TD', 'Chad', 'AFRO', '13', '1784', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16350, '2020-12-17', 'TD', 'Chad', 'AFRO', '0', '1784', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16351, '2020-12-18', 'TD', 'Chad', 'AFRO', '34', '1818', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16352, '2020-12-19', 'TD', 'Chad', 'AFRO', '21', '1839', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16467, '2020-03-09', 'CL', 'Chile', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16353, '2020-12-20', 'TD', 'Chad', 'AFRO', '28', '1867', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16354, '2020-12-21', 'TD', 'Chad', 'AFRO', '23', '1890', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16355, '2020-12-22', 'TD', 'Chad', 'AFRO', '12', '1902', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16356, '2020-12-23', 'TD', 'Chad', 'AFRO', '14', '1916', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16357, '2020-12-24', 'TD', 'Chad', 'AFRO', '0', '1916', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16358, '2020-12-25', 'TD', 'Chad', 'AFRO', '42', '1958', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16359, '2020-12-26', 'TD', 'Chad', 'AFRO', '13', '1971', '0', '102');
INSERT INTO public.who_global_data_import VALUES (16360, '2020-12-27', 'TD', 'Chad', 'AFRO', '15', '1986', '1', '103');
INSERT INTO public.who_global_data_import VALUES (16361, '2020-12-28', 'TD', 'Chad', 'AFRO', '0', '1986', '0', '103');
INSERT INTO public.who_global_data_import VALUES (16362, '2020-12-29', 'TD', 'Chad', 'AFRO', '29', '2015', '1', '104');
INSERT INTO public.who_global_data_import VALUES (16363, '2020-12-30', 'TD', 'Chad', 'AFRO', '0', '2015', '0', '104');
INSERT INTO public.who_global_data_import VALUES (16364, '2020-12-31', 'TD', 'Chad', 'AFRO', '62', '2077', '0', '104');
INSERT INTO public.who_global_data_import VALUES (16365, '2021-01-01', 'TD', 'Chad', 'AFRO', '36', '2113', '0', '104');
INSERT INTO public.who_global_data_import VALUES (16366, '2021-01-02', 'TD', 'Chad', 'AFRO', '0', '2113', '0', '104');
INSERT INTO public.who_global_data_import VALUES (16367, '2021-01-03', 'TD', 'Chad', 'AFRO', '56', '2169', '0', '104');
INSERT INTO public.who_global_data_import VALUES (16368, '2021-01-04', 'TD', 'Chad', 'AFRO', '44', '2213', '0', '104');
INSERT INTO public.who_global_data_import VALUES (16369, '2021-01-05', 'TD', 'Chad', 'AFRO', '16', '2229', '0', '104');
INSERT INTO public.who_global_data_import VALUES (16370, '2021-01-06', 'TD', 'Chad', 'AFRO', '60', '2289', '1', '105');
INSERT INTO public.who_global_data_import VALUES (16371, '2021-01-07', 'TD', 'Chad', 'AFRO', '39', '2328', '0', '105');
INSERT INTO public.who_global_data_import VALUES (16372, '2021-01-08', 'TD', 'Chad', 'AFRO', '30', '2358', '0', '105');
INSERT INTO public.who_global_data_import VALUES (16373, '2021-01-09', 'TD', 'Chad', 'AFRO', '61', '2419', '1', '106');
INSERT INTO public.who_global_data_import VALUES (16374, '2021-01-10', 'TD', 'Chad', 'AFRO', '91', '2510', '1', '107');
INSERT INTO public.who_global_data_import VALUES (16375, '2021-01-11', 'TD', 'Chad', 'AFRO', '27', '2537', '0', '107');
INSERT INTO public.who_global_data_import VALUES (16376, '2021-01-12', 'TD', 'Chad', 'AFRO', '52', '2589', '0', '107');
INSERT INTO public.who_global_data_import VALUES (16377, '2021-01-13', 'TD', 'Chad', 'AFRO', '79', '2668', '1', '108');
INSERT INTO public.who_global_data_import VALUES (16378, '2021-01-14', 'TD', 'Chad', 'AFRO', '41', '2709', '1', '109');
INSERT INTO public.who_global_data_import VALUES (16379, '2021-01-15', 'TD', 'Chad', 'AFRO', '64', '2773', '1', '110');
INSERT INTO public.who_global_data_import VALUES (16380, '2021-01-16', 'TD', 'Chad', 'AFRO', '34', '2807', '1', '111');
INSERT INTO public.who_global_data_import VALUES (16381, '2021-01-17', 'TD', 'Chad', 'AFRO', '48', '2855', '0', '111');
INSERT INTO public.who_global_data_import VALUES (16382, '2021-01-18', 'TD', 'Chad', 'AFRO', '40', '2895', '0', '111');
INSERT INTO public.who_global_data_import VALUES (16383, '2021-01-19', 'TD', 'Chad', 'AFRO', '24', '2919', '2', '113');
INSERT INTO public.who_global_data_import VALUES (16384, '2021-01-20', 'TD', 'Chad', 'AFRO', '58', '2977', '1', '114');
INSERT INTO public.who_global_data_import VALUES (16385, '2021-01-21', 'TD', 'Chad', 'AFRO', '35', '3012', '0', '114');
INSERT INTO public.who_global_data_import VALUES (16386, '2021-01-22', 'TD', 'Chad', 'AFRO', '53', '3065', '0', '114');
INSERT INTO public.who_global_data_import VALUES (16387, '2021-01-23', 'TD', 'Chad', 'AFRO', '39', '3104', '1', '115');
INSERT INTO public.who_global_data_import VALUES (16388, '2021-01-24', 'TD', 'Chad', 'AFRO', '33', '3137', '0', '115');
INSERT INTO public.who_global_data_import VALUES (16389, '2021-01-25', 'TD', 'Chad', 'AFRO', '24', '3161', '1', '116');
INSERT INTO public.who_global_data_import VALUES (16390, '2021-01-26', 'TD', 'Chad', 'AFRO', '21', '3182', '0', '116');
INSERT INTO public.who_global_data_import VALUES (16391, '2021-01-27', 'TD', 'Chad', 'AFRO', '43', '3225', '0', '116');
INSERT INTO public.who_global_data_import VALUES (16392, '2021-01-28', 'TD', 'Chad', 'AFRO', '44', '3269', '1', '117');
INSERT INTO public.who_global_data_import VALUES (16393, '2021-01-29', 'TD', 'Chad', 'AFRO', '27', '3296', '1', '118');
INSERT INTO public.who_global_data_import VALUES (16394, '2021-01-30', 'TD', 'Chad', 'AFRO', '25', '3321', '0', '118');
INSERT INTO public.who_global_data_import VALUES (16395, '2021-01-31', 'TD', 'Chad', 'AFRO', '26', '3347', '0', '118');
INSERT INTO public.who_global_data_import VALUES (16396, '2021-02-01', 'TD', 'Chad', 'AFRO', '29', '3376', '0', '118');
INSERT INTO public.who_global_data_import VALUES (16397, '2021-02-02', 'TD', 'Chad', 'AFRO', '9', '3385', '3', '121');
INSERT INTO public.who_global_data_import VALUES (16398, '2021-02-03', 'TD', 'Chad', 'AFRO', '19', '3404', '0', '121');
INSERT INTO public.who_global_data_import VALUES (16399, '2021-02-04', 'TD', 'Chad', 'AFRO', '15', '3419', '0', '121');
INSERT INTO public.who_global_data_import VALUES (16400, '2021-02-05', 'TD', 'Chad', 'AFRO', '14', '3433', '0', '121');
INSERT INTO public.who_global_data_import VALUES (16401, '2020-01-03', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16402, '2020-01-04', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16403, '2020-01-05', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16404, '2020-01-06', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16405, '2020-01-07', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16406, '2020-01-08', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16407, '2020-01-09', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16408, '2020-01-10', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16409, '2020-01-11', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16410, '2020-01-12', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16411, '2020-01-13', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16412, '2020-01-14', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16413, '2020-01-15', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16414, '2020-01-16', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16415, '2020-01-17', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16416, '2020-01-18', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16417, '2020-01-19', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16418, '2020-01-20', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16419, '2020-01-21', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16420, '2020-01-22', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16421, '2020-01-23', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16422, '2020-01-24', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16423, '2020-01-25', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16424, '2020-01-26', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16425, '2020-01-27', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16426, '2020-01-28', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16427, '2020-01-29', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16428, '2020-01-30', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16429, '2020-01-31', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16430, '2020-02-01', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16431, '2020-02-02', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16432, '2020-02-03', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16433, '2020-02-04', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16434, '2020-02-05', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16435, '2020-02-06', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16436, '2020-02-07', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16437, '2020-02-08', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16438, '2020-02-09', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16439, '2020-02-10', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16440, '2020-02-11', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16441, '2020-02-12', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16442, '2020-02-13', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16443, '2020-02-14', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16444, '2020-02-15', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16445, '2020-02-16', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16446, '2020-02-17', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16447, '2020-02-18', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16448, '2020-02-19', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16449, '2020-02-20', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16450, '2020-02-21', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16451, '2020-02-22', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16452, '2020-02-23', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16453, '2020-02-24', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16454, '2020-02-25', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16455, '2020-02-26', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16456, '2020-02-27', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16457, '2020-02-28', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16458, '2020-02-29', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16459, '2020-03-01', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16460, '2020-03-02', 'CL', 'Chile', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16461, '2020-03-03', 'CL', 'Chile', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16462, '2020-03-04', 'CL', 'Chile', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16463, '2020-03-05', 'CL', 'Chile', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16464, '2020-03-06', 'CL', 'Chile', 'AMRO', '4', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16465, '2020-03-07', 'CL', 'Chile', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16466, '2020-03-08', 'CL', 'Chile', 'AMRO', '5', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16468, '2020-03-10', 'CL', 'Chile', 'AMRO', '3', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16469, '2020-03-11', 'CL', 'Chile', 'AMRO', '4', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16470, '2020-03-12', 'CL', 'Chile', 'AMRO', '6', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16471, '2020-03-13', 'CL', 'Chile', 'AMRO', '20', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16472, '2020-03-14', 'CL', 'Chile', 'AMRO', '18', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16473, '2020-03-15', 'CL', 'Chile', 'AMRO', '0', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16474, '2020-03-16', 'CL', 'Chile', 'AMRO', '14', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16475, '2020-03-17', 'CL', 'Chile', 'AMRO', '81', '160', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16476, '2020-03-18', 'CL', 'Chile', 'AMRO', '82', '242', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16477, '2020-03-19', 'CL', 'Chile', 'AMRO', '100', '342', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16478, '2020-03-20', 'CL', 'Chile', 'AMRO', '92', '434', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16479, '2020-03-21', 'CL', 'Chile', 'AMRO', '0', '434', '1', '1');
INSERT INTO public.who_global_data_import VALUES (16480, '2020-03-22', 'CL', 'Chile', 'AMRO', '0', '434', '0', '1');
INSERT INTO public.who_global_data_import VALUES (16481, '2020-03-23', 'CL', 'Chile', 'AMRO', '198', '632', '0', '1');
INSERT INTO public.who_global_data_import VALUES (16482, '2020-03-24', 'CL', 'Chile', 'AMRO', '290', '922', '1', '2');
INSERT INTO public.who_global_data_import VALUES (16483, '2020-03-25', 'CL', 'Chile', 'AMRO', '0', '922', '0', '2');
INSERT INTO public.who_global_data_import VALUES (16484, '2020-03-26', 'CL', 'Chile', 'AMRO', '384', '1306', '2', '4');
INSERT INTO public.who_global_data_import VALUES (16485, '2020-03-27', 'CL', 'Chile', 'AMRO', '0', '1306', '0', '4');
INSERT INTO public.who_global_data_import VALUES (16486, '2020-03-28', 'CL', 'Chile', 'AMRO', '304', '1610', '1', '5');
INSERT INTO public.who_global_data_import VALUES (16487, '2020-03-29', 'CL', 'Chile', 'AMRO', '299', '1909', '1', '6');
INSERT INTO public.who_global_data_import VALUES (16488, '2020-03-30', 'CL', 'Chile', 'AMRO', '0', '1909', '0', '6');
INSERT INTO public.who_global_data_import VALUES (16489, '2020-03-31', 'CL', 'Chile', 'AMRO', '540', '2449', '2', '8');
INSERT INTO public.who_global_data_import VALUES (16490, '2020-04-01', 'CL', 'Chile', 'AMRO', '289', '2738', '4', '12');
INSERT INTO public.who_global_data_import VALUES (16491, '2020-04-02', 'CL', 'Chile', 'AMRO', '293', '3031', '4', '16');
INSERT INTO public.who_global_data_import VALUES (16492, '2020-04-03', 'CL', 'Chile', 'AMRO', '373', '3404', '2', '18');
INSERT INTO public.who_global_data_import VALUES (16493, '2020-04-04', 'CL', 'Chile', 'AMRO', '333', '3737', '4', '22');
INSERT INTO public.who_global_data_import VALUES (16494, '2020-04-05', 'CL', 'Chile', 'AMRO', '424', '4161', '5', '27');
INSERT INTO public.who_global_data_import VALUES (16495, '2020-04-06', 'CL', 'Chile', 'AMRO', '310', '4471', '7', '34');
INSERT INTO public.who_global_data_import VALUES (16496, '2020-04-07', 'CL', 'Chile', 'AMRO', '344', '4815', '3', '37');
INSERT INTO public.who_global_data_import VALUES (16497, '2020-04-08', 'CL', 'Chile', 'AMRO', '301', '5116', '6', '43');
INSERT INTO public.who_global_data_import VALUES (16498, '2020-04-09', 'CL', 'Chile', 'AMRO', '430', '5546', '5', '48');
INSERT INTO public.who_global_data_import VALUES (16499, '2020-04-10', 'CL', 'Chile', 'AMRO', '426', '5972', '9', '57');
INSERT INTO public.who_global_data_import VALUES (16500, '2020-04-11', 'CL', 'Chile', 'AMRO', '529', '6501', '8', '65');
INSERT INTO public.who_global_data_import VALUES (16501, '2020-04-12', 'CL', 'Chile', 'AMRO', '426', '6927', '8', '73');
INSERT INTO public.who_global_data_import VALUES (16502, '2020-04-13', 'CL', 'Chile', 'AMRO', '286', '7213', '7', '80');
INSERT INTO public.who_global_data_import VALUES (16503, '2020-04-14', 'CL', 'Chile', 'AMRO', '312', '7525', '2', '82');
INSERT INTO public.who_global_data_import VALUES (16504, '2020-04-15', 'CL', 'Chile', 'AMRO', '392', '7917', '10', '92');
INSERT INTO public.who_global_data_import VALUES (16505, '2020-04-16', 'CL', 'Chile', 'AMRO', '356', '8273', '2', '94');
INSERT INTO public.who_global_data_import VALUES (16506, '2020-04-17', 'CL', 'Chile', 'AMRO', '534', '8807', '11', '105');
INSERT INTO public.who_global_data_import VALUES (16507, '2020-04-18', 'CL', 'Chile', 'AMRO', '445', '9252', '11', '116');
INSERT INTO public.who_global_data_import VALUES (16508, '2020-04-19', 'CL', 'Chile', 'AMRO', '478', '9730', '10', '126');
INSERT INTO public.who_global_data_import VALUES (16509, '2020-04-20', 'CL', 'Chile', 'AMRO', '358', '10088', '7', '133');
INSERT INTO public.who_global_data_import VALUES (16510, '2020-04-21', 'CL', 'Chile', 'AMRO', '419', '10507', '6', '139');
INSERT INTO public.who_global_data_import VALUES (16511, '2020-04-22', 'CL', 'Chile', 'AMRO', '325', '10832', '8', '147');
INSERT INTO public.who_global_data_import VALUES (16512, '2020-04-23', 'CL', 'Chile', 'AMRO', '464', '11296', '13', '160');
INSERT INTO public.who_global_data_import VALUES (16513, '2020-04-24', 'CL', 'Chile', 'AMRO', '516', '11812', '8', '168');
INSERT INTO public.who_global_data_import VALUES (16514, '2020-04-25', 'CL', 'Chile', 'AMRO', '494', '12306', '6', '174');
INSERT INTO public.who_global_data_import VALUES (16515, '2020-04-26', 'CL', 'Chile', 'AMRO', '552', '12858', '7', '181');
INSERT INTO public.who_global_data_import VALUES (16516, '2020-04-27', 'CL', 'Chile', 'AMRO', '473', '13331', '8', '189');
INSERT INTO public.who_global_data_import VALUES (16517, '2020-04-28', 'CL', 'Chile', 'AMRO', '482', '13813', '9', '198');
INSERT INTO public.who_global_data_import VALUES (16518, '2020-04-29', 'CL', 'Chile', 'AMRO', '552', '14365', '9', '207');
INSERT INTO public.who_global_data_import VALUES (16519, '2020-04-30', 'CL', 'Chile', 'AMRO', '520', '14885', '9', '216');
INSERT INTO public.who_global_data_import VALUES (16520, '2020-05-01', 'CL', 'Chile', 'AMRO', '1138', '16023', '11', '227');
INSERT INTO public.who_global_data_import VALUES (16521, '2020-05-02', 'CL', 'Chile', 'AMRO', '985', '17008', '7', '234');
INSERT INTO public.who_global_data_import VALUES (16522, '2020-05-03', 'CL', 'Chile', 'AMRO', '1427', '18435', '13', '247');
INSERT INTO public.who_global_data_import VALUES (16523, '2020-05-04', 'CL', 'Chile', 'AMRO', '1228', '19663', '13', '260');
INSERT INTO public.who_global_data_import VALUES (16524, '2020-05-05', 'CL', 'Chile', 'AMRO', '980', '20643', '10', '270');
INSERT INTO public.who_global_data_import VALUES (16525, '2020-05-06', 'CL', 'Chile', 'AMRO', '1373', '22016', '5', '275');
INSERT INTO public.who_global_data_import VALUES (16526, '2020-05-07', 'CL', 'Chile', 'AMRO', '1032', '23048', '6', '281');
INSERT INTO public.who_global_data_import VALUES (16527, '2020-05-08', 'CL', 'Chile', 'AMRO', '1533', '24581', '4', '285');
INSERT INTO public.who_global_data_import VALUES (16528, '2020-05-09', 'CL', 'Chile', 'AMRO', '1391', '25972', '9', '294');
INSERT INTO public.who_global_data_import VALUES (16529, '2020-05-10', 'CL', 'Chile', 'AMRO', '1247', '27219', '10', '304');
INSERT INTO public.who_global_data_import VALUES (16530, '2020-05-11', 'CL', 'Chile', 'AMRO', '1647', '28866', '8', '312');
INSERT INTO public.who_global_data_import VALUES (16531, '2020-05-12', 'CL', 'Chile', 'AMRO', '1197', '30063', '11', '323');
INSERT INTO public.who_global_data_import VALUES (16532, '2020-05-13', 'CL', 'Chile', 'AMRO', '1658', '31721', '12', '335');
INSERT INTO public.who_global_data_import VALUES (16533, '2020-05-14', 'CL', 'Chile', 'AMRO', '2660', '34381', '11', '346');
INSERT INTO public.who_global_data_import VALUES (16534, '2020-05-15', 'CL', 'Chile', 'AMRO', '2659', '37040', '22', '368');
INSERT INTO public.who_global_data_import VALUES (16535, '2020-05-16', 'CL', 'Chile', 'AMRO', '0', '37040', '0', '368');
INSERT INTO public.who_global_data_import VALUES (16536, '2020-05-17', 'CL', 'Chile', 'AMRO', '4388', '41428', '53', '421');
INSERT INTO public.who_global_data_import VALUES (16537, '2020-05-18', 'CL', 'Chile', 'AMRO', '2353', '43781', '29', '450');
INSERT INTO public.who_global_data_import VALUES (16538, '2020-05-19', 'CL', 'Chile', 'AMRO', '2278', '46059', '28', '478');
INSERT INTO public.who_global_data_import VALUES (16539, '2020-05-20', 'CL', 'Chile', 'AMRO', '0', '46059', '0', '478');
INSERT INTO public.who_global_data_import VALUES (16540, '2020-05-21', 'CL', 'Chile', 'AMRO', '7558', '53617', '66', '544');
INSERT INTO public.who_global_data_import VALUES (16541, '2020-05-22', 'CL', 'Chile', 'AMRO', '0', '53617', '0', '544');
INSERT INTO public.who_global_data_import VALUES (16542, '2020-05-23', 'CL', 'Chile', 'AMRO', '8240', '61857', '86', '630');
INSERT INTO public.who_global_data_import VALUES (16543, '2020-05-24', 'CL', 'Chile', 'AMRO', '3536', '65393', '43', '673');
INSERT INTO public.who_global_data_import VALUES (16544, '2020-05-25', 'CL', 'Chile', 'AMRO', '3709', '69102', '45', '718');
INSERT INTO public.who_global_data_import VALUES (16545, '2020-05-26', 'CL', 'Chile', 'AMRO', '4895', '73997', '43', '761');
INSERT INTO public.who_global_data_import VALUES (16546, '2020-05-27', 'CL', 'Chile', 'AMRO', '3964', '77961', '45', '806');
INSERT INTO public.who_global_data_import VALUES (16547, '2020-05-28', 'CL', 'Chile', 'AMRO', '4328', '82289', '35', '841');
INSERT INTO public.who_global_data_import VALUES (16548, '2020-05-29', 'CL', 'Chile', 'AMRO', '4654', '86943', '49', '890');
INSERT INTO public.who_global_data_import VALUES (16549, '2020-05-30', 'CL', 'Chile', 'AMRO', '3695', '90638', '54', '944');
INSERT INTO public.who_global_data_import VALUES (16550, '2020-05-31', 'CL', 'Chile', 'AMRO', '4220', '94858', '53', '997');
INSERT INTO public.who_global_data_import VALUES (16551, '2020-06-01', 'CL', 'Chile', 'AMRO', '4830', '99688', '57', '1054');
INSERT INTO public.who_global_data_import VALUES (16552, '2020-06-02', 'CL', 'Chile', 'AMRO', '5471', '105159', '59', '1113');
INSERT INTO public.who_global_data_import VALUES (16553, '2020-06-03', 'CL', 'Chile', 'AMRO', '3527', '108686', '75', '1188');
INSERT INTO public.who_global_data_import VALUES (16554, '2020-06-04', 'CL', 'Chile', 'AMRO', '4942', '113628', '87', '1275');
INSERT INTO public.who_global_data_import VALUES (16555, '2020-06-05', 'CL', 'Chile', 'AMRO', '4664', '118292', '81', '1356');
INSERT INTO public.who_global_data_import VALUES (16556, '2020-06-06', 'CL', 'Chile', 'AMRO', '4207', '122499', '92', '1448');
INSERT INTO public.who_global_data_import VALUES (16557, '2020-06-07', 'CL', 'Chile', 'AMRO', '5246', '127745', '93', '1541');
INSERT INTO public.who_global_data_import VALUES (16558, '2020-06-08', 'CL', 'Chile', 'AMRO', '6405', '134150', '96', '1637');
INSERT INTO public.who_global_data_import VALUES (16559, '2020-06-09', 'CL', 'Chile', 'AMRO', '4696', '138846', '627', '2264');
INSERT INTO public.who_global_data_import VALUES (16560, '2020-06-10', 'CL', 'Chile', 'AMRO', '3913', '142759', '19', '2283');
INSERT INTO public.who_global_data_import VALUES (16561, '2020-06-11', 'CL', 'Chile', 'AMRO', '5737', '148496', '192', '2475');
INSERT INTO public.who_global_data_import VALUES (16562, '2020-06-12', 'CL', 'Chile', 'AMRO', '5596', '154092', '173', '2648');
INSERT INTO public.who_global_data_import VALUES (16563, '2020-06-13', 'CL', 'Chile', 'AMRO', '6754', '160846', '222', '2870');
INSERT INTO public.who_global_data_import VALUES (16564, '2020-06-14', 'CL', 'Chile', 'AMRO', '6509', '167355', '231', '3101');
INSERT INTO public.who_global_data_import VALUES (16565, '2020-06-15', 'CL', 'Chile', 'AMRO', '6938', '174293', '222', '3323');
INSERT INTO public.who_global_data_import VALUES (16566, '2020-06-16', 'CL', 'Chile', 'AMRO', '5143', '179436', '39', '3362');
INSERT INTO public.who_global_data_import VALUES (16567, '2020-06-17', 'CL', 'Chile', 'AMRO', '5013', '184449', '21', '3383');
INSERT INTO public.who_global_data_import VALUES (16568, '2020-06-18', 'CL', 'Chile', 'AMRO', '36179', '220628', '232', '3615');
INSERT INTO public.who_global_data_import VALUES (16569, '2020-06-19', 'CL', 'Chile', 'AMRO', '4475', '225103', '226', '3841');
INSERT INTO public.who_global_data_import VALUES (16570, '2020-06-20', 'CL', 'Chile', 'AMRO', '6290', '231393', '252', '4093');
INSERT INTO public.who_global_data_import VALUES (16571, '2020-06-21', 'CL', 'Chile', 'AMRO', '5355', '236748', '202', '4295');
INSERT INTO public.who_global_data_import VALUES (16572, '2020-06-22', 'CL', 'Chile', 'AMRO', '5607', '242355', '184', '4479');
INSERT INTO public.who_global_data_import VALUES (16573, '2020-06-23', 'CL', 'Chile', 'AMRO', '4608', '246963', '23', '4502');
INSERT INTO public.who_global_data_import VALUES (16574, '2020-06-24', 'CL', 'Chile', 'AMRO', '3804', '250767', '3', '4505');
INSERT INTO public.who_global_data_import VALUES (16575, '2020-06-25', 'CL', 'Chile', 'AMRO', '3649', '254416', '226', '4731');
INSERT INTO public.who_global_data_import VALUES (16576, '2020-06-26', 'CL', 'Chile', 'AMRO', '4648', '259064', '172', '4903');
INSERT INTO public.who_global_data_import VALUES (16577, '2020-06-27', 'CL', 'Chile', 'AMRO', '4296', '263360', '165', '5068');
INSERT INTO public.who_global_data_import VALUES (16578, '2020-06-28', 'CL', 'Chile', 'AMRO', '4406', '267766', '279', '5347');
INSERT INTO public.who_global_data_import VALUES (16579, '2020-06-29', 'CL', 'Chile', 'AMRO', '4216', '271982', '162', '5509');
INSERT INTO public.who_global_data_import VALUES (16580, '2020-06-30', 'CL', 'Chile', 'AMRO', '4017', '275999', '66', '5575');
INSERT INTO public.who_global_data_import VALUES (16581, '2020-07-01', 'CL', 'Chile', 'AMRO', '3394', '279393', '113', '5688');
INSERT INTO public.who_global_data_import VALUES (16582, '2020-07-02', 'CL', 'Chile', 'AMRO', '2650', '282043', '65', '5753');
INSERT INTO public.who_global_data_import VALUES (16583, '2020-07-03', 'CL', 'Chile', 'AMRO', '2498', '284541', '167', '5920');
INSERT INTO public.who_global_data_import VALUES (16584, '2020-07-04', 'CL', 'Chile', 'AMRO', '3548', '288089', '131', '6051');
INSERT INTO public.who_global_data_import VALUES (16585, '2020-07-05', 'CL', 'Chile', 'AMRO', '3758', '291847', '141', '6192');
INSERT INTO public.who_global_data_import VALUES (16586, '2020-07-06', 'CL', 'Chile', 'AMRO', '3685', '295532', '116', '6308');
INSERT INTO public.who_global_data_import VALUES (16587, '2020-07-07', 'CL', 'Chile', 'AMRO', '3025', '298557', '76', '6384');
INSERT INTO public.who_global_data_import VALUES (16588, '2020-07-08', 'CL', 'Chile', 'AMRO', '2462', '301019', '50', '6434');
INSERT INTO public.who_global_data_import VALUES (16589, '2020-07-09', 'CL', 'Chile', 'AMRO', '2064', '303083', '139', '6573');
INSERT INTO public.who_global_data_import VALUES (16590, '2020-07-10', 'CL', 'Chile', 'AMRO', '3133', '306216', '109', '6682');
INSERT INTO public.who_global_data_import VALUES (16591, '2020-07-11', 'CL', 'Chile', 'AMRO', '3058', '309274', '99', '6781');
INSERT INTO public.who_global_data_import VALUES (16592, '2020-07-12', 'CL', 'Chile', 'AMRO', '2755', '312029', '100', '6881');
INSERT INTO public.who_global_data_import VALUES (16593, '2020-07-13', 'CL', 'Chile', 'AMRO', '3012', '315041', '98', '6979');
INSERT INTO public.who_global_data_import VALUES (16594, '2020-07-14', 'CL', 'Chile', 'AMRO', '2616', '317657', '45', '7024');
INSERT INTO public.who_global_data_import VALUES (16595, '2020-07-15', 'CL', 'Chile', 'AMRO', '1836', '319493', '45', '7069');
INSERT INTO public.who_global_data_import VALUES (16596, '2020-07-16', 'CL', 'Chile', 'AMRO', '1712', '321205', '117', '7186');
INSERT INTO public.who_global_data_import VALUES (16597, '2020-07-17', 'CL', 'Chile', 'AMRO', '2493', '323698', '104', '7290');
INSERT INTO public.who_global_data_import VALUES (16598, '2020-07-18', 'CL', 'Chile', 'AMRO', '2841', '326539', '1057', '8347');
INSERT INTO public.who_global_data_import VALUES (16599, '2020-07-19', 'CL', 'Chile', 'AMRO', '2307', '328846', '98', '8445');
INSERT INTO public.who_global_data_import VALUES (16600, '2020-07-20', 'CL', 'Chile', 'AMRO', '2084', '330930', '58', '8503');
INSERT INTO public.who_global_data_import VALUES (16601, '2020-07-21', 'CL', 'Chile', 'AMRO', '2099', '333029', '130', '8633');
INSERT INTO public.who_global_data_import VALUES (16602, '2020-07-22', 'CL', 'Chile', 'AMRO', '1654', '334683', '44', '8677');
INSERT INTO public.who_global_data_import VALUES (16603, '2020-07-23', 'CL', 'Chile', 'AMRO', '1719', '336402', '45', '8722');
INSERT INTO public.who_global_data_import VALUES (16604, '2020-07-24', 'CL', 'Chile', 'AMRO', '2357', '338759', '116', '8838');
INSERT INTO public.who_global_data_import VALUES (16605, '2020-07-25', 'CL', 'Chile', 'AMRO', '2545', '341304', '76', '8914');
INSERT INTO public.who_global_data_import VALUES (16606, '2020-07-26', 'CL', 'Chile', 'AMRO', '2288', '343592', '106', '9020');
INSERT INTO public.who_global_data_import VALUES (16607, '2020-07-27', 'CL', 'Chile', 'AMRO', '2198', '345790', '92', '9112');
INSERT INTO public.who_global_data_import VALUES (16608, '2020-07-28', 'CL', 'Chile', 'AMRO', '2133', '347923', '75', '9187');
INSERT INTO public.who_global_data_import VALUES (16609, '2020-07-29', 'CL', 'Chile', 'AMRO', '1877', '349800', '53', '9240');
INSERT INTO public.who_global_data_import VALUES (16610, '2020-07-30', 'CL', 'Chile', 'AMRO', '1775', '351575', '38', '9278');
INSERT INTO public.who_global_data_import VALUES (16611, '2020-07-31', 'CL', 'Chile', 'AMRO', '1961', '353536', '99', '9377');
INSERT INTO public.who_global_data_import VALUES (16612, '2020-08-01', 'CL', 'Chile', 'AMRO', '2131', '355667', '80', '9457');
INSERT INTO public.who_global_data_import VALUES (16613, '2020-08-02', 'CL', 'Chile', 'AMRO', '1991', '357658', '76', '9533');
INSERT INTO public.who_global_data_import VALUES (16614, '2020-08-03', 'CL', 'Chile', 'AMRO', '2073', '359731', '75', '9608');
INSERT INTO public.who_global_data_import VALUES (16615, '2020-08-04', 'CL', 'Chile', 'AMRO', '1762', '361493', '99', '9707');
INSERT INTO public.who_global_data_import VALUES (16616, '2020-08-05', 'CL', 'Chile', 'AMRO', '1469', '362962', '38', '9745');
INSERT INTO public.who_global_data_import VALUES (16617, '2020-08-06', 'CL', 'Chile', 'AMRO', '1761', '364723', '47', '9792');
INSERT INTO public.who_global_data_import VALUES (16618, '2020-08-07', 'CL', 'Chile', 'AMRO', '1948', '366671', '97', '9889');
INSERT INTO public.who_global_data_import VALUES (16619, '2020-08-08', 'CL', 'Chile', 'AMRO', '2154', '368825', '69', '9958');
INSERT INTO public.who_global_data_import VALUES (16620, '2020-08-09', 'CL', 'Chile', 'AMRO', '2198', '371023', '53', '10011');
INSERT INTO public.who_global_data_import VALUES (16621, '2020-08-10', 'CL', 'Chile', 'AMRO', '2033', '373056', '66', '10077');
INSERT INTO public.who_global_data_import VALUES (16622, '2020-08-11', 'CL', 'Chile', 'AMRO', '1988', '375044', '62', '10139');
INSERT INTO public.who_global_data_import VALUES (16623, '2020-08-12', 'CL', 'Chile', 'AMRO', '1572', '376616', '39', '10178');
INSERT INTO public.who_global_data_import VALUES (16624, '2020-08-13', 'CL', 'Chile', 'AMRO', '1552', '378168', '27', '10205');
INSERT INTO public.who_global_data_import VALUES (16625, '2020-08-14', 'CL', 'Chile', 'AMRO', '1866', '380034', '94', '10299');
INSERT INTO public.who_global_data_import VALUES (16626, '2020-08-15', 'CL', 'Chile', 'AMRO', '2077', '382111', '41', '10340');
INSERT INTO public.who_global_data_import VALUES (16627, '2020-08-16', 'CL', 'Chile', 'AMRO', '1791', '383902', '55', '10395');
INSERT INTO public.who_global_data_import VALUES (16628, '2020-08-17', 'CL', 'Chile', 'AMRO', '2044', '385946', '57', '10452');
INSERT INTO public.who_global_data_import VALUES (16629, '2020-08-18', 'CL', 'Chile', 'AMRO', '1556', '387502', '61', '10513');
INSERT INTO public.who_global_data_import VALUES (16630, '2020-08-19', 'CL', 'Chile', 'AMRO', '1353', '388855', '33', '10546');
INSERT INTO public.who_global_data_import VALUES (16631, '2020-08-20', 'CL', 'Chile', 'AMRO', '1182', '390037', '32', '10578');
INSERT INTO public.who_global_data_import VALUES (16632, '2020-08-21', 'CL', 'Chile', 'AMRO', '1812', '391849', '93', '10671');
INSERT INTO public.who_global_data_import VALUES (16633, '2020-08-22', 'CL', 'Chile', 'AMRO', '1920', '393769', '52', '10723');
INSERT INTO public.who_global_data_import VALUES (16634, '2020-08-23', 'CL', 'Chile', 'AMRO', '1939', '395708', '69', '10792');
INSERT INTO public.who_global_data_import VALUES (16635, '2020-08-24', 'CL', 'Chile', 'AMRO', '1957', '397665', '60', '10852');
INSERT INTO public.who_global_data_import VALUES (16636, '2020-08-25', 'CL', 'Chile', 'AMRO', '1903', '399568', '64', '10916');
INSERT INTO public.who_global_data_import VALUES (16637, '2020-08-26', 'CL', 'Chile', 'AMRO', '1417', '400985', '42', '10958');
INSERT INTO public.who_global_data_import VALUES (16638, '2020-08-27', 'CL', 'Chile', 'AMRO', '1380', '402365', '32', '10990');
INSERT INTO public.who_global_data_import VALUES (16639, '2020-08-28', 'CL', 'Chile', 'AMRO', '1737', '404102', '82', '11072');
INSERT INTO public.who_global_data_import VALUES (16640, '2020-08-29', 'CL', 'Chile', 'AMRO', '1870', '405972', '60', '11132');
INSERT INTO public.who_global_data_import VALUES (16641, '2020-08-30', 'CL', 'Chile', 'AMRO', '2037', '408009', '49', '11181');
INSERT INTO public.who_global_data_import VALUES (16642, '2020-08-31', 'CL', 'Chile', 'AMRO', '1965', '409974', '63', '11244');
INSERT INTO public.who_global_data_import VALUES (16643, '2020-09-01', 'CL', 'Chile', 'AMRO', '1752', '411726', '45', '11289');
INSERT INTO public.who_global_data_import VALUES (16644, '2020-09-02', 'CL', 'Chile', 'AMRO', '1419', '413145', '32', '11321');
INSERT INTO public.who_global_data_import VALUES (16645, '2020-09-03', 'CL', 'Chile', 'AMRO', '1594', '414739', '23', '11344');
INSERT INTO public.who_global_data_import VALUES (16646, '2020-09-04', 'CL', 'Chile', 'AMRO', '1762', '416501', '78', '11422');
INSERT INTO public.who_global_data_import VALUES (16647, '2020-09-05', 'CL', 'Chile', 'AMRO', '1968', '418469', '72', '11494');
INSERT INTO public.who_global_data_import VALUES (16648, '2020-09-06', 'CL', 'Chile', 'AMRO', '1965', '420434', '57', '11551');
INSERT INTO public.who_global_data_import VALUES (16649, '2020-09-07', 'CL', 'Chile', 'AMRO', '2076', '422510', '41', '11592');
INSERT INTO public.who_global_data_import VALUES (16650, '2020-09-08', 'CL', 'Chile', 'AMRO', '1764', '424274', '60', '11652');
INSERT INTO public.who_global_data_import VALUES (16651, '2020-09-09', 'CL', 'Chile', 'AMRO', '1267', '425541', '30', '11682');
INSERT INTO public.who_global_data_import VALUES (16652, '2020-09-10', 'CL', 'Chile', 'AMRO', '1486', '427027', '20', '11702');
INSERT INTO public.who_global_data_import VALUES (16653, '2020-09-11', 'CL', 'Chile', 'AMRO', '1642', '428669', '79', '11781');
INSERT INTO public.who_global_data_import VALUES (16654, '2020-09-12', 'CL', 'Chile', 'AMRO', '1866', '430535', '69', '11850');
INSERT INTO public.who_global_data_import VALUES (16655, '2020-09-13', 'CL', 'Chile', 'AMRO', '2131', '432666', '45', '11895');
INSERT INTO public.who_global_data_import VALUES (16656, '2020-09-14', 'CL', 'Chile', 'AMRO', '2082', '434748', '54', '11949');
INSERT INTO public.who_global_data_import VALUES (16657, '2020-09-15', 'CL', 'Chile', 'AMRO', '1685', '436433', '64', '12013');
INSERT INTO public.who_global_data_import VALUES (16658, '2020-09-16', 'CL', 'Chile', 'AMRO', '1550', '437983', '27', '12040');
INSERT INTO public.who_global_data_import VALUES (16659, '2020-09-17', 'CL', 'Chile', 'AMRO', '1304', '439287', '18', '12058');
INSERT INTO public.who_global_data_import VALUES (16660, '2020-09-18', 'CL', 'Chile', 'AMRO', '1863', '441150', '84', '12142');
INSERT INTO public.who_global_data_import VALUES (16661, '2020-09-19', 'CL', 'Chile', 'AMRO', '1677', '442827', '57', '12199');
INSERT INTO public.who_global_data_import VALUES (16662, '2020-09-20', 'CL', 'Chile', 'AMRO', '1847', '444674', '55', '12254');
INSERT INTO public.who_global_data_import VALUES (16663, '2020-09-21', 'CL', 'Chile', 'AMRO', '1600', '446274', '32', '12286');
INSERT INTO public.who_global_data_import VALUES (16664, '2020-09-22', 'CL', 'Chile', 'AMRO', '1194', '447468', '12', '12298');
INSERT INTO public.who_global_data_import VALUES (16665, '2020-09-23', 'CL', 'Chile', 'AMRO', '1055', '448523', '23', '12321');
INSERT INTO public.who_global_data_import VALUES (16666, '2020-09-24', 'CL', 'Chile', 'AMRO', '1380', '449903', '24', '12345');
INSERT INTO public.who_global_data_import VALUES (16667, '2020-09-25', 'CL', 'Chile', 'AMRO', '1731', '451634', '124', '12469');
INSERT INTO public.who_global_data_import VALUES (16668, '2020-09-26', 'CL', 'Chile', 'AMRO', '2234', '453868', '58', '12527');
INSERT INTO public.who_global_data_import VALUES (16669, '2020-09-27', 'CL', 'Chile', 'AMRO', '2111', '455979', '64', '12591');
INSERT INTO public.who_global_data_import VALUES (16670, '2020-09-28', 'CL', 'Chile', 'AMRO', '1922', '457901', '50', '12641');
INSERT INTO public.who_global_data_import VALUES (16671, '2020-09-29', 'CL', 'Chile', 'AMRO', '1770', '459671', '57', '12698');
INSERT INTO public.who_global_data_import VALUES (16672, '2020-09-30', 'CL', 'Chile', 'AMRO', '1629', '461300', '27', '12725');
INSERT INTO public.who_global_data_import VALUES (16673, '2020-10-01', 'CL', 'Chile', 'AMRO', '1691', '462991', '16', '12741');
INSERT INTO public.who_global_data_import VALUES (16674, '2020-10-02', 'CL', 'Chile', 'AMRO', '1759', '464750', '81', '12822');
INSERT INTO public.who_global_data_import VALUES (16675, '2020-10-03', 'CL', 'Chile', 'AMRO', '1840', '466590', '45', '12867');
INSERT INTO public.who_global_data_import VALUES (16676, '2020-10-04', 'CL', 'Chile', 'AMRO', '1881', '468471', '52', '12919');
INSERT INTO public.who_global_data_import VALUES (16677, '2020-10-05', 'CL', 'Chile', 'AMRO', '1708', '470179', '60', '12979');
INSERT INTO public.who_global_data_import VALUES (16678, '2020-10-06', 'CL', 'Chile', 'AMRO', '1567', '471746', '58', '13037');
INSERT INTO public.who_global_data_import VALUES (16679, '2020-10-07', 'CL', 'Chile', 'AMRO', '1560', '473306', '33', '13070');
INSERT INTO public.who_global_data_import VALUES (16680, '2020-10-08', 'CL', 'Chile', 'AMRO', '1134', '474440', '20', '13090');
INSERT INTO public.who_global_data_import VALUES (16681, '2020-10-09', 'CL', 'Chile', 'AMRO', '1576', '476016', '77', '13167');
INSERT INTO public.who_global_data_import VALUES (16682, '2020-10-10', 'CL', 'Chile', 'AMRO', '1753', '477769', '53', '13220');
INSERT INTO public.who_global_data_import VALUES (16683, '2020-10-11', 'CL', 'Chile', 'AMRO', '1826', '479595', '52', '13272');
INSERT INTO public.who_global_data_import VALUES (16684, '2020-10-12', 'CL', 'Chile', 'AMRO', '1776', '481371', '46', '13318');
INSERT INTO public.who_global_data_import VALUES (16685, '2020-10-13', 'CL', 'Chile', 'AMRO', '1517', '482888', '61', '13379');
INSERT INTO public.who_global_data_import VALUES (16686, '2020-10-14', 'CL', 'Chile', 'AMRO', '1392', '484280', '17', '13396');
INSERT INTO public.who_global_data_import VALUES (16687, '2020-10-15', 'CL', 'Chile', 'AMRO', '1092', '485372', '19', '13415');
INSERT INTO public.who_global_data_import VALUES (16688, '2020-10-16', 'CL', 'Chile', 'AMRO', '1124', '486496', '19', '13434');
INSERT INTO public.who_global_data_import VALUES (16689, '2020-10-17', 'CL', 'Chile', 'AMRO', '1694', '488190', '95', '13529');
INSERT INTO public.who_global_data_import VALUES (16690, '2020-10-18', 'CL', 'Chile', 'AMRO', '1813', '490003', '59', '13588');
INSERT INTO public.who_global_data_import VALUES (16691, '2020-10-19', 'CL', 'Chile', 'AMRO', '1757', '491760', '47', '13635');
INSERT INTO public.who_global_data_import VALUES (16692, '2020-10-20', 'CL', 'Chile', 'AMRO', '1545', '493305', '41', '13676');
INSERT INTO public.who_global_data_import VALUES (16693, '2020-10-21', 'CL', 'Chile', 'AMRO', '1173', '494478', '26', '13702');
INSERT INTO public.who_global_data_import VALUES (16694, '2020-10-22', 'CL', 'Chile', 'AMRO', '1159', '495637', '17', '13719');
INSERT INTO public.who_global_data_import VALUES (16695, '2020-10-23', 'CL', 'Chile', 'AMRO', '1494', '497131', '73', '13792');
INSERT INTO public.who_global_data_import VALUES (16696, '2020-10-24', 'CL', 'Chile', 'AMRO', '1775', '498906', '52', '13844');
INSERT INTO public.who_global_data_import VALUES (16697, '2020-10-25', 'CL', 'Chile', 'AMRO', '1636', '500542', '48', '13892');
INSERT INTO public.who_global_data_import VALUES (16698, '2020-10-26', 'CL', 'Chile', 'AMRO', '1521', '502063', '52', '13944');
INSERT INTO public.who_global_data_import VALUES (16699, '2020-10-27', 'CL', 'Chile', 'AMRO', '1535', '503598', '59', '14003');
INSERT INTO public.who_global_data_import VALUES (16700, '2020-10-28', 'CL', 'Chile', 'AMRO', '927', '504525', '23', '14026');
INSERT INTO public.who_global_data_import VALUES (16701, '2020-10-29', 'CL', 'Chile', 'AMRO', '1005', '505530', '6', '14032');
INSERT INTO public.who_global_data_import VALUES (16702, '2020-10-30', 'CL', 'Chile', 'AMRO', '1520', '507050', '86', '14118');
INSERT INTO public.who_global_data_import VALUES (16703, '2020-10-31', 'CL', 'Chile', 'AMRO', '1521', '508571', '40', '14158');
INSERT INTO public.who_global_data_import VALUES (16704, '2020-11-01', 'CL', 'Chile', 'AMRO', '1685', '510256', '49', '14207');
INSERT INTO public.who_global_data_import VALUES (16705, '2020-11-02', 'CL', 'Chile', 'AMRO', '1608', '511864', '40', '14247');
INSERT INTO public.who_global_data_import VALUES (16706, '2020-11-03', 'CL', 'Chile', 'AMRO', '1324', '513188', '55', '14302');
INSERT INTO public.who_global_data_import VALUES (16707, '2020-11-04', 'CL', 'Chile', 'AMRO', '1014', '514202', '17', '14319');
INSERT INTO public.who_global_data_import VALUES (16708, '2020-11-05', 'CL', 'Chile', 'AMRO', '840', '515042', '21', '14340');
INSERT INTO public.who_global_data_import VALUES (16709, '2020-11-06', 'CL', 'Chile', 'AMRO', '1540', '516582', '64', '14404');
INSERT INTO public.who_global_data_import VALUES (16710, '2020-11-07', 'CL', 'Chile', 'AMRO', '1808', '518390', '46', '14450');
INSERT INTO public.who_global_data_import VALUES (16711, '2020-11-08', 'CL', 'Chile', 'AMRO', '1587', '519977', '49', '14499');
INSERT INTO public.who_global_data_import VALUES (16712, '2020-11-09', 'CL', 'Chile', 'AMRO', '1581', '521558', '44', '14543');
INSERT INTO public.who_global_data_import VALUES (16713, '2020-11-10', 'CL', 'Chile', 'AMRO', '1321', '522879', '45', '14588');
INSERT INTO public.who_global_data_import VALUES (16714, '2020-11-11', 'CL', 'Chile', 'AMRO', '1028', '523907', '23', '14611');
INSERT INTO public.who_global_data_import VALUES (16715, '2020-11-12', 'CL', 'Chile', 'AMRO', '897', '524804', '22', '14633');
INSERT INTO public.who_global_data_import VALUES (16716, '2020-11-13', 'CL', 'Chile', 'AMRO', '1634', '526438', '66', '14699');
INSERT INTO public.who_global_data_import VALUES (16717, '2020-11-14', 'CL', 'Chile', 'AMRO', '1592', '528030', '39', '14738');
INSERT INTO public.who_global_data_import VALUES (16718, '2020-11-15', 'CL', 'Chile', 'AMRO', '1646', '529676', '39', '14777');
INSERT INTO public.who_global_data_import VALUES (16719, '2020-11-16', 'CL', 'Chile', 'AMRO', '1597', '531273', '42', '14819');
INSERT INTO public.who_global_data_import VALUES (16720, '2020-11-17', 'CL', 'Chile', 'AMRO', '1331', '532604', '44', '14863');
INSERT INTO public.who_global_data_import VALUES (16721, '2020-11-18', 'CL', 'Chile', 'AMRO', '1006', '533610', '20', '14883');
INSERT INTO public.who_global_data_import VALUES (16722, '2020-11-19', 'CL', 'Chile', 'AMRO', '948', '534558', '14', '14897');
INSERT INTO public.who_global_data_import VALUES (16723, '2020-11-20', 'CL', 'Chile', 'AMRO', '1454', '536012', '58', '14955');
INSERT INTO public.who_global_data_import VALUES (16724, '2020-11-21', 'CL', 'Chile', 'AMRO', '1573', '537585', '48', '15003');
INSERT INTO public.who_global_data_import VALUES (16725, '2020-11-22', 'CL', 'Chile', 'AMRO', '1558', '539143', '27', '15030');
INSERT INTO public.who_global_data_import VALUES (16726, '2020-11-23', 'CL', 'Chile', 'AMRO', '1497', '540640', '39', '15069');
INSERT INTO public.who_global_data_import VALUES (16727, '2020-11-24', 'CL', 'Chile', 'AMRO', '1440', '542080', '37', '15106');
INSERT INTO public.who_global_data_import VALUES (16728, '2020-11-25', 'CL', 'Chile', 'AMRO', '1007', '543087', '25', '15131');
INSERT INTO public.who_global_data_import VALUES (16729, '2020-11-26', 'CL', 'Chile', 'AMRO', '1005', '544092', '7', '15138');
INSERT INTO public.who_global_data_import VALUES (16730, '2020-11-27', 'CL', 'Chile', 'AMRO', '1570', '545662', '97', '15235');
INSERT INTO public.who_global_data_import VALUES (16731, '2020-11-28', 'CL', 'Chile', 'AMRO', '1561', '547223', '43', '15278');
INSERT INTO public.who_global_data_import VALUES (16732, '2020-11-29', 'CL', 'Chile', 'AMRO', '1718', '548941', '44', '15322');
INSERT INTO public.who_global_data_import VALUES (16733, '2020-11-30', 'CL', 'Chile', 'AMRO', '1489', '550430', '34', '15356');
INSERT INTO public.who_global_data_import VALUES (16734, '2020-12-01', 'CL', 'Chile', 'AMRO', '1313', '551743', '54', '15410');
INSERT INTO public.who_global_data_import VALUES (16735, '2020-12-02', 'CL', 'Chile', 'AMRO', '1121', '552864', '20', '15430');
INSERT INTO public.who_global_data_import VALUES (16736, '2020-12-03', 'CL', 'Chile', 'AMRO', '1034', '553898', '8', '15438');
INSERT INTO public.who_global_data_import VALUES (16737, '2020-12-04', 'CL', 'Chile', 'AMRO', '1508', '555406', '81', '15519');
INSERT INTO public.who_global_data_import VALUES (16738, '2020-12-05', 'CL', 'Chile', 'AMRO', '1729', '557135', '39', '15558');
INSERT INTO public.who_global_data_import VALUES (16739, '2020-12-06', 'CL', 'Chile', 'AMRO', '1533', '558668', '34', '15592');
INSERT INTO public.who_global_data_import VALUES (16740, '2020-12-07', 'CL', 'Chile', 'AMRO', '1714', '560382', '36', '15628');
INSERT INTO public.who_global_data_import VALUES (16741, '2020-12-08', 'CL', 'Chile', 'AMRO', '1760', '562142', '35', '15663');
INSERT INTO public.who_global_data_import VALUES (16742, '2020-12-09', 'CL', 'Chile', 'AMRO', '1392', '563534', '17', '15680');
INSERT INTO public.who_global_data_import VALUES (16743, '2020-12-10', 'CL', 'Chile', 'AMRO', '1244', '564778', '10', '15690');
INSERT INTO public.who_global_data_import VALUES (16744, '2020-12-11', 'CL', 'Chile', 'AMRO', '1662', '566440', '84', '15774');
INSERT INTO public.who_global_data_import VALUES (16745, '2020-12-12', 'CL', 'Chile', 'AMRO', '1534', '567974', '8', '15782');
INSERT INTO public.who_global_data_import VALUES (16746, '2020-12-13', 'CL', 'Chile', 'AMRO', '1807', '569781', '64', '15846');
INSERT INTO public.who_global_data_import VALUES (16747, '2020-12-14', 'CL', 'Chile', 'AMRO', '2138', '571919', '40', '15886');
INSERT INTO public.who_global_data_import VALUES (16748, '2020-12-15', 'CL', 'Chile', 'AMRO', '1911', '573830', '45', '15931');
INSERT INTO public.who_global_data_import VALUES (16749, '2020-12-16', 'CL', 'Chile', 'AMRO', '1499', '575329', '18', '15949');
INSERT INTO public.who_global_data_import VALUES (16750, '2020-12-17', 'CL', 'Chile', 'AMRO', '1402', '576731', '10', '15959');
INSERT INTO public.who_global_data_import VALUES (16751, '2020-12-18', 'CL', 'Chile', 'AMRO', '2001', '578732', '48', '16007');
INSERT INTO public.who_global_data_import VALUES (16752, '2020-12-19', 'CL', 'Chile', 'AMRO', '2403', '581135', '44', '16051');
INSERT INTO public.who_global_data_import VALUES (16753, '2020-12-20', 'CL', 'Chile', 'AMRO', '2219', '583354', '50', '16101');
INSERT INTO public.who_global_data_import VALUES (16754, '2020-12-21', 'CL', 'Chile', 'AMRO', '2191', '585545', '53', '16154');
INSERT INTO public.who_global_data_import VALUES (16755, '2020-12-22', 'CL', 'Chile', 'AMRO', '1943', '587488', '43', '16197');
INSERT INTO public.who_global_data_import VALUES (16756, '2020-12-23', 'CL', 'Chile', 'AMRO', '1701', '589189', '20', '16217');
INSERT INTO public.who_global_data_import VALUES (16757, '2020-12-24', 'CL', 'Chile', 'AMRO', '1725', '590914', '11', '16228');
INSERT INTO public.who_global_data_import VALUES (16758, '2020-12-25', 'CL', 'Chile', 'AMRO', '2396', '593310', '75', '16303');
INSERT INTO public.who_global_data_import VALUES (16759, '2020-12-26', 'CL', 'Chile', 'AMRO', '2521', '595831', '55', '16358');
INSERT INTO public.who_global_data_import VALUES (16760, '2020-12-27', 'CL', 'Chile', 'AMRO', '2563', '598394', '46', '16404');
INSERT INTO public.who_global_data_import VALUES (16761, '2020-12-28', 'CL', 'Chile', 'AMRO', '1711', '600105', '39', '16443');
INSERT INTO public.who_global_data_import VALUES (16762, '2020-12-29', 'CL', 'Chile', 'AMRO', '1923', '602028', '0', '16443');
INSERT INTO public.who_global_data_import VALUES (16763, '2020-12-30', 'CL', 'Chile', 'AMRO', '1958', '603986', '45', '16488');
INSERT INTO public.who_global_data_import VALUES (16764, '2020-12-31', 'CL', 'Chile', 'AMRO', '1964', '605950', '11', '16499');
INSERT INTO public.who_global_data_import VALUES (16765, '2021-01-01', 'CL', 'Chile', 'AMRO', '3023', '608973', '109', '16608');
INSERT INTO public.who_global_data_import VALUES (16766, '2021-01-02', 'CL', 'Chile', 'AMRO', '3591', '612564', '52', '16660');
INSERT INTO public.who_global_data_import VALUES (16767, '2021-01-03', 'CL', 'Chile', 'AMRO', '3338', '615902', '64', '16724');
INSERT INTO public.who_global_data_import VALUES (16768, '2021-01-04', 'CL', 'Chile', 'AMRO', '2289', '618191', '43', '16767');
INSERT INTO public.who_global_data_import VALUES (16769, '2021-01-05', 'CL', 'Chile', 'AMRO', '2450', '620641', '0', '16767');
INSERT INTO public.who_global_data_import VALUES (16770, '2021-01-06', 'CL', 'Chile', 'AMRO', '2460', '623101', '21', '16788');
INSERT INTO public.who_global_data_import VALUES (16771, '2021-01-07', 'CL', 'Chile', 'AMRO', '2382', '625483', '28', '16816');
INSERT INTO public.who_global_data_import VALUES (16772, '2021-01-08', 'CL', 'Chile', 'AMRO', '3693', '629176', '97', '16913');
INSERT INTO public.who_global_data_import VALUES (16773, '2021-01-09', 'CL', 'Chile', 'AMRO', '4205', '633381', '61', '16974');
INSERT INTO public.who_global_data_import VALUES (16774, '2021-01-10', 'CL', 'Chile', 'AMRO', '4361', '637742', '63', '17037');
INSERT INTO public.who_global_data_import VALUES (16775, '2021-01-11', 'CL', 'Chile', 'AMRO', '4181', '641923', '59', '17096');
INSERT INTO public.who_global_data_import VALUES (16776, '2021-01-12', 'CL', 'Chile', 'AMRO', '3969', '645892', '66', '17162');
INSERT INTO public.who_global_data_import VALUES (16777, '2021-01-13', 'CL', 'Chile', 'AMRO', '3243', '649135', '20', '17182');
INSERT INTO public.who_global_data_import VALUES (16778, '2021-01-14', 'CL', 'Chile', 'AMRO', '3390', '652525', '22', '17204');
INSERT INTO public.who_global_data_import VALUES (16779, '2021-01-15', 'CL', 'Chile', 'AMRO', '4187', '656712', '90', '17294');
INSERT INTO public.who_global_data_import VALUES (16780, '2021-01-16', 'CL', 'Chile', 'AMRO', '4468', '661180', '75', '17369');
INSERT INTO public.who_global_data_import VALUES (16781, '2021-01-17', 'CL', 'Chile', 'AMRO', '4313', '665493', '66', '17435');
INSERT INTO public.who_global_data_import VALUES (16782, '2021-01-18', 'CL', 'Chile', 'AMRO', '4339', '669832', '42', '17477');
INSERT INTO public.who_global_data_import VALUES (16783, '2021-01-19', 'CL', 'Chile', 'AMRO', '3918', '673750', '70', '17547');
INSERT INTO public.who_global_data_import VALUES (16784, '2021-01-20', 'CL', 'Chile', 'AMRO', '3401', '677151', '26', '17573');
INSERT INTO public.who_global_data_import VALUES (16785, '2021-01-21', 'CL', 'Chile', 'AMRO', '3589', '680740', '21', '17594');
INSERT INTO public.who_global_data_import VALUES (16786, '2021-01-22', 'CL', 'Chile', 'AMRO', '4367', '685107', '108', '17702');
INSERT INTO public.who_global_data_import VALUES (16787, '2021-01-23', 'CL', 'Chile', 'AMRO', '4959', '690066', '84', '17786');
INSERT INTO public.who_global_data_import VALUES (16788, '2021-01-24', 'CL', 'Chile', 'AMRO', '4581', '694647', '68', '17854');
INSERT INTO public.who_global_data_import VALUES (16789, '2021-01-25', 'CL', 'Chile', 'AMRO', '4463', '699110', '79', '17933');
INSERT INTO public.who_global_data_import VALUES (16790, '2021-01-26', 'CL', 'Chile', 'AMRO', '4068', '703178', '66', '17999');
INSERT INTO public.who_global_data_import VALUES (16791, '2021-01-27', 'CL', 'Chile', 'AMRO', '3322', '706500', '24', '18023');
INSERT INTO public.who_global_data_import VALUES (16792, '2021-01-28', 'CL', 'Chile', 'AMRO', '3388', '709888', '17', '18040');
INSERT INTO public.who_global_data_import VALUES (16793, '2021-01-29', 'CL', 'Chile', 'AMRO', '4255', '714143', '134', '18174');
INSERT INTO public.who_global_data_import VALUES (16794, '2021-01-30', 'CL', 'Chile', 'AMRO', '4606', '718749', '83', '18257');
INSERT INTO public.who_global_data_import VALUES (16795, '2021-01-31', 'CL', 'Chile', 'AMRO', '4151', '722900', '82', '18339');
INSERT INTO public.who_global_data_import VALUES (16796, '2021-02-01', 'CL', 'Chile', 'AMRO', '4209', '727109', '113', '18452');
INSERT INTO public.who_global_data_import VALUES (16797, '2021-02-02', 'CL', 'Chile', 'AMRO', '3779', '730888', '85', '18537');
INSERT INTO public.who_global_data_import VALUES (16798, '2021-02-03', 'CL', 'Chile', 'AMRO', '3147', '734035', '22', '18559');
INSERT INTO public.who_global_data_import VALUES (16799, '2021-02-04', 'CL', 'Chile', 'AMRO', '2610', '736645', '17', '18576');
INSERT INTO public.who_global_data_import VALUES (16800, '2021-02-05', 'CL', 'Chile', 'AMRO', '3592', '740237', '155', '18731');
INSERT INTO public.who_global_data_import VALUES (16801, '2020-01-03', 'CN', 'China', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16802, '2020-01-04', 'CN', 'China', 'WPRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16803, '2020-01-05', 'CN', 'China', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16804, '2020-01-06', 'CN', 'China', 'WPRO', '3', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16805, '2020-01-07', 'CN', 'China', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16806, '2020-01-08', 'CN', 'China', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16807, '2020-01-09', 'CN', 'China', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16808, '2020-01-10', 'CN', 'China', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (16809, '2020-01-11', 'CN', 'China', 'WPRO', '41', '45', '1', '1');
INSERT INTO public.who_global_data_import VALUES (16810, '2020-01-12', 'CN', 'China', 'WPRO', '0', '45', '0', '1');
INSERT INTO public.who_global_data_import VALUES (16811, '2020-01-13', 'CN', 'China', 'WPRO', '0', '45', '0', '1');
INSERT INTO public.who_global_data_import VALUES (16812, '2020-01-14', 'CN', 'China', 'WPRO', '0', '45', '0', '1');
INSERT INTO public.who_global_data_import VALUES (16813, '2020-01-15', 'CN', 'China', 'WPRO', '0', '45', '0', '1');
INSERT INTO public.who_global_data_import VALUES (16814, '2020-01-16', 'CN', 'China', 'WPRO', '0', '45', '0', '1');
INSERT INTO public.who_global_data_import VALUES (16815, '2020-01-17', 'CN', 'China', 'WPRO', '4', '49', '1', '2');
INSERT INTO public.who_global_data_import VALUES (16816, '2020-01-18', 'CN', 'China', 'WPRO', '17', '66', '0', '2');
INSERT INTO public.who_global_data_import VALUES (16817, '2020-01-19', 'CN', 'China', 'WPRO', '59', '125', '1', '3');
INSERT INTO public.who_global_data_import VALUES (16818, '2020-01-20', 'CN', 'China', 'WPRO', '77', '202', '1', '4');
INSERT INTO public.who_global_data_import VALUES (16819, '2020-01-21', 'CN', 'China', 'WPRO', '93', '295', '2', '6');
INSERT INTO public.who_global_data_import VALUES (16820, '2020-01-22', 'CN', 'China', 'WPRO', '152', '447', '3', '9');
INSERT INTO public.who_global_data_import VALUES (16821, '2020-01-23', 'CN', 'China', 'WPRO', '131', '578', '8', '17');
INSERT INTO public.who_global_data_import VALUES (16822, '2020-01-24', 'CN', 'China', 'WPRO', '261', '839', '8', '25');
INSERT INTO public.who_global_data_import VALUES (16823, '2020-01-25', 'CN', 'China', 'WPRO', '462', '1301', '16', '41');
INSERT INTO public.who_global_data_import VALUES (16824, '2020-01-26', 'CN', 'China', 'WPRO', '688', '1989', '15', '56');
INSERT INTO public.who_global_data_import VALUES (16825, '2020-01-27', 'CN', 'China', 'WPRO', '776', '2765', '24', '80');
INSERT INTO public.who_global_data_import VALUES (16826, '2020-01-28', 'CN', 'China', 'WPRO', '1772', '4537', '26', '106');
INSERT INTO public.who_global_data_import VALUES (16827, '2020-01-29', 'CN', 'China', 'WPRO', '1462', '5999', '26', '132');
INSERT INTO public.who_global_data_import VALUES (16828, '2020-01-30', 'CN', 'China', 'WPRO', '1741', '7740', '38', '170');
INSERT INTO public.who_global_data_import VALUES (16829, '2020-01-31', 'CN', 'China', 'WPRO', '1984', '9724', '43', '213');
INSERT INTO public.who_global_data_import VALUES (16830, '2020-02-01', 'CN', 'China', 'WPRO', '2101', '11825', '46', '259');
INSERT INTO public.who_global_data_import VALUES (16831, '2020-02-02', 'CN', 'China', 'WPRO', '2590', '14415', '45', '304');
INSERT INTO public.who_global_data_import VALUES (16832, '2020-02-03', 'CN', 'China', 'WPRO', '2827', '17242', '57', '361');
INSERT INTO public.who_global_data_import VALUES (16833, '2020-02-04', 'CN', 'China', 'WPRO', '3233', '20475', '64', '425');
INSERT INTO public.who_global_data_import VALUES (16834, '2020-02-05', 'CN', 'China', 'WPRO', '3892', '24367', '66', '491');
INSERT INTO public.who_global_data_import VALUES (16835, '2020-02-06', 'CN', 'China', 'WPRO', '3697', '28064', '73', '564');
INSERT INTO public.who_global_data_import VALUES (16836, '2020-02-07', 'CN', 'China', 'WPRO', '3151', '31215', '73', '637');
INSERT INTO public.who_global_data_import VALUES (16837, '2020-02-08', 'CN', 'China', 'WPRO', '3387', '34602', '86', '723');
INSERT INTO public.who_global_data_import VALUES (16838, '2020-02-09', 'CN', 'China', 'WPRO', '2653', '37255', '89', '812');
INSERT INTO public.who_global_data_import VALUES (16839, '2020-02-10', 'CN', 'China', 'WPRO', '2985', '40240', '97', '909');
INSERT INTO public.who_global_data_import VALUES (16840, '2020-02-11', 'CN', 'China', 'WPRO', '2472', '42712', '108', '1017');
INSERT INTO public.who_global_data_import VALUES (16841, '2020-02-12', 'CN', 'China', 'WPRO', '2022', '44734', '97', '1114');
INSERT INTO public.who_global_data_import VALUES (16842, '2020-02-13', 'CN', 'China', 'WPRO', '15152', '59886', '254', '1368');
INSERT INTO public.who_global_data_import VALUES (16843, '2020-02-14', 'CN', 'China', 'WPRO', '4050', '63936', '13', '1381');
INSERT INTO public.who_global_data_import VALUES (16844, '2020-02-15', 'CN', 'China', 'WPRO', '2644', '66580', '143', '1524');
INSERT INTO public.who_global_data_import VALUES (16845, '2020-02-16', 'CN', 'China', 'WPRO', '2008', '68588', '142', '1666');
INSERT INTO public.who_global_data_import VALUES (16846, '2020-02-17', 'CN', 'China', 'WPRO', '2051', '70639', '106', '1772');
INSERT INTO public.who_global_data_import VALUES (16847, '2020-02-18', 'CN', 'China', 'WPRO', '1893', '72532', '98', '1870');
INSERT INTO public.who_global_data_import VALUES (16848, '2020-02-19', 'CN', 'China', 'WPRO', '1751', '74283', '136', '2006');
INSERT INTO public.who_global_data_import VALUES (16849, '2020-02-20', 'CN', 'China', 'WPRO', '396', '74679', '115', '2121');
INSERT INTO public.who_global_data_import VALUES (16850, '2020-02-21', 'CN', 'China', 'WPRO', '892', '75571', '118', '2239');
INSERT INTO public.who_global_data_import VALUES (16851, '2020-02-22', 'CN', 'China', 'WPRO', '825', '76396', '109', '2348');
INSERT INTO public.who_global_data_import VALUES (16852, '2020-02-23', 'CN', 'China', 'WPRO', '649', '77045', '97', '2445');
INSERT INTO public.who_global_data_import VALUES (16853, '2020-02-24', 'CN', 'China', 'WPRO', '221', '77266', '150', '2595');
INSERT INTO public.who_global_data_import VALUES (16854, '2020-02-25', 'CN', 'China', 'WPRO', '517', '77783', '71', '2666');
INSERT INTO public.who_global_data_import VALUES (16855, '2020-02-26', 'CN', 'China', 'WPRO', '411', '78194', '52', '2718');
INSERT INTO public.who_global_data_import VALUES (16856, '2020-02-27', 'CN', 'China', 'WPRO', '440', '78634', '29', '2747');
INSERT INTO public.who_global_data_import VALUES (16857, '2020-02-28', 'CN', 'China', 'WPRO', '329', '78963', '44', '2791');
INSERT INTO public.who_global_data_import VALUES (16858, '2020-02-29', 'CN', 'China', 'WPRO', '430', '79393', '47', '2838');
INSERT INTO public.who_global_data_import VALUES (16859, '2020-03-01', 'CN', 'China', 'WPRO', '579', '79972', '35', '2873');
INSERT INTO public.who_global_data_import VALUES (16860, '2020-03-02', 'CN', 'China', 'WPRO', '206', '80178', '42', '2915');
INSERT INTO public.who_global_data_import VALUES (16861, '2020-03-03', 'CN', 'China', 'WPRO', '128', '80306', '31', '2946');
INSERT INTO public.who_global_data_import VALUES (16862, '2020-03-04', 'CN', 'China', 'WPRO', '120', '80426', '38', '2984');
INSERT INTO public.who_global_data_import VALUES (16863, '2020-03-05', 'CN', 'China', 'WPRO', '143', '80569', '31', '3015');
INSERT INTO public.who_global_data_import VALUES (16864, '2020-03-06', 'CN', 'China', 'WPRO', '146', '80715', '30', '3045');
INSERT INTO public.who_global_data_import VALUES (16865, '2020-03-07', 'CN', 'China', 'WPRO', '102', '80817', '28', '3073');
INSERT INTO public.who_global_data_import VALUES (16866, '2020-03-08', 'CN', 'China', 'WPRO', '46', '80863', '27', '3100');
INSERT INTO public.who_global_data_import VALUES (16867, '2020-03-09', 'CN', 'China', 'WPRO', '45', '80908', '23', '3123');
INSERT INTO public.who_global_data_import VALUES (16868, '2020-03-10', 'CN', 'China', 'WPRO', '20', '80928', '17', '3140');
INSERT INTO public.who_global_data_import VALUES (16869, '2020-03-11', 'CN', 'China', 'WPRO', '31', '80959', '22', '3162');
INSERT INTO public.who_global_data_import VALUES (16870, '2020-03-12', 'CN', 'China', 'WPRO', '26', '80985', '11', '3173');
INSERT INTO public.who_global_data_import VALUES (16871, '2020-03-13', 'CN', 'China', 'WPRO', '10', '80995', '7', '3180');
INSERT INTO public.who_global_data_import VALUES (16872, '2020-03-14', 'CN', 'China', 'WPRO', '30', '81025', '14', '3194');
INSERT INTO public.who_global_data_import VALUES (16873, '2020-03-15', 'CN', 'China', 'WPRO', '27', '81052', '10', '3204');
INSERT INTO public.who_global_data_import VALUES (16874, '2020-03-16', 'CN', 'China', 'WPRO', '29', '81081', '14', '3218');
INSERT INTO public.who_global_data_import VALUES (16875, '2020-03-17', 'CN', 'China', 'WPRO', '39', '81120', '13', '3231');
INSERT INTO public.who_global_data_import VALUES (16876, '2020-03-18', 'CN', 'China', 'WPRO', '58', '81178', '11', '3242');
INSERT INTO public.who_global_data_import VALUES (16877, '2020-03-19', 'CN', 'China', 'WPRO', '99', '81277', '8', '3250');
INSERT INTO public.who_global_data_import VALUES (16878, '2020-03-20', 'CN', 'China', 'WPRO', '139', '81416', '11', '3261');
INSERT INTO public.who_global_data_import VALUES (16879, '2020-03-21', 'CN', 'China', 'WPRO', '82', '81498', '6', '3267');
INSERT INTO public.who_global_data_import VALUES (16880, '2020-03-22', 'CN', 'China', 'WPRO', '1', '81499', '0', '3267');
INSERT INTO public.who_global_data_import VALUES (16881, '2020-03-23', 'CN', 'China', 'WPRO', '104', '81603', '9', '3276');
INSERT INTO public.who_global_data_import VALUES (16882, '2020-03-24', 'CN', 'China', 'WPRO', '164', '81767', '7', '3283');
INSERT INTO public.who_global_data_import VALUES (16883, '2020-03-25', 'CN', 'China', 'WPRO', '102', '81869', '4', '3287');
INSERT INTO public.who_global_data_import VALUES (16884, '2020-03-26', 'CN', 'China', 'WPRO', '92', '81961', '6', '3293');
INSERT INTO public.who_global_data_import VALUES (16885, '2020-03-27', 'CN', 'China', 'WPRO', '132', '82093', '5', '3298');
INSERT INTO public.who_global_data_import VALUES (16886, '2020-03-28', 'CN', 'China', 'WPRO', '120', '82213', '3', '3301');
INSERT INTO public.who_global_data_import VALUES (16887, '2020-03-29', 'CN', 'China', 'WPRO', '128', '82341', '5', '3306');
INSERT INTO public.who_global_data_import VALUES (16888, '2020-03-30', 'CN', 'China', 'WPRO', '114', '82455', '4', '3310');
INSERT INTO public.who_global_data_import VALUES (16889, '2020-03-31', 'CN', 'China', 'WPRO', '90', '82545', '4', '3314');
INSERT INTO public.who_global_data_import VALUES (16890, '2020-04-01', 'CN', 'China', 'WPRO', '93', '82638', '7', '3321');
INSERT INTO public.who_global_data_import VALUES (16891, '2020-04-02', 'CN', 'China', 'WPRO', '86', '82724', '6', '3327');
INSERT INTO public.who_global_data_import VALUES (16892, '2020-04-03', 'CN', 'China', 'WPRO', '78', '82802', '4', '3331');
INSERT INTO public.who_global_data_import VALUES (16893, '2020-04-04', 'CN', 'China', 'WPRO', '73', '82875', '4', '3335');
INSERT INTO public.who_global_data_import VALUES (16894, '2020-04-05', 'CN', 'China', 'WPRO', '55', '82930', '3', '3338');
INSERT INTO public.who_global_data_import VALUES (16895, '2020-04-06', 'CN', 'China', 'WPRO', '75', '83005', '2', '3340');
INSERT INTO public.who_global_data_import VALUES (16896, '2020-04-07', 'CN', 'China', 'WPRO', '66', '83071', '0', '3340');
INSERT INTO public.who_global_data_import VALUES (16897, '2020-04-08', 'CN', 'China', 'WPRO', '90', '83161', '2', '3342');
INSERT INTO public.who_global_data_import VALUES (16898, '2020-04-09', 'CN', 'China', 'WPRO', '88', '83249', '2', '3344');
INSERT INTO public.who_global_data_import VALUES (16899, '2020-04-10', 'CN', 'China', 'WPRO', '56', '83305', '1', '3345');
INSERT INTO public.who_global_data_import VALUES (16900, '2020-04-11', 'CN', 'China', 'WPRO', '78', '83383', '4', '3349');
INSERT INTO public.who_global_data_import VALUES (16901, '2020-04-12', 'CN', 'China', 'WPRO', '102', '83485', '0', '3349');
INSERT INTO public.who_global_data_import VALUES (16902, '2020-04-13', 'CN', 'China', 'WPRO', '112', '83597', '2', '3351');
INSERT INTO public.who_global_data_import VALUES (16903, '2020-04-14', 'CN', 'China', 'WPRO', '99', '83696', '0', '3351');
INSERT INTO public.who_global_data_import VALUES (16904, '2020-04-15', 'CN', 'China', 'WPRO', '51', '83747', '1', '3352');
INSERT INTO public.who_global_data_import VALUES (16905, '2020-04-16', 'CN', 'China', 'WPRO', '50', '83797', '0', '3352');
INSERT INTO public.who_global_data_import VALUES (16906, '2020-04-17', 'CN', 'China', 'WPRO', '352', '84149', '1290', '4642');
INSERT INTO public.who_global_data_import VALUES (16907, '2020-04-18', 'CN', 'China', 'WPRO', '31', '84180', '0', '4642');
INSERT INTO public.who_global_data_import VALUES (16908, '2020-04-19', 'CN', 'China', 'WPRO', '43', '84223', '0', '4642');
INSERT INTO public.who_global_data_import VALUES (16909, '2020-04-20', 'CN', 'China', 'WPRO', '16', '84239', '0', '4642');
INSERT INTO public.who_global_data_import VALUES (16910, '2020-04-21', 'CN', 'China', 'WPRO', '14', '84253', '0', '4642');
INSERT INTO public.who_global_data_import VALUES (16911, '2020-04-22', 'CN', 'China', 'WPRO', '35', '84288', '0', '4642');
INSERT INTO public.who_global_data_import VALUES (16912, '2020-04-23', 'CN', 'China', 'WPRO', '15', '84303', '0', '4642');
INSERT INTO public.who_global_data_import VALUES (16913, '2020-04-24', 'CN', 'China', 'WPRO', '9', '84312', '0', '4642');
INSERT INTO public.who_global_data_import VALUES (16914, '2020-04-25', 'CN', 'China', 'WPRO', '12', '84324', '0', '4642');
INSERT INTO public.who_global_data_import VALUES (16915, '2020-04-26', 'CN', 'China', 'WPRO', '14', '84338', '0', '4642');
INSERT INTO public.who_global_data_import VALUES (16916, '2020-04-27', 'CN', 'China', 'WPRO', '3', '84341', '1', '4643');
INSERT INTO public.who_global_data_import VALUES (16917, '2020-04-28', 'CN', 'China', 'WPRO', '6', '84347', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16918, '2020-04-29', 'CN', 'China', 'WPRO', '22', '84369', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16919, '2020-04-30', 'CN', 'China', 'WPRO', '4', '84373', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16920, '2020-05-01', 'CN', 'China', 'WPRO', '12', '84385', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16921, '2020-05-02', 'CN', 'China', 'WPRO', '6', '84391', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16922, '2020-05-03', 'CN', 'China', 'WPRO', '2', '84393', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16923, '2020-05-04', 'CN', 'China', 'WPRO', '8', '84401', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16924, '2020-05-05', 'CN', 'China', 'WPRO', '3', '84404', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16925, '2020-05-06', 'CN', 'China', 'WPRO', '2', '84406', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16926, '2020-05-07', 'CN', 'China', 'WPRO', '3', '84409', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16927, '2020-05-08', 'CN', 'China', 'WPRO', '6', '84415', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16928, '2020-05-09', 'CN', 'China', 'WPRO', '1', '84416', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16929, '2020-05-10', 'CN', 'China', 'WPRO', '14', '84430', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16930, '2020-05-11', 'CN', 'China', 'WPRO', '20', '84450', '0', '4643');
INSERT INTO public.who_global_data_import VALUES (16931, '2020-05-12', 'CN', 'China', 'WPRO', '1', '84451', '1', '4644');
INSERT INTO public.who_global_data_import VALUES (16932, '2020-05-13', 'CN', 'China', 'WPRO', '7', '84458', '0', '4644');
INSERT INTO public.who_global_data_import VALUES (16933, '2020-05-14', 'CN', 'China', 'WPRO', '6', '84464', '0', '4644');
INSERT INTO public.who_global_data_import VALUES (16934, '2020-05-15', 'CN', 'China', 'WPRO', '5', '84469', '0', '4644');
INSERT INTO public.who_global_data_import VALUES (16935, '2020-05-16', 'CN', 'China', 'WPRO', '9', '84478', '0', '4644');
INSERT INTO public.who_global_data_import VALUES (16936, '2020-05-17', 'CN', 'China', 'WPRO', '6', '84484', '1', '4645');
INSERT INTO public.who_global_data_import VALUES (16937, '2020-05-18', 'CN', 'China', 'WPRO', '10', '84494', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16938, '2020-05-19', 'CN', 'China', 'WPRO', '6', '84500', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16939, '2020-05-20', 'CN', 'China', 'WPRO', '5', '84505', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16940, '2020-05-21', 'CN', 'China', 'WPRO', '2', '84507', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16941, '2020-05-22', 'CN', 'China', 'WPRO', '13', '84520', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16942, '2020-05-23', 'CN', 'China', 'WPRO', '2', '84522', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16943, '2020-05-24', 'CN', 'China', 'WPRO', '3', '84525', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16944, '2020-05-25', 'CN', 'China', 'WPRO', '11', '84536', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16945, '2020-05-26', 'CN', 'China', 'WPRO', '7', '84543', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16946, '2020-05-27', 'CN', 'China', 'WPRO', '1', '84544', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16947, '2020-05-28', 'CN', 'China', 'WPRO', '3', '84547', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16948, '2020-05-29', 'CN', 'China', 'WPRO', '0', '84547', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16949, '2020-05-30', 'CN', 'China', 'WPRO', '18', '84565', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16950, '2020-05-31', 'CN', 'China', 'WPRO', '5', '84570', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16951, '2020-06-01', 'CN', 'China', 'WPRO', '18', '84588', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16952, '2020-06-02', 'CN', 'China', 'WPRO', '9', '84597', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16953, '2020-06-03', 'CN', 'China', 'WPRO', '5', '84602', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16954, '2020-06-04', 'CN', 'China', 'WPRO', '1', '84603', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16955, '2020-06-05', 'CN', 'China', 'WPRO', '11', '84614', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16956, '2020-06-06', 'CN', 'China', 'WPRO', '6', '84620', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16957, '2020-06-07', 'CN', 'China', 'WPRO', '9', '84629', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16958, '2020-06-08', 'CN', 'China', 'WPRO', '5', '84634', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16959, '2020-06-09', 'CN', 'China', 'WPRO', '4', '84638', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16960, '2020-06-10', 'CN', 'China', 'WPRO', '3', '84641', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16961, '2020-06-11', 'CN', 'China', 'WPRO', '11', '84652', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16962, '2020-06-12', 'CN', 'China', 'WPRO', '7', '84659', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16963, '2020-06-13', 'CN', 'China', 'WPRO', '12', '84671', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16964, '2020-06-14', 'CN', 'China', 'WPRO', '58', '84729', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16965, '2020-06-15', 'CN', 'China', 'WPRO', '49', '84778', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16966, '2020-06-16', 'CN', 'China', 'WPRO', '45', '84823', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16967, '2020-06-17', 'CN', 'China', 'WPRO', '44', '84867', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16968, '2020-06-18', 'CN', 'China', 'WPRO', '36', '84903', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16969, '2020-06-19', 'CN', 'China', 'WPRO', '37', '84940', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16970, '2020-06-20', 'CN', 'China', 'WPRO', '30', '84970', '0', '4645');
INSERT INTO public.who_global_data_import VALUES (16971, '2020-06-21', 'CN', 'China', 'WPRO', '27', '84997', '1', '4646');
INSERT INTO public.who_global_data_import VALUES (16972, '2020-06-22', 'CN', 'China', 'WPRO', '21', '85018', '0', '4646');
INSERT INTO public.who_global_data_import VALUES (16973, '2020-06-23', 'CN', 'China', 'WPRO', '52', '85070', '0', '4646');
INSERT INTO public.who_global_data_import VALUES (16974, '2020-06-24', 'CN', 'China', 'WPRO', '28', '85098', '1', '4647');
INSERT INTO public.who_global_data_import VALUES (16975, '2020-06-25', 'CN', 'China', 'WPRO', '21', '85119', '0', '4647');
INSERT INTO public.who_global_data_import VALUES (16976, '2020-06-26', 'CN', 'China', 'WPRO', '29', '85148', '1', '4648');
INSERT INTO public.who_global_data_import VALUES (16977, '2020-06-27', 'CN', 'China', 'WPRO', '24', '85172', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16978, '2020-06-28', 'CN', 'China', 'WPRO', '18', '85190', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16979, '2020-06-29', 'CN', 'China', 'WPRO', '14', '85204', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16980, '2020-06-30', 'CN', 'China', 'WPRO', '23', '85227', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16981, '2020-07-01', 'CN', 'China', 'WPRO', '5', '85232', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16982, '2020-07-02', 'CN', 'China', 'WPRO', '31', '85263', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16983, '2020-07-03', 'CN', 'China', 'WPRO', '15', '85278', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16984, '2020-07-04', 'CN', 'China', 'WPRO', '9', '85287', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16985, '2020-07-05', 'CN', 'China', 'WPRO', '19', '85306', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16986, '2020-07-06', 'CN', 'China', 'WPRO', '14', '85320', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16987, '2020-07-07', 'CN', 'China', 'WPRO', '25', '85345', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16988, '2020-07-08', 'CN', 'China', 'WPRO', '21', '85366', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16989, '2020-07-09', 'CN', 'China', 'WPRO', '33', '85399', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16990, '2020-07-10', 'CN', 'China', 'WPRO', '46', '85445', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16991, '2020-07-11', 'CN', 'China', 'WPRO', '42', '85487', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16992, '2020-07-12', 'CN', 'China', 'WPRO', '35', '85522', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16993, '2020-07-13', 'CN', 'China', 'WPRO', '46', '85568', '0', '4648');
INSERT INTO public.who_global_data_import VALUES (16994, '2020-07-14', 'CN', 'China', 'WPRO', '55', '85623', '1', '4649');
INSERT INTO public.who_global_data_import VALUES (16995, '2020-07-15', 'CN', 'China', 'WPRO', '54', '85677', '0', '4649');
INSERT INTO public.who_global_data_import VALUES (16996, '2020-07-16', 'CN', 'China', 'WPRO', '20', '85697', '2', '4651');
INSERT INTO public.who_global_data_import VALUES (16997, '2020-07-17', 'CN', 'China', 'WPRO', '78', '85775', '0', '4651');
INSERT INTO public.who_global_data_import VALUES (16998, '2020-07-18', 'CN', 'China', 'WPRO', '82', '85857', '1', '4652');
INSERT INTO public.who_global_data_import VALUES (16999, '2020-07-19', 'CN', 'China', 'WPRO', '80', '85937', '1', '4653');
INSERT INTO public.who_global_data_import VALUES (17000, '2020-07-20', 'CN', 'China', 'WPRO', '131', '86068', '0', '4653');
INSERT INTO public.who_global_data_import VALUES (17001, '2020-07-21', 'CN', 'China', 'WPRO', '84', '86152', '0', '4653');
INSERT INTO public.who_global_data_import VALUES (17002, '2020-07-22', 'CN', 'China', 'WPRO', '74', '86226', '2', '4655');
INSERT INTO public.who_global_data_import VALUES (17003, '2020-07-23', 'CN', 'China', 'WPRO', '135', '86361', '0', '4655');
INSERT INTO public.who_global_data_import VALUES (17004, '2020-07-24', 'CN', 'China', 'WPRO', '139', '86500', '1', '4656');
INSERT INTO public.who_global_data_import VALUES (17005, '2020-07-25', 'CN', 'China', 'WPRO', '160', '86660', '1', '4657');
INSERT INTO public.who_global_data_import VALUES (17006, '2020-07-26', 'CN', 'China', 'WPRO', '179', '86839', '2', '4659');
INSERT INTO public.who_global_data_import VALUES (17007, '2020-07-27', 'CN', 'China', 'WPRO', '189', '87028', '0', '4659');
INSERT INTO public.who_global_data_import VALUES (17008, '2020-07-28', 'CN', 'China', 'WPRO', '217', '87245', '4', '4663');
INSERT INTO public.who_global_data_import VALUES (17009, '2020-07-29', 'CN', 'China', 'WPRO', '212', '87457', '1', '4664');
INSERT INTO public.who_global_data_import VALUES (17010, '2020-07-30', 'CN', 'China', 'WPRO', '223', '87680', '1', '4665');
INSERT INTO public.who_global_data_import VALUES (17011, '2020-07-31', 'CN', 'China', 'WPRO', '276', '87956', '1', '4666');
INSERT INTO public.who_global_data_import VALUES (17012, '2020-08-01', 'CN', 'China', 'WPRO', '166', '88122', '2', '4668');
INSERT INTO public.who_global_data_import VALUES (17013, '2020-08-02', 'CN', 'China', 'WPRO', '180', '88302', '6', '4674');
INSERT INTO public.who_global_data_import VALUES (17014, '2020-08-03', 'CN', 'China', 'WPRO', '157', '88459', '2', '4676');
INSERT INTO public.who_global_data_import VALUES (17015, '2020-08-04', 'CN', 'China', 'WPRO', '114', '88573', '3', '4679');
INSERT INTO public.who_global_data_import VALUES (17016, '2020-08-05', 'CN', 'China', 'WPRO', '109', '88682', '4', '4683');
INSERT INTO public.who_global_data_import VALUES (17017, '2020-08-06', 'CN', 'China', 'WPRO', '122', '88804', '1', '4684');
INSERT INTO public.who_global_data_import VALUES (17018, '2020-08-07', 'CN', 'China', 'WPRO', '133', '88937', '3', '4687');
INSERT INTO public.who_global_data_import VALUES (17019, '2020-08-08', 'CN', 'China', 'WPRO', '120', '89057', '1', '4688');
INSERT INTO public.who_global_data_import VALUES (17020, '2020-08-09', 'CN', 'China', 'WPRO', '92', '89149', '0', '4688');
INSERT INTO public.who_global_data_import VALUES (17021, '2020-08-10', 'CN', 'China', 'WPRO', '121', '89270', '5', '4693');
INSERT INTO public.who_global_data_import VALUES (17022, '2020-08-11', 'CN', 'China', 'WPRO', '113', '89383', '3', '4696');
INSERT INTO public.who_global_data_import VALUES (17023, '2020-08-12', 'CN', 'China', 'WPRO', '61', '89444', '3', '4699');
INSERT INTO public.who_global_data_import VALUES (17024, '2020-08-13', 'CN', 'China', 'WPRO', '82', '89526', '5', '4704');
INSERT INTO public.who_global_data_import VALUES (17025, '2020-08-14', 'CN', 'China', 'WPRO', '99', '89625', '3', '4707');
INSERT INTO public.who_global_data_import VALUES (17026, '2020-08-15', 'CN', 'China', 'WPRO', '70', '89695', '1', '4708');
INSERT INTO public.who_global_data_import VALUES (17027, '2020-08-16', 'CN', 'China', 'WPRO', '66', '89761', '2', '4710');
INSERT INTO public.who_global_data_import VALUES (17028, '2020-08-17', 'CN', 'China', 'WPRO', '98', '89859', '0', '4710');
INSERT INTO public.who_global_data_import VALUES (17029, '2020-08-18', 'CN', 'China', 'WPRO', '67', '89926', '0', '4710');
INSERT INTO public.who_global_data_import VALUES (17030, '2020-08-19', 'CN', 'China', 'WPRO', '54', '89980', '2', '4712');
INSERT INTO public.who_global_data_import VALUES (17031, '2020-08-20', 'CN', 'China', 'WPRO', '33', '90013', '1', '4713');
INSERT INTO public.who_global_data_import VALUES (17032, '2020-08-21', 'CN', 'China', 'WPRO', '40', '90053', '3', '4716');
INSERT INTO public.who_global_data_import VALUES (17033, '2020-08-22', 'CN', 'China', 'WPRO', '50', '90103', '0', '4716');
INSERT INTO public.who_global_data_import VALUES (17034, '2020-08-23', 'CN', 'China', 'WPRO', '38', '90141', '1', '4717');
INSERT INTO public.who_global_data_import VALUES (17035, '2020-08-24', 'CN', 'China', 'WPRO', '41', '90182', '1', '4718');
INSERT INTO public.who_global_data_import VALUES (17036, '2020-08-25', 'CN', 'China', 'WPRO', '23', '90205', '0', '4718');
INSERT INTO public.who_global_data_import VALUES (17037, '2020-08-26', 'CN', 'China', 'WPRO', '34', '90239', '1', '4719');
INSERT INTO public.who_global_data_import VALUES (17038, '2020-08-27', 'CN', 'China', 'WPRO', '32', '90271', '1', '4720');
INSERT INTO public.who_global_data_import VALUES (17039, '2020-08-28', 'CN', 'China', 'WPRO', '30', '90301', '2', '4722');
INSERT INTO public.who_global_data_import VALUES (17040, '2020-08-29', 'CN', 'China', 'WPRO', '22', '90323', '3', '4725');
INSERT INTO public.who_global_data_import VALUES (17041, '2020-08-30', 'CN', 'China', 'WPRO', '28', '90351', '3', '4728');
INSERT INTO public.who_global_data_import VALUES (17042, '2020-08-31', 'CN', 'China', 'WPRO', '32', '90383', '1', '4729');
INSERT INTO public.who_global_data_import VALUES (17043, '2020-09-01', 'CN', 'China', 'WPRO', '19', '90402', '1', '4730');
INSERT INTO public.who_global_data_import VALUES (17044, '2020-09-02', 'CN', 'China', 'WPRO', '20', '90422', '1', '4731');
INSERT INTO public.who_global_data_import VALUES (17045, '2020-09-03', 'CN', 'China', 'WPRO', '20', '90442', '3', '4734');
INSERT INTO public.who_global_data_import VALUES (17046, '2020-09-04', 'CN', 'China', 'WPRO', '33', '90475', '1', '4735');
INSERT INTO public.who_global_data_import VALUES (17047, '2020-09-05', 'CN', 'China', 'WPRO', '23', '90498', '0', '4735');
INSERT INTO public.who_global_data_import VALUES (17048, '2020-09-06', 'CN', 'China', 'WPRO', '19', '90517', '0', '4735');
INSERT INTO public.who_global_data_import VALUES (17049, '2020-09-07', 'CN', 'China', 'WPRO', '34', '90551', '2', '4737');
INSERT INTO public.who_global_data_import VALUES (17050, '2020-09-08', 'CN', 'China', 'WPRO', '22', '90573', '2', '4739');
INSERT INTO public.who_global_data_import VALUES (17051, '2020-09-09', 'CN', 'China', 'WPRO', '9', '90582', '1', '4740');
INSERT INTO public.who_global_data_import VALUES (17052, '2020-09-10', 'CN', 'China', 'WPRO', '13', '90595', '0', '4740');
INSERT INTO public.who_global_data_import VALUES (17053, '2020-09-11', 'CN', 'China', 'WPRO', '28', '90623', '0', '4740');
INSERT INTO public.who_global_data_import VALUES (17054, '2020-09-12', 'CN', 'China', 'WPRO', '20', '90643', '0', '4740');
INSERT INTO public.who_global_data_import VALUES (17055, '2020-09-13', 'CN', 'China', 'WPRO', '23', '90666', '1', '4741');
INSERT INTO public.who_global_data_import VALUES (17056, '2020-09-14', 'CN', 'China', 'WPRO', '29', '90695', '0', '4741');
INSERT INTO public.who_global_data_import VALUES (17057, '2020-09-15', 'CN', 'China', 'WPRO', '23', '90718', '1', '4742');
INSERT INTO public.who_global_data_import VALUES (17058, '2020-09-16', 'CN', 'China', 'WPRO', '16', '90734', '1', '4743');
INSERT INTO public.who_global_data_import VALUES (17059, '2020-09-17', 'CN', 'China', 'WPRO', '19', '90753', '0', '4743');
INSERT INTO public.who_global_data_import VALUES (17060, '2020-09-18', 'CN', 'China', 'WPRO', '44', '90797', '0', '4743');
INSERT INTO public.who_global_data_import VALUES (17061, '2020-09-19', 'CN', 'China', 'WPRO', '17', '90814', '1', '4744');
INSERT INTO public.who_global_data_import VALUES (17062, '2020-09-20', 'CN', 'China', 'WPRO', '26', '90840', '0', '4744');
INSERT INTO public.who_global_data_import VALUES (17063, '2020-09-21', 'CN', 'China', 'WPRO', '36', '90876', '0', '4744');
INSERT INTO public.who_global_data_import VALUES (17064, '2020-09-22', 'CN', 'China', 'WPRO', '14', '90890', '0', '4744');
INSERT INTO public.who_global_data_import VALUES (17065, '2020-09-23', 'CN', 'China', 'WPRO', '18', '90908', '0', '4744');
INSERT INTO public.who_global_data_import VALUES (17066, '2020-09-24', 'CN', 'China', 'WPRO', '10', '90918', '1', '4745');
INSERT INTO public.who_global_data_import VALUES (17067, '2020-09-25', 'CN', 'China', 'WPRO', '15', '90933', '0', '4745');
INSERT INTO public.who_global_data_import VALUES (17068, '2020-09-26', 'CN', 'China', 'WPRO', '18', '90951', '1', '4746');
INSERT INTO public.who_global_data_import VALUES (17069, '2020-09-27', 'CN', 'China', 'WPRO', '15', '90966', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17070, '2020-09-28', 'CN', 'China', 'WPRO', '27', '90993', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17071, '2020-09-29', 'CN', 'China', 'WPRO', '25', '91018', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17072, '2020-09-30', 'CN', 'China', 'WPRO', '23', '91041', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17073, '2020-10-01', 'CN', 'China', 'WPRO', '20', '91061', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17074, '2020-10-02', 'CN', 'China', 'WPRO', '21', '91082', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17075, '2020-10-03', 'CN', 'China', 'WPRO', '19', '91101', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17076, '2020-10-04', 'CN', 'China', 'WPRO', '20', '91121', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17077, '2020-10-05', 'CN', 'China', 'WPRO', '25', '91146', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17078, '2020-10-06', 'CN', 'China', 'WPRO', '24', '91170', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17079, '2020-10-07', 'CN', 'China', 'WPRO', '18', '91188', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17080, '2020-10-08', 'CN', 'China', 'WPRO', '24', '91212', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17081, '2020-10-09', 'CN', 'China', 'WPRO', '40', '91252', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17082, '2020-10-10', 'CN', 'China', 'WPRO', '26', '91278', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17083, '2020-10-11', 'CN', 'China', 'WPRO', '27', '91305', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17084, '2020-10-12', 'CN', 'China', 'WPRO', '28', '91333', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17085, '2020-10-13', 'CN', 'China', 'WPRO', '26', '91359', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17086, '2020-10-14', 'CN', 'China', 'WPRO', '28', '91387', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17087, '2020-10-15', 'CN', 'China', 'WPRO', '12', '91399', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17088, '2020-10-16', 'CN', 'China', 'WPRO', '37', '91436', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17089, '2020-10-17', 'CN', 'China', 'WPRO', '24', '91460', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17090, '2020-10-18', 'CN', 'China', 'WPRO', '30', '91490', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17091, '2020-10-19', 'CN', 'China', 'WPRO', '17', '91507', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17092, '2020-10-20', 'CN', 'China', 'WPRO', '39', '91546', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17093, '2020-10-21', 'CN', 'China', 'WPRO', '19', '91565', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17094, '2020-10-22', 'CN', 'China', 'WPRO', '23', '91588', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17095, '2020-10-23', 'CN', 'China', 'WPRO', '33', '91621', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17096, '2020-10-24', 'CN', 'China', 'WPRO', '32', '91653', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17097, '2020-10-25', 'CN', 'China', 'WPRO', '22', '91675', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17098, '2020-10-26', 'CN', 'China', 'WPRO', '26', '91701', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17099, '2020-10-27', 'CN', 'China', 'WPRO', '24', '91725', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17100, '2020-10-28', 'CN', 'China', 'WPRO', '47', '91772', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17101, '2020-10-29', 'CN', 'China', 'WPRO', '49', '91821', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17102, '2020-10-30', 'CN', 'China', 'WPRO', '31', '91852', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17103, '2020-10-31', 'CN', 'China', 'WPRO', '41', '91893', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17104, '2020-11-01', 'CN', 'China', 'WPRO', '28', '91921', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17105, '2020-11-02', 'CN', 'China', 'WPRO', '34', '91955', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17106, '2020-11-03', 'CN', 'China', 'WPRO', '60', '92015', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17107, '2020-11-04', 'CN', 'China', 'WPRO', '30', '92045', '0', '4746');
INSERT INTO public.who_global_data_import VALUES (17108, '2020-11-05', 'CN', 'China', 'WPRO', '32', '92077', '1', '4747');
INSERT INTO public.who_global_data_import VALUES (17109, '2020-11-06', 'CN', 'China', 'WPRO', '44', '92121', '1', '4748');
INSERT INTO public.who_global_data_import VALUES (17110, '2020-11-07', 'CN', 'China', 'WPRO', '43', '92164', '0', '4748');
INSERT INTO public.who_global_data_import VALUES (17111, '2020-11-08', 'CN', 'China', 'WPRO', '31', '92195', '0', '4748');
INSERT INTO public.who_global_data_import VALUES (17112, '2020-11-09', 'CN', 'China', 'WPRO', '47', '92242', '0', '4748');
INSERT INTO public.who_global_data_import VALUES (17113, '2020-11-10', 'CN', 'China', 'WPRO', '29', '92271', '0', '4748');
INSERT INTO public.who_global_data_import VALUES (17114, '2020-11-11', 'CN', 'China', 'WPRO', '28', '92299', '1', '4749');
INSERT INTO public.who_global_data_import VALUES (17115, '2020-11-12', 'CN', 'China', 'WPRO', '37', '92336', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17116, '2020-11-13', 'CN', 'China', 'WPRO', '36', '92372', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17117, '2020-11-14', 'CN', 'China', 'WPRO', '32', '92404', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17118, '2020-11-15', 'CN', 'China', 'WPRO', '24', '92428', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17119, '2020-11-16', 'CN', 'China', 'WPRO', '24', '92452', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17120, '2020-11-17', 'CN', 'China', 'WPRO', '24', '92476', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17121, '2020-11-18', 'CN', 'China', 'WPRO', '14', '92490', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17122, '2020-11-19', 'CN', 'China', 'WPRO', '23', '92513', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17123, '2020-11-20', 'CN', 'China', 'WPRO', '31', '92544', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17124, '2020-11-21', 'CN', 'China', 'WPRO', '44', '92588', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17125, '2020-11-22', 'CN', 'China', 'WPRO', '60', '92648', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17126, '2020-11-23', 'CN', 'China', 'WPRO', '85', '92733', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17127, '2020-11-24', 'CN', 'China', 'WPRO', '96', '92829', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17128, '2020-11-25', 'CN', 'China', 'WPRO', '85', '92914', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17129, '2020-11-26', 'CN', 'China', 'WPRO', '111', '93025', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17130, '2020-11-27', 'CN', 'China', 'WPRO', '88', '93113', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17131, '2020-11-28', 'CN', 'China', 'WPRO', '112', '93225', '0', '4749');
INSERT INTO public.who_global_data_import VALUES (17132, '2020-11-29', 'CN', 'China', 'WPRO', '104', '93329', '1', '4750');
INSERT INTO public.who_global_data_import VALUES (17133, '2020-11-30', 'CN', 'China', 'WPRO', '136', '93465', '0', '4750');
INSERT INTO public.who_global_data_import VALUES (17134, '2020-12-01', 'CN', 'China', 'WPRO', '112', '93577', '0', '4750');
INSERT INTO public.who_global_data_import VALUES (17135, '2020-12-02', 'CN', 'China', 'WPRO', '91', '93668', '0', '4750');
INSERT INTO public.who_global_data_import VALUES (17136, '2020-12-03', 'CN', 'China', 'WPRO', '129', '93797', '1', '4751');
INSERT INTO public.who_global_data_import VALUES (17137, '2020-12-04', 'CN', 'China', 'WPRO', '108', '93905', '1', '4752');
INSERT INTO public.who_global_data_import VALUES (17138, '2020-12-05', 'CN', 'China', 'WPRO', '133', '94038', '1', '4753');
INSERT INTO public.who_global_data_import VALUES (17139, '2020-12-06', 'CN', 'China', 'WPRO', '122', '94160', '0', '4753');
INSERT INTO public.who_global_data_import VALUES (17140, '2020-12-07', 'CN', 'China', 'WPRO', '133', '94293', '0', '4753');
INSERT INTO public.who_global_data_import VALUES (17141, '2020-12-08', 'CN', 'China', 'WPRO', '90', '94383', '0', '4753');
INSERT INTO public.who_global_data_import VALUES (17142, '2020-12-09', 'CN', 'China', 'WPRO', '117', '94500', '0', '4753');
INSERT INTO public.who_global_data_import VALUES (17143, '2020-12-10', 'CN', 'China', 'WPRO', '118', '94618', '2', '4755');
INSERT INTO public.who_global_data_import VALUES (17144, '2020-12-11', 'CN', 'China', 'WPRO', '131', '94749', '0', '4755');
INSERT INTO public.who_global_data_import VALUES (17145, '2020-12-12', 'CN', 'China', 'WPRO', '100', '94849', '0', '4755');
INSERT INTO public.who_global_data_import VALUES (17146, '2020-12-13', 'CN', 'China', 'WPRO', '101', '94950', '1', '4756');
INSERT INTO public.who_global_data_import VALUES (17147, '2020-12-14', 'CN', 'China', 'WPRO', '114', '95064', '2', '4758');
INSERT INTO public.who_global_data_import VALUES (17148, '2020-12-15', 'CN', 'China', 'WPRO', '103', '95167', '3', '4761');
INSERT INTO public.who_global_data_import VALUES (17149, '2020-12-16', 'CN', 'China', 'WPRO', '112', '95279', '3', '4764');
INSERT INTO public.who_global_data_import VALUES (17150, '2020-12-17', 'CN', 'China', 'WPRO', '96', '95375', '0', '4764');
INSERT INTO public.who_global_data_import VALUES (17151, '2020-12-18', 'CN', 'China', 'WPRO', '116', '95491', '2', '4766');
INSERT INTO public.who_global_data_import VALUES (17152, '2020-12-19', 'CN', 'China', 'WPRO', '89', '95580', '4', '4770');
INSERT INTO public.who_global_data_import VALUES (17153, '2020-12-20', 'CN', 'China', 'WPRO', '136', '95716', '0', '4770');
INSERT INTO public.who_global_data_import VALUES (17154, '2020-12-21', 'CN', 'China', 'WPRO', '100', '95816', '1', '4771');
INSERT INTO public.who_global_data_import VALUES (17155, '2020-12-22', 'CN', 'China', 'WPRO', '100', '95916', '1', '4772');
INSERT INTO public.who_global_data_import VALUES (17156, '2020-12-23', 'CN', 'China', 'WPRO', '82', '95998', '1', '4773');
INSERT INTO public.who_global_data_import VALUES (17157, '2020-12-24', 'CN', 'China', 'WPRO', '76', '96074', '1', '4774');
INSERT INTO public.who_global_data_import VALUES (17158, '2020-12-25', 'CN', 'China', 'WPRO', '85', '96159', '2', '4776');
INSERT INTO public.who_global_data_import VALUES (17159, '2020-12-26', 'CN', 'China', 'WPRO', '81', '96240', '1', '4777');
INSERT INTO public.who_global_data_import VALUES (17160, '2020-12-27', 'CN', 'China', 'WPRO', '84', '96324', '0', '4777');
INSERT INTO public.who_global_data_import VALUES (17161, '2020-12-28', 'CN', 'China', 'WPRO', '93', '96417', '1', '4778');
INSERT INTO public.who_global_data_import VALUES (17162, '2020-12-29', 'CN', 'China', 'WPRO', '96', '96513', '4', '4782');
INSERT INTO public.who_global_data_import VALUES (17163, '2020-12-30', 'CN', 'China', 'WPRO', '79', '96592', '2', '4784');
INSERT INTO public.who_global_data_import VALUES (17164, '2020-12-31', 'CN', 'China', 'WPRO', '81', '96673', '4', '4788');
INSERT INTO public.who_global_data_import VALUES (17165, '2021-01-01', 'CN', 'China', 'WPRO', '89', '96762', '1', '4789');
INSERT INTO public.who_global_data_import VALUES (17166, '2021-01-02', 'CN', 'China', 'WPRO', '67', '96829', '1', '4790');
INSERT INTO public.who_global_data_import VALUES (17167, '2021-01-03', 'CN', 'China', 'WPRO', '65', '96894', '1', '4791');
INSERT INTO public.who_global_data_import VALUES (17168, '2021-01-04', 'CN', 'China', 'WPRO', '78', '96972', '0', '4791');
INSERT INTO public.who_global_data_import VALUES (17169, '2021-01-05', 'CN', 'China', 'WPRO', '89', '97061', '3', '4794');
INSERT INTO public.who_global_data_import VALUES (17170, '2021-01-06', 'CN', 'China', 'WPRO', '66', '97127', '0', '4794');
INSERT INTO public.who_global_data_import VALUES (17171, '2021-01-07', 'CN', 'China', 'WPRO', '90', '97217', '1', '4795');
INSERT INTO public.who_global_data_import VALUES (17172, '2021-01-08', 'CN', 'China', 'WPRO', '89', '97306', '0', '4795');
INSERT INTO public.who_global_data_import VALUES (17173, '2021-01-09', 'CN', 'China', 'WPRO', '81', '97387', '1', '4796');
INSERT INTO public.who_global_data_import VALUES (17174, '2021-01-10', 'CN', 'China', 'WPRO', '131', '97518', '2', '4798');
INSERT INTO public.who_global_data_import VALUES (17175, '2021-01-11', 'CN', 'China', 'WPRO', '134', '97652', '1', '4799');
INSERT INTO public.who_global_data_import VALUES (17176, '2021-01-12', 'CN', 'China', 'WPRO', '102', '97754', '1', '4800');
INSERT INTO public.who_global_data_import VALUES (17177, '2021-01-13', 'CN', 'China', 'WPRO', '179', '97933', '1', '4801');
INSERT INTO public.who_global_data_import VALUES (17178, '2021-01-14', 'CN', 'China', 'WPRO', '184', '98117', '2', '4803');
INSERT INTO public.who_global_data_import VALUES (17179, '2021-01-15', 'CN', 'China', 'WPRO', '173', '98290', '0', '4803');
INSERT INTO public.who_global_data_import VALUES (17180, '2021-01-16', 'CN', 'China', 'WPRO', '169', '98459', '0', '4803');
INSERT INTO public.who_global_data_import VALUES (17181, '2021-01-17', 'CN', 'China', 'WPRO', '166', '98625', '1', '4804');
INSERT INTO public.who_global_data_import VALUES (17182, '2021-01-18', 'CN', 'China', 'WPRO', '169', '98794', '0', '4804');
INSERT INTO public.who_global_data_import VALUES (17183, '2021-01-19', 'CN', 'China', 'WPRO', '232', '99026', '1', '4805');
INSERT INTO public.who_global_data_import VALUES (17184, '2021-01-20', 'CN', 'China', 'WPRO', '165', '99191', '2', '4807');
INSERT INTO public.who_global_data_import VALUES (17185, '2021-01-21', 'CN', 'China', 'WPRO', '223', '99414', '1', '4808');
INSERT INTO public.who_global_data_import VALUES (17186, '2021-01-22', 'CN', 'China', 'WPRO', '175', '99589', '1', '4809');
INSERT INTO public.who_global_data_import VALUES (17187, '2021-01-23', 'CN', 'China', 'WPRO', '178', '99767', '1', '4810');
INSERT INTO public.who_global_data_import VALUES (17188, '2021-01-24', 'CN', 'China', 'WPRO', '164', '99931', '0', '4810');
INSERT INTO public.who_global_data_import VALUES (17189, '2021-01-25', 'CN', 'China', 'WPRO', '205', '100136', '1', '4811');
INSERT INTO public.who_global_data_import VALUES (17190, '2021-01-26', 'CN', 'China', 'WPRO', '155', '100291', '3', '4814');
INSERT INTO public.who_global_data_import VALUES (17191, '2021-01-27', 'CN', 'China', 'WPRO', '140', '100431', '2', '4816');
INSERT INTO public.who_global_data_import VALUES (17192, '2021-01-28', 'CN', 'China', 'WPRO', '117', '100548', '2', '4818');
INSERT INTO public.who_global_data_import VALUES (17193, '2021-01-29', 'CN', 'China', 'WPRO', '93', '100641', '2', '4820');
INSERT INTO public.who_global_data_import VALUES (17194, '2021-01-30', 'CN', 'China', 'WPRO', '106', '100747', '1', '4821');
INSERT INTO public.who_global_data_import VALUES (17195, '2021-01-31', 'CN', 'China', 'WPRO', '130', '100877', '2', '4823');
INSERT INTO public.who_global_data_import VALUES (17196, '2021-02-01', 'CN', 'China', 'WPRO', '97', '100974', '2', '4825');
INSERT INTO public.who_global_data_import VALUES (17197, '2021-02-02', 'CN', 'China', 'WPRO', '65', '101039', '1', '4826');
INSERT INTO public.who_global_data_import VALUES (17198, '2021-02-03', 'CN', 'China', 'WPRO', '53', '101092', '2', '4828');
INSERT INTO public.who_global_data_import VALUES (17199, '2021-02-04', 'CN', 'China', 'WPRO', '51', '101143', '1', '4829');
INSERT INTO public.who_global_data_import VALUES (17200, '2021-02-05', 'CN', 'China', 'WPRO', '44', '101187', '2', '4831');
INSERT INTO public.who_global_data_import VALUES (17201, '2020-01-03', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17202, '2020-01-04', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17203, '2020-01-05', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17204, '2020-01-06', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17205, '2020-01-07', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17206, '2020-01-08', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17207, '2020-01-09', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17208, '2020-01-10', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17209, '2020-01-11', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17210, '2020-01-12', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17211, '2020-01-13', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17212, '2020-01-14', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17213, '2020-01-15', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17214, '2020-01-16', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17215, '2020-01-17', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17216, '2020-01-18', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17217, '2020-01-19', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17218, '2020-01-20', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17219, '2020-01-21', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17220, '2020-01-22', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17221, '2020-01-23', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17222, '2020-01-24', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17223, '2020-01-25', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17224, '2020-01-26', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17225, '2020-01-27', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17226, '2020-01-28', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17227, '2020-01-29', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17228, '2020-01-30', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17229, '2020-01-31', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17230, '2020-02-01', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17231, '2020-02-02', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17232, '2020-02-03', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17233, '2020-02-04', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17234, '2020-02-05', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17235, '2020-02-06', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17236, '2020-02-07', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17237, '2020-02-08', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17238, '2020-02-09', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17239, '2020-02-10', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17240, '2020-02-11', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17241, '2020-02-12', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17242, '2020-02-13', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17243, '2020-02-14', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17244, '2020-02-15', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17245, '2020-02-16', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17246, '2020-02-17', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17247, '2020-02-18', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17248, '2020-02-19', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17249, '2020-02-20', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17250, '2020-02-21', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17251, '2020-02-22', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17252, '2020-02-23', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17253, '2020-02-24', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17254, '2020-02-25', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17255, '2020-02-26', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17256, '2020-02-27', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17257, '2020-02-28', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17258, '2020-02-29', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17259, '2020-03-01', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17260, '2020-03-02', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17261, '2020-03-03', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17262, '2020-03-04', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17263, '2020-03-05', 'CO', 'Colombia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17264, '2020-03-06', 'CO', 'Colombia', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17265, '2020-03-07', 'CO', 'Colombia', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17266, '2020-03-08', 'CO', 'Colombia', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17267, '2020-03-09', 'CO', 'Colombia', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17268, '2020-03-10', 'CO', 'Colombia', 'AMRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17269, '2020-03-11', 'CO', 'Colombia', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17270, '2020-03-12', 'CO', 'Colombia', 'AMRO', '6', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17271, '2020-03-13', 'CO', 'Colombia', 'AMRO', '7', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17272, '2020-03-14', 'CO', 'Colombia', 'AMRO', '8', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17273, '2020-03-15', 'CO', 'Colombia', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17274, '2020-03-16', 'CO', 'Colombia', 'AMRO', '10', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17275, '2020-03-17', 'CO', 'Colombia', 'AMRO', '11', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17276, '2020-03-18', 'CO', 'Colombia', 'AMRO', '48', '97', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17277, '2020-03-19', 'CO', 'Colombia', 'AMRO', '11', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17278, '2020-03-20', 'CO', 'Colombia', 'AMRO', '37', '145', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17279, '2020-03-21', 'CO', 'Colombia', 'AMRO', '51', '196', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17280, '2020-03-22', 'CO', 'Colombia', 'AMRO', '0', '196', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17281, '2020-03-23', 'CO', 'Colombia', 'AMRO', '0', '196', '2', '2');
INSERT INTO public.who_global_data_import VALUES (17282, '2020-03-24', 'CO', 'Colombia', 'AMRO', '110', '306', '1', '3');
INSERT INTO public.who_global_data_import VALUES (17283, '2020-03-25', 'CO', 'Colombia', 'AMRO', '0', '306', '0', '3');
INSERT INTO public.who_global_data_import VALUES (17284, '2020-03-26', 'CO', 'Colombia', 'AMRO', '164', '470', '1', '4');
INSERT INTO public.who_global_data_import VALUES (17285, '2020-03-27', 'CO', 'Colombia', 'AMRO', '0', '470', '0', '4');
INSERT INTO public.who_global_data_import VALUES (17286, '2020-03-28', 'CO', 'Colombia', 'AMRO', '21', '491', '2', '6');
INSERT INTO public.who_global_data_import VALUES (17287, '2020-03-29', 'CO', 'Colombia', 'AMRO', '48', '539', '0', '6');
INSERT INTO public.who_global_data_import VALUES (17288, '2020-03-30', 'CO', 'Colombia', 'AMRO', '69', '608', '0', '6');
INSERT INTO public.who_global_data_import VALUES (17289, '2020-03-31', 'CO', 'Colombia', 'AMRO', '94', '702', '4', '10');
INSERT INTO public.who_global_data_import VALUES (17290, '2020-04-01', 'CO', 'Colombia', 'AMRO', '96', '798', '4', '14');
INSERT INTO public.who_global_data_import VALUES (17291, '2020-04-02', 'CO', 'Colombia', 'AMRO', '108', '906', '2', '16');
INSERT INTO public.who_global_data_import VALUES (17292, '2020-04-03', 'CO', 'Colombia', 'AMRO', '159', '1065', '1', '17');
INSERT INTO public.who_global_data_import VALUES (17293, '2020-04-04', 'CO', 'Colombia', 'AMRO', '96', '1161', '2', '19');
INSERT INTO public.who_global_data_import VALUES (17294, '2020-04-05', 'CO', 'Colombia', 'AMRO', '106', '1267', '6', '25');
INSERT INTO public.who_global_data_import VALUES (17295, '2020-04-06', 'CO', 'Colombia', 'AMRO', '139', '1406', '7', '32');
INSERT INTO public.who_global_data_import VALUES (17296, '2020-04-07', 'CO', 'Colombia', 'AMRO', '79', '1485', '3', '35');
INSERT INTO public.who_global_data_import VALUES (17297, '2020-04-08', 'CO', 'Colombia', 'AMRO', '94', '1579', '11', '46');
INSERT INTO public.who_global_data_import VALUES (17298, '2020-04-09', 'CO', 'Colombia', 'AMRO', '201', '1780', '4', '50');
INSERT INTO public.who_global_data_import VALUES (17299, '2020-04-10', 'CO', 'Colombia', 'AMRO', '274', '2054', '5', '55');
INSERT INTO public.who_global_data_import VALUES (17300, '2020-04-11', 'CO', 'Colombia', 'AMRO', '169', '2223', '14', '69');
INSERT INTO public.who_global_data_import VALUES (17301, '2020-04-12', 'CO', 'Colombia', 'AMRO', '250', '2473', '11', '80');
INSERT INTO public.who_global_data_import VALUES (17302, '2020-04-13', 'CO', 'Colombia', 'AMRO', '236', '2709', '20', '100');
INSERT INTO public.who_global_data_import VALUES (17303, '2020-04-14', 'CO', 'Colombia', 'AMRO', '67', '2776', '9', '109');
INSERT INTO public.who_global_data_import VALUES (17304, '2020-04-15', 'CO', 'Colombia', 'AMRO', '76', '2852', '3', '112');
INSERT INTO public.who_global_data_import VALUES (17305, '2020-04-16', 'CO', 'Colombia', 'AMRO', '127', '2979', '15', '127');
INSERT INTO public.who_global_data_import VALUES (17306, '2020-04-17', 'CO', 'Colombia', 'AMRO', '126', '3105', '4', '131');
INSERT INTO public.who_global_data_import VALUES (17307, '2020-04-18', 'CO', 'Colombia', 'AMRO', '128', '3233', '13', '144');
INSERT INTO public.who_global_data_import VALUES (17308, '2020-04-19', 'CO', 'Colombia', 'AMRO', '206', '3439', '9', '153');
INSERT INTO public.who_global_data_import VALUES (17309, '2020-04-20', 'CO', 'Colombia', 'AMRO', '182', '3621', '13', '166');
INSERT INTO public.who_global_data_import VALUES (17310, '2020-04-21', 'CO', 'Colombia', 'AMRO', '171', '3792', '13', '179');
INSERT INTO public.who_global_data_import VALUES (17311, '2020-04-22', 'CO', 'Colombia', 'AMRO', '185', '3977', '10', '189');
INSERT INTO public.who_global_data_import VALUES (17312, '2020-04-23', 'CO', 'Colombia', 'AMRO', '172', '4149', '7', '196');
INSERT INTO public.who_global_data_import VALUES (17313, '2020-04-24', 'CO', 'Colombia', 'AMRO', '207', '4356', '10', '206');
INSERT INTO public.who_global_data_import VALUES (17314, '2020-04-25', 'CO', 'Colombia', 'AMRO', '205', '4561', '9', '215');
INSERT INTO public.who_global_data_import VALUES (17315, '2020-04-26', 'CO', 'Colombia', 'AMRO', '320', '4881', '10', '225');
INSERT INTO public.who_global_data_import VALUES (17316, '2020-04-27', 'CO', 'Colombia', 'AMRO', '261', '5142', '8', '233');
INSERT INTO public.who_global_data_import VALUES (17317, '2020-04-28', 'CO', 'Colombia', 'AMRO', '237', '5379', '11', '244');
INSERT INTO public.who_global_data_import VALUES (17318, '2020-04-29', 'CO', 'Colombia', 'AMRO', '218', '5597', '9', '253');
INSERT INTO public.who_global_data_import VALUES (17319, '2020-04-30', 'CO', 'Colombia', 'AMRO', '352', '5949', '16', '269');
INSERT INTO public.who_global_data_import VALUES (17320, '2020-05-01', 'CO', 'Colombia', 'AMRO', '262', '6211', '9', '278');
INSERT INTO public.who_global_data_import VALUES (17321, '2020-05-02', 'CO', 'Colombia', 'AMRO', '296', '6507', '15', '293');
INSERT INTO public.who_global_data_import VALUES (17322, '2020-05-03', 'CO', 'Colombia', 'AMRO', '499', '7006', '21', '314');
INSERT INTO public.who_global_data_import VALUES (17323, '2020-05-04', 'CO', 'Colombia', 'AMRO', '279', '7285', '10', '324');
INSERT INTO public.who_global_data_import VALUES (17324, '2020-05-05', 'CO', 'Colombia', 'AMRO', '383', '7668', '16', '340');
INSERT INTO public.who_global_data_import VALUES (17325, '2020-05-06', 'CO', 'Colombia', 'AMRO', '305', '7973', '18', '358');
INSERT INTO public.who_global_data_import VALUES (17326, '2020-05-07', 'CO', 'Colombia', 'AMRO', '640', '8613', '20', '378');
INSERT INTO public.who_global_data_import VALUES (17327, '2020-05-08', 'CO', 'Colombia', 'AMRO', '346', '8959', '19', '397');
INSERT INTO public.who_global_data_import VALUES (17328, '2020-05-09', 'CO', 'Colombia', 'AMRO', '497', '9456', '10', '407');
INSERT INTO public.who_global_data_import VALUES (17329, '2020-05-10', 'CO', 'Colombia', 'AMRO', '595', '10051', '21', '428');
INSERT INTO public.who_global_data_import VALUES (17330, '2020-05-11', 'CO', 'Colombia', 'AMRO', '444', '10495', '17', '445');
INSERT INTO public.who_global_data_import VALUES (17331, '2020-05-12', 'CO', 'Colombia', 'AMRO', '568', '11063', '18', '463');
INSERT INTO public.who_global_data_import VALUES (17332, '2020-05-13', 'CO', 'Colombia', 'AMRO', '550', '11613', '16', '479');
INSERT INTO public.who_global_data_import VALUES (17333, '2020-05-14', 'CO', 'Colombia', 'AMRO', '659', '12272', '14', '493');
INSERT INTO public.who_global_data_import VALUES (17334, '2020-05-15', 'CO', 'Colombia', 'AMRO', '658', '12930', '16', '509');
INSERT INTO public.who_global_data_import VALUES (17335, '2020-05-16', 'CO', 'Colombia', 'AMRO', '680', '13610', '16', '525');
INSERT INTO public.who_global_data_import VALUES (17336, '2020-05-17', 'CO', 'Colombia', 'AMRO', '606', '14216', '21', '546');
INSERT INTO public.who_global_data_import VALUES (17337, '2020-05-18', 'CO', 'Colombia', 'AMRO', '723', '14939', '16', '562');
INSERT INTO public.who_global_data_import VALUES (17338, '2020-05-19', 'CO', 'Colombia', 'AMRO', '635', '15574', '12', '574');
INSERT INTO public.who_global_data_import VALUES (17339, '2020-05-20', 'CO', 'Colombia', 'AMRO', '721', '16295', '18', '592');
INSERT INTO public.who_global_data_import VALUES (17340, '2020-05-21', 'CO', 'Colombia', 'AMRO', '640', '16935', '21', '613');
INSERT INTO public.who_global_data_import VALUES (17341, '2020-05-22', 'CO', 'Colombia', 'AMRO', '752', '17687', '17', '630');
INSERT INTO public.who_global_data_import VALUES (17342, '2020-05-23', 'CO', 'Colombia', 'AMRO', '643', '18330', '22', '652');
INSERT INTO public.who_global_data_import VALUES (17343, '2020-05-24', 'CO', 'Colombia', 'AMRO', '801', '19131', '30', '682');
INSERT INTO public.who_global_data_import VALUES (17344, '2020-05-25', 'CO', 'Colombia', 'AMRO', '1046', '20177', '23', '705');
INSERT INTO public.who_global_data_import VALUES (17345, '2020-05-26', 'CO', 'Colombia', 'AMRO', '998', '21175', '22', '727');
INSERT INTO public.who_global_data_import VALUES (17346, '2020-05-27', 'CO', 'Colombia', 'AMRO', '806', '21981', '23', '750');
INSERT INTO public.who_global_data_import VALUES (17347, '2020-05-28', 'CO', 'Colombia', 'AMRO', '1022', '23003', '26', '776');
INSERT INTO public.who_global_data_import VALUES (17348, '2020-05-29', 'CO', 'Colombia', 'AMRO', '1101', '24104', '27', '803');
INSERT INTO public.who_global_data_import VALUES (17349, '2020-05-30', 'CO', 'Colombia', 'AMRO', '1262', '25366', '19', '822');
INSERT INTO public.who_global_data_import VALUES (17350, '2020-05-31', 'CO', 'Colombia', 'AMRO', '1322', '26688', '31', '853');
INSERT INTO public.who_global_data_import VALUES (17351, '2020-06-01', 'CO', 'Colombia', 'AMRO', '1548', '28236', '37', '890');
INSERT INTO public.who_global_data_import VALUES (17352, '2020-06-02', 'CO', 'Colombia', 'AMRO', '1147', '29383', '49', '939');
INSERT INTO public.who_global_data_import VALUES (17353, '2020-06-03', 'CO', 'Colombia', 'AMRO', '1110', '30493', '30', '969');
INSERT INTO public.who_global_data_import VALUES (17354, '2020-06-04', 'CO', 'Colombia', 'AMRO', '1340', '31833', '40', '1009');
INSERT INTO public.who_global_data_import VALUES (17355, '2020-06-05', 'CO', 'Colombia', 'AMRO', '1521', '33354', '36', '1045');
INSERT INTO public.who_global_data_import VALUES (17356, '2020-06-06', 'CO', 'Colombia', 'AMRO', '1766', '35120', '42', '1087');
INSERT INTO public.who_global_data_import VALUES (17357, '2020-06-07', 'CO', 'Colombia', 'AMRO', '1515', '36635', '58', '1145');
INSERT INTO public.who_global_data_import VALUES (17358, '2020-06-08', 'CO', 'Colombia', 'AMRO', '1392', '38027', '60', '1205');
INSERT INTO public.who_global_data_import VALUES (17359, '2020-06-09', 'CO', 'Colombia', 'AMRO', '1209', '39236', '54', '1259');
INSERT INTO public.who_global_data_import VALUES (17360, '2020-06-10', 'CO', 'Colombia', 'AMRO', '1483', '40719', '49', '1308');
INSERT INTO public.who_global_data_import VALUES (17361, '2020-06-11', 'CO', 'Colombia', 'AMRO', '1359', '42078', '64', '1372');
INSERT INTO public.who_global_data_import VALUES (17362, '2020-06-12', 'CO', 'Colombia', 'AMRO', '1604', '43682', '61', '1433');
INSERT INTO public.who_global_data_import VALUES (17363, '2020-06-13', 'CO', 'Colombia', 'AMRO', '1530', '45212', '55', '1488');
INSERT INTO public.who_global_data_import VALUES (17364, '2020-06-14', 'CO', 'Colombia', 'AMRO', '1646', '46858', '57', '1545');
INSERT INTO public.who_global_data_import VALUES (17365, '2020-06-15', 'CO', 'Colombia', 'AMRO', '1888', '48746', '47', '1592');
INSERT INTO public.who_global_data_import VALUES (17366, '2020-06-16', 'CO', 'Colombia', 'AMRO', '2193', '50939', '75', '1667');
INSERT INTO public.who_global_data_import VALUES (17367, '2020-06-17', 'CO', 'Colombia', 'AMRO', '2124', '53063', '59', '1726');
INSERT INTO public.who_global_data_import VALUES (17368, '2020-06-18', 'CO', 'Colombia', 'AMRO', '1868', '54931', '75', '1801');
INSERT INTO public.who_global_data_import VALUES (17369, '2020-06-19', 'CO', 'Colombia', 'AMRO', '2115', '57046', '63', '1864');
INSERT INTO public.who_global_data_import VALUES (17370, '2020-06-20', 'CO', 'Colombia', 'AMRO', '3171', '60217', '86', '1950');
INSERT INTO public.who_global_data_import VALUES (17371, '2020-06-21', 'CO', 'Colombia', 'AMRO', '3059', '63276', '95', '2045');
INSERT INTO public.who_global_data_import VALUES (17372, '2020-06-22', 'CO', 'Colombia', 'AMRO', '2357', '65633', '81', '2126');
INSERT INTO public.who_global_data_import VALUES (17373, '2020-06-23', 'CO', 'Colombia', 'AMRO', '3019', '68652', '111', '2237');
INSERT INTO public.who_global_data_import VALUES (17374, '2020-06-24', 'CO', 'Colombia', 'AMRO', '2531', '71183', '73', '2310');
INSERT INTO public.who_global_data_import VALUES (17375, '2020-06-25', 'CO', 'Colombia', 'AMRO', '2389', '73572', '94', '2404');
INSERT INTO public.who_global_data_import VALUES (17376, '2020-06-26', 'CO', 'Colombia', 'AMRO', '3541', '77113', '87', '2491');
INSERT INTO public.who_global_data_import VALUES (17377, '2020-06-27', 'CO', 'Colombia', 'AMRO', '3486', '80599', '163', '2654');
INSERT INTO public.who_global_data_import VALUES (17378, '2020-06-28', 'CO', 'Colombia', 'AMRO', '3843', '84442', '157', '2811');
INSERT INTO public.who_global_data_import VALUES (17379, '2020-06-29', 'CO', 'Colombia', 'AMRO', '4149', '88591', '128', '2939');
INSERT INTO public.who_global_data_import VALUES (17380, '2020-06-30', 'CO', 'Colombia', 'AMRO', '3178', '91769', '167', '3106');
INSERT INTO public.who_global_data_import VALUES (17381, '2020-07-01', 'CO', 'Colombia', 'AMRO', '3274', '95043', '117', '3223');
INSERT INTO public.who_global_data_import VALUES (17382, '2020-07-02', 'CO', 'Colombia', 'AMRO', '2803', '97846', '111', '3334');
INSERT INTO public.who_global_data_import VALUES (17383, '2020-07-03', 'CO', 'Colombia', 'AMRO', '4163', '102009', '136', '3470');
INSERT INTO public.who_global_data_import VALUES (17384, '2020-07-04', 'CO', 'Colombia', 'AMRO', '4101', '106110', '171', '3641');
INSERT INTO public.who_global_data_import VALUES (17385, '2020-07-05', 'CO', 'Colombia', 'AMRO', '3395', '109505', '136', '3777');
INSERT INTO public.who_global_data_import VALUES (17386, '2020-07-06', 'CO', 'Colombia', 'AMRO', '3884', '113389', '165', '3942');
INSERT INTO public.who_global_data_import VALUES (17387, '2020-07-07', 'CO', 'Colombia', 'AMRO', '3721', '117110', '122', '4064');
INSERT INTO public.who_global_data_import VALUES (17388, '2020-07-08', 'CO', 'Colombia', 'AMRO', '3171', '120281', '146', '4210');
INSERT INTO public.who_global_data_import VALUES (17389, '2020-07-09', 'CO', 'Colombia', 'AMRO', '4213', '124494', '149', '4359');
INSERT INTO public.who_global_data_import VALUES (17390, '2020-07-10', 'CO', 'Colombia', 'AMRO', '4144', '128638', '168', '4527');
INSERT INTO public.who_global_data_import VALUES (17391, '2020-07-11', 'CO', 'Colombia', 'AMRO', '5335', '133973', '187', '4714');
INSERT INTO public.who_global_data_import VALUES (17392, '2020-07-12', 'CO', 'Colombia', 'AMRO', '6803', '140776', '211', '4925');
INSERT INTO public.who_global_data_import VALUES (17393, '2020-07-13', 'CO', 'Colombia', 'AMRO', '4586', '145362', '194', '5119');
INSERT INTO public.who_global_data_import VALUES (17394, '2020-07-14', 'CO', 'Colombia', 'AMRO', '5083', '150445', '188', '5307');
INSERT INTO public.who_global_data_import VALUES (17395, '2020-07-15', 'CO', 'Colombia', 'AMRO', '3832', '154277', '148', '5455');
INSERT INTO public.who_global_data_import VALUES (17396, '2020-07-16', 'CO', 'Colombia', 'AMRO', '5621', '159898', '170', '5625');
INSERT INTO public.who_global_data_import VALUES (17397, '2020-07-17', 'CO', 'Colombia', 'AMRO', '5271', '165169', '189', '5814');
INSERT INTO public.who_global_data_import VALUES (17398, '2020-07-18', 'CO', 'Colombia', 'AMRO', '8037', '173206', '215', '6029');
INSERT INTO public.who_global_data_import VALUES (17399, '2020-07-19', 'CO', 'Colombia', 'AMRO', '8934', '182140', '259', '6288');
INSERT INTO public.who_global_data_import VALUES (17400, '2020-07-20', 'CO', 'Colombia', 'AMRO', '8560', '190700', '228', '6516');
INSERT INTO public.who_global_data_import VALUES (17401, '2020-07-21', 'CO', 'Colombia', 'AMRO', '6578', '197278', '220', '6736');
INSERT INTO public.who_global_data_import VALUES (17402, '2020-07-22', 'CO', 'Colombia', 'AMRO', '6727', '204005', '193', '6929');
INSERT INTO public.who_global_data_import VALUES (17403, '2020-07-23', 'CO', 'Colombia', 'AMRO', '7033', '211038', '237', '7166');
INSERT INTO public.who_global_data_import VALUES (17404, '2020-07-24', 'CO', 'Colombia', 'AMRO', '7390', '218428', '207', '7373');
INSERT INTO public.who_global_data_import VALUES (17405, '2020-07-25', 'CO', 'Colombia', 'AMRO', '7945', '226373', '315', '7688');
INSERT INTO public.who_global_data_import VALUES (17406, '2020-07-26', 'CO', 'Colombia', 'AMRO', '7168', '233541', '287', '7975');
INSERT INTO public.who_global_data_import VALUES (17407, '2020-07-27', 'CO', 'Colombia', 'AMRO', '7254', '240795', '294', '8269');
INSERT INTO public.who_global_data_import VALUES (17408, '2020-07-28', 'CO', 'Colombia', 'AMRO', '8181', '248976', '256', '8525');
INSERT INTO public.who_global_data_import VALUES (17409, '2020-07-29', 'CO', 'Colombia', 'AMRO', '8125', '257101', '252', '8777');
INSERT INTO public.who_global_data_import VALUES (17410, '2020-07-30', 'CO', 'Colombia', 'AMRO', '10284', '267385', '297', '9074');
INSERT INTO public.who_global_data_import VALUES (17411, '2020-07-31', 'CO', 'Colombia', 'AMRO', '8670', '276055', '380', '9454');
INSERT INTO public.who_global_data_import VALUES (17412, '2020-08-01', 'CO', 'Colombia', 'AMRO', '9965', '286020', '356', '9810');
INSERT INTO public.who_global_data_import VALUES (17413, '2020-08-02', 'CO', 'Colombia', 'AMRO', '9488', '295508', '295', '10105');
INSERT INTO public.who_global_data_import VALUES (17414, '2020-08-03', 'CO', 'Colombia', 'AMRO', '10673', '306181', '225', '10330');
INSERT INTO public.who_global_data_import VALUES (17415, '2020-08-04', 'CO', 'Colombia', 'AMRO', '11470', '317651', '320', '10650');
INSERT INTO public.who_global_data_import VALUES (17416, '2020-08-05', 'CO', 'Colombia', 'AMRO', '10199', '327850', '367', '11017');
INSERT INTO public.who_global_data_import VALUES (17417, '2020-08-06', 'CO', 'Colombia', 'AMRO', '7129', '334979', '298', '11315');
INSERT INTO public.who_global_data_import VALUES (17418, '2020-08-07', 'CO', 'Colombia', 'AMRO', '10735', '345714', '309', '11624');
INSERT INTO public.who_global_data_import VALUES (17419, '2020-08-08', 'CO', 'Colombia', 'AMRO', '11996', '357710', '315', '11939');
INSERT INTO public.who_global_data_import VALUES (17420, '2020-08-09', 'CO', 'Colombia', 'AMRO', '9486', '367196', '311', '12250');
INSERT INTO public.who_global_data_import VALUES (17421, '2020-08-10', 'CO', 'Colombia', 'AMRO', '9674', '376870', '290', '12540');
INSERT INTO public.who_global_data_import VALUES (17422, '2020-08-11', 'CO', 'Colombia', 'AMRO', '10611', '387481', '302', '12842');
INSERT INTO public.who_global_data_import VALUES (17423, '2020-08-12', 'CO', 'Colombia', 'AMRO', '10142', '397623', '312', '13154');
INSERT INTO public.who_global_data_import VALUES (17424, '2020-08-13', 'CO', 'Colombia', 'AMRO', '12830', '410453', '321', '13475');
INSERT INTO public.who_global_data_import VALUES (17425, '2020-08-14', 'CO', 'Colombia', 'AMRO', '12066', '422519', '362', '13837');
INSERT INTO public.who_global_data_import VALUES (17426, '2020-08-15', 'CO', 'Colombia', 'AMRO', '11286', '433805', '308', '14145');
INSERT INTO public.who_global_data_import VALUES (17427, '2020-08-16', 'CO', 'Colombia', 'AMRO', '11306', '445111', '347', '14492');
INSERT INTO public.who_global_data_import VALUES (17428, '2020-08-17', 'CO', 'Colombia', 'AMRO', '11578', '456689', '318', '14810');
INSERT INTO public.who_global_data_import VALUES (17429, '2020-08-18', 'CO', 'Colombia', 'AMRO', '11643', '468332', '287', '15097');
INSERT INTO public.who_global_data_import VALUES (17430, '2020-08-19', 'CO', 'Colombia', 'AMRO', '8328', '476660', '275', '15372');
INSERT INTO public.who_global_data_import VALUES (17431, '2020-08-20', 'CO', 'Colombia', 'AMRO', '12462', '489122', '247', '15619');
INSERT INTO public.who_global_data_import VALUES (17432, '2020-08-21', 'CO', 'Colombia', 'AMRO', '13056', '502178', '360', '15979');
INSERT INTO public.who_global_data_import VALUES (17433, '2020-08-22', 'CO', 'Colombia', 'AMRO', '11541', '513719', '204', '16183');
INSERT INTO public.who_global_data_import VALUES (17434, '2020-08-23', 'CO', 'Colombia', 'AMRO', '8419', '522138', '385', '16568');
INSERT INTO public.who_global_data_import VALUES (17435, '2020-08-24', 'CO', 'Colombia', 'AMRO', '10965', '533103', '400', '16968');
INSERT INTO public.who_global_data_import VALUES (17436, '2020-08-25', 'CO', 'Colombia', 'AMRO', '8044', '541147', '348', '17316');
INSERT INTO public.who_global_data_import VALUES (17437, '2020-08-26', 'CO', 'Colombia', 'AMRO', '10549', '551696', '296', '17612');
INSERT INTO public.who_global_data_import VALUES (17438, '2020-08-27', 'CO', 'Colombia', 'AMRO', '10432', '562128', '277', '17889');
INSERT INTO public.who_global_data_import VALUES (17439, '2020-08-28', 'CO', 'Colombia', 'AMRO', '10142', '572270', '295', '18184');
INSERT INTO public.who_global_data_import VALUES (17440, '2020-08-29', 'CO', 'Colombia', 'AMRO', '9752', '582022', '284', '18468');
INSERT INTO public.who_global_data_import VALUES (17441, '2020-08-30', 'CO', 'Colombia', 'AMRO', '8498', '590520', '299', '18767');
INSERT INTO public.who_global_data_import VALUES (17442, '2020-08-31', 'CO', 'Colombia', 'AMRO', '9394', '599914', '297', '19064');
INSERT INTO public.who_global_data_import VALUES (17443, '2020-09-01', 'CO', 'Colombia', 'AMRO', '8024', '607938', '300', '19364');
INSERT INTO public.who_global_data_import VALUES (17444, '2020-09-02', 'CO', 'Colombia', 'AMRO', '7230', '615168', '299', '19663');
INSERT INTO public.who_global_data_import VALUES (17445, '2020-09-03', 'CO', 'Colombia', 'AMRO', '8901', '624069', '389', '20052');
INSERT INTO public.who_global_data_import VALUES (17446, '2020-09-04', 'CO', 'Colombia', 'AMRO', '9270', '633339', '296', '20348');
INSERT INTO public.who_global_data_import VALUES (17447, '2020-09-05', 'CO', 'Colombia', 'AMRO', '8235', '641574', '270', '20618');
INSERT INTO public.who_global_data_import VALUES (17448, '2020-09-06', 'CO', 'Colombia', 'AMRO', '8488', '650062', '270', '20888');
INSERT INTO public.who_global_data_import VALUES (17449, '2020-09-07', 'CO', 'Colombia', 'AMRO', '8394', '658456', '268', '21156');
INSERT INTO public.who_global_data_import VALUES (17450, '2020-09-08', 'CO', 'Colombia', 'AMRO', '8065', '666521', '256', '21412');
INSERT INTO public.who_global_data_import VALUES (17451, '2020-09-09', 'CO', 'Colombia', 'AMRO', '5327', '671848', '203', '21615');
INSERT INTO public.who_global_data_import VALUES (17452, '2020-09-10', 'CO', 'Colombia', 'AMRO', '7665', '679513', '202', '21817');
INSERT INTO public.who_global_data_import VALUES (17453, '2020-09-11', 'CO', 'Colombia', 'AMRO', '7338', '686851', '236', '22053');
INSERT INTO public.who_global_data_import VALUES (17454, '2020-09-12', 'CO', 'Colombia', 'AMRO', '7813', '694664', '222', '22275');
INSERT INTO public.who_global_data_import VALUES (17455, '2020-09-13', 'CO', 'Colombia', 'AMRO', '7424', '702088', '243', '22518');
INSERT INTO public.who_global_data_import VALUES (17456, '2020-09-14', 'CO', 'Colombia', 'AMRO', '6876', '708964', '216', '22734');
INSERT INTO public.who_global_data_import VALUES (17457, '2020-09-15', 'CO', 'Colombia', 'AMRO', '7355', '716319', '190', '22924');
INSERT INTO public.who_global_data_import VALUES (17458, '2020-09-16', 'CO', 'Colombia', 'AMRO', '5573', '721892', '199', '23123');
INSERT INTO public.who_global_data_import VALUES (17459, '2020-09-17', 'CO', 'Colombia', 'AMRO', '6698', '728590', '165', '23288');
INSERT INTO public.who_global_data_import VALUES (17460, '2020-09-18', 'CO', 'Colombia', 'AMRO', '7787', '736377', '190', '23478');
INSERT INTO public.who_global_data_import VALUES (17461, '2020-09-19', 'CO', 'Colombia', 'AMRO', '7568', '743945', '187', '23665');
INSERT INTO public.who_global_data_import VALUES (17462, '2020-09-20', 'CO', 'Colombia', 'AMRO', '6526', '750471', '185', '23850');
INSERT INTO public.who_global_data_import VALUES (17463, '2020-09-21', 'CO', 'Colombia', 'AMRO', '7927', '758398', '189', '24039');
INSERT INTO public.who_global_data_import VALUES (17464, '2020-09-22', 'CO', 'Colombia', 'AMRO', '6678', '765076', '169', '24208');
INSERT INTO public.who_global_data_import VALUES (17465, '2020-09-23', 'CO', 'Colombia', 'AMRO', '5359', '770435', '189', '24397');
INSERT INTO public.who_global_data_import VALUES (17466, '2020-09-24', 'CO', 'Colombia', 'AMRO', '7102', '777537', '173', '24570');
INSERT INTO public.who_global_data_import VALUES (17467, '2020-09-25', 'CO', 'Colombia', 'AMRO', '6731', '784268', '176', '24746');
INSERT INTO public.who_global_data_import VALUES (17468, '2020-09-26', 'CO', 'Colombia', 'AMRO', '6555', '790823', '178', '24924');
INSERT INTO public.who_global_data_import VALUES (17469, '2020-09-27', 'CO', 'Colombia', 'AMRO', '7494', '798317', '179', '25103');
INSERT INTO public.who_global_data_import VALUES (17470, '2020-09-28', 'CO', 'Colombia', 'AMRO', '7721', '806038', '193', '25296');
INSERT INTO public.who_global_data_import VALUES (17471, '2020-09-29', 'CO', 'Colombia', 'AMRO', '7018', '813056', '192', '25488');
INSERT INTO public.who_global_data_import VALUES (17472, '2020-09-30', 'CO', 'Colombia', 'AMRO', '5147', '818203', '153', '25641');
INSERT INTO public.who_global_data_import VALUES (17473, '2020-10-01', 'CO', 'Colombia', 'AMRO', '5839', '824042', '187', '25828');
INSERT INTO public.who_global_data_import VALUES (17474, '2020-10-02', 'CO', 'Colombia', 'AMRO', '5637', '829679', '170', '25998');
INSERT INTO public.who_global_data_import VALUES (17475, '2020-10-03', 'CO', 'Colombia', 'AMRO', '5660', '835339', '198', '26196');
INSERT INTO public.who_global_data_import VALUES (17476, '2020-10-04', 'CO', 'Colombia', 'AMRO', '6192', '841531', '201', '26397');
INSERT INTO public.who_global_data_import VALUES (17477, '2020-10-05', 'CO', 'Colombia', 'AMRO', '6616', '848147', '159', '26556');
INSERT INTO public.who_global_data_import VALUES (17478, '2020-10-06', 'CO', 'Colombia', 'AMRO', '6905', '855052', '156', '26712');
INSERT INTO public.who_global_data_import VALUES (17479, '2020-10-07', 'CO', 'Colombia', 'AMRO', '7106', '862158', '132', '26844');
INSERT INTO public.who_global_data_import VALUES (17480, '2020-10-08', 'CO', 'Colombia', 'AMRO', '7650', '869808', '173', '27017');
INSERT INTO public.who_global_data_import VALUES (17481, '2020-10-09', 'CO', 'Colombia', 'AMRO', '7875', '877683', '163', '27180');
INSERT INTO public.who_global_data_import VALUES (17482, '2020-10-10', 'CO', 'Colombia', 'AMRO', '8496', '886179', '151', '27331');
INSERT INTO public.who_global_data_import VALUES (17483, '2020-10-11', 'CO', 'Colombia', 'AMRO', '8121', '894300', '164', '27495');
INSERT INTO public.who_global_data_import VALUES (17484, '2020-10-12', 'CO', 'Colombia', 'AMRO', '8447', '902747', '165', '27660');
INSERT INTO public.who_global_data_import VALUES (17485, '2020-10-13', 'CO', 'Colombia', 'AMRO', '8569', '911316', '174', '27834');
INSERT INTO public.who_global_data_import VALUES (17486, '2020-10-14', 'CO', 'Colombia', 'AMRO', '7767', '919083', '151', '27985');
INSERT INTO public.who_global_data_import VALUES (17487, '2020-10-15', 'CO', 'Colombia', 'AMRO', '5015', '924098', '156', '28141');
INSERT INTO public.who_global_data_import VALUES (17488, '2020-10-16', 'CO', 'Colombia', 'AMRO', '6061', '930159', '165', '28306');
INSERT INTO public.who_global_data_import VALUES (17489, '2020-10-17', 'CO', 'Colombia', 'AMRO', '6823', '936982', '151', '28457');
INSERT INTO public.who_global_data_import VALUES (17490, '2020-10-18', 'CO', 'Colombia', 'AMRO', '8372', '945354', '159', '28616');
INSERT INTO public.who_global_data_import VALUES (17491, '2020-10-19', 'CO', 'Colombia', 'AMRO', '7017', '952371', '187', '28803');
INSERT INTO public.who_global_data_import VALUES (17492, '2020-10-20', 'CO', 'Colombia', 'AMRO', '7201', '959572', '167', '28970');
INSERT INTO public.who_global_data_import VALUES (17493, '2020-10-21', 'CO', 'Colombia', 'AMRO', '6311', '965883', '132', '29102');
INSERT INTO public.who_global_data_import VALUES (17494, '2020-10-22', 'CO', 'Colombia', 'AMRO', '8256', '974139', '170', '29272');
INSERT INTO public.who_global_data_import VALUES (17495, '2020-10-23', 'CO', 'Colombia', 'AMRO', '7561', '981700', '192', '29464');
INSERT INTO public.who_global_data_import VALUES (17496, '2020-10-24', 'CO', 'Colombia', 'AMRO', '8570', '990270', '172', '29636');
INSERT INTO public.who_global_data_import VALUES (17497, '2020-10-25', 'CO', 'Colombia', 'AMRO', '8672', '998942', '166', '29802');
INSERT INTO public.who_global_data_import VALUES (17498, '2020-10-26', 'CO', 'Colombia', 'AMRO', '8769', '1007711', '198', '30000');
INSERT INTO public.who_global_data_import VALUES (17499, '2020-10-27', 'CO', 'Colombia', 'AMRO', '8174', '1015885', '154', '30154');
INSERT INTO public.who_global_data_import VALUES (17500, '2020-10-28', 'CO', 'Colombia', 'AMRO', '9167', '1025052', '194', '30348');
INSERT INTO public.who_global_data_import VALUES (17501, '2020-10-29', 'CO', 'Colombia', 'AMRO', '8166', '1033218', '217', '30565');
INSERT INTO public.who_global_data_import VALUES (17502, '2020-10-30', 'CO', 'Colombia', 'AMRO', '8717', '1041935', '188', '30753');
INSERT INTO public.who_global_data_import VALUES (17503, '2020-10-31', 'CO', 'Colombia', 'AMRO', '11187', '1053122', '173', '30926');
INSERT INTO public.who_global_data_import VALUES (17504, '2020-11-01', 'CO', 'Colombia', 'AMRO', '10029', '1063151', '209', '31135');
INSERT INTO public.who_global_data_import VALUES (17505, '2020-11-02', 'CO', 'Colombia', 'AMRO', '11033', '1074184', '179', '31314');
INSERT INTO public.who_global_data_import VALUES (17506, '2020-11-03', 'CO', 'Colombia', 'AMRO', '9137', '1083321', '201', '31515');
INSERT INTO public.who_global_data_import VALUES (17507, '2020-11-04', 'CO', 'Colombia', 'AMRO', '9935', '1093256', '155', '31670');
INSERT INTO public.who_global_data_import VALUES (17508, '2020-11-05', 'CO', 'Colombia', 'AMRO', '6136', '1099392', '177', '31847');
INSERT INTO public.who_global_data_import VALUES (17509, '2020-11-06', 'CO', 'Colombia', 'AMRO', '8692', '1108084', '166', '32013');
INSERT INTO public.who_global_data_import VALUES (17510, '2020-11-07', 'CO', 'Colombia', 'AMRO', '9893', '1117977', '196', '32209');
INSERT INTO public.who_global_data_import VALUES (17511, '2020-11-08', 'CO', 'Colombia', 'AMRO', '9756', '1127733', '196', '32405');
INSERT INTO public.who_global_data_import VALUES (17512, '2020-11-09', 'CO', 'Colombia', 'AMRO', '8714', '1136447', '190', '32595');
INSERT INTO public.who_global_data_import VALUES (17513, '2020-11-10', 'CO', 'Colombia', 'AMRO', '7440', '1143887', '196', '32791');
INSERT INTO public.who_global_data_import VALUES (17514, '2020-11-11', 'CO', 'Colombia', 'AMRO', '5176', '1149063', '183', '32974');
INSERT INTO public.who_global_data_import VALUES (17515, '2020-11-12', 'CO', 'Colombia', 'AMRO', '7612', '1156675', '174', '33148');
INSERT INTO public.who_global_data_import VALUES (17516, '2020-11-13', 'CO', 'Colombia', 'AMRO', '8651', '1165326', '164', '33312');
INSERT INTO public.who_global_data_import VALUES (17517, '2020-11-14', 'CO', 'Colombia', 'AMRO', '8686', '1174012', '179', '33491');
INSERT INTO public.who_global_data_import VALUES (17518, '2020-11-15', 'CO', 'Colombia', 'AMRO', '8685', '1182697', '178', '33669');
INSERT INTO public.who_global_data_import VALUES (17519, '2020-11-16', 'CO', 'Colombia', 'AMRO', '8307', '1191004', '160', '33829');
INSERT INTO public.who_global_data_import VALUES (17520, '2020-11-17', 'CO', 'Colombia', 'AMRO', '7742', '1198746', '202', '34031');
INSERT INTO public.who_global_data_import VALUES (17521, '2020-11-18', 'CO', 'Colombia', 'AMRO', '6471', '1205217', '192', '34223');
INSERT INTO public.who_global_data_import VALUES (17522, '2020-11-19', 'CO', 'Colombia', 'AMRO', '5911', '1211128', '158', '34381');
INSERT INTO public.who_global_data_import VALUES (17523, '2020-11-20', 'CO', 'Colombia', 'AMRO', '6875', '1218003', '182', '34563');
INSERT INTO public.who_global_data_import VALUES (17524, '2020-11-21', 'CO', 'Colombia', 'AMRO', '7487', '1225490', '198', '34761');
INSERT INTO public.who_global_data_import VALUES (17525, '2020-11-22', 'CO', 'Colombia', 'AMRO', '7954', '1233444', '168', '34929');
INSERT INTO public.who_global_data_import VALUES (17526, '2020-11-23', 'CO', 'Colombia', 'AMRO', '7049', '1240493', '175', '35104');
INSERT INTO public.who_global_data_import VALUES (17527, '2020-11-24', 'CO', 'Colombia', 'AMRO', '7924', '1248417', '183', '35287');
INSERT INTO public.who_global_data_import VALUES (17528, '2020-11-25', 'CO', 'Colombia', 'AMRO', '6562', '1254979', '192', '35479');
INSERT INTO public.who_global_data_import VALUES (17529, '2020-11-26', 'CO', 'Colombia', 'AMRO', '7515', '1262494', '198', '35677');
INSERT INTO public.who_global_data_import VALUES (17530, '2020-11-27', 'CO', 'Colombia', 'AMRO', '8497', '1270991', '183', '35860');
INSERT INTO public.who_global_data_import VALUES (17531, '2020-11-28', 'CO', 'Colombia', 'AMRO', '9496', '1280487', '159', '36019');
INSERT INTO public.who_global_data_import VALUES (17532, '2020-11-29', 'CO', 'Colombia', 'AMRO', '10023', '1290510', '195', '36214');
INSERT INTO public.who_global_data_import VALUES (17533, '2020-11-30', 'CO', 'Colombia', 'AMRO', '9103', '1299613', '187', '36401');
INSERT INTO public.who_global_data_import VALUES (17534, '2020-12-01', 'CO', 'Colombia', 'AMRO', '8763', '1308376', '183', '36584');
INSERT INTO public.who_global_data_import VALUES (17535, '2020-12-02', 'CO', 'Colombia', 'AMRO', '8430', '1316806', '182', '36766');
INSERT INTO public.who_global_data_import VALUES (17536, '2020-12-03', 'CO', 'Colombia', 'AMRO', '7986', '1324792', '168', '36934');
INSERT INTO public.who_global_data_import VALUES (17537, '2020-12-04', 'CO', 'Colombia', 'AMRO', '9297', '1334089', '183', '37117');
INSERT INTO public.who_global_data_import VALUES (17538, '2020-12-05', 'CO', 'Colombia', 'AMRO', '9233', '1343322', '188', '37305');
INSERT INTO public.who_global_data_import VALUES (17539, '2020-12-06', 'CO', 'Colombia', 'AMRO', '9285', '1352607', '162', '37467');
INSERT INTO public.who_global_data_import VALUES (17540, '2020-12-07', 'CO', 'Colombia', 'AMRO', '9642', '1362249', '166', '37633');
INSERT INTO public.who_global_data_import VALUES (17541, '2020-12-08', 'CO', 'Colombia', 'AMRO', '8854', '1371103', '175', '37808');
INSERT INTO public.who_global_data_import VALUES (17542, '2020-12-09', 'CO', 'Colombia', 'AMRO', '5997', '1377100', '187', '37995');
INSERT INTO public.who_global_data_import VALUES (17543, '2020-12-10', 'CO', 'Colombia', 'AMRO', '7510', '1384610', '163', '38158');
INSERT INTO public.who_global_data_import VALUES (17544, '2020-12-11', 'CO', 'Colombia', 'AMRO', '7523', '1392133', '150', '38308');
INSERT INTO public.who_global_data_import VALUES (17545, '2020-12-12', 'CO', 'Colombia', 'AMRO', '7778', '1399911', '176', '38484');
INSERT INTO public.who_global_data_import VALUES (17546, '2020-12-13', 'CO', 'Colombia', 'AMRO', '8998', '1408909', '185', '38669');
INSERT INTO public.who_global_data_import VALUES (17547, '2020-12-14', 'CO', 'Colombia', 'AMRO', '8163', '1417072', '197', '38866');
INSERT INTO public.who_global_data_import VALUES (17548, '2020-12-15', 'CO', 'Colombia', 'AMRO', '8702', '1425774', '187', '39053');
INSERT INTO public.who_global_data_import VALUES (17549, '2020-12-16', 'CO', 'Colombia', 'AMRO', '8742', '1434516', '142', '39195');
INSERT INTO public.who_global_data_import VALUES (17550, '2020-12-17', 'CO', 'Colombia', 'AMRO', '10130', '1444646', '161', '39356');
INSERT INTO public.who_global_data_import VALUES (17551, '2020-12-18', 'CO', 'Colombia', 'AMRO', '11953', '1456599', '204', '39560');
INSERT INTO public.who_global_data_import VALUES (17552, '2020-12-19', 'CO', 'Colombia', 'AMRO', '12196', '1468795', '227', '39787');
INSERT INTO public.who_global_data_import VALUES (17553, '2020-12-20', 'CO', 'Colombia', 'AMRO', '13277', '1482072', '232', '40019');
INSERT INTO public.who_global_data_import VALUES (17554, '2020-12-21', 'CO', 'Colombia', 'AMRO', '13990', '1496062', '249', '40268');
INSERT INTO public.who_global_data_import VALUES (17555, '2020-12-22', 'CO', 'Colombia', 'AMRO', '11160', '1507222', '207', '40475');
INSERT INTO public.who_global_data_import VALUES (17556, '2020-12-23', 'CO', 'Colombia', 'AMRO', '10845', '1518067', '205', '40680');
INSERT INTO public.who_global_data_import VALUES (17557, '2020-12-24', 'CO', 'Colombia', 'AMRO', '12526', '1530593', '251', '40931');
INSERT INTO public.who_global_data_import VALUES (17558, '2020-12-25', 'CO', 'Colombia', 'AMRO', '14233', '1544826', '242', '41173');
INSERT INTO public.who_global_data_import VALUES (17559, '2020-12-26', 'CO', 'Colombia', 'AMRO', '14940', '1559766', '281', '41454');
INSERT INTO public.who_global_data_import VALUES (17560, '2020-12-27', 'CO', 'Colombia', 'AMRO', '14941', '1574707', '236', '41690');
INSERT INTO public.who_global_data_import VALUES (17561, '2020-12-28', 'CO', 'Colombia', 'AMRO', '10196', '1584903', '253', '41943');
INSERT INTO public.who_global_data_import VALUES (17562, '2020-12-29', 'CO', 'Colombia', 'AMRO', '9594', '1594497', '228', '42171');
INSERT INTO public.who_global_data_import VALUES (17563, '2020-12-30', 'CO', 'Colombia', 'AMRO', '9310', '1603807', '203', '42374');
INSERT INTO public.who_global_data_import VALUES (17564, '2020-12-31', 'CO', 'Colombia', 'AMRO', '11015', '1614822', '246', '42620');
INSERT INTO public.who_global_data_import VALUES (17565, '2021-01-01', 'CO', 'Colombia', 'AMRO', '11639', '1626461', '289', '42909');
INSERT INTO public.who_global_data_import VALUES (17566, '2021-01-02', 'CO', 'Colombia', 'AMRO', '16314', '1642775', '304', '43213');
INSERT INTO public.who_global_data_import VALUES (17567, '2021-01-03', 'CO', 'Colombia', 'AMRO', '12105', '1654880', '282', '43495');
INSERT INTO public.who_global_data_import VALUES (17568, '2021-01-04', 'CO', 'Colombia', 'AMRO', '11528', '1666408', '270', '43765');
INSERT INTO public.who_global_data_import VALUES (17569, '2021-01-05', 'CO', 'Colombia', 'AMRO', '9412', '1675820', '200', '43965');
INSERT INTO public.who_global_data_import VALUES (17570, '2021-01-06', 'CO', 'Colombia', 'AMRO', '10311', '1686131', '222', '44187');
INSERT INTO public.who_global_data_import VALUES (17571, '2021-01-07', 'CO', 'Colombia', 'AMRO', '16835', '1702966', '241', '44428');
INSERT INTO public.who_global_data_import VALUES (17572, '2021-01-08', 'CO', 'Colombia', 'AMRO', '16805', '1719771', '295', '44723');
INSERT INTO public.who_global_data_import VALUES (17573, '2021-01-09', 'CO', 'Colombia', 'AMRO', '17576', '1737347', '344', '45067');
INSERT INTO public.who_global_data_import VALUES (17574, '2021-01-10', 'CO', 'Colombia', 'AMRO', '18221', '1755568', '364', '45431');
INSERT INTO public.who_global_data_import VALUES (17575, '2021-01-11', 'CO', 'Colombia', 'AMRO', '15795', '1771363', '353', '45784');
INSERT INTO public.who_global_data_import VALUES (17576, '2021-01-12', 'CO', 'Colombia', 'AMRO', '15537', '1786900', '330', '46114');
INSERT INTO public.who_global_data_import VALUES (17577, '2021-01-13', 'CO', 'Colombia', 'AMRO', '15003', '1801903', '337', '46451');
INSERT INTO public.who_global_data_import VALUES (17578, '2021-01-14', 'CO', 'Colombia', 'AMRO', '14179', '1816082', '331', '46782');
INSERT INTO public.who_global_data_import VALUES (17579, '2021-01-15', 'CO', 'Colombia', 'AMRO', '15898', '1831980', '342', '47124');
INSERT INTO public.who_global_data_import VALUES (17580, '2021-01-16', 'CO', 'Colombia', 'AMRO', '17121', '1849101', '367', '47491');
INSERT INTO public.who_global_data_import VALUES (17581, '2021-01-17', 'CO', 'Colombia', 'AMRO', '21078', '1870179', '377', '47868');
INSERT INTO public.who_global_data_import VALUES (17582, '2021-01-18', 'CO', 'Colombia', 'AMRO', '20855', '1891034', '388', '48256');
INSERT INTO public.who_global_data_import VALUES (17583, '2021-01-19', 'CO', 'Colombia', 'AMRO', '17379', '1908413', '375', '48631');
INSERT INTO public.who_global_data_import VALUES (17584, '2021-01-20', 'CO', 'Colombia', 'AMRO', '14719', '1923132', '373', '49004');
INSERT INTO public.who_global_data_import VALUES (17585, '2021-01-21', 'CO', 'Colombia', 'AMRO', '15939', '1939071', '398', '49402');
INSERT INTO public.who_global_data_import VALUES (17586, '2021-01-22', 'CO', 'Colombia', 'AMRO', '17908', '1956979', '390', '49792');
INSERT INTO public.who_global_data_import VALUES (17587, '2021-01-23', 'CO', 'Colombia', 'AMRO', '15366', '1972345', '395', '50187');
INSERT INTO public.who_global_data_import VALUES (17588, '2021-01-24', 'CO', 'Colombia', 'AMRO', '15073', '1987418', '399', '50586');
INSERT INTO public.who_global_data_import VALUES (17589, '2021-01-25', 'CO', 'Colombia', 'AMRO', '15551', '2002969', '396', '50982');
INSERT INTO public.who_global_data_import VALUES (17590, '2021-01-26', 'CO', 'Colombia', 'AMRO', '12516', '2015485', '392', '51374');
INSERT INTO public.who_global_data_import VALUES (17591, '2021-01-27', 'CO', 'Colombia', 'AMRO', '12261', '2027746', '373', '51747');
INSERT INTO public.who_global_data_import VALUES (17592, '2021-01-28', 'CO', 'Colombia', 'AMRO', '13606', '2041352', '381', '52128');
INSERT INTO public.who_global_data_import VALUES (17593, '2021-01-29', 'CO', 'Colombia', 'AMRO', '13953', '2055305', '395', '52523');
INSERT INTO public.who_global_data_import VALUES (17594, '2021-01-30', 'CO', 'Colombia', 'AMRO', '12270', '2067575', '390', '52913');
INSERT INTO public.who_global_data_import VALUES (17595, '2021-01-31', 'CO', 'Colombia', 'AMRO', '10058', '2077633', '371', '53284');
INSERT INTO public.who_global_data_import VALUES (17596, '2021-02-01', 'CO', 'Colombia', 'AMRO', '9173', '2086806', '366', '53650');
INSERT INTO public.who_global_data_import VALUES (17597, '2021-02-02', 'CO', 'Colombia', 'AMRO', '8078', '2094884', '333', '53983');
INSERT INTO public.who_global_data_import VALUES (17598, '2021-02-03', 'CO', 'Colombia', 'AMRO', '9622', '2104506', '289', '54272');
INSERT INTO public.who_global_data_import VALUES (17599, '2021-02-04', 'CO', 'Colombia', 'AMRO', '10091', '2114597', '304', '54576');
INSERT INTO public.who_global_data_import VALUES (17600, '2021-02-05', 'CO', 'Colombia', 'AMRO', '11025', '2125622', '301', '54877');
INSERT INTO public.who_global_data_import VALUES (17601, '2020-01-03', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17602, '2020-01-04', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17603, '2020-01-05', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17604, '2020-01-06', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17605, '2020-01-07', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17606, '2020-01-08', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17607, '2020-01-09', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17608, '2020-01-10', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17609, '2020-01-11', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17610, '2020-01-12', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17611, '2020-01-13', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17612, '2020-01-14', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17613, '2020-01-15', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17614, '2020-01-16', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17615, '2020-01-17', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17616, '2020-01-18', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17617, '2020-01-19', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17618, '2020-01-20', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17619, '2020-01-21', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17620, '2020-01-22', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17621, '2020-01-23', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17622, '2020-01-24', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17623, '2020-01-25', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17624, '2020-01-26', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17625, '2020-01-27', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17626, '2020-01-28', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17627, '2020-01-29', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17628, '2020-01-30', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17629, '2020-01-31', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17630, '2020-02-01', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17631, '2020-02-02', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17632, '2020-02-03', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17633, '2020-02-04', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17634, '2020-02-05', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17635, '2020-02-06', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17636, '2020-02-07', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17637, '2020-02-08', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17638, '2020-02-09', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17639, '2020-02-10', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17640, '2020-02-11', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17641, '2020-02-12', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17642, '2020-02-13', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17643, '2020-02-14', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17644, '2020-02-15', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17645, '2020-02-16', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17646, '2020-02-17', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17647, '2020-02-18', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17648, '2020-02-19', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17649, '2020-02-20', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17650, '2020-02-21', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17651, '2020-02-22', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17652, '2020-02-23', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17653, '2020-02-24', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17654, '2020-02-25', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17655, '2020-02-26', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17656, '2020-02-27', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17657, '2020-02-28', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17658, '2020-02-29', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17659, '2020-03-01', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17660, '2020-03-02', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17661, '2020-03-03', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17662, '2020-03-04', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17663, '2020-03-05', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17664, '2020-03-06', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17665, '2020-03-07', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17666, '2020-03-08', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17667, '2020-03-09', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17668, '2020-03-10', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17669, '2020-03-11', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17670, '2020-03-12', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17671, '2020-03-13', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17672, '2020-03-14', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17673, '2020-03-15', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17674, '2020-03-16', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17675, '2020-03-17', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17676, '2020-03-18', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17677, '2020-03-19', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17678, '2020-03-20', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17679, '2020-03-21', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17680, '2020-03-22', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17681, '2020-03-23', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17682, '2020-03-24', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17683, '2020-03-25', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17684, '2020-03-26', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17685, '2020-03-27', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17686, '2020-03-28', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17687, '2020-03-29', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17688, '2020-03-30', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17689, '2020-03-31', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17690, '2020-04-01', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17691, '2020-04-02', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17692, '2020-04-03', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17693, '2020-04-04', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17694, '2020-04-05', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17695, '2020-04-06', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17696, '2020-04-07', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17697, '2020-04-08', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17698, '2020-04-09', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17699, '2020-04-10', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17700, '2020-04-11', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17701, '2020-04-12', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17702, '2020-04-13', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17703, '2020-04-14', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17704, '2020-04-15', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17705, '2020-04-16', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17706, '2020-04-17', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17707, '2020-04-18', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17708, '2020-04-19', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17709, '2020-04-20', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17710, '2020-04-21', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17711, '2020-04-22', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17712, '2020-04-23', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17713, '2020-04-24', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17714, '2020-04-25', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17715, '2020-04-26', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17716, '2020-04-27', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17717, '2020-04-28', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17718, '2020-04-29', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17719, '2020-04-30', 'KM', 'Comoros', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17720, '2020-05-01', 'KM', 'Comoros', 'AFRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17721, '2020-05-02', 'KM', 'Comoros', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17722, '2020-05-03', 'KM', 'Comoros', 'AFRO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17723, '2020-05-04', 'KM', 'Comoros', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (17724, '2020-05-05', 'KM', 'Comoros', 'AFRO', '1', '4', '1', '1');
INSERT INTO public.who_global_data_import VALUES (17725, '2020-05-06', 'KM', 'Comoros', 'AFRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17726, '2020-05-07', 'KM', 'Comoros', 'AFRO', '4', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17727, '2020-05-08', 'KM', 'Comoros', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17728, '2020-05-09', 'KM', 'Comoros', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17729, '2020-05-10', 'KM', 'Comoros', 'AFRO', '3', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17730, '2020-05-11', 'KM', 'Comoros', 'AFRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17731, '2020-05-12', 'KM', 'Comoros', 'AFRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17732, '2020-05-13', 'KM', 'Comoros', 'AFRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17733, '2020-05-14', 'KM', 'Comoros', 'AFRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17734, '2020-05-15', 'KM', 'Comoros', 'AFRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17735, '2020-05-16', 'KM', 'Comoros', 'AFRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17736, '2020-05-17', 'KM', 'Comoros', 'AFRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17737, '2020-05-18', 'KM', 'Comoros', 'AFRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17738, '2020-05-19', 'KM', 'Comoros', 'AFRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17739, '2020-05-20', 'KM', 'Comoros', 'AFRO', '23', '34', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17740, '2020-05-21', 'KM', 'Comoros', 'AFRO', '0', '34', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17741, '2020-05-22', 'KM', 'Comoros', 'AFRO', '0', '34', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17742, '2020-05-23', 'KM', 'Comoros', 'AFRO', '0', '34', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17743, '2020-05-24', 'KM', 'Comoros', 'AFRO', '0', '34', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17744, '2020-05-25', 'KM', 'Comoros', 'AFRO', '9', '43', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17745, '2020-05-26', 'KM', 'Comoros', 'AFRO', '0', '43', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17746, '2020-05-27', 'KM', 'Comoros', 'AFRO', '0', '43', '0', '1');
INSERT INTO public.who_global_data_import VALUES (17747, '2020-05-28', 'KM', 'Comoros', 'AFRO', '0', '43', '1', '2');
INSERT INTO public.who_global_data_import VALUES (17748, '2020-05-29', 'KM', 'Comoros', 'AFRO', '0', '43', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17749, '2020-05-30', 'KM', 'Comoros', 'AFRO', '0', '43', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17750, '2020-05-31', 'KM', 'Comoros', 'AFRO', '0', '43', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17751, '2020-06-01', 'KM', 'Comoros', 'AFRO', '19', '62', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17752, '2020-06-02', 'KM', 'Comoros', 'AFRO', '0', '62', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17753, '2020-06-03', 'KM', 'Comoros', 'AFRO', '0', '62', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17754, '2020-06-04', 'KM', 'Comoros', 'AFRO', '0', '62', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17755, '2020-06-05', 'KM', 'Comoros', 'AFRO', '0', '62', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17756, '2020-06-06', 'KM', 'Comoros', 'AFRO', '0', '62', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17757, '2020-06-07', 'KM', 'Comoros', 'AFRO', '35', '97', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17758, '2020-06-08', 'KM', 'Comoros', 'AFRO', '0', '97', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17759, '2020-06-09', 'KM', 'Comoros', 'AFRO', '0', '97', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17760, '2020-06-10', 'KM', 'Comoros', 'AFRO', '0', '97', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17761, '2020-06-11', 'KM', 'Comoros', 'AFRO', '65', '162', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17762, '2020-06-12', 'KM', 'Comoros', 'AFRO', '0', '162', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17763, '2020-06-13', 'KM', 'Comoros', 'AFRO', '1', '163', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17764, '2020-06-14', 'KM', 'Comoros', 'AFRO', '13', '176', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17765, '2020-06-15', 'KM', 'Comoros', 'AFRO', '0', '176', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17766, '2020-06-16', 'KM', 'Comoros', 'AFRO', '0', '176', '0', '2');
INSERT INTO public.who_global_data_import VALUES (17767, '2020-06-17', 'KM', 'Comoros', 'AFRO', '21', '197', '1', '3');
INSERT INTO public.who_global_data_import VALUES (17768, '2020-06-18', 'KM', 'Comoros', 'AFRO', '0', '197', '0', '3');
INSERT INTO public.who_global_data_import VALUES (17769, '2020-06-19', 'KM', 'Comoros', 'AFRO', '13', '210', '2', '5');
INSERT INTO public.who_global_data_import VALUES (17770, '2020-06-20', 'KM', 'Comoros', 'AFRO', '0', '210', '0', '5');
INSERT INTO public.who_global_data_import VALUES (17771, '2020-06-21', 'KM', 'Comoros', 'AFRO', '37', '247', '0', '5');
INSERT INTO public.who_global_data_import VALUES (17772, '2020-06-22', 'KM', 'Comoros', 'AFRO', '0', '247', '0', '5');
INSERT INTO public.who_global_data_import VALUES (17773, '2020-06-23', 'KM', 'Comoros', 'AFRO', '0', '247', '0', '5');
INSERT INTO public.who_global_data_import VALUES (17774, '2020-06-24', 'KM', 'Comoros', 'AFRO', '18', '265', '2', '7');
INSERT INTO public.who_global_data_import VALUES (17775, '2020-06-25', 'KM', 'Comoros', 'AFRO', '0', '265', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17776, '2020-06-26', 'KM', 'Comoros', 'AFRO', '7', '272', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17777, '2020-06-27', 'KM', 'Comoros', 'AFRO', '0', '272', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17778, '2020-06-28', 'KM', 'Comoros', 'AFRO', '0', '272', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17779, '2020-06-29', 'KM', 'Comoros', 'AFRO', '21', '293', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17780, '2020-06-30', 'KM', 'Comoros', 'AFRO', '0', '293', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17781, '2020-07-01', 'KM', 'Comoros', 'AFRO', '10', '303', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17782, '2020-07-02', 'KM', 'Comoros', 'AFRO', '0', '303', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17783, '2020-07-03', 'KM', 'Comoros', 'AFRO', '0', '303', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17784, '2020-07-04', 'KM', 'Comoros', 'AFRO', '6', '309', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17785, '2020-07-05', 'KM', 'Comoros', 'AFRO', '0', '309', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17786, '2020-07-06', 'KM', 'Comoros', 'AFRO', '2', '311', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17787, '2020-07-07', 'KM', 'Comoros', 'AFRO', '0', '311', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17788, '2020-07-08', 'KM', 'Comoros', 'AFRO', '2', '313', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17789, '2020-07-09', 'KM', 'Comoros', 'AFRO', '0', '313', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17790, '2020-07-10', 'KM', 'Comoros', 'AFRO', '0', '313', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17791, '2020-07-11', 'KM', 'Comoros', 'AFRO', '1', '314', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17792, '2020-07-12', 'KM', 'Comoros', 'AFRO', '0', '314', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17793, '2020-07-13', 'KM', 'Comoros', 'AFRO', '3', '317', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17794, '2020-07-14', 'KM', 'Comoros', 'AFRO', '0', '317', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17795, '2020-07-15', 'KM', 'Comoros', 'AFRO', '4', '321', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17796, '2020-07-16', 'KM', 'Comoros', 'AFRO', '0', '321', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17797, '2020-07-17', 'KM', 'Comoros', 'AFRO', '7', '328', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17798, '2020-07-18', 'KM', 'Comoros', 'AFRO', '0', '328', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17799, '2020-07-19', 'KM', 'Comoros', 'AFRO', '0', '328', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17800, '2020-07-20', 'KM', 'Comoros', 'AFRO', '6', '334', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17801, '2020-07-21', 'KM', 'Comoros', 'AFRO', '0', '334', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17802, '2020-07-22', 'KM', 'Comoros', 'AFRO', '3', '337', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17803, '2020-07-23', 'KM', 'Comoros', 'AFRO', '0', '337', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17804, '2020-07-24', 'KM', 'Comoros', 'AFRO', '3', '340', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17805, '2020-07-25', 'KM', 'Comoros', 'AFRO', '0', '340', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17806, '2020-07-26', 'KM', 'Comoros', 'AFRO', '0', '340', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17807, '2020-07-27', 'KM', 'Comoros', 'AFRO', '14', '354', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17808, '2020-07-28', 'KM', 'Comoros', 'AFRO', '0', '354', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17809, '2020-07-29', 'KM', 'Comoros', 'AFRO', '24', '378', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17810, '2020-07-30', 'KM', 'Comoros', 'AFRO', '0', '378', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17811, '2020-07-31', 'KM', 'Comoros', 'AFRO', '4', '382', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17812, '2020-08-01', 'KM', 'Comoros', 'AFRO', '0', '382', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17813, '2020-08-02', 'KM', 'Comoros', 'AFRO', '0', '382', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17814, '2020-08-03', 'KM', 'Comoros', 'AFRO', '4', '386', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17815, '2020-08-04', 'KM', 'Comoros', 'AFRO', '0', '386', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17816, '2020-08-05', 'KM', 'Comoros', 'AFRO', '2', '388', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17817, '2020-08-06', 'KM', 'Comoros', 'AFRO', '0', '388', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17818, '2020-08-07', 'KM', 'Comoros', 'AFRO', '8', '396', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17819, '2020-08-08', 'KM', 'Comoros', 'AFRO', '0', '396', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17820, '2020-08-09', 'KM', 'Comoros', 'AFRO', '3', '399', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17821, '2020-08-10', 'KM', 'Comoros', 'AFRO', '0', '399', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17822, '2020-08-11', 'KM', 'Comoros', 'AFRO', '0', '399', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17823, '2020-08-12', 'KM', 'Comoros', 'AFRO', '0', '399', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17824, '2020-08-13', 'KM', 'Comoros', 'AFRO', '0', '399', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17825, '2020-08-14', 'KM', 'Comoros', 'AFRO', '4', '403', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17826, '2020-08-15', 'KM', 'Comoros', 'AFRO', '0', '403', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17827, '2020-08-16', 'KM', 'Comoros', 'AFRO', '2', '405', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17828, '2020-08-17', 'KM', 'Comoros', 'AFRO', '0', '405', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17829, '2020-08-18', 'KM', 'Comoros', 'AFRO', '0', '405', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17830, '2020-08-19', 'KM', 'Comoros', 'AFRO', '0', '405', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17831, '2020-08-20', 'KM', 'Comoros', 'AFRO', '1', '406', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17832, '2020-08-21', 'KM', 'Comoros', 'AFRO', '0', '406', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17833, '2020-08-22', 'KM', 'Comoros', 'AFRO', '0', '406', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17834, '2020-08-23', 'KM', 'Comoros', 'AFRO', '11', '417', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17835, '2020-08-24', 'KM', 'Comoros', 'AFRO', '0', '417', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17836, '2020-08-25', 'KM', 'Comoros', 'AFRO', '0', '417', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17837, '2020-08-26', 'KM', 'Comoros', 'AFRO', '0', '417', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17838, '2020-08-27', 'KM', 'Comoros', 'AFRO', '0', '417', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17839, '2020-08-28', 'KM', 'Comoros', 'AFRO', '0', '417', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17840, '2020-08-29', 'KM', 'Comoros', 'AFRO', '5', '422', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17841, '2020-08-30', 'KM', 'Comoros', 'AFRO', '1', '423', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17842, '2020-08-31', 'KM', 'Comoros', 'AFRO', '0', '423', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17843, '2020-09-01', 'KM', 'Comoros', 'AFRO', '0', '423', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17844, '2020-09-02', 'KM', 'Comoros', 'AFRO', '0', '423', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17845, '2020-09-03', 'KM', 'Comoros', 'AFRO', '4', '427', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17846, '2020-09-04', 'KM', 'Comoros', 'AFRO', '21', '448', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17847, '2020-09-05', 'KM', 'Comoros', 'AFRO', '0', '448', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17848, '2020-09-06', 'KM', 'Comoros', 'AFRO', '0', '448', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17849, '2020-09-07', 'KM', 'Comoros', 'AFRO', '0', '448', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17850, '2020-09-08', 'KM', 'Comoros', 'AFRO', '0', '448', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17851, '2020-09-09', 'KM', 'Comoros', 'AFRO', '8', '456', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17852, '2020-09-10', 'KM', 'Comoros', 'AFRO', '0', '456', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17853, '2020-09-11', 'KM', 'Comoros', 'AFRO', '0', '456', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17854, '2020-09-12', 'KM', 'Comoros', 'AFRO', '0', '456', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17855, '2020-09-13', 'KM', 'Comoros', 'AFRO', '0', '456', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17856, '2020-09-14', 'KM', 'Comoros', 'AFRO', '0', '456', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17857, '2020-09-15', 'KM', 'Comoros', 'AFRO', '1', '457', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17858, '2020-09-16', 'KM', 'Comoros', 'AFRO', '0', '457', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17859, '2020-09-17', 'KM', 'Comoros', 'AFRO', '10', '467', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17860, '2020-09-18', 'KM', 'Comoros', 'AFRO', '3', '470', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17861, '2020-09-19', 'KM', 'Comoros', 'AFRO', '0', '470', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17862, '2020-09-20', 'KM', 'Comoros', 'AFRO', '0', '470', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17863, '2020-09-21', 'KM', 'Comoros', 'AFRO', '0', '470', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17864, '2020-09-22', 'KM', 'Comoros', 'AFRO', '0', '470', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17865, '2020-09-23', 'KM', 'Comoros', 'AFRO', '0', '470', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17866, '2020-09-24', 'KM', 'Comoros', 'AFRO', '0', '470', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17867, '2020-09-25', 'KM', 'Comoros', 'AFRO', '0', '470', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17868, '2020-09-26', 'KM', 'Comoros', 'AFRO', '4', '474', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17869, '2020-09-27', 'KM', 'Comoros', 'AFRO', '0', '474', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17870, '2020-09-28', 'KM', 'Comoros', 'AFRO', '0', '474', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17871, '2020-09-29', 'KM', 'Comoros', 'AFRO', '0', '474', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17872, '2020-09-30', 'KM', 'Comoros', 'AFRO', '4', '478', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17873, '2020-10-01', 'KM', 'Comoros', 'AFRO', '1', '479', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17874, '2020-10-02', 'KM', 'Comoros', 'AFRO', '0', '479', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17875, '2020-10-03', 'KM', 'Comoros', 'AFRO', '0', '479', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17876, '2020-10-04', 'KM', 'Comoros', 'AFRO', '5', '484', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17877, '2020-10-05', 'KM', 'Comoros', 'AFRO', '3', '487', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17878, '2020-10-06', 'KM', 'Comoros', 'AFRO', '0', '487', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17879, '2020-10-07', 'KM', 'Comoros', 'AFRO', '0', '487', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17880, '2020-10-08', 'KM', 'Comoros', 'AFRO', '0', '487', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17881, '2020-10-09', 'KM', 'Comoros', 'AFRO', '0', '487', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17882, '2020-10-10', 'KM', 'Comoros', 'AFRO', '4', '491', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17883, '2020-10-11', 'KM', 'Comoros', 'AFRO', '0', '491', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17884, '2020-10-12', 'KM', 'Comoros', 'AFRO', '4', '495', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17885, '2020-10-13', 'KM', 'Comoros', 'AFRO', '0', '495', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17886, '2020-10-14', 'KM', 'Comoros', 'AFRO', '1', '496', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17887, '2020-10-15', 'KM', 'Comoros', 'AFRO', '0', '496', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17888, '2020-10-16', 'KM', 'Comoros', 'AFRO', '0', '496', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17889, '2020-10-17', 'KM', 'Comoros', 'AFRO', '0', '496', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17890, '2020-10-18', 'KM', 'Comoros', 'AFRO', '0', '496', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17891, '2020-10-19', 'KM', 'Comoros', 'AFRO', '0', '496', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17892, '2020-10-20', 'KM', 'Comoros', 'AFRO', '6', '502', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17893, '2020-10-21', 'KM', 'Comoros', 'AFRO', '2', '504', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17894, '2020-10-22', 'KM', 'Comoros', 'AFRO', '0', '504', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17895, '2020-10-23', 'KM', 'Comoros', 'AFRO', '0', '504', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17896, '2020-10-24', 'KM', 'Comoros', 'AFRO', '0', '504', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17897, '2020-10-25', 'KM', 'Comoros', 'AFRO', '13', '517', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17898, '2020-10-26', 'KM', 'Comoros', 'AFRO', '0', '517', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17899, '2020-10-27', 'KM', 'Comoros', 'AFRO', '0', '517', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17900, '2020-10-28', 'KM', 'Comoros', 'AFRO', '8', '525', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17901, '2020-10-29', 'KM', 'Comoros', 'AFRO', '5', '530', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17902, '2020-10-30', 'KM', 'Comoros', 'AFRO', '0', '530', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17903, '2020-10-31', 'KM', 'Comoros', 'AFRO', '0', '530', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17904, '2020-11-01', 'KM', 'Comoros', 'AFRO', '0', '530', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17905, '2020-11-02', 'KM', 'Comoros', 'AFRO', '15', '545', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17906, '2020-11-03', 'KM', 'Comoros', 'AFRO', '0', '545', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17907, '2020-11-04', 'KM', 'Comoros', 'AFRO', '0', '545', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17908, '2020-11-05', 'KM', 'Comoros', 'AFRO', '9', '554', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17909, '2020-11-06', 'KM', 'Comoros', 'AFRO', '3', '557', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17910, '2020-11-07', 'KM', 'Comoros', 'AFRO', '0', '557', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17911, '2020-11-08', 'KM', 'Comoros', 'AFRO', '0', '557', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17912, '2020-11-09', 'KM', 'Comoros', 'AFRO', '6', '563', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17913, '2020-11-10', 'KM', 'Comoros', 'AFRO', '0', '563', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17914, '2020-11-11', 'KM', 'Comoros', 'AFRO', '0', '563', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17915, '2020-11-12', 'KM', 'Comoros', 'AFRO', '6', '569', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17916, '2020-11-13', 'KM', 'Comoros', 'AFRO', '5', '574', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17917, '2020-11-14', 'KM', 'Comoros', 'AFRO', '0', '574', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17918, '2020-11-15', 'KM', 'Comoros', 'AFRO', '0', '574', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17919, '2020-11-16', 'KM', 'Comoros', 'AFRO', '0', '574', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17920, '2020-11-17', 'KM', 'Comoros', 'AFRO', '5', '579', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17921, '2020-11-18', 'KM', 'Comoros', 'AFRO', '0', '579', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17922, '2020-11-19', 'KM', 'Comoros', 'AFRO', '12', '591', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17923, '2020-11-20', 'KM', 'Comoros', 'AFRO', '1', '592', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17924, '2020-11-21', 'KM', 'Comoros', 'AFRO', '0', '592', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17925, '2020-11-22', 'KM', 'Comoros', 'AFRO', '0', '592', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17926, '2020-11-23', 'KM', 'Comoros', 'AFRO', '0', '592', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17927, '2020-11-24', 'KM', 'Comoros', 'AFRO', '4', '596', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17928, '2020-11-25', 'KM', 'Comoros', 'AFRO', '0', '596', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17929, '2020-11-26', 'KM', 'Comoros', 'AFRO', '11', '607', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17930, '2020-11-27', 'KM', 'Comoros', 'AFRO', '0', '607', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17931, '2020-11-28', 'KM', 'Comoros', 'AFRO', '3', '610', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17932, '2020-11-29', 'KM', 'Comoros', 'AFRO', '0', '610', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17933, '2020-11-30', 'KM', 'Comoros', 'AFRO', '0', '610', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17934, '2020-12-01', 'KM', 'Comoros', 'AFRO', '1', '611', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17935, '2020-12-02', 'KM', 'Comoros', 'AFRO', '0', '611', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17936, '2020-12-03', 'KM', 'Comoros', 'AFRO', '2', '613', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17937, '2020-12-04', 'KM', 'Comoros', 'AFRO', '2', '615', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17938, '2020-12-05', 'KM', 'Comoros', 'AFRO', '0', '615', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17939, '2020-12-06', 'KM', 'Comoros', 'AFRO', '0', '615', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17940, '2020-12-07', 'KM', 'Comoros', 'AFRO', '0', '615', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17941, '2020-12-08', 'KM', 'Comoros', 'AFRO', '1', '616', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17942, '2020-12-09', 'KM', 'Comoros', 'AFRO', '0', '616', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17943, '2020-12-10', 'KM', 'Comoros', 'AFRO', '0', '616', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17944, '2020-12-11', 'KM', 'Comoros', 'AFRO', '0', '616', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17945, '2020-12-12', 'KM', 'Comoros', 'AFRO', '8', '624', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17946, '2020-12-13', 'KM', 'Comoros', 'AFRO', '0', '624', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17947, '2020-12-14', 'KM', 'Comoros', 'AFRO', '0', '624', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17948, '2020-12-15', 'KM', 'Comoros', 'AFRO', '5', '629', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17949, '2020-12-16', 'KM', 'Comoros', 'AFRO', '-1', '628', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17950, '2020-12-17', 'KM', 'Comoros', 'AFRO', '5', '633', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17951, '2020-12-18', 'KM', 'Comoros', 'AFRO', '0', '633', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17952, '2020-12-19', 'KM', 'Comoros', 'AFRO', '10', '643', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17953, '2020-12-20', 'KM', 'Comoros', 'AFRO', '0', '643', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17954, '2020-12-21', 'KM', 'Comoros', 'AFRO', '0', '643', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17955, '2020-12-22', 'KM', 'Comoros', 'AFRO', '23', '666', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17956, '2020-12-23', 'KM', 'Comoros', 'AFRO', '0', '666', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17957, '2020-12-24', 'KM', 'Comoros', 'AFRO', '0', '666', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17958, '2020-12-25', 'KM', 'Comoros', 'AFRO', '17', '683', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17959, '2020-12-26', 'KM', 'Comoros', 'AFRO', '32', '715', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17960, '2020-12-27', 'KM', 'Comoros', 'AFRO', '0', '715', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17961, '2020-12-28', 'KM', 'Comoros', 'AFRO', '0', '715', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17962, '2020-12-29', 'KM', 'Comoros', 'AFRO', '16', '731', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17963, '2020-12-30', 'KM', 'Comoros', 'AFRO', '0', '731', '0', '7');
INSERT INTO public.who_global_data_import VALUES (17964, '2020-12-31', 'KM', 'Comoros', 'AFRO', '34', '765', '2', '9');
INSERT INTO public.who_global_data_import VALUES (17965, '2021-01-01', 'KM', 'Comoros', 'AFRO', '0', '765', '0', '9');
INSERT INTO public.who_global_data_import VALUES (17966, '2021-01-02', 'KM', 'Comoros', 'AFRO', '0', '765', '0', '9');
INSERT INTO public.who_global_data_import VALUES (17967, '2021-01-03', 'KM', 'Comoros', 'AFRO', '99', '864', '4', '13');
INSERT INTO public.who_global_data_import VALUES (17968, '2021-01-04', 'KM', 'Comoros', 'AFRO', '0', '864', '0', '13');
INSERT INTO public.who_global_data_import VALUES (17969, '2021-01-05', 'KM', 'Comoros', 'AFRO', '0', '864', '0', '13');
INSERT INTO public.who_global_data_import VALUES (17970, '2021-01-06', 'KM', 'Comoros', 'AFRO', '0', '864', '0', '13');
INSERT INTO public.who_global_data_import VALUES (17971, '2021-01-07', 'KM', 'Comoros', 'AFRO', '0', '864', '0', '13');
INSERT INTO public.who_global_data_import VALUES (17972, '2021-01-08', 'KM', 'Comoros', 'AFRO', '0', '864', '0', '13');
INSERT INTO public.who_global_data_import VALUES (17973, '2021-01-09', 'KM', 'Comoros', 'AFRO', '0', '864', '0', '13');
INSERT INTO public.who_global_data_import VALUES (17974, '2021-01-10', 'KM', 'Comoros', 'AFRO', '286', '1150', '5', '18');
INSERT INTO public.who_global_data_import VALUES (17975, '2021-01-11', 'KM', 'Comoros', 'AFRO', '34', '1184', '7', '25');
INSERT INTO public.who_global_data_import VALUES (17976, '2021-01-12', 'KM', 'Comoros', 'AFRO', '0', '1184', '0', '25');
INSERT INTO public.who_global_data_import VALUES (17977, '2021-01-13', 'KM', 'Comoros', 'AFRO', '104', '1288', '5', '30');
INSERT INTO public.who_global_data_import VALUES (17978, '2021-01-14', 'KM', 'Comoros', 'AFRO', '53', '1341', '3', '33');
INSERT INTO public.who_global_data_import VALUES (17979, '2021-01-15', 'KM', 'Comoros', 'AFRO', '62', '1403', '5', '38');
INSERT INTO public.who_global_data_import VALUES (17980, '2021-01-16', 'KM', 'Comoros', 'AFRO', '66', '1469', '0', '38');
INSERT INTO public.who_global_data_import VALUES (17981, '2021-01-17', 'KM', 'Comoros', 'AFRO', '108', '1577', '3', '41');
INSERT INTO public.who_global_data_import VALUES (17982, '2021-01-18', 'KM', 'Comoros', 'AFRO', '15', '1592', '4', '45');
INSERT INTO public.who_global_data_import VALUES (17983, '2021-01-19', 'KM', 'Comoros', 'AFRO', '177', '1769', '4', '49');
INSERT INTO public.who_global_data_import VALUES (17984, '2021-01-20', 'KM', 'Comoros', 'AFRO', '95', '1864', '2', '51');
INSERT INTO public.who_global_data_import VALUES (17985, '2021-01-21', 'KM', 'Comoros', 'AFRO', '69', '1933', '3', '54');
INSERT INTO public.who_global_data_import VALUES (17986, '2021-01-22', 'KM', 'Comoros', 'AFRO', '149', '2082', '8', '62');
INSERT INTO public.who_global_data_import VALUES (17987, '2021-01-23', 'KM', 'Comoros', 'AFRO', '78', '2160', '1', '63');
INSERT INTO public.who_global_data_import VALUES (17988, '2021-01-24', 'KM', 'Comoros', 'AFRO', '100', '2260', '7', '70');
INSERT INTO public.who_global_data_import VALUES (17989, '2021-01-25', 'KM', 'Comoros', 'AFRO', '8', '2268', '1', '71');
INSERT INTO public.who_global_data_import VALUES (17990, '2021-01-26', 'KM', 'Comoros', 'AFRO', '82', '2350', '5', '76');
INSERT INTO public.who_global_data_import VALUES (17991, '2021-01-27', 'KM', 'Comoros', 'AFRO', '75', '2425', '1', '77');
INSERT INTO public.who_global_data_import VALUES (17992, '2021-01-28', 'KM', 'Comoros', 'AFRO', '67', '2492', '4', '81');
INSERT INTO public.who_global_data_import VALUES (17993, '2021-01-29', 'KM', 'Comoros', 'AFRO', '106', '2598', '4', '85');
INSERT INTO public.who_global_data_import VALUES (17994, '2021-01-30', 'KM', 'Comoros', 'AFRO', '48', '2646', '4', '89');
INSERT INTO public.who_global_data_import VALUES (17995, '2021-01-31', 'KM', 'Comoros', 'AFRO', '72', '2718', '1', '90');
INSERT INTO public.who_global_data_import VALUES (17996, '2021-02-01', 'KM', 'Comoros', 'AFRO', '8', '2726', '3', '93');
INSERT INTO public.who_global_data_import VALUES (17997, '2021-02-02', 'KM', 'Comoros', 'AFRO', '85', '2811', '5', '98');
INSERT INTO public.who_global_data_import VALUES (17998, '2021-02-03', 'KM', 'Comoros', 'AFRO', '37', '2848', '2', '100');
INSERT INTO public.who_global_data_import VALUES (17999, '2021-02-04', 'KM', 'Comoros', 'AFRO', '44', '2892', '4', '104');
INSERT INTO public.who_global_data_import VALUES (18000, '2021-02-05', 'KM', 'Comoros', 'AFRO', '83', '2975', '1', '105');
INSERT INTO public.who_global_data_import VALUES (18001, '2020-01-03', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18002, '2020-01-04', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18003, '2020-01-05', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18004, '2020-01-06', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18005, '2020-01-07', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18006, '2020-01-08', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18007, '2020-01-09', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18008, '2020-01-10', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18009, '2020-01-11', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18010, '2020-01-12', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18011, '2020-01-13', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18012, '2020-01-14', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18013, '2020-01-15', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18014, '2020-01-16', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18015, '2020-01-17', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18016, '2020-01-18', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18017, '2020-01-19', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18018, '2020-01-20', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18019, '2020-01-21', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18020, '2020-01-22', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18021, '2020-01-23', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18022, '2020-01-24', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18023, '2020-01-25', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18024, '2020-01-26', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18025, '2020-01-27', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18026, '2020-01-28', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18027, '2020-01-29', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18028, '2020-01-30', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18029, '2020-01-31', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18030, '2020-02-01', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18031, '2020-02-02', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18032, '2020-02-03', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18033, '2020-02-04', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18034, '2020-02-05', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18035, '2020-02-06', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18036, '2020-02-07', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18037, '2020-02-08', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18038, '2020-02-09', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18039, '2020-02-10', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18040, '2020-02-11', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18041, '2020-02-12', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18042, '2020-02-13', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18043, '2020-02-14', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18044, '2020-02-15', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18045, '2020-02-16', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18046, '2020-02-17', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18047, '2020-02-18', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18048, '2020-02-19', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18049, '2020-02-20', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18050, '2020-02-21', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18051, '2020-02-22', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18052, '2020-02-23', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18053, '2020-02-24', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18054, '2020-02-25', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18055, '2020-02-26', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18056, '2020-02-27', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18057, '2020-02-28', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18058, '2020-02-29', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18059, '2020-03-01', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18060, '2020-03-02', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18061, '2020-03-03', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18062, '2020-03-04', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18063, '2020-03-05', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18064, '2020-03-06', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18065, '2020-03-07', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18066, '2020-03-08', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18067, '2020-03-09', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18068, '2020-03-10', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18069, '2020-03-11', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18070, '2020-03-12', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18071, '2020-03-13', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18072, '2020-03-14', 'CG', 'Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18073, '2020-03-15', 'CG', 'Congo', 'AFRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18074, '2020-03-16', 'CG', 'Congo', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18075, '2020-03-17', 'CG', 'Congo', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18076, '2020-03-18', 'CG', 'Congo', 'AFRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18077, '2020-03-19', 'CG', 'Congo', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18078, '2020-03-20', 'CG', 'Congo', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18079, '2020-03-21', 'CG', 'Congo', 'AFRO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18080, '2020-03-22', 'CG', 'Congo', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18081, '2020-03-23', 'CG', 'Congo', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18082, '2020-03-24', 'CG', 'Congo', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18083, '2020-03-25', 'CG', 'Congo', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18084, '2020-03-26', 'CG', 'Congo', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18085, '2020-03-27', 'CG', 'Congo', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18086, '2020-03-28', 'CG', 'Congo', 'AFRO', '15', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18087, '2020-03-29', 'CG', 'Congo', 'AFRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18088, '2020-03-30', 'CG', 'Congo', 'AFRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18089, '2020-03-31', 'CG', 'Congo', 'AFRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18090, '2020-04-01', 'CG', 'Congo', 'AFRO', '3', '22', '2', '2');
INSERT INTO public.who_global_data_import VALUES (18091, '2020-04-02', 'CG', 'Congo', 'AFRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18092, '2020-04-03', 'CG', 'Congo', 'AFRO', '19', '41', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18093, '2020-04-04', 'CG', 'Congo', 'AFRO', '0', '41', '1', '3');
INSERT INTO public.who_global_data_import VALUES (18094, '2020-04-05', 'CG', 'Congo', 'AFRO', '4', '45', '2', '5');
INSERT INTO public.who_global_data_import VALUES (18095, '2020-04-06', 'CG', 'Congo', 'AFRO', '0', '45', '0', '5');
INSERT INTO public.who_global_data_import VALUES (18096, '2020-04-07', 'CG', 'Congo', 'AFRO', '0', '45', '0', '5');
INSERT INTO public.who_global_data_import VALUES (18097, '2020-04-08', 'CG', 'Congo', 'AFRO', '4', '49', '0', '5');
INSERT INTO public.who_global_data_import VALUES (18098, '2020-04-09', 'CG', 'Congo', 'AFRO', '11', '60', '0', '5');
INSERT INTO public.who_global_data_import VALUES (18099, '2020-04-10', 'CG', 'Congo', 'AFRO', '0', '60', '0', '5');
INSERT INTO public.who_global_data_import VALUES (18100, '2020-04-11', 'CG', 'Congo', 'AFRO', '0', '60', '0', '5');
INSERT INTO public.who_global_data_import VALUES (18101, '2020-04-12', 'CG', 'Congo', 'AFRO', '0', '60', '0', '5');
INSERT INTO public.who_global_data_import VALUES (18102, '2020-04-13', 'CG', 'Congo', 'AFRO', '10', '70', '0', '5');
INSERT INTO public.who_global_data_import VALUES (18103, '2020-04-14', 'CG', 'Congo', 'AFRO', '4', '74', '0', '5');
INSERT INTO public.who_global_data_import VALUES (18104, '2020-04-15', 'CG', 'Congo', 'AFRO', '0', '74', '0', '5');
INSERT INTO public.who_global_data_import VALUES (18105, '2020-04-16', 'CG', 'Congo', 'AFRO', '43', '117', '0', '5');
INSERT INTO public.who_global_data_import VALUES (18106, '2020-04-17', 'CG', 'Congo', 'AFRO', '0', '117', '0', '5');
INSERT INTO public.who_global_data_import VALUES (18107, '2020-04-18', 'CG', 'Congo', 'AFRO', '26', '143', '1', '6');
INSERT INTO public.who_global_data_import VALUES (18108, '2020-04-19', 'CG', 'Congo', 'AFRO', '0', '143', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18109, '2020-04-20', 'CG', 'Congo', 'AFRO', '0', '143', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18110, '2020-04-21', 'CG', 'Congo', 'AFRO', '17', '160', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18111, '2020-04-22', 'CG', 'Congo', 'AFRO', '5', '165', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18112, '2020-04-23', 'CG', 'Congo', 'AFRO', '21', '186', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18113, '2020-04-24', 'CG', 'Congo', 'AFRO', '0', '186', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18114, '2020-04-25', 'CG', 'Congo', 'AFRO', '14', '200', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18115, '2020-04-26', 'CG', 'Congo', 'AFRO', '0', '200', '2', '8');
INSERT INTO public.who_global_data_import VALUES (18116, '2020-04-27', 'CG', 'Congo', 'AFRO', '0', '200', '0', '8');
INSERT INTO public.who_global_data_import VALUES (18117, '2020-04-28', 'CG', 'Congo', 'AFRO', '7', '207', '0', '8');
INSERT INTO public.who_global_data_import VALUES (18118, '2020-04-29', 'CG', 'Congo', 'AFRO', '0', '207', '0', '8');
INSERT INTO public.who_global_data_import VALUES (18119, '2020-04-30', 'CG', 'Congo', 'AFRO', '13', '220', '1', '9');
INSERT INTO public.who_global_data_import VALUES (18120, '2020-05-01', 'CG', 'Congo', 'AFRO', '0', '220', '0', '9');
INSERT INTO public.who_global_data_import VALUES (18121, '2020-05-02', 'CG', 'Congo', 'AFRO', '9', '229', '1', '10');
INSERT INTO public.who_global_data_import VALUES (18122, '2020-05-03', 'CG', 'Congo', 'AFRO', '0', '229', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18123, '2020-05-04', 'CG', 'Congo', 'AFRO', '0', '229', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18124, '2020-05-05', 'CG', 'Congo', 'AFRO', '7', '236', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18125, '2020-05-06', 'CG', 'Congo', 'AFRO', '0', '236', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18126, '2020-05-07', 'CG', 'Congo', 'AFRO', '28', '264', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18127, '2020-05-08', 'CG', 'Congo', 'AFRO', '10', '274', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18128, '2020-05-09', 'CG', 'Congo', 'AFRO', '13', '287', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18129, '2020-05-10', 'CG', 'Congo', 'AFRO', '0', '287', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18130, '2020-05-11', 'CG', 'Congo', 'AFRO', '0', '287', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18131, '2020-05-12', 'CG', 'Congo', 'AFRO', '46', '333', '1', '11');
INSERT INTO public.who_global_data_import VALUES (18132, '2020-05-13', 'CG', 'Congo', 'AFRO', '0', '333', '0', '11');
INSERT INTO public.who_global_data_import VALUES (18133, '2020-05-14', 'CG', 'Congo', 'AFRO', '8', '341', '0', '11');
INSERT INTO public.who_global_data_import VALUES (18134, '2020-05-15', 'CG', 'Congo', 'AFRO', '50', '391', '4', '15');
INSERT INTO public.who_global_data_import VALUES (18135, '2020-05-16', 'CG', 'Congo', 'AFRO', '0', '391', '0', '15');
INSERT INTO public.who_global_data_import VALUES (18136, '2020-05-17', 'CG', 'Congo', 'AFRO', '0', '391', '0', '15');
INSERT INTO public.who_global_data_import VALUES (18137, '2020-05-18', 'CG', 'Congo', 'AFRO', '19', '410', '0', '15');
INSERT INTO public.who_global_data_import VALUES (18138, '2020-05-19', 'CG', 'Congo', 'AFRO', '4', '414', '0', '15');
INSERT INTO public.who_global_data_import VALUES (18139, '2020-05-20', 'CG', 'Congo', 'AFRO', '6', '420', '0', '15');
INSERT INTO public.who_global_data_import VALUES (18140, '2020-05-21', 'CG', 'Congo', 'AFRO', '0', '420', '0', '15');
INSERT INTO public.who_global_data_import VALUES (18141, '2020-05-22', 'CG', 'Congo', 'AFRO', '49', '469', '1', '16');
INSERT INTO public.who_global_data_import VALUES (18142, '2020-05-23', 'CG', 'Congo', 'AFRO', '0', '469', '0', '16');
INSERT INTO public.who_global_data_import VALUES (18143, '2020-05-24', 'CG', 'Congo', 'AFRO', '18', '487', '0', '16');
INSERT INTO public.who_global_data_import VALUES (18144, '2020-05-25', 'CG', 'Congo', 'AFRO', '0', '487', '0', '16');
INSERT INTO public.who_global_data_import VALUES (18145, '2020-05-26', 'CG', 'Congo', 'AFRO', '44', '531', '1', '17');
INSERT INTO public.who_global_data_import VALUES (18146, '2020-05-27', 'CG', 'Congo', 'AFRO', '38', '569', '2', '19');
INSERT INTO public.who_global_data_import VALUES (18147, '2020-05-28', 'CG', 'Congo', 'AFRO', '2', '571', '0', '19');
INSERT INTO public.who_global_data_import VALUES (18148, '2020-05-29', 'CG', 'Congo', 'AFRO', '0', '571', '0', '19');
INSERT INTO public.who_global_data_import VALUES (18149, '2020-05-30', 'CG', 'Congo', 'AFRO', '16', '587', '0', '19');
INSERT INTO public.who_global_data_import VALUES (18150, '2020-05-31', 'CG', 'Congo', 'AFRO', '0', '587', '0', '19');
INSERT INTO public.who_global_data_import VALUES (18151, '2020-06-01', 'CG', 'Congo', 'AFRO', '17', '604', '1', '20');
INSERT INTO public.who_global_data_import VALUES (18152, '2020-06-02', 'CG', 'Congo', 'AFRO', '7', '611', '0', '20');
INSERT INTO public.who_global_data_import VALUES (18153, '2020-06-03', 'CG', 'Congo', 'AFRO', '7', '618', '0', '20');
INSERT INTO public.who_global_data_import VALUES (18154, '2020-06-04', 'CG', 'Congo', 'AFRO', '14', '632', '0', '20');
INSERT INTO public.who_global_data_import VALUES (18155, '2020-06-05', 'CG', 'Congo', 'AFRO', '3', '635', '0', '20');
INSERT INTO public.who_global_data_import VALUES (18156, '2020-06-06', 'CG', 'Congo', 'AFRO', '4', '639', '0', '20');
INSERT INTO public.who_global_data_import VALUES (18157, '2020-06-07', 'CG', 'Congo', 'AFRO', '14', '653', '0', '20');
INSERT INTO public.who_global_data_import VALUES (18158, '2020-06-08', 'CG', 'Congo', 'AFRO', '30', '683', '2', '22');
INSERT INTO public.who_global_data_import VALUES (18159, '2020-06-09', 'CG', 'Congo', 'AFRO', '0', '683', '-2', '20');
INSERT INTO public.who_global_data_import VALUES (18160, '2020-06-10', 'CG', 'Congo', 'AFRO', '35', '718', '4', '24');
INSERT INTO public.who_global_data_import VALUES (18161, '2020-06-11', 'CG', 'Congo', 'AFRO', '10', '728', '0', '24');
INSERT INTO public.who_global_data_import VALUES (18162, '2020-06-12', 'CG', 'Congo', 'AFRO', '17', '745', '1', '25');
INSERT INTO public.who_global_data_import VALUES (18163, '2020-06-13', 'CG', 'Congo', 'AFRO', '0', '745', '0', '25');
INSERT INTO public.who_global_data_import VALUES (18164, '2020-06-14', 'CG', 'Congo', 'AFRO', '34', '779', '0', '25');
INSERT INTO public.who_global_data_import VALUES (18165, '2020-06-15', 'CG', 'Congo', 'AFRO', '0', '779', '0', '25');
INSERT INTO public.who_global_data_import VALUES (18166, '2020-06-16', 'CG', 'Congo', 'AFRO', '104', '883', '2', '27');
INSERT INTO public.who_global_data_import VALUES (18167, '2020-06-17', 'CG', 'Congo', 'AFRO', '0', '883', '0', '27');
INSERT INTO public.who_global_data_import VALUES (18168, '2020-06-18', 'CG', 'Congo', 'AFRO', '0', '883', '0', '27');
INSERT INTO public.who_global_data_import VALUES (18169, '2020-06-19', 'CG', 'Congo', 'AFRO', '0', '883', '0', '27');
INSERT INTO public.who_global_data_import VALUES (18170, '2020-06-20', 'CG', 'Congo', 'AFRO', '0', '883', '0', '27');
INSERT INTO public.who_global_data_import VALUES (18171, '2020-06-21', 'CG', 'Congo', 'AFRO', '0', '883', '0', '27');
INSERT INTO public.who_global_data_import VALUES (18172, '2020-06-22', 'CG', 'Congo', 'AFRO', '0', '883', '0', '27');
INSERT INTO public.who_global_data_import VALUES (18173, '2020-06-23', 'CG', 'Congo', 'AFRO', '204', '1087', '10', '37');
INSERT INTO public.who_global_data_import VALUES (18174, '2020-06-24', 'CG', 'Congo', 'AFRO', '54', '1141', '0', '37');
INSERT INTO public.who_global_data_import VALUES (18175, '2020-06-25', 'CG', 'Congo', 'AFRO', '0', '1141', '0', '37');
INSERT INTO public.who_global_data_import VALUES (18176, '2020-06-26', 'CG', 'Congo', 'AFRO', '63', '1204', '1', '38');
INSERT INTO public.who_global_data_import VALUES (18177, '2020-06-27', 'CG', 'Congo', 'AFRO', '0', '1204', '0', '38');
INSERT INTO public.who_global_data_import VALUES (18178, '2020-06-28', 'CG', 'Congo', 'AFRO', '41', '1245', '2', '40');
INSERT INTO public.who_global_data_import VALUES (18179, '2020-06-29', 'CG', 'Congo', 'AFRO', '0', '1245', '0', '40');
INSERT INTO public.who_global_data_import VALUES (18180, '2020-06-30', 'CG', 'Congo', 'AFRO', '0', '1245', '0', '40');
INSERT INTO public.who_global_data_import VALUES (18181, '2020-07-01', 'CG', 'Congo', 'AFRO', '84', '1329', '1', '41');
INSERT INTO public.who_global_data_import VALUES (18182, '2020-07-02', 'CG', 'Congo', 'AFRO', '114', '1443', '1', '42');
INSERT INTO public.who_global_data_import VALUES (18183, '2020-07-03', 'CG', 'Congo', 'AFRO', '0', '1443', '0', '42');
INSERT INTO public.who_global_data_import VALUES (18184, '2020-07-04', 'CG', 'Congo', 'AFRO', '114', '1557', '2', '44');
INSERT INTO public.who_global_data_import VALUES (18185, '2020-07-05', 'CG', 'Congo', 'AFRO', '0', '1557', '0', '44');
INSERT INTO public.who_global_data_import VALUES (18186, '2020-07-06', 'CG', 'Congo', 'AFRO', '0', '1557', '0', '44');
INSERT INTO public.who_global_data_import VALUES (18187, '2020-07-07', 'CG', 'Congo', 'AFRO', '0', '1557', '0', '44');
INSERT INTO public.who_global_data_import VALUES (18188, '2020-07-08', 'CG', 'Congo', 'AFRO', '200', '1757', '0', '44');
INSERT INTO public.who_global_data_import VALUES (18189, '2020-07-09', 'CG', 'Congo', 'AFRO', '64', '1821', '3', '47');
INSERT INTO public.who_global_data_import VALUES (18190, '2020-07-10', 'CG', 'Congo', 'AFRO', '207', '2028', '0', '47');
INSERT INTO public.who_global_data_import VALUES (18191, '2020-07-11', 'CG', 'Congo', 'AFRO', '0', '2028', '0', '47');
INSERT INTO public.who_global_data_import VALUES (18192, '2020-07-12', 'CG', 'Congo', 'AFRO', '75', '2103', '0', '47');
INSERT INTO public.who_global_data_import VALUES (18193, '2020-07-13', 'CG', 'Congo', 'AFRO', '0', '2103', '0', '47');
INSERT INTO public.who_global_data_import VALUES (18194, '2020-07-14', 'CG', 'Congo', 'AFRO', '119', '2222', '0', '47');
INSERT INTO public.who_global_data_import VALUES (18195, '2020-07-15', 'CG', 'Congo', 'AFRO', '136', '2358', '1', '48');
INSERT INTO public.who_global_data_import VALUES (18196, '2020-07-16', 'CG', 'Congo', 'AFRO', '0', '2358', '0', '48');
INSERT INTO public.who_global_data_import VALUES (18197, '2020-07-17', 'CG', 'Congo', 'AFRO', '0', '2358', '0', '48');
INSERT INTO public.who_global_data_import VALUES (18198, '2020-07-18', 'CG', 'Congo', 'AFRO', '275', '2633', '1', '49');
INSERT INTO public.who_global_data_import VALUES (18199, '2020-07-19', 'CG', 'Congo', 'AFRO', '0', '2633', '0', '49');
INSERT INTO public.who_global_data_import VALUES (18200, '2020-07-20', 'CG', 'Congo', 'AFRO', '0', '2633', '0', '49');
INSERT INTO public.who_global_data_import VALUES (18201, '2020-07-21', 'CG', 'Congo', 'AFRO', '218', '2851', '1', '50');
INSERT INTO public.who_global_data_import VALUES (18202, '2020-07-22', 'CG', 'Congo', 'AFRO', '0', '2851', '0', '50');
INSERT INTO public.who_global_data_import VALUES (18203, '2020-07-23', 'CG', 'Congo', 'AFRO', '83', '2934', '1', '51');
INSERT INTO public.who_global_data_import VALUES (18204, '2020-07-24', 'CG', 'Congo', 'AFRO', '0', '2934', '0', '51');
INSERT INTO public.who_global_data_import VALUES (18205, '2020-07-25', 'CG', 'Congo', 'AFRO', '104', '3038', '0', '51');
INSERT INTO public.who_global_data_import VALUES (18206, '2020-07-26', 'CG', 'Congo', 'AFRO', '0', '3038', '0', '51');
INSERT INTO public.who_global_data_import VALUES (18207, '2020-07-27', 'CG', 'Congo', 'AFRO', '121', '3159', '3', '54');
INSERT INTO public.who_global_data_import VALUES (18208, '2020-07-28', 'CG', 'Congo', 'AFRO', '0', '3159', '0', '54');
INSERT INTO public.who_global_data_import VALUES (18209, '2020-07-29', 'CG', 'Congo', 'AFRO', '41', '3200', '0', '54');
INSERT INTO public.who_global_data_import VALUES (18210, '2020-07-30', 'CG', 'Congo', 'AFRO', '0', '3200', '0', '54');
INSERT INTO public.who_global_data_import VALUES (18211, '2020-07-31', 'CG', 'Congo', 'AFRO', '176', '3376', '2', '56');
INSERT INTO public.who_global_data_import VALUES (18212, '2020-08-01', 'CG', 'Congo', 'AFRO', '0', '3376', '0', '56');
INSERT INTO public.who_global_data_import VALUES (18213, '2020-08-02', 'CG', 'Congo', 'AFRO', '11', '3387', '0', '56');
INSERT INTO public.who_global_data_import VALUES (18214, '2020-08-03', 'CG', 'Congo', 'AFRO', '0', '3387', '0', '56');
INSERT INTO public.who_global_data_import VALUES (18215, '2020-08-04', 'CG', 'Congo', 'AFRO', '0', '3387', '1', '57');
INSERT INTO public.who_global_data_import VALUES (18216, '2020-08-05', 'CG', 'Congo', 'AFRO', '159', '3546', '1', '58');
INSERT INTO public.who_global_data_import VALUES (18217, '2020-08-06', 'CG', 'Congo', 'AFRO', '0', '3546', '0', '58');
INSERT INTO public.who_global_data_import VALUES (18218, '2020-08-07', 'CG', 'Congo', 'AFRO', '91', '3637', '0', '58');
INSERT INTO public.who_global_data_import VALUES (18219, '2020-08-08', 'CG', 'Congo', 'AFRO', '27', '3664', '0', '58');
INSERT INTO public.who_global_data_import VALUES (18220, '2020-08-09', 'CG', 'Congo', 'AFRO', '0', '3664', '0', '58');
INSERT INTO public.who_global_data_import VALUES (18221, '2020-08-10', 'CG', 'Congo', 'AFRO', '0', '3664', '0', '58');
INSERT INTO public.who_global_data_import VALUES (18222, '2020-08-11', 'CG', 'Congo', 'AFRO', '81', '3745', '2', '60');
INSERT INTO public.who_global_data_import VALUES (18223, '2020-08-12', 'CG', 'Congo', 'AFRO', '0', '3745', '0', '60');
INSERT INTO public.who_global_data_import VALUES (18224, '2020-08-13', 'CG', 'Congo', 'AFRO', '0', '3745', '0', '60');
INSERT INTO public.who_global_data_import VALUES (18225, '2020-08-14', 'CG', 'Congo', 'AFRO', '0', '3745', '0', '60');
INSERT INTO public.who_global_data_import VALUES (18226, '2020-08-15', 'CG', 'Congo', 'AFRO', '0', '3745', '0', '60');
INSERT INTO public.who_global_data_import VALUES (18227, '2020-08-16', 'CG', 'Congo', 'AFRO', '86', '3831', '16', '76');
INSERT INTO public.who_global_data_import VALUES (18228, '2020-08-17', 'CG', 'Congo', 'AFRO', '0', '3831', '0', '76');
INSERT INTO public.who_global_data_import VALUES (18229, '2020-08-18', 'CG', 'Congo', 'AFRO', '0', '3831', '0', '76');
INSERT INTO public.who_global_data_import VALUES (18230, '2020-08-19', 'CG', 'Congo', 'AFRO', '19', '3850', '1', '77');
INSERT INTO public.who_global_data_import VALUES (18231, '2020-08-20', 'CG', 'Congo', 'AFRO', '0', '3850', '0', '77');
INSERT INTO public.who_global_data_import VALUES (18232, '2020-08-21', 'CG', 'Congo', 'AFRO', '0', '3850', '0', '77');
INSERT INTO public.who_global_data_import VALUES (18233, '2020-08-22', 'CG', 'Congo', 'AFRO', '0', '3850', '0', '77');
INSERT INTO public.who_global_data_import VALUES (18234, '2020-08-23', 'CG', 'Congo', 'AFRO', '0', '3850', '0', '77');
INSERT INTO public.who_global_data_import VALUES (18235, '2020-08-24', 'CG', 'Congo', 'AFRO', '0', '3850', '0', '77');
INSERT INTO public.who_global_data_import VALUES (18236, '2020-08-25', 'CG', 'Congo', 'AFRO', '129', '3979', '1', '78');
INSERT INTO public.who_global_data_import VALUES (18237, '2020-08-26', 'CG', 'Congo', 'AFRO', '0', '3979', '0', '78');
INSERT INTO public.who_global_data_import VALUES (18238, '2020-08-27', 'CG', 'Congo', 'AFRO', '0', '3979', '0', '78');
INSERT INTO public.who_global_data_import VALUES (18239, '2020-08-28', 'CG', 'Congo', 'AFRO', '0', '3979', '0', '78');
INSERT INTO public.who_global_data_import VALUES (18240, '2020-08-29', 'CG', 'Congo', 'AFRO', '0', '3979', '0', '78');
INSERT INTO public.who_global_data_import VALUES (18241, '2020-08-30', 'CG', 'Congo', 'AFRO', '0', '3979', '0', '78');
INSERT INTO public.who_global_data_import VALUES (18242, '2020-08-31', 'CG', 'Congo', 'AFRO', '0', '3979', '0', '78');
INSERT INTO public.who_global_data_import VALUES (18243, '2020-09-01', 'CG', 'Congo', 'AFRO', '0', '3979', '0', '78');
INSERT INTO public.who_global_data_import VALUES (18244, '2020-09-02', 'CG', 'Congo', 'AFRO', '649', '4628', '4', '82');
INSERT INTO public.who_global_data_import VALUES (18245, '2020-09-03', 'CG', 'Congo', 'AFRO', '0', '4628', '0', '82');
INSERT INTO public.who_global_data_import VALUES (18246, '2020-09-04', 'CG', 'Congo', 'AFRO', '0', '4628', '0', '82');
INSERT INTO public.who_global_data_import VALUES (18247, '2020-09-05', 'CG', 'Congo', 'AFRO', '0', '4628', '0', '82');
INSERT INTO public.who_global_data_import VALUES (18248, '2020-09-06', 'CG', 'Congo', 'AFRO', '0', '4628', '0', '82');
INSERT INTO public.who_global_data_import VALUES (18249, '2020-09-07', 'CG', 'Congo', 'AFRO', '239', '4867', '0', '82');
INSERT INTO public.who_global_data_import VALUES (18250, '2020-09-08', 'CG', 'Congo', 'AFRO', '24', '4891', '0', '82');
INSERT INTO public.who_global_data_import VALUES (18251, '2020-09-09', 'CG', 'Congo', 'AFRO', '0', '4891', '0', '82');
INSERT INTO public.who_global_data_import VALUES (18252, '2020-09-10', 'CG', 'Congo', 'AFRO', '0', '4891', '0', '82');
INSERT INTO public.who_global_data_import VALUES (18253, '2020-09-11', 'CG', 'Congo', 'AFRO', '22', '4913', '6', '88');
INSERT INTO public.who_global_data_import VALUES (18254, '2020-09-12', 'CG', 'Congo', 'AFRO', '0', '4913', '0', '88');
INSERT INTO public.who_global_data_import VALUES (18255, '2020-09-13', 'CG', 'Congo', 'AFRO', '21', '4934', '0', '88');
INSERT INTO public.who_global_data_import VALUES (18256, '2020-09-14', 'CG', 'Congo', 'AFRO', '0', '4934', '0', '88');
INSERT INTO public.who_global_data_import VALUES (18257, '2020-09-15', 'CG', 'Congo', 'AFRO', '0', '4934', '0', '88');
INSERT INTO public.who_global_data_import VALUES (18258, '2020-09-16', 'CG', 'Congo', 'AFRO', '0', '4934', '0', '88');
INSERT INTO public.who_global_data_import VALUES (18259, '2020-09-17', 'CG', 'Congo', 'AFRO', '46', '4980', '1', '89');
INSERT INTO public.who_global_data_import VALUES (18260, '2020-09-18', 'CG', 'Congo', 'AFRO', '0', '4980', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18261, '2020-09-19', 'CG', 'Congo', 'AFRO', '6', '4986', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18262, '2020-09-20', 'CG', 'Congo', 'AFRO', '0', '4986', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18263, '2020-09-21', 'CG', 'Congo', 'AFRO', '16', '5002', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18264, '2020-09-22', 'CG', 'Congo', 'AFRO', '0', '5002', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18265, '2020-09-23', 'CG', 'Congo', 'AFRO', '3', '5005', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18266, '2020-09-24', 'CG', 'Congo', 'AFRO', '0', '5005', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18267, '2020-09-25', 'CG', 'Congo', 'AFRO', '0', '5005', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18268, '2020-09-26', 'CG', 'Congo', 'AFRO', '0', '5005', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18269, '2020-09-27', 'CG', 'Congo', 'AFRO', '3', '5008', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18270, '2020-09-28', 'CG', 'Congo', 'AFRO', '0', '5008', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18271, '2020-09-29', 'CG', 'Congo', 'AFRO', '0', '5008', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18272, '2020-09-30', 'CG', 'Congo', 'AFRO', '81', '5089', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18273, '2020-10-01', 'CG', 'Congo', 'AFRO', '0', '5089', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18274, '2020-10-02', 'CG', 'Congo', 'AFRO', '0', '5089', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18275, '2020-10-03', 'CG', 'Congo', 'AFRO', '0', '5089', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18276, '2020-10-04', 'CG', 'Congo', 'AFRO', '0', '5089', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18277, '2020-10-05', 'CG', 'Congo', 'AFRO', '0', '5089', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18278, '2020-10-06', 'CG', 'Congo', 'AFRO', '0', '5089', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18279, '2020-10-07', 'CG', 'Congo', 'AFRO', '0', '5089', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18280, '2020-10-08', 'CG', 'Congo', 'AFRO', '0', '5089', '0', '89');
INSERT INTO public.who_global_data_import VALUES (18281, '2020-10-09', 'CG', 'Congo', 'AFRO', '29', '5118', '1', '90');
INSERT INTO public.who_global_data_import VALUES (18282, '2020-10-10', 'CG', 'Congo', 'AFRO', '0', '5118', '0', '90');
INSERT INTO public.who_global_data_import VALUES (18283, '2020-10-11', 'CG', 'Congo', 'AFRO', '0', '5118', '0', '90');
INSERT INTO public.who_global_data_import VALUES (18284, '2020-10-12', 'CG', 'Congo', 'AFRO', '0', '5118', '0', '90');
INSERT INTO public.who_global_data_import VALUES (18285, '2020-10-13', 'CG', 'Congo', 'AFRO', '0', '5118', '0', '90');
INSERT INTO public.who_global_data_import VALUES (18286, '2020-10-14', 'CG', 'Congo', 'AFRO', '38', '5156', '2', '92');
INSERT INTO public.who_global_data_import VALUES (18287, '2020-10-15', 'CG', 'Congo', 'AFRO', '0', '5156', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18288, '2020-10-16', 'CG', 'Congo', 'AFRO', '0', '5156', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18289, '2020-10-17', 'CG', 'Congo', 'AFRO', '0', '5156', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18290, '2020-10-18', 'CG', 'Congo', 'AFRO', '0', '5156', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18291, '2020-10-19', 'CG', 'Congo', 'AFRO', '0', '5156', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18292, '2020-10-20', 'CG', 'Congo', 'AFRO', '0', '5156', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18293, '2020-10-21', 'CG', 'Congo', 'AFRO', '0', '5156', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18294, '2020-10-22', 'CG', 'Congo', 'AFRO', '0', '5156', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18295, '2020-10-23', 'CG', 'Congo', 'AFRO', '0', '5156', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18296, '2020-10-24', 'CG', 'Congo', 'AFRO', '97', '5253', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18297, '2020-10-25', 'CG', 'Congo', 'AFRO', '0', '5253', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18298, '2020-10-26', 'CG', 'Congo', 'AFRO', '0', '5253', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18299, '2020-10-27', 'CG', 'Congo', 'AFRO', '0', '5253', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18300, '2020-10-28', 'CG', 'Congo', 'AFRO', '0', '5253', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18301, '2020-10-29', 'CG', 'Congo', 'AFRO', '37', '5290', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18302, '2020-10-30', 'CG', 'Congo', 'AFRO', '0', '5290', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18303, '2020-10-31', 'CG', 'Congo', 'AFRO', '0', '5290', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18304, '2020-11-01', 'CG', 'Congo', 'AFRO', '0', '5290', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18305, '2020-11-02', 'CG', 'Congo', 'AFRO', '0', '5290', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18306, '2020-11-03', 'CG', 'Congo', 'AFRO', '58', '5348', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18307, '2020-11-04', 'CG', 'Congo', 'AFRO', '0', '5348', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18308, '2020-11-05', 'CG', 'Congo', 'AFRO', '0', '5348', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18309, '2020-11-06', 'CG', 'Congo', 'AFRO', '31', '5379', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18310, '2020-11-07', 'CG', 'Congo', 'AFRO', '0', '5379', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18311, '2020-11-08', 'CG', 'Congo', 'AFRO', '0', '5379', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18312, '2020-11-09', 'CG', 'Congo', 'AFRO', '0', '5379', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18313, '2020-11-10', 'CG', 'Congo', 'AFRO', '0', '5379', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18314, '2020-11-11', 'CG', 'Congo', 'AFRO', '0', '5379', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18315, '2020-11-12', 'CG', 'Congo', 'AFRO', '0', '5379', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18316, '2020-11-13', 'CG', 'Congo', 'AFRO', '136', '5515', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18317, '2020-11-14', 'CG', 'Congo', 'AFRO', '0', '5515', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18318, '2020-11-15', 'CG', 'Congo', 'AFRO', '0', '5515', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18319, '2020-11-16', 'CG', 'Congo', 'AFRO', '0', '5515', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18320, '2020-11-17', 'CG', 'Congo', 'AFRO', '0', '5515', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18321, '2020-11-18', 'CG', 'Congo', 'AFRO', '0', '5515', '0', '92');
INSERT INTO public.who_global_data_import VALUES (18322, '2020-11-19', 'CG', 'Congo', 'AFRO', '117', '5632', '1', '93');
INSERT INTO public.who_global_data_import VALUES (18323, '2020-11-20', 'CG', 'Congo', 'AFRO', '0', '5632', '0', '93');
INSERT INTO public.who_global_data_import VALUES (18324, '2020-11-21', 'CG', 'Congo', 'AFRO', '0', '5632', '0', '93');
INSERT INTO public.who_global_data_import VALUES (18325, '2020-11-22', 'CG', 'Congo', 'AFRO', '0', '5632', '0', '93');
INSERT INTO public.who_global_data_import VALUES (18326, '2020-11-23', 'CG', 'Congo', 'AFRO', '0', '5632', '0', '93');
INSERT INTO public.who_global_data_import VALUES (18327, '2020-11-24', 'CG', 'Congo', 'AFRO', '0', '5632', '0', '93');
INSERT INTO public.who_global_data_import VALUES (18328, '2020-11-25', 'CG', 'Congo', 'AFRO', '0', '5632', '0', '93');
INSERT INTO public.who_global_data_import VALUES (18329, '2020-11-26', 'CG', 'Congo', 'AFRO', '0', '5632', '0', '93');
INSERT INTO public.who_global_data_import VALUES (18330, '2020-11-27', 'CG', 'Congo', 'AFRO', '142', '5774', '1', '94');
INSERT INTO public.who_global_data_import VALUES (18331, '2020-11-28', 'CG', 'Congo', 'AFRO', '0', '5774', '0', '94');
INSERT INTO public.who_global_data_import VALUES (18332, '2020-11-29', 'CG', 'Congo', 'AFRO', '0', '5774', '0', '94');
INSERT INTO public.who_global_data_import VALUES (18333, '2020-11-30', 'CG', 'Congo', 'AFRO', '0', '5774', '0', '94');
INSERT INTO public.who_global_data_import VALUES (18334, '2020-12-01', 'CG', 'Congo', 'AFRO', '0', '5774', '0', '94');
INSERT INTO public.who_global_data_import VALUES (18335, '2020-12-02', 'CG', 'Congo', 'AFRO', '0', '5774', '0', '94');
INSERT INTO public.who_global_data_import VALUES (18336, '2020-12-03', 'CG', 'Congo', 'AFRO', '0', '5774', '0', '94');
INSERT INTO public.who_global_data_import VALUES (18337, '2020-12-04', 'CG', 'Congo', 'AFRO', '0', '5774', '0', '94');
INSERT INTO public.who_global_data_import VALUES (18338, '2020-12-05', 'CG', 'Congo', 'AFRO', '0', '5774', '0', '94');
INSERT INTO public.who_global_data_import VALUES (18339, '2020-12-06', 'CG', 'Congo', 'AFRO', '0', '5774', '0', '94');
INSERT INTO public.who_global_data_import VALUES (18340, '2020-12-07', 'CG', 'Congo', 'AFRO', '0', '5774', '0', '94');
INSERT INTO public.who_global_data_import VALUES (18341, '2020-12-08', 'CG', 'Congo', 'AFRO', '0', '5774', '0', '94');
INSERT INTO public.who_global_data_import VALUES (18342, '2020-12-09', 'CG', 'Congo', 'AFRO', '275', '6049', '5', '99');
INSERT INTO public.who_global_data_import VALUES (18343, '2020-12-10', 'CG', 'Congo', 'AFRO', '0', '6049', '0', '99');
INSERT INTO public.who_global_data_import VALUES (18344, '2020-12-11', 'CG', 'Congo', 'AFRO', '0', '6049', '0', '99');
INSERT INTO public.who_global_data_import VALUES (18345, '2020-12-12', 'CG', 'Congo', 'AFRO', '0', '6049', '0', '99');
INSERT INTO public.who_global_data_import VALUES (18346, '2020-12-13', 'CG', 'Congo', 'AFRO', '0', '6049', '0', '99');
INSERT INTO public.who_global_data_import VALUES (18347, '2020-12-14', 'CG', 'Congo', 'AFRO', '151', '6200', '1', '100');
INSERT INTO public.who_global_data_import VALUES (18348, '2020-12-15', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18349, '2020-12-16', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18350, '2020-12-17', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18351, '2020-12-18', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18352, '2020-12-19', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18353, '2020-12-20', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18354, '2020-12-21', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18355, '2020-12-22', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18356, '2020-12-23', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18357, '2020-12-24', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18358, '2020-12-25', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18359, '2020-12-26', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18360, '2020-12-27', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18361, '2020-12-28', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18362, '2020-12-29', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18363, '2020-12-30', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18364, '2020-12-31', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18365, '2021-01-01', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18366, '2021-01-02', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18367, '2021-01-03', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18368, '2021-01-04', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18369, '2021-01-05', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18370, '2021-01-06', 'CG', 'Congo', 'AFRO', '0', '6200', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18371, '2021-01-07', 'CG', 'Congo', 'AFRO', '960', '7160', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18372, '2021-01-08', 'CG', 'Congo', 'AFRO', '0', '7160', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18373, '2021-01-09', 'CG', 'Congo', 'AFRO', '0', '7160', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18374, '2021-01-10', 'CG', 'Congo', 'AFRO', '0', '7160', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18375, '2021-01-11', 'CG', 'Congo', 'AFRO', '0', '7160', '0', '100');
INSERT INTO public.who_global_data_import VALUES (18376, '2021-01-12', 'CG', 'Congo', 'AFRO', '0', '7160', '12', '112');
INSERT INTO public.who_global_data_import VALUES (18377, '2021-01-13', 'CG', 'Congo', 'AFRO', '0', '7160', '0', '112');
INSERT INTO public.who_global_data_import VALUES (18378, '2021-01-14', 'CG', 'Congo', 'AFRO', '0', '7160', '0', '112');
INSERT INTO public.who_global_data_import VALUES (18379, '2021-01-15', 'CG', 'Congo', 'AFRO', '549', '7709', '2', '114');
INSERT INTO public.who_global_data_import VALUES (18380, '2021-01-16', 'CG', 'Congo', 'AFRO', '0', '7709', '0', '114');
INSERT INTO public.who_global_data_import VALUES (18381, '2021-01-17', 'CG', 'Congo', 'AFRO', '0', '7709', '0', '114');
INSERT INTO public.who_global_data_import VALUES (18382, '2021-01-18', 'CG', 'Congo', 'AFRO', '0', '7709', '0', '114');
INSERT INTO public.who_global_data_import VALUES (18383, '2021-01-19', 'CG', 'Congo', 'AFRO', '0', '7709', '0', '114');
INSERT INTO public.who_global_data_import VALUES (18384, '2021-01-20', 'CG', 'Congo', 'AFRO', '0', '7709', '0', '114');
INSERT INTO public.who_global_data_import VALUES (18385, '2021-01-21', 'CG', 'Congo', 'AFRO', '85', '7794', '3', '117');
INSERT INTO public.who_global_data_import VALUES (18386, '2021-01-22', 'CG', 'Congo', 'AFRO', '0', '7794', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18387, '2021-01-23', 'CG', 'Congo', 'AFRO', '0', '7794', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18388, '2021-01-24', 'CG', 'Congo', 'AFRO', '0', '7794', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18389, '2021-01-25', 'CG', 'Congo', 'AFRO', '93', '7887', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18390, '2021-01-26', 'CG', 'Congo', 'AFRO', '0', '7887', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18391, '2021-01-27', 'CG', 'Congo', 'AFRO', '0', '7887', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18392, '2021-01-28', 'CG', 'Congo', 'AFRO', '0', '7887', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18393, '2021-01-29', 'CG', 'Congo', 'AFRO', '0', '7887', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18394, '2021-01-30', 'CG', 'Congo', 'AFRO', '0', '7887', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18395, '2021-01-31', 'CG', 'Congo', 'AFRO', '0', '7887', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18396, '2021-02-01', 'CG', 'Congo', 'AFRO', '0', '7887', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18397, '2021-02-02', 'CG', 'Congo', 'AFRO', '0', '7887', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18398, '2021-02-03', 'CG', 'Congo', 'AFRO', '0', '7887', '0', '117');
INSERT INTO public.who_global_data_import VALUES (18399, '2021-02-04', 'CG', 'Congo', 'AFRO', '173', '8060', '5', '122');
INSERT INTO public.who_global_data_import VALUES (18400, '2021-02-05', 'CG', 'Congo', 'AFRO', '0', '8060', '0', '122');
INSERT INTO public.who_global_data_import VALUES (18401, '2020-01-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18402, '2020-01-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18403, '2020-01-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18404, '2020-01-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18405, '2020-01-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18406, '2020-01-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18407, '2020-01-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18408, '2020-01-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18409, '2020-01-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18410, '2020-01-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18411, '2020-01-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18412, '2020-01-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18413, '2020-01-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18414, '2020-01-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18415, '2020-01-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18416, '2020-01-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18417, '2020-01-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18418, '2020-01-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18419, '2020-01-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18420, '2020-01-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18421, '2020-01-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18422, '2020-01-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18423, '2020-01-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18424, '2020-01-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18425, '2020-01-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18426, '2020-01-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18427, '2020-01-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18428, '2020-01-30', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18429, '2020-01-31', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18430, '2020-02-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18431, '2020-02-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18432, '2020-02-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18433, '2020-02-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18434, '2020-02-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18435, '2020-02-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18436, '2020-02-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18437, '2020-02-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18438, '2020-02-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18439, '2020-02-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18440, '2020-02-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18441, '2020-02-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18442, '2020-02-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18443, '2020-02-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18444, '2020-02-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18445, '2020-02-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18446, '2020-02-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18447, '2020-02-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18448, '2020-02-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18449, '2020-02-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18450, '2020-02-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18451, '2020-02-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18452, '2020-02-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18453, '2020-02-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18454, '2020-02-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18455, '2020-02-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18456, '2020-02-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18457, '2020-02-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18458, '2020-02-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18459, '2020-03-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18460, '2020-03-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18461, '2020-03-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18462, '2020-03-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18463, '2020-03-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18464, '2020-03-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18465, '2020-03-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18466, '2020-03-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18467, '2020-03-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18468, '2020-03-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18469, '2020-03-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18470, '2020-03-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18471, '2020-03-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18472, '2020-03-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18473, '2020-03-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18474, '2020-03-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18475, '2020-03-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18476, '2020-03-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18477, '2020-03-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18478, '2020-03-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18479, '2020-03-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18480, '2020-03-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18481, '2020-03-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18482, '2020-03-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18483, '2020-03-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18484, '2020-03-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18485, '2020-03-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18486, '2020-03-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18487, '2020-03-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18488, '2020-03-30', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18489, '2020-03-31', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18490, '2020-04-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18491, '2020-04-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18492, '2020-04-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18493, '2020-04-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18494, '2020-04-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18495, '2020-04-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18496, '2020-04-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18497, '2020-04-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18498, '2020-04-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18499, '2020-04-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18500, '2020-04-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18501, '2020-04-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18502, '2020-04-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18503, '2020-04-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18504, '2020-04-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18505, '2020-04-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18506, '2020-04-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18507, '2020-04-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18508, '2020-04-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18509, '2020-04-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18510, '2020-04-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18511, '2020-04-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18512, '2020-04-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18513, '2020-04-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18514, '2020-04-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18515, '2020-04-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18516, '2020-04-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18517, '2020-04-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18518, '2020-04-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18519, '2020-04-30', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18520, '2020-05-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18521, '2020-05-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18522, '2020-05-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18523, '2020-05-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18524, '2020-05-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18525, '2020-05-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18526, '2020-05-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18527, '2020-05-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18528, '2020-05-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18529, '2020-05-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18530, '2020-05-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18531, '2020-05-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18532, '2020-05-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18533, '2020-05-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18534, '2020-05-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18535, '2020-05-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18536, '2020-05-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18537, '2020-05-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18538, '2020-05-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18539, '2020-05-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18540, '2020-05-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18541, '2020-05-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18542, '2020-05-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18543, '2020-05-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18544, '2020-05-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18545, '2020-05-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18546, '2020-05-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18547, '2020-05-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18548, '2020-05-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18549, '2020-05-30', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18550, '2020-05-31', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18551, '2020-06-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18552, '2020-06-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18553, '2020-06-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18554, '2020-06-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18555, '2020-06-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18556, '2020-06-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18557, '2020-06-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18558, '2020-06-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18559, '2020-06-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18560, '2020-06-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18561, '2020-06-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18562, '2020-06-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18563, '2020-06-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18564, '2020-06-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18565, '2020-06-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18566, '2020-06-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18567, '2020-06-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18568, '2020-06-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18569, '2020-06-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18570, '2020-06-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18571, '2020-06-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18572, '2020-06-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18573, '2020-06-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18574, '2020-06-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18575, '2020-06-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18576, '2020-06-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18577, '2020-06-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18578, '2020-06-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18579, '2020-06-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18580, '2020-06-30', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18581, '2020-07-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18582, '2020-07-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18583, '2020-07-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18584, '2020-07-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18585, '2020-07-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18586, '2020-07-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18587, '2020-07-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18588, '2020-07-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18589, '2020-07-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18590, '2020-07-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18591, '2020-07-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18592, '2020-07-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18593, '2020-07-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18594, '2020-07-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18595, '2020-07-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18596, '2020-07-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18597, '2020-07-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18598, '2020-07-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18599, '2020-07-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18600, '2020-07-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18601, '2020-07-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18602, '2020-07-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18603, '2020-07-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18604, '2020-07-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18605, '2020-07-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18606, '2020-07-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18607, '2020-07-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18608, '2020-07-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18609, '2020-07-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18610, '2020-07-30', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18611, '2020-07-31', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18612, '2020-08-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18613, '2020-08-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18614, '2020-08-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18615, '2020-08-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18616, '2020-08-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18617, '2020-08-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18618, '2020-08-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18619, '2020-08-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18620, '2020-08-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18621, '2020-08-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18622, '2020-08-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18623, '2020-08-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18624, '2020-08-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18625, '2020-08-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18626, '2020-08-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18627, '2020-08-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18628, '2020-08-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18629, '2020-08-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18630, '2020-08-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18631, '2020-08-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18632, '2020-08-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18633, '2020-08-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18634, '2020-08-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18635, '2020-08-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18636, '2020-08-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18637, '2020-08-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18638, '2020-08-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18639, '2020-08-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18640, '2020-08-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18641, '2020-08-30', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18642, '2020-08-31', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18643, '2020-09-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18644, '2020-09-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18645, '2020-09-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18646, '2020-09-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18647, '2020-09-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18648, '2020-09-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18649, '2020-09-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18650, '2020-09-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18651, '2020-09-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18652, '2020-09-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18653, '2020-09-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18654, '2020-09-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18655, '2020-09-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18656, '2020-09-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18657, '2020-09-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18658, '2020-09-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18659, '2020-09-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18660, '2020-09-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18661, '2020-09-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18662, '2020-09-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18663, '2020-09-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18664, '2020-09-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18665, '2020-09-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18666, '2020-09-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18667, '2020-09-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18668, '2020-09-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18669, '2020-09-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18670, '2020-09-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18671, '2020-09-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18672, '2020-09-30', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18673, '2020-10-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18674, '2020-10-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18675, '2020-10-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18676, '2020-10-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18677, '2020-10-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18678, '2020-10-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18679, '2020-10-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18680, '2020-10-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18681, '2020-10-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18682, '2020-10-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18683, '2020-10-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18684, '2020-10-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18685, '2020-10-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18686, '2020-10-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18687, '2020-10-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18688, '2020-10-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18689, '2020-10-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18690, '2020-10-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18691, '2020-10-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18692, '2020-10-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18693, '2020-10-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18694, '2020-10-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18695, '2020-10-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18696, '2020-10-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18697, '2020-10-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18698, '2020-10-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18699, '2020-10-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18700, '2020-10-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18701, '2020-10-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18702, '2020-10-30', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18703, '2020-10-31', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18704, '2020-11-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18705, '2020-11-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18706, '2020-11-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18707, '2020-11-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18708, '2020-11-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18709, '2020-11-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18710, '2020-11-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18711, '2020-11-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18712, '2020-11-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18713, '2020-11-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18714, '2020-11-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18715, '2020-11-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18716, '2020-11-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18717, '2020-11-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18718, '2020-11-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18719, '2020-11-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18720, '2020-11-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18721, '2020-11-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18722, '2020-11-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18723, '2020-11-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18724, '2020-11-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18725, '2020-11-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18726, '2020-11-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18727, '2020-11-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18728, '2020-11-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18729, '2020-11-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18730, '2020-11-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18731, '2020-11-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18732, '2020-11-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18733, '2020-11-30', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18734, '2020-12-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18735, '2020-12-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18736, '2020-12-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18737, '2020-12-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18738, '2020-12-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18739, '2020-12-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18740, '2020-12-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18741, '2020-12-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18742, '2020-12-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18743, '2020-12-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18744, '2020-12-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18745, '2020-12-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18746, '2020-12-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18747, '2020-12-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18748, '2020-12-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18749, '2020-12-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18750, '2020-12-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18751, '2020-12-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18752, '2020-12-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18753, '2020-12-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18754, '2020-12-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18755, '2020-12-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18756, '2020-12-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18757, '2020-12-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18758, '2020-12-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18759, '2020-12-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18760, '2020-12-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18761, '2020-12-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18762, '2020-12-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18763, '2020-12-30', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18764, '2020-12-31', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18765, '2021-01-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18766, '2021-01-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18767, '2021-01-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18768, '2021-01-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18769, '2021-01-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18770, '2021-01-06', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18771, '2021-01-07', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18772, '2021-01-08', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18773, '2021-01-09', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18774, '2021-01-10', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18775, '2021-01-11', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18776, '2021-01-12', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18777, '2021-01-13', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18778, '2021-01-14', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18779, '2021-01-15', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18780, '2021-01-16', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18781, '2021-01-17', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18782, '2021-01-18', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18783, '2021-01-19', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18784, '2021-01-20', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18785, '2021-01-21', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18786, '2021-01-22', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18787, '2021-01-23', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18788, '2021-01-24', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18789, '2021-01-25', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18790, '2021-01-26', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18791, '2021-01-27', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18792, '2021-01-28', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18793, '2021-01-29', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18794, '2021-01-30', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18795, '2021-01-31', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18796, '2021-02-01', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18797, '2021-02-02', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18798, '2021-02-03', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18799, '2021-02-04', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18800, '2021-02-05', 'CK', 'Cook Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18801, '2020-01-03', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18802, '2020-01-04', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18803, '2020-01-05', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18804, '2020-01-06', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18805, '2020-01-07', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18806, '2020-01-08', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18807, '2020-01-09', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18808, '2020-01-10', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18809, '2020-01-11', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18810, '2020-01-12', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18811, '2020-01-13', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18812, '2020-01-14', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18813, '2020-01-15', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18814, '2020-01-16', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18815, '2020-01-17', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18816, '2020-01-18', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18817, '2020-01-19', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18818, '2020-01-20', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18819, '2020-01-21', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18820, '2020-01-22', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18821, '2020-01-23', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18822, '2020-01-24', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18823, '2020-01-25', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18824, '2020-01-26', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18825, '2020-01-27', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18826, '2020-01-28', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18827, '2020-01-29', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18828, '2020-01-30', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18829, '2020-01-31', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18830, '2020-02-01', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18831, '2020-02-02', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18832, '2020-02-03', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18833, '2020-02-04', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18834, '2020-02-05', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18835, '2020-02-06', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18836, '2020-02-07', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18837, '2020-02-08', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18838, '2020-02-09', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18839, '2020-02-10', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18840, '2020-02-11', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18841, '2020-02-12', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18842, '2020-02-13', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18843, '2020-02-14', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18844, '2020-02-15', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18845, '2020-02-16', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18846, '2020-02-17', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18847, '2020-02-18', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18848, '2020-02-19', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18849, '2020-02-20', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18850, '2020-02-21', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18851, '2020-02-22', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18852, '2020-02-23', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18853, '2020-02-24', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18854, '2020-02-25', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18855, '2020-02-26', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18856, '2020-02-27', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18857, '2020-02-28', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18858, '2020-02-29', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18859, '2020-03-01', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18860, '2020-03-02', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18861, '2020-03-03', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18862, '2020-03-04', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18863, '2020-03-05', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18864, '2020-03-06', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18865, '2020-03-07', 'CR', 'Costa Rica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18866, '2020-03-08', 'CR', 'Costa Rica', 'AMRO', '9', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18867, '2020-03-09', 'CR', 'Costa Rica', 'AMRO', '4', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18868, '2020-03-10', 'CR', 'Costa Rica', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18869, '2020-03-11', 'CR', 'Costa Rica', 'AMRO', '4', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18870, '2020-03-12', 'CR', 'Costa Rica', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18871, '2020-03-13', 'CR', 'Costa Rica', 'AMRO', '10', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18872, '2020-03-14', 'CR', 'Costa Rica', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18873, '2020-03-15', 'CR', 'Costa Rica', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18874, '2020-03-16', 'CR', 'Costa Rica', 'AMRO', '12', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18875, '2020-03-17', 'CR', 'Costa Rica', 'AMRO', '6', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (18876, '2020-03-18', 'CR', 'Costa Rica', 'AMRO', '9', '54', '1', '1');
INSERT INTO public.who_global_data_import VALUES (18877, '2020-03-19', 'CR', 'Costa Rica', 'AMRO', '33', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (18878, '2020-03-20', 'CR', 'Costa Rica', 'AMRO', '26', '113', '1', '2');
INSERT INTO public.who_global_data_import VALUES (18879, '2020-03-21', 'CR', 'Costa Rica', 'AMRO', '0', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18880, '2020-03-22', 'CR', 'Costa Rica', 'AMRO', '0', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18881, '2020-03-23', 'CR', 'Costa Rica', 'AMRO', '4', '117', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18882, '2020-03-24', 'CR', 'Costa Rica', 'AMRO', '60', '177', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18883, '2020-03-25', 'CR', 'Costa Rica', 'AMRO', '0', '177', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18884, '2020-03-26', 'CR', 'Costa Rica', 'AMRO', '24', '201', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18885, '2020-03-27', 'CR', 'Costa Rica', 'AMRO', '0', '201', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18886, '2020-03-28', 'CR', 'Costa Rica', 'AMRO', '30', '231', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18887, '2020-03-29', 'CR', 'Costa Rica', 'AMRO', '32', '263', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18888, '2020-03-30', 'CR', 'Costa Rica', 'AMRO', '32', '295', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18889, '2020-03-31', 'CR', 'Costa Rica', 'AMRO', '19', '314', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18890, '2020-04-01', 'CR', 'Costa Rica', 'AMRO', '0', '314', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18891, '2020-04-02', 'CR', 'Costa Rica', 'AMRO', '33', '347', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18892, '2020-04-03', 'CR', 'Costa Rica', 'AMRO', '28', '375', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18893, '2020-04-04', 'CR', 'Costa Rica', 'AMRO', '21', '396', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18894, '2020-04-05', 'CR', 'Costa Rica', 'AMRO', '20', '416', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18895, '2020-04-06', 'CR', 'Costa Rica', 'AMRO', '19', '435', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18896, '2020-04-07', 'CR', 'Costa Rica', 'AMRO', '19', '454', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18897, '2020-04-08', 'CR', 'Costa Rica', 'AMRO', '13', '467', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18898, '2020-04-09', 'CR', 'Costa Rica', 'AMRO', '16', '483', '0', '2');
INSERT INTO public.who_global_data_import VALUES (18899, '2020-04-10', 'CR', 'Costa Rica', 'AMRO', '19', '502', '1', '3');
INSERT INTO public.who_global_data_import VALUES (18900, '2020-04-11', 'CR', 'Costa Rica', 'AMRO', '37', '539', '0', '3');
INSERT INTO public.who_global_data_import VALUES (18901, '2020-04-12', 'CR', 'Costa Rica', 'AMRO', '19', '558', '0', '3');
INSERT INTO public.who_global_data_import VALUES (18902, '2020-04-13', 'CR', 'Costa Rica', 'AMRO', '19', '577', '0', '3');
INSERT INTO public.who_global_data_import VALUES (18903, '2020-04-14', 'CR', 'Costa Rica', 'AMRO', '18', '595', '0', '3');
INSERT INTO public.who_global_data_import VALUES (18904, '2020-04-15', 'CR', 'Costa Rica', 'AMRO', '17', '612', '0', '3');
INSERT INTO public.who_global_data_import VALUES (18905, '2020-04-16', 'CR', 'Costa Rica', 'AMRO', '6', '618', '0', '3');
INSERT INTO public.who_global_data_import VALUES (18906, '2020-04-17', 'CR', 'Costa Rica', 'AMRO', '8', '626', '1', '4');
INSERT INTO public.who_global_data_import VALUES (18907, '2020-04-18', 'CR', 'Costa Rica', 'AMRO', '16', '642', '0', '4');
INSERT INTO public.who_global_data_import VALUES (18908, '2020-04-19', 'CR', 'Costa Rica', 'AMRO', '7', '649', '0', '4');
INSERT INTO public.who_global_data_import VALUES (18909, '2020-04-20', 'CR', 'Costa Rica', 'AMRO', '6', '655', '0', '4');
INSERT INTO public.who_global_data_import VALUES (18910, '2020-04-21', 'CR', 'Costa Rica', 'AMRO', '5', '660', '1', '5');
INSERT INTO public.who_global_data_import VALUES (18911, '2020-04-22', 'CR', 'Costa Rica', 'AMRO', '2', '662', '1', '6');
INSERT INTO public.who_global_data_import VALUES (18912, '2020-04-23', 'CR', 'Costa Rica', 'AMRO', '7', '669', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18913, '2020-04-24', 'CR', 'Costa Rica', 'AMRO', '12', '681', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18914, '2020-04-25', 'CR', 'Costa Rica', 'AMRO', '5', '686', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18915, '2020-04-26', 'CR', 'Costa Rica', 'AMRO', '1', '687', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18916, '2020-04-27', 'CR', 'Costa Rica', 'AMRO', '6', '693', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18917, '2020-04-28', 'CR', 'Costa Rica', 'AMRO', '2', '695', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18918, '2020-04-29', 'CR', 'Costa Rica', 'AMRO', '2', '697', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18919, '2020-04-30', 'CR', 'Costa Rica', 'AMRO', '8', '705', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18920, '2020-05-01', 'CR', 'Costa Rica', 'AMRO', '8', '713', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18921, '2020-05-02', 'CR', 'Costa Rica', 'AMRO', '6', '719', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18922, '2020-05-03', 'CR', 'Costa Rica', 'AMRO', '6', '725', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18923, '2020-05-04', 'CR', 'Costa Rica', 'AMRO', '8', '733', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18924, '2020-05-05', 'CR', 'Costa Rica', 'AMRO', '6', '739', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18925, '2020-05-06', 'CR', 'Costa Rica', 'AMRO', '3', '742', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18926, '2020-05-07', 'CR', 'Costa Rica', 'AMRO', '13', '755', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18927, '2020-05-08', 'CR', 'Costa Rica', 'AMRO', '6', '761', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18928, '2020-05-09', 'CR', 'Costa Rica', 'AMRO', '4', '765', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18929, '2020-05-10', 'CR', 'Costa Rica', 'AMRO', '8', '773', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18930, '2020-05-11', 'CR', 'Costa Rica', 'AMRO', '7', '780', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18931, '2020-05-12', 'CR', 'Costa Rica', 'AMRO', '12', '792', '0', '6');
INSERT INTO public.who_global_data_import VALUES (18932, '2020-05-13', 'CR', 'Costa Rica', 'AMRO', '9', '801', '1', '7');
INSERT INTO public.who_global_data_import VALUES (18933, '2020-05-14', 'CR', 'Costa Rica', 'AMRO', '3', '804', '0', '7');
INSERT INTO public.who_global_data_import VALUES (18934, '2020-05-15', 'CR', 'Costa Rica', 'AMRO', '11', '815', '0', '7');
INSERT INTO public.who_global_data_import VALUES (18935, '2020-05-16', 'CR', 'Costa Rica', 'AMRO', '15', '830', '1', '8');
INSERT INTO public.who_global_data_import VALUES (18936, '2020-05-17', 'CR', 'Costa Rica', 'AMRO', '13', '843', '0', '8');
INSERT INTO public.who_global_data_import VALUES (18937, '2020-05-18', 'CR', 'Costa Rica', 'AMRO', '10', '853', '2', '10');
INSERT INTO public.who_global_data_import VALUES (18938, '2020-05-19', 'CR', 'Costa Rica', 'AMRO', '10', '863', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18939, '2020-05-20', 'CR', 'Costa Rica', 'AMRO', '19', '882', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18940, '2020-05-21', 'CR', 'Costa Rica', 'AMRO', '0', '882', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18941, '2020-05-22', 'CR', 'Costa Rica', 'AMRO', '0', '882', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18942, '2020-05-23', 'CR', 'Costa Rica', 'AMRO', '21', '903', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18943, '2020-05-24', 'CR', 'Costa Rica', 'AMRO', '8', '911', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18944, '2020-05-25', 'CR', 'Costa Rica', 'AMRO', '7', '918', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18945, '2020-05-26', 'CR', 'Costa Rica', 'AMRO', '12', '930', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18946, '2020-05-27', 'CR', 'Costa Rica', 'AMRO', '21', '951', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18947, '2020-05-28', 'CR', 'Costa Rica', 'AMRO', '5', '956', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18948, '2020-05-29', 'CR', 'Costa Rica', 'AMRO', '28', '984', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18949, '2020-05-30', 'CR', 'Costa Rica', 'AMRO', '16', '1000', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18950, '2020-05-31', 'CR', 'Costa Rica', 'AMRO', '22', '1022', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18951, '2020-06-01', 'CR', 'Costa Rica', 'AMRO', '25', '1047', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18952, '2020-06-02', 'CR', 'Costa Rica', 'AMRO', '9', '1056', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18953, '2020-06-03', 'CR', 'Costa Rica', 'AMRO', '28', '1084', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18954, '2020-06-04', 'CR', 'Costa Rica', 'AMRO', '21', '1105', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18955, '2020-06-05', 'CR', 'Costa Rica', 'AMRO', '52', '1157', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18956, '2020-06-06', 'CR', 'Costa Rica', 'AMRO', '37', '1194', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18957, '2020-06-07', 'CR', 'Costa Rica', 'AMRO', '69', '1263', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18958, '2020-06-08', 'CR', 'Costa Rica', 'AMRO', '0', '1263', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18959, '2020-06-09', 'CR', 'Costa Rica', 'AMRO', '55', '1318', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18960, '2020-06-10', 'CR', 'Costa Rica', 'AMRO', '24', '1342', '0', '10');
INSERT INTO public.who_global_data_import VALUES (18961, '2020-06-11', 'CR', 'Costa Rica', 'AMRO', '33', '1375', '1', '11');
INSERT INTO public.who_global_data_import VALUES (18962, '2020-06-12', 'CR', 'Costa Rica', 'AMRO', '86', '1461', '1', '12');
INSERT INTO public.who_global_data_import VALUES (18963, '2020-06-13', 'CR', 'Costa Rica', 'AMRO', '77', '1538', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18964, '2020-06-14', 'CR', 'Costa Rica', 'AMRO', '74', '1612', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18965, '2020-06-15', 'CR', 'Costa Rica', 'AMRO', '50', '1662', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18966, '2020-06-16', 'CR', 'Costa Rica', 'AMRO', '53', '1715', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18967, '2020-06-17', 'CR', 'Costa Rica', 'AMRO', '29', '1744', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18968, '2020-06-18', 'CR', 'Costa Rica', 'AMRO', '52', '1796', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18969, '2020-06-19', 'CR', 'Costa Rica', 'AMRO', '75', '1871', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18970, '2020-06-20', 'CR', 'Costa Rica', 'AMRO', '68', '1939', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18971, '2020-06-21', 'CR', 'Costa Rica', 'AMRO', '119', '2058', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18972, '2020-06-22', 'CR', 'Costa Rica', 'AMRO', '69', '2127', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18973, '2020-06-23', 'CR', 'Costa Rica', 'AMRO', '86', '2213', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18974, '2020-06-24', 'CR', 'Costa Rica', 'AMRO', '64', '2277', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18975, '2020-06-25', 'CR', 'Costa Rica', 'AMRO', '91', '2368', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18976, '2020-06-26', 'CR', 'Costa Rica', 'AMRO', '147', '2515', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18977, '2020-06-27', 'CR', 'Costa Rica', 'AMRO', '169', '2684', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18978, '2020-06-28', 'CR', 'Costa Rica', 'AMRO', '152', '2836', '0', '12');
INSERT INTO public.who_global_data_import VALUES (18979, '2020-06-29', 'CR', 'Costa Rica', 'AMRO', '143', '2979', '1', '13');
INSERT INTO public.who_global_data_import VALUES (18980, '2020-06-30', 'CR', 'Costa Rica', 'AMRO', '151', '3130', '2', '15');
INSERT INTO public.who_global_data_import VALUES (18981, '2020-07-01', 'CR', 'Costa Rica', 'AMRO', '139', '3269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (18982, '2020-07-02', 'CR', 'Costa Rica', 'AMRO', '190', '3459', '1', '16');
INSERT INTO public.who_global_data_import VALUES (18983, '2020-07-03', 'CR', 'Costa Rica', 'AMRO', '294', '3753', '0', '16');
INSERT INTO public.who_global_data_import VALUES (18984, '2020-07-04', 'CR', 'Costa Rica', 'AMRO', '270', '4023', '2', '18');
INSERT INTO public.who_global_data_import VALUES (18985, '2020-07-05', 'CR', 'Costa Rica', 'AMRO', '288', '4311', '0', '18');
INSERT INTO public.who_global_data_import VALUES (18986, '2020-07-06', 'CR', 'Costa Rica', 'AMRO', '310', '4621', '0', '18');
INSERT INTO public.who_global_data_import VALUES (18987, '2020-07-07', 'CR', 'Costa Rica', 'AMRO', '375', '4996', '1', '19');
INSERT INTO public.who_global_data_import VALUES (18988, '2020-07-08', 'CR', 'Costa Rica', 'AMRO', '245', '5241', '4', '23');
INSERT INTO public.who_global_data_import VALUES (18989, '2020-07-09', 'CR', 'Costa Rica', 'AMRO', '245', '5486', '0', '23');
INSERT INTO public.who_global_data_import VALUES (18990, '2020-07-10', 'CR', 'Costa Rica', 'AMRO', '350', '5836', '1', '24');
INSERT INTO public.who_global_data_import VALUES (18991, '2020-07-11', 'CR', 'Costa Rica', 'AMRO', '649', '6485', '2', '26');
INSERT INTO public.who_global_data_import VALUES (18992, '2020-07-12', 'CR', 'Costa Rica', 'AMRO', '360', '6845', '1', '27');
INSERT INTO public.who_global_data_import VALUES (18993, '2020-07-13', 'CR', 'Costa Rica', 'AMRO', '386', '7231', '1', '28');
INSERT INTO public.who_global_data_import VALUES (18994, '2020-07-14', 'CR', 'Costa Rica', 'AMRO', '365', '7596', '2', '30');
INSERT INTO public.who_global_data_import VALUES (18995, '2020-07-15', 'CR', 'Costa Rica', 'AMRO', '440', '8036', '1', '31');
INSERT INTO public.who_global_data_import VALUES (18996, '2020-07-16', 'CR', 'Costa Rica', 'AMRO', '446', '8482', '5', '36');
INSERT INTO public.who_global_data_import VALUES (18997, '2020-07-17', 'CR', 'Costa Rica', 'AMRO', '504', '8986', '4', '40');
INSERT INTO public.who_global_data_import VALUES (18998, '2020-07-18', 'CR', 'Costa Rica', 'AMRO', '560', '9546', '2', '42');
INSERT INTO public.who_global_data_import VALUES (18999, '2020-07-19', 'CR', 'Costa Rica', 'AMRO', '423', '9969', '5', '47');
INSERT INTO public.who_global_data_import VALUES (19000, '2020-07-20', 'CR', 'Costa Rica', 'AMRO', '582', '10551', '7', '54');
INSERT INTO public.who_global_data_import VALUES (19001, '2020-07-21', 'CR', 'Costa Rica', 'AMRO', '563', '11114', '8', '62');
INSERT INTO public.who_global_data_import VALUES (19002, '2020-07-22', 'CR', 'Costa Rica', 'AMRO', '420', '11534', '4', '66');
INSERT INTO public.who_global_data_import VALUES (19003, '2020-07-23', 'CR', 'Costa Rica', 'AMRO', '277', '11811', '2', '68');
INSERT INTO public.who_global_data_import VALUES (19004, '2020-07-24', 'CR', 'Costa Rica', 'AMRO', '550', '12361', '3', '71');
INSERT INTO public.who_global_data_import VALUES (19005, '2020-07-25', 'CR', 'Costa Rica', 'AMRO', '768', '13129', '9', '80');
INSERT INTO public.who_global_data_import VALUES (19006, '2020-07-26', 'CR', 'Costa Rica', 'AMRO', '540', '13669', '7', '87');
INSERT INTO public.who_global_data_import VALUES (19007, '2020-07-27', 'CR', 'Costa Rica', 'AMRO', '931', '14600', '11', '98');
INSERT INTO public.who_global_data_import VALUES (19008, '2020-07-28', 'CR', 'Costa Rica', 'AMRO', '629', '15229', '6', '104');
INSERT INTO public.who_global_data_import VALUES (19009, '2020-07-29', 'CR', 'Costa Rica', 'AMRO', '612', '15841', '11', '115');
INSERT INTO public.who_global_data_import VALUES (19010, '2020-07-30', 'CR', 'Costa Rica', 'AMRO', '503', '16344', '10', '125');
INSERT INTO public.who_global_data_import VALUES (19011, '2020-07-31', 'CR', 'Costa Rica', 'AMRO', '456', '16800', '8', '133');
INSERT INTO public.who_global_data_import VALUES (19012, '2020-08-01', 'CR', 'Costa Rica', 'AMRO', '490', '17290', '7', '140');
INSERT INTO public.who_global_data_import VALUES (19013, '2020-08-02', 'CR', 'Costa Rica', 'AMRO', '530', '17820', '10', '150');
INSERT INTO public.who_global_data_import VALUES (19014, '2020-08-03', 'CR', 'Costa Rica', 'AMRO', '367', '18187', '4', '154');
INSERT INTO public.who_global_data_import VALUES (19015, '2020-08-04', 'CR', 'Costa Rica', 'AMRO', '788', '18975', '8', '162');
INSERT INTO public.who_global_data_import VALUES (19016, '2020-08-05', 'CR', 'Costa Rica', 'AMRO', '427', '19402', '9', '171');
INSERT INTO public.who_global_data_import VALUES (19017, '2020-08-06', 'CR', 'Costa Rica', 'AMRO', '435', '19837', '10', '181');
INSERT INTO public.who_global_data_import VALUES (19018, '2020-08-07', 'CR', 'Costa Rica', 'AMRO', '580', '20417', '10', '191');
INSERT INTO public.who_global_data_import VALUES (19019, '2020-08-08', 'CR', 'Costa Rica', 'AMRO', '653', '21070', '9', '200');
INSERT INTO public.who_global_data_import VALUES (19020, '2020-08-09', 'CR', 'Costa Rica', 'AMRO', '1011', '22081', '18', '218');
INSERT INTO public.who_global_data_import VALUES (19021, '2020-08-10', 'CR', 'Costa Rica', 'AMRO', '721', '22802', '10', '228');
INSERT INTO public.who_global_data_import VALUES (19022, '2020-08-11', 'CR', 'Costa Rica', 'AMRO', '484', '23286', '7', '235');
INSERT INTO public.who_global_data_import VALUES (19023, '2020-08-12', 'CR', 'Costa Rica', 'AMRO', '586', '23872', '9', '244');
INSERT INTO public.who_global_data_import VALUES (19024, '2020-08-13', 'CR', 'Costa Rica', 'AMRO', '636', '24508', '11', '255');
INSERT INTO public.who_global_data_import VALUES (19025, '2020-08-14', 'CR', 'Costa Rica', 'AMRO', '549', '25057', '8', '263');
INSERT INTO public.who_global_data_import VALUES (19026, '2020-08-15', 'CR', 'Costa Rica', 'AMRO', '1072', '26129', '9', '272');
INSERT INTO public.who_global_data_import VALUES (19027, '2020-08-16', 'CR', 'Costa Rica', 'AMRO', '802', '26931', '9', '281');
INSERT INTO public.who_global_data_import VALUES (19028, '2020-08-17', 'CR', 'Costa Rica', 'AMRO', '806', '27737', '10', '291');
INSERT INTO public.who_global_data_import VALUES (19029, '2020-08-18', 'CR', 'Costa Rica', 'AMRO', '728', '28465', '3', '294');
INSERT INTO public.who_global_data_import VALUES (19030, '2020-08-19', 'CR', 'Costa Rica', 'AMRO', '619', '29084', '10', '304');
INSERT INTO public.who_global_data_import VALUES (19031, '2020-08-20', 'CR', 'Costa Rica', 'AMRO', '559', '29643', '10', '314');
INSERT INTO public.who_global_data_import VALUES (19032, '2020-08-21', 'CR', 'Costa Rica', 'AMRO', '766', '30409', '7', '321');
INSERT INTO public.who_global_data_import VALUES (19033, '2020-08-22', 'CR', 'Costa Rica', 'AMRO', '666', '31075', '12', '333');
INSERT INTO public.who_global_data_import VALUES (19034, '2020-08-23', 'CR', 'Costa Rica', 'AMRO', '1059', '32134', '7', '340');
INSERT INTO public.who_global_data_import VALUES (19035, '2020-08-24', 'CR', 'Costa Rica', 'AMRO', '950', '33084', '8', '348');
INSERT INTO public.who_global_data_import VALUES (19036, '2020-08-25', 'CR', 'Costa Rica', 'AMRO', '736', '33820', '7', '355');
INSERT INTO public.who_global_data_import VALUES (19037, '2020-08-26', 'CR', 'Costa Rica', 'AMRO', '643', '34463', '7', '362');
INSERT INTO public.who_global_data_import VALUES (19038, '2020-08-27', 'CR', 'Costa Rica', 'AMRO', '842', '35305', '14', '376');
INSERT INTO public.who_global_data_import VALUES (19039, '2020-08-28', 'CR', 'Costa Rica', 'AMRO', '1002', '36307', '10', '386');
INSERT INTO public.who_global_data_import VALUES (19040, '2020-08-29', 'CR', 'Costa Rica', 'AMRO', '985', '37292', '11', '397');
INSERT INTO public.who_global_data_import VALUES (19041, '2020-08-30', 'CR', 'Costa Rica', 'AMRO', '1193', '38485', '10', '407');
INSERT INTO public.who_global_data_import VALUES (19042, '2020-08-31', 'CR', 'Costa Rica', 'AMRO', '1214', '39699', '11', '418');
INSERT INTO public.who_global_data_import VALUES (19043, '2020-09-01', 'CR', 'Costa Rica', 'AMRO', '0', '39699', '0', '418');
INSERT INTO public.who_global_data_import VALUES (19044, '2020-09-02', 'CR', 'Costa Rica', 'AMRO', '1588', '41287', '18', '436');
INSERT INTO public.who_global_data_import VALUES (19045, '2020-09-03', 'CR', 'Costa Rica', 'AMRO', '897', '42184', '7', '443');
INSERT INTO public.who_global_data_import VALUES (19046, '2020-09-04', 'CR', 'Costa Rica', 'AMRO', '1121', '43305', '10', '453');
INSERT INTO public.who_global_data_import VALUES (19047, '2020-09-05', 'CR', 'Costa Rica', 'AMRO', '1153', '44458', '7', '460');
INSERT INTO public.who_global_data_import VALUES (19048, '2020-09-06', 'CR', 'Costa Rica', 'AMRO', '1222', '45680', '9', '469');
INSERT INTO public.who_global_data_import VALUES (19049, '2020-09-07', 'CR', 'Costa Rica', 'AMRO', '1240', '46920', '9', '478');
INSERT INTO public.who_global_data_import VALUES (19050, '2020-09-08', 'CR', 'Costa Rica', 'AMRO', '1027', '47947', '13', '491');
INSERT INTO public.who_global_data_import VALUES (19051, '2020-09-09', 'CR', 'Costa Rica', 'AMRO', '833', '48780', '19', '510');
INSERT INTO public.who_global_data_import VALUES (19052, '2020-09-10', 'CR', 'Costa Rica', 'AMRO', '1117', '49897', '21', '531');
INSERT INTO public.who_global_data_import VALUES (19053, '2020-09-11', 'CR', 'Costa Rica', 'AMRO', '1327', '51224', '12', '543');
INSERT INTO public.who_global_data_import VALUES (19054, '2020-09-12', 'CR', 'Costa Rica', 'AMRO', '1325', '52549', '24', '567');
INSERT INTO public.who_global_data_import VALUES (19055, '2020-09-13', 'CR', 'Costa Rica', 'AMRO', '1420', '53969', '16', '583');
INSERT INTO public.who_global_data_import VALUES (19056, '2020-09-14', 'CR', 'Costa Rica', 'AMRO', '1485', '55454', '7', '590');
INSERT INTO public.who_global_data_import VALUES (19057, '2020-09-15', 'CR', 'Costa Rica', 'AMRO', '970', '56424', '15', '605');
INSERT INTO public.who_global_data_import VALUES (19058, '2020-09-16', 'CR', 'Costa Rica', 'AMRO', '937', '57361', '16', '621');
INSERT INTO public.who_global_data_import VALUES (19059, '2020-09-17', 'CR', 'Costa Rica', 'AMRO', '777', '58138', '12', '633');
INSERT INTO public.who_global_data_import VALUES (19060, '2020-09-18', 'CR', 'Costa Rica', 'AMRO', '1378', '59516', '16', '649');
INSERT INTO public.who_global_data_import VALUES (19061, '2020-09-19', 'CR', 'Costa Rica', 'AMRO', '1302', '60818', '17', '666');
INSERT INTO public.who_global_data_import VALUES (19062, '2020-09-20', 'CR', 'Costa Rica', 'AMRO', '1556', '62374', '20', '686');
INSERT INTO public.who_global_data_import VALUES (19063, '2020-09-21', 'CR', 'Costa Rica', 'AMRO', '1338', '63712', '20', '706');
INSERT INTO public.who_global_data_import VALUES (19064, '2020-09-22', 'CR', 'Costa Rica', 'AMRO', '1187', '64899', '21', '727');
INSERT INTO public.who_global_data_import VALUES (19065, '2020-09-23', 'CR', 'Costa Rica', 'AMRO', '703', '65602', '18', '745');
INSERT INTO public.who_global_data_import VALUES (19066, '2020-09-24', 'CR', 'Costa Rica', 'AMRO', '1087', '66689', '15', '760');
INSERT INTO public.who_global_data_import VALUES (19067, '2020-09-25', 'CR', 'Costa Rica', 'AMRO', '1370', '68059', '21', '781');
INSERT INTO public.who_global_data_import VALUES (19068, '2020-09-26', 'CR', 'Costa Rica', 'AMRO', '1400', '69459', '14', '795');
INSERT INTO public.who_global_data_import VALUES (19069, '2020-09-27', 'CR', 'Costa Rica', 'AMRO', '1357', '70816', '17', '812');
INSERT INTO public.who_global_data_import VALUES (19070, '2020-09-28', 'CR', 'Costa Rica', 'AMRO', '1233', '72049', '16', '828');
INSERT INTO public.who_global_data_import VALUES (19071, '2020-09-29', 'CR', 'Costa Rica', 'AMRO', '935', '72984', '19', '847');
INSERT INTO public.who_global_data_import VALUES (19072, '2020-09-30', 'CR', 'Costa Rica', 'AMRO', '730', '73714', '14', '861');
INSERT INTO public.who_global_data_import VALUES (19073, '2020-10-01', 'CR', 'Costa Rica', 'AMRO', '890', '74604', '19', '880');
INSERT INTO public.who_global_data_import VALUES (19074, '2020-10-02', 'CR', 'Costa Rica', 'AMRO', '1156', '75760', '24', '904');
INSERT INTO public.who_global_data_import VALUES (19075, '2020-10-03', 'CR', 'Costa Rica', 'AMRO', '1068', '76828', '13', '917');
INSERT INTO public.who_global_data_import VALUES (19076, '2020-10-04', 'CR', 'Costa Rica', 'AMRO', '1001', '77829', '13', '930');
INSERT INTO public.who_global_data_import VALUES (19077, '2020-10-05', 'CR', 'Costa Rica', 'AMRO', '1353', '79182', '20', '950');
INSERT INTO public.who_global_data_import VALUES (19078, '2020-10-06', 'CR', 'Costa Rica', 'AMRO', '1225', '80407', '21', '971');
INSERT INTO public.who_global_data_import VALUES (19079, '2020-10-07', 'CR', 'Costa Rica', 'AMRO', '722', '81129', '16', '987');
INSERT INTO public.who_global_data_import VALUES (19080, '2020-10-08', 'CR', 'Costa Rica', 'AMRO', '1013', '82142', '17', '1004');
INSERT INTO public.who_global_data_import VALUES (19081, '2020-10-09', 'CR', 'Costa Rica', 'AMRO', '1355', '83497', '20', '1024');
INSERT INTO public.who_global_data_import VALUES (19082, '2020-10-10', 'CR', 'Costa Rica', 'AMRO', '1331', '84828', '16', '1040');
INSERT INTO public.who_global_data_import VALUES (19083, '2020-10-11', 'CR', 'Costa Rica', 'AMRO', '1225', '86053', '15', '1055');
INSERT INTO public.who_global_data_import VALUES (19084, '2020-10-12', 'CR', 'Costa Rica', 'AMRO', '1386', '87439', '21', '1076');
INSERT INTO public.who_global_data_import VALUES (19085, '2020-10-13', 'CR', 'Costa Rica', 'AMRO', '1051', '88490', '14', '1090');
INSERT INTO public.who_global_data_import VALUES (19086, '2020-10-14', 'CR', 'Costa Rica', 'AMRO', '733', '89223', '18', '1108');
INSERT INTO public.who_global_data_import VALUES (19087, '2020-10-15', 'CR', 'Costa Rica', 'AMRO', '1015', '90238', '16', '1124');
INSERT INTO public.who_global_data_import VALUES (19088, '2020-10-16', 'CR', 'Costa Rica', 'AMRO', '1542', '91780', '10', '1134');
INSERT INTO public.who_global_data_import VALUES (19089, '2020-10-17', 'CR', 'Costa Rica', 'AMRO', '1372', '93152', '25', '1159');
INSERT INTO public.who_global_data_import VALUES (19090, '2020-10-18', 'CR', 'Costa Rica', 'AMRO', '1196', '94348', '9', '1168');
INSERT INTO public.who_global_data_import VALUES (19091, '2020-10-19', 'CR', 'Costa Rica', 'AMRO', '1166', '95514', '15', '1183');
INSERT INTO public.who_global_data_import VALUES (19092, '2020-10-20', 'CR', 'Costa Rica', 'AMRO', '929', '96443', '11', '1194');
INSERT INTO public.who_global_data_import VALUES (19093, '2020-10-21', 'CR', 'Costa Rica', 'AMRO', '632', '97075', '10', '1204');
INSERT INTO public.who_global_data_import VALUES (19094, '2020-10-22', 'CR', 'Costa Rica', 'AMRO', '847', '97922', '18', '1222');
INSERT INTO public.who_global_data_import VALUES (19095, '2020-10-23', 'CR', 'Costa Rica', 'AMRO', '1503', '99425', '14', '1236');
INSERT INTO public.who_global_data_import VALUES (19096, '2020-10-24', 'CR', 'Costa Rica', 'AMRO', '1191', '100616', '15', '1251');
INSERT INTO public.who_global_data_import VALUES (19097, '2020-10-25', 'CR', 'Costa Rica', 'AMRO', '1210', '101826', '14', '1265');
INSERT INTO public.who_global_data_import VALUES (19098, '2020-10-26', 'CR', 'Costa Rica', 'AMRO', '1262', '103088', '17', '1282');
INSERT INTO public.who_global_data_import VALUES (19099, '2020-10-27', 'CR', 'Costa Rica', 'AMRO', '861', '103949', '16', '1298');
INSERT INTO public.who_global_data_import VALUES (19100, '2020-10-28', 'CR', 'Costa Rica', 'AMRO', '511', '104460', '14', '1312');
INSERT INTO public.who_global_data_import VALUES (19101, '2020-10-29', 'CR', 'Costa Rica', 'AMRO', '862', '105322', '17', '1329');
INSERT INTO public.who_global_data_import VALUES (19102, '2020-10-30', 'CR', 'Costa Rica', 'AMRO', '1231', '106553', '11', '1340');
INSERT INTO public.who_global_data_import VALUES (19103, '2020-10-31', 'CR', 'Costa Rica', 'AMRO', '1017', '107570', '17', '1357');
INSERT INTO public.who_global_data_import VALUES (19104, '2020-11-01', 'CR', 'Costa Rica', 'AMRO', '1296', '108866', '14', '1371');
INSERT INTO public.who_global_data_import VALUES (19105, '2020-11-02', 'CR', 'Costa Rica', 'AMRO', '1105', '109971', '14', '1385');
INSERT INTO public.who_global_data_import VALUES (19106, '2020-11-03', 'CR', 'Costa Rica', 'AMRO', '746', '110717', '11', '1396');
INSERT INTO public.who_global_data_import VALUES (19107, '2020-11-04', 'CR', 'Costa Rica', 'AMRO', '540', '111257', '8', '1404');
INSERT INTO public.who_global_data_import VALUES (19108, '2020-11-05', 'CR', 'Costa Rica', 'AMRO', '863', '112120', '15', '1419');
INSERT INTO public.who_global_data_import VALUES (19109, '2020-11-06', 'CR', 'Costa Rica', 'AMRO', '1141', '113261', '12', '1431');
INSERT INTO public.who_global_data_import VALUES (19110, '2020-11-07', 'CR', 'Costa Rica', 'AMRO', '1106', '114367', '13', '1444');
INSERT INTO public.who_global_data_import VALUES (19111, '2020-11-08', 'CR', 'Costa Rica', 'AMRO', '1050', '115417', '9', '1453');
INSERT INTO public.who_global_data_import VALUES (19112, '2020-11-09', 'CR', 'Costa Rica', 'AMRO', '946', '116363', '11', '1464');
INSERT INTO public.who_global_data_import VALUES (19113, '2020-11-10', 'CR', 'Costa Rica', 'AMRO', '736', '117099', '12', '1476');
INSERT INTO public.who_global_data_import VALUES (19114, '2020-11-11', 'CR', 'Costa Rica', 'AMRO', '488', '117587', '15', '1491');
INSERT INTO public.who_global_data_import VALUES (19115, '2020-11-12', 'CR', 'Costa Rica', 'AMRO', '979', '118566', '11', '1502');
INSERT INTO public.who_global_data_import VALUES (19116, '2020-11-13', 'CR', 'Costa Rica', 'AMRO', '1202', '119768', '11', '1513');
INSERT INTO public.who_global_data_import VALUES (19117, '2020-11-14', 'CR', 'Costa Rica', 'AMRO', '1171', '120939', '14', '1527');
INSERT INTO public.who_global_data_import VALUES (19118, '2020-11-15', 'CR', 'Costa Rica', 'AMRO', '1184', '122123', '10', '1537');
INSERT INTO public.who_global_data_import VALUES (19119, '2020-11-16', 'CR', 'Costa Rica', 'AMRO', '1100', '123223', '9', '1546');
INSERT INTO public.who_global_data_import VALUES (19120, '2020-11-17', 'CR', 'Costa Rica', 'AMRO', '726', '123949', '9', '1555');
INSERT INTO public.who_global_data_import VALUES (19121, '2020-11-18', 'CR', 'Costa Rica', 'AMRO', '643', '124592', '11', '1566');
INSERT INTO public.who_global_data_import VALUES (19122, '2020-11-19', 'CR', 'Costa Rica', 'AMRO', '998', '125590', '12', '1578');
INSERT INTO public.who_global_data_import VALUES (19123, '2020-11-20', 'CR', 'Costa Rica', 'AMRO', '1422', '127012', '10', '1588');
INSERT INTO public.who_global_data_import VALUES (19124, '2020-11-21', 'CR', 'Costa Rica', 'AMRO', '1219', '128231', '11', '1599');
INSERT INTO public.who_global_data_import VALUES (19125, '2020-11-22', 'CR', 'Costa Rica', 'AMRO', '1187', '129418', '9', '1608');
INSERT INTO public.who_global_data_import VALUES (19126, '2020-11-23', 'CR', 'Costa Rica', 'AMRO', '0', '129418', '0', '1608');
INSERT INTO public.who_global_data_import VALUES (19127, '2020-11-24', 'CR', 'Costa Rica', 'AMRO', '0', '129418', '0', '1608');
INSERT INTO public.who_global_data_import VALUES (19128, '2020-11-25', 'CR', 'Costa Rica', 'AMRO', '2877', '132295', '33', '1641');
INSERT INTO public.who_global_data_import VALUES (19129, '2020-11-26', 'CR', 'Costa Rica', 'AMRO', '895', '133190', '21', '1662');
INSERT INTO public.who_global_data_import VALUES (19130, '2020-11-27', 'CR', 'Costa Rica', 'AMRO', '1330', '134520', '12', '1674');
INSERT INTO public.who_global_data_import VALUES (19131, '2020-11-28', 'CR', 'Costa Rica', 'AMRO', '1222', '135742', '5', '1679');
INSERT INTO public.who_global_data_import VALUES (19132, '2020-11-29', 'CR', 'Costa Rica', 'AMRO', '1351', '137093', '11', '1690');
INSERT INTO public.who_global_data_import VALUES (19133, '2020-11-30', 'CR', 'Costa Rica', 'AMRO', '0', '137093', '0', '1690');
INSERT INTO public.who_global_data_import VALUES (19134, '2020-12-01', 'CR', 'Costa Rica', 'AMRO', '2006', '139099', '25', '1715');
INSERT INTO public.who_global_data_import VALUES (19135, '2020-12-02', 'CR', 'Costa Rica', 'AMRO', '539', '139638', '11', '1726');
INSERT INTO public.who_global_data_import VALUES (19136, '2020-12-03', 'CR', 'Costa Rica', 'AMRO', '534', '140172', '5', '1731');
INSERT INTO public.who_global_data_import VALUES (19137, '2020-12-04', 'CR', 'Costa Rica', 'AMRO', '1168', '141340', '8', '1739');
INSERT INTO public.who_global_data_import VALUES (19138, '2020-12-05', 'CR', 'Costa Rica', 'AMRO', '1165', '142505', '18', '1757');
INSERT INTO public.who_global_data_import VALUES (19139, '2020-12-06', 'CR', 'Costa Rica', 'AMRO', '1180', '143685', '16', '1773');
INSERT INTO public.who_global_data_import VALUES (19140, '2020-12-07', 'CR', 'Costa Rica', 'AMRO', '0', '143685', '0', '1773');
INSERT INTO public.who_global_data_import VALUES (19141, '2020-12-08', 'CR', 'Costa Rica', 'AMRO', '2160', '145845', '37', '1810');
INSERT INTO public.who_global_data_import VALUES (19142, '2020-12-09', 'CR', 'Costa Rica', 'AMRO', '576', '146421', '15', '1825');
INSERT INTO public.who_global_data_import VALUES (19143, '2020-12-10', 'CR', 'Costa Rica', 'AMRO', '1009', '147430', '21', '1846');
INSERT INTO public.who_global_data_import VALUES (19144, '2020-12-11', 'CR', 'Costa Rica', 'AMRO', '1258', '148688', '18', '1864');
INSERT INTO public.who_global_data_import VALUES (19145, '2020-12-12', 'CR', 'Costa Rica', 'AMRO', '1127', '149815', '18', '1882');
INSERT INTO public.who_global_data_import VALUES (19146, '2020-12-13', 'CR', 'Costa Rica', 'AMRO', '1132', '150947', '13', '1895');
INSERT INTO public.who_global_data_import VALUES (19147, '2020-12-14', 'CR', 'Costa Rica', 'AMRO', '1149', '152096', '18', '1913');
INSERT INTO public.who_global_data_import VALUES (19148, '2020-12-15', 'CR', 'Costa Rica', 'AMRO', '524', '152620', '8', '1921');
INSERT INTO public.who_global_data_import VALUES (19149, '2020-12-16', 'CR', 'Costa Rica', 'AMRO', '549', '153169', '15', '1936');
INSERT INTO public.who_global_data_import VALUES (19150, '2020-12-17', 'CR', 'Costa Rica', 'AMRO', '927', '154096', '20', '1956');
INSERT INTO public.who_global_data_import VALUES (19151, '2020-12-18', 'CR', 'Costa Rica', 'AMRO', '1167', '155263', '11', '1967');
INSERT INTO public.who_global_data_import VALUES (19152, '2020-12-19', 'CR', 'Costa Rica', 'AMRO', '1125', '156388', '13', '1980');
INSERT INTO public.who_global_data_import VALUES (19153, '2020-12-20', 'CR', 'Costa Rica', 'AMRO', '1084', '157472', '16', '1996');
INSERT INTO public.who_global_data_import VALUES (19154, '2020-12-21', 'CR', 'Costa Rica', 'AMRO', '1019', '158491', '15', '2011');
INSERT INTO public.who_global_data_import VALUES (19155, '2020-12-22', 'CR', 'Costa Rica', 'AMRO', '767', '159258', '12', '2023');
INSERT INTO public.who_global_data_import VALUES (19156, '2020-12-23', 'CR', 'Costa Rica', 'AMRO', '635', '159893', '14', '2037');
INSERT INTO public.who_global_data_import VALUES (19157, '2020-12-24', 'CR', 'Costa Rica', 'AMRO', '911', '160804', '14', '2051');
INSERT INTO public.who_global_data_import VALUES (19158, '2020-12-25', 'CR', 'Costa Rica', 'AMRO', '1138', '161942', '14', '2065');
INSERT INTO public.who_global_data_import VALUES (19159, '2020-12-26', 'CR', 'Costa Rica', 'AMRO', '1048', '162990', '21', '2086');
INSERT INTO public.who_global_data_import VALUES (19160, '2020-12-27', 'CR', 'Costa Rica', 'AMRO', '1072', '164062', '17', '2103');
INSERT INTO public.who_global_data_import VALUES (19161, '2020-12-28', 'CR', 'Costa Rica', 'AMRO', '545', '164607', '14', '2117');
INSERT INTO public.who_global_data_import VALUES (19162, '2020-12-29', 'CR', 'Costa Rica', 'AMRO', '597', '165204', '17', '2134');
INSERT INTO public.who_global_data_import VALUES (19163, '2020-12-30', 'CR', 'Costa Rica', 'AMRO', '558', '165762', '10', '2144');
INSERT INTO public.who_global_data_import VALUES (19164, '2020-12-31', 'CR', 'Costa Rica', 'AMRO', '1037', '166799', '12', '2156');
INSERT INTO public.who_global_data_import VALUES (19165, '2021-01-01', 'CR', 'Costa Rica', 'AMRO', '1315', '168114', '15', '2171');
INSERT INTO public.who_global_data_import VALUES (19166, '2021-01-02', 'CR', 'Costa Rica', 'AMRO', '1207', '169321', '14', '2185');
INSERT INTO public.who_global_data_import VALUES (19167, '2021-01-03', 'CR', 'Costa Rica', 'AMRO', '1270', '170591', '8', '2193');
INSERT INTO public.who_global_data_import VALUES (19168, '2021-01-04', 'CR', 'Costa Rica', 'AMRO', '539', '171130', '12', '2205');
INSERT INTO public.who_global_data_import VALUES (19169, '2021-01-05', 'CR', 'Costa Rica', 'AMRO', '589', '171719', '13', '2218');
INSERT INTO public.who_global_data_import VALUES (19170, '2021-01-06', 'CR', 'Costa Rica', 'AMRO', '717', '172436', '11', '2229');
INSERT INTO public.who_global_data_import VALUES (19171, '2021-01-07', 'CR', 'Costa Rica', 'AMRO', '1155', '173591', '19', '2248');
INSERT INTO public.who_global_data_import VALUES (19172, '2021-01-08', 'CR', 'Costa Rica', 'AMRO', '1447', '175038', '19', '2267');
INSERT INTO public.who_global_data_import VALUES (19173, '2021-01-09', 'CR', 'Costa Rica', 'AMRO', '1369', '176407', '19', '2286');
INSERT INTO public.who_global_data_import VALUES (19174, '2021-01-10', 'CR', 'Costa Rica', 'AMRO', '1207', '177614', '19', '2305');
INSERT INTO public.who_global_data_import VALUES (19175, '2021-01-11', 'CR', 'Costa Rica', 'AMRO', '1035', '178649', '17', '2322');
INSERT INTO public.who_global_data_import VALUES (19176, '2021-01-12', 'CR', 'Costa Rica', 'AMRO', '756', '179405', '16', '2338');
INSERT INTO public.who_global_data_import VALUES (19177, '2021-01-13', 'CR', 'Costa Rica', 'AMRO', '656', '180061', '15', '2353');
INSERT INTO public.who_global_data_import VALUES (19178, '2021-01-14', 'CR', 'Costa Rica', 'AMRO', '1032', '181093', '14', '2367');
INSERT INTO public.who_global_data_import VALUES (19179, '2021-01-15', 'CR', 'Costa Rica', 'AMRO', '1063', '182156', '17', '2384');
INSERT INTO public.who_global_data_import VALUES (19180, '2021-01-16', 'CR', 'Costa Rica', 'AMRO', '1086', '183242', '17', '2401');
INSERT INTO public.who_global_data_import VALUES (19181, '2021-01-17', 'CR', 'Costa Rica', 'AMRO', '945', '184187', '15', '2416');
INSERT INTO public.who_global_data_import VALUES (19182, '2021-01-18', 'CR', 'Costa Rica', 'AMRO', '958', '185145', '27', '2443');
INSERT INTO public.who_global_data_import VALUES (19183, '2021-01-19', 'CR', 'Costa Rica', 'AMRO', '508', '185653', '6', '2449');
INSERT INTO public.who_global_data_import VALUES (19184, '2021-01-20', 'CR', 'Costa Rica', 'AMRO', '363', '186016', '9', '2458');
INSERT INTO public.who_global_data_import VALUES (19185, '2021-01-21', 'CR', 'Costa Rica', 'AMRO', '861', '186877', '19', '2477');
INSERT INTO public.who_global_data_import VALUES (19186, '2021-01-22', 'CR', 'Costa Rica', 'AMRO', '835', '187712', '15', '2492');
INSERT INTO public.who_global_data_import VALUES (19187, '2021-01-23', 'CR', 'Costa Rica', 'AMRO', '765', '188477', '14', '2506');
INSERT INTO public.who_global_data_import VALUES (19188, '2021-01-24', 'CR', 'Costa Rica', 'AMRO', '831', '189308', '12', '2518');
INSERT INTO public.who_global_data_import VALUES (19189, '2021-01-25', 'CR', 'Costa Rica', 'AMRO', '651', '189959', '14', '2532');
INSERT INTO public.who_global_data_import VALUES (19190, '2021-01-26', 'CR', 'Costa Rica', 'AMRO', '431', '190390', '11', '2543');
INSERT INTO public.who_global_data_import VALUES (19191, '2021-01-27', 'CR', 'Costa Rica', 'AMRO', '355', '190745', '15', '2558');
INSERT INTO public.who_global_data_import VALUES (19192, '2021-01-28', 'CR', 'Costa Rica', 'AMRO', '600', '191345', '9', '2567');
INSERT INTO public.who_global_data_import VALUES (19193, '2021-01-29', 'CR', 'Costa Rica', 'AMRO', '721', '192066', '17', '2584');
INSERT INTO public.who_global_data_import VALUES (19194, '2021-01-30', 'CR', 'Costa Rica', 'AMRO', '571', '192637', '15', '2599');
INSERT INTO public.who_global_data_import VALUES (19195, '2021-01-31', 'CR', 'Costa Rica', 'AMRO', '639', '193276', '5', '2604');
INSERT INTO public.who_global_data_import VALUES (19196, '2021-02-01', 'CR', 'Costa Rica', 'AMRO', '568', '193844', '8', '2612');
INSERT INTO public.who_global_data_import VALUES (19197, '2021-02-02', 'CR', 'Costa Rica', 'AMRO', '436', '194280', '15', '2627');
INSERT INTO public.who_global_data_import VALUES (19198, '2021-02-03', 'CR', 'Costa Rica', 'AMRO', '289', '194569', '7', '2634');
INSERT INTO public.who_global_data_import VALUES (19199, '2021-02-04', 'CR', 'Costa Rica', 'AMRO', '440', '195009', '7', '2641');
INSERT INTO public.who_global_data_import VALUES (19200, '2021-02-05', 'CR', 'Costa Rica', 'AMRO', '528', '195537', '9', '2650');
INSERT INTO public.who_global_data_import VALUES (19201, '2020-01-03', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19202, '2020-01-04', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19203, '2020-01-05', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19204, '2020-01-06', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19205, '2020-01-07', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19206, '2020-01-08', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19207, '2020-01-09', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19208, '2020-01-10', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19209, '2020-01-11', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19210, '2020-01-12', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19211, '2020-01-13', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19212, '2020-01-14', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19213, '2020-01-15', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19214, '2020-01-16', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19215, '2020-01-17', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19216, '2020-01-18', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19217, '2020-01-19', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19613, '2020-01-15', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19218, '2020-01-20', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19219, '2020-01-21', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19220, '2020-01-22', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19221, '2020-01-23', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19222, '2020-01-24', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19223, '2020-01-25', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19224, '2020-01-26', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19225, '2020-01-27', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19226, '2020-01-28', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19227, '2020-01-29', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19228, '2020-01-30', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19229, '2020-01-31', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19230, '2020-02-01', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19231, '2020-02-02', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19232, '2020-02-03', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19233, '2020-02-04', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19234, '2020-02-05', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19235, '2020-02-06', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19236, '2020-02-07', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19237, '2020-02-08', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19238, '2020-02-09', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19239, '2020-02-10', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19240, '2020-02-11', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19241, '2020-02-12', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19242, '2020-02-13', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19243, '2020-02-14', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19244, '2020-02-15', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19245, '2020-02-16', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19246, '2020-02-17', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19247, '2020-02-18', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19248, '2020-02-19', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19249, '2020-02-20', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19250, '2020-02-21', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19251, '2020-02-22', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19252, '2020-02-23', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19253, '2020-02-24', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19254, '2020-02-25', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19255, '2020-02-26', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19256, '2020-02-27', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19257, '2020-02-28', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19258, '2020-02-29', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19259, '2020-03-01', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19260, '2020-03-02', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19261, '2020-03-03', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19262, '2020-03-04', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19263, '2020-03-05', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19264, '2020-03-06', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19265, '2020-03-07', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19266, '2020-03-08', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19267, '2020-03-09', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19268, '2020-03-10', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19269, '2020-03-11', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19270, '2020-03-12', 'CI', 'Côte d’Ivoire', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19271, '2020-03-13', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19272, '2020-03-14', 'CI', 'Côte d’Ivoire', 'AFRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19273, '2020-03-15', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19274, '2020-03-16', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19275, '2020-03-17', 'CI', 'Côte d’Ivoire', 'AFRO', '3', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19276, '2020-03-18', 'CI', 'Côte d’Ivoire', 'AFRO', '3', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19277, '2020-03-19', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19278, '2020-03-20', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19279, '2020-03-21', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19280, '2020-03-22', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19281, '2020-03-23', 'CI', 'Côte d’Ivoire', 'AFRO', '12', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19282, '2020-03-24', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19283, '2020-03-25', 'CI', 'Côte d’Ivoire', 'AFRO', '47', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19284, '2020-03-26', 'CI', 'Côte d’Ivoire', 'AFRO', '8', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19285, '2020-03-27', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19286, '2020-03-28', 'CI', 'Côte d’Ivoire', 'AFRO', '12', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19287, '2020-03-29', 'CI', 'Côte d’Ivoire', 'AFRO', '48', '140', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19288, '2020-03-30', 'CI', 'Côte d’Ivoire', 'AFRO', '25', '165', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19289, '2020-03-31', 'CI', 'Côte d’Ivoire', 'AFRO', '4', '169', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19290, '2020-04-01', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '169', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19291, '2020-04-02', 'CI', 'Côte d’Ivoire', 'AFRO', '21', '190', '1', '1');
INSERT INTO public.who_global_data_import VALUES (19292, '2020-04-03', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '190', '0', '1');
INSERT INTO public.who_global_data_import VALUES (19293, '2020-04-04', 'CI', 'Côte d’Ivoire', 'AFRO', '28', '218', '0', '1');
INSERT INTO public.who_global_data_import VALUES (19294, '2020-04-05', 'CI', 'Côte d’Ivoire', 'AFRO', '27', '245', '1', '2');
INSERT INTO public.who_global_data_import VALUES (19295, '2020-04-06', 'CI', 'Côte d’Ivoire', 'AFRO', '16', '261', '0', '2');
INSERT INTO public.who_global_data_import VALUES (19296, '2020-04-07', 'CI', 'Côte d’Ivoire', 'AFRO', '62', '323', '1', '3');
INSERT INTO public.who_global_data_import VALUES (19297, '2020-04-08', 'CI', 'Côte d’Ivoire', 'AFRO', '26', '349', '0', '3');
INSERT INTO public.who_global_data_import VALUES (19298, '2020-04-09', 'CI', 'Côte d’Ivoire', 'AFRO', '35', '384', '0', '3');
INSERT INTO public.who_global_data_import VALUES (19299, '2020-04-10', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '384', '0', '3');
INSERT INTO public.who_global_data_import VALUES (19300, '2020-04-11', 'CI', 'Côte d’Ivoire', 'AFRO', '96', '480', '0', '3');
INSERT INTO public.who_global_data_import VALUES (19301, '2020-04-12', 'CI', 'Côte d’Ivoire', 'AFRO', '53', '533', '1', '4');
INSERT INTO public.who_global_data_import VALUES (19302, '2020-04-13', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '533', '0', '4');
INSERT INTO public.who_global_data_import VALUES (19303, '2020-04-14', 'CI', 'Côte d’Ivoire', 'AFRO', '93', '626', '2', '6');
INSERT INTO public.who_global_data_import VALUES (19304, '2020-04-15', 'CI', 'Côte d’Ivoire', 'AFRO', '12', '638', '0', '6');
INSERT INTO public.who_global_data_import VALUES (19305, '2020-04-16', 'CI', 'Côte d’Ivoire', 'AFRO', '16', '654', '0', '6');
INSERT INTO public.who_global_data_import VALUES (19306, '2020-04-17', 'CI', 'Côte d’Ivoire', 'AFRO', '34', '688', '0', '6');
INSERT INTO public.who_global_data_import VALUES (19307, '2020-04-18', 'CI', 'Côte d’Ivoire', 'AFRO', '54', '742', '0', '6');
INSERT INTO public.who_global_data_import VALUES (19308, '2020-04-19', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '742', '0', '6');
INSERT INTO public.who_global_data_import VALUES (19309, '2020-04-20', 'CI', 'Côte d’Ivoire', 'AFRO', '105', '847', '3', '9');
INSERT INTO public.who_global_data_import VALUES (19310, '2020-04-21', 'CI', 'Côte d’Ivoire', 'AFRO', '32', '879', '1', '10');
INSERT INTO public.who_global_data_import VALUES (19311, '2020-04-22', 'CI', 'Côte d’Ivoire', 'AFRO', '37', '916', '3', '13');
INSERT INTO public.who_global_data_import VALUES (19312, '2020-04-23', 'CI', 'Côte d’Ivoire', 'AFRO', '36', '952', '1', '14');
INSERT INTO public.who_global_data_import VALUES (19313, '2020-04-24', 'CI', 'Côte d’Ivoire', 'AFRO', '52', '1004', '0', '14');
INSERT INTO public.who_global_data_import VALUES (19314, '2020-04-25', 'CI', 'Côte d’Ivoire', 'AFRO', '73', '1077', '0', '14');
INSERT INTO public.who_global_data_import VALUES (19315, '2020-04-26', 'CI', 'Côte d’Ivoire', 'AFRO', '34', '1111', '0', '14');
INSERT INTO public.who_global_data_import VALUES (19316, '2020-04-27', 'CI', 'Côte d’Ivoire', 'AFRO', '39', '1150', '0', '14');
INSERT INTO public.who_global_data_import VALUES (19317, '2020-04-28', 'CI', 'Côte d’Ivoire', 'AFRO', '14', '1164', '0', '14');
INSERT INTO public.who_global_data_import VALUES (19318, '2020-04-29', 'CI', 'Côte d’Ivoire', 'AFRO', '19', '1183', '0', '14');
INSERT INTO public.who_global_data_import VALUES (19319, '2020-04-30', 'CI', 'Côte d’Ivoire', 'AFRO', '55', '1238', '0', '14');
INSERT INTO public.who_global_data_import VALUES (19320, '2020-05-01', 'CI', 'Côte d’Ivoire', 'AFRO', '37', '1275', '0', '14');
INSERT INTO public.who_global_data_import VALUES (19321, '2020-05-02', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '1275', '0', '14');
INSERT INTO public.who_global_data_import VALUES (19322, '2020-05-03', 'CI', 'Côte d’Ivoire', 'AFRO', '87', '1362', '1', '15');
INSERT INTO public.who_global_data_import VALUES (19323, '2020-05-04', 'CI', 'Côte d’Ivoire', 'AFRO', '36', '1398', '2', '17');
INSERT INTO public.who_global_data_import VALUES (19324, '2020-05-05', 'CI', 'Côte d’Ivoire', 'AFRO', '34', '1432', '0', '17');
INSERT INTO public.who_global_data_import VALUES (19325, '2020-05-06', 'CI', 'Côte d’Ivoire', 'AFRO', '32', '1464', '1', '18');
INSERT INTO public.who_global_data_import VALUES (19326, '2020-05-07', 'CI', 'Côte d’Ivoire', 'AFRO', '52', '1516', '0', '18');
INSERT INTO public.who_global_data_import VALUES (19327, '2020-05-08', 'CI', 'Côte d’Ivoire', 'AFRO', '55', '1571', '2', '20');
INSERT INTO public.who_global_data_import VALUES (19328, '2020-05-09', 'CI', 'Côte d’Ivoire', 'AFRO', '31', '1602', '0', '20');
INSERT INTO public.who_global_data_import VALUES (19329, '2020-05-10', 'CI', 'Côte d’Ivoire', 'AFRO', '65', '1667', '1', '21');
INSERT INTO public.who_global_data_import VALUES (19330, '2020-05-11', 'CI', 'Côte d’Ivoire', 'AFRO', '33', '1700', '0', '21');
INSERT INTO public.who_global_data_import VALUES (19331, '2020-05-12', 'CI', 'Côte d’Ivoire', 'AFRO', '30', '1730', '0', '21');
INSERT INTO public.who_global_data_import VALUES (19332, '2020-05-13', 'CI', 'Côte d’Ivoire', 'AFRO', '127', '1857', '0', '21');
INSERT INTO public.who_global_data_import VALUES (19333, '2020-05-14', 'CI', 'Côte d’Ivoire', 'AFRO', '55', '1912', '3', '24');
INSERT INTO public.who_global_data_import VALUES (19334, '2020-05-15', 'CI', 'Côte d’Ivoire', 'AFRO', '59', '1971', '0', '24');
INSERT INTO public.who_global_data_import VALUES (19335, '2020-05-16', 'CI', 'Côte d’Ivoire', 'AFRO', '46', '2017', '0', '24');
INSERT INTO public.who_global_data_import VALUES (19336, '2020-05-17', 'CI', 'Côte d’Ivoire', 'AFRO', '44', '2061', '1', '25');
INSERT INTO public.who_global_data_import VALUES (19337, '2020-05-18', 'CI', 'Côte d’Ivoire', 'AFRO', '48', '2109', '2', '27');
INSERT INTO public.who_global_data_import VALUES (19338, '2020-05-19', 'CI', 'Côte d’Ivoire', 'AFRO', '10', '2119', '1', '28');
INSERT INTO public.who_global_data_import VALUES (19339, '2020-05-20', 'CI', 'Côte d’Ivoire', 'AFRO', '34', '2153', '0', '28');
INSERT INTO public.who_global_data_import VALUES (19340, '2020-05-21', 'CI', 'Côte d’Ivoire', 'AFRO', '78', '2231', '1', '29');
INSERT INTO public.who_global_data_import VALUES (19341, '2020-05-22', 'CI', 'Côte d’Ivoire', 'AFRO', '70', '2301', '0', '29');
INSERT INTO public.who_global_data_import VALUES (19342, '2020-05-23', 'CI', 'Côte d’Ivoire', 'AFRO', '40', '2341', '0', '29');
INSERT INTO public.who_global_data_import VALUES (19343, '2020-05-24', 'CI', 'Côte d’Ivoire', 'AFRO', '25', '2366', '1', '30');
INSERT INTO public.who_global_data_import VALUES (19344, '2020-05-25', 'CI', 'Côte d’Ivoire', 'AFRO', '10', '2376', '0', '30');
INSERT INTO public.who_global_data_import VALUES (19345, '2020-05-26', 'CI', 'Côte d’Ivoire', 'AFRO', '47', '2423', '0', '30');
INSERT INTO public.who_global_data_import VALUES (19346, '2020-05-27', 'CI', 'Côte d’Ivoire', 'AFRO', '54', '2477', '0', '30');
INSERT INTO public.who_global_data_import VALUES (19347, '2020-05-28', 'CI', 'Côte d’Ivoire', 'AFRO', '79', '2556', '1', '31');
INSERT INTO public.who_global_data_import VALUES (19348, '2020-05-29', 'CI', 'Côte d’Ivoire', 'AFRO', '85', '2641', '1', '32');
INSERT INTO public.who_global_data_import VALUES (19349, '2020-05-30', 'CI', 'Côte d’Ivoire', 'AFRO', '109', '2750', '0', '32');
INSERT INTO public.who_global_data_import VALUES (19350, '2020-05-31', 'CI', 'Côte d’Ivoire', 'AFRO', '49', '2799', '1', '33');
INSERT INTO public.who_global_data_import VALUES (19351, '2020-06-01', 'CI', 'Côte d’Ivoire', 'AFRO', '34', '2833', '0', '33');
INSERT INTO public.who_global_data_import VALUES (19352, '2020-06-02', 'CI', 'Côte d’Ivoire', 'AFRO', '118', '2951', '0', '33');
INSERT INTO public.who_global_data_import VALUES (19353, '2020-06-03', 'CI', 'Côte d’Ivoire', 'AFRO', '73', '3024', '0', '33');
INSERT INTO public.who_global_data_import VALUES (19354, '2020-06-04', 'CI', 'Côte d’Ivoire', 'AFRO', '86', '3110', '2', '35');
INSERT INTO public.who_global_data_import VALUES (19355, '2020-06-05', 'CI', 'Côte d’Ivoire', 'AFRO', '152', '3262', '0', '35');
INSERT INTO public.who_global_data_import VALUES (19356, '2020-06-06', 'CI', 'Côte d’Ivoire', 'AFRO', '169', '3431', '1', '36');
INSERT INTO public.who_global_data_import VALUES (19357, '2020-06-07', 'CI', 'Côte d’Ivoire', 'AFRO', '126', '3557', '0', '36');
INSERT INTO public.who_global_data_import VALUES (19358, '2020-06-08', 'CI', 'Côte d’Ivoire', 'AFRO', '182', '3739', '0', '36');
INSERT INTO public.who_global_data_import VALUES (19359, '2020-06-09', 'CI', 'Côte d’Ivoire', 'AFRO', '142', '3881', '2', '38');
INSERT INTO public.who_global_data_import VALUES (19360, '2020-06-10', 'CI', 'Côte d’Ivoire', 'AFRO', '114', '3995', '0', '38');
INSERT INTO public.who_global_data_import VALUES (19361, '2020-06-11', 'CI', 'Côte d’Ivoire', 'AFRO', '186', '4181', '3', '41');
INSERT INTO public.who_global_data_import VALUES (19362, '2020-06-12', 'CI', 'Côte d’Ivoire', 'AFRO', '223', '4404', '0', '41');
INSERT INTO public.who_global_data_import VALUES (19363, '2020-06-13', 'CI', 'Côte d’Ivoire', 'AFRO', '280', '4684', '4', '45');
INSERT INTO public.who_global_data_import VALUES (19364, '2020-06-14', 'CI', 'Côte d’Ivoire', 'AFRO', '164', '4848', '0', '45');
INSERT INTO public.who_global_data_import VALUES (19365, '2020-06-15', 'CI', 'Côte d’Ivoire', 'AFRO', '236', '5084', '0', '45');
INSERT INTO public.who_global_data_import VALUES (19366, '2020-06-16', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '5084', '0', '45');
INSERT INTO public.who_global_data_import VALUES (19367, '2020-06-17', 'CI', 'Côte d’Ivoire', 'AFRO', '595', '5679', '1', '46');
INSERT INTO public.who_global_data_import VALUES (19368, '2020-06-18', 'CI', 'Côte d’Ivoire', 'AFRO', '384', '6063', '2', '48');
INSERT INTO public.who_global_data_import VALUES (19369, '2020-06-19', 'CI', 'Côte d’Ivoire', 'AFRO', '381', '6444', '1', '49');
INSERT INTO public.who_global_data_import VALUES (19370, '2020-06-20', 'CI', 'Côte d’Ivoire', 'AFRO', '430', '6874', '0', '49');
INSERT INTO public.who_global_data_import VALUES (19371, '2020-06-21', 'CI', 'Côte d’Ivoire', 'AFRO', '402', '7276', '3', '52');
INSERT INTO public.who_global_data_import VALUES (19372, '2020-06-22', 'CI', 'Côte d’Ivoire', 'AFRO', '216', '7492', '2', '54');
INSERT INTO public.who_global_data_import VALUES (19373, '2020-06-23', 'CI', 'Côte d’Ivoire', 'AFRO', '185', '7677', '2', '56');
INSERT INTO public.who_global_data_import VALUES (19374, '2020-06-24', 'CI', 'Côte d’Ivoire', 'AFRO', '227', '7904', '2', '58');
INSERT INTO public.who_global_data_import VALUES (19375, '2020-06-25', 'CI', 'Côte d’Ivoire', 'AFRO', '260', '8164', '0', '58');
INSERT INTO public.who_global_data_import VALUES (19376, '2020-06-26', 'CI', 'Côte d’Ivoire', 'AFRO', '170', '8334', '2', '60');
INSERT INTO public.who_global_data_import VALUES (19377, '2020-06-27', 'CI', 'Côte d’Ivoire', 'AFRO', '405', '8739', '4', '64');
INSERT INTO public.who_global_data_import VALUES (19378, '2020-06-28', 'CI', 'Côte d’Ivoire', 'AFRO', '205', '8944', '2', '66');
INSERT INTO public.who_global_data_import VALUES (19379, '2020-06-29', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '8944', '0', '66');
INSERT INTO public.who_global_data_import VALUES (19380, '2020-06-30', 'CI', 'Côte d’Ivoire', 'AFRO', '157', '9101', '0', '66');
INSERT INTO public.who_global_data_import VALUES (19381, '2020-07-01', 'CI', 'Côte d’Ivoire', 'AFRO', '113', '9214', '0', '66');
INSERT INTO public.who_global_data_import VALUES (19382, '2020-07-02', 'CI', 'Côte d’Ivoire', 'AFRO', '285', '9499', '2', '68');
INSERT INTO public.who_global_data_import VALUES (19383, '2020-07-03', 'CI', 'Côte d’Ivoire', 'AFRO', '203', '9702', '0', '68');
INSERT INTO public.who_global_data_import VALUES (19384, '2020-07-04', 'CI', 'Côte d’Ivoire', 'AFRO', '290', '9992', '0', '68');
INSERT INTO public.who_global_data_import VALUES (19385, '2020-07-05', 'CI', 'Côte d’Ivoire', 'AFRO', '252', '10244', '2', '70');
INSERT INTO public.who_global_data_import VALUES (19386, '2020-07-06', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '10244', '0', '70');
INSERT INTO public.who_global_data_import VALUES (19387, '2020-07-07', 'CI', 'Côte d’Ivoire', 'AFRO', '722', '10966', '5', '75');
INSERT INTO public.who_global_data_import VALUES (19388, '2020-07-08', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '10966', '0', '75');
INSERT INTO public.who_global_data_import VALUES (19389, '2020-07-09', 'CI', 'Côte d’Ivoire', 'AFRO', '538', '11504', '3', '78');
INSERT INTO public.who_global_data_import VALUES (19390, '2020-07-10', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '11504', '0', '78');
INSERT INTO public.who_global_data_import VALUES (19391, '2020-07-11', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '11504', '0', '78');
INSERT INTO public.who_global_data_import VALUES (19392, '2020-07-12', 'CI', 'Côte d’Ivoire', 'AFRO', '548', '12052', '3', '81');
INSERT INTO public.who_global_data_import VALUES (19393, '2020-07-13', 'CI', 'Côte d’Ivoire', 'AFRO', '714', '12766', '3', '84');
INSERT INTO public.who_global_data_import VALUES (19394, '2020-07-14', 'CI', 'Côte d’Ivoire', 'AFRO', '106', '12872', '0', '84');
INSERT INTO public.who_global_data_import VALUES (19395, '2020-07-15', 'CI', 'Côte d’Ivoire', 'AFRO', '165', '13037', '3', '87');
INSERT INTO public.who_global_data_import VALUES (19396, '2020-07-16', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '13037', '0', '87');
INSERT INTO public.who_global_data_import VALUES (19397, '2020-07-17', 'CI', 'Côte d’Ivoire', 'AFRO', '366', '13403', '0', '87');
INSERT INTO public.who_global_data_import VALUES (19398, '2020-07-18', 'CI', 'Côte d’Ivoire', 'AFRO', '293', '13696', '0', '87');
INSERT INTO public.who_global_data_import VALUES (19399, '2020-07-19', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '13696', '0', '87');
INSERT INTO public.who_global_data_import VALUES (19400, '2020-07-20', 'CI', 'Côte d’Ivoire', 'AFRO', '423', '14119', '5', '92');
INSERT INTO public.who_global_data_import VALUES (19401, '2020-07-21', 'CI', 'Côte d’Ivoire', 'AFRO', '193', '14312', '0', '92');
INSERT INTO public.who_global_data_import VALUES (19402, '2020-07-22', 'CI', 'Côte d’Ivoire', 'AFRO', '219', '14531', '1', '93');
INSERT INTO public.who_global_data_import VALUES (19403, '2020-07-23', 'CI', 'Côte d’Ivoire', 'AFRO', '202', '14733', '0', '93');
INSERT INTO public.who_global_data_import VALUES (19404, '2020-07-24', 'CI', 'Côte d’Ivoire', 'AFRO', '268', '15001', '0', '93');
INSERT INTO public.who_global_data_import VALUES (19405, '2020-07-25', 'CI', 'Côte d’Ivoire', 'AFRO', '252', '15253', '1', '94');
INSERT INTO public.who_global_data_import VALUES (19406, '2020-07-26', 'CI', 'Côte d’Ivoire', 'AFRO', '241', '15494', '0', '94');
INSERT INTO public.who_global_data_import VALUES (19407, '2020-07-27', 'CI', 'Côte d’Ivoire', 'AFRO', '102', '15596', '2', '96');
INSERT INTO public.who_global_data_import VALUES (19408, '2020-07-28', 'CI', 'Côte d’Ivoire', 'AFRO', '59', '15655', '0', '96');
INSERT INTO public.who_global_data_import VALUES (19409, '2020-07-29', 'CI', 'Côte d’Ivoire', 'AFRO', '58', '15713', '2', '98');
INSERT INTO public.who_global_data_import VALUES (19410, '2020-07-30', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '15713', '0', '98');
INSERT INTO public.who_global_data_import VALUES (19411, '2020-07-31', 'CI', 'Côte d’Ivoire', 'AFRO', '265', '15978', '2', '100');
INSERT INTO public.who_global_data_import VALUES (19412, '2020-08-01', 'CI', 'Côte d’Ivoire', 'AFRO', '69', '16047', '2', '102');
INSERT INTO public.who_global_data_import VALUES (19413, '2020-08-02', 'CI', 'Côte d’Ivoire', 'AFRO', '62', '16109', '0', '102');
INSERT INTO public.who_global_data_import VALUES (19414, '2020-08-03', 'CI', 'Côte d’Ivoire', 'AFRO', '73', '16182', '0', '102');
INSERT INTO public.who_global_data_import VALUES (19415, '2020-08-04', 'CI', 'Côte d’Ivoire', 'AFRO', '38', '16220', '0', '102');
INSERT INTO public.who_global_data_import VALUES (19416, '2020-08-05', 'CI', 'Côte d’Ivoire', 'AFRO', '73', '16293', '1', '103');
INSERT INTO public.who_global_data_import VALUES (19417, '2020-08-06', 'CI', 'Côte d’Ivoire', 'AFRO', '56', '16349', '0', '103');
INSERT INTO public.who_global_data_import VALUES (19418, '2020-08-07', 'CI', 'Côte d’Ivoire', 'AFRO', '98', '16447', '0', '103');
INSERT INTO public.who_global_data_import VALUES (19419, '2020-08-08', 'CI', 'Côte d’Ivoire', 'AFRO', '77', '16524', '1', '104');
INSERT INTO public.who_global_data_import VALUES (19420, '2020-08-09', 'CI', 'Côte d’Ivoire', 'AFRO', '96', '16620', '0', '104');
INSERT INTO public.who_global_data_import VALUES (19421, '2020-08-10', 'CI', 'Côte d’Ivoire', 'AFRO', '95', '16715', '1', '105');
INSERT INTO public.who_global_data_import VALUES (19422, '2020-08-11', 'CI', 'Côte d’Ivoire', 'AFRO', '83', '16798', '0', '105');
INSERT INTO public.who_global_data_import VALUES (19423, '2020-08-12', 'CI', 'Côte d’Ivoire', 'AFRO', '49', '16847', '0', '105');
INSERT INTO public.who_global_data_import VALUES (19424, '2020-08-13', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '16847', '0', '105');
INSERT INTO public.who_global_data_import VALUES (19425, '2020-08-14', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '16847', '0', '105');
INSERT INTO public.who_global_data_import VALUES (19426, '2020-08-15', 'CI', 'Côte d’Ivoire', 'AFRO', '88', '16935', '3', '108');
INSERT INTO public.who_global_data_import VALUES (19427, '2020-08-16', 'CI', 'Côte d’Ivoire', 'AFRO', '58', '16993', '0', '108');
INSERT INTO public.who_global_data_import VALUES (19428, '2020-08-17', 'CI', 'Côte d’Ivoire', 'AFRO', '33', '17026', '2', '110');
INSERT INTO public.who_global_data_import VALUES (19429, '2020-08-18', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '17026', '0', '110');
INSERT INTO public.who_global_data_import VALUES (19430, '2020-08-19', 'CI', 'Côte d’Ivoire', 'AFRO', '124', '17150', '0', '110');
INSERT INTO public.who_global_data_import VALUES (19431, '2020-08-20', 'CI', 'Côte d’Ivoire', 'AFRO', '82', '17232', '1', '111');
INSERT INTO public.who_global_data_import VALUES (19432, '2020-08-21', 'CI', 'Côte d’Ivoire', 'AFRO', '17', '17249', '1', '112');
INSERT INTO public.who_global_data_import VALUES (19433, '2020-08-22', 'CI', 'Côte d’Ivoire', 'AFRO', '61', '17310', '0', '112');
INSERT INTO public.who_global_data_import VALUES (19434, '2020-08-23', 'CI', 'Côte d’Ivoire', 'AFRO', '64', '17374', '1', '113');
INSERT INTO public.who_global_data_import VALUES (19435, '2020-08-24', 'CI', 'Côte d’Ivoire', 'AFRO', '97', '17471', '0', '113');
INSERT INTO public.who_global_data_import VALUES (19436, '2020-08-25', 'CI', 'Côte d’Ivoire', 'AFRO', '35', '17506', '1', '114');
INSERT INTO public.who_global_data_import VALUES (19437, '2020-08-26', 'CI', 'Côte d’Ivoire', 'AFRO', '56', '17562', '0', '114');
INSERT INTO public.who_global_data_import VALUES (19438, '2020-08-27', 'CI', 'Côte d’Ivoire', 'AFRO', '41', '17603', '0', '114');
INSERT INTO public.who_global_data_import VALUES (19439, '2020-08-28', 'CI', 'Côte d’Ivoire', 'AFRO', '99', '17702', '1', '115');
INSERT INTO public.who_global_data_import VALUES (19440, '2020-08-29', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '17702', '0', '115');
INSERT INTO public.who_global_data_import VALUES (19441, '2020-08-30', 'CI', 'Côte d’Ivoire', 'AFRO', '191', '17893', '0', '115');
INSERT INTO public.who_global_data_import VALUES (19442, '2020-08-31', 'CI', 'Côte d’Ivoire', 'AFRO', '55', '17948', '0', '115');
INSERT INTO public.who_global_data_import VALUES (19443, '2020-09-01', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '17948', '0', '115');
INSERT INTO public.who_global_data_import VALUES (19444, '2020-09-02', 'CI', 'Côte d’Ivoire', 'AFRO', '155', '18103', '2', '117');
INSERT INTO public.who_global_data_import VALUES (19445, '2020-09-03', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '18103', '0', '117');
INSERT INTO public.who_global_data_import VALUES (19446, '2020-09-04', 'CI', 'Côte d’Ivoire', 'AFRO', '58', '18161', '0', '117');
INSERT INTO public.who_global_data_import VALUES (19447, '2020-09-05', 'CI', 'Côte d’Ivoire', 'AFRO', '47', '18208', '2', '119');
INSERT INTO public.who_global_data_import VALUES (19448, '2020-09-06', 'CI', 'Côte d’Ivoire', 'AFRO', '61', '18269', '0', '119');
INSERT INTO public.who_global_data_import VALUES (19449, '2020-09-07', 'CI', 'Côte d’Ivoire', 'AFRO', '319', '18588', '0', '119');
INSERT INTO public.who_global_data_import VALUES (19450, '2020-09-08', 'CI', 'Côte d’Ivoire', 'AFRO', '113', '18701', '0', '119');
INSERT INTO public.who_global_data_import VALUES (19451, '2020-09-09', 'CI', 'Côte d’Ivoire', 'AFRO', '77', '18778', '0', '119');
INSERT INTO public.who_global_data_import VALUES (19452, '2020-09-10', 'CI', 'Côte d’Ivoire', 'AFRO', '37', '18815', '0', '119');
INSERT INTO public.who_global_data_import VALUES (19453, '2020-09-11', 'CI', 'Côte d’Ivoire', 'AFRO', '54', '18869', '0', '119');
INSERT INTO public.who_global_data_import VALUES (19454, '2020-09-12', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '18869', '0', '119');
INSERT INTO public.who_global_data_import VALUES (19455, '2020-09-13', 'CI', 'Côte d’Ivoire', 'AFRO', '118', '18987', '1', '120');
INSERT INTO public.who_global_data_import VALUES (19456, '2020-09-14', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '18987', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19457, '2020-09-15', 'CI', 'Côte d’Ivoire', 'AFRO', '26', '19013', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19458, '2020-09-16', 'CI', 'Côte d’Ivoire', 'AFRO', '87', '19100', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19459, '2020-09-17', 'CI', 'Côte d’Ivoire', 'AFRO', '32', '19132', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19460, '2020-09-18', 'CI', 'Côte d’Ivoire', 'AFRO', '26', '19158', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19461, '2020-09-19', 'CI', 'Côte d’Ivoire', 'AFRO', '42', '19200', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19462, '2020-09-20', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '19200', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19463, '2020-09-21', 'CI', 'Côte d’Ivoire', 'AFRO', '69', '19269', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19464, '2020-09-22', 'CI', 'Côte d’Ivoire', 'AFRO', '51', '19320', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19465, '2020-09-23', 'CI', 'Côte d’Ivoire', 'AFRO', '7', '19327', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19466, '2020-09-24', 'CI', 'Côte d’Ivoire', 'AFRO', '103', '19430', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19467, '2020-09-25', 'CI', 'Côte d’Ivoire', 'AFRO', '71', '19501', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19468, '2020-09-26', 'CI', 'Côte d’Ivoire', 'AFRO', '55', '19556', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19469, '2020-09-27', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '19556', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19470, '2020-09-28', 'CI', 'Côte d’Ivoire', 'AFRO', '73', '19629', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19471, '2020-09-29', 'CI', 'Côte d’Ivoire', 'AFRO', '12', '19641', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19472, '2020-09-30', 'CI', 'Côte d’Ivoire', 'AFRO', '28', '19669', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19473, '2020-10-01', 'CI', 'Côte d’Ivoire', 'AFRO', '55', '19724', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19474, '2020-10-02', 'CI', 'Côte d’Ivoire', 'AFRO', '31', '19755', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19475, '2020-10-03', 'CI', 'Côte d’Ivoire', 'AFRO', '38', '19793', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19476, '2020-10-04', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '19793', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19477, '2020-10-05', 'CI', 'Côte d’Ivoire', 'AFRO', '56', '19849', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19478, '2020-10-06', 'CI', 'Côte d’Ivoire', 'AFRO', '36', '19885', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19479, '2020-10-07', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '19885', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19480, '2020-10-08', 'CI', 'Côte d’Ivoire', 'AFRO', '18', '19903', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19481, '2020-10-09', 'CI', 'Côte d’Ivoire', 'AFRO', '79', '19982', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19482, '2020-10-10', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '19982', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19483, '2020-10-11', 'CI', 'Côte d’Ivoire', 'AFRO', '54', '20036', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19484, '2020-10-12', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '20036', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19485, '2020-10-13', 'CI', 'Côte d’Ivoire', 'AFRO', '118', '20154', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19486, '2020-10-14', 'CI', 'Côte d’Ivoire', 'AFRO', '29', '20183', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19487, '2020-10-15', 'CI', 'Côte d’Ivoire', 'AFRO', '34', '20217', '1', '121');
INSERT INTO public.who_global_data_import VALUES (19488, '2020-10-16', 'CI', 'Côte d’Ivoire', 'AFRO', '40', '20257', '0', '121');
INSERT INTO public.who_global_data_import VALUES (19489, '2020-10-17', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '20257', '0', '121');
INSERT INTO public.who_global_data_import VALUES (19490, '2020-10-18', 'CI', 'Côte d’Ivoire', 'AFRO', '18', '20275', '0', '121');
INSERT INTO public.who_global_data_import VALUES (19491, '2020-10-19', 'CI', 'Côte d’Ivoire', 'AFRO', '48', '20323', '0', '121');
INSERT INTO public.who_global_data_import VALUES (19492, '2020-10-20', 'CI', 'Côte d’Ivoire', 'AFRO', '1', '20324', '0', '121');
INSERT INTO public.who_global_data_import VALUES (19493, '2020-10-21', 'CI', 'Côte d’Ivoire', 'AFRO', '18', '20342', '0', '121');
INSERT INTO public.who_global_data_import VALUES (19494, '2020-10-22', 'CI', 'Côte d’Ivoire', 'AFRO', '21', '20363', '0', '121');
INSERT INTO public.who_global_data_import VALUES (19495, '2020-10-23', 'CI', 'Côte d’Ivoire', 'AFRO', '27', '20390', '0', '121');
INSERT INTO public.who_global_data_import VALUES (19496, '2020-10-24', 'CI', 'Côte d’Ivoire', 'AFRO', '15', '20405', '0', '121');
INSERT INTO public.who_global_data_import VALUES (19497, '2020-10-25', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '20405', '0', '121');
INSERT INTO public.who_global_data_import VALUES (19498, '2020-10-26', 'CI', 'Côte d’Ivoire', 'AFRO', '65', '20470', '1', '122');
INSERT INTO public.who_global_data_import VALUES (19499, '2020-10-27', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '20470', '0', '122');
INSERT INTO public.who_global_data_import VALUES (19500, '2020-10-28', 'CI', 'Côte d’Ivoire', 'AFRO', '18', '20488', '0', '122');
INSERT INTO public.who_global_data_import VALUES (19501, '2020-10-29', 'CI', 'Côte d’Ivoire', 'AFRO', '67', '20555', '2', '124');
INSERT INTO public.who_global_data_import VALUES (19502, '2020-10-30', 'CI', 'Côte d’Ivoire', 'AFRO', '73', '20628', '0', '124');
INSERT INTO public.who_global_data_import VALUES (19503, '2020-10-31', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '20628', '0', '124');
INSERT INTO public.who_global_data_import VALUES (19504, '2020-11-01', 'CI', 'Côte d’Ivoire', 'AFRO', '64', '20692', '0', '124');
INSERT INTO public.who_global_data_import VALUES (19505, '2020-11-02', 'CI', 'Côte d’Ivoire', 'AFRO', '24', '20716', '2', '126');
INSERT INTO public.who_global_data_import VALUES (19506, '2020-11-03', 'CI', 'Côte d’Ivoire', 'AFRO', '37', '20753', '0', '126');
INSERT INTO public.who_global_data_import VALUES (19507, '2020-11-04', 'CI', 'Côte d’Ivoire', 'AFRO', '12', '20765', '0', '126');
INSERT INTO public.who_global_data_import VALUES (19508, '2020-11-05', 'CI', 'Côte d’Ivoire', 'AFRO', '13', '20778', '0', '126');
INSERT INTO public.who_global_data_import VALUES (19509, '2020-11-06', 'CI', 'Côte d’Ivoire', 'AFRO', '11', '20789', '0', '126');
INSERT INTO public.who_global_data_import VALUES (19510, '2020-11-07', 'CI', 'Côte d’Ivoire', 'AFRO', '12', '20801', '0', '126');
INSERT INTO public.who_global_data_import VALUES (19511, '2020-11-08', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '20801', '0', '126');
INSERT INTO public.who_global_data_import VALUES (19512, '2020-11-09', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '20801', '0', '126');
INSERT INTO public.who_global_data_import VALUES (19513, '2020-11-10', 'CI', 'Côte d’Ivoire', 'AFRO', '31', '20832', '0', '126');
INSERT INTO public.who_global_data_import VALUES (19514, '2020-11-11', 'CI', 'Côte d’Ivoire', 'AFRO', '15', '20847', '0', '126');
INSERT INTO public.who_global_data_import VALUES (19515, '2020-11-12', 'CI', 'Côte d’Ivoire', 'AFRO', '8', '20855', '1', '127');
INSERT INTO public.who_global_data_import VALUES (19516, '2020-11-13', 'CI', 'Côte d’Ivoire', 'AFRO', '27', '20882', '0', '127');
INSERT INTO public.who_global_data_import VALUES (19517, '2020-11-14', 'CI', 'Côte d’Ivoire', 'AFRO', '17', '20899', '0', '127');
INSERT INTO public.who_global_data_import VALUES (19518, '2020-11-15', 'CI', 'Côte d’Ivoire', 'AFRO', '46', '20945', '1', '128');
INSERT INTO public.who_global_data_import VALUES (19519, '2020-11-16', 'CI', 'Côte d’Ivoire', 'AFRO', '31', '20976', '0', '128');
INSERT INTO public.who_global_data_import VALUES (19520, '2020-11-17', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '20976', '0', '128');
INSERT INTO public.who_global_data_import VALUES (19521, '2020-11-18', 'CI', 'Côte d’Ivoire', 'AFRO', '28', '21004', '1', '129');
INSERT INTO public.who_global_data_import VALUES (19522, '2020-11-19', 'CI', 'Côte d’Ivoire', 'AFRO', '41', '21045', '0', '129');
INSERT INTO public.who_global_data_import VALUES (19523, '2020-11-20', 'CI', 'Côte d’Ivoire', 'AFRO', '38', '21083', '0', '129');
INSERT INTO public.who_global_data_import VALUES (19524, '2020-11-21', 'CI', 'Côte d’Ivoire', 'AFRO', '16', '21099', '0', '129');
INSERT INTO public.who_global_data_import VALUES (19525, '2020-11-22', 'CI', 'Côte d’Ivoire', 'AFRO', '27', '21126', '0', '129');
INSERT INTO public.who_global_data_import VALUES (19526, '2020-11-23', 'CI', 'Côte d’Ivoire', 'AFRO', '12', '21138', '2', '131');
INSERT INTO public.who_global_data_import VALUES (19527, '2020-11-24', 'CI', 'Côte d’Ivoire', 'AFRO', '10', '21148', '0', '131');
INSERT INTO public.who_global_data_import VALUES (19528, '2020-11-25', 'CI', 'Côte d’Ivoire', 'AFRO', '8', '21156', '0', '131');
INSERT INTO public.who_global_data_import VALUES (19529, '2020-11-26', 'CI', 'Côte d’Ivoire', 'AFRO', '12', '21168', '0', '131');
INSERT INTO public.who_global_data_import VALUES (19530, '2020-11-27', 'CI', 'Côte d’Ivoire', 'AFRO', '31', '21199', '0', '131');
INSERT INTO public.who_global_data_import VALUES (19531, '2020-11-28', 'CI', 'Côte d’Ivoire', 'AFRO', '33', '21232', '0', '131');
INSERT INTO public.who_global_data_import VALUES (19532, '2020-11-29', 'CI', 'Côte d’Ivoire', 'AFRO', '29', '21261', '0', '131');
INSERT INTO public.who_global_data_import VALUES (19533, '2020-11-30', 'CI', 'Côte d’Ivoire', 'AFRO', '49', '21310', '0', '131');
INSERT INTO public.who_global_data_import VALUES (19534, '2020-12-01', 'CI', 'Côte d’Ivoire', 'AFRO', '21', '21331', '1', '132');
INSERT INTO public.who_global_data_import VALUES (19535, '2020-12-02', 'CI', 'Côte d’Ivoire', 'AFRO', '3', '21334', '0', '132');
INSERT INTO public.who_global_data_import VALUES (19536, '2020-12-03', 'CI', 'Côte d’Ivoire', 'AFRO', '27', '21361', '0', '132');
INSERT INTO public.who_global_data_import VALUES (19537, '2020-12-04', 'CI', 'Côte d’Ivoire', 'AFRO', '28', '21389', '0', '132');
INSERT INTO public.who_global_data_import VALUES (19538, '2020-12-05', 'CI', 'Côte d’Ivoire', 'AFRO', '23', '21412', '0', '132');
INSERT INTO public.who_global_data_import VALUES (19539, '2020-12-06', 'CI', 'Côte d’Ivoire', 'AFRO', '29', '21441', '0', '132');
INSERT INTO public.who_global_data_import VALUES (19540, '2020-12-07', 'CI', 'Côte d’Ivoire', 'AFRO', '44', '21485', '0', '132');
INSERT INTO public.who_global_data_import VALUES (19541, '2020-12-08', 'CI', 'Côte d’Ivoire', 'AFRO', '22', '21507', '0', '132');
INSERT INTO public.who_global_data_import VALUES (19542, '2020-12-09', 'CI', 'Côte d’Ivoire', 'AFRO', '6', '21513', '0', '132');
INSERT INTO public.who_global_data_import VALUES (19543, '2020-12-10', 'CI', 'Côte d’Ivoire', 'AFRO', '34', '21547', '1', '133');
INSERT INTO public.who_global_data_import VALUES (19544, '2020-12-11', 'CI', 'Côte d’Ivoire', 'AFRO', '43', '21590', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19545, '2020-12-12', 'CI', 'Côte d’Ivoire', 'AFRO', '28', '21618', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19546, '2020-12-13', 'CI', 'Côte d’Ivoire', 'AFRO', '21', '21639', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19547, '2020-12-14', 'CI', 'Côte d’Ivoire', 'AFRO', '41', '21680', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19548, '2020-12-15', 'CI', 'Côte d’Ivoire', 'AFRO', '25', '21705', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19549, '2020-12-16', 'CI', 'Côte d’Ivoire', 'AFRO', '12', '21717', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19550, '2020-12-17', 'CI', 'Côte d’Ivoire', 'AFRO', '24', '21741', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19551, '2020-12-18', 'CI', 'Côte d’Ivoire', 'AFRO', '31', '21772', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19552, '2020-12-19', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '21772', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19553, '2020-12-20', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '21772', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19554, '2020-12-21', 'CI', 'Côte d’Ivoire', 'AFRO', '146', '21918', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19555, '2020-12-22', 'CI', 'Côte d’Ivoire', 'AFRO', '14', '21932', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19556, '2020-12-23', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '21932', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19557, '2020-12-24', 'CI', 'Côte d’Ivoire', 'AFRO', '52', '21984', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19558, '2020-12-25', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '21984', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19559, '2020-12-26', 'CI', 'Côte d’Ivoire', 'AFRO', '97', '22081', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19560, '2020-12-27', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '22081', '0', '133');
INSERT INTO public.who_global_data_import VALUES (19561, '2020-12-28', 'CI', 'Côte d’Ivoire', 'AFRO', '71', '22152', '2', '135');
INSERT INTO public.who_global_data_import VALUES (19562, '2020-12-29', 'CI', 'Côte d’Ivoire', 'AFRO', '24', '22176', '2', '137');
INSERT INTO public.who_global_data_import VALUES (19563, '2020-12-30', 'CI', 'Côte d’Ivoire', 'AFRO', '74', '22250', '0', '137');
INSERT INTO public.who_global_data_import VALUES (19564, '2020-12-31', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '22250', '0', '137');
INSERT INTO public.who_global_data_import VALUES (19565, '2021-01-01', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '22250', '0', '137');
INSERT INTO public.who_global_data_import VALUES (19566, '2021-01-02', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '22250', '0', '137');
INSERT INTO public.who_global_data_import VALUES (19567, '2021-01-03', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '22250', '0', '137');
INSERT INTO public.who_global_data_import VALUES (19568, '2021-01-04', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '22250', '0', '137');
INSERT INTO public.who_global_data_import VALUES (19569, '2021-01-05', 'CI', 'Côte d’Ivoire', 'AFRO', '398', '22648', '1', '138');
INSERT INTO public.who_global_data_import VALUES (19570, '2021-01-06', 'CI', 'Côte d’Ivoire', 'AFRO', '152', '22800', '0', '138');
INSERT INTO public.who_global_data_import VALUES (19571, '2021-01-07', 'CI', 'Côte d’Ivoire', 'AFRO', '55', '22855', '0', '138');
INSERT INTO public.who_global_data_import VALUES (19572, '2021-01-08', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '22855', '0', '138');
INSERT INTO public.who_global_data_import VALUES (19573, '2021-01-09', 'CI', 'Côte d’Ivoire', 'AFRO', '318', '23173', '0', '138');
INSERT INTO public.who_global_data_import VALUES (19574, '2021-01-10', 'CI', 'Côte d’Ivoire', 'AFRO', '81', '23254', '0', '138');
INSERT INTO public.who_global_data_import VALUES (19575, '2021-01-11', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '23254', '0', '138');
INSERT INTO public.who_global_data_import VALUES (19576, '2021-01-12', 'CI', 'Côte d’Ivoire', 'AFRO', '228', '23482', '1', '139');
INSERT INTO public.who_global_data_import VALUES (19577, '2021-01-13', 'CI', 'Côte d’Ivoire', 'AFRO', '412', '23894', '0', '139');
INSERT INTO public.who_global_data_import VALUES (19578, '2021-01-14', 'CI', 'Côte d’Ivoire', 'AFRO', '292', '24186', '1', '140');
INSERT INTO public.who_global_data_import VALUES (19579, '2021-01-15', 'CI', 'Côte d’Ivoire', 'AFRO', '183', '24369', '0', '140');
INSERT INTO public.who_global_data_import VALUES (19580, '2021-01-16', 'CI', 'Côte d’Ivoire', 'AFRO', '487', '24856', '1', '141');
INSERT INTO public.who_global_data_import VALUES (19581, '2021-01-17', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '24856', '0', '141');
INSERT INTO public.who_global_data_import VALUES (19582, '2021-01-18', 'CI', 'Côte d’Ivoire', 'AFRO', '385', '25241', '0', '141');
INSERT INTO public.who_global_data_import VALUES (19583, '2021-01-19', 'CI', 'Côte d’Ivoire', 'AFRO', '64', '25305', '1', '142');
INSERT INTO public.who_global_data_import VALUES (19584, '2021-01-20', 'CI', 'Côte d’Ivoire', 'AFRO', '78', '25383', '0', '142');
INSERT INTO public.who_global_data_import VALUES (19585, '2021-01-21', 'CI', 'Côte d’Ivoire', 'AFRO', '214', '25597', '0', '142');
INSERT INTO public.who_global_data_import VALUES (19586, '2021-01-22', 'CI', 'Côte d’Ivoire', 'AFRO', '154', '25751', '0', '142');
INSERT INTO public.who_global_data_import VALUES (19587, '2021-01-23', 'CI', 'Côte d’Ivoire', 'AFRO', '564', '26315', '1', '143');
INSERT INTO public.who_global_data_import VALUES (19588, '2021-01-24', 'CI', 'Côte d’Ivoire', 'AFRO', '297', '26612', '2', '145');
INSERT INTO public.who_global_data_import VALUES (19589, '2021-01-25', 'CI', 'Côte d’Ivoire', 'AFRO', '238', '26850', '1', '146');
INSERT INTO public.who_global_data_import VALUES (19590, '2021-01-26', 'CI', 'Côte d’Ivoire', 'AFRO', '0', '26850', '0', '146');
INSERT INTO public.who_global_data_import VALUES (19591, '2021-01-27', 'CI', 'Côte d’Ivoire', 'AFRO', '387', '27237', '1', '147');
INSERT INTO public.who_global_data_import VALUES (19592, '2021-01-28', 'CI', 'Côte d’Ivoire', 'AFRO', '219', '27456', '4', '151');
INSERT INTO public.who_global_data_import VALUES (19593, '2021-01-29', 'CI', 'Côte d’Ivoire', 'AFRO', '239', '27695', '0', '151');
INSERT INTO public.who_global_data_import VALUES (19594, '2021-01-30', 'CI', 'Côte d’Ivoire', 'AFRO', '240', '27935', '1', '152');
INSERT INTO public.who_global_data_import VALUES (19595, '2021-01-31', 'CI', 'Côte d’Ivoire', 'AFRO', '243', '28178', '0', '152');
INSERT INTO public.who_global_data_import VALUES (19596, '2021-02-01', 'CI', 'Côte d’Ivoire', 'AFRO', '221', '28399', '2', '154');
INSERT INTO public.who_global_data_import VALUES (19597, '2021-02-02', 'CI', 'Côte d’Ivoire', 'AFRO', '76', '28475', '2', '156');
INSERT INTO public.who_global_data_import VALUES (19598, '2021-02-03', 'CI', 'Côte d’Ivoire', 'AFRO', '132', '28607', '2', '158');
INSERT INTO public.who_global_data_import VALUES (19599, '2021-02-04', 'CI', 'Côte d’Ivoire', 'AFRO', '132', '28739', '0', '158');
INSERT INTO public.who_global_data_import VALUES (19600, '2021-02-05', 'CI', 'Côte d’Ivoire', 'AFRO', '363', '29102', '0', '158');
INSERT INTO public.who_global_data_import VALUES (19601, '2020-01-03', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19602, '2020-01-04', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19603, '2020-01-05', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19604, '2020-01-06', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19605, '2020-01-07', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19606, '2020-01-08', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19607, '2020-01-09', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19608, '2020-01-10', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19609, '2020-01-11', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19610, '2020-01-12', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19611, '2020-01-13', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19612, '2020-01-14', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19614, '2020-01-16', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19615, '2020-01-17', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19616, '2020-01-18', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19617, '2020-01-19', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19618, '2020-01-20', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19619, '2020-01-21', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19620, '2020-01-22', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19621, '2020-01-23', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19622, '2020-01-24', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19623, '2020-01-25', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19624, '2020-01-26', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19625, '2020-01-27', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19626, '2020-01-28', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19627, '2020-01-29', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19628, '2020-01-30', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19629, '2020-01-31', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19630, '2020-02-01', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19631, '2020-02-02', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19632, '2020-02-03', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19633, '2020-02-04', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19634, '2020-02-05', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19635, '2020-02-06', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19636, '2020-02-07', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19637, '2020-02-08', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19638, '2020-02-09', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19639, '2020-02-10', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19640, '2020-02-11', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19641, '2020-02-12', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19642, '2020-02-13', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19643, '2020-02-14', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19644, '2020-02-15', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19645, '2020-02-16', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19646, '2020-02-17', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19647, '2020-02-18', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19648, '2020-02-19', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19649, '2020-02-20', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19650, '2020-02-21', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19651, '2020-02-22', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19652, '2020-02-23', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19653, '2020-02-24', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19654, '2020-02-25', 'HR', 'Croatia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19655, '2020-02-26', 'HR', 'Croatia', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19656, '2020-02-27', 'HR', 'Croatia', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19657, '2020-02-28', 'HR', 'Croatia', 'EURO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19658, '2020-02-29', 'HR', 'Croatia', 'EURO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19659, '2020-03-01', 'HR', 'Croatia', 'EURO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19660, '2020-03-02', 'HR', 'Croatia', 'EURO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19661, '2020-03-03', 'HR', 'Croatia', 'EURO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19662, '2020-03-04', 'HR', 'Croatia', 'EURO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19663, '2020-03-05', 'HR', 'Croatia', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19664, '2020-03-06', 'HR', 'Croatia', 'EURO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19665, '2020-03-07', 'HR', 'Croatia', 'EURO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19666, '2020-03-08', 'HR', 'Croatia', 'EURO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19667, '2020-03-09', 'HR', 'Croatia', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19668, '2020-03-10', 'HR', 'Croatia', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19669, '2020-03-11', 'HR', 'Croatia', 'EURO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19670, '2020-03-12', 'HR', 'Croatia', 'EURO', '3', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19671, '2020-03-13', 'HR', 'Croatia', 'EURO', '9', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19672, '2020-03-14', 'HR', 'Croatia', 'EURO', '6', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19673, '2020-03-15', 'HR', 'Croatia', 'EURO', '6', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19674, '2020-03-16', 'HR', 'Croatia', 'EURO', '11', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19675, '2020-03-17', 'HR', 'Croatia', 'EURO', '8', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19676, '2020-03-18', 'HR', 'Croatia', 'EURO', '13', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19677, '2020-03-19', 'HR', 'Croatia', 'EURO', '12', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19678, '2020-03-20', 'HR', 'Croatia', 'EURO', '23', '104', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19679, '2020-03-21', 'HR', 'Croatia', 'EURO', '22', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19680, '2020-03-22', 'HR', 'Croatia', 'EURO', '80', '206', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19681, '2020-03-23', 'HR', 'Croatia', 'EURO', '29', '235', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19682, '2020-03-24', 'HR', 'Croatia', 'EURO', '71', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19683, '2020-03-25', 'HR', 'Croatia', 'EURO', '76', '382', '1', '1');
INSERT INTO public.who_global_data_import VALUES (19684, '2020-03-26', 'HR', 'Croatia', 'EURO', '36', '418', '0', '1');
INSERT INTO public.who_global_data_import VALUES (19685, '2020-03-27', 'HR', 'Croatia', 'EURO', '77', '495', '1', '2');
INSERT INTO public.who_global_data_import VALUES (19686, '2020-03-28', 'HR', 'Croatia', 'EURO', '91', '586', '1', '3');
INSERT INTO public.who_global_data_import VALUES (19687, '2020-03-29', 'HR', 'Croatia', 'EURO', '71', '657', '2', '5');
INSERT INTO public.who_global_data_import VALUES (19688, '2020-03-30', 'HR', 'Croatia', 'EURO', '56', '713', '1', '6');
INSERT INTO public.who_global_data_import VALUES (19689, '2020-03-31', 'HR', 'Croatia', 'EURO', '77', '790', '0', '6');
INSERT INTO public.who_global_data_import VALUES (19690, '2020-04-01', 'HR', 'Croatia', 'EURO', '77', '867', '0', '6');
INSERT INTO public.who_global_data_import VALUES (19691, '2020-04-02', 'HR', 'Croatia', 'EURO', '96', '963', '0', '6');
INSERT INTO public.who_global_data_import VALUES (19692, '2020-04-03', 'HR', 'Croatia', 'EURO', '48', '1011', '1', '7');
INSERT INTO public.who_global_data_import VALUES (19693, '2020-04-04', 'HR', 'Croatia', 'EURO', '68', '1079', '1', '8');
INSERT INTO public.who_global_data_import VALUES (19694, '2020-04-05', 'HR', 'Croatia', 'EURO', '47', '1126', '4', '12');
INSERT INTO public.who_global_data_import VALUES (19695, '2020-04-06', 'HR', 'Croatia', 'EURO', '56', '1182', '3', '15');
INSERT INTO public.who_global_data_import VALUES (19696, '2020-04-07', 'HR', 'Croatia', 'EURO', '40', '1222', '1', '16');
INSERT INTO public.who_global_data_import VALUES (19697, '2020-04-08', 'HR', 'Croatia', 'EURO', '60', '1282', '2', '18');
INSERT INTO public.who_global_data_import VALUES (19698, '2020-04-09', 'HR', 'Croatia', 'EURO', '61', '1343', '1', '19');
INSERT INTO public.who_global_data_import VALUES (19699, '2020-04-10', 'HR', 'Croatia', 'EURO', '64', '1407', '1', '20');
INSERT INTO public.who_global_data_import VALUES (19700, '2020-04-11', 'HR', 'Croatia', 'EURO', '88', '1495', '1', '21');
INSERT INTO public.who_global_data_import VALUES (19701, '2020-04-12', 'HR', 'Croatia', 'EURO', '39', '1534', '0', '21');
INSERT INTO public.who_global_data_import VALUES (19702, '2020-04-13', 'HR', 'Croatia', 'EURO', '66', '1600', '2', '23');
INSERT INTO public.who_global_data_import VALUES (19703, '2020-04-14', 'HR', 'Croatia', 'EURO', '50', '1650', '2', '25');
INSERT INTO public.who_global_data_import VALUES (19704, '2020-04-15', 'HR', 'Croatia', 'EURO', '54', '1704', '6', '31');
INSERT INTO public.who_global_data_import VALUES (19705, '2020-04-16', 'HR', 'Croatia', 'EURO', '37', '1741', '3', '34');
INSERT INTO public.who_global_data_import VALUES (19706, '2020-04-17', 'HR', 'Croatia', 'EURO', '50', '1791', '1', '35');
INSERT INTO public.who_global_data_import VALUES (19707, '2020-04-18', 'HR', 'Croatia', 'EURO', '23', '1814', '1', '36');
INSERT INTO public.who_global_data_import VALUES (19708, '2020-04-19', 'HR', 'Croatia', 'EURO', '18', '1832', '3', '39');
INSERT INTO public.who_global_data_import VALUES (19709, '2020-04-20', 'HR', 'Croatia', 'EURO', '39', '1871', '8', '47');
INSERT INTO public.who_global_data_import VALUES (19710, '2020-04-21', 'HR', 'Croatia', 'EURO', '10', '1881', '0', '47');
INSERT INTO public.who_global_data_import VALUES (19711, '2020-04-22', 'HR', 'Croatia', 'EURO', '27', '1908', '1', '48');
INSERT INTO public.who_global_data_import VALUES (19712, '2020-04-23', 'HR', 'Croatia', 'EURO', '42', '1950', '0', '48');
INSERT INTO public.who_global_data_import VALUES (19713, '2020-04-24', 'HR', 'Croatia', 'EURO', '31', '1981', '2', '50');
INSERT INTO public.who_global_data_import VALUES (19714, '2020-04-25', 'HR', 'Croatia', 'EURO', '28', '2009', '1', '51');
INSERT INTO public.who_global_data_import VALUES (19715, '2020-04-26', 'HR', 'Croatia', 'EURO', '7', '2016', '3', '54');
INSERT INTO public.who_global_data_import VALUES (19716, '2020-04-27', 'HR', 'Croatia', 'EURO', '14', '2030', '1', '55');
INSERT INTO public.who_global_data_import VALUES (19717, '2020-04-28', 'HR', 'Croatia', 'EURO', '9', '2039', '4', '59');
INSERT INTO public.who_global_data_import VALUES (19718, '2020-04-29', 'HR', 'Croatia', 'EURO', '8', '2047', '4', '63');
INSERT INTO public.who_global_data_import VALUES (19719, '2020-04-30', 'HR', 'Croatia', 'EURO', '15', '2062', '4', '67');
INSERT INTO public.who_global_data_import VALUES (19720, '2020-05-01', 'HR', 'Croatia', 'EURO', '14', '2076', '2', '69');
INSERT INTO public.who_global_data_import VALUES (19721, '2020-05-02', 'HR', 'Croatia', 'EURO', '9', '2085', '6', '75');
INSERT INTO public.who_global_data_import VALUES (19722, '2020-05-03', 'HR', 'Croatia', 'EURO', '3', '2088', '2', '77');
INSERT INTO public.who_global_data_import VALUES (19723, '2020-05-04', 'HR', 'Croatia', 'EURO', '8', '2096', '2', '79');
INSERT INTO public.who_global_data_import VALUES (19724, '2020-05-05', 'HR', 'Croatia', 'EURO', '5', '2101', '1', '80');
INSERT INTO public.who_global_data_import VALUES (19725, '2020-05-06', 'HR', 'Croatia', 'EURO', '11', '2112', '3', '83');
INSERT INTO public.who_global_data_import VALUES (19726, '2020-05-07', 'HR', 'Croatia', 'EURO', '7', '2119', '2', '85');
INSERT INTO public.who_global_data_import VALUES (20042, '2020-02-13', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (19727, '2020-05-08', 'HR', 'Croatia', 'EURO', '6', '2125', '1', '86');
INSERT INTO public.who_global_data_import VALUES (19728, '2020-05-09', 'HR', 'Croatia', 'EURO', '36', '2161', '0', '86');
INSERT INTO public.who_global_data_import VALUES (19729, '2020-05-10', 'HR', 'Croatia', 'EURO', '15', '2176', '1', '87');
INSERT INTO public.who_global_data_import VALUES (19730, '2020-05-11', 'HR', 'Croatia', 'EURO', '11', '2187', '3', '90');
INSERT INTO public.who_global_data_import VALUES (19731, '2020-05-12', 'HR', 'Croatia', 'EURO', '9', '2196', '1', '91');
INSERT INTO public.who_global_data_import VALUES (19732, '2020-05-13', 'HR', 'Croatia', 'EURO', '11', '2207', '0', '91');
INSERT INTO public.who_global_data_import VALUES (19733, '2020-05-14', 'HR', 'Croatia', 'EURO', '6', '2213', '3', '94');
INSERT INTO public.who_global_data_import VALUES (19734, '2020-05-15', 'HR', 'Croatia', 'EURO', '8', '2221', '0', '94');
INSERT INTO public.who_global_data_import VALUES (19735, '2020-05-16', 'HR', 'Croatia', 'EURO', '1', '2222', '1', '95');
INSERT INTO public.who_global_data_import VALUES (19736, '2020-05-17', 'HR', 'Croatia', 'EURO', '2', '2224', '0', '95');
INSERT INTO public.who_global_data_import VALUES (19737, '2020-05-18', 'HR', 'Croatia', 'EURO', '2', '2226', '0', '95');
INSERT INTO public.who_global_data_import VALUES (19738, '2020-05-19', 'HR', 'Croatia', 'EURO', '2', '2228', '0', '95');
INSERT INTO public.who_global_data_import VALUES (19739, '2020-05-20', 'HR', 'Croatia', 'EURO', '4', '2232', '1', '96');
INSERT INTO public.who_global_data_import VALUES (19740, '2020-05-21', 'HR', 'Croatia', 'EURO', '2', '2234', '0', '96');
INSERT INTO public.who_global_data_import VALUES (19741, '2020-05-22', 'HR', 'Croatia', 'EURO', '3', '2237', '1', '97');
INSERT INTO public.who_global_data_import VALUES (19742, '2020-05-23', 'HR', 'Croatia', 'EURO', '6', '2243', '2', '99');
INSERT INTO public.who_global_data_import VALUES (19743, '2020-05-24', 'HR', 'Croatia', 'EURO', '0', '2243', '0', '99');
INSERT INTO public.who_global_data_import VALUES (19744, '2020-05-25', 'HR', 'Croatia', 'EURO', '1', '2244', '0', '99');
INSERT INTO public.who_global_data_import VALUES (19745, '2020-05-26', 'HR', 'Croatia', 'EURO', '0', '2244', '1', '100');
INSERT INTO public.who_global_data_import VALUES (19746, '2020-05-27', 'HR', 'Croatia', 'EURO', '0', '2244', '1', '101');
INSERT INTO public.who_global_data_import VALUES (19747, '2020-05-28', 'HR', 'Croatia', 'EURO', '0', '2244', '0', '101');
INSERT INTO public.who_global_data_import VALUES (19748, '2020-05-29', 'HR', 'Croatia', 'EURO', '1', '2245', '1', '102');
INSERT INTO public.who_global_data_import VALUES (19749, '2020-05-30', 'HR', 'Croatia', 'EURO', '0', '2245', '1', '103');
INSERT INTO public.who_global_data_import VALUES (19750, '2020-05-31', 'HR', 'Croatia', 'EURO', '1', '2246', '0', '103');
INSERT INTO public.who_global_data_import VALUES (19751, '2020-06-01', 'HR', 'Croatia', 'EURO', '0', '2246', '0', '103');
INSERT INTO public.who_global_data_import VALUES (19752, '2020-06-02', 'HR', 'Croatia', 'EURO', '0', '2246', '0', '103');
INSERT INTO public.who_global_data_import VALUES (19753, '2020-06-03', 'HR', 'Croatia', 'EURO', '0', '2246', '0', '103');
INSERT INTO public.who_global_data_import VALUES (19754, '2020-06-04', 'HR', 'Croatia', 'EURO', '0', '2246', '0', '103');
INSERT INTO public.who_global_data_import VALUES (19755, '2020-06-05', 'HR', 'Croatia', 'EURO', '1', '2247', '0', '103');
INSERT INTO public.who_global_data_import VALUES (19756, '2020-06-06', 'HR', 'Croatia', 'EURO', '0', '2247', '0', '103');
INSERT INTO public.who_global_data_import VALUES (19757, '2020-06-07', 'HR', 'Croatia', 'EURO', '0', '2247', '1', '104');
INSERT INTO public.who_global_data_import VALUES (19758, '2020-06-08', 'HR', 'Croatia', 'EURO', '0', '2247', '0', '104');
INSERT INTO public.who_global_data_import VALUES (19759, '2020-06-09', 'HR', 'Croatia', 'EURO', '0', '2247', '0', '104');
INSERT INTO public.who_global_data_import VALUES (19760, '2020-06-10', 'HR', 'Croatia', 'EURO', '0', '2247', '2', '106');
INSERT INTO public.who_global_data_import VALUES (19761, '2020-06-11', 'HR', 'Croatia', 'EURO', '2', '2249', '0', '106');
INSERT INTO public.who_global_data_import VALUES (19762, '2020-06-12', 'HR', 'Croatia', 'EURO', '0', '2249', '0', '106');
INSERT INTO public.who_global_data_import VALUES (19763, '2020-06-13', 'HR', 'Croatia', 'EURO', '0', '2249', '1', '107');
INSERT INTO public.who_global_data_import VALUES (19764, '2020-06-14', 'HR', 'Croatia', 'EURO', '2', '2251', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19765, '2020-06-15', 'HR', 'Croatia', 'EURO', '1', '2252', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19766, '2020-06-16', 'HR', 'Croatia', 'EURO', '2', '2254', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19767, '2020-06-17', 'HR', 'Croatia', 'EURO', '1', '2255', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19768, '2020-06-18', 'HR', 'Croatia', 'EURO', '3', '2258', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19769, '2020-06-19', 'HR', 'Croatia', 'EURO', '11', '2269', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19770, '2020-06-20', 'HR', 'Croatia', 'EURO', '11', '2280', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19771, '2020-06-21', 'HR', 'Croatia', 'EURO', '19', '2299', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19772, '2020-06-22', 'HR', 'Croatia', 'EURO', '18', '2317', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19773, '2020-06-23', 'HR', 'Croatia', 'EURO', '19', '2336', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19774, '2020-06-24', 'HR', 'Croatia', 'EURO', '30', '2366', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19775, '2020-06-25', 'HR', 'Croatia', 'EURO', '22', '2388', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19776, '2020-06-26', 'HR', 'Croatia', 'EURO', '95', '2483', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19777, '2020-06-27', 'HR', 'Croatia', 'EURO', '56', '2539', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19778, '2020-06-28', 'HR', 'Croatia', 'EURO', '85', '2624', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19779, '2020-06-29', 'HR', 'Croatia', 'EURO', '67', '2691', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19780, '2020-06-30', 'HR', 'Croatia', 'EURO', '34', '2725', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19781, '2020-07-01', 'HR', 'Croatia', 'EURO', '52', '2777', '0', '107');
INSERT INTO public.who_global_data_import VALUES (19782, '2020-07-02', 'HR', 'Croatia', 'EURO', '54', '2831', '1', '108');
INSERT INTO public.who_global_data_import VALUES (19783, '2020-07-03', 'HR', 'Croatia', 'EURO', '81', '2912', '2', '110');
INSERT INTO public.who_global_data_import VALUES (19784, '2020-07-04', 'HR', 'Croatia', 'EURO', '96', '3008', '2', '112');
INSERT INTO public.who_global_data_import VALUES (19785, '2020-07-05', 'HR', 'Croatia', 'EURO', '86', '3094', '1', '113');
INSERT INTO public.who_global_data_import VALUES (19786, '2020-07-06', 'HR', 'Croatia', 'EURO', '57', '3151', '0', '113');
INSERT INTO public.who_global_data_import VALUES (19787, '2020-07-07', 'HR', 'Croatia', 'EURO', '69', '3220', '0', '113');
INSERT INTO public.who_global_data_import VALUES (19788, '2020-07-08', 'HR', 'Croatia', 'EURO', '52', '3272', '0', '113');
INSERT INTO public.who_global_data_import VALUES (19789, '2020-07-09', 'HR', 'Croatia', 'EURO', '53', '3325', '1', '114');
INSERT INTO public.who_global_data_import VALUES (19790, '2020-07-10', 'HR', 'Croatia', 'EURO', '91', '3416', '1', '115');
INSERT INTO public.who_global_data_import VALUES (19791, '2020-07-11', 'HR', 'Croatia', 'EURO', '116', '3532', '2', '117');
INSERT INTO public.who_global_data_import VALUES (19792, '2020-07-12', 'HR', 'Croatia', 'EURO', '140', '3672', '1', '118');
INSERT INTO public.who_global_data_import VALUES (19793, '2020-07-13', 'HR', 'Croatia', 'EURO', '50', '3722', '1', '119');
INSERT INTO public.who_global_data_import VALUES (19794, '2020-07-14', 'HR', 'Croatia', 'EURO', '53', '3775', '0', '119');
INSERT INTO public.who_global_data_import VALUES (19795, '2020-07-15', 'HR', 'Croatia', 'EURO', '52', '3827', '0', '119');
INSERT INTO public.who_global_data_import VALUES (19796, '2020-07-16', 'HR', 'Croatia', 'EURO', '126', '3953', '0', '119');
INSERT INTO public.who_global_data_import VALUES (19797, '2020-07-17', 'HR', 'Croatia', 'EURO', '86', '4039', '0', '119');
INSERT INTO public.who_global_data_import VALUES (19798, '2020-07-18', 'HR', 'Croatia', 'EURO', '98', '4137', '1', '120');
INSERT INTO public.who_global_data_import VALUES (19799, '2020-07-19', 'HR', 'Croatia', 'EURO', '98', '4235', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19800, '2020-07-20', 'HR', 'Croatia', 'EURO', '119', '4354', '0', '120');
INSERT INTO public.who_global_data_import VALUES (19801, '2020-07-21', 'HR', 'Croatia', 'EURO', '16', '4370', '2', '122');
INSERT INTO public.who_global_data_import VALUES (19802, '2020-07-22', 'HR', 'Croatia', 'EURO', '52', '4422', '0', '122');
INSERT INTO public.who_global_data_import VALUES (19803, '2020-07-23', 'HR', 'Croatia', 'EURO', '108', '4530', '3', '125');
INSERT INTO public.who_global_data_import VALUES (19804, '2020-07-24', 'HR', 'Croatia', 'EURO', '104', '4634', '3', '128');
INSERT INTO public.who_global_data_import VALUES (19805, '2020-07-25', 'HR', 'Croatia', 'EURO', '81', '4715', '0', '128');
INSERT INTO public.who_global_data_import VALUES (19806, '2020-07-26', 'HR', 'Croatia', 'EURO', '77', '4792', '5', '133');
INSERT INTO public.who_global_data_import VALUES (19807, '2020-07-27', 'HR', 'Croatia', 'EURO', '65', '4857', '3', '136');
INSERT INTO public.who_global_data_import VALUES (19808, '2020-07-28', 'HR', 'Croatia', 'EURO', '24', '4881', '3', '139');
INSERT INTO public.who_global_data_import VALUES (19809, '2020-07-29', 'HR', 'Croatia', 'EURO', '42', '4923', '1', '140');
INSERT INTO public.who_global_data_import VALUES (19810, '2020-07-30', 'HR', 'Croatia', 'EURO', '70', '4993', '1', '141');
INSERT INTO public.who_global_data_import VALUES (19811, '2020-07-31', 'HR', 'Croatia', 'EURO', '78', '5071', '3', '144');
INSERT INTO public.who_global_data_import VALUES (19812, '2020-08-01', 'HR', 'Croatia', 'EURO', '67', '5138', '1', '145');
INSERT INTO public.who_global_data_import VALUES (19813, '2020-08-02', 'HR', 'Croatia', 'EURO', '86', '5224', '0', '145');
INSERT INTO public.who_global_data_import VALUES (19814, '2020-08-03', 'HR', 'Croatia', 'EURO', '36', '5260', '4', '149');
INSERT INTO public.who_global_data_import VALUES (19815, '2020-08-04', 'HR', 'Croatia', 'EURO', '36', '5296', '4', '153');
INSERT INTO public.who_global_data_import VALUES (19816, '2020-08-05', 'HR', 'Croatia', 'EURO', '22', '5318', '1', '154');
INSERT INTO public.who_global_data_import VALUES (19817, '2020-08-06', 'HR', 'Croatia', 'EURO', '58', '5376', '0', '154');
INSERT INTO public.who_global_data_import VALUES (19818, '2020-08-07', 'HR', 'Croatia', 'EURO', '28', '5404', '1', '155');
INSERT INTO public.who_global_data_import VALUES (19819, '2020-08-08', 'HR', 'Croatia', 'EURO', '62', '5466', '0', '155');
INSERT INTO public.who_global_data_import VALUES (19820, '2020-08-09', 'HR', 'Croatia', 'EURO', '77', '5543', '2', '157');
INSERT INTO public.who_global_data_import VALUES (19821, '2020-08-10', 'HR', 'Croatia', 'EURO', '61', '5604', '0', '157');
INSERT INTO public.who_global_data_import VALUES (19822, '2020-08-11', 'HR', 'Croatia', 'EURO', '45', '5649', '1', '158');
INSERT INTO public.who_global_data_import VALUES (19823, '2020-08-12', 'HR', 'Croatia', 'EURO', '91', '5740', '2', '160');
INSERT INTO public.who_global_data_import VALUES (19824, '2020-08-13', 'HR', 'Croatia', 'EURO', '130', '5870', '0', '160');
INSERT INTO public.who_global_data_import VALUES (19825, '2020-08-14', 'HR', 'Croatia', 'EURO', '180', '6050', '1', '161');
INSERT INTO public.who_global_data_import VALUES (19826, '2020-08-15', 'HR', 'Croatia', 'EURO', '208', '6258', '2', '163');
INSERT INTO public.who_global_data_import VALUES (19827, '2020-08-16', 'HR', 'Croatia', 'EURO', '162', '6420', '2', '165');
INSERT INTO public.who_global_data_import VALUES (19828, '2020-08-17', 'HR', 'Croatia', 'EURO', '151', '6571', '1', '166');
INSERT INTO public.who_global_data_import VALUES (19829, '2020-08-18', 'HR', 'Croatia', 'EURO', '85', '6656', '0', '166');
INSERT INTO public.who_global_data_import VALUES (19830, '2020-08-19', 'HR', 'Croatia', 'EURO', '199', '6855', '0', '166');
INSERT INTO public.who_global_data_import VALUES (19831, '2020-08-20', 'HR', 'Croatia', 'EURO', '219', '7074', '2', '168');
INSERT INTO public.who_global_data_import VALUES (19832, '2020-08-21', 'HR', 'Croatia', 'EURO', '255', '7329', '0', '168');
INSERT INTO public.who_global_data_import VALUES (19833, '2020-08-22', 'HR', 'Croatia', 'EURO', '265', '7594', '1', '169');
INSERT INTO public.who_global_data_import VALUES (19834, '2020-08-23', 'HR', 'Croatia', 'EURO', '306', '7900', '1', '170');
INSERT INTO public.who_global_data_import VALUES (19835, '2020-08-24', 'HR', 'Croatia', 'EURO', '275', '8175', '1', '171');
INSERT INTO public.who_global_data_import VALUES (19836, '2020-08-25', 'HR', 'Croatia', 'EURO', '136', '8311', '2', '173');
INSERT INTO public.who_global_data_import VALUES (19837, '2020-08-26', 'HR', 'Croatia', 'EURO', '219', '8530', '2', '175');
INSERT INTO public.who_global_data_import VALUES (19838, '2020-08-27', 'HR', 'Croatia', 'EURO', '358', '8888', '0', '175');
INSERT INTO public.who_global_data_import VALUES (19839, '2020-08-28', 'HR', 'Croatia', 'EURO', '304', '9192', '2', '177');
INSERT INTO public.who_global_data_import VALUES (19840, '2020-08-29', 'HR', 'Croatia', 'EURO', '357', '9549', '3', '180');
INSERT INTO public.who_global_data_import VALUES (19841, '2020-08-30', 'HR', 'Croatia', 'EURO', '312', '9861', '3', '183');
INSERT INTO public.who_global_data_import VALUES (19842, '2020-08-31', 'HR', 'Croatia', 'EURO', '262', '10123', '1', '184');
INSERT INTO public.who_global_data_import VALUES (19843, '2020-09-01', 'HR', 'Croatia', 'EURO', '146', '10269', '2', '186');
INSERT INTO public.who_global_data_import VALUES (19844, '2020-09-02', 'HR', 'Croatia', 'EURO', '145', '10414', '1', '187');
INSERT INTO public.who_global_data_import VALUES (19845, '2020-09-03', 'HR', 'Croatia', 'EURO', '311', '10725', '4', '191');
INSERT INTO public.who_global_data_import VALUES (19846, '2020-09-04', 'HR', 'Croatia', 'EURO', '369', '11094', '3', '194');
INSERT INTO public.who_global_data_import VALUES (19847, '2020-09-05', 'HR', 'Croatia', 'EURO', '334', '11428', '1', '195');
INSERT INTO public.who_global_data_import VALUES (19848, '2020-09-06', 'HR', 'Croatia', 'EURO', '311', '11739', '2', '197');
INSERT INTO public.who_global_data_import VALUES (19849, '2020-09-07', 'HR', 'Croatia', 'EURO', '225', '11964', '1', '198');
INSERT INTO public.who_global_data_import VALUES (19850, '2020-09-08', 'HR', 'Croatia', 'EURO', '117', '12081', '3', '201');
INSERT INTO public.who_global_data_import VALUES (19851, '2020-09-09', 'HR', 'Croatia', 'EURO', '204', '12285', '2', '203');
INSERT INTO public.who_global_data_import VALUES (19852, '2020-09-10', 'HR', 'Croatia', 'EURO', '341', '12626', '3', '206');
INSERT INTO public.who_global_data_import VALUES (19853, '2020-09-11', 'HR', 'Croatia', 'EURO', '291', '12917', '2', '208');
INSERT INTO public.who_global_data_import VALUES (19854, '2020-09-12', 'HR', 'Croatia', 'EURO', '190', '13107', '3', '211');
INSERT INTO public.who_global_data_import VALUES (19855, '2020-09-13', 'HR', 'Croatia', 'EURO', '261', '13368', '7', '218');
INSERT INTO public.who_global_data_import VALUES (19856, '2020-09-14', 'HR', 'Croatia', 'EURO', '165', '13533', '6', '224');
INSERT INTO public.who_global_data_import VALUES (19857, '2020-09-15', 'HR', 'Croatia', 'EURO', '65', '13598', '3', '227');
INSERT INTO public.who_global_data_import VALUES (19858, '2020-09-16', 'HR', 'Croatia', 'EURO', '151', '13749', '3', '230');
INSERT INTO public.who_global_data_import VALUES (19859, '2020-09-17', 'HR', 'Croatia', 'EURO', '280', '14029', '6', '236');
INSERT INTO public.who_global_data_import VALUES (19860, '2020-09-18', 'HR', 'Croatia', 'EURO', '250', '14279', '2', '238');
INSERT INTO public.who_global_data_import VALUES (19861, '2020-09-19', 'HR', 'Croatia', 'EURO', '234', '14513', '6', '244');
INSERT INTO public.who_global_data_import VALUES (19862, '2020-09-20', 'HR', 'Croatia', 'EURO', '212', '14725', '0', '244');
INSERT INTO public.who_global_data_import VALUES (19863, '2020-09-21', 'HR', 'Croatia', 'EURO', '197', '14922', '4', '248');
INSERT INTO public.who_global_data_import VALUES (19864, '2020-09-22', 'HR', 'Croatia', 'EURO', '70', '14992', '5', '253');
INSERT INTO public.who_global_data_import VALUES (19865, '2020-09-23', 'HR', 'Croatia', 'EURO', '144', '15136', '2', '255');
INSERT INTO public.who_global_data_import VALUES (19866, '2020-09-24', 'HR', 'Croatia', 'EURO', '204', '15340', '2', '257');
INSERT INTO public.who_global_data_import VALUES (19867, '2020-09-25', 'HR', 'Croatia', 'EURO', '232', '15572', '4', '261');
INSERT INTO public.who_global_data_import VALUES (19868, '2020-09-26', 'HR', 'Croatia', 'EURO', '223', '15795', '5', '266');
INSERT INTO public.who_global_data_import VALUES (19869, '2020-09-27', 'HR', 'Croatia', 'EURO', '212', '16007', '3', '269');
INSERT INTO public.who_global_data_import VALUES (19870, '2020-09-28', 'HR', 'Croatia', 'EURO', '190', '16197', '3', '272');
INSERT INTO public.who_global_data_import VALUES (19871, '2020-09-29', 'HR', 'Croatia', 'EURO', '48', '16245', '0', '272');
INSERT INTO public.who_global_data_import VALUES (19872, '2020-09-30', 'HR', 'Croatia', 'EURO', '135', '16380', '3', '275');
INSERT INTO public.who_global_data_import VALUES (19873, '2020-10-01', 'HR', 'Croatia', 'EURO', '213', '16593', '5', '280');
INSERT INTO public.who_global_data_import VALUES (19874, '2020-10-02', 'HR', 'Croatia', 'EURO', '234', '16827', '4', '284');
INSERT INTO public.who_global_data_import VALUES (19875, '2020-10-03', 'HR', 'Croatia', 'EURO', '333', '17160', '7', '291');
INSERT INTO public.who_global_data_import VALUES (19876, '2020-10-04', 'HR', 'Croatia', 'EURO', '241', '17401', '2', '293');
INSERT INTO public.who_global_data_import VALUES (19877, '2020-10-05', 'HR', 'Croatia', 'EURO', '258', '17659', '5', '298');
INSERT INTO public.who_global_data_import VALUES (19878, '2020-10-06', 'HR', 'Croatia', 'EURO', '138', '17797', '2', '300');
INSERT INTO public.who_global_data_import VALUES (19879, '2020-10-07', 'HR', 'Croatia', 'EURO', '287', '18084', '4', '304');
INSERT INTO public.who_global_data_import VALUES (19880, '2020-10-08', 'HR', 'Croatia', 'EURO', '363', '18447', '5', '309');
INSERT INTO public.who_global_data_import VALUES (19881, '2020-10-09', 'HR', 'Croatia', 'EURO', '542', '18989', '1', '310');
INSERT INTO public.who_global_data_import VALUES (19882, '2020-10-10', 'HR', 'Croatia', 'EURO', '457', '19446', '3', '313');
INSERT INTO public.who_global_data_import VALUES (19883, '2020-10-11', 'HR', 'Croatia', 'EURO', '486', '19932', '4', '317');
INSERT INTO public.who_global_data_import VALUES (19884, '2020-10-12', 'HR', 'Croatia', 'EURO', '508', '20440', '7', '324');
INSERT INTO public.who_global_data_import VALUES (19885, '2020-10-13', 'HR', 'Croatia', 'EURO', '181', '20621', '3', '327');
INSERT INTO public.who_global_data_import VALUES (19886, '2020-10-14', 'HR', 'Croatia', 'EURO', '372', '20993', '3', '330');
INSERT INTO public.who_global_data_import VALUES (19887, '2020-10-15', 'HR', 'Croatia', 'EURO', '748', '21741', '4', '334');
INSERT INTO public.who_global_data_import VALUES (19888, '2020-10-16', 'HR', 'Croatia', 'EURO', '793', '22534', '10', '344');
INSERT INTO public.who_global_data_import VALUES (19889, '2020-10-17', 'HR', 'Croatia', 'EURO', '1131', '23665', '1', '345');
INSERT INTO public.who_global_data_import VALUES (19890, '2020-10-18', 'HR', 'Croatia', 'EURO', '1096', '24761', '10', '355');
INSERT INTO public.who_global_data_import VALUES (19891, '2020-10-19', 'HR', 'Croatia', 'EURO', '819', '25580', '8', '363');
INSERT INTO public.who_global_data_import VALUES (19892, '2020-10-20', 'HR', 'Croatia', 'EURO', '393', '25973', '11', '374');
INSERT INTO public.who_global_data_import VALUES (19893, '2020-10-21', 'HR', 'Croatia', 'EURO', '890', '26863', '8', '382');
INSERT INTO public.who_global_data_import VALUES (19894, '2020-10-22', 'HR', 'Croatia', 'EURO', '1424', '28287', '11', '393');
INSERT INTO public.who_global_data_import VALUES (19895, '2020-10-23', 'HR', 'Croatia', 'EURO', '1563', '29850', '13', '406');
INSERT INTO public.who_global_data_import VALUES (19896, '2020-10-24', 'HR', 'Croatia', 'EURO', '1867', '31717', '7', '413');
INSERT INTO public.who_global_data_import VALUES (19897, '2020-10-25', 'HR', 'Croatia', 'EURO', '2242', '33959', '16', '429');
INSERT INTO public.who_global_data_import VALUES (19898, '2020-10-26', 'HR', 'Croatia', 'EURO', '2421', '36380', '8', '437');
INSERT INTO public.who_global_data_import VALUES (19899, '2020-10-27', 'HR', 'Croatia', 'EURO', '828', '37208', '15', '452');
INSERT INTO public.who_global_data_import VALUES (19900, '2020-10-28', 'HR', 'Croatia', 'EURO', '1413', '38621', '18', '470');
INSERT INTO public.who_global_data_import VALUES (19901, '2020-10-29', 'HR', 'Croatia', 'EURO', '2378', '40999', '23', '493');
INSERT INTO public.who_global_data_import VALUES (19902, '2020-10-30', 'HR', 'Croatia', 'EURO', '2776', '43775', '18', '511');
INSERT INTO public.who_global_data_import VALUES (19903, '2020-10-31', 'HR', 'Croatia', 'EURO', '2772', '46547', '20', '531');
INSERT INTO public.who_global_data_import VALUES (19904, '2020-11-01', 'HR', 'Croatia', 'EURO', '2769', '49316', '15', '546');
INSERT INTO public.who_global_data_import VALUES (19905, '2020-11-02', 'HR', 'Croatia', 'EURO', '2179', '51495', '16', '562');
INSERT INTO public.who_global_data_import VALUES (19906, '2020-11-03', 'HR', 'Croatia', 'EURO', '1165', '52660', '32', '594');
INSERT INTO public.who_global_data_import VALUES (19907, '2020-11-04', 'HR', 'Croatia', 'EURO', '1427', '54087', '34', '628');
INSERT INTO public.who_global_data_import VALUES (19908, '2020-11-05', 'HR', 'Croatia', 'EURO', '2480', '56567', '26', '654');
INSERT INTO public.who_global_data_import VALUES (19909, '2020-11-06', 'HR', 'Croatia', 'EURO', '2848', '59415', '29', '683');
INSERT INTO public.who_global_data_import VALUES (19910, '2020-11-07', 'HR', 'Croatia', 'EURO', '2890', '62305', '34', '717');
INSERT INTO public.who_global_data_import VALUES (19911, '2020-11-08', 'HR', 'Croatia', 'EURO', '2399', '64704', '35', '752');
INSERT INTO public.who_global_data_import VALUES (19912, '2020-11-09', 'HR', 'Croatia', 'EURO', '2543', '67247', '42', '794');
INSERT INTO public.who_global_data_import VALUES (19913, '2020-11-10', 'HR', 'Croatia', 'EURO', '1529', '68776', '38', '832');
INSERT INTO public.who_global_data_import VALUES (19914, '2020-11-11', 'HR', 'Croatia', 'EURO', '1467', '70243', '33', '865');
INSERT INTO public.who_global_data_import VALUES (19915, '2020-11-12', 'HR', 'Croatia', 'EURO', '2597', '72840', '28', '893');
INSERT INTO public.who_global_data_import VALUES (19916, '2020-11-13', 'HR', 'Croatia', 'EURO', '3082', '75922', '32', '925');
INSERT INTO public.who_global_data_import VALUES (19917, '2020-11-14', 'HR', 'Croatia', 'EURO', '3056', '78978', '43', '968');
INSERT INTO public.who_global_data_import VALUES (19918, '2020-11-15', 'HR', 'Croatia', 'EURO', '2866', '81844', '38', '1006');
INSERT INTO public.who_global_data_import VALUES (19919, '2020-11-16', 'HR', 'Croatia', 'EURO', '2362', '84206', '43', '1049');
INSERT INTO public.who_global_data_import VALUES (19920, '2020-11-17', 'HR', 'Croatia', 'EURO', '1313', '85519', '33', '1082');
INSERT INTO public.who_global_data_import VALUES (19921, '2020-11-18', 'HR', 'Croatia', 'EURO', '1945', '87464', '31', '1113');
INSERT INTO public.who_global_data_import VALUES (19922, '2020-11-19', 'HR', 'Croatia', 'EURO', '3251', '90715', '38', '1151');
INSERT INTO public.who_global_data_import VALUES (19923, '2020-11-20', 'HR', 'Croatia', 'EURO', '3164', '93879', '49', '1200');
INSERT INTO public.who_global_data_import VALUES (19924, '2020-11-21', 'HR', 'Croatia', 'EURO', '2958', '96837', '57', '1257');
INSERT INTO public.who_global_data_import VALUES (19925, '2020-11-22', 'HR', 'Croatia', 'EURO', '3573', '100410', '47', '1304');
INSERT INTO public.who_global_data_import VALUES (19926, '2020-11-23', 'HR', 'Croatia', 'EURO', '3308', '103718', '49', '1353');
INSERT INTO public.who_global_data_import VALUES (19927, '2020-11-24', 'HR', 'Croatia', 'EURO', '1973', '105691', '45', '1398');
INSERT INTO public.who_global_data_import VALUES (19928, '2020-11-25', 'HR', 'Croatia', 'EURO', '2323', '108014', '47', '1445');
INSERT INTO public.who_global_data_import VALUES (19929, '2020-11-26', 'HR', 'Croatia', 'EURO', '3603', '111617', '56', '1501');
INSERT INTO public.who_global_data_import VALUES (19930, '2020-11-27', 'HR', 'Croatia', 'EURO', '4009', '115626', '51', '1552');
INSERT INTO public.who_global_data_import VALUES (19931, '2020-11-28', 'HR', 'Croatia', 'EURO', '4080', '119706', '48', '1600');
INSERT INTO public.who_global_data_import VALUES (19932, '2020-11-29', 'HR', 'Croatia', 'EURO', '3987', '123693', '55', '1655');
INSERT INTO public.who_global_data_import VALUES (19933, '2020-11-30', 'HR', 'Croatia', 'EURO', '2919', '126612', '57', '1712');
INSERT INTO public.who_global_data_import VALUES (19934, '2020-12-01', 'HR', 'Croatia', 'EURO', '1830', '128442', '74', '1786');
INSERT INTO public.who_global_data_import VALUES (19935, '2020-12-02', 'HR', 'Croatia', 'EURO', '2900', '131342', '75', '1861');
INSERT INTO public.who_global_data_import VALUES (19936, '2020-12-03', 'HR', 'Croatia', 'EURO', '3539', '134881', '55', '1916');
INSERT INTO public.who_global_data_import VALUES (19937, '2020-12-04', 'HR', 'Croatia', 'EURO', '4534', '139415', '48', '1964');
INSERT INTO public.who_global_data_import VALUES (19938, '2020-12-05', 'HR', 'Croatia', 'EURO', '3955', '143370', '68', '2032');
INSERT INTO public.who_global_data_import VALUES (19939, '2020-12-06', 'HR', 'Croatia', 'EURO', '4084', '147454', '70', '2102');
INSERT INTO public.who_global_data_import VALUES (19940, '2020-12-07', 'HR', 'Croatia', 'EURO', '2899', '150353', '72', '2174');
INSERT INTO public.who_global_data_import VALUES (19941, '2020-12-08', 'HR', 'Croatia', 'EURO', '1886', '152239', '59', '2233');
INSERT INTO public.who_global_data_import VALUES (19942, '2020-12-09', 'HR', 'Croatia', 'EURO', '2613', '154852', '65', '2298');
INSERT INTO public.who_global_data_import VALUES (19943, '2020-12-10', 'HR', 'Croatia', 'EURO', '4520', '159372', '69', '2367');
INSERT INTO public.who_global_data_import VALUES (19944, '2020-12-11', 'HR', 'Croatia', 'EURO', '4620', '163992', '53', '2420');
INSERT INTO public.who_global_data_import VALUES (19945, '2020-12-12', 'HR', 'Croatia', 'EURO', '4396', '168388', '64', '2484');
INSERT INTO public.who_global_data_import VALUES (19946, '2020-12-13', 'HR', 'Croatia', 'EURO', '4135', '172523', '78', '2562');
INSERT INTO public.who_global_data_import VALUES (19947, '2020-12-14', 'HR', 'Croatia', 'EURO', '3363', '175886', '78', '2640');
INSERT INTO public.who_global_data_import VALUES (19948, '2020-12-15', 'HR', 'Croatia', 'EURO', '1472', '177358', '65', '2705');
INSERT INTO public.who_global_data_import VALUES (19949, '2020-12-16', 'HR', 'Croatia', 'EURO', '2360', '179718', '73', '2778');
INSERT INTO public.who_global_data_import VALUES (19950, '2020-12-17', 'HR', 'Croatia', 'EURO', '3327', '183045', '92', '2870');
INSERT INTO public.who_global_data_import VALUES (19951, '2020-12-18', 'HR', 'Croatia', 'EURO', '3918', '186963', '85', '2955');
INSERT INTO public.who_global_data_import VALUES (19952, '2020-12-19', 'HR', 'Croatia', 'EURO', '3272', '190235', '68', '3023');
INSERT INTO public.who_global_data_import VALUES (19953, '2020-12-20', 'HR', 'Croatia', 'EURO', '4727', '194962', '154', '3177');
INSERT INTO public.who_global_data_import VALUES (19954, '2020-12-21', 'HR', 'Croatia', 'EURO', '766', '195728', '80', '3257');
INSERT INTO public.who_global_data_import VALUES (19955, '2020-12-22', 'HR', 'Croatia', 'EURO', '1595', '197323', '71', '3328');
INSERT INTO public.who_global_data_import VALUES (19956, '2020-12-23', 'HR', 'Croatia', 'EURO', '2763', '200086', '66', '3394');
INSERT INTO public.who_global_data_import VALUES (19957, '2020-12-24', 'HR', 'Croatia', 'EURO', '2233', '202319', '70', '3464');
INSERT INTO public.who_global_data_import VALUES (19958, '2020-12-25', 'HR', 'Croatia', 'EURO', '1643', '203962', '84', '3548');
INSERT INTO public.who_global_data_import VALUES (19959, '2020-12-26', 'HR', 'Croatia', 'EURO', '350', '204312', '65', '3613');
INSERT INTO public.who_global_data_import VALUES (19960, '2020-12-27', 'HR', 'Croatia', 'EURO', '618', '204930', '58', '3671');
INSERT INTO public.who_global_data_import VALUES (19961, '2020-12-28', 'HR', 'Croatia', 'EURO', '316', '205246', '68', '3739');
INSERT INTO public.who_global_data_import VALUES (19962, '2020-12-29', 'HR', 'Croatia', 'EURO', '1350', '206596', '56', '3795');
INSERT INTO public.who_global_data_import VALUES (19963, '2020-12-30', 'HR', 'Croatia', 'EURO', '1850', '208446', '65', '3860');
INSERT INTO public.who_global_data_import VALUES (19964, '2020-12-31', 'HR', 'Croatia', 'EURO', '2391', '210837', '60', '3920');
INSERT INTO public.who_global_data_import VALUES (19965, '2021-01-01', 'HR', 'Croatia', 'EURO', '1170', '212007', '41', '3961');
INSERT INTO public.who_global_data_import VALUES (19966, '2021-01-02', 'HR', 'Croatia', 'EURO', '255', '212262', '55', '4016');
INSERT INTO public.who_global_data_import VALUES (19967, '2021-01-03', 'HR', 'Croatia', 'EURO', '696', '212958', '56', '4072');
INSERT INTO public.who_global_data_import VALUES (19968, '2021-01-04', 'HR', 'Croatia', 'EURO', '361', '213319', '54', '4126');
INSERT INTO public.who_global_data_import VALUES (19969, '2021-01-05', 'HR', 'Croatia', 'EURO', '1071', '214390', '53', '4179');
INSERT INTO public.who_global_data_import VALUES (19970, '2021-01-06', 'HR', 'Croatia', 'EURO', '1896', '216286', '44', '4223');
INSERT INTO public.who_global_data_import VALUES (19971, '2021-01-07', 'HR', 'Croatia', 'EURO', '562', '216848', '43', '4266');
INSERT INTO public.who_global_data_import VALUES (19972, '2021-01-08', 'HR', 'Croatia', 'EURO', '1098', '217946', '38', '4304');
INSERT INTO public.who_global_data_import VALUES (19973, '2021-01-09', 'HR', 'Croatia', 'EURO', '1401', '219347', '38', '4342');
INSERT INTO public.who_global_data_import VALUES (19974, '2021-01-10', 'HR', 'Croatia', 'EURO', '646', '219993', '26', '4368');
INSERT INTO public.who_global_data_import VALUES (19975, '2021-01-11', 'HR', 'Croatia', 'EURO', '230', '220223', '35', '4403');
INSERT INTO public.who_global_data_import VALUES (19976, '2021-01-12', 'HR', 'Croatia', 'EURO', '759', '220982', '43', '4446');
INSERT INTO public.who_global_data_import VALUES (19977, '2021-01-13', 'HR', 'Croatia', 'EURO', '1135', '222117', '26', '4472');
INSERT INTO public.who_global_data_import VALUES (19978, '2021-01-14', 'HR', 'Croatia', 'EURO', '980', '223097', '45', '4517');
INSERT INTO public.who_global_data_import VALUES (19979, '2021-01-15', 'HR', 'Croatia', 'EURO', '715', '223812', '33', '4550');
INSERT INTO public.who_global_data_import VALUES (19980, '2021-01-16', 'HR', 'Croatia', 'EURO', '763', '224575', '38', '4588');
INSERT INTO public.who_global_data_import VALUES (19981, '2021-01-17', 'HR', 'Croatia', 'EURO', '379', '224954', '28', '4616');
INSERT INTO public.who_global_data_import VALUES (19982, '2021-01-18', 'HR', 'Croatia', 'EURO', '174', '225128', '39', '4655');
INSERT INTO public.who_global_data_import VALUES (19983, '2021-01-19', 'HR', 'Croatia', 'EURO', '520', '225648', '29', '4684');
INSERT INTO public.who_global_data_import VALUES (19984, '2021-01-20', 'HR', 'Croatia', 'EURO', '902', '226550', '27', '4711');
INSERT INTO public.who_global_data_import VALUES (19985, '2021-01-21', 'HR', 'Croatia', 'EURO', '776', '227326', '27', '4738');
INSERT INTO public.who_global_data_import VALUES (19986, '2021-01-22', 'HR', 'Croatia', 'EURO', '643', '227969', '32', '4770');
INSERT INTO public.who_global_data_import VALUES (19987, '2021-01-23', 'HR', 'Croatia', 'EURO', '599', '228568', '29', '4799');
INSERT INTO public.who_global_data_import VALUES (19988, '2021-01-24', 'HR', 'Croatia', 'EURO', '352', '228920', '28', '4827');
INSERT INTO public.who_global_data_import VALUES (19989, '2021-01-25', 'HR', 'Croatia', 'EURO', '134', '229054', '32', '4859');
INSERT INTO public.who_global_data_import VALUES (19990, '2021-01-26', 'HR', 'Croatia', 'EURO', '448', '229502', '23', '4882');
INSERT INTO public.who_global_data_import VALUES (19991, '2021-01-27', 'HR', 'Croatia', 'EURO', '857', '230359', '31', '4913');
INSERT INTO public.who_global_data_import VALUES (19992, '2021-01-28', 'HR', 'Croatia', 'EURO', '619', '230978', '30', '4943');
INSERT INTO public.who_global_data_import VALUES (19993, '2021-01-29', 'HR', 'Croatia', 'EURO', '561', '231539', '29', '4972');
INSERT INTO public.who_global_data_import VALUES (19994, '2021-01-30', 'HR', 'Croatia', 'EURO', '551', '232090', '26', '4998');
INSERT INTO public.who_global_data_import VALUES (19995, '2021-01-31', 'HR', 'Croatia', 'EURO', '336', '232426', '29', '5027');
INSERT INTO public.who_global_data_import VALUES (19996, '2021-02-01', 'HR', 'Croatia', 'EURO', '94', '232520', '27', '5054');
INSERT INTO public.who_global_data_import VALUES (19997, '2021-02-02', 'HR', 'Croatia', 'EURO', '387', '232907', '17', '5071');
INSERT INTO public.who_global_data_import VALUES (19998, '2021-02-03', 'HR', 'Croatia', 'EURO', '730', '233637', '17', '5088');
INSERT INTO public.who_global_data_import VALUES (19999, '2021-02-04', 'HR', 'Croatia', 'EURO', '516', '234153', '18', '5106');
INSERT INTO public.who_global_data_import VALUES (20000, '2021-02-05', 'HR', 'Croatia', 'EURO', '549', '234702', '16', '5122');
INSERT INTO public.who_global_data_import VALUES (20001, '2020-01-03', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20002, '2020-01-04', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20003, '2020-01-05', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20004, '2020-01-06', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20005, '2020-01-07', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20006, '2020-01-08', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20007, '2020-01-09', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20008, '2020-01-10', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20009, '2020-01-11', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20010, '2020-01-12', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20011, '2020-01-13', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20012, '2020-01-14', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20013, '2020-01-15', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20014, '2020-01-16', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20015, '2020-01-17', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20016, '2020-01-18', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20017, '2020-01-19', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20018, '2020-01-20', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20019, '2020-01-21', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20020, '2020-01-22', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20021, '2020-01-23', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20022, '2020-01-24', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20023, '2020-01-25', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20024, '2020-01-26', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20025, '2020-01-27', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20026, '2020-01-28', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20027, '2020-01-29', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20028, '2020-01-30', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20029, '2020-01-31', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20030, '2020-02-01', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20031, '2020-02-02', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20032, '2020-02-03', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20033, '2020-02-04', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20034, '2020-02-05', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20035, '2020-02-06', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20036, '2020-02-07', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20037, '2020-02-08', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20038, '2020-02-09', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20039, '2020-02-10', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20040, '2020-02-11', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20041, '2020-02-12', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20043, '2020-02-14', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20044, '2020-02-15', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20045, '2020-02-16', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20046, '2020-02-17', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20047, '2020-02-18', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20048, '2020-02-19', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20049, '2020-02-20', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20050, '2020-02-21', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20051, '2020-02-22', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20052, '2020-02-23', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20053, '2020-02-24', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20054, '2020-02-25', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20055, '2020-02-26', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20056, '2020-02-27', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20057, '2020-02-28', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20058, '2020-02-29', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20059, '2020-03-01', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20060, '2020-03-02', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20061, '2020-03-03', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20062, '2020-03-04', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20063, '2020-03-05', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20064, '2020-03-06', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20065, '2020-03-07', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20066, '2020-03-08', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20067, '2020-03-09', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20068, '2020-03-10', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20069, '2020-03-11', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20070, '2020-03-12', 'CU', 'Cuba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20071, '2020-03-13', 'CU', 'Cuba', 'AMRO', '8', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20072, '2020-03-14', 'CU', 'Cuba', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20073, '2020-03-15', 'CU', 'Cuba', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20074, '2020-03-16', 'CU', 'Cuba', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20075, '2020-03-17', 'CU', 'Cuba', 'AMRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20076, '2020-03-18', 'CU', 'Cuba', 'AMRO', '5', '14', '1', '1');
INSERT INTO public.who_global_data_import VALUES (20077, '2020-03-19', 'CU', 'Cuba', 'AMRO', '-3', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20078, '2020-03-20', 'CU', 'Cuba', 'AMRO', '5', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20079, '2020-03-21', 'CU', 'Cuba', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20080, '2020-03-22', 'CU', 'Cuba', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20081, '2020-03-23', 'CU', 'Cuba', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20082, '2020-03-24', 'CU', 'Cuba', 'AMRO', '32', '48', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20083, '2020-03-25', 'CU', 'Cuba', 'AMRO', '0', '48', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20084, '2020-03-26', 'CU', 'Cuba', 'AMRO', '19', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20085, '2020-03-27', 'CU', 'Cuba', 'AMRO', '0', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20086, '2020-03-28', 'CU', 'Cuba', 'AMRO', '13', '80', '1', '2');
INSERT INTO public.who_global_data_import VALUES (20087, '2020-03-29', 'CU', 'Cuba', 'AMRO', '39', '119', '1', '3');
INSERT INTO public.who_global_data_import VALUES (20088, '2020-03-30', 'CU', 'Cuba', 'AMRO', '0', '119', '0', '3');
INSERT INTO public.who_global_data_import VALUES (20089, '2020-03-31', 'CU', 'Cuba', 'AMRO', '51', '170', '1', '4');
INSERT INTO public.who_global_data_import VALUES (20090, '2020-04-01', 'CU', 'Cuba', 'AMRO', '16', '186', '2', '6');
INSERT INTO public.who_global_data_import VALUES (20091, '2020-04-02', 'CU', 'Cuba', 'AMRO', '26', '212', '0', '6');
INSERT INTO public.who_global_data_import VALUES (20092, '2020-04-03', 'CU', 'Cuba', 'AMRO', '21', '233', '0', '6');
INSERT INTO public.who_global_data_import VALUES (20093, '2020-04-04', 'CU', 'Cuba', 'AMRO', '36', '269', '0', '6');
INSERT INTO public.who_global_data_import VALUES (20094, '2020-04-05', 'CU', 'Cuba', 'AMRO', '19', '288', '0', '6');
INSERT INTO public.who_global_data_import VALUES (20095, '2020-04-06', 'CU', 'Cuba', 'AMRO', '32', '320', '2', '8');
INSERT INTO public.who_global_data_import VALUES (20096, '2020-04-07', 'CU', 'Cuba', 'AMRO', '30', '350', '1', '9');
INSERT INTO public.who_global_data_import VALUES (20097, '2020-04-08', 'CU', 'Cuba', 'AMRO', '46', '396', '2', '11');
INSERT INTO public.who_global_data_import VALUES (20098, '2020-04-09', 'CU', 'Cuba', 'AMRO', '61', '457', '1', '12');
INSERT INTO public.who_global_data_import VALUES (20099, '2020-04-10', 'CU', 'Cuba', 'AMRO', '58', '515', '3', '15');
INSERT INTO public.who_global_data_import VALUES (20100, '2020-04-11', 'CU', 'Cuba', 'AMRO', '49', '564', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20101, '2020-04-12', 'CU', 'Cuba', 'AMRO', '56', '620', '1', '16');
INSERT INTO public.who_global_data_import VALUES (20102, '2020-04-13', 'CU', 'Cuba', 'AMRO', '49', '669', '2', '18');
INSERT INTO public.who_global_data_import VALUES (20103, '2020-04-14', 'CU', 'Cuba', 'AMRO', '57', '726', '3', '21');
INSERT INTO public.who_global_data_import VALUES (20104, '2020-04-15', 'CU', 'Cuba', 'AMRO', '40', '766', '0', '21');
INSERT INTO public.who_global_data_import VALUES (20105, '2020-04-16', 'CU', 'Cuba', 'AMRO', '48', '814', '3', '24');
INSERT INTO public.who_global_data_import VALUES (20106, '2020-04-17', 'CU', 'Cuba', 'AMRO', '48', '862', '3', '27');
INSERT INTO public.who_global_data_import VALUES (20107, '2020-04-18', 'CU', 'Cuba', 'AMRO', '61', '923', '4', '31');
INSERT INTO public.who_global_data_import VALUES (20108, '2020-04-19', 'CU', 'Cuba', 'AMRO', '63', '986', '1', '32');
INSERT INTO public.who_global_data_import VALUES (20109, '2020-04-20', 'CU', 'Cuba', 'AMRO', '49', '1035', '2', '34');
INSERT INTO public.who_global_data_import VALUES (20110, '2020-04-21', 'CU', 'Cuba', 'AMRO', '52', '1087', '2', '36');
INSERT INTO public.who_global_data_import VALUES (20111, '2020-04-22', 'CU', 'Cuba', 'AMRO', '50', '1137', '2', '38');
INSERT INTO public.who_global_data_import VALUES (20112, '2020-04-23', 'CU', 'Cuba', 'AMRO', '52', '1189', '2', '40');
INSERT INTO public.who_global_data_import VALUES (20113, '2020-04-24', 'CU', 'Cuba', 'AMRO', '46', '1235', '3', '43');
INSERT INTO public.who_global_data_import VALUES (20114, '2020-04-25', 'CU', 'Cuba', 'AMRO', '50', '1285', '6', '49');
INSERT INTO public.who_global_data_import VALUES (20115, '2020-04-26', 'CU', 'Cuba', 'AMRO', '52', '1337', '2', '51');
INSERT INTO public.who_global_data_import VALUES (20116, '2020-04-27', 'CU', 'Cuba', 'AMRO', '32', '1369', '3', '54');
INSERT INTO public.who_global_data_import VALUES (20117, '2020-04-28', 'CU', 'Cuba', 'AMRO', '20', '1389', '2', '56');
INSERT INTO public.who_global_data_import VALUES (20118, '2020-04-29', 'CU', 'Cuba', 'AMRO', '48', '1437', '2', '58');
INSERT INTO public.who_global_data_import VALUES (20119, '2020-04-30', 'CU', 'Cuba', 'AMRO', '30', '1467', '0', '58');
INSERT INTO public.who_global_data_import VALUES (20120, '2020-05-01', 'CU', 'Cuba', 'AMRO', '34', '1501', '3', '61');
INSERT INTO public.who_global_data_import VALUES (20121, '2020-05-02', 'CU', 'Cuba', 'AMRO', '36', '1537', '3', '64');
INSERT INTO public.who_global_data_import VALUES (20122, '2020-05-03', 'CU', 'Cuba', 'AMRO', '74', '1611', '2', '66');
INSERT INTO public.who_global_data_import VALUES (20123, '2020-05-04', 'CU', 'Cuba', 'AMRO', '38', '1649', '1', '67');
INSERT INTO public.who_global_data_import VALUES (20124, '2020-05-05', 'CU', 'Cuba', 'AMRO', '19', '1668', '2', '69');
INSERT INTO public.who_global_data_import VALUES (20125, '2020-05-06', 'CU', 'Cuba', 'AMRO', '17', '1685', '0', '69');
INSERT INTO public.who_global_data_import VALUES (20126, '2020-05-07', 'CU', 'Cuba', 'AMRO', '18', '1703', '0', '69');
INSERT INTO public.who_global_data_import VALUES (20127, '2020-05-08', 'CU', 'Cuba', 'AMRO', '26', '1729', '4', '73');
INSERT INTO public.who_global_data_import VALUES (20128, '2020-05-09', 'CU', 'Cuba', 'AMRO', '12', '1741', '1', '74');
INSERT INTO public.who_global_data_import VALUES (20129, '2020-05-10', 'CU', 'Cuba', 'AMRO', '13', '1754', '0', '74');
INSERT INTO public.who_global_data_import VALUES (20130, '2020-05-11', 'CU', 'Cuba', 'AMRO', '12', '1766', '3', '77');
INSERT INTO public.who_global_data_import VALUES (20131, '2020-05-12', 'CU', 'Cuba', 'AMRO', '17', '1783', '0', '77');
INSERT INTO public.who_global_data_import VALUES (20132, '2020-05-13', 'CU', 'Cuba', 'AMRO', '21', '1804', '1', '78');
INSERT INTO public.who_global_data_import VALUES (20133, '2020-05-14', 'CU', 'Cuba', 'AMRO', '6', '1810', '1', '79');
INSERT INTO public.who_global_data_import VALUES (20134, '2020-05-15', 'CU', 'Cuba', 'AMRO', '20', '1830', '0', '79');
INSERT INTO public.who_global_data_import VALUES (20135, '2020-05-16', 'CU', 'Cuba', 'AMRO', '10', '1840', '0', '79');
INSERT INTO public.who_global_data_import VALUES (20136, '2020-05-17', 'CU', 'Cuba', 'AMRO', '22', '1862', '0', '79');
INSERT INTO public.who_global_data_import VALUES (20137, '2020-05-18', 'CU', 'Cuba', 'AMRO', '10', '1872', '0', '79');
INSERT INTO public.who_global_data_import VALUES (20138, '2020-05-19', 'CU', 'Cuba', 'AMRO', '9', '1881', '0', '79');
INSERT INTO public.who_global_data_import VALUES (20139, '2020-05-20', 'CU', 'Cuba', 'AMRO', '6', '1887', '0', '79');
INSERT INTO public.who_global_data_import VALUES (20140, '2020-05-21', 'CU', 'Cuba', 'AMRO', '13', '1900', '0', '79');
INSERT INTO public.who_global_data_import VALUES (20141, '2020-05-22', 'CU', 'Cuba', 'AMRO', '8', '1908', '1', '80');
INSERT INTO public.who_global_data_import VALUES (20142, '2020-05-23', 'CU', 'Cuba', 'AMRO', '8', '1916', '1', '81');
INSERT INTO public.who_global_data_import VALUES (20143, '2020-05-24', 'CU', 'Cuba', 'AMRO', '15', '1931', '0', '81');
INSERT INTO public.who_global_data_import VALUES (20144, '2020-05-25', 'CU', 'Cuba', 'AMRO', '10', '1941', '1', '82');
INSERT INTO public.who_global_data_import VALUES (20145, '2020-05-26', 'CU', 'Cuba', 'AMRO', '6', '1947', '0', '82');
INSERT INTO public.who_global_data_import VALUES (20146, '2020-05-27', 'CU', 'Cuba', 'AMRO', '16', '1963', '0', '82');
INSERT INTO public.who_global_data_import VALUES (20147, '2020-05-28', 'CU', 'Cuba', 'AMRO', '11', '1974', '0', '82');
INSERT INTO public.who_global_data_import VALUES (20148, '2020-05-29', 'CU', 'Cuba', 'AMRO', '9', '1983', '0', '82');
INSERT INTO public.who_global_data_import VALUES (20149, '2020-05-30', 'CU', 'Cuba', 'AMRO', '22', '2005', '0', '82');
INSERT INTO public.who_global_data_import VALUES (20150, '2020-05-31', 'CU', 'Cuba', 'AMRO', '20', '2025', '1', '83');
INSERT INTO public.who_global_data_import VALUES (20151, '2020-06-01', 'CU', 'Cuba', 'AMRO', '20', '2045', '0', '83');
INSERT INTO public.who_global_data_import VALUES (20152, '2020-06-02', 'CU', 'Cuba', 'AMRO', '38', '2083', '0', '83');
INSERT INTO public.who_global_data_import VALUES (20153, '2020-06-03', 'CU', 'Cuba', 'AMRO', '9', '2092', '0', '83');
INSERT INTO public.who_global_data_import VALUES (20154, '2020-06-04', 'CU', 'Cuba', 'AMRO', '15', '2107', '0', '83');
INSERT INTO public.who_global_data_import VALUES (20155, '2020-06-05', 'CU', 'Cuba', 'AMRO', '12', '2119', '0', '83');
INSERT INTO public.who_global_data_import VALUES (20156, '2020-06-06', 'CU', 'Cuba', 'AMRO', '14', '2133', '0', '83');
INSERT INTO public.who_global_data_import VALUES (20157, '2020-06-07', 'CU', 'Cuba', 'AMRO', '40', '2173', '0', '83');
INSERT INTO public.who_global_data_import VALUES (20158, '2020-06-08', 'CU', 'Cuba', 'AMRO', '18', '2191', '0', '83');
INSERT INTO public.who_global_data_import VALUES (20159, '2020-06-09', 'CU', 'Cuba', 'AMRO', '9', '2200', '0', '83');
INSERT INTO public.who_global_data_import VALUES (20160, '2020-06-10', 'CU', 'Cuba', 'AMRO', '5', '2205', '0', '83');
INSERT INTO public.who_global_data_import VALUES (20161, '2020-06-11', 'CU', 'Cuba', 'AMRO', '6', '2211', '0', '83');
INSERT INTO public.who_global_data_import VALUES (20162, '2020-06-12', 'CU', 'Cuba', 'AMRO', '8', '2219', '1', '84');
INSERT INTO public.who_global_data_import VALUES (20163, '2020-06-13', 'CU', 'Cuba', 'AMRO', '14', '2233', '0', '84');
INSERT INTO public.who_global_data_import VALUES (20164, '2020-06-14', 'CU', 'Cuba', 'AMRO', '5', '2238', '0', '84');
INSERT INTO public.who_global_data_import VALUES (20165, '2020-06-15', 'CU', 'Cuba', 'AMRO', '10', '2248', '0', '84');
INSERT INTO public.who_global_data_import VALUES (20166, '2020-06-16', 'CU', 'Cuba', 'AMRO', '14', '2262', '0', '84');
INSERT INTO public.who_global_data_import VALUES (20167, '2020-06-17', 'CU', 'Cuba', 'AMRO', '11', '2273', '0', '84');
INSERT INTO public.who_global_data_import VALUES (20168, '2020-06-18', 'CU', 'Cuba', 'AMRO', '7', '2280', '0', '84');
INSERT INTO public.who_global_data_import VALUES (20169, '2020-06-19', 'CU', 'Cuba', 'AMRO', '15', '2295', '1', '85');
INSERT INTO public.who_global_data_import VALUES (20170, '2020-06-20', 'CU', 'Cuba', 'AMRO', '10', '2305', '0', '85');
INSERT INTO public.who_global_data_import VALUES (20171, '2020-06-21', 'CU', 'Cuba', 'AMRO', '4', '2309', '0', '85');
INSERT INTO public.who_global_data_import VALUES (20172, '2020-06-22', 'CU', 'Cuba', 'AMRO', '3', '2312', '0', '85');
INSERT INTO public.who_global_data_import VALUES (20173, '2020-06-23', 'CU', 'Cuba', 'AMRO', '3', '2315', '0', '85');
INSERT INTO public.who_global_data_import VALUES (20174, '2020-06-24', 'CU', 'Cuba', 'AMRO', '3', '2318', '0', '85');
INSERT INTO public.who_global_data_import VALUES (20175, '2020-06-25', 'CU', 'Cuba', 'AMRO', '1', '2319', '0', '85');
INSERT INTO public.who_global_data_import VALUES (20176, '2020-06-26', 'CU', 'Cuba', 'AMRO', '2', '2321', '0', '85');
INSERT INTO public.who_global_data_import VALUES (20177, '2020-06-27', 'CU', 'Cuba', 'AMRO', '4', '2325', '0', '85');
INSERT INTO public.who_global_data_import VALUES (20178, '2020-06-28', 'CU', 'Cuba', 'AMRO', '5', '2330', '1', '86');
INSERT INTO public.who_global_data_import VALUES (20179, '2020-06-29', 'CU', 'Cuba', 'AMRO', '2', '2332', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20180, '2020-06-30', 'CU', 'Cuba', 'AMRO', '8', '2340', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20181, '2020-07-01', 'CU', 'Cuba', 'AMRO', '1', '2341', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20182, '2020-07-02', 'CU', 'Cuba', 'AMRO', '7', '2348', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20183, '2020-07-03', 'CU', 'Cuba', 'AMRO', '5', '2353', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20184, '2020-07-04', 'CU', 'Cuba', 'AMRO', '8', '2361', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20185, '2020-07-05', 'CU', 'Cuba', 'AMRO', '8', '2369', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20186, '2020-07-06', 'CU', 'Cuba', 'AMRO', '3', '2372', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20187, '2020-07-07', 'CU', 'Cuba', 'AMRO', '8', '2380', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20188, '2020-07-08', 'CU', 'Cuba', 'AMRO', '15', '2395', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20189, '2020-07-09', 'CU', 'Cuba', 'AMRO', '4', '2399', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20190, '2020-07-10', 'CU', 'Cuba', 'AMRO', '4', '2403', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20191, '2020-07-11', 'CU', 'Cuba', 'AMRO', '10', '2413', '0', '86');
INSERT INTO public.who_global_data_import VALUES (20192, '2020-07-12', 'CU', 'Cuba', 'AMRO', '7', '2420', '1', '87');
INSERT INTO public.who_global_data_import VALUES (20193, '2020-07-13', 'CU', 'Cuba', 'AMRO', '6', '2426', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20194, '2020-07-14', 'CU', 'Cuba', 'AMRO', '2', '2428', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20195, '2020-07-15', 'CU', 'Cuba', 'AMRO', '4', '2432', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20196, '2020-07-16', 'CU', 'Cuba', 'AMRO', '6', '2438', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20197, '2020-07-17', 'CU', 'Cuba', 'AMRO', '2', '2440', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20198, '2020-07-18', 'CU', 'Cuba', 'AMRO', '4', '2444', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20199, '2020-07-19', 'CU', 'Cuba', 'AMRO', '1', '2445', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20200, '2020-07-20', 'CU', 'Cuba', 'AMRO', '1', '2446', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20201, '2020-07-21', 'CU', 'Cuba', 'AMRO', '0', '2446', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20202, '2020-07-22', 'CU', 'Cuba', 'AMRO', '3', '2449', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20203, '2020-07-23', 'CU', 'Cuba', 'AMRO', '13', '2462', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20204, '2020-07-24', 'CU', 'Cuba', 'AMRO', '4', '2466', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20205, '2020-07-25', 'CU', 'Cuba', 'AMRO', '3', '2469', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20206, '2020-07-26', 'CU', 'Cuba', 'AMRO', '9', '2478', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20207, '2020-07-27', 'CU', 'Cuba', 'AMRO', '17', '2495', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20208, '2020-07-28', 'CU', 'Cuba', 'AMRO', '37', '2532', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20209, '2020-07-29', 'CU', 'Cuba', 'AMRO', '23', '2555', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20210, '2020-07-30', 'CU', 'Cuba', 'AMRO', '33', '2588', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20211, '2020-07-31', 'CU', 'Cuba', 'AMRO', '9', '2597', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20212, '2020-08-01', 'CU', 'Cuba', 'AMRO', '11', '2608', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20213, '2020-08-02', 'CU', 'Cuba', 'AMRO', '25', '2633', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20214, '2020-08-03', 'CU', 'Cuba', 'AMRO', '13', '2646', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20215, '2020-08-04', 'CU', 'Cuba', 'AMRO', '24', '2670', '0', '87');
INSERT INTO public.who_global_data_import VALUES (20216, '2020-08-05', 'CU', 'Cuba', 'AMRO', '31', '2701', '1', '88');
INSERT INTO public.who_global_data_import VALUES (20217, '2020-08-06', 'CU', 'Cuba', 'AMRO', '25', '2726', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20218, '2020-08-07', 'CU', 'Cuba', 'AMRO', '49', '2775', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20219, '2020-08-08', 'CU', 'Cuba', 'AMRO', '54', '2829', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20220, '2020-08-09', 'CU', 'Cuba', 'AMRO', '59', '2888', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20221, '2020-08-10', 'CU', 'Cuba', 'AMRO', '65', '2953', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20222, '2020-08-11', 'CU', 'Cuba', 'AMRO', '93', '3046', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20223, '2020-08-12', 'CU', 'Cuba', 'AMRO', '47', '3093', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20224, '2020-08-13', 'CU', 'Cuba', 'AMRO', '35', '3128', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20225, '2020-08-14', 'CU', 'Cuba', 'AMRO', '46', '3174', '1', '89');
INSERT INTO public.who_global_data_import VALUES (20226, '2020-08-15', 'CU', 'Cuba', 'AMRO', '55', '3229', '-1', '88');
INSERT INTO public.who_global_data_import VALUES (20227, '2020-08-16', 'CU', 'Cuba', 'AMRO', '63', '3292', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20228, '2020-08-17', 'CU', 'Cuba', 'AMRO', '24', '3316', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20229, '2020-08-18', 'CU', 'Cuba', 'AMRO', '48', '3364', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20230, '2020-08-19', 'CU', 'Cuba', 'AMRO', '44', '3408', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20231, '2020-08-20', 'CU', 'Cuba', 'AMRO', '74', '3482', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20232, '2020-08-21', 'CU', 'Cuba', 'AMRO', '83', '3565', '0', '88');
INSERT INTO public.who_global_data_import VALUES (20233, '2020-08-22', 'CU', 'Cuba', 'AMRO', '17', '3582', '1', '89');
INSERT INTO public.who_global_data_import VALUES (20234, '2020-08-23', 'CU', 'Cuba', 'AMRO', '35', '3617', '0', '89');
INSERT INTO public.who_global_data_import VALUES (20235, '2020-08-24', 'CU', 'Cuba', 'AMRO', '65', '3682', '2', '91');
INSERT INTO public.who_global_data_import VALUES (20236, '2020-08-25', 'CU', 'Cuba', 'AMRO', '35', '3717', '0', '91');
INSERT INTO public.who_global_data_import VALUES (20237, '2020-08-26', 'CU', 'Cuba', 'AMRO', '27', '3744', '0', '91');
INSERT INTO public.who_global_data_import VALUES (20238, '2020-08-27', 'CU', 'Cuba', 'AMRO', '15', '3759', '1', '92');
INSERT INTO public.who_global_data_import VALUES (20239, '2020-08-28', 'CU', 'Cuba', 'AMRO', '47', '3806', '0', '92');
INSERT INTO public.who_global_data_import VALUES (20240, '2020-08-29', 'CU', 'Cuba', 'AMRO', '60', '3866', '0', '92');
INSERT INTO public.who_global_data_import VALUES (20241, '2020-08-30', 'CU', 'Cuba', 'AMRO', '59', '3925', '2', '94');
INSERT INTO public.who_global_data_import VALUES (20242, '2020-08-31', 'CU', 'Cuba', 'AMRO', '48', '3973', '0', '94');
INSERT INTO public.who_global_data_import VALUES (20243, '2020-09-01', 'CU', 'Cuba', 'AMRO', '59', '4032', '0', '94');
INSERT INTO public.who_global_data_import VALUES (20244, '2020-09-02', 'CU', 'Cuba', 'AMRO', '33', '4065', '1', '95');
INSERT INTO public.who_global_data_import VALUES (20245, '2020-09-03', 'CU', 'Cuba', 'AMRO', '61', '4126', '3', '98');
INSERT INTO public.who_global_data_import VALUES (20246, '2020-09-04', 'CU', 'Cuba', 'AMRO', '88', '4214', '2', '100');
INSERT INTO public.who_global_data_import VALUES (20247, '2020-09-05', 'CU', 'Cuba', 'AMRO', '52', '4266', '0', '100');
INSERT INTO public.who_global_data_import VALUES (20248, '2020-09-06', 'CU', 'Cuba', 'AMRO', '32', '4298', '0', '100');
INSERT INTO public.who_global_data_import VALUES (20249, '2020-09-07', 'CU', 'Cuba', 'AMRO', '11', '4309', '1', '101');
INSERT INTO public.who_global_data_import VALUES (20250, '2020-09-08', 'CU', 'Cuba', 'AMRO', '43', '4352', '1', '102');
INSERT INTO public.who_global_data_import VALUES (20251, '2020-09-09', 'CU', 'Cuba', 'AMRO', '25', '4377', '2', '104');
INSERT INTO public.who_global_data_import VALUES (20252, '2020-09-10', 'CU', 'Cuba', 'AMRO', '82', '4459', '0', '104');
INSERT INTO public.who_global_data_import VALUES (20253, '2020-09-11', 'CU', 'Cuba', 'AMRO', '92', '4551', '2', '106');
INSERT INTO public.who_global_data_import VALUES (20254, '2020-09-12', 'CU', 'Cuba', 'AMRO', '42', '4593', '0', '106');
INSERT INTO public.who_global_data_import VALUES (20255, '2020-09-13', 'CU', 'Cuba', 'AMRO', '60', '4653', '2', '108');
INSERT INTO public.who_global_data_import VALUES (20256, '2020-09-14', 'CU', 'Cuba', 'AMRO', '31', '4684', '0', '108');
INSERT INTO public.who_global_data_import VALUES (20257, '2020-09-15', 'CU', 'Cuba', 'AMRO', '42', '4726', '0', '108');
INSERT INTO public.who_global_data_import VALUES (20258, '2020-09-16', 'CU', 'Cuba', 'AMRO', '77', '4803', '0', '108');
INSERT INTO public.who_global_data_import VALUES (20259, '2020-09-17', 'CU', 'Cuba', 'AMRO', '73', '4876', '1', '109');
INSERT INTO public.who_global_data_import VALUES (20260, '2020-09-18', 'CU', 'Cuba', 'AMRO', '57', '4933', '0', '109');
INSERT INTO public.who_global_data_import VALUES (20261, '2020-09-19', 'CU', 'Cuba', 'AMRO', '71', '5004', '2', '111');
INSERT INTO public.who_global_data_import VALUES (20262, '2020-09-20', 'CU', 'Cuba', 'AMRO', '51', '5055', '2', '113');
INSERT INTO public.who_global_data_import VALUES (20263, '2020-09-21', 'CU', 'Cuba', 'AMRO', '36', '5091', '2', '115');
INSERT INTO public.who_global_data_import VALUES (20264, '2020-09-22', 'CU', 'Cuba', 'AMRO', '50', '5141', '1', '116');
INSERT INTO public.who_global_data_import VALUES (20265, '2020-09-23', 'CU', 'Cuba', 'AMRO', '81', '5222', '1', '117');
INSERT INTO public.who_global_data_import VALUES (20266, '2020-09-24', 'CU', 'Cuba', 'AMRO', '48', '5270', '1', '118');
INSERT INTO public.who_global_data_import VALUES (20267, '2020-09-25', 'CU', 'Cuba', 'AMRO', '40', '5310', '0', '118');
INSERT INTO public.who_global_data_import VALUES (20268, '2020-09-26', 'CU', 'Cuba', 'AMRO', '40', '5350', '0', '118');
INSERT INTO public.who_global_data_import VALUES (20269, '2020-09-27', 'CU', 'Cuba', 'AMRO', '62', '5412', '2', '120');
INSERT INTO public.who_global_data_import VALUES (20270, '2020-09-28', 'CU', 'Cuba', 'AMRO', '45', '5457', '2', '122');
INSERT INTO public.who_global_data_import VALUES (20271, '2020-09-29', 'CU', 'Cuba', 'AMRO', '26', '5483', '0', '122');
INSERT INTO public.who_global_data_import VALUES (20272, '2020-09-30', 'CU', 'Cuba', 'AMRO', '48', '5531', '0', '122');
INSERT INTO public.who_global_data_import VALUES (20273, '2020-10-01', 'CU', 'Cuba', 'AMRO', '66', '5597', '0', '122');
INSERT INTO public.who_global_data_import VALUES (20274, '2020-10-02', 'CU', 'Cuba', 'AMRO', '73', '5670', '0', '122');
INSERT INTO public.who_global_data_import VALUES (20275, '2020-10-03', 'CU', 'Cuba', 'AMRO', '48', '5718', '0', '122');
INSERT INTO public.who_global_data_import VALUES (20276, '2020-10-04', 'CU', 'Cuba', 'AMRO', '62', '5780', '0', '122');
INSERT INTO public.who_global_data_import VALUES (20277, '2020-10-05', 'CU', 'Cuba', 'AMRO', '29', '5809', '0', '122');
INSERT INTO public.who_global_data_import VALUES (20278, '2020-10-06', 'CU', 'Cuba', 'AMRO', '36', '5845', '1', '123');
INSERT INTO public.who_global_data_import VALUES (20279, '2020-10-07', 'CU', 'Cuba', 'AMRO', '38', '5883', '0', '123');
INSERT INTO public.who_global_data_import VALUES (20280, '2020-10-08', 'CU', 'Cuba', 'AMRO', '15', '5898', '0', '123');
INSERT INTO public.who_global_data_import VALUES (20281, '2020-10-09', 'CU', 'Cuba', 'AMRO', '19', '5917', '0', '123');
INSERT INTO public.who_global_data_import VALUES (20282, '2020-10-10', 'CU', 'Cuba', 'AMRO', '26', '5943', '0', '123');
INSERT INTO public.who_global_data_import VALUES (20283, '2020-10-11', 'CU', 'Cuba', 'AMRO', '5', '5948', '0', '123');
INSERT INTO public.who_global_data_import VALUES (20284, '2020-10-12', 'CU', 'Cuba', 'AMRO', '30', '5978', '0', '123');
INSERT INTO public.who_global_data_import VALUES (20285, '2020-10-13', 'CU', 'Cuba', 'AMRO', '22', '6000', '0', '123');
INSERT INTO public.who_global_data_import VALUES (20286, '2020-10-14', 'CU', 'Cuba', 'AMRO', '17', '6017', '0', '123');
INSERT INTO public.who_global_data_import VALUES (20287, '2020-10-15', 'CU', 'Cuba', 'AMRO', '18', '6035', '0', '123');
INSERT INTO public.who_global_data_import VALUES (20288, '2020-10-16', 'CU', 'Cuba', 'AMRO', '27', '6062', '0', '123');
INSERT INTO public.who_global_data_import VALUES (20289, '2020-10-17', 'CU', 'Cuba', 'AMRO', '56', '6118', '1', '124');
INSERT INTO public.who_global_data_import VALUES (20290, '2020-10-18', 'CU', 'Cuba', 'AMRO', '52', '6170', '1', '125');
INSERT INTO public.who_global_data_import VALUES (20291, '2020-10-19', 'CU', 'Cuba', 'AMRO', '50', '6220', '0', '125');
INSERT INTO public.who_global_data_import VALUES (20292, '2020-10-20', 'CU', 'Cuba', 'AMRO', '38', '6258', '2', '127');
INSERT INTO public.who_global_data_import VALUES (20293, '2020-10-21', 'CU', 'Cuba', 'AMRO', '47', '6305', '0', '127');
INSERT INTO public.who_global_data_import VALUES (20294, '2020-10-22', 'CU', 'Cuba', 'AMRO', '63', '6368', '0', '127');
INSERT INTO public.who_global_data_import VALUES (20295, '2020-10-23', 'CU', 'Cuba', 'AMRO', '53', '6421', '1', '128');
INSERT INTO public.who_global_data_import VALUES (20296, '2020-10-24', 'CU', 'Cuba', 'AMRO', '58', '6479', '0', '128');
INSERT INTO public.who_global_data_import VALUES (20297, '2020-10-25', 'CU', 'Cuba', 'AMRO', '55', '6534', '0', '128');
INSERT INTO public.who_global_data_import VALUES (20298, '2020-10-26', 'CU', 'Cuba', 'AMRO', '32', '6566', '0', '128');
INSERT INTO public.who_global_data_import VALUES (20299, '2020-10-27', 'CU', 'Cuba', 'AMRO', '29', '6595', '0', '128');
INSERT INTO public.who_global_data_import VALUES (20300, '2020-10-28', 'CU', 'Cuba', 'AMRO', '83', '6678', '0', '128');
INSERT INTO public.who_global_data_import VALUES (20301, '2020-10-29', 'CU', 'Cuba', 'AMRO', '49', '6727', '0', '128');
INSERT INTO public.who_global_data_import VALUES (20302, '2020-10-30', 'CU', 'Cuba', 'AMRO', '39', '6766', '0', '128');
INSERT INTO public.who_global_data_import VALUES (20303, '2020-10-31', 'CU', 'Cuba', 'AMRO', '35', '6801', '0', '128');
INSERT INTO public.who_global_data_import VALUES (20304, '2020-11-01', 'CU', 'Cuba', 'AMRO', '86', '6887', '0', '128');
INSERT INTO public.who_global_data_import VALUES (20305, '2020-11-02', 'CU', 'Cuba', 'AMRO', '48', '6935', '0', '128');
INSERT INTO public.who_global_data_import VALUES (20306, '2020-11-03', 'CU', 'Cuba', 'AMRO', '35', '6970', '1', '129');
INSERT INTO public.who_global_data_import VALUES (20307, '2020-11-04', 'CU', 'Cuba', 'AMRO', '65', '7035', '0', '129');
INSERT INTO public.who_global_data_import VALUES (20308, '2020-11-05', 'CU', 'Cuba', 'AMRO', '109', '7144', '0', '129');
INSERT INTO public.who_global_data_import VALUES (20309, '2020-11-06', 'CU', 'Cuba', 'AMRO', '40', '7184', '0', '129');
INSERT INTO public.who_global_data_import VALUES (20310, '2020-11-07', 'CU', 'Cuba', 'AMRO', '44', '7228', '1', '130');
INSERT INTO public.who_global_data_import VALUES (20311, '2020-11-08', 'CU', 'Cuba', 'AMRO', '39', '7267', '0', '130');
INSERT INTO public.who_global_data_import VALUES (20312, '2020-11-09', 'CU', 'Cuba', 'AMRO', '30', '7297', '0', '130');
INSERT INTO public.who_global_data_import VALUES (20313, '2020-11-10', 'CU', 'Cuba', 'AMRO', '52', '7349', '0', '130');
INSERT INTO public.who_global_data_import VALUES (20314, '2020-11-11', 'CU', 'Cuba', 'AMRO', '43', '7392', '0', '130');
INSERT INTO public.who_global_data_import VALUES (20315, '2020-11-12', 'CU', 'Cuba', 'AMRO', '37', '7429', '0', '130');
INSERT INTO public.who_global_data_import VALUES (20316, '2020-11-13', 'CU', 'Cuba', 'AMRO', '58', '7487', '1', '131');
INSERT INTO public.who_global_data_import VALUES (20317, '2020-11-14', 'CU', 'Cuba', 'AMRO', '54', '7541', '0', '131');
INSERT INTO public.who_global_data_import VALUES (20318, '2020-11-15', 'CU', 'Cuba', 'AMRO', '27', '7568', '0', '131');
INSERT INTO public.who_global_data_import VALUES (20319, '2020-11-16', 'CU', 'Cuba', 'AMRO', '22', '7590', '0', '131');
INSERT INTO public.who_global_data_import VALUES (20320, '2020-11-17', 'CU', 'Cuba', 'AMRO', '49', '7639', '0', '131');
INSERT INTO public.who_global_data_import VALUES (20321, '2020-11-18', 'CU', 'Cuba', 'AMRO', '28', '7667', '0', '131');
INSERT INTO public.who_global_data_import VALUES (20322, '2020-11-19', 'CU', 'Cuba', 'AMRO', '37', '7704', '0', '131');
INSERT INTO public.who_global_data_import VALUES (20323, '2020-11-20', 'CU', 'Cuba', 'AMRO', '21', '7725', '0', '131');
INSERT INTO public.who_global_data_import VALUES (20324, '2020-11-21', 'CU', 'Cuba', 'AMRO', '38', '7763', '0', '131');
INSERT INTO public.who_global_data_import VALUES (20325, '2020-11-22', 'CU', 'Cuba', 'AMRO', '35', '7798', '1', '132');
INSERT INTO public.who_global_data_import VALUES (20326, '2020-11-23', 'CU', 'Cuba', 'AMRO', '48', '7846', '0', '132');
INSERT INTO public.who_global_data_import VALUES (20327, '2020-11-24', 'CU', 'Cuba', 'AMRO', '33', '7879', '0', '132');
INSERT INTO public.who_global_data_import VALUES (20328, '2020-11-25', 'CU', 'Cuba', 'AMRO', '71', '7950', '1', '133');
INSERT INTO public.who_global_data_import VALUES (20329, '2020-11-26', 'CU', 'Cuba', 'AMRO', '76', '8026', '0', '133');
INSERT INTO public.who_global_data_import VALUES (20330, '2020-11-27', 'CU', 'Cuba', 'AMRO', '49', '8075', '0', '133');
INSERT INTO public.who_global_data_import VALUES (20331, '2020-11-28', 'CU', 'Cuba', 'AMRO', '35', '8110', '0', '133');
INSERT INTO public.who_global_data_import VALUES (20332, '2020-11-29', 'CU', 'Cuba', 'AMRO', '63', '8173', '0', '133');
INSERT INTO public.who_global_data_import VALUES (20333, '2020-11-30', 'CU', 'Cuba', 'AMRO', '60', '8233', '1', '134');
INSERT INTO public.who_global_data_import VALUES (20334, '2020-12-01', 'CU', 'Cuba', 'AMRO', '51', '8284', '1', '135');
INSERT INTO public.who_global_data_import VALUES (20335, '2020-12-02', 'CU', 'Cuba', 'AMRO', '97', '8381', '1', '136');
INSERT INTO public.who_global_data_import VALUES (20336, '2020-12-03', 'CU', 'Cuba', 'AMRO', '75', '8456', '0', '136');
INSERT INTO public.who_global_data_import VALUES (20337, '2020-12-04', 'CU', 'Cuba', 'AMRO', '75', '8531', '0', '136');
INSERT INTO public.who_global_data_import VALUES (20338, '2020-12-05', 'CU', 'Cuba', 'AMRO', '79', '8610', '0', '136');
INSERT INTO public.who_global_data_import VALUES (20339, '2020-12-06', 'CU', 'Cuba', 'AMRO', '104', '8714', '0', '136');
INSERT INTO public.who_global_data_import VALUES (20340, '2020-12-07', 'CU', 'Cuba', 'AMRO', '68', '8782', '0', '136');
INSERT INTO public.who_global_data_import VALUES (20341, '2020-12-08', 'CU', 'Cuba', 'AMRO', '124', '8906', '0', '136');
INSERT INTO public.who_global_data_import VALUES (20342, '2020-12-09', 'CU', 'Cuba', 'AMRO', '76', '8982', '0', '136');
INSERT INTO public.who_global_data_import VALUES (20343, '2020-12-10', 'CU', 'Cuba', 'AMRO', '124', '9106', '0', '136');
INSERT INTO public.who_global_data_import VALUES (20344, '2020-12-11', 'CU', 'Cuba', 'AMRO', '75', '9181', '0', '136');
INSERT INTO public.who_global_data_import VALUES (20345, '2020-12-12', 'CU', 'Cuba', 'AMRO', '86', '9267', '0', '136');
INSERT INTO public.who_global_data_import VALUES (20346, '2020-12-13', 'CU', 'Cuba', 'AMRO', '87', '9354', '1', '137');
INSERT INTO public.who_global_data_import VALUES (20347, '2020-12-14', 'CU', 'Cuba', 'AMRO', '69', '9423', '0', '137');
INSERT INTO public.who_global_data_import VALUES (20348, '2020-12-15', 'CU', 'Cuba', 'AMRO', '69', '9492', '0', '137');
INSERT INTO public.who_global_data_import VALUES (20349, '2020-12-16', 'CU', 'Cuba', 'AMRO', '96', '9588', '0', '137');
INSERT INTO public.who_global_data_import VALUES (20350, '2020-12-17', 'CU', 'Cuba', 'AMRO', '83', '9671', '0', '137');
INSERT INTO public.who_global_data_import VALUES (20351, '2020-12-18', 'CU', 'Cuba', 'AMRO', '100', '9771', '0', '137');
INSERT INTO public.who_global_data_import VALUES (20352, '2020-12-19', 'CU', 'Cuba', 'AMRO', '122', '9893', '0', '137');
INSERT INTO public.who_global_data_import VALUES (20353, '2020-12-20', 'CU', 'Cuba', 'AMRO', '131', '10024', '0', '137');
INSERT INTO public.who_global_data_import VALUES (20354, '2020-12-21', 'CU', 'Cuba', 'AMRO', '103', '10127', '0', '137');
INSERT INTO public.who_global_data_import VALUES (20355, '2020-12-22', 'CU', 'Cuba', 'AMRO', '115', '10242', '0', '137');
INSERT INTO public.who_global_data_import VALUES (20356, '2020-12-23', 'CU', 'Cuba', 'AMRO', '142', '10384', '2', '139');
INSERT INTO public.who_global_data_import VALUES (20357, '2020-12-24', 'CU', 'Cuba', 'AMRO', '116', '10500', '0', '139');
INSERT INTO public.who_global_data_import VALUES (20358, '2020-12-25', 'CU', 'Cuba', 'AMRO', '0', '10500', '0', '139');
INSERT INTO public.who_global_data_import VALUES (20359, '2020-12-26', 'CU', 'Cuba', 'AMRO', '400', '10900', '1', '140');
INSERT INTO public.who_global_data_import VALUES (20360, '2020-12-27', 'CU', 'Cuba', 'AMRO', '138', '11038', '1', '141');
INSERT INTO public.who_global_data_import VALUES (20361, '2020-12-28', 'CU', 'Cuba', 'AMRO', '167', '11205', '1', '142');
INSERT INTO public.who_global_data_import VALUES (20362, '2020-12-29', 'CU', 'Cuba', 'AMRO', '229', '11434', '1', '143');
INSERT INTO public.who_global_data_import VALUES (20363, '2020-12-30', 'CU', 'Cuba', 'AMRO', '167', '11601', '0', '143');
INSERT INTO public.who_global_data_import VALUES (20364, '2020-12-31', 'CU', 'Cuba', 'AMRO', '86', '11687', '2', '145');
INSERT INTO public.who_global_data_import VALUES (20365, '2021-01-01', 'CU', 'Cuba', 'AMRO', '176', '11863', '1', '146');
INSERT INTO public.who_global_data_import VALUES (20366, '2021-01-02', 'CU', 'Cuba', 'AMRO', '193', '12056', '0', '146');
INSERT INTO public.who_global_data_import VALUES (20367, '2021-01-03', 'CU', 'Cuba', 'AMRO', '169', '12225', '0', '146');
INSERT INTO public.who_global_data_import VALUES (20368, '2021-01-04', 'CU', 'Cuba', 'AMRO', '199', '12424', '1', '147');
INSERT INTO public.who_global_data_import VALUES (20369, '2021-01-05', 'CU', 'Cuba', 'AMRO', '316', '12740', '0', '147');
INSERT INTO public.who_global_data_import VALUES (20370, '2021-01-06', 'CU', 'Cuba', 'AMRO', '224', '12964', '0', '147');
INSERT INTO public.who_global_data_import VALUES (20371, '2021-01-07', 'CU', 'Cuba', 'AMRO', '201', '13165', '1', '148');
INSERT INTO public.who_global_data_import VALUES (20372, '2021-01-08', 'CU', 'Cuba', 'AMRO', '314', '13479', '0', '148');
INSERT INTO public.who_global_data_import VALUES (20373, '2021-01-09', 'CU', 'Cuba', 'AMRO', '344', '13823', '0', '148');
INSERT INTO public.who_global_data_import VALUES (20374, '2021-01-10', 'CU', 'Cuba', 'AMRO', '365', '14188', '0', '148');
INSERT INTO public.who_global_data_import VALUES (20375, '2021-01-11', 'CU', 'Cuba', 'AMRO', '388', '14576', '3', '151');
INSERT INTO public.who_global_data_import VALUES (20376, '2021-01-12', 'CU', 'Cuba', 'AMRO', '431', '15007', '2', '153');
INSERT INTO public.who_global_data_import VALUES (20377, '2021-01-13', 'CU', 'Cuba', 'AMRO', '487', '15494', '2', '155');
INSERT INTO public.who_global_data_import VALUES (20378, '2021-01-14', 'CU', 'Cuba', 'AMRO', '550', '16044', '3', '158');
INSERT INTO public.who_global_data_import VALUES (20379, '2021-01-15', 'CU', 'Cuba', 'AMRO', '505', '16549', '2', '160');
INSERT INTO public.who_global_data_import VALUES (20380, '2021-01-16', 'CU', 'Cuba', 'AMRO', '547', '17096', '2', '162');
INSERT INTO public.who_global_data_import VALUES (20381, '2021-01-17', 'CU', 'Cuba', 'AMRO', '405', '17501', '4', '166');
INSERT INTO public.who_global_data_import VALUES (20382, '2021-01-18', 'CU', 'Cuba', 'AMRO', '0', '17501', '0', '166');
INSERT INTO public.who_global_data_import VALUES (20383, '2021-01-19', 'CU', 'Cuba', 'AMRO', '942', '18443', '7', '173');
INSERT INTO public.who_global_data_import VALUES (20384, '2021-01-20', 'CU', 'Cuba', 'AMRO', '330', '18773', '2', '175');
INSERT INTO public.who_global_data_import VALUES (20385, '2021-01-21', 'CU', 'Cuba', 'AMRO', '349', '19122', '5', '180');
INSERT INTO public.who_global_data_import VALUES (20386, '2021-01-22', 'CU', 'Cuba', 'AMRO', '408', '19530', '4', '184');
INSERT INTO public.who_global_data_import VALUES (20387, '2021-01-23', 'CU', 'Cuba', 'AMRO', '530', '20060', '4', '188');
INSERT INTO public.who_global_data_import VALUES (20388, '2021-01-24', 'CU', 'Cuba', 'AMRO', '567', '20627', '3', '191');
INSERT INTO public.who_global_data_import VALUES (20389, '2021-01-25', 'CU', 'Cuba', 'AMRO', '634', '21261', '3', '194');
INSERT INTO public.who_global_data_import VALUES (20390, '2021-01-26', 'CU', 'Cuba', 'AMRO', '567', '21828', '3', '197');
INSERT INTO public.who_global_data_import VALUES (20391, '2021-01-27', 'CU', 'Cuba', 'AMRO', '786', '22614', '3', '200');
INSERT INTO public.who_global_data_import VALUES (20392, '2021-01-28', 'CU', 'Cuba', 'AMRO', '825', '23439', '4', '204');
INSERT INTO public.who_global_data_import VALUES (20393, '2021-01-29', 'CU', 'Cuba', 'AMRO', '666', '24105', '4', '208');
INSERT INTO public.who_global_data_import VALUES (20394, '2021-01-30', 'CU', 'Cuba', 'AMRO', '659', '24764', '2', '210');
INSERT INTO public.who_global_data_import VALUES (20395, '2021-01-31', 'CU', 'Cuba', 'AMRO', '910', '25674', '3', '213');
INSERT INTO public.who_global_data_import VALUES (20396, '2021-02-01', 'CU', 'Cuba', 'AMRO', '1012', '26686', '1', '214');
INSERT INTO public.who_global_data_import VALUES (20397, '2021-02-02', 'CU', 'Cuba', 'AMRO', '906', '27592', '2', '216');
INSERT INTO public.who_global_data_import VALUES (20398, '2021-02-03', 'CU', 'Cuba', 'AMRO', '1044', '28636', '2', '218');
INSERT INTO public.who_global_data_import VALUES (20399, '2021-02-04', 'CU', 'Cuba', 'AMRO', '893', '29529', '2', '220');
INSERT INTO public.who_global_data_import VALUES (20400, '2021-02-05', 'CU', 'Cuba', 'AMRO', '816', '30345', '5', '225');
INSERT INTO public.who_global_data_import VALUES (20401, '2020-01-03', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20402, '2020-01-04', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20403, '2020-01-05', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20404, '2020-01-06', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20405, '2020-01-07', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20406, '2020-01-08', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20407, '2020-01-09', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20408, '2020-01-10', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20409, '2020-01-11', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20410, '2020-01-12', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20411, '2020-01-13', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20412, '2020-01-14', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20413, '2020-01-15', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20414, '2020-01-16', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20415, '2020-01-17', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20416, '2020-01-18', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20417, '2020-01-19', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20418, '2020-01-20', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20419, '2020-01-21', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20420, '2020-01-22', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20421, '2020-01-23', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20422, '2020-01-24', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20423, '2020-01-25', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20424, '2020-01-26', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20425, '2020-01-27', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20426, '2020-01-28', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20427, '2020-01-29', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20428, '2020-01-30', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20429, '2020-01-31', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20430, '2020-02-01', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20431, '2020-02-02', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20432, '2020-02-03', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20433, '2020-02-04', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20434, '2020-02-05', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20435, '2020-02-06', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20436, '2020-02-07', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20437, '2020-02-08', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20438, '2020-02-09', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20439, '2020-02-10', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20440, '2020-02-11', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20441, '2020-02-12', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20442, '2020-02-13', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20443, '2020-02-14', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20444, '2020-02-15', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20445, '2020-02-16', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20446, '2020-02-17', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20447, '2020-02-18', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20448, '2020-02-19', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20449, '2020-02-20', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20450, '2020-02-21', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20451, '2020-02-22', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20452, '2020-02-23', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20453, '2020-02-24', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20454, '2020-02-25', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20455, '2020-02-26', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20456, '2020-02-27', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20457, '2020-02-28', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20458, '2020-02-29', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20459, '2020-03-01', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20460, '2020-03-02', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20461, '2020-03-03', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20462, '2020-03-04', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20463, '2020-03-05', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20464, '2020-03-06', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20465, '2020-03-07', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20466, '2020-03-08', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20467, '2020-03-09', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20468, '2020-03-10', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20469, '2020-03-11', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20470, '2020-03-12', 'CW', 'Curaçao', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20471, '2020-03-13', 'CW', 'Curaçao', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20472, '2020-03-14', 'CW', 'Curaçao', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20473, '2020-03-15', 'CW', 'Curaçao', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20474, '2020-03-16', 'CW', 'Curaçao', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20475, '2020-03-17', 'CW', 'Curaçao', 'AMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20476, '2020-03-18', 'CW', 'Curaçao', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20477, '2020-03-19', 'CW', 'Curaçao', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20478, '2020-03-20', 'CW', 'Curaçao', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20479, '2020-03-21', 'CW', 'Curaçao', 'AMRO', '-4', '3', '1', '1');
INSERT INTO public.who_global_data_import VALUES (20480, '2020-03-22', 'CW', 'Curaçao', 'AMRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20481, '2020-03-23', 'CW', 'Curaçao', 'AMRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20482, '2020-03-24', 'CW', 'Curaçao', 'AMRO', '3', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20483, '2020-03-25', 'CW', 'Curaçao', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20484, '2020-03-26', 'CW', 'Curaçao', 'AMRO', '1', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20485, '2020-03-27', 'CW', 'Curaçao', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20486, '2020-03-28', 'CW', 'Curaçao', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20487, '2020-03-29', 'CW', 'Curaçao', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20488, '2020-03-30', 'CW', 'Curaçao', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20489, '2020-03-31', 'CW', 'Curaçao', 'AMRO', '4', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20490, '2020-04-01', 'CW', 'Curaçao', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20491, '2020-04-02', 'CW', 'Curaçao', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20492, '2020-04-03', 'CW', 'Curaçao', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20493, '2020-04-04', 'CW', 'Curaçao', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20494, '2020-04-05', 'CW', 'Curaçao', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20495, '2020-04-06', 'CW', 'Curaçao', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20496, '2020-04-07', 'CW', 'Curaçao', 'AMRO', '2', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20497, '2020-04-08', 'CW', 'Curaçao', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20498, '2020-04-09', 'CW', 'Curaçao', 'AMRO', '1', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20499, '2020-04-10', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20500, '2020-04-11', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20501, '2020-04-12', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20502, '2020-04-13', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20503, '2020-04-14', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20504, '2020-04-15', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20505, '2020-04-16', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20506, '2020-04-17', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20507, '2020-04-18', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20508, '2020-04-19', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20509, '2020-04-20', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20510, '2020-04-21', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20511, '2020-04-22', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20512, '2020-04-23', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20513, '2020-04-24', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20514, '2020-04-25', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20515, '2020-04-26', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20516, '2020-04-27', 'CW', 'Curaçao', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20517, '2020-04-28', 'CW', 'Curaçao', 'AMRO', '2', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20518, '2020-04-29', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20519, '2020-04-30', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20520, '2020-05-01', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20521, '2020-05-02', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20522, '2020-05-03', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20523, '2020-05-04', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20524, '2020-05-05', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20525, '2020-05-06', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20526, '2020-05-07', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20527, '2020-05-08', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20528, '2020-05-09', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20529, '2020-05-10', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20530, '2020-05-11', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20531, '2020-05-12', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20532, '2020-05-13', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20533, '2020-05-14', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20534, '2020-05-15', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20535, '2020-05-16', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20536, '2020-05-17', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20537, '2020-05-18', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20538, '2020-05-19', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20539, '2020-05-20', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20540, '2020-05-21', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20541, '2020-05-22', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20542, '2020-05-23', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20543, '2020-05-24', 'CW', 'Curaçao', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20544, '2020-05-25', 'CW', 'Curaçao', 'AMRO', '1', '17', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20545, '2020-05-26', 'CW', 'Curaçao', 'AMRO', '0', '17', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20546, '2020-05-27', 'CW', 'Curaçao', 'AMRO', '1', '18', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20547, '2020-05-28', 'CW', 'Curaçao', 'AMRO', '0', '18', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20548, '2020-05-29', 'CW', 'Curaçao', 'AMRO', '2', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20549, '2020-05-30', 'CW', 'Curaçao', 'AMRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20550, '2020-05-31', 'CW', 'Curaçao', 'AMRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20551, '2020-06-01', 'CW', 'Curaçao', 'AMRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20552, '2020-06-02', 'CW', 'Curaçao', 'AMRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20553, '2020-06-03', 'CW', 'Curaçao', 'AMRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20554, '2020-06-04', 'CW', 'Curaçao', 'AMRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20555, '2020-06-05', 'CW', 'Curaçao', 'AMRO', '1', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20556, '2020-06-06', 'CW', 'Curaçao', 'AMRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20557, '2020-06-07', 'CW', 'Curaçao', 'AMRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20558, '2020-06-08', 'CW', 'Curaçao', 'AMRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20559, '2020-06-09', 'CW', 'Curaçao', 'AMRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20560, '2020-06-10', 'CW', 'Curaçao', 'AMRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20561, '2020-06-11', 'CW', 'Curaçao', 'AMRO', '1', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20562, '2020-06-12', 'CW', 'Curaçao', 'AMRO', '0', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20563, '2020-06-13', 'CW', 'Curaçao', 'AMRO', '0', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20564, '2020-06-14', 'CW', 'Curaçao', 'AMRO', '0', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20565, '2020-06-15', 'CW', 'Curaçao', 'AMRO', '0', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20566, '2020-06-16', 'CW', 'Curaçao', 'AMRO', '0', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20567, '2020-06-17', 'CW', 'Curaçao', 'AMRO', '0', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20568, '2020-06-18', 'CW', 'Curaçao', 'AMRO', '1', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20569, '2020-06-19', 'CW', 'Curaçao', 'AMRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20570, '2020-06-20', 'CW', 'Curaçao', 'AMRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20571, '2020-06-21', 'CW', 'Curaçao', 'AMRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20572, '2020-06-22', 'CW', 'Curaçao', 'AMRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20573, '2020-06-23', 'CW', 'Curaçao', 'AMRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20574, '2020-06-24', 'CW', 'Curaçao', 'AMRO', '1', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20575, '2020-06-25', 'CW', 'Curaçao', 'AMRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20576, '2020-06-26', 'CW', 'Curaçao', 'AMRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20577, '2020-06-27', 'CW', 'Curaçao', 'AMRO', '-1', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20578, '2020-06-28', 'CW', 'Curaçao', 'AMRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20579, '2020-06-29', 'CW', 'Curaçao', 'AMRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20580, '2020-06-30', 'CW', 'Curaçao', 'AMRO', '1', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20581, '2020-07-01', 'CW', 'Curaçao', 'AMRO', '1', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20582, '2020-07-02', 'CW', 'Curaçao', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20583, '2020-07-03', 'CW', 'Curaçao', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20584, '2020-07-04', 'CW', 'Curaçao', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20585, '2020-07-05', 'CW', 'Curaçao', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20586, '2020-07-06', 'CW', 'Curaçao', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20587, '2020-07-07', 'CW', 'Curaçao', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20588, '2020-07-08', 'CW', 'Curaçao', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20589, '2020-07-09', 'CW', 'Curaçao', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20590, '2020-07-10', 'CW', 'Curaçao', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20591, '2020-07-11', 'CW', 'Curaçao', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20592, '2020-07-12', 'CW', 'Curaçao', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20593, '2020-07-13', 'CW', 'Curaçao', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20594, '2020-07-14', 'CW', 'Curaçao', 'AMRO', '1', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20595, '2020-07-15', 'CW', 'Curaçao', 'AMRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20596, '2020-07-16', 'CW', 'Curaçao', 'AMRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20597, '2020-07-17', 'CW', 'Curaçao', 'AMRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20598, '2020-07-18', 'CW', 'Curaçao', 'AMRO', '2', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20599, '2020-07-19', 'CW', 'Curaçao', 'AMRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20600, '2020-07-20', 'CW', 'Curaçao', 'AMRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20601, '2020-07-21', 'CW', 'Curaçao', 'AMRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20602, '2020-07-22', 'CW', 'Curaçao', 'AMRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20603, '2020-07-23', 'CW', 'Curaçao', 'AMRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20604, '2020-07-24', 'CW', 'Curaçao', 'AMRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20605, '2020-07-25', 'CW', 'Curaçao', 'AMRO', '1', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20606, '2020-07-26', 'CW', 'Curaçao', 'AMRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20607, '2020-07-27', 'CW', 'Curaçao', 'AMRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20608, '2020-07-28', 'CW', 'Curaçao', 'AMRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20609, '2020-07-29', 'CW', 'Curaçao', 'AMRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20610, '2020-07-30', 'CW', 'Curaçao', 'AMRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20611, '2020-07-31', 'CW', 'Curaçao', 'AMRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20612, '2020-08-01', 'CW', 'Curaçao', 'AMRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20613, '2020-08-02', 'CW', 'Curaçao', 'AMRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20614, '2020-08-03', 'CW', 'Curaçao', 'AMRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20615, '2020-08-04', 'CW', 'Curaçao', 'AMRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20616, '2020-08-05', 'CW', 'Curaçao', 'AMRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20617, '2020-08-06', 'CW', 'Curaçao', 'AMRO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20618, '2020-08-07', 'CW', 'Curaçao', 'AMRO', '2', '31', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20619, '2020-08-08', 'CW', 'Curaçao', 'AMRO', '0', '31', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20620, '2020-08-09', 'CW', 'Curaçao', 'AMRO', '0', '31', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20621, '2020-08-10', 'CW', 'Curaçao', 'AMRO', '0', '31', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20622, '2020-08-11', 'CW', 'Curaçao', 'AMRO', '1', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20623, '2020-08-12', 'CW', 'Curaçao', 'AMRO', '0', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20624, '2020-08-13', 'CW', 'Curaçao', 'AMRO', '0', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20625, '2020-08-14', 'CW', 'Curaçao', 'AMRO', '0', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20626, '2020-08-15', 'CW', 'Curaçao', 'AMRO', '0', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20627, '2020-08-16', 'CW', 'Curaçao', 'AMRO', '0', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20628, '2020-08-17', 'CW', 'Curaçao', 'AMRO', '0', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20629, '2020-08-18', 'CW', 'Curaçao', 'AMRO', '1', '33', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20630, '2020-08-19', 'CW', 'Curaçao', 'AMRO', '2', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20631, '2020-08-20', 'CW', 'Curaçao', 'AMRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20632, '2020-08-21', 'CW', 'Curaçao', 'AMRO', '0', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20633, '2020-08-22', 'CW', 'Curaçao', 'AMRO', '2', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20634, '2020-08-23', 'CW', 'Curaçao', 'AMRO', '0', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20635, '2020-08-24', 'CW', 'Curaçao', 'AMRO', '0', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20636, '2020-08-25', 'CW', 'Curaçao', 'AMRO', '2', '39', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20637, '2020-08-26', 'CW', 'Curaçao', 'AMRO', '8', '47', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20638, '2020-08-27', 'CW', 'Curaçao', 'AMRO', '2', '49', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20639, '2020-08-28', 'CW', 'Curaçao', 'AMRO', '4', '53', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20640, '2020-08-29', 'CW', 'Curaçao', 'AMRO', '2', '55', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20641, '2020-08-30', 'CW', 'Curaçao', 'AMRO', '0', '55', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20642, '2020-08-31', 'CW', 'Curaçao', 'AMRO', '0', '55', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20643, '2020-09-01', 'CW', 'Curaçao', 'AMRO', '13', '68', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20644, '2020-09-02', 'CW', 'Curaçao', 'AMRO', '1', '69', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20645, '2020-09-03', 'CW', 'Curaçao', 'AMRO', '2', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20646, '2020-09-04', 'CW', 'Curaçao', 'AMRO', '4', '75', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20647, '2020-09-05', 'CW', 'Curaçao', 'AMRO', '3', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20648, '2020-09-06', 'CW', 'Curaçao', 'AMRO', '0', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20649, '2020-09-07', 'CW', 'Curaçao', 'AMRO', '0', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20650, '2020-09-08', 'CW', 'Curaçao', 'AMRO', '14', '92', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20651, '2020-09-09', 'CW', 'Curaçao', 'AMRO', '15', '107', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20652, '2020-09-10', 'CW', 'Curaçao', 'AMRO', '9', '116', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20653, '2020-09-11', 'CW', 'Curaçao', 'AMRO', '0', '116', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20654, '2020-09-12', 'CW', 'Curaçao', 'AMRO', '19', '135', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20655, '2020-09-13', 'CW', 'Curaçao', 'AMRO', '0', '135', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20656, '2020-09-14', 'CW', 'Curaçao', 'AMRO', '0', '135', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20657, '2020-09-15', 'CW', 'Curaçao', 'AMRO', '22', '157', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20658, '2020-09-16', 'CW', 'Curaçao', 'AMRO', '12', '169', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20659, '2020-09-17', 'CW', 'Curaçao', 'AMRO', '23', '192', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20660, '2020-09-18', 'CW', 'Curaçao', 'AMRO', '18', '210', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20661, '2020-09-19', 'CW', 'Curaçao', 'AMRO', '0', '210', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20662, '2020-09-20', 'CW', 'Curaçao', 'AMRO', '0', '210', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20663, '2020-09-21', 'CW', 'Curaçao', 'AMRO', '0', '210', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20664, '2020-09-22', 'CW', 'Curaçao', 'AMRO', '72', '282', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20665, '2020-09-23', 'CW', 'Curaçao', 'AMRO', '0', '282', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20666, '2020-09-24', 'CW', 'Curaçao', 'AMRO', '9', '291', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20667, '2020-09-25', 'CW', 'Curaçao', 'AMRO', '10', '301', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20668, '2020-09-26', 'CW', 'Curaçao', 'AMRO', '14', '315', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20669, '2020-09-27', 'CW', 'Curaçao', 'AMRO', '0', '315', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20670, '2020-09-28', 'CW', 'Curaçao', 'AMRO', '0', '315', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20671, '2020-09-29', 'CW', 'Curaçao', 'AMRO', '45', '360', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20672, '2020-09-30', 'CW', 'Curaçao', 'AMRO', '4', '364', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20673, '2020-10-01', 'CW', 'Curaçao', 'AMRO', '6', '370', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20674, '2020-10-02', 'CW', 'Curaçao', 'AMRO', '22', '392', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20675, '2020-10-03', 'CW', 'Curaçao', 'AMRO', '7', '399', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20676, '2020-10-04', 'CW', 'Curaçao', 'AMRO', '0', '399', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20677, '2020-10-05', 'CW', 'Curaçao', 'AMRO', '0', '399', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20678, '2020-10-06', 'CW', 'Curaçao', 'AMRO', '53', '452', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20679, '2020-10-07', 'CW', 'Curaçao', 'AMRO', '10', '462', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20680, '2020-10-08', 'CW', 'Curaçao', 'AMRO', '14', '476', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20681, '2020-10-09', 'CW', 'Curaçao', 'AMRO', '29', '505', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20682, '2020-10-10', 'CW', 'Curaçao', 'AMRO', '27', '532', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20683, '2020-10-11', 'CW', 'Curaçao', 'AMRO', '0', '532', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20684, '2020-10-12', 'CW', 'Curaçao', 'AMRO', '0', '532', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20685, '2020-10-13', 'CW', 'Curaçao', 'AMRO', '51', '583', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20686, '2020-10-14', 'CW', 'Curaçao', 'AMRO', '2', '585', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20687, '2020-10-15', 'CW', 'Curaçao', 'AMRO', '34', '619', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20688, '2020-10-16', 'CW', 'Curaçao', 'AMRO', '26', '645', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20689, '2020-10-17', 'CW', 'Curaçao', 'AMRO', '28', '673', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20690, '2020-10-18', 'CW', 'Curaçao', 'AMRO', '0', '673', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20691, '2020-10-19', 'CW', 'Curaçao', 'AMRO', '0', '673', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20692, '2020-10-20', 'CW', 'Curaçao', 'AMRO', '71', '744', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20693, '2020-10-21', 'CW', 'Curaçao', 'AMRO', '7', '751', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20694, '2020-10-22', 'CW', 'Curaçao', 'AMRO', '8', '759', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20695, '2020-10-23', 'CW', 'Curaçao', 'AMRO', '25', '784', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20696, '2020-10-24', 'CW', 'Curaçao', 'AMRO', '19', '803', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20697, '2020-10-25', 'CW', 'Curaçao', 'AMRO', '0', '803', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20698, '2020-10-26', 'CW', 'Curaçao', 'AMRO', '0', '803', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20699, '2020-10-27', 'CW', 'Curaçao', 'AMRO', '55', '858', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20700, '2020-10-28', 'CW', 'Curaçao', 'AMRO', '15', '873', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20701, '2020-10-29', 'CW', 'Curaçao', 'AMRO', '11', '884', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20702, '2020-10-30', 'CW', 'Curaçao', 'AMRO', '23', '907', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20703, '2020-10-31', 'CW', 'Curaçao', 'AMRO', '37', '944', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20704, '2020-11-01', 'CW', 'Curaçao', 'AMRO', '0', '944', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20705, '2020-11-02', 'CW', 'Curaçao', 'AMRO', '0', '944', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20706, '2020-11-03', 'CW', 'Curaçao', 'AMRO', '43', '987', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20707, '2020-11-04', 'CW', 'Curaçao', 'AMRO', '8', '995', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20708, '2020-11-05', 'CW', 'Curaçao', 'AMRO', '5', '1000', '0', '1');
INSERT INTO public.who_global_data_import VALUES (20709, '2020-11-06', 'CW', 'Curaçao', 'AMRO', '21', '1021', '1', '2');
INSERT INTO public.who_global_data_import VALUES (20710, '2020-11-07', 'CW', 'Curaçao', 'AMRO', '9', '1030', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20711, '2020-11-08', 'CW', 'Curaçao', 'AMRO', '0', '1030', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20712, '2020-11-09', 'CW', 'Curaçao', 'AMRO', '0', '1030', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20713, '2020-11-10', 'CW', 'Curaçao', 'AMRO', '67', '1097', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20714, '2020-11-11', 'CW', 'Curaçao', 'AMRO', '5', '1102', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20715, '2020-11-12', 'CW', 'Curaçao', 'AMRO', '29', '1131', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20716, '2020-11-13', 'CW', 'Curaçao', 'AMRO', '51', '1182', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20717, '2020-11-14', 'CW', 'Curaçao', 'AMRO', '33', '1215', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20718, '2020-11-15', 'CW', 'Curaçao', 'AMRO', '0', '1215', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20719, '2020-11-16', 'CW', 'Curaçao', 'AMRO', '0', '1215', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20720, '2020-11-17', 'CW', 'Curaçao', 'AMRO', '125', '1340', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20721, '2020-11-18', 'CW', 'Curaçao', 'AMRO', '34', '1374', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20722, '2020-11-19', 'CW', 'Curaçao', 'AMRO', '41', '1415', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20723, '2020-11-20', 'CW', 'Curaçao', 'AMRO', '67', '1482', '0', '2');
INSERT INTO public.who_global_data_import VALUES (20724, '2020-11-21', 'CW', 'Curaçao', 'AMRO', '79', '1561', '1', '3');
INSERT INTO public.who_global_data_import VALUES (20725, '2020-11-22', 'CW', 'Curaçao', 'AMRO', '0', '1561', '0', '3');
INSERT INTO public.who_global_data_import VALUES (20726, '2020-11-23', 'CW', 'Curaçao', 'AMRO', '0', '1561', '0', '3');
INSERT INTO public.who_global_data_import VALUES (20727, '2020-11-24', 'CW', 'Curaçao', 'AMRO', '188', '1749', '0', '3');
INSERT INTO public.who_global_data_import VALUES (20728, '2020-11-25', 'CW', 'Curaçao', 'AMRO', '24', '1773', '0', '3');
INSERT INTO public.who_global_data_import VALUES (20729, '2020-11-26', 'CW', 'Curaçao', 'AMRO', '54', '1827', '0', '3');
INSERT INTO public.who_global_data_import VALUES (20730, '2020-11-27', 'CW', 'Curaçao', 'AMRO', '102', '1929', '0', '3');
INSERT INTO public.who_global_data_import VALUES (20731, '2020-11-28', 'CW', 'Curaçao', 'AMRO', '117', '2046', '0', '3');
INSERT INTO public.who_global_data_import VALUES (20732, '2020-11-29', 'CW', 'Curaçao', 'AMRO', '0', '2046', '0', '3');
INSERT INTO public.who_global_data_import VALUES (20733, '2020-11-30', 'CW', 'Curaçao', 'AMRO', '0', '2046', '0', '3');
INSERT INTO public.who_global_data_import VALUES (20734, '2020-12-01', 'CW', 'Curaçao', 'AMRO', '318', '2364', '1', '4');
INSERT INTO public.who_global_data_import VALUES (20735, '2020-12-02', 'CW', 'Curaçao', 'AMRO', '15', '2379', '0', '4');
INSERT INTO public.who_global_data_import VALUES (20736, '2020-12-03', 'CW', 'Curaçao', 'AMRO', '124', '2503', '3', '7');
INSERT INTO public.who_global_data_import VALUES (20737, '2020-12-04', 'CW', 'Curaçao', 'AMRO', '155', '2658', '0', '7');
INSERT INTO public.who_global_data_import VALUES (20738, '2020-12-05', 'CW', 'Curaçao', 'AMRO', '82', '2740', '0', '7');
INSERT INTO public.who_global_data_import VALUES (20739, '2020-12-06', 'CW', 'Curaçao', 'AMRO', '0', '2740', '0', '7');
INSERT INTO public.who_global_data_import VALUES (20740, '2020-12-07', 'CW', 'Curaçao', 'AMRO', '0', '2740', '0', '7');
INSERT INTO public.who_global_data_import VALUES (20741, '2020-12-08', 'CW', 'Curaçao', 'AMRO', '396', '3136', '0', '7');
INSERT INTO public.who_global_data_import VALUES (20742, '2020-12-09', 'CW', 'Curaçao', 'AMRO', '38', '3174', '1', '8');
INSERT INTO public.who_global_data_import VALUES (20743, '2020-12-10', 'CW', 'Curaçao', 'AMRO', '72', '3246', '0', '8');
INSERT INTO public.who_global_data_import VALUES (20744, '2020-12-11', 'CW', 'Curaçao', 'AMRO', '79', '3325', '0', '8');
INSERT INTO public.who_global_data_import VALUES (20745, '2020-12-12', 'CW', 'Curaçao', 'AMRO', '79', '3404', '0', '8');
INSERT INTO public.who_global_data_import VALUES (20746, '2020-12-13', 'CW', 'Curaçao', 'AMRO', '0', '3404', '0', '8');
INSERT INTO public.who_global_data_import VALUES (20747, '2020-12-14', 'CW', 'Curaçao', 'AMRO', '0', '3404', '0', '8');
INSERT INTO public.who_global_data_import VALUES (20748, '2020-12-15', 'CW', 'Curaçao', 'AMRO', '220', '3624', '3', '11');
INSERT INTO public.who_global_data_import VALUES (20749, '2020-12-16', 'CW', 'Curaçao', 'AMRO', '37', '3661', '0', '11');
INSERT INTO public.who_global_data_import VALUES (20750, '2020-12-17', 'CW', 'Curaçao', 'AMRO', '38', '3699', '0', '11');
INSERT INTO public.who_global_data_import VALUES (20751, '2020-12-18', 'CW', 'Curaçao', 'AMRO', '68', '3767', '0', '11');
INSERT INTO public.who_global_data_import VALUES (20752, '2020-12-19', 'CW', 'Curaçao', 'AMRO', '56', '3823', '0', '11');
INSERT INTO public.who_global_data_import VALUES (20753, '2020-12-20', 'CW', 'Curaçao', 'AMRO', '0', '3823', '0', '11');
INSERT INTO public.who_global_data_import VALUES (20754, '2020-12-21', 'CW', 'Curaçao', 'AMRO', '0', '3823', '0', '11');
INSERT INTO public.who_global_data_import VALUES (20755, '2020-12-22', 'CW', 'Curaçao', 'AMRO', '124', '3947', '0', '11');
INSERT INTO public.who_global_data_import VALUES (20756, '2020-12-23', 'CW', 'Curaçao', 'AMRO', '27', '3974', '0', '11');
INSERT INTO public.who_global_data_import VALUES (20757, '2020-12-24', 'CW', 'Curaçao', 'AMRO', '32', '4006', '0', '11');
INSERT INTO public.who_global_data_import VALUES (20758, '2020-12-25', 'CW', 'Curaçao', 'AMRO', '45', '4051', '1', '12');
INSERT INTO public.who_global_data_import VALUES (20759, '2020-12-26', 'CW', 'Curaçao', 'AMRO', '0', '4051', '0', '12');
INSERT INTO public.who_global_data_import VALUES (20760, '2020-12-27', 'CW', 'Curaçao', 'AMRO', '0', '4051', '0', '12');
INSERT INTO public.who_global_data_import VALUES (20761, '2020-12-28', 'CW', 'Curaçao', 'AMRO', '0', '4051', '0', '12');
INSERT INTO public.who_global_data_import VALUES (20762, '2020-12-29', 'CW', 'Curaçao', 'AMRO', '93', '4144', '2', '14');
INSERT INTO public.who_global_data_import VALUES (20763, '2020-12-30', 'CW', 'Curaçao', 'AMRO', '7', '4151', '0', '14');
INSERT INTO public.who_global_data_import VALUES (20764, '2020-12-31', 'CW', 'Curaçao', 'AMRO', '28', '4179', '0', '14');
INSERT INTO public.who_global_data_import VALUES (20765, '2021-01-01', 'CW', 'Curaçao', 'AMRO', '51', '4230', '0', '14');
INSERT INTO public.who_global_data_import VALUES (20766, '2021-01-02', 'CW', 'Curaçao', 'AMRO', '0', '4230', '0', '14');
INSERT INTO public.who_global_data_import VALUES (20767, '2021-01-03', 'CW', 'Curaçao', 'AMRO', '0', '4230', '0', '14');
INSERT INTO public.who_global_data_import VALUES (20768, '2021-01-04', 'CW', 'Curaçao', 'AMRO', '0', '4230', '0', '14');
INSERT INTO public.who_global_data_import VALUES (20769, '2021-01-05', 'CW', 'Curaçao', 'AMRO', '87', '4317', '2', '16');
INSERT INTO public.who_global_data_import VALUES (20770, '2021-01-06', 'CW', 'Curaçao', 'AMRO', '6', '4323', '0', '16');
INSERT INTO public.who_global_data_import VALUES (20771, '2021-01-07', 'CW', 'Curaçao', 'AMRO', '19', '4342', '0', '16');
INSERT INTO public.who_global_data_import VALUES (20772, '2021-01-08', 'CW', 'Curaçao', 'AMRO', '36', '4378', '1', '17');
INSERT INTO public.who_global_data_import VALUES (20773, '2021-01-09', 'CW', 'Curaçao', 'AMRO', '27', '4405', '1', '18');
INSERT INTO public.who_global_data_import VALUES (20774, '2021-01-10', 'CW', 'Curaçao', 'AMRO', '0', '4405', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20775, '2021-01-11', 'CW', 'Curaçao', 'AMRO', '0', '4405', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20776, '2021-01-12', 'CW', 'Curaçao', 'AMRO', '53', '4458', '1', '19');
INSERT INTO public.who_global_data_import VALUES (20777, '2021-01-13', 'CW', 'Curaçao', 'AMRO', '6', '4464', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20778, '2021-01-14', 'CW', 'Curaçao', 'AMRO', '5', '4469', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20779, '2021-01-15', 'CW', 'Curaçao', 'AMRO', '19', '4488', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20780, '2021-01-16', 'CW', 'Curaçao', 'AMRO', '10', '4498', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20781, '2021-01-17', 'CW', 'Curaçao', 'AMRO', '0', '4498', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20782, '2021-01-18', 'CW', 'Curaçao', 'AMRO', '0', '4498', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20783, '2021-01-19', 'CW', 'Curaçao', 'AMRO', '22', '4520', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20784, '2021-01-20', 'CW', 'Curaçao', 'AMRO', '3', '4523', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20785, '2021-01-21', 'CW', 'Curaçao', 'AMRO', '4', '4527', '1', '20');
INSERT INTO public.who_global_data_import VALUES (20786, '2021-01-22', 'CW', 'Curaçao', 'AMRO', '8', '4535', '0', '20');
INSERT INTO public.who_global_data_import VALUES (20787, '2021-01-23', 'CW', 'Curaçao', 'AMRO', '2', '4537', '0', '20');
INSERT INTO public.who_global_data_import VALUES (20788, '2021-01-24', 'CW', 'Curaçao', 'AMRO', '0', '4537', '0', '20');
INSERT INTO public.who_global_data_import VALUES (20789, '2021-01-25', 'CW', 'Curaçao', 'AMRO', '0', '4537', '0', '20');
INSERT INTO public.who_global_data_import VALUES (20790, '2021-01-26', 'CW', 'Curaçao', 'AMRO', '11', '4548', '0', '20');
INSERT INTO public.who_global_data_import VALUES (20791, '2021-01-27', 'CW', 'Curaçao', 'AMRO', '0', '4548', '0', '20');
INSERT INTO public.who_global_data_import VALUES (20792, '2021-01-28', 'CW', 'Curaçao', 'AMRO', '10', '4558', '0', '20');
INSERT INTO public.who_global_data_import VALUES (20793, '2021-01-29', 'CW', 'Curaçao', 'AMRO', '9', '4567', '0', '20');
INSERT INTO public.who_global_data_import VALUES (20794, '2021-01-30', 'CW', 'Curaçao', 'AMRO', '7', '4574', '0', '20');
INSERT INTO public.who_global_data_import VALUES (20795, '2021-01-31', 'CW', 'Curaçao', 'AMRO', '0', '4574', '0', '20');
INSERT INTO public.who_global_data_import VALUES (20796, '2021-02-01', 'CW', 'Curaçao', 'AMRO', '0', '4574', '0', '20');
INSERT INTO public.who_global_data_import VALUES (20797, '2021-02-02', 'CW', 'Curaçao', 'AMRO', '11', '4585', '1', '21');
INSERT INTO public.who_global_data_import VALUES (20798, '2021-02-03', 'CW', 'Curaçao', 'AMRO', '0', '4585', '0', '21');
INSERT INTO public.who_global_data_import VALUES (20799, '2021-02-04', 'CW', 'Curaçao', 'AMRO', '6', '4591', '0', '21');
INSERT INTO public.who_global_data_import VALUES (20800, '2021-02-05', 'CW', 'Curaçao', 'AMRO', '4', '4595', '0', '21');
INSERT INTO public.who_global_data_import VALUES (20801, '2020-01-03', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20802, '2020-01-04', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20803, '2020-01-05', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20804, '2020-01-06', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20805, '2020-01-07', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20806, '2020-01-08', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20807, '2020-01-09', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20808, '2020-01-10', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20809, '2020-01-11', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20810, '2020-01-12', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20811, '2020-01-13', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20812, '2020-01-14', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20813, '2020-01-15', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20814, '2020-01-16', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20815, '2020-01-17', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20816, '2020-01-18', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20817, '2020-01-19', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20818, '2020-01-20', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20819, '2020-01-21', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20820, '2020-01-22', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20821, '2020-01-23', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20822, '2020-01-24', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20823, '2020-01-25', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20824, '2020-01-26', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20825, '2020-01-27', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20826, '2020-01-28', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20827, '2020-01-29', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20828, '2020-01-30', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20829, '2020-01-31', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20830, '2020-02-01', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20831, '2020-02-02', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20832, '2020-02-03', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20833, '2020-02-04', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20834, '2020-02-05', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20835, '2020-02-06', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20836, '2020-02-07', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20837, '2020-02-08', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20838, '2020-02-09', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20839, '2020-02-10', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20840, '2020-02-11', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20841, '2020-02-12', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20842, '2020-02-13', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20843, '2020-02-14', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20844, '2020-02-15', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20845, '2020-02-16', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20846, '2020-02-17', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20847, '2020-02-18', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20848, '2020-02-19', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20849, '2020-02-20', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20850, '2020-02-21', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20851, '2020-02-22', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20852, '2020-02-23', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20853, '2020-02-24', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20854, '2020-02-25', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20855, '2020-02-26', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20856, '2020-02-27', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20857, '2020-02-28', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20858, '2020-02-29', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20859, '2020-03-01', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20860, '2020-03-02', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20861, '2020-03-03', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20862, '2020-03-04', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20863, '2020-03-05', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20864, '2020-03-06', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20865, '2020-03-07', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20866, '2020-03-08', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20867, '2020-03-09', 'CY', 'Cyprus', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20868, '2020-03-10', 'CY', 'Cyprus', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20869, '2020-03-11', 'CY', 'Cyprus', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20870, '2020-03-12', 'CY', 'Cyprus', 'EURO', '4', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20871, '2020-03-13', 'CY', 'Cyprus', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20872, '2020-03-14', 'CY', 'Cyprus', 'EURO', '8', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20873, '2020-03-15', 'CY', 'Cyprus', 'EURO', '7', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20874, '2020-03-16', 'CY', 'Cyprus', 'EURO', '9', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20875, '2020-03-17', 'CY', 'Cyprus', 'EURO', '10', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20876, '2020-03-18', 'CY', 'Cyprus', 'EURO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20877, '2020-03-19', 'CY', 'Cyprus', 'EURO', '18', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20878, '2020-03-20', 'CY', 'Cyprus', 'EURO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20879, '2020-03-21', 'CY', 'Cyprus', 'EURO', '9', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20880, '2020-03-22', 'CY', 'Cyprus', 'EURO', '17', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20881, '2020-03-23', 'CY', 'Cyprus', 'EURO', '11', '95', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20882, '2020-03-24', 'CY', 'Cyprus', 'EURO', '21', '116', '0', '0');
INSERT INTO public.who_global_data_import VALUES (20883, '2020-03-25', 'CY', 'Cyprus', 'EURO', '8', '124', '3', '3');
INSERT INTO public.who_global_data_import VALUES (20884, '2020-03-26', 'CY', 'Cyprus', 'EURO', '8', '132', '0', '3');
INSERT INTO public.who_global_data_import VALUES (20885, '2020-03-27', 'CY', 'Cyprus', 'EURO', '14', '146', '0', '3');
INSERT INTO public.who_global_data_import VALUES (20886, '2020-03-28', 'CY', 'Cyprus', 'EURO', '16', '162', '2', '5');
INSERT INTO public.who_global_data_import VALUES (20887, '2020-03-29', 'CY', 'Cyprus', 'EURO', '17', '179', '0', '5');
INSERT INTO public.who_global_data_import VALUES (20888, '2020-03-30', 'CY', 'Cyprus', 'EURO', '35', '214', '1', '6');
INSERT INTO public.who_global_data_import VALUES (20889, '2020-03-31', 'CY', 'Cyprus', 'EURO', '16', '230', '1', '7');
INSERT INTO public.who_global_data_import VALUES (20890, '2020-04-01', 'CY', 'Cyprus', 'EURO', '32', '262', '1', '8');
INSERT INTO public.who_global_data_import VALUES (20891, '2020-04-02', 'CY', 'Cyprus', 'EURO', '58', '320', '1', '9');
INSERT INTO public.who_global_data_import VALUES (20892, '2020-04-03', 'CY', 'Cyprus', 'EURO', '36', '356', '0', '9');
INSERT INTO public.who_global_data_import VALUES (20893, '2020-04-04', 'CY', 'Cyprus', 'EURO', '40', '396', '0', '9');
INSERT INTO public.who_global_data_import VALUES (20894, '2020-04-05', 'CY', 'Cyprus', 'EURO', '30', '426', '0', '9');
INSERT INTO public.who_global_data_import VALUES (20895, '2020-04-06', 'CY', 'Cyprus', 'EURO', '20', '446', '0', '9');
INSERT INTO public.who_global_data_import VALUES (20896, '2020-04-07', 'CY', 'Cyprus', 'EURO', '19', '465', '0', '9');
INSERT INTO public.who_global_data_import VALUES (20897, '2020-04-08', 'CY', 'Cyprus', 'EURO', '29', '494', '0', '9');
INSERT INTO public.who_global_data_import VALUES (20898, '2020-04-09', 'CY', 'Cyprus', 'EURO', '32', '526', '0', '9');
INSERT INTO public.who_global_data_import VALUES (20899, '2020-04-10', 'CY', 'Cyprus', 'EURO', '38', '564', '1', '10');
INSERT INTO public.who_global_data_import VALUES (20900, '2020-04-11', 'CY', 'Cyprus', 'EURO', '31', '595', '0', '10');
INSERT INTO public.who_global_data_import VALUES (20901, '2020-04-12', 'CY', 'Cyprus', 'EURO', '21', '616', '0', '10');
INSERT INTO public.who_global_data_import VALUES (20902, '2020-04-13', 'CY', 'Cyprus', 'EURO', '17', '633', '1', '11');
INSERT INTO public.who_global_data_import VALUES (20903, '2020-04-14', 'CY', 'Cyprus', 'EURO', '29', '662', '1', '12');
INSERT INTO public.who_global_data_import VALUES (20904, '2020-04-15', 'CY', 'Cyprus', 'EURO', '33', '695', '0', '12');
INSERT INTO public.who_global_data_import VALUES (20905, '2020-04-16', 'CY', 'Cyprus', 'EURO', '20', '715', '0', '12');
INSERT INTO public.who_global_data_import VALUES (20906, '2020-04-17', 'CY', 'Cyprus', 'EURO', '20', '735', '0', '12');
INSERT INTO public.who_global_data_import VALUES (20907, '2020-04-18', 'CY', 'Cyprus', 'EURO', '0', '735', '0', '12');
INSERT INTO public.who_global_data_import VALUES (20908, '2020-04-19', 'CY', 'Cyprus', 'EURO', '26', '761', '0', '12');
INSERT INTO public.who_global_data_import VALUES (20909, '2020-04-20', 'CY', 'Cyprus', 'EURO', '6', '767', '0', '12');
INSERT INTO public.who_global_data_import VALUES (20910, '2020-04-21', 'CY', 'Cyprus', 'EURO', '5', '772', '0', '12');
INSERT INTO public.who_global_data_import VALUES (20911, '2020-04-22', 'CY', 'Cyprus', 'EURO', '12', '784', '0', '12');
INSERT INTO public.who_global_data_import VALUES (20912, '2020-04-23', 'CY', 'Cyprus', 'EURO', '6', '790', '2', '14');
INSERT INTO public.who_global_data_import VALUES (20913, '2020-04-24', 'CY', 'Cyprus', 'EURO', '5', '795', '0', '14');
INSERT INTO public.who_global_data_import VALUES (20914, '2020-04-25', 'CY', 'Cyprus', 'EURO', '9', '804', '0', '14');
INSERT INTO public.who_global_data_import VALUES (20915, '2020-04-26', 'CY', 'Cyprus', 'EURO', '6', '810', '0', '14');
INSERT INTO public.who_global_data_import VALUES (20916, '2020-04-27', 'CY', 'Cyprus', 'EURO', '7', '817', '0', '14');
INSERT INTO public.who_global_data_import VALUES (20917, '2020-04-28', 'CY', 'Cyprus', 'EURO', '5', '822', '1', '15');
INSERT INTO public.who_global_data_import VALUES (20918, '2020-04-29', 'CY', 'Cyprus', 'EURO', '15', '837', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20919, '2020-04-30', 'CY', 'Cyprus', 'EURO', '6', '843', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20920, '2020-05-01', 'CY', 'Cyprus', 'EURO', '7', '850', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20921, '2020-05-02', 'CY', 'Cyprus', 'EURO', '7', '857', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20922, '2020-05-03', 'CY', 'Cyprus', 'EURO', '7', '864', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20923, '2020-05-04', 'CY', 'Cyprus', 'EURO', '8', '872', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20924, '2020-05-05', 'CY', 'Cyprus', 'EURO', '2', '874', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20925, '2020-05-06', 'CY', 'Cyprus', 'EURO', '4', '878', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20926, '2020-05-07', 'CY', 'Cyprus', 'EURO', '5', '883', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20927, '2020-05-08', 'CY', 'Cyprus', 'EURO', '6', '889', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20928, '2020-05-09', 'CY', 'Cyprus', 'EURO', '2', '891', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20929, '2020-05-10', 'CY', 'Cyprus', 'EURO', '1', '892', '0', '15');
INSERT INTO public.who_global_data_import VALUES (20930, '2020-05-11', 'CY', 'Cyprus', 'EURO', '6', '898', '1', '16');
INSERT INTO public.who_global_data_import VALUES (20931, '2020-05-12', 'CY', 'Cyprus', 'EURO', '3', '901', '0', '16');
INSERT INTO public.who_global_data_import VALUES (20932, '2020-05-13', 'CY', 'Cyprus', 'EURO', '2', '903', '0', '16');
INSERT INTO public.who_global_data_import VALUES (20933, '2020-05-14', 'CY', 'Cyprus', 'EURO', '2', '905', '1', '17');
INSERT INTO public.who_global_data_import VALUES (20934, '2020-05-15', 'CY', 'Cyprus', 'EURO', '2', '907', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20935, '2020-05-16', 'CY', 'Cyprus', 'EURO', '3', '910', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20936, '2020-05-17', 'CY', 'Cyprus', 'EURO', '4', '914', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20937, '2020-05-18', 'CY', 'Cyprus', 'EURO', '2', '916', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20938, '2020-05-19', 'CY', 'Cyprus', 'EURO', '1', '917', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20939, '2020-05-20', 'CY', 'Cyprus', 'EURO', '1', '918', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20940, '2020-05-21', 'CY', 'Cyprus', 'EURO', '4', '922', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20941, '2020-05-22', 'CY', 'Cyprus', 'EURO', '1', '923', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20942, '2020-05-23', 'CY', 'Cyprus', 'EURO', '4', '927', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20943, '2020-05-24', 'CY', 'Cyprus', 'EURO', '0', '927', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20944, '2020-05-25', 'CY', 'Cyprus', 'EURO', '8', '935', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20945, '2020-05-26', 'CY', 'Cyprus', 'EURO', '2', '937', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20946, '2020-05-27', 'CY', 'Cyprus', 'EURO', '2', '939', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20947, '2020-05-28', 'CY', 'Cyprus', 'EURO', '0', '939', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20948, '2020-05-29', 'CY', 'Cyprus', 'EURO', '2', '941', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20949, '2020-05-30', 'CY', 'Cyprus', 'EURO', '0', '941', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20950, '2020-05-31', 'CY', 'Cyprus', 'EURO', '2', '943', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20951, '2020-06-01', 'CY', 'Cyprus', 'EURO', '1', '944', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20952, '2020-06-02', 'CY', 'Cyprus', 'EURO', '5', '949', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20953, '2020-06-03', 'CY', 'Cyprus', 'EURO', '3', '952', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20954, '2020-06-04', 'CY', 'Cyprus', 'EURO', '6', '958', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20955, '2020-06-05', 'CY', 'Cyprus', 'EURO', '0', '958', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20956, '2020-06-06', 'CY', 'Cyprus', 'EURO', '2', '960', '0', '17');
INSERT INTO public.who_global_data_import VALUES (20957, '2020-06-07', 'CY', 'Cyprus', 'EURO', '0', '960', '1', '18');
INSERT INTO public.who_global_data_import VALUES (20958, '2020-06-08', 'CY', 'Cyprus', 'EURO', '4', '964', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20959, '2020-06-09', 'CY', 'Cyprus', 'EURO', '6', '970', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20960, '2020-06-10', 'CY', 'Cyprus', 'EURO', '2', '972', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20961, '2020-06-11', 'CY', 'Cyprus', 'EURO', '2', '974', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20962, '2020-06-12', 'CY', 'Cyprus', 'EURO', '1', '975', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20963, '2020-06-13', 'CY', 'Cyprus', 'EURO', '5', '980', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20964, '2020-06-14', 'CY', 'Cyprus', 'EURO', '0', '980', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20965, '2020-06-15', 'CY', 'Cyprus', 'EURO', '3', '983', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20966, '2020-06-16', 'CY', 'Cyprus', 'EURO', '2', '985', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20967, '2020-06-17', 'CY', 'Cyprus', 'EURO', '0', '985', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20968, '2020-06-18', 'CY', 'Cyprus', 'EURO', '0', '985', '0', '18');
INSERT INTO public.who_global_data_import VALUES (20969, '2020-06-19', 'CY', 'Cyprus', 'EURO', '0', '985', '1', '19');
INSERT INTO public.who_global_data_import VALUES (20970, '2020-06-20', 'CY', 'Cyprus', 'EURO', '0', '985', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20971, '2020-06-21', 'CY', 'Cyprus', 'EURO', '0', '985', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20972, '2020-06-22', 'CY', 'Cyprus', 'EURO', '1', '986', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20973, '2020-06-23', 'CY', 'Cyprus', 'EURO', '2', '988', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20974, '2020-06-24', 'CY', 'Cyprus', 'EURO', '2', '990', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20975, '2020-06-25', 'CY', 'Cyprus', 'EURO', '1', '991', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20976, '2020-06-26', 'CY', 'Cyprus', 'EURO', '1', '992', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20977, '2020-06-27', 'CY', 'Cyprus', 'EURO', '0', '992', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20978, '2020-06-28', 'CY', 'Cyprus', 'EURO', '2', '994', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20979, '2020-06-29', 'CY', 'Cyprus', 'EURO', '0', '994', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20980, '2020-06-30', 'CY', 'Cyprus', 'EURO', '2', '996', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20981, '2020-07-01', 'CY', 'Cyprus', 'EURO', '2', '998', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20982, '2020-07-02', 'CY', 'Cyprus', 'EURO', '1', '999', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20983, '2020-07-03', 'CY', 'Cyprus', 'EURO', '0', '999', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20984, '2020-07-04', 'CY', 'Cyprus', 'EURO', '0', '999', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20985, '2020-07-05', 'CY', 'Cyprus', 'EURO', '3', '1002', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20986, '2020-07-06', 'CY', 'Cyprus', 'EURO', '1', '1003', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20987, '2020-07-07', 'CY', 'Cyprus', 'EURO', '1', '1004', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20988, '2020-07-08', 'CY', 'Cyprus', 'EURO', '1', '1005', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20989, '2020-07-09', 'CY', 'Cyprus', 'EURO', '3', '1008', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20990, '2020-07-10', 'CY', 'Cyprus', 'EURO', '2', '1010', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20991, '2020-07-11', 'CY', 'Cyprus', 'EURO', '3', '1013', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20992, '2020-07-12', 'CY', 'Cyprus', 'EURO', '1', '1014', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20993, '2020-07-13', 'CY', 'Cyprus', 'EURO', '7', '1021', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20994, '2020-07-14', 'CY', 'Cyprus', 'EURO', '1', '1022', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20995, '2020-07-15', 'CY', 'Cyprus', 'EURO', '0', '1022', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20996, '2020-07-16', 'CY', 'Cyprus', 'EURO', '1', '1023', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20997, '2020-07-17', 'CY', 'Cyprus', 'EURO', '8', '1031', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20998, '2020-07-18', 'CY', 'Cyprus', 'EURO', '0', '1031', '0', '19');
INSERT INTO public.who_global_data_import VALUES (20999, '2020-07-19', 'CY', 'Cyprus', 'EURO', '6', '1037', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21000, '2020-07-20', 'CY', 'Cyprus', 'EURO', '1', '1038', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21001, '2020-07-21', 'CY', 'Cyprus', 'EURO', '0', '1038', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21002, '2020-07-22', 'CY', 'Cyprus', 'EURO', '2', '1040', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21003, '2020-07-23', 'CY', 'Cyprus', 'EURO', '0', '1040', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21004, '2020-07-24', 'CY', 'Cyprus', 'EURO', '5', '1045', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21005, '2020-07-25', 'CY', 'Cyprus', 'EURO', '2', '1047', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21006, '2020-07-26', 'CY', 'Cyprus', 'EURO', '6', '1053', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21007, '2020-07-27', 'CY', 'Cyprus', 'EURO', '4', '1057', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21008, '2020-07-28', 'CY', 'Cyprus', 'EURO', '3', '1060', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21009, '2020-07-29', 'CY', 'Cyprus', 'EURO', '7', '1067', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21010, '2020-07-30', 'CY', 'Cyprus', 'EURO', '13', '1080', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21011, '2020-07-31', 'CY', 'Cyprus', 'EURO', '4', '1084', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21012, '2020-08-01', 'CY', 'Cyprus', 'EURO', '30', '1114', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21013, '2020-08-02', 'CY', 'Cyprus', 'EURO', '10', '1124', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21014, '2020-08-03', 'CY', 'Cyprus', 'EURO', '26', '1150', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21015, '2020-08-04', 'CY', 'Cyprus', 'EURO', '5', '1155', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21016, '2020-08-05', 'CY', 'Cyprus', 'EURO', '25', '1180', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21017, '2020-08-06', 'CY', 'Cyprus', 'EURO', '15', '1195', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21018, '2020-08-07', 'CY', 'Cyprus', 'EURO', '13', '1208', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21019, '2020-08-08', 'CY', 'Cyprus', 'EURO', '14', '1222', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21020, '2020-08-09', 'CY', 'Cyprus', 'EURO', '11', '1233', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21021, '2020-08-10', 'CY', 'Cyprus', 'EURO', '9', '1242', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21022, '2020-08-11', 'CY', 'Cyprus', 'EURO', '10', '1252', '0', '19');
INSERT INTO public.who_global_data_import VALUES (21023, '2020-08-12', 'CY', 'Cyprus', 'EURO', '25', '1277', '1', '20');
INSERT INTO public.who_global_data_import VALUES (21024, '2020-08-13', 'CY', 'Cyprus', 'EURO', '14', '1291', '0', '20');
INSERT INTO public.who_global_data_import VALUES (21025, '2020-08-14', 'CY', 'Cyprus', 'EURO', '14', '1305', '0', '20');
INSERT INTO public.who_global_data_import VALUES (21026, '2020-08-15', 'CY', 'Cyprus', 'EURO', '13', '1318', '0', '20');
INSERT INTO public.who_global_data_import VALUES (21027, '2020-08-16', 'CY', 'Cyprus', 'EURO', '14', '1332', '0', '20');
INSERT INTO public.who_global_data_import VALUES (21028, '2020-08-17', 'CY', 'Cyprus', 'EURO', '0', '1332', '0', '20');
INSERT INTO public.who_global_data_import VALUES (21029, '2020-08-18', 'CY', 'Cyprus', 'EURO', '19', '1351', '0', '20');
INSERT INTO public.who_global_data_import VALUES (21030, '2020-08-19', 'CY', 'Cyprus', 'EURO', '8', '1359', '0', '20');
INSERT INTO public.who_global_data_import VALUES (21031, '2020-08-20', 'CY', 'Cyprus', 'EURO', '26', '1385', '1', '21');
INSERT INTO public.who_global_data_import VALUES (21032, '2020-08-21', 'CY', 'Cyprus', 'EURO', '10', '1395', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21033, '2020-08-22', 'CY', 'Cyprus', 'EURO', '11', '1406', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21034, '2020-08-23', 'CY', 'Cyprus', 'EURO', '11', '1417', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21035, '2020-08-24', 'CY', 'Cyprus', 'EURO', '4', '1421', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21036, '2020-08-25', 'CY', 'Cyprus', 'EURO', '30', '1451', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21037, '2020-08-26', 'CY', 'Cyprus', 'EURO', '23', '1474', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21038, '2020-08-27', 'CY', 'Cyprus', 'EURO', '7', '1481', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21039, '2020-08-28', 'CY', 'Cyprus', 'EURO', '0', '1481', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21040, '2020-08-29', 'CY', 'Cyprus', 'EURO', '0', '1481', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21041, '2020-08-30', 'CY', 'Cyprus', 'EURO', '2', '1483', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21042, '2020-08-31', 'CY', 'Cyprus', 'EURO', '4', '1487', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21043, '2020-09-01', 'CY', 'Cyprus', 'EURO', '1', '1488', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21044, '2020-09-02', 'CY', 'Cyprus', 'EURO', '2', '1490', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21045, '2020-09-03', 'CY', 'Cyprus', 'EURO', '5', '1495', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21046, '2020-09-04', 'CY', 'Cyprus', 'EURO', '3', '1498', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21047, '2020-09-05', 'CY', 'Cyprus', 'EURO', '0', '1498', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21048, '2020-09-06', 'CY', 'Cyprus', 'EURO', '9', '1507', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21049, '2020-09-07', 'CY', 'Cyprus', 'EURO', '2', '1509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21050, '2020-09-08', 'CY', 'Cyprus', 'EURO', '1', '1510', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21051, '2020-09-09', 'CY', 'Cyprus', 'EURO', '1', '1511', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21052, '2020-09-10', 'CY', 'Cyprus', 'EURO', '3', '1514', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21053, '2020-09-11', 'CY', 'Cyprus', 'EURO', '3', '1517', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21054, '2020-09-12', 'CY', 'Cyprus', 'EURO', '3', '1520', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21055, '2020-09-13', 'CY', 'Cyprus', 'EURO', '3', '1523', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21056, '2020-09-14', 'CY', 'Cyprus', 'EURO', '3', '1526', '0', '21');
INSERT INTO public.who_global_data_import VALUES (21057, '2020-09-15', 'CY', 'Cyprus', 'EURO', '8', '1534', '1', '22');
INSERT INTO public.who_global_data_import VALUES (21058, '2020-09-16', 'CY', 'Cyprus', 'EURO', '6', '1540', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21059, '2020-09-17', 'CY', 'Cyprus', 'EURO', '8', '1548', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21060, '2020-09-18', 'CY', 'Cyprus', 'EURO', '10', '1558', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21061, '2020-09-19', 'CY', 'Cyprus', 'EURO', '7', '1565', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21062, '2020-09-20', 'CY', 'Cyprus', 'EURO', '15', '1580', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21063, '2020-09-21', 'CY', 'Cyprus', 'EURO', '20', '1600', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21064, '2020-09-22', 'CY', 'Cyprus', 'EURO', '3', '1603', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21065, '2020-09-23', 'CY', 'Cyprus', 'EURO', '15', '1618', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21066, '2020-09-24', 'CY', 'Cyprus', 'EURO', '36', '1654', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21067, '2020-09-25', 'CY', 'Cyprus', 'EURO', '9', '1663', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21068, '2020-09-26', 'CY', 'Cyprus', 'EURO', '8', '1671', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21069, '2020-09-27', 'CY', 'Cyprus', 'EURO', '13', '1684', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21070, '2020-09-28', 'CY', 'Cyprus', 'EURO', '12', '1696', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21071, '2020-09-29', 'CY', 'Cyprus', 'EURO', '17', '1713', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21072, '2020-09-30', 'CY', 'Cyprus', 'EURO', '30', '1743', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21073, '2020-10-01', 'CY', 'Cyprus', 'EURO', '12', '1755', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21074, '2020-10-02', 'CY', 'Cyprus', 'EURO', '17', '1772', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21075, '2020-10-03', 'CY', 'Cyprus', 'EURO', '17', '1789', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21076, '2020-10-04', 'CY', 'Cyprus', 'EURO', '22', '1811', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21077, '2020-10-05', 'CY', 'Cyprus', 'EURO', '13', '1824', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21078, '2020-10-06', 'CY', 'Cyprus', 'EURO', '23', '1847', '0', '22');
INSERT INTO public.who_global_data_import VALUES (21079, '2020-10-07', 'CY', 'Cyprus', 'EURO', '29', '1876', '1', '23');
INSERT INTO public.who_global_data_import VALUES (21080, '2020-10-08', 'CY', 'Cyprus', 'EURO', '21', '1897', '1', '24');
INSERT INTO public.who_global_data_import VALUES (21081, '2020-10-09', 'CY', 'Cyprus', 'EURO', '21', '1918', '0', '24');
INSERT INTO public.who_global_data_import VALUES (21082, '2020-10-10', 'CY', 'Cyprus', 'EURO', '33', '1951', '1', '25');
INSERT INTO public.who_global_data_import VALUES (21083, '2020-10-11', 'CY', 'Cyprus', 'EURO', '35', '1986', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21084, '2020-10-12', 'CY', 'Cyprus', 'EURO', '0', '1986', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21085, '2020-10-13', 'CY', 'Cyprus', 'EURO', '61', '2047', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21086, '2020-10-14', 'CY', 'Cyprus', 'EURO', '0', '2047', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21087, '2020-10-15', 'CY', 'Cyprus', 'EURO', '83', '2130', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21088, '2020-10-16', 'CY', 'Cyprus', 'EURO', '51', '2181', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21089, '2020-10-17', 'CY', 'Cyprus', 'EURO', '198', '2379', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21090, '2020-10-18', 'CY', 'Cyprus', 'EURO', '0', '2379', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21091, '2020-10-19', 'CY', 'Cyprus', 'EURO', '265', '2644', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21092, '2020-10-20', 'CY', 'Cyprus', 'EURO', '43', '2687', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21093, '2020-10-21', 'CY', 'Cyprus', 'EURO', '152', '2839', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21094, '2020-10-22', 'CY', 'Cyprus', 'EURO', '127', '2966', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21095, '2020-10-23', 'CY', 'Cyprus', 'EURO', '188', '3154', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21096, '2020-10-24', 'CY', 'Cyprus', 'EURO', '160', '3314', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21097, '2020-10-25', 'CY', 'Cyprus', 'EURO', '130', '3444', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21098, '2020-10-26', 'CY', 'Cyprus', 'EURO', '101', '3545', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21099, '2020-10-27', 'CY', 'Cyprus', 'EURO', '91', '3636', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21100, '2020-10-28', 'CY', 'Cyprus', 'EURO', '181', '3817', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21101, '2020-10-29', 'CY', 'Cyprus', 'EURO', '0', '3817', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21102, '2020-10-30', 'CY', 'Cyprus', 'EURO', '234', '4051', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21103, '2020-10-31', 'CY', 'Cyprus', 'EURO', '166', '4217', '0', '25');
INSERT INTO public.who_global_data_import VALUES (21104, '2020-11-01', 'CY', 'Cyprus', 'EURO', '149', '4366', '1', '26');
INSERT INTO public.who_global_data_import VALUES (21105, '2020-11-02', 'CY', 'Cyprus', 'EURO', '197', '4563', '0', '26');
INSERT INTO public.who_global_data_import VALUES (21106, '2020-11-03', 'CY', 'Cyprus', 'EURO', '197', '4760', '0', '26');
INSERT INTO public.who_global_data_import VALUES (21107, '2020-11-04', 'CY', 'Cyprus', 'EURO', '174', '4934', '0', '26');
INSERT INTO public.who_global_data_import VALUES (21108, '2020-11-05', 'CY', 'Cyprus', 'EURO', '166', '5100', '0', '26');
INSERT INTO public.who_global_data_import VALUES (21109, '2020-11-06', 'CY', 'Cyprus', 'EURO', '233', '5333', '0', '26');
INSERT INTO public.who_global_data_import VALUES (21110, '2020-11-07', 'CY', 'Cyprus', 'EURO', '224', '5557', '0', '26');
INSERT INTO public.who_global_data_import VALUES (21111, '2020-11-08', 'CY', 'Cyprus', 'EURO', '314', '5871', '1', '27');
INSERT INTO public.who_global_data_import VALUES (21112, '2020-11-09', 'CY', 'Cyprus', 'EURO', '116', '5987', '0', '27');
INSERT INTO public.who_global_data_import VALUES (21113, '2020-11-10', 'CY', 'Cyprus', 'EURO', '111', '6098', '0', '27');
INSERT INTO public.who_global_data_import VALUES (21114, '2020-11-11', 'CY', 'Cyprus', 'EURO', '198', '6296', '2', '29');
INSERT INTO public.who_global_data_import VALUES (21115, '2020-11-12', 'CY', 'Cyprus', 'EURO', '165', '6461', '3', '32');
INSERT INTO public.who_global_data_import VALUES (21116, '2020-11-13', 'CY', 'Cyprus', 'EURO', '185', '6646', '2', '34');
INSERT INTO public.who_global_data_import VALUES (21117, '2020-11-14', 'CY', 'Cyprus', 'EURO', '207', '6853', '4', '38');
INSERT INTO public.who_global_data_import VALUES (21118, '2020-11-15', 'CY', 'Cyprus', 'EURO', '198', '7051', '1', '39');
INSERT INTO public.who_global_data_import VALUES (21119, '2020-11-16', 'CY', 'Cyprus', 'EURO', '127', '7178', '1', '40');
INSERT INTO public.who_global_data_import VALUES (21120, '2020-11-17', 'CY', 'Cyprus', 'EURO', '107', '7285', '0', '40');
INSERT INTO public.who_global_data_import VALUES (21121, '2020-11-18', 'CY', 'Cyprus', 'EURO', '228', '7513', '0', '40');
INSERT INTO public.who_global_data_import VALUES (21122, '2020-11-19', 'CY', 'Cyprus', 'EURO', '198', '7711', '1', '41');
INSERT INTO public.who_global_data_import VALUES (21123, '2020-11-20', 'CY', 'Cyprus', 'EURO', '268', '7979', '0', '41');
INSERT INTO public.who_global_data_import VALUES (21124, '2020-11-21', 'CY', 'Cyprus', 'EURO', '232', '8211', '2', '43');
INSERT INTO public.who_global_data_import VALUES (21125, '2020-11-22', 'CY', 'Cyprus', 'EURO', '245', '8456', '0', '43');
INSERT INTO public.who_global_data_import VALUES (21126, '2020-11-23', 'CY', 'Cyprus', 'EURO', '187', '8643', '1', '44');
INSERT INTO public.who_global_data_import VALUES (21127, '2020-11-24', 'CY', 'Cyprus', 'EURO', '304', '8947', '0', '44');
INSERT INTO public.who_global_data_import VALUES (21128, '2020-11-25', 'CY', 'Cyprus', 'EURO', '252', '9199', '2', '46');
INSERT INTO public.who_global_data_import VALUES (21129, '2020-11-26', 'CY', 'Cyprus', 'EURO', '254', '9453', '1', '47');
INSERT INTO public.who_global_data_import VALUES (21130, '2020-11-27', 'CY', 'Cyprus', 'EURO', '220', '9673', '1', '48');
INSERT INTO public.who_global_data_import VALUES (21131, '2020-11-28', 'CY', 'Cyprus', 'EURO', '310', '9983', '0', '48');
INSERT INTO public.who_global_data_import VALUES (21132, '2020-11-29', 'CY', 'Cyprus', 'EURO', '248', '10231', '0', '48');
INSERT INTO public.who_global_data_import VALUES (21133, '2020-11-30', 'CY', 'Cyprus', 'EURO', '152', '10383', '0', '48');
INSERT INTO public.who_global_data_import VALUES (21134, '2020-12-01', 'CY', 'Cyprus', 'EURO', '182', '10565', '1', '49');
INSERT INTO public.who_global_data_import VALUES (21135, '2020-12-02', 'CY', 'Cyprus', 'EURO', '318', '10883', '0', '49');
INSERT INTO public.who_global_data_import VALUES (21136, '2020-12-03', 'CY', 'Cyprus', 'EURO', '292', '11175', '3', '52');
INSERT INTO public.who_global_data_import VALUES (21137, '2020-12-04', 'CY', 'Cyprus', 'EURO', '348', '11523', '2', '54');
INSERT INTO public.who_global_data_import VALUES (21138, '2020-12-05', 'CY', 'Cyprus', 'EURO', '289', '11812', '3', '57');
INSERT INTO public.who_global_data_import VALUES (21139, '2020-12-06', 'CY', 'Cyprus', 'EURO', '369', '12181', '2', '59');
INSERT INTO public.who_global_data_import VALUES (21140, '2020-12-07', 'CY', 'Cyprus', 'EURO', '270', '12451', '2', '61');
INSERT INTO public.who_global_data_import VALUES (21141, '2020-12-08', 'CY', 'Cyprus', 'EURO', '416', '12867', '2', '63');
INSERT INTO public.who_global_data_import VALUES (21142, '2020-12-09', 'CY', 'Cyprus', 'EURO', '419', '13286', '5', '68');
INSERT INTO public.who_global_data_import VALUES (21143, '2020-12-10', 'CY', 'Cyprus', 'EURO', '363', '13649', '2', '70');
INSERT INTO public.who_global_data_import VALUES (21144, '2020-12-11', 'CY', 'Cyprus', 'EURO', '403', '14052', '2', '72');
INSERT INTO public.who_global_data_import VALUES (21145, '2020-12-12', 'CY', 'Cyprus', 'EURO', '424', '14476', '3', '75');
INSERT INTO public.who_global_data_import VALUES (21146, '2020-12-13', 'CY', 'Cyprus', 'EURO', '324', '14800', '2', '77');
INSERT INTO public.who_global_data_import VALUES (21147, '2020-12-14', 'CY', 'Cyprus', 'EURO', '301', '15101', '1', '78');
INSERT INTO public.who_global_data_import VALUES (21148, '2020-12-15', 'CY', 'Cyprus', 'EURO', '349', '15450', '4', '82');
INSERT INTO public.who_global_data_import VALUES (21149, '2020-12-16', 'CY', 'Cyprus', 'EURO', '339', '15789', '2', '84');
INSERT INTO public.who_global_data_import VALUES (21150, '2020-12-17', 'CY', 'Cyprus', 'EURO', '401', '16190', '1', '85');
INSERT INTO public.who_global_data_import VALUES (21151, '2020-12-18', 'CY', 'Cyprus', 'EURO', '457', '16647', '0', '85');
INSERT INTO public.who_global_data_import VALUES (21152, '2020-12-19', 'CY', 'Cyprus', 'EURO', '410', '17057', '2', '87');
INSERT INTO public.who_global_data_import VALUES (21153, '2020-12-20', 'CY', 'Cyprus', 'EURO', '419', '17476', '2', '89');
INSERT INTO public.who_global_data_import VALUES (21154, '2020-12-21', 'CY', 'Cyprus', 'EURO', '242', '17718', '2', '91');
INSERT INTO public.who_global_data_import VALUES (21155, '2020-12-22', 'CY', 'Cyprus', 'EURO', '286', '18004', '5', '96');
INSERT INTO public.who_global_data_import VALUES (21156, '2020-12-23', 'CY', 'Cyprus', 'EURO', '402', '18406', '5', '101');
INSERT INTO public.who_global_data_import VALUES (21157, '2020-12-24', 'CY', 'Cyprus', 'EURO', '477', '18883', '3', '104');
INSERT INTO public.who_global_data_import VALUES (21158, '2020-12-25', 'CY', 'Cyprus', 'EURO', '433', '19316', '3', '107');
INSERT INTO public.who_global_data_import VALUES (21159, '2020-12-26', 'CY', 'Cyprus', 'EURO', '50', '19366', '2', '109');
INSERT INTO public.who_global_data_import VALUES (21160, '2020-12-27', 'CY', 'Cyprus', 'EURO', '25', '19391', '2', '111');
INSERT INTO public.who_global_data_import VALUES (21161, '2020-12-28', 'CY', 'Cyprus', 'EURO', '266', '19657', '1', '112');
INSERT INTO public.who_global_data_import VALUES (21162, '2020-12-29', 'CY', 'Cyprus', 'EURO', '751', '20408', '1', '113');
INSERT INTO public.who_global_data_import VALUES (21163, '2020-12-30', 'CY', 'Cyprus', 'EURO', '907', '21315', '4', '117');
INSERT INTO public.who_global_data_import VALUES (21164, '2020-12-31', 'CY', 'Cyprus', 'EURO', '704', '22019', '2', '119');
INSERT INTO public.who_global_data_import VALUES (21165, '2021-01-01', 'CY', 'Cyprus', 'EURO', '632', '22651', '6', '125');
INSERT INTO public.who_global_data_import VALUES (21166, '2021-01-02', 'CY', 'Cyprus', 'EURO', '167', '22818', '2', '127');
INSERT INTO public.who_global_data_import VALUES (21167, '2021-01-03', 'CY', 'Cyprus', 'EURO', '627', '23445', '2', '129');
INSERT INTO public.who_global_data_import VALUES (21168, '2021-01-04', 'CY', 'Cyprus', 'EURO', '529', '23974', '2', '131');
INSERT INTO public.who_global_data_import VALUES (21169, '2021-01-05', 'CY', 'Cyprus', 'EURO', '665', '24639', '2', '133');
INSERT INTO public.who_global_data_import VALUES (21170, '2021-01-06', 'CY', 'Cyprus', 'EURO', '569', '25208', '1', '134');
INSERT INTO public.who_global_data_import VALUES (21171, '2021-01-07', 'CY', 'Cyprus', 'EURO', '573', '25781', '4', '138');
INSERT INTO public.who_global_data_import VALUES (21172, '2021-01-08', 'CY', 'Cyprus', 'EURO', '427', '26208', '2', '140');
INSERT INTO public.who_global_data_import VALUES (21173, '2021-01-09', 'CY', 'Cyprus', 'EURO', '466', '26674', '1', '141');
INSERT INTO public.who_global_data_import VALUES (21174, '2021-01-10', 'CY', 'Cyprus', 'EURO', '337', '27011', '6', '147');
INSERT INTO public.who_global_data_import VALUES (21175, '2021-01-11', 'CY', 'Cyprus', 'EURO', '339', '27350', '1', '148');
INSERT INTO public.who_global_data_import VALUES (21176, '2021-01-12', 'CY', 'Cyprus', 'EURO', '288', '27638', '5', '153');
INSERT INTO public.who_global_data_import VALUES (21177, '2021-01-13', 'CY', 'Cyprus', 'EURO', '259', '27897', '4', '157');
INSERT INTO public.who_global_data_import VALUES (21178, '2021-01-14', 'CY', 'Cyprus', 'EURO', '227', '28124', '6', '163');
INSERT INTO public.who_global_data_import VALUES (21179, '2021-01-15', 'CY', 'Cyprus', 'EURO', '241', '28365', '3', '166');
INSERT INTO public.who_global_data_import VALUES (21180, '2021-01-16', 'CY', 'Cyprus', 'EURO', '244', '28609', '0', '166');
INSERT INTO public.who_global_data_import VALUES (21181, '2021-01-17', 'CY', 'Cyprus', 'EURO', '202', '28811', '1', '167');
INSERT INTO public.who_global_data_import VALUES (21182, '2021-01-18', 'CY', 'Cyprus', 'EURO', '157', '28968', '3', '170');
INSERT INTO public.who_global_data_import VALUES (21183, '2021-01-19', 'CY', 'Cyprus', 'EURO', '162', '29130', '5', '175');
INSERT INTO public.who_global_data_import VALUES (21184, '2021-01-20', 'CY', 'Cyprus', 'EURO', '164', '29294', '1', '176');
INSERT INTO public.who_global_data_import VALUES (21185, '2021-01-21', 'CY', 'Cyprus', 'EURO', '178', '29472', '0', '176');
INSERT INTO public.who_global_data_import VALUES (21186, '2021-01-22', 'CY', 'Cyprus', 'EURO', '164', '29636', '2', '178');
INSERT INTO public.who_global_data_import VALUES (21187, '2021-01-23', 'CY', 'Cyprus', 'EURO', '122', '29758', '1', '179');
INSERT INTO public.who_global_data_import VALUES (21188, '2021-01-24', 'CY', 'Cyprus', 'EURO', '129', '29887', '4', '183');
INSERT INTO public.who_global_data_import VALUES (21189, '2021-01-25', 'CY', 'Cyprus', 'EURO', '130', '30017', '3', '186');
INSERT INTO public.who_global_data_import VALUES (21190, '2021-01-26', 'CY', 'Cyprus', 'EURO', '126', '30143', '2', '188');
INSERT INTO public.who_global_data_import VALUES (21191, '2021-01-27', 'CY', 'Cyprus', 'EURO', '109', '30252', '2', '190');
INSERT INTO public.who_global_data_import VALUES (21192, '2021-01-28', 'CY', 'Cyprus', 'EURO', '128', '30380', '3', '193');
INSERT INTO public.who_global_data_import VALUES (21193, '2021-01-29', 'CY', 'Cyprus', 'EURO', '158', '30538', '4', '197');
INSERT INTO public.who_global_data_import VALUES (21194, '2021-01-30', 'CY', 'Cyprus', 'EURO', '119', '30657', '0', '197');
INSERT INTO public.who_global_data_import VALUES (21195, '2021-01-31', 'CY', 'Cyprus', 'EURO', '113', '30770', '0', '197');
INSERT INTO public.who_global_data_import VALUES (21196, '2021-02-01', 'CY', 'Cyprus', 'EURO', '106', '30876', '2', '199');
INSERT INTO public.who_global_data_import VALUES (21197, '2021-02-02', 'CY', 'Cyprus', 'EURO', '120', '30996', '3', '202');
INSERT INTO public.who_global_data_import VALUES (21198, '2021-02-03', 'CY', 'Cyprus', 'EURO', '128', '31124', '0', '202');
INSERT INTO public.who_global_data_import VALUES (21199, '2021-02-04', 'CY', 'Cyprus', 'EURO', '139', '31263', '1', '203');
INSERT INTO public.who_global_data_import VALUES (21200, '2021-02-05', 'CY', 'Cyprus', 'EURO', '116', '31379', '5', '208');
INSERT INTO public.who_global_data_import VALUES (21201, '2020-01-03', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21202, '2020-01-04', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21203, '2020-01-05', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21204, '2020-01-06', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21205, '2020-01-07', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21206, '2020-01-08', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21207, '2020-01-09', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21208, '2020-01-10', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21209, '2020-01-11', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21210, '2020-01-12', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21211, '2020-01-13', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21212, '2020-01-14', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21213, '2020-01-15', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21214, '2020-01-16', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21215, '2020-01-17', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21216, '2020-01-18', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21217, '2020-01-19', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21218, '2020-01-20', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21219, '2020-01-21', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21220, '2020-01-22', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21221, '2020-01-23', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21222, '2020-01-24', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21223, '2020-01-25', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21224, '2020-01-26', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21225, '2020-01-27', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21226, '2020-01-28', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21227, '2020-01-29', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21228, '2020-01-30', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21229, '2020-01-31', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21230, '2020-02-01', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21231, '2020-02-02', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21232, '2020-02-03', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21233, '2020-02-04', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21234, '2020-02-05', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21235, '2020-02-06', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21236, '2020-02-07', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21237, '2020-02-08', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21238, '2020-02-09', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21239, '2020-02-10', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21240, '2020-02-11', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21241, '2020-02-12', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21242, '2020-02-13', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21243, '2020-02-14', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21244, '2020-02-15', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21245, '2020-02-16', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21246, '2020-02-17', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21247, '2020-02-18', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21248, '2020-02-19', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21249, '2020-02-20', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21250, '2020-02-21', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21251, '2020-02-22', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21252, '2020-02-23', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21253, '2020-02-24', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21254, '2020-02-25', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21255, '2020-02-26', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21256, '2020-02-27', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21257, '2020-02-28', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21258, '2020-02-29', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21259, '2020-03-01', 'CZ', 'Czechia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21260, '2020-03-02', 'CZ', 'Czechia', 'EURO', '3', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21261, '2020-03-03', 'CZ', 'Czechia', 'EURO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21262, '2020-03-04', 'CZ', 'Czechia', 'EURO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21263, '2020-03-05', 'CZ', 'Czechia', 'EURO', '3', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21264, '2020-03-06', 'CZ', 'Czechia', 'EURO', '4', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21265, '2020-03-07', 'CZ', 'Czechia', 'EURO', '7', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21266, '2020-03-08', 'CZ', 'Czechia', 'EURO', '7', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21267, '2020-03-09', 'CZ', 'Czechia', 'EURO', '6', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21268, '2020-03-10', 'CZ', 'Czechia', 'EURO', '8', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21269, '2020-03-11', 'CZ', 'Czechia', 'EURO', '23', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21270, '2020-03-12', 'CZ', 'Czechia', 'EURO', '31', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21271, '2020-03-13', 'CZ', 'Czechia', 'EURO', '22', '116', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21272, '2020-03-14', 'CZ', 'Czechia', 'EURO', '34', '150', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21273, '2020-03-15', 'CZ', 'Czechia', 'EURO', '64', '214', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21274, '2020-03-16', 'CZ', 'Czechia', 'EURO', '84', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21275, '2020-03-17', 'CZ', 'Czechia', 'EURO', '46', '344', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21276, '2020-03-18', 'CZ', 'Czechia', 'EURO', '90', '434', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21277, '2020-03-19', 'CZ', 'Czechia', 'EURO', '88', '522', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21278, '2020-03-20', 'CZ', 'Czechia', 'EURO', '172', '694', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21279, '2020-03-21', 'CZ', 'Czechia', 'EURO', '210', '904', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21280, '2020-03-22', 'CZ', 'Czechia', 'EURO', '91', '995', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21281, '2020-03-23', 'CZ', 'Czechia', 'EURO', '170', '1165', '1', '1');
INSERT INTO public.who_global_data_import VALUES (21282, '2020-03-24', 'CZ', 'Czechia', 'EURO', '71', '1236', '0', '1');
INSERT INTO public.who_global_data_import VALUES (21283, '2020-03-25', 'CZ', 'Czechia', 'EURO', '158', '1394', '2', '3');
INSERT INTO public.who_global_data_import VALUES (21284, '2020-03-26', 'CZ', 'Czechia', 'EURO', '260', '1654', '3', '6');
INSERT INTO public.who_global_data_import VALUES (21285, '2020-03-27', 'CZ', 'Czechia', 'EURO', '408', '2062', '3', '9');
INSERT INTO public.who_global_data_import VALUES (21286, '2020-03-28', 'CZ', 'Czechia', 'EURO', '217', '2279', '0', '9');
INSERT INTO public.who_global_data_import VALUES (21287, '2020-03-29', 'CZ', 'Czechia', 'EURO', '384', '2663', '2', '11');
INSERT INTO public.who_global_data_import VALUES (21288, '2020-03-30', 'CZ', 'Czechia', 'EURO', '166', '2829', '5', '16');
INSERT INTO public.who_global_data_import VALUES (21289, '2020-03-31', 'CZ', 'Czechia', 'EURO', '173', '3002', '8', '24');
INSERT INTO public.who_global_data_import VALUES (21290, '2020-04-01', 'CZ', 'Czechia', 'EURO', '306', '3308', '7', '31');
INSERT INTO public.who_global_data_import VALUES (21291, '2020-04-02', 'CZ', 'Czechia', 'EURO', '281', '3589', '8', '39');
INSERT INTO public.who_global_data_import VALUES (21292, '2020-04-03', 'CZ', 'Czechia', 'EURO', '269', '3858', '5', '44');
INSERT INTO public.who_global_data_import VALUES (21293, '2020-04-04', 'CZ', 'Czechia', 'EURO', '332', '4190', '9', '53');
INSERT INTO public.who_global_data_import VALUES (21294, '2020-04-05', 'CZ', 'Czechia', 'EURO', '282', '4472', '6', '59');
INSERT INTO public.who_global_data_import VALUES (21295, '2020-04-06', 'CZ', 'Czechia', 'EURO', '115', '4587', '8', '67');
INSERT INTO public.who_global_data_import VALUES (21296, '2020-04-07', 'CZ', 'Czechia', 'EURO', '235', '4822', '11', '78');
INSERT INTO public.who_global_data_import VALUES (21297, '2020-04-08', 'CZ', 'Czechia', 'EURO', '195', '5017', '10', '88');
INSERT INTO public.who_global_data_import VALUES (21298, '2020-04-09', 'CZ', 'Czechia', 'EURO', '295', '5312', '11', '99');
INSERT INTO public.who_global_data_import VALUES (21299, '2020-04-10', 'CZ', 'Czechia', 'EURO', '257', '5569', '13', '112');
INSERT INTO public.who_global_data_import VALUES (21300, '2020-04-11', 'CZ', 'Czechia', 'EURO', '163', '5732', '7', '119');
INSERT INTO public.who_global_data_import VALUES (21301, '2020-04-12', 'CZ', 'Czechia', 'EURO', '170', '5902', '10', '129');
INSERT INTO public.who_global_data_import VALUES (21302, '2020-04-13', 'CZ', 'Czechia', 'EURO', '89', '5991', '9', '138');
INSERT INTO public.who_global_data_import VALUES (21303, '2020-04-14', 'CZ', 'Czechia', 'EURO', '68', '6059', '5', '143');
INSERT INTO public.who_global_data_import VALUES (21304, '2020-04-15', 'CZ', 'Czechia', 'EURO', '82', '6141', '18', '161');
INSERT INTO public.who_global_data_import VALUES (21305, '2020-04-16', 'CZ', 'Czechia', 'EURO', '162', '6303', '5', '166');
INSERT INTO public.who_global_data_import VALUES (21306, '2020-04-17', 'CZ', 'Czechia', 'EURO', '130', '6433', '3', '169');
INSERT INTO public.who_global_data_import VALUES (21307, '2020-04-18', 'CZ', 'Czechia', 'EURO', '116', '6549', '4', '173');
INSERT INTO public.who_global_data_import VALUES (21308, '2020-04-19', 'CZ', 'Czechia', 'EURO', '105', '6654', '8', '181');
INSERT INTO public.who_global_data_import VALUES (21309, '2020-04-20', 'CZ', 'Czechia', 'EURO', '133', '6787', '7', '188');
INSERT INTO public.who_global_data_import VALUES (21310, '2020-04-21', 'CZ', 'Czechia', 'EURO', '127', '6914', '8', '196');
INSERT INTO public.who_global_data_import VALUES (21311, '2020-04-22', 'CZ', 'Czechia', 'EURO', '127', '7041', '5', '201');
INSERT INTO public.who_global_data_import VALUES (21312, '2020-04-23', 'CZ', 'Czechia', 'EURO', '95', '7136', '9', '210');
INSERT INTO public.who_global_data_import VALUES (21313, '2020-04-24', 'CZ', 'Czechia', 'EURO', '52', '7188', '3', '213');
INSERT INTO public.who_global_data_import VALUES (21314, '2020-04-25', 'CZ', 'Czechia', 'EURO', '85', '7273', '2', '215');
INSERT INTO public.who_global_data_import VALUES (21315, '2020-04-26', 'CZ', 'Czechia', 'EURO', '79', '7352', '3', '218');
INSERT INTO public.who_global_data_import VALUES (21316, '2020-04-27', 'CZ', 'Czechia', 'EURO', '52', '7404', '3', '221');
INSERT INTO public.who_global_data_import VALUES (21317, '2020-04-28', 'CZ', 'Czechia', 'EURO', '45', '7449', '2', '223');
INSERT INTO public.who_global_data_import VALUES (21318, '2020-04-29', 'CZ', 'Czechia', 'EURO', '55', '7504', '4', '227');
INSERT INTO public.who_global_data_import VALUES (21319, '2020-04-30', 'CZ', 'Czechia', 'EURO', '75', '7579', '0', '227');
INSERT INTO public.who_global_data_import VALUES (21320, '2020-05-01', 'CZ', 'Czechia', 'EURO', '103', '7682', '9', '236');
INSERT INTO public.who_global_data_import VALUES (21321, '2020-05-02', 'CZ', 'Czechia', 'EURO', '55', '7737', '4', '240');
INSERT INTO public.who_global_data_import VALUES (21322, '2020-05-03', 'CZ', 'Czechia', 'EURO', '18', '7755', '5', '245');
INSERT INTO public.who_global_data_import VALUES (21323, '2020-05-04', 'CZ', 'Czechia', 'EURO', '26', '7781', '3', '248');
INSERT INTO public.who_global_data_import VALUES (21324, '2020-05-05', 'CZ', 'Czechia', 'EURO', '38', '7819', '4', '252');
INSERT INTO public.who_global_data_import VALUES (21325, '2020-05-06', 'CZ', 'Czechia', 'EURO', '77', '7896', '5', '257');
INSERT INTO public.who_global_data_import VALUES (21326, '2020-05-07', 'CZ', 'Czechia', 'EURO', '78', '7974', '5', '262');
INSERT INTO public.who_global_data_import VALUES (21327, '2020-05-08', 'CZ', 'Czechia', 'EURO', '57', '8031', '8', '270');
INSERT INTO public.who_global_data_import VALUES (21328, '2020-05-09', 'CZ', 'Czechia', 'EURO', '46', '8077', '3', '273');
INSERT INTO public.who_global_data_import VALUES (21329, '2020-05-10', 'CZ', 'Czechia', 'EURO', '18', '8095', '3', '276');
INSERT INTO public.who_global_data_import VALUES (21330, '2020-05-11', 'CZ', 'Czechia', 'EURO', '28', '8123', '4', '280');
INSERT INTO public.who_global_data_import VALUES (21331, '2020-05-12', 'CZ', 'Czechia', 'EURO', '53', '8176', '2', '282');
INSERT INTO public.who_global_data_import VALUES (21332, '2020-05-13', 'CZ', 'Czechia', 'EURO', '45', '8221', '1', '283');
INSERT INTO public.who_global_data_import VALUES (21333, '2020-05-14', 'CZ', 'Czechia', 'EURO', '48', '8269', '7', '290');
INSERT INTO public.who_global_data_import VALUES (21334, '2020-05-15', 'CZ', 'Czechia', 'EURO', '82', '8351', '3', '293');
INSERT INTO public.who_global_data_import VALUES (21335, '2020-05-16', 'CZ', 'Czechia', 'EURO', '55', '8406', '2', '295');
INSERT INTO public.who_global_data_import VALUES (21336, '2020-05-17', 'CZ', 'Czechia', 'EURO', '49', '8455', '1', '296');
INSERT INTO public.who_global_data_import VALUES (21337, '2020-05-18', 'CZ', 'Czechia', 'EURO', '20', '8475', '1', '297');
INSERT INTO public.who_global_data_import VALUES (21338, '2020-05-19', 'CZ', 'Czechia', 'EURO', '111', '8586', '0', '297');
INSERT INTO public.who_global_data_import VALUES (21339, '2020-05-20', 'CZ', 'Czechia', 'EURO', '61', '8647', '5', '302');
INSERT INTO public.who_global_data_import VALUES (21340, '2020-05-21', 'CZ', 'Czechia', 'EURO', '74', '8721', '2', '304');
INSERT INTO public.who_global_data_import VALUES (21341, '2020-05-22', 'CZ', 'Czechia', 'EURO', '33', '8754', '2', '306');
INSERT INTO public.who_global_data_import VALUES (21342, '2020-05-23', 'CZ', 'Czechia', 'EURO', '59', '8813', '6', '312');
INSERT INTO public.who_global_data_import VALUES (21343, '2020-05-24', 'CZ', 'Czechia', 'EURO', '77', '8890', '2', '314');
INSERT INTO public.who_global_data_import VALUES (21344, '2020-05-25', 'CZ', 'Czechia', 'EURO', '67', '8957', '1', '315');
INSERT INTO public.who_global_data_import VALUES (21345, '2020-05-26', 'CZ', 'Czechia', 'EURO', '47', '9004', '2', '317');
INSERT INTO public.who_global_data_import VALUES (21346, '2020-05-27', 'CZ', 'Czechia', 'EURO', '46', '9050', '0', '317');
INSERT INTO public.who_global_data_import VALUES (21347, '2020-05-28', 'CZ', 'Czechia', 'EURO', '36', '9086', '0', '317');
INSERT INTO public.who_global_data_import VALUES (21348, '2020-05-29', 'CZ', 'Czechia', 'EURO', '54', '9140', '2', '319');
INSERT INTO public.who_global_data_import VALUES (21349, '2020-05-30', 'CZ', 'Czechia', 'EURO', '56', '9196', '0', '319');
INSERT INTO public.who_global_data_import VALUES (21350, '2020-05-31', 'CZ', 'Czechia', 'EURO', '34', '9230', '0', '319');
INSERT INTO public.who_global_data_import VALUES (21351, '2020-06-01', 'CZ', 'Czechia', 'EURO', '43', '9273', '1', '320');
INSERT INTO public.who_global_data_import VALUES (21352, '2020-06-02', 'CZ', 'Czechia', 'EURO', '29', '9302', '1', '321');
INSERT INTO public.who_global_data_import VALUES (21353, '2020-06-03', 'CZ', 'Czechia', 'EURO', '62', '9364', '2', '323');
INSERT INTO public.who_global_data_import VALUES (21354, '2020-06-04', 'CZ', 'Czechia', 'EURO', '74', '9438', '1', '324');
INSERT INTO public.who_global_data_import VALUES (21355, '2020-06-05', 'CZ', 'Czechia', 'EURO', '56', '9494', '2', '326');
INSERT INTO public.who_global_data_import VALUES (21356, '2020-06-06', 'CZ', 'Czechia', 'EURO', '35', '9529', '1', '327');
INSERT INTO public.who_global_data_import VALUES (21357, '2020-06-07', 'CZ', 'Czechia', 'EURO', '38', '9567', '0', '327');
INSERT INTO public.who_global_data_import VALUES (21358, '2020-06-08', 'CZ', 'Czechia', 'EURO', '61', '9628', '0', '327');
INSERT INTO public.who_global_data_import VALUES (21359, '2020-06-09', 'CZ', 'Czechia', 'EURO', '69', '9697', '1', '328');
INSERT INTO public.who_global_data_import VALUES (21360, '2020-06-10', 'CZ', 'Czechia', 'EURO', '54', '9751', '0', '328');
INSERT INTO public.who_global_data_import VALUES (21361, '2020-06-11', 'CZ', 'Czechia', 'EURO', '73', '9824', '0', '328');
INSERT INTO public.who_global_data_import VALUES (21362, '2020-06-12', 'CZ', 'Czechia', 'EURO', '62', '9886', '1', '329');
INSERT INTO public.who_global_data_import VALUES (22814, '2020-01-16', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21363, '2020-06-13', 'CZ', 'Czechia', 'EURO', '52', '9938', '0', '329');
INSERT INTO public.who_global_data_import VALUES (21364, '2020-06-14', 'CZ', 'Czechia', 'EURO', '53', '9991', '0', '329');
INSERT INTO public.who_global_data_import VALUES (21365, '2020-06-15', 'CZ', 'Czechia', 'EURO', '33', '10024', '0', '329');
INSERT INTO public.who_global_data_import VALUES (21366, '2020-06-16', 'CZ', 'Czechia', 'EURO', '40', '10064', '1', '330');
INSERT INTO public.who_global_data_import VALUES (21367, '2020-06-17', 'CZ', 'Czechia', 'EURO', '47', '10111', '1', '331');
INSERT INTO public.who_global_data_import VALUES (21368, '2020-06-18', 'CZ', 'Czechia', 'EURO', '51', '10162', '2', '333');
INSERT INTO public.who_global_data_import VALUES (21369, '2020-06-19', 'CZ', 'Czechia', 'EURO', '68', '10230', '1', '334');
INSERT INTO public.who_global_data_import VALUES (21370, '2020-06-20', 'CZ', 'Czechia', 'EURO', '176', '10406', '1', '335');
INSERT INTO public.who_global_data_import VALUES (21371, '2020-06-21', 'CZ', 'Czechia', 'EURO', '42', '10448', '1', '336');
INSERT INTO public.who_global_data_import VALUES (21372, '2020-06-22', 'CZ', 'Czechia', 'EURO', '50', '10498', '0', '336');
INSERT INTO public.who_global_data_import VALUES (21373, '2020-06-23', 'CZ', 'Czechia', 'EURO', '63', '10561', '0', '336');
INSERT INTO public.who_global_data_import VALUES (21374, '2020-06-24', 'CZ', 'Czechia', 'EURO', '89', '10650', '3', '339');
INSERT INTO public.who_global_data_import VALUES (21375, '2020-06-25', 'CZ', 'Czechia', 'EURO', '127', '10777', '4', '343');
INSERT INTO public.who_global_data_import VALUES (21376, '2020-06-26', 'CZ', 'Czechia', 'EURO', '93', '10870', '2', '345');
INSERT INTO public.who_global_data_import VALUES (21377, '2020-06-27', 'CZ', 'Czechia', 'EURO', '168', '11038', '0', '345');
INSERT INTO public.who_global_data_import VALUES (21378, '2020-06-28', 'CZ', 'Czechia', 'EURO', '260', '11298', '2', '347');
INSERT INTO public.who_global_data_import VALUES (21379, '2020-06-29', 'CZ', 'Czechia', 'EURO', '305', '11603', '1', '348');
INSERT INTO public.who_global_data_import VALUES (21380, '2020-06-30', 'CZ', 'Czechia', 'EURO', '202', '11805', '0', '348');
INSERT INTO public.who_global_data_import VALUES (21381, '2020-07-01', 'CZ', 'Czechia', 'EURO', '149', '11954', '1', '349');
INSERT INTO public.who_global_data_import VALUES (21382, '2020-07-02', 'CZ', 'Czechia', 'EURO', '92', '12046', '0', '349');
INSERT INTO public.who_global_data_import VALUES (21383, '2020-07-03', 'CZ', 'Czechia', 'EURO', '132', '12178', '2', '351');
INSERT INTO public.who_global_data_import VALUES (21384, '2020-07-04', 'CZ', 'Czechia', 'EURO', '141', '12319', '1', '352');
INSERT INTO public.who_global_data_import VALUES (21385, '2020-07-05', 'CZ', 'Czechia', 'EURO', '121', '12440', '-1', '351');
INSERT INTO public.who_global_data_import VALUES (21386, '2020-07-06', 'CZ', 'Czechia', 'EURO', '75', '12515', '-3', '348');
INSERT INTO public.who_global_data_import VALUES (21387, '2020-07-07', 'CZ', 'Czechia', 'EURO', '51', '12566', '2', '350');
INSERT INTO public.who_global_data_import VALUES (21388, '2020-07-08', 'CZ', 'Czechia', 'EURO', '119', '12685', '1', '351');
INSERT INTO public.who_global_data_import VALUES (21389, '2020-07-09', 'CZ', 'Czechia', 'EURO', '129', '12814', '0', '351');
INSERT INTO public.who_global_data_import VALUES (21390, '2020-07-10', 'CZ', 'Czechia', 'EURO', '105', '12919', '1', '352');
INSERT INTO public.who_global_data_import VALUES (21391, '2020-07-11', 'CZ', 'Czechia', 'EURO', '143', '13062', '0', '352');
INSERT INTO public.who_global_data_import VALUES (21392, '2020-07-12', 'CZ', 'Czechia', 'EURO', '53', '13115', '0', '352');
INSERT INTO public.who_global_data_import VALUES (21393, '2020-07-13', 'CZ', 'Czechia', 'EURO', '59', '13174', '0', '352');
INSERT INTO public.who_global_data_import VALUES (21394, '2020-07-14', 'CZ', 'Czechia', 'EURO', '64', '13238', '1', '353');
INSERT INTO public.who_global_data_import VALUES (21395, '2020-07-15', 'CZ', 'Czechia', 'EURO', '103', '13341', '2', '355');
INSERT INTO public.who_global_data_import VALUES (21396, '2020-07-16', 'CZ', 'Czechia', 'EURO', '134', '13475', '0', '355');
INSERT INTO public.who_global_data_import VALUES (21397, '2020-07-17', 'CZ', 'Czechia', 'EURO', '137', '13612', '0', '355');
INSERT INTO public.who_global_data_import VALUES (21398, '2020-07-18', 'CZ', 'Czechia', 'EURO', '130', '13742', '3', '358');
INSERT INTO public.who_global_data_import VALUES (21399, '2020-07-19', 'CZ', 'Czechia', 'EURO', '113', '13855', '0', '358');
INSERT INTO public.who_global_data_import VALUES (21400, '2020-07-20', 'CZ', 'Czechia', 'EURO', '90', '13945', '1', '359');
INSERT INTO public.who_global_data_import VALUES (21401, '2020-07-21', 'CZ', 'Czechia', 'EURO', '153', '14098', '0', '359');
INSERT INTO public.who_global_data_import VALUES (21402, '2020-07-22', 'CZ', 'Czechia', 'EURO', '226', '14324', '1', '360');
INSERT INTO public.who_global_data_import VALUES (21403, '2020-07-23', 'CZ', 'Czechia', 'EURO', '246', '14570', '4', '364');
INSERT INTO public.who_global_data_import VALUES (21404, '2020-07-24', 'CZ', 'Czechia', 'EURO', '230', '14800', '1', '365');
INSERT INTO public.who_global_data_import VALUES (21405, '2020-07-25', 'CZ', 'Czechia', 'EURO', '281', '15081', '3', '368');
INSERT INTO public.who_global_data_import VALUES (21406, '2020-07-26', 'CZ', 'Czechia', 'EURO', '131', '15212', '0', '368');
INSERT INTO public.who_global_data_import VALUES (21407, '2020-07-27', 'CZ', 'Czechia', 'EURO', '112', '15324', '3', '371');
INSERT INTO public.who_global_data_import VALUES (21408, '2020-07-28', 'CZ', 'Czechia', 'EURO', '192', '15516', '2', '373');
INSERT INTO public.who_global_data_import VALUES (21409, '2020-07-29', 'CZ', 'Czechia', 'EURO', '283', '15799', '0', '373');
INSERT INTO public.who_global_data_import VALUES (21410, '2020-07-30', 'CZ', 'Czechia', 'EURO', '294', '16093', '1', '374');
INSERT INTO public.who_global_data_import VALUES (21411, '2020-07-31', 'CZ', 'Czechia', 'EURO', '249', '16342', '5', '379');
INSERT INTO public.who_global_data_import VALUES (21412, '2020-08-01', 'CZ', 'Czechia', 'EURO', '232', '16574', '3', '382');
INSERT INTO public.who_global_data_import VALUES (21413, '2020-08-02', 'CZ', 'Czechia', 'EURO', '125', '16699', '1', '383');
INSERT INTO public.who_global_data_import VALUES (21414, '2020-08-03', 'CZ', 'Czechia', 'EURO', '101', '16800', '0', '383');
INSERT INTO public.who_global_data_import VALUES (21415, '2020-08-04', 'CZ', 'Czechia', 'EURO', '208', '17008', '0', '383');
INSERT INTO public.who_global_data_import VALUES (21416, '2020-08-05', 'CZ', 'Czechia', 'EURO', '278', '17286', '0', '383');
INSERT INTO public.who_global_data_import VALUES (21417, '2020-08-06', 'CZ', 'Czechia', 'EURO', '243', '17529', '5', '388');
INSERT INTO public.who_global_data_import VALUES (21418, '2020-08-07', 'CZ', 'Czechia', 'EURO', '211', '17740', '1', '389');
INSERT INTO public.who_global_data_import VALUES (21419, '2020-08-08', 'CZ', 'Czechia', 'EURO', '320', '18060', '0', '389');
INSERT INTO public.who_global_data_import VALUES (21420, '2020-08-09', 'CZ', 'Czechia', 'EURO', '175', '18235', '0', '389');
INSERT INTO public.who_global_data_import VALUES (21421, '2020-08-10', 'CZ', 'Czechia', 'EURO', '120', '18355', '0', '389');
INSERT INTO public.who_global_data_import VALUES (21422, '2020-08-11', 'CZ', 'Czechia', 'EURO', '139', '18494', '0', '389');
INSERT INTO public.who_global_data_import VALUES (21423, '2020-08-12', 'CZ', 'Czechia', 'EURO', '289', '18783', '2', '391');
INSERT INTO public.who_global_data_import VALUES (21424, '2020-08-13', 'CZ', 'Czechia', 'EURO', '292', '19075', '0', '391');
INSERT INTO public.who_global_data_import VALUES (21425, '2020-08-14', 'CZ', 'Czechia', 'EURO', '326', '19401', '0', '391');
INSERT INTO public.who_global_data_import VALUES (21426, '2020-08-15', 'CZ', 'Czechia', 'EURO', '292', '19693', '3', '394');
INSERT INTO public.who_global_data_import VALUES (21427, '2020-08-16', 'CZ', 'Czechia', 'EURO', '198', '19891', '1', '395');
INSERT INTO public.who_global_data_import VALUES (21428, '2020-08-17', 'CZ', 'Czechia', 'EURO', '121', '20012', '2', '397');
INSERT INTO public.who_global_data_import VALUES (21429, '2020-08-18', 'CZ', 'Czechia', 'EURO', '190', '20202', '2', '399');
INSERT INTO public.who_global_data_import VALUES (21430, '2020-08-19', 'CZ', 'Czechia', 'EURO', '281', '20483', '2', '401');
INSERT INTO public.who_global_data_import VALUES (21431, '2020-08-20', 'CZ', 'Czechia', 'EURO', '315', '20798', '3', '404');
INSERT INTO public.who_global_data_import VALUES (21432, '2020-08-21', 'CZ', 'Czechia', 'EURO', '247', '21045', '2', '406');
INSERT INTO public.who_global_data_import VALUES (21433, '2020-08-22', 'CZ', 'Czechia', 'EURO', '506', '21551', '5', '411');
INSERT INTO public.who_global_data_import VALUES (21434, '2020-08-23', 'CZ', 'Czechia', 'EURO', '239', '21790', '0', '411');
INSERT INTO public.who_global_data_import VALUES (21435, '2020-08-24', 'CZ', 'Czechia', 'EURO', '133', '21923', '1', '412');
INSERT INTO public.who_global_data_import VALUES (21436, '2020-08-25', 'CZ', 'Czechia', 'EURO', '258', '22181', '3', '415');
INSERT INTO public.who_global_data_import VALUES (21437, '2020-08-26', 'CZ', 'Czechia', 'EURO', '367', '22548', '1', '416');
INSERT INTO public.who_global_data_import VALUES (21438, '2020-08-27', 'CZ', 'Czechia', 'EURO', '403', '22951', '2', '418');
INSERT INTO public.who_global_data_import VALUES (21439, '2020-08-28', 'CZ', 'Czechia', 'EURO', '349', '23300', '0', '418');
INSERT INTO public.who_global_data_import VALUES (21440, '2020-08-29', 'CZ', 'Czechia', 'EURO', '477', '23777', '1', '419');
INSERT INTO public.who_global_data_import VALUES (21441, '2020-08-30', 'CZ', 'Czechia', 'EURO', '317', '24094', '2', '421');
INSERT INTO public.who_global_data_import VALUES (21442, '2020-08-31', 'CZ', 'Czechia', 'EURO', '273', '24367', '2', '423');
INSERT INTO public.who_global_data_import VALUES (21443, '2020-09-01', 'CZ', 'Czechia', 'EURO', '251', '24618', '1', '424');
INSERT INTO public.who_global_data_import VALUES (21444, '2020-09-02', 'CZ', 'Czechia', 'EURO', '499', '25117', '1', '425');
INSERT INTO public.who_global_data_import VALUES (21445, '2020-09-03', 'CZ', 'Czechia', 'EURO', '656', '25773', '0', '425');
INSERT INTO public.who_global_data_import VALUES (21446, '2020-09-04', 'CZ', 'Czechia', 'EURO', '679', '26452', '1', '426');
INSERT INTO public.who_global_data_import VALUES (21447, '2020-09-05', 'CZ', 'Czechia', 'EURO', '797', '27249', '3', '429');
INSERT INTO public.who_global_data_import VALUES (21448, '2020-09-06', 'CZ', 'Czechia', 'EURO', '503', '27752', '2', '431');
INSERT INTO public.who_global_data_import VALUES (21449, '2020-09-07', 'CZ', 'Czechia', 'EURO', '404', '28156', '5', '436');
INSERT INTO public.who_global_data_import VALUES (21450, '2020-09-08', 'CZ', 'Czechia', 'EURO', '560', '28716', '1', '437');
INSERT INTO public.who_global_data_import VALUES (21451, '2020-09-09', 'CZ', 'Czechia', 'EURO', '1161', '29877', '4', '441');
INSERT INTO public.who_global_data_import VALUES (21452, '2020-09-10', 'CZ', 'Czechia', 'EURO', '1159', '31036', '3', '444');
INSERT INTO public.who_global_data_import VALUES (21453, '2020-09-11', 'CZ', 'Czechia', 'EURO', '1377', '32413', '4', '448');
INSERT INTO public.who_global_data_import VALUES (21454, '2020-09-12', 'CZ', 'Czechia', 'EURO', '1447', '33860', '2', '450');
INSERT INTO public.who_global_data_import VALUES (21455, '2020-09-13', 'CZ', 'Czechia', 'EURO', '1541', '35401', '3', '453');
INSERT INTO public.who_global_data_import VALUES (21456, '2020-09-14', 'CZ', 'Czechia', 'EURO', '787', '36188', '3', '456');
INSERT INTO public.who_global_data_import VALUES (21457, '2020-09-15', 'CZ', 'Czechia', 'EURO', '1034', '37222', '9', '465');
INSERT INTO public.who_global_data_import VALUES (21458, '2020-09-16', 'CZ', 'Czechia', 'EURO', '1674', '38896', '11', '476');
INSERT INTO public.who_global_data_import VALUES (21459, '2020-09-17', 'CZ', 'Czechia', 'EURO', '2136', '41032', '6', '482');
INSERT INTO public.who_global_data_import VALUES (21460, '2020-09-18', 'CZ', 'Czechia', 'EURO', '3123', '44155', '7', '489');
INSERT INTO public.who_global_data_import VALUES (21461, '2020-09-19', 'CZ', 'Czechia', 'EURO', '2107', '46262', '6', '495');
INSERT INTO public.who_global_data_import VALUES (21462, '2020-09-20', 'CZ', 'Czechia', 'EURO', '2044', '48306', '4', '499');
INSERT INTO public.who_global_data_import VALUES (21463, '2020-09-21', 'CZ', 'Czechia', 'EURO', '934', '49240', '4', '503');
INSERT INTO public.who_global_data_import VALUES (21464, '2020-09-22', 'CZ', 'Czechia', 'EURO', '1524', '50764', '19', '522');
INSERT INTO public.who_global_data_import VALUES (21465, '2020-09-23', 'CZ', 'Czechia', 'EURO', '2394', '53158', '9', '531');
INSERT INTO public.who_global_data_import VALUES (21466, '2020-09-24', 'CZ', 'Czechia', 'EURO', '2306', '55464', '24', '555');
INSERT INTO public.who_global_data_import VALUES (21467, '2020-09-25', 'CZ', 'Czechia', 'EURO', '2910', '58374', '12', '567');
INSERT INTO public.who_global_data_import VALUES (21468, '2020-09-26', 'CZ', 'Czechia', 'EURO', '2944', '61318', '14', '581');
INSERT INTO public.who_global_data_import VALUES (22815, '2020-01-17', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21469, '2020-09-27', 'CZ', 'Czechia', 'EURO', '1976', '63294', '10', '591');
INSERT INTO public.who_global_data_import VALUES (21470, '2020-09-28', 'CZ', 'Czechia', 'EURO', '1303', '64597', '15', '606');
INSERT INTO public.who_global_data_import VALUES (21471, '2020-09-29', 'CZ', 'Czechia', 'EURO', '1286', '65883', '12', '618');
INSERT INTO public.who_global_data_import VALUES (21472, '2020-09-30', 'CZ', 'Czechia', 'EURO', '1960', '67843', '18', '636');
INSERT INTO public.who_global_data_import VALUES (21473, '2020-10-01', 'CZ', 'Czechia', 'EURO', '1076', '68919', '19', '655');
INSERT INTO public.who_global_data_import VALUES (21474, '2020-10-02', 'CZ', 'Czechia', 'EURO', '5336', '74255', '23', '678');
INSERT INTO public.who_global_data_import VALUES (21475, '2020-10-03', 'CZ', 'Czechia', 'EURO', '3796', '78051', '21', '699');
INSERT INTO public.who_global_data_import VALUES (21476, '2020-10-04', 'CZ', 'Czechia', 'EURO', '2554', '80605', '12', '711');
INSERT INTO public.who_global_data_import VALUES (21477, '2020-10-05', 'CZ', 'Czechia', 'EURO', '1841', '82446', '16', '727');
INSERT INTO public.who_global_data_import VALUES (21478, '2020-10-06', 'CZ', 'Czechia', 'EURO', '3120', '85566', '31', '758');
INSERT INTO public.who_global_data_import VALUES (21479, '2020-10-07', 'CZ', 'Czechia', 'EURO', '4456', '90022', '36', '794');
INSERT INTO public.who_global_data_import VALUES (21480, '2020-10-08', 'CZ', 'Czechia', 'EURO', '5338', '95360', '35', '829');
INSERT INTO public.who_global_data_import VALUES (21481, '2020-10-09', 'CZ', 'Czechia', 'EURO', '5397', '100757', '40', '869');
INSERT INTO public.who_global_data_import VALUES (21482, '2020-10-10', 'CZ', 'Czechia', 'EURO', '8617', '109374', '36', '905');
INSERT INTO public.who_global_data_import VALUES (21483, '2020-10-11', 'CZ', 'Czechia', 'EURO', '4633', '114007', '90', '995');
INSERT INTO public.who_global_data_import VALUES (21484, '2020-10-12', 'CZ', 'Czechia', 'EURO', '3103', '117110', '39', '1034');
INSERT INTO public.who_global_data_import VALUES (21485, '2020-10-13', 'CZ', 'Czechia', 'EURO', '4311', '121421', '17', '1051');
INSERT INTO public.who_global_data_import VALUES (21486, '2020-10-14', 'CZ', 'Czechia', 'EURO', '8326', '129747', '55', '1106');
INSERT INTO public.who_global_data_import VALUES (21487, '2020-10-15', 'CZ', 'Czechia', 'EURO', '9543', '139290', '66', '1172');
INSERT INTO public.who_global_data_import VALUES (21488, '2020-10-16', 'CZ', 'Czechia', 'EURO', '9720', '149010', '58', '1230');
INSERT INTO public.who_global_data_import VALUES (21489, '2020-10-17', 'CZ', 'Czechia', 'EURO', '11102', '160112', '53', '1283');
INSERT INTO public.who_global_data_import VALUES (21490, '2020-10-18', 'CZ', 'Czechia', 'EURO', '8715', '168827', '69', '1352');
INSERT INTO public.who_global_data_import VALUES (21491, '2020-10-19', 'CZ', 'Czechia', 'EURO', '5058', '173885', '70', '1422');
INSERT INTO public.who_global_data_import VALUES (21492, '2020-10-20', 'CZ', 'Czechia', 'EURO', '8077', '181962', '91', '1513');
INSERT INTO public.who_global_data_import VALUES (21493, '2020-10-21', 'CZ', 'Czechia', 'EURO', '11984', '193946', '106', '1619');
INSERT INTO public.who_global_data_import VALUES (21494, '2020-10-22', 'CZ', 'Czechia', 'EURO', '14969', '208915', '120', '1739');
INSERT INTO public.who_global_data_import VALUES (21495, '2020-10-23', 'CZ', 'Czechia', 'EURO', '14150', '223065', '106', '1845');
INSERT INTO public.who_global_data_import VALUES (21496, '2020-10-24', 'CZ', 'Czechia', 'EURO', '15258', '238323', '126', '1971');
INSERT INTO public.who_global_data_import VALUES (21497, '2020-10-25', 'CZ', 'Czechia', 'EURO', '12474', '250797', '106', '2077');
INSERT INTO public.who_global_data_import VALUES (21498, '2020-10-26', 'CZ', 'Czechia', 'EURO', '7300', '258097', '124', '2201');
INSERT INTO public.who_global_data_import VALUES (21499, '2020-10-27', 'CZ', 'Czechia', 'EURO', '10273', '268370', '164', '2365');
INSERT INTO public.who_global_data_import VALUES (21500, '2020-10-28', 'CZ', 'Czechia', 'EURO', '15663', '284033', '182', '2547');
INSERT INTO public.who_global_data_import VALUES (21501, '2020-10-29', 'CZ', 'Czechia', 'EURO', '12980', '297013', '128', '2675');
INSERT INTO public.who_global_data_import VALUES (21502, '2020-10-30', 'CZ', 'Czechia', 'EURO', '13055', '310068', '187', '2862');
INSERT INTO public.who_global_data_import VALUES (21503, '2020-10-31', 'CZ', 'Czechia', 'EURO', '13605', '323673', '216', '3078');
INSERT INTO public.who_global_data_import VALUES (21504, '2020-11-01', 'CZ', 'Czechia', 'EURO', '11429', '335102', '173', '3251');
INSERT INTO public.who_global_data_import VALUES (21505, '2020-11-02', 'CZ', 'Czechia', 'EURO', '6542', '341644', '178', '3429');
INSERT INTO public.who_global_data_import VALUES (21506, '2020-11-03', 'CZ', 'Czechia', 'EURO', '9252', '350896', '225', '3654');
INSERT INTO public.who_global_data_import VALUES (21507, '2020-11-04', 'CZ', 'Czechia', 'EURO', '12089', '362985', '259', '3913');
INSERT INTO public.who_global_data_import VALUES (21508, '2020-11-05', 'CZ', 'Czechia', 'EURO', '15731', '378716', '220', '4133');
INSERT INTO public.who_global_data_import VALUES (21509, '2020-11-06', 'CZ', 'Czechia', 'EURO', '13229', '391945', '197', '4330');
INSERT INTO public.who_global_data_import VALUES (21510, '2020-11-07', 'CZ', 'Czechia', 'EURO', '11552', '403497', '196', '4526');
INSERT INTO public.who_global_data_import VALUES (21511, '2020-11-08', 'CZ', 'Czechia', 'EURO', '7723', '411220', '155', '4681');
INSERT INTO public.who_global_data_import VALUES (21512, '2020-11-09', 'CZ', 'Czechia', 'EURO', '3608', '414828', '177', '4858');
INSERT INTO public.who_global_data_import VALUES (21513, '2020-11-10', 'CZ', 'Czechia', 'EURO', '6047', '420875', '216', '5074');
INSERT INTO public.who_global_data_import VALUES (21514, '2020-11-11', 'CZ', 'Czechia', 'EURO', '9005', '429880', '249', '5323');
INSERT INTO public.who_global_data_import VALUES (21515, '2020-11-12', 'CZ', 'Czechia', 'EURO', '8925', '438805', '247', '5570');
INSERT INTO public.who_global_data_import VALUES (21516, '2020-11-13', 'CZ', 'Czechia', 'EURO', '7870', '446675', '185', '5755');
INSERT INTO public.who_global_data_import VALUES (21517, '2020-11-14', 'CZ', 'Czechia', 'EURO', '7355', '454030', '171', '5926');
INSERT INTO public.who_global_data_import VALUES (21518, '2020-11-15', 'CZ', 'Czechia', 'EURO', '4199', '458229', '132', '6058');
INSERT INTO public.who_global_data_import VALUES (21519, '2020-11-16', 'CZ', 'Czechia', 'EURO', '1887', '460116', '150', '6208');
INSERT INTO public.who_global_data_import VALUES (21520, '2020-11-17', 'CZ', 'Czechia', 'EURO', '5407', '465523', '208', '6416');
INSERT INTO public.who_global_data_import VALUES (21521, '2020-11-18', 'CZ', 'Czechia', 'EURO', '4246', '469769', '142', '6558');
INSERT INTO public.who_global_data_import VALUES (21522, '2020-11-19', 'CZ', 'Czechia', 'EURO', '5515', '475284', '182', '6740');
INSERT INTO public.who_global_data_import VALUES (21523, '2020-11-20', 'CZ', 'Czechia', 'EURO', '6471', '481755', '134', '6874');
INSERT INTO public.who_global_data_import VALUES (21524, '2020-11-21', 'CZ', 'Czechia', 'EURO', '5808', '487563', '147', '7021');
INSERT INTO public.who_global_data_import VALUES (21525, '2020-11-22', 'CZ', 'Czechia', 'EURO', '3187', '490750', '74', '7095');
INSERT INTO public.who_global_data_import VALUES (21526, '2020-11-23', 'CZ', 'Czechia', 'EURO', '1513', '492263', '101', '7196');
INSERT INTO public.who_global_data_import VALUES (21527, '2020-11-24', 'CZ', 'Czechia', 'EURO', '4375', '496638', '164', '7360');
INSERT INTO public.who_global_data_import VALUES (21528, '2020-11-25', 'CZ', 'Czechia', 'EURO', '5896', '502534', '139', '7499');
INSERT INTO public.who_global_data_import VALUES (21529, '2020-11-26', 'CZ', 'Czechia', 'EURO', '2681', '505215', '112', '7611');
INSERT INTO public.who_global_data_import VALUES (21530, '2020-11-27', 'CZ', 'Czechia', 'EURO', '6305', '511520', '168', '7779');
INSERT INTO public.who_global_data_import VALUES (21531, '2020-11-28', 'CZ', 'Czechia', 'EURO', '4464', '515984', '188', '7967');
INSERT INTO public.who_global_data_import VALUES (21532, '2020-11-29', 'CZ', 'Czechia', 'EURO', '2665', '518649', '87', '8054');
INSERT INTO public.who_global_data_import VALUES (21533, '2020-11-30', 'CZ', 'Czechia', 'EURO', '1074', '519723', '84', '8138');
INSERT INTO public.who_global_data_import VALUES (21534, '2020-12-01', 'CZ', 'Czechia', 'EURO', '3575', '523298', '157', '8295');
INSERT INTO public.who_global_data_import VALUES (21535, '2020-12-02', 'CZ', 'Czechia', 'EURO', '5176', '528474', '112', '8407');
INSERT INTO public.who_global_data_import VALUES (21536, '2020-12-03', 'CZ', 'Czechia', 'EURO', '4568', '533042', '108', '8515');
INSERT INTO public.who_global_data_import VALUES (21537, '2020-12-04', 'CZ', 'Czechia', 'EURO', '4621', '537663', '126', '8641');
INSERT INTO public.who_global_data_import VALUES (21538, '2020-12-05', 'CZ', 'Czechia', 'EURO', '4743', '542406', '97', '8738');
INSERT INTO public.who_global_data_import VALUES (21539, '2020-12-06', 'CZ', 'Czechia', 'EURO', '1773', '544179', '77', '8815');
INSERT INTO public.who_global_data_import VALUES (21540, '2020-12-07', 'CZ', 'Czechia', 'EURO', '2654', '546833', '87', '8902');
INSERT INTO public.who_global_data_import VALUES (21541, '2020-12-08', 'CZ', 'Czechia', 'EURO', '4237', '551070', '134', '9036');
INSERT INTO public.who_global_data_import VALUES (21542, '2020-12-09', 'CZ', 'Czechia', 'EURO', '5857', '556927', '100', '9136');
INSERT INTO public.who_global_data_import VALUES (21543, '2020-12-10', 'CZ', 'Czechia', 'EURO', '6406', '563333', '90', '9226');
INSERT INTO public.who_global_data_import VALUES (21544, '2020-12-11', 'CZ', 'Czechia', 'EURO', '5872', '569205', '115', '9341');
INSERT INTO public.who_global_data_import VALUES (21545, '2020-12-12', 'CZ', 'Czechia', 'EURO', '6217', '575422', '109', '9450');
INSERT INTO public.who_global_data_import VALUES (21546, '2020-12-13', 'CZ', 'Czechia', 'EURO', '3657', '579079', '85', '9535');
INSERT INTO public.who_global_data_import VALUES (21547, '2020-12-14', 'CZ', 'Czechia', 'EURO', '2000', '581079', '74', '9609');
INSERT INTO public.who_global_data_import VALUES (21548, '2020-12-15', 'CZ', 'Czechia', 'EURO', '5172', '586251', '134', '9743');
INSERT INTO public.who_global_data_import VALUES (21549, '2020-12-16', 'CZ', 'Czechia', 'EURO', '7897', '594148', '139', '9882');
INSERT INTO public.who_global_data_import VALUES (21550, '2020-12-17', 'CZ', 'Czechia', 'EURO', '8256', '602404', '154', '10036');
INSERT INTO public.who_global_data_import VALUES (21551, '2020-12-18', 'CZ', 'Czechia', 'EURO', '7602', '610006', '127', '10163');
INSERT INTO public.who_global_data_import VALUES (21552, '2020-12-19', 'CZ', 'Czechia', 'EURO', '8830', '618836', '108', '10271');
INSERT INTO public.who_global_data_import VALUES (21553, '2020-12-20', 'CZ', 'Czechia', 'EURO', '5304', '624140', '60', '10331');
INSERT INTO public.who_global_data_import VALUES (21554, '2020-12-21', 'CZ', 'Czechia', 'EURO', '3383', '627523', '80', '10411');
INSERT INTO public.who_global_data_import VALUES (21555, '2020-12-22', 'CZ', 'Czechia', 'EURO', '7891', '635414', '151', '10562');
INSERT INTO public.who_global_data_import VALUES (21556, '2020-12-23', 'CZ', 'Czechia', 'EURO', '10898', '646312', '102', '10664');
INSERT INTO public.who_global_data_import VALUES (21557, '2020-12-24', 'CZ', 'Czechia', 'EURO', '14149', '660461', '112', '10776');
INSERT INTO public.who_global_data_import VALUES (21558, '2020-12-25', 'CZ', 'Czechia', 'EURO', '4402', '664863', '83', '10859');
INSERT INTO public.who_global_data_import VALUES (21559, '2020-12-26', 'CZ', 'Czechia', 'EURO', '2706', '667569', '91', '10950');
INSERT INTO public.who_global_data_import VALUES (21560, '2020-12-27', 'CZ', 'Czechia', 'EURO', '3030', '670599', '94', '11044');
INSERT INTO public.who_global_data_import VALUES (21561, '2020-12-28', 'CZ', 'Czechia', 'EURO', '3741', '674340', '108', '11152');
INSERT INTO public.who_global_data_import VALUES (21562, '2020-12-29', 'CZ', 'Czechia', 'EURO', '10862', '685202', '150', '11302');
INSERT INTO public.who_global_data_import VALUES (21563, '2020-12-30', 'CZ', 'Czechia', 'EURO', '16420', '701622', '127', '11429');
INSERT INTO public.who_global_data_import VALUES (21564, '2020-12-31', 'CZ', 'Czechia', 'EURO', '17039', '718661', '151', '11580');
INSERT INTO public.who_global_data_import VALUES (21565, '2021-01-01', 'CZ', 'Czechia', 'EURO', '13361', '732022', '131', '11711');
INSERT INTO public.who_global_data_import VALUES (21566, '2021-01-02', 'CZ', 'Czechia', 'EURO', '3447', '735469', '116', '11827');
INSERT INTO public.who_global_data_import VALUES (21567, '2021-01-03', 'CZ', 'Czechia', 'EURO', '5012', '740481', '133', '11960');
INSERT INTO public.who_global_data_import VALUES (21568, '2021-01-04', 'CZ', 'Czechia', 'EURO', '6233', '746714', '110', '12070');
INSERT INTO public.who_global_data_import VALUES (21569, '2021-01-05', 'CZ', 'Czechia', 'EURO', '12921', '759635', '187', '12257');
INSERT INTO public.who_global_data_import VALUES (21570, '2021-01-06', 'CZ', 'Czechia', 'EURO', '17332', '776967', '179', '12436');
INSERT INTO public.who_global_data_import VALUES (21571, '2021-01-07', 'CZ', 'Czechia', 'EURO', '17773', '794740', '185', '12621');
INSERT INTO public.who_global_data_import VALUES (21572, '2021-01-08', 'CZ', 'Czechia', 'EURO', '14861', '809601', '179', '12800');
INSERT INTO public.who_global_data_import VALUES (21573, '2021-01-09', 'CZ', 'Czechia', 'EURO', '13115', '822716', '178', '12978');
INSERT INTO public.who_global_data_import VALUES (21574, '2021-01-10', 'CZ', 'Czechia', 'EURO', '8449', '831165', '137', '13115');
INSERT INTO public.who_global_data_import VALUES (21575, '2021-01-11', 'CZ', 'Czechia', 'EURO', '4289', '835454', '157', '13272');
INSERT INTO public.who_global_data_import VALUES (21576, '2021-01-12', 'CZ', 'Czechia', 'EURO', '9345', '844799', '213', '13485');
INSERT INTO public.who_global_data_import VALUES (21577, '2021-01-13', 'CZ', 'Czechia', 'EURO', '10801', '855600', '171', '13656');
INSERT INTO public.who_global_data_import VALUES (21578, '2021-01-14', 'CZ', 'Czechia', 'EURO', '10922', '866522', '200', '13856');
INSERT INTO public.who_global_data_import VALUES (21579, '2021-01-15', 'CZ', 'Czechia', 'EURO', '8083', '874605', '173', '14029');
INSERT INTO public.who_global_data_import VALUES (21580, '2021-01-16', 'CZ', 'Czechia', 'EURO', '9301', '883906', '186', '14215');
INSERT INTO public.who_global_data_import VALUES (21581, '2021-01-17', 'CZ', 'Czechia', 'EURO', '5253', '889159', '123', '14338');
INSERT INTO public.who_global_data_import VALUES (21582, '2021-01-18', 'CZ', 'Czechia', 'EURO', '2693', '891852', '111', '14449');
INSERT INTO public.who_global_data_import VALUES (21583, '2021-01-19', 'CZ', 'Czechia', 'EURO', '7651', '899503', '197', '14646');
INSERT INTO public.who_global_data_import VALUES (21584, '2021-01-20', 'CZ', 'Czechia', 'EURO', '9628', '909131', '174', '14820');
INSERT INTO public.who_global_data_import VALUES (21585, '2021-01-21', 'CZ', 'Czechia', 'EURO', '8228', '917359', '153', '14973');
INSERT INTO public.who_global_data_import VALUES (21586, '2021-01-22', 'CZ', 'Czechia', 'EURO', '7488', '924847', '157', '15130');
INSERT INTO public.who_global_data_import VALUES (21587, '2021-01-23', 'CZ', 'Czechia', 'EURO', '8514', '933361', '140', '15270');
INSERT INTO public.who_global_data_import VALUES (21588, '2021-01-24', 'CZ', 'Czechia', 'EURO', '4256', '937617', '99', '15369');
INSERT INTO public.who_global_data_import VALUES (21589, '2021-01-25', 'CZ', 'Czechia', 'EURO', '2387', '940004', '84', '15453');
INSERT INTO public.who_global_data_import VALUES (21590, '2021-01-26', 'CZ', 'Czechia', 'EURO', '6942', '946946', '165', '15618');
INSERT INTO public.who_global_data_import VALUES (21591, '2021-01-27', 'CZ', 'Czechia', 'EURO', '9209', '956155', '173', '15791');
INSERT INTO public.who_global_data_import VALUES (21592, '2021-01-28', 'CZ', 'Czechia', 'EURO', '8505', '964660', '153', '15944');
INSERT INTO public.who_global_data_import VALUES (21593, '2021-01-29', 'CZ', 'Czechia', 'EURO', '7982', '972642', '128', '16072');
INSERT INTO public.who_global_data_import VALUES (21594, '2021-01-30', 'CZ', 'Czechia', 'EURO', '8072', '980714', '139', '16211');
INSERT INTO public.who_global_data_import VALUES (21595, '2021-01-31', 'CZ', 'Czechia', 'EURO', '4060', '984774', '97', '16308');
INSERT INTO public.who_global_data_import VALUES (21596, '2021-02-01', 'CZ', 'Czechia', 'EURO', '2555', '987329', '84', '16392');
INSERT INTO public.who_global_data_import VALUES (21597, '2021-02-02', 'CZ', 'Czechia', 'EURO', '7185', '994514', '153', '16545');
INSERT INTO public.who_global_data_import VALUES (21598, '2021-02-03', 'CZ', 'Czechia', 'EURO', '9143', '1003657', '138', '16683');
INSERT INTO public.who_global_data_import VALUES (21599, '2021-02-04', 'CZ', 'Czechia', 'EURO', '9695', '1013352', '143', '16826');
INSERT INTO public.who_global_data_import VALUES (21600, '2021-02-05', 'CZ', 'Czechia', 'EURO', '8125', '1021477', '150', '16976');
INSERT INTO public.who_global_data_import VALUES (21601, '2020-01-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21602, '2020-01-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21603, '2020-01-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21604, '2020-01-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21605, '2020-01-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21606, '2020-01-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21607, '2020-01-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21608, '2020-01-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21609, '2020-01-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21610, '2020-01-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21611, '2020-01-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21612, '2020-01-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21613, '2020-01-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21614, '2020-01-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21615, '2020-01-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21616, '2020-01-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21617, '2020-01-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21618, '2020-01-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21619, '2020-01-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21620, '2020-01-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21621, '2020-01-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21622, '2020-01-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21623, '2020-01-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21624, '2020-01-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21625, '2020-01-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21626, '2020-01-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21627, '2020-01-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21628, '2020-01-30', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21629, '2020-01-31', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21630, '2020-02-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21631, '2020-02-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21632, '2020-02-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21633, '2020-02-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21634, '2020-02-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21635, '2020-02-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21636, '2020-02-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21637, '2020-02-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21638, '2020-02-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21639, '2020-02-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21640, '2020-02-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21641, '2020-02-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21642, '2020-02-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21643, '2020-02-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21644, '2020-02-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21645, '2020-02-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21646, '2020-02-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21647, '2020-02-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21648, '2020-02-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21649, '2020-02-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21650, '2020-02-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21651, '2020-02-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21652, '2020-02-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21653, '2020-02-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21654, '2020-02-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21655, '2020-02-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21656, '2020-02-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21657, '2020-02-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21658, '2020-02-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21659, '2020-03-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21660, '2020-03-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21661, '2020-03-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21662, '2020-03-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21663, '2020-03-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21664, '2020-03-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21665, '2020-03-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21666, '2020-03-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21667, '2020-03-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21668, '2020-03-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21669, '2020-03-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21670, '2020-03-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21671, '2020-03-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21672, '2020-03-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21673, '2020-03-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21674, '2020-03-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21675, '2020-03-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21676, '2020-03-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21677, '2020-03-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21678, '2020-03-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21679, '2020-03-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21680, '2020-03-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21681, '2020-03-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21682, '2020-03-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21683, '2020-03-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21684, '2020-03-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21685, '2020-03-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21686, '2020-03-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21687, '2020-03-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21688, '2020-03-30', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21689, '2020-03-31', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21690, '2020-04-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21691, '2020-04-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21692, '2020-04-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21693, '2020-04-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21694, '2020-04-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21695, '2020-04-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21696, '2020-04-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21697, '2020-04-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21698, '2020-04-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21699, '2020-04-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21700, '2020-04-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21701, '2020-04-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21702, '2020-04-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21703, '2020-04-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21704, '2020-04-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21705, '2020-04-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21706, '2020-04-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21707, '2020-04-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21708, '2020-04-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21709, '2020-04-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21710, '2020-04-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21711, '2020-04-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21712, '2020-04-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21713, '2020-04-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21714, '2020-04-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21715, '2020-04-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21716, '2020-04-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21717, '2020-04-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21718, '2020-04-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21719, '2020-04-30', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21720, '2020-05-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21721, '2020-05-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21722, '2020-05-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21723, '2020-05-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21724, '2020-05-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21725, '2020-05-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21726, '2020-05-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21727, '2020-05-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21728, '2020-05-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21729, '2020-05-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21730, '2020-05-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21731, '2020-05-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21732, '2020-05-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21733, '2020-05-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22816, '2020-01-18', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21734, '2020-05-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21735, '2020-05-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21736, '2020-05-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21737, '2020-05-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21738, '2020-05-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21739, '2020-05-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21740, '2020-05-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21741, '2020-05-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21742, '2020-05-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21743, '2020-05-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21744, '2020-05-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21745, '2020-05-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21746, '2020-05-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21747, '2020-05-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21748, '2020-05-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21749, '2020-05-30', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21750, '2020-05-31', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21751, '2020-06-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21752, '2020-06-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21753, '2020-06-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21754, '2020-06-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21755, '2020-06-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21756, '2020-06-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21757, '2020-06-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21758, '2020-06-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21759, '2020-06-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21760, '2020-06-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21761, '2020-06-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21762, '2020-06-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21763, '2020-06-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21764, '2020-06-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21765, '2020-06-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21766, '2020-06-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21767, '2020-06-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21768, '2020-06-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21769, '2020-06-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21770, '2020-06-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21771, '2020-06-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21772, '2020-06-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21773, '2020-06-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21774, '2020-06-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21775, '2020-06-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21776, '2020-06-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21777, '2020-06-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21778, '2020-06-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21779, '2020-06-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21780, '2020-06-30', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21781, '2020-07-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21782, '2020-07-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21783, '2020-07-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21784, '2020-07-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21785, '2020-07-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21786, '2020-07-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21787, '2020-07-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21788, '2020-07-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21789, '2020-07-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21790, '2020-07-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21791, '2020-07-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21792, '2020-07-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21793, '2020-07-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21794, '2020-07-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21795, '2020-07-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21796, '2020-07-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21797, '2020-07-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21798, '2020-07-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21799, '2020-07-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21800, '2020-07-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21801, '2020-07-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21802, '2020-07-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21803, '2020-07-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21804, '2020-07-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21805, '2020-07-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21806, '2020-07-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21807, '2020-07-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21808, '2020-07-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21809, '2020-07-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21810, '2020-07-30', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21811, '2020-07-31', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21812, '2020-08-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21813, '2020-08-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21814, '2020-08-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22817, '2020-01-19', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21815, '2020-08-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21816, '2020-08-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21817, '2020-08-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21818, '2020-08-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21819, '2020-08-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21820, '2020-08-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21821, '2020-08-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21822, '2020-08-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21823, '2020-08-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21824, '2020-08-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21825, '2020-08-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21826, '2020-08-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21827, '2020-08-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21828, '2020-08-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21829, '2020-08-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21830, '2020-08-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21831, '2020-08-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21832, '2020-08-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21833, '2020-08-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21834, '2020-08-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21835, '2020-08-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21836, '2020-08-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21837, '2020-08-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21838, '2020-08-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21839, '2020-08-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21840, '2020-08-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21841, '2020-08-30', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21842, '2020-08-31', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21843, '2020-09-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21844, '2020-09-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21845, '2020-09-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21846, '2020-09-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21847, '2020-09-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21848, '2020-09-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21849, '2020-09-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21850, '2020-09-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21851, '2020-09-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21852, '2020-09-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21853, '2020-09-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21854, '2020-09-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21855, '2020-09-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21856, '2020-09-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21857, '2020-09-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21858, '2020-09-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21859, '2020-09-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21860, '2020-09-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21861, '2020-09-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21862, '2020-09-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21863, '2020-09-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21864, '2020-09-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21865, '2020-09-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21866, '2020-09-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21867, '2020-09-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21868, '2020-09-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21869, '2020-09-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21870, '2020-09-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21871, '2020-09-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21872, '2020-09-30', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21873, '2020-10-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21874, '2020-10-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21875, '2020-10-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21876, '2020-10-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21877, '2020-10-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21878, '2020-10-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21879, '2020-10-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21880, '2020-10-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21881, '2020-10-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21882, '2020-10-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21883, '2020-10-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21884, '2020-10-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21885, '2020-10-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21886, '2020-10-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21887, '2020-10-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21888, '2020-10-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21889, '2020-10-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21890, '2020-10-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21891, '2020-10-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21892, '2020-10-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21893, '2020-10-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21894, '2020-10-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21895, '2020-10-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22818, '2020-01-20', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21896, '2020-10-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21897, '2020-10-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21898, '2020-10-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21899, '2020-10-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21900, '2020-10-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21901, '2020-10-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21902, '2020-10-30', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21903, '2020-10-31', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21904, '2020-11-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21905, '2020-11-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21906, '2020-11-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21907, '2020-11-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21908, '2020-11-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21909, '2020-11-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21910, '2020-11-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21911, '2020-11-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21912, '2020-11-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21913, '2020-11-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21914, '2020-11-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21915, '2020-11-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21916, '2020-11-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21917, '2020-11-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21918, '2020-11-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21919, '2020-11-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21920, '2020-11-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21921, '2020-11-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21922, '2020-11-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21923, '2020-11-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21924, '2020-11-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21925, '2020-11-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21926, '2020-11-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21927, '2020-11-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21928, '2020-11-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21929, '2020-11-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21930, '2020-11-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21931, '2020-11-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21932, '2020-11-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21933, '2020-11-30', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21934, '2020-12-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21935, '2020-12-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21936, '2020-12-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21937, '2020-12-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21938, '2020-12-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21939, '2020-12-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21940, '2020-12-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21941, '2020-12-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21942, '2020-12-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21943, '2020-12-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21944, '2020-12-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21945, '2020-12-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21946, '2020-12-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21947, '2020-12-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21948, '2020-12-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21949, '2020-12-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21950, '2020-12-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21951, '2020-12-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21952, '2020-12-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21953, '2020-12-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21954, '2020-12-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21955, '2020-12-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21956, '2020-12-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21957, '2020-12-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21958, '2020-12-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21959, '2020-12-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21960, '2020-12-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21961, '2020-12-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21962, '2020-12-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21963, '2020-12-30', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21964, '2020-12-31', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21965, '2021-01-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21966, '2021-01-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21967, '2021-01-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21968, '2021-01-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21969, '2021-01-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21970, '2021-01-06', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21971, '2021-01-07', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21972, '2021-01-08', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21973, '2021-01-09', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21974, '2021-01-10', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21975, '2021-01-11', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21976, '2021-01-12', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22819, '2020-01-21', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21977, '2021-01-13', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21978, '2021-01-14', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21979, '2021-01-15', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21980, '2021-01-16', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21981, '2021-01-17', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21982, '2021-01-18', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21983, '2021-01-19', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21984, '2021-01-20', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21985, '2021-01-21', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21986, '2021-01-22', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21987, '2021-01-23', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21988, '2021-01-24', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21989, '2021-01-25', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21990, '2021-01-26', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21991, '2021-01-27', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21992, '2021-01-28', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21993, '2021-01-29', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21994, '2021-01-30', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21995, '2021-01-31', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21996, '2021-02-01', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21997, '2021-02-02', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21998, '2021-02-03', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (21999, '2021-02-04', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22000, '2021-02-05', 'KP', 'Democratic People''s Republic of Korea', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22001, '2020-01-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22002, '2020-01-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22003, '2020-01-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22004, '2020-01-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22005, '2020-01-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22006, '2020-01-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22007, '2020-01-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22008, '2020-01-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22009, '2020-01-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22010, '2020-01-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22011, '2020-01-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22012, '2020-01-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22013, '2020-01-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22014, '2020-01-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22015, '2020-01-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22016, '2020-01-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22017, '2020-01-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22018, '2020-01-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22019, '2020-01-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22020, '2020-01-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22021, '2020-01-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22022, '2020-01-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22023, '2020-01-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22024, '2020-01-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22025, '2020-01-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22026, '2020-01-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22027, '2020-01-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22028, '2020-01-30', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22029, '2020-01-31', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22030, '2020-02-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22031, '2020-02-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22032, '2020-02-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22033, '2020-02-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22034, '2020-02-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22035, '2020-02-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22036, '2020-02-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22037, '2020-02-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22038, '2020-02-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22039, '2020-02-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22040, '2020-02-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22041, '2020-02-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22042, '2020-02-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22043, '2020-02-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22044, '2020-02-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22045, '2020-02-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22046, '2020-02-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22047, '2020-02-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22048, '2020-02-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22049, '2020-02-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22050, '2020-02-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22051, '2020-02-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22052, '2020-02-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22053, '2020-02-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22054, '2020-02-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22055, '2020-02-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22056, '2020-02-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22057, '2020-02-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22058, '2020-02-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22059, '2020-03-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22060, '2020-03-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22061, '2020-03-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22062, '2020-03-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22063, '2020-03-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22064, '2020-03-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22065, '2020-03-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22066, '2020-03-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22067, '2020-03-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22068, '2020-03-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22069, '2020-03-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22070, '2020-03-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22071, '2020-03-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22072, '2020-03-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22073, '2020-03-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22074, '2020-03-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22075, '2020-03-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22076, '2020-03-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '4', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22077, '2020-03-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '7', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22078, '2020-03-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22079, '2020-03-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22080, '2020-03-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22081, '2020-03-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '12', '30', '2', '2');
INSERT INTO public.who_global_data_import VALUES (22082, '2020-03-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '6', '36', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22083, '2020-03-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '9', '45', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22084, '2020-03-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '6', '51', '1', '3');
INSERT INTO public.who_global_data_import VALUES (22085, '2020-03-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '3', '54', '1', '4');
INSERT INTO public.who_global_data_import VALUES (22086, '2020-03-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '4', '58', '1', '5');
INSERT INTO public.who_global_data_import VALUES (22087, '2020-03-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '10', '68', '1', '6');
INSERT INTO public.who_global_data_import VALUES (22088, '2020-03-30', 'CD', 'Democratic Republic of the Congo', 'AFRO', '13', '81', '2', '8');
INSERT INTO public.who_global_data_import VALUES (22089, '2020-03-31', 'CD', 'Democratic Republic of the Congo', 'AFRO', '17', '98', '0', '8');
INSERT INTO public.who_global_data_import VALUES (22090, '2020-04-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '11', '109', '1', '9');
INSERT INTO public.who_global_data_import VALUES (22091, '2020-04-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '14', '123', '2', '11');
INSERT INTO public.who_global_data_import VALUES (22092, '2020-04-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '11', '134', '2', '13');
INSERT INTO public.who_global_data_import VALUES (22093, '2020-04-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '14', '148', '3', '16');
INSERT INTO public.who_global_data_import VALUES (22094, '2020-04-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '148', '0', '16');
INSERT INTO public.who_global_data_import VALUES (22095, '2020-04-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '13', '161', '2', '18');
INSERT INTO public.who_global_data_import VALUES (22096, '2020-04-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '161', '0', '18');
INSERT INTO public.who_global_data_import VALUES (22097, '2020-04-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '22', '183', '2', '20');
INSERT INTO public.who_global_data_import VALUES (22098, '2020-04-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '24', '207', '0', '20');
INSERT INTO public.who_global_data_import VALUES (22099, '2020-04-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '8', '215', '0', '20');
INSERT INTO public.who_global_data_import VALUES (22100, '2020-04-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '215', '0', '20');
INSERT INTO public.who_global_data_import VALUES (22101, '2020-04-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '8', '223', '0', '20');
INSERT INTO public.who_global_data_import VALUES (22102, '2020-04-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '12', '235', '0', '20');
INSERT INTO public.who_global_data_import VALUES (22103, '2020-04-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '6', '241', '0', '20');
INSERT INTO public.who_global_data_import VALUES (22104, '2020-04-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '13', '254', '1', '21');
INSERT INTO public.who_global_data_import VALUES (22105, '2020-04-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '13', '267', '1', '22');
INSERT INTO public.who_global_data_import VALUES (22106, '2020-04-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '20', '287', '1', '23');
INSERT INTO public.who_global_data_import VALUES (22107, '2020-04-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '287', '0', '23');
INSERT INTO public.who_global_data_import VALUES (22108, '2020-04-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '40', '327', '2', '25');
INSERT INTO public.who_global_data_import VALUES (22109, '2020-04-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '5', '332', '0', '25');
INSERT INTO public.who_global_data_import VALUES (22110, '2020-04-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '18', '350', '0', '25');
INSERT INTO public.who_global_data_import VALUES (22111, '2020-04-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '9', '359', '0', '25');
INSERT INTO public.who_global_data_import VALUES (22112, '2020-04-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '359', '0', '25');
INSERT INTO public.who_global_data_import VALUES (22113, '2020-04-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '35', '394', '0', '25');
INSERT INTO public.who_global_data_import VALUES (22114, '2020-04-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '22', '416', '3', '28');
INSERT INTO public.who_global_data_import VALUES (22115, '2020-04-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '26', '442', '0', '28');
INSERT INTO public.who_global_data_import VALUES (22116, '2020-04-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '17', '459', '0', '28');
INSERT INTO public.who_global_data_import VALUES (22117, '2020-04-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '12', '471', '2', '30');
INSERT INTO public.who_global_data_import VALUES (22118, '2020-04-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '20', '491', '0', '30');
INSERT INTO public.who_global_data_import VALUES (22119, '2020-04-30', 'CD', 'Democratic Republic of the Congo', 'AFRO', '9', '500', '1', '31');
INSERT INTO public.who_global_data_import VALUES (22120, '2020-05-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '72', '572', '0', '31');
INSERT INTO public.who_global_data_import VALUES (22121, '2020-05-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '32', '604', '1', '32');
INSERT INTO public.who_global_data_import VALUES (22122, '2020-05-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '70', '674', '1', '33');
INSERT INTO public.who_global_data_import VALUES (22123, '2020-05-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '8', '682', '1', '34');
INSERT INTO public.who_global_data_import VALUES (22124, '2020-05-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '682', '0', '34');
INSERT INTO public.who_global_data_import VALUES (22125, '2020-05-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '23', '705', '0', '34');
INSERT INTO public.who_global_data_import VALUES (22126, '2020-05-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '92', '797', '1', '35');
INSERT INTO public.who_global_data_import VALUES (22127, '2020-05-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '100', '897', '1', '36');
INSERT INTO public.who_global_data_import VALUES (22128, '2020-05-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '40', '937', '3', '39');
INSERT INTO public.who_global_data_import VALUES (22129, '2020-05-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '54', '991', '2', '41');
INSERT INTO public.who_global_data_import VALUES (22130, '2020-05-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '33', '1024', '0', '41');
INSERT INTO public.who_global_data_import VALUES (22131, '2020-05-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '78', '1102', '3', '44');
INSERT INTO public.who_global_data_import VALUES (22132, '2020-05-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '67', '1169', '6', '50');
INSERT INTO public.who_global_data_import VALUES (22133, '2020-05-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '73', '1242', '0', '50');
INSERT INTO public.who_global_data_import VALUES (22134, '2020-05-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '56', '1298', '0', '50');
INSERT INTO public.who_global_data_import VALUES (22135, '2020-05-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '71', '1369', '10', '60');
INSERT INTO public.who_global_data_import VALUES (22136, '2020-05-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '85', '1454', '0', '60');
INSERT INTO public.who_global_data_import VALUES (22137, '2020-05-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '1454', '0', '60');
INSERT INTO public.who_global_data_import VALUES (22138, '2020-05-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '83', '1537', '0', '60');
INSERT INTO public.who_global_data_import VALUES (22139, '2020-05-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '193', '1730', '0', '60');
INSERT INTO public.who_global_data_import VALUES (22140, '2020-05-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '104', '1834', '0', '60');
INSERT INTO public.who_global_data_import VALUES (22141, '2020-05-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '110', '1944', '2', '62');
INSERT INTO public.who_global_data_import VALUES (22142, '2020-05-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '1944', '0', '62');
INSERT INTO public.who_global_data_import VALUES (22143, '2020-05-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '196', '2140', '0', '62');
INSERT INTO public.who_global_data_import VALUES (22144, '2020-05-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '2140', '0', '62');
INSERT INTO public.who_global_data_import VALUES (22820, '2020-01-22', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22145, '2020-05-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '164', '2304', '4', '66');
INSERT INTO public.who_global_data_import VALUES (22146, '2020-05-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '98', '2402', '1', '67');
INSERT INTO public.who_global_data_import VALUES (22147, '2020-05-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '257', '2659', '1', '68');
INSERT INTO public.who_global_data_import VALUES (22148, '2020-05-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '173', '2832', '0', '68');
INSERT INTO public.who_global_data_import VALUES (22149, '2020-05-30', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '2832', '0', '68');
INSERT INTO public.who_global_data_import VALUES (22150, '2020-05-31', 'CD', 'Democratic Republic of the Congo', 'AFRO', '133', '2965', '0', '68');
INSERT INTO public.who_global_data_import VALUES (22151, '2020-06-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '83', '3048', '3', '71');
INSERT INTO public.who_global_data_import VALUES (22152, '2020-06-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '146', '3194', '0', '71');
INSERT INTO public.who_global_data_import VALUES (22153, '2020-06-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '131', '3325', '0', '71');
INSERT INTO public.who_global_data_import VALUES (22154, '2020-06-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '169', '3494', '3', '74');
INSERT INTO public.who_global_data_import VALUES (22155, '2020-06-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '149', '3643', '3', '77');
INSERT INTO public.who_global_data_import VALUES (22156, '2020-06-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '120', '3763', '3', '80');
INSERT INTO public.who_global_data_import VALUES (22157, '2020-06-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '114', '3877', '1', '81');
INSERT INTO public.who_global_data_import VALUES (22158, '2020-06-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '138', '4015', '3', '84');
INSERT INTO public.who_global_data_import VALUES (22159, '2020-06-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '90', '4105', '3', '87');
INSERT INTO public.who_global_data_import VALUES (22160, '2020-06-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '153', '4258', '3', '90');
INSERT INTO public.who_global_data_import VALUES (22161, '2020-06-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '131', '4389', '6', '96');
INSERT INTO public.who_global_data_import VALUES (22162, '2020-06-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '125', '4514', '1', '97');
INSERT INTO public.who_global_data_import VALUES (22163, '2020-06-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '122', '4636', '3', '100');
INSERT INTO public.who_global_data_import VALUES (22164, '2020-06-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '87', '4723', '5', '105');
INSERT INTO public.who_global_data_import VALUES (22165, '2020-06-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '54', '4777', '1', '106');
INSERT INTO public.who_global_data_import VALUES (22166, '2020-06-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '4777', '0', '106');
INSERT INTO public.who_global_data_import VALUES (22167, '2020-06-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '196', '4973', '5', '111');
INSERT INTO public.who_global_data_import VALUES (22168, '2020-06-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '126', '5099', '3', '114');
INSERT INTO public.who_global_data_import VALUES (22169, '2020-06-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '183', '5282', '2', '116');
INSERT INTO public.who_global_data_import VALUES (22170, '2020-06-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '194', '5476', '5', '121');
INSERT INTO public.who_global_data_import VALUES (22171, '2020-06-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '195', '5671', '3', '124');
INSERT INTO public.who_global_data_import VALUES (22172, '2020-06-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '154', '5825', '5', '129');
INSERT INTO public.who_global_data_import VALUES (22173, '2020-06-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '99', '5924', '5', '134');
INSERT INTO public.who_global_data_import VALUES (22174, '2020-06-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '102', '6026', '0', '134');
INSERT INTO public.who_global_data_import VALUES (22175, '2020-06-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '186', '6212', '7', '141');
INSERT INTO public.who_global_data_import VALUES (22176, '2020-06-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '198', '6410', '0', '141');
INSERT INTO public.who_global_data_import VALUES (22177, '2020-06-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '141', '6551', '7', '148');
INSERT INTO public.who_global_data_import VALUES (22178, '2020-06-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '138', '6689', '4', '152');
INSERT INTO public.who_global_data_import VALUES (22179, '2020-06-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '137', '6826', '5', '157');
INSERT INTO public.who_global_data_import VALUES (22180, '2020-06-30', 'CD', 'Democratic Republic of the Congo', 'AFRO', '112', '6938', '9', '166');
INSERT INTO public.who_global_data_import VALUES (22181, '2020-07-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '100', '7038', '3', '169');
INSERT INTO public.who_global_data_import VALUES (22182, '2020-07-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '83', '7121', '5', '174');
INSERT INTO public.who_global_data_import VALUES (22183, '2020-07-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '67', '7188', '1', '175');
INSERT INTO public.who_global_data_import VALUES (22184, '2020-07-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '122', '7310', '3', '178');
INSERT INTO public.who_global_data_import VALUES (22185, '2020-07-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '68', '7378', '3', '181');
INSERT INTO public.who_global_data_import VALUES (22186, '2020-07-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '32', '7410', '0', '181');
INSERT INTO public.who_global_data_import VALUES (22187, '2020-07-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '21', '7431', '0', '181');
INSERT INTO public.who_global_data_import VALUES (22188, '2020-07-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '228', '7659', '1', '182');
INSERT INTO public.who_global_data_import VALUES (22189, '2020-07-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '77', '7736', '1', '183');
INSERT INTO public.who_global_data_import VALUES (22190, '2020-07-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '109', '7845', '5', '188');
INSERT INTO public.who_global_data_import VALUES (22191, '2020-07-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '59', '7904', '0', '188');
INSERT INTO public.who_global_data_import VALUES (22192, '2020-07-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '66', '7970', '0', '188');
INSERT INTO public.who_global_data_import VALUES (22193, '2020-07-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '62', '8032', '0', '188');
INSERT INTO public.who_global_data_import VALUES (22194, '2020-07-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '42', '8074', '1', '189');
INSERT INTO public.who_global_data_import VALUES (22195, '2020-07-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '60', '8134', '0', '189');
INSERT INTO public.who_global_data_import VALUES (22196, '2020-07-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '28', '8162', '2', '191');
INSERT INTO public.who_global_data_import VALUES (22197, '2020-07-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '36', '8198', '1', '192');
INSERT INTO public.who_global_data_import VALUES (22198, '2020-07-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '50', '8248', '0', '192');
INSERT INTO public.who_global_data_import VALUES (22199, '2020-07-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '1', '8249', '0', '192');
INSERT INTO public.who_global_data_import VALUES (22200, '2020-07-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '153', '8402', '1', '193');
INSERT INTO public.who_global_data_import VALUES (22201, '2020-07-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '40', '8442', '0', '193');
INSERT INTO public.who_global_data_import VALUES (22202, '2020-07-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '91', '8533', '2', '195');
INSERT INTO public.who_global_data_import VALUES (22203, '2020-07-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '92', '8625', '1', '196');
INSERT INTO public.who_global_data_import VALUES (22204, '2020-07-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '8625', '0', '196');
INSERT INTO public.who_global_data_import VALUES (22205, '2020-07-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '8625', '0', '196');
INSERT INTO public.who_global_data_import VALUES (22206, '2020-07-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '141', '8766', '4', '200');
INSERT INTO public.who_global_data_import VALUES (22207, '2020-07-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '64', '8830', '3', '203');
INSERT INTO public.who_global_data_import VALUES (22208, '2020-07-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '13', '8843', '4', '207');
INSERT INTO public.who_global_data_import VALUES (22209, '2020-07-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '29', '8872', '0', '207');
INSERT INTO public.who_global_data_import VALUES (22210, '2020-07-30', 'CD', 'Democratic Republic of the Congo', 'AFRO', '58', '8930', '5', '212');
INSERT INTO public.who_global_data_import VALUES (22211, '2020-07-31', 'CD', 'Democratic Republic of the Congo', 'AFRO', '79', '9009', '2', '214');
INSERT INTO public.who_global_data_import VALUES (22212, '2020-08-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '60', '9069', '0', '214');
INSERT INTO public.who_global_data_import VALUES (22213, '2020-08-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '9069', '0', '214');
INSERT INTO public.who_global_data_import VALUES (22214, '2020-08-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '45', '9114', '0', '214');
INSERT INTO public.who_global_data_import VALUES (22215, '2020-08-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '18', '9132', '0', '214');
INSERT INTO public.who_global_data_import VALUES (22216, '2020-08-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '45', '9177', '0', '214');
INSERT INTO public.who_global_data_import VALUES (22217, '2020-08-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '75', '9252', '0', '214');
INSERT INTO public.who_global_data_import VALUES (22218, '2020-08-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '56', '9308', '0', '214');
INSERT INTO public.who_global_data_import VALUES (22219, '2020-08-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '46', '9354', '4', '218');
INSERT INTO public.who_global_data_import VALUES (22220, '2020-08-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '81', '9435', '0', '218');
INSERT INTO public.who_global_data_import VALUES (22221, '2020-08-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '18', '9453', '6', '224');
INSERT INTO public.who_global_data_import VALUES (22222, '2020-08-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '35', '9488', '0', '224');
INSERT INTO public.who_global_data_import VALUES (22223, '2020-08-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '10', '9498', '1', '225');
INSERT INTO public.who_global_data_import VALUES (22224, '2020-08-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '39', '9537', '0', '225');
INSERT INTO public.who_global_data_import VALUES (22225, '2020-08-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '51', '9588', '9', '234');
INSERT INTO public.who_global_data_import VALUES (22821, '2020-01-23', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22226, '2020-08-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '16', '9604', '4', '238');
INSERT INTO public.who_global_data_import VALUES (22227, '2020-08-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '33', '9637', '1', '239');
INSERT INTO public.who_global_data_import VALUES (22228, '2020-08-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '38', '9675', '1', '240');
INSERT INTO public.who_global_data_import VALUES (22229, '2020-08-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '30', '9705', '3', '243');
INSERT INTO public.who_global_data_import VALUES (22230, '2020-08-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '15', '9720', '0', '243');
INSERT INTO public.who_global_data_import VALUES (22231, '2020-08-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '20', '9740', '3', '246');
INSERT INTO public.who_global_data_import VALUES (22232, '2020-08-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '16', '9756', '1', '247');
INSERT INTO public.who_global_data_import VALUES (22233, '2020-08-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '45', '9801', '1', '248');
INSERT INTO public.who_global_data_import VALUES (22234, '2020-08-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '9', '9810', '3', '251');
INSERT INTO public.who_global_data_import VALUES (22235, '2020-08-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '19', '9829', '0', '251');
INSERT INTO public.who_global_data_import VALUES (22236, '2020-08-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '12', '9841', '0', '251');
INSERT INTO public.who_global_data_import VALUES (22237, '2020-08-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '49', '9890', '0', '251');
INSERT INTO public.who_global_data_import VALUES (22238, '2020-08-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '21', '9911', '3', '254');
INSERT INTO public.who_global_data_import VALUES (22239, '2020-08-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '3', '9914', '1', '255');
INSERT INTO public.who_global_data_import VALUES (22240, '2020-08-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '79', '9993', '0', '255');
INSERT INTO public.who_global_data_import VALUES (22241, '2020-08-30', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '9993', '0', '255');
INSERT INTO public.who_global_data_import VALUES (22242, '2020-08-31', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '9993', '0', '255');
INSERT INTO public.who_global_data_import VALUES (22243, '2020-09-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '103', '10096', '3', '258');
INSERT INTO public.who_global_data_import VALUES (22244, '2020-09-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '7', '10103', '1', '259');
INSERT INTO public.who_global_data_import VALUES (22245, '2020-09-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '10', '10113', '0', '259');
INSERT INTO public.who_global_data_import VALUES (22246, '2020-09-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '10113', '0', '259');
INSERT INTO public.who_global_data_import VALUES (22247, '2020-09-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '35', '10148', '0', '259');
INSERT INTO public.who_global_data_import VALUES (22248, '2020-09-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '10148', '0', '259');
INSERT INTO public.who_global_data_import VALUES (22249, '2020-09-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '61', '10209', '1', '260');
INSERT INTO public.who_global_data_import VALUES (22250, '2020-09-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '23', '10232', '0', '260');
INSERT INTO public.who_global_data_import VALUES (22251, '2020-09-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '59', '10291', '0', '260');
INSERT INTO public.who_global_data_import VALUES (22252, '2020-09-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '32', '10323', '0', '260');
INSERT INTO public.who_global_data_import VALUES (22253, '2020-09-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '19', '10342', '2', '262');
INSERT INTO public.who_global_data_import VALUES (22254, '2020-09-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '18', '10360', '0', '262');
INSERT INTO public.who_global_data_import VALUES (22255, '2020-09-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '24', '10384', '0', '262');
INSERT INTO public.who_global_data_import VALUES (22256, '2020-09-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '5', '10389', '2', '264');
INSERT INTO public.who_global_data_import VALUES (22257, '2020-09-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '10389', '0', '264');
INSERT INTO public.who_global_data_import VALUES (22258, '2020-09-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '11', '10400', '3', '267');
INSERT INTO public.who_global_data_import VALUES (22259, '2020-09-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '13', '10413', '0', '267');
INSERT INTO public.who_global_data_import VALUES (22260, '2020-09-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '28', '10441', '0', '267');
INSERT INTO public.who_global_data_import VALUES (22261, '2020-09-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '14', '10455', '1', '268');
INSERT INTO public.who_global_data_import VALUES (22262, '2020-09-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '32', '10487', '0', '268');
INSERT INTO public.who_global_data_import VALUES (22263, '2020-09-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '27', '10514', '3', '271');
INSERT INTO public.who_global_data_import VALUES (22264, '2020-09-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '4', '10518', '0', '271');
INSERT INTO public.who_global_data_import VALUES (22265, '2020-09-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '4', '10522', '0', '271');
INSERT INTO public.who_global_data_import VALUES (22266, '2020-09-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '14', '10536', '0', '271');
INSERT INTO public.who_global_data_import VALUES (22267, '2020-09-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '18', '10554', '0', '271');
INSERT INTO public.who_global_data_import VALUES (22268, '2020-09-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '23', '10577', '0', '271');
INSERT INTO public.who_global_data_import VALUES (22269, '2020-09-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '15', '10592', '0', '271');
INSERT INTO public.who_global_data_import VALUES (22270, '2020-09-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '19', '10611', '0', '271');
INSERT INTO public.who_global_data_import VALUES (22271, '2020-09-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '12', '10623', '0', '271');
INSERT INTO public.who_global_data_import VALUES (22272, '2020-09-30', 'CD', 'Democratic Republic of the Congo', 'AFRO', '7', '10630', '1', '272');
INSERT INTO public.who_global_data_import VALUES (22273, '2020-10-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '28', '10658', '0', '272');
INSERT INTO public.who_global_data_import VALUES (22274, '2020-10-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '26', '10684', '0', '272');
INSERT INTO public.who_global_data_import VALUES (22275, '2020-10-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '44', '10728', '0', '272');
INSERT INTO public.who_global_data_import VALUES (22276, '2020-10-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '23', '10751', '2', '274');
INSERT INTO public.who_global_data_import VALUES (22277, '2020-10-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '8', '10759', '0', '274');
INSERT INTO public.who_global_data_import VALUES (22278, '2020-10-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '18', '10777', '0', '274');
INSERT INTO public.who_global_data_import VALUES (22279, '2020-10-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '11', '10788', '0', '274');
INSERT INTO public.who_global_data_import VALUES (22280, '2020-10-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '15', '10803', '2', '276');
INSERT INTO public.who_global_data_import VALUES (22281, '2020-10-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '18', '10821', '0', '276');
INSERT INTO public.who_global_data_import VALUES (22282, '2020-10-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '13', '10834', '0', '276');
INSERT INTO public.who_global_data_import VALUES (22283, '2020-10-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '6', '10840', '0', '276');
INSERT INTO public.who_global_data_import VALUES (22284, '2020-10-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '10840', '0', '276');
INSERT INTO public.who_global_data_import VALUES (22285, '2020-10-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '27', '10867', '0', '276');
INSERT INTO public.who_global_data_import VALUES (22286, '2020-10-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '4', '10871', '0', '276');
INSERT INTO public.who_global_data_import VALUES (22287, '2020-10-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '63', '10934', '5', '281');
INSERT INTO public.who_global_data_import VALUES (22288, '2020-10-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '10934', '0', '281');
INSERT INTO public.who_global_data_import VALUES (22289, '2020-10-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '10934', '0', '281');
INSERT INTO public.who_global_data_import VALUES (22290, '2020-10-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '65', '10999', '21', '302');
INSERT INTO public.who_global_data_import VALUES (22291, '2020-10-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '6', '11005', '0', '302');
INSERT INTO public.who_global_data_import VALUES (22292, '2020-10-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '46', '11051', '1', '303');
INSERT INTO public.who_global_data_import VALUES (22293, '2020-10-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '11051', '0', '303');
INSERT INTO public.who_global_data_import VALUES (22294, '2020-10-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '26', '11077', '0', '303');
INSERT INTO public.who_global_data_import VALUES (22295, '2020-10-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '19', '11096', '1', '304');
INSERT INTO public.who_global_data_import VALUES (22296, '2020-10-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '25', '11121', '0', '304');
INSERT INTO public.who_global_data_import VALUES (22297, '2020-10-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '11121', '0', '304');
INSERT INTO public.who_global_data_import VALUES (22298, '2020-10-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '39', '11160', '1', '305');
INSERT INTO public.who_global_data_import VALUES (22299, '2020-10-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '13', '11173', '0', '305');
INSERT INTO public.who_global_data_import VALUES (22300, '2020-10-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '17', '11190', '0', '305');
INSERT INTO public.who_global_data_import VALUES (22301, '2020-10-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '20', '11210', '0', '305');
INSERT INTO public.who_global_data_import VALUES (22302, '2020-10-30', 'CD', 'Democratic Republic of the Congo', 'AFRO', '42', '11252', '0', '305');
INSERT INTO public.who_global_data_import VALUES (22303, '2020-10-31', 'CD', 'Democratic Republic of the Congo', 'AFRO', '53', '11305', '2', '307');
INSERT INTO public.who_global_data_import VALUES (22304, '2020-11-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '11305', '0', '307');
INSERT INTO public.who_global_data_import VALUES (22305, '2020-11-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '67', '11372', '1', '308');
INSERT INTO public.who_global_data_import VALUES (22306, '2020-11-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '22', '11394', '0', '308');
INSERT INTO public.who_global_data_import VALUES (22822, '2020-01-24', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22307, '2020-11-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '32', '11426', '7', '315');
INSERT INTO public.who_global_data_import VALUES (22308, '2020-11-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '23', '11449', '0', '315');
INSERT INTO public.who_global_data_import VALUES (22309, '2020-11-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '36', '11485', '0', '315');
INSERT INTO public.who_global_data_import VALUES (22310, '2020-11-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '31', '11516', '0', '315');
INSERT INTO public.who_global_data_import VALUES (22311, '2020-11-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '11516', '0', '315');
INSERT INTO public.who_global_data_import VALUES (22312, '2020-11-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '74', '11590', '1', '316');
INSERT INTO public.who_global_data_import VALUES (22313, '2020-11-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '17', '11607', '0', '316');
INSERT INTO public.who_global_data_import VALUES (22314, '2020-11-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '34', '11641', '0', '316');
INSERT INTO public.who_global_data_import VALUES (22315, '2020-11-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '14', '11655', '0', '316');
INSERT INTO public.who_global_data_import VALUES (22316, '2020-11-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '36', '11691', '2', '318');
INSERT INTO public.who_global_data_import VALUES (22317, '2020-11-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '11691', '0', '318');
INSERT INTO public.who_global_data_import VALUES (22318, '2020-11-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '68', '11759', '0', '318');
INSERT INTO public.who_global_data_import VALUES (22319, '2020-11-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '29', '11788', '1', '319');
INSERT INTO public.who_global_data_import VALUES (22320, '2020-11-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '11788', '0', '319');
INSERT INTO public.who_global_data_import VALUES (22321, '2020-11-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '77', '11865', '3', '322');
INSERT INTO public.who_global_data_import VALUES (22322, '2020-11-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '52', '11917', '1', '323');
INSERT INTO public.who_global_data_import VALUES (22323, '2020-11-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '90', '12007', '0', '323');
INSERT INTO public.who_global_data_import VALUES (22324, '2020-11-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '121', '12128', '1', '324');
INSERT INTO public.who_global_data_import VALUES (22325, '2020-11-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '51', '12179', '3', '327');
INSERT INTO public.who_global_data_import VALUES (22326, '2020-11-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '59', '12238', '1', '328');
INSERT INTO public.who_global_data_import VALUES (22327, '2020-11-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '39', '12277', '1', '329');
INSERT INTO public.who_global_data_import VALUES (22328, '2020-11-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '32', '12309', '2', '331');
INSERT INTO public.who_global_data_import VALUES (22329, '2020-11-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '55', '12364', '0', '331');
INSERT INTO public.who_global_data_import VALUES (22330, '2020-11-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '105', '12469', '2', '333');
INSERT INTO public.who_global_data_import VALUES (22331, '2020-11-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '71', '12540', '0', '333');
INSERT INTO public.who_global_data_import VALUES (22332, '2020-11-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '67', '12607', '0', '333');
INSERT INTO public.who_global_data_import VALUES (22333, '2020-11-30', 'CD', 'Democratic Republic of the Congo', 'AFRO', '94', '12701', '0', '333');
INSERT INTO public.who_global_data_import VALUES (22334, '2020-12-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '70', '12771', '0', '333');
INSERT INTO public.who_global_data_import VALUES (22335, '2020-12-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '87', '12858', '2', '335');
INSERT INTO public.who_global_data_import VALUES (22336, '2020-12-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '128', '12986', '1', '336');
INSERT INTO public.who_global_data_import VALUES (22337, '2020-12-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '145', '13131', '1', '337');
INSERT INTO public.who_global_data_import VALUES (22338, '2020-12-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '149', '13280', '0', '337');
INSERT INTO public.who_global_data_import VALUES (22339, '2020-12-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '246', '13526', '7', '344');
INSERT INTO public.who_global_data_import VALUES (22340, '2020-12-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '13526', '0', '344');
INSERT INTO public.who_global_data_import VALUES (22341, '2020-12-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '68', '13594', '0', '344');
INSERT INTO public.who_global_data_import VALUES (22342, '2020-12-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '155', '13749', '0', '344');
INSERT INTO public.who_global_data_import VALUES (22343, '2020-12-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '93', '13842', '6', '350');
INSERT INTO public.who_global_data_import VALUES (22344, '2020-12-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '152', '13994', '0', '350');
INSERT INTO public.who_global_data_import VALUES (22345, '2020-12-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '175', '14169', '0', '350');
INSERT INTO public.who_global_data_import VALUES (22346, '2020-12-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '172', '14341', '2', '352');
INSERT INTO public.who_global_data_import VALUES (22347, '2020-12-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '119', '14460', '0', '352');
INSERT INTO public.who_global_data_import VALUES (22348, '2020-12-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '14460', '4', '356');
INSERT INTO public.who_global_data_import VALUES (22349, '2020-12-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '51', '14511', '2', '358');
INSERT INTO public.who_global_data_import VALUES (22350, '2020-12-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '84', '14595', '6', '364');
INSERT INTO public.who_global_data_import VALUES (22351, '2020-12-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '333', '14928', '2', '366');
INSERT INTO public.who_global_data_import VALUES (22352, '2020-12-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '159', '15087', '0', '366');
INSERT INTO public.who_global_data_import VALUES (22353, '2020-12-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '123', '15210', '3', '369');
INSERT INTO public.who_global_data_import VALUES (22354, '2020-12-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '15210', '0', '369');
INSERT INTO public.who_global_data_import VALUES (22355, '2020-12-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '283', '15493', '1', '370');
INSERT INTO public.who_global_data_import VALUES (22356, '2020-12-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '174', '15667', '196', '566');
INSERT INTO public.who_global_data_import VALUES (22357, '2020-12-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '141', '15808', '0', '566');
INSERT INTO public.who_global_data_import VALUES (22358, '2020-12-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '229', '16037', '0', '566');
INSERT INTO public.who_global_data_import VALUES (22359, '2020-12-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '243', '16280', '0', '566');
INSERT INTO public.who_global_data_import VALUES (22360, '2020-12-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '16280', '0', '566');
INSERT INTO public.who_global_data_import VALUES (22361, '2020-12-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '16280', '0', '566');
INSERT INTO public.who_global_data_import VALUES (22362, '2020-12-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '557', '16837', '13', '579');
INSERT INTO public.who_global_data_import VALUES (22363, '2020-12-30', 'CD', 'Democratic Republic of the Congo', 'AFRO', '78', '16915', '5', '584');
INSERT INTO public.who_global_data_import VALUES (22364, '2020-12-31', 'CD', 'Democratic Republic of the Congo', 'AFRO', '265', '17180', '0', '584');
INSERT INTO public.who_global_data_import VALUES (22365, '2021-01-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '194', '17374', '7', '591');
INSERT INTO public.who_global_data_import VALUES (22366, '2021-01-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '17374', '0', '591');
INSERT INTO public.who_global_data_import VALUES (22367, '2021-01-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '474', '17848', '0', '591');
INSERT INTO public.who_global_data_import VALUES (22368, '2021-01-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '149', '17997', '5', '596');
INSERT INTO public.who_global_data_import VALUES (22369, '2021-01-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '17997', '0', '596');
INSERT INTO public.who_global_data_import VALUES (22370, '2021-01-06', 'CD', 'Democratic Republic of the Congo', 'AFRO', '155', '18152', '5', '601');
INSERT INTO public.who_global_data_import VALUES (22371, '2021-01-07', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '18152', '0', '601');
INSERT INTO public.who_global_data_import VALUES (22372, '2021-01-08', 'CD', 'Democratic Republic of the Congo', 'AFRO', '333', '18485', '9', '610');
INSERT INTO public.who_global_data_import VALUES (22373, '2021-01-09', 'CD', 'Democratic Republic of the Congo', 'AFRO', '251', '18736', '0', '610');
INSERT INTO public.who_global_data_import VALUES (22374, '2021-01-10', 'CD', 'Democratic Republic of the Congo', 'AFRO', '231', '18967', '0', '610');
INSERT INTO public.who_global_data_import VALUES (22375, '2021-01-11', 'CD', 'Democratic Republic of the Congo', 'AFRO', '190', '19157', '0', '610');
INSERT INTO public.who_global_data_import VALUES (22376, '2021-01-12', 'CD', 'Democratic Republic of the Congo', 'AFRO', '277', '19434', '0', '610');
INSERT INTO public.who_global_data_import VALUES (22377, '2021-01-13', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '19434', '0', '610');
INSERT INTO public.who_global_data_import VALUES (22378, '2021-01-14', 'CD', 'Democratic Republic of the Congo', 'AFRO', '61', '19495', '0', '610');
INSERT INTO public.who_global_data_import VALUES (22379, '2021-01-15', 'CD', 'Democratic Republic of the Congo', 'AFRO', '211', '19706', '15', '625');
INSERT INTO public.who_global_data_import VALUES (22380, '2021-01-16', 'CD', 'Democratic Republic of the Congo', 'AFRO', '919', '20625', '2', '627');
INSERT INTO public.who_global_data_import VALUES (22381, '2021-01-17', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '20625', '2', '629');
INSERT INTO public.who_global_data_import VALUES (22382, '2021-01-18', 'CD', 'Democratic Republic of the Congo', 'AFRO', '67', '20692', '1', '630');
INSERT INTO public.who_global_data_import VALUES (22383, '2021-01-19', 'CD', 'Democratic Republic of the Congo', 'AFRO', '215', '20907', '0', '630');
INSERT INTO public.who_global_data_import VALUES (22384, '2021-01-20', 'CD', 'Democratic Republic of the Congo', 'AFRO', '232', '21139', '10', '640');
INSERT INTO public.who_global_data_import VALUES (22385, '2021-01-21', 'CD', 'Democratic Republic of the Congo', 'AFRO', '162', '21301', '0', '640');
INSERT INTO public.who_global_data_import VALUES (22386, '2021-01-22', 'CD', 'Democratic Republic of the Congo', 'AFRO', '96', '21397', '3', '643');
INSERT INTO public.who_global_data_import VALUES (22387, '2021-01-23', 'CD', 'Democratic Republic of the Congo', 'AFRO', '198', '21595', '3', '646');
INSERT INTO public.who_global_data_import VALUES (22388, '2021-01-24', 'CD', 'Democratic Republic of the Congo', 'AFRO', '273', '21868', '14', '660');
INSERT INTO public.who_global_data_import VALUES (22389, '2021-01-25', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '21868', '0', '660');
INSERT INTO public.who_global_data_import VALUES (22390, '2021-01-26', 'CD', 'Democratic Republic of the Congo', 'AFRO', '179', '22047', '1', '661');
INSERT INTO public.who_global_data_import VALUES (22391, '2021-01-27', 'CD', 'Democratic Republic of the Congo', 'AFRO', '0', '22047', '0', '661');
INSERT INTO public.who_global_data_import VALUES (22392, '2021-01-28', 'CD', 'Democratic Republic of the Congo', 'AFRO', '130', '22177', '0', '661');
INSERT INTO public.who_global_data_import VALUES (22393, '2021-01-29', 'CD', 'Democratic Republic of the Congo', 'AFRO', '144', '22321', '4', '665');
INSERT INTO public.who_global_data_import VALUES (22394, '2021-01-30', 'CD', 'Democratic Republic of the Congo', 'AFRO', '133', '22454', '0', '665');
INSERT INTO public.who_global_data_import VALUES (22395, '2021-01-31', 'CD', 'Democratic Republic of the Congo', 'AFRO', '149', '22603', '6', '671');
INSERT INTO public.who_global_data_import VALUES (22396, '2021-02-01', 'CD', 'Democratic Republic of the Congo', 'AFRO', '167', '22770', '0', '671');
INSERT INTO public.who_global_data_import VALUES (22397, '2021-02-02', 'CD', 'Democratic Republic of the Congo', 'AFRO', '71', '22841', '2', '673');
INSERT INTO public.who_global_data_import VALUES (22398, '2021-02-03', 'CD', 'Democratic Republic of the Congo', 'AFRO', '201', '23042', '1', '674');
INSERT INTO public.who_global_data_import VALUES (22399, '2021-02-04', 'CD', 'Democratic Republic of the Congo', 'AFRO', '139', '23181', '0', '674');
INSERT INTO public.who_global_data_import VALUES (22400, '2021-02-05', 'CD', 'Democratic Republic of the Congo', 'AFRO', '30', '23211', '3', '677');
INSERT INTO public.who_global_data_import VALUES (22401, '2020-01-03', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22402, '2020-01-04', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22403, '2020-01-05', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22404, '2020-01-06', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22405, '2020-01-07', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22406, '2020-01-08', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22407, '2020-01-09', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22408, '2020-01-10', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22409, '2020-01-11', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22410, '2020-01-12', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22411, '2020-01-13', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22412, '2020-01-14', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22413, '2020-01-15', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22414, '2020-01-16', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22415, '2020-01-17', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22416, '2020-01-18', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22417, '2020-01-19', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22418, '2020-01-20', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22419, '2020-01-21', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22420, '2020-01-22', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22421, '2020-01-23', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22422, '2020-01-24', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22423, '2020-01-25', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22424, '2020-01-26', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22425, '2020-01-27', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22426, '2020-01-28', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22427, '2020-01-29', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22428, '2020-01-30', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22429, '2020-01-31', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22430, '2020-02-01', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22431, '2020-02-02', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22432, '2020-02-03', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22433, '2020-02-04', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22434, '2020-02-05', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22435, '2020-02-06', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22436, '2020-02-07', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22437, '2020-02-08', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22438, '2020-02-09', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22439, '2020-02-10', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22440, '2020-02-11', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22441, '2020-02-12', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22442, '2020-02-13', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22443, '2020-02-14', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22444, '2020-02-15', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22445, '2020-02-16', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22446, '2020-02-17', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22447, '2020-02-18', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22448, '2020-02-19', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22449, '2020-02-20', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22450, '2020-02-21', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22451, '2020-02-22', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22452, '2020-02-23', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22453, '2020-02-24', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22454, '2020-02-25', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22455, '2020-02-26', 'DK', 'Denmark', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22456, '2020-02-27', 'DK', 'Denmark', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22457, '2020-02-28', 'DK', 'Denmark', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22458, '2020-02-29', 'DK', 'Denmark', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22459, '2020-03-01', 'DK', 'Denmark', 'EURO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22460, '2020-03-02', 'DK', 'Denmark', 'EURO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22461, '2020-03-03', 'DK', 'Denmark', 'EURO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22462, '2020-03-04', 'DK', 'Denmark', 'EURO', '3', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22463, '2020-03-05', 'DK', 'Denmark', 'EURO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22464, '2020-03-06', 'DK', 'Denmark', 'EURO', '10', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22465, '2020-03-07', 'DK', 'Denmark', 'EURO', '3', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22466, '2020-03-08', 'DK', 'Denmark', 'EURO', '8', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22467, '2020-03-09', 'DK', 'Denmark', 'EURO', '7', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22468, '2020-03-10', 'DK', 'Denmark', 'EURO', '75', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22469, '2020-03-11', 'DK', 'Denmark', 'EURO', '151', '264', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22470, '2020-03-12', 'DK', 'Denmark', 'EURO', '252', '516', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22471, '2020-03-13', 'DK', 'Denmark', 'EURO', '160', '676', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22472, '2020-03-14', 'DK', 'Denmark', 'EURO', '128', '804', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22473, '2020-03-15', 'DK', 'Denmark', 'EURO', '23', '827', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22474, '2020-03-16', 'DK', 'Denmark', 'EURO', '48', '875', '1', '1');
INSERT INTO public.who_global_data_import VALUES (22475, '2020-03-17', 'DK', 'Denmark', 'EURO', '57', '932', '0', '1');
INSERT INTO public.who_global_data_import VALUES (22476, '2020-03-18', 'DK', 'Denmark', 'EURO', '92', '1024', '3', '4');
INSERT INTO public.who_global_data_import VALUES (22477, '2020-03-19', 'DK', 'Denmark', 'EURO', '91', '1115', '0', '4');
INSERT INTO public.who_global_data_import VALUES (22478, '2020-03-20', 'DK', 'Denmark', 'EURO', '36', '1151', '2', '6');
INSERT INTO public.who_global_data_import VALUES (22479, '2020-03-21', 'DK', 'Denmark', 'EURO', '104', '1255', '3', '9');
INSERT INTO public.who_global_data_import VALUES (22480, '2020-03-22', 'DK', 'Denmark', 'EURO', '71', '1326', '4', '13');
INSERT INTO public.who_global_data_import VALUES (22481, '2020-03-23', 'DK', 'Denmark', 'EURO', '69', '1395', '0', '13');
INSERT INTO public.who_global_data_import VALUES (22482, '2020-03-24', 'DK', 'Denmark', 'EURO', '65', '1460', '11', '24');
INSERT INTO public.who_global_data_import VALUES (22483, '2020-03-25', 'DK', 'Denmark', 'EURO', '131', '1591', '8', '32');
INSERT INTO public.who_global_data_import VALUES (22484, '2020-03-26', 'DK', 'Denmark', 'EURO', '133', '1724', '2', '34');
INSERT INTO public.who_global_data_import VALUES (22485, '2020-03-27', 'DK', 'Denmark', 'EURO', '153', '1877', '7', '41');
INSERT INTO public.who_global_data_import VALUES (22486, '2020-03-28', 'DK', 'Denmark', 'EURO', '169', '2046', '11', '52');
INSERT INTO public.who_global_data_import VALUES (22487, '2020-03-29', 'DK', 'Denmark', 'EURO', '155', '2201', '13', '65');
INSERT INTO public.who_global_data_import VALUES (22488, '2020-03-30', 'DK', 'Denmark', 'EURO', '194', '2395', '7', '72');
INSERT INTO public.who_global_data_import VALUES (22489, '2020-03-31', 'DK', 'Denmark', 'EURO', '182', '2577', '5', '77');
INSERT INTO public.who_global_data_import VALUES (22490, '2020-04-01', 'DK', 'Denmark', 'EURO', '283', '2860', '13', '90');
INSERT INTO public.who_global_data_import VALUES (22491, '2020-04-02', 'DK', 'Denmark', 'EURO', '247', '3107', '14', '104');
INSERT INTO public.who_global_data_import VALUES (22492, '2020-04-03', 'DK', 'Denmark', 'EURO', '279', '3386', '19', '123');
INSERT INTO public.who_global_data_import VALUES (22493, '2020-04-04', 'DK', 'Denmark', 'EURO', '371', '3757', '16', '139');
INSERT INTO public.who_global_data_import VALUES (22494, '2020-04-05', 'DK', 'Denmark', 'EURO', '320', '4077', '22', '161');
INSERT INTO public.who_global_data_import VALUES (22495, '2020-04-06', 'DK', 'Denmark', 'EURO', '292', '4369', '18', '179');
INSERT INTO public.who_global_data_import VALUES (22496, '2020-04-07', 'DK', 'Denmark', 'EURO', '312', '4681', '8', '187');
INSERT INTO public.who_global_data_import VALUES (22497, '2020-04-08', 'DK', 'Denmark', 'EURO', '390', '5071', '16', '203');
INSERT INTO public.who_global_data_import VALUES (22498, '2020-04-09', 'DK', 'Denmark', 'EURO', '331', '5402', '15', '218');
INSERT INTO public.who_global_data_import VALUES (22499, '2020-04-10', 'DK', 'Denmark', 'EURO', '233', '5635', '19', '237');
INSERT INTO public.who_global_data_import VALUES (22500, '2020-04-11', 'DK', 'Denmark', 'EURO', '184', '5819', '10', '247');
INSERT INTO public.who_global_data_import VALUES (22501, '2020-04-12', 'DK', 'Denmark', 'EURO', '177', '5996', '13', '260');
INSERT INTO public.who_global_data_import VALUES (22502, '2020-04-13', 'DK', 'Denmark', 'EURO', '178', '6174', '13', '273');
INSERT INTO public.who_global_data_import VALUES (22503, '2020-04-14', 'DK', 'Denmark', 'EURO', '144', '6318', '12', '285');
INSERT INTO public.who_global_data_import VALUES (22504, '2020-04-15', 'DK', 'Denmark', 'EURO', '193', '6511', '14', '299');
INSERT INTO public.who_global_data_import VALUES (22505, '2020-04-16', 'DK', 'Denmark', 'EURO', '170', '6681', '10', '309');
INSERT INTO public.who_global_data_import VALUES (22506, '2020-04-17', 'DK', 'Denmark', 'EURO', '198', '6879', '12', '321');
INSERT INTO public.who_global_data_import VALUES (22507, '2020-04-18', 'DK', 'Denmark', 'EURO', '194', '7073', '15', '336');
INSERT INTO public.who_global_data_import VALUES (22508, '2020-04-19', 'DK', 'Denmark', 'EURO', '169', '7242', '10', '346');
INSERT INTO public.who_global_data_import VALUES (22509, '2020-04-20', 'DK', 'Denmark', 'EURO', '142', '7384', '9', '355');
INSERT INTO public.who_global_data_import VALUES (22510, '2020-04-21', 'DK', 'Denmark', 'EURO', '131', '7515', '9', '364');
INSERT INTO public.who_global_data_import VALUES (22511, '2020-04-22', 'DK', 'Denmark', 'EURO', '180', '7695', '6', '370');
INSERT INTO public.who_global_data_import VALUES (22512, '2020-04-23', 'DK', 'Denmark', 'EURO', '217', '7912', '14', '384');
INSERT INTO public.who_global_data_import VALUES (22513, '2020-04-24', 'DK', 'Denmark', 'EURO', '161', '8073', '10', '394');
INSERT INTO public.who_global_data_import VALUES (22514, '2020-04-25', 'DK', 'Denmark', 'EURO', '137', '8210', '9', '403');
INSERT INTO public.who_global_data_import VALUES (22515, '2020-04-26', 'DK', 'Denmark', 'EURO', '235', '8445', '15', '418');
INSERT INTO public.who_global_data_import VALUES (22516, '2020-04-27', 'DK', 'Denmark', 'EURO', '130', '8575', '4', '422');
INSERT INTO public.who_global_data_import VALUES (22517, '2020-04-28', 'DK', 'Denmark', 'EURO', '123', '8698', '5', '427');
INSERT INTO public.who_global_data_import VALUES (22518, '2020-04-29', 'DK', 'Denmark', 'EURO', '153', '8851', '7', '434');
INSERT INTO public.who_global_data_import VALUES (22519, '2020-04-30', 'DK', 'Denmark', 'EURO', '157', '9008', '9', '443');
INSERT INTO public.who_global_data_import VALUES (22520, '2020-05-01', 'DK', 'Denmark', 'EURO', '150', '9158', '9', '452');
INSERT INTO public.who_global_data_import VALUES (22521, '2020-05-02', 'DK', 'Denmark', 'EURO', '153', '9311', '8', '460');
INSERT INTO public.who_global_data_import VALUES (22522, '2020-05-03', 'DK', 'Denmark', 'EURO', '96', '9407', '15', '475');
INSERT INTO public.who_global_data_import VALUES (22523, '2020-05-04', 'DK', 'Denmark', 'EURO', '116', '9523', '9', '484');
INSERT INTO public.who_global_data_import VALUES (22524, '2020-05-05', 'DK', 'Denmark', 'EURO', '147', '9670', '9', '493');
INSERT INTO public.who_global_data_import VALUES (22525, '2020-05-06', 'DK', 'Denmark', 'EURO', '151', '9821', '10', '503');
INSERT INTO public.who_global_data_import VALUES (22526, '2020-05-07', 'DK', 'Denmark', 'EURO', '162', '9983', '3', '506');
INSERT INTO public.who_global_data_import VALUES (22527, '2020-05-08', 'DK', 'Denmark', 'EURO', '100', '10083', '8', '514');
INSERT INTO public.who_global_data_import VALUES (22528, '2020-05-09', 'DK', 'Denmark', 'EURO', '135', '10218', '8', '522');
INSERT INTO public.who_global_data_import VALUES (22529, '2020-05-10', 'DK', 'Denmark', 'EURO', '101', '10319', '4', '526');
INSERT INTO public.who_global_data_import VALUES (22530, '2020-05-11', 'DK', 'Denmark', 'EURO', '110', '10429', '3', '529');
INSERT INTO public.who_global_data_import VALUES (22531, '2020-05-12', 'DK', 'Denmark', 'EURO', '84', '10513', '4', '533');
INSERT INTO public.who_global_data_import VALUES (22532, '2020-05-13', 'DK', 'Denmark', 'EURO', '78', '10591', '-6', '527');
INSERT INTO public.who_global_data_import VALUES (22533, '2020-05-14', 'DK', 'Denmark', 'EURO', '76', '10667', '6', '533');
INSERT INTO public.who_global_data_import VALUES (22534, '2020-05-15', 'DK', 'Denmark', 'EURO', '46', '10713', '4', '537');
INSERT INTO public.who_global_data_import VALUES (22535, '2020-05-16', 'DK', 'Denmark', 'EURO', '78', '10791', '0', '537');
INSERT INTO public.who_global_data_import VALUES (22536, '2020-05-17', 'DK', 'Denmark', 'EURO', '67', '10858', '6', '543');
INSERT INTO public.who_global_data_import VALUES (22537, '2020-05-18', 'DK', 'Denmark', 'EURO', '69', '10927', '4', '547');
INSERT INTO public.who_global_data_import VALUES (22538, '2020-05-19', 'DK', 'Denmark', 'EURO', '41', '10968', '1', '548');
INSERT INTO public.who_global_data_import VALUES (22539, '2020-05-20', 'DK', 'Denmark', 'EURO', '76', '11044', '3', '551');
INSERT INTO public.who_global_data_import VALUES (22540, '2020-05-21', 'DK', 'Denmark', 'EURO', '73', '11117', '3', '554');
INSERT INTO public.who_global_data_import VALUES (22541, '2020-05-22', 'DK', 'Denmark', 'EURO', '65', '11182', '7', '561');
INSERT INTO public.who_global_data_import VALUES (22542, '2020-05-23', 'DK', 'Denmark', 'EURO', '48', '11230', '0', '561');
INSERT INTO public.who_global_data_import VALUES (22543, '2020-05-24', 'DK', 'Denmark', 'EURO', '59', '11289', '0', '561');
INSERT INTO public.who_global_data_import VALUES (22544, '2020-05-25', 'DK', 'Denmark', 'EURO', '71', '11360', '1', '562');
INSERT INTO public.who_global_data_import VALUES (22545, '2020-05-26', 'DK', 'Denmark', 'EURO', '27', '11387', '1', '563');
INSERT INTO public.who_global_data_import VALUES (22546, '2020-05-27', 'DK', 'Denmark', 'EURO', '41', '11428', '0', '563');
INSERT INTO public.who_global_data_import VALUES (22547, '2020-05-28', 'DK', 'Denmark', 'EURO', '52', '11480', '2', '565');
INSERT INTO public.who_global_data_import VALUES (22548, '2020-05-29', 'DK', 'Denmark', 'EURO', '32', '11512', '3', '568');
INSERT INTO public.who_global_data_import VALUES (22549, '2020-05-30', 'DK', 'Denmark', 'EURO', '81', '11593', '0', '568');
INSERT INTO public.who_global_data_import VALUES (22550, '2020-05-31', 'DK', 'Denmark', 'EURO', '40', '11633', '3', '571');
INSERT INTO public.who_global_data_import VALUES (22551, '2020-06-01', 'DK', 'Denmark', 'EURO', '36', '11669', '3', '574');
INSERT INTO public.who_global_data_import VALUES (22552, '2020-06-02', 'DK', 'Denmark', 'EURO', '30', '11699', '2', '576');
INSERT INTO public.who_global_data_import VALUES (22553, '2020-06-03', 'DK', 'Denmark', 'EURO', '35', '11734', '4', '580');
INSERT INTO public.who_global_data_import VALUES (22554, '2020-06-04', 'DK', 'Denmark', 'EURO', '37', '11771', '0', '580');
INSERT INTO public.who_global_data_import VALUES (22555, '2020-06-05', 'DK', 'Denmark', 'EURO', '40', '11811', '2', '582');
INSERT INTO public.who_global_data_import VALUES (22556, '2020-06-06', 'DK', 'Denmark', 'EURO', '64', '11875', '4', '586');
INSERT INTO public.who_global_data_import VALUES (22557, '2020-06-07', 'DK', 'Denmark', 'EURO', '49', '11924', '1', '587');
INSERT INTO public.who_global_data_import VALUES (22558, '2020-06-08', 'DK', 'Denmark', 'EURO', '24', '11948', '2', '589');
INSERT INTO public.who_global_data_import VALUES (22559, '2020-06-09', 'DK', 'Denmark', 'EURO', '14', '11962', '4', '593');
INSERT INTO public.who_global_data_import VALUES (22560, '2020-06-10', 'DK', 'Denmark', 'EURO', '39', '12001', '0', '593');
INSERT INTO public.who_global_data_import VALUES (22561, '2020-06-11', 'DK', 'Denmark', 'EURO', '15', '12016', '0', '593');
INSERT INTO public.who_global_data_import VALUES (22562, '2020-06-12', 'DK', 'Denmark', 'EURO', '19', '12035', '0', '593');
INSERT INTO public.who_global_data_import VALUES (22563, '2020-06-13', 'DK', 'Denmark', 'EURO', '64', '12099', '1', '594');
INSERT INTO public.who_global_data_import VALUES (22564, '2020-06-14', 'DK', 'Denmark', 'EURO', '40', '12139', '3', '597');
INSERT INTO public.who_global_data_import VALUES (22565, '2020-06-15', 'DK', 'Denmark', 'EURO', '54', '12193', '0', '597');
INSERT INTO public.who_global_data_import VALUES (22566, '2020-06-16', 'DK', 'Denmark', 'EURO', '24', '12217', '1', '598');
INSERT INTO public.who_global_data_import VALUES (22567, '2020-06-17', 'DK', 'Denmark', 'EURO', '33', '12250', '0', '598');
INSERT INTO public.who_global_data_import VALUES (22568, '2020-06-18', 'DK', 'Denmark', 'EURO', '44', '12294', '0', '598');
INSERT INTO public.who_global_data_import VALUES (22569, '2020-06-19', 'DK', 'Denmark', 'EURO', '50', '12344', '2', '600');
INSERT INTO public.who_global_data_import VALUES (22570, '2020-06-20', 'DK', 'Denmark', 'EURO', '47', '12391', '0', '600');
INSERT INTO public.who_global_data_import VALUES (22571, '2020-06-21', 'DK', 'Denmark', 'EURO', '0', '12391', '0', '600');
INSERT INTO public.who_global_data_import VALUES (22572, '2020-06-22', 'DK', 'Denmark', 'EURO', '0', '12391', '0', '600');
INSERT INTO public.who_global_data_import VALUES (22573, '2020-06-23', 'DK', 'Denmark', 'EURO', '136', '12527', '2', '602');
INSERT INTO public.who_global_data_import VALUES (22574, '2020-06-24', 'DK', 'Denmark', 'EURO', '34', '12561', '1', '603');
INSERT INTO public.who_global_data_import VALUES (22575, '2020-06-25', 'DK', 'Denmark', 'EURO', '54', '12615', '0', '603');
INSERT INTO public.who_global_data_import VALUES (22576, '2020-06-26', 'DK', 'Denmark', 'EURO', '21', '12636', '0', '603');
INSERT INTO public.who_global_data_import VALUES (22577, '2020-06-27', 'DK', 'Denmark', 'EURO', '39', '12675', '1', '604');
INSERT INTO public.who_global_data_import VALUES (22578, '2020-06-28', 'DK', 'Denmark', 'EURO', '0', '12675', '0', '604');
INSERT INTO public.who_global_data_import VALUES (22579, '2020-06-29', 'DK', 'Denmark', 'EURO', '0', '12675', '0', '604');
INSERT INTO public.who_global_data_import VALUES (22580, '2020-06-30', 'DK', 'Denmark', 'EURO', '76', '12751', '1', '605');
INSERT INTO public.who_global_data_import VALUES (22581, '2020-07-01', 'DK', 'Denmark', 'EURO', '17', '12768', '0', '605');
INSERT INTO public.who_global_data_import VALUES (22582, '2020-07-02', 'DK', 'Denmark', 'EURO', '26', '12794', '1', '606');
INSERT INTO public.who_global_data_import VALUES (22583, '2020-07-03', 'DK', 'Denmark', 'EURO', '21', '12815', '0', '606');
INSERT INTO public.who_global_data_import VALUES (22584, '2020-07-04', 'DK', 'Denmark', 'EURO', '17', '12832', '0', '606');
INSERT INTO public.who_global_data_import VALUES (22585, '2020-07-05', 'DK', 'Denmark', 'EURO', '0', '12832', '0', '606');
INSERT INTO public.who_global_data_import VALUES (22586, '2020-07-06', 'DK', 'Denmark', 'EURO', '0', '12832', '0', '606');
INSERT INTO public.who_global_data_import VALUES (22587, '2020-07-07', 'DK', 'Denmark', 'EURO', '46', '12878', '1', '607');
INSERT INTO public.who_global_data_import VALUES (22588, '2020-07-08', 'DK', 'Denmark', 'EURO', '10', '12888', '2', '609');
INSERT INTO public.who_global_data_import VALUES (22589, '2020-07-09', 'DK', 'Denmark', 'EURO', '12', '12900', '0', '609');
INSERT INTO public.who_global_data_import VALUES (22590, '2020-07-10', 'DK', 'Denmark', 'EURO', '16', '12916', '0', '609');
INSERT INTO public.who_global_data_import VALUES (22591, '2020-07-11', 'DK', 'Denmark', 'EURO', '30', '12946', '0', '609');
INSERT INTO public.who_global_data_import VALUES (22592, '2020-07-12', 'DK', 'Denmark', 'EURO', '0', '12946', '0', '609');
INSERT INTO public.who_global_data_import VALUES (22593, '2020-07-13', 'DK', 'Denmark', 'EURO', '0', '12946', '0', '609');
INSERT INTO public.who_global_data_import VALUES (22594, '2020-07-14', 'DK', 'Denmark', 'EURO', '91', '13037', '1', '610');
INSERT INTO public.who_global_data_import VALUES (22595, '2020-07-15', 'DK', 'Denmark', 'EURO', '24', '13061', '0', '610');
INSERT INTO public.who_global_data_import VALUES (22596, '2020-07-16', 'DK', 'Denmark', 'EURO', '31', '13092', '0', '610');
INSERT INTO public.who_global_data_import VALUES (22597, '2020-07-17', 'DK', 'Denmark', 'EURO', '32', '13124', '0', '610');
INSERT INTO public.who_global_data_import VALUES (22598, '2020-07-18', 'DK', 'Denmark', 'EURO', '49', '13173', '1', '611');
INSERT INTO public.who_global_data_import VALUES (22599, '2020-07-19', 'DK', 'Denmark', 'EURO', '0', '13173', '0', '611');
INSERT INTO public.who_global_data_import VALUES (22600, '2020-07-20', 'DK', 'Denmark', 'EURO', '0', '13173', '0', '611');
INSERT INTO public.who_global_data_import VALUES (22601, '2020-07-21', 'DK', 'Denmark', 'EURO', '89', '13262', '0', '611');
INSERT INTO public.who_global_data_import VALUES (22602, '2020-07-22', 'DK', 'Denmark', 'EURO', '40', '13302', '0', '611');
INSERT INTO public.who_global_data_import VALUES (22603, '2020-07-23', 'DK', 'Denmark', 'EURO', '48', '13350', '0', '611');
INSERT INTO public.who_global_data_import VALUES (22604, '2020-07-24', 'DK', 'Denmark', 'EURO', '40', '13390', '1', '612');
INSERT INTO public.who_global_data_import VALUES (22605, '2020-07-25', 'DK', 'Denmark', 'EURO', '48', '13438', '1', '613');
INSERT INTO public.who_global_data_import VALUES (22606, '2020-07-26', 'DK', 'Denmark', 'EURO', '0', '13438', '0', '613');
INSERT INTO public.who_global_data_import VALUES (22607, '2020-07-27', 'DK', 'Denmark', 'EURO', '0', '13438', '0', '613');
INSERT INTO public.who_global_data_import VALUES (22608, '2020-07-28', 'DK', 'Denmark', 'EURO', '109', '13547', '0', '613');
INSERT INTO public.who_global_data_import VALUES (22609, '2020-07-29', 'DK', 'Denmark', 'EURO', '30', '13577', '0', '613');
INSERT INTO public.who_global_data_import VALUES (22610, '2020-07-30', 'DK', 'Denmark', 'EURO', '57', '13634', '1', '614');
INSERT INTO public.who_global_data_import VALUES (22611, '2020-07-31', 'DK', 'Denmark', 'EURO', '91', '13725', '1', '615');
INSERT INTO public.who_global_data_import VALUES (22612, '2020-08-01', 'DK', 'Denmark', 'EURO', '64', '13789', '0', '615');
INSERT INTO public.who_global_data_import VALUES (22613, '2020-08-02', 'DK', 'Denmark', 'EURO', '0', '13789', '0', '615');
INSERT INTO public.who_global_data_import VALUES (22614, '2020-08-03', 'DK', 'Denmark', 'EURO', '0', '13789', '0', '615');
INSERT INTO public.who_global_data_import VALUES (22615, '2020-08-04', 'DK', 'Denmark', 'EURO', '207', '13996', '1', '616');
INSERT INTO public.who_global_data_import VALUES (22616, '2020-08-05', 'DK', 'Denmark', 'EURO', '77', '14073', '0', '616');
INSERT INTO public.who_global_data_import VALUES (22617, '2020-08-06', 'DK', 'Denmark', 'EURO', '112', '14185', '0', '616');
INSERT INTO public.who_global_data_import VALUES (22618, '2020-08-07', 'DK', 'Denmark', 'EURO', '121', '14306', '1', '617');
INSERT INTO public.who_global_data_import VALUES (22619, '2020-08-08', 'DK', 'Denmark', 'EURO', '136', '14442', '0', '617');
INSERT INTO public.who_global_data_import VALUES (22620, '2020-08-09', 'DK', 'Denmark', 'EURO', '0', '14442', '0', '617');
INSERT INTO public.who_global_data_import VALUES (22621, '2020-08-10', 'DK', 'Denmark', 'EURO', '0', '14442', '0', '617');
INSERT INTO public.who_global_data_import VALUES (22622, '2020-08-11', 'DK', 'Denmark', 'EURO', '373', '14815', '3', '620');
INSERT INTO public.who_global_data_import VALUES (22623, '2020-08-12', 'DK', 'Denmark', 'EURO', '144', '14959', '1', '621');
INSERT INTO public.who_global_data_import VALUES (22624, '2020-08-13', 'DK', 'Denmark', 'EURO', '111', '15070', '0', '621');
INSERT INTO public.who_global_data_import VALUES (22625, '2020-08-14', 'DK', 'Denmark', 'EURO', '144', '15214', '0', '621');
INSERT INTO public.who_global_data_import VALUES (22626, '2020-08-15', 'DK', 'Denmark', 'EURO', '165', '15379', '0', '621');
INSERT INTO public.who_global_data_import VALUES (22627, '2020-08-16', 'DK', 'Denmark', 'EURO', '104', '15483', '0', '621');
INSERT INTO public.who_global_data_import VALUES (22628, '2020-08-17', 'DK', 'Denmark', 'EURO', '134', '15617', '0', '621');
INSERT INTO public.who_global_data_import VALUES (22629, '2020-08-18', 'DK', 'Denmark', 'EURO', '123', '15740', '0', '621');
INSERT INTO public.who_global_data_import VALUES (22630, '2020-08-19', 'DK', 'Denmark', 'EURO', '115', '15855', '0', '621');
INSERT INTO public.who_global_data_import VALUES (22631, '2020-08-20', 'DK', 'Denmark', 'EURO', '85', '15940', '0', '621');
INSERT INTO public.who_global_data_import VALUES (22632, '2020-08-21', 'DK', 'Denmark', 'EURO', '116', '16056', '0', '621');
INSERT INTO public.who_global_data_import VALUES (22633, '2020-08-22', 'DK', 'Denmark', 'EURO', '71', '16127', '0', '621');
INSERT INTO public.who_global_data_import VALUES (22634, '2020-08-23', 'DK', 'Denmark', 'EURO', '0', '16127', '0', '621');
INSERT INTO public.who_global_data_import VALUES (22635, '2020-08-24', 'DK', 'Denmark', 'EURO', '0', '16127', '0', '621');
INSERT INTO public.who_global_data_import VALUES (22636, '2020-08-25', 'DK', 'Denmark', 'EURO', '270', '16397', '2', '623');
INSERT INTO public.who_global_data_import VALUES (22637, '2020-08-26', 'DK', 'Denmark', 'EURO', '83', '16480', '0', '623');
INSERT INTO public.who_global_data_import VALUES (22638, '2020-08-27', 'DK', 'Denmark', 'EURO', '57', '16537', '0', '623');
INSERT INTO public.who_global_data_import VALUES (22639, '2020-08-28', 'DK', 'Denmark', 'EURO', '90', '16627', '1', '624');
INSERT INTO public.who_global_data_import VALUES (22640, '2020-08-29', 'DK', 'Denmark', 'EURO', '73', '16700', '0', '624');
INSERT INTO public.who_global_data_import VALUES (22641, '2020-08-30', 'DK', 'Denmark', 'EURO', '0', '16700', '0', '624');
INSERT INTO public.who_global_data_import VALUES (22642, '2020-08-31', 'DK', 'Denmark', 'EURO', '0', '16700', '0', '624');
INSERT INTO public.who_global_data_import VALUES (22643, '2020-09-01', 'DK', 'Denmark', 'EURO', '285', '16985', '0', '624');
INSERT INTO public.who_global_data_import VALUES (22644, '2020-09-02', 'DK', 'Denmark', 'EURO', '99', '17084', '1', '625');
INSERT INTO public.who_global_data_import VALUES (22645, '2020-09-03', 'DK', 'Denmark', 'EURO', '111', '17195', '1', '626');
INSERT INTO public.who_global_data_import VALUES (22646, '2020-09-04', 'DK', 'Denmark', 'EURO', '179', '17374', '0', '626');
INSERT INTO public.who_global_data_import VALUES (22647, '2020-09-05', 'DK', 'Denmark', 'EURO', '173', '17547', '1', '627');
INSERT INTO public.who_global_data_import VALUES (22648, '2020-09-06', 'DK', 'Denmark', 'EURO', '0', '17547', '0', '627');
INSERT INTO public.who_global_data_import VALUES (22649, '2020-09-07', 'DK', 'Denmark', 'EURO', '0', '17547', '0', '627');
INSERT INTO public.who_global_data_import VALUES (22650, '2020-09-08', 'DK', 'Denmark', 'EURO', '566', '18113', '1', '628');
INSERT INTO public.who_global_data_import VALUES (22651, '2020-09-09', 'DK', 'Denmark', 'EURO', '243', '18356', '0', '628');
INSERT INTO public.who_global_data_import VALUES (22652, '2020-09-10', 'DK', 'Denmark', 'EURO', '251', '18607', '0', '628');
INSERT INTO public.who_global_data_import VALUES (22653, '2020-09-11', 'DK', 'Denmark', 'EURO', '317', '18924', '1', '629');
INSERT INTO public.who_global_data_import VALUES (22654, '2020-09-12', 'DK', 'Denmark', 'EURO', '292', '19216', '0', '629');
INSERT INTO public.who_global_data_import VALUES (22655, '2020-09-13', 'DK', 'Denmark', 'EURO', '0', '19216', '0', '629');
INSERT INTO public.who_global_data_import VALUES (22656, '2020-09-14', 'DK', 'Denmark', 'EURO', '0', '19216', '0', '629');
INSERT INTO public.who_global_data_import VALUES (22657, '2020-09-15', 'DK', 'Denmark', 'EURO', '584', '19800', '4', '633');
INSERT INTO public.who_global_data_import VALUES (22658, '2020-09-16', 'DK', 'Denmark', 'EURO', '329', '20129', '0', '633');
INSERT INTO public.who_global_data_import VALUES (22659, '2020-09-17', 'DK', 'Denmark', 'EURO', '442', '20571', '0', '633');
INSERT INTO public.who_global_data_import VALUES (22660, '2020-09-18', 'DK', 'Denmark', 'EURO', '822', '21393', '2', '635');
INSERT INTO public.who_global_data_import VALUES (22661, '2020-09-19', 'DK', 'Denmark', 'EURO', '454', '21847', '0', '635');
INSERT INTO public.who_global_data_import VALUES (22662, '2020-09-20', 'DK', 'Denmark', 'EURO', '0', '21847', '0', '635');
INSERT INTO public.who_global_data_import VALUES (22663, '2020-09-21', 'DK', 'Denmark', 'EURO', '0', '21847', '0', '635');
INSERT INTO public.who_global_data_import VALUES (22664, '2020-09-22', 'DK', 'Denmark', 'EURO', '1476', '23323', '5', '640');
INSERT INTO public.who_global_data_import VALUES (22665, '2020-09-23', 'DK', 'Denmark', 'EURO', '476', '23799', '1', '641');
INSERT INTO public.who_global_data_import VALUES (22666, '2020-09-24', 'DK', 'Denmark', 'EURO', '558', '24357', '2', '643');
INSERT INTO public.who_global_data_import VALUES (22667, '2020-09-25', 'DK', 'Denmark', 'EURO', '559', '24916', '2', '645');
INSERT INTO public.who_global_data_import VALUES (22668, '2020-09-26', 'DK', 'Denmark', 'EURO', '678', '25594', '2', '647');
INSERT INTO public.who_global_data_import VALUES (22669, '2020-09-27', 'DK', 'Denmark', 'EURO', '619', '26213', '1', '648');
INSERT INTO public.who_global_data_import VALUES (22670, '2020-09-28', 'DK', 'Denmark', 'EURO', '424', '26637', '1', '649');
INSERT INTO public.who_global_data_import VALUES (22671, '2020-09-29', 'DK', 'Denmark', 'EURO', '435', '27072', '0', '649');
INSERT INTO public.who_global_data_import VALUES (22672, '2020-09-30', 'DK', 'Denmark', 'EURO', '392', '27464', '1', '650');
INSERT INTO public.who_global_data_import VALUES (22673, '2020-10-01', 'DK', 'Denmark', 'EURO', '534', '27998', '0', '650');
INSERT INTO public.who_global_data_import VALUES (22674, '2020-10-02', 'DK', 'Denmark', 'EURO', '398', '28396', '1', '651');
INSERT INTO public.who_global_data_import VALUES (22675, '2020-10-03', 'DK', 'Denmark', 'EURO', '536', '28932', '1', '652');
INSERT INTO public.who_global_data_import VALUES (22676, '2020-10-04', 'DK', 'Denmark', 'EURO', '370', '29302', '2', '654');
INSERT INTO public.who_global_data_import VALUES (22677, '2020-10-05', 'DK', 'Denmark', 'EURO', '378', '29680', '4', '658');
INSERT INTO public.who_global_data_import VALUES (22678, '2020-10-06', 'DK', 'Denmark', 'EURO', '377', '30057', '1', '659');
INSERT INTO public.who_global_data_import VALUES (22679, '2020-10-07', 'DK', 'Denmark', 'EURO', '322', '30379', '4', '663');
INSERT INTO public.who_global_data_import VALUES (22680, '2020-10-08', 'DK', 'Denmark', 'EURO', '331', '30710', '0', '663');
INSERT INTO public.who_global_data_import VALUES (22681, '2020-10-09', 'DK', 'Denmark', 'EURO', '446', '31156', '2', '665');
INSERT INTO public.who_global_data_import VALUES (22682, '2020-10-10', 'DK', 'Denmark', 'EURO', '482', '31638', '0', '665');
INSERT INTO public.who_global_data_import VALUES (22683, '2020-10-11', 'DK', 'Denmark', 'EURO', '444', '32082', '2', '667');
INSERT INTO public.who_global_data_import VALUES (22684, '2020-10-12', 'DK', 'Denmark', 'EURO', '340', '32422', '2', '669');
INSERT INTO public.who_global_data_import VALUES (22685, '2020-10-13', 'DK', 'Denmark', 'EURO', '389', '32811', '2', '671');
INSERT INTO public.who_global_data_import VALUES (22686, '2020-10-14', 'DK', 'Denmark', 'EURO', '290', '33101', '3', '674');
INSERT INTO public.who_global_data_import VALUES (22687, '2020-10-15', 'DK', 'Denmark', 'EURO', '492', '33593', '1', '675');
INSERT INTO public.who_global_data_import VALUES (22688, '2020-10-16', 'DK', 'Denmark', 'EURO', '430', '34023', '2', '677');
INSERT INTO public.who_global_data_import VALUES (22689, '2020-10-17', 'DK', 'Denmark', 'EURO', '418', '34441', '0', '677');
INSERT INTO public.who_global_data_import VALUES (22690, '2020-10-18', 'DK', 'Denmark', 'EURO', '500', '34941', '2', '679');
INSERT INTO public.who_global_data_import VALUES (22691, '2020-10-19', 'DK', 'Denmark', 'EURO', '451', '35392', '1', '680');
INSERT INTO public.who_global_data_import VALUES (22692, '2020-10-20', 'DK', 'Denmark', 'EURO', '452', '35844', '6', '686');
INSERT INTO public.who_global_data_import VALUES (22693, '2020-10-21', 'DK', 'Denmark', 'EURO', '529', '36373', '2', '688');
INSERT INTO public.who_global_data_import VALUES (22694, '2020-10-22', 'DK', 'Denmark', 'EURO', '630', '37003', '2', '690');
INSERT INTO public.who_global_data_import VALUES (22695, '2020-10-23', 'DK', 'Denmark', 'EURO', '760', '37763', '4', '694');
INSERT INTO public.who_global_data_import VALUES (22696, '2020-10-24', 'DK', 'Denmark', 'EURO', '859', '38622', '3', '697');
INSERT INTO public.who_global_data_import VALUES (22697, '2020-10-25', 'DK', 'Denmark', 'EURO', '789', '39411', '3', '700');
INSERT INTO public.who_global_data_import VALUES (22698, '2020-10-26', 'DK', 'Denmark', 'EURO', '945', '40356', '2', '702');
INSERT INTO public.who_global_data_import VALUES (22699, '2020-10-27', 'DK', 'Denmark', 'EURO', '1056', '41412', '6', '708');
INSERT INTO public.who_global_data_import VALUES (22700, '2020-10-28', 'DK', 'Denmark', 'EURO', '745', '42157', '1', '709');
INSERT INTO public.who_global_data_import VALUES (22701, '2020-10-29', 'DK', 'Denmark', 'EURO', '1017', '43174', '6', '715');
INSERT INTO public.who_global_data_import VALUES (22702, '2020-10-30', 'DK', 'Denmark', 'EURO', '860', '44034', '1', '716');
INSERT INTO public.who_global_data_import VALUES (22703, '2020-10-31', 'DK', 'Denmark', 'EURO', '1191', '45225', '3', '719');
INSERT INTO public.who_global_data_import VALUES (22704, '2020-11-01', 'DK', 'Denmark', 'EURO', '1126', '46351', '2', '721');
INSERT INTO public.who_global_data_import VALUES (22705, '2020-11-02', 'DK', 'Denmark', 'EURO', '948', '47299', '2', '723');
INSERT INTO public.who_global_data_import VALUES (22706, '2020-11-03', 'DK', 'Denmark', 'EURO', '942', '48241', '1', '724');
INSERT INTO public.who_global_data_import VALUES (22707, '2020-11-04', 'DK', 'Denmark', 'EURO', '1353', '49594', '4', '728');
INSERT INTO public.who_global_data_import VALUES (22708, '2020-11-05', 'DK', 'Denmark', 'EURO', '936', '50530', '1', '729');
INSERT INTO public.who_global_data_import VALUES (22709, '2020-11-06', 'DK', 'Denmark', 'EURO', '1223', '51753', '4', '733');
INSERT INTO public.who_global_data_import VALUES (22710, '2020-11-07', 'DK', 'Denmark', 'EURO', '1427', '53180', '5', '738');
INSERT INTO public.who_global_data_import VALUES (22711, '2020-11-08', 'DK', 'Denmark', 'EURO', '1050', '54230', '2', '740');
INSERT INTO public.who_global_data_import VALUES (22712, '2020-11-09', 'DK', 'Denmark', 'EURO', '891', '55121', '3', '743');
INSERT INTO public.who_global_data_import VALUES (22713, '2020-11-10', 'DK', 'Denmark', 'EURO', '771', '55892', '4', '747');
INSERT INTO public.who_global_data_import VALUES (22714, '2020-11-11', 'DK', 'Denmark', 'EURO', '1066', '56958', '3', '750');
INSERT INTO public.who_global_data_import VALUES (22715, '2020-11-12', 'DK', 'Denmark', 'EURO', '994', '57952', '3', '753');
INSERT INTO public.who_global_data_import VALUES (22716, '2020-11-13', 'DK', 'Denmark', 'EURO', '1011', '58963', '2', '755');
INSERT INTO public.who_global_data_import VALUES (22717, '2020-11-14', 'DK', 'Denmark', 'EURO', '1037', '60000', '1', '756');
INSERT INTO public.who_global_data_import VALUES (22718, '2020-11-15', 'DK', 'Denmark', 'EURO', '1078', '61078', '1', '757');
INSERT INTO public.who_global_data_import VALUES (22719, '2020-11-16', 'DK', 'Denmark', 'EURO', '1058', '62136', '3', '760');
INSERT INTO public.who_global_data_import VALUES (22720, '2020-11-17', 'DK', 'Denmark', 'EURO', '1195', '63331', '4', '764');
INSERT INTO public.who_global_data_import VALUES (22721, '2020-11-18', 'DK', 'Denmark', 'EURO', '1220', '64551', '4', '768');
INSERT INTO public.who_global_data_import VALUES (22722, '2020-11-19', 'DK', 'Denmark', 'EURO', '1257', '65808', '2', '770');
INSERT INTO public.who_global_data_import VALUES (22723, '2020-11-20', 'DK', 'Denmark', 'EURO', '1297', '67105', '3', '773');
INSERT INTO public.who_global_data_import VALUES (22724, '2020-11-21', 'DK', 'Denmark', 'EURO', '1257', '68362', '5', '778');
INSERT INTO public.who_global_data_import VALUES (22725, '2020-11-22', 'DK', 'Denmark', 'EURO', '1273', '69635', '3', '781');
INSERT INTO public.who_global_data_import VALUES (22726, '2020-11-23', 'DK', 'Denmark', 'EURO', '850', '70485', '3', '784');
INSERT INTO public.who_global_data_import VALUES (22727, '2020-11-24', 'DK', 'Denmark', 'EURO', '1169', '71654', '5', '789');
INSERT INTO public.who_global_data_import VALUES (22728, '2020-11-25', 'DK', 'Denmark', 'EURO', '1367', '73021', '8', '797');
INSERT INTO public.who_global_data_import VALUES (22729, '2020-11-26', 'DK', 'Denmark', 'EURO', '1183', '74204', '5', '802');
INSERT INTO public.who_global_data_import VALUES (22730, '2020-11-27', 'DK', 'Denmark', 'EURO', '1191', '75395', '9', '811');
INSERT INTO public.who_global_data_import VALUES (22731, '2020-11-28', 'DK', 'Denmark', 'EURO', '1323', '76718', '5', '816');
INSERT INTO public.who_global_data_import VALUES (22732, '2020-11-29', 'DK', 'Denmark', 'EURO', '1636', '78354', '7', '823');
INSERT INTO public.who_global_data_import VALUES (22733, '2020-11-30', 'DK', 'Denmark', 'EURO', '998', '79352', '6', '829');
INSERT INTO public.who_global_data_import VALUES (22734, '2020-12-01', 'DK', 'Denmark', 'EURO', '1129', '80481', '8', '837');
INSERT INTO public.who_global_data_import VALUES (22735, '2020-12-02', 'DK', 'Denmark', 'EURO', '1468', '81949', '9', '846');
INSERT INTO public.who_global_data_import VALUES (22736, '2020-12-03', 'DK', 'Denmark', 'EURO', '1586', '83535', '6', '852');
INSERT INTO public.who_global_data_import VALUES (22737, '2020-12-04', 'DK', 'Denmark', 'EURO', '1605', '85140', '6', '858');
INSERT INTO public.who_global_data_import VALUES (22738, '2020-12-05', 'DK', 'Denmark', 'EURO', '1603', '86743', '9', '867');
INSERT INTO public.who_global_data_import VALUES (22739, '2020-12-06', 'DK', 'Denmark', 'EURO', '2115', '88858', '11', '878');
INSERT INTO public.who_global_data_import VALUES (22740, '2020-12-07', 'DK', 'Denmark', 'EURO', '1745', '90603', '7', '885');
INSERT INTO public.who_global_data_import VALUES (22741, '2020-12-08', 'DK', 'Denmark', 'EURO', '2046', '92649', '9', '894');
INSERT INTO public.who_global_data_import VALUES (22742, '2020-12-09', 'DK', 'Denmark', 'EURO', '2150', '94799', '7', '901');
INSERT INTO public.who_global_data_import VALUES (22743, '2020-12-10', 'DK', 'Denmark', 'EURO', '2558', '97357', '3', '904');
INSERT INTO public.who_global_data_import VALUES (22744, '2020-12-11', 'DK', 'Denmark', 'EURO', '3132', '100489', '14', '918');
INSERT INTO public.who_global_data_import VALUES (22745, '2020-12-12', 'DK', 'Denmark', 'EURO', '3075', '103564', '9', '927');
INSERT INTO public.who_global_data_import VALUES (22746, '2020-12-13', 'DK', 'Denmark', 'EURO', '3552', '107116', '8', '935');
INSERT INTO public.who_global_data_import VALUES (22747, '2020-12-14', 'DK', 'Denmark', 'EURO', '2642', '109758', '6', '941');
INSERT INTO public.who_global_data_import VALUES (22748, '2020-12-15', 'DK', 'Denmark', 'EURO', '3337', '113095', '9', '950');
INSERT INTO public.who_global_data_import VALUES (22749, '2020-12-16', 'DK', 'Denmark', 'EURO', '2992', '116087', '11', '961');
INSERT INTO public.who_global_data_import VALUES (22750, '2020-12-17', 'DK', 'Denmark', 'EURO', '3692', '119779', '14', '975');
INSERT INTO public.who_global_data_import VALUES (22751, '2020-12-18', 'DK', 'Denmark', 'EURO', '4034', '123813', '17', '992');
INSERT INTO public.who_global_data_import VALUES (22752, '2020-12-19', 'DK', 'Denmark', 'EURO', '4508', '128321', '15', '1007');
INSERT INTO public.who_global_data_import VALUES (22753, '2020-12-20', 'DK', 'Denmark', 'EURO', '3285', '131606', '12', '1019');
INSERT INTO public.who_global_data_import VALUES (22754, '2020-12-21', 'DK', 'Denmark', 'EURO', '2828', '134434', '16', '1035');
INSERT INTO public.who_global_data_import VALUES (22755, '2020-12-22', 'DK', 'Denmark', 'EURO', '3198', '137632', '18', '1053');
INSERT INTO public.who_global_data_import VALUES (22756, '2020-12-23', 'DK', 'Denmark', 'EURO', '2543', '140175', '17', '1070');
INSERT INTO public.who_global_data_import VALUES (22757, '2020-12-24', 'DK', 'Denmark', 'EURO', '3297', '143472', '26', '1096');
INSERT INTO public.who_global_data_import VALUES (22758, '2020-12-25', 'DK', 'Denmark', 'EURO', '2869', '146341', '18', '1114');
INSERT INTO public.who_global_data_import VALUES (22759, '2020-12-26', 'DK', 'Denmark', 'EURO', '2992', '149333', '20', '1134');
INSERT INTO public.who_global_data_import VALUES (22760, '2020-12-27', 'DK', 'Denmark', 'EURO', '1834', '151167', '19', '1153');
INSERT INTO public.who_global_data_import VALUES (22761, '2020-12-28', 'DK', 'Denmark', 'EURO', '2180', '153347', '21', '1174');
INSERT INTO public.who_global_data_import VALUES (22762, '2020-12-29', 'DK', 'Denmark', 'EURO', '2479', '155826', '30', '1204');
INSERT INTO public.who_global_data_import VALUES (22763, '2020-12-30', 'DK', 'Denmark', 'EURO', '2621', '158447', '22', '1226');
INSERT INTO public.who_global_data_import VALUES (22764, '2020-12-31', 'DK', 'Denmark', 'EURO', '2783', '161230', '30', '1256');
INSERT INTO public.who_global_data_import VALUES (22765, '2021-01-01', 'DK', 'Denmark', 'EURO', '2249', '163479', '42', '1298');
INSERT INTO public.who_global_data_import VALUES (22766, '2021-01-02', 'DK', 'Denmark', 'EURO', '2451', '165930', '24', '1322');
INSERT INTO public.who_global_data_import VALUES (22767, '2021-01-03', 'DK', 'Denmark', 'EURO', '1611', '167541', '23', '1345');
INSERT INTO public.who_global_data_import VALUES (22768, '2021-01-04', 'DK', 'Denmark', 'EURO', '1170', '168711', '29', '1374');
INSERT INTO public.who_global_data_import VALUES (22769, '2021-01-05', 'DK', 'Denmark', 'EURO', '2076', '170787', '15', '1389');
INSERT INTO public.who_global_data_import VALUES (22770, '2021-01-06', 'DK', 'Denmark', 'EURO', '1992', '172779', '31', '1420');
INSERT INTO public.who_global_data_import VALUES (22771, '2021-01-07', 'DK', 'Denmark', 'EURO', '2216', '174995', '30', '1450');
INSERT INTO public.who_global_data_import VALUES (22772, '2021-01-08', 'DK', 'Denmark', 'EURO', '1842', '176837', '37', '1487');
INSERT INTO public.who_global_data_import VALUES (22773, '2021-01-09', 'DK', 'Denmark', 'EURO', '1660', '178497', '30', '1517');
INSERT INTO public.who_global_data_import VALUES (22774, '2021-01-10', 'DK', 'Denmark', 'EURO', '1743', '180240', '25', '1542');
INSERT INTO public.who_global_data_import VALUES (22775, '2021-01-11', 'DK', 'Denmark', 'EURO', '1246', '181486', '28', '1570');
INSERT INTO public.who_global_data_import VALUES (22776, '2021-01-12', 'DK', 'Denmark', 'EURO', '1239', '182725', '27', '1597');
INSERT INTO public.who_global_data_import VALUES (22777, '2021-01-13', 'DK', 'Denmark', 'EURO', '1076', '183801', '26', '1623');
INSERT INTO public.who_global_data_import VALUES (22778, '2021-01-14', 'DK', 'Denmark', 'EURO', '1358', '185159', '37', '1660');
INSERT INTO public.who_global_data_import VALUES (22779, '2021-01-15', 'DK', 'Denmark', 'EURO', '1502', '186661', '43', '1703');
INSERT INTO public.who_global_data_import VALUES (22780, '2021-01-16', 'DK', 'Denmark', 'EURO', '659', '187320', '17', '1720');
INSERT INTO public.who_global_data_import VALUES (22781, '2021-01-17', 'DK', 'Denmark', 'EURO', '879', '188199', '27', '1747');
INSERT INTO public.who_global_data_import VALUES (22782, '2021-01-18', 'DK', 'Denmark', 'EURO', '889', '189088', '28', '1775');
INSERT INTO public.who_global_data_import VALUES (22783, '2021-01-19', 'DK', 'Denmark', 'EURO', '807', '189895', '30', '1805');
INSERT INTO public.who_global_data_import VALUES (22784, '2021-01-20', 'DK', 'Denmark', 'EURO', '724', '190619', '32', '1837');
INSERT INTO public.who_global_data_import VALUES (22785, '2021-01-21', 'DK', 'Denmark', 'EURO', '886', '191505', '35', '1872');
INSERT INTO public.who_global_data_import VALUES (22786, '2021-01-22', 'DK', 'Denmark', 'EURO', '760', '192265', '37', '1909');
INSERT INTO public.who_global_data_import VALUES (22787, '2021-01-23', 'DK', 'Denmark', 'EURO', '773', '193038', '32', '1941');
INSERT INTO public.who_global_data_import VALUES (22788, '2021-01-24', 'DK', 'Denmark', 'EURO', '879', '193917', '28', '1969');
INSERT INTO public.who_global_data_import VALUES (22789, '2021-01-25', 'DK', 'Denmark', 'EURO', '754', '194671', '14', '1983');
INSERT INTO public.who_global_data_import VALUES (22790, '2021-01-26', 'DK', 'Denmark', 'EURO', '625', '195296', '27', '2010');
INSERT INTO public.who_global_data_import VALUES (22791, '2021-01-27', 'DK', 'Denmark', 'EURO', '652', '195948', '20', '2030');
INSERT INTO public.who_global_data_import VALUES (22792, '2021-01-28', 'DK', 'Denmark', 'EURO', '592', '196540', '20', '2050');
INSERT INTO public.who_global_data_import VALUES (22793, '2021-01-29', 'DK', 'Denmark', 'EURO', '668', '197208', '21', '2071');
INSERT INTO public.who_global_data_import VALUES (22794, '2021-01-30', 'DK', 'Denmark', 'EURO', '456', '197664', '13', '2084');
INSERT INTO public.who_global_data_import VALUES (22795, '2021-01-31', 'DK', 'Denmark', 'EURO', '431', '198095', '22', '2106');
INSERT INTO public.who_global_data_import VALUES (22796, '2021-02-01', 'DK', 'Denmark', 'EURO', '377', '198472', '19', '2125');
INSERT INTO public.who_global_data_import VALUES (22797, '2021-02-02', 'DK', 'Denmark', 'EURO', '488', '198960', '20', '2145');
INSERT INTO public.who_global_data_import VALUES (22798, '2021-02-03', 'DK', 'Denmark', 'EURO', '397', '199357', '15', '2160');
INSERT INTO public.who_global_data_import VALUES (22799, '2021-02-04', 'DK', 'Denmark', 'EURO', '425', '199782', '10', '2170');
INSERT INTO public.who_global_data_import VALUES (22800, '2021-02-05', 'DK', 'Denmark', 'EURO', '553', '200335', '14', '2184');
INSERT INTO public.who_global_data_import VALUES (22801, '2020-01-03', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22802, '2020-01-04', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22803, '2020-01-05', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22804, '2020-01-06', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22805, '2020-01-07', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22806, '2020-01-08', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22807, '2020-01-09', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22808, '2020-01-10', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22809, '2020-01-11', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22810, '2020-01-12', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22811, '2020-01-13', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22812, '2020-01-14', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22813, '2020-01-15', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22823, '2020-01-25', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22824, '2020-01-26', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22825, '2020-01-27', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22826, '2020-01-28', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22827, '2020-01-29', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22828, '2020-01-30', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22829, '2020-01-31', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22830, '2020-02-01', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22831, '2020-02-02', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22832, '2020-02-03', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22833, '2020-02-04', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22834, '2020-02-05', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22835, '2020-02-06', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22836, '2020-02-07', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22837, '2020-02-08', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22838, '2020-02-09', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22839, '2020-02-10', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22840, '2020-02-11', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22841, '2020-02-12', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22842, '2020-02-13', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22843, '2020-02-14', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22844, '2020-02-15', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22845, '2020-02-16', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22846, '2020-02-17', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22847, '2020-02-18', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22848, '2020-02-19', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22849, '2020-02-20', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22850, '2020-02-21', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22851, '2020-02-22', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22852, '2020-02-23', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22853, '2020-02-24', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22854, '2020-02-25', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22855, '2020-02-26', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22856, '2020-02-27', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22857, '2020-02-28', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22858, '2020-02-29', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22859, '2020-03-01', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22860, '2020-03-02', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22861, '2020-03-03', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22862, '2020-03-04', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22863, '2020-03-05', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22864, '2020-03-06', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22865, '2020-03-07', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22866, '2020-03-08', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22867, '2020-03-09', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22868, '2020-03-10', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22869, '2020-03-11', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22870, '2020-03-12', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22871, '2020-03-13', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22872, '2020-03-14', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22873, '2020-03-15', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22874, '2020-03-16', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22875, '2020-03-17', 'DJ', 'Djibouti', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22876, '2020-03-18', 'DJ', 'Djibouti', 'EMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22877, '2020-03-19', 'DJ', 'Djibouti', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22878, '2020-03-20', 'DJ', 'Djibouti', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22879, '2020-03-21', 'DJ', 'Djibouti', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22880, '2020-03-22', 'DJ', 'Djibouti', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22881, '2020-03-23', 'DJ', 'Djibouti', 'EMRO', '-2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22882, '2020-03-24', 'DJ', 'Djibouti', 'EMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22883, '2020-03-25', 'DJ', 'Djibouti', 'EMRO', '9', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22884, '2020-03-26', 'DJ', 'Djibouti', 'EMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22885, '2020-03-27', 'DJ', 'Djibouti', 'EMRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22886, '2020-03-28', 'DJ', 'Djibouti', 'EMRO', '2', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22887, '2020-03-29', 'DJ', 'Djibouti', 'EMRO', '4', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22888, '2020-03-30', 'DJ', 'Djibouti', 'EMRO', '7', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22889, '2020-03-31', 'DJ', 'Djibouti', 'EMRO', '5', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22890, '2020-04-01', 'DJ', 'Djibouti', 'EMRO', '3', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22891, '2020-04-02', 'DJ', 'Djibouti', 'EMRO', '7', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22892, '2020-04-03', 'DJ', 'Djibouti', 'EMRO', '9', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22893, '2020-04-04', 'DJ', 'Djibouti', 'EMRO', '1', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22894, '2020-04-05', 'DJ', 'Djibouti', 'EMRO', '8', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22895, '2020-04-06', 'DJ', 'Djibouti', 'EMRO', '31', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22896, '2020-04-07', 'DJ', 'Djibouti', 'EMRO', '31', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22897, '2020-04-08', 'DJ', 'Djibouti', 'EMRO', '14', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (22898, '2020-04-09', 'DJ', 'Djibouti', 'EMRO', '5', '140', '1', '1');
INSERT INTO public.who_global_data_import VALUES (22899, '2020-04-10', 'DJ', 'Djibouti', 'EMRO', '10', '150', '0', '1');
INSERT INTO public.who_global_data_import VALUES (22900, '2020-04-11', 'DJ', 'Djibouti', 'EMRO', '37', '187', '1', '2');
INSERT INTO public.who_global_data_import VALUES (22901, '2020-04-12', 'DJ', 'Djibouti', 'EMRO', '28', '215', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22902, '2020-04-13', 'DJ', 'Djibouti', 'EMRO', '83', '298', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22903, '2020-04-14', 'DJ', 'Djibouti', 'EMRO', '65', '363', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22904, '2020-04-15', 'DJ', 'Djibouti', 'EMRO', '72', '435', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22905, '2020-04-16', 'DJ', 'Djibouti', 'EMRO', '156', '591', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22906, '2020-04-17', 'DJ', 'Djibouti', 'EMRO', '141', '732', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22907, '2020-04-18', 'DJ', 'Djibouti', 'EMRO', '0', '732', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22908, '2020-04-19', 'DJ', 'Djibouti', 'EMRO', '0', '732', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22909, '2020-04-20', 'DJ', 'Djibouti', 'EMRO', '114', '846', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22910, '2020-04-21', 'DJ', 'Djibouti', 'EMRO', '99', '945', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22911, '2020-04-22', 'DJ', 'Djibouti', 'EMRO', '29', '974', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22912, '2020-04-23', 'DJ', 'Djibouti', 'EMRO', '12', '986', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22913, '2020-04-24', 'DJ', 'Djibouti', 'EMRO', '13', '999', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22914, '2020-04-25', 'DJ', 'Djibouti', 'EMRO', '9', '1008', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22915, '2020-04-26', 'DJ', 'Djibouti', 'EMRO', '15', '1023', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22916, '2020-04-27', 'DJ', 'Djibouti', 'EMRO', '12', '1035', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22917, '2020-04-28', 'DJ', 'Djibouti', 'EMRO', '37', '1072', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22918, '2020-04-29', 'DJ', 'Djibouti', 'EMRO', '5', '1077', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22919, '2020-04-30', 'DJ', 'Djibouti', 'EMRO', '12', '1089', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22920, '2020-05-01', 'DJ', 'Djibouti', 'EMRO', '8', '1097', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22921, '2020-05-02', 'DJ', 'Djibouti', 'EMRO', '15', '1112', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22922, '2020-05-03', 'DJ', 'Djibouti', 'EMRO', '0', '1112', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22923, '2020-05-04', 'DJ', 'Djibouti', 'EMRO', '0', '1112', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22924, '2020-05-05', 'DJ', 'Djibouti', 'EMRO', '8', '1120', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22925, '2020-05-06', 'DJ', 'Djibouti', 'EMRO', '0', '1120', '0', '2');
INSERT INTO public.who_global_data_import VALUES (22926, '2020-05-07', 'DJ', 'Djibouti', 'EMRO', '13', '1133', '1', '3');
INSERT INTO public.who_global_data_import VALUES (22927, '2020-05-08', 'DJ', 'Djibouti', 'EMRO', '2', '1135', '0', '3');
INSERT INTO public.who_global_data_import VALUES (22928, '2020-05-09', 'DJ', 'Djibouti', 'EMRO', '54', '1189', '0', '3');
INSERT INTO public.who_global_data_import VALUES (22929, '2020-05-10', 'DJ', 'Djibouti', 'EMRO', '0', '1189', '0', '3');
INSERT INTO public.who_global_data_import VALUES (22930, '2020-05-11', 'DJ', 'Djibouti', 'EMRO', '21', '1210', '0', '3');
INSERT INTO public.who_global_data_import VALUES (22931, '2020-05-12', 'DJ', 'Djibouti', 'EMRO', '46', '1256', '0', '3');
INSERT INTO public.who_global_data_import VALUES (22932, '2020-05-13', 'DJ', 'Djibouti', 'EMRO', '12', '1268', '0', '3');
INSERT INTO public.who_global_data_import VALUES (22933, '2020-05-14', 'DJ', 'Djibouti', 'EMRO', '0', '1268', '0', '3');
INSERT INTO public.who_global_data_import VALUES (22934, '2020-05-15', 'DJ', 'Djibouti', 'EMRO', '41', '1309', '1', '4');
INSERT INTO public.who_global_data_import VALUES (22935, '2020-05-16', 'DJ', 'Djibouti', 'EMRO', '22', '1331', '0', '4');
INSERT INTO public.who_global_data_import VALUES (22936, '2020-05-17', 'DJ', 'Djibouti', 'EMRO', '70', '1401', '0', '4');
INSERT INTO public.who_global_data_import VALUES (22937, '2020-05-18', 'DJ', 'Djibouti', 'EMRO', '117', '1518', '3', '7');
INSERT INTO public.who_global_data_import VALUES (22938, '2020-05-19', 'DJ', 'Djibouti', 'EMRO', '100', '1618', '0', '7');
INSERT INTO public.who_global_data_import VALUES (22939, '2020-05-20', 'DJ', 'Djibouti', 'EMRO', '210', '1828', '2', '9');
INSERT INTO public.who_global_data_import VALUES (22940, '2020-05-21', 'DJ', 'Djibouti', 'EMRO', '219', '2047', '1', '10');
INSERT INTO public.who_global_data_import VALUES (22941, '2020-05-22', 'DJ', 'Djibouti', 'EMRO', '0', '2047', '0', '10');
INSERT INTO public.who_global_data_import VALUES (22942, '2020-05-23', 'DJ', 'Djibouti', 'EMRO', '223', '2270', '0', '10');
INSERT INTO public.who_global_data_import VALUES (22943, '2020-05-24', 'DJ', 'Djibouti', 'EMRO', '0', '2270', '0', '10');
INSERT INTO public.who_global_data_import VALUES (22944, '2020-05-25', 'DJ', 'Djibouti', 'EMRO', '0', '2270', '0', '10');
INSERT INTO public.who_global_data_import VALUES (22945, '2020-05-26', 'DJ', 'Djibouti', 'EMRO', '198', '2468', '4', '14');
INSERT INTO public.who_global_data_import VALUES (22946, '2020-05-27', 'DJ', 'Djibouti', 'EMRO', '0', '2468', '0', '14');
INSERT INTO public.who_global_data_import VALUES (22947, '2020-05-28', 'DJ', 'Djibouti', 'EMRO', '229', '2697', '4', '18');
INSERT INTO public.who_global_data_import VALUES (22948, '2020-05-29', 'DJ', 'Djibouti', 'EMRO', '217', '2914', '2', '20');
INSERT INTO public.who_global_data_import VALUES (22949, '2020-05-30', 'DJ', 'Djibouti', 'EMRO', '0', '2914', '0', '20');
INSERT INTO public.who_global_data_import VALUES (22950, '2020-05-31', 'DJ', 'Djibouti', 'EMRO', '280', '3194', '2', '22');
INSERT INTO public.who_global_data_import VALUES (22951, '2020-06-01', 'DJ', 'Djibouti', 'EMRO', '160', '3354', '2', '24');
INSERT INTO public.who_global_data_import VALUES (22952, '2020-06-02', 'DJ', 'Djibouti', 'EMRO', '215', '3569', '0', '24');
INSERT INTO public.who_global_data_import VALUES (22953, '2020-06-03', 'DJ', 'Djibouti', 'EMRO', '210', '3779', '1', '25');
INSERT INTO public.who_global_data_import VALUES (22954, '2020-06-04', 'DJ', 'Djibouti', 'EMRO', '156', '3935', '1', '26');
INSERT INTO public.who_global_data_import VALUES (22955, '2020-06-05', 'DJ', 'Djibouti', 'EMRO', '119', '4054', '0', '26');
INSERT INTO public.who_global_data_import VALUES (22956, '2020-06-06', 'DJ', 'Djibouti', 'EMRO', '69', '4123', '0', '26');
INSERT INTO public.who_global_data_import VALUES (22957, '2020-06-07', 'DJ', 'Djibouti', 'EMRO', '46', '4169', '0', '26');
INSERT INTO public.who_global_data_import VALUES (22958, '2020-06-08', 'DJ', 'Djibouti', 'EMRO', '38', '4207', '2', '28');
INSERT INTO public.who_global_data_import VALUES (22959, '2020-06-09', 'DJ', 'Djibouti', 'EMRO', '71', '4278', '3', '31');
INSERT INTO public.who_global_data_import VALUES (22960, '2020-06-10', 'DJ', 'Djibouti', 'EMRO', '53', '4331', '3', '34');
INSERT INTO public.who_global_data_import VALUES (22961, '2020-06-11', 'DJ', 'Djibouti', 'EMRO', '42', '4373', '0', '34');
INSERT INTO public.who_global_data_import VALUES (22962, '2020-06-12', 'DJ', 'Djibouti', 'EMRO', '25', '4398', '3', '37');
INSERT INTO public.who_global_data_import VALUES (22963, '2020-06-13', 'DJ', 'Djibouti', 'EMRO', '43', '4441', '1', '38');
INSERT INTO public.who_global_data_import VALUES (22964, '2020-06-14', 'DJ', 'Djibouti', 'EMRO', '8', '4449', '3', '41');
INSERT INTO public.who_global_data_import VALUES (22965, '2020-06-15', 'DJ', 'Djibouti', 'EMRO', '16', '4465', '2', '43');
INSERT INTO public.who_global_data_import VALUES (22966, '2020-06-16', 'DJ', 'Djibouti', 'EMRO', '36', '4501', '0', '43');
INSERT INTO public.who_global_data_import VALUES (22967, '2020-06-17', 'DJ', 'Djibouti', 'EMRO', '38', '4539', '0', '43');
INSERT INTO public.who_global_data_import VALUES (22968, '2020-06-18', 'DJ', 'Djibouti', 'EMRO', '6', '4545', '0', '43');
INSERT INTO public.who_global_data_import VALUES (22969, '2020-06-19', 'DJ', 'Djibouti', 'EMRO', '12', '4557', '0', '43');
INSERT INTO public.who_global_data_import VALUES (22970, '2020-06-20', 'DJ', 'Djibouti', 'EMRO', '8', '4565', '2', '45');
INSERT INTO public.who_global_data_import VALUES (22971, '2020-06-21', 'DJ', 'Djibouti', 'EMRO', '0', '4565', '0', '45');
INSERT INTO public.who_global_data_import VALUES (22972, '2020-06-22', 'DJ', 'Djibouti', 'EMRO', '17', '4582', '0', '45');
INSERT INTO public.who_global_data_import VALUES (22973, '2020-06-23', 'DJ', 'Djibouti', 'EMRO', '17', '4599', '3', '48');
INSERT INTO public.who_global_data_import VALUES (22974, '2020-06-24', 'DJ', 'Djibouti', 'EMRO', '18', '4617', '1', '49');
INSERT INTO public.who_global_data_import VALUES (22975, '2020-06-25', 'DJ', 'Djibouti', 'EMRO', '13', '4630', '3', '52');
INSERT INTO public.who_global_data_import VALUES (22976, '2020-06-26', 'DJ', 'Djibouti', 'EMRO', '5', '4635', '0', '52');
INSERT INTO public.who_global_data_import VALUES (22977, '2020-06-27', 'DJ', 'Djibouti', 'EMRO', '8', '4643', '0', '52');
INSERT INTO public.who_global_data_import VALUES (22978, '2020-06-28', 'DJ', 'Djibouti', 'EMRO', '0', '4643', '0', '52');
INSERT INTO public.who_global_data_import VALUES (22979, '2020-06-29', 'DJ', 'Djibouti', 'EMRO', '0', '4643', '0', '52');
INSERT INTO public.who_global_data_import VALUES (22980, '2020-06-30', 'DJ', 'Djibouti', 'EMRO', '13', '4656', '1', '53');
INSERT INTO public.who_global_data_import VALUES (22981, '2020-07-01', 'DJ', 'Djibouti', 'EMRO', '26', '4682', '1', '54');
INSERT INTO public.who_global_data_import VALUES (22982, '2020-07-02', 'DJ', 'Djibouti', 'EMRO', '22', '4704', '1', '55');
INSERT INTO public.who_global_data_import VALUES (22983, '2020-07-03', 'DJ', 'Djibouti', 'EMRO', '11', '4715', '0', '55');
INSERT INTO public.who_global_data_import VALUES (22984, '2020-07-04', 'DJ', 'Djibouti', 'EMRO', '21', '4736', '0', '55');
INSERT INTO public.who_global_data_import VALUES (22985, '2020-07-05', 'DJ', 'Djibouti', 'EMRO', '0', '4736', '0', '55');
INSERT INTO public.who_global_data_import VALUES (22986, '2020-07-06', 'DJ', 'Djibouti', 'EMRO', '56', '4792', '0', '55');
INSERT INTO public.who_global_data_import VALUES (22987, '2020-07-07', 'DJ', 'Djibouti', 'EMRO', '30', '4822', '0', '55');
INSERT INTO public.who_global_data_import VALUES (22988, '2020-07-08', 'DJ', 'Djibouti', 'EMRO', '56', '4878', '0', '55');
INSERT INTO public.who_global_data_import VALUES (22989, '2020-07-09', 'DJ', 'Djibouti', 'EMRO', '11', '4889', '0', '55');
INSERT INTO public.who_global_data_import VALUES (22990, '2020-07-10', 'DJ', 'Djibouti', 'EMRO', '66', '4955', '1', '56');
INSERT INTO public.who_global_data_import VALUES (22991, '2020-07-11', 'DJ', 'Djibouti', 'EMRO', '13', '4968', '0', '56');
INSERT INTO public.who_global_data_import VALUES (22992, '2020-07-12', 'DJ', 'Djibouti', 'EMRO', '0', '4968', '0', '56');
INSERT INTO public.who_global_data_import VALUES (22993, '2020-07-13', 'DJ', 'Djibouti', 'EMRO', '4', '4972', '0', '56');
INSERT INTO public.who_global_data_import VALUES (22994, '2020-07-14', 'DJ', 'Djibouti', 'EMRO', '5', '4977', '0', '56');
INSERT INTO public.who_global_data_import VALUES (22995, '2020-07-15', 'DJ', 'Djibouti', 'EMRO', '2', '4979', '0', '56');
INSERT INTO public.who_global_data_import VALUES (22996, '2020-07-16', 'DJ', 'Djibouti', 'EMRO', '6', '4985', '0', '56');
INSERT INTO public.who_global_data_import VALUES (22997, '2020-07-17', 'DJ', 'Djibouti', 'EMRO', '8', '4993', '0', '56');
INSERT INTO public.who_global_data_import VALUES (22998, '2020-07-18', 'DJ', 'Djibouti', 'EMRO', '10', '5003', '0', '56');
INSERT INTO public.who_global_data_import VALUES (22999, '2020-07-19', 'DJ', 'Djibouti', 'EMRO', '0', '5003', '0', '56');
INSERT INTO public.who_global_data_import VALUES (23000, '2020-07-20', 'DJ', 'Djibouti', 'EMRO', '8', '5011', '0', '56');
INSERT INTO public.who_global_data_import VALUES (23001, '2020-07-21', 'DJ', 'Djibouti', 'EMRO', '9', '5020', '0', '56');
INSERT INTO public.who_global_data_import VALUES (23002, '2020-07-22', 'DJ', 'Djibouti', 'EMRO', '7', '5027', '0', '56');
INSERT INTO public.who_global_data_import VALUES (23003, '2020-07-23', 'DJ', 'Djibouti', 'EMRO', '3', '5030', '2', '58');
INSERT INTO public.who_global_data_import VALUES (23004, '2020-07-24', 'DJ', 'Djibouti', 'EMRO', '1', '5031', '0', '58');
INSERT INTO public.who_global_data_import VALUES (23005, '2020-07-25', 'DJ', 'Djibouti', 'EMRO', '8', '5039', '0', '58');
INSERT INTO public.who_global_data_import VALUES (23006, '2020-07-26', 'DJ', 'Djibouti', 'EMRO', '0', '5039', '0', '58');
INSERT INTO public.who_global_data_import VALUES (23007, '2020-07-27', 'DJ', 'Djibouti', 'EMRO', '11', '5050', '0', '58');
INSERT INTO public.who_global_data_import VALUES (23008, '2020-07-28', 'DJ', 'Djibouti', 'EMRO', '9', '5059', '0', '58');
INSERT INTO public.who_global_data_import VALUES (23009, '2020-07-29', 'DJ', 'Djibouti', 'EMRO', '9', '5068', '0', '58');
INSERT INTO public.who_global_data_import VALUES (23010, '2020-07-30', 'DJ', 'Djibouti', 'EMRO', '13', '5081', '0', '58');
INSERT INTO public.who_global_data_import VALUES (23011, '2020-07-31', 'DJ', 'Djibouti', 'EMRO', '0', '5081', '0', '58');
INSERT INTO public.who_global_data_import VALUES (23012, '2020-08-01', 'DJ', 'Djibouti', 'EMRO', '0', '5081', '0', '58');
INSERT INTO public.who_global_data_import VALUES (23013, '2020-08-02', 'DJ', 'Djibouti', 'EMRO', '0', '5081', '0', '58');
INSERT INTO public.who_global_data_import VALUES (23014, '2020-08-03', 'DJ', 'Djibouti', 'EMRO', '80', '5161', '1', '59');
INSERT INTO public.who_global_data_import VALUES (23015, '2020-08-04', 'DJ', 'Djibouti', 'EMRO', '79', '5240', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23016, '2020-08-05', 'DJ', 'Djibouti', 'EMRO', '8', '5248', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23017, '2020-08-06', 'DJ', 'Djibouti', 'EMRO', '82', '5330', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23018, '2020-08-07', 'DJ', 'Djibouti', 'EMRO', '4', '5334', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23019, '2020-08-08', 'DJ', 'Djibouti', 'EMRO', '4', '5338', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23020, '2020-08-09', 'DJ', 'Djibouti', 'EMRO', '0', '5338', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23021, '2020-08-10', 'DJ', 'Djibouti', 'EMRO', '6', '5344', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23022, '2020-08-11', 'DJ', 'Djibouti', 'EMRO', '3', '5347', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23023, '2020-08-12', 'DJ', 'Djibouti', 'EMRO', '1', '5348', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23024, '2020-08-13', 'DJ', 'Djibouti', 'EMRO', '10', '5358', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23025, '2020-08-14', 'DJ', 'Djibouti', 'EMRO', '0', '5358', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23026, '2020-08-15', 'DJ', 'Djibouti', 'EMRO', '9', '5367', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23027, '2020-08-16', 'DJ', 'Djibouti', 'EMRO', '0', '5367', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23028, '2020-08-17', 'DJ', 'Djibouti', 'EMRO', '2', '5369', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23029, '2020-08-18', 'DJ', 'Djibouti', 'EMRO', '3', '5372', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23030, '2020-08-19', 'DJ', 'Djibouti', 'EMRO', '2', '5374', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23031, '2020-08-20', 'DJ', 'Djibouti', 'EMRO', '0', '5374', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23032, '2020-08-21', 'DJ', 'Djibouti', 'EMRO', '0', '5374', '0', '59');
INSERT INTO public.who_global_data_import VALUES (23033, '2020-08-22', 'DJ', 'Djibouti', 'EMRO', '8', '5382', '1', '60');
INSERT INTO public.who_global_data_import VALUES (23034, '2020-08-23', 'DJ', 'Djibouti', 'EMRO', '0', '5382', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23035, '2020-08-24', 'DJ', 'Djibouti', 'EMRO', '0', '5382', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23036, '2020-08-25', 'DJ', 'Djibouti', 'EMRO', '1', '5383', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23037, '2020-08-26', 'DJ', 'Djibouti', 'EMRO', '0', '5383', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23038, '2020-08-27', 'DJ', 'Djibouti', 'EMRO', '0', '5383', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23039, '2020-08-28', 'DJ', 'Djibouti', 'EMRO', '0', '5383', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23040, '2020-08-29', 'DJ', 'Djibouti', 'EMRO', '0', '5383', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23041, '2020-08-30', 'DJ', 'Djibouti', 'EMRO', '2', '5385', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23042, '2020-08-31', 'DJ', 'Djibouti', 'EMRO', '0', '5385', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23043, '2020-09-01', 'DJ', 'Djibouti', 'EMRO', '2', '5387', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23044, '2020-09-02', 'DJ', 'Djibouti', 'EMRO', '0', '5387', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23045, '2020-09-03', 'DJ', 'Djibouti', 'EMRO', '0', '5387', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23046, '2020-09-04', 'DJ', 'Djibouti', 'EMRO', '0', '5387', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23047, '2020-09-05', 'DJ', 'Djibouti', 'EMRO', '0', '5387', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23048, '2020-09-06', 'DJ', 'Djibouti', 'EMRO', '0', '5387', '0', '60');
INSERT INTO public.who_global_data_import VALUES (23049, '2020-09-07', 'DJ', 'Djibouti', 'EMRO', '1', '5388', '1', '61');
INSERT INTO public.who_global_data_import VALUES (23050, '2020-09-08', 'DJ', 'Djibouti', 'EMRO', '0', '5388', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23051, '2020-09-09', 'DJ', 'Djibouti', 'EMRO', '0', '5388', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23052, '2020-09-10', 'DJ', 'Djibouti', 'EMRO', '3', '5391', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23053, '2020-09-11', 'DJ', 'Djibouti', 'EMRO', '3', '5394', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23054, '2020-09-12', 'DJ', 'Djibouti', 'EMRO', '0', '5394', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23055, '2020-09-13', 'DJ', 'Djibouti', 'EMRO', '0', '5394', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23056, '2020-09-14', 'DJ', 'Djibouti', 'EMRO', '1', '5395', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23057, '2020-09-15', 'DJ', 'Djibouti', 'EMRO', '1', '5396', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23058, '2020-09-16', 'DJ', 'Djibouti', 'EMRO', '0', '5396', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23059, '2020-09-17', 'DJ', 'Djibouti', 'EMRO', '3', '5399', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23060, '2020-09-18', 'DJ', 'Djibouti', 'EMRO', '2', '5401', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23061, '2020-09-19', 'DJ', 'Djibouti', 'EMRO', '2', '5403', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23062, '2020-09-20', 'DJ', 'Djibouti', 'EMRO', '0', '5403', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23063, '2020-09-21', 'DJ', 'Djibouti', 'EMRO', '0', '5403', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23064, '2020-09-22', 'DJ', 'Djibouti', 'EMRO', '1', '5404', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23065, '2020-09-23', 'DJ', 'Djibouti', 'EMRO', '3', '5407', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23066, '2020-09-24', 'DJ', 'Djibouti', 'EMRO', '0', '5407', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23067, '2020-09-25', 'DJ', 'Djibouti', 'EMRO', '0', '5407', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23068, '2020-09-26', 'DJ', 'Djibouti', 'EMRO', '2', '5409', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23069, '2020-09-27', 'DJ', 'Djibouti', 'EMRO', '0', '5409', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23070, '2020-09-28', 'DJ', 'Djibouti', 'EMRO', '0', '5409', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23071, '2020-09-29', 'DJ', 'Djibouti', 'EMRO', '1', '5410', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23072, '2020-09-30', 'DJ', 'Djibouti', 'EMRO', '6', '5416', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23073, '2020-10-01', 'DJ', 'Djibouti', 'EMRO', '0', '5416', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23074, '2020-10-02', 'DJ', 'Djibouti', 'EMRO', '1', '5417', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23075, '2020-10-03', 'DJ', 'Djibouti', 'EMRO', '0', '5417', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23076, '2020-10-04', 'DJ', 'Djibouti', 'EMRO', '1', '5418', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23077, '2020-10-05', 'DJ', 'Djibouti', 'EMRO', '1', '5419', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23078, '2020-10-06', 'DJ', 'Djibouti', 'EMRO', '2', '5421', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23079, '2020-10-07', 'DJ', 'Djibouti', 'EMRO', '2', '5423', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23080, '2020-10-08', 'DJ', 'Djibouti', 'EMRO', '0', '5423', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23081, '2020-10-09', 'DJ', 'Djibouti', 'EMRO', '0', '5423', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23082, '2020-10-10', 'DJ', 'Djibouti', 'EMRO', '0', '5423', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23083, '2020-10-11', 'DJ', 'Djibouti', 'EMRO', '0', '5423', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23084, '2020-10-12', 'DJ', 'Djibouti', 'EMRO', '1', '5424', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23085, '2020-10-13', 'DJ', 'Djibouti', 'EMRO', '2', '5426', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23086, '2020-10-14', 'DJ', 'Djibouti', 'EMRO', '2', '5428', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23087, '2020-10-15', 'DJ', 'Djibouti', 'EMRO', '12', '5440', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23088, '2020-10-16', 'DJ', 'Djibouti', 'EMRO', '3', '5443', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23089, '2020-10-17', 'DJ', 'Djibouti', 'EMRO', '6', '5449', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23090, '2020-10-18', 'DJ', 'Djibouti', 'EMRO', '3', '5452', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23091, '2020-10-19', 'DJ', 'Djibouti', 'EMRO', '7', '5459', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23092, '2020-10-20', 'DJ', 'Djibouti', 'EMRO', '10', '5469', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23093, '2020-10-21', 'DJ', 'Djibouti', 'EMRO', '30', '5499', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23094, '2020-10-22', 'DJ', 'Djibouti', 'EMRO', '13', '5512', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23095, '2020-10-23', 'DJ', 'Djibouti', 'EMRO', '10', '5522', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23096, '2020-10-24', 'DJ', 'Djibouti', 'EMRO', '6', '5528', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23097, '2020-10-25', 'DJ', 'Djibouti', 'EMRO', '2', '5530', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23098, '2020-10-26', 'DJ', 'Djibouti', 'EMRO', '6', '5536', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23099, '2020-10-27', 'DJ', 'Djibouti', 'EMRO', '5', '5541', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23100, '2020-10-28', 'DJ', 'Djibouti', 'EMRO', '0', '5541', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23101, '2020-10-29', 'DJ', 'Djibouti', 'EMRO', '14', '5555', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23102, '2020-10-30', 'DJ', 'Djibouti', 'EMRO', '3', '5558', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23103, '2020-10-31', 'DJ', 'Djibouti', 'EMRO', '1', '5559', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23104, '2020-11-01', 'DJ', 'Djibouti', 'EMRO', '2', '5561', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23105, '2020-11-02', 'DJ', 'Djibouti', 'EMRO', '2', '5563', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23106, '2020-11-03', 'DJ', 'Djibouti', 'EMRO', '10', '5573', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23107, '2020-11-04', 'DJ', 'Djibouti', 'EMRO', '2', '5575', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23108, '2020-11-05', 'DJ', 'Djibouti', 'EMRO', '5', '5580', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23109, '2020-11-06', 'DJ', 'Djibouti', 'EMRO', '19', '5599', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23110, '2020-11-07', 'DJ', 'Djibouti', 'EMRO', '5', '5604', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23111, '2020-11-08', 'DJ', 'Djibouti', 'EMRO', '1', '5605', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23112, '2020-11-09', 'DJ', 'Djibouti', 'EMRO', '3', '5608', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23113, '2020-11-10', 'DJ', 'Djibouti', 'EMRO', '19', '5627', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23114, '2020-11-11', 'DJ', 'Djibouti', 'EMRO', '6', '5633', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23115, '2020-11-12', 'DJ', 'Djibouti', 'EMRO', '2', '5635', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23116, '2020-11-13', 'DJ', 'Djibouti', 'EMRO', '6', '5641', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23117, '2020-11-14', 'DJ', 'Djibouti', 'EMRO', '3', '5644', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23118, '2020-11-15', 'DJ', 'Djibouti', 'EMRO', '1', '5645', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23119, '2020-11-16', 'DJ', 'Djibouti', 'EMRO', '4', '5649', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23120, '2020-11-17', 'DJ', 'Djibouti', 'EMRO', '6', '5655', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23121, '2020-11-18', 'DJ', 'Djibouti', 'EMRO', '1', '5656', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23122, '2020-11-19', 'DJ', 'Djibouti', 'EMRO', '2', '5658', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23123, '2020-11-20', 'DJ', 'Djibouti', 'EMRO', '0', '5658', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23124, '2020-11-21', 'DJ', 'Djibouti', 'EMRO', '2', '5660', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23125, '2020-11-22', 'DJ', 'Djibouti', 'EMRO', '1', '5661', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23126, '2020-11-23', 'DJ', 'Djibouti', 'EMRO', '7', '5668', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23127, '2020-11-24', 'DJ', 'Djibouti', 'EMRO', '0', '5668', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23128, '2020-11-25', 'DJ', 'Djibouti', 'EMRO', '1', '5669', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23129, '2020-11-26', 'DJ', 'Djibouti', 'EMRO', '1', '5670', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23130, '2020-11-27', 'DJ', 'Djibouti', 'EMRO', '6', '5676', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23131, '2020-11-28', 'DJ', 'Djibouti', 'EMRO', '0', '5676', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23132, '2020-11-29', 'DJ', 'Djibouti', 'EMRO', '0', '5676', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23133, '2020-11-30', 'DJ', 'Djibouti', 'EMRO', '1', '5677', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23134, '2020-12-01', 'DJ', 'Djibouti', 'EMRO', '2', '5679', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23135, '2020-12-02', 'DJ', 'Djibouti', 'EMRO', '1', '5680', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23136, '2020-12-03', 'DJ', 'Djibouti', 'EMRO', '2', '5682', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23137, '2020-12-04', 'DJ', 'Djibouti', 'EMRO', '7', '5689', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23138, '2020-12-05', 'DJ', 'Djibouti', 'EMRO', '1', '5690', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23139, '2020-12-06', 'DJ', 'Djibouti', 'EMRO', '2', '5692', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23140, '2020-12-07', 'DJ', 'Djibouti', 'EMRO', '9', '5701', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23141, '2020-12-08', 'DJ', 'Djibouti', 'EMRO', '7', '5708', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23142, '2020-12-09', 'DJ', 'Djibouti', 'EMRO', '6', '5714', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23143, '2020-12-10', 'DJ', 'Djibouti', 'EMRO', '3', '5717', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23144, '2020-12-11', 'DJ', 'Djibouti', 'EMRO', '0', '5717', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23145, '2020-12-12', 'DJ', 'Djibouti', 'EMRO', '4', '5721', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23146, '2020-12-13', 'DJ', 'Djibouti', 'EMRO', '4', '5725', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23147, '2020-12-14', 'DJ', 'Djibouti', 'EMRO', '4', '5729', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23148, '2020-12-15', 'DJ', 'Djibouti', 'EMRO', '4', '5733', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23149, '2020-12-16', 'DJ', 'Djibouti', 'EMRO', '16', '5749', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23150, '2020-12-17', 'DJ', 'Djibouti', 'EMRO', '10', '5759', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23151, '2020-12-18', 'DJ', 'Djibouti', 'EMRO', '11', '5770', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23152, '2020-12-19', 'DJ', 'Djibouti', 'EMRO', '10', '5780', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23153, '2020-12-20', 'DJ', 'Djibouti', 'EMRO', '1', '5781', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23154, '2020-12-21', 'DJ', 'Djibouti', 'EMRO', '0', '5781', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23155, '2020-12-22', 'DJ', 'Djibouti', 'EMRO', '2', '5783', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23156, '2020-12-23', 'DJ', 'Djibouti', 'EMRO', '3', '5786', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23157, '2020-12-24', 'DJ', 'Djibouti', 'EMRO', '3', '5789', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23158, '2020-12-25', 'DJ', 'Djibouti', 'EMRO', '11', '5800', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23159, '2020-12-26', 'DJ', 'Djibouti', 'EMRO', '4', '5804', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23160, '2020-12-27', 'DJ', 'Djibouti', 'EMRO', '1', '5805', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23161, '2020-12-28', 'DJ', 'Djibouti', 'EMRO', '8', '5813', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23162, '2020-12-29', 'DJ', 'Djibouti', 'EMRO', '0', '5813', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23163, '2020-12-30', 'DJ', 'Djibouti', 'EMRO', '0', '5813', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23164, '2020-12-31', 'DJ', 'Djibouti', 'EMRO', '11', '5824', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23165, '2021-01-01', 'DJ', 'Djibouti', 'EMRO', '7', '5831', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23166, '2021-01-02', 'DJ', 'Djibouti', 'EMRO', '9', '5840', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23167, '2021-01-03', 'DJ', 'Djibouti', 'EMRO', '1', '5841', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23168, '2021-01-04', 'DJ', 'Djibouti', 'EMRO', '1', '5842', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23169, '2021-01-05', 'DJ', 'Djibouti', 'EMRO', '4', '5846', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23170, '2021-01-06', 'DJ', 'Djibouti', 'EMRO', '8', '5854', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23171, '2021-01-07', 'DJ', 'Djibouti', 'EMRO', '1', '5855', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23172, '2021-01-08', 'DJ', 'Djibouti', 'EMRO', '2', '5857', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23173, '2021-01-09', 'DJ', 'Djibouti', 'EMRO', '8', '5865', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23174, '2021-01-10', 'DJ', 'Djibouti', 'EMRO', '1', '5866', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23175, '2021-01-11', 'DJ', 'Djibouti', 'EMRO', '5', '5871', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23176, '2021-01-12', 'DJ', 'Djibouti', 'EMRO', '6', '5877', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23177, '2021-01-13', 'DJ', 'Djibouti', 'EMRO', '2', '5879', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23178, '2021-01-14', 'DJ', 'Djibouti', 'EMRO', '12', '5891', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23179, '2021-01-15', 'DJ', 'Djibouti', 'EMRO', '9', '5900', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23180, '2021-01-16', 'DJ', 'Djibouti', 'EMRO', '3', '5903', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23181, '2021-01-17', 'DJ', 'Djibouti', 'EMRO', '0', '5903', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23182, '2021-01-18', 'DJ', 'Djibouti', 'EMRO', '2', '5905', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23183, '2021-01-19', 'DJ', 'Djibouti', 'EMRO', '1', '5906', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23184, '2021-01-20', 'DJ', 'Djibouti', 'EMRO', '4', '5910', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23185, '2021-01-21', 'DJ', 'Djibouti', 'EMRO', '3', '5913', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23186, '2021-01-22', 'DJ', 'Djibouti', 'EMRO', '3', '5916', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23187, '2021-01-23', 'DJ', 'Djibouti', 'EMRO', '1', '5917', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23188, '2021-01-24', 'DJ', 'Djibouti', 'EMRO', '1', '5918', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23189, '2021-01-25', 'DJ', 'Djibouti', 'EMRO', '1', '5919', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23190, '2021-01-26', 'DJ', 'Djibouti', 'EMRO', '1', '5920', '0', '61');
INSERT INTO public.who_global_data_import VALUES (23191, '2021-01-27', 'DJ', 'Djibouti', 'EMRO', '3', '5923', '1', '62');
INSERT INTO public.who_global_data_import VALUES (23192, '2021-01-28', 'DJ', 'Djibouti', 'EMRO', '3', '5926', '0', '62');
INSERT INTO public.who_global_data_import VALUES (23193, '2021-01-29', 'DJ', 'Djibouti', 'EMRO', '3', '5929', '0', '62');
INSERT INTO public.who_global_data_import VALUES (23194, '2021-01-30', 'DJ', 'Djibouti', 'EMRO', '1', '5930', '0', '62');
INSERT INTO public.who_global_data_import VALUES (23195, '2021-01-31', 'DJ', 'Djibouti', 'EMRO', '1', '5931', '0', '62');
INSERT INTO public.who_global_data_import VALUES (23196, '2021-02-01', 'DJ', 'Djibouti', 'EMRO', '1', '5932', '1', '63');
INSERT INTO public.who_global_data_import VALUES (23197, '2021-02-02', 'DJ', 'Djibouti', 'EMRO', '1', '5933', '0', '63');
INSERT INTO public.who_global_data_import VALUES (23198, '2021-02-03', 'DJ', 'Djibouti', 'EMRO', '2', '5935', '0', '63');
INSERT INTO public.who_global_data_import VALUES (23199, '2021-02-04', 'DJ', 'Djibouti', 'EMRO', '1', '5936', '0', '63');
INSERT INTO public.who_global_data_import VALUES (23200, '2021-02-05', 'DJ', 'Djibouti', 'EMRO', '0', '5936', '0', '63');
INSERT INTO public.who_global_data_import VALUES (23201, '2020-01-03', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23202, '2020-01-04', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23203, '2020-01-05', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23204, '2020-01-06', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23205, '2020-01-07', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23206, '2020-01-08', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23207, '2020-01-09', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23208, '2020-01-10', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23209, '2020-01-11', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23210, '2020-01-12', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23211, '2020-01-13', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23212, '2020-01-14', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23213, '2020-01-15', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23214, '2020-01-16', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23215, '2020-01-17', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23216, '2020-01-18', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23217, '2020-01-19', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23218, '2020-01-20', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23219, '2020-01-21', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23220, '2020-01-22', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23221, '2020-01-23', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23222, '2020-01-24', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23223, '2020-01-25', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23224, '2020-01-26', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23225, '2020-01-27', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23226, '2020-01-28', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23227, '2020-01-29', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23228, '2020-01-30', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23229, '2020-01-31', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23230, '2020-02-01', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23231, '2020-02-02', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23232, '2020-02-03', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23233, '2020-02-04', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23234, '2020-02-05', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23235, '2020-02-06', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23236, '2020-02-07', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23237, '2020-02-08', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23238, '2020-02-09', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23239, '2020-02-10', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23240, '2020-02-11', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23241, '2020-02-12', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23242, '2020-02-13', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23243, '2020-02-14', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23244, '2020-02-15', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23245, '2020-02-16', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23246, '2020-02-17', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23247, '2020-02-18', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23248, '2020-02-19', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23249, '2020-02-20', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23250, '2020-02-21', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23251, '2020-02-22', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23252, '2020-02-23', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23253, '2020-02-24', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23254, '2020-02-25', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23255, '2020-02-26', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23256, '2020-02-27', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23257, '2020-02-28', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23258, '2020-02-29', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23259, '2020-03-01', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23260, '2020-03-02', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23261, '2020-03-03', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23262, '2020-03-04', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23263, '2020-03-05', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23264, '2020-03-06', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23265, '2020-03-07', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23266, '2020-03-08', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23267, '2020-03-09', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23268, '2020-03-10', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23269, '2020-03-11', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23270, '2020-03-12', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23271, '2020-03-13', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23272, '2020-03-14', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23273, '2020-03-15', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23274, '2020-03-16', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23275, '2020-03-17', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23276, '2020-03-18', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23277, '2020-03-19', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23278, '2020-03-20', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23279, '2020-03-21', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23280, '2020-03-22', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23281, '2020-03-23', 'DM', 'Dominica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23282, '2020-03-24', 'DM', 'Dominica', 'AMRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23283, '2020-03-25', 'DM', 'Dominica', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23284, '2020-03-26', 'DM', 'Dominica', 'AMRO', '9', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23285, '2020-03-27', 'DM', 'Dominica', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23286, '2020-03-28', 'DM', 'Dominica', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23287, '2020-03-29', 'DM', 'Dominica', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23288, '2020-03-30', 'DM', 'Dominica', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23289, '2020-03-31', 'DM', 'Dominica', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23290, '2020-04-01', 'DM', 'Dominica', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23291, '2020-04-02', 'DM', 'Dominica', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23292, '2020-04-03', 'DM', 'Dominica', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23293, '2020-04-04', 'DM', 'Dominica', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23294, '2020-04-05', 'DM', 'Dominica', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23295, '2020-04-06', 'DM', 'Dominica', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23296, '2020-04-07', 'DM', 'Dominica', 'AMRO', '3', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23297, '2020-04-08', 'DM', 'Dominica', 'AMRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23298, '2020-04-09', 'DM', 'Dominica', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23299, '2020-04-10', 'DM', 'Dominica', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23300, '2020-04-11', 'DM', 'Dominica', 'AMRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23301, '2020-04-12', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23302, '2020-04-13', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23303, '2020-04-14', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23304, '2020-04-15', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23305, '2020-04-16', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23306, '2020-04-17', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23307, '2020-04-18', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23308, '2020-04-19', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23309, '2020-04-20', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23310, '2020-04-21', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23311, '2020-04-22', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23312, '2020-04-23', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23313, '2020-04-24', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23314, '2020-04-25', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23315, '2020-04-26', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23316, '2020-04-27', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23317, '2020-04-28', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23318, '2020-04-29', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23319, '2020-04-30', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23320, '2020-05-01', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23321, '2020-05-02', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23322, '2020-05-03', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23323, '2020-05-04', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23324, '2020-05-05', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23325, '2020-05-06', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23326, '2020-05-07', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23327, '2020-05-08', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23328, '2020-05-09', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23329, '2020-05-10', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23330, '2020-05-11', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23331, '2020-05-12', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23332, '2020-05-13', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23333, '2020-05-14', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23334, '2020-05-15', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23335, '2020-05-16', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23336, '2020-05-17', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23337, '2020-05-18', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23338, '2020-05-19', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23339, '2020-05-20', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23340, '2020-05-21', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23341, '2020-05-22', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23342, '2020-05-23', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23343, '2020-05-24', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23344, '2020-05-25', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23345, '2020-05-26', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23346, '2020-05-27', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23347, '2020-05-28', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23348, '2020-05-29', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23349, '2020-05-30', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23350, '2020-05-31', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23351, '2020-06-01', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23352, '2020-06-02', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23353, '2020-06-03', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23354, '2020-06-04', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23355, '2020-06-05', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23356, '2020-06-06', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23357, '2020-06-07', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23358, '2020-06-08', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23359, '2020-06-09', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23360, '2020-06-10', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23361, '2020-06-11', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23362, '2020-06-12', 'DM', 'Dominica', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23363, '2020-06-13', 'DM', 'Dominica', 'AMRO', '2', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23364, '2020-06-14', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23365, '2020-06-15', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23366, '2020-06-16', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23367, '2020-06-17', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23368, '2020-06-18', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23369, '2020-06-19', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23370, '2020-06-20', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23371, '2020-06-21', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23372, '2020-06-22', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23373, '2020-06-23', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23374, '2020-06-24', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23375, '2020-06-25', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23376, '2020-06-26', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23377, '2020-06-27', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23378, '2020-06-28', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23379, '2020-06-29', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23380, '2020-06-30', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23381, '2020-07-01', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23382, '2020-07-02', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23383, '2020-07-03', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23384, '2020-07-04', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23385, '2020-07-05', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23386, '2020-07-06', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23387, '2020-07-07', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23388, '2020-07-08', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23389, '2020-07-09', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23390, '2020-07-10', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23391, '2020-07-11', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23392, '2020-07-12', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23393, '2020-07-13', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23394, '2020-07-14', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23395, '2020-07-15', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23396, '2020-07-16', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23397, '2020-07-17', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23398, '2020-07-18', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23399, '2020-07-19', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23400, '2020-07-20', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23401, '2020-07-21', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23402, '2020-07-22', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23403, '2020-07-23', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23404, '2020-07-24', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23405, '2020-07-25', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23406, '2020-07-26', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23407, '2020-07-27', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23408, '2020-07-28', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23409, '2020-07-29', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23410, '2020-07-30', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23411, '2020-07-31', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23412, '2020-08-01', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23413, '2020-08-02', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23414, '2020-08-03', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23415, '2020-08-04', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23416, '2020-08-05', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23417, '2020-08-06', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23418, '2020-08-07', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23419, '2020-08-08', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23420, '2020-08-09', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23421, '2020-08-10', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23422, '2020-08-11', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23423, '2020-08-12', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23424, '2020-08-13', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23425, '2020-08-14', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23426, '2020-08-15', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23427, '2020-08-16', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23428, '2020-08-17', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23429, '2020-08-18', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23430, '2020-08-19', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23431, '2020-08-20', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23432, '2020-08-21', 'DM', 'Dominica', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23433, '2020-08-22', 'DM', 'Dominica', 'AMRO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23434, '2020-08-23', 'DM', 'Dominica', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23435, '2020-08-24', 'DM', 'Dominica', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23436, '2020-08-25', 'DM', 'Dominica', 'AMRO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23437, '2020-08-26', 'DM', 'Dominica', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23438, '2020-08-27', 'DM', 'Dominica', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23439, '2020-08-28', 'DM', 'Dominica', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23440, '2020-08-29', 'DM', 'Dominica', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23441, '2020-08-30', 'DM', 'Dominica', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23442, '2020-08-31', 'DM', 'Dominica', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23443, '2020-09-01', 'DM', 'Dominica', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23444, '2020-09-02', 'DM', 'Dominica', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23445, '2020-09-03', 'DM', 'Dominica', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23446, '2020-09-04', 'DM', 'Dominica', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23447, '2020-09-05', 'DM', 'Dominica', 'AMRO', '2', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23448, '2020-09-06', 'DM', 'Dominica', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23449, '2020-09-07', 'DM', 'Dominica', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23450, '2020-09-08', 'DM', 'Dominica', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23451, '2020-09-09', 'DM', 'Dominica', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23452, '2020-09-10', 'DM', 'Dominica', 'AMRO', '2', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23453, '2020-09-11', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23454, '2020-09-12', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23455, '2020-09-13', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23456, '2020-09-14', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23457, '2020-09-15', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23458, '2020-09-16', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23459, '2020-09-17', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23460, '2020-09-18', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23461, '2020-09-19', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23462, '2020-09-20', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23463, '2020-09-21', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23464, '2020-09-22', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23465, '2020-09-23', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23466, '2020-09-24', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23467, '2020-09-25', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23468, '2020-09-26', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23469, '2020-09-27', 'DM', 'Dominica', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23470, '2020-09-28', 'DM', 'Dominica', 'AMRO', '6', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23471, '2020-09-29', 'DM', 'Dominica', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23472, '2020-09-30', 'DM', 'Dominica', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23473, '2020-10-01', 'DM', 'Dominica', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23474, '2020-10-02', 'DM', 'Dominica', 'AMRO', '1', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23475, '2020-10-03', 'DM', 'Dominica', 'AMRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23476, '2020-10-04', 'DM', 'Dominica', 'AMRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23477, '2020-10-05', 'DM', 'Dominica', 'AMRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23478, '2020-10-06', 'DM', 'Dominica', 'AMRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23479, '2020-10-07', 'DM', 'Dominica', 'AMRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23480, '2020-10-08', 'DM', 'Dominica', 'AMRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23481, '2020-10-09', 'DM', 'Dominica', 'AMRO', '1', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23482, '2020-10-10', 'DM', 'Dominica', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23483, '2020-10-11', 'DM', 'Dominica', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23484, '2020-10-12', 'DM', 'Dominica', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23485, '2020-10-13', 'DM', 'Dominica', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23486, '2020-10-14', 'DM', 'Dominica', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23487, '2020-10-15', 'DM', 'Dominica', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23488, '2020-10-16', 'DM', 'Dominica', 'AMRO', '1', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23489, '2020-10-17', 'DM', 'Dominica', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23490, '2020-10-18', 'DM', 'Dominica', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23491, '2020-10-19', 'DM', 'Dominica', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23492, '2020-10-20', 'DM', 'Dominica', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23493, '2020-10-21', 'DM', 'Dominica', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23494, '2020-10-22', 'DM', 'Dominica', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23495, '2020-10-23', 'DM', 'Dominica', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23496, '2020-10-24', 'DM', 'Dominica', 'AMRO', '4', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23497, '2020-10-25', 'DM', 'Dominica', 'AMRO', '1', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23498, '2020-10-26', 'DM', 'Dominica', 'AMRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23499, '2020-10-27', 'DM', 'Dominica', 'AMRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23500, '2020-10-28', 'DM', 'Dominica', 'AMRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23501, '2020-10-29', 'DM', 'Dominica', 'AMRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23502, '2020-10-30', 'DM', 'Dominica', 'AMRO', '4', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23503, '2020-10-31', 'DM', 'Dominica', 'AMRO', '0', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23504, '2020-11-01', 'DM', 'Dominica', 'AMRO', '8', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23505, '2020-11-02', 'DM', 'Dominica', 'AMRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23506, '2020-11-03', 'DM', 'Dominica', 'AMRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23507, '2020-11-04', 'DM', 'Dominica', 'AMRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23508, '2020-11-05', 'DM', 'Dominica', 'AMRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23509, '2020-11-06', 'DM', 'Dominica', 'AMRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23510, '2020-11-07', 'DM', 'Dominica', 'AMRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23511, '2020-11-08', 'DM', 'Dominica', 'AMRO', '13', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23512, '2020-11-09', 'DM', 'Dominica', 'AMRO', '0', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23513, '2020-11-10', 'DM', 'Dominica', 'AMRO', '0', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23514, '2020-11-11', 'DM', 'Dominica', 'AMRO', '0', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23515, '2020-11-12', 'DM', 'Dominica', 'AMRO', '0', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23516, '2020-11-13', 'DM', 'Dominica', 'AMRO', '5', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23517, '2020-11-14', 'DM', 'Dominica', 'AMRO', '0', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23518, '2020-11-15', 'DM', 'Dominica', 'AMRO', '0', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23519, '2020-11-16', 'DM', 'Dominica', 'AMRO', '0', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23520, '2020-11-17', 'DM', 'Dominica', 'AMRO', '0', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23521, '2020-11-18', 'DM', 'Dominica', 'AMRO', '0', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23522, '2020-11-19', 'DM', 'Dominica', 'AMRO', '0', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23523, '2020-11-20', 'DM', 'Dominica', 'AMRO', '4', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23524, '2020-11-21', 'DM', 'Dominica', 'AMRO', '0', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23525, '2020-11-22', 'DM', 'Dominica', 'AMRO', '0', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23526, '2020-11-23', 'DM', 'Dominica', 'AMRO', '5', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23527, '2020-11-24', 'DM', 'Dominica', 'AMRO', '0', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23528, '2020-11-25', 'DM', 'Dominica', 'AMRO', '0', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23529, '2020-11-26', 'DM', 'Dominica', 'AMRO', '0', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23530, '2020-11-27', 'DM', 'Dominica', 'AMRO', '3', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23531, '2020-11-28', 'DM', 'Dominica', 'AMRO', '5', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23532, '2020-11-29', 'DM', 'Dominica', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23533, '2020-11-30', 'DM', 'Dominica', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23534, '2020-12-01', 'DM', 'Dominica', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23535, '2020-12-02', 'DM', 'Dominica', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23536, '2020-12-03', 'DM', 'Dominica', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23537, '2020-12-04', 'DM', 'Dominica', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23538, '2020-12-05', 'DM', 'Dominica', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23539, '2020-12-06', 'DM', 'Dominica', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23540, '2020-12-07', 'DM', 'Dominica', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23541, '2020-12-08', 'DM', 'Dominica', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23542, '2020-12-09', 'DM', 'Dominica', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23543, '2020-12-10', 'DM', 'Dominica', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23544, '2020-12-11', 'DM', 'Dominica', 'AMRO', '2', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23545, '2020-12-12', 'DM', 'Dominica', 'AMRO', '0', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23546, '2020-12-13', 'DM', 'Dominica', 'AMRO', '0', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23547, '2020-12-14', 'DM', 'Dominica', 'AMRO', '0', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23548, '2020-12-15', 'DM', 'Dominica', 'AMRO', '1', '88', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23549, '2020-12-16', 'DM', 'Dominica', 'AMRO', '0', '88', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23550, '2020-12-17', 'DM', 'Dominica', 'AMRO', '0', '88', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23551, '2020-12-18', 'DM', 'Dominica', 'AMRO', '0', '88', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23552, '2020-12-19', 'DM', 'Dominica', 'AMRO', '0', '88', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23553, '2020-12-20', 'DM', 'Dominica', 'AMRO', '0', '88', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23554, '2020-12-21', 'DM', 'Dominica', 'AMRO', '4', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23555, '2020-12-22', 'DM', 'Dominica', 'AMRO', '0', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23556, '2020-12-23', 'DM', 'Dominica', 'AMRO', '0', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23557, '2020-12-24', 'DM', 'Dominica', 'AMRO', '0', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23558, '2020-12-25', 'DM', 'Dominica', 'AMRO', '4', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23559, '2020-12-26', 'DM', 'Dominica', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23560, '2020-12-27', 'DM', 'Dominica', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23561, '2020-12-28', 'DM', 'Dominica', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23562, '2020-12-29', 'DM', 'Dominica', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23563, '2020-12-30', 'DM', 'Dominica', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23564, '2020-12-31', 'DM', 'Dominica', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23565, '2021-01-01', 'DM', 'Dominica', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23566, '2021-01-02', 'DM', 'Dominica', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23567, '2021-01-03', 'DM', 'Dominica', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23568, '2021-01-04', 'DM', 'Dominica', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23569, '2021-01-05', 'DM', 'Dominica', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23570, '2021-01-06', 'DM', 'Dominica', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23571, '2021-01-07', 'DM', 'Dominica', 'AMRO', '9', '105', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23572, '2021-01-08', 'DM', 'Dominica', 'AMRO', '0', '105', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23573, '2021-01-09', 'DM', 'Dominica', 'AMRO', '1', '106', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23574, '2021-01-10', 'DM', 'Dominica', 'AMRO', '0', '106', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23575, '2021-01-11', 'DM', 'Dominica', 'AMRO', '0', '106', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23576, '2021-01-12', 'DM', 'Dominica', 'AMRO', '0', '106', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23577, '2021-01-13', 'DM', 'Dominica', 'AMRO', '3', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23578, '2021-01-14', 'DM', 'Dominica', 'AMRO', '0', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23579, '2021-01-15', 'DM', 'Dominica', 'AMRO', '0', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23580, '2021-01-16', 'DM', 'Dominica', 'AMRO', '0', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23581, '2021-01-17', 'DM', 'Dominica', 'AMRO', '1', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23582, '2021-01-18', 'DM', 'Dominica', 'AMRO', '0', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23583, '2021-01-19', 'DM', 'Dominica', 'AMRO', '0', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23584, '2021-01-20', 'DM', 'Dominica', 'AMRO', '0', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23585, '2021-01-21', 'DM', 'Dominica', 'AMRO', '3', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23586, '2021-01-22', 'DM', 'Dominica', 'AMRO', '0', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23587, '2021-01-23', 'DM', 'Dominica', 'AMRO', '0', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23588, '2021-01-24', 'DM', 'Dominica', 'AMRO', '0', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23589, '2021-01-25', 'DM', 'Dominica', 'AMRO', '0', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23590, '2021-01-26', 'DM', 'Dominica', 'AMRO', '0', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23591, '2021-01-27', 'DM', 'Dominica', 'AMRO', '0', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23592, '2021-01-28', 'DM', 'Dominica', 'AMRO', '0', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23593, '2021-01-29', 'DM', 'Dominica', 'AMRO', '4', '117', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23594, '2021-01-30', 'DM', 'Dominica', 'AMRO', '0', '117', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23595, '2021-01-31', 'DM', 'Dominica', 'AMRO', '0', '117', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23596, '2021-02-01', 'DM', 'Dominica', 'AMRO', '0', '117', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23597, '2021-02-02', 'DM', 'Dominica', 'AMRO', '0', '117', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23598, '2021-02-03', 'DM', 'Dominica', 'AMRO', '4', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23599, '2021-02-04', 'DM', 'Dominica', 'AMRO', '0', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23600, '2021-02-05', 'DM', 'Dominica', 'AMRO', '0', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23601, '2020-01-03', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23602, '2020-01-04', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23603, '2020-01-05', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23604, '2020-01-06', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23605, '2020-01-07', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23606, '2020-01-08', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23607, '2020-01-09', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23608, '2020-01-10', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23609, '2020-01-11', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23610, '2020-01-12', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23611, '2020-01-13', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23612, '2020-01-14', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23613, '2020-01-15', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23614, '2020-01-16', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23615, '2020-01-17', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23616, '2020-01-18', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23617, '2020-01-19', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23618, '2020-01-20', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23619, '2020-01-21', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23620, '2020-01-22', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23621, '2020-01-23', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23622, '2020-01-24', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23623, '2020-01-25', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23624, '2020-01-26', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23625, '2020-01-27', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23626, '2020-01-28', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23627, '2020-01-29', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23628, '2020-01-30', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23629, '2020-01-31', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23630, '2020-02-01', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23631, '2020-02-02', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23632, '2020-02-03', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23633, '2020-02-04', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23634, '2020-02-05', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23635, '2020-02-06', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23636, '2020-02-07', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23637, '2020-02-08', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23638, '2020-02-09', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23639, '2020-02-10', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23640, '2020-02-11', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23641, '2020-02-12', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23642, '2020-02-13', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23643, '2020-02-14', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23644, '2020-02-15', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23645, '2020-02-16', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23646, '2020-02-17', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23647, '2020-02-18', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23648, '2020-02-19', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23649, '2020-02-20', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23650, '2020-02-21', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23651, '2020-02-22', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23652, '2020-02-23', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23653, '2020-02-24', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23654, '2020-02-25', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23655, '2020-02-26', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23656, '2020-02-27', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23657, '2020-02-28', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23658, '2020-02-29', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23659, '2020-03-01', 'DO', 'Dominican Republic', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23660, '2020-03-02', 'DO', 'Dominican Republic', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23661, '2020-03-03', 'DO', 'Dominican Republic', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23662, '2020-03-04', 'DO', 'Dominican Republic', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23663, '2020-03-05', 'DO', 'Dominican Republic', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23664, '2020-03-06', 'DO', 'Dominican Republic', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23665, '2020-03-07', 'DO', 'Dominican Republic', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23666, '2020-03-08', 'DO', 'Dominican Republic', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23667, '2020-03-09', 'DO', 'Dominican Republic', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23668, '2020-03-10', 'DO', 'Dominican Republic', 'AMRO', '4', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23669, '2020-03-11', 'DO', 'Dominican Republic', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23670, '2020-03-12', 'DO', 'Dominican Republic', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23671, '2020-03-13', 'DO', 'Dominican Republic', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23672, '2020-03-14', 'DO', 'Dominican Republic', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23673, '2020-03-15', 'DO', 'Dominican Republic', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23674, '2020-03-16', 'DO', 'Dominican Republic', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23675, '2020-03-17', 'DO', 'Dominican Republic', 'AMRO', '16', '25', '1', '1');
INSERT INTO public.who_global_data_import VALUES (23676, '2020-03-18', 'DO', 'Dominican Republic', 'AMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (23677, '2020-03-19', 'DO', 'Dominican Republic', 'AMRO', '9', '34', '1', '2');
INSERT INTO public.who_global_data_import VALUES (23678, '2020-03-20', 'DO', 'Dominican Republic', 'AMRO', '38', '72', '0', '2');
INSERT INTO public.who_global_data_import VALUES (23679, '2020-03-21', 'DO', 'Dominican Republic', 'AMRO', '0', '72', '0', '2');
INSERT INTO public.who_global_data_import VALUES (23680, '2020-03-22', 'DO', 'Dominican Republic', 'AMRO', '0', '72', '0', '2');
INSERT INTO public.who_global_data_import VALUES (23681, '2020-03-23', 'DO', 'Dominican Republic', 'AMRO', '0', '72', '0', '2');
INSERT INTO public.who_global_data_import VALUES (23682, '2020-03-24', 'DO', 'Dominican Republic', 'AMRO', '240', '312', '4', '6');
INSERT INTO public.who_global_data_import VALUES (23683, '2020-03-25', 'DO', 'Dominican Republic', 'AMRO', '0', '312', '0', '6');
INSERT INTO public.who_global_data_import VALUES (23684, '2020-03-26', 'DO', 'Dominican Republic', 'AMRO', '176', '488', '4', '10');
INSERT INTO public.who_global_data_import VALUES (23685, '2020-03-27', 'DO', 'Dominican Republic', 'AMRO', '0', '488', '0', '10');
INSERT INTO public.who_global_data_import VALUES (23686, '2020-03-28', 'DO', 'Dominican Republic', 'AMRO', '93', '581', '10', '20');
INSERT INTO public.who_global_data_import VALUES (23687, '2020-03-29', 'DO', 'Dominican Republic', 'AMRO', '0', '581', '0', '20');
INSERT INTO public.who_global_data_import VALUES (23688, '2020-03-30', 'DO', 'Dominican Republic', 'AMRO', '0', '581', '0', '20');
INSERT INTO public.who_global_data_import VALUES (23689, '2020-03-31', 'DO', 'Dominican Republic', 'AMRO', '320', '901', '22', '42');
INSERT INTO public.who_global_data_import VALUES (23690, '2020-04-01', 'DO', 'Dominican Republic', 'AMRO', '208', '1109', '9', '51');
INSERT INTO public.who_global_data_import VALUES (23691, '2020-04-02', 'DO', 'Dominican Republic', 'AMRO', '175', '1284', '6', '57');
INSERT INTO public.who_global_data_import VALUES (23692, '2020-04-03', 'DO', 'Dominican Republic', 'AMRO', '96', '1380', '3', '60');
INSERT INTO public.who_global_data_import VALUES (23693, '2020-04-04', 'DO', 'Dominican Republic', 'AMRO', '108', '1488', '8', '68');
INSERT INTO public.who_global_data_import VALUES (23694, '2020-04-05', 'DO', 'Dominican Republic', 'AMRO', '0', '1488', '0', '68');
INSERT INTO public.who_global_data_import VALUES (23695, '2020-04-06', 'DO', 'Dominican Republic', 'AMRO', '0', '1488', '0', '68');
INSERT INTO public.who_global_data_import VALUES (23696, '2020-04-07', 'DO', 'Dominican Republic', 'AMRO', '340', '1828', '18', '86');
INSERT INTO public.who_global_data_import VALUES (23697, '2020-04-08', 'DO', 'Dominican Republic', 'AMRO', '128', '1956', '12', '98');
INSERT INTO public.who_global_data_import VALUES (23698, '2020-04-09', 'DO', 'Dominican Republic', 'AMRO', '0', '1956', '0', '98');
INSERT INTO public.who_global_data_import VALUES (23699, '2020-04-10', 'DO', 'Dominican Republic', 'AMRO', '393', '2349', '20', '118');
INSERT INTO public.who_global_data_import VALUES (23700, '2020-04-11', 'DO', 'Dominican Republic', 'AMRO', '0', '2349', '0', '118');
INSERT INTO public.who_global_data_import VALUES (23701, '2020-04-12', 'DO', 'Dominican Republic', 'AMRO', '271', '2620', '8', '126');
INSERT INTO public.who_global_data_import VALUES (23702, '2020-04-13', 'DO', 'Dominican Republic', 'AMRO', '347', '2967', '47', '173');
INSERT INTO public.who_global_data_import VALUES (23703, '2020-04-14', 'DO', 'Dominican Republic', 'AMRO', '200', '3167', '4', '177');
INSERT INTO public.who_global_data_import VALUES (23704, '2020-04-15', 'DO', 'Dominican Republic', 'AMRO', '119', '3286', '6', '183');
INSERT INTO public.who_global_data_import VALUES (23705, '2020-04-16', 'DO', 'Dominican Republic', 'AMRO', '328', '3614', '6', '189');
INSERT INTO public.who_global_data_import VALUES (23706, '2020-04-17', 'DO', 'Dominican Republic', 'AMRO', '141', '3755', '7', '196');
INSERT INTO public.who_global_data_import VALUES (23707, '2020-04-18', 'DO', 'Dominican Republic', 'AMRO', '371', '4126', '4', '200');
INSERT INTO public.who_global_data_import VALUES (23708, '2020-04-19', 'DO', 'Dominican Republic', 'AMRO', '209', '4335', '17', '217');
INSERT INTO public.who_global_data_import VALUES (23709, '2020-04-20', 'DO', 'Dominican Republic', 'AMRO', '345', '4680', '9', '226');
INSERT INTO public.who_global_data_import VALUES (23710, '2020-04-21', 'DO', 'Dominican Republic', 'AMRO', '284', '4964', '9', '235');
INSERT INTO public.who_global_data_import VALUES (23711, '2020-04-22', 'DO', 'Dominican Republic', 'AMRO', '80', '5044', '10', '245');
INSERT INTO public.who_global_data_import VALUES (23712, '2020-04-23', 'DO', 'Dominican Republic', 'AMRO', '256', '5300', '15', '260');
INSERT INTO public.who_global_data_import VALUES (23713, '2020-04-24', 'DO', 'Dominican Republic', 'AMRO', '243', '5543', '5', '265');
INSERT INTO public.who_global_data_import VALUES (23714, '2020-04-25', 'DO', 'Dominican Republic', 'AMRO', '206', '5749', '2', '267');
INSERT INTO public.who_global_data_import VALUES (23715, '2020-04-26', 'DO', 'Dominican Republic', 'AMRO', '177', '5926', '6', '273');
INSERT INTO public.who_global_data_import VALUES (23716, '2020-04-27', 'DO', 'Dominican Republic', 'AMRO', '209', '6135', '5', '278');
INSERT INTO public.who_global_data_import VALUES (23717, '2020-04-28', 'DO', 'Dominican Republic', 'AMRO', '158', '6293', '4', '282');
INSERT INTO public.who_global_data_import VALUES (23718, '2020-04-29', 'DO', 'Dominican Republic', 'AMRO', '123', '6416', '4', '286');
INSERT INTO public.who_global_data_import VALUES (23719, '2020-04-30', 'DO', 'Dominican Republic', 'AMRO', '236', '6652', '7', '293');
INSERT INTO public.who_global_data_import VALUES (23720, '2020-05-01', 'DO', 'Dominican Republic', 'AMRO', '320', '6972', '8', '301');
INSERT INTO public.who_global_data_import VALUES (23721, '2020-05-02', 'DO', 'Dominican Republic', 'AMRO', '316', '7288', '12', '313');
INSERT INTO public.who_global_data_import VALUES (23722, '2020-05-03', 'DO', 'Dominican Republic', 'AMRO', '290', '7578', '13', '326');
INSERT INTO public.who_global_data_import VALUES (23723, '2020-05-04', 'DO', 'Dominican Republic', 'AMRO', '376', '7954', '7', '333');
INSERT INTO public.who_global_data_import VALUES (23724, '2020-05-05', 'DO', 'Dominican Republic', 'AMRO', '281', '8235', '13', '346');
INSERT INTO public.who_global_data_import VALUES (23725, '2020-05-06', 'DO', 'Dominican Republic', 'AMRO', '245', '8480', '8', '354');
INSERT INTO public.who_global_data_import VALUES (23726, '2020-05-07', 'DO', 'Dominican Republic', 'AMRO', '327', '8807', '8', '362');
INSERT INTO public.who_global_data_import VALUES (23727, '2020-05-08', 'DO', 'Dominican Republic', 'AMRO', '288', '9095', '11', '373');
INSERT INTO public.who_global_data_import VALUES (23728, '2020-05-09', 'DO', 'Dominican Republic', 'AMRO', '281', '9376', '7', '380');
INSERT INTO public.who_global_data_import VALUES (23729, '2020-05-10', 'DO', 'Dominican Republic', 'AMRO', '506', '9882', '5', '385');
INSERT INTO public.who_global_data_import VALUES (23730, '2020-05-11', 'DO', 'Dominican Republic', 'AMRO', '465', '10347', '3', '388');
INSERT INTO public.who_global_data_import VALUES (23731, '2020-05-12', 'DO', 'Dominican Republic', 'AMRO', '287', '10634', '5', '393');
INSERT INTO public.who_global_data_import VALUES (23732, '2020-05-13', 'DO', 'Dominican Republic', 'AMRO', '266', '10900', '9', '402');
INSERT INTO public.who_global_data_import VALUES (23733, '2020-05-14', 'DO', 'Dominican Republic', 'AMRO', '296', '11196', '7', '409');
INSERT INTO public.who_global_data_import VALUES (23734, '2020-05-15', 'DO', 'Dominican Republic', 'AMRO', '124', '11320', '13', '422');
INSERT INTO public.who_global_data_import VALUES (23735, '2020-05-16', 'DO', 'Dominican Republic', 'AMRO', '419', '11739', '2', '424');
INSERT INTO public.who_global_data_import VALUES (23736, '2020-05-17', 'DO', 'Dominican Republic', 'AMRO', '371', '12110', '4', '428');
INSERT INTO public.who_global_data_import VALUES (23737, '2020-05-18', 'DO', 'Dominican Republic', 'AMRO', '204', '12314', '0', '428');
INSERT INTO public.who_global_data_import VALUES (23738, '2020-05-19', 'DO', 'Dominican Republic', 'AMRO', '411', '12725', '6', '434');
INSERT INTO public.who_global_data_import VALUES (23739, '2020-05-20', 'DO', 'Dominican Republic', 'AMRO', '498', '13223', '7', '441');
INSERT INTO public.who_global_data_import VALUES (23740, '2020-05-21', 'DO', 'Dominican Republic', 'AMRO', '254', '13477', '5', '446');
INSERT INTO public.who_global_data_import VALUES (23741, '2020-05-22', 'DO', 'Dominican Republic', 'AMRO', '180', '13657', '2', '448');
INSERT INTO public.who_global_data_import VALUES (23742, '2020-05-23', 'DO', 'Dominican Republic', 'AMRO', '332', '13989', '8', '456');
INSERT INTO public.who_global_data_import VALUES (23743, '2020-05-24', 'DO', 'Dominican Republic', 'AMRO', '433', '14422', '2', '458');
INSERT INTO public.who_global_data_import VALUES (23744, '2020-05-25', 'DO', 'Dominican Republic', 'AMRO', '379', '14801', '0', '458');
INSERT INTO public.who_global_data_import VALUES (23745, '2020-05-26', 'DO', 'Dominican Republic', 'AMRO', '272', '15073', '2', '460');
INSERT INTO public.who_global_data_import VALUES (23746, '2020-05-27', 'DO', 'Dominican Republic', 'AMRO', '191', '15264', '8', '468');
INSERT INTO public.who_global_data_import VALUES (23747, '2020-05-28', 'DO', 'Dominican Republic', 'AMRO', '459', '15723', '6', '474');
INSERT INTO public.who_global_data_import VALUES (23748, '2020-05-29', 'DO', 'Dominican Republic', 'AMRO', '345', '16068', '11', '485');
INSERT INTO public.who_global_data_import VALUES (23749, '2020-05-30', 'DO', 'Dominican Republic', 'AMRO', '463', '16531', '3', '488');
INSERT INTO public.who_global_data_import VALUES (23750, '2020-05-31', 'DO', 'Dominican Republic', 'AMRO', '377', '16908', '10', '498');
INSERT INTO public.who_global_data_import VALUES (23751, '2020-06-01', 'DO', 'Dominican Republic', 'AMRO', '377', '17285', '4', '502');
INSERT INTO public.who_global_data_import VALUES (23752, '2020-06-02', 'DO', 'Dominican Republic', 'AMRO', '287', '17572', '0', '502');
INSERT INTO public.who_global_data_import VALUES (23753, '2020-06-03', 'DO', 'Dominican Republic', 'AMRO', '180', '17752', '13', '515');
INSERT INTO public.who_global_data_import VALUES (23754, '2020-06-04', 'DO', 'Dominican Republic', 'AMRO', '288', '18040', '1', '516');
INSERT INTO public.who_global_data_import VALUES (23755, '2020-06-05', 'DO', 'Dominican Republic', 'AMRO', '279', '18319', '4', '520');
INSERT INTO public.who_global_data_import VALUES (23756, '2020-06-06', 'DO', 'Dominican Republic', 'AMRO', '389', '18708', '5', '525');
INSERT INTO public.who_global_data_import VALUES (23757, '2020-06-07', 'DO', 'Dominican Republic', 'AMRO', '487', '19195', '11', '536');
INSERT INTO public.who_global_data_import VALUES (23758, '2020-06-08', 'DO', 'Dominican Republic', 'AMRO', '405', '19600', '2', '538');
INSERT INTO public.who_global_data_import VALUES (23759, '2020-06-09', 'DO', 'Dominican Republic', 'AMRO', '526', '20126', '1', '539');
INSERT INTO public.who_global_data_import VALUES (23760, '2020-06-10', 'DO', 'Dominican Republic', 'AMRO', '289', '20415', '5', '544');
INSERT INTO public.who_global_data_import VALUES (23761, '2020-06-11', 'DO', 'Dominican Republic', 'AMRO', '393', '20808', '6', '550');
INSERT INTO public.who_global_data_import VALUES (23762, '2020-06-12', 'DO', 'Dominican Republic', 'AMRO', '629', '21437', '11', '561');
INSERT INTO public.who_global_data_import VALUES (23763, '2020-06-13', 'DO', 'Dominican Republic', 'AMRO', '571', '22008', '7', '568');
INSERT INTO public.who_global_data_import VALUES (23764, '2020-06-14', 'DO', 'Dominican Republic', 'AMRO', '564', '22572', '9', '577');
INSERT INTO public.who_global_data_import VALUES (23765, '2020-06-15', 'DO', 'Dominican Republic', 'AMRO', '390', '22962', '15', '592');
INSERT INTO public.who_global_data_import VALUES (23766, '2020-06-16', 'DO', 'Dominican Republic', 'AMRO', '309', '23271', '13', '605');
INSERT INTO public.who_global_data_import VALUES (23767, '2020-06-17', 'DO', 'Dominican Republic', 'AMRO', '415', '23686', '10', '615');
INSERT INTO public.who_global_data_import VALUES (23768, '2020-06-18', 'DO', 'Dominican Republic', 'AMRO', '419', '24105', '18', '633');
INSERT INTO public.who_global_data_import VALUES (23769, '2020-06-19', 'DO', 'Dominican Republic', 'AMRO', '540', '24645', '2', '635');
INSERT INTO public.who_global_data_import VALUES (23770, '2020-06-20', 'DO', 'Dominican Republic', 'AMRO', '423', '25068', '12', '647');
INSERT INTO public.who_global_data_import VALUES (23771, '2020-06-21', 'DO', 'Dominican Republic', 'AMRO', '710', '25778', '8', '655');
INSERT INTO public.who_global_data_import VALUES (23772, '2020-06-22', 'DO', 'Dominican Republic', 'AMRO', '899', '26677', '7', '662');
INSERT INTO public.who_global_data_import VALUES (23773, '2020-06-23', 'DO', 'Dominican Republic', 'AMRO', '693', '27370', '7', '669');
INSERT INTO public.who_global_data_import VALUES (24052, '2020-02-23', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23774, '2020-06-24', 'DO', 'Dominican Republic', 'AMRO', '566', '27936', '6', '675');
INSERT INTO public.who_global_data_import VALUES (23775, '2020-06-25', 'DO', 'Dominican Republic', 'AMRO', '695', '28631', '16', '691');
INSERT INTO public.who_global_data_import VALUES (23776, '2020-06-26', 'DO', 'Dominican Republic', 'AMRO', '510', '29141', '7', '698');
INSERT INTO public.who_global_data_import VALUES (23777, '2020-06-27', 'DO', 'Dominican Republic', 'AMRO', '623', '29764', '14', '712');
INSERT INTO public.who_global_data_import VALUES (23778, '2020-06-28', 'DO', 'Dominican Republic', 'AMRO', '855', '30619', '6', '718');
INSERT INTO public.who_global_data_import VALUES (23779, '2020-06-29', 'DO', 'Dominican Republic', 'AMRO', '754', '31373', '8', '726');
INSERT INTO public.who_global_data_import VALUES (23780, '2020-06-30', 'DO', 'Dominican Republic', 'AMRO', '443', '31816', '7', '733');
INSERT INTO public.who_global_data_import VALUES (23781, '2020-07-01', 'DO', 'Dominican Republic', 'AMRO', '752', '32568', '14', '747');
INSERT INTO public.who_global_data_import VALUES (23782, '2020-07-02', 'DO', 'Dominican Republic', 'AMRO', '819', '33387', '7', '754');
INSERT INTO public.who_global_data_import VALUES (23783, '2020-07-03', 'DO', 'Dominican Republic', 'AMRO', '810', '34197', '11', '765');
INSERT INTO public.who_global_data_import VALUES (23784, '2020-07-04', 'DO', 'Dominican Republic', 'AMRO', '951', '35148', '10', '775');
INSERT INTO public.who_global_data_import VALUES (23785, '2020-07-05', 'DO', 'Dominican Republic', 'AMRO', '1036', '36184', '11', '786');
INSERT INTO public.who_global_data_import VALUES (23786, '2020-07-06', 'DO', 'Dominican Republic', 'AMRO', '1241', '37425', '8', '794');
INSERT INTO public.who_global_data_import VALUES (23787, '2020-07-07', 'DO', 'Dominican Republic', 'AMRO', '703', '38128', '10', '804');
INSERT INTO public.who_global_data_import VALUES (23788, '2020-07-08', 'DO', 'Dominican Republic', 'AMRO', '302', '38430', '17', '821');
INSERT INTO public.who_global_data_import VALUES (23789, '2020-07-09', 'DO', 'Dominican Republic', 'AMRO', '1158', '39588', '8', '829');
INSERT INTO public.who_global_data_import VALUES (23790, '2020-07-10', 'DO', 'Dominican Republic', 'AMRO', '1202', '40790', '13', '842');
INSERT INTO public.who_global_data_import VALUES (23791, '2020-07-11', 'DO', 'Dominican Republic', 'AMRO', '1125', '41915', '22', '864');
INSERT INTO public.who_global_data_import VALUES (23792, '2020-07-12', 'DO', 'Dominican Republic', 'AMRO', '1199', '43114', '16', '880');
INSERT INTO public.who_global_data_import VALUES (23793, '2020-07-13', 'DO', 'Dominican Republic', 'AMRO', '1418', '44532', '17', '897');
INSERT INTO public.who_global_data_import VALUES (23794, '2020-07-14', 'DO', 'Dominican Republic', 'AMRO', '974', '45506', '6', '903');
INSERT INTO public.who_global_data_import VALUES (23795, '2020-07-15', 'DO', 'Dominican Republic', 'AMRO', '799', '46305', '7', '910');
INSERT INTO public.who_global_data_import VALUES (23796, '2020-07-16', 'DO', 'Dominican Republic', 'AMRO', '1366', '47671', '19', '929');
INSERT INTO public.who_global_data_import VALUES (23797, '2020-07-17', 'DO', 'Dominican Republic', 'AMRO', '1072', '48743', '12', '941');
INSERT INTO public.who_global_data_import VALUES (23798, '2020-07-18', 'DO', 'Dominican Republic', 'AMRO', '1370', '50113', '1', '942');
INSERT INTO public.who_global_data_import VALUES (23799, '2020-07-19', 'DO', 'Dominican Republic', 'AMRO', '1406', '51519', '29', '971');
INSERT INTO public.who_global_data_import VALUES (23800, '2020-07-20', 'DO', 'Dominican Republic', 'AMRO', '1336', '52855', '10', '981');
INSERT INTO public.who_global_data_import VALUES (23801, '2020-07-21', 'DO', 'Dominican Republic', 'AMRO', '1101', '53956', '12', '993');
INSERT INTO public.who_global_data_import VALUES (23802, '2020-07-22', 'DO', 'Dominican Republic', 'AMRO', '841', '54797', '6', '999');
INSERT INTO public.who_global_data_import VALUES (23803, '2020-07-23', 'DO', 'Dominican Republic', 'AMRO', '1246', '56043', '6', '1005');
INSERT INTO public.who_global_data_import VALUES (23804, '2020-07-24', 'DO', 'Dominican Republic', 'AMRO', '1572', '57615', '1', '1006');
INSERT INTO public.who_global_data_import VALUES (23805, '2020-07-25', 'DO', 'Dominican Republic', 'AMRO', '1462', '59077', '30', '1036');
INSERT INTO public.who_global_data_import VALUES (23806, '2020-07-26', 'DO', 'Dominican Republic', 'AMRO', '1819', '60896', '19', '1055');
INSERT INTO public.who_global_data_import VALUES (23807, '2020-07-27', 'DO', 'Dominican Republic', 'AMRO', '2012', '62908', '8', '1063');
INSERT INTO public.who_global_data_import VALUES (23808, '2020-07-28', 'DO', 'Dominican Republic', 'AMRO', '1248', '64156', '20', '1083');
INSERT INTO public.who_global_data_import VALUES (23809, '2020-07-29', 'DO', 'Dominican Republic', 'AMRO', '534', '64690', '18', '1101');
INSERT INTO public.who_global_data_import VALUES (23810, '2020-07-30', 'DO', 'Dominican Republic', 'AMRO', '1492', '66182', '22', '1123');
INSERT INTO public.who_global_data_import VALUES (23811, '2020-07-31', 'DO', 'Dominican Republic', 'AMRO', '1733', '67915', '23', '1146');
INSERT INTO public.who_global_data_import VALUES (23812, '2020-08-01', 'DO', 'Dominican Republic', 'AMRO', '1734', '69649', '14', '1160');
INSERT INTO public.who_global_data_import VALUES (23813, '2020-08-02', 'DO', 'Dominican Republic', 'AMRO', '1766', '71415', '10', '1170');
INSERT INTO public.who_global_data_import VALUES (23814, '2020-08-03', 'DO', 'Dominican Republic', 'AMRO', '828', '72243', '8', '1178');
INSERT INTO public.who_global_data_import VALUES (23815, '2020-08-04', 'DO', 'Dominican Republic', 'AMRO', '874', '73117', '5', '1183');
INSERT INTO public.who_global_data_import VALUES (23816, '2020-08-05', 'DO', 'Dominican Republic', 'AMRO', '1178', '74295', '30', '1213');
INSERT INTO public.who_global_data_import VALUES (23817, '2020-08-06', 'DO', 'Dominican Republic', 'AMRO', '1365', '75660', '9', '1222');
INSERT INTO public.who_global_data_import VALUES (23818, '2020-08-07', 'DO', 'Dominican Republic', 'AMRO', '876', '76536', '24', '1246');
INSERT INTO public.who_global_data_import VALUES (23819, '2020-08-08', 'DO', 'Dominican Republic', 'AMRO', '1173', '77709', '13', '1259');
INSERT INTO public.who_global_data_import VALUES (23820, '2020-08-09', 'DO', 'Dominican Republic', 'AMRO', '1069', '78778', '30', '1289');
INSERT INTO public.who_global_data_import VALUES (23821, '2020-08-10', 'DO', 'Dominican Republic', 'AMRO', '954', '79732', '20', '1309');
INSERT INTO public.who_global_data_import VALUES (23822, '2020-08-11', 'DO', 'Dominican Republic', 'AMRO', '767', '80499', '19', '1328');
INSERT INTO public.who_global_data_import VALUES (23823, '2020-08-12', 'DO', 'Dominican Republic', 'AMRO', '595', '81094', '18', '1346');
INSERT INTO public.who_global_data_import VALUES (23824, '2020-08-13', 'DO', 'Dominican Republic', 'AMRO', '1130', '82224', '25', '1371');
INSERT INTO public.who_global_data_import VALUES (23825, '2020-08-14', 'DO', 'Dominican Republic', 'AMRO', '910', '83134', '22', '1393');
INSERT INTO public.who_global_data_import VALUES (23826, '2020-08-15', 'DO', 'Dominican Republic', 'AMRO', '1354', '84488', '16', '1409');
INSERT INTO public.who_global_data_import VALUES (23827, '2020-08-16', 'DO', 'Dominican Republic', 'AMRO', '1057', '85545', '29', '1438');
INSERT INTO public.who_global_data_import VALUES (23828, '2020-08-17', 'DO', 'Dominican Republic', 'AMRO', '764', '86309', '15', '1453');
INSERT INTO public.who_global_data_import VALUES (23829, '2020-08-18', 'DO', 'Dominican Republic', 'AMRO', '428', '86737', '28', '1481');
INSERT INTO public.who_global_data_import VALUES (23830, '2020-08-19', 'DO', 'Dominican Republic', 'AMRO', '386', '87123', '8', '1489');
INSERT INTO public.who_global_data_import VALUES (23831, '2020-08-20', 'DO', 'Dominican Republic', 'AMRO', '1004', '88127', '12', '1501');
INSERT INTO public.who_global_data_import VALUES (23832, '2020-08-21', 'DO', 'Dominican Republic', 'AMRO', '0', '88127', '0', '1501');
INSERT INTO public.who_global_data_import VALUES (23833, '2020-08-22', 'DO', 'Dominican Republic', 'AMRO', '1740', '89867', '32', '1533');
INSERT INTO public.who_global_data_import VALUES (23834, '2020-08-23', 'DO', 'Dominican Republic', 'AMRO', '694', '90561', '21', '1554');
INSERT INTO public.who_global_data_import VALUES (23835, '2020-08-24', 'DO', 'Dominican Republic', 'AMRO', '600', '91161', '13', '1567');
INSERT INTO public.who_global_data_import VALUES (23836, '2020-08-25', 'DO', 'Dominican Republic', 'AMRO', '447', '91608', '6', '1573');
INSERT INTO public.who_global_data_import VALUES (23837, '2020-08-26', 'DO', 'Dominican Republic', 'AMRO', '609', '92217', '12', '1585');
INSERT INTO public.who_global_data_import VALUES (23838, '2020-08-27', 'DO', 'Dominican Republic', 'AMRO', '340', '92557', '28', '1613');
INSERT INTO public.who_global_data_import VALUES (23839, '2020-08-28', 'DO', 'Dominican Republic', 'AMRO', '407', '92964', '17', '1630');
INSERT INTO public.who_global_data_import VALUES (23840, '2020-08-29', 'DO', 'Dominican Republic', 'AMRO', '426', '93390', '18', '1648');
INSERT INTO public.who_global_data_import VALUES (23841, '2020-08-30', 'DO', 'Dominican Republic', 'AMRO', '336', '93726', '25', '1673');
INSERT INTO public.who_global_data_import VALUES (23842, '2020-08-31', 'DO', 'Dominican Republic', 'AMRO', '509', '94235', '8', '1681');
INSERT INTO public.who_global_data_import VALUES (23843, '2020-09-01', 'DO', 'Dominican Republic', 'AMRO', '480', '94715', '29', '1710');
INSERT INTO public.who_global_data_import VALUES (23844, '2020-09-02', 'DO', 'Dominican Republic', 'AMRO', '264', '94979', '28', '1738');
INSERT INTO public.who_global_data_import VALUES (23845, '2020-09-03', 'DO', 'Dominican Republic', 'AMRO', '648', '95627', '27', '1765');
INSERT INTO public.who_global_data_import VALUES (23846, '2020-09-04', 'DO', 'Dominican Republic', 'AMRO', '1002', '96629', '36', '1801');
INSERT INTO public.who_global_data_import VALUES (23847, '2020-09-05', 'DO', 'Dominican Republic', 'AMRO', '0', '96629', '0', '1801');
INSERT INTO public.who_global_data_import VALUES (23848, '2020-09-06', 'DO', 'Dominican Republic', 'AMRO', '2147', '98776', '39', '1840');
INSERT INTO public.who_global_data_import VALUES (23849, '2020-09-07', 'DO', 'Dominican Republic', 'AMRO', '557', '99333', '5', '1845');
INSERT INTO public.who_global_data_import VALUES (23850, '2020-09-08', 'DO', 'Dominican Republic', 'AMRO', '565', '99898', '19', '1864');
INSERT INTO public.who_global_data_import VALUES (23851, '2020-09-09', 'DO', 'Dominican Republic', 'AMRO', '233', '100131', '25', '1889');
INSERT INTO public.who_global_data_import VALUES (23852, '2020-09-10', 'DO', 'Dominican Republic', 'AMRO', '806', '100937', '25', '1914');
INSERT INTO public.who_global_data_import VALUES (23853, '2020-09-11', 'DO', 'Dominican Republic', 'AMRO', '779', '101716', '12', '1926');
INSERT INTO public.who_global_data_import VALUES (23854, '2020-09-12', 'DO', 'Dominican Republic', 'AMRO', '516', '102232', '15', '1941');
INSERT INTO public.who_global_data_import VALUES (23855, '2020-09-13', 'DO', 'Dominican Republic', 'AMRO', '0', '102232', '0', '1941');
INSERT INTO public.who_global_data_import VALUES (23856, '2020-09-14', 'DO', 'Dominican Republic', 'AMRO', '1428', '103660', '27', '1968');
INSERT INTO public.who_global_data_import VALUES (23857, '2020-09-15', 'DO', 'Dominican Republic', 'AMRO', '450', '104110', '16', '1984');
INSERT INTO public.who_global_data_import VALUES (23858, '2020-09-16', 'DO', 'Dominican Republic', 'AMRO', '693', '104803', '14', '1998');
INSERT INTO public.who_global_data_import VALUES (23859, '2020-09-17', 'DO', 'Dominican Republic', 'AMRO', '718', '105521', '11', '2009');
INSERT INTO public.who_global_data_import VALUES (23860, '2020-09-18', 'DO', 'Dominican Republic', 'AMRO', '615', '106136', '13', '2022');
INSERT INTO public.who_global_data_import VALUES (23861, '2020-09-19', 'DO', 'Dominican Republic', 'AMRO', '596', '106732', '12', '2034');
INSERT INTO public.who_global_data_import VALUES (24053, '2020-02-24', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23862, '2020-09-20', 'DO', 'Dominican Republic', 'AMRO', '968', '107700', '10', '2044');
INSERT INTO public.who_global_data_import VALUES (23863, '2020-09-21', 'DO', 'Dominican Republic', 'AMRO', '589', '108289', '3', '2047');
INSERT INTO public.who_global_data_import VALUES (23864, '2020-09-22', 'DO', 'Dominican Republic', 'AMRO', '494', '108783', '7', '2054');
INSERT INTO public.who_global_data_import VALUES (23865, '2020-09-23', 'DO', 'Dominican Republic', 'AMRO', '486', '109269', '10', '2064');
INSERT INTO public.who_global_data_import VALUES (23866, '2020-09-24', 'DO', 'Dominican Republic', 'AMRO', '468', '109737', '10', '2074');
INSERT INTO public.who_global_data_import VALUES (23867, '2020-09-25', 'DO', 'Dominican Republic', 'AMRO', '385', '110122', '2', '2076');
INSERT INTO public.who_global_data_import VALUES (23868, '2020-09-26', 'DO', 'Dominican Republic', 'AMRO', '475', '110597', '11', '2087');
INSERT INTO public.who_global_data_import VALUES (23869, '2020-09-27', 'DO', 'Dominican Republic', 'AMRO', '360', '110957', '6', '2093');
INSERT INTO public.who_global_data_import VALUES (23870, '2020-09-28', 'DO', 'Dominican Republic', 'AMRO', '429', '111386', '2', '2095');
INSERT INTO public.who_global_data_import VALUES (23871, '2020-09-29', 'DO', 'Dominican Republic', 'AMRO', '280', '111666', '3', '2098');
INSERT INTO public.who_global_data_import VALUES (23872, '2020-09-30', 'DO', 'Dominican Republic', 'AMRO', '234', '111900', '3', '2101');
INSERT INTO public.who_global_data_import VALUES (23873, '2020-10-01', 'DO', 'Dominican Republic', 'AMRO', '309', '112209', '4', '2105');
INSERT INTO public.who_global_data_import VALUES (23874, '2020-10-02', 'DO', 'Dominican Republic', 'AMRO', '519', '112728', '3', '2108');
INSERT INTO public.who_global_data_import VALUES (23875, '2020-10-03', 'DO', 'Dominican Republic', 'AMRO', '622', '113350', '9', '2117');
INSERT INTO public.who_global_data_import VALUES (23876, '2020-10-04', 'DO', 'Dominican Republic', 'AMRO', '576', '113926', '11', '2128');
INSERT INTO public.who_global_data_import VALUES (23877, '2020-10-05', 'DO', 'Dominican Republic', 'AMRO', '554', '114480', '6', '2134');
INSERT INTO public.who_global_data_import VALUES (23878, '2020-10-06', 'DO', 'Dominican Republic', 'AMRO', '574', '115054', '10', '2144');
INSERT INTO public.who_global_data_import VALUES (23879, '2020-10-07', 'DO', 'Dominican Republic', 'AMRO', '317', '115371', '5', '2149');
INSERT INTO public.who_global_data_import VALUES (23880, '2020-10-08', 'DO', 'Dominican Republic', 'AMRO', '777', '116148', '10', '2159');
INSERT INTO public.who_global_data_import VALUES (23881, '2020-10-09', 'DO', 'Dominican Republic', 'AMRO', '724', '116872', '4', '2163');
INSERT INTO public.who_global_data_import VALUES (23882, '2020-10-10', 'DO', 'Dominican Republic', 'AMRO', '585', '117457', '2', '2165');
INSERT INTO public.who_global_data_import VALUES (23883, '2020-10-11', 'DO', 'Dominican Republic', 'AMRO', '557', '118014', '2', '2167');
INSERT INTO public.who_global_data_import VALUES (23884, '2020-10-12', 'DO', 'Dominican Republic', 'AMRO', '463', '118477', '6', '2173');
INSERT INTO public.who_global_data_import VALUES (23885, '2020-10-13', 'DO', 'Dominican Republic', 'AMRO', '366', '118843', '6', '2179');
INSERT INTO public.who_global_data_import VALUES (23886, '2020-10-14', 'DO', 'Dominican Republic', 'AMRO', '165', '119008', '4', '2183');
INSERT INTO public.who_global_data_import VALUES (23887, '2020-10-15', 'DO', 'Dominican Republic', 'AMRO', '654', '119662', '3', '2186');
INSERT INTO public.who_global_data_import VALUES (23888, '2020-10-16', 'DO', 'Dominican Republic', 'AMRO', '404', '120066', '3', '2189');
INSERT INTO public.who_global_data_import VALUES (23889, '2020-10-17', 'DO', 'Dominican Republic', 'AMRO', '384', '120450', '3', '2192');
INSERT INTO public.who_global_data_import VALUES (23890, '2020-10-18', 'DO', 'Dominican Republic', 'AMRO', '475', '120925', '3', '2195');
INSERT INTO public.who_global_data_import VALUES (23891, '2020-10-19', 'DO', 'Dominican Republic', 'AMRO', '422', '121347', '4', '2199');
INSERT INTO public.who_global_data_import VALUES (23892, '2020-10-20', 'DO', 'Dominican Republic', 'AMRO', '320', '121667', '4', '2203');
INSERT INTO public.who_global_data_import VALUES (23893, '2020-10-21', 'DO', 'Dominican Republic', 'AMRO', '306', '121973', '1', '2204');
INSERT INTO public.who_global_data_import VALUES (23894, '2020-10-22', 'DO', 'Dominican Republic', 'AMRO', '425', '122398', '2', '2206');
INSERT INTO public.who_global_data_import VALUES (23895, '2020-10-23', 'DO', 'Dominican Republic', 'AMRO', '475', '122873', '6', '2212');
INSERT INTO public.who_global_data_import VALUES (23896, '2020-10-24', 'DO', 'Dominican Republic', 'AMRO', '0', '122873', '0', '2212');
INSERT INTO public.who_global_data_import VALUES (23897, '2020-10-25', 'DO', 'Dominican Republic', 'AMRO', '1145', '124018', '8', '2220');
INSERT INTO public.who_global_data_import VALUES (23898, '2020-10-26', 'DO', 'Dominican Republic', 'AMRO', '509', '124527', '3', '2223');
INSERT INTO public.who_global_data_import VALUES (23899, '2020-10-27', 'DO', 'Dominican Republic', 'AMRO', '316', '124843', '2', '2225');
INSERT INTO public.who_global_data_import VALUES (23900, '2020-10-28', 'DO', 'Dominican Republic', 'AMRO', '165', '125008', '1', '2226');
INSERT INTO public.who_global_data_import VALUES (23901, '2020-10-29', 'DO', 'Dominican Republic', 'AMRO', '562', '125570', '6', '2232');
INSERT INTO public.who_global_data_import VALUES (23902, '2020-10-30', 'DO', 'Dominican Republic', 'AMRO', '343', '125913', '2', '2234');
INSERT INTO public.who_global_data_import VALUES (23903, '2020-10-31', 'DO', 'Dominican Republic', 'AMRO', '419', '126332', '2', '2236');
INSERT INTO public.who_global_data_import VALUES (23904, '2020-11-01', 'DO', 'Dominican Republic', 'AMRO', '686', '127018', '9', '2245');
INSERT INTO public.who_global_data_import VALUES (23905, '2020-11-02', 'DO', 'Dominican Republic', 'AMRO', '314', '127332', '4', '2249');
INSERT INTO public.who_global_data_import VALUES (23906, '2020-11-03', 'DO', 'Dominican Republic', 'AMRO', '259', '127591', '1', '2250');
INSERT INTO public.who_global_data_import VALUES (23907, '2020-11-04', 'DO', 'Dominican Republic', 'AMRO', '257', '127848', '2', '2252');
INSERT INTO public.who_global_data_import VALUES (23908, '2020-11-05', 'DO', 'Dominican Republic', 'AMRO', '430', '128278', '5', '2257');
INSERT INTO public.who_global_data_import VALUES (23909, '2020-11-06', 'DO', 'Dominican Republic', 'AMRO', '546', '128824', '3', '2260');
INSERT INTO public.who_global_data_import VALUES (23910, '2020-11-07', 'DO', 'Dominican Republic', 'AMRO', '476', '129300', '1', '2261');
INSERT INTO public.who_global_data_import VALUES (23911, '2020-11-08', 'DO', 'Dominican Republic', 'AMRO', '345', '129645', '2', '2263');
INSERT INTO public.who_global_data_import VALUES (23912, '2020-11-09', 'DO', 'Dominican Republic', 'AMRO', '537', '130182', '2', '2265');
INSERT INTO public.who_global_data_import VALUES (23913, '2020-11-10', 'DO', 'Dominican Republic', 'AMRO', '421', '130603', '2', '2267');
INSERT INTO public.who_global_data_import VALUES (23914, '2020-11-11', 'DO', 'Dominican Republic', 'AMRO', '528', '131131', '2', '2269');
INSERT INTO public.who_global_data_import VALUES (23915, '2020-11-12', 'DO', 'Dominican Republic', 'AMRO', '134', '131265', '3', '2272');
INSERT INTO public.who_global_data_import VALUES (23916, '2020-11-13', 'DO', 'Dominican Republic', 'AMRO', '371', '131636', '2', '2274');
INSERT INTO public.who_global_data_import VALUES (23917, '2020-11-14', 'DO', 'Dominican Republic', 'AMRO', '918', '132554', '6', '2280');
INSERT INTO public.who_global_data_import VALUES (23918, '2020-11-15', 'DO', 'Dominican Republic', 'AMRO', '671', '133225', '2', '2282');
INSERT INTO public.who_global_data_import VALUES (23919, '2020-11-16', 'DO', 'Dominican Republic', 'AMRO', '499', '133724', '3', '2285');
INSERT INTO public.who_global_data_import VALUES (23920, '2020-11-17', 'DO', 'Dominican Republic', 'AMRO', '479', '134203', '1', '2286');
INSERT INTO public.who_global_data_import VALUES (23921, '2020-11-18', 'DO', 'Dominican Republic', 'AMRO', '494', '134697', '4', '2290');
INSERT INTO public.who_global_data_import VALUES (23922, '2020-11-19', 'DO', 'Dominican Republic', 'AMRO', '460', '135157', '3', '2293');
INSERT INTO public.who_global_data_import VALUES (23923, '2020-11-20', 'DO', 'Dominican Republic', 'AMRO', '1026', '136183', '8', '2301');
INSERT INTO public.who_global_data_import VALUES (23924, '2020-11-21', 'DO', 'Dominican Republic', 'AMRO', '601', '136784', '5', '2306');
INSERT INTO public.who_global_data_import VALUES (23925, '2020-11-22', 'DO', 'Dominican Republic', 'AMRO', '986', '137770', '2', '2308');
INSERT INTO public.who_global_data_import VALUES (23926, '2020-11-23', 'DO', 'Dominican Republic', 'AMRO', '640', '138410', '2', '2310');
INSERT INTO public.who_global_data_import VALUES (23927, '2020-11-24', 'DO', 'Dominican Republic', 'AMRO', '419', '138829', '1', '2311');
INSERT INTO public.who_global_data_import VALUES (23928, '2020-11-25', 'DO', 'Dominican Republic', 'AMRO', '282', '139111', '2', '2313');
INSERT INTO public.who_global_data_import VALUES (23929, '2020-11-26', 'DO', 'Dominican Republic', 'AMRO', '553', '139664', '2', '2315');
INSERT INTO public.who_global_data_import VALUES (23930, '2020-11-27', 'DO', 'Dominican Republic', 'AMRO', '1258', '140922', '2', '2317');
INSERT INTO public.who_global_data_import VALUES (23931, '2020-11-28', 'DO', 'Dominican Republic', 'AMRO', '855', '141777', '7', '2324');
INSERT INTO public.who_global_data_import VALUES (23932, '2020-11-29', 'DO', 'Dominican Republic', 'AMRO', '876', '142653', '4', '2328');
INSERT INTO public.who_global_data_import VALUES (23933, '2020-11-30', 'DO', 'Dominican Republic', 'AMRO', '820', '143473', '2', '2330');
INSERT INTO public.who_global_data_import VALUES (23934, '2020-12-01', 'DO', 'Dominican Republic', 'AMRO', '515', '143988', '1', '2331');
INSERT INTO public.who_global_data_import VALUES (23935, '2020-12-02', 'DO', 'Dominican Republic', 'AMRO', '314', '144302', '2', '2333');
INSERT INTO public.who_global_data_import VALUES (23936, '2020-12-03', 'DO', 'Dominican Republic', 'AMRO', '895', '145197', '1', '2334');
INSERT INTO public.who_global_data_import VALUES (23937, '2020-12-04', 'DO', 'Dominican Republic', 'AMRO', '812', '146009', '1', '2335');
INSERT INTO public.who_global_data_import VALUES (23938, '2020-12-05', 'DO', 'Dominican Republic', 'AMRO', '671', '146680', '8', '2343');
INSERT INTO public.who_global_data_import VALUES (23939, '2020-12-06', 'DO', 'Dominican Republic', 'AMRO', '975', '147655', '2', '2345');
INSERT INTO public.who_global_data_import VALUES (23940, '2020-12-07', 'DO', 'Dominican Republic', 'AMRO', '798', '148453', '0', '2345');
INSERT INTO public.who_global_data_import VALUES (23941, '2020-12-08', 'DO', 'Dominican Republic', 'AMRO', '685', '149138', '1', '2346');
INSERT INTO public.who_global_data_import VALUES (23942, '2020-12-09', 'DO', 'Dominican Republic', 'AMRO', '492', '149630', '1', '2347');
INSERT INTO public.who_global_data_import VALUES (23943, '2020-12-10', 'DO', 'Dominican Republic', 'AMRO', '531', '150161', '3', '2350');
INSERT INTO public.who_global_data_import VALUES (23944, '2020-12-11', 'DO', 'Dominican Republic', 'AMRO', '1560', '151721', '8', '2358');
INSERT INTO public.who_global_data_import VALUES (23945, '2020-12-12', 'DO', 'Dominican Republic', 'AMRO', '731', '152452', '1', '2359');
INSERT INTO public.who_global_data_import VALUES (23946, '2020-12-13', 'DO', 'Dominican Republic', 'AMRO', '1133', '153585', '1', '2360');
INSERT INTO public.who_global_data_import VALUES (23947, '2020-12-14', 'DO', 'Dominican Republic', 'AMRO', '1107', '154692', '1', '2361');
INSERT INTO public.who_global_data_import VALUES (23948, '2020-12-15', 'DO', 'Dominican Republic', 'AMRO', '492', '155184', '3', '2364');
INSERT INTO public.who_global_data_import VALUES (23949, '2020-12-16', 'DO', 'Dominican Republic', 'AMRO', '613', '155797', '3', '2367');
INSERT INTO public.who_global_data_import VALUES (24054, '2020-02-25', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (23950, '2020-12-17', 'DO', 'Dominican Republic', 'AMRO', '788', '156585', '5', '2372');
INSERT INTO public.who_global_data_import VALUES (23951, '2020-12-18', 'DO', 'Dominican Republic', 'AMRO', '720', '157305', '3', '2375');
INSERT INTO public.who_global_data_import VALUES (23952, '2020-12-19', 'DO', 'Dominican Republic', 'AMRO', '624', '157929', '1', '2376');
INSERT INTO public.who_global_data_import VALUES (23953, '2020-12-20', 'DO', 'Dominican Republic', 'AMRO', '1135', '159064', '6', '2382');
INSERT INTO public.who_global_data_import VALUES (23954, '2020-12-21', 'DO', 'Dominican Republic', 'AMRO', '1322', '160386', '2', '2384');
INSERT INTO public.who_global_data_import VALUES (23955, '2020-12-22', 'DO', 'Dominican Republic', 'AMRO', '666', '161052', '1', '2385');
INSERT INTO public.who_global_data_import VALUES (23956, '2020-12-23', 'DO', 'Dominican Republic', 'AMRO', '878', '161930', '13', '2398');
INSERT INTO public.who_global_data_import VALUES (23957, '2020-12-24', 'DO', 'Dominican Republic', 'AMRO', '566', '162496', '3', '2401');
INSERT INTO public.who_global_data_import VALUES (23958, '2020-12-25', 'DO', 'Dominican Republic', 'AMRO', '1158', '163654', '3', '2404');
INSERT INTO public.who_global_data_import VALUES (23959, '2020-12-26', 'DO', 'Dominican Republic', 'AMRO', '1381', '165035', '0', '2404');
INSERT INTO public.who_global_data_import VALUES (23960, '2020-12-27', 'DO', 'Dominican Republic', 'AMRO', '905', '165940', '0', '2404');
INSERT INTO public.who_global_data_import VALUES (23961, '2020-12-28', 'DO', 'Dominican Republic', 'AMRO', '824', '166764', '0', '2404');
INSERT INTO public.who_global_data_import VALUES (23962, '2020-12-29', 'DO', 'Dominican Republic', 'AMRO', '641', '167405', '0', '2404');
INSERT INTO public.who_global_data_import VALUES (23963, '2020-12-30', 'DO', 'Dominican Republic', 'AMRO', '860', '168265', '1', '2405');
INSERT INTO public.who_global_data_import VALUES (23964, '2020-12-31', 'DO', 'Dominican Republic', 'AMRO', '1314', '169579', '4', '2409');
INSERT INTO public.who_global_data_import VALUES (23965, '2021-01-01', 'DO', 'Dominican Republic', 'AMRO', '1206', '170785', '5', '2414');
INSERT INTO public.who_global_data_import VALUES (23966, '2021-01-02', 'DO', 'Dominican Republic', 'AMRO', '1433', '172218', '2', '2416');
INSERT INTO public.who_global_data_import VALUES (23967, '2021-01-03', 'DO', 'Dominican Republic', 'AMRO', '747', '172965', '0', '2416');
INSERT INTO public.who_global_data_import VALUES (23968, '2021-01-04', 'DO', 'Dominican Republic', 'AMRO', '366', '173331', '2', '2418');
INSERT INTO public.who_global_data_import VALUES (23969, '2021-01-05', 'DO', 'Dominican Republic', 'AMRO', '0', '173331', '0', '2418');
INSERT INTO public.who_global_data_import VALUES (23970, '2021-01-06', 'DO', 'Dominican Republic', 'AMRO', '2518', '175849', '1', '2419');
INSERT INTO public.who_global_data_import VALUES (23971, '2021-01-07', 'DO', 'Dominican Republic', 'AMRO', '529', '176378', '0', '2419');
INSERT INTO public.who_global_data_import VALUES (23972, '2021-01-08', 'DO', 'Dominican Republic', 'AMRO', '1115', '177493', '4', '2423');
INSERT INTO public.who_global_data_import VALUES (23973, '2021-01-09', 'DO', 'Dominican Republic', 'AMRO', '1045', '178538', '1', '2424');
INSERT INTO public.who_global_data_import VALUES (23974, '2021-01-10', 'DO', 'Dominican Republic', 'AMRO', '2106', '180644', '0', '2424');
INSERT INTO public.who_global_data_import VALUES (23975, '2021-01-11', 'DO', 'Dominican Republic', 'AMRO', '1459', '182103', '3', '2427');
INSERT INTO public.who_global_data_import VALUES (23976, '2021-01-12', 'DO', 'Dominican Republic', 'AMRO', '1179', '183282', '0', '2427');
INSERT INTO public.who_global_data_import VALUES (23977, '2021-01-13', 'DO', 'Dominican Republic', 'AMRO', '1506', '184788', '0', '2427');
INSERT INTO public.who_global_data_import VALUES (23978, '2021-01-14', 'DO', 'Dominican Republic', 'AMRO', '1595', '186383', '1', '2428');
INSERT INTO public.who_global_data_import VALUES (23979, '2021-01-15', 'DO', 'Dominican Republic', 'AMRO', '1104', '187487', '0', '2428');
INSERT INTO public.who_global_data_import VALUES (23980, '2021-01-16', 'DO', 'Dominican Republic', 'AMRO', '1482', '188969', '4', '2432');
INSERT INTO public.who_global_data_import VALUES (23981, '2021-01-17', 'DO', 'Dominican Republic', 'AMRO', '2370', '191339', '0', '2432');
INSERT INTO public.who_global_data_import VALUES (23982, '2021-01-18', 'DO', 'Dominican Republic', 'AMRO', '1779', '193118', '5', '2437');
INSERT INTO public.who_global_data_import VALUES (23983, '2021-01-19', 'DO', 'Dominican Republic', 'AMRO', '1848', '194966', '11', '2448');
INSERT INTO public.who_global_data_import VALUES (23984, '2021-01-20', 'DO', 'Dominican Republic', 'AMRO', '1625', '196591', '13', '2461');
INSERT INTO public.who_global_data_import VALUES (23985, '2021-01-21', 'DO', 'Dominican Republic', 'AMRO', '1532', '198123', '9', '2470');
INSERT INTO public.who_global_data_import VALUES (23986, '2021-01-22', 'DO', 'Dominican Republic', 'AMRO', '1549', '199672', '12', '2482');
INSERT INTO public.who_global_data_import VALUES (23987, '2021-01-23', 'DO', 'Dominican Republic', 'AMRO', '1473', '201145', '14', '2496');
INSERT INTO public.who_global_data_import VALUES (23988, '2021-01-24', 'DO', 'Dominican Republic', 'AMRO', '1362', '202507', '17', '2513');
INSERT INTO public.who_global_data_import VALUES (23989, '2021-01-25', 'DO', 'Dominican Republic', 'AMRO', '1439', '203946', '0', '2513');
INSERT INTO public.who_global_data_import VALUES (23990, '2021-01-26', 'DO', 'Dominican Republic', 'AMRO', '1216', '205162', '32', '2545');
INSERT INTO public.who_global_data_import VALUES (23991, '2021-01-27', 'DO', 'Dominican Republic', 'AMRO', '1143', '206305', '19', '2564');
INSERT INTO public.who_global_data_import VALUES (23992, '2021-01-28', 'DO', 'Dominican Republic', 'AMRO', '1150', '207455', '15', '2579');
INSERT INTO public.who_global_data_import VALUES (23993, '2021-01-29', 'DO', 'Dominican Republic', 'AMRO', '1155', '208610', '24', '2603');
INSERT INTO public.who_global_data_import VALUES (23994, '2021-01-30', 'DO', 'Dominican Republic', 'AMRO', '1802', '210412', '23', '2626');
INSERT INTO public.who_global_data_import VALUES (23995, '2021-01-31', 'DO', 'Dominican Republic', 'AMRO', '2141', '212553', '20', '2646');
INSERT INTO public.who_global_data_import VALUES (23996, '2021-02-01', 'DO', 'Dominican Republic', 'AMRO', '1507', '214060', '20', '2666');
INSERT INTO public.who_global_data_import VALUES (23997, '2021-02-02', 'DO', 'Dominican Republic', 'AMRO', '1026', '215086', '22', '2688');
INSERT INTO public.who_global_data_import VALUES (23998, '2021-02-03', 'DO', 'Dominican Republic', 'AMRO', '834', '215920', '16', '2704');
INSERT INTO public.who_global_data_import VALUES (23999, '2021-02-04', 'DO', 'Dominican Republic', 'AMRO', '1357', '217277', '15', '2719');
INSERT INTO public.who_global_data_import VALUES (24000, '2021-02-05', 'DO', 'Dominican Republic', 'AMRO', '1671', '218948', '28', '2747');
INSERT INTO public.who_global_data_import VALUES (24001, '2020-01-03', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24002, '2020-01-04', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24003, '2020-01-05', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24004, '2020-01-06', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24005, '2020-01-07', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24006, '2020-01-08', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24007, '2020-01-09', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24008, '2020-01-10', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24009, '2020-01-11', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24010, '2020-01-12', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24011, '2020-01-13', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24012, '2020-01-14', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24013, '2020-01-15', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24014, '2020-01-16', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24015, '2020-01-17', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24016, '2020-01-18', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24017, '2020-01-19', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24018, '2020-01-20', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24019, '2020-01-21', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24020, '2020-01-22', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24021, '2020-01-23', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24022, '2020-01-24', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24023, '2020-01-25', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24024, '2020-01-26', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24025, '2020-01-27', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24026, '2020-01-28', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24027, '2020-01-29', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24028, '2020-01-30', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24029, '2020-01-31', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24030, '2020-02-01', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24031, '2020-02-02', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24032, '2020-02-03', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24033, '2020-02-04', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24034, '2020-02-05', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24035, '2020-02-06', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24036, '2020-02-07', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24037, '2020-02-08', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24038, '2020-02-09', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24039, '2020-02-10', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24040, '2020-02-11', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24041, '2020-02-12', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24042, '2020-02-13', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24043, '2020-02-14', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24044, '2020-02-15', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24045, '2020-02-16', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24046, '2020-02-17', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24047, '2020-02-18', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24048, '2020-02-19', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24049, '2020-02-20', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24050, '2020-02-21', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24051, '2020-02-22', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24055, '2020-02-26', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24056, '2020-02-27', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24057, '2020-02-28', 'EC', 'Ecuador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24058, '2020-02-29', 'EC', 'Ecuador', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24059, '2020-03-01', 'EC', 'Ecuador', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24060, '2020-03-02', 'EC', 'Ecuador', 'AMRO', '5', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24061, '2020-03-03', 'EC', 'Ecuador', 'AMRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24062, '2020-03-04', 'EC', 'Ecuador', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24063, '2020-03-05', 'EC', 'Ecuador', 'AMRO', '6', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24064, '2020-03-06', 'EC', 'Ecuador', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24065, '2020-03-07', 'EC', 'Ecuador', 'AMRO', '1', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24066, '2020-03-08', 'EC', 'Ecuador', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24067, '2020-03-09', 'EC', 'Ecuador', 'AMRO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24068, '2020-03-10', 'EC', 'Ecuador', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24069, '2020-03-11', 'EC', 'Ecuador', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24070, '2020-03-12', 'EC', 'Ecuador', 'AMRO', '2', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24071, '2020-03-13', 'EC', 'Ecuador', 'AMRO', '6', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24072, '2020-03-14', 'EC', 'Ecuador', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24073, '2020-03-15', 'EC', 'Ecuador', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24074, '2020-03-16', 'EC', 'Ecuador', 'AMRO', '14', '41', '2', '2');
INSERT INTO public.who_global_data_import VALUES (24075, '2020-03-17', 'EC', 'Ecuador', 'AMRO', '21', '62', '0', '2');
INSERT INTO public.who_global_data_import VALUES (24076, '2020-03-18', 'EC', 'Ecuador', 'AMRO', '97', '159', '0', '2');
INSERT INTO public.who_global_data_import VALUES (24077, '2020-03-19', 'EC', 'Ecuador', 'AMRO', '40', '199', '1', '3');
INSERT INTO public.who_global_data_import VALUES (24078, '2020-03-20', 'EC', 'Ecuador', 'AMRO', '168', '367', '2', '5');
INSERT INTO public.who_global_data_import VALUES (24079, '2020-03-21', 'EC', 'Ecuador', 'AMRO', '139', '506', '2', '7');
INSERT INTO public.who_global_data_import VALUES (24080, '2020-03-22', 'EC', 'Ecuador', 'AMRO', '0', '506', '0', '7');
INSERT INTO public.who_global_data_import VALUES (24081, '2020-03-23', 'EC', 'Ecuador', 'AMRO', '26', '532', '0', '7');
INSERT INTO public.who_global_data_import VALUES (24082, '2020-03-24', 'EC', 'Ecuador', 'AMRO', '517', '1049', '1', '8');
INSERT INTO public.who_global_data_import VALUES (24083, '2020-03-25', 'EC', 'Ecuador', 'AMRO', '0', '1049', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24084, '2020-03-26', 'EC', 'Ecuador', 'AMRO', '162', '1211', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24085, '2020-03-27', 'EC', 'Ecuador', 'AMRO', '0', '1211', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24086, '2020-03-28', 'EC', 'Ecuador', 'AMRO', '384', '1595', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24087, '2020-03-29', 'EC', 'Ecuador', 'AMRO', '228', '1823', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24088, '2020-03-30', 'EC', 'Ecuador', 'AMRO', '12', '1835', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24089, '2020-03-31', 'EC', 'Ecuador', 'AMRO', '127', '1962', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24090, '2020-04-01', 'EC', 'Ecuador', 'AMRO', '278', '2240', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24091, '2020-04-02', 'EC', 'Ecuador', 'AMRO', '132', '2372', '71', '79');
INSERT INTO public.who_global_data_import VALUES (24092, '2020-04-03', 'EC', 'Ecuador', 'AMRO', '791', '3163', '41', '120');
INSERT INTO public.who_global_data_import VALUES (24093, '2020-04-04', 'EC', 'Ecuador', 'AMRO', '0', '3163', '0', '120');
INSERT INTO public.who_global_data_import VALUES (24094, '2020-04-05', 'EC', 'Ecuador', 'AMRO', '302', '3465', '52', '172');
INSERT INTO public.who_global_data_import VALUES (24095, '2020-04-06', 'EC', 'Ecuador', 'AMRO', '0', '3465', '0', '172');
INSERT INTO public.who_global_data_import VALUES (24096, '2020-04-07', 'EC', 'Ecuador', 'AMRO', '282', '3747', '19', '191');
INSERT INTO public.who_global_data_import VALUES (24097, '2020-04-08', 'EC', 'Ecuador', 'AMRO', '0', '3747', '0', '191');
INSERT INTO public.who_global_data_import VALUES (24098, '2020-04-09', 'EC', 'Ecuador', 'AMRO', '703', '4450', '51', '242');
INSERT INTO public.who_global_data_import VALUES (24099, '2020-04-10', 'EC', 'Ecuador', 'AMRO', '515', '4965', '30', '272');
INSERT INTO public.who_global_data_import VALUES (24100, '2020-04-11', 'EC', 'Ecuador', 'AMRO', '2196', '7161', '25', '297');
INSERT INTO public.who_global_data_import VALUES (24101, '2020-04-12', 'EC', 'Ecuador', 'AMRO', '96', '7257', '18', '315');
INSERT INTO public.who_global_data_import VALUES (24102, '2020-04-13', 'EC', 'Ecuador', 'AMRO', '209', '7466', '18', '333');
INSERT INTO public.who_global_data_import VALUES (24103, '2020-04-14', 'EC', 'Ecuador', 'AMRO', '63', '7529', '22', '355');
INSERT INTO public.who_global_data_import VALUES (24104, '2020-04-15', 'EC', 'Ecuador', 'AMRO', '74', '7603', '14', '369');
INSERT INTO public.who_global_data_import VALUES (24105, '2020-04-16', 'EC', 'Ecuador', 'AMRO', '255', '7858', '19', '388');
INSERT INTO public.who_global_data_import VALUES (24106, '2020-04-17', 'EC', 'Ecuador', 'AMRO', '367', '8225', '15', '403');
INSERT INTO public.who_global_data_import VALUES (24107, '2020-04-18', 'EC', 'Ecuador', 'AMRO', '225', '8450', '18', '421');
INSERT INTO public.who_global_data_import VALUES (24108, '2020-04-19', 'EC', 'Ecuador', 'AMRO', '572', '9022', '35', '456');
INSERT INTO public.who_global_data_import VALUES (24109, '2020-04-20', 'EC', 'Ecuador', 'AMRO', '446', '9468', '18', '474');
INSERT INTO public.who_global_data_import VALUES (24110, '2020-04-21', 'EC', 'Ecuador', 'AMRO', '660', '10128', '33', '507');
INSERT INTO public.who_global_data_import VALUES (24111, '2020-04-22', 'EC', 'Ecuador', 'AMRO', '270', '10398', '13', '520');
INSERT INTO public.who_global_data_import VALUES (24112, '2020-04-23', 'EC', 'Ecuador', 'AMRO', '452', '10850', '17', '537');
INSERT INTO public.who_global_data_import VALUES (24113, '2020-04-24', 'EC', 'Ecuador', 'AMRO', '333', '11183', '23', '560');
INSERT INTO public.who_global_data_import VALUES (24114, '2020-04-25', 'EC', 'Ecuador', 'AMRO', '11536', '22719', '16', '576');
INSERT INTO public.who_global_data_import VALUES (24115, '2020-04-26', 'EC', 'Ecuador', 'AMRO', '0', '22719', '0', '576');
INSERT INTO public.who_global_data_import VALUES (24116, '2020-04-27', 'EC', 'Ecuador', 'AMRO', '0', '22719', '0', '576');
INSERT INTO public.who_global_data_import VALUES (24117, '2020-04-28', 'EC', 'Ecuador', 'AMRO', '521', '23240', '87', '663');
INSERT INTO public.who_global_data_import VALUES (24118, '2020-04-29', 'EC', 'Ecuador', 'AMRO', '1018', '24258', '208', '871');
INSERT INTO public.who_global_data_import VALUES (24119, '2020-04-30', 'EC', 'Ecuador', 'AMRO', '417', '24675', '12', '883');
INSERT INTO public.who_global_data_import VALUES (24120, '2020-05-01', 'EC', 'Ecuador', 'AMRO', '259', '24934', '17', '900');
INSERT INTO public.who_global_data_import VALUES (24121, '2020-05-02', 'EC', 'Ecuador', 'AMRO', '1402', '26336', '163', '1063');
INSERT INTO public.who_global_data_import VALUES (24122, '2020-05-03', 'EC', 'Ecuador', 'AMRO', '1128', '27464', '308', '1371');
INSERT INTO public.who_global_data_import VALUES (24123, '2020-05-04', 'EC', 'Ecuador', 'AMRO', '2074', '29538', '193', '1564');
INSERT INTO public.who_global_data_import VALUES (24124, '2020-05-05', 'EC', 'Ecuador', 'AMRO', '2343', '31881', '5', '1569');
INSERT INTO public.who_global_data_import VALUES (24125, '2020-05-06', 'EC', 'Ecuador', 'AMRO', '0', '31881', '0', '1569');
INSERT INTO public.who_global_data_import VALUES (24126, '2020-05-07', 'EC', 'Ecuador', 'AMRO', '-2461', '29420', '49', '1618');
INSERT INTO public.who_global_data_import VALUES (24127, '2020-05-08', 'EC', 'Ecuador', 'AMRO', '878', '30298', '36', '1654');
INSERT INTO public.who_global_data_import VALUES (24128, '2020-05-09', 'EC', 'Ecuador', 'AMRO', '0', '30298', '0', '1654');
INSERT INTO public.who_global_data_import VALUES (24129, '2020-05-10', 'EC', 'Ecuador', 'AMRO', '-1480', '28818', '50', '1704');
INSERT INTO public.who_global_data_import VALUES (24130, '2020-05-11', 'EC', 'Ecuador', 'AMRO', '741', '29559', '423', '2127');
INSERT INTO public.who_global_data_import VALUES (24131, '2020-05-12', 'EC', 'Ecuador', 'AMRO', '-50', '29509', '18', '2145');
INSERT INTO public.who_global_data_import VALUES (24132, '2020-05-13', 'EC', 'Ecuador', 'AMRO', '910', '30419', '182', '2327');
INSERT INTO public.who_global_data_import VALUES (24133, '2020-05-14', 'EC', 'Ecuador', 'AMRO', '67', '30486', '7', '2334');
INSERT INTO public.who_global_data_import VALUES (24134, '2020-05-15', 'EC', 'Ecuador', 'AMRO', '16', '30502', '4', '2338');
INSERT INTO public.who_global_data_import VALUES (24135, '2020-05-16', 'EC', 'Ecuador', 'AMRO', '0', '30502', '0', '2338');
INSERT INTO public.who_global_data_import VALUES (24136, '2020-05-17', 'EC', 'Ecuador', 'AMRO', '965', '31467', '256', '2594');
INSERT INTO public.who_global_data_import VALUES (24137, '2020-05-18', 'EC', 'Ecuador', 'AMRO', '1256', '32723', '94', '2688');
INSERT INTO public.who_global_data_import VALUES (24138, '2020-05-19', 'EC', 'Ecuador', 'AMRO', '459', '33182', '48', '2736');
INSERT INTO public.who_global_data_import VALUES (24139, '2020-05-20', 'EC', 'Ecuador', 'AMRO', '969', '34151', '103', '2839');
INSERT INTO public.who_global_data_import VALUES (24140, '2020-05-21', 'EC', 'Ecuador', 'AMRO', '0', '34151', '0', '2839');
INSERT INTO public.who_global_data_import VALUES (24141, '2020-05-22', 'EC', 'Ecuador', 'AMRO', '703', '34854', '49', '2888');
INSERT INTO public.who_global_data_import VALUES (24142, '2020-05-23', 'EC', 'Ecuador', 'AMRO', '974', '35828', '168', '3056');
INSERT INTO public.who_global_data_import VALUES (24143, '2020-05-24', 'EC', 'Ecuador', 'AMRO', '430', '36258', '40', '3096');
INSERT INTO public.who_global_data_import VALUES (24144, '2020-05-25', 'EC', 'Ecuador', 'AMRO', '498', '36756', '12', '3108');
INSERT INTO public.who_global_data_import VALUES (24145, '2020-05-26', 'EC', 'Ecuador', 'AMRO', '599', '37355', '95', '3203');
INSERT INTO public.who_global_data_import VALUES (24146, '2020-05-27', 'EC', 'Ecuador', 'AMRO', '301', '37656', '18', '3221');
INSERT INTO public.who_global_data_import VALUES (24147, '2020-05-28', 'EC', 'Ecuador', 'AMRO', '447', '38103', '54', '3275');
INSERT INTO public.who_global_data_import VALUES (24148, '2020-05-29', 'EC', 'Ecuador', 'AMRO', '368', '38471', '38', '3313');
INSERT INTO public.who_global_data_import VALUES (24149, '2020-05-30', 'EC', 'Ecuador', 'AMRO', '100', '38571', '21', '3334');
INSERT INTO public.who_global_data_import VALUES (24150, '2020-05-31', 'EC', 'Ecuador', 'AMRO', '0', '38571', '0', '3334');
INSERT INTO public.who_global_data_import VALUES (24151, '2020-06-01', 'EC', 'Ecuador', 'AMRO', '527', '39098', '24', '3358');
INSERT INTO public.who_global_data_import VALUES (24152, '2020-06-02', 'EC', 'Ecuador', 'AMRO', '0', '39098', '0', '3358');
INSERT INTO public.who_global_data_import VALUES (24153, '2020-06-03', 'EC', 'Ecuador', 'AMRO', '1316', '40414', '80', '3438');
INSERT INTO public.who_global_data_import VALUES (24154, '2020-06-04', 'EC', 'Ecuador', 'AMRO', '552', '40966', '48', '3486');
INSERT INTO public.who_global_data_import VALUES (24155, '2020-06-05', 'EC', 'Ecuador', 'AMRO', '0', '40966', '0', '3486');
INSERT INTO public.who_global_data_import VALUES (24156, '2020-06-06', 'EC', 'Ecuador', 'AMRO', '1140', '42106', '106', '3592');
INSERT INTO public.who_global_data_import VALUES (24157, '2020-06-07', 'EC', 'Ecuador', 'AMRO', '622', '42728', '16', '3608');
INSERT INTO public.who_global_data_import VALUES (24158, '2020-06-08', 'EC', 'Ecuador', 'AMRO', '392', '43120', '13', '3621');
INSERT INTO public.who_global_data_import VALUES (24159, '2020-06-09', 'EC', 'Ecuador', 'AMRO', '258', '43378', '21', '3642');
INSERT INTO public.who_global_data_import VALUES (24160, '2020-06-10', 'EC', 'Ecuador', 'AMRO', '539', '43917', '48', '3690');
INSERT INTO public.who_global_data_import VALUES (24161, '2020-06-11', 'EC', 'Ecuador', 'AMRO', '523', '44440', '30', '3720');
INSERT INTO public.who_global_data_import VALUES (24162, '2020-06-12', 'EC', 'Ecuador', 'AMRO', '0', '44440', '0', '3720');
INSERT INTO public.who_global_data_import VALUES (24163, '2020-06-13', 'EC', 'Ecuador', 'AMRO', '1338', '45778', '108', '3828');
INSERT INTO public.who_global_data_import VALUES (24164, '2020-06-14', 'EC', 'Ecuador', 'AMRO', '578', '46356', '46', '3874');
INSERT INTO public.who_global_data_import VALUES (24165, '2020-06-15', 'EC', 'Ecuador', 'AMRO', '395', '46751', '22', '3896');
INSERT INTO public.who_global_data_import VALUES (24166, '2020-06-16', 'EC', 'Ecuador', 'AMRO', '571', '47322', '33', '3929');
INSERT INTO public.who_global_data_import VALUES (24167, '2020-06-17', 'EC', 'Ecuador', 'AMRO', '621', '47943', '41', '3970');
INSERT INTO public.who_global_data_import VALUES (24168, '2020-06-18', 'EC', 'Ecuador', 'AMRO', '547', '48490', '37', '4007');
INSERT INTO public.who_global_data_import VALUES (24169, '2020-06-19', 'EC', 'Ecuador', 'AMRO', '607', '49097', '80', '4087');
INSERT INTO public.who_global_data_import VALUES (24170, '2020-06-20', 'EC', 'Ecuador', 'AMRO', '634', '49731', '69', '4156');
INSERT INTO public.who_global_data_import VALUES (24171, '2020-06-21', 'EC', 'Ecuador', 'AMRO', '452', '50183', '43', '4199');
INSERT INTO public.who_global_data_import VALUES (24172, '2020-06-22', 'EC', 'Ecuador', 'AMRO', '457', '50640', '24', '4223');
INSERT INTO public.who_global_data_import VALUES (24173, '2020-06-23', 'EC', 'Ecuador', 'AMRO', '275', '50915', '23', '4246');
INSERT INTO public.who_global_data_import VALUES (24174, '2020-06-24', 'EC', 'Ecuador', 'AMRO', '728', '51643', '28', '4274');
INSERT INTO public.who_global_data_import VALUES (24175, '2020-06-25', 'EC', 'Ecuador', 'AMRO', '691', '52334', '35', '4309');
INSERT INTO public.who_global_data_import VALUES (24176, '2020-06-26', 'EC', 'Ecuador', 'AMRO', '822', '53156', '34', '4343');
INSERT INTO public.who_global_data_import VALUES (24177, '2020-06-27', 'EC', 'Ecuador', 'AMRO', '700', '53856', '63', '4406');
INSERT INTO public.who_global_data_import VALUES (24178, '2020-06-28', 'EC', 'Ecuador', 'AMRO', '718', '54574', '18', '4424');
INSERT INTO public.who_global_data_import VALUES (24179, '2020-06-29', 'EC', 'Ecuador', 'AMRO', '681', '55255', '5', '4429');
INSERT INTO public.who_global_data_import VALUES (24180, '2020-06-30', 'EC', 'Ecuador', 'AMRO', '410', '55665', '73', '4502');
INSERT INTO public.who_global_data_import VALUES (24181, '2020-07-01', 'EC', 'Ecuador', 'AMRO', '677', '56342', '25', '4527');
INSERT INTO public.who_global_data_import VALUES (24182, '2020-07-02', 'EC', 'Ecuador', 'AMRO', '0', '56342', '0', '4527');
INSERT INTO public.who_global_data_import VALUES (24183, '2020-07-03', 'EC', 'Ecuador', 'AMRO', '3126', '59468', '112', '4639');
INSERT INTO public.who_global_data_import VALUES (24184, '2020-07-04', 'EC', 'Ecuador', 'AMRO', '1189', '60657', '61', '4700');
INSERT INTO public.who_global_data_import VALUES (24185, '2020-07-05', 'EC', 'Ecuador', 'AMRO', '878', '61535', '69', '4769');
INSERT INTO public.who_global_data_import VALUES (24186, '2020-07-06', 'EC', 'Ecuador', 'AMRO', '423', '61958', '12', '4781');
INSERT INTO public.who_global_data_import VALUES (24187, '2020-07-07', 'EC', 'Ecuador', 'AMRO', '422', '62380', '40', '4821');
INSERT INTO public.who_global_data_import VALUES (24188, '2020-07-08', 'EC', 'Ecuador', 'AMRO', '865', '63245', '52', '4873');
INSERT INTO public.who_global_data_import VALUES (24189, '2020-07-09', 'EC', 'Ecuador', 'AMRO', '0', '63245', '0', '4873');
INSERT INTO public.who_global_data_import VALUES (24190, '2020-07-10', 'EC', 'Ecuador', 'AMRO', '1773', '65018', '66', '4939');
INSERT INTO public.who_global_data_import VALUES (24191, '2020-07-11', 'EC', 'Ecuador', 'AMRO', '783', '65801', '44', '4983');
INSERT INTO public.who_global_data_import VALUES (24192, '2020-07-12', 'EC', 'Ecuador', 'AMRO', '1408', '67209', '48', '5031');
INSERT INTO public.who_global_data_import VALUES (24193, '2020-07-13', 'EC', 'Ecuador', 'AMRO', '661', '67870', '16', '5047');
INSERT INTO public.who_global_data_import VALUES (24194, '2020-07-14', 'EC', 'Ecuador', 'AMRO', '589', '68459', '16', '5063');
INSERT INTO public.who_global_data_import VALUES (24195, '2020-07-15', 'EC', 'Ecuador', 'AMRO', '1111', '69570', '67', '5130');
INSERT INTO public.who_global_data_import VALUES (24196, '2020-07-16', 'EC', 'Ecuador', 'AMRO', '759', '70329', '28', '5158');
INSERT INTO public.who_global_data_import VALUES (24197, '2020-07-17', 'EC', 'Ecuador', 'AMRO', '1036', '71365', '49', '5207');
INSERT INTO public.who_global_data_import VALUES (24198, '2020-07-18', 'EC', 'Ecuador', 'AMRO', '1079', '72444', '43', '5250');
INSERT INTO public.who_global_data_import VALUES (24199, '2020-07-19', 'EC', 'Ecuador', 'AMRO', '938', '73382', '32', '5282');
INSERT INTO public.who_global_data_import VALUES (24200, '2020-07-20', 'EC', 'Ecuador', 'AMRO', '631', '74013', '31', '5313');
INSERT INTO public.who_global_data_import VALUES (24201, '2020-07-21', 'EC', 'Ecuador', 'AMRO', '607', '74620', '5', '5318');
INSERT INTO public.who_global_data_import VALUES (24202, '2020-07-22', 'EC', 'Ecuador', 'AMRO', '1597', '76217', '48', '5366');
INSERT INTO public.who_global_data_import VALUES (24203, '2020-07-23', 'EC', 'Ecuador', 'AMRO', '1040', '77257', '52', '5418');
INSERT INTO public.who_global_data_import VALUES (24204, '2020-07-24', 'EC', 'Ecuador', 'AMRO', '891', '78148', '21', '5439');
INSERT INTO public.who_global_data_import VALUES (24205, '2020-07-25', 'EC', 'Ecuador', 'AMRO', '901', '79049', '29', '5468');
INSERT INTO public.who_global_data_import VALUES (24206, '2020-07-26', 'EC', 'Ecuador', 'AMRO', '987', '80036', '39', '5507');
INSERT INTO public.who_global_data_import VALUES (24207, '2020-07-27', 'EC', 'Ecuador', 'AMRO', '658', '80694', '8', '5515');
INSERT INTO public.who_global_data_import VALUES (24208, '2020-07-28', 'EC', 'Ecuador', 'AMRO', '467', '81161', '17', '5532');
INSERT INTO public.who_global_data_import VALUES (24209, '2020-07-29', 'EC', 'Ecuador', 'AMRO', '1118', '82279', '52', '5584');
INSERT INTO public.who_global_data_import VALUES (24210, '2020-07-30', 'EC', 'Ecuador', 'AMRO', '914', '83193', '39', '5623');
INSERT INTO public.who_global_data_import VALUES (24211, '2020-07-31', 'EC', 'Ecuador', 'AMRO', '1177', '84370', '34', '5657');
INSERT INTO public.who_global_data_import VALUES (24212, '2020-08-01', 'EC', 'Ecuador', 'AMRO', '985', '85355', '45', '5702');
INSERT INTO public.who_global_data_import VALUES (24213, '2020-08-02', 'EC', 'Ecuador', 'AMRO', '877', '86232', '34', '5736');
INSERT INTO public.who_global_data_import VALUES (24214, '2020-08-03', 'EC', 'Ecuador', 'AMRO', '0', '86232', '0', '5736');
INSERT INTO public.who_global_data_import VALUES (24215, '2020-08-04', 'EC', 'Ecuador', 'AMRO', '809', '87041', '31', '5767');
INSERT INTO public.who_global_data_import VALUES (24216, '2020-08-05', 'EC', 'Ecuador', 'AMRO', '922', '87963', '41', '5808');
INSERT INTO public.who_global_data_import VALUES (24217, '2020-08-06', 'EC', 'Ecuador', 'AMRO', '903', '88866', '39', '5847');
INSERT INTO public.who_global_data_import VALUES (24218, '2020-08-07', 'EC', 'Ecuador', 'AMRO', '1671', '90537', '30', '5877');
INSERT INTO public.who_global_data_import VALUES (24219, '2020-08-08', 'EC', 'Ecuador', 'AMRO', '1432', '91969', '20', '5897');
INSERT INTO public.who_global_data_import VALUES (24220, '2020-08-09', 'EC', 'Ecuador', 'AMRO', '1603', '93572', '19', '5916');
INSERT INTO public.who_global_data_import VALUES (24221, '2020-08-10', 'EC', 'Ecuador', 'AMRO', '887', '94459', '6', '5922');
INSERT INTO public.who_global_data_import VALUES (24222, '2020-08-11', 'EC', 'Ecuador', 'AMRO', '242', '94701', '10', '5932');
INSERT INTO public.who_global_data_import VALUES (24223, '2020-08-12', 'EC', 'Ecuador', 'AMRO', '862', '95563', '19', '5951');
INSERT INTO public.who_global_data_import VALUES (24224, '2020-08-13', 'EC', 'Ecuador', 'AMRO', '1547', '97110', '33', '5984');
INSERT INTO public.who_global_data_import VALUES (24225, '2020-08-14', 'EC', 'Ecuador', 'AMRO', '1233', '98343', '26', '6010');
INSERT INTO public.who_global_data_import VALUES (24226, '2020-08-15', 'EC', 'Ecuador', 'AMRO', '1066', '99409', '20', '6030');
INSERT INTO public.who_global_data_import VALUES (24227, '2020-08-16', 'EC', 'Ecuador', 'AMRO', '1279', '100688', '35', '6065');
INSERT INTO public.who_global_data_import VALUES (24228, '2020-08-17', 'EC', 'Ecuador', 'AMRO', '854', '101542', '5', '6070');
INSERT INTO public.who_global_data_import VALUES (24229, '2020-08-18', 'EC', 'Ecuador', 'AMRO', '209', '101751', '13', '6083');
INSERT INTO public.who_global_data_import VALUES (24230, '2020-08-19', 'EC', 'Ecuador', 'AMRO', '1190', '102941', '22', '6105');
INSERT INTO public.who_global_data_import VALUES (24231, '2020-08-20', 'EC', 'Ecuador', 'AMRO', '1534', '104475', '41', '6146');
INSERT INTO public.who_global_data_import VALUES (24232, '2020-08-21', 'EC', 'Ecuador', 'AMRO', '1033', '105508', '54', '6200');
INSERT INTO public.who_global_data_import VALUES (24233, '2020-08-22', 'EC', 'Ecuador', 'AMRO', '973', '106481', '48', '6248');
INSERT INTO public.who_global_data_import VALUES (24234, '2020-08-23', 'EC', 'Ecuador', 'AMRO', '608', '107089', '29', '6277');
INSERT INTO public.who_global_data_import VALUES (24235, '2020-08-24', 'EC', 'Ecuador', 'AMRO', '680', '107769', '33', '6310');
INSERT INTO public.who_global_data_import VALUES (24236, '2020-08-25', 'EC', 'Ecuador', 'AMRO', '520', '108289', '12', '6322');
INSERT INTO public.who_global_data_import VALUES (24237, '2020-08-26', 'EC', 'Ecuador', 'AMRO', '741', '109030', '46', '6368');
INSERT INTO public.who_global_data_import VALUES (24238, '2020-08-27', 'EC', 'Ecuador', 'AMRO', '1519', '110549', '42', '6410');
INSERT INTO public.who_global_data_import VALUES (24239, '2020-08-28', 'EC', 'Ecuador', 'AMRO', '670', '111219', '61', '6471');
INSERT INTO public.who_global_data_import VALUES (24240, '2020-08-29', 'EC', 'Ecuador', 'AMRO', '922', '112141', '33', '6504');
INSERT INTO public.who_global_data_import VALUES (24241, '2020-08-30', 'EC', 'Ecuador', 'AMRO', '765', '112906', '33', '6537');
INSERT INTO public.who_global_data_import VALUES (24242, '2020-08-31', 'EC', 'Ecuador', 'AMRO', '742', '113648', '18', '6555');
INSERT INTO public.who_global_data_import VALUES (24243, '2020-09-01', 'EC', 'Ecuador', 'AMRO', '119', '113767', '1', '6556');
INSERT INTO public.who_global_data_import VALUES (24244, '2020-09-02', 'EC', 'Ecuador', 'AMRO', '542', '114309', '15', '6571');
INSERT INTO public.who_global_data_import VALUES (24245, '2020-09-03', 'EC', 'Ecuador', 'AMRO', '1148', '115457', '48', '6619');
INSERT INTO public.who_global_data_import VALUES (24246, '2020-09-04', 'EC', 'Ecuador', 'AMRO', '903', '116360', '29', '6648');
INSERT INTO public.who_global_data_import VALUES (24247, '2020-09-05', 'EC', 'Ecuador', 'AMRO', '815', '117175', '26', '6674');
INSERT INTO public.who_global_data_import VALUES (24248, '2020-09-06', 'EC', 'Ecuador', 'AMRO', '870', '118045', '50', '6724');
INSERT INTO public.who_global_data_import VALUES (24249, '2020-09-07', 'EC', 'Ecuador', 'AMRO', '-8956', '109089', '3800', '10524');
INSERT INTO public.who_global_data_import VALUES (24250, '2020-09-08', 'EC', 'Ecuador', 'AMRO', '1003', '110092', '52', '10576');
INSERT INTO public.who_global_data_import VALUES (24251, '2020-09-09', 'EC', 'Ecuador', 'AMRO', '665', '110757', '51', '10627');
INSERT INTO public.who_global_data_import VALUES (24252, '2020-09-10', 'EC', 'Ecuador', 'AMRO', '1409', '112166', '74', '10701');
INSERT INTO public.who_global_data_import VALUES (24253, '2020-09-11', 'EC', 'Ecuador', 'AMRO', '1040', '113206', '48', '10749');
INSERT INTO public.who_global_data_import VALUES (24254, '2020-09-12', 'EC', 'Ecuador', 'AMRO', '0', '113206', '0', '10749');
INSERT INTO public.who_global_data_import VALUES (24255, '2020-09-13', 'EC', 'Ecuador', 'AMRO', '1526', '114732', '87', '10836');
INSERT INTO public.who_global_data_import VALUES (24256, '2020-09-14', 'EC', 'Ecuador', 'AMRO', '3862', '118594', '67', '10903');
INSERT INTO public.who_global_data_import VALUES (24257, '2020-09-15', 'EC', 'Ecuador', 'AMRO', '317', '118911', '19', '10922');
INSERT INTO public.who_global_data_import VALUES (24258, '2020-09-16', 'EC', 'Ecuador', 'AMRO', '642', '119553', '41', '10963');
INSERT INTO public.who_global_data_import VALUES (24259, '2020-09-17', 'EC', 'Ecuador', 'AMRO', '1972', '121525', '33', '10996');
INSERT INTO public.who_global_data_import VALUES (24260, '2020-09-18', 'EC', 'Ecuador', 'AMRO', '732', '122257', '33', '11029');
INSERT INTO public.who_global_data_import VALUES (24261, '2020-09-19', 'EC', 'Ecuador', 'AMRO', '0', '122257', '0', '11029');
INSERT INTO public.who_global_data_import VALUES (24262, '2020-09-20', 'EC', 'Ecuador', 'AMRO', '3363', '125620', '60', '11089');
INSERT INTO public.who_global_data_import VALUES (24263, '2020-09-21', 'EC', 'Ecuador', 'AMRO', '799', '126419', '1', '11090');
INSERT INTO public.who_global_data_import VALUES (24264, '2020-09-22', 'EC', 'Ecuador', 'AMRO', '292', '126711', '5', '11095');
INSERT INTO public.who_global_data_import VALUES (24265, '2020-09-23', 'EC', 'Ecuador', 'AMRO', '932', '127643', '31', '11126');
INSERT INTO public.who_global_data_import VALUES (24266, '2020-09-24', 'EC', 'Ecuador', 'AMRO', '2339', '129982', '45', '11171');
INSERT INTO public.who_global_data_import VALUES (24267, '2020-09-25', 'EC', 'Ecuador', 'AMRO', '1164', '131146', '42', '11213');
INSERT INTO public.who_global_data_import VALUES (24268, '2020-09-26', 'EC', 'Ecuador', 'AMRO', '1329', '132475', '23', '11236');
INSERT INTO public.who_global_data_import VALUES (24269, '2020-09-27', 'EC', 'Ecuador', 'AMRO', '1506', '133981', '37', '11273');
INSERT INTO public.who_global_data_import VALUES (24270, '2020-09-28', 'EC', 'Ecuador', 'AMRO', '766', '134747', '6', '11279');
INSERT INTO public.who_global_data_import VALUES (24271, '2020-09-29', 'EC', 'Ecuador', 'AMRO', '218', '134965', '1', '11280');
INSERT INTO public.who_global_data_import VALUES (24272, '2020-09-30', 'EC', 'Ecuador', 'AMRO', '784', '135749', '32', '11312');
INSERT INTO public.who_global_data_import VALUES (24273, '2020-10-01', 'EC', 'Ecuador', 'AMRO', '1298', '137047', '43', '11355');
INSERT INTO public.who_global_data_import VALUES (24274, '2020-10-02', 'EC', 'Ecuador', 'AMRO', '1537', '138584', '78', '11433');
INSERT INTO public.who_global_data_import VALUES (24275, '2020-10-03', 'EC', 'Ecuador', 'AMRO', '950', '139534', '62', '11495');
INSERT INTO public.who_global_data_import VALUES (24276, '2020-10-04', 'EC', 'Ecuador', 'AMRO', '817', '140351', '102', '11597');
INSERT INTO public.who_global_data_import VALUES (24277, '2020-10-05', 'EC', 'Ecuador', 'AMRO', '683', '141034', '50', '11647');
INSERT INTO public.who_global_data_import VALUES (24278, '2020-10-06', 'EC', 'Ecuador', 'AMRO', '305', '141339', '34', '11681');
INSERT INTO public.who_global_data_import VALUES (24279, '2020-10-07', 'EC', 'Ecuador', 'AMRO', '717', '142056', '21', '11702');
INSERT INTO public.who_global_data_import VALUES (24280, '2020-10-08', 'EC', 'Ecuador', 'AMRO', '1475', '143531', '41', '11743');
INSERT INTO public.who_global_data_import VALUES (24281, '2020-10-09', 'EC', 'Ecuador', 'AMRO', '1514', '145045', '398', '12141');
INSERT INTO public.who_global_data_import VALUES (24282, '2020-10-10', 'EC', 'Ecuador', 'AMRO', '0', '145045', '0', '12141');
INSERT INTO public.who_global_data_import VALUES (24283, '2020-10-11', 'EC', 'Ecuador', 'AMRO', '1783', '146828', '47', '12188');
INSERT INTO public.who_global_data_import VALUES (24284, '2020-10-12', 'EC', 'Ecuador', 'AMRO', '0', '146828', '0', '12188');
INSERT INTO public.who_global_data_import VALUES (24285, '2020-10-13', 'EC', 'Ecuador', 'AMRO', '487', '147315', '30', '12218');
INSERT INTO public.who_global_data_import VALUES (24286, '2020-10-14', 'EC', 'Ecuador', 'AMRO', '856', '148171', '17', '12235');
INSERT INTO public.who_global_data_import VALUES (24287, '2020-10-15', 'EC', 'Ecuador', 'AMRO', '912', '149083', '29', '12264');
INSERT INTO public.who_global_data_import VALUES (24288, '2020-10-16', 'EC', 'Ecuador', 'AMRO', '1277', '150360', '42', '12306');
INSERT INTO public.who_global_data_import VALUES (24289, '2020-10-17', 'EC', 'Ecuador', 'AMRO', '1299', '151659', '51', '12357');
INSERT INTO public.who_global_data_import VALUES (24290, '2020-10-18', 'EC', 'Ecuador', 'AMRO', '763', '152422', '18', '12375');
INSERT INTO public.who_global_data_import VALUES (24291, '2020-10-19', 'EC', 'Ecuador', 'AMRO', '867', '153289', '12', '12387');
INSERT INTO public.who_global_data_import VALUES (24292, '2020-10-20', 'EC', 'Ecuador', 'AMRO', '134', '153423', '8', '12395');
INSERT INTO public.who_global_data_import VALUES (24293, '2020-10-21', 'EC', 'Ecuador', 'AMRO', '692', '154115', '9', '12404');
INSERT INTO public.who_global_data_import VALUES (24294, '2020-10-22', 'EC', 'Ecuador', 'AMRO', '1510', '155625', '49', '12453');
INSERT INTO public.who_global_data_import VALUES (24295, '2020-10-23', 'EC', 'Ecuador', 'AMRO', '826', '156451', '47', '12500');
INSERT INTO public.who_global_data_import VALUES (24296, '2020-10-24', 'EC', 'Ecuador', 'AMRO', '0', '156451', '0', '12500');
INSERT INTO public.who_global_data_import VALUES (24297, '2020-10-25', 'EC', 'Ecuador', 'AMRO', '3163', '159614', '42', '12542');
INSERT INTO public.who_global_data_import VALUES (24298, '2020-10-26', 'EC', 'Ecuador', 'AMRO', '2021', '161635', '11', '12553');
INSERT INTO public.who_global_data_import VALUES (24299, '2020-10-27', 'EC', 'Ecuador', 'AMRO', '543', '162178', '20', '12573');
INSERT INTO public.who_global_data_import VALUES (24300, '2020-10-28', 'EC', 'Ecuador', 'AMRO', '1014', '163192', '15', '12588');
INSERT INTO public.who_global_data_import VALUES (24301, '2020-10-29', 'EC', 'Ecuador', 'AMRO', '1716', '164908', '20', '12608');
INSERT INTO public.who_global_data_import VALUES (24302, '2020-10-30', 'EC', 'Ecuador', 'AMRO', '1394', '166302', '14', '12622');
INSERT INTO public.who_global_data_import VALUES (24303, '2020-10-31', 'EC', 'Ecuador', 'AMRO', '845', '167147', '10', '12632');
INSERT INTO public.who_global_data_import VALUES (24304, '2020-11-01', 'EC', 'Ecuador', 'AMRO', '1045', '168192', '38', '12670');
INSERT INTO public.who_global_data_import VALUES (24305, '2020-11-02', 'EC', 'Ecuador', 'AMRO', '1002', '169194', '14', '12684');
INSERT INTO public.who_global_data_import VALUES (24306, '2020-11-03', 'EC', 'Ecuador', 'AMRO', '368', '169562', '8', '12692');
INSERT INTO public.who_global_data_import VALUES (24307, '2020-11-04', 'EC', 'Ecuador', 'AMRO', '548', '170110', '6', '12698');
INSERT INTO public.who_global_data_import VALUES (24308, '2020-11-05', 'EC', 'Ecuador', 'AMRO', '1323', '171433', '6', '12704');
INSERT INTO public.who_global_data_import VALUES (24309, '2020-11-06', 'EC', 'Ecuador', 'AMRO', '350', '171783', '26', '12730');
INSERT INTO public.who_global_data_import VALUES (24310, '2020-11-07', 'EC', 'Ecuador', 'AMRO', '725', '172508', '31', '12761');
INSERT INTO public.who_global_data_import VALUES (24311, '2020-11-08', 'EC', 'Ecuador', 'AMRO', '978', '173486', '54', '12815');
INSERT INTO public.who_global_data_import VALUES (24312, '2020-11-09', 'EC', 'Ecuador', 'AMRO', '1421', '174907', '15', '12830');
INSERT INTO public.who_global_data_import VALUES (24313, '2020-11-10', 'EC', 'Ecuador', 'AMRO', '362', '175269', '9', '12839');
INSERT INTO public.who_global_data_import VALUES (24314, '2020-11-11', 'EC', 'Ecuador', 'AMRO', '442', '175711', '10', '12849');
INSERT INTO public.who_global_data_import VALUES (24315, '2020-11-12', 'EC', 'Ecuador', 'AMRO', '919', '176630', '71', '12920');
INSERT INTO public.who_global_data_import VALUES (24316, '2020-11-13', 'EC', 'Ecuador', 'AMRO', '883', '177513', '26', '12946');
INSERT INTO public.who_global_data_import VALUES (24317, '2020-11-14', 'EC', 'Ecuador', 'AMRO', '1161', '178674', '31', '12977');
INSERT INTO public.who_global_data_import VALUES (24318, '2020-11-15', 'EC', 'Ecuador', 'AMRO', '953', '179627', '20', '12997');
INSERT INTO public.who_global_data_import VALUES (24319, '2020-11-16', 'EC', 'Ecuador', 'AMRO', '668', '180295', '11', '13008');
INSERT INTO public.who_global_data_import VALUES (24320, '2020-11-17', 'EC', 'Ecuador', 'AMRO', '381', '180676', '8', '13016');
INSERT INTO public.who_global_data_import VALUES (24321, '2020-11-18', 'EC', 'Ecuador', 'AMRO', '428', '181104', '9', '13025');
INSERT INTO public.who_global_data_import VALUES (24322, '2020-11-19', 'EC', 'Ecuador', 'AMRO', '1146', '182250', '27', '13052');
INSERT INTO public.who_global_data_import VALUES (24323, '2020-11-20', 'EC', 'Ecuador', 'AMRO', '996', '183246', '21', '13073');
INSERT INTO public.who_global_data_import VALUES (24324, '2020-11-21', 'EC', 'Ecuador', 'AMRO', '594', '183840', '22', '13095');
INSERT INTO public.who_global_data_import VALUES (24325, '2020-11-22', 'EC', 'Ecuador', 'AMRO', '1036', '184876', '44', '13139');
INSERT INTO public.who_global_data_import VALUES (24326, '2020-11-23', 'EC', 'Ecuador', 'AMRO', '767', '185643', '62', '13201');
INSERT INTO public.who_global_data_import VALUES (24327, '2020-11-24', 'EC', 'Ecuador', 'AMRO', '301', '185944', '24', '13225');
INSERT INTO public.who_global_data_import VALUES (24328, '2020-11-25', 'EC', 'Ecuador', 'AMRO', '492', '186436', '39', '13264');
INSERT INTO public.who_global_data_import VALUES (24329, '2020-11-26', 'EC', 'Ecuador', 'AMRO', '794', '187230', '24', '13288');
INSERT INTO public.who_global_data_import VALUES (24330, '2020-11-27', 'EC', 'Ecuador', 'AMRO', '908', '188138', '28', '13316');
INSERT INTO public.who_global_data_import VALUES (24331, '2020-11-28', 'EC', 'Ecuador', 'AMRO', '1396', '189534', '42', '13358');
INSERT INTO public.who_global_data_import VALUES (24332, '2020-11-29', 'EC', 'Ecuador', 'AMRO', '1375', '190909', '13', '13371');
INSERT INTO public.who_global_data_import VALUES (24333, '2020-11-30', 'EC', 'Ecuador', 'AMRO', '1208', '192117', '52', '13423');
INSERT INTO public.who_global_data_import VALUES (24334, '2020-12-01', 'EC', 'Ecuador', 'AMRO', '568', '192685', '38', '13461');
INSERT INTO public.who_global_data_import VALUES (24335, '2020-12-02', 'EC', 'Ecuador', 'AMRO', '988', '193673', '40', '13501');
INSERT INTO public.who_global_data_import VALUES (24336, '2020-12-03', 'EC', 'Ecuador', 'AMRO', '1203', '194876', '61', '13562');
INSERT INTO public.who_global_data_import VALUES (24337, '2020-12-04', 'EC', 'Ecuador', 'AMRO', '1008', '195884', '50', '13612');
INSERT INTO public.who_global_data_import VALUES (24338, '2020-12-05', 'EC', 'Ecuador', 'AMRO', '0', '195884', '0', '13612');
INSERT INTO public.who_global_data_import VALUES (24339, '2020-12-06', 'EC', 'Ecuador', 'AMRO', '1507', '197391', '144', '13756');
INSERT INTO public.who_global_data_import VALUES (24340, '2020-12-07', 'EC', 'Ecuador', 'AMRO', '607', '197998', '22', '13778');
INSERT INTO public.who_global_data_import VALUES (24341, '2020-12-08', 'EC', 'Ecuador', 'AMRO', '246', '198244', '2', '13780');
INSERT INTO public.who_global_data_import VALUES (24342, '2020-12-09', 'EC', 'Ecuador', 'AMRO', '508', '198752', '14', '13794');
INSERT INTO public.who_global_data_import VALUES (24343, '2020-12-10', 'EC', 'Ecuador', 'AMRO', '476', '199228', '20', '13814');
INSERT INTO public.who_global_data_import VALUES (24344, '2020-12-11', 'EC', 'Ecuador', 'AMRO', '1151', '200379', '36', '13850');
INSERT INTO public.who_global_data_import VALUES (24345, '2020-12-12', 'EC', 'Ecuador', 'AMRO', '386', '200765', '8', '13858');
INSERT INTO public.who_global_data_import VALUES (24346, '2020-12-13', 'EC', 'Ecuador', 'AMRO', '759', '201524', '16', '13874');
INSERT INTO public.who_global_data_import VALUES (24347, '2020-12-14', 'EC', 'Ecuador', 'AMRO', '586', '202110', '1', '13875');
INSERT INTO public.who_global_data_import VALUES (24348, '2020-12-15', 'EC', 'Ecuador', 'AMRO', '70', '202180', '0', '13875');
INSERT INTO public.who_global_data_import VALUES (24349, '2020-12-16', 'EC', 'Ecuador', 'AMRO', '176', '202356', '21', '13896');
INSERT INTO public.who_global_data_import VALUES (24350, '2020-12-17', 'EC', 'Ecuador', 'AMRO', '1105', '203461', '19', '13915');
INSERT INTO public.who_global_data_import VALUES (24351, '2020-12-18', 'EC', 'Ecuador', 'AMRO', '788', '204249', '17', '13932');
INSERT INTO public.who_global_data_import VALUES (24352, '2020-12-19', 'EC', 'Ecuador', 'AMRO', '0', '204249', '0', '13932');
INSERT INTO public.who_global_data_import VALUES (24353, '2020-12-20', 'EC', 'Ecuador', 'AMRO', '1671', '205920', '16', '13948');
INSERT INTO public.who_global_data_import VALUES (24354, '2020-12-21', 'EC', 'Ecuador', 'AMRO', '337', '206257', '0', '13948');
INSERT INTO public.who_global_data_import VALUES (24355, '2020-12-22', 'EC', 'Ecuador', 'AMRO', '72', '206329', '1', '13949');
INSERT INTO public.who_global_data_import VALUES (24465, '2020-03-07', 'EG', 'Egypt', 'EMRO', '45', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24356, '2020-12-23', 'EC', 'Ecuador', 'AMRO', '35', '206364', '0', '13949');
INSERT INTO public.who_global_data_import VALUES (24357, '2020-12-24', 'EC', 'Ecuador', 'AMRO', '720', '207084', '13', '13962');
INSERT INTO public.who_global_data_import VALUES (24358, '2020-12-25', 'EC', 'Ecuador', 'AMRO', '926', '208010', '15', '13977');
INSERT INTO public.who_global_data_import VALUES (24359, '2020-12-26', 'EC', 'Ecuador', 'AMRO', '818', '208828', '7', '13984');
INSERT INTO public.who_global_data_import VALUES (24360, '2020-12-27', 'EC', 'Ecuador', 'AMRO', '446', '209274', '6', '13990');
INSERT INTO public.who_global_data_import VALUES (24361, '2020-12-28', 'EC', 'Ecuador', 'AMRO', '81', '209355', '2', '13992');
INSERT INTO public.who_global_data_import VALUES (24362, '2020-12-29', 'EC', 'Ecuador', 'AMRO', '403', '209758', '2', '13994');
INSERT INTO public.who_global_data_import VALUES (24363, '2020-12-30', 'EC', 'Ecuador', 'AMRO', '568', '210326', '7', '14001');
INSERT INTO public.who_global_data_import VALUES (24364, '2020-12-31', 'EC', 'Ecuador', 'AMRO', '1186', '211512', '22', '14023');
INSERT INTO public.who_global_data_import VALUES (24365, '2021-01-01', 'EC', 'Ecuador', 'AMRO', '1000', '212512', '11', '14034');
INSERT INTO public.who_global_data_import VALUES (24366, '2021-01-02', 'EC', 'Ecuador', 'AMRO', '866', '213378', '17', '14051');
INSERT INTO public.who_global_data_import VALUES (24367, '2021-01-03', 'EC', 'Ecuador', 'AMRO', '1135', '214513', '8', '14059');
INSERT INTO public.who_global_data_import VALUES (24368, '2021-01-04', 'EC', 'Ecuador', 'AMRO', '101', '214614', '0', '14059');
INSERT INTO public.who_global_data_import VALUES (24369, '2021-01-05', 'EC', 'Ecuador', 'AMRO', '466', '215080', '10', '14069');
INSERT INTO public.who_global_data_import VALUES (24370, '2021-01-06', 'EC', 'Ecuador', 'AMRO', '1003', '216083', '34', '14103');
INSERT INTO public.who_global_data_import VALUES (24371, '2021-01-07', 'EC', 'Ecuador', 'AMRO', '1294', '217377', '43', '14146');
INSERT INTO public.who_global_data_import VALUES (24372, '2021-01-08', 'EC', 'Ecuador', 'AMRO', '1008', '218385', '12', '14158');
INSERT INTO public.who_global_data_import VALUES (24373, '2021-01-09', 'EC', 'Ecuador', 'AMRO', '763', '219148', '7', '14165');
INSERT INTO public.who_global_data_import VALUES (24374, '2021-01-10', 'EC', 'Ecuador', 'AMRO', '1201', '220349', '12', '14177');
INSERT INTO public.who_global_data_import VALUES (24375, '2021-01-11', 'EC', 'Ecuador', 'AMRO', '721', '221070', '0', '14177');
INSERT INTO public.who_global_data_import VALUES (24376, '2021-01-12', 'EC', 'Ecuador', 'AMRO', '436', '221506', '7', '14184');
INSERT INTO public.who_global_data_import VALUES (24377, '2021-01-13', 'EC', 'Ecuador', 'AMRO', '1061', '222567', '12', '14196');
INSERT INTO public.who_global_data_import VALUES (24378, '2021-01-14', 'EC', 'Ecuador', 'AMRO', '1748', '224315', '33', '14229');
INSERT INTO public.who_global_data_import VALUES (24379, '2021-01-15', 'EC', 'Ecuador', 'AMRO', '1687', '226002', '17', '14246');
INSERT INTO public.who_global_data_import VALUES (24380, '2021-01-16', 'EC', 'Ecuador', 'AMRO', '864', '226866', '27', '14273');
INSERT INTO public.who_global_data_import VALUES (24381, '2021-01-17', 'EC', 'Ecuador', 'AMRO', '3942', '230808', '43', '14316');
INSERT INTO public.who_global_data_import VALUES (24382, '2021-01-18', 'EC', 'Ecuador', 'AMRO', '674', '231482', '3', '14319');
INSERT INTO public.who_global_data_import VALUES (24383, '2021-01-19', 'EC', 'Ecuador', 'AMRO', '162', '231644', '3', '14322');
INSERT INTO public.who_global_data_import VALUES (24384, '2021-01-20', 'EC', 'Ecuador', 'AMRO', '924', '232568', '60', '14382');
INSERT INTO public.who_global_data_import VALUES (24385, '2021-01-21', 'EC', 'Ecuador', 'AMRO', '1747', '234315', '55', '14437');
INSERT INTO public.who_global_data_import VALUES (24386, '2021-01-22', 'EC', 'Ecuador', 'AMRO', '1874', '236189', '89', '14526');
INSERT INTO public.who_global_data_import VALUES (24387, '2021-01-23', 'EC', 'Ecuador', 'AMRO', '969', '237158', '36', '14562');
INSERT INTO public.who_global_data_import VALUES (24388, '2021-01-24', 'EC', 'Ecuador', 'AMRO', '1074', '238232', '34', '14596');
INSERT INTO public.who_global_data_import VALUES (24389, '2021-01-25', 'EC', 'Ecuador', 'AMRO', '3060', '241292', '27', '14623');
INSERT INTO public.who_global_data_import VALUES (24390, '2021-01-26', 'EC', 'Ecuador', 'AMRO', '275', '241567', '16', '14639');
INSERT INTO public.who_global_data_import VALUES (24391, '2021-01-27', 'EC', 'Ecuador', 'AMRO', '579', '242146', '29', '14668');
INSERT INTO public.who_global_data_import VALUES (24392, '2021-01-28', 'EC', 'Ecuador', 'AMRO', '1389', '243535', '36', '14704');
INSERT INTO public.who_global_data_import VALUES (24393, '2021-01-29', 'EC', 'Ecuador', 'AMRO', '2465', '246000', '62', '14766');
INSERT INTO public.who_global_data_import VALUES (24394, '2021-01-30', 'EC', 'Ecuador', 'AMRO', '0', '246000', '0', '14766');
INSERT INTO public.who_global_data_import VALUES (24395, '2021-01-31', 'EC', 'Ecuador', 'AMRO', '3779', '249779', '85', '14851');
INSERT INTO public.who_global_data_import VALUES (24396, '2021-02-01', 'EC', 'Ecuador', 'AMRO', '1049', '250828', '8', '14859');
INSERT INTO public.who_global_data_import VALUES (24397, '2021-02-02', 'EC', 'Ecuador', 'AMRO', '158', '250986', '31', '14890');
INSERT INTO public.who_global_data_import VALUES (24398, '2021-02-03', 'EC', 'Ecuador', 'AMRO', '293', '251279', '25', '14915');
INSERT INTO public.who_global_data_import VALUES (24399, '2021-02-04', 'EC', 'Ecuador', 'AMRO', '1111', '252390', '34', '14949');
INSERT INTO public.who_global_data_import VALUES (24400, '2021-02-05', 'EC', 'Ecuador', 'AMRO', '949', '253339', '19', '14968');
INSERT INTO public.who_global_data_import VALUES (24401, '2020-01-03', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24402, '2020-01-04', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24403, '2020-01-05', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24404, '2020-01-06', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24405, '2020-01-07', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24406, '2020-01-08', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24407, '2020-01-09', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24408, '2020-01-10', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24409, '2020-01-11', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24410, '2020-01-12', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24411, '2020-01-13', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24412, '2020-01-14', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24413, '2020-01-15', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24414, '2020-01-16', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24415, '2020-01-17', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24416, '2020-01-18', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24417, '2020-01-19', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24418, '2020-01-20', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24419, '2020-01-21', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24420, '2020-01-22', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24421, '2020-01-23', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24422, '2020-01-24', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24423, '2020-01-25', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24424, '2020-01-26', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24425, '2020-01-27', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24426, '2020-01-28', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24427, '2020-01-29', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24428, '2020-01-30', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24429, '2020-01-31', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24430, '2020-02-01', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24431, '2020-02-02', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24432, '2020-02-03', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24433, '2020-02-04', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24434, '2020-02-05', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24435, '2020-02-06', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24436, '2020-02-07', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24437, '2020-02-08', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24438, '2020-02-09', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24439, '2020-02-10', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24440, '2020-02-11', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24441, '2020-02-12', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24442, '2020-02-13', 'EG', 'Egypt', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24443, '2020-02-14', 'EG', 'Egypt', 'EMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24444, '2020-02-15', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24445, '2020-02-16', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24446, '2020-02-17', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24447, '2020-02-18', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24448, '2020-02-19', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24449, '2020-02-20', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24450, '2020-02-21', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24451, '2020-02-22', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24452, '2020-02-23', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24453, '2020-02-24', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24454, '2020-02-25', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24455, '2020-02-26', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24456, '2020-02-27', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24457, '2020-02-28', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24458, '2020-02-29', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24459, '2020-03-01', 'EG', 'Egypt', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24460, '2020-03-02', 'EG', 'Egypt', 'EMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24461, '2020-03-03', 'EG', 'Egypt', 'EMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24462, '2020-03-04', 'EG', 'Egypt', 'EMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24463, '2020-03-05', 'EG', 'Egypt', 'EMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24464, '2020-03-06', 'EG', 'Egypt', 'EMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24466, '2020-03-08', 'EG', 'Egypt', 'EMRO', '1', '53', '1', '1');
INSERT INTO public.who_global_data_import VALUES (24467, '2020-03-09', 'EG', 'Egypt', 'EMRO', '10', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (24468, '2020-03-10', 'EG', 'Egypt', 'EMRO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (24469, '2020-03-11', 'EG', 'Egypt', 'EMRO', '8', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (24470, '2020-03-12', 'EG', 'Egypt', 'EMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (24471, '2020-03-13', 'EG', 'Egypt', 'EMRO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (24472, '2020-03-14', 'EG', 'Egypt', 'EMRO', '26', '97', '1', '2');
INSERT INTO public.who_global_data_import VALUES (24473, '2020-03-15', 'EG', 'Egypt', 'EMRO', '17', '114', '0', '2');
INSERT INTO public.who_global_data_import VALUES (24474, '2020-03-16', 'EG', 'Egypt', 'EMRO', '16', '130', '0', '2');
INSERT INTO public.who_global_data_import VALUES (24475, '2020-03-17', 'EG', 'Egypt', 'EMRO', '40', '170', '2', '4');
INSERT INTO public.who_global_data_import VALUES (24476, '2020-03-18', 'EG', 'Egypt', 'EMRO', '30', '200', '2', '6');
INSERT INTO public.who_global_data_import VALUES (24477, '2020-03-19', 'EG', 'Egypt', 'EMRO', '14', '214', '0', '6');
INSERT INTO public.who_global_data_import VALUES (24478, '2020-03-20', 'EG', 'Egypt', 'EMRO', '42', '256', '1', '7');
INSERT INTO public.who_global_data_import VALUES (24479, '2020-03-21', 'EG', 'Egypt', 'EMRO', '29', '285', '1', '8');
INSERT INTO public.who_global_data_import VALUES (24480, '2020-03-22', 'EG', 'Egypt', 'EMRO', '9', '294', '2', '10');
INSERT INTO public.who_global_data_import VALUES (24481, '2020-03-23', 'EG', 'Egypt', 'EMRO', '33', '327', '4', '14');
INSERT INTO public.who_global_data_import VALUES (24482, '2020-03-24', 'EG', 'Egypt', 'EMRO', '39', '366', '5', '19');
INSERT INTO public.who_global_data_import VALUES (24483, '2020-03-25', 'EG', 'Egypt', 'EMRO', '76', '442', '2', '21');
INSERT INTO public.who_global_data_import VALUES (24484, '2020-03-26', 'EG', 'Egypt', 'EMRO', '14', '456', '0', '21');
INSERT INTO public.who_global_data_import VALUES (24485, '2020-03-27', 'EG', 'Egypt', 'EMRO', '39', '495', '3', '24');
INSERT INTO public.who_global_data_import VALUES (24486, '2020-03-28', 'EG', 'Egypt', 'EMRO', '41', '536', '6', '30');
INSERT INTO public.who_global_data_import VALUES (24487, '2020-03-29', 'EG', 'Egypt', 'EMRO', '40', '576', '6', '36');
INSERT INTO public.who_global_data_import VALUES (24488, '2020-03-30', 'EG', 'Egypt', 'EMRO', '33', '609', '4', '40');
INSERT INTO public.who_global_data_import VALUES (24489, '2020-03-31', 'EG', 'Egypt', 'EMRO', '47', '656', '1', '41');
INSERT INTO public.who_global_data_import VALUES (24490, '2020-04-01', 'EG', 'Egypt', 'EMRO', '54', '710', '5', '46');
INSERT INTO public.who_global_data_import VALUES (24491, '2020-04-02', 'EG', 'Egypt', 'EMRO', '69', '779', '6', '52');
INSERT INTO public.who_global_data_import VALUES (24492, '2020-04-03', 'EG', 'Egypt', 'EMRO', '86', '865', '6', '58');
INSERT INTO public.who_global_data_import VALUES (24493, '2020-04-04', 'EG', 'Egypt', 'EMRO', '120', '985', '8', '66');
INSERT INTO public.who_global_data_import VALUES (24494, '2020-04-05', 'EG', 'Egypt', 'EMRO', '85', '1070', '5', '71');
INSERT INTO public.who_global_data_import VALUES (24495, '2020-04-06', 'EG', 'Egypt', 'EMRO', '103', '1173', '7', '78');
INSERT INTO public.who_global_data_import VALUES (24496, '2020-04-07', 'EG', 'Egypt', 'EMRO', '149', '1322', '7', '85');
INSERT INTO public.who_global_data_import VALUES (24497, '2020-04-08', 'EG', 'Egypt', 'EMRO', '128', '1450', '9', '94');
INSERT INTO public.who_global_data_import VALUES (24498, '2020-04-09', 'EG', 'Egypt', 'EMRO', '110', '1560', '9', '103');
INSERT INTO public.who_global_data_import VALUES (24499, '2020-04-10', 'EG', 'Egypt', 'EMRO', '139', '1699', '15', '118');
INSERT INTO public.who_global_data_import VALUES (24500, '2020-04-11', 'EG', 'Egypt', 'EMRO', '95', '1794', '17', '135');
INSERT INTO public.who_global_data_import VALUES (24501, '2020-04-12', 'EG', 'Egypt', 'EMRO', '145', '1939', '11', '146');
INSERT INTO public.who_global_data_import VALUES (24502, '2020-04-13', 'EG', 'Egypt', 'EMRO', '126', '2065', '13', '159');
INSERT INTO public.who_global_data_import VALUES (24503, '2020-04-14', 'EG', 'Egypt', 'EMRO', '125', '2190', '5', '164');
INSERT INTO public.who_global_data_import VALUES (24504, '2020-04-15', 'EG', 'Egypt', 'EMRO', '160', '2350', '14', '178');
INSERT INTO public.who_global_data_import VALUES (24505, '2020-04-16', 'EG', 'Egypt', 'EMRO', '155', '2505', '5', '183');
INSERT INTO public.who_global_data_import VALUES (24506, '2020-04-17', 'EG', 'Egypt', 'EMRO', '168', '2673', '13', '196');
INSERT INTO public.who_global_data_import VALUES (24507, '2020-04-18', 'EG', 'Egypt', 'EMRO', '171', '2844', '9', '205');
INSERT INTO public.who_global_data_import VALUES (24508, '2020-04-19', 'EG', 'Egypt', 'EMRO', '188', '3032', '19', '224');
INSERT INTO public.who_global_data_import VALUES (24509, '2020-04-20', 'EG', 'Egypt', 'EMRO', '112', '3144', '15', '239');
INSERT INTO public.who_global_data_import VALUES (24510, '2020-04-21', 'EG', 'Egypt', 'EMRO', '189', '3333', '11', '250');
INSERT INTO public.who_global_data_import VALUES (24511, '2020-04-22', 'EG', 'Egypt', 'EMRO', '157', '3490', '14', '264');
INSERT INTO public.who_global_data_import VALUES (24512, '2020-04-23', 'EG', 'Egypt', 'EMRO', '169', '3659', '12', '276');
INSERT INTO public.who_global_data_import VALUES (24513, '2020-04-24', 'EG', 'Egypt', 'EMRO', '433', '4092', '18', '294');
INSERT INTO public.who_global_data_import VALUES (24514, '2020-04-25', 'EG', 'Egypt', 'EMRO', '0', '4092', '0', '294');
INSERT INTO public.who_global_data_import VALUES (24515, '2020-04-26', 'EG', 'Egypt', 'EMRO', '227', '4319', '13', '307');
INSERT INTO public.who_global_data_import VALUES (24516, '2020-04-27', 'EG', 'Egypt', 'EMRO', '463', '4782', '30', '337');
INSERT INTO public.who_global_data_import VALUES (24517, '2020-04-28', 'EG', 'Egypt', 'EMRO', '260', '5042', '22', '359');
INSERT INTO public.who_global_data_import VALUES (24518, '2020-04-29', 'EG', 'Egypt', 'EMRO', '226', '5268', '21', '380');
INSERT INTO public.who_global_data_import VALUES (24519, '2020-04-30', 'EG', 'Egypt', 'EMRO', '269', '5537', '12', '392');
INSERT INTO public.who_global_data_import VALUES (24520, '2020-05-01', 'EG', 'Egypt', 'EMRO', '358', '5895', '14', '406');
INSERT INTO public.who_global_data_import VALUES (24521, '2020-05-02', 'EG', 'Egypt', 'EMRO', '0', '5895', '0', '406');
INSERT INTO public.who_global_data_import VALUES (24522, '2020-05-03', 'EG', 'Egypt', 'EMRO', '298', '6193', '9', '415');
INSERT INTO public.who_global_data_import VALUES (24523, '2020-05-04', 'EG', 'Egypt', 'EMRO', '272', '6465', '14', '429');
INSERT INTO public.who_global_data_import VALUES (24524, '2020-05-05', 'EG', 'Egypt', 'EMRO', '736', '7201', '23', '452');
INSERT INTO public.who_global_data_import VALUES (24525, '2020-05-06', 'EG', 'Egypt', 'EMRO', '387', '7588', '17', '469');
INSERT INTO public.who_global_data_import VALUES (24526, '2020-05-07', 'EG', 'Egypt', 'EMRO', '0', '7588', '0', '469');
INSERT INTO public.who_global_data_import VALUES (24527, '2020-05-08', 'EG', 'Egypt', 'EMRO', '393', '7981', '13', '482');
INSERT INTO public.who_global_data_import VALUES (24528, '2020-05-09', 'EG', 'Egypt', 'EMRO', '495', '8476', '21', '503');
INSERT INTO public.who_global_data_import VALUES (24529, '2020-05-10', 'EG', 'Egypt', 'EMRO', '924', '9400', '22', '525');
INSERT INTO public.who_global_data_import VALUES (24530, '2020-05-11', 'EG', 'Egypt', 'EMRO', '346', '9746', '8', '533');
INSERT INTO public.who_global_data_import VALUES (24531, '2020-05-12', 'EG', 'Egypt', 'EMRO', '0', '9746', '0', '533');
INSERT INTO public.who_global_data_import VALUES (24532, '2020-05-13', 'EG', 'Egypt', 'EMRO', '685', '10431', '23', '556');
INSERT INTO public.who_global_data_import VALUES (24533, '2020-05-14', 'EG', 'Egypt', 'EMRO', '398', '10829', '15', '571');
INSERT INTO public.who_global_data_import VALUES (24534, '2020-05-15', 'EG', 'Egypt', 'EMRO', '0', '10829', '0', '571');
INSERT INTO public.who_global_data_import VALUES (24535, '2020-05-16', 'EG', 'Egypt', 'EMRO', '399', '11228', '21', '592');
INSERT INTO public.who_global_data_import VALUES (24536, '2020-05-17', 'EG', 'Egypt', 'EMRO', '491', '11719', '20', '612');
INSERT INTO public.who_global_data_import VALUES (24537, '2020-05-18', 'EG', 'Egypt', 'EMRO', '510', '12229', '18', '630');
INSERT INTO public.who_global_data_import VALUES (24538, '2020-05-19', 'EG', 'Egypt', 'EMRO', '535', '12764', '15', '645');
INSERT INTO public.who_global_data_import VALUES (24539, '2020-05-20', 'EG', 'Egypt', 'EMRO', '1465', '14229', '35', '680');
INSERT INTO public.who_global_data_import VALUES (24540, '2020-05-21', 'EG', 'Egypt', 'EMRO', '0', '14229', '0', '680');
INSERT INTO public.who_global_data_import VALUES (24541, '2020-05-22', 'EG', 'Egypt', 'EMRO', '774', '15003', '16', '696');
INSERT INTO public.who_global_data_import VALUES (24542, '2020-05-23', 'EG', 'Egypt', 'EMRO', '783', '15786', '11', '707');
INSERT INTO public.who_global_data_import VALUES (24543, '2020-05-24', 'EG', 'Egypt', 'EMRO', '727', '16513', '28', '735');
INSERT INTO public.who_global_data_import VALUES (24544, '2020-05-25', 'EG', 'Egypt', 'EMRO', '752', '17265', '29', '764');
INSERT INTO public.who_global_data_import VALUES (24545, '2020-05-26', 'EG', 'Egypt', 'EMRO', '702', '17967', '19', '783');
INSERT INTO public.who_global_data_import VALUES (24546, '2020-05-27', 'EG', 'Egypt', 'EMRO', '789', '18756', '14', '797');
INSERT INTO public.who_global_data_import VALUES (24547, '2020-05-28', 'EG', 'Egypt', 'EMRO', '910', '19666', '19', '816');
INSERT INTO public.who_global_data_import VALUES (24548, '2020-05-29', 'EG', 'Egypt', 'EMRO', '1127', '20793', '29', '845');
INSERT INTO public.who_global_data_import VALUES (24549, '2020-05-30', 'EG', 'Egypt', 'EMRO', '1289', '22082', '34', '879');
INSERT INTO public.who_global_data_import VALUES (24550, '2020-05-31', 'EG', 'Egypt', 'EMRO', '1367', '23449', '34', '913');
INSERT INTO public.who_global_data_import VALUES (24551, '2020-06-01', 'EG', 'Egypt', 'EMRO', '1536', '24985', '46', '959');
INSERT INTO public.who_global_data_import VALUES (24552, '2020-06-02', 'EG', 'Egypt', 'EMRO', '1399', '26384', '46', '1005');
INSERT INTO public.who_global_data_import VALUES (24553, '2020-06-03', 'EG', 'Egypt', 'EMRO', '1152', '27536', '47', '1052');
INSERT INTO public.who_global_data_import VALUES (24554, '2020-06-04', 'EG', 'Egypt', 'EMRO', '1079', '28615', '36', '1088');
INSERT INTO public.who_global_data_import VALUES (24555, '2020-06-05', 'EG', 'Egypt', 'EMRO', '1152', '29767', '38', '1126');
INSERT INTO public.who_global_data_import VALUES (24556, '2020-06-06', 'EG', 'Egypt', 'EMRO', '1348', '31115', '40', '1166');
INSERT INTO public.who_global_data_import VALUES (24557, '2020-06-07', 'EG', 'Egypt', 'EMRO', '1497', '32612', '32', '1198');
INSERT INTO public.who_global_data_import VALUES (24558, '2020-06-08', 'EG', 'Egypt', 'EMRO', '1467', '34079', '39', '1237');
INSERT INTO public.who_global_data_import VALUES (24559, '2020-06-09', 'EG', 'Egypt', 'EMRO', '1365', '35444', '34', '1271');
INSERT INTO public.who_global_data_import VALUES (24560, '2020-06-10', 'EG', 'Egypt', 'EMRO', '1385', '36829', '35', '1306');
INSERT INTO public.who_global_data_import VALUES (24561, '2020-06-11', 'EG', 'Egypt', 'EMRO', '1455', '38284', '36', '1342');
INSERT INTO public.who_global_data_import VALUES (24562, '2020-06-12', 'EG', 'Egypt', 'EMRO', '1442', '39726', '35', '1377');
INSERT INTO public.who_global_data_import VALUES (24563, '2020-06-13', 'EG', 'Egypt', 'EMRO', '1577', '41303', '45', '1422');
INSERT INTO public.who_global_data_import VALUES (24564, '2020-06-14', 'EG', 'Egypt', 'EMRO', '1677', '42980', '62', '1484');
INSERT INTO public.who_global_data_import VALUES (24565, '2020-06-15', 'EG', 'Egypt', 'EMRO', '1618', '44598', '91', '1575');
INSERT INTO public.who_global_data_import VALUES (24566, '2020-06-16', 'EG', 'Egypt', 'EMRO', '1691', '46289', '97', '1672');
INSERT INTO public.who_global_data_import VALUES (24567, '2020-06-17', 'EG', 'Egypt', 'EMRO', '1567', '47856', '94', '1766');
INSERT INTO public.who_global_data_import VALUES (24568, '2020-06-18', 'EG', 'Egypt', 'EMRO', '1363', '49219', '84', '1850');
INSERT INTO public.who_global_data_import VALUES (24569, '2020-06-19', 'EG', 'Egypt', 'EMRO', '1218', '50437', '88', '1938');
INSERT INTO public.who_global_data_import VALUES (24570, '2020-06-20', 'EG', 'Egypt', 'EMRO', '1774', '52211', '79', '2017');
INSERT INTO public.who_global_data_import VALUES (24571, '2020-06-21', 'EG', 'Egypt', 'EMRO', '1547', '53758', '89', '2106');
INSERT INTO public.who_global_data_import VALUES (24572, '2020-06-22', 'EG', 'Egypt', 'EMRO', '1475', '55233', '87', '2193');
INSERT INTO public.who_global_data_import VALUES (24573, '2020-06-23', 'EG', 'Egypt', 'EMRO', '1576', '56809', '85', '2278');
INSERT INTO public.who_global_data_import VALUES (24574, '2020-06-24', 'EG', 'Egypt', 'EMRO', '1332', '58141', '87', '2365');
INSERT INTO public.who_global_data_import VALUES (24575, '2020-06-25', 'EG', 'Egypt', 'EMRO', '1420', '59561', '85', '2450');
INSERT INTO public.who_global_data_import VALUES (24576, '2020-06-26', 'EG', 'Egypt', 'EMRO', '1569', '61130', '83', '2533');
INSERT INTO public.who_global_data_import VALUES (24577, '2020-06-27', 'EG', 'Egypt', 'EMRO', '1625', '62755', '87', '2620');
INSERT INTO public.who_global_data_import VALUES (24578, '2020-06-28', 'EG', 'Egypt', 'EMRO', '1168', '63923', '88', '2708');
INSERT INTO public.who_global_data_import VALUES (24579, '2020-06-29', 'EG', 'Egypt', 'EMRO', '1265', '65188', '81', '2789');
INSERT INTO public.who_global_data_import VALUES (24580, '2020-06-30', 'EG', 'Egypt', 'EMRO', '1566', '66754', '83', '2872');
INSERT INTO public.who_global_data_import VALUES (24581, '2020-07-01', 'EG', 'Egypt', 'EMRO', '1557', '68311', '81', '2953');
INSERT INTO public.who_global_data_import VALUES (24582, '2020-07-02', 'EG', 'Egypt', 'EMRO', '1503', '69814', '81', '3034');
INSERT INTO public.who_global_data_import VALUES (24583, '2020-07-03', 'EG', 'Egypt', 'EMRO', '1485', '71299', '86', '3120');
INSERT INTO public.who_global_data_import VALUES (24584, '2020-07-04', 'EG', 'Egypt', 'EMRO', '1412', '72711', '81', '3201');
INSERT INTO public.who_global_data_import VALUES (24585, '2020-07-05', 'EG', 'Egypt', 'EMRO', '1324', '74035', '79', '3280');
INSERT INTO public.who_global_data_import VALUES (24586, '2020-07-06', 'EG', 'Egypt', 'EMRO', '1218', '75253', '63', '3343');
INSERT INTO public.who_global_data_import VALUES (24587, '2020-07-07', 'EG', 'Egypt', 'EMRO', '969', '76222', '79', '3422');
INSERT INTO public.who_global_data_import VALUES (24588, '2020-07-08', 'EG', 'Egypt', 'EMRO', '1057', '77279', '67', '3489');
INSERT INTO public.who_global_data_import VALUES (24589, '2020-07-09', 'EG', 'Egypt', 'EMRO', '1025', '78304', '75', '3564');
INSERT INTO public.who_global_data_import VALUES (24590, '2020-07-10', 'EG', 'Egypt', 'EMRO', '950', '79254', '53', '3617');
INSERT INTO public.who_global_data_import VALUES (24591, '2020-07-11', 'EG', 'Egypt', 'EMRO', '981', '80235', '85', '3702');
INSERT INTO public.who_global_data_import VALUES (24592, '2020-07-12', 'EG', 'Egypt', 'EMRO', '923', '81158', '67', '3769');
INSERT INTO public.who_global_data_import VALUES (24593, '2020-07-13', 'EG', 'Egypt', 'EMRO', '912', '82070', '89', '3858');
INSERT INTO public.who_global_data_import VALUES (24594, '2020-07-14', 'EG', 'Egypt', 'EMRO', '931', '83001', '77', '3935');
INSERT INTO public.who_global_data_import VALUES (24595, '2020-07-15', 'EG', 'Egypt', 'EMRO', '929', '83930', '73', '4008');
INSERT INTO public.who_global_data_import VALUES (24596, '2020-07-16', 'EG', 'Egypt', 'EMRO', '913', '84843', '59', '4067');
INSERT INTO public.who_global_data_import VALUES (24597, '2020-07-17', 'EG', 'Egypt', 'EMRO', '928', '85771', '53', '4120');
INSERT INTO public.who_global_data_import VALUES (24598, '2020-07-18', 'EG', 'Egypt', 'EMRO', '703', '86474', '68', '4188');
INSERT INTO public.who_global_data_import VALUES (24599, '2020-07-19', 'EG', 'Egypt', 'EMRO', '698', '87172', '63', '4251');
INSERT INTO public.who_global_data_import VALUES (24600, '2020-07-20', 'EG', 'Egypt', 'EMRO', '603', '87775', '51', '4302');
INSERT INTO public.who_global_data_import VALUES (24601, '2020-07-21', 'EG', 'Egypt', 'EMRO', '627', '88402', '50', '4352');
INSERT INTO public.who_global_data_import VALUES (24602, '2020-07-22', 'EG', 'Egypt', 'EMRO', '676', '89078', '47', '4399');
INSERT INTO public.who_global_data_import VALUES (24603, '2020-07-23', 'EG', 'Egypt', 'EMRO', '667', '89745', '41', '4440');
INSERT INTO public.who_global_data_import VALUES (24604, '2020-07-24', 'EG', 'Egypt', 'EMRO', '668', '90413', '40', '4480');
INSERT INTO public.who_global_data_import VALUES (24605, '2020-07-25', 'EG', 'Egypt', 'EMRO', '659', '91072', '38', '4518');
INSERT INTO public.who_global_data_import VALUES (24606, '2020-07-26', 'EG', 'Egypt', 'EMRO', '511', '91583', '40', '4558');
INSERT INTO public.who_global_data_import VALUES (24607, '2020-07-27', 'EG', 'Egypt', 'EMRO', '479', '92062', '48', '4606');
INSERT INTO public.who_global_data_import VALUES (24608, '2020-07-28', 'EG', 'Egypt', 'EMRO', '420', '92482', '46', '4652');
INSERT INTO public.who_global_data_import VALUES (24609, '2020-07-29', 'EG', 'Egypt', 'EMRO', '465', '92947', '39', '4691');
INSERT INTO public.who_global_data_import VALUES (24610, '2020-07-30', 'EG', 'Egypt', 'EMRO', '409', '93356', '37', '4728');
INSERT INTO public.who_global_data_import VALUES (24611, '2020-07-31', 'EG', 'Egypt', 'EMRO', '401', '93757', '46', '4774');
INSERT INTO public.who_global_data_import VALUES (24612, '2020-08-01', 'EG', 'Egypt', 'EMRO', '321', '94078', '31', '4805');
INSERT INTO public.who_global_data_import VALUES (24613, '2020-08-02', 'EG', 'Egypt', 'EMRO', '238', '94316', '29', '4834');
INSERT INTO public.who_global_data_import VALUES (24614, '2020-08-03', 'EG', 'Egypt', 'EMRO', '167', '94483', '31', '4865');
INSERT INTO public.who_global_data_import VALUES (24615, '2020-08-04', 'EG', 'Egypt', 'EMRO', '157', '94640', '23', '4888');
INSERT INTO public.who_global_data_import VALUES (24616, '2020-08-05', 'EG', 'Egypt', 'EMRO', '112', '94752', '24', '4912');
INSERT INTO public.who_global_data_import VALUES (24617, '2020-08-06', 'EG', 'Egypt', 'EMRO', '123', '94875', '18', '4930');
INSERT INTO public.who_global_data_import VALUES (24618, '2020-08-07', 'EG', 'Egypt', 'EMRO', '131', '95006', '21', '4951');
INSERT INTO public.who_global_data_import VALUES (24619, '2020-08-08', 'EG', 'Egypt', 'EMRO', '141', '95147', '20', '4971');
INSERT INTO public.who_global_data_import VALUES (24620, '2020-08-09', 'EG', 'Egypt', 'EMRO', '167', '95314', '21', '4992');
INSERT INTO public.who_global_data_import VALUES (24621, '2020-08-10', 'EG', 'Egypt', 'EMRO', '178', '95492', '17', '5009');
INSERT INTO public.who_global_data_import VALUES (24622, '2020-08-11', 'EG', 'Egypt', 'EMRO', '174', '95666', '26', '5035');
INSERT INTO public.who_global_data_import VALUES (24623, '2020-08-12', 'EG', 'Egypt', 'EMRO', '168', '95834', '24', '5059');
INSERT INTO public.who_global_data_import VALUES (24624, '2020-08-13', 'EG', 'Egypt', 'EMRO', '129', '95963', '26', '5085');
INSERT INTO public.who_global_data_import VALUES (24625, '2020-08-14', 'EG', 'Egypt', 'EMRO', '145', '96108', '22', '5107');
INSERT INTO public.who_global_data_import VALUES (24626, '2020-08-15', 'EG', 'Egypt', 'EMRO', '112', '96220', '17', '5124');
INSERT INTO public.who_global_data_import VALUES (24627, '2020-08-16', 'EG', 'Egypt', 'EMRO', '116', '96336', '17', '5141');
INSERT INTO public.who_global_data_import VALUES (24628, '2020-08-17', 'EG', 'Egypt', 'EMRO', '139', '96475', '19', '5160');
INSERT INTO public.who_global_data_import VALUES (24629, '2020-08-18', 'EG', 'Egypt', 'EMRO', '115', '96590', '13', '5173');
INSERT INTO public.who_global_data_import VALUES (24630, '2020-08-19', 'EG', 'Egypt', 'EMRO', '163', '96753', '11', '5184');
INSERT INTO public.who_global_data_import VALUES (24631, '2020-08-20', 'EG', 'Egypt', 'EMRO', '161', '96914', '13', '5197');
INSERT INTO public.who_global_data_import VALUES (24632, '2020-08-21', 'EG', 'Egypt', 'EMRO', '111', '97025', '15', '5212');
INSERT INTO public.who_global_data_import VALUES (24633, '2020-08-22', 'EG', 'Egypt', 'EMRO', '123', '97148', '19', '5231');
INSERT INTO public.who_global_data_import VALUES (24634, '2020-08-23', 'EG', 'Egypt', 'EMRO', '89', '97237', '12', '5243');
INSERT INTO public.who_global_data_import VALUES (24635, '2020-08-24', 'EG', 'Egypt', 'EMRO', '103', '97340', '19', '5262');
INSERT INTO public.who_global_data_import VALUES (24636, '2020-08-25', 'EG', 'Egypt', 'EMRO', '138', '97478', '18', '5280');
INSERT INTO public.who_global_data_import VALUES (24637, '2020-08-26', 'EG', 'Egypt', 'EMRO', '141', '97619', '18', '5298');
INSERT INTO public.who_global_data_import VALUES (24638, '2020-08-27', 'EG', 'Egypt', 'EMRO', '206', '97825', '19', '5317');
INSERT INTO public.who_global_data_import VALUES (24639, '2020-08-28', 'EG', 'Egypt', 'EMRO', '237', '98062', '25', '5342');
INSERT INTO public.who_global_data_import VALUES (24640, '2020-08-29', 'EG', 'Egypt', 'EMRO', '223', '98285', '20', '5362');
INSERT INTO public.who_global_data_import VALUES (24641, '2020-08-30', 'EG', 'Egypt', 'EMRO', '212', '98497', '14', '5376');
INSERT INTO public.who_global_data_import VALUES (24642, '2020-08-31', 'EG', 'Egypt', 'EMRO', '230', '98727', '23', '5399');
INSERT INTO public.who_global_data_import VALUES (24643, '2020-09-01', 'EG', 'Egypt', 'EMRO', '212', '98939', '22', '5421');
INSERT INTO public.who_global_data_import VALUES (24644, '2020-09-02', 'EG', 'Egypt', 'EMRO', '176', '99115', '19', '5440');
INSERT INTO public.who_global_data_import VALUES (24645, '2020-09-03', 'EG', 'Egypt', 'EMRO', '165', '99280', '21', '5461');
INSERT INTO public.who_global_data_import VALUES (24646, '2020-09-04', 'EG', 'Egypt', 'EMRO', '145', '99425', '18', '5479');
INSERT INTO public.who_global_data_import VALUES (24647, '2020-09-05', 'EG', 'Egypt', 'EMRO', '157', '99582', '16', '5495');
INSERT INTO public.who_global_data_import VALUES (24648, '2020-09-06', 'EG', 'Egypt', 'EMRO', '130', '99712', '16', '5511');
INSERT INTO public.who_global_data_import VALUES (24649, '2020-09-07', 'EG', 'Egypt', 'EMRO', '151', '99863', '19', '5530');
INSERT INTO public.who_global_data_import VALUES (24650, '2020-09-08', 'EG', 'Egypt', 'EMRO', '178', '100041', '11', '5541');
INSERT INTO public.who_global_data_import VALUES (24651, '2020-09-09', 'EG', 'Egypt', 'EMRO', '187', '100228', '19', '5560');
INSERT INTO public.who_global_data_import VALUES (24652, '2020-09-10', 'EG', 'Egypt', 'EMRO', '175', '100403', '17', '5577');
INSERT INTO public.who_global_data_import VALUES (24653, '2020-09-11', 'EG', 'Egypt', 'EMRO', '154', '100557', '13', '5590');
INSERT INTO public.who_global_data_import VALUES (24654, '2020-09-12', 'EG', 'Egypt', 'EMRO', '151', '100708', '17', '5607');
INSERT INTO public.who_global_data_import VALUES (24655, '2020-09-13', 'EG', 'Egypt', 'EMRO', '148', '100856', '20', '5627');
INSERT INTO public.who_global_data_import VALUES (24656, '2020-09-14', 'EG', 'Egypt', 'EMRO', '153', '101009', '21', '5648');
INSERT INTO public.who_global_data_import VALUES (24657, '2020-09-15', 'EG', 'Egypt', 'EMRO', '168', '101177', '13', '5661');
INSERT INTO public.who_global_data_import VALUES (24658, '2020-09-16', 'EG', 'Egypt', 'EMRO', '163', '101340', '18', '5679');
INSERT INTO public.who_global_data_import VALUES (24659, '2020-09-17', 'EG', 'Egypt', 'EMRO', '160', '101500', '17', '5696');
INSERT INTO public.who_global_data_import VALUES (24660, '2020-09-18', 'EG', 'Egypt', 'EMRO', '141', '101641', '19', '5715');
INSERT INTO public.who_global_data_import VALUES (24661, '2020-09-19', 'EG', 'Egypt', 'EMRO', '131', '101772', '18', '5733');
INSERT INTO public.who_global_data_import VALUES (24662, '2020-09-20', 'EG', 'Egypt', 'EMRO', '128', '101900', '17', '5750');
INSERT INTO public.who_global_data_import VALUES (24663, '2020-09-21', 'EG', 'Egypt', 'EMRO', '115', '102015', '20', '5770');
INSERT INTO public.who_global_data_import VALUES (24664, '2020-09-22', 'EG', 'Egypt', 'EMRO', '126', '102141', '17', '5787');
INSERT INTO public.who_global_data_import VALUES (24665, '2020-09-23', 'EG', 'Egypt', 'EMRO', '113', '102254', '19', '5806');
INSERT INTO public.who_global_data_import VALUES (24666, '2020-09-24', 'EG', 'Egypt', 'EMRO', '121', '102375', '16', '5822');
INSERT INTO public.who_global_data_import VALUES (24667, '2020-09-25', 'EG', 'Egypt', 'EMRO', '138', '102513', '13', '5835');
INSERT INTO public.who_global_data_import VALUES (24668, '2020-09-26', 'EG', 'Egypt', 'EMRO', '112', '102625', '18', '5853');
INSERT INTO public.who_global_data_import VALUES (24669, '2020-09-27', 'EG', 'Egypt', 'EMRO', '111', '102736', '16', '5869');
INSERT INTO public.who_global_data_import VALUES (24670, '2020-09-28', 'EG', 'Egypt', 'EMRO', '104', '102840', '14', '5883');
INSERT INTO public.who_global_data_import VALUES (24671, '2020-09-29', 'EG', 'Egypt', 'EMRO', '115', '102955', '18', '5901');
INSERT INTO public.who_global_data_import VALUES (24672, '2020-09-30', 'EG', 'Egypt', 'EMRO', '124', '103079', '13', '5914');
INSERT INTO public.who_global_data_import VALUES (24673, '2020-10-01', 'EG', 'Egypt', 'EMRO', '119', '103198', '16', '5930');
INSERT INTO public.who_global_data_import VALUES (24674, '2020-10-02', 'EG', 'Egypt', 'EMRO', '119', '103317', '16', '5946');
INSERT INTO public.who_global_data_import VALUES (24675, '2020-10-03', 'EG', 'Egypt', 'EMRO', '149', '103466', '10', '5956');
INSERT INTO public.who_global_data_import VALUES (24676, '2020-10-04', 'EG', 'Egypt', 'EMRO', '109', '103575', '14', '5970');
INSERT INTO public.who_global_data_import VALUES (24677, '2020-10-05', 'EG', 'Egypt', 'EMRO', '108', '103683', '11', '5981');
INSERT INTO public.who_global_data_import VALUES (24678, '2020-10-06', 'EG', 'Egypt', 'EMRO', '98', '103781', '9', '5990');
INSERT INTO public.who_global_data_import VALUES (24679, '2020-10-07', 'EG', 'Egypt', 'EMRO', '121', '103902', '11', '6001');
INSERT INTO public.who_global_data_import VALUES (24680, '2020-10-08', 'EG', 'Egypt', 'EMRO', '133', '104035', '9', '6010');
INSERT INTO public.who_global_data_import VALUES (24681, '2020-10-09', 'EG', 'Egypt', 'EMRO', '121', '104156', '7', '6017');
INSERT INTO public.who_global_data_import VALUES (24682, '2020-10-10', 'EG', 'Egypt', 'EMRO', '106', '104262', '12', '6029');
INSERT INTO public.who_global_data_import VALUES (24683, '2020-10-11', 'EG', 'Egypt', 'EMRO', '125', '104387', '11', '6040');
INSERT INTO public.who_global_data_import VALUES (24684, '2020-10-12', 'EG', 'Egypt', 'EMRO', '129', '104516', '12', '6052');
INSERT INTO public.who_global_data_import VALUES (24685, '2020-10-13', 'EG', 'Egypt', 'EMRO', '132', '104648', '10', '6062');
INSERT INTO public.who_global_data_import VALUES (24686, '2020-10-14', 'EG', 'Egypt', 'EMRO', '139', '104787', '9', '6071');
INSERT INTO public.who_global_data_import VALUES (24687, '2020-10-15', 'EG', 'Egypt', 'EMRO', '128', '104915', '6', '6077');
INSERT INTO public.who_global_data_import VALUES (24688, '2020-10-16', 'EG', 'Egypt', 'EMRO', '118', '105033', '11', '6088');
INSERT INTO public.who_global_data_import VALUES (24689, '2020-10-17', 'EG', 'Egypt', 'EMRO', '126', '105159', '11', '6099');
INSERT INTO public.who_global_data_import VALUES (24690, '2020-10-18', 'EG', 'Egypt', 'EMRO', '138', '105297', '10', '6109');
INSERT INTO public.who_global_data_import VALUES (24691, '2020-10-19', 'EG', 'Egypt', 'EMRO', '127', '105424', '11', '6120');
INSERT INTO public.who_global_data_import VALUES (24692, '2020-10-20', 'EG', 'Egypt', 'EMRO', '123', '105547', '10', '6130');
INSERT INTO public.who_global_data_import VALUES (24693, '2020-10-21', 'EG', 'Egypt', 'EMRO', '158', '105705', '12', '6142');
INSERT INTO public.who_global_data_import VALUES (24694, '2020-10-22', 'EG', 'Egypt', 'EMRO', '178', '105883', '13', '6155');
INSERT INTO public.who_global_data_import VALUES (24695, '2020-10-23', 'EG', 'Egypt', 'EMRO', '177', '106060', '11', '6166');
INSERT INTO public.who_global_data_import VALUES (24696, '2020-10-24', 'EG', 'Egypt', 'EMRO', '170', '106230', '10', '6176');
INSERT INTO public.who_global_data_import VALUES (24697, '2020-10-25', 'EG', 'Egypt', 'EMRO', '167', '106397', '11', '6187');
INSERT INTO public.who_global_data_import VALUES (24698, '2020-10-26', 'EG', 'Egypt', 'EMRO', '143', '106540', '12', '6199');
INSERT INTO public.who_global_data_import VALUES (24699, '2020-10-27', 'EG', 'Egypt', 'EMRO', '167', '106707', '12', '6211');
INSERT INTO public.who_global_data_import VALUES (24700, '2020-10-28', 'EG', 'Egypt', 'EMRO', '170', '106877', '11', '6222');
INSERT INTO public.who_global_data_import VALUES (24701, '2020-10-29', 'EG', 'Egypt', 'EMRO', '153', '107030', '12', '6234');
INSERT INTO public.who_global_data_import VALUES (24702, '2020-10-30', 'EG', 'Egypt', 'EMRO', '179', '107209', '13', '6247');
INSERT INTO public.who_global_data_import VALUES (24703, '2020-10-31', 'EG', 'Egypt', 'EMRO', '176', '107385', '11', '6258');
INSERT INTO public.who_global_data_import VALUES (24704, '2020-11-01', 'EG', 'Egypt', 'EMRO', '170', '107555', '8', '6266');
INSERT INTO public.who_global_data_import VALUES (24705, '2020-11-02', 'EG', 'Egypt', 'EMRO', '181', '107736', '12', '6278');
INSERT INTO public.who_global_data_import VALUES (24706, '2020-11-03', 'EG', 'Egypt', 'EMRO', '189', '107925', '13', '6291');
INSERT INTO public.who_global_data_import VALUES (24707, '2020-11-04', 'EG', 'Egypt', 'EMRO', '197', '108122', '14', '6305');
INSERT INTO public.who_global_data_import VALUES (24708, '2020-11-05', 'EG', 'Egypt', 'EMRO', '207', '108329', '13', '6318');
INSERT INTO public.who_global_data_import VALUES (24709, '2020-11-06', 'EG', 'Egypt', 'EMRO', '201', '108530', '11', '6329');
INSERT INTO public.who_global_data_import VALUES (24710, '2020-11-07', 'EG', 'Egypt', 'EMRO', '224', '108754', '14', '6343');
INSERT INTO public.who_global_data_import VALUES (24711, '2020-11-08', 'EG', 'Egypt', 'EMRO', '208', '108962', '12', '6355');
INSERT INTO public.who_global_data_import VALUES (24712, '2020-11-09', 'EG', 'Egypt', 'EMRO', '239', '109201', '13', '6368');
INSERT INTO public.who_global_data_import VALUES (24713, '2020-11-10', 'EG', 'Egypt', 'EMRO', '221', '109422', '12', '6380');
INSERT INTO public.who_global_data_import VALUES (24714, '2020-11-11', 'EG', 'Egypt', 'EMRO', '232', '109654', '14', '6394');
INSERT INTO public.who_global_data_import VALUES (24715, '2020-11-12', 'EG', 'Egypt', 'EMRO', '227', '109881', '11', '6405');
INSERT INTO public.who_global_data_import VALUES (24716, '2020-11-13', 'EG', 'Egypt', 'EMRO', '214', '110095', '12', '6417');
INSERT INTO public.who_global_data_import VALUES (24717, '2020-11-14', 'EG', 'Egypt', 'EMRO', '224', '110319', '12', '6429');
INSERT INTO public.who_global_data_import VALUES (24718, '2020-11-15', 'EG', 'Egypt', 'EMRO', '228', '110547', '13', '6442');
INSERT INTO public.who_global_data_import VALUES (24719, '2020-11-16', 'EG', 'Egypt', 'EMRO', '220', '110767', '11', '6453');
INSERT INTO public.who_global_data_import VALUES (24720, '2020-11-17', 'EG', 'Egypt', 'EMRO', '242', '111009', '12', '6465');
INSERT INTO public.who_global_data_import VALUES (24721, '2020-11-18', 'EG', 'Egypt', 'EMRO', '275', '111284', '16', '6481');
INSERT INTO public.who_global_data_import VALUES (24722, '2020-11-19', 'EG', 'Egypt', 'EMRO', '329', '111613', '14', '6495');
INSERT INTO public.who_global_data_import VALUES (24723, '2020-11-20', 'EG', 'Egypt', 'EMRO', '342', '111955', '13', '6508');
INSERT INTO public.who_global_data_import VALUES (24724, '2020-11-21', 'EG', 'Egypt', 'EMRO', '363', '112318', '13', '6521');
INSERT INTO public.who_global_data_import VALUES (24725, '2020-11-22', 'EG', 'Egypt', 'EMRO', '358', '112676', '14', '6535');
INSERT INTO public.who_global_data_import VALUES (24726, '2020-11-23', 'EG', 'Egypt', 'EMRO', '351', '113027', '13', '6548');
INSERT INTO public.who_global_data_import VALUES (24727, '2020-11-24', 'EG', 'Egypt', 'EMRO', '354', '113381', '12', '6560');
INSERT INTO public.who_global_data_import VALUES (24728, '2020-11-25', 'EG', 'Egypt', 'EMRO', '361', '113742', '13', '6573');
INSERT INTO public.who_global_data_import VALUES (24729, '2020-11-26', 'EG', 'Egypt', 'EMRO', '365', '114107', '12', '6585');
INSERT INTO public.who_global_data_import VALUES (24730, '2020-11-27', 'EG', 'Egypt', 'EMRO', '368', '114475', '11', '6596');
INSERT INTO public.who_global_data_import VALUES (24731, '2020-11-28', 'EG', 'Egypt', 'EMRO', '357', '114832', '12', '6608');
INSERT INTO public.who_global_data_import VALUES (24732, '2020-11-29', 'EG', 'Egypt', 'EMRO', '351', '115183', '13', '6621');
INSERT INTO public.who_global_data_import VALUES (24733, '2020-11-30', 'EG', 'Egypt', 'EMRO', '358', '115541', '15', '6636');
INSERT INTO public.who_global_data_import VALUES (24734, '2020-12-01', 'EG', 'Egypt', 'EMRO', '370', '115911', '14', '6650');
INSERT INTO public.who_global_data_import VALUES (24735, '2020-12-02', 'EG', 'Egypt', 'EMRO', '392', '116303', '16', '6666');
INSERT INTO public.who_global_data_import VALUES (24736, '2020-12-03', 'EG', 'Egypt', 'EMRO', '421', '116724', '28', '6694');
INSERT INTO public.who_global_data_import VALUES (24737, '2020-12-04', 'EG', 'Egypt', 'EMRO', '432', '117156', '19', '6713');
INSERT INTO public.who_global_data_import VALUES (24738, '2020-12-05', 'EG', 'Egypt', 'EMRO', '427', '117583', '19', '6732');
INSERT INTO public.who_global_data_import VALUES (24739, '2020-12-06', 'EG', 'Egypt', 'EMRO', '431', '118014', '18', '6750');
INSERT INTO public.who_global_data_import VALUES (24740, '2020-12-07', 'EG', 'Egypt', 'EMRO', '418', '118432', '21', '6771');
INSERT INTO public.who_global_data_import VALUES (24741, '2020-12-08', 'EG', 'Egypt', 'EMRO', '415', '118847', '19', '6790');
INSERT INTO public.who_global_data_import VALUES (24742, '2020-12-09', 'EG', 'Egypt', 'EMRO', '434', '119281', '23', '6813');
INSERT INTO public.who_global_data_import VALUES (24743, '2020-12-10', 'EG', 'Egypt', 'EMRO', '421', '119702', '19', '6832');
INSERT INTO public.who_global_data_import VALUES (24744, '2020-12-11', 'EG', 'Egypt', 'EMRO', '445', '120147', '22', '6854');
INSERT INTO public.who_global_data_import VALUES (24745, '2020-12-12', 'EG', 'Egypt', 'EMRO', '464', '120611', '23', '6877');
INSERT INTO public.who_global_data_import VALUES (24746, '2020-12-13', 'EG', 'Egypt', 'EMRO', '478', '121089', '21', '6898');
INSERT INTO public.who_global_data_import VALUES (24747, '2020-12-14', 'EG', 'Egypt', 'EMRO', '486', '121575', '22', '6920');
INSERT INTO public.who_global_data_import VALUES (24748, '2020-12-15', 'EG', 'Egypt', 'EMRO', '511', '122086', '23', '6943');
INSERT INTO public.who_global_data_import VALUES (24749, '2020-12-16', 'EG', 'Egypt', 'EMRO', '523', '122609', '23', '6966');
INSERT INTO public.who_global_data_import VALUES (24750, '2020-12-17', 'EG', 'Egypt', 'EMRO', '544', '123153', '24', '6990');
INSERT INTO public.who_global_data_import VALUES (24751, '2020-12-18', 'EG', 'Egypt', 'EMRO', '548', '123701', '25', '7015');
INSERT INTO public.who_global_data_import VALUES (24752, '2020-12-19', 'EG', 'Egypt', 'EMRO', '579', '124280', '26', '7041');
INSERT INTO public.who_global_data_import VALUES (24753, '2020-12-20', 'EG', 'Egypt', 'EMRO', '611', '124891', '28', '7069');
INSERT INTO public.who_global_data_import VALUES (24754, '2020-12-21', 'EG', 'Egypt', 'EMRO', '664', '125555', '29', '7098');
INSERT INTO public.who_global_data_import VALUES (24755, '2020-12-22', 'EG', 'Egypt', 'EMRO', '718', '126273', '32', '7130');
INSERT INTO public.who_global_data_import VALUES (24756, '2020-12-23', 'EG', 'Egypt', 'EMRO', '788', '127061', '37', '7167');
INSERT INTO public.who_global_data_import VALUES (24757, '2020-12-24', 'EG', 'Egypt', 'EMRO', '911', '127972', '42', '7209');
INSERT INTO public.who_global_data_import VALUES (24758, '2020-12-25', 'EG', 'Egypt', 'EMRO', '1021', '128993', '51', '7260');
INSERT INTO public.who_global_data_import VALUES (24759, '2020-12-26', 'EG', 'Egypt', 'EMRO', '1133', '130126', '49', '7309');
INSERT INTO public.who_global_data_import VALUES (24760, '2020-12-27', 'EG', 'Egypt', 'EMRO', '1189', '131315', '43', '7352');
INSERT INTO public.who_global_data_import VALUES (24761, '2020-12-28', 'EG', 'Egypt', 'EMRO', '1226', '132541', '53', '7405');
INSERT INTO public.who_global_data_import VALUES (24762, '2020-12-29', 'EG', 'Egypt', 'EMRO', '1359', '133900', '61', '7466');
INSERT INTO public.who_global_data_import VALUES (24763, '2020-12-30', 'EG', 'Egypt', 'EMRO', '1333', '135233', '54', '7520');
INSERT INTO public.who_global_data_import VALUES (24764, '2020-12-31', 'EG', 'Egypt', 'EMRO', '1411', '136644', '56', '7576');
INSERT INTO public.who_global_data_import VALUES (24765, '2021-01-01', 'EG', 'Egypt', 'EMRO', '1418', '138062', '55', '7631');
INSERT INTO public.who_global_data_import VALUES (24766, '2021-01-02', 'EG', 'Egypt', 'EMRO', '1409', '139471', '56', '7687');
INSERT INTO public.who_global_data_import VALUES (24767, '2021-01-03', 'EG', 'Egypt', 'EMRO', '1407', '140878', '54', '7741');
INSERT INTO public.who_global_data_import VALUES (24768, '2021-01-04', 'EG', 'Egypt', 'EMRO', '1309', '142187', '64', '7805');
INSERT INTO public.who_global_data_import VALUES (24769, '2021-01-05', 'EG', 'Egypt', 'EMRO', '1277', '143464', '58', '7863');
INSERT INTO public.who_global_data_import VALUES (24770, '2021-01-06', 'EG', 'Egypt', 'EMRO', '1119', '144583', '55', '7918');
INSERT INTO public.who_global_data_import VALUES (24771, '2021-01-07', 'EG', 'Egypt', 'EMRO', '1007', '145590', '57', '7975');
INSERT INTO public.who_global_data_import VALUES (24772, '2021-01-08', 'EG', 'Egypt', 'EMRO', '1219', '146809', '54', '8029');
INSERT INTO public.who_global_data_import VALUES (24773, '2021-01-09', 'EG', 'Egypt', 'EMRO', '1001', '147810', '56', '8085');
INSERT INTO public.who_global_data_import VALUES (24774, '2021-01-10', 'EG', 'Egypt', 'EMRO', '989', '148799', '57', '8142');
INSERT INTO public.who_global_data_import VALUES (24775, '2021-01-11', 'EG', 'Egypt', 'EMRO', '993', '149792', '55', '8197');
INSERT INTO public.who_global_data_import VALUES (24776, '2021-01-12', 'EG', 'Egypt', 'EMRO', '961', '150753', '52', '8249');
INSERT INTO public.who_global_data_import VALUES (24777, '2021-01-13', 'EG', 'Egypt', 'EMRO', '970', '151723', '55', '8304');
INSERT INTO public.who_global_data_import VALUES (24778, '2021-01-14', 'EG', 'Egypt', 'EMRO', '996', '152719', '58', '8362');
INSERT INTO public.who_global_data_import VALUES (24779, '2021-01-15', 'EG', 'Egypt', 'EMRO', '1022', '153741', '59', '8421');
INSERT INTO public.who_global_data_import VALUES (24780, '2021-01-16', 'EG', 'Egypt', 'EMRO', '879', '154620', '52', '8473');
INSERT INTO public.who_global_data_import VALUES (24781, '2021-01-17', 'EG', 'Egypt', 'EMRO', '887', '155507', '54', '8527');
INSERT INTO public.who_global_data_import VALUES (24782, '2021-01-18', 'EG', 'Egypt', 'EMRO', '890', '156397', '56', '8583');
INSERT INTO public.who_global_data_import VALUES (24783, '2021-01-19', 'EG', 'Egypt', 'EMRO', '878', '157275', '55', '8638');
INSERT INTO public.who_global_data_import VALUES (24784, '2021-01-20', 'EG', 'Egypt', 'EMRO', '899', '158174', '58', '8696');
INSERT INTO public.who_global_data_import VALUES (24785, '2021-01-21', 'EG', 'Egypt', 'EMRO', '789', '158963', '51', '8747');
INSERT INTO public.who_global_data_import VALUES (24786, '2021-01-22', 'EG', 'Egypt', 'EMRO', '752', '159715', '54', '8801');
INSERT INTO public.who_global_data_import VALUES (24787, '2021-01-23', 'EG', 'Egypt', 'EMRO', '748', '160463', '52', '8853');
INSERT INTO public.who_global_data_import VALUES (24788, '2021-01-24', 'EG', 'Egypt', 'EMRO', '680', '161143', '49', '8902');
INSERT INTO public.who_global_data_import VALUES (24789, '2021-01-25', 'EG', 'Egypt', 'EMRO', '674', '161817', '57', '8959');
INSERT INTO public.who_global_data_import VALUES (24790, '2021-01-26', 'EG', 'Egypt', 'EMRO', '669', '162486', '53', '9012');
INSERT INTO public.who_global_data_import VALUES (24791, '2021-01-27', 'EG', 'Egypt', 'EMRO', '643', '163129', '55', '9067');
INSERT INTO public.who_global_data_import VALUES (24792, '2021-01-28', 'EG', 'Egypt', 'EMRO', '632', '163761', '48', '9115');
INSERT INTO public.who_global_data_import VALUES (24793, '2021-01-29', 'EG', 'Egypt', 'EMRO', '521', '164282', '54', '9169');
INSERT INTO public.who_global_data_import VALUES (24794, '2021-01-30', 'EG', 'Egypt', 'EMRO', '589', '164871', '48', '9217');
INSERT INTO public.who_global_data_import VALUES (24795, '2021-01-31', 'EG', 'Egypt', 'EMRO', '547', '165418', '46', '9263');
INSERT INTO public.who_global_data_import VALUES (24796, '2021-02-01', 'EG', 'Egypt', 'EMRO', '533', '165951', '53', '9316');
INSERT INTO public.who_global_data_import VALUES (24797, '2021-02-02', 'EG', 'Egypt', 'EMRO', '541', '166492', '44', '9360');
INSERT INTO public.who_global_data_import VALUES (24798, '2021-02-03', 'EG', 'Egypt', 'EMRO', '521', '167013', '47', '9407');
INSERT INTO public.who_global_data_import VALUES (24799, '2021-02-04', 'EG', 'Egypt', 'EMRO', '512', '167525', '53', '9460');
INSERT INTO public.who_global_data_import VALUES (24800, '2021-02-05', 'EG', 'Egypt', 'EMRO', '532', '168057', '52', '9512');
INSERT INTO public.who_global_data_import VALUES (24801, '2020-01-03', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24802, '2020-01-04', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24803, '2020-01-05', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24804, '2020-01-06', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24805, '2020-01-07', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24806, '2020-01-08', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24807, '2020-01-09', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24808, '2020-01-10', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24809, '2020-01-11', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24810, '2020-01-12', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24811, '2020-01-13', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24812, '2020-01-14', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24813, '2020-01-15', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24814, '2020-01-16', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24815, '2020-01-17', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24816, '2020-01-18', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24817, '2020-01-19', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24818, '2020-01-20', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24819, '2020-01-21', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24820, '2020-01-22', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24821, '2020-01-23', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24822, '2020-01-24', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24823, '2020-01-25', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24824, '2020-01-26', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24825, '2020-01-27', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24826, '2020-01-28', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24827, '2020-01-29', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24828, '2020-01-30', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24829, '2020-01-31', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24830, '2020-02-01', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24831, '2020-02-02', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24832, '2020-02-03', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24833, '2020-02-04', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24834, '2020-02-05', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24835, '2020-02-06', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24836, '2020-02-07', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24837, '2020-02-08', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24838, '2020-02-09', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24839, '2020-02-10', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24840, '2020-02-11', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24841, '2020-02-12', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24842, '2020-02-13', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24843, '2020-02-14', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24844, '2020-02-15', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24845, '2020-02-16', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24846, '2020-02-17', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24847, '2020-02-18', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24848, '2020-02-19', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24849, '2020-02-20', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24850, '2020-02-21', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24851, '2020-02-22', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24852, '2020-02-23', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24853, '2020-02-24', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24854, '2020-02-25', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24855, '2020-02-26', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24856, '2020-02-27', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24857, '2020-02-28', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24858, '2020-02-29', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24859, '2020-03-01', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24860, '2020-03-02', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24861, '2020-03-03', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24862, '2020-03-04', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24863, '2020-03-05', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24864, '2020-03-06', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24865, '2020-03-07', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24866, '2020-03-08', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24867, '2020-03-09', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24868, '2020-03-10', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24869, '2020-03-11', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24870, '2020-03-12', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24871, '2020-03-13', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24872, '2020-03-14', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24873, '2020-03-15', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24874, '2020-03-16', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24875, '2020-03-17', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24876, '2020-03-18', 'SV', 'El Salvador', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24877, '2020-03-19', 'SV', 'El Salvador', 'AMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24878, '2020-03-20', 'SV', 'El Salvador', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24879, '2020-03-21', 'SV', 'El Salvador', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24880, '2020-03-22', 'SV', 'El Salvador', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24881, '2020-03-23', 'SV', 'El Salvador', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24882, '2020-03-24', 'SV', 'El Salvador', 'AMRO', '4', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24883, '2020-03-25', 'SV', 'El Salvador', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24884, '2020-03-26', 'SV', 'El Salvador', 'AMRO', '8', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24885, '2020-03-27', 'SV', 'El Salvador', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24886, '2020-03-28', 'SV', 'El Salvador', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24887, '2020-03-29', 'SV', 'El Salvador', 'AMRO', '6', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24888, '2020-03-30', 'SV', 'El Salvador', 'AMRO', '5', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24889, '2020-03-31', 'SV', 'El Salvador', 'AMRO', '6', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24890, '2020-04-01', 'SV', 'El Salvador', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (24891, '2020-04-02', 'SV', 'El Salvador', 'AMRO', '2', '32', '1', '1');
INSERT INTO public.who_global_data_import VALUES (24892, '2020-04-03', 'SV', 'El Salvador', 'AMRO', '9', '41', '1', '2');
INSERT INTO public.who_global_data_import VALUES (24893, '2020-04-04', 'SV', 'El Salvador', 'AMRO', '5', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (24894, '2020-04-05', 'SV', 'El Salvador', 'AMRO', '10', '56', '1', '3');
INSERT INTO public.who_global_data_import VALUES (24895, '2020-04-06', 'SV', 'El Salvador', 'AMRO', '6', '62', '0', '3');
INSERT INTO public.who_global_data_import VALUES (24896, '2020-04-07', 'SV', 'El Salvador', 'AMRO', '7', '69', '0', '3');
INSERT INTO public.who_global_data_import VALUES (24897, '2020-04-08', 'SV', 'El Salvador', 'AMRO', '9', '78', '1', '4');
INSERT INTO public.who_global_data_import VALUES (24898, '2020-04-09', 'SV', 'El Salvador', 'AMRO', '15', '93', '1', '5');
INSERT INTO public.who_global_data_import VALUES (24899, '2020-04-10', 'SV', 'El Salvador', 'AMRO', '10', '103', '0', '5');
INSERT INTO public.who_global_data_import VALUES (24900, '2020-04-11', 'SV', 'El Salvador', 'AMRO', '14', '117', '1', '6');
INSERT INTO public.who_global_data_import VALUES (24901, '2020-04-12', 'SV', 'El Salvador', 'AMRO', '1', '118', '0', '6');
INSERT INTO public.who_global_data_import VALUES (24902, '2020-04-13', 'SV', 'El Salvador', 'AMRO', '7', '125', '0', '6');
INSERT INTO public.who_global_data_import VALUES (24903, '2020-04-14', 'SV', 'El Salvador', 'AMRO', '12', '137', '0', '6');
INSERT INTO public.who_global_data_import VALUES (24904, '2020-04-15', 'SV', 'El Salvador', 'AMRO', '12', '149', '0', '6');
INSERT INTO public.who_global_data_import VALUES (24905, '2020-04-16', 'SV', 'El Salvador', 'AMRO', '10', '159', '0', '6');
INSERT INTO public.who_global_data_import VALUES (24906, '2020-04-17', 'SV', 'El Salvador', 'AMRO', '5', '164', '0', '6');
INSERT INTO public.who_global_data_import VALUES (24907, '2020-04-18', 'SV', 'El Salvador', 'AMRO', '13', '177', '1', '7');
INSERT INTO public.who_global_data_import VALUES (24908, '2020-04-19', 'SV', 'El Salvador', 'AMRO', '13', '190', '0', '7');
INSERT INTO public.who_global_data_import VALUES (24909, '2020-04-20', 'SV', 'El Salvador', 'AMRO', '11', '201', '0', '7');
INSERT INTO public.who_global_data_import VALUES (24910, '2020-04-21', 'SV', 'El Salvador', 'AMRO', '17', '218', '0', '7');
INSERT INTO public.who_global_data_import VALUES (24911, '2020-04-22', 'SV', 'El Salvador', 'AMRO', '7', '225', '0', '7');
INSERT INTO public.who_global_data_import VALUES (24912, '2020-04-23', 'SV', 'El Salvador', 'AMRO', '12', '237', '0', '7');
INSERT INTO public.who_global_data_import VALUES (24913, '2020-04-24', 'SV', 'El Salvador', 'AMRO', '13', '250', '1', '8');
INSERT INTO public.who_global_data_import VALUES (24914, '2020-04-25', 'SV', 'El Salvador', 'AMRO', '11', '261', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24915, '2020-04-26', 'SV', 'El Salvador', 'AMRO', '13', '274', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24916, '2020-04-27', 'SV', 'El Salvador', 'AMRO', '24', '298', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24917, '2020-04-28', 'SV', 'El Salvador', 'AMRO', '25', '323', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24918, '2020-04-29', 'SV', 'El Salvador', 'AMRO', '22', '345', '0', '8');
INSERT INTO public.who_global_data_import VALUES (24919, '2020-04-30', 'SV', 'El Salvador', 'AMRO', '32', '377', '1', '9');
INSERT INTO public.who_global_data_import VALUES (24920, '2020-05-01', 'SV', 'El Salvador', 'AMRO', '18', '395', '0', '9');
INSERT INTO public.who_global_data_import VALUES (24921, '2020-05-02', 'SV', 'El Salvador', 'AMRO', '29', '424', '1', '10');
INSERT INTO public.who_global_data_import VALUES (24922, '2020-05-03', 'SV', 'El Salvador', 'AMRO', '22', '446', '0', '10');
INSERT INTO public.who_global_data_import VALUES (24923, '2020-05-04', 'SV', 'El Salvador', 'AMRO', '44', '490', '1', '11');
INSERT INTO public.who_global_data_import VALUES (24924, '2020-05-05', 'SV', 'El Salvador', 'AMRO', '65', '555', '1', '12');
INSERT INTO public.who_global_data_import VALUES (24925, '2020-05-06', 'SV', 'El Salvador', 'AMRO', '32', '587', '1', '13');
INSERT INTO public.who_global_data_import VALUES (24926, '2020-05-07', 'SV', 'El Salvador', 'AMRO', '46', '633', '1', '14');
INSERT INTO public.who_global_data_import VALUES (24927, '2020-05-08', 'SV', 'El Salvador', 'AMRO', '62', '695', '1', '15');
INSERT INTO public.who_global_data_import VALUES (24928, '2020-05-09', 'SV', 'El Salvador', 'AMRO', '47', '742', '0', '15');
INSERT INTO public.who_global_data_import VALUES (24929, '2020-05-10', 'SV', 'El Salvador', 'AMRO', '42', '784', '1', '16');
INSERT INTO public.who_global_data_import VALUES (24930, '2020-05-11', 'SV', 'El Salvador', 'AMRO', '105', '889', '1', '17');
INSERT INTO public.who_global_data_import VALUES (24931, '2020-05-12', 'SV', 'El Salvador', 'AMRO', '69', '958', '0', '17');
INSERT INTO public.who_global_data_import VALUES (24932, '2020-05-13', 'SV', 'El Salvador', 'AMRO', '40', '998', '1', '18');
INSERT INTO public.who_global_data_import VALUES (24933, '2020-05-14', 'SV', 'El Salvador', 'AMRO', '39', '1037', '2', '20');
INSERT INTO public.who_global_data_import VALUES (24934, '2020-05-15', 'SV', 'El Salvador', 'AMRO', '75', '1112', '0', '20');
INSERT INTO public.who_global_data_import VALUES (24935, '2020-05-16', 'SV', 'El Salvador', 'AMRO', '98', '1210', '3', '23');
INSERT INTO public.who_global_data_import VALUES (24936, '2020-05-17', 'SV', 'El Salvador', 'AMRO', '55', '1265', '2', '25');
INSERT INTO public.who_global_data_import VALUES (24937, '2020-05-18', 'SV', 'El Salvador', 'AMRO', '73', '1338', '2', '27');
INSERT INTO public.who_global_data_import VALUES (24938, '2020-05-19', 'SV', 'El Salvador', 'AMRO', '75', '1413', '3', '30');
INSERT INTO public.who_global_data_import VALUES (24939, '2020-05-20', 'SV', 'El Salvador', 'AMRO', '85', '1498', '0', '30');
INSERT INTO public.who_global_data_import VALUES (24940, '2020-05-21', 'SV', 'El Salvador', 'AMRO', '73', '1571', '1', '31');
INSERT INTO public.who_global_data_import VALUES (24941, '2020-05-22', 'SV', 'El Salvador', 'AMRO', '69', '1640', '1', '32');
INSERT INTO public.who_global_data_import VALUES (24942, '2020-05-23', 'SV', 'El Salvador', 'AMRO', '85', '1725', '1', '33');
INSERT INTO public.who_global_data_import VALUES (24943, '2020-05-24', 'SV', 'El Salvador', 'AMRO', '94', '1819', '0', '33');
INSERT INTO public.who_global_data_import VALUES (24944, '2020-05-25', 'SV', 'El Salvador', 'AMRO', '96', '1915', '2', '35');
INSERT INTO public.who_global_data_import VALUES (24945, '2020-05-26', 'SV', 'El Salvador', 'AMRO', '68', '1983', '0', '35');
INSERT INTO public.who_global_data_import VALUES (24946, '2020-05-27', 'SV', 'El Salvador', 'AMRO', '59', '2042', '1', '36');
INSERT INTO public.who_global_data_import VALUES (24947, '2020-05-28', 'SV', 'El Salvador', 'AMRO', '67', '2109', '1', '37');
INSERT INTO public.who_global_data_import VALUES (24948, '2020-05-29', 'SV', 'El Salvador', 'AMRO', '85', '2194', '2', '39');
INSERT INTO public.who_global_data_import VALUES (24949, '2020-05-30', 'SV', 'El Salvador', 'AMRO', '84', '2278', '3', '42');
INSERT INTO public.who_global_data_import VALUES (24950, '2020-05-31', 'SV', 'El Salvador', 'AMRO', '117', '2395', '2', '44');
INSERT INTO public.who_global_data_import VALUES (24951, '2020-06-01', 'SV', 'El Salvador', 'AMRO', '122', '2517', '2', '46');
INSERT INTO public.who_global_data_import VALUES (24952, '2020-06-02', 'SV', 'El Salvador', 'AMRO', '65', '2582', '0', '46');
INSERT INTO public.who_global_data_import VALUES (24953, '2020-06-03', 'SV', 'El Salvador', 'AMRO', '71', '2653', '0', '46');
INSERT INTO public.who_global_data_import VALUES (24954, '2020-06-04', 'SV', 'El Salvador', 'AMRO', '52', '2705', '5', '51');
INSERT INTO public.who_global_data_import VALUES (24955, '2020-06-05', 'SV', 'El Salvador', 'AMRO', '76', '2781', '1', '52');
INSERT INTO public.who_global_data_import VALUES (24956, '2020-06-06', 'SV', 'El Salvador', 'AMRO', '68', '2849', '1', '53');
INSERT INTO public.who_global_data_import VALUES (24957, '2020-06-07', 'SV', 'El Salvador', 'AMRO', '85', '2934', '0', '53');
INSERT INTO public.who_global_data_import VALUES (24958, '2020-06-08', 'SV', 'El Salvador', 'AMRO', '81', '3015', '2', '55');
INSERT INTO public.who_global_data_import VALUES (24959, '2020-06-09', 'SV', 'El Salvador', 'AMRO', '89', '3104', '0', '55');
INSERT INTO public.who_global_data_import VALUES (24960, '2020-06-10', 'SV', 'El Salvador', 'AMRO', '87', '3191', '3', '58');
INSERT INTO public.who_global_data_import VALUES (24961, '2020-06-11', 'SV', 'El Salvador', 'AMRO', '83', '3274', '2', '60');
INSERT INTO public.who_global_data_import VALUES (24962, '2020-06-12', 'SV', 'El Salvador', 'AMRO', '99', '3373', '4', '64');
INSERT INTO public.who_global_data_import VALUES (24963, '2020-06-13', 'SV', 'El Salvador', 'AMRO', '108', '3481', '4', '68');
INSERT INTO public.who_global_data_import VALUES (24964, '2020-06-14', 'SV', 'El Salvador', 'AMRO', '122', '3603', '4', '72');
INSERT INTO public.who_global_data_import VALUES (24965, '2020-06-15', 'SV', 'El Salvador', 'AMRO', '117', '3720', '0', '72');
INSERT INTO public.who_global_data_import VALUES (24966, '2020-06-16', 'SV', 'El Salvador', 'AMRO', '106', '3826', '2', '74');
INSERT INTO public.who_global_data_import VALUES (24967, '2020-06-17', 'SV', 'El Salvador', 'AMRO', '115', '3941', '2', '76');
INSERT INTO public.who_global_data_import VALUES (24968, '2020-06-18', 'SV', 'El Salvador', 'AMRO', '125', '4066', '3', '79');
INSERT INTO public.who_global_data_import VALUES (24969, '2020-06-19', 'SV', 'El Salvador', 'AMRO', '134', '4200', '3', '82');
INSERT INTO public.who_global_data_import VALUES (24970, '2020-06-20', 'SV', 'El Salvador', 'AMRO', '129', '4329', '4', '86');
INSERT INTO public.who_global_data_import VALUES (24971, '2020-06-21', 'SV', 'El Salvador', 'AMRO', '146', '4475', '7', '93');
INSERT INTO public.who_global_data_import VALUES (24972, '2020-06-22', 'SV', 'El Salvador', 'AMRO', '151', '4626', '5', '98');
INSERT INTO public.who_global_data_import VALUES (24973, '2020-06-23', 'SV', 'El Salvador', 'AMRO', '182', '4808', '9', '107');
INSERT INTO public.who_global_data_import VALUES (24974, '2020-06-24', 'SV', 'El Salvador', 'AMRO', '165', '4973', '6', '113');
INSERT INTO public.who_global_data_import VALUES (24975, '2020-06-25', 'SV', 'El Salvador', 'AMRO', '177', '5150', '6', '119');
INSERT INTO public.who_global_data_import VALUES (24976, '2020-06-26', 'SV', 'El Salvador', 'AMRO', '186', '5336', '7', '126');
INSERT INTO public.who_global_data_import VALUES (24977, '2020-06-27', 'SV', 'El Salvador', 'AMRO', '181', '5517', '7', '133');
INSERT INTO public.who_global_data_import VALUES (24978, '2020-06-28', 'SV', 'El Salvador', 'AMRO', '210', '5727', '10', '143');
INSERT INTO public.who_global_data_import VALUES (24979, '2020-06-29', 'SV', 'El Salvador', 'AMRO', '207', '5934', '9', '152');
INSERT INTO public.who_global_data_import VALUES (24980, '2020-06-30', 'SV', 'El Salvador', 'AMRO', '239', '6173', '12', '164');
INSERT INTO public.who_global_data_import VALUES (24981, '2020-07-01', 'SV', 'El Salvador', 'AMRO', '265', '6438', '10', '174');
INSERT INTO public.who_global_data_import VALUES (24982, '2020-07-02', 'SV', 'El Salvador', 'AMRO', '298', '6736', '8', '182');
INSERT INTO public.who_global_data_import VALUES (24983, '2020-07-03', 'SV', 'El Salvador', 'AMRO', '264', '7000', '9', '191');
INSERT INTO public.who_global_data_import VALUES (24984, '2020-07-04', 'SV', 'El Salvador', 'AMRO', '267', '7267', '11', '202');
INSERT INTO public.who_global_data_import VALUES (24985, '2020-07-05', 'SV', 'El Salvador', 'AMRO', '240', '7507', '8', '210');
INSERT INTO public.who_global_data_import VALUES (24986, '2020-07-06', 'SV', 'El Salvador', 'AMRO', '270', '7777', '7', '217');
INSERT INTO public.who_global_data_import VALUES (24987, '2020-07-07', 'SV', 'El Salvador', 'AMRO', '250', '8027', '6', '223');
INSERT INTO public.who_global_data_import VALUES (24988, '2020-07-08', 'SV', 'El Salvador', 'AMRO', '280', '8307', '6', '229');
INSERT INTO public.who_global_data_import VALUES (24989, '2020-07-09', 'SV', 'El Salvador', 'AMRO', '259', '8566', '6', '235');
INSERT INTO public.who_global_data_import VALUES (24990, '2020-07-10', 'SV', 'El Salvador', 'AMRO', '278', '8844', '8', '243');
INSERT INTO public.who_global_data_import VALUES (24991, '2020-07-11', 'SV', 'El Salvador', 'AMRO', '298', '9142', '6', '249');
INSERT INTO public.who_global_data_import VALUES (24992, '2020-07-12', 'SV', 'El Salvador', 'AMRO', '249', '9391', '5', '254');
INSERT INTO public.who_global_data_import VALUES (24993, '2020-07-13', 'SV', 'El Salvador', 'AMRO', '283', '9674', '6', '260');
INSERT INTO public.who_global_data_import VALUES (24994, '2020-07-14', 'SV', 'El Salvador', 'AMRO', '304', '9978', '7', '267');
INSERT INTO public.who_global_data_import VALUES (24995, '2020-07-15', 'SV', 'El Salvador', 'AMRO', '325', '10303', '11', '278');
INSERT INTO public.who_global_data_import VALUES (24996, '2020-07-16', 'SV', 'El Salvador', 'AMRO', '342', '10645', '8', '286');
INSERT INTO public.who_global_data_import VALUES (24997, '2020-07-17', 'SV', 'El Salvador', 'AMRO', '312', '10957', '12', '298');
INSERT INTO public.who_global_data_import VALUES (24998, '2020-07-18', 'SV', 'El Salvador', 'AMRO', '250', '11207', '11', '309');
INSERT INTO public.who_global_data_import VALUES (24999, '2020-07-19', 'SV', 'El Salvador', 'AMRO', '301', '11508', '15', '324');
INSERT INTO public.who_global_data_import VALUES (25000, '2020-07-20', 'SV', 'El Salvador', 'AMRO', '338', '11846', '11', '335');
INSERT INTO public.who_global_data_import VALUES (25001, '2020-07-21', 'SV', 'El Salvador', 'AMRO', '361', '12207', '9', '344');
INSERT INTO public.who_global_data_import VALUES (25002, '2020-07-22', 'SV', 'El Salvador', 'AMRO', '375', '12582', '8', '352');
INSERT INTO public.who_global_data_import VALUES (25003, '2020-07-23', 'SV', 'El Salvador', 'AMRO', '393', '12975', '11', '363');
INSERT INTO public.who_global_data_import VALUES (25004, '2020-07-24', 'SV', 'El Salvador', 'AMRO', '402', '13377', '9', '372');
INSERT INTO public.who_global_data_import VALUES (25005, '2020-07-25', 'SV', 'El Salvador', 'AMRO', '415', '13792', '7', '379');
INSERT INTO public.who_global_data_import VALUES (25006, '2020-07-26', 'SV', 'El Salvador', 'AMRO', '429', '14221', '11', '390');
INSERT INTO public.who_global_data_import VALUES (25007, '2020-07-27', 'SV', 'El Salvador', 'AMRO', '409', '14630', '10', '400');
INSERT INTO public.who_global_data_import VALUES (25008, '2020-07-28', 'SV', 'El Salvador', 'AMRO', '405', '15035', '8', '408');
INSERT INTO public.who_global_data_import VALUES (25009, '2020-07-29', 'SV', 'El Salvador', 'AMRO', '411', '15446', '9', '417');
INSERT INTO public.who_global_data_import VALUES (25010, '2020-07-30', 'SV', 'El Salvador', 'AMRO', '395', '15841', '13', '430');
INSERT INTO public.who_global_data_import VALUES (25011, '2020-07-31', 'SV', 'El Salvador', 'AMRO', '389', '16230', '9', '439');
INSERT INTO public.who_global_data_import VALUES (25012, '2020-08-01', 'SV', 'El Salvador', 'AMRO', '402', '16632', '9', '448');
INSERT INTO public.who_global_data_import VALUES (25013, '2020-08-02', 'SV', 'El Salvador', 'AMRO', '418', '17050', '11', '459');
INSERT INTO public.who_global_data_import VALUES (25014, '2020-08-03', 'SV', 'El Salvador', 'AMRO', '398', '17448', '8', '467');
INSERT INTO public.who_global_data_import VALUES (25015, '2020-08-04', 'SV', 'El Salvador', 'AMRO', '395', '17843', '10', '477');
INSERT INTO public.who_global_data_import VALUES (25016, '2020-08-05', 'SV', 'El Salvador', 'AMRO', '419', '18262', '9', '486');
INSERT INTO public.who_global_data_import VALUES (25017, '2020-08-06', 'SV', 'El Salvador', 'AMRO', '439', '18701', '12', '498');
INSERT INTO public.who_global_data_import VALUES (25018, '2020-08-07', 'SV', 'El Salvador', 'AMRO', '425', '19126', '15', '513');
INSERT INTO public.who_global_data_import VALUES (25019, '2020-08-08', 'SV', 'El Salvador', 'AMRO', '418', '19544', '7', '520');
INSERT INTO public.who_global_data_import VALUES (25020, '2020-08-09', 'SV', 'El Salvador', 'AMRO', '434', '19978', '16', '536');
INSERT INTO public.who_global_data_import VALUES (25021, '2020-08-10', 'SV', 'El Salvador', 'AMRO', '445', '20423', '13', '549');
INSERT INTO public.who_global_data_import VALUES (25022, '2020-08-11', 'SV', 'El Salvador', 'AMRO', '449', '20872', '14', '563');
INSERT INTO public.who_global_data_import VALUES (25023, '2020-08-12', 'SV', 'El Salvador', 'AMRO', '397', '21269', '7', '570');
INSERT INTO public.who_global_data_import VALUES (25024, '2020-08-13', 'SV', 'El Salvador', 'AMRO', '375', '21644', '7', '577');
INSERT INTO public.who_global_data_import VALUES (25025, '2020-08-14', 'SV', 'El Salvador', 'AMRO', '349', '21993', '7', '584');
INSERT INTO public.who_global_data_import VALUES (25026, '2020-08-15', 'SV', 'El Salvador', 'AMRO', '321', '22314', '11', '595');
INSERT INTO public.who_global_data_import VALUES (25027, '2020-08-16', 'SV', 'El Salvador', 'AMRO', '305', '22619', '8', '603');
INSERT INTO public.who_global_data_import VALUES (25028, '2020-08-17', 'SV', 'El Salvador', 'AMRO', '293', '22912', '9', '612');
INSERT INTO public.who_global_data_import VALUES (25029, '2020-08-18', 'SV', 'El Salvador', 'AMRO', '281', '23193', '6', '618');
INSERT INTO public.who_global_data_import VALUES (25030, '2020-08-19', 'SV', 'El Salvador', 'AMRO', '269', '23462', '7', '625');
INSERT INTO public.who_global_data_import VALUES (25031, '2020-08-20', 'SV', 'El Salvador', 'AMRO', '255', '23717', '8', '633');
INSERT INTO public.who_global_data_import VALUES (25032, '2020-08-21', 'SV', 'El Salvador', 'AMRO', '247', '23964', '7', '640');
INSERT INTO public.who_global_data_import VALUES (25033, '2020-08-22', 'SV', 'El Salvador', 'AMRO', '236', '24200', '6', '646');
INSERT INTO public.who_global_data_import VALUES (25034, '2020-08-23', 'SV', 'El Salvador', 'AMRO', '220', '24420', '8', '654');
INSERT INTO public.who_global_data_import VALUES (25035, '2020-08-24', 'SV', 'El Salvador', 'AMRO', '202', '24622', '7', '661');
INSERT INTO public.who_global_data_import VALUES (25036, '2020-08-25', 'SV', 'El Salvador', 'AMRO', '189', '24811', '8', '669');
INSERT INTO public.who_global_data_import VALUES (25037, '2020-08-26', 'SV', 'El Salvador', 'AMRO', '175', '24986', '9', '678');
INSERT INTO public.who_global_data_import VALUES (25038, '2020-08-27', 'SV', 'El Salvador', 'AMRO', '154', '25140', '9', '687');
INSERT INTO public.who_global_data_import VALUES (25039, '2020-08-28', 'SV', 'El Salvador', 'AMRO', '144', '25284', '7', '694');
INSERT INTO public.who_global_data_import VALUES (25040, '2020-08-29', 'SV', 'El Salvador', 'AMRO', '131', '25415', '8', '702');
INSERT INTO public.who_global_data_import VALUES (25041, '2020-08-30', 'SV', 'El Salvador', 'AMRO', '122', '25537', '6', '708');
INSERT INTO public.who_global_data_import VALUES (25042, '2020-08-31', 'SV', 'El Salvador', 'AMRO', '98', '25635', '5', '713');
INSERT INTO public.who_global_data_import VALUES (25043, '2020-09-01', 'SV', 'El Salvador', 'AMRO', '94', '25729', '4', '717');
INSERT INTO public.who_global_data_import VALUES (25044, '2020-09-02', 'SV', 'El Salvador', 'AMRO', '91', '25820', '7', '724');
INSERT INTO public.who_global_data_import VALUES (25045, '2020-09-03', 'SV', 'El Salvador', 'AMRO', '84', '25904', '7', '731');
INSERT INTO public.who_global_data_import VALUES (25046, '2020-09-04', 'SV', 'El Salvador', 'AMRO', '96', '26000', '8', '739');
INSERT INTO public.who_global_data_import VALUES (25047, '2020-09-05', 'SV', 'El Salvador', 'AMRO', '99', '26099', '5', '744');
INSERT INTO public.who_global_data_import VALUES (25048, '2020-09-06', 'SV', 'El Salvador', 'AMRO', '107', '26206', '8', '752');
INSERT INTO public.who_global_data_import VALUES (25049, '2020-09-07', 'SV', 'El Salvador', 'AMRO', '102', '26308', '7', '759');
INSERT INTO public.who_global_data_import VALUES (25050, '2020-09-08', 'SV', 'El Salvador', 'AMRO', '105', '26413', '5', '764');
INSERT INTO public.who_global_data_import VALUES (25051, '2020-09-09', 'SV', 'El Salvador', 'AMRO', '98', '26511', '1', '765');
INSERT INTO public.who_global_data_import VALUES (25052, '2020-09-10', 'SV', 'El Salvador', 'AMRO', '91', '26602', '5', '770');
INSERT INTO public.who_global_data_import VALUES (25053, '2020-09-11', 'SV', 'El Salvador', 'AMRO', '86', '26688', '4', '774');
INSERT INTO public.who_global_data_import VALUES (25054, '2020-09-12', 'SV', 'El Salvador', 'AMRO', '85', '26773', '3', '777');
INSERT INTO public.who_global_data_import VALUES (25055, '2020-09-13', 'SV', 'El Salvador', 'AMRO', '78', '26851', '5', '782');
INSERT INTO public.who_global_data_import VALUES (25056, '2020-09-14', 'SV', 'El Salvador', 'AMRO', '77', '26928', '3', '785');
INSERT INTO public.who_global_data_import VALUES (25057, '2020-09-15', 'SV', 'El Salvador', 'AMRO', '81', '27009', '3', '788');
INSERT INTO public.who_global_data_import VALUES (25058, '2020-09-16', 'SV', 'El Salvador', 'AMRO', '79', '27088', '4', '792');
INSERT INTO public.who_global_data_import VALUES (25059, '2020-09-17', 'SV', 'El Salvador', 'AMRO', '75', '27163', '4', '796');
INSERT INTO public.who_global_data_import VALUES (25060, '2020-09-18', 'SV', 'El Salvador', 'AMRO', '86', '27249', '5', '801');
INSERT INTO public.who_global_data_import VALUES (25061, '2020-09-19', 'SV', 'El Salvador', 'AMRO', '97', '27346', '3', '804');
INSERT INTO public.who_global_data_import VALUES (25062, '2020-09-20', 'SV', 'El Salvador', 'AMRO', '82', '27428', '4', '808');
INSERT INTO public.who_global_data_import VALUES (25063, '2020-09-21', 'SV', 'El Salvador', 'AMRO', '125', '27553', '3', '811');
INSERT INTO public.who_global_data_import VALUES (25064, '2020-09-22', 'SV', 'El Salvador', 'AMRO', '245', '27798', '1', '812');
INSERT INTO public.who_global_data_import VALUES (25065, '2020-09-23', 'SV', 'El Salvador', 'AMRO', '0', '27798', '2', '814');
INSERT INTO public.who_global_data_import VALUES (25066, '2020-09-24', 'SV', 'El Salvador', 'AMRO', '156', '27954', '5', '819');
INSERT INTO public.who_global_data_import VALUES (25067, '2020-09-25', 'SV', 'El Salvador', 'AMRO', '247', '28201', '4', '823');
INSERT INTO public.who_global_data_import VALUES (25068, '2020-09-26', 'SV', 'El Salvador', 'AMRO', '214', '28415', '0', '823');
INSERT INTO public.who_global_data_import VALUES (25069, '2020-09-27', 'SV', 'El Salvador', 'AMRO', '0', '28415', '3', '826');
INSERT INTO public.who_global_data_import VALUES (25070, '2020-09-28', 'SV', 'El Salvador', 'AMRO', '215', '28630', '0', '826');
INSERT INTO public.who_global_data_import VALUES (25071, '2020-09-29', 'SV', 'El Salvador', 'AMRO', '179', '28809', '5', '831');
INSERT INTO public.who_global_data_import VALUES (25072, '2020-09-30', 'SV', 'El Salvador', 'AMRO', '172', '28981', '8', '839');
INSERT INTO public.who_global_data_import VALUES (25073, '2020-10-01', 'SV', 'El Salvador', 'AMRO', '96', '29077', '4', '843');
INSERT INTO public.who_global_data_import VALUES (25074, '2020-10-02', 'SV', 'El Salvador', 'AMRO', '98', '29175', '5', '848');
INSERT INTO public.who_global_data_import VALUES (25075, '2020-10-03', 'SV', 'El Salvador', 'AMRO', '0', '29175', '5', '853');
INSERT INTO public.who_global_data_import VALUES (25076, '2020-10-04', 'SV', 'El Salvador', 'AMRO', '183', '29358', '4', '857');
INSERT INTO public.who_global_data_import VALUES (25077, '2020-10-05', 'SV', 'El Salvador', 'AMRO', '92', '29450', '6', '863');
INSERT INTO public.who_global_data_import VALUES (25078, '2020-10-06', 'SV', 'El Salvador', 'AMRO', '89', '29539', '2', '865');
INSERT INTO public.who_global_data_import VALUES (25079, '2020-10-07', 'SV', 'El Salvador', 'AMRO', '95', '29634', '4', '869');
INSERT INTO public.who_global_data_import VALUES (25080, '2020-10-08', 'SV', 'El Salvador', 'AMRO', '103', '29737', '4', '873');
INSERT INTO public.who_global_data_import VALUES (25081, '2020-10-09', 'SV', 'El Salvador', 'AMRO', '105', '29842', '4', '877');
INSERT INTO public.who_global_data_import VALUES (25082, '2020-10-10', 'SV', 'El Salvador', 'AMRO', '109', '29951', '4', '881');
INSERT INTO public.who_global_data_import VALUES (25083, '2020-10-11', 'SV', 'El Salvador', 'AMRO', '0', '29951', '6', '887');
INSERT INTO public.who_global_data_import VALUES (25084, '2020-10-12', 'SV', 'El Salvador', 'AMRO', '245', '30196', '3', '890');
INSERT INTO public.who_global_data_import VALUES (25085, '2020-10-13', 'SV', 'El Salvador', 'AMRO', '0', '30196', '4', '894');
INSERT INTO public.who_global_data_import VALUES (25086, '2020-10-14', 'SV', 'El Salvador', 'AMRO', '284', '30480', '5', '899');
INSERT INTO public.who_global_data_import VALUES (25087, '2020-10-15', 'SV', 'El Salvador', 'AMRO', '286', '30766', '5', '904');
INSERT INTO public.who_global_data_import VALUES (25088, '2020-10-16', 'SV', 'El Salvador', 'AMRO', '295', '31061', '4', '908');
INSERT INTO public.who_global_data_import VALUES (25089, '2020-10-17', 'SV', 'El Salvador', 'AMRO', '204', '31265', '4', '912');
INSERT INTO public.who_global_data_import VALUES (25090, '2020-10-18', 'SV', 'El Salvador', 'AMRO', '191', '31456', '5', '917');
INSERT INTO public.who_global_data_import VALUES (25091, '2020-10-19', 'SV', 'El Salvador', 'AMRO', '210', '31666', '5', '922');
INSERT INTO public.who_global_data_import VALUES (25092, '2020-10-20', 'SV', 'El Salvador', 'AMRO', '0', '31666', '4', '926');
INSERT INTO public.who_global_data_import VALUES (25093, '2020-10-21', 'SV', 'El Salvador', 'AMRO', '309', '31975', '3', '929');
INSERT INTO public.who_global_data_import VALUES (25094, '2020-10-22', 'SV', 'El Salvador', 'AMRO', '145', '32120', '4', '933');
INSERT INTO public.who_global_data_import VALUES (25095, '2020-10-23', 'SV', 'El Salvador', 'AMRO', '142', '32262', '3', '936');
INSERT INTO public.who_global_data_import VALUES (25096, '2020-10-24', 'SV', 'El Salvador', 'AMRO', '159', '32421', '4', '940');
INSERT INTO public.who_global_data_import VALUES (25097, '2020-10-25', 'SV', 'El Salvador', 'AMRO', '164', '32585', '4', '944');
INSERT INTO public.who_global_data_import VALUES (25098, '2020-10-26', 'SV', 'El Salvador', 'AMRO', '0', '32585', '5', '949');
INSERT INTO public.who_global_data_import VALUES (25099, '2020-10-27', 'SV', 'El Salvador', 'AMRO', '340', '32925', '4', '953');
INSERT INTO public.who_global_data_import VALUES (25100, '2020-10-28', 'SV', 'El Salvador', 'AMRO', '0', '32925', '4', '957');
INSERT INTO public.who_global_data_import VALUES (25101, '2020-10-29', 'SV', 'El Salvador', 'AMRO', '0', '32925', '5', '962');
INSERT INTO public.who_global_data_import VALUES (25102, '2020-10-30', 'SV', 'El Salvador', 'AMRO', '520', '33445', '5', '967');
INSERT INTO public.who_global_data_import VALUES (25103, '2020-10-31', 'SV', 'El Salvador', 'AMRO', '0', '33445', '4', '971');
INSERT INTO public.who_global_data_import VALUES (25104, '2020-11-01', 'SV', 'El Salvador', 'AMRO', '0', '33445', '4', '975');
INSERT INTO public.who_global_data_import VALUES (25105, '2020-11-02', 'SV', 'El Salvador', 'AMRO', '570', '34015', '4', '979');
INSERT INTO public.who_global_data_import VALUES (25106, '2020-11-03', 'SV', 'El Salvador', 'AMRO', '0', '34015', '4', '983');
INSERT INTO public.who_global_data_import VALUES (25107, '2020-11-04', 'SV', 'El Salvador', 'AMRO', '0', '34015', '4', '987');
INSERT INTO public.who_global_data_import VALUES (25108, '2020-11-05', 'SV', 'El Salvador', 'AMRO', '0', '34015', '5', '992');
INSERT INTO public.who_global_data_import VALUES (25109, '2020-11-06', 'SV', 'El Salvador', 'AMRO', '767', '34782', '5', '997');
INSERT INTO public.who_global_data_import VALUES (25110, '2020-11-07', 'SV', 'El Salvador', 'AMRO', '184', '34966', '5', '1002');
INSERT INTO public.who_global_data_import VALUES (25111, '2020-11-08', 'SV', 'El Salvador', 'AMRO', '179', '35145', '4', '1006');
INSERT INTO public.who_global_data_import VALUES (25112, '2020-11-09', 'SV', 'El Salvador', 'AMRO', '0', '35145', '4', '1010');
INSERT INTO public.who_global_data_import VALUES (25113, '2020-11-10', 'SV', 'El Salvador', 'AMRO', '0', '35145', '4', '1014');
INSERT INTO public.who_global_data_import VALUES (25114, '2020-11-11', 'SV', 'El Salvador', 'AMRO', '0', '35145', '6', '1020');
INSERT INTO public.who_global_data_import VALUES (25115, '2020-11-12', 'SV', 'El Salvador', 'AMRO', '0', '35145', '4', '1024');
INSERT INTO public.who_global_data_import VALUES (25116, '2020-11-13', 'SV', 'El Salvador', 'AMRO', '885', '36030', '4', '1028');
INSERT INTO public.who_global_data_import VALUES (25117, '2020-11-14', 'SV', 'El Salvador', 'AMRO', '165', '36195', '5', '1033');
INSERT INTO public.who_global_data_import VALUES (25118, '2020-11-15', 'SV', 'El Salvador', 'AMRO', '163', '36358', '6', '1039');
INSERT INTO public.who_global_data_import VALUES (25119, '2020-11-16', 'SV', 'El Salvador', 'AMRO', '0', '36358', '5', '1044');
INSERT INTO public.who_global_data_import VALUES (25120, '2020-11-17', 'SV', 'El Salvador', 'AMRO', '311', '36669', '3', '1047');
INSERT INTO public.who_global_data_import VALUES (25121, '2020-11-18', 'SV', 'El Salvador', 'AMRO', '0', '36669', '5', '1052');
INSERT INTO public.who_global_data_import VALUES (25122, '2020-11-19', 'SV', 'El Salvador', 'AMRO', '296', '36965', '4', '1056');
INSERT INTO public.who_global_data_import VALUES (25123, '2020-11-20', 'SV', 'El Salvador', 'AMRO', '0', '36965', '5', '1061');
INSERT INTO public.who_global_data_import VALUES (25124, '2020-11-21', 'SV', 'El Salvador', 'AMRO', '285', '37250', '3', '1064');
INSERT INTO public.who_global_data_import VALUES (25125, '2020-11-22', 'SV', 'El Salvador', 'AMRO', '0', '37250', '6', '1070');
INSERT INTO public.who_global_data_import VALUES (25126, '2020-11-23', 'SV', 'El Salvador', 'AMRO', '312', '37562', '5', '1075');
INSERT INTO public.who_global_data_import VALUES (25127, '2020-11-24', 'SV', 'El Salvador', 'AMRO', '0', '37562', '6', '1081');
INSERT INTO public.who_global_data_import VALUES (25128, '2020-11-25', 'SV', 'El Salvador', 'AMRO', '322', '37884', '5', '1086');
INSERT INTO public.who_global_data_import VALUES (25129, '2020-11-26', 'SV', 'El Salvador', 'AMRO', '0', '37884', '0', '1086');
INSERT INTO public.who_global_data_import VALUES (25130, '2020-11-27', 'SV', 'El Salvador', 'AMRO', '0', '37884', '12', '1098');
INSERT INTO public.who_global_data_import VALUES (25131, '2020-11-28', 'SV', 'El Salvador', 'AMRO', '521', '38405', '4', '1102');
INSERT INTO public.who_global_data_import VALUES (25132, '2020-11-29', 'SV', 'El Salvador', 'AMRO', '0', '38405', '5', '1107');
INSERT INTO public.who_global_data_import VALUES (25133, '2020-11-30', 'SV', 'El Salvador', 'AMRO', '0', '38405', '4', '1111');
INSERT INTO public.who_global_data_import VALUES (25134, '2020-12-01', 'SV', 'El Salvador', 'AMRO', '0', '38405', '3', '1114');
INSERT INTO public.who_global_data_import VALUES (25135, '2020-12-02', 'SV', 'El Salvador', 'AMRO', '725', '39130', '6', '1120');
INSERT INTO public.who_global_data_import VALUES (25136, '2020-12-03', 'SV', 'El Salvador', 'AMRO', '0', '39130', '9', '1129');
INSERT INTO public.who_global_data_import VALUES (25137, '2020-12-04', 'SV', 'El Salvador', 'AMRO', '0', '39130', '5', '1134');
INSERT INTO public.who_global_data_import VALUES (25138, '2020-12-05', 'SV', 'El Salvador', 'AMRO', '588', '39718', '8', '1142');
INSERT INTO public.who_global_data_import VALUES (25139, '2020-12-06', 'SV', 'El Salvador', 'AMRO', '0', '39718', '11', '1153');
INSERT INTO public.who_global_data_import VALUES (25140, '2020-12-07', 'SV', 'El Salvador', 'AMRO', '413', '40131', '6', '1159');
INSERT INTO public.who_global_data_import VALUES (25141, '2020-12-08', 'SV', 'El Salvador', 'AMRO', '214', '40345', '5', '1164');
INSERT INTO public.who_global_data_import VALUES (25142, '2020-12-09', 'SV', 'El Salvador', 'AMRO', '0', '40345', '4', '1168');
INSERT INTO public.who_global_data_import VALUES (25143, '2020-12-10', 'SV', 'El Salvador', 'AMRO', '396', '40741', '6', '1174');
INSERT INTO public.who_global_data_import VALUES (25144, '2020-12-11', 'SV', 'El Salvador', 'AMRO', '0', '40741', '6', '1180');
INSERT INTO public.who_global_data_import VALUES (25145, '2020-12-12', 'SV', 'El Salvador', 'AMRO', '0', '40741', '6', '1186');
INSERT INTO public.who_global_data_import VALUES (25146, '2020-12-13', 'SV', 'El Salvador', 'AMRO', '653', '41394', '7', '1193');
INSERT INTO public.who_global_data_import VALUES (25147, '2020-12-14', 'SV', 'El Salvador', 'AMRO', '0', '41394', '7', '1200');
INSERT INTO public.who_global_data_import VALUES (25148, '2020-12-15', 'SV', 'El Salvador', 'AMRO', '486', '41880', '5', '1205');
INSERT INTO public.who_global_data_import VALUES (25149, '2020-12-16', 'SV', 'El Salvador', 'AMRO', '252', '42132', '7', '1212');
INSERT INTO public.who_global_data_import VALUES (25150, '2020-12-17', 'SV', 'El Salvador', 'AMRO', '265', '42397', '7', '1219');
INSERT INTO public.who_global_data_import VALUES (25151, '2020-12-18', 'SV', 'El Salvador', 'AMRO', '0', '42397', '8', '1227');
INSERT INTO public.who_global_data_import VALUES (25152, '2020-12-19', 'SV', 'El Salvador', 'AMRO', '0', '42397', '7', '1234');
INSERT INTO public.who_global_data_import VALUES (25153, '2020-12-20', 'SV', 'El Salvador', 'AMRO', '798', '43195', '8', '1242');
INSERT INTO public.who_global_data_import VALUES (25154, '2020-12-21', 'SV', 'El Salvador', 'AMRO', '282', '43477', '8', '1250');
INSERT INTO public.who_global_data_import VALUES (25155, '2020-12-22', 'SV', 'El Salvador', 'AMRO', '295', '43772', '7', '1257');
INSERT INTO public.who_global_data_import VALUES (25156, '2020-12-23', 'SV', 'El Salvador', 'AMRO', '0', '43772', '8', '1265');
INSERT INTO public.who_global_data_import VALUES (25157, '2020-12-24', 'SV', 'El Salvador', 'AMRO', '0', '43772', '9', '1274');
INSERT INTO public.who_global_data_import VALUES (25158, '2020-12-25', 'SV', 'El Salvador', 'AMRO', '847', '44619', '9', '1283');
INSERT INTO public.who_global_data_import VALUES (25159, '2020-12-26', 'SV', 'El Salvador', 'AMRO', '0', '44619', '6', '1289');
INSERT INTO public.who_global_data_import VALUES (25160, '2020-12-27', 'SV', 'El Salvador', 'AMRO', '0', '44619', '8', '1297');
INSERT INTO public.who_global_data_import VALUES (25161, '2020-12-28', 'SV', 'El Salvador', 'AMRO', '0', '44619', '8', '1305');
INSERT INTO public.who_global_data_import VALUES (25162, '2020-12-29', 'SV', 'El Salvador', 'AMRO', '796', '45415', '8', '1313');
INSERT INTO public.who_global_data_import VALUES (25163, '2020-12-30', 'SV', 'El Salvador', 'AMRO', '0', '45415', '0', '1313');
INSERT INTO public.who_global_data_import VALUES (25164, '2020-12-31', 'SV', 'El Salvador', 'AMRO', '545', '45960', '14', '1327');
INSERT INTO public.who_global_data_import VALUES (25165, '2021-01-01', 'SV', 'El Salvador', 'AMRO', '0', '45960', '9', '1336');
INSERT INTO public.who_global_data_import VALUES (25166, '2021-01-02', 'SV', 'El Salvador', 'AMRO', '0', '45960', '7', '1343');
INSERT INTO public.who_global_data_import VALUES (25167, '2021-01-03', 'SV', 'El Salvador', 'AMRO', '282', '46242', '8', '1351');
INSERT INTO public.who_global_data_import VALUES (25168, '2021-01-04', 'SV', 'El Salvador', 'AMRO', '561', '46803', '7', '1358');
INSERT INTO public.who_global_data_import VALUES (25169, '2021-01-05', 'SV', 'El Salvador', 'AMRO', '284', '47087', '6', '1364');
INSERT INTO public.who_global_data_import VALUES (25170, '2021-01-06', 'SV', 'El Salvador', 'AMRO', '268', '47355', '9', '1373');
INSERT INTO public.who_global_data_import VALUES (25171, '2021-01-07', 'SV', 'El Salvador', 'AMRO', '0', '47355', '0', '1373');
INSERT INTO public.who_global_data_import VALUES (25172, '2021-01-08', 'SV', 'El Salvador', 'AMRO', '593', '47948', '17', '1390');
INSERT INTO public.who_global_data_import VALUES (25173, '2021-01-09', 'SV', 'El Salvador', 'AMRO', '307', '48255', '8', '1398');
INSERT INTO public.who_global_data_import VALUES (25174, '2021-01-10', 'SV', 'El Salvador', 'AMRO', '319', '48574', '10', '1408');
INSERT INTO public.who_global_data_import VALUES (25175, '2021-01-11', 'SV', 'El Salvador', 'AMRO', '331', '48905', '11', '1419');
INSERT INTO public.who_global_data_import VALUES (25176, '2021-01-12', 'SV', 'El Salvador', 'AMRO', '0', '48905', '9', '1428');
INSERT INTO public.who_global_data_import VALUES (25177, '2021-01-13', 'SV', 'El Salvador', 'AMRO', '0', '48905', '9', '1437');
INSERT INTO public.who_global_data_import VALUES (25178, '2021-01-14', 'SV', 'El Salvador', 'AMRO', '634', '49539', '10', '1447');
INSERT INTO public.who_global_data_import VALUES (25179, '2021-01-15', 'SV', 'El Salvador', 'AMRO', '618', '50157', '12', '1459');
INSERT INTO public.who_global_data_import VALUES (25180, '2021-01-16', 'SV', 'El Salvador', 'AMRO', '0', '50157', '10', '1469');
INSERT INTO public.who_global_data_import VALUES (25181, '2021-01-17', 'SV', 'El Salvador', 'AMRO', '0', '50157', '10', '1479');
INSERT INTO public.who_global_data_import VALUES (25182, '2021-01-18', 'SV', 'El Salvador', 'AMRO', '627', '50784', '8', '1487');
INSERT INTO public.who_global_data_import VALUES (25183, '2021-01-19', 'SV', 'El Salvador', 'AMRO', '653', '51437', '11', '1498');
INSERT INTO public.who_global_data_import VALUES (25184, '2021-01-20', 'SV', 'El Salvador', 'AMRO', '0', '51437', '11', '1509');
INSERT INTO public.who_global_data_import VALUES (25185, '2021-01-21', 'SV', 'El Salvador', 'AMRO', '0', '51437', '12', '1521');
INSERT INTO public.who_global_data_import VALUES (25186, '2021-01-22', 'SV', 'El Salvador', 'AMRO', '951', '52388', '9', '1530');
INSERT INTO public.who_global_data_import VALUES (25187, '2021-01-23', 'SV', 'El Salvador', 'AMRO', '284', '52672', '10', '1540');
INSERT INTO public.who_global_data_import VALUES (25188, '2021-01-24', 'SV', 'El Salvador', 'AMRO', '0', '52672', '11', '1551');
INSERT INTO public.who_global_data_import VALUES (25189, '2021-01-25', 'SV', 'El Salvador', 'AMRO', '546', '53218', '10', '1561');
INSERT INTO public.who_global_data_import VALUES (25190, '2021-01-26', 'SV', 'El Salvador', 'AMRO', '261', '53479', '11', '1572');
INSERT INTO public.who_global_data_import VALUES (25191, '2021-01-27', 'SV', 'El Salvador', 'AMRO', '0', '53479', '11', '1583');
INSERT INTO public.who_global_data_import VALUES (25192, '2021-01-28', 'SV', 'El Salvador', 'AMRO', '510', '53989', '6', '1589');
INSERT INTO public.who_global_data_import VALUES (25193, '2021-01-29', 'SV', 'El Salvador', 'AMRO', '0', '53989', '10', '1599');
INSERT INTO public.who_global_data_import VALUES (25194, '2021-01-30', 'SV', 'El Salvador', 'AMRO', '0', '53989', '5', '1604');
INSERT INTO public.who_global_data_import VALUES (25195, '2021-01-31', 'SV', 'El Salvador', 'AMRO', '0', '53989', '10', '1614');
INSERT INTO public.who_global_data_import VALUES (25196, '2021-02-01', 'SV', 'El Salvador', 'AMRO', '977', '54966', '9', '1623');
INSERT INTO public.who_global_data_import VALUES (25197, '2021-02-02', 'SV', 'El Salvador', 'AMRO', '229', '55195', '9', '1632');
INSERT INTO public.who_global_data_import VALUES (25198, '2021-02-03', 'SV', 'El Salvador', 'AMRO', '0', '55195', '6', '1638');
INSERT INTO public.who_global_data_import VALUES (25199, '2021-02-04', 'SV', 'El Salvador', 'AMRO', '428', '55623', '8', '1646');
INSERT INTO public.who_global_data_import VALUES (25200, '2021-02-05', 'SV', 'El Salvador', 'AMRO', '198', '55821', '7', '1653');
INSERT INTO public.who_global_data_import VALUES (25201, '2020-01-03', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25202, '2020-01-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25203, '2020-01-05', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25204, '2020-01-06', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25205, '2020-01-07', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25206, '2020-01-08', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25207, '2020-01-09', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25208, '2020-01-10', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25209, '2020-01-11', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25210, '2020-01-12', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25211, '2020-01-13', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25212, '2020-01-14', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25213, '2020-01-15', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25214, '2020-01-16', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25215, '2020-01-17', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25216, '2020-01-18', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25217, '2020-01-19', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25218, '2020-01-20', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25219, '2020-01-21', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25220, '2020-01-22', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25221, '2020-01-23', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25222, '2020-01-24', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25223, '2020-01-25', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25224, '2020-01-26', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25225, '2020-01-27', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25226, '2020-01-28', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25227, '2020-01-29', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25228, '2020-01-30', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25229, '2020-01-31', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25230, '2020-02-01', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25231, '2020-02-02', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25232, '2020-02-03', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25233, '2020-02-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25234, '2020-02-05', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25235, '2020-02-06', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25236, '2020-02-07', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25237, '2020-02-08', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25238, '2020-02-09', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25239, '2020-02-10', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25240, '2020-02-11', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25241, '2020-02-12', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25242, '2020-02-13', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25243, '2020-02-14', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25244, '2020-02-15', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25245, '2020-02-16', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25246, '2020-02-17', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25247, '2020-02-18', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25248, '2020-02-19', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25249, '2020-02-20', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25250, '2020-02-21', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25251, '2020-02-22', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25252, '2020-02-23', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25253, '2020-02-24', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25254, '2020-02-25', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25255, '2020-02-26', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25256, '2020-02-27', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25257, '2020-02-28', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25258, '2020-02-29', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25259, '2020-03-01', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25260, '2020-03-02', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25261, '2020-03-03', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25262, '2020-03-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25263, '2020-03-05', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25264, '2020-03-06', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25265, '2020-03-07', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25266, '2020-03-08', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25267, '2020-03-09', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25268, '2020-03-10', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25269, '2020-03-11', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25270, '2020-03-12', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25271, '2020-03-13', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25272, '2020-03-14', 'GQ', 'Equatorial Guinea', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25273, '2020-03-15', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25274, '2020-03-16', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25275, '2020-03-17', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25276, '2020-03-18', 'GQ', 'Equatorial Guinea', 'AFRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25277, '2020-03-19', 'GQ', 'Equatorial Guinea', 'AFRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25278, '2020-03-20', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25279, '2020-03-21', 'GQ', 'Equatorial Guinea', 'AFRO', '-2', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25280, '2020-03-22', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25281, '2020-03-23', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25282, '2020-03-24', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25283, '2020-03-25', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25284, '2020-03-26', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25285, '2020-03-27', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25286, '2020-03-28', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25287, '2020-03-29', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25288, '2020-03-30', 'GQ', 'Equatorial Guinea', 'AFRO', '7', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25289, '2020-03-31', 'GQ', 'Equatorial Guinea', 'AFRO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25290, '2020-04-01', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25291, '2020-04-02', 'GQ', 'Equatorial Guinea', 'AFRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25292, '2020-04-03', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25293, '2020-04-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25294, '2020-04-05', 'GQ', 'Equatorial Guinea', 'AFRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25295, '2020-04-06', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25296, '2020-04-07', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25297, '2020-04-08', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25298, '2020-04-09', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25299, '2020-04-10', 'GQ', 'Equatorial Guinea', 'AFRO', '2', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25300, '2020-04-11', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25301, '2020-04-12', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25302, '2020-04-13', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25303, '2020-04-14', 'GQ', 'Equatorial Guinea', 'AFRO', '3', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25304, '2020-04-15', 'GQ', 'Equatorial Guinea', 'AFRO', '20', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25305, '2020-04-16', 'GQ', 'Equatorial Guinea', 'AFRO', '10', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25306, '2020-04-17', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25307, '2020-04-18', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25308, '2020-04-19', 'GQ', 'Equatorial Guinea', 'AFRO', '28', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25309, '2020-04-20', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25310, '2020-04-21', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25311, '2020-04-22', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25312, '2020-04-23', 'GQ', 'Equatorial Guinea', 'AFRO', '5', '84', '1', '1');
INSERT INTO public.who_global_data_import VALUES (25313, '2020-04-24', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '84', '0', '1');
INSERT INTO public.who_global_data_import VALUES (25314, '2020-04-25', 'GQ', 'Equatorial Guinea', 'AFRO', '128', '212', '0', '1');
INSERT INTO public.who_global_data_import VALUES (25315, '2020-04-26', 'GQ', 'Equatorial Guinea', 'AFRO', '46', '258', '0', '1');
INSERT INTO public.who_global_data_import VALUES (25316, '2020-04-27', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '258', '0', '1');
INSERT INTO public.who_global_data_import VALUES (25317, '2020-04-28', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '258', '0', '1');
INSERT INTO public.who_global_data_import VALUES (25318, '2020-04-29', 'GQ', 'Equatorial Guinea', 'AFRO', '57', '315', '0', '1');
INSERT INTO public.who_global_data_import VALUES (25319, '2020-04-30', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '315', '0', '1');
INSERT INTO public.who_global_data_import VALUES (25320, '2020-05-01', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '315', '1', '2');
INSERT INTO public.who_global_data_import VALUES (25321, '2020-05-02', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '315', '0', '2');
INSERT INTO public.who_global_data_import VALUES (25322, '2020-05-03', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '315', '0', '2');
INSERT INTO public.who_global_data_import VALUES (25323, '2020-05-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '315', '0', '2');
INSERT INTO public.who_global_data_import VALUES (25324, '2020-05-05', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '315', '0', '2');
INSERT INTO public.who_global_data_import VALUES (25325, '2020-05-06', 'GQ', 'Equatorial Guinea', 'AFRO', '124', '439', '2', '4');
INSERT INTO public.who_global_data_import VALUES (25326, '2020-05-07', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '439', '0', '4');
INSERT INTO public.who_global_data_import VALUES (25327, '2020-05-08', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '439', '0', '4');
INSERT INTO public.who_global_data_import VALUES (25328, '2020-05-09', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '439', '0', '4');
INSERT INTO public.who_global_data_import VALUES (25329, '2020-05-10', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '439', '0', '4');
INSERT INTO public.who_global_data_import VALUES (25330, '2020-05-11', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '439', '0', '4');
INSERT INTO public.who_global_data_import VALUES (25331, '2020-05-12', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '439', '0', '4');
INSERT INTO public.who_global_data_import VALUES (25332, '2020-05-13', 'GQ', 'Equatorial Guinea', 'AFRO', '83', '522', '2', '6');
INSERT INTO public.who_global_data_import VALUES (25333, '2020-05-14', 'GQ', 'Equatorial Guinea', 'AFRO', '61', '583', '1', '7');
INSERT INTO public.who_global_data_import VALUES (25334, '2020-05-15', 'GQ', 'Equatorial Guinea', 'AFRO', '11', '594', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25335, '2020-05-16', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '594', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25336, '2020-05-17', 'GQ', 'Equatorial Guinea', 'AFRO', '96', '690', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25337, '2020-05-18', 'GQ', 'Equatorial Guinea', 'AFRO', '29', '719', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25338, '2020-05-19', 'GQ', 'Equatorial Guinea', 'AFRO', '106', '825', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25339, '2020-05-20', 'GQ', 'Equatorial Guinea', 'AFRO', '65', '890', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25340, '2020-05-21', 'GQ', 'Equatorial Guinea', 'AFRO', '13', '903', '3', '10');
INSERT INTO public.who_global_data_import VALUES (25341, '2020-05-22', 'GQ', 'Equatorial Guinea', 'AFRO', '57', '960', '1', '11');
INSERT INTO public.who_global_data_import VALUES (25342, '2020-05-23', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '960', '0', '11');
INSERT INTO public.who_global_data_import VALUES (25343, '2020-05-24', 'GQ', 'Equatorial Guinea', 'AFRO', '83', '1043', '1', '12');
INSERT INTO public.who_global_data_import VALUES (25344, '2020-05-25', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25345, '2020-05-26', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25346, '2020-05-27', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25347, '2020-05-28', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25348, '2020-05-29', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25349, '2020-05-30', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25350, '2020-05-31', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25351, '2020-06-01', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25352, '2020-06-02', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25353, '2020-06-03', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25354, '2020-06-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25355, '2020-06-05', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25356, '2020-06-06', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25357, '2020-06-07', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25358, '2020-06-08', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25359, '2020-06-09', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25360, '2020-06-10', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25361, '2020-06-11', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25362, '2020-06-12', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25363, '2020-06-13', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25364, '2020-06-14', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25365, '2020-06-15', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25366, '2020-06-16', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25367, '2020-06-17', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25368, '2020-06-18', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25369, '2020-06-19', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25370, '2020-06-20', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25371, '2020-06-21', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25372, '2020-06-22', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25373, '2020-06-23', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25374, '2020-06-24', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25375, '2020-06-25', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25376, '2020-06-26', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25377, '2020-06-27', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25378, '2020-06-28', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25379, '2020-06-29', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25380, '2020-06-30', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25381, '2020-07-01', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25382, '2020-07-02', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25383, '2020-07-03', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25384, '2020-07-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25385, '2020-07-05', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25386, '2020-07-06', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25387, '2020-07-07', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25388, '2020-07-08', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25389, '2020-07-09', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25390, '2020-07-10', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25391, '2020-07-11', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25392, '2020-07-12', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25393, '2020-07-13', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25394, '2020-07-14', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25395, '2020-07-15', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25396, '2020-07-16', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '1043', '0', '12');
INSERT INTO public.who_global_data_import VALUES (25397, '2020-07-17', 'GQ', 'Equatorial Guinea', 'AFRO', '1307', '2350', '29', '41');
INSERT INTO public.who_global_data_import VALUES (25398, '2020-07-18', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25399, '2020-07-19', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25400, '2020-07-20', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25401, '2020-07-21', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25402, '2020-07-22', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25403, '2020-07-23', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25404, '2020-07-24', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25405, '2020-07-25', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25406, '2020-07-26', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25407, '2020-07-27', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25408, '2020-07-28', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25409, '2020-07-29', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25410, '2020-07-30', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25411, '2020-07-31', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '2350', '0', '41');
INSERT INTO public.who_global_data_import VALUES (25412, '2020-08-01', 'GQ', 'Equatorial Guinea', 'AFRO', '2471', '4821', '42', '83');
INSERT INTO public.who_global_data_import VALUES (25413, '2020-08-02', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25414, '2020-08-03', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25415, '2020-08-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25416, '2020-08-05', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25417, '2020-08-06', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25418, '2020-08-07', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25419, '2020-08-08', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25420, '2020-08-09', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25421, '2020-08-10', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25422, '2020-08-11', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25423, '2020-08-12', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25424, '2020-08-13', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25425, '2020-08-14', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25426, '2020-08-15', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25427, '2020-08-16', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25428, '2020-08-17', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25429, '2020-08-18', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25430, '2020-08-19', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25431, '2020-08-20', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25432, '2020-08-21', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25433, '2020-08-22', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4821', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25434, '2020-08-23', 'GQ', 'Equatorial Guinea', 'AFRO', '105', '4926', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25435, '2020-08-24', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4926', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25436, '2020-08-25', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4926', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25437, '2020-08-26', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4926', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25438, '2020-08-27', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4926', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25439, '2020-08-28', 'GQ', 'Equatorial Guinea', 'AFRO', '2', '4928', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25440, '2020-08-29', 'GQ', 'Equatorial Guinea', 'AFRO', '13', '4941', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25441, '2020-08-30', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4941', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25442, '2020-08-31', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4941', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25443, '2020-09-01', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4941', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25444, '2020-09-02', 'GQ', 'Equatorial Guinea', 'AFRO', '24', '4965', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25445, '2020-09-03', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4965', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25446, '2020-09-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4965', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25447, '2020-09-05', 'GQ', 'Equatorial Guinea', 'AFRO', '7', '4972', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25448, '2020-09-06', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4972', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25449, '2020-09-07', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4972', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25450, '2020-09-08', 'GQ', 'Equatorial Guinea', 'AFRO', '13', '4985', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25451, '2020-09-09', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4985', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25452, '2020-09-10', 'GQ', 'Equatorial Guinea', 'AFRO', '5', '4990', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25453, '2020-09-11', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4990', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25454, '2020-09-12', 'GQ', 'Equatorial Guinea', 'AFRO', '6', '4996', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25455, '2020-09-13', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4996', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25456, '2020-09-14', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '4996', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25457, '2020-09-15', 'GQ', 'Equatorial Guinea', 'AFRO', '4', '5000', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25458, '2020-09-16', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5000', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25459, '2020-09-17', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5000', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25460, '2020-09-18', 'GQ', 'Equatorial Guinea', 'AFRO', '2', '5002', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25461, '2020-09-19', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5002', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25462, '2020-09-20', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5002', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25463, '2020-09-21', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5002', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25464, '2020-09-22', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5002', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25465, '2020-09-23', 'GQ', 'Equatorial Guinea', 'AFRO', '16', '5018', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25466, '2020-09-24', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5018', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25467, '2020-09-25', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5018', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25468, '2020-09-26', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5018', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25469, '2020-09-27', 'GQ', 'Equatorial Guinea', 'AFRO', '10', '5028', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25470, '2020-09-28', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5028', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25471, '2020-09-29', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5028', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25472, '2020-09-30', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5028', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25473, '2020-10-01', 'GQ', 'Equatorial Guinea', 'AFRO', '2', '5030', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25474, '2020-10-02', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5030', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25475, '2020-10-03', 'GQ', 'Equatorial Guinea', 'AFRO', '15', '5045', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25476, '2020-10-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5045', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25477, '2020-10-05', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5045', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25478, '2020-10-06', 'GQ', 'Equatorial Guinea', 'AFRO', '7', '5052', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25479, '2020-10-07', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5052', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25480, '2020-10-08', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5052', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25481, '2020-10-09', 'GQ', 'Equatorial Guinea', 'AFRO', '10', '5062', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25482, '2020-10-10', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5062', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25483, '2020-10-11', 'GQ', 'Equatorial Guinea', 'AFRO', '1', '5063', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25484, '2020-10-12', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5063', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25485, '2020-10-13', 'GQ', 'Equatorial Guinea', 'AFRO', '3', '5066', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25486, '2020-10-14', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5066', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25487, '2020-10-15', 'GQ', 'Equatorial Guinea', 'AFRO', '2', '5068', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25488, '2020-10-16', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5068', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25489, '2020-10-17', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5068', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25490, '2020-10-18', 'GQ', 'Equatorial Guinea', 'AFRO', '2', '5070', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25491, '2020-10-19', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5070', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25492, '2020-10-20', 'GQ', 'Equatorial Guinea', 'AFRO', '4', '5074', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25493, '2020-10-21', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5074', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25494, '2020-10-22', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5074', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25495, '2020-10-23', 'GQ', 'Equatorial Guinea', 'AFRO', '2', '5076', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25496, '2020-10-24', 'GQ', 'Equatorial Guinea', 'AFRO', '3', '5079', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25497, '2020-10-25', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5079', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25498, '2020-10-26', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5079', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25499, '2020-10-27', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5079', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25500, '2020-10-28', 'GQ', 'Equatorial Guinea', 'AFRO', '4', '5083', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25501, '2020-10-29', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5083', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25502, '2020-10-30', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5083', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25503, '2020-10-31', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5083', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25504, '2020-11-01', 'GQ', 'Equatorial Guinea', 'AFRO', '5', '5088', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25505, '2020-11-02', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5088', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25506, '2020-11-03', 'GQ', 'Equatorial Guinea', 'AFRO', '1', '5089', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25507, '2020-11-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5089', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25508, '2020-11-05', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5089', '0', '83');
INSERT INTO public.who_global_data_import VALUES (25509, '2020-11-06', 'GQ', 'Equatorial Guinea', 'AFRO', '3', '5092', '2', '85');
INSERT INTO public.who_global_data_import VALUES (25510, '2020-11-07', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5092', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25511, '2020-11-08', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5092', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25512, '2020-11-09', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5092', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25513, '2020-11-10', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5092', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25514, '2020-11-11', 'GQ', 'Equatorial Guinea', 'AFRO', '10', '5102', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25515, '2020-11-12', 'GQ', 'Equatorial Guinea', 'AFRO', '2', '5104', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25516, '2020-11-13', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5104', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25517, '2020-11-14', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5104', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25518, '2020-11-15', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5104', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25519, '2020-11-16', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5104', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25520, '2020-11-17', 'GQ', 'Equatorial Guinea', 'AFRO', '17', '5121', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25521, '2020-11-18', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5121', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25522, '2020-11-19', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5121', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25523, '2020-11-20', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5121', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25524, '2020-11-21', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5121', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25525, '2020-11-22', 'GQ', 'Equatorial Guinea', 'AFRO', '9', '5130', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25526, '2020-11-23', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5130', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25527, '2020-11-24', 'GQ', 'Equatorial Guinea', 'AFRO', '7', '5137', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25528, '2020-11-25', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5137', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25529, '2020-11-26', 'GQ', 'Equatorial Guinea', 'AFRO', '9', '5146', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25530, '2020-11-27', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5146', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25531, '2020-11-28', 'GQ', 'Equatorial Guinea', 'AFRO', '7', '5153', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25532, '2020-11-29', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5153', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25533, '2020-11-30', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5153', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25534, '2020-12-01', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5153', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25535, '2020-12-02', 'GQ', 'Equatorial Guinea', 'AFRO', '3', '5156', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25536, '2020-12-03', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5156', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25537, '2020-12-04', 'GQ', 'Equatorial Guinea', 'AFRO', '3', '5159', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25538, '2020-12-05', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5159', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25539, '2020-12-06', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5159', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25540, '2020-12-07', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5159', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25541, '2020-12-08', 'GQ', 'Equatorial Guinea', 'AFRO', '7', '5166', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25542, '2020-12-09', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5166', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25543, '2020-12-10', 'GQ', 'Equatorial Guinea', 'AFRO', '17', '5183', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25544, '2020-12-11', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5183', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25545, '2020-12-12', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5183', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25546, '2020-12-13', 'GQ', 'Equatorial Guinea', 'AFRO', '2', '5185', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25547, '2020-12-14', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5185', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25548, '2020-12-15', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5185', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25549, '2020-12-16', 'GQ', 'Equatorial Guinea', 'AFRO', '10', '5195', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25550, '2020-12-17', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5195', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25551, '2020-12-18', 'GQ', 'Equatorial Guinea', 'AFRO', '19', '5214', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25552, '2020-12-19', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5214', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25553, '2020-12-20', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5214', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25554, '2020-12-21', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5214', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25555, '2020-12-22', 'GQ', 'Equatorial Guinea', 'AFRO', '17', '5231', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25556, '2020-12-23', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5231', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25557, '2020-12-24', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5231', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25558, '2020-12-25', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5231', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25559, '2020-12-26', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5231', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25560, '2020-12-27', 'GQ', 'Equatorial Guinea', 'AFRO', '5', '5236', '0', '85');
INSERT INTO public.who_global_data_import VALUES (25561, '2020-12-28', 'GQ', 'Equatorial Guinea', 'AFRO', '12', '5248', '1', '86');
INSERT INTO public.who_global_data_import VALUES (25562, '2020-12-29', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5248', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25563, '2020-12-30', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5248', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25564, '2020-12-31', 'GQ', 'Equatorial Guinea', 'AFRO', '16', '5264', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25565, '2021-01-01', 'GQ', 'Equatorial Guinea', 'AFRO', '13', '5277', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25566, '2021-01-02', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5277', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25567, '2021-01-03', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5277', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25568, '2021-01-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5277', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25569, '2021-01-05', 'GQ', 'Equatorial Guinea', 'AFRO', '2', '5279', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25570, '2021-01-06', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5279', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25571, '2021-01-07', 'GQ', 'Equatorial Guinea', 'AFRO', '7', '5286', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25572, '2021-01-08', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5286', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25573, '2021-01-09', 'GQ', 'Equatorial Guinea', 'AFRO', '3', '5289', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25574, '2021-01-10', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5289', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25575, '2021-01-11', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5289', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25576, '2021-01-12', 'GQ', 'Equatorial Guinea', 'AFRO', '7', '5296', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25577, '2021-01-13', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5296', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25578, '2021-01-14', 'GQ', 'Equatorial Guinea', 'AFRO', '20', '5316', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25579, '2021-01-15', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5316', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25580, '2021-01-16', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5316', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25581, '2021-01-17', 'GQ', 'Equatorial Guinea', 'AFRO', '40', '5356', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25582, '2021-01-18', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5356', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25583, '2021-01-19', 'GQ', 'Equatorial Guinea', 'AFRO', '9', '5365', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25584, '2021-01-20', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5365', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25585, '2021-01-21', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5365', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25586, '2021-01-22', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5365', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25587, '2021-01-23', 'GQ', 'Equatorial Guinea', 'AFRO', '36', '5401', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25588, '2021-01-24', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5401', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25589, '2021-01-25', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5401', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25590, '2021-01-26', 'GQ', 'Equatorial Guinea', 'AFRO', '53', '5454', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25591, '2021-01-27', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5454', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25592, '2021-01-28', 'GQ', 'Equatorial Guinea', 'AFRO', '38', '5492', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25593, '2021-01-29', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5492', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25594, '2021-01-30', 'GQ', 'Equatorial Guinea', 'AFRO', '24', '5516', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25595, '2021-01-31', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5516', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25596, '2021-02-01', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5516', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25597, '2021-02-02', 'GQ', 'Equatorial Guinea', 'AFRO', '18', '5534', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25598, '2021-02-03', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5534', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25599, '2021-02-04', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5534', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25600, '2021-02-05', 'GQ', 'Equatorial Guinea', 'AFRO', '0', '5534', '0', '86');
INSERT INTO public.who_global_data_import VALUES (25601, '2020-01-03', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25602, '2020-01-04', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25603, '2020-01-05', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25604, '2020-01-06', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25605, '2020-01-07', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25606, '2020-01-08', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25607, '2020-01-09', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25608, '2020-01-10', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25609, '2020-01-11', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25610, '2020-01-12', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25611, '2020-01-13', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25612, '2020-01-14', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25613, '2020-01-15', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25614, '2020-01-16', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25615, '2020-01-17', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25616, '2020-01-18', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25617, '2020-01-19', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25618, '2020-01-20', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25619, '2020-01-21', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25620, '2020-01-22', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25621, '2020-01-23', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25622, '2020-01-24', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25623, '2020-01-25', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25624, '2020-01-26', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25625, '2020-01-27', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25626, '2020-01-28', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25627, '2020-01-29', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25628, '2020-01-30', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25629, '2020-01-31', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25630, '2020-02-01', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25631, '2020-02-02', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25632, '2020-02-03', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25633, '2020-02-04', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25634, '2020-02-05', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25635, '2020-02-06', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25636, '2020-02-07', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25637, '2020-02-08', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25638, '2020-02-09', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25639, '2020-02-10', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25640, '2020-02-11', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25641, '2020-02-12', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25642, '2020-02-13', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25643, '2020-02-14', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25644, '2020-02-15', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25645, '2020-02-16', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25646, '2020-02-17', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25647, '2020-02-18', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25648, '2020-02-19', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25649, '2020-02-20', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25650, '2020-02-21', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25651, '2020-02-22', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25652, '2020-02-23', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25653, '2020-02-24', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25654, '2020-02-25', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25655, '2020-02-26', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25656, '2020-02-27', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25657, '2020-02-28', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25658, '2020-02-29', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25659, '2020-03-01', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25660, '2020-03-02', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25661, '2020-03-03', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25662, '2020-03-04', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25663, '2020-03-05', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25664, '2020-03-06', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25665, '2020-03-07', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25666, '2020-03-08', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25667, '2020-03-09', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25668, '2020-03-10', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25669, '2020-03-11', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25670, '2020-03-12', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25671, '2020-03-13', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25672, '2020-03-14', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25673, '2020-03-15', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25674, '2020-03-16', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25675, '2020-03-17', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25676, '2020-03-18', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25677, '2020-03-19', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25678, '2020-03-20', 'ER', 'Eritrea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25679, '2020-03-21', 'ER', 'Eritrea', 'AFRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25680, '2020-03-22', 'ER', 'Eritrea', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25681, '2020-03-23', 'ER', 'Eritrea', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25682, '2020-03-24', 'ER', 'Eritrea', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25683, '2020-03-25', 'ER', 'Eritrea', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25684, '2020-03-26', 'ER', 'Eritrea', 'AFRO', '3', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25685, '2020-03-27', 'ER', 'Eritrea', 'AFRO', '2', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25686, '2020-03-28', 'ER', 'Eritrea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25687, '2020-03-29', 'ER', 'Eritrea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25688, '2020-03-30', 'ER', 'Eritrea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25689, '2020-03-31', 'ER', 'Eritrea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25690, '2020-04-01', 'ER', 'Eritrea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25691, '2020-04-02', 'ER', 'Eritrea', 'AFRO', '9', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25692, '2020-04-03', 'ER', 'Eritrea', 'AFRO', '5', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25693, '2020-04-04', 'ER', 'Eritrea', 'AFRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25694, '2020-04-05', 'ER', 'Eritrea', 'AFRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25695, '2020-04-06', 'ER', 'Eritrea', 'AFRO', '9', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25696, '2020-04-07', 'ER', 'Eritrea', 'AFRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25697, '2020-04-08', 'ER', 'Eritrea', 'AFRO', '2', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25698, '2020-04-09', 'ER', 'Eritrea', 'AFRO', '2', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25699, '2020-04-10', 'ER', 'Eritrea', 'AFRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25700, '2020-04-11', 'ER', 'Eritrea', 'AFRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25701, '2020-04-12', 'ER', 'Eritrea', 'AFRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25702, '2020-04-13', 'ER', 'Eritrea', 'AFRO', '1', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25703, '2020-04-14', 'ER', 'Eritrea', 'AFRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25704, '2020-04-15', 'ER', 'Eritrea', 'AFRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25705, '2020-04-16', 'ER', 'Eritrea', 'AFRO', '1', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25706, '2020-04-17', 'ER', 'Eritrea', 'AFRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25707, '2020-04-18', 'ER', 'Eritrea', 'AFRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25708, '2020-04-19', 'ER', 'Eritrea', 'AFRO', '4', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25709, '2020-04-20', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25710, '2020-04-21', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25711, '2020-04-22', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25712, '2020-04-23', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25713, '2020-04-24', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25714, '2020-04-25', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25715, '2020-04-26', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25716, '2020-04-27', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25717, '2020-04-28', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25718, '2020-04-29', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25719, '2020-04-30', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25720, '2020-05-01', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25721, '2020-05-02', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25722, '2020-05-03', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25723, '2020-05-04', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25724, '2020-05-05', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25725, '2020-05-06', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25726, '2020-05-07', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25727, '2020-05-08', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25728, '2020-05-09', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25729, '2020-05-10', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25730, '2020-05-11', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25731, '2020-05-12', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25732, '2020-05-13', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25733, '2020-05-14', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25734, '2020-05-15', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25735, '2020-05-16', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25736, '2020-05-17', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25737, '2020-05-18', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25738, '2020-05-19', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25739, '2020-05-20', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25740, '2020-05-21', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25741, '2020-05-22', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25742, '2020-05-23', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25743, '2020-05-24', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25744, '2020-05-25', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25745, '2020-05-26', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25746, '2020-05-27', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25747, '2020-05-28', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25748, '2020-05-29', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25749, '2020-05-30', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25750, '2020-05-31', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25751, '2020-06-01', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25752, '2020-06-02', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25753, '2020-06-03', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25754, '2020-06-04', 'ER', 'Eritrea', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25755, '2020-06-05', 'ER', 'Eritrea', 'AFRO', '2', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25756, '2020-06-06', 'ER', 'Eritrea', 'AFRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25757, '2020-06-07', 'ER', 'Eritrea', 'AFRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25758, '2020-06-08', 'ER', 'Eritrea', 'AFRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25759, '2020-06-09', 'ER', 'Eritrea', 'AFRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25760, '2020-06-10', 'ER', 'Eritrea', 'AFRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25761, '2020-06-11', 'ER', 'Eritrea', 'AFRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25762, '2020-06-12', 'ER', 'Eritrea', 'AFRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25763, '2020-06-13', 'ER', 'Eritrea', 'AFRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25764, '2020-06-14', 'ER', 'Eritrea', 'AFRO', '24', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25765, '2020-06-15', 'ER', 'Eritrea', 'AFRO', '31', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25766, '2020-06-16', 'ER', 'Eritrea', 'AFRO', '13', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25767, '2020-06-17', 'ER', 'Eritrea', 'AFRO', '12', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25768, '2020-06-18', 'ER', 'Eritrea', 'AFRO', '10', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25769, '2020-06-19', 'ER', 'Eritrea', 'AFRO', '11', '142', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25770, '2020-06-20', 'ER', 'Eritrea', 'AFRO', '0', '142', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25771, '2020-06-21', 'ER', 'Eritrea', 'AFRO', '0', '142', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25772, '2020-06-22', 'ER', 'Eritrea', 'AFRO', '1', '143', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25773, '2020-06-23', 'ER', 'Eritrea', 'AFRO', '0', '143', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25774, '2020-06-24', 'ER', 'Eritrea', 'AFRO', '0', '143', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25775, '2020-06-25', 'ER', 'Eritrea', 'AFRO', '1', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25776, '2020-06-26', 'ER', 'Eritrea', 'AFRO', '0', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25777, '2020-06-27', 'ER', 'Eritrea', 'AFRO', '23', '167', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25778, '2020-06-28', 'ER', 'Eritrea', 'AFRO', '24', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25779, '2020-06-29', 'ER', 'Eritrea', 'AFRO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25780, '2020-06-30', 'ER', 'Eritrea', 'AFRO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25781, '2020-07-01', 'ER', 'Eritrea', 'AFRO', '12', '203', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25782, '2020-07-02', 'ER', 'Eritrea', 'AFRO', '0', '203', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25783, '2020-07-03', 'ER', 'Eritrea', 'AFRO', '12', '215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25784, '2020-07-04', 'ER', 'Eritrea', 'AFRO', '0', '215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25785, '2020-07-05', 'ER', 'Eritrea', 'AFRO', '0', '215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25786, '2020-07-06', 'ER', 'Eritrea', 'AFRO', '0', '215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25787, '2020-07-07', 'ER', 'Eritrea', 'AFRO', '0', '215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25788, '2020-07-08', 'ER', 'Eritrea', 'AFRO', '0', '215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25789, '2020-07-09', 'ER', 'Eritrea', 'AFRO', '0', '215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25790, '2020-07-10', 'ER', 'Eritrea', 'AFRO', '17', '232', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25791, '2020-07-11', 'ER', 'Eritrea', 'AFRO', '0', '232', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25792, '2020-07-12', 'ER', 'Eritrea', 'AFRO', '0', '232', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25793, '2020-07-13', 'ER', 'Eritrea', 'AFRO', '0', '232', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25794, '2020-07-14', 'ER', 'Eritrea', 'AFRO', '0', '232', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25795, '2020-07-15', 'ER', 'Eritrea', 'AFRO', '0', '232', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25796, '2020-07-16', 'ER', 'Eritrea', 'AFRO', '0', '232', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25797, '2020-07-17', 'ER', 'Eritrea', 'AFRO', '19', '251', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25798, '2020-07-18', 'ER', 'Eritrea', 'AFRO', '0', '251', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25799, '2020-07-19', 'ER', 'Eritrea', 'AFRO', '0', '251', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25800, '2020-07-20', 'ER', 'Eritrea', 'AFRO', '0', '251', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25801, '2020-07-21', 'ER', 'Eritrea', 'AFRO', '0', '251', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25802, '2020-07-22', 'ER', 'Eritrea', 'AFRO', '0', '251', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25803, '2020-07-23', 'ER', 'Eritrea', 'AFRO', '0', '251', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25804, '2020-07-24', 'ER', 'Eritrea', 'AFRO', '10', '261', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25805, '2020-07-25', 'ER', 'Eritrea', 'AFRO', '0', '261', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25806, '2020-07-26', 'ER', 'Eritrea', 'AFRO', '2', '263', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26023, '2020-01-25', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25807, '2020-07-27', 'ER', 'Eritrea', 'AFRO', '0', '263', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25808, '2020-07-28', 'ER', 'Eritrea', 'AFRO', '2', '265', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25809, '2020-07-29', 'ER', 'Eritrea', 'AFRO', '0', '265', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25810, '2020-07-30', 'ER', 'Eritrea', 'AFRO', '0', '265', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25811, '2020-07-31', 'ER', 'Eritrea', 'AFRO', '14', '279', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25812, '2020-08-01', 'ER', 'Eritrea', 'AFRO', '0', '279', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25813, '2020-08-02', 'ER', 'Eritrea', 'AFRO', '0', '279', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25814, '2020-08-03', 'ER', 'Eritrea', 'AFRO', '0', '279', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25815, '2020-08-04', 'ER', 'Eritrea', 'AFRO', '3', '282', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25816, '2020-08-05', 'ER', 'Eritrea', 'AFRO', '0', '282', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25817, '2020-08-06', 'ER', 'Eritrea', 'AFRO', '0', '282', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25818, '2020-08-07', 'ER', 'Eritrea', 'AFRO', '0', '282', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25819, '2020-08-08', 'ER', 'Eritrea', 'AFRO', '3', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25820, '2020-08-09', 'ER', 'Eritrea', 'AFRO', '0', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25821, '2020-08-10', 'ER', 'Eritrea', 'AFRO', '0', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25822, '2020-08-11', 'ER', 'Eritrea', 'AFRO', '0', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25823, '2020-08-12', 'ER', 'Eritrea', 'AFRO', '0', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25824, '2020-08-13', 'ER', 'Eritrea', 'AFRO', '0', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25825, '2020-08-14', 'ER', 'Eritrea', 'AFRO', '0', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25826, '2020-08-15', 'ER', 'Eritrea', 'AFRO', '0', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25827, '2020-08-16', 'ER', 'Eritrea', 'AFRO', '0', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25828, '2020-08-17', 'ER', 'Eritrea', 'AFRO', '0', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25829, '2020-08-18', 'ER', 'Eritrea', 'AFRO', '0', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25830, '2020-08-19', 'ER', 'Eritrea', 'AFRO', '19', '304', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25831, '2020-08-20', 'ER', 'Eritrea', 'AFRO', '0', '304', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25832, '2020-08-21', 'ER', 'Eritrea', 'AFRO', '2', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25833, '2020-08-22', 'ER', 'Eritrea', 'AFRO', '0', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25834, '2020-08-23', 'ER', 'Eritrea', 'AFRO', '0', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25835, '2020-08-24', 'ER', 'Eritrea', 'AFRO', '0', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25836, '2020-08-25', 'ER', 'Eritrea', 'AFRO', '0', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25837, '2020-08-26', 'ER', 'Eritrea', 'AFRO', '9', '315', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25838, '2020-08-27', 'ER', 'Eritrea', 'AFRO', '0', '315', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25839, '2020-08-28', 'ER', 'Eritrea', 'AFRO', '0', '315', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25840, '2020-08-29', 'ER', 'Eritrea', 'AFRO', '0', '315', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25841, '2020-08-30', 'ER', 'Eritrea', 'AFRO', '3', '318', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25842, '2020-08-31', 'ER', 'Eritrea', 'AFRO', '0', '318', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25843, '2020-09-01', 'ER', 'Eritrea', 'AFRO', '1', '319', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25844, '2020-09-02', 'ER', 'Eritrea', 'AFRO', '0', '319', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25845, '2020-09-03', 'ER', 'Eritrea', 'AFRO', '0', '319', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25846, '2020-09-04', 'ER', 'Eritrea', 'AFRO', '11', '330', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25847, '2020-09-05', 'ER', 'Eritrea', 'AFRO', '0', '330', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25848, '2020-09-06', 'ER', 'Eritrea', 'AFRO', '0', '330', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25849, '2020-09-07', 'ER', 'Eritrea', 'AFRO', '0', '330', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25850, '2020-09-08', 'ER', 'Eritrea', 'AFRO', '0', '330', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25851, '2020-09-09', 'ER', 'Eritrea', 'AFRO', '11', '341', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25852, '2020-09-10', 'ER', 'Eritrea', 'AFRO', '0', '341', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25853, '2020-09-11', 'ER', 'Eritrea', 'AFRO', '20', '361', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25854, '2020-09-12', 'ER', 'Eritrea', 'AFRO', '0', '361', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25855, '2020-09-13', 'ER', 'Eritrea', 'AFRO', '0', '361', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25856, '2020-09-14', 'ER', 'Eritrea', 'AFRO', '0', '361', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25857, '2020-09-15', 'ER', 'Eritrea', 'AFRO', '0', '361', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25858, '2020-09-16', 'ER', 'Eritrea', 'AFRO', '3', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25859, '2020-09-17', 'ER', 'Eritrea', 'AFRO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25860, '2020-09-18', 'ER', 'Eritrea', 'AFRO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25861, '2020-09-19', 'ER', 'Eritrea', 'AFRO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25862, '2020-09-20', 'ER', 'Eritrea', 'AFRO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25863, '2020-09-21', 'ER', 'Eritrea', 'AFRO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25864, '2020-09-22', 'ER', 'Eritrea', 'AFRO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25865, '2020-09-23', 'ER', 'Eritrea', 'AFRO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25866, '2020-09-24', 'ER', 'Eritrea', 'AFRO', '0', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25867, '2020-09-25', 'ER', 'Eritrea', 'AFRO', '5', '369', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25868, '2020-09-26', 'ER', 'Eritrea', 'AFRO', '0', '369', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25869, '2020-09-27', 'ER', 'Eritrea', 'AFRO', '6', '375', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25870, '2020-09-28', 'ER', 'Eritrea', 'AFRO', '0', '375', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25871, '2020-09-29', 'ER', 'Eritrea', 'AFRO', '0', '375', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25872, '2020-09-30', 'ER', 'Eritrea', 'AFRO', '0', '375', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25873, '2020-10-01', 'ER', 'Eritrea', 'AFRO', '0', '375', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25874, '2020-10-02', 'ER', 'Eritrea', 'AFRO', '0', '375', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25875, '2020-10-03', 'ER', 'Eritrea', 'AFRO', '6', '381', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25876, '2020-10-04', 'ER', 'Eritrea', 'AFRO', '17', '398', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25877, '2020-10-05', 'ER', 'Eritrea', 'AFRO', '0', '398', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25878, '2020-10-06', 'ER', 'Eritrea', 'AFRO', '0', '398', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25879, '2020-10-07', 'ER', 'Eritrea', 'AFRO', '0', '398', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25880, '2020-10-08', 'ER', 'Eritrea', 'AFRO', '0', '398', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25881, '2020-10-09', 'ER', 'Eritrea', 'AFRO', '7', '405', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25882, '2020-10-10', 'ER', 'Eritrea', 'AFRO', '0', '405', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25883, '2020-10-11', 'ER', 'Eritrea', 'AFRO', '9', '414', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25884, '2020-10-12', 'ER', 'Eritrea', 'AFRO', '0', '414', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25885, '2020-10-13', 'ER', 'Eritrea', 'AFRO', '0', '414', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25886, '2020-10-14', 'ER', 'Eritrea', 'AFRO', '0', '414', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25887, '2020-10-15', 'ER', 'Eritrea', 'AFRO', '0', '414', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25888, '2020-10-16', 'ER', 'Eritrea', 'AFRO', '8', '422', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25889, '2020-10-17', 'ER', 'Eritrea', 'AFRO', '0', '422', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25890, '2020-10-18', 'ER', 'Eritrea', 'AFRO', '3', '425', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25891, '2020-10-19', 'ER', 'Eritrea', 'AFRO', '0', '425', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25892, '2020-10-20', 'ER', 'Eritrea', 'AFRO', '0', '425', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25893, '2020-10-21', 'ER', 'Eritrea', 'AFRO', '27', '452', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25894, '2020-10-22', 'ER', 'Eritrea', 'AFRO', '0', '452', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25895, '2020-10-23', 'ER', 'Eritrea', 'AFRO', '0', '452', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25896, '2020-10-24', 'ER', 'Eritrea', 'AFRO', '9', '461', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25897, '2020-10-25', 'ER', 'Eritrea', 'AFRO', '0', '461', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25898, '2020-10-26', 'ER', 'Eritrea', 'AFRO', '0', '461', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25899, '2020-10-27', 'ER', 'Eritrea', 'AFRO', '0', '461', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25900, '2020-10-28', 'ER', 'Eritrea', 'AFRO', '0', '461', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25901, '2020-10-29', 'ER', 'Eritrea', 'AFRO', '0', '461', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25902, '2020-10-30', 'ER', 'Eritrea', 'AFRO', '0', '461', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25903, '2020-10-31', 'ER', 'Eritrea', 'AFRO', '2', '463', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25904, '2020-11-01', 'ER', 'Eritrea', 'AFRO', '0', '463', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25905, '2020-11-02', 'ER', 'Eritrea', 'AFRO', '0', '463', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25906, '2020-11-03', 'ER', 'Eritrea', 'AFRO', '17', '480', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25907, '2020-11-04', 'ER', 'Eritrea', 'AFRO', '0', '480', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25908, '2020-11-05', 'ER', 'Eritrea', 'AFRO', '0', '480', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25909, '2020-11-06', 'ER', 'Eritrea', 'AFRO', '4', '484', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25910, '2020-11-07', 'ER', 'Eritrea', 'AFRO', '0', '484', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25911, '2020-11-08', 'ER', 'Eritrea', 'AFRO', '7', '491', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25912, '2020-11-09', 'ER', 'Eritrea', 'AFRO', '0', '491', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25913, '2020-11-10', 'ER', 'Eritrea', 'AFRO', '0', '491', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25914, '2020-11-11', 'ER', 'Eritrea', 'AFRO', '0', '491', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25915, '2020-11-12', 'ER', 'Eritrea', 'AFRO', '0', '491', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25916, '2020-11-13', 'ER', 'Eritrea', 'AFRO', '2', '493', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25917, '2020-11-14', 'ER', 'Eritrea', 'AFRO', '0', '493', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25918, '2020-11-15', 'ER', 'Eritrea', 'AFRO', '0', '493', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25919, '2020-11-16', 'ER', 'Eritrea', 'AFRO', '0', '493', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25920, '2020-11-17', 'ER', 'Eritrea', 'AFRO', '25', '518', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25921, '2020-11-18', 'ER', 'Eritrea', 'AFRO', '0', '518', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25922, '2020-11-19', 'ER', 'Eritrea', 'AFRO', '0', '518', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25923, '2020-11-20', 'ER', 'Eritrea', 'AFRO', '9', '527', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25924, '2020-11-21', 'ER', 'Eritrea', 'AFRO', '0', '527', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25925, '2020-11-22', 'ER', 'Eritrea', 'AFRO', '24', '551', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25926, '2020-11-23', 'ER', 'Eritrea', 'AFRO', '0', '551', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25927, '2020-11-24', 'ER', 'Eritrea', 'AFRO', '7', '558', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25928, '2020-11-25', 'ER', 'Eritrea', 'AFRO', '0', '558', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25929, '2020-11-26', 'ER', 'Eritrea', 'AFRO', '0', '558', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25930, '2020-11-27', 'ER', 'Eritrea', 'AFRO', '8', '566', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25931, '2020-11-28', 'ER', 'Eritrea', 'AFRO', '0', '566', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25932, '2020-11-29', 'ER', 'Eritrea', 'AFRO', '11', '577', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25933, '2020-11-30', 'ER', 'Eritrea', 'AFRO', '0', '577', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25934, '2020-12-01', 'ER', 'Eritrea', 'AFRO', '0', '577', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25935, '2020-12-02', 'ER', 'Eritrea', 'AFRO', '0', '577', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25936, '2020-12-03', 'ER', 'Eritrea', 'AFRO', '0', '577', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25937, '2020-12-04', 'ER', 'Eritrea', 'AFRO', '17', '594', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25938, '2020-12-05', 'ER', 'Eritrea', 'AFRO', '38', '632', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25939, '2020-12-06', 'ER', 'Eritrea', 'AFRO', '0', '632', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25940, '2020-12-07', 'ER', 'Eritrea', 'AFRO', '0', '632', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25941, '2020-12-08', 'ER', 'Eritrea', 'AFRO', '17', '649', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25942, '2020-12-09', 'ER', 'Eritrea', 'AFRO', '0', '649', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25943, '2020-12-10', 'ER', 'Eritrea', 'AFRO', '0', '649', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25944, '2020-12-11', 'ER', 'Eritrea', 'AFRO', '7', '656', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25945, '2020-12-12', 'ER', 'Eritrea', 'AFRO', '0', '656', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25946, '2020-12-13', 'ER', 'Eritrea', 'AFRO', '0', '656', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25947, '2020-12-14', 'ER', 'Eritrea', 'AFRO', '55', '711', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25948, '2020-12-15', 'ER', 'Eritrea', 'AFRO', '0', '711', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25949, '2020-12-16', 'ER', 'Eritrea', 'AFRO', '0', '711', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25950, '2020-12-17', 'ER', 'Eritrea', 'AFRO', '0', '711', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25951, '2020-12-18', 'ER', 'Eritrea', 'AFRO', '30', '741', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25952, '2020-12-19', 'ER', 'Eritrea', 'AFRO', '0', '741', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25953, '2020-12-20', 'ER', 'Eritrea', 'AFRO', '13', '754', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25954, '2020-12-21', 'ER', 'Eritrea', 'AFRO', '0', '754', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25955, '2020-12-22', 'ER', 'Eritrea', 'AFRO', '53', '807', '0', '0');
INSERT INTO public.who_global_data_import VALUES (25956, '2020-12-23', 'ER', 'Eritrea', 'AFRO', '25', '832', '1', '1');
INSERT INTO public.who_global_data_import VALUES (25957, '2020-12-24', 'ER', 'Eritrea', 'AFRO', '45', '877', '0', '1');
INSERT INTO public.who_global_data_import VALUES (25958, '2020-12-25', 'ER', 'Eritrea', 'AFRO', '78', '955', '0', '1');
INSERT INTO public.who_global_data_import VALUES (25959, '2020-12-26', 'ER', 'Eritrea', 'AFRO', '37', '992', '0', '1');
INSERT INTO public.who_global_data_import VALUES (25960, '2020-12-27', 'ER', 'Eritrea', 'AFRO', '0', '992', '0', '1');
INSERT INTO public.who_global_data_import VALUES (25961, '2020-12-28', 'ER', 'Eritrea', 'AFRO', '47', '1039', '1', '2');
INSERT INTO public.who_global_data_import VALUES (25962, '2020-12-29', 'ER', 'Eritrea', 'AFRO', '0', '1039', '0', '2');
INSERT INTO public.who_global_data_import VALUES (25963, '2020-12-30', 'ER', 'Eritrea', 'AFRO', '181', '1220', '-1', '1');
INSERT INTO public.who_global_data_import VALUES (25964, '2020-12-31', 'ER', 'Eritrea', 'AFRO', '32', '1252', '0', '1');
INSERT INTO public.who_global_data_import VALUES (25965, '2021-01-01', 'ER', 'Eritrea', 'AFRO', '68', '1320', '2', '3');
INSERT INTO public.who_global_data_import VALUES (25966, '2021-01-02', 'ER', 'Eritrea', 'AFRO', '0', '1320', '0', '3');
INSERT INTO public.who_global_data_import VALUES (25967, '2021-01-03', 'ER', 'Eritrea', 'AFRO', '0', '1320', '0', '3');
INSERT INTO public.who_global_data_import VALUES (25968, '2021-01-04', 'ER', 'Eritrea', 'AFRO', '0', '1320', '0', '3');
INSERT INTO public.who_global_data_import VALUES (25969, '2021-01-05', 'ER', 'Eritrea', 'AFRO', '43', '1363', '0', '3');
INSERT INTO public.who_global_data_import VALUES (25970, '2021-01-06', 'ER', 'Eritrea', 'AFRO', '82', '1445', '0', '3');
INSERT INTO public.who_global_data_import VALUES (25971, '2021-01-07', 'ER', 'Eritrea', 'AFRO', '0', '1445', '0', '3');
INSERT INTO public.who_global_data_import VALUES (25972, '2021-01-08', 'ER', 'Eritrea', 'AFRO', '0', '1445', '0', '3');
INSERT INTO public.who_global_data_import VALUES (25973, '2021-01-09', 'ER', 'Eritrea', 'AFRO', '111', '1556', '3', '6');
INSERT INTO public.who_global_data_import VALUES (25974, '2021-01-10', 'ER', 'Eritrea', 'AFRO', '0', '1556', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25975, '2021-01-11', 'ER', 'Eritrea', 'AFRO', '0', '1556', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25976, '2021-01-12', 'ER', 'Eritrea', 'AFRO', '0', '1556', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25977, '2021-01-13', 'ER', 'Eritrea', 'AFRO', '40', '1596', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25978, '2021-01-14', 'ER', 'Eritrea', 'AFRO', '0', '1596', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25979, '2021-01-15', 'ER', 'Eritrea', 'AFRO', '209', '1805', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25980, '2021-01-16', 'ER', 'Eritrea', 'AFRO', '0', '1805', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25981, '2021-01-17', 'ER', 'Eritrea', 'AFRO', '72', '1877', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25982, '2021-01-18', 'ER', 'Eritrea', 'AFRO', '0', '1877', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25983, '2021-01-19', 'ER', 'Eritrea', 'AFRO', '0', '1877', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25984, '2021-01-20', 'ER', 'Eritrea', 'AFRO', '0', '1877', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25985, '2021-01-21', 'ER', 'Eritrea', 'AFRO', '33', '1910', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25986, '2021-01-22', 'ER', 'Eritrea', 'AFRO', '3', '1913', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25987, '2021-01-23', 'ER', 'Eritrea', 'AFRO', '27', '1940', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25988, '2021-01-24', 'ER', 'Eritrea', 'AFRO', '0', '1940', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25989, '2021-01-25', 'ER', 'Eritrea', 'AFRO', '0', '1940', '0', '6');
INSERT INTO public.who_global_data_import VALUES (25990, '2021-01-26', 'ER', 'Eritrea', 'AFRO', '0', '1940', '1', '7');
INSERT INTO public.who_global_data_import VALUES (25991, '2021-01-27', 'ER', 'Eritrea', 'AFRO', '30', '1970', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25992, '2021-01-28', 'ER', 'Eritrea', 'AFRO', '115', '2085', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25993, '2021-01-29', 'ER', 'Eritrea', 'AFRO', '0', '2085', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25994, '2021-01-30', 'ER', 'Eritrea', 'AFRO', '50', '2135', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25995, '2021-01-31', 'ER', 'Eritrea', 'AFRO', '0', '2135', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25996, '2021-02-01', 'ER', 'Eritrea', 'AFRO', '0', '2135', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25997, '2021-02-02', 'ER', 'Eritrea', 'AFRO', '0', '2135', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25998, '2021-02-03', 'ER', 'Eritrea', 'AFRO', '132', '2267', '0', '7');
INSERT INTO public.who_global_data_import VALUES (25999, '2021-02-04', 'ER', 'Eritrea', 'AFRO', '42', '2309', '0', '7');
INSERT INTO public.who_global_data_import VALUES (26000, '2021-02-05', 'ER', 'Eritrea', 'AFRO', '0', '2309', '0', '7');
INSERT INTO public.who_global_data_import VALUES (26001, '2020-01-03', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26002, '2020-01-04', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26003, '2020-01-05', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26004, '2020-01-06', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26005, '2020-01-07', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26006, '2020-01-08', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26007, '2020-01-09', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26008, '2020-01-10', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26009, '2020-01-11', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26010, '2020-01-12', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26011, '2020-01-13', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26012, '2020-01-14', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26013, '2020-01-15', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26014, '2020-01-16', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26015, '2020-01-17', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26016, '2020-01-18', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26017, '2020-01-19', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26018, '2020-01-20', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26019, '2020-01-21', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26020, '2020-01-22', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26021, '2020-01-23', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26022, '2020-01-24', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26024, '2020-01-26', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26025, '2020-01-27', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26026, '2020-01-28', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26027, '2020-01-29', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26028, '2020-01-30', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26029, '2020-01-31', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26030, '2020-02-01', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26031, '2020-02-02', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26032, '2020-02-03', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26033, '2020-02-04', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26034, '2020-02-05', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26035, '2020-02-06', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26036, '2020-02-07', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26037, '2020-02-08', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26038, '2020-02-09', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26039, '2020-02-10', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26040, '2020-02-11', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26041, '2020-02-12', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26042, '2020-02-13', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26043, '2020-02-14', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26044, '2020-02-15', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26045, '2020-02-16', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26046, '2020-02-17', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26047, '2020-02-18', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26048, '2020-02-19', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26049, '2020-02-20', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26050, '2020-02-21', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26051, '2020-02-22', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26052, '2020-02-23', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26053, '2020-02-24', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26054, '2020-02-25', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26055, '2020-02-26', 'EE', 'Estonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26056, '2020-02-27', 'EE', 'Estonia', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26057, '2020-02-28', 'EE', 'Estonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26058, '2020-02-29', 'EE', 'Estonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26059, '2020-03-01', 'EE', 'Estonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26060, '2020-03-02', 'EE', 'Estonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26061, '2020-03-03', 'EE', 'Estonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26062, '2020-03-04', 'EE', 'Estonia', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26063, '2020-03-05', 'EE', 'Estonia', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26064, '2020-03-06', 'EE', 'Estonia', 'EURO', '3', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26065, '2020-03-07', 'EE', 'Estonia', 'EURO', '5', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26066, '2020-03-08', 'EE', 'Estonia', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26067, '2020-03-09', 'EE', 'Estonia', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26068, '2020-03-10', 'EE', 'Estonia', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26069, '2020-03-11', 'EE', 'Estonia', 'EURO', '3', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26070, '2020-03-12', 'EE', 'Estonia', 'EURO', '3', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26071, '2020-03-13', 'EE', 'Estonia', 'EURO', '11', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26072, '2020-03-14', 'EE', 'Estonia', 'EURO', '52', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26073, '2020-03-15', 'EE', 'Estonia', 'EURO', '36', '115', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26074, '2020-03-16', 'EE', 'Estonia', 'EURO', '56', '171', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26075, '2020-03-17', 'EE', 'Estonia', 'EURO', '34', '205', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26076, '2020-03-18', 'EE', 'Estonia', 'EURO', '20', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26077, '2020-03-19', 'EE', 'Estonia', 'EURO', '33', '258', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26078, '2020-03-20', 'EE', 'Estonia', 'EURO', '9', '267', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26079, '2020-03-21', 'EE', 'Estonia', 'EURO', '16', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26080, '2020-03-22', 'EE', 'Estonia', 'EURO', '23', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26081, '2020-03-23', 'EE', 'Estonia', 'EURO', '20', '326', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26082, '2020-03-24', 'EE', 'Estonia', 'EURO', '26', '352', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26083, '2020-03-25', 'EE', 'Estonia', 'EURO', '17', '369', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26084, '2020-03-26', 'EE', 'Estonia', 'EURO', '35', '404', '1', '1');
INSERT INTO public.who_global_data_import VALUES (26085, '2020-03-27', 'EE', 'Estonia', 'EURO', '134', '538', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26086, '2020-03-28', 'EE', 'Estonia', 'EURO', '37', '575', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26087, '2020-03-29', 'EE', 'Estonia', 'EURO', '65', '640', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26088, '2020-03-30', 'EE', 'Estonia', 'EURO', '39', '679', '2', '3');
INSERT INTO public.who_global_data_import VALUES (26089, '2020-03-31', 'EE', 'Estonia', 'EURO', '36', '715', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26090, '2020-04-01', 'EE', 'Estonia', 'EURO', '30', '745', '1', '4');
INSERT INTO public.who_global_data_import VALUES (26091, '2020-04-02', 'EE', 'Estonia', 'EURO', '34', '779', '1', '5');
INSERT INTO public.who_global_data_import VALUES (26092, '2020-04-03', 'EE', 'Estonia', 'EURO', '79', '858', '6', '11');
INSERT INTO public.who_global_data_import VALUES (26093, '2020-04-04', 'EE', 'Estonia', 'EURO', '103', '961', '1', '12');
INSERT INTO public.who_global_data_import VALUES (26094, '2020-04-05', 'EE', 'Estonia', 'EURO', '57', '1018', '1', '13');
INSERT INTO public.who_global_data_import VALUES (26095, '2020-04-06', 'EE', 'Estonia', 'EURO', '79', '1097', '2', '15');
INSERT INTO public.who_global_data_import VALUES (26096, '2020-04-07', 'EE', 'Estonia', 'EURO', '11', '1108', '4', '19');
INSERT INTO public.who_global_data_import VALUES (26097, '2020-04-08', 'EE', 'Estonia', 'EURO', '41', '1149', '2', '21');
INSERT INTO public.who_global_data_import VALUES (26098, '2020-04-09', 'EE', 'Estonia', 'EURO', '36', '1185', '3', '24');
INSERT INTO public.who_global_data_import VALUES (26099, '2020-04-10', 'EE', 'Estonia', 'EURO', '22', '1207', '0', '24');
INSERT INTO public.who_global_data_import VALUES (26100, '2020-04-11', 'EE', 'Estonia', 'EURO', '51', '1258', '0', '24');
INSERT INTO public.who_global_data_import VALUES (26101, '2020-04-12', 'EE', 'Estonia', 'EURO', '46', '1304', '0', '24');
INSERT INTO public.who_global_data_import VALUES (26102, '2020-04-13', 'EE', 'Estonia', 'EURO', '5', '1309', '1', '25');
INSERT INTO public.who_global_data_import VALUES (26103, '2020-04-14', 'EE', 'Estonia', 'EURO', '23', '1332', '3', '28');
INSERT INTO public.who_global_data_import VALUES (26104, '2020-04-15', 'EE', 'Estonia', 'EURO', '41', '1373', '3', '31');
INSERT INTO public.who_global_data_import VALUES (26105, '2020-04-16', 'EE', 'Estonia', 'EURO', '29', '1402', '4', '35');
INSERT INTO public.who_global_data_import VALUES (26106, '2020-04-17', 'EE', 'Estonia', 'EURO', '32', '1434', '1', '36');
INSERT INTO public.who_global_data_import VALUES (26107, '2020-04-18', 'EE', 'Estonia', 'EURO', '25', '1459', '2', '38');
INSERT INTO public.who_global_data_import VALUES (26108, '2020-04-19', 'EE', 'Estonia', 'EURO', '53', '1512', '0', '38');
INSERT INTO public.who_global_data_import VALUES (26109, '2020-04-20', 'EE', 'Estonia', 'EURO', '16', '1528', '2', '40');
INSERT INTO public.who_global_data_import VALUES (26110, '2020-04-21', 'EE', 'Estonia', 'EURO', '7', '1535', '0', '40');
INSERT INTO public.who_global_data_import VALUES (26111, '2020-04-22', 'EE', 'Estonia', 'EURO', '17', '1552', '3', '43');
INSERT INTO public.who_global_data_import VALUES (26112, '2020-04-23', 'EE', 'Estonia', 'EURO', '7', '1559', '1', '44');
INSERT INTO public.who_global_data_import VALUES (26113, '2020-04-24', 'EE', 'Estonia', 'EURO', '33', '1592', '1', '45');
INSERT INTO public.who_global_data_import VALUES (26114, '2020-04-25', 'EE', 'Estonia', 'EURO', '13', '1605', '1', '46');
INSERT INTO public.who_global_data_import VALUES (26115, '2020-04-26', 'EE', 'Estonia', 'EURO', '30', '1635', '0', '46');
INSERT INTO public.who_global_data_import VALUES (26116, '2020-04-27', 'EE', 'Estonia', 'EURO', '8', '1643', '3', '49');
INSERT INTO public.who_global_data_import VALUES (26117, '2020-04-28', 'EE', 'Estonia', 'EURO', '4', '1647', '1', '50');
INSERT INTO public.who_global_data_import VALUES (26118, '2020-04-29', 'EE', 'Estonia', 'EURO', '13', '1660', '0', '50');
INSERT INTO public.who_global_data_import VALUES (26119, '2020-04-30', 'EE', 'Estonia', 'EURO', '6', '1666', '0', '50');
INSERT INTO public.who_global_data_import VALUES (26120, '2020-05-01', 'EE', 'Estonia', 'EURO', '23', '1689', '2', '52');
INSERT INTO public.who_global_data_import VALUES (26121, '2020-05-02', 'EE', 'Estonia', 'EURO', '5', '1694', '0', '52');
INSERT INTO public.who_global_data_import VALUES (26122, '2020-05-03', 'EE', 'Estonia', 'EURO', '5', '1699', '1', '53');
INSERT INTO public.who_global_data_import VALUES (26123, '2020-05-04', 'EE', 'Estonia', 'EURO', '1', '1700', '2', '55');
INSERT INTO public.who_global_data_import VALUES (26124, '2020-05-05', 'EE', 'Estonia', 'EURO', '3', '1703', '0', '55');
INSERT INTO public.who_global_data_import VALUES (26125, '2020-05-06', 'EE', 'Estonia', 'EURO', '8', '1711', '0', '55');
INSERT INTO public.who_global_data_import VALUES (26126, '2020-05-07', 'EE', 'Estonia', 'EURO', '2', '1713', '0', '55');
INSERT INTO public.who_global_data_import VALUES (26127, '2020-05-08', 'EE', 'Estonia', 'EURO', '7', '1720', '1', '56');
INSERT INTO public.who_global_data_import VALUES (26128, '2020-05-09', 'EE', 'Estonia', 'EURO', '5', '1725', '0', '56');
INSERT INTO public.who_global_data_import VALUES (26129, '2020-05-10', 'EE', 'Estonia', 'EURO', '8', '1733', '4', '60');
INSERT INTO public.who_global_data_import VALUES (26130, '2020-05-11', 'EE', 'Estonia', 'EURO', '6', '1739', '0', '60');
INSERT INTO public.who_global_data_import VALUES (26131, '2020-05-12', 'EE', 'Estonia', 'EURO', '2', '1741', '1', '61');
INSERT INTO public.who_global_data_import VALUES (26132, '2020-05-13', 'EE', 'Estonia', 'EURO', '5', '1746', '0', '61');
INSERT INTO public.who_global_data_import VALUES (26133, '2020-05-14', 'EE', 'Estonia', 'EURO', '5', '1751', '0', '61');
INSERT INTO public.who_global_data_import VALUES (26134, '2020-05-15', 'EE', 'Estonia', 'EURO', '7', '1758', '1', '62');
INSERT INTO public.who_global_data_import VALUES (26135, '2020-05-16', 'EE', 'Estonia', 'EURO', '8', '1766', '1', '63');
INSERT INTO public.who_global_data_import VALUES (26136, '2020-05-17', 'EE', 'Estonia', 'EURO', '4', '1770', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26137, '2020-05-18', 'EE', 'Estonia', 'EURO', '4', '1774', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26138, '2020-05-19', 'EE', 'Estonia', 'EURO', '10', '1784', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26139, '2020-05-20', 'EE', 'Estonia', 'EURO', '7', '1791', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26140, '2020-05-21', 'EE', 'Estonia', 'EURO', '3', '1794', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26141, '2020-05-22', 'EE', 'Estonia', 'EURO', '6', '1800', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26142, '2020-05-23', 'EE', 'Estonia', 'EURO', '7', '1807', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26143, '2020-05-24', 'EE', 'Estonia', 'EURO', '14', '1821', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26144, '2020-05-25', 'EE', 'Estonia', 'EURO', '2', '1823', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26145, '2020-05-26', 'EE', 'Estonia', 'EURO', '1', '1824', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26146, '2020-05-27', 'EE', 'Estonia', 'EURO', '10', '1834', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26147, '2020-05-28', 'EE', 'Estonia', 'EURO', '6', '1840', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26148, '2020-05-29', 'EE', 'Estonia', 'EURO', '11', '1851', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26149, '2020-05-30', 'EE', 'Estonia', 'EURO', '8', '1859', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26150, '2020-05-31', 'EE', 'Estonia', 'EURO', '6', '1865', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26151, '2020-06-01', 'EE', 'Estonia', 'EURO', '4', '1869', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26152, '2020-06-02', 'EE', 'Estonia', 'EURO', '1', '1870', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26153, '2020-06-03', 'EE', 'Estonia', 'EURO', '0', '1870', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26154, '2020-06-04', 'EE', 'Estonia', 'EURO', '10', '1880', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26155, '2020-06-05', 'EE', 'Estonia', 'EURO', '10', '1890', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26156, '2020-06-06', 'EE', 'Estonia', 'EURO', '20', '1910', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26157, '2020-06-07', 'EE', 'Estonia', 'EURO', '21', '1931', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26158, '2020-06-08', 'EE', 'Estonia', 'EURO', '8', '1939', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26159, '2020-06-09', 'EE', 'Estonia', 'EURO', '1', '1940', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26160, '2020-06-10', 'EE', 'Estonia', 'EURO', '7', '1947', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26161, '2020-06-11', 'EE', 'Estonia', 'EURO', '11', '1958', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26162, '2020-06-12', 'EE', 'Estonia', 'EURO', '7', '1965', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26163, '2020-06-13', 'EE', 'Estonia', 'EURO', '5', '1970', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26164, '2020-06-14', 'EE', 'Estonia', 'EURO', '3', '1973', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26165, '2020-06-15', 'EE', 'Estonia', 'EURO', '0', '1973', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26166, '2020-06-16', 'EE', 'Estonia', 'EURO', '1', '1974', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26167, '2020-06-17', 'EE', 'Estonia', 'EURO', '1', '1975', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26168, '2020-06-18', 'EE', 'Estonia', 'EURO', '2', '1977', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26169, '2020-06-19', 'EE', 'Estonia', 'EURO', '0', '1977', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26170, '2020-06-20', 'EE', 'Estonia', 'EURO', '2', '1979', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26171, '2020-06-21', 'EE', 'Estonia', 'EURO', '2', '1981', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26172, '2020-06-22', 'EE', 'Estonia', 'EURO', '0', '1981', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26173, '2020-06-23', 'EE', 'Estonia', 'EURO', '0', '1981', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26174, '2020-06-24', 'EE', 'Estonia', 'EURO', '1', '1982', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26175, '2020-06-25', 'EE', 'Estonia', 'EURO', '1', '1983', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26176, '2020-06-26', 'EE', 'Estonia', 'EURO', '1', '1984', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26177, '2020-06-27', 'EE', 'Estonia', 'EURO', '2', '1986', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26178, '2020-06-28', 'EE', 'Estonia', 'EURO', '0', '1986', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26179, '2020-06-29', 'EE', 'Estonia', 'EURO', '1', '1987', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26180, '2020-06-30', 'EE', 'Estonia', 'EURO', '0', '1987', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26181, '2020-07-01', 'EE', 'Estonia', 'EURO', '2', '1989', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26182, '2020-07-02', 'EE', 'Estonia', 'EURO', '0', '1989', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26183, '2020-07-03', 'EE', 'Estonia', 'EURO', '1', '1990', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26184, '2020-07-04', 'EE', 'Estonia', 'EURO', '1', '1991', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26185, '2020-07-05', 'EE', 'Estonia', 'EURO', '2', '1993', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26186, '2020-07-06', 'EE', 'Estonia', 'EURO', '0', '1993', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26187, '2020-07-07', 'EE', 'Estonia', 'EURO', '1', '1994', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26188, '2020-07-08', 'EE', 'Estonia', 'EURO', '1', '1995', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26189, '2020-07-09', 'EE', 'Estonia', 'EURO', '8', '2003', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26190, '2020-07-10', 'EE', 'Estonia', 'EURO', '8', '2011', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26191, '2020-07-11', 'EE', 'Estonia', 'EURO', '2', '2013', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26192, '2020-07-12', 'EE', 'Estonia', 'EURO', '1', '2014', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26193, '2020-07-13', 'EE', 'Estonia', 'EURO', '0', '2014', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26194, '2020-07-14', 'EE', 'Estonia', 'EURO', '0', '2014', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26195, '2020-07-15', 'EE', 'Estonia', 'EURO', '1', '2015', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26196, '2020-07-16', 'EE', 'Estonia', 'EURO', '1', '2016', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26197, '2020-07-17', 'EE', 'Estonia', 'EURO', '0', '2016', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26198, '2020-07-18', 'EE', 'Estonia', 'EURO', '4', '2020', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26199, '2020-07-19', 'EE', 'Estonia', 'EURO', '1', '2021', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26200, '2020-07-20', 'EE', 'Estonia', 'EURO', '0', '2021', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26201, '2020-07-21', 'EE', 'Estonia', 'EURO', '0', '2021', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26202, '2020-07-22', 'EE', 'Estonia', 'EURO', '1', '2022', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26203, '2020-07-23', 'EE', 'Estonia', 'EURO', '3', '2025', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26204, '2020-07-24', 'EE', 'Estonia', 'EURO', '2', '2027', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26205, '2020-07-25', 'EE', 'Estonia', 'EURO', '1', '2028', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26206, '2020-07-26', 'EE', 'Estonia', 'EURO', '5', '2033', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26207, '2020-07-27', 'EE', 'Estonia', 'EURO', '1', '2034', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26208, '2020-07-28', 'EE', 'Estonia', 'EURO', '4', '2038', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26209, '2020-07-29', 'EE', 'Estonia', 'EURO', '0', '2038', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26210, '2020-07-30', 'EE', 'Estonia', 'EURO', '4', '2042', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26211, '2020-07-31', 'EE', 'Estonia', 'EURO', '9', '2051', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26212, '2020-08-01', 'EE', 'Estonia', 'EURO', '13', '2064', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26213, '2020-08-02', 'EE', 'Estonia', 'EURO', '8', '2072', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26214, '2020-08-03', 'EE', 'Estonia', 'EURO', '7', '2079', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26215, '2020-08-04', 'EE', 'Estonia', 'EURO', '1', '2080', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26216, '2020-08-05', 'EE', 'Estonia', 'EURO', '11', '2091', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26217, '2020-08-06', 'EE', 'Estonia', 'EURO', '22', '2113', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26218, '2020-08-07', 'EE', 'Estonia', 'EURO', '11', '2124', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26219, '2020-08-08', 'EE', 'Estonia', 'EURO', '9', '2133', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26220, '2020-08-09', 'EE', 'Estonia', 'EURO', '14', '2147', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26221, '2020-08-10', 'EE', 'Estonia', 'EURO', '5', '2152', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26222, '2020-08-11', 'EE', 'Estonia', 'EURO', '6', '2158', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26223, '2020-08-12', 'EE', 'Estonia', 'EURO', '9', '2167', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26224, '2020-08-13', 'EE', 'Estonia', 'EURO', '7', '2174', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26225, '2020-08-14', 'EE', 'Estonia', 'EURO', '0', '2174', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26226, '2020-08-15', 'EE', 'Estonia', 'EURO', '3', '2177', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26227, '2020-08-16', 'EE', 'Estonia', 'EURO', '7', '2184', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26228, '2020-08-17', 'EE', 'Estonia', 'EURO', '6', '2190', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26229, '2020-08-18', 'EE', 'Estonia', 'EURO', '2', '2192', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26230, '2020-08-19', 'EE', 'Estonia', 'EURO', '8', '2200', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26231, '2020-08-20', 'EE', 'Estonia', 'EURO', '7', '2207', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26232, '2020-08-21', 'EE', 'Estonia', 'EURO', '20', '2227', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26233, '2020-08-22', 'EE', 'Estonia', 'EURO', '17', '2244', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26234, '2020-08-23', 'EE', 'Estonia', 'EURO', '21', '2265', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26235, '2020-08-24', 'EE', 'Estonia', 'EURO', '7', '2272', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26236, '2020-08-25', 'EE', 'Estonia', 'EURO', '3', '2275', '1', '64');
INSERT INTO public.who_global_data_import VALUES (26237, '2020-08-26', 'EE', 'Estonia', 'EURO', '19', '2294', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26238, '2020-08-27', 'EE', 'Estonia', 'EURO', '17', '2311', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26239, '2020-08-28', 'EE', 'Estonia', 'EURO', '14', '2325', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26240, '2020-08-29', 'EE', 'Estonia', 'EURO', '18', '2343', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26241, '2020-08-30', 'EE', 'Estonia', 'EURO', '20', '2363', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26242, '2020-08-31', 'EE', 'Estonia', 'EURO', '10', '2373', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26243, '2020-09-01', 'EE', 'Estonia', 'EURO', '2', '2375', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26244, '2020-09-02', 'EE', 'Estonia', 'EURO', '20', '2395', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26245, '2020-09-03', 'EE', 'Estonia', 'EURO', '20', '2415', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26246, '2020-09-04', 'EE', 'Estonia', 'EURO', '26', '2441', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26247, '2020-09-05', 'EE', 'Estonia', 'EURO', '15', '2456', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26248, '2020-09-06', 'EE', 'Estonia', 'EURO', '34', '2490', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26249, '2020-09-07', 'EE', 'Estonia', 'EURO', '25', '2515', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26250, '2020-09-08', 'EE', 'Estonia', 'EURO', '16', '2531', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26251, '2020-09-09', 'EE', 'Estonia', 'EURO', '32', '2563', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26252, '2020-09-10', 'EE', 'Estonia', 'EURO', '22', '2585', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26253, '2020-09-11', 'EE', 'Estonia', 'EURO', '15', '2600', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26254, '2020-09-12', 'EE', 'Estonia', 'EURO', '32', '2632', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26255, '2020-09-13', 'EE', 'Estonia', 'EURO', '23', '2655', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26256, '2020-09-14', 'EE', 'Estonia', 'EURO', '21', '2676', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26257, '2020-09-15', 'EE', 'Estonia', 'EURO', '22', '2698', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26258, '2020-09-16', 'EE', 'Estonia', 'EURO', '24', '2722', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26259, '2020-09-17', 'EE', 'Estonia', 'EURO', '34', '2756', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26260, '2020-09-18', 'EE', 'Estonia', 'EURO', '22', '2778', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26261, '2020-09-19', 'EE', 'Estonia', 'EURO', '36', '2814', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26262, '2020-09-20', 'EE', 'Estonia', 'EURO', '61', '2875', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26263, '2020-09-21', 'EE', 'Estonia', 'EURO', '49', '2924', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26264, '2020-09-22', 'EE', 'Estonia', 'EURO', '17', '2941', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26265, '2020-09-23', 'EE', 'Estonia', 'EURO', '35', '2976', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26266, '2020-09-24', 'EE', 'Estonia', 'EURO', '57', '3033', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26267, '2020-09-25', 'EE', 'Estonia', 'EURO', '43', '3076', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26268, '2020-09-26', 'EE', 'Estonia', 'EURO', '42', '3118', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26269, '2020-09-27', 'EE', 'Estonia', 'EURO', '47', '3165', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26270, '2020-09-28', 'EE', 'Estonia', 'EURO', '35', '3200', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26271, '2020-09-29', 'EE', 'Estonia', 'EURO', '67', '3267', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26272, '2020-09-30', 'EE', 'Estonia', 'EURO', '48', '3315', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26273, '2020-10-01', 'EE', 'Estonia', 'EURO', '56', '3371', '0', '64');
INSERT INTO public.who_global_data_import VALUES (26274, '2020-10-02', 'EE', 'Estonia', 'EURO', '79', '3450', '1', '65');
INSERT INTO public.who_global_data_import VALUES (26275, '2020-10-03', 'EE', 'Estonia', 'EURO', '57', '3507', '1', '66');
INSERT INTO public.who_global_data_import VALUES (26276, '2020-10-04', 'EE', 'Estonia', 'EURO', '70', '3577', '1', '67');
INSERT INTO public.who_global_data_import VALUES (26277, '2020-10-05', 'EE', 'Estonia', 'EURO', '30', '3607', '0', '67');
INSERT INTO public.who_global_data_import VALUES (26278, '2020-10-06', 'EE', 'Estonia', 'EURO', '10', '3617', '0', '67');
INSERT INTO public.who_global_data_import VALUES (26279, '2020-10-07', 'EE', 'Estonia', 'EURO', '42', '3659', '0', '67');
INSERT INTO public.who_global_data_import VALUES (26280, '2020-10-08', 'EE', 'Estonia', 'EURO', '56', '3715', '0', '67');
INSERT INTO public.who_global_data_import VALUES (26281, '2020-10-09', 'EE', 'Estonia', 'EURO', '45', '3760', '0', '67');
INSERT INTO public.who_global_data_import VALUES (26282, '2020-10-10', 'EE', 'Estonia', 'EURO', '49', '3809', '1', '68');
INSERT INTO public.who_global_data_import VALUES (26283, '2020-10-11', 'EE', 'Estonia', 'EURO', '37', '3846', '0', '68');
INSERT INTO public.who_global_data_import VALUES (26284, '2020-10-12', 'EE', 'Estonia', 'EURO', '19', '3865', '0', '68');
INSERT INTO public.who_global_data_import VALUES (26285, '2020-10-13', 'EE', 'Estonia', 'EURO', '18', '3883', '0', '68');
INSERT INTO public.who_global_data_import VALUES (26286, '2020-10-14', 'EE', 'Estonia', 'EURO', '25', '3908', '0', '68');
INSERT INTO public.who_global_data_import VALUES (26287, '2020-10-15', 'EE', 'Estonia', 'EURO', '39', '3947', '0', '68');
INSERT INTO public.who_global_data_import VALUES (26288, '2020-10-16', 'EE', 'Estonia', 'EURO', '33', '3980', '0', '68');
INSERT INTO public.who_global_data_import VALUES (26289, '2020-10-17', 'EE', 'Estonia', 'EURO', '37', '4017', '0', '68');
INSERT INTO public.who_global_data_import VALUES (26290, '2020-10-18', 'EE', 'Estonia', 'EURO', '35', '4052', '0', '68');
INSERT INTO public.who_global_data_import VALUES (26291, '2020-10-19', 'EE', 'Estonia', 'EURO', '26', '4078', '0', '68');
INSERT INTO public.who_global_data_import VALUES (26292, '2020-10-20', 'EE', 'Estonia', 'EURO', '7', '4085', '0', '68');
INSERT INTO public.who_global_data_import VALUES (26293, '2020-10-21', 'EE', 'Estonia', 'EURO', '42', '4127', '3', '71');
INSERT INTO public.who_global_data_import VALUES (26294, '2020-10-22', 'EE', 'Estonia', 'EURO', '44', '4171', '0', '71');
INSERT INTO public.who_global_data_import VALUES (26295, '2020-10-23', 'EE', 'Estonia', 'EURO', '76', '4247', '0', '71');
INSERT INTO public.who_global_data_import VALUES (26296, '2020-10-24', 'EE', 'Estonia', 'EURO', '53', '4300', '2', '73');
INSERT INTO public.who_global_data_import VALUES (26297, '2020-10-25', 'EE', 'Estonia', 'EURO', '51', '4351', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26298, '2020-10-26', 'EE', 'Estonia', 'EURO', '60', '4411', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26299, '2020-10-27', 'EE', 'Estonia', 'EURO', '17', '4428', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26300, '2020-10-28', 'EE', 'Estonia', 'EURO', '37', '4465', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26301, '2020-10-29', 'EE', 'Estonia', 'EURO', '125', '4590', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26302, '2020-10-30', 'EE', 'Estonia', 'EURO', '81', '4671', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26303, '2020-10-31', 'EE', 'Estonia', 'EURO', '100', '4771', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26304, '2020-11-01', 'EE', 'Estonia', 'EURO', '134', '4905', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26305, '2020-11-02', 'EE', 'Estonia', 'EURO', '80', '4985', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26306, '2020-11-03', 'EE', 'Estonia', 'EURO', '61', '5046', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26307, '2020-11-04', 'EE', 'Estonia', 'EURO', '79', '5125', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26308, '2020-11-05', 'EE', 'Estonia', 'EURO', '208', '5333', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26309, '2020-11-06', 'EE', 'Estonia', 'EURO', '131', '5464', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26310, '2020-11-07', 'EE', 'Estonia', 'EURO', '241', '5705', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26311, '2020-11-08', 'EE', 'Estonia', 'EURO', '228', '5933', '0', '73');
INSERT INTO public.who_global_data_import VALUES (26312, '2020-11-09', 'EE', 'Estonia', 'EURO', '192', '6125', '2', '75');
INSERT INTO public.who_global_data_import VALUES (26313, '2020-11-10', 'EE', 'Estonia', 'EURO', '125', '6250', '1', '76');
INSERT INTO public.who_global_data_import VALUES (26314, '2020-11-11', 'EE', 'Estonia', 'EURO', '126', '6376', '0', '76');
INSERT INTO public.who_global_data_import VALUES (26315, '2020-11-12', 'EE', 'Estonia', 'EURO', '132', '6508', '0', '76');
INSERT INTO public.who_global_data_import VALUES (26316, '2020-11-13', 'EE', 'Estonia', 'EURO', '373', '6881', '0', '76');
INSERT INTO public.who_global_data_import VALUES (26317, '2020-11-14', 'EE', 'Estonia', 'EURO', '267', '7148', '4', '80');
INSERT INTO public.who_global_data_import VALUES (26318, '2020-11-15', 'EE', 'Estonia', 'EURO', '0', '7148', '0', '80');
INSERT INTO public.who_global_data_import VALUES (26319, '2020-11-16', 'EE', 'Estonia', 'EURO', '489', '7637', '1', '81');
INSERT INTO public.who_global_data_import VALUES (26320, '2020-11-17', 'EE', 'Estonia', 'EURO', '211', '7848', '0', '81');
INSERT INTO public.who_global_data_import VALUES (26321, '2020-11-18', 'EE', 'Estonia', 'EURO', '185', '8033', '3', '84');
INSERT INTO public.who_global_data_import VALUES (26322, '2020-11-19', 'EE', 'Estonia', 'EURO', '271', '8304', '1', '85');
INSERT INTO public.who_global_data_import VALUES (26323, '2020-11-20', 'EE', 'Estonia', 'EURO', '411', '8715', '1', '86');
INSERT INTO public.who_global_data_import VALUES (26324, '2020-11-21', 'EE', 'Estonia', 'EURO', '361', '9076', '1', '87');
INSERT INTO public.who_global_data_import VALUES (26325, '2020-11-22', 'EE', 'Estonia', 'EURO', '299', '9375', '0', '87');
INSERT INTO public.who_global_data_import VALUES (26326, '2020-11-23', 'EE', 'Estonia', 'EURO', '349', '9724', '1', '88');
INSERT INTO public.who_global_data_import VALUES (26327, '2020-11-24', 'EE', 'Estonia', 'EURO', '232', '9956', '4', '92');
INSERT INTO public.who_global_data_import VALUES (26328, '2020-11-25', 'EE', 'Estonia', 'EURO', '203', '10159', '2', '94');
INSERT INTO public.who_global_data_import VALUES (26329, '2020-11-26', 'EE', 'Estonia', 'EURO', '382', '10541', '3', '97');
INSERT INTO public.who_global_data_import VALUES (26330, '2020-11-27', 'EE', 'Estonia', 'EURO', '414', '10955', '2', '99');
INSERT INTO public.who_global_data_import VALUES (26331, '2020-11-28', 'EE', 'Estonia', 'EURO', '368', '11323', '5', '104');
INSERT INTO public.who_global_data_import VALUES (26332, '2020-11-29', 'EE', 'Estonia', 'EURO', '375', '11698', '5', '109');
INSERT INTO public.who_global_data_import VALUES (26333, '2020-11-30', 'EE', 'Estonia', 'EURO', '354', '12052', '3', '112');
INSERT INTO public.who_global_data_import VALUES (26334, '2020-12-01', 'EE', 'Estonia', 'EURO', '256', '12308', '6', '118');
INSERT INTO public.who_global_data_import VALUES (26335, '2020-12-02', 'EE', 'Estonia', 'EURO', '189', '12497', '3', '121');
INSERT INTO public.who_global_data_import VALUES (26336, '2020-12-03', 'EE', 'Estonia', 'EURO', '522', '13019', '1', '122');
INSERT INTO public.who_global_data_import VALUES (26337, '2020-12-04', 'EE', 'Estonia', 'EURO', '450', '13469', '1', '123');
INSERT INTO public.who_global_data_import VALUES (26338, '2020-12-05', 'EE', 'Estonia', 'EURO', '470', '13939', '2', '125');
INSERT INTO public.who_global_data_import VALUES (26339, '2020-12-06', 'EE', 'Estonia', 'EURO', '561', '14500', '1', '126');
INSERT INTO public.who_global_data_import VALUES (26340, '2020-12-07', 'EE', 'Estonia', 'EURO', '478', '14978', '5', '131');
INSERT INTO public.who_global_data_import VALUES (26341, '2020-12-08', 'EE', 'Estonia', 'EURO', '248', '15226', '3', '134');
INSERT INTO public.who_global_data_import VALUES (26342, '2020-12-09', 'EE', 'Estonia', 'EURO', '284', '15510', '3', '137');
INSERT INTO public.who_global_data_import VALUES (26343, '2020-12-10', 'EE', 'Estonia', 'EURO', '544', '16054', '2', '139');
INSERT INTO public.who_global_data_import VALUES (26344, '2020-12-11', 'EE', 'Estonia', 'EURO', '544', '16598', '2', '141');
INSERT INTO public.who_global_data_import VALUES (26345, '2020-12-12', 'EE', 'Estonia', 'EURO', '358', '16956', '1', '142');
INSERT INTO public.who_global_data_import VALUES (26346, '2020-12-13', 'EE', 'Estonia', 'EURO', '757', '17713', '6', '148');
INSERT INTO public.who_global_data_import VALUES (26347, '2020-12-14', 'EE', 'Estonia', 'EURO', '342', '18055', '1', '149');
INSERT INTO public.who_global_data_import VALUES (26348, '2020-12-15', 'EE', 'Estonia', 'EURO', '331', '18386', '5', '154');
INSERT INTO public.who_global_data_import VALUES (26349, '2020-12-16', 'EE', 'Estonia', 'EURO', '885', '19271', '3', '157');
INSERT INTO public.who_global_data_import VALUES (26350, '2020-12-17', 'EE', 'Estonia', 'EURO', '733', '20004', '7', '164');
INSERT INTO public.who_global_data_import VALUES (26351, '2020-12-18', 'EE', 'Estonia', 'EURO', '654', '20658', '4', '168');
INSERT INTO public.who_global_data_import VALUES (26352, '2020-12-19', 'EE', 'Estonia', 'EURO', '561', '21219', '2', '170');
INSERT INTO public.who_global_data_import VALUES (26353, '2020-12-20', 'EE', 'Estonia', 'EURO', '575', '21794', '4', '174');
INSERT INTO public.who_global_data_import VALUES (26354, '2020-12-21', 'EE', 'Estonia', 'EURO', '289', '22083', '7', '181');
INSERT INTO public.who_global_data_import VALUES (26355, '2020-12-22', 'EE', 'Estonia', 'EURO', '564', '22647', '6', '187');
INSERT INTO public.who_global_data_import VALUES (26356, '2020-12-23', 'EE', 'Estonia', 'EURO', '662', '23309', '5', '192');
INSERT INTO public.who_global_data_import VALUES (26357, '2020-12-24', 'EE', 'Estonia', 'EURO', '700', '24009', '3', '195');
INSERT INTO public.who_global_data_import VALUES (26358, '2020-12-25', 'EE', 'Estonia', 'EURO', '573', '24582', '7', '202');
INSERT INTO public.who_global_data_import VALUES (26359, '2020-12-26', 'EE', 'Estonia', 'EURO', '445', '25027', '0', '202');
INSERT INTO public.who_global_data_import VALUES (26360, '2020-12-27', 'EE', 'Estonia', 'EURO', '365', '25392', '2', '204');
INSERT INTO public.who_global_data_import VALUES (26361, '2020-12-28', 'EE', 'Estonia', 'EURO', '416', '25808', '9', '213');
INSERT INTO public.who_global_data_import VALUES (26362, '2020-12-29', 'EE', 'Estonia', 'EURO', '475', '26283', '0', '213');
INSERT INTO public.who_global_data_import VALUES (26363, '2020-12-30', 'EE', 'Estonia', 'EURO', '973', '27256', '13', '226');
INSERT INTO public.who_global_data_import VALUES (26364, '2020-12-31', 'EE', 'Estonia', 'EURO', '734', '27990', '3', '229');
INSERT INTO public.who_global_data_import VALUES (26365, '2021-01-01', 'EE', 'Estonia', 'EURO', '416', '28406', '5', '234');
INSERT INTO public.who_global_data_import VALUES (26366, '2021-01-02', 'EE', 'Estonia', 'EURO', '383', '28789', '7', '241');
INSERT INTO public.who_global_data_import VALUES (26367, '2021-01-03', 'EE', 'Estonia', 'EURO', '342', '29131', '3', '244');
INSERT INTO public.who_global_data_import VALUES (26368, '2021-01-04', 'EE', 'Estonia', 'EURO', '390', '29521', '7', '251');
INSERT INTO public.who_global_data_import VALUES (26369, '2021-01-05', 'EE', 'Estonia', 'EURO', '429', '29950', '7', '258');
INSERT INTO public.who_global_data_import VALUES (26370, '2021-01-06', 'EE', 'Estonia', 'EURO', '717', '30667', '0', '258');
INSERT INTO public.who_global_data_import VALUES (26371, '2021-01-07', 'EE', 'Estonia', 'EURO', '1084', '31751', '7', '265');
INSERT INTO public.who_global_data_import VALUES (26372, '2021-01-08', 'EE', 'Estonia', 'EURO', '786', '32537', '5', '270');
INSERT INTO public.who_global_data_import VALUES (26373, '2021-01-09', 'EE', 'Estonia', 'EURO', '552', '33089', '8', '278');
INSERT INTO public.who_global_data_import VALUES (26374, '2021-01-10', 'EE', 'Estonia', 'EURO', '427', '33516', '5', '283');
INSERT INTO public.who_global_data_import VALUES (26375, '2021-01-11', 'EE', 'Estonia', 'EURO', '289', '33805', '4', '287');
INSERT INTO public.who_global_data_import VALUES (26376, '2021-01-12', 'EE', 'Estonia', 'EURO', '333', '34138', '5', '292');
INSERT INTO public.who_global_data_import VALUES (26377, '2021-01-13', 'EE', 'Estonia', 'EURO', '853', '34991', '0', '292');
INSERT INTO public.who_global_data_import VALUES (26378, '2021-01-14', 'EE', 'Estonia', 'EURO', '630', '35621', '9', '301');
INSERT INTO public.who_global_data_import VALUES (26379, '2021-01-15', 'EE', 'Estonia', 'EURO', '475', '36096', '10', '311');
INSERT INTO public.who_global_data_import VALUES (26380, '2021-01-16', 'EE', 'Estonia', 'EURO', '595', '36691', '9', '320');
INSERT INTO public.who_global_data_import VALUES (26381, '2021-01-17', 'EE', 'Estonia', 'EURO', '388', '37079', '5', '325');
INSERT INTO public.who_global_data_import VALUES (26382, '2021-01-18', 'EE', 'Estonia', 'EURO', '265', '37344', '8', '333');
INSERT INTO public.who_global_data_import VALUES (26383, '2021-01-19', 'EE', 'Estonia', 'EURO', '597', '37941', '11', '344');
INSERT INTO public.who_global_data_import VALUES (26384, '2021-01-20', 'EE', 'Estonia', 'EURO', '603', '38544', '5', '349');
INSERT INTO public.who_global_data_import VALUES (26385, '2021-01-21', 'EE', 'Estonia', 'EURO', '668', '39212', '5', '354');
INSERT INTO public.who_global_data_import VALUES (26386, '2021-01-22', 'EE', 'Estonia', 'EURO', '489', '39701', '4', '358');
INSERT INTO public.who_global_data_import VALUES (26387, '2021-01-23', 'EE', 'Estonia', 'EURO', '483', '40184', '10', '368');
INSERT INTO public.who_global_data_import VALUES (26388, '2021-01-24', 'EE', 'Estonia', 'EURO', '532', '40716', '8', '376');
INSERT INTO public.who_global_data_import VALUES (26389, '2021-01-25', 'EE', 'Estonia', 'EURO', '259', '40975', '7', '383');
INSERT INTO public.who_global_data_import VALUES (26390, '2021-01-26', 'EE', 'Estonia', 'EURO', '355', '41330', '9', '392');
INSERT INTO public.who_global_data_import VALUES (26391, '2021-01-27', 'EE', 'Estonia', 'EURO', '636', '41966', '6', '398');
INSERT INTO public.who_global_data_import VALUES (26392, '2021-01-28', 'EE', 'Estonia', 'EURO', '690', '42656', '8', '406');
INSERT INTO public.who_global_data_import VALUES (26393, '2021-01-29', 'EE', 'Estonia', 'EURO', '687', '43343', '3', '409');
INSERT INTO public.who_global_data_import VALUES (26394, '2021-01-30', 'EE', 'Estonia', 'EURO', '404', '43747', '2', '411');
INSERT INTO public.who_global_data_import VALUES (26395, '2021-01-31', 'EE', 'Estonia', 'EURO', '461', '44208', '8', '419');
INSERT INTO public.who_global_data_import VALUES (26396, '2021-02-01', 'EE', 'Estonia', 'EURO', '367', '44575', '3', '422');
INSERT INTO public.who_global_data_import VALUES (26397, '2021-02-02', 'EE', 'Estonia', 'EURO', '403', '44978', '2', '424');
INSERT INTO public.who_global_data_import VALUES (26398, '2021-02-03', 'EE', 'Estonia', 'EURO', '685', '45663', '9', '433');
INSERT INTO public.who_global_data_import VALUES (26399, '2021-02-04', 'EE', 'Estonia', 'EURO', '671', '46334', '10', '443');
INSERT INTO public.who_global_data_import VALUES (26400, '2021-02-05', 'EE', 'Estonia', 'EURO', '591', '46925', '4', '447');
INSERT INTO public.who_global_data_import VALUES (26401, '2020-01-03', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26402, '2020-01-04', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26403, '2020-01-05', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26404, '2020-01-06', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26405, '2020-01-07', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26406, '2020-01-08', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26407, '2020-01-09', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26408, '2020-01-10', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26409, '2020-01-11', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26410, '2020-01-12', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26411, '2020-01-13', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26412, '2020-01-14', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26413, '2020-01-15', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26414, '2020-01-16', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26415, '2020-01-17', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26416, '2020-01-18', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26417, '2020-01-19', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26418, '2020-01-20', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26419, '2020-01-21', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26420, '2020-01-22', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26421, '2020-01-23', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26422, '2020-01-24', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26423, '2020-01-25', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26424, '2020-01-26', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26425, '2020-01-27', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26426, '2020-01-28', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26427, '2020-01-29', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26428, '2020-01-30', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26429, '2020-01-31', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26430, '2020-02-01', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26431, '2020-02-02', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26432, '2020-02-03', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26433, '2020-02-04', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26434, '2020-02-05', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26435, '2020-02-06', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26436, '2020-02-07', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26437, '2020-02-08', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26438, '2020-02-09', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26439, '2020-02-10', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26440, '2020-02-11', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26441, '2020-02-12', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26442, '2020-02-13', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26443, '2020-02-14', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26444, '2020-02-15', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26445, '2020-02-16', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26446, '2020-02-17', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26447, '2020-02-18', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26448, '2020-02-19', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26449, '2020-02-20', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26450, '2020-02-21', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26451, '2020-02-22', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26452, '2020-02-23', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26453, '2020-02-24', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26454, '2020-02-25', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26455, '2020-02-26', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26456, '2020-02-27', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26457, '2020-02-28', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26458, '2020-02-29', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26459, '2020-03-01', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26460, '2020-03-02', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26461, '2020-03-03', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26462, '2020-03-04', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26463, '2020-03-05', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26464, '2020-03-06', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26465, '2020-03-07', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26466, '2020-03-08', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26467, '2020-03-09', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26468, '2020-03-10', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26469, '2020-03-11', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26470, '2020-03-12', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26471, '2020-03-13', 'SZ', 'Eswatini', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26472, '2020-03-14', 'SZ', 'Eswatini', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26473, '2020-03-15', 'SZ', 'Eswatini', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26474, '2020-03-16', 'SZ', 'Eswatini', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26475, '2020-03-17', 'SZ', 'Eswatini', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26476, '2020-03-18', 'SZ', 'Eswatini', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26477, '2020-03-19', 'SZ', 'Eswatini', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26478, '2020-03-20', 'SZ', 'Eswatini', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26479, '2020-03-21', 'SZ', 'Eswatini', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26480, '2020-03-22', 'SZ', 'Eswatini', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26481, '2020-03-23', 'SZ', 'Eswatini', 'AFRO', '-1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26482, '2020-03-24', 'SZ', 'Eswatini', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26483, '2020-03-25', 'SZ', 'Eswatini', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26484, '2020-03-26', 'SZ', 'Eswatini', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26485, '2020-03-27', 'SZ', 'Eswatini', 'AFRO', '2', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26486, '2020-03-28', 'SZ', 'Eswatini', 'AFRO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26487, '2020-03-29', 'SZ', 'Eswatini', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26488, '2020-03-30', 'SZ', 'Eswatini', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26489, '2020-03-31', 'SZ', 'Eswatini', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26490, '2020-04-01', 'SZ', 'Eswatini', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26491, '2020-04-02', 'SZ', 'Eswatini', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26492, '2020-04-03', 'SZ', 'Eswatini', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26493, '2020-04-04', 'SZ', 'Eswatini', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26494, '2020-04-05', 'SZ', 'Eswatini', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26495, '2020-04-06', 'SZ', 'Eswatini', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26496, '2020-04-07', 'SZ', 'Eswatini', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26497, '2020-04-08', 'SZ', 'Eswatini', 'AFRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26498, '2020-04-09', 'SZ', 'Eswatini', 'AFRO', '2', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26499, '2020-04-10', 'SZ', 'Eswatini', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26500, '2020-04-11', 'SZ', 'Eswatini', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26501, '2020-04-12', 'SZ', 'Eswatini', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26502, '2020-04-13', 'SZ', 'Eswatini', 'AFRO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26503, '2020-04-14', 'SZ', 'Eswatini', 'AFRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26504, '2020-04-15', 'SZ', 'Eswatini', 'AFRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26505, '2020-04-16', 'SZ', 'Eswatini', 'AFRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26506, '2020-04-17', 'SZ', 'Eswatini', 'AFRO', '0', '16', '1', '1');
INSERT INTO public.who_global_data_import VALUES (26507, '2020-04-18', 'SZ', 'Eswatini', 'AFRO', '3', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26508, '2020-04-19', 'SZ', 'Eswatini', 'AFRO', '3', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26509, '2020-04-20', 'SZ', 'Eswatini', 'AFRO', '0', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26510, '2020-04-21', 'SZ', 'Eswatini', 'AFRO', '2', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26511, '2020-04-22', 'SZ', 'Eswatini', 'AFRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26512, '2020-04-23', 'SZ', 'Eswatini', 'AFRO', '7', '31', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26513, '2020-04-24', 'SZ', 'Eswatini', 'AFRO', '0', '31', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26514, '2020-04-25', 'SZ', 'Eswatini', 'AFRO', '9', '40', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26515, '2020-04-26', 'SZ', 'Eswatini', 'AFRO', '16', '56', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26516, '2020-04-27', 'SZ', 'Eswatini', 'AFRO', '3', '59', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26517, '2020-04-28', 'SZ', 'Eswatini', 'AFRO', '6', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26518, '2020-04-29', 'SZ', 'Eswatini', 'AFRO', '6', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26519, '2020-04-30', 'SZ', 'Eswatini', 'AFRO', '20', '91', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26520, '2020-05-01', 'SZ', 'Eswatini', 'AFRO', '9', '100', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26521, '2020-05-02', 'SZ', 'Eswatini', 'AFRO', '6', '106', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26522, '2020-05-03', 'SZ', 'Eswatini', 'AFRO', '2', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26523, '2020-05-04', 'SZ', 'Eswatini', 'AFRO', '4', '112', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26524, '2020-05-05', 'SZ', 'Eswatini', 'AFRO', '4', '116', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26525, '2020-05-06', 'SZ', 'Eswatini', 'AFRO', '3', '119', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26526, '2020-05-07', 'SZ', 'Eswatini', 'AFRO', '4', '123', '1', '2');
INSERT INTO public.who_global_data_import VALUES (26527, '2020-05-08', 'SZ', 'Eswatini', 'AFRO', '30', '153', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26528, '2020-05-09', 'SZ', 'Eswatini', 'AFRO', '6', '159', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26529, '2020-05-10', 'SZ', 'Eswatini', 'AFRO', '4', '163', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26530, '2020-05-11', 'SZ', 'Eswatini', 'AFRO', '9', '172', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26531, '2020-05-12', 'SZ', 'Eswatini', 'AFRO', '3', '175', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26532, '2020-05-13', 'SZ', 'Eswatini', 'AFRO', '9', '184', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26533, '2020-05-14', 'SZ', 'Eswatini', 'AFRO', '3', '187', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26534, '2020-05-15', 'SZ', 'Eswatini', 'AFRO', '0', '187', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26535, '2020-05-16', 'SZ', 'Eswatini', 'AFRO', '3', '190', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26536, '2020-05-17', 'SZ', 'Eswatini', 'AFRO', '12', '202', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26537, '2020-05-18', 'SZ', 'Eswatini', 'AFRO', '1', '203', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26538, '2020-05-19', 'SZ', 'Eswatini', 'AFRO', '2', '205', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26539, '2020-05-20', 'SZ', 'Eswatini', 'AFRO', '3', '208', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26540, '2020-05-21', 'SZ', 'Eswatini', 'AFRO', '9', '217', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26541, '2020-05-22', 'SZ', 'Eswatini', 'AFRO', '3', '220', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26542, '2020-05-23', 'SZ', 'Eswatini', 'AFRO', '5', '225', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26543, '2020-05-24', 'SZ', 'Eswatini', 'AFRO', '13', '238', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26544, '2020-05-25', 'SZ', 'Eswatini', 'AFRO', '12', '250', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26545, '2020-05-26', 'SZ', 'Eswatini', 'AFRO', '6', '256', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26546, '2020-05-27', 'SZ', 'Eswatini', 'AFRO', '5', '261', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26547, '2020-05-28', 'SZ', 'Eswatini', 'AFRO', '11', '272', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26548, '2020-05-29', 'SZ', 'Eswatini', 'AFRO', '7', '279', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26549, '2020-05-30', 'SZ', 'Eswatini', 'AFRO', '0', '279', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26550, '2020-05-31', 'SZ', 'Eswatini', 'AFRO', '4', '283', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26551, '2020-06-01', 'SZ', 'Eswatini', 'AFRO', '2', '285', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26552, '2020-06-02', 'SZ', 'Eswatini', 'AFRO', '8', '293', '1', '3');
INSERT INTO public.who_global_data_import VALUES (26553, '2020-06-03', 'SZ', 'Eswatini', 'AFRO', '1', '294', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26554, '2020-06-04', 'SZ', 'Eswatini', 'AFRO', '1', '295', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26555, '2020-06-05', 'SZ', 'Eswatini', 'AFRO', '5', '300', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26556, '2020-06-06', 'SZ', 'Eswatini', 'AFRO', '5', '305', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26557, '2020-06-07', 'SZ', 'Eswatini', 'AFRO', '17', '322', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26558, '2020-06-08', 'SZ', 'Eswatini', 'AFRO', '11', '333', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26559, '2020-06-09', 'SZ', 'Eswatini', 'AFRO', '7', '340', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26560, '2020-06-10', 'SZ', 'Eswatini', 'AFRO', '31', '371', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26561, '2020-06-11', 'SZ', 'Eswatini', 'AFRO', '27', '398', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26562, '2020-06-12', 'SZ', 'Eswatini', 'AFRO', '51', '449', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26563, '2020-06-13', 'SZ', 'Eswatini', 'AFRO', '23', '472', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26564, '2020-06-14', 'SZ', 'Eswatini', 'AFRO', '14', '486', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26565, '2020-06-15', 'SZ', 'Eswatini', 'AFRO', '4', '490', '1', '4');
INSERT INTO public.who_global_data_import VALUES (26566, '2020-06-16', 'SZ', 'Eswatini', 'AFRO', '16', '506', '0', '4');
INSERT INTO public.who_global_data_import VALUES (26567, '2020-06-17', 'SZ', 'Eswatini', 'AFRO', '14', '520', '0', '4');
INSERT INTO public.who_global_data_import VALUES (26568, '2020-06-18', 'SZ', 'Eswatini', 'AFRO', '43', '563', '0', '4');
INSERT INTO public.who_global_data_import VALUES (26569, '2020-06-19', 'SZ', 'Eswatini', 'AFRO', '23', '586', '0', '4');
INSERT INTO public.who_global_data_import VALUES (26570, '2020-06-20', 'SZ', 'Eswatini', 'AFRO', '37', '623', '0', '4');
INSERT INTO public.who_global_data_import VALUES (26571, '2020-06-21', 'SZ', 'Eswatini', 'AFRO', '4', '627', '1', '5');
INSERT INTO public.who_global_data_import VALUES (26572, '2020-06-22', 'SZ', 'Eswatini', 'AFRO', '8', '635', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26573, '2020-06-23', 'SZ', 'Eswatini', 'AFRO', '8', '643', '1', '6');
INSERT INTO public.who_global_data_import VALUES (26574, '2020-06-24', 'SZ', 'Eswatini', 'AFRO', '31', '674', '1', '7');
INSERT INTO public.who_global_data_import VALUES (26575, '2020-06-25', 'SZ', 'Eswatini', 'AFRO', '16', '690', '0', '7');
INSERT INTO public.who_global_data_import VALUES (26576, '2020-06-26', 'SZ', 'Eswatini', 'AFRO', '16', '706', '1', '8');
INSERT INTO public.who_global_data_import VALUES (26577, '2020-06-27', 'SZ', 'Eswatini', 'AFRO', '25', '731', '0', '8');
INSERT INTO public.who_global_data_import VALUES (26578, '2020-06-28', 'SZ', 'Eswatini', 'AFRO', '14', '745', '0', '8');
INSERT INTO public.who_global_data_import VALUES (26579, '2020-06-29', 'SZ', 'Eswatini', 'AFRO', '36', '781', '3', '11');
INSERT INTO public.who_global_data_import VALUES (26580, '2020-06-30', 'SZ', 'Eswatini', 'AFRO', '14', '795', '0', '11');
INSERT INTO public.who_global_data_import VALUES (26581, '2020-07-01', 'SZ', 'Eswatini', 'AFRO', '17', '812', '0', '11');
INSERT INTO public.who_global_data_import VALUES (26582, '2020-07-02', 'SZ', 'Eswatini', 'AFRO', '28', '840', '0', '11');
INSERT INTO public.who_global_data_import VALUES (26583, '2020-07-03', 'SZ', 'Eswatini', 'AFRO', '33', '873', '0', '11');
INSERT INTO public.who_global_data_import VALUES (26584, '2020-07-04', 'SZ', 'Eswatini', 'AFRO', '36', '909', '2', '13');
INSERT INTO public.who_global_data_import VALUES (26585, '2020-07-05', 'SZ', 'Eswatini', 'AFRO', '45', '954', '0', '13');
INSERT INTO public.who_global_data_import VALUES (26586, '2020-07-06', 'SZ', 'Eswatini', 'AFRO', '34', '988', '0', '13');
INSERT INTO public.who_global_data_import VALUES (26587, '2020-07-07', 'SZ', 'Eswatini', 'AFRO', '23', '1011', '0', '13');
INSERT INTO public.who_global_data_import VALUES (26588, '2020-07-08', 'SZ', 'Eswatini', 'AFRO', '45', '1056', '1', '14');
INSERT INTO public.who_global_data_import VALUES (26589, '2020-07-09', 'SZ', 'Eswatini', 'AFRO', '82', '1138', '0', '14');
INSERT INTO public.who_global_data_import VALUES (26590, '2020-07-10', 'SZ', 'Eswatini', 'AFRO', '75', '1213', '3', '17');
INSERT INTO public.who_global_data_import VALUES (26591, '2020-07-11', 'SZ', 'Eswatini', 'AFRO', '44', '1257', '1', '18');
INSERT INTO public.who_global_data_import VALUES (26592, '2020-07-12', 'SZ', 'Eswatini', 'AFRO', '54', '1311', '0', '18');
INSERT INTO public.who_global_data_import VALUES (26593, '2020-07-13', 'SZ', 'Eswatini', 'AFRO', '40', '1351', '2', '20');
INSERT INTO public.who_global_data_import VALUES (26594, '2020-07-14', 'SZ', 'Eswatini', 'AFRO', '38', '1389', '0', '20');
INSERT INTO public.who_global_data_import VALUES (26595, '2020-07-15', 'SZ', 'Eswatini', 'AFRO', '45', '1434', '0', '20');
INSERT INTO public.who_global_data_import VALUES (26596, '2020-07-16', 'SZ', 'Eswatini', 'AFRO', '55', '1489', '0', '20');
INSERT INTO public.who_global_data_import VALUES (26597, '2020-07-17', 'SZ', 'Eswatini', 'AFRO', '63', '1552', '1', '21');
INSERT INTO public.who_global_data_import VALUES (26598, '2020-07-18', 'SZ', 'Eswatini', 'AFRO', '67', '1619', '0', '21');
INSERT INTO public.who_global_data_import VALUES (26599, '2020-07-19', 'SZ', 'Eswatini', 'AFRO', '110', '1729', '0', '21');
INSERT INTO public.who_global_data_import VALUES (26600, '2020-07-20', 'SZ', 'Eswatini', 'AFRO', '64', '1793', '0', '21');
INSERT INTO public.who_global_data_import VALUES (26601, '2020-07-21', 'SZ', 'Eswatini', 'AFRO', '33', '1826', '2', '23');
INSERT INTO public.who_global_data_import VALUES (26602, '2020-07-22', 'SZ', 'Eswatini', 'AFRO', '68', '1894', '1', '24');
INSERT INTO public.who_global_data_import VALUES (26603, '2020-07-23', 'SZ', 'Eswatini', 'AFRO', '44', '1938', '1', '25');
INSERT INTO public.who_global_data_import VALUES (26604, '2020-07-24', 'SZ', 'Eswatini', 'AFRO', '83', '2021', '3', '28');
INSERT INTO public.who_global_data_import VALUES (26605, '2020-07-25', 'SZ', 'Eswatini', 'AFRO', '52', '2073', '0', '28');
INSERT INTO public.who_global_data_import VALUES (26606, '2020-07-26', 'SZ', 'Eswatini', 'AFRO', '69', '2142', '0', '28');
INSERT INTO public.who_global_data_import VALUES (26607, '2020-07-27', 'SZ', 'Eswatini', 'AFRO', '65', '2207', '4', '32');
INSERT INTO public.who_global_data_import VALUES (26608, '2020-07-28', 'SZ', 'Eswatini', 'AFRO', '109', '2316', '2', '34');
INSERT INTO public.who_global_data_import VALUES (26609, '2020-07-29', 'SZ', 'Eswatini', 'AFRO', '88', '2404', '5', '39');
INSERT INTO public.who_global_data_import VALUES (26610, '2020-07-30', 'SZ', 'Eswatini', 'AFRO', '147', '2551', '1', '40');
INSERT INTO public.who_global_data_import VALUES (26611, '2020-07-31', 'SZ', 'Eswatini', 'AFRO', '26', '2577', '0', '40');
INSERT INTO public.who_global_data_import VALUES (26612, '2020-08-01', 'SZ', 'Eswatini', 'AFRO', '71', '2648', '0', '40');
INSERT INTO public.who_global_data_import VALUES (26613, '2020-08-02', 'SZ', 'Eswatini', 'AFRO', '58', '2706', '2', '42');
INSERT INTO public.who_global_data_import VALUES (26614, '2020-08-03', 'SZ', 'Eswatini', 'AFRO', '69', '2775', '0', '42');
INSERT INTO public.who_global_data_import VALUES (26615, '2020-08-04', 'SZ', 'Eswatini', 'AFRO', '63', '2838', '0', '42');
INSERT INTO public.who_global_data_import VALUES (26616, '2020-08-05', 'SZ', 'Eswatini', 'AFRO', '18', '2856', '7', '49');
INSERT INTO public.who_global_data_import VALUES (26617, '2020-08-06', 'SZ', 'Eswatini', 'AFRO', '53', '2909', '4', '53');
INSERT INTO public.who_global_data_import VALUES (26618, '2020-08-07', 'SZ', 'Eswatini', 'AFRO', '59', '2968', '2', '55');
INSERT INTO public.who_global_data_import VALUES (26619, '2020-08-08', 'SZ', 'Eswatini', 'AFRO', '68', '3036', '1', '56');
INSERT INTO public.who_global_data_import VALUES (26620, '2020-08-09', 'SZ', 'Eswatini', 'AFRO', '92', '3128', '0', '56');
INSERT INTO public.who_global_data_import VALUES (26621, '2020-08-10', 'SZ', 'Eswatini', 'AFRO', '108', '3236', '2', '58');
INSERT INTO public.who_global_data_import VALUES (26622, '2020-08-11', 'SZ', 'Eswatini', 'AFRO', '73', '3309', '3', '61');
INSERT INTO public.who_global_data_import VALUES (26623, '2020-08-12', 'SZ', 'Eswatini', 'AFRO', '101', '3410', '2', '63');
INSERT INTO public.who_global_data_import VALUES (26624, '2020-08-13', 'SZ', 'Eswatini', 'AFRO', '115', '3525', '0', '63');
INSERT INTO public.who_global_data_import VALUES (26625, '2020-08-14', 'SZ', 'Eswatini', 'AFRO', '74', '3599', '2', '65');
INSERT INTO public.who_global_data_import VALUES (26626, '2020-08-15', 'SZ', 'Eswatini', 'AFRO', '71', '3670', '3', '68');
INSERT INTO public.who_global_data_import VALUES (26627, '2020-08-16', 'SZ', 'Eswatini', 'AFRO', '75', '3745', '1', '69');
INSERT INTO public.who_global_data_import VALUES (26628, '2020-08-17', 'SZ', 'Eswatini', 'AFRO', '94', '3839', '1', '70');
INSERT INTO public.who_global_data_import VALUES (26629, '2020-08-18', 'SZ', 'Eswatini', 'AFRO', '55', '3894', '3', '73');
INSERT INTO public.who_global_data_import VALUES (26630, '2020-08-19', 'SZ', 'Eswatini', 'AFRO', '95', '3989', '3', '76');
INSERT INTO public.who_global_data_import VALUES (26631, '2020-08-20', 'SZ', 'Eswatini', 'AFRO', '69', '4058', '3', '79');
INSERT INTO public.who_global_data_import VALUES (26632, '2020-08-21', 'SZ', 'Eswatini', 'AFRO', '52', '4110', '2', '81');
INSERT INTO public.who_global_data_import VALUES (26633, '2020-08-22', 'SZ', 'Eswatini', 'AFRO', '18', '4128', '0', '81');
INSERT INTO public.who_global_data_import VALUES (26634, '2020-08-23', 'SZ', 'Eswatini', 'AFRO', '61', '4189', '2', '83');
INSERT INTO public.who_global_data_import VALUES (26635, '2020-08-24', 'SZ', 'Eswatini', 'AFRO', '36', '4225', '2', '85');
INSERT INTO public.who_global_data_import VALUES (26636, '2020-08-25', 'SZ', 'Eswatini', 'AFRO', '79', '4304', '0', '85');
INSERT INTO public.who_global_data_import VALUES (26637, '2020-08-26', 'SZ', 'Eswatini', 'AFRO', '23', '4327', '1', '86');
INSERT INTO public.who_global_data_import VALUES (26638, '2020-08-27', 'SZ', 'Eswatini', 'AFRO', '60', '4387', '2', '88');
INSERT INTO public.who_global_data_import VALUES (26639, '2020-08-28', 'SZ', 'Eswatini', 'AFRO', '46', '4433', '1', '89');
INSERT INTO public.who_global_data_import VALUES (26640, '2020-08-29', 'SZ', 'Eswatini', 'AFRO', '28', '4461', '4', '93');
INSERT INTO public.who_global_data_import VALUES (26641, '2020-08-30', 'SZ', 'Eswatini', 'AFRO', '49', '4510', '-2', '91');
INSERT INTO public.who_global_data_import VALUES (26642, '2020-08-31', 'SZ', 'Eswatini', 'AFRO', '51', '4561', '0', '91');
INSERT INTO public.who_global_data_import VALUES (26643, '2020-09-01', 'SZ', 'Eswatini', 'AFRO', '16', '4577', '0', '91');
INSERT INTO public.who_global_data_import VALUES (26644, '2020-09-02', 'SZ', 'Eswatini', 'AFRO', '41', '4618', '3', '94');
INSERT INTO public.who_global_data_import VALUES (26645, '2020-09-03', 'SZ', 'Eswatini', 'AFRO', '50', '4668', '0', '94');
INSERT INTO public.who_global_data_import VALUES (26646, '2020-09-04', 'SZ', 'Eswatini', 'AFRO', '52', '4720', '0', '94');
INSERT INTO public.who_global_data_import VALUES (26647, '2020-09-05', 'SZ', 'Eswatini', 'AFRO', '60', '4780', '0', '94');
INSERT INTO public.who_global_data_import VALUES (26648, '2020-09-06', 'SZ', 'Eswatini', 'AFRO', '39', '4819', '0', '94');
INSERT INTO public.who_global_data_import VALUES (26649, '2020-09-07', 'SZ', 'Eswatini', 'AFRO', '34', '4853', '0', '94');
INSERT INTO public.who_global_data_import VALUES (26650, '2020-09-08', 'SZ', 'Eswatini', 'AFRO', '31', '4884', '0', '94');
INSERT INTO public.who_global_data_import VALUES (26651, '2020-09-09', 'SZ', 'Eswatini', 'AFRO', '20', '4904', '2', '96');
INSERT INTO public.who_global_data_import VALUES (26652, '2020-09-10', 'SZ', 'Eswatini', 'AFRO', '32', '4936', '1', '97');
INSERT INTO public.who_global_data_import VALUES (26653, '2020-09-11', 'SZ', 'Eswatini', 'AFRO', '58', '4994', '1', '98');
INSERT INTO public.who_global_data_import VALUES (26654, '2020-09-12', 'SZ', 'Eswatini', 'AFRO', '31', '5025', '0', '98');
INSERT INTO public.who_global_data_import VALUES (26655, '2020-09-13', 'SZ', 'Eswatini', 'AFRO', '25', '5050', '0', '98');
INSERT INTO public.who_global_data_import VALUES (26656, '2020-09-14', 'SZ', 'Eswatini', 'AFRO', '25', '5075', '0', '98');
INSERT INTO public.who_global_data_import VALUES (26657, '2020-09-15', 'SZ', 'Eswatini', 'AFRO', '29', '5104', '3', '101');
INSERT INTO public.who_global_data_import VALUES (26658, '2020-09-16', 'SZ', 'Eswatini', 'AFRO', '24', '5128', '0', '101');
INSERT INTO public.who_global_data_import VALUES (26659, '2020-09-17', 'SZ', 'Eswatini', 'AFRO', '27', '5155', '0', '101');
INSERT INTO public.who_global_data_import VALUES (26660, '2020-09-18', 'SZ', 'Eswatini', 'AFRO', '36', '5191', '2', '103');
INSERT INTO public.who_global_data_import VALUES (26661, '2020-09-19', 'SZ', 'Eswatini', 'AFRO', '24', '5215', '0', '103');
INSERT INTO public.who_global_data_import VALUES (26662, '2020-09-20', 'SZ', 'Eswatini', 'AFRO', '30', '5245', '1', '104');
INSERT INTO public.who_global_data_import VALUES (26663, '2020-09-21', 'SZ', 'Eswatini', 'AFRO', '24', '5269', '0', '104');
INSERT INTO public.who_global_data_import VALUES (26664, '2020-09-22', 'SZ', 'Eswatini', 'AFRO', '13', '5282', '0', '104');
INSERT INTO public.who_global_data_import VALUES (26665, '2020-09-23', 'SZ', 'Eswatini', 'AFRO', '25', '5307', '2', '106');
INSERT INTO public.who_global_data_import VALUES (26666, '2020-09-24', 'SZ', 'Eswatini', 'AFRO', '36', '5343', '2', '108');
INSERT INTO public.who_global_data_import VALUES (26667, '2020-09-25', 'SZ', 'Eswatini', 'AFRO', '32', '5375', '0', '108');
INSERT INTO public.who_global_data_import VALUES (26668, '2020-09-26', 'SZ', 'Eswatini', 'AFRO', '24', '5399', '0', '108');
INSERT INTO public.who_global_data_import VALUES (26669, '2020-09-27', 'SZ', 'Eswatini', 'AFRO', '20', '5419', '0', '108');
INSERT INTO public.who_global_data_import VALUES (26670, '2020-09-28', 'SZ', 'Eswatini', 'AFRO', '12', '5431', '0', '108');
INSERT INTO public.who_global_data_import VALUES (26671, '2020-09-29', 'SZ', 'Eswatini', 'AFRO', '21', '5452', '0', '108');
INSERT INTO public.who_global_data_import VALUES (26672, '2020-09-30', 'SZ', 'Eswatini', 'AFRO', '10', '5462', '0', '108');
INSERT INTO public.who_global_data_import VALUES (26673, '2020-10-01', 'SZ', 'Eswatini', 'AFRO', '20', '5482', '1', '109');
INSERT INTO public.who_global_data_import VALUES (26674, '2020-10-02', 'SZ', 'Eswatini', 'AFRO', '18', '5500', '2', '111');
INSERT INTO public.who_global_data_import VALUES (26675, '2020-10-03', 'SZ', 'Eswatini', 'AFRO', '21', '5521', '0', '111');
INSERT INTO public.who_global_data_import VALUES (26676, '2020-10-04', 'SZ', 'Eswatini', 'AFRO', '9', '5530', '0', '111');
INSERT INTO public.who_global_data_import VALUES (26677, '2020-10-05', 'SZ', 'Eswatini', 'AFRO', '39', '5569', '0', '111');
INSERT INTO public.who_global_data_import VALUES (26678, '2020-10-06', 'SZ', 'Eswatini', 'AFRO', '10', '5579', '1', '112');
INSERT INTO public.who_global_data_import VALUES (26679, '2020-10-07', 'SZ', 'Eswatini', 'AFRO', '19', '5598', '0', '112');
INSERT INTO public.who_global_data_import VALUES (26680, '2020-10-08', 'SZ', 'Eswatini', 'AFRO', '19', '5617', '1', '113');
INSERT INTO public.who_global_data_import VALUES (26681, '2020-10-09', 'SZ', 'Eswatini', 'AFRO', '15', '5632', '0', '113');
INSERT INTO public.who_global_data_import VALUES (26682, '2020-10-10', 'SZ', 'Eswatini', 'AFRO', '12', '5644', '0', '113');
INSERT INTO public.who_global_data_import VALUES (26683, '2020-10-11', 'SZ', 'Eswatini', 'AFRO', '16', '5660', '0', '113');
INSERT INTO public.who_global_data_import VALUES (26684, '2020-10-12', 'SZ', 'Eswatini', 'AFRO', '9', '5669', '0', '113');
INSERT INTO public.who_global_data_import VALUES (26685, '2020-10-13', 'SZ', 'Eswatini', 'AFRO', '14', '5683', '0', '113');
INSERT INTO public.who_global_data_import VALUES (26686, '2020-10-14', 'SZ', 'Eswatini', 'AFRO', '13', '5696', '1', '114');
INSERT INTO public.who_global_data_import VALUES (26687, '2020-10-15', 'SZ', 'Eswatini', 'AFRO', '19', '5715', '0', '114');
INSERT INTO public.who_global_data_import VALUES (26688, '2020-10-16', 'SZ', 'Eswatini', 'AFRO', '18', '5733', '1', '115');
INSERT INTO public.who_global_data_import VALUES (26689, '2020-10-17', 'SZ', 'Eswatini', 'AFRO', '13', '5746', '0', '115');
INSERT INTO public.who_global_data_import VALUES (26690, '2020-10-18', 'SZ', 'Eswatini', 'AFRO', '19', '5765', '0', '115');
INSERT INTO public.who_global_data_import VALUES (26691, '2020-10-19', 'SZ', 'Eswatini', 'AFRO', '15', '5780', '1', '116');
INSERT INTO public.who_global_data_import VALUES (26692, '2020-10-20', 'SZ', 'Eswatini', 'AFRO', '8', '5788', '0', '116');
INSERT INTO public.who_global_data_import VALUES (26693, '2020-10-21', 'SZ', 'Eswatini', 'AFRO', '12', '5800', '0', '116');
INSERT INTO public.who_global_data_import VALUES (26694, '2020-10-22', 'SZ', 'Eswatini', 'AFRO', '5', '5805', '0', '116');
INSERT INTO public.who_global_data_import VALUES (26695, '2020-10-23', 'SZ', 'Eswatini', 'AFRO', '9', '5814', '0', '116');
INSERT INTO public.who_global_data_import VALUES (26696, '2020-10-24', 'SZ', 'Eswatini', 'AFRO', '17', '5831', '0', '116');
INSERT INTO public.who_global_data_import VALUES (26697, '2020-10-25', 'SZ', 'Eswatini', 'AFRO', '16', '5847', '0', '116');
INSERT INTO public.who_global_data_import VALUES (26698, '2020-10-26', 'SZ', 'Eswatini', 'AFRO', '7', '5854', '0', '116');
INSERT INTO public.who_global_data_import VALUES (26699, '2020-10-27', 'SZ', 'Eswatini', 'AFRO', '9', '5863', '0', '116');
INSERT INTO public.who_global_data_import VALUES (26700, '2020-10-28', 'SZ', 'Eswatini', 'AFRO', '12', '5875', '0', '116');
INSERT INTO public.who_global_data_import VALUES (26701, '2020-10-29', 'SZ', 'Eswatini', 'AFRO', '11', '5886', '0', '116');
INSERT INTO public.who_global_data_import VALUES (26702, '2020-10-30', 'SZ', 'Eswatini', 'AFRO', '13', '5899', '1', '117');
INSERT INTO public.who_global_data_import VALUES (26703, '2020-10-31', 'SZ', 'Eswatini', 'AFRO', '10', '5909', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26704, '2020-11-01', 'SZ', 'Eswatini', 'AFRO', '8', '5917', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26705, '2020-11-02', 'SZ', 'Eswatini', 'AFRO', '8', '5925', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26706, '2020-11-03', 'SZ', 'Eswatini', 'AFRO', '4', '5929', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26707, '2020-11-04', 'SZ', 'Eswatini', 'AFRO', '13', '5942', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26708, '2020-11-05', 'SZ', 'Eswatini', 'AFRO', '13', '5955', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26709, '2020-11-06', 'SZ', 'Eswatini', 'AFRO', '12', '5967', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26710, '2020-11-07', 'SZ', 'Eswatini', 'AFRO', '9', '5976', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26711, '2020-11-08', 'SZ', 'Eswatini', 'AFRO', '13', '5989', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26712, '2020-11-09', 'SZ', 'Eswatini', 'AFRO', '14', '6003', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26713, '2020-11-10', 'SZ', 'Eswatini', 'AFRO', '10', '6013', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26714, '2020-11-11', 'SZ', 'Eswatini', 'AFRO', '11', '6024', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26715, '2020-11-12', 'SZ', 'Eswatini', 'AFRO', '20', '6044', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26716, '2020-11-13', 'SZ', 'Eswatini', 'AFRO', '16', '6060', '0', '117');
INSERT INTO public.who_global_data_import VALUES (26717, '2020-11-14', 'SZ', 'Eswatini', 'AFRO', '16', '6076', '1', '118');
INSERT INTO public.who_global_data_import VALUES (26718, '2020-11-15', 'SZ', 'Eswatini', 'AFRO', '17', '6093', '1', '119');
INSERT INTO public.who_global_data_import VALUES (26719, '2020-11-16', 'SZ', 'Eswatini', 'AFRO', '2', '6095', '0', '119');
INSERT INTO public.who_global_data_import VALUES (26720, '2020-11-17', 'SZ', 'Eswatini', 'AFRO', '10', '6105', '0', '119');
INSERT INTO public.who_global_data_import VALUES (26721, '2020-11-18', 'SZ', 'Eswatini', 'AFRO', '19', '6124', '0', '119');
INSERT INTO public.who_global_data_import VALUES (26722, '2020-11-19', 'SZ', 'Eswatini', 'AFRO', '20', '6144', '0', '119');
INSERT INTO public.who_global_data_import VALUES (26723, '2020-11-20', 'SZ', 'Eswatini', 'AFRO', '12', '6156', '0', '119');
INSERT INTO public.who_global_data_import VALUES (26724, '2020-11-21', 'SZ', 'Eswatini', 'AFRO', '29', '6185', '0', '119');
INSERT INTO public.who_global_data_import VALUES (26725, '2020-11-22', 'SZ', 'Eswatini', 'AFRO', '20', '6205', '0', '119');
INSERT INTO public.who_global_data_import VALUES (26726, '2020-11-23', 'SZ', 'Eswatini', 'AFRO', '14', '6219', '1', '120');
INSERT INTO public.who_global_data_import VALUES (26727, '2020-11-24', 'SZ', 'Eswatini', 'AFRO', '14', '6233', '0', '120');
INSERT INTO public.who_global_data_import VALUES (26728, '2020-11-25', 'SZ', 'Eswatini', 'AFRO', '14', '6247', '0', '120');
INSERT INTO public.who_global_data_import VALUES (26729, '2020-11-26', 'SZ', 'Eswatini', 'AFRO', '25', '6272', '0', '120');
INSERT INTO public.who_global_data_import VALUES (26730, '2020-11-27', 'SZ', 'Eswatini', 'AFRO', '57', '6329', '0', '120');
INSERT INTO public.who_global_data_import VALUES (26731, '2020-11-28', 'SZ', 'Eswatini', 'AFRO', '33', '6362', '0', '120');
INSERT INTO public.who_global_data_import VALUES (26732, '2020-11-29', 'SZ', 'Eswatini', 'AFRO', '44', '6406', '1', '121');
INSERT INTO public.who_global_data_import VALUES (26733, '2020-11-30', 'SZ', 'Eswatini', 'AFRO', '4', '6410', '0', '121');
INSERT INTO public.who_global_data_import VALUES (26734, '2020-12-01', 'SZ', 'Eswatini', 'AFRO', '9', '6419', '1', '122');
INSERT INTO public.who_global_data_import VALUES (26735, '2020-12-02', 'SZ', 'Eswatini', 'AFRO', '23', '6442', '0', '122');
INSERT INTO public.who_global_data_import VALUES (26736, '2020-12-03', 'SZ', 'Eswatini', 'AFRO', '13', '6455', '0', '122');
INSERT INTO public.who_global_data_import VALUES (26737, '2020-12-04', 'SZ', 'Eswatini', 'AFRO', '19', '6474', '0', '122');
INSERT INTO public.who_global_data_import VALUES (26738, '2020-12-05', 'SZ', 'Eswatini', 'AFRO', '6', '6480', '0', '122');
INSERT INTO public.who_global_data_import VALUES (26739, '2020-12-06', 'SZ', 'Eswatini', 'AFRO', '15', '6495', '0', '122');
INSERT INTO public.who_global_data_import VALUES (26740, '2020-12-07', 'SZ', 'Eswatini', 'AFRO', '6', '6501', '0', '122');
INSERT INTO public.who_global_data_import VALUES (26741, '2020-12-08', 'SZ', 'Eswatini', 'AFRO', '28', '6529', '1', '123');
INSERT INTO public.who_global_data_import VALUES (26742, '2020-12-09', 'SZ', 'Eswatini', 'AFRO', '34', '6563', '1', '124');
INSERT INTO public.who_global_data_import VALUES (26743, '2020-12-10', 'SZ', 'Eswatini', 'AFRO', '49', '6612', '1', '125');
INSERT INTO public.who_global_data_import VALUES (26744, '2020-12-11', 'SZ', 'Eswatini', 'AFRO', '21', '6633', '1', '126');
INSERT INTO public.who_global_data_import VALUES (26745, '2020-12-12', 'SZ', 'Eswatini', 'AFRO', '52', '6685', '0', '126');
INSERT INTO public.who_global_data_import VALUES (26746, '2020-12-13', 'SZ', 'Eswatini', 'AFRO', '29', '6714', '1', '127');
INSERT INTO public.who_global_data_import VALUES (26747, '2020-12-14', 'SZ', 'Eswatini', 'AFRO', '54', '6768', '0', '127');
INSERT INTO public.who_global_data_import VALUES (26748, '2020-12-15', 'SZ', 'Eswatini', 'AFRO', '57', '6825', '3', '130');
INSERT INTO public.who_global_data_import VALUES (26749, '2020-12-16', 'SZ', 'Eswatini', 'AFRO', '87', '6912', '2', '132');
INSERT INTO public.who_global_data_import VALUES (26750, '2020-12-17', 'SZ', 'Eswatini', 'AFRO', '114', '7026', '3', '135');
INSERT INTO public.who_global_data_import VALUES (26751, '2020-12-18', 'SZ', 'Eswatini', 'AFRO', '67', '7093', '0', '135');
INSERT INTO public.who_global_data_import VALUES (26752, '2020-12-19', 'SZ', 'Eswatini', 'AFRO', '109', '7202', '1', '136');
INSERT INTO public.who_global_data_import VALUES (26753, '2020-12-20', 'SZ', 'Eswatini', 'AFRO', '103', '7305', '1', '137');
INSERT INTO public.who_global_data_import VALUES (26754, '2020-12-21', 'SZ', 'Eswatini', 'AFRO', '122', '7427', '3', '140');
INSERT INTO public.who_global_data_import VALUES (26755, '2020-12-22', 'SZ', 'Eswatini', 'AFRO', '135', '7562', '1', '141');
INSERT INTO public.who_global_data_import VALUES (26756, '2020-12-23', 'SZ', 'Eswatini', 'AFRO', '153', '7715', '1', '142');
INSERT INTO public.who_global_data_import VALUES (26757, '2020-12-24', 'SZ', 'Eswatini', 'AFRO', '153', '7868', '11', '153');
INSERT INTO public.who_global_data_import VALUES (26758, '2020-12-25', 'SZ', 'Eswatini', 'AFRO', '164', '8032', '1', '154');
INSERT INTO public.who_global_data_import VALUES (26759, '2020-12-26', 'SZ', 'Eswatini', 'AFRO', '138', '8170', '0', '154');
INSERT INTO public.who_global_data_import VALUES (26760, '2020-12-27', 'SZ', 'Eswatini', 'AFRO', '197', '8367', '9', '163');
INSERT INTO public.who_global_data_import VALUES (26761, '2020-12-28', 'SZ', 'Eswatini', 'AFRO', '117', '8484', '2', '165');
INSERT INTO public.who_global_data_import VALUES (26762, '2020-12-29', 'SZ', 'Eswatini', 'AFRO', '0', '8484', '0', '165');
INSERT INTO public.who_global_data_import VALUES (26763, '2020-12-30', 'SZ', 'Eswatini', 'AFRO', '450', '8934', '11', '176');
INSERT INTO public.who_global_data_import VALUES (26764, '2020-12-31', 'SZ', 'Eswatini', 'AFRO', '212', '9146', '9', '185');
INSERT INTO public.who_global_data_import VALUES (26765, '2021-01-01', 'SZ', 'Eswatini', 'AFRO', '212', '9358', '21', '206');
INSERT INTO public.who_global_data_import VALUES (26766, '2021-01-02', 'SZ', 'Eswatini', 'AFRO', '0', '9358', '0', '206');
INSERT INTO public.who_global_data_import VALUES (26767, '2021-01-03', 'SZ', 'Eswatini', 'AFRO', '353', '9711', '21', '227');
INSERT INTO public.who_global_data_import VALUES (26768, '2021-01-04', 'SZ', 'Eswatini', 'AFRO', '232', '9943', '4', '231');
INSERT INTO public.who_global_data_import VALUES (26769, '2021-01-05', 'SZ', 'Eswatini', 'AFRO', '195', '10138', '13', '244');
INSERT INTO public.who_global_data_import VALUES (26770, '2021-01-06', 'SZ', 'Eswatini', 'AFRO', '200', '10338', '8', '252');
INSERT INTO public.who_global_data_import VALUES (26771, '2021-01-07', 'SZ', 'Eswatini', 'AFRO', '201', '10539', '9', '261');
INSERT INTO public.who_global_data_import VALUES (26772, '2021-01-08', 'SZ', 'Eswatini', 'AFRO', '234', '10773', '0', '261');
INSERT INTO public.who_global_data_import VALUES (26773, '2021-01-09', 'SZ', 'Eswatini', 'AFRO', '200', '10973', '18', '279');
INSERT INTO public.who_global_data_import VALUES (26774, '2021-01-10', 'SZ', 'Eswatini', 'AFRO', '207', '11180', '12', '291');
INSERT INTO public.who_global_data_import VALUES (26775, '2021-01-11', 'SZ', 'Eswatini', 'AFRO', '255', '11435', '4', '295');
INSERT INTO public.who_global_data_import VALUES (26776, '2021-01-12', 'SZ', 'Eswatini', 'AFRO', '276', '11711', '3', '298');
INSERT INTO public.who_global_data_import VALUES (26777, '2021-01-13', 'SZ', 'Eswatini', 'AFRO', '208', '11919', '21', '319');
INSERT INTO public.who_global_data_import VALUES (26778, '2021-01-14', 'SZ', 'Eswatini', 'AFRO', '205', '12124', '13', '332');
INSERT INTO public.who_global_data_import VALUES (26779, '2021-01-15', 'SZ', 'Eswatini', 'AFRO', '203', '12327', '3', '335');
INSERT INTO public.who_global_data_import VALUES (26780, '2021-01-16', 'SZ', 'Eswatini', 'AFRO', '0', '12327', '0', '335');
INSERT INTO public.who_global_data_import VALUES (26781, '2021-01-17', 'SZ', 'Eswatini', 'AFRO', '409', '12736', '25', '360');
INSERT INTO public.who_global_data_import VALUES (26782, '2021-01-18', 'SZ', 'Eswatini', 'AFRO', '208', '12944', '16', '376');
INSERT INTO public.who_global_data_import VALUES (26783, '2021-01-19', 'SZ', 'Eswatini', 'AFRO', '243', '13187', '8', '384');
INSERT INTO public.who_global_data_import VALUES (26784, '2021-01-20', 'SZ', 'Eswatini', 'AFRO', '256', '13443', '19', '403');
INSERT INTO public.who_global_data_import VALUES (26785, '2021-01-21', 'SZ', 'Eswatini', 'AFRO', '346', '13789', '24', '427');
INSERT INTO public.who_global_data_import VALUES (26786, '2021-01-22', 'SZ', 'Eswatini', 'AFRO', '228', '14017', '14', '441');
INSERT INTO public.who_global_data_import VALUES (26787, '2021-01-23', 'SZ', 'Eswatini', 'AFRO', '202', '14219', '17', '458');
INSERT INTO public.who_global_data_import VALUES (26788, '2021-01-24', 'SZ', 'Eswatini', 'AFRO', '111', '14330', '0', '458');
INSERT INTO public.who_global_data_import VALUES (26789, '2021-01-25', 'SZ', 'Eswatini', 'AFRO', '154', '14484', '21', '479');
INSERT INTO public.who_global_data_import VALUES (26790, '2021-01-26', 'SZ', 'Eswatini', 'AFRO', '0', '14484', '14', '493');
INSERT INTO public.who_global_data_import VALUES (26791, '2021-01-27', 'SZ', 'Eswatini', 'AFRO', '347', '14831', '24', '517');
INSERT INTO public.who_global_data_import VALUES (26792, '2021-01-28', 'SZ', 'Eswatini', 'AFRO', '220', '15051', '5', '522');
INSERT INTO public.who_global_data_import VALUES (26793, '2021-01-29', 'SZ', 'Eswatini', 'AFRO', '232', '15283', '16', '538');
INSERT INTO public.who_global_data_import VALUES (26794, '2021-01-30', 'SZ', 'Eswatini', 'AFRO', '188', '15471', '13', '551');
INSERT INTO public.who_global_data_import VALUES (26795, '2021-01-31', 'SZ', 'Eswatini', 'AFRO', '195', '15666', '11', '562');
INSERT INTO public.who_global_data_import VALUES (26796, '2021-02-01', 'SZ', 'Eswatini', 'AFRO', '45', '15711', '3', '565');
INSERT INTO public.who_global_data_import VALUES (26797, '2021-02-02', 'SZ', 'Eswatini', 'AFRO', '93', '15804', '9', '574');
INSERT INTO public.who_global_data_import VALUES (26798, '2021-02-03', 'SZ', 'Eswatini', 'AFRO', '74', '15878', '9', '583');
INSERT INTO public.who_global_data_import VALUES (26799, '2021-02-04', 'SZ', 'Eswatini', 'AFRO', '96', '15974', '2', '585');
INSERT INTO public.who_global_data_import VALUES (26800, '2021-02-05', 'SZ', 'Eswatini', 'AFRO', '71', '16045', '6', '591');
INSERT INTO public.who_global_data_import VALUES (26801, '2020-01-03', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26802, '2020-01-04', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26803, '2020-01-05', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26804, '2020-01-06', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26805, '2020-01-07', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26806, '2020-01-08', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26807, '2020-01-09', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26808, '2020-01-10', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26809, '2020-01-11', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26810, '2020-01-12', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26811, '2020-01-13', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26812, '2020-01-14', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26813, '2020-01-15', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26814, '2020-01-16', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26815, '2020-01-17', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26816, '2020-01-18', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26817, '2020-01-19', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26818, '2020-01-20', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26819, '2020-01-21', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26820, '2020-01-22', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26821, '2020-01-23', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26822, '2020-01-24', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26823, '2020-01-25', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26824, '2020-01-26', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26825, '2020-01-27', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26826, '2020-01-28', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26827, '2020-01-29', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26828, '2020-01-30', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26829, '2020-01-31', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26830, '2020-02-01', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26831, '2020-02-02', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26832, '2020-02-03', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26833, '2020-02-04', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26834, '2020-02-05', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26835, '2020-02-06', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26836, '2020-02-07', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26837, '2020-02-08', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26838, '2020-02-09', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26839, '2020-02-10', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26840, '2020-02-11', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26841, '2020-02-12', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26842, '2020-02-13', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26843, '2020-02-14', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26844, '2020-02-15', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26845, '2020-02-16', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26846, '2020-02-17', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26847, '2020-02-18', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26848, '2020-02-19', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26849, '2020-02-20', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26850, '2020-02-21', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26851, '2020-02-22', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26852, '2020-02-23', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26853, '2020-02-24', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26854, '2020-02-25', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26855, '2020-02-26', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26856, '2020-02-27', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26857, '2020-02-28', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26858, '2020-02-29', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26859, '2020-03-01', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26860, '2020-03-02', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26861, '2020-03-03', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26862, '2020-03-04', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26863, '2020-03-05', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26864, '2020-03-06', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26865, '2020-03-07', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26866, '2020-03-08', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26867, '2020-03-09', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26868, '2020-03-10', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26869, '2020-03-11', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26870, '2020-03-12', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26871, '2020-03-13', 'ET', 'Ethiopia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26872, '2020-03-14', 'ET', 'Ethiopia', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26873, '2020-03-15', 'ET', 'Ethiopia', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26874, '2020-03-16', 'ET', 'Ethiopia', 'AFRO', '3', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26875, '2020-03-17', 'ET', 'Ethiopia', 'AFRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26876, '2020-03-18', 'ET', 'Ethiopia', 'AFRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26877, '2020-03-19', 'ET', 'Ethiopia', 'AFRO', '3', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26878, '2020-03-20', 'ET', 'Ethiopia', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26879, '2020-03-21', 'ET', 'Ethiopia', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26880, '2020-03-22', 'ET', 'Ethiopia', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26881, '2020-03-23', 'ET', 'Ethiopia', 'AFRO', '-2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26882, '2020-03-24', 'ET', 'Ethiopia', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26883, '2020-03-25', 'ET', 'Ethiopia', 'AFRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26884, '2020-03-26', 'ET', 'Ethiopia', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26885, '2020-03-27', 'ET', 'Ethiopia', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26886, '2020-03-28', 'ET', 'Ethiopia', 'AFRO', '4', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26887, '2020-03-29', 'ET', 'Ethiopia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26888, '2020-03-30', 'ET', 'Ethiopia', 'AFRO', '5', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26889, '2020-03-31', 'ET', 'Ethiopia', 'AFRO', '2', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26890, '2020-04-01', 'ET', 'Ethiopia', 'AFRO', '3', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26891, '2020-04-02', 'ET', 'Ethiopia', 'AFRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26892, '2020-04-03', 'ET', 'Ethiopia', 'AFRO', '5', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26893, '2020-04-04', 'ET', 'Ethiopia', 'AFRO', '4', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26894, '2020-04-05', 'ET', 'Ethiopia', 'AFRO', '3', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (26895, '2020-04-06', 'ET', 'Ethiopia', 'AFRO', '5', '43', '1', '1');
INSERT INTO public.who_global_data_import VALUES (26896, '2020-04-07', 'ET', 'Ethiopia', 'AFRO', '1', '44', '0', '1');
INSERT INTO public.who_global_data_import VALUES (26897, '2020-04-08', 'ET', 'Ethiopia', 'AFRO', '8', '52', '1', '2');
INSERT INTO public.who_global_data_import VALUES (26898, '2020-04-09', 'ET', 'Ethiopia', 'AFRO', '3', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26899, '2020-04-10', 'ET', 'Ethiopia', 'AFRO', '1', '56', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26900, '2020-04-11', 'ET', 'Ethiopia', 'AFRO', '9', '65', '0', '2');
INSERT INTO public.who_global_data_import VALUES (26901, '2020-04-12', 'ET', 'Ethiopia', 'AFRO', '4', '69', '1', '3');
INSERT INTO public.who_global_data_import VALUES (26902, '2020-04-13', 'ET', 'Ethiopia', 'AFRO', '2', '71', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26903, '2020-04-14', 'ET', 'Ethiopia', 'AFRO', '3', '74', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26904, '2020-04-15', 'ET', 'Ethiopia', 'AFRO', '8', '82', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26905, '2020-04-16', 'ET', 'Ethiopia', 'AFRO', '3', '85', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26906, '2020-04-17', 'ET', 'Ethiopia', 'AFRO', '7', '92', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26907, '2020-04-18', 'ET', 'Ethiopia', 'AFRO', '4', '96', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26908, '2020-04-19', 'ET', 'Ethiopia', 'AFRO', '9', '105', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26909, '2020-04-20', 'ET', 'Ethiopia', 'AFRO', '3', '108', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26910, '2020-04-21', 'ET', 'Ethiopia', 'AFRO', '3', '111', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26911, '2020-04-22', 'ET', 'Ethiopia', 'AFRO', '3', '114', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26912, '2020-04-23', 'ET', 'Ethiopia', 'AFRO', '2', '116', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26913, '2020-04-24', 'ET', 'Ethiopia', 'AFRO', '0', '116', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26914, '2020-04-25', 'ET', 'Ethiopia', 'AFRO', '1', '117', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26915, '2020-04-26', 'ET', 'Ethiopia', 'AFRO', '5', '122', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26916, '2020-04-27', 'ET', 'Ethiopia', 'AFRO', '1', '123', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26917, '2020-04-28', 'ET', 'Ethiopia', 'AFRO', '1', '124', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26918, '2020-04-29', 'ET', 'Ethiopia', 'AFRO', '2', '126', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26919, '2020-04-30', 'ET', 'Ethiopia', 'AFRO', '4', '130', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26920, '2020-05-01', 'ET', 'Ethiopia', 'AFRO', '1', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26921, '2020-05-02', 'ET', 'Ethiopia', 'AFRO', '2', '133', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26922, '2020-05-03', 'ET', 'Ethiopia', 'AFRO', '0', '133', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26923, '2020-05-04', 'ET', 'Ethiopia', 'AFRO', '2', '135', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26924, '2020-05-05', 'ET', 'Ethiopia', 'AFRO', '5', '140', '0', '3');
INSERT INTO public.who_global_data_import VALUES (26925, '2020-05-06', 'ET', 'Ethiopia', 'AFRO', '5', '145', '1', '4');
INSERT INTO public.who_global_data_import VALUES (26926, '2020-05-07', 'ET', 'Ethiopia', 'AFRO', '17', '162', '0', '4');
INSERT INTO public.who_global_data_import VALUES (26927, '2020-05-08', 'ET', 'Ethiopia', 'AFRO', '29', '191', '0', '4');
INSERT INTO public.who_global_data_import VALUES (26928, '2020-05-09', 'ET', 'Ethiopia', 'AFRO', '3', '194', '0', '4');
INSERT INTO public.who_global_data_import VALUES (26929, '2020-05-10', 'ET', 'Ethiopia', 'AFRO', '16', '210', '1', '5');
INSERT INTO public.who_global_data_import VALUES (26930, '2020-05-11', 'ET', 'Ethiopia', 'AFRO', '29', '239', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26931, '2020-05-12', 'ET', 'Ethiopia', 'AFRO', '11', '250', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26932, '2020-05-13', 'ET', 'Ethiopia', 'AFRO', '11', '261', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26933, '2020-05-14', 'ET', 'Ethiopia', 'AFRO', '2', '263', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26934, '2020-05-15', 'ET', 'Ethiopia', 'AFRO', '9', '272', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26935, '2020-05-16', 'ET', 'Ethiopia', 'AFRO', '15', '287', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26936, '2020-05-17', 'ET', 'Ethiopia', 'AFRO', '19', '306', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26937, '2020-05-18', 'ET', 'Ethiopia', 'AFRO', '11', '317', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26938, '2020-05-19', 'ET', 'Ethiopia', 'AFRO', '35', '352', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26939, '2020-05-20', 'ET', 'Ethiopia', 'AFRO', '13', '365', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26940, '2020-05-21', 'ET', 'Ethiopia', 'AFRO', '24', '389', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26941, '2020-05-22', 'ET', 'Ethiopia', 'AFRO', '10', '399', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26942, '2020-05-23', 'ET', 'Ethiopia', 'AFRO', '34', '433', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26943, '2020-05-24', 'ET', 'Ethiopia', 'AFRO', '61', '494', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26944, '2020-05-25', 'ET', 'Ethiopia', 'AFRO', '88', '582', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26945, '2020-05-26', 'ET', 'Ethiopia', 'AFRO', '73', '655', '0', '5');
INSERT INTO public.who_global_data_import VALUES (26946, '2020-05-27', 'ET', 'Ethiopia', 'AFRO', '46', '701', '1', '6');
INSERT INTO public.who_global_data_import VALUES (26947, '2020-05-28', 'ET', 'Ethiopia', 'AFRO', '30', '731', '0', '6');
INSERT INTO public.who_global_data_import VALUES (26948, '2020-05-29', 'ET', 'Ethiopia', 'AFRO', '100', '831', '1', '7');
INSERT INTO public.who_global_data_import VALUES (26949, '2020-05-30', 'ET', 'Ethiopia', 'AFRO', '137', '968', '1', '8');
INSERT INTO public.who_global_data_import VALUES (26950, '2020-05-31', 'ET', 'Ethiopia', 'AFRO', '95', '1063', '0', '8');
INSERT INTO public.who_global_data_import VALUES (26951, '2020-06-01', 'ET', 'Ethiopia', 'AFRO', '109', '1172', '3', '11');
INSERT INTO public.who_global_data_import VALUES (26952, '2020-06-02', 'ET', 'Ethiopia', 'AFRO', '85', '1257', '1', '12');
INSERT INTO public.who_global_data_import VALUES (26953, '2020-06-03', 'ET', 'Ethiopia', 'AFRO', '87', '1344', '2', '14');
INSERT INTO public.who_global_data_import VALUES (26954, '2020-06-04', 'ET', 'Ethiopia', 'AFRO', '142', '1486', '3', '17');
INSERT INTO public.who_global_data_import VALUES (26955, '2020-06-05', 'ET', 'Ethiopia', 'AFRO', '150', '1636', '1', '18');
INSERT INTO public.who_global_data_import VALUES (26956, '2020-06-06', 'ET', 'Ethiopia', 'AFRO', '169', '1805', '1', '19');
INSERT INTO public.who_global_data_import VALUES (26957, '2020-06-07', 'ET', 'Ethiopia', 'AFRO', '129', '1934', '1', '20');
INSERT INTO public.who_global_data_import VALUES (26958, '2020-06-08', 'ET', 'Ethiopia', 'AFRO', '86', '2020', '7', '27');
INSERT INTO public.who_global_data_import VALUES (26959, '2020-06-09', 'ET', 'Ethiopia', 'AFRO', '136', '2156', '0', '27');
INSERT INTO public.who_global_data_import VALUES (26960, '2020-06-10', 'ET', 'Ethiopia', 'AFRO', '180', '2336', '5', '32');
INSERT INTO public.who_global_data_import VALUES (26961, '2020-06-11', 'ET', 'Ethiopia', 'AFRO', '170', '2506', '3', '35');
INSERT INTO public.who_global_data_import VALUES (26962, '2020-06-12', 'ET', 'Ethiopia', 'AFRO', '164', '2670', '5', '40');
INSERT INTO public.who_global_data_import VALUES (26963, '2020-06-13', 'ET', 'Ethiopia', 'AFRO', '245', '2915', '7', '47');
INSERT INTO public.who_global_data_import VALUES (26964, '2020-06-14', 'ET', 'Ethiopia', 'AFRO', '251', '3166', '8', '55');
INSERT INTO public.who_global_data_import VALUES (26965, '2020-06-15', 'ET', 'Ethiopia', 'AFRO', '179', '3345', '2', '57');
INSERT INTO public.who_global_data_import VALUES (26966, '2020-06-16', 'ET', 'Ethiopia', 'AFRO', '176', '3521', '3', '60');
INSERT INTO public.who_global_data_import VALUES (26967, '2020-06-17', 'ET', 'Ethiopia', 'AFRO', '109', '3630', '1', '61');
INSERT INTO public.who_global_data_import VALUES (26968, '2020-06-18', 'ET', 'Ethiopia', 'AFRO', '129', '3759', '2', '63');
INSERT INTO public.who_global_data_import VALUES (26969, '2020-06-19', 'ET', 'Ethiopia', 'AFRO', '195', '3954', '2', '65');
INSERT INTO public.who_global_data_import VALUES (26970, '2020-06-20', 'ET', 'Ethiopia', 'AFRO', '116', '4070', '7', '72');
INSERT INTO public.who_global_data_import VALUES (26971, '2020-06-21', 'ET', 'Ethiopia', 'AFRO', '399', '4469', '0', '72');
INSERT INTO public.who_global_data_import VALUES (26972, '2020-06-22', 'ET', 'Ethiopia', 'AFRO', '63', '4532', '2', '74');
INSERT INTO public.who_global_data_import VALUES (26973, '2020-06-23', 'ET', 'Ethiopia', 'AFRO', '131', '4663', '1', '75');
INSERT INTO public.who_global_data_import VALUES (26974, '2020-06-24', 'ET', 'Ethiopia', 'AFRO', '185', '4848', '0', '75');
INSERT INTO public.who_global_data_import VALUES (26975, '2020-06-25', 'ET', 'Ethiopia', 'AFRO', '186', '5034', '3', '78');
INSERT INTO public.who_global_data_import VALUES (26976, '2020-06-26', 'ET', 'Ethiopia', 'AFRO', '141', '5175', '3', '81');
INSERT INTO public.who_global_data_import VALUES (26977, '2020-06-27', 'ET', 'Ethiopia', 'AFRO', '250', '5425', '8', '89');
INSERT INTO public.who_global_data_import VALUES (26978, '2020-06-28', 'ET', 'Ethiopia', 'AFRO', '145', '5570', '5', '94');
INSERT INTO public.who_global_data_import VALUES (26979, '2020-06-29', 'ET', 'Ethiopia', 'AFRO', '119', '5689', '4', '98');
INSERT INTO public.who_global_data_import VALUES (26980, '2020-06-30', 'ET', 'Ethiopia', 'AFRO', '157', '5846', '5', '103');
INSERT INTO public.who_global_data_import VALUES (26981, '2020-07-01', 'ET', 'Ethiopia', 'AFRO', '0', '5846', '0', '103');
INSERT INTO public.who_global_data_import VALUES (26982, '2020-07-02', 'ET', 'Ethiopia', 'AFRO', '202', '6048', '4', '107');
INSERT INTO public.who_global_data_import VALUES (26983, '2020-07-03', 'ET', 'Ethiopia', 'AFRO', '115', '6163', '2', '109');
INSERT INTO public.who_global_data_import VALUES (26984, '2020-07-04', 'ET', 'Ethiopia', 'AFRO', '54', '6217', '5', '114');
INSERT INTO public.who_global_data_import VALUES (26985, '2020-07-05', 'ET', 'Ethiopia', 'AFRO', '169', '6386', '2', '116');
INSERT INTO public.who_global_data_import VALUES (26986, '2020-07-06', 'ET', 'Ethiopia', 'AFRO', '0', '6386', '0', '116');
INSERT INTO public.who_global_data_import VALUES (26987, '2020-07-07', 'ET', 'Ethiopia', 'AFRO', '280', '6666', '3', '119');
INSERT INTO public.who_global_data_import VALUES (26988, '2020-07-08', 'ET', 'Ethiopia', 'AFRO', '108', '6774', '1', '120');
INSERT INTO public.who_global_data_import VALUES (26989, '2020-07-09', 'ET', 'Ethiopia', 'AFRO', '199', '6973', '0', '120');
INSERT INTO public.who_global_data_import VALUES (26990, '2020-07-10', 'ET', 'Ethiopia', 'AFRO', '147', '7120', '4', '124');
INSERT INTO public.who_global_data_import VALUES (26991, '2020-07-11', 'ET', 'Ethiopia', 'AFRO', '282', '7402', '0', '124');
INSERT INTO public.who_global_data_import VALUES (26992, '2020-07-12', 'ET', 'Ethiopia', 'AFRO', '158', '7560', '3', '127');
INSERT INTO public.who_global_data_import VALUES (26993, '2020-07-13', 'ET', 'Ethiopia', 'AFRO', '206', '7766', '1', '128');
INSERT INTO public.who_global_data_import VALUES (26994, '2020-07-14', 'ET', 'Ethiopia', 'AFRO', '203', '7969', '11', '139');
INSERT INTO public.who_global_data_import VALUES (26995, '2020-07-15', 'ET', 'Ethiopia', 'AFRO', '212', '8181', '7', '146');
INSERT INTO public.who_global_data_import VALUES (26996, '2020-07-16', 'ET', 'Ethiopia', 'AFRO', '294', '8475', '2', '148');
INSERT INTO public.who_global_data_import VALUES (26997, '2020-07-17', 'ET', 'Ethiopia', 'AFRO', '328', '8803', '2', '150');
INSERT INTO public.who_global_data_import VALUES (26998, '2020-07-18', 'ET', 'Ethiopia', 'AFRO', '344', '9147', '13', '163');
INSERT INTO public.who_global_data_import VALUES (26999, '2020-07-19', 'ET', 'Ethiopia', 'AFRO', '356', '9503', '4', '167');
INSERT INTO public.who_global_data_import VALUES (27000, '2020-07-20', 'ET', 'Ethiopia', 'AFRO', '704', '10207', '3', '170');
INSERT INTO public.who_global_data_import VALUES (27001, '2020-07-21', 'ET', 'Ethiopia', 'AFRO', '304', '10511', '3', '173');
INSERT INTO public.who_global_data_import VALUES (27002, '2020-07-22', 'ET', 'Ethiopia', 'AFRO', '561', '11072', '7', '180');
INSERT INTO public.who_global_data_import VALUES (27003, '2020-07-23', 'ET', 'Ethiopia', 'AFRO', '452', '11524', '8', '188');
INSERT INTO public.who_global_data_import VALUES (27004, '2020-07-24', 'ET', 'Ethiopia', 'AFRO', '409', '11933', '9', '197');
INSERT INTO public.who_global_data_import VALUES (27005, '2020-07-25', 'ET', 'Ethiopia', 'AFRO', '760', '12693', '3', '200');
INSERT INTO public.who_global_data_import VALUES (27006, '2020-07-26', 'ET', 'Ethiopia', 'AFRO', '555', '13248', '9', '209');
INSERT INTO public.who_global_data_import VALUES (27007, '2020-07-27', 'ET', 'Ethiopia', 'AFRO', '720', '13968', '14', '223');
INSERT INTO public.who_global_data_import VALUES (27008, '2020-07-28', 'ET', 'Ethiopia', 'AFRO', '579', '14547', '5', '228');
INSERT INTO public.who_global_data_import VALUES (27009, '2020-07-29', 'ET', 'Ethiopia', 'AFRO', '653', '15200', '11', '239');
INSERT INTO public.who_global_data_import VALUES (27010, '2020-07-30', 'ET', 'Ethiopia', 'AFRO', '610', '15810', '14', '253');
INSERT INTO public.who_global_data_import VALUES (27011, '2020-07-31', 'ET', 'Ethiopia', 'AFRO', '805', '16615', '10', '263');
INSERT INTO public.who_global_data_import VALUES (27012, '2020-08-01', 'ET', 'Ethiopia', 'AFRO', '915', '17530', '11', '274');
INSERT INTO public.who_global_data_import VALUES (27013, '2020-08-02', 'ET', 'Ethiopia', 'AFRO', '469', '17999', '10', '284');
INSERT INTO public.who_global_data_import VALUES (27014, '2020-08-03', 'ET', 'Ethiopia', 'AFRO', '707', '18706', '26', '310');
INSERT INTO public.who_global_data_import VALUES (27015, '2020-08-04', 'ET', 'Ethiopia', 'AFRO', '583', '19289', '26', '336');
INSERT INTO public.who_global_data_import VALUES (27016, '2020-08-05', 'ET', 'Ethiopia', 'AFRO', '586', '19875', '7', '343');
INSERT INTO public.who_global_data_import VALUES (27017, '2020-08-06', 'ET', 'Ethiopia', 'AFRO', '461', '20336', '13', '356');
INSERT INTO public.who_global_data_import VALUES (27018, '2020-08-07', 'ET', 'Ethiopia', 'AFRO', '564', '20900', '9', '365');
INSERT INTO public.who_global_data_import VALUES (27019, '2020-08-08', 'ET', 'Ethiopia', 'AFRO', '552', '21452', '15', '380');
INSERT INTO public.who_global_data_import VALUES (27020, '2020-08-09', 'ET', 'Ethiopia', 'AFRO', '801', '22253', '10', '390');
INSERT INTO public.who_global_data_import VALUES (27021, '2020-08-10', 'ET', 'Ethiopia', 'AFRO', '565', '22818', '17', '407');
INSERT INTO public.who_global_data_import VALUES (27022, '2020-08-11', 'ET', 'Ethiopia', 'AFRO', '773', '23591', '13', '420');
INSERT INTO public.who_global_data_import VALUES (27023, '2020-08-12', 'ET', 'Ethiopia', 'AFRO', '584', '24175', '20', '440');
INSERT INTO public.who_global_data_import VALUES (27024, '2020-08-13', 'ET', 'Ethiopia', 'AFRO', '961', '25136', '23', '463');
INSERT INTO public.who_global_data_import VALUES (27025, '2020-08-14', 'ET', 'Ethiopia', 'AFRO', '1068', '26204', '16', '479');
INSERT INTO public.who_global_data_import VALUES (27026, '2020-08-15', 'ET', 'Ethiopia', 'AFRO', '1038', '27242', '13', '492');
INSERT INTO public.who_global_data_import VALUES (27027, '2020-08-16', 'ET', 'Ethiopia', 'AFRO', '1652', '28894', '17', '509');
INSERT INTO public.who_global_data_import VALUES (27028, '2020-08-17', 'ET', 'Ethiopia', 'AFRO', '982', '29876', '19', '528');
INSERT INTO public.who_global_data_import VALUES (27029, '2020-08-18', 'ET', 'Ethiopia', 'AFRO', '1460', '31336', '16', '544');
INSERT INTO public.who_global_data_import VALUES (27030, '2020-08-19', 'ET', 'Ethiopia', 'AFRO', '1386', '32722', '28', '572');
INSERT INTO public.who_global_data_import VALUES (27031, '2020-08-20', 'ET', 'Ethiopia', 'AFRO', '1336', '34058', '28', '600');
INSERT INTO public.who_global_data_import VALUES (27032, '2020-08-21', 'ET', 'Ethiopia', 'AFRO', '1778', '35836', '20', '620');
INSERT INTO public.who_global_data_import VALUES (27033, '2020-08-22', 'ET', 'Ethiopia', 'AFRO', '1829', '37665', '17', '637');
INSERT INTO public.who_global_data_import VALUES (27034, '2020-08-23', 'ET', 'Ethiopia', 'AFRO', '1368', '39033', '25', '662');
INSERT INTO public.who_global_data_import VALUES (27035, '2020-08-24', 'ET', 'Ethiopia', 'AFRO', '1638', '40671', '16', '678');
INSERT INTO public.who_global_data_import VALUES (27036, '2020-08-25', 'ET', 'Ethiopia', 'AFRO', '1472', '42143', '14', '692');
INSERT INTO public.who_global_data_import VALUES (27037, '2020-08-26', 'ET', 'Ethiopia', 'AFRO', '1545', '43688', '17', '709');
INSERT INTO public.who_global_data_import VALUES (27038, '2020-08-27', 'ET', 'Ethiopia', 'AFRO', '1533', '45221', '16', '725');
INSERT INTO public.who_global_data_import VALUES (27039, '2020-08-28', 'ET', 'Ethiopia', 'AFRO', '1186', '46407', '20', '745');
INSERT INTO public.who_global_data_import VALUES (27040, '2020-08-29', 'ET', 'Ethiopia', 'AFRO', '1733', '48140', '13', '758');
INSERT INTO public.who_global_data_import VALUES (27041, '2020-08-30', 'ET', 'Ethiopia', 'AFRO', '1514', '49654', '12', '770');
INSERT INTO public.who_global_data_import VALUES (27042, '2020-08-31', 'ET', 'Ethiopia', 'AFRO', '1468', '51122', '23', '793');
INSERT INTO public.who_global_data_import VALUES (27043, '2020-09-01', 'ET', 'Ethiopia', 'AFRO', '1009', '52131', '16', '809');
INSERT INTO public.who_global_data_import VALUES (27044, '2020-09-02', 'ET', 'Ethiopia', 'AFRO', '1173', '53304', '19', '828');
INSERT INTO public.who_global_data_import VALUES (27045, '2020-09-03', 'ET', 'Ethiopia', 'AFRO', '1105', '54409', '18', '846');
INSERT INTO public.who_global_data_import VALUES (27046, '2020-09-04', 'ET', 'Ethiopia', 'AFRO', '804', '55213', '10', '856');
INSERT INTO public.who_global_data_import VALUES (27047, '2020-09-05', 'ET', 'Ethiopia', 'AFRO', '1303', '56516', '24', '880');
INSERT INTO public.who_global_data_import VALUES (27048, '2020-09-06', 'ET', 'Ethiopia', 'AFRO', '950', '57466', '17', '897');
INSERT INTO public.who_global_data_import VALUES (27049, '2020-09-07', 'ET', 'Ethiopia', 'AFRO', '1206', '58672', '21', '918');
INSERT INTO public.who_global_data_import VALUES (27050, '2020-09-08', 'ET', 'Ethiopia', 'AFRO', '976', '59648', '15', '933');
INSERT INTO public.who_global_data_import VALUES (27051, '2020-09-09', 'ET', 'Ethiopia', 'AFRO', '1136', '60784', '16', '949');
INSERT INTO public.who_global_data_import VALUES (27052, '2020-09-10', 'ET', 'Ethiopia', 'AFRO', '916', '61700', '17', '966');
INSERT INTO public.who_global_data_import VALUES (27053, '2020-09-11', 'ET', 'Ethiopia', 'AFRO', '878', '62578', '8', '974');
INSERT INTO public.who_global_data_import VALUES (27054, '2020-09-12', 'ET', 'Ethiopia', 'AFRO', '789', '63367', '12', '986');
INSERT INTO public.who_global_data_import VALUES (27055, '2020-09-13', 'ET', 'Ethiopia', 'AFRO', '521', '63888', '10', '996');
INSERT INTO public.who_global_data_import VALUES (27056, '2020-09-14', 'ET', 'Ethiopia', 'AFRO', '413', '64301', '17', '1013');
INSERT INTO public.who_global_data_import VALUES (27057, '2020-09-15', 'ET', 'Ethiopia', 'AFRO', '485', '64786', '9', '1022');
INSERT INTO public.who_global_data_import VALUES (27058, '2020-09-16', 'ET', 'Ethiopia', 'AFRO', '700', '65486', '13', '1035');
INSERT INTO public.who_global_data_import VALUES (27059, '2020-09-17', 'ET', 'Ethiopia', 'AFRO', '738', '66224', '10', '1045');
INSERT INTO public.who_global_data_import VALUES (27060, '2020-09-18', 'ET', 'Ethiopia', 'AFRO', '689', '66913', '15', '1060');
INSERT INTO public.who_global_data_import VALUES (27061, '2020-09-19', 'ET', 'Ethiopia', 'AFRO', '602', '67515', '12', '1072');
INSERT INTO public.who_global_data_import VALUES (27062, '2020-09-20', 'ET', 'Ethiopia', 'AFRO', '616', '68131', '17', '1089');
INSERT INTO public.who_global_data_import VALUES (27063, '2020-09-21', 'ET', 'Ethiopia', 'AFRO', '689', '68820', '7', '1096');
INSERT INTO public.who_global_data_import VALUES (27064, '2020-09-22', 'ET', 'Ethiopia', 'AFRO', '889', '69709', '12', '1108');
INSERT INTO public.who_global_data_import VALUES (27065, '2020-09-23', 'ET', 'Ethiopia', 'AFRO', '713', '70422', '19', '1127');
INSERT INTO public.who_global_data_import VALUES (27066, '2020-09-24', 'ET', 'Ethiopia', 'AFRO', '661', '71083', '14', '1141');
INSERT INTO public.who_global_data_import VALUES (27067, '2020-09-25', 'ET', 'Ethiopia', 'AFRO', '604', '71687', '7', '1148');
INSERT INTO public.who_global_data_import VALUES (27068, '2020-09-26', 'ET', 'Ethiopia', 'AFRO', '486', '72173', '7', '1155');
INSERT INTO public.who_global_data_import VALUES (27069, '2020-09-27', 'ET', 'Ethiopia', 'AFRO', '527', '72700', '10', '1165');
INSERT INTO public.who_global_data_import VALUES (27070, '2020-09-28', 'ET', 'Ethiopia', 'AFRO', '632', '73332', '5', '1170');
INSERT INTO public.who_global_data_import VALUES (27071, '2020-09-29', 'ET', 'Ethiopia', 'AFRO', '612', '73944', '7', '1177');
INSERT INTO public.who_global_data_import VALUES (27072, '2020-09-30', 'ET', 'Ethiopia', 'AFRO', '640', '74584', '14', '1191');
INSERT INTO public.who_global_data_import VALUES (27073, '2020-10-01', 'ET', 'Ethiopia', 'AFRO', '784', '75368', '7', '1198');
INSERT INTO public.who_global_data_import VALUES (27074, '2020-10-02', 'ET', 'Ethiopia', 'AFRO', '730', '76098', '6', '1204');
INSERT INTO public.who_global_data_import VALUES (27075, '2020-10-03', 'ET', 'Ethiopia', 'AFRO', '890', '76988', '3', '1207');
INSERT INTO public.who_global_data_import VALUES (27076, '2020-10-04', 'ET', 'Ethiopia', 'AFRO', '872', '77860', '7', '1214');
INSERT INTO public.who_global_data_import VALUES (27077, '2020-10-05', 'ET', 'Ethiopia', 'AFRO', '959', '78819', '8', '1222');
INSERT INTO public.who_global_data_import VALUES (27078, '2020-10-06', 'ET', 'Ethiopia', 'AFRO', '618', '79437', '8', '1230');
INSERT INTO public.who_global_data_import VALUES (27079, '2020-10-07', 'ET', 'Ethiopia', 'AFRO', '566', '80003', '8', '1238');
INSERT INTO public.who_global_data_import VALUES (27080, '2020-10-08', 'ET', 'Ethiopia', 'AFRO', '892', '80895', '17', '1255');
INSERT INTO public.who_global_data_import VALUES (27081, '2020-10-09', 'ET', 'Ethiopia', 'AFRO', '902', '81797', '7', '1262');
INSERT INTO public.who_global_data_import VALUES (27082, '2020-10-10', 'ET', 'Ethiopia', 'AFRO', '865', '82662', '9', '1271');
INSERT INTO public.who_global_data_import VALUES (27083, '2020-10-11', 'ET', 'Ethiopia', 'AFRO', '767', '83429', '6', '1277');
INSERT INTO public.who_global_data_import VALUES (27084, '2020-10-12', 'ET', 'Ethiopia', 'AFRO', '866', '84295', '10', '1287');
INSERT INTO public.who_global_data_import VALUES (27085, '2020-10-13', 'ET', 'Ethiopia', 'AFRO', '841', '85136', '14', '1301');
INSERT INTO public.who_global_data_import VALUES (27086, '2020-10-14', 'ET', 'Ethiopia', 'AFRO', '582', '85718', '4', '1305');
INSERT INTO public.who_global_data_import VALUES (27087, '2020-10-15', 'ET', 'Ethiopia', 'AFRO', '712', '86430', '7', '1312');
INSERT INTO public.who_global_data_import VALUES (27088, '2020-10-16', 'ET', 'Ethiopia', 'AFRO', '739', '87169', '13', '1325');
INSERT INTO public.who_global_data_import VALUES (27089, '2020-10-17', 'ET', 'Ethiopia', 'AFRO', '665', '87834', '12', '1337');
INSERT INTO public.who_global_data_import VALUES (27090, '2020-10-18', 'ET', 'Ethiopia', 'AFRO', '600', '88434', '9', '1346');
INSERT INTO public.who_global_data_import VALUES (27091, '2020-10-19', 'ET', 'Ethiopia', 'AFRO', '703', '89137', '6', '1352');
INSERT INTO public.who_global_data_import VALUES (27092, '2020-10-20', 'ET', 'Ethiopia', 'AFRO', '723', '89860', '13', '1365');
INSERT INTO public.who_global_data_import VALUES (27093, '2020-10-21', 'ET', 'Ethiopia', 'AFRO', '630', '90490', '6', '1371');
INSERT INTO public.who_global_data_import VALUES (27094, '2020-10-22', 'ET', 'Ethiopia', 'AFRO', '628', '91118', '13', '1384');
INSERT INTO public.who_global_data_import VALUES (27095, '2020-10-23', 'ET', 'Ethiopia', 'AFRO', '575', '91693', '12', '1396');
INSERT INTO public.who_global_data_import VALUES (27096, '2020-10-24', 'ET', 'Ethiopia', 'AFRO', '536', '92229', '4', '1400');
INSERT INTO public.who_global_data_import VALUES (27097, '2020-10-25', 'ET', 'Ethiopia', 'AFRO', '629', '92858', '19', '1419');
INSERT INTO public.who_global_data_import VALUES (27098, '2020-10-26', 'ET', 'Ethiopia', 'AFRO', '485', '93343', '7', '1426');
INSERT INTO public.who_global_data_import VALUES (27099, '2020-10-27', 'ET', 'Ethiopia', 'AFRO', '364', '93707', '11', '1437');
INSERT INTO public.who_global_data_import VALUES (27100, '2020-10-28', 'ET', 'Ethiopia', 'AFRO', '511', '94218', '8', '1445');
INSERT INTO public.who_global_data_import VALUES (27101, '2020-10-29', 'ET', 'Ethiopia', 'AFRO', '602', '94820', '6', '1451');
INSERT INTO public.who_global_data_import VALUES (27102, '2020-10-30', 'ET', 'Ethiopia', 'AFRO', '481', '95301', '6', '1457');
INSERT INTO public.who_global_data_import VALUES (27103, '2020-10-31', 'ET', 'Ethiopia', 'AFRO', '488', '95789', '7', '1464');
INSERT INTO public.who_global_data_import VALUES (27104, '2020-11-01', 'ET', 'Ethiopia', 'AFRO', '380', '96169', '5', '1469');
INSERT INTO public.who_global_data_import VALUES (27105, '2020-11-02', 'ET', 'Ethiopia', 'AFRO', '414', '96583', '9', '1478');
INSERT INTO public.who_global_data_import VALUES (27106, '2020-11-03', 'ET', 'Ethiopia', 'AFRO', '359', '96942', '11', '1489');
INSERT INTO public.who_global_data_import VALUES (27107, '2020-11-04', 'ET', 'Ethiopia', 'AFRO', '560', '97502', '5', '1494');
INSERT INTO public.who_global_data_import VALUES (27108, '2020-11-05', 'ET', 'Ethiopia', 'AFRO', '379', '97881', '9', '1503');
INSERT INTO public.who_global_data_import VALUES (27109, '2020-11-06', 'ET', 'Ethiopia', 'AFRO', '510', '98391', '5', '1508');
INSERT INTO public.who_global_data_import VALUES (27110, '2020-11-07', 'ET', 'Ethiopia', 'AFRO', '355', '98746', '4', '1512');
INSERT INTO public.who_global_data_import VALUES (27111, '2020-11-08', 'ET', 'Ethiopia', 'AFRO', '458', '99204', '6', '1518');
INSERT INTO public.who_global_data_import VALUES (27112, '2020-11-09', 'ET', 'Ethiopia', 'AFRO', '471', '99675', '5', '1523');
INSERT INTO public.who_global_data_import VALUES (27113, '2020-11-10', 'ET', 'Ethiopia', 'AFRO', '307', '99982', '7', '1530');
INSERT INTO public.who_global_data_import VALUES (27114, '2020-11-11', 'ET', 'Ethiopia', 'AFRO', '345', '100327', '7', '1537');
INSERT INTO public.who_global_data_import VALUES (27115, '2020-11-12', 'ET', 'Ethiopia', 'AFRO', '400', '100727', '8', '1545');
INSERT INTO public.who_global_data_import VALUES (27116, '2020-11-13', 'ET', 'Ethiopia', 'AFRO', '521', '101248', '9', '1554');
INSERT INTO public.who_global_data_import VALUES (27117, '2020-11-14', 'ET', 'Ethiopia', 'AFRO', '509', '101757', '4', '1558');
INSERT INTO public.who_global_data_import VALUES (27118, '2020-11-15', 'ET', 'Ethiopia', 'AFRO', '564', '102321', '7', '1565');
INSERT INTO public.who_global_data_import VALUES (27119, '2020-11-16', 'ET', 'Ethiopia', 'AFRO', '399', '102720', '4', '1569');
INSERT INTO public.who_global_data_import VALUES (27120, '2020-11-17', 'ET', 'Ethiopia', 'AFRO', '336', '103056', '12', '1581');
INSERT INTO public.who_global_data_import VALUES (27121, '2020-11-18', 'ET', 'Ethiopia', 'AFRO', '339', '103395', '7', '1588');
INSERT INTO public.who_global_data_import VALUES (27122, '2020-11-19', 'ET', 'Ethiopia', 'AFRO', '533', '103928', '13', '1601');
INSERT INTO public.who_global_data_import VALUES (27123, '2020-11-20', 'ET', 'Ethiopia', 'AFRO', '499', '104427', '6', '1607');
INSERT INTO public.who_global_data_import VALUES (27124, '2020-11-21', 'ET', 'Ethiopia', 'AFRO', '452', '104879', '13', '1620');
INSERT INTO public.who_global_data_import VALUES (27125, '2020-11-22', 'ET', 'Ethiopia', 'AFRO', '473', '105352', '16', '1636');
INSERT INTO public.who_global_data_import VALUES (27126, '2020-11-23', 'ET', 'Ethiopia', 'AFRO', '433', '105785', '11', '1647');
INSERT INTO public.who_global_data_import VALUES (27127, '2020-11-24', 'ET', 'Ethiopia', 'AFRO', '418', '106203', '4', '1651');
INSERT INTO public.who_global_data_import VALUES (27128, '2020-11-25', 'ET', 'Ethiopia', 'AFRO', '388', '106591', '10', '1661');
INSERT INTO public.who_global_data_import VALUES (27129, '2020-11-26', 'ET', 'Ethiopia', 'AFRO', '518', '107109', '3', '1664');
INSERT INTO public.who_global_data_import VALUES (27130, '2020-11-27', 'ET', 'Ethiopia', 'AFRO', '560', '107669', '8', '1672');
INSERT INTO public.who_global_data_import VALUES (27131, '2020-11-28', 'ET', 'Ethiopia', 'AFRO', '769', '108438', '14', '1686');
INSERT INTO public.who_global_data_import VALUES (27132, '2020-11-29', 'ET', 'Ethiopia', 'AFRO', '492', '108930', '9', '1695');
INSERT INTO public.who_global_data_import VALUES (27133, '2020-11-30', 'ET', 'Ethiopia', 'AFRO', '604', '109534', '5', '1700');
INSERT INTO public.who_global_data_import VALUES (27134, '2020-12-01', 'ET', 'Ethiopia', 'AFRO', '540', '110074', '6', '1706');
INSERT INTO public.who_global_data_import VALUES (27135, '2020-12-02', 'ET', 'Ethiopia', 'AFRO', '480', '110554', '3', '1709');
INSERT INTO public.who_global_data_import VALUES (27136, '2020-12-03', 'ET', 'Ethiopia', 'AFRO', '430', '110984', '6', '1715');
INSERT INTO public.who_global_data_import VALUES (27137, '2020-12-04', 'ET', 'Ethiopia', 'AFRO', '595', '111579', '9', '1724');
INSERT INTO public.who_global_data_import VALUES (27138, '2020-12-05', 'ET', 'Ethiopia', 'AFRO', '512', '112091', '10', '1734');
INSERT INTO public.who_global_data_import VALUES (27139, '2020-12-06', 'ET', 'Ethiopia', 'AFRO', '649', '112740', '11', '1745');
INSERT INTO public.who_global_data_import VALUES (27140, '2020-12-07', 'ET', 'Ethiopia', 'AFRO', '555', '113295', '2', '1747');
INSERT INTO public.who_global_data_import VALUES (27141, '2020-12-08', 'ET', 'Ethiopia', 'AFRO', '440', '113735', '8', '1755');
INSERT INTO public.who_global_data_import VALUES (27142, '2020-12-09', 'ET', 'Ethiopia', 'AFRO', '0', '113735', '0', '1755');
INSERT INTO public.who_global_data_import VALUES (27143, '2020-12-10', 'ET', 'Ethiopia', 'AFRO', '1099', '114834', '14', '1769');
INSERT INTO public.who_global_data_import VALUES (27144, '2020-12-11', 'ET', 'Ethiopia', 'AFRO', '526', '115360', '10', '1779');
INSERT INTO public.who_global_data_import VALUES (27145, '2020-12-12', 'ET', 'Ethiopia', 'AFRO', '0', '115360', '0', '1779');
INSERT INTO public.who_global_data_import VALUES (27146, '2020-12-13', 'ET', 'Ethiopia', 'AFRO', '0', '115360', '0', '1779');
INSERT INTO public.who_global_data_import VALUES (27147, '2020-12-14', 'ET', 'Ethiopia', 'AFRO', '1409', '116769', '27', '1806');
INSERT INTO public.who_global_data_import VALUES (27148, '2020-12-15', 'ET', 'Ethiopia', 'AFRO', '473', '117242', '3', '1809');
INSERT INTO public.who_global_data_import VALUES (27149, '2020-12-16', 'ET', 'Ethiopia', 'AFRO', '300', '117542', '4', '1813');
INSERT INTO public.who_global_data_import VALUES (27150, '2020-12-17', 'ET', 'Ethiopia', 'AFRO', '0', '117542', '0', '1813');
INSERT INTO public.who_global_data_import VALUES (27151, '2020-12-18', 'ET', 'Ethiopia', 'AFRO', '939', '118481', '18', '1831');
INSERT INTO public.who_global_data_import VALUES (27152, '2020-12-19', 'ET', 'Ethiopia', 'AFRO', '544', '119025', '12', '1843');
INSERT INTO public.who_global_data_import VALUES (27153, '2020-12-20', 'ET', 'Ethiopia', 'AFRO', '469', '119494', '3', '1846');
INSERT INTO public.who_global_data_import VALUES (27154, '2020-12-21', 'ET', 'Ethiopia', 'AFRO', '457', '119951', '7', '1853');
INSERT INTO public.who_global_data_import VALUES (27155, '2020-12-22', 'ET', 'Ethiopia', 'AFRO', '397', '120348', '8', '1861');
INSERT INTO public.who_global_data_import VALUES (27156, '2020-12-23', 'ET', 'Ethiopia', 'AFRO', '290', '120638', '3', '1864');
INSERT INTO public.who_global_data_import VALUES (27157, '2020-12-24', 'ET', 'Ethiopia', 'AFRO', '0', '120638', '0', '1864');
INSERT INTO public.who_global_data_import VALUES (27158, '2020-12-25', 'ET', 'Ethiopia', 'AFRO', '761', '121399', '18', '1882');
INSERT INTO public.who_global_data_import VALUES (27159, '2020-12-26', 'ET', 'Ethiopia', 'AFRO', '481', '121880', '15', '1897');
INSERT INTO public.who_global_data_import VALUES (27160, '2020-12-27', 'ET', 'Ethiopia', 'AFRO', '533', '122413', '4', '1901');
INSERT INTO public.who_global_data_import VALUES (27161, '2020-12-28', 'ET', 'Ethiopia', 'AFRO', '0', '122413', '0', '1901');
INSERT INTO public.who_global_data_import VALUES (27162, '2020-12-29', 'ET', 'Ethiopia', 'AFRO', '732', '123145', '11', '1912');
INSERT INTO public.who_global_data_import VALUES (27163, '2020-12-30', 'ET', 'Ethiopia', 'AFRO', '0', '123145', '0', '1912');
INSERT INTO public.who_global_data_import VALUES (27164, '2020-12-31', 'ET', 'Ethiopia', 'AFRO', '711', '123856', '6', '1918');
INSERT INTO public.who_global_data_import VALUES (27165, '2021-01-01', 'ET', 'Ethiopia', 'AFRO', '408', '124264', '5', '1923');
INSERT INTO public.who_global_data_import VALUES (27166, '2021-01-02', 'ET', 'Ethiopia', 'AFRO', '0', '124264', '0', '1923');
INSERT INTO public.who_global_data_import VALUES (27167, '2021-01-03', 'ET', 'Ethiopia', 'AFRO', '785', '125049', '21', '1944');
INSERT INTO public.who_global_data_import VALUES (27168, '2021-01-04', 'ET', 'Ethiopia', 'AFRO', '573', '125622', '4', '1948');
INSERT INTO public.who_global_data_import VALUES (27169, '2021-01-05', 'ET', 'Ethiopia', 'AFRO', '297', '125919', '2', '1950');
INSERT INTO public.who_global_data_import VALUES (27170, '2021-01-06', 'ET', 'Ethiopia', 'AFRO', '322', '126241', '13', '1963');
INSERT INTO public.who_global_data_import VALUES (27171, '2021-01-07', 'ET', 'Ethiopia', 'AFRO', '545', '126786', '2', '1965');
INSERT INTO public.who_global_data_import VALUES (27172, '2021-01-08', 'ET', 'Ethiopia', 'AFRO', '441', '127227', '1', '1966');
INSERT INTO public.who_global_data_import VALUES (27173, '2021-01-09', 'ET', 'Ethiopia', 'AFRO', '345', '127572', '8', '1974');
INSERT INTO public.who_global_data_import VALUES (27174, '2021-01-10', 'ET', 'Ethiopia', 'AFRO', '220', '127792', '11', '1985');
INSERT INTO public.who_global_data_import VALUES (27175, '2021-01-11', 'ET', 'Ethiopia', 'AFRO', '524', '128316', '9', '1994');
INSERT INTO public.who_global_data_import VALUES (27176, '2021-01-12', 'ET', 'Ethiopia', 'AFRO', '300', '128616', '9', '2003');
INSERT INTO public.who_global_data_import VALUES (27177, '2021-01-13', 'ET', 'Ethiopia', 'AFRO', '376', '128992', '1', '2004');
INSERT INTO public.who_global_data_import VALUES (27178, '2021-01-14', 'ET', 'Ethiopia', 'AFRO', '453', '129445', '2', '2006');
INSERT INTO public.who_global_data_import VALUES (27179, '2021-01-15', 'ET', 'Ethiopia', 'AFRO', '477', '129922', '2', '2008');
INSERT INTO public.who_global_data_import VALUES (27180, '2021-01-16', 'ET', 'Ethiopia', 'AFRO', '404', '130326', '15', '2023');
INSERT INTO public.who_global_data_import VALUES (27181, '2021-01-17', 'ET', 'Ethiopia', 'AFRO', '446', '130772', '6', '2029');
INSERT INTO public.who_global_data_import VALUES (27182, '2021-01-18', 'ET', 'Ethiopia', 'AFRO', '423', '131195', '1', '2030');
INSERT INTO public.who_global_data_import VALUES (27183, '2021-01-19', 'ET', 'Ethiopia', 'AFRO', '351', '131546', '3', '2033');
INSERT INTO public.who_global_data_import VALUES (27184, '2021-01-20', 'ET', 'Ethiopia', 'AFRO', '181', '131727', '4', '2037');
INSERT INTO public.who_global_data_import VALUES (27185, '2021-01-21', 'ET', 'Ethiopia', 'AFRO', '307', '132034', '7', '2044');
INSERT INTO public.who_global_data_import VALUES (27186, '2021-01-22', 'ET', 'Ethiopia', 'AFRO', '292', '132326', '13', '2057');
INSERT INTO public.who_global_data_import VALUES (27187, '2021-01-23', 'ET', 'Ethiopia', 'AFRO', '555', '132881', '3', '2060');
INSERT INTO public.who_global_data_import VALUES (27188, '2021-01-24', 'ET', 'Ethiopia', 'AFRO', '417', '133298', '3', '2063');
INSERT INTO public.who_global_data_import VALUES (27189, '2021-01-25', 'ET', 'Ethiopia', 'AFRO', '469', '133767', '3', '2066');
INSERT INTO public.who_global_data_import VALUES (27190, '2021-01-26', 'ET', 'Ethiopia', 'AFRO', '365', '134132', '5', '2071');
INSERT INTO public.who_global_data_import VALUES (27191, '2021-01-27', 'ET', 'Ethiopia', 'AFRO', '437', '134569', '4', '2075');
INSERT INTO public.who_global_data_import VALUES (27192, '2021-01-28', 'ET', 'Ethiopia', 'AFRO', '476', '135045', '8', '2083');
INSERT INTO public.who_global_data_import VALUES (27193, '2021-01-29', 'ET', 'Ethiopia', 'AFRO', '549', '135594', '2', '2085');
INSERT INTO public.who_global_data_import VALUES (27194, '2021-01-30', 'ET', 'Ethiopia', 'AFRO', '771', '136365', '2', '2087');
INSERT INTO public.who_global_data_import VALUES (27195, '2021-01-31', 'ET', 'Ethiopia', 'AFRO', '656', '137021', '4', '2091');
INSERT INTO public.who_global_data_import VALUES (27196, '2021-02-01', 'ET', 'Ethiopia', 'AFRO', '629', '137650', '2', '2093');
INSERT INTO public.who_global_data_import VALUES (27197, '2021-02-02', 'ET', 'Ethiopia', 'AFRO', '734', '138384', '10', '2103');
INSERT INTO public.who_global_data_import VALUES (27198, '2021-02-03', 'ET', 'Ethiopia', 'AFRO', '477', '138861', '13', '2116');
INSERT INTO public.who_global_data_import VALUES (27199, '2021-02-04', 'ET', 'Ethiopia', 'AFRO', '547', '139408', '6', '2122');
INSERT INTO public.who_global_data_import VALUES (27200, '2021-02-05', 'ET', 'Ethiopia', 'AFRO', '749', '140157', '4', '2126');
INSERT INTO public.who_global_data_import VALUES (27201, '2020-01-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28088, '2020-03-30', 'FJ', 'Fiji', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27202, '2020-01-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27203, '2020-01-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27204, '2020-01-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27205, '2020-01-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27206, '2020-01-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27207, '2020-01-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27208, '2020-01-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27209, '2020-01-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27210, '2020-01-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27211, '2020-01-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27212, '2020-01-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27213, '2020-01-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27214, '2020-01-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27215, '2020-01-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27216, '2020-01-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27217, '2020-01-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27218, '2020-01-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27219, '2020-01-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27220, '2020-01-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27221, '2020-01-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27222, '2020-01-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27223, '2020-01-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27224, '2020-01-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27225, '2020-01-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27226, '2020-01-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27227, '2020-01-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27228, '2020-01-30', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27229, '2020-01-31', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27230, '2020-02-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27231, '2020-02-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27232, '2020-02-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27233, '2020-02-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27234, '2020-02-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27235, '2020-02-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27236, '2020-02-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27237, '2020-02-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27238, '2020-02-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27239, '2020-02-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27240, '2020-02-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27241, '2020-02-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27242, '2020-02-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27243, '2020-02-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27244, '2020-02-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27245, '2020-02-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27246, '2020-02-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27247, '2020-02-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27248, '2020-02-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27249, '2020-02-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27250, '2020-02-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27251, '2020-02-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27252, '2020-02-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27253, '2020-02-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27254, '2020-02-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27255, '2020-02-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27256, '2020-02-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27257, '2020-02-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27258, '2020-02-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27259, '2020-03-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27260, '2020-03-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27261, '2020-03-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27262, '2020-03-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27263, '2020-03-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27264, '2020-03-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27265, '2020-03-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27266, '2020-03-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27267, '2020-03-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27268, '2020-03-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27269, '2020-03-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27270, '2020-03-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27271, '2020-03-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27272, '2020-03-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27273, '2020-03-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27274, '2020-03-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27275, '2020-03-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27276, '2020-03-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27277, '2020-03-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27278, '2020-03-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27279, '2020-03-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27280, '2020-03-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27281, '2020-03-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27282, '2020-03-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27283, '2020-03-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27284, '2020-03-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27285, '2020-03-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27286, '2020-03-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27287, '2020-03-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27288, '2020-03-30', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27289, '2020-03-31', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28089, '2020-03-31', 'FJ', 'Fiji', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27290, '2020-04-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27291, '2020-04-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27292, '2020-04-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27293, '2020-04-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27294, '2020-04-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27295, '2020-04-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27296, '2020-04-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27297, '2020-04-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27298, '2020-04-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '3', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27299, '2020-04-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27300, '2020-04-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27301, '2020-04-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27302, '2020-04-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27303, '2020-04-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27304, '2020-04-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '6', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27305, '2020-04-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27306, '2020-04-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27307, '2020-04-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27308, '2020-04-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27309, '2020-04-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27310, '2020-04-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27311, '2020-04-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27312, '2020-04-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27313, '2020-04-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27314, '2020-04-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27315, '2020-04-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27316, '2020-04-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27317, '2020-04-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27318, '2020-04-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27319, '2020-04-30', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27320, '2020-05-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27321, '2020-05-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27322, '2020-05-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27323, '2020-05-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27324, '2020-05-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27325, '2020-05-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27326, '2020-05-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27327, '2020-05-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27328, '2020-05-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27329, '2020-05-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27330, '2020-05-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27331, '2020-05-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27332, '2020-05-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27333, '2020-05-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27334, '2020-05-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27335, '2020-05-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27336, '2020-05-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27337, '2020-05-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27338, '2020-05-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27339, '2020-05-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27340, '2020-05-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27341, '2020-05-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27342, '2020-05-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27343, '2020-05-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27344, '2020-05-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27345, '2020-05-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27346, '2020-05-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27347, '2020-05-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27348, '2020-05-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27349, '2020-05-30', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27350, '2020-05-31', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27351, '2020-06-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27352, '2020-06-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27353, '2020-06-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27354, '2020-06-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27355, '2020-06-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27356, '2020-06-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27357, '2020-06-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27358, '2020-06-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27359, '2020-06-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27360, '2020-06-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27361, '2020-06-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27362, '2020-06-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27363, '2020-06-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27364, '2020-06-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27365, '2020-06-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27366, '2020-06-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27367, '2020-06-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27368, '2020-06-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27369, '2020-06-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27370, '2020-06-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27371, '2020-06-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27372, '2020-06-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27373, '2020-06-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27374, '2020-06-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27375, '2020-06-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27376, '2020-06-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27377, '2020-06-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28090, '2020-04-01', 'FJ', 'Fiji', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27378, '2020-06-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27379, '2020-06-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27380, '2020-06-30', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27381, '2020-07-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27382, '2020-07-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27383, '2020-07-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27384, '2020-07-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27385, '2020-07-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27386, '2020-07-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27387, '2020-07-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27388, '2020-07-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27389, '2020-07-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27390, '2020-07-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27391, '2020-07-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27392, '2020-07-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27393, '2020-07-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27394, '2020-07-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27395, '2020-07-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27396, '2020-07-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27397, '2020-07-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27398, '2020-07-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27399, '2020-07-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27400, '2020-07-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27401, '2020-07-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27402, '2020-07-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27403, '2020-07-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27404, '2020-07-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27405, '2020-07-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27406, '2020-07-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27407, '2020-07-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27408, '2020-07-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27409, '2020-07-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27410, '2020-07-30', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27411, '2020-07-31', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27412, '2020-08-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27413, '2020-08-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27414, '2020-08-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27415, '2020-08-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27416, '2020-08-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27417, '2020-08-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27418, '2020-08-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27419, '2020-08-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27420, '2020-08-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27421, '2020-08-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27422, '2020-08-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27423, '2020-08-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27424, '2020-08-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27425, '2020-08-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27426, '2020-08-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27427, '2020-08-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27428, '2020-08-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27429, '2020-08-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27430, '2020-08-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27431, '2020-08-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27432, '2020-08-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27433, '2020-08-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27434, '2020-08-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27435, '2020-08-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27436, '2020-08-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27437, '2020-08-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27438, '2020-08-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27439, '2020-08-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27440, '2020-08-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27441, '2020-08-30', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27442, '2020-08-31', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27443, '2020-09-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27444, '2020-09-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27445, '2020-09-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27446, '2020-09-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27447, '2020-09-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27448, '2020-09-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27449, '2020-09-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27450, '2020-09-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27451, '2020-09-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27452, '2020-09-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27453, '2020-09-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27454, '2020-09-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27455, '2020-09-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27456, '2020-09-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27457, '2020-09-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27458, '2020-09-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27459, '2020-09-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27460, '2020-09-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27461, '2020-09-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27462, '2020-09-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27463, '2020-09-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27464, '2020-09-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27465, '2020-09-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28091, '2020-04-02', 'FJ', 'Fiji', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27466, '2020-09-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27467, '2020-09-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27468, '2020-09-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27469, '2020-09-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27470, '2020-09-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27471, '2020-09-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27472, '2020-09-30', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27473, '2020-10-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27474, '2020-10-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27475, '2020-10-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27476, '2020-10-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27477, '2020-10-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27478, '2020-10-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27479, '2020-10-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27480, '2020-10-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27481, '2020-10-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27482, '2020-10-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27483, '2020-10-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27484, '2020-10-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27485, '2020-10-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27486, '2020-10-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27487, '2020-10-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27488, '2020-10-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27489, '2020-10-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27490, '2020-10-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27491, '2020-10-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27492, '2020-10-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27493, '2020-10-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27494, '2020-10-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27495, '2020-10-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27496, '2020-10-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27497, '2020-10-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27498, '2020-10-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27499, '2020-10-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27500, '2020-10-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27501, '2020-10-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27502, '2020-10-30', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27503, '2020-10-31', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27504, '2020-11-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27505, '2020-11-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27506, '2020-11-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27507, '2020-11-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27508, '2020-11-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27509, '2020-11-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27510, '2020-11-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27511, '2020-11-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27512, '2020-11-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27513, '2020-11-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27514, '2020-11-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27515, '2020-11-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27516, '2020-11-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27517, '2020-11-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27518, '2020-11-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27519, '2020-11-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27520, '2020-11-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27521, '2020-11-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27522, '2020-11-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27523, '2020-11-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27524, '2020-11-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27525, '2020-11-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27526, '2020-11-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27527, '2020-11-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27528, '2020-11-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27529, '2020-11-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27530, '2020-11-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27531, '2020-11-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27532, '2020-11-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27533, '2020-11-30', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27534, '2020-12-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27535, '2020-12-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27536, '2020-12-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27537, '2020-12-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27538, '2020-12-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27539, '2020-12-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27540, '2020-12-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27541, '2020-12-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27542, '2020-12-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27543, '2020-12-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27544, '2020-12-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '2', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27545, '2020-12-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27546, '2020-12-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27547, '2020-12-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27548, '2020-12-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27549, '2020-12-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27550, '2020-12-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '4', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27551, '2020-12-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27552, '2020-12-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27553, '2020-12-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28092, '2020-04-03', 'FJ', 'Fiji', 'WPRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27554, '2020-12-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27555, '2020-12-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27556, '2020-12-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27557, '2020-12-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '6', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27558, '2020-12-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27559, '2020-12-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27560, '2020-12-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27561, '2020-12-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27562, '2020-12-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27563, '2020-12-30', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27564, '2020-12-31', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27565, '2021-01-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27566, '2021-01-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27567, '2021-01-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27568, '2021-01-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27569, '2021-01-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27570, '2021-01-06', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27571, '2021-01-07', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27572, '2021-01-08', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27573, '2021-01-09', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27574, '2021-01-10', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27575, '2021-01-11', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27576, '2021-01-12', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27577, '2021-01-13', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '3', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27578, '2021-01-14', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27579, '2021-01-15', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27580, '2021-01-16', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27581, '2021-01-17', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27582, '2021-01-18', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27583, '2021-01-19', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27584, '2021-01-20', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27585, '2021-01-21', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27586, '2021-01-22', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27587, '2021-01-23', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '2', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27588, '2021-01-24', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '3', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27589, '2021-01-25', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27590, '2021-01-26', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27591, '2021-01-27', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27592, '2021-01-28', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '1', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27593, '2021-01-29', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27594, '2021-01-30', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27595, '2021-01-31', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '2', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27596, '2021-02-01', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27597, '2021-02-02', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27598, '2021-02-03', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '1', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27599, '2021-02-04', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27600, '2021-02-05', 'FK', 'Falkland Islands (Malvinas)', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27601, '2020-01-03', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27602, '2020-01-04', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27603, '2020-01-05', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27604, '2020-01-06', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27605, '2020-01-07', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27606, '2020-01-08', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27607, '2020-01-09', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27608, '2020-01-10', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27609, '2020-01-11', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27610, '2020-01-12', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27611, '2020-01-13', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27612, '2020-01-14', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27613, '2020-01-15', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27614, '2020-01-16', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27615, '2020-01-17', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27616, '2020-01-18', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27617, '2020-01-19', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27618, '2020-01-20', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27619, '2020-01-21', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27620, '2020-01-22', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27621, '2020-01-23', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27622, '2020-01-24', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27623, '2020-01-25', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27624, '2020-01-26', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27625, '2020-01-27', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27626, '2020-01-28', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27627, '2020-01-29', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27628, '2020-01-30', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27629, '2020-01-31', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27630, '2020-02-01', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27631, '2020-02-02', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27632, '2020-02-03', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27633, '2020-02-04', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27634, '2020-02-05', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27635, '2020-02-06', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27636, '2020-02-07', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27637, '2020-02-08', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27638, '2020-02-09', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27639, '2020-02-10', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27640, '2020-02-11', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27641, '2020-02-12', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27642, '2020-02-13', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27643, '2020-02-14', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27644, '2020-02-15', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27645, '2020-02-16', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27646, '2020-02-17', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27647, '2020-02-18', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27648, '2020-02-19', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27649, '2020-02-20', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27650, '2020-02-21', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27651, '2020-02-22', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27652, '2020-02-23', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27653, '2020-02-24', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27654, '2020-02-25', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27655, '2020-02-26', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27656, '2020-02-27', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27657, '2020-02-28', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27658, '2020-02-29', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27659, '2020-03-01', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27660, '2020-03-02', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27661, '2020-03-03', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27662, '2020-03-04', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27663, '2020-03-05', 'FO', 'Faroe Islands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27664, '2020-03-06', 'FO', 'Faroe Islands', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27665, '2020-03-07', 'FO', 'Faroe Islands', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27666, '2020-03-08', 'FO', 'Faroe Islands', 'EURO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27667, '2020-03-09', 'FO', 'Faroe Islands', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27668, '2020-03-10', 'FO', 'Faroe Islands', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27669, '2020-03-11', 'FO', 'Faroe Islands', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27670, '2020-03-12', 'FO', 'Faroe Islands', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27671, '2020-03-13', 'FO', 'Faroe Islands', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27672, '2020-03-14', 'FO', 'Faroe Islands', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27673, '2020-03-15', 'FO', 'Faroe Islands', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27674, '2020-03-16', 'FO', 'Faroe Islands', 'EURO', '6', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27675, '2020-03-17', 'FO', 'Faroe Islands', 'EURO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27676, '2020-03-18', 'FO', 'Faroe Islands', 'EURO', '7', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27677, '2020-03-19', 'FO', 'Faroe Islands', 'EURO', '29', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27678, '2020-03-20', 'FO', 'Faroe Islands', 'EURO', '25', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27679, '2020-03-21', 'FO', 'Faroe Islands', 'EURO', '8', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27680, '2020-03-22', 'FO', 'Faroe Islands', 'EURO', '12', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27681, '2020-03-23', 'FO', 'Faroe Islands', 'EURO', '23', '115', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27682, '2020-03-24', 'FO', 'Faroe Islands', 'EURO', '3', '118', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27683, '2020-03-25', 'FO', 'Faroe Islands', 'EURO', '4', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27684, '2020-03-26', 'FO', 'Faroe Islands', 'EURO', '10', '132', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27685, '2020-03-27', 'FO', 'Faroe Islands', 'EURO', '8', '140', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27686, '2020-03-28', 'FO', 'Faroe Islands', 'EURO', '4', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27687, '2020-03-29', 'FO', 'Faroe Islands', 'EURO', '11', '155', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27688, '2020-03-30', 'FO', 'Faroe Islands', 'EURO', '4', '159', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27689, '2020-03-31', 'FO', 'Faroe Islands', 'EURO', '9', '168', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27690, '2020-04-01', 'FO', 'Faroe Islands', 'EURO', '1', '169', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27691, '2020-04-02', 'FO', 'Faroe Islands', 'EURO', '4', '173', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27692, '2020-04-03', 'FO', 'Faroe Islands', 'EURO', '4', '177', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27693, '2020-04-04', 'FO', 'Faroe Islands', 'EURO', '2', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27694, '2020-04-05', 'FO', 'Faroe Islands', 'EURO', '2', '181', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27695, '2020-04-06', 'FO', 'Faroe Islands', 'EURO', '0', '181', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27696, '2020-04-07', 'FO', 'Faroe Islands', 'EURO', '2', '183', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27697, '2020-04-08', 'FO', 'Faroe Islands', 'EURO', '1', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27698, '2020-04-09', 'FO', 'Faroe Islands', 'EURO', '0', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27699, '2020-04-10', 'FO', 'Faroe Islands', 'EURO', '0', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27700, '2020-04-11', 'FO', 'Faroe Islands', 'EURO', '0', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27701, '2020-04-12', 'FO', 'Faroe Islands', 'EURO', '0', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27702, '2020-04-13', 'FO', 'Faroe Islands', 'EURO', '0', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27703, '2020-04-14', 'FO', 'Faroe Islands', 'EURO', '0', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27704, '2020-04-15', 'FO', 'Faroe Islands', 'EURO', '0', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27705, '2020-04-16', 'FO', 'Faroe Islands', 'EURO', '0', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27706, '2020-04-17', 'FO', 'Faroe Islands', 'EURO', '0', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27707, '2020-04-18', 'FO', 'Faroe Islands', 'EURO', '0', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27708, '2020-04-19', 'FO', 'Faroe Islands', 'EURO', '0', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27709, '2020-04-20', 'FO', 'Faroe Islands', 'EURO', '1', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27710, '2020-04-21', 'FO', 'Faroe Islands', 'EURO', '0', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27711, '2020-04-22', 'FO', 'Faroe Islands', 'EURO', '0', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27712, '2020-04-23', 'FO', 'Faroe Islands', 'EURO', '0', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27713, '2020-04-24', 'FO', 'Faroe Islands', 'EURO', '2', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27714, '2020-04-25', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27715, '2020-04-26', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27716, '2020-04-27', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27717, '2020-04-28', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27718, '2020-04-29', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27719, '2020-04-30', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27720, '2020-05-01', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27721, '2020-05-02', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27722, '2020-05-03', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27723, '2020-05-04', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27724, '2020-05-05', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27725, '2020-05-06', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27726, '2020-05-07', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27727, '2020-05-08', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27728, '2020-05-09', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27729, '2020-05-10', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27730, '2020-05-11', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27731, '2020-05-12', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27732, '2020-05-13', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27733, '2020-05-14', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27734, '2020-05-15', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27735, '2020-05-16', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27736, '2020-05-17', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27737, '2020-05-18', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27738, '2020-05-19', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27739, '2020-05-20', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27740, '2020-05-21', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27741, '2020-05-22', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27742, '2020-05-23', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27743, '2020-05-24', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27744, '2020-05-25', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27745, '2020-05-26', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27746, '2020-05-27', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27747, '2020-05-28', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27748, '2020-05-29', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27749, '2020-05-30', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27750, '2020-05-31', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27751, '2020-06-01', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27752, '2020-06-02', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27753, '2020-06-03', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27754, '2020-06-04', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27755, '2020-06-05', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27756, '2020-06-06', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27757, '2020-06-07', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27758, '2020-06-08', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27759, '2020-06-09', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27760, '2020-06-10', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27761, '2020-06-11', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27762, '2020-06-12', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27763, '2020-06-13', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27764, '2020-06-14', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27765, '2020-06-15', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27766, '2020-06-16', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27767, '2020-06-17', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27768, '2020-06-18', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27769, '2020-06-19', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27770, '2020-06-20', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27771, '2020-06-21', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27772, '2020-06-22', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27773, '2020-06-23', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27774, '2020-06-24', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27775, '2020-06-25', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27776, '2020-06-26', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27777, '2020-06-27', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27778, '2020-06-28', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27779, '2020-06-29', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27780, '2020-06-30', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27781, '2020-07-01', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27782, '2020-07-02', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27783, '2020-07-03', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27784, '2020-07-04', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27785, '2020-07-05', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27786, '2020-07-06', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27787, '2020-07-07', 'FO', 'Faroe Islands', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27788, '2020-07-08', 'FO', 'Faroe Islands', 'EURO', '1', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27789, '2020-07-09', 'FO', 'Faroe Islands', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27790, '2020-07-10', 'FO', 'Faroe Islands', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27791, '2020-07-11', 'FO', 'Faroe Islands', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27792, '2020-07-12', 'FO', 'Faroe Islands', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27793, '2020-07-13', 'FO', 'Faroe Islands', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27794, '2020-07-14', 'FO', 'Faroe Islands', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27795, '2020-07-15', 'FO', 'Faroe Islands', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27796, '2020-07-16', 'FO', 'Faroe Islands', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27797, '2020-07-17', 'FO', 'Faroe Islands', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27798, '2020-07-18', 'FO', 'Faroe Islands', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27799, '2020-07-19', 'FO', 'Faroe Islands', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27800, '2020-07-20', 'FO', 'Faroe Islands', 'EURO', '3', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27801, '2020-07-21', 'FO', 'Faroe Islands', 'EURO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27802, '2020-07-22', 'FO', 'Faroe Islands', 'EURO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27803, '2020-07-23', 'FO', 'Faroe Islands', 'EURO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27804, '2020-07-24', 'FO', 'Faroe Islands', 'EURO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27805, '2020-07-25', 'FO', 'Faroe Islands', 'EURO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27806, '2020-07-26', 'FO', 'Faroe Islands', 'EURO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27807, '2020-07-27', 'FO', 'Faroe Islands', 'EURO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27808, '2020-07-28', 'FO', 'Faroe Islands', 'EURO', '23', '214', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27809, '2020-07-29', 'FO', 'Faroe Islands', 'EURO', '6', '220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27810, '2020-07-30', 'FO', 'Faroe Islands', 'EURO', '0', '220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27811, '2020-07-31', 'FO', 'Faroe Islands', 'EURO', '0', '220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27812, '2020-08-01', 'FO', 'Faroe Islands', 'EURO', '5', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27813, '2020-08-02', 'FO', 'Faroe Islands', 'EURO', '0', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27814, '2020-08-03', 'FO', 'Faroe Islands', 'EURO', '0', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27815, '2020-08-04', 'FO', 'Faroe Islands', 'EURO', '0', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27816, '2020-08-05', 'FO', 'Faroe Islands', 'EURO', '2', '227', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27817, '2020-08-06', 'FO', 'Faroe Islands', 'EURO', '14', '241', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27818, '2020-08-07', 'FO', 'Faroe Islands', 'EURO', '0', '241', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27819, '2020-08-08', 'FO', 'Faroe Islands', 'EURO', '50', '291', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27820, '2020-08-09', 'FO', 'Faroe Islands', 'EURO', '0', '291', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27821, '2020-08-10', 'FO', 'Faroe Islands', 'EURO', '0', '291', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27822, '2020-08-11', 'FO', 'Faroe Islands', 'EURO', '22', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27823, '2020-08-12', 'FO', 'Faroe Islands', 'EURO', '11', '324', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27824, '2020-08-13', 'FO', 'Faroe Islands', 'EURO', '15', '339', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27825, '2020-08-14', 'FO', 'Faroe Islands', 'EURO', '23', '362', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27826, '2020-08-15', 'FO', 'Faroe Islands', 'EURO', '0', '362', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27827, '2020-08-16', 'FO', 'Faroe Islands', 'EURO', '8', '370', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27828, '2020-08-17', 'FO', 'Faroe Islands', 'EURO', '2', '372', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27829, '2020-08-18', 'FO', 'Faroe Islands', 'EURO', '1', '373', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27830, '2020-08-19', 'FO', 'Faroe Islands', 'EURO', '0', '373', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27831, '2020-08-20', 'FO', 'Faroe Islands', 'EURO', '9', '382', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27832, '2020-08-21', 'FO', 'Faroe Islands', 'EURO', '1', '383', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27833, '2020-08-22', 'FO', 'Faroe Islands', 'EURO', '1', '384', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27834, '2020-08-23', 'FO', 'Faroe Islands', 'EURO', '0', '384', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27835, '2020-08-24', 'FO', 'Faroe Islands', 'EURO', '0', '384', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27836, '2020-08-25', 'FO', 'Faroe Islands', 'EURO', '26', '410', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27837, '2020-08-26', 'FO', 'Faroe Islands', 'EURO', '1', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27838, '2020-08-27', 'FO', 'Faroe Islands', 'EURO', '0', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27839, '2020-08-28', 'FO', 'Faroe Islands', 'EURO', '0', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27840, '2020-08-29', 'FO', 'Faroe Islands', 'EURO', '0', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27841, '2020-08-30', 'FO', 'Faroe Islands', 'EURO', '0', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27842, '2020-08-31', 'FO', 'Faroe Islands', 'EURO', '0', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27843, '2020-09-01', 'FO', 'Faroe Islands', 'EURO', '0', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27844, '2020-09-02', 'FO', 'Faroe Islands', 'EURO', '0', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27845, '2020-09-03', 'FO', 'Faroe Islands', 'EURO', '0', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27846, '2020-09-04', 'FO', 'Faroe Islands', 'EURO', '1', '412', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27847, '2020-09-05', 'FO', 'Faroe Islands', 'EURO', '1', '413', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27848, '2020-09-06', 'FO', 'Faroe Islands', 'EURO', '0', '413', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27849, '2020-09-07', 'FO', 'Faroe Islands', 'EURO', '0', '413', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27850, '2020-09-08', 'FO', 'Faroe Islands', 'EURO', '0', '413', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27851, '2020-09-09', 'FO', 'Faroe Islands', 'EURO', '1', '414', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27852, '2020-09-10', 'FO', 'Faroe Islands', 'EURO', '1', '415', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27853, '2020-09-11', 'FO', 'Faroe Islands', 'EURO', '0', '415', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27854, '2020-09-12', 'FO', 'Faroe Islands', 'EURO', '1', '416', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27855, '2020-09-13', 'FO', 'Faroe Islands', 'EURO', '2', '418', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27856, '2020-09-14', 'FO', 'Faroe Islands', 'EURO', '5', '423', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27857, '2020-09-15', 'FO', 'Faroe Islands', 'EURO', '0', '423', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27858, '2020-09-16', 'FO', 'Faroe Islands', 'EURO', '5', '428', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27859, '2020-09-17', 'FO', 'Faroe Islands', 'EURO', '0', '428', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27860, '2020-09-18', 'FO', 'Faroe Islands', 'EURO', '1', '429', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27861, '2020-09-19', 'FO', 'Faroe Islands', 'EURO', '1', '430', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27862, '2020-09-20', 'FO', 'Faroe Islands', 'EURO', '1', '431', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27863, '2020-09-21', 'FO', 'Faroe Islands', 'EURO', '3', '434', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27864, '2020-09-22', 'FO', 'Faroe Islands', 'EURO', '3', '437', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27865, '2020-09-23', 'FO', 'Faroe Islands', 'EURO', '11', '448', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27866, '2020-09-24', 'FO', 'Faroe Islands', 'EURO', '3', '451', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27867, '2020-09-25', 'FO', 'Faroe Islands', 'EURO', '4', '455', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27868, '2020-09-26', 'FO', 'Faroe Islands', 'EURO', '3', '458', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27869, '2020-09-27', 'FO', 'Faroe Islands', 'EURO', '2', '460', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27870, '2020-09-28', 'FO', 'Faroe Islands', 'EURO', '0', '460', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27871, '2020-09-29', 'FO', 'Faroe Islands', 'EURO', '0', '460', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27872, '2020-09-30', 'FO', 'Faroe Islands', 'EURO', '3', '463', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27873, '2020-10-01', 'FO', 'Faroe Islands', 'EURO', '4', '467', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27874, '2020-10-02', 'FO', 'Faroe Islands', 'EURO', '5', '472', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27875, '2020-10-03', 'FO', 'Faroe Islands', 'EURO', '0', '472', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27876, '2020-10-04', 'FO', 'Faroe Islands', 'EURO', '1', '473', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27877, '2020-10-05', 'FO', 'Faroe Islands', 'EURO', '1', '474', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27878, '2020-10-06', 'FO', 'Faroe Islands', 'EURO', '1', '475', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27879, '2020-10-07', 'FO', 'Faroe Islands', 'EURO', '0', '475', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27880, '2020-10-08', 'FO', 'Faroe Islands', 'EURO', '1', '476', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27881, '2020-10-09', 'FO', 'Faroe Islands', 'EURO', '1', '477', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27882, '2020-10-10', 'FO', 'Faroe Islands', 'EURO', '0', '477', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27883, '2020-10-11', 'FO', 'Faroe Islands', 'EURO', '0', '477', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27884, '2020-10-12', 'FO', 'Faroe Islands', 'EURO', '0', '477', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27885, '2020-10-13', 'FO', 'Faroe Islands', 'EURO', '0', '477', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27886, '2020-10-14', 'FO', 'Faroe Islands', 'EURO', '0', '477', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27887, '2020-10-15', 'FO', 'Faroe Islands', 'EURO', '1', '478', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27888, '2020-10-16', 'FO', 'Faroe Islands', 'EURO', '2', '480', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27889, '2020-10-17', 'FO', 'Faroe Islands', 'EURO', '2', '482', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27890, '2020-10-18', 'FO', 'Faroe Islands', 'EURO', '1', '483', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27891, '2020-10-19', 'FO', 'Faroe Islands', 'EURO', '2', '485', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27892, '2020-10-20', 'FO', 'Faroe Islands', 'EURO', '0', '485', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27893, '2020-10-21', 'FO', 'Faroe Islands', 'EURO', '3', '488', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27894, '2020-10-22', 'FO', 'Faroe Islands', 'EURO', '0', '488', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27895, '2020-10-23', 'FO', 'Faroe Islands', 'EURO', '2', '490', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27896, '2020-10-24', 'FO', 'Faroe Islands', 'EURO', '0', '490', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27897, '2020-10-25', 'FO', 'Faroe Islands', 'EURO', '0', '490', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27898, '2020-10-26', 'FO', 'Faroe Islands', 'EURO', '0', '490', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27899, '2020-10-27', 'FO', 'Faroe Islands', 'EURO', '0', '490', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27900, '2020-10-28', 'FO', 'Faroe Islands', 'EURO', '4', '494', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27901, '2020-10-29', 'FO', 'Faroe Islands', 'EURO', '0', '494', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27902, '2020-10-30', 'FO', 'Faroe Islands', 'EURO', '0', '494', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27903, '2020-10-31', 'FO', 'Faroe Islands', 'EURO', '0', '494', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27904, '2020-11-01', 'FO', 'Faroe Islands', 'EURO', '1', '495', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27905, '2020-11-02', 'FO', 'Faroe Islands', 'EURO', '0', '495', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27906, '2020-11-03', 'FO', 'Faroe Islands', 'EURO', '0', '495', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27907, '2020-11-04', 'FO', 'Faroe Islands', 'EURO', '0', '495', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27908, '2020-11-05', 'FO', 'Faroe Islands', 'EURO', '0', '495', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27909, '2020-11-06', 'FO', 'Faroe Islands', 'EURO', '0', '495', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27910, '2020-11-07', 'FO', 'Faroe Islands', 'EURO', '0', '495', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27911, '2020-11-08', 'FO', 'Faroe Islands', 'EURO', '0', '495', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27912, '2020-11-09', 'FO', 'Faroe Islands', 'EURO', '2', '497', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27913, '2020-11-10', 'FO', 'Faroe Islands', 'EURO', '0', '497', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27914, '2020-11-11', 'FO', 'Faroe Islands', 'EURO', '0', '497', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27915, '2020-11-12', 'FO', 'Faroe Islands', 'EURO', '0', '497', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27916, '2020-11-13', 'FO', 'Faroe Islands', 'EURO', '0', '497', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27917, '2020-11-14', 'FO', 'Faroe Islands', 'EURO', '0', '497', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27918, '2020-11-15', 'FO', 'Faroe Islands', 'EURO', '0', '497', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27919, '2020-11-16', 'FO', 'Faroe Islands', 'EURO', '1', '498', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27920, '2020-11-17', 'FO', 'Faroe Islands', 'EURO', '0', '498', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27921, '2020-11-18', 'FO', 'Faroe Islands', 'EURO', '0', '498', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27922, '2020-11-19', 'FO', 'Faroe Islands', 'EURO', '0', '498', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27923, '2020-11-20', 'FO', 'Faroe Islands', 'EURO', '0', '498', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27924, '2020-11-21', 'FO', 'Faroe Islands', 'EURO', '0', '498', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27925, '2020-11-22', 'FO', 'Faroe Islands', 'EURO', '1', '499', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27926, '2020-11-23', 'FO', 'Faroe Islands', 'EURO', '1', '500', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27927, '2020-11-24', 'FO', 'Faroe Islands', 'EURO', '0', '500', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27928, '2020-11-25', 'FO', 'Faroe Islands', 'EURO', '0', '500', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27929, '2020-11-26', 'FO', 'Faroe Islands', 'EURO', '0', '500', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27930, '2020-11-27', 'FO', 'Faroe Islands', 'EURO', '0', '500', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27931, '2020-11-28', 'FO', 'Faroe Islands', 'EURO', '0', '500', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27932, '2020-11-29', 'FO', 'Faroe Islands', 'EURO', '2', '502', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27933, '2020-11-30', 'FO', 'Faroe Islands', 'EURO', '0', '502', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27934, '2020-12-01', 'FO', 'Faroe Islands', 'EURO', '1', '503', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27935, '2020-12-02', 'FO', 'Faroe Islands', 'EURO', '0', '503', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27936, '2020-12-03', 'FO', 'Faroe Islands', 'EURO', '0', '503', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27937, '2020-12-04', 'FO', 'Faroe Islands', 'EURO', '2', '505', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27938, '2020-12-05', 'FO', 'Faroe Islands', 'EURO', '0', '505', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27939, '2020-12-06', 'FO', 'Faroe Islands', 'EURO', '1', '506', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27940, '2020-12-07', 'FO', 'Faroe Islands', 'EURO', '4', '510', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27941, '2020-12-08', 'FO', 'Faroe Islands', 'EURO', '0', '510', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27942, '2020-12-09', 'FO', 'Faroe Islands', 'EURO', '4', '514', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27943, '2020-12-10', 'FO', 'Faroe Islands', 'EURO', '5', '519', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27944, '2020-12-11', 'FO', 'Faroe Islands', 'EURO', '0', '519', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27945, '2020-12-12', 'FO', 'Faroe Islands', 'EURO', '1', '520', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27946, '2020-12-13', 'FO', 'Faroe Islands', 'EURO', '5', '525', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27947, '2020-12-14', 'FO', 'Faroe Islands', 'EURO', '3', '528', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27948, '2020-12-15', 'FO', 'Faroe Islands', 'EURO', '0', '528', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27949, '2020-12-16', 'FO', 'Faroe Islands', 'EURO', '2', '530', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27950, '2020-12-17', 'FO', 'Faroe Islands', 'EURO', '2', '532', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27951, '2020-12-18', 'FO', 'Faroe Islands', 'EURO', '2', '534', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27952, '2020-12-19', 'FO', 'Faroe Islands', 'EURO', '12', '546', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27953, '2020-12-20', 'FO', 'Faroe Islands', 'EURO', '0', '546', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27954, '2020-12-21', 'FO', 'Faroe Islands', 'EURO', '0', '546', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27955, '2020-12-22', 'FO', 'Faroe Islands', 'EURO', '1', '547', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27956, '2020-12-23', 'FO', 'Faroe Islands', 'EURO', '3', '550', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27957, '2020-12-24', 'FO', 'Faroe Islands', 'EURO', '6', '556', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27958, '2020-12-25', 'FO', 'Faroe Islands', 'EURO', '5', '561', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27959, '2020-12-26', 'FO', 'Faroe Islands', 'EURO', '6', '567', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27960, '2020-12-27', 'FO', 'Faroe Islands', 'EURO', '4', '571', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27961, '2020-12-28', 'FO', 'Faroe Islands', 'EURO', '8', '579', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27962, '2020-12-29', 'FO', 'Faroe Islands', 'EURO', '3', '582', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27963, '2020-12-30', 'FO', 'Faroe Islands', 'EURO', '19', '601', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27964, '2020-12-31', 'FO', 'Faroe Islands', 'EURO', '4', '605', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27965, '2021-01-01', 'FO', 'Faroe Islands', 'EURO', '5', '610', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27966, '2021-01-02', 'FO', 'Faroe Islands', 'EURO', '0', '610', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27967, '2021-01-03', 'FO', 'Faroe Islands', 'EURO', '4', '614', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27968, '2021-01-04', 'FO', 'Faroe Islands', 'EURO', '6', '620', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27969, '2021-01-05', 'FO', 'Faroe Islands', 'EURO', '2', '622', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27970, '2021-01-06', 'FO', 'Faroe Islands', 'EURO', '4', '626', '0', '0');
INSERT INTO public.who_global_data_import VALUES (27971, '2021-01-07', 'FO', 'Faroe Islands', 'EURO', '14', '640', '1', '1');
INSERT INTO public.who_global_data_import VALUES (27972, '2021-01-08', 'FO', 'Faroe Islands', 'EURO', '3', '643', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27973, '2021-01-09', 'FO', 'Faroe Islands', 'EURO', '1', '644', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27974, '2021-01-10', 'FO', 'Faroe Islands', 'EURO', '2', '646', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27975, '2021-01-11', 'FO', 'Faroe Islands', 'EURO', '0', '646', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27976, '2021-01-12', 'FO', 'Faroe Islands', 'EURO', '0', '646', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27977, '2021-01-13', 'FO', 'Faroe Islands', 'EURO', '0', '646', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27978, '2021-01-14', 'FO', 'Faroe Islands', 'EURO', '1', '647', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27979, '2021-01-15', 'FO', 'Faroe Islands', 'EURO', '0', '647', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27980, '2021-01-16', 'FO', 'Faroe Islands', 'EURO', '1', '648', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27981, '2021-01-17', 'FO', 'Faroe Islands', 'EURO', '1', '649', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27982, '2021-01-18', 'FO', 'Faroe Islands', 'EURO', '0', '649', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27983, '2021-01-19', 'FO', 'Faroe Islands', 'EURO', '0', '649', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27984, '2021-01-20', 'FO', 'Faroe Islands', 'EURO', '1', '650', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27985, '2021-01-21', 'FO', 'Faroe Islands', 'EURO', '2', '652', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27986, '2021-01-22', 'FO', 'Faroe Islands', 'EURO', '0', '652', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27987, '2021-01-23', 'FO', 'Faroe Islands', 'EURO', '0', '652', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27988, '2021-01-24', 'FO', 'Faroe Islands', 'EURO', '0', '652', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27989, '2021-01-25', 'FO', 'Faroe Islands', 'EURO', '0', '652', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27990, '2021-01-26', 'FO', 'Faroe Islands', 'EURO', '0', '652', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27991, '2021-01-27', 'FO', 'Faroe Islands', 'EURO', '2', '654', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27992, '2021-01-28', 'FO', 'Faroe Islands', 'EURO', '0', '654', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27993, '2021-01-29', 'FO', 'Faroe Islands', 'EURO', '0', '654', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27994, '2021-01-30', 'FO', 'Faroe Islands', 'EURO', '0', '654', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27995, '2021-01-31', 'FO', 'Faroe Islands', 'EURO', '0', '654', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27996, '2021-02-01', 'FO', 'Faroe Islands', 'EURO', '0', '654', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27997, '2021-02-02', 'FO', 'Faroe Islands', 'EURO', '0', '654', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27998, '2021-02-03', 'FO', 'Faroe Islands', 'EURO', '0', '654', '0', '1');
INSERT INTO public.who_global_data_import VALUES (27999, '2021-02-04', 'FO', 'Faroe Islands', 'EURO', '0', '654', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28000, '2021-02-05', 'FO', 'Faroe Islands', 'EURO', '1', '655', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28001, '2020-01-03', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28002, '2020-01-04', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28003, '2020-01-05', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28004, '2020-01-06', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28005, '2020-01-07', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28006, '2020-01-08', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28007, '2020-01-09', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28008, '2020-01-10', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28009, '2020-01-11', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28010, '2020-01-12', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28011, '2020-01-13', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28012, '2020-01-14', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28013, '2020-01-15', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28014, '2020-01-16', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28015, '2020-01-17', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28016, '2020-01-18', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28017, '2020-01-19', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28018, '2020-01-20', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28019, '2020-01-21', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28020, '2020-01-22', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28021, '2020-01-23', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28022, '2020-01-24', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28023, '2020-01-25', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28024, '2020-01-26', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28025, '2020-01-27', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28026, '2020-01-28', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28027, '2020-01-29', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28028, '2020-01-30', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28029, '2020-01-31', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28030, '2020-02-01', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28031, '2020-02-02', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28032, '2020-02-03', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28033, '2020-02-04', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28034, '2020-02-05', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28035, '2020-02-06', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28036, '2020-02-07', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28037, '2020-02-08', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28038, '2020-02-09', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28039, '2020-02-10', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28040, '2020-02-11', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28041, '2020-02-12', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28042, '2020-02-13', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28043, '2020-02-14', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28044, '2020-02-15', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28045, '2020-02-16', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28046, '2020-02-17', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28047, '2020-02-18', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28048, '2020-02-19', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28049, '2020-02-20', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28050, '2020-02-21', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28051, '2020-02-22', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28052, '2020-02-23', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28053, '2020-02-24', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28054, '2020-02-25', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28055, '2020-02-26', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28056, '2020-02-27', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28057, '2020-02-28', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28058, '2020-02-29', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28059, '2020-03-01', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28060, '2020-03-02', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28061, '2020-03-03', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28062, '2020-03-04', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28063, '2020-03-05', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28064, '2020-03-06', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28065, '2020-03-07', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28066, '2020-03-08', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28067, '2020-03-09', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28068, '2020-03-10', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28069, '2020-03-11', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28070, '2020-03-12', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28071, '2020-03-13', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28072, '2020-03-14', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28073, '2020-03-15', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28074, '2020-03-16', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28075, '2020-03-17', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28076, '2020-03-18', 'FJ', 'Fiji', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28077, '2020-03-19', 'FJ', 'Fiji', 'WPRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28078, '2020-03-20', 'FJ', 'Fiji', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28079, '2020-03-21', 'FJ', 'Fiji', 'WPRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28080, '2020-03-22', 'FJ', 'Fiji', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28081, '2020-03-23', 'FJ', 'Fiji', 'WPRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28082, '2020-03-24', 'FJ', 'Fiji', 'WPRO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28083, '2020-03-25', 'FJ', 'Fiji', 'WPRO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28084, '2020-03-26', 'FJ', 'Fiji', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28085, '2020-03-27', 'FJ', 'Fiji', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28086, '2020-03-28', 'FJ', 'Fiji', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28087, '2020-03-29', 'FJ', 'Fiji', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28093, '2020-04-04', 'FJ', 'Fiji', 'WPRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28094, '2020-04-05', 'FJ', 'Fiji', 'WPRO', '5', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28095, '2020-04-06', 'FJ', 'Fiji', 'WPRO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28096, '2020-04-07', 'FJ', 'Fiji', 'WPRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28097, '2020-04-08', 'FJ', 'Fiji', 'WPRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28098, '2020-04-09', 'FJ', 'Fiji', 'WPRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28099, '2020-04-10', 'FJ', 'Fiji', 'WPRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28100, '2020-04-11', 'FJ', 'Fiji', 'WPRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28101, '2020-04-12', 'FJ', 'Fiji', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28102, '2020-04-13', 'FJ', 'Fiji', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28103, '2020-04-14', 'FJ', 'Fiji', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28104, '2020-04-15', 'FJ', 'Fiji', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28105, '2020-04-16', 'FJ', 'Fiji', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28106, '2020-04-17', 'FJ', 'Fiji', 'WPRO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28107, '2020-04-18', 'FJ', 'Fiji', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28108, '2020-04-19', 'FJ', 'Fiji', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28109, '2020-04-20', 'FJ', 'Fiji', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28110, '2020-04-21', 'FJ', 'Fiji', 'WPRO', '1', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28111, '2020-04-22', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28112, '2020-04-23', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28113, '2020-04-24', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28114, '2020-04-25', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28115, '2020-04-26', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28116, '2020-04-27', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28117, '2020-04-28', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28118, '2020-04-29', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28119, '2020-04-30', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28120, '2020-05-01', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28121, '2020-05-02', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28122, '2020-05-03', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28123, '2020-05-04', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28124, '2020-05-05', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28125, '2020-05-06', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28126, '2020-05-07', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28127, '2020-05-08', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28128, '2020-05-09', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28129, '2020-05-10', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28130, '2020-05-11', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28131, '2020-05-12', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28132, '2020-05-13', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28133, '2020-05-14', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28134, '2020-05-15', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28135, '2020-05-16', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28136, '2020-05-17', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28137, '2020-05-18', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28138, '2020-05-19', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28139, '2020-05-20', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28140, '2020-05-21', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28141, '2020-05-22', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28142, '2020-05-23', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28143, '2020-05-24', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28144, '2020-05-25', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28145, '2020-05-26', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28146, '2020-05-27', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28147, '2020-05-28', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28148, '2020-05-29', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28149, '2020-05-30', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28150, '2020-05-31', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28151, '2020-06-01', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28152, '2020-06-02', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28153, '2020-06-03', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28154, '2020-06-04', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28155, '2020-06-05', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28156, '2020-06-06', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28157, '2020-06-07', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28158, '2020-06-08', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28159, '2020-06-09', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28160, '2020-06-10', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28161, '2020-06-11', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28162, '2020-06-12', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28163, '2020-06-13', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28164, '2020-06-14', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28165, '2020-06-15', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28166, '2020-06-16', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28167, '2020-06-17', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28168, '2020-06-18', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28169, '2020-06-19', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28170, '2020-06-20', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28171, '2020-06-21', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28172, '2020-06-22', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28173, '2020-06-23', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28174, '2020-06-24', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28175, '2020-06-25', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28176, '2020-06-26', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28177, '2020-06-27', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28178, '2020-06-28', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28179, '2020-06-29', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28180, '2020-06-30', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28181, '2020-07-01', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28182, '2020-07-02', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28183, '2020-07-03', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28184, '2020-07-04', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28185, '2020-07-05', 'FJ', 'Fiji', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28186, '2020-07-06', 'FJ', 'Fiji', 'WPRO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28187, '2020-07-07', 'FJ', 'Fiji', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28188, '2020-07-08', 'FJ', 'Fiji', 'WPRO', '2', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28189, '2020-07-09', 'FJ', 'Fiji', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28190, '2020-07-10', 'FJ', 'Fiji', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28191, '2020-07-11', 'FJ', 'Fiji', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28192, '2020-07-12', 'FJ', 'Fiji', 'WPRO', '5', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28193, '2020-07-13', 'FJ', 'Fiji', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28194, '2020-07-14', 'FJ', 'Fiji', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28195, '2020-07-15', 'FJ', 'Fiji', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28196, '2020-07-16', 'FJ', 'Fiji', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28197, '2020-07-17', 'FJ', 'Fiji', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28198, '2020-07-18', 'FJ', 'Fiji', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28199, '2020-07-19', 'FJ', 'Fiji', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28200, '2020-07-20', 'FJ', 'Fiji', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28201, '2020-07-21', 'FJ', 'Fiji', 'WPRO', '1', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28202, '2020-07-22', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28203, '2020-07-23', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28204, '2020-07-24', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28205, '2020-07-25', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28206, '2020-07-26', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28207, '2020-07-27', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28208, '2020-07-28', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28209, '2020-07-29', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28210, '2020-07-30', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28211, '2020-07-31', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28212, '2020-08-01', 'FJ', 'Fiji', 'WPRO', '0', '27', '1', '1');
INSERT INTO public.who_global_data_import VALUES (28213, '2020-08-02', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28214, '2020-08-03', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28215, '2020-08-04', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28216, '2020-08-05', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28217, '2020-08-06', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28218, '2020-08-07', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28219, '2020-08-08', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28220, '2020-08-09', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28221, '2020-08-10', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28222, '2020-08-11', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28223, '2020-08-12', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28224, '2020-08-13', 'FJ', 'Fiji', 'WPRO', '0', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28225, '2020-08-14', 'FJ', 'Fiji', 'WPRO', '1', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28226, '2020-08-15', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28227, '2020-08-16', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28228, '2020-08-17', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28229, '2020-08-18', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28230, '2020-08-19', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28231, '2020-08-20', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28232, '2020-08-21', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28233, '2020-08-22', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28234, '2020-08-23', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28235, '2020-08-24', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28236, '2020-08-25', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28237, '2020-08-26', 'FJ', 'Fiji', 'WPRO', '0', '28', '1', '2');
INSERT INTO public.who_global_data_import VALUES (28238, '2020-08-27', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28239, '2020-08-28', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28240, '2020-08-29', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28241, '2020-08-30', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28242, '2020-08-31', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28243, '2020-09-01', 'FJ', 'Fiji', 'WPRO', '0', '28', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28244, '2020-09-02', 'FJ', 'Fiji', 'WPRO', '1', '29', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28245, '2020-09-03', 'FJ', 'Fiji', 'WPRO', '0', '29', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28246, '2020-09-04', 'FJ', 'Fiji', 'WPRO', '2', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28247, '2020-09-05', 'FJ', 'Fiji', 'WPRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28248, '2020-09-06', 'FJ', 'Fiji', 'WPRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28249, '2020-09-07', 'FJ', 'Fiji', 'WPRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28250, '2020-09-08', 'FJ', 'Fiji', 'WPRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28251, '2020-09-09', 'FJ', 'Fiji', 'WPRO', '1', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28252, '2020-09-10', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28253, '2020-09-11', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28254, '2020-09-12', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28255, '2020-09-13', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28256, '2020-09-14', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28257, '2020-09-15', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28258, '2020-09-16', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28259, '2020-09-17', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28260, '2020-09-18', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28261, '2020-09-19', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28262, '2020-09-20', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28263, '2020-09-21', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28264, '2020-09-22', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28265, '2020-09-23', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28266, '2020-09-24', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28267, '2020-09-25', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28268, '2020-09-26', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28269, '2020-09-27', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28270, '2020-09-28', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28271, '2020-09-29', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28272, '2020-09-30', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28273, '2020-10-01', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28274, '2020-10-02', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28275, '2020-10-03', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28276, '2020-10-04', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28277, '2020-10-05', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28278, '2020-10-06', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28279, '2020-10-07', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28280, '2020-10-08', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28281, '2020-10-09', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28282, '2020-10-10', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28283, '2020-10-11', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28284, '2020-10-12', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28285, '2020-10-13', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28286, '2020-10-14', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28287, '2020-10-15', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28288, '2020-10-16', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28289, '2020-10-17', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28290, '2020-10-18', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28291, '2020-10-19', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28292, '2020-10-20', 'FJ', 'Fiji', 'WPRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28293, '2020-10-21', 'FJ', 'Fiji', 'WPRO', '1', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28294, '2020-10-22', 'FJ', 'Fiji', 'WPRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28295, '2020-10-23', 'FJ', 'Fiji', 'WPRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28296, '2020-10-24', 'FJ', 'Fiji', 'WPRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28297, '2020-10-25', 'FJ', 'Fiji', 'WPRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28298, '2020-10-26', 'FJ', 'Fiji', 'WPRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28299, '2020-10-27', 'FJ', 'Fiji', 'WPRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28300, '2020-10-28', 'FJ', 'Fiji', 'WPRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28301, '2020-10-29', 'FJ', 'Fiji', 'WPRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28302, '2020-10-30', 'FJ', 'Fiji', 'WPRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28303, '2020-10-31', 'FJ', 'Fiji', 'WPRO', '1', '34', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28304, '2020-11-01', 'FJ', 'Fiji', 'WPRO', '0', '34', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28305, '2020-11-02', 'FJ', 'Fiji', 'WPRO', '0', '34', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28306, '2020-11-03', 'FJ', 'Fiji', 'WPRO', '0', '34', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28307, '2020-11-04', 'FJ', 'Fiji', 'WPRO', '0', '34', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28308, '2020-11-05', 'FJ', 'Fiji', 'WPRO', '0', '34', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28309, '2020-11-06', 'FJ', 'Fiji', 'WPRO', '0', '34', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28310, '2020-11-07', 'FJ', 'Fiji', 'WPRO', '0', '34', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28311, '2020-11-08', 'FJ', 'Fiji', 'WPRO', '0', '34', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28312, '2020-11-09', 'FJ', 'Fiji', 'WPRO', '0', '34', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28313, '2020-11-10', 'FJ', 'Fiji', 'WPRO', '0', '34', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28314, '2020-11-11', 'FJ', 'Fiji', 'WPRO', '0', '34', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28315, '2020-11-12', 'FJ', 'Fiji', 'WPRO', '1', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28316, '2020-11-13', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28317, '2020-11-14', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28318, '2020-11-15', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28319, '2020-11-16', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28320, '2020-11-17', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28321, '2020-11-18', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28322, '2020-11-19', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28323, '2020-11-20', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28324, '2020-11-21', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28325, '2020-11-22', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28326, '2020-11-23', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28327, '2020-11-24', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28328, '2020-11-25', 'FJ', 'Fiji', 'WPRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28329, '2020-11-26', 'FJ', 'Fiji', 'WPRO', '3', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28330, '2020-11-27', 'FJ', 'Fiji', 'WPRO', '0', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28331, '2020-11-28', 'FJ', 'Fiji', 'WPRO', '0', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28332, '2020-11-29', 'FJ', 'Fiji', 'WPRO', '0', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28333, '2020-11-30', 'FJ', 'Fiji', 'WPRO', '0', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28334, '2020-12-01', 'FJ', 'Fiji', 'WPRO', '4', '42', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28335, '2020-12-02', 'FJ', 'Fiji', 'WPRO', '0', '42', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28336, '2020-12-03', 'FJ', 'Fiji', 'WPRO', '0', '42', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28337, '2020-12-04', 'FJ', 'Fiji', 'WPRO', '2', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28338, '2020-12-05', 'FJ', 'Fiji', 'WPRO', '0', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28339, '2020-12-06', 'FJ', 'Fiji', 'WPRO', '0', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28340, '2020-12-07', 'FJ', 'Fiji', 'WPRO', '0', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28341, '2020-12-08', 'FJ', 'Fiji', 'WPRO', '0', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28342, '2020-12-09', 'FJ', 'Fiji', 'WPRO', '0', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28343, '2020-12-10', 'FJ', 'Fiji', 'WPRO', '0', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28344, '2020-12-11', 'FJ', 'Fiji', 'WPRO', '0', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28345, '2020-12-12', 'FJ', 'Fiji', 'WPRO', '0', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28346, '2020-12-13', 'FJ', 'Fiji', 'WPRO', '0', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28347, '2020-12-14', 'FJ', 'Fiji', 'WPRO', '2', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28348, '2020-12-15', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28349, '2020-12-16', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28350, '2020-12-17', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28351, '2020-12-18', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28352, '2020-12-19', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28353, '2020-12-20', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28354, '2020-12-21', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28355, '2020-12-22', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28356, '2020-12-23', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28357, '2020-12-24', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28358, '2020-12-25', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28359, '2020-12-26', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28360, '2020-12-27', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28361, '2020-12-28', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28362, '2020-12-29', 'FJ', 'Fiji', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28363, '2020-12-30', 'FJ', 'Fiji', 'WPRO', '3', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28364, '2020-12-31', 'FJ', 'Fiji', 'WPRO', '0', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28365, '2021-01-01', 'FJ', 'Fiji', 'WPRO', '0', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28366, '2021-01-02', 'FJ', 'Fiji', 'WPRO', '0', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28367, '2021-01-03', 'FJ', 'Fiji', 'WPRO', '0', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28368, '2021-01-04', 'FJ', 'Fiji', 'WPRO', '0', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28369, '2021-01-05', 'FJ', 'Fiji', 'WPRO', '0', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28370, '2021-01-06', 'FJ', 'Fiji', 'WPRO', '0', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28371, '2021-01-07', 'FJ', 'Fiji', 'WPRO', '4', '53', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28372, '2021-01-08', 'FJ', 'Fiji', 'WPRO', '0', '53', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28373, '2021-01-09', 'FJ', 'Fiji', 'WPRO', '0', '53', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28374, '2021-01-10', 'FJ', 'Fiji', 'WPRO', '0', '53', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28375, '2021-01-11', 'FJ', 'Fiji', 'WPRO', '0', '53', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28376, '2021-01-12', 'FJ', 'Fiji', 'WPRO', '0', '53', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28377, '2021-01-13', 'FJ', 'Fiji', 'WPRO', '0', '53', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28378, '2021-01-14', 'FJ', 'Fiji', 'WPRO', '0', '53', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28379, '2021-01-15', 'FJ', 'Fiji', 'WPRO', '0', '53', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28380, '2021-01-16', 'FJ', 'Fiji', 'WPRO', '0', '53', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28381, '2021-01-17', 'FJ', 'Fiji', 'WPRO', '2', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28382, '2021-01-18', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28383, '2021-01-19', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28384, '2021-01-20', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28385, '2021-01-21', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28386, '2021-01-22', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28387, '2021-01-23', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28388, '2021-01-24', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28389, '2021-01-25', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28390, '2021-01-26', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28391, '2021-01-27', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28392, '2021-01-28', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28393, '2021-01-29', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28394, '2021-01-30', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28395, '2021-01-31', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28396, '2021-02-01', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28397, '2021-02-02', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28398, '2021-02-03', 'FJ', 'Fiji', 'WPRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28399, '2021-02-04', 'FJ', 'Fiji', 'WPRO', '1', '56', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28400, '2021-02-05', 'FJ', 'Fiji', 'WPRO', '0', '56', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28401, '2020-01-03', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28402, '2020-01-04', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28403, '2020-01-05', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28404, '2020-01-06', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28405, '2020-01-07', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28406, '2020-01-08', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28407, '2020-01-09', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28408, '2020-01-10', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28409, '2020-01-11', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28410, '2020-01-12', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28411, '2020-01-13', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28412, '2020-01-14', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28413, '2020-01-15', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28414, '2020-01-16', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28415, '2020-01-17', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28416, '2020-01-18', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28417, '2020-01-19', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28418, '2020-01-20', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28419, '2020-01-21', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28420, '2020-01-22', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28421, '2020-01-23', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28422, '2020-01-24', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28423, '2020-01-25', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28424, '2020-01-26', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28425, '2020-01-27', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28426, '2020-01-28', 'FI', 'Finland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28427, '2020-01-29', 'FI', 'Finland', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28428, '2020-01-30', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28429, '2020-01-31', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28430, '2020-02-01', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28431, '2020-02-02', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28432, '2020-02-03', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28433, '2020-02-04', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28434, '2020-02-05', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28435, '2020-02-06', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28436, '2020-02-07', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28437, '2020-02-08', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28438, '2020-02-09', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28439, '2020-02-10', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28440, '2020-02-11', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28441, '2020-02-12', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28442, '2020-02-13', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28443, '2020-02-14', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28444, '2020-02-15', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28445, '2020-02-16', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28446, '2020-02-17', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28447, '2020-02-18', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28448, '2020-02-19', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28449, '2020-02-20', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28450, '2020-02-21', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28451, '2020-02-22', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28452, '2020-02-23', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28453, '2020-02-24', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28454, '2020-02-25', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28455, '2020-02-26', 'FI', 'Finland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28456, '2020-02-27', 'FI', 'Finland', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28457, '2020-02-28', 'FI', 'Finland', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28458, '2020-02-29', 'FI', 'Finland', 'EURO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28459, '2020-03-01', 'FI', 'Finland', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28460, '2020-03-02', 'FI', 'Finland', 'EURO', '3', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28461, '2020-03-03', 'FI', 'Finland', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28462, '2020-03-04', 'FI', 'Finland', 'EURO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28463, '2020-03-05', 'FI', 'Finland', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28464, '2020-03-06', 'FI', 'Finland', 'EURO', '5', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28465, '2020-03-07', 'FI', 'Finland', 'EURO', '7', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28466, '2020-03-08', 'FI', 'Finland', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28467, '2020-03-09', 'FI', 'Finland', 'EURO', '11', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28468, '2020-03-10', 'FI', 'Finland', 'EURO', '10', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28469, '2020-03-11', 'FI', 'Finland', 'EURO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28470, '2020-03-12', 'FI', 'Finland', 'EURO', '19', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28471, '2020-03-13', 'FI', 'Finland', 'EURO', '96', '155', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28472, '2020-03-14', 'FI', 'Finland', 'EURO', '28', '183', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28473, '2020-03-15', 'FI', 'Finland', 'EURO', '27', '210', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28474, '2020-03-16', 'FI', 'Finland', 'EURO', '57', '267', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28475, '2020-03-17', 'FI', 'Finland', 'EURO', '5', '272', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28476, '2020-03-18', 'FI', 'Finland', 'EURO', '47', '319', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28477, '2020-03-19', 'FI', 'Finland', 'EURO', '50', '369', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28478, '2020-03-20', 'FI', 'Finland', 'EURO', '31', '400', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28479, '2020-03-21', 'FI', 'Finland', 'EURO', '50', '450', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28480, '2020-03-22', 'FI', 'Finland', 'EURO', '71', '521', '1', '1');
INSERT INTO public.who_global_data_import VALUES (28481, '2020-03-23', 'FI', 'Finland', 'EURO', '105', '626', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28482, '2020-03-24', 'FI', 'Finland', 'EURO', '74', '700', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28483, '2020-03-25', 'FI', 'Finland', 'EURO', '92', '792', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28484, '2020-03-26', 'FI', 'Finland', 'EURO', '88', '880', '2', '3');
INSERT INTO public.who_global_data_import VALUES (28485, '2020-03-27', 'FI', 'Finland', 'EURO', '78', '958', '1', '4');
INSERT INTO public.who_global_data_import VALUES (28486, '2020-03-28', 'FI', 'Finland', 'EURO', '67', '1025', '3', '7');
INSERT INTO public.who_global_data_import VALUES (28487, '2020-03-29', 'FI', 'Finland', 'EURO', '193', '1218', '2', '9');
INSERT INTO public.who_global_data_import VALUES (28488, '2020-03-30', 'FI', 'Finland', 'EURO', '0', '1218', '2', '11');
INSERT INTO public.who_global_data_import VALUES (28489, '2020-03-31', 'FI', 'Finland', 'EURO', '95', '1313', '2', '13');
INSERT INTO public.who_global_data_import VALUES (28490, '2020-04-01', 'FI', 'Finland', 'EURO', '71', '1384', '4', '17');
INSERT INTO public.who_global_data_import VALUES (28491, '2020-04-02', 'FI', 'Finland', 'EURO', '62', '1446', '0', '17');
INSERT INTO public.who_global_data_import VALUES (28492, '2020-04-03', 'FI', 'Finland', 'EURO', '72', '1518', '2', '19');
INSERT INTO public.who_global_data_import VALUES (28493, '2020-04-04', 'FI', 'Finland', 'EURO', '97', '1615', '1', '20');
INSERT INTO public.who_global_data_import VALUES (28494, '2020-04-05', 'FI', 'Finland', 'EURO', '267', '1882', '5', '25');
INSERT INTO public.who_global_data_import VALUES (28495, '2020-04-06', 'FI', 'Finland', 'EURO', '45', '1927', '2', '27');
INSERT INTO public.who_global_data_import VALUES (28496, '2020-04-07', 'FI', 'Finland', 'EURO', '249', '2176', '0', '27');
INSERT INTO public.who_global_data_import VALUES (28497, '2020-04-08', 'FI', 'Finland', 'EURO', '132', '2308', '7', '34');
INSERT INTO public.who_global_data_import VALUES (28498, '2020-04-09', 'FI', 'Finland', 'EURO', '179', '2487', '6', '40');
INSERT INTO public.who_global_data_import VALUES (28499, '2020-04-10', 'FI', 'Finland', 'EURO', '118', '2605', '2', '42');
INSERT INTO public.who_global_data_import VALUES (28500, '2020-04-11', 'FI', 'Finland', 'EURO', '164', '2769', '6', '48');
INSERT INTO public.who_global_data_import VALUES (28501, '2020-04-12', 'FI', 'Finland', 'EURO', '136', '2905', '1', '49');
INSERT INTO public.who_global_data_import VALUES (28502, '2020-04-13', 'FI', 'Finland', 'EURO', '69', '2974', '7', '56');
INSERT INTO public.who_global_data_import VALUES (28503, '2020-04-14', 'FI', 'Finland', 'EURO', '90', '3064', '3', '59');
INSERT INTO public.who_global_data_import VALUES (28504, '2020-04-15', 'FI', 'Finland', 'EURO', '97', '3161', '5', '64');
INSERT INTO public.who_global_data_import VALUES (28505, '2020-04-16', 'FI', 'Finland', 'EURO', '76', '3237', '8', '72');
INSERT INTO public.who_global_data_import VALUES (28506, '2020-04-17', 'FI', 'Finland', 'EURO', '132', '3369', '3', '75');
INSERT INTO public.who_global_data_import VALUES (28507, '2020-04-18', 'FI', 'Finland', 'EURO', '120', '3489', '7', '82');
INSERT INTO public.who_global_data_import VALUES (28508, '2020-04-19', 'FI', 'Finland', 'EURO', '192', '3681', '8', '90');
INSERT INTO public.who_global_data_import VALUES (28509, '2020-04-20', 'FI', 'Finland', 'EURO', '102', '3783', '4', '94');
INSERT INTO public.who_global_data_import VALUES (28510, '2020-04-21', 'FI', 'Finland', 'EURO', '85', '3868', '4', '98');
INSERT INTO public.who_global_data_import VALUES (28511, '2020-04-22', 'FI', 'Finland', 'EURO', '146', '4014', '43', '141');
INSERT INTO public.who_global_data_import VALUES (28512, '2020-04-23', 'FI', 'Finland', 'EURO', '115', '4129', '8', '149');
INSERT INTO public.who_global_data_import VALUES (28513, '2020-04-24', 'FI', 'Finland', 'EURO', '155', '4284', '23', '172');
INSERT INTO public.who_global_data_import VALUES (28514, '2020-04-25', 'FI', 'Finland', 'EURO', '111', '4395', '5', '177');
INSERT INTO public.who_global_data_import VALUES (28515, '2020-04-26', 'FI', 'Finland', 'EURO', '80', '4475', '9', '186');
INSERT INTO public.who_global_data_import VALUES (28516, '2020-04-27', 'FI', 'Finland', 'EURO', '101', '4576', '4', '190');
INSERT INTO public.who_global_data_import VALUES (28517, '2020-04-28', 'FI', 'Finland', 'EURO', '119', '4695', '3', '193');
INSERT INTO public.who_global_data_import VALUES (28518, '2020-04-29', 'FI', 'Finland', 'EURO', '45', '4740', '6', '199');
INSERT INTO public.who_global_data_import VALUES (28519, '2020-04-30', 'FI', 'Finland', 'EURO', '166', '4906', '7', '206');
INSERT INTO public.who_global_data_import VALUES (28520, '2020-05-01', 'FI', 'Finland', 'EURO', '89', '4995', '5', '211');
INSERT INTO public.who_global_data_import VALUES (28521, '2020-05-02', 'FI', 'Finland', 'EURO', '56', '5051', '7', '218');
INSERT INTO public.who_global_data_import VALUES (28522, '2020-05-03', 'FI', 'Finland', 'EURO', '128', '5179', '2', '220');
INSERT INTO public.who_global_data_import VALUES (28523, '2020-05-04', 'FI', 'Finland', 'EURO', '75', '5254', '10', '230');
INSERT INTO public.who_global_data_import VALUES (28524, '2020-05-05', 'FI', 'Finland', 'EURO', '73', '5327', '10', '240');
INSERT INTO public.who_global_data_import VALUES (28525, '2020-05-06', 'FI', 'Finland', 'EURO', '85', '5412', '6', '246');
INSERT INTO public.who_global_data_import VALUES (28526, '2020-05-07', 'FI', 'Finland', 'EURO', '161', '5573', '6', '252');
INSERT INTO public.who_global_data_import VALUES (28527, '2020-05-08', 'FI', 'Finland', 'EURO', '100', '5673', '3', '255');
INSERT INTO public.who_global_data_import VALUES (28528, '2020-05-09', 'FI', 'Finland', 'EURO', '65', '5738', '5', '260');
INSERT INTO public.who_global_data_import VALUES (28529, '2020-05-10', 'FI', 'Finland', 'EURO', '142', '5880', '5', '265');
INSERT INTO public.who_global_data_import VALUES (28530, '2020-05-11', 'FI', 'Finland', 'EURO', '82', '5962', '2', '267');
INSERT INTO public.who_global_data_import VALUES (28531, '2020-05-12', 'FI', 'Finland', 'EURO', '22', '5984', '4', '271');
INSERT INTO public.who_global_data_import VALUES (28532, '2020-05-13', 'FI', 'Finland', 'EURO', '19', '6003', '4', '275');
INSERT INTO public.who_global_data_import VALUES (28533, '2020-05-14', 'FI', 'Finland', 'EURO', '51', '6054', '9', '284');
INSERT INTO public.who_global_data_import VALUES (28534, '2020-05-15', 'FI', 'Finland', 'EURO', '91', '6145', '3', '287');
INSERT INTO public.who_global_data_import VALUES (28535, '2020-05-16', 'FI', 'Finland', 'EURO', '83', '6228', '6', '293');
INSERT INTO public.who_global_data_import VALUES (28536, '2020-05-17', 'FI', 'Finland', 'EURO', '58', '6286', '4', '297');
INSERT INTO public.who_global_data_import VALUES (28537, '2020-05-18', 'FI', 'Finland', 'EURO', '61', '6347', '1', '298');
INSERT INTO public.who_global_data_import VALUES (28538, '2020-05-19', 'FI', 'Finland', 'EURO', '33', '6380', '2', '300');
INSERT INTO public.who_global_data_import VALUES (28539, '2020-05-20', 'FI', 'Finland', 'EURO', '19', '6399', '1', '301');
INSERT INTO public.who_global_data_import VALUES (28540, '2020-05-21', 'FI', 'Finland', 'EURO', '44', '6443', '3', '304');
INSERT INTO public.who_global_data_import VALUES (28541, '2020-05-22', 'FI', 'Finland', 'EURO', '50', '6493', '2', '306');
INSERT INTO public.who_global_data_import VALUES (28542, '2020-05-23', 'FI', 'Finland', 'EURO', '44', '6537', '0', '306');
INSERT INTO public.who_global_data_import VALUES (28543, '2020-05-24', 'FI', 'Finland', 'EURO', '31', '6568', '0', '306');
INSERT INTO public.who_global_data_import VALUES (28544, '2020-05-25', 'FI', 'Finland', 'EURO', '11', '6579', '1', '307');
INSERT INTO public.who_global_data_import VALUES (28545, '2020-05-26', 'FI', 'Finland', 'EURO', '20', '6599', '1', '308');
INSERT INTO public.who_global_data_import VALUES (28546, '2020-05-27', 'FI', 'Finland', 'EURO', '29', '6628', '4', '312');
INSERT INTO public.who_global_data_import VALUES (28547, '2020-05-28', 'FI', 'Finland', 'EURO', '64', '6692', '1', '313');
INSERT INTO public.who_global_data_import VALUES (28548, '2020-05-29', 'FI', 'Finland', 'EURO', '51', '6743', '0', '313');
INSERT INTO public.who_global_data_import VALUES (28549, '2020-05-30', 'FI', 'Finland', 'EURO', '33', '6776', '1', '314');
INSERT INTO public.who_global_data_import VALUES (28550, '2020-05-31', 'FI', 'Finland', 'EURO', '50', '6826', '2', '316');
INSERT INTO public.who_global_data_import VALUES (28551, '2020-06-01', 'FI', 'Finland', 'EURO', '33', '6859', '4', '320');
INSERT INTO public.who_global_data_import VALUES (28552, '2020-06-02', 'FI', 'Finland', 'EURO', '26', '6885', '0', '320');
INSERT INTO public.who_global_data_import VALUES (28553, '2020-06-03', 'FI', 'Finland', 'EURO', '2', '6887', '0', '320');
INSERT INTO public.who_global_data_import VALUES (28554, '2020-06-04', 'FI', 'Finland', 'EURO', '24', '6911', '1', '321');
INSERT INTO public.who_global_data_import VALUES (28555, '2020-06-05', 'FI', 'Finland', 'EURO', '0', '6911', '1', '322');
INSERT INTO public.who_global_data_import VALUES (28556, '2020-06-06', 'FI', 'Finland', 'EURO', '30', '6941', '0', '322');
INSERT INTO public.who_global_data_import VALUES (28557, '2020-06-07', 'FI', 'Finland', 'EURO', '23', '6964', '0', '322');
INSERT INTO public.who_global_data_import VALUES (28558, '2020-06-08', 'FI', 'Finland', 'EURO', '17', '6981', '1', '323');
INSERT INTO public.who_global_data_import VALUES (28559, '2020-06-09', 'FI', 'Finland', 'EURO', '20', '7001', '0', '323');
INSERT INTO public.who_global_data_import VALUES (28560, '2020-06-10', 'FI', 'Finland', 'EURO', '24', '7025', '1', '324');
INSERT INTO public.who_global_data_import VALUES (28561, '2020-06-11', 'FI', 'Finland', 'EURO', '15', '7040', '0', '324');
INSERT INTO public.who_global_data_import VALUES (28562, '2020-06-12', 'FI', 'Finland', 'EURO', '24', '7064', '1', '325');
INSERT INTO public.who_global_data_import VALUES (28563, '2020-06-13', 'FI', 'Finland', 'EURO', '9', '7073', '0', '325');
INSERT INTO public.who_global_data_import VALUES (28564, '2020-06-14', 'FI', 'Finland', 'EURO', '14', '7087', '0', '325');
INSERT INTO public.who_global_data_import VALUES (28565, '2020-06-15', 'FI', 'Finland', 'EURO', '17', '7104', '1', '326');
INSERT INTO public.who_global_data_import VALUES (28566, '2020-06-16', 'FI', 'Finland', 'EURO', '4', '7108', '0', '326');
INSERT INTO public.who_global_data_import VALUES (28567, '2020-06-17', 'FI', 'Finland', 'EURO', '4', '7112', '0', '326');
INSERT INTO public.who_global_data_import VALUES (28568, '2020-06-18', 'FI', 'Finland', 'EURO', '5', '7117', '0', '326');
INSERT INTO public.who_global_data_import VALUES (28569, '2020-06-19', 'FI', 'Finland', 'EURO', '0', '7117', '0', '326');
INSERT INTO public.who_global_data_import VALUES (28570, '2020-06-20', 'FI', 'Finland', 'EURO', '16', '7133', '0', '326');
INSERT INTO public.who_global_data_import VALUES (28571, '2020-06-21', 'FI', 'Finland', 'EURO', '9', '7142', '0', '326');
INSERT INTO public.who_global_data_import VALUES (28572, '2020-06-22', 'FI', 'Finland', 'EURO', '1', '7143', '0', '326');
INSERT INTO public.who_global_data_import VALUES (28573, '2020-06-23', 'FI', 'Finland', 'EURO', '1', '7144', '1', '327');
INSERT INTO public.who_global_data_import VALUES (28574, '2020-06-24', 'FI', 'Finland', 'EURO', '11', '7155', '0', '327');
INSERT INTO public.who_global_data_import VALUES (28575, '2020-06-25', 'FI', 'Finland', 'EURO', '12', '7167', '0', '327');
INSERT INTO public.who_global_data_import VALUES (28576, '2020-06-26', 'FI', 'Finland', 'EURO', '5', '7172', '0', '327');
INSERT INTO public.who_global_data_import VALUES (28577, '2020-06-27', 'FI', 'Finland', 'EURO', '19', '7191', '1', '328');
INSERT INTO public.who_global_data_import VALUES (28578, '2020-06-28', 'FI', 'Finland', 'EURO', '0', '7191', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28579, '2020-06-29', 'FI', 'Finland', 'EURO', '0', '7191', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28580, '2020-06-30', 'FI', 'Finland', 'EURO', '18', '7209', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28581, '2020-07-01', 'FI', 'Finland', 'EURO', '5', '7214', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28582, '2020-07-02', 'FI', 'Finland', 'EURO', '22', '7236', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28583, '2020-07-03', 'FI', 'Finland', 'EURO', '5', '7241', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28584, '2020-07-04', 'FI', 'Finland', 'EURO', '28', '7269', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28585, '2020-07-05', 'FI', 'Finland', 'EURO', '1', '7270', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28586, '2020-07-06', 'FI', 'Finland', 'EURO', '2', '7272', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28587, '2020-07-07', 'FI', 'Finland', 'EURO', '3', '7275', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28588, '2020-07-08', 'FI', 'Finland', 'EURO', '1', '7276', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28589, '2020-07-09', 'FI', 'Finland', 'EURO', '7', '7283', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28590, '2020-07-10', 'FI', 'Finland', 'EURO', '4', '7287', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28591, '2020-07-11', 'FI', 'Finland', 'EURO', '3', '7290', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28592, '2020-07-12', 'FI', 'Finland', 'EURO', '0', '7290', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28593, '2020-07-13', 'FI', 'Finland', 'EURO', '2', '7292', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28594, '2020-07-14', 'FI', 'Finland', 'EURO', '1', '7293', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28595, '2020-07-15', 'FI', 'Finland', 'EURO', '0', '7293', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28596, '2020-07-16', 'FI', 'Finland', 'EURO', '0', '7293', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28597, '2020-07-17', 'FI', 'Finland', 'EURO', '0', '7293', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28598, '2020-07-18', 'FI', 'Finland', 'EURO', '8', '7301', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28599, '2020-07-19', 'FI', 'Finland', 'EURO', '17', '7318', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28600, '2020-07-20', 'FI', 'Finland', 'EURO', '20', '7338', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28601, '2020-07-21', 'FI', 'Finland', 'EURO', '2', '7340', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28602, '2020-07-22', 'FI', 'Finland', 'EURO', '11', '7351', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28603, '2020-07-23', 'FI', 'Finland', 'EURO', '11', '7362', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28604, '2020-07-24', 'FI', 'Finland', 'EURO', '10', '7372', '0', '328');
INSERT INTO public.who_global_data_import VALUES (28605, '2020-07-25', 'FI', 'Finland', 'EURO', '8', '7380', '1', '329');
INSERT INTO public.who_global_data_import VALUES (28606, '2020-07-26', 'FI', 'Finland', 'EURO', '8', '7388', '0', '329');
INSERT INTO public.who_global_data_import VALUES (28607, '2020-07-27', 'FI', 'Finland', 'EURO', '5', '7393', '0', '329');
INSERT INTO public.who_global_data_import VALUES (28608, '2020-07-28', 'FI', 'Finland', 'EURO', '5', '7398', '0', '329');
INSERT INTO public.who_global_data_import VALUES (28609, '2020-07-29', 'FI', 'Finland', 'EURO', '6', '7404', '0', '329');
INSERT INTO public.who_global_data_import VALUES (28610, '2020-07-30', 'FI', 'Finland', 'EURO', '10', '7414', '0', '329');
INSERT INTO public.who_global_data_import VALUES (28611, '2020-07-31', 'FI', 'Finland', 'EURO', '9', '7423', '0', '329');
INSERT INTO public.who_global_data_import VALUES (28612, '2020-08-01', 'FI', 'Finland', 'EURO', '9', '7432', '0', '329');
INSERT INTO public.who_global_data_import VALUES (28613, '2020-08-02', 'FI', 'Finland', 'EURO', '11', '7443', '0', '329');
INSERT INTO public.who_global_data_import VALUES (28614, '2020-08-03', 'FI', 'Finland', 'EURO', '10', '7453', '0', '329');
INSERT INTO public.who_global_data_import VALUES (28615, '2020-08-04', 'FI', 'Finland', 'EURO', '13', '7466', '0', '329');
INSERT INTO public.who_global_data_import VALUES (28616, '2020-08-05', 'FI', 'Finland', 'EURO', '17', '7483', '2', '331');
INSERT INTO public.who_global_data_import VALUES (28617, '2020-08-06', 'FI', 'Finland', 'EURO', '29', '7512', '0', '331');
INSERT INTO public.who_global_data_import VALUES (28618, '2020-08-07', 'FI', 'Finland', 'EURO', '20', '7532', '0', '331');
INSERT INTO public.who_global_data_import VALUES (28619, '2020-08-08', 'FI', 'Finland', 'EURO', '22', '7554', '0', '331');
INSERT INTO public.who_global_data_import VALUES (28620, '2020-08-09', 'FI', 'Finland', 'EURO', '14', '7568', '0', '331');
INSERT INTO public.who_global_data_import VALUES (28621, '2020-08-10', 'FI', 'Finland', 'EURO', '16', '7584', '0', '331');
INSERT INTO public.who_global_data_import VALUES (28622, '2020-08-11', 'FI', 'Finland', 'EURO', '17', '7601', '2', '333');
INSERT INTO public.who_global_data_import VALUES (28623, '2020-08-12', 'FI', 'Finland', 'EURO', '22', '7623', '0', '333');
INSERT INTO public.who_global_data_import VALUES (28624, '2020-08-13', 'FI', 'Finland', 'EURO', '19', '7642', '0', '333');
INSERT INTO public.who_global_data_import VALUES (28625, '2020-08-14', 'FI', 'Finland', 'EURO', '41', '7683', '0', '333');
INSERT INTO public.who_global_data_import VALUES (28626, '2020-08-15', 'FI', 'Finland', 'EURO', '17', '7700', '0', '333');
INSERT INTO public.who_global_data_import VALUES (28627, '2020-08-16', 'FI', 'Finland', 'EURO', '20', '7720', '0', '333');
INSERT INTO public.who_global_data_import VALUES (28628, '2020-08-17', 'FI', 'Finland', 'EURO', '11', '7731', '0', '333');
INSERT INTO public.who_global_data_import VALUES (28629, '2020-08-18', 'FI', 'Finland', 'EURO', '21', '7752', '1', '334');
INSERT INTO public.who_global_data_import VALUES (28630, '2020-08-19', 'FI', 'Finland', 'EURO', '24', '7776', '0', '334');
INSERT INTO public.who_global_data_import VALUES (28631, '2020-08-20', 'FI', 'Finland', 'EURO', '29', '7805', '0', '334');
INSERT INTO public.who_global_data_import VALUES (28632, '2020-08-21', 'FI', 'Finland', 'EURO', '37', '7842', '0', '334');
INSERT INTO public.who_global_data_import VALUES (28633, '2020-08-22', 'FI', 'Finland', 'EURO', '29', '7871', '0', '334');
INSERT INTO public.who_global_data_import VALUES (28634, '2020-08-23', 'FI', 'Finland', 'EURO', '35', '7906', '0', '334');
INSERT INTO public.who_global_data_import VALUES (28635, '2020-08-24', 'FI', 'Finland', 'EURO', '14', '7920', '0', '334');
INSERT INTO public.who_global_data_import VALUES (28636, '2020-08-25', 'FI', 'Finland', 'EURO', '18', '7938', '1', '335');
INSERT INTO public.who_global_data_import VALUES (28637, '2020-08-26', 'FI', 'Finland', 'EURO', '43', '7981', '0', '335');
INSERT INTO public.who_global_data_import VALUES (28638, '2020-08-27', 'FI', 'Finland', 'EURO', '21', '8002', '0', '335');
INSERT INTO public.who_global_data_import VALUES (28639, '2020-08-28', 'FI', 'Finland', 'EURO', '17', '8019', '0', '335');
INSERT INTO public.who_global_data_import VALUES (28640, '2020-08-29', 'FI', 'Finland', 'EURO', '23', '8042', '0', '335');
INSERT INTO public.who_global_data_import VALUES (28641, '2020-08-30', 'FI', 'Finland', 'EURO', '7', '8049', '0', '335');
INSERT INTO public.who_global_data_import VALUES (28642, '2020-08-31', 'FI', 'Finland', 'EURO', '28', '8077', '0', '335');
INSERT INTO public.who_global_data_import VALUES (28643, '2020-09-01', 'FI', 'Finland', 'EURO', '9', '8086', '0', '335');
INSERT INTO public.who_global_data_import VALUES (28644, '2020-09-02', 'FI', 'Finland', 'EURO', '56', '8142', '0', '335');
INSERT INTO public.who_global_data_import VALUES (28645, '2020-09-03', 'FI', 'Finland', 'EURO', '19', '8161', '0', '335');
INSERT INTO public.who_global_data_import VALUES (28646, '2020-09-04', 'FI', 'Finland', 'EURO', '39', '8200', '0', '335');
INSERT INTO public.who_global_data_import VALUES (28647, '2020-09-05', 'FI', 'Finland', 'EURO', '25', '8225', '0', '335');
INSERT INTO public.who_global_data_import VALUES (28648, '2020-09-06', 'FI', 'Finland', 'EURO', '36', '8261', '1', '336');
INSERT INTO public.who_global_data_import VALUES (28649, '2020-09-07', 'FI', 'Finland', 'EURO', '30', '8291', '0', '336');
INSERT INTO public.who_global_data_import VALUES (28650, '2020-09-08', 'FI', 'Finland', 'EURO', '36', '8327', '0', '336');
INSERT INTO public.who_global_data_import VALUES (28651, '2020-09-09', 'FI', 'Finland', 'EURO', '10', '8337', '0', '336');
INSERT INTO public.who_global_data_import VALUES (28652, '2020-09-10', 'FI', 'Finland', 'EURO', '93', '8430', '1', '337');
INSERT INTO public.who_global_data_import VALUES (28653, '2020-09-11', 'FI', 'Finland', 'EURO', '39', '8469', '0', '337');
INSERT INTO public.who_global_data_import VALUES (28654, '2020-09-12', 'FI', 'Finland', 'EURO', '43', '8512', '0', '337');
INSERT INTO public.who_global_data_import VALUES (28655, '2020-09-13', 'FI', 'Finland', 'EURO', '45', '8557', '0', '337');
INSERT INTO public.who_global_data_import VALUES (28656, '2020-09-14', 'FI', 'Finland', 'EURO', '23', '8580', '0', '337');
INSERT INTO public.who_global_data_import VALUES (28657, '2020-09-15', 'FI', 'Finland', 'EURO', '47', '8627', '2', '339');
INSERT INTO public.who_global_data_import VALUES (28658, '2020-09-16', 'FI', 'Finland', 'EURO', '98', '8725', '0', '339');
INSERT INTO public.who_global_data_import VALUES (28659, '2020-09-17', 'FI', 'Finland', 'EURO', '25', '8750', '0', '339');
INSERT INTO public.who_global_data_import VALUES (28660, '2020-09-18', 'FI', 'Finland', 'EURO', '49', '8799', '0', '339');
INSERT INTO public.who_global_data_import VALUES (28661, '2020-09-19', 'FI', 'Finland', 'EURO', '59', '8858', '0', '339');
INSERT INTO public.who_global_data_import VALUES (28662, '2020-09-20', 'FI', 'Finland', 'EURO', '64', '8922', '0', '339');
INSERT INTO public.who_global_data_import VALUES (28663, '2020-09-21', 'FI', 'Finland', 'EURO', '58', '8980', '0', '339');
INSERT INTO public.who_global_data_import VALUES (28664, '2020-09-22', 'FI', 'Finland', 'EURO', '66', '9046', '2', '341');
INSERT INTO public.who_global_data_import VALUES (28665, '2020-09-23', 'FI', 'Finland', 'EURO', '149', '9195', '0', '341');
INSERT INTO public.who_global_data_import VALUES (28666, '2020-09-24', 'FI', 'Finland', 'EURO', '93', '9288', '2', '343');
INSERT INTO public.who_global_data_import VALUES (28667, '2020-09-25', 'FI', 'Finland', 'EURO', '91', '9379', '0', '343');
INSERT INTO public.who_global_data_import VALUES (28668, '2020-09-26', 'FI', 'Finland', 'EURO', '105', '9484', '0', '343');
INSERT INTO public.who_global_data_import VALUES (28669, '2020-09-27', 'FI', 'Finland', 'EURO', '93', '9577', '0', '343');
INSERT INTO public.who_global_data_import VALUES (28670, '2020-09-28', 'FI', 'Finland', 'EURO', '105', '9682', '0', '343');
INSERT INTO public.who_global_data_import VALUES (28671, '2020-09-29', 'FI', 'Finland', 'EURO', '52', '9734', '0', '343');
INSERT INTO public.who_global_data_import VALUES (28672, '2020-09-30', 'FI', 'Finland', 'EURO', '158', '9892', '0', '343');
INSERT INTO public.who_global_data_import VALUES (28673, '2020-10-01', 'FI', 'Finland', 'EURO', '100', '9992', '1', '344');
INSERT INTO public.who_global_data_import VALUES (28674, '2020-10-02', 'FI', 'Finland', 'EURO', '111', '10103', '0', '344');
INSERT INTO public.who_global_data_import VALUES (28675, '2020-10-03', 'FI', 'Finland', 'EURO', '101', '10204', '1', '345');
INSERT INTO public.who_global_data_import VALUES (28676, '2020-10-04', 'FI', 'Finland', 'EURO', '40', '10244', '0', '345');
INSERT INTO public.who_global_data_import VALUES (28677, '2020-10-05', 'FI', 'Finland', 'EURO', '294', '10538', '0', '345');
INSERT INTO public.who_global_data_import VALUES (28678, '2020-10-06', 'FI', 'Finland', 'EURO', '164', '10702', '1', '346');
INSERT INTO public.who_global_data_import VALUES (28679, '2020-10-07', 'FI', 'Finland', 'EURO', '227', '10929', '0', '346');
INSERT INTO public.who_global_data_import VALUES (28680, '2020-10-08', 'FI', 'Finland', 'EURO', '120', '11049', '0', '346');
INSERT INTO public.who_global_data_import VALUES (28681, '2020-10-09', 'FI', 'Finland', 'EURO', '296', '11345', '0', '346');
INSERT INTO public.who_global_data_import VALUES (28682, '2020-10-10', 'FI', 'Finland', 'EURO', '235', '11580', '0', '346');
INSERT INTO public.who_global_data_import VALUES (28683, '2020-10-11', 'FI', 'Finland', 'EURO', '269', '11849', '0', '346');
INSERT INTO public.who_global_data_import VALUES (28684, '2020-10-12', 'FI', 'Finland', 'EURO', '149', '11998', '0', '346');
INSERT INTO public.who_global_data_import VALUES (28685, '2020-10-13', 'FI', 'Finland', 'EURO', '214', '12212', '0', '346');
INSERT INTO public.who_global_data_import VALUES (28686, '2020-10-14', 'FI', 'Finland', 'EURO', '287', '12499', '0', '346');
INSERT INTO public.who_global_data_import VALUES (28687, '2020-10-15', 'FI', 'Finland', 'EURO', '204', '12703', '4', '350');
INSERT INTO public.who_global_data_import VALUES (28688, '2020-10-16', 'FI', 'Finland', 'EURO', '291', '12994', '0', '350');
INSERT INTO public.who_global_data_import VALUES (28689, '2020-10-17', 'FI', 'Finland', 'EURO', '139', '13133', '1', '351');
INSERT INTO public.who_global_data_import VALUES (28690, '2020-10-18', 'FI', 'Finland', 'EURO', '160', '13293', '0', '351');
INSERT INTO public.who_global_data_import VALUES (28691, '2020-10-19', 'FI', 'Finland', 'EURO', '131', '13424', '0', '351');
INSERT INTO public.who_global_data_import VALUES (28692, '2020-10-20', 'FI', 'Finland', 'EURO', '131', '13555', '0', '351');
INSERT INTO public.who_global_data_import VALUES (28693, '2020-10-21', 'FI', 'Finland', 'EURO', '294', '13849', '0', '351');
INSERT INTO public.who_global_data_import VALUES (28694, '2020-10-22', 'FI', 'Finland', 'EURO', '222', '14071', '2', '353');
INSERT INTO public.who_global_data_import VALUES (28695, '2020-10-23', 'FI', 'Finland', 'EURO', '184', '14255', '0', '353');
INSERT INTO public.who_global_data_import VALUES (28696, '2020-10-24', 'FI', 'Finland', 'EURO', '219', '14474', '0', '353');
INSERT INTO public.who_global_data_import VALUES (28697, '2020-10-25', 'FI', 'Finland', 'EURO', '178', '14652', '0', '353');
INSERT INTO public.who_global_data_import VALUES (28698, '2020-10-26', 'FI', 'Finland', 'EURO', '196', '14848', '0', '353');
INSERT INTO public.who_global_data_import VALUES (28699, '2020-10-27', 'FI', 'Finland', 'EURO', '122', '14970', '1', '354');
INSERT INTO public.who_global_data_import VALUES (28700, '2020-10-28', 'FI', 'Finland', 'EURO', '193', '15163', '0', '354');
INSERT INTO public.who_global_data_import VALUES (28701, '2020-10-29', 'FI', 'Finland', 'EURO', '215', '15378', '0', '354');
INSERT INTO public.who_global_data_import VALUES (28702, '2020-10-30', 'FI', 'Finland', 'EURO', '188', '15566', '0', '354');
INSERT INTO public.who_global_data_import VALUES (28703, '2020-10-31', 'FI', 'Finland', 'EURO', '344', '15910', '4', '358');
INSERT INTO public.who_global_data_import VALUES (28704, '2020-11-01', 'FI', 'Finland', 'EURO', '203', '16113', '0', '358');
INSERT INTO public.who_global_data_import VALUES (28705, '2020-11-02', 'FI', 'Finland', 'EURO', '178', '16291', '0', '358');
INSERT INTO public.who_global_data_import VALUES (28706, '2020-11-03', 'FI', 'Finland', 'EURO', '109', '16400', '1', '359');
INSERT INTO public.who_global_data_import VALUES (28707, '2020-11-04', 'FI', 'Finland', 'EURO', '237', '16637', '0', '359');
INSERT INTO public.who_global_data_import VALUES (28708, '2020-11-05', 'FI', 'Finland', 'EURO', '293', '16930', '2', '361');
INSERT INTO public.who_global_data_import VALUES (28709, '2020-11-06', 'FI', 'Finland', 'EURO', '189', '17119', '0', '361');
INSERT INTO public.who_global_data_import VALUES (28710, '2020-11-07', 'FI', 'Finland', 'EURO', '266', '17385', '1', '362');
INSERT INTO public.who_global_data_import VALUES (28711, '2020-11-08', 'FI', 'Finland', 'EURO', '0', '17385', '0', '362');
INSERT INTO public.who_global_data_import VALUES (28712, '2020-11-09', 'FI', 'Finland', 'EURO', '412', '17797', '0', '362');
INSERT INTO public.who_global_data_import VALUES (28713, '2020-11-10', 'FI', 'Finland', 'EURO', '90', '17887', '1', '363');
INSERT INTO public.who_global_data_import VALUES (28714, '2020-11-11', 'FI', 'Finland', 'EURO', '220', '18107', '0', '363');
INSERT INTO public.who_global_data_import VALUES (28715, '2020-11-12', 'FI', 'Finland', 'EURO', '238', '18345', '2', '365');
INSERT INTO public.who_global_data_import VALUES (28716, '2020-11-13', 'FI', 'Finland', 'EURO', '197', '18542', '0', '365');
INSERT INTO public.who_global_data_import VALUES (28717, '2020-11-14', 'FI', 'Finland', 'EURO', '316', '18858', '4', '369');
INSERT INTO public.who_global_data_import VALUES (28718, '2020-11-15', 'FI', 'Finland', 'EURO', '244', '19102', '0', '369');
INSERT INTO public.who_global_data_import VALUES (28719, '2020-11-16', 'FI', 'Finland', 'EURO', '213', '19315', '0', '369');
INSERT INTO public.who_global_data_import VALUES (28720, '2020-11-17', 'FI', 'Finland', 'EURO', '104', '19419', '2', '371');
INSERT INTO public.who_global_data_import VALUES (28721, '2020-11-18', 'FI', 'Finland', 'EURO', '228', '19647', '0', '371');
INSERT INTO public.who_global_data_import VALUES (28722, '2020-11-19', 'FI', 'Finland', 'EURO', '288', '19935', '3', '374');
INSERT INTO public.who_global_data_import VALUES (28723, '2020-11-20', 'FI', 'Finland', 'EURO', '351', '20286', '0', '374');
INSERT INTO public.who_global_data_import VALUES (28724, '2020-11-21', 'FI', 'Finland', 'EURO', '461', '20747', '1', '375');
INSERT INTO public.who_global_data_import VALUES (28725, '2020-11-22', 'FI', 'Finland', 'EURO', '469', '21216', '0', '375');
INSERT INTO public.who_global_data_import VALUES (28726, '2020-11-23', 'FI', 'Finland', 'EURO', '423', '21639', '0', '375');
INSERT INTO public.who_global_data_import VALUES (28727, '2020-11-24', 'FI', 'Finland', 'EURO', '297', '21936', '9', '384');
INSERT INTO public.who_global_data_import VALUES (28728, '2020-11-25', 'FI', 'Finland', 'EURO', '353', '22289', '0', '384');
INSERT INTO public.who_global_data_import VALUES (28729, '2020-11-26', 'FI', 'Finland', 'EURO', '363', '22652', '4', '388');
INSERT INTO public.who_global_data_import VALUES (28730, '2020-11-27', 'FI', 'Finland', 'EURO', '496', '23148', '0', '388');
INSERT INTO public.who_global_data_import VALUES (28731, '2020-11-28', 'FI', 'Finland', 'EURO', '618', '23766', '5', '393');
INSERT INTO public.who_global_data_import VALUES (28732, '2020-11-29', 'FI', 'Finland', 'EURO', '541', '24307', '0', '393');
INSERT INTO public.who_global_data_import VALUES (28733, '2020-11-30', 'FI', 'Finland', 'EURO', '322', '24629', '0', '393');
INSERT INTO public.who_global_data_import VALUES (28734, '2020-12-01', 'FI', 'Finland', 'EURO', '283', '24912', '6', '399');
INSERT INTO public.who_global_data_import VALUES (28735, '2020-12-02', 'FI', 'Finland', 'EURO', '550', '25462', '0', '399');
INSERT INTO public.who_global_data_import VALUES (28736, '2020-12-03', 'FI', 'Finland', 'EURO', '420', '25882', '9', '408');
INSERT INTO public.who_global_data_import VALUES (28737, '2020-12-04', 'FI', 'Finland', 'EURO', '560', '26442', '0', '408');
INSERT INTO public.who_global_data_import VALUES (28738, '2020-12-05', 'FI', 'Finland', 'EURO', '316', '26758', '7', '415');
INSERT INTO public.who_global_data_import VALUES (28739, '2020-12-06', 'FI', 'Finland', 'EURO', '460', '27218', '0', '415');
INSERT INTO public.who_global_data_import VALUES (28740, '2020-12-07', 'FI', 'Finland', 'EURO', '413', '27631', '0', '415');
INSERT INTO public.who_global_data_import VALUES (28741, '2020-12-08', 'FI', 'Finland', 'EURO', '250', '27881', '9', '424');
INSERT INTO public.who_global_data_import VALUES (28742, '2020-12-09', 'FI', 'Finland', 'EURO', '361', '28242', '1', '425');
INSERT INTO public.who_global_data_import VALUES (28743, '2020-12-10', 'FI', 'Finland', 'EURO', '490', '28732', '8', '433');
INSERT INTO public.who_global_data_import VALUES (28744, '2020-12-11', 'FI', 'Finland', 'EURO', '840', '29572', '9', '442');
INSERT INTO public.who_global_data_import VALUES (28745, '2020-12-12', 'FI', 'Finland', 'EURO', '501', '30073', '11', '453');
INSERT INTO public.who_global_data_import VALUES (28746, '2020-12-13', 'FI', 'Finland', 'EURO', '377', '30450', '0', '453');
INSERT INTO public.who_global_data_import VALUES (28747, '2020-12-14', 'FI', 'Finland', 'EURO', '360', '30810', '0', '453');
INSERT INTO public.who_global_data_import VALUES (28748, '2020-12-15', 'FI', 'Finland', 'EURO', '300', '31110', '8', '461');
INSERT INTO public.who_global_data_import VALUES (28749, '2020-12-16', 'FI', 'Finland', 'EURO', '349', '31459', '5', '466');
INSERT INTO public.who_global_data_import VALUES (28750, '2020-12-17', 'FI', 'Finland', 'EURO', '411', '31870', '6', '472');
INSERT INTO public.who_global_data_import VALUES (28751, '2020-12-18', 'FI', 'Finland', 'EURO', '358', '32228', '12', '484');
INSERT INTO public.who_global_data_import VALUES (28752, '2020-12-19', 'FI', 'Finland', 'EURO', '354', '32582', '5', '489');
INSERT INTO public.who_global_data_import VALUES (28753, '2020-12-20', 'FI', 'Finland', 'EURO', '0', '32582', '0', '489');
INSERT INTO public.who_global_data_import VALUES (28754, '2020-12-21', 'FI', 'Finland', 'EURO', '0', '32582', '0', '489');
INSERT INTO public.who_global_data_import VALUES (28755, '2020-12-22', 'FI', 'Finland', 'EURO', '832', '33414', '17', '506');
INSERT INTO public.who_global_data_import VALUES (28756, '2020-12-23', 'FI', 'Finland', 'EURO', '303', '33717', '5', '511');
INSERT INTO public.who_global_data_import VALUES (28757, '2020-12-24', 'FI', 'Finland', 'EURO', '367', '34084', '13', '524');
INSERT INTO public.who_global_data_import VALUES (28758, '2020-12-25', 'FI', 'Finland', 'EURO', '0', '34084', '0', '524');
INSERT INTO public.who_global_data_import VALUES (28759, '2020-12-26', 'FI', 'Finland', 'EURO', '0', '34084', '0', '524');
INSERT INTO public.who_global_data_import VALUES (28760, '2020-12-27', 'FI', 'Finland', 'EURO', '0', '34084', '0', '524');
INSERT INTO public.who_global_data_import VALUES (28761, '2020-12-28', 'FI', 'Finland', 'EURO', '1053', '35137', '22', '546');
INSERT INTO public.who_global_data_import VALUES (28762, '2020-12-29', 'FI', 'Finland', 'EURO', '283', '35420', '4', '550');
INSERT INTO public.who_global_data_import VALUES (28763, '2020-12-30', 'FI', 'Finland', 'EURO', '438', '35858', '6', '556');
INSERT INTO public.who_global_data_import VALUES (28764, '2020-12-31', 'FI', 'Finland', 'EURO', '0', '35858', '0', '556');
INSERT INTO public.who_global_data_import VALUES (28765, '2021-01-01', 'FI', 'Finland', 'EURO', '249', '36107', '5', '561');
INSERT INTO public.who_global_data_import VALUES (28766, '2021-01-02', 'FI', 'Finland', 'EURO', '296', '36403', '0', '561');
INSERT INTO public.who_global_data_import VALUES (28767, '2021-01-03', 'FI', 'Finland', 'EURO', '201', '36604', '0', '561');
INSERT INTO public.who_global_data_import VALUES (28768, '2021-01-04', 'FI', 'Finland', 'EURO', '168', '36772', '0', '561');
INSERT INTO public.who_global_data_import VALUES (28769, '2021-01-05', 'FI', 'Finland', 'EURO', '147', '36919', '4', '565');
INSERT INTO public.who_global_data_import VALUES (28770, '2021-01-06', 'FI', 'Finland', 'EURO', '299', '37218', '11', '576');
INSERT INTO public.who_global_data_import VALUES (28771, '2021-01-07', 'FI', 'Finland', 'EURO', '331', '37549', '0', '576');
INSERT INTO public.who_global_data_import VALUES (28772, '2021-01-08', 'FI', 'Finland', 'EURO', '223', '37772', '8', '584');
INSERT INTO public.who_global_data_import VALUES (28773, '2021-01-09', 'FI', 'Finland', 'EURO', '296', '38068', '2', '586');
INSERT INTO public.who_global_data_import VALUES (28774, '2021-01-10', 'FI', 'Finland', 'EURO', '324', '38392', '0', '586');
INSERT INTO public.who_global_data_import VALUES (28775, '2021-01-11', 'FI', 'Finland', 'EURO', '198', '38590', '0', '586');
INSERT INTO public.who_global_data_import VALUES (28776, '2021-01-12', 'FI', 'Finland', 'EURO', '200', '38790', '11', '597');
INSERT INTO public.who_global_data_import VALUES (28777, '2021-01-13', 'FI', 'Finland', 'EURO', '221', '39011', '5', '602');
INSERT INTO public.who_global_data_import VALUES (28778, '2021-01-14', 'FI', 'Finland', 'EURO', '324', '39335', '8', '610');
INSERT INTO public.who_global_data_import VALUES (28779, '2021-01-15', 'FI', 'Finland', 'EURO', '258', '39593', '6', '616');
INSERT INTO public.who_global_data_import VALUES (28780, '2021-01-16', 'FI', 'Finland', 'EURO', '318', '39911', '2', '618');
INSERT INTO public.who_global_data_import VALUES (28781, '2021-01-17', 'FI', 'Finland', 'EURO', '190', '40101', '0', '618');
INSERT INTO public.who_global_data_import VALUES (28782, '2021-01-18', 'FI', 'Finland', 'EURO', '236', '40337', '0', '618');
INSERT INTO public.who_global_data_import VALUES (28783, '2021-01-19', 'FI', 'Finland', 'EURO', '168', '40505', '3', '621');
INSERT INTO public.who_global_data_import VALUES (28784, '2021-01-20', 'FI', 'Finland', 'EURO', '217', '40722', '12', '633');
INSERT INTO public.who_global_data_import VALUES (28785, '2021-01-21', 'FI', 'Finland', 'EURO', '444', '41166', '0', '633');
INSERT INTO public.who_global_data_import VALUES (28786, '2021-01-22', 'FI', 'Finland', 'EURO', '399', '41565', '5', '638');
INSERT INTO public.who_global_data_import VALUES (28787, '2021-01-23', 'FI', 'Finland', 'EURO', '350', '41915', '6', '644');
INSERT INTO public.who_global_data_import VALUES (28788, '2021-01-24', 'FI', 'Finland', 'EURO', '419', '42334', '4', '648');
INSERT INTO public.who_global_data_import VALUES (28789, '2021-01-25', 'FI', 'Finland', 'EURO', '246', '42580', '4', '652');
INSERT INTO public.who_global_data_import VALUES (28790, '2021-01-26', 'FI', 'Finland', 'EURO', '192', '42772', '3', '655');
INSERT INTO public.who_global_data_import VALUES (28791, '2021-01-27', 'FI', 'Finland', 'EURO', '348', '43120', '0', '655');
INSERT INTO public.who_global_data_import VALUES (28792, '2021-01-28', 'FI', 'Finland', 'EURO', '496', '43616', '5', '660');
INSERT INTO public.who_global_data_import VALUES (28793, '2021-01-29', 'FI', 'Finland', 'EURO', '423', '44039', '4', '664');
INSERT INTO public.who_global_data_import VALUES (28794, '2021-01-30', 'FI', 'Finland', 'EURO', '363', '44402', '7', '671');
INSERT INTO public.who_global_data_import VALUES (28795, '2021-01-31', 'FI', 'Finland', 'EURO', '469', '44871', '0', '671');
INSERT INTO public.who_global_data_import VALUES (28796, '2021-02-01', 'FI', 'Finland', 'EURO', '367', '45238', '0', '671');
INSERT INTO public.who_global_data_import VALUES (28797, '2021-02-02', 'FI', 'Finland', 'EURO', '244', '45482', '6', '677');
INSERT INTO public.who_global_data_import VALUES (28798, '2021-02-03', 'FI', 'Finland', 'EURO', '302', '45784', '7', '684');
INSERT INTO public.who_global_data_import VALUES (28799, '2021-02-04', 'FI', 'Finland', 'EURO', '265', '46049', '1', '685');
INSERT INTO public.who_global_data_import VALUES (28800, '2021-02-05', 'FI', 'Finland', 'EURO', '444', '46493', '3', '688');
INSERT INTO public.who_global_data_import VALUES (28801, '2020-01-03', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28802, '2020-01-04', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28803, '2020-01-05', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28804, '2020-01-06', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28805, '2020-01-07', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28806, '2020-01-08', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28807, '2020-01-09', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28808, '2020-01-10', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28809, '2020-01-11', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28810, '2020-01-12', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28811, '2020-01-13', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28812, '2020-01-14', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28813, '2020-01-15', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28814, '2020-01-16', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28815, '2020-01-17', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28816, '2020-01-18', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28817, '2020-01-19', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28818, '2020-01-20', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28819, '2020-01-21', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28820, '2020-01-22', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28821, '2020-01-23', 'FR', 'France', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28822, '2020-01-24', 'FR', 'France', 'EURO', '3', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28823, '2020-01-25', 'FR', 'France', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28824, '2020-01-26', 'FR', 'France', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28825, '2020-01-27', 'FR', 'France', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28826, '2020-01-28', 'FR', 'France', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28827, '2020-01-29', 'FR', 'France', 'EURO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28828, '2020-01-30', 'FR', 'France', 'EURO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28829, '2020-01-31', 'FR', 'France', 'EURO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28830, '2020-02-01', 'FR', 'France', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28831, '2020-02-02', 'FR', 'France', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28832, '2020-02-03', 'FR', 'France', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28833, '2020-02-04', 'FR', 'France', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28834, '2020-02-05', 'FR', 'France', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28835, '2020-02-06', 'FR', 'France', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28836, '2020-02-07', 'FR', 'France', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28837, '2020-02-08', 'FR', 'France', 'EURO', '5', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28838, '2020-02-09', 'FR', 'France', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28839, '2020-02-10', 'FR', 'France', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28840, '2020-02-11', 'FR', 'France', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28841, '2020-02-12', 'FR', 'France', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28842, '2020-02-13', 'FR', 'France', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28843, '2020-02-14', 'FR', 'France', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (28844, '2020-02-15', 'FR', 'France', 'EURO', '0', '11', '1', '1');
INSERT INTO public.who_global_data_import VALUES (28845, '2020-02-16', 'FR', 'France', 'EURO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28846, '2020-02-17', 'FR', 'France', 'EURO', '1', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28847, '2020-02-18', 'FR', 'France', 'EURO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28848, '2020-02-19', 'FR', 'France', 'EURO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28849, '2020-02-20', 'FR', 'France', 'EURO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28850, '2020-02-21', 'FR', 'France', 'EURO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28851, '2020-02-22', 'FR', 'France', 'EURO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28852, '2020-02-23', 'FR', 'France', 'EURO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28853, '2020-02-24', 'FR', 'France', 'EURO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28854, '2020-02-25', 'FR', 'France', 'EURO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28855, '2020-02-26', 'FR', 'France', 'EURO', '2', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (28856, '2020-02-27', 'FR', 'France', 'EURO', '3', '17', '1', '2');
INSERT INTO public.who_global_data_import VALUES (28857, '2020-02-28', 'FR', 'France', 'EURO', '21', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28858, '2020-02-29', 'FR', 'France', 'EURO', '19', '57', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28859, '2020-03-01', 'FR', 'France', 'EURO', '43', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28860, '2020-03-02', 'FR', 'France', 'EURO', '23', '123', '0', '2');
INSERT INTO public.who_global_data_import VALUES (28861, '2020-03-03', 'FR', 'France', 'EURO', '48', '171', '1', '3');
INSERT INTO public.who_global_data_import VALUES (28862, '2020-03-04', 'FR', 'France', 'EURO', '34', '205', '1', '4');
INSERT INTO public.who_global_data_import VALUES (28863, '2020-03-05', 'FR', 'France', 'EURO', '73', '278', '0', '4');
INSERT INTO public.who_global_data_import VALUES (28864, '2020-03-06', 'FR', 'France', 'EURO', '138', '416', '3', '7');
INSERT INTO public.who_global_data_import VALUES (28865, '2020-03-07', 'FR', 'France', 'EURO', '179', '595', '2', '9');
INSERT INTO public.who_global_data_import VALUES (28866, '2020-03-08', 'FR', 'France', 'EURO', '103', '698', '1', '10');
INSERT INTO public.who_global_data_import VALUES (28867, '2020-03-09', 'FR', 'France', 'EURO', '410', '1108', '9', '19');
INSERT INTO public.who_global_data_import VALUES (28868, '2020-03-10', 'FR', 'France', 'EURO', '286', '1394', '11', '30');
INSERT INTO public.who_global_data_import VALUES (28869, '2020-03-11', 'FR', 'France', 'EURO', '371', '1765', '3', '33');
INSERT INTO public.who_global_data_import VALUES (28870, '2020-03-12', 'FR', 'France', 'EURO', '497', '2262', '15', '48');
INSERT INTO public.who_global_data_import VALUES (28871, '2020-03-13', 'FR', 'France', 'EURO', '586', '2848', '13', '61');
INSERT INTO public.who_global_data_import VALUES (28872, '2020-03-14', 'FR', 'France', 'EURO', '763', '3611', '18', '79');
INSERT INTO public.who_global_data_import VALUES (28873, '2020-03-15', 'FR', 'France', 'EURO', '825', '4436', '12', '91');
INSERT INTO public.who_global_data_import VALUES (28874, '2020-03-16', 'FR', 'France', 'EURO', '923', '5359', '36', '127');
INSERT INTO public.who_global_data_import VALUES (28875, '2020-03-17', 'FR', 'France', 'EURO', '1198', '6557', '21', '148');
INSERT INTO public.who_global_data_import VALUES (28876, '2020-03-18', 'FR', 'France', 'EURO', '1060', '7617', '27', '175');
INSERT INTO public.who_global_data_import VALUES (28877, '2020-03-19', 'FR', 'France', 'EURO', '1387', '9004', '69', '244');
INSERT INTO public.who_global_data_import VALUES (28878, '2020-03-20', 'FR', 'France', 'EURO', '1846', '10850', '128', '372');
INSERT INTO public.who_global_data_import VALUES (28879, '2020-03-21', 'FR', 'France', 'EURO', '1595', '12445', '78', '450');
INSERT INTO public.who_global_data_import VALUES (28880, '2020-03-22', 'FR', 'France', 'EURO', '1847', '14292', '112', '562');
INSERT INTO public.who_global_data_import VALUES (28881, '2020-03-23', 'FR', 'France', 'EURO', '1529', '15821', '112', '674');
INSERT INTO public.who_global_data_import VALUES (28882, '2020-03-24', 'FR', 'France', 'EURO', '3776', '19597', '186', '860');
INSERT INTO public.who_global_data_import VALUES (28883, '2020-03-25', 'FR', 'France', 'EURO', '2428', '22025', '240', '1100');
INSERT INTO public.who_global_data_import VALUES (28884, '2020-03-26', 'FR', 'France', 'EURO', '2895', '24920', '230', '1330');
INSERT INTO public.who_global_data_import VALUES (28885, '2020-03-27', 'FR', 'France', 'EURO', '3866', '28786', '365', '1695');
INSERT INTO public.who_global_data_import VALUES (28886, '2020-03-28', 'FR', 'France', 'EURO', '3748', '32534', '297', '1992');
INSERT INTO public.who_global_data_import VALUES (28887, '2020-03-29', 'FR', 'France', 'EURO', '4611', '37145', '319', '2311');
INSERT INTO public.who_global_data_import VALUES (28888, '2020-03-30', 'FR', 'France', 'EURO', '2491', '39636', '291', '2602');
INSERT INTO public.who_global_data_import VALUES (28889, '2020-03-31', 'FR', 'France', 'EURO', '4341', '43977', '415', '3017');
INSERT INTO public.who_global_data_import VALUES (28890, '2020-04-01', 'FR', 'France', 'EURO', '7500', '51477', '497', '3514');
INSERT INTO public.who_global_data_import VALUES (28891, '2020-04-02', 'FR', 'France', 'EURO', '4784', '56261', '505', '4019');
INSERT INTO public.who_global_data_import VALUES (28892, '2020-04-03', 'FR', 'France', 'EURO', '2066', '58327', '471', '4490');
INSERT INTO public.who_global_data_import VALUES (28893, '2020-04-04', 'FR', 'France', 'EURO', '5209', '63536', '2003', '6493');
INSERT INTO public.who_global_data_import VALUES (28894, '2020-04-05', 'FR', 'France', 'EURO', '4221', '67757', '1053', '7546');
INSERT INTO public.who_global_data_import VALUES (28895, '2020-04-06', 'FR', 'France', 'EURO', '1850', '69607', '518', '8064');
INSERT INTO public.who_global_data_import VALUES (28896, '2020-04-07', 'FR', 'France', 'EURO', '3881', '73488', '832', '8896');
INSERT INTO public.who_global_data_import VALUES (28897, '2020-04-08', 'FR', 'France', 'EURO', '3737', '77225', '1417', '10313');
INSERT INTO public.who_global_data_import VALUES (28898, '2020-04-09', 'FR', 'France', 'EURO', '3869', '81094', '540', '10853');
INSERT INTO public.who_global_data_import VALUES (28899, '2020-04-10', 'FR', 'France', 'EURO', '4256', '85350', '1339', '12192');
INSERT INTO public.who_global_data_import VALUES (28900, '2020-04-11', 'FR', 'France', 'EURO', '4333', '89683', '987', '13179');
INSERT INTO public.who_global_data_import VALUES (28901, '2020-04-12', 'FR', 'France', 'EURO', '3104', '92787', '635', '13814');
INSERT INTO public.who_global_data_import VALUES (28902, '2020-04-13', 'FR', 'France', 'EURO', '1595', '94382', '560', '14374');
INSERT INTO public.who_global_data_import VALUES (28903, '2020-04-14', 'FR', 'France', 'EURO', '2669', '97051', '572', '14946');
INSERT INTO public.who_global_data_import VALUES (28904, '2020-04-15', 'FR', 'France', 'EURO', '5483', '102534', '762', '15708');
INSERT INTO public.who_global_data_import VALUES (28905, '2020-04-16', 'FR', 'France', 'EURO', '2621', '105155', '1438', '17146');
INSERT INTO public.who_global_data_import VALUES (28906, '2020-04-17', 'FR', 'France', 'EURO', '2623', '107778', '753', '17899');
INSERT INTO public.who_global_data_import VALUES (28907, '2020-04-18', 'FR', 'France', 'EURO', '385', '108163', '760', '18659');
INSERT INTO public.who_global_data_import VALUES (28908, '2020-04-19', 'FR', 'France', 'EURO', '2558', '110721', '636', '19295');
INSERT INTO public.who_global_data_import VALUES (28909, '2020-04-20', 'FR', 'France', 'EURO', '742', '111463', '395', '19690');
INSERT INTO public.who_global_data_import VALUES (28910, '2020-04-21', 'FR', 'France', 'EURO', '2050', '113513', '544', '20234');
INSERT INTO public.who_global_data_import VALUES (28911, '2020-04-22', 'FR', 'France', 'EURO', '2638', '116151', '531', '20765');
INSERT INTO public.who_global_data_import VALUES (28912, '2020-04-23', 'FR', 'France', 'EURO', '1810', '117961', '544', '21309');
INSERT INTO public.who_global_data_import VALUES (28913, '2020-04-24', 'FR', 'France', 'EURO', '1623', '119584', '516', '21825');
INSERT INTO public.who_global_data_import VALUES (28914, '2020-04-25', 'FR', 'France', 'EURO', '1755', '121339', '389', '22214');
INSERT INTO public.who_global_data_import VALUES (28915, '2020-04-26', 'FR', 'France', 'EURO', '1537', '122876', '368', '22582');
INSERT INTO public.who_global_data_import VALUES (28916, '2020-04-27', 'FR', 'France', 'EURO', '404', '123280', '242', '22824');
INSERT INTO public.who_global_data_import VALUES (28917, '2020-04-28', 'FR', 'France', 'EURO', '1160', '124440', '437', '23261');
INSERT INTO public.who_global_data_import VALUES (28918, '2020-04-29', 'FR', 'France', 'EURO', '1025', '125465', '366', '23627');
INSERT INTO public.who_global_data_import VALUES (28919, '2020-04-30', 'FR', 'France', 'EURO', '1601', '127066', '427', '24054');
INSERT INTO public.who_global_data_import VALUES (28920, '2020-05-01', 'FR', 'France', 'EURO', '1055', '128121', '288', '24342');
INSERT INTO public.who_global_data_import VALUES (28921, '2020-05-02', 'FR', 'France', 'EURO', '601', '128722', '218', '24560');
INSERT INTO public.who_global_data_import VALUES (28922, '2020-05-03', 'FR', 'France', 'EURO', '736', '129458', '164', '24724');
INSERT INTO public.who_global_data_import VALUES (28923, '2020-05-04', 'FR', 'France', 'EURO', '250', '129708', '135', '24859');
INSERT INTO public.who_global_data_import VALUES (28924, '2020-05-05', 'FR', 'France', 'EURO', '534', '130242', '306', '25165');
INSERT INTO public.who_global_data_import VALUES (28925, '2020-05-06', 'FR', 'France', 'EURO', '1050', '131292', '326', '25491');
INSERT INTO public.who_global_data_import VALUES (28926, '2020-05-07', 'FR', 'France', 'EURO', '4176', '135468', '278', '25769');
INSERT INTO public.who_global_data_import VALUES (28927, '2020-05-08', 'FR', 'France', 'EURO', '512', '135980', '177', '25946');
INSERT INTO public.who_global_data_import VALUES (28928, '2020-05-09', 'FR', 'France', 'EURO', '598', '136578', '242', '26188');
INSERT INTO public.who_global_data_import VALUES (28929, '2020-05-10', 'FR', 'France', 'EURO', '430', '137008', '80', '26268');
INSERT INTO public.who_global_data_import VALUES (28930, '2020-05-11', 'FR', 'France', 'EURO', '65', '137073', '70', '26338');
INSERT INTO public.who_global_data_import VALUES (28931, '2020-05-12', 'FR', 'France', 'EURO', '418', '137491', '262', '26600');
INSERT INTO public.who_global_data_import VALUES (28932, '2020-05-13', 'FR', 'France', 'EURO', '670', '138161', '348', '26948');
INSERT INTO public.who_global_data_import VALUES (28933, '2020-05-14', 'FR', 'France', 'EURO', '448', '138609', '81', '27029');
INSERT INTO public.who_global_data_import VALUES (28934, '2020-05-15', 'FR', 'France', 'EURO', '543', '139152', '349', '27378');
INSERT INTO public.who_global_data_import VALUES (28935, '2020-05-16', 'FR', 'France', 'EURO', '494', '139646', '130', '27508');
INSERT INTO public.who_global_data_import VALUES (28936, '2020-05-17', 'FR', 'France', 'EURO', '362', '140008', '88', '27596');
INSERT INTO public.who_global_data_import VALUES (28937, '2020-05-18', 'FR', 'France', 'EURO', '28', '140036', '66', '27662');
INSERT INTO public.who_global_data_import VALUES (28938, '2020-05-19', 'FR', 'France', 'EURO', '461', '140497', '186', '27848');
INSERT INTO public.who_global_data_import VALUES (28939, '2020-05-20', 'FR', 'France', 'EURO', '462', '140959', '124', '27972');
INSERT INTO public.who_global_data_import VALUES (28940, '2020-05-21', 'FR', 'France', 'EURO', '353', '141312', '109', '28081');
INSERT INTO public.who_global_data_import VALUES (28941, '2020-05-22', 'FR', 'France', 'EURO', '278', '141590', '83', '28164');
INSERT INTO public.who_global_data_import VALUES (28942, '2020-05-23', 'FR', 'France', 'EURO', '359', '141949', '74', '28238');
INSERT INTO public.who_global_data_import VALUES (28943, '2020-05-24', 'FR', 'France', 'EURO', '224', '142173', '43', '28281');
INSERT INTO public.who_global_data_import VALUES (28944, '2020-05-25', 'FR', 'France', 'EURO', '31', '142204', '34', '28315');
INSERT INTO public.who_global_data_import VALUES (28945, '2020-05-26', 'FR', 'France', 'EURO', '278', '142482', '64', '28379');
INSERT INTO public.who_global_data_import VALUES (28946, '2020-05-27', 'FR', 'France', 'EURO', '222', '142704', '98', '28477');
INSERT INTO public.who_global_data_import VALUES (28947, '2020-05-28', 'FR', 'France', 'EURO', '148', '142852', '66', '28543');
INSERT INTO public.who_global_data_import VALUES (28948, '2020-05-29', 'FR', 'France', 'EURO', '3270', '146122', '65', '28608');
INSERT INTO public.who_global_data_import VALUES (28949, '2020-05-30', 'FR', 'France', 'EURO', '535', '146657', '52', '28660');
INSERT INTO public.who_global_data_import VALUES (28950, '2020-05-31', 'FR', 'France', 'EURO', '1779', '148436', '57', '28717');
INSERT INTO public.who_global_data_import VALUES (28951, '2020-06-01', 'FR', 'France', 'EURO', '88', '148524', '29', '28746');
INSERT INTO public.who_global_data_import VALUES (28952, '2020-06-02', 'FR', 'France', 'EURO', '251', '148775', '30', '28776');
INSERT INTO public.who_global_data_import VALUES (28953, '2020-06-03', 'FR', 'France', 'EURO', '-840', '147935', '107', '28883');
INSERT INTO public.who_global_data_import VALUES (28954, '2020-06-04', 'FR', 'France', 'EURO', '328', '148263', '81', '28964');
INSERT INTO public.who_global_data_import VALUES (28955, '2020-06-05', 'FR', 'France', 'EURO', '678', '148941', '43', '29007');
INSERT INTO public.who_global_data_import VALUES (28956, '2020-06-06', 'FR', 'France', 'EURO', '554', '149495', '46', '29053');
INSERT INTO public.who_global_data_import VALUES (28957, '2020-06-07', 'FR', 'France', 'EURO', '527', '150022', '31', '29084');
INSERT INTO public.who_global_data_import VALUES (28958, '2020-06-08', 'FR', 'France', 'EURO', '293', '150315', '13', '29097');
INSERT INTO public.who_global_data_import VALUES (28959, '2020-06-09', 'FR', 'France', 'EURO', '98', '150413', '52', '29149');
INSERT INTO public.who_global_data_import VALUES (28960, '2020-06-10', 'FR', 'France', 'EURO', '335', '150748', '85', '29234');
INSERT INTO public.who_global_data_import VALUES (28961, '2020-06-11', 'FR', 'France', 'EURO', '417', '151165', '23', '29257');
INSERT INTO public.who_global_data_import VALUES (28962, '2020-06-12', 'FR', 'France', 'EURO', '338', '151503', '27', '29284');
INSERT INTO public.who_global_data_import VALUES (28963, '2020-06-13', 'FR', 'France', 'EURO', '564', '152067', '28', '29312');
INSERT INTO public.who_global_data_import VALUES (28964, '2020-06-14', 'FR', 'France', 'EURO', '393', '152460', '23', '29335');
INSERT INTO public.who_global_data_import VALUES (28965, '2020-06-15', 'FR', 'France', 'EURO', '307', '152767', '8', '29343');
INSERT INTO public.who_global_data_import VALUES (28966, '2020-06-16', 'FR', 'France', 'EURO', '52', '152819', '30', '29373');
INSERT INTO public.who_global_data_import VALUES (28967, '2020-06-17', 'FR', 'France', 'EURO', '226', '153045', '108', '29481');
INSERT INTO public.who_global_data_import VALUES (28968, '2020-06-18', 'FR', 'France', 'EURO', '311', '153356', '28', '29509');
INSERT INTO public.who_global_data_import VALUES (28969, '2020-06-19', 'FR', 'France', 'EURO', '201', '153557', '28', '29537');
INSERT INTO public.who_global_data_import VALUES (28970, '2020-06-20', 'FR', 'France', 'EURO', '584', '154141', '14', '29551');
INSERT INTO public.who_global_data_import VALUES (28971, '2020-06-21', 'FR', 'France', 'EURO', '421', '154562', '14', '29565');
INSERT INTO public.who_global_data_import VALUES (28972, '2020-06-22', 'FR', 'France', 'EURO', '5', '154567', '6', '29571');
INSERT INTO public.who_global_data_import VALUES (28973, '2020-06-23', 'FR', 'France', 'EURO', '325', '154892', '20', '29591');
INSERT INTO public.who_global_data_import VALUES (28974, '2020-06-24', 'FR', 'France', 'EURO', '364', '155256', '57', '29648');
INSERT INTO public.who_global_data_import VALUES (28975, '2020-06-25', 'FR', 'France', 'EURO', '0', '155256', '0', '29648');
INSERT INTO public.who_global_data_import VALUES (28976, '2020-06-26', 'FR', 'France', 'EURO', '0', '155256', '27', '29675');
INSERT INTO public.who_global_data_import VALUES (28977, '2020-06-27', 'FR', 'France', 'EURO', '900', '156156', '25', '29700');
INSERT INTO public.who_global_data_import VALUES (28978, '2020-06-28', 'FR', 'France', 'EURO', '0', '156156', '0', '29700');
INSERT INTO public.who_global_data_import VALUES (28979, '2020-06-29', 'FR', 'France', 'EURO', '0', '156156', '0', '29700');
INSERT INTO public.who_global_data_import VALUES (28980, '2020-06-30', 'FR', 'France', 'EURO', '731', '156887', '30', '29730');
INSERT INTO public.who_global_data_import VALUES (28981, '2020-07-01', 'FR', 'France', 'EURO', '307', '157194', '30', '29760');
INSERT INTO public.who_global_data_import VALUES (28982, '2020-07-02', 'FR', 'France', 'EURO', '612', '157806', '17', '29777');
INSERT INTO public.who_global_data_import VALUES (28983, '2020-07-03', 'FR', 'France', 'EURO', '480', '158286', '14', '29791');
INSERT INTO public.who_global_data_import VALUES (28984, '2020-07-04', 'FR', 'France', 'EURO', '448', '158734', '17', '29808');
INSERT INTO public.who_global_data_import VALUES (28985, '2020-07-05', 'FR', 'France', 'EURO', '0', '158734', '0', '29808');
INSERT INTO public.who_global_data_import VALUES (28986, '2020-07-06', 'FR', 'France', 'EURO', '0', '158734', '0', '29808');
INSERT INTO public.who_global_data_import VALUES (28987, '2020-07-07', 'FR', 'France', 'EURO', '834', '159568', '23', '29831');
INSERT INTO public.who_global_data_import VALUES (28988, '2020-07-08', 'FR', 'France', 'EURO', '341', '159909', '11', '29842');
INSERT INTO public.who_global_data_import VALUES (28989, '2020-07-09', 'FR', 'France', 'EURO', '370', '160279', '31', '29873');
INSERT INTO public.who_global_data_import VALUES (28990, '2020-07-10', 'FR', 'France', 'EURO', '504', '160783', '13', '29886');
INSERT INTO public.who_global_data_import VALUES (28991, '2020-07-11', 'FR', 'France', 'EURO', '492', '161275', '24', '29910');
INSERT INTO public.who_global_data_import VALUES (28992, '2020-07-12', 'FR', 'France', 'EURO', '0', '161275', '0', '29910');
INSERT INTO public.who_global_data_import VALUES (28993, '2020-07-13', 'FR', 'France', 'EURO', '0', '161275', '0', '29910');
INSERT INTO public.who_global_data_import VALUES (28994, '2020-07-14', 'FR', 'France', 'EURO', '1115', '162390', '18', '29928');
INSERT INTO public.who_global_data_import VALUES (28995, '2020-07-15', 'FR', 'France', 'EURO', '0', '162390', '0', '29928');
INSERT INTO public.who_global_data_import VALUES (28996, '2020-07-16', 'FR', 'France', 'EURO', '767', '163157', '87', '30015');
INSERT INTO public.who_global_data_import VALUES (28997, '2020-07-17', 'FR', 'France', 'EURO', '393', '163550', '17', '30032');
INSERT INTO public.who_global_data_import VALUES (28998, '2020-07-18', 'FR', 'France', 'EURO', '697', '164247', '14', '30046');
INSERT INTO public.who_global_data_import VALUES (28999, '2020-07-19', 'FR', 'France', 'EURO', '0', '164247', '0', '30046');
INSERT INTO public.who_global_data_import VALUES (29000, '2020-07-20', 'FR', 'France', 'EURO', '0', '164247', '0', '30046');
INSERT INTO public.who_global_data_import VALUES (29001, '2020-07-21', 'FR', 'France', 'EURO', '1810', '166057', '8', '30054');
INSERT INTO public.who_global_data_import VALUES (29002, '2020-07-22', 'FR', 'France', 'EURO', '454', '166511', '-1', '30053');
INSERT INTO public.who_global_data_import VALUES (29003, '2020-07-23', 'FR', 'France', 'EURO', '945', '167456', '7', '30060');
INSERT INTO public.who_global_data_import VALUES (29004, '2020-07-24', 'FR', 'France', 'EURO', '835', '168291', '9', '30069');
INSERT INTO public.who_global_data_import VALUES (29005, '2020-07-25', 'FR', 'France', 'EURO', '931', '169222', '9', '30078');
INSERT INTO public.who_global_data_import VALUES (29006, '2020-07-26', 'FR', 'France', 'EURO', '0', '169222', '0', '30078');
INSERT INTO public.who_global_data_import VALUES (29007, '2020-07-27', 'FR', 'France', 'EURO', '0', '169222', '0', '30078');
INSERT INTO public.who_global_data_import VALUES (29008, '2020-07-28', 'FR', 'France', 'EURO', '2254', '171476', '15', '30093');
INSERT INTO public.who_global_data_import VALUES (29009, '2020-07-29', 'FR', 'France', 'EURO', '672', '172148', '12', '30105');
INSERT INTO public.who_global_data_import VALUES (29010, '2020-07-30', 'FR', 'France', 'EURO', '1261', '173409', '15', '30120');
INSERT INTO public.who_global_data_import VALUES (29011, '2020-07-31', 'FR', 'France', 'EURO', '1239', '174648', '16', '30136');
INSERT INTO public.who_global_data_import VALUES (29012, '2020-08-01', 'FR', 'France', 'EURO', '1272', '175920', '11', '30147');
INSERT INTO public.who_global_data_import VALUES (29013, '2020-08-02', 'FR', 'France', 'EURO', '0', '175920', '0', '30147');
INSERT INTO public.who_global_data_import VALUES (29014, '2020-08-03', 'FR', 'France', 'EURO', '0', '175920', '0', '30147');
INSERT INTO public.who_global_data_import VALUES (29015, '2020-08-04', 'FR', 'France', 'EURO', '3152', '179072', '28', '30175');
INSERT INTO public.who_global_data_import VALUES (29016, '2020-08-05', 'FR', 'France', 'EURO', '965', '180037', '1', '30176');
INSERT INTO public.who_global_data_import VALUES (29017, '2020-08-06', 'FR', 'France', 'EURO', '1615', '181652', '6', '30182');
INSERT INTO public.who_global_data_import VALUES (29018, '2020-08-07', 'FR', 'France', 'EURO', '1520', '183172', '7', '30189');
INSERT INTO public.who_global_data_import VALUES (29019, '2020-08-08', 'FR', 'France', 'EURO', '2181', '185353', '12', '30201');
INSERT INTO public.who_global_data_import VALUES (29020, '2020-08-09', 'FR', 'France', 'EURO', '0', '185353', '0', '30201');
INSERT INTO public.who_global_data_import VALUES (29021, '2020-08-10', 'FR', 'France', 'EURO', '0', '185353', '0', '30201');
INSERT INTO public.who_global_data_import VALUES (29022, '2020-08-11', 'FR', 'France', 'EURO', '4619', '189972', '13', '30214');
INSERT INTO public.who_global_data_import VALUES (29023, '2020-08-12', 'FR', 'France', 'EURO', '1293', '191265', '13', '30227');
INSERT INTO public.who_global_data_import VALUES (29024, '2020-08-13', 'FR', 'France', 'EURO', '2429', '193694', '16', '30243');
INSERT INTO public.who_global_data_import VALUES (29025, '2020-08-14', 'FR', 'France', 'EURO', '2515', '196209', '16', '30259');
INSERT INTO public.who_global_data_import VALUES (29026, '2020-08-15', 'FR', 'France', 'EURO', '2667', '198876', '16', '30275');
INSERT INTO public.who_global_data_import VALUES (29027, '2020-08-16', 'FR', 'France', 'EURO', '3242', '202118', '2', '30277');
INSERT INTO public.who_global_data_import VALUES (29028, '2020-08-17', 'FR', 'France', 'EURO', '2947', '205065', '1', '30278');
INSERT INTO public.who_global_data_import VALUES (29029, '2020-08-18', 'FR', 'France', 'EURO', '315', '205380', '18', '30296');
INSERT INTO public.who_global_data_import VALUES (29030, '2020-08-19', 'FR', 'France', 'EURO', '2165', '207545', '22', '30318');
INSERT INTO public.who_global_data_import VALUES (29031, '2020-08-20', 'FR', 'France', 'EURO', '3680', '211225', '16', '30334');
INSERT INTO public.who_global_data_import VALUES (29032, '2020-08-21', 'FR', 'France', 'EURO', '4688', '215913', '12', '30346');
INSERT INTO public.who_global_data_import VALUES (29033, '2020-08-22', 'FR', 'France', 'EURO', '4396', '220309', '22', '30368');
INSERT INTO public.who_global_data_import VALUES (29034, '2020-08-23', 'FR', 'France', 'EURO', '3110', '223419', '8', '30376');
INSERT INTO public.who_global_data_import VALUES (29035, '2020-08-24', 'FR', 'France', 'EURO', '4805', '228224', '1', '30377');
INSERT INTO public.who_global_data_import VALUES (29036, '2020-08-25', 'FR', 'France', 'EURO', '1842', '230066', '18', '30395');
INSERT INTO public.who_global_data_import VALUES (29037, '2020-08-26', 'FR', 'France', 'EURO', '3227', '233293', '16', '30411');
INSERT INTO public.who_global_data_import VALUES (29038, '2020-08-27', 'FR', 'France', 'EURO', '4998', '238291', '0', '30411');
INSERT INTO public.who_global_data_import VALUES (29039, '2020-08-28', 'FR', 'France', 'EURO', '5963', '244254', '29', '30440');
INSERT INTO public.who_global_data_import VALUES (29040, '2020-08-29', 'FR', 'France', 'EURO', '7262', '251516', '20', '30460');
INSERT INTO public.who_global_data_import VALUES (29041, '2020-08-30', 'FR', 'France', 'EURO', '5313', '256829', '5', '30465');
INSERT INTO public.who_global_data_import VALUES (29042, '2020-08-31', 'FR', 'France', 'EURO', '5126', '261955', '2', '30467');
INSERT INTO public.who_global_data_import VALUES (29043, '2020-09-01', 'FR', 'France', 'EURO', '2998', '264953', '27', '30494');
INSERT INTO public.who_global_data_import VALUES (29044, '2020-09-02', 'FR', 'France', 'EURO', '4765', '269718', '23', '30517');
INSERT INTO public.who_global_data_import VALUES (29045, '2020-09-03', 'FR', 'France', 'EURO', '6748', '276466', '22', '30539');
INSERT INTO public.who_global_data_import VALUES (29046, '2020-09-04', 'FR', 'France', 'EURO', '6799', '283265', '-3', '30536');
INSERT INTO public.who_global_data_import VALUES (29047, '2020-09-05', 'FR', 'France', 'EURO', '8860', '292125', '-1', '30535');
INSERT INTO public.who_global_data_import VALUES (29048, '2020-09-06', 'FR', 'France', 'EURO', '8386', '300511', '11', '30546');
INSERT INTO public.who_global_data_import VALUES (29049, '2020-09-07', 'FR', 'France', 'EURO', '6961', '307472', '1', '30547');
INSERT INTO public.who_global_data_import VALUES (29050, '2020-09-08', 'FR', 'France', 'EURO', '4115', '311587', '25', '30572');
INSERT INTO public.who_global_data_import VALUES (29051, '2020-09-09', 'FR', 'France', 'EURO', '5519', '317106', '35', '30607');
INSERT INTO public.who_global_data_import VALUES (29052, '2020-09-10', 'FR', 'France', 'EURO', '8294', '325400', '29', '30636');
INSERT INTO public.who_global_data_import VALUES (29053, '2020-09-11', 'FR', 'France', 'EURO', '9685', '335085', '18', '30654');
INSERT INTO public.who_global_data_import VALUES (29054, '2020-09-12', 'FR', 'France', 'EURO', '9260', '344345', '80', '30734');
INSERT INTO public.who_global_data_import VALUES (29055, '2020-09-13', 'FR', 'France', 'EURO', '9641', '353986', '15', '30749');
INSERT INTO public.who_global_data_import VALUES (29056, '2020-09-14', 'FR', 'France', 'EURO', '7101', '361087', '6', '30755');
INSERT INTO public.who_global_data_import VALUES (29057, '2020-09-15', 'FR', 'France', 'EURO', '5893', '366980', '34', '30789');
INSERT INTO public.who_global_data_import VALUES (29058, '2020-09-16', 'FR', 'France', 'EURO', '7720', '374700', '48', '30837');
INSERT INTO public.who_global_data_import VALUES (29059, '2020-09-17', 'FR', 'France', 'EURO', '9138', '383838', '43', '30880');
INSERT INTO public.who_global_data_import VALUES (29060, '2020-09-18', 'FR', 'France', 'EURO', '10468', '394306', '50', '30930');
INSERT INTO public.who_global_data_import VALUES (29061, '2020-09-19', 'FR', 'France', 'EURO', '13084', '407390', '154', '31084');
INSERT INTO public.who_global_data_import VALUES (29062, '2020-09-20', 'FR', 'France', 'EURO', '13465', '420855', '25', '31109');
INSERT INTO public.who_global_data_import VALUES (29063, '2020-09-21', 'FR', 'France', 'EURO', '11569', '432424', '11', '31120');
INSERT INTO public.who_global_data_import VALUES (29064, '2020-09-22', 'FR', 'France', 'EURO', '4057', '436481', '52', '31172');
INSERT INTO public.who_global_data_import VALUES (29065, '2020-09-23', 'FR', 'France', 'EURO', '8921', '445402', '62', '31234');
INSERT INTO public.who_global_data_import VALUES (29066, '2020-09-24', 'FR', 'France', 'EURO', '12730', '458132', '39', '31273');
INSERT INTO public.who_global_data_import VALUES (29067, '2020-09-25', 'FR', 'France', 'EURO', '16068', '474200', '52', '31325');
INSERT INTO public.who_global_data_import VALUES (29068, '2020-09-26', 'FR', 'France', 'EURO', '15572', '489772', '150', '31475');
INSERT INTO public.who_global_data_import VALUES (29069, '2020-09-27', 'FR', 'France', 'EURO', '13886', '503658', '39', '31514');
INSERT INTO public.who_global_data_import VALUES (29070, '2020-09-28', 'FR', 'France', 'EURO', '11123', '514781', '27', '31541');
INSERT INTO public.who_global_data_import VALUES (29071, '2020-09-29', 'FR', 'France', 'EURO', '3841', '518622', '67', '31608');
INSERT INTO public.who_global_data_import VALUES (29072, '2020-09-30', 'FR', 'France', 'EURO', '7779', '526401', '82', '31690');
INSERT INTO public.who_global_data_import VALUES (29073, '2020-10-01', 'FR', 'France', 'EURO', '11889', '538290', '56', '31746');
INSERT INTO public.who_global_data_import VALUES (29074, '2020-10-02', 'FR', 'France', 'EURO', '13959', '552249', '62', '31808');
INSERT INTO public.who_global_data_import VALUES (29075, '2020-10-03', 'FR', 'France', 'EURO', '11543', '563792', '118', '31926');
INSERT INTO public.who_global_data_import VALUES (29076, '2020-10-04', 'FR', 'France', 'EURO', '16911', '580703', '43', '31969');
INSERT INTO public.who_global_data_import VALUES (29077, '2020-10-05', 'FR', 'France', 'EURO', '12545', '593248', '32', '32001');
INSERT INTO public.who_global_data_import VALUES (29078, '2020-10-06', 'FR', 'France', 'EURO', '4813', '598061', '68', '32069');
INSERT INTO public.who_global_data_import VALUES (29079, '2020-10-07', 'FR', 'France', 'EURO', '10476', '608537', '65', '32134');
INSERT INTO public.who_global_data_import VALUES (29080, '2020-10-08', 'FR', 'France', 'EURO', '17932', '626469', '77', '32211');
INSERT INTO public.who_global_data_import VALUES (29081, '2020-10-09', 'FR', 'France', 'EURO', '18104', '644573', '76', '32287');
INSERT INTO public.who_global_data_import VALUES (29082, '2020-10-10', 'FR', 'France', 'EURO', '20120', '664693', '90', '32377');
INSERT INTO public.who_global_data_import VALUES (29083, '2020-10-11', 'FR', 'France', 'EURO', '26675', '691368', '54', '32431');
INSERT INTO public.who_global_data_import VALUES (29084, '2020-10-12', 'FR', 'France', 'EURO', '16101', '707469', '46', '32477');
INSERT INTO public.who_global_data_import VALUES (29085, '2020-10-13', 'FR', 'France', 'EURO', '8295', '715764', '94', '32571');
INSERT INTO public.who_global_data_import VALUES (29086, '2020-10-14', 'FR', 'France', 'EURO', '12981', '728745', '108', '32679');
INSERT INTO public.who_global_data_import VALUES (29087, '2020-10-15', 'FR', 'France', 'EURO', '21696', '750441', '101', '32780');
INSERT INTO public.who_global_data_import VALUES (29088, '2020-10-16', 'FR', 'France', 'EURO', '30553', '780994', '88', '32868');
INSERT INTO public.who_global_data_import VALUES (29089, '2020-10-17', 'FR', 'France', 'EURO', '24724', '805718', '162', '33030');
INSERT INTO public.who_global_data_import VALUES (29090, '2020-10-18', 'FR', 'France', 'EURO', '32427', '838145', '89', '33119');
INSERT INTO public.who_global_data_import VALUES (29091, '2020-10-19', 'FR', 'France', 'EURO', '29833', '867978', '85', '33204');
INSERT INTO public.who_global_data_import VALUES (29092, '2020-10-20', 'FR', 'France', 'EURO', '12944', '880922', '146', '33350');
INSERT INTO public.who_global_data_import VALUES (29093, '2020-10-21', 'FR', 'France', 'EURO', '20424', '901346', '261', '33611');
INSERT INTO public.who_global_data_import VALUES (29094, '2020-10-22', 'FR', 'France', 'EURO', '25847', '927193', '155', '33766');
INSERT INTO public.who_global_data_import VALUES (29095, '2020-10-23', 'FR', 'France', 'EURO', '41536', '968729', '162', '33928');
INSERT INTO public.who_global_data_import VALUES (29096, '2020-10-24', 'FR', 'France', 'EURO', '41825', '1010554', '297', '34225');
INSERT INTO public.who_global_data_import VALUES (29097, '2020-10-25', 'FR', 'France', 'EURO', '45388', '1055942', '137', '34362');
INSERT INTO public.who_global_data_import VALUES (29098, '2020-10-26', 'FR', 'France', 'EURO', '52010', '1107952', '116', '34478');
INSERT INTO public.who_global_data_import VALUES (29099, '2020-10-27', 'FR', 'France', 'EURO', '26344', '1134296', '243', '34721');
INSERT INTO public.who_global_data_import VALUES (29100, '2020-10-28', 'FR', 'France', 'EURO', '33405', '1167701', '522', '35243');
INSERT INTO public.who_global_data_import VALUES (29101, '2020-10-29', 'FR', 'France', 'EURO', '35367', '1203068', '241', '35484');
INSERT INTO public.who_global_data_import VALUES (29102, '2020-10-30', 'FR', 'France', 'EURO', '47637', '1250705', '235', '35719');
INSERT INTO public.who_global_data_import VALUES (29103, '2020-10-31', 'FR', 'France', 'EURO', '48573', '1299278', '531', '36250');
INSERT INTO public.who_global_data_import VALUES (29104, '2020-11-01', 'FR', 'France', 'EURO', '32530', '1331808', '223', '36473');
INSERT INTO public.who_global_data_import VALUES (29105, '2020-11-02', 'FR', 'France', 'EURO', '49290', '1381098', '231', '36704');
INSERT INTO public.who_global_data_import VALUES (29106, '2020-11-03', 'FR', 'France', 'EURO', '52156', '1433254', '411', '37115');
INSERT INTO public.who_global_data_import VALUES (29107, '2020-11-04', 'FR', 'France', 'EURO', '36254', '1469508', '854', '37969');
INSERT INTO public.who_global_data_import VALUES (29108, '2020-11-05', 'FR', 'France', 'EURO', '39807', '1509315', '386', '38355');
INSERT INTO public.who_global_data_import VALUES (29109, '2020-11-06', 'FR', 'France', 'EURO', '58017', '1567332', '363', '38718');
INSERT INTO public.who_global_data_import VALUES (29110, '2020-11-07', 'FR', 'France', 'EURO', '60235', '1627567', '827', '39545');
INSERT INTO public.who_global_data_import VALUES (29111, '2020-11-08', 'FR', 'France', 'EURO', '86794', '1714361', '304', '39849');
INSERT INTO public.who_global_data_import VALUES (29112, '2020-11-09', 'FR', 'France', 'EURO', '38619', '1752980', '270', '40119');
INSERT INTO public.who_global_data_import VALUES (29113, '2020-11-10', 'FR', 'France', 'EURO', '19571', '1772551', '546', '40665');
INSERT INTO public.who_global_data_import VALUES (29114, '2020-11-11', 'FR', 'France', 'EURO', '22166', '1794717', '1220', '41885');
INSERT INTO public.who_global_data_import VALUES (29115, '2020-11-12', 'FR', 'France', 'EURO', '34971', '1829688', '318', '42203');
INSERT INTO public.who_global_data_import VALUES (29116, '2020-11-13', 'FR', 'France', 'EURO', '32978', '1862666', '425', '42628');
INSERT INTO public.who_global_data_import VALUES (29117, '2020-11-14', 'FR', 'France', 'EURO', '23620', '1886286', '931', '43559');
INSERT INTO public.who_global_data_import VALUES (29118, '2020-11-15', 'FR', 'France', 'EURO', '32059', '1918345', '354', '43913');
INSERT INTO public.who_global_data_import VALUES (29119, '2020-11-16', 'FR', 'France', 'EURO', '27123', '1945468', '302', '44215');
INSERT INTO public.who_global_data_import VALUES (29120, '2020-11-17', 'FR', 'France', 'EURO', '9094', '1954562', '504', '44719');
INSERT INTO public.who_global_data_import VALUES (29121, '2020-11-18', 'FR', 'France', 'EURO', '45498', '2000060', '1219', '45938');
INSERT INTO public.who_global_data_import VALUES (29122, '2020-11-19', 'FR', 'France', 'EURO', '27667', '2027727', '413', '46351');
INSERT INTO public.who_global_data_import VALUES (29123, '2020-11-20', 'FR', 'France', 'EURO', '21130', '2048857', '429', '46780');
INSERT INTO public.who_global_data_import VALUES (29124, '2020-11-21', 'FR', 'France', 'EURO', '22642', '2071499', '1137', '47917');
INSERT INTO public.who_global_data_import VALUES (29125, '2020-11-22', 'FR', 'France', 'EURO', '17854', '2089353', '253', '48170');
INSERT INTO public.who_global_data_import VALUES (29126, '2020-11-23', 'FR', 'France', 'EURO', '13157', '2102510', '214', '48384');
INSERT INTO public.who_global_data_import VALUES (29127, '2020-11-24', 'FR', 'France', 'EURO', '4150', '2106660', '499', '48883');
INSERT INTO public.who_global_data_import VALUES (29128, '2020-11-25', 'FR', 'France', 'EURO', '9118', '2115778', '1005', '49888');
INSERT INTO public.who_global_data_import VALUES (29129, '2020-11-26', 'FR', 'France', 'EURO', '15598', '2131376', '371', '50259');
INSERT INTO public.who_global_data_import VALUES (29130, '2020-11-27', 'FR', 'France', 'EURO', '13541', '2144917', '339', '50598');
INSERT INTO public.who_global_data_import VALUES (29131, '2020-11-28', 'FR', 'France', 'EURO', '12415', '2157332', '956', '51554');
INSERT INTO public.who_global_data_import VALUES (29132, '2020-11-29', 'FR', 'France', 'EURO', '12479', '2169811', '213', '51767');
INSERT INTO public.who_global_data_import VALUES (29133, '2020-11-30', 'FR', 'France', 'EURO', '9670', '2179481', '198', '51965');
INSERT INTO public.who_global_data_import VALUES (29134, '2020-12-01', 'FR', 'France', 'EURO', '3794', '2183275', '406', '52371');
INSERT INTO public.who_global_data_import VALUES (29135, '2020-12-02', 'FR', 'France', 'EURO', '7999', '2191274', '775', '53146');
INSERT INTO public.who_global_data_import VALUES (29136, '2020-12-03', 'FR', 'France', 'EURO', '13938', '2205212', '309', '53455');
INSERT INTO public.who_global_data_import VALUES (29137, '2020-12-04', 'FR', 'France', 'EURO', '12661', '2217873', '324', '53779');
INSERT INTO public.who_global_data_import VALUES (29138, '2020-12-05', 'FR', 'France', 'EURO', '11107', '2228980', '625', '54404');
INSERT INTO public.who_global_data_import VALUES (29139, '2020-12-06', 'FR', 'France', 'EURO', '12850', '2241830', '214', '54618');
INSERT INTO public.who_global_data_import VALUES (29140, '2020-12-07', 'FR', 'France', 'EURO', '11022', '2252852', '174', '54792');
INSERT INTO public.who_global_data_import VALUES (29141, '2020-12-08', 'FR', 'France', 'EURO', '3103', '2255955', '366', '55158');
INSERT INTO public.who_global_data_import VALUES (29142, '2020-12-09', 'FR', 'France', 'EURO', '13713', '2269668', '828', '55986');
INSERT INTO public.who_global_data_import VALUES (29143, '2020-12-10', 'FR', 'France', 'EURO', '14084', '2283752', '294', '56280');
INSERT INTO public.who_global_data_import VALUES (29144, '2020-12-11', 'FR', 'France', 'EURO', '13673', '2297425', '292', '56572');
INSERT INTO public.who_global_data_import VALUES (29145, '2020-12-12', 'FR', 'France', 'EURO', '13276', '2310701', '626', '57198');
INSERT INTO public.who_global_data_import VALUES (29146, '2020-12-13', 'FR', 'France', 'EURO', '13902', '2324603', '194', '57392');
INSERT INTO public.who_global_data_import VALUES (29147, '2020-12-14', 'FR', 'France', 'EURO', '11533', '2336136', '150', '57542');
INSERT INTO public.who_global_data_import VALUES (29148, '2020-12-15', 'FR', 'France', 'EURO', '2590', '2338726', '368', '57910');
INSERT INTO public.who_global_data_import VALUES (29149, '2020-12-16', 'FR', 'France', 'EURO', '11481', '2350207', '790', '58700');
INSERT INTO public.who_global_data_import VALUES (29150, '2020-12-17', 'FR', 'France', 'EURO', '17441', '2367648', '289', '58989');
INSERT INTO public.who_global_data_import VALUES (29151, '2020-12-18', 'FR', 'France', 'EURO', '18025', '2385673', '256', '59245');
INSERT INTO public.who_global_data_import VALUES (29152, '2020-12-19', 'FR', 'France', 'EURO', '15440', '2401113', '610', '59855');
INSERT INTO public.who_global_data_import VALUES (29153, '2020-12-20', 'FR', 'France', 'EURO', '17326', '2418439', '188', '60043');
INSERT INTO public.who_global_data_import VALUES (29154, '2020-12-21', 'FR', 'France', 'EURO', '12798', '2431237', '131', '60174');
INSERT INTO public.who_global_data_import VALUES (29155, '2020-12-22', 'FR', 'France', 'EURO', '5636', '2436873', '351', '60525');
INSERT INTO public.who_global_data_import VALUES (29156, '2020-12-23', 'FR', 'France', 'EURO', '11670', '2448543', '801', '61326');
INSERT INTO public.who_global_data_import VALUES (29157, '2020-12-24', 'FR', 'France', 'EURO', '14836', '2463379', '276', '61602');
INSERT INTO public.who_global_data_import VALUES (29158, '2020-12-25', 'FR', 'France', 'EURO', '21496', '2484875', '290', '61892');
INSERT INTO public.who_global_data_import VALUES (29159, '2020-12-26', 'FR', 'France', 'EURO', '20199', '2505074', '159', '62051');
INSERT INTO public.who_global_data_import VALUES (29160, '2020-12-27', 'FR', 'France', 'EURO', '2458', '2507532', '146', '62197');
INSERT INTO public.who_global_data_import VALUES (29161, '2020-12-28', 'FR', 'France', 'EURO', '8816', '2516348', '173', '62370');
INSERT INTO public.who_global_data_import VALUES (29162, '2020-12-29', 'FR', 'France', 'EURO', '2757', '2519105', '362', '62732');
INSERT INTO public.who_global_data_import VALUES (29163, '2020-12-30', 'FR', 'France', 'EURO', '11295', '2530400', '969', '63701');
INSERT INTO public.who_global_data_import VALUES (29164, '2020-12-31', 'FR', 'France', 'EURO', '26308', '2556708', '303', '64004');
INSERT INTO public.who_global_data_import VALUES (29165, '2021-01-01', 'FR', 'France', 'EURO', '19712', '2576420', '250', '64254');
INSERT INTO public.who_global_data_import VALUES (29166, '2021-01-02', 'FR', 'France', 'EURO', '19241', '2595661', '133', '64387');
INSERT INTO public.who_global_data_import VALUES (29167, '2021-01-03', 'FR', 'France', 'EURO', '3466', '2599127', '156', '64543');
INSERT INTO public.who_global_data_import VALUES (29168, '2021-01-04', 'FR', 'France', 'EURO', '12489', '2611616', '116', '64659');
INSERT INTO public.who_global_data_import VALUES (29169, '2021-01-05', 'FR', 'France', 'EURO', '3569', '2615185', '376', '65035');
INSERT INTO public.who_global_data_import VALUES (29170, '2021-01-06', 'FR', 'France', 'EURO', '20366', '2635551', '867', '65902');
INSERT INTO public.who_global_data_import VALUES (29171, '2021-01-07', 'FR', 'France', 'EURO', '25189', '2660740', '282', '66184');
INSERT INTO public.who_global_data_import VALUES (29172, '2021-01-08', 'FR', 'France', 'EURO', '21510', '2682250', '276', '66460');
INSERT INTO public.who_global_data_import VALUES (29173, '2021-01-09', 'FR', 'France', 'EURO', '19408', '2701658', '589', '67049');
INSERT INTO public.who_global_data_import VALUES (29174, '2021-01-10', 'FR', 'France', 'EURO', '20034', '2721692', '168', '67217');
INSERT INTO public.who_global_data_import VALUES (29175, '2021-01-11', 'FR', 'France', 'EURO', '15809', '2737501', '151', '67368');
INSERT INTO public.who_global_data_import VALUES (29176, '2021-01-12', 'FR', 'France', 'EURO', '3155', '2740656', '689', '68057');
INSERT INTO public.who_global_data_import VALUES (29177, '2021-01-13', 'FR', 'France', 'EURO', '19603', '2760259', '362', '68419');
INSERT INTO public.who_global_data_import VALUES (29178, '2021-01-14', 'FR', 'France', 'EURO', '23649', '2783908', '229', '68648');
INSERT INTO public.who_global_data_import VALUES (29179, '2021-01-15', 'FR', 'France', 'EURO', '20872', '2804780', '280', '68928');
INSERT INTO public.who_global_data_import VALUES (29180, '2021-01-16', 'FR', 'France', 'EURO', '20984', '2825764', '633', '69561');
INSERT INTO public.who_global_data_import VALUES (29181, '2021-01-17', 'FR', 'France', 'EURO', '21207', '2846971', '192', '69753');
INSERT INTO public.who_global_data_import VALUES (29182, '2021-01-18', 'FR', 'France', 'EURO', '16642', '2863613', '141', '69894');
INSERT INTO public.who_global_data_import VALUES (29183, '2021-01-19', 'FR', 'France', 'EURO', '3052', '2866665', '401', '70295');
INSERT INTO public.who_global_data_import VALUES (29184, '2021-01-20', 'FR', 'France', 'EURO', '23347', '2890012', '656', '70951');
INSERT INTO public.who_global_data_import VALUES (29185, '2021-01-21', 'FR', 'France', 'EURO', '26565', '2916577', '310', '71261');
INSERT INTO public.who_global_data_import VALUES (29186, '2021-01-22', 'FR', 'France', 'EURO', '22551', '2939128', '346', '71607');
INSERT INTO public.who_global_data_import VALUES (29187, '2021-01-23', 'FR', 'France', 'EURO', '22609', '2961737', '648', '72255');
INSERT INTO public.who_global_data_import VALUES (29188, '2021-01-24', 'FR', 'France', 'EURO', '23522', '2985259', '229', '72484');
INSERT INTO public.who_global_data_import VALUES (29189, '2021-01-25', 'FR', 'France', 'EURO', '18435', '3003694', '172', '72656');
INSERT INTO public.who_global_data_import VALUES (29190, '2021-01-26', 'FR', 'France', 'EURO', '4012', '3007706', '445', '73101');
INSERT INTO public.who_global_data_import VALUES (29191, '2021-01-27', 'FR', 'France', 'EURO', '22086', '3029792', '612', '73713');
INSERT INTO public.who_global_data_import VALUES (29192, '2021-01-28', 'FR', 'France', 'EURO', '26406', '3056198', '349', '74062');
INSERT INTO public.who_global_data_import VALUES (29193, '2021-01-29', 'FR', 'France', 'EURO', '23347', '3079545', '343', '74405');
INSERT INTO public.who_global_data_import VALUES (29194, '2021-01-30', 'FR', 'France', 'EURO', '22670', '3102215', '819', '75224');
INSERT INTO public.who_global_data_import VALUES (29195, '2021-01-31', 'FR', 'France', 'EURO', '24136', '3126351', '242', '75466');
INSERT INTO public.who_global_data_import VALUES (29196, '2021-02-01', 'FR', 'France', 'EURO', '19235', '3145586', '195', '75661');
INSERT INTO public.who_global_data_import VALUES (29197, '2021-02-02', 'FR', 'France', 'EURO', '3669', '3149255', '453', '76114');
INSERT INTO public.who_global_data_import VALUES (29198, '2021-02-03', 'FR', 'France', 'EURO', '22871', '3172126', '726', '76840');
INSERT INTO public.who_global_data_import VALUES (29199, '2021-02-04', 'FR', 'France', 'EURO', '25904', '3198030', '353', '77193');
INSERT INTO public.who_global_data_import VALUES (29200, '2021-02-05', 'FR', 'France', 'EURO', '23148', '3221178', '355', '77548');
INSERT INTO public.who_global_data_import VALUES (29201, '2020-01-03', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29202, '2020-01-04', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29203, '2020-01-05', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29204, '2020-01-06', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29205, '2020-01-07', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29206, '2020-01-08', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29207, '2020-01-09', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29208, '2020-01-10', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29209, '2020-01-11', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29210, '2020-01-12', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29211, '2020-01-13', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29212, '2020-01-14', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29213, '2020-01-15', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29214, '2020-01-16', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29215, '2020-01-17', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29216, '2020-01-18', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29217, '2020-01-19', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29218, '2020-01-20', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29219, '2020-01-21', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29220, '2020-01-22', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29221, '2020-01-23', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29222, '2020-01-24', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29223, '2020-01-25', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29224, '2020-01-26', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29225, '2020-01-27', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29226, '2020-01-28', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29227, '2020-01-29', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29228, '2020-01-30', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29229, '2020-01-31', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29230, '2020-02-01', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29231, '2020-02-02', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29232, '2020-02-03', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29233, '2020-02-04', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29234, '2020-02-05', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29235, '2020-02-06', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29236, '2020-02-07', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29237, '2020-02-08', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29238, '2020-02-09', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29239, '2020-02-10', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29240, '2020-02-11', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29241, '2020-02-12', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29242, '2020-02-13', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29243, '2020-02-14', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29244, '2020-02-15', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29245, '2020-02-16', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29246, '2020-02-17', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29247, '2020-02-18', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29248, '2020-02-19', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29249, '2020-02-20', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29250, '2020-02-21', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29251, '2020-02-22', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29252, '2020-02-23', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29253, '2020-02-24', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29254, '2020-02-25', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29255, '2020-02-26', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29256, '2020-02-27', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29257, '2020-02-28', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29258, '2020-02-29', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29259, '2020-03-01', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29260, '2020-03-02', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29261, '2020-03-03', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29262, '2020-03-04', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29263, '2020-03-05', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29264, '2020-03-06', 'GF', 'French Guiana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29265, '2020-03-07', 'GF', 'French Guiana', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29266, '2020-03-08', 'GF', 'French Guiana', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29267, '2020-03-09', 'GF', 'French Guiana', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29268, '2020-03-10', 'GF', 'French Guiana', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29269, '2020-03-11', 'GF', 'French Guiana', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29270, '2020-03-12', 'GF', 'French Guiana', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29271, '2020-03-13', 'GF', 'French Guiana', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29272, '2020-03-14', 'GF', 'French Guiana', 'AMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29273, '2020-03-15', 'GF', 'French Guiana', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29274, '2020-03-16', 'GF', 'French Guiana', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29275, '2020-03-17', 'GF', 'French Guiana', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29276, '2020-03-18', 'GF', 'French Guiana', 'AMRO', '8', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29277, '2020-03-19', 'GF', 'French Guiana', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29278, '2020-03-20', 'GF', 'French Guiana', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29279, '2020-03-21', 'GF', 'French Guiana', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29280, '2020-03-22', 'GF', 'French Guiana', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29281, '2020-03-23', 'GF', 'French Guiana', 'AMRO', '3', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29282, '2020-03-24', 'GF', 'French Guiana', 'AMRO', '5', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29283, '2020-03-25', 'GF', 'French Guiana', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29284, '2020-03-26', 'GF', 'French Guiana', 'AMRO', '5', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29285, '2020-03-27', 'GF', 'French Guiana', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29286, '2020-03-28', 'GF', 'French Guiana', 'AMRO', '3', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29287, '2020-03-29', 'GF', 'French Guiana', 'AMRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29288, '2020-03-30', 'GF', 'French Guiana', 'AMRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29289, '2020-03-31', 'GF', 'French Guiana', 'AMRO', '12', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29290, '2020-04-01', 'GF', 'French Guiana', 'AMRO', '3', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29291, '2020-04-02', 'GF', 'French Guiana', 'AMRO', '5', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29292, '2020-04-03', 'GF', 'French Guiana', 'AMRO', '4', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29293, '2020-04-04', 'GF', 'French Guiana', 'AMRO', '2', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29294, '2020-04-05', 'GF', 'French Guiana', 'AMRO', '5', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29295, '2020-04-06', 'GF', 'French Guiana', 'AMRO', '4', '66', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29296, '2020-04-07', 'GF', 'French Guiana', 'AMRO', '2', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29297, '2020-04-08', 'GF', 'French Guiana', 'AMRO', '4', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29298, '2020-04-09', 'GF', 'French Guiana', 'AMRO', '5', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29299, '2020-04-10', 'GF', 'French Guiana', 'AMRO', '6', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29300, '2020-04-11', 'GF', 'French Guiana', 'AMRO', '1', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29301, '2020-04-12', 'GF', 'French Guiana', 'AMRO', '2', '86', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29302, '2020-04-13', 'GF', 'French Guiana', 'AMRO', '0', '86', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29303, '2020-04-14', 'GF', 'French Guiana', 'AMRO', '2', '88', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29304, '2020-04-15', 'GF', 'French Guiana', 'AMRO', '0', '88', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29305, '2020-04-16', 'GF', 'French Guiana', 'AMRO', '7', '95', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29306, '2020-04-17', 'GF', 'French Guiana', 'AMRO', '1', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29307, '2020-04-18', 'GF', 'French Guiana', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29308, '2020-04-19', 'GF', 'French Guiana', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29309, '2020-04-20', 'GF', 'French Guiana', 'AMRO', '0', '96', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29310, '2020-04-21', 'GF', 'French Guiana', 'AMRO', '1', '97', '1', '1');
INSERT INTO public.who_global_data_import VALUES (29311, '2020-04-22', 'GF', 'French Guiana', 'AMRO', '0', '97', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29312, '2020-04-23', 'GF', 'French Guiana', 'AMRO', '0', '97', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29313, '2020-04-24', 'GF', 'French Guiana', 'AMRO', '10', '107', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29314, '2020-04-25', 'GF', 'French Guiana', 'AMRO', '2', '109', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29315, '2020-04-26', 'GF', 'French Guiana', 'AMRO', '0', '109', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29316, '2020-04-27', 'GF', 'French Guiana', 'AMRO', '0', '109', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29317, '2020-04-28', 'GF', 'French Guiana', 'AMRO', '2', '111', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29318, '2020-04-29', 'GF', 'French Guiana', 'AMRO', '13', '124', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29319, '2020-04-30', 'GF', 'French Guiana', 'AMRO', '1', '125', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29320, '2020-05-01', 'GF', 'French Guiana', 'AMRO', '1', '126', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29321, '2020-05-02', 'GF', 'French Guiana', 'AMRO', '2', '128', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29322, '2020-05-03', 'GF', 'French Guiana', 'AMRO', '0', '128', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29323, '2020-05-04', 'GF', 'French Guiana', 'AMRO', '0', '128', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29324, '2020-05-05', 'GF', 'French Guiana', 'AMRO', '5', '133', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29325, '2020-05-06', 'GF', 'French Guiana', 'AMRO', '0', '133', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29326, '2020-05-07', 'GF', 'French Guiana', 'AMRO', '5', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29327, '2020-05-08', 'GF', 'French Guiana', 'AMRO', '0', '138', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29328, '2020-05-09', 'GF', 'French Guiana', 'AMRO', '3', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29329, '2020-05-10', 'GF', 'French Guiana', 'AMRO', '0', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29330, '2020-05-11', 'GF', 'French Guiana', 'AMRO', '3', '144', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29331, '2020-05-12', 'GF', 'French Guiana', 'AMRO', '0', '144', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29332, '2020-05-13', 'GF', 'French Guiana', 'AMRO', '2', '146', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29333, '2020-05-14', 'GF', 'French Guiana', 'AMRO', '7', '153', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29334, '2020-05-15', 'GF', 'French Guiana', 'AMRO', '11', '164', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29335, '2020-05-16', 'GF', 'French Guiana', 'AMRO', '20', '184', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29336, '2020-05-17', 'GF', 'French Guiana', 'AMRO', '5', '189', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29337, '2020-05-18', 'GF', 'French Guiana', 'AMRO', '8', '197', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29338, '2020-05-19', 'GF', 'French Guiana', 'AMRO', '0', '197', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29339, '2020-05-20', 'GF', 'French Guiana', 'AMRO', '13', '210', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29340, '2020-05-21', 'GF', 'French Guiana', 'AMRO', '8', '218', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29341, '2020-05-22', 'GF', 'French Guiana', 'AMRO', '19', '237', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29342, '2020-05-23', 'GF', 'French Guiana', 'AMRO', '12', '249', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29343, '2020-05-24', 'GF', 'French Guiana', 'AMRO', '12', '261', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29344, '2020-05-25', 'GF', 'French Guiana', 'AMRO', '18', '279', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29345, '2020-05-26', 'GF', 'French Guiana', 'AMRO', '49', '328', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29346, '2020-05-27', 'GF', 'French Guiana', 'AMRO', '25', '353', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29347, '2020-05-28', 'GF', 'French Guiana', 'AMRO', '31', '384', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29348, '2020-05-29', 'GF', 'French Guiana', 'AMRO', '25', '409', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29349, '2020-05-30', 'GF', 'French Guiana', 'AMRO', '27', '436', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29350, '2020-05-31', 'GF', 'French Guiana', 'AMRO', '0', '436', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29351, '2020-06-01', 'GF', 'French Guiana', 'AMRO', '41', '477', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29352, '2020-06-02', 'GF', 'French Guiana', 'AMRO', '22', '499', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29353, '2020-06-03', 'GF', 'French Guiana', 'AMRO', '18', '517', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29354, '2020-06-04', 'GF', 'French Guiana', 'AMRO', '16', '533', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29355, '2020-06-05', 'GF', 'French Guiana', 'AMRO', '23', '556', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29356, '2020-06-06', 'GF', 'French Guiana', 'AMRO', '33', '589', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29357, '2020-06-07', 'GF', 'French Guiana', 'AMRO', '50', '639', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29358, '2020-06-08', 'GF', 'French Guiana', 'AMRO', '50', '689', '0', '1');
INSERT INTO public.who_global_data_import VALUES (29359, '2020-06-09', 'GF', 'French Guiana', 'AMRO', '40', '729', '1', '2');
INSERT INTO public.who_global_data_import VALUES (29360, '2020-06-10', 'GF', 'French Guiana', 'AMRO', '44', '773', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29361, '2020-06-11', 'GF', 'French Guiana', 'AMRO', '92', '865', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29362, '2020-06-12', 'GF', 'French Guiana', 'AMRO', '52', '917', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29363, '2020-06-13', 'GF', 'French Guiana', 'AMRO', '126', '1043', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29364, '2020-06-14', 'GF', 'French Guiana', 'AMRO', '118', '1161', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29365, '2020-06-15', 'GF', 'French Guiana', 'AMRO', '94', '1255', '1', '3');
INSERT INTO public.who_global_data_import VALUES (29366, '2020-06-16', 'GF', 'French Guiana', 'AMRO', '71', '1326', '0', '3');
INSERT INTO public.who_global_data_import VALUES (29367, '2020-06-17', 'GF', 'French Guiana', 'AMRO', '95', '1421', '2', '5');
INSERT INTO public.who_global_data_import VALUES (29368, '2020-06-18', 'GF', 'French Guiana', 'AMRO', '133', '1554', '0', '5');
INSERT INTO public.who_global_data_import VALUES (29369, '2020-06-19', 'GF', 'French Guiana', 'AMRO', '204', '1758', '0', '5');
INSERT INTO public.who_global_data_import VALUES (29370, '2020-06-20', 'GF', 'French Guiana', 'AMRO', '211', '1969', '0', '5');
INSERT INTO public.who_global_data_import VALUES (29371, '2020-06-21', 'GF', 'French Guiana', 'AMRO', '194', '2163', '0', '5');
INSERT INTO public.who_global_data_import VALUES (29372, '2020-06-22', 'GF', 'French Guiana', 'AMRO', '278', '2441', '1', '6');
INSERT INTO public.who_global_data_import VALUES (29373, '2020-06-23', 'GF', 'French Guiana', 'AMRO', '17', '2458', '2', '8');
INSERT INTO public.who_global_data_import VALUES (29374, '2020-06-24', 'GF', 'French Guiana', 'AMRO', '135', '2593', '0', '8');
INSERT INTO public.who_global_data_import VALUES (29375, '2020-06-25', 'GF', 'French Guiana', 'AMRO', '234', '2827', '1', '9');
INSERT INTO public.who_global_data_import VALUES (29376, '2020-06-26', 'GF', 'French Guiana', 'AMRO', '206', '3033', '1', '10');
INSERT INTO public.who_global_data_import VALUES (29377, '2020-06-27', 'GF', 'French Guiana', 'AMRO', '237', '3270', '1', '11');
INSERT INTO public.who_global_data_import VALUES (29378, '2020-06-28', 'GF', 'French Guiana', 'AMRO', '191', '3461', '1', '12');
INSERT INTO public.who_global_data_import VALUES (29379, '2020-06-29', 'GF', 'French Guiana', 'AMRO', '0', '3461', '0', '12');
INSERT INTO public.who_global_data_import VALUES (29380, '2020-06-30', 'GF', 'French Guiana', 'AMRO', '313', '3774', '3', '15');
INSERT INTO public.who_global_data_import VALUES (29381, '2020-07-01', 'GF', 'French Guiana', 'AMRO', '230', '4004', '0', '15');
INSERT INTO public.who_global_data_import VALUES (29382, '2020-07-02', 'GF', 'French Guiana', 'AMRO', '264', '4268', '1', '16');
INSERT INTO public.who_global_data_import VALUES (29383, '2020-07-03', 'GF', 'French Guiana', 'AMRO', '176', '4444', '0', '16');
INSERT INTO public.who_global_data_import VALUES (29384, '2020-07-04', 'GF', 'French Guiana', 'AMRO', '114', '4558', '0', '16');
INSERT INTO public.who_global_data_import VALUES (29385, '2020-07-05', 'GF', 'French Guiana', 'AMRO', '355', '4913', '0', '16');
INSERT INTO public.who_global_data_import VALUES (29386, '2020-07-06', 'GF', 'French Guiana', 'AMRO', '0', '4913', '0', '16');
INSERT INTO public.who_global_data_import VALUES (29387, '2020-07-07', 'GF', 'French Guiana', 'AMRO', '141', '5054', '4', '20');
INSERT INTO public.who_global_data_import VALUES (29388, '2020-07-08', 'GF', 'French Guiana', 'AMRO', '124', '5178', '1', '21');
INSERT INTO public.who_global_data_import VALUES (29389, '2020-07-09', 'GF', 'French Guiana', 'AMRO', '281', '5459', '1', '22');
INSERT INTO public.who_global_data_import VALUES (29390, '2020-07-10', 'GF', 'French Guiana', 'AMRO', '99', '5558', '0', '22');
INSERT INTO public.who_global_data_import VALUES (29391, '2020-07-11', 'GF', 'French Guiana', 'AMRO', '146', '5704', '1', '23');
INSERT INTO public.who_global_data_import VALUES (29392, '2020-07-12', 'GF', 'French Guiana', 'AMRO', '245', '5949', '3', '26');
INSERT INTO public.who_global_data_import VALUES (29393, '2020-07-13', 'GF', 'French Guiana', 'AMRO', '0', '5949', '0', '26');
INSERT INTO public.who_global_data_import VALUES (29394, '2020-07-14', 'GF', 'French Guiana', 'AMRO', '221', '6170', '3', '29');
INSERT INTO public.who_global_data_import VALUES (29395, '2020-07-15', 'GF', 'French Guiana', 'AMRO', '59', '6229', '2', '31');
INSERT INTO public.who_global_data_import VALUES (29396, '2020-07-16', 'GF', 'French Guiana', 'AMRO', '70', '6299', '2', '33');
INSERT INTO public.who_global_data_import VALUES (29397, '2020-07-17', 'GF', 'French Guiana', 'AMRO', '94', '6393', '1', '34');
INSERT INTO public.who_global_data_import VALUES (29398, '2020-07-18', 'GF', 'French Guiana', 'AMRO', '116', '6509', '0', '34');
INSERT INTO public.who_global_data_import VALUES (29399, '2020-07-19', 'GF', 'French Guiana', 'AMRO', '146', '6655', '3', '37');
INSERT INTO public.who_global_data_import VALUES (29400, '2020-07-20', 'GF', 'French Guiana', 'AMRO', '0', '6655', '0', '37');
INSERT INTO public.who_global_data_import VALUES (29401, '2020-07-21', 'GF', 'French Guiana', 'AMRO', '90', '6745', '1', '38');
INSERT INTO public.who_global_data_import VALUES (29402, '2020-07-22', 'GF', 'French Guiana', 'AMRO', '106', '6851', '1', '39');
INSERT INTO public.who_global_data_import VALUES (29403, '2020-07-23', 'GF', 'French Guiana', 'AMRO', '32', '6883', '0', '39');
INSERT INTO public.who_global_data_import VALUES (29404, '2020-07-24', 'GF', 'French Guiana', 'AMRO', '203', '7086', '1', '40');
INSERT INTO public.who_global_data_import VALUES (29405, '2020-07-25', 'GF', 'French Guiana', 'AMRO', '165', '7251', '1', '41');
INSERT INTO public.who_global_data_import VALUES (29406, '2020-07-26', 'GF', 'French Guiana', 'AMRO', '81', '7332', '0', '41');
INSERT INTO public.who_global_data_import VALUES (29407, '2020-07-27', 'GF', 'French Guiana', 'AMRO', '0', '7332', '0', '41');
INSERT INTO public.who_global_data_import VALUES (29408, '2020-07-28', 'GF', 'French Guiana', 'AMRO', '182', '7514', '1', '42');
INSERT INTO public.who_global_data_import VALUES (29409, '2020-07-29', 'GF', 'French Guiana', 'AMRO', '48', '7562', '1', '43');
INSERT INTO public.who_global_data_import VALUES (29410, '2020-07-30', 'GF', 'French Guiana', 'AMRO', '85', '7647', '0', '43');
INSERT INTO public.who_global_data_import VALUES (29411, '2020-07-31', 'GF', 'French Guiana', 'AMRO', '81', '7728', '0', '43');
INSERT INTO public.who_global_data_import VALUES (29412, '2020-08-01', 'GF', 'French Guiana', 'AMRO', '71', '7799', '0', '43');
INSERT INTO public.who_global_data_import VALUES (29413, '2020-08-02', 'GF', 'French Guiana', 'AMRO', '58', '7857', '0', '43');
INSERT INTO public.who_global_data_import VALUES (29414, '2020-08-03', 'GF', 'French Guiana', 'AMRO', '0', '7857', '0', '43');
INSERT INTO public.who_global_data_import VALUES (29415, '2020-08-04', 'GF', 'French Guiana', 'AMRO', '91', '7948', '1', '44');
INSERT INTO public.who_global_data_import VALUES (29416, '2020-08-05', 'GF', 'French Guiana', 'AMRO', '50', '7998', '1', '45');
INSERT INTO public.who_global_data_import VALUES (29417, '2020-08-06', 'GF', 'French Guiana', 'AMRO', '71', '8069', '2', '47');
INSERT INTO public.who_global_data_import VALUES (29418, '2020-08-07', 'GF', 'French Guiana', 'AMRO', '58', '8127', '0', '47');
INSERT INTO public.who_global_data_import VALUES (29419, '2020-08-08', 'GF', 'French Guiana', 'AMRO', '77', '8204', '0', '47');
INSERT INTO public.who_global_data_import VALUES (29420, '2020-08-09', 'GF', 'French Guiana', 'AMRO', '63', '8267', '1', '48');
INSERT INTO public.who_global_data_import VALUES (29421, '2020-08-10', 'GF', 'French Guiana', 'AMRO', '0', '8267', '0', '48');
INSERT INTO public.who_global_data_import VALUES (29422, '2020-08-11', 'GF', 'French Guiana', 'AMRO', '57', '8324', '1', '49');
INSERT INTO public.who_global_data_import VALUES (29423, '2020-08-12', 'GF', 'French Guiana', 'AMRO', '36', '8360', '0', '49');
INSERT INTO public.who_global_data_import VALUES (29424, '2020-08-13', 'GF', 'French Guiana', 'AMRO', '63', '8423', '1', '50');
INSERT INTO public.who_global_data_import VALUES (29425, '2020-08-14', 'GF', 'French Guiana', 'AMRO', '48', '8471', '1', '51');
INSERT INTO public.who_global_data_import VALUES (29426, '2020-08-15', 'GF', 'French Guiana', 'AMRO', '78', '8549', '2', '53');
INSERT INTO public.who_global_data_import VALUES (29427, '2020-08-16', 'GF', 'French Guiana', 'AMRO', '39', '8588', '0', '53');
INSERT INTO public.who_global_data_import VALUES (29428, '2020-08-17', 'GF', 'French Guiana', 'AMRO', '0', '8588', '0', '53');
INSERT INTO public.who_global_data_import VALUES (29429, '2020-08-18', 'GF', 'French Guiana', 'AMRO', '34', '8622', '0', '53');
INSERT INTO public.who_global_data_import VALUES (29430, '2020-08-19', 'GF', 'French Guiana', 'AMRO', '35', '8657', '0', '53');
INSERT INTO public.who_global_data_import VALUES (29431, '2020-08-20', 'GF', 'French Guiana', 'AMRO', '54', '8711', '1', '54');
INSERT INTO public.who_global_data_import VALUES (29432, '2020-08-21', 'GF', 'French Guiana', 'AMRO', '32', '8743', '0', '54');
INSERT INTO public.who_global_data_import VALUES (29433, '2020-08-22', 'GF', 'French Guiana', 'AMRO', '34', '8777', '1', '55');
INSERT INTO public.who_global_data_import VALUES (29434, '2020-08-23', 'GF', 'French Guiana', 'AMRO', '20', '8797', '0', '55');
INSERT INTO public.who_global_data_import VALUES (29435, '2020-08-24', 'GF', 'French Guiana', 'AMRO', '0', '8797', '0', '55');
INSERT INTO public.who_global_data_import VALUES (29436, '2020-08-25', 'GF', 'French Guiana', 'AMRO', '78', '8875', '1', '56');
INSERT INTO public.who_global_data_import VALUES (29437, '2020-08-26', 'GF', 'French Guiana', 'AMRO', '29', '8904', '0', '56');
INSERT INTO public.who_global_data_import VALUES (29438, '2020-08-27', 'GF', 'French Guiana', 'AMRO', '32', '8936', '0', '56');
INSERT INTO public.who_global_data_import VALUES (29439, '2020-08-28', 'GF', 'French Guiana', 'AMRO', '46', '8982', '2', '58');
INSERT INTO public.who_global_data_import VALUES (29440, '2020-08-29', 'GF', 'French Guiana', 'AMRO', '40', '9022', '0', '58');
INSERT INTO public.who_global_data_import VALUES (29441, '2020-08-30', 'GF', 'French Guiana', 'AMRO', '54', '9076', '0', '58');
INSERT INTO public.who_global_data_import VALUES (29442, '2020-08-31', 'GF', 'French Guiana', 'AMRO', '0', '9076', '0', '58');
INSERT INTO public.who_global_data_import VALUES (29443, '2020-09-01', 'GF', 'French Guiana', 'AMRO', '39', '9115', '1', '59');
INSERT INTO public.who_global_data_import VALUES (29444, '2020-09-02', 'GF', 'French Guiana', 'AMRO', '39', '9154', '1', '60');
INSERT INTO public.who_global_data_import VALUES (29445, '2020-09-03', 'GF', 'French Guiana', 'AMRO', '55', '9209', '1', '61');
INSERT INTO public.who_global_data_import VALUES (29446, '2020-09-04', 'GF', 'French Guiana', 'AMRO', '42', '9251', '0', '61');
INSERT INTO public.who_global_data_import VALUES (29447, '2020-09-05', 'GF', 'French Guiana', 'AMRO', '25', '9276', '1', '62');
INSERT INTO public.who_global_data_import VALUES (29448, '2020-09-06', 'GF', 'French Guiana', 'AMRO', '46', '9322', '0', '62');
INSERT INTO public.who_global_data_import VALUES (29449, '2020-09-07', 'GF', 'French Guiana', 'AMRO', '0', '9322', '0', '62');
INSERT INTO public.who_global_data_import VALUES (29450, '2020-09-08', 'GF', 'French Guiana', 'AMRO', '33', '9355', '0', '62');
INSERT INTO public.who_global_data_import VALUES (29451, '2020-09-09', 'GF', 'French Guiana', 'AMRO', '32', '9387', '0', '62');
INSERT INTO public.who_global_data_import VALUES (29452, '2020-09-10', 'GF', 'French Guiana', 'AMRO', '31', '9418', '0', '62');
INSERT INTO public.who_global_data_import VALUES (29453, '2020-09-11', 'GF', 'French Guiana', 'AMRO', '44', '9462', '1', '63');
INSERT INTO public.who_global_data_import VALUES (29454, '2020-09-12', 'GF', 'French Guiana', 'AMRO', '32', '9494', '0', '63');
INSERT INTO public.who_global_data_import VALUES (29455, '2020-09-13', 'GF', 'French Guiana', 'AMRO', '27', '9521', '0', '63');
INSERT INTO public.who_global_data_import VALUES (29456, '2020-09-14', 'GF', 'French Guiana', 'AMRO', '0', '9521', '0', '63');
INSERT INTO public.who_global_data_import VALUES (29457, '2020-09-15', 'GF', 'French Guiana', 'AMRO', '31', '9552', '0', '63');
INSERT INTO public.who_global_data_import VALUES (29458, '2020-09-16', 'GF', 'French Guiana', 'AMRO', '26', '9578', '1', '64');
INSERT INTO public.who_global_data_import VALUES (29459, '2020-09-17', 'GF', 'French Guiana', 'AMRO', '17', '9595', '1', '65');
INSERT INTO public.who_global_data_import VALUES (29460, '2020-09-18', 'GF', 'French Guiana', 'AMRO', '28', '9623', '0', '65');
INSERT INTO public.who_global_data_import VALUES (29461, '2020-09-19', 'GF', 'French Guiana', 'AMRO', '36', '9659', '0', '65');
INSERT INTO public.who_global_data_import VALUES (29462, '2020-09-20', 'GF', 'French Guiana', 'AMRO', '33', '9692', '0', '65');
INSERT INTO public.who_global_data_import VALUES (29463, '2020-09-21', 'GF', 'French Guiana', 'AMRO', '0', '9692', '0', '65');
INSERT INTO public.who_global_data_import VALUES (29464, '2020-09-22', 'GF', 'French Guiana', 'AMRO', '20', '9712', '0', '65');
INSERT INTO public.who_global_data_import VALUES (29465, '2020-09-23', 'GF', 'French Guiana', 'AMRO', '26', '9738', '0', '65');
INSERT INTO public.who_global_data_import VALUES (29466, '2020-09-24', 'GF', 'French Guiana', 'AMRO', '24', '9762', '0', '65');
INSERT INTO public.who_global_data_import VALUES (29467, '2020-09-25', 'GF', 'French Guiana', 'AMRO', '28', '9790', '0', '65');
INSERT INTO public.who_global_data_import VALUES (29468, '2020-09-26', 'GF', 'French Guiana', 'AMRO', '41', '9831', '0', '65');
INSERT INTO public.who_global_data_import VALUES (29469, '2020-09-27', 'GF', 'French Guiana', 'AMRO', '32', '9863', '0', '65');
INSERT INTO public.who_global_data_import VALUES (29470, '2020-09-28', 'GF', 'French Guiana', 'AMRO', '0', '9863', '0', '65');
INSERT INTO public.who_global_data_import VALUES (29471, '2020-09-29', 'GF', 'French Guiana', 'AMRO', '32', '9895', '0', '65');
INSERT INTO public.who_global_data_import VALUES (29472, '2020-09-30', 'GF', 'French Guiana', 'AMRO', '34', '9929', '1', '66');
INSERT INTO public.who_global_data_import VALUES (29473, '2020-10-01', 'GF', 'French Guiana', 'AMRO', '26', '9955', '0', '66');
INSERT INTO public.who_global_data_import VALUES (29474, '2020-10-02', 'GF', 'French Guiana', 'AMRO', '11', '9966', '1', '67');
INSERT INTO public.who_global_data_import VALUES (29475, '2020-10-03', 'GF', 'French Guiana', 'AMRO', '2', '9968', '0', '67');
INSERT INTO public.who_global_data_import VALUES (29476, '2020-10-04', 'GF', 'French Guiana', 'AMRO', '61', '10029', '0', '67');
INSERT INTO public.who_global_data_import VALUES (29477, '2020-10-05', 'GF', 'French Guiana', 'AMRO', '0', '10029', '0', '67');
INSERT INTO public.who_global_data_import VALUES (29478, '2020-10-06', 'GF', 'French Guiana', 'AMRO', '28', '10057', '1', '68');
INSERT INTO public.who_global_data_import VALUES (29479, '2020-10-07', 'GF', 'French Guiana', 'AMRO', '13', '10070', '1', '69');
INSERT INTO public.who_global_data_import VALUES (29480, '2020-10-08', 'GF', 'French Guiana', 'AMRO', '33', '10103', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29481, '2020-10-09', 'GF', 'French Guiana', 'AMRO', '25', '10128', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29482, '2020-10-10', 'GF', 'French Guiana', 'AMRO', '16', '10144', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29483, '2020-10-11', 'GF', 'French Guiana', 'AMRO', '0', '10144', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29484, '2020-10-12', 'GF', 'French Guiana', 'AMRO', '0', '10144', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29485, '2020-10-13', 'GF', 'French Guiana', 'AMRO', '36', '10180', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29486, '2020-10-14', 'GF', 'French Guiana', 'AMRO', '12', '10192', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29487, '2020-10-15', 'GF', 'French Guiana', 'AMRO', '10', '10202', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29488, '2020-10-16', 'GF', 'French Guiana', 'AMRO', '31', '10233', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29489, '2020-10-17', 'GF', 'French Guiana', 'AMRO', '6', '10239', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29490, '2020-10-18', 'GF', 'French Guiana', 'AMRO', '0', '10239', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29491, '2020-10-19', 'GF', 'French Guiana', 'AMRO', '4', '10243', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29492, '2020-10-20', 'GF', 'French Guiana', 'AMRO', '25', '10268', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29493, '2020-10-21', 'GF', 'French Guiana', 'AMRO', '0', '10268', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29494, '2020-10-22', 'GF', 'French Guiana', 'AMRO', '27', '10295', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29495, '2020-10-23', 'GF', 'French Guiana', 'AMRO', '47', '10342', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29496, '2020-10-24', 'GF', 'French Guiana', 'AMRO', '0', '10342', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29497, '2020-10-25', 'GF', 'French Guiana', 'AMRO', '34', '10376', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29498, '2020-10-26', 'GF', 'French Guiana', 'AMRO', '0', '10376', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29499, '2020-10-27', 'GF', 'French Guiana', 'AMRO', '9', '10385', '0', '69');
INSERT INTO public.who_global_data_import VALUES (29500, '2020-10-28', 'GF', 'French Guiana', 'AMRO', '12', '10397', '1', '70');
INSERT INTO public.who_global_data_import VALUES (29501, '2020-10-29', 'GF', 'French Guiana', 'AMRO', '7', '10404', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29502, '2020-10-30', 'GF', 'French Guiana', 'AMRO', '21', '10425', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29503, '2020-10-31', 'GF', 'French Guiana', 'AMRO', '0', '10425', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29504, '2020-11-01', 'GF', 'French Guiana', 'AMRO', '111', '10536', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29505, '2020-11-02', 'GF', 'French Guiana', 'AMRO', '0', '10536', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29506, '2020-11-03', 'GF', 'French Guiana', 'AMRO', '0', '10536', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29507, '2020-11-04', 'GF', 'French Guiana', 'AMRO', '41', '10577', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29508, '2020-11-05', 'GF', 'French Guiana', 'AMRO', '14', '10591', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29509, '2020-11-06', 'GF', 'French Guiana', 'AMRO', '29', '10620', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29510, '2020-11-07', 'GF', 'French Guiana', 'AMRO', '27', '10647', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29511, '2020-11-08', 'GF', 'French Guiana', 'AMRO', '57', '10704', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29512, '2020-11-09', 'GF', 'French Guiana', 'AMRO', '0', '10704', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29513, '2020-11-10', 'GF', 'French Guiana', 'AMRO', '11', '10715', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29514, '2020-11-11', 'GF', 'French Guiana', 'AMRO', '14', '10729', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29515, '2020-11-12', 'GF', 'French Guiana', 'AMRO', '33', '10762', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29516, '2020-11-13', 'GF', 'French Guiana', 'AMRO', '18', '10780', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29517, '2020-11-14', 'GF', 'French Guiana', 'AMRO', '28', '10808', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29518, '2020-11-15', 'GF', 'French Guiana', 'AMRO', '36', '10844', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29519, '2020-11-16', 'GF', 'French Guiana', 'AMRO', '0', '10844', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29520, '2020-11-17', 'GF', 'French Guiana', 'AMRO', '32', '10876', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29521, '2020-11-18', 'GF', 'French Guiana', 'AMRO', '24', '10900', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29522, '2020-11-19', 'GF', 'French Guiana', 'AMRO', '30', '10930', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29523, '2020-11-20', 'GF', 'French Guiana', 'AMRO', '20', '10950', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29524, '2020-11-21', 'GF', 'French Guiana', 'AMRO', '37', '10987', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29525, '2020-11-22', 'GF', 'French Guiana', 'AMRO', '27', '11014', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29526, '2020-11-23', 'GF', 'French Guiana', 'AMRO', '0', '11014', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29527, '2020-11-24', 'GF', 'French Guiana', 'AMRO', '28', '11042', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29528, '2020-11-25', 'GF', 'French Guiana', 'AMRO', '37', '11079', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29529, '2020-11-26', 'GF', 'French Guiana', 'AMRO', '37', '11116', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29530, '2020-11-27', 'GF', 'French Guiana', 'AMRO', '22', '11138', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29531, '2020-11-28', 'GF', 'French Guiana', 'AMRO', '20', '11158', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29532, '2020-11-29', 'GF', 'French Guiana', 'AMRO', '21', '11179', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29533, '2020-11-30', 'GF', 'French Guiana', 'AMRO', '0', '11179', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29534, '2020-12-01', 'GF', 'French Guiana', 'AMRO', '25', '11204', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29535, '2020-12-02', 'GF', 'French Guiana', 'AMRO', '36', '11240', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29536, '2020-12-03', 'GF', 'French Guiana', 'AMRO', '43', '11283', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29537, '2020-12-04', 'GF', 'French Guiana', 'AMRO', '35', '11318', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29538, '2020-12-05', 'GF', 'French Guiana', 'AMRO', '16', '11334', '1', '71');
INSERT INTO public.who_global_data_import VALUES (29539, '2020-12-06', 'GF', 'French Guiana', 'AMRO', '73', '11407', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29540, '2020-12-07', 'GF', 'French Guiana', 'AMRO', '0', '11407', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29541, '2020-12-08', 'GF', 'French Guiana', 'AMRO', '51', '11458', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29542, '2020-12-09', 'GF', 'French Guiana', 'AMRO', '55', '11513', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29543, '2020-12-10', 'GF', 'French Guiana', 'AMRO', '87', '11600', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29544, '2020-12-11', 'GF', 'French Guiana', 'AMRO', '77', '11677', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29545, '2020-12-12', 'GF', 'French Guiana', 'AMRO', '78', '11755', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29546, '2020-12-13', 'GF', 'French Guiana', 'AMRO', '45', '11800', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29547, '2020-12-14', 'GF', 'French Guiana', 'AMRO', '0', '11800', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29548, '2020-12-15', 'GF', 'French Guiana', 'AMRO', '55', '11855', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29549, '2020-12-16', 'GF', 'French Guiana', 'AMRO', '51', '11906', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29550, '2020-12-17', 'GF', 'French Guiana', 'AMRO', '120', '12026', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29551, '2020-12-18', 'GF', 'French Guiana', 'AMRO', '137', '12163', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29552, '2020-12-19', 'GF', 'French Guiana', 'AMRO', '118', '12281', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29553, '2020-12-20', 'GF', 'French Guiana', 'AMRO', '88', '12369', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29554, '2020-12-21', 'GF', 'French Guiana', 'AMRO', '0', '12369', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29555, '2020-12-22', 'GF', 'French Guiana', 'AMRO', '64', '12433', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29556, '2020-12-23', 'GF', 'French Guiana', 'AMRO', '66', '12499', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29557, '2020-12-24', 'GF', 'French Guiana', 'AMRO', '48', '12547', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29558, '2020-12-25', 'GF', 'French Guiana', 'AMRO', '138', '12685', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29559, '2020-12-26', 'GF', 'French Guiana', 'AMRO', '0', '12685', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29560, '2020-12-27', 'GF', 'French Guiana', 'AMRO', '88', '12773', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29561, '2020-12-28', 'GF', 'French Guiana', 'AMRO', '6', '12779', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29562, '2020-12-29', 'GF', 'French Guiana', 'AMRO', '53', '12832', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29563, '2020-12-30', 'GF', 'French Guiana', 'AMRO', '64', '12896', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29564, '2020-12-31', 'GF', 'French Guiana', 'AMRO', '149', '13045', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29565, '2021-01-01', 'GF', 'French Guiana', 'AMRO', '121', '13166', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29566, '2021-01-02', 'GF', 'French Guiana', 'AMRO', '107', '13273', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29567, '2021-01-03', 'GF', 'French Guiana', 'AMRO', '0', '13273', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29568, '2021-01-04', 'GF', 'French Guiana', 'AMRO', '0', '13273', '0', '71');
INSERT INTO public.who_global_data_import VALUES (29569, '2021-01-05', 'GF', 'French Guiana', 'AMRO', '101', '13374', '1', '72');
INSERT INTO public.who_global_data_import VALUES (29570, '2021-01-06', 'GF', 'French Guiana', 'AMRO', '123', '13497', '0', '72');
INSERT INTO public.who_global_data_import VALUES (29571, '2021-01-07', 'GF', 'French Guiana', 'AMRO', '135', '13632', '1', '73');
INSERT INTO public.who_global_data_import VALUES (29572, '2021-01-08', 'GF', 'French Guiana', 'AMRO', '193', '13825', '0', '73');
INSERT INTO public.who_global_data_import VALUES (29573, '2021-01-09', 'GF', 'French Guiana', 'AMRO', '145', '13970', '1', '74');
INSERT INTO public.who_global_data_import VALUES (29574, '2021-01-10', 'GF', 'French Guiana', 'AMRO', '143', '14113', '0', '74');
INSERT INTO public.who_global_data_import VALUES (29575, '2021-01-11', 'GF', 'French Guiana', 'AMRO', '0', '14113', '0', '74');
INSERT INTO public.who_global_data_import VALUES (29576, '2021-01-12', 'GF', 'French Guiana', 'AMRO', '108', '14221', '0', '74');
INSERT INTO public.who_global_data_import VALUES (29577, '2021-01-13', 'GF', 'French Guiana', 'AMRO', '149', '14370', '0', '74');
INSERT INTO public.who_global_data_import VALUES (29578, '2021-01-14', 'GF', 'French Guiana', 'AMRO', '156', '14526', '0', '74');
INSERT INTO public.who_global_data_import VALUES (29579, '2021-01-15', 'GF', 'French Guiana', 'AMRO', '128', '14654', '0', '74');
INSERT INTO public.who_global_data_import VALUES (29580, '2021-01-16', 'GF', 'French Guiana', 'AMRO', '122', '14776', '0', '74');
INSERT INTO public.who_global_data_import VALUES (29581, '2021-01-17', 'GF', 'French Guiana', 'AMRO', '199', '14975', '1', '75');
INSERT INTO public.who_global_data_import VALUES (29582, '2021-01-18', 'GF', 'French Guiana', 'AMRO', '0', '14975', '0', '75');
INSERT INTO public.who_global_data_import VALUES (29583, '2021-01-19', 'GF', 'French Guiana', 'AMRO', '80', '15055', '1', '76');
INSERT INTO public.who_global_data_import VALUES (29584, '2021-01-20', 'GF', 'French Guiana', 'AMRO', '132', '15187', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29585, '2021-01-21', 'GF', 'French Guiana', 'AMRO', '124', '15311', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29586, '2021-01-22', 'GF', 'French Guiana', 'AMRO', '120', '15431', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29587, '2021-01-23', 'GF', 'French Guiana', 'AMRO', '129', '15560', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29588, '2021-01-24', 'GF', 'French Guiana', 'AMRO', '104', '15664', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29589, '2021-01-25', 'GF', 'French Guiana', 'AMRO', '0', '15664', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29590, '2021-01-26', 'GF', 'French Guiana', 'AMRO', '38', '15702', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29591, '2021-01-27', 'GF', 'French Guiana', 'AMRO', '77', '15779', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29592, '2021-01-28', 'GF', 'French Guiana', 'AMRO', '78', '15857', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29593, '2021-01-29', 'GF', 'French Guiana', 'AMRO', '75', '15932', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29594, '2021-01-30', 'GF', 'French Guiana', 'AMRO', '96', '16028', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29595, '2021-01-31', 'GF', 'French Guiana', 'AMRO', '55', '16083', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29596, '2021-02-01', 'GF', 'French Guiana', 'AMRO', '0', '16083', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29597, '2021-02-02', 'GF', 'French Guiana', 'AMRO', '51', '16134', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29598, '2021-02-03', 'GF', 'French Guiana', 'AMRO', '51', '16185', '0', '76');
INSERT INTO public.who_global_data_import VALUES (29599, '2021-02-04', 'GF', 'French Guiana', 'AMRO', '33', '16218', '2', '78');
INSERT INTO public.who_global_data_import VALUES (29600, '2021-02-05', 'GF', 'French Guiana', 'AMRO', '46', '16264', '1', '79');
INSERT INTO public.who_global_data_import VALUES (29601, '2020-01-03', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29602, '2020-01-04', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29603, '2020-01-05', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29604, '2020-01-06', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29605, '2020-01-07', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29606, '2020-01-08', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29607, '2020-01-09', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29608, '2020-01-10', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29609, '2020-01-11', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29610, '2020-01-12', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29611, '2020-01-13', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29612, '2020-01-14', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29613, '2020-01-15', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29614, '2020-01-16', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29615, '2020-01-17', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29616, '2020-01-18', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29617, '2020-01-19', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29618, '2020-01-20', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29619, '2020-01-21', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29620, '2020-01-22', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29621, '2020-01-23', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29622, '2020-01-24', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29623, '2020-01-25', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29624, '2020-01-26', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29625, '2020-01-27', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29626, '2020-01-28', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29627, '2020-01-29', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29628, '2020-01-30', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29629, '2020-01-31', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29630, '2020-02-01', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29631, '2020-02-02', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29632, '2020-02-03', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29633, '2020-02-04', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29634, '2020-02-05', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29635, '2020-02-06', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29636, '2020-02-07', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29637, '2020-02-08', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29638, '2020-02-09', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29639, '2020-02-10', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29640, '2020-02-11', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29641, '2020-02-12', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29642, '2020-02-13', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29643, '2020-02-14', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29644, '2020-02-15', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29645, '2020-02-16', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29646, '2020-02-17', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29647, '2020-02-18', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29648, '2020-02-19', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29649, '2020-02-20', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29650, '2020-02-21', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29651, '2020-02-22', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29652, '2020-02-23', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29653, '2020-02-24', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29654, '2020-02-25', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29655, '2020-02-26', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29656, '2020-02-27', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29657, '2020-02-28', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29658, '2020-02-29', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29659, '2020-03-01', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29660, '2020-03-02', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29661, '2020-03-03', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29662, '2020-03-04', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29663, '2020-03-05', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29664, '2020-03-06', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29665, '2020-03-07', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29666, '2020-03-08', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29667, '2020-03-09', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29668, '2020-03-10', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29669, '2020-03-11', 'PF', 'French Polynesia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29670, '2020-03-12', 'PF', 'French Polynesia', 'WPRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29671, '2020-03-13', 'PF', 'French Polynesia', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29672, '2020-03-14', 'PF', 'French Polynesia', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29673, '2020-03-15', 'PF', 'French Polynesia', 'WPRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29674, '2020-03-16', 'PF', 'French Polynesia', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29675, '2020-03-17', 'PF', 'French Polynesia', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29676, '2020-03-18', 'PF', 'French Polynesia', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29677, '2020-03-19', 'PF', 'French Polynesia', 'WPRO', '9', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29678, '2020-03-20', 'PF', 'French Polynesia', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29679, '2020-03-21', 'PF', 'French Polynesia', 'WPRO', '4', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29680, '2020-03-22', 'PF', 'French Polynesia', 'WPRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29681, '2020-03-23', 'PF', 'French Polynesia', 'WPRO', '3', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29682, '2020-03-24', 'PF', 'French Polynesia', 'WPRO', '5', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29683, '2020-03-25', 'PF', 'French Polynesia', 'WPRO', '2', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29684, '2020-03-26', 'PF', 'French Polynesia', 'WPRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29685, '2020-03-27', 'PF', 'French Polynesia', 'WPRO', '5', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29686, '2020-03-28', 'PF', 'French Polynesia', 'WPRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29687, '2020-03-29', 'PF', 'French Polynesia', 'WPRO', '4', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29688, '2020-03-30', 'PF', 'French Polynesia', 'WPRO', '1', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29689, '2020-03-31', 'PF', 'French Polynesia', 'WPRO', '1', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29690, '2020-04-01', 'PF', 'French Polynesia', 'WPRO', '1', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29691, '2020-04-02', 'PF', 'French Polynesia', 'WPRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29692, '2020-04-03', 'PF', 'French Polynesia', 'WPRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29693, '2020-04-04', 'PF', 'French Polynesia', 'WPRO', '2', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29694, '2020-04-05', 'PF', 'French Polynesia', 'WPRO', '1', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29695, '2020-04-06', 'PF', 'French Polynesia', 'WPRO', '1', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29696, '2020-04-07', 'PF', 'French Polynesia', 'WPRO', '1', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29697, '2020-04-08', 'PF', 'French Polynesia', 'WPRO', '5', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29698, '2020-04-09', 'PF', 'French Polynesia', 'WPRO', '4', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29699, '2020-04-10', 'PF', 'French Polynesia', 'WPRO', '0', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29700, '2020-04-11', 'PF', 'French Polynesia', 'WPRO', '0', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29701, '2020-04-12', 'PF', 'French Polynesia', 'WPRO', '0', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29702, '2020-04-13', 'PF', 'French Polynesia', 'WPRO', '2', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29703, '2020-04-14', 'PF', 'French Polynesia', 'WPRO', '2', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29704, '2020-04-15', 'PF', 'French Polynesia', 'WPRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29705, '2020-04-16', 'PF', 'French Polynesia', 'WPRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29706, '2020-04-17', 'PF', 'French Polynesia', 'WPRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29707, '2020-04-18', 'PF', 'French Polynesia', 'WPRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29708, '2020-04-19', 'PF', 'French Polynesia', 'WPRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29709, '2020-04-20', 'PF', 'French Polynesia', 'WPRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29710, '2020-04-21', 'PF', 'French Polynesia', 'WPRO', '1', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29711, '2020-04-22', 'PF', 'French Polynesia', 'WPRO', '1', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29712, '2020-04-23', 'PF', 'French Polynesia', 'WPRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29713, '2020-04-24', 'PF', 'French Polynesia', 'WPRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29714, '2020-04-25', 'PF', 'French Polynesia', 'WPRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29715, '2020-04-26', 'PF', 'French Polynesia', 'WPRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29716, '2020-04-27', 'PF', 'French Polynesia', 'WPRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29717, '2020-04-28', 'PF', 'French Polynesia', 'WPRO', '1', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29718, '2020-04-29', 'PF', 'French Polynesia', 'WPRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29719, '2020-04-30', 'PF', 'French Polynesia', 'WPRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29720, '2020-05-01', 'PF', 'French Polynesia', 'WPRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29721, '2020-05-02', 'PF', 'French Polynesia', 'WPRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29722, '2020-05-03', 'PF', 'French Polynesia', 'WPRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29723, '2020-05-04', 'PF', 'French Polynesia', 'WPRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29724, '2020-05-05', 'PF', 'French Polynesia', 'WPRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29725, '2020-05-06', 'PF', 'French Polynesia', 'WPRO', '2', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29726, '2020-05-07', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29727, '2020-05-08', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29728, '2020-05-09', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29729, '2020-05-10', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29730, '2020-05-11', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29731, '2020-05-12', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29732, '2020-05-13', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29733, '2020-05-14', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29734, '2020-05-15', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29735, '2020-05-16', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29736, '2020-05-17', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29737, '2020-05-18', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29738, '2020-05-19', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29739, '2020-05-20', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29740, '2020-05-21', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29741, '2020-05-22', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29742, '2020-05-23', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29743, '2020-05-24', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29744, '2020-05-25', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29745, '2020-05-26', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29746, '2020-05-27', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29747, '2020-05-28', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29748, '2020-05-29', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29749, '2020-05-30', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29750, '2020-05-31', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29751, '2020-06-01', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29752, '2020-06-02', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29753, '2020-06-03', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29754, '2020-06-04', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29755, '2020-06-05', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29756, '2020-06-06', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29757, '2020-06-07', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29758, '2020-06-08', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29759, '2020-06-09', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29760, '2020-06-10', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29761, '2020-06-11', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29762, '2020-06-12', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29763, '2020-06-13', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29764, '2020-06-14', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29765, '2020-06-15', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29766, '2020-06-16', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29767, '2020-06-17', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29768, '2020-06-18', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29769, '2020-06-19', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29770, '2020-06-20', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29771, '2020-06-21', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29772, '2020-06-22', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29773, '2020-06-23', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29774, '2020-06-24', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29775, '2020-06-25', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29776, '2020-06-26', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29777, '2020-06-27', 'PF', 'French Polynesia', 'WPRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29778, '2020-06-28', 'PF', 'French Polynesia', 'WPRO', '2', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29779, '2020-06-29', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29780, '2020-06-30', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29781, '2020-07-01', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29782, '2020-07-02', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29783, '2020-07-03', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29784, '2020-07-04', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29785, '2020-07-05', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29786, '2020-07-06', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29787, '2020-07-07', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29788, '2020-07-08', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29789, '2020-07-09', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29790, '2020-07-10', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29791, '2020-07-11', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29792, '2020-07-12', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29793, '2020-07-13', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29794, '2020-07-14', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29795, '2020-07-15', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29796, '2020-07-16', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29797, '2020-07-17', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29798, '2020-07-18', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29799, '2020-07-19', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29800, '2020-07-20', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29801, '2020-07-21', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29802, '2020-07-22', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29803, '2020-07-23', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29804, '2020-07-24', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29805, '2020-07-25', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29806, '2020-07-26', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29807, '2020-07-27', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29808, '2020-07-28', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29809, '2020-07-29', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29810, '2020-07-30', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29811, '2020-07-31', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29812, '2020-08-01', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29813, '2020-08-02', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29814, '2020-08-03', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29815, '2020-08-04', 'PF', 'French Polynesia', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29816, '2020-08-05', 'PF', 'French Polynesia', 'WPRO', '2', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29817, '2020-08-06', 'PF', 'French Polynesia', 'WPRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29818, '2020-08-07', 'PF', 'French Polynesia', 'WPRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29819, '2020-08-08', 'PF', 'French Polynesia', 'WPRO', '5', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29820, '2020-08-09', 'PF', 'French Polynesia', 'WPRO', '0', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29821, '2020-08-10', 'PF', 'French Polynesia', 'WPRO', '0', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29822, '2020-08-11', 'PF', 'French Polynesia', 'WPRO', '0', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29823, '2020-08-12', 'PF', 'French Polynesia', 'WPRO', '43', '112', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29824, '2020-08-13', 'PF', 'French Polynesia', 'WPRO', '27', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29825, '2020-08-14', 'PF', 'French Polynesia', 'WPRO', '0', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29826, '2020-08-15', 'PF', 'French Polynesia', 'WPRO', '27', '166', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29827, '2020-08-16', 'PF', 'French Polynesia', 'WPRO', '0', '166', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29828, '2020-08-17', 'PF', 'French Polynesia', 'WPRO', '0', '166', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29829, '2020-08-18', 'PF', 'French Polynesia', 'WPRO', '45', '211', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29830, '2020-08-19', 'PF', 'French Polynesia', 'WPRO', '0', '211', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29831, '2020-08-20', 'PF', 'French Polynesia', 'WPRO', '21', '232', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29832, '2020-08-21', 'PF', 'French Polynesia', 'WPRO', '20', '252', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29833, '2020-08-22', 'PF', 'French Polynesia', 'WPRO', '46', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29834, '2020-08-23', 'PF', 'French Polynesia', 'WPRO', '0', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29835, '2020-08-24', 'PF', 'French Polynesia', 'WPRO', '51', '349', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29836, '2020-08-25', 'PF', 'French Polynesia', 'WPRO', '23', '372', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29837, '2020-08-26', 'PF', 'French Polynesia', 'WPRO', '25', '397', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29838, '2020-08-27', 'PF', 'French Polynesia', 'WPRO', '18', '415', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29839, '2020-08-28', 'PF', 'French Polynesia', 'WPRO', '32', '447', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29840, '2020-08-29', 'PF', 'French Polynesia', 'WPRO', '35', '482', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29841, '2020-08-30', 'PF', 'French Polynesia', 'WPRO', '0', '482', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29842, '2020-08-31', 'PF', 'French Polynesia', 'WPRO', '45', '527', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29843, '2020-09-01', 'PF', 'French Polynesia', 'WPRO', '46', '573', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29844, '2020-09-02', 'PF', 'French Polynesia', 'WPRO', '23', '596', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29845, '2020-09-03', 'PF', 'French Polynesia', 'WPRO', '26', '622', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29846, '2020-09-04', 'PF', 'French Polynesia', 'WPRO', '36', '658', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29847, '2020-09-05', 'PF', 'French Polynesia', 'WPRO', '36', '694', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29848, '2020-09-06', 'PF', 'French Polynesia', 'WPRO', '26', '720', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29849, '2020-09-07', 'PF', 'French Polynesia', 'WPRO', '18', '738', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29850, '2020-09-08', 'PF', 'French Polynesia', 'WPRO', '35', '773', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29851, '2020-09-09', 'PF', 'French Polynesia', 'WPRO', '47', '820', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29852, '2020-09-10', 'PF', 'French Polynesia', 'WPRO', '37', '857', '0', '0');
INSERT INTO public.who_global_data_import VALUES (29853, '2020-09-11', 'PF', 'French Polynesia', 'WPRO', '74', '931', '1', '1');
INSERT INTO public.who_global_data_import VALUES (29854, '2020-09-12', 'PF', 'French Polynesia', 'WPRO', '22', '953', '1', '2');
INSERT INTO public.who_global_data_import VALUES (29855, '2020-09-13', 'PF', 'French Polynesia', 'WPRO', '67', '1020', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29856, '2020-09-14', 'PF', 'French Polynesia', 'WPRO', '35', '1055', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29857, '2020-09-15', 'PF', 'French Polynesia', 'WPRO', '44', '1099', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29858, '2020-09-16', 'PF', 'French Polynesia', 'WPRO', '36', '1135', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29859, '2020-09-17', 'PF', 'French Polynesia', 'WPRO', '55', '1190', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29860, '2020-09-18', 'PF', 'French Polynesia', 'WPRO', '34', '1224', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29861, '2020-09-19', 'PF', 'French Polynesia', 'WPRO', '47', '1271', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29862, '2020-09-20', 'PF', 'French Polynesia', 'WPRO', '47', '1318', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29863, '2020-09-21', 'PF', 'French Polynesia', 'WPRO', '35', '1353', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29864, '2020-09-22', 'PF', 'French Polynesia', 'WPRO', '41', '1394', '0', '2');
INSERT INTO public.who_global_data_import VALUES (29865, '2020-09-23', 'PF', 'French Polynesia', 'WPRO', '0', '1394', '3', '5');
INSERT INTO public.who_global_data_import VALUES (29866, '2020-09-24', 'PF', 'French Polynesia', 'WPRO', '75', '1469', '0', '5');
INSERT INTO public.who_global_data_import VALUES (29867, '2020-09-25', 'PF', 'French Polynesia', 'WPRO', '0', '1469', '0', '5');
INSERT INTO public.who_global_data_import VALUES (29868, '2020-09-26', 'PF', 'French Polynesia', 'WPRO', '110', '1579', '1', '6');
INSERT INTO public.who_global_data_import VALUES (29869, '2020-09-27', 'PF', 'French Polynesia', 'WPRO', '0', '1579', '0', '6');
INSERT INTO public.who_global_data_import VALUES (29870, '2020-09-28', 'PF', 'French Polynesia', 'WPRO', '0', '1579', '0', '6');
INSERT INTO public.who_global_data_import VALUES (29871, '2020-09-29', 'PF', 'French Polynesia', 'WPRO', '0', '1579', '1', '7');
INSERT INTO public.who_global_data_import VALUES (29872, '2020-09-30', 'PF', 'French Polynesia', 'WPRO', '149', '1728', '0', '7');
INSERT INTO public.who_global_data_import VALUES (29873, '2020-10-01', 'PF', 'French Polynesia', 'WPRO', '124', '1852', '0', '7');
INSERT INTO public.who_global_data_import VALUES (29874, '2020-10-02', 'PF', 'French Polynesia', 'WPRO', '0', '1852', '0', '7');
INSERT INTO public.who_global_data_import VALUES (29875, '2020-10-03', 'PF', 'French Polynesia', 'WPRO', '174', '2026', '1', '8');
INSERT INTO public.who_global_data_import VALUES (29876, '2020-10-04', 'PF', 'French Polynesia', 'WPRO', '0', '2026', '0', '8');
INSERT INTO public.who_global_data_import VALUES (29877, '2020-10-05', 'PF', 'French Polynesia', 'WPRO', '0', '2026', '0', '8');
INSERT INTO public.who_global_data_import VALUES (29878, '2020-10-06', 'PF', 'French Polynesia', 'WPRO', '264', '2290', '1', '9');
INSERT INTO public.who_global_data_import VALUES (29879, '2020-10-07', 'PF', 'French Polynesia', 'WPRO', '0', '2290', '0', '9');
INSERT INTO public.who_global_data_import VALUES (29880, '2020-10-08', 'PF', 'French Polynesia', 'WPRO', '130', '2420', '1', '10');
INSERT INTO public.who_global_data_import VALUES (29881, '2020-10-09', 'PF', 'French Polynesia', 'WPRO', '0', '2420', '0', '10');
INSERT INTO public.who_global_data_import VALUES (29882, '2020-10-10', 'PF', 'French Polynesia', 'WPRO', '334', '2754', '0', '10');
INSERT INTO public.who_global_data_import VALUES (29883, '2020-10-11', 'PF', 'French Polynesia', 'WPRO', '0', '2754', '0', '10');
INSERT INTO public.who_global_data_import VALUES (29884, '2020-10-12', 'PF', 'French Polynesia', 'WPRO', '0', '2754', '0', '10');
INSERT INTO public.who_global_data_import VALUES (29885, '2020-10-13', 'PF', 'French Polynesia', 'WPRO', '497', '3251', '1', '11');
INSERT INTO public.who_global_data_import VALUES (29886, '2020-10-14', 'PF', 'French Polynesia', 'WPRO', '0', '3251', '0', '11');
INSERT INTO public.who_global_data_import VALUES (29887, '2020-10-15', 'PF', 'French Polynesia', 'WPRO', '322', '3573', '2', '13');
INSERT INTO public.who_global_data_import VALUES (29888, '2020-10-16', 'PF', 'French Polynesia', 'WPRO', '0', '3573', '0', '13');
INSERT INTO public.who_global_data_import VALUES (29889, '2020-10-17', 'PF', 'French Polynesia', 'WPRO', '224', '3797', '1', '14');
INSERT INTO public.who_global_data_import VALUES (29890, '2020-10-18', 'PF', 'French Polynesia', 'WPRO', '0', '3797', '0', '14');
INSERT INTO public.who_global_data_import VALUES (29891, '2020-10-19', 'PF', 'French Polynesia', 'WPRO', '0', '3797', '0', '14');
INSERT INTO public.who_global_data_import VALUES (29892, '2020-10-20', 'PF', 'French Polynesia', 'WPRO', '813', '4610', '2', '16');
INSERT INTO public.who_global_data_import VALUES (29893, '2020-10-21', 'PF', 'French Polynesia', 'WPRO', '0', '4610', '0', '16');
INSERT INTO public.who_global_data_import VALUES (29894, '2020-10-22', 'PF', 'French Polynesia', 'WPRO', '551', '5161', '3', '19');
INSERT INTO public.who_global_data_import VALUES (29895, '2020-10-23', 'PF', 'French Polynesia', 'WPRO', '0', '5161', '0', '19');
INSERT INTO public.who_global_data_import VALUES (29896, '2020-10-24', 'PF', 'French Polynesia', 'WPRO', '698', '5859', '1', '20');
INSERT INTO public.who_global_data_import VALUES (29897, '2020-10-25', 'PF', 'French Polynesia', 'WPRO', '0', '5859', '0', '20');
INSERT INTO public.who_global_data_import VALUES (29898, '2020-10-26', 'PF', 'French Polynesia', 'WPRO', '0', '5859', '0', '20');
INSERT INTO public.who_global_data_import VALUES (29899, '2020-10-27', 'PF', 'French Polynesia', 'WPRO', '634', '6493', '6', '26');
INSERT INTO public.who_global_data_import VALUES (29900, '2020-10-28', 'PF', 'French Polynesia', 'WPRO', '0', '6493', '0', '26');
INSERT INTO public.who_global_data_import VALUES (29901, '2020-10-29', 'PF', 'French Polynesia', 'WPRO', '769', '7262', '3', '29');
INSERT INTO public.who_global_data_import VALUES (29902, '2020-10-30', 'PF', 'French Polynesia', 'WPRO', '0', '7262', '0', '29');
INSERT INTO public.who_global_data_import VALUES (29903, '2020-10-31', 'PF', 'French Polynesia', 'WPRO', '0', '7262', '0', '29');
INSERT INTO public.who_global_data_import VALUES (29904, '2020-11-01', 'PF', 'French Polynesia', 'WPRO', '0', '7262', '0', '29');
INSERT INTO public.who_global_data_import VALUES (29905, '2020-11-02', 'PF', 'French Polynesia', 'WPRO', '0', '7262', '0', '29');
INSERT INTO public.who_global_data_import VALUES (29906, '2020-11-03', 'PF', 'French Polynesia', 'WPRO', '1384', '8646', '9', '38');
INSERT INTO public.who_global_data_import VALUES (29907, '2020-11-04', 'PF', 'French Polynesia', 'WPRO', '303', '8949', '0', '38');
INSERT INTO public.who_global_data_import VALUES (29908, '2020-11-05', 'PF', 'French Polynesia', 'WPRO', '338', '9287', '1', '39');
INSERT INTO public.who_global_data_import VALUES (29909, '2020-11-06', 'PF', 'French Polynesia', 'WPRO', '467', '9754', '0', '39');
INSERT INTO public.who_global_data_import VALUES (29910, '2020-11-07', 'PF', 'French Polynesia', 'WPRO', '241', '9995', '0', '39');
INSERT INTO public.who_global_data_import VALUES (29911, '2020-11-08', 'PF', 'French Polynesia', 'WPRO', '0', '9995', '0', '39');
INSERT INTO public.who_global_data_import VALUES (29912, '2020-11-09', 'PF', 'French Polynesia', 'WPRO', '0', '9995', '0', '39');
INSERT INTO public.who_global_data_import VALUES (29913, '2020-11-10', 'PF', 'French Polynesia', 'WPRO', '685', '10680', '10', '49');
INSERT INTO public.who_global_data_import VALUES (29914, '2020-11-11', 'PF', 'French Polynesia', 'WPRO', '291', '10971', '3', '52');
INSERT INTO public.who_global_data_import VALUES (29915, '2020-11-12', 'PF', 'French Polynesia', 'WPRO', '345', '11316', '0', '52');
INSERT INTO public.who_global_data_import VALUES (29916, '2020-11-13', 'PF', 'French Polynesia', 'WPRO', '169', '11485', '0', '52');
INSERT INTO public.who_global_data_import VALUES (29917, '2020-11-14', 'PF', 'French Polynesia', 'WPRO', '221', '11706', '1', '53');
INSERT INTO public.who_global_data_import VALUES (29918, '2020-11-15', 'PF', 'French Polynesia', 'WPRO', '0', '11706', '0', '53');
INSERT INTO public.who_global_data_import VALUES (29919, '2020-11-16', 'PF', 'French Polynesia', 'WPRO', '0', '11706', '0', '53');
INSERT INTO public.who_global_data_import VALUES (29920, '2020-11-17', 'PF', 'French Polynesia', 'WPRO', '415', '12121', '3', '56');
INSERT INTO public.who_global_data_import VALUES (29921, '2020-11-18', 'PF', 'French Polynesia', 'WPRO', '241', '12362', '5', '61');
INSERT INTO public.who_global_data_import VALUES (29922, '2020-11-19', 'PF', 'French Polynesia', 'WPRO', '225', '12587', '1', '62');
INSERT INTO public.who_global_data_import VALUES (29923, '2020-11-20', 'PF', 'French Polynesia', 'WPRO', '229', '12816', '0', '62');
INSERT INTO public.who_global_data_import VALUES (29924, '2020-11-21', 'PF', 'French Polynesia', 'WPRO', '162', '12978', '1', '63');
INSERT INTO public.who_global_data_import VALUES (29925, '2020-11-22', 'PF', 'French Polynesia', 'WPRO', '0', '12978', '0', '63');
INSERT INTO public.who_global_data_import VALUES (29926, '2020-11-23', 'PF', 'French Polynesia', 'WPRO', '0', '12978', '0', '63');
INSERT INTO public.who_global_data_import VALUES (29927, '2020-11-24', 'PF', 'French Polynesia', 'WPRO', '308', '13286', '5', '68');
INSERT INTO public.who_global_data_import VALUES (29928, '2020-11-25', 'PF', 'French Polynesia', 'WPRO', '231', '13517', '2', '70');
INSERT INTO public.who_global_data_import VALUES (29929, '2020-11-26', 'PF', 'French Polynesia', 'WPRO', '266', '13783', '0', '70');
INSERT INTO public.who_global_data_import VALUES (29930, '2020-11-27', 'PF', 'French Polynesia', 'WPRO', '100', '13883', '2', '72');
INSERT INTO public.who_global_data_import VALUES (29931, '2020-11-28', 'PF', 'French Polynesia', 'WPRO', '213', '14096', '1', '73');
INSERT INTO public.who_global_data_import VALUES (29932, '2020-11-29', 'PF', 'French Polynesia', 'WPRO', '0', '14096', '0', '73');
INSERT INTO public.who_global_data_import VALUES (29933, '2020-11-30', 'PF', 'French Polynesia', 'WPRO', '0', '14096', '0', '73');
INSERT INTO public.who_global_data_import VALUES (29934, '2020-12-01', 'PF', 'French Polynesia', 'WPRO', '276', '14372', '2', '75');
INSERT INTO public.who_global_data_import VALUES (29935, '2020-12-02', 'PF', 'French Polynesia', 'WPRO', '187', '14559', '1', '76');
INSERT INTO public.who_global_data_import VALUES (29936, '2020-12-03', 'PF', 'French Polynesia', 'WPRO', '157', '14716', '1', '77');
INSERT INTO public.who_global_data_import VALUES (29937, '2020-12-04', 'PF', 'French Polynesia', 'WPRO', '181', '14897', '1', '78');
INSERT INTO public.who_global_data_import VALUES (29938, '2020-12-05', 'PF', 'French Polynesia', 'WPRO', '210', '15107', '1', '79');
INSERT INTO public.who_global_data_import VALUES (29939, '2020-12-06', 'PF', 'French Polynesia', 'WPRO', '0', '15107', '0', '79');
INSERT INTO public.who_global_data_import VALUES (29940, '2020-12-07', 'PF', 'French Polynesia', 'WPRO', '0', '15107', '0', '79');
INSERT INTO public.who_global_data_import VALUES (29941, '2020-12-08', 'PF', 'French Polynesia', 'WPRO', '0', '15107', '0', '79');
INSERT INTO public.who_global_data_import VALUES (29942, '2020-12-09', 'PF', 'French Polynesia', 'WPRO', '225', '15332', '7', '86');
INSERT INTO public.who_global_data_import VALUES (29943, '2020-12-10', 'PF', 'French Polynesia', 'WPRO', '79', '15411', '4', '90');
INSERT INTO public.who_global_data_import VALUES (29944, '2020-12-11', 'PF', 'French Polynesia', 'WPRO', '124', '15535', '1', '91');
INSERT INTO public.who_global_data_import VALUES (29945, '2020-12-12', 'PF', 'French Polynesia', 'WPRO', '83', '15618', '0', '91');
INSERT INTO public.who_global_data_import VALUES (29946, '2020-12-13', 'PF', 'French Polynesia', 'WPRO', '0', '15618', '0', '91');
INSERT INTO public.who_global_data_import VALUES (29947, '2020-12-14', 'PF', 'French Polynesia', 'WPRO', '0', '15618', '0', '91');
INSERT INTO public.who_global_data_import VALUES (29948, '2020-12-15', 'PF', 'French Polynesia', 'WPRO', '129', '15747', '5', '96');
INSERT INTO public.who_global_data_import VALUES (29949, '2020-12-16', 'PF', 'French Polynesia', 'WPRO', '123', '15870', '1', '97');
INSERT INTO public.who_global_data_import VALUES (29950, '2020-12-17', 'PF', 'French Polynesia', 'WPRO', '104', '15974', '1', '98');
INSERT INTO public.who_global_data_import VALUES (29951, '2020-12-18', 'PF', 'French Polynesia', 'WPRO', '144', '16118', '3', '101');
INSERT INTO public.who_global_data_import VALUES (29952, '2020-12-19', 'PF', 'French Polynesia', 'WPRO', '64', '16182', '2', '103');
INSERT INTO public.who_global_data_import VALUES (29953, '2020-12-20', 'PF', 'French Polynesia', 'WPRO', '0', '16182', '0', '103');
INSERT INTO public.who_global_data_import VALUES (29954, '2020-12-21', 'PF', 'French Polynesia', 'WPRO', '0', '16182', '0', '103');
INSERT INTO public.who_global_data_import VALUES (29955, '2020-12-22', 'PF', 'French Polynesia', 'WPRO', '163', '16345', '3', '106');
INSERT INTO public.who_global_data_import VALUES (29956, '2020-12-23', 'PF', 'French Polynesia', 'WPRO', '65', '16410', '0', '106');
INSERT INTO public.who_global_data_import VALUES (29957, '2020-12-24', 'PF', 'French Polynesia', 'WPRO', '56', '16466', '1', '107');
INSERT INTO public.who_global_data_import VALUES (29958, '2020-12-25', 'PF', 'French Polynesia', 'WPRO', '84', '16550', '1', '108');
INSERT INTO public.who_global_data_import VALUES (29959, '2020-12-26', 'PF', 'French Polynesia', 'WPRO', '0', '16550', '0', '108');
INSERT INTO public.who_global_data_import VALUES (29960, '2020-12-27', 'PF', 'French Polynesia', 'WPRO', '0', '16550', '0', '108');
INSERT INTO public.who_global_data_import VALUES (29961, '2020-12-28', 'PF', 'French Polynesia', 'WPRO', '0', '16550', '0', '108');
INSERT INTO public.who_global_data_import VALUES (29962, '2020-12-29', 'PF', 'French Polynesia', 'WPRO', '146', '16696', '5', '113');
INSERT INTO public.who_global_data_import VALUES (29963, '2020-12-30', 'PF', 'French Polynesia', 'WPRO', '99', '16795', '0', '113');
INSERT INTO public.who_global_data_import VALUES (29964, '2020-12-31', 'PF', 'French Polynesia', 'WPRO', '56', '16851', '1', '114');
INSERT INTO public.who_global_data_import VALUES (29965, '2021-01-01', 'PF', 'French Polynesia', 'WPRO', '75', '16926', '0', '114');
INSERT INTO public.who_global_data_import VALUES (29966, '2021-01-02', 'PF', 'French Polynesia', 'WPRO', '0', '16926', '0', '114');
INSERT INTO public.who_global_data_import VALUES (29967, '2021-01-03', 'PF', 'French Polynesia', 'WPRO', '0', '16926', '0', '114');
INSERT INTO public.who_global_data_import VALUES (29968, '2021-01-04', 'PF', 'French Polynesia', 'WPRO', '0', '16926', '0', '114');
INSERT INTO public.who_global_data_import VALUES (29969, '2021-01-05', 'PF', 'French Polynesia', 'WPRO', '62', '16988', '7', '121');
INSERT INTO public.who_global_data_import VALUES (29970, '2021-01-06', 'PF', 'French Polynesia', 'WPRO', '100', '17088', '0', '121');
INSERT INTO public.who_global_data_import VALUES (29971, '2021-01-07', 'PF', 'French Polynesia', 'WPRO', '43', '17131', '0', '121');
INSERT INTO public.who_global_data_import VALUES (29972, '2021-01-08', 'PF', 'French Polynesia', 'WPRO', '64', '17195', '0', '121');
INSERT INTO public.who_global_data_import VALUES (29973, '2021-01-09', 'PF', 'French Polynesia', 'WPRO', '46', '17241', '1', '122');
INSERT INTO public.who_global_data_import VALUES (29974, '2021-01-10', 'PF', 'French Polynesia', 'WPRO', '0', '17241', '0', '122');
INSERT INTO public.who_global_data_import VALUES (29975, '2021-01-11', 'PF', 'French Polynesia', 'WPRO', '0', '17241', '0', '122');
INSERT INTO public.who_global_data_import VALUES (29976, '2021-01-12', 'PF', 'French Polynesia', 'WPRO', '99', '17340', '2', '124');
INSERT INTO public.who_global_data_import VALUES (29977, '2021-01-13', 'PF', 'French Polynesia', 'WPRO', '63', '17403', '0', '124');
INSERT INTO public.who_global_data_import VALUES (29978, '2021-01-14', 'PF', 'French Polynesia', 'WPRO', '80', '17483', '0', '124');
INSERT INTO public.who_global_data_import VALUES (29979, '2021-01-15', 'PF', 'French Polynesia', 'WPRO', '107', '17590', '2', '126');
INSERT INTO public.who_global_data_import VALUES (29980, '2021-01-16', 'PF', 'French Polynesia', 'WPRO', '45', '17635', '0', '126');
INSERT INTO public.who_global_data_import VALUES (29981, '2021-01-17', 'PF', 'French Polynesia', 'WPRO', '0', '17635', '0', '126');
INSERT INTO public.who_global_data_import VALUES (29982, '2021-01-18', 'PF', 'French Polynesia', 'WPRO', '0', '17635', '0', '126');
INSERT INTO public.who_global_data_import VALUES (29983, '2021-01-19', 'PF', 'French Polynesia', 'WPRO', '62', '17697', '1', '127');
INSERT INTO public.who_global_data_import VALUES (29984, '2021-01-20', 'PF', 'French Polynesia', 'WPRO', '0', '17697', '0', '127');
INSERT INTO public.who_global_data_import VALUES (29985, '2021-01-21', 'PF', 'French Polynesia', 'WPRO', '111', '17808', '1', '128');
INSERT INTO public.who_global_data_import VALUES (29986, '2021-01-22', 'PF', 'French Polynesia', 'WPRO', '12', '17820', '0', '128');
INSERT INTO public.who_global_data_import VALUES (29987, '2021-01-23', 'PF', 'French Polynesia', 'WPRO', '32', '17852', '0', '128');
INSERT INTO public.who_global_data_import VALUES (29988, '2021-01-24', 'PF', 'French Polynesia', 'WPRO', '0', '17852', '0', '128');
INSERT INTO public.who_global_data_import VALUES (29989, '2021-01-25', 'PF', 'French Polynesia', 'WPRO', '0', '17852', '0', '128');
INSERT INTO public.who_global_data_import VALUES (29990, '2021-01-26', 'PF', 'French Polynesia', 'WPRO', '60', '17912', '1', '129');
INSERT INTO public.who_global_data_import VALUES (29991, '2021-01-27', 'PF', 'French Polynesia', 'WPRO', '49', '17961', '2', '131');
INSERT INTO public.who_global_data_import VALUES (29992, '2021-01-28', 'PF', 'French Polynesia', 'WPRO', '35', '17996', '0', '131');
INSERT INTO public.who_global_data_import VALUES (29993, '2021-01-29', 'PF', 'French Polynesia', 'WPRO', '37', '18033', '0', '131');
INSERT INTO public.who_global_data_import VALUES (29994, '2021-01-30', 'PF', 'French Polynesia', 'WPRO', '27', '18060', '0', '131');
INSERT INTO public.who_global_data_import VALUES (29995, '2021-01-31', 'PF', 'French Polynesia', 'WPRO', '0', '18060', '0', '131');
INSERT INTO public.who_global_data_import VALUES (29996, '2021-02-01', 'PF', 'French Polynesia', 'WPRO', '0', '18060', '0', '131');
INSERT INTO public.who_global_data_import VALUES (29997, '2021-02-02', 'PF', 'French Polynesia', 'WPRO', '41', '18101', '1', '132');
INSERT INTO public.who_global_data_import VALUES (29998, '2021-02-03', 'PF', 'French Polynesia', 'WPRO', '20', '18121', '1', '133');
INSERT INTO public.who_global_data_import VALUES (29999, '2021-02-04', 'PF', 'French Polynesia', 'WPRO', '24', '18145', '0', '133');
INSERT INTO public.who_global_data_import VALUES (30000, '2021-02-05', 'PF', 'French Polynesia', 'WPRO', '20', '18165', '0', '133');
INSERT INTO public.who_global_data_import VALUES (30001, '2020-01-03', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30002, '2020-01-04', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30003, '2020-01-05', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30004, '2020-01-06', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30005, '2020-01-07', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30006, '2020-01-08', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30007, '2020-01-09', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30008, '2020-01-10', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30009, '2020-01-11', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30010, '2020-01-12', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30011, '2020-01-13', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30012, '2020-01-14', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30013, '2020-01-15', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30014, '2020-01-16', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30015, '2020-01-17', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30016, '2020-01-18', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30017, '2020-01-19', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30018, '2020-01-20', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30019, '2020-01-21', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30020, '2020-01-22', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30021, '2020-01-23', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30022, '2020-01-24', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30023, '2020-01-25', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30024, '2020-01-26', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30025, '2020-01-27', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30026, '2020-01-28', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30027, '2020-01-29', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30028, '2020-01-30', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30029, '2020-01-31', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30030, '2020-02-01', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30031, '2020-02-02', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30032, '2020-02-03', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30033, '2020-02-04', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30034, '2020-02-05', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30035, '2020-02-06', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30036, '2020-02-07', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30037, '2020-02-08', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30038, '2020-02-09', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30039, '2020-02-10', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30040, '2020-02-11', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30041, '2020-02-12', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30042, '2020-02-13', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30043, '2020-02-14', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30044, '2020-02-15', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30045, '2020-02-16', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30046, '2020-02-17', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30047, '2020-02-18', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30048, '2020-02-19', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30049, '2020-02-20', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30050, '2020-02-21', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30051, '2020-02-22', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30052, '2020-02-23', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30053, '2020-02-24', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30054, '2020-02-25', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30055, '2020-02-26', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30056, '2020-02-27', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30057, '2020-02-28', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30058, '2020-02-29', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30059, '2020-03-01', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30060, '2020-03-02', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30061, '2020-03-03', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30062, '2020-03-04', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30063, '2020-03-05', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30064, '2020-03-06', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30065, '2020-03-07', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30066, '2020-03-08', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30067, '2020-03-09', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30068, '2020-03-10', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30069, '2020-03-11', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30070, '2020-03-12', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30071, '2020-03-13', 'GA', 'Gabon', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30072, '2020-03-14', 'GA', 'Gabon', 'AFRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30073, '2020-03-15', 'GA', 'Gabon', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30074, '2020-03-16', 'GA', 'Gabon', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30075, '2020-03-17', 'GA', 'Gabon', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30076, '2020-03-18', 'GA', 'Gabon', 'AFRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30077, '2020-03-19', 'GA', 'Gabon', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30078, '2020-03-20', 'GA', 'Gabon', 'AFRO', '1', '3', '1', '1');
INSERT INTO public.who_global_data_import VALUES (30079, '2020-03-21', 'GA', 'Gabon', 'AFRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30080, '2020-03-22', 'GA', 'Gabon', 'AFRO', '3', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30081, '2020-03-23', 'GA', 'Gabon', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30082, '2020-03-24', 'GA', 'Gabon', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30083, '2020-03-25', 'GA', 'Gabon', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30084, '2020-03-26', 'GA', 'Gabon', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30085, '2020-03-27', 'GA', 'Gabon', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30086, '2020-03-28', 'GA', 'Gabon', 'AFRO', '1', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30087, '2020-03-29', 'GA', 'Gabon', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30088, '2020-03-30', 'GA', 'Gabon', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30089, '2020-03-31', 'GA', 'Gabon', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30090, '2020-04-01', 'GA', 'Gabon', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30091, '2020-04-02', 'GA', 'Gabon', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30092, '2020-04-03', 'GA', 'Gabon', 'AFRO', '11', '18', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30093, '2020-04-04', 'GA', 'Gabon', 'AFRO', '3', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30094, '2020-04-05', 'GA', 'Gabon', 'AFRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30095, '2020-04-06', 'GA', 'Gabon', 'AFRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30096, '2020-04-07', 'GA', 'Gabon', 'AFRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30097, '2020-04-08', 'GA', 'Gabon', 'AFRO', '3', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30098, '2020-04-09', 'GA', 'Gabon', 'AFRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30099, '2020-04-10', 'GA', 'Gabon', 'AFRO', '20', '44', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30100, '2020-04-11', 'GA', 'Gabon', 'AFRO', '0', '44', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30101, '2020-04-12', 'GA', 'Gabon', 'AFRO', '5', '49', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30102, '2020-04-13', 'GA', 'Gabon', 'AFRO', '8', '57', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30103, '2020-04-14', 'GA', 'Gabon', 'AFRO', '0', '57', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30104, '2020-04-15', 'GA', 'Gabon', 'AFRO', '23', '80', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30105, '2020-04-16', 'GA', 'Gabon', 'AFRO', '7', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30106, '2020-04-17', 'GA', 'Gabon', 'AFRO', '8', '95', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30107, '2020-04-18', 'GA', 'Gabon', 'AFRO', '0', '95', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30108, '2020-04-19', 'GA', 'Gabon', 'AFRO', '13', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30109, '2020-04-20', 'GA', 'Gabon', 'AFRO', '1', '109', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30110, '2020-04-21', 'GA', 'Gabon', 'AFRO', '11', '120', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30111, '2020-04-22', 'GA', 'Gabon', 'AFRO', '36', '156', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30112, '2020-04-23', 'GA', 'Gabon', 'AFRO', '10', '166', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30113, '2020-04-24', 'GA', 'Gabon', 'AFRO', '0', '166', '1', '2');
INSERT INTO public.who_global_data_import VALUES (30114, '2020-04-25', 'GA', 'Gabon', 'AFRO', '6', '172', '1', '3');
INSERT INTO public.who_global_data_import VALUES (30115, '2020-04-26', 'GA', 'Gabon', 'AFRO', '4', '176', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30116, '2020-04-27', 'GA', 'Gabon', 'AFRO', '0', '176', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30117, '2020-04-28', 'GA', 'Gabon', 'AFRO', '0', '176', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30118, '2020-04-29', 'GA', 'Gabon', 'AFRO', '62', '238', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30119, '2020-04-30', 'GA', 'Gabon', 'AFRO', '38', '276', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30120, '2020-05-01', 'GA', 'Gabon', 'AFRO', '0', '276', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30121, '2020-05-02', 'GA', 'Gabon', 'AFRO', '32', '308', '1', '4');
INSERT INTO public.who_global_data_import VALUES (30122, '2020-05-03', 'GA', 'Gabon', 'AFRO', '27', '335', '1', '5');
INSERT INTO public.who_global_data_import VALUES (30123, '2020-05-04', 'GA', 'Gabon', 'AFRO', '0', '335', '0', '5');
INSERT INTO public.who_global_data_import VALUES (30124, '2020-05-05', 'GA', 'Gabon', 'AFRO', '32', '367', '1', '6');
INSERT INTO public.who_global_data_import VALUES (30125, '2020-05-06', 'GA', 'Gabon', 'AFRO', '30', '397', '0', '6');
INSERT INTO public.who_global_data_import VALUES (30126, '2020-05-07', 'GA', 'Gabon', 'AFRO', '0', '397', '0', '6');
INSERT INTO public.who_global_data_import VALUES (30127, '2020-05-08', 'GA', 'Gabon', 'AFRO', '107', '504', '2', '8');
INSERT INTO public.who_global_data_import VALUES (30128, '2020-05-09', 'GA', 'Gabon', 'AFRO', '116', '620', '0', '8');
INSERT INTO public.who_global_data_import VALUES (30129, '2020-05-10', 'GA', 'Gabon', 'AFRO', '41', '661', '0', '8');
INSERT INTO public.who_global_data_import VALUES (30130, '2020-05-11', 'GA', 'Gabon', 'AFRO', '0', '661', '0', '8');
INSERT INTO public.who_global_data_import VALUES (30131, '2020-05-12', 'GA', 'Gabon', 'AFRO', '141', '802', '1', '9');
INSERT INTO public.who_global_data_import VALUES (30132, '2020-05-13', 'GA', 'Gabon', 'AFRO', '61', '863', '0', '9');
INSERT INTO public.who_global_data_import VALUES (30133, '2020-05-14', 'GA', 'Gabon', 'AFRO', '141', '1004', '0', '9');
INSERT INTO public.who_global_data_import VALUES (30134, '2020-05-15', 'GA', 'Gabon', 'AFRO', '100', '1104', '1', '10');
INSERT INTO public.who_global_data_import VALUES (30135, '2020-05-16', 'GA', 'Gabon', 'AFRO', '105', '1209', '0', '10');
INSERT INTO public.who_global_data_import VALUES (30136, '2020-05-17', 'GA', 'Gabon', 'AFRO', '111', '1320', '1', '11');
INSERT INTO public.who_global_data_import VALUES (30137, '2020-05-18', 'GA', 'Gabon', 'AFRO', '0', '1320', '0', '11');
INSERT INTO public.who_global_data_import VALUES (30138, '2020-05-19', 'GA', 'Gabon', 'AFRO', '112', '1432', '0', '11');
INSERT INTO public.who_global_data_import VALUES (30139, '2020-05-20', 'GA', 'Gabon', 'AFRO', '70', '1502', '1', '12');
INSERT INTO public.who_global_data_import VALUES (30140, '2020-05-21', 'GA', 'Gabon', 'AFRO', '65', '1567', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30141, '2020-05-22', 'GA', 'Gabon', 'AFRO', '0', '1567', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30142, '2020-05-23', 'GA', 'Gabon', 'AFRO', '161', '1728', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30143, '2020-05-24', 'GA', 'Gabon', 'AFRO', '206', '1934', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30144, '2020-05-25', 'GA', 'Gabon', 'AFRO', '0', '1934', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30145, '2020-05-26', 'GA', 'Gabon', 'AFRO', '201', '2135', '2', '14');
INSERT INTO public.who_global_data_import VALUES (30146, '2020-05-27', 'GA', 'Gabon', 'AFRO', '103', '2238', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30147, '2020-05-28', 'GA', 'Gabon', 'AFRO', '81', '2319', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30148, '2020-05-29', 'GA', 'Gabon', 'AFRO', '112', '2431', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30149, '2020-05-30', 'GA', 'Gabon', 'AFRO', '182', '2613', '1', '15');
INSERT INTO public.who_global_data_import VALUES (30150, '2020-05-31', 'GA', 'Gabon', 'AFRO', '0', '2613', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30151, '2020-06-01', 'GA', 'Gabon', 'AFRO', '42', '2655', '2', '17');
INSERT INTO public.who_global_data_import VALUES (30152, '2020-06-02', 'GA', 'Gabon', 'AFRO', '0', '2655', '0', '17');
INSERT INTO public.who_global_data_import VALUES (30153, '2020-06-03', 'GA', 'Gabon', 'AFRO', '148', '2803', '3', '20');
INSERT INTO public.who_global_data_import VALUES (30154, '2020-06-04', 'GA', 'Gabon', 'AFRO', '99', '2902', '0', '20');
INSERT INTO public.who_global_data_import VALUES (30155, '2020-06-05', 'GA', 'Gabon', 'AFRO', '53', '2955', '1', '21');
INSERT INTO public.who_global_data_import VALUES (30156, '2020-06-06', 'GA', 'Gabon', 'AFRO', '146', '3101', '0', '21');
INSERT INTO public.who_global_data_import VALUES (30157, '2020-06-07', 'GA', 'Gabon', 'AFRO', '0', '3101', '0', '21');
INSERT INTO public.who_global_data_import VALUES (30158, '2020-06-08', 'GA', 'Gabon', 'AFRO', '0', '3101', '0', '21');
INSERT INTO public.who_global_data_import VALUES (30159, '2020-06-09', 'GA', 'Gabon', 'AFRO', '0', '3101', '0', '21');
INSERT INTO public.who_global_data_import VALUES (30160, '2020-06-10', 'GA', 'Gabon', 'AFRO', '193', '3294', '0', '21');
INSERT INTO public.who_global_data_import VALUES (30161, '2020-06-11', 'GA', 'Gabon', 'AFRO', '0', '3294', '0', '21');
INSERT INTO public.who_global_data_import VALUES (30162, '2020-06-12', 'GA', 'Gabon', 'AFRO', '169', '3463', '2', '23');
INSERT INTO public.who_global_data_import VALUES (30163, '2020-06-13', 'GA', 'Gabon', 'AFRO', '0', '3463', '0', '23');
INSERT INTO public.who_global_data_import VALUES (30164, '2020-06-14', 'GA', 'Gabon', 'AFRO', '0', '3463', '0', '23');
INSERT INTO public.who_global_data_import VALUES (30165, '2020-06-15', 'GA', 'Gabon', 'AFRO', '0', '3463', '0', '23');
INSERT INTO public.who_global_data_import VALUES (30166, '2020-06-16', 'GA', 'Gabon', 'AFRO', '570', '4033', '4', '27');
INSERT INTO public.who_global_data_import VALUES (30167, '2020-06-17', 'GA', 'Gabon', 'AFRO', '81', '4114', '2', '29');
INSERT INTO public.who_global_data_import VALUES (30168, '2020-06-18', 'GA', 'Gabon', 'AFRO', '115', '4229', '1', '30');
INSERT INTO public.who_global_data_import VALUES (30169, '2020-06-19', 'GA', 'Gabon', 'AFRO', '111', '4340', '2', '32');
INSERT INTO public.who_global_data_import VALUES (30170, '2020-06-20', 'GA', 'Gabon', 'AFRO', '0', '4340', '0', '32');
INSERT INTO public.who_global_data_import VALUES (30171, '2020-06-21', 'GA', 'Gabon', 'AFRO', '88', '4428', '2', '34');
INSERT INTO public.who_global_data_import VALUES (30172, '2020-06-22', 'GA', 'Gabon', 'AFRO', '0', '4428', '0', '34');
INSERT INTO public.who_global_data_import VALUES (30173, '2020-06-23', 'GA', 'Gabon', 'AFRO', '311', '4739', '5', '39');
INSERT INTO public.who_global_data_import VALUES (30174, '2020-06-24', 'GA', 'Gabon', 'AFRO', '110', '4849', '0', '39');
INSERT INTO public.who_global_data_import VALUES (30175, '2020-06-25', 'GA', 'Gabon', 'AFRO', '107', '4956', '0', '39');
INSERT INTO public.who_global_data_import VALUES (30176, '2020-06-26', 'GA', 'Gabon', 'AFRO', '131', '5087', '1', '40');
INSERT INTO public.who_global_data_import VALUES (30177, '2020-06-27', 'GA', 'Gabon', 'AFRO', '122', '5209', '0', '40');
INSERT INTO public.who_global_data_import VALUES (30178, '2020-06-28', 'GA', 'Gabon', 'AFRO', '0', '5209', '0', '40');
INSERT INTO public.who_global_data_import VALUES (30179, '2020-06-29', 'GA', 'Gabon', 'AFRO', '0', '5209', '0', '40');
INSERT INTO public.who_global_data_import VALUES (30180, '2020-06-30', 'GA', 'Gabon', 'AFRO', '185', '5394', '2', '42');
INSERT INTO public.who_global_data_import VALUES (30181, '2020-07-01', 'GA', 'Gabon', 'AFRO', '0', '5394', '0', '42');
INSERT INTO public.who_global_data_import VALUES (30182, '2020-07-02', 'GA', 'Gabon', 'AFRO', '0', '5394', '0', '42');
INSERT INTO public.who_global_data_import VALUES (30183, '2020-07-03', 'GA', 'Gabon', 'AFRO', '119', '5513', '0', '42');
INSERT INTO public.who_global_data_import VALUES (30184, '2020-07-04', 'GA', 'Gabon', 'AFRO', '0', '5513', '0', '42');
INSERT INTO public.who_global_data_import VALUES (30185, '2020-07-05', 'GA', 'Gabon', 'AFRO', '107', '5620', '2', '44');
INSERT INTO public.who_global_data_import VALUES (30186, '2020-07-06', 'GA', 'Gabon', 'AFRO', '0', '5620', '0', '44');
INSERT INTO public.who_global_data_import VALUES (30187, '2020-07-07', 'GA', 'Gabon', 'AFRO', '123', '5743', '2', '46');
INSERT INTO public.who_global_data_import VALUES (30188, '2020-07-08', 'GA', 'Gabon', 'AFRO', '0', '5743', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30189, '2020-07-09', 'GA', 'Gabon', 'AFRO', '128', '5871', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30190, '2020-07-10', 'GA', 'Gabon', 'AFRO', '0', '5871', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30191, '2020-07-11', 'GA', 'Gabon', 'AFRO', '71', '5942', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30192, '2020-07-12', 'GA', 'Gabon', 'AFRO', '0', '5942', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30193, '2020-07-13', 'GA', 'Gabon', 'AFRO', '0', '5942', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30194, '2020-07-14', 'GA', 'Gabon', 'AFRO', '0', '5942', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30195, '2020-07-15', 'GA', 'Gabon', 'AFRO', '0', '5942', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30196, '2020-07-16', 'GA', 'Gabon', 'AFRO', '0', '5942', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30197, '2020-07-17', 'GA', 'Gabon', 'AFRO', '179', '6121', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30198, '2020-07-18', 'GA', 'Gabon', 'AFRO', '0', '6121', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30199, '2020-07-19', 'GA', 'Gabon', 'AFRO', '0', '6121', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30200, '2020-07-20', 'GA', 'Gabon', 'AFRO', '0', '6121', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30201, '2020-07-21', 'GA', 'Gabon', 'AFRO', '0', '6121', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30202, '2020-07-22', 'GA', 'Gabon', 'AFRO', '312', '6433', '0', '46');
INSERT INTO public.who_global_data_import VALUES (30203, '2020-07-23', 'GA', 'Gabon', 'AFRO', '155', '6588', '1', '47');
INSERT INTO public.who_global_data_import VALUES (30204, '2020-07-24', 'GA', 'Gabon', 'AFRO', '0', '6588', '0', '47');
INSERT INTO public.who_global_data_import VALUES (30205, '2020-07-25', 'GA', 'Gabon', 'AFRO', '396', '6984', '2', '49');
INSERT INTO public.who_global_data_import VALUES (30206, '2020-07-26', 'GA', 'Gabon', 'AFRO', '0', '6984', '0', '49');
INSERT INTO public.who_global_data_import VALUES (30207, '2020-07-27', 'GA', 'Gabon', 'AFRO', '0', '6984', '0', '49');
INSERT INTO public.who_global_data_import VALUES (30208, '2020-07-28', 'GA', 'Gabon', 'AFRO', '205', '7189', '0', '49');
INSERT INTO public.who_global_data_import VALUES (30209, '2020-07-29', 'GA', 'Gabon', 'AFRO', '0', '7189', '0', '49');
INSERT INTO public.who_global_data_import VALUES (30210, '2020-07-30', 'GA', 'Gabon', 'AFRO', '163', '7352', '0', '49');
INSERT INTO public.who_global_data_import VALUES (30211, '2020-07-31', 'GA', 'Gabon', 'AFRO', '0', '7352', '0', '49');
INSERT INTO public.who_global_data_import VALUES (30212, '2020-08-01', 'GA', 'Gabon', 'AFRO', '0', '7352', '0', '49');
INSERT INTO public.who_global_data_import VALUES (30213, '2020-08-02', 'GA', 'Gabon', 'AFRO', '179', '7531', '1', '50');
INSERT INTO public.who_global_data_import VALUES (30214, '2020-08-03', 'GA', 'Gabon', 'AFRO', '0', '7531', '0', '50');
INSERT INTO public.who_global_data_import VALUES (30215, '2020-08-04', 'GA', 'Gabon', 'AFRO', '115', '7646', '1', '51');
INSERT INTO public.who_global_data_import VALUES (30216, '2020-08-05', 'GA', 'Gabon', 'AFRO', '0', '7646', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30217, '2020-08-06', 'GA', 'Gabon', 'AFRO', '141', '7787', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30218, '2020-08-07', 'GA', 'Gabon', 'AFRO', '0', '7787', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30219, '2020-08-08', 'GA', 'Gabon', 'AFRO', '136', '7923', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30220, '2020-08-09', 'GA', 'Gabon', 'AFRO', '0', '7923', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30221, '2020-08-10', 'GA', 'Gabon', 'AFRO', '0', '7923', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30222, '2020-08-11', 'GA', 'Gabon', 'AFRO', '83', '8006', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30223, '2020-08-12', 'GA', 'Gabon', 'AFRO', '0', '8006', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30224, '2020-08-13', 'GA', 'Gabon', 'AFRO', '71', '8077', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30225, '2020-08-14', 'GA', 'Gabon', 'AFRO', '0', '8077', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30226, '2020-08-15', 'GA', 'Gabon', 'AFRO', '148', '8225', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30227, '2020-08-16', 'GA', 'Gabon', 'AFRO', '0', '8225', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30228, '2020-08-17', 'GA', 'Gabon', 'AFRO', '0', '8225', '0', '51');
INSERT INTO public.who_global_data_import VALUES (30229, '2020-08-18', 'GA', 'Gabon', 'AFRO', '45', '8270', '2', '53');
INSERT INTO public.who_global_data_import VALUES (30230, '2020-08-19', 'GA', 'Gabon', 'AFRO', '0', '8270', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30231, '2020-08-20', 'GA', 'Gabon', 'AFRO', '49', '8319', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30232, '2020-08-21', 'GA', 'Gabon', 'AFRO', '0', '8319', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30233, '2020-08-22', 'GA', 'Gabon', 'AFRO', '69', '8388', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30234, '2020-08-23', 'GA', 'Gabon', 'AFRO', '0', '8388', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30235, '2020-08-24', 'GA', 'Gabon', 'AFRO', '0', '8388', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30236, '2020-08-25', 'GA', 'Gabon', 'AFRO', '21', '8409', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30237, '2020-08-26', 'GA', 'Gabon', 'AFRO', '0', '8409', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30238, '2020-08-27', 'GA', 'Gabon', 'AFRO', '59', '8468', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30239, '2020-08-28', 'GA', 'Gabon', 'AFRO', '0', '8468', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30240, '2020-08-29', 'GA', 'Gabon', 'AFRO', '0', '8468', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30241, '2020-08-30', 'GA', 'Gabon', 'AFRO', '37', '8505', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30242, '2020-08-31', 'GA', 'Gabon', 'AFRO', '0', '8505', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30243, '2020-09-01', 'GA', 'Gabon', 'AFRO', '28', '8533', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30244, '2020-09-02', 'GA', 'Gabon', 'AFRO', '0', '8533', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30245, '2020-09-03', 'GA', 'Gabon', 'AFRO', '5', '8538', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30246, '2020-09-04', 'GA', 'Gabon', 'AFRO', '0', '8538', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30247, '2020-09-05', 'GA', 'Gabon', 'AFRO', '63', '8601', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30248, '2020-09-06', 'GA', 'Gabon', 'AFRO', '0', '8601', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30249, '2020-09-07', 'GA', 'Gabon', 'AFRO', '0', '8601', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30250, '2020-09-08', 'GA', 'Gabon', 'AFRO', '7', '8608', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30251, '2020-09-09', 'GA', 'Gabon', 'AFRO', '0', '8608', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30252, '2020-09-10', 'GA', 'Gabon', 'AFRO', '13', '8621', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30253, '2020-09-11', 'GA', 'Gabon', 'AFRO', '0', '8621', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30254, '2020-09-12', 'GA', 'Gabon', 'AFRO', '22', '8643', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30255, '2020-09-13', 'GA', 'Gabon', 'AFRO', '0', '8643', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30256, '2020-09-14', 'GA', 'Gabon', 'AFRO', '0', '8643', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30257, '2020-09-15', 'GA', 'Gabon', 'AFRO', '11', '8654', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30258, '2020-09-16', 'GA', 'Gabon', 'AFRO', '0', '8654', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30259, '2020-09-17', 'GA', 'Gabon', 'AFRO', '24', '8678', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30260, '2020-09-18', 'GA', 'Gabon', 'AFRO', '0', '8678', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30261, '2020-09-19', 'GA', 'Gabon', 'AFRO', '18', '8696', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30262, '2020-09-20', 'GA', 'Gabon', 'AFRO', '0', '8696', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30263, '2020-09-21', 'GA', 'Gabon', 'AFRO', '0', '8696', '0', '53');
INSERT INTO public.who_global_data_import VALUES (30264, '2020-09-22', 'GA', 'Gabon', 'AFRO', '8', '8704', '1', '54');
INSERT INTO public.who_global_data_import VALUES (30265, '2020-09-23', 'GA', 'Gabon', 'AFRO', '0', '8704', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30266, '2020-09-24', 'GA', 'Gabon', 'AFRO', '12', '8716', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30267, '2020-09-25', 'GA', 'Gabon', 'AFRO', '0', '8716', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30268, '2020-09-26', 'GA', 'Gabon', 'AFRO', '12', '8728', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30269, '2020-09-27', 'GA', 'Gabon', 'AFRO', '0', '8728', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30270, '2020-09-28', 'GA', 'Gabon', 'AFRO', '0', '8728', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30271, '2020-09-29', 'GA', 'Gabon', 'AFRO', '24', '8752', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30272, '2020-09-30', 'GA', 'Gabon', 'AFRO', '0', '8752', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30273, '2020-10-01', 'GA', 'Gabon', 'AFRO', '14', '8766', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30274, '2020-10-02', 'GA', 'Gabon', 'AFRO', '0', '8766', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30275, '2020-10-03', 'GA', 'Gabon', 'AFRO', '31', '8797', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30276, '2020-10-04', 'GA', 'Gabon', 'AFRO', '0', '8797', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30277, '2020-10-05', 'GA', 'Gabon', 'AFRO', '0', '8797', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30278, '2020-10-06', 'GA', 'Gabon', 'AFRO', '11', '8808', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30279, '2020-10-07', 'GA', 'Gabon', 'AFRO', '0', '8808', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30280, '2020-10-08', 'GA', 'Gabon', 'AFRO', '7', '8815', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30281, '2020-10-09', 'GA', 'Gabon', 'AFRO', '0', '8815', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30282, '2020-10-10', 'GA', 'Gabon', 'AFRO', '0', '8815', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30283, '2020-10-11', 'GA', 'Gabon', 'AFRO', '0', '8815', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30284, '2020-10-12', 'GA', 'Gabon', 'AFRO', '0', '8815', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30285, '2020-10-13', 'GA', 'Gabon', 'AFRO', '45', '8860', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30286, '2020-10-14', 'GA', 'Gabon', 'AFRO', '0', '8860', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30287, '2020-10-15', 'GA', 'Gabon', 'AFRO', '9', '8869', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30288, '2020-10-16', 'GA', 'Gabon', 'AFRO', '0', '8869', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30289, '2020-10-17', 'GA', 'Gabon', 'AFRO', '12', '8881', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30290, '2020-10-18', 'GA', 'Gabon', 'AFRO', '0', '8881', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30291, '2020-10-19', 'GA', 'Gabon', 'AFRO', '0', '8881', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30292, '2020-10-20', 'GA', 'Gabon', 'AFRO', '3', '8884', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30293, '2020-10-21', 'GA', 'Gabon', 'AFRO', '0', '8884', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30294, '2020-10-22', 'GA', 'Gabon', 'AFRO', '17', '8901', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30295, '2020-10-23', 'GA', 'Gabon', 'AFRO', '0', '8901', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30296, '2020-10-24', 'GA', 'Gabon', 'AFRO', '18', '8919', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30297, '2020-10-25', 'GA', 'Gabon', 'AFRO', '0', '8919', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30298, '2020-10-26', 'GA', 'Gabon', 'AFRO', '0', '8919', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30299, '2020-10-27', 'GA', 'Gabon', 'AFRO', '18', '8937', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30300, '2020-10-28', 'GA', 'Gabon', 'AFRO', '0', '8937', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30301, '2020-10-29', 'GA', 'Gabon', 'AFRO', '20', '8957', '1', '55');
INSERT INTO public.who_global_data_import VALUES (30302, '2020-10-30', 'GA', 'Gabon', 'AFRO', '0', '8957', '0', '55');
INSERT INTO public.who_global_data_import VALUES (30303, '2020-10-31', 'GA', 'Gabon', 'AFRO', '0', '8957', '0', '55');
INSERT INTO public.who_global_data_import VALUES (30304, '2020-11-01', 'GA', 'Gabon', 'AFRO', '11', '8968', '0', '55');
INSERT INTO public.who_global_data_import VALUES (30305, '2020-11-02', 'GA', 'Gabon', 'AFRO', '0', '8968', '0', '55');
INSERT INTO public.who_global_data_import VALUES (30306, '2020-11-03', 'GA', 'Gabon', 'AFRO', '16', '8984', '0', '55');
INSERT INTO public.who_global_data_import VALUES (30307, '2020-11-04', 'GA', 'Gabon', 'AFRO', '0', '8984', '0', '55');
INSERT INTO public.who_global_data_import VALUES (30308, '2020-11-05', 'GA', 'Gabon', 'AFRO', '21', '9005', '0', '55');
INSERT INTO public.who_global_data_import VALUES (30309, '2020-11-06', 'GA', 'Gabon', 'AFRO', '0', '9005', '0', '55');
INSERT INTO public.who_global_data_import VALUES (30310, '2020-11-07', 'GA', 'Gabon', 'AFRO', '17', '9022', '0', '55');
INSERT INTO public.who_global_data_import VALUES (30311, '2020-11-08', 'GA', 'Gabon', 'AFRO', '0', '9022', '0', '55');
INSERT INTO public.who_global_data_import VALUES (30312, '2020-11-09', 'GA', 'Gabon', 'AFRO', '0', '9022', '0', '55');
INSERT INTO public.who_global_data_import VALUES (30313, '2020-11-10', 'GA', 'Gabon', 'AFRO', '7', '9029', '2', '57');
INSERT INTO public.who_global_data_import VALUES (30314, '2020-11-11', 'GA', 'Gabon', 'AFRO', '0', '9029', '0', '57');
INSERT INTO public.who_global_data_import VALUES (30315, '2020-11-12', 'GA', 'Gabon', 'AFRO', '19', '9048', '0', '57');
INSERT INTO public.who_global_data_import VALUES (30316, '2020-11-13', 'GA', 'Gabon', 'AFRO', '0', '9048', '0', '57');
INSERT INTO public.who_global_data_import VALUES (30317, '2020-11-14', 'GA', 'Gabon', 'AFRO', '14', '9062', '1', '58');
INSERT INTO public.who_global_data_import VALUES (30318, '2020-11-15', 'GA', 'Gabon', 'AFRO', '0', '9062', '0', '58');
INSERT INTO public.who_global_data_import VALUES (30319, '2020-11-16', 'GA', 'Gabon', 'AFRO', '0', '9062', '0', '58');
INSERT INTO public.who_global_data_import VALUES (30320, '2020-11-17', 'GA', 'Gabon', 'AFRO', '0', '9062', '0', '58');
INSERT INTO public.who_global_data_import VALUES (30321, '2020-11-18', 'GA', 'Gabon', 'AFRO', '0', '9062', '0', '58');
INSERT INTO public.who_global_data_import VALUES (30322, '2020-11-19', 'GA', 'Gabon', 'AFRO', '0', '9062', '0', '58');
INSERT INTO public.who_global_data_import VALUES (30323, '2020-11-20', 'GA', 'Gabon', 'AFRO', '54', '9116', '1', '59');
INSERT INTO public.who_global_data_import VALUES (30324, '2020-11-21', 'GA', 'Gabon', 'AFRO', '15', '9131', '0', '59');
INSERT INTO public.who_global_data_import VALUES (30325, '2020-11-22', 'GA', 'Gabon', 'AFRO', '0', '9131', '0', '59');
INSERT INTO public.who_global_data_import VALUES (30326, '2020-11-23', 'GA', 'Gabon', 'AFRO', '0', '9131', '0', '59');
INSERT INTO public.who_global_data_import VALUES (30327, '2020-11-24', 'GA', 'Gabon', 'AFRO', '19', '9150', '0', '59');
INSERT INTO public.who_global_data_import VALUES (30328, '2020-11-25', 'GA', 'Gabon', 'AFRO', '0', '9150', '0', '59');
INSERT INTO public.who_global_data_import VALUES (30329, '2020-11-26', 'GA', 'Gabon', 'AFRO', '23', '9173', '0', '59');
INSERT INTO public.who_global_data_import VALUES (30330, '2020-11-27', 'GA', 'Gabon', 'AFRO', '0', '9173', '0', '59');
INSERT INTO public.who_global_data_import VALUES (30331, '2020-11-28', 'GA', 'Gabon', 'AFRO', '18', '9191', '0', '59');
INSERT INTO public.who_global_data_import VALUES (30332, '2020-11-29', 'GA', 'Gabon', 'AFRO', '0', '9191', '0', '59');
INSERT INTO public.who_global_data_import VALUES (30333, '2020-11-30', 'GA', 'Gabon', 'AFRO', '0', '9191', '0', '59');
INSERT INTO public.who_global_data_import VALUES (30334, '2020-12-01', 'GA', 'Gabon', 'AFRO', '0', '9191', '0', '59');
INSERT INTO public.who_global_data_import VALUES (30335, '2020-12-02', 'GA', 'Gabon', 'AFRO', '0', '9191', '0', '59');
INSERT INTO public.who_global_data_import VALUES (30336, '2020-12-03', 'GA', 'Gabon', 'AFRO', '48', '9239', '1', '60');
INSERT INTO public.who_global_data_import VALUES (30337, '2020-12-04', 'GA', 'Gabon', 'AFRO', '0', '9239', '0', '60');
INSERT INTO public.who_global_data_import VALUES (30338, '2020-12-05', 'GA', 'Gabon', 'AFRO', '15', '9254', '0', '60');
INSERT INTO public.who_global_data_import VALUES (30339, '2020-12-06', 'GA', 'Gabon', 'AFRO', '0', '9254', '0', '60');
INSERT INTO public.who_global_data_import VALUES (30340, '2020-12-07', 'GA', 'Gabon', 'AFRO', '0', '9254', '0', '60');
INSERT INTO public.who_global_data_import VALUES (30341, '2020-12-08', 'GA', 'Gabon', 'AFRO', '24', '9278', '0', '60');
INSERT INTO public.who_global_data_import VALUES (30342, '2020-12-09', 'GA', 'Gabon', 'AFRO', '0', '9278', '0', '60');
INSERT INTO public.who_global_data_import VALUES (30343, '2020-12-10', 'GA', 'Gabon', 'AFRO', '22', '9300', '2', '62');
INSERT INTO public.who_global_data_import VALUES (30344, '2020-12-11', 'GA', 'Gabon', 'AFRO', '0', '9300', '0', '62');
INSERT INTO public.who_global_data_import VALUES (30345, '2020-12-12', 'GA', 'Gabon', 'AFRO', '30', '9330', '1', '63');
INSERT INTO public.who_global_data_import VALUES (30346, '2020-12-13', 'GA', 'Gabon', 'AFRO', '0', '9330', '0', '63');
INSERT INTO public.who_global_data_import VALUES (30347, '2020-12-14', 'GA', 'Gabon', 'AFRO', '0', '9330', '0', '63');
INSERT INTO public.who_global_data_import VALUES (30348, '2020-12-15', 'GA', 'Gabon', 'AFRO', '21', '9351', '0', '63');
INSERT INTO public.who_global_data_import VALUES (30349, '2020-12-16', 'GA', 'Gabon', 'AFRO', '0', '9351', '0', '63');
INSERT INTO public.who_global_data_import VALUES (30350, '2020-12-17', 'GA', 'Gabon', 'AFRO', '22', '9373', '0', '63');
INSERT INTO public.who_global_data_import VALUES (30351, '2020-12-18', 'GA', 'Gabon', 'AFRO', '0', '9373', '0', '63');
INSERT INTO public.who_global_data_import VALUES (30352, '2020-12-19', 'GA', 'Gabon', 'AFRO', '27', '9400', '1', '64');
INSERT INTO public.who_global_data_import VALUES (30353, '2020-12-20', 'GA', 'Gabon', 'AFRO', '0', '9400', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30354, '2020-12-21', 'GA', 'Gabon', 'AFRO', '0', '9400', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30355, '2020-12-22', 'GA', 'Gabon', 'AFRO', '20', '9420', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30356, '2020-12-23', 'GA', 'Gabon', 'AFRO', '0', '9420', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30357, '2020-12-24', 'GA', 'Gabon', 'AFRO', '49', '9469', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30358, '2020-12-25', 'GA', 'Gabon', 'AFRO', '0', '9469', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30359, '2020-12-26', 'GA', 'Gabon', 'AFRO', '0', '9469', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30360, '2020-12-27', 'GA', 'Gabon', 'AFRO', '28', '9497', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30361, '2020-12-28', 'GA', 'Gabon', 'AFRO', '0', '9497', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30362, '2020-12-29', 'GA', 'Gabon', 'AFRO', '13', '9510', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30363, '2020-12-30', 'GA', 'Gabon', 'AFRO', '0', '9510', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30364, '2020-12-31', 'GA', 'Gabon', 'AFRO', '61', '9571', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30365, '2021-01-01', 'GA', 'Gabon', 'AFRO', '0', '9571', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30366, '2021-01-02', 'GA', 'Gabon', 'AFRO', '0', '9571', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30367, '2021-01-03', 'GA', 'Gabon', 'AFRO', '0', '9571', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30368, '2021-01-04', 'GA', 'Gabon', 'AFRO', '0', '9571', '0', '64');
INSERT INTO public.who_global_data_import VALUES (30369, '2021-01-05', 'GA', 'Gabon', 'AFRO', '34', '9605', '2', '66');
INSERT INTO public.who_global_data_import VALUES (30370, '2021-01-06', 'GA', 'Gabon', 'AFRO', '0', '9605', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30371, '2021-01-07', 'GA', 'Gabon', 'AFRO', '36', '9641', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30372, '2021-01-08', 'GA', 'Gabon', 'AFRO', '0', '9641', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30373, '2021-01-09', 'GA', 'Gabon', 'AFRO', '53', '9694', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30374, '2021-01-10', 'GA', 'Gabon', 'AFRO', '0', '9694', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30375, '2021-01-11', 'GA', 'Gabon', 'AFRO', '0', '9694', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30376, '2021-01-12', 'GA', 'Gabon', 'AFRO', '46', '9740', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30377, '2021-01-13', 'GA', 'Gabon', 'AFRO', '0', '9740', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30378, '2021-01-14', 'GA', 'Gabon', 'AFRO', '79', '9819', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30379, '2021-01-15', 'GA', 'Gabon', 'AFRO', '0', '9819', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30380, '2021-01-16', 'GA', 'Gabon', 'AFRO', '0', '9819', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30381, '2021-01-17', 'GA', 'Gabon', 'AFRO', '80', '9899', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30382, '2021-01-18', 'GA', 'Gabon', 'AFRO', '0', '9899', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30383, '2021-01-19', 'GA', 'Gabon', 'AFRO', '120', '10019', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30384, '2021-01-20', 'GA', 'Gabon', 'AFRO', '0', '10019', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30385, '2021-01-21', 'GA', 'Gabon', 'AFRO', '101', '10120', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30386, '2021-01-22', 'GA', 'Gabon', 'AFRO', '0', '10120', '0', '66');
INSERT INTO public.who_global_data_import VALUES (30387, '2021-01-23', 'GA', 'Gabon', 'AFRO', '158', '10278', '1', '67');
INSERT INTO public.who_global_data_import VALUES (30388, '2021-01-24', 'GA', 'Gabon', 'AFRO', '0', '10278', '0', '67');
INSERT INTO public.who_global_data_import VALUES (30389, '2021-01-25', 'GA', 'Gabon', 'AFRO', '0', '10278', '0', '67');
INSERT INTO public.who_global_data_import VALUES (30390, '2021-01-26', 'GA', 'Gabon', 'AFRO', '133', '10411', '0', '67');
INSERT INTO public.who_global_data_import VALUES (30391, '2021-01-27', 'GA', 'Gabon', 'AFRO', '0', '10411', '0', '67');
INSERT INTO public.who_global_data_import VALUES (30392, '2021-01-28', 'GA', 'Gabon', 'AFRO', '125', '10536', '1', '68');
INSERT INTO public.who_global_data_import VALUES (30393, '2021-01-29', 'GA', 'Gabon', 'AFRO', '0', '10536', '0', '68');
INSERT INTO public.who_global_data_import VALUES (30394, '2021-01-30', 'GA', 'Gabon', 'AFRO', '212', '10748', '0', '68');
INSERT INTO public.who_global_data_import VALUES (30395, '2021-01-31', 'GA', 'Gabon', 'AFRO', '0', '10748', '0', '68');
INSERT INTO public.who_global_data_import VALUES (30396, '2021-02-01', 'GA', 'Gabon', 'AFRO', '0', '10748', '0', '68');
INSERT INTO public.who_global_data_import VALUES (30397, '2021-02-02', 'GA', 'Gabon', 'AFRO', '204', '10952', '0', '68');
INSERT INTO public.who_global_data_import VALUES (30398, '2021-02-03', 'GA', 'Gabon', 'AFRO', '0', '10952', '0', '68');
INSERT INTO public.who_global_data_import VALUES (30399, '2021-02-04', 'GA', 'Gabon', 'AFRO', '177', '11129', '2', '70');
INSERT INTO public.who_global_data_import VALUES (30400, '2021-02-05', 'GA', 'Gabon', 'AFRO', '0', '11129', '0', '70');
INSERT INTO public.who_global_data_import VALUES (30401, '2020-01-03', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30402, '2020-01-04', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30403, '2020-01-05', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30404, '2020-01-06', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30405, '2020-01-07', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30406, '2020-01-08', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30407, '2020-01-09', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30408, '2020-01-10', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30409, '2020-01-11', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30410, '2020-01-12', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30411, '2020-01-13', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30412, '2020-01-14', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30413, '2020-01-15', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30414, '2020-01-16', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30415, '2020-01-17', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30416, '2020-01-18', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30417, '2020-01-19', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30418, '2020-01-20', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30419, '2020-01-21', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30420, '2020-01-22', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30421, '2020-01-23', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30422, '2020-01-24', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30423, '2020-01-25', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30424, '2020-01-26', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30425, '2020-01-27', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30426, '2020-01-28', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30427, '2020-01-29', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30428, '2020-01-30', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30429, '2020-01-31', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30430, '2020-02-01', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30431, '2020-02-02', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30432, '2020-02-03', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30433, '2020-02-04', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30434, '2020-02-05', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30435, '2020-02-06', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30436, '2020-02-07', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30437, '2020-02-08', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30438, '2020-02-09', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30439, '2020-02-10', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30440, '2020-02-11', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30441, '2020-02-12', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30442, '2020-02-13', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30443, '2020-02-14', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30444, '2020-02-15', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30445, '2020-02-16', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30446, '2020-02-17', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30447, '2020-02-18', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30448, '2020-02-19', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30449, '2020-02-20', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30450, '2020-02-21', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30451, '2020-02-22', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30452, '2020-02-23', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30453, '2020-02-24', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30454, '2020-02-25', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30455, '2020-02-26', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30456, '2020-02-27', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30457, '2020-02-28', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30458, '2020-02-29', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30459, '2020-03-01', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30460, '2020-03-02', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30461, '2020-03-03', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30462, '2020-03-04', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30463, '2020-03-05', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30464, '2020-03-06', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30465, '2020-03-07', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30466, '2020-03-08', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30467, '2020-03-09', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30468, '2020-03-10', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30469, '2020-03-11', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30470, '2020-03-12', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30471, '2020-03-13', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30472, '2020-03-14', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30473, '2020-03-15', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30474, '2020-03-16', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30475, '2020-03-17', 'GM', 'Gambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30476, '2020-03-18', 'GM', 'Gambia', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30477, '2020-03-19', 'GM', 'Gambia', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30478, '2020-03-20', 'GM', 'Gambia', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30479, '2020-03-21', 'GM', 'Gambia', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30480, '2020-03-22', 'GM', 'Gambia', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30481, '2020-03-23', 'GM', 'Gambia', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30482, '2020-03-24', 'GM', 'Gambia', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30483, '2020-03-25', 'GM', 'Gambia', 'AFRO', '-3', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30484, '2020-03-26', 'GM', 'Gambia', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30485, '2020-03-27', 'GM', 'Gambia', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30486, '2020-03-28', 'GM', 'Gambia', 'AFRO', '0', '2', '1', '1');
INSERT INTO public.who_global_data_import VALUES (30487, '2020-03-29', 'GM', 'Gambia', 'AFRO', '1', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30488, '2020-03-30', 'GM', 'Gambia', 'AFRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30489, '2020-03-31', 'GM', 'Gambia', 'AFRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30490, '2020-04-01', 'GM', 'Gambia', 'AFRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30491, '2020-04-02', 'GM', 'Gambia', 'AFRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30492, '2020-04-03', 'GM', 'Gambia', 'AFRO', '1', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30493, '2020-04-04', 'GM', 'Gambia', 'AFRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30494, '2020-04-05', 'GM', 'Gambia', 'AFRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30495, '2020-04-06', 'GM', 'Gambia', 'AFRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30496, '2020-04-07', 'GM', 'Gambia', 'AFRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30497, '2020-04-08', 'GM', 'Gambia', 'AFRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30498, '2020-04-09', 'GM', 'Gambia', 'AFRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30499, '2020-04-10', 'GM', 'Gambia', 'AFRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30500, '2020-04-11', 'GM', 'Gambia', 'AFRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30501, '2020-04-12', 'GM', 'Gambia', 'AFRO', '5', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30502, '2020-04-13', 'GM', 'Gambia', 'AFRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30503, '2020-04-14', 'GM', 'Gambia', 'AFRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30504, '2020-04-15', 'GM', 'Gambia', 'AFRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30505, '2020-04-16', 'GM', 'Gambia', 'AFRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30506, '2020-04-17', 'GM', 'Gambia', 'AFRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30507, '2020-04-18', 'GM', 'Gambia', 'AFRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30508, '2020-04-19', 'GM', 'Gambia', 'AFRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30509, '2020-04-20', 'GM', 'Gambia', 'AFRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30510, '2020-04-21', 'GM', 'Gambia', 'AFRO', '1', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30511, '2020-04-22', 'GM', 'Gambia', 'AFRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30512, '2020-04-23', 'GM', 'Gambia', 'AFRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30513, '2020-04-24', 'GM', 'Gambia', 'AFRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30514, '2020-04-25', 'GM', 'Gambia', 'AFRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30515, '2020-04-26', 'GM', 'Gambia', 'AFRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30516, '2020-04-27', 'GM', 'Gambia', 'AFRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30517, '2020-04-28', 'GM', 'Gambia', 'AFRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30518, '2020-04-29', 'GM', 'Gambia', 'AFRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30519, '2020-04-30', 'GM', 'Gambia', 'AFRO', '1', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30520, '2020-05-01', 'GM', 'Gambia', 'AFRO', '1', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30521, '2020-05-02', 'GM', 'Gambia', 'AFRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30522, '2020-05-03', 'GM', 'Gambia', 'AFRO', '5', '17', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30523, '2020-05-04', 'GM', 'Gambia', 'AFRO', '0', '17', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30524, '2020-05-05', 'GM', 'Gambia', 'AFRO', '0', '17', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30525, '2020-05-06', 'GM', 'Gambia', 'AFRO', '0', '17', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30526, '2020-05-07', 'GM', 'Gambia', 'AFRO', '0', '17', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30527, '2020-05-08', 'GM', 'Gambia', 'AFRO', '1', '18', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30528, '2020-05-09', 'GM', 'Gambia', 'AFRO', '2', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30529, '2020-05-10', 'GM', 'Gambia', 'AFRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30530, '2020-05-11', 'GM', 'Gambia', 'AFRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30531, '2020-05-12', 'GM', 'Gambia', 'AFRO', '2', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30532, '2020-05-13', 'GM', 'Gambia', 'AFRO', '1', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30533, '2020-05-14', 'GM', 'Gambia', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30534, '2020-05-15', 'GM', 'Gambia', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30535, '2020-05-16', 'GM', 'Gambia', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30536, '2020-05-17', 'GM', 'Gambia', 'AFRO', '0', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30537, '2020-05-18', 'GM', 'Gambia', 'AFRO', '1', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30538, '2020-05-19', 'GM', 'Gambia', 'AFRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30539, '2020-05-20', 'GM', 'Gambia', 'AFRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30540, '2020-05-21', 'GM', 'Gambia', 'AFRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30541, '2020-05-22', 'GM', 'Gambia', 'AFRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30542, '2020-05-23', 'GM', 'Gambia', 'AFRO', '1', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30543, '2020-05-24', 'GM', 'Gambia', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30544, '2020-05-25', 'GM', 'Gambia', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30545, '2020-05-26', 'GM', 'Gambia', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30546, '2020-05-27', 'GM', 'Gambia', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30547, '2020-05-28', 'GM', 'Gambia', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30548, '2020-05-29', 'GM', 'Gambia', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30549, '2020-05-30', 'GM', 'Gambia', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30550, '2020-05-31', 'GM', 'Gambia', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30551, '2020-06-01', 'GM', 'Gambia', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30552, '2020-06-02', 'GM', 'Gambia', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30553, '2020-06-03', 'GM', 'Gambia', 'AFRO', '1', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30554, '2020-06-04', 'GM', 'Gambia', 'AFRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30555, '2020-06-05', 'GM', 'Gambia', 'AFRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30556, '2020-06-06', 'GM', 'Gambia', 'AFRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30557, '2020-06-07', 'GM', 'Gambia', 'AFRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30558, '2020-06-08', 'GM', 'Gambia', 'AFRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30559, '2020-06-09', 'GM', 'Gambia', 'AFRO', '2', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30560, '2020-06-10', 'GM', 'Gambia', 'AFRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30561, '2020-06-11', 'GM', 'Gambia', 'AFRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30562, '2020-06-12', 'GM', 'Gambia', 'AFRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30563, '2020-06-13', 'GM', 'Gambia', 'AFRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30564, '2020-06-14', 'GM', 'Gambia', 'AFRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30565, '2020-06-15', 'GM', 'Gambia', 'AFRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30566, '2020-06-16', 'GM', 'Gambia', 'AFRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30567, '2020-06-17', 'GM', 'Gambia', 'AFRO', '6', '34', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30568, '2020-06-18', 'GM', 'Gambia', 'AFRO', '0', '34', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30569, '2020-06-19', 'GM', 'Gambia', 'AFRO', '2', '36', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30570, '2020-06-20', 'GM', 'Gambia', 'AFRO', '0', '36', '0', '1');
INSERT INTO public.who_global_data_import VALUES (30571, '2020-06-21', 'GM', 'Gambia', 'AFRO', '1', '37', '1', '2');
INSERT INTO public.who_global_data_import VALUES (30572, '2020-06-22', 'GM', 'Gambia', 'AFRO', '0', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30573, '2020-06-23', 'GM', 'Gambia', 'AFRO', '4', '41', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30574, '2020-06-24', 'GM', 'Gambia', 'AFRO', '1', '42', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30575, '2020-06-25', 'GM', 'Gambia', 'AFRO', '0', '42', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30576, '2020-06-26', 'GM', 'Gambia', 'AFRO', '1', '43', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30577, '2020-06-27', 'GM', 'Gambia', 'AFRO', '1', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30578, '2020-06-28', 'GM', 'Gambia', 'AFRO', '1', '45', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30579, '2020-06-29', 'GM', 'Gambia', 'AFRO', '0', '45', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30580, '2020-06-30', 'GM', 'Gambia', 'AFRO', '2', '47', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30581, '2020-07-01', 'GM', 'Gambia', 'AFRO', '2', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30582, '2020-07-02', 'GM', 'Gambia', 'AFRO', '0', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30583, '2020-07-03', 'GM', 'Gambia', 'AFRO', '6', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30584, '2020-07-04', 'GM', 'Gambia', 'AFRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30585, '2020-07-05', 'GM', 'Gambia', 'AFRO', '2', '57', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30586, '2020-07-06', 'GM', 'Gambia', 'AFRO', '0', '57', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30587, '2020-07-07', 'GM', 'Gambia', 'AFRO', '4', '61', '1', '3');
INSERT INTO public.who_global_data_import VALUES (30588, '2020-07-08', 'GM', 'Gambia', 'AFRO', '0', '61', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30589, '2020-07-09', 'GM', 'Gambia', 'AFRO', '2', '63', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30590, '2020-07-10', 'GM', 'Gambia', 'AFRO', '1', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30591, '2020-07-11', 'GM', 'Gambia', 'AFRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30592, '2020-07-12', 'GM', 'Gambia', 'AFRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30593, '2020-07-13', 'GM', 'Gambia', 'AFRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30594, '2020-07-14', 'GM', 'Gambia', 'AFRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30595, '2020-07-15', 'GM', 'Gambia', 'AFRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30596, '2020-07-16', 'GM', 'Gambia', 'AFRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30597, '2020-07-17', 'GM', 'Gambia', 'AFRO', '14', '78', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30598, '2020-07-18', 'GM', 'Gambia', 'AFRO', '15', '93', '1', '4');
INSERT INTO public.who_global_data_import VALUES (30599, '2020-07-19', 'GM', 'Gambia', 'AFRO', '0', '93', '0', '4');
INSERT INTO public.who_global_data_import VALUES (30600, '2020-07-20', 'GM', 'Gambia', 'AFRO', '0', '93', '0', '4');
INSERT INTO public.who_global_data_import VALUES (30601, '2020-07-21', 'GM', 'Gambia', 'AFRO', '19', '112', '0', '4');
INSERT INTO public.who_global_data_import VALUES (30602, '2020-07-22', 'GM', 'Gambia', 'AFRO', '20', '132', '1', '5');
INSERT INTO public.who_global_data_import VALUES (30603, '2020-07-23', 'GM', 'Gambia', 'AFRO', '0', '132', '0', '5');
INSERT INTO public.who_global_data_import VALUES (30604, '2020-07-24', 'GM', 'Gambia', 'AFRO', '38', '170', '0', '5');
INSERT INTO public.who_global_data_import VALUES (30605, '2020-07-25', 'GM', 'Gambia', 'AFRO', '0', '170', '0', '5');
INSERT INTO public.who_global_data_import VALUES (30606, '2020-07-26', 'GM', 'Gambia', 'AFRO', '46', '216', '1', '6');
INSERT INTO public.who_global_data_import VALUES (30607, '2020-07-27', 'GM', 'Gambia', 'AFRO', '61', '277', '0', '6');
INSERT INTO public.who_global_data_import VALUES (30608, '2020-07-28', 'GM', 'Gambia', 'AFRO', '49', '326', '2', '8');
INSERT INTO public.who_global_data_import VALUES (30609, '2020-07-29', 'GM', 'Gambia', 'AFRO', '0', '326', '0', '8');
INSERT INTO public.who_global_data_import VALUES (30610, '2020-07-30', 'GM', 'Gambia', 'AFRO', '0', '326', '0', '8');
INSERT INTO public.who_global_data_import VALUES (30611, '2020-07-31', 'GM', 'Gambia', 'AFRO', '77', '403', '0', '8');
INSERT INTO public.who_global_data_import VALUES (30612, '2020-08-01', 'GM', 'Gambia', 'AFRO', '95', '498', '1', '9');
INSERT INTO public.who_global_data_import VALUES (30613, '2020-08-02', 'GM', 'Gambia', 'AFRO', '0', '498', '0', '9');
INSERT INTO public.who_global_data_import VALUES (30614, '2020-08-03', 'GM', 'Gambia', 'AFRO', '0', '498', '0', '9');
INSERT INTO public.who_global_data_import VALUES (30615, '2020-08-04', 'GM', 'Gambia', 'AFRO', '0', '498', '0', '9');
INSERT INTO public.who_global_data_import VALUES (30616, '2020-08-05', 'GM', 'Gambia', 'AFRO', '301', '799', '7', '16');
INSERT INTO public.who_global_data_import VALUES (30617, '2020-08-06', 'GM', 'Gambia', 'AFRO', '136', '935', '0', '16');
INSERT INTO public.who_global_data_import VALUES (30618, '2020-08-07', 'GM', 'Gambia', 'AFRO', '0', '935', '0', '16');
INSERT INTO public.who_global_data_import VALUES (30619, '2020-08-08', 'GM', 'Gambia', 'AFRO', '155', '1090', '3', '19');
INSERT INTO public.who_global_data_import VALUES (30620, '2020-08-09', 'GM', 'Gambia', 'AFRO', '0', '1090', '0', '19');
INSERT INTO public.who_global_data_import VALUES (30621, '2020-08-10', 'GM', 'Gambia', 'AFRO', '145', '1235', '4', '23');
INSERT INTO public.who_global_data_import VALUES (30622, '2020-08-11', 'GM', 'Gambia', 'AFRO', '0', '1235', '0', '23');
INSERT INTO public.who_global_data_import VALUES (30623, '2020-08-12', 'GM', 'Gambia', 'AFRO', '242', '1477', '10', '33');
INSERT INTO public.who_global_data_import VALUES (30624, '2020-08-13', 'GM', 'Gambia', 'AFRO', '0', '1477', '0', '33');
INSERT INTO public.who_global_data_import VALUES (30625, '2020-08-14', 'GM', 'Gambia', 'AFRO', '79', '1556', '10', '43');
INSERT INTO public.who_global_data_import VALUES (30626, '2020-08-15', 'GM', 'Gambia', 'AFRO', '133', '1689', '11', '54');
INSERT INTO public.who_global_data_import VALUES (30627, '2020-08-16', 'GM', 'Gambia', 'AFRO', '0', '1689', '0', '54');
INSERT INTO public.who_global_data_import VALUES (30628, '2020-08-17', 'GM', 'Gambia', 'AFRO', '183', '1872', '9', '63');
INSERT INTO public.who_global_data_import VALUES (30629, '2020-08-18', 'GM', 'Gambia', 'AFRO', '0', '1872', '0', '63');
INSERT INTO public.who_global_data_import VALUES (30630, '2020-08-19', 'GM', 'Gambia', 'AFRO', '244', '2116', '0', '63');
INSERT INTO public.who_global_data_import VALUES (30631, '2020-08-20', 'GM', 'Gambia', 'AFRO', '172', '2288', '14', '77');
INSERT INTO public.who_global_data_import VALUES (30632, '2020-08-21', 'GM', 'Gambia', 'AFRO', '113', '2401', '4', '81');
INSERT INTO public.who_global_data_import VALUES (30633, '2020-08-22', 'GM', 'Gambia', 'AFRO', '36', '2437', '3', '84');
INSERT INTO public.who_global_data_import VALUES (30634, '2020-08-23', 'GM', 'Gambia', 'AFRO', '0', '2437', '0', '84');
INSERT INTO public.who_global_data_import VALUES (30635, '2020-08-24', 'GM', 'Gambia', 'AFRO', '148', '2585', '3', '87');
INSERT INTO public.who_global_data_import VALUES (30636, '2020-08-25', 'GM', 'Gambia', 'AFRO', '0', '2585', '0', '87');
INSERT INTO public.who_global_data_import VALUES (30637, '2020-08-26', 'GM', 'Gambia', 'AFRO', '101', '2686', '3', '90');
INSERT INTO public.who_global_data_import VALUES (30638, '2020-08-27', 'GM', 'Gambia', 'AFRO', '22', '2708', '3', '93');
INSERT INTO public.who_global_data_import VALUES (30639, '2020-08-28', 'GM', 'Gambia', 'AFRO', '35', '2743', '0', '93');
INSERT INTO public.who_global_data_import VALUES (30640, '2020-08-29', 'GM', 'Gambia', 'AFRO', '54', '2797', '3', '96');
INSERT INTO public.who_global_data_import VALUES (30641, '2020-08-30', 'GM', 'Gambia', 'AFRO', '0', '2797', '0', '96');
INSERT INTO public.who_global_data_import VALUES (30642, '2020-08-31', 'GM', 'Gambia', 'AFRO', '0', '2797', '0', '96');
INSERT INTO public.who_global_data_import VALUES (30643, '2020-09-01', 'GM', 'Gambia', 'AFRO', '166', '2963', '0', '96');
INSERT INTO public.who_global_data_import VALUES (30644, '2020-09-02', 'GM', 'Gambia', 'AFRO', '66', '3029', '0', '96');
INSERT INTO public.who_global_data_import VALUES (30645, '2020-09-03', 'GM', 'Gambia', 'AFRO', '38', '3067', '1', '97');
INSERT INTO public.who_global_data_import VALUES (30646, '2020-09-04', 'GM', 'Gambia', 'AFRO', '34', '3101', '2', '99');
INSERT INTO public.who_global_data_import VALUES (30647, '2020-09-05', 'GM', 'Gambia', 'AFRO', '19', '3120', '0', '99');
INSERT INTO public.who_global_data_import VALUES (30648, '2020-09-06', 'GM', 'Gambia', 'AFRO', '0', '3120', '0', '99');
INSERT INTO public.who_global_data_import VALUES (30649, '2020-09-07', 'GM', 'Gambia', 'AFRO', '76', '3196', '0', '99');
INSERT INTO public.who_global_data_import VALUES (30650, '2020-09-08', 'GM', 'Gambia', 'AFRO', '0', '3196', '0', '99');
INSERT INTO public.who_global_data_import VALUES (30651, '2020-09-09', 'GM', 'Gambia', 'AFRO', '79', '3275', '0', '99');
INSERT INTO public.who_global_data_import VALUES (30652, '2020-09-10', 'GM', 'Gambia', 'AFRO', '18', '3293', '0', '99');
INSERT INTO public.who_global_data_import VALUES (30653, '2020-09-11', 'GM', 'Gambia', 'AFRO', '37', '3330', '1', '100');
INSERT INTO public.who_global_data_import VALUES (30654, '2020-09-12', 'GM', 'Gambia', 'AFRO', '32', '3362', '0', '100');
INSERT INTO public.who_global_data_import VALUES (30655, '2020-09-13', 'GM', 'Gambia', 'AFRO', '14', '3376', '2', '102');
INSERT INTO public.who_global_data_import VALUES (30656, '2020-09-14', 'GM', 'Gambia', 'AFRO', '29', '3405', '1', '103');
INSERT INTO public.who_global_data_import VALUES (30657, '2020-09-15', 'GM', 'Gambia', 'AFRO', '0', '3405', '0', '103');
INSERT INTO public.who_global_data_import VALUES (30658, '2020-09-16', 'GM', 'Gambia', 'AFRO', '35', '3440', '4', '107');
INSERT INTO public.who_global_data_import VALUES (30659, '2020-09-17', 'GM', 'Gambia', 'AFRO', '33', '3473', '0', '107');
INSERT INTO public.who_global_data_import VALUES (30660, '2020-09-18', 'GM', 'Gambia', 'AFRO', '12', '3485', '1', '108');
INSERT INTO public.who_global_data_import VALUES (30661, '2020-09-19', 'GM', 'Gambia', 'AFRO', '19', '3504', '0', '108');
INSERT INTO public.who_global_data_import VALUES (30662, '2020-09-20', 'GM', 'Gambia', 'AFRO', '0', '3504', '0', '108');
INSERT INTO public.who_global_data_import VALUES (30663, '2020-09-21', 'GM', 'Gambia', 'AFRO', '22', '3526', '0', '108');
INSERT INTO public.who_global_data_import VALUES (30664, '2020-09-22', 'GM', 'Gambia', 'AFRO', '14', '3540', '2', '110');
INSERT INTO public.who_global_data_import VALUES (30665, '2020-09-23', 'GM', 'Gambia', 'AFRO', '0', '3540', '0', '110');
INSERT INTO public.who_global_data_import VALUES (30666, '2020-09-24', 'GM', 'Gambia', 'AFRO', '12', '3552', '0', '110');
INSERT INTO public.who_global_data_import VALUES (30667, '2020-09-25', 'GM', 'Gambia', 'AFRO', '0', '3552', '0', '110');
INSERT INTO public.who_global_data_import VALUES (30668, '2020-09-26', 'GM', 'Gambia', 'AFRO', '3', '3555', '0', '110');
INSERT INTO public.who_global_data_import VALUES (30669, '2020-09-27', 'GM', 'Gambia', 'AFRO', '9', '3564', '0', '110');
INSERT INTO public.who_global_data_import VALUES (30670, '2020-09-28', 'GM', 'Gambia', 'AFRO', '5', '3569', '1', '111');
INSERT INTO public.who_global_data_import VALUES (30671, '2020-09-29', 'GM', 'Gambia', 'AFRO', '10', '3579', '1', '112');
INSERT INTO public.who_global_data_import VALUES (30672, '2020-09-30', 'GM', 'Gambia', 'AFRO', '0', '3579', '0', '112');
INSERT INTO public.who_global_data_import VALUES (30673, '2020-10-01', 'GM', 'Gambia', 'AFRO', '0', '3579', '0', '112');
INSERT INTO public.who_global_data_import VALUES (30674, '2020-10-02', 'GM', 'Gambia', 'AFRO', '5', '3584', '1', '113');
INSERT INTO public.who_global_data_import VALUES (30675, '2020-10-03', 'GM', 'Gambia', 'AFRO', '6', '3590', '2', '115');
INSERT INTO public.who_global_data_import VALUES (30676, '2020-10-04', 'GM', 'Gambia', 'AFRO', '0', '3590', '0', '115');
INSERT INTO public.who_global_data_import VALUES (30677, '2020-10-05', 'GM', 'Gambia', 'AFRO', '4', '3594', '0', '115');
INSERT INTO public.who_global_data_import VALUES (30678, '2020-10-06', 'GM', 'Gambia', 'AFRO', '0', '3594', '0', '115');
INSERT INTO public.who_global_data_import VALUES (30679, '2020-10-07', 'GM', 'Gambia', 'AFRO', '19', '3613', '2', '117');
INSERT INTO public.who_global_data_import VALUES (30680, '2020-10-08', 'GM', 'Gambia', 'AFRO', '0', '3613', '0', '117');
INSERT INTO public.who_global_data_import VALUES (30681, '2020-10-09', 'GM', 'Gambia', 'AFRO', '8', '3621', '0', '117');
INSERT INTO public.who_global_data_import VALUES (30682, '2020-10-10', 'GM', 'Gambia', 'AFRO', '7', '3628', '0', '117');
INSERT INTO public.who_global_data_import VALUES (30683, '2020-10-11', 'GM', 'Gambia', 'AFRO', '0', '3628', '0', '117');
INSERT INTO public.who_global_data_import VALUES (30684, '2020-10-12', 'GM', 'Gambia', 'AFRO', '0', '3628', '0', '117');
INSERT INTO public.who_global_data_import VALUES (30685, '2020-10-13', 'GM', 'Gambia', 'AFRO', '4', '3632', '0', '117');
INSERT INTO public.who_global_data_import VALUES (30686, '2020-10-14', 'GM', 'Gambia', 'AFRO', '4', '3636', '1', '118');
INSERT INTO public.who_global_data_import VALUES (30687, '2020-10-15', 'GM', 'Gambia', 'AFRO', '8', '3644', '0', '118');
INSERT INTO public.who_global_data_import VALUES (30688, '2020-10-16', 'GM', 'Gambia', 'AFRO', '0', '3644', '0', '118');
INSERT INTO public.who_global_data_import VALUES (30689, '2020-10-17', 'GM', 'Gambia', 'AFRO', '0', '3644', '0', '118');
INSERT INTO public.who_global_data_import VALUES (30690, '2020-10-18', 'GM', 'Gambia', 'AFRO', '5', '3649', '0', '118');
INSERT INTO public.who_global_data_import VALUES (30691, '2020-10-19', 'GM', 'Gambia', 'AFRO', '0', '3649', '0', '118');
INSERT INTO public.who_global_data_import VALUES (30692, '2020-10-20', 'GM', 'Gambia', 'AFRO', '6', '3655', '0', '118');
INSERT INTO public.who_global_data_import VALUES (30693, '2020-10-21', 'GM', 'Gambia', 'AFRO', '0', '3655', '0', '118');
INSERT INTO public.who_global_data_import VALUES (30694, '2020-10-22', 'GM', 'Gambia', 'AFRO', '2', '3657', '0', '118');
INSERT INTO public.who_global_data_import VALUES (30695, '2020-10-23', 'GM', 'Gambia', 'AFRO', '2', '3659', '1', '119');
INSERT INTO public.who_global_data_import VALUES (30696, '2020-10-24', 'GM', 'Gambia', 'AFRO', '0', '3659', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30697, '2020-10-25', 'GM', 'Gambia', 'AFRO', '0', '3659', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30698, '2020-10-26', 'GM', 'Gambia', 'AFRO', '1', '3660', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30699, '2020-10-27', 'GM', 'Gambia', 'AFRO', '0', '3660', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30700, '2020-10-28', 'GM', 'Gambia', 'AFRO', '6', '3666', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30701, '2020-10-29', 'GM', 'Gambia', 'AFRO', '0', '3666', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30702, '2020-10-30', 'GM', 'Gambia', 'AFRO', '0', '3666', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30703, '2020-10-31', 'GM', 'Gambia', 'AFRO', '0', '3666', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30704, '2020-11-01', 'GM', 'Gambia', 'AFRO', '4', '3670', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30705, '2020-11-02', 'GM', 'Gambia', 'AFRO', '2', '3672', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30706, '2020-11-03', 'GM', 'Gambia', 'AFRO', '0', '3672', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30707, '2020-11-04', 'GM', 'Gambia', 'AFRO', '7', '3679', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30708, '2020-11-05', 'GM', 'Gambia', 'AFRO', '0', '3679', '0', '119');
INSERT INTO public.who_global_data_import VALUES (30709, '2020-11-06', 'GM', 'Gambia', 'AFRO', '1', '3680', '1', '120');
INSERT INTO public.who_global_data_import VALUES (30710, '2020-11-07', 'GM', 'Gambia', 'AFRO', '1', '3681', '0', '120');
INSERT INTO public.who_global_data_import VALUES (30711, '2020-11-08', 'GM', 'Gambia', 'AFRO', '0', '3681', '0', '120');
INSERT INTO public.who_global_data_import VALUES (30712, '2020-11-09', 'GM', 'Gambia', 'AFRO', '3', '3684', '0', '120');
INSERT INTO public.who_global_data_import VALUES (30713, '2020-11-10', 'GM', 'Gambia', 'AFRO', '0', '3684', '1', '121');
INSERT INTO public.who_global_data_import VALUES (30714, '2020-11-11', 'GM', 'Gambia', 'AFRO', '1', '3685', '1', '122');
INSERT INTO public.who_global_data_import VALUES (30715, '2020-11-12', 'GM', 'Gambia', 'AFRO', '12', '3697', '0', '122');
INSERT INTO public.who_global_data_import VALUES (30716, '2020-11-13', 'GM', 'Gambia', 'AFRO', '1', '3698', '0', '122');
INSERT INTO public.who_global_data_import VALUES (30717, '2020-11-14', 'GM', 'Gambia', 'AFRO', '0', '3698', '0', '122');
INSERT INTO public.who_global_data_import VALUES (30718, '2020-11-15', 'GM', 'Gambia', 'AFRO', '4', '3702', '0', '122');
INSERT INTO public.who_global_data_import VALUES (30719, '2020-11-16', 'GM', 'Gambia', 'AFRO', '0', '3702', '0', '122');
INSERT INTO public.who_global_data_import VALUES (30720, '2020-11-17', 'GM', 'Gambia', 'AFRO', '0', '3702', '0', '122');
INSERT INTO public.who_global_data_import VALUES (30721, '2020-11-18', 'GM', 'Gambia', 'AFRO', '3', '3705', '0', '122');
INSERT INTO public.who_global_data_import VALUES (30722, '2020-11-19', 'GM', 'Gambia', 'AFRO', '0', '3705', '0', '122');
INSERT INTO public.who_global_data_import VALUES (30723, '2020-11-20', 'GM', 'Gambia', 'AFRO', '1', '3706', '0', '122');
INSERT INTO public.who_global_data_import VALUES (30724, '2020-11-21', 'GM', 'Gambia', 'AFRO', '10', '3716', '0', '122');
INSERT INTO public.who_global_data_import VALUES (30725, '2020-11-22', 'GM', 'Gambia', 'AFRO', '10', '3726', '1', '123');
INSERT INTO public.who_global_data_import VALUES (30726, '2020-11-23', 'GM', 'Gambia', 'AFRO', '0', '3726', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30727, '2020-11-24', 'GM', 'Gambia', 'AFRO', '0', '3726', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30728, '2020-11-25', 'GM', 'Gambia', 'AFRO', '0', '3726', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30729, '2020-11-26', 'GM', 'Gambia', 'AFRO', '1', '3727', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30730, '2020-11-27', 'GM', 'Gambia', 'AFRO', '1', '3728', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30731, '2020-11-28', 'GM', 'Gambia', 'AFRO', '3', '3731', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30732, '2020-11-29', 'GM', 'Gambia', 'AFRO', '3', '3734', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30733, '2020-11-30', 'GM', 'Gambia', 'AFRO', '0', '3734', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30734, '2020-12-01', 'GM', 'Gambia', 'AFRO', '8', '3742', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30735, '2020-12-02', 'GM', 'Gambia', 'AFRO', '0', '3742', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30736, '2020-12-03', 'GM', 'Gambia', 'AFRO', '22', '3764', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30737, '2020-12-04', 'GM', 'Gambia', 'AFRO', '3', '3767', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30738, '2020-12-05', 'GM', 'Gambia', 'AFRO', '1', '3768', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30739, '2020-12-06', 'GM', 'Gambia', 'AFRO', '2', '3770', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30740, '2020-12-07', 'GM', 'Gambia', 'AFRO', '0', '3770', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30741, '2020-12-08', 'GM', 'Gambia', 'AFRO', '2', '3772', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30742, '2020-12-09', 'GM', 'Gambia', 'AFRO', '4', '3776', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30743, '2020-12-10', 'GM', 'Gambia', 'AFRO', '2', '3778', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30744, '2020-12-11', 'GM', 'Gambia', 'AFRO', '1', '3779', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30745, '2020-12-12', 'GM', 'Gambia', 'AFRO', '1', '3780', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30746, '2020-12-13', 'GM', 'Gambia', 'AFRO', '2', '3782', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30747, '2020-12-14', 'GM', 'Gambia', 'AFRO', '0', '3782', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30748, '2020-12-15', 'GM', 'Gambia', 'AFRO', '3', '3785', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30749, '2020-12-16', 'GM', 'Gambia', 'AFRO', '1', '3786', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30750, '2020-12-17', 'GM', 'Gambia', 'AFRO', '0', '3786', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30751, '2020-12-18', 'GM', 'Gambia', 'AFRO', '0', '3786', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30752, '2020-12-19', 'GM', 'Gambia', 'AFRO', '0', '3786', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30753, '2020-12-20', 'GM', 'Gambia', 'AFRO', '2', '3788', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30754, '2020-12-21', 'GM', 'Gambia', 'AFRO', '0', '3788', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30755, '2020-12-22', 'GM', 'Gambia', 'AFRO', '1', '3789', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30756, '2020-12-23', 'GM', 'Gambia', 'AFRO', '2', '3791', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30757, '2020-12-24', 'GM', 'Gambia', 'AFRO', '0', '3791', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30758, '2020-12-25', 'GM', 'Gambia', 'AFRO', '0', '3791', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30759, '2020-12-26', 'GM', 'Gambia', 'AFRO', '1', '3792', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30760, '2020-12-27', 'GM', 'Gambia', 'AFRO', '0', '3792', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30761, '2020-12-28', 'GM', 'Gambia', 'AFRO', '0', '3792', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30762, '2020-12-29', 'GM', 'Gambia', 'AFRO', '5', '3797', '0', '123');
INSERT INTO public.who_global_data_import VALUES (30763, '2020-12-30', 'GM', 'Gambia', 'AFRO', '0', '3797', '1', '124');
INSERT INTO public.who_global_data_import VALUES (30764, '2020-12-31', 'GM', 'Gambia', 'AFRO', '0', '3797', '0', '124');
INSERT INTO public.who_global_data_import VALUES (30765, '2021-01-01', 'GM', 'Gambia', 'AFRO', '3', '3800', '0', '124');
INSERT INTO public.who_global_data_import VALUES (30766, '2021-01-02', 'GM', 'Gambia', 'AFRO', '0', '3800', '0', '124');
INSERT INTO public.who_global_data_import VALUES (30767, '2021-01-03', 'GM', 'Gambia', 'AFRO', '2', '3802', '0', '124');
INSERT INTO public.who_global_data_import VALUES (30768, '2021-01-04', 'GM', 'Gambia', 'AFRO', '0', '3802', '0', '124');
INSERT INTO public.who_global_data_import VALUES (30769, '2021-01-05', 'GM', 'Gambia', 'AFRO', '4', '3806', '1', '125');
INSERT INTO public.who_global_data_import VALUES (30770, '2021-01-06', 'GM', 'Gambia', 'AFRO', '6', '3812', '0', '125');
INSERT INTO public.who_global_data_import VALUES (30771, '2021-01-07', 'GM', 'Gambia', 'AFRO', '21', '3833', '0', '125');
INSERT INTO public.who_global_data_import VALUES (30772, '2021-01-08', 'GM', 'Gambia', 'AFRO', '5', '3838', '0', '125');
INSERT INTO public.who_global_data_import VALUES (30773, '2021-01-09', 'GM', 'Gambia', 'AFRO', '3', '3841', '0', '125');
INSERT INTO public.who_global_data_import VALUES (30774, '2021-01-10', 'GM', 'Gambia', 'AFRO', '16', '3857', '0', '125');
INSERT INTO public.who_global_data_import VALUES (30775, '2021-01-11', 'GM', 'Gambia', 'AFRO', '0', '3857', '0', '125');
INSERT INTO public.who_global_data_import VALUES (30776, '2021-01-12', 'GM', 'Gambia', 'AFRO', '19', '3876', '0', '125');
INSERT INTO public.who_global_data_import VALUES (30777, '2021-01-13', 'GM', 'Gambia', 'AFRO', '9', '3885', '0', '125');
INSERT INTO public.who_global_data_import VALUES (30778, '2021-01-14', 'GM', 'Gambia', 'AFRO', '5', '3890', '1', '126');
INSERT INTO public.who_global_data_import VALUES (30779, '2021-01-15', 'GM', 'Gambia', 'AFRO', '3', '3893', '1', '127');
INSERT INTO public.who_global_data_import VALUES (30780, '2021-01-16', 'GM', 'Gambia', 'AFRO', '4', '3897', '0', '127');
INSERT INTO public.who_global_data_import VALUES (30781, '2021-01-17', 'GM', 'Gambia', 'AFRO', '0', '3897', '0', '127');
INSERT INTO public.who_global_data_import VALUES (30782, '2021-01-18', 'GM', 'Gambia', 'AFRO', '13', '3910', '0', '127');
INSERT INTO public.who_global_data_import VALUES (30783, '2021-01-19', 'GM', 'Gambia', 'AFRO', '23', '3933', '1', '128');
INSERT INTO public.who_global_data_import VALUES (30784, '2021-01-20', 'GM', 'Gambia', 'AFRO', '5', '3938', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30785, '2021-01-21', 'GM', 'Gambia', 'AFRO', '12', '3950', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30786, '2021-01-22', 'GM', 'Gambia', 'AFRO', '0', '3950', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30787, '2021-01-23', 'GM', 'Gambia', 'AFRO', '0', '3950', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30788, '2021-01-24', 'GM', 'Gambia', 'AFRO', '8', '3958', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30789, '2021-01-25', 'GM', 'Gambia', 'AFRO', '0', '3958', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30790, '2021-01-26', 'GM', 'Gambia', 'AFRO', '50', '4008', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30791, '2021-01-27', 'GM', 'Gambia', 'AFRO', '4', '4012', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30792, '2021-01-28', 'GM', 'Gambia', 'AFRO', '7', '4019', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30793, '2021-01-29', 'GM', 'Gambia', 'AFRO', '0', '4019', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30794, '2021-01-30', 'GM', 'Gambia', 'AFRO', '71', '4090', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30795, '2021-01-31', 'GM', 'Gambia', 'AFRO', '0', '4090', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30796, '2021-02-01', 'GM', 'Gambia', 'AFRO', '0', '4090', '0', '128');
INSERT INTO public.who_global_data_import VALUES (30797, '2021-02-02', 'GM', 'Gambia', 'AFRO', '49', '4139', '3', '131');
INSERT INTO public.who_global_data_import VALUES (30798, '2021-02-03', 'GM', 'Gambia', 'AFRO', '0', '4139', '0', '131');
INSERT INTO public.who_global_data_import VALUES (30799, '2021-02-04', 'GM', 'Gambia', 'AFRO', '45', '4184', '1', '132');
INSERT INTO public.who_global_data_import VALUES (30800, '2021-02-05', 'GM', 'Gambia', 'AFRO', '0', '4184', '0', '132');
INSERT INTO public.who_global_data_import VALUES (30801, '2020-01-03', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30802, '2020-01-04', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30803, '2020-01-05', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30804, '2020-01-06', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30805, '2020-01-07', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30806, '2020-01-08', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30807, '2020-01-09', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30808, '2020-01-10', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30809, '2020-01-11', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30810, '2020-01-12', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30811, '2020-01-13', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30812, '2020-01-14', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30813, '2020-01-15', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30814, '2020-01-16', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30815, '2020-01-17', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30816, '2020-01-18', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30817, '2020-01-19', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30818, '2020-01-20', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30819, '2020-01-21', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30820, '2020-01-22', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30821, '2020-01-23', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30822, '2020-01-24', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30823, '2020-01-25', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30824, '2020-01-26', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30825, '2020-01-27', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30826, '2020-01-28', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30827, '2020-01-29', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30828, '2020-01-30', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30829, '2020-01-31', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30830, '2020-02-01', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30831, '2020-02-02', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30832, '2020-02-03', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30833, '2020-02-04', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30834, '2020-02-05', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30835, '2020-02-06', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30836, '2020-02-07', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30837, '2020-02-08', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30838, '2020-02-09', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30839, '2020-02-10', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30840, '2020-02-11', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30841, '2020-02-12', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30842, '2020-02-13', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30843, '2020-02-14', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30844, '2020-02-15', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30845, '2020-02-16', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30846, '2020-02-17', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30847, '2020-02-18', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30848, '2020-02-19', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30849, '2020-02-20', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30850, '2020-02-21', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30851, '2020-02-22', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30852, '2020-02-23', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30853, '2020-02-24', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30854, '2020-02-25', 'GE', 'Georgia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30855, '2020-02-26', 'GE', 'Georgia', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30856, '2020-02-27', 'GE', 'Georgia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30857, '2020-02-28', 'GE', 'Georgia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30858, '2020-02-29', 'GE', 'Georgia', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30859, '2020-03-01', 'GE', 'Georgia', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30860, '2020-03-02', 'GE', 'Georgia', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30861, '2020-03-03', 'GE', 'Georgia', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30862, '2020-03-04', 'GE', 'Georgia', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30863, '2020-03-05', 'GE', 'Georgia', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30864, '2020-03-06', 'GE', 'Georgia', 'EURO', '6', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30865, '2020-03-07', 'GE', 'Georgia', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30866, '2020-03-08', 'GE', 'Georgia', 'EURO', '3', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30867, '2020-03-09', 'GE', 'Georgia', 'EURO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30868, '2020-03-10', 'GE', 'Georgia', 'EURO', '2', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30869, '2020-03-11', 'GE', 'Georgia', 'EURO', '8', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30870, '2020-03-12', 'GE', 'Georgia', 'EURO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30871, '2020-03-13', 'GE', 'Georgia', 'EURO', '2', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30872, '2020-03-14', 'GE', 'Georgia', 'EURO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30873, '2020-03-15', 'GE', 'Georgia', 'EURO', '5', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30874, '2020-03-16', 'GE', 'Georgia', 'EURO', '3', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30875, '2020-03-17', 'GE', 'Georgia', 'EURO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30876, '2020-03-18', 'GE', 'Georgia', 'EURO', '1', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30877, '2020-03-19', 'GE', 'Georgia', 'EURO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30878, '2020-03-20', 'GE', 'Georgia', 'EURO', '4', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30879, '2020-03-21', 'GE', 'Georgia', 'EURO', '10', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30880, '2020-03-22', 'GE', 'Georgia', 'EURO', '6', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30881, '2020-03-23', 'GE', 'Georgia', 'EURO', '7', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30882, '2020-03-24', 'GE', 'Georgia', 'EURO', '9', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30883, '2020-03-25', 'GE', 'Georgia', 'EURO', '7', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30884, '2020-03-26', 'GE', 'Georgia', 'EURO', '3', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30885, '2020-03-27', 'GE', 'Georgia', 'EURO', '3', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30886, '2020-03-28', 'GE', 'Georgia', 'EURO', '7', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30887, '2020-03-29', 'GE', 'Georgia', 'EURO', '8', '98', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30888, '2020-03-30', 'GE', 'Georgia', 'EURO', '5', '103', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30889, '2020-03-31', 'GE', 'Georgia', 'EURO', '12', '115', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30890, '2020-04-01', 'GE', 'Georgia', 'EURO', '6', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30891, '2020-04-02', 'GE', 'Georgia', 'EURO', '0', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30892, '2020-04-03', 'GE', 'Georgia', 'EURO', '27', '148', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30893, '2020-04-04', 'GE', 'Georgia', 'EURO', '9', '157', '0', '0');
INSERT INTO public.who_global_data_import VALUES (30894, '2020-04-05', 'GE', 'Georgia', 'EURO', '13', '170', '1', '1');
INSERT INTO public.who_global_data_import VALUES (30895, '2020-04-06', 'GE', 'Georgia', 'EURO', '18', '188', '1', '2');
INSERT INTO public.who_global_data_import VALUES (30896, '2020-04-07', 'GE', 'Georgia', 'EURO', '7', '195', '0', '2');
INSERT INTO public.who_global_data_import VALUES (30897, '2020-04-08', 'GE', 'Georgia', 'EURO', '13', '208', '1', '3');
INSERT INTO public.who_global_data_import VALUES (30898, '2020-04-09', 'GE', 'Georgia', 'EURO', '6', '214', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30899, '2020-04-10', 'GE', 'Georgia', 'EURO', '16', '230', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30900, '2020-04-11', 'GE', 'Georgia', 'EURO', '3', '233', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30901, '2020-04-12', 'GE', 'Georgia', 'EURO', '19', '252', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30902, '2020-04-13', 'GE', 'Georgia', 'EURO', '14', '266', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30903, '2020-04-14', 'GE', 'Georgia', 'EURO', '30', '296', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30904, '2020-04-15', 'GE', 'Georgia', 'EURO', '10', '306', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30905, '2020-04-16', 'GE', 'Georgia', 'EURO', '30', '336', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30906, '2020-04-17', 'GE', 'Georgia', 'EURO', '34', '370', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30907, '2020-04-18', 'GE', 'Georgia', 'EURO', '15', '385', '0', '3');
INSERT INTO public.who_global_data_import VALUES (30908, '2020-04-19', 'GE', 'Georgia', 'EURO', '9', '394', '1', '4');
INSERT INTO public.who_global_data_import VALUES (30909, '2020-04-20', 'GE', 'Georgia', 'EURO', '5', '399', '0', '4');
INSERT INTO public.who_global_data_import VALUES (30910, '2020-04-21', 'GE', 'Georgia', 'EURO', '9', '408', '0', '4');
INSERT INTO public.who_global_data_import VALUES (30911, '2020-04-22', 'GE', 'Georgia', 'EURO', '3', '411', '1', '5');
INSERT INTO public.who_global_data_import VALUES (30912, '2020-04-23', 'GE', 'Georgia', 'EURO', '9', '420', '0', '5');
INSERT INTO public.who_global_data_import VALUES (30913, '2020-04-24', 'GE', 'Georgia', 'EURO', '11', '431', '0', '5');
INSERT INTO public.who_global_data_import VALUES (30914, '2020-04-25', 'GE', 'Georgia', 'EURO', '25', '456', '0', '5');
INSERT INTO public.who_global_data_import VALUES (30915, '2020-04-26', 'GE', 'Georgia', 'EURO', '29', '485', '0', '5');
INSERT INTO public.who_global_data_import VALUES (30916, '2020-04-27', 'GE', 'Georgia', 'EURO', '11', '496', '1', '6');
INSERT INTO public.who_global_data_import VALUES (30917, '2020-04-28', 'GE', 'Georgia', 'EURO', '15', '511', '0', '6');
INSERT INTO public.who_global_data_import VALUES (30918, '2020-04-29', 'GE', 'Georgia', 'EURO', '6', '517', '0', '6');
INSERT INTO public.who_global_data_import VALUES (30919, '2020-04-30', 'GE', 'Georgia', 'EURO', '22', '539', '0', '6');
INSERT INTO public.who_global_data_import VALUES (30920, '2020-05-01', 'GE', 'Georgia', 'EURO', '27', '566', '0', '6');
INSERT INTO public.who_global_data_import VALUES (30921, '2020-05-02', 'GE', 'Georgia', 'EURO', '16', '582', '2', '8');
INSERT INTO public.who_global_data_import VALUES (30922, '2020-05-03', 'GE', 'Georgia', 'EURO', '7', '589', '0', '8');
INSERT INTO public.who_global_data_import VALUES (30923, '2020-05-04', 'GE', 'Georgia', 'EURO', '4', '593', '1', '9');
INSERT INTO public.who_global_data_import VALUES (30924, '2020-05-05', 'GE', 'Georgia', 'EURO', '11', '604', '0', '9');
INSERT INTO public.who_global_data_import VALUES (30925, '2020-05-06', 'GE', 'Georgia', 'EURO', '6', '610', '0', '9');
INSERT INTO public.who_global_data_import VALUES (30926, '2020-05-07', 'GE', 'Georgia', 'EURO', '4', '614', '0', '9');
INSERT INTO public.who_global_data_import VALUES (30927, '2020-05-08', 'GE', 'Georgia', 'EURO', '9', '623', '0', '9');
INSERT INTO public.who_global_data_import VALUES (30928, '2020-05-09', 'GE', 'Georgia', 'EURO', '3', '626', '1', '10');
INSERT INTO public.who_global_data_import VALUES (30929, '2020-05-10', 'GE', 'Georgia', 'EURO', '9', '635', '0', '10');
INSERT INTO public.who_global_data_import VALUES (30930, '2020-05-11', 'GE', 'Georgia', 'EURO', '3', '638', '0', '10');
INSERT INTO public.who_global_data_import VALUES (30931, '2020-05-12', 'GE', 'Georgia', 'EURO', '1', '639', '1', '11');
INSERT INTO public.who_global_data_import VALUES (30932, '2020-05-13', 'GE', 'Georgia', 'EURO', '3', '642', '0', '11');
INSERT INTO public.who_global_data_import VALUES (30933, '2020-05-14', 'GE', 'Georgia', 'EURO', '10', '652', '0', '11');
INSERT INTO public.who_global_data_import VALUES (30934, '2020-05-15', 'GE', 'Georgia', 'EURO', '19', '671', '1', '12');
INSERT INTO public.who_global_data_import VALUES (30935, '2020-05-16', 'GE', 'Georgia', 'EURO', '6', '677', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30936, '2020-05-17', 'GE', 'Georgia', 'EURO', '18', '695', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30937, '2020-05-18', 'GE', 'Georgia', 'EURO', '6', '701', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30938, '2020-05-19', 'GE', 'Georgia', 'EURO', '1', '702', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30939, '2020-05-20', 'GE', 'Georgia', 'EURO', '11', '713', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30940, '2020-05-21', 'GE', 'Georgia', 'EURO', '8', '721', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30941, '2020-05-22', 'GE', 'Georgia', 'EURO', '2', '723', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30942, '2020-05-23', 'GE', 'Georgia', 'EURO', '0', '723', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30943, '2020-05-24', 'GE', 'Georgia', 'EURO', '7', '730', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30944, '2020-05-25', 'GE', 'Georgia', 'EURO', '1', '731', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30945, '2020-05-26', 'GE', 'Georgia', 'EURO', '1', '732', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30946, '2020-05-27', 'GE', 'Georgia', 'EURO', '3', '735', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30947, '2020-05-28', 'GE', 'Georgia', 'EURO', '3', '738', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30948, '2020-05-29', 'GE', 'Georgia', 'EURO', '8', '746', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30949, '2020-05-30', 'GE', 'Georgia', 'EURO', '11', '757', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30950, '2020-05-31', 'GE', 'Georgia', 'EURO', '26', '783', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30951, '2020-06-01', 'GE', 'Georgia', 'EURO', '11', '794', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30952, '2020-06-02', 'GE', 'Georgia', 'EURO', '2', '796', '0', '12');
INSERT INTO public.who_global_data_import VALUES (30953, '2020-06-03', 'GE', 'Georgia', 'EURO', '4', '800', '1', '13');
INSERT INTO public.who_global_data_import VALUES (30954, '2020-06-04', 'GE', 'Georgia', 'EURO', '1', '801', '0', '13');
INSERT INTO public.who_global_data_import VALUES (30955, '2020-06-05', 'GE', 'Georgia', 'EURO', '5', '806', '0', '13');
INSERT INTO public.who_global_data_import VALUES (30956, '2020-06-06', 'GE', 'Georgia', 'EURO', '2', '808', '0', '13');
INSERT INTO public.who_global_data_import VALUES (30957, '2020-06-07', 'GE', 'Georgia', 'EURO', '1', '809', '0', '13');
INSERT INTO public.who_global_data_import VALUES (30958, '2020-06-08', 'GE', 'Georgia', 'EURO', '1', '810', '0', '13');
INSERT INTO public.who_global_data_import VALUES (30959, '2020-06-09', 'GE', 'Georgia', 'EURO', '8', '818', '0', '13');
INSERT INTO public.who_global_data_import VALUES (30960, '2020-06-10', 'GE', 'Georgia', 'EURO', '4', '822', '0', '13');
INSERT INTO public.who_global_data_import VALUES (30961, '2020-06-11', 'GE', 'Georgia', 'EURO', '6', '828', '0', '13');
INSERT INTO public.who_global_data_import VALUES (30962, '2020-06-12', 'GE', 'Georgia', 'EURO', '9', '837', '0', '13');
INSERT INTO public.who_global_data_import VALUES (30963, '2020-06-13', 'GE', 'Georgia', 'EURO', '14', '851', '0', '13');
INSERT INTO public.who_global_data_import VALUES (30964, '2020-06-14', 'GE', 'Georgia', 'EURO', '13', '864', '1', '14');
INSERT INTO public.who_global_data_import VALUES (30965, '2020-06-15', 'GE', 'Georgia', 'EURO', '15', '879', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30966, '2020-06-16', 'GE', 'Georgia', 'EURO', '0', '879', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30967, '2020-06-17', 'GE', 'Georgia', 'EURO', '9', '888', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30968, '2020-06-18', 'GE', 'Georgia', 'EURO', '5', '893', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30969, '2020-06-19', 'GE', 'Georgia', 'EURO', '2', '895', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30970, '2020-06-20', 'GE', 'Georgia', 'EURO', '3', '898', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30971, '2020-06-21', 'GE', 'Georgia', 'EURO', '8', '906', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30972, '2020-06-22', 'GE', 'Georgia', 'EURO', '2', '908', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30973, '2020-06-23', 'GE', 'Georgia', 'EURO', '3', '911', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30974, '2020-06-24', 'GE', 'Georgia', 'EURO', '3', '914', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30975, '2020-06-25', 'GE', 'Georgia', 'EURO', '3', '917', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30976, '2020-06-26', 'GE', 'Georgia', 'EURO', '2', '919', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30977, '2020-06-27', 'GE', 'Georgia', 'EURO', '2', '921', '0', '14');
INSERT INTO public.who_global_data_import VALUES (30978, '2020-06-28', 'GE', 'Georgia', 'EURO', '3', '924', '1', '15');
INSERT INTO public.who_global_data_import VALUES (30979, '2020-06-29', 'GE', 'Georgia', 'EURO', '2', '926', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30980, '2020-06-30', 'GE', 'Georgia', 'EURO', '2', '928', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30981, '2020-07-01', 'GE', 'Georgia', 'EURO', '3', '931', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30982, '2020-07-02', 'GE', 'Georgia', 'EURO', '8', '939', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30983, '2020-07-03', 'GE', 'Georgia', 'EURO', '4', '943', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30984, '2020-07-04', 'GE', 'Georgia', 'EURO', '3', '946', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30985, '2020-07-05', 'GE', 'Georgia', 'EURO', '5', '951', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30986, '2020-07-06', 'GE', 'Georgia', 'EURO', '2', '953', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30987, '2020-07-07', 'GE', 'Georgia', 'EURO', '5', '958', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30988, '2020-07-08', 'GE', 'Georgia', 'EURO', '5', '963', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30989, '2020-07-09', 'GE', 'Georgia', 'EURO', '5', '968', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30990, '2020-07-10', 'GE', 'Georgia', 'EURO', '5', '973', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30991, '2020-07-11', 'GE', 'Georgia', 'EURO', '8', '981', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30992, '2020-07-12', 'GE', 'Georgia', 'EURO', '5', '986', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30993, '2020-07-13', 'GE', 'Georgia', 'EURO', '9', '995', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30994, '2020-07-14', 'GE', 'Georgia', 'EURO', '4', '999', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30995, '2020-07-15', 'GE', 'Georgia', 'EURO', '4', '1003', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30996, '2020-07-16', 'GE', 'Georgia', 'EURO', '3', '1006', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30997, '2020-07-17', 'GE', 'Georgia', 'EURO', '4', '1010', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30998, '2020-07-18', 'GE', 'Georgia', 'EURO', '8', '1018', '0', '15');
INSERT INTO public.who_global_data_import VALUES (30999, '2020-07-19', 'GE', 'Georgia', 'EURO', '10', '1028', '0', '15');
INSERT INTO public.who_global_data_import VALUES (31000, '2020-07-20', 'GE', 'Georgia', 'EURO', '11', '1039', '0', '15');
INSERT INTO public.who_global_data_import VALUES (31001, '2020-07-21', 'GE', 'Georgia', 'EURO', '10', '1049', '1', '16');
INSERT INTO public.who_global_data_import VALUES (31002, '2020-07-22', 'GE', 'Georgia', 'EURO', '24', '1073', '0', '16');
INSERT INTO public.who_global_data_import VALUES (31003, '2020-07-23', 'GE', 'Georgia', 'EURO', '12', '1085', '0', '16');
INSERT INTO public.who_global_data_import VALUES (31004, '2020-07-24', 'GE', 'Georgia', 'EURO', '19', '1104', '0', '16');
INSERT INTO public.who_global_data_import VALUES (31005, '2020-07-25', 'GE', 'Georgia', 'EURO', '13', '1117', '0', '16');
INSERT INTO public.who_global_data_import VALUES (31006, '2020-07-26', 'GE', 'Georgia', 'EURO', '14', '1131', '0', '16');
INSERT INTO public.who_global_data_import VALUES (31007, '2020-07-27', 'GE', 'Georgia', 'EURO', '6', '1137', '0', '16');
INSERT INTO public.who_global_data_import VALUES (31008, '2020-07-28', 'GE', 'Georgia', 'EURO', '8', '1145', '0', '16');
INSERT INTO public.who_global_data_import VALUES (31009, '2020-07-29', 'GE', 'Georgia', 'EURO', '10', '1155', '0', '16');
INSERT INTO public.who_global_data_import VALUES (31010, '2020-07-30', 'GE', 'Georgia', 'EURO', '5', '1160', '1', '17');
INSERT INTO public.who_global_data_import VALUES (31011, '2020-07-31', 'GE', 'Georgia', 'EURO', '8', '1168', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31012, '2020-08-01', 'GE', 'Georgia', 'EURO', '3', '1171', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31013, '2020-08-02', 'GE', 'Georgia', 'EURO', '6', '1177', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31014, '2020-08-03', 'GE', 'Georgia', 'EURO', '2', '1179', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31015, '2020-08-04', 'GE', 'Georgia', 'EURO', '3', '1182', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31016, '2020-08-05', 'GE', 'Georgia', 'EURO', '15', '1197', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31017, '2020-08-06', 'GE', 'Georgia', 'EURO', '9', '1206', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31018, '2020-08-07', 'GE', 'Georgia', 'EURO', '7', '1213', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31019, '2020-08-08', 'GE', 'Georgia', 'EURO', '3', '1216', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31020, '2020-08-09', 'GE', 'Georgia', 'EURO', '9', '1225', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31021, '2020-08-10', 'GE', 'Georgia', 'EURO', '25', '1250', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31022, '2020-08-11', 'GE', 'Georgia', 'EURO', '14', '1264', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31023, '2020-08-12', 'GE', 'Georgia', 'EURO', '14', '1278', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31024, '2020-08-13', 'GE', 'Georgia', 'EURO', '5', '1283', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31025, '2020-08-14', 'GE', 'Georgia', 'EURO', '23', '1306', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31026, '2020-08-15', 'GE', 'Georgia', 'EURO', '15', '1321', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31027, '2020-08-16', 'GE', 'Georgia', 'EURO', '15', '1336', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31028, '2020-08-17', 'GE', 'Georgia', 'EURO', '5', '1341', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31029, '2020-08-18', 'GE', 'Georgia', 'EURO', '10', '1351', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31030, '2020-08-19', 'GE', 'Georgia', 'EURO', '10', '1361', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31031, '2020-08-20', 'GE', 'Georgia', 'EURO', '9', '1370', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31032, '2020-08-21', 'GE', 'Georgia', 'EURO', '15', '1385', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31033, '2020-08-22', 'GE', 'Georgia', 'EURO', '9', '1394', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31034, '2020-08-23', 'GE', 'Georgia', 'EURO', '17', '1411', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31035, '2020-08-24', 'GE', 'Georgia', 'EURO', '10', '1421', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31036, '2020-08-25', 'GE', 'Georgia', 'EURO', '8', '1429', '2', '19');
INSERT INTO public.who_global_data_import VALUES (31037, '2020-08-26', 'GE', 'Georgia', 'EURO', '7', '1436', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31038, '2020-08-27', 'GE', 'Georgia', 'EURO', '11', '1447', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31039, '2020-08-28', 'GE', 'Georgia', 'EURO', '8', '1455', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31040, '2020-08-29', 'GE', 'Georgia', 'EURO', '7', '1462', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31041, '2020-08-30', 'GE', 'Georgia', 'EURO', '7', '1469', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31042, '2020-08-31', 'GE', 'Georgia', 'EURO', '18', '1487', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31043, '2020-09-01', 'GE', 'Georgia', 'EURO', '23', '1510', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31044, '2020-09-02', 'GE', 'Georgia', 'EURO', '38', '1548', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31045, '2020-09-03', 'GE', 'Georgia', 'EURO', '20', '1568', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31046, '2020-09-04', 'GE', 'Georgia', 'EURO', '28', '1596', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31047, '2020-09-05', 'GE', 'Georgia', 'EURO', '25', '1621', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31048, '2020-09-06', 'GE', 'Georgia', 'EURO', '29', '1650', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31049, '2020-09-07', 'GE', 'Georgia', 'EURO', '34', '1684', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31050, '2020-09-08', 'GE', 'Georgia', 'EURO', '45', '1729', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31051, '2020-09-09', 'GE', 'Georgia', 'EURO', '44', '1773', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31052, '2020-09-10', 'GE', 'Georgia', 'EURO', '57', '1830', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31053, '2020-09-11', 'GE', 'Georgia', 'EURO', '87', '1917', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31054, '2020-09-12', 'GE', 'Georgia', 'EURO', '158', '2075', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31055, '2020-09-13', 'GE', 'Georgia', 'EURO', '152', '2227', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31056, '2020-09-14', 'GE', 'Georgia', 'EURO', '165', '2392', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31057, '2020-09-15', 'GE', 'Georgia', 'EURO', '170', '2562', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31058, '2020-09-16', 'GE', 'Georgia', 'EURO', '196', '2758', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31059, '2020-09-17', 'GE', 'Georgia', 'EURO', '179', '2937', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31060, '2020-09-18', 'GE', 'Georgia', 'EURO', '182', '3119', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31061, '2020-09-19', 'GE', 'Georgia', 'EURO', '187', '3306', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31062, '2020-09-20', 'GE', 'Georgia', 'EURO', '196', '3502', '0', '19');
INSERT INTO public.who_global_data_import VALUES (31063, '2020-09-21', 'GE', 'Georgia', 'EURO', '193', '3695', '1', '20');
INSERT INTO public.who_global_data_import VALUES (31064, '2020-09-22', 'GE', 'Georgia', 'EURO', '218', '3913', '2', '22');
INSERT INTO public.who_global_data_import VALUES (31065, '2020-09-23', 'GE', 'Georgia', 'EURO', '227', '4140', '2', '24');
INSERT INTO public.who_global_data_import VALUES (31066, '2020-09-24', 'GE', 'Georgia', 'EURO', '259', '4399', '1', '25');
INSERT INTO public.who_global_data_import VALUES (31067, '2020-09-25', 'GE', 'Georgia', 'EURO', '265', '4664', '1', '26');
INSERT INTO public.who_global_data_import VALUES (31068, '2020-09-26', 'GE', 'Georgia', 'EURO', '296', '4960', '1', '27');
INSERT INTO public.who_global_data_import VALUES (31069, '2020-09-27', 'GE', 'Georgia', 'EURO', '294', '5254', '1', '28');
INSERT INTO public.who_global_data_import VALUES (31070, '2020-09-28', 'GE', 'Georgia', 'EURO', '298', '5552', '0', '28');
INSERT INTO public.who_global_data_import VALUES (31071, '2020-09-29', 'GE', 'Georgia', 'EURO', '314', '5866', '5', '33');
INSERT INTO public.who_global_data_import VALUES (31072, '2020-09-30', 'GE', 'Georgia', 'EURO', '326', '6192', '3', '36');
INSERT INTO public.who_global_data_import VALUES (31073, '2020-10-01', 'GE', 'Georgia', 'EURO', '448', '6640', '4', '40');
INSERT INTO public.who_global_data_import VALUES (31074, '2020-10-02', 'GE', 'Georgia', 'EURO', '453', '7093', '3', '43');
INSERT INTO public.who_global_data_import VALUES (31075, '2020-10-03', 'GE', 'Georgia', 'EURO', '471', '7564', '5', '48');
INSERT INTO public.who_global_data_import VALUES (31076, '2020-10-04', 'GE', 'Georgia', 'EURO', '554', '8118', '2', '50');
INSERT INTO public.who_global_data_import VALUES (31077, '2020-10-05', 'GE', 'Georgia', 'EURO', '578', '8696', '2', '52');
INSERT INTO public.who_global_data_import VALUES (31078, '2020-10-06', 'GE', 'Georgia', 'EURO', '549', '9245', '6', '58');
INSERT INTO public.who_global_data_import VALUES (31079, '2020-10-07', 'GE', 'Georgia', 'EURO', '508', '9753', '4', '62');
INSERT INTO public.who_global_data_import VALUES (31080, '2020-10-08', 'GE', 'Georgia', 'EURO', '472', '10225', '4', '66');
INSERT INTO public.who_global_data_import VALUES (31081, '2020-10-09', 'GE', 'Georgia', 'EURO', '527', '10752', '6', '72');
INSERT INTO public.who_global_data_import VALUES (31082, '2020-10-10', 'GE', 'Georgia', 'EURO', '519', '11271', '6', '78');
INSERT INTO public.who_global_data_import VALUES (31083, '2020-10-11', 'GE', 'Georgia', 'EURO', '523', '11794', '7', '85');
INSERT INTO public.who_global_data_import VALUES (31084, '2020-10-12', 'GE', 'Georgia', 'EURO', '478', '12272', '6', '91');
INSERT INTO public.who_global_data_import VALUES (31085, '2020-10-13', 'GE', 'Georgia', 'EURO', '569', '12841', '11', '102');
INSERT INTO public.who_global_data_import VALUES (31086, '2020-10-14', 'GE', 'Georgia', 'EURO', '680', '13521', '7', '109');
INSERT INTO public.who_global_data_import VALUES (31087, '2020-10-15', 'GE', 'Georgia', 'EURO', '919', '14440', '4', '113');
INSERT INTO public.who_global_data_import VALUES (31088, '2020-10-16', 'GE', 'Georgia', 'EURO', '887', '15327', '11', '124');
INSERT INTO public.who_global_data_import VALUES (31089, '2020-10-17', 'GE', 'Georgia', 'EURO', '958', '16285', '4', '128');
INSERT INTO public.who_global_data_import VALUES (31090, '2020-10-18', 'GE', 'Georgia', 'EURO', '1192', '17477', '8', '136');
INSERT INTO public.who_global_data_import VALUES (31091, '2020-10-19', 'GE', 'Georgia', 'EURO', '1186', '18663', '7', '143');
INSERT INTO public.who_global_data_import VALUES (31092, '2020-10-20', 'GE', 'Georgia', 'EURO', '1194', '19857', '15', '158');
INSERT INTO public.who_global_data_import VALUES (31093, '2020-10-21', 'GE', 'Georgia', 'EURO', '1351', '21208', '14', '172');
INSERT INTO public.who_global_data_import VALUES (31094, '2020-10-22', 'GE', 'Georgia', 'EURO', '1595', '22803', '7', '179');
INSERT INTO public.who_global_data_import VALUES (31095, '2020-10-23', 'GE', 'Georgia', 'EURO', '1759', '24562', '4', '183');
INSERT INTO public.who_global_data_import VALUES (31096, '2020-10-24', 'GE', 'Georgia', 'EURO', '1941', '26503', '10', '193');
INSERT INTO public.who_global_data_import VALUES (31097, '2020-10-25', 'GE', 'Georgia', 'EURO', '1928', '28431', '8', '201');
INSERT INTO public.who_global_data_import VALUES (31098, '2020-10-26', 'GE', 'Georgia', 'EURO', '1872', '30303', '14', '215');
INSERT INTO public.who_global_data_import VALUES (31099, '2020-10-27', 'GE', 'Georgia', 'EURO', '1824', '32127', '23', '238');
INSERT INTO public.who_global_data_import VALUES (31100, '2020-10-28', 'GE', 'Georgia', 'EURO', '1731', '33858', '15', '253');
INSERT INTO public.who_global_data_import VALUES (31101, '2020-10-29', 'GE', 'Georgia', 'EURO', '1709', '35567', '20', '273');
INSERT INTO public.who_global_data_import VALUES (31102, '2020-10-30', 'GE', 'Georgia', 'EURO', '1696', '37263', '12', '285');
INSERT INTO public.who_global_data_import VALUES (31103, '2020-10-31', 'GE', 'Georgia', 'EURO', '1673', '38936', '22', '307');
INSERT INTO public.who_global_data_import VALUES (31104, '2020-11-01', 'GE', 'Georgia', 'EURO', '1791', '40727', '28', '335');
INSERT INTO public.who_global_data_import VALUES (31105, '2020-11-02', 'GE', 'Georgia', 'EURO', '1852', '42579', '7', '342');
INSERT INTO public.who_global_data_import VALUES (31106, '2020-11-03', 'GE', 'Georgia', 'EURO', '1943', '44522', '20', '362');
INSERT INTO public.who_global_data_import VALUES (31107, '2020-11-04', 'GE', 'Georgia', 'EURO', '2295', '46817', '19', '381');
INSERT INTO public.who_global_data_import VALUES (31108, '2020-11-05', 'GE', 'Georgia', 'EURO', '2401', '49218', '20', '401');
INSERT INTO public.who_global_data_import VALUES (31109, '2020-11-06', 'GE', 'Georgia', 'EURO', '2775', '51993', '22', '423');
INSERT INTO public.who_global_data_import VALUES (31110, '2020-11-07', 'GE', 'Georgia', 'EURO', '2859', '54852', '18', '441');
INSERT INTO public.who_global_data_import VALUES (31111, '2020-11-08', 'GE', 'Georgia', 'EURO', '2901', '57753', '34', '475');
INSERT INTO public.who_global_data_import VALUES (31112, '2020-11-09', 'GE', 'Georgia', 'EURO', '2927', '60680', '24', '499');
INSERT INTO public.who_global_data_import VALUES (31113, '2020-11-10', 'GE', 'Georgia', 'EURO', '2970', '63650', '22', '521');
INSERT INTO public.who_global_data_import VALUES (31114, '2020-11-11', 'GE', 'Georgia', 'EURO', '2911', '66561', '45', '566');
INSERT INTO public.who_global_data_import VALUES (31115, '2020-11-12', 'GE', 'Georgia', 'EURO', '3120', '69681', '33', '599');
INSERT INTO public.who_global_data_import VALUES (31116, '2020-11-13', 'GE', 'Georgia', 'EURO', '3473', '73154', '37', '636');
INSERT INTO public.who_global_data_import VALUES (31117, '2020-11-14', 'GE', 'Georgia', 'EURO', '3504', '76658', '33', '669');
INSERT INTO public.who_global_data_import VALUES (31118, '2020-11-15', 'GE', 'Georgia', 'EURO', '3020', '79678', '34', '703');
INSERT INTO public.who_global_data_import VALUES (31119, '2020-11-16', 'GE', 'Georgia', 'EURO', '3157', '82835', '30', '733');
INSERT INTO public.who_global_data_import VALUES (31120, '2020-11-17', 'GE', 'Georgia', 'EURO', '3117', '85952', '45', '778');
INSERT INTO public.who_global_data_import VALUES (31121, '2020-11-18', 'GE', 'Georgia', 'EURO', '3443', '89395', '37', '815');
INSERT INTO public.who_global_data_import VALUES (31122, '2020-11-19', 'GE', 'Georgia', 'EURO', '3697', '93092', '38', '853');
INSERT INTO public.who_global_data_import VALUES (31123, '2020-11-20', 'GE', 'Georgia', 'EURO', '3768', '96860', '41', '894');
INSERT INTO public.who_global_data_import VALUES (31124, '2020-11-21', 'GE', 'Georgia', 'EURO', '3824', '100684', '33', '927');
INSERT INTO public.who_global_data_import VALUES (31125, '2020-11-22', 'GE', 'Georgia', 'EURO', '4048', '104732', '49', '976');
INSERT INTO public.who_global_data_import VALUES (31126, '2020-11-23', 'GE', 'Georgia', 'EURO', '3958', '108690', '36', '1012');
INSERT INTO public.who_global_data_import VALUES (31127, '2020-11-24', 'GE', 'Georgia', 'EURO', '3128', '111818', '39', '1051');
INSERT INTO public.who_global_data_import VALUES (31128, '2020-11-25', 'GE', 'Georgia', 'EURO', '3071', '114889', '34', '1085');
INSERT INTO public.who_global_data_import VALUES (31129, '2020-11-26', 'GE', 'Georgia', 'EURO', '3801', '118690', '39', '1124');
INSERT INTO public.who_global_data_import VALUES (31130, '2020-11-27', 'GE', 'Georgia', 'EURO', '4780', '123470', '37', '1161');
INSERT INTO public.who_global_data_import VALUES (31131, '2020-11-28', 'GE', 'Georgia', 'EURO', '4472', '127942', '34', '1195');
INSERT INTO public.who_global_data_import VALUES (31132, '2020-11-29', 'GE', 'Georgia', 'EURO', '4426', '132368', '35', '1230');
INSERT INTO public.who_global_data_import VALUES (31133, '2020-11-30', 'GE', 'Georgia', 'EURO', '3216', '135584', '37', '1267');
INSERT INTO public.who_global_data_import VALUES (31134, '2020-12-01', 'GE', 'Georgia', 'EURO', '3759', '139343', '36', '1303');
INSERT INTO public.who_global_data_import VALUES (31135, '2020-12-02', 'GE', 'Georgia', 'EURO', '4033', '143376', '39', '1342');
INSERT INTO public.who_global_data_import VALUES (31136, '2020-12-03', 'GE', 'Georgia', 'EURO', '4260', '147636', '45', '1387');
INSERT INTO public.who_global_data_import VALUES (31137, '2020-12-04', 'GE', 'Georgia', 'EURO', '5068', '152704', '38', '1425');
INSERT INTO public.who_global_data_import VALUES (31138, '2020-12-05', 'GE', 'Georgia', 'EURO', '5450', '158154', '37', '1462');
INSERT INTO public.who_global_data_import VALUES (31139, '2020-12-06', 'GE', 'Georgia', 'EURO', '4321', '162475', '42', '1504');
INSERT INTO public.who_global_data_import VALUES (31140, '2020-12-07', 'GE', 'Georgia', 'EURO', '2501', '164976', '36', '1540');
INSERT INTO public.who_global_data_import VALUES (31141, '2020-12-08', 'GE', 'Georgia', 'EURO', '4673', '169649', '36', '1576');
INSERT INTO public.who_global_data_import VALUES (31142, '2020-12-09', 'GE', 'Georgia', 'EURO', '4734', '174383', '38', '1614');
INSERT INTO public.who_global_data_import VALUES (31143, '2020-12-10', 'GE', 'Georgia', 'EURO', '4570', '178953', '43', '1657');
INSERT INTO public.who_global_data_import VALUES (31144, '2020-12-11', 'GE', 'Georgia', 'EURO', '4146', '183099', '37', '1694');
INSERT INTO public.who_global_data_import VALUES (31145, '2020-12-12', 'GE', 'Georgia', 'EURO', '3907', '187006', '50', '1744');
INSERT INTO public.who_global_data_import VALUES (31146, '2020-12-13', 'GE', 'Georgia', 'EURO', '2720', '189726', '46', '1790');
INSERT INTO public.who_global_data_import VALUES (31147, '2020-12-14', 'GE', 'Georgia', 'EURO', '1337', '191063', '49', '1839');
INSERT INTO public.who_global_data_import VALUES (31148, '2020-12-15', 'GE', 'Georgia', 'EURO', '3837', '194900', '44', '1883');
INSERT INTO public.who_global_data_import VALUES (31149, '2020-12-16', 'GE', 'Georgia', 'EURO', '3487', '198387', '39', '1922');
INSERT INTO public.who_global_data_import VALUES (31150, '2020-12-17', 'GE', 'Georgia', 'EURO', '2981', '201368', '31', '1953');
INSERT INTO public.who_global_data_import VALUES (31151, '2020-12-18', 'GE', 'Georgia', 'EURO', '2635', '204003', '49', '2002');
INSERT INTO public.who_global_data_import VALUES (31152, '2020-12-19', 'GE', 'Georgia', 'EURO', '2904', '206907', '53', '2055');
INSERT INTO public.who_global_data_import VALUES (31153, '2020-12-20', 'GE', 'Georgia', 'EURO', '1731', '208638', '39', '2094');
INSERT INTO public.who_global_data_import VALUES (31154, '2020-12-21', 'GE', 'Georgia', 'EURO', '824', '209462', '46', '2140');
INSERT INTO public.who_global_data_import VALUES (31155, '2020-12-22', 'GE', 'Georgia', 'EURO', '3064', '212526', '42', '2182');
INSERT INTO public.who_global_data_import VALUES (31156, '2020-12-23', 'GE', 'Georgia', 'EURO', '2345', '214871', '51', '2233');
INSERT INTO public.who_global_data_import VALUES (31157, '2020-12-24', 'GE', 'Georgia', 'EURO', '1972', '216843', '43', '2276');
INSERT INTO public.who_global_data_import VALUES (31158, '2020-12-25', 'GE', 'Georgia', 'EURO', '1881', '218724', '37', '2313');
INSERT INTO public.who_global_data_import VALUES (31159, '2020-12-26', 'GE', 'Georgia', 'EURO', '1784', '220508', '39', '2352');
INSERT INTO public.who_global_data_import VALUES (31160, '2020-12-27', 'GE', 'Georgia', 'EURO', '1097', '221605', '25', '2377');
INSERT INTO public.who_global_data_import VALUES (31161, '2020-12-28', 'GE', 'Georgia', 'EURO', '538', '222143', '41', '2418');
INSERT INTO public.who_global_data_import VALUES (31162, '2020-12-29', 'GE', 'Georgia', 'EURO', '2012', '224155', '25', '2443');
INSERT INTO public.who_global_data_import VALUES (31163, '2020-12-30', 'GE', 'Georgia', 'EURO', '1738', '225893', '38', '2481');
INSERT INTO public.who_global_data_import VALUES (31164, '2020-12-31', 'GE', 'Georgia', 'EURO', '1527', '227420', '24', '2505');
INSERT INTO public.who_global_data_import VALUES (31165, '2021-01-01', 'GE', 'Georgia', 'EURO', '990', '228410', '23', '2528');
INSERT INTO public.who_global_data_import VALUES (31166, '2021-01-02', 'GE', 'Georgia', 'EURO', '342', '228752', '44', '2572');
INSERT INTO public.who_global_data_import VALUES (31167, '2021-01-03', 'GE', 'Georgia', 'EURO', '417', '229169', '31', '2603');
INSERT INTO public.who_global_data_import VALUES (31168, '2021-01-04', 'GE', 'Georgia', 'EURO', '594', '229763', '25', '2628');
INSERT INTO public.who_global_data_import VALUES (31169, '2021-01-05', 'GE', 'Georgia', 'EURO', '2316', '232079', '18', '2646');
INSERT INTO public.who_global_data_import VALUES (31170, '2021-01-06', 'GE', 'Georgia', 'EURO', '1800', '233879', '20', '2666');
INSERT INTO public.who_global_data_import VALUES (31171, '2021-01-07', 'GE', 'Georgia', 'EURO', '1612', '235491', '28', '2694');
INSERT INTO public.who_global_data_import VALUES (31172, '2021-01-08', 'GE', 'Georgia', 'EURO', '537', '236028', '34', '2728');
INSERT INTO public.who_global_data_import VALUES (31173, '2021-01-09', 'GE', 'Georgia', 'EURO', '2058', '238086', '22', '2750');
INSERT INTO public.who_global_data_import VALUES (31174, '2021-01-10', 'GE', 'Georgia', 'EURO', '1143', '239229', '23', '2773');
INSERT INTO public.who_global_data_import VALUES (31175, '2021-01-11', 'GE', 'Georgia', 'EURO', '551', '239780', '23', '2796');
INSERT INTO public.who_global_data_import VALUES (31176, '2021-01-12', 'GE', 'Georgia', 'EURO', '1857', '241637', '24', '2820');
INSERT INTO public.who_global_data_import VALUES (31177, '2021-01-13', 'GE', 'Georgia', 'EURO', '1618', '243255', '26', '2846');
INSERT INTO public.who_global_data_import VALUES (31178, '2021-01-14', 'GE', 'Georgia', 'EURO', '1357', '244612', '21', '2867');
INSERT INTO public.who_global_data_import VALUES (31179, '2021-01-15', 'GE', 'Georgia', 'EURO', '1177', '245789', '26', '2893');
INSERT INTO public.who_global_data_import VALUES (31180, '2021-01-16', 'GE', 'Georgia', 'EURO', '1236', '247025', '23', '2916');
INSERT INTO public.who_global_data_import VALUES (31181, '2021-01-17', 'GE', 'Georgia', 'EURO', '780', '247805', '17', '2933');
INSERT INTO public.who_global_data_import VALUES (31182, '2021-01-18', 'GE', 'Georgia', 'EURO', '110', '247915', '25', '2958');
INSERT INTO public.who_global_data_import VALUES (31183, '2021-01-19', 'GE', 'Georgia', 'EURO', '1550', '249465', '15', '2973');
INSERT INTO public.who_global_data_import VALUES (31184, '2021-01-20', 'GE', 'Georgia', 'EURO', '469', '249934', '14', '2987');
INSERT INTO public.who_global_data_import VALUES (31185, '2021-01-21', 'GE', 'Georgia', 'EURO', '1137', '251071', '11', '2998');
INSERT INTO public.who_global_data_import VALUES (31186, '2021-01-22', 'GE', 'Georgia', 'EURO', '903', '251974', '24', '3022');
INSERT INTO public.who_global_data_import VALUES (31704, '2020-04-15', 'GH', 'Ghana', 'AFRO', '70', '636', '0', '8');
INSERT INTO public.who_global_data_import VALUES (31187, '2021-01-23', 'GE', 'Georgia', 'EURO', '998', '252972', '16', '3038');
INSERT INTO public.who_global_data_import VALUES (31188, '2021-01-24', 'GE', 'Georgia', 'EURO', '546', '253518', '17', '3055');
INSERT INTO public.who_global_data_import VALUES (31189, '2021-01-25', 'GE', 'Georgia', 'EURO', '298', '253816', '16', '3071');
INSERT INTO public.who_global_data_import VALUES (31190, '2021-01-26', 'GE', 'Georgia', 'EURO', '1006', '254822', '25', '3096');
INSERT INTO public.who_global_data_import VALUES (31191, '2021-01-27', 'GE', 'Georgia', 'EURO', '742', '255564', '12', '3108');
INSERT INTO public.who_global_data_import VALUES (31192, '2021-01-28', 'GE', 'Georgia', 'EURO', '723', '256287', '19', '3127');
INSERT INTO public.who_global_data_import VALUES (31193, '2021-01-29', 'GE', 'Georgia', 'EURO', '669', '256956', '21', '3148');
INSERT INTO public.who_global_data_import VALUES (31194, '2021-01-30', 'GE', 'Georgia', 'EURO', '676', '257632', '11', '3159');
INSERT INTO public.who_global_data_import VALUES (31195, '2021-01-31', 'GE', 'Georgia', 'EURO', '479', '258111', '19', '3178');
INSERT INTO public.who_global_data_import VALUES (31196, '2021-02-01', 'GE', 'Georgia', 'EURO', '240', '258351', '16', '3194');
INSERT INTO public.who_global_data_import VALUES (31197, '2021-02-02', 'GE', 'Georgia', 'EURO', '858', '259209', '14', '3208');
INSERT INTO public.who_global_data_import VALUES (31198, '2021-02-03', 'GE', 'Georgia', 'EURO', '688', '259897', '13', '3221');
INSERT INTO public.who_global_data_import VALUES (31199, '2021-02-04', 'GE', 'Georgia', 'EURO', '583', '260480', '19', '3240');
INSERT INTO public.who_global_data_import VALUES (31200, '2021-02-05', 'GE', 'Georgia', 'EURO', '538', '261018', '18', '3258');
INSERT INTO public.who_global_data_import VALUES (31201, '2020-01-03', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31202, '2020-01-04', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31203, '2020-01-05', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31204, '2020-01-06', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31205, '2020-01-07', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31206, '2020-01-08', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31207, '2020-01-09', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31208, '2020-01-10', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31209, '2020-01-11', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31210, '2020-01-12', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31211, '2020-01-13', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31212, '2020-01-14', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31213, '2020-01-15', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31214, '2020-01-16', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31215, '2020-01-17', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31216, '2020-01-18', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31217, '2020-01-19', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31218, '2020-01-20', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31219, '2020-01-21', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31220, '2020-01-22', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31221, '2020-01-23', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31222, '2020-01-24', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31223, '2020-01-25', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31224, '2020-01-26', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31225, '2020-01-27', 'DE', 'Germany', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31226, '2020-01-28', 'DE', 'Germany', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31227, '2020-01-29', 'DE', 'Germany', 'EURO', '3', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31228, '2020-01-30', 'DE', 'Germany', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31229, '2020-01-31', 'DE', 'Germany', 'EURO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31230, '2020-02-01', 'DE', 'Germany', 'EURO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31231, '2020-02-02', 'DE', 'Germany', 'EURO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31232, '2020-02-03', 'DE', 'Germany', 'EURO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31233, '2020-02-04', 'DE', 'Germany', 'EURO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31234, '2020-02-05', 'DE', 'Germany', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31235, '2020-02-06', 'DE', 'Germany', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31236, '2020-02-07', 'DE', 'Germany', 'EURO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31237, '2020-02-08', 'DE', 'Germany', 'EURO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31238, '2020-02-09', 'DE', 'Germany', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31239, '2020-02-10', 'DE', 'Germany', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31240, '2020-02-11', 'DE', 'Germany', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31241, '2020-02-12', 'DE', 'Germany', 'EURO', '2', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31242, '2020-02-13', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31243, '2020-02-14', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31244, '2020-02-15', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31245, '2020-02-16', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31246, '2020-02-17', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31247, '2020-02-18', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31248, '2020-02-19', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31249, '2020-02-20', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31250, '2020-02-21', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31251, '2020-02-22', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31252, '2020-02-23', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31253, '2020-02-24', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31254, '2020-02-25', 'DE', 'Germany', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31255, '2020-02-26', 'DE', 'Germany', 'EURO', '2', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31256, '2020-02-27', 'DE', 'Germany', 'EURO', '4', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31257, '2020-02-28', 'DE', 'Germany', 'EURO', '26', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31258, '2020-02-29', 'DE', 'Germany', 'EURO', '10', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31259, '2020-03-01', 'DE', 'Germany', 'EURO', '54', '111', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31260, '2020-03-02', 'DE', 'Germany', 'EURO', '18', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31261, '2020-03-03', 'DE', 'Germany', 'EURO', '28', '157', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31262, '2020-03-04', 'DE', 'Germany', 'EURO', '39', '196', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31263, '2020-03-05', 'DE', 'Germany', 'EURO', '66', '262', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31264, '2020-03-06', 'DE', 'Germany', 'EURO', '138', '400', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31265, '2020-03-07', 'DE', 'Germany', 'EURO', '284', '684', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31266, '2020-03-08', 'DE', 'Germany', 'EURO', '163', '847', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31267, '2020-03-09', 'DE', 'Germany', 'EURO', '55', '902', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31268, '2020-03-10', 'DE', 'Germany', 'EURO', '237', '1139', '2', '2');
INSERT INTO public.who_global_data_import VALUES (31269, '2020-03-11', 'DE', 'Germany', 'EURO', '157', '1296', '0', '2');
INSERT INTO public.who_global_data_import VALUES (31270, '2020-03-12', 'DE', 'Germany', 'EURO', '271', '1567', '1', '3');
INSERT INTO public.who_global_data_import VALUES (31271, '2020-03-13', 'DE', 'Germany', 'EURO', '802', '2369', '2', '5');
INSERT INTO public.who_global_data_import VALUES (31272, '2020-03-14', 'DE', 'Germany', 'EURO', '693', '3062', '0', '5');
INSERT INTO public.who_global_data_import VALUES (31273, '2020-03-15', 'DE', 'Germany', 'EURO', '733', '3795', '3', '8');
INSERT INTO public.who_global_data_import VALUES (31274, '2020-03-16', 'DE', 'Germany', 'EURO', '1043', '4838', '4', '12');
INSERT INTO public.who_global_data_import VALUES (31275, '2020-03-17', 'DE', 'Germany', 'EURO', '1174', '6012', '1', '13');
INSERT INTO public.who_global_data_import VALUES (31276, '2020-03-18', 'DE', 'Germany', 'EURO', '1144', '7156', '0', '13');
INSERT INTO public.who_global_data_import VALUES (31277, '2020-03-19', 'DE', 'Germany', 'EURO', '1042', '8198', '0', '13');
INSERT INTO public.who_global_data_import VALUES (31278, '2020-03-20', 'DE', 'Germany', 'EURO', '5940', '14138', '30', '43');
INSERT INTO public.who_global_data_import VALUES (31279, '2020-03-21', 'DE', 'Germany', 'EURO', '4049', '18187', '2', '45');
INSERT INTO public.who_global_data_import VALUES (31280, '2020-03-22', 'DE', 'Germany', 'EURO', '3276', '21463', '22', '67');
INSERT INTO public.who_global_data_import VALUES (31281, '2020-03-23', 'DE', 'Germany', 'EURO', '3311', '24774', '27', '94');
INSERT INTO public.who_global_data_import VALUES (31282, '2020-03-24', 'DE', 'Germany', 'EURO', '4438', '29212', '32', '126');
INSERT INTO public.who_global_data_import VALUES (31283, '2020-03-25', 'DE', 'Germany', 'EURO', '2342', '31554', '23', '149');
INSERT INTO public.who_global_data_import VALUES (31284, '2020-03-26', 'DE', 'Germany', 'EURO', '4954', '36508', '49', '198');
INSERT INTO public.who_global_data_import VALUES (31285, '2020-03-27', 'DE', 'Germany', 'EURO', '5780', '42288', '55', '253');
INSERT INTO public.who_global_data_import VALUES (31286, '2020-03-28', 'DE', 'Germany', 'EURO', '6294', '48582', '72', '325');
INSERT INTO public.who_global_data_import VALUES (31287, '2020-03-29', 'DE', 'Germany', 'EURO', '3965', '52547', '64', '389');
INSERT INTO public.who_global_data_import VALUES (31288, '2020-03-30', 'DE', 'Germany', 'EURO', '4751', '57298', '66', '455');
INSERT INTO public.who_global_data_import VALUES (31289, '2020-03-31', 'DE', 'Germany', 'EURO', '4615', '61913', '128', '583');
INSERT INTO public.who_global_data_import VALUES (31290, '2020-04-01', 'DE', 'Germany', 'EURO', '5453', '67366', '149', '732');
INSERT INTO public.who_global_data_import VALUES (31291, '2020-04-02', 'DE', 'Germany', 'EURO', '6156', '73522', '140', '872');
INSERT INTO public.who_global_data_import VALUES (31292, '2020-04-03', 'DE', 'Germany', 'EURO', '6174', '79696', '145', '1017');
INSERT INTO public.who_global_data_import VALUES (31293, '2020-04-04', 'DE', 'Germany', 'EURO', '6082', '85778', '141', '1158');
INSERT INTO public.who_global_data_import VALUES (31294, '2020-04-05', 'DE', 'Germany', 'EURO', '5936', '91714', '184', '1342');
INSERT INTO public.who_global_data_import VALUES (31295, '2020-04-06', 'DE', 'Germany', 'EURO', '3677', '95391', '92', '1434');
INSERT INTO public.who_global_data_import VALUES (31296, '2020-04-07', 'DE', 'Germany', 'EURO', '3834', '99225', '173', '1607');
INSERT INTO public.who_global_data_import VALUES (31297, '2020-04-08', 'DE', 'Germany', 'EURO', '4003', '103228', '254', '1861');
INSERT INTO public.who_global_data_import VALUES (31298, '2020-04-09', 'DE', 'Germany', 'EURO', '4974', '108202', '246', '2107');
INSERT INTO public.who_global_data_import VALUES (31299, '2020-04-10', 'DE', 'Germany', 'EURO', '5323', '113525', '266', '2373');
INSERT INTO public.who_global_data_import VALUES (31300, '2020-04-11', 'DE', 'Germany', 'EURO', '4133', '117658', '171', '2544');
INSERT INTO public.who_global_data_import VALUES (31301, '2020-04-12', 'DE', 'Germany', 'EURO', '2821', '120479', '129', '2673');
INSERT INTO public.who_global_data_import VALUES (31302, '2020-04-13', 'DE', 'Germany', 'EURO', '2537', '123016', '126', '2799');
INSERT INTO public.who_global_data_import VALUES (31303, '2020-04-14', 'DE', 'Germany', 'EURO', '2082', '125098', '170', '2969');
INSERT INTO public.who_global_data_import VALUES (31304, '2020-04-15', 'DE', 'Germany', 'EURO', '2486', '127584', '285', '3254');
INSERT INTO public.who_global_data_import VALUES (31305, '2020-04-16', 'DE', 'Germany', 'EURO', '2866', '130450', '315', '3569');
INSERT INTO public.who_global_data_import VALUES (31306, '2020-04-17', 'DE', 'Germany', 'EURO', '3380', '133830', '299', '3868');
INSERT INTO public.who_global_data_import VALUES (31307, '2020-04-18', 'DE', 'Germany', 'EURO', '3609', '137439', '242', '4110');
INSERT INTO public.who_global_data_import VALUES (31308, '2020-04-19', 'DE', 'Germany', 'EURO', '2458', '139897', '184', '4294');
INSERT INTO public.who_global_data_import VALUES (31309, '2020-04-20', 'DE', 'Germany', 'EURO', '1775', '141672', '110', '4404');
INSERT INTO public.who_global_data_import VALUES (31310, '2020-04-21', 'DE', 'Germany', 'EURO', '1785', '143457', '194', '4598');
INSERT INTO public.who_global_data_import VALUES (31311, '2020-04-22', 'DE', 'Germany', 'EURO', '2237', '145694', '281', '4879');
INSERT INTO public.who_global_data_import VALUES (31312, '2020-04-23', 'DE', 'Germany', 'EURO', '2352', '148046', '215', '5094');
INSERT INTO public.who_global_data_import VALUES (31313, '2020-04-24', 'DE', 'Germany', 'EURO', '2337', '150383', '227', '5321');
INSERT INTO public.who_global_data_import VALUES (31314, '2020-04-25', 'DE', 'Germany', 'EURO', '2055', '152438', '179', '5500');
INSERT INTO public.who_global_data_import VALUES (31315, '2020-04-26', 'DE', 'Germany', 'EURO', '1737', '154175', '140', '5640');
INSERT INTO public.who_global_data_import VALUES (31316, '2020-04-27', 'DE', 'Germany', 'EURO', '1018', '155193', '110', '5750');
INSERT INTO public.who_global_data_import VALUES (31317, '2020-04-28', 'DE', 'Germany', 'EURO', '1144', '156337', '163', '5913');
INSERT INTO public.who_global_data_import VALUES (31318, '2020-04-29', 'DE', 'Germany', 'EURO', '1304', '157641', '202', '6115');
INSERT INTO public.who_global_data_import VALUES (31319, '2020-04-30', 'DE', 'Germany', 'EURO', '1478', '159119', '173', '6288');
INSERT INTO public.who_global_data_import VALUES (31320, '2020-05-01', 'DE', 'Germany', 'EURO', '1639', '160758', '193', '6481');
INSERT INTO public.who_global_data_import VALUES (31321, '2020-05-02', 'DE', 'Germany', 'EURO', '945', '161703', '94', '6575');
INSERT INTO public.who_global_data_import VALUES (31322, '2020-05-03', 'DE', 'Germany', 'EURO', '793', '162496', '74', '6649');
INSERT INTO public.who_global_data_import VALUES (31323, '2020-05-04', 'DE', 'Germany', 'EURO', '679', '163175', '43', '6692');
INSERT INTO public.who_global_data_import VALUES (31324, '2020-05-05', 'DE', 'Germany', 'EURO', '685', '163860', '139', '6831');
INSERT INTO public.who_global_data_import VALUES (31325, '2020-05-06', 'DE', 'Germany', 'EURO', '947', '164807', '165', '6996');
INSERT INTO public.who_global_data_import VALUES (31326, '2020-05-07', 'DE', 'Germany', 'EURO', '1284', '166091', '123', '7119');
INSERT INTO public.who_global_data_import VALUES (31327, '2020-05-08', 'DE', 'Germany', 'EURO', '1209', '167300', '147', '7266');
INSERT INTO public.who_global_data_import VALUES (31328, '2020-05-09', 'DE', 'Germany', 'EURO', '1251', '168551', '103', '7369');
INSERT INTO public.who_global_data_import VALUES (31329, '2020-05-10', 'DE', 'Germany', 'EURO', '667', '169218', '26', '7395');
INSERT INTO public.who_global_data_import VALUES (31330, '2020-05-11', 'DE', 'Germany', 'EURO', '357', '169575', '22', '7417');
INSERT INTO public.who_global_data_import VALUES (31331, '2020-05-12', 'DE', 'Germany', 'EURO', '933', '170508', '116', '7533');
INSERT INTO public.who_global_data_import VALUES (31332, '2020-05-13', 'DE', 'Germany', 'EURO', '798', '171306', '101', '7634');
INSERT INTO public.who_global_data_import VALUES (31333, '2020-05-14', 'DE', 'Germany', 'EURO', '933', '172239', '89', '7723');
INSERT INTO public.who_global_data_import VALUES (31334, '2020-05-15', 'DE', 'Germany', 'EURO', '913', '173152', '101', '7824');
INSERT INTO public.who_global_data_import VALUES (31335, '2020-05-16', 'DE', 'Germany', 'EURO', '620', '173772', '57', '7881');
INSERT INTO public.who_global_data_import VALUES (31336, '2020-05-17', 'DE', 'Germany', 'EURO', '583', '174355', '33', '7914');
INSERT INTO public.who_global_data_import VALUES (31337, '2020-05-18', 'DE', 'Germany', 'EURO', '342', '174697', '21', '7935');
INSERT INTO public.who_global_data_import VALUES (31338, '2020-05-19', 'DE', 'Germany', 'EURO', '513', '175210', '72', '8007');
INSERT INTO public.who_global_data_import VALUES (31339, '2020-05-20', 'DE', 'Germany', 'EURO', '797', '176007', '83', '8090');
INSERT INTO public.who_global_data_import VALUES (31340, '2020-05-21', 'DE', 'Germany', 'EURO', '745', '176752', '57', '8147');
INSERT INTO public.who_global_data_import VALUES (31341, '2020-05-22', 'DE', 'Germany', 'EURO', '460', '177212', '27', '8174');
INSERT INTO public.who_global_data_import VALUES (31342, '2020-05-23', 'DE', 'Germany', 'EURO', '638', '177850', '42', '8216');
INSERT INTO public.who_global_data_import VALUES (31343, '2020-05-24', 'DE', 'Germany', 'EURO', '431', '178281', '31', '8247');
INSERT INTO public.who_global_data_import VALUES (31344, '2020-05-25', 'DE', 'Germany', 'EURO', '289', '178570', '10', '8257');
INSERT INTO public.who_global_data_import VALUES (31345, '2020-05-26', 'DE', 'Germany', 'EURO', '432', '179002', '45', '8302');
INSERT INTO public.who_global_data_import VALUES (31346, '2020-05-27', 'DE', 'Germany', 'EURO', '362', '179364', '47', '8349');
INSERT INTO public.who_global_data_import VALUES (31347, '2020-05-28', 'DE', 'Germany', 'EURO', '353', '179717', '62', '8411');
INSERT INTO public.who_global_data_import VALUES (31348, '2020-05-29', 'DE', 'Germany', 'EURO', '741', '180458', '39', '8450');
INSERT INTO public.who_global_data_import VALUES (31349, '2020-05-30', 'DE', 'Germany', 'EURO', '738', '181196', '39', '8489');
INSERT INTO public.who_global_data_import VALUES (31350, '2020-05-31', 'DE', 'Germany', 'EURO', '286', '181482', '11', '8500');
INSERT INTO public.who_global_data_import VALUES (31351, '2020-06-01', 'DE', 'Germany', 'EURO', '333', '181815', '11', '8511');
INSERT INTO public.who_global_data_import VALUES (31352, '2020-06-02', 'DE', 'Germany', 'EURO', '213', '182028', '11', '8522');
INSERT INTO public.who_global_data_import VALUES (31353, '2020-06-03', 'DE', 'Germany', 'EURO', '342', '182370', '29', '8551');
INSERT INTO public.who_global_data_import VALUES (31354, '2020-06-04', 'DE', 'Germany', 'EURO', '394', '182764', '30', '8581');
INSERT INTO public.who_global_data_import VALUES (31355, '2020-06-05', 'DE', 'Germany', 'EURO', '507', '183271', '32', '8613');
INSERT INTO public.who_global_data_import VALUES (31356, '2020-06-06', 'DE', 'Germany', 'EURO', '407', '183678', '33', '8646');
INSERT INTO public.who_global_data_import VALUES (31357, '2020-06-07', 'DE', 'Germany', 'EURO', '301', '183979', '22', '8668');
INSERT INTO public.who_global_data_import VALUES (31358, '2020-06-08', 'DE', 'Germany', 'EURO', '214', '184193', '6', '8674');
INSERT INTO public.who_global_data_import VALUES (31359, '2020-06-09', 'DE', 'Germany', 'EURO', '350', '184543', '37', '8711');
INSERT INTO public.who_global_data_import VALUES (31360, '2020-06-10', 'DE', 'Germany', 'EURO', '318', '184861', '18', '8729');
INSERT INTO public.who_global_data_import VALUES (31361, '2020-06-11', 'DE', 'Germany', 'EURO', '555', '185416', '26', '8755');
INSERT INTO public.who_global_data_import VALUES (31362, '2020-06-12', 'DE', 'Germany', 'EURO', '258', '185674', '8', '8763');
INSERT INTO public.who_global_data_import VALUES (31363, '2020-06-13', 'DE', 'Germany', 'EURO', '348', '186022', '18', '8781');
INSERT INTO public.who_global_data_import VALUES (31364, '2020-06-14', 'DE', 'Germany', 'EURO', '247', '186269', '6', '8787');
INSERT INTO public.who_global_data_import VALUES (31365, '2020-06-15', 'DE', 'Germany', 'EURO', '192', '186461', '4', '8791');
INSERT INTO public.who_global_data_import VALUES (31366, '2020-06-16', 'DE', 'Germany', 'EURO', '378', '186839', '9', '8800');
INSERT INTO public.who_global_data_import VALUES (31367, '2020-06-17', 'DE', 'Germany', 'EURO', '345', '187184', '30', '8830');
INSERT INTO public.who_global_data_import VALUES (31368, '2020-06-18', 'DE', 'Germany', 'EURO', '580', '187764', '26', '8856');
INSERT INTO public.who_global_data_import VALUES (31369, '2020-06-19', 'DE', 'Germany', 'EURO', '770', '188534', '16', '8872');
INSERT INTO public.who_global_data_import VALUES (31370, '2020-06-20', 'DE', 'Germany', 'EURO', '601', '189135', '10', '8882');
INSERT INTO public.who_global_data_import VALUES (31371, '2020-06-21', 'DE', 'Germany', 'EURO', '687', '189822', '0', '8882');
INSERT INTO public.who_global_data_import VALUES (31372, '2020-06-22', 'DE', 'Germany', 'EURO', '537', '190359', '3', '8885');
INSERT INTO public.who_global_data_import VALUES (31373, '2020-06-23', 'DE', 'Germany', 'EURO', '503', '190862', '10', '8895');
INSERT INTO public.who_global_data_import VALUES (31374, '2020-06-24', 'DE', 'Germany', 'EURO', '587', '191449', '19', '8914');
INSERT INTO public.who_global_data_import VALUES (31375, '2020-06-25', 'DE', 'Germany', 'EURO', '630', '192079', '13', '8927');
INSERT INTO public.who_global_data_import VALUES (31376, '2020-06-26', 'DE', 'Germany', 'EURO', '477', '192556', '21', '8948');
INSERT INTO public.who_global_data_import VALUES (31377, '2020-06-27', 'DE', 'Germany', 'EURO', '687', '193243', '6', '8954');
INSERT INTO public.who_global_data_import VALUES (31378, '2020-06-28', 'DE', 'Germany', 'EURO', '256', '193499', '3', '8957');
INSERT INTO public.who_global_data_import VALUES (31379, '2020-06-29', 'DE', 'Germany', 'EURO', '262', '193761', '4', '8961');
INSERT INTO public.who_global_data_import VALUES (31380, '2020-06-30', 'DE', 'Germany', 'EURO', '498', '194259', '12', '8973');
INSERT INTO public.who_global_data_import VALUES (31381, '2020-07-01', 'DE', 'Germany', 'EURO', '466', '194725', '12', '8985');
INSERT INTO public.who_global_data_import VALUES (31382, '2020-07-02', 'DE', 'Germany', 'EURO', '503', '195228', '9', '8994');
INSERT INTO public.who_global_data_import VALUES (31383, '2020-07-03', 'DE', 'Germany', 'EURO', '446', '195674', '9', '9003');
INSERT INTO public.who_global_data_import VALUES (31384, '2020-07-04', 'DE', 'Germany', 'EURO', '422', '196096', '7', '9010');
INSERT INTO public.who_global_data_import VALUES (31385, '2020-07-05', 'DE', 'Germany', 'EURO', '239', '196335', '2', '9012');
INSERT INTO public.who_global_data_import VALUES (31386, '2020-07-06', 'DE', 'Germany', 'EURO', '219', '196554', '4', '9016');
INSERT INTO public.who_global_data_import VALUES (31387, '2020-07-07', 'DE', 'Germany', 'EURO', '390', '196944', '8', '9024');
INSERT INTO public.who_global_data_import VALUES (31388, '2020-07-08', 'DE', 'Germany', 'EURO', '397', '197341', '12', '9036');
INSERT INTO public.who_global_data_import VALUES (31389, '2020-07-09', 'DE', 'Germany', 'EURO', '442', '197783', '12', '9048');
INSERT INTO public.who_global_data_import VALUES (31390, '2020-07-10', 'DE', 'Germany', 'EURO', '395', '198178', '6', '9054');
INSERT INTO public.who_global_data_import VALUES (31391, '2020-07-11', 'DE', 'Germany', 'EURO', '378', '198556', '6', '9060');
INSERT INTO public.who_global_data_import VALUES (31392, '2020-07-12', 'DE', 'Germany', 'EURO', '248', '198804', '3', '9063');
INSERT INTO public.who_global_data_import VALUES (31393, '2020-07-13', 'DE', 'Germany', 'EURO', '159', '198963', '1', '9064');
INSERT INTO public.who_global_data_import VALUES (31394, '2020-07-14', 'DE', 'Germany', 'EURO', '412', '199375', '4', '9068');
INSERT INTO public.who_global_data_import VALUES (31395, '2020-07-15', 'DE', 'Germany', 'EURO', '351', '199726', '3', '9071');
INSERT INTO public.who_global_data_import VALUES (31396, '2020-07-16', 'DE', 'Germany', 'EURO', '534', '200260', '7', '9078');
INSERT INTO public.who_global_data_import VALUES (31397, '2020-07-17', 'DE', 'Germany', 'EURO', '583', '200843', '4', '9082');
INSERT INTO public.who_global_data_import VALUES (31398, '2020-07-18', 'DE', 'Germany', 'EURO', '529', '201372', '1', '9083');
INSERT INTO public.who_global_data_import VALUES (31399, '2020-07-19', 'DE', 'Germany', 'EURO', '202', '201574', '1', '9084');
INSERT INTO public.who_global_data_import VALUES (31400, '2020-07-20', 'DE', 'Germany', 'EURO', '249', '201823', '2', '9086');
INSERT INTO public.who_global_data_import VALUES (31401, '2020-07-21', 'DE', 'Germany', 'EURO', '522', '202345', '4', '9090');
INSERT INTO public.who_global_data_import VALUES (31402, '2020-07-22', 'DE', 'Germany', 'EURO', '454', '202799', '5', '9095');
INSERT INTO public.who_global_data_import VALUES (31403, '2020-07-23', 'DE', 'Germany', 'EURO', '569', '203368', '6', '9101');
INSERT INTO public.who_global_data_import VALUES (31404, '2020-07-24', 'DE', 'Germany', 'EURO', '815', '204183', '10', '9111');
INSERT INTO public.who_global_data_import VALUES (31405, '2020-07-25', 'DE', 'Germany', 'EURO', '781', '204964', '7', '9118');
INSERT INTO public.who_global_data_import VALUES (31406, '2020-07-26', 'DE', 'Germany', 'EURO', '305', '205269', '0', '9118');
INSERT INTO public.who_global_data_import VALUES (31407, '2020-07-27', 'DE', 'Germany', 'EURO', '340', '205609', '0', '9118');
INSERT INTO public.who_global_data_import VALUES (31408, '2020-07-28', 'DE', 'Germany', 'EURO', '633', '206242', '4', '9122');
INSERT INTO public.who_global_data_import VALUES (31409, '2020-07-29', 'DE', 'Germany', 'EURO', '684', '206926', '6', '9128');
INSERT INTO public.who_global_data_import VALUES (31410, '2020-07-30', 'DE', 'Germany', 'EURO', '902', '207828', '6', '9134');
INSERT INTO public.who_global_data_import VALUES (31411, '2020-07-31', 'DE', 'Germany', 'EURO', '870', '208698', '7', '9141');
INSERT INTO public.who_global_data_import VALUES (31412, '2020-08-01', 'DE', 'Germany', 'EURO', '955', '209653', '0', '9141');
INSERT INTO public.who_global_data_import VALUES (31413, '2020-08-02', 'DE', 'Germany', 'EURO', '240', '209893', '0', '9141');
INSERT INTO public.who_global_data_import VALUES (31414, '2020-08-03', 'DE', 'Germany', 'EURO', '509', '210402', '7', '9148');
INSERT INTO public.who_global_data_import VALUES (31415, '2020-08-04', 'DE', 'Germany', 'EURO', '879', '211281', '8', '9156');
INSERT INTO public.who_global_data_import VALUES (31416, '2020-08-05', 'DE', 'Germany', 'EURO', '741', '212022', '12', '9168');
INSERT INTO public.who_global_data_import VALUES (31417, '2020-08-06', 'DE', 'Germany', 'EURO', '1045', '213067', '7', '9175');
INSERT INTO public.who_global_data_import VALUES (31418, '2020-08-07', 'DE', 'Germany', 'EURO', '1147', '214214', '8', '9183');
INSERT INTO public.who_global_data_import VALUES (31419, '2020-08-08', 'DE', 'Germany', 'EURO', '1122', '215336', '12', '9195');
INSERT INTO public.who_global_data_import VALUES (31420, '2020-08-09', 'DE', 'Germany', 'EURO', '555', '215891', '1', '9196');
INSERT INTO public.who_global_data_import VALUES (31421, '2020-08-10', 'DE', 'Germany', 'EURO', '436', '216327', '1', '9197');
INSERT INTO public.who_global_data_import VALUES (31422, '2020-08-11', 'DE', 'Germany', 'EURO', '966', '217293', '4', '9201');
INSERT INTO public.who_global_data_import VALUES (31423, '2020-08-12', 'DE', 'Germany', 'EURO', '1226', '218519', '6', '9207');
INSERT INTO public.who_global_data_import VALUES (31424, '2020-08-13', 'DE', 'Germany', 'EURO', '1445', '219964', '4', '9211');
INSERT INTO public.who_global_data_import VALUES (31425, '2020-08-14', 'DE', 'Germany', 'EURO', '1449', '221413', '14', '9225');
INSERT INTO public.who_global_data_import VALUES (31426, '2020-08-15', 'DE', 'Germany', 'EURO', '1415', '222828', '6', '9231');
INSERT INTO public.who_global_data_import VALUES (31427, '2020-08-16', 'DE', 'Germany', 'EURO', '625', '223453', '0', '9231');
INSERT INTO public.who_global_data_import VALUES (31428, '2020-08-17', 'DE', 'Germany', 'EURO', '561', '224014', '1', '9232');
INSERT INTO public.who_global_data_import VALUES (31429, '2020-08-18', 'DE', 'Germany', 'EURO', '1390', '225404', '4', '9236');
INSERT INTO public.who_global_data_import VALUES (31430, '2020-08-19', 'DE', 'Germany', 'EURO', '1510', '226914', '7', '9243');
INSERT INTO public.who_global_data_import VALUES (31431, '2020-08-20', 'DE', 'Germany', 'EURO', '1707', '228621', '10', '9253');
INSERT INTO public.who_global_data_import VALUES (31432, '2020-08-21', 'DE', 'Germany', 'EURO', '1427', '230048', '7', '9260');
INSERT INTO public.who_global_data_import VALUES (31433, '2020-08-22', 'DE', 'Germany', 'EURO', '2034', '232082', '7', '9267');
INSERT INTO public.who_global_data_import VALUES (31434, '2020-08-23', 'DE', 'Germany', 'EURO', '782', '232864', '2', '9269');
INSERT INTO public.who_global_data_import VALUES (31435, '2020-08-24', 'DE', 'Germany', 'EURO', '711', '233575', '3', '9272');
INSERT INTO public.who_global_data_import VALUES (31436, '2020-08-25', 'DE', 'Germany', 'EURO', '1278', '234853', '5', '9277');
INSERT INTO public.who_global_data_import VALUES (31437, '2020-08-26', 'DE', 'Germany', 'EURO', '1576', '236429', '3', '9280');
INSERT INTO public.who_global_data_import VALUES (31438, '2020-08-27', 'DE', 'Germany', 'EURO', '1507', '237936', '5', '9285');
INSERT INTO public.who_global_data_import VALUES (31439, '2020-08-28', 'DE', 'Germany', 'EURO', '1571', '239507', '3', '9288');
INSERT INTO public.who_global_data_import VALUES (31440, '2020-08-29', 'DE', 'Germany', 'EURO', '1479', '240986', '1', '9289');
INSERT INTO public.who_global_data_import VALUES (31441, '2020-08-30', 'DE', 'Germany', 'EURO', '785', '241771', '6', '9295');
INSERT INTO public.who_global_data_import VALUES (31442, '2020-08-31', 'DE', 'Germany', 'EURO', '610', '242381', '3', '9298');
INSERT INTO public.who_global_data_import VALUES (31443, '2020-09-01', 'DE', 'Germany', 'EURO', '1218', '243599', '4', '9302');
INSERT INTO public.who_global_data_import VALUES (31444, '2020-09-02', 'DE', 'Germany', 'EURO', '1256', '244855', '11', '9313');
INSERT INTO public.who_global_data_import VALUES (31445, '2020-09-03', 'DE', 'Germany', 'EURO', '1311', '246166', '8', '9321');
INSERT INTO public.who_global_data_import VALUES (31446, '2020-09-04', 'DE', 'Germany', 'EURO', '1453', '247619', '1', '9322');
INSERT INTO public.who_global_data_import VALUES (31447, '2020-09-05', 'DE', 'Germany', 'EURO', '1378', '248997', '2', '9324');
INSERT INTO public.who_global_data_import VALUES (31448, '2020-09-06', 'DE', 'Germany', 'EURO', '988', '249985', '1', '9325');
INSERT INTO public.who_global_data_import VALUES (31449, '2020-09-07', 'DE', 'Germany', 'EURO', '814', '250799', '0', '9325');
INSERT INTO public.who_global_data_import VALUES (31450, '2020-09-08', 'DE', 'Germany', 'EURO', '1499', '252298', '4', '9329');
INSERT INTO public.who_global_data_import VALUES (31451, '2020-09-09', 'DE', 'Germany', 'EURO', '1176', '253474', '9', '9338');
INSERT INTO public.who_global_data_import VALUES (31452, '2020-09-10', 'DE', 'Germany', 'EURO', '1892', '255366', '3', '9341');
INSERT INTO public.who_global_data_import VALUES (31453, '2020-09-11', 'DE', 'Germany', 'EURO', '1484', '256850', '1', '9342');
INSERT INTO public.who_global_data_import VALUES (31454, '2020-09-12', 'DE', 'Germany', 'EURO', '1630', '258480', '5', '9347');
INSERT INTO public.who_global_data_import VALUES (31455, '2020-09-13', 'DE', 'Germany', 'EURO', '948', '259428', '2', '9349');
INSERT INTO public.who_global_data_import VALUES (31456, '2020-09-14', 'DE', 'Germany', 'EURO', '927', '260355', '1', '9350');
INSERT INTO public.who_global_data_import VALUES (31457, '2020-09-15', 'DE', 'Germany', 'EURO', '1407', '261762', '12', '9362');
INSERT INTO public.who_global_data_import VALUES (31458, '2020-09-16', 'DE', 'Germany', 'EURO', '1901', '263663', '6', '9368');
INSERT INTO public.who_global_data_import VALUES (31459, '2020-09-17', 'DE', 'Germany', 'EURO', '2194', '265857', '3', '9371');
INSERT INTO public.who_global_data_import VALUES (31460, '2020-09-18', 'DE', 'Germany', 'EURO', '1916', '267773', '7', '9378');
INSERT INTO public.who_global_data_import VALUES (31461, '2020-09-19', 'DE', 'Germany', 'EURO', '2297', '270070', '6', '9384');
INSERT INTO public.who_global_data_import VALUES (31462, '2020-09-20', 'DE', 'Germany', 'EURO', '1345', '271415', '2', '9386');
INSERT INTO public.who_global_data_import VALUES (31463, '2020-09-21', 'DE', 'Germany', 'EURO', '922', '272337', '0', '9386');
INSERT INTO public.who_global_data_import VALUES (31464, '2020-09-22', 'DE', 'Germany', 'EURO', '1821', '274158', '10', '9396');
INSERT INTO public.who_global_data_import VALUES (31465, '2020-09-23', 'DE', 'Germany', 'EURO', '1769', '275927', '13', '9409');
INSERT INTO public.who_global_data_import VALUES (31466, '2020-09-24', 'DE', 'Germany', 'EURO', '2143', '278070', '19', '9428');
INSERT INTO public.who_global_data_import VALUES (31467, '2020-09-25', 'DE', 'Germany', 'EURO', '2153', '280223', '15', '9443');
INSERT INTO public.who_global_data_import VALUES (31468, '2020-09-26', 'DE', 'Germany', 'EURO', '2507', '282730', '9', '9452');
INSERT INTO public.who_global_data_import VALUES (31469, '2020-09-27', 'DE', 'Germany', 'EURO', '1410', '284140', '5', '9457');
INSERT INTO public.who_global_data_import VALUES (31470, '2020-09-28', 'DE', 'Germany', 'EURO', '1192', '285332', '3', '9460');
INSERT INTO public.who_global_data_import VALUES (31471, '2020-09-29', 'DE', 'Germany', 'EURO', '2089', '287421', '11', '9471');
INSERT INTO public.who_global_data_import VALUES (31472, '2020-09-30', 'DE', 'Germany', 'EURO', '1798', '289219', '17', '9488');
INSERT INTO public.who_global_data_import VALUES (31473, '2020-10-01', 'DE', 'Germany', 'EURO', '2503', '291722', '12', '9500');
INSERT INTO public.who_global_data_import VALUES (31474, '2020-10-02', 'DE', 'Germany', 'EURO', '2673', '294395', '8', '9508');
INSERT INTO public.who_global_data_import VALUES (31475, '2020-10-03', 'DE', 'Germany', 'EURO', '2563', '296958', '19', '9527');
INSERT INTO public.who_global_data_import VALUES (31476, '2020-10-04', 'DE', 'Germany', 'EURO', '2279', '299237', '2', '9529');
INSERT INTO public.who_global_data_import VALUES (31477, '2020-10-05', 'DE', 'Germany', 'EURO', '1382', '300619', '5', '9534');
INSERT INTO public.who_global_data_import VALUES (31478, '2020-10-06', 'DE', 'Germany', 'EURO', '2639', '303258', '12', '9546');
INSERT INTO public.who_global_data_import VALUES (31479, '2020-10-07', 'DE', 'Germany', 'EURO', '2828', '306086', '16', '9562');
INSERT INTO public.who_global_data_import VALUES (31480, '2020-10-08', 'DE', 'Germany', 'EURO', '4058', '310144', '16', '9578');
INSERT INTO public.who_global_data_import VALUES (31481, '2020-10-09', 'DE', 'Germany', 'EURO', '4516', '314660', '11', '9589');
INSERT INTO public.who_global_data_import VALUES (31482, '2020-10-10', 'DE', 'Germany', 'EURO', '4721', '319381', '15', '9604');
INSERT INTO public.who_global_data_import VALUES (31483, '2020-10-11', 'DE', 'Germany', 'EURO', '3483', '322864', '11', '9615');
INSERT INTO public.who_global_data_import VALUES (31484, '2020-10-12', 'DE', 'Germany', 'EURO', '2467', '325331', '6', '9621');
INSERT INTO public.who_global_data_import VALUES (31485, '2020-10-13', 'DE', 'Germany', 'EURO', '4122', '329453', '13', '9634');
INSERT INTO public.who_global_data_import VALUES (31486, '2020-10-14', 'DE', 'Germany', 'EURO', '5132', '334585', '43', '9677');
INSERT INTO public.who_global_data_import VALUES (31487, '2020-10-15', 'DE', 'Germany', 'EURO', '6638', '341223', '33', '9710');
INSERT INTO public.who_global_data_import VALUES (31488, '2020-10-16', 'DE', 'Germany', 'EURO', '7334', '348557', '24', '9734');
INSERT INTO public.who_global_data_import VALUES (31489, '2020-10-17', 'DE', 'Germany', 'EURO', '7830', '356387', '33', '9767');
INSERT INTO public.who_global_data_import VALUES (31490, '2020-10-18', 'DE', 'Germany', 'EURO', '5587', '361974', '10', '9777');
INSERT INTO public.who_global_data_import VALUES (31491, '2020-10-19', 'DE', 'Germany', 'EURO', '4325', '366299', '12', '9789');
INSERT INTO public.who_global_data_import VALUES (31492, '2020-10-20', 'DE', 'Germany', 'EURO', '6868', '373167', '47', '9836');
INSERT INTO public.who_global_data_import VALUES (31493, '2020-10-21', 'DE', 'Germany', 'EURO', '7595', '380762', '39', '9875');
INSERT INTO public.who_global_data_import VALUES (31494, '2020-10-22', 'DE', 'Germany', 'EURO', '11287', '392049', '30', '9905');
INSERT INTO public.who_global_data_import VALUES (31495, '2020-10-23', 'DE', 'Germany', 'EURO', '11242', '403291', '49', '9954');
INSERT INTO public.who_global_data_import VALUES (31496, '2020-10-24', 'DE', 'Germany', 'EURO', '14714', '418005', '49', '10003');
INSERT INTO public.who_global_data_import VALUES (31497, '2020-10-25', 'DE', 'Germany', 'EURO', '11176', '429181', '29', '10032');
INSERT INTO public.who_global_data_import VALUES (31498, '2020-10-26', 'DE', 'Germany', 'EURO', '8685', '437866', '24', '10056');
INSERT INTO public.who_global_data_import VALUES (31499, '2020-10-27', 'DE', 'Germany', 'EURO', '11409', '449275', '42', '10098');
INSERT INTO public.who_global_data_import VALUES (31500, '2020-10-28', 'DE', 'Germany', 'EURO', '14964', '464239', '85', '10183');
INSERT INTO public.who_global_data_import VALUES (31501, '2020-10-29', 'DE', 'Germany', 'EURO', '16774', '481013', '89', '10272');
INSERT INTO public.who_global_data_import VALUES (31502, '2020-10-30', 'DE', 'Germany', 'EURO', '18681', '499694', '77', '10349');
INSERT INTO public.who_global_data_import VALUES (31503, '2020-10-31', 'DE', 'Germany', 'EURO', '19059', '518753', '103', '10452');
INSERT INTO public.who_global_data_import VALUES (31504, '2020-11-01', 'DE', 'Germany', 'EURO', '14177', '532930', '29', '10481');
INSERT INTO public.who_global_data_import VALUES (31505, '2020-11-02', 'DE', 'Germany', 'EURO', '12097', '545027', '49', '10530');
INSERT INTO public.who_global_data_import VALUES (31506, '2020-11-03', 'DE', 'Germany', 'EURO', '15352', '560379', '131', '10661');
INSERT INTO public.who_global_data_import VALUES (31507, '2020-11-04', 'DE', 'Germany', 'EURO', '17214', '577593', '151', '10812');
INSERT INTO public.who_global_data_import VALUES (31508, '2020-11-05', 'DE', 'Germany', 'EURO', '19990', '597583', '118', '10930');
INSERT INTO public.who_global_data_import VALUES (31509, '2020-11-06', 'DE', 'Germany', 'EURO', '21506', '619089', '166', '11096');
INSERT INTO public.who_global_data_import VALUES (31510, '2020-11-07', 'DE', 'Germany', 'EURO', '23399', '642488', '130', '11226');
INSERT INTO public.who_global_data_import VALUES (31511, '2020-11-08', 'DE', 'Germany', 'EURO', '16017', '658505', '63', '11289');
INSERT INTO public.who_global_data_import VALUES (31512, '2020-11-09', 'DE', 'Germany', 'EURO', '13363', '671868', '63', '11352');
INSERT INTO public.who_global_data_import VALUES (31513, '2020-11-10', 'DE', 'Germany', 'EURO', '15332', '687200', '154', '11506');
INSERT INTO public.who_global_data_import VALUES (31514, '2020-11-11', 'DE', 'Germany', 'EURO', '18487', '705687', '261', '11767');
INSERT INTO public.who_global_data_import VALUES (31515, '2020-11-12', 'DE', 'Germany', 'EURO', '21866', '727553', '215', '11982');
INSERT INTO public.who_global_data_import VALUES (31516, '2020-11-13', 'DE', 'Germany', 'EURO', '23542', '751095', '218', '12200');
INSERT INTO public.who_global_data_import VALUES (31517, '2020-11-14', 'DE', 'Germany', 'EURO', '22461', '773556', '178', '12378');
INSERT INTO public.who_global_data_import VALUES (31518, '2020-11-15', 'DE', 'Germany', 'EURO', '16947', '790503', '107', '12485');
INSERT INTO public.who_global_data_import VALUES (31519, '2020-11-16', 'DE', 'Germany', 'EURO', '10824', '801327', '62', '12547');
INSERT INTO public.who_global_data_import VALUES (31520, '2020-11-17', 'DE', 'Germany', 'EURO', '14419', '815746', '267', '12814');
INSERT INTO public.who_global_data_import VALUES (31521, '2020-11-18', 'DE', 'Germany', 'EURO', '17561', '833307', '305', '13119');
INSERT INTO public.who_global_data_import VALUES (31522, '2020-11-19', 'DE', 'Germany', 'EURO', '22609', '855916', '251', '13370');
INSERT INTO public.who_global_data_import VALUES (31523, '2020-11-20', 'DE', 'Germany', 'EURO', '23648', '879564', '260', '13630');
INSERT INTO public.who_global_data_import VALUES (31524, '2020-11-21', 'DE', 'Germany', 'EURO', '22964', '902528', '254', '13884');
INSERT INTO public.who_global_data_import VALUES (31525, '2020-11-22', 'DE', 'Germany', 'EURO', '15741', '918269', '138', '14022');
INSERT INTO public.who_global_data_import VALUES (31526, '2020-11-23', 'DE', 'Germany', 'EURO', '10864', '929133', '90', '14112');
INSERT INTO public.who_global_data_import VALUES (31527, '2020-11-24', 'DE', 'Germany', 'EURO', '13554', '942687', '249', '14361');
INSERT INTO public.who_global_data_import VALUES (31528, '2020-11-25', 'DE', 'Germany', 'EURO', '18633', '961320', '410', '14771');
INSERT INTO public.who_global_data_import VALUES (31529, '2020-11-26', 'DE', 'Germany', 'EURO', '22268', '983588', '389', '15160');
INSERT INTO public.who_global_data_import VALUES (31530, '2020-11-27', 'DE', 'Germany', 'EURO', '22806', '1006394', '426', '15586');
INSERT INTO public.who_global_data_import VALUES (31531, '2020-11-28', 'DE', 'Germany', 'EURO', '21695', '1028089', '379', '15965');
INSERT INTO public.who_global_data_import VALUES (31532, '2020-11-29', 'DE', 'Germany', 'EURO', '14611', '1042700', '158', '16123');
INSERT INTO public.who_global_data_import VALUES (31533, '2020-11-30', 'DE', 'Germany', 'EURO', '11169', '1053869', '125', '16248');
INSERT INTO public.who_global_data_import VALUES (31534, '2020-12-01', 'DE', 'Germany', 'EURO', '13604', '1067473', '388', '16636');
INSERT INTO public.who_global_data_import VALUES (31535, '2020-12-02', 'DE', 'Germany', 'EURO', '17270', '1084743', '487', '17123');
INSERT INTO public.who_global_data_import VALUES (31536, '2020-12-03', 'DE', 'Germany', 'EURO', '22046', '1106789', '479', '17602');
INSERT INTO public.who_global_data_import VALUES (31537, '2020-12-04', 'DE', 'Germany', 'EURO', '23448', '1130237', '432', '18034');
INSERT INTO public.who_global_data_import VALUES (31538, '2020-12-05', 'DE', 'Germany', 'EURO', '23318', '1153555', '483', '18517');
INSERT INTO public.who_global_data_import VALUES (31539, '2020-12-06', 'DE', 'Germany', 'EURO', '17767', '1171322', '255', '18772');
INSERT INTO public.who_global_data_import VALUES (31540, '2020-12-07', 'DE', 'Germany', 'EURO', '12332', '1183654', '147', '18919');
INSERT INTO public.who_global_data_import VALUES (31541, '2020-12-08', 'DE', 'Germany', 'EURO', '14055', '1197709', '423', '19342');
INSERT INTO public.who_global_data_import VALUES (31542, '2020-12-09', 'DE', 'Germany', 'EURO', '20815', '1218524', '590', '19932');
INSERT INTO public.who_global_data_import VALUES (31543, '2020-12-10', 'DE', 'Germany', 'EURO', '23679', '1242203', '440', '20372');
INSERT INTO public.who_global_data_import VALUES (31544, '2020-12-11', 'DE', 'Germany', 'EURO', '29875', '1272078', '598', '20970');
INSERT INTO public.who_global_data_import VALUES (31545, '2020-12-12', 'DE', 'Germany', 'EURO', '28438', '1300516', '496', '21466');
INSERT INTO public.who_global_data_import VALUES (31546, '2020-12-13', 'DE', 'Germany', 'EURO', '20200', '1320716', '321', '21787');
INSERT INTO public.who_global_data_import VALUES (31547, '2020-12-14', 'DE', 'Germany', 'EURO', '16362', '1337078', '188', '21975');
INSERT INTO public.who_global_data_import VALUES (31548, '2020-12-15', 'DE', 'Germany', 'EURO', '14432', '1351510', '500', '22475');
INSERT INTO public.who_global_data_import VALUES (31549, '2020-12-16', 'DE', 'Germany', 'EURO', '27728', '1379238', '952', '23427');
INSERT INTO public.who_global_data_import VALUES (31550, '2020-12-17', 'DE', 'Germany', 'EURO', '26923', '1406161', '698', '24125');
INSERT INTO public.who_global_data_import VALUES (31551, '2020-12-18', 'DE', 'Germany', 'EURO', '33777', '1439938', '813', '24938');
INSERT INTO public.who_global_data_import VALUES (31552, '2020-12-19', 'DE', 'Germany', 'EURO', '31300', '1471238', '702', '25640');
INSERT INTO public.who_global_data_import VALUES (31553, '2020-12-20', 'DE', 'Germany', 'EURO', '22771', '1494009', '409', '26049');
INSERT INTO public.who_global_data_import VALUES (31554, '2020-12-21', 'DE', 'Germany', 'EURO', '16643', '1510652', '226', '26275');
INSERT INTO public.who_global_data_import VALUES (31555, '2020-12-22', 'DE', 'Germany', 'EURO', '19528', '1530180', '731', '27006');
INSERT INTO public.who_global_data_import VALUES (31556, '2020-12-23', 'DE', 'Germany', 'EURO', '24740', '1554920', '962', '27968');
INSERT INTO public.who_global_data_import VALUES (31557, '2020-12-24', 'DE', 'Germany', 'EURO', '32195', '1587115', '802', '28770');
INSERT INTO public.who_global_data_import VALUES (31558, '2020-12-25', 'DE', 'Germany', 'EURO', '25533', '1612648', '412', '29182');
INSERT INTO public.who_global_data_import VALUES (31559, '2020-12-26', 'DE', 'Germany', 'EURO', '14455', '1627103', '240', '29422');
INSERT INTO public.who_global_data_import VALUES (31560, '2020-12-27', 'DE', 'Germany', 'EURO', '13755', '1640858', '356', '29778');
INSERT INTO public.who_global_data_import VALUES (31561, '2020-12-28', 'DE', 'Germany', 'EURO', '10976', '1651834', '348', '30126');
INSERT INTO public.who_global_data_import VALUES (31562, '2020-12-29', 'DE', 'Germany', 'EURO', '12892', '1664726', '852', '30978');
INSERT INTO public.who_global_data_import VALUES (31563, '2020-12-30', 'DE', 'Germany', 'EURO', '22459', '1687185', '1129', '32107');
INSERT INTO public.who_global_data_import VALUES (31564, '2020-12-31', 'DE', 'Germany', 'EURO', '32552', '1719737', '964', '33071');
INSERT INTO public.who_global_data_import VALUES (31565, '2021-01-01', 'DE', 'Germany', 'EURO', '22924', '1742661', '553', '33624');
INSERT INTO public.who_global_data_import VALUES (31566, '2021-01-02', 'DE', 'Germany', 'EURO', '12690', '1755351', '336', '33960');
INSERT INTO public.who_global_data_import VALUES (31567, '2021-01-03', 'DE', 'Germany', 'EURO', '10315', '1765666', '312', '34272');
INSERT INTO public.who_global_data_import VALUES (31568, '2021-01-04', 'DE', 'Germany', 'EURO', '9847', '1775513', '302', '34574');
INSERT INTO public.who_global_data_import VALUES (31569, '2021-01-05', 'DE', 'Germany', 'EURO', '11897', '1787410', '944', '35518');
INSERT INTO public.who_global_data_import VALUES (31570, '2021-01-06', 'DE', 'Germany', 'EURO', '21237', '1808647', '1019', '36537');
INSERT INTO public.who_global_data_import VALUES (31571, '2021-01-07', 'DE', 'Germany', 'EURO', '26391', '1835038', '1070', '37607');
INSERT INTO public.who_global_data_import VALUES (31572, '2021-01-08', 'DE', 'Germany', 'EURO', '31849', '1866887', '1188', '38795');
INSERT INTO public.who_global_data_import VALUES (31573, '2021-01-09', 'DE', 'Germany', 'EURO', '24694', '1891581', '1083', '39878');
INSERT INTO public.who_global_data_import VALUES (31574, '2021-01-10', 'DE', 'Germany', 'EURO', '16946', '1908527', '465', '40343');
INSERT INTO public.who_global_data_import VALUES (31575, '2021-01-11', 'DE', 'Germany', 'EURO', '12497', '1921024', '343', '40686');
INSERT INTO public.who_global_data_import VALUES (31576, '2021-01-12', 'DE', 'Germany', 'EURO', '12802', '1933826', '891', '41577');
INSERT INTO public.who_global_data_import VALUES (31577, '2021-01-13', 'DE', 'Germany', 'EURO', '19600', '1953426', '1060', '42637');
INSERT INTO public.who_global_data_import VALUES (31578, '2021-01-14', 'DE', 'Germany', 'EURO', '25164', '1978590', '1244', '43881');
INSERT INTO public.who_global_data_import VALUES (31579, '2021-01-15', 'DE', 'Germany', 'EURO', '22368', '2000958', '1113', '44994');
INSERT INTO public.who_global_data_import VALUES (31580, '2021-01-16', 'DE', 'Germany', 'EURO', '18678', '2019636', '980', '45974');
INSERT INTO public.who_global_data_import VALUES (31581, '2021-01-17', 'DE', 'Germany', 'EURO', '13882', '2033518', '445', '46419');
INSERT INTO public.who_global_data_import VALUES (31582, '2021-01-18', 'DE', 'Germany', 'EURO', '7141', '2040659', '214', '46633');
INSERT INTO public.who_global_data_import VALUES (31583, '2021-01-19', 'DE', 'Germany', 'EURO', '11369', '2052028', '989', '47622');
INSERT INTO public.who_global_data_import VALUES (31584, '2021-01-20', 'DE', 'Germany', 'EURO', '15974', '2068002', '1148', '48770');
INSERT INTO public.who_global_data_import VALUES (31585, '2021-01-21', 'DE', 'Germany', 'EURO', '20398', '2088400', '1013', '49783');
INSERT INTO public.who_global_data_import VALUES (31586, '2021-01-22', 'DE', 'Germany', 'EURO', '17862', '2106262', '859', '50642');
INSERT INTO public.who_global_data_import VALUES (31587, '2021-01-23', 'DE', 'Germany', 'EURO', '16417', '2122679', '879', '51521');
INSERT INTO public.who_global_data_import VALUES (31588, '2021-01-24', 'DE', 'Germany', 'EURO', '12257', '2134936', '349', '51870');
INSERT INTO public.who_global_data_import VALUES (31589, '2021-01-25', 'DE', 'Germany', 'EURO', '6729', '2141665', '217', '52087');
INSERT INTO public.who_global_data_import VALUES (31590, '2021-01-26', 'DE', 'Germany', 'EURO', '6412', '2148077', '903', '52990');
INSERT INTO public.who_global_data_import VALUES (31591, '2021-01-27', 'DE', 'Germany', 'EURO', '13202', '2161279', '982', '53972');
INSERT INTO public.who_global_data_import VALUES (31592, '2021-01-28', 'DE', 'Germany', 'EURO', '17549', '2178828', '941', '54913');
INSERT INTO public.who_global_data_import VALUES (31593, '2021-01-29', 'DE', 'Germany', 'EURO', '14022', '2192850', '839', '55752');
INSERT INTO public.who_global_data_import VALUES (31594, '2021-01-30', 'DE', 'Germany', 'EURO', '12321', '2205171', '794', '56546');
INSERT INTO public.who_global_data_import VALUES (31595, '2021-01-31', 'DE', 'Germany', 'EURO', '11192', '2216363', '399', '56945');
INSERT INTO public.who_global_data_import VALUES (31596, '2021-02-01', 'DE', 'Germany', 'EURO', '5608', '2221971', '175', '57120');
INSERT INTO public.who_global_data_import VALUES (31597, '2021-02-02', 'DE', 'Germany', 'EURO', '6114', '2228085', '861', '57981');
INSERT INTO public.who_global_data_import VALUES (31598, '2021-02-03', 'DE', 'Germany', 'EURO', '9705', '2237790', '975', '58956');
INSERT INTO public.who_global_data_import VALUES (31599, '2021-02-04', 'DE', 'Germany', 'EURO', '14211', '2252001', '786', '59742');
INSERT INTO public.who_global_data_import VALUES (31600, '2021-02-05', 'DE', 'Germany', 'EURO', '12908', '2264909', '855', '60597');
INSERT INTO public.who_global_data_import VALUES (31601, '2020-01-03', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31602, '2020-01-04', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31603, '2020-01-05', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31604, '2020-01-06', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31605, '2020-01-07', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31606, '2020-01-08', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31607, '2020-01-09', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31608, '2020-01-10', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31609, '2020-01-11', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31610, '2020-01-12', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31611, '2020-01-13', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31612, '2020-01-14', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31613, '2020-01-15', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31614, '2020-01-16', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31615, '2020-01-17', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31616, '2020-01-18', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31617, '2020-01-19', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31618, '2020-01-20', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31619, '2020-01-21', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31620, '2020-01-22', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31621, '2020-01-23', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31622, '2020-01-24', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31623, '2020-01-25', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31624, '2020-01-26', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31625, '2020-01-27', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31626, '2020-01-28', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31627, '2020-01-29', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31628, '2020-01-30', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31629, '2020-01-31', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31630, '2020-02-01', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31631, '2020-02-02', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31632, '2020-02-03', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31633, '2020-02-04', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31634, '2020-02-05', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31635, '2020-02-06', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31636, '2020-02-07', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31637, '2020-02-08', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31638, '2020-02-09', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31639, '2020-02-10', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31640, '2020-02-11', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31641, '2020-02-12', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31642, '2020-02-13', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31643, '2020-02-14', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31644, '2020-02-15', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31645, '2020-02-16', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31646, '2020-02-17', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31647, '2020-02-18', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31648, '2020-02-19', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31649, '2020-02-20', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31650, '2020-02-21', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31651, '2020-02-22', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31652, '2020-02-23', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31653, '2020-02-24', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31654, '2020-02-25', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31655, '2020-02-26', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31656, '2020-02-27', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31657, '2020-02-28', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31658, '2020-02-29', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31659, '2020-03-01', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31660, '2020-03-02', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31661, '2020-03-03', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31662, '2020-03-04', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31663, '2020-03-05', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31664, '2020-03-06', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31665, '2020-03-07', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31666, '2020-03-08', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31667, '2020-03-09', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31668, '2020-03-10', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31669, '2020-03-11', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31670, '2020-03-12', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31671, '2020-03-13', 'GH', 'Ghana', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31672, '2020-03-14', 'GH', 'Ghana', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31673, '2020-03-15', 'GH', 'Ghana', 'AFRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31674, '2020-03-16', 'GH', 'Ghana', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31675, '2020-03-17', 'GH', 'Ghana', 'AFRO', '4', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31676, '2020-03-18', 'GH', 'Ghana', 'AFRO', '3', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31677, '2020-03-19', 'GH', 'Ghana', 'AFRO', '2', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31678, '2020-03-20', 'GH', 'Ghana', 'AFRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31679, '2020-03-21', 'GH', 'Ghana', 'AFRO', '3', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31680, '2020-03-22', 'GH', 'Ghana', 'AFRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31681, '2020-03-23', 'GH', 'Ghana', 'AFRO', '5', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (31682, '2020-03-24', 'GH', 'Ghana', 'AFRO', '3', '27', '2', '2');
INSERT INTO public.who_global_data_import VALUES (31683, '2020-03-25', 'GH', 'Ghana', 'AFRO', '26', '53', '0', '2');
INSERT INTO public.who_global_data_import VALUES (31684, '2020-03-26', 'GH', 'Ghana', 'AFRO', '79', '132', '0', '2');
INSERT INTO public.who_global_data_import VALUES (31685, '2020-03-27', 'GH', 'Ghana', 'AFRO', '4', '136', '1', '3');
INSERT INTO public.who_global_data_import VALUES (31686, '2020-03-28', 'GH', 'Ghana', 'AFRO', '1', '137', '1', '4');
INSERT INTO public.who_global_data_import VALUES (31687, '2020-03-29', 'GH', 'Ghana', 'AFRO', '0', '137', '0', '4');
INSERT INTO public.who_global_data_import VALUES (31688, '2020-03-30', 'GH', 'Ghana', 'AFRO', '15', '152', '0', '4');
INSERT INTO public.who_global_data_import VALUES (31689, '2020-03-31', 'GH', 'Ghana', 'AFRO', '0', '152', '0', '4');
INSERT INTO public.who_global_data_import VALUES (31690, '2020-04-01', 'GH', 'Ghana', 'AFRO', '9', '161', '0', '4');
INSERT INTO public.who_global_data_import VALUES (31691, '2020-04-02', 'GH', 'Ghana', 'AFRO', '34', '195', '0', '4');
INSERT INTO public.who_global_data_import VALUES (31692, '2020-04-03', 'GH', 'Ghana', 'AFRO', '9', '204', '0', '4');
INSERT INTO public.who_global_data_import VALUES (31693, '2020-04-04', 'GH', 'Ghana', 'AFRO', '1', '205', '0', '4');
INSERT INTO public.who_global_data_import VALUES (31694, '2020-04-05', 'GH', 'Ghana', 'AFRO', '0', '205', '0', '4');
INSERT INTO public.who_global_data_import VALUES (31695, '2020-04-06', 'GH', 'Ghana', 'AFRO', '9', '214', '1', '5');
INSERT INTO public.who_global_data_import VALUES (31696, '2020-04-07', 'GH', 'Ghana', 'AFRO', '0', '214', '0', '5');
INSERT INTO public.who_global_data_import VALUES (31697, '2020-04-08', 'GH', 'Ghana', 'AFRO', '73', '287', '0', '5');
INSERT INTO public.who_global_data_import VALUES (31698, '2020-04-09', 'GH', 'Ghana', 'AFRO', '26', '313', '1', '6');
INSERT INTO public.who_global_data_import VALUES (31699, '2020-04-10', 'GH', 'Ghana', 'AFRO', '0', '313', '0', '6');
INSERT INTO public.who_global_data_import VALUES (31700, '2020-04-11', 'GH', 'Ghana', 'AFRO', '65', '378', '0', '6');
INSERT INTO public.who_global_data_import VALUES (31701, '2020-04-12', 'GH', 'Ghana', 'AFRO', '30', '408', '2', '8');
INSERT INTO public.who_global_data_import VALUES (31702, '2020-04-13', 'GH', 'Ghana', 'AFRO', '158', '566', '0', '8');
INSERT INTO public.who_global_data_import VALUES (31703, '2020-04-14', 'GH', 'Ghana', 'AFRO', '0', '566', '0', '8');
INSERT INTO public.who_global_data_import VALUES (31705, '2020-04-16', 'GH', 'Ghana', 'AFRO', '0', '636', '0', '8');
INSERT INTO public.who_global_data_import VALUES (31706, '2020-04-17', 'GH', 'Ghana', 'AFRO', '5', '641', '0', '8');
INSERT INTO public.who_global_data_import VALUES (31707, '2020-04-18', 'GH', 'Ghana', 'AFRO', '0', '641', '0', '8');
INSERT INTO public.who_global_data_import VALUES (31708, '2020-04-19', 'GH', 'Ghana', 'AFRO', '193', '834', '1', '9');
INSERT INTO public.who_global_data_import VALUES (31709, '2020-04-20', 'GH', 'Ghana', 'AFRO', '208', '1042', '0', '9');
INSERT INTO public.who_global_data_import VALUES (31710, '2020-04-21', 'GH', 'Ghana', 'AFRO', '0', '1042', '0', '9');
INSERT INTO public.who_global_data_import VALUES (31711, '2020-04-22', 'GH', 'Ghana', 'AFRO', '0', '1042', '0', '9');
INSERT INTO public.who_global_data_import VALUES (31712, '2020-04-23', 'GH', 'Ghana', 'AFRO', '112', '1154', '0', '9');
INSERT INTO public.who_global_data_import VALUES (31713, '2020-04-24', 'GH', 'Ghana', 'AFRO', '0', '1154', '0', '9');
INSERT INTO public.who_global_data_import VALUES (31714, '2020-04-25', 'GH', 'Ghana', 'AFRO', '125', '1279', '1', '10');
INSERT INTO public.who_global_data_import VALUES (31715, '2020-04-26', 'GH', 'Ghana', 'AFRO', '0', '1279', '0', '10');
INSERT INTO public.who_global_data_import VALUES (31716, '2020-04-27', 'GH', 'Ghana', 'AFRO', '271', '1550', '1', '11');
INSERT INTO public.who_global_data_import VALUES (31717, '2020-04-28', 'GH', 'Ghana', 'AFRO', '0', '1550', '0', '11');
INSERT INTO public.who_global_data_import VALUES (31718, '2020-04-29', 'GH', 'Ghana', 'AFRO', '121', '1671', '5', '16');
INSERT INTO public.who_global_data_import VALUES (31719, '2020-04-30', 'GH', 'Ghana', 'AFRO', '0', '1671', '0', '16');
INSERT INTO public.who_global_data_import VALUES (31720, '2020-05-01', 'GH', 'Ghana', 'AFRO', '403', '2074', '1', '17');
INSERT INTO public.who_global_data_import VALUES (31721, '2020-05-02', 'GH', 'Ghana', 'AFRO', '0', '2074', '0', '17');
INSERT INTO public.who_global_data_import VALUES (31722, '2020-05-03', 'GH', 'Ghana', 'AFRO', '95', '2169', '1', '18');
INSERT INTO public.who_global_data_import VALUES (31723, '2020-05-04', 'GH', 'Ghana', 'AFRO', '0', '2169', '0', '18');
INSERT INTO public.who_global_data_import VALUES (31724, '2020-05-05', 'GH', 'Ghana', 'AFRO', '550', '2719', '0', '18');
INSERT INTO public.who_global_data_import VALUES (31725, '2020-05-06', 'GH', 'Ghana', 'AFRO', '0', '2719', '0', '18');
INSERT INTO public.who_global_data_import VALUES (31726, '2020-05-07', 'GH', 'Ghana', 'AFRO', '0', '2719', '0', '18');
INSERT INTO public.who_global_data_import VALUES (31727, '2020-05-08', 'GH', 'Ghana', 'AFRO', '372', '3091', '0', '18');
INSERT INTO public.who_global_data_import VALUES (31728, '2020-05-09', 'GH', 'Ghana', 'AFRO', '921', '4012', '0', '18');
INSERT INTO public.who_global_data_import VALUES (31729, '2020-05-10', 'GH', 'Ghana', 'AFRO', '251', '4263', '4', '22');
INSERT INTO public.who_global_data_import VALUES (31730, '2020-05-11', 'GH', 'Ghana', 'AFRO', '0', '4263', '0', '22');
INSERT INTO public.who_global_data_import VALUES (31731, '2020-05-12', 'GH', 'Ghana', 'AFRO', '437', '4700', '0', '22');
INSERT INTO public.who_global_data_import VALUES (31732, '2020-05-13', 'GH', 'Ghana', 'AFRO', '427', '5127', '0', '22');
INSERT INTO public.who_global_data_import VALUES (31733, '2020-05-14', 'GH', 'Ghana', 'AFRO', '281', '5408', '2', '24');
INSERT INTO public.who_global_data_import VALUES (31734, '2020-05-15', 'GH', 'Ghana', 'AFRO', '122', '5530', '0', '24');
INSERT INTO public.who_global_data_import VALUES (31735, '2020-05-16', 'GH', 'Ghana', 'AFRO', '108', '5638', '4', '28');
INSERT INTO public.who_global_data_import VALUES (31736, '2020-05-17', 'GH', 'Ghana', 'AFRO', '97', '5735', '1', '29');
INSERT INTO public.who_global_data_import VALUES (31737, '2020-05-18', 'GH', 'Ghana', 'AFRO', '0', '5735', '0', '29');
INSERT INTO public.who_global_data_import VALUES (31738, '2020-05-19', 'GH', 'Ghana', 'AFRO', '0', '5735', '0', '29');
INSERT INTO public.who_global_data_import VALUES (31739, '2020-05-20', 'GH', 'Ghana', 'AFRO', '361', '6096', '2', '31');
INSERT INTO public.who_global_data_import VALUES (31740, '2020-05-21', 'GH', 'Ghana', 'AFRO', '0', '6096', '0', '31');
INSERT INTO public.who_global_data_import VALUES (31741, '2020-05-22', 'GH', 'Ghana', 'AFRO', '173', '6269', '0', '31');
INSERT INTO public.who_global_data_import VALUES (31742, '2020-05-23', 'GH', 'Ghana', 'AFRO', '217', '6486', '0', '31');
INSERT INTO public.who_global_data_import VALUES (31743, '2020-05-24', 'GH', 'Ghana', 'AFRO', '131', '6617', '0', '31');
INSERT INTO public.who_global_data_import VALUES (31744, '2020-05-25', 'GH', 'Ghana', 'AFRO', '66', '6683', '1', '32');
INSERT INTO public.who_global_data_import VALUES (31745, '2020-05-26', 'GH', 'Ghana', 'AFRO', '125', '6808', '0', '32');
INSERT INTO public.who_global_data_import VALUES (31746, '2020-05-27', 'GH', 'Ghana', 'AFRO', '156', '6964', '0', '32');
INSERT INTO public.who_global_data_import VALUES (31747, '2020-05-28', 'GH', 'Ghana', 'AFRO', '339', '7303', '2', '34');
INSERT INTO public.who_global_data_import VALUES (31748, '2020-05-29', 'GH', 'Ghana', 'AFRO', '0', '7303', '0', '34');
INSERT INTO public.who_global_data_import VALUES (31749, '2020-05-30', 'GH', 'Ghana', 'AFRO', '313', '7616', '0', '34');
INSERT INTO public.who_global_data_import VALUES (31750, '2020-05-31', 'GH', 'Ghana', 'AFRO', '152', '7768', '1', '35');
INSERT INTO public.who_global_data_import VALUES (31751, '2020-06-01', 'GH', 'Ghana', 'AFRO', '113', '7881', '1', '36');
INSERT INTO public.who_global_data_import VALUES (31752, '2020-06-02', 'GH', 'Ghana', 'AFRO', '189', '8070', '0', '36');
INSERT INTO public.who_global_data_import VALUES (31753, '2020-06-03', 'GH', 'Ghana', 'AFRO', '227', '8297', '2', '38');
INSERT INTO public.who_global_data_import VALUES (31754, '2020-06-04', 'GH', 'Ghana', 'AFRO', '251', '8548', '0', '38');
INSERT INTO public.who_global_data_import VALUES (31755, '2020-06-05', 'GH', 'Ghana', 'AFRO', '337', '8885', '0', '38');
INSERT INTO public.who_global_data_import VALUES (31756, '2020-06-06', 'GH', 'Ghana', 'AFRO', '283', '9168', '4', '42');
INSERT INTO public.who_global_data_import VALUES (31757, '2020-06-07', 'GH', 'Ghana', 'AFRO', '294', '9462', '2', '44');
INSERT INTO public.who_global_data_import VALUES (31758, '2020-06-08', 'GH', 'Ghana', 'AFRO', '176', '9638', '0', '44');
INSERT INTO public.who_global_data_import VALUES (31759, '2020-06-09', 'GH', 'Ghana', 'AFRO', '272', '9910', '4', '48');
INSERT INTO public.who_global_data_import VALUES (31760, '2020-06-10', 'GH', 'Ghana', 'AFRO', '291', '10201', '0', '48');
INSERT INTO public.who_global_data_import VALUES (31761, '2020-06-11', 'GH', 'Ghana', 'AFRO', '0', '10201', '0', '48');
INSERT INTO public.who_global_data_import VALUES (31762, '2020-06-12', 'GH', 'Ghana', 'AFRO', '157', '10358', '0', '48');
INSERT INTO public.who_global_data_import VALUES (31763, '2020-06-13', 'GH', 'Ghana', 'AFRO', '498', '10856', '0', '48');
INSERT INTO public.who_global_data_import VALUES (31764, '2020-06-14', 'GH', 'Ghana', 'AFRO', '262', '11118', '0', '48');
INSERT INTO public.who_global_data_import VALUES (31765, '2020-06-15', 'GH', 'Ghana', 'AFRO', '304', '11422', '3', '51');
INSERT INTO public.who_global_data_import VALUES (31766, '2020-06-16', 'GH', 'Ghana', 'AFRO', '542', '11964', '3', '54');
INSERT INTO public.who_global_data_import VALUES (31767, '2020-06-17', 'GH', 'Ghana', 'AFRO', '229', '12193', '4', '58');
INSERT INTO public.who_global_data_import VALUES (31768, '2020-06-18', 'GH', 'Ghana', 'AFRO', '397', '12590', '8', '66');
INSERT INTO public.who_global_data_import VALUES (31769, '2020-06-19', 'GH', 'Ghana', 'AFRO', '339', '12929', '0', '66');
INSERT INTO public.who_global_data_import VALUES (31770, '2020-06-20', 'GH', 'Ghana', 'AFRO', '274', '13203', '4', '70');
INSERT INTO public.who_global_data_import VALUES (31771, '2020-06-21', 'GH', 'Ghana', 'AFRO', '514', '13717', '15', '85');
INSERT INTO public.who_global_data_import VALUES (31772, '2020-06-22', 'GH', 'Ghana', 'AFRO', '437', '14154', '0', '85');
INSERT INTO public.who_global_data_import VALUES (31773, '2020-06-23', 'GH', 'Ghana', 'AFRO', '0', '14154', '0', '85');
INSERT INTO public.who_global_data_import VALUES (31774, '2020-06-24', 'GH', 'Ghana', 'AFRO', '414', '14568', '10', '95');
INSERT INTO public.who_global_data_import VALUES (31775, '2020-06-25', 'GH', 'Ghana', 'AFRO', '445', '15013', '0', '95');
INSERT INTO public.who_global_data_import VALUES (31776, '2020-06-26', 'GH', 'Ghana', 'AFRO', '460', '15473', '0', '95');
INSERT INTO public.who_global_data_import VALUES (31777, '2020-06-27', 'GH', 'Ghana', 'AFRO', '361', '15834', '8', '103');
INSERT INTO public.who_global_data_import VALUES (31778, '2020-06-28', 'GH', 'Ghana', 'AFRO', '597', '16431', '0', '103');
INSERT INTO public.who_global_data_import VALUES (31779, '2020-06-29', 'GH', 'Ghana', 'AFRO', '920', '17351', '9', '112');
INSERT INTO public.who_global_data_import VALUES (31780, '2020-06-30', 'GH', 'Ghana', 'AFRO', '0', '17351', '0', '112');
INSERT INTO public.who_global_data_import VALUES (31781, '2020-07-01', 'GH', 'Ghana', 'AFRO', '390', '17741', '0', '112');
INSERT INTO public.who_global_data_import VALUES (31782, '2020-07-02', 'GH', 'Ghana', 'AFRO', '393', '18134', '5', '117');
INSERT INTO public.who_global_data_import VALUES (31783, '2020-07-03', 'GH', 'Ghana', 'AFRO', '0', '18134', '0', '117');
INSERT INTO public.who_global_data_import VALUES (31784, '2020-07-04', 'GH', 'Ghana', 'AFRO', '758', '18892', '0', '117');
INSERT INTO public.who_global_data_import VALUES (31785, '2020-07-05', 'GH', 'Ghana', 'AFRO', '496', '19388', '0', '117');
INSERT INTO public.who_global_data_import VALUES (31786, '2020-07-06', 'GH', 'Ghana', 'AFRO', '697', '20085', '5', '122');
INSERT INTO public.who_global_data_import VALUES (31787, '2020-07-07', 'GH', 'Ghana', 'AFRO', '0', '20085', '0', '122');
INSERT INTO public.who_global_data_import VALUES (31788, '2020-07-08', 'GH', 'Ghana', 'AFRO', '1883', '21968', '7', '129');
INSERT INTO public.who_global_data_import VALUES (31789, '2020-07-09', 'GH', 'Ghana', 'AFRO', '854', '22822', '0', '129');
INSERT INTO public.who_global_data_import VALUES (31790, '2020-07-10', 'GH', 'Ghana', 'AFRO', '641', '23463', '0', '129');
INSERT INTO public.who_global_data_import VALUES (31791, '2020-07-11', 'GH', 'Ghana', 'AFRO', '0', '23463', '0', '129');
INSERT INTO public.who_global_data_import VALUES (31792, '2020-07-12', 'GH', 'Ghana', 'AFRO', '785', '24248', '6', '135');
INSERT INTO public.who_global_data_import VALUES (31793, '2020-07-13', 'GH', 'Ghana', 'AFRO', '270', '24518', '4', '139');
INSERT INTO public.who_global_data_import VALUES (31794, '2020-07-14', 'GH', 'Ghana', 'AFRO', '470', '24988', '0', '139');
INSERT INTO public.who_global_data_import VALUES (31795, '2020-07-15', 'GH', 'Ghana', 'AFRO', '0', '24988', '0', '139');
INSERT INTO public.who_global_data_import VALUES (31796, '2020-07-16', 'GH', 'Ghana', 'AFRO', '442', '25430', '0', '139');
INSERT INTO public.who_global_data_import VALUES (31797, '2020-07-17', 'GH', 'Ghana', 'AFRO', '695', '26125', '0', '139');
INSERT INTO public.who_global_data_import VALUES (31798, '2020-07-18', 'GH', 'Ghana', 'AFRO', '447', '26572', '5', '144');
INSERT INTO public.who_global_data_import VALUES (31799, '2020-07-19', 'GH', 'Ghana', 'AFRO', '488', '27060', '1', '145');
INSERT INTO public.who_global_data_import VALUES (31800, '2020-07-20', 'GH', 'Ghana', 'AFRO', '607', '27667', '3', '148');
INSERT INTO public.who_global_data_import VALUES (31801, '2020-07-21', 'GH', 'Ghana', 'AFRO', '763', '28430', '5', '153');
INSERT INTO public.who_global_data_import VALUES (31802, '2020-07-22', 'GH', 'Ghana', 'AFRO', '559', '28989', '0', '153');
INSERT INTO public.who_global_data_import VALUES (31803, '2020-07-23', 'GH', 'Ghana', 'AFRO', '683', '29672', '0', '153');
INSERT INTO public.who_global_data_import VALUES (31804, '2020-07-24', 'GH', 'Ghana', 'AFRO', '0', '29672', '0', '153');
INSERT INTO public.who_global_data_import VALUES (31805, '2020-07-25', 'GH', 'Ghana', 'AFRO', '1385', '31057', '8', '161');
INSERT INTO public.who_global_data_import VALUES (31806, '2020-07-26', 'GH', 'Ghana', 'AFRO', '794', '31851', '0', '161');
INSERT INTO public.who_global_data_import VALUES (31807, '2020-07-27', 'GH', 'Ghana', 'AFRO', '586', '32437', '0', '161');
INSERT INTO public.who_global_data_import VALUES (31808, '2020-07-28', 'GH', 'Ghana', 'AFRO', '1187', '33624', '7', '168');
INSERT INTO public.who_global_data_import VALUES (31809, '2020-07-29', 'GH', 'Ghana', 'AFRO', '782', '34406', '0', '168');
INSERT INTO public.who_global_data_import VALUES (31810, '2020-07-30', 'GH', 'Ghana', 'AFRO', '736', '35142', '7', '175');
INSERT INTO public.who_global_data_import VALUES (31811, '2020-07-31', 'GH', 'Ghana', 'AFRO', '0', '35142', '0', '175');
INSERT INTO public.who_global_data_import VALUES (31812, '2020-08-01', 'GH', 'Ghana', 'AFRO', '359', '35501', '7', '182');
INSERT INTO public.who_global_data_import VALUES (31813, '2020-08-02', 'GH', 'Ghana', 'AFRO', '0', '35501', '0', '182');
INSERT INTO public.who_global_data_import VALUES (31814, '2020-08-03', 'GH', 'Ghana', 'AFRO', '1513', '37014', '0', '182');
INSERT INTO public.who_global_data_import VALUES (31815, '2020-08-04', 'GH', 'Ghana', 'AFRO', '0', '37014', '0', '182');
INSERT INTO public.who_global_data_import VALUES (31816, '2020-08-05', 'GH', 'Ghana', 'AFRO', '798', '37812', '9', '191');
INSERT INTO public.who_global_data_import VALUES (31817, '2020-08-06', 'GH', 'Ghana', 'AFRO', '1263', '39075', '8', '199');
INSERT INTO public.who_global_data_import VALUES (31818, '2020-08-07', 'GH', 'Ghana', 'AFRO', '567', '39642', '0', '199');
INSERT INTO public.who_global_data_import VALUES (31819, '2020-08-08', 'GH', 'Ghana', 'AFRO', '455', '40097', '7', '206');
INSERT INTO public.who_global_data_import VALUES (31820, '2020-08-09', 'GH', 'Ghana', 'AFRO', '436', '40533', '0', '206');
INSERT INTO public.who_global_data_import VALUES (31821, '2020-08-10', 'GH', 'Ghana', 'AFRO', '470', '41003', '9', '215');
INSERT INTO public.who_global_data_import VALUES (31822, '2020-08-11', 'GH', 'Ghana', 'AFRO', '209', '41212', '0', '215');
INSERT INTO public.who_global_data_import VALUES (31823, '2020-08-12', 'GH', 'Ghana', 'AFRO', '192', '41404', '0', '215');
INSERT INTO public.who_global_data_import VALUES (31824, '2020-08-13', 'GH', 'Ghana', 'AFRO', '168', '41572', '8', '223');
INSERT INTO public.who_global_data_import VALUES (31825, '2020-08-14', 'GH', 'Ghana', 'AFRO', '275', '41847', '0', '223');
INSERT INTO public.who_global_data_import VALUES (31826, '2020-08-15', 'GH', 'Ghana', 'AFRO', '216', '42063', '8', '231');
INSERT INTO public.who_global_data_import VALUES (31827, '2020-08-16', 'GH', 'Ghana', 'AFRO', '147', '42210', '0', '231');
INSERT INTO public.who_global_data_import VALUES (31828, '2020-08-17', 'GH', 'Ghana', 'AFRO', '322', '42532', '0', '231');
INSERT INTO public.who_global_data_import VALUES (31829, '2020-08-18', 'GH', 'Ghana', 'AFRO', '121', '42653', '8', '239');
INSERT INTO public.who_global_data_import VALUES (31830, '2020-08-19', 'GH', 'Ghana', 'AFRO', '340', '42993', '9', '248');
INSERT INTO public.who_global_data_import VALUES (31831, '2020-08-20', 'GH', 'Ghana', 'AFRO', '101', '43094', '8', '256');
INSERT INTO public.who_global_data_import VALUES (31832, '2020-08-21', 'GH', 'Ghana', 'AFRO', '166', '43260', '5', '261');
INSERT INTO public.who_global_data_import VALUES (31833, '2020-08-22', 'GH', 'Ghana', 'AFRO', '65', '43325', '0', '261');
INSERT INTO public.who_global_data_import VALUES (31834, '2020-08-23', 'GH', 'Ghana', 'AFRO', '0', '43325', '0', '261');
INSERT INTO public.who_global_data_import VALUES (31835, '2020-08-24', 'GH', 'Ghana', 'AFRO', '180', '43505', '0', '261');
INSERT INTO public.who_global_data_import VALUES (31836, '2020-08-25', 'GH', 'Ghana', 'AFRO', '117', '43622', '2', '263');
INSERT INTO public.who_global_data_import VALUES (31837, '2020-08-26', 'GH', 'Ghana', 'AFRO', '95', '43717', '7', '270');
INSERT INTO public.who_global_data_import VALUES (31838, '2020-08-27', 'GH', 'Ghana', 'AFRO', '52', '43769', '0', '270');
INSERT INTO public.who_global_data_import VALUES (31839, '2020-08-28', 'GH', 'Ghana', 'AFRO', '72', '43841', '0', '270');
INSERT INTO public.who_global_data_import VALUES (31840, '2020-08-29', 'GH', 'Ghana', 'AFRO', '0', '43841', '0', '270');
INSERT INTO public.who_global_data_import VALUES (31841, '2020-08-30', 'GH', 'Ghana', 'AFRO', '108', '43949', '0', '270');
INSERT INTO public.who_global_data_import VALUES (31842, '2020-08-31', 'GH', 'Ghana', 'AFRO', '256', '44205', '6', '276');
INSERT INTO public.who_global_data_import VALUES (31843, '2020-09-01', 'GH', 'Ghana', 'AFRO', '0', '44205', '0', '276');
INSERT INTO public.who_global_data_import VALUES (31844, '2020-09-02', 'GH', 'Ghana', 'AFRO', '0', '44205', '0', '276');
INSERT INTO public.who_global_data_import VALUES (31845, '2020-09-03', 'GH', 'Ghana', 'AFRO', '255', '44460', '0', '276');
INSERT INTO public.who_global_data_import VALUES (31846, '2020-09-04', 'GH', 'Ghana', 'AFRO', '253', '44713', '4', '280');
INSERT INTO public.who_global_data_import VALUES (31847, '2020-09-05', 'GH', 'Ghana', 'AFRO', '64', '44777', '3', '283');
INSERT INTO public.who_global_data_import VALUES (31848, '2020-09-06', 'GH', 'Ghana', 'AFRO', '0', '44777', '0', '283');
INSERT INTO public.who_global_data_import VALUES (31849, '2020-09-07', 'GH', 'Ghana', 'AFRO', '0', '44777', '0', '283');
INSERT INTO public.who_global_data_import VALUES (31850, '2020-09-08', 'GH', 'Ghana', 'AFRO', '0', '44777', '0', '283');
INSERT INTO public.who_global_data_import VALUES (31851, '2020-09-09', 'GH', 'Ghana', 'AFRO', '235', '45012', '0', '283');
INSERT INTO public.who_global_data_import VALUES (31852, '2020-09-10', 'GH', 'Ghana', 'AFRO', '0', '45012', '0', '283');
INSERT INTO public.who_global_data_import VALUES (31853, '2020-09-11', 'GH', 'Ghana', 'AFRO', '301', '45313', '0', '283');
INSERT INTO public.who_global_data_import VALUES (31854, '2020-09-12', 'GH', 'Ghana', 'AFRO', '75', '45388', '2', '285');
INSERT INTO public.who_global_data_import VALUES (31855, '2020-09-13', 'GH', 'Ghana', 'AFRO', '46', '45434', '1', '286');
INSERT INTO public.who_global_data_import VALUES (31856, '2020-09-14', 'GH', 'Ghana', 'AFRO', '0', '45434', '0', '286');
INSERT INTO public.who_global_data_import VALUES (31857, '2020-09-15', 'GH', 'Ghana', 'AFRO', '0', '45434', '0', '286');
INSERT INTO public.who_global_data_import VALUES (31858, '2020-09-16', 'GH', 'Ghana', 'AFRO', '221', '45655', '8', '294');
INSERT INTO public.who_global_data_import VALUES (31859, '2020-09-17', 'GH', 'Ghana', 'AFRO', '0', '45655', '0', '294');
INSERT INTO public.who_global_data_import VALUES (31860, '2020-09-18', 'GH', 'Ghana', 'AFRO', '59', '45714', '0', '294');
INSERT INTO public.who_global_data_import VALUES (31861, '2020-09-19', 'GH', 'Ghana', 'AFRO', '143', '45857', '1', '295');
INSERT INTO public.who_global_data_import VALUES (31862, '2020-09-20', 'GH', 'Ghana', 'AFRO', '20', '45877', '2', '297');
INSERT INTO public.who_global_data_import VALUES (31863, '2020-09-21', 'GH', 'Ghana', 'AFRO', '127', '46004', '0', '297');
INSERT INTO public.who_global_data_import VALUES (31864, '2020-09-22', 'GH', 'Ghana', 'AFRO', '0', '46004', '0', '297');
INSERT INTO public.who_global_data_import VALUES (31865, '2020-09-23', 'GH', 'Ghana', 'AFRO', '58', '46062', '0', '297');
INSERT INTO public.who_global_data_import VALUES (31866, '2020-09-24', 'GH', 'Ghana', 'AFRO', '54', '46116', '0', '297');
INSERT INTO public.who_global_data_import VALUES (31867, '2020-09-25', 'GH', 'Ghana', 'AFRO', '37', '46153', '2', '299');
INSERT INTO public.who_global_data_import VALUES (31868, '2020-09-26', 'GH', 'Ghana', 'AFRO', '69', '46222', '0', '299');
INSERT INTO public.who_global_data_import VALUES (31869, '2020-09-27', 'GH', 'Ghana', 'AFRO', '0', '46222', '0', '299');
INSERT INTO public.who_global_data_import VALUES (31870, '2020-09-28', 'GH', 'Ghana', 'AFRO', '0', '46222', '0', '299');
INSERT INTO public.who_global_data_import VALUES (31871, '2020-09-29', 'GH', 'Ghana', 'AFRO', '0', '46222', '0', '299');
INSERT INTO public.who_global_data_import VALUES (31872, '2020-09-30', 'GH', 'Ghana', 'AFRO', '260', '46482', '2', '301');
INSERT INTO public.who_global_data_import VALUES (31873, '2020-10-01', 'GH', 'Ghana', 'AFRO', '174', '46656', '0', '301');
INSERT INTO public.who_global_data_import VALUES (31874, '2020-10-02', 'GH', 'Ghana', 'AFRO', '0', '46656', '0', '301');
INSERT INTO public.who_global_data_import VALUES (31875, '2020-10-03', 'GH', 'Ghana', 'AFRO', '0', '46656', '0', '301');
INSERT INTO public.who_global_data_import VALUES (31876, '2020-10-04', 'GH', 'Ghana', 'AFRO', '112', '46768', '0', '301');
INSERT INTO public.who_global_data_import VALUES (31877, '2020-10-05', 'GH', 'Ghana', 'AFRO', '61', '46829', '2', '303');
INSERT INTO public.who_global_data_import VALUES (31878, '2020-10-06', 'GH', 'Ghana', 'AFRO', '0', '46829', '0', '303');
INSERT INTO public.who_global_data_import VALUES (31879, '2020-10-07', 'GH', 'Ghana', 'AFRO', '0', '46829', '0', '303');
INSERT INTO public.who_global_data_import VALUES (31880, '2020-10-08', 'GH', 'Ghana', 'AFRO', '0', '46829', '0', '303');
INSERT INTO public.who_global_data_import VALUES (31881, '2020-10-09', 'GH', 'Ghana', 'AFRO', '118', '46947', '3', '306');
INSERT INTO public.who_global_data_import VALUES (31882, '2020-10-10', 'GH', 'Ghana', 'AFRO', '40', '46987', '0', '306');
INSERT INTO public.who_global_data_import VALUES (31883, '2020-10-11', 'GH', 'Ghana', 'AFRO', '0', '46987', '0', '306');
INSERT INTO public.who_global_data_import VALUES (31884, '2020-10-12', 'GH', 'Ghana', 'AFRO', '18', '47005', '0', '306');
INSERT INTO public.who_global_data_import VALUES (31885, '2020-10-13', 'GH', 'Ghana', 'AFRO', '0', '47005', '0', '306');
INSERT INTO public.who_global_data_import VALUES (31886, '2020-10-14', 'GH', 'Ghana', 'AFRO', '92', '47097', '2', '308');
INSERT INTO public.who_global_data_import VALUES (31887, '2020-10-15', 'GH', 'Ghana', 'AFRO', '29', '47126', '2', '310');
INSERT INTO public.who_global_data_import VALUES (31888, '2020-10-16', 'GH', 'Ghana', 'AFRO', '25', '47151', '0', '310');
INSERT INTO public.who_global_data_import VALUES (31889, '2020-10-17', 'GH', 'Ghana', 'AFRO', '22', '47173', '0', '310');
INSERT INTO public.who_global_data_import VALUES (31890, '2020-10-18', 'GH', 'Ghana', 'AFRO', '0', '47173', '0', '310');
INSERT INTO public.who_global_data_import VALUES (31891, '2020-10-19', 'GH', 'Ghana', 'AFRO', '59', '47232', '0', '310');
INSERT INTO public.who_global_data_import VALUES (31892, '2020-10-20', 'GH', 'Ghana', 'AFRO', '140', '47372', '0', '310');
INSERT INTO public.who_global_data_import VALUES (31893, '2020-10-21', 'GH', 'Ghana', 'AFRO', '0', '47372', '0', '310');
INSERT INTO public.who_global_data_import VALUES (31894, '2020-10-22', 'GH', 'Ghana', 'AFRO', '89', '47461', '2', '312');
INSERT INTO public.who_global_data_import VALUES (31895, '2020-10-23', 'GH', 'Ghana', 'AFRO', '77', '47538', '0', '312');
INSERT INTO public.who_global_data_import VALUES (31896, '2020-10-24', 'GH', 'Ghana', 'AFRO', '63', '47601', '2', '314');
INSERT INTO public.who_global_data_import VALUES (31897, '2020-10-25', 'GH', 'Ghana', 'AFRO', '89', '47690', '2', '316');
INSERT INTO public.who_global_data_import VALUES (31898, '2020-10-26', 'GH', 'Ghana', 'AFRO', '0', '47690', '0', '316');
INSERT INTO public.who_global_data_import VALUES (31899, '2020-10-27', 'GH', 'Ghana', 'AFRO', '0', '47690', '0', '316');
INSERT INTO public.who_global_data_import VALUES (31900, '2020-10-28', 'GH', 'Ghana', 'AFRO', '85', '47775', '0', '316');
INSERT INTO public.who_global_data_import VALUES (31901, '2020-10-29', 'GH', 'Ghana', 'AFRO', '0', '47775', '0', '316');
INSERT INTO public.who_global_data_import VALUES (31902, '2020-10-30', 'GH', 'Ghana', 'AFRO', '280', '48055', '4', '320');
INSERT INTO public.who_global_data_import VALUES (31903, '2020-10-31', 'GH', 'Ghana', 'AFRO', '0', '48055', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31904, '2020-11-01', 'GH', 'Ghana', 'AFRO', '0', '48055', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31905, '2020-11-02', 'GH', 'Ghana', 'AFRO', '0', '48055', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31906, '2020-11-03', 'GH', 'Ghana', 'AFRO', '69', '48124', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31907, '2020-11-04', 'GH', 'Ghana', 'AFRO', '76', '48200', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31908, '2020-11-05', 'GH', 'Ghana', 'AFRO', '443', '48643', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31909, '2020-11-06', 'GH', 'Ghana', 'AFRO', '145', '48788', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31910, '2020-11-07', 'GH', 'Ghana', 'AFRO', '0', '48788', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31911, '2020-11-08', 'GH', 'Ghana', 'AFRO', '0', '48788', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31912, '2020-11-09', 'GH', 'Ghana', 'AFRO', '414', '49202', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31913, '2020-11-10', 'GH', 'Ghana', 'AFRO', '0', '49202', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31914, '2020-11-11', 'GH', 'Ghana', 'AFRO', '100', '49302', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31915, '2020-11-12', 'GH', 'Ghana', 'AFRO', '0', '49302', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31916, '2020-11-13', 'GH', 'Ghana', 'AFRO', '716', '50018', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31917, '2020-11-14', 'GH', 'Ghana', 'AFRO', '0', '50018', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31918, '2020-11-15', 'GH', 'Ghana', 'AFRO', '0', '50018', '0', '320');
INSERT INTO public.who_global_data_import VALUES (31919, '2020-11-16', 'GH', 'Ghana', 'AFRO', '105', '50123', '2', '322');
INSERT INTO public.who_global_data_import VALUES (31920, '2020-11-17', 'GH', 'Ghana', 'AFRO', '0', '50123', '0', '322');
INSERT INTO public.who_global_data_import VALUES (31921, '2020-11-18', 'GH', 'Ghana', 'AFRO', '334', '50457', '1', '323');
INSERT INTO public.who_global_data_import VALUES (31922, '2020-11-19', 'GH', 'Ghana', 'AFRO', '0', '50457', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31923, '2020-11-20', 'GH', 'Ghana', 'AFRO', '174', '50631', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31924, '2020-11-21', 'GH', 'Ghana', 'AFRO', '0', '50631', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31925, '2020-11-22', 'GH', 'Ghana', 'AFRO', '243', '50874', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31926, '2020-11-23', 'GH', 'Ghana', 'AFRO', '0', '50874', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31927, '2020-11-24', 'GH', 'Ghana', 'AFRO', '67', '50941', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31928, '2020-11-25', 'GH', 'Ghana', 'AFRO', '243', '51184', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31929, '2020-11-26', 'GH', 'Ghana', 'AFRO', '41', '51225', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31930, '2020-11-27', 'GH', 'Ghana', 'AFRO', '0', '51225', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31931, '2020-11-28', 'GH', 'Ghana', 'AFRO', '0', '51225', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31932, '2020-11-29', 'GH', 'Ghana', 'AFRO', '154', '51379', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31933, '2020-11-30', 'GH', 'Ghana', 'AFRO', '190', '51569', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31934, '2020-12-01', 'GH', 'Ghana', 'AFRO', '98', '51667', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31935, '2020-12-02', 'GH', 'Ghana', 'AFRO', '0', '51667', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31936, '2020-12-03', 'GH', 'Ghana', 'AFRO', '0', '51667', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31937, '2020-12-04', 'GH', 'Ghana', 'AFRO', '0', '51667', '0', '323');
INSERT INTO public.who_global_data_import VALUES (31938, '2020-12-05', 'GH', 'Ghana', 'AFRO', '429', '52096', '2', '325');
INSERT INTO public.who_global_data_import VALUES (31939, '2020-12-06', 'GH', 'Ghana', 'AFRO', '0', '52096', '0', '325');
INSERT INTO public.who_global_data_import VALUES (31940, '2020-12-07', 'GH', 'Ghana', 'AFRO', '178', '52274', '0', '325');
INSERT INTO public.who_global_data_import VALUES (31941, '2020-12-08', 'GH', 'Ghana', 'AFRO', '0', '52274', '0', '325');
INSERT INTO public.who_global_data_import VALUES (31942, '2020-12-09', 'GH', 'Ghana', 'AFRO', '226', '52500', '1', '326');
INSERT INTO public.who_global_data_import VALUES (31943, '2020-12-10', 'GH', 'Ghana', 'AFRO', '122', '52622', '0', '326');
INSERT INTO public.who_global_data_import VALUES (31944, '2020-12-11', 'GH', 'Ghana', 'AFRO', '116', '52738', '0', '326');
INSERT INTO public.who_global_data_import VALUES (31945, '2020-12-12', 'GH', 'Ghana', 'AFRO', '0', '52738', '0', '326');
INSERT INTO public.who_global_data_import VALUES (31946, '2020-12-13', 'GH', 'Ghana', 'AFRO', '195', '52933', '1', '327');
INSERT INTO public.who_global_data_import VALUES (31947, '2020-12-14', 'GH', 'Ghana', 'AFRO', '0', '52933', '0', '327');
INSERT INTO public.who_global_data_import VALUES (31948, '2020-12-15', 'GH', 'Ghana', 'AFRO', '81', '53014', '0', '327');
INSERT INTO public.who_global_data_import VALUES (31949, '2020-12-16', 'GH', 'Ghana', 'AFRO', '372', '53386', '0', '327');
INSERT INTO public.who_global_data_import VALUES (31950, '2020-12-17', 'GH', 'Ghana', 'AFRO', '0', '53386', '0', '327');
INSERT INTO public.who_global_data_import VALUES (31951, '2020-12-18', 'GH', 'Ghana', 'AFRO', '167', '53553', '4', '331');
INSERT INTO public.who_global_data_import VALUES (31952, '2020-12-19', 'GH', 'Ghana', 'AFRO', '100', '53653', '0', '331');
INSERT INTO public.who_global_data_import VALUES (31953, '2020-12-20', 'GH', 'Ghana', 'AFRO', '0', '53653', '0', '331');
INSERT INTO public.who_global_data_import VALUES (31954, '2020-12-21', 'GH', 'Ghana', 'AFRO', '0', '53653', '0', '331');
INSERT INTO public.who_global_data_import VALUES (31955, '2020-12-22', 'GH', 'Ghana', 'AFRO', '301', '53954', '2', '333');
INSERT INTO public.who_global_data_import VALUES (31956, '2020-12-23', 'GH', 'Ghana', 'AFRO', '0', '53954', '0', '333');
INSERT INTO public.who_global_data_import VALUES (31957, '2020-12-24', 'GH', 'Ghana', 'AFRO', '89', '54043', '0', '333');
INSERT INTO public.who_global_data_import VALUES (31958, '2020-12-25', 'GH', 'Ghana', 'AFRO', '0', '54043', '0', '333');
INSERT INTO public.who_global_data_import VALUES (31959, '2020-12-26', 'GH', 'Ghana', 'AFRO', '0', '54043', '0', '333');
INSERT INTO public.who_global_data_import VALUES (31960, '2020-12-27', 'GH', 'Ghana', 'AFRO', '243', '54286', '0', '333');
INSERT INTO public.who_global_data_import VALUES (31961, '2020-12-28', 'GH', 'Ghana', 'AFRO', '115', '54401', '0', '333');
INSERT INTO public.who_global_data_import VALUES (31962, '2020-12-29', 'GH', 'Ghana', 'AFRO', '102', '54503', '0', '333');
INSERT INTO public.who_global_data_import VALUES (31963, '2020-12-30', 'GH', 'Ghana', 'AFRO', '178', '54681', '2', '335');
INSERT INTO public.who_global_data_import VALUES (31964, '2020-12-31', 'GH', 'Ghana', 'AFRO', '90', '54771', '0', '335');
INSERT INTO public.who_global_data_import VALUES (31965, '2021-01-01', 'GH', 'Ghana', 'AFRO', '0', '54771', '0', '335');
INSERT INTO public.who_global_data_import VALUES (31966, '2021-01-02', 'GH', 'Ghana', 'AFRO', '0', '54771', '0', '335');
INSERT INTO public.who_global_data_import VALUES (31967, '2021-01-03', 'GH', 'Ghana', 'AFRO', '293', '55064', '0', '335');
INSERT INTO public.who_global_data_import VALUES (31968, '2021-01-04', 'GH', 'Ghana', 'AFRO', '104', '55168', '0', '335');
INSERT INTO public.who_global_data_import VALUES (31969, '2021-01-05', 'GH', 'Ghana', 'AFRO', '0', '55168', '0', '335');
INSERT INTO public.who_global_data_import VALUES (31970, '2021-01-06', 'GH', 'Ghana', 'AFRO', '0', '55168', '0', '335');
INSERT INTO public.who_global_data_import VALUES (31971, '2021-01-07', 'GH', 'Ghana', 'AFRO', '0', '55168', '0', '335');
INSERT INTO public.who_global_data_import VALUES (31972, '2021-01-08', 'GH', 'Ghana', 'AFRO', '293', '55461', '1', '336');
INSERT INTO public.who_global_data_import VALUES (31973, '2021-01-09', 'GH', 'Ghana', 'AFRO', '0', '55461', '0', '336');
INSERT INTO public.who_global_data_import VALUES (31974, '2021-01-10', 'GH', 'Ghana', 'AFRO', '311', '55772', '0', '336');
INSERT INTO public.who_global_data_import VALUES (31975, '2021-01-11', 'GH', 'Ghana', 'AFRO', '0', '55772', '0', '336');
INSERT INTO public.who_global_data_import VALUES (31976, '2021-01-12', 'GH', 'Ghana', 'AFRO', '458', '56230', '2', '338');
INSERT INTO public.who_global_data_import VALUES (31977, '2021-01-13', 'GH', 'Ghana', 'AFRO', '191', '56421', '0', '338');
INSERT INTO public.who_global_data_import VALUES (31978, '2021-01-14', 'GH', 'Ghana', 'AFRO', '560', '56981', '3', '341');
INSERT INTO public.who_global_data_import VALUES (31979, '2021-01-15', 'GH', 'Ghana', 'AFRO', '0', '56981', '0', '341');
INSERT INTO public.who_global_data_import VALUES (31980, '2021-01-16', 'GH', 'Ghana', 'AFRO', '0', '56981', '0', '341');
INSERT INTO public.who_global_data_import VALUES (31981, '2021-01-17', 'GH', 'Ghana', 'AFRO', '0', '56981', '0', '341');
INSERT INTO public.who_global_data_import VALUES (31982, '2021-01-18', 'GH', 'Ghana', 'AFRO', '733', '57714', '5', '346');
INSERT INTO public.who_global_data_import VALUES (31983, '2021-01-19', 'GH', 'Ghana', 'AFRO', '351', '58065', '6', '352');
INSERT INTO public.who_global_data_import VALUES (31984, '2021-01-20', 'GH', 'Ghana', 'AFRO', '366', '58431', '6', '358');
INSERT INTO public.who_global_data_import VALUES (31985, '2021-01-21', 'GH', 'Ghana', 'AFRO', '391', '58822', '0', '358');
INSERT INTO public.who_global_data_import VALUES (31986, '2021-01-22', 'GH', 'Ghana', 'AFRO', '658', '59480', '3', '361');
INSERT INTO public.who_global_data_import VALUES (31987, '2021-01-23', 'GH', 'Ghana', 'AFRO', '0', '59480', '0', '361');
INSERT INTO public.who_global_data_import VALUES (31988, '2021-01-24', 'GH', 'Ghana', 'AFRO', '635', '60115', '0', '361');
INSERT INTO public.who_global_data_import VALUES (31989, '2021-01-25', 'GH', 'Ghana', 'AFRO', '679', '60794', '6', '367');
INSERT INTO public.who_global_data_import VALUES (31990, '2021-01-26', 'GH', 'Ghana', 'AFRO', '1341', '62135', '5', '372');
INSERT INTO public.who_global_data_import VALUES (31991, '2021-01-27', 'GH', 'Ghana', 'AFRO', '0', '62135', '0', '372');
INSERT INTO public.who_global_data_import VALUES (31992, '2021-01-28', 'GH', 'Ghana', 'AFRO', '616', '62751', '5', '377');
INSERT INTO public.who_global_data_import VALUES (31993, '2021-01-29', 'GH', 'Ghana', 'AFRO', '1132', '63883', '13', '390');
INSERT INTO public.who_global_data_import VALUES (31994, '2021-01-30', 'GH', 'Ghana', 'AFRO', '0', '63883', '0', '390');
INSERT INTO public.who_global_data_import VALUES (31995, '2021-01-31', 'GH', 'Ghana', 'AFRO', '1544', '65427', '15', '405');
INSERT INTO public.who_global_data_import VALUES (31996, '2021-02-01', 'GH', 'Ghana', 'AFRO', '1583', '67010', '11', '416');
INSERT INTO public.who_global_data_import VALUES (31997, '2021-02-02', 'GH', 'Ghana', 'AFRO', '0', '67010', '0', '416');
INSERT INTO public.who_global_data_import VALUES (31998, '2021-02-03', 'GH', 'Ghana', 'AFRO', '772', '67782', '8', '424');
INSERT INTO public.who_global_data_import VALUES (31999, '2021-02-04', 'GH', 'Ghana', 'AFRO', '0', '67782', '0', '424');
INSERT INTO public.who_global_data_import VALUES (32000, '2021-02-05', 'GH', 'Ghana', 'AFRO', '777', '68559', '9', '433');
INSERT INTO public.who_global_data_import VALUES (32001, '2020-01-03', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32002, '2020-01-04', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32003, '2020-01-05', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32004, '2020-01-06', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32005, '2020-01-07', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32006, '2020-01-08', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32007, '2020-01-09', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32008, '2020-01-10', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32009, '2020-01-11', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32010, '2020-01-12', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32011, '2020-01-13', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32012, '2020-01-14', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32013, '2020-01-15', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32014, '2020-01-16', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32015, '2020-01-17', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32016, '2020-01-18', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32017, '2020-01-19', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32018, '2020-01-20', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32019, '2020-01-21', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32020, '2020-01-22', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32021, '2020-01-23', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32022, '2020-01-24', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32023, '2020-01-25', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32024, '2020-01-26', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32025, '2020-01-27', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32026, '2020-01-28', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32027, '2020-01-29', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32028, '2020-01-30', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32029, '2020-01-31', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32030, '2020-02-01', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32031, '2020-02-02', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32032, '2020-02-03', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32033, '2020-02-04', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32034, '2020-02-05', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32035, '2020-02-06', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32036, '2020-02-07', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32037, '2020-02-08', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32038, '2020-02-09', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32039, '2020-02-10', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32040, '2020-02-11', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32041, '2020-02-12', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32042, '2020-02-13', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32043, '2020-02-14', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32044, '2020-02-15', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32045, '2020-02-16', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32046, '2020-02-17', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32047, '2020-02-18', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32048, '2020-02-19', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32049, '2020-02-20', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32050, '2020-02-21', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32051, '2020-02-22', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32052, '2020-02-23', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32053, '2020-02-24', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32054, '2020-02-25', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32055, '2020-02-26', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32056, '2020-02-27', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32057, '2020-02-28', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32058, '2020-02-29', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32059, '2020-03-01', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32060, '2020-03-02', 'GI', 'Gibraltar', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32061, '2020-03-03', 'GI', 'Gibraltar', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32062, '2020-03-04', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32063, '2020-03-05', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32064, '2020-03-06', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32065, '2020-03-07', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32066, '2020-03-08', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32067, '2020-03-09', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32068, '2020-03-10', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32069, '2020-03-11', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32070, '2020-03-12', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32071, '2020-03-13', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32072, '2020-03-14', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32073, '2020-03-15', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32074, '2020-03-16', 'GI', 'Gibraltar', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32075, '2020-03-17', 'GI', 'Gibraltar', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32076, '2020-03-18', 'GI', 'Gibraltar', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32077, '2020-03-19', 'GI', 'Gibraltar', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32078, '2020-03-20', 'GI', 'Gibraltar', 'EURO', '7', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32079, '2020-03-21', 'GI', 'Gibraltar', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32080, '2020-03-22', 'GI', 'Gibraltar', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32081, '2020-03-23', 'GI', 'Gibraltar', 'EURO', '5', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32082, '2020-03-24', 'GI', 'Gibraltar', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32083, '2020-03-25', 'GI', 'Gibraltar', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32084, '2020-03-26', 'GI', 'Gibraltar', 'EURO', '11', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32085, '2020-03-27', 'GI', 'Gibraltar', 'EURO', '9', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32086, '2020-03-28', 'GI', 'Gibraltar', 'EURO', '20', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32087, '2020-03-29', 'GI', 'Gibraltar', 'EURO', '1', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32088, '2020-03-30', 'GI', 'Gibraltar', 'EURO', '9', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32089, '2020-03-31', 'GI', 'Gibraltar', 'EURO', '4', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32090, '2020-04-01', 'GI', 'Gibraltar', 'EURO', '0', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32091, '2020-04-02', 'GI', 'Gibraltar', 'EURO', '0', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32092, '2020-04-03', 'GI', 'Gibraltar', 'EURO', '12', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32093, '2020-04-04', 'GI', 'Gibraltar', 'EURO', '14', '95', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32094, '2020-04-05', 'GI', 'Gibraltar', 'EURO', '3', '98', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32095, '2020-04-06', 'GI', 'Gibraltar', 'EURO', '5', '103', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32096, '2020-04-07', 'GI', 'Gibraltar', 'EURO', '0', '103', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32097, '2020-04-08', 'GI', 'Gibraltar', 'EURO', '10', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32098, '2020-04-09', 'GI', 'Gibraltar', 'EURO', '0', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32099, '2020-04-10', 'GI', 'Gibraltar', 'EURO', '0', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32100, '2020-04-11', 'GI', 'Gibraltar', 'EURO', '0', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32101, '2020-04-12', 'GI', 'Gibraltar', 'EURO', '0', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32102, '2020-04-13', 'GI', 'Gibraltar', 'EURO', '16', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32103, '2020-04-14', 'GI', 'Gibraltar', 'EURO', '0', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32104, '2020-04-15', 'GI', 'Gibraltar', 'EURO', '0', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32105, '2020-04-16', 'GI', 'Gibraltar', 'EURO', '0', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32106, '2020-04-17', 'GI', 'Gibraltar', 'EURO', '2', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32107, '2020-04-18', 'GI', 'Gibraltar', 'EURO', '2', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32108, '2020-04-19', 'GI', 'Gibraltar', 'EURO', '0', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32109, '2020-04-20', 'GI', 'Gibraltar', 'EURO', '0', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32110, '2020-04-21', 'GI', 'Gibraltar', 'EURO', '0', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32111, '2020-04-22', 'GI', 'Gibraltar', 'EURO', '0', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32112, '2020-04-23', 'GI', 'Gibraltar', 'EURO', '0', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32113, '2020-04-24', 'GI', 'Gibraltar', 'EURO', '0', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32114, '2020-04-25', 'GI', 'Gibraltar', 'EURO', '0', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32115, '2020-04-26', 'GI', 'Gibraltar', 'EURO', '3', '136', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32116, '2020-04-27', 'GI', 'Gibraltar', 'EURO', '5', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32117, '2020-04-28', 'GI', 'Gibraltar', 'EURO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32118, '2020-04-29', 'GI', 'Gibraltar', 'EURO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32119, '2020-04-30', 'GI', 'Gibraltar', 'EURO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32120, '2020-05-01', 'GI', 'Gibraltar', 'EURO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32121, '2020-05-02', 'GI', 'Gibraltar', 'EURO', '3', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32122, '2020-05-03', 'GI', 'Gibraltar', 'EURO', '0', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32123, '2020-05-04', 'GI', 'Gibraltar', 'EURO', '0', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32124, '2020-05-05', 'GI', 'Gibraltar', 'EURO', '0', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32125, '2020-05-06', 'GI', 'Gibraltar', 'EURO', '0', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32126, '2020-05-07', 'GI', 'Gibraltar', 'EURO', '0', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32127, '2020-05-08', 'GI', 'Gibraltar', 'EURO', '0', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32128, '2020-05-09', 'GI', 'Gibraltar', 'EURO', '0', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32129, '2020-05-10', 'GI', 'Gibraltar', 'EURO', '2', '146', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32130, '2020-05-11', 'GI', 'Gibraltar', 'EURO', '0', '146', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32131, '2020-05-12', 'GI', 'Gibraltar', 'EURO', '0', '146', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32132, '2020-05-13', 'GI', 'Gibraltar', 'EURO', '1', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32133, '2020-05-14', 'GI', 'Gibraltar', 'EURO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32134, '2020-05-15', 'GI', 'Gibraltar', 'EURO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32135, '2020-05-16', 'GI', 'Gibraltar', 'EURO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32136, '2020-05-17', 'GI', 'Gibraltar', 'EURO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32137, '2020-05-18', 'GI', 'Gibraltar', 'EURO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32138, '2020-05-19', 'GI', 'Gibraltar', 'EURO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32139, '2020-05-20', 'GI', 'Gibraltar', 'EURO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32140, '2020-05-21', 'GI', 'Gibraltar', 'EURO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32141, '2020-05-22', 'GI', 'Gibraltar', 'EURO', '2', '149', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32142, '2020-05-23', 'GI', 'Gibraltar', 'EURO', '2', '151', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32143, '2020-05-24', 'GI', 'Gibraltar', 'EURO', '0', '151', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32144, '2020-05-25', 'GI', 'Gibraltar', 'EURO', '3', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32145, '2020-05-26', 'GI', 'Gibraltar', 'EURO', '0', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32146, '2020-05-27', 'GI', 'Gibraltar', 'EURO', '0', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32147, '2020-05-28', 'GI', 'Gibraltar', 'EURO', '0', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32148, '2020-05-29', 'GI', 'Gibraltar', 'EURO', '3', '157', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32149, '2020-05-30', 'GI', 'Gibraltar', 'EURO', '1', '158', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32150, '2020-05-31', 'GI', 'Gibraltar', 'EURO', '3', '161', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32151, '2020-06-01', 'GI', 'Gibraltar', 'EURO', '8', '169', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32152, '2020-06-02', 'GI', 'Gibraltar', 'EURO', '1', '170', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32153, '2020-06-03', 'GI', 'Gibraltar', 'EURO', '0', '170', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32154, '2020-06-04', 'GI', 'Gibraltar', 'EURO', '2', '172', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32155, '2020-06-05', 'GI', 'Gibraltar', 'EURO', '1', '173', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32156, '2020-06-06', 'GI', 'Gibraltar', 'EURO', '1', '174', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32157, '2020-06-07', 'GI', 'Gibraltar', 'EURO', '0', '174', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32158, '2020-06-08', 'GI', 'Gibraltar', 'EURO', '1', '175', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32159, '2020-06-09', 'GI', 'Gibraltar', 'EURO', '1', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32160, '2020-06-10', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32161, '2020-06-11', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32162, '2020-06-12', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32163, '2020-06-13', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32164, '2020-06-14', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32165, '2020-06-15', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32166, '2020-06-16', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32167, '2020-06-17', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32168, '2020-06-18', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32169, '2020-06-19', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32170, '2020-06-20', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32171, '2020-06-21', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32172, '2020-06-22', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32173, '2020-06-23', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32174, '2020-06-24', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32175, '2020-06-25', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32176, '2020-06-26', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32177, '2020-06-27', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32178, '2020-06-28', 'GI', 'Gibraltar', 'EURO', '0', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32179, '2020-06-29', 'GI', 'Gibraltar', 'EURO', '1', '177', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32180, '2020-06-30', 'GI', 'Gibraltar', 'EURO', '0', '177', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32181, '2020-07-01', 'GI', 'Gibraltar', 'EURO', '0', '177', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32182, '2020-07-02', 'GI', 'Gibraltar', 'EURO', '0', '177', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32183, '2020-07-03', 'GI', 'Gibraltar', 'EURO', '1', '178', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32184, '2020-07-04', 'GI', 'Gibraltar', 'EURO', '0', '178', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32185, '2020-07-05', 'GI', 'Gibraltar', 'EURO', '0', '178', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32186, '2020-07-06', 'GI', 'Gibraltar', 'EURO', '0', '178', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32187, '2020-07-07', 'GI', 'Gibraltar', 'EURO', '1', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32188, '2020-07-08', 'GI', 'Gibraltar', 'EURO', '0', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32189, '2020-07-09', 'GI', 'Gibraltar', 'EURO', '0', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32190, '2020-07-10', 'GI', 'Gibraltar', 'EURO', '0', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32191, '2020-07-11', 'GI', 'Gibraltar', 'EURO', '1', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32192, '2020-07-12', 'GI', 'Gibraltar', 'EURO', '0', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32193, '2020-07-13', 'GI', 'Gibraltar', 'EURO', '0', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32194, '2020-07-14', 'GI', 'Gibraltar', 'EURO', '0', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32195, '2020-07-15', 'GI', 'Gibraltar', 'EURO', '0', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32196, '2020-07-16', 'GI', 'Gibraltar', 'EURO', '0', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32197, '2020-07-17', 'GI', 'Gibraltar', 'EURO', '0', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32198, '2020-07-18', 'GI', 'Gibraltar', 'EURO', '0', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32199, '2020-07-19', 'GI', 'Gibraltar', 'EURO', '0', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32200, '2020-07-20', 'GI', 'Gibraltar', 'EURO', '0', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32201, '2020-07-21', 'GI', 'Gibraltar', 'EURO', '0', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32202, '2020-07-22', 'GI', 'Gibraltar', 'EURO', '0', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32203, '2020-07-23', 'GI', 'Gibraltar', 'EURO', '0', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32204, '2020-07-24', 'GI', 'Gibraltar', 'EURO', '2', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32205, '2020-07-25', 'GI', 'Gibraltar', 'EURO', '2', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32206, '2020-07-26', 'GI', 'Gibraltar', 'EURO', '1', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32207, '2020-07-27', 'GI', 'Gibraltar', 'EURO', '0', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32208, '2020-07-28', 'GI', 'Gibraltar', 'EURO', '0', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32209, '2020-07-29', 'GI', 'Gibraltar', 'EURO', '0', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32210, '2020-07-30', 'GI', 'Gibraltar', 'EURO', '1', '186', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32211, '2020-07-31', 'GI', 'Gibraltar', 'EURO', '0', '186', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32212, '2020-08-01', 'GI', 'Gibraltar', 'EURO', '1', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32213, '2020-08-02', 'GI', 'Gibraltar', 'EURO', '0', '187', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32214, '2020-08-03', 'GI', 'Gibraltar', 'EURO', '1', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32215, '2020-08-04', 'GI', 'Gibraltar', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32216, '2020-08-05', 'GI', 'Gibraltar', 'EURO', '0', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32217, '2020-08-06', 'GI', 'Gibraltar', 'EURO', '1', '189', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32218, '2020-08-07', 'GI', 'Gibraltar', 'EURO', '0', '189', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32219, '2020-08-08', 'GI', 'Gibraltar', 'EURO', '1', '190', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32220, '2020-08-09', 'GI', 'Gibraltar', 'EURO', '3', '193', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32221, '2020-08-10', 'GI', 'Gibraltar', 'EURO', '4', '197', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32222, '2020-08-11', 'GI', 'Gibraltar', 'EURO', '0', '197', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32223, '2020-08-12', 'GI', 'Gibraltar', 'EURO', '4', '201', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32224, '2020-08-13', 'GI', 'Gibraltar', 'EURO', '1', '202', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32225, '2020-08-14', 'GI', 'Gibraltar', 'EURO', '1', '203', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32226, '2020-08-15', 'GI', 'Gibraltar', 'EURO', '2', '205', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32227, '2020-08-16', 'GI', 'Gibraltar', 'EURO', '1', '206', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32228, '2020-08-17', 'GI', 'Gibraltar', 'EURO', '3', '209', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32229, '2020-08-18', 'GI', 'Gibraltar', 'EURO', '0', '209', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32230, '2020-08-19', 'GI', 'Gibraltar', 'EURO', '8', '217', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32231, '2020-08-20', 'GI', 'Gibraltar', 'EURO', '5', '222', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32232, '2020-08-21', 'GI', 'Gibraltar', 'EURO', '1', '223', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32233, '2020-08-22', 'GI', 'Gibraltar', 'EURO', '6', '229', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32234, '2020-08-23', 'GI', 'Gibraltar', 'EURO', '0', '229', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32235, '2020-08-24', 'GI', 'Gibraltar', 'EURO', '10', '239', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32236, '2020-08-25', 'GI', 'Gibraltar', 'EURO', '7', '246', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32237, '2020-08-26', 'GI', 'Gibraltar', 'EURO', '2', '248', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32238, '2020-08-27', 'GI', 'Gibraltar', 'EURO', '8', '256', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32239, '2020-08-28', 'GI', 'Gibraltar', 'EURO', '14', '270', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32240, '2020-08-29', 'GI', 'Gibraltar', 'EURO', '2', '272', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32241, '2020-08-30', 'GI', 'Gibraltar', 'EURO', '2', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32242, '2020-08-31', 'GI', 'Gibraltar', 'EURO', '1', '275', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32243, '2020-09-01', 'GI', 'Gibraltar', 'EURO', '10', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32244, '2020-09-02', 'GI', 'Gibraltar', 'EURO', '3', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32245, '2020-09-03', 'GI', 'Gibraltar', 'EURO', '2', '290', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32246, '2020-09-04', 'GI', 'Gibraltar', 'EURO', '5', '295', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32247, '2020-09-05', 'GI', 'Gibraltar', 'EURO', '3', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32248, '2020-09-06', 'GI', 'Gibraltar', 'EURO', '7', '305', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32249, '2020-09-07', 'GI', 'Gibraltar', 'EURO', '7', '312', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32250, '2020-09-08', 'GI', 'Gibraltar', 'EURO', '3', '315', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32251, '2020-09-09', 'GI', 'Gibraltar', 'EURO', '0', '315', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32252, '2020-09-10', 'GI', 'Gibraltar', 'EURO', '5', '320', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32253, '2020-09-11', 'GI', 'Gibraltar', 'EURO', '2', '322', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32254, '2020-09-12', 'GI', 'Gibraltar', 'EURO', '1', '323', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32255, '2020-09-13', 'GI', 'Gibraltar', 'EURO', '0', '323', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32256, '2020-09-14', 'GI', 'Gibraltar', 'EURO', '4', '327', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32257, '2020-09-15', 'GI', 'Gibraltar', 'EURO', '3', '330', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32258, '2020-09-16', 'GI', 'Gibraltar', 'EURO', '0', '330', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32259, '2020-09-17', 'GI', 'Gibraltar', 'EURO', '4', '334', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32260, '2020-09-18', 'GI', 'Gibraltar', 'EURO', '6', '340', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32261, '2020-09-19', 'GI', 'Gibraltar', 'EURO', '3', '343', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32262, '2020-09-20', 'GI', 'Gibraltar', 'EURO', '3', '346', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32263, '2020-09-21', 'GI', 'Gibraltar', 'EURO', '4', '350', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32264, '2020-09-22', 'GI', 'Gibraltar', 'EURO', '0', '350', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32265, '2020-09-23', 'GI', 'Gibraltar', 'EURO', '0', '350', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32266, '2020-09-24', 'GI', 'Gibraltar', 'EURO', '5', '355', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32267, '2020-09-25', 'GI', 'Gibraltar', 'EURO', '2', '357', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32268, '2020-09-26', 'GI', 'Gibraltar', 'EURO', '4', '361', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32269, '2020-09-27', 'GI', 'Gibraltar', 'EURO', '3', '364', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32270, '2020-09-28', 'GI', 'Gibraltar', 'EURO', '8', '372', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32271, '2020-09-29', 'GI', 'Gibraltar', 'EURO', '7', '379', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32272, '2020-09-30', 'GI', 'Gibraltar', 'EURO', '3', '382', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32273, '2020-10-01', 'GI', 'Gibraltar', 'EURO', '9', '391', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32274, '2020-10-02', 'GI', 'Gibraltar', 'EURO', '5', '396', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32275, '2020-10-03', 'GI', 'Gibraltar', 'EURO', '14', '410', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32276, '2020-10-04', 'GI', 'Gibraltar', 'EURO', '6', '416', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32277, '2020-10-05', 'GI', 'Gibraltar', 'EURO', '12', '428', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32278, '2020-10-06', 'GI', 'Gibraltar', 'EURO', '4', '432', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32279, '2020-10-07', 'GI', 'Gibraltar', 'EURO', '0', '432', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32280, '2020-10-08', 'GI', 'Gibraltar', 'EURO', '5', '437', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32281, '2020-10-09', 'GI', 'Gibraltar', 'EURO', '8', '445', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32282, '2020-10-10', 'GI', 'Gibraltar', 'EURO', '7', '452', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32283, '2020-10-11', 'GI', 'Gibraltar', 'EURO', '16', '468', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32284, '2020-10-12', 'GI', 'Gibraltar', 'EURO', '8', '476', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32285, '2020-10-13', 'GI', 'Gibraltar', 'EURO', '9', '485', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32286, '2020-10-14', 'GI', 'Gibraltar', 'EURO', '1', '486', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32287, '2020-10-15', 'GI', 'Gibraltar', 'EURO', '13', '499', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32288, '2020-10-16', 'GI', 'Gibraltar', 'EURO', '17', '516', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32289, '2020-10-17', 'GI', 'Gibraltar', 'EURO', '15', '531', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32290, '2020-10-18', 'GI', 'Gibraltar', 'EURO', '13', '544', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32291, '2020-10-19', 'GI', 'Gibraltar', 'EURO', '14', '558', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32292, '2020-10-20', 'GI', 'Gibraltar', 'EURO', '13', '571', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32293, '2020-10-21', 'GI', 'Gibraltar', 'EURO', '6', '577', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32294, '2020-10-22', 'GI', 'Gibraltar', 'EURO', '31', '608', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32295, '2020-10-23', 'GI', 'Gibraltar', 'EURO', '13', '621', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32296, '2020-10-24', 'GI', 'Gibraltar', 'EURO', '9', '630', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32297, '2020-10-25', 'GI', 'Gibraltar', 'EURO', '11', '641', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32298, '2020-10-26', 'GI', 'Gibraltar', 'EURO', '19', '660', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32299, '2020-10-27', 'GI', 'Gibraltar', 'EURO', '7', '667', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32300, '2020-10-28', 'GI', 'Gibraltar', 'EURO', '3', '670', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32301, '2020-10-29', 'GI', 'Gibraltar', 'EURO', '9', '679', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32302, '2020-10-30', 'GI', 'Gibraltar', 'EURO', '3', '682', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32303, '2020-10-31', 'GI', 'Gibraltar', 'EURO', '6', '688', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32304, '2020-11-01', 'GI', 'Gibraltar', 'EURO', '5', '693', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32305, '2020-11-02', 'GI', 'Gibraltar', 'EURO', '4', '697', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32306, '2020-11-03', 'GI', 'Gibraltar', 'EURO', '6', '703', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32307, '2020-11-04', 'GI', 'Gibraltar', 'EURO', '4', '707', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32308, '2020-11-05', 'GI', 'Gibraltar', 'EURO', '23', '730', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32309, '2020-11-06', 'GI', 'Gibraltar', 'EURO', '13', '743', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32310, '2020-11-07', 'GI', 'Gibraltar', 'EURO', '11', '754', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32311, '2020-11-08', 'GI', 'Gibraltar', 'EURO', '16', '770', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32312, '2020-11-09', 'GI', 'Gibraltar', 'EURO', '15', '785', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32313, '2020-11-10', 'GI', 'Gibraltar', 'EURO', '8', '793', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32314, '2020-11-11', 'GI', 'Gibraltar', 'EURO', '12', '805', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32315, '2020-11-12', 'GI', 'Gibraltar', 'EURO', '9', '814', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32316, '2020-11-13', 'GI', 'Gibraltar', 'EURO', '28', '842', '1', '1');
INSERT INTO public.who_global_data_import VALUES (32317, '2020-11-14', 'GI', 'Gibraltar', 'EURO', '22', '864', '0', '1');
INSERT INTO public.who_global_data_import VALUES (32318, '2020-11-15', 'GI', 'Gibraltar', 'EURO', '12', '876', '0', '1');
INSERT INTO public.who_global_data_import VALUES (32319, '2020-11-16', 'GI', 'Gibraltar', 'EURO', '11', '887', '0', '1');
INSERT INTO public.who_global_data_import VALUES (32320, '2020-11-17', 'GI', 'Gibraltar', 'EURO', '15', '902', '0', '1');
INSERT INTO public.who_global_data_import VALUES (32321, '2020-11-18', 'GI', 'Gibraltar', 'EURO', '5', '907', '0', '1');
INSERT INTO public.who_global_data_import VALUES (32322, '2020-11-19', 'GI', 'Gibraltar', 'EURO', '8', '915', '1', '2');
INSERT INTO public.who_global_data_import VALUES (32323, '2020-11-20', 'GI', 'Gibraltar', 'EURO', '11', '926', '0', '2');
INSERT INTO public.who_global_data_import VALUES (32324, '2020-11-21', 'GI', 'Gibraltar', 'EURO', '5', '931', '1', '3');
INSERT INTO public.who_global_data_import VALUES (32325, '2020-11-22', 'GI', 'Gibraltar', 'EURO', '12', '943', '0', '3');
INSERT INTO public.who_global_data_import VALUES (32326, '2020-11-23', 'GI', 'Gibraltar', 'EURO', '10', '953', '0', '3');
INSERT INTO public.who_global_data_import VALUES (32327, '2020-11-24', 'GI', 'Gibraltar', 'EURO', '5', '958', '1', '4');
INSERT INTO public.who_global_data_import VALUES (32328, '2020-11-25', 'GI', 'Gibraltar', 'EURO', '9', '967', '1', '5');
INSERT INTO public.who_global_data_import VALUES (32329, '2020-11-26', 'GI', 'Gibraltar', 'EURO', '14', '981', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32330, '2020-11-27', 'GI', 'Gibraltar', 'EURO', '10', '991', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32331, '2020-11-28', 'GI', 'Gibraltar', 'EURO', '0', '991', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32332, '2020-11-29', 'GI', 'Gibraltar', 'EURO', '8', '999', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32333, '2020-11-30', 'GI', 'Gibraltar', 'EURO', '10', '1009', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32334, '2020-12-01', 'GI', 'Gibraltar', 'EURO', '5', '1014', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32335, '2020-12-02', 'GI', 'Gibraltar', 'EURO', '6', '1020', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32336, '2020-12-03', 'GI', 'Gibraltar', 'EURO', '10', '1030', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32337, '2020-12-04', 'GI', 'Gibraltar', 'EURO', '5', '1035', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32338, '2020-12-05', 'GI', 'Gibraltar', 'EURO', '3', '1038', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32339, '2020-12-06', 'GI', 'Gibraltar', 'EURO', '4', '1042', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32340, '2020-12-07', 'GI', 'Gibraltar', 'EURO', '6', '1048', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32341, '2020-12-08', 'GI', 'Gibraltar', 'EURO', '5', '1053', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32342, '2020-12-09', 'GI', 'Gibraltar', 'EURO', '2', '1055', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32343, '2020-12-10', 'GI', 'Gibraltar', 'EURO', '3', '1058', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32344, '2020-12-11', 'GI', 'Gibraltar', 'EURO', '7', '1065', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32345, '2020-12-12', 'GI', 'Gibraltar', 'EURO', '4', '1069', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32346, '2020-12-13', 'GI', 'Gibraltar', 'EURO', '1', '1070', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32347, '2020-12-14', 'GI', 'Gibraltar', 'EURO', '2', '1072', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32348, '2020-12-15', 'GI', 'Gibraltar', 'EURO', '3', '1075', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32349, '2020-12-16', 'GI', 'Gibraltar', 'EURO', '7', '1082', '1', '6');
INSERT INTO public.who_global_data_import VALUES (32350, '2020-12-17', 'GI', 'Gibraltar', 'EURO', '22', '1104', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32351, '2020-12-18', 'GI', 'Gibraltar', 'EURO', '21', '1125', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32352, '2020-12-19', 'GI', 'Gibraltar', 'EURO', '28', '1153', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32353, '2020-12-20', 'GI', 'Gibraltar', 'EURO', '31', '1184', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32354, '2020-12-21', 'GI', 'Gibraltar', 'EURO', '27', '1211', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32355, '2020-12-22', 'GI', 'Gibraltar', 'EURO', '33', '1244', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32356, '2020-12-23', 'GI', 'Gibraltar', 'EURO', '38', '1282', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32357, '2020-12-24', 'GI', 'Gibraltar', 'EURO', '48', '1330', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32358, '2020-12-25', 'GI', 'Gibraltar', 'EURO', '68', '1398', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32359, '2020-12-26', 'GI', 'Gibraltar', 'EURO', '78', '1476', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32360, '2020-12-27', 'GI', 'Gibraltar', 'EURO', '58', '1534', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32361, '2020-12-28', 'GI', 'Gibraltar', 'EURO', '59', '1593', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32362, '2020-12-29', 'GI', 'Gibraltar', 'EURO', '68', '1661', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32363, '2020-12-30', 'GI', 'Gibraltar', 'EURO', '45', '1706', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32364, '2020-12-31', 'GI', 'Gibraltar', 'EURO', '87', '1793', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32365, '2021-01-01', 'GI', 'Gibraltar', 'EURO', '180', '1973', '0', '6');
INSERT INTO public.who_global_data_import VALUES (32366, '2021-01-02', 'GI', 'Gibraltar', 'EURO', '67', '2040', '1', '7');
INSERT INTO public.who_global_data_import VALUES (32367, '2021-01-03', 'GI', 'Gibraltar', 'EURO', '172', '2212', '0', '7');
INSERT INTO public.who_global_data_import VALUES (32368, '2021-01-04', 'GI', 'Gibraltar', 'EURO', '92', '2304', '0', '7');
INSERT INTO public.who_global_data_import VALUES (32369, '2021-01-05', 'GI', 'Gibraltar', 'EURO', '102', '2406', '1', '8');
INSERT INTO public.who_global_data_import VALUES (32370, '2021-01-06', 'GI', 'Gibraltar', 'EURO', '107', '2513', '0', '8');
INSERT INTO public.who_global_data_import VALUES (32371, '2021-01-07', 'GI', 'Gibraltar', 'EURO', '113', '2626', '2', '10');
INSERT INTO public.who_global_data_import VALUES (32372, '2021-01-08', 'GI', 'Gibraltar', 'EURO', '172', '2798', '1', '11');
INSERT INTO public.who_global_data_import VALUES (32373, '2021-01-09', 'GI', 'Gibraltar', 'EURO', '130', '2928', '0', '11');
INSERT INTO public.who_global_data_import VALUES (32374, '2021-01-10', 'GI', 'Gibraltar', 'EURO', '93', '3021', '1', '12');
INSERT INTO public.who_global_data_import VALUES (32375, '2021-01-11', 'GI', 'Gibraltar', 'EURO', '88', '3109', '0', '12');
INSERT INTO public.who_global_data_import VALUES (32376, '2021-01-12', 'GI', 'Gibraltar', 'EURO', '61', '3170', '4', '16');
INSERT INTO public.who_global_data_import VALUES (32377, '2021-01-13', 'GI', 'Gibraltar', 'EURO', '70', '3240', '0', '16');
INSERT INTO public.who_global_data_import VALUES (32378, '2021-01-14', 'GI', 'Gibraltar', 'EURO', '84', '3324', '1', '17');
INSERT INTO public.who_global_data_import VALUES (32379, '2021-01-15', 'GI', 'Gibraltar', 'EURO', '107', '3431', '3', '20');
INSERT INTO public.who_global_data_import VALUES (32380, '2021-01-16', 'GI', 'Gibraltar', 'EURO', '78', '3509', '5', '25');
INSERT INTO public.who_global_data_import VALUES (32381, '2021-01-17', 'GI', 'Gibraltar', 'EURO', '66', '3575', '5', '30');
INSERT INTO public.who_global_data_import VALUES (32382, '2021-01-18', 'GI', 'Gibraltar', 'EURO', '62', '3637', '4', '34');
INSERT INTO public.who_global_data_import VALUES (32383, '2021-01-19', 'GI', 'Gibraltar', 'EURO', '33', '3670', '9', '43');
INSERT INTO public.who_global_data_import VALUES (32384, '2021-01-20', 'GI', 'Gibraltar', 'EURO', '42', '3712', '2', '45');
INSERT INTO public.who_global_data_import VALUES (32385, '2021-01-21', 'GI', 'Gibraltar', 'EURO', '81', '3793', '2', '47');
INSERT INTO public.who_global_data_import VALUES (32386, '2021-01-22', 'GI', 'Gibraltar', 'EURO', '52', '3845', '6', '53');
INSERT INTO public.who_global_data_import VALUES (32387, '2021-01-23', 'GI', 'Gibraltar', 'EURO', '36', '3881', '6', '59');
INSERT INTO public.who_global_data_import VALUES (32388, '2021-01-24', 'GI', 'Gibraltar', 'EURO', '24', '3905', '0', '59');
INSERT INTO public.who_global_data_import VALUES (32389, '2021-01-25', 'GI', 'Gibraltar', 'EURO', '30', '3935', '3', '62');
INSERT INTO public.who_global_data_import VALUES (32390, '2021-01-26', 'GI', 'Gibraltar', 'EURO', '31', '3966', '1', '63');
INSERT INTO public.who_global_data_import VALUES (32391, '2021-01-27', 'GI', 'Gibraltar', 'EURO', '26', '3992', '2', '65');
INSERT INTO public.who_global_data_import VALUES (32392, '2021-01-28', 'GI', 'Gibraltar', 'EURO', '32', '4024', '4', '69');
INSERT INTO public.who_global_data_import VALUES (32393, '2021-01-29', 'GI', 'Gibraltar', 'EURO', '33', '4057', '1', '70');
INSERT INTO public.who_global_data_import VALUES (32394, '2021-01-30', 'GI', 'Gibraltar', 'EURO', '25', '4082', '0', '70');
INSERT INTO public.who_global_data_import VALUES (32395, '2021-01-31', 'GI', 'Gibraltar', 'EURO', '14', '4096', '3', '73');
INSERT INTO public.who_global_data_import VALUES (32396, '2021-02-01', 'GI', 'Gibraltar', 'EURO', '12', '4108', '2', '75');
INSERT INTO public.who_global_data_import VALUES (32397, '2021-02-02', 'GI', 'Gibraltar', 'EURO', '6', '4114', '2', '77');
INSERT INTO public.who_global_data_import VALUES (32398, '2021-02-03', 'GI', 'Gibraltar', 'EURO', '14', '4128', '1', '78');
INSERT INTO public.who_global_data_import VALUES (32399, '2021-02-04', 'GI', 'Gibraltar', 'EURO', '15', '4143', '1', '79');
INSERT INTO public.who_global_data_import VALUES (32400, '2021-02-05', 'GI', 'Gibraltar', 'EURO', '13', '4156', '0', '79');
INSERT INTO public.who_global_data_import VALUES (32401, '2020-01-03', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32402, '2020-01-04', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32403, '2020-01-05', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32404, '2020-01-06', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32405, '2020-01-07', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32406, '2020-01-08', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32407, '2020-01-09', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32408, '2020-01-10', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32409, '2020-01-11', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32410, '2020-01-12', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32411, '2020-01-13', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32412, '2020-01-14', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32413, '2020-01-15', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32414, '2020-01-16', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32415, '2020-01-17', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32416, '2020-01-18', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32417, '2020-01-19', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32418, '2020-01-20', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32419, '2020-01-21', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32420, '2020-01-22', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32421, '2020-01-23', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32422, '2020-01-24', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32423, '2020-01-25', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32424, '2020-01-26', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32425, '2020-01-27', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32426, '2020-01-28', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32427, '2020-01-29', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32428, '2020-01-30', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32429, '2020-01-31', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32430, '2020-02-01', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32431, '2020-02-02', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32432, '2020-02-03', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32433, '2020-02-04', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32434, '2020-02-05', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32435, '2020-02-06', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32436, '2020-02-07', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32437, '2020-02-08', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32438, '2020-02-09', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32439, '2020-02-10', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32440, '2020-02-11', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32441, '2020-02-12', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32442, '2020-02-13', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32443, '2020-02-14', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32444, '2020-02-15', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32445, '2020-02-16', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32446, '2020-02-17', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32447, '2020-02-18', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32448, '2020-02-19', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32449, '2020-02-20', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32450, '2020-02-21', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32451, '2020-02-22', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32452, '2020-02-23', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32453, '2020-02-24', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32454, '2020-02-25', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32455, '2020-02-26', 'GR', 'Greece', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32456, '2020-02-27', 'GR', 'Greece', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32457, '2020-02-28', 'GR', 'Greece', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32458, '2020-02-29', 'GR', 'Greece', 'EURO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32459, '2020-03-01', 'GR', 'Greece', 'EURO', '3', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32460, '2020-03-02', 'GR', 'Greece', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32461, '2020-03-03', 'GR', 'Greece', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32462, '2020-03-04', 'GR', 'Greece', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32463, '2020-03-05', 'GR', 'Greece', 'EURO', '3', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32464, '2020-03-06', 'GR', 'Greece', 'EURO', '22', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32465, '2020-03-07', 'GR', 'Greece', 'EURO', '13', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32466, '2020-03-08', 'GR', 'Greece', 'EURO', '21', '66', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32467, '2020-03-09', 'GR', 'Greece', 'EURO', '7', '73', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32468, '2020-03-10', 'GR', 'Greece', 'EURO', '11', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32469, '2020-03-11', 'GR', 'Greece', 'EURO', '6', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32470, '2020-03-12', 'GR', 'Greece', 'EURO', '9', '99', '1', '1');
INSERT INTO public.who_global_data_import VALUES (32471, '2020-03-13', 'GR', 'Greece', 'EURO', '34', '133', '0', '1');
INSERT INTO public.who_global_data_import VALUES (32472, '2020-03-14', 'GR', 'Greece', 'EURO', '57', '190', '0', '1');
INSERT INTO public.who_global_data_import VALUES (32473, '2020-03-15', 'GR', 'Greece', 'EURO', '38', '228', '2', '3');
INSERT INTO public.who_global_data_import VALUES (32474, '2020-03-16', 'GR', 'Greece', 'EURO', '103', '331', '1', '4');
INSERT INTO public.who_global_data_import VALUES (32475, '2020-03-17', 'GR', 'Greece', 'EURO', '21', '352', '0', '4');
INSERT INTO public.who_global_data_import VALUES (32476, '2020-03-18', 'GR', 'Greece', 'EURO', '35', '387', '1', '5');
INSERT INTO public.who_global_data_import VALUES (32477, '2020-03-19', 'GR', 'Greece', 'EURO', '31', '418', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32478, '2020-03-20', 'GR', 'Greece', 'EURO', '46', '464', '0', '5');
INSERT INTO public.who_global_data_import VALUES (32479, '2020-03-21', 'GR', 'Greece', 'EURO', '31', '495', '3', '8');
INSERT INTO public.who_global_data_import VALUES (32480, '2020-03-22', 'GR', 'Greece', 'EURO', '35', '530', '5', '13');
INSERT INTO public.who_global_data_import VALUES (32481, '2020-03-23', 'GR', 'Greece', 'EURO', '94', '624', '2', '15');
INSERT INTO public.who_global_data_import VALUES (32482, '2020-03-24', 'GR', 'Greece', 'EURO', '71', '695', '2', '17');
INSERT INTO public.who_global_data_import VALUES (32483, '2020-03-25', 'GR', 'Greece', 'EURO', '48', '743', '3', '20');
INSERT INTO public.who_global_data_import VALUES (32484, '2020-03-26', 'GR', 'Greece', 'EURO', '78', '821', '2', '22');
INSERT INTO public.who_global_data_import VALUES (32485, '2020-03-27', 'GR', 'Greece', 'EURO', '71', '892', '4', '26');
INSERT INTO public.who_global_data_import VALUES (32486, '2020-03-28', 'GR', 'Greece', 'EURO', '74', '966', '2', '28');
INSERT INTO public.who_global_data_import VALUES (32487, '2020-03-29', 'GR', 'Greece', 'EURO', '95', '1061', '4', '32');
INSERT INTO public.who_global_data_import VALUES (32488, '2020-03-30', 'GR', 'Greece', 'EURO', '95', '1156', '6', '38');
INSERT INTO public.who_global_data_import VALUES (32489, '2020-03-31', 'GR', 'Greece', 'EURO', '56', '1212', '5', '43');
INSERT INTO public.who_global_data_import VALUES (32490, '2020-04-01', 'GR', 'Greece', 'EURO', '102', '1314', '6', '49');
INSERT INTO public.who_global_data_import VALUES (32491, '2020-04-02', 'GR', 'Greece', 'EURO', '61', '1375', '1', '50');
INSERT INTO public.who_global_data_import VALUES (32492, '2020-04-03', 'GR', 'Greece', 'EURO', '139', '1514', '3', '53');
INSERT INTO public.who_global_data_import VALUES (32493, '2020-04-04', 'GR', 'Greece', 'EURO', '99', '1613', '6', '59');
INSERT INTO public.who_global_data_import VALUES (32494, '2020-04-05', 'GR', 'Greece', 'EURO', '60', '1673', '9', '68');
INSERT INTO public.who_global_data_import VALUES (32495, '2020-04-06', 'GR', 'Greece', 'EURO', '62', '1735', '5', '73');
INSERT INTO public.who_global_data_import VALUES (32496, '2020-04-07', 'GR', 'Greece', 'EURO', '20', '1755', '6', '79');
INSERT INTO public.who_global_data_import VALUES (32497, '2020-04-08', 'GR', 'Greece', 'EURO', '77', '1832', '2', '81');
INSERT INTO public.who_global_data_import VALUES (32498, '2020-04-09', 'GR', 'Greece', 'EURO', '52', '1884', '2', '83');
INSERT INTO public.who_global_data_import VALUES (32499, '2020-04-10', 'GR', 'Greece', 'EURO', '71', '1955', '3', '86');
INSERT INTO public.who_global_data_import VALUES (32500, '2020-04-11', 'GR', 'Greece', 'EURO', '56', '2011', '4', '90');
INSERT INTO public.who_global_data_import VALUES (32501, '2020-04-12', 'GR', 'Greece', 'EURO', '70', '2081', '3', '93');
INSERT INTO public.who_global_data_import VALUES (32502, '2020-04-13', 'GR', 'Greece', 'EURO', '33', '2114', '5', '98');
INSERT INTO public.who_global_data_import VALUES (32503, '2020-04-14', 'GR', 'Greece', 'EURO', '31', '2145', '1', '99');
INSERT INTO public.who_global_data_import VALUES (32504, '2020-04-15', 'GR', 'Greece', 'EURO', '25', '2170', '2', '101');
INSERT INTO public.who_global_data_import VALUES (32505, '2020-04-16', 'GR', 'Greece', 'EURO', '22', '2192', '1', '102');
INSERT INTO public.who_global_data_import VALUES (32506, '2020-04-17', 'GR', 'Greece', 'EURO', '15', '2207', '3', '105');
INSERT INTO public.who_global_data_import VALUES (32507, '2020-04-18', 'GR', 'Greece', 'EURO', '0', '2207', '0', '105');
INSERT INTO public.who_global_data_import VALUES (32508, '2020-04-19', 'GR', 'Greece', 'EURO', '0', '2207', '0', '105');
INSERT INTO public.who_global_data_import VALUES (32509, '2020-04-20', 'GR', 'Greece', 'EURO', '28', '2235', '5', '110');
INSERT INTO public.who_global_data_import VALUES (32510, '2020-04-21', 'GR', 'Greece', 'EURO', '10', '2245', '6', '116');
INSERT INTO public.who_global_data_import VALUES (32511, '2020-04-22', 'GR', 'Greece', 'EURO', '156', '2401', '5', '121');
INSERT INTO public.who_global_data_import VALUES (32512, '2020-04-23', 'GR', 'Greece', 'EURO', '7', '2408', '0', '121');
INSERT INTO public.who_global_data_import VALUES (32513, '2020-04-24', 'GR', 'Greece', 'EURO', '55', '2463', '4', '125');
INSERT INTO public.who_global_data_import VALUES (32514, '2020-04-25', 'GR', 'Greece', 'EURO', '27', '2490', '5', '130');
INSERT INTO public.who_global_data_import VALUES (32515, '2020-04-26', 'GR', 'Greece', 'EURO', '16', '2506', '0', '130');
INSERT INTO public.who_global_data_import VALUES (32516, '2020-04-27', 'GR', 'Greece', 'EURO', '0', '2506', '0', '130');
INSERT INTO public.who_global_data_import VALUES (32517, '2020-04-28', 'GR', 'Greece', 'EURO', '28', '2534', '6', '136');
INSERT INTO public.who_global_data_import VALUES (32518, '2020-04-29', 'GR', 'Greece', 'EURO', '0', '2534', '0', '136');
INSERT INTO public.who_global_data_import VALUES (32519, '2020-04-30', 'GR', 'Greece', 'EURO', '42', '2576', '3', '139');
INSERT INTO public.who_global_data_import VALUES (32520, '2020-05-01', 'GR', 'Greece', 'EURO', '15', '2591', '1', '140');
INSERT INTO public.who_global_data_import VALUES (32521, '2020-05-02', 'GR', 'Greece', 'EURO', '0', '2591', '0', '140');
INSERT INTO public.who_global_data_import VALUES (32522, '2020-05-03', 'GR', 'Greece', 'EURO', '29', '2620', '3', '143');
INSERT INTO public.who_global_data_import VALUES (32523, '2020-05-04', 'GR', 'Greece', 'EURO', '6', '2626', '1', '144');
INSERT INTO public.who_global_data_import VALUES (32524, '2020-05-05', 'GR', 'Greece', 'EURO', '6', '2632', '2', '146');
INSERT INTO public.who_global_data_import VALUES (32525, '2020-05-06', 'GR', 'Greece', 'EURO', '10', '2642', '0', '146');
INSERT INTO public.who_global_data_import VALUES (32526, '2020-05-07', 'GR', 'Greece', 'EURO', '21', '2663', '1', '147');
INSERT INTO public.who_global_data_import VALUES (32527, '2020-05-08', 'GR', 'Greece', 'EURO', '15', '2678', '1', '148');
INSERT INTO public.who_global_data_import VALUES (32528, '2020-05-09', 'GR', 'Greece', 'EURO', '13', '2691', '2', '150');
INSERT INTO public.who_global_data_import VALUES (32529, '2020-05-10', 'GR', 'Greece', 'EURO', '19', '2710', '1', '151');
INSERT INTO public.who_global_data_import VALUES (32530, '2020-05-11', 'GR', 'Greece', 'EURO', '6', '2716', '0', '151');
INSERT INTO public.who_global_data_import VALUES (32531, '2020-05-12', 'GR', 'Greece', 'EURO', '10', '2726', '0', '151');
INSERT INTO public.who_global_data_import VALUES (32532, '2020-05-13', 'GR', 'Greece', 'EURO', '18', '2744', '1', '152');
INSERT INTO public.who_global_data_import VALUES (32533, '2020-05-14', 'GR', 'Greece', 'EURO', '16', '2760', '3', '155');
INSERT INTO public.who_global_data_import VALUES (32534, '2020-05-15', 'GR', 'Greece', 'EURO', '10', '2770', '1', '156');
INSERT INTO public.who_global_data_import VALUES (32535, '2020-05-16', 'GR', 'Greece', 'EURO', '40', '2810', '4', '160');
INSERT INTO public.who_global_data_import VALUES (32536, '2020-05-17', 'GR', 'Greece', 'EURO', '9', '2819', '2', '162');
INSERT INTO public.who_global_data_import VALUES (32537, '2020-05-18', 'GR', 'Greece', 'EURO', '15', '2834', '1', '163');
INSERT INTO public.who_global_data_import VALUES (32538, '2020-05-19', 'GR', 'Greece', 'EURO', '2', '2836', '2', '165');
INSERT INTO public.who_global_data_import VALUES (32539, '2020-05-20', 'GR', 'Greece', 'EURO', '4', '2840', '0', '165');
INSERT INTO public.who_global_data_import VALUES (32540, '2020-05-21', 'GR', 'Greece', 'EURO', '10', '2850', '1', '166');
INSERT INTO public.who_global_data_import VALUES (32541, '2020-05-22', 'GR', 'Greece', 'EURO', '3', '2853', '2', '168');
INSERT INTO public.who_global_data_import VALUES (32542, '2020-05-23', 'GR', 'Greece', 'EURO', '20', '2873', '1', '169');
INSERT INTO public.who_global_data_import VALUES (32543, '2020-05-24', 'GR', 'Greece', 'EURO', '3', '2876', '2', '171');
INSERT INTO public.who_global_data_import VALUES (32544, '2020-05-25', 'GR', 'Greece', 'EURO', '2', '2878', '0', '171');
INSERT INTO public.who_global_data_import VALUES (32545, '2020-05-26', 'GR', 'Greece', 'EURO', '4', '2882', '1', '172');
INSERT INTO public.who_global_data_import VALUES (32546, '2020-05-27', 'GR', 'Greece', 'EURO', '10', '2892', '1', '173');
INSERT INTO public.who_global_data_import VALUES (32547, '2020-05-28', 'GR', 'Greece', 'EURO', '11', '2903', '0', '173');
INSERT INTO public.who_global_data_import VALUES (32548, '2020-05-29', 'GR', 'Greece', 'EURO', '3', '2906', '2', '175');
INSERT INTO public.who_global_data_import VALUES (32549, '2020-05-30', 'GR', 'Greece', 'EURO', '3', '2909', '0', '175');
INSERT INTO public.who_global_data_import VALUES (32550, '2020-05-31', 'GR', 'Greece', 'EURO', '6', '2915', '0', '175');
INSERT INTO public.who_global_data_import VALUES (32551, '2020-06-01', 'GR', 'Greece', 'EURO', '2', '2917', '0', '175');
INSERT INTO public.who_global_data_import VALUES (32552, '2020-06-02', 'GR', 'Greece', 'EURO', '1', '2918', '4', '179');
INSERT INTO public.who_global_data_import VALUES (32553, '2020-06-03', 'GR', 'Greece', 'EURO', '19', '2937', '0', '179');
INSERT INTO public.who_global_data_import VALUES (32554, '2020-06-04', 'GR', 'Greece', 'EURO', '0', '2937', '0', '179');
INSERT INTO public.who_global_data_import VALUES (32555, '2020-06-05', 'GR', 'Greece', 'EURO', '15', '2952', '1', '180');
INSERT INTO public.who_global_data_import VALUES (32556, '2020-06-06', 'GR', 'Greece', 'EURO', '15', '2967', '0', '180');
INSERT INTO public.who_global_data_import VALUES (32557, '2020-06-07', 'GR', 'Greece', 'EURO', '13', '2980', '0', '180');
INSERT INTO public.who_global_data_import VALUES (32558, '2020-06-08', 'GR', 'Greece', 'EURO', '17', '2997', '0', '180');
INSERT INTO public.who_global_data_import VALUES (32559, '2020-06-09', 'GR', 'Greece', 'EURO', '52', '3049', '2', '182');
INSERT INTO public.who_global_data_import VALUES (32560, '2020-06-10', 'GR', 'Greece', 'EURO', '9', '3058', '1', '183');
INSERT INTO public.who_global_data_import VALUES (32561, '2020-06-11', 'GR', 'Greece', 'EURO', '10', '3068', '0', '183');
INSERT INTO public.who_global_data_import VALUES (32562, '2020-06-12', 'GR', 'Greece', 'EURO', '20', '3088', '0', '183');
INSERT INTO public.who_global_data_import VALUES (32563, '2020-06-13', 'GR', 'Greece', 'EURO', '20', '3108', '0', '183');
INSERT INTO public.who_global_data_import VALUES (32564, '2020-06-14', 'GR', 'Greece', 'EURO', '4', '3112', '0', '183');
INSERT INTO public.who_global_data_import VALUES (32565, '2020-06-15', 'GR', 'Greece', 'EURO', '9', '3121', '0', '183');
INSERT INTO public.who_global_data_import VALUES (32566, '2020-06-16', 'GR', 'Greece', 'EURO', '13', '3134', '1', '184');
INSERT INTO public.who_global_data_import VALUES (32567, '2020-06-17', 'GR', 'Greece', 'EURO', '14', '3148', '1', '185');
INSERT INTO public.who_global_data_import VALUES (32568, '2020-06-18', 'GR', 'Greece', 'EURO', '55', '3203', '2', '187');
INSERT INTO public.who_global_data_import VALUES (32569, '2020-06-19', 'GR', 'Greece', 'EURO', '24', '3227', '1', '188');
INSERT INTO public.who_global_data_import VALUES (32570, '2020-06-20', 'GR', 'Greece', 'EURO', '10', '3237', '1', '189');
INSERT INTO public.who_global_data_import VALUES (32571, '2020-06-21', 'GR', 'Greece', 'EURO', '19', '3256', '1', '190');
INSERT INTO public.who_global_data_import VALUES (32572, '2020-06-22', 'GR', 'Greece', 'EURO', '10', '3266', '0', '190');
INSERT INTO public.who_global_data_import VALUES (32573, '2020-06-23', 'GR', 'Greece', 'EURO', '21', '3287', '0', '190');
INSERT INTO public.who_global_data_import VALUES (32574, '2020-06-24', 'GR', 'Greece', 'EURO', '15', '3302', '0', '190');
INSERT INTO public.who_global_data_import VALUES (32575, '2020-06-25', 'GR', 'Greece', 'EURO', '8', '3310', '0', '190');
INSERT INTO public.who_global_data_import VALUES (32576, '2020-06-26', 'GR', 'Greece', 'EURO', '11', '3321', '1', '191');
INSERT INTO public.who_global_data_import VALUES (32577, '2020-06-27', 'GR', 'Greece', 'EURO', '22', '3343', '0', '191');
INSERT INTO public.who_global_data_import VALUES (32578, '2020-06-28', 'GR', 'Greece', 'EURO', '23', '3366', '0', '191');
INSERT INTO public.who_global_data_import VALUES (32579, '2020-06-29', 'GR', 'Greece', 'EURO', '10', '3376', '0', '191');
INSERT INTO public.who_global_data_import VALUES (32580, '2020-06-30', 'GR', 'Greece', 'EURO', '14', '3390', '0', '191');
INSERT INTO public.who_global_data_import VALUES (32581, '2020-07-01', 'GR', 'Greece', 'EURO', '19', '3409', '1', '192');
INSERT INTO public.who_global_data_import VALUES (32582, '2020-07-02', 'GR', 'Greece', 'EURO', '23', '3432', '0', '192');
INSERT INTO public.who_global_data_import VALUES (32583, '2020-07-03', 'GR', 'Greece', 'EURO', '26', '3458', '0', '192');
INSERT INTO public.who_global_data_import VALUES (32584, '2020-07-04', 'GR', 'Greece', 'EURO', '28', '3486', '0', '192');
INSERT INTO public.who_global_data_import VALUES (32585, '2020-07-05', 'GR', 'Greece', 'EURO', '25', '3511', '0', '192');
INSERT INTO public.who_global_data_import VALUES (32586, '2020-07-06', 'GR', 'Greece', 'EURO', '8', '3519', '0', '192');
INSERT INTO public.who_global_data_import VALUES (32587, '2020-07-07', 'GR', 'Greece', 'EURO', '43', '3562', '0', '192');
INSERT INTO public.who_global_data_import VALUES (32588, '2020-07-08', 'GR', 'Greece', 'EURO', '27', '3589', '1', '193');
INSERT INTO public.who_global_data_import VALUES (32589, '2020-07-09', 'GR', 'Greece', 'EURO', '33', '3622', '0', '193');
INSERT INTO public.who_global_data_import VALUES (32590, '2020-07-10', 'GR', 'Greece', 'EURO', '50', '3672', '0', '193');
INSERT INTO public.who_global_data_import VALUES (32591, '2020-07-11', 'GR', 'Greece', 'EURO', '60', '3732', '0', '193');
INSERT INTO public.who_global_data_import VALUES (32592, '2020-07-12', 'GR', 'Greece', 'EURO', '40', '3772', '0', '193');
INSERT INTO public.who_global_data_import VALUES (32593, '2020-07-13', 'GR', 'Greece', 'EURO', '31', '3803', '0', '193');
INSERT INTO public.who_global_data_import VALUES (32594, '2020-07-14', 'GR', 'Greece', 'EURO', '23', '3826', '0', '193');
INSERT INTO public.who_global_data_import VALUES (32595, '2020-07-15', 'GR', 'Greece', 'EURO', '57', '3883', '0', '193');
INSERT INTO public.who_global_data_import VALUES (32596, '2020-07-16', 'GR', 'Greece', 'EURO', '27', '3910', '0', '193');
INSERT INTO public.who_global_data_import VALUES (32597, '2020-07-17', 'GR', 'Greece', 'EURO', '29', '3939', '0', '193');
INSERT INTO public.who_global_data_import VALUES (32598, '2020-07-18', 'GR', 'Greece', 'EURO', '25', '3964', '1', '194');
INSERT INTO public.who_global_data_import VALUES (32599, '2020-07-19', 'GR', 'Greece', 'EURO', '19', '3983', '0', '194');
INSERT INTO public.who_global_data_import VALUES (32600, '2020-07-20', 'GR', 'Greece', 'EURO', '24', '4007', '0', '194');
INSERT INTO public.who_global_data_import VALUES (32601, '2020-07-21', 'GR', 'Greece', 'EURO', '5', '4012', '1', '195');
INSERT INTO public.who_global_data_import VALUES (32602, '2020-07-22', 'GR', 'Greece', 'EURO', '36', '4048', '2', '197');
INSERT INTO public.who_global_data_import VALUES (32603, '2020-07-23', 'GR', 'Greece', 'EURO', '29', '4077', '3', '200');
INSERT INTO public.who_global_data_import VALUES (32604, '2020-07-24', 'GR', 'Greece', 'EURO', '33', '4110', '1', '201');
INSERT INTO public.who_global_data_import VALUES (32605, '2020-07-25', 'GR', 'Greece', 'EURO', '25', '4135', '0', '201');
INSERT INTO public.who_global_data_import VALUES (32606, '2020-07-26', 'GR', 'Greece', 'EURO', '31', '4166', '0', '201');
INSERT INTO public.who_global_data_import VALUES (32607, '2020-07-27', 'GR', 'Greece', 'EURO', '27', '4193', '1', '202');
INSERT INTO public.who_global_data_import VALUES (32608, '2020-07-28', 'GR', 'Greece', 'EURO', '34', '4227', '0', '202');
INSERT INTO public.who_global_data_import VALUES (32609, '2020-07-29', 'GR', 'Greece', 'EURO', '52', '4279', '1', '203');
INSERT INTO public.who_global_data_import VALUES (32610, '2020-07-30', 'GR', 'Greece', 'EURO', '57', '4336', '0', '203');
INSERT INTO public.who_global_data_import VALUES (32611, '2020-07-31', 'GR', 'Greece', 'EURO', '65', '4401', '0', '203');
INSERT INTO public.who_global_data_import VALUES (32612, '2020-08-01', 'GR', 'Greece', 'EURO', '76', '4477', '3', '206');
INSERT INTO public.who_global_data_import VALUES (32613, '2020-08-02', 'GR', 'Greece', 'EURO', '110', '4587', '0', '206');
INSERT INTO public.who_global_data_import VALUES (32614, '2020-08-03', 'GR', 'Greece', 'EURO', '75', '4662', '2', '208');
INSERT INTO public.who_global_data_import VALUES (32615, '2020-08-04', 'GR', 'Greece', 'EURO', '75', '4737', '1', '209');
INSERT INTO public.who_global_data_import VALUES (32616, '2020-08-05', 'GR', 'Greece', 'EURO', '118', '4855', '0', '209');
INSERT INTO public.who_global_data_import VALUES (32617, '2020-08-06', 'GR', 'Greece', 'EURO', '118', '4973', '1', '210');
INSERT INTO public.who_global_data_import VALUES (32618, '2020-08-07', 'GR', 'Greece', 'EURO', '150', '5123', '0', '210');
INSERT INTO public.who_global_data_import VALUES (32619, '2020-08-08', 'GR', 'Greece', 'EURO', '147', '5270', '0', '210');
INSERT INTO public.who_global_data_import VALUES (32620, '2020-08-09', 'GR', 'Greece', 'EURO', '151', '5421', '1', '211');
INSERT INTO public.who_global_data_import VALUES (32621, '2020-08-10', 'GR', 'Greece', 'EURO', '202', '5623', '1', '212');
INSERT INTO public.who_global_data_import VALUES (32622, '2020-08-11', 'GR', 'Greece', 'EURO', '126', '5749', '1', '213');
INSERT INTO public.who_global_data_import VALUES (32623, '2020-08-12', 'GR', 'Greece', 'EURO', '193', '5942', '1', '214');
INSERT INTO public.who_global_data_import VALUES (32624, '2020-08-13', 'GR', 'Greece', 'EURO', '235', '6177', '2', '216');
INSERT INTO public.who_global_data_import VALUES (32625, '2020-08-14', 'GR', 'Greece', 'EURO', '204', '6381', '5', '221');
INSERT INTO public.who_global_data_import VALUES (32626, '2020-08-15', 'GR', 'Greece', 'EURO', '251', '6632', '2', '223');
INSERT INTO public.who_global_data_import VALUES (32627, '2020-08-16', 'GR', 'Greece', 'EURO', '226', '6858', '3', '226');
INSERT INTO public.who_global_data_import VALUES (32628, '2020-08-17', 'GR', 'Greece', 'EURO', '217', '7075', '2', '228');
INSERT INTO public.who_global_data_import VALUES (32629, '2020-08-18', 'GR', 'Greece', 'EURO', '147', '7222', '2', '230');
INSERT INTO public.who_global_data_import VALUES (32630, '2020-08-19', 'GR', 'Greece', 'EURO', '250', '7472', '2', '232');
INSERT INTO public.who_global_data_import VALUES (32631, '2020-08-20', 'GR', 'Greece', 'EURO', '212', '7684', '3', '235');
INSERT INTO public.who_global_data_import VALUES (32632, '2020-08-21', 'GR', 'Greece', 'EURO', '250', '7934', '0', '235');
INSERT INTO public.who_global_data_import VALUES (32633, '2020-08-22', 'GR', 'Greece', 'EURO', '204', '8138', '3', '238');
INSERT INTO public.who_global_data_import VALUES (32634, '2020-08-23', 'GR', 'Greece', 'EURO', '243', '8381', '2', '240');
INSERT INTO public.who_global_data_import VALUES (32635, '2020-08-24', 'GR', 'Greece', 'EURO', '283', '8664', '2', '242');
INSERT INTO public.who_global_data_import VALUES (32636, '2020-08-25', 'GR', 'Greece', 'EURO', '155', '8819', '0', '242');
INSERT INTO public.who_global_data_import VALUES (32637, '2020-08-26', 'GR', 'Greece', 'EURO', '168', '8987', '1', '243');
INSERT INTO public.who_global_data_import VALUES (32638, '2020-08-27', 'GR', 'Greece', 'EURO', '293', '9280', '5', '248');
INSERT INTO public.who_global_data_import VALUES (32639, '2020-08-28', 'GR', 'Greece', 'EURO', '251', '9531', '6', '254');
INSERT INTO public.who_global_data_import VALUES (32640, '2020-08-29', 'GR', 'Greece', 'EURO', '269', '9800', '5', '259');
INSERT INTO public.who_global_data_import VALUES (32641, '2020-08-30', 'GR', 'Greece', 'EURO', '177', '9977', '1', '260');
INSERT INTO public.who_global_data_import VALUES (32642, '2020-08-31', 'GR', 'Greece', 'EURO', '157', '10134', '2', '262');
INSERT INTO public.who_global_data_import VALUES (32643, '2020-09-01', 'GR', 'Greece', 'EURO', '183', '10317', '4', '266');
INSERT INTO public.who_global_data_import VALUES (32644, '2020-09-02', 'GR', 'Greece', 'EURO', '207', '10524', '5', '271');
INSERT INTO public.who_global_data_import VALUES (32645, '2020-09-03', 'GR', 'Greece', 'EURO', '233', '10757', '2', '273');
INSERT INTO public.who_global_data_import VALUES (32646, '2020-09-04', 'GR', 'Greece', 'EURO', '241', '10998', '5', '278');
INSERT INTO public.who_global_data_import VALUES (32647, '2020-09-05', 'GR', 'Greece', 'EURO', '202', '11200', '1', '279');
INSERT INTO public.who_global_data_import VALUES (32648, '2020-09-06', 'GR', 'Greece', 'EURO', '186', '11386', '1', '280');
INSERT INTO public.who_global_data_import VALUES (32649, '2020-09-07', 'GR', 'Greece', 'EURO', '138', '11524', '4', '284');
INSERT INTO public.who_global_data_import VALUES (32650, '2020-09-08', 'GR', 'Greece', 'EURO', '139', '11663', '5', '289');
INSERT INTO public.who_global_data_import VALUES (32651, '2020-09-09', 'GR', 'Greece', 'EURO', '169', '11832', '1', '290');
INSERT INTO public.who_global_data_import VALUES (32652, '2020-09-10', 'GR', 'Greece', 'EURO', '248', '12080', '3', '293');
INSERT INTO public.who_global_data_import VALUES (32653, '2020-09-11', 'GR', 'Greece', 'EURO', '372', '12452', '4', '297');
INSERT INTO public.who_global_data_import VALUES (32654, '2020-09-12', 'GR', 'Greece', 'EURO', '282', '12734', '3', '300');
INSERT INTO public.who_global_data_import VALUES (32655, '2020-09-13', 'GR', 'Greece', 'EURO', '302', '13036', '2', '302');
INSERT INTO public.who_global_data_import VALUES (32656, '2020-09-14', 'GR', 'Greece', 'EURO', '204', '13240', '3', '305');
INSERT INTO public.who_global_data_import VALUES (32657, '2020-09-15', 'GR', 'Greece', 'EURO', '180', '13420', '5', '310');
INSERT INTO public.who_global_data_import VALUES (32658, '2020-09-16', 'GR', 'Greece', 'EURO', '310', '13730', '3', '313');
INSERT INTO public.who_global_data_import VALUES (32659, '2020-09-17', 'GR', 'Greece', 'EURO', '311', '14041', '3', '316');
INSERT INTO public.who_global_data_import VALUES (32660, '2020-09-18', 'GR', 'Greece', 'EURO', '359', '14400', '9', '325');
INSERT INTO public.who_global_data_import VALUES (32661, '2020-09-19', 'GR', 'Greece', 'EURO', '338', '14738', '2', '327');
INSERT INTO public.who_global_data_import VALUES (32662, '2020-09-20', 'GR', 'Greece', 'EURO', '240', '14978', '4', '331');
INSERT INTO public.who_global_data_import VALUES (32663, '2020-09-21', 'GR', 'Greece', 'EURO', '164', '15142', '7', '338');
INSERT INTO public.who_global_data_import VALUES (32664, '2020-09-22', 'GR', 'Greece', 'EURO', '453', '15595', '6', '344');
INSERT INTO public.who_global_data_import VALUES (32665, '2020-09-23', 'GR', 'Greece', 'EURO', '333', '15928', '8', '352');
INSERT INTO public.who_global_data_import VALUES (32666, '2020-09-24', 'GR', 'Greece', 'EURO', '358', '16286', '5', '357');
INSERT INTO public.who_global_data_import VALUES (32667, '2020-09-25', 'GR', 'Greece', 'EURO', '341', '16627', '9', '366');
INSERT INTO public.who_global_data_import VALUES (32668, '2020-09-26', 'GR', 'Greece', 'EURO', '286', '16913', '3', '369');
INSERT INTO public.who_global_data_import VALUES (32669, '2020-09-27', 'GR', 'Greece', 'EURO', '315', '17228', '7', '376');
INSERT INTO public.who_global_data_import VALUES (32670, '2020-09-28', 'GR', 'Greece', 'EURO', '216', '17444', '3', '379');
INSERT INTO public.who_global_data_import VALUES (32671, '2020-09-29', 'GR', 'Greece', 'EURO', '263', '17707', '4', '383');
INSERT INTO public.who_global_data_import VALUES (32672, '2020-09-30', 'GR', 'Greece', 'EURO', '416', '18123', '5', '388');
INSERT INTO public.who_global_data_import VALUES (32673, '2020-10-01', 'GR', 'Greece', 'EURO', '352', '18475', '3', '391');
INSERT INTO public.who_global_data_import VALUES (32674, '2020-10-02', 'GR', 'Greece', 'EURO', '411', '18886', '2', '393');
INSERT INTO public.who_global_data_import VALUES (32675, '2020-10-03', 'GR', 'Greece', 'EURO', '460', '19346', '5', '398');
INSERT INTO public.who_global_data_import VALUES (32676, '2020-10-04', 'GR', 'Greece', 'EURO', '267', '19613', '7', '405');
INSERT INTO public.who_global_data_import VALUES (32677, '2020-10-05', 'GR', 'Greece', 'EURO', '229', '19842', '4', '409');
INSERT INTO public.who_global_data_import VALUES (32678, '2020-10-06', 'GR', 'Greece', 'EURO', '300', '20142', '8', '417');
INSERT INTO public.who_global_data_import VALUES (32679, '2020-10-07', 'GR', 'Greece', 'EURO', '399', '20541', '3', '420');
INSERT INTO public.who_global_data_import VALUES (32680, '2020-10-08', 'GR', 'Greece', 'EURO', '406', '20947', '4', '424');
INSERT INTO public.who_global_data_import VALUES (32681, '2020-10-09', 'GR', 'Greece', 'EURO', '434', '21381', '6', '430');
INSERT INTO public.who_global_data_import VALUES (32682, '2020-10-10', 'GR', 'Greece', 'EURO', '391', '21772', '1', '431');
INSERT INTO public.who_global_data_import VALUES (32683, '2020-10-11', 'GR', 'Greece', 'EURO', '306', '22078', '5', '436');
INSERT INTO public.who_global_data_import VALUES (32684, '2020-10-12', 'GR', 'Greece', 'EURO', '280', '22358', '13', '449');
INSERT INTO public.who_global_data_import VALUES (32685, '2020-10-13', 'GR', 'Greece', 'EURO', '294', '22652', '7', '456');
INSERT INTO public.who_global_data_import VALUES (32686, '2020-10-14', 'GR', 'Greece', 'EURO', '408', '23060', '6', '462');
INSERT INTO public.who_global_data_import VALUES (32687, '2020-10-15', 'GR', 'Greece', 'EURO', '435', '23495', '7', '469');
INSERT INTO public.who_global_data_import VALUES (32688, '2020-10-16', 'GR', 'Greece', 'EURO', '452', '23947', '13', '482');
INSERT INTO public.who_global_data_import VALUES (32689, '2020-10-17', 'GR', 'Greece', 'EURO', '503', '24450', '8', '490');
INSERT INTO public.who_global_data_import VALUES (32690, '2020-10-18', 'GR', 'Greece', 'EURO', '482', '24932', '10', '500');
INSERT INTO public.who_global_data_import VALUES (32691, '2020-10-19', 'GR', 'Greece', 'EURO', '438', '25370', '9', '509');
INSERT INTO public.who_global_data_import VALUES (32692, '2020-10-20', 'GR', 'Greece', 'EURO', '432', '25802', '11', '520');
INSERT INTO public.who_global_data_import VALUES (32693, '2020-10-21', 'GR', 'Greece', 'EURO', '667', '26469', '8', '528');
INSERT INTO public.who_global_data_import VALUES (32694, '2020-10-22', 'GR', 'Greece', 'EURO', '865', '27334', '6', '534');
INSERT INTO public.who_global_data_import VALUES (32695, '2020-10-23', 'GR', 'Greece', 'EURO', '882', '28216', '15', '549');
INSERT INTO public.who_global_data_import VALUES (32696, '2020-10-24', 'GR', 'Greece', 'EURO', '841', '29057', '10', '559');
INSERT INTO public.who_global_data_import VALUES (32697, '2020-10-25', 'GR', 'Greece', 'EURO', '935', '29992', '5', '564');
INSERT INTO public.who_global_data_import VALUES (32698, '2020-10-26', 'GR', 'Greece', 'EURO', '790', '30782', '10', '574');
INSERT INTO public.who_global_data_import VALUES (32699, '2020-10-27', 'GR', 'Greece', 'EURO', '714', '31496', '7', '581');
INSERT INTO public.who_global_data_import VALUES (32700, '2020-10-28', 'GR', 'Greece', 'EURO', '1256', '32752', '12', '593');
INSERT INTO public.who_global_data_import VALUES (32701, '2020-10-29', 'GR', 'Greece', 'EURO', '1547', '34299', '10', '603');
INSERT INTO public.who_global_data_import VALUES (32702, '2020-10-30', 'GR', 'Greece', 'EURO', '1211', '35510', '12', '615');
INSERT INTO public.who_global_data_import VALUES (32703, '2020-10-31', 'GR', 'Greece', 'EURO', '1686', '37196', '5', '620');
INSERT INTO public.who_global_data_import VALUES (32704, '2020-11-01', 'GR', 'Greece', 'EURO', '2055', '39251', '6', '626');
INSERT INTO public.who_global_data_import VALUES (32705, '2020-11-02', 'GR', 'Greece', 'EURO', '1678', '40929', '9', '635');
INSERT INTO public.who_global_data_import VALUES (32706, '2020-11-03', 'GR', 'Greece', 'EURO', '1151', '42080', '7', '642');
INSERT INTO public.who_global_data_import VALUES (32707, '2020-11-04', 'GR', 'Greece', 'EURO', '2166', '44246', '13', '655');
INSERT INTO public.who_global_data_import VALUES (32708, '2020-11-05', 'GR', 'Greece', 'EURO', '2646', '46892', '18', '673');
INSERT INTO public.who_global_data_import VALUES (32709, '2020-11-06', 'GR', 'Greece', 'EURO', '2915', '49807', '29', '702');
INSERT INTO public.who_global_data_import VALUES (32710, '2020-11-07', 'GR', 'Greece', 'EURO', '2447', '52254', '13', '715');
INSERT INTO public.who_global_data_import VALUES (32711, '2020-11-08', 'GR', 'Greece', 'EURO', '2555', '54809', '34', '749');
INSERT INTO public.who_global_data_import VALUES (32712, '2020-11-09', 'GR', 'Greece', 'EURO', '1889', '56698', '35', '784');
INSERT INTO public.who_global_data_import VALUES (32713, '2020-11-10', 'GR', 'Greece', 'EURO', '1489', '58187', '41', '825');
INSERT INTO public.who_global_data_import VALUES (32714, '2020-11-11', 'GR', 'Greece', 'EURO', '2383', '60570', '41', '866');
INSERT INTO public.who_global_data_import VALUES (32715, '2020-11-12', 'GR', 'Greece', 'EURO', '2751', '63321', '43', '909');
INSERT INTO public.who_global_data_import VALUES (32716, '2020-11-13', 'GR', 'Greece', 'EURO', '3316', '66637', '50', '959');
INSERT INTO public.who_global_data_import VALUES (32717, '2020-11-14', 'GR', 'Greece', 'EURO', '3038', '69675', '38', '997');
INSERT INTO public.who_global_data_import VALUES (32718, '2020-11-15', 'GR', 'Greece', 'EURO', '2835', '72510', '38', '1035');
INSERT INTO public.who_global_data_import VALUES (32719, '2020-11-16', 'GR', 'Greece', 'EURO', '1695', '74205', '71', '1106');
INSERT INTO public.who_global_data_import VALUES (32720, '2020-11-17', 'GR', 'Greece', 'EURO', '2198', '76403', '59', '1165');
INSERT INTO public.who_global_data_import VALUES (32721, '2020-11-18', 'GR', 'Greece', 'EURO', '2422', '78825', '63', '1228');
INSERT INTO public.who_global_data_import VALUES (32722, '2020-11-19', 'GR', 'Greece', 'EURO', '3209', '82034', '60', '1288');
INSERT INTO public.who_global_data_import VALUES (32723, '2020-11-20', 'GR', 'Greece', 'EURO', '3227', '85261', '59', '1347');
INSERT INTO public.who_global_data_import VALUES (32724, '2020-11-21', 'GR', 'Greece', 'EURO', '2551', '87812', '72', '1419');
INSERT INTO public.who_global_data_import VALUES (32725, '2020-11-22', 'GR', 'Greece', 'EURO', '2309', '90121', '108', '1527');
INSERT INTO public.who_global_data_import VALUES (32726, '2020-11-23', 'GR', 'Greece', 'EURO', '1498', '91619', '103', '1630');
INSERT INTO public.who_global_data_import VALUES (32727, '2020-11-24', 'GR', 'Greece', 'EURO', '1387', '93006', '84', '1714');
INSERT INTO public.who_global_data_import VALUES (32728, '2020-11-25', 'GR', 'Greece', 'EURO', '2131', '95137', '101', '1815');
INSERT INTO public.who_global_data_import VALUES (32729, '2020-11-26', 'GR', 'Greece', 'EURO', '2151', '97288', '87', '1902');
INSERT INTO public.who_global_data_import VALUES (32730, '2020-11-27', 'GR', 'Greece', 'EURO', '2018', '99306', '99', '2001');
INSERT INTO public.who_global_data_import VALUES (32731, '2020-11-28', 'GR', 'Greece', 'EURO', '1981', '101287', '101', '2102');
INSERT INTO public.who_global_data_import VALUES (32732, '2020-11-29', 'GR', 'Greece', 'EURO', '1747', '103034', '121', '2223');
INSERT INTO public.who_global_data_import VALUES (32733, '2020-11-30', 'GR', 'Greece', 'EURO', '1193', '104227', '98', '2321');
INSERT INTO public.who_global_data_import VALUES (32734, '2020-12-01', 'GR', 'Greece', 'EURO', '1044', '105271', '85', '2406');
INSERT INTO public.who_global_data_import VALUES (32735, '2020-12-02', 'GR', 'Greece', 'EURO', '2199', '107470', '111', '2517');
INSERT INTO public.who_global_data_import VALUES (32736, '2020-12-03', 'GR', 'Greece', 'EURO', '2185', '109655', '89', '2606');
INSERT INTO public.who_global_data_import VALUES (32737, '2020-12-04', 'GR', 'Greece', 'EURO', '1882', '111537', '100', '2706');
INSERT INTO public.who_global_data_import VALUES (32738, '2020-12-05', 'GR', 'Greece', 'EURO', '1648', '113185', '98', '2804');
INSERT INTO public.who_global_data_import VALUES (32739, '2020-12-06', 'GR', 'Greece', 'EURO', '1383', '114568', '98', '2902');
INSERT INTO public.who_global_data_import VALUES (32740, '2020-12-07', 'GR', 'Greece', 'EURO', '903', '115471', '101', '3003');
INSERT INTO public.who_global_data_import VALUES (32741, '2020-12-08', 'GR', 'Greece', 'EURO', '1250', '116721', '89', '3092');
INSERT INTO public.who_global_data_import VALUES (32742, '2020-12-09', 'GR', 'Greece', 'EURO', '1324', '118045', '102', '3194');
INSERT INTO public.who_global_data_import VALUES (32743, '2020-12-10', 'GR', 'Greece', 'EURO', '1675', '119720', '95', '3289');
INSERT INTO public.who_global_data_import VALUES (32744, '2020-12-11', 'GR', 'Greece', 'EURO', '1533', '121253', '81', '3370');
INSERT INTO public.who_global_data_import VALUES (32745, '2020-12-12', 'GR', 'Greece', 'EURO', '1395', '122648', '102', '3472');
INSERT INTO public.who_global_data_import VALUES (32746, '2020-12-13', 'GR', 'Greece', 'EURO', '1194', '123842', '68', '3540');
INSERT INTO public.who_global_data_import VALUES (32747, '2020-12-14', 'GR', 'Greece', 'EURO', '692', '124534', '85', '3625');
INSERT INTO public.who_global_data_import VALUES (32748, '2020-12-15', 'GR', 'Greece', 'EURO', '639', '125173', '62', '3687');
INSERT INTO public.who_global_data_import VALUES (32749, '2020-12-16', 'GR', 'Greece', 'EURO', '1199', '126372', '98', '3785');
INSERT INTO public.who_global_data_import VALUES (32750, '2020-12-17', 'GR', 'Greece', 'EURO', '1185', '127557', '85', '3870');
INSERT INTO public.who_global_data_import VALUES (32751, '2020-12-18', 'GR', 'Greece', 'EURO', '1153', '128710', '78', '3948');
INSERT INTO public.who_global_data_import VALUES (32752, '2020-12-19', 'GR', 'Greece', 'EURO', '874', '129584', '96', '4044');
INSERT INTO public.who_global_data_import VALUES (32753, '2020-12-20', 'GR', 'Greece', 'EURO', '901', '130485', '58', '4102');
INSERT INTO public.who_global_data_import VALUES (32754, '2020-12-21', 'GR', 'Greece', 'EURO', '587', '131072', '70', '4172');
INSERT INTO public.who_global_data_import VALUES (32755, '2020-12-22', 'GR', 'Greece', 'EURO', '525', '131597', '85', '4257');
INSERT INTO public.who_global_data_import VALUES (32756, '2020-12-23', 'GR', 'Greece', 'EURO', '833', '132430', '83', '4340');
INSERT INTO public.who_global_data_import VALUES (32757, '2020-12-24', 'GR', 'Greece', 'EURO', '935', '133365', '62', '4402');
INSERT INTO public.who_global_data_import VALUES (32758, '2020-12-25', 'GR', 'Greece', 'EURO', '870', '134235', '55', '4457');
INSERT INTO public.who_global_data_import VALUES (32759, '2020-12-26', 'GR', 'Greece', 'EURO', '617', '134852', '50', '4507');
INSERT INTO public.who_global_data_import VALUES (32760, '2020-12-27', 'GR', 'Greece', 'EURO', '262', '135114', '46', '4553');
INSERT INTO public.who_global_data_import VALUES (32761, '2020-12-28', 'GR', 'Greece', 'EURO', '342', '135456', '53', '4606');
INSERT INTO public.who_global_data_import VALUES (32762, '2020-12-29', 'GR', 'Greece', 'EURO', '475', '135931', '66', '4672');
INSERT INTO public.who_global_data_import VALUES (32763, '2020-12-30', 'GR', 'Greece', 'EURO', '1045', '136976', '58', '4730');
INSERT INTO public.who_global_data_import VALUES (32764, '2020-12-31', 'GR', 'Greece', 'EURO', '942', '137918', '58', '4788');
INSERT INTO public.who_global_data_import VALUES (32765, '2021-01-01', 'GR', 'Greece', 'EURO', '932', '138850', '50', '4838');
INSERT INTO public.who_global_data_import VALUES (32766, '2021-01-02', 'GR', 'Greece', 'EURO', '597', '139447', '43', '4881');
INSERT INTO public.who_global_data_import VALUES (32767, '2021-01-03', 'GR', 'Greece', 'EURO', '262', '139709', '40', '4921');
INSERT INTO public.who_global_data_import VALUES (32768, '2021-01-04', 'GR', 'Greece', 'EURO', '390', '140099', '36', '4957');
INSERT INTO public.who_global_data_import VALUES (32769, '2021-01-05', 'GR', 'Greece', 'EURO', '427', '140526', '54', '5011');
INSERT INTO public.who_global_data_import VALUES (32770, '2021-01-06', 'GR', 'Greece', 'EURO', '927', '141453', '40', '5051');
INSERT INTO public.who_global_data_import VALUES (32771, '2021-01-07', 'GR', 'Greece', 'EURO', '814', '142267', '48', '5099');
INSERT INTO public.who_global_data_import VALUES (32772, '2021-01-08', 'GR', 'Greece', 'EURO', '510', '142777', '47', '5146');
INSERT INTO public.who_global_data_import VALUES (32773, '2021-01-09', 'GR', 'Greece', 'EURO', '717', '143494', '49', '5195');
INSERT INTO public.who_global_data_import VALUES (32774, '2021-01-10', 'GR', 'Greece', 'EURO', '799', '144293', '32', '5227');
INSERT INTO public.who_global_data_import VALUES (32775, '2021-01-11', 'GR', 'Greece', 'EURO', '445', '144738', '36', '5263');
INSERT INTO public.who_global_data_import VALUES (32776, '2021-01-12', 'GR', 'Greece', 'EURO', '441', '145179', '39', '5302');
INSERT INTO public.who_global_data_import VALUES (32777, '2021-01-13', 'GR', 'Greece', 'EURO', '841', '146020', '27', '5329');
INSERT INTO public.who_global_data_import VALUES (32778, '2021-01-14', 'GR', 'Greece', 'EURO', '668', '146688', '25', '5354');
INSERT INTO public.who_global_data_import VALUES (32779, '2021-01-15', 'GR', 'Greece', 'EURO', '595', '147283', '33', '5387');
INSERT INTO public.who_global_data_import VALUES (32780, '2021-01-16', 'GR', 'Greece', 'EURO', '577', '147860', '34', '5421');
INSERT INTO public.who_global_data_import VALUES (32781, '2021-01-17', 'GR', 'Greece', 'EURO', '510', '148370', '20', '5441');
INSERT INTO public.who_global_data_import VALUES (32782, '2021-01-18', 'GR', 'Greece', 'EURO', '237', '148607', '28', '5469');
INSERT INTO public.who_global_data_import VALUES (32783, '2021-01-19', 'GR', 'Greece', 'EURO', '318', '148925', '19', '5488');
INSERT INTO public.who_global_data_import VALUES (32784, '2021-01-20', 'GR', 'Greece', 'EURO', '537', '149462', '30', '5518');
INSERT INTO public.who_global_data_import VALUES (32785, '2021-01-21', 'GR', 'Greece', 'EURO', '511', '149973', '27', '5545');
INSERT INTO public.who_global_data_import VALUES (32786, '2021-01-22', 'GR', 'Greece', 'EURO', '506', '150479', '25', '5570');
INSERT INTO public.who_global_data_import VALUES (32787, '2021-01-23', 'GR', 'Greece', 'EURO', '562', '151041', '28', '5598');
INSERT INTO public.who_global_data_import VALUES (32788, '2021-01-24', 'GR', 'Greece', 'EURO', '605', '151646', '24', '5622');
INSERT INTO public.who_global_data_import VALUES (32789, '2021-01-25', 'GR', 'Greece', 'EURO', '334', '151980', '24', '5646');
INSERT INTO public.who_global_data_import VALUES (32790, '2021-01-26', 'GR', 'Greece', 'EURO', '432', '152412', '25', '5671');
INSERT INTO public.who_global_data_import VALUES (32791, '2021-01-27', 'GR', 'Greece', 'EURO', '814', '153226', '21', '5692');
INSERT INTO public.who_global_data_import VALUES (32792, '2021-01-28', 'GR', 'Greece', 'EURO', '857', '154083', '32', '5724');
INSERT INTO public.who_global_data_import VALUES (32793, '2021-01-29', 'GR', 'Greece', 'EURO', '713', '154796', '18', '5742');
INSERT INTO public.who_global_data_import VALUES (32794, '2021-01-30', 'GR', 'Greece', 'EURO', '882', '155678', '22', '5764');
INSERT INTO public.who_global_data_import VALUES (32795, '2021-01-31', 'GR', 'Greece', 'EURO', '795', '156473', '15', '5779');
INSERT INTO public.who_global_data_import VALUES (32796, '2021-02-01', 'GR', 'Greece', 'EURO', '484', '156957', '17', '5796');
INSERT INTO public.who_global_data_import VALUES (32797, '2021-02-02', 'GR', 'Greece', 'EURO', '538', '157495', '33', '5829');
INSERT INTO public.who_global_data_import VALUES (32798, '2021-02-03', 'GR', 'Greece', 'EURO', '1221', '158716', '22', '5851');
INSERT INTO public.who_global_data_import VALUES (32799, '2021-02-04', 'GR', 'Greece', 'EURO', '1150', '159866', '27', '5878');
INSERT INTO public.who_global_data_import VALUES (32800, '2021-02-05', 'GR', 'Greece', 'EURO', '1069', '160935', '25', '5903');
INSERT INTO public.who_global_data_import VALUES (32801, '2020-01-03', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32802, '2020-01-04', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32803, '2020-01-05', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32804, '2020-01-06', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32805, '2020-01-07', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32806, '2020-01-08', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32807, '2020-01-09', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32808, '2020-01-10', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32809, '2020-01-11', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32810, '2020-01-12', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32811, '2020-01-13', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32812, '2020-01-14', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32813, '2020-01-15', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32814, '2020-01-16', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32815, '2020-01-17', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32816, '2020-01-18', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32817, '2020-01-19', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32818, '2020-01-20', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32819, '2020-01-21', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32820, '2020-01-22', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32821, '2020-01-23', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32822, '2020-01-24', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32823, '2020-01-25', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32824, '2020-01-26', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32825, '2020-01-27', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32826, '2020-01-28', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32827, '2020-01-29', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32828, '2020-01-30', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32829, '2020-01-31', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32830, '2020-02-01', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32831, '2020-02-02', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32832, '2020-02-03', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32833, '2020-02-04', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32834, '2020-02-05', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32835, '2020-02-06', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32836, '2020-02-07', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32837, '2020-02-08', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32838, '2020-02-09', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32839, '2020-02-10', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32840, '2020-02-11', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32841, '2020-02-12', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32842, '2020-02-13', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32843, '2020-02-14', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32844, '2020-02-15', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32845, '2020-02-16', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32846, '2020-02-17', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32847, '2020-02-18', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32848, '2020-02-19', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32849, '2020-02-20', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32850, '2020-02-21', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32851, '2020-02-22', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32852, '2020-02-23', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32853, '2020-02-24', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32854, '2020-02-25', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32855, '2020-02-26', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32856, '2020-02-27', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32857, '2020-02-28', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32858, '2020-02-29', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32859, '2020-03-01', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32860, '2020-03-02', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32861, '2020-03-03', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32862, '2020-03-04', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32863, '2020-03-05', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32864, '2020-03-06', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32865, '2020-03-07', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32866, '2020-03-08', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32867, '2020-03-09', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32868, '2020-03-10', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32869, '2020-03-11', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32870, '2020-03-12', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32871, '2020-03-13', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32872, '2020-03-14', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32873, '2020-03-15', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32874, '2020-03-16', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32875, '2020-03-17', 'GL', 'Greenland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32876, '2020-03-18', 'GL', 'Greenland', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32877, '2020-03-19', 'GL', 'Greenland', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32878, '2020-03-20', 'GL', 'Greenland', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32879, '2020-03-21', 'GL', 'Greenland', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32880, '2020-03-22', 'GL', 'Greenland', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33202, '2020-01-04', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32881, '2020-03-23', 'GL', 'Greenland', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32882, '2020-03-24', 'GL', 'Greenland', 'EURO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32883, '2020-03-25', 'GL', 'Greenland', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32884, '2020-03-26', 'GL', 'Greenland', 'EURO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32885, '2020-03-27', 'GL', 'Greenland', 'EURO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32886, '2020-03-28', 'GL', 'Greenland', 'EURO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32887, '2020-03-29', 'GL', 'Greenland', 'EURO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32888, '2020-03-30', 'GL', 'Greenland', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32889, '2020-03-31', 'GL', 'Greenland', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32890, '2020-04-01', 'GL', 'Greenland', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32891, '2020-04-02', 'GL', 'Greenland', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32892, '2020-04-03', 'GL', 'Greenland', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32893, '2020-04-04', 'GL', 'Greenland', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32894, '2020-04-05', 'GL', 'Greenland', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32895, '2020-04-06', 'GL', 'Greenland', 'EURO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32896, '2020-04-07', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32897, '2020-04-08', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32898, '2020-04-09', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32899, '2020-04-10', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32900, '2020-04-11', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32901, '2020-04-12', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32902, '2020-04-13', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32903, '2020-04-14', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32904, '2020-04-15', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32905, '2020-04-16', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32906, '2020-04-17', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32907, '2020-04-18', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32908, '2020-04-19', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32909, '2020-04-20', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32910, '2020-04-21', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32911, '2020-04-22', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32912, '2020-04-23', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32913, '2020-04-24', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32914, '2020-04-25', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32915, '2020-04-26', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32916, '2020-04-27', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32917, '2020-04-28', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32918, '2020-04-29', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32919, '2020-04-30', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32920, '2020-05-01', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32921, '2020-05-02', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32922, '2020-05-03', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32923, '2020-05-04', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32924, '2020-05-05', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32925, '2020-05-06', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32926, '2020-05-07', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32927, '2020-05-08', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32928, '2020-05-09', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32929, '2020-05-10', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32930, '2020-05-11', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32931, '2020-05-12', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32932, '2020-05-13', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32933, '2020-05-14', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32934, '2020-05-15', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32935, '2020-05-16', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32936, '2020-05-17', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32937, '2020-05-18', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32938, '2020-05-19', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32939, '2020-05-20', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32940, '2020-05-21', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32941, '2020-05-22', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32942, '2020-05-23', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32943, '2020-05-24', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32944, '2020-05-25', 'GL', 'Greenland', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32945, '2020-05-26', 'GL', 'Greenland', 'EURO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32946, '2020-05-27', 'GL', 'Greenland', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32947, '2020-05-28', 'GL', 'Greenland', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32948, '2020-05-29', 'GL', 'Greenland', 'EURO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32949, '2020-05-30', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32950, '2020-05-31', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32951, '2020-06-01', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32952, '2020-06-02', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32953, '2020-06-03', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32954, '2020-06-04', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32955, '2020-06-05', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32956, '2020-06-06', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32957, '2020-06-07', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32958, '2020-06-08', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32959, '2020-06-09', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32960, '2020-06-10', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32961, '2020-06-11', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32962, '2020-06-12', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32963, '2020-06-13', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32964, '2020-06-14', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32965, '2020-06-15', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32966, '2020-06-16', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32967, '2020-06-17', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32968, '2020-06-18', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32969, '2020-06-19', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32970, '2020-06-20', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32971, '2020-06-21', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32972, '2020-06-22', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32973, '2020-06-23', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32974, '2020-06-24', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32975, '2020-06-25', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32976, '2020-06-26', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32977, '2020-06-27', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32978, '2020-06-28', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32979, '2020-06-29', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32980, '2020-06-30', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32981, '2020-07-01', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32982, '2020-07-02', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32983, '2020-07-03', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32984, '2020-07-04', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32985, '2020-07-05', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32986, '2020-07-06', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32987, '2020-07-07', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32988, '2020-07-08', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32989, '2020-07-09', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32990, '2020-07-10', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32991, '2020-07-11', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32992, '2020-07-12', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32993, '2020-07-13', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32994, '2020-07-14', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32995, '2020-07-15', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32996, '2020-07-16', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32997, '2020-07-17', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32998, '2020-07-18', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (32999, '2020-07-19', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33000, '2020-07-20', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33001, '2020-07-21', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33002, '2020-07-22', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33003, '2020-07-23', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33004, '2020-07-24', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33005, '2020-07-25', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33006, '2020-07-26', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33007, '2020-07-27', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33008, '2020-07-28', 'GL', 'Greenland', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33009, '2020-07-29', 'GL', 'Greenland', 'EURO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33010, '2020-07-30', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33011, '2020-07-31', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33012, '2020-08-01', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33013, '2020-08-02', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33014, '2020-08-03', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33015, '2020-08-04', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33016, '2020-08-05', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33017, '2020-08-06', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33018, '2020-08-07', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33019, '2020-08-08', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33020, '2020-08-09', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33021, '2020-08-10', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33022, '2020-08-11', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33023, '2020-08-12', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33024, '2020-08-13', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33025, '2020-08-14', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33026, '2020-08-15', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33027, '2020-08-16', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33028, '2020-08-17', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33029, '2020-08-18', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33030, '2020-08-19', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33031, '2020-08-20', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33032, '2020-08-21', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33033, '2020-08-22', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33034, '2020-08-23', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33035, '2020-08-24', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33036, '2020-08-25', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33037, '2020-08-26', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33038, '2020-08-27', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33039, '2020-08-28', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33040, '2020-08-29', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33041, '2020-08-30', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33042, '2020-08-31', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33043, '2020-09-01', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33044, '2020-09-02', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33045, '2020-09-03', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33046, '2020-09-04', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33047, '2020-09-05', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33048, '2020-09-06', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33049, '2020-09-07', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33050, '2020-09-08', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33051, '2020-09-09', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33052, '2020-09-10', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33053, '2020-09-11', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33054, '2020-09-12', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33055, '2020-09-13', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33056, '2020-09-14', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33057, '2020-09-15', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33058, '2020-09-16', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33059, '2020-09-17', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33060, '2020-09-18', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33061, '2020-09-19', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33062, '2020-09-20', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33063, '2020-09-21', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33064, '2020-09-22', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33065, '2020-09-23', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33066, '2020-09-24', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33067, '2020-09-25', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33068, '2020-09-26', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33069, '2020-09-27', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33070, '2020-09-28', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33071, '2020-09-29', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33072, '2020-09-30', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33073, '2020-10-01', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33074, '2020-10-02', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33075, '2020-10-03', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33076, '2020-10-04', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33077, '2020-10-05', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33078, '2020-10-06', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33079, '2020-10-07', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33080, '2020-10-08', 'GL', 'Greenland', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33081, '2020-10-09', 'GL', 'Greenland', 'EURO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33082, '2020-10-10', 'GL', 'Greenland', 'EURO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33083, '2020-10-11', 'GL', 'Greenland', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33084, '2020-10-12', 'GL', 'Greenland', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33085, '2020-10-13', 'GL', 'Greenland', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33086, '2020-10-14', 'GL', 'Greenland', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33087, '2020-10-15', 'GL', 'Greenland', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33088, '2020-10-16', 'GL', 'Greenland', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33089, '2020-10-17', 'GL', 'Greenland', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33090, '2020-10-18', 'GL', 'Greenland', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33091, '2020-10-19', 'GL', 'Greenland', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33092, '2020-10-20', 'GL', 'Greenland', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33093, '2020-10-21', 'GL', 'Greenland', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33094, '2020-10-22', 'GL', 'Greenland', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33095, '2020-10-23', 'GL', 'Greenland', 'EURO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33096, '2020-10-24', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33097, '2020-10-25', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33098, '2020-10-26', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33099, '2020-10-27', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33100, '2020-10-28', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33101, '2020-10-29', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33102, '2020-10-30', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33103, '2020-10-31', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33104, '2020-11-01', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33105, '2020-11-02', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33106, '2020-11-03', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33107, '2020-11-04', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33108, '2020-11-05', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33109, '2020-11-06', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33110, '2020-11-07', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33111, '2020-11-08', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33112, '2020-11-09', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33113, '2020-11-10', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33114, '2020-11-11', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33115, '2020-11-12', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33116, '2020-11-13', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33117, '2020-11-14', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33118, '2020-11-15', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33119, '2020-11-16', 'GL', 'Greenland', 'EURO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33120, '2020-11-17', 'GL', 'Greenland', 'EURO', '1', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33121, '2020-11-18', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33122, '2020-11-19', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33123, '2020-11-20', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33124, '2020-11-21', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33125, '2020-11-22', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33126, '2020-11-23', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33127, '2020-11-24', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33128, '2020-11-25', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33129, '2020-11-26', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33130, '2020-11-27', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33131, '2020-11-28', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33132, '2020-11-29', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33133, '2020-11-30', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33134, '2020-12-01', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33135, '2020-12-02', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33136, '2020-12-03', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33137, '2020-12-04', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33138, '2020-12-05', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33139, '2020-12-06', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33140, '2020-12-07', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33141, '2020-12-08', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33142, '2020-12-09', 'GL', 'Greenland', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33143, '2020-12-10', 'GL', 'Greenland', 'EURO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33144, '2020-12-11', 'GL', 'Greenland', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33145, '2020-12-12', 'GL', 'Greenland', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33146, '2020-12-13', 'GL', 'Greenland', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33147, '2020-12-14', 'GL', 'Greenland', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33148, '2020-12-15', 'GL', 'Greenland', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33149, '2020-12-16', 'GL', 'Greenland', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33150, '2020-12-17', 'GL', 'Greenland', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33151, '2020-12-18', 'GL', 'Greenland', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33152, '2020-12-19', 'GL', 'Greenland', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33153, '2020-12-20', 'GL', 'Greenland', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33154, '2020-12-21', 'GL', 'Greenland', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33155, '2020-12-22', 'GL', 'Greenland', 'EURO', '5', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33156, '2020-12-23', 'GL', 'Greenland', 'EURO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33157, '2020-12-24', 'GL', 'Greenland', 'EURO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33158, '2020-12-25', 'GL', 'Greenland', 'EURO', '2', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33159, '2020-12-26', 'GL', 'Greenland', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33160, '2020-12-27', 'GL', 'Greenland', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33161, '2020-12-28', 'GL', 'Greenland', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33162, '2020-12-29', 'GL', 'Greenland', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33163, '2020-12-30', 'GL', 'Greenland', 'EURO', '1', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33164, '2020-12-31', 'GL', 'Greenland', 'EURO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33165, '2021-01-01', 'GL', 'Greenland', 'EURO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33166, '2021-01-02', 'GL', 'Greenland', 'EURO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33167, '2021-01-03', 'GL', 'Greenland', 'EURO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33168, '2021-01-04', 'GL', 'Greenland', 'EURO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33169, '2021-01-05', 'GL', 'Greenland', 'EURO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33170, '2021-01-06', 'GL', 'Greenland', 'EURO', '1', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33171, '2021-01-07', 'GL', 'Greenland', 'EURO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33172, '2021-01-08', 'GL', 'Greenland', 'EURO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33173, '2021-01-09', 'GL', 'Greenland', 'EURO', '1', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33174, '2021-01-10', 'GL', 'Greenland', 'EURO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33175, '2021-01-11', 'GL', 'Greenland', 'EURO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33176, '2021-01-12', 'GL', 'Greenland', 'EURO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33177, '2021-01-13', 'GL', 'Greenland', 'EURO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33178, '2021-01-14', 'GL', 'Greenland', 'EURO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33179, '2021-01-15', 'GL', 'Greenland', 'EURO', '1', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33180, '2021-01-16', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33181, '2021-01-17', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33182, '2021-01-18', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33183, '2021-01-19', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33184, '2021-01-20', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33185, '2021-01-21', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33186, '2021-01-22', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33187, '2021-01-23', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33188, '2021-01-24', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33189, '2021-01-25', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33190, '2021-01-26', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33191, '2021-01-27', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33192, '2021-01-28', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33193, '2021-01-29', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33194, '2021-01-30', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33195, '2021-01-31', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33196, '2021-02-01', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33197, '2021-02-02', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33198, '2021-02-03', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33199, '2021-02-04', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33200, '2021-02-05', 'GL', 'Greenland', 'EURO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33201, '2020-01-03', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33203, '2020-01-05', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33204, '2020-01-06', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33205, '2020-01-07', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33206, '2020-01-08', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33207, '2020-01-09', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33208, '2020-01-10', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33209, '2020-01-11', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33210, '2020-01-12', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33211, '2020-01-13', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33212, '2020-01-14', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33213, '2020-01-15', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33214, '2020-01-16', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33215, '2020-01-17', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33216, '2020-01-18', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33217, '2020-01-19', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33218, '2020-01-20', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33219, '2020-01-21', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33220, '2020-01-22', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33221, '2020-01-23', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33222, '2020-01-24', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33223, '2020-01-25', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33224, '2020-01-26', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33225, '2020-01-27', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33226, '2020-01-28', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33227, '2020-01-29', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33228, '2020-01-30', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33229, '2020-01-31', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33230, '2020-02-01', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33231, '2020-02-02', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33232, '2020-02-03', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33233, '2020-02-04', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33234, '2020-02-05', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33235, '2020-02-06', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33236, '2020-02-07', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33237, '2020-02-08', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33238, '2020-02-09', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33239, '2020-02-10', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33240, '2020-02-11', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33241, '2020-02-12', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33242, '2020-02-13', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33243, '2020-02-14', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33244, '2020-02-15', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33245, '2020-02-16', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33246, '2020-02-17', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33247, '2020-02-18', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33248, '2020-02-19', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33249, '2020-02-20', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33250, '2020-02-21', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33251, '2020-02-22', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33252, '2020-02-23', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33253, '2020-02-24', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33254, '2020-02-25', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33255, '2020-02-26', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33256, '2020-02-27', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33257, '2020-02-28', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33258, '2020-02-29', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33259, '2020-03-01', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33260, '2020-03-02', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33261, '2020-03-03', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33262, '2020-03-04', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33263, '2020-03-05', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33264, '2020-03-06', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33265, '2020-03-07', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33266, '2020-03-08', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33267, '2020-03-09', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33268, '2020-03-10', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33269, '2020-03-11', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33270, '2020-03-12', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33271, '2020-03-13', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33272, '2020-03-14', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33273, '2020-03-15', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33274, '2020-03-16', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33275, '2020-03-17', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33276, '2020-03-18', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33277, '2020-03-19', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33278, '2020-03-20', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33279, '2020-03-21', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33280, '2020-03-22', 'GD', 'Grenada', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33281, '2020-03-23', 'GD', 'Grenada', 'AMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33282, '2020-03-24', 'GD', 'Grenada', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33283, '2020-03-25', 'GD', 'Grenada', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33284, '2020-03-26', 'GD', 'Grenada', 'AMRO', '6', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33285, '2020-03-27', 'GD', 'Grenada', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33286, '2020-03-28', 'GD', 'Grenada', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33287, '2020-03-29', 'GD', 'Grenada', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33288, '2020-03-30', 'GD', 'Grenada', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33289, '2020-03-31', 'GD', 'Grenada', 'AMRO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33290, '2020-04-01', 'GD', 'Grenada', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33291, '2020-04-02', 'GD', 'Grenada', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33292, '2020-04-03', 'GD', 'Grenada', 'AMRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33293, '2020-04-04', 'GD', 'Grenada', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33294, '2020-04-05', 'GD', 'Grenada', 'AMRO', '2', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33295, '2020-04-06', 'GD', 'Grenada', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33296, '2020-04-07', 'GD', 'Grenada', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33297, '2020-04-08', 'GD', 'Grenada', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33298, '2020-04-09', 'GD', 'Grenada', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33299, '2020-04-10', 'GD', 'Grenada', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33300, '2020-04-11', 'GD', 'Grenada', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33301, '2020-04-12', 'GD', 'Grenada', 'AMRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33302, '2020-04-13', 'GD', 'Grenada', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33303, '2020-04-14', 'GD', 'Grenada', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33304, '2020-04-15', 'GD', 'Grenada', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33305, '2020-04-16', 'GD', 'Grenada', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33306, '2020-04-17', 'GD', 'Grenada', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33307, '2020-04-18', 'GD', 'Grenada', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33308, '2020-04-19', 'GD', 'Grenada', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33309, '2020-04-20', 'GD', 'Grenada', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33310, '2020-04-21', 'GD', 'Grenada', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33311, '2020-04-22', 'GD', 'Grenada', 'AMRO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33312, '2020-04-23', 'GD', 'Grenada', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33313, '2020-04-24', 'GD', 'Grenada', 'AMRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33314, '2020-04-25', 'GD', 'Grenada', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33315, '2020-04-26', 'GD', 'Grenada', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33316, '2020-04-27', 'GD', 'Grenada', 'AMRO', '3', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33317, '2020-04-28', 'GD', 'Grenada', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33318, '2020-04-29', 'GD', 'Grenada', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33319, '2020-04-30', 'GD', 'Grenada', 'AMRO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33320, '2020-05-01', 'GD', 'Grenada', 'AMRO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33321, '2020-05-02', 'GD', 'Grenada', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33322, '2020-05-03', 'GD', 'Grenada', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33323, '2020-05-04', 'GD', 'Grenada', 'AMRO', '1', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33324, '2020-05-05', 'GD', 'Grenada', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33325, '2020-05-06', 'GD', 'Grenada', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33326, '2020-05-07', 'GD', 'Grenada', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33327, '2020-05-08', 'GD', 'Grenada', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33328, '2020-05-09', 'GD', 'Grenada', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33329, '2020-05-10', 'GD', 'Grenada', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33330, '2020-05-11', 'GD', 'Grenada', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33331, '2020-05-12', 'GD', 'Grenada', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33332, '2020-05-13', 'GD', 'Grenada', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33333, '2020-05-14', 'GD', 'Grenada', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33334, '2020-05-15', 'GD', 'Grenada', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33335, '2020-05-16', 'GD', 'Grenada', 'AMRO', '1', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33336, '2020-05-17', 'GD', 'Grenada', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33337, '2020-05-18', 'GD', 'Grenada', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33338, '2020-05-19', 'GD', 'Grenada', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33339, '2020-05-20', 'GD', 'Grenada', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33340, '2020-05-21', 'GD', 'Grenada', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33341, '2020-05-22', 'GD', 'Grenada', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33342, '2020-05-23', 'GD', 'Grenada', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33343, '2020-05-24', 'GD', 'Grenada', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33344, '2020-05-25', 'GD', 'Grenada', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33345, '2020-05-26', 'GD', 'Grenada', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33346, '2020-05-27', 'GD', 'Grenada', 'AMRO', '1', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33347, '2020-05-28', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33348, '2020-05-29', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33349, '2020-05-30', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33350, '2020-05-31', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33351, '2020-06-01', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33352, '2020-06-02', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33353, '2020-06-03', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33354, '2020-06-04', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33355, '2020-06-05', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33356, '2020-06-06', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33357, '2020-06-07', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33358, '2020-06-08', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33359, '2020-06-09', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33360, '2020-06-10', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33361, '2020-06-11', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33362, '2020-06-12', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33363, '2020-06-13', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33364, '2020-06-14', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33365, '2020-06-15', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33366, '2020-06-16', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33367, '2020-06-17', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33368, '2020-06-18', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33369, '2020-06-19', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33370, '2020-06-20', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33371, '2020-06-21', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33372, '2020-06-22', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33373, '2020-06-23', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33374, '2020-06-24', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33375, '2020-06-25', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33376, '2020-06-26', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33377, '2020-06-27', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33378, '2020-06-28', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33379, '2020-06-29', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33380, '2020-06-30', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33381, '2020-07-01', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33382, '2020-07-02', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33383, '2020-07-03', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33384, '2020-07-04', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33385, '2020-07-05', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33386, '2020-07-06', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33387, '2020-07-07', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33388, '2020-07-08', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33389, '2020-07-09', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33390, '2020-07-10', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33391, '2020-07-11', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33392, '2020-07-12', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33393, '2020-07-13', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33394, '2020-07-14', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33395, '2020-07-15', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33396, '2020-07-16', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33397, '2020-07-17', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33398, '2020-07-18', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33399, '2020-07-19', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33400, '2020-07-20', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33401, '2020-07-21', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33402, '2020-07-22', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33403, '2020-07-23', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33404, '2020-07-24', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33405, '2020-07-25', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33406, '2020-07-26', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33407, '2020-07-27', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33408, '2020-07-28', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33409, '2020-07-29', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33410, '2020-07-30', 'GD', 'Grenada', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33411, '2020-07-31', 'GD', 'Grenada', 'AMRO', '1', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33412, '2020-08-01', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33413, '2020-08-02', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33414, '2020-08-03', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33415, '2020-08-04', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33416, '2020-08-05', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33417, '2020-08-06', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33418, '2020-08-07', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33419, '2020-08-08', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33420, '2020-08-09', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33421, '2020-08-10', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33422, '2020-08-11', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33423, '2020-08-12', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33424, '2020-08-13', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33425, '2020-08-14', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33426, '2020-08-15', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33427, '2020-08-16', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33428, '2020-08-17', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33429, '2020-08-18', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33430, '2020-08-19', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33431, '2020-08-20', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33432, '2020-08-21', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33433, '2020-08-22', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33434, '2020-08-23', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33435, '2020-08-24', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33436, '2020-08-25', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33437, '2020-08-26', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33438, '2020-08-27', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33439, '2020-08-28', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33440, '2020-08-29', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33441, '2020-08-30', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33442, '2020-08-31', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33443, '2020-09-01', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33444, '2020-09-02', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33445, '2020-09-03', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33446, '2020-09-04', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33447, '2020-09-05', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33448, '2020-09-06', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33449, '2020-09-07', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33450, '2020-09-08', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33451, '2020-09-09', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33452, '2020-09-10', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33453, '2020-09-11', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33454, '2020-09-12', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33455, '2020-09-13', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33456, '2020-09-14', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33457, '2020-09-15', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33458, '2020-09-16', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33459, '2020-09-17', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33460, '2020-09-18', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33461, '2020-09-19', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33462, '2020-09-20', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33463, '2020-09-21', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33464, '2020-09-22', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33465, '2020-09-23', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33466, '2020-09-24', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33467, '2020-09-25', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33468, '2020-09-26', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33469, '2020-09-27', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33470, '2020-09-28', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33471, '2020-09-29', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33472, '2020-09-30', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33473, '2020-10-01', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33474, '2020-10-02', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33475, '2020-10-03', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33476, '2020-10-04', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33477, '2020-10-05', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33478, '2020-10-06', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33479, '2020-10-07', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33480, '2020-10-08', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33481, '2020-10-09', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33482, '2020-10-10', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33483, '2020-10-11', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33484, '2020-10-12', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33485, '2020-10-13', 'GD', 'Grenada', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33486, '2020-10-14', 'GD', 'Grenada', 'AMRO', '1', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33487, '2020-10-15', 'GD', 'Grenada', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33488, '2020-10-16', 'GD', 'Grenada', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33489, '2020-10-17', 'GD', 'Grenada', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33490, '2020-10-18', 'GD', 'Grenada', 'AMRO', '2', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33491, '2020-10-19', 'GD', 'Grenada', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33492, '2020-10-20', 'GD', 'Grenada', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33493, '2020-10-21', 'GD', 'Grenada', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33494, '2020-10-22', 'GD', 'Grenada', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33495, '2020-10-23', 'GD', 'Grenada', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33496, '2020-10-24', 'GD', 'Grenada', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33497, '2020-10-25', 'GD', 'Grenada', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33498, '2020-10-26', 'GD', 'Grenada', 'AMRO', '1', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33499, '2020-10-27', 'GD', 'Grenada', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33500, '2020-10-28', 'GD', 'Grenada', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33501, '2020-10-29', 'GD', 'Grenada', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33502, '2020-10-30', 'GD', 'Grenada', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33503, '2020-10-31', 'GD', 'Grenada', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33504, '2020-11-01', 'GD', 'Grenada', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33505, '2020-11-02', 'GD', 'Grenada', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33506, '2020-11-03', 'GD', 'Grenada', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33507, '2020-11-04', 'GD', 'Grenada', 'AMRO', '1', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33508, '2020-11-05', 'GD', 'Grenada', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33509, '2020-11-06', 'GD', 'Grenada', 'AMRO', '1', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33510, '2020-11-07', 'GD', 'Grenada', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33511, '2020-11-08', 'GD', 'Grenada', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33512, '2020-11-09', 'GD', 'Grenada', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33513, '2020-11-10', 'GD', 'Grenada', 'AMRO', '2', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33514, '2020-11-11', 'GD', 'Grenada', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33515, '2020-11-12', 'GD', 'Grenada', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33516, '2020-11-13', 'GD', 'Grenada', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33517, '2020-11-14', 'GD', 'Grenada', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33518, '2020-11-15', 'GD', 'Grenada', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33519, '2020-11-16', 'GD', 'Grenada', 'AMRO', '1', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33520, '2020-11-17', 'GD', 'Grenada', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33521, '2020-11-18', 'GD', 'Grenada', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33522, '2020-11-19', 'GD', 'Grenada', 'AMRO', '3', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33523, '2020-11-20', 'GD', 'Grenada', 'AMRO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33524, '2020-11-21', 'GD', 'Grenada', 'AMRO', '5', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33525, '2020-11-22', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33526, '2020-11-23', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33527, '2020-11-24', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33528, '2020-11-25', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33529, '2020-11-26', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33530, '2020-11-27', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33531, '2020-11-28', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33532, '2020-11-29', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33533, '2020-11-30', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33534, '2020-12-01', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33535, '2020-12-02', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33536, '2020-12-03', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33537, '2020-12-04', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33538, '2020-12-05', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33539, '2020-12-06', 'GD', 'Grenada', 'AMRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33540, '2020-12-07', 'GD', 'Grenada', 'AMRO', '2', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33541, '2020-12-08', 'GD', 'Grenada', 'AMRO', '0', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33542, '2020-12-09', 'GD', 'Grenada', 'AMRO', '0', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33543, '2020-12-10', 'GD', 'Grenada', 'AMRO', '0', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33544, '2020-12-11', 'GD', 'Grenada', 'AMRO', '0', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33545, '2020-12-12', 'GD', 'Grenada', 'AMRO', '0', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33546, '2020-12-13', 'GD', 'Grenada', 'AMRO', '0', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33547, '2020-12-14', 'GD', 'Grenada', 'AMRO', '26', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33548, '2020-12-15', 'GD', 'Grenada', 'AMRO', '2', '71', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33549, '2020-12-16', 'GD', 'Grenada', 'AMRO', '0', '71', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33550, '2020-12-17', 'GD', 'Grenada', 'AMRO', '14', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33551, '2020-12-18', 'GD', 'Grenada', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33552, '2020-12-19', 'GD', 'Grenada', 'AMRO', '9', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33553, '2020-12-20', 'GD', 'Grenada', 'AMRO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33554, '2020-12-21', 'GD', 'Grenada', 'AMRO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33555, '2020-12-22', 'GD', 'Grenada', 'AMRO', '13', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33556, '2020-12-23', 'GD', 'Grenada', 'AMRO', '0', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33557, '2020-12-24', 'GD', 'Grenada', 'AMRO', '2', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33558, '2020-12-25', 'GD', 'Grenada', 'AMRO', '3', '112', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33559, '2020-12-26', 'GD', 'Grenada', 'AMRO', '4', '116', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33560, '2020-12-27', 'GD', 'Grenada', 'AMRO', '0', '116', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33561, '2020-12-28', 'GD', 'Grenada', 'AMRO', '0', '116', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33562, '2020-12-29', 'GD', 'Grenada', 'AMRO', '14', '130', '1', '1');
INSERT INTO public.who_global_data_import VALUES (33563, '2020-12-30', 'GD', 'Grenada', 'AMRO', '0', '130', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33564, '2020-12-31', 'GD', 'Grenada', 'AMRO', '0', '130', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33565, '2021-01-01', 'GD', 'Grenada', 'AMRO', '0', '130', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33566, '2021-01-02', 'GD', 'Grenada', 'AMRO', '0', '130', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33567, '2021-01-03', 'GD', 'Grenada', 'AMRO', '0', '130', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33568, '2021-01-04', 'GD', 'Grenada', 'AMRO', '0', '130', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33569, '2021-01-05', 'GD', 'Grenada', 'AMRO', '0', '130', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33570, '2021-01-06', 'GD', 'Grenada', 'AMRO', '0', '130', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33571, '2021-01-07', 'GD', 'Grenada', 'AMRO', '0', '130', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33572, '2021-01-08', 'GD', 'Grenada', 'AMRO', '0', '130', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33573, '2021-01-09', 'GD', 'Grenada', 'AMRO', '1', '131', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33574, '2021-01-10', 'GD', 'Grenada', 'AMRO', '4', '135', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33575, '2021-01-11', 'GD', 'Grenada', 'AMRO', '0', '135', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33576, '2021-01-12', 'GD', 'Grenada', 'AMRO', '0', '135', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33577, '2021-01-13', 'GD', 'Grenada', 'AMRO', '4', '139', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33578, '2021-01-14', 'GD', 'Grenada', 'AMRO', '0', '139', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33579, '2021-01-15', 'GD', 'Grenada', 'AMRO', '0', '139', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33580, '2021-01-16', 'GD', 'Grenada', 'AMRO', '0', '139', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33581, '2021-01-17', 'GD', 'Grenada', 'AMRO', '0', '139', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33582, '2021-01-18', 'GD', 'Grenada', 'AMRO', '0', '139', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33583, '2021-01-19', 'GD', 'Grenada', 'AMRO', '0', '139', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33584, '2021-01-20', 'GD', 'Grenada', 'AMRO', '0', '139', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33585, '2021-01-21', 'GD', 'Grenada', 'AMRO', '0', '139', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33586, '2021-01-22', 'GD', 'Grenada', 'AMRO', '0', '139', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33587, '2021-01-23', 'GD', 'Grenada', 'AMRO', '8', '147', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33588, '2021-01-24', 'GD', 'Grenada', 'AMRO', '0', '147', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33589, '2021-01-25', 'GD', 'Grenada', 'AMRO', '1', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33590, '2021-01-26', 'GD', 'Grenada', 'AMRO', '0', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33591, '2021-01-27', 'GD', 'Grenada', 'AMRO', '0', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33592, '2021-01-28', 'GD', 'Grenada', 'AMRO', '0', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33593, '2021-01-29', 'GD', 'Grenada', 'AMRO', '0', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33594, '2021-01-30', 'GD', 'Grenada', 'AMRO', '0', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33595, '2021-01-31', 'GD', 'Grenada', 'AMRO', '0', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33596, '2021-02-01', 'GD', 'Grenada', 'AMRO', '0', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33597, '2021-02-02', 'GD', 'Grenada', 'AMRO', '0', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33598, '2021-02-03', 'GD', 'Grenada', 'AMRO', '0', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33599, '2021-02-04', 'GD', 'Grenada', 'AMRO', '0', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33600, '2021-02-05', 'GD', 'Grenada', 'AMRO', '0', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (33601, '2020-01-03', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33602, '2020-01-04', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33603, '2020-01-05', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33604, '2020-01-06', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33605, '2020-01-07', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33606, '2020-01-08', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33607, '2020-01-09', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33608, '2020-01-10', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33609, '2020-01-11', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33610, '2020-01-12', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33611, '2020-01-13', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33612, '2020-01-14', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33613, '2020-01-15', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33614, '2020-01-16', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33615, '2020-01-17', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33616, '2020-01-18', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33617, '2020-01-19', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33618, '2020-01-20', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33619, '2020-01-21', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33620, '2020-01-22', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33621, '2020-01-23', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33622, '2020-01-24', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33623, '2020-01-25', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33624, '2020-01-26', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33625, '2020-01-27', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33626, '2020-01-28', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33627, '2020-01-29', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33628, '2020-01-30', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33629, '2020-01-31', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33630, '2020-02-01', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33631, '2020-02-02', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33632, '2020-02-03', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33633, '2020-02-04', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33634, '2020-02-05', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33635, '2020-02-06', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33636, '2020-02-07', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33637, '2020-02-08', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33638, '2020-02-09', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33639, '2020-02-10', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33640, '2020-02-11', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33641, '2020-02-12', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33642, '2020-02-13', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33643, '2020-02-14', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33644, '2020-02-15', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33645, '2020-02-16', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33646, '2020-02-17', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33647, '2020-02-18', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33648, '2020-02-19', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33649, '2020-02-20', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33650, '2020-02-21', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33651, '2020-02-22', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33652, '2020-02-23', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33653, '2020-02-24', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33654, '2020-02-25', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33655, '2020-02-26', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33656, '2020-02-27', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33657, '2020-02-28', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33658, '2020-02-29', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33659, '2020-03-01', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33660, '2020-03-02', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33661, '2020-03-03', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33662, '2020-03-04', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33663, '2020-03-05', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33664, '2020-03-06', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33665, '2020-03-07', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33666, '2020-03-08', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33667, '2020-03-09', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33668, '2020-03-10', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33669, '2020-03-11', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33670, '2020-03-12', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33671, '2020-03-13', 'GP', 'Guadeloupe', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33672, '2020-03-14', 'GP', 'Guadeloupe', 'AMRO', '7', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33673, '2020-03-15', 'GP', 'Guadeloupe', 'AMRO', '3', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33674, '2020-03-16', 'GP', 'Guadeloupe', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33675, '2020-03-17', 'GP', 'Guadeloupe', 'AMRO', '12', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33676, '2020-03-18', 'GP', 'Guadeloupe', 'AMRO', '15', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33677, '2020-03-19', 'GP', 'Guadeloupe', 'AMRO', '8', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33678, '2020-03-20', 'GP', 'Guadeloupe', 'AMRO', '6', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33679, '2020-03-21', 'GP', 'Guadeloupe', 'AMRO', '0', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33680, '2020-03-22', 'GP', 'Guadeloupe', 'AMRO', '0', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33681, '2020-03-23', 'GP', 'Guadeloupe', 'AMRO', '5', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33682, '2020-03-24', 'GP', 'Guadeloupe', 'AMRO', '17', '73', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33683, '2020-03-25', 'GP', 'Guadeloupe', 'AMRO', '0', '73', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33684, '2020-03-26', 'GP', 'Guadeloupe', 'AMRO', '3', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33685, '2020-03-27', 'GP', 'Guadeloupe', 'AMRO', '0', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (33686, '2020-03-28', 'GP', 'Guadeloupe', 'AMRO', '20', '96', '2', '2');
INSERT INTO public.who_global_data_import VALUES (33687, '2020-03-29', 'GP', 'Guadeloupe', 'AMRO', '0', '96', '0', '2');
INSERT INTO public.who_global_data_import VALUES (33688, '2020-03-30', 'GP', 'Guadeloupe', 'AMRO', '0', '96', '0', '2');
INSERT INTO public.who_global_data_import VALUES (33689, '2020-03-31', 'GP', 'Guadeloupe', 'AMRO', '10', '106', '2', '4');
INSERT INTO public.who_global_data_import VALUES (33690, '2020-04-01', 'GP', 'Guadeloupe', 'AMRO', '8', '114', '1', '5');
INSERT INTO public.who_global_data_import VALUES (33691, '2020-04-02', 'GP', 'Guadeloupe', 'AMRO', '11', '125', '1', '6');
INSERT INTO public.who_global_data_import VALUES (33692, '2020-04-03', 'GP', 'Guadeloupe', 'AMRO', '3', '128', '0', '6');
INSERT INTO public.who_global_data_import VALUES (33693, '2020-04-04', 'GP', 'Guadeloupe', 'AMRO', '2', '130', '1', '7');
INSERT INTO public.who_global_data_import VALUES (33694, '2020-04-05', 'GP', 'Guadeloupe', 'AMRO', '0', '130', '0', '7');
INSERT INTO public.who_global_data_import VALUES (33695, '2020-04-06', 'GP', 'Guadeloupe', 'AMRO', '4', '134', '0', '7');
INSERT INTO public.who_global_data_import VALUES (33696, '2020-04-07', 'GP', 'Guadeloupe', 'AMRO', '1', '135', '0', '7');
INSERT INTO public.who_global_data_import VALUES (33697, '2020-04-08', 'GP', 'Guadeloupe', 'AMRO', '4', '139', '0', '7');
INSERT INTO public.who_global_data_import VALUES (33698, '2020-04-09', 'GP', 'Guadeloupe', 'AMRO', '0', '139', '1', '8');
INSERT INTO public.who_global_data_import VALUES (33699, '2020-04-10', 'GP', 'Guadeloupe', 'AMRO', '2', '141', '0', '8');
INSERT INTO public.who_global_data_import VALUES (33700, '2020-04-11', 'GP', 'Guadeloupe', 'AMRO', '2', '143', '0', '8');
INSERT INTO public.who_global_data_import VALUES (33701, '2020-04-12', 'GP', 'Guadeloupe', 'AMRO', '0', '143', '0', '8');
INSERT INTO public.who_global_data_import VALUES (33702, '2020-04-13', 'GP', 'Guadeloupe', 'AMRO', '0', '143', '0', '8');
INSERT INTO public.who_global_data_import VALUES (33703, '2020-04-14', 'GP', 'Guadeloupe', 'AMRO', '0', '143', '0', '8');
INSERT INTO public.who_global_data_import VALUES (33704, '2020-04-15', 'GP', 'Guadeloupe', 'AMRO', '2', '145', '0', '8');
INSERT INTO public.who_global_data_import VALUES (33705, '2020-04-16', 'GP', 'Guadeloupe', 'AMRO', '0', '145', '0', '8');
INSERT INTO public.who_global_data_import VALUES (33706, '2020-04-17', 'GP', 'Guadeloupe', 'AMRO', '0', '145', '0', '8');
INSERT INTO public.who_global_data_import VALUES (33707, '2020-04-18', 'GP', 'Guadeloupe', 'AMRO', '0', '145', '0', '8');
INSERT INTO public.who_global_data_import VALUES (33708, '2020-04-19', 'GP', 'Guadeloupe', 'AMRO', '0', '145', '2', '10');
INSERT INTO public.who_global_data_import VALUES (33709, '2020-04-20', 'GP', 'Guadeloupe', 'AMRO', '3', '148', '0', '10');
INSERT INTO public.who_global_data_import VALUES (33710, '2020-04-21', 'GP', 'Guadeloupe', 'AMRO', '0', '148', '0', '10');
INSERT INTO public.who_global_data_import VALUES (33711, '2020-04-22', 'GP', 'Guadeloupe', 'AMRO', '0', '148', '0', '10');
INSERT INTO public.who_global_data_import VALUES (33712, '2020-04-23', 'GP', 'Guadeloupe', 'AMRO', '0', '148', '0', '10');
INSERT INTO public.who_global_data_import VALUES (33713, '2020-04-24', 'GP', 'Guadeloupe', 'AMRO', '0', '148', '0', '10');
INSERT INTO public.who_global_data_import VALUES (33714, '2020-04-25', 'GP', 'Guadeloupe', 'AMRO', '1', '149', '0', '10');
INSERT INTO public.who_global_data_import VALUES (33715, '2020-04-26', 'GP', 'Guadeloupe', 'AMRO', '0', '149', '0', '10');
INSERT INTO public.who_global_data_import VALUES (33716, '2020-04-27', 'GP', 'Guadeloupe', 'AMRO', '0', '149', '0', '10');
INSERT INTO public.who_global_data_import VALUES (33717, '2020-04-28', 'GP', 'Guadeloupe', 'AMRO', '0', '149', '0', '10');
INSERT INTO public.who_global_data_import VALUES (33718, '2020-04-29', 'GP', 'Guadeloupe', 'AMRO', '0', '149', '1', '11');
INSERT INTO public.who_global_data_import VALUES (33719, '2020-04-30', 'GP', 'Guadeloupe', 'AMRO', '2', '151', '0', '11');
INSERT INTO public.who_global_data_import VALUES (33720, '2020-05-01', 'GP', 'Guadeloupe', 'AMRO', '1', '152', '1', '12');
INSERT INTO public.who_global_data_import VALUES (33721, '2020-05-02', 'GP', 'Guadeloupe', 'AMRO', '0', '152', '0', '12');
INSERT INTO public.who_global_data_import VALUES (33722, '2020-05-03', 'GP', 'Guadeloupe', 'AMRO', '0', '152', '0', '12');
INSERT INTO public.who_global_data_import VALUES (33723, '2020-05-04', 'GP', 'Guadeloupe', 'AMRO', '0', '152', '0', '12');
INSERT INTO public.who_global_data_import VALUES (33724, '2020-05-05', 'GP', 'Guadeloupe', 'AMRO', '0', '152', '0', '12');
INSERT INTO public.who_global_data_import VALUES (33725, '2020-05-06', 'GP', 'Guadeloupe', 'AMRO', '0', '152', '1', '13');
INSERT INTO public.who_global_data_import VALUES (33726, '2020-05-07', 'GP', 'Guadeloupe', 'AMRO', '1', '153', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33727, '2020-05-08', 'GP', 'Guadeloupe', 'AMRO', '0', '153', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33728, '2020-05-09', 'GP', 'Guadeloupe', 'AMRO', '1', '154', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33729, '2020-05-10', 'GP', 'Guadeloupe', 'AMRO', '0', '154', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33730, '2020-05-11', 'GP', 'Guadeloupe', 'AMRO', '0', '154', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33731, '2020-05-12', 'GP', 'Guadeloupe', 'AMRO', '0', '154', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33732, '2020-05-13', 'GP', 'Guadeloupe', 'AMRO', '1', '155', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33733, '2020-05-14', 'GP', 'Guadeloupe', 'AMRO', '0', '155', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33734, '2020-05-15', 'GP', 'Guadeloupe', 'AMRO', '0', '155', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33735, '2020-05-16', 'GP', 'Guadeloupe', 'AMRO', '0', '155', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33736, '2020-05-17', 'GP', 'Guadeloupe', 'AMRO', '0', '155', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33737, '2020-05-18', 'GP', 'Guadeloupe', 'AMRO', '0', '155', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33738, '2020-05-19', 'GP', 'Guadeloupe', 'AMRO', '0', '155', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33739, '2020-05-20', 'GP', 'Guadeloupe', 'AMRO', '0', '155', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33740, '2020-05-21', 'GP', 'Guadeloupe', 'AMRO', '0', '155', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33741, '2020-05-22', 'GP', 'Guadeloupe', 'AMRO', '0', '155', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33742, '2020-05-23', 'GP', 'Guadeloupe', 'AMRO', '0', '155', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33743, '2020-05-24', 'GP', 'Guadeloupe', 'AMRO', '1', '156', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33744, '2020-05-25', 'GP', 'Guadeloupe', 'AMRO', '0', '156', '0', '13');
INSERT INTO public.who_global_data_import VALUES (33745, '2020-05-26', 'GP', 'Guadeloupe', 'AMRO', '5', '161', '1', '14');
INSERT INTO public.who_global_data_import VALUES (33746, '2020-05-27', 'GP', 'Guadeloupe', 'AMRO', '0', '161', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33747, '2020-05-28', 'GP', 'Guadeloupe', 'AMRO', '0', '161', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33748, '2020-05-29', 'GP', 'Guadeloupe', 'AMRO', '0', '161', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33749, '2020-05-30', 'GP', 'Guadeloupe', 'AMRO', '1', '162', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33750, '2020-05-31', 'GP', 'Guadeloupe', 'AMRO', '0', '162', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33751, '2020-06-01', 'GP', 'Guadeloupe', 'AMRO', '0', '162', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33752, '2020-06-02', 'GP', 'Guadeloupe', 'AMRO', '0', '162', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33753, '2020-06-03', 'GP', 'Guadeloupe', 'AMRO', '0', '162', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33754, '2020-06-04', 'GP', 'Guadeloupe', 'AMRO', '0', '162', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33755, '2020-06-05', 'GP', 'Guadeloupe', 'AMRO', '0', '162', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33756, '2020-06-06', 'GP', 'Guadeloupe', 'AMRO', '2', '164', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33757, '2020-06-07', 'GP', 'Guadeloupe', 'AMRO', '0', '164', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33758, '2020-06-08', 'GP', 'Guadeloupe', 'AMRO', '0', '164', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33759, '2020-06-09', 'GP', 'Guadeloupe', 'AMRO', '0', '164', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33760, '2020-06-10', 'GP', 'Guadeloupe', 'AMRO', '0', '164', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33761, '2020-06-11', 'GP', 'Guadeloupe', 'AMRO', '0', '164', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33762, '2020-06-12', 'GP', 'Guadeloupe', 'AMRO', '0', '164', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33763, '2020-06-13', 'GP', 'Guadeloupe', 'AMRO', '7', '171', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33764, '2020-06-14', 'GP', 'Guadeloupe', 'AMRO', '0', '171', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33765, '2020-06-15', 'GP', 'Guadeloupe', 'AMRO', '0', '171', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33766, '2020-06-16', 'GP', 'Guadeloupe', 'AMRO', '0', '171', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33767, '2020-06-17', 'GP', 'Guadeloupe', 'AMRO', '0', '171', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33768, '2020-06-18', 'GP', 'Guadeloupe', 'AMRO', '0', '171', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33769, '2020-06-19', 'GP', 'Guadeloupe', 'AMRO', '0', '171', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33770, '2020-06-20', 'GP', 'Guadeloupe', 'AMRO', '3', '174', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33771, '2020-06-21', 'GP', 'Guadeloupe', 'AMRO', '0', '174', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33772, '2020-06-22', 'GP', 'Guadeloupe', 'AMRO', '0', '174', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33773, '2020-06-23', 'GP', 'Guadeloupe', 'AMRO', '0', '174', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33774, '2020-06-24', 'GP', 'Guadeloupe', 'AMRO', '0', '174', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33775, '2020-06-25', 'GP', 'Guadeloupe', 'AMRO', '0', '174', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33776, '2020-06-26', 'GP', 'Guadeloupe', 'AMRO', '0', '174', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33777, '2020-06-27', 'GP', 'Guadeloupe', 'AMRO', '8', '182', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33778, '2020-06-28', 'GP', 'Guadeloupe', 'AMRO', '0', '182', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33779, '2020-06-29', 'GP', 'Guadeloupe', 'AMRO', '0', '182', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33780, '2020-06-30', 'GP', 'Guadeloupe', 'AMRO', '0', '182', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33781, '2020-07-01', 'GP', 'Guadeloupe', 'AMRO', '0', '182', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33782, '2020-07-02', 'GP', 'Guadeloupe', 'AMRO', '0', '182', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33783, '2020-07-03', 'GP', 'Guadeloupe', 'AMRO', '0', '182', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33784, '2020-07-04', 'GP', 'Guadeloupe', 'AMRO', '0', '182', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33785, '2020-07-05', 'GP', 'Guadeloupe', 'AMRO', '2', '184', '2', '16');
INSERT INTO public.who_global_data_import VALUES (33786, '2020-07-06', 'GP', 'Guadeloupe', 'AMRO', '0', '184', '-2', '14');
INSERT INTO public.who_global_data_import VALUES (33787, '2020-07-07', 'GP', 'Guadeloupe', 'AMRO', '0', '184', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33788, '2020-07-08', 'GP', 'Guadeloupe', 'AMRO', '0', '184', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33789, '2020-07-09', 'GP', 'Guadeloupe', 'AMRO', '0', '184', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33790, '2020-07-10', 'GP', 'Guadeloupe', 'AMRO', '0', '184', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33791, '2020-07-11', 'GP', 'Guadeloupe', 'AMRO', '6', '190', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33792, '2020-07-12', 'GP', 'Guadeloupe', 'AMRO', '0', '190', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33793, '2020-07-13', 'GP', 'Guadeloupe', 'AMRO', '0', '190', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33794, '2020-07-14', 'GP', 'Guadeloupe', 'AMRO', '0', '190', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33795, '2020-07-15', 'GP', 'Guadeloupe', 'AMRO', '0', '190', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33796, '2020-07-16', 'GP', 'Guadeloupe', 'AMRO', '0', '190', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33797, '2020-07-17', 'GP', 'Guadeloupe', 'AMRO', '0', '190', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33798, '2020-07-18', 'GP', 'Guadeloupe', 'AMRO', '5', '195', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33799, '2020-07-19', 'GP', 'Guadeloupe', 'AMRO', '0', '195', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33800, '2020-07-20', 'GP', 'Guadeloupe', 'AMRO', '0', '195', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33801, '2020-07-21', 'GP', 'Guadeloupe', 'AMRO', '0', '195', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33802, '2020-07-22', 'GP', 'Guadeloupe', 'AMRO', '0', '195', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33803, '2020-07-23', 'GP', 'Guadeloupe', 'AMRO', '0', '195', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33804, '2020-07-24', 'GP', 'Guadeloupe', 'AMRO', '0', '195', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33805, '2020-07-25', 'GP', 'Guadeloupe', 'AMRO', '8', '203', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33806, '2020-07-26', 'GP', 'Guadeloupe', 'AMRO', '0', '203', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33807, '2020-07-27', 'GP', 'Guadeloupe', 'AMRO', '0', '203', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33808, '2020-07-28', 'GP', 'Guadeloupe', 'AMRO', '0', '203', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33809, '2020-07-29', 'GP', 'Guadeloupe', 'AMRO', '0', '203', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33810, '2020-07-30', 'GP', 'Guadeloupe', 'AMRO', '41', '244', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33811, '2020-07-31', 'GP', 'Guadeloupe', 'AMRO', '0', '244', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33812, '2020-08-01', 'GP', 'Guadeloupe', 'AMRO', '0', '244', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33813, '2020-08-02', 'GP', 'Guadeloupe', 'AMRO', '21', '265', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33814, '2020-08-03', 'GP', 'Guadeloupe', 'AMRO', '0', '265', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33815, '2020-08-04', 'GP', 'Guadeloupe', 'AMRO', '0', '265', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33816, '2020-08-05', 'GP', 'Guadeloupe', 'AMRO', '7', '272', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33817, '2020-08-06', 'GP', 'Guadeloupe', 'AMRO', '0', '272', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33818, '2020-08-07', 'GP', 'Guadeloupe', 'AMRO', '7', '279', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33819, '2020-08-08', 'GP', 'Guadeloupe', 'AMRO', '0', '279', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33820, '2020-08-09', 'GP', 'Guadeloupe', 'AMRO', '11', '290', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33821, '2020-08-10', 'GP', 'Guadeloupe', 'AMRO', '0', '290', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33822, '2020-08-11', 'GP', 'Guadeloupe', 'AMRO', '0', '290', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33823, '2020-08-12', 'GP', 'Guadeloupe', 'AMRO', '27', '317', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33824, '2020-08-13', 'GP', 'Guadeloupe', 'AMRO', '0', '317', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33825, '2020-08-14', 'GP', 'Guadeloupe', 'AMRO', '50', '367', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33826, '2020-08-15', 'GP', 'Guadeloupe', 'AMRO', '79', '446', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33827, '2020-08-16', 'GP', 'Guadeloupe', 'AMRO', '0', '446', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33828, '2020-08-17', 'GP', 'Guadeloupe', 'AMRO', '0', '446', '0', '14');
INSERT INTO public.who_global_data_import VALUES (33829, '2020-08-18', 'GP', 'Guadeloupe', 'AMRO', '64', '510', '1', '15');
INSERT INTO public.who_global_data_import VALUES (33830, '2020-08-19', 'GP', 'Guadeloupe', 'AMRO', '0', '510', '0', '15');
INSERT INTO public.who_global_data_import VALUES (33831, '2020-08-20', 'GP', 'Guadeloupe', 'AMRO', '0', '510', '0', '15');
INSERT INTO public.who_global_data_import VALUES (33832, '2020-08-21', 'GP', 'Guadeloupe', 'AMRO', '0', '510', '0', '15');
INSERT INTO public.who_global_data_import VALUES (33833, '2020-08-22', 'GP', 'Guadeloupe', 'AMRO', '0', '510', '0', '15');
INSERT INTO public.who_global_data_import VALUES (33834, '2020-08-23', 'GP', 'Guadeloupe', 'AMRO', '261', '771', '0', '15');
INSERT INTO public.who_global_data_import VALUES (33835, '2020-08-24', 'GP', 'Guadeloupe', 'AMRO', '0', '771', '0', '15');
INSERT INTO public.who_global_data_import VALUES (33836, '2020-08-25', 'GP', 'Guadeloupe', 'AMRO', '0', '771', '0', '15');
INSERT INTO public.who_global_data_import VALUES (33837, '2020-08-26', 'GP', 'Guadeloupe', 'AMRO', '0', '771', '0', '15');
INSERT INTO public.who_global_data_import VALUES (33838, '2020-08-27', 'GP', 'Guadeloupe', 'AMRO', '164', '935', '0', '15');
INSERT INTO public.who_global_data_import VALUES (33839, '2020-08-28', 'GP', 'Guadeloupe', 'AMRO', '0', '935', '0', '15');
INSERT INTO public.who_global_data_import VALUES (33840, '2020-08-29', 'GP', 'Guadeloupe', 'AMRO', '0', '935', '0', '15');
INSERT INTO public.who_global_data_import VALUES (33841, '2020-08-30', 'GP', 'Guadeloupe', 'AMRO', '0', '935', '0', '15');
INSERT INTO public.who_global_data_import VALUES (33842, '2020-08-31', 'GP', 'Guadeloupe', 'AMRO', '210', '1145', '1', '16');
INSERT INTO public.who_global_data_import VALUES (33843, '2020-09-01', 'GP', 'Guadeloupe', 'AMRO', '0', '1145', '0', '16');
INSERT INTO public.who_global_data_import VALUES (33844, '2020-09-02', 'GP', 'Guadeloupe', 'AMRO', '124', '1269', '2', '18');
INSERT INTO public.who_global_data_import VALUES (33845, '2020-09-03', 'GP', 'Guadeloupe', 'AMRO', '0', '1269', '0', '18');
INSERT INTO public.who_global_data_import VALUES (33846, '2020-09-04', 'GP', 'Guadeloupe', 'AMRO', '94', '1363', '2', '20');
INSERT INTO public.who_global_data_import VALUES (33847, '2020-09-05', 'GP', 'Guadeloupe', 'AMRO', '0', '1363', '0', '20');
INSERT INTO public.who_global_data_import VALUES (33848, '2020-09-06', 'GP', 'Guadeloupe', 'AMRO', '0', '1363', '0', '20');
INSERT INTO public.who_global_data_import VALUES (33849, '2020-09-07', 'GP', 'Guadeloupe', 'AMRO', '0', '1363', '0', '20');
INSERT INTO public.who_global_data_import VALUES (33850, '2020-09-08', 'GP', 'Guadeloupe', 'AMRO', '0', '1363', '0', '20');
INSERT INTO public.who_global_data_import VALUES (33851, '2020-09-09', 'GP', 'Guadeloupe', 'AMRO', '924', '2287', '3', '23');
INSERT INTO public.who_global_data_import VALUES (33852, '2020-09-10', 'GP', 'Guadeloupe', 'AMRO', '0', '2287', '0', '23');
INSERT INTO public.who_global_data_import VALUES (33853, '2020-09-11', 'GP', 'Guadeloupe', 'AMRO', '0', '2287', '0', '23');
INSERT INTO public.who_global_data_import VALUES (33854, '2020-09-12', 'GP', 'Guadeloupe', 'AMRO', '0', '2287', '0', '23');
INSERT INTO public.who_global_data_import VALUES (33855, '2020-09-13', 'GP', 'Guadeloupe', 'AMRO', '793', '3080', '1', '24');
INSERT INTO public.who_global_data_import VALUES (33856, '2020-09-14', 'GP', 'Guadeloupe', 'AMRO', '0', '3080', '0', '24');
INSERT INTO public.who_global_data_import VALUES (33857, '2020-09-15', 'GP', 'Guadeloupe', 'AMRO', '0', '3080', '0', '24');
INSERT INTO public.who_global_data_import VALUES (33858, '2020-09-16', 'GP', 'Guadeloupe', 'AMRO', '0', '3080', '0', '24');
INSERT INTO public.who_global_data_import VALUES (33859, '2020-09-17', 'GP', 'Guadeloupe', 'AMRO', '346', '3426', '2', '26');
INSERT INTO public.who_global_data_import VALUES (33860, '2020-09-18', 'GP', 'Guadeloupe', 'AMRO', '0', '3426', '0', '26');
INSERT INTO public.who_global_data_import VALUES (33861, '2020-09-19', 'GP', 'Guadeloupe', 'AMRO', '0', '3426', '0', '26');
INSERT INTO public.who_global_data_import VALUES (33862, '2020-09-20', 'GP', 'Guadeloupe', 'AMRO', '0', '3426', '0', '26');
INSERT INTO public.who_global_data_import VALUES (33863, '2020-09-21', 'GP', 'Guadeloupe', 'AMRO', '0', '3426', '0', '26');
INSERT INTO public.who_global_data_import VALUES (33864, '2020-09-22', 'GP', 'Guadeloupe', 'AMRO', '0', '3426', '0', '26');
INSERT INTO public.who_global_data_import VALUES (33865, '2020-09-23', 'GP', 'Guadeloupe', 'AMRO', '1061', '4487', '16', '42');
INSERT INTO public.who_global_data_import VALUES (33866, '2020-09-24', 'GP', 'Guadeloupe', 'AMRO', '0', '4487', '0', '42');
INSERT INTO public.who_global_data_import VALUES (33867, '2020-09-25', 'GP', 'Guadeloupe', 'AMRO', '0', '4487', '0', '42');
INSERT INTO public.who_global_data_import VALUES (33868, '2020-09-26', 'GP', 'Guadeloupe', 'AMRO', '0', '4487', '0', '42');
INSERT INTO public.who_global_data_import VALUES (33869, '2020-09-27', 'GP', 'Guadeloupe', 'AMRO', '467', '4954', '0', '42');
INSERT INTO public.who_global_data_import VALUES (33870, '2020-09-28', 'GP', 'Guadeloupe', 'AMRO', '0', '4954', '0', '42');
INSERT INTO public.who_global_data_import VALUES (33871, '2020-09-29', 'GP', 'Guadeloupe', 'AMRO', '0', '4954', '11', '53');
INSERT INTO public.who_global_data_import VALUES (33872, '2020-09-30', 'GP', 'Guadeloupe', 'AMRO', '0', '4954', '0', '53');
INSERT INTO public.who_global_data_import VALUES (33873, '2020-10-01', 'GP', 'Guadeloupe', 'AMRO', '574', '5528', '4', '57');
INSERT INTO public.who_global_data_import VALUES (33874, '2020-10-02', 'GP', 'Guadeloupe', 'AMRO', '0', '5528', '0', '57');
INSERT INTO public.who_global_data_import VALUES (33875, '2020-10-03', 'GP', 'Guadeloupe', 'AMRO', '375', '5903', '18', '75');
INSERT INTO public.who_global_data_import VALUES (33876, '2020-10-04', 'GP', 'Guadeloupe', 'AMRO', '0', '5903', '0', '75');
INSERT INTO public.who_global_data_import VALUES (33877, '2020-10-05', 'GP', 'Guadeloupe', 'AMRO', '0', '5903', '0', '75');
INSERT INTO public.who_global_data_import VALUES (33878, '2020-10-06', 'GP', 'Guadeloupe', 'AMRO', '0', '5903', '0', '75');
INSERT INTO public.who_global_data_import VALUES (33879, '2020-10-07', 'GP', 'Guadeloupe', 'AMRO', '0', '5903', '0', '75');
INSERT INTO public.who_global_data_import VALUES (33880, '2020-10-08', 'GP', 'Guadeloupe', 'AMRO', '416', '6319', '2', '77');
INSERT INTO public.who_global_data_import VALUES (33881, '2020-10-09', 'GP', 'Guadeloupe', 'AMRO', '0', '6319', '0', '77');
INSERT INTO public.who_global_data_import VALUES (33882, '2020-10-10', 'GP', 'Guadeloupe', 'AMRO', '0', '6319', '18', '95');
INSERT INTO public.who_global_data_import VALUES (33883, '2020-10-11', 'GP', 'Guadeloupe', 'AMRO', '164', '6483', '0', '95');
INSERT INTO public.who_global_data_import VALUES (33884, '2020-10-12', 'GP', 'Guadeloupe', 'AMRO', '0', '6483', '0', '95');
INSERT INTO public.who_global_data_import VALUES (33885, '2020-10-13', 'GP', 'Guadeloupe', 'AMRO', '0', '6483', '0', '95');
INSERT INTO public.who_global_data_import VALUES (33886, '2020-10-14', 'GP', 'Guadeloupe', 'AMRO', '0', '6483', '0', '95');
INSERT INTO public.who_global_data_import VALUES (33887, '2020-10-15', 'GP', 'Guadeloupe', 'AMRO', '425', '6908', '1', '96');
INSERT INTO public.who_global_data_import VALUES (33888, '2020-10-16', 'GP', 'Guadeloupe', 'AMRO', '0', '6908', '0', '96');
INSERT INTO public.who_global_data_import VALUES (33889, '2020-10-17', 'GP', 'Guadeloupe', 'AMRO', '214', '7122', '15', '111');
INSERT INTO public.who_global_data_import VALUES (33890, '2020-10-18', 'GP', 'Guadeloupe', 'AMRO', '0', '7122', '0', '111');
INSERT INTO public.who_global_data_import VALUES (33891, '2020-10-19', 'GP', 'Guadeloupe', 'AMRO', '0', '7122', '0', '111');
INSERT INTO public.who_global_data_import VALUES (33892, '2020-10-20', 'GP', 'Guadeloupe', 'AMRO', '0', '7122', '0', '111');
INSERT INTO public.who_global_data_import VALUES (33893, '2020-10-21', 'GP', 'Guadeloupe', 'AMRO', '0', '7122', '0', '111');
INSERT INTO public.who_global_data_import VALUES (33894, '2020-10-22', 'GP', 'Guadeloupe', 'AMRO', '207', '7329', '4', '115');
INSERT INTO public.who_global_data_import VALUES (33895, '2020-10-23', 'GP', 'Guadeloupe', 'AMRO', '0', '7329', '0', '115');
INSERT INTO public.who_global_data_import VALUES (33896, '2020-10-24', 'GP', 'Guadeloupe', 'AMRO', '0', '7329', '0', '115');
INSERT INTO public.who_global_data_import VALUES (33897, '2020-10-25', 'GP', 'Guadeloupe', 'AMRO', '0', '7329', '0', '115');
INSERT INTO public.who_global_data_import VALUES (33898, '2020-10-26', 'GP', 'Guadeloupe', 'AMRO', '145', '7474', '11', '126');
INSERT INTO public.who_global_data_import VALUES (33899, '2020-10-27', 'GP', 'Guadeloupe', 'AMRO', '0', '7474', '0', '126');
INSERT INTO public.who_global_data_import VALUES (33900, '2020-10-28', 'GP', 'Guadeloupe', 'AMRO', '0', '7474', '0', '126');
INSERT INTO public.who_global_data_import VALUES (33901, '2020-10-29', 'GP', 'Guadeloupe', 'AMRO', '131', '7605', '0', '126');
INSERT INTO public.who_global_data_import VALUES (33902, '2020-10-30', 'GP', 'Guadeloupe', 'AMRO', '0', '7605', '0', '126');
INSERT INTO public.who_global_data_import VALUES (33903, '2020-10-31', 'GP', 'Guadeloupe', 'AMRO', '137', '7742', '0', '126');
INSERT INTO public.who_global_data_import VALUES (33904, '2020-11-01', 'GP', 'Guadeloupe', 'AMRO', '0', '7742', '0', '126');
INSERT INTO public.who_global_data_import VALUES (33905, '2020-11-02', 'GP', 'Guadeloupe', 'AMRO', '0', '7742', '0', '126');
INSERT INTO public.who_global_data_import VALUES (33906, '2020-11-03', 'GP', 'Guadeloupe', 'AMRO', '0', '7742', '0', '126');
INSERT INTO public.who_global_data_import VALUES (33907, '2020-11-04', 'GP', 'Guadeloupe', 'AMRO', '0', '7742', '0', '126');
INSERT INTO public.who_global_data_import VALUES (33908, '2020-11-05', 'GP', 'Guadeloupe', 'AMRO', '161', '7903', '7', '133');
INSERT INTO public.who_global_data_import VALUES (33909, '2020-11-06', 'GP', 'Guadeloupe', 'AMRO', '0', '7903', '0', '133');
INSERT INTO public.who_global_data_import VALUES (33910, '2020-11-07', 'GP', 'Guadeloupe', 'AMRO', '0', '7903', '0', '133');
INSERT INTO public.who_global_data_import VALUES (33911, '2020-11-08', 'GP', 'Guadeloupe', 'AMRO', '0', '7903', '0', '133');
INSERT INTO public.who_global_data_import VALUES (33912, '2020-11-09', 'GP', 'Guadeloupe', 'AMRO', '0', '7903', '0', '133');
INSERT INTO public.who_global_data_import VALUES (33913, '2020-11-10', 'GP', 'Guadeloupe', 'AMRO', '0', '7903', '0', '133');
INSERT INTO public.who_global_data_import VALUES (33914, '2020-11-11', 'GP', 'Guadeloupe', 'AMRO', '0', '7903', '0', '133');
INSERT INTO public.who_global_data_import VALUES (33915, '2020-11-12', 'GP', 'Guadeloupe', 'AMRO', '195', '8098', '6', '139');
INSERT INTO public.who_global_data_import VALUES (33916, '2020-11-13', 'GP', 'Guadeloupe', 'AMRO', '0', '8098', '0', '139');
INSERT INTO public.who_global_data_import VALUES (33917, '2020-11-14', 'GP', 'Guadeloupe', 'AMRO', '0', '8098', '0', '139');
INSERT INTO public.who_global_data_import VALUES (33918, '2020-11-15', 'GP', 'Guadeloupe', 'AMRO', '0', '8098', '0', '139');
INSERT INTO public.who_global_data_import VALUES (33919, '2020-11-16', 'GP', 'Guadeloupe', 'AMRO', '83', '8181', '0', '139');
INSERT INTO public.who_global_data_import VALUES (33920, '2020-11-17', 'GP', 'Guadeloupe', 'AMRO', '0', '8181', '0', '139');
INSERT INTO public.who_global_data_import VALUES (33921, '2020-11-18', 'GP', 'Guadeloupe', 'AMRO', '0', '8181', '0', '139');
INSERT INTO public.who_global_data_import VALUES (33922, '2020-11-19', 'GP', 'Guadeloupe', 'AMRO', '44', '8225', '5', '144');
INSERT INTO public.who_global_data_import VALUES (33923, '2020-11-20', 'GP', 'Guadeloupe', 'AMRO', '0', '8225', '0', '144');
INSERT INTO public.who_global_data_import VALUES (33924, '2020-11-21', 'GP', 'Guadeloupe', 'AMRO', '0', '8225', '0', '144');
INSERT INTO public.who_global_data_import VALUES (33925, '2020-11-22', 'GP', 'Guadeloupe', 'AMRO', '0', '8225', '0', '144');
INSERT INTO public.who_global_data_import VALUES (33926, '2020-11-23', 'GP', 'Guadeloupe', 'AMRO', '0', '8225', '0', '144');
INSERT INTO public.who_global_data_import VALUES (33927, '2020-11-24', 'GP', 'Guadeloupe', 'AMRO', '0', '8225', '0', '144');
INSERT INTO public.who_global_data_import VALUES (33928, '2020-11-25', 'GP', 'Guadeloupe', 'AMRO', '0', '8225', '0', '144');
INSERT INTO public.who_global_data_import VALUES (33929, '2020-11-26', 'GP', 'Guadeloupe', 'AMRO', '119', '8344', '5', '149');
INSERT INTO public.who_global_data_import VALUES (33930, '2020-11-27', 'GP', 'Guadeloupe', 'AMRO', '0', '8344', '0', '149');
INSERT INTO public.who_global_data_import VALUES (33931, '2020-11-28', 'GP', 'Guadeloupe', 'AMRO', '0', '8344', '0', '149');
INSERT INTO public.who_global_data_import VALUES (33932, '2020-11-29', 'GP', 'Guadeloupe', 'AMRO', '0', '8344', '0', '149');
INSERT INTO public.who_global_data_import VALUES (33933, '2020-11-30', 'GP', 'Guadeloupe', 'AMRO', '0', '8344', '0', '149');
INSERT INTO public.who_global_data_import VALUES (33934, '2020-12-01', 'GP', 'Guadeloupe', 'AMRO', '34', '8378', '0', '149');
INSERT INTO public.who_global_data_import VALUES (33935, '2020-12-02', 'GP', 'Guadeloupe', 'AMRO', '0', '8378', '0', '149');
INSERT INTO public.who_global_data_import VALUES (33936, '2020-12-03', 'GP', 'Guadeloupe', 'AMRO', '49', '8427', '0', '149');
INSERT INTO public.who_global_data_import VALUES (33937, '2020-12-04', 'GP', 'Guadeloupe', 'AMRO', '0', '8427', '0', '149');
INSERT INTO public.who_global_data_import VALUES (33938, '2020-12-05', 'GP', 'Guadeloupe', 'AMRO', '0', '8427', '0', '149');
INSERT INTO public.who_global_data_import VALUES (33939, '2020-12-06', 'GP', 'Guadeloupe', 'AMRO', '0', '8427', '0', '149');
INSERT INTO public.who_global_data_import VALUES (33940, '2020-12-07', 'GP', 'Guadeloupe', 'AMRO', '0', '8427', '0', '149');
INSERT INTO public.who_global_data_import VALUES (33941, '2020-12-08', 'GP', 'Guadeloupe', 'AMRO', '24', '8451', '0', '149');
INSERT INTO public.who_global_data_import VALUES (33942, '2020-12-09', 'GP', 'Guadeloupe', 'AMRO', '0', '8451', '3', '152');
INSERT INTO public.who_global_data_import VALUES (33943, '2020-12-10', 'GP', 'Guadeloupe', 'AMRO', '0', '8451', '0', '152');
INSERT INTO public.who_global_data_import VALUES (33944, '2020-12-11', 'GP', 'Guadeloupe', 'AMRO', '0', '8451', '0', '152');
INSERT INTO public.who_global_data_import VALUES (33945, '2020-12-12', 'GP', 'Guadeloupe', 'AMRO', '0', '8451', '0', '152');
INSERT INTO public.who_global_data_import VALUES (33946, '2020-12-13', 'GP', 'Guadeloupe', 'AMRO', '0', '8451', '0', '152');
INSERT INTO public.who_global_data_import VALUES (33947, '2020-12-14', 'GP', 'Guadeloupe', 'AMRO', '0', '8451', '0', '152');
INSERT INTO public.who_global_data_import VALUES (33948, '2020-12-15', 'GP', 'Guadeloupe', 'AMRO', '47', '8498', '0', '152');
INSERT INTO public.who_global_data_import VALUES (33949, '2020-12-16', 'GP', 'Guadeloupe', 'AMRO', '0', '8498', '0', '152');
INSERT INTO public.who_global_data_import VALUES (33950, '2020-12-17', 'GP', 'Guadeloupe', 'AMRO', '0', '8498', '0', '152');
INSERT INTO public.who_global_data_import VALUES (33951, '2020-12-18', 'GP', 'Guadeloupe', 'AMRO', '0', '8498', '2', '154');
INSERT INTO public.who_global_data_import VALUES (33952, '2020-12-19', 'GP', 'Guadeloupe', 'AMRO', '0', '8498', '0', '154');
INSERT INTO public.who_global_data_import VALUES (33953, '2020-12-20', 'GP', 'Guadeloupe', 'AMRO', '59', '8557', '1', '155');
INSERT INTO public.who_global_data_import VALUES (33954, '2020-12-21', 'GP', 'Guadeloupe', 'AMRO', '0', '8557', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33955, '2020-12-22', 'GP', 'Guadeloupe', 'AMRO', '0', '8557', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33956, '2020-12-23', 'GP', 'Guadeloupe', 'AMRO', '0', '8557', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33957, '2020-12-24', 'GP', 'Guadeloupe', 'AMRO', '0', '8557', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33958, '2020-12-25', 'GP', 'Guadeloupe', 'AMRO', '0', '8557', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33959, '2020-12-26', 'GP', 'Guadeloupe', 'AMRO', '0', '8557', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33960, '2020-12-27', 'GP', 'Guadeloupe', 'AMRO', '63', '8620', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33961, '2020-12-28', 'GP', 'Guadeloupe', 'AMRO', '0', '8620', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33962, '2020-12-29', 'GP', 'Guadeloupe', 'AMRO', '0', '8620', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33963, '2020-12-30', 'GP', 'Guadeloupe', 'AMRO', '0', '8620', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33964, '2020-12-31', 'GP', 'Guadeloupe', 'AMRO', '0', '8620', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33965, '2021-01-01', 'GP', 'Guadeloupe', 'AMRO', '0', '8620', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33966, '2021-01-02', 'GP', 'Guadeloupe', 'AMRO', '0', '8620', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33967, '2021-01-03', 'GP', 'Guadeloupe', 'AMRO', '0', '8620', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33968, '2021-01-04', 'GP', 'Guadeloupe', 'AMRO', '0', '8620', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33969, '2021-01-05', 'GP', 'Guadeloupe', 'AMRO', '82', '8702', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33970, '2021-01-06', 'GP', 'Guadeloupe', 'AMRO', '0', '8702', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33971, '2021-01-07', 'GP', 'Guadeloupe', 'AMRO', '0', '8702', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33972, '2021-01-08', 'GP', 'Guadeloupe', 'AMRO', '0', '8702', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33973, '2021-01-09', 'GP', 'Guadeloupe', 'AMRO', '0', '8702', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33974, '2021-01-10', 'GP', 'Guadeloupe', 'AMRO', '0', '8702', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33975, '2021-01-11', 'GP', 'Guadeloupe', 'AMRO', '0', '8702', '0', '155');
INSERT INTO public.who_global_data_import VALUES (33976, '2021-01-12', 'GP', 'Guadeloupe', 'AMRO', '132', '8834', '1', '156');
INSERT INTO public.who_global_data_import VALUES (33977, '2021-01-13', 'GP', 'Guadeloupe', 'AMRO', '0', '8834', '0', '156');
INSERT INTO public.who_global_data_import VALUES (33978, '2021-01-14', 'GP', 'Guadeloupe', 'AMRO', '0', '8834', '0', '156');
INSERT INTO public.who_global_data_import VALUES (33979, '2021-01-15', 'GP', 'Guadeloupe', 'AMRO', '0', '8834', '0', '156');
INSERT INTO public.who_global_data_import VALUES (33980, '2021-01-16', 'GP', 'Guadeloupe', 'AMRO', '0', '8834', '0', '156');
INSERT INTO public.who_global_data_import VALUES (33981, '2021-01-17', 'GP', 'Guadeloupe', 'AMRO', '0', '8834', '0', '156');
INSERT INTO public.who_global_data_import VALUES (33982, '2021-01-18', 'GP', 'Guadeloupe', 'AMRO', '0', '8834', '0', '156');
INSERT INTO public.who_global_data_import VALUES (33983, '2021-01-19', 'GP', 'Guadeloupe', 'AMRO', '114', '8948', '0', '156');
INSERT INTO public.who_global_data_import VALUES (33984, '2021-01-20', 'GP', 'Guadeloupe', 'AMRO', '0', '8948', '0', '156');
INSERT INTO public.who_global_data_import VALUES (33985, '2021-01-21', 'GP', 'Guadeloupe', 'AMRO', '0', '8948', '0', '156');
INSERT INTO public.who_global_data_import VALUES (33986, '2021-01-22', 'GP', 'Guadeloupe', 'AMRO', '0', '8948', '0', '156');
INSERT INTO public.who_global_data_import VALUES (33987, '2021-01-23', 'GP', 'Guadeloupe', 'AMRO', '108', '9056', '1', '157');
INSERT INTO public.who_global_data_import VALUES (33988, '2021-01-24', 'GP', 'Guadeloupe', 'AMRO', '0', '9056', '0', '157');
INSERT INTO public.who_global_data_import VALUES (33989, '2021-01-25', 'GP', 'Guadeloupe', 'AMRO', '0', '9056', '0', '157');
INSERT INTO public.who_global_data_import VALUES (33990, '2021-01-26', 'GP', 'Guadeloupe', 'AMRO', '0', '9056', '0', '157');
INSERT INTO public.who_global_data_import VALUES (33991, '2021-01-27', 'GP', 'Guadeloupe', 'AMRO', '0', '9056', '0', '157');
INSERT INTO public.who_global_data_import VALUES (33992, '2021-01-28', 'GP', 'Guadeloupe', 'AMRO', '0', '9056', '0', '157');
INSERT INTO public.who_global_data_import VALUES (33993, '2021-01-29', 'GP', 'Guadeloupe', 'AMRO', '0', '9056', '0', '157');
INSERT INTO public.who_global_data_import VALUES (33994, '2021-01-30', 'GP', 'Guadeloupe', 'AMRO', '0', '9056', '0', '157');
INSERT INTO public.who_global_data_import VALUES (33995, '2021-01-31', 'GP', 'Guadeloupe', 'AMRO', '100', '9156', '0', '157');
INSERT INTO public.who_global_data_import VALUES (33996, '2021-02-01', 'GP', 'Guadeloupe', 'AMRO', '0', '9156', '0', '157');
INSERT INTO public.who_global_data_import VALUES (33997, '2021-02-02', 'GP', 'Guadeloupe', 'AMRO', '0', '9156', '1', '158');
INSERT INTO public.who_global_data_import VALUES (33998, '2021-02-03', 'GP', 'Guadeloupe', 'AMRO', '0', '9156', '0', '158');
INSERT INTO public.who_global_data_import VALUES (33999, '2021-02-04', 'GP', 'Guadeloupe', 'AMRO', '0', '9156', '0', '158');
INSERT INTO public.who_global_data_import VALUES (34000, '2021-02-05', 'GP', 'Guadeloupe', 'AMRO', '0', '9156', '0', '158');
INSERT INTO public.who_global_data_import VALUES (34001, '2020-01-03', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34002, '2020-01-04', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34003, '2020-01-05', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34004, '2020-01-06', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34005, '2020-01-07', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34006, '2020-01-08', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34007, '2020-01-09', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34008, '2020-01-10', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34009, '2020-01-11', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34010, '2020-01-12', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34011, '2020-01-13', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34012, '2020-01-14', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34013, '2020-01-15', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34014, '2020-01-16', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34015, '2020-01-17', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34016, '2020-01-18', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34017, '2020-01-19', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34018, '2020-01-20', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34019, '2020-01-21', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34020, '2020-01-22', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34021, '2020-01-23', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34022, '2020-01-24', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34023, '2020-01-25', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34024, '2020-01-26', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34025, '2020-01-27', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34026, '2020-01-28', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34027, '2020-01-29', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34028, '2020-01-30', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34029, '2020-01-31', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34030, '2020-02-01', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34031, '2020-02-02', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34032, '2020-02-03', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34033, '2020-02-04', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34034, '2020-02-05', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34035, '2020-02-06', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34036, '2020-02-07', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34037, '2020-02-08', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34038, '2020-02-09', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34039, '2020-02-10', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34040, '2020-02-11', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34041, '2020-02-12', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34042, '2020-02-13', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34043, '2020-02-14', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34044, '2020-02-15', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34045, '2020-02-16', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34046, '2020-02-17', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34047, '2020-02-18', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34048, '2020-02-19', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34049, '2020-02-20', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34050, '2020-02-21', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34051, '2020-02-22', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34052, '2020-02-23', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34053, '2020-02-24', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34054, '2020-02-25', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34055, '2020-02-26', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34056, '2020-02-27', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34057, '2020-02-28', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34058, '2020-02-29', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34059, '2020-03-01', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34060, '2020-03-02', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34061, '2020-03-03', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34062, '2020-03-04', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34063, '2020-03-05', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34064, '2020-03-06', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34065, '2020-03-07', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34066, '2020-03-08', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34067, '2020-03-09', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34068, '2020-03-10', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34069, '2020-03-11', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34070, '2020-03-12', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34071, '2020-03-13', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34072, '2020-03-14', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34073, '2020-03-15', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34074, '2020-03-16', 'GU', 'Guam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34075, '2020-03-17', 'GU', 'Guam', 'WPRO', '7', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34076, '2020-03-18', 'GU', 'Guam', 'WPRO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34077, '2020-03-19', 'GU', 'Guam', 'WPRO', '3', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34078, '2020-03-20', 'GU', 'Guam', 'WPRO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34079, '2020-03-21', 'GU', 'Guam', 'WPRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34080, '2020-03-22', 'GU', 'Guam', 'WPRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34081, '2020-03-23', 'GU', 'Guam', 'WPRO', '12', '27', '1', '1');
INSERT INTO public.who_global_data_import VALUES (34082, '2020-03-24', 'GU', 'Guam', 'WPRO', '2', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34083, '2020-03-25', 'GU', 'Guam', 'WPRO', '3', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34084, '2020-03-26', 'GU', 'Guam', 'WPRO', '5', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34085, '2020-03-27', 'GU', 'Guam', 'WPRO', '8', '45', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34086, '2020-03-28', 'GU', 'Guam', 'WPRO', '6', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34087, '2020-03-29', 'GU', 'Guam', 'WPRO', '5', '56', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34088, '2020-03-30', 'GU', 'Guam', 'WPRO', '0', '56', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34089, '2020-03-31', 'GU', 'Guam', 'WPRO', '2', '58', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34090, '2020-04-01', 'GU', 'Guam', 'WPRO', '11', '69', '1', '2');
INSERT INTO public.who_global_data_import VALUES (34091, '2020-04-02', 'GU', 'Guam', 'WPRO', '8', '77', '1', '3');
INSERT INTO public.who_global_data_import VALUES (34092, '2020-04-03', 'GU', 'Guam', 'WPRO', '5', '82', '0', '3');
INSERT INTO public.who_global_data_import VALUES (34093, '2020-04-04', 'GU', 'Guam', 'WPRO', '2', '84', '0', '3');
INSERT INTO public.who_global_data_import VALUES (34094, '2020-04-05', 'GU', 'Guam', 'WPRO', '9', '93', '1', '4');
INSERT INTO public.who_global_data_import VALUES (34095, '2020-04-06', 'GU', 'Guam', 'WPRO', '19', '112', '0', '4');
INSERT INTO public.who_global_data_import VALUES (34096, '2020-04-07', 'GU', 'Guam', 'WPRO', '1', '113', '0', '4');
INSERT INTO public.who_global_data_import VALUES (34097, '2020-04-08', 'GU', 'Guam', 'WPRO', '11', '124', '0', '4');
INSERT INTO public.who_global_data_import VALUES (34098, '2020-04-09', 'GU', 'Guam', 'WPRO', '1', '125', '0', '4');
INSERT INTO public.who_global_data_import VALUES (34099, '2020-04-10', 'GU', 'Guam', 'WPRO', '3', '128', '0', '4');
INSERT INTO public.who_global_data_import VALUES (34100, '2020-04-11', 'GU', 'Guam', 'WPRO', '2', '130', '0', '4');
INSERT INTO public.who_global_data_import VALUES (34101, '2020-04-12', 'GU', 'Guam', 'WPRO', '3', '133', '1', '5');
INSERT INTO public.who_global_data_import VALUES (34102, '2020-04-13', 'GU', 'Guam', 'WPRO', '0', '133', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34103, '2020-04-14', 'GU', 'Guam', 'WPRO', '0', '133', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34104, '2020-04-15', 'GU', 'Guam', 'WPRO', '0', '133', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34105, '2020-04-16', 'GU', 'Guam', 'WPRO', '0', '133', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34106, '2020-04-17', 'GU', 'Guam', 'WPRO', '0', '133', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34107, '2020-04-18', 'GU', 'Guam', 'WPRO', '0', '133', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34108, '2020-04-19', 'GU', 'Guam', 'WPRO', '0', '133', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34109, '2020-04-20', 'GU', 'Guam', 'WPRO', '0', '133', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34110, '2020-04-21', 'GU', 'Guam', 'WPRO', '0', '133', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34111, '2020-04-22', 'GU', 'Guam', 'WPRO', '0', '133', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34112, '2020-04-23', 'GU', 'Guam', 'WPRO', '2', '135', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34113, '2020-04-24', 'GU', 'Guam', 'WPRO', '1', '136', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34114, '2020-04-25', 'GU', 'Guam', 'WPRO', '0', '136', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34115, '2020-04-26', 'GU', 'Guam', 'WPRO', '1', '137', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34116, '2020-04-27', 'GU', 'Guam', 'WPRO', '1', '138', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34117, '2020-04-28', 'GU', 'Guam', 'WPRO', '2', '140', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34118, '2020-04-29', 'GU', 'Guam', 'WPRO', '1', '141', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34119, '2020-04-30', 'GU', 'Guam', 'WPRO', '0', '141', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34120, '2020-05-01', 'GU', 'Guam', 'WPRO', '1', '142', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34121, '2020-05-02', 'GU', 'Guam', 'WPRO', '0', '142', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34122, '2020-05-03', 'GU', 'Guam', 'WPRO', '1', '143', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34123, '2020-05-04', 'GU', 'Guam', 'WPRO', '2', '145', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34124, '2020-05-05', 'GU', 'Guam', 'WPRO', '0', '145', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34125, '2020-05-06', 'GU', 'Guam', 'WPRO', '0', '145', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34126, '2020-05-07', 'GU', 'Guam', 'WPRO', '2', '147', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34127, '2020-05-08', 'GU', 'Guam', 'WPRO', '0', '147', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34128, '2020-05-09', 'GU', 'Guam', 'WPRO', '0', '147', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34129, '2020-05-10', 'GU', 'Guam', 'WPRO', '0', '147', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34130, '2020-05-11', 'GU', 'Guam', 'WPRO', '0', '147', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34131, '2020-05-12', 'GU', 'Guam', 'WPRO', '0', '147', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34132, '2020-05-13', 'GU', 'Guam', 'WPRO', '1', '148', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34133, '2020-05-14', 'GU', 'Guam', 'WPRO', '0', '148', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34134, '2020-05-15', 'GU', 'Guam', 'WPRO', '1', '149', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34135, '2020-05-16', 'GU', 'Guam', 'WPRO', '0', '149', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34136, '2020-05-17', 'GU', 'Guam', 'WPRO', '0', '149', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34137, '2020-05-18', 'GU', 'Guam', 'WPRO', '0', '149', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34138, '2020-05-19', 'GU', 'Guam', 'WPRO', '0', '149', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34139, '2020-05-20', 'GU', 'Guam', 'WPRO', '0', '149', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34140, '2020-05-21', 'GU', 'Guam', 'WPRO', '11', '160', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34141, '2020-05-22', 'GU', 'Guam', 'WPRO', '0', '160', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34142, '2020-05-23', 'GU', 'Guam', 'WPRO', '0', '160', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34143, '2020-05-24', 'GU', 'Guam', 'WPRO', '1', '161', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34144, '2020-05-25', 'GU', 'Guam', 'WPRO', '0', '161', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34145, '2020-05-26', 'GU', 'Guam', 'WPRO', '0', '161', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34146, '2020-05-27', 'GU', 'Guam', 'WPRO', '2', '163', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34147, '2020-05-28', 'GU', 'Guam', 'WPRO', '1', '164', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34148, '2020-05-29', 'GU', 'Guam', 'WPRO', '1', '165', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34149, '2020-05-30', 'GU', 'Guam', 'WPRO', '0', '165', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34150, '2020-05-31', 'GU', 'Guam', 'WPRO', '1', '166', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34151, '2020-06-01', 'GU', 'Guam', 'WPRO', '0', '166', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34152, '2020-06-02', 'GU', 'Guam', 'WPRO', '1', '167', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34153, '2020-06-03', 'GU', 'Guam', 'WPRO', '2', '169', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34154, '2020-06-04', 'GU', 'Guam', 'WPRO', '1', '170', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34155, '2020-06-05', 'GU', 'Guam', 'WPRO', '1', '171', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34156, '2020-06-06', 'GU', 'Guam', 'WPRO', '0', '171', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34157, '2020-06-07', 'GU', 'Guam', 'WPRO', '0', '171', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34158, '2020-06-08', 'GU', 'Guam', 'WPRO', '0', '171', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34159, '2020-06-09', 'GU', 'Guam', 'WPRO', '0', '171', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34160, '2020-06-10', 'GU', 'Guam', 'WPRO', '1', '172', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34161, '2020-06-11', 'GU', 'Guam', 'WPRO', '2', '174', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34162, '2020-06-12', 'GU', 'Guam', 'WPRO', '0', '174', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34163, '2020-06-13', 'GU', 'Guam', 'WPRO', '2', '176', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34164, '2020-06-14', 'GU', 'Guam', 'WPRO', '1', '177', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34165, '2020-06-15', 'GU', 'Guam', 'WPRO', '0', '177', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34166, '2020-06-16', 'GU', 'Guam', 'WPRO', '1', '178', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34167, '2020-06-17', 'GU', 'Guam', 'WPRO', '0', '178', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34168, '2020-06-18', 'GU', 'Guam', 'WPRO', '2', '180', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34169, '2020-06-19', 'GU', 'Guam', 'WPRO', '5', '185', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34170, '2020-06-20', 'GU', 'Guam', 'WPRO', '7', '192', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34171, '2020-06-21', 'GU', 'Guam', 'WPRO', '22', '214', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34172, '2020-06-22', 'GU', 'Guam', 'WPRO', '0', '214', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34173, '2020-06-23', 'GU', 'Guam', 'WPRO', '2', '216', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34174, '2020-06-24', 'GU', 'Guam', 'WPRO', '1', '217', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34175, '2020-06-25', 'GU', 'Guam', 'WPRO', '6', '223', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34176, '2020-06-26', 'GU', 'Guam', 'WPRO', '14', '237', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34177, '2020-06-27', 'GU', 'Guam', 'WPRO', '3', '240', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34178, '2020-06-28', 'GU', 'Guam', 'WPRO', '0', '240', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34179, '2020-06-29', 'GU', 'Guam', 'WPRO', '0', '240', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34180, '2020-06-30', 'GU', 'Guam', 'WPRO', '7', '247', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34181, '2020-07-01', 'GU', 'Guam', 'WPRO', '4', '251', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34182, '2020-07-02', 'GU', 'Guam', 'WPRO', '21', '272', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34183, '2020-07-03', 'GU', 'Guam', 'WPRO', '0', '272', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34184, '2020-07-04', 'GU', 'Guam', 'WPRO', '6', '278', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34185, '2020-07-05', 'GU', 'Guam', 'WPRO', '2', '280', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34186, '2020-07-06', 'GU', 'Guam', 'WPRO', '0', '280', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34187, '2020-07-07', 'GU', 'Guam', 'WPRO', '13', '293', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34188, '2020-07-08', 'GU', 'Guam', 'WPRO', '2', '295', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34189, '2020-07-09', 'GU', 'Guam', 'WPRO', '4', '299', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34190, '2020-07-10', 'GU', 'Guam', 'WPRO', '3', '302', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34191, '2020-07-11', 'GU', 'Guam', 'WPRO', '0', '302', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34192, '2020-07-12', 'GU', 'Guam', 'WPRO', '2', '304', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34193, '2020-07-13', 'GU', 'Guam', 'WPRO', '0', '304', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34194, '2020-07-14', 'GU', 'Guam', 'WPRO', '0', '304', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34195, '2020-07-15', 'GU', 'Guam', 'WPRO', '1', '305', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34196, '2020-07-16', 'GU', 'Guam', 'WPRO', '1', '306', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34197, '2020-07-17', 'GU', 'Guam', 'WPRO', '0', '306', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34198, '2020-07-18', 'GU', 'Guam', 'WPRO', '0', '306', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34199, '2020-07-19', 'GU', 'Guam', 'WPRO', '1', '307', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34200, '2020-07-20', 'GU', 'Guam', 'WPRO', '4', '311', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34201, '2020-07-21', 'GU', 'Guam', 'WPRO', '0', '311', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34202, '2020-07-22', 'GU', 'Guam', 'WPRO', '8', '319', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34203, '2020-07-23', 'GU', 'Guam', 'WPRO', '5', '324', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34204, '2020-07-24', 'GU', 'Guam', 'WPRO', '5', '329', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34205, '2020-07-25', 'GU', 'Guam', 'WPRO', '0', '329', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34206, '2020-07-26', 'GU', 'Guam', 'WPRO', '0', '329', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34207, '2020-07-27', 'GU', 'Guam', 'WPRO', '0', '329', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34208, '2020-07-28', 'GU', 'Guam', 'WPRO', '12', '341', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34209, '2020-07-29', 'GU', 'Guam', 'WPRO', '2', '343', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34210, '2020-07-30', 'GU', 'Guam', 'WPRO', '3', '346', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34211, '2020-07-31', 'GU', 'Guam', 'WPRO', '2', '348', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34212, '2020-08-01', 'GU', 'Guam', 'WPRO', '3', '351', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34213, '2020-08-02', 'GU', 'Guam', 'WPRO', '0', '351', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34214, '2020-08-03', 'GU', 'Guam', 'WPRO', '0', '351', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34215, '2020-08-04', 'GU', 'Guam', 'WPRO', '16', '367', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34216, '2020-08-05', 'GU', 'Guam', 'WPRO', '0', '367', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34217, '2020-08-06', 'GU', 'Guam', 'WPRO', '14', '381', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34218, '2020-08-07', 'GU', 'Guam', 'WPRO', '8', '389', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34219, '2020-08-08', 'GU', 'Guam', 'WPRO', '14', '403', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34220, '2020-08-09', 'GU', 'Guam', 'WPRO', '1', '404', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34221, '2020-08-10', 'GU', 'Guam', 'WPRO', '0', '404', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34222, '2020-08-11', 'GU', 'Guam', 'WPRO', '6', '410', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34223, '2020-08-12', 'GU', 'Guam', 'WPRO', '16', '426', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34224, '2020-08-13', 'GU', 'Guam', 'WPRO', '15', '441', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34225, '2020-08-14', 'GU', 'Guam', 'WPRO', '28', '469', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34226, '2020-08-15', 'GU', 'Guam', 'WPRO', '25', '494', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34227, '2020-08-16', 'GU', 'Guam', 'WPRO', '14', '508', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34228, '2020-08-17', 'GU', 'Guam', 'WPRO', '0', '508', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34229, '2020-08-18', 'GU', 'Guam', 'WPRO', '42', '550', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34230, '2020-08-19', 'GU', 'Guam', 'WPRO', '19', '569', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34231, '2020-08-20', 'GU', 'Guam', 'WPRO', '22', '591', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34232, '2020-08-21', 'GU', 'Guam', 'WPRO', '105', '696', '1', '6');
INSERT INTO public.who_global_data_import VALUES (34233, '2020-08-22', 'GU', 'Guam', 'WPRO', '63', '759', '1', '7');
INSERT INTO public.who_global_data_import VALUES (34234, '2020-08-23', 'GU', 'Guam', 'WPRO', '53', '812', '0', '7');
INSERT INTO public.who_global_data_import VALUES (34235, '2020-08-24', 'GU', 'Guam', 'WPRO', '0', '812', '0', '7');
INSERT INTO public.who_global_data_import VALUES (34236, '2020-08-25', 'GU', 'Guam', 'WPRO', '87', '899', '0', '7');
INSERT INTO public.who_global_data_import VALUES (34237, '2020-08-26', 'GU', 'Guam', 'WPRO', '77', '976', '0', '7');
INSERT INTO public.who_global_data_import VALUES (34238, '2020-08-27', 'GU', 'Guam', 'WPRO', '136', '1112', '2', '9');
INSERT INTO public.who_global_data_import VALUES (34239, '2020-08-28', 'GU', 'Guam', 'WPRO', '112', '1224', '1', '10');
INSERT INTO public.who_global_data_import VALUES (34240, '2020-08-29', 'GU', 'Guam', 'WPRO', '55', '1279', '0', '10');
INSERT INTO public.who_global_data_import VALUES (34241, '2020-08-30', 'GU', 'Guam', 'WPRO', '60', '1339', '0', '10');
INSERT INTO public.who_global_data_import VALUES (34242, '2020-08-31', 'GU', 'Guam', 'WPRO', '0', '1339', '0', '10');
INSERT INTO public.who_global_data_import VALUES (34243, '2020-09-01', 'GU', 'Guam', 'WPRO', '48', '1387', '0', '10');
INSERT INTO public.who_global_data_import VALUES (34244, '2020-09-02', 'GU', 'Guam', 'WPRO', '52', '1439', '3', '13');
INSERT INTO public.who_global_data_import VALUES (34245, '2020-09-03', 'GU', 'Guam', 'WPRO', '47', '1486', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34246, '2020-09-04', 'GU', 'Guam', 'WPRO', '74', '1560', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34247, '2020-09-05', 'GU', 'Guam', 'WPRO', '59', '1619', '1', '14');
INSERT INTO public.who_global_data_import VALUES (34248, '2020-09-06', 'GU', 'Guam', 'WPRO', '52', '1671', '2', '16');
INSERT INTO public.who_global_data_import VALUES (34249, '2020-09-07', 'GU', 'Guam', 'WPRO', '0', '1671', '0', '16');
INSERT INTO public.who_global_data_import VALUES (34250, '2020-09-08', 'GU', 'Guam', 'WPRO', '1', '1672', '2', '18');
INSERT INTO public.who_global_data_import VALUES (34251, '2020-09-09', 'GU', 'Guam', 'WPRO', '41', '1713', '1', '19');
INSERT INTO public.who_global_data_import VALUES (34252, '2020-09-10', 'GU', 'Guam', 'WPRO', '45', '1758', '2', '21');
INSERT INTO public.who_global_data_import VALUES (34253, '2020-09-11', 'GU', 'Guam', 'WPRO', '88', '1846', '2', '23');
INSERT INTO public.who_global_data_import VALUES (34254, '2020-09-12', 'GU', 'Guam', 'WPRO', '17', '1863', '0', '23');
INSERT INTO public.who_global_data_import VALUES (34255, '2020-09-13', 'GU', 'Guam', 'WPRO', '28', '1891', '2', '25');
INSERT INTO public.who_global_data_import VALUES (34256, '2020-09-14', 'GU', 'Guam', 'WPRO', '0', '1891', '1', '26');
INSERT INTO public.who_global_data_import VALUES (34257, '2020-09-15', 'GU', 'Guam', 'WPRO', '36', '1927', '0', '26');
INSERT INTO public.who_global_data_import VALUES (34258, '2020-09-16', 'GU', 'Guam', 'WPRO', '39', '1966', '3', '29');
INSERT INTO public.who_global_data_import VALUES (34259, '2020-09-17', 'GU', 'Guam', 'WPRO', '47', '2013', '1', '30');
INSERT INTO public.who_global_data_import VALUES (34260, '2020-09-18', 'GU', 'Guam', 'WPRO', '32', '2045', '1', '31');
INSERT INTO public.who_global_data_import VALUES (34261, '2020-09-19', 'GU', 'Guam', 'WPRO', '29', '2074', '2', '33');
INSERT INTO public.who_global_data_import VALUES (34262, '2020-09-20', 'GU', 'Guam', 'WPRO', '43', '2117', '1', '34');
INSERT INTO public.who_global_data_import VALUES (34263, '2020-09-21', 'GU', 'Guam', 'WPRO', '0', '2117', '0', '34');
INSERT INTO public.who_global_data_import VALUES (34264, '2020-09-22', 'GU', 'Guam', 'WPRO', '30', '2147', '1', '35');
INSERT INTO public.who_global_data_import VALUES (34265, '2020-09-23', 'GU', 'Guam', 'WPRO', '43', '2190', '2', '37');
INSERT INTO public.who_global_data_import VALUES (34266, '2020-09-24', 'GU', 'Guam', 'WPRO', '45', '2235', '1', '38');
INSERT INTO public.who_global_data_import VALUES (34267, '2020-09-25', 'GU', 'Guam', 'WPRO', '28', '2263', '1', '39');
INSERT INTO public.who_global_data_import VALUES (34268, '2020-09-26', 'GU', 'Guam', 'WPRO', '23', '2286', '2', '41');
INSERT INTO public.who_global_data_import VALUES (34269, '2020-09-27', 'GU', 'Guam', 'WPRO', '68', '2354', '2', '43');
INSERT INTO public.who_global_data_import VALUES (34270, '2020-09-28', 'GU', 'Guam', 'WPRO', '1', '2355', '0', '43');
INSERT INTO public.who_global_data_import VALUES (34271, '2020-09-29', 'GU', 'Guam', 'WPRO', '35', '2390', '3', '46');
INSERT INTO public.who_global_data_import VALUES (34272, '2020-09-30', 'GU', 'Guam', 'WPRO', '53', '2443', '1', '47');
INSERT INTO public.who_global_data_import VALUES (34273, '2020-10-01', 'GU', 'Guam', 'WPRO', '45', '2488', '2', '49');
INSERT INTO public.who_global_data_import VALUES (34274, '2020-10-02', 'GU', 'Guam', 'WPRO', '62', '2550', '0', '49');
INSERT INTO public.who_global_data_import VALUES (34275, '2020-10-03', 'GU', 'Guam', 'WPRO', '67', '2617', '1', '50');
INSERT INTO public.who_global_data_import VALUES (34276, '2020-10-04', 'GU', 'Guam', 'WPRO', '82', '2699', '1', '51');
INSERT INTO public.who_global_data_import VALUES (34277, '2020-10-05', 'GU', 'Guam', 'WPRO', '1', '2700', '1', '52');
INSERT INTO public.who_global_data_import VALUES (34278, '2020-10-06', 'GU', 'Guam', 'WPRO', '53', '2753', '3', '55');
INSERT INTO public.who_global_data_import VALUES (34279, '2020-10-07', 'GU', 'Guam', 'WPRO', '65', '2818', '0', '55');
INSERT INTO public.who_global_data_import VALUES (34280, '2020-10-08', 'GU', 'Guam', 'WPRO', '50', '2868', '2', '57');
INSERT INTO public.who_global_data_import VALUES (34281, '2020-10-09', 'GU', 'Guam', 'WPRO', '66', '2934', '1', '58');
INSERT INTO public.who_global_data_import VALUES (34282, '2020-10-10', 'GU', 'Guam', 'WPRO', '55', '2989', '0', '58');
INSERT INTO public.who_global_data_import VALUES (34283, '2020-10-11', 'GU', 'Guam', 'WPRO', '67', '3056', '1', '59');
INSERT INTO public.who_global_data_import VALUES (34284, '2020-10-12', 'GU', 'Guam', 'WPRO', '22', '3078', '1', '60');
INSERT INTO public.who_global_data_import VALUES (34285, '2020-10-13', 'GU', 'Guam', 'WPRO', '92', '3170', '0', '60');
INSERT INTO public.who_global_data_import VALUES (34286, '2020-10-14', 'GU', 'Guam', 'WPRO', '96', '3266', '1', '61');
INSERT INTO public.who_global_data_import VALUES (34287, '2020-10-15', 'GU', 'Guam', 'WPRO', '75', '3341', '0', '61');
INSERT INTO public.who_global_data_import VALUES (34288, '2020-10-16', 'GU', 'Guam', 'WPRO', '86', '3427', '2', '63');
INSERT INTO public.who_global_data_import VALUES (34289, '2020-10-17', 'GU', 'Guam', 'WPRO', '100', '3527', '0', '63');
INSERT INTO public.who_global_data_import VALUES (34290, '2020-10-18', 'GU', 'Guam', 'WPRO', '79', '3606', '3', '66');
INSERT INTO public.who_global_data_import VALUES (34291, '2020-10-19', 'GU', 'Guam', 'WPRO', '58', '3664', '0', '66');
INSERT INTO public.who_global_data_import VALUES (34292, '2020-10-20', 'GU', 'Guam', 'WPRO', '78', '3742', '0', '66');
INSERT INTO public.who_global_data_import VALUES (34293, '2020-10-21', 'GU', 'Guam', 'WPRO', '127', '3869', '1', '67');
INSERT INTO public.who_global_data_import VALUES (34294, '2020-10-22', 'GU', 'Guam', 'WPRO', '81', '3950', '2', '69');
INSERT INTO public.who_global_data_import VALUES (34295, '2020-10-23', 'GU', 'Guam', 'WPRO', '87', '4037', '0', '69');
INSERT INTO public.who_global_data_import VALUES (34296, '2020-10-24', 'GU', 'Guam', 'WPRO', '84', '4121', '0', '69');
INSERT INTO public.who_global_data_import VALUES (34297, '2020-10-25', 'GU', 'Guam', 'WPRO', '34', '4155', '2', '71');
INSERT INTO public.who_global_data_import VALUES (34298, '2020-10-26', 'GU', 'Guam', 'WPRO', '41', '4196', '0', '71');
INSERT INTO public.who_global_data_import VALUES (34299, '2020-10-27', 'GU', 'Guam', 'WPRO', '112', '4308', '4', '75');
INSERT INTO public.who_global_data_import VALUES (34300, '2020-10-28', 'GU', 'Guam', 'WPRO', '76', '4384', '0', '75');
INSERT INTO public.who_global_data_import VALUES (34301, '2020-10-29', 'GU', 'Guam', 'WPRO', '48', '4432', '2', '77');
INSERT INTO public.who_global_data_import VALUES (34302, '2020-10-30', 'GU', 'Guam', 'WPRO', '72', '4504', '1', '78');
INSERT INTO public.who_global_data_import VALUES (34303, '2020-10-31', 'GU', 'Guam', 'WPRO', '75', '4579', '1', '79');
INSERT INTO public.who_global_data_import VALUES (34304, '2020-11-01', 'GU', 'Guam', 'WPRO', '53', '4632', '0', '79');
INSERT INTO public.who_global_data_import VALUES (34305, '2020-11-02', 'GU', 'Guam', 'WPRO', '9', '4641', '0', '79');
INSERT INTO public.who_global_data_import VALUES (34306, '2020-11-03', 'GU', 'Guam', 'WPRO', '3', '4644', '0', '79');
INSERT INTO public.who_global_data_import VALUES (34307, '2020-11-04', 'GU', 'Guam', 'WPRO', '104', '4748', '1', '80');
INSERT INTO public.who_global_data_import VALUES (34308, '2020-11-05', 'GU', 'Guam', 'WPRO', '82', '4830', '3', '83');
INSERT INTO public.who_global_data_import VALUES (34309, '2020-11-06', 'GU', 'Guam', 'WPRO', '101', '4931', '4', '87');
INSERT INTO public.who_global_data_import VALUES (34310, '2020-11-07', 'GU', 'Guam', 'WPRO', '67', '4998', '1', '88');
INSERT INTO public.who_global_data_import VALUES (34311, '2020-11-08', 'GU', 'Guam', 'WPRO', '36', '5034', '1', '89');
INSERT INTO public.who_global_data_import VALUES (34312, '2020-11-09', 'GU', 'Guam', 'WPRO', '120', '5154', '1', '90');
INSERT INTO public.who_global_data_import VALUES (34313, '2020-11-10', 'GU', 'Guam', 'WPRO', '221', '5375', '0', '90');
INSERT INTO public.who_global_data_import VALUES (34314, '2020-11-11', 'GU', 'Guam', 'WPRO', '177', '5552', '1', '91');
INSERT INTO public.who_global_data_import VALUES (34315, '2020-11-12', 'GU', 'Guam', 'WPRO', '101', '5653', '0', '91');
INSERT INTO public.who_global_data_import VALUES (34316, '2020-11-13', 'GU', 'Guam', 'WPRO', '87', '5740', '0', '91');
INSERT INTO public.who_global_data_import VALUES (34317, '2020-11-14', 'GU', 'Guam', 'WPRO', '73', '5813', '2', '93');
INSERT INTO public.who_global_data_import VALUES (34318, '2020-11-15', 'GU', 'Guam', 'WPRO', '41', '5854', '0', '93');
INSERT INTO public.who_global_data_import VALUES (34319, '2020-11-16', 'GU', 'Guam', 'WPRO', '156', '6010', '1', '94');
INSERT INTO public.who_global_data_import VALUES (34320, '2020-11-17', 'GU', 'Guam', 'WPRO', '52', '6062', '4', '98');
INSERT INTO public.who_global_data_import VALUES (34321, '2020-11-18', 'GU', 'Guam', 'WPRO', '59', '6121', '2', '100');
INSERT INTO public.who_global_data_import VALUES (34322, '2020-11-19', 'GU', 'Guam', 'WPRO', '104', '6225', '0', '100');
INSERT INTO public.who_global_data_import VALUES (34323, '2020-11-20', 'GU', 'Guam', 'WPRO', '70', '6295', '1', '101');
INSERT INTO public.who_global_data_import VALUES (34324, '2020-11-21', 'GU', 'Guam', 'WPRO', '36', '6331', '2', '103');
INSERT INTO public.who_global_data_import VALUES (34325, '2020-11-22', 'GU', 'Guam', 'WPRO', '24', '6355', '1', '104');
INSERT INTO public.who_global_data_import VALUES (34326, '2020-11-23', 'GU', 'Guam', 'WPRO', '73', '6428', '2', '106');
INSERT INTO public.who_global_data_import VALUES (34327, '2020-11-24', 'GU', 'Guam', 'WPRO', '53', '6481', '0', '106');
INSERT INTO public.who_global_data_import VALUES (34328, '2020-11-25', 'GU', 'Guam', 'WPRO', '52', '6533', '1', '107');
INSERT INTO public.who_global_data_import VALUES (34329, '2020-11-26', 'GU', 'Guam', 'WPRO', '47', '6580', '2', '109');
INSERT INTO public.who_global_data_import VALUES (34330, '2020-11-27', 'GU', 'Guam', 'WPRO', '43', '6623', '2', '111');
INSERT INTO public.who_global_data_import VALUES (34331, '2020-11-28', 'GU', 'Guam', 'WPRO', '18', '6641', '1', '112');
INSERT INTO public.who_global_data_import VALUES (34332, '2020-11-29', 'GU', 'Guam', 'WPRO', '14', '6655', '0', '112');
INSERT INTO public.who_global_data_import VALUES (34333, '2020-11-30', 'GU', 'Guam', 'WPRO', '36', '6691', '0', '112');
INSERT INTO public.who_global_data_import VALUES (34334, '2020-12-01', 'GU', 'Guam', 'WPRO', '31', '6722', '0', '112');
INSERT INTO public.who_global_data_import VALUES (34335, '2020-12-02', 'GU', 'Guam', 'WPRO', '35', '6757', '0', '112');
INSERT INTO public.who_global_data_import VALUES (34336, '2020-12-03', 'GU', 'Guam', 'WPRO', '25', '6782', '0', '112');
INSERT INTO public.who_global_data_import VALUES (34337, '2020-12-04', 'GU', 'Guam', 'WPRO', '20', '6802', '0', '112');
INSERT INTO public.who_global_data_import VALUES (34338, '2020-12-05', 'GU', 'Guam', 'WPRO', '25', '6827', '1', '113');
INSERT INTO public.who_global_data_import VALUES (34339, '2020-12-06', 'GU', 'Guam', 'WPRO', '18', '6845', '0', '113');
INSERT INTO public.who_global_data_import VALUES (34340, '2020-12-07', 'GU', 'Guam', 'WPRO', '27', '6872', '0', '113');
INSERT INTO public.who_global_data_import VALUES (34341, '2020-12-08', 'GU', 'Guam', 'WPRO', '11', '6883', '0', '113');
INSERT INTO public.who_global_data_import VALUES (34342, '2020-12-09', 'GU', 'Guam', 'WPRO', '7', '6890', '0', '113');
INSERT INTO public.who_global_data_import VALUES (34343, '2020-12-10', 'GU', 'Guam', 'WPRO', '12', '6902', '0', '113');
INSERT INTO public.who_global_data_import VALUES (34344, '2020-12-11', 'GU', 'Guam', 'WPRO', '13', '6915', '2', '115');
INSERT INTO public.who_global_data_import VALUES (34345, '2020-12-12', 'GU', 'Guam', 'WPRO', '27', '6942', '0', '115');
INSERT INTO public.who_global_data_import VALUES (34346, '2020-12-13', 'GU', 'Guam', 'WPRO', '11', '6953', '2', '117');
INSERT INTO public.who_global_data_import VALUES (34347, '2020-12-14', 'GU', 'Guam', 'WPRO', '16', '6969', '1', '118');
INSERT INTO public.who_global_data_import VALUES (34348, '2020-12-15', 'GU', 'Guam', 'WPRO', '9', '6978', '1', '119');
INSERT INTO public.who_global_data_import VALUES (34349, '2020-12-16', 'GU', 'Guam', 'WPRO', '10', '6988', '0', '119');
INSERT INTO public.who_global_data_import VALUES (34350, '2020-12-17', 'GU', 'Guam', 'WPRO', '16', '7004', '0', '119');
INSERT INTO public.who_global_data_import VALUES (34351, '2020-12-18', 'GU', 'Guam', 'WPRO', '13', '7017', '0', '119');
INSERT INTO public.who_global_data_import VALUES (34352, '2020-12-19', 'GU', 'Guam', 'WPRO', '9', '7026', '0', '119');
INSERT INTO public.who_global_data_import VALUES (34353, '2020-12-20', 'GU', 'Guam', 'WPRO', '5', '7031', '0', '119');
INSERT INTO public.who_global_data_import VALUES (34354, '2020-12-21', 'GU', 'Guam', 'WPRO', '4', '7035', '0', '119');
INSERT INTO public.who_global_data_import VALUES (34355, '2020-12-22', 'GU', 'Guam', 'WPRO', '6', '7041', '1', '120');
INSERT INTO public.who_global_data_import VALUES (34356, '2020-12-23', 'GU', 'Guam', 'WPRO', '25', '7066', '1', '121');
INSERT INTO public.who_global_data_import VALUES (34357, '2020-12-24', 'GU', 'Guam', 'WPRO', '18', '7084', '0', '121');
INSERT INTO public.who_global_data_import VALUES (34358, '2020-12-25', 'GU', 'Guam', 'WPRO', '7', '7091', '0', '121');
INSERT INTO public.who_global_data_import VALUES (34359, '2020-12-26', 'GU', 'Guam', 'WPRO', '2', '7093', '0', '121');
INSERT INTO public.who_global_data_import VALUES (34360, '2020-12-27', 'GU', 'Guam', 'WPRO', '1', '7094', '0', '121');
INSERT INTO public.who_global_data_import VALUES (34361, '2020-12-28', 'GU', 'Guam', 'WPRO', '1', '7095', '0', '121');
INSERT INTO public.who_global_data_import VALUES (34362, '2020-12-29', 'GU', 'Guam', 'WPRO', '7', '7102', '0', '121');
INSERT INTO public.who_global_data_import VALUES (34363, '2020-12-30', 'GU', 'Guam', 'WPRO', '12', '7114', '0', '121');
INSERT INTO public.who_global_data_import VALUES (34364, '2020-12-31', 'GU', 'Guam', 'WPRO', '15', '7129', '0', '121');
INSERT INTO public.who_global_data_import VALUES (34365, '2021-01-01', 'GU', 'Guam', 'WPRO', '10', '7139', '1', '122');
INSERT INTO public.who_global_data_import VALUES (34366, '2021-01-02', 'GU', 'Guam', 'WPRO', '9', '7148', '0', '122');
INSERT INTO public.who_global_data_import VALUES (34367, '2021-01-03', 'GU', 'Guam', 'WPRO', '0', '7148', '1', '123');
INSERT INTO public.who_global_data_import VALUES (34368, '2021-01-04', 'GU', 'Guam', 'WPRO', '1', '7149', '0', '123');
INSERT INTO public.who_global_data_import VALUES (34369, '2021-01-05', 'GU', 'Guam', 'WPRO', '14', '7163', '0', '123');
INSERT INTO public.who_global_data_import VALUES (34370, '2021-01-06', 'GU', 'Guam', 'WPRO', '10', '7173', '0', '123');
INSERT INTO public.who_global_data_import VALUES (34371, '2021-01-07', 'GU', 'Guam', 'WPRO', '19', '7192', '0', '123');
INSERT INTO public.who_global_data_import VALUES (34372, '2021-01-08', 'GU', 'Guam', 'WPRO', '8', '7200', '1', '124');
INSERT INTO public.who_global_data_import VALUES (34373, '2021-01-09', 'GU', 'Guam', 'WPRO', '13', '7213', '0', '124');
INSERT INTO public.who_global_data_import VALUES (34374, '2021-01-10', 'GU', 'Guam', 'WPRO', '5', '7218', '0', '124');
INSERT INTO public.who_global_data_import VALUES (34375, '2021-01-11', 'GU', 'Guam', 'WPRO', '8', '7226', '0', '124');
INSERT INTO public.who_global_data_import VALUES (34376, '2021-01-12', 'GU', 'Guam', 'WPRO', '8', '7234', '0', '124');
INSERT INTO public.who_global_data_import VALUES (34377, '2021-01-13', 'GU', 'Guam', 'WPRO', '5', '7239', '0', '124');
INSERT INTO public.who_global_data_import VALUES (34378, '2021-01-14', 'GU', 'Guam', 'WPRO', '11', '7250', '0', '124');
INSERT INTO public.who_global_data_import VALUES (34379, '2021-01-15', 'GU', 'Guam', 'WPRO', '13', '7263', '0', '124');
INSERT INTO public.who_global_data_import VALUES (34380, '2021-01-16', 'GU', 'Guam', 'WPRO', '13', '7276', '1', '125');
INSERT INTO public.who_global_data_import VALUES (34381, '2021-01-17', 'GU', 'Guam', 'WPRO', '7', '7283', '1', '126');
INSERT INTO public.who_global_data_import VALUES (34382, '2021-01-18', 'GU', 'Guam', 'WPRO', '3', '7286', '1', '127');
INSERT INTO public.who_global_data_import VALUES (34383, '2021-01-19', 'GU', 'Guam', 'WPRO', '1', '7287', '1', '128');
INSERT INTO public.who_global_data_import VALUES (34384, '2021-01-20', 'GU', 'Guam', 'WPRO', '22', '7309', '0', '128');
INSERT INTO public.who_global_data_import VALUES (34385, '2021-01-21', 'GU', 'Guam', 'WPRO', '5', '7314', '0', '128');
INSERT INTO public.who_global_data_import VALUES (34386, '2021-01-22', 'GU', 'Guam', 'WPRO', '7', '7321', '0', '128');
INSERT INTO public.who_global_data_import VALUES (34387, '2021-01-23', 'GU', 'Guam', 'WPRO', '19', '7340', '0', '128');
INSERT INTO public.who_global_data_import VALUES (34388, '2021-01-24', 'GU', 'Guam', 'WPRO', '0', '7340', '0', '128');
INSERT INTO public.who_global_data_import VALUES (34389, '2021-01-25', 'GU', 'Guam', 'WPRO', '0', '7340', '0', '128');
INSERT INTO public.who_global_data_import VALUES (34390, '2021-01-26', 'GU', 'Guam', 'WPRO', '7', '7347', '1', '129');
INSERT INTO public.who_global_data_import VALUES (34391, '2021-01-27', 'GU', 'Guam', 'WPRO', '12', '7359', '0', '129');
INSERT INTO public.who_global_data_import VALUES (34392, '2021-01-28', 'GU', 'Guam', 'WPRO', '2', '7361', '0', '129');
INSERT INTO public.who_global_data_import VALUES (34393, '2021-01-29', 'GU', 'Guam', 'WPRO', '4', '7365', '0', '129');
INSERT INTO public.who_global_data_import VALUES (34394, '2021-01-30', 'GU', 'Guam', 'WPRO', '7', '7372', '0', '129');
INSERT INTO public.who_global_data_import VALUES (34395, '2021-01-31', 'GU', 'Guam', 'WPRO', '7', '7379', '0', '129');
INSERT INTO public.who_global_data_import VALUES (34396, '2021-02-01', 'GU', 'Guam', 'WPRO', '1', '7380', '0', '129');
INSERT INTO public.who_global_data_import VALUES (34397, '2021-02-02', 'GU', 'Guam', 'WPRO', '21', '7401', '0', '129');
INSERT INTO public.who_global_data_import VALUES (34398, '2021-02-03', 'GU', 'Guam', 'WPRO', '2', '7403', '0', '129');
INSERT INTO public.who_global_data_import VALUES (34399, '2021-02-04', 'GU', 'Guam', 'WPRO', '8', '7411', '0', '129');
INSERT INTO public.who_global_data_import VALUES (34400, '2021-02-05', 'GU', 'Guam', 'WPRO', '4', '7415', '0', '129');
INSERT INTO public.who_global_data_import VALUES (34401, '2020-01-03', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34402, '2020-01-04', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34403, '2020-01-05', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34404, '2020-01-06', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34405, '2020-01-07', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34406, '2020-01-08', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34407, '2020-01-09', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34408, '2020-01-10', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34409, '2020-01-11', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34410, '2020-01-12', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34411, '2020-01-13', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34412, '2020-01-14', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34413, '2020-01-15', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34414, '2020-01-16', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34415, '2020-01-17', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34416, '2020-01-18', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34417, '2020-01-19', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34418, '2020-01-20', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34419, '2020-01-21', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34420, '2020-01-22', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34421, '2020-01-23', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34422, '2020-01-24', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34423, '2020-01-25', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34424, '2020-01-26', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34425, '2020-01-27', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34426, '2020-01-28', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34427, '2020-01-29', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34428, '2020-01-30', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34429, '2020-01-31', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34430, '2020-02-01', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34431, '2020-02-02', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34432, '2020-02-03', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34433, '2020-02-04', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34434, '2020-02-05', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34435, '2020-02-06', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34436, '2020-02-07', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34437, '2020-02-08', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34438, '2020-02-09', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34439, '2020-02-10', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34440, '2020-02-11', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34441, '2020-02-12', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34442, '2020-02-13', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34443, '2020-02-14', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34444, '2020-02-15', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34445, '2020-02-16', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34446, '2020-02-17', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34447, '2020-02-18', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34448, '2020-02-19', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34449, '2020-02-20', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34450, '2020-02-21', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34451, '2020-02-22', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34452, '2020-02-23', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34453, '2020-02-24', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34454, '2020-02-25', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34455, '2020-02-26', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34456, '2020-02-27', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34457, '2020-02-28', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34458, '2020-02-29', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34459, '2020-03-01', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34460, '2020-03-02', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34461, '2020-03-03', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34462, '2020-03-04', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34463, '2020-03-05', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34464, '2020-03-06', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34465, '2020-03-07', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34466, '2020-03-08', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34467, '2020-03-09', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34468, '2020-03-10', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34469, '2020-03-11', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34470, '2020-03-12', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34471, '2020-03-13', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34472, '2020-03-14', 'GT', 'Guatemala', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34473, '2020-03-15', 'GT', 'Guatemala', 'AMRO', '5', '5', '1', '1');
INSERT INTO public.who_global_data_import VALUES (34474, '2020-03-16', 'GT', 'Guatemala', 'AMRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34475, '2020-03-17', 'GT', 'Guatemala', 'AMRO', '5', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34476, '2020-03-18', 'GT', 'Guatemala', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34477, '2020-03-19', 'GT', 'Guatemala', 'AMRO', '-1', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34478, '2020-03-20', 'GT', 'Guatemala', 'AMRO', '3', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34479, '2020-03-21', 'GT', 'Guatemala', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34480, '2020-03-22', 'GT', 'Guatemala', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34481, '2020-03-23', 'GT', 'Guatemala', 'AMRO', '6', '18', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34482, '2020-03-24', 'GT', 'Guatemala', 'AMRO', '3', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34483, '2020-03-25', 'GT', 'Guatemala', 'AMRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34484, '2020-03-26', 'GT', 'Guatemala', 'AMRO', '3', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34485, '2020-03-27', 'GT', 'Guatemala', 'AMRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34486, '2020-03-28', 'GT', 'Guatemala', 'AMRO', '1', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34487, '2020-03-29', 'GT', 'Guatemala', 'AMRO', '7', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34488, '2020-03-30', 'GT', 'Guatemala', 'AMRO', '2', '34', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34489, '2020-03-31', 'GT', 'Guatemala', 'AMRO', '2', '36', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34490, '2020-04-01', 'GT', 'Guatemala', 'AMRO', '0', '36', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34491, '2020-04-02', 'GT', 'Guatemala', 'AMRO', '3', '39', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34492, '2020-04-03', 'GT', 'Guatemala', 'AMRO', '8', '47', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34493, '2020-04-04', 'GT', 'Guatemala', 'AMRO', '3', '50', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34494, '2020-04-05', 'GT', 'Guatemala', 'AMRO', '0', '50', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34495, '2020-04-06', 'GT', 'Guatemala', 'AMRO', '11', '61', '1', '2');
INSERT INTO public.who_global_data_import VALUES (34496, '2020-04-07', 'GT', 'Guatemala', 'AMRO', '9', '70', '1', '3');
INSERT INTO public.who_global_data_import VALUES (34497, '2020-04-08', 'GT', 'Guatemala', 'AMRO', '7', '77', '0', '3');
INSERT INTO public.who_global_data_import VALUES (34498, '2020-04-09', 'GT', 'Guatemala', 'AMRO', '10', '87', '0', '3');
INSERT INTO public.who_global_data_import VALUES (34499, '2020-04-10', 'GT', 'Guatemala', 'AMRO', '8', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (34500, '2020-04-11', 'GT', 'Guatemala', 'AMRO', '31', '126', '0', '3');
INSERT INTO public.who_global_data_import VALUES (34501, '2020-04-12', 'GT', 'Guatemala', 'AMRO', '11', '137', '0', '3');
INSERT INTO public.who_global_data_import VALUES (34502, '2020-04-13', 'GT', 'Guatemala', 'AMRO', '16', '153', '0', '3');
INSERT INTO public.who_global_data_import VALUES (34503, '2020-04-14', 'GT', 'Guatemala', 'AMRO', '3', '156', '2', '5');
INSERT INTO public.who_global_data_import VALUES (34504, '2020-04-15', 'GT', 'Guatemala', 'AMRO', '11', '167', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34505, '2020-04-16', 'GT', 'Guatemala', 'AMRO', '13', '180', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34506, '2020-04-17', 'GT', 'Guatemala', 'AMRO', '16', '196', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34507, '2020-04-18', 'GT', 'Guatemala', 'AMRO', '18', '214', '2', '7');
INSERT INTO public.who_global_data_import VALUES (34508, '2020-04-19', 'GT', 'Guatemala', 'AMRO', '21', '235', '0', '7');
INSERT INTO public.who_global_data_import VALUES (34509, '2020-04-20', 'GT', 'Guatemala', 'AMRO', '22', '257', '0', '7');
INSERT INTO public.who_global_data_import VALUES (34510, '2020-04-21', 'GT', 'Guatemala', 'AMRO', '32', '289', '0', '7');
INSERT INTO public.who_global_data_import VALUES (34511, '2020-04-22', 'GT', 'Guatemala', 'AMRO', '5', '294', '1', '8');
INSERT INTO public.who_global_data_import VALUES (34512, '2020-04-23', 'GT', 'Guatemala', 'AMRO', '22', '316', '0', '8');
INSERT INTO public.who_global_data_import VALUES (34513, '2020-04-24', 'GT', 'Guatemala', 'AMRO', '26', '342', '2', '10');
INSERT INTO public.who_global_data_import VALUES (34514, '2020-04-25', 'GT', 'Guatemala', 'AMRO', '42', '384', '1', '11');
INSERT INTO public.who_global_data_import VALUES (34515, '2020-04-26', 'GT', 'Guatemala', 'AMRO', '46', '430', '2', '13');
INSERT INTO public.who_global_data_import VALUES (34516, '2020-04-27', 'GT', 'Guatemala', 'AMRO', '43', '473', '2', '15');
INSERT INTO public.who_global_data_import VALUES (34517, '2020-04-28', 'GT', 'Guatemala', 'AMRO', '27', '500', '0', '15');
INSERT INTO public.who_global_data_import VALUES (34518, '2020-04-29', 'GT', 'Guatemala', 'AMRO', '30', '530', '0', '15');
INSERT INTO public.who_global_data_import VALUES (34519, '2020-04-30', 'GT', 'Guatemala', 'AMRO', '27', '557', '1', '16');
INSERT INTO public.who_global_data_import VALUES (34520, '2020-05-01', 'GT', 'Guatemala', 'AMRO', '28', '585', '0', '16');
INSERT INTO public.who_global_data_import VALUES (34521, '2020-05-02', 'GT', 'Guatemala', 'AMRO', '14', '599', '0', '16');
INSERT INTO public.who_global_data_import VALUES (34522, '2020-05-03', 'GT', 'Guatemala', 'AMRO', '45', '644', '2', '18');
INSERT INTO public.who_global_data_import VALUES (34523, '2020-05-04', 'GT', 'Guatemala', 'AMRO', '44', '688', '1', '19');
INSERT INTO public.who_global_data_import VALUES (34524, '2020-05-05', 'GT', 'Guatemala', 'AMRO', '15', '703', '-2', '17');
INSERT INTO public.who_global_data_import VALUES (34525, '2020-05-06', 'GT', 'Guatemala', 'AMRO', '27', '730', '2', '19');
INSERT INTO public.who_global_data_import VALUES (34526, '2020-05-07', 'GT', 'Guatemala', 'AMRO', '33', '763', '0', '19');
INSERT INTO public.who_global_data_import VALUES (34527, '2020-05-08', 'GT', 'Guatemala', 'AMRO', '35', '798', '2', '21');
INSERT INTO public.who_global_data_import VALUES (34528, '2020-05-09', 'GT', 'Guatemala', 'AMRO', '34', '832', '2', '23');
INSERT INTO public.who_global_data_import VALUES (34529, '2020-05-10', 'GT', 'Guatemala', 'AMRO', '68', '900', '1', '24');
INSERT INTO public.who_global_data_import VALUES (34530, '2020-05-11', 'GT', 'Guatemala', 'AMRO', '67', '967', '0', '24');
INSERT INTO public.who_global_data_import VALUES (34531, '2020-05-12', 'GT', 'Guatemala', 'AMRO', '85', '1052', '2', '26');
INSERT INTO public.who_global_data_import VALUES (34532, '2020-05-13', 'GT', 'Guatemala', 'AMRO', '62', '1114', '0', '26');
INSERT INTO public.who_global_data_import VALUES (34533, '2020-05-14', 'GT', 'Guatemala', 'AMRO', '85', '1199', '1', '27');
INSERT INTO public.who_global_data_import VALUES (34534, '2020-05-15', 'GT', 'Guatemala', 'AMRO', '143', '1342', '2', '29');
INSERT INTO public.who_global_data_import VALUES (34535, '2020-05-16', 'GT', 'Guatemala', 'AMRO', '176', '1518', '0', '29');
INSERT INTO public.who_global_data_import VALUES (34536, '2020-05-17', 'GT', 'Guatemala', 'AMRO', '125', '1643', '1', '30');
INSERT INTO public.who_global_data_import VALUES (34537, '2020-05-18', 'GT', 'Guatemala', 'AMRO', '120', '1763', '3', '33');
INSERT INTO public.who_global_data_import VALUES (34538, '2020-05-19', 'GT', 'Guatemala', 'AMRO', '149', '1912', '2', '35');
INSERT INTO public.who_global_data_import VALUES (34539, '2020-05-20', 'GT', 'Guatemala', 'AMRO', '89', '2001', '3', '38');
INSERT INTO public.who_global_data_import VALUES (34540, '2020-05-21', 'GT', 'Guatemala', 'AMRO', '132', '2133', '5', '43');
INSERT INTO public.who_global_data_import VALUES (34541, '2020-05-22', 'GT', 'Guatemala', 'AMRO', '132', '2265', '2', '45');
INSERT INTO public.who_global_data_import VALUES (34542, '2020-05-23', 'GT', 'Guatemala', 'AMRO', '247', '2512', '3', '48');
INSERT INTO public.who_global_data_import VALUES (34543, '2020-05-24', 'GT', 'Guatemala', 'AMRO', '231', '2743', '5', '53');
INSERT INTO public.who_global_data_import VALUES (34544, '2020-05-25', 'GT', 'Guatemala', 'AMRO', '311', '3054', '4', '57');
INSERT INTO public.who_global_data_import VALUES (34545, '2020-05-26', 'GT', 'Guatemala', 'AMRO', '370', '3424', '1', '58');
INSERT INTO public.who_global_data_import VALUES (34546, '2020-05-27', 'GT', 'Guatemala', 'AMRO', '336', '3760', '1', '59');
INSERT INTO public.who_global_data_import VALUES (34547, '2020-05-28', 'GT', 'Guatemala', 'AMRO', '194', '3954', '4', '63');
INSERT INTO public.who_global_data_import VALUES (34548, '2020-05-29', 'GT', 'Guatemala', 'AMRO', '191', '4145', '5', '68');
INSERT INTO public.who_global_data_import VALUES (34549, '2020-05-30', 'GT', 'Guatemala', 'AMRO', '203', '4348', '12', '80');
INSERT INTO public.who_global_data_import VALUES (34550, '2020-05-31', 'GT', 'Guatemala', 'AMRO', '259', '4607', '10', '90');
INSERT INTO public.who_global_data_import VALUES (34551, '2020-06-01', 'GT', 'Guatemala', 'AMRO', '132', '4739', '12', '102');
INSERT INTO public.who_global_data_import VALUES (34552, '2020-06-02', 'GT', 'Guatemala', 'AMRO', '348', '5087', '6', '108');
INSERT INTO public.who_global_data_import VALUES (34553, '2020-06-03', 'GT', 'Guatemala', 'AMRO', '249', '5336', '8', '116');
INSERT INTO public.who_global_data_import VALUES (34554, '2020-06-04', 'GT', 'Guatemala', 'AMRO', '250', '5586', '7', '123');
INSERT INTO public.who_global_data_import VALUES (34555, '2020-06-05', 'GT', 'Guatemala', 'AMRO', '174', '5760', '20', '143');
INSERT INTO public.who_global_data_import VALUES (34556, '2020-06-06', 'GT', 'Guatemala', 'AMRO', '394', '6154', '15', '158');
INSERT INTO public.who_global_data_import VALUES (34557, '2020-06-07', 'GT', 'Guatemala', 'AMRO', '331', '6485', '58', '216');
INSERT INTO public.who_global_data_import VALUES (34558, '2020-06-08', 'GT', 'Guatemala', 'AMRO', '307', '6792', '14', '230');
INSERT INTO public.who_global_data_import VALUES (34559, '2020-06-09', 'GT', 'Guatemala', 'AMRO', '263', '7055', '22', '252');
INSERT INTO public.who_global_data_import VALUES (34560, '2020-06-10', 'GT', 'Guatemala', 'AMRO', '447', '7502', '15', '267');
INSERT INTO public.who_global_data_import VALUES (34561, '2020-06-11', 'GT', 'Guatemala', 'AMRO', '364', '7866', '22', '289');
INSERT INTO public.who_global_data_import VALUES (34562, '2020-06-12', 'GT', 'Guatemala', 'AMRO', '355', '8221', '27', '316');
INSERT INTO public.who_global_data_import VALUES (34563, '2020-06-13', 'GT', 'Guatemala', 'AMRO', '340', '8561', '18', '334');
INSERT INTO public.who_global_data_import VALUES (34564, '2020-06-14', 'GT', 'Guatemala', 'AMRO', '421', '8982', '17', '351');
INSERT INTO public.who_global_data_import VALUES (34565, '2020-06-15', 'GT', 'Guatemala', 'AMRO', '509', '9491', '16', '367');
INSERT INTO public.who_global_data_import VALUES (34566, '2020-06-16', 'GT', 'Guatemala', 'AMRO', '354', '9845', '17', '384');
INSERT INTO public.who_global_data_import VALUES (34567, '2020-06-17', 'GT', 'Guatemala', 'AMRO', '427', '10272', '15', '399');
INSERT INTO public.who_global_data_import VALUES (34568, '2020-06-18', 'GT', 'Guatemala', 'AMRO', '434', '10706', '19', '418');
INSERT INTO public.who_global_data_import VALUES (34569, '2020-06-19', 'GT', 'Guatemala', 'AMRO', '545', '11251', '14', '432');
INSERT INTO public.who_global_data_import VALUES (34570, '2020-06-20', 'GT', 'Guatemala', 'AMRO', '617', '11868', '17', '449');
INSERT INTO public.who_global_data_import VALUES (34571, '2020-06-21', 'GT', 'Guatemala', 'AMRO', '641', '12509', '34', '483');
INSERT INTO public.who_global_data_import VALUES (34572, '2020-06-22', 'GT', 'Guatemala', 'AMRO', '246', '12755', '31', '514');
INSERT INTO public.who_global_data_import VALUES (34573, '2020-06-23', 'GT', 'Guatemala', 'AMRO', '390', '13145', '17', '531');
INSERT INTO public.who_global_data_import VALUES (34574, '2020-06-24', 'GT', 'Guatemala', 'AMRO', '624', '13769', '16', '547');
INSERT INTO public.who_global_data_import VALUES (34575, '2020-06-25', 'GT', 'Guatemala', 'AMRO', '771', '14540', '35', '582');
INSERT INTO public.who_global_data_import VALUES (34576, '2020-06-26', 'GT', 'Guatemala', 'AMRO', '279', '14819', '19', '601');
INSERT INTO public.who_global_data_import VALUES (34577, '2020-06-27', 'GT', 'Guatemala', 'AMRO', '800', '15619', '22', '623');
INSERT INTO public.who_global_data_import VALUES (34578, '2020-06-28', 'GT', 'Guatemala', 'AMRO', '209', '15828', '49', '672');
INSERT INTO public.who_global_data_import VALUES (34579, '2020-06-29', 'GT', 'Guatemala', 'AMRO', '569', '16397', '34', '706');
INSERT INTO public.who_global_data_import VALUES (34580, '2020-06-30', 'GT', 'Guatemala', 'AMRO', '533', '16930', '21', '727');
INSERT INTO public.who_global_data_import VALUES (34581, '2020-07-01', 'GT', 'Guatemala', 'AMRO', '479', '17409', '19', '746');
INSERT INTO public.who_global_data_import VALUES (34582, '2020-07-02', 'GT', 'Guatemala', 'AMRO', '687', '18096', '27', '773');
INSERT INTO public.who_global_data_import VALUES (34583, '2020-07-03', 'GT', 'Guatemala', 'AMRO', '915', '19011', '44', '817');
INSERT INTO public.who_global_data_import VALUES (34584, '2020-07-04', 'GT', 'Guatemala', 'AMRO', '1061', '20072', '26', '843');
INSERT INTO public.who_global_data_import VALUES (34585, '2020-07-05', 'GT', 'Guatemala', 'AMRO', '1221', '21293', '37', '880');
INSERT INTO public.who_global_data_import VALUES (34586, '2020-07-06', 'GT', 'Guatemala', 'AMRO', '1208', '22501', '40', '920');
INSERT INTO public.who_global_data_import VALUES (34587, '2020-07-07', 'GT', 'Guatemala', 'AMRO', '747', '23248', '27', '947');
INSERT INTO public.who_global_data_import VALUES (34588, '2020-07-08', 'GT', 'Guatemala', 'AMRO', '724', '23972', '34', '981');
INSERT INTO public.who_global_data_import VALUES (34589, '2020-07-09', 'GT', 'Guatemala', 'AMRO', '815', '24787', '23', '1004');
INSERT INTO public.who_global_data_import VALUES (34590, '2020-07-10', 'GT', 'Guatemala', 'AMRO', '624', '25411', '49', '1053');
INSERT INTO public.who_global_data_import VALUES (34591, '2020-07-11', 'GT', 'Guatemala', 'AMRO', '1247', '26658', '39', '1092');
INSERT INTO public.who_global_data_import VALUES (34592, '2020-07-12', 'GT', 'Guatemala', 'AMRO', '961', '27619', '47', '1139');
INSERT INTO public.who_global_data_import VALUES (34593, '2020-07-13', 'GT', 'Guatemala', 'AMRO', '979', '28598', '33', '1172');
INSERT INTO public.who_global_data_import VALUES (34594, '2020-07-14', 'GT', 'Guatemala', 'AMRO', '757', '29355', '47', '1219');
INSERT INTO public.who_global_data_import VALUES (34595, '2020-07-15', 'GT', 'Guatemala', 'AMRO', '387', '29742', '25', '1244');
INSERT INTO public.who_global_data_import VALUES (34596, '2020-07-16', 'GT', 'Guatemala', 'AMRO', '1130', '30872', '58', '1302');
INSERT INTO public.who_global_data_import VALUES (34597, '2020-07-17', 'GT', 'Guatemala', 'AMRO', '1202', '32074', '48', '1350');
INSERT INTO public.who_global_data_import VALUES (34598, '2020-07-18', 'GT', 'Guatemala', 'AMRO', '865', '32939', '54', '1404');
INSERT INTO public.who_global_data_import VALUES (34599, '2020-07-19', 'GT', 'Guatemala', 'AMRO', '870', '33809', '39', '1443');
INSERT INTO public.who_global_data_import VALUES (34600, '2020-07-20', 'GT', 'Guatemala', 'AMRO', '4233', '38042', '6', '1449');
INSERT INTO public.who_global_data_import VALUES (34601, '2020-07-21', 'GT', 'Guatemala', 'AMRO', '997', '39039', '53', '1502');
INSERT INTO public.who_global_data_import VALUES (34602, '2020-07-22', 'GT', 'Guatemala', 'AMRO', '1190', '40229', '29', '1531');
INSERT INTO public.who_global_data_import VALUES (34603, '2020-07-23', 'GT', 'Guatemala', 'AMRO', '906', '41135', '42', '1573');
INSERT INTO public.who_global_data_import VALUES (34604, '2020-07-24', 'GT', 'Guatemala', 'AMRO', '1057', '42192', '59', '1632');
INSERT INTO public.who_global_data_import VALUES (34605, '2020-07-25', 'GT', 'Guatemala', 'AMRO', '1091', '43283', '37', '1669');
INSERT INTO public.who_global_data_import VALUES (34606, '2020-07-26', 'GT', 'Guatemala', 'AMRO', '1209', '44492', '30', '1699');
INSERT INTO public.who_global_data_import VALUES (34607, '2020-07-27', 'GT', 'Guatemala', 'AMRO', '561', '45053', '35', '1734');
INSERT INTO public.who_global_data_import VALUES (34608, '2020-07-28', 'GT', 'Guatemala', 'AMRO', '6', '45059', '27', '1761');
INSERT INTO public.who_global_data_import VALUES (34609, '2020-07-29', 'GT', 'Guatemala', 'AMRO', '1392', '46451', '21', '1782');
INSERT INTO public.who_global_data_import VALUES (34610, '2020-07-30', 'GT', 'Guatemala', 'AMRO', '1154', '47605', '53', '1835');
INSERT INTO public.who_global_data_import VALUES (34611, '2020-07-31', 'GT', 'Guatemala', 'AMRO', '1221', '48826', '32', '1867');
INSERT INTO public.who_global_data_import VALUES (34612, '2020-08-01', 'GT', 'Guatemala', 'AMRO', '963', '49789', '57', '1924');
INSERT INTO public.who_global_data_import VALUES (34613, '2020-08-02', 'GT', 'Guatemala', 'AMRO', '1190', '50979', '33', '1957');
INSERT INTO public.who_global_data_import VALUES (34614, '2020-08-03', 'GT', 'Guatemala', 'AMRO', '327', '51306', '38', '1995');
INSERT INTO public.who_global_data_import VALUES (34615, '2020-08-04', 'GT', 'Guatemala', 'AMRO', '236', '51542', '18', '2013');
INSERT INTO public.who_global_data_import VALUES (34616, '2020-08-05', 'GT', 'Guatemala', 'AMRO', '823', '52365', '24', '2037');
INSERT INTO public.who_global_data_import VALUES (34617, '2020-08-06', 'GT', 'Guatemala', 'AMRO', '1144', '53509', '35', '2072');
INSERT INTO public.who_global_data_import VALUES (34618, '2020-08-07', 'GT', 'Guatemala', 'AMRO', '830', '54339', '47', '2119');
INSERT INTO public.who_global_data_import VALUES (34619, '2020-08-08', 'GT', 'Guatemala', 'AMRO', '931', '55270', '49', '2168');
INSERT INTO public.who_global_data_import VALUES (34620, '2020-08-09', 'GT', 'Guatemala', 'AMRO', '919', '56189', '29', '2197');
INSERT INTO public.who_global_data_import VALUES (34621, '2020-08-10', 'GT', 'Guatemala', 'AMRO', '416', '56605', '14', '2211');
INSERT INTO public.who_global_data_import VALUES (34622, '2020-08-11', 'GT', 'Guatemala', 'AMRO', '382', '56987', '11', '2222');
INSERT INTO public.who_global_data_import VALUES (34623, '2020-08-12', 'GT', 'Guatemala', 'AMRO', '979', '57966', '11', '2233');
INSERT INTO public.who_global_data_import VALUES (34624, '2020-08-13', 'GT', 'Guatemala', 'AMRO', '1123', '59089', '34', '2267');
INSERT INTO public.who_global_data_import VALUES (34625, '2020-08-14', 'GT', 'Guatemala', 'AMRO', '1195', '60284', '29', '2296');
INSERT INTO public.who_global_data_import VALUES (34626, '2020-08-15', 'GT', 'Guatemala', 'AMRO', '1144', '61428', '45', '2341');
INSERT INTO public.who_global_data_import VALUES (34627, '2020-08-16', 'GT', 'Guatemala', 'AMRO', '885', '62313', '14', '2355');
INSERT INTO public.who_global_data_import VALUES (34628, '2020-08-17', 'GT', 'Guatemala', 'AMRO', '249', '62562', '24', '2379');
INSERT INTO public.who_global_data_import VALUES (34629, '2020-08-18', 'GT', 'Guatemala', 'AMRO', '382', '62944', '10', '2389');
INSERT INTO public.who_global_data_import VALUES (34630, '2020-08-19', 'GT', 'Guatemala', 'AMRO', '903', '63847', '30', '2419');
INSERT INTO public.who_global_data_import VALUES (34631, '2020-08-20', 'GT', 'Guatemala', 'AMRO', '1034', '64881', '48', '2467');
INSERT INTO public.who_global_data_import VALUES (34632, '2020-08-21', 'GT', 'Guatemala', 'AMRO', '1102', '65983', '39', '2506');
INSERT INTO public.who_global_data_import VALUES (34633, '2020-08-22', 'GT', 'Guatemala', 'AMRO', '958', '66941', '26', '2532');
INSERT INTO public.who_global_data_import VALUES (34634, '2020-08-23', 'GT', 'Guatemala', 'AMRO', '915', '67856', '48', '2580');
INSERT INTO public.who_global_data_import VALUES (34635, '2020-08-24', 'GT', 'Guatemala', 'AMRO', '332', '68188', '14', '2594');
INSERT INTO public.who_global_data_import VALUES (34636, '2020-08-25', 'GT', 'Guatemala', 'AMRO', '345', '68533', '17', '2611');
INSERT INTO public.who_global_data_import VALUES (34637, '2020-08-26', 'GT', 'Guatemala', 'AMRO', '1118', '69651', '19', '2630');
INSERT INTO public.who_global_data_import VALUES (34638, '2020-08-27', 'GT', 'Guatemala', 'AMRO', '1063', '70714', '32', '2662');
INSERT INTO public.who_global_data_import VALUES (34639, '2020-08-28', 'GT', 'Guatemala', 'AMRO', '1142', '71856', '23', '2685');
INSERT INTO public.who_global_data_import VALUES (34640, '2020-08-29', 'GT', 'Guatemala', 'AMRO', '1065', '72921', '24', '2709');
INSERT INTO public.who_global_data_import VALUES (34641, '2020-08-30', 'GT', 'Guatemala', 'AMRO', '758', '73679', '19', '2728');
INSERT INTO public.who_global_data_import VALUES (34642, '2020-08-31', 'GT', 'Guatemala', 'AMRO', '233', '73912', '12', '2740');
INSERT INTO public.who_global_data_import VALUES (34643, '2020-09-01', 'GT', 'Guatemala', 'AMRO', '162', '74074', '20', '2760');
INSERT INTO public.who_global_data_import VALUES (34644, '2020-09-02', 'GT', 'Guatemala', 'AMRO', '819', '74893', '18', '2778');
INSERT INTO public.who_global_data_import VALUES (34645, '2020-09-03', 'GT', 'Guatemala', 'AMRO', '751', '75644', '12', '2790');
INSERT INTO public.who_global_data_import VALUES (34646, '2020-09-04', 'GT', 'Guatemala', 'AMRO', '714', '76358', '14', '2804');
INSERT INTO public.who_global_data_import VALUES (34647, '2020-09-05', 'GT', 'Guatemala', 'AMRO', '682', '77040', '21', '2825');
INSERT INTO public.who_global_data_import VALUES (34648, '2020-09-06', 'GT', 'Guatemala', 'AMRO', '441', '77481', '20', '2845');
INSERT INTO public.who_global_data_import VALUES (34649, '2020-09-07', 'GT', 'Guatemala', 'AMRO', '202', '77683', '7', '2852');
INSERT INTO public.who_global_data_import VALUES (34650, '2020-09-08', 'GT', 'Guatemala', 'AMRO', '145', '77828', '10', '2862');
INSERT INTO public.who_global_data_import VALUES (34651, '2020-09-09', 'GT', 'Guatemala', 'AMRO', '893', '78721', '28', '2890');
INSERT INTO public.who_global_data_import VALUES (34652, '2020-09-10', 'GT', 'Guatemala', 'AMRO', '901', '79622', '7', '2897');
INSERT INTO public.who_global_data_import VALUES (34653, '2020-09-11', 'GT', 'Guatemala', 'AMRO', '684', '80306', '21', '2918');
INSERT INTO public.who_global_data_import VALUES (34654, '2020-09-12', 'GT', 'Guatemala', 'AMRO', '703', '81009', '11', '2929');
INSERT INTO public.who_global_data_import VALUES (34655, '2020-09-13', 'GT', 'Guatemala', 'AMRO', '649', '81658', '20', '2949');
INSERT INTO public.who_global_data_import VALUES (34656, '2020-09-14', 'GT', 'Guatemala', 'AMRO', '251', '81909', '8', '2957');
INSERT INTO public.who_global_data_import VALUES (34657, '2020-09-15', 'GT', 'Guatemala', 'AMRO', '263', '82172', '15', '2972');
INSERT INTO public.who_global_data_import VALUES (34658, '2020-09-16', 'GT', 'Guatemala', 'AMRO', '512', '82684', '12', '2984');
INSERT INTO public.who_global_data_import VALUES (34659, '2020-09-17', 'GT', 'Guatemala', 'AMRO', '240', '82924', '25', '3009');
INSERT INTO public.who_global_data_import VALUES (34660, '2020-09-18', 'GT', 'Guatemala', 'AMRO', '740', '83664', '27', '3036');
INSERT INTO public.who_global_data_import VALUES (34661, '2020-09-19', 'GT', 'Guatemala', 'AMRO', '680', '84344', '40', '3076');
INSERT INTO public.who_global_data_import VALUES (34662, '2020-09-20', 'GT', 'Guatemala', 'AMRO', '808', '85152', '29', '3105');
INSERT INTO public.who_global_data_import VALUES (34663, '2020-09-21', 'GT', 'Guatemala', 'AMRO', '292', '85444', '14', '3119');
INSERT INTO public.who_global_data_import VALUES (34664, '2020-09-22', 'GT', 'Guatemala', 'AMRO', '237', '85681', '5', '3124');
INSERT INTO public.who_global_data_import VALUES (34665, '2020-09-23', 'GT', 'Guatemala', 'AMRO', '942', '86623', '13', '3137');
INSERT INTO public.who_global_data_import VALUES (34666, '2020-09-24', 'GT', 'Guatemala', 'AMRO', '819', '87442', '17', '3154');
INSERT INTO public.who_global_data_import VALUES (34667, '2020-09-25', 'GT', 'Guatemala', 'AMRO', '491', '87933', '16', '3170');
INSERT INTO public.who_global_data_import VALUES (34668, '2020-09-26', 'GT', 'Guatemala', 'AMRO', '945', '88878', '16', '3186');
INSERT INTO public.who_global_data_import VALUES (34669, '2020-09-27', 'GT', 'Guatemala', 'AMRO', '824', '89702', '27', '3213');
INSERT INTO public.who_global_data_import VALUES (34670, '2020-09-28', 'GT', 'Guatemala', 'AMRO', '390', '90092', '16', '3229');
INSERT INTO public.who_global_data_import VALUES (34671, '2020-09-29', 'GT', 'Guatemala', 'AMRO', '171', '90263', '5', '3234');
INSERT INTO public.who_global_data_import VALUES (34672, '2020-09-30', 'GT', 'Guatemala', 'AMRO', '705', '90968', '4', '3238');
INSERT INTO public.who_global_data_import VALUES (34673, '2020-10-01', 'GT', 'Guatemala', 'AMRO', '778', '91746', '8', '3246');
INSERT INTO public.who_global_data_import VALUES (34674, '2020-10-02', 'GT', 'Guatemala', 'AMRO', '663', '92409', '15', '3261');
INSERT INTO public.who_global_data_import VALUES (34675, '2020-10-03', 'GT', 'Guatemala', 'AMRO', '681', '93090', '6', '3267');
INSERT INTO public.who_global_data_import VALUES (34676, '2020-10-04', 'GT', 'Guatemala', 'AMRO', '658', '93748', '18', '3285');
INSERT INTO public.who_global_data_import VALUES (34677, '2020-10-05', 'GT', 'Guatemala', 'AMRO', '215', '93963', '8', '3293');
INSERT INTO public.who_global_data_import VALUES (34678, '2020-10-06', 'GT', 'Guatemala', 'AMRO', '219', '94182', '9', '3302');
INSERT INTO public.who_global_data_import VALUES (34679, '2020-10-07', 'GT', 'Guatemala', 'AMRO', '688', '94870', '8', '3310');
INSERT INTO public.who_global_data_import VALUES (34680, '2020-10-08', 'GT', 'Guatemala', 'AMRO', '834', '95704', '25', '3335');
INSERT INTO public.who_global_data_import VALUES (34681, '2020-10-09', 'GT', 'Guatemala', 'AMRO', '776', '96480', '12', '3347');
INSERT INTO public.who_global_data_import VALUES (34682, '2020-10-10', 'GT', 'Guatemala', 'AMRO', '455', '96935', '9', '3356');
INSERT INTO public.who_global_data_import VALUES (34683, '2020-10-11', 'GT', 'Guatemala', 'AMRO', '609', '97544', '9', '3365');
INSERT INTO public.who_global_data_import VALUES (34684, '2020-10-12', 'GT', 'Guatemala', 'AMRO', '171', '97715', '19', '3384');
INSERT INTO public.who_global_data_import VALUES (34685, '2020-10-13', 'GT', 'Guatemala', 'AMRO', '111', '97826', '3', '3387');
INSERT INTO public.who_global_data_import VALUES (34686, '2020-10-14', 'GT', 'Guatemala', 'AMRO', '554', '98380', '23', '3410');
INSERT INTO public.who_global_data_import VALUES (34687, '2020-10-15', 'GT', 'Guatemala', 'AMRO', '714', '99094', '20', '3430');
INSERT INTO public.who_global_data_import VALUES (34688, '2020-10-16', 'GT', 'Guatemala', 'AMRO', '671', '99765', '23', '3453');
INSERT INTO public.who_global_data_import VALUES (34689, '2020-10-17', 'GT', 'Guatemala', 'AMRO', '666', '100431', '25', '3478');
INSERT INTO public.who_global_data_import VALUES (34690, '2020-10-18', 'GT', 'Guatemala', 'AMRO', '597', '101028', '37', '3515');
INSERT INTO public.who_global_data_import VALUES (34691, '2020-10-19', 'GT', 'Guatemala', 'AMRO', '332', '101360', '15', '3530');
INSERT INTO public.who_global_data_import VALUES (34692, '2020-10-20', 'GT', 'Guatemala', 'AMRO', '239', '101599', '11', '3541');
INSERT INTO public.who_global_data_import VALUES (34693, '2020-10-21', 'GT', 'Guatemala', 'AMRO', '620', '102219', '5', '3546');
INSERT INTO public.who_global_data_import VALUES (34694, '2020-10-22', 'GT', 'Guatemala', 'AMRO', '196', '102415', '21', '3567');
INSERT INTO public.who_global_data_import VALUES (34695, '2020-10-23', 'GT', 'Guatemala', 'AMRO', '757', '103172', '13', '3580');
INSERT INTO public.who_global_data_import VALUES (34696, '2020-10-24', 'GT', 'Guatemala', 'AMRO', '730', '103902', '14', '3594');
INSERT INTO public.who_global_data_import VALUES (34697, '2020-10-25', 'GT', 'Guatemala', 'AMRO', '730', '104632', '15', '3609');
INSERT INTO public.who_global_data_import VALUES (34698, '2020-10-26', 'GT', 'Guatemala', 'AMRO', '155', '104787', '35', '3644');
INSERT INTO public.who_global_data_import VALUES (34699, '2020-10-27', 'GT', 'Guatemala', 'AMRO', '107', '104894', '7', '3651');
INSERT INTO public.who_global_data_import VALUES (34700, '2020-10-28', 'GT', 'Guatemala', 'AMRO', '677', '105571', '14', '3665');
INSERT INTO public.who_global_data_import VALUES (34701, '2020-10-29', 'GT', 'Guatemala', 'AMRO', '749', '106320', '17', '3682');
INSERT INTO public.who_global_data_import VALUES (34702, '2020-10-30', 'GT', 'Guatemala', 'AMRO', '470', '106790', '22', '3704');
INSERT INTO public.who_global_data_import VALUES (34703, '2020-10-31', 'GT', 'Guatemala', 'AMRO', '549', '107339', '10', '3714');
INSERT INTO public.who_global_data_import VALUES (34704, '2020-11-01', 'GT', 'Guatemala', 'AMRO', '600', '107939', '15', '3729');
INSERT INTO public.who_global_data_import VALUES (34705, '2020-11-02', 'GT', 'Guatemala', 'AMRO', '165', '108104', '9', '3738');
INSERT INTO public.who_global_data_import VALUES (34706, '2020-11-03', 'GT', 'Guatemala', 'AMRO', '0', '108104', '0', '3738');
INSERT INTO public.who_global_data_import VALUES (34707, '2020-11-04', 'GT', 'Guatemala', 'AMRO', '379', '108483', '10', '3748');
INSERT INTO public.who_global_data_import VALUES (34708, '2020-11-05', 'GT', 'Guatemala', 'AMRO', '664', '109147', '4', '3752');
INSERT INTO public.who_global_data_import VALUES (34709, '2020-11-06', 'GT', 'Guatemala', 'AMRO', '702', '109849', '14', '3766');
INSERT INTO public.who_global_data_import VALUES (34710, '2020-11-07', 'GT', 'Guatemala', 'AMRO', '653', '110502', '28', '3794');
INSERT INTO public.who_global_data_import VALUES (34711, '2020-11-08', 'GT', 'Guatemala', 'AMRO', '548', '111050', '17', '3811');
INSERT INTO public.who_global_data_import VALUES (34712, '2020-11-09', 'GT', 'Guatemala', 'AMRO', '212', '111262', '10', '3821');
INSERT INTO public.who_global_data_import VALUES (34713, '2020-11-10', 'GT', 'Guatemala', 'AMRO', '98', '111360', '2', '3823');
INSERT INTO public.who_global_data_import VALUES (34714, '2020-11-11', 'GT', 'Guatemala', 'AMRO', '769', '112129', '9', '3832');
INSERT INTO public.who_global_data_import VALUES (34715, '2020-11-12', 'GT', 'Guatemala', 'AMRO', '682', '112811', '13', '3845');
INSERT INTO public.who_global_data_import VALUES (34716, '2020-11-13', 'GT', 'Guatemala', 'AMRO', '732', '113543', '13', '3858');
INSERT INTO public.who_global_data_import VALUES (34717, '2020-11-14', 'GT', 'Guatemala', 'AMRO', '580', '114123', '22', '3880');
INSERT INTO public.who_global_data_import VALUES (34718, '2020-11-15', 'GT', 'Guatemala', 'AMRO', '596', '114719', '40', '3920');
INSERT INTO public.who_global_data_import VALUES (34719, '2020-11-16', 'GT', 'Guatemala', 'AMRO', '166', '114885', '12', '3932');
INSERT INTO public.who_global_data_import VALUES (34720, '2020-11-17', 'GT', 'Guatemala', 'AMRO', '147', '115032', '6', '3938');
INSERT INTO public.who_global_data_import VALUES (34721, '2020-11-18', 'GT', 'Guatemala', 'AMRO', '698', '115730', '9', '3947');
INSERT INTO public.who_global_data_import VALUES (34722, '2020-11-19', 'GT', 'Guatemala', 'AMRO', '651', '116381', '61', '4008');
INSERT INTO public.who_global_data_import VALUES (34723, '2020-11-20', 'GT', 'Guatemala', 'AMRO', '685', '117066', '42', '4050');
INSERT INTO public.who_global_data_import VALUES (34724, '2020-11-21', 'GT', 'Guatemala', 'AMRO', '691', '117757', '17', '4067');
INSERT INTO public.who_global_data_import VALUES (34725, '2020-11-22', 'GT', 'Guatemala', 'AMRO', '660', '118417', '7', '4074');
INSERT INTO public.who_global_data_import VALUES (34726, '2020-11-23', 'GT', 'Guatemala', 'AMRO', '212', '118629', '2', '4076');
INSERT INTO public.who_global_data_import VALUES (34727, '2020-11-24', 'GT', 'Guatemala', 'AMRO', '93', '118722', '16', '4092');
INSERT INTO public.who_global_data_import VALUES (34728, '2020-11-25', 'GT', 'Guatemala', 'AMRO', '627', '119349', '7', '4099');
INSERT INTO public.who_global_data_import VALUES (34729, '2020-11-26', 'GT', 'Guatemala', 'AMRO', '640', '119989', '8', '4107');
INSERT INTO public.who_global_data_import VALUES (34730, '2020-11-27', 'GT', 'Guatemala', 'AMRO', '696', '120685', '26', '4133');
INSERT INTO public.who_global_data_import VALUES (34731, '2020-11-28', 'GT', 'Guatemala', 'AMRO', '447', '121132', '8', '4141');
INSERT INTO public.who_global_data_import VALUES (34732, '2020-11-29', 'GT', 'Guatemala', 'AMRO', '666', '121798', '20', '4161');
INSERT INTO public.who_global_data_import VALUES (34733, '2020-11-30', 'GT', 'Guatemala', 'AMRO', '173', '121971', '5', '4166');
INSERT INTO public.who_global_data_import VALUES (34734, '2020-12-01', 'GT', 'Guatemala', 'AMRO', '91', '122062', '5', '4171');
INSERT INTO public.who_global_data_import VALUES (34735, '2020-12-02', 'GT', 'Guatemala', 'AMRO', '712', '122774', '7', '4178');
INSERT INTO public.who_global_data_import VALUES (34736, '2020-12-03', 'GT', 'Guatemala', 'AMRO', '686', '123460', '13', '4191');
INSERT INTO public.who_global_data_import VALUES (34737, '2020-12-04', 'GT', 'Guatemala', 'AMRO', '593', '124053', '18', '4209');
INSERT INTO public.who_global_data_import VALUES (34738, '2020-12-05', 'GT', 'Guatemala', 'AMRO', '752', '124805', '15', '4224');
INSERT INTO public.who_global_data_import VALUES (34739, '2020-12-06', 'GT', 'Guatemala', 'AMRO', '547', '125352', '15', '4239');
INSERT INTO public.who_global_data_import VALUES (34740, '2020-12-07', 'GT', 'Guatemala', 'AMRO', '198', '125550', '11', '4250');
INSERT INTO public.who_global_data_import VALUES (34741, '2020-12-08', 'GT', 'Guatemala', 'AMRO', '124', '125674', '24', '4274');
INSERT INTO public.who_global_data_import VALUES (34742, '2020-12-09', 'GT', 'Guatemala', 'AMRO', '799', '126473', '12', '4286');
INSERT INTO public.who_global_data_import VALUES (34743, '2020-12-10', 'GT', 'Guatemala', 'AMRO', '654', '127127', '25', '4311');
INSERT INTO public.who_global_data_import VALUES (34744, '2020-12-11', 'GT', 'Guatemala', 'AMRO', '659', '127786', '34', '4345');
INSERT INTO public.who_global_data_import VALUES (34745, '2020-12-12', 'GT', 'Guatemala', 'AMRO', '755', '128541', '31', '4376');
INSERT INTO public.who_global_data_import VALUES (34746, '2020-12-13', 'GT', 'Guatemala', 'AMRO', '558', '129099', '29', '4405');
INSERT INTO public.who_global_data_import VALUES (34747, '2020-12-14', 'GT', 'Guatemala', 'AMRO', '183', '129282', '18', '4423');
INSERT INTO public.who_global_data_import VALUES (34748, '2020-12-15', 'GT', 'Guatemala', 'AMRO', '123', '129405', '22', '4445');
INSERT INTO public.who_global_data_import VALUES (34749, '2020-12-16', 'GT', 'Guatemala', 'AMRO', '677', '130082', '31', '4476');
INSERT INTO public.who_global_data_import VALUES (34750, '2020-12-17', 'GT', 'Guatemala', 'AMRO', '746', '130828', '34', '4510');
INSERT INTO public.who_global_data_import VALUES (34751, '2020-12-18', 'GT', 'Guatemala', 'AMRO', '607', '131435', '41', '4551');
INSERT INTO public.who_global_data_import VALUES (34752, '2020-12-19', 'GT', 'Guatemala', 'AMRO', '627', '132062', '38', '4589');
INSERT INTO public.who_global_data_import VALUES (34753, '2020-12-20', 'GT', 'Guatemala', 'AMRO', '533', '132595', '35', '4624');
INSERT INTO public.who_global_data_import VALUES (34754, '2020-12-21', 'GT', 'Guatemala', 'AMRO', '170', '132765', '32', '4656');
INSERT INTO public.who_global_data_import VALUES (34755, '2020-12-22', 'GT', 'Guatemala', 'AMRO', '102', '132867', '32', '4688');
INSERT INTO public.who_global_data_import VALUES (34756, '2020-12-23', 'GT', 'Guatemala', 'AMRO', '734', '133601', '30', '4718');
INSERT INTO public.who_global_data_import VALUES (34757, '2020-12-24', 'GT', 'Guatemala', 'AMRO', '655', '134256', '21', '4739');
INSERT INTO public.who_global_data_import VALUES (34758, '2020-12-25', 'GT', 'Guatemala', 'AMRO', '638', '134894', '10', '4749');
INSERT INTO public.who_global_data_import VALUES (34759, '2020-12-26', 'GT', 'Guatemala', 'AMRO', '186', '135080', '8', '4757');
INSERT INTO public.who_global_data_import VALUES (34760, '2020-12-27', 'GT', 'Guatemala', 'AMRO', '91', '135171', '6', '4763');
INSERT INTO public.who_global_data_import VALUES (34761, '2020-12-28', 'GT', 'Guatemala', 'AMRO', '138', '135309', '5', '4768');
INSERT INTO public.who_global_data_import VALUES (34762, '2020-12-29', 'GT', 'Guatemala', 'AMRO', '132', '135441', '5', '4773');
INSERT INTO public.who_global_data_import VALUES (34763, '2020-12-30', 'GT', 'Guatemala', 'AMRO', '846', '136287', '8', '4781');
INSERT INTO public.who_global_data_import VALUES (34764, '2020-12-31', 'GT', 'Guatemala', 'AMRO', '879', '137166', '22', '4803');
INSERT INTO public.who_global_data_import VALUES (34765, '2021-01-01', 'GT', 'Guatemala', 'AMRO', '846', '138012', '10', '4813');
INSERT INTO public.who_global_data_import VALUES (34766, '2021-01-02', 'GT', 'Guatemala', 'AMRO', '224', '138236', '7', '4820');
INSERT INTO public.who_global_data_import VALUES (34767, '2021-01-03', 'GT', 'Guatemala', 'AMRO', '80', '138316', '7', '4827');
INSERT INTO public.who_global_data_import VALUES (34768, '2021-01-04', 'GT', 'Guatemala', 'AMRO', '159', '138475', '6', '4833');
INSERT INTO public.who_global_data_import VALUES (34769, '2021-01-05', 'GT', 'Guatemala', 'AMRO', '181', '138656', '2', '4835');
INSERT INTO public.who_global_data_import VALUES (34770, '2021-01-06', 'GT', 'Guatemala', 'AMRO', '763', '139419', '24', '4859');
INSERT INTO public.who_global_data_import VALUES (34771, '2021-01-07', 'GT', 'Guatemala', 'AMRO', '783', '140202', '40', '4899');
INSERT INTO public.who_global_data_import VALUES (34772, '2021-01-08', 'GT', 'Guatemala', 'AMRO', '872', '141074', '29', '4928');
INSERT INTO public.who_global_data_import VALUES (34773, '2021-01-09', 'GT', 'Guatemala', 'AMRO', '990', '142064', '44', '4972');
INSERT INTO public.who_global_data_import VALUES (34774, '2021-01-10', 'GT', 'Guatemala', 'AMRO', '1063', '143127', '27', '4999');
INSERT INTO public.who_global_data_import VALUES (34775, '2021-01-11', 'GT', 'Guatemala', 'AMRO', '116', '143243', '26', '5025');
INSERT INTO public.who_global_data_import VALUES (34776, '2021-01-12', 'GT', 'Guatemala', 'AMRO', '717', '143960', '0', '5025');
INSERT INTO public.who_global_data_import VALUES (34777, '2021-01-13', 'GT', 'Guatemala', 'AMRO', '1044', '145004', '92', '5117');
INSERT INTO public.who_global_data_import VALUES (34778, '2021-01-14', 'GT', 'Guatemala', 'AMRO', '982', '145986', '0', '5117');
INSERT INTO public.who_global_data_import VALUES (34779, '2021-01-15', 'GT', 'Guatemala', 'AMRO', '951', '146937', '34', '5151');
INSERT INTO public.who_global_data_import VALUES (34780, '2021-01-16', 'GT', 'Guatemala', 'AMRO', '623', '147560', '26', '5177');
INSERT INTO public.who_global_data_import VALUES (34781, '2021-01-17', 'GT', 'Guatemala', 'AMRO', '1038', '148598', '43', '5220');
INSERT INTO public.who_global_data_import VALUES (34782, '2021-01-18', 'GT', 'Guatemala', 'AMRO', '290', '148888', '34', '5254');
INSERT INTO public.who_global_data_import VALUES (34783, '2021-01-19', 'GT', 'Guatemala', 'AMRO', '258', '149146', '24', '5278');
INSERT INTO public.who_global_data_import VALUES (34784, '2021-01-20', 'GT', 'Guatemala', 'AMRO', '1131', '150277', '35', '5313');
INSERT INTO public.who_global_data_import VALUES (34785, '2021-01-21', 'GT', 'Guatemala', 'AMRO', '1047', '151324', '30', '5343');
INSERT INTO public.who_global_data_import VALUES (34786, '2021-01-22', 'GT', 'Guatemala', 'AMRO', '1071', '152395', '46', '5389');
INSERT INTO public.who_global_data_import VALUES (34787, '2021-01-23', 'GT', 'Guatemala', 'AMRO', '561', '152956', '31', '5420');
INSERT INTO public.who_global_data_import VALUES (34788, '2021-01-24', 'GT', 'Guatemala', 'AMRO', '934', '153890', '36', '5456');
INSERT INTO public.who_global_data_import VALUES (34789, '2021-01-25', 'GT', 'Guatemala', 'AMRO', '322', '154212', '9', '5465');
INSERT INTO public.who_global_data_import VALUES (34790, '2021-01-26', 'GT', 'Guatemala', 'AMRO', '218', '154430', '4', '5469');
INSERT INTO public.who_global_data_import VALUES (34791, '2021-01-27', 'GT', 'Guatemala', 'AMRO', '1029', '155459', '17', '5486');
INSERT INTO public.who_global_data_import VALUES (34792, '2021-01-28', 'GT', 'Guatemala', 'AMRO', '1038', '156497', '27', '5513');
INSERT INTO public.who_global_data_import VALUES (34793, '2021-01-29', 'GT', 'Guatemala', 'AMRO', '1098', '157595', '30', '5543');
INSERT INTO public.who_global_data_import VALUES (34794, '2021-01-30', 'GT', 'Guatemala', 'AMRO', '741', '158336', '39', '5582');
INSERT INTO public.who_global_data_import VALUES (34795, '2021-01-31', 'GT', 'Guatemala', 'AMRO', '782', '159118', '36', '5618');
INSERT INTO public.who_global_data_import VALUES (34796, '2021-02-01', 'GT', 'Guatemala', 'AMRO', '386', '159504', '25', '5643');
INSERT INTO public.who_global_data_import VALUES (34797, '2021-02-02', 'GT', 'Guatemala', 'AMRO', '128', '159632', '30', '5673');
INSERT INTO public.who_global_data_import VALUES (34798, '2021-02-03', 'GT', 'Guatemala', 'AMRO', '667', '160299', '36', '5709');
INSERT INTO public.who_global_data_import VALUES (34799, '2021-02-04', 'GT', 'Guatemala', 'AMRO', '667', '160966', '27', '5736');
INSERT INTO public.who_global_data_import VALUES (34800, '2021-02-05', 'GT', 'Guatemala', 'AMRO', '699', '161665', '49', '5785');
INSERT INTO public.who_global_data_import VALUES (34801, '2020-01-03', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34802, '2020-01-04', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34803, '2020-01-05', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34804, '2020-01-06', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34805, '2020-01-07', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34806, '2020-01-08', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34807, '2020-01-09', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34808, '2020-01-10', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34809, '2020-01-11', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34810, '2020-01-12', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34811, '2020-01-13', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34812, '2020-01-14', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34813, '2020-01-15', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34814, '2020-01-16', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34815, '2020-01-17', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34816, '2020-01-18', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34817, '2020-01-19', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34818, '2020-01-20', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34819, '2020-01-21', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34820, '2020-01-22', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34821, '2020-01-23', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34822, '2020-01-24', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34823, '2020-01-25', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34824, '2020-01-26', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34825, '2020-01-27', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34826, '2020-01-28', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34827, '2020-01-29', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34828, '2020-01-30', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34829, '2020-01-31', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34830, '2020-02-01', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34831, '2020-02-02', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34832, '2020-02-03', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34833, '2020-02-04', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34834, '2020-02-05', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34835, '2020-02-06', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34836, '2020-02-07', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34837, '2020-02-08', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34838, '2020-02-09', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34839, '2020-02-10', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34840, '2020-02-11', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34841, '2020-02-12', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34842, '2020-02-13', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34843, '2020-02-14', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34844, '2020-02-15', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34845, '2020-02-16', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34846, '2020-02-17', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34847, '2020-02-18', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34848, '2020-02-19', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34849, '2020-02-20', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34850, '2020-02-21', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34851, '2020-02-22', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34852, '2020-02-23', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34853, '2020-02-24', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34854, '2020-02-25', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34855, '2020-02-26', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34856, '2020-02-27', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34857, '2020-02-28', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34858, '2020-02-29', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34859, '2020-03-01', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34860, '2020-03-02', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34861, '2020-03-03', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34862, '2020-03-04', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34863, '2020-03-05', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34864, '2020-03-06', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34865, '2020-03-07', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34866, '2020-03-08', 'GG', 'Guernsey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34867, '2020-03-09', 'GG', 'Guernsey', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34868, '2020-03-10', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34869, '2020-03-11', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34870, '2020-03-12', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34871, '2020-03-13', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34872, '2020-03-14', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34873, '2020-03-15', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34874, '2020-03-16', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34875, '2020-03-17', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34876, '2020-03-18', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34877, '2020-03-19', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34878, '2020-03-20', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34879, '2020-03-21', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34880, '2020-03-22', 'GG', 'Guernsey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34881, '2020-03-23', 'GG', 'Guernsey', 'EURO', '16', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34882, '2020-03-24', 'GG', 'Guernsey', 'EURO', '3', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34883, '2020-03-25', 'GG', 'Guernsey', 'EURO', '3', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34884, '2020-03-26', 'GG', 'Guernsey', 'EURO', '7', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34885, '2020-03-27', 'GG', 'Guernsey', 'EURO', '4', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34886, '2020-03-28', 'GG', 'Guernsey', 'EURO', '2', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34887, '2020-03-29', 'GG', 'Guernsey', 'EURO', '3', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34888, '2020-03-30', 'GG', 'Guernsey', 'EURO', '6', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (34889, '2020-03-31', 'GG', 'Guernsey', 'EURO', '15', '60', '1', '1');
INSERT INTO public.who_global_data_import VALUES (34890, '2020-04-01', 'GG', 'Guernsey', 'EURO', '0', '60', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34891, '2020-04-02', 'GG', 'Guernsey', 'EURO', '18', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34892, '2020-04-03', 'GG', 'Guernsey', 'EURO', '13', '91', '0', '1');
INSERT INTO public.who_global_data_import VALUES (34893, '2020-04-04', 'GG', 'Guernsey', 'EURO', '23', '114', '1', '2');
INSERT INTO public.who_global_data_import VALUES (34894, '2020-04-05', 'GG', 'Guernsey', 'EURO', '22', '136', '0', '2');
INSERT INTO public.who_global_data_import VALUES (34895, '2020-04-06', 'GG', 'Guernsey', 'EURO', '18', '154', '1', '3');
INSERT INTO public.who_global_data_import VALUES (34896, '2020-04-07', 'GG', 'Guernsey', 'EURO', '0', '154', '0', '3');
INSERT INTO public.who_global_data_import VALUES (34897, '2020-04-08', 'GG', 'Guernsey', 'EURO', '12', '166', '1', '4');
INSERT INTO public.who_global_data_import VALUES (34898, '2020-04-09', 'GG', 'Guernsey', 'EURO', '0', '166', '0', '4');
INSERT INTO public.who_global_data_import VALUES (34899, '2020-04-10', 'GG', 'Guernsey', 'EURO', '15', '181', '1', '5');
INSERT INTO public.who_global_data_import VALUES (34900, '2020-04-11', 'GG', 'Guernsey', 'EURO', '10', '191', '0', '5');
INSERT INTO public.who_global_data_import VALUES (34901, '2020-04-12', 'GG', 'Guernsey', 'EURO', '9', '200', '1', '6');
INSERT INTO public.who_global_data_import VALUES (34902, '2020-04-13', 'GG', 'Guernsey', 'EURO', '9', '209', '0', '6');
INSERT INTO public.who_global_data_import VALUES (34903, '2020-04-14', 'GG', 'Guernsey', 'EURO', '9', '218', '0', '6');
INSERT INTO public.who_global_data_import VALUES (34904, '2020-04-15', 'GG', 'Guernsey', 'EURO', '1', '219', '0', '6');
INSERT INTO public.who_global_data_import VALUES (34905, '2020-04-16', 'GG', 'Guernsey', 'EURO', '4', '223', '1', '7');
INSERT INTO public.who_global_data_import VALUES (34906, '2020-04-17', 'GG', 'Guernsey', 'EURO', '5', '228', '1', '8');
INSERT INTO public.who_global_data_import VALUES (34907, '2020-04-18', 'GG', 'Guernsey', 'EURO', '6', '234', '1', '9');
INSERT INTO public.who_global_data_import VALUES (34908, '2020-04-19', 'GG', 'Guernsey', 'EURO', '2', '236', '0', '9');
INSERT INTO public.who_global_data_import VALUES (34909, '2020-04-20', 'GG', 'Guernsey', 'EURO', '3', '239', '0', '9');
INSERT INTO public.who_global_data_import VALUES (34910, '2020-04-21', 'GG', 'Guernsey', 'EURO', '0', '239', '0', '9');
INSERT INTO public.who_global_data_import VALUES (34911, '2020-04-22', 'GG', 'Guernsey', 'EURO', '0', '239', '1', '10');
INSERT INTO public.who_global_data_import VALUES (34912, '2020-04-23', 'GG', 'Guernsey', 'EURO', '2', '241', '0', '10');
INSERT INTO public.who_global_data_import VALUES (34913, '2020-04-24', 'GG', 'Guernsey', 'EURO', '2', '243', '0', '10');
INSERT INTO public.who_global_data_import VALUES (34914, '2020-04-25', 'GG', 'Guernsey', 'EURO', '2', '245', '0', '10');
INSERT INTO public.who_global_data_import VALUES (34915, '2020-04-26', 'GG', 'Guernsey', 'EURO', '0', '245', '1', '11');
INSERT INTO public.who_global_data_import VALUES (34916, '2020-04-27', 'GG', 'Guernsey', 'EURO', '0', '245', '1', '12');
INSERT INTO public.who_global_data_import VALUES (34917, '2020-04-28', 'GG', 'Guernsey', 'EURO', '2', '247', '1', '13');
INSERT INTO public.who_global_data_import VALUES (34918, '2020-04-29', 'GG', 'Guernsey', 'EURO', '0', '247', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34919, '2020-04-30', 'GG', 'Guernsey', 'EURO', '0', '247', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34920, '2020-05-01', 'GG', 'Guernsey', 'EURO', '4', '251', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34921, '2020-05-02', 'GG', 'Guernsey', 'EURO', '0', '251', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34922, '2020-05-03', 'GG', 'Guernsey', 'EURO', '1', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34923, '2020-05-04', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34924, '2020-05-05', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34925, '2020-05-06', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34926, '2020-05-07', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34927, '2020-05-08', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34928, '2020-05-09', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34929, '2020-05-10', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34930, '2020-05-11', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34931, '2020-05-12', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34932, '2020-05-13', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34933, '2020-05-14', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34934, '2020-05-15', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34935, '2020-05-16', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34936, '2020-05-17', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34937, '2020-05-18', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34938, '2020-05-19', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34939, '2020-05-20', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34940, '2020-05-21', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34941, '2020-05-22', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34942, '2020-05-23', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34943, '2020-05-24', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34944, '2020-05-25', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34945, '2020-05-26', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34946, '2020-05-27', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34947, '2020-05-28', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34948, '2020-05-29', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34949, '2020-05-30', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34950, '2020-05-31', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34951, '2020-06-01', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34952, '2020-06-02', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34953, '2020-06-03', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34954, '2020-06-04', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34955, '2020-06-05', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34956, '2020-06-06', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34957, '2020-06-07', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34958, '2020-06-08', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34959, '2020-06-09', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34960, '2020-06-10', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34961, '2020-06-11', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34962, '2020-06-12', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34963, '2020-06-13', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34964, '2020-06-14', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34965, '2020-06-15', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34966, '2020-06-16', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34967, '2020-06-17', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34968, '2020-06-18', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34969, '2020-06-19', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34970, '2020-06-20', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34971, '2020-06-21', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34972, '2020-06-22', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34973, '2020-06-23', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34974, '2020-06-24', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34975, '2020-06-25', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34976, '2020-06-26', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34977, '2020-06-27', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34978, '2020-06-28', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34979, '2020-06-29', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34980, '2020-06-30', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34981, '2020-07-01', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34982, '2020-07-02', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34983, '2020-07-03', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34984, '2020-07-04', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34985, '2020-07-05', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34986, '2020-07-06', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34987, '2020-07-07', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34988, '2020-07-08', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34989, '2020-07-09', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34990, '2020-07-10', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34991, '2020-07-11', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34992, '2020-07-12', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34993, '2020-07-13', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34994, '2020-07-14', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34995, '2020-07-15', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34996, '2020-07-16', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34997, '2020-07-17', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34998, '2020-07-18', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (34999, '2020-07-19', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35000, '2020-07-20', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35001, '2020-07-21', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35002, '2020-07-22', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35003, '2020-07-23', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35004, '2020-07-24', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35005, '2020-07-25', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35006, '2020-07-26', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35007, '2020-07-27', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35008, '2020-07-28', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35009, '2020-07-29', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35010, '2020-07-30', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35011, '2020-07-31', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35012, '2020-08-01', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35013, '2020-08-02', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35014, '2020-08-03', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35015, '2020-08-04', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35016, '2020-08-05', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35017, '2020-08-06', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35018, '2020-08-07', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35019, '2020-08-08', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35020, '2020-08-09', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35021, '2020-08-10', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35022, '2020-08-11', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35023, '2020-08-12', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35024, '2020-08-13', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35025, '2020-08-14', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35026, '2020-08-15', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35027, '2020-08-16', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35028, '2020-08-17', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35029, '2020-08-18', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35030, '2020-08-19', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35031, '2020-08-20', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35032, '2020-08-21', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35033, '2020-08-22', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35034, '2020-08-23', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35035, '2020-08-24', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35036, '2020-08-25', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35037, '2020-08-26', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35038, '2020-08-27', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35039, '2020-08-28', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35040, '2020-08-29', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35041, '2020-08-30', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35042, '2020-08-31', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35043, '2020-09-01', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35044, '2020-09-02', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35045, '2020-09-03', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35046, '2020-09-04', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35047, '2020-09-05', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35048, '2020-09-06', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35049, '2020-09-07', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35050, '2020-09-08', 'GG', 'Guernsey', 'EURO', '0', '252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35051, '2020-09-09', 'GG', 'Guernsey', 'EURO', '1', '253', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35052, '2020-09-10', 'GG', 'Guernsey', 'EURO', '0', '253', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35053, '2020-09-11', 'GG', 'Guernsey', 'EURO', '0', '253', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35054, '2020-09-12', 'GG', 'Guernsey', 'EURO', '0', '253', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35055, '2020-09-13', 'GG', 'Guernsey', 'EURO', '0', '253', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35056, '2020-09-14', 'GG', 'Guernsey', 'EURO', '0', '253', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35057, '2020-09-15', 'GG', 'Guernsey', 'EURO', '0', '253', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35058, '2020-09-16', 'GG', 'Guernsey', 'EURO', '0', '253', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35059, '2020-09-17', 'GG', 'Guernsey', 'EURO', '0', '253', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35060, '2020-09-18', 'GG', 'Guernsey', 'EURO', '0', '253', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35061, '2020-09-19', 'GG', 'Guernsey', 'EURO', '0', '253', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35062, '2020-09-20', 'GG', 'Guernsey', 'EURO', '1', '254', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35063, '2020-09-21', 'GG', 'Guernsey', 'EURO', '0', '254', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35064, '2020-09-22', 'GG', 'Guernsey', 'EURO', '2', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35065, '2020-09-23', 'GG', 'Guernsey', 'EURO', '0', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35066, '2020-09-24', 'GG', 'Guernsey', 'EURO', '0', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35067, '2020-09-25', 'GG', 'Guernsey', 'EURO', '0', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35068, '2020-09-26', 'GG', 'Guernsey', 'EURO', '0', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35069, '2020-09-27', 'GG', 'Guernsey', 'EURO', '0', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35070, '2020-09-28', 'GG', 'Guernsey', 'EURO', '0', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35071, '2020-09-29', 'GG', 'Guernsey', 'EURO', '0', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35072, '2020-09-30', 'GG', 'Guernsey', 'EURO', '0', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35073, '2020-10-01', 'GG', 'Guernsey', 'EURO', '0', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35074, '2020-10-02', 'GG', 'Guernsey', 'EURO', '0', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35075, '2020-10-03', 'GG', 'Guernsey', 'EURO', '0', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35076, '2020-10-04', 'GG', 'Guernsey', 'EURO', '0', '256', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35077, '2020-10-05', 'GG', 'Guernsey', 'EURO', '1', '257', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35078, '2020-10-06', 'GG', 'Guernsey', 'EURO', '0', '257', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35079, '2020-10-07', 'GG', 'Guernsey', 'EURO', '0', '257', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35080, '2020-10-08', 'GG', 'Guernsey', 'EURO', '0', '257', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35081, '2020-10-09', 'GG', 'Guernsey', 'EURO', '1', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35082, '2020-10-10', 'GG', 'Guernsey', 'EURO', '0', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35083, '2020-10-11', 'GG', 'Guernsey', 'EURO', '0', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35084, '2020-10-12', 'GG', 'Guernsey', 'EURO', '0', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35085, '2020-10-13', 'GG', 'Guernsey', 'EURO', '0', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35086, '2020-10-14', 'GG', 'Guernsey', 'EURO', '0', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35087, '2020-10-15', 'GG', 'Guernsey', 'EURO', '0', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35088, '2020-10-16', 'GG', 'Guernsey', 'EURO', '0', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35089, '2020-10-17', 'GG', 'Guernsey', 'EURO', '0', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35090, '2020-10-18', 'GG', 'Guernsey', 'EURO', '0', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35091, '2020-10-19', 'GG', 'Guernsey', 'EURO', '0', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35092, '2020-10-20', 'GG', 'Guernsey', 'EURO', '0', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35093, '2020-10-21', 'GG', 'Guernsey', 'EURO', '0', '258', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35094, '2020-10-22', 'GG', 'Guernsey', 'EURO', '2', '260', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35095, '2020-10-23', 'GG', 'Guernsey', 'EURO', '0', '260', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35096, '2020-10-24', 'GG', 'Guernsey', 'EURO', '5', '265', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35097, '2020-10-25', 'GG', 'Guernsey', 'EURO', '0', '265', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35098, '2020-10-26', 'GG', 'Guernsey', 'EURO', '0', '265', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35099, '2020-10-27', 'GG', 'Guernsey', 'EURO', '1', '266', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35100, '2020-10-28', 'GG', 'Guernsey', 'EURO', '0', '266', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35101, '2020-10-29', 'GG', 'Guernsey', 'EURO', '0', '266', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35102, '2020-10-30', 'GG', 'Guernsey', 'EURO', '1', '267', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35103, '2020-10-31', 'GG', 'Guernsey', 'EURO', '0', '267', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35104, '2020-11-01', 'GG', 'Guernsey', 'EURO', '0', '267', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35105, '2020-11-02', 'GG', 'Guernsey', 'EURO', '1', '268', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35106, '2020-11-03', 'GG', 'Guernsey', 'EURO', '2', '270', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35107, '2020-11-04', 'GG', 'Guernsey', 'EURO', '1', '271', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35108, '2020-11-05', 'GG', 'Guernsey', 'EURO', '1', '272', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35109, '2020-11-06', 'GG', 'Guernsey', 'EURO', '1', '273', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35110, '2020-11-07', 'GG', 'Guernsey', 'EURO', '1', '274', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35111, '2020-11-08', 'GG', 'Guernsey', 'EURO', '4', '278', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35112, '2020-11-09', 'GG', 'Guernsey', 'EURO', '1', '279', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35113, '2020-11-10', 'GG', 'Guernsey', 'EURO', '0', '279', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35114, '2020-11-11', 'GG', 'Guernsey', 'EURO', '0', '279', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35115, '2020-11-12', 'GG', 'Guernsey', 'EURO', '3', '282', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35116, '2020-11-13', 'GG', 'Guernsey', 'EURO', '0', '282', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35117, '2020-11-14', 'GG', 'Guernsey', 'EURO', '0', '282', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35118, '2020-11-15', 'GG', 'Guernsey', 'EURO', '0', '282', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35119, '2020-11-16', 'GG', 'Guernsey', 'EURO', '0', '282', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35120, '2020-11-17', 'GG', 'Guernsey', 'EURO', '0', '282', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35121, '2020-11-18', 'GG', 'Guernsey', 'EURO', '0', '282', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35122, '2020-11-19', 'GG', 'Guernsey', 'EURO', '0', '282', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35123, '2020-11-20', 'GG', 'Guernsey', 'EURO', '0', '282', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35124, '2020-11-21', 'GG', 'Guernsey', 'EURO', '0', '282', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35125, '2020-11-22', 'GG', 'Guernsey', 'EURO', '1', '283', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35126, '2020-11-23', 'GG', 'Guernsey', 'EURO', '0', '283', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35127, '2020-11-24', 'GG', 'Guernsey', 'EURO', '0', '283', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35128, '2020-11-25', 'GG', 'Guernsey', 'EURO', '0', '283', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35129, '2020-11-26', 'GG', 'Guernsey', 'EURO', '0', '283', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35130, '2020-11-27', 'GG', 'Guernsey', 'EURO', '2', '285', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35131, '2020-11-28', 'GG', 'Guernsey', 'EURO', '1', '286', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35132, '2020-11-29', 'GG', 'Guernsey', 'EURO', '0', '286', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35133, '2020-11-30', 'GG', 'Guernsey', 'EURO', '0', '286', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35134, '2020-12-01', 'GG', 'Guernsey', 'EURO', '0', '286', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35135, '2020-12-02', 'GG', 'Guernsey', 'EURO', '1', '287', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35136, '2020-12-03', 'GG', 'Guernsey', 'EURO', '0', '287', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35137, '2020-12-04', 'GG', 'Guernsey', 'EURO', '0', '287', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35138, '2020-12-05', 'GG', 'Guernsey', 'EURO', '1', '288', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35139, '2020-12-06', 'GG', 'Guernsey', 'EURO', '0', '288', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35140, '2020-12-07', 'GG', 'Guernsey', 'EURO', '0', '288', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35141, '2020-12-08', 'GG', 'Guernsey', 'EURO', '0', '288', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35142, '2020-12-09', 'GG', 'Guernsey', 'EURO', '0', '288', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35143, '2020-12-10', 'GG', 'Guernsey', 'EURO', '0', '288', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35144, '2020-12-11', 'GG', 'Guernsey', 'EURO', '1', '289', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35145, '2020-12-12', 'GG', 'Guernsey', 'EURO', '0', '289', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35146, '2020-12-13', 'GG', 'Guernsey', 'EURO', '0', '289', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35147, '2020-12-14', 'GG', 'Guernsey', 'EURO', '0', '289', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35148, '2020-12-15', 'GG', 'Guernsey', 'EURO', '0', '289', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35149, '2020-12-16', 'GG', 'Guernsey', 'EURO', '2', '291', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35150, '2020-12-17', 'GG', 'Guernsey', 'EURO', '0', '291', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35151, '2020-12-18', 'GG', 'Guernsey', 'EURO', '0', '291', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35152, '2020-12-19', 'GG', 'Guernsey', 'EURO', '0', '291', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35153, '2020-12-20', 'GG', 'Guernsey', 'EURO', '0', '291', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35154, '2020-12-21', 'GG', 'Guernsey', 'EURO', '1', '292', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35155, '2020-12-22', 'GG', 'Guernsey', 'EURO', '1', '293', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35156, '2020-12-23', 'GG', 'Guernsey', 'EURO', '0', '293', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35157, '2020-12-24', 'GG', 'Guernsey', 'EURO', '0', '293', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35158, '2020-12-25', 'GG', 'Guernsey', 'EURO', '4', '297', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35159, '2020-12-26', 'GG', 'Guernsey', 'EURO', '0', '297', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35160, '2020-12-27', 'GG', 'Guernsey', 'EURO', '0', '297', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35161, '2020-12-28', 'GG', 'Guernsey', 'EURO', '0', '297', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35162, '2020-12-29', 'GG', 'Guernsey', 'EURO', '0', '297', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35163, '2020-12-30', 'GG', 'Guernsey', 'EURO', '0', '297', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35164, '2020-12-31', 'GG', 'Guernsey', 'EURO', '0', '297', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35165, '2021-01-01', 'GG', 'Guernsey', 'EURO', '1', '298', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35166, '2021-01-02', 'GG', 'Guernsey', 'EURO', '0', '298', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35167, '2021-01-03', 'GG', 'Guernsey', 'EURO', '1', '299', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35168, '2021-01-04', 'GG', 'Guernsey', 'EURO', '0', '299', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35169, '2021-01-05', 'GG', 'Guernsey', 'EURO', '1', '300', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35170, '2021-01-06', 'GG', 'Guernsey', 'EURO', '0', '300', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35171, '2021-01-07', 'GG', 'Guernsey', 'EURO', '1', '301', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35172, '2021-01-08', 'GG', 'Guernsey', 'EURO', '1', '302', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35173, '2021-01-09', 'GG', 'Guernsey', 'EURO', '0', '302', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35174, '2021-01-10', 'GG', 'Guernsey', 'EURO', '0', '302', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35175, '2021-01-11', 'GG', 'Guernsey', 'EURO', '2', '304', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35176, '2021-01-12', 'GG', 'Guernsey', 'EURO', '1', '305', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35177, '2021-01-13', 'GG', 'Guernsey', 'EURO', '1', '306', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35178, '2021-01-14', 'GG', 'Guernsey', 'EURO', '1', '307', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35179, '2021-01-15', 'GG', 'Guernsey', 'EURO', '1', '308', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35180, '2021-01-16', 'GG', 'Guernsey', 'EURO', '0', '308', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35181, '2021-01-17', 'GG', 'Guernsey', 'EURO', '1', '309', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35182, '2021-01-18', 'GG', 'Guernsey', 'EURO', '0', '309', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35183, '2021-01-19', 'GG', 'Guernsey', 'EURO', '0', '309', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35184, '2021-01-20', 'GG', 'Guernsey', 'EURO', '0', '309', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35185, '2021-01-21', 'GG', 'Guernsey', 'EURO', '0', '309', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35186, '2021-01-22', 'GG', 'Guernsey', 'EURO', '1', '310', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35187, '2021-01-23', 'GG', 'Guernsey', 'EURO', '0', '310', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35188, '2021-01-24', 'GG', 'Guernsey', 'EURO', '0', '310', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35189, '2021-01-25', 'GG', 'Guernsey', 'EURO', '4', '314', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35190, '2021-01-26', 'GG', 'Guernsey', 'EURO', '7', '321', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35191, '2021-01-27', 'GG', 'Guernsey', 'EURO', '38', '359', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35192, '2021-01-28', 'GG', 'Guernsey', 'EURO', '10', '369', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35193, '2021-01-29', 'GG', 'Guernsey', 'EURO', '22', '391', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35194, '2021-01-30', 'GG', 'Guernsey', 'EURO', '23', '414', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35195, '2021-01-31', 'GG', 'Guernsey', 'EURO', '35', '449', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35196, '2021-02-01', 'GG', 'Guernsey', 'EURO', '44', '493', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35197, '2021-02-02', 'GG', 'Guernsey', 'EURO', '46', '539', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35198, '2021-02-03', 'GG', 'Guernsey', 'EURO', '46', '585', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35199, '2021-02-04', 'GG', 'Guernsey', 'EURO', '30', '615', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35200, '2021-02-05', 'GG', 'Guernsey', 'EURO', '36', '651', '0', '13');
INSERT INTO public.who_global_data_import VALUES (35201, '2020-01-03', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35202, '2020-01-04', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35203, '2020-01-05', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35204, '2020-01-06', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35205, '2020-01-07', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35206, '2020-01-08', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35207, '2020-01-09', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35208, '2020-01-10', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35209, '2020-01-11', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35210, '2020-01-12', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35211, '2020-01-13', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35212, '2020-01-14', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35213, '2020-01-15', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35214, '2020-01-16', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35215, '2020-01-17', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35216, '2020-01-18', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35217, '2020-01-19', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35218, '2020-01-20', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35219, '2020-01-21', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35220, '2020-01-22', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35221, '2020-01-23', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35222, '2020-01-24', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35223, '2020-01-25', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35224, '2020-01-26', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35225, '2020-01-27', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35226, '2020-01-28', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35227, '2020-01-29', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35228, '2020-01-30', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35229, '2020-01-31', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35230, '2020-02-01', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35231, '2020-02-02', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35232, '2020-02-03', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35233, '2020-02-04', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35234, '2020-02-05', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35235, '2020-02-06', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35236, '2020-02-07', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35237, '2020-02-08', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35238, '2020-02-09', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35239, '2020-02-10', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35240, '2020-02-11', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35241, '2020-02-12', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35242, '2020-02-13', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35243, '2020-02-14', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35244, '2020-02-15', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35245, '2020-02-16', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35246, '2020-02-17', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35247, '2020-02-18', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35248, '2020-02-19', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35249, '2020-02-20', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35250, '2020-02-21', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35251, '2020-02-22', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35252, '2020-02-23', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35253, '2020-02-24', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35254, '2020-02-25', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35255, '2020-02-26', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35256, '2020-02-27', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35257, '2020-02-28', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35258, '2020-02-29', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35259, '2020-03-01', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35260, '2020-03-02', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35261, '2020-03-03', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35262, '2020-03-04', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35263, '2020-03-05', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35264, '2020-03-06', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35265, '2020-03-07', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35266, '2020-03-08', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35267, '2020-03-09', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35268, '2020-03-10', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35269, '2020-03-11', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35270, '2020-03-12', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35271, '2020-03-13', 'GN', 'Guinea', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35272, '2020-03-14', 'GN', 'Guinea', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35273, '2020-03-15', 'GN', 'Guinea', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35274, '2020-03-16', 'GN', 'Guinea', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35275, '2020-03-17', 'GN', 'Guinea', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35276, '2020-03-18', 'GN', 'Guinea', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35277, '2020-03-19', 'GN', 'Guinea', 'AFRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35278, '2020-03-20', 'GN', 'Guinea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35279, '2020-03-21', 'GN', 'Guinea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35280, '2020-03-22', 'GN', 'Guinea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35281, '2020-03-23', 'GN', 'Guinea', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35282, '2020-03-24', 'GN', 'Guinea', 'AFRO', '-2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35283, '2020-03-25', 'GN', 'Guinea', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35284, '2020-03-26', 'GN', 'Guinea', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35285, '2020-03-27', 'GN', 'Guinea', 'AFRO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35286, '2020-03-28', 'GN', 'Guinea', 'AFRO', '3', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35287, '2020-03-29', 'GN', 'Guinea', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35288, '2020-03-30', 'GN', 'Guinea', 'AFRO', '8', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35289, '2020-03-31', 'GN', 'Guinea', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35290, '2020-04-01', 'GN', 'Guinea', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35291, '2020-04-02', 'GN', 'Guinea', 'AFRO', '14', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35292, '2020-04-03', 'GN', 'Guinea', 'AFRO', '22', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35293, '2020-04-04', 'GN', 'Guinea', 'AFRO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35294, '2020-04-05', 'GN', 'Guinea', 'AFRO', '59', '111', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35295, '2020-04-06', 'GN', 'Guinea', 'AFRO', '0', '111', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35296, '2020-04-07', 'GN', 'Guinea', 'AFRO', '0', '111', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35297, '2020-04-08', 'GN', 'Guinea', 'AFRO', '33', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35298, '2020-04-09', 'GN', 'Guinea', 'AFRO', '20', '164', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35299, '2020-04-10', 'GN', 'Guinea', 'AFRO', '30', '194', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35300, '2020-04-11', 'GN', 'Guinea', 'AFRO', '0', '194', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35301, '2020-04-12', 'GN', 'Guinea', 'AFRO', '56', '250', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35302, '2020-04-13', 'GN', 'Guinea', 'AFRO', '0', '250', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35303, '2020-04-14', 'GN', 'Guinea', 'AFRO', '69', '319', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35304, '2020-04-15', 'GN', 'Guinea', 'AFRO', '44', '363', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35305, '2020-04-16', 'GN', 'Guinea', 'AFRO', '41', '404', '1', '1');
INSERT INTO public.who_global_data_import VALUES (35306, '2020-04-17', 'GN', 'Guinea', 'AFRO', '34', '438', '0', '1');
INSERT INTO public.who_global_data_import VALUES (35307, '2020-04-18', 'GN', 'Guinea', 'AFRO', '0', '438', '0', '1');
INSERT INTO public.who_global_data_import VALUES (35308, '2020-04-19', 'GN', 'Guinea', 'AFRO', '39', '477', '2', '3');
INSERT INTO public.who_global_data_import VALUES (35309, '2020-04-20', 'GN', 'Guinea', 'AFRO', '0', '477', '0', '3');
INSERT INTO public.who_global_data_import VALUES (35310, '2020-04-21', 'GN', 'Guinea', 'AFRO', '145', '622', '2', '5');
INSERT INTO public.who_global_data_import VALUES (35311, '2020-04-22', 'GN', 'Guinea', 'AFRO', '66', '688', '1', '6');
INSERT INTO public.who_global_data_import VALUES (35312, '2020-04-23', 'GN', 'Guinea', 'AFRO', '73', '761', '0', '6');
INSERT INTO public.who_global_data_import VALUES (35313, '2020-04-24', 'GN', 'Guinea', 'AFRO', '101', '862', '0', '6');
INSERT INTO public.who_global_data_import VALUES (35314, '2020-04-25', 'GN', 'Guinea', 'AFRO', '92', '954', '0', '6');
INSERT INTO public.who_global_data_import VALUES (35315, '2020-04-26', 'GN', 'Guinea', 'AFRO', '42', '996', '1', '7');
INSERT INTO public.who_global_data_import VALUES (35316, '2020-04-27', 'GN', 'Guinea', 'AFRO', '98', '1094', '0', '7');
INSERT INTO public.who_global_data_import VALUES (35317, '2020-04-28', 'GN', 'Guinea', 'AFRO', '69', '1163', '0', '7');
INSERT INTO public.who_global_data_import VALUES (35318, '2020-04-29', 'GN', 'Guinea', 'AFRO', '77', '1240', '0', '7');
INSERT INTO public.who_global_data_import VALUES (35319, '2020-04-30', 'GN', 'Guinea', 'AFRO', '111', '1351', '0', '7');
INSERT INTO public.who_global_data_import VALUES (35320, '2020-05-01', 'GN', 'Guinea', 'AFRO', '144', '1495', '0', '7');
INSERT INTO public.who_global_data_import VALUES (35321, '2020-05-02', 'GN', 'Guinea', 'AFRO', '42', '1537', '0', '7');
INSERT INTO public.who_global_data_import VALUES (35322, '2020-05-03', 'GN', 'Guinea', 'AFRO', '49', '1586', '0', '7');
INSERT INTO public.who_global_data_import VALUES (35323, '2020-05-04', 'GN', 'Guinea', 'AFRO', '64', '1650', '0', '7');
INSERT INTO public.who_global_data_import VALUES (35324, '2020-05-05', 'GN', 'Guinea', 'AFRO', '60', '1710', '2', '9');
INSERT INTO public.who_global_data_import VALUES (35325, '2020-05-06', 'GN', 'Guinea', 'AFRO', '101', '1811', '1', '10');
INSERT INTO public.who_global_data_import VALUES (35326, '2020-05-07', 'GN', 'Guinea', 'AFRO', '45', '1856', '1', '11');
INSERT INTO public.who_global_data_import VALUES (35327, '2020-05-08', 'GN', 'Guinea', 'AFRO', '71', '1927', '0', '11');
INSERT INTO public.who_global_data_import VALUES (35328, '2020-05-09', 'GN', 'Guinea', 'AFRO', '82', '2009', '0', '11');
INSERT INTO public.who_global_data_import VALUES (35329, '2020-05-10', 'GN', 'Guinea', 'AFRO', '33', '2042', '0', '11');
INSERT INTO public.who_global_data_import VALUES (35330, '2020-05-11', 'GN', 'Guinea', 'AFRO', '104', '2146', '0', '11');
INSERT INTO public.who_global_data_import VALUES (35331, '2020-05-12', 'GN', 'Guinea', 'AFRO', '0', '2146', '0', '11');
INSERT INTO public.who_global_data_import VALUES (35332, '2020-05-13', 'GN', 'Guinea', 'AFRO', '152', '2298', '0', '11');
INSERT INTO public.who_global_data_import VALUES (35333, '2020-05-14', 'GN', 'Guinea', 'AFRO', '74', '2372', '3', '14');
INSERT INTO public.who_global_data_import VALUES (35334, '2020-05-15', 'GN', 'Guinea', 'AFRO', '101', '2473', '0', '14');
INSERT INTO public.who_global_data_import VALUES (35335, '2020-05-16', 'GN', 'Guinea', 'AFRO', '58', '2531', '1', '15');
INSERT INTO public.who_global_data_import VALUES (35336, '2020-05-17', 'GN', 'Guinea', 'AFRO', '127', '2658', '1', '16');
INSERT INTO public.who_global_data_import VALUES (35337, '2020-05-18', 'GN', 'Guinea', 'AFRO', '69', '2727', '0', '16');
INSERT INTO public.who_global_data_import VALUES (35338, '2020-05-19', 'GN', 'Guinea', 'AFRO', '69', '2796', '0', '16');
INSERT INTO public.who_global_data_import VALUES (35339, '2020-05-20', 'GN', 'Guinea', 'AFRO', '67', '2863', '2', '18');
INSERT INTO public.who_global_data_import VALUES (35340, '2020-05-21', 'GN', 'Guinea', 'AFRO', '64', '2927', '1', '19');
INSERT INTO public.who_global_data_import VALUES (35341, '2020-05-22', 'GN', 'Guinea', 'AFRO', '140', '3067', '0', '19');
INSERT INTO public.who_global_data_import VALUES (35342, '2020-05-23', 'GN', 'Guinea', 'AFRO', '47', '3114', '0', '19');
INSERT INTO public.who_global_data_import VALUES (35343, '2020-05-24', 'GN', 'Guinea', 'AFRO', '62', '3176', '1', '20');
INSERT INTO public.who_global_data_import VALUES (35344, '2020-05-25', 'GN', 'Guinea', 'AFRO', '99', '3275', '0', '20');
INSERT INTO public.who_global_data_import VALUES (35345, '2020-05-26', 'GN', 'Guinea', 'AFRO', '47', '3322', '0', '20');
INSERT INTO public.who_global_data_import VALUES (35346, '2020-05-27', 'GN', 'Guinea', 'AFRO', '36', '3358', '0', '20');
INSERT INTO public.who_global_data_import VALUES (35347, '2020-05-28', 'GN', 'Guinea', 'AFRO', '88', '3446', '1', '21');
INSERT INTO public.who_global_data_import VALUES (35348, '2020-05-29', 'GN', 'Guinea', 'AFRO', '107', '3553', '1', '22');
INSERT INTO public.who_global_data_import VALUES (35349, '2020-05-30', 'GN', 'Guinea', 'AFRO', '103', '3656', '0', '22');
INSERT INTO public.who_global_data_import VALUES (35350, '2020-05-31', 'GN', 'Guinea', 'AFRO', '50', '3706', '1', '23');
INSERT INTO public.who_global_data_import VALUES (35351, '2020-06-01', 'GN', 'Guinea', 'AFRO', '65', '3771', '0', '23');
INSERT INTO public.who_global_data_import VALUES (35352, '2020-06-02', 'GN', 'Guinea', 'AFRO', '73', '3844', '0', '23');
INSERT INTO public.who_global_data_import VALUES (35353, '2020-06-03', 'GN', 'Guinea', 'AFRO', '42', '3886', '0', '23');
INSERT INTO public.who_global_data_import VALUES (35354, '2020-06-04', 'GN', 'Guinea', 'AFRO', '47', '3933', '0', '23');
INSERT INTO public.who_global_data_import VALUES (35355, '2020-06-05', 'GN', 'Guinea', 'AFRO', '58', '3991', '0', '23');
INSERT INTO public.who_global_data_import VALUES (35356, '2020-06-06', 'GN', 'Guinea', 'AFRO', '69', '4060', '0', '23');
INSERT INTO public.who_global_data_import VALUES (35357, '2020-06-07', 'GN', 'Guinea', 'AFRO', '57', '4117', '0', '23');
INSERT INTO public.who_global_data_import VALUES (35358, '2020-06-08', 'GN', 'Guinea', 'AFRO', '48', '4165', '0', '23');
INSERT INTO public.who_global_data_import VALUES (35359, '2020-06-09', 'GN', 'Guinea', 'AFRO', '51', '4216', '0', '23');
INSERT INTO public.who_global_data_import VALUES (35360, '2020-06-10', 'GN', 'Guinea', 'AFRO', '42', '4258', '0', '23');
INSERT INTO public.who_global_data_import VALUES (35361, '2020-06-11', 'GN', 'Guinea', 'AFRO', '33', '4291', '0', '23');
INSERT INTO public.who_global_data_import VALUES (35362, '2020-06-12', 'GN', 'Guinea', 'AFRO', '81', '4372', '0', '23');
INSERT INTO public.who_global_data_import VALUES (35363, '2020-06-13', 'GN', 'Guinea', 'AFRO', '54', '4426', '1', '24');
INSERT INTO public.who_global_data_import VALUES (35364, '2020-06-14', 'GN', 'Guinea', 'AFRO', '58', '4484', '1', '25');
INSERT INTO public.who_global_data_import VALUES (35365, '2020-06-15', 'GN', 'Guinea', 'AFRO', '50', '4534', '0', '25');
INSERT INTO public.who_global_data_import VALUES (35366, '2020-06-16', 'GN', 'Guinea', 'AFRO', '38', '4572', '1', '26');
INSERT INTO public.who_global_data_import VALUES (35367, '2020-06-17', 'GN', 'Guinea', 'AFRO', '67', '4639', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35368, '2020-06-18', 'GN', 'Guinea', 'AFRO', '29', '4668', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35369, '2020-06-19', 'GN', 'Guinea', 'AFRO', '173', '4841', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35370, '2020-06-20', 'GN', 'Guinea', 'AFRO', '63', '4904', '1', '27');
INSERT INTO public.who_global_data_import VALUES (35371, '2020-06-21', 'GN', 'Guinea', 'AFRO', '56', '4960', '0', '27');
INSERT INTO public.who_global_data_import VALUES (35372, '2020-06-22', 'GN', 'Guinea', 'AFRO', '28', '4988', '0', '27');
INSERT INTO public.who_global_data_import VALUES (35373, '2020-06-23', 'GN', 'Guinea', 'AFRO', '0', '4988', '0', '27');
INSERT INTO public.who_global_data_import VALUES (35374, '2020-06-24', 'GN', 'Guinea', 'AFRO', '116', '5104', '2', '29');
INSERT INTO public.who_global_data_import VALUES (35375, '2020-06-25', 'GN', 'Guinea', 'AFRO', '70', '5174', '0', '29');
INSERT INTO public.who_global_data_import VALUES (35376, '2020-06-26', 'GN', 'Guinea', 'AFRO', '37', '5211', '0', '29');
INSERT INTO public.who_global_data_import VALUES (35377, '2020-06-27', 'GN', 'Guinea', 'AFRO', '49', '5260', '0', '29');
INSERT INTO public.who_global_data_import VALUES (35378, '2020-06-28', 'GN', 'Guinea', 'AFRO', '31', '5291', '1', '30');
INSERT INTO public.who_global_data_import VALUES (35379, '2020-06-29', 'GN', 'Guinea', 'AFRO', '51', '5342', '1', '31');
INSERT INTO public.who_global_data_import VALUES (35380, '2020-06-30', 'GN', 'Guinea', 'AFRO', '9', '5351', '0', '31');
INSERT INTO public.who_global_data_import VALUES (35381, '2020-07-01', 'GN', 'Guinea', 'AFRO', '40', '5391', '2', '33');
INSERT INTO public.who_global_data_import VALUES (35382, '2020-07-02', 'GN', 'Guinea', 'AFRO', '13', '5404', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35383, '2020-07-03', 'GN', 'Guinea', 'AFRO', '46', '5450', '13', '46');
INSERT INTO public.who_global_data_import VALUES (35384, '2020-07-04', 'GN', 'Guinea', 'AFRO', '71', '5521', '-13', '33');
INSERT INTO public.who_global_data_import VALUES (35385, '2020-07-05', 'GN', 'Guinea', 'AFRO', '49', '5570', '1', '34');
INSERT INTO public.who_global_data_import VALUES (35386, '2020-07-06', 'GN', 'Guinea', 'AFRO', '40', '5610', '0', '34');
INSERT INTO public.who_global_data_import VALUES (35387, '2020-07-07', 'GN', 'Guinea', 'AFRO', '0', '5610', '0', '34');
INSERT INTO public.who_global_data_import VALUES (35388, '2020-07-08', 'GN', 'Guinea', 'AFRO', '26', '5636', '0', '34');
INSERT INTO public.who_global_data_import VALUES (35389, '2020-07-09', 'GN', 'Guinea', 'AFRO', '61', '5697', '0', '34');
INSERT INTO public.who_global_data_import VALUES (35390, '2020-07-10', 'GN', 'Guinea', 'AFRO', '184', '5881', '2', '36');
INSERT INTO public.who_global_data_import VALUES (35391, '2020-07-11', 'GN', 'Guinea', 'AFRO', '88', '5969', '1', '37');
INSERT INTO public.who_global_data_import VALUES (35392, '2020-07-12', 'GN', 'Guinea', 'AFRO', '75', '6044', '0', '37');
INSERT INTO public.who_global_data_import VALUES (35393, '2020-07-13', 'GN', 'Guinea', 'AFRO', '97', '6141', '0', '37');
INSERT INTO public.who_global_data_import VALUES (35394, '2020-07-14', 'GN', 'Guinea', 'AFRO', '29', '6170', '1', '38');
INSERT INTO public.who_global_data_import VALUES (35395, '2020-07-15', 'GN', 'Guinea', 'AFRO', '30', '6200', '0', '38');
INSERT INTO public.who_global_data_import VALUES (35396, '2020-07-16', 'GN', 'Guinea', 'AFRO', '76', '6276', '0', '38');
INSERT INTO public.who_global_data_import VALUES (35397, '2020-07-17', 'GN', 'Guinea', 'AFRO', '83', '6359', '1', '39');
INSERT INTO public.who_global_data_import VALUES (35398, '2020-07-18', 'GN', 'Guinea', 'AFRO', '71', '6430', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35399, '2020-07-19', 'GN', 'Guinea', 'AFRO', '61', '6491', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35400, '2020-07-20', 'GN', 'Guinea', 'AFRO', '53', '6544', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35401, '2020-07-21', 'GN', 'Guinea', 'AFRO', '46', '6590', '1', '40');
INSERT INTO public.who_global_data_import VALUES (35402, '2020-07-22', 'GN', 'Guinea', 'AFRO', '35', '6625', '1', '41');
INSERT INTO public.who_global_data_import VALUES (35403, '2020-07-23', 'GN', 'Guinea', 'AFRO', '122', '6747', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35404, '2020-07-24', 'GN', 'Guinea', 'AFRO', '59', '6806', '1', '42');
INSERT INTO public.who_global_data_import VALUES (35405, '2020-07-25', 'GN', 'Guinea', 'AFRO', '61', '6867', '0', '42');
INSERT INTO public.who_global_data_import VALUES (35406, '2020-07-26', 'GN', 'Guinea', 'AFRO', '60', '6927', '0', '42');
INSERT INTO public.who_global_data_import VALUES (35407, '2020-07-27', 'GN', 'Guinea', 'AFRO', '81', '7008', '1', '43');
INSERT INTO public.who_global_data_import VALUES (35408, '2020-07-28', 'GN', 'Guinea', 'AFRO', '47', '7055', '2', '45');
INSERT INTO public.who_global_data_import VALUES (35409, '2020-07-29', 'GN', 'Guinea', 'AFRO', '71', '7126', '1', '46');
INSERT INTO public.who_global_data_import VALUES (35410, '2020-07-30', 'GN', 'Guinea', 'AFRO', '57', '7183', '0', '46');
INSERT INTO public.who_global_data_import VALUES (35411, '2020-07-31', 'GN', 'Guinea', 'AFRO', '59', '7242', '0', '46');
INSERT INTO public.who_global_data_import VALUES (35412, '2020-08-01', 'GN', 'Guinea', 'AFRO', '66', '7308', '0', '46');
INSERT INTO public.who_global_data_import VALUES (35413, '2020-08-02', 'GN', 'Guinea', 'AFRO', '0', '7308', '0', '46');
INSERT INTO public.who_global_data_import VALUES (35414, '2020-08-03', 'GN', 'Guinea', 'AFRO', '56', '7364', '0', '46');
INSERT INTO public.who_global_data_import VALUES (35415, '2020-08-04', 'GN', 'Guinea', 'AFRO', '54', '7418', '0', '46');
INSERT INTO public.who_global_data_import VALUES (35416, '2020-08-05', 'GN', 'Guinea', 'AFRO', '71', '7489', '2', '48');
INSERT INTO public.who_global_data_import VALUES (35417, '2020-08-06', 'GN', 'Guinea', 'AFRO', '86', '7575', '1', '49');
INSERT INTO public.who_global_data_import VALUES (35418, '2020-08-07', 'GN', 'Guinea', 'AFRO', '89', '7664', '0', '49');
INSERT INTO public.who_global_data_import VALUES (35419, '2020-08-08', 'GN', 'Guinea', 'AFRO', '113', '7777', '1', '50');
INSERT INTO public.who_global_data_import VALUES (35420, '2020-08-09', 'GN', 'Guinea', 'AFRO', '98', '7875', '0', '50');
INSERT INTO public.who_global_data_import VALUES (35421, '2020-08-10', 'GN', 'Guinea', 'AFRO', '55', '7930', '0', '50');
INSERT INTO public.who_global_data_import VALUES (35422, '2020-08-11', 'GN', 'Guinea', 'AFRO', '22', '7952', '0', '50');
INSERT INTO public.who_global_data_import VALUES (35423, '2020-08-12', 'GN', 'Guinea', 'AFRO', '66', '8018', '0', '50');
INSERT INTO public.who_global_data_import VALUES (35424, '2020-08-13', 'GN', 'Guinea', 'AFRO', '98', '8116', '0', '50');
INSERT INTO public.who_global_data_import VALUES (35425, '2020-08-14', 'GN', 'Guinea', 'AFRO', '82', '8198', '0', '50');
INSERT INTO public.who_global_data_import VALUES (35426, '2020-08-15', 'GN', 'Guinea', 'AFRO', '62', '8260', '0', '50');
INSERT INTO public.who_global_data_import VALUES (35427, '2020-08-16', 'GN', 'Guinea', 'AFRO', '83', '8343', '0', '50');
INSERT INTO public.who_global_data_import VALUES (35428, '2020-08-17', 'GN', 'Guinea', 'AFRO', '139', '8482', '1', '51');
INSERT INTO public.who_global_data_import VALUES (35429, '2020-08-18', 'GN', 'Guinea', 'AFRO', '138', '8620', '0', '51');
INSERT INTO public.who_global_data_import VALUES (35430, '2020-08-19', 'GN', 'Guinea', 'AFRO', '95', '8715', '1', '52');
INSERT INTO public.who_global_data_import VALUES (35431, '2020-08-20', 'GN', 'Guinea', 'AFRO', '77', '8792', '1', '53');
INSERT INTO public.who_global_data_import VALUES (35432, '2020-08-21', 'GN', 'Guinea', 'AFRO', '84', '8876', '0', '53');
INSERT INTO public.who_global_data_import VALUES (35433, '2020-08-22', 'GN', 'Guinea', 'AFRO', '56', '8932', '0', '53');
INSERT INTO public.who_global_data_import VALUES (35434, '2020-08-23', 'GN', 'Guinea', 'AFRO', '35', '8967', '0', '53');
INSERT INTO public.who_global_data_import VALUES (35435, '2020-08-24', 'GN', 'Guinea', 'AFRO', '0', '8967', '0', '53');
INSERT INTO public.who_global_data_import VALUES (35436, '2020-08-25', 'GN', 'Guinea', 'AFRO', '109', '9076', '2', '55');
INSERT INTO public.who_global_data_import VALUES (35437, '2020-08-26', 'GN', 'Guinea', 'AFRO', '52', '9128', '2', '57');
INSERT INTO public.who_global_data_import VALUES (35438, '2020-08-27', 'GN', 'Guinea', 'AFRO', '39', '9167', '0', '57');
INSERT INTO public.who_global_data_import VALUES (35439, '2020-08-28', 'GN', 'Guinea', 'AFRO', '46', '9213', '1', '58');
INSERT INTO public.who_global_data_import VALUES (35440, '2020-08-29', 'GN', 'Guinea', 'AFRO', '38', '9251', '1', '59');
INSERT INTO public.who_global_data_import VALUES (35441, '2020-08-30', 'GN', 'Guinea', 'AFRO', '0', '9251', '0', '59');
INSERT INTO public.who_global_data_import VALUES (35442, '2020-08-31', 'GN', 'Guinea', 'AFRO', '120', '9371', '0', '59');
INSERT INTO public.who_global_data_import VALUES (35443, '2020-09-01', 'GN', 'Guinea', 'AFRO', '38', '9409', '0', '59');
INSERT INTO public.who_global_data_import VALUES (35444, '2020-09-02', 'GN', 'Guinea', 'AFRO', '70', '9479', '0', '59');
INSERT INTO public.who_global_data_import VALUES (35445, '2020-09-03', 'GN', 'Guinea', 'AFRO', '0', '9479', '0', '59');
INSERT INTO public.who_global_data_import VALUES (35446, '2020-09-04', 'GN', 'Guinea', 'AFRO', '100', '9579', '2', '61');
INSERT INTO public.who_global_data_import VALUES (35447, '2020-09-05', 'GN', 'Guinea', 'AFRO', '70', '9649', '0', '61');
INSERT INTO public.who_global_data_import VALUES (35448, '2020-09-06', 'GN', 'Guinea', 'AFRO', '73', '9722', '0', '61');
INSERT INTO public.who_global_data_import VALUES (35449, '2020-09-07', 'GN', 'Guinea', 'AFRO', '76', '9798', '0', '61');
INSERT INTO public.who_global_data_import VALUES (35450, '2020-09-08', 'GN', 'Guinea', 'AFRO', '18', '9816', '1', '62');
INSERT INTO public.who_global_data_import VALUES (35451, '2020-09-09', 'GN', 'Guinea', 'AFRO', '32', '9848', '1', '63');
INSERT INTO public.who_global_data_import VALUES (35452, '2020-09-10', 'GN', 'Guinea', 'AFRO', '37', '9885', '0', '63');
INSERT INTO public.who_global_data_import VALUES (35453, '2020-09-11', 'GN', 'Guinea', 'AFRO', '61', '9946', '0', '63');
INSERT INTO public.who_global_data_import VALUES (35454, '2020-09-12', 'GN', 'Guinea', 'AFRO', '33', '9979', '0', '63');
INSERT INTO public.who_global_data_import VALUES (35455, '2020-09-13', 'GN', 'Guinea', 'AFRO', '41', '10020', '0', '63');
INSERT INTO public.who_global_data_import VALUES (35456, '2020-09-14', 'GN', 'Guinea', 'AFRO', '25', '10045', '0', '63');
INSERT INTO public.who_global_data_import VALUES (35457, '2020-09-15', 'GN', 'Guinea', 'AFRO', '16', '10061', '0', '63');
INSERT INTO public.who_global_data_import VALUES (35458, '2020-09-16', 'GN', 'Guinea', 'AFRO', '50', '10111', '0', '63');
INSERT INTO public.who_global_data_import VALUES (35459, '2020-09-17', 'GN', 'Guinea', 'AFRO', '43', '10154', '0', '63');
INSERT INTO public.who_global_data_import VALUES (35460, '2020-09-18', 'GN', 'Guinea', 'AFRO', '0', '10154', '0', '63');
INSERT INTO public.who_global_data_import VALUES (35461, '2020-09-19', 'GN', 'Guinea', 'AFRO', '77', '10231', '0', '63');
INSERT INTO public.who_global_data_import VALUES (35462, '2020-09-20', 'GN', 'Guinea', 'AFRO', '55', '10286', '0', '63');
INSERT INTO public.who_global_data_import VALUES (35463, '2020-09-21', 'GN', 'Guinea', 'AFRO', '39', '10325', '1', '64');
INSERT INTO public.who_global_data_import VALUES (35464, '2020-09-22', 'GN', 'Guinea', 'AFRO', '19', '10344', '1', '65');
INSERT INTO public.who_global_data_import VALUES (35465, '2020-09-23', 'GN', 'Guinea', 'AFRO', '43', '10387', '0', '65');
INSERT INTO public.who_global_data_import VALUES (35466, '2020-09-24', 'GN', 'Guinea', 'AFRO', '47', '10434', '0', '65');
INSERT INTO public.who_global_data_import VALUES (35467, '2020-09-25', 'GN', 'Guinea', 'AFRO', '44', '10478', '0', '65');
INSERT INTO public.who_global_data_import VALUES (35468, '2020-09-26', 'GN', 'Guinea', 'AFRO', '0', '10478', '0', '65');
INSERT INTO public.who_global_data_import VALUES (35469, '2020-09-27', 'GN', 'Guinea', 'AFRO', '70', '10548', '1', '66');
INSERT INTO public.who_global_data_import VALUES (35470, '2020-09-28', 'GN', 'Guinea', 'AFRO', '32', '10580', '0', '66');
INSERT INTO public.who_global_data_import VALUES (35471, '2020-09-29', 'GN', 'Guinea', 'AFRO', '18', '10598', '0', '66');
INSERT INTO public.who_global_data_import VALUES (35472, '2020-09-30', 'GN', 'Guinea', 'AFRO', '36', '10634', '0', '66');
INSERT INTO public.who_global_data_import VALUES (35473, '2020-10-01', 'GN', 'Guinea', 'AFRO', '18', '10652', '0', '66');
INSERT INTO public.who_global_data_import VALUES (35474, '2020-10-02', 'GN', 'Guinea', 'AFRO', '48', '10700', '0', '66');
INSERT INTO public.who_global_data_import VALUES (35475, '2020-10-03', 'GN', 'Guinea', 'AFRO', '35', '10735', '0', '66');
INSERT INTO public.who_global_data_import VALUES (35476, '2020-10-04', 'GN', 'Guinea', 'AFRO', '0', '10735', '0', '66');
INSERT INTO public.who_global_data_import VALUES (35477, '2020-10-05', 'GN', 'Guinea', 'AFRO', '19', '10754', '0', '66');
INSERT INTO public.who_global_data_import VALUES (35478, '2020-10-06', 'GN', 'Guinea', 'AFRO', '46', '10800', '1', '67');
INSERT INTO public.who_global_data_import VALUES (35479, '2020-10-07', 'GN', 'Guinea', 'AFRO', '63', '10863', '1', '68');
INSERT INTO public.who_global_data_import VALUES (35480, '2020-10-08', 'GN', 'Guinea', 'AFRO', '0', '10863', '0', '68');
INSERT INTO public.who_global_data_import VALUES (35481, '2020-10-09', 'GN', 'Guinea', 'AFRO', '38', '10901', '0', '68');
INSERT INTO public.who_global_data_import VALUES (35482, '2020-10-10', 'GN', 'Guinea', 'AFRO', '53', '10954', '0', '68');
INSERT INTO public.who_global_data_import VALUES (35483, '2020-10-11', 'GN', 'Guinea', 'AFRO', '42', '10996', '1', '69');
INSERT INTO public.who_global_data_import VALUES (35484, '2020-10-12', 'GN', 'Guinea', 'AFRO', '26', '11022', '0', '69');
INSERT INTO public.who_global_data_import VALUES (35485, '2020-10-13', 'GN', 'Guinea', 'AFRO', '40', '11062', '1', '70');
INSERT INTO public.who_global_data_import VALUES (35486, '2020-10-14', 'GN', 'Guinea', 'AFRO', '72', '11134', '0', '70');
INSERT INTO public.who_global_data_import VALUES (35487, '2020-10-15', 'GN', 'Guinea', 'AFRO', '54', '11188', '0', '70');
INSERT INTO public.who_global_data_import VALUES (35488, '2020-10-16', 'GN', 'Guinea', 'AFRO', '67', '11255', '0', '70');
INSERT INTO public.who_global_data_import VALUES (35489, '2020-10-17', 'GN', 'Guinea', 'AFRO', '107', '11362', '0', '70');
INSERT INTO public.who_global_data_import VALUES (35490, '2020-10-18', 'GN', 'Guinea', 'AFRO', '116', '11478', '0', '70');
INSERT INTO public.who_global_data_import VALUES (35491, '2020-10-19', 'GN', 'Guinea', 'AFRO', '40', '11518', '0', '70');
INSERT INTO public.who_global_data_import VALUES (35492, '2020-10-20', 'GN', 'Guinea', 'AFRO', '0', '11518', '0', '70');
INSERT INTO public.who_global_data_import VALUES (35493, '2020-10-21', 'GN', 'Guinea', 'AFRO', '20', '11538', '0', '70');
INSERT INTO public.who_global_data_import VALUES (35494, '2020-10-22', 'GN', 'Guinea', 'AFRO', '97', '11635', '1', '71');
INSERT INTO public.who_global_data_import VALUES (35495, '2020-10-23', 'GN', 'Guinea', 'AFRO', '0', '11635', '0', '71');
INSERT INTO public.who_global_data_import VALUES (35496, '2020-10-24', 'GN', 'Guinea', 'AFRO', '34', '11669', '0', '71');
INSERT INTO public.who_global_data_import VALUES (35497, '2020-10-25', 'GN', 'Guinea', 'AFRO', '0', '11669', '0', '71');
INSERT INTO public.who_global_data_import VALUES (35498, '2020-10-26', 'GN', 'Guinea', 'AFRO', '0', '11669', '0', '71');
INSERT INTO public.who_global_data_import VALUES (35499, '2020-10-27', 'GN', 'Guinea', 'AFRO', '0', '11669', '0', '71');
INSERT INTO public.who_global_data_import VALUES (35500, '2020-10-28', 'GN', 'Guinea', 'AFRO', '150', '11819', '0', '71');
INSERT INTO public.who_global_data_import VALUES (35501, '2020-10-29', 'GN', 'Guinea', 'AFRO', '0', '11819', '0', '71');
INSERT INTO public.who_global_data_import VALUES (35502, '2020-10-30', 'GN', 'Guinea', 'AFRO', '201', '12020', '0', '71');
INSERT INTO public.who_global_data_import VALUES (35503, '2020-10-31', 'GN', 'Guinea', 'AFRO', '0', '12020', '0', '71');
INSERT INTO public.who_global_data_import VALUES (35504, '2020-11-01', 'GN', 'Guinea', 'AFRO', '52', '12072', '1', '72');
INSERT INTO public.who_global_data_import VALUES (35505, '2020-11-02', 'GN', 'Guinea', 'AFRO', '123', '12195', '1', '73');
INSERT INTO public.who_global_data_import VALUES (35506, '2020-11-03', 'GN', 'Guinea', 'AFRO', '18', '12213', '0', '73');
INSERT INTO public.who_global_data_import VALUES (35507, '2020-11-04', 'GN', 'Guinea', 'AFRO', '0', '12213', '0', '73');
INSERT INTO public.who_global_data_import VALUES (35508, '2020-11-05', 'GN', 'Guinea', 'AFRO', '118', '12331', '0', '73');
INSERT INTO public.who_global_data_import VALUES (35509, '2020-11-06', 'GN', 'Guinea', 'AFRO', '32', '12363', '0', '73');
INSERT INTO public.who_global_data_import VALUES (35510, '2020-11-07', 'GN', 'Guinea', 'AFRO', '0', '12363', '0', '73');
INSERT INTO public.who_global_data_import VALUES (35511, '2020-11-08', 'GN', 'Guinea', 'AFRO', '37', '12400', '0', '73');
INSERT INTO public.who_global_data_import VALUES (35512, '2020-11-09', 'GN', 'Guinea', 'AFRO', '14', '12414', '1', '74');
INSERT INTO public.who_global_data_import VALUES (35513, '2020-11-10', 'GN', 'Guinea', 'AFRO', '12', '12426', '0', '74');
INSERT INTO public.who_global_data_import VALUES (35514, '2020-11-11', 'GN', 'Guinea', 'AFRO', '33', '12459', '0', '74');
INSERT INTO public.who_global_data_import VALUES (35515, '2020-11-12', 'GN', 'Guinea', 'AFRO', '25', '12484', '0', '74');
INSERT INTO public.who_global_data_import VALUES (35516, '2020-11-13', 'GN', 'Guinea', 'AFRO', '32', '12516', '0', '74');
INSERT INTO public.who_global_data_import VALUES (35517, '2020-11-14', 'GN', 'Guinea', 'AFRO', '21', '12537', '0', '74');
INSERT INTO public.who_global_data_import VALUES (35518, '2020-11-15', 'GN', 'Guinea', 'AFRO', '48', '12585', '0', '74');
INSERT INTO public.who_global_data_import VALUES (35519, '2020-11-16', 'GN', 'Guinea', 'AFRO', '26', '12611', '1', '75');
INSERT INTO public.who_global_data_import VALUES (35520, '2020-11-17', 'GN', 'Guinea', 'AFRO', '13', '12624', '0', '75');
INSERT INTO public.who_global_data_import VALUES (35521, '2020-11-18', 'GN', 'Guinea', 'AFRO', '30', '12654', '0', '75');
INSERT INTO public.who_global_data_import VALUES (35522, '2020-11-19', 'GN', 'Guinea', 'AFRO', '29', '12683', '0', '75');
INSERT INTO public.who_global_data_import VALUES (35523, '2020-11-20', 'GN', 'Guinea', 'AFRO', '30', '12713', '0', '75');
INSERT INTO public.who_global_data_import VALUES (35524, '2020-11-21', 'GN', 'Guinea', 'AFRO', '85', '12798', '0', '75');
INSERT INTO public.who_global_data_import VALUES (35525, '2020-11-22', 'GN', 'Guinea', 'AFRO', '0', '12798', '0', '75');
INSERT INTO public.who_global_data_import VALUES (35526, '2020-11-23', 'GN', 'Guinea', 'AFRO', '28', '12826', '0', '75');
INSERT INTO public.who_global_data_import VALUES (35527, '2020-11-24', 'GN', 'Guinea', 'AFRO', '37', '12863', '0', '75');
INSERT INTO public.who_global_data_import VALUES (35528, '2020-11-25', 'GN', 'Guinea', 'AFRO', '0', '12863', '0', '75');
INSERT INTO public.who_global_data_import VALUES (35529, '2020-11-26', 'GN', 'Guinea', 'AFRO', '0', '12863', '0', '75');
INSERT INTO public.who_global_data_import VALUES (35530, '2020-11-27', 'GN', 'Guinea', 'AFRO', '86', '12949', '1', '76');
INSERT INTO public.who_global_data_import VALUES (35531, '2020-11-28', 'GN', 'Guinea', 'AFRO', '90', '13039', '0', '76');
INSERT INTO public.who_global_data_import VALUES (35532, '2020-11-29', 'GN', 'Guinea', 'AFRO', '0', '13039', '0', '76');
INSERT INTO public.who_global_data_import VALUES (35533, '2020-11-30', 'GN', 'Guinea', 'AFRO', '0', '13039', '0', '76');
INSERT INTO public.who_global_data_import VALUES (35534, '2020-12-01', 'GN', 'Guinea', 'AFRO', '58', '13097', '0', '76');
INSERT INTO public.who_global_data_import VALUES (35535, '2020-12-02', 'GN', 'Guinea', 'AFRO', '22', '13119', '0', '76');
INSERT INTO public.who_global_data_import VALUES (35536, '2020-12-03', 'GN', 'Guinea', 'AFRO', '24', '13143', '0', '76');
INSERT INTO public.who_global_data_import VALUES (35537, '2020-12-04', 'GN', 'Guinea', 'AFRO', '24', '13167', '0', '76');
INSERT INTO public.who_global_data_import VALUES (35538, '2020-12-05', 'GN', 'Guinea', 'AFRO', '19', '13186', '0', '76');
INSERT INTO public.who_global_data_import VALUES (35539, '2020-12-06', 'GN', 'Guinea', 'AFRO', '21', '13207', '0', '76');
INSERT INTO public.who_global_data_import VALUES (35540, '2020-12-07', 'GN', 'Guinea', 'AFRO', '26', '13233', '0', '76');
INSERT INTO public.who_global_data_import VALUES (35541, '2020-12-08', 'GN', 'Guinea', 'AFRO', '13', '13246', '1', '77');
INSERT INTO public.who_global_data_import VALUES (35542, '2020-12-09', 'GN', 'Guinea', 'AFRO', '18', '13264', '2', '79');
INSERT INTO public.who_global_data_import VALUES (35543, '2020-12-10', 'GN', 'Guinea', 'AFRO', '61', '13325', '0', '79');
INSERT INTO public.who_global_data_import VALUES (35544, '2020-12-11', 'GN', 'Guinea', 'AFRO', '43', '13368', '0', '79');
INSERT INTO public.who_global_data_import VALUES (35545, '2020-12-12', 'GN', 'Guinea', 'AFRO', '30', '13398', '0', '79');
INSERT INTO public.who_global_data_import VALUES (35546, '2020-12-13', 'GN', 'Guinea', 'AFRO', '22', '13420', '0', '79');
INSERT INTO public.who_global_data_import VALUES (35547, '2020-12-14', 'GN', 'Guinea', 'AFRO', '0', '13420', '0', '79');
INSERT INTO public.who_global_data_import VALUES (35548, '2020-12-15', 'GN', 'Guinea', 'AFRO', '11', '13431', '0', '79');
INSERT INTO public.who_global_data_import VALUES (35549, '2020-12-16', 'GN', 'Guinea', 'AFRO', '26', '13457', '1', '80');
INSERT INTO public.who_global_data_import VALUES (35550, '2020-12-17', 'GN', 'Guinea', 'AFRO', '17', '13474', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35551, '2020-12-18', 'GN', 'Guinea', 'AFRO', '11', '13485', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35552, '2020-12-19', 'GN', 'Guinea', 'AFRO', '26', '13511', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35553, '2020-12-20', 'GN', 'Guinea', 'AFRO', '21', '13532', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35554, '2020-12-21', 'GN', 'Guinea', 'AFRO', '13', '13545', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35555, '2020-12-22', 'GN', 'Guinea', 'AFRO', '5', '13550', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35556, '2020-12-23', 'GN', 'Guinea', 'AFRO', '28', '13578', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35557, '2020-12-24', 'GN', 'Guinea', 'AFRO', '52', '13630', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35558, '2020-12-25', 'GN', 'Guinea', 'AFRO', '0', '13630', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35559, '2020-12-26', 'GN', 'Guinea', 'AFRO', '16', '13646', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35560, '2020-12-27', 'GN', 'Guinea', 'AFRO', '0', '13646', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35561, '2020-12-28', 'GN', 'Guinea', 'AFRO', '28', '13674', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35562, '2020-12-29', 'GN', 'Guinea', 'AFRO', '14', '13688', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35563, '2020-12-30', 'GN', 'Guinea', 'AFRO', '0', '13688', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35564, '2020-12-31', 'GN', 'Guinea', 'AFRO', '19', '13707', '0', '80');
INSERT INTO public.who_global_data_import VALUES (35565, '2021-01-01', 'GN', 'Guinea', 'AFRO', '15', '13722', '1', '81');
INSERT INTO public.who_global_data_import VALUES (35566, '2021-01-02', 'GN', 'Guinea', 'AFRO', '0', '13722', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35567, '2021-01-03', 'GN', 'Guinea', 'AFRO', '62', '13784', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35568, '2021-01-04', 'GN', 'Guinea', 'AFRO', '0', '13784', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35569, '2021-01-05', 'GN', 'Guinea', 'AFRO', '15', '13799', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35570, '2021-01-06', 'GN', 'Guinea', 'AFRO', '19', '13818', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35571, '2021-01-07', 'GN', 'Guinea', 'AFRO', '27', '13845', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35572, '2021-01-08', 'GN', 'Guinea', 'AFRO', '17', '13862', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35573, '2021-01-09', 'GN', 'Guinea', 'AFRO', '42', '13904', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35574, '2021-01-10', 'GN', 'Guinea', 'AFRO', '0', '13904', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35575, '2021-01-11', 'GN', 'Guinea', 'AFRO', '38', '13942', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35576, '2021-01-12', 'GN', 'Guinea', 'AFRO', '25', '13967', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35577, '2021-01-13', 'GN', 'Guinea', 'AFRO', '22', '13989', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35578, '2021-01-14', 'GN', 'Guinea', 'AFRO', '36', '14025', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35579, '2021-01-15', 'GN', 'Guinea', 'AFRO', '26', '14051', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35580, '2021-01-16', 'GN', 'Guinea', 'AFRO', '14', '14065', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35581, '2021-01-17', 'GN', 'Guinea', 'AFRO', '33', '14098', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35582, '2021-01-18', 'GN', 'Guinea', 'AFRO', '16', '14114', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35583, '2021-01-19', 'GN', 'Guinea', 'AFRO', '51', '14165', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35584, '2021-01-20', 'GN', 'Guinea', 'AFRO', '7', '14172', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35585, '2021-01-21', 'GN', 'Guinea', 'AFRO', '35', '14207', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35586, '2021-01-22', 'GN', 'Guinea', 'AFRO', '29', '14236', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35587, '2021-01-23', 'GN', 'Guinea', 'AFRO', '26', '14262', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35588, '2021-01-24', 'GN', 'Guinea', 'AFRO', '38', '14300', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35589, '2021-01-25', 'GN', 'Guinea', 'AFRO', '19', '14319', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35590, '2021-01-26', 'GN', 'Guinea', 'AFRO', '56', '14375', '0', '81');
INSERT INTO public.who_global_data_import VALUES (35591, '2021-01-27', 'GN', 'Guinea', 'AFRO', '4', '14379', '1', '82');
INSERT INTO public.who_global_data_import VALUES (35592, '2021-01-28', 'GN', 'Guinea', 'AFRO', '38', '14417', '0', '82');
INSERT INTO public.who_global_data_import VALUES (35593, '2021-01-29', 'GN', 'Guinea', 'AFRO', '18', '14435', '0', '82');
INSERT INTO public.who_global_data_import VALUES (35594, '2021-01-30', 'GN', 'Guinea', 'AFRO', '16', '14451', '0', '82');
INSERT INTO public.who_global_data_import VALUES (35595, '2021-01-31', 'GN', 'Guinea', 'AFRO', '24', '14475', '0', '82');
INSERT INTO public.who_global_data_import VALUES (35596, '2021-02-01', 'GN', 'Guinea', 'AFRO', '57', '14532', '0', '82');
INSERT INTO public.who_global_data_import VALUES (35597, '2021-02-02', 'GN', 'Guinea', 'AFRO', '14', '14546', '0', '82');
INSERT INTO public.who_global_data_import VALUES (35598, '2021-02-03', 'GN', 'Guinea', 'AFRO', '9', '14555', '1', '83');
INSERT INTO public.who_global_data_import VALUES (35599, '2021-02-04', 'GN', 'Guinea', 'AFRO', '13', '14568', '0', '83');
INSERT INTO public.who_global_data_import VALUES (35600, '2021-02-05', 'GN', 'Guinea', 'AFRO', '61', '14629', '1', '84');
INSERT INTO public.who_global_data_import VALUES (35601, '2020-01-03', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35602, '2020-01-04', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35603, '2020-01-05', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35604, '2020-01-06', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35605, '2020-01-07', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35606, '2020-01-08', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35607, '2020-01-09', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35608, '2020-01-10', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35609, '2020-01-11', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35610, '2020-01-12', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35611, '2020-01-13', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35612, '2020-01-14', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35613, '2020-01-15', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35614, '2020-01-16', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35615, '2020-01-17', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35616, '2020-01-18', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35617, '2020-01-19', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35618, '2020-01-20', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35619, '2020-01-21', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35620, '2020-01-22', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35621, '2020-01-23', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35622, '2020-01-24', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35623, '2020-01-25', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35624, '2020-01-26', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35625, '2020-01-27', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35626, '2020-01-28', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35627, '2020-01-29', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35628, '2020-01-30', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35629, '2020-01-31', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35630, '2020-02-01', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35631, '2020-02-02', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35632, '2020-02-03', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35633, '2020-02-04', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35634, '2020-02-05', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35635, '2020-02-06', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35636, '2020-02-07', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35637, '2020-02-08', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35638, '2020-02-09', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35639, '2020-02-10', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35640, '2020-02-11', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35641, '2020-02-12', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35642, '2020-02-13', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35643, '2020-02-14', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35644, '2020-02-15', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35645, '2020-02-16', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35646, '2020-02-17', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35647, '2020-02-18', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35648, '2020-02-19', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35649, '2020-02-20', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35650, '2020-02-21', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35651, '2020-02-22', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35652, '2020-02-23', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35653, '2020-02-24', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35654, '2020-02-25', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35655, '2020-02-26', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35656, '2020-02-27', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35657, '2020-02-28', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35658, '2020-02-29', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35659, '2020-03-01', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35660, '2020-03-02', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35661, '2020-03-03', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35662, '2020-03-04', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35663, '2020-03-05', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35664, '2020-03-06', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35665, '2020-03-07', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35666, '2020-03-08', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35667, '2020-03-09', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35668, '2020-03-10', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35669, '2020-03-11', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35670, '2020-03-12', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35671, '2020-03-13', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35672, '2020-03-14', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35673, '2020-03-15', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35674, '2020-03-16', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35675, '2020-03-17', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35676, '2020-03-18', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35677, '2020-03-19', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35678, '2020-03-20', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35679, '2020-03-21', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35680, '2020-03-22', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35681, '2020-03-23', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35682, '2020-03-24', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35683, '2020-03-25', 'GW', 'Guinea-Bissau', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35684, '2020-03-26', 'GW', 'Guinea-Bissau', 'AFRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35685, '2020-03-27', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35686, '2020-03-28', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35687, '2020-03-29', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35688, '2020-03-30', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35689, '2020-03-31', 'GW', 'Guinea-Bissau', 'AFRO', '6', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35690, '2020-04-01', 'GW', 'Guinea-Bissau', 'AFRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35691, '2020-04-02', 'GW', 'Guinea-Bissau', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35692, '2020-04-03', 'GW', 'Guinea-Bissau', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35693, '2020-04-04', 'GW', 'Guinea-Bissau', 'AFRO', '6', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35694, '2020-04-05', 'GW', 'Guinea-Bissau', 'AFRO', '3', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35695, '2020-04-06', 'GW', 'Guinea-Bissau', 'AFRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35696, '2020-04-07', 'GW', 'Guinea-Bissau', 'AFRO', '15', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35697, '2020-04-08', 'GW', 'Guinea-Bissau', 'AFRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35698, '2020-04-09', 'GW', 'Guinea-Bissau', 'AFRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35699, '2020-04-10', 'GW', 'Guinea-Bissau', 'AFRO', '2', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35700, '2020-04-11', 'GW', 'Guinea-Bissau', 'AFRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35701, '2020-04-12', 'GW', 'Guinea-Bissau', 'AFRO', '3', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35702, '2020-04-13', 'GW', 'Guinea-Bissau', 'AFRO', '1', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35703, '2020-04-14', 'GW', 'Guinea-Bissau', 'AFRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35704, '2020-04-15', 'GW', 'Guinea-Bissau', 'AFRO', '1', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35705, '2020-04-16', 'GW', 'Guinea-Bissau', 'AFRO', '3', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35706, '2020-04-17', 'GW', 'Guinea-Bissau', 'AFRO', '3', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35707, '2020-04-18', 'GW', 'Guinea-Bissau', 'AFRO', '4', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35708, '2020-04-19', 'GW', 'Guinea-Bissau', 'AFRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35709, '2020-04-20', 'GW', 'Guinea-Bissau', 'AFRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35710, '2020-04-21', 'GW', 'Guinea-Bissau', 'AFRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35711, '2020-04-22', 'GW', 'Guinea-Bissau', 'AFRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35712, '2020-04-23', 'GW', 'Guinea-Bissau', 'AFRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35713, '2020-04-24', 'GW', 'Guinea-Bissau', 'AFRO', '2', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35714, '2020-04-25', 'GW', 'Guinea-Bissau', 'AFRO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35715, '2020-04-26', 'GW', 'Guinea-Bissau', 'AFRO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (35716, '2020-04-27', 'GW', 'Guinea-Bissau', 'AFRO', '1', '53', '1', '1');
INSERT INTO public.who_global_data_import VALUES (35717, '2020-04-28', 'GW', 'Guinea-Bissau', 'AFRO', '20', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (35718, '2020-04-29', 'GW', 'Guinea-Bissau', 'AFRO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (35719, '2020-04-30', 'GW', 'Guinea-Bissau', 'AFRO', '4', '77', '0', '1');
INSERT INTO public.who_global_data_import VALUES (35720, '2020-05-01', 'GW', 'Guinea-Bissau', 'AFRO', '124', '201', '0', '1');
INSERT INTO public.who_global_data_import VALUES (35721, '2020-05-02', 'GW', 'Guinea-Bissau', 'AFRO', '56', '257', '0', '1');
INSERT INTO public.who_global_data_import VALUES (35722, '2020-05-03', 'GW', 'Guinea-Bissau', 'AFRO', '3', '260', '0', '1');
INSERT INTO public.who_global_data_import VALUES (35723, '2020-05-04', 'GW', 'Guinea-Bissau', 'AFRO', '32', '292', '1', '2');
INSERT INTO public.who_global_data_import VALUES (35724, '2020-05-05', 'GW', 'Guinea-Bissau', 'AFRO', '0', '292', '0', '2');
INSERT INTO public.who_global_data_import VALUES (35725, '2020-05-06', 'GW', 'Guinea-Bissau', 'AFRO', '0', '292', '0', '2');
INSERT INTO public.who_global_data_import VALUES (35726, '2020-05-07', 'GW', 'Guinea-Bissau', 'AFRO', '216', '508', '0', '2');
INSERT INTO public.who_global_data_import VALUES (35727, '2020-05-08', 'GW', 'Guinea-Bissau', 'AFRO', '0', '508', '0', '2');
INSERT INTO public.who_global_data_import VALUES (35728, '2020-05-09', 'GW', 'Guinea-Bissau', 'AFRO', '0', '508', '0', '2');
INSERT INTO public.who_global_data_import VALUES (35729, '2020-05-10', 'GW', 'Guinea-Bissau', 'AFRO', '134', '642', '1', '3');
INSERT INTO public.who_global_data_import VALUES (35730, '2020-05-11', 'GW', 'Guinea-Bissau', 'AFRO', '0', '642', '0', '3');
INSERT INTO public.who_global_data_import VALUES (35731, '2020-05-12', 'GW', 'Guinea-Bissau', 'AFRO', '119', '761', '0', '3');
INSERT INTO public.who_global_data_import VALUES (35732, '2020-05-13', 'GW', 'Guinea-Bissau', 'AFRO', '59', '820', '0', '3');
INSERT INTO public.who_global_data_import VALUES (35733, '2020-05-14', 'GW', 'Guinea-Bissau', 'AFRO', '16', '836', '0', '3');
INSERT INTO public.who_global_data_import VALUES (35734, '2020-05-15', 'GW', 'Guinea-Bissau', 'AFRO', '77', '913', '0', '3');
INSERT INTO public.who_global_data_import VALUES (35735, '2020-05-16', 'GW', 'Guinea-Bissau', 'AFRO', '0', '913', '0', '3');
INSERT INTO public.who_global_data_import VALUES (35736, '2020-05-17', 'GW', 'Guinea-Bissau', 'AFRO', '0', '913', '0', '3');
INSERT INTO public.who_global_data_import VALUES (35737, '2020-05-18', 'GW', 'Guinea-Bissau', 'AFRO', '77', '990', '1', '4');
INSERT INTO public.who_global_data_import VALUES (35738, '2020-05-19', 'GW', 'Guinea-Bissau', 'AFRO', '48', '1038', '2', '6');
INSERT INTO public.who_global_data_import VALUES (35739, '2020-05-20', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1038', '0', '6');
INSERT INTO public.who_global_data_import VALUES (35740, '2020-05-21', 'GW', 'Guinea-Bissau', 'AFRO', '51', '1089', '0', '6');
INSERT INTO public.who_global_data_import VALUES (35741, '2020-05-22', 'GW', 'Guinea-Bissau', 'AFRO', '20', '1109', '0', '6');
INSERT INTO public.who_global_data_import VALUES (35742, '2020-05-23', 'GW', 'Guinea-Bissau', 'AFRO', '5', '1114', '0', '6');
INSERT INTO public.who_global_data_import VALUES (35743, '2020-05-24', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1114', '0', '6');
INSERT INTO public.who_global_data_import VALUES (35744, '2020-05-25', 'GW', 'Guinea-Bissau', 'AFRO', '59', '1173', '0', '6');
INSERT INTO public.who_global_data_import VALUES (35745, '2020-05-26', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1173', '0', '6');
INSERT INTO public.who_global_data_import VALUES (35746, '2020-05-27', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1173', '0', '6');
INSERT INTO public.who_global_data_import VALUES (35747, '2020-05-28', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1173', '0', '6');
INSERT INTO public.who_global_data_import VALUES (35748, '2020-05-29', 'GW', 'Guinea-Bissau', 'AFRO', '22', '1195', '2', '8');
INSERT INTO public.who_global_data_import VALUES (35749, '2020-05-30', 'GW', 'Guinea-Bissau', 'AFRO', '61', '1256', '0', '8');
INSERT INTO public.who_global_data_import VALUES (35750, '2020-05-31', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1256', '0', '8');
INSERT INTO public.who_global_data_import VALUES (35751, '2020-06-01', 'GW', 'Guinea-Bissau', 'AFRO', '66', '1322', '0', '8');
INSERT INTO public.who_global_data_import VALUES (35752, '2020-06-02', 'GW', 'Guinea-Bissau', 'AFRO', '17', '1339', '0', '8');
INSERT INTO public.who_global_data_import VALUES (35753, '2020-06-03', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1339', '0', '8');
INSERT INTO public.who_global_data_import VALUES (35754, '2020-06-04', 'GW', 'Guinea-Bissau', 'AFRO', '7', '1346', '1', '9');
INSERT INTO public.who_global_data_import VALUES (35755, '2020-06-05', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1346', '0', '9');
INSERT INTO public.who_global_data_import VALUES (35756, '2020-06-06', 'GW', 'Guinea-Bissau', 'AFRO', '22', '1368', '3', '12');
INSERT INTO public.who_global_data_import VALUES (35757, '2020-06-07', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1368', '0', '12');
INSERT INTO public.who_global_data_import VALUES (35758, '2020-06-08', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1368', '0', '12');
INSERT INTO public.who_global_data_import VALUES (35759, '2020-06-09', 'GW', 'Guinea-Bissau', 'AFRO', '21', '1389', '0', '12');
INSERT INTO public.who_global_data_import VALUES (35760, '2020-06-10', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1389', '0', '12');
INSERT INTO public.who_global_data_import VALUES (35761, '2020-06-11', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1389', '0', '12');
INSERT INTO public.who_global_data_import VALUES (35762, '2020-06-12', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1389', '0', '12');
INSERT INTO public.who_global_data_import VALUES (35763, '2020-06-13', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1389', '0', '12');
INSERT INTO public.who_global_data_import VALUES (35764, '2020-06-14', 'GW', 'Guinea-Bissau', 'AFRO', '71', '1460', '3', '15');
INSERT INTO public.who_global_data_import VALUES (35765, '2020-06-15', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1460', '0', '15');
INSERT INTO public.who_global_data_import VALUES (35766, '2020-06-16', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1460', '0', '15');
INSERT INTO public.who_global_data_import VALUES (35767, '2020-06-17', 'GW', 'Guinea-Bissau', 'AFRO', '32', '1492', '0', '15');
INSERT INTO public.who_global_data_import VALUES (35768, '2020-06-18', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1492', '0', '15');
INSERT INTO public.who_global_data_import VALUES (35769, '2020-06-19', 'GW', 'Guinea-Bissau', 'AFRO', '20', '1512', '1', '16');
INSERT INTO public.who_global_data_import VALUES (35770, '2020-06-20', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1512', '0', '16');
INSERT INTO public.who_global_data_import VALUES (35771, '2020-06-21', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1512', '0', '16');
INSERT INTO public.who_global_data_import VALUES (35772, '2020-06-22', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1512', '0', '16');
INSERT INTO public.who_global_data_import VALUES (35773, '2020-06-23', 'GW', 'Guinea-Bissau', 'AFRO', '44', '1556', '3', '19');
INSERT INTO public.who_global_data_import VALUES (35774, '2020-06-24', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1556', '0', '19');
INSERT INTO public.who_global_data_import VALUES (35775, '2020-06-25', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1556', '0', '19');
INSERT INTO public.who_global_data_import VALUES (35776, '2020-06-26', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1556', '0', '19');
INSERT INTO public.who_global_data_import VALUES (35777, '2020-06-27', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1556', '0', '19');
INSERT INTO public.who_global_data_import VALUES (35778, '2020-06-28', 'GW', 'Guinea-Bissau', 'AFRO', '58', '1614', '2', '21');
INSERT INTO public.who_global_data_import VALUES (35779, '2020-06-29', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1614', '0', '21');
INSERT INTO public.who_global_data_import VALUES (35780, '2020-06-30', 'GW', 'Guinea-Bissau', 'AFRO', '40', '1654', '3', '24');
INSERT INTO public.who_global_data_import VALUES (35781, '2020-07-01', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1654', '0', '24');
INSERT INTO public.who_global_data_import VALUES (35782, '2020-07-02', 'GW', 'Guinea-Bissau', 'AFRO', '56', '1710', '0', '24');
INSERT INTO public.who_global_data_import VALUES (35783, '2020-07-03', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1710', '0', '24');
INSERT INTO public.who_global_data_import VALUES (35784, '2020-07-04', 'GW', 'Guinea-Bissau', 'AFRO', '55', '1765', '1', '25');
INSERT INTO public.who_global_data_import VALUES (35785, '2020-07-05', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1765', '0', '25');
INSERT INTO public.who_global_data_import VALUES (35786, '2020-07-06', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1765', '0', '25');
INSERT INTO public.who_global_data_import VALUES (35787, '2020-07-07', 'GW', 'Guinea-Bissau', 'AFRO', '25', '1790', '0', '25');
INSERT INTO public.who_global_data_import VALUES (35788, '2020-07-08', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1790', '0', '25');
INSERT INTO public.who_global_data_import VALUES (35789, '2020-07-09', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1790', '0', '25');
INSERT INTO public.who_global_data_import VALUES (35790, '2020-07-10', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1790', '0', '25');
INSERT INTO public.who_global_data_import VALUES (35791, '2020-07-11', 'GW', 'Guinea-Bissau', 'AFRO', '52', '1842', '0', '25');
INSERT INTO public.who_global_data_import VALUES (35792, '2020-07-12', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1842', '0', '25');
INSERT INTO public.who_global_data_import VALUES (35793, '2020-07-13', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1842', '0', '25');
INSERT INTO public.who_global_data_import VALUES (35794, '2020-07-14', 'GW', 'Guinea-Bissau', 'AFRO', '60', '1902', '1', '26');
INSERT INTO public.who_global_data_import VALUES (35795, '2020-07-15', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1902', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35796, '2020-07-16', 'GW', 'Guinea-Bissau', 'AFRO', '25', '1927', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35797, '2020-07-17', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1927', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35798, '2020-07-18', 'GW', 'Guinea-Bissau', 'AFRO', '23', '1950', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35799, '2020-07-19', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1950', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35800, '2020-07-20', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1950', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35801, '2020-07-21', 'GW', 'Guinea-Bissau', 'AFRO', '4', '1954', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35802, '2020-07-22', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1954', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35803, '2020-07-23', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1954', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35804, '2020-07-24', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1954', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35805, '2020-07-25', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1954', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35806, '2020-07-26', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1954', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35807, '2020-07-27', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1954', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35808, '2020-07-28', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1954', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35809, '2020-07-29', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1954', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35810, '2020-07-30', 'GW', 'Guinea-Bissau', 'AFRO', '27', '1981', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35811, '2020-07-31', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1981', '0', '26');
INSERT INTO public.who_global_data_import VALUES (35812, '2020-08-01', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1981', '1', '27');
INSERT INTO public.who_global_data_import VALUES (35813, '2020-08-02', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1981', '0', '27');
INSERT INTO public.who_global_data_import VALUES (35814, '2020-08-03', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1981', '0', '27');
INSERT INTO public.who_global_data_import VALUES (35815, '2020-08-04', 'GW', 'Guinea-Bissau', 'AFRO', '0', '1981', '0', '27');
INSERT INTO public.who_global_data_import VALUES (35816, '2020-08-05', 'GW', 'Guinea-Bissau', 'AFRO', '41', '2022', '0', '27');
INSERT INTO public.who_global_data_import VALUES (35817, '2020-08-06', 'GW', 'Guinea-Bissau', 'AFRO', '10', '2032', '0', '27');
INSERT INTO public.who_global_data_import VALUES (35818, '2020-08-07', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2032', '0', '27');
INSERT INTO public.who_global_data_import VALUES (35819, '2020-08-08', 'GW', 'Guinea-Bissau', 'AFRO', '20', '2052', '2', '29');
INSERT INTO public.who_global_data_import VALUES (35820, '2020-08-09', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2052', '0', '29');
INSERT INTO public.who_global_data_import VALUES (35821, '2020-08-10', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2052', '0', '29');
INSERT INTO public.who_global_data_import VALUES (35822, '2020-08-11', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2052', '0', '29');
INSERT INTO public.who_global_data_import VALUES (35823, '2020-08-12', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2052', '0', '29');
INSERT INTO public.who_global_data_import VALUES (35824, '2020-08-13', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2052', '0', '29');
INSERT INTO public.who_global_data_import VALUES (35825, '2020-08-14', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2052', '0', '29');
INSERT INTO public.who_global_data_import VALUES (35826, '2020-08-15', 'GW', 'Guinea-Bissau', 'AFRO', '65', '2117', '4', '33');
INSERT INTO public.who_global_data_import VALUES (35827, '2020-08-16', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2117', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35828, '2020-08-17', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2117', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35829, '2020-08-18', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2117', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35830, '2020-08-19', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2117', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35831, '2020-08-20', 'GW', 'Guinea-Bissau', 'AFRO', '32', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35832, '2020-08-21', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35833, '2020-08-22', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35834, '2020-08-23', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35835, '2020-08-24', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35836, '2020-08-25', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35837, '2020-08-26', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35838, '2020-08-27', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35839, '2020-08-28', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35840, '2020-08-29', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35841, '2020-08-30', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35842, '2020-08-31', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35843, '2020-09-01', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35844, '2020-09-02', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35845, '2020-09-03', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2149', '0', '33');
INSERT INTO public.who_global_data_import VALUES (35846, '2020-09-04', 'GW', 'Guinea-Bissau', 'AFRO', '96', '2245', '5', '38');
INSERT INTO public.who_global_data_import VALUES (35847, '2020-09-05', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2245', '0', '38');
INSERT INTO public.who_global_data_import VALUES (35848, '2020-09-06', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2245', '0', '38');
INSERT INTO public.who_global_data_import VALUES (35849, '2020-09-07', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2245', '0', '38');
INSERT INTO public.who_global_data_import VALUES (35850, '2020-09-08', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2245', '0', '38');
INSERT INTO public.who_global_data_import VALUES (35851, '2020-09-09', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2245', '0', '38');
INSERT INTO public.who_global_data_import VALUES (35852, '2020-09-10', 'GW', 'Guinea-Bissau', 'AFRO', '30', '2275', '1', '39');
INSERT INTO public.who_global_data_import VALUES (35853, '2020-09-11', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2275', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35854, '2020-09-12', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2275', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35855, '2020-09-13', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2275', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35856, '2020-09-14', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2275', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35857, '2020-09-15', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2275', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35858, '2020-09-16', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2275', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35859, '2020-09-17', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2275', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35860, '2020-09-18', 'GW', 'Guinea-Bissau', 'AFRO', '28', '2303', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35861, '2020-09-19', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2303', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35862, '2020-09-20', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2303', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35863, '2020-09-21', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2303', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35864, '2020-09-22', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2303', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35865, '2020-09-23', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2303', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35866, '2020-09-24', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2303', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35867, '2020-09-25', 'GW', 'Guinea-Bissau', 'AFRO', '21', '2324', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35868, '2020-09-26', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2324', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35869, '2020-09-27', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2324', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35870, '2020-09-28', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2324', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35871, '2020-09-29', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2324', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35872, '2020-09-30', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2324', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35873, '2020-10-01', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2324', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35874, '2020-10-02', 'GW', 'Guinea-Bissau', 'AFRO', '38', '2362', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35875, '2020-10-03', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2362', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35876, '2020-10-04', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2362', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35877, '2020-10-05', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2362', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35878, '2020-10-06', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2362', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35879, '2020-10-07', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2362', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35880, '2020-10-08', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2362', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35881, '2020-10-09', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2362', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35882, '2020-10-10', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2362', '0', '39');
INSERT INTO public.who_global_data_import VALUES (35883, '2020-10-11', 'GW', 'Guinea-Bissau', 'AFRO', '23', '2385', '1', '40');
INSERT INTO public.who_global_data_import VALUES (35884, '2020-10-12', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2385', '0', '40');
INSERT INTO public.who_global_data_import VALUES (35885, '2020-10-13', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2385', '0', '40');
INSERT INTO public.who_global_data_import VALUES (35886, '2020-10-14', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2385', '0', '40');
INSERT INTO public.who_global_data_import VALUES (35887, '2020-10-15', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2385', '0', '40');
INSERT INTO public.who_global_data_import VALUES (35888, '2020-10-16', 'GW', 'Guinea-Bissau', 'AFRO', '4', '2389', '1', '41');
INSERT INTO public.who_global_data_import VALUES (35889, '2020-10-17', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2389', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35890, '2020-10-18', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2389', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35891, '2020-10-19', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2389', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35892, '2020-10-20', 'GW', 'Guinea-Bissau', 'AFRO', '14', '2403', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35893, '2020-10-21', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2403', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35894, '2020-10-22', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2403', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35895, '2020-10-23', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2403', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35896, '2020-10-24', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2403', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35897, '2020-10-25', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2403', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35898, '2020-10-26', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2403', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35899, '2020-10-27', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2403', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35900, '2020-10-28', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2403', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35901, '2020-10-29', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2403', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35902, '2020-10-30', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2403', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35903, '2020-10-31', 'GW', 'Guinea-Bissau', 'AFRO', '10', '2413', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35904, '2020-11-01', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2413', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35905, '2020-11-02', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2413', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35906, '2020-11-03', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2413', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35907, '2020-11-04', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2413', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35908, '2020-11-05', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2413', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35909, '2020-11-06', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2413', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35910, '2020-11-07', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2413', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35911, '2020-11-08', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2413', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35912, '2020-11-09', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2413', '0', '41');
INSERT INTO public.who_global_data_import VALUES (35913, '2020-11-10', 'GW', 'Guinea-Bissau', 'AFRO', '1', '2414', '1', '42');
INSERT INTO public.who_global_data_import VALUES (35914, '2020-11-11', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2414', '0', '42');
INSERT INTO public.who_global_data_import VALUES (35915, '2020-11-12', 'GW', 'Guinea-Bissau', 'AFRO', '5', '2419', '1', '43');
INSERT INTO public.who_global_data_import VALUES (35916, '2020-11-13', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2419', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35917, '2020-11-14', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2419', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35918, '2020-11-15', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2419', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35919, '2020-11-16', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2419', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35920, '2020-11-17', 'GW', 'Guinea-Bissau', 'AFRO', '2', '2421', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35921, '2020-11-18', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2421', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35922, '2020-11-19', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2421', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35923, '2020-11-20', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2421', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35924, '2020-11-21', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2421', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35925, '2020-11-22', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2421', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35926, '2020-11-23', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2421', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35927, '2020-11-24', 'GW', 'Guinea-Bissau', 'AFRO', '1', '2422', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35928, '2020-11-25', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2422', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35929, '2020-11-26', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2422', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35930, '2020-11-27', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2422', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35931, '2020-11-28', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2422', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35932, '2020-11-29', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2422', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35933, '2020-11-30', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2422', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35934, '2020-12-01', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2422', '0', '43');
INSERT INTO public.who_global_data_import VALUES (35935, '2020-12-02', 'GW', 'Guinea-Bissau', 'AFRO', '3', '2425', '1', '44');
INSERT INTO public.who_global_data_import VALUES (35936, '2020-12-03', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2425', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35937, '2020-12-04', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2425', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35938, '2020-12-05', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2425', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35939, '2020-12-06', 'GW', 'Guinea-Bissau', 'AFRO', '16', '2441', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35940, '2020-12-07', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2441', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35941, '2020-12-08', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2441', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35942, '2020-12-09', 'GW', 'Guinea-Bissau', 'AFRO', '3', '2444', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35943, '2020-12-10', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2444', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35944, '2020-12-11', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2444', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35945, '2020-12-12', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2444', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35946, '2020-12-13', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2444', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35947, '2020-12-14', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2444', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35948, '2020-12-15', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2444', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35949, '2020-12-16', 'GW', 'Guinea-Bissau', 'AFRO', '3', '2447', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35950, '2020-12-17', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35951, '2020-12-18', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35952, '2020-12-19', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35953, '2020-12-20', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35954, '2020-12-21', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35955, '2020-12-22', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35956, '2020-12-23', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '44');
INSERT INTO public.who_global_data_import VALUES (35957, '2020-12-24', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '1', '45');
INSERT INTO public.who_global_data_import VALUES (35958, '2020-12-25', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35959, '2020-12-26', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35960, '2020-12-27', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35961, '2020-12-28', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35962, '2020-12-29', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35963, '2020-12-30', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35964, '2020-12-31', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35965, '2021-01-01', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35966, '2021-01-02', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35967, '2021-01-03', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35968, '2021-01-04', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35969, '2021-01-05', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35970, '2021-01-06', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35971, '2021-01-07', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35972, '2021-01-08', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35973, '2021-01-09', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35974, '2021-01-10', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35975, '2021-01-11', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35976, '2021-01-12', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35977, '2021-01-13', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35978, '2021-01-14', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35979, '2021-01-15', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35980, '2021-01-16', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2447', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35981, '2021-01-17', 'GW', 'Guinea-Bissau', 'AFRO', '31', '2478', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35982, '2021-01-18', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2478', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35983, '2021-01-19', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2478', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35984, '2021-01-20', 'GW', 'Guinea-Bissau', 'AFRO', '32', '2510', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35985, '2021-01-21', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2510', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35986, '2021-01-22', 'GW', 'Guinea-Bissau', 'AFRO', '7', '2517', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35987, '2021-01-23', 'GW', 'Guinea-Bissau', 'AFRO', '8', '2525', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35988, '2021-01-24', 'GW', 'Guinea-Bissau', 'AFRO', '6', '2531', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35989, '2021-01-25', 'GW', 'Guinea-Bissau', 'AFRO', '2', '2533', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35990, '2021-01-26', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2533', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35991, '2021-01-27', 'GW', 'Guinea-Bissau', 'AFRO', '9', '2542', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35992, '2021-01-28', 'GW', 'Guinea-Bissau', 'AFRO', '2', '2544', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35993, '2021-01-29', 'GW', 'Guinea-Bissau', 'AFRO', '61', '2605', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35994, '2021-01-30', 'GW', 'Guinea-Bissau', 'AFRO', '9', '2614', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35995, '2021-01-31', 'GW', 'Guinea-Bissau', 'AFRO', '9', '2623', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35996, '2021-02-01', 'GW', 'Guinea-Bissau', 'AFRO', '12', '2635', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35997, '2021-02-02', 'GW', 'Guinea-Bissau', 'AFRO', '0', '2635', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35998, '2021-02-03', 'GW', 'Guinea-Bissau', 'AFRO', '20', '2655', '0', '45');
INSERT INTO public.who_global_data_import VALUES (35999, '2021-02-04', 'GW', 'Guinea-Bissau', 'AFRO', '7', '2662', '0', '45');
INSERT INTO public.who_global_data_import VALUES (36000, '2021-02-05', 'GW', 'Guinea-Bissau', 'AFRO', '31', '2693', '1', '46');
INSERT INTO public.who_global_data_import VALUES (36001, '2020-01-03', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36002, '2020-01-04', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36003, '2020-01-05', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36004, '2020-01-06', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36005, '2020-01-07', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36006, '2020-01-08', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36007, '2020-01-09', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36008, '2020-01-10', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36009, '2020-01-11', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36010, '2020-01-12', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36011, '2020-01-13', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36012, '2020-01-14', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36013, '2020-01-15', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36014, '2020-01-16', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36015, '2020-01-17', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36016, '2020-01-18', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36017, '2020-01-19', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36018, '2020-01-20', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36019, '2020-01-21', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36020, '2020-01-22', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36021, '2020-01-23', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36022, '2020-01-24', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36023, '2020-01-25', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36024, '2020-01-26', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36025, '2020-01-27', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36026, '2020-01-28', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36027, '2020-01-29', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36028, '2020-01-30', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36029, '2020-01-31', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36030, '2020-02-01', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36031, '2020-02-02', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36032, '2020-02-03', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36033, '2020-02-04', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36034, '2020-02-05', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36035, '2020-02-06', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36036, '2020-02-07', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36037, '2020-02-08', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36038, '2020-02-09', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36039, '2020-02-10', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36040, '2020-02-11', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36041, '2020-02-12', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36042, '2020-02-13', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36043, '2020-02-14', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36044, '2020-02-15', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36045, '2020-02-16', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36046, '2020-02-17', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36047, '2020-02-18', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36048, '2020-02-19', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36049, '2020-02-20', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36050, '2020-02-21', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36051, '2020-02-22', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36052, '2020-02-23', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36053, '2020-02-24', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36054, '2020-02-25', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36055, '2020-02-26', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36056, '2020-02-27', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36057, '2020-02-28', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36058, '2020-02-29', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36059, '2020-03-01', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36060, '2020-03-02', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36061, '2020-03-03', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36062, '2020-03-04', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36063, '2020-03-05', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36064, '2020-03-06', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36065, '2020-03-07', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36066, '2020-03-08', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36067, '2020-03-09', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36068, '2020-03-10', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36069, '2020-03-11', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36070, '2020-03-12', 'GY', 'Guyana', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36071, '2020-03-13', 'GY', 'Guyana', 'AMRO', '5', '5', '1', '1');
INSERT INTO public.who_global_data_import VALUES (36072, '2020-03-14', 'GY', 'Guyana', 'AMRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36073, '2020-03-15', 'GY', 'Guyana', 'AMRO', '3', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36074, '2020-03-16', 'GY', 'Guyana', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36075, '2020-03-17', 'GY', 'Guyana', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36076, '2020-03-18', 'GY', 'Guyana', 'AMRO', '1', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36077, '2020-03-19', 'GY', 'Guyana', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36078, '2020-03-20', 'GY', 'Guyana', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36079, '2020-03-21', 'GY', 'Guyana', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36080, '2020-03-22', 'GY', 'Guyana', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36081, '2020-03-23', 'GY', 'Guyana', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36082, '2020-03-24', 'GY', 'Guyana', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36083, '2020-03-25', 'GY', 'Guyana', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36084, '2020-03-26', 'GY', 'Guyana', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36085, '2020-03-27', 'GY', 'Guyana', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36086, '2020-03-28', 'GY', 'Guyana', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36087, '2020-03-29', 'GY', 'Guyana', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36088, '2020-03-30', 'GY', 'Guyana', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36089, '2020-03-31', 'GY', 'Guyana', 'AMRO', '-1', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36090, '2020-04-01', 'GY', 'Guyana', 'AMRO', '4', '12', '1', '2');
INSERT INTO public.who_global_data_import VALUES (36091, '2020-04-02', 'GY', 'Guyana', 'AMRO', '7', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (36092, '2020-04-03', 'GY', 'Guyana', 'AMRO', '0', '19', '2', '4');
INSERT INTO public.who_global_data_import VALUES (36093, '2020-04-04', 'GY', 'Guyana', 'AMRO', '0', '19', '0', '4');
INSERT INTO public.who_global_data_import VALUES (36094, '2020-04-05', 'GY', 'Guyana', 'AMRO', '4', '23', '0', '4');
INSERT INTO public.who_global_data_import VALUES (36095, '2020-04-06', 'GY', 'Guyana', 'AMRO', '1', '24', '0', '4');
INSERT INTO public.who_global_data_import VALUES (36096, '2020-04-07', 'GY', 'Guyana', 'AMRO', '5', '29', '0', '4');
INSERT INTO public.who_global_data_import VALUES (36097, '2020-04-08', 'GY', 'Guyana', 'AMRO', '2', '31', '1', '5');
INSERT INTO public.who_global_data_import VALUES (36098, '2020-04-09', 'GY', 'Guyana', 'AMRO', '2', '33', '0', '5');
INSERT INTO public.who_global_data_import VALUES (36099, '2020-04-10', 'GY', 'Guyana', 'AMRO', '4', '37', '1', '6');
INSERT INTO public.who_global_data_import VALUES (36100, '2020-04-11', 'GY', 'Guyana', 'AMRO', '0', '37', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36101, '2020-04-12', 'GY', 'Guyana', 'AMRO', '0', '37', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36102, '2020-04-13', 'GY', 'Guyana', 'AMRO', '0', '37', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36103, '2020-04-14', 'GY', 'Guyana', 'AMRO', '10', '47', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36104, '2020-04-15', 'GY', 'Guyana', 'AMRO', '0', '47', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36105, '2020-04-16', 'GY', 'Guyana', 'AMRO', '1', '48', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36106, '2020-04-17', 'GY', 'Guyana', 'AMRO', '7', '55', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36107, '2020-04-18', 'GY', 'Guyana', 'AMRO', '2', '57', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36108, '2020-04-19', 'GY', 'Guyana', 'AMRO', '6', '63', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36109, '2020-04-20', 'GY', 'Guyana', 'AMRO', '0', '63', '1', '7');
INSERT INTO public.who_global_data_import VALUES (36110, '2020-04-21', 'GY', 'Guyana', 'AMRO', '2', '65', '0', '7');
INSERT INTO public.who_global_data_import VALUES (36111, '2020-04-22', 'GY', 'Guyana', 'AMRO', '1', '66', '0', '7');
INSERT INTO public.who_global_data_import VALUES (36112, '2020-04-23', 'GY', 'Guyana', 'AMRO', '1', '67', '0', '7');
INSERT INTO public.who_global_data_import VALUES (36113, '2020-04-24', 'GY', 'Guyana', 'AMRO', '0', '67', '0', '7');
INSERT INTO public.who_global_data_import VALUES (36114, '2020-04-25', 'GY', 'Guyana', 'AMRO', '3', '70', '0', '7');
INSERT INTO public.who_global_data_import VALUES (36115, '2020-04-26', 'GY', 'Guyana', 'AMRO', '3', '73', '0', '7');
INSERT INTO public.who_global_data_import VALUES (36116, '2020-04-27', 'GY', 'Guyana', 'AMRO', '1', '74', '1', '8');
INSERT INTO public.who_global_data_import VALUES (36117, '2020-04-28', 'GY', 'Guyana', 'AMRO', '0', '74', '0', '8');
INSERT INTO public.who_global_data_import VALUES (36118, '2020-04-29', 'GY', 'Guyana', 'AMRO', '0', '74', '0', '8');
INSERT INTO public.who_global_data_import VALUES (36119, '2020-04-30', 'GY', 'Guyana', 'AMRO', '1', '75', '0', '8');
INSERT INTO public.who_global_data_import VALUES (36120, '2020-05-01', 'GY', 'Guyana', 'AMRO', '3', '78', '0', '8');
INSERT INTO public.who_global_data_import VALUES (36121, '2020-05-02', 'GY', 'Guyana', 'AMRO', '4', '82', '1', '9');
INSERT INTO public.who_global_data_import VALUES (36122, '2020-05-03', 'GY', 'Guyana', 'AMRO', '0', '82', '0', '9');
INSERT INTO public.who_global_data_import VALUES (36123, '2020-05-04', 'GY', 'Guyana', 'AMRO', '0', '82', '0', '9');
INSERT INTO public.who_global_data_import VALUES (36124, '2020-05-05', 'GY', 'Guyana', 'AMRO', '0', '82', '0', '9');
INSERT INTO public.who_global_data_import VALUES (36125, '2020-05-06', 'GY', 'Guyana', 'AMRO', '10', '92', '0', '9');
INSERT INTO public.who_global_data_import VALUES (36126, '2020-05-07', 'GY', 'Guyana', 'AMRO', '1', '93', '1', '10');
INSERT INTO public.who_global_data_import VALUES (36127, '2020-05-08', 'GY', 'Guyana', 'AMRO', '0', '93', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36128, '2020-05-09', 'GY', 'Guyana', 'AMRO', '0', '93', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36129, '2020-05-10', 'GY', 'Guyana', 'AMRO', '0', '93', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36130, '2020-05-11', 'GY', 'Guyana', 'AMRO', '4', '97', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36131, '2020-05-12', 'GY', 'Guyana', 'AMRO', '7', '104', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36132, '2020-05-13', 'GY', 'Guyana', 'AMRO', '5', '109', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36133, '2020-05-14', 'GY', 'Guyana', 'AMRO', '4', '113', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36134, '2020-05-15', 'GY', 'Guyana', 'AMRO', '0', '113', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36135, '2020-05-16', 'GY', 'Guyana', 'AMRO', '0', '113', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36136, '2020-05-17', 'GY', 'Guyana', 'AMRO', '3', '116', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36137, '2020-05-18', 'GY', 'Guyana', 'AMRO', '1', '117', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36138, '2020-05-19', 'GY', 'Guyana', 'AMRO', '0', '117', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36139, '2020-05-20', 'GY', 'Guyana', 'AMRO', '7', '124', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36140, '2020-05-21', 'GY', 'Guyana', 'AMRO', '1', '125', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36141, '2020-05-22', 'GY', 'Guyana', 'AMRO', '0', '125', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36142, '2020-05-23', 'GY', 'Guyana', 'AMRO', '2', '127', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36143, '2020-05-24', 'GY', 'Guyana', 'AMRO', '0', '127', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36144, '2020-05-25', 'GY', 'Guyana', 'AMRO', '0', '127', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36145, '2020-05-26', 'GY', 'Guyana', 'AMRO', '8', '135', '0', '10');
INSERT INTO public.who_global_data_import VALUES (36146, '2020-05-27', 'GY', 'Guyana', 'AMRO', '2', '137', '1', '11');
INSERT INTO public.who_global_data_import VALUES (36147, '2020-05-28', 'GY', 'Guyana', 'AMRO', '2', '139', '0', '11');
INSERT INTO public.who_global_data_import VALUES (36148, '2020-05-29', 'GY', 'Guyana', 'AMRO', '0', '139', '0', '11');
INSERT INTO public.who_global_data_import VALUES (36149, '2020-05-30', 'GY', 'Guyana', 'AMRO', '11', '150', '0', '11');
INSERT INTO public.who_global_data_import VALUES (36150, '2020-05-31', 'GY', 'Guyana', 'AMRO', '0', '150', '0', '11');
INSERT INTO public.who_global_data_import VALUES (36151, '2020-06-01', 'GY', 'Guyana', 'AMRO', '2', '152', '1', '12');
INSERT INTO public.who_global_data_import VALUES (36152, '2020-06-02', 'GY', 'Guyana', 'AMRO', '1', '153', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36153, '2020-06-03', 'GY', 'Guyana', 'AMRO', '0', '153', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36154, '2020-06-04', 'GY', 'Guyana', 'AMRO', '0', '153', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36155, '2020-06-05', 'GY', 'Guyana', 'AMRO', '0', '153', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36156, '2020-06-06', 'GY', 'Guyana', 'AMRO', '0', '153', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36157, '2020-06-07', 'GY', 'Guyana', 'AMRO', '0', '153', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36158, '2020-06-08', 'GY', 'Guyana', 'AMRO', '1', '154', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36159, '2020-06-09', 'GY', 'Guyana', 'AMRO', '0', '154', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36160, '2020-06-10', 'GY', 'Guyana', 'AMRO', '0', '154', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36161, '2020-06-11', 'GY', 'Guyana', 'AMRO', '2', '156', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36162, '2020-06-12', 'GY', 'Guyana', 'AMRO', '0', '156', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36163, '2020-06-13', 'GY', 'Guyana', 'AMRO', '2', '158', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36164, '2020-06-14', 'GY', 'Guyana', 'AMRO', '1', '159', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36165, '2020-06-15', 'GY', 'Guyana', 'AMRO', '0', '159', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36166, '2020-06-16', 'GY', 'Guyana', 'AMRO', '0', '159', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36167, '2020-06-17', 'GY', 'Guyana', 'AMRO', '0', '159', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36168, '2020-06-18', 'GY', 'Guyana', 'AMRO', '12', '171', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36169, '2020-06-19', 'GY', 'Guyana', 'AMRO', '12', '183', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36170, '2020-06-20', 'GY', 'Guyana', 'AMRO', '0', '183', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36171, '2020-06-21', 'GY', 'Guyana', 'AMRO', '0', '183', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36172, '2020-06-22', 'GY', 'Guyana', 'AMRO', '0', '183', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36173, '2020-06-23', 'GY', 'Guyana', 'AMRO', '1', '184', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36174, '2020-06-24', 'GY', 'Guyana', 'AMRO', '21', '205', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36175, '2020-06-25', 'GY', 'Guyana', 'AMRO', '1', '206', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36176, '2020-06-26', 'GY', 'Guyana', 'AMRO', '3', '209', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36177, '2020-06-27', 'GY', 'Guyana', 'AMRO', '6', '215', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36178, '2020-06-28', 'GY', 'Guyana', 'AMRO', '15', '230', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36179, '2020-06-29', 'GY', 'Guyana', 'AMRO', '0', '230', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36180, '2020-06-30', 'GY', 'Guyana', 'AMRO', '0', '230', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36181, '2020-07-01', 'GY', 'Guyana', 'AMRO', '5', '235', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36182, '2020-07-02', 'GY', 'Guyana', 'AMRO', '10', '245', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36183, '2020-07-03', 'GY', 'Guyana', 'AMRO', '3', '248', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36184, '2020-07-04', 'GY', 'Guyana', 'AMRO', '2', '250', '2', '14');
INSERT INTO public.who_global_data_import VALUES (36185, '2020-07-05', 'GY', 'Guyana', 'AMRO', '6', '256', '0', '14');
INSERT INTO public.who_global_data_import VALUES (36186, '2020-07-06', 'GY', 'Guyana', 'AMRO', '16', '272', '0', '14');
INSERT INTO public.who_global_data_import VALUES (36187, '2020-07-07', 'GY', 'Guyana', 'AMRO', '1', '273', '1', '15');
INSERT INTO public.who_global_data_import VALUES (36188, '2020-07-08', 'GY', 'Guyana', 'AMRO', '5', '278', '1', '16');
INSERT INTO public.who_global_data_import VALUES (36189, '2020-07-09', 'GY', 'Guyana', 'AMRO', '6', '284', '0', '16');
INSERT INTO public.who_global_data_import VALUES (36190, '2020-07-10', 'GY', 'Guyana', 'AMRO', '1', '285', '0', '16');
INSERT INTO public.who_global_data_import VALUES (36191, '2020-07-11', 'GY', 'Guyana', 'AMRO', '1', '286', '0', '16');
INSERT INTO public.who_global_data_import VALUES (36192, '2020-07-12', 'GY', 'Guyana', 'AMRO', '4', '290', '0', '16');
INSERT INTO public.who_global_data_import VALUES (36193, '2020-07-13', 'GY', 'Guyana', 'AMRO', '1', '291', '1', '17');
INSERT INTO public.who_global_data_import VALUES (36194, '2020-07-14', 'GY', 'Guyana', 'AMRO', '6', '297', '0', '17');
INSERT INTO public.who_global_data_import VALUES (36195, '2020-07-15', 'GY', 'Guyana', 'AMRO', '3', '300', '0', '17');
INSERT INTO public.who_global_data_import VALUES (36196, '2020-07-16', 'GY', 'Guyana', 'AMRO', '8', '308', '1', '18');
INSERT INTO public.who_global_data_import VALUES (36197, '2020-07-17', 'GY', 'Guyana', 'AMRO', '5', '313', '1', '19');
INSERT INTO public.who_global_data_import VALUES (36198, '2020-07-18', 'GY', 'Guyana', 'AMRO', '2', '315', '0', '19');
INSERT INTO public.who_global_data_import VALUES (36199, '2020-07-19', 'GY', 'Guyana', 'AMRO', '5', '320', '0', '19');
INSERT INTO public.who_global_data_import VALUES (36200, '2020-07-20', 'GY', 'Guyana', 'AMRO', '7', '327', '0', '19');
INSERT INTO public.who_global_data_import VALUES (36201, '2020-07-21', 'GY', 'Guyana', 'AMRO', '9', '336', '0', '19');
INSERT INTO public.who_global_data_import VALUES (36202, '2020-07-22', 'GY', 'Guyana', 'AMRO', '1', '337', '0', '19');
INSERT INTO public.who_global_data_import VALUES (36203, '2020-07-23', 'GY', 'Guyana', 'AMRO', '2', '339', '0', '19');
INSERT INTO public.who_global_data_import VALUES (36204, '2020-07-24', 'GY', 'Guyana', 'AMRO', '11', '350', '0', '19');
INSERT INTO public.who_global_data_import VALUES (36205, '2020-07-25', 'GY', 'Guyana', 'AMRO', '1', '351', '0', '19');
INSERT INTO public.who_global_data_import VALUES (36206, '2020-07-26', 'GY', 'Guyana', 'AMRO', '1', '352', '1', '20');
INSERT INTO public.who_global_data_import VALUES (36207, '2020-07-27', 'GY', 'Guyana', 'AMRO', '8', '360', '0', '20');
INSERT INTO public.who_global_data_import VALUES (36208, '2020-07-28', 'GY', 'Guyana', 'AMRO', '10', '370', '0', '20');
INSERT INTO public.who_global_data_import VALUES (36209, '2020-07-29', 'GY', 'Guyana', 'AMRO', '19', '389', '0', '20');
INSERT INTO public.who_global_data_import VALUES (36210, '2020-07-30', 'GY', 'Guyana', 'AMRO', '7', '396', '0', '20');
INSERT INTO public.who_global_data_import VALUES (36211, '2020-07-31', 'GY', 'Guyana', 'AMRO', '2', '398', '0', '20');
INSERT INTO public.who_global_data_import VALUES (36212, '2020-08-01', 'GY', 'Guyana', 'AMRO', '3', '401', '0', '20');
INSERT INTO public.who_global_data_import VALUES (36213, '2020-08-02', 'GY', 'Guyana', 'AMRO', '12', '413', '0', '20');
INSERT INTO public.who_global_data_import VALUES (36214, '2020-08-03', 'GY', 'Guyana', 'AMRO', '17', '430', '0', '20');
INSERT INTO public.who_global_data_import VALUES (36215, '2020-08-04', 'GY', 'Guyana', 'AMRO', '44', '474', '1', '21');
INSERT INTO public.who_global_data_import VALUES (36216, '2020-08-05', 'GY', 'Guyana', 'AMRO', '0', '474', '0', '21');
INSERT INTO public.who_global_data_import VALUES (36217, '2020-08-06', 'GY', 'Guyana', 'AMRO', '23', '497', '1', '22');
INSERT INTO public.who_global_data_import VALUES (36218, '2020-08-07', 'GY', 'Guyana', 'AMRO', '12', '509', '0', '22');
INSERT INTO public.who_global_data_import VALUES (36219, '2020-08-08', 'GY', 'Guyana', 'AMRO', '29', '538', '0', '22');
INSERT INTO public.who_global_data_import VALUES (36220, '2020-08-09', 'GY', 'Guyana', 'AMRO', '0', '538', '0', '22');
INSERT INTO public.who_global_data_import VALUES (36221, '2020-08-10', 'GY', 'Guyana', 'AMRO', '16', '554', '0', '22');
INSERT INTO public.who_global_data_import VALUES (36222, '2020-08-11', 'GY', 'Guyana', 'AMRO', '14', '568', '0', '22');
INSERT INTO public.who_global_data_import VALUES (36223, '2020-08-12', 'GY', 'Guyana', 'AMRO', '0', '568', '0', '22');
INSERT INTO public.who_global_data_import VALUES (36224, '2020-08-13', 'GY', 'Guyana', 'AMRO', '34', '602', '0', '22');
INSERT INTO public.who_global_data_import VALUES (36225, '2020-08-14', 'GY', 'Guyana', 'AMRO', '21', '623', '0', '22');
INSERT INTO public.who_global_data_import VALUES (36226, '2020-08-15', 'GY', 'Guyana', 'AMRO', '8', '631', '0', '22');
INSERT INTO public.who_global_data_import VALUES (36227, '2020-08-16', 'GY', 'Guyana', 'AMRO', '18', '649', '0', '22');
INSERT INTO public.who_global_data_import VALUES (36228, '2020-08-17', 'GY', 'Guyana', 'AMRO', '25', '674', '0', '22');
INSERT INTO public.who_global_data_import VALUES (36229, '2020-08-18', 'GY', 'Guyana', 'AMRO', '35', '709', '1', '23');
INSERT INTO public.who_global_data_import VALUES (36230, '2020-08-19', 'GY', 'Guyana', 'AMRO', '0', '709', '0', '23');
INSERT INTO public.who_global_data_import VALUES (36231, '2020-08-20', 'GY', 'Guyana', 'AMRO', '28', '737', '3', '26');
INSERT INTO public.who_global_data_import VALUES (36232, '2020-08-21', 'GY', 'Guyana', 'AMRO', '39', '776', '3', '29');
INSERT INTO public.who_global_data_import VALUES (36233, '2020-08-22', 'GY', 'Guyana', 'AMRO', '70', '846', '0', '29');
INSERT INTO public.who_global_data_import VALUES (36234, '2020-08-23', 'GY', 'Guyana', 'AMRO', '35', '881', '1', '30');
INSERT INTO public.who_global_data_import VALUES (36235, '2020-08-24', 'GY', 'Guyana', 'AMRO', '44', '925', '1', '31');
INSERT INTO public.who_global_data_import VALUES (36236, '2020-08-25', 'GY', 'Guyana', 'AMRO', '30', '955', '0', '31');
INSERT INTO public.who_global_data_import VALUES (36237, '2020-08-26', 'GY', 'Guyana', 'AMRO', '74', '1029', '0', '31');
INSERT INTO public.who_global_data_import VALUES (36238, '2020-08-27', 'GY', 'Guyana', 'AMRO', '31', '1060', '0', '31');
INSERT INTO public.who_global_data_import VALUES (36239, '2020-08-28', 'GY', 'Guyana', 'AMRO', '33', '1093', '0', '31');
INSERT INTO public.who_global_data_import VALUES (36240, '2020-08-29', 'GY', 'Guyana', 'AMRO', '47', '1140', '1', '32');
INSERT INTO public.who_global_data_import VALUES (36241, '2020-08-30', 'GY', 'Guyana', 'AMRO', '40', '1180', '3', '35');
INSERT INTO public.who_global_data_import VALUES (36242, '2020-08-31', 'GY', 'Guyana', 'AMRO', '4', '1184', '0', '35');
INSERT INTO public.who_global_data_import VALUES (36243, '2020-09-01', 'GY', 'Guyana', 'AMRO', '50', '1234', '2', '37');
INSERT INTO public.who_global_data_import VALUES (36244, '2020-09-02', 'GY', 'Guyana', 'AMRO', '72', '1306', '2', '39');
INSERT INTO public.who_global_data_import VALUES (36245, '2020-09-03', 'GY', 'Guyana', 'AMRO', '67', '1373', '2', '41');
INSERT INTO public.who_global_data_import VALUES (36246, '2020-09-04', 'GY', 'Guyana', 'AMRO', '9', '1382', '0', '41');
INSERT INTO public.who_global_data_import VALUES (36247, '2020-09-05', 'GY', 'Guyana', 'AMRO', '19', '1401', '3', '44');
INSERT INTO public.who_global_data_import VALUES (36248, '2020-09-06', 'GY', 'Guyana', 'AMRO', '15', '1416', '0', '44');
INSERT INTO public.who_global_data_import VALUES (36249, '2020-09-07', 'GY', 'Guyana', 'AMRO', '43', '1459', '2', '46');
INSERT INTO public.who_global_data_import VALUES (36250, '2020-09-08', 'GY', 'Guyana', 'AMRO', '9', '1468', '0', '46');
INSERT INTO public.who_global_data_import VALUES (36251, '2020-09-09', 'GY', 'Guyana', 'AMRO', '92', '1560', '1', '47');
INSERT INTO public.who_global_data_import VALUES (36252, '2020-09-10', 'GY', 'Guyana', 'AMRO', '53', '1613', '1', '48');
INSERT INTO public.who_global_data_import VALUES (36253, '2020-09-11', 'GY', 'Guyana', 'AMRO', '90', '1703', '0', '48');
INSERT INTO public.who_global_data_import VALUES (36254, '2020-09-12', 'GY', 'Guyana', 'AMRO', '47', '1750', '1', '49');
INSERT INTO public.who_global_data_import VALUES (36255, '2020-09-13', 'GY', 'Guyana', 'AMRO', '13', '1763', '3', '52');
INSERT INTO public.who_global_data_import VALUES (36256, '2020-09-14', 'GY', 'Guyana', 'AMRO', '49', '1812', '2', '54');
INSERT INTO public.who_global_data_import VALUES (36257, '2020-09-15', 'GY', 'Guyana', 'AMRO', '41', '1853', '2', '56');
INSERT INTO public.who_global_data_import VALUES (36258, '2020-09-16', 'GY', 'Guyana', 'AMRO', '31', '1884', '0', '56');
INSERT INTO public.who_global_data_import VALUES (36259, '2020-09-17', 'GY', 'Guyana', 'AMRO', '74', '1958', '2', '58');
INSERT INTO public.who_global_data_import VALUES (36260, '2020-09-18', 'GY', 'Guyana', 'AMRO', '26', '1984', '2', '60');
INSERT INTO public.who_global_data_import VALUES (36261, '2020-09-19', 'GY', 'Guyana', 'AMRO', '43', '2027', '2', '62');
INSERT INTO public.who_global_data_import VALUES (36262, '2020-09-20', 'GY', 'Guyana', 'AMRO', '75', '2102', '0', '62');
INSERT INTO public.who_global_data_import VALUES (36263, '2020-09-21', 'GY', 'Guyana', 'AMRO', '66', '2168', '2', '64');
INSERT INTO public.who_global_data_import VALUES (36264, '2020-09-22', 'GY', 'Guyana', 'AMRO', '101', '2269', '0', '64');
INSERT INTO public.who_global_data_import VALUES (36265, '2020-09-23', 'GY', 'Guyana', 'AMRO', '133', '2402', '3', '67');
INSERT INTO public.who_global_data_import VALUES (36266, '2020-09-24', 'GY', 'Guyana', 'AMRO', '35', '2437', '1', '68');
INSERT INTO public.who_global_data_import VALUES (36267, '2020-09-25', 'GY', 'Guyana', 'AMRO', '98', '2535', '1', '69');
INSERT INTO public.who_global_data_import VALUES (36268, '2020-09-26', 'GY', 'Guyana', 'AMRO', '44', '2579', '2', '71');
INSERT INTO public.who_global_data_import VALUES (36269, '2020-09-27', 'GY', 'Guyana', 'AMRO', '130', '2709', '2', '73');
INSERT INTO public.who_global_data_import VALUES (36270, '2020-09-28', 'GY', 'Guyana', 'AMRO', '16', '2725', '1', '74');
INSERT INTO public.who_global_data_import VALUES (36271, '2020-09-29', 'GY', 'Guyana', 'AMRO', '47', '2772', '2', '76');
INSERT INTO public.who_global_data_import VALUES (36272, '2020-09-30', 'GY', 'Guyana', 'AMRO', '15', '2787', '2', '78');
INSERT INTO public.who_global_data_import VALUES (36273, '2020-10-01', 'GY', 'Guyana', 'AMRO', '59', '2846', '0', '78');
INSERT INTO public.who_global_data_import VALUES (36274, '2020-10-02', 'GY', 'Guyana', 'AMRO', '48', '2894', '2', '80');
INSERT INTO public.who_global_data_import VALUES (36275, '2020-10-03', 'GY', 'Guyana', 'AMRO', '35', '2929', '2', '82');
INSERT INTO public.who_global_data_import VALUES (36276, '2020-10-04', 'GY', 'Guyana', 'AMRO', '39', '2968', '3', '85');
INSERT INTO public.who_global_data_import VALUES (36277, '2020-10-05', 'GY', 'Guyana', 'AMRO', '37', '3005', '0', '85');
INSERT INTO public.who_global_data_import VALUES (36278, '2020-10-06', 'GY', 'Guyana', 'AMRO', '88', '3093', '2', '87');
INSERT INTO public.who_global_data_import VALUES (36279, '2020-10-07', 'GY', 'Guyana', 'AMRO', '95', '3188', '3', '90');
INSERT INTO public.who_global_data_import VALUES (36280, '2020-10-08', 'GY', 'Guyana', 'AMRO', '0', '3188', '2', '92');
INSERT INTO public.who_global_data_import VALUES (36281, '2020-10-09', 'GY', 'Guyana', 'AMRO', '104', '3292', '3', '95');
INSERT INTO public.who_global_data_import VALUES (36282, '2020-10-10', 'GY', 'Guyana', 'AMRO', '37', '3329', '3', '98');
INSERT INTO public.who_global_data_import VALUES (36283, '2020-10-11', 'GY', 'Guyana', 'AMRO', '29', '3358', '2', '100');
INSERT INTO public.who_global_data_import VALUES (36284, '2020-10-12', 'GY', 'Guyana', 'AMRO', '47', '3405', '2', '102');
INSERT INTO public.who_global_data_import VALUES (36285, '2020-10-13', 'GY', 'Guyana', 'AMRO', '64', '3469', '1', '103');
INSERT INTO public.who_global_data_import VALUES (36286, '2020-10-14', 'GY', 'Guyana', 'AMRO', '52', '3521', '1', '104');
INSERT INTO public.who_global_data_import VALUES (36287, '2020-10-15', 'GY', 'Guyana', 'AMRO', '44', '3565', '2', '106');
INSERT INTO public.who_global_data_import VALUES (36288, '2020-10-16', 'GY', 'Guyana', 'AMRO', '24', '3589', '0', '106');
INSERT INTO public.who_global_data_import VALUES (36289, '2020-10-17', 'GY', 'Guyana', 'AMRO', '31', '3620', '1', '107');
INSERT INTO public.who_global_data_import VALUES (36290, '2020-10-18', 'GY', 'Guyana', 'AMRO', '52', '3672', '0', '107');
INSERT INTO public.who_global_data_import VALUES (36291, '2020-10-19', 'GY', 'Guyana', 'AMRO', '38', '3710', '2', '109');
INSERT INTO public.who_global_data_import VALUES (36292, '2020-10-20', 'GY', 'Guyana', 'AMRO', '24', '3734', '0', '109');
INSERT INTO public.who_global_data_import VALUES (36293, '2020-10-21', 'GY', 'Guyana', 'AMRO', '31', '3765', '2', '111');
INSERT INTO public.who_global_data_import VALUES (36294, '2020-10-22', 'GY', 'Guyana', 'AMRO', '31', '3796', '3', '114');
INSERT INTO public.who_global_data_import VALUES (36295, '2020-10-23', 'GY', 'Guyana', 'AMRO', '54', '3850', '2', '116');
INSERT INTO public.who_global_data_import VALUES (36296, '2020-10-24', 'GY', 'Guyana', 'AMRO', '27', '3877', '1', '117');
INSERT INTO public.who_global_data_import VALUES (36297, '2020-10-25', 'GY', 'Guyana', 'AMRO', '83', '3960', '0', '117');
INSERT INTO public.who_global_data_import VALUES (36298, '2020-10-26', 'GY', 'Guyana', 'AMRO', '34', '3994', '0', '117');
INSERT INTO public.who_global_data_import VALUES (36299, '2020-10-27', 'GY', 'Guyana', 'AMRO', '29', '4023', '2', '119');
INSERT INTO public.who_global_data_import VALUES (36300, '2020-10-28', 'GY', 'Guyana', 'AMRO', '3', '4026', '0', '119');
INSERT INTO public.who_global_data_import VALUES (36301, '2020-10-29', 'GY', 'Guyana', 'AMRO', '35', '4061', '0', '119');
INSERT INTO public.who_global_data_import VALUES (36302, '2020-10-30', 'GY', 'Guyana', 'AMRO', '13', '4074', '4', '123');
INSERT INTO public.who_global_data_import VALUES (36303, '2020-10-31', 'GY', 'Guyana', 'AMRO', '24', '4098', '0', '123');
INSERT INTO public.who_global_data_import VALUES (36304, '2020-11-01', 'GY', 'Guyana', 'AMRO', '45', '4143', '1', '124');
INSERT INTO public.who_global_data_import VALUES (36305, '2020-11-02', 'GY', 'Guyana', 'AMRO', '19', '4162', '0', '124');
INSERT INTO public.who_global_data_import VALUES (36306, '2020-11-03', 'GY', 'Guyana', 'AMRO', '46', '4208', '2', '126');
INSERT INTO public.who_global_data_import VALUES (36307, '2020-11-04', 'GY', 'Guyana', 'AMRO', '30', '4238', '2', '128');
INSERT INTO public.who_global_data_import VALUES (36308, '2020-11-05', 'GY', 'Guyana', 'AMRO', '7', '4245', '0', '128');
INSERT INTO public.who_global_data_import VALUES (36309, '2020-11-06', 'GY', 'Guyana', 'AMRO', '79', '4324', '2', '130');
INSERT INTO public.who_global_data_import VALUES (36310, '2020-11-07', 'GY', 'Guyana', 'AMRO', '69', '4393', '0', '130');
INSERT INTO public.who_global_data_import VALUES (36311, '2020-11-08', 'GY', 'Guyana', 'AMRO', '64', '4457', '3', '133');
INSERT INTO public.who_global_data_import VALUES (36312, '2020-11-09', 'GY', 'Guyana', 'AMRO', '27', '4484', '1', '134');
INSERT INTO public.who_global_data_import VALUES (36313, '2020-11-10', 'GY', 'Guyana', 'AMRO', '30', '4514', '0', '134');
INSERT INTO public.who_global_data_import VALUES (36314, '2020-11-11', 'GY', 'Guyana', 'AMRO', '10', '4524', '1', '135');
INSERT INTO public.who_global_data_import VALUES (36315, '2020-11-12', 'GY', 'Guyana', 'AMRO', '6', '4530', '2', '137');
INSERT INTO public.who_global_data_import VALUES (36316, '2020-11-13', 'GY', 'Guyana', 'AMRO', '88', '4618', '0', '137');
INSERT INTO public.who_global_data_import VALUES (36317, '2020-11-14', 'GY', 'Guyana', 'AMRO', '44', '4662', '1', '138');
INSERT INTO public.who_global_data_import VALUES (36318, '2020-11-15', 'GY', 'Guyana', 'AMRO', '62', '4724', '0', '138');
INSERT INTO public.who_global_data_import VALUES (36319, '2020-11-16', 'GY', 'Guyana', 'AMRO', '70', '4794', '0', '138');
INSERT INTO public.who_global_data_import VALUES (36320, '2020-11-17', 'GY', 'Guyana', 'AMRO', '29', '4823', '1', '139');
INSERT INTO public.who_global_data_import VALUES (36321, '2020-11-18', 'GY', 'Guyana', 'AMRO', '51', '4874', '0', '139');
INSERT INTO public.who_global_data_import VALUES (36322, '2020-11-19', 'GY', 'Guyana', 'AMRO', '16', '4890', '1', '140');
INSERT INTO public.who_global_data_import VALUES (36323, '2020-11-20', 'GY', 'Guyana', 'AMRO', '24', '4914', '2', '142');
INSERT INTO public.who_global_data_import VALUES (36324, '2020-11-21', 'GY', 'Guyana', 'AMRO', '62', '4976', '1', '143');
INSERT INTO public.who_global_data_import VALUES (36325, '2020-11-22', 'GY', 'Guyana', 'AMRO', '29', '5005', '0', '143');
INSERT INTO public.who_global_data_import VALUES (36326, '2020-11-23', 'GY', 'Guyana', 'AMRO', '88', '5093', '0', '143');
INSERT INTO public.who_global_data_import VALUES (36327, '2020-11-24', 'GY', 'Guyana', 'AMRO', '40', '5133', '0', '143');
INSERT INTO public.who_global_data_import VALUES (36328, '2020-11-25', 'GY', 'Guyana', 'AMRO', '21', '5154', '3', '146');
INSERT INTO public.who_global_data_import VALUES (36329, '2020-11-26', 'GY', 'Guyana', 'AMRO', '35', '5189', '1', '147');
INSERT INTO public.who_global_data_import VALUES (36330, '2020-11-27', 'GY', 'Guyana', 'AMRO', '47', '5236', '0', '147');
INSERT INTO public.who_global_data_import VALUES (36331, '2020-11-28', 'GY', 'Guyana', 'AMRO', '40', '5276', '2', '149');
INSERT INTO public.who_global_data_import VALUES (36332, '2020-11-29', 'GY', 'Guyana', 'AMRO', '34', '5310', '0', '149');
INSERT INTO public.who_global_data_import VALUES (36333, '2020-11-30', 'GY', 'Guyana', 'AMRO', '28', '5338', '0', '149');
INSERT INTO public.who_global_data_import VALUES (36334, '2020-12-01', 'GY', 'Guyana', 'AMRO', '38', '5376', '1', '150');
INSERT INTO public.who_global_data_import VALUES (36335, '2020-12-02', 'GY', 'Guyana', 'AMRO', '30', '5406', '1', '151');
INSERT INTO public.who_global_data_import VALUES (36336, '2020-12-03', 'GY', 'Guyana', 'AMRO', '17', '5423', '0', '151');
INSERT INTO public.who_global_data_import VALUES (36337, '2020-12-04', 'GY', 'Guyana', 'AMRO', '26', '5449', '0', '151');
INSERT INTO public.who_global_data_import VALUES (36338, '2020-12-05', 'GY', 'Guyana', 'AMRO', '79', '5528', '0', '151');
INSERT INTO public.who_global_data_import VALUES (36339, '2020-12-06', 'GY', 'Guyana', 'AMRO', '73', '5601', '0', '151');
INSERT INTO public.who_global_data_import VALUES (36340, '2020-12-07', 'GY', 'Guyana', 'AMRO', '36', '5637', '0', '151');
INSERT INTO public.who_global_data_import VALUES (36341, '2020-12-08', 'GY', 'Guyana', 'AMRO', '28', '5665', '2', '153');
INSERT INTO public.who_global_data_import VALUES (36342, '2020-12-09', 'GY', 'Guyana', 'AMRO', '32', '5697', '1', '154');
INSERT INTO public.who_global_data_import VALUES (36343, '2020-12-10', 'GY', 'Guyana', 'AMRO', '3', '5700', '0', '154');
INSERT INTO public.who_global_data_import VALUES (36344, '2020-12-11', 'GY', 'Guyana', 'AMRO', '32', '5732', '0', '154');
INSERT INTO public.who_global_data_import VALUES (36345, '2020-12-12', 'GY', 'Guyana', 'AMRO', '79', '5811', '0', '154');
INSERT INTO public.who_global_data_import VALUES (36346, '2020-12-13', 'GY', 'Guyana', 'AMRO', '28', '5839', '0', '154');
INSERT INTO public.who_global_data_import VALUES (36347, '2020-12-14', 'GY', 'Guyana', 'AMRO', '40', '5879', '0', '154');
INSERT INTO public.who_global_data_import VALUES (36348, '2020-12-15', 'GY', 'Guyana', 'AMRO', '41', '5920', '1', '155');
INSERT INTO public.who_global_data_import VALUES (36349, '2020-12-16', 'GY', 'Guyana', 'AMRO', '23', '5943', '1', '156');
INSERT INTO public.who_global_data_import VALUES (36350, '2020-12-17', 'GY', 'Guyana', 'AMRO', '30', '5973', '0', '156');
INSERT INTO public.who_global_data_import VALUES (36351, '2020-12-18', 'GY', 'Guyana', 'AMRO', '43', '6016', '2', '158');
INSERT INTO public.who_global_data_import VALUES (36352, '2020-12-19', 'GY', 'Guyana', 'AMRO', '26', '6042', '0', '158');
INSERT INTO public.who_global_data_import VALUES (36353, '2020-12-20', 'GY', 'Guyana', 'AMRO', '34', '6076', '1', '159');
INSERT INTO public.who_global_data_import VALUES (36354, '2020-12-21', 'GY', 'Guyana', 'AMRO', '29', '6105', '0', '159');
INSERT INTO public.who_global_data_import VALUES (36355, '2020-12-22', 'GY', 'Guyana', 'AMRO', '20', '6125', '0', '159');
INSERT INTO public.who_global_data_import VALUES (36356, '2020-12-23', 'GY', 'Guyana', 'AMRO', '46', '6171', '0', '159');
INSERT INTO public.who_global_data_import VALUES (36357, '2020-12-24', 'GY', 'Guyana', 'AMRO', '45', '6216', '1', '160');
INSERT INTO public.who_global_data_import VALUES (36358, '2020-12-25', 'GY', 'Guyana', 'AMRO', '42', '6258', '2', '162');
INSERT INTO public.who_global_data_import VALUES (36359, '2020-12-26', 'GY', 'Guyana', 'AMRO', '8', '6266', '0', '162');
INSERT INTO public.who_global_data_import VALUES (36360, '2020-12-27', 'GY', 'Guyana', 'AMRO', '23', '6289', '0', '162');
INSERT INTO public.who_global_data_import VALUES (36361, '2020-12-28', 'GY', 'Guyana', 'AMRO', '4', '6293', '2', '164');
INSERT INTO public.who_global_data_import VALUES (36362, '2020-12-29', 'GY', 'Guyana', 'AMRO', '5', '6298', '0', '164');
INSERT INTO public.who_global_data_import VALUES (36363, '2020-12-30', 'GY', 'Guyana', 'AMRO', '0', '6298', '0', '164');
INSERT INTO public.who_global_data_import VALUES (36364, '2020-12-31', 'GY', 'Guyana', 'AMRO', '3', '6301', '0', '164');
INSERT INTO public.who_global_data_import VALUES (36365, '2021-01-01', 'GY', 'Guyana', 'AMRO', '18', '6319', '0', '164');
INSERT INTO public.who_global_data_import VALUES (36366, '2021-01-02', 'GY', 'Guyana', 'AMRO', '13', '6332', '0', '164');
INSERT INTO public.who_global_data_import VALUES (36367, '2021-01-03', 'GY', 'Guyana', 'AMRO', '19', '6351', '0', '164');
INSERT INTO public.who_global_data_import VALUES (36368, '2021-01-04', 'GY', 'Guyana', 'AMRO', '7', '6358', '0', '164');
INSERT INTO public.who_global_data_import VALUES (36369, '2021-01-05', 'GY', 'Guyana', 'AMRO', '0', '6358', '0', '164');
INSERT INTO public.who_global_data_import VALUES (36370, '2021-01-06', 'GY', 'Guyana', 'AMRO', '21', '6379', '2', '166');
INSERT INTO public.who_global_data_import VALUES (36371, '2021-01-07', 'GY', 'Guyana', 'AMRO', '28', '6407', '0', '166');
INSERT INTO public.who_global_data_import VALUES (36372, '2021-01-08', 'GY', 'Guyana', 'AMRO', '0', '6407', '0', '166');
INSERT INTO public.who_global_data_import VALUES (36373, '2021-01-09', 'GY', 'Guyana', 'AMRO', '62', '6469', '1', '167');
INSERT INTO public.who_global_data_import VALUES (36374, '2021-01-10', 'GY', 'Guyana', 'AMRO', '0', '6469', '0', '167');
INSERT INTO public.who_global_data_import VALUES (36375, '2021-01-11', 'GY', 'Guyana', 'AMRO', '72', '6541', '0', '167');
INSERT INTO public.who_global_data_import VALUES (36376, '2021-01-12', 'GY', 'Guyana', 'AMRO', '33', '6574', '2', '169');
INSERT INTO public.who_global_data_import VALUES (36377, '2021-01-13', 'GY', 'Guyana', 'AMRO', '14', '6588', '1', '170');
INSERT INTO public.who_global_data_import VALUES (36378, '2021-01-14', 'GY', 'Guyana', 'AMRO', '65', '6653', '0', '170');
INSERT INTO public.who_global_data_import VALUES (36379, '2021-01-15', 'GY', 'Guyana', 'AMRO', '43', '6696', '0', '170');
INSERT INTO public.who_global_data_import VALUES (36380, '2021-01-16', 'GY', 'Guyana', 'AMRO', '49', '6745', '0', '170');
INSERT INTO public.who_global_data_import VALUES (36381, '2021-01-17', 'GY', 'Guyana', 'AMRO', '60', '6805', '0', '170');
INSERT INTO public.who_global_data_import VALUES (36382, '2021-01-18', 'GY', 'Guyana', 'AMRO', '46', '6851', '0', '170');
INSERT INTO public.who_global_data_import VALUES (36383, '2021-01-19', 'GY', 'Guyana', 'AMRO', '57', '6908', '0', '170');
INSERT INTO public.who_global_data_import VALUES (36384, '2021-01-20', 'GY', 'Guyana', 'AMRO', '23', '6931', '0', '170');
INSERT INTO public.who_global_data_import VALUES (36385, '2021-01-21', 'GY', 'Guyana', 'AMRO', '19', '6950', '0', '170');
INSERT INTO public.who_global_data_import VALUES (36386, '2021-01-22', 'GY', 'Guyana', 'AMRO', '65', '7015', '0', '170');
INSERT INTO public.who_global_data_import VALUES (36387, '2021-01-23', 'GY', 'Guyana', 'AMRO', '52', '7067', '0', '170');
INSERT INTO public.who_global_data_import VALUES (36388, '2021-01-24', 'GY', 'Guyana', 'AMRO', '76', '7143', '0', '170');
INSERT INTO public.who_global_data_import VALUES (36389, '2021-01-25', 'GY', 'Guyana', 'AMRO', '79', '7222', '0', '170');
INSERT INTO public.who_global_data_import VALUES (36390, '2021-01-26', 'GY', 'Guyana', 'AMRO', '76', '7298', '2', '172');
INSERT INTO public.who_global_data_import VALUES (36391, '2021-01-27', 'GY', 'Guyana', 'AMRO', '19', '7317', '0', '172');
INSERT INTO public.who_global_data_import VALUES (36392, '2021-01-28', 'GY', 'Guyana', 'AMRO', '29', '7346', '0', '172');
INSERT INTO public.who_global_data_import VALUES (36393, '2021-01-29', 'GY', 'Guyana', 'AMRO', '34', '7380', '2', '174');
INSERT INTO public.who_global_data_import VALUES (36394, '2021-01-30', 'GY', 'Guyana', 'AMRO', '90', '7470', '1', '175');
INSERT INTO public.who_global_data_import VALUES (36395, '2021-01-31', 'GY', 'Guyana', 'AMRO', '58', '7528', '0', '175');
INSERT INTO public.who_global_data_import VALUES (36396, '2021-02-01', 'GY', 'Guyana', 'AMRO', '53', '7581', '1', '176');
INSERT INTO public.who_global_data_import VALUES (36397, '2021-02-02', 'GY', 'Guyana', 'AMRO', '60', '7641', '0', '176');
INSERT INTO public.who_global_data_import VALUES (36398, '2021-02-03', 'GY', 'Guyana', 'AMRO', '13', '7654', '1', '177');
INSERT INTO public.who_global_data_import VALUES (36399, '2021-02-04', 'GY', 'Guyana', 'AMRO', '24', '7678', '0', '177');
INSERT INTO public.who_global_data_import VALUES (36400, '2021-02-05', 'GY', 'Guyana', 'AMRO', '36', '7714', '0', '177');
INSERT INTO public.who_global_data_import VALUES (36401, '2020-01-03', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36402, '2020-01-04', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36403, '2020-01-05', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36404, '2020-01-06', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36405, '2020-01-07', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36406, '2020-01-08', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36407, '2020-01-09', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36408, '2020-01-10', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36409, '2020-01-11', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36410, '2020-01-12', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36411, '2020-01-13', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36412, '2020-01-14', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36413, '2020-01-15', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36414, '2020-01-16', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36415, '2020-01-17', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36416, '2020-01-18', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36417, '2020-01-19', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36418, '2020-01-20', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36419, '2020-01-21', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36420, '2020-01-22', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36421, '2020-01-23', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36422, '2020-01-24', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36423, '2020-01-25', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36424, '2020-01-26', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36425, '2020-01-27', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36426, '2020-01-28', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36427, '2020-01-29', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36428, '2020-01-30', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36429, '2020-01-31', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36430, '2020-02-01', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36431, '2020-02-02', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36432, '2020-02-03', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36433, '2020-02-04', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36434, '2020-02-05', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36435, '2020-02-06', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36436, '2020-02-07', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36437, '2020-02-08', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36438, '2020-02-09', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36439, '2020-02-10', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36440, '2020-02-11', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36441, '2020-02-12', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36442, '2020-02-13', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36443, '2020-02-14', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36444, '2020-02-15', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36445, '2020-02-16', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36446, '2020-02-17', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36447, '2020-02-18', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36448, '2020-02-19', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36449, '2020-02-20', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36450, '2020-02-21', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36451, '2020-02-22', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36452, '2020-02-23', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36453, '2020-02-24', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36454, '2020-02-25', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36455, '2020-02-26', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36456, '2020-02-27', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36457, '2020-02-28', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36458, '2020-02-29', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36459, '2020-03-01', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36460, '2020-03-02', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36461, '2020-03-03', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36462, '2020-03-04', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36463, '2020-03-05', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36464, '2020-03-06', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36465, '2020-03-07', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36466, '2020-03-08', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36467, '2020-03-09', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36468, '2020-03-10', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36469, '2020-03-11', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36470, '2020-03-12', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36471, '2020-03-13', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36472, '2020-03-14', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36473, '2020-03-15', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36474, '2020-03-16', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36475, '2020-03-17', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36476, '2020-03-18', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36477, '2020-03-19', 'HT', 'Haiti', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36478, '2020-03-20', 'HT', 'Haiti', 'AMRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36479, '2020-03-21', 'HT', 'Haiti', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36480, '2020-03-22', 'HT', 'Haiti', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36481, '2020-03-23', 'HT', 'Haiti', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36482, '2020-03-24', 'HT', 'Haiti', 'AMRO', '5', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36483, '2020-03-25', 'HT', 'Haiti', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36484, '2020-03-26', 'HT', 'Haiti', 'AMRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36485, '2020-03-27', 'HT', 'Haiti', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36486, '2020-03-28', 'HT', 'Haiti', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36487, '2020-03-29', 'HT', 'Haiti', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36488, '2020-03-30', 'HT', 'Haiti', 'AMRO', '7', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36489, '2020-03-31', 'HT', 'Haiti', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36490, '2020-04-01', 'HT', 'Haiti', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36491, '2020-04-02', 'HT', 'Haiti', 'AMRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36492, '2020-04-03', 'HT', 'Haiti', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36493, '2020-04-04', 'HT', 'Haiti', 'AMRO', '2', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36494, '2020-04-05', 'HT', 'Haiti', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36495, '2020-04-06', 'HT', 'Haiti', 'AMRO', '3', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36496, '2020-04-07', 'HT', 'Haiti', 'AMRO', '3', '24', '1', '1');
INSERT INTO public.who_global_data_import VALUES (36497, '2020-04-08', 'HT', 'Haiti', 'AMRO', '1', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36498, '2020-04-09', 'HT', 'Haiti', 'AMRO', '2', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (36499, '2020-04-10', 'HT', 'Haiti', 'AMRO', '3', '30', '1', '2');
INSERT INTO public.who_global_data_import VALUES (36500, '2020-04-11', 'HT', 'Haiti', 'AMRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (36501, '2020-04-12', 'HT', 'Haiti', 'AMRO', '1', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (36502, '2020-04-13', 'HT', 'Haiti', 'AMRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (36503, '2020-04-14', 'HT', 'Haiti', 'AMRO', '9', '40', '1', '3');
INSERT INTO public.who_global_data_import VALUES (36504, '2020-04-15', 'HT', 'Haiti', 'AMRO', '0', '40', '0', '3');
INSERT INTO public.who_global_data_import VALUES (36505, '2020-04-16', 'HT', 'Haiti', 'AMRO', '1', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (36506, '2020-04-17', 'HT', 'Haiti', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (36507, '2020-04-18', 'HT', 'Haiti', 'AMRO', '2', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (36508, '2020-04-19', 'HT', 'Haiti', 'AMRO', '1', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (36509, '2020-04-20', 'HT', 'Haiti', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (36510, '2020-04-21', 'HT', 'Haiti', 'AMRO', '3', '47', '0', '3');
INSERT INTO public.who_global_data_import VALUES (36511, '2020-04-22', 'HT', 'Haiti', 'AMRO', '10', '57', '0', '3');
INSERT INTO public.who_global_data_import VALUES (36512, '2020-04-23', 'HT', 'Haiti', 'AMRO', '1', '58', '1', '4');
INSERT INTO public.who_global_data_import VALUES (36513, '2020-04-24', 'HT', 'Haiti', 'AMRO', '4', '62', '0', '4');
INSERT INTO public.who_global_data_import VALUES (36514, '2020-04-25', 'HT', 'Haiti', 'AMRO', '10', '72', '1', '5');
INSERT INTO public.who_global_data_import VALUES (36515, '2020-04-26', 'HT', 'Haiti', 'AMRO', '0', '72', '1', '6');
INSERT INTO public.who_global_data_import VALUES (36516, '2020-04-27', 'HT', 'Haiti', 'AMRO', '0', '72', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36517, '2020-04-28', 'HT', 'Haiti', 'AMRO', '2', '74', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36518, '2020-04-29', 'HT', 'Haiti', 'AMRO', '2', '76', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36519, '2020-04-30', 'HT', 'Haiti', 'AMRO', '0', '76', '0', '6');
INSERT INTO public.who_global_data_import VALUES (36520, '2020-05-01', 'HT', 'Haiti', 'AMRO', '0', '76', '1', '7');
INSERT INTO public.who_global_data_import VALUES (36521, '2020-05-02', 'HT', 'Haiti', 'AMRO', '5', '81', '1', '8');
INSERT INTO public.who_global_data_import VALUES (36522, '2020-05-03', 'HT', 'Haiti', 'AMRO', '4', '85', '0', '8');
INSERT INTO public.who_global_data_import VALUES (36523, '2020-05-04', 'HT', 'Haiti', 'AMRO', '0', '85', '0', '8');
INSERT INTO public.who_global_data_import VALUES (36524, '2020-05-05', 'HT', 'Haiti', 'AMRO', '3', '88', '1', '9');
INSERT INTO public.who_global_data_import VALUES (36525, '2020-05-06', 'HT', 'Haiti', 'AMRO', '12', '100', '2', '11');
INSERT INTO public.who_global_data_import VALUES (36526, '2020-05-07', 'HT', 'Haiti', 'AMRO', '1', '101', '1', '12');
INSERT INTO public.who_global_data_import VALUES (36527, '2020-05-08', 'HT', 'Haiti', 'AMRO', '7', '108', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36528, '2020-05-09', 'HT', 'Haiti', 'AMRO', '21', '129', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36529, '2020-05-10', 'HT', 'Haiti', 'AMRO', '17', '146', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36530, '2020-05-11', 'HT', 'Haiti', 'AMRO', '5', '151', '0', '12');
INSERT INTO public.who_global_data_import VALUES (36531, '2020-05-12', 'HT', 'Haiti', 'AMRO', '31', '182', '3', '15');
INSERT INTO public.who_global_data_import VALUES (36532, '2020-05-13', 'HT', 'Haiti', 'AMRO', '27', '209', '1', '16');
INSERT INTO public.who_global_data_import VALUES (36533, '2020-05-14', 'HT', 'Haiti', 'AMRO', '10', '219', '2', '18');
INSERT INTO public.who_global_data_import VALUES (36534, '2020-05-15', 'HT', 'Haiti', 'AMRO', '15', '234', '0', '18');
INSERT INTO public.who_global_data_import VALUES (36535, '2020-05-16', 'HT', 'Haiti', 'AMRO', '39', '273', '2', '20');
INSERT INTO public.who_global_data_import VALUES (36536, '2020-05-17', 'HT', 'Haiti', 'AMRO', '37', '310', '0', '20');
INSERT INTO public.who_global_data_import VALUES (36537, '2020-05-18', 'HT', 'Haiti', 'AMRO', '48', '358', '0', '20');
INSERT INTO public.who_global_data_import VALUES (36538, '2020-05-19', 'HT', 'Haiti', 'AMRO', '98', '456', '0', '20');
INSERT INTO public.who_global_data_import VALUES (36539, '2020-05-20', 'HT', 'Haiti', 'AMRO', '77', '533', '1', '21');
INSERT INTO public.who_global_data_import VALUES (36540, '2020-05-21', 'HT', 'Haiti', 'AMRO', '63', '596', '1', '22');
INSERT INTO public.who_global_data_import VALUES (36541, '2020-05-22', 'HT', 'Haiti', 'AMRO', '67', '663', '0', '22');
INSERT INTO public.who_global_data_import VALUES (36542, '2020-05-23', 'HT', 'Haiti', 'AMRO', '71', '734', '3', '25');
INSERT INTO public.who_global_data_import VALUES (36543, '2020-05-24', 'HT', 'Haiti', 'AMRO', '78', '812', '0', '25');
INSERT INTO public.who_global_data_import VALUES (36544, '2020-05-25', 'HT', 'Haiti', 'AMRO', '53', '865', '1', '26');
INSERT INTO public.who_global_data_import VALUES (36545, '2020-05-26', 'HT', 'Haiti', 'AMRO', '93', '958', '1', '27');
INSERT INTO public.who_global_data_import VALUES (36546, '2020-05-27', 'HT', 'Haiti', 'AMRO', '105', '1063', '4', '31');
INSERT INTO public.who_global_data_import VALUES (36547, '2020-05-28', 'HT', 'Haiti', 'AMRO', '111', '1174', '2', '33');
INSERT INTO public.who_global_data_import VALUES (36548, '2020-05-29', 'HT', 'Haiti', 'AMRO', '146', '1320', '1', '34');
INSERT INTO public.who_global_data_import VALUES (36549, '2020-05-30', 'HT', 'Haiti', 'AMRO', '123', '1443', '1', '35');
INSERT INTO public.who_global_data_import VALUES (36550, '2020-05-31', 'HT', 'Haiti', 'AMRO', '141', '1584', '0', '35');
INSERT INTO public.who_global_data_import VALUES (36551, '2020-06-01', 'HT', 'Haiti', 'AMRO', '281', '1865', '6', '41');
INSERT INTO public.who_global_data_import VALUES (36552, '2020-06-02', 'HT', 'Haiti', 'AMRO', '259', '2124', '3', '44');
INSERT INTO public.who_global_data_import VALUES (36553, '2020-06-03', 'HT', 'Haiti', 'AMRO', '102', '2226', '1', '45');
INSERT INTO public.who_global_data_import VALUES (36554, '2020-06-04', 'HT', 'Haiti', 'AMRO', '281', '2507', '3', '48');
INSERT INTO public.who_global_data_import VALUES (36555, '2020-06-05', 'HT', 'Haiti', 'AMRO', '97', '2604', '2', '50');
INSERT INTO public.who_global_data_import VALUES (36556, '2020-06-06', 'HT', 'Haiti', 'AMRO', '36', '2640', '0', '50');
INSERT INTO public.who_global_data_import VALUES (36557, '2020-06-07', 'HT', 'Haiti', 'AMRO', '284', '2924', '0', '50');
INSERT INTO public.who_global_data_import VALUES (36558, '2020-06-08', 'HT', 'Haiti', 'AMRO', '148', '3072', '0', '50');
INSERT INTO public.who_global_data_import VALUES (36559, '2020-06-09', 'HT', 'Haiti', 'AMRO', '262', '3334', '1', '51');
INSERT INTO public.who_global_data_import VALUES (36560, '2020-06-10', 'HT', 'Haiti', 'AMRO', '204', '3538', '3', '54');
INSERT INTO public.who_global_data_import VALUES (36561, '2020-06-11', 'HT', 'Haiti', 'AMRO', '124', '3662', '2', '56');
INSERT INTO public.who_global_data_import VALUES (36562, '2020-06-12', 'HT', 'Haiti', 'AMRO', '134', '3796', '2', '58');
INSERT INTO public.who_global_data_import VALUES (36563, '2020-06-13', 'HT', 'Haiti', 'AMRO', '145', '3941', '6', '64');
INSERT INTO public.who_global_data_import VALUES (36564, '2020-06-14', 'HT', 'Haiti', 'AMRO', '0', '3941', '0', '64');
INSERT INTO public.who_global_data_import VALUES (36565, '2020-06-15', 'HT', 'Haiti', 'AMRO', '224', '4165', '6', '70');
INSERT INTO public.who_global_data_import VALUES (36566, '2020-06-16', 'HT', 'Haiti', 'AMRO', '144', '4309', '3', '73');
INSERT INTO public.who_global_data_import VALUES (36567, '2020-06-17', 'HT', 'Haiti', 'AMRO', '132', '4441', '3', '76');
INSERT INTO public.who_global_data_import VALUES (36568, '2020-06-18', 'HT', 'Haiti', 'AMRO', '106', '4547', '4', '80');
INSERT INTO public.who_global_data_import VALUES (36569, '2020-06-19', 'HT', 'Haiti', 'AMRO', '141', '4688', '2', '82');
INSERT INTO public.who_global_data_import VALUES (36570, '2020-06-20', 'HT', 'Haiti', 'AMRO', '228', '4916', '2', '84');
INSERT INTO public.who_global_data_import VALUES (36571, '2020-06-21', 'HT', 'Haiti', 'AMRO', '64', '4980', '3', '87');
INSERT INTO public.who_global_data_import VALUES (36572, '2020-06-22', 'HT', 'Haiti', 'AMRO', '97', '5077', '1', '88');
INSERT INTO public.who_global_data_import VALUES (36573, '2020-06-23', 'HT', 'Haiti', 'AMRO', '134', '5211', '0', '88');
INSERT INTO public.who_global_data_import VALUES (36574, '2020-06-24', 'HT', 'Haiti', 'AMRO', '5', '5216', '0', '88');
INSERT INTO public.who_global_data_import VALUES (36575, '2020-06-25', 'HT', 'Haiti', 'AMRO', '108', '5324', '1', '89');
INSERT INTO public.who_global_data_import VALUES (36576, '2020-06-26', 'HT', 'Haiti', 'AMRO', '105', '5429', '3', '92');
INSERT INTO public.who_global_data_import VALUES (36577, '2020-06-27', 'HT', 'Haiti', 'AMRO', '114', '5543', '4', '96');
INSERT INTO public.who_global_data_import VALUES (36578, '2020-06-28', 'HT', 'Haiti', 'AMRO', '179', '5722', '2', '98');
INSERT INTO public.who_global_data_import VALUES (36579, '2020-06-29', 'HT', 'Haiti', 'AMRO', '0', '5722', '0', '98');
INSERT INTO public.who_global_data_import VALUES (36580, '2020-06-30', 'HT', 'Haiti', 'AMRO', '125', '5847', '6', '104');
INSERT INTO public.who_global_data_import VALUES (36581, '2020-07-01', 'HT', 'Haiti', 'AMRO', '86', '5933', '1', '105');
INSERT INTO public.who_global_data_import VALUES (36582, '2020-07-02', 'HT', 'Haiti', 'AMRO', '42', '5975', '0', '105');
INSERT INTO public.who_global_data_import VALUES (36583, '2020-07-03', 'HT', 'Haiti', 'AMRO', '65', '6040', '2', '107');
INSERT INTO public.who_global_data_import VALUES (36584, '2020-07-04', 'HT', 'Haiti', 'AMRO', '61', '6101', '3', '110');
INSERT INTO public.who_global_data_import VALUES (36585, '2020-07-05', 'HT', 'Haiti', 'AMRO', '129', '6230', '0', '110');
INSERT INTO public.who_global_data_import VALUES (36586, '2020-07-06', 'HT', 'Haiti', 'AMRO', '64', '6294', '3', '113');
INSERT INTO public.who_global_data_import VALUES (36587, '2020-07-07', 'HT', 'Haiti', 'AMRO', '39', '6333', '0', '113');
INSERT INTO public.who_global_data_import VALUES (36588, '2020-07-08', 'HT', 'Haiti', 'AMRO', '38', '6371', '0', '113');
INSERT INTO public.who_global_data_import VALUES (36589, '2020-07-09', 'HT', 'Haiti', 'AMRO', '61', '6432', '4', '117');
INSERT INTO public.who_global_data_import VALUES (36590, '2020-07-10', 'HT', 'Haiti', 'AMRO', '54', '6486', '6', '123');
INSERT INTO public.who_global_data_import VALUES (36591, '2020-07-11', 'HT', 'Haiti', 'AMRO', '96', '6582', '7', '130');
INSERT INTO public.who_global_data_import VALUES (36592, '2020-07-12', 'HT', 'Haiti', 'AMRO', '35', '6617', '5', '135');
INSERT INTO public.who_global_data_import VALUES (36593, '2020-07-13', 'HT', 'Haiti', 'AMRO', '73', '6690', '4', '139');
INSERT INTO public.who_global_data_import VALUES (36594, '2020-07-14', 'HT', 'Haiti', 'AMRO', '37', '6727', '0', '139');
INSERT INTO public.who_global_data_import VALUES (36595, '2020-07-15', 'HT', 'Haiti', 'AMRO', '0', '6727', '2', '141');
INSERT INTO public.who_global_data_import VALUES (36596, '2020-07-16', 'HT', 'Haiti', 'AMRO', '104', '6831', '2', '143');
INSERT INTO public.who_global_data_import VALUES (36597, '2020-07-17', 'HT', 'Haiti', 'AMRO', '71', '6902', '2', '145');
INSERT INTO public.who_global_data_import VALUES (36598, '2020-07-18', 'HT', 'Haiti', 'AMRO', '46', '6948', '0', '145');
INSERT INTO public.who_global_data_import VALUES (36599, '2020-07-19', 'HT', 'Haiti', 'AMRO', '27', '6975', '1', '146');
INSERT INTO public.who_global_data_import VALUES (36600, '2020-07-20', 'HT', 'Haiti', 'AMRO', '78', '7053', '0', '146');
INSERT INTO public.who_global_data_import VALUES (36601, '2020-07-21', 'HT', 'Haiti', 'AMRO', '10', '7063', '0', '146');
INSERT INTO public.who_global_data_import VALUES (36602, '2020-07-22', 'HT', 'Haiti', 'AMRO', '37', '7100', '5', '151');
INSERT INTO public.who_global_data_import VALUES (36603, '2020-07-23', 'HT', 'Haiti', 'AMRO', '46', '7146', '3', '154');
INSERT INTO public.who_global_data_import VALUES (36604, '2020-07-24', 'HT', 'Haiti', 'AMRO', '21', '7167', '0', '154');
INSERT INTO public.who_global_data_import VALUES (36605, '2020-07-25', 'HT', 'Haiti', 'AMRO', '30', '7197', '0', '154');
INSERT INTO public.who_global_data_import VALUES (36606, '2020-07-26', 'HT', 'Haiti', 'AMRO', '63', '7260', '2', '156');
INSERT INTO public.who_global_data_import VALUES (36607, '2020-07-27', 'HT', 'Haiti', 'AMRO', '37', '7297', '1', '157');
INSERT INTO public.who_global_data_import VALUES (36608, '2020-07-28', 'HT', 'Haiti', 'AMRO', '18', '7315', '0', '157');
INSERT INTO public.who_global_data_import VALUES (36609, '2020-07-29', 'HT', 'Haiti', 'AMRO', '25', '7340', '1', '158');
INSERT INTO public.who_global_data_import VALUES (36610, '2020-07-30', 'HT', 'Haiti', 'AMRO', '31', '7371', '0', '158');
INSERT INTO public.who_global_data_import VALUES (36611, '2020-07-31', 'HT', 'Haiti', 'AMRO', '7', '7378', '1', '159');
INSERT INTO public.who_global_data_import VALUES (36612, '2020-08-01', 'HT', 'Haiti', 'AMRO', '34', '7412', '2', '161');
INSERT INTO public.who_global_data_import VALUES (36613, '2020-08-02', 'HT', 'Haiti', 'AMRO', '12', '7424', '0', '161');
INSERT INTO public.who_global_data_import VALUES (36614, '2020-08-03', 'HT', 'Haiti', 'AMRO', '44', '7468', '4', '165');
INSERT INTO public.who_global_data_import VALUES (36615, '2020-08-04', 'HT', 'Haiti', 'AMRO', '8', '7476', '0', '165');
INSERT INTO public.who_global_data_import VALUES (36616, '2020-08-05', 'HT', 'Haiti', 'AMRO', '35', '7511', '1', '166');
INSERT INTO public.who_global_data_import VALUES (36617, '2020-08-06', 'HT', 'Haiti', 'AMRO', '21', '7532', '5', '171');
INSERT INTO public.who_global_data_import VALUES (36618, '2020-08-07', 'HT', 'Haiti', 'AMRO', '12', '7544', '0', '171');
INSERT INTO public.who_global_data_import VALUES (36619, '2020-08-08', 'HT', 'Haiti', 'AMRO', '38', '7582', '0', '171');
INSERT INTO public.who_global_data_import VALUES (36620, '2020-08-09', 'HT', 'Haiti', 'AMRO', '17', '7599', '6', '177');
INSERT INTO public.who_global_data_import VALUES (36621, '2020-08-10', 'HT', 'Haiti', 'AMRO', '12', '7611', '5', '182');
INSERT INTO public.who_global_data_import VALUES (36622, '2020-08-11', 'HT', 'Haiti', 'AMRO', '23', '7634', '1', '183');
INSERT INTO public.who_global_data_import VALUES (36623, '2020-08-12', 'HT', 'Haiti', 'AMRO', '15', '7649', '0', '183');
INSERT INTO public.who_global_data_import VALUES (36624, '2020-08-13', 'HT', 'Haiti', 'AMRO', '94', '7743', '4', '187');
INSERT INTO public.who_global_data_import VALUES (36625, '2020-08-14', 'HT', 'Haiti', 'AMRO', '38', '7781', '5', '192');
INSERT INTO public.who_global_data_import VALUES (36626, '2020-08-15', 'HT', 'Haiti', 'AMRO', '29', '7810', '0', '192');
INSERT INTO public.who_global_data_import VALUES (36627, '2020-08-16', 'HT', 'Haiti', 'AMRO', '21', '7831', '4', '196');
INSERT INTO public.who_global_data_import VALUES (36628, '2020-08-17', 'HT', 'Haiti', 'AMRO', '48', '7879', '0', '196');
INSERT INTO public.who_global_data_import VALUES (36629, '2020-08-18', 'HT', 'Haiti', 'AMRO', '18', '7897', '0', '196');
INSERT INTO public.who_global_data_import VALUES (36630, '2020-08-19', 'HT', 'Haiti', 'AMRO', '24', '7921', '0', '196');
INSERT INTO public.who_global_data_import VALUES (36631, '2020-08-20', 'HT', 'Haiti', 'AMRO', '28', '7949', '0', '196');
INSERT INTO public.who_global_data_import VALUES (36632, '2020-08-21', 'HT', 'Haiti', 'AMRO', '48', '7997', '0', '196');
INSERT INTO public.who_global_data_import VALUES (36633, '2020-08-22', 'HT', 'Haiti', 'AMRO', '19', '8016', '0', '196');
INSERT INTO public.who_global_data_import VALUES (36634, '2020-08-23', 'HT', 'Haiti', 'AMRO', '34', '8050', '0', '196');
INSERT INTO public.who_global_data_import VALUES (36635, '2020-08-24', 'HT', 'Haiti', 'AMRO', '32', '8082', '0', '196');
INSERT INTO public.who_global_data_import VALUES (36636, '2020-08-25', 'HT', 'Haiti', 'AMRO', '28', '8110', '0', '196');
INSERT INTO public.who_global_data_import VALUES (36637, '2020-08-26', 'HT', 'Haiti', 'AMRO', '2', '8112', '0', '196');
INSERT INTO public.who_global_data_import VALUES (36638, '2020-08-27', 'HT', 'Haiti', 'AMRO', '10', '8122', '1', '197');
INSERT INTO public.who_global_data_import VALUES (36639, '2020-08-28', 'HT', 'Haiti', 'AMRO', '29', '8151', '3', '200');
INSERT INTO public.who_global_data_import VALUES (36640, '2020-08-29', 'HT', 'Haiti', 'AMRO', '10', '8161', '1', '201');
INSERT INTO public.who_global_data_import VALUES (36641, '2020-08-30', 'HT', 'Haiti', 'AMRO', '13', '8174', '0', '201');
INSERT INTO public.who_global_data_import VALUES (36642, '2020-08-31', 'HT', 'Haiti', 'AMRO', '35', '8209', '0', '201');
INSERT INTO public.who_global_data_import VALUES (36643, '2020-09-01', 'HT', 'Haiti', 'AMRO', '15', '8224', '0', '201');
INSERT INTO public.who_global_data_import VALUES (36644, '2020-09-02', 'HT', 'Haiti', 'AMRO', '0', '8224', '0', '201');
INSERT INTO public.who_global_data_import VALUES (36645, '2020-09-03', 'HT', 'Haiti', 'AMRO', '34', '8258', '5', '206');
INSERT INTO public.who_global_data_import VALUES (36646, '2020-09-04', 'HT', 'Haiti', 'AMRO', '0', '8258', '0', '206');
INSERT INTO public.who_global_data_import VALUES (36647, '2020-09-05', 'HT', 'Haiti', 'AMRO', '68', '8326', '6', '212');
INSERT INTO public.who_global_data_import VALUES (36648, '2020-09-06', 'HT', 'Haiti', 'AMRO', '0', '8326', '0', '212');
INSERT INTO public.who_global_data_import VALUES (36649, '2020-09-07', 'HT', 'Haiti', 'AMRO', '34', '8360', '2', '214');
INSERT INTO public.who_global_data_import VALUES (36650, '2020-09-08', 'HT', 'Haiti', 'AMRO', '0', '8360', '0', '214');
INSERT INTO public.who_global_data_import VALUES (36651, '2020-09-09', 'HT', 'Haiti', 'AMRO', '2', '8362', '0', '214');
INSERT INTO public.who_global_data_import VALUES (36652, '2020-09-10', 'HT', 'Haiti', 'AMRO', '14', '8376', '0', '214');
INSERT INTO public.who_global_data_import VALUES (36653, '2020-09-11', 'HT', 'Haiti', 'AMRO', '53', '8429', '1', '215');
INSERT INTO public.who_global_data_import VALUES (36654, '2020-09-12', 'HT', 'Haiti', 'AMRO', '28', '8457', '1', '216');
INSERT INTO public.who_global_data_import VALUES (36655, '2020-09-13', 'HT', 'Haiti', 'AMRO', '0', '8457', '0', '216');
INSERT INTO public.who_global_data_import VALUES (36656, '2020-09-14', 'HT', 'Haiti', 'AMRO', '21', '8478', '3', '219');
INSERT INTO public.who_global_data_import VALUES (36657, '2020-09-15', 'HT', 'Haiti', 'AMRO', '15', '8493', '0', '219');
INSERT INTO public.who_global_data_import VALUES (36658, '2020-09-16', 'HT', 'Haiti', 'AMRO', '6', '8499', '0', '219');
INSERT INTO public.who_global_data_import VALUES (36659, '2020-09-17', 'HT', 'Haiti', 'AMRO', '31', '8530', '1', '220');
INSERT INTO public.who_global_data_import VALUES (36660, '2020-09-18', 'HT', 'Haiti', 'AMRO', '26', '8556', '0', '220');
INSERT INTO public.who_global_data_import VALUES (36661, '2020-09-19', 'HT', 'Haiti', 'AMRO', '0', '8556', '0', '220');
INSERT INTO public.who_global_data_import VALUES (36662, '2020-09-20', 'HT', 'Haiti', 'AMRO', '44', '8600', '1', '221');
INSERT INTO public.who_global_data_import VALUES (36663, '2020-09-21', 'HT', 'Haiti', 'AMRO', '0', '8600', '0', '221');
INSERT INTO public.who_global_data_import VALUES (36664, '2020-09-22', 'HT', 'Haiti', 'AMRO', '24', '8624', '0', '221');
INSERT INTO public.who_global_data_import VALUES (36665, '2020-09-23', 'HT', 'Haiti', 'AMRO', '0', '8624', '0', '221');
INSERT INTO public.who_global_data_import VALUES (36666, '2020-09-24', 'HT', 'Haiti', 'AMRO', '22', '8646', '4', '225');
INSERT INTO public.who_global_data_import VALUES (36667, '2020-09-25', 'HT', 'Haiti', 'AMRO', '0', '8646', '0', '225');
INSERT INTO public.who_global_data_import VALUES (36668, '2020-09-26', 'HT', 'Haiti', 'AMRO', '38', '8684', '2', '227');
INSERT INTO public.who_global_data_import VALUES (36669, '2020-09-27', 'HT', 'Haiti', 'AMRO', '0', '8684', '0', '227');
INSERT INTO public.who_global_data_import VALUES (36670, '2020-09-28', 'HT', 'Haiti', 'AMRO', '39', '8723', '0', '227');
INSERT INTO public.who_global_data_import VALUES (36671, '2020-09-29', 'HT', 'Haiti', 'AMRO', '17', '8740', '0', '227');
INSERT INTO public.who_global_data_import VALUES (36672, '2020-09-30', 'HT', 'Haiti', 'AMRO', '0', '8740', '0', '227');
INSERT INTO public.who_global_data_import VALUES (36673, '2020-10-01', 'HT', 'Haiti', 'AMRO', '26', '8766', '2', '229');
INSERT INTO public.who_global_data_import VALUES (36674, '2020-10-02', 'HT', 'Haiti', 'AMRO', '0', '8766', '0', '229');
INSERT INTO public.who_global_data_import VALUES (36675, '2020-10-03', 'HT', 'Haiti', 'AMRO', '26', '8792', '0', '229');
INSERT INTO public.who_global_data_import VALUES (36676, '2020-10-04', 'HT', 'Haiti', 'AMRO', '0', '8792', '0', '229');
INSERT INTO public.who_global_data_import VALUES (36677, '2020-10-05', 'HT', 'Haiti', 'AMRO', '27', '8819', '0', '229');
INSERT INTO public.who_global_data_import VALUES (36678, '2020-10-06', 'HT', 'Haiti', 'AMRO', '0', '8819', '0', '229');
INSERT INTO public.who_global_data_import VALUES (36679, '2020-10-07', 'HT', 'Haiti', 'AMRO', '0', '8819', '0', '229');
INSERT INTO public.who_global_data_import VALUES (36680, '2020-10-08', 'HT', 'Haiti', 'AMRO', '19', '8838', '0', '229');
INSERT INTO public.who_global_data_import VALUES (36681, '2020-10-09', 'HT', 'Haiti', 'AMRO', '16', '8854', '1', '230');
INSERT INTO public.who_global_data_import VALUES (36682, '2020-10-10', 'HT', 'Haiti', 'AMRO', '0', '8854', '0', '230');
INSERT INTO public.who_global_data_import VALUES (36683, '2020-10-11', 'HT', 'Haiti', 'AMRO', '6', '8860', '0', '230');
INSERT INTO public.who_global_data_import VALUES (36684, '2020-10-12', 'HT', 'Haiti', 'AMRO', '22', '8882', '0', '230');
INSERT INTO public.who_global_data_import VALUES (36685, '2020-10-13', 'HT', 'Haiti', 'AMRO', '0', '8882', '0', '230');
INSERT INTO public.who_global_data_import VALUES (36686, '2020-10-14', 'HT', 'Haiti', 'AMRO', '5', '8887', '0', '230');
INSERT INTO public.who_global_data_import VALUES (36687, '2020-10-15', 'HT', 'Haiti', 'AMRO', '21', '8908', '1', '231');
INSERT INTO public.who_global_data_import VALUES (36688, '2020-10-16', 'HT', 'Haiti', 'AMRO', '0', '8908', '0', '231');
INSERT INTO public.who_global_data_import VALUES (36689, '2020-10-17', 'HT', 'Haiti', 'AMRO', '17', '8925', '0', '231');
INSERT INTO public.who_global_data_import VALUES (36690, '2020-10-18', 'HT', 'Haiti', 'AMRO', '0', '8925', '0', '231');
INSERT INTO public.who_global_data_import VALUES (36691, '2020-10-19', 'HT', 'Haiti', 'AMRO', '0', '8925', '0', '231');
INSERT INTO public.who_global_data_import VALUES (36692, '2020-10-20', 'HT', 'Haiti', 'AMRO', '0', '8925', '0', '231');
INSERT INTO public.who_global_data_import VALUES (36693, '2020-10-21', 'HT', 'Haiti', 'AMRO', '51', '8976', '0', '231');
INSERT INTO public.who_global_data_import VALUES (36694, '2020-10-22', 'HT', 'Haiti', 'AMRO', '3', '8979', '0', '231');
INSERT INTO public.who_global_data_import VALUES (36695, '2020-10-23', 'HT', 'Haiti', 'AMRO', '0', '8979', '0', '231');
INSERT INTO public.who_global_data_import VALUES (36696, '2020-10-24', 'HT', 'Haiti', 'AMRO', '20', '8999', '0', '231');
INSERT INTO public.who_global_data_import VALUES (36697, '2020-10-25', 'HT', 'Haiti', 'AMRO', '16', '9015', '0', '231');
INSERT INTO public.who_global_data_import VALUES (36698, '2020-10-26', 'HT', 'Haiti', 'AMRO', '11', '9026', '1', '232');
INSERT INTO public.who_global_data_import VALUES (36699, '2020-10-27', 'HT', 'Haiti', 'AMRO', '0', '9026', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36700, '2020-10-28', 'HT', 'Haiti', 'AMRO', '0', '9026', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36701, '2020-10-29', 'HT', 'Haiti', 'AMRO', '20', '9046', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36702, '2020-10-30', 'HT', 'Haiti', 'AMRO', '8', '9054', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36703, '2020-10-31', 'HT', 'Haiti', 'AMRO', '0', '9054', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36704, '2020-11-01', 'HT', 'Haiti', 'AMRO', '0', '9054', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36705, '2020-11-02', 'HT', 'Haiti', 'AMRO', '0', '9054', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36706, '2020-11-03', 'HT', 'Haiti', 'AMRO', '0', '9054', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36707, '2020-11-04', 'HT', 'Haiti', 'AMRO', '0', '9054', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36708, '2020-11-05', 'HT', 'Haiti', 'AMRO', '46', '9100', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36709, '2020-11-06', 'HT', 'Haiti', 'AMRO', '9', '9109', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36710, '2020-11-07', 'HT', 'Haiti', 'AMRO', '0', '9109', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36711, '2020-11-08', 'HT', 'Haiti', 'AMRO', '18', '9127', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36712, '2020-11-09', 'HT', 'Haiti', 'AMRO', '0', '9127', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36713, '2020-11-10', 'HT', 'Haiti', 'AMRO', '0', '9127', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36714, '2020-11-11', 'HT', 'Haiti', 'AMRO', '10', '9137', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36715, '2020-11-12', 'HT', 'Haiti', 'AMRO', '15', '9152', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36716, '2020-11-13', 'HT', 'Haiti', 'AMRO', '0', '9152', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36717, '2020-11-14', 'HT', 'Haiti', 'AMRO', '16', '9168', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36718, '2020-11-15', 'HT', 'Haiti', 'AMRO', '0', '9168', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36719, '2020-11-16', 'HT', 'Haiti', 'AMRO', '11', '9179', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36720, '2020-11-17', 'HT', 'Haiti', 'AMRO', '9', '9188', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36721, '2020-11-18', 'HT', 'Haiti', 'AMRO', '3', '9191', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36722, '2020-11-19', 'HT', 'Haiti', 'AMRO', '0', '9191', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36723, '2020-11-20', 'HT', 'Haiti', 'AMRO', '17', '9208', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36724, '2020-11-21', 'HT', 'Haiti', 'AMRO', '3', '9211', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36725, '2020-11-22', 'HT', 'Haiti', 'AMRO', '3', '9214', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36726, '2020-11-23', 'HT', 'Haiti', 'AMRO', '0', '9214', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36727, '2020-11-24', 'HT', 'Haiti', 'AMRO', '10', '9224', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36728, '2020-11-25', 'HT', 'Haiti', 'AMRO', '5', '9229', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36729, '2020-11-26', 'HT', 'Haiti', 'AMRO', '19', '9248', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36730, '2020-11-27', 'HT', 'Haiti', 'AMRO', '8', '9256', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36731, '2020-11-28', 'HT', 'Haiti', 'AMRO', '8', '9264', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36732, '2020-11-29', 'HT', 'Haiti', 'AMRO', '0', '9264', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36733, '2020-11-30', 'HT', 'Haiti', 'AMRO', '8', '9272', '0', '232');
INSERT INTO public.who_global_data_import VALUES (36734, '2020-12-01', 'HT', 'Haiti', 'AMRO', '22', '9294', '1', '233');
INSERT INTO public.who_global_data_import VALUES (36735, '2020-12-02', 'HT', 'Haiti', 'AMRO', '2', '9296', '0', '233');
INSERT INTO public.who_global_data_import VALUES (36736, '2020-12-03', 'HT', 'Haiti', 'AMRO', '7', '9303', '0', '233');
INSERT INTO public.who_global_data_import VALUES (36737, '2020-12-04', 'HT', 'Haiti', 'AMRO', '10', '9313', '0', '233');
INSERT INTO public.who_global_data_import VALUES (36738, '2020-12-05', 'HT', 'Haiti', 'AMRO', '34', '9347', '0', '233');
INSERT INTO public.who_global_data_import VALUES (36739, '2020-12-06', 'HT', 'Haiti', 'AMRO', '23', '9370', '0', '233');
INSERT INTO public.who_global_data_import VALUES (36740, '2020-12-07', 'HT', 'Haiti', 'AMRO', '0', '9370', '0', '233');
INSERT INTO public.who_global_data_import VALUES (36741, '2020-12-08', 'HT', 'Haiti', 'AMRO', '29', '9399', '0', '233');
INSERT INTO public.who_global_data_import VALUES (36742, '2020-12-09', 'HT', 'Haiti', 'AMRO', '0', '9399', '0', '233');
INSERT INTO public.who_global_data_import VALUES (36743, '2020-12-10', 'HT', 'Haiti', 'AMRO', '35', '9434', '0', '233');
INSERT INTO public.who_global_data_import VALUES (36744, '2020-12-11', 'HT', 'Haiti', 'AMRO', '0', '9434', '0', '233');
INSERT INTO public.who_global_data_import VALUES (36745, '2020-12-12', 'HT', 'Haiti', 'AMRO', '31', '9465', '0', '233');
INSERT INTO public.who_global_data_import VALUES (36746, '2020-12-13', 'HT', 'Haiti', 'AMRO', '26', '9491', '0', '233');
INSERT INTO public.who_global_data_import VALUES (36747, '2020-12-14', 'HT', 'Haiti', 'AMRO', '18', '9509', '1', '234');
INSERT INTO public.who_global_data_import VALUES (36748, '2020-12-15', 'HT', 'Haiti', 'AMRO', '56', '9565', '0', '234');
INSERT INTO public.who_global_data_import VALUES (36749, '2020-12-16', 'HT', 'Haiti', 'AMRO', '32', '9597', '0', '234');
INSERT INTO public.who_global_data_import VALUES (36750, '2020-12-17', 'HT', 'Haiti', 'AMRO', '0', '9597', '0', '234');
INSERT INTO public.who_global_data_import VALUES (36751, '2020-12-18', 'HT', 'Haiti', 'AMRO', '30', '9627', '0', '234');
INSERT INTO public.who_global_data_import VALUES (36752, '2020-12-19', 'HT', 'Haiti', 'AMRO', '21', '9648', '0', '234');
INSERT INTO public.who_global_data_import VALUES (36753, '2020-12-20', 'HT', 'Haiti', 'AMRO', '26', '9674', '0', '234');
INSERT INTO public.who_global_data_import VALUES (36754, '2020-12-21', 'HT', 'Haiti', 'AMRO', '0', '9674', '0', '234');
INSERT INTO public.who_global_data_import VALUES (36755, '2020-12-22', 'HT', 'Haiti', 'AMRO', '89', '9763', '0', '234');
INSERT INTO public.who_global_data_import VALUES (36756, '2020-12-23', 'HT', 'Haiti', 'AMRO', '8', '9771', '1', '235');
INSERT INTO public.who_global_data_import VALUES (36757, '2020-12-24', 'HT', 'Haiti', 'AMRO', '34', '9805', '0', '235');
INSERT INTO public.who_global_data_import VALUES (36758, '2020-12-25', 'HT', 'Haiti', 'AMRO', '41', '9846', '0', '235');
INSERT INTO public.who_global_data_import VALUES (36759, '2020-12-26', 'HT', 'Haiti', 'AMRO', '0', '9846', '0', '235');
INSERT INTO public.who_global_data_import VALUES (36760, '2020-12-27', 'HT', 'Haiti', 'AMRO', '0', '9846', '0', '235');
INSERT INTO public.who_global_data_import VALUES (36761, '2020-12-28', 'HT', 'Haiti', 'AMRO', '112', '9958', '1', '236');
INSERT INTO public.who_global_data_import VALUES (36762, '2020-12-29', 'HT', 'Haiti', 'AMRO', '0', '9958', '0', '236');
INSERT INTO public.who_global_data_import VALUES (36763, '2020-12-30', 'HT', 'Haiti', 'AMRO', '41', '9999', '0', '236');
INSERT INTO public.who_global_data_import VALUES (36764, '2020-12-31', 'HT', 'Haiti', 'AMRO', '0', '9999', '0', '236');
INSERT INTO public.who_global_data_import VALUES (36765, '2021-01-01', 'HT', 'Haiti', 'AMRO', '16', '10015', '0', '236');
INSERT INTO public.who_global_data_import VALUES (36766, '2021-01-02', 'HT', 'Haiti', 'AMRO', '0', '10015', '0', '236');
INSERT INTO public.who_global_data_import VALUES (36767, '2021-01-03', 'HT', 'Haiti', 'AMRO', '62', '10077', '0', '236');
INSERT INTO public.who_global_data_import VALUES (36768, '2021-01-04', 'HT', 'Haiti', 'AMRO', '50', '10127', '0', '236');
INSERT INTO public.who_global_data_import VALUES (36769, '2021-01-05', 'HT', 'Haiti', 'AMRO', '0', '10127', '0', '236');
INSERT INTO public.who_global_data_import VALUES (36770, '2021-01-06', 'HT', 'Haiti', 'AMRO', '0', '10127', '0', '236');
INSERT INTO public.who_global_data_import VALUES (36771, '2021-01-07', 'HT', 'Haiti', 'AMRO', '0', '10127', '0', '236');
INSERT INTO public.who_global_data_import VALUES (36772, '2021-01-08', 'HT', 'Haiti', 'AMRO', '76', '10203', '0', '236');
INSERT INTO public.who_global_data_import VALUES (36773, '2021-01-09', 'HT', 'Haiti', 'AMRO', '38', '10241', '1', '237');
INSERT INTO public.who_global_data_import VALUES (36774, '2021-01-10', 'HT', 'Haiti', 'AMRO', '0', '10241', '0', '237');
INSERT INTO public.who_global_data_import VALUES (36775, '2021-01-11', 'HT', 'Haiti', 'AMRO', '31', '10272', '1', '238');
INSERT INTO public.who_global_data_import VALUES (36776, '2021-01-12', 'HT', 'Haiti', 'AMRO', '0', '10272', '0', '238');
INSERT INTO public.who_global_data_import VALUES (36777, '2021-01-13', 'HT', 'Haiti', 'AMRO', '114', '10386', '0', '238');
INSERT INTO public.who_global_data_import VALUES (36778, '2021-01-14', 'HT', 'Haiti', 'AMRO', '29', '10415', '0', '238');
INSERT INTO public.who_global_data_import VALUES (36779, '2021-01-15', 'HT', 'Haiti', 'AMRO', '154', '10569', '0', '238');
INSERT INTO public.who_global_data_import VALUES (36780, '2021-01-16', 'HT', 'Haiti', 'AMRO', '66', '10635', '0', '238');
INSERT INTO public.who_global_data_import VALUES (36781, '2021-01-17', 'HT', 'Haiti', 'AMRO', '146', '10781', '2', '240');
INSERT INTO public.who_global_data_import VALUES (36782, '2021-01-18', 'HT', 'Haiti', 'AMRO', '0', '10781', '0', '240');
INSERT INTO public.who_global_data_import VALUES (36783, '2021-01-19', 'HT', 'Haiti', 'AMRO', '71', '10852', '0', '240');
INSERT INTO public.who_global_data_import VALUES (36784, '2021-01-20', 'HT', 'Haiti', 'AMRO', '55', '10907', '0', '240');
INSERT INTO public.who_global_data_import VALUES (36785, '2021-01-21', 'HT', 'Haiti', 'AMRO', '56', '10963', '0', '240');
INSERT INTO public.who_global_data_import VALUES (36786, '2021-01-22', 'HT', 'Haiti', 'AMRO', '0', '10963', '0', '240');
INSERT INTO public.who_global_data_import VALUES (36787, '2021-01-23', 'HT', 'Haiti', 'AMRO', '72', '11035', '3', '243');
INSERT INTO public.who_global_data_import VALUES (36788, '2021-01-24', 'HT', 'Haiti', 'AMRO', '64', '11099', '0', '243');
INSERT INTO public.who_global_data_import VALUES (36789, '2021-01-25', 'HT', 'Haiti', 'AMRO', '82', '11181', '0', '243');
INSERT INTO public.who_global_data_import VALUES (36790, '2021-01-26', 'HT', 'Haiti', 'AMRO', '105', '11286', '0', '243');
INSERT INTO public.who_global_data_import VALUES (36791, '2021-01-27', 'HT', 'Haiti', 'AMRO', '0', '11286', '0', '243');
INSERT INTO public.who_global_data_import VALUES (36792, '2021-01-28', 'HT', 'Haiti', 'AMRO', '0', '11286', '0', '243');
INSERT INTO public.who_global_data_import VALUES (36793, '2021-01-29', 'HT', 'Haiti', 'AMRO', '116', '11402', '1', '244');
INSERT INTO public.who_global_data_import VALUES (36794, '2021-01-30', 'HT', 'Haiti', 'AMRO', '58', '11460', '1', '245');
INSERT INTO public.who_global_data_import VALUES (36795, '2021-01-31', 'HT', 'Haiti', 'AMRO', '73', '11533', '0', '245');
INSERT INTO public.who_global_data_import VALUES (36796, '2021-02-01', 'HT', 'Haiti', 'AMRO', '0', '11533', '0', '245');
INSERT INTO public.who_global_data_import VALUES (36797, '2021-02-02', 'HT', 'Haiti', 'AMRO', '57', '11590', '0', '245');
INSERT INTO public.who_global_data_import VALUES (36798, '2021-02-03', 'HT', 'Haiti', 'AMRO', '82', '11672', '0', '245');
INSERT INTO public.who_global_data_import VALUES (36799, '2021-02-04', 'HT', 'Haiti', 'AMRO', '20', '11692', '0', '245');
INSERT INTO public.who_global_data_import VALUES (36800, '2021-02-05', 'HT', 'Haiti', 'AMRO', '0', '11692', '0', '245');
INSERT INTO public.who_global_data_import VALUES (36801, '2020-01-03', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36802, '2020-01-04', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36803, '2020-01-05', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36804, '2020-01-06', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36805, '2020-01-07', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36806, '2020-01-08', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36807, '2020-01-09', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36808, '2020-01-10', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36809, '2020-01-11', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36810, '2020-01-12', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36811, '2020-01-13', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36812, '2020-01-14', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36813, '2020-01-15', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36814, '2020-01-16', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36815, '2020-01-17', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36816, '2020-01-18', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36817, '2020-01-19', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36818, '2020-01-20', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36819, '2020-01-21', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36820, '2020-01-22', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36821, '2020-01-23', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36822, '2020-01-24', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36823, '2020-01-25', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36824, '2020-01-26', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36825, '2020-01-27', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36826, '2020-01-28', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36827, '2020-01-29', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36828, '2020-01-30', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36829, '2020-01-31', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36830, '2020-02-01', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36831, '2020-02-02', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36832, '2020-02-03', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36833, '2020-02-04', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36834, '2020-02-05', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36835, '2020-02-06', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36836, '2020-02-07', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36837, '2020-02-08', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36838, '2020-02-09', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36839, '2020-02-10', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36840, '2020-02-11', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36841, '2020-02-12', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36842, '2020-02-13', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36843, '2020-02-14', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36844, '2020-02-15', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36845, '2020-02-16', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36846, '2020-02-17', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36847, '2020-02-18', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36848, '2020-02-19', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36849, '2020-02-20', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36850, '2020-02-21', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36851, '2020-02-22', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36852, '2020-02-23', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36853, '2020-02-24', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36854, '2020-02-25', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36855, '2020-02-26', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36856, '2020-02-27', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36857, '2020-02-28', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36858, '2020-02-29', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36859, '2020-03-01', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36860, '2020-03-02', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36861, '2020-03-03', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36862, '2020-03-04', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36863, '2020-03-05', 'VA', 'Holy See', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36864, '2020-03-06', 'VA', 'Holy See', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36865, '2020-03-07', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36866, '2020-03-08', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36867, '2020-03-09', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36868, '2020-03-10', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36869, '2020-03-11', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36870, '2020-03-12', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36871, '2020-03-13', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36872, '2020-03-14', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36873, '2020-03-15', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36874, '2020-03-16', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36875, '2020-03-17', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36876, '2020-03-18', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36877, '2020-03-19', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36878, '2020-03-20', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36879, '2020-03-21', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36880, '2020-03-22', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36881, '2020-03-23', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36882, '2020-03-24', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36883, '2020-03-25', 'VA', 'Holy See', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36884, '2020-03-26', 'VA', 'Holy See', 'EURO', '3', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36885, '2020-03-27', 'VA', 'Holy See', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36886, '2020-03-28', 'VA', 'Holy See', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36887, '2020-03-29', 'VA', 'Holy See', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36888, '2020-03-30', 'VA', 'Holy See', 'EURO', '2', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36889, '2020-03-31', 'VA', 'Holy See', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36890, '2020-04-01', 'VA', 'Holy See', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36891, '2020-04-02', 'VA', 'Holy See', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36892, '2020-04-03', 'VA', 'Holy See', 'EURO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36893, '2020-04-04', 'VA', 'Holy See', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36894, '2020-04-05', 'VA', 'Holy See', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36895, '2020-04-06', 'VA', 'Holy See', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36896, '2020-04-07', 'VA', 'Holy See', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36897, '2020-04-08', 'VA', 'Holy See', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36898, '2020-04-09', 'VA', 'Holy See', 'EURO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36899, '2020-04-10', 'VA', 'Holy See', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36900, '2020-04-11', 'VA', 'Holy See', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36901, '2020-04-12', 'VA', 'Holy See', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36902, '2020-04-13', 'VA', 'Holy See', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36903, '2020-04-14', 'VA', 'Holy See', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36904, '2020-04-15', 'VA', 'Holy See', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36905, '2020-04-16', 'VA', 'Holy See', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36906, '2020-04-17', 'VA', 'Holy See', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36907, '2020-04-18', 'VA', 'Holy See', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36908, '2020-04-19', 'VA', 'Holy See', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36909, '2020-04-20', 'VA', 'Holy See', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36910, '2020-04-21', 'VA', 'Holy See', 'EURO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36911, '2020-04-22', 'VA', 'Holy See', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36912, '2020-04-23', 'VA', 'Holy See', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36913, '2020-04-24', 'VA', 'Holy See', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36914, '2020-04-25', 'VA', 'Holy See', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36915, '2020-04-26', 'VA', 'Holy See', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36916, '2020-04-27', 'VA', 'Holy See', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36917, '2020-04-28', 'VA', 'Holy See', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36918, '2020-04-29', 'VA', 'Holy See', 'EURO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36919, '2020-04-30', 'VA', 'Holy See', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36920, '2020-05-01', 'VA', 'Holy See', 'EURO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36921, '2020-05-02', 'VA', 'Holy See', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36922, '2020-05-03', 'VA', 'Holy See', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36923, '2020-05-04', 'VA', 'Holy See', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36924, '2020-05-05', 'VA', 'Holy See', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36925, '2020-05-06', 'VA', 'Holy See', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36926, '2020-05-07', 'VA', 'Holy See', 'EURO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36927, '2020-05-08', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36928, '2020-05-09', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36929, '2020-05-10', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36930, '2020-05-11', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36931, '2020-05-12', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36932, '2020-05-13', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36933, '2020-05-14', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36934, '2020-05-15', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36935, '2020-05-16', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36936, '2020-05-17', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36937, '2020-05-18', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36938, '2020-05-19', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36939, '2020-05-20', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36940, '2020-05-21', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36941, '2020-05-22', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36942, '2020-05-23', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36943, '2020-05-24', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36944, '2020-05-25', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36945, '2020-05-26', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36946, '2020-05-27', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36947, '2020-05-28', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36948, '2020-05-29', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36949, '2020-05-30', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36950, '2020-05-31', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36951, '2020-06-01', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36952, '2020-06-02', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36953, '2020-06-03', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36954, '2020-06-04', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36955, '2020-06-05', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36956, '2020-06-06', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36957, '2020-06-07', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36958, '2020-06-08', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36959, '2020-06-09', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36960, '2020-06-10', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36961, '2020-06-11', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36962, '2020-06-12', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36963, '2020-06-13', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36964, '2020-06-14', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36965, '2020-06-15', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36966, '2020-06-16', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36967, '2020-06-17', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36968, '2020-06-18', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36969, '2020-06-19', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36970, '2020-06-20', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36971, '2020-06-21', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36972, '2020-06-22', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36973, '2020-06-23', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36974, '2020-06-24', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36975, '2020-06-25', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36976, '2020-06-26', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36977, '2020-06-27', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36978, '2020-06-28', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36979, '2020-06-29', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36980, '2020-06-30', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36981, '2020-07-01', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36982, '2020-07-02', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36983, '2020-07-03', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36984, '2020-07-04', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36985, '2020-07-05', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36986, '2020-07-06', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36987, '2020-07-07', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36988, '2020-07-08', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36989, '2020-07-09', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36990, '2020-07-10', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36991, '2020-07-11', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36992, '2020-07-12', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36993, '2020-07-13', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36994, '2020-07-14', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36995, '2020-07-15', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36996, '2020-07-16', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36997, '2020-07-17', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36998, '2020-07-18', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (36999, '2020-07-19', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37000, '2020-07-20', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37001, '2020-07-21', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37002, '2020-07-22', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37003, '2020-07-23', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37004, '2020-07-24', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37005, '2020-07-25', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37006, '2020-07-26', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37007, '2020-07-27', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37008, '2020-07-28', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37009, '2020-07-29', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37010, '2020-07-30', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37011, '2020-07-31', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37012, '2020-08-01', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37013, '2020-08-02', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37014, '2020-08-03', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37015, '2020-08-04', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37016, '2020-08-05', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37017, '2020-08-06', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37018, '2020-08-07', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37019, '2020-08-08', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37020, '2020-08-09', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37021, '2020-08-10', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37022, '2020-08-11', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37023, '2020-08-12', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37024, '2020-08-13', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37025, '2020-08-14', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37026, '2020-08-15', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37027, '2020-08-16', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37028, '2020-08-17', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37029, '2020-08-18', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37030, '2020-08-19', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37031, '2020-08-20', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37032, '2020-08-21', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37033, '2020-08-22', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37034, '2020-08-23', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37035, '2020-08-24', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37036, '2020-08-25', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37037, '2020-08-26', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37038, '2020-08-27', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37039, '2020-08-28', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37040, '2020-08-29', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37041, '2020-08-30', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37042, '2020-08-31', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37043, '2020-09-01', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37044, '2020-09-02', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37045, '2020-09-03', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37046, '2020-09-04', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37047, '2020-09-05', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37048, '2020-09-06', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37049, '2020-09-07', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37050, '2020-09-08', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37051, '2020-09-09', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37052, '2020-09-10', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37053, '2020-09-11', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37054, '2020-09-12', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37055, '2020-09-13', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37056, '2020-09-14', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37057, '2020-09-15', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37058, '2020-09-16', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37059, '2020-09-17', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37060, '2020-09-18', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37061, '2020-09-19', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37062, '2020-09-20', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37063, '2020-09-21', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37064, '2020-09-22', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37065, '2020-09-23', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37066, '2020-09-24', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37067, '2020-09-25', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37068, '2020-09-26', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37069, '2020-09-27', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37070, '2020-09-28', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37071, '2020-09-29', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37072, '2020-09-30', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37073, '2020-10-01', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37074, '2020-10-02', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37075, '2020-10-03', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37076, '2020-10-04', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37077, '2020-10-05', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37078, '2020-10-06', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37079, '2020-10-07', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37080, '2020-10-08', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37081, '2020-10-09', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37082, '2020-10-10', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37083, '2020-10-11', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37084, '2020-10-12', 'VA', 'Holy See', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37085, '2020-10-13', 'VA', 'Holy See', 'EURO', '7', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37086, '2020-10-14', 'VA', 'Holy See', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37087, '2020-10-15', 'VA', 'Holy See', 'EURO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37088, '2020-10-16', 'VA', 'Holy See', 'EURO', '7', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37089, '2020-10-17', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37090, '2020-10-18', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37091, '2020-10-19', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37092, '2020-10-20', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37093, '2020-10-21', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37094, '2020-10-22', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37095, '2020-10-23', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37096, '2020-10-24', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37097, '2020-10-25', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37098, '2020-10-26', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37099, '2020-10-27', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37100, '2020-10-28', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37101, '2020-10-29', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37102, '2020-10-30', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37103, '2020-10-31', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37104, '2020-11-01', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37105, '2020-11-02', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37106, '2020-11-03', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37107, '2020-11-04', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37108, '2020-11-05', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37109, '2020-11-06', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37110, '2020-11-07', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37111, '2020-11-08', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37112, '2020-11-09', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37113, '2020-11-10', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37114, '2020-11-11', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37115, '2020-11-12', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37116, '2020-11-13', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37117, '2020-11-14', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37118, '2020-11-15', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37119, '2020-11-16', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37120, '2020-11-17', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37121, '2020-11-18', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37122, '2020-11-19', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37123, '2020-11-20', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37124, '2020-11-21', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37125, '2020-11-22', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37126, '2020-11-23', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37127, '2020-11-24', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37128, '2020-11-25', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37129, '2020-11-26', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37130, '2020-11-27', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37131, '2020-11-28', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37132, '2020-11-29', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37133, '2020-11-30', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37134, '2020-12-01', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37135, '2020-12-02', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37136, '2020-12-03', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37137, '2020-12-04', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37138, '2020-12-05', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37139, '2020-12-06', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37140, '2020-12-07', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37141, '2020-12-08', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37142, '2020-12-09', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37143, '2020-12-10', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37144, '2020-12-11', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37145, '2020-12-12', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37146, '2020-12-13', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37147, '2020-12-14', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37148, '2020-12-15', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37149, '2020-12-16', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37150, '2020-12-17', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37151, '2020-12-18', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37152, '2020-12-19', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37153, '2020-12-20', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37154, '2020-12-21', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37155, '2020-12-22', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37156, '2020-12-23', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37157, '2020-12-24', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37158, '2020-12-25', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37159, '2020-12-26', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37160, '2020-12-27', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37161, '2020-12-28', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37162, '2020-12-29', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37163, '2020-12-30', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37164, '2020-12-31', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37165, '2021-01-01', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37166, '2021-01-02', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37167, '2021-01-03', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37168, '2021-01-04', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37169, '2021-01-05', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37170, '2021-01-06', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37171, '2021-01-07', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37172, '2021-01-08', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37173, '2021-01-09', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37174, '2021-01-10', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37175, '2021-01-11', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37176, '2021-01-12', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37177, '2021-01-13', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37178, '2021-01-14', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37179, '2021-01-15', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37180, '2021-01-16', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37181, '2021-01-17', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37182, '2021-01-18', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37183, '2021-01-19', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37184, '2021-01-20', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37185, '2021-01-21', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37186, '2021-01-22', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37187, '2021-01-23', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37188, '2021-01-24', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37189, '2021-01-25', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37190, '2021-01-26', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37191, '2021-01-27', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37192, '2021-01-28', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37193, '2021-01-29', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37194, '2021-01-30', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37195, '2021-01-31', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37196, '2021-02-01', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37197, '2021-02-02', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37198, '2021-02-03', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37199, '2021-02-04', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37200, '2021-02-05', 'VA', 'Holy See', 'EURO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37201, '2020-01-03', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37202, '2020-01-04', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37203, '2020-01-05', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37204, '2020-01-06', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37205, '2020-01-07', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37206, '2020-01-08', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37207, '2020-01-09', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37208, '2020-01-10', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37209, '2020-01-11', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37210, '2020-01-12', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37211, '2020-01-13', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37212, '2020-01-14', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37213, '2020-01-15', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37214, '2020-01-16', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37215, '2020-01-17', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37216, '2020-01-18', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37217, '2020-01-19', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37218, '2020-01-20', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37219, '2020-01-21', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37220, '2020-01-22', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37221, '2020-01-23', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37222, '2020-01-24', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37223, '2020-01-25', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37224, '2020-01-26', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37225, '2020-01-27', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37226, '2020-01-28', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37227, '2020-01-29', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37228, '2020-01-30', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37229, '2020-01-31', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37230, '2020-02-01', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37231, '2020-02-02', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37232, '2020-02-03', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37233, '2020-02-04', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37234, '2020-02-05', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37235, '2020-02-06', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37236, '2020-02-07', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37237, '2020-02-08', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37238, '2020-02-09', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37239, '2020-02-10', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37240, '2020-02-11', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37241, '2020-02-12', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37242, '2020-02-13', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37243, '2020-02-14', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37244, '2020-02-15', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37245, '2020-02-16', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37246, '2020-02-17', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37247, '2020-02-18', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37248, '2020-02-19', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37249, '2020-02-20', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37250, '2020-02-21', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37251, '2020-02-22', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37252, '2020-02-23', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37253, '2020-02-24', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37254, '2020-02-25', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37255, '2020-02-26', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37256, '2020-02-27', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37257, '2020-02-28', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37258, '2020-02-29', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37259, '2020-03-01', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37260, '2020-03-02', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37261, '2020-03-03', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37262, '2020-03-04', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37263, '2020-03-05', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37264, '2020-03-06', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37265, '2020-03-07', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37266, '2020-03-08', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37267, '2020-03-09', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37268, '2020-03-10', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37269, '2020-03-11', 'HN', 'Honduras', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37270, '2020-03-12', 'HN', 'Honduras', 'AMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37271, '2020-03-13', 'HN', 'Honduras', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37272, '2020-03-14', 'HN', 'Honduras', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37273, '2020-03-15', 'HN', 'Honduras', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37274, '2020-03-16', 'HN', 'Honduras', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37275, '2020-03-17', 'HN', 'Honduras', 'AMRO', '6', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37276, '2020-03-18', 'HN', 'Honduras', 'AMRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37277, '2020-03-19', 'HN', 'Honduras', 'AMRO', '-1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37278, '2020-03-20', 'HN', 'Honduras', 'AMRO', '12', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37279, '2020-03-21', 'HN', 'Honduras', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37280, '2020-03-22', 'HN', 'Honduras', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37281, '2020-03-23', 'HN', 'Honduras', 'AMRO', '2', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37282, '2020-03-24', 'HN', 'Honduras', 'AMRO', '4', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37283, '2020-03-25', 'HN', 'Honduras', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37284, '2020-03-26', 'HN', 'Honduras', 'AMRO', '22', '52', '1', '1');
INSERT INTO public.who_global_data_import VALUES (37285, '2020-03-27', 'HN', 'Honduras', 'AMRO', '0', '52', '0', '1');
INSERT INTO public.who_global_data_import VALUES (37286, '2020-03-28', 'HN', 'Honduras', 'AMRO', '15', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (37287, '2020-03-29', 'HN', 'Honduras', 'AMRO', '0', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (37288, '2020-03-30', 'HN', 'Honduras', 'AMRO', '43', '110', '1', '2');
INSERT INTO public.who_global_data_import VALUES (37289, '2020-03-31', 'HN', 'Honduras', 'AMRO', '29', '139', '0', '2');
INSERT INTO public.who_global_data_import VALUES (37290, '2020-04-01', 'HN', 'Honduras', 'AMRO', '0', '139', '0', '2');
INSERT INTO public.who_global_data_import VALUES (37291, '2020-04-02', 'HN', 'Honduras', 'AMRO', '33', '172', '8', '10');
INSERT INTO public.who_global_data_import VALUES (37292, '2020-04-03', 'HN', 'Honduras', 'AMRO', '47', '219', '4', '14');
INSERT INTO public.who_global_data_import VALUES (37293, '2020-04-04', 'HN', 'Honduras', 'AMRO', '3', '222', '1', '15');
INSERT INTO public.who_global_data_import VALUES (37294, '2020-04-05', 'HN', 'Honduras', 'AMRO', '42', '264', '0', '15');
INSERT INTO public.who_global_data_import VALUES (37295, '2020-04-06', 'HN', 'Honduras', 'AMRO', '4', '268', '7', '22');
INSERT INTO public.who_global_data_import VALUES (37296, '2020-04-07', 'HN', 'Honduras', 'AMRO', '30', '298', '0', '22');
INSERT INTO public.who_global_data_import VALUES (37297, '2020-04-08', 'HN', 'Honduras', 'AMRO', '7', '305', '0', '22');
INSERT INTO public.who_global_data_import VALUES (37298, '2020-04-09', 'HN', 'Honduras', 'AMRO', '7', '312', '0', '22');
INSERT INTO public.who_global_data_import VALUES (37299, '2020-04-10', 'HN', 'Honduras', 'AMRO', '31', '343', '1', '23');
INSERT INTO public.who_global_data_import VALUES (37300, '2020-04-11', 'HN', 'Honduras', 'AMRO', '39', '382', '0', '23');
INSERT INTO public.who_global_data_import VALUES (37301, '2020-04-12', 'HN', 'Honduras', 'AMRO', '10', '392', '1', '24');
INSERT INTO public.who_global_data_import VALUES (37302, '2020-04-13', 'HN', 'Honduras', 'AMRO', '1', '393', '1', '25');
INSERT INTO public.who_global_data_import VALUES (37303, '2020-04-14', 'HN', 'Honduras', 'AMRO', '4', '397', '0', '25');
INSERT INTO public.who_global_data_import VALUES (37304, '2020-04-15', 'HN', 'Honduras', 'AMRO', '10', '407', '1', '26');
INSERT INTO public.who_global_data_import VALUES (37305, '2020-04-16', 'HN', 'Honduras', 'AMRO', '12', '419', '5', '31');
INSERT INTO public.who_global_data_import VALUES (37306, '2020-04-17', 'HN', 'Honduras', 'AMRO', '7', '426', '4', '35');
INSERT INTO public.who_global_data_import VALUES (37307, '2020-04-18', 'HN', 'Honduras', 'AMRO', '16', '442', '6', '41');
INSERT INTO public.who_global_data_import VALUES (37308, '2020-04-19', 'HN', 'Honduras', 'AMRO', '15', '457', '5', '46');
INSERT INTO public.who_global_data_import VALUES (37309, '2020-04-20', 'HN', 'Honduras', 'AMRO', '15', '472', '0', '46');
INSERT INTO public.who_global_data_import VALUES (37310, '2020-04-21', 'HN', 'Honduras', 'AMRO', '5', '477', '0', '46');
INSERT INTO public.who_global_data_import VALUES (37311, '2020-04-22', 'HN', 'Honduras', 'AMRO', '17', '494', '0', '46');
INSERT INTO public.who_global_data_import VALUES (37312, '2020-04-23', 'HN', 'Honduras', 'AMRO', '16', '510', '0', '46');
INSERT INTO public.who_global_data_import VALUES (37313, '2020-04-24', 'HN', 'Honduras', 'AMRO', '9', '519', '1', '47');
INSERT INTO public.who_global_data_import VALUES (37314, '2020-04-25', 'HN', 'Honduras', 'AMRO', '43', '562', '0', '47');
INSERT INTO public.who_global_data_import VALUES (37315, '2020-04-26', 'HN', 'Honduras', 'AMRO', '29', '591', '8', '55');
INSERT INTO public.who_global_data_import VALUES (37316, '2020-04-27', 'HN', 'Honduras', 'AMRO', '36', '627', '4', '59');
INSERT INTO public.who_global_data_import VALUES (37317, '2020-04-28', 'HN', 'Honduras', 'AMRO', '34', '661', '2', '61');
INSERT INTO public.who_global_data_import VALUES (37318, '2020-04-29', 'HN', 'Honduras', 'AMRO', '41', '702', '3', '64');
INSERT INTO public.who_global_data_import VALUES (37319, '2020-04-30', 'HN', 'Honduras', 'AMRO', '36', '738', '2', '66');
INSERT INTO public.who_global_data_import VALUES (37320, '2020-05-01', 'HN', 'Honduras', 'AMRO', '33', '771', '5', '71');
INSERT INTO public.who_global_data_import VALUES (37321, '2020-05-02', 'HN', 'Honduras', 'AMRO', '33', '804', '4', '75');
INSERT INTO public.who_global_data_import VALUES (37322, '2020-05-03', 'HN', 'Honduras', 'AMRO', '95', '899', '0', '75');
INSERT INTO public.who_global_data_import VALUES (37323, '2020-05-04', 'HN', 'Honduras', 'AMRO', '111', '1010', '1', '76');
INSERT INTO public.who_global_data_import VALUES (37324, '2020-05-05', 'HN', 'Honduras', 'AMRO', '45', '1055', '6', '82');
INSERT INTO public.who_global_data_import VALUES (37325, '2020-05-06', 'HN', 'Honduras', 'AMRO', '123', '1178', '7', '89');
INSERT INTO public.who_global_data_import VALUES (37326, '2020-05-07', 'HN', 'Honduras', 'AMRO', '92', '1270', '4', '93');
INSERT INTO public.who_global_data_import VALUES (37327, '2020-05-08', 'HN', 'Honduras', 'AMRO', '191', '1461', '6', '99');
INSERT INTO public.who_global_data_import VALUES (37328, '2020-05-09', 'HN', 'Honduras', 'AMRO', '224', '1685', '6', '105');
INSERT INTO public.who_global_data_import VALUES (37329, '2020-05-10', 'HN', 'Honduras', 'AMRO', '86', '1771', '2', '107');
INSERT INTO public.who_global_data_import VALUES (37330, '2020-05-11', 'HN', 'Honduras', 'AMRO', '59', '1830', '1', '108');
INSERT INTO public.who_global_data_import VALUES (37331, '2020-05-12', 'HN', 'Honduras', 'AMRO', '142', '1972', '0', '108');
INSERT INTO public.who_global_data_import VALUES (37332, '2020-05-13', 'HN', 'Honduras', 'AMRO', '128', '2100', '8', '116');
INSERT INTO public.who_global_data_import VALUES (37333, '2020-05-14', 'HN', 'Honduras', 'AMRO', '-20', '2080', '5', '121');
INSERT INTO public.who_global_data_import VALUES (37334, '2020-05-15', 'HN', 'Honduras', 'AMRO', '175', '2255', '2', '123');
INSERT INTO public.who_global_data_import VALUES (37335, '2020-05-16', 'HN', 'Honduras', 'AMRO', '63', '2318', '10', '133');
INSERT INTO public.who_global_data_import VALUES (37336, '2020-05-17', 'HN', 'Honduras', 'AMRO', '142', '2460', '1', '134');
INSERT INTO public.who_global_data_import VALUES (37337, '2020-05-18', 'HN', 'Honduras', 'AMRO', '105', '2565', '4', '138');
INSERT INTO public.who_global_data_import VALUES (37338, '2020-05-19', 'HN', 'Honduras', 'AMRO', '81', '2646', '4', '142');
INSERT INTO public.who_global_data_import VALUES (37339, '2020-05-20', 'HN', 'Honduras', 'AMRO', '152', '2798', '4', '146');
INSERT INTO public.who_global_data_import VALUES (37340, '2020-05-21', 'HN', 'Honduras', 'AMRO', '157', '2955', '1', '147');
INSERT INTO public.who_global_data_import VALUES (37341, '2020-05-22', 'HN', 'Honduras', 'AMRO', '145', '3100', '4', '151');
INSERT INTO public.who_global_data_import VALUES (37342, '2020-05-23', 'HN', 'Honduras', 'AMRO', '104', '3204', '5', '156');
INSERT INTO public.who_global_data_import VALUES (37343, '2020-05-24', 'HN', 'Honduras', 'AMRO', '273', '3477', '11', '167');
INSERT INTO public.who_global_data_import VALUES (37344, '2020-05-25', 'HN', 'Honduras', 'AMRO', '266', '3743', '7', '174');
INSERT INTO public.who_global_data_import VALUES (37345, '2020-05-26', 'HN', 'Honduras', 'AMRO', '207', '3950', '6', '180');
INSERT INTO public.who_global_data_import VALUES (37346, '2020-05-27', 'HN', 'Honduras', 'AMRO', '239', '4189', '2', '182');
INSERT INTO public.who_global_data_import VALUES (37347, '2020-05-28', 'HN', 'Honduras', 'AMRO', '212', '4401', '6', '188');
INSERT INTO public.who_global_data_import VALUES (37348, '2020-05-29', 'HN', 'Honduras', 'AMRO', '239', '4640', '6', '194');
INSERT INTO public.who_global_data_import VALUES (37349, '2020-05-30', 'HN', 'Honduras', 'AMRO', '112', '4752', '2', '196');
INSERT INTO public.who_global_data_import VALUES (37350, '2020-05-31', 'HN', 'Honduras', 'AMRO', '134', '4886', '3', '199');
INSERT INTO public.who_global_data_import VALUES (37351, '2020-06-01', 'HN', 'Honduras', 'AMRO', '208', '5094', '2', '201');
INSERT INTO public.who_global_data_import VALUES (37352, '2020-06-02', 'HN', 'Honduras', 'AMRO', '108', '5202', '11', '212');
INSERT INTO public.who_global_data_import VALUES (37353, '2020-06-03', 'HN', 'Honduras', 'AMRO', '160', '5362', '5', '217');
INSERT INTO public.who_global_data_import VALUES (37354, '2020-06-04', 'HN', 'Honduras', 'AMRO', '165', '5527', '8', '225');
INSERT INTO public.who_global_data_import VALUES (37355, '2020-06-05', 'HN', 'Honduras', 'AMRO', '163', '5690', '9', '234');
INSERT INTO public.who_global_data_import VALUES (37356, '2020-06-06', 'HN', 'Honduras', 'AMRO', '190', '5880', '9', '243');
INSERT INTO public.who_global_data_import VALUES (37357, '2020-06-07', 'HN', 'Honduras', 'AMRO', '91', '5971', '5', '248');
INSERT INTO public.who_global_data_import VALUES (37358, '2020-06-08', 'HN', 'Honduras', 'AMRO', '184', '6155', '2', '250');
INSERT INTO public.who_global_data_import VALUES (37359, '2020-06-09', 'HN', 'Honduras', 'AMRO', '172', '6327', '8', '258');
INSERT INTO public.who_global_data_import VALUES (37360, '2020-06-10', 'HN', 'Honduras', 'AMRO', '123', '6450', '4', '262');
INSERT INTO public.who_global_data_import VALUES (37361, '2020-06-11', 'HN', 'Honduras', 'AMRO', '485', '6935', '9', '271');
INSERT INTO public.who_global_data_import VALUES (37362, '2020-06-12', 'HN', 'Honduras', 'AMRO', '425', '7360', '19', '290');
INSERT INTO public.who_global_data_import VALUES (37363, '2020-06-13', 'HN', 'Honduras', 'AMRO', '309', '7669', '4', '294');
INSERT INTO public.who_global_data_import VALUES (37364, '2020-06-14', 'HN', 'Honduras', 'AMRO', '463', '8132', '12', '306');
INSERT INTO public.who_global_data_import VALUES (37365, '2020-06-15', 'HN', 'Honduras', 'AMRO', '323', '8455', '4', '310');
INSERT INTO public.who_global_data_import VALUES (37366, '2020-06-16', 'HN', 'Honduras', 'AMRO', '403', '8858', '2', '312');
INSERT INTO public.who_global_data_import VALUES (37367, '2020-06-17', 'HN', 'Honduras', 'AMRO', '320', '9178', '10', '322');
INSERT INTO public.who_global_data_import VALUES (37368, '2020-06-18', 'HN', 'Honduras', 'AMRO', '478', '9656', '8', '330');
INSERT INTO public.who_global_data_import VALUES (37369, '2020-06-19', 'HN', 'Honduras', 'AMRO', '643', '10299', '6', '336');
INSERT INTO public.who_global_data_import VALUES (37370, '2020-06-20', 'HN', 'Honduras', 'AMRO', '440', '10739', '7', '343');
INSERT INTO public.who_global_data_import VALUES (37371, '2020-06-21', 'HN', 'Honduras', 'AMRO', '519', '11258', '6', '349');
INSERT INTO public.who_global_data_import VALUES (37372, '2020-06-22', 'HN', 'Honduras', 'AMRO', '1048', '12306', '9', '358');
INSERT INTO public.who_global_data_import VALUES (37373, '2020-06-23', 'HN', 'Honduras', 'AMRO', '519', '12825', '5', '363');
INSERT INTO public.who_global_data_import VALUES (37374, '2020-06-24', 'HN', 'Honduras', 'AMRO', '531', '13356', '32', '395');
INSERT INTO public.who_global_data_import VALUES (37375, '2020-06-25', 'HN', 'Honduras', 'AMRO', '587', '13943', '10', '405');
INSERT INTO public.who_global_data_import VALUES (37376, '2020-06-26', 'HN', 'Honduras', 'AMRO', '628', '14571', '12', '417');
INSERT INTO public.who_global_data_import VALUES (37377, '2020-06-27', 'HN', 'Honduras', 'AMRO', '795', '15366', '9', '426');
INSERT INTO public.who_global_data_import VALUES (37378, '2020-06-28', 'HN', 'Honduras', 'AMRO', '628', '15994', '45', '471');
INSERT INTO public.who_global_data_import VALUES (37379, '2020-06-29', 'HN', 'Honduras', 'AMRO', '1013', '17007', '8', '479');
INSERT INTO public.who_global_data_import VALUES (37380, '2020-06-30', 'HN', 'Honduras', 'AMRO', '1075', '18082', '0', '479');
INSERT INTO public.who_global_data_import VALUES (37381, '2020-07-01', 'HN', 'Honduras', 'AMRO', '736', '18818', '6', '485');
INSERT INTO public.who_global_data_import VALUES (37382, '2020-07-02', 'HN', 'Honduras', 'AMRO', '740', '19558', '12', '497');
INSERT INTO public.who_global_data_import VALUES (37383, '2020-07-03', 'HN', 'Honduras', 'AMRO', '704', '20262', '45', '542');
INSERT INTO public.who_global_data_import VALUES (37384, '2020-07-04', 'HN', 'Honduras', 'AMRO', '858', '21120', '49', '591');
INSERT INTO public.who_global_data_import VALUES (37385, '2020-07-05', 'HN', 'Honduras', 'AMRO', '996', '22116', '14', '605');
INSERT INTO public.who_global_data_import VALUES (37386, '2020-07-06', 'HN', 'Honduras', 'AMRO', '805', '22921', '24', '629');
INSERT INTO public.who_global_data_import VALUES (37387, '2020-07-07', 'HN', 'Honduras', 'AMRO', '1022', '23943', '10', '639');
INSERT INTO public.who_global_data_import VALUES (37388, '2020-07-08', 'HN', 'Honduras', 'AMRO', '722', '24665', '17', '656');
INSERT INTO public.who_global_data_import VALUES (37389, '2020-07-09', 'HN', 'Honduras', 'AMRO', '763', '25428', '21', '677');
INSERT INTO public.who_global_data_import VALUES (37390, '2020-07-10', 'HN', 'Honduras', 'AMRO', '550', '25978', '17', '694');
INSERT INTO public.who_global_data_import VALUES (37391, '2020-07-11', 'HN', 'Honduras', 'AMRO', '406', '26384', '10', '704');
INSERT INTO public.who_global_data_import VALUES (37392, '2020-07-12', 'HN', 'Honduras', 'AMRO', '669', '27053', '46', '750');
INSERT INTO public.who_global_data_import VALUES (37393, '2020-07-13', 'HN', 'Honduras', 'AMRO', '530', '27583', '21', '771');
INSERT INTO public.who_global_data_import VALUES (37394, '2020-07-14', 'HN', 'Honduras', 'AMRO', '507', '28090', '3', '774');
INSERT INTO public.who_global_data_import VALUES (37395, '2020-07-15', 'HN', 'Honduras', 'AMRO', '489', '28579', '15', '789');
INSERT INTO public.who_global_data_import VALUES (37396, '2020-07-16', 'HN', 'Honduras', 'AMRO', '527', '29106', '18', '807');
INSERT INTO public.who_global_data_import VALUES (37397, '2020-07-17', 'HN', 'Honduras', 'AMRO', '930', '30036', '18', '825');
INSERT INTO public.who_global_data_import VALUES (37398, '2020-07-18', 'HN', 'Honduras', 'AMRO', '831', '30867', '10', '835');
INSERT INTO public.who_global_data_import VALUES (37399, '2020-07-19', 'HN', 'Honduras', 'AMRO', '878', '31745', '22', '857');
INSERT INTO public.who_global_data_import VALUES (37400, '2020-07-20', 'HN', 'Honduras', 'AMRO', '1048', '32793', '34', '891');
INSERT INTO public.who_global_data_import VALUES (37401, '2020-07-21', 'HN', 'Honduras', 'AMRO', '1042', '33835', '9', '900');
INSERT INTO public.who_global_data_import VALUES (37402, '2020-07-22', 'HN', 'Honduras', 'AMRO', '776', '34611', '35', '935');
INSERT INTO public.who_global_data_import VALUES (37403, '2020-07-23', 'HN', 'Honduras', 'AMRO', '734', '35345', '53', '988');
INSERT INTO public.who_global_data_import VALUES (37404, '2020-07-24', 'HN', 'Honduras', 'AMRO', '757', '36102', '18', '1006');
INSERT INTO public.who_global_data_import VALUES (37405, '2020-07-25', 'HN', 'Honduras', 'AMRO', '800', '36902', '5', '1011');
INSERT INTO public.who_global_data_import VALUES (37406, '2020-07-26', 'HN', 'Honduras', 'AMRO', '657', '37559', '50', '1061');
INSERT INTO public.who_global_data_import VALUES (37407, '2020-07-27', 'HN', 'Honduras', 'AMRO', '879', '38438', '37', '1098');
INSERT INTO public.who_global_data_import VALUES (37408, '2020-07-28', 'HN', 'Honduras', 'AMRO', '838', '39276', '18', '1116');
INSERT INTO public.who_global_data_import VALUES (37409, '2020-07-29', 'HN', 'Honduras', 'AMRO', '465', '39741', '50', '1166');
INSERT INTO public.who_global_data_import VALUES (37410, '2020-07-30', 'HN', 'Honduras', 'AMRO', '719', '40460', '48', '1214');
INSERT INTO public.who_global_data_import VALUES (37411, '2020-07-31', 'HN', 'Honduras', 'AMRO', '484', '40944', '45', '1259');
INSERT INTO public.who_global_data_import VALUES (37412, '2020-08-01', 'HN', 'Honduras', 'AMRO', '482', '41426', '53', '1312');
INSERT INTO public.who_global_data_import VALUES (37413, '2020-08-02', 'HN', 'Honduras', 'AMRO', '588', '42014', '25', '1337');
INSERT INTO public.who_global_data_import VALUES (37414, '2020-08-03', 'HN', 'Honduras', 'AMRO', '671', '42685', '31', '1368');
INSERT INTO public.who_global_data_import VALUES (37415, '2020-08-04', 'HN', 'Honduras', 'AMRO', '512', '43197', '9', '1377');
INSERT INTO public.who_global_data_import VALUES (37416, '2020-08-05', 'HN', 'Honduras', 'AMRO', '597', '43794', '7', '1384');
INSERT INTO public.who_global_data_import VALUES (37417, '2020-08-06', 'HN', 'Honduras', 'AMRO', '505', '44299', '16', '1400');
INSERT INTO public.who_global_data_import VALUES (37418, '2020-08-07', 'HN', 'Honduras', 'AMRO', '799', '45098', '23', '1423');
INSERT INTO public.who_global_data_import VALUES (37419, '2020-08-08', 'HN', 'Honduras', 'AMRO', '657', '45755', '23', '1446');
INSERT INTO public.who_global_data_import VALUES (37420, '2020-08-09', 'HN', 'Honduras', 'AMRO', '880', '46635', '19', '1465');
INSERT INTO public.who_global_data_import VALUES (37421, '2020-08-10', 'HN', 'Honduras', 'AMRO', '338', '46973', '11', '1476');
INSERT INTO public.who_global_data_import VALUES (37422, '2020-08-11', 'HN', 'Honduras', 'AMRO', '481', '47454', '19', '1495');
INSERT INTO public.who_global_data_import VALUES (37423, '2020-08-12', 'HN', 'Honduras', 'AMRO', '418', '47872', '11', '1506');
INSERT INTO public.who_global_data_import VALUES (37424, '2020-08-13', 'HN', 'Honduras', 'AMRO', '531', '48403', '9', '1515');
INSERT INTO public.who_global_data_import VALUES (37425, '2020-08-14', 'HN', 'Honduras', 'AMRO', '254', '48657', '18', '1533');
INSERT INTO public.who_global_data_import VALUES (37426, '2020-08-15', 'HN', 'Honduras', 'AMRO', '385', '49042', '9', '1542');
INSERT INTO public.who_global_data_import VALUES (37427, '2020-08-16', 'HN', 'Honduras', 'AMRO', '425', '49467', '6', '1548');
INSERT INTO public.who_global_data_import VALUES (37428, '2020-08-17', 'HN', 'Honduras', 'AMRO', '512', '49979', '19', '1567');
INSERT INTO public.who_global_data_import VALUES (37429, '2020-08-18', 'HN', 'Honduras', 'AMRO', '523', '50502', '8', '1575');
INSERT INTO public.who_global_data_import VALUES (37430, '2020-08-19', 'HN', 'Honduras', 'AMRO', '493', '50995', '8', '1583');
INSERT INTO public.who_global_data_import VALUES (37431, '2020-08-20', 'HN', 'Honduras', 'AMRO', '675', '51670', '10', '1593');
INSERT INTO public.who_global_data_import VALUES (37432, '2020-08-21', 'HN', 'Honduras', 'AMRO', '626', '52296', '15', '1608');
INSERT INTO public.who_global_data_import VALUES (37433, '2020-08-22', 'HN', 'Honduras', 'AMRO', '523', '52819', '11', '1619');
INSERT INTO public.who_global_data_import VALUES (37434, '2020-08-23', 'HN', 'Honduras', 'AMRO', '562', '53381', '13', '1632');
INSERT INTO public.who_global_data_import VALUES (37435, '2020-08-24', 'HN', 'Honduras', 'AMRO', '602', '53983', '11', '1643');
INSERT INTO public.who_global_data_import VALUES (37436, '2020-08-25', 'HN', 'Honduras', 'AMRO', '528', '54511', '11', '1654');
INSERT INTO public.who_global_data_import VALUES (37437, '2020-08-26', 'HN', 'Honduras', 'AMRO', '968', '55479', '29', '1683');
INSERT INTO public.who_global_data_import VALUES (37438, '2020-08-27', 'HN', 'Honduras', 'AMRO', '398', '55877', '20', '1703');
INSERT INTO public.who_global_data_import VALUES (37439, '2020-08-28', 'HN', 'Honduras', 'AMRO', '772', '56649', '44', '1747');
INSERT INTO public.who_global_data_import VALUES (37440, '2020-08-29', 'HN', 'Honduras', 'AMRO', '1020', '57669', '56', '1803');
INSERT INTO public.who_global_data_import VALUES (37441, '2020-08-30', 'HN', 'Honduras', 'AMRO', '1141', '58810', '24', '1827');
INSERT INTO public.who_global_data_import VALUES (37442, '2020-08-31', 'HN', 'Honduras', 'AMRO', '835', '59645', '15', '1842');
INSERT INTO public.who_global_data_import VALUES (37443, '2020-09-01', 'HN', 'Honduras', 'AMRO', '529', '60174', '16', '1858');
INSERT INTO public.who_global_data_import VALUES (37444, '2020-09-02', 'HN', 'Honduras', 'AMRO', '840', '61014', '15', '1873');
INSERT INTO public.who_global_data_import VALUES (37445, '2020-09-03', 'HN', 'Honduras', 'AMRO', '755', '61769', '15', '1888');
INSERT INTO public.who_global_data_import VALUES (37446, '2020-09-04', 'HN', 'Honduras', 'AMRO', '757', '62526', '36', '1924');
INSERT INTO public.who_global_data_import VALUES (37447, '2020-09-05', 'HN', 'Honduras', 'AMRO', '632', '63158', '30', '1954');
INSERT INTO public.who_global_data_import VALUES (37448, '2020-09-06', 'HN', 'Honduras', 'AMRO', '640', '63798', '30', '1984');
INSERT INTO public.who_global_data_import VALUES (37449, '2020-09-07', 'HN', 'Honduras', 'AMRO', '554', '64352', '22', '2006');
INSERT INTO public.who_global_data_import VALUES (37450, '2020-09-08', 'HN', 'Honduras', 'AMRO', '412', '64764', '1', '2007');
INSERT INTO public.who_global_data_import VALUES (37451, '2020-09-09', 'HN', 'Honduras', 'AMRO', '50', '64814', '16', '2023');
INSERT INTO public.who_global_data_import VALUES (37452, '2020-09-10', 'HN', 'Honduras', 'AMRO', '404', '65218', '11', '2034');
INSERT INTO public.who_global_data_import VALUES (37453, '2020-09-11', 'HN', 'Honduras', 'AMRO', '379', '65597', '10', '2044');
INSERT INTO public.who_global_data_import VALUES (37454, '2020-09-12', 'HN', 'Honduras', 'AMRO', '205', '65802', '5', '2049');
INSERT INTO public.who_global_data_import VALUES (37455, '2020-09-13', 'HN', 'Honduras', 'AMRO', '247', '66049', '9', '2058');
INSERT INTO public.who_global_data_import VALUES (37456, '2020-09-14', 'HN', 'Honduras', 'AMRO', '1087', '67136', '7', '2065');
INSERT INTO public.who_global_data_import VALUES (37457, '2020-09-15', 'HN', 'Honduras', 'AMRO', '653', '67789', '14', '2079');
INSERT INTO public.who_global_data_import VALUES (37458, '2020-09-16', 'HN', 'Honduras', 'AMRO', '831', '68620', '8', '2087');
INSERT INTO public.who_global_data_import VALUES (37459, '2020-09-17', 'HN', 'Honduras', 'AMRO', '0', '68620', '0', '2087');
INSERT INTO public.who_global_data_import VALUES (37460, '2020-09-18', 'HN', 'Honduras', 'AMRO', '1040', '69660', '15', '2102');
INSERT INTO public.who_global_data_import VALUES (37461, '2020-09-19', 'HN', 'Honduras', 'AMRO', '460', '70120', '20', '2122');
INSERT INTO public.who_global_data_import VALUES (37462, '2020-09-20', 'HN', 'Honduras', 'AMRO', '491', '70611', '24', '2146');
INSERT INTO public.who_global_data_import VALUES (37463, '2020-09-21', 'HN', 'Honduras', 'AMRO', '532', '71143', '20', '2166');
INSERT INTO public.who_global_data_import VALUES (37464, '2020-09-22', 'HN', 'Honduras', 'AMRO', '473', '71616', '18', '2184');
INSERT INTO public.who_global_data_import VALUES (37465, '2020-09-23', 'HN', 'Honduras', 'AMRO', '459', '72075', '20', '2204');
INSERT INTO public.who_global_data_import VALUES (37466, '2020-09-24', 'HN', 'Honduras', 'AMRO', '231', '72306', '2', '2206');
INSERT INTO public.who_global_data_import VALUES (37467, '2020-09-25', 'HN', 'Honduras', 'AMRO', '369', '72675', '16', '2222');
INSERT INTO public.who_global_data_import VALUES (37468, '2020-09-26', 'HN', 'Honduras', 'AMRO', '518', '73193', '27', '2249');
INSERT INTO public.who_global_data_import VALUES (37469, '2020-09-27', 'HN', 'Honduras', 'AMRO', '647', '73840', '22', '2271');
INSERT INTO public.who_global_data_import VALUES (37470, '2020-09-28', 'HN', 'Honduras', 'AMRO', '708', '74548', '17', '2288');
INSERT INTO public.who_global_data_import VALUES (37471, '2020-09-29', 'HN', 'Honduras', 'AMRO', '561', '75109', '1', '2289');
INSERT INTO public.who_global_data_import VALUES (37472, '2020-09-30', 'HN', 'Honduras', 'AMRO', '428', '75537', '12', '2301');
INSERT INTO public.who_global_data_import VALUES (37473, '2020-10-01', 'HN', 'Honduras', 'AMRO', '561', '76098', '22', '2323');
INSERT INTO public.who_global_data_import VALUES (37474, '2020-10-02', 'HN', 'Honduras', 'AMRO', '802', '76900', '30', '2353');
INSERT INTO public.who_global_data_import VALUES (37475, '2020-10-03', 'HN', 'Honduras', 'AMRO', '698', '77598', '27', '2380');
INSERT INTO public.who_global_data_import VALUES (37476, '2020-10-04', 'HN', 'Honduras', 'AMRO', '671', '78269', '6', '2386');
INSERT INTO public.who_global_data_import VALUES (37477, '2020-10-05', 'HN', 'Honduras', 'AMRO', '519', '78788', '13', '2399');
INSERT INTO public.who_global_data_import VALUES (37478, '2020-10-06', 'HN', 'Honduras', 'AMRO', '841', '79629', '23', '2422');
INSERT INTO public.who_global_data_import VALUES (37479, '2020-10-07', 'HN', 'Honduras', 'AMRO', '391', '80020', '11', '2433');
INSERT INTO public.who_global_data_import VALUES (37480, '2020-10-08', 'HN', 'Honduras', 'AMRO', '642', '80662', '14', '2447');
INSERT INTO public.who_global_data_import VALUES (37481, '2020-10-09', 'HN', 'Honduras', 'AMRO', '498', '81160', '19', '2466');
INSERT INTO public.who_global_data_import VALUES (37482, '2020-10-10', 'HN', 'Honduras', 'AMRO', '512', '81672', '11', '2477');
INSERT INTO public.who_global_data_import VALUES (37483, '2020-10-11', 'HN', 'Honduras', 'AMRO', '880', '82552', '15', '2492');
INSERT INTO public.who_global_data_import VALUES (37484, '2020-10-12', 'HN', 'Honduras', 'AMRO', '594', '83146', '12', '2504');
INSERT INTO public.who_global_data_import VALUES (37485, '2020-10-13', 'HN', 'Honduras', 'AMRO', '935', '84081', '8', '2512');
INSERT INTO public.who_global_data_import VALUES (37486, '2020-10-14', 'HN', 'Honduras', 'AMRO', '332', '84413', '9', '2521');
INSERT INTO public.who_global_data_import VALUES (37487, '2020-10-15', 'HN', 'Honduras', 'AMRO', '439', '84852', '7', '2528');
INSERT INTO public.who_global_data_import VALUES (37488, '2020-10-16', 'HN', 'Honduras', 'AMRO', '606', '85458', '5', '2533');
INSERT INTO public.who_global_data_import VALUES (37489, '2020-10-17', 'HN', 'Honduras', 'AMRO', '631', '86089', '19', '2552');
INSERT INTO public.who_global_data_import VALUES (37490, '2020-10-18', 'HN', 'Honduras', 'AMRO', '602', '86691', '4', '2556');
INSERT INTO public.who_global_data_import VALUES (37491, '2020-10-19', 'HN', 'Honduras', 'AMRO', '903', '87594', '7', '2563');
INSERT INTO public.who_global_data_import VALUES (37492, '2020-10-20', 'HN', 'Honduras', 'AMRO', '841', '88435', '5', '2568');
INSERT INTO public.who_global_data_import VALUES (37493, '2020-10-21', 'HN', 'Honduras', 'AMRO', '946', '89381', '8', '2576');
INSERT INTO public.who_global_data_import VALUES (37494, '2020-10-22', 'HN', 'Honduras', 'AMRO', '851', '90232', '6', '2582');
INSERT INTO public.who_global_data_import VALUES (37495, '2020-10-23', 'HN', 'Honduras', 'AMRO', '846', '91078', '14', '2596');
INSERT INTO public.who_global_data_import VALUES (37496, '2020-10-24', 'HN', 'Honduras', 'AMRO', '431', '91509', '8', '2604');
INSERT INTO public.who_global_data_import VALUES (37497, '2020-10-25', 'HN', 'Honduras', 'AMRO', '373', '91882', '8', '2612');
INSERT INTO public.who_global_data_import VALUES (37498, '2020-10-26', 'HN', 'Honduras', 'AMRO', '842', '92724', '5', '2617');
INSERT INTO public.who_global_data_import VALUES (37499, '2020-10-27', 'HN', 'Honduras', 'AMRO', '490', '93214', '6', '2623');
INSERT INTO public.who_global_data_import VALUES (37500, '2020-10-28', 'HN', 'Honduras', 'AMRO', '752', '93966', '10', '2633');
INSERT INTO public.who_global_data_import VALUES (37501, '2020-10-29', 'HN', 'Honduras', 'AMRO', '657', '94623', '6', '2639');
INSERT INTO public.who_global_data_import VALUES (37502, '2020-10-30', 'HN', 'Honduras', 'AMRO', '576', '95199', '13', '2652');
INSERT INTO public.who_global_data_import VALUES (37503, '2020-10-31', 'HN', 'Honduras', 'AMRO', '951', '96150', '9', '2661');
INSERT INTO public.who_global_data_import VALUES (37504, '2020-11-01', 'HN', 'Honduras', 'AMRO', '738', '96888', '8', '2669');
INSERT INTO public.who_global_data_import VALUES (37505, '2020-11-02', 'HN', 'Honduras', 'AMRO', '516', '97404', '3', '2672');
INSERT INTO public.who_global_data_import VALUES (37506, '2020-11-03', 'HN', 'Honduras', 'AMRO', '808', '98212', '3', '2675');
INSERT INTO public.who_global_data_import VALUES (37507, '2020-11-04', 'HN', 'Honduras', 'AMRO', '193', '98405', '13', '2688');
INSERT INTO public.who_global_data_import VALUES (37508, '2020-11-05', 'HN', 'Honduras', 'AMRO', '283', '98688', '18', '2706');
INSERT INTO public.who_global_data_import VALUES (37509, '2020-11-06', 'HN', 'Honduras', 'AMRO', '436', '99124', '24', '2730');
INSERT INTO public.who_global_data_import VALUES (37510, '2020-11-07', 'HN', 'Honduras', 'AMRO', '223', '99347', '6', '2736');
INSERT INTO public.who_global_data_import VALUES (37511, '2020-11-08', 'HN', 'Honduras', 'AMRO', '229', '99576', '5', '2741');
INSERT INTO public.who_global_data_import VALUES (37512, '2020-11-09', 'HN', 'Honduras', 'AMRO', '465', '100041', '4', '2745');
INSERT INTO public.who_global_data_import VALUES (37513, '2020-11-10', 'HN', 'Honduras', 'AMRO', '467', '100508', '6', '2751');
INSERT INTO public.who_global_data_import VALUES (37514, '2020-11-11', 'HN', 'Honduras', 'AMRO', '65', '100573', '14', '2765');
INSERT INTO public.who_global_data_import VALUES (37515, '2020-11-12', 'HN', 'Honduras', 'AMRO', '231', '100804', '15', '2780');
INSERT INTO public.who_global_data_import VALUES (37516, '2020-11-13', 'HN', 'Honduras', 'AMRO', '365', '101169', '17', '2797');
INSERT INTO public.who_global_data_import VALUES (37517, '2020-11-14', 'HN', 'Honduras', 'AMRO', '299', '101468', '7', '2804');
INSERT INTO public.who_global_data_import VALUES (37518, '2020-11-15', 'HN', 'Honduras', 'AMRO', '611', '102079', '16', '2820');
INSERT INTO public.who_global_data_import VALUES (37519, '2020-11-16', 'HN', 'Honduras', 'AMRO', '476', '102555', '2', '2822');
INSERT INTO public.who_global_data_import VALUES (37520, '2020-11-17', 'HN', 'Honduras', 'AMRO', '547', '103102', '1', '2823');
INSERT INTO public.who_global_data_import VALUES (37521, '2020-11-18', 'HN', 'Honduras', 'AMRO', '137', '103239', '16', '2839');
INSERT INTO public.who_global_data_import VALUES (37522, '2020-11-19', 'HN', 'Honduras', 'AMRO', '249', '103488', '0', '2839');
INSERT INTO public.who_global_data_import VALUES (37523, '2020-11-20', 'HN', 'Honduras', 'AMRO', '0', '103488', '0', '2839');
INSERT INTO public.who_global_data_import VALUES (37524, '2020-11-21', 'HN', 'Honduras', 'AMRO', '63', '103551', '14', '2853');
INSERT INTO public.who_global_data_import VALUES (37525, '2020-11-22', 'HN', 'Honduras', 'AMRO', '628', '104179', '2', '2855');
INSERT INTO public.who_global_data_import VALUES (37526, '2020-11-23', 'HN', 'Honduras', 'AMRO', '256', '104435', '2', '2857');
INSERT INTO public.who_global_data_import VALUES (37527, '2020-11-24', 'HN', 'Honduras', 'AMRO', '480', '104915', '2', '2859');
INSERT INTO public.who_global_data_import VALUES (37528, '2020-11-25', 'HN', 'Honduras', 'AMRO', '296', '105211', '10', '2869');
INSERT INTO public.who_global_data_import VALUES (37529, '2020-11-26', 'HN', 'Honduras', 'AMRO', '361', '105572', '8', '2877');
INSERT INTO public.who_global_data_import VALUES (37530, '2020-11-27', 'HN', 'Honduras', 'AMRO', '544', '106116', '11', '2888');
INSERT INTO public.who_global_data_import VALUES (37531, '2020-11-28', 'HN', 'Honduras', 'AMRO', '565', '106681', '4', '2892');
INSERT INTO public.who_global_data_import VALUES (37532, '2020-11-29', 'HN', 'Honduras', 'AMRO', '453', '107134', '7', '2899');
INSERT INTO public.who_global_data_import VALUES (37533, '2020-11-30', 'HN', 'Honduras', 'AMRO', '379', '107513', '6', '2905');
INSERT INTO public.who_global_data_import VALUES (37534, '2020-12-01', 'HN', 'Honduras', 'AMRO', '375', '107888', '4', '2909');
INSERT INTO public.who_global_data_import VALUES (37535, '2020-12-02', 'HN', 'Honduras', 'AMRO', '365', '108253', '9', '2918');
INSERT INTO public.who_global_data_import VALUES (37536, '2020-12-03', 'HN', 'Honduras', 'AMRO', '388', '108641', '9', '2927');
INSERT INTO public.who_global_data_import VALUES (37537, '2020-12-04', 'HN', 'Honduras', 'AMRO', '503', '109144', '3', '2930');
INSERT INTO public.who_global_data_import VALUES (37538, '2020-12-05', 'HN', 'Honduras', 'AMRO', '616', '109760', '8', '2938');
INSERT INTO public.who_global_data_import VALUES (37539, '2020-12-06', 'HN', 'Honduras', 'AMRO', '200', '109960', '3', '2941');
INSERT INTO public.who_global_data_import VALUES (37540, '2020-12-07', 'HN', 'Honduras', 'AMRO', '763', '110723', '4', '2945');
INSERT INTO public.who_global_data_import VALUES (37541, '2020-12-08', 'HN', 'Honduras', 'AMRO', '300', '111023', '1', '2946');
INSERT INTO public.who_global_data_import VALUES (37542, '2020-12-09', 'HN', 'Honduras', 'AMRO', '684', '111707', '4', '2950');
INSERT INTO public.who_global_data_import VALUES (37543, '2020-12-10', 'HN', 'Honduras', 'AMRO', '468', '112175', '2', '2952');
INSERT INTO public.who_global_data_import VALUES (37544, '2020-12-11', 'HN', 'Honduras', 'AMRO', '617', '112792', '9', '2961');
INSERT INTO public.who_global_data_import VALUES (37545, '2020-12-12', 'HN', 'Honduras', 'AMRO', '415', '113207', '7', '2968');
INSERT INTO public.who_global_data_import VALUES (37546, '2020-12-13', 'HN', 'Honduras', 'AMRO', '501', '113708', '3', '2971');
INSERT INTO public.who_global_data_import VALUES (37547, '2020-12-14', 'HN', 'Honduras', 'AMRO', '335', '114043', '3', '2974');
INSERT INTO public.who_global_data_import VALUES (37548, '2020-12-15', 'HN', 'Honduras', 'AMRO', '316', '114359', '1', '2975');
INSERT INTO public.who_global_data_import VALUES (37549, '2020-12-16', 'HN', 'Honduras', 'AMRO', '283', '114642', '14', '2989');
INSERT INTO public.who_global_data_import VALUES (37550, '2020-12-17', 'HN', 'Honduras', 'AMRO', '301', '114943', '12', '3001');
INSERT INTO public.who_global_data_import VALUES (37551, '2020-12-18', 'HN', 'Honduras', 'AMRO', '374', '115317', '12', '3013');
INSERT INTO public.who_global_data_import VALUES (37552, '2020-12-19', 'HN', 'Honduras', 'AMRO', '157', '115474', '8', '3021');
INSERT INTO public.who_global_data_import VALUES (37553, '2020-12-20', 'HN', 'Honduras', 'AMRO', '738', '116212', '2', '3023');
INSERT INTO public.who_global_data_import VALUES (37554, '2020-12-21', 'HN', 'Honduras', 'AMRO', '648', '116860', '2', '3025');
INSERT INTO public.who_global_data_import VALUES (37555, '2020-12-22', 'HN', 'Honduras', 'AMRO', '162', '117022', '2', '3027');
INSERT INTO public.who_global_data_import VALUES (37556, '2020-12-23', 'HN', 'Honduras', 'AMRO', '168', '117190', '7', '3034');
INSERT INTO public.who_global_data_import VALUES (37557, '2020-12-24', 'HN', 'Honduras', 'AMRO', '398', '117588', '12', '3046');
INSERT INTO public.who_global_data_import VALUES (37558, '2020-12-25', 'HN', 'Honduras', 'AMRO', '448', '118036', '8', '3054');
INSERT INTO public.who_global_data_import VALUES (37559, '2020-12-26', 'HN', 'Honduras', 'AMRO', '385', '118421', '6', '3060');
INSERT INTO public.who_global_data_import VALUES (37560, '2020-12-27', 'HN', 'Honduras', 'AMRO', '238', '118659', '1', '3061');
INSERT INTO public.who_global_data_import VALUES (37561, '2020-12-28', 'HN', 'Honduras', 'AMRO', '438', '119097', '4', '3065');
INSERT INTO public.who_global_data_import VALUES (37562, '2020-12-29', 'HN', 'Honduras', 'AMRO', '616', '119713', '1', '3066');
INSERT INTO public.who_global_data_import VALUES (37563, '2020-12-30', 'HN', 'Honduras', 'AMRO', '390', '120103', '22', '3088');
INSERT INTO public.who_global_data_import VALUES (37564, '2020-12-31', 'HN', 'Honduras', 'AMRO', '809', '120912', '23', '3111');
INSERT INTO public.who_global_data_import VALUES (37565, '2021-01-01', 'HN', 'Honduras', 'AMRO', '915', '121827', '19', '3130');
INSERT INTO public.who_global_data_import VALUES (37566, '2021-01-02', 'HN', 'Honduras', 'AMRO', '936', '122763', '11', '3141');
INSERT INTO public.who_global_data_import VALUES (37567, '2021-01-03', 'HN', 'Honduras', 'AMRO', '211', '122974', '19', '3160');
INSERT INTO public.who_global_data_import VALUES (37568, '2021-01-04', 'HN', 'Honduras', 'AMRO', '170', '123144', '13', '3173');
INSERT INTO public.who_global_data_import VALUES (37569, '2021-01-05', 'HN', 'Honduras', 'AMRO', '225', '123369', '7', '3180');
INSERT INTO public.who_global_data_import VALUES (37570, '2021-01-06', 'HN', 'Honduras', 'AMRO', '29', '123398', '1', '3181');
INSERT INTO public.who_global_data_import VALUES (37571, '2021-01-07', 'HN', 'Honduras', 'AMRO', '424', '123822', '5', '3186');
INSERT INTO public.who_global_data_import VALUES (37572, '2021-01-08', 'HN', 'Honduras', 'AMRO', '1077', '124899', '6', '3192');
INSERT INTO public.who_global_data_import VALUES (37573, '2021-01-09', 'HN', 'Honduras', 'AMRO', '658', '125557', '52', '3244');
INSERT INTO public.who_global_data_import VALUES (37574, '2021-01-10', 'HN', 'Honduras', 'AMRO', '839', '126396', '22', '3266');
INSERT INTO public.who_global_data_import VALUES (37575, '2021-01-11', 'HN', 'Honduras', 'AMRO', '830', '127226', '9', '3275');
INSERT INTO public.who_global_data_import VALUES (37576, '2021-01-12', 'HN', 'Honduras', 'AMRO', '719', '127945', '-2', '3273');
INSERT INTO public.who_global_data_import VALUES (37577, '2021-01-13', 'HN', 'Honduras', 'AMRO', '756', '128701', '12', '3285');
INSERT INTO public.who_global_data_import VALUES (37578, '2021-01-14', 'HN', 'Honduras', 'AMRO', '1104', '129805', '9', '3294');
INSERT INTO public.who_global_data_import VALUES (37579, '2021-01-15', 'HN', 'Honduras', 'AMRO', '1204', '131009', '26', '3320');
INSERT INTO public.who_global_data_import VALUES (37580, '2021-01-16', 'HN', 'Honduras', 'AMRO', '954', '131963', '15', '3335');
INSERT INTO public.who_global_data_import VALUES (37581, '2021-01-17', 'HN', 'Honduras', 'AMRO', '449', '132412', '9', '3344');
INSERT INTO public.who_global_data_import VALUES (37582, '2021-01-18', 'HN', 'Honduras', 'AMRO', '1095', '133507', '4', '3348');
INSERT INTO public.who_global_data_import VALUES (37583, '2021-01-19', 'HN', 'Honduras', 'AMRO', '604', '134111', '6', '3354');
INSERT INTO public.who_global_data_import VALUES (37584, '2021-01-20', 'HN', 'Honduras', 'AMRO', '827', '134938', '14', '3368');
INSERT INTO public.who_global_data_import VALUES (37585, '2021-01-21', 'HN', 'Honduras', 'AMRO', '1130', '136068', '23', '3391');
INSERT INTO public.who_global_data_import VALUES (37586, '2021-01-22', 'HN', 'Honduras', 'AMRO', '830', '136898', '15', '3406');
INSERT INTO public.who_global_data_import VALUES (37587, '2021-01-23', 'HN', 'Honduras', 'AMRO', '1146', '138044', '16', '3422');
INSERT INTO public.who_global_data_import VALUES (37588, '2021-01-24', 'HN', 'Honduras', 'AMRO', '1138', '139182', '17', '3439');
INSERT INTO public.who_global_data_import VALUES (37589, '2021-01-25', 'HN', 'Honduras', 'AMRO', '1056', '140238', '2', '3441');
INSERT INTO public.who_global_data_import VALUES (37590, '2021-01-26', 'HN', 'Honduras', 'AMRO', '691', '140929', '6', '3447');
INSERT INTO public.who_global_data_import VALUES (37591, '2021-01-27', 'HN', 'Honduras', 'AMRO', '1055', '141984', '15', '3462');
INSERT INTO public.who_global_data_import VALUES (37592, '2021-01-28', 'HN', 'Honduras', 'AMRO', '896', '142880', '24', '3486');
INSERT INTO public.who_global_data_import VALUES (37593, '2021-01-29', 'HN', 'Honduras', 'AMRO', '1127', '144007', '26', '3512');
INSERT INTO public.who_global_data_import VALUES (37594, '2021-01-30', 'HN', 'Honduras', 'AMRO', '985', '144992', '37', '3549');
INSERT INTO public.who_global_data_import VALUES (37595, '2021-01-31', 'HN', 'Honduras', 'AMRO', '1118', '146110', '26', '3575');
INSERT INTO public.who_global_data_import VALUES (37596, '2021-02-01', 'HN', 'Honduras', 'AMRO', '990', '147100', '17', '3592');
INSERT INTO public.who_global_data_import VALUES (37597, '2021-02-02', 'HN', 'Honduras', 'AMRO', '743', '147843', '18', '3610');
INSERT INTO public.who_global_data_import VALUES (37598, '2021-02-03', 'HN', 'Honduras', 'AMRO', '1108', '148951', '4', '3614');
INSERT INTO public.who_global_data_import VALUES (37599, '2021-02-04', 'HN', 'Honduras', 'AMRO', '840', '149791', '24', '3638');
INSERT INTO public.who_global_data_import VALUES (37600, '2021-02-05', 'HN', 'Honduras', 'AMRO', '1312', '151103', '24', '3662');
INSERT INTO public.who_global_data_import VALUES (37601, '2020-01-03', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37602, '2020-01-04', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37603, '2020-01-05', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37604, '2020-01-06', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37605, '2020-01-07', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37606, '2020-01-08', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37607, '2020-01-09', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37608, '2020-01-10', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37609, '2020-01-11', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37610, '2020-01-12', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37611, '2020-01-13', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37612, '2020-01-14', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37613, '2020-01-15', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37614, '2020-01-16', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37615, '2020-01-17', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37616, '2020-01-18', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37617, '2020-01-19', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37618, '2020-01-20', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37619, '2020-01-21', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37620, '2020-01-22', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37621, '2020-01-23', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37622, '2020-01-24', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37623, '2020-01-25', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37624, '2020-01-26', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37625, '2020-01-27', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37626, '2020-01-28', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37627, '2020-01-29', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37628, '2020-01-30', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37629, '2020-01-31', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37630, '2020-02-01', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37631, '2020-02-02', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37632, '2020-02-03', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37633, '2020-02-04', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37634, '2020-02-05', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37635, '2020-02-06', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37636, '2020-02-07', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37637, '2020-02-08', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37638, '2020-02-09', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37639, '2020-02-10', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37640, '2020-02-11', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37641, '2020-02-12', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37642, '2020-02-13', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37643, '2020-02-14', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37644, '2020-02-15', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37645, '2020-02-16', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37646, '2020-02-17', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37647, '2020-02-18', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37648, '2020-02-19', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37649, '2020-02-20', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37650, '2020-02-21', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37651, '2020-02-22', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37652, '2020-02-23', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37653, '2020-02-24', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37654, '2020-02-25', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37655, '2020-02-26', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37656, '2020-02-27', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37657, '2020-02-28', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37658, '2020-02-29', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37659, '2020-03-01', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37660, '2020-03-02', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37661, '2020-03-03', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37662, '2020-03-04', 'HU', 'Hungary', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37663, '2020-03-05', 'HU', 'Hungary', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37664, '2020-03-06', 'HU', 'Hungary', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37665, '2020-03-07', 'HU', 'Hungary', 'EURO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37666, '2020-03-08', 'HU', 'Hungary', 'EURO', '3', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37667, '2020-03-09', 'HU', 'Hungary', 'EURO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37668, '2020-03-10', 'HU', 'Hungary', 'EURO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37669, '2020-03-11', 'HU', 'Hungary', 'EURO', '3', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37670, '2020-03-12', 'HU', 'Hungary', 'EURO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37671, '2020-03-13', 'HU', 'Hungary', 'EURO', '3', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37672, '2020-03-14', 'HU', 'Hungary', 'EURO', '9', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37673, '2020-03-15', 'HU', 'Hungary', 'EURO', '6', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37674, '2020-03-16', 'HU', 'Hungary', 'EURO', '8', '39', '1', '1');
INSERT INTO public.who_global_data_import VALUES (37675, '2020-03-17', 'HU', 'Hungary', 'EURO', '11', '50', '0', '1');
INSERT INTO public.who_global_data_import VALUES (37676, '2020-03-18', 'HU', 'Hungary', 'EURO', '0', '50', '0', '1');
INSERT INTO public.who_global_data_import VALUES (37677, '2020-03-19', 'HU', 'Hungary', 'EURO', '23', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (37678, '2020-03-20', 'HU', 'Hungary', 'EURO', '12', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (37679, '2020-03-21', 'HU', 'Hungary', 'EURO', '18', '103', '3', '4');
INSERT INTO public.who_global_data_import VALUES (37680, '2020-03-22', 'HU', 'Hungary', 'EURO', '28', '131', '0', '4');
INSERT INTO public.who_global_data_import VALUES (37681, '2020-03-23', 'HU', 'Hungary', 'EURO', '36', '167', '3', '7');
INSERT INTO public.who_global_data_import VALUES (37682, '2020-03-24', 'HU', 'Hungary', 'EURO', '20', '187', '1', '8');
INSERT INTO public.who_global_data_import VALUES (37683, '2020-03-25', 'HU', 'Hungary', 'EURO', '39', '226', '2', '10');
INSERT INTO public.who_global_data_import VALUES (37684, '2020-03-26', 'HU', 'Hungary', 'EURO', '35', '261', '0', '10');
INSERT INTO public.who_global_data_import VALUES (37685, '2020-03-27', 'HU', 'Hungary', 'EURO', '39', '300', '0', '10');
INSERT INTO public.who_global_data_import VALUES (37686, '2020-03-28', 'HU', 'Hungary', 'EURO', '43', '343', '1', '11');
INSERT INTO public.who_global_data_import VALUES (37687, '2020-03-29', 'HU', 'Hungary', 'EURO', '65', '408', '2', '13');
INSERT INTO public.who_global_data_import VALUES (37688, '2020-03-30', 'HU', 'Hungary', 'EURO', '39', '447', '2', '15');
INSERT INTO public.who_global_data_import VALUES (37689, '2020-03-31', 'HU', 'Hungary', 'EURO', '45', '492', '1', '16');
INSERT INTO public.who_global_data_import VALUES (37690, '2020-04-01', 'HU', 'Hungary', 'EURO', '33', '525', '4', '20');
INSERT INTO public.who_global_data_import VALUES (37691, '2020-04-02', 'HU', 'Hungary', 'EURO', '60', '585', '1', '21');
INSERT INTO public.who_global_data_import VALUES (37692, '2020-04-03', 'HU', 'Hungary', 'EURO', '38', '623', '5', '26');
INSERT INTO public.who_global_data_import VALUES (37693, '2020-04-04', 'HU', 'Hungary', 'EURO', '55', '678', '6', '32');
INSERT INTO public.who_global_data_import VALUES (37694, '2020-04-05', 'HU', 'Hungary', 'EURO', '55', '733', '2', '34');
INSERT INTO public.who_global_data_import VALUES (37695, '2020-04-06', 'HU', 'Hungary', 'EURO', '11', '744', '4', '38');
INSERT INTO public.who_global_data_import VALUES (37696, '2020-04-07', 'HU', 'Hungary', 'EURO', '73', '817', '9', '47');
INSERT INTO public.who_global_data_import VALUES (37697, '2020-04-08', 'HU', 'Hungary', 'EURO', '78', '895', '11', '58');
INSERT INTO public.who_global_data_import VALUES (37698, '2020-04-09', 'HU', 'Hungary', 'EURO', '85', '980', '8', '66');
INSERT INTO public.who_global_data_import VALUES (37699, '2020-04-10', 'HU', 'Hungary', 'EURO', '210', '1190', '11', '77');
INSERT INTO public.who_global_data_import VALUES (37700, '2020-04-11', 'HU', 'Hungary', 'EURO', '120', '1310', '8', '85');
INSERT INTO public.who_global_data_import VALUES (37701, '2020-04-12', 'HU', 'Hungary', 'EURO', '100', '1410', '14', '99');
INSERT INTO public.who_global_data_import VALUES (37702, '2020-04-13', 'HU', 'Hungary', 'EURO', '48', '1458', '10', '109');
INSERT INTO public.who_global_data_import VALUES (37703, '2020-04-14', 'HU', 'Hungary', 'EURO', '54', '1512', '13', '122');
INSERT INTO public.who_global_data_import VALUES (37704, '2020-04-15', 'HU', 'Hungary', 'EURO', '67', '1579', '12', '134');
INSERT INTO public.who_global_data_import VALUES (37705, '2020-04-16', 'HU', 'Hungary', 'EURO', '73', '1652', '8', '142');
INSERT INTO public.who_global_data_import VALUES (37706, '2020-04-17', 'HU', 'Hungary', 'EURO', '111', '1763', '14', '156');
INSERT INTO public.who_global_data_import VALUES (37707, '2020-04-18', 'HU', 'Hungary', 'EURO', '71', '1834', '16', '172');
INSERT INTO public.who_global_data_import VALUES (37708, '2020-04-19', 'HU', 'Hungary', 'EURO', '82', '1916', '17', '189');
INSERT INTO public.who_global_data_import VALUES (37709, '2020-04-20', 'HU', 'Hungary', 'EURO', '68', '1984', '10', '199');
INSERT INTO public.who_global_data_import VALUES (37710, '2020-04-21', 'HU', 'Hungary', 'EURO', '114', '2098', '14', '213');
INSERT INTO public.who_global_data_import VALUES (37711, '2020-04-22', 'HU', 'Hungary', 'EURO', '70', '2168', '12', '225');
INSERT INTO public.who_global_data_import VALUES (37712, '2020-04-23', 'HU', 'Hungary', 'EURO', '116', '2284', '0', '225');
INSERT INTO public.who_global_data_import VALUES (37713, '2020-04-24', 'HU', 'Hungary', 'EURO', '99', '2383', '25', '250');
INSERT INTO public.who_global_data_import VALUES (37714, '2020-04-25', 'HU', 'Hungary', 'EURO', '60', '2443', '12', '262');
INSERT INTO public.who_global_data_import VALUES (37715, '2020-04-26', 'HU', 'Hungary', 'EURO', '57', '2500', '10', '272');
INSERT INTO public.who_global_data_import VALUES (37716, '2020-04-27', 'HU', 'Hungary', 'EURO', '83', '2583', '8', '280');
INSERT INTO public.who_global_data_import VALUES (37717, '2020-04-28', 'HU', 'Hungary', 'EURO', '66', '2649', '11', '291');
INSERT INTO public.who_global_data_import VALUES (37718, '2020-04-29', 'HU', 'Hungary', 'EURO', '78', '2727', '9', '300');
INSERT INTO public.who_global_data_import VALUES (37719, '2020-04-30', 'HU', 'Hungary', 'EURO', '48', '2775', '12', '312');
INSERT INTO public.who_global_data_import VALUES (37720, '2020-05-01', 'HU', 'Hungary', 'EURO', '88', '2863', '11', '323');
INSERT INTO public.who_global_data_import VALUES (37721, '2020-05-02', 'HU', 'Hungary', 'EURO', '79', '2942', '12', '335');
INSERT INTO public.who_global_data_import VALUES (37722, '2020-05-03', 'HU', 'Hungary', 'EURO', '56', '2998', '5', '340');
INSERT INTO public.who_global_data_import VALUES (37723, '2020-05-04', 'HU', 'Hungary', 'EURO', '37', '3035', '11', '351');
INSERT INTO public.who_global_data_import VALUES (37724, '2020-05-05', 'HU', 'Hungary', 'EURO', '30', '3065', '12', '363');
INSERT INTO public.who_global_data_import VALUES (37725, '2020-05-06', 'HU', 'Hungary', 'EURO', '46', '3111', '10', '373');
INSERT INTO public.who_global_data_import VALUES (37726, '2020-05-07', 'HU', 'Hungary', 'EURO', '39', '3150', '10', '383');
INSERT INTO public.who_global_data_import VALUES (37727, '2020-05-08', 'HU', 'Hungary', 'EURO', '28', '3178', '9', '392');
INSERT INTO public.who_global_data_import VALUES (37728, '2020-05-09', 'HU', 'Hungary', 'EURO', '35', '3213', '13', '405');
INSERT INTO public.who_global_data_import VALUES (37729, '2020-05-10', 'HU', 'Hungary', 'EURO', '50', '3263', '8', '413');
INSERT INTO public.who_global_data_import VALUES (37730, '2020-05-11', 'HU', 'Hungary', 'EURO', '21', '3284', '8', '421');
INSERT INTO public.who_global_data_import VALUES (37731, '2020-05-12', 'HU', 'Hungary', 'EURO', '29', '3313', '4', '425');
INSERT INTO public.who_global_data_import VALUES (37732, '2020-05-13', 'HU', 'Hungary', 'EURO', '28', '3341', '5', '430');
INSERT INTO public.who_global_data_import VALUES (37733, '2020-05-14', 'HU', 'Hungary', 'EURO', '39', '3380', '6', '436');
INSERT INTO public.who_global_data_import VALUES (37734, '2020-05-15', 'HU', 'Hungary', 'EURO', '37', '3417', '6', '442');
INSERT INTO public.who_global_data_import VALUES (37735, '2020-05-16', 'HU', 'Hungary', 'EURO', '56', '3473', '6', '448');
INSERT INTO public.who_global_data_import VALUES (37736, '2020-05-17', 'HU', 'Hungary', 'EURO', '36', '3509', '3', '451');
INSERT INTO public.who_global_data_import VALUES (37737, '2020-05-18', 'HU', 'Hungary', 'EURO', '26', '3535', '11', '462');
INSERT INTO public.who_global_data_import VALUES (37738, '2020-05-19', 'HU', 'Hungary', 'EURO', '21', '3556', '5', '467');
INSERT INTO public.who_global_data_import VALUES (37739, '2020-05-20', 'HU', 'Hungary', 'EURO', '42', '3598', '3', '470');
INSERT INTO public.who_global_data_import VALUES (37740, '2020-05-21', 'HU', 'Hungary', 'EURO', '43', '3641', '3', '473');
INSERT INTO public.who_global_data_import VALUES (37741, '2020-05-22', 'HU', 'Hungary', 'EURO', '37', '3678', '3', '476');
INSERT INTO public.who_global_data_import VALUES (37742, '2020-05-23', 'HU', 'Hungary', 'EURO', '35', '3713', '6', '482');
INSERT INTO public.who_global_data_import VALUES (37743, '2020-05-24', 'HU', 'Hungary', 'EURO', '28', '3741', '4', '486');
INSERT INTO public.who_global_data_import VALUES (37744, '2020-05-25', 'HU', 'Hungary', 'EURO', '15', '3756', '5', '491');
INSERT INTO public.who_global_data_import VALUES (37745, '2020-05-26', 'HU', 'Hungary', 'EURO', '15', '3771', '8', '499');
INSERT INTO public.who_global_data_import VALUES (37746, '2020-05-27', 'HU', 'Hungary', 'EURO', '22', '3793', '6', '505');
INSERT INTO public.who_global_data_import VALUES (37747, '2020-05-28', 'HU', 'Hungary', 'EURO', '23', '3816', '4', '509');
INSERT INTO public.who_global_data_import VALUES (37748, '2020-05-29', 'HU', 'Hungary', 'EURO', '25', '3841', '8', '517');
INSERT INTO public.who_global_data_import VALUES (37749, '2020-05-30', 'HU', 'Hungary', 'EURO', '0', '3841', '0', '517');
INSERT INTO public.who_global_data_import VALUES (37750, '2020-05-31', 'HU', 'Hungary', 'EURO', '26', '3867', '7', '524');
INSERT INTO public.who_global_data_import VALUES (37751, '2020-06-01', 'HU', 'Hungary', 'EURO', '9', '3876', '2', '526');
INSERT INTO public.who_global_data_import VALUES (37752, '2020-06-02', 'HU', 'Hungary', 'EURO', '45', '3921', '6', '532');
INSERT INTO public.who_global_data_import VALUES (37753, '2020-06-03', 'HU', 'Hungary', 'EURO', '10', '3931', '2', '534');
INSERT INTO public.who_global_data_import VALUES (37754, '2020-06-04', 'HU', 'Hungary', 'EURO', '0', '3931', '0', '534');
INSERT INTO public.who_global_data_import VALUES (37755, '2020-06-05', 'HU', 'Hungary', 'EURO', '23', '3954', '5', '539');
INSERT INTO public.who_global_data_import VALUES (37756, '2020-06-06', 'HU', 'Hungary', 'EURO', '16', '3970', '3', '542');
INSERT INTO public.who_global_data_import VALUES (37757, '2020-06-07', 'HU', 'Hungary', 'EURO', '0', '3970', '0', '542');
INSERT INTO public.who_global_data_import VALUES (37758, '2020-06-08', 'HU', 'Hungary', 'EURO', '0', '3970', '0', '542');
INSERT INTO public.who_global_data_import VALUES (37759, '2020-06-09', 'HU', 'Hungary', 'EURO', '44', '4014', '6', '548');
INSERT INTO public.who_global_data_import VALUES (37760, '2020-06-10', 'HU', 'Hungary', 'EURO', '3', '4017', '2', '550');
INSERT INTO public.who_global_data_import VALUES (37761, '2020-06-11', 'HU', 'Hungary', 'EURO', '10', '4027', '1', '551');
INSERT INTO public.who_global_data_import VALUES (37762, '2020-06-12', 'HU', 'Hungary', 'EURO', '12', '4039', '2', '553');
INSERT INTO public.who_global_data_import VALUES (37763, '2020-06-13', 'HU', 'Hungary', 'EURO', '14', '4053', '2', '555');
INSERT INTO public.who_global_data_import VALUES (37764, '2020-06-14', 'HU', 'Hungary', 'EURO', '11', '4064', '4', '559');
INSERT INTO public.who_global_data_import VALUES (37765, '2020-06-15', 'HU', 'Hungary', 'EURO', '12', '4076', '4', '563');
INSERT INTO public.who_global_data_import VALUES (37766, '2020-06-16', 'HU', 'Hungary', 'EURO', '1', '4077', '2', '565');
INSERT INTO public.who_global_data_import VALUES (37767, '2020-06-17', 'HU', 'Hungary', 'EURO', '1', '4078', '2', '567');
INSERT INTO public.who_global_data_import VALUES (37768, '2020-06-18', 'HU', 'Hungary', 'EURO', '1', '4079', '1', '568');
INSERT INTO public.who_global_data_import VALUES (37769, '2020-06-19', 'HU', 'Hungary', 'EURO', '2', '4081', '0', '568');
INSERT INTO public.who_global_data_import VALUES (37770, '2020-06-20', 'HU', 'Hungary', 'EURO', '5', '4086', '2', '570');
INSERT INTO public.who_global_data_import VALUES (37771, '2020-06-21', 'HU', 'Hungary', 'EURO', '8', '4094', '0', '570');
INSERT INTO public.who_global_data_import VALUES (37772, '2020-06-22', 'HU', 'Hungary', 'EURO', '8', '4102', '2', '572');
INSERT INTO public.who_global_data_import VALUES (37773, '2020-06-23', 'HU', 'Hungary', 'EURO', '5', '4107', '1', '573');
INSERT INTO public.who_global_data_import VALUES (37774, '2020-06-24', 'HU', 'Hungary', 'EURO', '0', '4107', '0', '573');
INSERT INTO public.who_global_data_import VALUES (37775, '2020-06-25', 'HU', 'Hungary', 'EURO', '7', '4114', '3', '576');
INSERT INTO public.who_global_data_import VALUES (37776, '2020-06-26', 'HU', 'Hungary', 'EURO', '9', '4123', '1', '577');
INSERT INTO public.who_global_data_import VALUES (37777, '2020-06-27', 'HU', 'Hungary', 'EURO', '4', '4127', '1', '578');
INSERT INTO public.who_global_data_import VALUES (37778, '2020-06-28', 'HU', 'Hungary', 'EURO', '11', '4138', '0', '578');
INSERT INTO public.who_global_data_import VALUES (37779, '2020-06-29', 'HU', 'Hungary', 'EURO', '4', '4142', '3', '581');
INSERT INTO public.who_global_data_import VALUES (37780, '2020-06-30', 'HU', 'Hungary', 'EURO', '3', '4145', '4', '585');
INSERT INTO public.who_global_data_import VALUES (37781, '2020-07-01', 'HU', 'Hungary', 'EURO', '10', '4155', '0', '585');
INSERT INTO public.who_global_data_import VALUES (37782, '2020-07-02', 'HU', 'Hungary', 'EURO', '2', '4157', '1', '586');
INSERT INTO public.who_global_data_import VALUES (37783, '2020-07-03', 'HU', 'Hungary', 'EURO', '9', '4166', '1', '587');
INSERT INTO public.who_global_data_import VALUES (37784, '2020-07-04', 'HU', 'Hungary', 'EURO', '6', '4172', '1', '588');
INSERT INTO public.who_global_data_import VALUES (37785, '2020-07-05', 'HU', 'Hungary', 'EURO', '11', '4183', '1', '589');
INSERT INTO public.who_global_data_import VALUES (37786, '2020-07-06', 'HU', 'Hungary', 'EURO', '0', '4183', '0', '589');
INSERT INTO public.who_global_data_import VALUES (37787, '2020-07-07', 'HU', 'Hungary', 'EURO', '6', '4189', '0', '589');
INSERT INTO public.who_global_data_import VALUES (37788, '2020-07-08', 'HU', 'Hungary', 'EURO', '16', '4205', '0', '589');
INSERT INTO public.who_global_data_import VALUES (37789, '2020-07-09', 'HU', 'Hungary', 'EURO', '5', '4210', '0', '589');
INSERT INTO public.who_global_data_import VALUES (37790, '2020-07-10', 'HU', 'Hungary', 'EURO', '10', '4220', '2', '591');
INSERT INTO public.who_global_data_import VALUES (37791, '2020-07-11', 'HU', 'Hungary', 'EURO', '3', '4223', '2', '593');
INSERT INTO public.who_global_data_import VALUES (37792, '2020-07-12', 'HU', 'Hungary', 'EURO', '6', '4229', '2', '595');
INSERT INTO public.who_global_data_import VALUES (37793, '2020-07-13', 'HU', 'Hungary', 'EURO', '5', '4234', '0', '595');
INSERT INTO public.who_global_data_import VALUES (37794, '2020-07-14', 'HU', 'Hungary', 'EURO', '13', '4247', '0', '595');
INSERT INTO public.who_global_data_import VALUES (37795, '2020-07-15', 'HU', 'Hungary', 'EURO', '16', '4263', '0', '595');
INSERT INTO public.who_global_data_import VALUES (37796, '2020-07-16', 'HU', 'Hungary', 'EURO', '0', '4263', '0', '595');
INSERT INTO public.who_global_data_import VALUES (37797, '2020-07-17', 'HU', 'Hungary', 'EURO', '16', '4279', '0', '595');
INSERT INTO public.who_global_data_import VALUES (37798, '2020-07-18', 'HU', 'Hungary', 'EURO', '14', '4293', '0', '595');
INSERT INTO public.who_global_data_import VALUES (37799, '2020-07-19', 'HU', 'Hungary', 'EURO', '22', '4315', '1', '596');
INSERT INTO public.who_global_data_import VALUES (37800, '2020-07-20', 'HU', 'Hungary', 'EURO', '18', '4333', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37801, '2020-07-21', 'HU', 'Hungary', 'EURO', '14', '4347', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37802, '2020-07-22', 'HU', 'Hungary', 'EURO', '19', '4366', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37803, '2020-07-23', 'HU', 'Hungary', 'EURO', '14', '4380', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37804, '2020-07-24', 'HU', 'Hungary', 'EURO', '18', '4398', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37805, '2020-07-25', 'HU', 'Hungary', 'EURO', '26', '4424', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37806, '2020-07-26', 'HU', 'Hungary', 'EURO', '11', '4435', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37807, '2020-07-27', 'HU', 'Hungary', 'EURO', '13', '4448', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37808, '2020-07-28', 'HU', 'Hungary', 'EURO', '8', '4456', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37809, '2020-07-29', 'HU', 'Hungary', 'EURO', '9', '4465', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37810, '2020-07-30', 'HU', 'Hungary', 'EURO', '19', '4484', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37811, '2020-07-31', 'HU', 'Hungary', 'EURO', '21', '4505', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37812, '2020-08-01', 'HU', 'Hungary', 'EURO', '0', '4505', '0', '596');
INSERT INTO public.who_global_data_import VALUES (37813, '2020-08-02', 'HU', 'Hungary', 'EURO', '21', '4526', '1', '597');
INSERT INTO public.who_global_data_import VALUES (37814, '2020-08-03', 'HU', 'Hungary', 'EURO', '9', '4535', '0', '597');
INSERT INTO public.who_global_data_import VALUES (37815, '2020-08-04', 'HU', 'Hungary', 'EURO', '9', '4544', '0', '597');
INSERT INTO public.who_global_data_import VALUES (37816, '2020-08-05', 'HU', 'Hungary', 'EURO', '9', '4553', '1', '598');
INSERT INTO public.who_global_data_import VALUES (37817, '2020-08-06', 'HU', 'Hungary', 'EURO', '11', '4564', '1', '599');
INSERT INTO public.who_global_data_import VALUES (37818, '2020-08-07', 'HU', 'Hungary', 'EURO', '33', '4597', '1', '600');
INSERT INTO public.who_global_data_import VALUES (37819, '2020-08-08', 'HU', 'Hungary', 'EURO', '24', '4621', '2', '602');
INSERT INTO public.who_global_data_import VALUES (37820, '2020-08-09', 'HU', 'Hungary', 'EURO', '32', '4653', '0', '602');
INSERT INTO public.who_global_data_import VALUES (37821, '2020-08-10', 'HU', 'Hungary', 'EURO', '43', '4696', '0', '602');
INSERT INTO public.who_global_data_import VALUES (37822, '2020-08-11', 'HU', 'Hungary', 'EURO', '35', '4731', '3', '605');
INSERT INTO public.who_global_data_import VALUES (37823, '2020-08-12', 'HU', 'Hungary', 'EURO', '15', '4746', '0', '605');
INSERT INTO public.who_global_data_import VALUES (37824, '2020-08-13', 'HU', 'Hungary', 'EURO', '22', '4768', '0', '605');
INSERT INTO public.who_global_data_import VALUES (37825, '2020-08-14', 'HU', 'Hungary', 'EURO', '45', '4813', '2', '607');
INSERT INTO public.who_global_data_import VALUES (37826, '2020-08-15', 'HU', 'Hungary', 'EURO', '40', '4853', '0', '607');
INSERT INTO public.who_global_data_import VALUES (37827, '2020-08-16', 'HU', 'Hungary', 'EURO', '24', '4877', '0', '607');
INSERT INTO public.who_global_data_import VALUES (37828, '2020-08-17', 'HU', 'Hungary', 'EURO', '39', '4916', '1', '608');
INSERT INTO public.who_global_data_import VALUES (37829, '2020-08-18', 'HU', 'Hungary', 'EURO', '54', '4970', '1', '609');
INSERT INTO public.who_global_data_import VALUES (37830, '2020-08-19', 'HU', 'Hungary', 'EURO', '0', '4970', '0', '609');
INSERT INTO public.who_global_data_import VALUES (37831, '2020-08-20', 'HU', 'Hungary', 'EURO', '32', '5002', '0', '609');
INSERT INTO public.who_global_data_import VALUES (37832, '2020-08-21', 'HU', 'Hungary', 'EURO', '44', '5046', '0', '609');
INSERT INTO public.who_global_data_import VALUES (37833, '2020-08-22', 'HU', 'Hungary', 'EURO', '52', '5098', '2', '611');
INSERT INTO public.who_global_data_import VALUES (37834, '2020-08-23', 'HU', 'Hungary', 'EURO', '35', '5133', '0', '611');
INSERT INTO public.who_global_data_import VALUES (37835, '2020-08-24', 'HU', 'Hungary', 'EURO', '22', '5155', '2', '613');
INSERT INTO public.who_global_data_import VALUES (37836, '2020-08-25', 'HU', 'Hungary', 'EURO', '36', '5191', '0', '613');
INSERT INTO public.who_global_data_import VALUES (37837, '2020-08-26', 'HU', 'Hungary', 'EURO', '24', '5215', '1', '614');
INSERT INTO public.who_global_data_import VALUES (37838, '2020-08-27', 'HU', 'Hungary', 'EURO', '73', '5288', '0', '614');
INSERT INTO public.who_global_data_import VALUES (37839, '2020-08-28', 'HU', 'Hungary', 'EURO', '91', '5379', '0', '614');
INSERT INTO public.who_global_data_import VALUES (37840, '2020-08-29', 'HU', 'Hungary', 'EURO', '132', '5511', '0', '614');
INSERT INTO public.who_global_data_import VALUES (37841, '2020-08-30', 'HU', 'Hungary', 'EURO', '158', '5669', '0', '614');
INSERT INTO public.who_global_data_import VALUES (37842, '2020-08-31', 'HU', 'Hungary', 'EURO', '292', '5961', '0', '614');
INSERT INTO public.who_global_data_import VALUES (37843, '2020-09-01', 'HU', 'Hungary', 'EURO', '178', '6139', '1', '615');
INSERT INTO public.who_global_data_import VALUES (37844, '2020-09-02', 'HU', 'Hungary', 'EURO', '118', '6257', '1', '616');
INSERT INTO public.who_global_data_import VALUES (37845, '2020-09-03', 'HU', 'Hungary', 'EURO', '365', '6622', '3', '619');
INSERT INTO public.who_global_data_import VALUES (37846, '2020-09-04', 'HU', 'Hungary', 'EURO', '301', '6923', '1', '620');
INSERT INTO public.who_global_data_import VALUES (37847, '2020-09-05', 'HU', 'Hungary', 'EURO', '459', '7382', '1', '621');
INSERT INTO public.who_global_data_import VALUES (37848, '2020-09-06', 'HU', 'Hungary', 'EURO', '510', '7892', '3', '624');
INSERT INTO public.who_global_data_import VALUES (37849, '2020-09-07', 'HU', 'Hungary', 'EURO', '495', '8387', '0', '624');
INSERT INTO public.who_global_data_import VALUES (37850, '2020-09-08', 'HU', 'Hungary', 'EURO', '576', '8963', '1', '625');
INSERT INTO public.who_global_data_import VALUES (37851, '2020-09-09', 'HU', 'Hungary', 'EURO', '341', '9304', '1', '626');
INSERT INTO public.who_global_data_import VALUES (37852, '2020-09-10', 'HU', 'Hungary', 'EURO', '411', '9715', '2', '628');
INSERT INTO public.who_global_data_import VALUES (37853, '2020-09-11', 'HU', 'Hungary', 'EURO', '476', '10191', '2', '630');
INSERT INTO public.who_global_data_import VALUES (37854, '2020-09-12', 'HU', 'Hungary', 'EURO', '718', '10909', '1', '631');
INSERT INTO public.who_global_data_import VALUES (37855, '2020-09-13', 'HU', 'Hungary', 'EURO', '916', '11825', '2', '633');
INSERT INTO public.who_global_data_import VALUES (37856, '2020-09-14', 'HU', 'Hungary', 'EURO', '484', '12309', '4', '637');
INSERT INTO public.who_global_data_import VALUES (37857, '2020-09-15', 'HU', 'Hungary', 'EURO', '844', '13153', '5', '642');
INSERT INTO public.who_global_data_import VALUES (37858, '2020-09-16', 'HU', 'Hungary', 'EURO', '1307', '14460', '12', '654');
INSERT INTO public.who_global_data_import VALUES (37859, '2020-09-17', 'HU', 'Hungary', 'EURO', '710', '15170', '9', '663');
INSERT INTO public.who_global_data_import VALUES (37860, '2020-09-18', 'HU', 'Hungary', 'EURO', '941', '16111', '6', '669');
INSERT INTO public.who_global_data_import VALUES (37861, '2020-09-19', 'HU', 'Hungary', 'EURO', '809', '16920', '6', '675');
INSERT INTO public.who_global_data_import VALUES (37862, '2020-09-20', 'HU', 'Hungary', 'EURO', '1070', '17990', '8', '683');
INSERT INTO public.who_global_data_import VALUES (37863, '2020-09-21', 'HU', 'Hungary', 'EURO', '876', '18866', '3', '686');
INSERT INTO public.who_global_data_import VALUES (37864, '2020-09-22', 'HU', 'Hungary', 'EURO', '633', '19499', '8', '694');
INSERT INTO public.who_global_data_import VALUES (37865, '2020-09-23', 'HU', 'Hungary', 'EURO', '951', '20450', '8', '702');
INSERT INTO public.who_global_data_import VALUES (37866, '2020-09-24', 'HU', 'Hungary', 'EURO', '750', '21200', '7', '709');
INSERT INTO public.who_global_data_import VALUES (37867, '2020-09-25', 'HU', 'Hungary', 'EURO', '927', '22127', '9', '718');
INSERT INTO public.who_global_data_import VALUES (37868, '2020-09-26', 'HU', 'Hungary', 'EURO', '950', '23077', '12', '730');
INSERT INTO public.who_global_data_import VALUES (37869, '2020-09-27', 'HU', 'Hungary', 'EURO', '937', '24014', '6', '736');
INSERT INTO public.who_global_data_import VALUES (37870, '2020-09-28', 'HU', 'Hungary', 'EURO', '702', '24716', '13', '749');
INSERT INTO public.who_global_data_import VALUES (37871, '2020-09-29', 'HU', 'Hungary', 'EURO', '851', '25567', '8', '757');
INSERT INTO public.who_global_data_import VALUES (37872, '2020-09-30', 'HU', 'Hungary', 'EURO', '894', '26461', '8', '765');
INSERT INTO public.who_global_data_import VALUES (37873, '2020-10-01', 'HU', 'Hungary', 'EURO', '848', '27309', '16', '781');
INSERT INTO public.who_global_data_import VALUES (37874, '2020-10-02', 'HU', 'Hungary', 'EURO', '1322', '28631', '17', '798');
INSERT INTO public.who_global_data_import VALUES (37875, '2020-10-03', 'HU', 'Hungary', 'EURO', '1086', '29717', '14', '812');
INSERT INTO public.who_global_data_import VALUES (37876, '2020-10-04', 'HU', 'Hungary', 'EURO', '858', '30575', '10', '822');
INSERT INTO public.who_global_data_import VALUES (37877, '2020-10-05', 'HU', 'Hungary', 'EURO', '905', '31480', '11', '833');
INSERT INTO public.who_global_data_import VALUES (37878, '2020-10-06', 'HU', 'Hungary', 'EURO', '818', '32298', '20', '853');
INSERT INTO public.who_global_data_import VALUES (37879, '2020-10-07', 'HU', 'Hungary', 'EURO', '816', '33114', '24', '877');
INSERT INTO public.who_global_data_import VALUES (37880, '2020-10-08', 'HU', 'Hungary', 'EURO', '932', '34046', '21', '898');
INSERT INTO public.who_global_data_import VALUES (37881, '2020-10-09', 'HU', 'Hungary', 'EURO', '1176', '35222', '15', '913');
INSERT INTO public.who_global_data_import VALUES (37882, '2020-10-10', 'HU', 'Hungary', 'EURO', '1374', '36596', '20', '933');
INSERT INTO public.who_global_data_import VALUES (37883, '2020-10-11', 'HU', 'Hungary', 'EURO', '1068', '37664', '21', '954');
INSERT INTO public.who_global_data_import VALUES (37884, '2020-10-12', 'HU', 'Hungary', 'EURO', '913', '38577', '14', '968');
INSERT INTO public.who_global_data_import VALUES (37885, '2020-10-13', 'HU', 'Hungary', 'EURO', '1285', '39862', '28', '996');
INSERT INTO public.who_global_data_import VALUES (37886, '2020-10-14', 'HU', 'Hungary', 'EURO', '920', '40782', '27', '1023');
INSERT INTO public.who_global_data_import VALUES (37887, '2020-10-15', 'HU', 'Hungary', 'EURO', '950', '41732', '29', '1052');
INSERT INTO public.who_global_data_import VALUES (37888, '2020-10-16', 'HU', 'Hungary', 'EURO', '1293', '43025', '33', '1085');
INSERT INTO public.who_global_data_import VALUES (37889, '2020-10-17', 'HU', 'Hungary', 'EURO', '1791', '44816', '24', '1109');
INSERT INTO public.who_global_data_import VALUES (37890, '2020-10-18', 'HU', 'Hungary', 'EURO', '1474', '46290', '33', '1142');
INSERT INTO public.who_global_data_import VALUES (37891, '2020-10-19', 'HU', 'Hungary', 'EURO', '1478', '47768', '31', '1173');
INSERT INTO public.who_global_data_import VALUES (37892, '2020-10-20', 'HU', 'Hungary', 'EURO', '989', '48757', '38', '1211');
INSERT INTO public.who_global_data_import VALUES (37893, '2020-10-21', 'HU', 'Hungary', 'EURO', '1423', '50180', '48', '1259');
INSERT INTO public.who_global_data_import VALUES (37894, '2020-10-22', 'HU', 'Hungary', 'EURO', '2032', '52212', '46', '1305');
INSERT INTO public.who_global_data_import VALUES (37895, '2020-10-23', 'HU', 'Hungary', 'EURO', '2066', '54278', '47', '1352');
INSERT INTO public.who_global_data_import VALUES (37896, '2020-10-24', 'HU', 'Hungary', 'EURO', '1820', '56098', '38', '1390');
INSERT INTO public.who_global_data_import VALUES (37897, '2020-10-25', 'HU', 'Hungary', 'EURO', '3149', '59247', '35', '1425');
INSERT INTO public.who_global_data_import VALUES (37898, '2020-10-26', 'HU', 'Hungary', 'EURO', '2316', '61563', '47', '1472');
INSERT INTO public.who_global_data_import VALUES (37899, '2020-10-27', 'HU', 'Hungary', 'EURO', '2079', '63642', '63', '1535');
INSERT INTO public.who_global_data_import VALUES (37900, '2020-10-28', 'HU', 'Hungary', 'EURO', '2291', '65933', '43', '1578');
INSERT INTO public.who_global_data_import VALUES (37901, '2020-10-29', 'HU', 'Hungary', 'EURO', '2194', '68127', '56', '1634');
INSERT INTO public.who_global_data_import VALUES (37902, '2020-10-30', 'HU', 'Hungary', 'EURO', '3286', '71413', '65', '1699');
INSERT INTO public.who_global_data_import VALUES (37903, '2020-10-31', 'HU', 'Hungary', 'EURO', '3908', '75321', '51', '1750');
INSERT INTO public.who_global_data_import VALUES (37904, '2020-11-01', 'HU', 'Hungary', 'EURO', '3878', '79199', '69', '1819');
INSERT INTO public.who_global_data_import VALUES (37905, '2020-11-02', 'HU', 'Hungary', 'EURO', '3581', '82780', '70', '1889');
INSERT INTO public.who_global_data_import VALUES (37906, '2020-11-03', 'HU', 'Hungary', 'EURO', '3989', '86769', '84', '1973');
INSERT INTO public.who_global_data_import VALUES (37907, '2020-11-04', 'HU', 'Hungary', 'EURO', '4219', '90988', '90', '2063');
INSERT INTO public.who_global_data_import VALUES (37908, '2020-11-05', 'HU', 'Hungary', 'EURO', '3928', '94916', '84', '2147');
INSERT INTO public.who_global_data_import VALUES (37909, '2020-11-06', 'HU', 'Hungary', 'EURO', '4709', '99625', '103', '2250');
INSERT INTO public.who_global_data_import VALUES (37910, '2020-11-07', 'HU', 'Hungary', 'EURO', '5318', '104943', '107', '2357');
INSERT INTO public.who_global_data_import VALUES (37911, '2020-11-08', 'HU', 'Hungary', 'EURO', '4673', '109616', '81', '2438');
INSERT INTO public.who_global_data_import VALUES (37912, '2020-11-09', 'HU', 'Hungary', 'EURO', '5162', '114778', '55', '2493');
INSERT INTO public.who_global_data_import VALUES (37913, '2020-11-10', 'HU', 'Hungary', 'EURO', '4140', '118918', '103', '2596');
INSERT INTO public.who_global_data_import VALUES (37914, '2020-11-11', 'HU', 'Hungary', 'EURO', '3945', '122863', '101', '2697');
INSERT INTO public.who_global_data_import VALUES (37915, '2020-11-12', 'HU', 'Hungary', 'EURO', '3927', '126790', '87', '2784');
INSERT INTO public.who_global_data_import VALUES (37916, '2020-11-13', 'HU', 'Hungary', 'EURO', '5097', '131887', '99', '2883');
INSERT INTO public.who_global_data_import VALUES (37917, '2020-11-14', 'HU', 'Hungary', 'EURO', '4836', '136723', '107', '2990');
INSERT INTO public.who_global_data_import VALUES (37918, '2020-11-15', 'HU', 'Hungary', 'EURO', '4238', '140961', '107', '3097');
INSERT INTO public.who_global_data_import VALUES (37919, '2020-11-16', 'HU', 'Hungary', 'EURO', '6495', '147456', '93', '3190');
INSERT INTO public.who_global_data_import VALUES (37920, '2020-11-17', 'HU', 'Hungary', 'EURO', '5203', '152659', '91', '3281');
INSERT INTO public.who_global_data_import VALUES (37921, '2020-11-18', 'HU', 'Hungary', 'EURO', '4290', '156949', '99', '3380');
INSERT INTO public.who_global_data_import VALUES (37922, '2020-11-19', 'HU', 'Hungary', 'EURO', '4512', '161461', '92', '3472');
INSERT INTO public.who_global_data_import VALUES (37923, '2020-11-20', 'HU', 'Hungary', 'EURO', '4440', '165901', '96', '3568');
INSERT INTO public.who_global_data_import VALUES (37924, '2020-11-21', 'HU', 'Hungary', 'EURO', '4397', '170298', '121', '3689');
INSERT INTO public.who_global_data_import VALUES (37925, '2020-11-22', 'HU', 'Hungary', 'EURO', '4320', '174618', '111', '3800');
INSERT INTO public.who_global_data_import VALUES (37926, '2020-11-23', 'HU', 'Hungary', 'EURO', '3334', '177952', '91', '3891');
INSERT INTO public.who_global_data_import VALUES (37927, '2020-11-24', 'HU', 'Hungary', 'EURO', '3929', '181881', '117', '4008');
INSERT INTO public.who_global_data_import VALUES (37928, '2020-11-25', 'HU', 'Hungary', 'EURO', '3806', '185687', '106', '4114');
INSERT INTO public.who_global_data_import VALUES (37929, '2020-11-26', 'HU', 'Hungary', 'EURO', '6360', '192047', '115', '4229');
INSERT INTO public.who_global_data_import VALUES (37930, '2020-11-27', 'HU', 'Hungary', 'EURO', '6393', '198440', '135', '4364');
INSERT INTO public.who_global_data_import VALUES (37931, '2020-11-28', 'HU', 'Hungary', 'EURO', '6268', '204708', '152', '4516');
INSERT INTO public.who_global_data_import VALUES (37932, '2020-11-29', 'HU', 'Hungary', 'EURO', '6819', '211527', '156', '4672');
INSERT INTO public.who_global_data_import VALUES (37933, '2020-11-30', 'HU', 'Hungary', 'EURO', '5595', '217122', '151', '4823');
INSERT INTO public.who_global_data_import VALUES (37934, '2020-12-01', 'HU', 'Hungary', 'EURO', '3951', '221073', '154', '4977');
INSERT INTO public.who_global_data_import VALUES (37935, '2020-12-02', 'HU', 'Hungary', 'EURO', '4136', '225209', '165', '5142');
INSERT INTO public.who_global_data_import VALUES (37936, '2020-12-03', 'HU', 'Hungary', 'EURO', '6635', '231844', '182', '5324');
INSERT INTO public.who_global_data_import VALUES (37937, '2020-12-04', 'HU', 'Hungary', 'EURO', '6212', '238056', '189', '5513');
INSERT INTO public.who_global_data_import VALUES (37938, '2020-12-05', 'HU', 'Hungary', 'EURO', '5525', '243581', '193', '5706');
INSERT INTO public.who_global_data_import VALUES (37939, '2020-12-06', 'HU', 'Hungary', 'EURO', '6697', '250278', '162', '5868');
INSERT INTO public.who_global_data_import VALUES (37940, '2020-12-07', 'HU', 'Hungary', 'EURO', '3870', '254148', '116', '5984');
INSERT INTO public.who_global_data_import VALUES (37941, '2020-12-08', 'HU', 'Hungary', 'EURO', '2219', '256367', '136', '6120');
INSERT INTO public.who_global_data_import VALUES (37942, '2020-12-09', 'HU', 'Hungary', 'EURO', '3221', '259588', '160', '6280');
INSERT INTO public.who_global_data_import VALUES (37943, '2020-12-10', 'HU', 'Hungary', 'EURO', '5415', '265003', '171', '6451');
INSERT INTO public.who_global_data_import VALUES (37944, '2020-12-11', 'HU', 'Hungary', 'EURO', '6197', '271200', '171', '6622');
INSERT INTO public.who_global_data_import VALUES (37945, '2020-12-12', 'HU', 'Hungary', 'EURO', '5047', '276247', '162', '6784');
INSERT INTO public.who_global_data_import VALUES (37946, '2020-12-13', 'HU', 'Hungary', 'EURO', '4153', '280400', '181', '6965');
INSERT INTO public.who_global_data_import VALUES (37947, '2020-12-14', 'HU', 'Hungary', 'EURO', '3470', '283870', '165', '7130');
INSERT INTO public.who_global_data_import VALUES (37948, '2020-12-15', 'HU', 'Hungary', 'EURO', '1893', '285763', '107', '7237');
INSERT INTO public.who_global_data_import VALUES (37949, '2020-12-16', 'HU', 'Hungary', 'EURO', '2804', '288567', '144', '7381');
INSERT INTO public.who_global_data_import VALUES (37950, '2020-12-17', 'HU', 'Hungary', 'EURO', '2982', '291549', '157', '7538');
INSERT INTO public.who_global_data_import VALUES (37951, '2020-12-18', 'HU', 'Hungary', 'EURO', '4428', '295977', '187', '7725');
INSERT INTO public.who_global_data_import VALUES (37952, '2020-12-19', 'HU', 'Hungary', 'EURO', '4045', '300022', '189', '7914');
INSERT INTO public.who_global_data_import VALUES (37953, '2020-12-20', 'HU', 'Hungary', 'EURO', '2967', '302989', '185', '8099');
INSERT INTO public.who_global_data_import VALUES (37954, '2020-12-21', 'HU', 'Hungary', 'EURO', '2141', '305130', '193', '8292');
INSERT INTO public.who_global_data_import VALUES (37955, '2020-12-22', 'HU', 'Hungary', 'EURO', '1238', '306368', '170', '8462');
INSERT INTO public.who_global_data_import VALUES (37956, '2020-12-23', 'HU', 'Hungary', 'EURO', '1894', '308262', '154', '8616');
INSERT INTO public.who_global_data_import VALUES (37957, '2020-12-24', 'HU', 'Hungary', 'EURO', '3292', '311554', '113', '8729');
INSERT INTO public.who_global_data_import VALUES (37958, '2020-12-25', 'HU', 'Hungary', 'EURO', '2610', '314164', '104', '8833');
INSERT INTO public.who_global_data_import VALUES (37959, '2020-12-26', 'HU', 'Hungary', 'EURO', '1198', '315362', '118', '8951');
INSERT INTO public.who_global_data_import VALUES (40034, '2020-02-05', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (37960, '2020-12-27', 'HU', 'Hungary', 'EURO', '698', '316060', '96', '9047');
INSERT INTO public.who_global_data_import VALUES (37961, '2020-12-28', 'HU', 'Hungary', 'EURO', '609', '316669', '114', '9161');
INSERT INTO public.who_global_data_import VALUES (37962, '2020-12-29', 'HU', 'Hungary', 'EURO', '902', '317571', '131', '9292');
INSERT INTO public.who_global_data_import VALUES (37963, '2020-12-30', 'HU', 'Hungary', 'EURO', '1972', '319543', '137', '9429');
INSERT INTO public.who_global_data_import VALUES (37964, '2020-12-31', 'HU', 'Hungary', 'EURO', '2971', '322514', '108', '9537');
INSERT INTO public.who_global_data_import VALUES (37965, '2021-01-01', 'HU', 'Hungary', 'EURO', '2764', '325278', '130', '9667');
INSERT INTO public.who_global_data_import VALUES (37966, '2021-01-02', 'HU', 'Hungary', 'EURO', '1410', '326688', '114', '9781');
INSERT INTO public.who_global_data_import VALUES (37967, '2021-01-03', 'HU', 'Hungary', 'EURO', '1307', '327995', '103', '9884');
INSERT INTO public.who_global_data_import VALUES (37968, '2021-01-04', 'HU', 'Hungary', 'EURO', '856', '328851', '93', '9977');
INSERT INTO public.who_global_data_import VALUES (37969, '2021-01-05', 'HU', 'Hungary', 'EURO', '870', '329721', '103', '10080');
INSERT INTO public.who_global_data_import VALUES (37970, '2021-01-06', 'HU', 'Hungary', 'EURO', '2047', '331768', '118', '10198');
INSERT INTO public.who_global_data_import VALUES (37971, '2021-01-07', 'HU', 'Hungary', 'EURO', '3068', '334836', '127', '10325');
INSERT INTO public.who_global_data_import VALUES (37972, '2021-01-08', 'HU', 'Hungary', 'EURO', '2907', '337743', '115', '10440');
INSERT INTO public.who_global_data_import VALUES (37973, '2021-01-09', 'HU', 'Hungary', 'EURO', '2716', '340459', '114', '10554');
INSERT INTO public.who_global_data_import VALUES (37974, '2021-01-10', 'HU', 'Hungary', 'EURO', '1778', '342237', '94', '10648');
INSERT INTO public.who_global_data_import VALUES (37975, '2021-01-11', 'HU', 'Hungary', 'EURO', '1419', '343656', '77', '10725');
INSERT INTO public.who_global_data_import VALUES (37976, '2021-01-12', 'HU', 'Hungary', 'EURO', '696', '344352', '128', '10853');
INSERT INTO public.who_global_data_import VALUES (37977, '2021-01-13', 'HU', 'Hungary', 'EURO', '1358', '345710', '95', '10948');
INSERT INTO public.who_global_data_import VALUES (37978, '2021-01-14', 'HU', 'Hungary', 'EURO', '1926', '347636', '118', '11066');
INSERT INTO public.who_global_data_import VALUES (37979, '2021-01-15', 'HU', 'Hungary', 'EURO', '1513', '349149', '111', '11177');
INSERT INTO public.who_global_data_import VALUES (37980, '2021-01-16', 'HU', 'Hungary', 'EURO', '1438', '350587', '87', '11264');
INSERT INTO public.who_global_data_import VALUES (37981, '2021-01-17', 'HU', 'Hungary', 'EURO', '1241', '351828', '77', '11341');
INSERT INTO public.who_global_data_import VALUES (37982, '2021-01-18', 'HU', 'Hungary', 'EURO', '875', '352703', '68', '11409');
INSERT INTO public.who_global_data_import VALUES (37983, '2021-01-19', 'HU', 'Hungary', 'EURO', '573', '353276', '111', '11520');
INSERT INTO public.who_global_data_import VALUES (37984, '2021-01-20', 'HU', 'Hungary', 'EURO', '976', '354252', '95', '11615');
INSERT INTO public.who_global_data_import VALUES (37985, '2021-01-21', 'HU', 'Hungary', 'EURO', '1410', '355662', '98', '11713');
INSERT INTO public.who_global_data_import VALUES (37986, '2021-01-22', 'HU', 'Hungary', 'EURO', '1311', '356973', '98', '11811');
INSERT INTO public.who_global_data_import VALUES (37987, '2021-01-23', 'HU', 'Hungary', 'EURO', '1344', '358317', '93', '11904');
INSERT INTO public.who_global_data_import VALUES (37988, '2021-01-24', 'HU', 'Hungary', 'EURO', '1257', '359574', '64', '11968');
INSERT INTO public.who_global_data_import VALUES (37989, '2021-01-25', 'HU', 'Hungary', 'EURO', '844', '360418', '56', '12024');
INSERT INTO public.who_global_data_import VALUES (37990, '2021-01-26', 'HU', 'Hungary', 'EURO', '459', '360877', '89', '12113');
INSERT INTO public.who_global_data_import VALUES (37991, '2021-01-27', 'HU', 'Hungary', 'EURO', '1004', '361881', '85', '12198');
INSERT INTO public.who_global_data_import VALUES (37992, '2021-01-28', 'HU', 'Hungary', 'EURO', '1569', '363450', '93', '12291');
INSERT INTO public.who_global_data_import VALUES (37993, '2021-01-29', 'HU', 'Hungary', 'EURO', '1459', '364909', '83', '12374');
INSERT INTO public.who_global_data_import VALUES (37994, '2021-01-30', 'HU', 'Hungary', 'EURO', '1370', '366279', '89', '12463');
INSERT INTO public.who_global_data_import VALUES (37995, '2021-01-31', 'HU', 'Hungary', 'EURO', '1307', '367586', '61', '12524');
INSERT INTO public.who_global_data_import VALUES (37996, '2021-02-01', 'HU', 'Hungary', 'EURO', '1124', '368710', '54', '12578');
INSERT INTO public.who_global_data_import VALUES (37997, '2021-02-02', 'HU', 'Hungary', 'EURO', '578', '369288', '78', '12656');
INSERT INTO public.who_global_data_import VALUES (37998, '2021-02-03', 'HU', 'Hungary', 'EURO', '1048', '370336', '83', '12739');
INSERT INTO public.who_global_data_import VALUES (37999, '2021-02-04', 'HU', 'Hungary', 'EURO', '1652', '371988', '93', '12832');
INSERT INTO public.who_global_data_import VALUES (38000, '2021-02-05', 'HU', 'Hungary', 'EURO', '1576', '373564', '98', '12930');
INSERT INTO public.who_global_data_import VALUES (38001, '2020-01-03', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38002, '2020-01-04', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38003, '2020-01-05', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38004, '2020-01-06', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38005, '2020-01-07', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38006, '2020-01-08', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38007, '2020-01-09', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38008, '2020-01-10', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38009, '2020-01-11', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38010, '2020-01-12', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38011, '2020-01-13', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38012, '2020-01-14', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38013, '2020-01-15', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38014, '2020-01-16', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38015, '2020-01-17', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38016, '2020-01-18', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38017, '2020-01-19', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38018, '2020-01-20', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38019, '2020-01-21', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38020, '2020-01-22', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38021, '2020-01-23', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38022, '2020-01-24', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38023, '2020-01-25', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38024, '2020-01-26', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38025, '2020-01-27', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38026, '2020-01-28', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38027, '2020-01-29', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38028, '2020-01-30', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38029, '2020-01-31', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38030, '2020-02-01', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38031, '2020-02-02', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38032, '2020-02-03', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38033, '2020-02-04', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38034, '2020-02-05', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38035, '2020-02-06', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38036, '2020-02-07', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38037, '2020-02-08', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38038, '2020-02-09', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38039, '2020-02-10', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38040, '2020-02-11', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38041, '2020-02-12', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38042, '2020-02-13', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38043, '2020-02-14', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38044, '2020-02-15', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38045, '2020-02-16', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38046, '2020-02-17', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38047, '2020-02-18', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38048, '2020-02-19', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38049, '2020-02-20', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38050, '2020-02-21', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38051, '2020-02-22', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38052, '2020-02-23', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38053, '2020-02-24', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38054, '2020-02-25', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38055, '2020-02-26', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38056, '2020-02-27', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38057, '2020-02-28', 'IS', 'Iceland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38058, '2020-02-29', 'IS', 'Iceland', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38059, '2020-03-01', 'IS', 'Iceland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38060, '2020-03-02', 'IS', 'Iceland', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38061, '2020-03-03', 'IS', 'Iceland', 'EURO', '3', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38062, '2020-03-04', 'IS', 'Iceland', 'EURO', '10', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38063, '2020-03-05', 'IS', 'Iceland', 'EURO', '10', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38064, '2020-03-06', 'IS', 'Iceland', 'EURO', '9', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38065, '2020-03-07', 'IS', 'Iceland', 'EURO', '8', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38066, '2020-03-08', 'IS', 'Iceland', 'EURO', '10', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38067, '2020-03-09', 'IS', 'Iceland', 'EURO', '2', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38068, '2020-03-10', 'IS', 'Iceland', 'EURO', '10', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38069, '2020-03-11', 'IS', 'Iceland', 'EURO', '5', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38070, '2020-03-12', 'IS', 'Iceland', 'EURO', '15', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38071, '2020-03-13', 'IS', 'Iceland', 'EURO', '32', '117', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38072, '2020-03-14', 'IS', 'Iceland', 'EURO', '0', '117', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38073, '2020-03-15', 'IS', 'Iceland', 'EURO', '21', '138', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38074, '2020-03-16', 'IS', 'Iceland', 'EURO', '40', '178', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38075, '2020-03-17', 'IS', 'Iceland', 'EURO', '21', '199', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38076, '2020-03-18', 'IS', 'Iceland', 'EURO', '48', '247', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38077, '2020-03-19', 'IS', 'Iceland', 'EURO', '3', '250', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38078, '2020-03-20', 'IS', 'Iceland', 'EURO', '80', '330', '1', '1');
INSERT INTO public.who_global_data_import VALUES (38079, '2020-03-21', 'IS', 'Iceland', 'EURO', '79', '409', '0', '1');
INSERT INTO public.who_global_data_import VALUES (38080, '2020-03-22', 'IS', 'Iceland', 'EURO', '64', '473', '0', '1');
INSERT INTO public.who_global_data_import VALUES (38081, '2020-03-23', 'IS', 'Iceland', 'EURO', '95', '568', '0', '1');
INSERT INTO public.who_global_data_import VALUES (38082, '2020-03-24', 'IS', 'Iceland', 'EURO', '20', '588', '1', '2');
INSERT INTO public.who_global_data_import VALUES (38083, '2020-03-25', 'IS', 'Iceland', 'EURO', '60', '648', '0', '2');
INSERT INTO public.who_global_data_import VALUES (38084, '2020-03-26', 'IS', 'Iceland', 'EURO', '89', '737', '0', '2');
INSERT INTO public.who_global_data_import VALUES (38085, '2020-03-27', 'IS', 'Iceland', 'EURO', '65', '802', '0', '2');
INSERT INTO public.who_global_data_import VALUES (38086, '2020-03-28', 'IS', 'Iceland', 'EURO', '88', '890', '0', '2');
INSERT INTO public.who_global_data_import VALUES (38087, '2020-03-29', 'IS', 'Iceland', 'EURO', '73', '963', '0', '2');
INSERT INTO public.who_global_data_import VALUES (38088, '2020-03-30', 'IS', 'Iceland', 'EURO', '57', '1020', '0', '2');
INSERT INTO public.who_global_data_import VALUES (38089, '2020-03-31', 'IS', 'Iceland', 'EURO', '66', '1086', '0', '2');
INSERT INTO public.who_global_data_import VALUES (38090, '2020-04-01', 'IS', 'Iceland', 'EURO', '49', '1135', '0', '2');
INSERT INTO public.who_global_data_import VALUES (38091, '2020-04-02', 'IS', 'Iceland', 'EURO', '85', '1220', '0', '2');
INSERT INTO public.who_global_data_import VALUES (38092, '2020-04-03', 'IS', 'Iceland', 'EURO', '99', '1319', '2', '4');
INSERT INTO public.who_global_data_import VALUES (38093, '2020-04-04', 'IS', 'Iceland', 'EURO', '45', '1364', '0', '4');
INSERT INTO public.who_global_data_import VALUES (38094, '2020-04-05', 'IS', 'Iceland', 'EURO', '53', '1417', '0', '4');
INSERT INTO public.who_global_data_import VALUES (38095, '2020-04-06', 'IS', 'Iceland', 'EURO', '69', '1486', '0', '4');
INSERT INTO public.who_global_data_import VALUES (38096, '2020-04-07', 'IS', 'Iceland', 'EURO', '76', '1562', '2', '6');
INSERT INTO public.who_global_data_import VALUES (38097, '2020-04-08', 'IS', 'Iceland', 'EURO', '24', '1586', '0', '6');
INSERT INTO public.who_global_data_import VALUES (38098, '2020-04-09', 'IS', 'Iceland', 'EURO', '30', '1616', '0', '6');
INSERT INTO public.who_global_data_import VALUES (38099, '2020-04-10', 'IS', 'Iceland', 'EURO', '32', '1648', '0', '6');
INSERT INTO public.who_global_data_import VALUES (38100, '2020-04-11', 'IS', 'Iceland', 'EURO', '27', '1675', '1', '7');
INSERT INTO public.who_global_data_import VALUES (38101, '2020-04-12', 'IS', 'Iceland', 'EURO', '14', '1689', '1', '8');
INSERT INTO public.who_global_data_import VALUES (38102, '2020-04-13', 'IS', 'Iceland', 'EURO', '12', '1701', '0', '8');
INSERT INTO public.who_global_data_import VALUES (38103, '2020-04-14', 'IS', 'Iceland', 'EURO', '10', '1711', '0', '8');
INSERT INTO public.who_global_data_import VALUES (38104, '2020-04-15', 'IS', 'Iceland', 'EURO', '9', '1720', '0', '8');
INSERT INTO public.who_global_data_import VALUES (38105, '2020-04-16', 'IS', 'Iceland', 'EURO', '7', '1727', '0', '8');
INSERT INTO public.who_global_data_import VALUES (38106, '2020-04-17', 'IS', 'Iceland', 'EURO', '12', '1739', '0', '8');
INSERT INTO public.who_global_data_import VALUES (38107, '2020-04-18', 'IS', 'Iceland', 'EURO', '15', '1754', '0', '8');
INSERT INTO public.who_global_data_import VALUES (38108, '2020-04-19', 'IS', 'Iceland', 'EURO', '6', '1760', '1', '9');
INSERT INTO public.who_global_data_import VALUES (38109, '2020-04-20', 'IS', 'Iceland', 'EURO', '11', '1771', '0', '9');
INSERT INTO public.who_global_data_import VALUES (38110, '2020-04-21', 'IS', 'Iceland', 'EURO', '2', '1773', '1', '10');
INSERT INTO public.who_global_data_import VALUES (38111, '2020-04-22', 'IS', 'Iceland', 'EURO', '5', '1778', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38112, '2020-04-23', 'IS', 'Iceland', 'EURO', '7', '1785', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38113, '2020-04-24', 'IS', 'Iceland', 'EURO', '4', '1789', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38114, '2020-04-25', 'IS', 'Iceland', 'EURO', '0', '1789', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38115, '2020-04-26', 'IS', 'Iceland', 'EURO', '1', '1790', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38116, '2020-04-27', 'IS', 'Iceland', 'EURO', '2', '1792', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38117, '2020-04-28', 'IS', 'Iceland', 'EURO', '0', '1792', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38118, '2020-04-29', 'IS', 'Iceland', 'EURO', '3', '1795', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38119, '2020-04-30', 'IS', 'Iceland', 'EURO', '2', '1797', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38120, '2020-05-01', 'IS', 'Iceland', 'EURO', '0', '1797', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38121, '2020-05-02', 'IS', 'Iceland', 'EURO', '1', '1798', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38122, '2020-05-03', 'IS', 'Iceland', 'EURO', '0', '1798', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38123, '2020-05-04', 'IS', 'Iceland', 'EURO', '1', '1799', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38124, '2020-05-05', 'IS', 'Iceland', 'EURO', '0', '1799', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38125, '2020-05-06', 'IS', 'Iceland', 'EURO', '0', '1799', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38126, '2020-05-07', 'IS', 'Iceland', 'EURO', '0', '1799', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38127, '2020-05-08', 'IS', 'Iceland', 'EURO', '2', '1801', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38128, '2020-05-09', 'IS', 'Iceland', 'EURO', '0', '1801', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38129, '2020-05-10', 'IS', 'Iceland', 'EURO', '0', '1801', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38130, '2020-05-11', 'IS', 'Iceland', 'EURO', '0', '1801', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38131, '2020-05-12', 'IS', 'Iceland', 'EURO', '0', '1801', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38132, '2020-05-13', 'IS', 'Iceland', 'EURO', '0', '1801', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38133, '2020-05-14', 'IS', 'Iceland', 'EURO', '1', '1802', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38134, '2020-05-15', 'IS', 'Iceland', 'EURO', '0', '1802', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38135, '2020-05-16', 'IS', 'Iceland', 'EURO', '0', '1802', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38136, '2020-05-17', 'IS', 'Iceland', 'EURO', '0', '1802', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38137, '2020-05-18', 'IS', 'Iceland', 'EURO', '0', '1802', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38138, '2020-05-19', 'IS', 'Iceland', 'EURO', '0', '1802', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38139, '2020-05-20', 'IS', 'Iceland', 'EURO', '0', '1802', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38140, '2020-05-21', 'IS', 'Iceland', 'EURO', '1', '1803', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38141, '2020-05-22', 'IS', 'Iceland', 'EURO', '0', '1803', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38142, '2020-05-23', 'IS', 'Iceland', 'EURO', '0', '1803', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38143, '2020-05-24', 'IS', 'Iceland', 'EURO', '1', '1804', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38144, '2020-05-25', 'IS', 'Iceland', 'EURO', '0', '1804', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38145, '2020-05-26', 'IS', 'Iceland', 'EURO', '0', '1804', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38146, '2020-05-27', 'IS', 'Iceland', 'EURO', '0', '1804', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38147, '2020-05-28', 'IS', 'Iceland', 'EURO', '1', '1805', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38148, '2020-05-29', 'IS', 'Iceland', 'EURO', '0', '1805', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38149, '2020-05-30', 'IS', 'Iceland', 'EURO', '0', '1805', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38150, '2020-05-31', 'IS', 'Iceland', 'EURO', '1', '1806', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38151, '2020-06-01', 'IS', 'Iceland', 'EURO', '0', '1806', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38152, '2020-06-02', 'IS', 'Iceland', 'EURO', '0', '1806', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38153, '2020-06-03', 'IS', 'Iceland', 'EURO', '0', '1806', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38154, '2020-06-04', 'IS', 'Iceland', 'EURO', '0', '1806', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38155, '2020-06-05', 'IS', 'Iceland', 'EURO', '0', '1806', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38156, '2020-06-06', 'IS', 'Iceland', 'EURO', '0', '1806', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38157, '2020-06-07', 'IS', 'Iceland', 'EURO', '0', '1806', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38158, '2020-06-08', 'IS', 'Iceland', 'EURO', '1', '1807', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38159, '2020-06-09', 'IS', 'Iceland', 'EURO', '0', '1807', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38160, '2020-06-10', 'IS', 'Iceland', 'EURO', '0', '1807', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38161, '2020-06-11', 'IS', 'Iceland', 'EURO', '0', '1807', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38162, '2020-06-12', 'IS', 'Iceland', 'EURO', '0', '1807', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38163, '2020-06-13', 'IS', 'Iceland', 'EURO', '1', '1808', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38164, '2020-06-14', 'IS', 'Iceland', 'EURO', '2', '1810', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38165, '2020-06-15', 'IS', 'Iceland', 'EURO', '0', '1810', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38166, '2020-06-16', 'IS', 'Iceland', 'EURO', '1', '1811', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38167, '2020-06-17', 'IS', 'Iceland', 'EURO', '1', '1812', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38168, '2020-06-18', 'IS', 'Iceland', 'EURO', '0', '1812', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38169, '2020-06-19', 'IS', 'Iceland', 'EURO', '2', '1814', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38170, '2020-06-20', 'IS', 'Iceland', 'EURO', '1', '1815', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38171, '2020-06-21', 'IS', 'Iceland', 'EURO', '0', '1815', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38172, '2020-06-22', 'IS', 'Iceland', 'EURO', '0', '1815', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38173, '2020-06-23', 'IS', 'Iceland', 'EURO', '0', '1815', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38174, '2020-06-24', 'IS', 'Iceland', 'EURO', '0', '1815', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38175, '2020-06-25', 'IS', 'Iceland', 'EURO', '2', '1817', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38176, '2020-06-26', 'IS', 'Iceland', 'EURO', '1', '1818', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38177, '2020-06-27', 'IS', 'Iceland', 'EURO', '2', '1820', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38178, '2020-06-28', 'IS', 'Iceland', 'EURO', '0', '1820', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38179, '2020-06-29', 'IS', 'Iceland', 'EURO', '1', '1821', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38180, '2020-06-30', 'IS', 'Iceland', 'EURO', '1', '1822', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38181, '2020-07-01', 'IS', 'Iceland', 'EURO', '2', '1824', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38182, '2020-07-02', 'IS', 'Iceland', 'EURO', '1', '1825', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38183, '2020-07-03', 'IS', 'Iceland', 'EURO', '5', '1830', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38184, '2020-07-04', 'IS', 'Iceland', 'EURO', '0', '1830', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38185, '2020-07-05', 'IS', 'Iceland', 'EURO', '0', '1830', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38186, '2020-07-06', 'IS', 'Iceland', 'EURO', '0', '1830', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38187, '2020-07-07', 'IS', 'Iceland', 'EURO', '2', '1832', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38188, '2020-07-08', 'IS', 'Iceland', 'EURO', '1', '1833', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38189, '2020-07-09', 'IS', 'Iceland', 'EURO', '0', '1833', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38190, '2020-07-10', 'IS', 'Iceland', 'EURO', '0', '1833', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38191, '2020-07-11', 'IS', 'Iceland', 'EURO', '0', '1833', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38192, '2020-07-12', 'IS', 'Iceland', 'EURO', '0', '1833', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38193, '2020-07-13', 'IS', 'Iceland', 'EURO', '0', '1833', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38194, '2020-07-14', 'IS', 'Iceland', 'EURO', '0', '1833', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38195, '2020-07-15', 'IS', 'Iceland', 'EURO', '2', '1835', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38196, '2020-07-16', 'IS', 'Iceland', 'EURO', '0', '1835', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38197, '2020-07-17', 'IS', 'Iceland', 'EURO', '1', '1836', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38198, '2020-07-18', 'IS', 'Iceland', 'EURO', '0', '1836', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38199, '2020-07-19', 'IS', 'Iceland', 'EURO', '2', '1838', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38200, '2020-07-20', 'IS', 'Iceland', 'EURO', '1', '1839', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38201, '2020-07-21', 'IS', 'Iceland', 'EURO', '0', '1839', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38202, '2020-07-22', 'IS', 'Iceland', 'EURO', '0', '1839', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38203, '2020-07-23', 'IS', 'Iceland', 'EURO', '1', '1840', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38204, '2020-07-24', 'IS', 'Iceland', 'EURO', '1', '1841', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38205, '2020-07-25', 'IS', 'Iceland', 'EURO', '2', '1843', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38206, '2020-07-26', 'IS', 'Iceland', 'EURO', '0', '1843', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38207, '2020-07-27', 'IS', 'Iceland', 'EURO', '4', '1847', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38208, '2020-07-28', 'IS', 'Iceland', 'EURO', '7', '1854', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38209, '2020-07-29', 'IS', 'Iceland', 'EURO', '3', '1857', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38210, '2020-07-30', 'IS', 'Iceland', 'EURO', '4', '1861', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38211, '2020-07-31', 'IS', 'Iceland', 'EURO', '11', '1872', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38212, '2020-08-01', 'IS', 'Iceland', 'EURO', '13', '1885', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38213, '2020-08-02', 'IS', 'Iceland', 'EURO', '8', '1893', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38214, '2020-08-03', 'IS', 'Iceland', 'EURO', '14', '1907', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38215, '2020-08-04', 'IS', 'Iceland', 'EURO', '8', '1915', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38216, '2020-08-05', 'IS', 'Iceland', 'EURO', '3', '1918', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38217, '2020-08-06', 'IS', 'Iceland', 'EURO', '8', '1926', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38218, '2020-08-07', 'IS', 'Iceland', 'EURO', '6', '1932', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38219, '2020-08-08', 'IS', 'Iceland', 'EURO', '20', '1952', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38220, '2020-08-09', 'IS', 'Iceland', 'EURO', '3', '1955', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38221, '2020-08-10', 'IS', 'Iceland', 'EURO', '3', '1958', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38222, '2020-08-11', 'IS', 'Iceland', 'EURO', '4', '1962', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38223, '2020-08-12', 'IS', 'Iceland', 'EURO', '6', '1968', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38224, '2020-08-13', 'IS', 'Iceland', 'EURO', '4', '1972', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38225, '2020-08-14', 'IS', 'Iceland', 'EURO', '4', '1976', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38226, '2020-08-15', 'IS', 'Iceland', 'EURO', '7', '1983', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38227, '2020-08-16', 'IS', 'Iceland', 'EURO', '16', '1999', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38228, '2020-08-17', 'IS', 'Iceland', 'EURO', '12', '2011', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38229, '2020-08-18', 'IS', 'Iceland', 'EURO', '3', '2014', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38230, '2020-08-19', 'IS', 'Iceland', 'EURO', '13', '2027', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38231, '2020-08-20', 'IS', 'Iceland', 'EURO', '8', '2035', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38232, '2020-08-21', 'IS', 'Iceland', 'EURO', '5', '2040', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38233, '2020-08-22', 'IS', 'Iceland', 'EURO', '10', '2050', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38234, '2020-08-23', 'IS', 'Iceland', 'EURO', '8', '2058', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38235, '2020-08-24', 'IS', 'Iceland', 'EURO', '6', '2064', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38236, '2020-08-25', 'IS', 'Iceland', 'EURO', '9', '2073', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38237, '2020-08-26', 'IS', 'Iceland', 'EURO', '4', '2077', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38238, '2020-08-27', 'IS', 'Iceland', 'EURO', '5', '2082', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38239, '2020-08-28', 'IS', 'Iceland', 'EURO', '5', '2087', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38240, '2020-08-29', 'IS', 'Iceland', 'EURO', '5', '2092', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38241, '2020-08-30', 'IS', 'Iceland', 'EURO', '8', '2100', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38242, '2020-08-31', 'IS', 'Iceland', 'EURO', '5', '2105', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38243, '2020-09-01', 'IS', 'Iceland', 'EURO', '2', '2107', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38244, '2020-09-02', 'IS', 'Iceland', 'EURO', '9', '2116', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38245, '2020-09-03', 'IS', 'Iceland', 'EURO', '5', '2121', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38246, '2020-09-04', 'IS', 'Iceland', 'EURO', '7', '2128', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38247, '2020-09-05', 'IS', 'Iceland', 'EURO', '7', '2135', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38248, '2020-09-06', 'IS', 'Iceland', 'EURO', '1', '2136', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38249, '2020-09-07', 'IS', 'Iceland', 'EURO', '5', '2141', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38250, '2020-09-08', 'IS', 'Iceland', 'EURO', '2', '2143', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38251, '2020-09-09', 'IS', 'Iceland', 'EURO', '7', '2150', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38252, '2020-09-10', 'IS', 'Iceland', 'EURO', '3', '2153', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38253, '2020-09-11', 'IS', 'Iceland', 'EURO', '4', '2157', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38254, '2020-09-12', 'IS', 'Iceland', 'EURO', '4', '2161', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38255, '2020-09-13', 'IS', 'Iceland', 'EURO', '1', '2162', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38256, '2020-09-14', 'IS', 'Iceland', 'EURO', '3', '2165', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38257, '2020-09-15', 'IS', 'Iceland', 'EURO', '3', '2168', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38258, '2020-09-16', 'IS', 'Iceland', 'EURO', '6', '2174', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38259, '2020-09-17', 'IS', 'Iceland', 'EURO', '15', '2189', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38260, '2020-09-18', 'IS', 'Iceland', 'EURO', '17', '2206', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38261, '2020-09-19', 'IS', 'Iceland', 'EURO', '24', '2230', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38262, '2020-09-20', 'IS', 'Iceland', 'EURO', '77', '2307', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38263, '2020-09-21', 'IS', 'Iceland', 'EURO', '39', '2346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38264, '2020-09-22', 'IS', 'Iceland', 'EURO', '31', '2377', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38265, '2020-09-23', 'IS', 'Iceland', 'EURO', '42', '2419', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38266, '2020-09-24', 'IS', 'Iceland', 'EURO', '57', '2476', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38267, '2020-09-25', 'IS', 'Iceland', 'EURO', '36', '2512', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38268, '2020-09-26', 'IS', 'Iceland', 'EURO', '49', '2561', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38269, '2020-09-27', 'IS', 'Iceland', 'EURO', '40', '2601', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38270, '2020-09-28', 'IS', 'Iceland', 'EURO', '22', '2623', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38271, '2020-09-29', 'IS', 'Iceland', 'EURO', '40', '2663', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38272, '2020-09-30', 'IS', 'Iceland', 'EURO', '32', '2695', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38273, '2020-10-01', 'IS', 'Iceland', 'EURO', '33', '2728', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38274, '2020-10-02', 'IS', 'Iceland', 'EURO', '41', '2769', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38275, '2020-10-03', 'IS', 'Iceland', 'EURO', '40', '2809', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38276, '2020-10-04', 'IS', 'Iceland', 'EURO', '63', '2872', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38277, '2020-10-05', 'IS', 'Iceland', 'EURO', '49', '2921', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38278, '2020-10-06', 'IS', 'Iceland', 'EURO', '59', '2980', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38279, '2020-10-07', 'IS', 'Iceland', 'EURO', '101', '3081', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38280, '2020-10-08', 'IS', 'Iceland', 'EURO', '91', '3172', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38281, '2020-10-09', 'IS', 'Iceland', 'EURO', '95', '3267', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38282, '2020-10-10', 'IS', 'Iceland', 'EURO', '106', '3373', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38283, '2020-10-11', 'IS', 'Iceland', 'EURO', '87', '3460', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38284, '2020-10-12', 'IS', 'Iceland', 'EURO', '66', '3526', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38285, '2020-10-13', 'IS', 'Iceland', 'EURO', '56', '3582', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38286, '2020-10-14', 'IS', 'Iceland', 'EURO', '86', '3668', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38287, '2020-10-15', 'IS', 'Iceland', 'EURO', '89', '3757', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38288, '2020-10-16', 'IS', 'Iceland', 'EURO', '80', '3837', '0', '10');
INSERT INTO public.who_global_data_import VALUES (38289, '2020-10-17', 'IS', 'Iceland', 'EURO', '92', '3929', '1', '11');
INSERT INTO public.who_global_data_import VALUES (38290, '2020-10-18', 'IS', 'Iceland', 'EURO', '69', '3998', '0', '11');
INSERT INTO public.who_global_data_import VALUES (38291, '2020-10-19', 'IS', 'Iceland', 'EURO', '57', '4055', '0', '11');
INSERT INTO public.who_global_data_import VALUES (38292, '2020-10-20', 'IS', 'Iceland', 'EURO', '46', '4101', '0', '11');
INSERT INTO public.who_global_data_import VALUES (38293, '2020-10-21', 'IS', 'Iceland', 'EURO', '92', '4193', '0', '11');
INSERT INTO public.who_global_data_import VALUES (38294, '2020-10-22', 'IS', 'Iceland', 'EURO', '37', '4230', '0', '11');
INSERT INTO public.who_global_data_import VALUES (38295, '2020-10-23', 'IS', 'Iceland', 'EURO', '38', '4268', '0', '11');
INSERT INTO public.who_global_data_import VALUES (38296, '2020-10-24', 'IS', 'Iceland', 'EURO', '40', '4308', '0', '11');
INSERT INTO public.who_global_data_import VALUES (38297, '2020-10-25', 'IS', 'Iceland', 'EURO', '86', '4394', '0', '11');
INSERT INTO public.who_global_data_import VALUES (38298, '2020-10-26', 'IS', 'Iceland', 'EURO', '54', '4448', '0', '11');
INSERT INTO public.who_global_data_import VALUES (38299, '2020-10-27', 'IS', 'Iceland', 'EURO', '56', '4504', '0', '11');
INSERT INTO public.who_global_data_import VALUES (38300, '2020-10-28', 'IS', 'Iceland', 'EURO', '70', '4574', '0', '11');
INSERT INTO public.who_global_data_import VALUES (38301, '2020-10-29', 'IS', 'Iceland', 'EURO', '97', '4671', '1', '12');
INSERT INTO public.who_global_data_import VALUES (38302, '2020-10-30', 'IS', 'Iceland', 'EURO', '48', '4719', '0', '12');
INSERT INTO public.who_global_data_import VALUES (38303, '2020-10-31', 'IS', 'Iceland', 'EURO', '78', '4797', '0', '12');
INSERT INTO public.who_global_data_import VALUES (38304, '2020-11-01', 'IS', 'Iceland', 'EURO', '68', '4865', '0', '12');
INSERT INTO public.who_global_data_import VALUES (38305, '2020-11-02', 'IS', 'Iceland', 'EURO', '25', '4890', '0', '12');
INSERT INTO public.who_global_data_import VALUES (38306, '2020-11-03', 'IS', 'Iceland', 'EURO', '41', '4931', '0', '12');
INSERT INTO public.who_global_data_import VALUES (38307, '2020-11-04', 'IS', 'Iceland', 'EURO', '26', '4957', '5', '17');
INSERT INTO public.who_global_data_import VALUES (38308, '2020-11-05', 'IS', 'Iceland', 'EURO', '32', '4989', '0', '17');
INSERT INTO public.who_global_data_import VALUES (38309, '2020-11-06', 'IS', 'Iceland', 'EURO', '28', '5017', '1', '18');
INSERT INTO public.who_global_data_import VALUES (38310, '2020-11-07', 'IS', 'Iceland', 'EURO', '22', '5039', '0', '18');
INSERT INTO public.who_global_data_import VALUES (38311, '2020-11-08', 'IS', 'Iceland', 'EURO', '24', '5063', '0', '18');
INSERT INTO public.who_global_data_import VALUES (38312, '2020-11-09', 'IS', 'Iceland', 'EURO', '15', '5078', '2', '20');
INSERT INTO public.who_global_data_import VALUES (38313, '2020-11-10', 'IS', 'Iceland', 'EURO', '23', '5101', '3', '23');
INSERT INTO public.who_global_data_import VALUES (38314, '2020-11-11', 'IS', 'Iceland', 'EURO', '13', '5114', '1', '24');
INSERT INTO public.who_global_data_import VALUES (38315, '2020-11-12', 'IS', 'Iceland', 'EURO', '28', '5142', '0', '24');
INSERT INTO public.who_global_data_import VALUES (38316, '2020-11-13', 'IS', 'Iceland', 'EURO', '18', '5160', '1', '25');
INSERT INTO public.who_global_data_import VALUES (38317, '2020-11-14', 'IS', 'Iceland', 'EURO', '10', '5170', '0', '25');
INSERT INTO public.who_global_data_import VALUES (38318, '2020-11-15', 'IS', 'Iceland', 'EURO', '16', '5186', '0', '25');
INSERT INTO public.who_global_data_import VALUES (38319, '2020-11-16', 'IS', 'Iceland', 'EURO', '3', '5189', '0', '25');
INSERT INTO public.who_global_data_import VALUES (38320, '2020-11-17', 'IS', 'Iceland', 'EURO', '16', '5205', '0', '25');
INSERT INTO public.who_global_data_import VALUES (38321, '2020-11-18', 'IS', 'Iceland', 'EURO', '10', '5215', '0', '25');
INSERT INTO public.who_global_data_import VALUES (38322, '2020-11-19', 'IS', 'Iceland', 'EURO', '11', '5226', '0', '25');
INSERT INTO public.who_global_data_import VALUES (38323, '2020-11-20', 'IS', 'Iceland', 'EURO', '5', '5231', '0', '25');
INSERT INTO public.who_global_data_import VALUES (38324, '2020-11-21', 'IS', 'Iceland', 'EURO', '20', '5251', '1', '26');
INSERT INTO public.who_global_data_import VALUES (38325, '2020-11-22', 'IS', 'Iceland', 'EURO', '18', '5269', '0', '26');
INSERT INTO public.who_global_data_import VALUES (38326, '2020-11-23', 'IS', 'Iceland', 'EURO', '8', '5277', '0', '26');
INSERT INTO public.who_global_data_import VALUES (38327, '2020-11-24', 'IS', 'Iceland', 'EURO', '12', '5289', '0', '26');
INSERT INTO public.who_global_data_import VALUES (38328, '2020-11-25', 'IS', 'Iceland', 'EURO', '9', '5298', '0', '26');
INSERT INTO public.who_global_data_import VALUES (38329, '2020-11-26', 'IS', 'Iceland', 'EURO', '14', '5312', '0', '26');
INSERT INTO public.who_global_data_import VALUES (38330, '2020-11-27', 'IS', 'Iceland', 'EURO', '11', '5323', '0', '26');
INSERT INTO public.who_global_data_import VALUES (38331, '2020-11-28', 'IS', 'Iceland', 'EURO', '23', '5346', '0', '26');
INSERT INTO public.who_global_data_import VALUES (38332, '2020-11-29', 'IS', 'Iceland', 'EURO', '25', '5371', '0', '26');
INSERT INTO public.who_global_data_import VALUES (38333, '2020-11-30', 'IS', 'Iceland', 'EURO', '10', '5381', '0', '26');
INSERT INTO public.who_global_data_import VALUES (38334, '2020-12-01', 'IS', 'Iceland', 'EURO', '11', '5392', '0', '26');
INSERT INTO public.who_global_data_import VALUES (38335, '2020-12-02', 'IS', 'Iceland', 'EURO', '21', '5413', '1', '27');
INSERT INTO public.who_global_data_import VALUES (38336, '2020-12-03', 'IS', 'Iceland', 'EURO', '20', '5433', '0', '27');
INSERT INTO public.who_global_data_import VALUES (38337, '2020-12-04', 'IS', 'Iceland', 'EURO', '15', '5448', '0', '27');
INSERT INTO public.who_global_data_import VALUES (38338, '2020-12-05', 'IS', 'Iceland', 'EURO', '14', '5462', '0', '27');
INSERT INTO public.who_global_data_import VALUES (38339, '2020-12-06', 'IS', 'Iceland', 'EURO', '14', '5476', '0', '27');
INSERT INTO public.who_global_data_import VALUES (38340, '2020-12-07', 'IS', 'Iceland', 'EURO', '6', '5482', '0', '27');
INSERT INTO public.who_global_data_import VALUES (38341, '2020-12-08', 'IS', 'Iceland', 'EURO', '14', '5496', '0', '27');
INSERT INTO public.who_global_data_import VALUES (38342, '2020-12-09', 'IS', 'Iceland', 'EURO', '10', '5506', '1', '28');
INSERT INTO public.who_global_data_import VALUES (38343, '2020-12-10', 'IS', 'Iceland', 'EURO', '10', '5516', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38344, '2020-12-11', 'IS', 'Iceland', 'EURO', '8', '5524', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38345, '2020-12-12', 'IS', 'Iceland', 'EURO', '15', '5539', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38346, '2020-12-13', 'IS', 'Iceland', 'EURO', '13', '5552', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38347, '2020-12-14', 'IS', 'Iceland', 'EURO', '5', '5557', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38348, '2020-12-15', 'IS', 'Iceland', 'EURO', '14', '5571', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38349, '2020-12-16', 'IS', 'Iceland', 'EURO', '7', '5578', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38350, '2020-12-17', 'IS', 'Iceland', 'EURO', '10', '5588', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38351, '2020-12-18', 'IS', 'Iceland', 'EURO', '0', '5588', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38352, '2020-12-19', 'IS', 'Iceland', 'EURO', '16', '5604', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38353, '2020-12-20', 'IS', 'Iceland', 'EURO', '17', '5621', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38354, '2020-12-21', 'IS', 'Iceland', 'EURO', '21', '5642', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38355, '2020-12-22', 'IS', 'Iceland', 'EURO', '14', '5656', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38356, '2020-12-23', 'IS', 'Iceland', 'EURO', '11', '5667', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38357, '2020-12-24', 'IS', 'Iceland', 'EURO', '16', '5683', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38358, '2020-12-25', 'IS', 'Iceland', 'EURO', '0', '5683', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38359, '2020-12-26', 'IS', 'Iceland', 'EURO', '0', '5683', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38360, '2020-12-27', 'IS', 'Iceland', 'EURO', '0', '5683', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38361, '2020-12-28', 'IS', 'Iceland', 'EURO', '43', '5726', '0', '28');
INSERT INTO public.who_global_data_import VALUES (38362, '2020-12-29', 'IS', 'Iceland', 'EURO', '10', '5736', '1', '29');
INSERT INTO public.who_global_data_import VALUES (38363, '2020-12-30', 'IS', 'Iceland', 'EURO', '18', '5754', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38364, '2020-12-31', 'IS', 'Iceland', 'EURO', '0', '5754', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38365, '2021-01-01', 'IS', 'Iceland', 'EURO', '0', '5754', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38366, '2021-01-02', 'IS', 'Iceland', 'EURO', '0', '5754', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38367, '2021-01-03', 'IS', 'Iceland', 'EURO', '0', '5754', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38368, '2021-01-04', 'IS', 'Iceland', 'EURO', '41', '5795', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38369, '2021-01-05', 'IS', 'Iceland', 'EURO', '0', '5795', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38370, '2021-01-06', 'IS', 'Iceland', 'EURO', '16', '5811', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38371, '2021-01-07', 'IS', 'Iceland', 'EURO', '21', '5832', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38372, '2021-01-08', 'IS', 'Iceland', 'EURO', '13', '5845', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38373, '2021-01-09', 'IS', 'Iceland', 'EURO', '22', '5867', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38374, '2021-01-10', 'IS', 'Iceland', 'EURO', '13', '5880', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38375, '2021-01-11', 'IS', 'Iceland', 'EURO', '10', '5890', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38376, '2021-01-12', 'IS', 'Iceland', 'EURO', '8', '5898', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38377, '2021-01-13', 'IS', 'Iceland', 'EURO', '14', '5912', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38378, '2021-01-14', 'IS', 'Iceland', 'EURO', '23', '5935', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38379, '2021-01-15', 'IS', 'Iceland', 'EURO', '13', '5948', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38380, '2021-01-16', 'IS', 'Iceland', 'EURO', '8', '5956', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38381, '2021-01-17', 'IS', 'Iceland', 'EURO', '0', '5956', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38382, '2021-01-18', 'IS', 'Iceland', 'EURO', '0', '5956', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38383, '2021-01-19', 'IS', 'Iceland', 'EURO', '14', '5970', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38384, '2021-01-20', 'IS', 'Iceland', 'EURO', '0', '5970', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38385, '2021-01-21', 'IS', 'Iceland', 'EURO', '5', '5975', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38386, '2021-01-22', 'IS', 'Iceland', 'EURO', '6', '5981', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38387, '2021-01-23', 'IS', 'Iceland', 'EURO', '0', '5981', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38388, '2021-01-24', 'IS', 'Iceland', 'EURO', '0', '5981', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38389, '2021-01-25', 'IS', 'Iceland', 'EURO', '9', '5990', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38390, '2021-01-26', 'IS', 'Iceland', 'EURO', '0', '5990', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38391, '2021-01-27', 'IS', 'Iceland', 'EURO', '2', '5992', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38392, '2021-01-28', 'IS', 'Iceland', 'EURO', '8', '6000', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38393, '2021-01-29', 'IS', 'Iceland', 'EURO', '1', '6001', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38394, '2021-01-30', 'IS', 'Iceland', 'EURO', '1', '6002', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38395, '2021-01-31', 'IS', 'Iceland', 'EURO', '0', '6002', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38396, '2021-02-01', 'IS', 'Iceland', 'EURO', '7', '6009', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38397, '2021-02-02', 'IS', 'Iceland', 'EURO', '0', '6009', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38398, '2021-02-03', 'IS', 'Iceland', 'EURO', '2', '6011', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38399, '2021-02-04', 'IS', 'Iceland', 'EURO', '2', '6013', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38400, '2021-02-05', 'IS', 'Iceland', 'EURO', '3', '6016', '0', '29');
INSERT INTO public.who_global_data_import VALUES (38401, '2020-01-03', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38402, '2020-01-04', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38403, '2020-01-05', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38404, '2020-01-06', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38405, '2020-01-07', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38406, '2020-01-08', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38407, '2020-01-09', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38408, '2020-01-10', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38409, '2020-01-11', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38410, '2020-01-12', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38411, '2020-01-13', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38412, '2020-01-14', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38413, '2020-01-15', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38414, '2020-01-16', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38415, '2020-01-17', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38416, '2020-01-18', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38417, '2020-01-19', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38418, '2020-01-20', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38419, '2020-01-21', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38420, '2020-01-22', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38421, '2020-01-23', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38422, '2020-01-24', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38423, '2020-01-25', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38424, '2020-01-26', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38425, '2020-01-27', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38426, '2020-01-28', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38427, '2020-01-29', 'IN', 'India', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38428, '2020-01-30', 'IN', 'India', 'SEARO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38429, '2020-01-31', 'IN', 'India', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38430, '2020-02-01', 'IN', 'India', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38431, '2020-02-02', 'IN', 'India', 'SEARO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38432, '2020-02-03', 'IN', 'India', 'SEARO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38433, '2020-02-04', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38434, '2020-02-05', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38435, '2020-02-06', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38436, '2020-02-07', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38437, '2020-02-08', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38438, '2020-02-09', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38439, '2020-02-10', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38440, '2020-02-11', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38441, '2020-02-12', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38442, '2020-02-13', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38443, '2020-02-14', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38444, '2020-02-15', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38445, '2020-02-16', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38446, '2020-02-17', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38447, '2020-02-18', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38448, '2020-02-19', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38449, '2020-02-20', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38450, '2020-02-21', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38451, '2020-02-22', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38452, '2020-02-23', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38453, '2020-02-24', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38454, '2020-02-25', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38455, '2020-02-26', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38456, '2020-02-27', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38457, '2020-02-28', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38458, '2020-02-29', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38459, '2020-03-01', 'IN', 'India', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38460, '2020-03-02', 'IN', 'India', 'SEARO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38461, '2020-03-03', 'IN', 'India', 'SEARO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38462, '2020-03-04', 'IN', 'India', 'SEARO', '22', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38463, '2020-03-05', 'IN', 'India', 'SEARO', '1', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38464, '2020-03-06', 'IN', 'India', 'SEARO', '3', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38465, '2020-03-07', 'IN', 'India', 'SEARO', '3', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38466, '2020-03-08', 'IN', 'India', 'SEARO', '5', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38467, '2020-03-09', 'IN', 'India', 'SEARO', '5', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38468, '2020-03-10', 'IN', 'India', 'SEARO', '6', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38469, '2020-03-11', 'IN', 'India', 'SEARO', '10', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38470, '2020-03-12', 'IN', 'India', 'SEARO', '14', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38471, '2020-03-13', 'IN', 'India', 'SEARO', '7', '85', '1', '1');
INSERT INTO public.who_global_data_import VALUES (38472, '2020-03-14', 'IN', 'India', 'SEARO', '3', '88', '1', '2');
INSERT INTO public.who_global_data_import VALUES (38473, '2020-03-15', 'IN', 'India', 'SEARO', '23', '111', '0', '2');
INSERT INTO public.who_global_data_import VALUES (38474, '2020-03-16', 'IN', 'India', 'SEARO', '7', '118', '0', '2');
INSERT INTO public.who_global_data_import VALUES (38475, '2020-03-17', 'IN', 'India', 'SEARO', '23', '141', '1', '3');
INSERT INTO public.who_global_data_import VALUES (38476, '2020-03-18', 'IN', 'India', 'SEARO', '14', '155', '0', '3');
INSERT INTO public.who_global_data_import VALUES (38477, '2020-03-19', 'IN', 'India', 'SEARO', '40', '195', '1', '4');
INSERT INTO public.who_global_data_import VALUES (38478, '2020-03-20', 'IN', 'India', 'SEARO', '0', '195', '0', '4');
INSERT INTO public.who_global_data_import VALUES (38479, '2020-03-21', 'IN', 'India', 'SEARO', '88', '283', '0', '4');
INSERT INTO public.who_global_data_import VALUES (38480, '2020-03-22', 'IN', 'India', 'SEARO', '58', '341', '1', '5');
INSERT INTO public.who_global_data_import VALUES (38481, '2020-03-23', 'IN', 'India', 'SEARO', '93', '434', '4', '9');
INSERT INTO public.who_global_data_import VALUES (38482, '2020-03-24', 'IN', 'India', 'SEARO', '85', '519', '0', '9');
INSERT INTO public.who_global_data_import VALUES (38483, '2020-03-25', 'IN', 'India', 'SEARO', '87', '606', '1', '10');
INSERT INTO public.who_global_data_import VALUES (38484, '2020-03-26', 'IN', 'India', 'SEARO', '43', '649', '3', '13');
INSERT INTO public.who_global_data_import VALUES (38485, '2020-03-27', 'IN', 'India', 'SEARO', '75', '724', '4', '17');
INSERT INTO public.who_global_data_import VALUES (38486, '2020-03-28', 'IN', 'India', 'SEARO', '0', '724', '0', '17');
INSERT INTO public.who_global_data_import VALUES (38487, '2020-03-29', 'IN', 'India', 'SEARO', '255', '979', '8', '25');
INSERT INTO public.who_global_data_import VALUES (38488, '2020-03-30', 'IN', 'India', 'SEARO', '92', '1071', '4', '29');
INSERT INTO public.who_global_data_import VALUES (38489, '2020-03-31', 'IN', 'India', 'SEARO', '180', '1251', '3', '32');
INSERT INTO public.who_global_data_import VALUES (38490, '2020-04-01', 'IN', 'India', 'SEARO', '385', '1636', '6', '38');
INSERT INTO public.who_global_data_import VALUES (38491, '2020-04-02', 'IN', 'India', 'SEARO', '329', '1965', '12', '50');
INSERT INTO public.who_global_data_import VALUES (38492, '2020-04-03', 'IN', 'India', 'SEARO', '336', '2301', '6', '56');
INSERT INTO public.who_global_data_import VALUES (38493, '2020-04-04', 'IN', 'India', 'SEARO', '601', '2902', '12', '68');
INSERT INTO public.who_global_data_import VALUES (38494, '2020-04-05', 'IN', 'India', 'SEARO', '472', '3374', '9', '77');
INSERT INTO public.who_global_data_import VALUES (38495, '2020-04-06', 'IN', 'India', 'SEARO', '693', '4067', '32', '109');
INSERT INTO public.who_global_data_import VALUES (38496, '2020-04-07', 'IN', 'India', 'SEARO', '354', '4421', '5', '114');
INSERT INTO public.who_global_data_import VALUES (38497, '2020-04-08', 'IN', 'India', 'SEARO', '853', '5274', '35', '149');
INSERT INTO public.who_global_data_import VALUES (38498, '2020-04-09', 'IN', 'India', 'SEARO', '591', '5865', '20', '169');
INSERT INTO public.who_global_data_import VALUES (38499, '2020-04-10', 'IN', 'India', 'SEARO', '547', '6412', '30', '199');
INSERT INTO public.who_global_data_import VALUES (38500, '2020-04-11', 'IN', 'India', 'SEARO', '1035', '7447', '40', '239');
INSERT INTO public.who_global_data_import VALUES (38501, '2020-04-12', 'IN', 'India', 'SEARO', '909', '8356', '34', '273');
INSERT INTO public.who_global_data_import VALUES (38502, '2020-04-13', 'IN', 'India', 'SEARO', '796', '9152', '35', '308');
INSERT INTO public.who_global_data_import VALUES (38503, '2020-04-14', 'IN', 'India', 'SEARO', '1211', '10363', '31', '339');
INSERT INTO public.who_global_data_import VALUES (38504, '2020-04-15', 'IN', 'India', 'SEARO', '1076', '11439', '38', '377');
INSERT INTO public.who_global_data_import VALUES (38505, '2020-04-16', 'IN', 'India', 'SEARO', '941', '12380', '37', '414');
INSERT INTO public.who_global_data_import VALUES (38506, '2020-04-17', 'IN', 'India', 'SEARO', '1007', '13387', '23', '437');
INSERT INTO public.who_global_data_import VALUES (38507, '2020-04-18', 'IN', 'India', 'SEARO', '991', '14378', '43', '480');
INSERT INTO public.who_global_data_import VALUES (38508, '2020-04-19', 'IN', 'India', 'SEARO', '1334', '15712', '27', '507');
INSERT INTO public.who_global_data_import VALUES (38509, '2020-04-20', 'IN', 'India', 'SEARO', '1553', '17265', '36', '543');
INSERT INTO public.who_global_data_import VALUES (38510, '2020-04-21', 'IN', 'India', 'SEARO', '1336', '18601', '47', '590');
INSERT INTO public.who_global_data_import VALUES (38511, '2020-04-22', 'IN', 'India', 'SEARO', '1383', '19984', '50', '640');
INSERT INTO public.who_global_data_import VALUES (38512, '2020-04-23', 'IN', 'India', 'SEARO', '1409', '21393', '41', '681');
INSERT INTO public.who_global_data_import VALUES (38513, '2020-04-24', 'IN', 'India', 'SEARO', '1684', '23077', '37', '718');
INSERT INTO public.who_global_data_import VALUES (38514, '2020-04-25', 'IN', 'India', 'SEARO', '1429', '24506', '57', '775');
INSERT INTO public.who_global_data_import VALUES (38515, '2020-04-26', 'IN', 'India', 'SEARO', '1990', '26496', '49', '824');
INSERT INTO public.who_global_data_import VALUES (38516, '2020-04-27', 'IN', 'India', 'SEARO', '1396', '27892', '48', '872');
INSERT INTO public.who_global_data_import VALUES (38517, '2020-04-28', 'IN', 'India', 'SEARO', '1543', '29435', '62', '934');
INSERT INTO public.who_global_data_import VALUES (38518, '2020-04-29', 'IN', 'India', 'SEARO', '1897', '31332', '73', '1007');
INSERT INTO public.who_global_data_import VALUES (38519, '2020-04-30', 'IN', 'India', 'SEARO', '1718', '33050', '67', '1074');
INSERT INTO public.who_global_data_import VALUES (38520, '2020-05-01', 'IN', 'India', 'SEARO', '1993', '35043', '73', '1147');
INSERT INTO public.who_global_data_import VALUES (38521, '2020-05-02', 'IN', 'India', 'SEARO', '2293', '37336', '71', '1218');
INSERT INTO public.who_global_data_import VALUES (38522, '2020-05-03', 'IN', 'India', 'SEARO', '2644', '39980', '83', '1301');
INSERT INTO public.who_global_data_import VALUES (38523, '2020-05-04', 'IN', 'India', 'SEARO', '2553', '42533', '72', '1373');
INSERT INTO public.who_global_data_import VALUES (38524, '2020-05-05', 'IN', 'India', 'SEARO', '3900', '46433', '195', '1568');
INSERT INTO public.who_global_data_import VALUES (38525, '2020-05-06', 'IN', 'India', 'SEARO', '2958', '49391', '126', '1694');
INSERT INTO public.who_global_data_import VALUES (38526, '2020-05-07', 'IN', 'India', 'SEARO', '3561', '52952', '89', '1783');
INSERT INTO public.who_global_data_import VALUES (38527, '2020-05-08', 'IN', 'India', 'SEARO', '3390', '56342', '103', '1886');
INSERT INTO public.who_global_data_import VALUES (38528, '2020-05-09', 'IN', 'India', 'SEARO', '3320', '59662', '95', '1981');
INSERT INTO public.who_global_data_import VALUES (38529, '2020-05-10', 'IN', 'India', 'SEARO', '3277', '62939', '128', '2109');
INSERT INTO public.who_global_data_import VALUES (38530, '2020-05-11', 'IN', 'India', 'SEARO', '4213', '67152', '97', '2206');
INSERT INTO public.who_global_data_import VALUES (38531, '2020-05-12', 'IN', 'India', 'SEARO', '3604', '70756', '87', '2293');
INSERT INTO public.who_global_data_import VALUES (38532, '2020-05-13', 'IN', 'India', 'SEARO', '3525', '74281', '122', '2415');
INSERT INTO public.who_global_data_import VALUES (38533, '2020-05-14', 'IN', 'India', 'SEARO', '3722', '78003', '134', '2549');
INSERT INTO public.who_global_data_import VALUES (38534, '2020-05-15', 'IN', 'India', 'SEARO', '3967', '81970', '100', '2649');
INSERT INTO public.who_global_data_import VALUES (38535, '2020-05-16', 'IN', 'India', 'SEARO', '3970', '85940', '103', '2752');
INSERT INTO public.who_global_data_import VALUES (38536, '2020-05-17', 'IN', 'India', 'SEARO', '4987', '90927', '120', '2872');
INSERT INTO public.who_global_data_import VALUES (38537, '2020-05-18', 'IN', 'India', 'SEARO', '5242', '96169', '157', '3029');
INSERT INTO public.who_global_data_import VALUES (38538, '2020-05-19', 'IN', 'India', 'SEARO', '4970', '101139', '134', '3163');
INSERT INTO public.who_global_data_import VALUES (38539, '2020-05-20', 'IN', 'India', 'SEARO', '5611', '106750', '140', '3303');
INSERT INTO public.who_global_data_import VALUES (38540, '2020-05-21', 'IN', 'India', 'SEARO', '5609', '112359', '132', '3435');
INSERT INTO public.who_global_data_import VALUES (38541, '2020-05-22', 'IN', 'India', 'SEARO', '6088', '118447', '148', '3583');
INSERT INTO public.who_global_data_import VALUES (38542, '2020-05-23', 'IN', 'India', 'SEARO', '6654', '125101', '137', '3720');
INSERT INTO public.who_global_data_import VALUES (38543, '2020-05-24', 'IN', 'India', 'SEARO', '6767', '131868', '147', '3867');
INSERT INTO public.who_global_data_import VALUES (38544, '2020-05-25', 'IN', 'India', 'SEARO', '6977', '138845', '154', '4021');
INSERT INTO public.who_global_data_import VALUES (38545, '2020-05-26', 'IN', 'India', 'SEARO', '6535', '145380', '146', '4167');
INSERT INTO public.who_global_data_import VALUES (38546, '2020-05-27', 'IN', 'India', 'SEARO', '6387', '151767', '170', '4337');
INSERT INTO public.who_global_data_import VALUES (38547, '2020-05-28', 'IN', 'India', 'SEARO', '6566', '158333', '194', '4531');
INSERT INTO public.who_global_data_import VALUES (38548, '2020-05-29', 'IN', 'India', 'SEARO', '7466', '165799', '175', '4706');
INSERT INTO public.who_global_data_import VALUES (38549, '2020-05-30', 'IN', 'India', 'SEARO', '7964', '173763', '265', '4971');
INSERT INTO public.who_global_data_import VALUES (38550, '2020-05-31', 'IN', 'India', 'SEARO', '8380', '182143', '193', '5164');
INSERT INTO public.who_global_data_import VALUES (38551, '2020-06-01', 'IN', 'India', 'SEARO', '8392', '190535', '230', '5394');
INSERT INTO public.who_global_data_import VALUES (38552, '2020-06-02', 'IN', 'India', 'SEARO', '8171', '198706', '204', '5598');
INSERT INTO public.who_global_data_import VALUES (38553, '2020-06-03', 'IN', 'India', 'SEARO', '8909', '207615', '217', '5815');
INSERT INTO public.who_global_data_import VALUES (38554, '2020-06-04', 'IN', 'India', 'SEARO', '9304', '216919', '260', '6075');
INSERT INTO public.who_global_data_import VALUES (38555, '2020-06-05', 'IN', 'India', 'SEARO', '9851', '226770', '273', '6348');
INSERT INTO public.who_global_data_import VALUES (38556, '2020-06-06', 'IN', 'India', 'SEARO', '9887', '236657', '294', '6642');
INSERT INTO public.who_global_data_import VALUES (38557, '2020-06-07', 'IN', 'India', 'SEARO', '9971', '246628', '287', '6929');
INSERT INTO public.who_global_data_import VALUES (38558, '2020-06-08', 'IN', 'India', 'SEARO', '9983', '256611', '206', '7135');
INSERT INTO public.who_global_data_import VALUES (38559, '2020-06-09', 'IN', 'India', 'SEARO', '9987', '266598', '331', '7466');
INSERT INTO public.who_global_data_import VALUES (38560, '2020-06-10', 'IN', 'India', 'SEARO', '9985', '276583', '279', '7745');
INSERT INTO public.who_global_data_import VALUES (38561, '2020-06-11', 'IN', 'India', 'SEARO', '9996', '286579', '357', '8102');
INSERT INTO public.who_global_data_import VALUES (38562, '2020-06-12', 'IN', 'India', 'SEARO', '10956', '297535', '396', '8498');
INSERT INTO public.who_global_data_import VALUES (38563, '2020-06-13', 'IN', 'India', 'SEARO', '11458', '308993', '386', '8884');
INSERT INTO public.who_global_data_import VALUES (38564, '2020-06-14', 'IN', 'India', 'SEARO', '11929', '320922', '311', '9195');
INSERT INTO public.who_global_data_import VALUES (38565, '2020-06-15', 'IN', 'India', 'SEARO', '11502', '332424', '325', '9520');
INSERT INTO public.who_global_data_import VALUES (38566, '2020-06-16', 'IN', 'India', 'SEARO', '10667', '343091', '380', '9900');
INSERT INTO public.who_global_data_import VALUES (38567, '2020-06-17', 'IN', 'India', 'SEARO', '10974', '354065', '2003', '11903');
INSERT INTO public.who_global_data_import VALUES (38568, '2020-06-18', 'IN', 'India', 'SEARO', '12881', '366946', '334', '12237');
INSERT INTO public.who_global_data_import VALUES (38569, '2020-06-19', 'IN', 'India', 'SEARO', '13586', '380532', '336', '12573');
INSERT INTO public.who_global_data_import VALUES (38570, '2020-06-20', 'IN', 'India', 'SEARO', '14516', '395048', '375', '12948');
INSERT INTO public.who_global_data_import VALUES (38571, '2020-06-21', 'IN', 'India', 'SEARO', '15413', '410461', '306', '13254');
INSERT INTO public.who_global_data_import VALUES (38572, '2020-06-22', 'IN', 'India', 'SEARO', '14821', '425282', '445', '13699');
INSERT INTO public.who_global_data_import VALUES (38573, '2020-06-23', 'IN', 'India', 'SEARO', '14933', '440215', '312', '14011');
INSERT INTO public.who_global_data_import VALUES (38574, '2020-06-24', 'IN', 'India', 'SEARO', '15968', '456183', '465', '14476');
INSERT INTO public.who_global_data_import VALUES (38575, '2020-06-25', 'IN', 'India', 'SEARO', '16922', '473105', '418', '14894');
INSERT INTO public.who_global_data_import VALUES (38576, '2020-06-26', 'IN', 'India', 'SEARO', '17296', '490401', '407', '15301');
INSERT INTO public.who_global_data_import VALUES (38577, '2020-06-27', 'IN', 'India', 'SEARO', '18552', '508953', '384', '15685');
INSERT INTO public.who_global_data_import VALUES (38578, '2020-06-28', 'IN', 'India', 'SEARO', '19906', '528859', '410', '16095');
INSERT INTO public.who_global_data_import VALUES (38579, '2020-06-29', 'IN', 'India', 'SEARO', '19459', '548318', '380', '16475');
INSERT INTO public.who_global_data_import VALUES (38580, '2020-06-30', 'IN', 'India', 'SEARO', '18522', '566840', '418', '16893');
INSERT INTO public.who_global_data_import VALUES (38581, '2020-07-01', 'IN', 'India', 'SEARO', '18653', '585493', '507', '17400');
INSERT INTO public.who_global_data_import VALUES (38582, '2020-07-02', 'IN', 'India', 'SEARO', '19148', '604641', '434', '17834');
INSERT INTO public.who_global_data_import VALUES (38583, '2020-07-03', 'IN', 'India', 'SEARO', '20903', '625544', '379', '18213');
INSERT INTO public.who_global_data_import VALUES (38584, '2020-07-04', 'IN', 'India', 'SEARO', '22771', '648315', '442', '18655');
INSERT INTO public.who_global_data_import VALUES (38585, '2020-07-05', 'IN', 'India', 'SEARO', '24850', '673165', '613', '19268');
INSERT INTO public.who_global_data_import VALUES (38586, '2020-07-06', 'IN', 'India', 'SEARO', '24248', '697413', '425', '19693');
INSERT INTO public.who_global_data_import VALUES (38587, '2020-07-07', 'IN', 'India', 'SEARO', '22252', '719665', '467', '20160');
INSERT INTO public.who_global_data_import VALUES (38588, '2020-07-08', 'IN', 'India', 'SEARO', '22752', '742417', '482', '20642');
INSERT INTO public.who_global_data_import VALUES (38589, '2020-07-09', 'IN', 'India', 'SEARO', '24879', '767296', '487', '21129');
INSERT INTO public.who_global_data_import VALUES (38590, '2020-07-10', 'IN', 'India', 'SEARO', '26506', '793802', '475', '21604');
INSERT INTO public.who_global_data_import VALUES (38591, '2020-07-11', 'IN', 'India', 'SEARO', '27114', '820916', '519', '22123');
INSERT INTO public.who_global_data_import VALUES (38592, '2020-07-12', 'IN', 'India', 'SEARO', '28637', '849553', '551', '22674');
INSERT INTO public.who_global_data_import VALUES (38593, '2020-07-13', 'IN', 'India', 'SEARO', '28701', '878254', '500', '23174');
INSERT INTO public.who_global_data_import VALUES (38594, '2020-07-14', 'IN', 'India', 'SEARO', '28498', '906752', '553', '23727');
INSERT INTO public.who_global_data_import VALUES (38595, '2020-07-15', 'IN', 'India', 'SEARO', '29429', '936181', '582', '24309');
INSERT INTO public.who_global_data_import VALUES (38596, '2020-07-16', 'IN', 'India', 'SEARO', '32695', '968876', '606', '24915');
INSERT INTO public.who_global_data_import VALUES (38597, '2020-07-17', 'IN', 'India', 'SEARO', '34956', '1003832', '687', '25602');
INSERT INTO public.who_global_data_import VALUES (38598, '2020-07-18', 'IN', 'India', 'SEARO', '34884', '1038716', '671', '26273');
INSERT INTO public.who_global_data_import VALUES (38599, '2020-07-19', 'IN', 'India', 'SEARO', '38902', '1077618', '543', '26816');
INSERT INTO public.who_global_data_import VALUES (38600, '2020-07-20', 'IN', 'India', 'SEARO', '40425', '1118043', '681', '27497');
INSERT INTO public.who_global_data_import VALUES (38601, '2020-07-21', 'IN', 'India', 'SEARO', '37148', '1155191', '587', '28084');
INSERT INTO public.who_global_data_import VALUES (38602, '2020-07-22', 'IN', 'India', 'SEARO', '37724', '1192915', '648', '28732');
INSERT INTO public.who_global_data_import VALUES (38603, '2020-07-23', 'IN', 'India', 'SEARO', '45720', '1238635', '1129', '29861');
INSERT INTO public.who_global_data_import VALUES (38604, '2020-07-24', 'IN', 'India', 'SEARO', '49310', '1287945', '740', '30601');
INSERT INTO public.who_global_data_import VALUES (38605, '2020-07-25', 'IN', 'India', 'SEARO', '48916', '1336861', '757', '31358');
INSERT INTO public.who_global_data_import VALUES (38606, '2020-07-26', 'IN', 'India', 'SEARO', '48661', '1385522', '705', '32063');
INSERT INTO public.who_global_data_import VALUES (38607, '2020-07-27', 'IN', 'India', 'SEARO', '49931', '1435453', '708', '32771');
INSERT INTO public.who_global_data_import VALUES (38608, '2020-07-28', 'IN', 'India', 'SEARO', '47703', '1483156', '654', '33425');
INSERT INTO public.who_global_data_import VALUES (38609, '2020-07-29', 'IN', 'India', 'SEARO', '48513', '1531669', '768', '34193');
INSERT INTO public.who_global_data_import VALUES (38610, '2020-07-30', 'IN', 'India', 'SEARO', '52123', '1583792', '775', '34968');
INSERT INTO public.who_global_data_import VALUES (38611, '2020-07-31', 'IN', 'India', 'SEARO', '55078', '1638870', '779', '35747');
INSERT INTO public.who_global_data_import VALUES (38612, '2020-08-01', 'IN', 'India', 'SEARO', '57118', '1695988', '764', '36511');
INSERT INTO public.who_global_data_import VALUES (38613, '2020-08-02', 'IN', 'India', 'SEARO', '54735', '1750723', '853', '37364');
INSERT INTO public.who_global_data_import VALUES (38614, '2020-08-03', 'IN', 'India', 'SEARO', '52972', '1803695', '771', '38135');
INSERT INTO public.who_global_data_import VALUES (38615, '2020-08-04', 'IN', 'India', 'SEARO', '52050', '1855745', '803', '38938');
INSERT INTO public.who_global_data_import VALUES (38616, '2020-08-05', 'IN', 'India', 'SEARO', '52509', '1908254', '857', '39795');
INSERT INTO public.who_global_data_import VALUES (38617, '2020-08-06', 'IN', 'India', 'SEARO', '56282', '1964536', '904', '40699');
INSERT INTO public.who_global_data_import VALUES (38618, '2020-08-07', 'IN', 'India', 'SEARO', '62538', '2027074', '886', '41585');
INSERT INTO public.who_global_data_import VALUES (38619, '2020-08-08', 'IN', 'India', 'SEARO', '61537', '2088611', '933', '42518');
INSERT INTO public.who_global_data_import VALUES (38620, '2020-08-09', 'IN', 'India', 'SEARO', '64399', '2153010', '861', '43379');
INSERT INTO public.who_global_data_import VALUES (38621, '2020-08-10', 'IN', 'India', 'SEARO', '62064', '2215074', '1007', '44386');
INSERT INTO public.who_global_data_import VALUES (38622, '2020-08-11', 'IN', 'India', 'SEARO', '53601', '2268675', '871', '45257');
INSERT INTO public.who_global_data_import VALUES (38623, '2020-08-12', 'IN', 'India', 'SEARO', '60963', '2329638', '834', '46091');
INSERT INTO public.who_global_data_import VALUES (38624, '2020-08-13', 'IN', 'India', 'SEARO', '66999', '2396637', '942', '47033');
INSERT INTO public.who_global_data_import VALUES (38625, '2020-08-14', 'IN', 'India', 'SEARO', '64553', '2461190', '1007', '48040');
INSERT INTO public.who_global_data_import VALUES (38626, '2020-08-15', 'IN', 'India', 'SEARO', '65002', '2526192', '996', '49036');
INSERT INTO public.who_global_data_import VALUES (38627, '2020-08-16', 'IN', 'India', 'SEARO', '63490', '2589682', '944', '49980');
INSERT INTO public.who_global_data_import VALUES (38628, '2020-08-17', 'IN', 'India', 'SEARO', '57981', '2647663', '941', '50921');
INSERT INTO public.who_global_data_import VALUES (38629, '2020-08-18', 'IN', 'India', 'SEARO', '55079', '2702742', '876', '51797');
INSERT INTO public.who_global_data_import VALUES (38630, '2020-08-19', 'IN', 'India', 'SEARO', '64531', '2767273', '1092', '52889');
INSERT INTO public.who_global_data_import VALUES (38631, '2020-08-20', 'IN', 'India', 'SEARO', '69652', '2836925', '977', '53866');
INSERT INTO public.who_global_data_import VALUES (38632, '2020-08-21', 'IN', 'India', 'SEARO', '68898', '2905823', '983', '54849');
INSERT INTO public.who_global_data_import VALUES (38633, '2020-08-22', 'IN', 'India', 'SEARO', '69878', '2975701', '945', '55794');
INSERT INTO public.who_global_data_import VALUES (38634, '2020-08-23', 'IN', 'India', 'SEARO', '69239', '3044940', '912', '56706');
INSERT INTO public.who_global_data_import VALUES (38635, '2020-08-24', 'IN', 'India', 'SEARO', '61408', '3106348', '836', '57542');
INSERT INTO public.who_global_data_import VALUES (38636, '2020-08-25', 'IN', 'India', 'SEARO', '60975', '3167323', '848', '58390');
INSERT INTO public.who_global_data_import VALUES (38637, '2020-08-26', 'IN', 'India', 'SEARO', '67151', '3234474', '1059', '59449');
INSERT INTO public.who_global_data_import VALUES (38638, '2020-08-27', 'IN', 'India', 'SEARO', '75760', '3310234', '1023', '60472');
INSERT INTO public.who_global_data_import VALUES (38639, '2020-08-28', 'IN', 'India', 'SEARO', '77266', '3387500', '1057', '61529');
INSERT INTO public.who_global_data_import VALUES (38640, '2020-08-29', 'IN', 'India', 'SEARO', '76472', '3463972', '1021', '62550');
INSERT INTO public.who_global_data_import VALUES (38641, '2020-08-30', 'IN', 'India', 'SEARO', '78761', '3542733', '948', '63498');
INSERT INTO public.who_global_data_import VALUES (38642, '2020-08-31', 'IN', 'India', 'SEARO', '78512', '3621245', '971', '64469');
INSERT INTO public.who_global_data_import VALUES (38643, '2020-09-01', 'IN', 'India', 'SEARO', '69921', '3691166', '819', '65288');
INSERT INTO public.who_global_data_import VALUES (38644, '2020-09-02', 'IN', 'India', 'SEARO', '78357', '3769523', '1045', '66333');
INSERT INTO public.who_global_data_import VALUES (38645, '2020-09-03', 'IN', 'India', 'SEARO', '83883', '3853406', '1043', '67376');
INSERT INTO public.who_global_data_import VALUES (38646, '2020-09-04', 'IN', 'India', 'SEARO', '83341', '3936747', '1096', '68472');
INSERT INTO public.who_global_data_import VALUES (38647, '2020-09-05', 'IN', 'India', 'SEARO', '86432', '4023179', '1089', '69561');
INSERT INTO public.who_global_data_import VALUES (38648, '2020-09-06', 'IN', 'India', 'SEARO', '90632', '4113811', '1065', '70626');
INSERT INTO public.who_global_data_import VALUES (38649, '2020-09-07', 'IN', 'India', 'SEARO', '90802', '4204613', '1016', '71642');
INSERT INTO public.who_global_data_import VALUES (38650, '2020-09-08', 'IN', 'India', 'SEARO', '75809', '4280422', '1133', '72775');
INSERT INTO public.who_global_data_import VALUES (38651, '2020-09-09', 'IN', 'India', 'SEARO', '89706', '4370128', '1115', '73890');
INSERT INTO public.who_global_data_import VALUES (38652, '2020-09-10', 'IN', 'India', 'SEARO', '95735', '4465863', '1172', '75062');
INSERT INTO public.who_global_data_import VALUES (38653, '2020-09-11', 'IN', 'India', 'SEARO', '96551', '4562414', '1209', '76271');
INSERT INTO public.who_global_data_import VALUES (38654, '2020-09-12', 'IN', 'India', 'SEARO', '97570', '4659984', '1201', '77472');
INSERT INTO public.who_global_data_import VALUES (38655, '2020-09-13', 'IN', 'India', 'SEARO', '94372', '4754356', '1114', '78586');
INSERT INTO public.who_global_data_import VALUES (38656, '2020-09-14', 'IN', 'India', 'SEARO', '92071', '4846427', '1136', '79722');
INSERT INTO public.who_global_data_import VALUES (38657, '2020-09-15', 'IN', 'India', 'SEARO', '83809', '4930236', '1054', '80776');
INSERT INTO public.who_global_data_import VALUES (38658, '2020-09-16', 'IN', 'India', 'SEARO', '90123', '5020359', '1290', '82066');
INSERT INTO public.who_global_data_import VALUES (38659, '2020-09-17', 'IN', 'India', 'SEARO', '97894', '5118253', '1132', '83198');
INSERT INTO public.who_global_data_import VALUES (38660, '2020-09-18', 'IN', 'India', 'SEARO', '96424', '5214677', '1174', '84372');
INSERT INTO public.who_global_data_import VALUES (38661, '2020-09-19', 'IN', 'India', 'SEARO', '93337', '5308014', '1247', '85619');
INSERT INTO public.who_global_data_import VALUES (38662, '2020-09-20', 'IN', 'India', 'SEARO', '92605', '5400619', '1133', '86752');
INSERT INTO public.who_global_data_import VALUES (38663, '2020-09-21', 'IN', 'India', 'SEARO', '86961', '5487580', '1130', '87882');
INSERT INTO public.who_global_data_import VALUES (38664, '2020-09-22', 'IN', 'India', 'SEARO', '75083', '5562663', '1053', '88935');
INSERT INTO public.who_global_data_import VALUES (38665, '2020-09-23', 'IN', 'India', 'SEARO', '83347', '5646010', '1085', '90020');
INSERT INTO public.who_global_data_import VALUES (38666, '2020-09-24', 'IN', 'India', 'SEARO', '86508', '5732518', '1129', '91149');
INSERT INTO public.who_global_data_import VALUES (38667, '2020-09-25', 'IN', 'India', 'SEARO', '86052', '5818570', '1141', '92290');
INSERT INTO public.who_global_data_import VALUES (38668, '2020-09-26', 'IN', 'India', 'SEARO', '85362', '5903932', '1089', '93379');
INSERT INTO public.who_global_data_import VALUES (38669, '2020-09-27', 'IN', 'India', 'SEARO', '88600', '5992532', '1124', '94503');
INSERT INTO public.who_global_data_import VALUES (38670, '2020-09-28', 'IN', 'India', 'SEARO', '82170', '6074702', '1039', '95542');
INSERT INTO public.who_global_data_import VALUES (38671, '2020-09-29', 'IN', 'India', 'SEARO', '70589', '6145291', '776', '96318');
INSERT INTO public.who_global_data_import VALUES (38672, '2020-09-30', 'IN', 'India', 'SEARO', '80472', '6225763', '1179', '97497');
INSERT INTO public.who_global_data_import VALUES (38673, '2020-10-01', 'IN', 'India', 'SEARO', '86821', '6312584', '1181', '98678');
INSERT INTO public.who_global_data_import VALUES (38674, '2020-10-02', 'IN', 'India', 'SEARO', '81484', '6394068', '1095', '99773');
INSERT INTO public.who_global_data_import VALUES (38675, '2020-10-03', 'IN', 'India', 'SEARO', '79476', '6473544', '1069', '100842');
INSERT INTO public.who_global_data_import VALUES (38676, '2020-10-04', 'IN', 'India', 'SEARO', '75829', '6549373', '940', '101782');
INSERT INTO public.who_global_data_import VALUES (38677, '2020-10-05', 'IN', 'India', 'SEARO', '74442', '6623815', '903', '102685');
INSERT INTO public.who_global_data_import VALUES (38678, '2020-10-06', 'IN', 'India', 'SEARO', '61267', '6685082', '884', '103569');
INSERT INTO public.who_global_data_import VALUES (38679, '2020-10-07', 'IN', 'India', 'SEARO', '72049', '6757131', '986', '104555');
INSERT INTO public.who_global_data_import VALUES (38680, '2020-10-08', 'IN', 'India', 'SEARO', '78524', '6835655', '971', '105526');
INSERT INTO public.who_global_data_import VALUES (38681, '2020-10-09', 'IN', 'India', 'SEARO', '70496', '6906151', '964', '106490');
INSERT INTO public.who_global_data_import VALUES (38682, '2020-10-10', 'IN', 'India', 'SEARO', '73272', '6979423', '926', '107416');
INSERT INTO public.who_global_data_import VALUES (38683, '2020-10-11', 'IN', 'India', 'SEARO', '74383', '7053806', '918', '108334');
INSERT INTO public.who_global_data_import VALUES (38684, '2020-10-12', 'IN', 'India', 'SEARO', '66732', '7120538', '816', '109150');
INSERT INTO public.who_global_data_import VALUES (38685, '2020-10-13', 'IN', 'India', 'SEARO', '55342', '7175880', '706', '109856');
INSERT INTO public.who_global_data_import VALUES (38686, '2020-10-14', 'IN', 'India', 'SEARO', '63509', '7239389', '730', '110586');
INSERT INTO public.who_global_data_import VALUES (38687, '2020-10-15', 'IN', 'India', 'SEARO', '67708', '7307097', '680', '111266');
INSERT INTO public.who_global_data_import VALUES (38688, '2020-10-16', 'IN', 'India', 'SEARO', '63371', '7370468', '895', '112161');
INSERT INTO public.who_global_data_import VALUES (38689, '2020-10-17', 'IN', 'India', 'SEARO', '62212', '7432680', '837', '112998');
INSERT INTO public.who_global_data_import VALUES (38690, '2020-10-18', 'IN', 'India', 'SEARO', '61871', '7494551', '1033', '114031');
INSERT INTO public.who_global_data_import VALUES (38691, '2020-10-19', 'IN', 'India', 'SEARO', '55722', '7550273', '579', '114610');
INSERT INTO public.who_global_data_import VALUES (38692, '2020-10-20', 'IN', 'India', 'SEARO', '46790', '7597063', '587', '115197');
INSERT INTO public.who_global_data_import VALUES (38693, '2020-10-21', 'IN', 'India', 'SEARO', '54044', '7651107', '717', '115914');
INSERT INTO public.who_global_data_import VALUES (38694, '2020-10-22', 'IN', 'India', 'SEARO', '55839', '7706946', '702', '116616');
INSERT INTO public.who_global_data_import VALUES (38695, '2020-10-23', 'IN', 'India', 'SEARO', '54366', '7761312', '690', '117306');
INSERT INTO public.who_global_data_import VALUES (38696, '2020-10-24', 'IN', 'India', 'SEARO', '53370', '7814682', '650', '117956');
INSERT INTO public.who_global_data_import VALUES (38697, '2020-10-25', 'IN', 'India', 'SEARO', '50129', '7864811', '578', '118534');
INSERT INTO public.who_global_data_import VALUES (38698, '2020-10-26', 'IN', 'India', 'SEARO', '45148', '7909959', '480', '119014');
INSERT INTO public.who_global_data_import VALUES (38699, '2020-10-27', 'IN', 'India', 'SEARO', '36470', '7946429', '488', '119502');
INSERT INTO public.who_global_data_import VALUES (38700, '2020-10-28', 'IN', 'India', 'SEARO', '43893', '7990322', '508', '120010');
INSERT INTO public.who_global_data_import VALUES (38701, '2020-10-29', 'IN', 'India', 'SEARO', '49881', '8040203', '517', '120527');
INSERT INTO public.who_global_data_import VALUES (38702, '2020-10-30', 'IN', 'India', 'SEARO', '48648', '8088851', '563', '121090');
INSERT INTO public.who_global_data_import VALUES (38703, '2020-10-31', 'IN', 'India', 'SEARO', '48268', '8137119', '551', '121641');
INSERT INTO public.who_global_data_import VALUES (38704, '2020-11-01', 'IN', 'India', 'SEARO', '46963', '8184082', '470', '122111');
INSERT INTO public.who_global_data_import VALUES (38705, '2020-11-02', 'IN', 'India', 'SEARO', '45231', '8229313', '496', '122607');
INSERT INTO public.who_global_data_import VALUES (38706, '2020-11-03', 'IN', 'India', 'SEARO', '38310', '8267623', '490', '123097');
INSERT INTO public.who_global_data_import VALUES (38707, '2020-11-04', 'IN', 'India', 'SEARO', '46253', '8313876', '514', '123611');
INSERT INTO public.who_global_data_import VALUES (38708, '2020-11-05', 'IN', 'India', 'SEARO', '50210', '8364086', '704', '124315');
INSERT INTO public.who_global_data_import VALUES (38709, '2020-11-06', 'IN', 'India', 'SEARO', '47638', '8411724', '670', '124985');
INSERT INTO public.who_global_data_import VALUES (38710, '2020-11-07', 'IN', 'India', 'SEARO', '50356', '8462080', '577', '125562');
INSERT INTO public.who_global_data_import VALUES (38711, '2020-11-08', 'IN', 'India', 'SEARO', '45674', '8507754', '559', '126121');
INSERT INTO public.who_global_data_import VALUES (38712, '2020-11-09', 'IN', 'India', 'SEARO', '45903', '8553657', '490', '126611');
INSERT INTO public.who_global_data_import VALUES (38713, '2020-11-10', 'IN', 'India', 'SEARO', '38073', '8591730', '448', '127059');
INSERT INTO public.who_global_data_import VALUES (38714, '2020-11-11', 'IN', 'India', 'SEARO', '44281', '8636011', '512', '127571');
INSERT INTO public.who_global_data_import VALUES (38715, '2020-11-12', 'IN', 'India', 'SEARO', '47905', '8683916', '550', '128121');
INSERT INTO public.who_global_data_import VALUES (38716, '2020-11-13', 'IN', 'India', 'SEARO', '44879', '8728795', '547', '128668');
INSERT INTO public.who_global_data_import VALUES (38717, '2020-11-14', 'IN', 'India', 'SEARO', '44684', '8773479', '520', '129188');
INSERT INTO public.who_global_data_import VALUES (38718, '2020-11-15', 'IN', 'India', 'SEARO', '41100', '8814579', '447', '129635');
INSERT INTO public.who_global_data_import VALUES (38719, '2020-11-16', 'IN', 'India', 'SEARO', '30548', '8845127', '435', '130070');
INSERT INTO public.who_global_data_import VALUES (38720, '2020-11-17', 'IN', 'India', 'SEARO', '29163', '8874290', '449', '130519');
INSERT INTO public.who_global_data_import VALUES (38721, '2020-11-18', 'IN', 'India', 'SEARO', '38617', '8912907', '474', '130993');
INSERT INTO public.who_global_data_import VALUES (38722, '2020-11-19', 'IN', 'India', 'SEARO', '45576', '8958483', '585', '131578');
INSERT INTO public.who_global_data_import VALUES (38723, '2020-11-20', 'IN', 'India', 'SEARO', '45882', '9004365', '584', '132162');
INSERT INTO public.who_global_data_import VALUES (38724, '2020-11-21', 'IN', 'India', 'SEARO', '46232', '9050597', '564', '132726');
INSERT INTO public.who_global_data_import VALUES (38725, '2020-11-22', 'IN', 'India', 'SEARO', '45209', '9095806', '501', '133227');
INSERT INTO public.who_global_data_import VALUES (38726, '2020-11-23', 'IN', 'India', 'SEARO', '44059', '9139865', '511', '133738');
INSERT INTO public.who_global_data_import VALUES (38727, '2020-11-24', 'IN', 'India', 'SEARO', '37975', '9177840', '480', '134218');
INSERT INTO public.who_global_data_import VALUES (38728, '2020-11-25', 'IN', 'India', 'SEARO', '44376', '9222216', '481', '134699');
INSERT INTO public.who_global_data_import VALUES (38729, '2020-11-26', 'IN', 'India', 'SEARO', '44489', '9266705', '524', '135223');
INSERT INTO public.who_global_data_import VALUES (38730, '2020-11-27', 'IN', 'India', 'SEARO', '43082', '9309787', '492', '135715');
INSERT INTO public.who_global_data_import VALUES (38731, '2020-11-28', 'IN', 'India', 'SEARO', '41322', '9351109', '485', '136200');
INSERT INTO public.who_global_data_import VALUES (38732, '2020-11-29', 'IN', 'India', 'SEARO', '41810', '9392919', '496', '136696');
INSERT INTO public.who_global_data_import VALUES (38733, '2020-11-30', 'IN', 'India', 'SEARO', '38772', '9431691', '443', '137139');
INSERT INTO public.who_global_data_import VALUES (38734, '2020-12-01', 'IN', 'India', 'SEARO', '31118', '9462809', '482', '137621');
INSERT INTO public.who_global_data_import VALUES (38735, '2020-12-02', 'IN', 'India', 'SEARO', '36604', '9499413', '501', '138122');
INSERT INTO public.who_global_data_import VALUES (38736, '2020-12-03', 'IN', 'India', 'SEARO', '35551', '9534964', '526', '138648');
INSERT INTO public.who_global_data_import VALUES (38737, '2020-12-04', 'IN', 'India', 'SEARO', '36595', '9571559', '540', '139188');
INSERT INTO public.who_global_data_import VALUES (38738, '2020-12-05', 'IN', 'India', 'SEARO', '36652', '9608211', '512', '139700');
INSERT INTO public.who_global_data_import VALUES (38739, '2020-12-06', 'IN', 'India', 'SEARO', '36011', '9644222', '482', '140182');
INSERT INTO public.who_global_data_import VALUES (38740, '2020-12-07', 'IN', 'India', 'SEARO', '32981', '9677203', '391', '140573');
INSERT INTO public.who_global_data_import VALUES (38741, '2020-12-08', 'IN', 'India', 'SEARO', '26567', '9703770', '385', '140958');
INSERT INTO public.who_global_data_import VALUES (38742, '2020-12-09', 'IN', 'India', 'SEARO', '32080', '9735850', '402', '141360');
INSERT INTO public.who_global_data_import VALUES (38743, '2020-12-10', 'IN', 'India', 'SEARO', '31521', '9767371', '412', '141772');
INSERT INTO public.who_global_data_import VALUES (38744, '2020-12-11', 'IN', 'India', 'SEARO', '29398', '9796769', '414', '142186');
INSERT INTO public.who_global_data_import VALUES (38745, '2020-12-12', 'IN', 'India', 'SEARO', '30006', '9826775', '442', '142628');
INSERT INTO public.who_global_data_import VALUES (38746, '2020-12-13', 'IN', 'India', 'SEARO', '30254', '9857029', '391', '143019');
INSERT INTO public.who_global_data_import VALUES (38747, '2020-12-14', 'IN', 'India', 'SEARO', '27071', '9884100', '336', '143355');
INSERT INTO public.who_global_data_import VALUES (38748, '2020-12-15', 'IN', 'India', 'SEARO', '22065', '9906165', '354', '143709');
INSERT INTO public.who_global_data_import VALUES (38749, '2020-12-16', 'IN', 'India', 'SEARO', '26382', '9932547', '387', '144096');
INSERT INTO public.who_global_data_import VALUES (38750, '2020-12-17', 'IN', 'India', 'SEARO', '24010', '9956557', '355', '144451');
INSERT INTO public.who_global_data_import VALUES (38751, '2020-12-18', 'IN', 'India', 'SEARO', '22890', '9979447', '338', '144789');
INSERT INTO public.who_global_data_import VALUES (38752, '2020-12-19', 'IN', 'India', 'SEARO', '25152', '10004599', '347', '145136');
INSERT INTO public.who_global_data_import VALUES (38753, '2020-12-20', 'IN', 'India', 'SEARO', '26624', '10031223', '341', '145477');
INSERT INTO public.who_global_data_import VALUES (38754, '2020-12-21', 'IN', 'India', 'SEARO', '24337', '10055560', '333', '145810');
INSERT INTO public.who_global_data_import VALUES (38755, '2020-12-22', 'IN', 'India', 'SEARO', '19556', '10075116', '301', '146111');
INSERT INTO public.who_global_data_import VALUES (38756, '2020-12-23', 'IN', 'India', 'SEARO', '23950', '10099066', '333', '146444');
INSERT INTO public.who_global_data_import VALUES (38757, '2020-12-24', 'IN', 'India', 'SEARO', '24712', '10123778', '312', '146756');
INSERT INTO public.who_global_data_import VALUES (38758, '2020-12-25', 'IN', 'India', 'SEARO', '23067', '10146845', '336', '147092');
INSERT INTO public.who_global_data_import VALUES (38759, '2020-12-26', 'IN', 'India', 'SEARO', '22273', '10169118', '251', '147343');
INSERT INTO public.who_global_data_import VALUES (38760, '2020-12-27', 'IN', 'India', 'SEARO', '18732', '10187850', '279', '147622');
INSERT INTO public.who_global_data_import VALUES (38761, '2020-12-28', 'IN', 'India', 'SEARO', '20021', '10207871', '279', '147901');
INSERT INTO public.who_global_data_import VALUES (38762, '2020-12-29', 'IN', 'India', 'SEARO', '16432', '10224303', '252', '148153');
INSERT INTO public.who_global_data_import VALUES (38763, '2020-12-30', 'IN', 'India', 'SEARO', '20549', '10244852', '286', '148439');
INSERT INTO public.who_global_data_import VALUES (38764, '2020-12-31', 'IN', 'India', 'SEARO', '21822', '10266674', '299', '148738');
INSERT INTO public.who_global_data_import VALUES (38765, '2021-01-01', 'IN', 'India', 'SEARO', '20035', '10286709', '256', '148994');
INSERT INTO public.who_global_data_import VALUES (38766, '2021-01-02', 'IN', 'India', 'SEARO', '19079', '10305788', '224', '149218');
INSERT INTO public.who_global_data_import VALUES (38767, '2021-01-03', 'IN', 'India', 'SEARO', '18177', '10323965', '217', '149435');
INSERT INTO public.who_global_data_import VALUES (38768, '2021-01-04', 'IN', 'India', 'SEARO', '16504', '10340469', '214', '149649');
INSERT INTO public.who_global_data_import VALUES (38769, '2021-01-05', 'IN', 'India', 'SEARO', '16375', '10356844', '201', '149850');
INSERT INTO public.who_global_data_import VALUES (38770, '2021-01-06', 'IN', 'India', 'SEARO', '18088', '10374932', '264', '150114');
INSERT INTO public.who_global_data_import VALUES (38771, '2021-01-07', 'IN', 'India', 'SEARO', '20346', '10395278', '222', '150336');
INSERT INTO public.who_global_data_import VALUES (38772, '2021-01-08', 'IN', 'India', 'SEARO', '18139', '10413417', '234', '150570');
INSERT INTO public.who_global_data_import VALUES (38773, '2021-01-09', 'IN', 'India', 'SEARO', '0', '10413417', '0', '150570');
INSERT INTO public.who_global_data_import VALUES (38774, '2021-01-10', 'IN', 'India', 'SEARO', '36867', '10450284', '429', '150999');
INSERT INTO public.who_global_data_import VALUES (38775, '2021-01-11', 'IN', 'India', 'SEARO', '16311', '10466595', '161', '151160');
INSERT INTO public.who_global_data_import VALUES (38776, '2021-01-12', 'IN', 'India', 'SEARO', '12584', '10479179', '167', '151327');
INSERT INTO public.who_global_data_import VALUES (38777, '2021-01-13', 'IN', 'India', 'SEARO', '15968', '10495147', '202', '151529');
INSERT INTO public.who_global_data_import VALUES (38778, '2021-01-14', 'IN', 'India', 'SEARO', '16946', '10512093', '198', '151727');
INSERT INTO public.who_global_data_import VALUES (38779, '2021-01-15', 'IN', 'India', 'SEARO', '15590', '10527683', '191', '151918');
INSERT INTO public.who_global_data_import VALUES (38780, '2021-01-16', 'IN', 'India', 'SEARO', '15158', '10542841', '175', '152093');
INSERT INTO public.who_global_data_import VALUES (38781, '2021-01-17', 'IN', 'India', 'SEARO', '15144', '10557985', '181', '152274');
INSERT INTO public.who_global_data_import VALUES (38782, '2021-01-18', 'IN', 'India', 'SEARO', '13788', '10571773', '145', '152419');
INSERT INTO public.who_global_data_import VALUES (38783, '2021-01-19', 'IN', 'India', 'SEARO', '10064', '10581837', '137', '152556');
INSERT INTO public.who_global_data_import VALUES (38784, '2021-01-20', 'IN', 'India', 'SEARO', '13823', '10595660', '162', '152718');
INSERT INTO public.who_global_data_import VALUES (38785, '2021-01-21', 'IN', 'India', 'SEARO', '15223', '10610883', '151', '152869');
INSERT INTO public.who_global_data_import VALUES (38786, '2021-01-22', 'IN', 'India', 'SEARO', '14545', '10625428', '163', '153032');
INSERT INTO public.who_global_data_import VALUES (38787, '2021-01-23', 'IN', 'India', 'SEARO', '14256', '10639684', '152', '153184');
INSERT INTO public.who_global_data_import VALUES (38788, '2021-01-24', 'IN', 'India', 'SEARO', '14849', '10654533', '155', '153339');
INSERT INTO public.who_global_data_import VALUES (38789, '2021-01-25', 'IN', 'India', 'SEARO', '13203', '10667736', '131', '153470');
INSERT INTO public.who_global_data_import VALUES (38790, '2021-01-26', 'IN', 'India', 'SEARO', '9102', '10676838', '117', '153587');
INSERT INTO public.who_global_data_import VALUES (38791, '2021-01-27', 'IN', 'India', 'SEARO', '12689', '10689527', '137', '153724');
INSERT INTO public.who_global_data_import VALUES (38792, '2021-01-28', 'IN', 'India', 'SEARO', '11666', '10701193', '123', '153847');
INSERT INTO public.who_global_data_import VALUES (38793, '2021-01-29', 'IN', 'India', 'SEARO', '18855', '10720048', '163', '154010');
INSERT INTO public.who_global_data_import VALUES (38794, '2021-01-30', 'IN', 'India', 'SEARO', '13083', '10733131', '137', '154147');
INSERT INTO public.who_global_data_import VALUES (38795, '2021-01-31', 'IN', 'India', 'SEARO', '13052', '10746183', '127', '154274');
INSERT INTO public.who_global_data_import VALUES (38796, '2021-02-01', 'IN', 'India', 'SEARO', '11427', '10757610', '118', '154392');
INSERT INTO public.who_global_data_import VALUES (38797, '2021-02-02', 'IN', 'India', 'SEARO', '8635', '10766245', '94', '154486');
INSERT INTO public.who_global_data_import VALUES (38798, '2021-02-03', 'IN', 'India', 'SEARO', '11039', '10777284', '110', '154596');
INSERT INTO public.who_global_data_import VALUES (38799, '2021-02-04', 'IN', 'India', 'SEARO', '12899', '10790183', '107', '154703');
INSERT INTO public.who_global_data_import VALUES (38800, '2021-02-05', 'IN', 'India', 'SEARO', '12408', '10802591', '120', '154823');
INSERT INTO public.who_global_data_import VALUES (38801, '2020-01-03', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38802, '2020-01-04', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38803, '2020-01-05', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38804, '2020-01-06', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38805, '2020-01-07', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38806, '2020-01-08', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38807, '2020-01-09', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38808, '2020-01-10', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38809, '2020-01-11', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38810, '2020-01-12', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38811, '2020-01-13', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38812, '2020-01-14', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38813, '2020-01-15', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38814, '2020-01-16', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38815, '2020-01-17', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38816, '2020-01-18', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38817, '2020-01-19', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38818, '2020-01-20', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38819, '2020-01-21', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38820, '2020-01-22', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38821, '2020-01-23', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38822, '2020-01-24', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38823, '2020-01-25', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38824, '2020-01-26', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38825, '2020-01-27', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38826, '2020-01-28', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38827, '2020-01-29', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38828, '2020-01-30', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38829, '2020-01-31', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38830, '2020-02-01', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38831, '2020-02-02', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38832, '2020-02-03', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38833, '2020-02-04', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38834, '2020-02-05', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38835, '2020-02-06', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38836, '2020-02-07', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38837, '2020-02-08', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38838, '2020-02-09', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38839, '2020-02-10', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38840, '2020-02-11', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38841, '2020-02-12', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38842, '2020-02-13', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38843, '2020-02-14', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38844, '2020-02-15', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38845, '2020-02-16', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38846, '2020-02-17', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38847, '2020-02-18', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38848, '2020-02-19', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38849, '2020-02-20', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38850, '2020-02-21', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38851, '2020-02-22', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38852, '2020-02-23', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38853, '2020-02-24', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38854, '2020-02-25', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38855, '2020-02-26', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38856, '2020-02-27', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38857, '2020-02-28', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38858, '2020-02-29', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38859, '2020-03-01', 'ID', 'Indonesia', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38860, '2020-03-02', 'ID', 'Indonesia', 'SEARO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38861, '2020-03-03', 'ID', 'Indonesia', 'SEARO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38862, '2020-03-04', 'ID', 'Indonesia', 'SEARO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38863, '2020-03-05', 'ID', 'Indonesia', 'SEARO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38864, '2020-03-06', 'ID', 'Indonesia', 'SEARO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38865, '2020-03-07', 'ID', 'Indonesia', 'SEARO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38866, '2020-03-08', 'ID', 'Indonesia', 'SEARO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38867, '2020-03-09', 'ID', 'Indonesia', 'SEARO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38868, '2020-03-10', 'ID', 'Indonesia', 'SEARO', '13', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (38869, '2020-03-11', 'ID', 'Indonesia', 'SEARO', '8', '31', '1', '1');
INSERT INTO public.who_global_data_import VALUES (38870, '2020-03-12', 'ID', 'Indonesia', 'SEARO', '7', '38', '0', '1');
INSERT INTO public.who_global_data_import VALUES (38871, '2020-03-13', 'ID', 'Indonesia', 'SEARO', '35', '73', '3', '4');
INSERT INTO public.who_global_data_import VALUES (38872, '2020-03-14', 'ID', 'Indonesia', 'SEARO', '0', '73', '0', '4');
INSERT INTO public.who_global_data_import VALUES (38873, '2020-03-15', 'ID', 'Indonesia', 'SEARO', '48', '121', '0', '4');
INSERT INTO public.who_global_data_import VALUES (38874, '2020-03-16', 'ID', 'Indonesia', 'SEARO', '55', '176', '1', '5');
INSERT INTO public.who_global_data_import VALUES (38875, '2020-03-17', 'ID', 'Indonesia', 'SEARO', '0', '176', '0', '5');
INSERT INTO public.who_global_data_import VALUES (38876, '2020-03-18', 'ID', 'Indonesia', 'SEARO', '55', '231', '14', '19');
INSERT INTO public.who_global_data_import VALUES (38877, '2020-03-19', 'ID', 'Indonesia', 'SEARO', '78', '309', '6', '25');
INSERT INTO public.who_global_data_import VALUES (38878, '2020-03-20', 'ID', 'Indonesia', 'SEARO', '60', '369', '7', '32');
INSERT INTO public.who_global_data_import VALUES (38879, '2020-03-21', 'ID', 'Indonesia', 'SEARO', '81', '450', '6', '38');
INSERT INTO public.who_global_data_import VALUES (38880, '2020-03-22', 'ID', 'Indonesia', 'SEARO', '64', '514', '10', '48');
INSERT INTO public.who_global_data_import VALUES (38881, '2020-03-23', 'ID', 'Indonesia', 'SEARO', '65', '579', '1', '49');
INSERT INTO public.who_global_data_import VALUES (38882, '2020-03-24', 'ID', 'Indonesia', 'SEARO', '0', '579', '0', '49');
INSERT INTO public.who_global_data_import VALUES (38883, '2020-03-25', 'ID', 'Indonesia', 'SEARO', '211', '790', '9', '58');
INSERT INTO public.who_global_data_import VALUES (38884, '2020-03-26', 'ID', 'Indonesia', 'SEARO', '103', '893', '20', '78');
INSERT INTO public.who_global_data_import VALUES (38885, '2020-03-27', 'ID', 'Indonesia', 'SEARO', '153', '1046', '9', '87');
INSERT INTO public.who_global_data_import VALUES (38886, '2020-03-28', 'ID', 'Indonesia', 'SEARO', '0', '1046', '0', '87');
INSERT INTO public.who_global_data_import VALUES (38887, '2020-03-29', 'ID', 'Indonesia', 'SEARO', '239', '1285', '27', '114');
INSERT INTO public.who_global_data_import VALUES (38888, '2020-03-30', 'ID', 'Indonesia', 'SEARO', '129', '1414', '8', '122');
INSERT INTO public.who_global_data_import VALUES (38889, '2020-03-31', 'ID', 'Indonesia', 'SEARO', '114', '1528', '14', '136');
INSERT INTO public.who_global_data_import VALUES (38890, '2020-04-01', 'ID', 'Indonesia', 'SEARO', '149', '1677', '21', '157');
INSERT INTO public.who_global_data_import VALUES (38891, '2020-04-02', 'ID', 'Indonesia', 'SEARO', '113', '1790', '13', '170');
INSERT INTO public.who_global_data_import VALUES (38892, '2020-04-03', 'ID', 'Indonesia', 'SEARO', '196', '1986', '11', '181');
INSERT INTO public.who_global_data_import VALUES (38893, '2020-04-04', 'ID', 'Indonesia', 'SEARO', '106', '2092', '10', '191');
INSERT INTO public.who_global_data_import VALUES (38894, '2020-04-05', 'ID', 'Indonesia', 'SEARO', '181', '2273', '7', '198');
INSERT INTO public.who_global_data_import VALUES (38895, '2020-04-06', 'ID', 'Indonesia', 'SEARO', '218', '2491', '11', '209');
INSERT INTO public.who_global_data_import VALUES (38896, '2020-04-07', 'ID', 'Indonesia', 'SEARO', '247', '2738', '12', '221');
INSERT INTO public.who_global_data_import VALUES (38897, '2020-04-08', 'ID', 'Indonesia', 'SEARO', '218', '2956', '19', '240');
INSERT INTO public.who_global_data_import VALUES (38898, '2020-04-09', 'ID', 'Indonesia', 'SEARO', '337', '3293', '40', '280');
INSERT INTO public.who_global_data_import VALUES (38899, '2020-04-10', 'ID', 'Indonesia', 'SEARO', '219', '3512', '26', '306');
INSERT INTO public.who_global_data_import VALUES (38900, '2020-04-11', 'ID', 'Indonesia', 'SEARO', '330', '3842', '21', '327');
INSERT INTO public.who_global_data_import VALUES (38901, '2020-04-12', 'ID', 'Indonesia', 'SEARO', '399', '4241', '46', '373');
INSERT INTO public.who_global_data_import VALUES (38902, '2020-04-13', 'ID', 'Indonesia', 'SEARO', '316', '4557', '26', '399');
INSERT INTO public.who_global_data_import VALUES (38903, '2020-04-14', 'ID', 'Indonesia', 'SEARO', '282', '4839', '60', '459');
INSERT INTO public.who_global_data_import VALUES (38904, '2020-04-15', 'ID', 'Indonesia', 'SEARO', '297', '5136', '10', '469');
INSERT INTO public.who_global_data_import VALUES (38905, '2020-04-16', 'ID', 'Indonesia', 'SEARO', '380', '5516', '27', '496');
INSERT INTO public.who_global_data_import VALUES (38906, '2020-04-17', 'ID', 'Indonesia', 'SEARO', '407', '5923', '24', '520');
INSERT INTO public.who_global_data_import VALUES (38907, '2020-04-18', 'ID', 'Indonesia', 'SEARO', '325', '6248', '15', '535');
INSERT INTO public.who_global_data_import VALUES (38908, '2020-04-19', 'ID', 'Indonesia', 'SEARO', '327', '6575', '47', '582');
INSERT INTO public.who_global_data_import VALUES (38909, '2020-04-20', 'ID', 'Indonesia', 'SEARO', '185', '6760', '8', '590');
INSERT INTO public.who_global_data_import VALUES (38910, '2020-04-21', 'ID', 'Indonesia', 'SEARO', '375', '7135', '26', '616');
INSERT INTO public.who_global_data_import VALUES (38911, '2020-04-22', 'ID', 'Indonesia', 'SEARO', '283', '7418', '19', '635');
INSERT INTO public.who_global_data_import VALUES (38912, '2020-04-23', 'ID', 'Indonesia', 'SEARO', '357', '7775', '12', '647');
INSERT INTO public.who_global_data_import VALUES (38913, '2020-04-24', 'ID', 'Indonesia', 'SEARO', '436', '8211', '42', '689');
INSERT INTO public.who_global_data_import VALUES (38914, '2020-04-25', 'ID', 'Indonesia', 'SEARO', '396', '8607', '31', '720');
INSERT INTO public.who_global_data_import VALUES (38915, '2020-04-26', 'ID', 'Indonesia', 'SEARO', '275', '8882', '23', '743');
INSERT INTO public.who_global_data_import VALUES (38916, '2020-04-27', 'ID', 'Indonesia', 'SEARO', '214', '9096', '22', '765');
INSERT INTO public.who_global_data_import VALUES (38917, '2020-04-28', 'ID', 'Indonesia', 'SEARO', '415', '9511', '8', '773');
INSERT INTO public.who_global_data_import VALUES (38918, '2020-04-29', 'ID', 'Indonesia', 'SEARO', '260', '9771', '11', '784');
INSERT INTO public.who_global_data_import VALUES (38919, '2020-04-30', 'ID', 'Indonesia', 'SEARO', '347', '10118', '8', '792');
INSERT INTO public.who_global_data_import VALUES (38920, '2020-05-01', 'ID', 'Indonesia', 'SEARO', '433', '10551', '8', '800');
INSERT INTO public.who_global_data_import VALUES (38921, '2020-05-02', 'ID', 'Indonesia', 'SEARO', '292', '10843', '31', '831');
INSERT INTO public.who_global_data_import VALUES (38922, '2020-05-03', 'ID', 'Indonesia', 'SEARO', '349', '11192', '14', '845');
INSERT INTO public.who_global_data_import VALUES (38923, '2020-05-04', 'ID', 'Indonesia', 'SEARO', '395', '11587', '19', '864');
INSERT INTO public.who_global_data_import VALUES (38924, '2020-05-05', 'ID', 'Indonesia', 'SEARO', '484', '12071', '8', '872');
INSERT INTO public.who_global_data_import VALUES (38925, '2020-05-06', 'ID', 'Indonesia', 'SEARO', '367', '12438', '23', '895');
INSERT INTO public.who_global_data_import VALUES (38926, '2020-05-07', 'ID', 'Indonesia', 'SEARO', '338', '12776', '35', '930');
INSERT INTO public.who_global_data_import VALUES (38927, '2020-05-08', 'ID', 'Indonesia', 'SEARO', '336', '13112', '13', '943');
INSERT INTO public.who_global_data_import VALUES (38928, '2020-05-09', 'ID', 'Indonesia', 'SEARO', '533', '13645', '16', '959');
INSERT INTO public.who_global_data_import VALUES (38929, '2020-05-10', 'ID', 'Indonesia', 'SEARO', '387', '14032', '14', '973');
INSERT INTO public.who_global_data_import VALUES (38930, '2020-05-11', 'ID', 'Indonesia', 'SEARO', '233', '14265', '18', '991');
INSERT INTO public.who_global_data_import VALUES (38931, '2020-05-12', 'ID', 'Indonesia', 'SEARO', '484', '14749', '16', '1007');
INSERT INTO public.who_global_data_import VALUES (38932, '2020-05-13', 'ID', 'Indonesia', 'SEARO', '689', '15438', '21', '1028');
INSERT INTO public.who_global_data_import VALUES (38933, '2020-05-14', 'ID', 'Indonesia', 'SEARO', '568', '16006', '15', '1043');
INSERT INTO public.who_global_data_import VALUES (38934, '2020-05-15', 'ID', 'Indonesia', 'SEARO', '490', '16496', '33', '1076');
INSERT INTO public.who_global_data_import VALUES (38935, '2020-05-16', 'ID', 'Indonesia', 'SEARO', '529', '17025', '13', '1089');
INSERT INTO public.who_global_data_import VALUES (38936, '2020-05-17', 'ID', 'Indonesia', 'SEARO', '489', '17514', '59', '1148');
INSERT INTO public.who_global_data_import VALUES (38937, '2020-05-18', 'ID', 'Indonesia', 'SEARO', '496', '18010', '43', '1191');
INSERT INTO public.who_global_data_import VALUES (38938, '2020-05-19', 'ID', 'Indonesia', 'SEARO', '486', '18496', '30', '1221');
INSERT INTO public.who_global_data_import VALUES (38939, '2020-05-20', 'ID', 'Indonesia', 'SEARO', '693', '19189', '21', '1242');
INSERT INTO public.who_global_data_import VALUES (38940, '2020-05-21', 'ID', 'Indonesia', 'SEARO', '973', '20162', '36', '1278');
INSERT INTO public.who_global_data_import VALUES (38941, '2020-05-22', 'ID', 'Indonesia', 'SEARO', '634', '20796', '48', '1326');
INSERT INTO public.who_global_data_import VALUES (38942, '2020-05-23', 'ID', 'Indonesia', 'SEARO', '949', '21745', '25', '1351');
INSERT INTO public.who_global_data_import VALUES (38943, '2020-05-24', 'ID', 'Indonesia', 'SEARO', '526', '22271', '21', '1372');
INSERT INTO public.who_global_data_import VALUES (38944, '2020-05-25', 'ID', 'Indonesia', 'SEARO', '479', '22750', '19', '1391');
INSERT INTO public.who_global_data_import VALUES (38945, '2020-05-26', 'ID', 'Indonesia', 'SEARO', '415', '23165', '27', '1418');
INSERT INTO public.who_global_data_import VALUES (38946, '2020-05-27', 'ID', 'Indonesia', 'SEARO', '686', '23851', '55', '1473');
INSERT INTO public.who_global_data_import VALUES (38947, '2020-05-28', 'ID', 'Indonesia', 'SEARO', '687', '24538', '23', '1496');
INSERT INTO public.who_global_data_import VALUES (38948, '2020-05-29', 'ID', 'Indonesia', 'SEARO', '678', '25216', '24', '1520');
INSERT INTO public.who_global_data_import VALUES (38949, '2020-05-30', 'ID', 'Indonesia', 'SEARO', '557', '25773', '53', '1573');
INSERT INTO public.who_global_data_import VALUES (38950, '2020-05-31', 'ID', 'Indonesia', 'SEARO', '700', '26473', '40', '1613');
INSERT INTO public.who_global_data_import VALUES (38951, '2020-06-01', 'ID', 'Indonesia', 'SEARO', '0', '26473', '0', '1613');
INSERT INTO public.who_global_data_import VALUES (38952, '2020-06-02', 'ID', 'Indonesia', 'SEARO', '467', '26940', '28', '1641');
INSERT INTO public.who_global_data_import VALUES (38953, '2020-06-03', 'ID', 'Indonesia', 'SEARO', '609', '27549', '22', '1663');
INSERT INTO public.who_global_data_import VALUES (38954, '2020-06-04', 'ID', 'Indonesia', 'SEARO', '684', '28233', '35', '1698');
INSERT INTO public.who_global_data_import VALUES (38955, '2020-06-05', 'ID', 'Indonesia', 'SEARO', '585', '28818', '23', '1721');
INSERT INTO public.who_global_data_import VALUES (38956, '2020-06-06', 'ID', 'Indonesia', 'SEARO', '703', '29521', '49', '1770');
INSERT INTO public.who_global_data_import VALUES (38957, '2020-06-07', 'ID', 'Indonesia', 'SEARO', '993', '30514', '31', '1801');
INSERT INTO public.who_global_data_import VALUES (38958, '2020-06-08', 'ID', 'Indonesia', 'SEARO', '672', '31186', '50', '1851');
INSERT INTO public.who_global_data_import VALUES (38959, '2020-06-09', 'ID', 'Indonesia', 'SEARO', '847', '32033', '32', '1883');
INSERT INTO public.who_global_data_import VALUES (38960, '2020-06-10', 'ID', 'Indonesia', 'SEARO', '1043', '33076', '40', '1923');
INSERT INTO public.who_global_data_import VALUES (38961, '2020-06-11', 'ID', 'Indonesia', 'SEARO', '1240', '34316', '36', '1959');
INSERT INTO public.who_global_data_import VALUES (38962, '2020-06-12', 'ID', 'Indonesia', 'SEARO', '979', '35295', '41', '2000');
INSERT INTO public.who_global_data_import VALUES (38963, '2020-06-13', 'ID', 'Indonesia', 'SEARO', '1111', '36406', '48', '2048');
INSERT INTO public.who_global_data_import VALUES (38964, '2020-06-14', 'ID', 'Indonesia', 'SEARO', '1014', '37420', '43', '2091');
INSERT INTO public.who_global_data_import VALUES (38965, '2020-06-15', 'ID', 'Indonesia', 'SEARO', '857', '38277', '43', '2134');
INSERT INTO public.who_global_data_import VALUES (38966, '2020-06-16', 'ID', 'Indonesia', 'SEARO', '1017', '39294', '64', '2198');
INSERT INTO public.who_global_data_import VALUES (38967, '2020-06-17', 'ID', 'Indonesia', 'SEARO', '1106', '40400', '33', '2231');
INSERT INTO public.who_global_data_import VALUES (38968, '2020-06-18', 'ID', 'Indonesia', 'SEARO', '1031', '41431', '45', '2276');
INSERT INTO public.who_global_data_import VALUES (38969, '2020-06-19', 'ID', 'Indonesia', 'SEARO', '1331', '42762', '63', '2339');
INSERT INTO public.who_global_data_import VALUES (38970, '2020-06-20', 'ID', 'Indonesia', 'SEARO', '1041', '43803', '34', '2373');
INSERT INTO public.who_global_data_import VALUES (38971, '2020-06-21', 'ID', 'Indonesia', 'SEARO', '1226', '45029', '56', '2429');
INSERT INTO public.who_global_data_import VALUES (38972, '2020-06-22', 'ID', 'Indonesia', 'SEARO', '862', '45891', '36', '2465');
INSERT INTO public.who_global_data_import VALUES (38973, '2020-06-23', 'ID', 'Indonesia', 'SEARO', '954', '46845', '35', '2500');
INSERT INTO public.who_global_data_import VALUES (38974, '2020-06-24', 'ID', 'Indonesia', 'SEARO', '1051', '47896', '35', '2535');
INSERT INTO public.who_global_data_import VALUES (38975, '2020-06-25', 'ID', 'Indonesia', 'SEARO', '1113', '49009', '38', '2573');
INSERT INTO public.who_global_data_import VALUES (38976, '2020-06-26', 'ID', 'Indonesia', 'SEARO', '1178', '50187', '47', '2620');
INSERT INTO public.who_global_data_import VALUES (38977, '2020-06-27', 'ID', 'Indonesia', 'SEARO', '1240', '51427', '63', '2683');
INSERT INTO public.who_global_data_import VALUES (38978, '2020-06-28', 'ID', 'Indonesia', 'SEARO', '1385', '52812', '37', '2720');
INSERT INTO public.who_global_data_import VALUES (38979, '2020-06-29', 'ID', 'Indonesia', 'SEARO', '1198', '54010', '34', '2754');
INSERT INTO public.who_global_data_import VALUES (38980, '2020-06-30', 'ID', 'Indonesia', 'SEARO', '1082', '55092', '51', '2805');
INSERT INTO public.who_global_data_import VALUES (38981, '2020-07-01', 'ID', 'Indonesia', 'SEARO', '1293', '56385', '71', '2876');
INSERT INTO public.who_global_data_import VALUES (38982, '2020-07-02', 'ID', 'Indonesia', 'SEARO', '1385', '57770', '58', '2934');
INSERT INTO public.who_global_data_import VALUES (38983, '2020-07-03', 'ID', 'Indonesia', 'SEARO', '1624', '59394', '53', '2987');
INSERT INTO public.who_global_data_import VALUES (38984, '2020-07-04', 'ID', 'Indonesia', 'SEARO', '1301', '60695', '49', '3036');
INSERT INTO public.who_global_data_import VALUES (38985, '2020-07-05', 'ID', 'Indonesia', 'SEARO', '1447', '62142', '53', '3089');
INSERT INTO public.who_global_data_import VALUES (38986, '2020-07-06', 'ID', 'Indonesia', 'SEARO', '1607', '63749', '82', '3171');
INSERT INTO public.who_global_data_import VALUES (38987, '2020-07-07', 'ID', 'Indonesia', 'SEARO', '1209', '64958', '70', '3241');
INSERT INTO public.who_global_data_import VALUES (38988, '2020-07-08', 'ID', 'Indonesia', 'SEARO', '1268', '66226', '68', '3309');
INSERT INTO public.who_global_data_import VALUES (38989, '2020-07-09', 'ID', 'Indonesia', 'SEARO', '1853', '68079', '50', '3359');
INSERT INTO public.who_global_data_import VALUES (38990, '2020-07-10', 'ID', 'Indonesia', 'SEARO', '2657', '70736', '58', '3417');
INSERT INTO public.who_global_data_import VALUES (38991, '2020-07-11', 'ID', 'Indonesia', 'SEARO', '1611', '72347', '52', '3469');
INSERT INTO public.who_global_data_import VALUES (38992, '2020-07-12', 'ID', 'Indonesia', 'SEARO', '1671', '74018', '66', '3535');
INSERT INTO public.who_global_data_import VALUES (38993, '2020-07-13', 'ID', 'Indonesia', 'SEARO', '1681', '75699', '71', '3606');
INSERT INTO public.who_global_data_import VALUES (38994, '2020-07-14', 'ID', 'Indonesia', 'SEARO', '1282', '76981', '50', '3656');
INSERT INTO public.who_global_data_import VALUES (38995, '2020-07-15', 'ID', 'Indonesia', 'SEARO', '1591', '78572', '54', '3710');
INSERT INTO public.who_global_data_import VALUES (38996, '2020-07-16', 'ID', 'Indonesia', 'SEARO', '1522', '80094', '87', '3797');
INSERT INTO public.who_global_data_import VALUES (38997, '2020-07-17', 'ID', 'Indonesia', 'SEARO', '1574', '81668', '76', '3873');
INSERT INTO public.who_global_data_import VALUES (38998, '2020-07-18', 'ID', 'Indonesia', 'SEARO', '1462', '83130', '84', '3957');
INSERT INTO public.who_global_data_import VALUES (38999, '2020-07-19', 'ID', 'Indonesia', 'SEARO', '1752', '84882', '59', '4016');
INSERT INTO public.who_global_data_import VALUES (39000, '2020-07-20', 'ID', 'Indonesia', 'SEARO', '1639', '86521', '127', '4143');
INSERT INTO public.who_global_data_import VALUES (39001, '2020-07-21', 'ID', 'Indonesia', 'SEARO', '1693', '88214', '96', '4239');
INSERT INTO public.who_global_data_import VALUES (39002, '2020-07-22', 'ID', 'Indonesia', 'SEARO', '1655', '89869', '81', '4320');
INSERT INTO public.who_global_data_import VALUES (39003, '2020-07-23', 'ID', 'Indonesia', 'SEARO', '1882', '91751', '139', '4459');
INSERT INTO public.who_global_data_import VALUES (39004, '2020-07-24', 'ID', 'Indonesia', 'SEARO', '1906', '93657', '117', '4576');
INSERT INTO public.who_global_data_import VALUES (39005, '2020-07-25', 'ID', 'Indonesia', 'SEARO', '1761', '95418', '89', '4665');
INSERT INTO public.who_global_data_import VALUES (39006, '2020-07-26', 'ID', 'Indonesia', 'SEARO', '1868', '97286', '49', '4714');
INSERT INTO public.who_global_data_import VALUES (39007, '2020-07-27', 'ID', 'Indonesia', 'SEARO', '1492', '98778', '67', '4781');
INSERT INTO public.who_global_data_import VALUES (39008, '2020-07-28', 'ID', 'Indonesia', 'SEARO', '1525', '100303', '57', '4838');
INSERT INTO public.who_global_data_import VALUES (39009, '2020-07-29', 'ID', 'Indonesia', 'SEARO', '1748', '102051', '63', '4901');
INSERT INTO public.who_global_data_import VALUES (39010, '2020-07-30', 'ID', 'Indonesia', 'SEARO', '2381', '104432', '74', '4975');
INSERT INTO public.who_global_data_import VALUES (39011, '2020-07-31', 'ID', 'Indonesia', 'SEARO', '1904', '106336', '83', '5058');
INSERT INTO public.who_global_data_import VALUES (39012, '2020-08-01', 'ID', 'Indonesia', 'SEARO', '2040', '108376', '73', '5131');
INSERT INTO public.who_global_data_import VALUES (39013, '2020-08-02', 'ID', 'Indonesia', 'SEARO', '1560', '109936', '62', '5193');
INSERT INTO public.who_global_data_import VALUES (39014, '2020-08-03', 'ID', 'Indonesia', 'SEARO', '1519', '111455', '43', '5236');
INSERT INTO public.who_global_data_import VALUES (39015, '2020-08-04', 'ID', 'Indonesia', 'SEARO', '1679', '113134', '66', '5302');
INSERT INTO public.who_global_data_import VALUES (39016, '2020-08-05', 'ID', 'Indonesia', 'SEARO', '1922', '115056', '86', '5388');
INSERT INTO public.who_global_data_import VALUES (39017, '2020-08-06', 'ID', 'Indonesia', 'SEARO', '1815', '116871', '64', '5452');
INSERT INTO public.who_global_data_import VALUES (39018, '2020-08-07', 'ID', 'Indonesia', 'SEARO', '1882', '118753', '69', '5521');
INSERT INTO public.who_global_data_import VALUES (39019, '2020-08-08', 'ID', 'Indonesia', 'SEARO', '2473', '121226', '72', '5593');
INSERT INTO public.who_global_data_import VALUES (39020, '2020-08-09', 'ID', 'Indonesia', 'SEARO', '2277', '123503', '65', '5658');
INSERT INTO public.who_global_data_import VALUES (39021, '2020-08-10', 'ID', 'Indonesia', 'SEARO', '1893', '125396', '65', '5723');
INSERT INTO public.who_global_data_import VALUES (39022, '2020-08-11', 'ID', 'Indonesia', 'SEARO', '1687', '127083', '42', '5765');
INSERT INTO public.who_global_data_import VALUES (39023, '2020-08-12', 'ID', 'Indonesia', 'SEARO', '1693', '128776', '59', '5824');
INSERT INTO public.who_global_data_import VALUES (39024, '2020-08-13', 'ID', 'Indonesia', 'SEARO', '1942', '130718', '79', '5903');
INSERT INTO public.who_global_data_import VALUES (39025, '2020-08-14', 'ID', 'Indonesia', 'SEARO', '2098', '132816', '65', '5968');
INSERT INTO public.who_global_data_import VALUES (39026, '2020-08-15', 'ID', 'Indonesia', 'SEARO', '2307', '135123', '53', '6021');
INSERT INTO public.who_global_data_import VALUES (39027, '2020-08-16', 'ID', 'Indonesia', 'SEARO', '2345', '137468', '50', '6071');
INSERT INTO public.who_global_data_import VALUES (39028, '2020-08-17', 'ID', 'Indonesia', 'SEARO', '2081', '139549', '79', '6150');
INSERT INTO public.who_global_data_import VALUES (39029, '2020-08-18', 'ID', 'Indonesia', 'SEARO', '1821', '141370', '57', '6207');
INSERT INTO public.who_global_data_import VALUES (39030, '2020-08-19', 'ID', 'Indonesia', 'SEARO', '1673', '143043', '70', '6277');
INSERT INTO public.who_global_data_import VALUES (39031, '2020-08-20', 'ID', 'Indonesia', 'SEARO', '1902', '144945', '69', '6346');
INSERT INTO public.who_global_data_import VALUES (39032, '2020-08-21', 'ID', 'Indonesia', 'SEARO', '2266', '147211', '72', '6418');
INSERT INTO public.who_global_data_import VALUES (39033, '2020-08-22', 'ID', 'Indonesia', 'SEARO', '2197', '149408', '82', '6500');
INSERT INTO public.who_global_data_import VALUES (39034, '2020-08-23', 'ID', 'Indonesia', 'SEARO', '2090', '151498', '94', '6594');
INSERT INTO public.who_global_data_import VALUES (39035, '2020-08-24', 'ID', 'Indonesia', 'SEARO', '3914', '155412', '165', '6759');
INSERT INTO public.who_global_data_import VALUES (39036, '2020-08-25', 'ID', 'Indonesia', 'SEARO', '0', '155412', '0', '6759');
INSERT INTO public.who_global_data_import VALUES (39037, '2020-08-26', 'ID', 'Indonesia', 'SEARO', '2447', '157859', '99', '6858');
INSERT INTO public.who_global_data_import VALUES (39038, '2020-08-27', 'ID', 'Indonesia', 'SEARO', '2306', '160165', '86', '6944');
INSERT INTO public.who_global_data_import VALUES (39039, '2020-08-28', 'ID', 'Indonesia', 'SEARO', '2719', '162884', '120', '7064');
INSERT INTO public.who_global_data_import VALUES (39040, '2020-08-29', 'ID', 'Indonesia', 'SEARO', '3003', '165887', '105', '7169');
INSERT INTO public.who_global_data_import VALUES (39041, '2020-08-30', 'ID', 'Indonesia', 'SEARO', '3308', '169195', '92', '7261');
INSERT INTO public.who_global_data_import VALUES (39042, '2020-08-31', 'ID', 'Indonesia', 'SEARO', '2858', '172053', '82', '7343');
INSERT INTO public.who_global_data_import VALUES (39043, '2020-09-01', 'ID', 'Indonesia', 'SEARO', '2743', '174796', '74', '7417');
INSERT INTO public.who_global_data_import VALUES (39044, '2020-09-02', 'ID', 'Indonesia', 'SEARO', '2775', '177571', '88', '7505');
INSERT INTO public.who_global_data_import VALUES (39045, '2020-09-03', 'ID', 'Indonesia', 'SEARO', '3075', '180646', '111', '7616');
INSERT INTO public.who_global_data_import VALUES (39046, '2020-09-04', 'ID', 'Indonesia', 'SEARO', '3622', '184268', '134', '7750');
INSERT INTO public.who_global_data_import VALUES (39047, '2020-09-05', 'ID', 'Indonesia', 'SEARO', '3269', '187537', '82', '7832');
INSERT INTO public.who_global_data_import VALUES (39048, '2020-09-06', 'ID', 'Indonesia', 'SEARO', '3128', '190665', '108', '7940');
INSERT INTO public.who_global_data_import VALUES (39049, '2020-09-07', 'ID', 'Indonesia', 'SEARO', '3444', '194109', '85', '8025');
INSERT INTO public.who_global_data_import VALUES (39050, '2020-09-08', 'ID', 'Indonesia', 'SEARO', '2880', '196989', '105', '8130');
INSERT INTO public.who_global_data_import VALUES (39051, '2020-09-09', 'ID', 'Indonesia', 'SEARO', '3046', '200035', '100', '8230');
INSERT INTO public.who_global_data_import VALUES (39052, '2020-09-10', 'ID', 'Indonesia', 'SEARO', '3307', '203342', '106', '8336');
INSERT INTO public.who_global_data_import VALUES (39053, '2020-09-11', 'ID', 'Indonesia', 'SEARO', '3861', '207203', '120', '8456');
INSERT INTO public.who_global_data_import VALUES (39054, '2020-09-12', 'ID', 'Indonesia', 'SEARO', '3737', '210940', '88', '8544');
INSERT INTO public.who_global_data_import VALUES (39055, '2020-09-13', 'ID', 'Indonesia', 'SEARO', '3806', '214746', '106', '8650');
INSERT INTO public.who_global_data_import VALUES (39056, '2020-09-14', 'ID', 'Indonesia', 'SEARO', '3636', '218382', '73', '8723');
INSERT INTO public.who_global_data_import VALUES (39057, '2020-09-15', 'ID', 'Indonesia', 'SEARO', '3141', '221523', '118', '8841');
INSERT INTO public.who_global_data_import VALUES (39058, '2020-09-16', 'ID', 'Indonesia', 'SEARO', '3507', '225030', '124', '8965');
INSERT INTO public.who_global_data_import VALUES (39059, '2020-09-17', 'ID', 'Indonesia', 'SEARO', '3963', '228993', '135', '9100');
INSERT INTO public.who_global_data_import VALUES (39060, '2020-09-18', 'ID', 'Indonesia', 'SEARO', '3635', '232628', '122', '9222');
INSERT INTO public.who_global_data_import VALUES (39061, '2020-09-19', 'ID', 'Indonesia', 'SEARO', '3891', '236519', '114', '9336');
INSERT INTO public.who_global_data_import VALUES (39062, '2020-09-20', 'ID', 'Indonesia', 'SEARO', '4168', '240687', '112', '9448');
INSERT INTO public.who_global_data_import VALUES (39063, '2020-09-21', 'ID', 'Indonesia', 'SEARO', '3989', '244676', '105', '9553');
INSERT INTO public.who_global_data_import VALUES (39064, '2020-09-22', 'ID', 'Indonesia', 'SEARO', '4176', '248852', '124', '9677');
INSERT INTO public.who_global_data_import VALUES (39065, '2020-09-23', 'ID', 'Indonesia', 'SEARO', '4071', '252923', '160', '9837');
INSERT INTO public.who_global_data_import VALUES (39066, '2020-09-24', 'ID', 'Indonesia', 'SEARO', '4465', '257388', '140', '9977');
INSERT INTO public.who_global_data_import VALUES (39067, '2020-09-25', 'ID', 'Indonesia', 'SEARO', '4634', '262022', '128', '10105');
INSERT INTO public.who_global_data_import VALUES (39068, '2020-09-26', 'ID', 'Indonesia', 'SEARO', '4823', '266845', '113', '10218');
INSERT INTO public.who_global_data_import VALUES (39069, '2020-09-27', 'ID', 'Indonesia', 'SEARO', '4494', '271339', '90', '10308');
INSERT INTO public.who_global_data_import VALUES (39070, '2020-09-28', 'ID', 'Indonesia', 'SEARO', '3874', '275213', '78', '10386');
INSERT INTO public.who_global_data_import VALUES (39071, '2020-09-29', 'ID', 'Indonesia', 'SEARO', '3509', '278722', '87', '10473');
INSERT INTO public.who_global_data_import VALUES (39072, '2020-09-30', 'ID', 'Indonesia', 'SEARO', '4002', '282724', '128', '10601');
INSERT INTO public.who_global_data_import VALUES (39073, '2020-10-01', 'ID', 'Indonesia', 'SEARO', '4284', '287008', '139', '10740');
INSERT INTO public.who_global_data_import VALUES (39074, '2020-10-02', 'ID', 'Indonesia', 'SEARO', '4174', '291182', '116', '10856');
INSERT INTO public.who_global_data_import VALUES (39075, '2020-10-03', 'ID', 'Indonesia', 'SEARO', '4317', '295499', '116', '10972');
INSERT INTO public.who_global_data_import VALUES (39076, '2020-10-04', 'ID', 'Indonesia', 'SEARO', '4007', '299506', '83', '11055');
INSERT INTO public.who_global_data_import VALUES (39077, '2020-10-05', 'ID', 'Indonesia', 'SEARO', '3992', '303498', '96', '11151');
INSERT INTO public.who_global_data_import VALUES (39078, '2020-10-06', 'ID', 'Indonesia', 'SEARO', '3622', '307120', '102', '11253');
INSERT INTO public.who_global_data_import VALUES (39079, '2020-10-07', 'ID', 'Indonesia', 'SEARO', '4056', '311176', '121', '11374');
INSERT INTO public.who_global_data_import VALUES (39080, '2020-10-08', 'ID', 'Indonesia', 'SEARO', '4538', '315714', '98', '11472');
INSERT INTO public.who_global_data_import VALUES (39081, '2020-10-09', 'ID', 'Indonesia', 'SEARO', '4850', '320564', '108', '11580');
INSERT INTO public.who_global_data_import VALUES (39082, '2020-10-10', 'ID', 'Indonesia', 'SEARO', '4094', '324658', '97', '11677');
INSERT INTO public.who_global_data_import VALUES (39083, '2020-10-11', 'ID', 'Indonesia', 'SEARO', '4294', '328952', '88', '11765');
INSERT INTO public.who_global_data_import VALUES (39084, '2020-10-12', 'ID', 'Indonesia', 'SEARO', '4497', '333449', '79', '11844');
INSERT INTO public.who_global_data_import VALUES (39085, '2020-10-13', 'ID', 'Indonesia', 'SEARO', '3267', '336716', '91', '11935');
INSERT INTO public.who_global_data_import VALUES (39086, '2020-10-14', 'ID', 'Indonesia', 'SEARO', '3906', '340622', '92', '12027');
INSERT INTO public.who_global_data_import VALUES (39087, '2020-10-15', 'ID', 'Indonesia', 'SEARO', '4127', '344749', '129', '12156');
INSERT INTO public.who_global_data_import VALUES (39088, '2020-10-16', 'ID', 'Indonesia', 'SEARO', '4411', '349160', '112', '12268');
INSERT INTO public.who_global_data_import VALUES (39089, '2020-10-17', 'ID', 'Indonesia', 'SEARO', '4301', '353461', '79', '12347');
INSERT INTO public.who_global_data_import VALUES (39090, '2020-10-18', 'ID', 'Indonesia', 'SEARO', '4301', '357762', '84', '12431');
INSERT INTO public.who_global_data_import VALUES (39091, '2020-10-19', 'ID', 'Indonesia', 'SEARO', '4105', '361867', '80', '12511');
INSERT INTO public.who_global_data_import VALUES (39092, '2020-10-20', 'ID', 'Indonesia', 'SEARO', '3373', '365240', '106', '12617');
INSERT INTO public.who_global_data_import VALUES (39093, '2020-10-21', 'ID', 'Indonesia', 'SEARO', '3602', '368842', '117', '12734');
INSERT INTO public.who_global_data_import VALUES (39094, '2020-10-22', 'ID', 'Indonesia', 'SEARO', '4267', '373109', '123', '12857');
INSERT INTO public.who_global_data_import VALUES (39095, '2020-10-23', 'ID', 'Indonesia', 'SEARO', '4432', '377541', '102', '12959');
INSERT INTO public.who_global_data_import VALUES (39096, '2020-10-24', 'ID', 'Indonesia', 'SEARO', '4369', '381910', '118', '13077');
INSERT INTO public.who_global_data_import VALUES (39097, '2020-10-25', 'ID', 'Indonesia', 'SEARO', '4070', '385980', '128', '13205');
INSERT INTO public.who_global_data_import VALUES (39098, '2020-10-26', 'ID', 'Indonesia', 'SEARO', '3732', '389712', '94', '13299');
INSERT INTO public.who_global_data_import VALUES (39099, '2020-10-27', 'ID', 'Indonesia', 'SEARO', '3222', '392934', '112', '13411');
INSERT INTO public.who_global_data_import VALUES (39100, '2020-10-28', 'ID', 'Indonesia', 'SEARO', '3520', '396454', '101', '13512');
INSERT INTO public.who_global_data_import VALUES (39101, '2020-10-29', 'ID', 'Indonesia', 'SEARO', '4029', '400483', '100', '13612');
INSERT INTO public.who_global_data_import VALUES (39102, '2020-10-30', 'ID', 'Indonesia', 'SEARO', '3565', '404048', '89', '13701');
INSERT INTO public.who_global_data_import VALUES (39103, '2020-10-31', 'ID', 'Indonesia', 'SEARO', '2897', '406945', '81', '13782');
INSERT INTO public.who_global_data_import VALUES (39104, '2020-11-01', 'ID', 'Indonesia', 'SEARO', '3143', '410088', '87', '13869');
INSERT INTO public.who_global_data_import VALUES (39105, '2020-11-02', 'ID', 'Indonesia', 'SEARO', '2696', '412784', '74', '13943');
INSERT INTO public.who_global_data_import VALUES (39106, '2020-11-03', 'ID', 'Indonesia', 'SEARO', '2618', '415402', '101', '14044');
INSERT INTO public.who_global_data_import VALUES (39107, '2020-11-04', 'ID', 'Indonesia', 'SEARO', '2973', '418375', '102', '14146');
INSERT INTO public.who_global_data_import VALUES (39108, '2020-11-05', 'ID', 'Indonesia', 'SEARO', '3356', '421731', '113', '14259');
INSERT INTO public.who_global_data_import VALUES (39109, '2020-11-06', 'ID', 'Indonesia', 'SEARO', '7843', '429574', '183', '14442');
INSERT INTO public.who_global_data_import VALUES (39110, '2020-11-07', 'ID', 'Indonesia', 'SEARO', '0', '429574', '0', '14442');
INSERT INTO public.who_global_data_import VALUES (39111, '2020-11-08', 'ID', 'Indonesia', 'SEARO', '4262', '433836', '98', '14540');
INSERT INTO public.who_global_data_import VALUES (39112, '2020-11-09', 'ID', 'Indonesia', 'SEARO', '3880', '437716', '74', '14614');
INSERT INTO public.who_global_data_import VALUES (39113, '2020-11-10', 'ID', 'Indonesia', 'SEARO', '2853', '440569', '75', '14689');
INSERT INTO public.who_global_data_import VALUES (39114, '2020-11-11', 'ID', 'Indonesia', 'SEARO', '3779', '444348', '72', '14761');
INSERT INTO public.who_global_data_import VALUES (39115, '2020-11-12', 'ID', 'Indonesia', 'SEARO', '3770', '448118', '75', '14836');
INSERT INTO public.who_global_data_import VALUES (39116, '2020-11-13', 'ID', 'Indonesia', 'SEARO', '4173', '452291', '97', '14933');
INSERT INTO public.who_global_data_import VALUES (39117, '2020-11-14', 'ID', 'Indonesia', 'SEARO', '5444', '457735', '104', '15037');
INSERT INTO public.who_global_data_import VALUES (39118, '2020-11-15', 'ID', 'Indonesia', 'SEARO', '5272', '463007', '111', '15148');
INSERT INTO public.who_global_data_import VALUES (39119, '2020-11-16', 'ID', 'Indonesia', 'SEARO', '4106', '467113', '63', '15211');
INSERT INTO public.who_global_data_import VALUES (39120, '2020-11-17', 'ID', 'Indonesia', 'SEARO', '3535', '470648', '85', '15296');
INSERT INTO public.who_global_data_import VALUES (39121, '2020-11-18', 'ID', 'Indonesia', 'SEARO', '3807', '474455', '97', '15393');
INSERT INTO public.who_global_data_import VALUES (39122, '2020-11-19', 'ID', 'Indonesia', 'SEARO', '4265', '478720', '110', '15503');
INSERT INTO public.who_global_data_import VALUES (39123, '2020-11-20', 'ID', 'Indonesia', 'SEARO', '4798', '483518', '97', '15600');
INSERT INTO public.who_global_data_import VALUES (39124, '2020-11-21', 'ID', 'Indonesia', 'SEARO', '4792', '488310', '78', '15678');
INSERT INTO public.who_global_data_import VALUES (39125, '2020-11-22', 'ID', 'Indonesia', 'SEARO', '4998', '493308', '96', '15774');
INSERT INTO public.who_global_data_import VALUES (39126, '2020-11-23', 'ID', 'Indonesia', 'SEARO', '4360', '497668', '110', '15884');
INSERT INTO public.who_global_data_import VALUES (39127, '2020-11-24', 'ID', 'Indonesia', 'SEARO', '4442', '502110', '118', '16002');
INSERT INTO public.who_global_data_import VALUES (39128, '2020-11-25', 'ID', 'Indonesia', 'SEARO', '4192', '506302', '109', '16111');
INSERT INTO public.who_global_data_import VALUES (39129, '2020-11-26', 'ID', 'Indonesia', 'SEARO', '5534', '511836', '114', '16225');
INSERT INTO public.who_global_data_import VALUES (39130, '2020-11-27', 'ID', 'Indonesia', 'SEARO', '4917', '516753', '127', '16352');
INSERT INTO public.who_global_data_import VALUES (39131, '2020-11-28', 'ID', 'Indonesia', 'SEARO', '5828', '522581', '169', '16521');
INSERT INTO public.who_global_data_import VALUES (39132, '2020-11-29', 'ID', 'Indonesia', 'SEARO', '5418', '527999', '125', '16646');
INSERT INTO public.who_global_data_import VALUES (39133, '2020-11-30', 'ID', 'Indonesia', 'SEARO', '6267', '534266', '169', '16815');
INSERT INTO public.who_global_data_import VALUES (39134, '2020-12-01', 'ID', 'Indonesia', 'SEARO', '4617', '538883', '130', '16945');
INSERT INTO public.who_global_data_import VALUES (39135, '2020-12-02', 'ID', 'Indonesia', 'SEARO', '5092', '543975', '136', '17081');
INSERT INTO public.who_global_data_import VALUES (39136, '2020-12-03', 'ID', 'Indonesia', 'SEARO', '5533', '549508', '118', '17199');
INSERT INTO public.who_global_data_import VALUES (39137, '2020-12-04', 'ID', 'Indonesia', 'SEARO', '8369', '557877', '156', '17355');
INSERT INTO public.who_global_data_import VALUES (39138, '2020-12-05', 'ID', 'Indonesia', 'SEARO', '5803', '563680', '124', '17479');
INSERT INTO public.who_global_data_import VALUES (39139, '2020-12-06', 'ID', 'Indonesia', 'SEARO', '6027', '569707', '110', '17589');
INSERT INTO public.who_global_data_import VALUES (39140, '2020-12-07', 'ID', 'Indonesia', 'SEARO', '6089', '575796', '151', '17740');
INSERT INTO public.who_global_data_import VALUES (39141, '2020-12-08', 'ID', 'Indonesia', 'SEARO', '5754', '581550', '127', '17867');
INSERT INTO public.who_global_data_import VALUES (39142, '2020-12-09', 'ID', 'Indonesia', 'SEARO', '5292', '586842', '133', '18000');
INSERT INTO public.who_global_data_import VALUES (39143, '2020-12-10', 'ID', 'Indonesia', 'SEARO', '6058', '592900', '171', '18171');
INSERT INTO public.who_global_data_import VALUES (39144, '2020-12-11', 'ID', 'Indonesia', 'SEARO', '6033', '598933', '165', '18336');
INSERT INTO public.who_global_data_import VALUES (39145, '2020-12-12', 'ID', 'Indonesia', 'SEARO', '6310', '605243', '175', '18511');
INSERT INTO public.who_global_data_import VALUES (39146, '2020-12-13', 'ID', 'Indonesia', 'SEARO', '6388', '611631', '142', '18653');
INSERT INTO public.who_global_data_import VALUES (39147, '2020-12-14', 'ID', 'Indonesia', 'SEARO', '6189', '617820', '166', '18819');
INSERT INTO public.who_global_data_import VALUES (39148, '2020-12-15', 'ID', 'Indonesia', 'SEARO', '5489', '623309', '137', '18956');
INSERT INTO public.who_global_data_import VALUES (39149, '2020-12-16', 'ID', 'Indonesia', 'SEARO', '6120', '629429', '155', '19111');
INSERT INTO public.who_global_data_import VALUES (39150, '2020-12-17', 'ID', 'Indonesia', 'SEARO', '6725', '636154', '137', '19248');
INSERT INTO public.who_global_data_import VALUES (39151, '2020-12-18', 'ID', 'Indonesia', 'SEARO', '7354', '643508', '142', '19390');
INSERT INTO public.who_global_data_import VALUES (39152, '2020-12-19', 'ID', 'Indonesia', 'SEARO', '6689', '650197', '124', '19514');
INSERT INTO public.who_global_data_import VALUES (39153, '2020-12-20', 'ID', 'Indonesia', 'SEARO', '7751', '657948', '145', '19659');
INSERT INTO public.who_global_data_import VALUES (39154, '2020-12-21', 'ID', 'Indonesia', 'SEARO', '6982', '664930', '221', '19880');
INSERT INTO public.who_global_data_import VALUES (39155, '2020-12-22', 'ID', 'Indonesia', 'SEARO', '6848', '671778', '205', '20085');
INSERT INTO public.who_global_data_import VALUES (39156, '2020-12-23', 'ID', 'Indonesia', 'SEARO', '6347', '678125', '172', '20257');
INSERT INTO public.who_global_data_import VALUES (39157, '2020-12-24', 'ID', 'Indonesia', 'SEARO', '7514', '685639', '151', '20408');
INSERT INTO public.who_global_data_import VALUES (39158, '2020-12-25', 'ID', 'Indonesia', 'SEARO', '7199', '692838', '181', '20589');
INSERT INTO public.who_global_data_import VALUES (39159, '2020-12-26', 'ID', 'Indonesia', 'SEARO', '7259', '700097', '258', '20847');
INSERT INTO public.who_global_data_import VALUES (39160, '2020-12-27', 'ID', 'Indonesia', 'SEARO', '6740', '706837', '147', '20994');
INSERT INTO public.who_global_data_import VALUES (39161, '2020-12-28', 'ID', 'Indonesia', 'SEARO', '6528', '713365', '243', '21237');
INSERT INTO public.who_global_data_import VALUES (39162, '2020-12-29', 'ID', 'Indonesia', 'SEARO', '5854', '719219', '215', '21452');
INSERT INTO public.who_global_data_import VALUES (39163, '2020-12-30', 'ID', 'Indonesia', 'SEARO', '7903', '727122', '251', '21703');
INSERT INTO public.who_global_data_import VALUES (39164, '2020-12-31', 'ID', 'Indonesia', 'SEARO', '8002', '735124', '241', '21944');
INSERT INTO public.who_global_data_import VALUES (39165, '2021-01-01', 'ID', 'Indonesia', 'SEARO', '8074', '743198', '194', '22138');
INSERT INTO public.who_global_data_import VALUES (39166, '2021-01-02', 'ID', 'Indonesia', 'SEARO', '8072', '751270', '191', '22329');
INSERT INTO public.who_global_data_import VALUES (39167, '2021-01-03', 'ID', 'Indonesia', 'SEARO', '7203', '758473', '226', '22555');
INSERT INTO public.who_global_data_import VALUES (39168, '2021-01-04', 'ID', 'Indonesia', 'SEARO', '6877', '765350', '179', '22734');
INSERT INTO public.who_global_data_import VALUES (39169, '2021-01-05', 'ID', 'Indonesia', 'SEARO', '6753', '772103', '177', '22911');
INSERT INTO public.who_global_data_import VALUES (39170, '2021-01-06', 'ID', 'Indonesia', 'SEARO', '7445', '779548', '198', '23109');
INSERT INTO public.who_global_data_import VALUES (39171, '2021-01-07', 'ID', 'Indonesia', 'SEARO', '8854', '788402', '187', '23296');
INSERT INTO public.who_global_data_import VALUES (39172, '2021-01-08', 'ID', 'Indonesia', 'SEARO', '9321', '797723', '224', '23520');
INSERT INTO public.who_global_data_import VALUES (39173, '2021-01-09', 'ID', 'Indonesia', 'SEARO', '10617', '808340', '233', '23753');
INSERT INTO public.who_global_data_import VALUES (39174, '2021-01-10', 'ID', 'Indonesia', 'SEARO', '10046', '818386', '194', '23947');
INSERT INTO public.who_global_data_import VALUES (39175, '2021-01-11', 'ID', 'Indonesia', 'SEARO', '9640', '828026', '182', '24129');
INSERT INTO public.who_global_data_import VALUES (39176, '2021-01-12', 'ID', 'Indonesia', 'SEARO', '8692', '836718', '214', '24343');
INSERT INTO public.who_global_data_import VALUES (39177, '2021-01-13', 'ID', 'Indonesia', 'SEARO', '10047', '846765', '302', '24645');
INSERT INTO public.who_global_data_import VALUES (39178, '2021-01-14', 'ID', 'Indonesia', 'SEARO', '11278', '858043', '306', '24951');
INSERT INTO public.who_global_data_import VALUES (39179, '2021-01-15', 'ID', 'Indonesia', 'SEARO', '11557', '869600', '295', '25246');
INSERT INTO public.who_global_data_import VALUES (39180, '2021-01-16', 'ID', 'Indonesia', 'SEARO', '12818', '882418', '238', '25484');
INSERT INTO public.who_global_data_import VALUES (39181, '2021-01-17', 'ID', 'Indonesia', 'SEARO', '14224', '896642', '283', '25767');
INSERT INTO public.who_global_data_import VALUES (39182, '2021-01-18', 'ID', 'Indonesia', 'SEARO', '11287', '907929', '220', '25987');
INSERT INTO public.who_global_data_import VALUES (39183, '2021-01-19', 'ID', 'Indonesia', 'SEARO', '9086', '917015', '295', '26282');
INSERT INTO public.who_global_data_import VALUES (39184, '2021-01-20', 'ID', 'Indonesia', 'SEARO', '10365', '927380', '308', '26590');
INSERT INTO public.who_global_data_import VALUES (39185, '2021-01-21', 'ID', 'Indonesia', 'SEARO', '12568', '939948', '267', '26857');
INSERT INTO public.who_global_data_import VALUES (39186, '2021-01-22', 'ID', 'Indonesia', 'SEARO', '11703', '951651', '346', '27203');
INSERT INTO public.who_global_data_import VALUES (39187, '2021-01-23', 'ID', 'Indonesia', 'SEARO', '13632', '965283', '250', '27453');
INSERT INTO public.who_global_data_import VALUES (39188, '2021-01-24', 'ID', 'Indonesia', 'SEARO', '12191', '977474', '211', '27664');
INSERT INTO public.who_global_data_import VALUES (39189, '2021-01-25', 'ID', 'Indonesia', 'SEARO', '11788', '989262', '171', '27835');
INSERT INTO public.who_global_data_import VALUES (39190, '2021-01-26', 'ID', 'Indonesia', 'SEARO', '9994', '999256', '297', '28132');
INSERT INTO public.who_global_data_import VALUES (39191, '2021-01-27', 'ID', 'Indonesia', 'SEARO', '13094', '1012350', '336', '28468');
INSERT INTO public.who_global_data_import VALUES (40035, '2020-02-06', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39192, '2021-01-28', 'ID', 'Indonesia', 'SEARO', '11948', '1024298', '387', '28855');
INSERT INTO public.who_global_data_import VALUES (39193, '2021-01-29', 'ID', 'Indonesia', 'SEARO', '13695', '1037993', '476', '29331');
INSERT INTO public.who_global_data_import VALUES (39194, '2021-01-30', 'ID', 'Indonesia', 'SEARO', '13802', '1051795', '187', '29518');
INSERT INTO public.who_global_data_import VALUES (39195, '2021-01-31', 'ID', 'Indonesia', 'SEARO', '14518', '1066313', '210', '29728');
INSERT INTO public.who_global_data_import VALUES (39196, '2021-02-01', 'ID', 'Indonesia', 'SEARO', '12001', '1078314', '270', '29998');
INSERT INTO public.who_global_data_import VALUES (39197, '2021-02-02', 'ID', 'Indonesia', 'SEARO', '10994', '1089308', '279', '30277');
INSERT INTO public.who_global_data_import VALUES (39198, '2021-02-03', 'ID', 'Indonesia', 'SEARO', '10379', '1099687', '304', '30581');
INSERT INTO public.who_global_data_import VALUES (39199, '2021-02-04', 'ID', 'Indonesia', 'SEARO', '11984', '1111671', '189', '30770');
INSERT INTO public.who_global_data_import VALUES (39200, '2021-02-05', 'ID', 'Indonesia', 'SEARO', '11434', '1123105', '231', '31001');
INSERT INTO public.who_global_data_import VALUES (39201, '2020-01-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39202, '2020-01-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39203, '2020-01-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39204, '2020-01-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39205, '2020-01-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39206, '2020-01-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39207, '2020-01-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39208, '2020-01-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39209, '2020-01-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39210, '2020-01-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39211, '2020-01-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39212, '2020-01-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39213, '2020-01-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39214, '2020-01-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39215, '2020-01-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39216, '2020-01-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39217, '2020-01-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39218, '2020-01-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39219, '2020-01-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39220, '2020-01-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39221, '2020-01-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39222, '2020-01-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39223, '2020-01-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39224, '2020-01-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39225, '2020-01-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39226, '2020-01-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39227, '2020-01-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39228, '2020-01-30', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39229, '2020-01-31', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39230, '2020-02-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39231, '2020-02-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39232, '2020-02-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39233, '2020-02-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39234, '2020-02-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39235, '2020-02-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39236, '2020-02-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39237, '2020-02-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39238, '2020-02-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39239, '2020-02-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39240, '2020-02-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39241, '2020-02-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39242, '2020-02-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39243, '2020-02-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39244, '2020-02-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39245, '2020-02-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39246, '2020-02-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39247, '2020-02-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39248, '2020-02-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6', '6', '2', '2');
INSERT INTO public.who_global_data_import VALUES (39249, '2020-02-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3', '9', '0', '2');
INSERT INTO public.who_global_data_import VALUES (39250, '2020-02-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13', '22', '2', '4');
INSERT INTO public.who_global_data_import VALUES (39251, '2020-02-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '10', '32', '1', '5');
INSERT INTO public.who_global_data_import VALUES (39252, '2020-02-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '15', '47', '3', '8');
INSERT INTO public.who_global_data_import VALUES (39253, '2020-02-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '18', '65', '4', '12');
INSERT INTO public.who_global_data_import VALUES (39254, '2020-02-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '34', '99', '3', '15');
INSERT INTO public.who_global_data_import VALUES (39255, '2020-02-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '44', '143', '4', '19');
INSERT INTO public.who_global_data_import VALUES (39256, '2020-02-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '106', '249', '7', '26');
INSERT INTO public.who_global_data_import VALUES (39257, '2020-02-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '143', '392', '8', '34');
INSERT INTO public.who_global_data_import VALUES (39258, '2020-02-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '205', '597', '9', '43');
INSERT INTO public.who_global_data_import VALUES (39259, '2020-03-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '597', '0', '43');
INSERT INTO public.who_global_data_import VALUES (39260, '2020-03-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '908', '1505', '23', '66');
INSERT INTO public.who_global_data_import VALUES (39261, '2020-03-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '835', '2340', '11', '77');
INSERT INTO public.who_global_data_import VALUES (39262, '2020-03-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '586', '2926', '15', '92');
INSERT INTO public.who_global_data_import VALUES (39263, '2020-03-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '591', '3517', '15', '107');
INSERT INTO public.who_global_data_import VALUES (39264, '2020-03-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1234', '4751', '17', '124');
INSERT INTO public.who_global_data_import VALUES (39265, '2020-03-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1076', '5827', '21', '145');
INSERT INTO public.who_global_data_import VALUES (39266, '2020-03-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '743', '6570', '49', '194');
INSERT INTO public.who_global_data_import VALUES (39267, '2020-03-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '595', '7165', '43', '237');
INSERT INTO public.who_global_data_import VALUES (39268, '2020-03-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '881', '8046', '54', '291');
INSERT INTO public.who_global_data_import VALUES (39269, '2020-03-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '958', '9004', '63', '354');
INSERT INTO public.who_global_data_import VALUES (39270, '2020-03-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1075', '10079', '75', '429');
INSERT INTO public.who_global_data_import VALUES (39271, '2020-03-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1289', '11368', '85', '514');
INSERT INTO public.who_global_data_import VALUES (39272, '2020-03-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1365', '12733', '94', '608');
INSERT INTO public.who_global_data_import VALUES (39273, '2020-03-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1254', '13987', '116', '724');
INSERT INTO public.who_global_data_import VALUES (39274, '2020-03-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1008', '14995', '129', '853');
INSERT INTO public.who_global_data_import VALUES (39275, '2020-03-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1178', '16173', '135', '988');
INSERT INTO public.who_global_data_import VALUES (39276, '2020-03-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1192', '17365', '147', '1135');
INSERT INTO public.who_global_data_import VALUES (39277, '2020-03-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1046', '18411', '149', '1284');
INSERT INTO public.who_global_data_import VALUES (39278, '2020-03-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1233', '19644', '149', '1433');
INSERT INTO public.who_global_data_import VALUES (39279, '2020-03-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '966', '20610', '123', '1556');
INSERT INTO public.who_global_data_import VALUES (39280, '2020-03-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1028', '21638', '129', '1685');
INSERT INTO public.who_global_data_import VALUES (39281, '2020-03-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1411', '23049', '127', '1812');
INSERT INTO public.who_global_data_import VALUES (39282, '2020-03-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1762', '24811', '122', '1934');
INSERT INTO public.who_global_data_import VALUES (39283, '2020-03-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2206', '27017', '143', '2077');
INSERT INTO public.who_global_data_import VALUES (39284, '2020-03-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2389', '29406', '157', '2234');
INSERT INTO public.who_global_data_import VALUES (39285, '2020-03-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2926', '32332', '144', '2378');
INSERT INTO public.who_global_data_import VALUES (39286, '2020-03-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3076', '35408', '139', '2517');
INSERT INTO public.who_global_data_import VALUES (39287, '2020-03-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2901', '38309', '123', '2640');
INSERT INTO public.who_global_data_import VALUES (39288, '2020-03-30', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3186', '41495', '117', '2757');
INSERT INTO public.who_global_data_import VALUES (39289, '2020-03-31', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3111', '44606', '141', '2898');
INSERT INTO public.who_global_data_import VALUES (39290, '2020-04-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2987', '47593', '138', '3036');
INSERT INTO public.who_global_data_import VALUES (39291, '2020-04-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2875', '50468', '124', '3160');
INSERT INTO public.who_global_data_import VALUES (39292, '2020-04-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2715', '53183', '134', '3294');
INSERT INTO public.who_global_data_import VALUES (39293, '2020-04-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2560', '55743', '158', '3452');
INSERT INTO public.who_global_data_import VALUES (39294, '2020-04-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2483', '58226', '151', '3603');
INSERT INTO public.who_global_data_import VALUES (39295, '2020-04-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2274', '60500', '136', '3739');
INSERT INTO public.who_global_data_import VALUES (39296, '2020-04-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2089', '62589', '133', '3872');
INSERT INTO public.who_global_data_import VALUES (39297, '2020-04-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1997', '64586', '121', '3993');
INSERT INTO public.who_global_data_import VALUES (39298, '2020-04-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1634', '66220', '117', '4110');
INSERT INTO public.who_global_data_import VALUES (39299, '2020-04-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1972', '68192', '122', '4232');
INSERT INTO public.who_global_data_import VALUES (39300, '2020-04-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1837', '70029', '125', '4357');
INSERT INTO public.who_global_data_import VALUES (39301, '2020-04-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1657', '71686', '117', '4474');
INSERT INTO public.who_global_data_import VALUES (39302, '2020-04-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1617', '73303', '111', '4585');
INSERT INTO public.who_global_data_import VALUES (39303, '2020-04-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1574', '74877', '98', '4683');
INSERT INTO public.who_global_data_import VALUES (39304, '2020-04-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1512', '76389', '94', '4777');
INSERT INTO public.who_global_data_import VALUES (39305, '2020-04-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1606', '77995', '92', '4869');
INSERT INTO public.who_global_data_import VALUES (39306, '2020-04-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1499', '79494', '89', '4958');
INSERT INTO public.who_global_data_import VALUES (39307, '2020-04-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1374', '80868', '73', '5031');
INSERT INTO public.who_global_data_import VALUES (39308, '2020-04-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1343', '82211', '87', '5118');
INSERT INTO public.who_global_data_import VALUES (39309, '2020-04-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1294', '83505', '91', '5209');
INSERT INTO public.who_global_data_import VALUES (39310, '2020-04-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1297', '84802', '88', '5297');
INSERT INTO public.who_global_data_import VALUES (39311, '2020-04-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1194', '85996', '94', '5391');
INSERT INTO public.who_global_data_import VALUES (39312, '2020-04-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1030', '87026', '90', '5481');
INSERT INTO public.who_global_data_import VALUES (39313, '2020-04-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1168', '88194', '93', '5574');
INSERT INTO public.who_global_data_import VALUES (39314, '2020-04-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1134', '89328', '76', '5650');
INSERT INTO public.who_global_data_import VALUES (39315, '2020-04-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1153', '90481', '60', '5710');
INSERT INTO public.who_global_data_import VALUES (39316, '2020-04-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '991', '91472', '96', '5806');
INSERT INTO public.who_global_data_import VALUES (39317, '2020-04-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1112', '92584', '71', '5877');
INSERT INTO public.who_global_data_import VALUES (39318, '2020-04-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1073', '93657', '80', '5957');
INSERT INTO public.who_global_data_import VALUES (39319, '2020-04-30', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '983', '94640', '71', '6028');
INSERT INTO public.who_global_data_import VALUES (39320, '2020-05-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1006', '95646', '63', '6091');
INSERT INTO public.who_global_data_import VALUES (39321, '2020-05-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '802', '96448', '65', '6156');
INSERT INTO public.who_global_data_import VALUES (39322, '2020-05-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '976', '97424', '47', '6203');
INSERT INTO public.who_global_data_import VALUES (39323, '2020-05-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1223', '98647', '74', '6277');
INSERT INTO public.who_global_data_import VALUES (39324, '2020-05-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1323', '99970', '63', '6340');
INSERT INTO public.who_global_data_import VALUES (39325, '2020-05-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1680', '101650', '78', '6418');
INSERT INTO public.who_global_data_import VALUES (39326, '2020-05-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1485', '103135', '68', '6486');
INSERT INTO public.who_global_data_import VALUES (39327, '2020-05-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1556', '104691', '55', '6541');
INSERT INTO public.who_global_data_import VALUES (39328, '2020-05-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1529', '106220', '48', '6589');
INSERT INTO public.who_global_data_import VALUES (39329, '2020-05-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1383', '107603', '51', '6640');
INSERT INTO public.who_global_data_import VALUES (39330, '2020-05-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1683', '109286', '45', '6685');
INSERT INTO public.who_global_data_import VALUES (39331, '2020-05-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1481', '110767', '48', '6733');
INSERT INTO public.who_global_data_import VALUES (39332, '2020-05-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1958', '112725', '50', '6783');
INSERT INTO public.who_global_data_import VALUES (39333, '2020-05-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1808', '114533', '71', '6854');
INSERT INTO public.who_global_data_import VALUES (39334, '2020-05-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2102', '116635', '48', '6902');
INSERT INTO public.who_global_data_import VALUES (39335, '2020-05-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1757', '118392', '35', '6937');
INSERT INTO public.who_global_data_import VALUES (39336, '2020-05-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1806', '120198', '51', '6988');
INSERT INTO public.who_global_data_import VALUES (39337, '2020-05-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2294', '122492', '69', '7057');
INSERT INTO public.who_global_data_import VALUES (39338, '2020-05-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2111', '124603', '62', '7119');
INSERT INTO public.who_global_data_import VALUES (39339, '2020-05-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2346', '126949', '64', '7183');
INSERT INTO public.who_global_data_import VALUES (39340, '2020-05-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2392', '129341', '66', '7249');
INSERT INTO public.who_global_data_import VALUES (39341, '2020-05-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '0', '129341', '0', '7249');
INSERT INTO public.who_global_data_import VALUES (39342, '2020-05-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2311', '131652', '51', '7300');
INSERT INTO public.who_global_data_import VALUES (39343, '2020-05-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1869', '133521', '59', '7359');
INSERT INTO public.who_global_data_import VALUES (39344, '2020-05-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2180', '135701', '58', '7417');
INSERT INTO public.who_global_data_import VALUES (39345, '2020-05-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2023', '137724', '34', '7451');
INSERT INTO public.who_global_data_import VALUES (39346, '2020-05-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1787', '139511', '57', '7508');
INSERT INTO public.who_global_data_import VALUES (39347, '2020-05-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2080', '141591', '56', '7564');
INSERT INTO public.who_global_data_import VALUES (39348, '2020-05-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2258', '143849', '63', '7627');
INSERT INTO public.who_global_data_import VALUES (39349, '2020-05-30', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2819', '146668', '50', '7677');
INSERT INTO public.who_global_data_import VALUES (39350, '2020-05-31', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2282', '148950', '57', '7734');
INSERT INTO public.who_global_data_import VALUES (39351, '2020-06-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2516', '151466', '63', '7797');
INSERT INTO public.who_global_data_import VALUES (39352, '2020-06-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2979', '154445', '81', '7878');
INSERT INTO public.who_global_data_import VALUES (39353, '2020-06-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3117', '157562', '64', '7942');
INSERT INTO public.who_global_data_import VALUES (39354, '2020-06-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3134', '160696', '70', '8012');
INSERT INTO public.who_global_data_import VALUES (39355, '2020-06-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3574', '164270', '59', '8071');
INSERT INTO public.who_global_data_import VALUES (39356, '2020-06-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2886', '167156', '63', '8134');
INSERT INTO public.who_global_data_import VALUES (39357, '2020-06-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2269', '169425', '75', '8209');
INSERT INTO public.who_global_data_import VALUES (39358, '2020-06-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2364', '171789', '72', '8281');
INSERT INTO public.who_global_data_import VALUES (39359, '2020-06-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2043', '173832', '70', '8351');
INSERT INTO public.who_global_data_import VALUES (40036, '2020-02-07', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39360, '2020-06-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2095', '175927', '74', '8425');
INSERT INTO public.who_global_data_import VALUES (39361, '2020-06-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2011', '177938', '81', '8506');
INSERT INTO public.who_global_data_import VALUES (39362, '2020-06-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2238', '180176', '78', '8584');
INSERT INTO public.who_global_data_import VALUES (39363, '2020-06-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2369', '182545', '75', '8659');
INSERT INTO public.who_global_data_import VALUES (39364, '2020-06-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2410', '184955', '71', '8730');
INSERT INTO public.who_global_data_import VALUES (39365, '2020-06-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2472', '187427', '107', '8837');
INSERT INTO public.who_global_data_import VALUES (39366, '2020-06-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2449', '189876', '113', '8950');
INSERT INTO public.who_global_data_import VALUES (39367, '2020-06-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2563', '192439', '115', '9065');
INSERT INTO public.who_global_data_import VALUES (39368, '2020-06-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2612', '195051', '120', '9185');
INSERT INTO public.who_global_data_import VALUES (39369, '2020-06-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2596', '197647', '87', '9272');
INSERT INTO public.who_global_data_import VALUES (39370, '2020-06-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2615', '200262', '120', '9392');
INSERT INTO public.who_global_data_import VALUES (39371, '2020-06-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2322', '202584', '115', '9507');
INSERT INTO public.who_global_data_import VALUES (39372, '2020-06-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2368', '204952', '116', '9623');
INSERT INTO public.who_global_data_import VALUES (39373, '2020-06-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2573', '207525', '119', '9742');
INSERT INTO public.who_global_data_import VALUES (39374, '2020-06-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2445', '209970', '121', '9863');
INSERT INTO public.who_global_data_import VALUES (39375, '2020-06-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2531', '212501', '133', '9996');
INSERT INTO public.who_global_data_import VALUES (39376, '2020-06-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2595', '215096', '134', '10130');
INSERT INTO public.who_global_data_import VALUES (39377, '2020-06-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2628', '217724', '109', '10239');
INSERT INTO public.who_global_data_import VALUES (39378, '2020-06-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2456', '220180', '125', '10364');
INSERT INTO public.who_global_data_import VALUES (39379, '2020-06-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2489', '222669', '144', '10508');
INSERT INTO public.who_global_data_import VALUES (39380, '2020-06-30', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2536', '225205', '162', '10670');
INSERT INTO public.who_global_data_import VALUES (39381, '2020-07-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2457', '227662', '147', '10817');
INSERT INTO public.who_global_data_import VALUES (39382, '2020-07-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2549', '230211', '141', '10958');
INSERT INTO public.who_global_data_import VALUES (39383, '2020-07-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2652', '232863', '148', '11106');
INSERT INTO public.who_global_data_import VALUES (39384, '2020-07-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2566', '235429', '154', '11260');
INSERT INTO public.who_global_data_import VALUES (39385, '2020-07-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2449', '237878', '148', '11408');
INSERT INTO public.who_global_data_import VALUES (39386, '2020-07-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2560', '240438', '163', '11571');
INSERT INTO public.who_global_data_import VALUES (39387, '2020-07-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2613', '243051', '160', '11731');
INSERT INTO public.who_global_data_import VALUES (39388, '2020-07-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2637', '245688', '200', '11931');
INSERT INTO public.who_global_data_import VALUES (39389, '2020-07-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2691', '248379', '153', '12084');
INSERT INTO public.who_global_data_import VALUES (39390, '2020-07-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2079', '250458', '221', '12305');
INSERT INTO public.who_global_data_import VALUES (39391, '2020-07-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2262', '252720', '142', '12447');
INSERT INTO public.who_global_data_import VALUES (39392, '2020-07-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2397', '255117', '188', '12635');
INSERT INTO public.who_global_data_import VALUES (39393, '2020-07-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2186', '257303', '194', '12829');
INSERT INTO public.who_global_data_import VALUES (39394, '2020-07-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2349', '259652', '203', '13032');
INSERT INTO public.who_global_data_import VALUES (39395, '2020-07-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2521', '262173', '179', '13211');
INSERT INTO public.who_global_data_import VALUES (39396, '2020-07-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2388', '264561', '199', '13410');
INSERT INTO public.who_global_data_import VALUES (39397, '2020-07-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2500', '267061', '198', '13608');
INSERT INTO public.who_global_data_import VALUES (39398, '2020-07-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2379', '269440', '183', '13791');
INSERT INTO public.who_global_data_import VALUES (39399, '2020-07-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2166', '271606', '188', '13979');
INSERT INTO public.who_global_data_import VALUES (39400, '2020-07-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2182', '273788', '209', '14188');
INSERT INTO public.who_global_data_import VALUES (39401, '2020-07-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2414', '276202', '217', '14405');
INSERT INTO public.who_global_data_import VALUES (39402, '2020-07-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2625', '278827', '229', '14634');
INSERT INTO public.who_global_data_import VALUES (39403, '2020-07-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2586', '281413', '219', '14853');
INSERT INTO public.who_global_data_import VALUES (39404, '2020-07-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2621', '284034', '221', '15074');
INSERT INTO public.who_global_data_import VALUES (39405, '2020-07-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2489', '286523', '215', '15289');
INSERT INTO public.who_global_data_import VALUES (39406, '2020-07-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2316', '288839', '195', '15484');
INSERT INTO public.who_global_data_import VALUES (39407, '2020-07-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2333', '291172', '216', '15700');
INSERT INTO public.who_global_data_import VALUES (39408, '2020-07-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2434', '293606', '212', '15912');
INSERT INTO public.who_global_data_import VALUES (39409, '2020-07-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2667', '296273', '235', '16147');
INSERT INTO public.who_global_data_import VALUES (39410, '2020-07-30', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2636', '298909', '196', '16343');
INSERT INTO public.who_global_data_import VALUES (39411, '2020-07-31', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2621', '301530', '226', '16569');
INSERT INTO public.who_global_data_import VALUES (39412, '2020-08-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2674', '304204', '197', '16766');
INSERT INTO public.who_global_data_import VALUES (39413, '2020-08-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2548', '306752', '216', '16982');
INSERT INTO public.who_global_data_import VALUES (39414, '2020-08-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2685', '309437', '208', '17190');
INSERT INTO public.who_global_data_import VALUES (39415, '2020-08-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2598', '312035', '215', '17405');
INSERT INTO public.who_global_data_import VALUES (39416, '2020-08-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2751', '314786', '212', '17617');
INSERT INTO public.who_global_data_import VALUES (39417, '2020-08-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2697', '317483', '185', '17802');
INSERT INTO public.who_global_data_import VALUES (39418, '2020-08-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2634', '320117', '174', '17976');
INSERT INTO public.who_global_data_import VALUES (39419, '2020-08-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2450', '322567', '156', '18132');
INSERT INTO public.who_global_data_import VALUES (39420, '2020-08-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2125', '324692', '132', '18264');
INSERT INTO public.who_global_data_import VALUES (39421, '2020-08-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2020', '326712', '163', '18427');
INSERT INTO public.who_global_data_import VALUES (39422, '2020-08-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2132', '328844', '189', '18616');
INSERT INTO public.who_global_data_import VALUES (39423, '2020-08-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2345', '331189', '184', '18800');
INSERT INTO public.who_global_data_import VALUES (39424, '2020-08-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2510', '333699', '188', '18988');
INSERT INTO public.who_global_data_import VALUES (39425, '2020-08-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2625', '336324', '174', '19162');
INSERT INTO public.who_global_data_import VALUES (39426, '2020-08-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2501', '338825', '169', '19331');
INSERT INTO public.who_global_data_import VALUES (39427, '2020-08-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2245', '341070', '161', '19492');
INSERT INTO public.who_global_data_import VALUES (39428, '2020-08-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2133', '343203', '147', '19639');
INSERT INTO public.who_global_data_import VALUES (39429, '2020-08-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2247', '345450', '165', '19804');
INSERT INTO public.who_global_data_import VALUES (39430, '2020-08-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2385', '347835', '168', '19972');
INSERT INTO public.who_global_data_import VALUES (39431, '2020-08-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2444', '350279', '153', '20125');
INSERT INTO public.who_global_data_import VALUES (39432, '2020-08-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2279', '352558', '139', '20264');
INSERT INTO public.who_global_data_import VALUES (39433, '2020-08-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2206', '354764', '112', '20376');
INSERT INTO public.who_global_data_import VALUES (39434, '2020-08-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2028', '356792', '126', '20502');
INSERT INTO public.who_global_data_import VALUES (39435, '2020-08-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2113', '358905', '141', '20643');
INSERT INTO public.who_global_data_import VALUES (39436, '2020-08-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2245', '361150', '133', '20776');
INSERT INTO public.who_global_data_import VALUES (39437, '2020-08-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2213', '363363', '125', '20901');
INSERT INTO public.who_global_data_import VALUES (39438, '2020-08-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2243', '365606', '119', '21020');
INSERT INTO public.who_global_data_import VALUES (39439, '2020-08-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2190', '367796', '117', '21137');
INSERT INTO public.who_global_data_import VALUES (39440, '2020-08-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2115', '369911', '112', '21249');
INSERT INTO public.who_global_data_import VALUES (40037, '2020-02-08', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39441, '2020-08-30', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1905', '371816', '110', '21359');
INSERT INTO public.who_global_data_import VALUES (39442, '2020-08-31', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1754', '373570', '103', '21462');
INSERT INTO public.who_global_data_import VALUES (39443, '2020-09-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1642', '375212', '109', '21571');
INSERT INTO public.who_global_data_import VALUES (39444, '2020-09-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1682', '376894', '101', '21672');
INSERT INTO public.who_global_data_import VALUES (39445, '2020-09-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1858', '378752', '125', '21797');
INSERT INTO public.who_global_data_import VALUES (39446, '2020-09-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1994', '380746', '129', '21926');
INSERT INTO public.who_global_data_import VALUES (39447, '2020-09-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2026', '382772', '118', '22044');
INSERT INTO public.who_global_data_import VALUES (39448, '2020-09-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1894', '384666', '110', '22154');
INSERT INTO public.who_global_data_import VALUES (39449, '2020-09-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '1992', '386658', '139', '22293');
INSERT INTO public.who_global_data_import VALUES (39450, '2020-09-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2152', '388810', '117', '22410');
INSERT INTO public.who_global_data_import VALUES (39451, '2020-09-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2302', '391112', '132', '22542');
INSERT INTO public.who_global_data_import VALUES (39452, '2020-09-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2313', '393425', '127', '22669');
INSERT INTO public.who_global_data_import VALUES (39453, '2020-09-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2063', '395488', '129', '22798');
INSERT INTO public.who_global_data_import VALUES (39454, '2020-09-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2313', '397801', '115', '22913');
INSERT INTO public.who_global_data_import VALUES (39455, '2020-09-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2139', '399940', '116', '23029');
INSERT INTO public.who_global_data_import VALUES (39456, '2020-09-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2089', '402029', '128', '23157');
INSERT INTO public.who_global_data_import VALUES (39457, '2020-09-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2619', '404648', '156', '23313');
INSERT INTO public.who_global_data_import VALUES (39458, '2020-09-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2705', '407353', '140', '23453');
INSERT INTO public.who_global_data_import VALUES (39459, '2020-09-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2981', '410334', '179', '23632');
INSERT INTO public.who_global_data_import VALUES (39460, '2020-09-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2815', '413149', '176', '23808');
INSERT INTO public.who_global_data_import VALUES (39461, '2020-09-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3049', '416198', '144', '23952');
INSERT INTO public.who_global_data_import VALUES (39462, '2020-09-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '2845', '419043', '166', '24118');
INSERT INTO public.who_global_data_import VALUES (39463, '2020-09-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3097', '422140', '183', '24301');
INSERT INTO public.who_global_data_import VALUES (39464, '2020-09-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3341', '425481', '177', '24478');
INSERT INTO public.who_global_data_import VALUES (39465, '2020-09-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3712', '429193', '178', '24656');
INSERT INTO public.who_global_data_import VALUES (39466, '2020-09-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3605', '432798', '184', '24840');
INSERT INTO public.who_global_data_import VALUES (39467, '2020-09-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3521', '436319', '175', '25015');
INSERT INTO public.who_global_data_import VALUES (39468, '2020-09-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3563', '439882', '207', '25222');
INSERT INTO public.who_global_data_import VALUES (39469, '2020-09-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3204', '443086', '172', '25394');
INSERT INTO public.who_global_data_import VALUES (39470, '2020-09-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3362', '446448', '195', '25589');
INSERT INTO public.who_global_data_import VALUES (39471, '2020-09-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3512', '449960', '190', '25779');
INSERT INTO public.who_global_data_import VALUES (39472, '2020-09-30', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3677', '453637', '207', '25986');
INSERT INTO public.who_global_data_import VALUES (39473, '2020-10-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3582', '457219', '183', '26169');
INSERT INTO public.who_global_data_import VALUES (39474, '2020-10-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3825', '461044', '211', '26380');
INSERT INTO public.who_global_data_import VALUES (39475, '2020-10-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3552', '464596', '187', '26567');
INSERT INTO public.who_global_data_import VALUES (39476, '2020-10-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3523', '468119', '179', '26746');
INSERT INTO public.who_global_data_import VALUES (39477, '2020-10-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3653', '471772', '211', '26957');
INSERT INTO public.who_global_data_import VALUES (39478, '2020-10-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3902', '475674', '235', '27192');
INSERT INTO public.who_global_data_import VALUES (39479, '2020-10-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '4151', '479825', '227', '27419');
INSERT INTO public.who_global_data_import VALUES (39480, '2020-10-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '4019', '483844', '239', '27658');
INSERT INTO public.who_global_data_import VALUES (39481, '2020-10-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '4392', '488236', '230', '27888');
INSERT INTO public.who_global_data_import VALUES (39482, '2020-10-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '4142', '492378', '210', '28098');
INSERT INTO public.who_global_data_import VALUES (39483, '2020-10-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3875', '496253', '195', '28293');
INSERT INTO public.who_global_data_import VALUES (39484, '2020-10-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3822', '500075', '251', '28544');
INSERT INTO public.who_global_data_import VALUES (39485, '2020-10-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '4206', '504281', '272', '28816');
INSERT INTO public.who_global_data_import VALUES (39486, '2020-10-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '4108', '508389', '254', '29070');
INSERT INTO public.who_global_data_import VALUES (39487, '2020-10-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '4830', '513219', '279', '29349');
INSERT INTO public.who_global_data_import VALUES (39488, '2020-10-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '4616', '517835', '256', '29605');
INSERT INTO public.who_global_data_import VALUES (39489, '2020-10-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '4552', '522387', '265', '29870');
INSERT INTO public.who_global_data_import VALUES (39490, '2020-10-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '4103', '526490', '253', '30123');
INSERT INTO public.who_global_data_import VALUES (39491, '2020-10-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '3890', '530380', '252', '30375');
INSERT INTO public.who_global_data_import VALUES (39492, '2020-10-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '4251', '534631', '337', '30712');
INSERT INTO public.who_global_data_import VALUES (39493, '2020-10-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5039', '539670', '322', '31034');
INSERT INTO public.who_global_data_import VALUES (39494, '2020-10-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5616', '545286', '312', '31346');
INSERT INTO public.who_global_data_import VALUES (39495, '2020-10-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5471', '550757', '304', '31650');
INSERT INTO public.who_global_data_import VALUES (39496, '2020-10-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6134', '556891', '335', '31985');
INSERT INTO public.who_global_data_import VALUES (39497, '2020-10-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5814', '562705', '335', '32320');
INSERT INTO public.who_global_data_import VALUES (39498, '2020-10-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6191', '568896', '296', '32616');
INSERT INTO public.who_global_data_import VALUES (39499, '2020-10-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5960', '574856', '337', '32953');
INSERT INTO public.who_global_data_import VALUES (39500, '2020-10-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6968', '581824', '346', '33299');
INSERT INTO public.who_global_data_import VALUES (39501, '2020-10-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6824', '588648', '415', '33714');
INSERT INTO public.who_global_data_import VALUES (39502, '2020-10-30', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '8293', '596941', '399', '34113');
INSERT INTO public.who_global_data_import VALUES (39503, '2020-10-31', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '8011', '604952', '365', '34478');
INSERT INTO public.who_global_data_import VALUES (39504, '2020-11-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '7820', '612772', '386', '34864');
INSERT INTO public.who_global_data_import VALUES (39505, '2020-11-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '7719', '620491', '434', '35298');
INSERT INTO public.who_global_data_import VALUES (39506, '2020-11-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '8289', '628780', '440', '35738');
INSERT INTO public.who_global_data_import VALUES (39507, '2020-11-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '8932', '637712', '422', '36160');
INSERT INTO public.who_global_data_import VALUES (39508, '2020-11-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '8452', '646164', '419', '36579');
INSERT INTO public.who_global_data_import VALUES (39509, '2020-11-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '8772', '654936', '406', '36985');
INSERT INTO public.who_global_data_import VALUES (39510, '2020-11-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '8864', '663800', '424', '37409');
INSERT INTO public.who_global_data_import VALUES (39511, '2020-11-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '9450', '673250', '423', '37832');
INSERT INTO public.who_global_data_import VALUES (39512, '2020-11-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '9236', '682486', '459', '38291');
INSERT INTO public.who_global_data_import VALUES (39513, '2020-11-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '10463', '692949', '458', '38749');
INSERT INTO public.who_global_data_import VALUES (39514, '2020-11-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '10339', '703288', '453', '39202');
INSERT INTO public.who_global_data_import VALUES (39515, '2020-11-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '11780', '715068', '462', '39664');
INSERT INTO public.who_global_data_import VALUES (39516, '2020-11-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '11517', '726585', '457', '40121');
INSERT INTO public.who_global_data_import VALUES (39517, '2020-11-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '11737', '738322', '461', '40582');
INSERT INTO public.who_global_data_import VALUES (39518, '2020-11-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '11203', '749525', '452', '41034');
INSERT INTO public.who_global_data_import VALUES (39519, '2020-11-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '12543', '762068', '459', '41493');
INSERT INTO public.who_global_data_import VALUES (39520, '2020-11-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13053', '775121', '486', '41979');
INSERT INTO public.who_global_data_import VALUES (39598, '2021-02-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6820', '1431416', '72', '58110');
INSERT INTO public.who_global_data_import VALUES (39521, '2020-11-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13352', '788473', '482', '42461');
INSERT INTO public.who_global_data_import VALUES (39522, '2020-11-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13421', '801894', '480', '42941');
INSERT INTO public.who_global_data_import VALUES (39523, '2020-11-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13223', '815117', '476', '43417');
INSERT INTO public.who_global_data_import VALUES (39524, '2020-11-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13260', '828377', '479', '43896');
INSERT INTO public.who_global_data_import VALUES (39525, '2020-11-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '12931', '841308', '431', '44327');
INSERT INTO public.who_global_data_import VALUES (39526, '2020-11-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13053', '854361', '475', '44802');
INSERT INTO public.who_global_data_import VALUES (39527, '2020-11-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '12460', '866821', '453', '45255');
INSERT INTO public.who_global_data_import VALUES (39528, '2020-11-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13721', '880542', '483', '45738');
INSERT INTO public.who_global_data_import VALUES (39529, '2020-11-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13843', '894385', '469', '46207');
INSERT INTO public.who_global_data_import VALUES (39530, '2020-11-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13961', '908346', '482', '46689');
INSERT INTO public.who_global_data_import VALUES (39531, '2020-11-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '14051', '922397', '406', '47095');
INSERT INTO public.who_global_data_import VALUES (39532, '2020-11-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13402', '935799', '391', '47486');
INSERT INTO public.who_global_data_import VALUES (39533, '2020-11-30', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '12950', '948749', '389', '47875');
INSERT INTO public.who_global_data_import VALUES (39534, '2020-12-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13321', '962070', '371', '48246');
INSERT INTO public.who_global_data_import VALUES (39535, '2020-12-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13881', '975951', '382', '48628');
INSERT INTO public.who_global_data_import VALUES (39536, '2020-12-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13621', '989572', '362', '48990');
INSERT INTO public.who_global_data_import VALUES (39537, '2020-12-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13922', '1003494', '358', '49348');
INSERT INTO public.who_global_data_import VALUES (39538, '2020-12-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '13341', '1016835', '347', '49695');
INSERT INTO public.who_global_data_import VALUES (39539, '2020-12-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '12151', '1028986', '321', '50016');
INSERT INTO public.who_global_data_import VALUES (39540, '2020-12-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '11561', '1040547', '294', '50310');
INSERT INTO public.who_global_data_import VALUES (39541, '2020-12-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '10827', '1051374', '284', '50594');
INSERT INTO public.who_global_data_import VALUES (39542, '2020-12-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '11023', '1062397', '323', '50917');
INSERT INTO public.who_global_data_import VALUES (39543, '2020-12-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '10223', '1072620', '295', '51212');
INSERT INTO public.who_global_data_import VALUES (39544, '2020-12-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '10403', '1083023', '284', '51496');
INSERT INTO public.who_global_data_import VALUES (39545, '2020-12-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '9594', '1092617', '232', '51728');
INSERT INTO public.who_global_data_import VALUES (39546, '2020-12-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '8201', '1100818', '221', '51949');
INSERT INTO public.who_global_data_import VALUES (39547, '2020-12-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '7451', '1108269', '247', '52196');
INSERT INTO public.who_global_data_import VALUES (39548, '2020-12-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '7501', '1115770', '251', '52447');
INSERT INTO public.who_global_data_import VALUES (39549, '2020-12-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '7704', '1123474', '223', '52670');
INSERT INTO public.who_global_data_import VALUES (39550, '2020-12-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '7603', '1131077', '213', '52883');
INSERT INTO public.who_global_data_import VALUES (39551, '2020-12-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '7453', '1138530', '212', '53095');
INSERT INTO public.who_global_data_import VALUES (39552, '2020-12-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '7121', '1145651', '178', '53273');
INSERT INTO public.who_global_data_import VALUES (39553, '2020-12-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6421', '1152072', '175', '53448');
INSERT INTO public.who_global_data_import VALUES (39554, '2020-12-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6312', '1158384', '177', '53625');
INSERT INTO public.who_global_data_import VALUES (39555, '2020-12-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6151', '1164535', '191', '53816');
INSERT INTO public.who_global_data_import VALUES (39556, '2020-12-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6208', '1170743', '187', '54003');
INSERT INTO public.who_global_data_import VALUES (39557, '2020-12-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6261', '1177004', '153', '54156');
INSERT INTO public.who_global_data_import VALUES (39558, '2020-12-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6178', '1183182', '152', '54308');
INSERT INTO public.who_global_data_import VALUES (39559, '2020-12-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6021', '1189203', '132', '54440');
INSERT INTO public.who_global_data_import VALUES (39560, '2020-12-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5760', '1194963', '134', '54574');
INSERT INTO public.who_global_data_import VALUES (39561, '2020-12-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5502', '1200465', '119', '54693');
INSERT INTO public.who_global_data_import VALUES (39562, '2020-12-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5908', '1206373', '121', '54814');
INSERT INTO public.who_global_data_import VALUES (39563, '2020-12-30', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6108', '1212481', '132', '54946');
INSERT INTO public.who_global_data_import VALUES (39564, '2020-12-31', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6272', '1218753', '149', '55095');
INSERT INTO public.who_global_data_import VALUES (39565, '2021-01-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6390', '1225143', '128', '55223');
INSERT INTO public.who_global_data_import VALUES (39566, '2021-01-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6286', '1231429', '114', '55337');
INSERT INTO public.who_global_data_import VALUES (39567, '2021-01-03', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6045', '1237474', '101', '55438');
INSERT INTO public.who_global_data_import VALUES (39568, '2021-01-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5960', '1243434', '102', '55540');
INSERT INTO public.who_global_data_import VALUES (39569, '2021-01-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6073', '1249507', '110', '55650');
INSERT INTO public.who_global_data_import VALUES (39570, '2021-01-06', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6113', '1255620', '98', '55748');
INSERT INTO public.who_global_data_import VALUES (39571, '2021-01-07', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6283', '1261903', '82', '55830');
INSERT INTO public.who_global_data_import VALUES (39572, '2021-01-08', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6360', '1268263', '103', '55933');
INSERT INTO public.who_global_data_import VALUES (39573, '2021-01-09', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6251', '1274514', '85', '56018');
INSERT INTO public.who_global_data_import VALUES (39574, '2021-01-10', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5924', '1280438', '82', '56100');
INSERT INTO public.who_global_data_import VALUES (39575, '2021-01-11', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5968', '1286406', '71', '56171');
INSERT INTO public.who_global_data_import VALUES (39576, '2021-01-12', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6208', '1292614', '91', '56262');
INSERT INTO public.who_global_data_import VALUES (39577, '2021-01-13', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6408', '1299022', '98', '56360');
INSERT INTO public.who_global_data_import VALUES (39578, '2021-01-14', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6317', '1305339', '97', '56457');
INSERT INTO public.who_global_data_import VALUES (39579, '2021-01-15', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6471', '1311810', '81', '56538');
INSERT INTO public.who_global_data_import VALUES (39580, '2021-01-16', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6485', '1318295', '83', '56621');
INSERT INTO public.who_global_data_import VALUES (39581, '2021-01-17', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6100', '1324395', '96', '56717');
INSERT INTO public.who_global_data_import VALUES (39582, '2021-01-18', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6016', '1330411', '86', '56803');
INSERT INTO public.who_global_data_import VALUES (39583, '2021-01-19', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5806', '1336217', '83', '56886');
INSERT INTO public.who_global_data_import VALUES (39584, '2021-01-20', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5917', '1342134', '87', '56973');
INSERT INTO public.who_global_data_import VALUES (39585, '2021-01-21', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6182', '1348316', '84', '57057');
INSERT INTO public.who_global_data_import VALUES (39586, '2021-01-22', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6204', '1354520', '93', '57150');
INSERT INTO public.who_global_data_import VALUES (39587, '2021-01-23', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6305', '1360825', '75', '57225');
INSERT INTO public.who_global_data_import VALUES (39588, '2021-01-24', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6207', '1367032', '69', '57294');
INSERT INTO public.who_global_data_import VALUES (39589, '2021-01-25', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '5945', '1372977', '89', '57383');
INSERT INTO public.who_global_data_import VALUES (39590, '2021-01-26', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6309', '1379286', '98', '57481');
INSERT INTO public.who_global_data_import VALUES (39591, '2021-01-27', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6420', '1385706', '79', '57560');
INSERT INTO public.who_global_data_import VALUES (39592, '2021-01-28', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6608', '1392314', '91', '57651');
INSERT INTO public.who_global_data_import VALUES (39593, '2021-01-29', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6527', '1398841', '85', '57736');
INSERT INTO public.who_global_data_import VALUES (39594, '2021-01-30', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6573', '1405414', '71', '57807');
INSERT INTO public.who_global_data_import VALUES (39595, '2021-01-31', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6317', '1411731', '82', '57889');
INSERT INTO public.who_global_data_import VALUES (39596, '2021-02-01', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6268', '1417999', '70', '57959');
INSERT INTO public.who_global_data_import VALUES (39597, '2021-02-02', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6597', '1424596', '79', '58038');
INSERT INTO public.who_global_data_import VALUES (40033, '2020-02-04', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39599, '2021-02-04', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '6870', '1438286', '79', '58189');
INSERT INTO public.who_global_data_import VALUES (39600, '2021-02-05', 'IR', 'Iran (Islamic Republic of)', 'EMRO', '7040', '1445326', '67', '58256');
INSERT INTO public.who_global_data_import VALUES (39601, '2020-01-03', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39602, '2020-01-04', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39603, '2020-01-05', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39604, '2020-01-06', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39605, '2020-01-07', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39606, '2020-01-08', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39607, '2020-01-09', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39608, '2020-01-10', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39609, '2020-01-11', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39610, '2020-01-12', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39611, '2020-01-13', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39612, '2020-01-14', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39613, '2020-01-15', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39614, '2020-01-16', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39615, '2020-01-17', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39616, '2020-01-18', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39617, '2020-01-19', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39618, '2020-01-20', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39619, '2020-01-21', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39620, '2020-01-22', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39621, '2020-01-23', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39622, '2020-01-24', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39623, '2020-01-25', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39624, '2020-01-26', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39625, '2020-01-27', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39626, '2020-01-28', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39627, '2020-01-29', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39628, '2020-01-30', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39629, '2020-01-31', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39630, '2020-02-01', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39631, '2020-02-02', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39632, '2020-02-03', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39633, '2020-02-04', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39634, '2020-02-05', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39635, '2020-02-06', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39636, '2020-02-07', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39637, '2020-02-08', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39638, '2020-02-09', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39639, '2020-02-10', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39640, '2020-02-11', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39641, '2020-02-12', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39642, '2020-02-13', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39643, '2020-02-14', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39644, '2020-02-15', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39645, '2020-02-16', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39646, '2020-02-17', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39647, '2020-02-18', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39648, '2020-02-19', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39649, '2020-02-20', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39650, '2020-02-21', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39651, '2020-02-22', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39652, '2020-02-23', 'IQ', 'Iraq', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39653, '2020-02-24', 'IQ', 'Iraq', 'EMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39654, '2020-02-25', 'IQ', 'Iraq', 'EMRO', '4', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39655, '2020-02-26', 'IQ', 'Iraq', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39656, '2020-02-27', 'IQ', 'Iraq', 'EMRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39657, '2020-02-28', 'IQ', 'Iraq', 'EMRO', '2', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39658, '2020-02-29', 'IQ', 'Iraq', 'EMRO', '5', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39659, '2020-03-01', 'IQ', 'Iraq', 'EMRO', '6', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39660, '2020-03-02', 'IQ', 'Iraq', 'EMRO', '7', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39661, '2020-03-03', 'IQ', 'Iraq', 'EMRO', '5', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (39662, '2020-03-04', 'IQ', 'Iraq', 'EMRO', '5', '40', '2', '2');
INSERT INTO public.who_global_data_import VALUES (39663, '2020-03-05', 'IQ', 'Iraq', 'EMRO', '0', '40', '0', '2');
INSERT INTO public.who_global_data_import VALUES (39664, '2020-03-06', 'IQ', 'Iraq', 'EMRO', '8', '48', '2', '4');
INSERT INTO public.who_global_data_import VALUES (39665, '2020-03-07', 'IQ', 'Iraq', 'EMRO', '10', '58', '0', '4');
INSERT INTO public.who_global_data_import VALUES (39666, '2020-03-08', 'IQ', 'Iraq', 'EMRO', '6', '64', '0', '4');
INSERT INTO public.who_global_data_import VALUES (39667, '2020-03-09', 'IQ', 'Iraq', 'EMRO', '0', '64', '0', '4');
INSERT INTO public.who_global_data_import VALUES (39668, '2020-03-10', 'IQ', 'Iraq', 'EMRO', '1', '65', '2', '6');
INSERT INTO public.who_global_data_import VALUES (39669, '2020-03-11', 'IQ', 'Iraq', 'EMRO', '9', '74', '1', '7');
INSERT INTO public.who_global_data_import VALUES (39670, '2020-03-12', 'IQ', 'Iraq', 'EMRO', '0', '74', '0', '7');
INSERT INTO public.who_global_data_import VALUES (39671, '2020-03-13', 'IQ', 'Iraq', 'EMRO', '0', '74', '0', '7');
INSERT INTO public.who_global_data_import VALUES (39672, '2020-03-14', 'IQ', 'Iraq', 'EMRO', '23', '97', '2', '9');
INSERT INTO public.who_global_data_import VALUES (39673, '2020-03-15', 'IQ', 'Iraq', 'EMRO', '31', '128', '0', '9');
INSERT INTO public.who_global_data_import VALUES (39674, '2020-03-16', 'IQ', 'Iraq', 'EMRO', '0', '128', '0', '9');
INSERT INTO public.who_global_data_import VALUES (39675, '2020-03-17', 'IQ', 'Iraq', 'EMRO', '30', '158', '2', '11');
INSERT INTO public.who_global_data_import VALUES (39676, '2020-03-18', 'IQ', 'Iraq', 'EMRO', '10', '168', '1', '12');
INSERT INTO public.who_global_data_import VALUES (39677, '2020-03-19', 'IQ', 'Iraq', 'EMRO', '13', '181', '0', '12');
INSERT INTO public.who_global_data_import VALUES (39678, '2020-03-20', 'IQ', 'Iraq', 'EMRO', '12', '193', '2', '14');
INSERT INTO public.who_global_data_import VALUES (39679, '2020-03-21', 'IQ', 'Iraq', 'EMRO', '21', '214', '3', '17');
INSERT INTO public.who_global_data_import VALUES (39680, '2020-03-22', 'IQ', 'Iraq', 'EMRO', '19', '233', '3', '20');
INSERT INTO public.who_global_data_import VALUES (39681, '2020-03-23', 'IQ', 'Iraq', 'EMRO', '33', '266', '3', '23');
INSERT INTO public.who_global_data_import VALUES (39682, '2020-03-24', 'IQ', 'Iraq', 'EMRO', '50', '316', '4', '27');
INSERT INTO public.who_global_data_import VALUES (39683, '2020-03-25', 'IQ', 'Iraq', 'EMRO', '30', '346', '2', '29');
INSERT INTO public.who_global_data_import VALUES (39684, '2020-03-26', 'IQ', 'Iraq', 'EMRO', '36', '382', '7', '36');
INSERT INTO public.who_global_data_import VALUES (39685, '2020-03-27', 'IQ', 'Iraq', 'EMRO', '76', '458', '4', '40');
INSERT INTO public.who_global_data_import VALUES (39686, '2020-03-28', 'IQ', 'Iraq', 'EMRO', '48', '506', '2', '42');
INSERT INTO public.who_global_data_import VALUES (39687, '2020-03-29', 'IQ', 'Iraq', 'EMRO', '41', '547', '0', '42');
INSERT INTO public.who_global_data_import VALUES (39688, '2020-03-30', 'IQ', 'Iraq', 'EMRO', '0', '547', '0', '42');
INSERT INTO public.who_global_data_import VALUES (39689, '2020-03-31', 'IQ', 'Iraq', 'EMRO', '83', '630', '4', '46');
INSERT INTO public.who_global_data_import VALUES (39690, '2020-04-01', 'IQ', 'Iraq', 'EMRO', '64', '694', '4', '50');
INSERT INTO public.who_global_data_import VALUES (39691, '2020-04-02', 'IQ', 'Iraq', 'EMRO', '78', '772', '4', '54');
INSERT INTO public.who_global_data_import VALUES (39692, '2020-04-03', 'IQ', 'Iraq', 'EMRO', '48', '820', '0', '54');
INSERT INTO public.who_global_data_import VALUES (39693, '2020-04-04', 'IQ', 'Iraq', 'EMRO', '58', '878', '2', '56');
INSERT INTO public.who_global_data_import VALUES (39694, '2020-04-05', 'IQ', 'Iraq', 'EMRO', '83', '961', '5', '61');
INSERT INTO public.who_global_data_import VALUES (39695, '2020-04-06', 'IQ', 'Iraq', 'EMRO', '70', '1031', '3', '64');
INSERT INTO public.who_global_data_import VALUES (39696, '2020-04-07', 'IQ', 'Iraq', 'EMRO', '0', '1031', '0', '64');
INSERT INTO public.who_global_data_import VALUES (39697, '2020-04-08', 'IQ', 'Iraq', 'EMRO', '91', '1122', '1', '65');
INSERT INTO public.who_global_data_import VALUES (39698, '2020-04-09', 'IQ', 'Iraq', 'EMRO', '80', '1202', '4', '69');
INSERT INTO public.who_global_data_import VALUES (39699, '2020-04-10', 'IQ', 'Iraq', 'EMRO', '77', '1279', '1', '70');
INSERT INTO public.who_global_data_import VALUES (39700, '2020-04-11', 'IQ', 'Iraq', 'EMRO', '39', '1318', '2', '72');
INSERT INTO public.who_global_data_import VALUES (39701, '2020-04-12', 'IQ', 'Iraq', 'EMRO', '34', '1352', '4', '76');
INSERT INTO public.who_global_data_import VALUES (39702, '2020-04-13', 'IQ', 'Iraq', 'EMRO', '26', '1378', '2', '78');
INSERT INTO public.who_global_data_import VALUES (39703, '2020-04-14', 'IQ', 'Iraq', 'EMRO', '22', '1400', '0', '78');
INSERT INTO public.who_global_data_import VALUES (39704, '2020-04-15', 'IQ', 'Iraq', 'EMRO', '15', '1415', '1', '79');
INSERT INTO public.who_global_data_import VALUES (39705, '2020-04-16', 'IQ', 'Iraq', 'EMRO', '19', '1434', '1', '80');
INSERT INTO public.who_global_data_import VALUES (39706, '2020-04-17', 'IQ', 'Iraq', 'EMRO', '0', '1434', '0', '80');
INSERT INTO public.who_global_data_import VALUES (39707, '2020-04-18', 'IQ', 'Iraq', 'EMRO', '48', '1482', '1', '81');
INSERT INTO public.who_global_data_import VALUES (39708, '2020-04-19', 'IQ', 'Iraq', 'EMRO', '31', '1513', '1', '82');
INSERT INTO public.who_global_data_import VALUES (39709, '2020-04-20', 'IQ', 'Iraq', 'EMRO', '61', '1574', '0', '82');
INSERT INTO public.who_global_data_import VALUES (39710, '2020-04-21', 'IQ', 'Iraq', 'EMRO', '28', '1602', '1', '83');
INSERT INTO public.who_global_data_import VALUES (39711, '2020-04-22', 'IQ', 'Iraq', 'EMRO', '0', '1602', '0', '83');
INSERT INTO public.who_global_data_import VALUES (39712, '2020-04-23', 'IQ', 'Iraq', 'EMRO', '75', '1677', '0', '83');
INSERT INTO public.who_global_data_import VALUES (39713, '2020-04-24', 'IQ', 'Iraq', 'EMRO', '0', '1677', '0', '83');
INSERT INTO public.who_global_data_import VALUES (39714, '2020-04-25', 'IQ', 'Iraq', 'EMRO', '31', '1708', '3', '86');
INSERT INTO public.who_global_data_import VALUES (39715, '2020-04-26', 'IQ', 'Iraq', 'EMRO', '55', '1763', '0', '86');
INSERT INTO public.who_global_data_import VALUES (39716, '2020-04-27', 'IQ', 'Iraq', 'EMRO', '57', '1820', '1', '87');
INSERT INTO public.who_global_data_import VALUES (39717, '2020-04-28', 'IQ', 'Iraq', 'EMRO', '27', '1847', '1', '88');
INSERT INTO public.who_global_data_import VALUES (39718, '2020-04-29', 'IQ', 'Iraq', 'EMRO', '81', '1928', '2', '90');
INSERT INTO public.who_global_data_import VALUES (39719, '2020-04-30', 'IQ', 'Iraq', 'EMRO', '75', '2003', '2', '92');
INSERT INTO public.who_global_data_import VALUES (39720, '2020-05-01', 'IQ', 'Iraq', 'EMRO', '82', '2085', '1', '93');
INSERT INTO public.who_global_data_import VALUES (39721, '2020-05-02', 'IQ', 'Iraq', 'EMRO', '68', '2153', '1', '94');
INSERT INTO public.who_global_data_import VALUES (39722, '2020-05-03', 'IQ', 'Iraq', 'EMRO', '66', '2219', '1', '95');
INSERT INTO public.who_global_data_import VALUES (39723, '2020-05-04', 'IQ', 'Iraq', 'EMRO', '77', '2296', '2', '97');
INSERT INTO public.who_global_data_import VALUES (39724, '2020-05-05', 'IQ', 'Iraq', 'EMRO', '50', '2346', '1', '98');
INSERT INTO public.who_global_data_import VALUES (39725, '2020-05-06', 'IQ', 'Iraq', 'EMRO', '85', '2431', '4', '102');
INSERT INTO public.who_global_data_import VALUES (39726, '2020-05-07', 'IQ', 'Iraq', 'EMRO', '49', '2480', '0', '102');
INSERT INTO public.who_global_data_import VALUES (39727, '2020-05-08', 'IQ', 'Iraq', 'EMRO', '63', '2543', '0', '102');
INSERT INTO public.who_global_data_import VALUES (39728, '2020-05-09', 'IQ', 'Iraq', 'EMRO', '60', '2603', '2', '104');
INSERT INTO public.who_global_data_import VALUES (39729, '2020-05-10', 'IQ', 'Iraq', 'EMRO', '164', '2767', '5', '109');
INSERT INTO public.who_global_data_import VALUES (39730, '2020-05-11', 'IQ', 'Iraq', 'EMRO', '51', '2818', '1', '110');
INSERT INTO public.who_global_data_import VALUES (39731, '2020-05-12', 'IQ', 'Iraq', 'EMRO', '95', '2913', '2', '112');
INSERT INTO public.who_global_data_import VALUES (39732, '2020-05-13', 'IQ', 'Iraq', 'EMRO', '119', '3032', '3', '115');
INSERT INTO public.who_global_data_import VALUES (39733, '2020-05-14', 'IQ', 'Iraq', 'EMRO', '111', '3143', '0', '115');
INSERT INTO public.who_global_data_import VALUES (39734, '2020-05-15', 'IQ', 'Iraq', 'EMRO', '50', '3193', '2', '117');
INSERT INTO public.who_global_data_import VALUES (39735, '2020-05-16', 'IQ', 'Iraq', 'EMRO', '67', '3260', '4', '121');
INSERT INTO public.who_global_data_import VALUES (39736, '2020-05-17', 'IQ', 'Iraq', 'EMRO', '144', '3404', '2', '123');
INSERT INTO public.who_global_data_import VALUES (39737, '2020-05-18', 'IQ', 'Iraq', 'EMRO', '150', '3554', '4', '127');
INSERT INTO public.who_global_data_import VALUES (39738, '2020-05-19', 'IQ', 'Iraq', 'EMRO', '57', '3611', '4', '131');
INSERT INTO public.who_global_data_import VALUES (39739, '2020-05-20', 'IQ', 'Iraq', 'EMRO', '113', '3724', '3', '134');
INSERT INTO public.who_global_data_import VALUES (39740, '2020-05-21', 'IQ', 'Iraq', 'EMRO', '153', '3877', '6', '140');
INSERT INTO public.who_global_data_import VALUES (39741, '2020-05-22', 'IQ', 'Iraq', 'EMRO', '0', '3877', '0', '140');
INSERT INTO public.who_global_data_import VALUES (39742, '2020-05-23', 'IQ', 'Iraq', 'EMRO', '87', '3964', '7', '147');
INSERT INTO public.who_global_data_import VALUES (39743, '2020-05-24', 'IQ', 'Iraq', 'EMRO', '308', '4272', '5', '152');
INSERT INTO public.who_global_data_import VALUES (39744, '2020-05-25', 'IQ', 'Iraq', 'EMRO', '197', '4469', '8', '160');
INSERT INTO public.who_global_data_import VALUES (39745, '2020-05-26', 'IQ', 'Iraq', 'EMRO', '163', '4632', '3', '163');
INSERT INTO public.who_global_data_import VALUES (39746, '2020-05-27', 'IQ', 'Iraq', 'EMRO', '216', '4848', '6', '169');
INSERT INTO public.who_global_data_import VALUES (39747, '2020-05-28', 'IQ', 'Iraq', 'EMRO', '287', '5135', '6', '175');
INSERT INTO public.who_global_data_import VALUES (39748, '2020-05-29', 'IQ', 'Iraq', 'EMRO', '322', '5457', '4', '179');
INSERT INTO public.who_global_data_import VALUES (39749, '2020-05-30', 'IQ', 'Iraq', 'EMRO', '416', '5873', '6', '185');
INSERT INTO public.who_global_data_import VALUES (39750, '2020-05-31', 'IQ', 'Iraq', 'EMRO', '306', '6179', '10', '195');
INSERT INTO public.who_global_data_import VALUES (39751, '2020-06-01', 'IQ', 'Iraq', 'EMRO', '260', '6439', '10', '205');
INSERT INTO public.who_global_data_import VALUES (39752, '2020-06-02', 'IQ', 'Iraq', 'EMRO', '429', '6868', '10', '215');
INSERT INTO public.who_global_data_import VALUES (39753, '2020-06-03', 'IQ', 'Iraq', 'EMRO', '519', '7387', '20', '235');
INSERT INTO public.who_global_data_import VALUES (39754, '2020-06-04', 'IQ', 'Iraq', 'EMRO', '781', '8168', '21', '256');
INSERT INTO public.who_global_data_import VALUES (39755, '2020-06-05', 'IQ', 'Iraq', 'EMRO', '672', '8840', '15', '271');
INSERT INTO public.who_global_data_import VALUES (39756, '2020-06-06', 'IQ', 'Iraq', 'EMRO', '1006', '9846', '14', '285');
INSERT INTO public.who_global_data_import VALUES (39757, '2020-06-07', 'IQ', 'Iraq', 'EMRO', '1252', '11098', '33', '318');
INSERT INTO public.who_global_data_import VALUES (39758, '2020-06-08', 'IQ', 'Iraq', 'EMRO', '1268', '12366', '28', '346');
INSERT INTO public.who_global_data_import VALUES (39759, '2020-06-09', 'IQ', 'Iraq', 'EMRO', '1115', '13481', '24', '370');
INSERT INTO public.who_global_data_import VALUES (39760, '2020-06-10', 'IQ', 'Iraq', 'EMRO', '787', '14268', '22', '392');
INSERT INTO public.who_global_data_import VALUES (39761, '2020-06-11', 'IQ', 'Iraq', 'EMRO', '1146', '15414', '34', '426');
INSERT INTO public.who_global_data_import VALUES (39762, '2020-06-12', 'IQ', 'Iraq', 'EMRO', '1261', '16675', '31', '457');
INSERT INTO public.who_global_data_import VALUES (39763, '2020-06-13', 'IQ', 'Iraq', 'EMRO', '1095', '17770', '39', '496');
INSERT INTO public.who_global_data_import VALUES (39764, '2020-06-14', 'IQ', 'Iraq', 'EMRO', '1180', '18950', '53', '549');
INSERT INTO public.who_global_data_import VALUES (39765, '2020-06-15', 'IQ', 'Iraq', 'EMRO', '1259', '20209', '58', '607');
INSERT INTO public.who_global_data_import VALUES (39766, '2020-06-16', 'IQ', 'Iraq', 'EMRO', '1106', '21315', '45', '652');
INSERT INTO public.who_global_data_import VALUES (39767, '2020-06-17', 'IQ', 'Iraq', 'EMRO', '1385', '22700', '60', '712');
INSERT INTO public.who_global_data_import VALUES (39768, '2020-06-18', 'IQ', 'Iraq', 'EMRO', '1554', '24254', '61', '773');
INSERT INTO public.who_global_data_import VALUES (39769, '2020-06-19', 'IQ', 'Iraq', 'EMRO', '1463', '25717', '83', '856');
INSERT INTO public.who_global_data_import VALUES (39770, '2020-06-20', 'IQ', 'Iraq', 'EMRO', '1635', '27352', '69', '925');
INSERT INTO public.who_global_data_import VALUES (39771, '2020-06-21', 'IQ', 'Iraq', 'EMRO', '1870', '29222', '88', '1013');
INSERT INTO public.who_global_data_import VALUES (39772, '2020-06-22', 'IQ', 'Iraq', 'EMRO', '1646', '30868', '87', '1100');
INSERT INTO public.who_global_data_import VALUES (39773, '2020-06-23', 'IQ', 'Iraq', 'EMRO', '1808', '32676', '67', '1167');
INSERT INTO public.who_global_data_import VALUES (39774, '2020-06-24', 'IQ', 'Iraq', 'EMRO', '1826', '34502', '84', '1251');
INSERT INTO public.who_global_data_import VALUES (39775, '2020-06-25', 'IQ', 'Iraq', 'EMRO', '2200', '36702', '79', '1330');
INSERT INTO public.who_global_data_import VALUES (39776, '2020-06-26', 'IQ', 'Iraq', 'EMRO', '2437', '39139', '107', '1437');
INSERT INTO public.who_global_data_import VALUES (39777, '2020-06-27', 'IQ', 'Iraq', 'EMRO', '2054', '41193', '122', '1559');
INSERT INTO public.who_global_data_import VALUES (39778, '2020-06-28', 'IQ', 'Iraq', 'EMRO', '2069', '43262', '101', '1660');
INSERT INTO public.who_global_data_import VALUES (39779, '2020-06-29', 'IQ', 'Iraq', 'EMRO', '2140', '45402', '96', '1756');
INSERT INTO public.who_global_data_import VALUES (39780, '2020-06-30', 'IQ', 'Iraq', 'EMRO', '1749', '47151', '83', '1839');
INSERT INTO public.who_global_data_import VALUES (39781, '2020-07-01', 'IQ', 'Iraq', 'EMRO', '1958', '49109', '104', '1943');
INSERT INTO public.who_global_data_import VALUES (39782, '2020-07-02', 'IQ', 'Iraq', 'EMRO', '2415', '51524', '107', '2050');
INSERT INTO public.who_global_data_import VALUES (39783, '2020-07-03', 'IQ', 'Iraq', 'EMRO', '2184', '53708', '110', '2160');
INSERT INTO public.who_global_data_import VALUES (39784, '2020-07-04', 'IQ', 'Iraq', 'EMRO', '2312', '56020', '102', '2262');
INSERT INTO public.who_global_data_import VALUES (39785, '2020-07-05', 'IQ', 'Iraq', 'EMRO', '2334', '58354', '106', '2368');
INSERT INTO public.who_global_data_import VALUES (39786, '2020-07-06', 'IQ', 'Iraq', 'EMRO', '2125', '60479', '105', '2473');
INSERT INTO public.who_global_data_import VALUES (39787, '2020-07-07', 'IQ', 'Iraq', 'EMRO', '1796', '62275', '94', '2567');
INSERT INTO public.who_global_data_import VALUES (39788, '2020-07-08', 'IQ', 'Iraq', 'EMRO', '2426', '64701', '118', '2685');
INSERT INTO public.who_global_data_import VALUES (39789, '2020-07-09', 'IQ', 'Iraq', 'EMRO', '2741', '67442', '94', '2779');
INSERT INTO public.who_global_data_import VALUES (39790, '2020-07-10', 'IQ', 'Iraq', 'EMRO', '2170', '69612', '103', '2882');
INSERT INTO public.who_global_data_import VALUES (39791, '2020-07-11', 'IQ', 'Iraq', 'EMRO', '2848', '72460', '78', '2960');
INSERT INTO public.who_global_data_import VALUES (39792, '2020-07-12', 'IQ', 'Iraq', 'EMRO', '2734', '75194', '95', '3055');
INSERT INTO public.who_global_data_import VALUES (39793, '2020-07-13', 'IQ', 'Iraq', 'EMRO', '2312', '77506', '95', '3150');
INSERT INTO public.who_global_data_import VALUES (39794, '2020-07-14', 'IQ', 'Iraq', 'EMRO', '2229', '79735', '100', '3250');
INSERT INTO public.who_global_data_import VALUES (39795, '2020-07-15', 'IQ', 'Iraq', 'EMRO', '2022', '81757', '95', '3345');
INSERT INTO public.who_global_data_import VALUES (39796, '2020-07-16', 'IQ', 'Iraq', 'EMRO', '2110', '83867', '87', '3432');
INSERT INTO public.who_global_data_import VALUES (39797, '2020-07-17', 'IQ', 'Iraq', 'EMRO', '2281', '86148', '90', '3522');
INSERT INTO public.who_global_data_import VALUES (39798, '2020-07-18', 'IQ', 'Iraq', 'EMRO', '2023', '88171', '94', '3616');
INSERT INTO public.who_global_data_import VALUES (39799, '2020-07-19', 'IQ', 'Iraq', 'EMRO', '2049', '90220', '75', '3691');
INSERT INTO public.who_global_data_import VALUES (39800, '2020-07-20', 'IQ', 'Iraq', 'EMRO', '2310', '92530', '90', '3781');
INSERT INTO public.who_global_data_import VALUES (39801, '2020-07-21', 'IQ', 'Iraq', 'EMRO', '2163', '94693', '88', '3869');
INSERT INTO public.who_global_data_import VALUES (39802, '2020-07-22', 'IQ', 'Iraq', 'EMRO', '2466', '97159', '81', '3950');
INSERT INTO public.who_global_data_import VALUES (39803, '2020-07-23', 'IQ', 'Iraq', 'EMRO', '2706', '99865', '92', '4042');
INSERT INTO public.who_global_data_import VALUES (39804, '2020-07-24', 'IQ', 'Iraq', 'EMRO', '2361', '102226', '80', '4122');
INSERT INTO public.who_global_data_import VALUES (39805, '2020-07-25', 'IQ', 'Iraq', 'EMRO', '2485', '104711', '90', '4212');
INSERT INTO public.who_global_data_import VALUES (39806, '2020-07-26', 'IQ', 'Iraq', 'EMRO', '2862', '107573', '72', '4284');
INSERT INTO public.who_global_data_import VALUES (39807, '2020-07-27', 'IQ', 'Iraq', 'EMRO', '2459', '110032', '78', '4362');
INSERT INTO public.who_global_data_import VALUES (39808, '2020-07-28', 'IQ', 'Iraq', 'EMRO', '2553', '112585', '96', '4458');
INSERT INTO public.who_global_data_import VALUES (39809, '2020-07-29', 'IQ', 'Iraq', 'EMRO', '2747', '115332', '77', '4535');
INSERT INTO public.who_global_data_import VALUES (39810, '2020-07-30', 'IQ', 'Iraq', 'EMRO', '2968', '118300', '68', '4603');
INSERT INTO public.who_global_data_import VALUES (39811, '2020-07-31', 'IQ', 'Iraq', 'EMRO', '2963', '121263', '68', '4671');
INSERT INTO public.who_global_data_import VALUES (39812, '2020-08-01', 'IQ', 'Iraq', 'EMRO', '3346', '124609', '70', '4741');
INSERT INTO public.who_global_data_import VALUES (39813, '2020-08-02', 'IQ', 'Iraq', 'EMRO', '2095', '126704', '64', '4805');
INSERT INTO public.who_global_data_import VALUES (39814, '2020-08-03', 'IQ', 'Iraq', 'EMRO', '2447', '129151', '63', '4868');
INSERT INTO public.who_global_data_import VALUES (39815, '2020-08-04', 'IQ', 'Iraq', 'EMRO', '2735', '131886', '66', '4934');
INSERT INTO public.who_global_data_import VALUES (39816, '2020-08-05', 'IQ', 'Iraq', 'EMRO', '2836', '134722', '83', '5017');
INSERT INTO public.who_global_data_import VALUES (39817, '2020-08-06', 'IQ', 'Iraq', 'EMRO', '2834', '137556', '77', '5094');
INSERT INTO public.who_global_data_import VALUES (39818, '2020-08-07', 'IQ', 'Iraq', 'EMRO', '3047', '140603', '67', '5161');
INSERT INTO public.who_global_data_import VALUES (39819, '2020-08-08', 'IQ', 'Iraq', 'EMRO', '3461', '144064', '75', '5236');
INSERT INTO public.who_global_data_import VALUES (39820, '2020-08-09', 'IQ', 'Iraq', 'EMRO', '3325', '147389', '74', '5310');
INSERT INTO public.who_global_data_import VALUES (39821, '2020-08-10', 'IQ', 'Iraq', 'EMRO', '2726', '150115', '82', '5392');
INSERT INTO public.who_global_data_import VALUES (39822, '2020-08-11', 'IQ', 'Iraq', 'EMRO', '3484', '153599', '72', '5464');
INSERT INTO public.who_global_data_import VALUES (39823, '2020-08-12', 'IQ', 'Iraq', 'EMRO', '3396', '156995', '67', '5531');
INSERT INTO public.who_global_data_import VALUES (39824, '2020-08-13', 'IQ', 'Iraq', 'EMRO', '3441', '160436', '57', '5588');
INSERT INTO public.who_global_data_import VALUES (39825, '2020-08-14', 'IQ', 'Iraq', 'EMRO', '3841', '164277', '53', '5641');
INSERT INTO public.who_global_data_import VALUES (39826, '2020-08-15', 'IQ', 'Iraq', 'EMRO', '4013', '168290', '68', '5709');
INSERT INTO public.who_global_data_import VALUES (39827, '2020-08-16', 'IQ', 'Iraq', 'EMRO', '4293', '172583', '76', '5785');
INSERT INTO public.who_global_data_import VALUES (39828, '2020-08-17', 'IQ', 'Iraq', 'EMRO', '4348', '176931', '75', '5860');
INSERT INTO public.who_global_data_import VALUES (39829, '2020-08-18', 'IQ', 'Iraq', 'EMRO', '3202', '180133', '94', '5954');
INSERT INTO public.who_global_data_import VALUES (39830, '2020-08-19', 'IQ', 'Iraq', 'EMRO', '4576', '184709', '82', '6036');
INSERT INTO public.who_global_data_import VALUES (39831, '2020-08-20', 'IQ', 'Iraq', 'EMRO', '4093', '188802', '85', '6121');
INSERT INTO public.who_global_data_import VALUES (39832, '2020-08-21', 'IQ', 'Iraq', 'EMRO', '3995', '192797', '87', '6208');
INSERT INTO public.who_global_data_import VALUES (39833, '2020-08-22', 'IQ', 'Iraq', 'EMRO', '4288', '197085', '75', '6283');
INSERT INTO public.who_global_data_import VALUES (39834, '2020-08-23', 'IQ', 'Iraq', 'EMRO', '3965', '201050', '70', '6353');
INSERT INTO public.who_global_data_import VALUES (39835, '2020-08-24', 'IQ', 'Iraq', 'EMRO', '3291', '204341', '75', '6428');
INSERT INTO public.who_global_data_import VALUES (39836, '2020-08-25', 'IQ', 'Iraq', 'EMRO', '3644', '207985', '91', '6519');
INSERT INTO public.who_global_data_import VALUES (39837, '2020-08-26', 'IQ', 'Iraq', 'EMRO', '3962', '211947', '77', '6596');
INSERT INTO public.who_global_data_import VALUES (39838, '2020-08-27', 'IQ', 'Iraq', 'EMRO', '3837', '215784', '72', '6668');
INSERT INTO public.who_global_data_import VALUES (39839, '2020-08-28', 'IQ', 'Iraq', 'EMRO', '3651', '219435', '72', '6740');
INSERT INTO public.who_global_data_import VALUES (39840, '2020-08-29', 'IQ', 'Iraq', 'EMRO', '4177', '223612', '74', '6814');
INSERT INTO public.who_global_data_import VALUES (39841, '2020-08-30', 'IQ', 'Iraq', 'EMRO', '3834', '227446', '77', '6891');
INSERT INTO public.who_global_data_import VALUES (39842, '2020-08-31', 'IQ', 'Iraq', 'EMRO', '3731', '231177', '68', '6959');
INSERT INTO public.who_global_data_import VALUES (39843, '2020-09-01', 'IQ', 'Iraq', 'EMRO', '3757', '234934', '83', '7042');
INSERT INTO public.who_global_data_import VALUES (39844, '2020-09-02', 'IQ', 'Iraq', 'EMRO', '3404', '238338', '81', '7123');
INSERT INTO public.who_global_data_import VALUES (39845, '2020-09-03', 'IQ', 'Iraq', 'EMRO', '3946', '242284', '78', '7201');
INSERT INTO public.who_global_data_import VALUES (39846, '2020-09-04', 'IQ', 'Iraq', 'EMRO', '4755', '247039', '74', '7275');
INSERT INTO public.who_global_data_import VALUES (39847, '2020-09-05', 'IQ', 'Iraq', 'EMRO', '5036', '252075', '84', '7359');
INSERT INTO public.who_global_data_import VALUES (39848, '2020-09-06', 'IQ', 'Iraq', 'EMRO', '4644', '256719', '63', '7422');
INSERT INTO public.who_global_data_import VALUES (39849, '2020-09-07', 'IQ', 'Iraq', 'EMRO', '3651', '260370', '90', '7512');
INSERT INTO public.who_global_data_import VALUES (39850, '2020-09-08', 'IQ', 'Iraq', 'EMRO', '4314', '264684', '77', '7589');
INSERT INTO public.who_global_data_import VALUES (39851, '2020-09-09', 'IQ', 'Iraq', 'EMRO', '4894', '269578', '68', '7657');
INSERT INTO public.who_global_data_import VALUES (39852, '2020-09-10', 'IQ', 'Iraq', 'EMRO', '4243', '273821', '75', '7732');
INSERT INTO public.who_global_data_import VALUES (39853, '2020-09-11', 'IQ', 'Iraq', 'EMRO', '4597', '278418', '82', '7814');
INSERT INTO public.who_global_data_import VALUES (39854, '2020-09-12', 'IQ', 'Iraq', 'EMRO', '4254', '282672', '67', '7881');
INSERT INTO public.who_global_data_import VALUES (39855, '2020-09-13', 'IQ', 'Iraq', 'EMRO', '4106', '286778', '60', '7941');
INSERT INTO public.who_global_data_import VALUES (39856, '2020-09-14', 'IQ', 'Iraq', 'EMRO', '3531', '290309', '73', '8014');
INSERT INTO public.who_global_data_import VALUES (39857, '2020-09-15', 'IQ', 'Iraq', 'EMRO', '4169', '294478', '72', '8086');
INSERT INTO public.who_global_data_import VALUES (39858, '2020-09-16', 'IQ', 'Iraq', 'EMRO', '4224', '298702', '80', '8166');
INSERT INTO public.who_global_data_import VALUES (39859, '2020-09-17', 'IQ', 'Iraq', 'EMRO', '4357', '303059', '82', '8248');
INSERT INTO public.who_global_data_import VALUES (39860, '2020-09-18', 'IQ', 'Iraq', 'EMRO', '4326', '307385', '84', '8332');
INSERT INTO public.who_global_data_import VALUES (39861, '2020-09-19', 'IQ', 'Iraq', 'EMRO', '4305', '311690', '76', '8408');
INSERT INTO public.who_global_data_import VALUES (39862, '2020-09-20', 'IQ', 'Iraq', 'EMRO', '3907', '315597', '83', '8491');
INSERT INTO public.who_global_data_import VALUES (39863, '2020-09-21', 'IQ', 'Iraq', 'EMRO', '3438', '319035', '64', '8555');
INSERT INTO public.who_global_data_import VALUES (39864, '2020-09-22', 'IQ', 'Iraq', 'EMRO', '3821', '322856', '70', '8625');
INSERT INTO public.who_global_data_import VALUES (39865, '2020-09-23', 'IQ', 'Iraq', 'EMRO', '4724', '327580', '57', '8682');
INSERT INTO public.who_global_data_import VALUES (39866, '2020-09-24', 'IQ', 'Iraq', 'EMRO', '5055', '332635', '72', '8754');
INSERT INTO public.who_global_data_import VALUES (39867, '2020-09-25', 'IQ', 'Iraq', 'EMRO', '4471', '337106', '45', '8799');
INSERT INTO public.who_global_data_import VALUES (39868, '2020-09-26', 'IQ', 'Iraq', 'EMRO', '4593', '341699', '68', '8867');
INSERT INTO public.who_global_data_import VALUES (39869, '2020-09-27', 'IQ', 'Iraq', 'EMRO', '4270', '345969', '68', '8935');
INSERT INTO public.who_global_data_import VALUES (39870, '2020-09-28', 'IQ', 'Iraq', 'EMRO', '3481', '349450', '55', '8990');
INSERT INTO public.who_global_data_import VALUES (39871, '2020-09-29', 'IQ', 'Iraq', 'EMRO', '4116', '353566', '62', '9052');
INSERT INTO public.who_global_data_import VALUES (39872, '2020-09-30', 'IQ', 'Iraq', 'EMRO', '4724', '358290', '70', '9122');
INSERT INTO public.who_global_data_import VALUES (39873, '2020-10-01', 'IQ', 'Iraq', 'EMRO', '4691', '362981', '59', '9181');
INSERT INTO public.who_global_data_import VALUES (39874, '2020-10-02', 'IQ', 'Iraq', 'EMRO', '4493', '367474', '50', '9231');
INSERT INTO public.who_global_data_import VALUES (39875, '2020-10-03', 'IQ', 'Iraq', 'EMRO', '4785', '372259', '67', '9298');
INSERT INTO public.who_global_data_import VALUES (39876, '2020-10-04', 'IQ', 'Iraq', 'EMRO', '3672', '375931', '49', '9347');
INSERT INTO public.who_global_data_import VALUES (39877, '2020-10-05', 'IQ', 'Iraq', 'EMRO', '3210', '379141', '52', '9399');
INSERT INTO public.who_global_data_import VALUES (39878, '2020-10-06', 'IQ', 'Iraq', 'EMRO', '3808', '382949', '65', '9464');
INSERT INTO public.who_global_data_import VALUES (39879, '2020-10-07', 'IQ', 'Iraq', 'EMRO', '4172', '387121', '67', '9531');
INSERT INTO public.who_global_data_import VALUES (39880, '2020-10-08', 'IQ', 'Iraq', 'EMRO', '3923', '391044', '73', '9604');
INSERT INTO public.who_global_data_import VALUES (39881, '2020-10-09', 'IQ', 'Iraq', 'EMRO', '3522', '394566', '79', '9683');
INSERT INTO public.who_global_data_import VALUES (39882, '2020-10-10', 'IQ', 'Iraq', 'EMRO', '3214', '397780', '52', '9735');
INSERT INTO public.who_global_data_import VALUES (39883, '2020-10-11', 'IQ', 'Iraq', 'EMRO', '2344', '400124', '55', '9790');
INSERT INTO public.who_global_data_import VALUES (39884, '2020-10-12', 'IQ', 'Iraq', 'EMRO', '2206', '402330', '62', '9852');
INSERT INTO public.who_global_data_import VALUES (39885, '2020-10-13', 'IQ', 'Iraq', 'EMRO', '3107', '405437', '60', '9912');
INSERT INTO public.who_global_data_import VALUES (39886, '2020-10-14', 'IQ', 'Iraq', 'EMRO', '3921', '409358', '58', '9970');
INSERT INTO public.who_global_data_import VALUES (39887, '2020-10-15', 'IQ', 'Iraq', 'EMRO', '3857', '413215', '51', '10021');
INSERT INTO public.who_global_data_import VALUES (39888, '2020-10-16', 'IQ', 'Iraq', 'EMRO', '3587', '416802', '65', '10086');
INSERT INTO public.who_global_data_import VALUES (39889, '2020-10-17', 'IQ', 'Iraq', 'EMRO', '3501', '420303', '56', '10142');
INSERT INTO public.who_global_data_import VALUES (39890, '2020-10-18', 'IQ', 'Iraq', 'EMRO', '3221', '423524', '56', '10198');
INSERT INTO public.who_global_data_import VALUES (39891, '2020-10-19', 'IQ', 'Iraq', 'EMRO', '3110', '426634', '56', '10254');
INSERT INTO public.who_global_data_import VALUES (39892, '2020-10-20', 'IQ', 'Iraq', 'EMRO', '4044', '430678', '63', '10317');
INSERT INTO public.who_global_data_import VALUES (39893, '2020-10-21', 'IQ', 'Iraq', 'EMRO', '3920', '434598', '49', '10366');
INSERT INTO public.who_global_data_import VALUES (39894, '2020-10-22', 'IQ', 'Iraq', 'EMRO', '3667', '438265', '52', '10418');
INSERT INTO public.who_global_data_import VALUES (39895, '2020-10-23', 'IQ', 'Iraq', 'EMRO', '3899', '442164', '47', '10465');
INSERT INTO public.who_global_data_import VALUES (39896, '2020-10-24', 'IQ', 'Iraq', 'EMRO', '3785', '445949', '48', '10513');
INSERT INTO public.who_global_data_import VALUES (39897, '2020-10-25', 'IQ', 'Iraq', 'EMRO', '3204', '449153', '55', '10568');
INSERT INTO public.who_global_data_import VALUES (39898, '2020-10-26', 'IQ', 'Iraq', 'EMRO', '2554', '451707', '55', '10623');
INSERT INTO public.who_global_data_import VALUES (39899, '2020-10-27', 'IQ', 'Iraq', 'EMRO', '3691', '455398', '48', '10671');
INSERT INTO public.who_global_data_import VALUES (39900, '2020-10-28', 'IQ', 'Iraq', 'EMRO', '4510', '459908', '53', '10724');
INSERT INTO public.who_global_data_import VALUES (39901, '2020-10-29', 'IQ', 'Iraq', 'EMRO', '4043', '463951', '46', '10770');
INSERT INTO public.who_global_data_import VALUES (39902, '2020-10-30', 'IQ', 'Iraq', 'EMRO', '3804', '467755', '45', '10815');
INSERT INTO public.who_global_data_import VALUES (39903, '2020-10-31', 'IQ', 'Iraq', 'EMRO', '2878', '470633', '47', '10862');
INSERT INTO public.who_global_data_import VALUES (39904, '2020-11-01', 'IQ', 'Iraq', 'EMRO', '1997', '472630', '48', '10910');
INSERT INTO public.who_global_data_import VALUES (39905, '2020-11-02', 'IQ', 'Iraq', 'EMRO', '2658', '475288', '56', '10966');
INSERT INTO public.who_global_data_import VALUES (39906, '2020-11-03', 'IQ', 'Iraq', 'EMRO', '3413', '478701', '51', '11017');
INSERT INTO public.who_global_data_import VALUES (39907, '2020-11-04', 'IQ', 'Iraq', 'EMRO', '3595', '482296', '51', '11068');
INSERT INTO public.who_global_data_import VALUES (39908, '2020-11-05', 'IQ', 'Iraq', 'EMRO', '3574', '485870', '60', '11128');
INSERT INTO public.who_global_data_import VALUES (39909, '2020-11-06', 'IQ', 'Iraq', 'EMRO', '3701', '489571', '47', '11175');
INSERT INTO public.who_global_data_import VALUES (39910, '2020-11-07', 'IQ', 'Iraq', 'EMRO', '3568', '493139', '69', '11244');
INSERT INTO public.who_global_data_import VALUES (39911, '2020-11-08', 'IQ', 'Iraq', 'EMRO', '2880', '496019', '39', '11283');
INSERT INTO public.who_global_data_import VALUES (39912, '2020-11-09', 'IQ', 'Iraq', 'EMRO', '2530', '498549', '44', '11327');
INSERT INTO public.who_global_data_import VALUES (39913, '2020-11-10', 'IQ', 'Iraq', 'EMRO', '3184', '501733', '53', '11380');
INSERT INTO public.who_global_data_import VALUES (39914, '2020-11-11', 'IQ', 'Iraq', 'EMRO', '3577', '505310', '52', '11432');
INSERT INTO public.who_global_data_import VALUES (39915, '2020-11-12', 'IQ', 'Iraq', 'EMRO', '3198', '508508', '50', '11482');
INSERT INTO public.who_global_data_import VALUES (39916, '2020-11-13', 'IQ', 'Iraq', 'EMRO', '3298', '511806', '50', '11532');
INSERT INTO public.who_global_data_import VALUES (39917, '2020-11-14', 'IQ', 'Iraq', 'EMRO', '2690', '514496', '48', '11580');
INSERT INTO public.who_global_data_import VALUES (39918, '2020-11-15', 'IQ', 'Iraq', 'EMRO', '2419', '516915', '43', '11623');
INSERT INTO public.who_global_data_import VALUES (39919, '2020-11-16', 'IQ', 'Iraq', 'EMRO', '2237', '519152', '47', '11670');
INSERT INTO public.who_global_data_import VALUES (39920, '2020-11-17', 'IQ', 'Iraq', 'EMRO', '2390', '521542', '42', '11712');
INSERT INTO public.who_global_data_import VALUES (39921, '2020-11-18', 'IQ', 'Iraq', 'EMRO', '2961', '524503', '40', '11752');
INSERT INTO public.who_global_data_import VALUES (39922, '2020-11-19', 'IQ', 'Iraq', 'EMRO', '2349', '526852', '43', '11795');
INSERT INTO public.who_global_data_import VALUES (39923, '2020-11-20', 'IQ', 'Iraq', 'EMRO', '2374', '529226', '39', '11834');
INSERT INTO public.who_global_data_import VALUES (39924, '2020-11-21', 'IQ', 'Iraq', 'EMRO', '2543', '531769', '49', '11883');
INSERT INTO public.who_global_data_import VALUES (39925, '2020-11-22', 'IQ', 'Iraq', 'EMRO', '1786', '533555', '42', '11925');
INSERT INTO public.who_global_data_import VALUES (39926, '2020-11-23', 'IQ', 'Iraq', 'EMRO', '1766', '535321', '33', '11958');
INSERT INTO public.who_global_data_import VALUES (39927, '2020-11-24', 'IQ', 'Iraq', 'EMRO', '2136', '537457', '38', '11996');
INSERT INTO public.who_global_data_import VALUES (39928, '2020-11-25', 'IQ', 'Iraq', 'EMRO', '2292', '539749', '35', '12031');
INSERT INTO public.who_global_data_import VALUES (39929, '2020-11-26', 'IQ', 'Iraq', 'EMRO', '2438', '542187', '55', '12086');
INSERT INTO public.who_global_data_import VALUES (39930, '2020-11-27', 'IQ', 'Iraq', 'EMRO', '2483', '544670', '39', '12125');
INSERT INTO public.who_global_data_import VALUES (39931, '2020-11-28', 'IQ', 'Iraq', 'EMRO', '2545', '547215', '42', '12167');
INSERT INTO public.who_global_data_import VALUES (39932, '2020-11-29', 'IQ', 'Iraq', 'EMRO', '1606', '548821', '33', '12200');
INSERT INTO public.who_global_data_import VALUES (39933, '2020-11-30', 'IQ', 'Iraq', 'EMRO', '1614', '550435', '24', '12224');
INSERT INTO public.who_global_data_import VALUES (39934, '2020-12-01', 'IQ', 'Iraq', 'EMRO', '2114', '552549', '34', '12258');
INSERT INTO public.who_global_data_import VALUES (39935, '2020-12-02', 'IQ', 'Iraq', 'EMRO', '2218', '554767', '48', '12306');
INSERT INTO public.who_global_data_import VALUES (39936, '2020-12-03', 'IQ', 'Iraq', 'EMRO', '1961', '556728', '34', '12340');
INSERT INTO public.who_global_data_import VALUES (39937, '2020-12-04', 'IQ', 'Iraq', 'EMRO', '2039', '558767', '21', '12361');
INSERT INTO public.who_global_data_import VALUES (39938, '2020-12-05', 'IQ', 'Iraq', 'EMRO', '1855', '560622', '26', '12387');
INSERT INTO public.who_global_data_import VALUES (39939, '2020-12-06', 'IQ', 'Iraq', 'EMRO', '1898', '562520', '24', '12411');
INSERT INTO public.who_global_data_import VALUES (39940, '2020-12-07', 'IQ', 'Iraq', 'EMRO', '1680', '564200', '21', '12432');
INSERT INTO public.who_global_data_import VALUES (39941, '2020-12-08', 'IQ', 'Iraq', 'EMRO', '1815', '566015', '28', '12460');
INSERT INTO public.who_global_data_import VALUES (39942, '2020-12-09', 'IQ', 'Iraq', 'EMRO', '2123', '568138', '17', '12477');
INSERT INTO public.who_global_data_import VALUES (39943, '2020-12-10', 'IQ', 'Iraq', 'EMRO', '1735', '569873', '24', '12501');
INSERT INTO public.who_global_data_import VALUES (39944, '2020-12-11', 'IQ', 'Iraq', 'EMRO', '1380', '571253', '25', '12526');
INSERT INTO public.who_global_data_import VALUES (39945, '2020-12-12', 'IQ', 'Iraq', 'EMRO', '1347', '572600', '23', '12549');
INSERT INTO public.who_global_data_import VALUES (39946, '2020-12-13', 'IQ', 'Iraq', 'EMRO', '1022', '573622', '16', '12565');
INSERT INTO public.who_global_data_import VALUES (39947, '2020-12-14', 'IQ', 'Iraq', 'EMRO', '1012', '574634', '14', '12579');
INSERT INTO public.who_global_data_import VALUES (39948, '2020-12-15', 'IQ', 'Iraq', 'EMRO', '1338', '575972', '24', '12603');
INSERT INTO public.who_global_data_import VALUES (39949, '2020-12-16', 'IQ', 'Iraq', 'EMRO', '1391', '577363', '11', '12614');
INSERT INTO public.who_global_data_import VALUES (39950, '2020-12-17', 'IQ', 'Iraq', 'EMRO', '1553', '578916', '22', '12636');
INSERT INTO public.who_global_data_import VALUES (39951, '2020-12-18', 'IQ', 'Iraq', 'EMRO', '1533', '580449', '14', '12650');
INSERT INTO public.who_global_data_import VALUES (39952, '2020-12-19', 'IQ', 'Iraq', 'EMRO', '1362', '581811', '20', '12670');
INSERT INTO public.who_global_data_import VALUES (39953, '2020-12-20', 'IQ', 'Iraq', 'EMRO', '1307', '583118', '10', '12680');
INSERT INTO public.who_global_data_import VALUES (39954, '2020-12-21', 'IQ', 'Iraq', 'EMRO', '1027', '584145', '17', '12697');
INSERT INTO public.who_global_data_import VALUES (39955, '2020-12-22', 'IQ', 'Iraq', 'EMRO', '1200', '585345', '13', '12710');
INSERT INTO public.who_global_data_import VALUES (39956, '2020-12-23', 'IQ', 'Iraq', 'EMRO', '1158', '586503', '15', '12725');
INSERT INTO public.who_global_data_import VALUES (39957, '2020-12-24', 'IQ', 'Iraq', 'EMRO', '1173', '587676', '12', '12737');
INSERT INTO public.who_global_data_import VALUES (39958, '2020-12-25', 'IQ', 'Iraq', 'EMRO', '1127', '588803', '7', '12744');
INSERT INTO public.who_global_data_import VALUES (39959, '2020-12-26', 'IQ', 'Iraq', 'EMRO', '1140', '589943', '11', '12755');
INSERT INTO public.who_global_data_import VALUES (39960, '2020-12-27', 'IQ', 'Iraq', 'EMRO', '836', '590779', '12', '12767');
INSERT INTO public.who_global_data_import VALUES (39961, '2020-12-28', 'IQ', 'Iraq', 'EMRO', '818', '591597', '13', '12780');
INSERT INTO public.who_global_data_import VALUES (39962, '2020-12-29', 'IQ', 'Iraq', 'EMRO', '931', '592528', '11', '12791');
INSERT INTO public.who_global_data_import VALUES (39963, '2020-12-30', 'IQ', 'Iraq', 'EMRO', '1013', '593541', '9', '12800');
INSERT INTO public.who_global_data_import VALUES (39964, '2020-12-31', 'IQ', 'Iraq', 'EMRO', '901', '594442', '8', '12808');
INSERT INTO public.who_global_data_import VALUES (39965, '2021-01-01', 'IQ', 'Iraq', 'EMRO', '849', '595291', '5', '12813');
INSERT INTO public.who_global_data_import VALUES (39966, '2021-01-02', 'IQ', 'Iraq', 'EMRO', '902', '596193', '11', '12824');
INSERT INTO public.who_global_data_import VALUES (39967, '2021-01-03', 'IQ', 'Iraq', 'EMRO', '840', '597033', '5', '12829');
INSERT INTO public.who_global_data_import VALUES (39968, '2021-01-04', 'IQ', 'Iraq', 'EMRO', '741', '597774', '5', '12834');
INSERT INTO public.who_global_data_import VALUES (39969, '2021-01-05', 'IQ', 'Iraq', 'EMRO', '595', '598369', '10', '12844');
INSERT INTO public.who_global_data_import VALUES (39970, '2021-01-06', 'IQ', 'Iraq', 'EMRO', '757', '599126', '12', '12856');
INSERT INTO public.who_global_data_import VALUES (39971, '2021-01-07', 'IQ', 'Iraq', 'EMRO', '839', '599965', '9', '12865');
INSERT INTO public.who_global_data_import VALUES (39972, '2021-01-08', 'IQ', 'Iraq', 'EMRO', '790', '600755', '4', '12869');
INSERT INTO public.who_global_data_import VALUES (39973, '2021-01-09', 'IQ', 'Iraq', 'EMRO', '669', '601424', '8', '12877');
INSERT INTO public.who_global_data_import VALUES (39974, '2021-01-10', 'IQ', 'Iraq', 'EMRO', '907', '602331', '4', '12881');
INSERT INTO public.who_global_data_import VALUES (39975, '2021-01-11', 'IQ', 'Iraq', 'EMRO', '607', '602938', '14', '12895');
INSERT INTO public.who_global_data_import VALUES (39976, '2021-01-12', 'IQ', 'Iraq', 'EMRO', '801', '603739', '11', '12906');
INSERT INTO public.who_global_data_import VALUES (39977, '2021-01-13', 'IQ', 'Iraq', 'EMRO', '810', '604549', '5', '12911');
INSERT INTO public.who_global_data_import VALUES (39978, '2021-01-14', 'IQ', 'Iraq', 'EMRO', '867', '605416', '4', '12915');
INSERT INTO public.who_global_data_import VALUES (39979, '2021-01-15', 'IQ', 'Iraq', 'EMRO', '770', '606186', '7', '12922');
INSERT INTO public.who_global_data_import VALUES (39980, '2021-01-16', 'IQ', 'Iraq', 'EMRO', '805', '606991', '10', '12932');
INSERT INTO public.who_global_data_import VALUES (39981, '2021-01-17', 'IQ', 'Iraq', 'EMRO', '596', '607587', '3', '12935');
INSERT INTO public.who_global_data_import VALUES (39982, '2021-01-18', 'IQ', 'Iraq', 'EMRO', '645', '608232', '9', '12944');
INSERT INTO public.who_global_data_import VALUES (39983, '2021-01-19', 'IQ', 'Iraq', 'EMRO', '797', '609029', '9', '12953');
INSERT INTO public.who_global_data_import VALUES (39984, '2021-01-20', 'IQ', 'Iraq', 'EMRO', '823', '609852', '9', '12962');
INSERT INTO public.who_global_data_import VALUES (39985, '2021-01-21', 'IQ', 'Iraq', 'EMRO', '746', '610598', '6', '12968');
INSERT INTO public.who_global_data_import VALUES (39986, '2021-01-22', 'IQ', 'Iraq', 'EMRO', '809', '611407', '9', '12977');
INSERT INTO public.who_global_data_import VALUES (39987, '2021-01-23', 'IQ', 'Iraq', 'EMRO', '685', '612092', '7', '12984');
INSERT INTO public.who_global_data_import VALUES (39988, '2021-01-24', 'IQ', 'Iraq', 'EMRO', '778', '612870', '4', '12988');
INSERT INTO public.who_global_data_import VALUES (39989, '2021-01-25', 'IQ', 'Iraq', 'EMRO', '893', '613763', '5', '12993');
INSERT INTO public.who_global_data_import VALUES (39990, '2021-01-26', 'IQ', 'Iraq', 'EMRO', '813', '614576', '7', '13000');
INSERT INTO public.who_global_data_import VALUES (39991, '2021-01-27', 'IQ', 'Iraq', 'EMRO', '804', '615380', '10', '13010');
INSERT INTO public.who_global_data_import VALUES (39992, '2021-01-28', 'IQ', 'Iraq', 'EMRO', '879', '616259', '8', '13018');
INSERT INTO public.who_global_data_import VALUES (39993, '2021-01-29', 'IQ', 'Iraq', 'EMRO', '943', '617202', '6', '13024');
INSERT INTO public.who_global_data_import VALUES (39994, '2021-01-30', 'IQ', 'Iraq', 'EMRO', '945', '618147', '12', '13036');
INSERT INTO public.who_global_data_import VALUES (39995, '2021-01-31', 'IQ', 'Iraq', 'EMRO', '775', '618922', '5', '13041');
INSERT INTO public.who_global_data_import VALUES (39996, '2021-02-01', 'IQ', 'Iraq', 'EMRO', '714', '619636', '6', '13047');
INSERT INTO public.who_global_data_import VALUES (39997, '2021-02-02', 'IQ', 'Iraq', 'EMRO', '984', '620620', '10', '13057');
INSERT INTO public.who_global_data_import VALUES (39998, '2021-02-03', 'IQ', 'Iraq', 'EMRO', '1135', '621755', '11', '13068');
INSERT INTO public.who_global_data_import VALUES (39999, '2021-02-04', 'IQ', 'Iraq', 'EMRO', '1317', '623072', '11', '13079');
INSERT INTO public.who_global_data_import VALUES (40000, '2021-02-05', 'IQ', 'Iraq', 'EMRO', '1150', '624222', '12', '13091');
INSERT INTO public.who_global_data_import VALUES (40001, '2020-01-03', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40002, '2020-01-04', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40003, '2020-01-05', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40004, '2020-01-06', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40005, '2020-01-07', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40006, '2020-01-08', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40007, '2020-01-09', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40008, '2020-01-10', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40009, '2020-01-11', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40010, '2020-01-12', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40011, '2020-01-13', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40012, '2020-01-14', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40013, '2020-01-15', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40014, '2020-01-16', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40015, '2020-01-17', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40016, '2020-01-18', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40017, '2020-01-19', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40018, '2020-01-20', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40019, '2020-01-21', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40020, '2020-01-22', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40021, '2020-01-23', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40022, '2020-01-24', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40023, '2020-01-25', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40024, '2020-01-26', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40025, '2020-01-27', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40026, '2020-01-28', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40027, '2020-01-29', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40028, '2020-01-30', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40029, '2020-01-31', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40030, '2020-02-01', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40031, '2020-02-02', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40032, '2020-02-03', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40038, '2020-02-09', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40039, '2020-02-10', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40040, '2020-02-11', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40041, '2020-02-12', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40042, '2020-02-13', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40043, '2020-02-14', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40044, '2020-02-15', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40045, '2020-02-16', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40046, '2020-02-17', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40047, '2020-02-18', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40048, '2020-02-19', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40049, '2020-02-20', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40050, '2020-02-21', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40051, '2020-02-22', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40052, '2020-02-23', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40053, '2020-02-24', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40054, '2020-02-25', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40055, '2020-02-26', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40056, '2020-02-27', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40057, '2020-02-28', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40058, '2020-02-29', 'IE', 'Ireland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40059, '2020-03-01', 'IE', 'Ireland', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40060, '2020-03-02', 'IE', 'Ireland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40061, '2020-03-03', 'IE', 'Ireland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40062, '2020-03-04', 'IE', 'Ireland', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40063, '2020-03-05', 'IE', 'Ireland', 'EURO', '4', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40064, '2020-03-06', 'IE', 'Ireland', 'EURO', '7', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40065, '2020-03-07', 'IE', 'Ireland', 'EURO', '5', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40066, '2020-03-08', 'IE', 'Ireland', 'EURO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40067, '2020-03-09', 'IE', 'Ireland', 'EURO', '2', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40068, '2020-03-10', 'IE', 'Ireland', 'EURO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40069, '2020-03-11', 'IE', 'Ireland', 'EURO', '14', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40070, '2020-03-12', 'IE', 'Ireland', 'EURO', '8', '43', '1', '1');
INSERT INTO public.who_global_data_import VALUES (40071, '2020-03-13', 'IE', 'Ireland', 'EURO', '27', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40072, '2020-03-14', 'IE', 'Ireland', 'EURO', '21', '91', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40073, '2020-03-15', 'IE', 'Ireland', 'EURO', '38', '129', '1', '2');
INSERT INTO public.who_global_data_import VALUES (40074, '2020-03-16', 'IE', 'Ireland', 'EURO', '40', '169', '0', '2');
INSERT INTO public.who_global_data_import VALUES (40075, '2020-03-17', 'IE', 'Ireland', 'EURO', '54', '223', '0', '2');
INSERT INTO public.who_global_data_import VALUES (40076, '2020-03-18', 'IE', 'Ireland', 'EURO', '69', '292', '0', '2');
INSERT INTO public.who_global_data_import VALUES (40077, '2020-03-19', 'IE', 'Ireland', 'EURO', '74', '366', '0', '2');
INSERT INTO public.who_global_data_import VALUES (40078, '2020-03-20', 'IE', 'Ireland', 'EURO', '191', '557', '1', '3');
INSERT INTO public.who_global_data_import VALUES (40079, '2020-03-21', 'IE', 'Ireland', 'EURO', '126', '683', '0', '3');
INSERT INTO public.who_global_data_import VALUES (40080, '2020-03-22', 'IE', 'Ireland', 'EURO', '102', '785', '0', '3');
INSERT INTO public.who_global_data_import VALUES (40081, '2020-03-23', 'IE', 'Ireland', 'EURO', '121', '906', '1', '4');
INSERT INTO public.who_global_data_import VALUES (40082, '2020-03-24', 'IE', 'Ireland', 'EURO', '219', '1125', '2', '6');
INSERT INTO public.who_global_data_import VALUES (40083, '2020-03-25', 'IE', 'Ireland', 'EURO', '204', '1329', '1', '7');
INSERT INTO public.who_global_data_import VALUES (40084, '2020-03-26', 'IE', 'Ireland', 'EURO', '235', '1564', '2', '9');
INSERT INTO public.who_global_data_import VALUES (40085, '2020-03-27', 'IE', 'Ireland', 'EURO', '255', '1819', '10', '19');
INSERT INTO public.who_global_data_import VALUES (40086, '2020-03-28', 'IE', 'Ireland', 'EURO', '302', '2121', '3', '22');
INSERT INTO public.who_global_data_import VALUES (40087, '2020-03-29', 'IE', 'Ireland', 'EURO', '294', '2415', '14', '36');
INSERT INTO public.who_global_data_import VALUES (40088, '2020-03-30', 'IE', 'Ireland', 'EURO', '200', '2615', '10', '46');
INSERT INTO public.who_global_data_import VALUES (40089, '2020-03-31', 'IE', 'Ireland', 'EURO', '295', '2910', '8', '54');
INSERT INTO public.who_global_data_import VALUES (40090, '2020-04-01', 'IE', 'Ireland', 'EURO', '325', '3235', '17', '71');
INSERT INTO public.who_global_data_import VALUES (40091, '2020-04-02', 'IE', 'Ireland', 'EURO', '212', '3447', '14', '85');
INSERT INTO public.who_global_data_import VALUES (40092, '2020-04-03', 'IE', 'Ireland', 'EURO', '402', '3849', '13', '98');
INSERT INTO public.who_global_data_import VALUES (40093, '2020-04-04', 'IE', 'Ireland', 'EURO', '424', '4273', '22', '120');
INSERT INTO public.who_global_data_import VALUES (40094, '2020-04-05', 'IE', 'Ireland', 'EURO', '331', '4604', '17', '137');
INSERT INTO public.who_global_data_import VALUES (40095, '2020-04-06', 'IE', 'Ireland', 'EURO', '507', '5111', '21', '158');
INSERT INTO public.who_global_data_import VALUES (40096, '2020-04-07', 'IE', 'Ireland', 'EURO', '253', '5364', '16', '174');
INSERT INTO public.who_global_data_import VALUES (40097, '2020-04-08', 'IE', 'Ireland', 'EURO', '345', '5709', '36', '210');
INSERT INTO public.who_global_data_import VALUES (40098, '2020-04-09', 'IE', 'Ireland', 'EURO', '515', '6224', '25', '235');
INSERT INTO public.who_global_data_import VALUES (40099, '2020-04-10', 'IE', 'Ireland', 'EURO', '1169', '7393', '28', '263');
INSERT INTO public.who_global_data_import VALUES (40100, '2020-04-11', 'IE', 'Ireland', 'EURO', '696', '8089', '24', '287');
INSERT INTO public.who_global_data_import VALUES (40101, '2020-04-12', 'IE', 'Ireland', 'EURO', '839', '8928', '33', '320');
INSERT INTO public.who_global_data_import VALUES (40102, '2020-04-13', 'IE', 'Ireland', 'EURO', '727', '9655', '14', '334');
INSERT INTO public.who_global_data_import VALUES (40103, '2020-04-14', 'IE', 'Ireland', 'EURO', '992', '10647', '31', '365');
INSERT INTO public.who_global_data_import VALUES (40104, '2020-04-15', 'IE', 'Ireland', 'EURO', '832', '11479', '41', '406');
INSERT INTO public.who_global_data_import VALUES (40105, '2020-04-16', 'IE', 'Ireland', 'EURO', '1068', '12547', '38', '444');
INSERT INTO public.who_global_data_import VALUES (40106, '2020-04-17', 'IE', 'Ireland', 'EURO', '724', '13271', '42', '486');
INSERT INTO public.who_global_data_import VALUES (40107, '2020-04-18', 'IE', 'Ireland', 'EURO', '709', '13980', '44', '530');
INSERT INTO public.who_global_data_import VALUES (40108, '2020-04-19', 'IE', 'Ireland', 'EURO', '778', '14758', '41', '571');
INSERT INTO public.who_global_data_import VALUES (40109, '2020-04-20', 'IE', 'Ireland', 'EURO', '493', '15251', '39', '610');
INSERT INTO public.who_global_data_import VALUES (40110, '2020-04-21', 'IE', 'Ireland', 'EURO', '401', '15652', '77', '687');
INSERT INTO public.who_global_data_import VALUES (40111, '2020-04-22', 'IE', 'Ireland', 'EURO', '388', '16040', '43', '730');
INSERT INTO public.who_global_data_import VALUES (40112, '2020-04-23', 'IE', 'Ireland', 'EURO', '631', '16671', '39', '769');
INSERT INTO public.who_global_data_import VALUES (40113, '2020-04-24', 'IE', 'Ireland', 'EURO', '936', '17607', '25', '794');
INSERT INTO public.who_global_data_import VALUES (40114, '2020-04-25', 'IE', 'Ireland', 'EURO', '577', '18184', '35', '829');
INSERT INTO public.who_global_data_import VALUES (40115, '2020-04-26', 'IE', 'Ireland', 'EURO', '377', '18561', '234', '1063');
INSERT INTO public.who_global_data_import VALUES (40116, '2020-04-27', 'IE', 'Ireland', 'EURO', '701', '19262', '24', '1087');
INSERT INTO public.who_global_data_import VALUES (40117, '2020-04-28', 'IE', 'Ireland', 'EURO', '386', '19648', '15', '1102');
INSERT INTO public.who_global_data_import VALUES (40118, '2020-04-29', 'IE', 'Ireland', 'EURO', '229', '19877', '57', '1159');
INSERT INTO public.who_global_data_import VALUES (40119, '2020-04-30', 'IE', 'Ireland', 'EURO', '376', '20253', '31', '1190');
INSERT INTO public.who_global_data_import VALUES (40120, '2020-05-01', 'IE', 'Ireland', 'EURO', '359', '20612', '42', '1232');
INSERT INTO public.who_global_data_import VALUES (40121, '2020-05-02', 'IE', 'Ireland', 'EURO', '221', '20833', '33', '1265');
INSERT INTO public.who_global_data_import VALUES (40122, '2020-05-03', 'IE', 'Ireland', 'EURO', '343', '21176', '0', '1265');
INSERT INTO public.who_global_data_import VALUES (40123, '2020-05-04', 'IE', 'Ireland', 'EURO', '330', '21506', '38', '1303');
INSERT INTO public.who_global_data_import VALUES (40124, '2020-05-05', 'IE', 'Ireland', 'EURO', '216', '21722', '16', '1319');
INSERT INTO public.who_global_data_import VALUES (40125, '2020-05-06', 'IE', 'Ireland', 'EURO', '261', '21983', '20', '1339');
INSERT INTO public.who_global_data_import VALUES (40126, '2020-05-07', 'IE', 'Ireland', 'EURO', '265', '22248', '36', '1375');
INSERT INTO public.who_global_data_import VALUES (40127, '2020-05-08', 'IE', 'Ireland', 'EURO', '137', '22385', '28', '1403');
INSERT INTO public.who_global_data_import VALUES (40128, '2020-05-09', 'IE', 'Ireland', 'EURO', '156', '22541', '26', '1429');
INSERT INTO public.who_global_data_import VALUES (40129, '2020-05-10', 'IE', 'Ireland', 'EURO', '219', '22760', '17', '1446');
INSERT INTO public.who_global_data_import VALUES (40130, '2020-05-11', 'IE', 'Ireland', 'EURO', '236', '22996', '12', '1458');
INSERT INTO public.who_global_data_import VALUES (40131, '2020-05-12', 'IE', 'Ireland', 'EURO', '139', '23135', '9', '1467');
INSERT INTO public.who_global_data_import VALUES (40132, '2020-05-13', 'IE', 'Ireland', 'EURO', '107', '23242', '21', '1488');
INSERT INTO public.who_global_data_import VALUES (40133, '2020-05-14', 'IE', 'Ireland', 'EURO', '159', '23401', '9', '1497');
INSERT INTO public.who_global_data_import VALUES (40134, '2020-05-15', 'IE', 'Ireland', 'EURO', '426', '23827', '9', '1506');
INSERT INTO public.who_global_data_import VALUES (40135, '2020-05-16', 'IE', 'Ireland', 'EURO', '129', '23956', '12', '1518');
INSERT INTO public.who_global_data_import VALUES (40136, '2020-05-17', 'IE', 'Ireland', 'EURO', '92', '24048', '15', '1533');
INSERT INTO public.who_global_data_import VALUES (40137, '2020-05-18', 'IE', 'Ireland', 'EURO', '64', '24112', '10', '1543');
INSERT INTO public.who_global_data_import VALUES (40138, '2020-05-19', 'IE', 'Ireland', 'EURO', '88', '24200', '4', '1547');
INSERT INTO public.who_global_data_import VALUES (40139, '2020-05-20', 'IE', 'Ireland', 'EURO', '51', '24251', '14', '1561');
INSERT INTO public.who_global_data_import VALUES (40140, '2020-05-21', 'IE', 'Ireland', 'EURO', '64', '24315', '10', '1571');
INSERT INTO public.who_global_data_import VALUES (40141, '2020-05-22', 'IE', 'Ireland', 'EURO', '76', '24391', '12', '1583');
INSERT INTO public.who_global_data_import VALUES (40142, '2020-05-23', 'IE', 'Ireland', 'EURO', '115', '24506', '9', '1592');
INSERT INTO public.who_global_data_import VALUES (40143, '2020-05-24', 'IE', 'Ireland', 'EURO', '76', '24582', '12', '1604');
INSERT INTO public.who_global_data_import VALUES (40144, '2020-05-25', 'IE', 'Ireland', 'EURO', '57', '24639', '2', '1606');
INSERT INTO public.who_global_data_import VALUES (40145, '2020-05-26', 'IE', 'Ireland', 'EURO', '59', '24698', '0', '1606');
INSERT INTO public.who_global_data_import VALUES (41201, '2020-01-03', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40146, '2020-05-27', 'IE', 'Ireland', 'EURO', '37', '24735', '9', '1615');
INSERT INTO public.who_global_data_import VALUES (40147, '2020-05-28', 'IE', 'Ireland', 'EURO', '68', '24803', '16', '1631');
INSERT INTO public.who_global_data_import VALUES (40148, '2020-05-29', 'IE', 'Ireland', 'EURO', '38', '24841', '8', '1639');
INSERT INTO public.who_global_data_import VALUES (40149, '2020-05-30', 'IE', 'Ireland', 'EURO', '35', '24876', '6', '1645');
INSERT INTO public.who_global_data_import VALUES (40150, '2020-05-31', 'IE', 'Ireland', 'EURO', '53', '24929', '5', '1650');
INSERT INTO public.who_global_data_import VALUES (40151, '2020-06-01', 'IE', 'Ireland', 'EURO', '61', '24990', '0', '1650');
INSERT INTO public.who_global_data_import VALUES (40152, '2020-06-02', 'IE', 'Ireland', 'EURO', '72', '25062', '0', '1650');
INSERT INTO public.who_global_data_import VALUES (40153, '2020-06-03', 'IE', 'Ireland', 'EURO', '4', '25066', '8', '1658');
INSERT INTO public.who_global_data_import VALUES (40154, '2020-06-04', 'IE', 'Ireland', 'EURO', '45', '25111', '1', '1659');
INSERT INTO public.who_global_data_import VALUES (40155, '2020-06-05', 'IE', 'Ireland', 'EURO', '31', '25142', '5', '1664');
INSERT INTO public.who_global_data_import VALUES (40156, '2020-06-06', 'IE', 'Ireland', 'EURO', '21', '25163', '6', '1670');
INSERT INTO public.who_global_data_import VALUES (40157, '2020-06-07', 'IE', 'Ireland', 'EURO', '20', '25183', '0', '1670');
INSERT INTO public.who_global_data_import VALUES (40158, '2020-06-08', 'IE', 'Ireland', 'EURO', '18', '25201', '9', '1679');
INSERT INTO public.who_global_data_import VALUES (40159, '2020-06-09', 'IE', 'Ireland', 'EURO', '6', '25207', '4', '1683');
INSERT INTO public.who_global_data_import VALUES (40160, '2020-06-10', 'IE', 'Ireland', 'EURO', '8', '25215', '8', '1691');
INSERT INTO public.who_global_data_import VALUES (40161, '2020-06-11', 'IE', 'Ireland', 'EURO', '16', '25231', '4', '1695');
INSERT INTO public.who_global_data_import VALUES (40162, '2020-06-12', 'IE', 'Ireland', 'EURO', '7', '25238', '8', '1703');
INSERT INTO public.who_global_data_import VALUES (40163, '2020-06-13', 'IE', 'Ireland', 'EURO', '12', '25250', '2', '1705');
INSERT INTO public.who_global_data_import VALUES (40164, '2020-06-14', 'IE', 'Ireland', 'EURO', '45', '25295', '0', '1705');
INSERT INTO public.who_global_data_import VALUES (40165, '2020-06-15', 'IE', 'Ireland', 'EURO', '8', '25303', '1', '1706');
INSERT INTO public.who_global_data_import VALUES (40166, '2020-06-16', 'IE', 'Ireland', 'EURO', '18', '25321', '0', '1706');
INSERT INTO public.who_global_data_import VALUES (40167, '2020-06-17', 'IE', 'Ireland', 'EURO', '13', '25334', '3', '1709');
INSERT INTO public.who_global_data_import VALUES (40168, '2020-06-18', 'IE', 'Ireland', 'EURO', '7', '25341', '1', '1710');
INSERT INTO public.who_global_data_import VALUES (40169, '2020-06-19', 'IE', 'Ireland', 'EURO', '14', '25355', '4', '1714');
INSERT INTO public.who_global_data_import VALUES (40170, '2020-06-20', 'IE', 'Ireland', 'EURO', '13', '25368', '0', '1714');
INSERT INTO public.who_global_data_import VALUES (40171, '2020-06-21', 'IE', 'Ireland', 'EURO', '6', '25374', '1', '1715');
INSERT INTO public.who_global_data_import VALUES (40172, '2020-06-22', 'IE', 'Ireland', 'EURO', '5', '25379', '0', '1715');
INSERT INTO public.who_global_data_import VALUES (40173, '2020-06-23', 'IE', 'Ireland', 'EURO', '4', '25383', '2', '1717');
INSERT INTO public.who_global_data_import VALUES (40174, '2020-06-24', 'IE', 'Ireland', 'EURO', '8', '25391', '3', '1720');
INSERT INTO public.who_global_data_import VALUES (40175, '2020-06-25', 'IE', 'Ireland', 'EURO', '5', '25396', '6', '1726');
INSERT INTO public.who_global_data_import VALUES (40176, '2020-06-26', 'IE', 'Ireland', 'EURO', '9', '25405', '1', '1727');
INSERT INTO public.who_global_data_import VALUES (40177, '2020-06-27', 'IE', 'Ireland', 'EURO', '9', '25414', '3', '1730');
INSERT INTO public.who_global_data_import VALUES (40178, '2020-06-28', 'IE', 'Ireland', 'EURO', '23', '25437', '4', '1734');
INSERT INTO public.who_global_data_import VALUES (40179, '2020-06-29', 'IE', 'Ireland', 'EURO', '2', '25439', '1', '1735');
INSERT INTO public.who_global_data_import VALUES (40180, '2020-06-30', 'IE', 'Ireland', 'EURO', '23', '25462', '0', '1735');
INSERT INTO public.who_global_data_import VALUES (40181, '2020-07-01', 'IE', 'Ireland', 'EURO', '11', '25473', '1', '1736');
INSERT INTO public.who_global_data_import VALUES (40182, '2020-07-02', 'IE', 'Ireland', 'EURO', '4', '25477', '2', '1738');
INSERT INTO public.who_global_data_import VALUES (40183, '2020-07-03', 'IE', 'Ireland', 'EURO', '12', '25489', '0', '1738');
INSERT INTO public.who_global_data_import VALUES (40184, '2020-07-04', 'IE', 'Ireland', 'EURO', '9', '25498', '2', '1740');
INSERT INTO public.who_global_data_import VALUES (40185, '2020-07-05', 'IE', 'Ireland', 'EURO', '11', '25509', '1', '1741');
INSERT INTO public.who_global_data_import VALUES (40186, '2020-07-06', 'IE', 'Ireland', 'EURO', '18', '25527', '0', '1741');
INSERT INTO public.who_global_data_import VALUES (40187, '2020-07-07', 'IE', 'Ireland', 'EURO', '4', '25531', '0', '1741');
INSERT INTO public.who_global_data_import VALUES (40188, '2020-07-08', 'IE', 'Ireland', 'EURO', '7', '25538', '2', '1743');
INSERT INTO public.who_global_data_import VALUES (40189, '2020-07-09', 'IE', 'Ireland', 'EURO', '4', '25542', '0', '1743');
INSERT INTO public.who_global_data_import VALUES (40190, '2020-07-10', 'IE', 'Ireland', 'EURO', '23', '25565', '0', '1743');
INSERT INTO public.who_global_data_import VALUES (40191, '2020-07-11', 'IE', 'Ireland', 'EURO', '24', '25589', '1', '1744');
INSERT INTO public.who_global_data_import VALUES (40192, '2020-07-12', 'IE', 'Ireland', 'EURO', '22', '25611', '2', '1746');
INSERT INTO public.who_global_data_import VALUES (40193, '2020-07-13', 'IE', 'Ireland', 'EURO', '17', '25628', '0', '1746');
INSERT INTO public.who_global_data_import VALUES (40194, '2020-07-14', 'IE', 'Ireland', 'EURO', '10', '25638', '0', '1746');
INSERT INTO public.who_global_data_import VALUES (40195, '2020-07-15', 'IE', 'Ireland', 'EURO', '32', '25670', '0', '1746');
INSERT INTO public.who_global_data_import VALUES (40196, '2020-07-16', 'IE', 'Ireland', 'EURO', '13', '25683', '2', '1748');
INSERT INTO public.who_global_data_import VALUES (40197, '2020-07-17', 'IE', 'Ireland', 'EURO', '15', '25698', '1', '1749');
INSERT INTO public.who_global_data_import VALUES (40198, '2020-07-18', 'IE', 'Ireland', 'EURO', '32', '25730', '3', '1752');
INSERT INTO public.who_global_data_import VALUES (40199, '2020-07-19', 'IE', 'Ireland', 'EURO', '20', '25750', '1', '1753');
INSERT INTO public.who_global_data_import VALUES (40200, '2020-07-20', 'IE', 'Ireland', 'EURO', '10', '25760', '0', '1753');
INSERT INTO public.who_global_data_import VALUES (40201, '2020-07-21', 'IE', 'Ireland', 'EURO', '6', '25766', '0', '1753');
INSERT INTO public.who_global_data_import VALUES (40202, '2020-07-22', 'IE', 'Ireland', 'EURO', '36', '25802', '0', '1753');
INSERT INTO public.who_global_data_import VALUES (40203, '2020-07-23', 'IE', 'Ireland', 'EURO', '17', '25819', '1', '1754');
INSERT INTO public.who_global_data_import VALUES (40204, '2020-07-24', 'IE', 'Ireland', 'EURO', '7', '25826', '9', '1763');
INSERT INTO public.who_global_data_import VALUES (40205, '2020-07-25', 'IE', 'Ireland', 'EURO', '19', '25845', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40206, '2020-07-26', 'IE', 'Ireland', 'EURO', '24', '25869', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40207, '2020-07-27', 'IE', 'Ireland', 'EURO', '12', '25881', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40208, '2020-07-28', 'IE', 'Ireland', 'EURO', '11', '25892', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40209, '2020-07-29', 'IE', 'Ireland', 'EURO', '37', '25929', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40210, '2020-07-30', 'IE', 'Ireland', 'EURO', '13', '25942', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40211, '2020-07-31', 'IE', 'Ireland', 'EURO', '85', '26027', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40212, '2020-08-01', 'IE', 'Ireland', 'EURO', '38', '26065', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40213, '2020-08-02', 'IE', 'Ireland', 'EURO', '44', '26109', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40214, '2020-08-03', 'IE', 'Ireland', 'EURO', '53', '26162', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40215, '2020-08-04', 'IE', 'Ireland', 'EURO', '46', '26208', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40216, '2020-08-05', 'IE', 'Ireland', 'EURO', '45', '26253', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40217, '2020-08-06', 'IE', 'Ireland', 'EURO', '50', '26303', '0', '1763');
INSERT INTO public.who_global_data_import VALUES (40218, '2020-08-07', 'IE', 'Ireland', 'EURO', '69', '26372', '5', '1768');
INSERT INTO public.who_global_data_import VALUES (40219, '2020-08-08', 'IE', 'Ireland', 'EURO', '98', '26470', '4', '1772');
INSERT INTO public.who_global_data_import VALUES (40220, '2020-08-09', 'IE', 'Ireland', 'EURO', '174', '26644', '0', '1772');
INSERT INTO public.who_global_data_import VALUES (40221, '2020-08-10', 'IE', 'Ireland', 'EURO', '68', '26712', '0', '1772');
INSERT INTO public.who_global_data_import VALUES (40222, '2020-08-11', 'IE', 'Ireland', 'EURO', '56', '26768', '0', '1772');
INSERT INTO public.who_global_data_import VALUES (40223, '2020-08-12', 'IE', 'Ireland', 'EURO', '33', '26801', '1', '1773');
INSERT INTO public.who_global_data_import VALUES (40224, '2020-08-13', 'IE', 'Ireland', 'EURO', '37', '26838', '1', '1774');
INSERT INTO public.who_global_data_import VALUES (40225, '2020-08-14', 'IE', 'Ireland', 'EURO', '91', '26929', '0', '1774');
INSERT INTO public.who_global_data_import VALUES (40226, '2020-08-15', 'IE', 'Ireland', 'EURO', '66', '26995', '0', '1774');
INSERT INTO public.who_global_data_import VALUES (40227, '2020-08-16', 'IE', 'Ireland', 'EURO', '196', '27191', '0', '1774');
INSERT INTO public.who_global_data_import VALUES (40228, '2020-08-17', 'IE', 'Ireland', 'EURO', '66', '27257', '0', '1774');
INSERT INTO public.who_global_data_import VALUES (40229, '2020-08-18', 'IE', 'Ireland', 'EURO', '56', '27313', '0', '1774');
INSERT INTO public.who_global_data_import VALUES (40230, '2020-08-19', 'IE', 'Ireland', 'EURO', '186', '27499', '1', '1775');
INSERT INTO public.who_global_data_import VALUES (40231, '2020-08-20', 'IE', 'Ireland', 'EURO', '48', '27547', '0', '1775');
INSERT INTO public.who_global_data_import VALUES (40232, '2020-08-21', 'IE', 'Ireland', 'EURO', '129', '27676', '1', '1776');
INSERT INTO public.who_global_data_import VALUES (40233, '2020-08-22', 'IE', 'Ireland', 'EURO', '79', '27755', '0', '1776');
INSERT INTO public.who_global_data_import VALUES (40234, '2020-08-23', 'IE', 'Ireland', 'EURO', '153', '27908', '1', '1777');
INSERT INTO public.who_global_data_import VALUES (40235, '2020-08-24', 'IE', 'Ireland', 'EURO', '61', '27969', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40236, '2020-08-25', 'IE', 'Ireland', 'EURO', '147', '28116', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40237, '2020-08-26', 'IE', 'Ireland', 'EURO', '85', '28201', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40238, '2020-08-27', 'IE', 'Ireland', 'EURO', '162', '28363', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40239, '2020-08-28', 'IE', 'Ireland', 'EURO', '90', '28453', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40240, '2020-08-29', 'IE', 'Ireland', 'EURO', '126', '28579', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40241, '2020-08-30', 'IE', 'Ireland', 'EURO', '141', '28720', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40242, '2020-08-31', 'IE', 'Ireland', 'EURO', '40', '28760', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40243, '2020-09-01', 'IE', 'Ireland', 'EURO', '51', '28811', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40244, '2020-09-02', 'IE', 'Ireland', 'EURO', '214', '29025', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40245, '2020-09-03', 'IE', 'Ireland', 'EURO', '89', '29114', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40246, '2020-09-04', 'IE', 'Ireland', 'EURO', '92', '29206', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40247, '2020-09-05', 'IE', 'Ireland', 'EURO', '97', '29303', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40248, '2020-09-06', 'IE', 'Ireland', 'EURO', '231', '29534', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40249, '2020-09-07', 'IE', 'Ireland', 'EURO', '138', '29672', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40250, '2020-09-08', 'IE', 'Ireland', 'EURO', '102', '29774', '0', '1777');
INSERT INTO public.who_global_data_import VALUES (40251, '2020-09-09', 'IE', 'Ireland', 'EURO', '306', '30080', '1', '1778');
INSERT INTO public.who_global_data_import VALUES (40252, '2020-09-10', 'IE', 'Ireland', 'EURO', '84', '30164', '3', '1781');
INSERT INTO public.who_global_data_import VALUES (40253, '2020-09-11', 'IE', 'Ireland', 'EURO', '196', '30360', '0', '1781');
INSERT INTO public.who_global_data_import VALUES (40254, '2020-09-12', 'IE', 'Ireland', 'EURO', '211', '30571', '0', '1781');
INSERT INTO public.who_global_data_import VALUES (40255, '2020-09-13', 'IE', 'Ireland', 'EURO', '159', '30730', '2', '1783');
INSERT INTO public.who_global_data_import VALUES (40256, '2020-09-14', 'IE', 'Ireland', 'EURO', '255', '30985', '1', '1784');
INSERT INTO public.who_global_data_import VALUES (40257, '2020-09-15', 'IE', 'Ireland', 'EURO', '207', '31192', '0', '1784');
INSERT INTO public.who_global_data_import VALUES (40258, '2020-09-16', 'IE', 'Ireland', 'EURO', '357', '31549', '3', '1787');
INSERT INTO public.who_global_data_import VALUES (40259, '2020-09-17', 'IE', 'Ireland', 'EURO', '250', '31799', '1', '1788');
INSERT INTO public.who_global_data_import VALUES (40260, '2020-09-18', 'IE', 'Ireland', 'EURO', '224', '32023', '1', '1789');
INSERT INTO public.who_global_data_import VALUES (40261, '2020-09-19', 'IE', 'Ireland', 'EURO', '248', '32271', '3', '1792');
INSERT INTO public.who_global_data_import VALUES (40262, '2020-09-20', 'IE', 'Ireland', 'EURO', '267', '32538', '0', '1792');
INSERT INTO public.who_global_data_import VALUES (40263, '2020-09-21', 'IE', 'Ireland', 'EURO', '395', '32933', '0', '1792');
INSERT INTO public.who_global_data_import VALUES (40264, '2020-09-22', 'IE', 'Ireland', 'EURO', '188', '33121', '0', '1792');
INSERT INTO public.who_global_data_import VALUES (40265, '2020-09-23', 'IE', 'Ireland', 'EURO', '323', '33444', '0', '1792');
INSERT INTO public.who_global_data_import VALUES (40266, '2020-09-24', 'IE', 'Ireland', 'EURO', '231', '33675', '2', '1794');
INSERT INTO public.who_global_data_import VALUES (40267, '2020-09-25', 'IE', 'Ireland', 'EURO', '319', '33994', '3', '1797');
INSERT INTO public.who_global_data_import VALUES (40268, '2020-09-26', 'IE', 'Ireland', 'EURO', '321', '34315', '0', '1797');
INSERT INTO public.who_global_data_import VALUES (40269, '2020-09-27', 'IE', 'Ireland', 'EURO', '245', '34560', '5', '1802');
INSERT INTO public.who_global_data_import VALUES (40270, '2020-09-28', 'IE', 'Ireland', 'EURO', '430', '34990', '0', '1802');
INSERT INTO public.who_global_data_import VALUES (40271, '2020-09-29', 'IE', 'Ireland', 'EURO', '388', '35378', '0', '1802');
INSERT INTO public.who_global_data_import VALUES (40272, '2020-09-30', 'IE', 'Ireland', 'EURO', '362', '35740', '1', '1803');
INSERT INTO public.who_global_data_import VALUES (40273, '2020-10-01', 'IE', 'Ireland', 'EURO', '415', '36155', '1', '1804');
INSERT INTO public.who_global_data_import VALUES (40274, '2020-10-02', 'IE', 'Ireland', 'EURO', '442', '36597', '2', '1806');
INSERT INTO public.who_global_data_import VALUES (40275, '2020-10-03', 'IE', 'Ireland', 'EURO', '466', '37063', '-5', '1801');
INSERT INTO public.who_global_data_import VALUES (40276, '2020-10-04', 'IE', 'Ireland', 'EURO', '605', '37668', '9', '1810');
INSERT INTO public.who_global_data_import VALUES (40277, '2020-10-05', 'IE', 'Ireland', 'EURO', '364', '38032', '0', '1810');
INSERT INTO public.who_global_data_import VALUES (40278, '2020-10-06', 'IE', 'Ireland', 'EURO', '519', '38551', '0', '1810');
INSERT INTO public.who_global_data_import VALUES (40279, '2020-10-07', 'IE', 'Ireland', 'EURO', '424', '38975', '1', '1811');
INSERT INTO public.who_global_data_import VALUES (40280, '2020-10-08', 'IE', 'Ireland', 'EURO', '609', '39584', '5', '1816');
INSERT INTO public.who_global_data_import VALUES (40281, '2020-10-09', 'IE', 'Ireland', 'EURO', '502', '40086', '1', '1817');
INSERT INTO public.who_global_data_import VALUES (40282, '2020-10-10', 'IE', 'Ireland', 'EURO', '617', '40703', '4', '1821');
INSERT INTO public.who_global_data_import VALUES (40283, '2020-10-11', 'IE', 'Ireland', 'EURO', '1011', '41714', '0', '1821');
INSERT INTO public.who_global_data_import VALUES (40284, '2020-10-12', 'IE', 'Ireland', 'EURO', '814', '42528', '5', '1826');
INSERT INTO public.who_global_data_import VALUES (40285, '2020-10-13', 'IE', 'Ireland', 'EURO', '823', '43351', '1', '1827');
INSERT INTO public.who_global_data_import VALUES (40286, '2020-10-14', 'IE', 'Ireland', 'EURO', '808', '44159', '3', '1830');
INSERT INTO public.who_global_data_import VALUES (40287, '2020-10-15', 'IE', 'Ireland', 'EURO', '1084', '45243', '5', '1835');
INSERT INTO public.who_global_data_import VALUES (40288, '2020-10-16', 'IE', 'Ireland', 'EURO', '1186', '46429', '3', '1838');
INSERT INTO public.who_global_data_import VALUES (40289, '2020-10-17', 'IE', 'Ireland', 'EURO', '998', '47427', '3', '1841');
INSERT INTO public.who_global_data_import VALUES (40290, '2020-10-18', 'IE', 'Ireland', 'EURO', '1251', '48678', '8', '1849');
INSERT INTO public.who_global_data_import VALUES (40291, '2020-10-19', 'IE', 'Ireland', 'EURO', '1284', '49962', '3', '1852');
INSERT INTO public.who_global_data_import VALUES (40292, '2020-10-20', 'IE', 'Ireland', 'EURO', '1031', '50993', '0', '1852');
INSERT INTO public.who_global_data_import VALUES (40293, '2020-10-21', 'IE', 'Ireland', 'EURO', '1263', '52256', '13', '1865');
INSERT INTO public.who_global_data_import VALUES (40294, '2020-10-22', 'IE', 'Ireland', 'EURO', '1166', '53422', '3', '1868');
INSERT INTO public.who_global_data_import VALUES (40295, '2020-10-23', 'IE', 'Ireland', 'EURO', '1054', '54476', '3', '1871');
INSERT INTO public.who_global_data_import VALUES (40296, '2020-10-24', 'IE', 'Ireland', 'EURO', '785', '55261', '7', '1878');
INSERT INTO public.who_global_data_import VALUES (40297, '2020-10-25', 'IE', 'Ireland', 'EURO', '847', '56108', '4', '1882');
INSERT INTO public.who_global_data_import VALUES (40298, '2020-10-26', 'IE', 'Ireland', 'EURO', '1020', '57128', '0', '1882');
INSERT INTO public.who_global_data_import VALUES (40299, '2020-10-27', 'IE', 'Ireland', 'EURO', '939', '58067', '3', '1885');
INSERT INTO public.who_global_data_import VALUES (40300, '2020-10-28', 'IE', 'Ireland', 'EURO', '700', '58767', '5', '1890');
INSERT INTO public.who_global_data_import VALUES (40301, '2020-10-29', 'IE', 'Ireland', 'EURO', '667', '59434', '6', '1896');
INSERT INTO public.who_global_data_import VALUES (40302, '2020-10-30', 'IE', 'Ireland', 'EURO', '863', '60297', '6', '1902');
INSERT INTO public.who_global_data_import VALUES (40303, '2020-10-31', 'IE', 'Ireland', 'EURO', '762', '61059', '6', '1908');
INSERT INTO public.who_global_data_import VALUES (40304, '2020-11-01', 'IE', 'Ireland', 'EURO', '397', '61456', '5', '1913');
INSERT INTO public.who_global_data_import VALUES (40305, '2020-11-02', 'IE', 'Ireland', 'EURO', '546', '62002', '2', '1915');
INSERT INTO public.who_global_data_import VALUES (40306, '2020-11-03', 'IE', 'Ireland', 'EURO', '748', '62750', '2', '1917');
INSERT INTO public.who_global_data_import VALUES (40307, '2020-11-04', 'IE', 'Ireland', 'EURO', '298', '63048', '5', '1922');
INSERT INTO public.who_global_data_import VALUES (40308, '2020-11-05', 'IE', 'Ireland', 'EURO', '435', '63483', '8', '1930');
INSERT INTO public.who_global_data_import VALUES (40309, '2020-11-06', 'IE', 'Ireland', 'EURO', '563', '64046', '3', '1933');
INSERT INTO public.who_global_data_import VALUES (40310, '2020-11-07', 'IE', 'Ireland', 'EURO', '492', '64538', '7', '1940');
INSERT INTO public.who_global_data_import VALUES (40311, '2020-11-08', 'IE', 'Ireland', 'EURO', '317', '64855', '5', '1945');
INSERT INTO public.who_global_data_import VALUES (40312, '2020-11-09', 'IE', 'Ireland', 'EURO', '539', '65394', '2', '1947');
INSERT INTO public.who_global_data_import VALUES (40313, '2020-11-10', 'IE', 'Ireland', 'EURO', '265', '65659', '1', '1948');
INSERT INTO public.who_global_data_import VALUES (40314, '2020-11-11', 'IE', 'Ireland', 'EURO', '230', '65889', '15', '1963');
INSERT INTO public.who_global_data_import VALUES (40315, '2020-11-12', 'IE', 'Ireland', 'EURO', '358', '66247', '2', '1965');
INSERT INTO public.who_global_data_import VALUES (40316, '2020-11-13', 'IE', 'Ireland', 'EURO', '385', '66632', '0', '1965');
INSERT INTO public.who_global_data_import VALUES (40317, '2020-11-14', 'IE', 'Ireland', 'EURO', '467', '67099', '7', '1972');
INSERT INTO public.who_global_data_import VALUES (40318, '2020-11-15', 'IE', 'Ireland', 'EURO', '427', '67526', '6', '1978');
INSERT INTO public.who_global_data_import VALUES (40319, '2020-11-16', 'IE', 'Ireland', 'EURO', '377', '67903', '1', '1979');
INSERT INTO public.who_global_data_import VALUES (40320, '2020-11-17', 'IE', 'Ireland', 'EURO', '453', '68356', '5', '1984');
INSERT INTO public.who_global_data_import VALUES (40321, '2020-11-18', 'IE', 'Ireland', 'EURO', '330', '68686', '11', '1995');
INSERT INTO public.who_global_data_import VALUES (40322, '2020-11-19', 'IE', 'Ireland', 'EURO', '372', '69058', '11', '2006');
INSERT INTO public.who_global_data_import VALUES (40323, '2020-11-20', 'IE', 'Ireland', 'EURO', '415', '69473', '4', '2010');
INSERT INTO public.who_global_data_import VALUES (40324, '2020-11-21', 'IE', 'Ireland', 'EURO', '329', '69802', '8', '2018');
INSERT INTO public.who_global_data_import VALUES (40325, '2020-11-22', 'IE', 'Ireland', 'EURO', '341', '70143', '4', '2022');
INSERT INTO public.who_global_data_import VALUES (40326, '2020-11-23', 'IE', 'Ireland', 'EURO', '318', '70461', '0', '2022');
INSERT INTO public.who_global_data_import VALUES (40327, '2020-11-24', 'IE', 'Ireland', 'EURO', '250', '70711', '0', '2022');
INSERT INTO public.who_global_data_import VALUES (40328, '2020-11-25', 'IE', 'Ireland', 'EURO', '219', '70930', '6', '2028');
INSERT INTO public.who_global_data_import VALUES (40329, '2020-11-26', 'IE', 'Ireland', 'EURO', '257', '71187', '5', '2033');
INSERT INTO public.who_global_data_import VALUES (40330, '2020-11-27', 'IE', 'Ireland', 'EURO', '307', '71494', '3', '2036');
INSERT INTO public.who_global_data_import VALUES (40331, '2020-11-28', 'IE', 'Ireland', 'EURO', '205', '71699', '7', '2043');
INSERT INTO public.who_global_data_import VALUES (40332, '2020-11-29', 'IE', 'Ireland', 'EURO', '243', '71942', '7', '2050');
INSERT INTO public.who_global_data_import VALUES (40333, '2020-11-30', 'IE', 'Ireland', 'EURO', '299', '72241', '2', '2052');
INSERT INTO public.who_global_data_import VALUES (40334, '2020-12-01', 'IE', 'Ireland', 'EURO', '303', '72544', '1', '2053');
INSERT INTO public.who_global_data_import VALUES (40335, '2020-12-02', 'IE', 'Ireland', 'EURO', '254', '72798', '16', '2069');
INSERT INTO public.who_global_data_import VALUES (40336, '2020-12-03', 'IE', 'Ireland', 'EURO', '268', '73066', '5', '2074');
INSERT INTO public.who_global_data_import VALUES (40337, '2020-12-04', 'IE', 'Ireland', 'EURO', '162', '73228', '6', '2080');
INSERT INTO public.who_global_data_import VALUES (40338, '2020-12-05', 'IE', 'Ireland', 'EURO', '263', '73491', '6', '2086');
INSERT INTO public.who_global_data_import VALUES (40339, '2020-12-06', 'IE', 'Ireland', 'EURO', '457', '73948', '11', '2097');
INSERT INTO public.who_global_data_import VALUES (40340, '2020-12-07', 'IE', 'Ireland', 'EURO', '298', '74246', '0', '2097');
INSERT INTO public.who_global_data_import VALUES (40341, '2020-12-08', 'IE', 'Ireland', 'EURO', '222', '74468', '0', '2097');
INSERT INTO public.who_global_data_import VALUES (40342, '2020-12-09', 'IE', 'Ireland', 'EURO', '214', '74682', '0', '2097');
INSERT INTO public.who_global_data_import VALUES (40343, '2020-12-10', 'IE', 'Ireland', 'EURO', '218', '74900', '5', '2102');
INSERT INTO public.who_global_data_import VALUES (40344, '2020-12-11', 'IE', 'Ireland', 'EURO', '303', '75203', '15', '2117');
INSERT INTO public.who_global_data_import VALUES (40345, '2020-12-12', 'IE', 'Ireland', 'EURO', '304', '75507', '3', '2120');
INSERT INTO public.who_global_data_import VALUES (40346, '2020-12-13', 'IE', 'Ireland', 'EURO', '249', '75756', '3', '2123');
INSERT INTO public.who_global_data_import VALUES (40347, '2020-12-14', 'IE', 'Ireland', 'EURO', '429', '76185', '1', '2124');
INSERT INTO public.who_global_data_import VALUES (40348, '2020-12-15', 'IE', 'Ireland', 'EURO', '264', '76449', '2', '2126');
INSERT INTO public.who_global_data_import VALUES (40349, '2020-12-16', 'IE', 'Ireland', 'EURO', '327', '76776', '8', '2134');
INSERT INTO public.who_global_data_import VALUES (40350, '2020-12-17', 'IE', 'Ireland', 'EURO', '421', '77197', '6', '2140');
INSERT INTO public.who_global_data_import VALUES (40351, '2020-12-18', 'IE', 'Ireland', 'EURO', '481', '77678', '3', '2143');
INSERT INTO public.who_global_data_import VALUES (40352, '2020-12-19', 'IE', 'Ireland', 'EURO', '576', '78254', '6', '2149');
INSERT INTO public.who_global_data_import VALUES (40353, '2020-12-20', 'IE', 'Ireland', 'EURO', '522', '78776', '5', '2154');
INSERT INTO public.who_global_data_import VALUES (40354, '2020-12-21', 'IE', 'Ireland', 'EURO', '766', '79542', '4', '2158');
INSERT INTO public.who_global_data_import VALUES (40355, '2020-12-22', 'IE', 'Ireland', 'EURO', '725', '80267', '0', '2158');
INSERT INTO public.who_global_data_import VALUES (40356, '2020-12-23', 'IE', 'Ireland', 'EURO', '961', '81228', '13', '2171');
INSERT INTO public.who_global_data_import VALUES (40357, '2020-12-24', 'IE', 'Ireland', 'EURO', '927', '82155', '13', '2184');
INSERT INTO public.who_global_data_import VALUES (40358, '2020-12-25', 'IE', 'Ireland', 'EURO', '918', '83073', '8', '2192');
INSERT INTO public.who_global_data_import VALUES (40359, '2020-12-26', 'IE', 'Ireland', 'EURO', '1025', '84098', '2', '2194');
INSERT INTO public.who_global_data_import VALUES (40360, '2020-12-27', 'IE', 'Ireland', 'EURO', '1296', '85394', '6', '2200');
INSERT INTO public.who_global_data_import VALUES (40361, '2020-12-28', 'IE', 'Ireland', 'EURO', '735', '86129', '4', '2204');
INSERT INTO public.who_global_data_import VALUES (40362, '2020-12-29', 'IE', 'Ireland', 'EURO', '765', '86894', '1', '2205');
INSERT INTO public.who_global_data_import VALUES (40363, '2020-12-30', 'IE', 'Ireland', 'EURO', '1545', '88439', '8', '2213');
INSERT INTO public.who_global_data_import VALUES (40364, '2020-12-31', 'IE', 'Ireland', 'EURO', '1718', '90157', '13', '2226');
INSERT INTO public.who_global_data_import VALUES (40365, '2021-01-01', 'IE', 'Ireland', 'EURO', '1622', '91779', '11', '2237');
INSERT INTO public.who_global_data_import VALUES (40366, '2021-01-02', 'IE', 'Ireland', 'EURO', '1753', '93532', '11', '2248');
INSERT INTO public.who_global_data_import VALUES (40367, '2021-01-03', 'IE', 'Ireland', 'EURO', '3394', '96926', '4', '2252');
INSERT INTO public.who_global_data_import VALUES (40368, '2021-01-04', 'IE', 'Ireland', 'EURO', '4961', '101887', '7', '2259');
INSERT INTO public.who_global_data_import VALUES (40369, '2021-01-05', 'IE', 'Ireland', 'EURO', '6110', '107997', '6', '2265');
INSERT INTO public.who_global_data_import VALUES (40370, '2021-01-06', 'IE', 'Ireland', 'EURO', '5325', '113322', '17', '2282');
INSERT INTO public.who_global_data_import VALUES (40371, '2021-01-07', 'IE', 'Ireland', 'EURO', '7832', '121154', '17', '2299');
INSERT INTO public.who_global_data_import VALUES (40372, '2021-01-08', 'IE', 'Ireland', 'EURO', '6503', '127657', '8', '2307');
INSERT INTO public.who_global_data_import VALUES (40373, '2021-01-09', 'IE', 'Ireland', 'EURO', '8227', '135884', '20', '2327');
INSERT INTO public.who_global_data_import VALUES (40374, '2021-01-10', 'IE', 'Ireland', 'EURO', '4843', '140727', '9', '2336');
INSERT INTO public.who_global_data_import VALUES (40375, '2021-01-11', 'IE', 'Ireland', 'EURO', '6886', '147613', '8', '2344');
INSERT INTO public.who_global_data_import VALUES (40376, '2021-01-12', 'IE', 'Ireland', 'EURO', '4926', '152539', '8', '2352');
INSERT INTO public.who_global_data_import VALUES (40377, '2021-01-13', 'IE', 'Ireland', 'EURO', '3052', '155591', '45', '2397');
INSERT INTO public.who_global_data_import VALUES (40378, '2021-01-14', 'IE', 'Ireland', 'EURO', '3553', '159144', '63', '2460');
INSERT INTO public.who_global_data_import VALUES (40379, '2021-01-15', 'IE', 'Ireland', 'EURO', '3913', '163057', '28', '2488');
INSERT INTO public.who_global_data_import VALUES (40380, '2021-01-16', 'IE', 'Ireland', 'EURO', '3491', '166548', '48', '2536');
INSERT INTO public.who_global_data_import VALUES (40381, '2021-01-17', 'IE', 'Ireland', 'EURO', '3232', '169780', '59', '2595');
INSERT INTO public.who_global_data_import VALUES (40382, '2021-01-18', 'IE', 'Ireland', 'EURO', '2946', '172726', '13', '2608');
INSERT INTO public.who_global_data_import VALUES (40383, '2021-01-19', 'IE', 'Ireland', 'EURO', '2117', '174843', '8', '2616');
INSERT INTO public.who_global_data_import VALUES (40384, '2021-01-20', 'IE', 'Ireland', 'EURO', '1996', '176839', '92', '2708');
INSERT INTO public.who_global_data_import VALUES (40385, '2021-01-21', 'IE', 'Ireland', 'EURO', '2485', '179324', '60', '2768');
INSERT INTO public.who_global_data_import VALUES (40386, '2021-01-22', 'IE', 'Ireland', 'EURO', '2598', '181922', '50', '2818');
INSERT INTO public.who_global_data_import VALUES (40387, '2021-01-23', 'IE', 'Ireland', 'EURO', '2357', '184279', '52', '2870');
INSERT INTO public.who_global_data_import VALUES (40388, '2021-01-24', 'IE', 'Ireland', 'EURO', '1905', '186184', '77', '2947');
INSERT INTO public.who_global_data_import VALUES (40389, '2021-01-25', 'IE', 'Ireland', 'EURO', '1370', '187554', '23', '2970');
INSERT INTO public.who_global_data_import VALUES (40390, '2021-01-26', 'IE', 'Ireland', 'EURO', '1369', '188923', '7', '2977');
INSERT INTO public.who_global_data_import VALUES (40391, '2021-01-27', 'IE', 'Ireland', 'EURO', '928', '189851', '89', '3066');
INSERT INTO public.who_global_data_import VALUES (40392, '2021-01-28', 'IE', 'Ireland', 'EURO', '1331', '191182', '54', '3120');
INSERT INTO public.who_global_data_import VALUES (40393, '2021-01-29', 'IE', 'Ireland', 'EURO', '2463', '193645', '47', '3167');
INSERT INTO public.who_global_data_import VALUES (40394, '2021-01-30', 'IE', 'Ireland', 'EURO', '247', '193892', '47', '3214');
INSERT INTO public.who_global_data_import VALUES (40395, '2021-01-31', 'IE', 'Ireland', 'EURO', '1411', '195303', '78', '3292');
INSERT INTO public.who_global_data_import VALUES (40396, '2021-02-01', 'IE', 'Ireland', 'EURO', '1244', '196547', '15', '3307');
INSERT INTO public.who_global_data_import VALUES (40397, '2021-02-02', 'IE', 'Ireland', 'EURO', '1006', '197553', '10', '3317');
INSERT INTO public.who_global_data_import VALUES (40398, '2021-02-03', 'IE', 'Ireland', 'EURO', '871', '198424', '101', '3418');
INSERT INTO public.who_global_data_import VALUES (40399, '2021-02-04', 'IE', 'Ireland', 'EURO', '1006', '199430', '94', '3512');
INSERT INTO public.who_global_data_import VALUES (40400, '2021-02-05', 'IE', 'Ireland', 'EURO', '1314', '200744', '74', '3586');
INSERT INTO public.who_global_data_import VALUES (40401, '2020-01-03', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40402, '2020-01-04', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40403, '2020-01-05', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40404, '2020-01-06', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40405, '2020-01-07', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40406, '2020-01-08', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40407, '2020-01-09', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40408, '2020-01-10', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40409, '2020-01-11', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40410, '2020-01-12', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40411, '2020-01-13', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40412, '2020-01-14', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40413, '2020-01-15', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40414, '2020-01-16', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40415, '2020-01-17', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40416, '2020-01-18', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40417, '2020-01-19', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40418, '2020-01-20', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40419, '2020-01-21', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40420, '2020-01-22', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40421, '2020-01-23', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40422, '2020-01-24', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40423, '2020-01-25', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40424, '2020-01-26', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40425, '2020-01-27', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40426, '2020-01-28', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40427, '2020-01-29', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40428, '2020-01-30', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40429, '2020-01-31', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40430, '2020-02-01', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40431, '2020-02-02', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40432, '2020-02-03', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40433, '2020-02-04', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40434, '2020-02-05', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40435, '2020-02-06', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40436, '2020-02-07', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40437, '2020-02-08', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40438, '2020-02-09', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40439, '2020-02-10', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40440, '2020-02-11', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40441, '2020-02-12', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40442, '2020-02-13', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40443, '2020-02-14', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40444, '2020-02-15', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40445, '2020-02-16', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40446, '2020-02-17', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40447, '2020-02-18', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40448, '2020-02-19', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40449, '2020-02-20', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40450, '2020-02-21', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40451, '2020-02-22', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40452, '2020-02-23', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40453, '2020-02-24', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40454, '2020-02-25', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40455, '2020-02-26', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40456, '2020-02-27', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40457, '2020-02-28', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40458, '2020-02-29', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40459, '2020-03-01', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40460, '2020-03-02', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40461, '2020-03-03', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40462, '2020-03-04', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40463, '2020-03-05', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40464, '2020-03-06', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40465, '2020-03-07', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40466, '2020-03-08', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40467, '2020-03-09', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40468, '2020-03-10', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40469, '2020-03-11', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40470, '2020-03-12', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40471, '2020-03-13', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40472, '2020-03-14', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40473, '2020-03-15', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40474, '2020-03-16', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40475, '2020-03-17', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40476, '2020-03-18', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40477, '2020-03-19', 'IM', 'Isle of Man', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40478, '2020-03-20', 'IM', 'Isle of Man', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40479, '2020-03-21', 'IM', 'Isle of Man', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40480, '2020-03-22', 'IM', 'Isle of Man', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40481, '2020-03-23', 'IM', 'Isle of Man', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40482, '2020-03-24', 'IM', 'Isle of Man', 'EURO', '11', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40483, '2020-03-25', 'IM', 'Isle of Man', 'EURO', '10', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40484, '2020-03-26', 'IM', 'Isle of Man', 'EURO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40485, '2020-03-27', 'IM', 'Isle of Man', 'EURO', '3', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40486, '2020-03-28', 'IM', 'Isle of Man', 'EURO', '3', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40487, '2020-03-29', 'IM', 'Isle of Man', 'EURO', '3', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40488, '2020-03-30', 'IM', 'Isle of Man', 'EURO', '10', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40489, '2020-03-31', 'IM', 'Isle of Man', 'EURO', '10', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40490, '2020-04-01', 'IM', 'Isle of Man', 'EURO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40491, '2020-04-02', 'IM', 'Isle of Man', 'EURO', '13', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40492, '2020-04-03', 'IM', 'Isle of Man', 'EURO', '6', '71', '1', '1');
INSERT INTO public.who_global_data_import VALUES (40493, '2020-04-04', 'IM', 'Isle of Man', 'EURO', '43', '114', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40494, '2020-04-05', 'IM', 'Isle of Man', 'EURO', '12', '126', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40495, '2020-04-06', 'IM', 'Isle of Man', 'EURO', '1', '127', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40496, '2020-04-07', 'IM', 'Isle of Man', 'EURO', '0', '127', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40497, '2020-04-08', 'IM', 'Isle of Man', 'EURO', '23', '150', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40498, '2020-04-09', 'IM', 'Isle of Man', 'EURO', '0', '150', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40499, '2020-04-10', 'IM', 'Isle of Man', 'EURO', '15', '165', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40500, '2020-04-11', 'IM', 'Isle of Man', 'EURO', '25', '190', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40501, '2020-04-12', 'IM', 'Isle of Man', 'EURO', '14', '204', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40502, '2020-04-13', 'IM', 'Isle of Man', 'EURO', '22', '226', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40503, '2020-04-14', 'IM', 'Isle of Man', 'EURO', '2', '228', '1', '2');
INSERT INTO public.who_global_data_import VALUES (40504, '2020-04-15', 'IM', 'Isle of Man', 'EURO', '14', '242', '0', '2');
INSERT INTO public.who_global_data_import VALUES (40505, '2020-04-16', 'IM', 'Isle of Man', 'EURO', '12', '254', '0', '2');
INSERT INTO public.who_global_data_import VALUES (40506, '2020-04-17', 'IM', 'Isle of Man', 'EURO', '4', '258', '2', '4');
INSERT INTO public.who_global_data_import VALUES (40507, '2020-04-18', 'IM', 'Isle of Man', 'EURO', '31', '289', '0', '4');
INSERT INTO public.who_global_data_import VALUES (40508, '2020-04-19', 'IM', 'Isle of Man', 'EURO', '2', '291', '0', '4');
INSERT INTO public.who_global_data_import VALUES (40509, '2020-04-20', 'IM', 'Isle of Man', 'EURO', '6', '297', '0', '4');
INSERT INTO public.who_global_data_import VALUES (40510, '2020-04-21', 'IM', 'Isle of Man', 'EURO', '0', '297', '0', '4');
INSERT INTO public.who_global_data_import VALUES (40511, '2020-04-22', 'IM', 'Isle of Man', 'EURO', '10', '307', '6', '10');
INSERT INTO public.who_global_data_import VALUES (40512, '2020-04-23', 'IM', 'Isle of Man', 'EURO', '0', '307', '0', '10');
INSERT INTO public.who_global_data_import VALUES (40513, '2020-04-24', 'IM', 'Isle of Man', 'EURO', '0', '307', '6', '16');
INSERT INTO public.who_global_data_import VALUES (40514, '2020-04-25', 'IM', 'Isle of Man', 'EURO', '1', '308', '1', '17');
INSERT INTO public.who_global_data_import VALUES (40515, '2020-04-26', 'IM', 'Isle of Man', 'EURO', '0', '308', '1', '18');
INSERT INTO public.who_global_data_import VALUES (40516, '2020-04-27', 'IM', 'Isle of Man', 'EURO', '0', '308', '0', '18');
INSERT INTO public.who_global_data_import VALUES (40517, '2020-04-28', 'IM', 'Isle of Man', 'EURO', '0', '308', '0', '18');
INSERT INTO public.who_global_data_import VALUES (40518, '2020-04-29', 'IM', 'Isle of Man', 'EURO', '0', '308', '2', '20');
INSERT INTO public.who_global_data_import VALUES (40519, '2020-04-30', 'IM', 'Isle of Man', 'EURO', '1', '309', '1', '21');
INSERT INTO public.who_global_data_import VALUES (40520, '2020-05-01', 'IM', 'Isle of Man', 'EURO', '2', '311', '1', '22');
INSERT INTO public.who_global_data_import VALUES (40521, '2020-05-02', 'IM', 'Isle of Man', 'EURO', '0', '311', '0', '22');
INSERT INTO public.who_global_data_import VALUES (40522, '2020-05-03', 'IM', 'Isle of Man', 'EURO', '4', '315', '1', '23');
INSERT INTO public.who_global_data_import VALUES (40523, '2020-05-04', 'IM', 'Isle of Man', 'EURO', '5', '320', '0', '23');
INSERT INTO public.who_global_data_import VALUES (40524, '2020-05-05', 'IM', 'Isle of Man', 'EURO', '1', '321', '0', '23');
INSERT INTO public.who_global_data_import VALUES (40525, '2020-05-06', 'IM', 'Isle of Man', 'EURO', '4', '325', '0', '23');
INSERT INTO public.who_global_data_import VALUES (40526, '2020-05-07', 'IM', 'Isle of Man', 'EURO', '1', '326', '0', '23');
INSERT INTO public.who_global_data_import VALUES (40527, '2020-05-08', 'IM', 'Isle of Man', 'EURO', '1', '327', '0', '23');
INSERT INTO public.who_global_data_import VALUES (40528, '2020-05-09', 'IM', 'Isle of Man', 'EURO', '2', '329', '0', '23');
INSERT INTO public.who_global_data_import VALUES (40529, '2020-05-10', 'IM', 'Isle of Man', 'EURO', '0', '329', '0', '23');
INSERT INTO public.who_global_data_import VALUES (40530, '2020-05-11', 'IM', 'Isle of Man', 'EURO', '1', '330', '0', '23');
INSERT INTO public.who_global_data_import VALUES (40531, '2020-05-12', 'IM', 'Isle of Man', 'EURO', '0', '330', '0', '23');
INSERT INTO public.who_global_data_import VALUES (40532, '2020-05-13', 'IM', 'Isle of Man', 'EURO', '0', '330', '0', '23');
INSERT INTO public.who_global_data_import VALUES (40533, '2020-05-14', 'IM', 'Isle of Man', 'EURO', '1', '331', '0', '23');
INSERT INTO public.who_global_data_import VALUES (40534, '2020-05-15', 'IM', 'Isle of Man', 'EURO', '0', '331', '0', '23');
INSERT INTO public.who_global_data_import VALUES (40535, '2020-05-16', 'IM', 'Isle of Man', 'EURO', '2', '333', '1', '24');
INSERT INTO public.who_global_data_import VALUES (40536, '2020-05-17', 'IM', 'Isle of Man', 'EURO', '1', '334', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40537, '2020-05-18', 'IM', 'Isle of Man', 'EURO', '1', '335', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40538, '2020-05-19', 'IM', 'Isle of Man', 'EURO', '0', '335', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40539, '2020-05-20', 'IM', 'Isle of Man', 'EURO', '0', '335', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40540, '2020-05-21', 'IM', 'Isle of Man', 'EURO', '0', '335', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40541, '2020-05-22', 'IM', 'Isle of Man', 'EURO', '1', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40542, '2020-05-23', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40543, '2020-05-24', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40544, '2020-05-25', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40545, '2020-05-26', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40546, '2020-05-27', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40547, '2020-05-28', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40548, '2020-05-29', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40549, '2020-05-30', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40550, '2020-05-31', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40551, '2020-06-01', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40552, '2020-06-02', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40553, '2020-06-03', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40554, '2020-06-04', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40555, '2020-06-05', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40556, '2020-06-06', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40557, '2020-06-07', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40558, '2020-06-08', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40559, '2020-06-09', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40560, '2020-06-10', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40561, '2020-06-11', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40562, '2020-06-12', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40563, '2020-06-13', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40564, '2020-06-14', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40565, '2020-06-15', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40566, '2020-06-16', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40567, '2020-06-17', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40568, '2020-06-18', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40569, '2020-06-19', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40570, '2020-06-20', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40571, '2020-06-21', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40572, '2020-06-22', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40573, '2020-06-23', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40574, '2020-06-24', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40575, '2020-06-25', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40576, '2020-06-26', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40577, '2020-06-27', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40578, '2020-06-28', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40579, '2020-06-29', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40580, '2020-06-30', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40581, '2020-07-01', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40582, '2020-07-02', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40583, '2020-07-03', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40584, '2020-07-04', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40585, '2020-07-05', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40586, '2020-07-06', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40587, '2020-07-07', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40588, '2020-07-08', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40589, '2020-07-09', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40590, '2020-07-10', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40591, '2020-07-11', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40592, '2020-07-12', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40593, '2020-07-13', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40594, '2020-07-14', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40595, '2020-07-15', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40596, '2020-07-16', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40597, '2020-07-17', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40598, '2020-07-18', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40599, '2020-07-19', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40600, '2020-07-20', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40601, '2020-07-21', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40602, '2020-07-22', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40603, '2020-07-23', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40604, '2020-07-24', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40605, '2020-07-25', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40606, '2020-07-26', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40607, '2020-07-27', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40608, '2020-07-28', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40609, '2020-07-29', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40610, '2020-07-30', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40611, '2020-07-31', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40612, '2020-08-01', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40613, '2020-08-02', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40614, '2020-08-03', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40615, '2020-08-04', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40616, '2020-08-05', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40617, '2020-08-06', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40618, '2020-08-07', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40619, '2020-08-08', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40620, '2020-08-09', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40621, '2020-08-10', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40622, '2020-08-11', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40623, '2020-08-12', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40624, '2020-08-13', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40625, '2020-08-14', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40626, '2020-08-15', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40627, '2020-08-16', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40628, '2020-08-17', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40629, '2020-08-18', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40630, '2020-08-19', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40631, '2020-08-20', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40632, '2020-08-21', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40633, '2020-08-22', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40634, '2020-08-23', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40635, '2020-08-24', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40636, '2020-08-25', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40637, '2020-08-26', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40638, '2020-08-27', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40639, '2020-08-28', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40640, '2020-08-29', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40641, '2020-08-30', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40642, '2020-08-31', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40643, '2020-09-01', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40644, '2020-09-02', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40645, '2020-09-03', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40646, '2020-09-04', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40647, '2020-09-05', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40648, '2020-09-06', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40649, '2020-09-07', 'IM', 'Isle of Man', 'EURO', '0', '336', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40650, '2020-09-08', 'IM', 'Isle of Man', 'EURO', '1', '337', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40651, '2020-09-09', 'IM', 'Isle of Man', 'EURO', '0', '337', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40652, '2020-09-10', 'IM', 'Isle of Man', 'EURO', '0', '337', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40653, '2020-09-11', 'IM', 'Isle of Man', 'EURO', '0', '337', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40654, '2020-09-12', 'IM', 'Isle of Man', 'EURO', '0', '337', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40655, '2020-09-13', 'IM', 'Isle of Man', 'EURO', '0', '337', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40656, '2020-09-14', 'IM', 'Isle of Man', 'EURO', '0', '337', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40657, '2020-09-15', 'IM', 'Isle of Man', 'EURO', '1', '338', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40658, '2020-09-16', 'IM', 'Isle of Man', 'EURO', '1', '339', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40659, '2020-09-17', 'IM', 'Isle of Man', 'EURO', '0', '339', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40660, '2020-09-18', 'IM', 'Isle of Man', 'EURO', '0', '339', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40661, '2020-09-19', 'IM', 'Isle of Man', 'EURO', '0', '339', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40662, '2020-09-20', 'IM', 'Isle of Man', 'EURO', '0', '339', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40663, '2020-09-21', 'IM', 'Isle of Man', 'EURO', '0', '339', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40664, '2020-09-22', 'IM', 'Isle of Man', 'EURO', '0', '339', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40665, '2020-09-23', 'IM', 'Isle of Man', 'EURO', '1', '340', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40666, '2020-09-24', 'IM', 'Isle of Man', 'EURO', '0', '340', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40667, '2020-09-25', 'IM', 'Isle of Man', 'EURO', '0', '340', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40668, '2020-09-26', 'IM', 'Isle of Man', 'EURO', '0', '340', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40669, '2020-09-27', 'IM', 'Isle of Man', 'EURO', '0', '340', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40670, '2020-09-28', 'IM', 'Isle of Man', 'EURO', '0', '340', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40671, '2020-09-29', 'IM', 'Isle of Man', 'EURO', '0', '340', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40672, '2020-09-30', 'IM', 'Isle of Man', 'EURO', '0', '340', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40673, '2020-10-01', 'IM', 'Isle of Man', 'EURO', '0', '340', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40674, '2020-10-02', 'IM', 'Isle of Man', 'EURO', '0', '340', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40675, '2020-10-03', 'IM', 'Isle of Man', 'EURO', '0', '340', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40676, '2020-10-04', 'IM', 'Isle of Man', 'EURO', '1', '341', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40677, '2020-10-05', 'IM', 'Isle of Man', 'EURO', '1', '342', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40678, '2020-10-06', 'IM', 'Isle of Man', 'EURO', '0', '342', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40679, '2020-10-07', 'IM', 'Isle of Man', 'EURO', '2', '344', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40680, '2020-10-08', 'IM', 'Isle of Man', 'EURO', '1', '345', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40681, '2020-10-09', 'IM', 'Isle of Man', 'EURO', '0', '345', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40682, '2020-10-10', 'IM', 'Isle of Man', 'EURO', '0', '345', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40683, '2020-10-11', 'IM', 'Isle of Man', 'EURO', '0', '345', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40684, '2020-10-12', 'IM', 'Isle of Man', 'EURO', '0', '345', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40685, '2020-10-13', 'IM', 'Isle of Man', 'EURO', '1', '346', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40686, '2020-10-14', 'IM', 'Isle of Man', 'EURO', '0', '346', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40687, '2020-10-15', 'IM', 'Isle of Man', 'EURO', '0', '346', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40688, '2020-10-16', 'IM', 'Isle of Man', 'EURO', '2', '348', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40689, '2020-10-17', 'IM', 'Isle of Man', 'EURO', '0', '348', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40690, '2020-10-18', 'IM', 'Isle of Man', 'EURO', '0', '348', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40691, '2020-10-19', 'IM', 'Isle of Man', 'EURO', '0', '348', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40692, '2020-10-20', 'IM', 'Isle of Man', 'EURO', '0', '348', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40693, '2020-10-21', 'IM', 'Isle of Man', 'EURO', '0', '348', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40694, '2020-10-22', 'IM', 'Isle of Man', 'EURO', '0', '348', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40695, '2020-10-23', 'IM', 'Isle of Man', 'EURO', '0', '348', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40696, '2020-10-24', 'IM', 'Isle of Man', 'EURO', '0', '348', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40697, '2020-10-25', 'IM', 'Isle of Man', 'EURO', '0', '348', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40698, '2020-10-26', 'IM', 'Isle of Man', 'EURO', '0', '348', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40699, '2020-10-27', 'IM', 'Isle of Man', 'EURO', '0', '348', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40700, '2020-10-28', 'IM', 'Isle of Man', 'EURO', '3', '351', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40701, '2020-10-29', 'IM', 'Isle of Man', 'EURO', '1', '352', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40702, '2020-10-30', 'IM', 'Isle of Man', 'EURO', '0', '352', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40703, '2020-10-31', 'IM', 'Isle of Man', 'EURO', '0', '352', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40704, '2020-11-01', 'IM', 'Isle of Man', 'EURO', '1', '353', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40705, '2020-11-02', 'IM', 'Isle of Man', 'EURO', '0', '353', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40706, '2020-11-03', 'IM', 'Isle of Man', 'EURO', '0', '353', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40707, '2020-11-04', 'IM', 'Isle of Man', 'EURO', '2', '355', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40708, '2020-11-05', 'IM', 'Isle of Man', 'EURO', '1', '356', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40709, '2020-11-06', 'IM', 'Isle of Man', 'EURO', '1', '357', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40710, '2020-11-07', 'IM', 'Isle of Man', 'EURO', '0', '357', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40711, '2020-11-08', 'IM', 'Isle of Man', 'EURO', '0', '357', '0', '24');
INSERT INTO public.who_global_data_import VALUES (40712, '2020-11-09', 'IM', 'Isle of Man', 'EURO', '0', '357', '1', '25');
INSERT INTO public.who_global_data_import VALUES (40713, '2020-11-10', 'IM', 'Isle of Man', 'EURO', '0', '357', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40714, '2020-11-11', 'IM', 'Isle of Man', 'EURO', '0', '357', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40715, '2020-11-12', 'IM', 'Isle of Man', 'EURO', '2', '359', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40716, '2020-11-13', 'IM', 'Isle of Man', 'EURO', '2', '361', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40717, '2020-11-14', 'IM', 'Isle of Man', 'EURO', '2', '363', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40718, '2020-11-15', 'IM', 'Isle of Man', 'EURO', '0', '363', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40719, '2020-11-16', 'IM', 'Isle of Man', 'EURO', '0', '363', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40720, '2020-11-17', 'IM', 'Isle of Man', 'EURO', '0', '363', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40721, '2020-11-18', 'IM', 'Isle of Man', 'EURO', '1', '364', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40722, '2020-11-19', 'IM', 'Isle of Man', 'EURO', '0', '364', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40723, '2020-11-20', 'IM', 'Isle of Man', 'EURO', '0', '364', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40724, '2020-11-21', 'IM', 'Isle of Man', 'EURO', '2', '366', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40725, '2020-11-22', 'IM', 'Isle of Man', 'EURO', '2', '368', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40726, '2020-11-23', 'IM', 'Isle of Man', 'EURO', '0', '368', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40727, '2020-11-24', 'IM', 'Isle of Man', 'EURO', '1', '369', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40728, '2020-11-25', 'IM', 'Isle of Man', 'EURO', '0', '369', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40729, '2020-11-26', 'IM', 'Isle of Man', 'EURO', '0', '369', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40730, '2020-11-27', 'IM', 'Isle of Man', 'EURO', '0', '369', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40731, '2020-11-28', 'IM', 'Isle of Man', 'EURO', '0', '369', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40732, '2020-11-29', 'IM', 'Isle of Man', 'EURO', '0', '369', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40733, '2020-11-30', 'IM', 'Isle of Man', 'EURO', '0', '369', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40734, '2020-12-01', 'IM', 'Isle of Man', 'EURO', '0', '369', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40735, '2020-12-02', 'IM', 'Isle of Man', 'EURO', '0', '369', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40736, '2020-12-03', 'IM', 'Isle of Man', 'EURO', '0', '369', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40737, '2020-12-04', 'IM', 'Isle of Man', 'EURO', '0', '369', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40738, '2020-12-05', 'IM', 'Isle of Man', 'EURO', '0', '369', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40739, '2020-12-06', 'IM', 'Isle of Man', 'EURO', '1', '370', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40740, '2020-12-07', 'IM', 'Isle of Man', 'EURO', '0', '370', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40741, '2020-12-08', 'IM', 'Isle of Man', 'EURO', '0', '370', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40742, '2020-12-09', 'IM', 'Isle of Man', 'EURO', '0', '370', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40743, '2020-12-10', 'IM', 'Isle of Man', 'EURO', '0', '370', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40744, '2020-12-11', 'IM', 'Isle of Man', 'EURO', '0', '370', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40745, '2020-12-12', 'IM', 'Isle of Man', 'EURO', '0', '370', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40746, '2020-12-13', 'IM', 'Isle of Man', 'EURO', '0', '370', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40747, '2020-12-14', 'IM', 'Isle of Man', 'EURO', '0', '370', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40748, '2020-12-15', 'IM', 'Isle of Man', 'EURO', '0', '370', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40749, '2020-12-16', 'IM', 'Isle of Man', 'EURO', '3', '373', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40750, '2020-12-17', 'IM', 'Isle of Man', 'EURO', '0', '373', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40751, '2020-12-18', 'IM', 'Isle of Man', 'EURO', '0', '373', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40752, '2020-12-19', 'IM', 'Isle of Man', 'EURO', '0', '373', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40753, '2020-12-20', 'IM', 'Isle of Man', 'EURO', '0', '373', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40754, '2020-12-21', 'IM', 'Isle of Man', 'EURO', '0', '373', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40755, '2020-12-22', 'IM', 'Isle of Man', 'EURO', '1', '374', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40756, '2020-12-23', 'IM', 'Isle of Man', 'EURO', '0', '374', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40757, '2020-12-24', 'IM', 'Isle of Man', 'EURO', '0', '374', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40758, '2020-12-25', 'IM', 'Isle of Man', 'EURO', '0', '374', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40759, '2020-12-26', 'IM', 'Isle of Man', 'EURO', '0', '374', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40760, '2020-12-27', 'IM', 'Isle of Man', 'EURO', '0', '374', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40761, '2020-12-28', 'IM', 'Isle of Man', 'EURO', '0', '374', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40762, '2020-12-29', 'IM', 'Isle of Man', 'EURO', '0', '374', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40763, '2020-12-30', 'IM', 'Isle of Man', 'EURO', '0', '374', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40764, '2020-12-31', 'IM', 'Isle of Man', 'EURO', '0', '374', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40765, '2021-01-01', 'IM', 'Isle of Man', 'EURO', '3', '377', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40766, '2021-01-02', 'IM', 'Isle of Man', 'EURO', '3', '380', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40767, '2021-01-03', 'IM', 'Isle of Man', 'EURO', '0', '380', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40768, '2021-01-04', 'IM', 'Isle of Man', 'EURO', '0', '380', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40769, '2021-01-05', 'IM', 'Isle of Man', 'EURO', '0', '380', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40770, '2021-01-06', 'IM', 'Isle of Man', 'EURO', '0', '380', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40771, '2021-01-07', 'IM', 'Isle of Man', 'EURO', '6', '386', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40772, '2021-01-08', 'IM', 'Isle of Man', 'EURO', '3', '389', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40773, '2021-01-09', 'IM', 'Isle of Man', 'EURO', '2', '391', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40774, '2021-01-10', 'IM', 'Isle of Man', 'EURO', '1', '392', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40775, '2021-01-11', 'IM', 'Isle of Man', 'EURO', '2', '394', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40776, '2021-01-12', 'IM', 'Isle of Man', 'EURO', '2', '396', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40777, '2021-01-13', 'IM', 'Isle of Man', 'EURO', '7', '403', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40778, '2021-01-14', 'IM', 'Isle of Man', 'EURO', '3', '406', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40779, '2021-01-15', 'IM', 'Isle of Man', 'EURO', '8', '414', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40780, '2021-01-16', 'IM', 'Isle of Man', 'EURO', '3', '417', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40781, '2021-01-17', 'IM', 'Isle of Man', 'EURO', '1', '418', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40782, '2021-01-18', 'IM', 'Isle of Man', 'EURO', '1', '419', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40783, '2021-01-19', 'IM', 'Isle of Man', 'EURO', '9', '428', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40784, '2021-01-20', 'IM', 'Isle of Man', 'EURO', '4', '432', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40785, '2021-01-21', 'IM', 'Isle of Man', 'EURO', '0', '432', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40786, '2021-01-22', 'IM', 'Isle of Man', 'EURO', '0', '432', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40787, '2021-01-23', 'IM', 'Isle of Man', 'EURO', '0', '432', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40788, '2021-01-24', 'IM', 'Isle of Man', 'EURO', '0', '432', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40789, '2021-01-25', 'IM', 'Isle of Man', 'EURO', '0', '432', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40790, '2021-01-26', 'IM', 'Isle of Man', 'EURO', '0', '432', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40791, '2021-01-27', 'IM', 'Isle of Man', 'EURO', '0', '432', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40792, '2021-01-28', 'IM', 'Isle of Man', 'EURO', '0', '432', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40793, '2021-01-29', 'IM', 'Isle of Man', 'EURO', '0', '432', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40794, '2021-01-30', 'IM', 'Isle of Man', 'EURO', '0', '432', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40795, '2021-01-31', 'IM', 'Isle of Man', 'EURO', '2', '434', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40796, '2021-02-01', 'IM', 'Isle of Man', 'EURO', '0', '434', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40797, '2021-02-02', 'IM', 'Isle of Man', 'EURO', '0', '434', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40798, '2021-02-03', 'IM', 'Isle of Man', 'EURO', '0', '434', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40799, '2021-02-04', 'IM', 'Isle of Man', 'EURO', '0', '434', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40800, '2021-02-05', 'IM', 'Isle of Man', 'EURO', '0', '434', '0', '25');
INSERT INTO public.who_global_data_import VALUES (40801, '2020-01-03', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40802, '2020-01-04', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40803, '2020-01-05', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40804, '2020-01-06', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40805, '2020-01-07', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40806, '2020-01-08', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40807, '2020-01-09', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40808, '2020-01-10', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40809, '2020-01-11', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40810, '2020-01-12', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40811, '2020-01-13', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40812, '2020-01-14', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40813, '2020-01-15', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40814, '2020-01-16', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40815, '2020-01-17', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40816, '2020-01-18', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40817, '2020-01-19', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40818, '2020-01-20', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40819, '2020-01-21', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40820, '2020-01-22', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40821, '2020-01-23', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40822, '2020-01-24', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40823, '2020-01-25', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40824, '2020-01-26', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40825, '2020-01-27', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40826, '2020-01-28', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40827, '2020-01-29', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40828, '2020-01-30', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40829, '2020-01-31', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40830, '2020-02-01', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40831, '2020-02-02', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40832, '2020-02-03', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40833, '2020-02-04', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40834, '2020-02-05', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40835, '2020-02-06', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40836, '2020-02-07', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40837, '2020-02-08', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40838, '2020-02-09', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40839, '2020-02-10', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40840, '2020-02-11', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40841, '2020-02-12', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40842, '2020-02-13', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40843, '2020-02-14', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40844, '2020-02-15', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40845, '2020-02-16', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40846, '2020-02-17', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40847, '2020-02-18', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40848, '2020-02-19', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40849, '2020-02-20', 'IL', 'Israel', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40850, '2020-02-21', 'IL', 'Israel', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40851, '2020-02-22', 'IL', 'Israel', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40852, '2020-02-23', 'IL', 'Israel', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40853, '2020-02-24', 'IL', 'Israel', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40854, '2020-02-25', 'IL', 'Israel', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40855, '2020-02-26', 'IL', 'Israel', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40856, '2020-02-27', 'IL', 'Israel', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40857, '2020-02-28', 'IL', 'Israel', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40858, '2020-02-29', 'IL', 'Israel', 'EURO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40859, '2020-03-01', 'IL', 'Israel', 'EURO', '3', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40860, '2020-03-02', 'IL', 'Israel', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40861, '2020-03-03', 'IL', 'Israel', 'EURO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40862, '2020-03-04', 'IL', 'Israel', 'EURO', '5', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40863, '2020-03-05', 'IL', 'Israel', 'EURO', '3', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40864, '2020-03-06', 'IL', 'Israel', 'EURO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40865, '2020-03-07', 'IL', 'Israel', 'EURO', '2', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40866, '2020-03-08', 'IL', 'Israel', 'EURO', '4', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40867, '2020-03-09', 'IL', 'Israel', 'EURO', '4', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40868, '2020-03-10', 'IL', 'Israel', 'EURO', '9', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40869, '2020-03-11', 'IL', 'Israel', 'EURO', '4', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40870, '2020-03-12', 'IL', 'Israel', 'EURO', '33', '71', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40871, '2020-03-13', 'IL', 'Israel', 'EURO', '19', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40872, '2020-03-14', 'IL', 'Israel', 'EURO', '22', '112', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40873, '2020-03-15', 'IL', 'Israel', 'EURO', '35', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40874, '2020-03-16', 'IL', 'Israel', 'EURO', '29', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40875, '2020-03-17', 'IL', 'Israel', 'EURO', '39', '215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40876, '2020-03-18', 'IL', 'Israel', 'EURO', '73', '288', '1', '1');
INSERT INTO public.who_global_data_import VALUES (40877, '2020-03-19', 'IL', 'Israel', 'EURO', '94', '382', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40878, '2020-03-20', 'IL', 'Israel', 'EURO', '118', '500', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40879, '2020-03-21', 'IL', 'Israel', 'EURO', '136', '636', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40880, '2020-03-22', 'IL', 'Israel', 'EURO', '168', '804', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40881, '2020-03-23', 'IL', 'Israel', 'EURO', '210', '1014', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40882, '2020-03-24', 'IL', 'Israel', 'EURO', '254', '1268', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40883, '2020-03-25', 'IL', 'Israel', 'EURO', '352', '1620', '0', '1');
INSERT INTO public.who_global_data_import VALUES (40884, '2020-03-26', 'IL', 'Israel', 'EURO', '427', '2047', '3', '4');
INSERT INTO public.who_global_data_import VALUES (40885, '2020-03-27', 'IL', 'Israel', 'EURO', '425', '2472', '1', '5');
INSERT INTO public.who_global_data_import VALUES (40886, '2020-03-28', 'IL', 'Israel', 'EURO', '520', '2992', '5', '10');
INSERT INTO public.who_global_data_import VALUES (40887, '2020-03-29', 'IL', 'Israel', 'EURO', '433', '3425', '2', '12');
INSERT INTO public.who_global_data_import VALUES (40888, '2020-03-30', 'IL', 'Israel', 'EURO', '480', '3905', '1', '13');
INSERT INTO public.who_global_data_import VALUES (40889, '2020-03-31', 'IL', 'Israel', 'EURO', '532', '4437', '3', '16');
INSERT INTO public.who_global_data_import VALUES (40890, '2020-04-01', 'IL', 'Israel', 'EURO', '547', '4984', '1', '17');
INSERT INTO public.who_global_data_import VALUES (40891, '2020-04-02', 'IL', 'Israel', 'EURO', '738', '5722', '4', '21');
INSERT INTO public.who_global_data_import VALUES (40892, '2020-04-03', 'IL', 'Israel', 'EURO', '696', '6418', '8', '29');
INSERT INTO public.who_global_data_import VALUES (40893, '2020-04-04', 'IL', 'Israel', 'EURO', '719', '7137', '9', '38');
INSERT INTO public.who_global_data_import VALUES (40894, '2020-04-05', 'IL', 'Israel', 'EURO', '597', '7734', '5', '43');
INSERT INTO public.who_global_data_import VALUES (40895, '2020-04-06', 'IL', 'Israel', 'EURO', '428', '8162', '6', '49');
INSERT INTO public.who_global_data_import VALUES (41202, '2020-01-04', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (40896, '2020-04-07', 'IL', 'Israel', 'EURO', '583', '8745', '7', '56');
INSERT INTO public.who_global_data_import VALUES (40897, '2020-04-08', 'IL', 'Israel', 'EURO', '451', '9196', '8', '64');
INSERT INTO public.who_global_data_import VALUES (40898, '2020-04-09', 'IL', 'Israel', 'EURO', '377', '9573', '8', '72');
INSERT INTO public.who_global_data_import VALUES (40899, '2020-04-10', 'IL', 'Israel', 'EURO', '338', '9911', '8', '80');
INSERT INTO public.who_global_data_import VALUES (40900, '2020-04-11', 'IL', 'Israel', 'EURO', '343', '10254', '9', '89');
INSERT INTO public.who_global_data_import VALUES (40901, '2020-04-12', 'IL', 'Israel', 'EURO', '359', '10613', '8', '97');
INSERT INTO public.who_global_data_import VALUES (40902, '2020-04-13', 'IL', 'Israel', 'EURO', '345', '10958', '6', '103');
INSERT INTO public.who_global_data_import VALUES (40903, '2020-04-14', 'IL', 'Israel', 'EURO', '552', '11510', '6', '109');
INSERT INTO public.who_global_data_import VALUES (40904, '2020-04-15', 'IL', 'Israel', 'EURO', '438', '11948', '9', '118');
INSERT INTO public.who_global_data_import VALUES (40905, '2020-04-16', 'IL', 'Israel', 'EURO', '399', '12347', '8', '126');
INSERT INTO public.who_global_data_import VALUES (40906, '2020-04-17', 'IL', 'Israel', 'EURO', '311', '12658', '13', '139');
INSERT INTO public.who_global_data_import VALUES (40907, '2020-04-18', 'IL', 'Israel', 'EURO', '296', '12954', '7', '146');
INSERT INTO public.who_global_data_import VALUES (40908, '2020-04-19', 'IL', 'Israel', 'EURO', '298', '13252', '9', '155');
INSERT INTO public.who_global_data_import VALUES (40909, '2020-04-20', 'IL', 'Israel', 'EURO', '291', '13543', '11', '166');
INSERT INTO public.who_global_data_import VALUES (40910, '2020-04-21', 'IL', 'Israel', 'EURO', '276', '13819', '8', '174');
INSERT INTO public.who_global_data_import VALUES (40911, '2020-04-22', 'IL', 'Israel', 'EURO', '299', '14118', '6', '180');
INSERT INTO public.who_global_data_import VALUES (40912, '2020-04-23', 'IL', 'Israel', 'EURO', '282', '14400', '9', '189');
INSERT INTO public.who_global_data_import VALUES (40913, '2020-04-24', 'IL', 'Israel', 'EURO', '225', '14625', '3', '192');
INSERT INTO public.who_global_data_import VALUES (40914, '2020-04-25', 'IL', 'Israel', 'EURO', '276', '14901', '4', '196');
INSERT INTO public.who_global_data_import VALUES (40915, '2020-04-26', 'IL', 'Israel', 'EURO', '248', '15149', '3', '199');
INSERT INTO public.who_global_data_import VALUES (40916, '2020-04-27', 'IL', 'Israel', 'EURO', '159', '15308', '3', '202');
INSERT INTO public.who_global_data_import VALUES (40917, '2020-04-28', 'IL', 'Israel', 'EURO', '83', '15391', '2', '204');
INSERT INTO public.who_global_data_import VALUES (40918, '2020-04-29', 'IL', 'Israel', 'EURO', '128', '15519', '4', '208');
INSERT INTO public.who_global_data_import VALUES (40919, '2020-04-30', 'IL', 'Israel', 'EURO', '159', '15678', '5', '213');
INSERT INTO public.who_global_data_import VALUES (40920, '2020-05-01', 'IL', 'Israel', 'EURO', '82', '15760', '6', '219');
INSERT INTO public.who_global_data_import VALUES (40921, '2020-05-02', 'IL', 'Israel', 'EURO', '142', '15902', '6', '225');
INSERT INTO public.who_global_data_import VALUES (40922, '2020-05-03', 'IL', 'Israel', 'EURO', '116', '16018', '4', '229');
INSERT INTO public.who_global_data_import VALUES (40923, '2020-05-04', 'IL', 'Israel', 'EURO', '57', '16075', '3', '232');
INSERT INTO public.who_global_data_import VALUES (40924, '2020-05-05', 'IL', 'Israel', 'EURO', '27', '16102', '3', '235');
INSERT INTO public.who_global_data_import VALUES (40925, '2020-05-06', 'IL', 'Israel', 'EURO', '53', '16155', '3', '238');
INSERT INTO public.who_global_data_import VALUES (40926, '2020-05-07', 'IL', 'Israel', 'EURO', '32', '16187', '2', '240');
INSERT INTO public.who_global_data_import VALUES (40927, '2020-05-08', 'IL', 'Israel', 'EURO', '65', '16252', '1', '241');
INSERT INTO public.who_global_data_import VALUES (40928, '2020-05-09', 'IL', 'Israel', 'EURO', '61', '16313', '1', '242');
INSERT INTO public.who_global_data_import VALUES (40929, '2020-05-10', 'IL', 'Israel', 'EURO', '33', '16346', '6', '248');
INSERT INTO public.who_global_data_import VALUES (40930, '2020-05-11', 'IL', 'Israel', 'EURO', '19', '16365', '3', '251');
INSERT INTO public.who_global_data_import VALUES (40931, '2020-05-12', 'IL', 'Israel', 'EURO', '29', '16394', '4', '255');
INSERT INTO public.who_global_data_import VALUES (40932, '2020-05-13', 'IL', 'Israel', 'EURO', '39', '16433', '5', '260');
INSERT INTO public.who_global_data_import VALUES (40933, '2020-05-14', 'IL', 'Israel', 'EURO', '23', '16456', '3', '263');
INSERT INTO public.who_global_data_import VALUES (40934, '2020-05-15', 'IL', 'Israel', 'EURO', '39', '16495', '3', '266');
INSERT INTO public.who_global_data_import VALUES (40935, '2020-05-16', 'IL', 'Israel', 'EURO', '22', '16517', '2', '268');
INSERT INTO public.who_global_data_import VALUES (40936, '2020-05-17', 'IL', 'Israel', 'EURO', '12', '16529', '0', '268');
INSERT INTO public.who_global_data_import VALUES (40937, '2020-05-18', 'IL', 'Israel', 'EURO', '5', '16534', '3', '271');
INSERT INTO public.who_global_data_import VALUES (40938, '2020-05-19', 'IL', 'Israel', 'EURO', '15', '16549', '4', '275');
INSERT INTO public.who_global_data_import VALUES (40939, '2020-05-20', 'IL', 'Israel', 'EURO', '27', '16576', '3', '278');
INSERT INTO public.who_global_data_import VALUES (40940, '2020-05-21', 'IL', 'Israel', 'EURO', '22', '16598', '2', '280');
INSERT INTO public.who_global_data_import VALUES (40941, '2020-05-22', 'IL', 'Israel', 'EURO', '15', '16613', '1', '281');
INSERT INTO public.who_global_data_import VALUES (40942, '2020-05-23', 'IL', 'Israel', 'EURO', '17', '16630', '0', '281');
INSERT INTO public.who_global_data_import VALUES (40943, '2020-05-24', 'IL', 'Israel', 'EURO', '19', '16649', '0', '281');
INSERT INTO public.who_global_data_import VALUES (40944, '2020-05-25', 'IL', 'Israel', 'EURO', '5', '16654', '0', '281');
INSERT INTO public.who_global_data_import VALUES (40945, '2020-05-26', 'IL', 'Israel', 'EURO', '13', '16667', '1', '282');
INSERT INTO public.who_global_data_import VALUES (40946, '2020-05-27', 'IL', 'Israel', 'EURO', '22', '16689', '2', '284');
INSERT INTO public.who_global_data_import VALUES (40947, '2020-05-28', 'IL', 'Israel', 'EURO', '50', '16739', '0', '284');
INSERT INTO public.who_global_data_import VALUES (40948, '2020-05-29', 'IL', 'Israel', 'EURO', '40', '16779', '2', '286');
INSERT INTO public.who_global_data_import VALUES (40949, '2020-05-30', 'IL', 'Israel', 'EURO', '77', '16856', '1', '287');
INSERT INTO public.who_global_data_import VALUES (40950, '2020-05-31', 'IL', 'Israel', 'EURO', '113', '16969', '0', '287');
INSERT INTO public.who_global_data_import VALUES (40951, '2020-06-01', 'IL', 'Israel', 'EURO', '29', '16998', '0', '287');
INSERT INTO public.who_global_data_import VALUES (40952, '2020-06-02', 'IL', 'Israel', 'EURO', '87', '17085', '0', '287');
INSERT INTO public.who_global_data_import VALUES (40953, '2020-06-03', 'IL', 'Israel', 'EURO', '100', '17185', '3', '290');
INSERT INTO public.who_global_data_import VALUES (40954, '2020-06-04', 'IL', 'Israel', 'EURO', '121', '17306', '2', '292');
INSERT INTO public.who_global_data_import VALUES (40955, '2020-06-05', 'IL', 'Israel', 'EURO', '97', '17403', '1', '293');
INSERT INTO public.who_global_data_import VALUES (40956, '2020-06-06', 'IL', 'Israel', 'EURO', '142', '17545', '0', '293');
INSERT INTO public.who_global_data_import VALUES (40957, '2020-06-07', 'IL', 'Israel', 'EURO', '127', '17672', '1', '294');
INSERT INTO public.who_global_data_import VALUES (40958, '2020-06-08', 'IL', 'Israel', 'EURO', '78', '17750', '4', '298');
INSERT INTO public.who_global_data_import VALUES (40959, '2020-06-09', 'IL', 'Israel', 'EURO', '140', '17890', '2', '300');
INSERT INTO public.who_global_data_import VALUES (40960, '2020-06-10', 'IL', 'Israel', 'EURO', '179', '18069', '0', '300');
INSERT INTO public.who_global_data_import VALUES (40961, '2020-06-11', 'IL', 'Israel', 'EURO', '173', '18242', '1', '301');
INSERT INTO public.who_global_data_import VALUES (40962, '2020-06-12', 'IL', 'Israel', 'EURO', '240', '18482', '1', '302');
INSERT INTO public.who_global_data_import VALUES (40963, '2020-06-13', 'IL', 'Israel', 'EURO', '191', '18673', '0', '302');
INSERT INTO public.who_global_data_import VALUES (40964, '2020-06-14', 'IL', 'Israel', 'EURO', '184', '18857', '0', '302');
INSERT INTO public.who_global_data_import VALUES (40965, '2020-06-15', 'IL', 'Israel', 'EURO', '149', '19006', '1', '303');
INSERT INTO public.who_global_data_import VALUES (40966, '2020-06-16', 'IL', 'Israel', 'EURO', '136', '19142', '2', '305');
INSERT INTO public.who_global_data_import VALUES (40967, '2020-06-17', 'IL', 'Israel', 'EURO', '198', '19340', '0', '305');
INSERT INTO public.who_global_data_import VALUES (40968, '2020-06-18', 'IL', 'Israel', 'EURO', '300', '19640', '1', '306');
INSERT INTO public.who_global_data_import VALUES (40969, '2020-06-19', 'IL', 'Israel', 'EURO', '271', '19911', '0', '306');
INSERT INTO public.who_global_data_import VALUES (40970, '2020-06-20', 'IL', 'Israel', 'EURO', '302', '20213', '0', '306');
INSERT INTO public.who_global_data_import VALUES (40971, '2020-06-21', 'IL', 'Israel', 'EURO', '310', '20523', '1', '307');
INSERT INTO public.who_global_data_import VALUES (40972, '2020-06-22', 'IL', 'Israel', 'EURO', '160', '20683', '1', '308');
INSERT INTO public.who_global_data_import VALUES (40973, '2020-06-23', 'IL', 'Israel', 'EURO', '173', '20856', '0', '308');
INSERT INTO public.who_global_data_import VALUES (40974, '2020-06-24', 'IL', 'Israel', 'EURO', '345', '21201', '1', '309');
INSERT INTO public.who_global_data_import VALUES (40975, '2020-06-25', 'IL', 'Israel', 'EURO', '452', '21653', '2', '311');
INSERT INTO public.who_global_data_import VALUES (40976, '2020-06-26', 'IL', 'Israel', 'EURO', '487', '22140', '3', '314');
INSERT INTO public.who_global_data_import VALUES (40977, '2020-06-27', 'IL', 'Israel', 'EURO', '516', '22656', '4', '318');
INSERT INTO public.who_global_data_import VALUES (40978, '2020-06-28', 'IL', 'Israel', 'EURO', '464', '23120', '3', '321');
INSERT INTO public.who_global_data_import VALUES (40979, '2020-06-29', 'IL', 'Israel', 'EURO', '398', '23518', '3', '324');
INSERT INTO public.who_global_data_import VALUES (40980, '2020-06-30', 'IL', 'Israel', 'EURO', '385', '23903', '2', '326');
INSERT INTO public.who_global_data_import VALUES (40981, '2020-07-01', 'IL', 'Israel', 'EURO', '757', '24660', '0', '326');
INSERT INTO public.who_global_data_import VALUES (40982, '2020-07-02', 'IL', 'Israel', 'EURO', '786', '25446', '1', '327');
INSERT INTO public.who_global_data_import VALUES (40983, '2020-07-03', 'IL', 'Israel', 'EURO', '972', '26418', '3', '330');
INSERT INTO public.who_global_data_import VALUES (40984, '2020-07-04', 'IL', 'Israel', 'EURO', '1148', '27566', '1', '331');
INSERT INTO public.who_global_data_import VALUES (40985, '2020-07-05', 'IL', 'Israel', 'EURO', '939', '28505', '3', '334');
INSERT INTO public.who_global_data_import VALUES (40986, '2020-07-06', 'IL', 'Israel', 'EURO', '821', '29326', '5', '339');
INSERT INTO public.who_global_data_import VALUES (40987, '2020-07-07', 'IL', 'Israel', 'EURO', '831', '30157', '2', '341');
INSERT INTO public.who_global_data_import VALUES (40988, '2020-07-08', 'IL', 'Israel', 'EURO', '1134', '31291', '8', '349');
INSERT INTO public.who_global_data_import VALUES (40989, '2020-07-09', 'IL', 'Israel', 'EURO', '1390', '32681', '5', '354');
INSERT INTO public.who_global_data_import VALUES (40990, '2020-07-10', 'IL', 'Israel', 'EURO', '1327', '34008', '5', '359');
INSERT INTO public.who_global_data_import VALUES (40991, '2020-07-11', 'IL', 'Israel', 'EURO', '1525', '35533', '5', '364');
INSERT INTO public.who_global_data_import VALUES (40992, '2020-07-12', 'IL', 'Israel', 'EURO', '1409', '36942', '4', '368');
INSERT INTO public.who_global_data_import VALUES (40993, '2020-07-13', 'IL', 'Israel', 'EURO', '1168', '38110', '5', '373');
INSERT INTO public.who_global_data_import VALUES (40994, '2020-07-14', 'IL', 'Israel', 'EURO', '1239', '39349', '7', '380');
INSERT INTO public.who_global_data_import VALUES (40995, '2020-07-15', 'IL', 'Israel', 'EURO', '1720', '41069', '4', '384');
INSERT INTO public.who_global_data_import VALUES (40996, '2020-07-16', 'IL', 'Israel', 'EURO', '1604', '42673', '7', '391');
INSERT INTO public.who_global_data_import VALUES (40997, '2020-07-17', 'IL', 'Israel', 'EURO', '1877', '44550', '6', '397');
INSERT INTO public.who_global_data_import VALUES (40998, '2020-07-18', 'IL', 'Israel', 'EURO', '1938', '46488', '9', '406');
INSERT INTO public.who_global_data_import VALUES (40999, '2020-07-19', 'IL', 'Israel', 'EURO', '1605', '48093', '12', '418');
INSERT INTO public.who_global_data_import VALUES (41000, '2020-07-20', 'IL', 'Israel', 'EURO', '1448', '49541', '8', '426');
INSERT INTO public.who_global_data_import VALUES (41001, '2020-07-21', 'IL', 'Israel', 'EURO', '1016', '50557', '10', '436');
INSERT INTO public.who_global_data_import VALUES (41002, '2020-07-22', 'IL', 'Israel', 'EURO', '1887', '52444', '12', '448');
INSERT INTO public.who_global_data_import VALUES (41003, '2020-07-23', 'IL', 'Israel', 'EURO', '2006', '54450', '9', '457');
INSERT INTO public.who_global_data_import VALUES (41004, '2020-07-24', 'IL', 'Israel', 'EURO', '2044', '56494', '6', '463');
INSERT INTO public.who_global_data_import VALUES (41005, '2020-07-25', 'IL', 'Israel', 'EURO', '1990', '58484', '16', '479');
INSERT INTO public.who_global_data_import VALUES (41006, '2020-07-26', 'IL', 'Israel', 'EURO', '1830', '60314', '8', '487');
INSERT INTO public.who_global_data_import VALUES (41007, '2020-07-27', 'IL', 'Israel', 'EURO', '1112', '61426', '7', '494');
INSERT INTO public.who_global_data_import VALUES (41008, '2020-07-28', 'IL', 'Israel', 'EURO', '1042', '62468', '11', '505');
INSERT INTO public.who_global_data_import VALUES (41009, '2020-07-29', 'IL', 'Israel', 'EURO', '2048', '64516', '7', '512');
INSERT INTO public.who_global_data_import VALUES (41010, '2020-07-30', 'IL', 'Israel', 'EURO', '2125', '66641', '8', '520');
INSERT INTO public.who_global_data_import VALUES (41011, '2020-07-31', 'IL', 'Israel', 'EURO', '1954', '68595', '15', '535');
INSERT INTO public.who_global_data_import VALUES (41012, '2020-08-01', 'IL', 'Israel', 'EURO', '1787', '70382', '15', '550');
INSERT INTO public.who_global_data_import VALUES (41013, '2020-08-02', 'IL', 'Israel', 'EURO', '1362', '71744', '14', '564');
INSERT INTO public.who_global_data_import VALUES (41014, '2020-08-03', 'IL', 'Israel', 'EURO', '625', '72369', '14', '578');
INSERT INTO public.who_global_data_import VALUES (41015, '2020-08-04', 'IL', 'Israel', 'EURO', '708', '73077', '11', '589');
INSERT INTO public.who_global_data_import VALUES (41016, '2020-08-05', 'IL', 'Israel', 'EURO', '1800', '74877', '15', '604');
INSERT INTO public.who_global_data_import VALUES (41017, '2020-08-06', 'IL', 'Israel', 'EURO', '1729', '76606', '11', '615');
INSERT INTO public.who_global_data_import VALUES (41018, '2020-08-07', 'IL', 'Israel', 'EURO', '1690', '78296', '10', '625');
INSERT INTO public.who_global_data_import VALUES (41019, '2020-08-08', 'IL', 'Israel', 'EURO', '1677', '79973', '9', '634');
INSERT INTO public.who_global_data_import VALUES (41020, '2020-08-09', 'IL', 'Israel', 'EURO', '1764', '81737', '12', '646');
INSERT INTO public.who_global_data_import VALUES (41021, '2020-08-10', 'IL', 'Israel', 'EURO', '754', '82491', '13', '659');
INSERT INTO public.who_global_data_import VALUES (41022, '2020-08-11', 'IL', 'Israel', 'EURO', '924', '83415', '7', '666');
INSERT INTO public.who_global_data_import VALUES (41023, '2020-08-12', 'IL', 'Israel', 'EURO', '1704', '85119', '15', '681');
INSERT INTO public.who_global_data_import VALUES (41024, '2020-08-13', 'IL', 'Israel', 'EURO', '1823', '86942', '11', '692');
INSERT INTO public.who_global_data_import VALUES (41025, '2020-08-14', 'IL', 'Israel', 'EURO', '1622', '88564', '15', '707');
INSERT INTO public.who_global_data_import VALUES (41026, '2020-08-15', 'IL', 'Israel', 'EURO', '1643', '90207', '16', '723');
INSERT INTO public.who_global_data_import VALUES (41027, '2020-08-16', 'IL', 'Israel', 'EURO', '1388', '91595', '12', '735');
INSERT INTO public.who_global_data_import VALUES (41028, '2020-08-17', 'IL', 'Israel', 'EURO', '757', '92352', '10', '745');
INSERT INTO public.who_global_data_import VALUES (41029, '2020-08-18', 'IL', 'Israel', 'EURO', '1068', '93420', '19', '764');
INSERT INTO public.who_global_data_import VALUES (41030, '2020-08-19', 'IL', 'Israel', 'EURO', '1650', '95070', '4', '768');
INSERT INTO public.who_global_data_import VALUES (41031, '2020-08-20', 'IL', 'Israel', 'EURO', '1649', '96719', '14', '782');
INSERT INTO public.who_global_data_import VALUES (41032, '2020-08-21', 'IL', 'Israel', 'EURO', '1640', '98359', '12', '794');
INSERT INTO public.who_global_data_import VALUES (41033, '2020-08-22', 'IL', 'Israel', 'EURO', '1487', '99846', '12', '806');
INSERT INTO public.who_global_data_import VALUES (41034, '2020-08-23', 'IL', 'Israel', 'EURO', '1493', '101339', '13', '819');
INSERT INTO public.who_global_data_import VALUES (41035, '2020-08-24', 'IL', 'Israel', 'EURO', '711', '102050', '10', '829');
INSERT INTO public.who_global_data_import VALUES (41036, '2020-08-25', 'IL', 'Israel', 'EURO', '965', '103015', '13', '842');
INSERT INTO public.who_global_data_import VALUES (41037, '2020-08-26', 'IL', 'Israel', 'EURO', '1900', '104915', '16', '858');
INSERT INTO public.who_global_data_import VALUES (41038, '2020-08-27', 'IL', 'Israel', 'EURO', '1956', '106871', '19', '877');
INSERT INTO public.who_global_data_import VALUES (41039, '2020-08-28', 'IL', 'Israel', 'EURO', '1953', '108824', '11', '888');
INSERT INTO public.who_global_data_import VALUES (41040, '2020-08-29', 'IL', 'Israel', 'EURO', '2071', '110895', '11', '899');
INSERT INTO public.who_global_data_import VALUES (41041, '2020-08-30', 'IL', 'Israel', 'EURO', '1832', '112727', '12', '911');
INSERT INTO public.who_global_data_import VALUES (41042, '2020-08-31', 'IL', 'Israel', 'EURO', '910', '113637', '5', '916');
INSERT INTO public.who_global_data_import VALUES (41043, '2020-09-01', 'IL', 'Israel', 'EURO', '1101', '114738', '14', '930');
INSERT INTO public.who_global_data_import VALUES (41044, '2020-09-02', 'IL', 'Israel', 'EURO', '2178', '116916', '23', '953');
INSERT INTO public.who_global_data_import VALUES (41045, '2020-09-03', 'IL', 'Israel', 'EURO', '2252', '119168', '15', '968');
INSERT INTO public.who_global_data_import VALUES (41046, '2020-09-04', 'IL', 'Israel', 'EURO', '3193', '122361', '14', '982');
INSERT INTO public.who_global_data_import VALUES (41047, '2020-09-05', 'IL', 'Israel', 'EURO', '2661', '125022', '16', '998');
INSERT INTO public.who_global_data_import VALUES (41048, '2020-09-06', 'IL', 'Israel', 'EURO', '2623', '127645', '12', '1010');
INSERT INTO public.who_global_data_import VALUES (41049, '2020-09-07', 'IL', 'Israel', 'EURO', '1505', '129150', '15', '1025');
INSERT INTO public.who_global_data_import VALUES (41050, '2020-09-08', 'IL', 'Israel', 'EURO', '2177', '131327', '12', '1037');
INSERT INTO public.who_global_data_import VALUES (41051, '2020-09-09', 'IL', 'Israel', 'EURO', '3388', '134715', '17', '1054');
INSERT INTO public.who_global_data_import VALUES (41052, '2020-09-10', 'IL', 'Israel', 'EURO', '3489', '138204', '20', '1074');
INSERT INTO public.who_global_data_import VALUES (41053, '2020-09-11', 'IL', 'Israel', 'EURO', '3994', '142198', '16', '1090');
INSERT INTO public.who_global_data_import VALUES (41054, '2020-09-12', 'IL', 'Israel', 'EURO', '4161', '146359', '14', '1104');
INSERT INTO public.who_global_data_import VALUES (41055, '2020-09-13', 'IL', 'Israel', 'EURO', '3975', '150334', '20', '1124');
INSERT INTO public.who_global_data_import VALUES (41056, '2020-09-14', 'IL', 'Israel', 'EURO', '2718', '153052', '15', '1139');
INSERT INTO public.who_global_data_import VALUES (41057, '2020-09-15', 'IL', 'Israel', 'EURO', '3175', '156227', '17', '1156');
INSERT INTO public.who_global_data_import VALUES (41058, '2020-09-16', 'IL', 'Israel', 'EURO', '4805', '161032', '20', '1176');
INSERT INTO public.who_global_data_import VALUES (41059, '2020-09-17', 'IL', 'Israel', 'EURO', '5539', '166571', '16', '1192');
INSERT INTO public.who_global_data_import VALUES (41060, '2020-09-18', 'IL', 'Israel', 'EURO', '4574', '171145', '26', '1218');
INSERT INTO public.who_global_data_import VALUES (41061, '2020-09-19', 'IL', 'Israel', 'EURO', '5385', '176530', '17', '1235');
INSERT INTO public.who_global_data_import VALUES (41062, '2020-09-20', 'IL', 'Israel', 'EURO', '5340', '181870', '20', '1255');
INSERT INTO public.who_global_data_import VALUES (41063, '2020-09-21', 'IL', 'Israel', 'EURO', '3809', '185679', '27', '1282');
INSERT INTO public.who_global_data_import VALUES (41064, '2020-09-22', 'IL', 'Israel', 'EURO', '2579', '188258', '21', '1303');
INSERT INTO public.who_global_data_import VALUES (41065, '2020-09-23', 'IL', 'Israel', 'EURO', '3865', '192123', '32', '1335');
INSERT INTO public.who_global_data_import VALUES (41066, '2020-09-24', 'IL', 'Israel', 'EURO', '7021', '199144', '26', '1361');
INSERT INTO public.who_global_data_import VALUES (41067, '2020-09-25', 'IL', 'Israel', 'EURO', '7125', '206269', '25', '1386');
INSERT INTO public.who_global_data_import VALUES (41068, '2020-09-26', 'IL', 'Israel', 'EURO', '8234', '214503', '31', '1417');
INSERT INTO public.who_global_data_import VALUES (41069, '2020-09-27', 'IL', 'Israel', 'EURO', '8389', '222892', '30', '1447');
INSERT INTO public.who_global_data_import VALUES (41070, '2020-09-28', 'IL', 'Israel', 'EURO', '5882', '228774', '26', '1473');
INSERT INTO public.who_global_data_import VALUES (41071, '2020-09-29', 'IL', 'Israel', 'EURO', '3413', '232187', '32', '1505');
INSERT INTO public.who_global_data_import VALUES (41072, '2020-09-30', 'IL', 'Israel', 'EURO', '1159', '233346', '28', '1533');
INSERT INTO public.who_global_data_import VALUES (41073, '2020-10-01', 'IL', 'Israel', 'EURO', '4992', '238338', '35', '1568');
INSERT INTO public.who_global_data_import VALUES (41074, '2020-10-02', 'IL', 'Israel', 'EURO', '9078', '247416', '37', '1605');
INSERT INTO public.who_global_data_import VALUES (41075, '2020-10-03', 'IL', 'Israel', 'EURO', '7731', '255147', '46', '1651');
INSERT INTO public.who_global_data_import VALUES (41076, '2020-10-04', 'IL', 'Israel', 'EURO', '7059', '262206', '25', '1676');
INSERT INTO public.who_global_data_import VALUES (41077, '2020-10-05', 'IL', 'Israel', 'EURO', '2595', '264801', '37', '1713');
INSERT INTO public.who_global_data_import VALUES (41078, '2020-10-06', 'IL', 'Israel', 'EURO', '2938', '267739', '37', '1750');
INSERT INTO public.who_global_data_import VALUES (41079, '2020-10-07', 'IL', 'Israel', 'EURO', '5721', '273460', '27', '1777');
INSERT INTO public.who_global_data_import VALUES (41080, '2020-10-08', 'IL', 'Israel', 'EURO', '4724', '278184', '45', '1822');
INSERT INTO public.who_global_data_import VALUES (41081, '2020-10-09', 'IL', 'Israel', 'EURO', '4165', '282349', '26', '1848');
INSERT INTO public.who_global_data_import VALUES (41082, '2020-10-10', 'IL', 'Israel', 'EURO', '3755', '286104', '47', '1895');
INSERT INTO public.who_global_data_import VALUES (41083, '2020-10-11', 'IL', 'Israel', 'EURO', '2963', '289067', '40', '1935');
INSERT INTO public.who_global_data_import VALUES (41084, '2020-10-12', 'IL', 'Israel', 'EURO', '916', '289983', '35', '1970');
INSERT INTO public.who_global_data_import VALUES (41085, '2020-10-13', 'IL', 'Israel', 'EURO', '1646', '291629', '46', '2016');
INSERT INTO public.who_global_data_import VALUES (41086, '2020-10-14', 'IL', 'Israel', 'EURO', '3169', '294798', '30', '2046');
INSERT INTO public.who_global_data_import VALUES (41087, '2020-10-15', 'IL', 'Israel', 'EURO', '2336', '297134', '38', '2084');
INSERT INTO public.who_global_data_import VALUES (41088, '2020-10-16', 'IL', 'Israel', 'EURO', '2118', '299252', '35', '2119');
INSERT INTO public.who_global_data_import VALUES (41089, '2020-10-17', 'IL', 'Israel', 'EURO', '1612', '300864', '31', '2150');
INSERT INTO public.who_global_data_import VALUES (41090, '2020-10-18', 'IL', 'Israel', 'EURO', '1500', '302364', '36', '2186');
INSERT INTO public.who_global_data_import VALUES (41091, '2020-10-19', 'IL', 'Israel', 'EURO', '412', '302776', '32', '2218');
INSERT INTO public.who_global_data_import VALUES (41092, '2020-10-20', 'IL', 'Israel', 'EURO', '922', '303698', '33', '2251');
INSERT INTO public.who_global_data_import VALUES (41093, '2020-10-21', 'IL', 'Israel', 'EURO', '1517', '305215', '31', '2282');
INSERT INTO public.who_global_data_import VALUES (41094, '2020-10-22', 'IL', 'Israel', 'EURO', '1193', '306408', '20', '2302');
INSERT INTO public.who_global_data_import VALUES (41095, '2020-10-23', 'IL', 'Israel', 'EURO', '1172', '307580', '25', '2327');
INSERT INTO public.who_global_data_import VALUES (41096, '2020-10-24', 'IL', 'Israel', 'EURO', '1032', '308612', '29', '2356');
INSERT INTO public.who_global_data_import VALUES (41097, '2020-10-25', 'IL', 'Israel', 'EURO', '849', '309461', '26', '2382');
INSERT INTO public.who_global_data_import VALUES (41098, '2020-10-26', 'IL', 'Israel', 'EURO', '246', '309707', '27', '2409');
INSERT INTO public.who_global_data_import VALUES (41099, '2020-10-27', 'IL', 'Israel', 'EURO', '607', '310314', '35', '2444');
INSERT INTO public.who_global_data_import VALUES (41100, '2020-10-28', 'IL', 'Israel', 'EURO', '884', '311198', '28', '2472');
INSERT INTO public.who_global_data_import VALUES (41101, '2020-10-29', 'IL', 'Israel', 'EURO', '887', '312085', '28', '2500');
INSERT INTO public.who_global_data_import VALUES (41102, '2020-10-30', 'IL', 'Israel', 'EURO', '723', '312808', '10', '2510');
INSERT INTO public.who_global_data_import VALUES (41103, '2020-10-31', 'IL', 'Israel', 'EURO', '644', '313452', '19', '2529');
INSERT INTO public.who_global_data_import VALUES (41104, '2020-11-01', 'IL', 'Israel', 'EURO', '680', '314132', '12', '2541');
INSERT INTO public.who_global_data_import VALUES (41105, '2020-11-02', 'IL', 'Israel', 'EURO', '228', '314360', '25', '2566');
INSERT INTO public.who_global_data_import VALUES (41106, '2020-11-03', 'IL', 'Israel', 'EURO', '658', '315018', '19', '2585');
INSERT INTO public.who_global_data_import VALUES (41107, '2020-11-04', 'IL', 'Israel', 'EURO', '788', '315806', '15', '2600');
INSERT INTO public.who_global_data_import VALUES (41108, '2020-11-05', 'IL', 'Israel', 'EURO', '845', '316651', '26', '2626');
INSERT INTO public.who_global_data_import VALUES (41109, '2020-11-06', 'IL', 'Israel', 'EURO', '769', '317420', '16', '2642');
INSERT INTO public.who_global_data_import VALUES (41110, '2020-11-07', 'IL', 'Israel', 'EURO', '570', '317990', '14', '2656');
INSERT INTO public.who_global_data_import VALUES (41111, '2020-11-08', 'IL', 'Israel', 'EURO', '691', '318681', '16', '2672');
INSERT INTO public.who_global_data_import VALUES (41112, '2020-11-09', 'IL', 'Israel', 'EURO', '212', '318893', '8', '2680');
INSERT INTO public.who_global_data_import VALUES (41113, '2020-11-10', 'IL', 'Israel', 'EURO', '534', '319427', '7', '2687');
INSERT INTO public.who_global_data_import VALUES (41114, '2020-11-11', 'IL', 'Israel', 'EURO', '719', '320146', '6', '2693');
INSERT INTO public.who_global_data_import VALUES (41115, '2020-11-12', 'IL', 'Israel', 'EURO', '675', '320821', '10', '2703');
INSERT INTO public.who_global_data_import VALUES (41116, '2020-11-13', 'IL', 'Israel', 'EURO', '764', '321585', '7', '2710');
INSERT INTO public.who_global_data_import VALUES (41117, '2020-11-14', 'IL', 'Israel', 'EURO', '836', '322421', '12', '2722');
INSERT INTO public.who_global_data_import VALUES (41118, '2020-11-15', 'IL', 'Israel', 'EURO', '761', '323182', '5', '2727');
INSERT INTO public.who_global_data_import VALUES (41119, '2020-11-16', 'IL', 'Israel', 'EURO', '291', '323473', '12', '2739');
INSERT INTO public.who_global_data_import VALUES (41120, '2020-11-17', 'IL', 'Israel', 'EURO', '625', '324098', '9', '2748');
INSERT INTO public.who_global_data_import VALUES (41121, '2020-11-18', 'IL', 'Israel', 'EURO', '873', '324971', '8', '2756');
INSERT INTO public.who_global_data_import VALUES (41122, '2020-11-19', 'IL', 'Israel', 'EURO', '829', '325800', '12', '2768');
INSERT INTO public.who_global_data_import VALUES (41123, '2020-11-20', 'IL', 'Israel', 'EURO', '795', '326595', '7', '2775');
INSERT INTO public.who_global_data_import VALUES (41124, '2020-11-21', 'IL', 'Israel', 'EURO', '771', '327366', '8', '2783');
INSERT INTO public.who_global_data_import VALUES (41125, '2020-11-22', 'IL', 'Israel', 'EURO', '773', '328139', '6', '2789');
INSERT INTO public.who_global_data_import VALUES (41126, '2020-11-23', 'IL', 'Israel', 'EURO', '422', '328561', '12', '2801');
INSERT INTO public.who_global_data_import VALUES (41127, '2020-11-24', 'IL', 'Israel', 'EURO', '762', '329323', '17', '2818');
INSERT INTO public.who_global_data_import VALUES (41128, '2020-11-25', 'IL', 'Israel', 'EURO', '959', '330282', '7', '2825');
INSERT INTO public.who_global_data_import VALUES (41129, '2020-11-26', 'IL', 'Israel', 'EURO', '857', '331139', '6', '2831');
INSERT INTO public.who_global_data_import VALUES (41130, '2020-11-27', 'IL', 'Israel', 'EURO', '1079', '332218', '5', '2836');
INSERT INTO public.who_global_data_import VALUES (41131, '2020-11-28', 'IL', 'Israel', 'EURO', '1087', '333305', '9', '2845');
INSERT INTO public.who_global_data_import VALUES (41132, '2020-11-29', 'IL', 'Israel', 'EURO', '1031', '334336', '6', '2851');
INSERT INTO public.who_global_data_import VALUES (41133, '2020-11-30', 'IL', 'Israel', 'EURO', '582', '334918', '10', '2861');
INSERT INTO public.who_global_data_import VALUES (41134, '2020-12-01', 'IL', 'Israel', 'EURO', '1024', '335942', '10', '2871');
INSERT INTO public.who_global_data_import VALUES (41135, '2020-12-02', 'IL', 'Israel', 'EURO', '1253', '337195', '7', '2878');
INSERT INTO public.who_global_data_import VALUES (41136, '2020-12-03', 'IL', 'Israel', 'EURO', '1199', '338394', '10', '2888');
INSERT INTO public.who_global_data_import VALUES (41137, '2020-12-04', 'IL', 'Israel', 'EURO', '1588', '339982', '5', '2893');
INSERT INTO public.who_global_data_import VALUES (41138, '2020-12-05', 'IL', 'Israel', 'EURO', '1451', '341433', '10', '2903');
INSERT INTO public.who_global_data_import VALUES (41139, '2020-12-06', 'IL', 'Israel', 'EURO', '1514', '342947', '10', '2913');
INSERT INTO public.who_global_data_import VALUES (41140, '2020-12-07', 'IL', 'Israel', 'EURO', '1000', '343947', '10', '2923');
INSERT INTO public.who_global_data_import VALUES (41141, '2020-12-08', 'IL', 'Israel', 'EURO', '1363', '345310', '8', '2931');
INSERT INTO public.who_global_data_import VALUES (41142, '2020-12-09', 'IL', 'Israel', 'EURO', '1860', '347170', '7', '2938');
INSERT INTO public.who_global_data_import VALUES (41143, '2020-12-10', 'IL', 'Israel', 'EURO', '1768', '348938', '12', '2950');
INSERT INTO public.who_global_data_import VALUES (41144, '2020-12-11', 'IL', 'Israel', 'EURO', '1866', '350804', '15', '2965');
INSERT INTO public.who_global_data_import VALUES (41145, '2020-12-12', 'IL', 'Israel', 'EURO', '2005', '352809', '12', '2977');
INSERT INTO public.who_global_data_import VALUES (41146, '2020-12-13', 'IL', 'Israel', 'EURO', '1835', '354644', '12', '2989');
INSERT INTO public.who_global_data_import VALUES (41147, '2020-12-14', 'IL', 'Israel', 'EURO', '1296', '355940', '16', '3005');
INSERT INTO public.who_global_data_import VALUES (41148, '2020-12-15', 'IL', 'Israel', 'EURO', '1729', '357669', '9', '3014');
INSERT INTO public.who_global_data_import VALUES (41149, '2020-12-16', 'IL', 'Israel', 'EURO', '2315', '359984', '11', '3025');
INSERT INTO public.who_global_data_import VALUES (41150, '2020-12-17', 'IL', 'Israel', 'EURO', '2891', '362875', '12', '3037');
INSERT INTO public.who_global_data_import VALUES (41151, '2020-12-18', 'IL', 'Israel', 'EURO', '2852', '365727', '14', '3051');
INSERT INTO public.who_global_data_import VALUES (41152, '2020-12-19', 'IL', 'Israel', 'EURO', '2846', '368573', '17', '3068');
INSERT INTO public.who_global_data_import VALUES (41153, '2020-12-20', 'IL', 'Israel', 'EURO', '2792', '371365', '16', '3084');
INSERT INTO public.who_global_data_import VALUES (41154, '2020-12-21', 'IL', 'Israel', 'EURO', '1887', '373252', '19', '3103');
INSERT INTO public.who_global_data_import VALUES (41155, '2020-12-22', 'IL', 'Israel', 'EURO', '3093', '376345', '19', '3122');
INSERT INTO public.who_global_data_import VALUES (41156, '2020-12-23', 'IL', 'Israel', 'EURO', '3781', '380126', '16', '3138');
INSERT INTO public.who_global_data_import VALUES (41157, '2020-12-24', 'IL', 'Israel', 'EURO', '4376', '384502', '13', '3151');
INSERT INTO public.who_global_data_import VALUES (41158, '2020-12-25', 'IL', 'Israel', 'EURO', '4035', '388537', '25', '3176');
INSERT INTO public.who_global_data_import VALUES (41159, '2020-12-26', 'IL', 'Israel', 'EURO', '4053', '392590', '15', '3191');
INSERT INTO public.who_global_data_import VALUES (41160, '2020-12-27', 'IL', 'Israel', 'EURO', '4010', '396600', '20', '3211');
INSERT INTO public.who_global_data_import VALUES (41161, '2020-12-28', 'IL', 'Israel', 'EURO', '2659', '399259', '23', '3234');
INSERT INTO public.who_global_data_import VALUES (41162, '2020-12-29', 'IL', 'Israel', 'EURO', '3528', '402787', '20', '3254');
INSERT INTO public.who_global_data_import VALUES (41163, '2020-12-30', 'IL', 'Israel', 'EURO', '5519', '408306', '34', '3288');
INSERT INTO public.who_global_data_import VALUES (41164, '2020-12-31', 'IL', 'Israel', 'EURO', '5639', '413945', '26', '3314');
INSERT INTO public.who_global_data_import VALUES (41165, '2021-01-01', 'IL', 'Israel', 'EURO', '5868', '419813', '15', '3329');
INSERT INTO public.who_global_data_import VALUES (41166, '2021-01-02', 'IL', 'Israel', 'EURO', '5876', '425689', '35', '3364');
INSERT INTO public.who_global_data_import VALUES (41167, '2021-01-03', 'IL', 'Israel', 'EURO', '6022', '431711', '38', '3402');
INSERT INTO public.who_global_data_import VALUES (41168, '2021-01-04', 'IL', 'Israel', 'EURO', '4218', '435929', '26', '3428');
INSERT INTO public.who_global_data_import VALUES (41169, '2021-01-05', 'IL', 'Israel', 'EURO', '5230', '441159', '24', '3452');
INSERT INTO public.who_global_data_import VALUES (41170, '2021-01-06', 'IL', 'Israel', 'EURO', '8404', '449563', '38', '3490');
INSERT INTO public.who_global_data_import VALUES (41171, '2021-01-07', 'IL', 'Israel', 'EURO', '8236', '457799', '24', '3514');
INSERT INTO public.who_global_data_import VALUES (41172, '2021-01-08', 'IL', 'Israel', 'EURO', '7878', '465677', '45', '3559');
INSERT INTO public.who_global_data_import VALUES (41173, '2021-01-09', 'IL', 'Israel', 'EURO', '7642', '473319', '45', '3604');
INSERT INTO public.who_global_data_import VALUES (41174, '2021-01-10', 'IL', 'Israel', 'EURO', '8159', '481478', '48', '3652');
INSERT INTO public.who_global_data_import VALUES (41175, '2021-01-11', 'IL', 'Israel', 'EURO', '5156', '486634', '21', '3673');
INSERT INTO public.who_global_data_import VALUES (41176, '2021-01-12', 'IL', 'Israel', 'EURO', '6937', '493571', '44', '3717');
INSERT INTO public.who_global_data_import VALUES (41177, '2021-01-13', 'IL', 'Israel', 'EURO', '9712', '503283', '30', '3747');
INSERT INTO public.who_global_data_import VALUES (41178, '2021-01-14', 'IL', 'Israel', 'EURO', '9295', '512578', '57', '3804');
INSERT INTO public.who_global_data_import VALUES (41179, '2021-01-15', 'IL', 'Israel', 'EURO', '9467', '522045', '55', '3859');
INSERT INTO public.who_global_data_import VALUES (41180, '2021-01-16', 'IL', 'Israel', 'EURO', '9291', '531336', '59', '3918');
INSERT INTO public.who_global_data_import VALUES (41181, '2021-01-17', 'IL', 'Israel', 'EURO', '8427', '539763', '45', '3963');
INSERT INTO public.who_global_data_import VALUES (41182, '2021-01-18', 'IL', 'Israel', 'EURO', '5086', '544849', '51', '4014');
INSERT INTO public.who_global_data_import VALUES (41183, '2021-01-19', 'IL', 'Israel', 'EURO', '5649', '550498', '58', '4072');
INSERT INTO public.who_global_data_import VALUES (41184, '2021-01-20', 'IL', 'Israel', 'EURO', '10116', '560614', '47', '4119');
INSERT INTO public.who_global_data_import VALUES (41185, '2021-01-21', 'IL', 'Israel', 'EURO', '8601', '569215', '46', '4165');
INSERT INTO public.who_global_data_import VALUES (41186, '2021-01-22', 'IL', 'Israel', 'EURO', '8252', '577467', '54', '4219');
INSERT INTO public.who_global_data_import VALUES (41187, '2021-01-23', 'IL', 'Israel', 'EURO', '7200', '584667', '41', '4260');
INSERT INTO public.who_global_data_import VALUES (41188, '2021-01-24', 'IL', 'Israel', 'EURO', '7381', '592048', '56', '4316');
INSERT INTO public.who_global_data_import VALUES (41189, '2021-01-25', 'IL', 'Israel', 'EURO', '2418', '594466', '47', '4363');
INSERT INTO public.who_global_data_import VALUES (41190, '2021-01-26', 'IL', 'Israel', 'EURO', '4924', '599390', '69', '4432');
INSERT INTO public.who_global_data_import VALUES (41191, '2021-01-27', 'IL', 'Israel', 'EURO', '8714', '608104', '55', '4487');
INSERT INTO public.who_global_data_import VALUES (41192, '2021-01-28', 'IL', 'Israel', 'EURO', '7824', '615928', '75', '4562');
INSERT INTO public.who_global_data_import VALUES (41193, '2021-01-29', 'IL', 'Israel', 'EURO', '6488', '622416', '72', '4634');
INSERT INTO public.who_global_data_import VALUES (41194, '2021-01-30', 'IL', 'Israel', 'EURO', '7726', '630142', '47', '4681');
INSERT INTO public.who_global_data_import VALUES (41195, '2021-01-31', 'IL', 'Israel', 'EURO', '7100', '637242', '41', '4722');
INSERT INTO public.who_global_data_import VALUES (41196, '2021-02-01', 'IL', 'Israel', 'EURO', '3177', '640419', '43', '4765');
INSERT INTO public.who_global_data_import VALUES (41197, '2021-02-02', 'IL', 'Israel', 'EURO', '5171', '645590', '41', '4806');
INSERT INTO public.who_global_data_import VALUES (41198, '2021-02-03', 'IL', 'Israel', 'EURO', '0', '645590', '0', '4806');
INSERT INTO public.who_global_data_import VALUES (41199, '2021-02-04', 'IL', 'Israel', 'EURO', '0', '645590', '0', '4806');
INSERT INTO public.who_global_data_import VALUES (41200, '2021-02-05', 'IL', 'Israel', 'EURO', '0', '645590', '0', '4806');
INSERT INTO public.who_global_data_import VALUES (41203, '2020-01-05', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41204, '2020-01-06', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41205, '2020-01-07', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41206, '2020-01-08', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41207, '2020-01-09', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41208, '2020-01-10', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41209, '2020-01-11', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41210, '2020-01-12', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41211, '2020-01-13', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41212, '2020-01-14', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41213, '2020-01-15', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41214, '2020-01-16', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41215, '2020-01-17', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41216, '2020-01-18', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41217, '2020-01-19', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41218, '2020-01-20', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41219, '2020-01-21', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41220, '2020-01-22', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41221, '2020-01-23', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41222, '2020-01-24', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41223, '2020-01-25', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41224, '2020-01-26', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41225, '2020-01-27', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41226, '2020-01-28', 'IT', 'Italy', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41227, '2020-01-29', 'IT', 'Italy', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41228, '2020-01-30', 'IT', 'Italy', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41229, '2020-01-31', 'IT', 'Italy', 'EURO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41230, '2020-02-01', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41231, '2020-02-02', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41232, '2020-02-03', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41233, '2020-02-04', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41234, '2020-02-05', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41235, '2020-02-06', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41236, '2020-02-07', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41237, '2020-02-08', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41238, '2020-02-09', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41239, '2020-02-10', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41240, '2020-02-11', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41241, '2020-02-12', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41242, '2020-02-13', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41243, '2020-02-14', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41244, '2020-02-15', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41245, '2020-02-16', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41246, '2020-02-17', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41247, '2020-02-18', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41248, '2020-02-19', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41249, '2020-02-20', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41250, '2020-02-21', 'IT', 'Italy', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41251, '2020-02-22', 'IT', 'Italy', 'EURO', '14', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41252, '2020-02-23', 'IT', 'Italy', 'EURO', '62', '79', '2', '2');
INSERT INTO public.who_global_data_import VALUES (41253, '2020-02-24', 'IT', 'Italy', 'EURO', '53', '132', '0', '2');
INSERT INTO public.who_global_data_import VALUES (41254, '2020-02-25', 'IT', 'Italy', 'EURO', '97', '229', '4', '6');
INSERT INTO public.who_global_data_import VALUES (41255, '2020-02-26', 'IT', 'Italy', 'EURO', '93', '322', '5', '11');
INSERT INTO public.who_global_data_import VALUES (41256, '2020-02-27', 'IT', 'Italy', 'EURO', '78', '400', '1', '12');
INSERT INTO public.who_global_data_import VALUES (41257, '2020-02-28', 'IT', 'Italy', 'EURO', '250', '650', '5', '17');
INSERT INTO public.who_global_data_import VALUES (41258, '2020-02-29', 'IT', 'Italy', 'EURO', '238', '888', '4', '21');
INSERT INTO public.who_global_data_import VALUES (41259, '2020-03-01', 'IT', 'Italy', 'EURO', '240', '1128', '8', '29');
INSERT INTO public.who_global_data_import VALUES (41260, '2020-03-02', 'IT', 'Italy', 'EURO', '561', '1689', '6', '35');
INSERT INTO public.who_global_data_import VALUES (41261, '2020-03-03', 'IT', 'Italy', 'EURO', '347', '2036', '17', '52');
INSERT INTO public.who_global_data_import VALUES (41262, '2020-03-04', 'IT', 'Italy', 'EURO', '466', '2502', '28', '80');
INSERT INTO public.who_global_data_import VALUES (41263, '2020-03-05', 'IT', 'Italy', 'EURO', '587', '3089', '27', '107');
INSERT INTO public.who_global_data_import VALUES (41264, '2020-03-06', 'IT', 'Italy', 'EURO', '769', '3858', '41', '148');
INSERT INTO public.who_global_data_import VALUES (41265, '2020-03-07', 'IT', 'Italy', 'EURO', '778', '4636', '49', '197');
INSERT INTO public.who_global_data_import VALUES (41266, '2020-03-08', 'IT', 'Italy', 'EURO', '1247', '5883', '36', '233');
INSERT INTO public.who_global_data_import VALUES (41267, '2020-03-09', 'IT', 'Italy', 'EURO', '1492', '7375', '133', '366');
INSERT INTO public.who_global_data_import VALUES (41268, '2020-03-10', 'IT', 'Italy', 'EURO', '1797', '9172', '98', '464');
INSERT INTO public.who_global_data_import VALUES (41269, '2020-03-11', 'IT', 'Italy', 'EURO', '977', '10149', '167', '631');
INSERT INTO public.who_global_data_import VALUES (41270, '2020-03-12', 'IT', 'Italy', 'EURO', '2313', '12462', '196', '827');
INSERT INTO public.who_global_data_import VALUES (41271, '2020-03-13', 'IT', 'Italy', 'EURO', '2651', '15113', '189', '1016');
INSERT INTO public.who_global_data_import VALUES (41272, '2020-03-14', 'IT', 'Italy', 'EURO', '2547', '17660', '252', '1268');
INSERT INTO public.who_global_data_import VALUES (41273, '2020-03-15', 'IT', 'Italy', 'EURO', '3497', '21157', '173', '1441');
INSERT INTO public.who_global_data_import VALUES (41274, '2020-03-16', 'IT', 'Italy', 'EURO', '2823', '23980', '370', '1811');
INSERT INTO public.who_global_data_import VALUES (41275, '2020-03-17', 'IT', 'Italy', 'EURO', '4000', '27980', '347', '2158');
INSERT INTO public.who_global_data_import VALUES (41276, '2020-03-18', 'IT', 'Italy', 'EURO', '3526', '31506', '347', '2505');
INSERT INTO public.who_global_data_import VALUES (41277, '2020-03-19', 'IT', 'Italy', 'EURO', '4207', '35713', '473', '2978');
INSERT INTO public.who_global_data_import VALUES (41278, '2020-03-20', 'IT', 'Italy', 'EURO', '5322', '41035', '429', '3407');
INSERT INTO public.who_global_data_import VALUES (41279, '2020-03-21', 'IT', 'Italy', 'EURO', '5986', '47021', '625', '4032');
INSERT INTO public.who_global_data_import VALUES (41280, '2020-03-22', 'IT', 'Italy', 'EURO', '6557', '53578', '795', '4827');
INSERT INTO public.who_global_data_import VALUES (41281, '2020-03-23', 'IT', 'Italy', 'EURO', '5560', '59138', '649', '5476');
INSERT INTO public.who_global_data_import VALUES (41282, '2020-03-24', 'IT', 'Italy', 'EURO', '4789', '63927', '601', '6077');
INSERT INTO public.who_global_data_import VALUES (41283, '2020-03-25', 'IT', 'Italy', 'EURO', '5249', '69176', '743', '6820');
INSERT INTO public.who_global_data_import VALUES (41284, '2020-03-26', 'IT', 'Italy', 'EURO', '5210', '74386', '685', '7505');
INSERT INTO public.who_global_data_import VALUES (41285, '2020-03-27', 'IT', 'Italy', 'EURO', '6153', '80539', '660', '8165');
INSERT INTO public.who_global_data_import VALUES (41286, '2020-03-28', 'IT', 'Italy', 'EURO', '5959', '86498', '971', '9136');
INSERT INTO public.who_global_data_import VALUES (41287, '2020-03-29', 'IT', 'Italy', 'EURO', '5974', '92472', '887', '10023');
INSERT INTO public.who_global_data_import VALUES (41288, '2020-03-30', 'IT', 'Italy', 'EURO', '5217', '97689', '758', '10781');
INSERT INTO public.who_global_data_import VALUES (41289, '2020-03-31', 'IT', 'Italy', 'EURO', '4050', '101739', '810', '11591');
INSERT INTO public.who_global_data_import VALUES (41290, '2020-04-01', 'IT', 'Italy', 'EURO', '4053', '105792', '839', '12430');
INSERT INTO public.who_global_data_import VALUES (41291, '2020-04-02', 'IT', 'Italy', 'EURO', '4782', '110574', '727', '13157');
INSERT INTO public.who_global_data_import VALUES (41292, '2020-04-03', 'IT', 'Italy', 'EURO', '4668', '115242', '760', '13917');
INSERT INTO public.who_global_data_import VALUES (41293, '2020-04-04', 'IT', 'Italy', 'EURO', '4585', '119827', '764', '14681');
INSERT INTO public.who_global_data_import VALUES (41294, '2020-04-05', 'IT', 'Italy', 'EURO', '4805', '124632', '681', '15362');
INSERT INTO public.who_global_data_import VALUES (41295, '2020-04-06', 'IT', 'Italy', 'EURO', '4316', '128948', '527', '15889');
INSERT INTO public.who_global_data_import VALUES (41296, '2020-04-07', 'IT', 'Italy', 'EURO', '3599', '132547', '636', '16525');
INSERT INTO public.who_global_data_import VALUES (41297, '2020-04-08', 'IT', 'Italy', 'EURO', '3039', '135586', '604', '17129');
INSERT INTO public.who_global_data_import VALUES (41298, '2020-04-09', 'IT', 'Italy', 'EURO', '3836', '139422', '540', '17669');
INSERT INTO public.who_global_data_import VALUES (41299, '2020-04-10', 'IT', 'Italy', 'EURO', '4204', '143626', '612', '18281');
INSERT INTO public.who_global_data_import VALUES (41300, '2020-04-11', 'IT', 'Italy', 'EURO', '3951', '147577', '570', '18851');
INSERT INTO public.who_global_data_import VALUES (41301, '2020-04-12', 'IT', 'Italy', 'EURO', '4694', '152271', '619', '19470');
INSERT INTO public.who_global_data_import VALUES (41302, '2020-04-13', 'IT', 'Italy', 'EURO', '4092', '156363', '431', '19901');
INSERT INTO public.who_global_data_import VALUES (41303, '2020-04-14', 'IT', 'Italy', 'EURO', '3153', '159516', '564', '20465');
INSERT INTO public.who_global_data_import VALUES (41304, '2020-04-15', 'IT', 'Italy', 'EURO', '2972', '162488', '604', '21069');
INSERT INTO public.who_global_data_import VALUES (41305, '2020-04-16', 'IT', 'Italy', 'EURO', '2667', '165155', '578', '21647');
INSERT INTO public.who_global_data_import VALUES (41306, '2020-04-17', 'IT', 'Italy', 'EURO', '3786', '168941', '525', '22172');
INSERT INTO public.who_global_data_import VALUES (41307, '2020-04-18', 'IT', 'Italy', 'EURO', '3493', '172434', '575', '22747');
INSERT INTO public.who_global_data_import VALUES (41308, '2020-04-19', 'IT', 'Italy', 'EURO', '3491', '175925', '480', '23227');
INSERT INTO public.who_global_data_import VALUES (41309, '2020-04-20', 'IT', 'Italy', 'EURO', '3047', '178972', '433', '23660');
INSERT INTO public.who_global_data_import VALUES (41310, '2020-04-21', 'IT', 'Italy', 'EURO', '2256', '181228', '454', '24114');
INSERT INTO public.who_global_data_import VALUES (41311, '2020-04-22', 'IT', 'Italy', 'EURO', '2729', '183957', '534', '24648');
INSERT INTO public.who_global_data_import VALUES (41312, '2020-04-23', 'IT', 'Italy', 'EURO', '3370', '187327', '437', '25085');
INSERT INTO public.who_global_data_import VALUES (41313, '2020-04-24', 'IT', 'Italy', 'EURO', '2646', '189973', '464', '25549');
INSERT INTO public.who_global_data_import VALUES (41314, '2020-04-25', 'IT', 'Italy', 'EURO', '3021', '192994', '420', '25969');
INSERT INTO public.who_global_data_import VALUES (41315, '2020-04-26', 'IT', 'Italy', 'EURO', '2357', '195351', '415', '26384');
INSERT INTO public.who_global_data_import VALUES (41316, '2020-04-27', 'IT', 'Italy', 'EURO', '2324', '197675', '260', '26644');
INSERT INTO public.who_global_data_import VALUES (41317, '2020-04-28', 'IT', 'Italy', 'EURO', '1739', '199414', '333', '26977');
INSERT INTO public.who_global_data_import VALUES (41318, '2020-04-29', 'IT', 'Italy', 'EURO', '2091', '201505', '382', '27359');
INSERT INTO public.who_global_data_import VALUES (41319, '2020-04-30', 'IT', 'Italy', 'EURO', '2086', '203591', '323', '27682');
INSERT INTO public.who_global_data_import VALUES (41320, '2020-05-01', 'IT', 'Italy', 'EURO', '1872', '205463', '285', '27967');
INSERT INTO public.who_global_data_import VALUES (41321, '2020-05-02', 'IT', 'Italy', 'EURO', '1965', '207428', '269', '28236');
INSERT INTO public.who_global_data_import VALUES (41322, '2020-05-03', 'IT', 'Italy', 'EURO', '1900', '209328', '474', '28710');
INSERT INTO public.who_global_data_import VALUES (41323, '2020-05-04', 'IT', 'Italy', 'EURO', '1389', '210717', '174', '28884');
INSERT INTO public.who_global_data_import VALUES (41324, '2020-05-05', 'IT', 'Italy', 'EURO', '1221', '211938', '195', '29079');
INSERT INTO public.who_global_data_import VALUES (41325, '2020-05-06', 'IT', 'Italy', 'EURO', '1075', '213013', '236', '29315');
INSERT INTO public.who_global_data_import VALUES (41326, '2020-05-07', 'IT', 'Italy', 'EURO', '1444', '214457', '369', '29684');
INSERT INTO public.who_global_data_import VALUES (41327, '2020-05-08', 'IT', 'Italy', 'EURO', '1401', '215858', '274', '29958');
INSERT INTO public.who_global_data_import VALUES (41328, '2020-05-09', 'IT', 'Italy', 'EURO', '1327', '217185', '243', '30201');
INSERT INTO public.who_global_data_import VALUES (41329, '2020-05-10', 'IT', 'Italy', 'EURO', '1083', '218268', '194', '30395');
INSERT INTO public.who_global_data_import VALUES (41330, '2020-05-11', 'IT', 'Italy', 'EURO', '802', '219070', '165', '30560');
INSERT INTO public.who_global_data_import VALUES (41331, '2020-05-12', 'IT', 'Italy', 'EURO', '744', '219814', '179', '30739');
INSERT INTO public.who_global_data_import VALUES (41332, '2020-05-13', 'IT', 'Italy', 'EURO', '1402', '221216', '172', '30911');
INSERT INTO public.who_global_data_import VALUES (41333, '2020-05-14', 'IT', 'Italy', 'EURO', '888', '222104', '195', '31106');
INSERT INTO public.who_global_data_import VALUES (41334, '2020-05-15', 'IT', 'Italy', 'EURO', '992', '223096', '262', '31368');
INSERT INTO public.who_global_data_import VALUES (41335, '2020-05-16', 'IT', 'Italy', 'EURO', '789', '223885', '242', '31610');
INSERT INTO public.who_global_data_import VALUES (41336, '2020-05-17', 'IT', 'Italy', 'EURO', '875', '224760', '153', '31763');
INSERT INTO public.who_global_data_import VALUES (41337, '2020-05-18', 'IT', 'Italy', 'EURO', '675', '225435', '145', '31908');
INSERT INTO public.who_global_data_import VALUES (41338, '2020-05-19', 'IT', 'Italy', 'EURO', '451', '225886', '99', '32007');
INSERT INTO public.who_global_data_import VALUES (41339, '2020-05-20', 'IT', 'Italy', 'EURO', '813', '226699', '162', '32169');
INSERT INTO public.who_global_data_import VALUES (41340, '2020-05-21', 'IT', 'Italy', 'EURO', '665', '227364', '161', '32330');
INSERT INTO public.who_global_data_import VALUES (41341, '2020-05-22', 'IT', 'Italy', 'EURO', '642', '228006', '156', '32486');
INSERT INTO public.who_global_data_import VALUES (41342, '2020-05-23', 'IT', 'Italy', 'EURO', '652', '228658', '130', '32616');
INSERT INTO public.who_global_data_import VALUES (41343, '2020-05-24', 'IT', 'Italy', 'EURO', '669', '229327', '119', '32735');
INSERT INTO public.who_global_data_import VALUES (41344, '2020-05-25', 'IT', 'Italy', 'EURO', '531', '229858', '50', '32785');
INSERT INTO public.who_global_data_import VALUES (41345, '2020-05-26', 'IT', 'Italy', 'EURO', '300', '230158', '92', '32877');
INSERT INTO public.who_global_data_import VALUES (41346, '2020-05-27', 'IT', 'Italy', 'EURO', '397', '230555', '78', '32955');
INSERT INTO public.who_global_data_import VALUES (41347, '2020-05-28', 'IT', 'Italy', 'EURO', '584', '231139', '117', '33072');
INSERT INTO public.who_global_data_import VALUES (41348, '2020-05-29', 'IT', 'Italy', 'EURO', '593', '231732', '70', '33142');
INSERT INTO public.who_global_data_import VALUES (41349, '2020-05-30', 'IT', 'Italy', 'EURO', '516', '232248', '87', '33229');
INSERT INTO public.who_global_data_import VALUES (41350, '2020-05-31', 'IT', 'Italy', 'EURO', '416', '232664', '111', '33340');
INSERT INTO public.who_global_data_import VALUES (41351, '2020-06-01', 'IT', 'Italy', 'EURO', '355', '233019', '75', '33415');
INSERT INTO public.who_global_data_import VALUES (41352, '2020-06-02', 'IT', 'Italy', 'EURO', '178', '233197', '60', '33475');
INSERT INTO public.who_global_data_import VALUES (41353, '2020-06-03', 'IT', 'Italy', 'EURO', '318', '233515', '55', '33530');
INSERT INTO public.who_global_data_import VALUES (41354, '2020-06-04', 'IT', 'Italy', 'EURO', '321', '233836', '71', '33601');
INSERT INTO public.who_global_data_import VALUES (41355, '2020-06-05', 'IT', 'Italy', 'EURO', '177', '234013', '88', '33689');
INSERT INTO public.who_global_data_import VALUES (41356, '2020-06-06', 'IT', 'Italy', 'EURO', '518', '234531', '85', '33774');
INSERT INTO public.who_global_data_import VALUES (41357, '2020-06-07', 'IT', 'Italy', 'EURO', '270', '234801', '72', '33846');
INSERT INTO public.who_global_data_import VALUES (41358, '2020-06-08', 'IT', 'Italy', 'EURO', '197', '234998', '53', '33899');
INSERT INTO public.who_global_data_import VALUES (41359, '2020-06-09', 'IT', 'Italy', 'EURO', '280', '235278', '65', '33964');
INSERT INTO public.who_global_data_import VALUES (41360, '2020-06-10', 'IT', 'Italy', 'EURO', '283', '235561', '79', '34043');
INSERT INTO public.who_global_data_import VALUES (41361, '2020-06-11', 'IT', 'Italy', 'EURO', '202', '235763', '71', '34114');
INSERT INTO public.who_global_data_import VALUES (41362, '2020-06-12', 'IT', 'Italy', 'EURO', '379', '236142', '53', '34167');
INSERT INTO public.who_global_data_import VALUES (41363, '2020-06-13', 'IT', 'Italy', 'EURO', '163', '236305', '56', '34223');
INSERT INTO public.who_global_data_import VALUES (41364, '2020-06-14', 'IT', 'Italy', 'EURO', '346', '236651', '78', '34301');
INSERT INTO public.who_global_data_import VALUES (41365, '2020-06-15', 'IT', 'Italy', 'EURO', '338', '236989', '44', '34345');
INSERT INTO public.who_global_data_import VALUES (41366, '2020-06-16', 'IT', 'Italy', 'EURO', '301', '237290', '26', '34371');
INSERT INTO public.who_global_data_import VALUES (41367, '2020-06-17', 'IT', 'Italy', 'EURO', '210', '237500', '34', '34405');
INSERT INTO public.who_global_data_import VALUES (41368, '2020-06-18', 'IT', 'Italy', 'EURO', '328', '237828', '43', '34448');
INSERT INTO public.who_global_data_import VALUES (41369, '2020-06-19', 'IT', 'Italy', 'EURO', '331', '238159', '66', '34514');
INSERT INTO public.who_global_data_import VALUES (41370, '2020-06-20', 'IT', 'Italy', 'EURO', '-148', '238011', '47', '34561');
INSERT INTO public.who_global_data_import VALUES (41371, '2020-06-21', 'IT', 'Italy', 'EURO', '264', '238275', '49', '34610');
INSERT INTO public.who_global_data_import VALUES (41372, '2020-06-22', 'IT', 'Italy', 'EURO', '224', '238499', '24', '34634');
INSERT INTO public.who_global_data_import VALUES (41373, '2020-06-23', 'IT', 'Italy', 'EURO', '221', '238720', '23', '34657');
INSERT INTO public.who_global_data_import VALUES (41374, '2020-06-24', 'IT', 'Italy', 'EURO', '113', '238833', '18', '34675');
INSERT INTO public.who_global_data_import VALUES (41375, '2020-06-25', 'IT', 'Italy', 'EURO', '577', '239410', '-31', '34644');
INSERT INTO public.who_global_data_import VALUES (41376, '2020-06-26', 'IT', 'Italy', 'EURO', '296', '239706', '34', '34678');
INSERT INTO public.who_global_data_import VALUES (41377, '2020-06-27', 'IT', 'Italy', 'EURO', '255', '239961', '30', '34708');
INSERT INTO public.who_global_data_import VALUES (41378, '2020-06-28', 'IT', 'Italy', 'EURO', '175', '240136', '8', '34716');
INSERT INTO public.who_global_data_import VALUES (41379, '2020-06-29', 'IT', 'Italy', 'EURO', '174', '240310', '22', '34738');
INSERT INTO public.who_global_data_import VALUES (41380, '2020-06-30', 'IT', 'Italy', 'EURO', '126', '240436', '6', '34744');
INSERT INTO public.who_global_data_import VALUES (41381, '2020-07-01', 'IT', 'Italy', 'EURO', '142', '240578', '23', '34767');
INSERT INTO public.who_global_data_import VALUES (41382, '2020-07-02', 'IT', 'Italy', 'EURO', '182', '240760', '21', '34788');
INSERT INTO public.who_global_data_import VALUES (41383, '2020-07-03', 'IT', 'Italy', 'EURO', '201', '240961', '30', '34818');
INSERT INTO public.who_global_data_import VALUES (41384, '2020-07-04', 'IT', 'Italy', 'EURO', '223', '241184', '15', '34833');
INSERT INTO public.who_global_data_import VALUES (41385, '2020-07-05', 'IT', 'Italy', 'EURO', '235', '241419', '21', '34854');
INSERT INTO public.who_global_data_import VALUES (41386, '2020-07-06', 'IT', 'Italy', 'EURO', '192', '241611', '7', '34861');
INSERT INTO public.who_global_data_import VALUES (41387, '2020-07-07', 'IT', 'Italy', 'EURO', '208', '241819', '8', '34869');
INSERT INTO public.who_global_data_import VALUES (41388, '2020-07-08', 'IT', 'Italy', 'EURO', '137', '241956', '30', '34899');
INSERT INTO public.who_global_data_import VALUES (41389, '2020-07-09', 'IT', 'Italy', 'EURO', '193', '242149', '15', '34914');
INSERT INTO public.who_global_data_import VALUES (41390, '2020-07-10', 'IT', 'Italy', 'EURO', '214', '242363', '12', '34926');
INSERT INTO public.who_global_data_import VALUES (41391, '2020-07-11', 'IT', 'Italy', 'EURO', '276', '242639', '12', '34938');
INSERT INTO public.who_global_data_import VALUES (41392, '2020-07-12', 'IT', 'Italy', 'EURO', '188', '242827', '7', '34945');
INSERT INTO public.who_global_data_import VALUES (41393, '2020-07-13', 'IT', 'Italy', 'EURO', '234', '243061', '9', '34954');
INSERT INTO public.who_global_data_import VALUES (41394, '2020-07-14', 'IT', 'Italy', 'EURO', '169', '243230', '13', '34967');
INSERT INTO public.who_global_data_import VALUES (41395, '2020-07-15', 'IT', 'Italy', 'EURO', '114', '243344', '17', '34984');
INSERT INTO public.who_global_data_import VALUES (41396, '2020-07-16', 'IT', 'Italy', 'EURO', '162', '243506', '13', '34997');
INSERT INTO public.who_global_data_import VALUES (41397, '2020-07-17', 'IT', 'Italy', 'EURO', '230', '243736', '20', '35017');
INSERT INTO public.who_global_data_import VALUES (41398, '2020-07-18', 'IT', 'Italy', 'EURO', '231', '243967', '11', '35028');
INSERT INTO public.who_global_data_import VALUES (41399, '2020-07-19', 'IT', 'Italy', 'EURO', '249', '244216', '14', '35042');
INSERT INTO public.who_global_data_import VALUES (41400, '2020-07-20', 'IT', 'Italy', 'EURO', '218', '244434', '3', '35045');
INSERT INTO public.who_global_data_import VALUES (41401, '2020-07-21', 'IT', 'Italy', 'EURO', '190', '244624', '13', '35058');
INSERT INTO public.who_global_data_import VALUES (41402, '2020-07-22', 'IT', 'Italy', 'EURO', '128', '244752', '15', '35073');
INSERT INTO public.who_global_data_import VALUES (41403, '2020-07-23', 'IT', 'Italy', 'EURO', '280', '245032', '9', '35082');
INSERT INTO public.who_global_data_import VALUES (41404, '2020-07-24', 'IT', 'Italy', 'EURO', '306', '245338', '10', '35092');
INSERT INTO public.who_global_data_import VALUES (41405, '2020-07-25', 'IT', 'Italy', 'EURO', '252', '245590', '5', '35097');
INSERT INTO public.who_global_data_import VALUES (41406, '2020-07-26', 'IT', 'Italy', 'EURO', '274', '245864', '5', '35102');
INSERT INTO public.who_global_data_import VALUES (41407, '2020-07-27', 'IT', 'Italy', 'EURO', '254', '246118', '5', '35107');
INSERT INTO public.who_global_data_import VALUES (41408, '2020-07-28', 'IT', 'Italy', 'EURO', '168', '246286', '5', '35112');
INSERT INTO public.who_global_data_import VALUES (41409, '2020-07-29', 'IT', 'Italy', 'EURO', '202', '246488', '11', '35123');
INSERT INTO public.who_global_data_import VALUES (41410, '2020-07-30', 'IT', 'Italy', 'EURO', '288', '246776', '6', '35129');
INSERT INTO public.who_global_data_import VALUES (41411, '2020-07-31', 'IT', 'Italy', 'EURO', '382', '247158', '3', '35132');
INSERT INTO public.who_global_data_import VALUES (41412, '2020-08-01', 'IT', 'Italy', 'EURO', '379', '247537', '9', '35141');
INSERT INTO public.who_global_data_import VALUES (41413, '2020-08-02', 'IT', 'Italy', 'EURO', '295', '247832', '5', '35146');
INSERT INTO public.who_global_data_import VALUES (41414, '2020-08-03', 'IT', 'Italy', 'EURO', '238', '248070', '8', '35154');
INSERT INTO public.who_global_data_import VALUES (41415, '2020-08-04', 'IT', 'Italy', 'EURO', '159', '248229', '12', '35166');
INSERT INTO public.who_global_data_import VALUES (41416, '2020-08-05', 'IT', 'Italy', 'EURO', '190', '248419', '5', '35171');
INSERT INTO public.who_global_data_import VALUES (41417, '2020-08-06', 'IT', 'Italy', 'EURO', '384', '248803', '10', '35181');
INSERT INTO public.who_global_data_import VALUES (41418, '2020-08-07', 'IT', 'Italy', 'EURO', '401', '249204', '6', '35187');
INSERT INTO public.who_global_data_import VALUES (41419, '2020-08-08', 'IT', 'Italy', 'EURO', '552', '249756', '3', '35190');
INSERT INTO public.who_global_data_import VALUES (41420, '2020-08-09', 'IT', 'Italy', 'EURO', '347', '250103', '13', '35203');
INSERT INTO public.who_global_data_import VALUES (41421, '2020-08-10', 'IT', 'Italy', 'EURO', '463', '250566', '2', '35205');
INSERT INTO public.who_global_data_import VALUES (41422, '2020-08-11', 'IT', 'Italy', 'EURO', '259', '250825', '4', '35209');
INSERT INTO public.who_global_data_import VALUES (41423, '2020-08-12', 'IT', 'Italy', 'EURO', '412', '251237', '6', '35215');
INSERT INTO public.who_global_data_import VALUES (41424, '2020-08-13', 'IT', 'Italy', 'EURO', '476', '251713', '10', '35225');
INSERT INTO public.who_global_data_import VALUES (41425, '2020-08-14', 'IT', 'Italy', 'EURO', '522', '252235', '6', '35231');
INSERT INTO public.who_global_data_import VALUES (41426, '2020-08-15', 'IT', 'Italy', 'EURO', '574', '252809', '3', '35234');
INSERT INTO public.who_global_data_import VALUES (41427, '2020-08-16', 'IT', 'Italy', 'EURO', '629', '253438', '158', '35392');
INSERT INTO public.who_global_data_import VALUES (41428, '2020-08-17', 'IT', 'Italy', 'EURO', '477', '253915', '4', '35396');
INSERT INTO public.who_global_data_import VALUES (41429, '2020-08-18', 'IT', 'Italy', 'EURO', '320', '254235', '4', '35400');
INSERT INTO public.who_global_data_import VALUES (41430, '2020-08-19', 'IT', 'Italy', 'EURO', '401', '254636', '5', '35405');
INSERT INTO public.who_global_data_import VALUES (41431, '2020-08-20', 'IT', 'Italy', 'EURO', '642', '255278', '7', '35412');
INSERT INTO public.who_global_data_import VALUES (41432, '2020-08-21', 'IT', 'Italy', 'EURO', '840', '256118', '6', '35418');
INSERT INTO public.who_global_data_import VALUES (41433, '2020-08-22', 'IT', 'Italy', 'EURO', '947', '257065', '9', '35427');
INSERT INTO public.who_global_data_import VALUES (41434, '2020-08-23', 'IT', 'Italy', 'EURO', '1071', '258136', '3', '35430');
INSERT INTO public.who_global_data_import VALUES (41435, '2020-08-24', 'IT', 'Italy', 'EURO', '1209', '259345', '7', '35437');
INSERT INTO public.who_global_data_import VALUES (41436, '2020-08-25', 'IT', 'Italy', 'EURO', '953', '260298', '4', '35441');
INSERT INTO public.who_global_data_import VALUES (41437, '2020-08-26', 'IT', 'Italy', 'EURO', '876', '261174', '4', '35445');
INSERT INTO public.who_global_data_import VALUES (41438, '2020-08-27', 'IT', 'Italy', 'EURO', '1366', '262540', '13', '35458');
INSERT INTO public.who_global_data_import VALUES (41439, '2020-08-28', 'IT', 'Italy', 'EURO', '1409', '263949', '5', '35463');
INSERT INTO public.who_global_data_import VALUES (41440, '2020-08-29', 'IT', 'Italy', 'EURO', '1460', '265409', '9', '35472');
INSERT INTO public.who_global_data_import VALUES (41441, '2020-08-30', 'IT', 'Italy', 'EURO', '1444', '266853', '1', '35473');
INSERT INTO public.who_global_data_import VALUES (41442, '2020-08-31', 'IT', 'Italy', 'EURO', '1365', '268218', '4', '35477');
INSERT INTO public.who_global_data_import VALUES (41443, '2020-09-01', 'IT', 'Italy', 'EURO', '996', '269214', '6', '35483');
INSERT INTO public.who_global_data_import VALUES (41444, '2020-09-02', 'IT', 'Italy', 'EURO', '975', '270189', '8', '35491');
INSERT INTO public.who_global_data_import VALUES (41445, '2020-09-03', 'IT', 'Italy', 'EURO', '1326', '271515', '6', '35497');
INSERT INTO public.who_global_data_import VALUES (41446, '2020-09-04', 'IT', 'Italy', 'EURO', '1397', '272912', '10', '35507');
INSERT INTO public.who_global_data_import VALUES (41447, '2020-09-05', 'IT', 'Italy', 'EURO', '1732', '274644', '11', '35518');
INSERT INTO public.who_global_data_import VALUES (41448, '2020-09-06', 'IT', 'Italy', 'EURO', '1694', '276338', '16', '35534');
INSERT INTO public.who_global_data_import VALUES (41449, '2020-09-07', 'IT', 'Italy', 'EURO', '1296', '277634', '7', '35541');
INSERT INTO public.who_global_data_import VALUES (41450, '2020-09-08', 'IT', 'Italy', 'EURO', '1150', '278784', '12', '35553');
INSERT INTO public.who_global_data_import VALUES (41451, '2020-09-09', 'IT', 'Italy', 'EURO', '1369', '280153', '10', '35563');
INSERT INTO public.who_global_data_import VALUES (41452, '2020-09-10', 'IT', 'Italy', 'EURO', '1430', '281583', '14', '35577');
INSERT INTO public.who_global_data_import VALUES (41453, '2020-09-11', 'IT', 'Italy', 'EURO', '1597', '283180', '10', '35587');
INSERT INTO public.who_global_data_import VALUES (41454, '2020-09-12', 'IT', 'Italy', 'EURO', '1616', '284796', '10', '35597');
INSERT INTO public.who_global_data_import VALUES (41455, '2020-09-13', 'IT', 'Italy', 'EURO', '1501', '286297', '6', '35603');
INSERT INTO public.who_global_data_import VALUES (41456, '2020-09-14', 'IT', 'Italy', 'EURO', '1456', '287753', '7', '35610');
INSERT INTO public.who_global_data_import VALUES (41457, '2020-09-15', 'IT', 'Italy', 'EURO', '1008', '288761', '14', '35624');
INSERT INTO public.who_global_data_import VALUES (41458, '2020-09-16', 'IT', 'Italy', 'EURO', '1229', '289990', '9', '35633');
INSERT INTO public.who_global_data_import VALUES (41459, '2020-09-17', 'IT', 'Italy', 'EURO', '1452', '291442', '12', '35645');
INSERT INTO public.who_global_data_import VALUES (41460, '2020-09-18', 'IT', 'Italy', 'EURO', '1583', '293025', '13', '35658');
INSERT INTO public.who_global_data_import VALUES (41461, '2020-09-19', 'IT', 'Italy', 'EURO', '1907', '294932', '10', '35668');
INSERT INTO public.who_global_data_import VALUES (41462, '2020-09-20', 'IT', 'Italy', 'EURO', '1637', '296569', '24', '35692');
INSERT INTO public.who_global_data_import VALUES (41463, '2020-09-21', 'IT', 'Italy', 'EURO', '1587', '298156', '15', '35707');
INSERT INTO public.who_global_data_import VALUES (41464, '2020-09-22', 'IT', 'Italy', 'EURO', '1350', '299506', '17', '35724');
INSERT INTO public.who_global_data_import VALUES (41465, '2020-09-23', 'IT', 'Italy', 'EURO', '1391', '300897', '14', '35738');
INSERT INTO public.who_global_data_import VALUES (41466, '2020-09-24', 'IT', 'Italy', 'EURO', '1640', '302537', '20', '35758');
INSERT INTO public.who_global_data_import VALUES (41467, '2020-09-25', 'IT', 'Italy', 'EURO', '1786', '304323', '23', '35781');
INSERT INTO public.who_global_data_import VALUES (41468, '2020-09-26', 'IT', 'Italy', 'EURO', '1912', '306235', '20', '35801');
INSERT INTO public.who_global_data_import VALUES (41469, '2020-09-27', 'IT', 'Italy', 'EURO', '1869', '308104', '17', '35818');
INSERT INTO public.who_global_data_import VALUES (41470, '2020-09-28', 'IT', 'Italy', 'EURO', '1766', '309870', '17', '35835');
INSERT INTO public.who_global_data_import VALUES (41471, '2020-09-29', 'IT', 'Italy', 'EURO', '1494', '311364', '16', '35851');
INSERT INTO public.who_global_data_import VALUES (41472, '2020-09-30', 'IT', 'Italy', 'EURO', '1647', '313011', '24', '35875');
INSERT INTO public.who_global_data_import VALUES (41473, '2020-10-01', 'IT', 'Italy', 'EURO', '1850', '314861', '19', '35894');
INSERT INTO public.who_global_data_import VALUES (41474, '2020-10-02', 'IT', 'Italy', 'EURO', '2548', '317409', '24', '35918');
INSERT INTO public.who_global_data_import VALUES (41475, '2020-10-03', 'IT', 'Italy', 'EURO', '2499', '319908', '23', '35941');
INSERT INTO public.who_global_data_import VALUES (41476, '2020-10-04', 'IT', 'Italy', 'EURO', '2843', '322751', '27', '35968');
INSERT INTO public.who_global_data_import VALUES (41477, '2020-10-05', 'IT', 'Italy', 'EURO', '2578', '325329', '18', '35986');
INSERT INTO public.who_global_data_import VALUES (41478, '2020-10-06', 'IT', 'Italy', 'EURO', '2257', '327586', '16', '36002');
INSERT INTO public.who_global_data_import VALUES (41479, '2020-10-07', 'IT', 'Italy', 'EURO', '2677', '330263', '28', '36030');
INSERT INTO public.who_global_data_import VALUES (41480, '2020-10-08', 'IT', 'Italy', 'EURO', '3677', '333940', '31', '36061');
INSERT INTO public.who_global_data_import VALUES (41481, '2020-10-09', 'IT', 'Italy', 'EURO', '4458', '338398', '22', '36083');
INSERT INTO public.who_global_data_import VALUES (41482, '2020-10-10', 'IT', 'Italy', 'EURO', '5372', '343770', '28', '36111');
INSERT INTO public.who_global_data_import VALUES (41483, '2020-10-11', 'IT', 'Italy', 'EURO', '5724', '349494', '29', '36140');
INSERT INTO public.who_global_data_import VALUES (41484, '2020-10-12', 'IT', 'Italy', 'EURO', '5456', '354950', '26', '36166');
INSERT INTO public.who_global_data_import VALUES (41485, '2020-10-13', 'IT', 'Italy', 'EURO', '4619', '359569', '39', '36205');
INSERT INTO public.who_global_data_import VALUES (41486, '2020-10-14', 'IT', 'Italy', 'EURO', '5898', '365467', '41', '36246');
INSERT INTO public.who_global_data_import VALUES (41487, '2020-10-15', 'IT', 'Italy', 'EURO', '7332', '372799', '43', '36289');
INSERT INTO public.who_global_data_import VALUES (41488, '2020-10-16', 'IT', 'Italy', 'EURO', '8803', '381602', '83', '36372');
INSERT INTO public.who_global_data_import VALUES (41489, '2020-10-17', 'IT', 'Italy', 'EURO', '10009', '391611', '55', '36427');
INSERT INTO public.who_global_data_import VALUES (41490, '2020-10-18', 'IT', 'Italy', 'EURO', '10925', '402536', '47', '36474');
INSERT INTO public.who_global_data_import VALUES (41491, '2020-10-19', 'IT', 'Italy', 'EURO', '11705', '414241', '69', '36543');
INSERT INTO public.who_global_data_import VALUES (41492, '2020-10-20', 'IT', 'Italy', 'EURO', '9337', '423578', '73', '36616');
INSERT INTO public.who_global_data_import VALUES (41493, '2020-10-21', 'IT', 'Italy', 'EURO', '10871', '434449', '89', '36705');
INSERT INTO public.who_global_data_import VALUES (41494, '2020-10-22', 'IT', 'Italy', 'EURO', '15199', '449648', '127', '36832');
INSERT INTO public.who_global_data_import VALUES (41495, '2020-10-23', 'IT', 'Italy', 'EURO', '16078', '465726', '136', '36968');
INSERT INTO public.who_global_data_import VALUES (41496, '2020-10-24', 'IT', 'Italy', 'EURO', '19143', '484869', '91', '37059');
INSERT INTO public.who_global_data_import VALUES (41497, '2020-10-25', 'IT', 'Italy', 'EURO', '19640', '504509', '151', '37210');
INSERT INTO public.who_global_data_import VALUES (41498, '2020-10-26', 'IT', 'Italy', 'EURO', '21273', '525782', '128', '37338');
INSERT INTO public.who_global_data_import VALUES (41499, '2020-10-27', 'IT', 'Italy', 'EURO', '17007', '542789', '141', '37479');
INSERT INTO public.who_global_data_import VALUES (41500, '2020-10-28', 'IT', 'Italy', 'EURO', '21989', '564778', '221', '37700');
INSERT INTO public.who_global_data_import VALUES (41501, '2020-10-29', 'IT', 'Italy', 'EURO', '24988', '589766', '205', '37905');
INSERT INTO public.who_global_data_import VALUES (41502, '2020-10-30', 'IT', 'Italy', 'EURO', '26829', '616595', '217', '38122');
INSERT INTO public.who_global_data_import VALUES (41503, '2020-10-31', 'IT', 'Italy', 'EURO', '31079', '647674', '199', '38321');
INSERT INTO public.who_global_data_import VALUES (41504, '2020-11-01', 'IT', 'Italy', 'EURO', '31756', '679430', '297', '38618');
INSERT INTO public.who_global_data_import VALUES (41505, '2020-11-02', 'IT', 'Italy', 'EURO', '29905', '709335', '208', '38826');
INSERT INTO public.who_global_data_import VALUES (41506, '2020-11-03', 'IT', 'Italy', 'EURO', '22253', '731588', '233', '39059');
INSERT INTO public.who_global_data_import VALUES (41507, '2020-11-04', 'IT', 'Italy', 'EURO', '28241', '759829', '353', '39412');
INSERT INTO public.who_global_data_import VALUES (41508, '2020-11-05', 'IT', 'Italy', 'EURO', '30548', '790377', '352', '39764');
INSERT INTO public.who_global_data_import VALUES (41509, '2020-11-06', 'IT', 'Italy', 'EURO', '34502', '824879', '428', '40192');
INSERT INTO public.who_global_data_import VALUES (41510, '2020-11-07', 'IT', 'Italy', 'EURO', '37802', '862681', '446', '40638');
INSERT INTO public.who_global_data_import VALUES (41511, '2020-11-08', 'IT', 'Italy', 'EURO', '39809', '902490', '425', '41063');
INSERT INTO public.who_global_data_import VALUES (41512, '2020-11-09', 'IT', 'Italy', 'EURO', '32614', '935104', '331', '41394');
INSERT INTO public.who_global_data_import VALUES (41513, '2020-11-10', 'IT', 'Italy', 'EURO', '25269', '960373', '356', '41750');
INSERT INTO public.who_global_data_import VALUES (41514, '2020-11-11', 'IT', 'Italy', 'EURO', '35090', '995463', '580', '42330');
INSERT INTO public.who_global_data_import VALUES (41515, '2020-11-12', 'IT', 'Italy', 'EURO', '32961', '1028424', '623', '42953');
INSERT INTO public.who_global_data_import VALUES (41516, '2020-11-13', 'IT', 'Italy', 'EURO', '37977', '1066401', '636', '43589');
INSERT INTO public.who_global_data_import VALUES (41517, '2020-11-14', 'IT', 'Italy', 'EURO', '40902', '1107303', '550', '44139');
INSERT INTO public.who_global_data_import VALUES (41518, '2020-11-15', 'IT', 'Italy', 'EURO', '37249', '1144552', '544', '44683');
INSERT INTO public.who_global_data_import VALUES (41519, '2020-11-16', 'IT', 'Italy', 'EURO', '33977', '1178529', '546', '45229');
INSERT INTO public.who_global_data_import VALUES (41520, '2020-11-17', 'IT', 'Italy', 'EURO', '27352', '1205881', '504', '45733');
INSERT INTO public.who_global_data_import VALUES (41521, '2020-11-18', 'IT', 'Italy', 'EURO', '32191', '1238072', '731', '46464');
INSERT INTO public.who_global_data_import VALUES (41522, '2020-11-19', 'IT', 'Italy', 'EURO', '34280', '1272352', '753', '47217');
INSERT INTO public.who_global_data_import VALUES (41523, '2020-11-20', 'IT', 'Italy', 'EURO', '36176', '1308528', '653', '47870');
INSERT INTO public.who_global_data_import VALUES (41524, '2020-11-21', 'IT', 'Italy', 'EURO', '37239', '1345767', '699', '48569');
INSERT INTO public.who_global_data_import VALUES (41525, '2020-11-22', 'IT', 'Italy', 'EURO', '34764', '1380531', '692', '49261');
INSERT INTO public.who_global_data_import VALUES (41526, '2020-11-23', 'IT', 'Italy', 'EURO', '28337', '1408868', '562', '49823');
INSERT INTO public.who_global_data_import VALUES (41527, '2020-11-24', 'IT', 'Italy', 'EURO', '22927', '1431795', '630', '50453');
INSERT INTO public.who_global_data_import VALUES (41528, '2020-11-25', 'IT', 'Italy', 'EURO', '23227', '1455022', '853', '51306');
INSERT INTO public.who_global_data_import VALUES (41529, '2020-11-26', 'IT', 'Italy', 'EURO', '25852', '1480874', '722', '52028');
INSERT INTO public.who_global_data_import VALUES (41530, '2020-11-27', 'IT', 'Italy', 'EURO', '29001', '1509875', '822', '52850');
INSERT INTO public.who_global_data_import VALUES (41531, '2020-11-28', 'IT', 'Italy', 'EURO', '28342', '1538217', '827', '53677');
INSERT INTO public.who_global_data_import VALUES (41532, '2020-11-29', 'IT', 'Italy', 'EURO', '26315', '1564532', '686', '54363');
INSERT INTO public.who_global_data_import VALUES (41533, '2020-11-30', 'IT', 'Italy', 'EURO', '20646', '1585178', '541', '54904');
INSERT INTO public.who_global_data_import VALUES (41534, '2020-12-01', 'IT', 'Italy', 'EURO', '16376', '1601554', '672', '55576');
INSERT INTO public.who_global_data_import VALUES (41535, '2020-12-02', 'IT', 'Italy', 'EURO', '19347', '1620901', '785', '56361');
INSERT INTO public.who_global_data_import VALUES (41536, '2020-12-03', 'IT', 'Italy', 'EURO', '20709', '1641610', '684', '57045');
INSERT INTO public.who_global_data_import VALUES (41537, '2020-12-04', 'IT', 'Italy', 'EURO', '23219', '1664829', '993', '58038');
INSERT INTO public.who_global_data_import VALUES (41538, '2020-12-05', 'IT', 'Italy', 'EURO', '24110', '1688939', '814', '58852');
INSERT INTO public.who_global_data_import VALUES (41539, '2020-12-06', 'IT', 'Italy', 'EURO', '21052', '1709991', '662', '59514');
INSERT INTO public.who_global_data_import VALUES (41540, '2020-12-07', 'IT', 'Italy', 'EURO', '18887', '1728878', '564', '60078');
INSERT INTO public.who_global_data_import VALUES (41541, '2020-12-08', 'IT', 'Italy', 'EURO', '13679', '1742557', '528', '60606');
INSERT INTO public.who_global_data_import VALUES (41542, '2020-12-09', 'IT', 'Italy', 'EURO', '14837', '1757394', '634', '61240');
INSERT INTO public.who_global_data_import VALUES (41543, '2020-12-10', 'IT', 'Italy', 'EURO', '12755', '1770149', '499', '61739');
INSERT INTO public.who_global_data_import VALUES (41544, '2020-12-11', 'IT', 'Italy', 'EURO', '16998', '1787147', '887', '62626');
INSERT INTO public.who_global_data_import VALUES (41545, '2020-12-12', 'IT', 'Italy', 'EURO', '18726', '1805873', '761', '63387');
INSERT INTO public.who_global_data_import VALUES (41546, '2020-12-13', 'IT', 'Italy', 'EURO', '19902', '1825775', '649', '64036');
INSERT INTO public.who_global_data_import VALUES (41547, '2020-12-14', 'IT', 'Italy', 'EURO', '17937', '1843712', '484', '64520');
INSERT INTO public.who_global_data_import VALUES (41548, '2020-12-15', 'IT', 'Italy', 'EURO', '12025', '1855737', '491', '65011');
INSERT INTO public.who_global_data_import VALUES (41549, '2020-12-16', 'IT', 'Italy', 'EURO', '14839', '1870576', '846', '65857');
INSERT INTO public.who_global_data_import VALUES (41550, '2020-12-17', 'IT', 'Italy', 'EURO', '17568', '1888144', '680', '66537');
INSERT INTO public.who_global_data_import VALUES (41551, '2020-12-18', 'IT', 'Italy', 'EURO', '18233', '1906377', '683', '67220');
INSERT INTO public.who_global_data_import VALUES (41552, '2020-12-19', 'IT', 'Italy', 'EURO', '15401', '1921778', '674', '67894');
INSERT INTO public.who_global_data_import VALUES (41553, '2020-12-20', 'IT', 'Italy', 'EURO', '16305', '1938083', '553', '68447');
INSERT INTO public.who_global_data_import VALUES (41554, '2020-12-21', 'IT', 'Italy', 'EURO', '15102', '1953185', '352', '68799');
INSERT INTO public.who_global_data_import VALUES (41555, '2020-12-22', 'IT', 'Italy', 'EURO', '10869', '1964054', '415', '69214');
INSERT INTO public.who_global_data_import VALUES (41556, '2020-12-23', 'IT', 'Italy', 'EURO', '13316', '1977370', '628', '69842');
INSERT INTO public.who_global_data_import VALUES (41557, '2020-12-24', 'IT', 'Italy', 'EURO', '13908', '1991278', '553', '70395');
INSERT INTO public.who_global_data_import VALUES (41558, '2020-12-25', 'IT', 'Italy', 'EURO', '18039', '2009317', '505', '70900');
INSERT INTO public.who_global_data_import VALUES (41559, '2020-12-26', 'IT', 'Italy', 'EURO', '19037', '2028354', '459', '71359');
INSERT INTO public.who_global_data_import VALUES (41560, '2020-12-27', 'IT', 'Italy', 'EURO', '10405', '2038759', '261', '71620');
INSERT INTO public.who_global_data_import VALUES (41561, '2020-12-28', 'IT', 'Italy', 'EURO', '8937', '2047696', '305', '71925');
INSERT INTO public.who_global_data_import VALUES (41562, '2020-12-29', 'IT', 'Italy', 'EURO', '8581', '2056277', '445', '72370');
INSERT INTO public.who_global_data_import VALUES (41563, '2020-12-30', 'IT', 'Italy', 'EURO', '11210', '2067487', '659', '73029');
INSERT INTO public.who_global_data_import VALUES (41564, '2020-12-31', 'IT', 'Italy', 'EURO', '16202', '2083689', '575', '73604');
INSERT INTO public.who_global_data_import VALUES (41565, '2021-01-01', 'IT', 'Italy', 'EURO', '23477', '2107166', '555', '74159');
INSERT INTO public.who_global_data_import VALUES (41566, '2021-01-02', 'IT', 'Italy', 'EURO', '22210', '2129376', '462', '74621');
INSERT INTO public.who_global_data_import VALUES (41567, '2021-01-03', 'IT', 'Italy', 'EURO', '11825', '2141201', '364', '74985');
INSERT INTO public.who_global_data_import VALUES (41568, '2021-01-04', 'IT', 'Italy', 'EURO', '14245', '2155446', '347', '75332');
INSERT INTO public.who_global_data_import VALUES (41569, '2021-01-05', 'IT', 'Italy', 'EURO', '10798', '2166244', '348', '75680');
INSERT INTO public.who_global_data_import VALUES (41570, '2021-01-06', 'IT', 'Italy', 'EURO', '15375', '2181619', '649', '76329');
INSERT INTO public.who_global_data_import VALUES (41571, '2021-01-07', 'IT', 'Italy', 'EURO', '20326', '2201945', '548', '76877');
INSERT INTO public.who_global_data_import VALUES (41572, '2021-01-08', 'IT', 'Italy', 'EURO', '18416', '2220361', '414', '77291');
INSERT INTO public.who_global_data_import VALUES (41573, '2021-01-09', 'IT', 'Italy', 'EURO', '17529', '2237890', '620', '77911');
INSERT INTO public.who_global_data_import VALUES (41574, '2021-01-10', 'IT', 'Italy', 'EURO', '19976', '2257866', '483', '78394');
INSERT INTO public.who_global_data_import VALUES (41575, '2021-01-11', 'IT', 'Italy', 'EURO', '18625', '2276491', '361', '78755');
INSERT INTO public.who_global_data_import VALUES (41576, '2021-01-12', 'IT', 'Italy', 'EURO', '12530', '2289021', '448', '79203');
INSERT INTO public.who_global_data_import VALUES (41577, '2021-01-13', 'IT', 'Italy', 'EURO', '14242', '2303263', '616', '79819');
INSERT INTO public.who_global_data_import VALUES (41578, '2021-01-14', 'IT', 'Italy', 'EURO', '15773', '2319036', '507', '80326');
INSERT INTO public.who_global_data_import VALUES (41579, '2021-01-15', 'IT', 'Italy', 'EURO', '17243', '2336279', '522', '80848');
INSERT INTO public.who_global_data_import VALUES (41580, '2021-01-16', 'IT', 'Italy', 'EURO', '16144', '2352423', '477', '81325');
INSERT INTO public.who_global_data_import VALUES (41581, '2021-01-17', 'IT', 'Italy', 'EURO', '16310', '2368733', '475', '81800');
INSERT INTO public.who_global_data_import VALUES (41582, '2021-01-18', 'IT', 'Italy', 'EURO', '12544', '2381277', '377', '82177');
INSERT INTO public.who_global_data_import VALUES (41583, '2021-01-19', 'IT', 'Italy', 'EURO', '8825', '2390102', '377', '82554');
INSERT INTO public.who_global_data_import VALUES (41584, '2021-01-20', 'IT', 'Italy', 'EURO', '10496', '2400598', '603', '83157');
INSERT INTO public.who_global_data_import VALUES (41585, '2021-01-21', 'IT', 'Italy', 'EURO', '13568', '2414166', '524', '83681');
INSERT INTO public.who_global_data_import VALUES (41586, '2021-01-22', 'IT', 'Italy', 'EURO', '14055', '2428221', '521', '84202');
INSERT INTO public.who_global_data_import VALUES (41587, '2021-01-23', 'IT', 'Italy', 'EURO', '13633', '2441854', '472', '84674');
INSERT INTO public.who_global_data_import VALUES (41588, '2021-01-24', 'IT', 'Italy', 'EURO', '13331', '2455185', '488', '85162');
INSERT INTO public.who_global_data_import VALUES (41589, '2021-01-25', 'IT', 'Italy', 'EURO', '11628', '2466813', '299', '85461');
INSERT INTO public.who_global_data_import VALUES (41590, '2021-01-26', 'IT', 'Italy', 'EURO', '8559', '2475372', '420', '85881');
INSERT INTO public.who_global_data_import VALUES (41591, '2021-01-27', 'IT', 'Italy', 'EURO', '10584', '2485956', '541', '86422');
INSERT INTO public.who_global_data_import VALUES (41592, '2021-01-28', 'IT', 'Italy', 'EURO', '15191', '2501147', '467', '86889');
INSERT INTO public.who_global_data_import VALUES (41593, '2021-01-29', 'IT', 'Italy', 'EURO', '14360', '2515507', '492', '87381');
INSERT INTO public.who_global_data_import VALUES (41594, '2021-01-30', 'IT', 'Italy', 'EURO', '13563', '2529070', '477', '87858');
INSERT INTO public.who_global_data_import VALUES (41595, '2021-01-31', 'IT', 'Italy', 'EURO', '12713', '2541783', '421', '88279');
INSERT INTO public.who_global_data_import VALUES (41596, '2021-02-01', 'IT', 'Italy', 'EURO', '11249', '2553032', '237', '88516');
INSERT INTO public.who_global_data_import VALUES (41597, '2021-02-02', 'IT', 'Italy', 'EURO', '7925', '2560957', '329', '88845');
INSERT INTO public.who_global_data_import VALUES (41598, '2021-02-03', 'IT', 'Italy', 'EURO', '9651', '2570608', '499', '89344');
INSERT INTO public.who_global_data_import VALUES (41599, '2021-02-04', 'IT', 'Italy', 'EURO', '13182', '2583790', '476', '89820');
INSERT INTO public.who_global_data_import VALUES (41600, '2021-02-05', 'IT', 'Italy', 'EURO', '13656', '2597446', '421', '90241');
INSERT INTO public.who_global_data_import VALUES (41601, '2020-01-03', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41602, '2020-01-04', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41603, '2020-01-05', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41604, '2020-01-06', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41605, '2020-01-07', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41606, '2020-01-08', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41607, '2020-01-09', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41608, '2020-01-10', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41609, '2020-01-11', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41610, '2020-01-12', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41611, '2020-01-13', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41612, '2020-01-14', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41613, '2020-01-15', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41614, '2020-01-16', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41615, '2020-01-17', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41616, '2020-01-18', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41617, '2020-01-19', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41618, '2020-01-20', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41619, '2020-01-21', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41620, '2020-01-22', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41621, '2020-01-23', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41622, '2020-01-24', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41623, '2020-01-25', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41624, '2020-01-26', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41625, '2020-01-27', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41626, '2020-01-28', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41627, '2020-01-29', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41628, '2020-01-30', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41629, '2020-01-31', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41630, '2020-02-01', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41631, '2020-02-02', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41632, '2020-02-03', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41633, '2020-02-04', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41634, '2020-02-05', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41635, '2020-02-06', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41636, '2020-02-07', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41637, '2020-02-08', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41638, '2020-02-09', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41639, '2020-02-10', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41640, '2020-02-11', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41641, '2020-02-12', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41642, '2020-02-13', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41643, '2020-02-14', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41644, '2020-02-15', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41645, '2020-02-16', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41646, '2020-02-17', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41647, '2020-02-18', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41648, '2020-02-19', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41649, '2020-02-20', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41650, '2020-02-21', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41651, '2020-02-22', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41652, '2020-02-23', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41653, '2020-02-24', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41654, '2020-02-25', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41655, '2020-02-26', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41656, '2020-02-27', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41657, '2020-02-28', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41658, '2020-02-29', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41659, '2020-03-01', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41660, '2020-03-02', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41661, '2020-03-03', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41662, '2020-03-04', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41663, '2020-03-05', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41664, '2020-03-06', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41665, '2020-03-07', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41666, '2020-03-08', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41667, '2020-03-09', 'JM', 'Jamaica', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41668, '2020-03-10', 'JM', 'Jamaica', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41669, '2020-03-11', 'JM', 'Jamaica', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41670, '2020-03-12', 'JM', 'Jamaica', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41671, '2020-03-13', 'JM', 'Jamaica', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41672, '2020-03-14', 'JM', 'Jamaica', 'AMRO', '6', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41673, '2020-03-15', 'JM', 'Jamaica', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41674, '2020-03-16', 'JM', 'Jamaica', 'AMRO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41675, '2020-03-17', 'JM', 'Jamaica', 'AMRO', '2', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41676, '2020-03-18', 'JM', 'Jamaica', 'AMRO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (41677, '2020-03-19', 'JM', 'Jamaica', 'AMRO', '-2', '15', '1', '1');
INSERT INTO public.who_global_data_import VALUES (41678, '2020-03-20', 'JM', 'Jamaica', 'AMRO', '1', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41679, '2020-03-21', 'JM', 'Jamaica', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41680, '2020-03-22', 'JM', 'Jamaica', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41681, '2020-03-23', 'JM', 'Jamaica', 'AMRO', '3', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41682, '2020-03-24', 'JM', 'Jamaica', 'AMRO', '2', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41683, '2020-03-25', 'JM', 'Jamaica', 'AMRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41684, '2020-03-26', 'JM', 'Jamaica', 'AMRO', '5', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41685, '2020-03-27', 'JM', 'Jamaica', 'AMRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41686, '2020-03-28', 'JM', 'Jamaica', 'AMRO', '0', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41687, '2020-03-29', 'JM', 'Jamaica', 'AMRO', '4', '30', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41688, '2020-03-30', 'JM', 'Jamaica', 'AMRO', '2', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41689, '2020-03-31', 'JM', 'Jamaica', 'AMRO', '4', '36', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41690, '2020-04-01', 'JM', 'Jamaica', 'AMRO', '0', '36', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41691, '2020-04-02', 'JM', 'Jamaica', 'AMRO', '2', '38', '0', '1');
INSERT INTO public.who_global_data_import VALUES (41692, '2020-04-03', 'JM', 'Jamaica', 'AMRO', '6', '44', '2', '3');
INSERT INTO public.who_global_data_import VALUES (41693, '2020-04-04', 'JM', 'Jamaica', 'AMRO', '3', '47', '0', '3');
INSERT INTO public.who_global_data_import VALUES (41694, '2020-04-05', 'JM', 'Jamaica', 'AMRO', '6', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (41695, '2020-04-06', 'JM', 'Jamaica', 'AMRO', '2', '55', '0', '3');
INSERT INTO public.who_global_data_import VALUES (41696, '2020-04-07', 'JM', 'Jamaica', 'AMRO', '3', '58', '0', '3');
INSERT INTO public.who_global_data_import VALUES (41697, '2020-04-08', 'JM', 'Jamaica', 'AMRO', '1', '59', '0', '3');
INSERT INTO public.who_global_data_import VALUES (41698, '2020-04-09', 'JM', 'Jamaica', 'AMRO', '4', '63', '0', '3');
INSERT INTO public.who_global_data_import VALUES (41699, '2020-04-10', 'JM', 'Jamaica', 'AMRO', '0', '63', '1', '4');
INSERT INTO public.who_global_data_import VALUES (41700, '2020-04-11', 'JM', 'Jamaica', 'AMRO', '0', '63', '0', '4');
INSERT INTO public.who_global_data_import VALUES (41701, '2020-04-12', 'JM', 'Jamaica', 'AMRO', '2', '65', '0', '4');
INSERT INTO public.who_global_data_import VALUES (41702, '2020-04-13', 'JM', 'Jamaica', 'AMRO', '4', '69', '0', '4');
INSERT INTO public.who_global_data_import VALUES (41703, '2020-04-14', 'JM', 'Jamaica', 'AMRO', '3', '72', '0', '4');
INSERT INTO public.who_global_data_import VALUES (41704, '2020-04-15', 'JM', 'Jamaica', 'AMRO', '1', '73', '0', '4');
INSERT INTO public.who_global_data_import VALUES (41705, '2020-04-16', 'JM', 'Jamaica', 'AMRO', '32', '105', '1', '5');
INSERT INTO public.who_global_data_import VALUES (41706, '2020-04-17', 'JM', 'Jamaica', 'AMRO', '20', '125', '0', '5');
INSERT INTO public.who_global_data_import VALUES (41707, '2020-04-18', 'JM', 'Jamaica', 'AMRO', '18', '143', '0', '5');
INSERT INTO public.who_global_data_import VALUES (41708, '2020-04-19', 'JM', 'Jamaica', 'AMRO', '20', '163', '0', '5');
INSERT INTO public.who_global_data_import VALUES (41709, '2020-04-20', 'JM', 'Jamaica', 'AMRO', '10', '173', '0', '5');
INSERT INTO public.who_global_data_import VALUES (41710, '2020-04-21', 'JM', 'Jamaica', 'AMRO', '23', '196', '0', '5');
INSERT INTO public.who_global_data_import VALUES (41711, '2020-04-22', 'JM', 'Jamaica', 'AMRO', '27', '223', '1', '6');
INSERT INTO public.who_global_data_import VALUES (41712, '2020-04-23', 'JM', 'Jamaica', 'AMRO', '10', '233', '0', '6');
INSERT INTO public.who_global_data_import VALUES (41713, '2020-04-24', 'JM', 'Jamaica', 'AMRO', '10', '243', '0', '6');
INSERT INTO public.who_global_data_import VALUES (41714, '2020-04-25', 'JM', 'Jamaica', 'AMRO', '14', '257', '1', '7');
INSERT INTO public.who_global_data_import VALUES (41715, '2020-04-26', 'JM', 'Jamaica', 'AMRO', '31', '288', '0', '7');
INSERT INTO public.who_global_data_import VALUES (41716, '2020-04-27', 'JM', 'Jamaica', 'AMRO', '17', '305', '0', '7');
INSERT INTO public.who_global_data_import VALUES (41717, '2020-04-28', 'JM', 'Jamaica', 'AMRO', '0', '305', '0', '7');
INSERT INTO public.who_global_data_import VALUES (41718, '2020-04-29', 'JM', 'Jamaica', 'AMRO', '59', '364', '0', '7');
INSERT INTO public.who_global_data_import VALUES (41719, '2020-04-30', 'JM', 'Jamaica', 'AMRO', '17', '381', '0', '7');
INSERT INTO public.who_global_data_import VALUES (41720, '2020-05-01', 'JM', 'Jamaica', 'AMRO', '15', '396', '0', '7');
INSERT INTO public.who_global_data_import VALUES (41721, '2020-05-02', 'JM', 'Jamaica', 'AMRO', '26', '422', '1', '8');
INSERT INTO public.who_global_data_import VALUES (41722, '2020-05-03', 'JM', 'Jamaica', 'AMRO', '10', '432', '0', '8');
INSERT INTO public.who_global_data_import VALUES (41723, '2020-05-04', 'JM', 'Jamaica', 'AMRO', '31', '463', '0', '8');
INSERT INTO public.who_global_data_import VALUES (41724, '2020-05-05', 'JM', 'Jamaica', 'AMRO', '6', '469', '1', '9');
INSERT INTO public.who_global_data_import VALUES (41725, '2020-05-06', 'JM', 'Jamaica', 'AMRO', '2', '471', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41726, '2020-05-07', 'JM', 'Jamaica', 'AMRO', '2', '473', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41727, '2020-05-08', 'JM', 'Jamaica', 'AMRO', '5', '478', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41728, '2020-05-09', 'JM', 'Jamaica', 'AMRO', '10', '488', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41729, '2020-05-10', 'JM', 'Jamaica', 'AMRO', '2', '490', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41730, '2020-05-11', 'JM', 'Jamaica', 'AMRO', '8', '498', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41731, '2020-05-12', 'JM', 'Jamaica', 'AMRO', '4', '502', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41732, '2020-05-13', 'JM', 'Jamaica', 'AMRO', '3', '505', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41733, '2020-05-14', 'JM', 'Jamaica', 'AMRO', '2', '507', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41734, '2020-05-15', 'JM', 'Jamaica', 'AMRO', '2', '509', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41735, '2020-05-16', 'JM', 'Jamaica', 'AMRO', '0', '509', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41736, '2020-05-17', 'JM', 'Jamaica', 'AMRO', '2', '511', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41737, '2020-05-18', 'JM', 'Jamaica', 'AMRO', '6', '517', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41738, '2020-05-19', 'JM', 'Jamaica', 'AMRO', '3', '520', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41739, '2020-05-20', 'JM', 'Jamaica', 'AMRO', '0', '520', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41740, '2020-05-21', 'JM', 'Jamaica', 'AMRO', '0', '520', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41741, '2020-05-22', 'JM', 'Jamaica', 'AMRO', '9', '529', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41742, '2020-05-23', 'JM', 'Jamaica', 'AMRO', '5', '534', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41743, '2020-05-24', 'JM', 'Jamaica', 'AMRO', '10', '544', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41744, '2020-05-25', 'JM', 'Jamaica', 'AMRO', '6', '550', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41745, '2020-05-26', 'JM', 'Jamaica', 'AMRO', '2', '552', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41746, '2020-05-27', 'JM', 'Jamaica', 'AMRO', '4', '556', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41747, '2020-05-28', 'JM', 'Jamaica', 'AMRO', '8', '564', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41748, '2020-05-29', 'JM', 'Jamaica', 'AMRO', '5', '569', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41749, '2020-05-30', 'JM', 'Jamaica', 'AMRO', '0', '569', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41750, '2020-05-31', 'JM', 'Jamaica', 'AMRO', '6', '575', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41751, '2020-06-01', 'JM', 'Jamaica', 'AMRO', '6', '581', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41752, '2020-06-02', 'JM', 'Jamaica', 'AMRO', '0', '581', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41753, '2020-06-03', 'JM', 'Jamaica', 'AMRO', '7', '588', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41754, '2020-06-04', 'JM', 'Jamaica', 'AMRO', '2', '590', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41755, '2020-06-05', 'JM', 'Jamaica', 'AMRO', '0', '590', '0', '9');
INSERT INTO public.who_global_data_import VALUES (41756, '2020-06-06', 'JM', 'Jamaica', 'AMRO', '1', '591', '1', '10');
INSERT INTO public.who_global_data_import VALUES (41757, '2020-06-07', 'JM', 'Jamaica', 'AMRO', '4', '595', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41758, '2020-06-08', 'JM', 'Jamaica', 'AMRO', '1', '596', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41759, '2020-06-09', 'JM', 'Jamaica', 'AMRO', '2', '598', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41760, '2020-06-10', 'JM', 'Jamaica', 'AMRO', '0', '598', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41761, '2020-06-11', 'JM', 'Jamaica', 'AMRO', '0', '598', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41762, '2020-06-12', 'JM', 'Jamaica', 'AMRO', '0', '598', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41763, '2020-06-13', 'JM', 'Jamaica', 'AMRO', '13', '611', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41764, '2020-06-14', 'JM', 'Jamaica', 'AMRO', '3', '614', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41765, '2020-06-15', 'JM', 'Jamaica', 'AMRO', '1', '615', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41766, '2020-06-16', 'JM', 'Jamaica', 'AMRO', '2', '617', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41767, '2020-06-17', 'JM', 'Jamaica', 'AMRO', '4', '621', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41768, '2020-06-18', 'JM', 'Jamaica', 'AMRO', '0', '621', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41769, '2020-06-19', 'JM', 'Jamaica', 'AMRO', '5', '626', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41770, '2020-06-20', 'JM', 'Jamaica', 'AMRO', '12', '638', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41771, '2020-06-21', 'JM', 'Jamaica', 'AMRO', '14', '652', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41772, '2020-06-22', 'JM', 'Jamaica', 'AMRO', '5', '657', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41773, '2020-06-23', 'JM', 'Jamaica', 'AMRO', '2', '659', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41774, '2020-06-24', 'JM', 'Jamaica', 'AMRO', '6', '665', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41775, '2020-06-25', 'JM', 'Jamaica', 'AMRO', '5', '670', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41776, '2020-06-26', 'JM', 'Jamaica', 'AMRO', '8', '678', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41777, '2020-06-27', 'JM', 'Jamaica', 'AMRO', '6', '684', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41778, '2020-06-28', 'JM', 'Jamaica', 'AMRO', '2', '686', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41779, '2020-06-29', 'JM', 'Jamaica', 'AMRO', '0', '686', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41780, '2020-06-30', 'JM', 'Jamaica', 'AMRO', '10', '696', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41781, '2020-07-01', 'JM', 'Jamaica', 'AMRO', '2', '698', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41782, '2020-07-02', 'JM', 'Jamaica', 'AMRO', '4', '702', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41783, '2020-07-03', 'JM', 'Jamaica', 'AMRO', '5', '707', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41784, '2020-07-04', 'JM', 'Jamaica', 'AMRO', '8', '715', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41785, '2020-07-05', 'JM', 'Jamaica', 'AMRO', '6', '721', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41786, '2020-07-06', 'JM', 'Jamaica', 'AMRO', '7', '728', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41787, '2020-07-07', 'JM', 'Jamaica', 'AMRO', '4', '732', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41788, '2020-07-08', 'JM', 'Jamaica', 'AMRO', '5', '737', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41789, '2020-07-09', 'JM', 'Jamaica', 'AMRO', '8', '745', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41790, '2020-07-10', 'JM', 'Jamaica', 'AMRO', '6', '751', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41791, '2020-07-11', 'JM', 'Jamaica', 'AMRO', '2', '753', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41792, '2020-07-12', 'JM', 'Jamaica', 'AMRO', '0', '753', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41793, '2020-07-13', 'JM', 'Jamaica', 'AMRO', '5', '758', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41794, '2020-07-14', 'JM', 'Jamaica', 'AMRO', '0', '758', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41795, '2020-07-15', 'JM', 'Jamaica', 'AMRO', '1', '759', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41796, '2020-07-16', 'JM', 'Jamaica', 'AMRO', '3', '762', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41797, '2020-07-17', 'JM', 'Jamaica', 'AMRO', '1', '763', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41798, '2020-07-18', 'JM', 'Jamaica', 'AMRO', '2', '765', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41799, '2020-07-19', 'JM', 'Jamaica', 'AMRO', '3', '768', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41800, '2020-07-20', 'JM', 'Jamaica', 'AMRO', '6', '774', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41801, '2020-07-21', 'JM', 'Jamaica', 'AMRO', '16', '790', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41802, '2020-07-22', 'JM', 'Jamaica', 'AMRO', '19', '809', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41803, '2020-07-23', 'JM', 'Jamaica', 'AMRO', '1', '810', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41804, '2020-07-24', 'JM', 'Jamaica', 'AMRO', '6', '816', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41805, '2020-07-25', 'JM', 'Jamaica', 'AMRO', '5', '821', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41806, '2020-07-26', 'JM', 'Jamaica', 'AMRO', '10', '831', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41807, '2020-07-27', 'JM', 'Jamaica', 'AMRO', '6', '837', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41808, '2020-07-28', 'JM', 'Jamaica', 'AMRO', '5', '842', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41809, '2020-07-29', 'JM', 'Jamaica', 'AMRO', '11', '853', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41810, '2020-07-30', 'JM', 'Jamaica', 'AMRO', '2', '855', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41811, '2020-07-31', 'JM', 'Jamaica', 'AMRO', '1', '856', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41812, '2020-08-01', 'JM', 'Jamaica', 'AMRO', '8', '864', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41813, '2020-08-02', 'JM', 'Jamaica', 'AMRO', '14', '878', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41814, '2020-08-03', 'JM', 'Jamaica', 'AMRO', '5', '883', '0', '10');
INSERT INTO public.who_global_data_import VALUES (41815, '2020-08-04', 'JM', 'Jamaica', 'AMRO', '11', '894', '2', '12');
INSERT INTO public.who_global_data_import VALUES (41816, '2020-08-05', 'JM', 'Jamaica', 'AMRO', '11', '905', '0', '12');
INSERT INTO public.who_global_data_import VALUES (41817, '2020-08-06', 'JM', 'Jamaica', 'AMRO', '15', '920', '0', '12');
INSERT INTO public.who_global_data_import VALUES (41818, '2020-08-07', 'JM', 'Jamaica', 'AMRO', '8', '928', '0', '12');
INSERT INTO public.who_global_data_import VALUES (41819, '2020-08-08', 'JM', 'Jamaica', 'AMRO', '30', '958', '0', '12');
INSERT INTO public.who_global_data_import VALUES (41820, '2020-08-09', 'JM', 'Jamaica', 'AMRO', '29', '987', '0', '12');
INSERT INTO public.who_global_data_import VALUES (41821, '2020-08-10', 'JM', 'Jamaica', 'AMRO', '16', '1003', '0', '12');
INSERT INTO public.who_global_data_import VALUES (41822, '2020-08-11', 'JM', 'Jamaica', 'AMRO', '20', '1023', '2', '14');
INSERT INTO public.who_global_data_import VALUES (41823, '2020-08-12', 'JM', 'Jamaica', 'AMRO', '8', '1031', '0', '14');
INSERT INTO public.who_global_data_import VALUES (41824, '2020-08-13', 'JM', 'Jamaica', 'AMRO', '16', '1047', '0', '14');
INSERT INTO public.who_global_data_import VALUES (41825, '2020-08-14', 'JM', 'Jamaica', 'AMRO', '18', '1065', '0', '14');
INSERT INTO public.who_global_data_import VALUES (41826, '2020-08-15', 'JM', 'Jamaica', 'AMRO', '6', '1071', '0', '14');
INSERT INTO public.who_global_data_import VALUES (41827, '2020-08-16', 'JM', 'Jamaica', 'AMRO', '11', '1082', '0', '14');
INSERT INTO public.who_global_data_import VALUES (41828, '2020-08-17', 'JM', 'Jamaica', 'AMRO', '24', '1106', '0', '14');
INSERT INTO public.who_global_data_import VALUES (41829, '2020-08-18', 'JM', 'Jamaica', 'AMRO', '7', '1113', '0', '14');
INSERT INTO public.who_global_data_import VALUES (41830, '2020-08-19', 'JM', 'Jamaica', 'AMRO', '16', '1129', '0', '14');
INSERT INTO public.who_global_data_import VALUES (41831, '2020-08-20', 'JM', 'Jamaica', 'AMRO', '17', '1146', '0', '14');
INSERT INTO public.who_global_data_import VALUES (41832, '2020-08-21', 'JM', 'Jamaica', 'AMRO', '46', '1192', '0', '14');
INSERT INTO public.who_global_data_import VALUES (41833, '2020-08-22', 'JM', 'Jamaica', 'AMRO', '98', '1290', '1', '15');
INSERT INTO public.who_global_data_import VALUES (41834, '2020-08-23', 'JM', 'Jamaica', 'AMRO', '56', '1346', '1', '16');
INSERT INTO public.who_global_data_import VALUES (41835, '2020-08-24', 'JM', 'Jamaica', 'AMRO', '67', '1413', '0', '16');
INSERT INTO public.who_global_data_import VALUES (41836, '2020-08-25', 'JM', 'Jamaica', 'AMRO', '116', '1529', '0', '16');
INSERT INTO public.who_global_data_import VALUES (41837, '2020-08-26', 'JM', 'Jamaica', 'AMRO', '83', '1612', '0', '16');
INSERT INTO public.who_global_data_import VALUES (41838, '2020-08-27', 'JM', 'Jamaica', 'AMRO', '120', '1732', '3', '19');
INSERT INTO public.who_global_data_import VALUES (41839, '2020-08-28', 'JM', 'Jamaica', 'AMRO', '72', '1804', '0', '19');
INSERT INTO public.who_global_data_import VALUES (41840, '2020-08-29', 'JM', 'Jamaica', 'AMRO', '66', '1870', '0', '19');
INSERT INTO public.who_global_data_import VALUES (41841, '2020-08-30', 'JM', 'Jamaica', 'AMRO', '141', '2011', '0', '19');
INSERT INTO public.who_global_data_import VALUES (41842, '2020-08-31', 'JM', 'Jamaica', 'AMRO', '102', '2113', '0', '19');
INSERT INTO public.who_global_data_import VALUES (41843, '2020-09-01', 'JM', 'Jamaica', 'AMRO', '244', '2357', '2', '21');
INSERT INTO public.who_global_data_import VALUES (41844, '2020-09-02', 'JM', 'Jamaica', 'AMRO', '102', '2459', '0', '21');
INSERT INTO public.who_global_data_import VALUES (41845, '2020-09-03', 'JM', 'Jamaica', 'AMRO', '224', '2683', '3', '24');
INSERT INTO public.who_global_data_import VALUES (41846, '2020-09-04', 'JM', 'Jamaica', 'AMRO', '140', '2823', '3', '27');
INSERT INTO public.who_global_data_import VALUES (41847, '2020-09-05', 'JM', 'Jamaica', 'AMRO', '73', '2896', '2', '29');
INSERT INTO public.who_global_data_import VALUES (41848, '2020-09-06', 'JM', 'Jamaica', 'AMRO', '68', '2964', '1', '30');
INSERT INTO public.who_global_data_import VALUES (41849, '2020-09-07', 'JM', 'Jamaica', 'AMRO', '60', '3024', '2', '32');
INSERT INTO public.who_global_data_import VALUES (41850, '2020-09-08', 'JM', 'Jamaica', 'AMRO', '79', '3103', '1', '33');
INSERT INTO public.who_global_data_import VALUES (41851, '2020-09-09', 'JM', 'Jamaica', 'AMRO', '80', '3183', '1', '34');
INSERT INTO public.who_global_data_import VALUES (41852, '2020-09-10', 'JM', 'Jamaica', 'AMRO', '140', '3323', '2', '36');
INSERT INTO public.who_global_data_import VALUES (41853, '2020-09-11', 'JM', 'Jamaica', 'AMRO', '114', '3437', '2', '38');
INSERT INTO public.who_global_data_import VALUES (41854, '2020-09-12', 'JM', 'Jamaica', 'AMRO', '74', '3511', '2', '40');
INSERT INTO public.who_global_data_import VALUES (41855, '2020-09-13', 'JM', 'Jamaica', 'AMRO', '0', '3511', '0', '40');
INSERT INTO public.who_global_data_import VALUES (41856, '2020-09-14', 'JM', 'Jamaica', 'AMRO', '260', '3771', '2', '42');
INSERT INTO public.who_global_data_import VALUES (41857, '2020-09-15', 'JM', 'Jamaica', 'AMRO', '162', '3933', '2', '44');
INSERT INTO public.who_global_data_import VALUES (41858, '2020-09-16', 'JM', 'Jamaica', 'AMRO', '109', '4042', '2', '46');
INSERT INTO public.who_global_data_import VALUES (41859, '2020-09-17', 'JM', 'Jamaica', 'AMRO', '122', '4164', '0', '46');
INSERT INTO public.who_global_data_import VALUES (41860, '2020-09-18', 'JM', 'Jamaica', 'AMRO', '210', '4374', '5', '51');
INSERT INTO public.who_global_data_import VALUES (41861, '2020-09-19', 'JM', 'Jamaica', 'AMRO', '197', '4571', '4', '55');
INSERT INTO public.who_global_data_import VALUES (41862, '2020-09-20', 'JM', 'Jamaica', 'AMRO', '187', '4758', '5', '60');
INSERT INTO public.who_global_data_import VALUES (41863, '2020-09-21', 'JM', 'Jamaica', 'AMRO', '230', '4988', '7', '67');
INSERT INTO public.who_global_data_import VALUES (41864, '2020-09-22', 'JM', 'Jamaica', 'AMRO', '155', '5143', '3', '70');
INSERT INTO public.who_global_data_import VALUES (41865, '2020-09-23', 'JM', 'Jamaica', 'AMRO', '127', '5270', '5', '75');
INSERT INTO public.who_global_data_import VALUES (41866, '2020-09-24', 'JM', 'Jamaica', 'AMRO', '125', '5395', '1', '76');
INSERT INTO public.who_global_data_import VALUES (41867, '2020-09-25', 'JM', 'Jamaica', 'AMRO', '193', '5588', '1', '77');
INSERT INTO public.who_global_data_import VALUES (41868, '2020-09-26', 'JM', 'Jamaica', 'AMRO', '135', '5723', '3', '80');
INSERT INTO public.who_global_data_import VALUES (41869, '2020-09-27', 'JM', 'Jamaica', 'AMRO', '131', '5854', '8', '88');
INSERT INTO public.who_global_data_import VALUES (41870, '2020-09-28', 'JM', 'Jamaica', 'AMRO', '163', '6017', '1', '89');
INSERT INTO public.who_global_data_import VALUES (41871, '2020-09-29', 'JM', 'Jamaica', 'AMRO', '153', '6170', '4', '93');
INSERT INTO public.who_global_data_import VALUES (41872, '2020-09-30', 'JM', 'Jamaica', 'AMRO', '238', '6408', '8', '101');
INSERT INTO public.who_global_data_import VALUES (41873, '2020-10-01', 'JM', 'Jamaica', 'AMRO', '74', '6482', '6', '107');
INSERT INTO public.who_global_data_import VALUES (41874, '2020-10-02', 'JM', 'Jamaica', 'AMRO', '73', '6555', '4', '111');
INSERT INTO public.who_global_data_import VALUES (41875, '2020-10-03', 'JM', 'Jamaica', 'AMRO', '149', '6704', '5', '116');
INSERT INTO public.who_global_data_import VALUES (41876, '2020-10-04', 'JM', 'Jamaica', 'AMRO', '91', '6795', '3', '119');
INSERT INTO public.who_global_data_import VALUES (41877, '2020-10-05', 'JM', 'Jamaica', 'AMRO', '100', '6895', '1', '120');
INSERT INTO public.who_global_data_import VALUES (41878, '2020-10-06', 'JM', 'Jamaica', 'AMRO', '117', '7012', '0', '120');
INSERT INTO public.who_global_data_import VALUES (41879, '2020-10-07', 'JM', 'Jamaica', 'AMRO', '97', '7109', '3', '123');
INSERT INTO public.who_global_data_import VALUES (41880, '2020-10-08', 'JM', 'Jamaica', 'AMRO', '82', '7191', '3', '126');
INSERT INTO public.who_global_data_import VALUES (41881, '2020-10-09', 'JM', 'Jamaica', 'AMRO', '82', '7273', '2', '128');
INSERT INTO public.who_global_data_import VALUES (41882, '2020-10-10', 'JM', 'Jamaica', 'AMRO', '90', '7363', '4', '132');
INSERT INTO public.who_global_data_import VALUES (41883, '2020-10-11', 'JM', 'Jamaica', 'AMRO', '196', '7559', '6', '138');
INSERT INTO public.who_global_data_import VALUES (41884, '2020-10-12', 'JM', 'Jamaica', 'AMRO', '159', '7718', '1', '139');
INSERT INTO public.who_global_data_import VALUES (41885, '2020-10-13', 'JM', 'Jamaica', 'AMRO', '95', '7813', '7', '146');
INSERT INTO public.who_global_data_import VALUES (41886, '2020-10-14', 'JM', 'Jamaica', 'AMRO', '97', '7910', '0', '146');
INSERT INTO public.who_global_data_import VALUES (41887, '2020-10-15', 'JM', 'Jamaica', 'AMRO', '79', '7989', '5', '151');
INSERT INTO public.who_global_data_import VALUES (41888, '2020-10-16', 'JM', 'Jamaica', 'AMRO', '78', '8067', '9', '160');
INSERT INTO public.who_global_data_import VALUES (41889, '2020-10-17', 'JM', 'Jamaica', 'AMRO', '65', '8132', '2', '162');
INSERT INTO public.who_global_data_import VALUES (41890, '2020-10-18', 'JM', 'Jamaica', 'AMRO', '63', '8195', '6', '168');
INSERT INTO public.who_global_data_import VALUES (41891, '2020-10-19', 'JM', 'Jamaica', 'AMRO', '79', '8274', '3', '171');
INSERT INTO public.who_global_data_import VALUES (41892, '2020-10-20', 'JM', 'Jamaica', 'AMRO', '47', '8321', '2', '173');
INSERT INTO public.who_global_data_import VALUES (41893, '2020-10-21', 'JM', 'Jamaica', 'AMRO', '53', '8374', '1', '174');
INSERT INTO public.who_global_data_import VALUES (41894, '2020-10-22', 'JM', 'Jamaica', 'AMRO', '71', '8445', '0', '174');
INSERT INTO public.who_global_data_import VALUES (41895, '2020-10-23', 'JM', 'Jamaica', 'AMRO', '155', '8600', '5', '179');
INSERT INTO public.who_global_data_import VALUES (41896, '2020-10-24', 'JM', 'Jamaica', 'AMRO', '38', '8638', '3', '182');
INSERT INTO public.who_global_data_import VALUES (41897, '2020-10-25', 'JM', 'Jamaica', 'AMRO', '32', '8670', '4', '186');
INSERT INTO public.who_global_data_import VALUES (41898, '2020-10-26', 'JM', 'Jamaica', 'AMRO', '44', '8714', '2', '188');
INSERT INTO public.who_global_data_import VALUES (41899, '2020-10-27', 'JM', 'Jamaica', 'AMRO', '35', '8749', '4', '192');
INSERT INTO public.who_global_data_import VALUES (41900, '2020-10-28', 'JM', 'Jamaica', 'AMRO', '38', '8787', '4', '196');
INSERT INTO public.who_global_data_import VALUES (41901, '2020-10-29', 'JM', 'Jamaica', 'AMRO', '64', '8851', '2', '198');
INSERT INTO public.who_global_data_import VALUES (41902, '2020-10-30', 'JM', 'Jamaica', 'AMRO', '76', '8927', '4', '202');
INSERT INTO public.who_global_data_import VALUES (41903, '2020-10-31', 'JM', 'Jamaica', 'AMRO', '78', '9005', '3', '205');
INSERT INTO public.who_global_data_import VALUES (41904, '2020-11-01', 'JM', 'Jamaica', 'AMRO', '89', '9094', '1', '206');
INSERT INTO public.who_global_data_import VALUES (41905, '2020-11-02', 'JM', 'Jamaica', 'AMRO', '37', '9131', '3', '209');
INSERT INTO public.who_global_data_import VALUES (41906, '2020-11-03', 'JM', 'Jamaica', 'AMRO', '126', '9257', '1', '210');
INSERT INTO public.who_global_data_import VALUES (41907, '2020-11-04', 'JM', 'Jamaica', 'AMRO', '39', '9296', '4', '214');
INSERT INTO public.who_global_data_import VALUES (41908, '2020-11-05', 'JM', 'Jamaica', 'AMRO', '30', '9326', '1', '215');
INSERT INTO public.who_global_data_import VALUES (41909, '2020-11-06', 'JM', 'Jamaica', 'AMRO', '47', '9373', '2', '217');
INSERT INTO public.who_global_data_import VALUES (41910, '2020-11-07', 'JM', 'Jamaica', 'AMRO', '53', '9426', '1', '218');
INSERT INTO public.who_global_data_import VALUES (41911, '2020-11-08', 'JM', 'Jamaica', 'AMRO', '46', '9472', '0', '218');
INSERT INTO public.who_global_data_import VALUES (41912, '2020-11-09', 'JM', 'Jamaica', 'AMRO', '34', '9506', '3', '221');
INSERT INTO public.who_global_data_import VALUES (41913, '2020-11-10', 'JM', 'Jamaica', 'AMRO', '36', '9542', '0', '221');
INSERT INTO public.who_global_data_import VALUES (41914, '2020-11-11', 'JM', 'Jamaica', 'AMRO', '31', '9573', '3', '224');
INSERT INTO public.who_global_data_import VALUES (41915, '2020-11-12', 'JM', 'Jamaica', 'AMRO', '8', '9581', '1', '225');
INSERT INTO public.who_global_data_import VALUES (41916, '2020-11-13', 'JM', 'Jamaica', 'AMRO', '53', '9634', '0', '225');
INSERT INTO public.who_global_data_import VALUES (41917, '2020-11-14', 'JM', 'Jamaica', 'AMRO', '89', '9723', '2', '227');
INSERT INTO public.who_global_data_import VALUES (41918, '2020-11-15', 'JM', 'Jamaica', 'AMRO', '57', '9780', '2', '229');
INSERT INTO public.who_global_data_import VALUES (41919, '2020-11-16', 'JM', 'Jamaica', 'AMRO', '104', '9884', '2', '231');
INSERT INTO public.who_global_data_import VALUES (41920, '2020-11-17', 'JM', 'Jamaica', 'AMRO', '45', '9929', '0', '231');
INSERT INTO public.who_global_data_import VALUES (41921, '2020-11-18', 'JM', 'Jamaica', 'AMRO', '30', '9959', '0', '231');
INSERT INTO public.who_global_data_import VALUES (41922, '2020-11-19', 'JM', 'Jamaica', 'AMRO', '60', '10019', '2', '233');
INSERT INTO public.who_global_data_import VALUES (41923, '2020-11-20', 'JM', 'Jamaica', 'AMRO', '69', '10088', '2', '235');
INSERT INTO public.who_global_data_import VALUES (41924, '2020-11-21', 'JM', 'Jamaica', 'AMRO', '63', '10151', '0', '235');
INSERT INTO public.who_global_data_import VALUES (41925, '2020-11-22', 'JM', 'Jamaica', 'AMRO', '89', '10240', '2', '237');
INSERT INTO public.who_global_data_import VALUES (41926, '2020-11-23', 'JM', 'Jamaica', 'AMRO', '44', '10284', '1', '238');
INSERT INTO public.who_global_data_import VALUES (41927, '2020-11-24', 'JM', 'Jamaica', 'AMRO', '59', '10343', '1', '239');
INSERT INTO public.who_global_data_import VALUES (41928, '2020-11-25', 'JM', 'Jamaica', 'AMRO', '79', '10422', '4', '243');
INSERT INTO public.who_global_data_import VALUES (41929, '2020-11-26', 'JM', 'Jamaica', 'AMRO', '66', '10488', '4', '247');
INSERT INTO public.who_global_data_import VALUES (41930, '2020-11-27', 'JM', 'Jamaica', 'AMRO', '53', '10541', '1', '248');
INSERT INTO public.who_global_data_import VALUES (41931, '2020-11-28', 'JM', 'Jamaica', 'AMRO', '59', '10600', '2', '250');
INSERT INTO public.who_global_data_import VALUES (41932, '2020-11-29', 'JM', 'Jamaica', 'AMRO', '69', '10669', '1', '251');
INSERT INTO public.who_global_data_import VALUES (41933, '2020-11-30', 'JM', 'Jamaica', 'AMRO', '40', '10709', '5', '256');
INSERT INTO public.who_global_data_import VALUES (41934, '2020-12-01', 'JM', 'Jamaica', 'AMRO', '54', '10763', '1', '257');
INSERT INTO public.who_global_data_import VALUES (41935, '2020-12-02', 'JM', 'Jamaica', 'AMRO', '47', '10810', '1', '258');
INSERT INTO public.who_global_data_import VALUES (41936, '2020-12-03', 'JM', 'Jamaica', 'AMRO', '54', '10864', '0', '258');
INSERT INTO public.who_global_data_import VALUES (41937, '2020-12-04', 'JM', 'Jamaica', 'AMRO', '47', '10911', '1', '259');
INSERT INTO public.who_global_data_import VALUES (41938, '2020-12-05', 'JM', 'Jamaica', 'AMRO', '76', '10987', '1', '260');
INSERT INTO public.who_global_data_import VALUES (41939, '2020-12-06', 'JM', 'Jamaica', 'AMRO', '76', '11063', '1', '261');
INSERT INTO public.who_global_data_import VALUES (41940, '2020-12-07', 'JM', 'Jamaica', 'AMRO', '57', '11120', '4', '265');
INSERT INTO public.who_global_data_import VALUES (41941, '2020-12-08', 'JM', 'Jamaica', 'AMRO', '64', '11184', '0', '265');
INSERT INTO public.who_global_data_import VALUES (41942, '2020-12-09', 'JM', 'Jamaica', 'AMRO', '87', '11271', '0', '265');
INSERT INTO public.who_global_data_import VALUES (41943, '2020-12-10', 'JM', 'Jamaica', 'AMRO', '98', '11369', '1', '266');
INSERT INTO public.who_global_data_import VALUES (41944, '2020-12-11', 'JM', 'Jamaica', 'AMRO', '74', '11443', '4', '270');
INSERT INTO public.who_global_data_import VALUES (41945, '2020-12-12', 'JM', 'Jamaica', 'AMRO', '66', '11509', '0', '270');
INSERT INTO public.who_global_data_import VALUES (41946, '2020-12-13', 'JM', 'Jamaica', 'AMRO', '99', '11608', '1', '271');
INSERT INTO public.who_global_data_import VALUES (41947, '2020-12-14', 'JM', 'Jamaica', 'AMRO', '102', '11710', '2', '273');
INSERT INTO public.who_global_data_import VALUES (41948, '2020-12-15', 'JM', 'Jamaica', 'AMRO', '82', '11792', '0', '273');
INSERT INTO public.who_global_data_import VALUES (41949, '2020-12-16', 'JM', 'Jamaica', 'AMRO', '83', '11875', '3', '276');
INSERT INTO public.who_global_data_import VALUES (41950, '2020-12-17', 'JM', 'Jamaica', 'AMRO', '32', '11907', '0', '276');
INSERT INTO public.who_global_data_import VALUES (41951, '2020-12-18', 'JM', 'Jamaica', 'AMRO', '61', '11968', '3', '279');
INSERT INTO public.who_global_data_import VALUES (41952, '2020-12-19', 'JM', 'Jamaica', 'AMRO', '71', '12039', '4', '283');
INSERT INTO public.who_global_data_import VALUES (41953, '2020-12-20', 'JM', 'Jamaica', 'AMRO', '96', '12135', '2', '285');
INSERT INTO public.who_global_data_import VALUES (41954, '2020-12-21', 'JM', 'Jamaica', 'AMRO', '89', '12224', '1', '286');
INSERT INTO public.who_global_data_import VALUES (41955, '2020-12-22', 'JM', 'Jamaica', 'AMRO', '65', '12289', '0', '286');
INSERT INTO public.who_global_data_import VALUES (41956, '2020-12-23', 'JM', 'Jamaica', 'AMRO', '65', '12354', '2', '288');
INSERT INTO public.who_global_data_import VALUES (41957, '2020-12-24', 'JM', 'Jamaica', 'AMRO', '69', '12423', '2', '290');
INSERT INTO public.who_global_data_import VALUES (41958, '2020-12-25', 'JM', 'Jamaica', 'AMRO', '96', '12519', '2', '292');
INSERT INTO public.who_global_data_import VALUES (41959, '2020-12-26', 'JM', 'Jamaica', 'AMRO', '78', '12597', '2', '294');
INSERT INTO public.who_global_data_import VALUES (41960, '2020-12-27', 'JM', 'Jamaica', 'AMRO', '87', '12684', '0', '294');
INSERT INTO public.who_global_data_import VALUES (41961, '2020-12-28', 'JM', 'Jamaica', 'AMRO', '39', '12723', '1', '295');
INSERT INTO public.who_global_data_import VALUES (41962, '2020-12-29', 'JM', 'Jamaica', 'AMRO', '9', '12732', '3', '298');
INSERT INTO public.who_global_data_import VALUES (41963, '2020-12-30', 'JM', 'Jamaica', 'AMRO', '20', '12752', '0', '298');
INSERT INTO public.who_global_data_import VALUES (41964, '2020-12-31', 'JM', 'Jamaica', 'AMRO', '41', '12793', '4', '302');
INSERT INTO public.who_global_data_import VALUES (41965, '2021-01-01', 'JM', 'Jamaica', 'AMRO', '34', '12827', '0', '302');
INSERT INTO public.who_global_data_import VALUES (41966, '2021-01-02', 'JM', 'Jamaica', 'AMRO', '88', '12915', '1', '303');
INSERT INTO public.who_global_data_import VALUES (41967, '2021-01-03', 'JM', 'Jamaica', 'AMRO', '16', '12931', '0', '303');
INSERT INTO public.who_global_data_import VALUES (41968, '2021-01-04', 'JM', 'Jamaica', 'AMRO', '118', '13049', '1', '304');
INSERT INTO public.who_global_data_import VALUES (41969, '2021-01-05', 'JM', 'Jamaica', 'AMRO', '154', '13203', '0', '304');
INSERT INTO public.who_global_data_import VALUES (41970, '2021-01-06', 'JM', 'Jamaica', 'AMRO', '43', '13246', '1', '305');
INSERT INTO public.who_global_data_import VALUES (41971, '2021-01-07', 'JM', 'Jamaica', 'AMRO', '84', '13330', '1', '306');
INSERT INTO public.who_global_data_import VALUES (41972, '2021-01-08', 'JM', 'Jamaica', 'AMRO', '38', '13368', '0', '306');
INSERT INTO public.who_global_data_import VALUES (41973, '2021-01-09', 'JM', 'Jamaica', 'AMRO', '43', '13411', '1', '307');
INSERT INTO public.who_global_data_import VALUES (41974, '2021-01-10', 'JM', 'Jamaica', 'AMRO', '44', '13455', '4', '311');
INSERT INTO public.who_global_data_import VALUES (41975, '2021-01-11', 'JM', 'Jamaica', 'AMRO', '93', '13548', '1', '312');
INSERT INTO public.who_global_data_import VALUES (41976, '2021-01-12', 'JM', 'Jamaica', 'AMRO', '89', '13637', '1', '313');
INSERT INTO public.who_global_data_import VALUES (41977, '2021-01-13', 'JM', 'Jamaica', 'AMRO', '123', '13760', '2', '315');
INSERT INTO public.who_global_data_import VALUES (41978, '2021-01-14', 'JM', 'Jamaica', 'AMRO', '92', '13852', '2', '317');
INSERT INTO public.who_global_data_import VALUES (41979, '2021-01-15', 'JM', 'Jamaica', 'AMRO', '63', '13915', '5', '322');
INSERT INTO public.who_global_data_import VALUES (41980, '2021-01-16', 'JM', 'Jamaica', 'AMRO', '77', '13992', '1', '323');
INSERT INTO public.who_global_data_import VALUES (41981, '2021-01-17', 'JM', 'Jamaica', 'AMRO', '104', '14096', '0', '323');
INSERT INTO public.who_global_data_import VALUES (41982, '2021-01-18', 'JM', 'Jamaica', 'AMRO', '65', '14161', '1', '324');
INSERT INTO public.who_global_data_import VALUES (41983, '2021-01-19', 'JM', 'Jamaica', 'AMRO', '113', '14274', '2', '326');
INSERT INTO public.who_global_data_import VALUES (41984, '2021-01-20', 'JM', 'Jamaica', 'AMRO', '145', '14419', '3', '329');
INSERT INTO public.who_global_data_import VALUES (41985, '2021-01-21', 'JM', 'Jamaica', 'AMRO', '68', '14487', '2', '331');
INSERT INTO public.who_global_data_import VALUES (41986, '2021-01-22', 'JM', 'Jamaica', 'AMRO', '63', '14550', '0', '331');
INSERT INTO public.who_global_data_import VALUES (41987, '2021-01-23', 'JM', 'Jamaica', 'AMRO', '108', '14658', '1', '332');
INSERT INTO public.who_global_data_import VALUES (41988, '2021-01-24', 'JM', 'Jamaica', 'AMRO', '114', '14772', '4', '336');
INSERT INTO public.who_global_data_import VALUES (41989, '2021-01-25', 'JM', 'Jamaica', 'AMRO', '107', '14879', '0', '336');
INSERT INTO public.who_global_data_import VALUES (41990, '2021-01-26', 'JM', 'Jamaica', 'AMRO', '133', '15012', '2', '338');
INSERT INTO public.who_global_data_import VALUES (41991, '2021-01-27', 'JM', 'Jamaica', 'AMRO', '141', '15153', '1', '339');
INSERT INTO public.who_global_data_import VALUES (41992, '2021-01-28', 'JM', 'Jamaica', 'AMRO', '88', '15241', '3', '342');
INSERT INTO public.who_global_data_import VALUES (41993, '2021-01-29', 'JM', 'Jamaica', 'AMRO', '194', '15435', '2', '344');
INSERT INTO public.who_global_data_import VALUES (41994, '2021-01-30', 'JM', 'Jamaica', 'AMRO', '27', '15462', '1', '345');
INSERT INTO public.who_global_data_import VALUES (41995, '2021-01-31', 'JM', 'Jamaica', 'AMRO', '65', '15527', '3', '348');
INSERT INTO public.who_global_data_import VALUES (41996, '2021-02-01', 'JM', 'Jamaica', 'AMRO', '126', '15653', '2', '350');
INSERT INTO public.who_global_data_import VALUES (41997, '2021-02-02', 'JM', 'Jamaica', 'AMRO', '125', '15778', '2', '352');
INSERT INTO public.who_global_data_import VALUES (41998, '2021-02-03', 'JM', 'Jamaica', 'AMRO', '195', '15973', '1', '353');
INSERT INTO public.who_global_data_import VALUES (41999, '2021-02-04', 'JM', 'Jamaica', 'AMRO', '100', '16073', '2', '355');
INSERT INTO public.who_global_data_import VALUES (42000, '2021-02-05', 'JM', 'Jamaica', 'AMRO', '177', '16250', '0', '355');
INSERT INTO public.who_global_data_import VALUES (42001, '2020-01-03', 'JP', 'Japan', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42002, '2020-01-04', 'JP', 'Japan', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42003, '2020-01-05', 'JP', 'Japan', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42004, '2020-01-06', 'JP', 'Japan', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42005, '2020-01-07', 'JP', 'Japan', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42006, '2020-01-08', 'JP', 'Japan', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42007, '2020-01-09', 'JP', 'Japan', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42008, '2020-01-10', 'JP', 'Japan', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42009, '2020-01-11', 'JP', 'Japan', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42010, '2020-01-12', 'JP', 'Japan', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42011, '2020-01-13', 'JP', 'Japan', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42012, '2020-01-14', 'JP', 'Japan', 'WPRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42013, '2020-01-15', 'JP', 'Japan', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42014, '2020-01-16', 'JP', 'Japan', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42015, '2020-01-17', 'JP', 'Japan', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42016, '2020-01-18', 'JP', 'Japan', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42017, '2020-01-19', 'JP', 'Japan', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42018, '2020-01-20', 'JP', 'Japan', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42019, '2020-01-21', 'JP', 'Japan', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42020, '2020-01-22', 'JP', 'Japan', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42021, '2020-01-23', 'JP', 'Japan', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42022, '2020-01-24', 'JP', 'Japan', 'WPRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42023, '2020-01-25', 'JP', 'Japan', 'WPRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42024, '2020-01-26', 'JP', 'Japan', 'WPRO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42025, '2020-01-27', 'JP', 'Japan', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42026, '2020-01-28', 'JP', 'Japan', 'WPRO', '4', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42027, '2020-01-29', 'JP', 'Japan', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42028, '2020-01-30', 'JP', 'Japan', 'WPRO', '6', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42029, '2020-01-31', 'JP', 'Japan', 'WPRO', '7', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42030, '2020-02-01', 'JP', 'Japan', 'WPRO', '3', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42031, '2020-02-02', 'JP', 'Japan', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42032, '2020-02-03', 'JP', 'Japan', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42033, '2020-02-04', 'JP', 'Japan', 'WPRO', '3', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42034, '2020-02-05', 'JP', 'Japan', 'WPRO', '2', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42035, '2020-02-06', 'JP', 'Japan', 'WPRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42036, '2020-02-07', 'JP', 'Japan', 'WPRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42037, '2020-02-08', 'JP', 'Japan', 'WPRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42038, '2020-02-09', 'JP', 'Japan', 'WPRO', '1', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42039, '2020-02-10', 'JP', 'Japan', 'WPRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42040, '2020-02-11', 'JP', 'Japan', 'WPRO', '2', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42041, '2020-02-12', 'JP', 'Japan', 'WPRO', '1', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42042, '2020-02-13', 'JP', 'Japan', 'WPRO', '4', '37', '1', '1');
INSERT INTO public.who_global_data_import VALUES (42043, '2020-02-14', 'JP', 'Japan', 'WPRO', '8', '45', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42044, '2020-02-15', 'JP', 'Japan', 'WPRO', '12', '57', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42045, '2020-02-16', 'JP', 'Japan', 'WPRO', '6', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42046, '2020-02-17', 'JP', 'Japan', 'WPRO', '6', '69', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42047, '2020-02-18', 'JP', 'Japan', 'WPRO', '7', '76', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42048, '2020-02-19', 'JP', 'Japan', 'WPRO', '1', '77', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42049, '2020-02-20', 'JP', 'Japan', 'WPRO', '20', '97', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42050, '2020-02-21', 'JP', 'Japan', 'WPRO', '12', '109', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42051, '2020-02-22', 'JP', 'Japan', 'WPRO', '27', '136', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42052, '2020-02-23', 'JP', 'Japan', 'WPRO', '12', '148', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42053, '2020-02-24', 'JP', 'Japan', 'WPRO', '12', '160', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42054, '2020-02-25', 'JP', 'Japan', 'WPRO', '1', '161', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42055, '2020-02-26', 'JP', 'Japan', 'WPRO', '29', '190', '2', '3');
INSERT INTO public.who_global_data_import VALUES (42056, '2020-02-27', 'JP', 'Japan', 'WPRO', '1', '191', '1', '4');
INSERT INTO public.who_global_data_import VALUES (42057, '2020-02-28', 'JP', 'Japan', 'WPRO', '23', '214', '1', '5');
INSERT INTO public.who_global_data_import VALUES (42058, '2020-02-29', 'JP', 'Japan', 'WPRO', '29', '243', '0', '5');
INSERT INTO public.who_global_data_import VALUES (42059, '2020-03-01', 'JP', 'Japan', 'WPRO', '0', '243', '1', '6');
INSERT INTO public.who_global_data_import VALUES (42060, '2020-03-02', 'JP', 'Japan', 'WPRO', '29', '272', '0', '6');
INSERT INTO public.who_global_data_import VALUES (42061, '2020-03-03', 'JP', 'Japan', 'WPRO', '16', '288', '0', '6');
INSERT INTO public.who_global_data_import VALUES (42062, '2020-03-04', 'JP', 'Japan', 'WPRO', '3', '291', '0', '6');
INSERT INTO public.who_global_data_import VALUES (42063, '2020-03-05', 'JP', 'Japan', 'WPRO', '62', '353', '0', '6');
INSERT INTO public.who_global_data_import VALUES (42064, '2020-03-06', 'JP', 'Japan', 'WPRO', '0', '353', '0', '6');
INSERT INTO public.who_global_data_import VALUES (42065, '2020-03-07', 'JP', 'Japan', 'WPRO', '58', '411', '0', '6');
INSERT INTO public.who_global_data_import VALUES (42066, '2020-03-08', 'JP', 'Japan', 'WPRO', '48', '459', '0', '6');
INSERT INTO public.who_global_data_import VALUES (42067, '2020-03-09', 'JP', 'Japan', 'WPRO', '59', '518', '3', '9');
INSERT INTO public.who_global_data_import VALUES (42068, '2020-03-10', 'JP', 'Japan', 'WPRO', '0', '518', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42069, '2020-03-11', 'JP', 'Japan', 'WPRO', '54', '572', '3', '12');
INSERT INTO public.who_global_data_import VALUES (42070, '2020-03-12', 'JP', 'Japan', 'WPRO', '52', '624', '3', '15');
INSERT INTO public.who_global_data_import VALUES (42071, '2020-03-13', 'JP', 'Japan', 'WPRO', '55', '679', '4', '19');
INSERT INTO public.who_global_data_import VALUES (42072, '2020-03-14', 'JP', 'Japan', 'WPRO', '105', '784', '3', '22');
INSERT INTO public.who_global_data_import VALUES (42073, '2020-03-15', 'JP', 'Japan', 'WPRO', '0', '784', '0', '22');
INSERT INTO public.who_global_data_import VALUES (42074, '2020-03-16', 'JP', 'Japan', 'WPRO', '34', '818', '2', '24');
INSERT INTO public.who_global_data_import VALUES (42075, '2020-03-17', 'JP', 'Japan', 'WPRO', '15', '833', '4', '28');
INSERT INTO public.who_global_data_import VALUES (42076, '2020-03-18', 'JP', 'Japan', 'WPRO', '44', '877', '1', '29');
INSERT INTO public.who_global_data_import VALUES (42077, '2020-03-19', 'JP', 'Japan', 'WPRO', '73', '950', '4', '33');
INSERT INTO public.who_global_data_import VALUES (42078, '2020-03-20', 'JP', 'Japan', 'WPRO', '46', '996', '2', '35');
INSERT INTO public.who_global_data_import VALUES (42079, '2020-03-21', 'JP', 'Japan', 'WPRO', '50', '1046', '1', '36');
INSERT INTO public.who_global_data_import VALUES (42080, '2020-03-22', 'JP', 'Japan', 'WPRO', '0', '1046', '0', '36');
INSERT INTO public.who_global_data_import VALUES (42081, '2020-03-23', 'JP', 'Japan', 'WPRO', '43', '1089', '5', '41');
INSERT INTO public.who_global_data_import VALUES (42082, '2020-03-24', 'JP', 'Japan', 'WPRO', '39', '1128', '1', '42');
INSERT INTO public.who_global_data_import VALUES (42083, '2020-03-25', 'JP', 'Japan', 'WPRO', '65', '1193', '1', '43');
INSERT INTO public.who_global_data_import VALUES (42084, '2020-03-26', 'JP', 'Japan', 'WPRO', '98', '1291', '2', '45');
INSERT INTO public.who_global_data_import VALUES (42085, '2020-03-27', 'JP', 'Japan', 'WPRO', '96', '1387', '1', '46');
INSERT INTO public.who_global_data_import VALUES (42086, '2020-03-28', 'JP', 'Japan', 'WPRO', '112', '1499', '3', '49');
INSERT INTO public.who_global_data_import VALUES (42087, '2020-03-29', 'JP', 'Japan', 'WPRO', '194', '1693', '3', '52');
INSERT INTO public.who_global_data_import VALUES (42088, '2020-03-30', 'JP', 'Japan', 'WPRO', '173', '1866', '2', '54');
INSERT INTO public.who_global_data_import VALUES (42089, '2020-03-31', 'JP', 'Japan', 'WPRO', '87', '1953', '2', '56');
INSERT INTO public.who_global_data_import VALUES (42090, '2020-04-01', 'JP', 'Japan', 'WPRO', '225', '2178', '1', '57');
INSERT INTO public.who_global_data_import VALUES (42091, '2020-04-02', 'JP', 'Japan', 'WPRO', '206', '2384', '0', '57');
INSERT INTO public.who_global_data_import VALUES (42092, '2020-04-03', 'JP', 'Japan', 'WPRO', '233', '2617', '8', '65');
INSERT INTO public.who_global_data_import VALUES (42093, '2020-04-04', 'JP', 'Japan', 'WPRO', '318', '2935', '4', '69');
INSERT INTO public.who_global_data_import VALUES (42094, '2020-04-05', 'JP', 'Japan', 'WPRO', '336', '3271', '1', '70');
INSERT INTO public.who_global_data_import VALUES (42095, '2020-04-06', 'JP', 'Japan', 'WPRO', '383', '3654', '3', '73');
INSERT INTO public.who_global_data_import VALUES (42096, '2020-04-07', 'JP', 'Japan', 'WPRO', '252', '3906', '7', '80');
INSERT INTO public.who_global_data_import VALUES (42097, '2020-04-08', 'JP', 'Japan', 'WPRO', '351', '4257', '1', '81');
INSERT INTO public.who_global_data_import VALUES (42098, '2020-04-09', 'JP', 'Japan', 'WPRO', '511', '4768', '4', '85');
INSERT INTO public.who_global_data_import VALUES (42099, '2020-04-10', 'JP', 'Japan', 'WPRO', '579', '5347', '3', '88');
INSERT INTO public.who_global_data_import VALUES (42100, '2020-04-11', 'JP', 'Japan', 'WPRO', '658', '6005', '6', '94');
INSERT INTO public.who_global_data_import VALUES (42101, '2020-04-12', 'JP', 'Japan', 'WPRO', '743', '6748', '4', '98');
INSERT INTO public.who_global_data_import VALUES (42102, '2020-04-13', 'JP', 'Japan', 'WPRO', '507', '7255', '4', '102');
INSERT INTO public.who_global_data_import VALUES (42103, '2020-04-14', 'JP', 'Japan', 'WPRO', '390', '7645', '7', '109');
INSERT INTO public.who_global_data_import VALUES (42104, '2020-04-15', 'JP', 'Japan', 'WPRO', '455', '8100', '10', '119');
INSERT INTO public.who_global_data_import VALUES (42105, '2020-04-16', 'JP', 'Japan', 'WPRO', '482', '8582', '17', '136');
INSERT INTO public.who_global_data_import VALUES (42106, '2020-04-17', 'JP', 'Japan', 'WPRO', '585', '9167', '12', '148');
INSERT INTO public.who_global_data_import VALUES (42107, '2020-04-18', 'JP', 'Japan', 'WPRO', '628', '9795', '6', '154');
INSERT INTO public.who_global_data_import VALUES (42108, '2020-04-19', 'JP', 'Japan', 'WPRO', '566', '10361', '7', '161');
INSERT INTO public.who_global_data_import VALUES (42109, '2020-04-20', 'JP', 'Japan', 'WPRO', '390', '10751', '10', '171');
INSERT INTO public.who_global_data_import VALUES (42110, '2020-04-21', 'JP', 'Japan', 'WPRO', '368', '11119', '15', '186');
INSERT INTO public.who_global_data_import VALUES (42111, '2020-04-22', 'JP', 'Japan', 'WPRO', '377', '11496', '91', '277');
INSERT INTO public.who_global_data_import VALUES (42112, '2020-04-23', 'JP', 'Japan', 'WPRO', '423', '11919', '10', '287');
INSERT INTO public.who_global_data_import VALUES (42113, '2020-04-24', 'JP', 'Japan', 'WPRO', '469', '12388', '30', '317');
INSERT INTO public.who_global_data_import VALUES (42114, '2020-04-25', 'JP', 'Japan', 'WPRO', '441', '12829', '17', '334');
INSERT INTO public.who_global_data_import VALUES (42115, '2020-04-26', 'JP', 'Japan', 'WPRO', '353', '13182', '14', '348');
INSERT INTO public.who_global_data_import VALUES (42116, '2020-04-27', 'JP', 'Japan', 'WPRO', '203', '13385', '3', '351');
INSERT INTO public.who_global_data_import VALUES (42117, '2020-04-28', 'JP', 'Japan', 'WPRO', '191', '13576', '25', '376');
INSERT INTO public.who_global_data_import VALUES (42118, '2020-04-29', 'JP', 'Japan', 'WPRO', '276', '13852', '13', '389');
INSERT INTO public.who_global_data_import VALUES (42119, '2020-04-30', 'JP', 'Japan', 'WPRO', '236', '14088', '26', '415');
INSERT INTO public.who_global_data_import VALUES (42120, '2020-05-01', 'JP', 'Japan', 'WPRO', '193', '14281', '17', '432');
INSERT INTO public.who_global_data_import VALUES (42121, '2020-05-02', 'JP', 'Japan', 'WPRO', '264', '14545', '22', '454');
INSERT INTO public.who_global_data_import VALUES (42122, '2020-05-03', 'JP', 'Japan', 'WPRO', '294', '14839', '38', '492');
INSERT INTO public.who_global_data_import VALUES (42123, '2020-05-04', 'JP', 'Japan', 'WPRO', '218', '15057', '18', '510');
INSERT INTO public.who_global_data_import VALUES (42124, '2020-05-05', 'JP', 'Japan', 'WPRO', '174', '15231', '11', '521');
INSERT INTO public.who_global_data_import VALUES (42125, '2020-05-06', 'JP', 'Japan', 'WPRO', '123', '15354', '22', '543');
INSERT INTO public.who_global_data_import VALUES (42126, '2020-05-07', 'JP', 'Japan', 'WPRO', '109', '15463', '8', '551');
INSERT INTO public.who_global_data_import VALUES (42127, '2020-05-08', 'JP', 'Japan', 'WPRO', '84', '15547', '6', '557');
INSERT INTO public.who_global_data_import VALUES (42128, '2020-05-09', 'JP', 'Japan', 'WPRO', '102', '15649', '43', '600');
INSERT INTO public.who_global_data_import VALUES (42129, '2020-05-10', 'JP', 'Japan', 'WPRO', '98', '15747', '13', '613');
INSERT INTO public.who_global_data_import VALUES (42130, '2020-05-11', 'JP', 'Japan', 'WPRO', '51', '15798', '8', '621');
INSERT INTO public.who_global_data_import VALUES (42131, '2020-05-12', 'JP', 'Japan', 'WPRO', '76', '15874', '22', '643');
INSERT INTO public.who_global_data_import VALUES (42132, '2020-05-13', 'JP', 'Japan', 'WPRO', '150', '16024', '25', '668');
INSERT INTO public.who_global_data_import VALUES (42133, '2020-05-14', 'JP', 'Japan', 'WPRO', '55', '16079', '19', '687');
INSERT INTO public.who_global_data_import VALUES (42134, '2020-05-15', 'JP', 'Japan', 'WPRO', '114', '16193', '23', '710');
INSERT INTO public.who_global_data_import VALUES (42135, '2020-05-16', 'JP', 'Japan', 'WPRO', '44', '16237', '15', '725');
INSERT INTO public.who_global_data_import VALUES (42136, '2020-05-17', 'JP', 'Japan', 'WPRO', '48', '16285', '19', '744');
INSERT INTO public.who_global_data_import VALUES (42137, '2020-05-18', 'JP', 'Japan', 'WPRO', '20', '16305', '5', '749');
INSERT INTO public.who_global_data_import VALUES (42138, '2020-05-19', 'JP', 'Japan', 'WPRO', '60', '16365', '14', '763');
INSERT INTO public.who_global_data_import VALUES (42139, '2020-05-20', 'JP', 'Japan', 'WPRO', '20', '16385', '8', '771');
INSERT INTO public.who_global_data_import VALUES (42140, '2020-05-21', 'JP', 'Japan', 'WPRO', '39', '16424', '6', '777');
INSERT INTO public.who_global_data_import VALUES (42141, '2020-05-22', 'JP', 'Japan', 'WPRO', '89', '16513', '19', '796');
INSERT INTO public.who_global_data_import VALUES (42142, '2020-05-23', 'JP', 'Japan', 'WPRO', '23', '16536', '12', '808');
INSERT INTO public.who_global_data_import VALUES (42143, '2020-05-24', 'JP', 'Japan', 'WPRO', '14', '16550', '12', '820');
INSERT INTO public.who_global_data_import VALUES (42144, '2020-05-25', 'JP', 'Japan', 'WPRO', '31', '16581', '10', '830');
INSERT INTO public.who_global_data_import VALUES (42145, '2020-05-26', 'JP', 'Japan', 'WPRO', '42', '16623', '16', '846');
INSERT INTO public.who_global_data_import VALUES (42146, '2020-05-27', 'JP', 'Japan', 'WPRO', '28', '16651', '12', '858');
INSERT INTO public.who_global_data_import VALUES (42147, '2020-05-28', 'JP', 'Japan', 'WPRO', '32', '16683', '9', '867');
INSERT INTO public.who_global_data_import VALUES (42148, '2020-05-29', 'JP', 'Japan', 'WPRO', '36', '16719', '7', '874');
INSERT INTO public.who_global_data_import VALUES (42149, '2020-05-30', 'JP', 'Japan', 'WPRO', '85', '16804', '12', '886');
INSERT INTO public.who_global_data_import VALUES (42150, '2020-05-31', 'JP', 'Japan', 'WPRO', '47', '16851', '5', '891');
INSERT INTO public.who_global_data_import VALUES (42151, '2020-06-01', 'JP', 'Japan', 'WPRO', '33', '16884', '1', '892');
INSERT INTO public.who_global_data_import VALUES (42152, '2020-06-02', 'JP', 'Japan', 'WPRO', '46', '16930', '2', '894');
INSERT INTO public.who_global_data_import VALUES (42153, '2020-06-03', 'JP', 'Japan', 'WPRO', '56', '16986', '6', '900');
INSERT INTO public.who_global_data_import VALUES (42154, '2020-06-04', 'JP', 'Japan', 'WPRO', '32', '17018', '3', '903');
INSERT INTO public.who_global_data_import VALUES (42155, '2020-06-05', 'JP', 'Japan', 'WPRO', '46', '17064', '4', '907');
INSERT INTO public.who_global_data_import VALUES (42156, '2020-06-06', 'JP', 'Japan', 'WPRO', '39', '17103', '7', '914');
INSERT INTO public.who_global_data_import VALUES (42157, '2020-06-07', 'JP', 'Japan', 'WPRO', '38', '17141', '2', '916');
INSERT INTO public.who_global_data_import VALUES (42158, '2020-06-08', 'JP', 'Japan', 'WPRO', '33', '17174', '0', '916');
INSERT INTO public.who_global_data_import VALUES (42159, '2020-06-09', 'JP', 'Japan', 'WPRO', '36', '17210', '0', '916');
INSERT INTO public.who_global_data_import VALUES (42160, '2020-06-10', 'JP', 'Japan', 'WPRO', '41', '17251', '3', '919');
INSERT INTO public.who_global_data_import VALUES (42161, '2020-06-11', 'JP', 'Japan', 'WPRO', '41', '17292', '1', '920');
INSERT INTO public.who_global_data_import VALUES (42162, '2020-06-12', 'JP', 'Japan', 'WPRO', '40', '17332', '2', '922');
INSERT INTO public.who_global_data_import VALUES (42163, '2020-06-13', 'JP', 'Japan', 'WPRO', '50', '17382', '2', '924');
INSERT INTO public.who_global_data_import VALUES (42164, '2020-06-14', 'JP', 'Japan', 'WPRO', '47', '17429', '1', '925');
INSERT INTO public.who_global_data_import VALUES (42165, '2020-06-15', 'JP', 'Japan', 'WPRO', '73', '17502', '0', '925');
INSERT INTO public.who_global_data_import VALUES (42166, '2020-06-16', 'JP', 'Japan', 'WPRO', '85', '17587', '2', '927');
INSERT INTO public.who_global_data_import VALUES (42167, '2020-06-17', 'JP', 'Japan', 'WPRO', '41', '17628', '4', '931');
INSERT INTO public.who_global_data_import VALUES (42168, '2020-06-18', 'JP', 'Japan', 'WPRO', '40', '17668', '4', '935');
INSERT INTO public.who_global_data_import VALUES (42169, '2020-06-19', 'JP', 'Japan', 'WPRO', '72', '17740', '0', '935');
INSERT INTO public.who_global_data_import VALUES (42170, '2020-06-20', 'JP', 'Japan', 'WPRO', '59', '17799', '17', '952');
INSERT INTO public.who_global_data_import VALUES (42171, '2020-06-21', 'JP', 'Japan', 'WPRO', '65', '17864', '1', '953');
INSERT INTO public.who_global_data_import VALUES (42172, '2020-06-22', 'JP', 'Japan', 'WPRO', '52', '17916', '0', '953');
INSERT INTO public.who_global_data_import VALUES (42173, '2020-06-23', 'JP', 'Japan', 'WPRO', '52', '17968', '2', '955');
INSERT INTO public.who_global_data_import VALUES (42174, '2020-06-24', 'JP', 'Japan', 'WPRO', '56', '18024', '8', '963');
INSERT INTO public.who_global_data_import VALUES (42175, '2020-06-25', 'JP', 'Japan', 'WPRO', '86', '18110', '5', '968');
INSERT INTO public.who_global_data_import VALUES (42176, '2020-06-26', 'JP', 'Japan', 'WPRO', '87', '18197', '1', '969');
INSERT INTO public.who_global_data_import VALUES (42177, '2020-06-27', 'JP', 'Japan', 'WPRO', '100', '18297', '2', '971');
INSERT INTO public.who_global_data_import VALUES (42178, '2020-06-28', 'JP', 'Japan', 'WPRO', '93', '18390', '0', '971');
INSERT INTO public.who_global_data_import VALUES (42179, '2020-06-29', 'JP', 'Japan', 'WPRO', '86', '18476', '1', '972');
INSERT INTO public.who_global_data_import VALUES (42180, '2020-06-30', 'JP', 'Japan', 'WPRO', '117', '18593', '0', '972');
INSERT INTO public.who_global_data_import VALUES (42181, '2020-07-01', 'JP', 'Japan', 'WPRO', '130', '18723', '2', '974');
INSERT INTO public.who_global_data_import VALUES (42182, '2020-07-02', 'JP', 'Japan', 'WPRO', '151', '18874', '1', '975');
INSERT INTO public.who_global_data_import VALUES (42183, '2020-07-03', 'JP', 'Japan', 'WPRO', '194', '19068', '1', '976');
INSERT INTO public.who_global_data_import VALUES (42184, '2020-07-04', 'JP', 'Japan', 'WPRO', '214', '19282', '1', '977');
INSERT INTO public.who_global_data_import VALUES (42185, '2020-07-05', 'JP', 'Japan', 'WPRO', '240', '19522', '0', '977');
INSERT INTO public.who_global_data_import VALUES (42186, '2020-07-06', 'JP', 'Japan', 'WPRO', '253', '19775', '0', '977');
INSERT INTO public.who_global_data_import VALUES (42187, '2020-07-07', 'JP', 'Japan', 'WPRO', '206', '19981', '1', '978');
INSERT INTO public.who_global_data_import VALUES (42188, '2020-07-08', 'JP', 'Japan', 'WPRO', '193', '20174', '2', '980');
INSERT INTO public.who_global_data_import VALUES (42189, '2020-07-09', 'JP', 'Japan', 'WPRO', '197', '20371', '1', '981');
INSERT INTO public.who_global_data_import VALUES (42190, '2020-07-10', 'JP', 'Japan', 'WPRO', '348', '20719', '1', '982');
INSERT INTO public.who_global_data_import VALUES (42191, '2020-07-11', 'JP', 'Japan', 'WPRO', '410', '21129', '0', '982');
INSERT INTO public.who_global_data_import VALUES (42192, '2020-07-12', 'JP', 'Japan', 'WPRO', '373', '21502', '0', '982');
INSERT INTO public.who_global_data_import VALUES (42193, '2020-07-13', 'JP', 'Japan', 'WPRO', '366', '21868', '0', '982');
INSERT INTO public.who_global_data_import VALUES (42194, '2020-07-14', 'JP', 'Japan', 'WPRO', '352', '22220', '0', '982');
INSERT INTO public.who_global_data_import VALUES (42195, '2020-07-15', 'JP', 'Japan', 'WPRO', '288', '22508', '2', '984');
INSERT INTO public.who_global_data_import VALUES (42196, '2020-07-16', 'JP', 'Japan', 'WPRO', '382', '22890', '1', '985');
INSERT INTO public.who_global_data_import VALUES (42197, '2020-07-17', 'JP', 'Japan', 'WPRO', '583', '23473', '0', '985');
INSERT INTO public.who_global_data_import VALUES (42198, '2020-07-18', 'JP', 'Japan', 'WPRO', '659', '24132', '0', '985');
INSERT INTO public.who_global_data_import VALUES (42199, '2020-07-19', 'JP', 'Japan', 'WPRO', '510', '24642', '0', '985');
INSERT INTO public.who_global_data_import VALUES (42200, '2020-07-20', 'JP', 'Japan', 'WPRO', '454', '25096', '0', '985');
INSERT INTO public.who_global_data_import VALUES (42201, '2020-07-21', 'JP', 'Japan', 'WPRO', '640', '25736', '3', '988');
INSERT INTO public.who_global_data_import VALUES (42202, '2020-07-22', 'JP', 'Japan', 'WPRO', '567', '26303', '1', '989');
INSERT INTO public.who_global_data_import VALUES (42203, '2020-07-23', 'JP', 'Japan', 'WPRO', '726', '27029', '1', '990');
INSERT INTO public.who_global_data_import VALUES (42204, '2020-07-24', 'JP', 'Japan', 'WPRO', '927', '27956', '2', '992');
INSERT INTO public.who_global_data_import VALUES (42205, '2020-07-25', 'JP', 'Japan', 'WPRO', '830', '28786', '1', '993');
INSERT INTO public.who_global_data_import VALUES (42206, '2020-07-26', 'JP', 'Japan', 'WPRO', '596', '29382', '3', '996');
INSERT INTO public.who_global_data_import VALUES (42207, '2020-07-27', 'JP', 'Japan', 'WPRO', '607', '29989', '0', '996');
INSERT INTO public.who_global_data_import VALUES (42208, '2020-07-28', 'JP', 'Japan', 'WPRO', '972', '30961', '2', '998');
INSERT INTO public.who_global_data_import VALUES (42209, '2020-07-29', 'JP', 'Japan', 'WPRO', '940', '31901', '3', '1001');
INSERT INTO public.who_global_data_import VALUES (42210, '2020-07-30', 'JP', 'Japan', 'WPRO', '1148', '33049', '3', '1004');
INSERT INTO public.who_global_data_import VALUES (42211, '2020-07-31', 'JP', 'Japan', 'WPRO', '1323', '34372', '2', '1006');
INSERT INTO public.who_global_data_import VALUES (42212, '2020-08-01', 'JP', 'Japan', 'WPRO', '1464', '35836', '5', '1011');
INSERT INTO public.who_global_data_import VALUES (42213, '2020-08-02', 'JP', 'Japan', 'WPRO', '853', '36689', '0', '1011');
INSERT INTO public.who_global_data_import VALUES (42214, '2020-08-03', 'JP', 'Japan', 'WPRO', '1998', '38687', '1', '1012');
INSERT INTO public.who_global_data_import VALUES (42215, '2020-08-04', 'JP', 'Japan', 'WPRO', '1171', '39858', '4', '1016');
INSERT INTO public.who_global_data_import VALUES (42216, '2020-08-05', 'JP', 'Japan', 'WPRO', '1271', '41129', '6', '1022');
INSERT INTO public.who_global_data_import VALUES (42217, '2020-08-06', 'JP', 'Japan', 'WPRO', '1134', '42263', '4', '1026');
INSERT INTO public.who_global_data_import VALUES (42218, '2020-08-07', 'JP', 'Japan', 'WPRO', '1552', '43815', '7', '1033');
INSERT INTO public.who_global_data_import VALUES (42219, '2020-08-08', 'JP', 'Japan', 'WPRO', '1624', '45439', '6', '1039');
INSERT INTO public.who_global_data_import VALUES (42220, '2020-08-09', 'JP', 'Japan', 'WPRO', '1344', '46783', '1', '1040');
INSERT INTO public.who_global_data_import VALUES (42221, '2020-08-10', 'JP', 'Japan', 'WPRO', '1207', '47990', '7', '1047');
INSERT INTO public.who_global_data_import VALUES (42222, '2020-08-11', 'JP', 'Japan', 'WPRO', '938', '48928', '5', '1052');
INSERT INTO public.who_global_data_import VALUES (42223, '2020-08-12', 'JP', 'Japan', 'WPRO', '1282', '50210', '7', '1059');
INSERT INTO public.who_global_data_import VALUES (42224, '2020-08-13', 'JP', 'Japan', 'WPRO', '937', '51147', '4', '1063');
INSERT INTO public.who_global_data_import VALUES (42225, '2020-08-14', 'JP', 'Japan', 'WPRO', '1070', '52217', '10', '1073');
INSERT INTO public.who_global_data_import VALUES (42226, '2020-08-15', 'JP', 'Japan', 'WPRO', '1360', '53577', '12', '1085');
INSERT INTO public.who_global_data_import VALUES (42227, '2020-08-16', 'JP', 'Japan', 'WPRO', '1137', '54714', '3', '1088');
INSERT INTO public.who_global_data_import VALUES (42228, '2020-08-17', 'JP', 'Japan', 'WPRO', '953', '55667', '11', '1099');
INSERT INTO public.who_global_data_import VALUES (42229, '2020-08-18', 'JP', 'Japan', 'WPRO', '1018', '56685', '16', '1115');
INSERT INTO public.who_global_data_import VALUES (42230, '2020-08-19', 'JP', 'Japan', 'WPRO', '865', '57550', '13', '1128');
INSERT INTO public.who_global_data_import VALUES (42231, '2020-08-20', 'JP', 'Japan', 'WPRO', '951', '58501', '16', '1144');
INSERT INTO public.who_global_data_import VALUES (42232, '2020-08-21', 'JP', 'Japan', 'WPRO', '1220', '59721', '11', '1155');
INSERT INTO public.who_global_data_import VALUES (42233, '2020-08-22', 'JP', 'Japan', 'WPRO', '1012', '60733', '14', '1169');
INSERT INTO public.who_global_data_import VALUES (42234, '2020-08-23', 'JP', 'Japan', 'WPRO', '1014', '61747', '7', '1176');
INSERT INTO public.who_global_data_import VALUES (42235, '2020-08-24', 'JP', 'Japan', 'WPRO', '760', '62507', '5', '1181');
INSERT INTO public.who_global_data_import VALUES (42236, '2020-08-25', 'JP', 'Japan', 'WPRO', '614', '63121', '15', '1196');
INSERT INTO public.who_global_data_import VALUES (42237, '2020-08-26', 'JP', 'Japan', 'WPRO', '701', '63822', '13', '1209');
INSERT INTO public.who_global_data_import VALUES (42238, '2020-08-27', 'JP', 'Japan', 'WPRO', '846', '64668', '17', '1226');
INSERT INTO public.who_global_data_import VALUES (42239, '2020-08-28', 'JP', 'Japan', 'WPRO', '905', '65573', '12', '1238');
INSERT INTO public.who_global_data_import VALUES (42240, '2020-08-29', 'JP', 'Japan', 'WPRO', '850', '66423', '17', '1255');
INSERT INTO public.who_global_data_import VALUES (42241, '2020-08-30', 'JP', 'Japan', 'WPRO', '841', '67264', '9', '1264');
INSERT INTO public.who_global_data_import VALUES (42242, '2020-08-31', 'JP', 'Japan', 'WPRO', '601', '67865', '15', '1279');
INSERT INTO public.who_global_data_import VALUES (42243, '2020-09-01', 'JP', 'Japan', 'WPRO', '527', '68392', '17', '1296');
INSERT INTO public.who_global_data_import VALUES (42244, '2020-09-02', 'JP', 'Japan', 'WPRO', '609', '69001', '11', '1307');
INSERT INTO public.who_global_data_import VALUES (42245, '2020-09-03', 'JP', 'Japan', 'WPRO', '598', '69599', '12', '1319');
INSERT INTO public.who_global_data_import VALUES (42246, '2020-09-04', 'JP', 'Japan', 'WPRO', '669', '70268', '11', '1330');
INSERT INTO public.who_global_data_import VALUES (42247, '2020-09-05', 'JP', 'Japan', 'WPRO', '608', '70876', '19', '1349');
INSERT INTO public.who_global_data_import VALUES (42248, '2020-09-06', 'JP', 'Japan', 'WPRO', '543', '71419', '8', '1357');
INSERT INTO public.who_global_data_import VALUES (42249, '2020-09-07', 'JP', 'Japan', 'WPRO', '437', '71856', '6', '1363');
INSERT INTO public.who_global_data_import VALUES (42250, '2020-09-08', 'JP', 'Japan', 'WPRO', '378', '72234', '14', '1377');
INSERT INTO public.who_global_data_import VALUES (42251, '2020-09-09', 'JP', 'Japan', 'WPRO', '492', '72726', '16', '1393');
INSERT INTO public.who_global_data_import VALUES (42252, '2020-09-10', 'JP', 'Japan', 'WPRO', '495', '73221', '13', '1406');
INSERT INTO public.who_global_data_import VALUES (42253, '2020-09-11', 'JP', 'Japan', 'WPRO', '680', '73901', '6', '1412');
INSERT INTO public.who_global_data_import VALUES (42254, '2020-09-12', 'JP', 'Japan', 'WPRO', '643', '74544', '11', '1423');
INSERT INTO public.who_global_data_import VALUES (42255, '2020-09-13', 'JP', 'Japan', 'WPRO', '674', '75218', '16', '1439');
INSERT INTO public.who_global_data_import VALUES (42256, '2020-09-14', 'JP', 'Japan', 'WPRO', '439', '75657', '3', '1442');
INSERT INTO public.who_global_data_import VALUES (42257, '2020-09-15', 'JP', 'Japan', 'WPRO', '301', '75958', '9', '1451');
INSERT INTO public.who_global_data_import VALUES (42258, '2020-09-16', 'JP', 'Japan', 'WPRO', '490', '76448', '10', '1461');
INSERT INTO public.who_global_data_import VALUES (42259, '2020-09-17', 'JP', 'Japan', 'WPRO', '561', '77009', '12', '1473');
INSERT INTO public.who_global_data_import VALUES (42260, '2020-09-18', 'JP', 'Japan', 'WPRO', '485', '77494', '9', '1482');
INSERT INTO public.who_global_data_import VALUES (42261, '2020-09-19', 'JP', 'Japan', 'WPRO', '579', '78073', '13', '1495');
INSERT INTO public.who_global_data_import VALUES (42262, '2020-09-20', 'JP', 'Japan', 'WPRO', '584', '78657', '5', '1500');
INSERT INTO public.who_global_data_import VALUES (42263, '2020-09-21', 'JP', 'Japan', 'WPRO', '483', '79140', '0', '1500');
INSERT INTO public.who_global_data_import VALUES (42264, '2020-09-22', 'JP', 'Japan', 'WPRO', '298', '79438', '8', '1508');
INSERT INTO public.who_global_data_import VALUES (42265, '2020-09-23', 'JP', 'Japan', 'WPRO', '330', '79768', '4', '1512');
INSERT INTO public.who_global_data_import VALUES (42266, '2020-09-24', 'JP', 'Japan', 'WPRO', '273', '80041', '8', '1520');
INSERT INTO public.who_global_data_import VALUES (42267, '2020-09-25', 'JP', 'Japan', 'WPRO', '456', '80497', '12', '1532');
INSERT INTO public.who_global_data_import VALUES (42268, '2020-09-26', 'JP', 'Japan', 'WPRO', '558', '81055', '8', '1540');
INSERT INTO public.who_global_data_import VALUES (42269, '2020-09-27', 'JP', 'Japan', 'WPRO', '635', '81690', '5', '1545');
INSERT INTO public.who_global_data_import VALUES (42270, '2020-09-28', 'JP', 'Japan', 'WPRO', '441', '82131', '3', '1548');
INSERT INTO public.who_global_data_import VALUES (42271, '2020-09-29', 'JP', 'Japan', 'WPRO', '363', '82494', '9', '1557');
INSERT INTO public.who_global_data_import VALUES (42272, '2020-09-30', 'JP', 'Japan', 'WPRO', '516', '83010', '7', '1564');
INSERT INTO public.who_global_data_import VALUES (42273, '2020-10-01', 'JP', 'Japan', 'WPRO', '553', '83563', '7', '1571');
INSERT INTO public.who_global_data_import VALUES (42274, '2020-10-02', 'JP', 'Japan', 'WPRO', '652', '84215', '7', '1578');
INSERT INTO public.who_global_data_import VALUES (42275, '2020-10-03', 'JP', 'Japan', 'WPRO', '553', '84768', '12', '1590');
INSERT INTO public.who_global_data_import VALUES (42276, '2020-10-04', 'JP', 'Japan', 'WPRO', '571', '85339', '7', '1597');
INSERT INTO public.who_global_data_import VALUES (42277, '2020-10-05', 'JP', 'Japan', 'WPRO', '400', '85739', '2', '1599');
INSERT INTO public.who_global_data_import VALUES (42278, '2020-10-06', 'JP', 'Japan', 'WPRO', '308', '86047', '3', '1602');
INSERT INTO public.who_global_data_import VALUES (42279, '2020-10-07', 'JP', 'Japan', 'WPRO', '496', '86543', '3', '1605');
INSERT INTO public.who_global_data_import VALUES (42280, '2020-10-08', 'JP', 'Japan', 'WPRO', '477', '87020', '8', '1613');
INSERT INTO public.who_global_data_import VALUES (42281, '2020-10-09', 'JP', 'Japan', 'WPRO', '619', '87639', '3', '1616');
INSERT INTO public.who_global_data_import VALUES (42282, '2020-10-10', 'JP', 'Japan', 'WPRO', '594', '88233', '8', '1624');
INSERT INTO public.who_global_data_import VALUES (42283, '2020-10-11', 'JP', 'Japan', 'WPRO', '679', '88912', '3', '1627');
INSERT INTO public.who_global_data_import VALUES (42284, '2020-10-12', 'JP', 'Japan', 'WPRO', '435', '89347', '2', '1629');
INSERT INTO public.who_global_data_import VALUES (42285, '2020-10-13', 'JP', 'Japan', 'WPRO', '326', '89673', '5', '1634');
INSERT INTO public.who_global_data_import VALUES (42286, '2020-10-14', 'JP', 'Japan', 'WPRO', '467', '90140', '4', '1638');
INSERT INTO public.who_global_data_import VALUES (42287, '2020-10-15', 'JP', 'Japan', 'WPRO', '570', '90710', '8', '1646');
INSERT INTO public.who_global_data_import VALUES (42288, '2020-10-16', 'JP', 'Japan', 'WPRO', '721', '91431', '4', '1650');
INSERT INTO public.who_global_data_import VALUES (42289, '2020-10-17', 'JP', 'Japan', 'WPRO', '632', '92063', '11', '1661');
INSERT INTO public.who_global_data_import VALUES (42290, '2020-10-18', 'JP', 'Japan', 'WPRO', '593', '92656', '9', '1670');
INSERT INTO public.who_global_data_import VALUES (42291, '2020-10-19', 'JP', 'Japan', 'WPRO', '471', '93127', '4', '1674');
INSERT INTO public.who_global_data_import VALUES (42292, '2020-10-20', 'JP', 'Japan', 'WPRO', '353', '93480', '2', '1676');
INSERT INTO public.who_global_data_import VALUES (42293, '2020-10-21', 'JP', 'Japan', 'WPRO', '453', '93933', '3', '1679');
INSERT INTO public.who_global_data_import VALUES (42294, '2020-10-22', 'JP', 'Japan', 'WPRO', '591', '94524', '6', '1685');
INSERT INTO public.who_global_data_import VALUES (42295, '2020-10-23', 'JP', 'Japan', 'WPRO', '614', '95138', '9', '1694');
INSERT INTO public.who_global_data_import VALUES (42296, '2020-10-24', 'JP', 'Japan', 'WPRO', '697', '95835', '12', '1706');
INSERT INTO public.who_global_data_import VALUES (42297, '2020-10-25', 'JP', 'Japan', 'WPRO', '699', '96534', '5', '1711');
INSERT INTO public.who_global_data_import VALUES (42298, '2020-10-26', 'JP', 'Japan', 'WPRO', '540', '97074', '7', '1718');
INSERT INTO public.who_global_data_import VALUES (42299, '2020-10-27', 'JP', 'Japan', 'WPRO', '424', '97498', '7', '1725');
INSERT INTO public.who_global_data_import VALUES (42300, '2020-10-28', 'JP', 'Japan', 'WPRO', '618', '98116', '5', '1730');
INSERT INTO public.who_global_data_import VALUES (42301, '2020-10-29', 'JP', 'Japan', 'WPRO', '736', '98852', '3', '1733');
INSERT INTO public.who_global_data_import VALUES (42302, '2020-10-30', 'JP', 'Japan', 'WPRO', '770', '99622', '11', '1744');
INSERT INTO public.who_global_data_import VALUES (42303, '2020-10-31', 'JP', 'Japan', 'WPRO', '770', '100392', '11', '1755');
INSERT INTO public.who_global_data_import VALUES (42304, '2020-11-01', 'JP', 'Japan', 'WPRO', '754', '101146', '11', '1766');
INSERT INTO public.who_global_data_import VALUES (42305, '2020-11-02', 'JP', 'Japan', 'WPRO', '667', '101813', '8', '1774');
INSERT INTO public.who_global_data_import VALUES (42306, '2020-11-03', 'JP', 'Japan', 'WPRO', '468', '102281', '6', '1780');
INSERT INTO public.who_global_data_import VALUES (42307, '2020-11-04', 'JP', 'Japan', 'WPRO', '619', '102900', '6', '1786');
INSERT INTO public.who_global_data_import VALUES (42308, '2020-11-05', 'JP', 'Japan', 'WPRO', '938', '103838', '8', '1794');
INSERT INTO public.who_global_data_import VALUES (42309, '2020-11-06', 'JP', 'Japan', 'WPRO', '944', '104782', '12', '1806');
INSERT INTO public.who_global_data_import VALUES (42310, '2020-11-07', 'JP', 'Japan', 'WPRO', '1132', '105914', '3', '1809');
INSERT INTO public.who_global_data_import VALUES (42311, '2020-11-08', 'JP', 'Japan', 'WPRO', '1172', '107086', '3', '1812');
INSERT INTO public.who_global_data_import VALUES (42312, '2020-11-09', 'JP', 'Japan', 'WPRO', '998', '108084', '6', '1818');
INSERT INTO public.who_global_data_import VALUES (42313, '2020-11-10', 'JP', 'Japan', 'WPRO', '899', '108983', '11', '1829');
INSERT INTO public.who_global_data_import VALUES (42314, '2020-11-11', 'JP', 'Japan', 'WPRO', '1173', '110156', '12', '1841');
INSERT INTO public.who_global_data_import VALUES (42315, '2020-11-12', 'JP', 'Japan', 'WPRO', '1555', '111711', '10', '1851');
INSERT INTO public.who_global_data_import VALUES (42316, '2020-11-13', 'JP', 'Japan', 'WPRO', '1587', '113298', '16', '1867');
INSERT INTO public.who_global_data_import VALUES (42317, '2020-11-14', 'JP', 'Japan', 'WPRO', '1685', '114983', '13', '1880');
INSERT INTO public.who_global_data_import VALUES (42318, '2020-11-15', 'JP', 'Japan', 'WPRO', '1694', '116677', '3', '1883');
INSERT INTO public.who_global_data_import VALUES (42319, '2020-11-16', 'JP', 'Japan', 'WPRO', '1459', '118136', '2', '1885');
INSERT INTO public.who_global_data_import VALUES (42320, '2020-11-17', 'JP', 'Japan', 'WPRO', '1190', '119326', '18', '1903');
INSERT INTO public.who_global_data_import VALUES (42321, '2020-11-18', 'JP', 'Japan', 'WPRO', '1489', '120815', '10', '1913');
INSERT INTO public.who_global_data_import VALUES (42322, '2020-11-19', 'JP', 'Japan', 'WPRO', '2151', '122966', '9', '1922');
INSERT INTO public.who_global_data_import VALUES (42323, '2020-11-20', 'JP', 'Japan', 'WPRO', '2301', '125267', '21', '1943');
INSERT INTO public.who_global_data_import VALUES (42324, '2020-11-21', 'JP', 'Japan', 'WPRO', '2398', '127665', '20', '1963');
INSERT INTO public.who_global_data_import VALUES (42325, '2020-11-22', 'JP', 'Japan', 'WPRO', '2514', '130179', '11', '1974');
INSERT INTO public.who_global_data_import VALUES (42326, '2020-11-23', 'JP', 'Japan', 'WPRO', '2179', '132358', '7', '1981');
INSERT INTO public.who_global_data_import VALUES (42327, '2020-11-24', 'JP', 'Japan', 'WPRO', '1571', '133929', '8', '1989');
INSERT INTO public.who_global_data_import VALUES (42328, '2020-11-25', 'JP', 'Japan', 'WPRO', '1471', '135400', '12', '2001');
INSERT INTO public.who_global_data_import VALUES (42329, '2020-11-26', 'JP', 'Japan', 'WPRO', '1861', '137261', '21', '2022');
INSERT INTO public.who_global_data_import VALUES (42330, '2020-11-27', 'JP', 'Japan', 'WPRO', '2230', '139491', '29', '2051');
INSERT INTO public.who_global_data_import VALUES (42331, '2020-11-28', 'JP', 'Japan', 'WPRO', '2577', '142068', '23', '2074');
INSERT INTO public.who_global_data_import VALUES (42332, '2020-11-29', 'JP', 'Japan', 'WPRO', '2585', '144653', '32', '2106');
INSERT INTO public.who_global_data_import VALUES (42333, '2020-11-30', 'JP', 'Japan', 'WPRO', '2107', '146760', '13', '2119');
INSERT INTO public.who_global_data_import VALUES (42334, '2020-12-01', 'JP', 'Japan', 'WPRO', '1934', '148694', '20', '2139');
INSERT INTO public.who_global_data_import VALUES (42335, '2020-12-02', 'JP', 'Japan', 'WPRO', '1692', '150386', '33', '2172');
INSERT INTO public.who_global_data_import VALUES (42336, '2020-12-03', 'JP', 'Japan', 'WPRO', '2441', '152827', '41', '2213');
INSERT INTO public.who_global_data_import VALUES (42337, '2020-12-04', 'JP', 'Japan', 'WPRO', '2405', '155232', '27', '2240');
INSERT INTO public.who_global_data_import VALUES (42338, '2020-12-05', 'JP', 'Japan', 'WPRO', '2442', '157674', '43', '2283');
INSERT INTO public.who_global_data_import VALUES (42339, '2020-12-06', 'JP', 'Japan', 'WPRO', '2424', '160098', '32', '2315');
INSERT INTO public.who_global_data_import VALUES (42340, '2020-12-07', 'JP', 'Japan', 'WPRO', '1969', '162067', '20', '2335');
INSERT INTO public.who_global_data_import VALUES (42341, '2020-12-08', 'JP', 'Japan', 'WPRO', '1862', '163929', '47', '2382');
INSERT INTO public.who_global_data_import VALUES (42342, '2020-12-09', 'JP', 'Japan', 'WPRO', '1911', '165840', '38', '2420');
INSERT INTO public.who_global_data_import VALUES (42343, '2020-12-10', 'JP', 'Japan', 'WPRO', '2733', '168573', '45', '2465');
INSERT INTO public.who_global_data_import VALUES (42344, '2020-12-11', 'JP', 'Japan', 'WPRO', '2969', '171542', '37', '2502');
INSERT INTO public.who_global_data_import VALUES (42345, '2020-12-12', 'JP', 'Japan', 'WPRO', '2757', '174299', '32', '2534');
INSERT INTO public.who_global_data_import VALUES (42346, '2020-12-13', 'JP', 'Japan', 'WPRO', '2988', '177287', '28', '2562');
INSERT INTO public.who_global_data_import VALUES (42347, '2020-12-14', 'JP', 'Japan', 'WPRO', '2366', '179653', '23', '2585');
INSERT INTO public.who_global_data_import VALUES (42348, '2020-12-15', 'JP', 'Japan', 'WPRO', '2217', '181870', '58', '2643');
INSERT INTO public.who_global_data_import VALUES (42349, '2020-12-16', 'JP', 'Japan', 'WPRO', '2172', '184042', '45', '2688');
INSERT INTO public.who_global_data_import VALUES (42350, '2020-12-17', 'JP', 'Japan', 'WPRO', '3061', '187103', '51', '2739');
INSERT INTO public.who_global_data_import VALUES (42351, '2020-12-18', 'JP', 'Japan', 'WPRO', '3035', '190138', '44', '2783');
INSERT INTO public.who_global_data_import VALUES (42352, '2020-12-19', 'JP', 'Japan', 'WPRO', '2893', '193031', '45', '2828');
INSERT INTO public.who_global_data_import VALUES (42353, '2020-12-20', 'JP', 'Japan', 'WPRO', '2849', '195880', '45', '2873');
INSERT INTO public.who_global_data_import VALUES (42354, '2020-12-21', 'JP', 'Japan', 'WPRO', '2643', '198523', '27', '2900');
INSERT INTO public.who_global_data_import VALUES (42355, '2020-12-22', 'JP', 'Japan', 'WPRO', '2135', '200658', '44', '2944');
INSERT INTO public.who_global_data_import VALUES (42356, '2020-12-23', 'JP', 'Japan', 'WPRO', '2455', '203113', '50', '2994');
INSERT INTO public.who_global_data_import VALUES (42357, '2020-12-24', 'JP', 'Japan', 'WPRO', '3026', '206139', '56', '3050');
INSERT INTO public.who_global_data_import VALUES (42358, '2020-12-25', 'JP', 'Japan', 'WPRO', '3841', '209980', '55', '3105');
INSERT INTO public.who_global_data_import VALUES (42359, '2020-12-26', 'JP', 'Japan', 'WPRO', '3567', '213547', '50', '3155');
INSERT INTO public.who_global_data_import VALUES (42360, '2020-12-27', 'JP', 'Japan', 'WPRO', '3765', '217312', '58', '3213');
INSERT INTO public.who_global_data_import VALUES (42361, '2020-12-28', 'JP', 'Japan', 'WPRO', '2924', '220236', '39', '3252');
INSERT INTO public.who_global_data_import VALUES (42362, '2020-12-29', 'JP', 'Japan', 'WPRO', '2884', '223120', '54', '3306');
INSERT INTO public.who_global_data_import VALUES (42363, '2020-12-30', 'JP', 'Japan', 'WPRO', '3476', '226596', '43', '3349');
INSERT INTO public.who_global_data_import VALUES (42364, '2020-12-31', 'JP', 'Japan', 'WPRO', '3708', '230304', '65', '3414');
INSERT INTO public.who_global_data_import VALUES (42365, '2021-01-01', 'JP', 'Japan', 'WPRO', '4091', '234395', '46', '3460');
INSERT INTO public.who_global_data_import VALUES (42366, '2021-01-02', 'JP', 'Japan', 'WPRO', '3617', '238012', '54', '3514');
INSERT INTO public.who_global_data_import VALUES (42367, '2021-01-03', 'JP', 'Japan', 'WPRO', '2942', '240954', '34', '3548');
INSERT INTO public.who_global_data_import VALUES (42368, '2021-01-04', 'JP', 'Japan', 'WPRO', '2893', '243847', '51', '3599');
INSERT INTO public.who_global_data_import VALUES (42369, '2021-01-05', 'JP', 'Japan', 'WPRO', '4113', '247960', '56', '3655');
INSERT INTO public.who_global_data_import VALUES (42370, '2021-01-06', 'JP', 'Japan', 'WPRO', '4357', '252317', '64', '3719');
INSERT INTO public.who_global_data_import VALUES (42371, '2021-01-07', 'JP', 'Japan', 'WPRO', '6076', '258393', '72', '3791');
INSERT INTO public.who_global_data_import VALUES (42372, '2021-01-08', 'JP', 'Japan', 'WPRO', '6906', '265299', '66', '3857');
INSERT INTO public.who_global_data_import VALUES (42373, '2021-01-09', 'JP', 'Japan', 'WPRO', '7855', '273154', '75', '3932');
INSERT INTO public.who_global_data_import VALUES (42374, '2021-01-10', 'JP', 'Japan', 'WPRO', '7621', '280775', '64', '3996');
INSERT INTO public.who_global_data_import VALUES (42375, '2021-01-11', 'JP', 'Japan', 'WPRO', '5977', '286752', '48', '4044');
INSERT INTO public.who_global_data_import VALUES (42376, '2021-01-12', 'JP', 'Japan', 'WPRO', '5460', '292212', '50', '4094');
INSERT INTO public.who_global_data_import VALUES (42377, '2021-01-13', 'JP', 'Japan', 'WPRO', '5103', '297315', '51', '4145');
INSERT INTO public.who_global_data_import VALUES (42378, '2021-01-14', 'JP', 'Japan', 'WPRO', '5308', '302623', '88', '4233');
INSERT INTO public.who_global_data_import VALUES (42379, '2021-01-15', 'JP', 'Japan', 'WPRO', '6591', '309214', '82', '4315');
INSERT INTO public.who_global_data_import VALUES (42380, '2021-01-16', 'JP', 'Japan', 'WPRO', '6696', '315910', '65', '4380');
INSERT INTO public.who_global_data_import VALUES (42381, '2021-01-17', 'JP', 'Japan', 'WPRO', '6386', '322296', '66', '4446');
INSERT INTO public.who_global_data_import VALUES (42382, '2021-01-18', 'JP', 'Japan', 'WPRO', '5998', '328294', '55', '4501');
INSERT INTO public.who_global_data_import VALUES (42383, '2021-01-19', 'JP', 'Japan', 'WPRO', '6034', '334328', '47', '4548');
INSERT INTO public.who_global_data_import VALUES (42384, '2021-01-20', 'JP', 'Japan', 'WPRO', '5446', '339774', '99', '4647');
INSERT INTO public.who_global_data_import VALUES (42385, '2021-01-21', 'JP', 'Japan', 'WPRO', '5447', '345221', '96', '4743');
INSERT INTO public.who_global_data_import VALUES (42386, '2021-01-22', 'JP', 'Japan', 'WPRO', '5799', '351020', '87', '4830');
INSERT INTO public.who_global_data_import VALUES (42387, '2021-01-23', 'JP', 'Japan', 'WPRO', '5054', '356074', '105', '4935');
INSERT INTO public.who_global_data_import VALUES (42388, '2021-01-24', 'JP', 'Japan', 'WPRO', '4587', '360661', '84', '5019');
INSERT INTO public.who_global_data_import VALUES (42389, '2021-01-25', 'JP', 'Japan', 'WPRO', '4152', '364813', '65', '5084');
INSERT INTO public.who_global_data_import VALUES (42390, '2021-01-26', 'JP', 'Japan', 'WPRO', '3330', '368143', '74', '5158');
INSERT INTO public.who_global_data_import VALUES (42391, '2021-01-27', 'JP', 'Japan', 'WPRO', '3537', '371680', '94', '5252');
INSERT INTO public.who_global_data_import VALUES (42392, '2021-01-28', 'JP', 'Japan', 'WPRO', '3927', '375607', '109', '5361');
INSERT INTO public.who_global_data_import VALUES (42393, '2021-01-29', 'JP', 'Japan', 'WPRO', '3909', '379516', '91', '5452');
INSERT INTO public.who_global_data_import VALUES (42394, '2021-01-30', 'JP', 'Japan', 'WPRO', '3567', '383083', '94', '5546');
INSERT INTO public.who_global_data_import VALUES (42395, '2021-01-31', 'JP', 'Japan', 'WPRO', '3659', '386742', '108', '5654');
INSERT INTO public.who_global_data_import VALUES (42396, '2021-02-01', 'JP', 'Japan', 'WPRO', '2776', '389518', '68', '5722');
INSERT INTO public.who_global_data_import VALUES (42397, '2021-02-02', 'JP', 'Japan', 'WPRO', '2108', '391626', '72', '5794');
INSERT INTO public.who_global_data_import VALUES (42398, '2021-02-03', 'JP', 'Japan', 'WPRO', '2210', '393836', '118', '5912');
INSERT INTO public.who_global_data_import VALUES (42399, '2021-02-04', 'JP', 'Japan', 'WPRO', '2593', '396429', '108', '6020');
INSERT INTO public.who_global_data_import VALUES (42400, '2021-02-05', 'JP', 'Japan', 'WPRO', '2619', '399048', '115', '6135');
INSERT INTO public.who_global_data_import VALUES (42401, '2020-01-03', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42402, '2020-01-04', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42403, '2020-01-05', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42404, '2020-01-06', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42405, '2020-01-07', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42406, '2020-01-08', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42407, '2020-01-09', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42408, '2020-01-10', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42409, '2020-01-11', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42410, '2020-01-12', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42411, '2020-01-13', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42412, '2020-01-14', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42413, '2020-01-15', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42414, '2020-01-16', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42415, '2020-01-17', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42416, '2020-01-18', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42417, '2020-01-19', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42418, '2020-01-20', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42419, '2020-01-21', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42420, '2020-01-22', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42421, '2020-01-23', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42422, '2020-01-24', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42423, '2020-01-25', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42424, '2020-01-26', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42425, '2020-01-27', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42426, '2020-01-28', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42427, '2020-01-29', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42428, '2020-01-30', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42429, '2020-01-31', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42430, '2020-02-01', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42431, '2020-02-02', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42432, '2020-02-03', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42433, '2020-02-04', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42434, '2020-02-05', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42435, '2020-02-06', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42436, '2020-02-07', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42437, '2020-02-08', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42438, '2020-02-09', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42439, '2020-02-10', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42440, '2020-02-11', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42441, '2020-02-12', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42442, '2020-02-13', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42443, '2020-02-14', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42444, '2020-02-15', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42445, '2020-02-16', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42446, '2020-02-17', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42447, '2020-02-18', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42448, '2020-02-19', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42449, '2020-02-20', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42450, '2020-02-21', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42451, '2020-02-22', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42452, '2020-02-23', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42453, '2020-02-24', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42454, '2020-02-25', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42455, '2020-02-26', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42456, '2020-02-27', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42457, '2020-02-28', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42458, '2020-02-29', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42459, '2020-03-01', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42460, '2020-03-02', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42461, '2020-03-03', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42462, '2020-03-04', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42463, '2020-03-05', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42464, '2020-03-06', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42465, '2020-03-07', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42466, '2020-03-08', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42467, '2020-03-09', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42468, '2020-03-10', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42469, '2020-03-11', 'JE', 'Jersey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42470, '2020-03-12', 'JE', 'Jersey', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42471, '2020-03-13', 'JE', 'Jersey', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42472, '2020-03-14', 'JE', 'Jersey', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42473, '2020-03-15', 'JE', 'Jersey', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42474, '2020-03-16', 'JE', 'Jersey', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42475, '2020-03-17', 'JE', 'Jersey', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42476, '2020-03-18', 'JE', 'Jersey', 'EURO', '3', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42477, '2020-03-19', 'JE', 'Jersey', 'EURO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42478, '2020-03-20', 'JE', 'Jersey', 'EURO', '7', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42479, '2020-03-21', 'JE', 'Jersey', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42480, '2020-03-22', 'JE', 'Jersey', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42481, '2020-03-23', 'JE', 'Jersey', 'EURO', '3', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42482, '2020-03-24', 'JE', 'Jersey', 'EURO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42483, '2020-03-25', 'JE', 'Jersey', 'EURO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42484, '2020-03-26', 'JE', 'Jersey', 'EURO', '2', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42485, '2020-03-27', 'JE', 'Jersey', 'EURO', '14', '32', '1', '1');
INSERT INTO public.who_global_data_import VALUES (42486, '2020-03-28', 'JE', 'Jersey', 'EURO', '20', '52', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42487, '2020-03-29', 'JE', 'Jersey', 'EURO', '9', '61', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42488, '2020-03-30', 'JE', 'Jersey', 'EURO', '2', '63', '1', '2');
INSERT INTO public.who_global_data_import VALUES (42489, '2020-03-31', 'JE', 'Jersey', 'EURO', '0', '63', '0', '2');
INSERT INTO public.who_global_data_import VALUES (42490, '2020-04-01', 'JE', 'Jersey', 'EURO', '0', '63', '0', '2');
INSERT INTO public.who_global_data_import VALUES (42491, '2020-04-02', 'JE', 'Jersey', 'EURO', '18', '81', '0', '2');
INSERT INTO public.who_global_data_import VALUES (42492, '2020-04-03', 'JE', 'Jersey', 'EURO', '0', '81', '0', '2');
INSERT INTO public.who_global_data_import VALUES (42493, '2020-04-04', 'JE', 'Jersey', 'EURO', '37', '118', '0', '2');
INSERT INTO public.who_global_data_import VALUES (42494, '2020-04-05', 'JE', 'Jersey', 'EURO', '5', '123', '1', '3');
INSERT INTO public.who_global_data_import VALUES (42495, '2020-04-06', 'JE', 'Jersey', 'EURO', '32', '155', '0', '3');
INSERT INTO public.who_global_data_import VALUES (42496, '2020-04-07', 'JE', 'Jersey', 'EURO', '0', '155', '0', '3');
INSERT INTO public.who_global_data_import VALUES (42497, '2020-04-08', 'JE', 'Jersey', 'EURO', '15', '170', '0', '3');
INSERT INTO public.who_global_data_import VALUES (42498, '2020-04-09', 'JE', 'Jersey', 'EURO', '0', '170', '0', '3');
INSERT INTO public.who_global_data_import VALUES (42499, '2020-04-10', 'JE', 'Jersey', 'EURO', '0', '170', '0', '3');
INSERT INTO public.who_global_data_import VALUES (42500, '2020-04-11', 'JE', 'Jersey', 'EURO', '13', '183', '1', '4');
INSERT INTO public.who_global_data_import VALUES (42501, '2020-04-12', 'JE', 'Jersey', 'EURO', '15', '198', '0', '4');
INSERT INTO public.who_global_data_import VALUES (42502, '2020-04-13', 'JE', 'Jersey', 'EURO', '0', '198', '0', '4');
INSERT INTO public.who_global_data_import VALUES (42503, '2020-04-14', 'JE', 'Jersey', 'EURO', '15', '213', '0', '4');
INSERT INTO public.who_global_data_import VALUES (42504, '2020-04-15', 'JE', 'Jersey', 'EURO', '4', '217', '0', '4');
INSERT INTO public.who_global_data_import VALUES (42505, '2020-04-16', 'JE', 'Jersey', 'EURO', '0', '217', '2', '6');
INSERT INTO public.who_global_data_import VALUES (42506, '2020-04-17', 'JE', 'Jersey', 'EURO', '2', '219', '1', '7');
INSERT INTO public.who_global_data_import VALUES (42507, '2020-04-18', 'JE', 'Jersey', 'EURO', '4', '223', '3', '10');
INSERT INTO public.who_global_data_import VALUES (42508, '2020-04-19', 'JE', 'Jersey', 'EURO', '11', '234', '1', '11');
INSERT INTO public.who_global_data_import VALUES (42509, '2020-04-20', 'JE', 'Jersey', 'EURO', '11', '245', '1', '12');
INSERT INTO public.who_global_data_import VALUES (42510, '2020-04-21', 'JE', 'Jersey', 'EURO', '4', '249', '0', '12');
INSERT INTO public.who_global_data_import VALUES (42511, '2020-04-22', 'JE', 'Jersey', 'EURO', '1', '250', '2', '14');
INSERT INTO public.who_global_data_import VALUES (42512, '2020-04-23', 'JE', 'Jersey', 'EURO', '5', '255', '0', '14');
INSERT INTO public.who_global_data_import VALUES (42513, '2020-04-24', 'JE', 'Jersey', 'EURO', '0', '255', '4', '18');
INSERT INTO public.who_global_data_import VALUES (42514, '2020-04-25', 'JE', 'Jersey', 'EURO', '21', '276', '1', '19');
INSERT INTO public.who_global_data_import VALUES (42515, '2020-04-26', 'JE', 'Jersey', 'EURO', '2', '278', '0', '19');
INSERT INTO public.who_global_data_import VALUES (42516, '2020-04-27', 'JE', 'Jersey', 'EURO', '2', '280', '0', '19');
INSERT INTO public.who_global_data_import VALUES (42517, '2020-04-28', 'JE', 'Jersey', 'EURO', '1', '281', '0', '19');
INSERT INTO public.who_global_data_import VALUES (42518, '2020-04-29', 'JE', 'Jersey', 'EURO', '2', '283', '0', '19');
INSERT INTO public.who_global_data_import VALUES (42519, '2020-04-30', 'JE', 'Jersey', 'EURO', '1', '284', '1', '20');
INSERT INTO public.who_global_data_import VALUES (42520, '2020-05-01', 'JE', 'Jersey', 'EURO', '6', '290', '0', '20');
INSERT INTO public.who_global_data_import VALUES (42521, '2020-05-02', 'JE', 'Jersey', 'EURO', '0', '290', '2', '22');
INSERT INTO public.who_global_data_import VALUES (42522, '2020-05-03', 'JE', 'Jersey', 'EURO', '0', '290', '1', '23');
INSERT INTO public.who_global_data_import VALUES (42523, '2020-05-04', 'JE', 'Jersey', 'EURO', '1', '291', '1', '24');
INSERT INTO public.who_global_data_import VALUES (42524, '2020-05-05', 'JE', 'Jersey', 'EURO', '1', '292', '0', '24');
INSERT INTO public.who_global_data_import VALUES (42525, '2020-05-06', 'JE', 'Jersey', 'EURO', '1', '293', '0', '24');
INSERT INTO public.who_global_data_import VALUES (42526, '2020-05-07', 'JE', 'Jersey', 'EURO', '0', '293', '0', '24');
INSERT INTO public.who_global_data_import VALUES (42527, '2020-05-08', 'JE', 'Jersey', 'EURO', '0', '293', '1', '25');
INSERT INTO public.who_global_data_import VALUES (42528, '2020-05-09', 'JE', 'Jersey', 'EURO', '0', '293', '0', '25');
INSERT INTO public.who_global_data_import VALUES (42529, '2020-05-10', 'JE', 'Jersey', 'EURO', '0', '293', '0', '25');
INSERT INTO public.who_global_data_import VALUES (42530, '2020-05-11', 'JE', 'Jersey', 'EURO', '0', '293', '0', '25');
INSERT INTO public.who_global_data_import VALUES (42531, '2020-05-12', 'JE', 'Jersey', 'EURO', '3', '296', '1', '26');
INSERT INTO public.who_global_data_import VALUES (42532, '2020-05-13', 'JE', 'Jersey', 'EURO', '0', '296', '0', '26');
INSERT INTO public.who_global_data_import VALUES (42533, '2020-05-14', 'JE', 'Jersey', 'EURO', '1', '297', '1', '27');
INSERT INTO public.who_global_data_import VALUES (42534, '2020-05-15', 'JE', 'Jersey', 'EURO', '0', '297', '0', '27');
INSERT INTO public.who_global_data_import VALUES (42535, '2020-05-16', 'JE', 'Jersey', 'EURO', '0', '297', '0', '27');
INSERT INTO public.who_global_data_import VALUES (42536, '2020-05-17', 'JE', 'Jersey', 'EURO', '0', '297', '0', '27');
INSERT INTO public.who_global_data_import VALUES (42537, '2020-05-18', 'JE', 'Jersey', 'EURO', '0', '297', '0', '27');
INSERT INTO public.who_global_data_import VALUES (42538, '2020-05-19', 'JE', 'Jersey', 'EURO', '5', '302', '0', '27');
INSERT INTO public.who_global_data_import VALUES (42539, '2020-05-20', 'JE', 'Jersey', 'EURO', '1', '303', '0', '27');
INSERT INTO public.who_global_data_import VALUES (42540, '2020-05-21', 'JE', 'Jersey', 'EURO', '0', '303', '1', '28');
INSERT INTO public.who_global_data_import VALUES (42541, '2020-05-22', 'JE', 'Jersey', 'EURO', '3', '306', '1', '29');
INSERT INTO public.who_global_data_import VALUES (42542, '2020-05-23', 'JE', 'Jersey', 'EURO', '0', '306', '0', '29');
INSERT INTO public.who_global_data_import VALUES (42543, '2020-05-24', 'JE', 'Jersey', 'EURO', '0', '306', '0', '29');
INSERT INTO public.who_global_data_import VALUES (42544, '2020-05-25', 'JE', 'Jersey', 'EURO', '0', '306', '0', '29');
INSERT INTO public.who_global_data_import VALUES (42545, '2020-05-26', 'JE', 'Jersey', 'EURO', '0', '306', '0', '29');
INSERT INTO public.who_global_data_import VALUES (42546, '2020-05-27', 'JE', 'Jersey', 'EURO', '1', '307', '0', '29');
INSERT INTO public.who_global_data_import VALUES (42547, '2020-05-28', 'JE', 'Jersey', 'EURO', '0', '307', '0', '29');
INSERT INTO public.who_global_data_import VALUES (42548, '2020-05-29', 'JE', 'Jersey', 'EURO', '1', '308', '0', '29');
INSERT INTO public.who_global_data_import VALUES (42549, '2020-05-30', 'JE', 'Jersey', 'EURO', '0', '308', '0', '29');
INSERT INTO public.who_global_data_import VALUES (42550, '2020-05-31', 'JE', 'Jersey', 'EURO', '0', '308', '0', '29');
INSERT INTO public.who_global_data_import VALUES (42551, '2020-06-01', 'JE', 'Jersey', 'EURO', '0', '308', '0', '29');
INSERT INTO public.who_global_data_import VALUES (42552, '2020-06-02', 'JE', 'Jersey', 'EURO', '0', '308', '0', '29');
INSERT INTO public.who_global_data_import VALUES (42553, '2020-06-03', 'JE', 'Jersey', 'EURO', '0', '308', '0', '29');
INSERT INTO public.who_global_data_import VALUES (42554, '2020-06-04', 'JE', 'Jersey', 'EURO', '0', '308', '1', '30');
INSERT INTO public.who_global_data_import VALUES (42555, '2020-06-05', 'JE', 'Jersey', 'EURO', '1', '309', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42556, '2020-06-06', 'JE', 'Jersey', 'EURO', '0', '309', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42557, '2020-06-07', 'JE', 'Jersey', 'EURO', '0', '309', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42558, '2020-06-08', 'JE', 'Jersey', 'EURO', '2', '311', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42559, '2020-06-09', 'JE', 'Jersey', 'EURO', '0', '311', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42560, '2020-06-10', 'JE', 'Jersey', 'EURO', '2', '313', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42561, '2020-06-11', 'JE', 'Jersey', 'EURO', '0', '313', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42562, '2020-06-12', 'JE', 'Jersey', 'EURO', '0', '313', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42563, '2020-06-13', 'JE', 'Jersey', 'EURO', '0', '313', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42564, '2020-06-14', 'JE', 'Jersey', 'EURO', '0', '313', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42565, '2020-06-15', 'JE', 'Jersey', 'EURO', '0', '313', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42566, '2020-06-16', 'JE', 'Jersey', 'EURO', '0', '313', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42567, '2020-06-17', 'JE', 'Jersey', 'EURO', '3', '316', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42568, '2020-06-18', 'JE', 'Jersey', 'EURO', '0', '316', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42569, '2020-06-19', 'JE', 'Jersey', 'EURO', '2', '318', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42570, '2020-06-20', 'JE', 'Jersey', 'EURO', '0', '318', '0', '30');
INSERT INTO public.who_global_data_import VALUES (42571, '2020-06-21', 'JE', 'Jersey', 'EURO', '0', '318', '1', '31');
INSERT INTO public.who_global_data_import VALUES (42572, '2020-06-22', 'JE', 'Jersey', 'EURO', '0', '318', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42573, '2020-06-23', 'JE', 'Jersey', 'EURO', '0', '318', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42574, '2020-06-24', 'JE', 'Jersey', 'EURO', '0', '318', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42575, '2020-06-25', 'JE', 'Jersey', 'EURO', '0', '318', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42576, '2020-06-26', 'JE', 'Jersey', 'EURO', '2', '320', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42577, '2020-06-27', 'JE', 'Jersey', 'EURO', '0', '320', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42578, '2020-06-28', 'JE', 'Jersey', 'EURO', '0', '320', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42579, '2020-06-29', 'JE', 'Jersey', 'EURO', '0', '320', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42580, '2020-06-30', 'JE', 'Jersey', 'EURO', '0', '320', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42581, '2020-07-01', 'JE', 'Jersey', 'EURO', '0', '320', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42582, '2020-07-02', 'JE', 'Jersey', 'EURO', '0', '320', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42583, '2020-07-03', 'JE', 'Jersey', 'EURO', '0', '320', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42584, '2020-07-04', 'JE', 'Jersey', 'EURO', '0', '320', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42585, '2020-07-05', 'JE', 'Jersey', 'EURO', '0', '320', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42586, '2020-07-06', 'JE', 'Jersey', 'EURO', '0', '320', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42587, '2020-07-07', 'JE', 'Jersey', 'EURO', '0', '320', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42588, '2020-07-08', 'JE', 'Jersey', 'EURO', '5', '325', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42589, '2020-07-09', 'JE', 'Jersey', 'EURO', '0', '325', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42590, '2020-07-10', 'JE', 'Jersey', 'EURO', '0', '325', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42591, '2020-07-11', 'JE', 'Jersey', 'EURO', '0', '325', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42592, '2020-07-12', 'JE', 'Jersey', 'EURO', '0', '325', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42593, '2020-07-13', 'JE', 'Jersey', 'EURO', '0', '325', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42594, '2020-07-14', 'JE', 'Jersey', 'EURO', '4', '329', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42595, '2020-07-15', 'JE', 'Jersey', 'EURO', '0', '329', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42596, '2020-07-16', 'JE', 'Jersey', 'EURO', '0', '329', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42597, '2020-07-17', 'JE', 'Jersey', 'EURO', '0', '329', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42598, '2020-07-18', 'JE', 'Jersey', 'EURO', '2', '331', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42599, '2020-07-19', 'JE', 'Jersey', 'EURO', '0', '331', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42600, '2020-07-20', 'JE', 'Jersey', 'EURO', '0', '331', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42601, '2020-07-21', 'JE', 'Jersey', 'EURO', '0', '331', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42602, '2020-07-22', 'JE', 'Jersey', 'EURO', '0', '331', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42603, '2020-07-23', 'JE', 'Jersey', 'EURO', '0', '331', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42604, '2020-07-24', 'JE', 'Jersey', 'EURO', '0', '331', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42605, '2020-07-25', 'JE', 'Jersey', 'EURO', '0', '331', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42606, '2020-07-26', 'JE', 'Jersey', 'EURO', '1', '332', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42607, '2020-07-27', 'JE', 'Jersey', 'EURO', '0', '332', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42608, '2020-07-28', 'JE', 'Jersey', 'EURO', '0', '332', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42609, '2020-07-29', 'JE', 'Jersey', 'EURO', '2', '334', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42610, '2020-07-30', 'JE', 'Jersey', 'EURO', '1', '335', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42611, '2020-07-31', 'JE', 'Jersey', 'EURO', '0', '335', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42612, '2020-08-01', 'JE', 'Jersey', 'EURO', '0', '335', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42613, '2020-08-02', 'JE', 'Jersey', 'EURO', '0', '335', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42614, '2020-08-03', 'JE', 'Jersey', 'EURO', '0', '335', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42615, '2020-08-04', 'JE', 'Jersey', 'EURO', '0', '335', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42616, '2020-08-05', 'JE', 'Jersey', 'EURO', '4', '339', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42617, '2020-08-06', 'JE', 'Jersey', 'EURO', '4', '343', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42618, '2020-08-07', 'JE', 'Jersey', 'EURO', '1', '344', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42619, '2020-08-08', 'JE', 'Jersey', 'EURO', '1', '345', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42620, '2020-08-09', 'JE', 'Jersey', 'EURO', '0', '345', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42621, '2020-08-10', 'JE', 'Jersey', 'EURO', '0', '345', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42622, '2020-08-11', 'JE', 'Jersey', 'EURO', '0', '345', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42623, '2020-08-12', 'JE', 'Jersey', 'EURO', '3', '348', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42624, '2020-08-13', 'JE', 'Jersey', 'EURO', '0', '348', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42625, '2020-08-14', 'JE', 'Jersey', 'EURO', '4', '352', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42626, '2020-08-15', 'JE', 'Jersey', 'EURO', '4', '356', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42627, '2020-08-16', 'JE', 'Jersey', 'EURO', '0', '356', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42628, '2020-08-17', 'JE', 'Jersey', 'EURO', '0', '356', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42629, '2020-08-18', 'JE', 'Jersey', 'EURO', '0', '356', '0', '31');
INSERT INTO public.who_global_data_import VALUES (42630, '2020-08-19', 'JE', 'Jersey', 'EURO', '1', '357', '1', '32');
INSERT INTO public.who_global_data_import VALUES (42631, '2020-08-20', 'JE', 'Jersey', 'EURO', '2', '359', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42632, '2020-08-21', 'JE', 'Jersey', 'EURO', '3', '362', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42633, '2020-08-22', 'JE', 'Jersey', 'EURO', '1', '363', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42634, '2020-08-23', 'JE', 'Jersey', 'EURO', '0', '363', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42635, '2020-08-24', 'JE', 'Jersey', 'EURO', '1', '364', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42636, '2020-08-25', 'JE', 'Jersey', 'EURO', '0', '364', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42637, '2020-08-26', 'JE', 'Jersey', 'EURO', '3', '367', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42638, '2020-08-27', 'JE', 'Jersey', 'EURO', '2', '369', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42639, '2020-08-28', 'JE', 'Jersey', 'EURO', '3', '372', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42640, '2020-08-29', 'JE', 'Jersey', 'EURO', '1', '373', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42641, '2020-08-30', 'JE', 'Jersey', 'EURO', '1', '374', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42642, '2020-08-31', 'JE', 'Jersey', 'EURO', '0', '374', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42643, '2020-09-01', 'JE', 'Jersey', 'EURO', '0', '374', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42644, '2020-09-02', 'JE', 'Jersey', 'EURO', '5', '379', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42645, '2020-09-03', 'JE', 'Jersey', 'EURO', '0', '379', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42646, '2020-09-04', 'JE', 'Jersey', 'EURO', '3', '382', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42647, '2020-09-05', 'JE', 'Jersey', 'EURO', '1', '383', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42648, '2020-09-06', 'JE', 'Jersey', 'EURO', '1', '384', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42649, '2020-09-07', 'JE', 'Jersey', 'EURO', '0', '384', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42650, '2020-09-08', 'JE', 'Jersey', 'EURO', '0', '384', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42651, '2020-09-09', 'JE', 'Jersey', 'EURO', '1', '385', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42652, '2020-09-10', 'JE', 'Jersey', 'EURO', '0', '385', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42653, '2020-09-11', 'JE', 'Jersey', 'EURO', '-7', '378', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42654, '2020-09-12', 'JE', 'Jersey', 'EURO', '1', '379', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42655, '2020-09-13', 'JE', 'Jersey', 'EURO', '1', '380', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42656, '2020-09-14', 'JE', 'Jersey', 'EURO', '0', '380', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42657, '2020-09-15', 'JE', 'Jersey', 'EURO', '0', '380', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42658, '2020-09-16', 'JE', 'Jersey', 'EURO', '6', '386', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42659, '2020-09-17', 'JE', 'Jersey', 'EURO', '0', '386', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42660, '2020-09-18', 'JE', 'Jersey', 'EURO', '3', '389', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42661, '2020-09-19', 'JE', 'Jersey', 'EURO', '2', '391', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42662, '2020-09-20', 'JE', 'Jersey', 'EURO', '2', '393', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42663, '2020-09-21', 'JE', 'Jersey', 'EURO', '0', '393', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42664, '2020-09-22', 'JE', 'Jersey', 'EURO', '0', '393', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42665, '2020-09-23', 'JE', 'Jersey', 'EURO', '3', '396', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42666, '2020-09-24', 'JE', 'Jersey', 'EURO', '2', '398', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42667, '2020-09-25', 'JE', 'Jersey', 'EURO', '1', '399', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42668, '2020-09-26', 'JE', 'Jersey', 'EURO', '0', '399', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42669, '2020-09-27', 'JE', 'Jersey', 'EURO', '3', '402', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42670, '2020-09-28', 'JE', 'Jersey', 'EURO', '0', '402', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42671, '2020-09-29', 'JE', 'Jersey', 'EURO', '0', '402', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42672, '2020-09-30', 'JE', 'Jersey', 'EURO', '6', '408', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42673, '2020-10-01', 'JE', 'Jersey', 'EURO', '1', '409', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42674, '2020-10-02', 'JE', 'Jersey', 'EURO', '5', '414', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42675, '2020-10-03', 'JE', 'Jersey', 'EURO', '5', '419', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42676, '2020-10-04', 'JE', 'Jersey', 'EURO', '2', '421', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42677, '2020-10-05', 'JE', 'Jersey', 'EURO', '0', '421', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42678, '2020-10-06', 'JE', 'Jersey', 'EURO', '0', '421', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42679, '2020-10-07', 'JE', 'Jersey', 'EURO', '10', '431', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42680, '2020-10-08', 'JE', 'Jersey', 'EURO', '7', '438', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42681, '2020-10-09', 'JE', 'Jersey', 'EURO', '3', '441', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42682, '2020-10-10', 'JE', 'Jersey', 'EURO', '2', '443', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42683, '2020-10-11', 'JE', 'Jersey', 'EURO', '6', '449', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42684, '2020-10-12', 'JE', 'Jersey', 'EURO', '0', '449', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42685, '2020-10-13', 'JE', 'Jersey', 'EURO', '0', '449', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42686, '2020-10-14', 'JE', 'Jersey', 'EURO', '30', '479', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42687, '2020-10-15', 'JE', 'Jersey', 'EURO', '5', '484', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42688, '2020-10-16', 'JE', 'Jersey', 'EURO', '3', '487', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42689, '2020-10-17', 'JE', 'Jersey', 'EURO', '3', '490', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42690, '2020-10-18', 'JE', 'Jersey', 'EURO', '1', '491', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42691, '2020-10-19', 'JE', 'Jersey', 'EURO', '0', '491', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42692, '2020-10-20', 'JE', 'Jersey', 'EURO', '0', '491', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42693, '2020-10-21', 'JE', 'Jersey', 'EURO', '18', '509', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42694, '2020-10-22', 'JE', 'Jersey', 'EURO', '9', '518', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42695, '2020-10-23', 'JE', 'Jersey', 'EURO', '5', '523', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42696, '2020-10-24', 'JE', 'Jersey', 'EURO', '3', '526', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42697, '2020-10-25', 'JE', 'Jersey', 'EURO', '4', '530', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42698, '2020-10-26', 'JE', 'Jersey', 'EURO', '0', '530', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42699, '2020-10-27', 'JE', 'Jersey', 'EURO', '0', '530', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42700, '2020-10-28', 'JE', 'Jersey', 'EURO', '26', '556', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42701, '2020-10-29', 'JE', 'Jersey', 'EURO', '4', '560', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42702, '2020-10-30', 'JE', 'Jersey', 'EURO', '5', '565', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42703, '2020-10-31', 'JE', 'Jersey', 'EURO', '4', '569', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42704, '2020-11-01', 'JE', 'Jersey', 'EURO', '5', '574', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42705, '2020-11-02', 'JE', 'Jersey', 'EURO', '0', '574', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42706, '2020-11-03', 'JE', 'Jersey', 'EURO', '0', '574', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42707, '2020-11-04', 'JE', 'Jersey', 'EURO', '17', '591', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42708, '2020-11-05', 'JE', 'Jersey', 'EURO', '17', '608', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42709, '2020-11-06', 'JE', 'Jersey', 'EURO', '12', '620', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42710, '2020-11-07', 'JE', 'Jersey', 'EURO', '12', '632', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42711, '2020-11-08', 'JE', 'Jersey', 'EURO', '11', '643', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42712, '2020-11-09', 'JE', 'Jersey', 'EURO', '0', '643', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42713, '2020-11-10', 'JE', 'Jersey', 'EURO', '0', '643', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42714, '2020-11-11', 'JE', 'Jersey', 'EURO', '29', '672', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42715, '2020-11-12', 'JE', 'Jersey', 'EURO', '18', '690', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42716, '2020-11-13', 'JE', 'Jersey', 'EURO', '14', '704', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42717, '2020-11-14', 'JE', 'Jersey', 'EURO', '17', '721', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42718, '2020-11-15', 'JE', 'Jersey', 'EURO', '7', '728', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42719, '2020-11-16', 'JE', 'Jersey', 'EURO', '0', '728', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42720, '2020-11-17', 'JE', 'Jersey', 'EURO', '0', '728', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42721, '2020-11-18', 'JE', 'Jersey', 'EURO', '33', '761', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42722, '2020-11-19', 'JE', 'Jersey', 'EURO', '10', '771', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42723, '2020-11-20', 'JE', 'Jersey', 'EURO', '11', '782', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42724, '2020-11-21', 'JE', 'Jersey', 'EURO', '10', '792', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42725, '2020-11-22', 'JE', 'Jersey', 'EURO', '14', '806', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42726, '2020-11-23', 'JE', 'Jersey', 'EURO', '0', '806', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42727, '2020-11-24', 'JE', 'Jersey', 'EURO', '0', '806', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42728, '2020-11-25', 'JE', 'Jersey', 'EURO', '24', '830', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42729, '2020-11-26', 'JE', 'Jersey', 'EURO', '6', '836', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42730, '2020-11-27', 'JE', 'Jersey', 'EURO', '19', '855', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42731, '2020-11-28', 'JE', 'Jersey', 'EURO', '37', '892', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42732, '2020-11-29', 'JE', 'Jersey', 'EURO', '31', '923', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42733, '2020-11-30', 'JE', 'Jersey', 'EURO', '0', '923', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42734, '2020-12-01', 'JE', 'Jersey', 'EURO', '0', '923', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42735, '2020-12-02', 'JE', 'Jersey', 'EURO', '85', '1008', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42736, '2020-12-03', 'JE', 'Jersey', 'EURO', '32', '1040', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42737, '2020-12-04', 'JE', 'Jersey', 'EURO', '0', '1040', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42738, '2020-12-05', 'JE', 'Jersey', 'EURO', '130', '1170', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42739, '2020-12-06', 'JE', 'Jersey', 'EURO', '68', '1238', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42740, '2020-12-07', 'JE', 'Jersey', 'EURO', '0', '1238', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42741, '2020-12-08', 'JE', 'Jersey', 'EURO', '0', '1238', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42742, '2020-12-09', 'JE', 'Jersey', 'EURO', '100', '1338', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42743, '2020-12-10', 'JE', 'Jersey', 'EURO', '122', '1460', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42744, '2020-12-11', 'JE', 'Jersey', 'EURO', '37', '1497', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42745, '2020-12-12', 'JE', 'Jersey', 'EURO', '58', '1555', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42746, '2020-12-13', 'JE', 'Jersey', 'EURO', '82', '1637', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42747, '2020-12-14', 'JE', 'Jersey', 'EURO', '51', '1688', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42748, '2020-12-15', 'JE', 'Jersey', 'EURO', '91', '1779', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42749, '2020-12-16', 'JE', 'Jersey', 'EURO', '63', '1842', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42750, '2020-12-17', 'JE', 'Jersey', 'EURO', '59', '1901', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42751, '2020-12-18', 'JE', 'Jersey', 'EURO', '100', '2001', '0', '32');
INSERT INTO public.who_global_data_import VALUES (42752, '2020-12-19', 'JE', 'Jersey', 'EURO', '97', '2098', '1', '33');
INSERT INTO public.who_global_data_import VALUES (42753, '2020-12-20', 'JE', 'Jersey', 'EURO', '136', '2234', '3', '36');
INSERT INTO public.who_global_data_import VALUES (42754, '2020-12-21', 'JE', 'Jersey', 'EURO', '22', '2256', '0', '36');
INSERT INTO public.who_global_data_import VALUES (42755, '2020-12-22', 'JE', 'Jersey', 'EURO', '80', '2336', '0', '36');
INSERT INTO public.who_global_data_import VALUES (42756, '2020-12-23', 'JE', 'Jersey', 'EURO', '109', '2445', '2', '38');
INSERT INTO public.who_global_data_import VALUES (42757, '2020-12-24', 'JE', 'Jersey', 'EURO', '38', '2483', '1', '39');
INSERT INTO public.who_global_data_import VALUES (42758, '2020-12-25', 'JE', 'Jersey', 'EURO', '77', '2560', '1', '40');
INSERT INTO public.who_global_data_import VALUES (42759, '2020-12-26', 'JE', 'Jersey', 'EURO', '23', '2583', '1', '41');
INSERT INTO public.who_global_data_import VALUES (42760, '2020-12-27', 'JE', 'Jersey', 'EURO', '0', '2583', '0', '41');
INSERT INTO public.who_global_data_import VALUES (42761, '2020-12-28', 'JE', 'Jersey', 'EURO', '0', '2583', '0', '41');
INSERT INTO public.who_global_data_import VALUES (42762, '2020-12-29', 'JE', 'Jersey', 'EURO', '80', '2663', '0', '41');
INSERT INTO public.who_global_data_import VALUES (42763, '2020-12-30', 'JE', 'Jersey', 'EURO', '29', '2692', '0', '41');
INSERT INTO public.who_global_data_import VALUES (42764, '2020-12-31', 'JE', 'Jersey', 'EURO', '15', '2707', '0', '41');
INSERT INTO public.who_global_data_import VALUES (42765, '2021-01-01', 'JE', 'Jersey', 'EURO', '19', '2726', '1', '42');
INSERT INTO public.who_global_data_import VALUES (42766, '2021-01-02', 'JE', 'Jersey', 'EURO', '34', '2760', '2', '44');
INSERT INTO public.who_global_data_import VALUES (42767, '2021-01-03', 'JE', 'Jersey', 'EURO', '0', '2760', '0', '44');
INSERT INTO public.who_global_data_import VALUES (42768, '2021-01-04', 'JE', 'Jersey', 'EURO', '0', '2760', '0', '44');
INSERT INTO public.who_global_data_import VALUES (42769, '2021-01-05', 'JE', 'Jersey', 'EURO', '61', '2821', '0', '44');
INSERT INTO public.who_global_data_import VALUES (42770, '2021-01-06', 'JE', 'Jersey', 'EURO', '21', '2842', '3', '47');
INSERT INTO public.who_global_data_import VALUES (42771, '2021-01-07', 'JE', 'Jersey', 'EURO', '21', '2863', '4', '51');
INSERT INTO public.who_global_data_import VALUES (42772, '2021-01-08', 'JE', 'Jersey', 'EURO', '29', '2892', '2', '53');
INSERT INTO public.who_global_data_import VALUES (42773, '2021-01-09', 'JE', 'Jersey', 'EURO', '16', '2908', '3', '56');
INSERT INTO public.who_global_data_import VALUES (42774, '2021-01-10', 'JE', 'Jersey', 'EURO', '13', '2921', '1', '57');
INSERT INTO public.who_global_data_import VALUES (42775, '2021-01-11', 'JE', 'Jersey', 'EURO', '37', '2958', '0', '57');
INSERT INTO public.who_global_data_import VALUES (42776, '2021-01-12', 'JE', 'Jersey', 'EURO', '14', '2972', '0', '57');
INSERT INTO public.who_global_data_import VALUES (42777, '2021-01-13', 'JE', 'Jersey', 'EURO', '21', '2993', '2', '59');
INSERT INTO public.who_global_data_import VALUES (42778, '2021-01-14', 'JE', 'Jersey', 'EURO', '10', '3003', '0', '59');
INSERT INTO public.who_global_data_import VALUES (42779, '2021-01-15', 'JE', 'Jersey', 'EURO', '13', '3016', '1', '60');
INSERT INTO public.who_global_data_import VALUES (42780, '2021-01-16', 'JE', 'Jersey', 'EURO', '13', '3029', '0', '60');
INSERT INTO public.who_global_data_import VALUES (42781, '2021-01-17', 'JE', 'Jersey', 'EURO', '15', '3044', '2', '62');
INSERT INTO public.who_global_data_import VALUES (42782, '2021-01-18', 'JE', 'Jersey', 'EURO', '3', '3047', '0', '62');
INSERT INTO public.who_global_data_import VALUES (42783, '2021-01-19', 'JE', 'Jersey', 'EURO', '7', '3054', '0', '62');
INSERT INTO public.who_global_data_import VALUES (42784, '2021-01-20', 'JE', 'Jersey', 'EURO', '7', '3061', '0', '62');
INSERT INTO public.who_global_data_import VALUES (42785, '2021-01-21', 'JE', 'Jersey', 'EURO', '16', '3077', '0', '62');
INSERT INTO public.who_global_data_import VALUES (42786, '2021-01-22', 'JE', 'Jersey', 'EURO', '11', '3088', '0', '62');
INSERT INTO public.who_global_data_import VALUES (42787, '2021-01-23', 'JE', 'Jersey', 'EURO', '9', '3097', '0', '62');
INSERT INTO public.who_global_data_import VALUES (42788, '2021-01-24', 'JE', 'Jersey', 'EURO', '7', '3104', '1', '63');
INSERT INTO public.who_global_data_import VALUES (42789, '2021-01-25', 'JE', 'Jersey', 'EURO', '12', '3116', '0', '63');
INSERT INTO public.who_global_data_import VALUES (42790, '2021-01-26', 'JE', 'Jersey', 'EURO', '6', '3122', '0', '63');
INSERT INTO public.who_global_data_import VALUES (42791, '2021-01-27', 'JE', 'Jersey', 'EURO', '5', '3127', '0', '63');
INSERT INTO public.who_global_data_import VALUES (42792, '2021-01-28', 'JE', 'Jersey', 'EURO', '3', '3130', '0', '63');
INSERT INTO public.who_global_data_import VALUES (42793, '2021-01-29', 'JE', 'Jersey', 'EURO', '4', '3134', '1', '64');
INSERT INTO public.who_global_data_import VALUES (42794, '2021-01-30', 'JE', 'Jersey', 'EURO', '6', '3140', '1', '65');
INSERT INTO public.who_global_data_import VALUES (42795, '2021-01-31', 'JE', 'Jersey', 'EURO', '3', '3143', '1', '66');
INSERT INTO public.who_global_data_import VALUES (42796, '2021-02-01', 'JE', 'Jersey', 'EURO', '3', '3146', '0', '66');
INSERT INTO public.who_global_data_import VALUES (42797, '2021-02-02', 'JE', 'Jersey', 'EURO', '6', '3152', '0', '66');
INSERT INTO public.who_global_data_import VALUES (42798, '2021-02-03', 'JE', 'Jersey', 'EURO', '2', '3154', '0', '66');
INSERT INTO public.who_global_data_import VALUES (42799, '2021-02-04', 'JE', 'Jersey', 'EURO', '7', '3161', '1', '67');
INSERT INTO public.who_global_data_import VALUES (42800, '2021-02-05', 'JE', 'Jersey', 'EURO', '4', '3165', '0', '67');
INSERT INTO public.who_global_data_import VALUES (42801, '2020-01-03', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42802, '2020-01-04', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42803, '2020-01-05', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42804, '2020-01-06', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42805, '2020-01-07', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42806, '2020-01-08', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42807, '2020-01-09', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42808, '2020-01-10', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42809, '2020-01-11', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42810, '2020-01-12', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42811, '2020-01-13', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42812, '2020-01-14', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42813, '2020-01-15', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42814, '2020-01-16', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42815, '2020-01-17', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42816, '2020-01-18', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42817, '2020-01-19', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42818, '2020-01-20', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42819, '2020-01-21', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42820, '2020-01-22', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42821, '2020-01-23', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42822, '2020-01-24', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42823, '2020-01-25', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42824, '2020-01-26', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42825, '2020-01-27', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42826, '2020-01-28', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42827, '2020-01-29', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42828, '2020-01-30', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42829, '2020-01-31', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42830, '2020-02-01', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42831, '2020-02-02', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42832, '2020-02-03', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42833, '2020-02-04', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42834, '2020-02-05', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42835, '2020-02-06', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42836, '2020-02-07', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42837, '2020-02-08', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42838, '2020-02-09', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42839, '2020-02-10', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42840, '2020-02-11', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42841, '2020-02-12', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42842, '2020-02-13', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42843, '2020-02-14', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42844, '2020-02-15', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42845, '2020-02-16', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42846, '2020-02-17', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42847, '2020-02-18', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42848, '2020-02-19', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42849, '2020-02-20', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42850, '2020-02-21', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42851, '2020-02-22', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42852, '2020-02-23', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42853, '2020-02-24', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42854, '2020-02-25', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42855, '2020-02-26', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42856, '2020-02-27', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42857, '2020-02-28', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42858, '2020-02-29', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42859, '2020-03-01', 'JO', 'Jordan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42860, '2020-03-02', 'JO', 'Jordan', 'EMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42861, '2020-03-03', 'JO', 'Jordan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42862, '2020-03-04', 'JO', 'Jordan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42863, '2020-03-05', 'JO', 'Jordan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42864, '2020-03-06', 'JO', 'Jordan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42865, '2020-03-07', 'JO', 'Jordan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42866, '2020-03-08', 'JO', 'Jordan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42867, '2020-03-09', 'JO', 'Jordan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42868, '2020-03-10', 'JO', 'Jordan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42869, '2020-03-11', 'JO', 'Jordan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42870, '2020-03-12', 'JO', 'Jordan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42871, '2020-03-13', 'JO', 'Jordan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42872, '2020-03-14', 'JO', 'Jordan', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42873, '2020-03-15', 'JO', 'Jordan', 'EMRO', '5', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42874, '2020-03-16', 'JO', 'Jordan', 'EMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42875, '2020-03-17', 'JO', 'Jordan', 'EMRO', '29', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42876, '2020-03-18', 'JO', 'Jordan', 'EMRO', '17', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42877, '2020-03-19', 'JO', 'Jordan', 'EMRO', '4', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42878, '2020-03-20', 'JO', 'Jordan', 'EMRO', '9', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42879, '2020-03-21', 'JO', 'Jordan', 'EMRO', '15', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42880, '2020-03-22', 'JO', 'Jordan', 'EMRO', '15', '99', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42881, '2020-03-23', 'JO', 'Jordan', 'EMRO', '13', '112', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42882, '2020-03-24', 'JO', 'Jordan', 'EMRO', '15', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42883, '2020-03-25', 'JO', 'Jordan', 'EMRO', '26', '153', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42884, '2020-03-26', 'JO', 'Jordan', 'EMRO', '19', '172', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42885, '2020-03-27', 'JO', 'Jordan', 'EMRO', '40', '212', '0', '0');
INSERT INTO public.who_global_data_import VALUES (42886, '2020-03-28', 'JO', 'Jordan', 'EMRO', '23', '235', '1', '1');
INSERT INTO public.who_global_data_import VALUES (42887, '2020-03-29', 'JO', 'Jordan', 'EMRO', '11', '246', '0', '1');
INSERT INTO public.who_global_data_import VALUES (42888, '2020-03-30', 'JO', 'Jordan', 'EMRO', '13', '259', '3', '4');
INSERT INTO public.who_global_data_import VALUES (42889, '2020-03-31', 'JO', 'Jordan', 'EMRO', '9', '268', '1', '5');
INSERT INTO public.who_global_data_import VALUES (42890, '2020-04-01', 'JO', 'Jordan', 'EMRO', '6', '274', '0', '5');
INSERT INTO public.who_global_data_import VALUES (42891, '2020-04-02', 'JO', 'Jordan', 'EMRO', '4', '278', '0', '5');
INSERT INTO public.who_global_data_import VALUES (42892, '2020-04-03', 'JO', 'Jordan', 'EMRO', '21', '299', '0', '5');
INSERT INTO public.who_global_data_import VALUES (42893, '2020-04-04', 'JO', 'Jordan', 'EMRO', '11', '310', '0', '5');
INSERT INTO public.who_global_data_import VALUES (42894, '2020-04-05', 'JO', 'Jordan', 'EMRO', '13', '323', '0', '5');
INSERT INTO public.who_global_data_import VALUES (42895, '2020-04-06', 'JO', 'Jordan', 'EMRO', '22', '345', '0', '5');
INSERT INTO public.who_global_data_import VALUES (42896, '2020-04-07', 'JO', 'Jordan', 'EMRO', '4', '349', '1', '6');
INSERT INTO public.who_global_data_import VALUES (42897, '2020-04-08', 'JO', 'Jordan', 'EMRO', '4', '353', '0', '6');
INSERT INTO public.who_global_data_import VALUES (42898, '2020-04-09', 'JO', 'Jordan', 'EMRO', '5', '358', '0', '6');
INSERT INTO public.who_global_data_import VALUES (42899, '2020-04-10', 'JO', 'Jordan', 'EMRO', '14', '372', '1', '7');
INSERT INTO public.who_global_data_import VALUES (42900, '2020-04-11', 'JO', 'Jordan', 'EMRO', '0', '372', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42901, '2020-04-12', 'JO', 'Jordan', 'EMRO', '9', '381', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42902, '2020-04-13', 'JO', 'Jordan', 'EMRO', '8', '389', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42903, '2020-04-14', 'JO', 'Jordan', 'EMRO', '2', '391', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42904, '2020-04-15', 'JO', 'Jordan', 'EMRO', '6', '397', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42905, '2020-04-16', 'JO', 'Jordan', 'EMRO', '4', '401', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42906, '2020-04-17', 'JO', 'Jordan', 'EMRO', '1', '402', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42907, '2020-04-18', 'JO', 'Jordan', 'EMRO', '5', '407', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42908, '2020-04-19', 'JO', 'Jordan', 'EMRO', '6', '413', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42909, '2020-04-20', 'JO', 'Jordan', 'EMRO', '4', '417', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42910, '2020-04-21', 'JO', 'Jordan', 'EMRO', '8', '425', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42911, '2020-04-22', 'JO', 'Jordan', 'EMRO', '3', '428', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42912, '2020-04-23', 'JO', 'Jordan', 'EMRO', '7', '435', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42913, '2020-04-24', 'JO', 'Jordan', 'EMRO', '2', '437', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42914, '2020-04-25', 'JO', 'Jordan', 'EMRO', '7', '444', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42915, '2020-04-26', 'JO', 'Jordan', 'EMRO', '3', '447', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42916, '2020-04-27', 'JO', 'Jordan', 'EMRO', '2', '449', '0', '7');
INSERT INTO public.who_global_data_import VALUES (42917, '2020-04-28', 'JO', 'Jordan', 'EMRO', '0', '449', '1', '8');
INSERT INTO public.who_global_data_import VALUES (42918, '2020-04-29', 'JO', 'Jordan', 'EMRO', '0', '449', '0', '8');
INSERT INTO public.who_global_data_import VALUES (42919, '2020-04-30', 'JO', 'Jordan', 'EMRO', '4', '453', '0', '8');
INSERT INTO public.who_global_data_import VALUES (42920, '2020-05-01', 'JO', 'Jordan', 'EMRO', '0', '453', '0', '8');
INSERT INTO public.who_global_data_import VALUES (42921, '2020-05-02', 'JO', 'Jordan', 'EMRO', '6', '459', '1', '9');
INSERT INTO public.who_global_data_import VALUES (42922, '2020-05-03', 'JO', 'Jordan', 'EMRO', '2', '461', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42923, '2020-05-04', 'JO', 'Jordan', 'EMRO', '4', '465', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42924, '2020-05-05', 'JO', 'Jordan', 'EMRO', '6', '471', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42925, '2020-05-06', 'JO', 'Jordan', 'EMRO', '2', '473', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42926, '2020-05-07', 'JO', 'Jordan', 'EMRO', '11', '484', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42927, '2020-05-08', 'JO', 'Jordan', 'EMRO', '10', '494', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42928, '2020-05-09', 'JO', 'Jordan', 'EMRO', '28', '522', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42929, '2020-05-10', 'JO', 'Jordan', 'EMRO', '18', '540', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42930, '2020-05-11', 'JO', 'Jordan', 'EMRO', '22', '562', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42931, '2020-05-12', 'JO', 'Jordan', 'EMRO', '14', '576', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42932, '2020-05-13', 'JO', 'Jordan', 'EMRO', '6', '582', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42933, '2020-05-14', 'JO', 'Jordan', 'EMRO', '4', '586', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42934, '2020-05-15', 'JO', 'Jordan', 'EMRO', '10', '596', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42935, '2020-05-16', 'JO', 'Jordan', 'EMRO', '11', '607', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42936, '2020-05-17', 'JO', 'Jordan', 'EMRO', '6', '613', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42937, '2020-05-18', 'JO', 'Jordan', 'EMRO', '16', '629', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42938, '2020-05-19', 'JO', 'Jordan', 'EMRO', '20', '649', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42939, '2020-05-20', 'JO', 'Jordan', 'EMRO', '23', '672', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42940, '2020-05-21', 'JO', 'Jordan', 'EMRO', '12', '684', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42941, '2020-05-22', 'JO', 'Jordan', 'EMRO', '0', '684', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42942, '2020-05-23', 'JO', 'Jordan', 'EMRO', '16', '700', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42943, '2020-05-24', 'JO', 'Jordan', 'EMRO', '2', '702', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42944, '2020-05-25', 'JO', 'Jordan', 'EMRO', '4', '706', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42945, '2020-05-26', 'JO', 'Jordan', 'EMRO', '3', '709', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42946, '2020-05-27', 'JO', 'Jordan', 'EMRO', '7', '716', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42947, '2020-05-28', 'JO', 'Jordan', 'EMRO', '2', '718', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42948, '2020-05-29', 'JO', 'Jordan', 'EMRO', '7', '725', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42949, '2020-05-30', 'JO', 'Jordan', 'EMRO', '1', '726', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42950, '2020-05-31', 'JO', 'Jordan', 'EMRO', '4', '730', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42951, '2020-06-01', 'JO', 'Jordan', 'EMRO', '3', '733', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42952, '2020-06-02', 'JO', 'Jordan', 'EMRO', '7', '740', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42953, '2020-06-03', 'JO', 'Jordan', 'EMRO', '5', '745', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42954, '2020-06-04', 'JO', 'Jordan', 'EMRO', '0', '745', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42955, '2020-06-05', 'JO', 'Jordan', 'EMRO', '2', '747', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42956, '2020-06-06', 'JO', 'Jordan', 'EMRO', '8', '755', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42957, '2020-06-07', 'JO', 'Jordan', 'EMRO', '6', '761', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42958, '2020-06-08', 'JO', 'Jordan', 'EMRO', '8', '769', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42959, '2020-06-09', 'JO', 'Jordan', 'EMRO', '23', '792', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42960, '2020-06-10', 'JO', 'Jordan', 'EMRO', '10', '802', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42961, '2020-06-11', 'JO', 'Jordan', 'EMRO', '13', '815', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42962, '2020-06-12', 'JO', 'Jordan', 'EMRO', '21', '836', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42963, '2020-06-13', 'JO', 'Jordan', 'EMRO', '21', '857', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42964, '2020-06-14', 'JO', 'Jordan', 'EMRO', '38', '895', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42965, '2020-06-15', 'JO', 'Jordan', 'EMRO', '8', '903', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42966, '2020-06-16', 'JO', 'Jordan', 'EMRO', '18', '921', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42967, '2020-06-17', 'JO', 'Jordan', 'EMRO', '0', '921', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42968, '2020-06-18', 'JO', 'Jordan', 'EMRO', '6', '927', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42969, '2020-06-19', 'JO', 'Jordan', 'EMRO', '10', '937', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42970, '2020-06-20', 'JO', 'Jordan', 'EMRO', '6', '943', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42971, '2020-06-21', 'JO', 'Jordan', 'EMRO', '7', '950', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42972, '2020-06-22', 'JO', 'Jordan', 'EMRO', '17', '967', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42973, '2020-06-23', 'JO', 'Jordan', 'EMRO', '9', '976', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42974, '2020-06-24', 'JO', 'Jordan', 'EMRO', '4', '980', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42975, '2020-06-25', 'JO', 'Jordan', 'EMRO', '19', '999', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42976, '2020-06-26', 'JO', 'Jordan', 'EMRO', '14', '1013', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42977, '2020-06-27', 'JO', 'Jordan', 'EMRO', '17', '1030', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42978, '2020-06-28', 'JO', 'Jordan', 'EMRO', '6', '1036', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42979, '2020-06-29', 'JO', 'Jordan', 'EMRO', '9', '1045', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42980, '2020-06-30', 'JO', 'Jordan', 'EMRO', '7', '1052', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42981, '2020-07-01', 'JO', 'Jordan', 'EMRO', '4', '1056', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42982, '2020-07-02', 'JO', 'Jordan', 'EMRO', '1', '1057', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42983, '2020-07-03', 'JO', 'Jordan', 'EMRO', '3', '1060', '0', '9');
INSERT INTO public.who_global_data_import VALUES (42984, '2020-07-04', 'JO', 'Jordan', 'EMRO', '10', '1070', '1', '10');
INSERT INTO public.who_global_data_import VALUES (42985, '2020-07-05', 'JO', 'Jordan', 'EMRO', '1', '1071', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42986, '2020-07-06', 'JO', 'Jordan', 'EMRO', '12', '1083', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42987, '2020-07-07', 'JO', 'Jordan', 'EMRO', '3', '1086', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42988, '2020-07-08', 'JO', 'Jordan', 'EMRO', '2', '1088', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42989, '2020-07-09', 'JO', 'Jordan', 'EMRO', '0', '1088', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42990, '2020-07-10', 'JO', 'Jordan', 'EMRO', '0', '1088', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42991, '2020-07-11', 'JO', 'Jordan', 'EMRO', '0', '1088', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42992, '2020-07-12', 'JO', 'Jordan', 'EMRO', '1', '1089', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42993, '2020-07-13', 'JO', 'Jordan', 'EMRO', '3', '1092', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42994, '2020-07-14', 'JO', 'Jordan', 'EMRO', '3', '1095', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42995, '2020-07-15', 'JO', 'Jordan', 'EMRO', '15', '1110', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42996, '2020-07-16', 'JO', 'Jordan', 'EMRO', '3', '1113', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42997, '2020-07-17', 'JO', 'Jordan', 'EMRO', '5', '1118', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42998, '2020-07-18', 'JO', 'Jordan', 'EMRO', '3', '1121', '0', '10');
INSERT INTO public.who_global_data_import VALUES (42999, '2020-07-19', 'JO', 'Jordan', 'EMRO', '5', '1126', '1', '11');
INSERT INTO public.who_global_data_import VALUES (43000, '2020-07-20', 'JO', 'Jordan', 'EMRO', '4', '1130', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43001, '2020-07-21', 'JO', 'Jordan', 'EMRO', '5', '1135', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43002, '2020-07-22', 'JO', 'Jordan', 'EMRO', '46', '1181', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43003, '2020-07-23', 'JO', 'Jordan', 'EMRO', '7', '1188', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43004, '2020-07-24', 'JO', 'Jordan', 'EMRO', '11', '1199', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43005, '2020-07-25', 'JO', 'Jordan', 'EMRO', '15', '1214', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43006, '2020-07-26', 'JO', 'Jordan', 'EMRO', '8', '1222', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43007, '2020-07-27', 'JO', 'Jordan', 'EMRO', '14', '1236', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43008, '2020-07-28', 'JO', 'Jordan', 'EMRO', '8', '1244', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43009, '2020-07-29', 'JO', 'Jordan', 'EMRO', '6', '1250', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43010, '2020-07-30', 'JO', 'Jordan', 'EMRO', '5', '1255', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43011, '2020-07-31', 'JO', 'Jordan', 'EMRO', '4', '1259', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43012, '2020-08-01', 'JO', 'Jordan', 'EMRO', '2', '1261', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43013, '2020-08-02', 'JO', 'Jordan', 'EMRO', '15', '1276', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43014, '2020-08-03', 'JO', 'Jordan', 'EMRO', '5', '1281', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43015, '2020-08-04', 'JO', 'Jordan', 'EMRO', '5', '1286', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43016, '2020-08-05', 'JO', 'Jordan', 'EMRO', '6', '1292', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43017, '2020-08-06', 'JO', 'Jordan', 'EMRO', '7', '1299', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43018, '2020-08-07', 'JO', 'Jordan', 'EMRO', '1', '1300', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43019, '2020-08-08', 'JO', 'Jordan', 'EMRO', '5', '1305', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43020, '2020-08-09', 'JO', 'Jordan', 'EMRO', '9', '1314', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43021, '2020-08-10', 'JO', 'Jordan', 'EMRO', '6', '1320', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43022, '2020-08-11', 'JO', 'Jordan', 'EMRO', '16', '1336', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43023, '2020-08-12', 'JO', 'Jordan', 'EMRO', '15', '1351', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43024, '2020-08-13', 'JO', 'Jordan', 'EMRO', '20', '1371', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43025, '2020-08-14', 'JO', 'Jordan', 'EMRO', '17', '1388', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43026, '2020-08-15', 'JO', 'Jordan', 'EMRO', '9', '1397', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43027, '2020-08-16', 'JO', 'Jordan', 'EMRO', '10', '1407', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43028, '2020-08-17', 'JO', 'Jordan', 'EMRO', '39', '1446', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43029, '2020-08-18', 'JO', 'Jordan', 'EMRO', '20', '1466', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43639, '2020-02-10', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43030, '2020-08-19', 'JO', 'Jordan', 'EMRO', '40', '1506', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43031, '2020-08-20', 'JO', 'Jordan', 'EMRO', '44', '1550', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43032, '2020-08-21', 'JO', 'Jordan', 'EMRO', '16', '1566', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43033, '2020-08-22', 'JO', 'Jordan', 'EMRO', '34', '1600', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43034, '2020-08-23', 'JO', 'Jordan', 'EMRO', '44', '1644', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43035, '2020-08-24', 'JO', 'Jordan', 'EMRO', '33', '1677', '1', '12');
INSERT INTO public.who_global_data_import VALUES (43036, '2020-08-25', 'JO', 'Jordan', 'EMRO', '30', '1707', '2', '14');
INSERT INTO public.who_global_data_import VALUES (43037, '2020-08-26', 'JO', 'Jordan', 'EMRO', '77', '1784', '0', '14');
INSERT INTO public.who_global_data_import VALUES (43038, '2020-08-27', 'JO', 'Jordan', 'EMRO', '40', '1824', '1', '15');
INSERT INTO public.who_global_data_import VALUES (43039, '2020-08-28', 'JO', 'Jordan', 'EMRO', '45', '1869', '0', '15');
INSERT INTO public.who_global_data_import VALUES (43040, '2020-08-29', 'JO', 'Jordan', 'EMRO', '68', '1937', '0', '15');
INSERT INTO public.who_global_data_import VALUES (43041, '2020-08-30', 'JO', 'Jordan', 'EMRO', '24', '1961', '0', '15');
INSERT INTO public.who_global_data_import VALUES (43042, '2020-08-31', 'JO', 'Jordan', 'EMRO', '73', '2034', '0', '15');
INSERT INTO public.who_global_data_import VALUES (43043, '2020-09-01', 'JO', 'Jordan', 'EMRO', '68', '2102', '0', '15');
INSERT INTO public.who_global_data_import VALUES (43044, '2020-09-02', 'JO', 'Jordan', 'EMRO', '63', '2165', '0', '15');
INSERT INTO public.who_global_data_import VALUES (43045, '2020-09-03', 'JO', 'Jordan', 'EMRO', '64', '2229', '0', '15');
INSERT INTO public.who_global_data_import VALUES (43046, '2020-09-04', 'JO', 'Jordan', 'EMRO', '72', '2301', '1', '16');
INSERT INTO public.who_global_data_import VALUES (43047, '2020-09-05', 'JO', 'Jordan', 'EMRO', '68', '2369', '0', '16');
INSERT INTO public.who_global_data_import VALUES (43048, '2020-09-06', 'JO', 'Jordan', 'EMRO', '52', '2421', '0', '16');
INSERT INTO public.who_global_data_import VALUES (43049, '2020-09-07', 'JO', 'Jordan', 'EMRO', '58', '2479', '0', '16');
INSERT INTO public.who_global_data_import VALUES (43050, '2020-09-08', 'JO', 'Jordan', 'EMRO', '67', '2546', '1', '17');
INSERT INTO public.who_global_data_import VALUES (43051, '2020-09-09', 'JO', 'Jordan', 'EMRO', '103', '2649', '2', '19');
INSERT INTO public.who_global_data_import VALUES (43052, '2020-09-10', 'JO', 'Jordan', 'EMRO', '78', '2727', '0', '19');
INSERT INTO public.who_global_data_import VALUES (43053, '2020-09-11', 'JO', 'Jordan', 'EMRO', '80', '2807', '1', '20');
INSERT INTO public.who_global_data_import VALUES (43054, '2020-09-12', 'JO', 'Jordan', 'EMRO', '206', '3013', '1', '21');
INSERT INTO public.who_global_data_import VALUES (43055, '2020-09-13', 'JO', 'Jordan', 'EMRO', '117', '3130', '1', '22');
INSERT INTO public.who_global_data_import VALUES (43056, '2020-09-14', 'JO', 'Jordan', 'EMRO', '252', '3382', '2', '24');
INSERT INTO public.who_global_data_import VALUES (43057, '2020-09-15', 'JO', 'Jordan', 'EMRO', '214', '3596', '2', '26');
INSERT INTO public.who_global_data_import VALUES (43058, '2020-09-16', 'JO', 'Jordan', 'EMRO', '149', '3745', '0', '26');
INSERT INTO public.who_global_data_import VALUES (43059, '2020-09-17', 'JO', 'Jordan', 'EMRO', '175', '3920', '0', '26');
INSERT INTO public.who_global_data_import VALUES (43060, '2020-09-18', 'JO', 'Jordan', 'EMRO', '279', '4199', '0', '26');
INSERT INTO public.who_global_data_import VALUES (43061, '2020-09-19', 'JO', 'Jordan', 'EMRO', '213', '4412', '3', '29');
INSERT INTO public.who_global_data_import VALUES (43062, '2020-09-20', 'JO', 'Jordan', 'EMRO', '196', '4608', '1', '30');
INSERT INTO public.who_global_data_import VALUES (43063, '2020-09-21', 'JO', 'Jordan', 'EMRO', '239', '4847', '0', '30');
INSERT INTO public.who_global_data_import VALUES (43064, '2020-09-22', 'JO', 'Jordan', 'EMRO', '266', '5113', '2', '32');
INSERT INTO public.who_global_data_import VALUES (43065, '2020-09-23', 'JO', 'Jordan', 'EMRO', '634', '5747', '1', '33');
INSERT INTO public.who_global_data_import VALUES (43066, '2020-09-24', 'JO', 'Jordan', 'EMRO', '363', '6110', '2', '35');
INSERT INTO public.who_global_data_import VALUES (43067, '2020-09-25', 'JO', 'Jordan', 'EMRO', '549', '6659', '1', '36');
INSERT INTO public.who_global_data_import VALUES (43068, '2020-09-26', 'JO', 'Jordan', 'EMRO', '620', '7279', '3', '39');
INSERT INTO public.who_global_data_import VALUES (43069, '2020-09-27', 'JO', 'Jordan', 'EMRO', '850', '8129', '4', '43');
INSERT INTO public.who_global_data_import VALUES (43070, '2020-09-28', 'JO', 'Jordan', 'EMRO', '431', '8560', '2', '45');
INSERT INTO public.who_global_data_import VALUES (43071, '2020-09-29', 'JO', 'Jordan', 'EMRO', '734', '9294', '6', '51');
INSERT INTO public.who_global_data_import VALUES (43072, '2020-09-30', 'JO', 'Jordan', 'EMRO', '823', '10117', '6', '57');
INSERT INTO public.who_global_data_import VALUES (43073, '2020-10-01', 'JO', 'Jordan', 'EMRO', '1776', '11893', '4', '61');
INSERT INTO public.who_global_data_import VALUES (43074, '2020-10-02', 'JO', 'Jordan', 'EMRO', '1276', '13169', '8', '69');
INSERT INTO public.who_global_data_import VALUES (43075, '2020-10-03', 'JO', 'Jordan', 'EMRO', '549', '13718', '10', '79');
INSERT INTO public.who_global_data_import VALUES (43076, '2020-10-04', 'JO', 'Jordan', 'EMRO', '1099', '14817', '9', '88');
INSERT INTO public.who_global_data_import VALUES (43077, '2020-10-05', 'JO', 'Jordan', 'EMRO', '891', '15708', '13', '101');
INSERT INTO public.who_global_data_import VALUES (43078, '2020-10-06', 'JO', 'Jordan', 'EMRO', '1824', '17532', '9', '110');
INSERT INTO public.who_global_data_import VALUES (43079, '2020-10-07', 'JO', 'Jordan', 'EMRO', '1537', '19069', '12', '122');
INSERT INTO public.who_global_data_import VALUES (43080, '2020-10-08', 'JO', 'Jordan', 'EMRO', '1199', '20268', '9', '131');
INSERT INTO public.who_global_data_import VALUES (43081, '2020-10-09', 'JO', 'Jordan', 'EMRO', '1317', '21585', '13', '144');
INSERT INTO public.who_global_data_import VALUES (43082, '2020-10-10', 'JO', 'Jordan', 'EMRO', '1246', '22831', '22', '166');
INSERT INTO public.who_global_data_import VALUES (43083, '2020-10-11', 'JO', 'Jordan', 'EMRO', '1235', '24066', '15', '181');
INSERT INTO public.who_global_data_import VALUES (43084, '2020-10-12', 'JO', 'Jordan', 'EMRO', '928', '24994', '10', '191');
INSERT INTO public.who_global_data_import VALUES (43085, '2020-10-13', 'JO', 'Jordan', 'EMRO', '1147', '26141', '16', '207');
INSERT INTO public.who_global_data_import VALUES (43086, '2020-10-14', 'JO', 'Jordan', 'EMRO', '2054', '28195', '18', '225');
INSERT INTO public.who_global_data_import VALUES (43087, '2020-10-15', 'JO', 'Jordan', 'EMRO', '2423', '30618', '32', '257');
INSERT INTO public.who_global_data_import VALUES (43088, '2020-10-16', 'JO', 'Jordan', 'EMRO', '2459', '33077', '25', '282');
INSERT INTO public.who_global_data_import VALUES (43089, '2020-10-17', 'JO', 'Jordan', 'EMRO', '1539', '34616', '28', '310');
INSERT INTO public.who_global_data_import VALUES (43090, '2020-10-18', 'JO', 'Jordan', 'EMRO', '1505', '36121', '20', '330');
INSERT INTO public.who_global_data_import VALUES (43091, '2020-10-19', 'JO', 'Jordan', 'EMRO', '1520', '37641', '15', '345');
INSERT INTO public.who_global_data_import VALUES (43092, '2020-10-20', 'JO', 'Jordan', 'EMRO', '1364', '39005', '35', '380');
INSERT INTO public.who_global_data_import VALUES (43093, '2020-10-21', 'JO', 'Jordan', 'EMRO', '2035', '41040', '34', '414');
INSERT INTO public.who_global_data_import VALUES (43094, '2020-10-22', 'JO', 'Jordan', 'EMRO', '2580', '43620', '29', '443');
INSERT INTO public.who_global_data_import VALUES (43095, '2020-10-23', 'JO', 'Jordan', 'EMRO', '2821', '46441', '38', '481');
INSERT INTO public.who_global_data_import VALUES (43096, '2020-10-24', 'JO', 'Jordan', 'EMRO', '2489', '48930', '27', '508');
INSERT INTO public.who_global_data_import VALUES (43097, '2020-10-25', 'JO', 'Jordan', 'EMRO', '1820', '50750', '32', '540');
INSERT INTO public.who_global_data_import VALUES (43098, '2020-10-26', 'JO', 'Jordan', 'EMRO', '2337', '53087', '39', '579');
INSERT INTO public.who_global_data_import VALUES (43099, '2020-10-27', 'JO', 'Jordan', 'EMRO', '1968', '55055', '45', '624');
INSERT INTO public.who_global_data_import VALUES (43100, '2020-10-28', 'JO', 'Jordan', 'EMRO', '3800', '58855', '44', '668');
INSERT INTO public.who_global_data_import VALUES (43101, '2020-10-29', 'JO', 'Jordan', 'EMRO', '3087', '61942', '32', '700');
INSERT INTO public.who_global_data_import VALUES (43102, '2020-10-30', 'JO', 'Jordan', 'EMRO', '3443', '65385', '40', '740');
INSERT INTO public.who_global_data_import VALUES (43103, '2020-10-31', 'JO', 'Jordan', 'EMRO', '3921', '69306', '32', '772');
INSERT INTO public.who_global_data_import VALUES (43104, '2020-11-01', 'JO', 'Jordan', 'EMRO', '3301', '72607', '57', '829');
INSERT INTO public.who_global_data_import VALUES (43105, '2020-11-02', 'JO', 'Jordan', 'EMRO', '3259', '75866', '37', '866');
INSERT INTO public.who_global_data_import VALUES (43106, '2020-11-03', 'JO', 'Jordan', 'EMRO', '5877', '81743', '47', '913');
INSERT INTO public.who_global_data_import VALUES (43107, '2020-11-04', 'JO', 'Jordan', 'EMRO', '4833', '86576', '54', '967');
INSERT INTO public.who_global_data_import VALUES (43108, '2020-11-05', 'JO', 'Jordan', 'EMRO', '4658', '91234', '62', '1029');
INSERT INTO public.who_global_data_import VALUES (43109, '2020-11-06', 'JO', 'Jordan', 'EMRO', '4630', '95864', '40', '1069');
INSERT INTO public.who_global_data_import VALUES (43110, '2020-11-07', 'JO', 'Jordan', 'EMRO', '5384', '101248', '67', '1136');
INSERT INTO public.who_global_data_import VALUES (43111, '2020-11-08', 'JO', 'Jordan', 'EMRO', '3554', '104802', '45', '1181');
INSERT INTO public.who_global_data_import VALUES (43112, '2020-11-09', 'JO', 'Jordan', 'EMRO', '4519', '109321', '52', '1233');
INSERT INTO public.who_global_data_import VALUES (43113, '2020-11-10', 'JO', 'Jordan', 'EMRO', '5665', '114986', '62', '1295');
INSERT INTO public.who_global_data_import VALUES (43114, '2020-11-11', 'JO', 'Jordan', 'EMRO', '5996', '120982', '91', '1386');
INSERT INTO public.who_global_data_import VALUES (43115, '2020-11-12', 'JO', 'Jordan', 'EMRO', '5419', '126401', '81', '1467');
INSERT INTO public.who_global_data_import VALUES (43116, '2020-11-13', 'JO', 'Jordan', 'EMRO', '5685', '132086', '80', '1547');
INSERT INTO public.who_global_data_import VALUES (43117, '2020-11-14', 'JO', 'Jordan', 'EMRO', '4469', '136555', '71', '1618');
INSERT INTO public.who_global_data_import VALUES (43118, '2020-11-15', 'JO', 'Jordan', 'EMRO', '4750', '141305', '86', '1704');
INSERT INTO public.who_global_data_import VALUES (43119, '2020-11-16', 'JO', 'Jordan', 'EMRO', '2373', '143678', '68', '1772');
INSERT INTO public.who_global_data_import VALUES (43120, '2020-11-17', 'JO', 'Jordan', 'EMRO', '5861', '149539', '71', '1843');
INSERT INTO public.who_global_data_import VALUES (43121, '2020-11-18', 'JO', 'Jordan', 'EMRO', '6454', '155993', '66', '1909');
INSERT INTO public.who_global_data_import VALUES (43122, '2020-11-19', 'JO', 'Jordan', 'EMRO', '7933', '163926', '60', '1969');
INSERT INTO public.who_global_data_import VALUES (43123, '2020-11-20', 'JO', 'Jordan', 'EMRO', '5470', '169396', '84', '2053');
INSERT INTO public.who_global_data_import VALUES (43124, '2020-11-21', 'JO', 'Jordan', 'EMRO', '4939', '174335', '63', '2116');
INSERT INTO public.who_global_data_import VALUES (43125, '2020-11-22', 'JO', 'Jordan', 'EMRO', '3826', '178161', '56', '2172');
INSERT INTO public.who_global_data_import VALUES (43126, '2020-11-23', 'JO', 'Jordan', 'EMRO', '5268', '183429', '64', '2236');
INSERT INTO public.who_global_data_import VALUES (43127, '2020-11-24', 'JO', 'Jordan', 'EMRO', '4981', '188410', '66', '2302');
INSERT INTO public.who_global_data_import VALUES (43128, '2020-11-25', 'JO', 'Jordan', 'EMRO', '4586', '192996', '78', '2380');
INSERT INTO public.who_global_data_import VALUES (43129, '2020-11-26', 'JO', 'Jordan', 'EMRO', '5025', '198021', '62', '2442');
INSERT INTO public.who_global_data_import VALUES (43130, '2020-11-27', 'JO', 'Jordan', 'EMRO', '5000', '203021', '67', '2509');
INSERT INTO public.who_global_data_import VALUES (43131, '2020-11-28', 'JO', 'Jordan', 'EMRO', '4580', '207601', '61', '2570');
INSERT INTO public.who_global_data_import VALUES (43132, '2020-11-29', 'JO', 'Jordan', 'EMRO', '3108', '210709', '56', '2626');
INSERT INTO public.who_global_data_import VALUES (43133, '2020-11-30', 'JO', 'Jordan', 'EMRO', '3598', '214307', '68', '2694');
INSERT INTO public.who_global_data_import VALUES (43134, '2020-12-01', 'JO', 'Jordan', 'EMRO', '5123', '219430', '57', '2751');
INSERT INTO public.who_global_data_import VALUES (43135, '2020-12-02', 'JO', 'Jordan', 'EMRO', '4187', '223617', '51', '2802');
INSERT INTO public.who_global_data_import VALUES (43136, '2020-12-03', 'JO', 'Jordan', 'EMRO', '3591', '227208', '52', '2854');
INSERT INTO public.who_global_data_import VALUES (43137, '2020-12-04', 'JO', 'Jordan', 'EMRO', '4029', '231237', '55', '2909');
INSERT INTO public.who_global_data_import VALUES (43138, '2020-12-05', 'JO', 'Jordan', 'EMRO', '3116', '234353', '51', '2960');
INSERT INTO public.who_global_data_import VALUES (43139, '2020-12-06', 'JO', 'Jordan', 'EMRO', '3160', '237513', '50', '3010');
INSERT INTO public.who_global_data_import VALUES (43140, '2020-12-07', 'JO', 'Jordan', 'EMRO', '2576', '240089', '46', '3056');
INSERT INTO public.who_global_data_import VALUES (43141, '2020-12-08', 'JO', 'Jordan', 'EMRO', '3980', '244069', '60', '3116');
INSERT INTO public.who_global_data_import VALUES (43142, '2020-12-09', 'JO', 'Jordan', 'EMRO', '3062', '247131', '46', '3162');
INSERT INTO public.who_global_data_import VALUES (43143, '2020-12-10', 'JO', 'Jordan', 'EMRO', '3088', '250219', '44', '3206');
INSERT INTO public.who_global_data_import VALUES (43144, '2020-12-11', 'JO', 'Jordan', 'EMRO', '2902', '253121', '44', '3250');
INSERT INTO public.who_global_data_import VALUES (43145, '2020-12-12', 'JO', 'Jordan', 'EMRO', '2338', '255459', '36', '3286');
INSERT INTO public.who_global_data_import VALUES (43146, '2020-12-13', 'JO', 'Jordan', 'EMRO', '1816', '257275', '49', '3335');
INSERT INTO public.who_global_data_import VALUES (43147, '2020-12-14', 'JO', 'Jordan', 'EMRO', '2339', '259614', '30', '3365');
INSERT INTO public.who_global_data_import VALUES (43148, '2020-12-15', 'JO', 'Jordan', 'EMRO', '2863', '262477', '42', '3407');
INSERT INTO public.who_global_data_import VALUES (43149, '2020-12-16', 'JO', 'Jordan', 'EMRO', '2547', '265024', '30', '3437');
INSERT INTO public.who_global_data_import VALUES (43150, '2020-12-17', 'JO', 'Jordan', 'EMRO', '2561', '267585', '28', '3465');
INSERT INTO public.who_global_data_import VALUES (43151, '2020-12-18', 'JO', 'Jordan', 'EMRO', '2221', '269806', '31', '3496');
INSERT INTO public.who_global_data_import VALUES (43152, '2020-12-19', 'JO', 'Jordan', 'EMRO', '1708', '271514', '22', '3518');
INSERT INTO public.who_global_data_import VALUES (43153, '2020-12-20', 'JO', 'Jordan', 'EMRO', '1283', '272797', '27', '3545');
INSERT INTO public.who_global_data_import VALUES (43154, '2020-12-21', 'JO', 'Jordan', 'EMRO', '2152', '274949', '23', '3568');
INSERT INTO public.who_global_data_import VALUES (43155, '2020-12-22', 'JO', 'Jordan', 'EMRO', '2499', '277448', '36', '3604');
INSERT INTO public.who_global_data_import VALUES (43156, '2020-12-23', 'JO', 'Jordan', 'EMRO', '2444', '279892', '23', '3627');
INSERT INTO public.who_global_data_import VALUES (43157, '2020-12-24', 'JO', 'Jordan', 'EMRO', '2091', '281983', '25', '3652');
INSERT INTO public.who_global_data_import VALUES (43158, '2020-12-25', 'JO', 'Jordan', 'EMRO', '1707', '283690', '29', '3681');
INSERT INTO public.who_global_data_import VALUES (43159, '2020-12-26', 'JO', 'Jordan', 'EMRO', '1616', '285306', '30', '3711');
INSERT INTO public.who_global_data_import VALUES (43160, '2020-12-27', 'JO', 'Jordan', 'EMRO', '1050', '286356', '18', '3729');
INSERT INTO public.who_global_data_import VALUES (43161, '2020-12-28', 'JO', 'Jordan', 'EMRO', '1590', '287946', '29', '3758');
INSERT INTO public.who_global_data_import VALUES (43162, '2020-12-29', 'JO', 'Jordan', 'EMRO', '1802', '289748', '20', '3778');
INSERT INTO public.who_global_data_import VALUES (43163, '2020-12-30', 'JO', 'Jordan', 'EMRO', '1645', '291393', '23', '3801');
INSERT INTO public.who_global_data_import VALUES (43164, '2020-12-31', 'JO', 'Jordan', 'EMRO', '1674', '293067', '14', '3815');
INSERT INTO public.who_global_data_import VALUES (43165, '2021-01-01', 'JO', 'Jordan', 'EMRO', '1427', '294494', '19', '3834');
INSERT INTO public.who_global_data_import VALUES (43166, '2021-01-02', 'JO', 'Jordan', 'EMRO', '1271', '295765', '17', '3851');
INSERT INTO public.who_global_data_import VALUES (43167, '2021-01-03', 'JO', 'Jordan', 'EMRO', '903', '296668', '26', '3877');
INSERT INTO public.who_global_data_import VALUES (43168, '2021-01-04', 'JO', 'Jordan', 'EMRO', '1540', '298208', '26', '3903');
INSERT INTO public.who_global_data_import VALUES (43169, '2021-01-05', 'JO', 'Jordan', 'EMRO', '1623', '299831', '16', '3919');
INSERT INTO public.who_global_data_import VALUES (43170, '2021-01-06', 'JO', 'Jordan', 'EMRO', '1472', '301303', '21', '3940');
INSERT INTO public.who_global_data_import VALUES (43171, '2021-01-07', 'JO', 'Jordan', 'EMRO', '1553', '302856', '15', '3955');
INSERT INTO public.who_global_data_import VALUES (43172, '2021-01-08', 'JO', 'Jordan', 'EMRO', '1215', '304071', '13', '3968');
INSERT INTO public.who_global_data_import VALUES (43173, '2021-01-09', 'JO', 'Jordan', 'EMRO', '1092', '305163', '21', '3989');
INSERT INTO public.who_global_data_import VALUES (43174, '2021-01-10', 'JO', 'Jordan', 'EMRO', '796', '305959', '20', '4009');
INSERT INTO public.who_global_data_import VALUES (43175, '2021-01-11', 'JO', 'Jordan', 'EMRO', '1250', '307209', '15', '4024');
INSERT INTO public.who_global_data_import VALUES (43176, '2021-01-12', 'JO', 'Jordan', 'EMRO', '1461', '308670', '19', '4043');
INSERT INTO public.who_global_data_import VALUES (43177, '2021-01-13', 'JO', 'Jordan', 'EMRO', '1176', '309846', '33', '4076');
INSERT INTO public.who_global_data_import VALUES (43178, '2021-01-14', 'JO', 'Jordan', 'EMRO', '1122', '310968', '15', '4091');
INSERT INTO public.who_global_data_import VALUES (43179, '2021-01-15', 'JO', 'Jordan', 'EMRO', '1075', '312043', '16', '4107');
INSERT INTO public.who_global_data_import VALUES (43180, '2021-01-16', 'JO', 'Jordan', 'EMRO', '808', '312851', '14', '4121');
INSERT INTO public.who_global_data_import VALUES (43181, '2021-01-17', 'JO', 'Jordan', 'EMRO', '706', '313557', '16', '4137');
INSERT INTO public.who_global_data_import VALUES (43182, '2021-01-18', 'JO', 'Jordan', 'EMRO', '957', '314514', '8', '4145');
INSERT INTO public.who_global_data_import VALUES (43183, '2021-01-19', 'JO', 'Jordan', 'EMRO', '1030', '315544', '8', '4153');
INSERT INTO public.who_global_data_import VALUES (43184, '2021-01-20', 'JO', 'Jordan', 'EMRO', '883', '316427', '17', '4170');
INSERT INTO public.who_global_data_import VALUES (43185, '2021-01-21', 'JO', 'Jordan', 'EMRO', '978', '317405', '17', '4187');
INSERT INTO public.who_global_data_import VALUES (43186, '2021-01-22', 'JO', 'Jordan', 'EMRO', '776', '318181', '11', '4198');
INSERT INTO public.who_global_data_import VALUES (43187, '2021-01-23', 'JO', 'Jordan', 'EMRO', '730', '318911', '9', '4207');
INSERT INTO public.who_global_data_import VALUES (43188, '2021-01-24', 'JO', 'Jordan', 'EMRO', '608', '319519', '10', '4217');
INSERT INTO public.who_global_data_import VALUES (43189, '2021-01-25', 'JO', 'Jordan', 'EMRO', '934', '320453', '7', '4224');
INSERT INTO public.who_global_data_import VALUES (43190, '2021-01-26', 'JO', 'Jordan', 'EMRO', '845', '321298', '15', '4239');
INSERT INTO public.who_global_data_import VALUES (43191, '2021-01-27', 'JO', 'Jordan', 'EMRO', '943', '322241', '9', '4248');
INSERT INTO public.who_global_data_import VALUES (43192, '2021-01-28', 'JO', 'Jordan', 'EMRO', '870', '323111', '14', '4262');
INSERT INTO public.who_global_data_import VALUES (43193, '2021-01-29', 'JO', 'Jordan', 'EMRO', '1058', '324169', '7', '4269');
INSERT INTO public.who_global_data_import VALUES (43194, '2021-01-30', 'JO', 'Jordan', 'EMRO', '864', '325033', '12', '4281');
INSERT INTO public.who_global_data_import VALUES (43195, '2021-01-31', 'JO', 'Jordan', 'EMRO', '641', '325674', '23', '4304');
INSERT INTO public.who_global_data_import VALUES (43196, '2021-02-01', 'JO', 'Jordan', 'EMRO', '1181', '326855', '12', '4316');
INSERT INTO public.who_global_data_import VALUES (43197, '2021-02-02', 'JO', 'Jordan', 'EMRO', '1207', '328062', '10', '4326');
INSERT INTO public.who_global_data_import VALUES (43198, '2021-02-03', 'JO', 'Jordan', 'EMRO', '1132', '329194', '8', '4334');
INSERT INTO public.who_global_data_import VALUES (43199, '2021-02-04', 'JO', 'Jordan', 'EMRO', '1280', '330474', '10', '4344');
INSERT INTO public.who_global_data_import VALUES (43200, '2021-02-05', 'JO', 'Jordan', 'EMRO', '1294', '331768', '10', '4354');
INSERT INTO public.who_global_data_import VALUES (43201, '2020-01-03', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43202, '2020-01-04', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43203, '2020-01-05', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43204, '2020-01-06', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43205, '2020-01-07', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43206, '2020-01-08', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43207, '2020-01-09', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43208, '2020-01-10', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43209, '2020-01-11', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43210, '2020-01-12', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43211, '2020-01-13', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43212, '2020-01-14', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43213, '2020-01-15', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43214, '2020-01-16', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43215, '2020-01-17', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43216, '2020-01-18', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43217, '2020-01-19', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43218, '2020-01-20', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43219, '2020-01-21', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43220, '2020-01-22', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43221, '2020-01-23', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43222, '2020-01-24', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43223, '2020-01-25', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43224, '2020-01-26', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43225, '2020-01-27', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43226, '2020-01-28', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43227, '2020-01-29', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43228, '2020-01-30', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43229, '2020-01-31', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43230, '2020-02-01', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43231, '2020-02-02', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43232, '2020-02-03', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43233, '2020-02-04', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43234, '2020-02-05', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43235, '2020-02-06', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43236, '2020-02-07', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43237, '2020-02-08', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43238, '2020-02-09', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43239, '2020-02-10', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43240, '2020-02-11', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43241, '2020-02-12', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43242, '2020-02-13', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43243, '2020-02-14', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43244, '2020-02-15', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43245, '2020-02-16', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43246, '2020-02-17', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43247, '2020-02-18', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43248, '2020-02-19', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43249, '2020-02-20', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43250, '2020-02-21', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43251, '2020-02-22', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43252, '2020-02-23', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43253, '2020-02-24', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43254, '2020-02-25', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43255, '2020-02-26', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43256, '2020-02-27', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43257, '2020-02-28', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43258, '2020-02-29', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43259, '2020-03-01', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43260, '2020-03-02', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43261, '2020-03-03', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43262, '2020-03-04', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43263, '2020-03-05', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43264, '2020-03-06', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43265, '2020-03-07', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43266, '2020-03-08', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43267, '2020-03-09', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43268, '2020-03-10', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43269, '2020-03-11', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43270, '2020-03-12', 'KZ', 'Kazakhstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43271, '2020-03-13', 'KZ', 'Kazakhstan', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43272, '2020-03-14', 'KZ', 'Kazakhstan', 'EURO', '4', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43273, '2020-03-15', 'KZ', 'Kazakhstan', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43274, '2020-03-16', 'KZ', 'Kazakhstan', 'EURO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43275, '2020-03-17', 'KZ', 'Kazakhstan', 'EURO', '27', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43276, '2020-03-18', 'KZ', 'Kazakhstan', 'EURO', '2', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43277, '2020-03-19', 'KZ', 'Kazakhstan', 'EURO', '11', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43278, '2020-03-20', 'KZ', 'Kazakhstan', 'EURO', '7', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43279, '2020-03-21', 'KZ', 'Kazakhstan', 'EURO', '4', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43280, '2020-03-22', 'KZ', 'Kazakhstan', 'EURO', '5', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43281, '2020-03-23', 'KZ', 'Kazakhstan', 'EURO', '10', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43282, '2020-03-24', 'KZ', 'Kazakhstan', 'EURO', '10', '82', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43283, '2020-03-25', 'KZ', 'Kazakhstan', 'EURO', '15', '97', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43284, '2020-03-26', 'KZ', 'Kazakhstan', 'EURO', '53', '150', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43285, '2020-03-27', 'KZ', 'Kazakhstan', 'EURO', '78', '228', '1', '1');
INSERT INTO public.who_global_data_import VALUES (43286, '2020-03-28', 'KZ', 'Kazakhstan', 'EURO', '56', '284', '0', '1');
INSERT INTO public.who_global_data_import VALUES (43287, '2020-03-29', 'KZ', 'Kazakhstan', 'EURO', '28', '312', '0', '1');
INSERT INTO public.who_global_data_import VALUES (43288, '2020-03-30', 'KZ', 'Kazakhstan', 'EURO', '0', '312', '0', '1');
INSERT INTO public.who_global_data_import VALUES (43289, '2020-03-31', 'KZ', 'Kazakhstan', 'EURO', '36', '348', '1', '2');
INSERT INTO public.who_global_data_import VALUES (43290, '2020-04-01', 'KZ', 'Kazakhstan', 'EURO', '38', '386', '1', '3');
INSERT INTO public.who_global_data_import VALUES (43291, '2020-04-02', 'KZ', 'Kazakhstan', 'EURO', '49', '435', '0', '3');
INSERT INTO public.who_global_data_import VALUES (43292, '2020-04-03', 'KZ', 'Kazakhstan', 'EURO', '25', '460', '0', '3');
INSERT INTO public.who_global_data_import VALUES (43293, '2020-04-04', 'KZ', 'Kazakhstan', 'EURO', '71', '531', '2', '5');
INSERT INTO public.who_global_data_import VALUES (43294, '2020-04-05', 'KZ', 'Kazakhstan', 'EURO', '73', '604', '0', '5');
INSERT INTO public.who_global_data_import VALUES (43295, '2020-04-06', 'KZ', 'Kazakhstan', 'EURO', '66', '670', '1', '6');
INSERT INTO public.who_global_data_import VALUES (43296, '2020-04-07', 'KZ', 'Kazakhstan', 'EURO', '39', '709', '0', '6');
INSERT INTO public.who_global_data_import VALUES (43297, '2020-04-08', 'KZ', 'Kazakhstan', 'EURO', '18', '727', '1', '7');
INSERT INTO public.who_global_data_import VALUES (43298, '2020-04-09', 'KZ', 'Kazakhstan', 'EURO', '75', '802', '2', '9');
INSERT INTO public.who_global_data_import VALUES (43299, '2020-04-10', 'KZ', 'Kazakhstan', 'EURO', '57', '859', '1', '10');
INSERT INTO public.who_global_data_import VALUES (43300, '2020-04-11', 'KZ', 'Kazakhstan', 'EURO', '38', '897', '0', '10');
INSERT INTO public.who_global_data_import VALUES (43301, '2020-04-12', 'KZ', 'Kazakhstan', 'EURO', '82', '979', '2', '12');
INSERT INTO public.who_global_data_import VALUES (43302, '2020-04-13', 'KZ', 'Kazakhstan', 'EURO', '112', '1091', '0', '12');
INSERT INTO public.who_global_data_import VALUES (43303, '2020-04-14', 'KZ', 'Kazakhstan', 'EURO', '184', '1275', '0', '12');
INSERT INTO public.who_global_data_import VALUES (43304, '2020-04-15', 'KZ', 'Kazakhstan', 'EURO', '20', '1295', '4', '16');
INSERT INTO public.who_global_data_import VALUES (43305, '2020-04-16', 'KZ', 'Kazakhstan', 'EURO', '185', '1480', '0', '16');
INSERT INTO public.who_global_data_import VALUES (43306, '2020-04-17', 'KZ', 'Kazakhstan', 'EURO', '66', '1546', '1', '17');
INSERT INTO public.who_global_data_import VALUES (43307, '2020-04-18', 'KZ', 'Kazakhstan', 'EURO', '81', '1627', '2', '19');
INSERT INTO public.who_global_data_import VALUES (43308, '2020-04-19', 'KZ', 'Kazakhstan', 'EURO', '141', '1768', '0', '19');
INSERT INTO public.who_global_data_import VALUES (43309, '2020-04-20', 'KZ', 'Kazakhstan', 'EURO', '84', '1852', '0', '19');
INSERT INTO public.who_global_data_import VALUES (43310, '2020-04-21', 'KZ', 'Kazakhstan', 'EURO', '143', '1995', '0', '19');
INSERT INTO public.who_global_data_import VALUES (43311, '2020-04-22', 'KZ', 'Kazakhstan', 'EURO', '30', '2025', '0', '19');
INSERT INTO public.who_global_data_import VALUES (43312, '2020-04-23', 'KZ', 'Kazakhstan', 'EURO', '0', '2025', '0', '19');
INSERT INTO public.who_global_data_import VALUES (43313, '2020-04-24', 'KZ', 'Kazakhstan', 'EURO', '391', '2416', '6', '25');
INSERT INTO public.who_global_data_import VALUES (43314, '2020-04-25', 'KZ', 'Kazakhstan', 'EURO', '185', '2601', '0', '25');
INSERT INTO public.who_global_data_import VALUES (43315, '2020-04-26', 'KZ', 'Kazakhstan', 'EURO', '190', '2791', '0', '25');
INSERT INTO public.who_global_data_import VALUES (43316, '2020-04-27', 'KZ', 'Kazakhstan', 'EURO', '191', '2982', '0', '25');
INSERT INTO public.who_global_data_import VALUES (43317, '2020-04-28', 'KZ', 'Kazakhstan', 'EURO', '96', '3078', '0', '25');
INSERT INTO public.who_global_data_import VALUES (43318, '2020-04-29', 'KZ', 'Kazakhstan', 'EURO', '255', '3333', '0', '25');
INSERT INTO public.who_global_data_import VALUES (43319, '2020-04-30', 'KZ', 'Kazakhstan', 'EURO', '218', '3551', '0', '25');
INSERT INTO public.who_global_data_import VALUES (43320, '2020-05-01', 'KZ', 'Kazakhstan', 'EURO', '234', '3785', '0', '25');
INSERT INTO public.who_global_data_import VALUES (43321, '2020-05-02', 'KZ', 'Kazakhstan', 'EURO', '92', '3877', '1', '26');
INSERT INTO public.who_global_data_import VALUES (43322, '2020-05-03', 'KZ', 'Kazakhstan', 'EURO', '111', '3988', '1', '27');
INSERT INTO public.who_global_data_import VALUES (43323, '2020-05-04', 'KZ', 'Kazakhstan', 'EURO', '172', '4160', '2', '29');
INSERT INTO public.who_global_data_import VALUES (43324, '2020-05-05', 'KZ', 'Kazakhstan', 'EURO', '138', '4298', '0', '29');
INSERT INTO public.who_global_data_import VALUES (43325, '2020-05-06', 'KZ', 'Kazakhstan', 'EURO', '211', '4509', '1', '30');
INSERT INTO public.who_global_data_import VALUES (43326, '2020-05-07', 'KZ', 'Kazakhstan', 'EURO', '69', '4578', '0', '30');
INSERT INTO public.who_global_data_import VALUES (43327, '2020-05-08', 'KZ', 'Kazakhstan', 'EURO', '344', '4922', '1', '31');
INSERT INTO public.who_global_data_import VALUES (43328, '2020-05-09', 'KZ', 'Kazakhstan', 'EURO', '134', '5056', '0', '31');
INSERT INTO public.who_global_data_import VALUES (43329, '2020-05-10', 'KZ', 'Kazakhstan', 'EURO', '82', '5138', '0', '31');
INSERT INTO public.who_global_data_import VALUES (43330, '2020-05-11', 'KZ', 'Kazakhstan', 'EURO', '69', '5207', '1', '32');
INSERT INTO public.who_global_data_import VALUES (43331, '2020-05-12', 'KZ', 'Kazakhstan', 'EURO', '210', '5417', '0', '32');
INSERT INTO public.who_global_data_import VALUES (43332, '2020-05-13', 'KZ', 'Kazakhstan', 'EURO', '154', '5571', '1', '33');
INSERT INTO public.who_global_data_import VALUES (43333, '2020-05-14', 'KZ', 'Kazakhstan', 'EURO', '118', '5689', '1', '34');
INSERT INTO public.who_global_data_import VALUES (43334, '2020-05-15', 'KZ', 'Kazakhstan', 'EURO', '161', '5850', '0', '34');
INSERT INTO public.who_global_data_import VALUES (43335, '2020-05-16', 'KZ', 'Kazakhstan', 'EURO', '307', '6157', '0', '34');
INSERT INTO public.who_global_data_import VALUES (43336, '2020-05-17', 'KZ', 'Kazakhstan', 'EURO', '283', '6440', '0', '34');
INSERT INTO public.who_global_data_import VALUES (43337, '2020-05-18', 'KZ', 'Kazakhstan', 'EURO', '311', '6751', '1', '35');
INSERT INTO public.who_global_data_import VALUES (43338, '2020-05-19', 'KZ', 'Kazakhstan', 'EURO', '218', '6969', '0', '35');
INSERT INTO public.who_global_data_import VALUES (43339, '2020-05-20', 'KZ', 'Kazakhstan', 'EURO', '265', '7234', '0', '35');
INSERT INTO public.who_global_data_import VALUES (43340, '2020-05-21', 'KZ', 'Kazakhstan', 'EURO', '363', '7597', '0', '35');
INSERT INTO public.who_global_data_import VALUES (43341, '2020-05-22', 'KZ', 'Kazakhstan', 'EURO', '322', '7919', '0', '35');
INSERT INTO public.who_global_data_import VALUES (43342, '2020-05-23', 'KZ', 'Kazakhstan', 'EURO', '403', '8322', '0', '35');
INSERT INTO public.who_global_data_import VALUES (43343, '2020-05-24', 'KZ', 'Kazakhstan', 'EURO', '209', '8531', '0', '35');
INSERT INTO public.who_global_data_import VALUES (43344, '2020-05-25', 'KZ', 'Kazakhstan', 'EURO', '438', '8969', '0', '35');
INSERT INTO public.who_global_data_import VALUES (43345, '2020-05-26', 'KZ', 'Kazakhstan', 'EURO', '335', '9304', '2', '37');
INSERT INTO public.who_global_data_import VALUES (43346, '2020-05-27', 'KZ', 'Kazakhstan', 'EURO', '272', '9576', '0', '37');
INSERT INTO public.who_global_data_import VALUES (43347, '2020-05-28', 'KZ', 'Kazakhstan', 'EURO', '356', '9932', '0', '37');
INSERT INTO public.who_global_data_import VALUES (43348, '2020-05-29', 'KZ', 'Kazakhstan', 'EURO', '450', '10382', '0', '37');
INSERT INTO public.who_global_data_import VALUES (43349, '2020-05-30', 'KZ', 'Kazakhstan', 'EURO', '476', '10858', '1', '38');
INSERT INTO public.who_global_data_import VALUES (43350, '2020-05-31', 'KZ', 'Kazakhstan', 'EURO', '450', '11308', '3', '41');
INSERT INTO public.who_global_data_import VALUES (43351, '2020-06-01', 'KZ', 'Kazakhstan', 'EURO', '263', '11571', '0', '41');
INSERT INTO public.who_global_data_import VALUES (43352, '2020-06-02', 'KZ', 'Kazakhstan', 'EURO', '225', '11796', '3', '44');
INSERT INTO public.who_global_data_import VALUES (43353, '2020-06-03', 'KZ', 'Kazakhstan', 'EURO', '271', '12067', '4', '48');
INSERT INTO public.who_global_data_import VALUES (43354, '2020-06-04', 'KZ', 'Kazakhstan', 'EURO', '245', '12312', '0', '48');
INSERT INTO public.who_global_data_import VALUES (43355, '2020-06-05', 'KZ', 'Kazakhstan', 'EURO', '199', '12511', '4', '52');
INSERT INTO public.who_global_data_import VALUES (43356, '2020-06-06', 'KZ', 'Kazakhstan', 'EURO', '183', '12694', '2', '54');
INSERT INTO public.who_global_data_import VALUES (43357, '2020-06-07', 'KZ', 'Kazakhstan', 'EURO', '165', '12859', '2', '56');
INSERT INTO public.who_global_data_import VALUES (43358, '2020-06-08', 'KZ', 'Kazakhstan', 'EURO', '215', '13074', '2', '58');
INSERT INTO public.who_global_data_import VALUES (43359, '2020-06-09', 'KZ', 'Kazakhstan', 'EURO', '245', '13319', '3', '61');
INSERT INTO public.who_global_data_import VALUES (43360, '2020-06-10', 'KZ', 'Kazakhstan', 'EURO', '240', '13559', '6', '67');
INSERT INTO public.who_global_data_import VALUES (43361, '2020-06-11', 'KZ', 'Kazakhstan', 'EURO', '313', '13872', '0', '67');
INSERT INTO public.who_global_data_import VALUES (43362, '2020-06-12', 'KZ', 'Kazakhstan', 'EURO', '366', '14238', '3', '70');
INSERT INTO public.who_global_data_import VALUES (43363, '2020-06-13', 'KZ', 'Kazakhstan', 'EURO', '258', '14496', '3', '73');
INSERT INTO public.who_global_data_import VALUES (43364, '2020-06-14', 'KZ', 'Kazakhstan', 'EURO', '313', '14809', '4', '77');
INSERT INTO public.who_global_data_import VALUES (43365, '2020-06-15', 'KZ', 'Kazakhstan', 'EURO', '383', '15192', '4', '81');
INSERT INTO public.who_global_data_import VALUES (43366, '2020-06-16', 'KZ', 'Kazakhstan', 'EURO', '350', '15542', '7', '88');
INSERT INTO public.who_global_data_import VALUES (43367, '2020-06-17', 'KZ', 'Kazakhstan', 'EURO', '335', '15877', '12', '100');
INSERT INTO public.who_global_data_import VALUES (43368, '2020-06-18', 'KZ', 'Kazakhstan', 'EURO', '474', '16351', '5', '105');
INSERT INTO public.who_global_data_import VALUES (43369, '2020-06-19', 'KZ', 'Kazakhstan', 'EURO', '428', '16779', '8', '113');
INSERT INTO public.who_global_data_import VALUES (43370, '2020-06-20', 'KZ', 'Kazakhstan', 'EURO', '1062', '17841', '5', '118');
INSERT INTO public.who_global_data_import VALUES (43371, '2020-06-21', 'KZ', 'Kazakhstan', 'EURO', '1410', '19251', '2', '120');
INSERT INTO public.who_global_data_import VALUES (43372, '2020-06-22', 'KZ', 'Kazakhstan', 'EURO', '1315', '20566', '7', '127');
INSERT INTO public.who_global_data_import VALUES (43373, '2020-06-23', 'KZ', 'Kazakhstan', 'EURO', '1630', '22196', '7', '134');
INSERT INTO public.who_global_data_import VALUES (43374, '2020-06-24', 'KZ', 'Kazakhstan', 'EURO', '1476', '23672', '2', '136');
INSERT INTO public.who_global_data_import VALUES (43375, '2020-06-25', 'KZ', 'Kazakhstan', 'EURO', '1348', '25020', '11', '147');
INSERT INTO public.who_global_data_import VALUES (43376, '2020-06-26', 'KZ', 'Kazakhstan', 'EURO', '1557', '26577', '11', '158');
INSERT INTO public.who_global_data_import VALUES (43377, '2020-06-27', 'KZ', 'Kazakhstan', 'EURO', '1486', '28063', '15', '173');
INSERT INTO public.who_global_data_import VALUES (43378, '2020-06-28', 'KZ', 'Kazakhstan', 'EURO', '1613', '29676', '10', '183');
INSERT INTO public.who_global_data_import VALUES (43379, '2020-06-29', 'KZ', 'Kazakhstan', 'EURO', '492', '30168', '5', '188');
INSERT INTO public.who_global_data_import VALUES (43380, '2020-06-30', 'KZ', 'Kazakhstan', 'EURO', '10897', '41065', '0', '188');
INSERT INTO public.who_global_data_import VALUES (43381, '2020-07-01', 'KZ', 'Kazakhstan', 'EURO', '1509', '42574', '10', '198');
INSERT INTO public.who_global_data_import VALUES (43382, '2020-07-02', 'KZ', 'Kazakhstan', 'EURO', '1501', '44075', '12', '210');
INSERT INTO public.who_global_data_import VALUES (43383, '2020-07-03', 'KZ', 'Kazakhstan', 'EURO', '1644', '45719', '14', '224');
INSERT INTO public.who_global_data_import VALUES (43384, '2020-07-04', 'KZ', 'Kazakhstan', 'EURO', '1452', '47171', '18', '242');
INSERT INTO public.who_global_data_import VALUES (43385, '2020-07-05', 'KZ', 'Kazakhstan', 'EURO', '1403', '48574', '18', '260');
INSERT INTO public.who_global_data_import VALUES (43386, '2020-07-06', 'KZ', 'Kazakhstan', 'EURO', '1109', '49683', '4', '264');
INSERT INTO public.who_global_data_import VALUES (43387, '2020-07-07', 'KZ', 'Kazakhstan', 'EURO', '1376', '51059', '0', '264');
INSERT INTO public.who_global_data_import VALUES (43388, '2020-07-08', 'KZ', 'Kazakhstan', 'EURO', '1962', '53021', '32', '296');
INSERT INTO public.who_global_data_import VALUES (43389, '2020-07-09', 'KZ', 'Kazakhstan', 'EURO', '1726', '54747', '17', '313');
INSERT INTO public.who_global_data_import VALUES (43390, '2020-07-10', 'KZ', 'Kazakhstan', 'EURO', '1708', '56455', '19', '332');
INSERT INTO public.who_global_data_import VALUES (43391, '2020-07-11', 'KZ', 'Kazakhstan', 'EURO', '1798', '58253', '20', '352');
INSERT INTO public.who_global_data_import VALUES (43392, '2020-07-12', 'KZ', 'Kazakhstan', 'EURO', '1646', '59899', '23', '375');
INSERT INTO public.who_global_data_import VALUES (43393, '2020-07-13', 'KZ', 'Kazakhstan', 'EURO', '1856', '61755', '0', '375');
INSERT INTO public.who_global_data_import VALUES (43394, '2020-07-14', 'KZ', 'Kazakhstan', 'EURO', '1759', '63514', '0', '375');
INSERT INTO public.who_global_data_import VALUES (43395, '2020-07-15', 'KZ', 'Kazakhstan', 'EURO', '1674', '65188', '0', '375');
INSERT INTO public.who_global_data_import VALUES (43396, '2020-07-16', 'KZ', 'Kazakhstan', 'EURO', '1707', '66895', '0', '375');
INSERT INTO public.who_global_data_import VALUES (43397, '2020-07-17', 'KZ', 'Kazakhstan', 'EURO', '1808', '68703', '0', '375');
INSERT INTO public.who_global_data_import VALUES (43398, '2020-07-18', 'KZ', 'Kazakhstan', 'EURO', '1636', '70339', '0', '375');
INSERT INTO public.who_global_data_import VALUES (43399, '2020-07-19', 'KZ', 'Kazakhstan', 'EURO', '1499', '71838', '210', '585');
INSERT INTO public.who_global_data_import VALUES (43400, '2020-07-20', 'KZ', 'Kazakhstan', 'EURO', '1630', '73468', '0', '585');
INSERT INTO public.who_global_data_import VALUES (43401, '2020-07-21', 'KZ', 'Kazakhstan', 'EURO', '1685', '75153', '0', '585');
INSERT INTO public.who_global_data_import VALUES (43402, '2020-07-22', 'KZ', 'Kazakhstan', 'EURO', '1646', '76799', '0', '585');
INSERT INTO public.who_global_data_import VALUES (43403, '2020-07-23', 'KZ', 'Kazakhstan', 'EURO', '1687', '78486', '0', '585');
INSERT INTO public.who_global_data_import VALUES (43404, '2020-07-24', 'KZ', 'Kazakhstan', 'EURO', '1740', '80226', '0', '585');
INSERT INTO public.who_global_data_import VALUES (43405, '2020-07-25', 'KZ', 'Kazakhstan', 'EURO', '1494', '81720', '0', '585');
INSERT INTO public.who_global_data_import VALUES (43406, '2020-07-26', 'KZ', 'Kazakhstan', 'EURO', '1402', '83122', '0', '585');
INSERT INTO public.who_global_data_import VALUES (43407, '2020-07-27', 'KZ', 'Kazakhstan', 'EURO', '1526', '84648', '0', '585');
INSERT INTO public.who_global_data_import VALUES (43408, '2020-07-28', 'KZ', 'Kazakhstan', 'EURO', '1544', '86192', '208', '793');
INSERT INTO public.who_global_data_import VALUES (43409, '2020-07-29', 'KZ', 'Kazakhstan', 'EURO', '1472', '87664', '0', '793');
INSERT INTO public.who_global_data_import VALUES (43410, '2020-07-30', 'KZ', 'Kazakhstan', 'EURO', '1414', '89078', '0', '793');
INSERT INTO public.who_global_data_import VALUES (43411, '2020-07-31', 'KZ', 'Kazakhstan', 'EURO', '1289', '90367', '0', '793');
INSERT INTO public.who_global_data_import VALUES (43412, '2020-08-01', 'KZ', 'Kazakhstan', 'EURO', '6407', '96774', '30', '823');
INSERT INTO public.who_global_data_import VALUES (43413, '2020-08-02', 'KZ', 'Kazakhstan', 'EURO', '1867', '98641', '286', '1109');
INSERT INTO public.who_global_data_import VALUES (43414, '2020-08-03', 'KZ', 'Kazakhstan', 'EURO', '1434', '100075', '0', '1109');
INSERT INTO public.who_global_data_import VALUES (43415, '2020-08-04', 'KZ', 'Kazakhstan', 'EURO', '2861', '102936', '0', '1109');
INSERT INTO public.who_global_data_import VALUES (43416, '2020-08-05', 'KZ', 'Kazakhstan', 'EURO', '2590', '105526', '0', '1109');
INSERT INTO public.who_global_data_import VALUES (43417, '2020-08-06', 'KZ', 'Kazakhstan', 'EURO', '2404', '107930', '0', '1109');
INSERT INTO public.who_global_data_import VALUES (43418, '2020-08-07', 'KZ', 'Kazakhstan', 'EURO', '2009', '109939', '0', '1109');
INSERT INTO public.who_global_data_import VALUES (43419, '2020-08-08', 'KZ', 'Kazakhstan', 'EURO', '1883', '111822', '0', '1109');
INSERT INTO public.who_global_data_import VALUES (43420, '2020-08-09', 'KZ', 'Kazakhstan', 'EURO', '900', '112722', '324', '1433');
INSERT INTO public.who_global_data_import VALUES (43421, '2020-08-10', 'KZ', 'Kazakhstan', 'EURO', '779', '113501', '0', '1433');
INSERT INTO public.who_global_data_import VALUES (43422, '2020-08-11', 'KZ', 'Kazakhstan', 'EURO', '2114', '115615', '0', '1433');
INSERT INTO public.who_global_data_import VALUES (43423, '2020-08-12', 'KZ', 'Kazakhstan', 'EURO', '1489', '117104', '0', '1433');
INSERT INTO public.who_global_data_import VALUES (43424, '2020-08-13', 'KZ', 'Kazakhstan', 'EURO', '1410', '118514', '0', '1433');
INSERT INTO public.who_global_data_import VALUES (43425, '2020-08-14', 'KZ', 'Kazakhstan', 'EURO', '1267', '119781', '0', '1433');
INSERT INTO public.who_global_data_import VALUES (43426, '2020-08-15', 'KZ', 'Kazakhstan', 'EURO', '1380', '121161', '0', '1433');
INSERT INTO public.who_global_data_import VALUES (43427, '2020-08-16', 'KZ', 'Kazakhstan', 'EURO', '478', '121639', '200', '1633');
INSERT INTO public.who_global_data_import VALUES (43428, '2020-08-17', 'KZ', 'Kazakhstan', 'EURO', '334', '121973', '0', '1633');
INSERT INTO public.who_global_data_import VALUES (43429, '2020-08-18', 'KZ', 'Kazakhstan', 'EURO', '1352', '123325', '0', '1633');
INSERT INTO public.who_global_data_import VALUES (43430, '2020-08-19', 'KZ', 'Kazakhstan', 'EURO', '1031', '124356', '0', '1633');
INSERT INTO public.who_global_data_import VALUES (43431, '2020-08-20', 'KZ', 'Kazakhstan', 'EURO', '979', '125335', '0', '1633');
INSERT INTO public.who_global_data_import VALUES (43432, '2020-08-21', 'KZ', 'Kazakhstan', 'EURO', '908', '126243', '0', '1633');
INSERT INTO public.who_global_data_import VALUES (43433, '2020-08-22', 'KZ', 'Kazakhstan', 'EURO', '960', '127203', '0', '1633');
INSERT INTO public.who_global_data_import VALUES (43434, '2020-08-23', 'KZ', 'Kazakhstan', 'EURO', '259', '127462', '148', '1781');
INSERT INTO public.who_global_data_import VALUES (43435, '2020-08-24', 'KZ', 'Kazakhstan', 'EURO', '202', '127664', '0', '1781');
INSERT INTO public.who_global_data_import VALUES (43436, '2020-08-25', 'KZ', 'Kazakhstan', 'EURO', '954', '128618', '0', '1781');
INSERT INTO public.who_global_data_import VALUES (43437, '2020-08-26', 'KZ', 'Kazakhstan', 'EURO', '726', '129344', '0', '1781');
INSERT INTO public.who_global_data_import VALUES (43640, '2020-02-11', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43438, '2020-08-27', 'KZ', 'Kazakhstan', 'EURO', '696', '130040', '0', '1781');
INSERT INTO public.who_global_data_import VALUES (43439, '2020-08-28', 'KZ', 'Kazakhstan', 'EURO', '633', '130673', '0', '1781');
INSERT INTO public.who_global_data_import VALUES (43440, '2020-08-29', 'KZ', 'Kazakhstan', 'EURO', '669', '131342', '0', '1781');
INSERT INTO public.who_global_data_import VALUES (43441, '2020-08-30', 'KZ', 'Kazakhstan', 'EURO', '167', '131509', '97', '1878');
INSERT INTO public.who_global_data_import VALUES (43442, '2020-08-31', 'KZ', 'Kazakhstan', 'EURO', '87', '131596', '0', '1878');
INSERT INTO public.who_global_data_import VALUES (43443, '2020-09-01', 'KZ', 'Kazakhstan', 'EURO', '99', '131695', '0', '1878');
INSERT INTO public.who_global_data_import VALUES (43444, '2020-09-02', 'KZ', 'Kazakhstan', 'EURO', '659', '132354', '0', '1878');
INSERT INTO public.who_global_data_import VALUES (43445, '2020-09-03', 'KZ', 'Kazakhstan', 'EURO', '570', '132924', '0', '1878');
INSERT INTO public.who_global_data_import VALUES (43446, '2020-09-04', 'KZ', 'Kazakhstan', 'EURO', '501', '133425', '0', '1878');
INSERT INTO public.who_global_data_import VALUES (43447, '2020-09-05', 'KZ', 'Kazakhstan', 'EURO', '499', '133924', '0', '1878');
INSERT INTO public.who_global_data_import VALUES (43448, '2020-09-06', 'KZ', 'Kazakhstan', 'EURO', '199', '134123', '70', '1948');
INSERT INTO public.who_global_data_import VALUES (43449, '2020-09-07', 'KZ', 'Kazakhstan', 'EURO', '80', '134203', '0', '1948');
INSERT INTO public.who_global_data_import VALUES (43450, '2020-09-08', 'KZ', 'Kazakhstan', 'EURO', '433', '134636', '0', '1948');
INSERT INTO public.who_global_data_import VALUES (43451, '2020-09-09', 'KZ', 'Kazakhstan', 'EURO', '523', '135159', '0', '1948');
INSERT INTO public.who_global_data_import VALUES (43452, '2020-09-10', 'KZ', 'Kazakhstan', 'EURO', '430', '135589', '0', '1948');
INSERT INTO public.who_global_data_import VALUES (43453, '2020-09-11', 'KZ', 'Kazakhstan', 'EURO', '375', '135964', '0', '1948');
INSERT INTO public.who_global_data_import VALUES (43454, '2020-09-12', 'KZ', 'Kazakhstan', 'EURO', '420', '136384', '0', '1948');
INSERT INTO public.who_global_data_import VALUES (43455, '2020-09-13', 'KZ', 'Kazakhstan', 'EURO', '129', '136513', '51', '1999');
INSERT INTO public.who_global_data_import VALUES (43456, '2020-09-14', 'KZ', 'Kazakhstan', 'EURO', '73', '136586', '0', '1999');
INSERT INTO public.who_global_data_import VALUES (43457, '2020-09-15', 'KZ', 'Kazakhstan', 'EURO', '472', '137058', '0', '1999');
INSERT INTO public.who_global_data_import VALUES (43458, '2020-09-16', 'KZ', 'Kazakhstan', 'EURO', '335', '137393', '0', '1999');
INSERT INTO public.who_global_data_import VALUES (43459, '2020-09-17', 'KZ', 'Kazakhstan', 'EURO', '320', '137713', '0', '1999');
INSERT INTO public.who_global_data_import VALUES (43460, '2020-09-18', 'KZ', 'Kazakhstan', 'EURO', '300', '138013', '0', '1999');
INSERT INTO public.who_global_data_import VALUES (43461, '2020-09-19', 'KZ', 'Kazakhstan', 'EURO', '335', '138348', '0', '1999');
INSERT INTO public.who_global_data_import VALUES (43462, '2020-09-20', 'KZ', 'Kazakhstan', 'EURO', '107', '138455', '44', '2043');
INSERT INTO public.who_global_data_import VALUES (43463, '2020-09-21', 'KZ', 'Kazakhstan', 'EURO', '87', '138542', '0', '2043');
INSERT INTO public.who_global_data_import VALUES (43464, '2020-09-22', 'KZ', 'Kazakhstan', 'EURO', '440', '138982', '0', '2043');
INSERT INTO public.who_global_data_import VALUES (43465, '2020-09-23', 'KZ', 'Kazakhstan', 'EURO', '307', '139289', '0', '2043');
INSERT INTO public.who_global_data_import VALUES (43466, '2020-09-24', 'KZ', 'Kazakhstan', 'EURO', '292', '139581', '0', '2043');
INSERT INTO public.who_global_data_import VALUES (43467, '2020-09-25', 'KZ', 'Kazakhstan', 'EURO', '301', '139882', '0', '2043');
INSERT INTO public.who_global_data_import VALUES (43468, '2020-09-26', 'KZ', 'Kazakhstan', 'EURO', '293', '140175', '0', '2043');
INSERT INTO public.who_global_data_import VALUES (43469, '2020-09-27', 'KZ', 'Kazakhstan', 'EURO', '90', '140265', '32', '2075');
INSERT INTO public.who_global_data_import VALUES (43470, '2020-09-28', 'KZ', 'Kazakhstan', 'EURO', '68', '140333', '0', '2075');
INSERT INTO public.who_global_data_import VALUES (43471, '2020-09-29', 'KZ', 'Kazakhstan', 'EURO', '374', '140707', '0', '2075');
INSERT INTO public.who_global_data_import VALUES (43472, '2020-09-30', 'KZ', 'Kazakhstan', 'EURO', '250', '140957', '0', '2075');
INSERT INTO public.who_global_data_import VALUES (43473, '2020-10-01', 'KZ', 'Kazakhstan', 'EURO', '299', '141256', '0', '2075');
INSERT INTO public.who_global_data_import VALUES (43474, '2020-10-02', 'KZ', 'Kazakhstan', 'EURO', '228', '141484', '0', '2075');
INSERT INTO public.who_global_data_import VALUES (43475, '2020-10-03', 'KZ', 'Kazakhstan', 'EURO', '264', '141748', '0', '2075');
INSERT INTO public.who_global_data_import VALUES (43476, '2020-10-04', 'KZ', 'Kazakhstan', 'EURO', '96', '141844', '31', '2106');
INSERT INTO public.who_global_data_import VALUES (43477, '2020-10-05', 'KZ', 'Kazakhstan', 'EURO', '67', '141911', '0', '2106');
INSERT INTO public.who_global_data_import VALUES (43478, '2020-10-06', 'KZ', 'Kazakhstan', 'EURO', '328', '142239', '0', '2106');
INSERT INTO public.who_global_data_import VALUES (43479, '2020-10-07', 'KZ', 'Kazakhstan', 'EURO', '358', '142597', '0', '2106');
INSERT INTO public.who_global_data_import VALUES (43480, '2020-10-08', 'KZ', 'Kazakhstan', 'EURO', '348', '142945', '0', '2106');
INSERT INTO public.who_global_data_import VALUES (43481, '2020-10-09', 'KZ', 'Kazakhstan', 'EURO', '335', '143280', '0', '2106');
INSERT INTO public.who_global_data_import VALUES (43482, '2020-10-10', 'KZ', 'Kazakhstan', 'EURO', '352', '143632', '0', '2106');
INSERT INTO public.who_global_data_import VALUES (43483, '2020-10-11', 'KZ', 'Kazakhstan', 'EURO', '108', '143740', '30', '2136');
INSERT INTO public.who_global_data_import VALUES (43484, '2020-10-12', 'KZ', 'Kazakhstan', 'EURO', '74', '143814', '0', '2136');
INSERT INTO public.who_global_data_import VALUES (43485, '2020-10-13', 'KZ', 'Kazakhstan', 'EURO', '404', '144218', '0', '2136');
INSERT INTO public.who_global_data_import VALUES (43486, '2020-10-14', 'KZ', 'Kazakhstan', 'EURO', '269', '144487', '0', '2136');
INSERT INTO public.who_global_data_import VALUES (43487, '2020-10-15', 'KZ', 'Kazakhstan', 'EURO', '274', '144761', '0', '2136');
INSERT INTO public.who_global_data_import VALUES (43488, '2020-10-16', 'KZ', 'Kazakhstan', 'EURO', '258', '145019', '0', '2136');
INSERT INTO public.who_global_data_import VALUES (43489, '2020-10-17', 'KZ', 'Kazakhstan', 'EURO', '301', '145320', '0', '2136');
INSERT INTO public.who_global_data_import VALUES (43490, '2020-10-18', 'KZ', 'Kazakhstan', 'EURO', '153', '145473', '42', '2178');
INSERT INTO public.who_global_data_import VALUES (43491, '2020-10-19', 'KZ', 'Kazakhstan', 'EURO', '130', '145603', '0', '2178');
INSERT INTO public.who_global_data_import VALUES (43492, '2020-10-20', 'KZ', 'Kazakhstan', 'EURO', '363', '145966', '0', '2178');
INSERT INTO public.who_global_data_import VALUES (43493, '2020-10-21', 'KZ', 'Kazakhstan', 'EURO', '322', '146288', '0', '2178');
INSERT INTO public.who_global_data_import VALUES (43494, '2020-10-22', 'KZ', 'Kazakhstan', 'EURO', '365', '146653', '0', '2178');
INSERT INTO public.who_global_data_import VALUES (43495, '2020-10-23', 'KZ', 'Kazakhstan', 'EURO', '329', '146982', '0', '2178');
INSERT INTO public.who_global_data_import VALUES (43496, '2020-10-24', 'KZ', 'Kazakhstan', 'EURO', '315', '147297', '0', '2178');
INSERT INTO public.who_global_data_import VALUES (43497, '2020-10-25', 'KZ', 'Kazakhstan', 'EURO', '166', '147463', '41', '2219');
INSERT INTO public.who_global_data_import VALUES (43498, '2020-10-26', 'KZ', 'Kazakhstan', 'EURO', '152', '147615', '0', '2219');
INSERT INTO public.who_global_data_import VALUES (43499, '2020-10-27', 'KZ', 'Kazakhstan', 'EURO', '422', '148037', '0', '2219');
INSERT INTO public.who_global_data_import VALUES (43500, '2020-10-28', 'KZ', 'Kazakhstan', 'EURO', '442', '148479', '0', '2219');
INSERT INTO public.who_global_data_import VALUES (43501, '2020-10-29', 'KZ', 'Kazakhstan', 'EURO', '587', '149066', '0', '2219');
INSERT INTO public.who_global_data_import VALUES (43502, '2020-10-30', 'KZ', 'Kazakhstan', 'EURO', '633', '149699', '0', '2219');
INSERT INTO public.who_global_data_import VALUES (43503, '2020-10-31', 'KZ', 'Kazakhstan', 'EURO', '681', '150380', '0', '2219');
INSERT INTO public.who_global_data_import VALUES (43504, '2020-11-01', 'KZ', 'Kazakhstan', 'EURO', '483', '150863', '40', '2259');
INSERT INTO public.who_global_data_import VALUES (43505, '2020-11-02', 'KZ', 'Kazakhstan', 'EURO', '458', '151321', '0', '2259');
INSERT INTO public.who_global_data_import VALUES (43506, '2020-11-03', 'KZ', 'Kazakhstan', 'EURO', '701', '152022', '0', '2259');
INSERT INTO public.who_global_data_import VALUES (43507, '2020-11-04', 'KZ', 'Kazakhstan', 'EURO', '703', '152725', '0', '2259');
INSERT INTO public.who_global_data_import VALUES (43508, '2020-11-05', 'KZ', 'Kazakhstan', 'EURO', '822', '153547', '0', '2259');
INSERT INTO public.who_global_data_import VALUES (43509, '2020-11-06', 'KZ', 'Kazakhstan', 'EURO', '774', '154321', '0', '2259');
INSERT INTO public.who_global_data_import VALUES (43510, '2020-11-07', 'KZ', 'Kazakhstan', 'EURO', '899', '155220', '0', '2259');
INSERT INTO public.who_global_data_import VALUES (43511, '2020-11-08', 'KZ', 'Kazakhstan', 'EURO', '656', '155876', '47', '2306');
INSERT INTO public.who_global_data_import VALUES (43512, '2020-11-09', 'KZ', 'Kazakhstan', 'EURO', '575', '156451', '0', '2306');
INSERT INTO public.who_global_data_import VALUES (43513, '2020-11-10', 'KZ', 'Kazakhstan', 'EURO', '810', '157261', '0', '2306');
INSERT INTO public.who_global_data_import VALUES (43514, '2020-11-11', 'KZ', 'Kazakhstan', 'EURO', '775', '158036', '0', '2306');
INSERT INTO public.who_global_data_import VALUES (43515, '2020-11-12', 'KZ', 'Kazakhstan', 'EURO', '817', '158853', '0', '2306');
INSERT INTO public.who_global_data_import VALUES (43516, '2020-11-13', 'KZ', 'Kazakhstan', 'EURO', '903', '159756', '0', '2306');
INSERT INTO public.who_global_data_import VALUES (43517, '2020-11-14', 'KZ', 'Kazakhstan', 'EURO', '856', '160612', '0', '2306');
INSERT INTO public.who_global_data_import VALUES (43518, '2020-11-15', 'KZ', 'Kazakhstan', 'EURO', '636', '161248', '59', '2365');
INSERT INTO public.who_global_data_import VALUES (43519, '2020-11-16', 'KZ', 'Kazakhstan', 'EURO', '625', '161873', '0', '2365');
INSERT INTO public.who_global_data_import VALUES (43520, '2020-11-17', 'KZ', 'Kazakhstan', 'EURO', '950', '162823', '0', '2365');
INSERT INTO public.who_global_data_import VALUES (43521, '2020-11-18', 'KZ', 'Kazakhstan', 'EURO', '964', '163787', '0', '2365');
INSERT INTO public.who_global_data_import VALUES (43522, '2020-11-19', 'KZ', 'Kazakhstan', 'EURO', '949', '164736', '0', '2365');
INSERT INTO public.who_global_data_import VALUES (43523, '2020-11-20', 'KZ', 'Kazakhstan', 'EURO', '976', '165712', '0', '2365');
INSERT INTO public.who_global_data_import VALUES (43524, '2020-11-21', 'KZ', 'Kazakhstan', 'EURO', '913', '166625', '0', '2365');
INSERT INTO public.who_global_data_import VALUES (43525, '2020-11-22', 'KZ', 'Kazakhstan', 'EURO', '760', '167385', '52', '2417');
INSERT INTO public.who_global_data_import VALUES (43526, '2020-11-23', 'KZ', 'Kazakhstan', 'EURO', '698', '168083', '0', '2417');
INSERT INTO public.who_global_data_import VALUES (43527, '2020-11-24', 'KZ', 'Kazakhstan', 'EURO', '924', '169007', '0', '2417');
INSERT INTO public.who_global_data_import VALUES (43528, '2020-11-25', 'KZ', 'Kazakhstan', 'EURO', '988', '169995', '0', '2417');
INSERT INTO public.who_global_data_import VALUES (43529, '2020-11-26', 'KZ', 'Kazakhstan', 'EURO', '974', '170969', '0', '2417');
INSERT INTO public.who_global_data_import VALUES (43530, '2020-11-27', 'KZ', 'Kazakhstan', 'EURO', '1010', '171979', '0', '2417');
INSERT INTO public.who_global_data_import VALUES (43531, '2020-11-28', 'KZ', 'Kazakhstan', 'EURO', '990', '172969', '0', '2417');
INSERT INTO public.who_global_data_import VALUES (43532, '2020-11-29', 'KZ', 'Kazakhstan', 'EURO', '837', '173806', '60', '2477');
INSERT INTO public.who_global_data_import VALUES (43533, '2020-11-30', 'KZ', 'Kazakhstan', 'EURO', '757', '174563', '0', '2477');
INSERT INTO public.who_global_data_import VALUES (43534, '2020-12-01', 'KZ', 'Kazakhstan', 'EURO', '1002', '175565', '0', '2477');
INSERT INTO public.who_global_data_import VALUES (43535, '2020-12-02', 'KZ', 'Kazakhstan', 'EURO', '777', '176342', '0', '2477');
INSERT INTO public.who_global_data_import VALUES (43536, '2020-12-03', 'KZ', 'Kazakhstan', 'EURO', '1044', '177386', '0', '2477');
INSERT INTO public.who_global_data_import VALUES (43537, '2020-12-04', 'KZ', 'Kazakhstan', 'EURO', '992', '178378', '0', '2477');
INSERT INTO public.who_global_data_import VALUES (43538, '2020-12-05', 'KZ', 'Kazakhstan', 'EURO', '966', '179344', '0', '2477');
INSERT INTO public.who_global_data_import VALUES (43539, '2020-12-06', 'KZ', 'Kazakhstan', 'EURO', '745', '180089', '65', '2542');
INSERT INTO public.who_global_data_import VALUES (43540, '2020-12-07', 'KZ', 'Kazakhstan', 'EURO', '688', '180777', '0', '2542');
INSERT INTO public.who_global_data_import VALUES (43541, '2020-12-08', 'KZ', 'Kazakhstan', 'EURO', '944', '181721', '0', '2542');
INSERT INTO public.who_global_data_import VALUES (43542, '2020-12-09', 'KZ', 'Kazakhstan', 'EURO', '936', '182657', '0', '2542');
INSERT INTO public.who_global_data_import VALUES (43543, '2020-12-10', 'KZ', 'Kazakhstan', 'EURO', '973', '183630', '0', '2542');
INSERT INTO public.who_global_data_import VALUES (43544, '2020-12-11', 'KZ', 'Kazakhstan', 'EURO', '927', '184557', '0', '2542');
INSERT INTO public.who_global_data_import VALUES (43545, '2020-12-12', 'KZ', 'Kazakhstan', 'EURO', '956', '185513', '0', '2542');
INSERT INTO public.who_global_data_import VALUES (43546, '2020-12-13', 'KZ', 'Kazakhstan', 'EURO', '764', '186277', '67', '2609');
INSERT INTO public.who_global_data_import VALUES (43547, '2020-12-14', 'KZ', 'Kazakhstan', 'EURO', '683', '186960', '0', '2609');
INSERT INTO public.who_global_data_import VALUES (43548, '2020-12-15', 'KZ', 'Kazakhstan', 'EURO', '930', '187890', '0', '2609');
INSERT INTO public.who_global_data_import VALUES (43549, '2020-12-16', 'KZ', 'Kazakhstan', 'EURO', '947', '188837', '0', '2609');
INSERT INTO public.who_global_data_import VALUES (43550, '2020-12-17', 'KZ', 'Kazakhstan', 'EURO', '714', '189551', '0', '2609');
INSERT INTO public.who_global_data_import VALUES (43551, '2020-12-18', 'KZ', 'Kazakhstan', 'EURO', '741', '190292', '0', '2609');
INSERT INTO public.who_global_data_import VALUES (43552, '2020-12-19', 'KZ', 'Kazakhstan', 'EURO', '677', '190969', '0', '2609');
INSERT INTO public.who_global_data_import VALUES (43553, '2020-12-20', 'KZ', 'Kazakhstan', 'EURO', '681', '191650', '60', '2669');
INSERT INTO public.who_global_data_import VALUES (43554, '2020-12-21', 'KZ', 'Kazakhstan', 'EURO', '929', '192579', '0', '2669');
INSERT INTO public.who_global_data_import VALUES (43555, '2020-12-22', 'KZ', 'Kazakhstan', 'EURO', '924', '193503', '0', '2669');
INSERT INTO public.who_global_data_import VALUES (43556, '2020-12-23', 'KZ', 'Kazakhstan', 'EURO', '910', '194413', '0', '2669');
INSERT INTO public.who_global_data_import VALUES (43557, '2020-12-24', 'KZ', 'Kazakhstan', 'EURO', '890', '195303', '0', '2669');
INSERT INTO public.who_global_data_import VALUES (43558, '2020-12-25', 'KZ', 'Kazakhstan', 'EURO', '913', '196216', '0', '2669');
INSERT INTO public.who_global_data_import VALUES (43559, '2020-12-26', 'KZ', 'Kazakhstan', 'EURO', '926', '197142', '0', '2669');
INSERT INTO public.who_global_data_import VALUES (43560, '2020-12-27', 'KZ', 'Kazakhstan', 'EURO', '760', '197902', '80', '2749');
INSERT INTO public.who_global_data_import VALUES (43561, '2020-12-28', 'KZ', 'Kazakhstan', 'EURO', '757', '198659', '0', '2749');
INSERT INTO public.who_global_data_import VALUES (43562, '2020-12-29', 'KZ', 'Kazakhstan', 'EURO', '896', '199555', '0', '2749');
INSERT INTO public.who_global_data_import VALUES (43563, '2020-12-30', 'KZ', 'Kazakhstan', 'EURO', '888', '200443', '0', '2749');
INSERT INTO public.who_global_data_import VALUES (43564, '2020-12-31', 'KZ', 'Kazakhstan', 'EURO', '870', '201313', '0', '2749');
INSERT INTO public.who_global_data_import VALUES (43565, '2021-01-01', 'KZ', 'Kazakhstan', 'EURO', '846', '202159', '0', '2749');
INSERT INTO public.who_global_data_import VALUES (43566, '2021-01-02', 'KZ', 'Kazakhstan', 'EURO', '721', '202880', '0', '2749');
INSERT INTO public.who_global_data_import VALUES (43567, '2021-01-03', 'KZ', 'Kazakhstan', 'EURO', '683', '203563', '96', '2845');
INSERT INTO public.who_global_data_import VALUES (43568, '2021-01-04', 'KZ', 'Kazakhstan', 'EURO', '730', '204293', '0', '2845');
INSERT INTO public.who_global_data_import VALUES (43569, '2021-01-05', 'KZ', 'Kazakhstan', 'EURO', '771', '205064', '0', '2845');
INSERT INTO public.who_global_data_import VALUES (43570, '2021-01-06', 'KZ', 'Kazakhstan', 'EURO', '869', '205933', '0', '2845');
INSERT INTO public.who_global_data_import VALUES (43571, '2021-01-07', 'KZ', 'Kazakhstan', 'EURO', '907', '206840', '0', '2845');
INSERT INTO public.who_global_data_import VALUES (43572, '2021-01-08', 'KZ', 'Kazakhstan', 'EURO', '871', '207711', '0', '2845');
INSERT INTO public.who_global_data_import VALUES (43573, '2021-01-09', 'KZ', 'Kazakhstan', 'EURO', '885', '208596', '0', '2845');
INSERT INTO public.who_global_data_import VALUES (43574, '2021-01-10', 'KZ', 'Kazakhstan', 'EURO', '773', '209369', '40', '2885');
INSERT INTO public.who_global_data_import VALUES (43575, '2021-01-11', 'KZ', 'Kazakhstan', 'EURO', '717', '210086', '0', '2885');
INSERT INTO public.who_global_data_import VALUES (43576, '2021-01-12', 'KZ', 'Kazakhstan', 'EURO', '890', '210976', '0', '2885');
INSERT INTO public.who_global_data_import VALUES (43577, '2021-01-13', 'KZ', 'Kazakhstan', 'EURO', '925', '211901', '0', '2885');
INSERT INTO public.who_global_data_import VALUES (43578, '2021-01-14', 'KZ', 'Kazakhstan', 'EURO', '911', '212812', '0', '2885');
INSERT INTO public.who_global_data_import VALUES (43579, '2021-01-15', 'KZ', 'Kazakhstan', 'EURO', '1043', '213855', '0', '2885');
INSERT INTO public.who_global_data_import VALUES (43580, '2021-01-16', 'KZ', 'Kazakhstan', 'EURO', '1072', '214927', '0', '2885');
INSERT INTO public.who_global_data_import VALUES (43581, '2021-01-17', 'KZ', 'Kazakhstan', 'EURO', '1020', '215947', '71', '2956');
INSERT INTO public.who_global_data_import VALUES (43582, '2021-01-18', 'KZ', 'Kazakhstan', 'EURO', '1017', '216964', '0', '2956');
INSERT INTO public.who_global_data_import VALUES (43583, '2021-01-19', 'KZ', 'Kazakhstan', 'EURO', '1252', '218216', '0', '2956');
INSERT INTO public.who_global_data_import VALUES (43584, '2021-01-20', 'KZ', 'Kazakhstan', 'EURO', '1311', '219527', '0', '2956');
INSERT INTO public.who_global_data_import VALUES (43585, '2021-01-21', 'KZ', 'Kazakhstan', 'EURO', '1526', '221053', '0', '2956');
INSERT INTO public.who_global_data_import VALUES (43586, '2021-01-22', 'KZ', 'Kazakhstan', 'EURO', '1648', '222701', '0', '2956');
INSERT INTO public.who_global_data_import VALUES (43587, '2021-01-23', 'KZ', 'Kazakhstan', 'EURO', '1694', '224395', '0', '2956');
INSERT INTO public.who_global_data_import VALUES (43588, '2021-01-24', 'KZ', 'Kazakhstan', 'EURO', '1496', '225891', '79', '3035');
INSERT INTO public.who_global_data_import VALUES (43589, '2021-01-25', 'KZ', 'Kazakhstan', 'EURO', '1274', '227165', '0', '3035');
INSERT INTO public.who_global_data_import VALUES (43590, '2021-01-26', 'KZ', 'Kazakhstan', 'EURO', '1527', '228692', '0', '3035');
INSERT INTO public.who_global_data_import VALUES (43591, '2021-01-27', 'KZ', 'Kazakhstan', 'EURO', '1496', '230188', '0', '3035');
INSERT INTO public.who_global_data_import VALUES (43592, '2021-01-28', 'KZ', 'Kazakhstan', 'EURO', '1528', '231716', '0', '3035');
INSERT INTO public.who_global_data_import VALUES (43593, '2021-01-29', 'KZ', 'Kazakhstan', 'EURO', '1440', '233156', '0', '3035');
INSERT INTO public.who_global_data_import VALUES (43594, '2021-01-30', 'KZ', 'Kazakhstan', 'EURO', '1413', '234569', '0', '3035');
INSERT INTO public.who_global_data_import VALUES (43595, '2021-01-31', 'KZ', 'Kazakhstan', 'EURO', '1275', '235844', '91', '3126');
INSERT INTO public.who_global_data_import VALUES (43596, '2021-02-01', 'KZ', 'Kazakhstan', 'EURO', '1185', '237029', '0', '3126');
INSERT INTO public.who_global_data_import VALUES (43597, '2021-02-02', 'KZ', 'Kazakhstan', 'EURO', '1335', '238364', '0', '3126');
INSERT INTO public.who_global_data_import VALUES (43598, '2021-02-03', 'KZ', 'Kazakhstan', 'EURO', '1362', '239726', '0', '3126');
INSERT INTO public.who_global_data_import VALUES (43599, '2021-02-04', 'KZ', 'Kazakhstan', 'EURO', '1257', '240983', '0', '3126');
INSERT INTO public.who_global_data_import VALUES (43600, '2021-02-05', 'KZ', 'Kazakhstan', 'EURO', '0', '240983', '0', '3126');
INSERT INTO public.who_global_data_import VALUES (43601, '2020-01-03', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43602, '2020-01-04', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43603, '2020-01-05', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43604, '2020-01-06', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43605, '2020-01-07', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43606, '2020-01-08', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43607, '2020-01-09', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43608, '2020-01-10', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43609, '2020-01-11', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43610, '2020-01-12', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43611, '2020-01-13', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43612, '2020-01-14', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43613, '2020-01-15', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43614, '2020-01-16', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43615, '2020-01-17', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43616, '2020-01-18', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43617, '2020-01-19', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43618, '2020-01-20', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43619, '2020-01-21', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43620, '2020-01-22', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43621, '2020-01-23', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43622, '2020-01-24', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43623, '2020-01-25', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43624, '2020-01-26', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43625, '2020-01-27', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43626, '2020-01-28', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43627, '2020-01-29', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43628, '2020-01-30', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43629, '2020-01-31', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43630, '2020-02-01', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43631, '2020-02-02', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43632, '2020-02-03', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43633, '2020-02-04', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43634, '2020-02-05', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43635, '2020-02-06', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43636, '2020-02-07', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43637, '2020-02-08', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43638, '2020-02-09', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43641, '2020-02-12', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43642, '2020-02-13', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43643, '2020-02-14', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43644, '2020-02-15', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43645, '2020-02-16', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43646, '2020-02-17', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43647, '2020-02-18', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43648, '2020-02-19', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43649, '2020-02-20', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43650, '2020-02-21', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43651, '2020-02-22', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43652, '2020-02-23', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43653, '2020-02-24', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43654, '2020-02-25', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43655, '2020-02-26', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43656, '2020-02-27', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43657, '2020-02-28', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43658, '2020-02-29', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43659, '2020-03-01', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43660, '2020-03-02', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43661, '2020-03-03', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43662, '2020-03-04', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43663, '2020-03-05', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43664, '2020-03-06', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43665, '2020-03-07', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43666, '2020-03-08', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43667, '2020-03-09', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43668, '2020-03-10', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43669, '2020-03-11', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43670, '2020-03-12', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43671, '2020-03-13', 'KE', 'Kenya', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43672, '2020-03-14', 'KE', 'Kenya', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43673, '2020-03-15', 'KE', 'Kenya', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43674, '2020-03-16', 'KE', 'Kenya', 'AFRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43675, '2020-03-17', 'KE', 'Kenya', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43676, '2020-03-18', 'KE', 'Kenya', 'AFRO', '4', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43677, '2020-03-19', 'KE', 'Kenya', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43678, '2020-03-20', 'KE', 'Kenya', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43679, '2020-03-21', 'KE', 'Kenya', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43680, '2020-03-22', 'KE', 'Kenya', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43681, '2020-03-23', 'KE', 'Kenya', 'AFRO', '4', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43682, '2020-03-24', 'KE', 'Kenya', 'AFRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43683, '2020-03-25', 'KE', 'Kenya', 'AFRO', '9', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43684, '2020-03-26', 'KE', 'Kenya', 'AFRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (43685, '2020-03-27', 'KE', 'Kenya', 'AFRO', '0', '25', '1', '1');
INSERT INTO public.who_global_data_import VALUES (43686, '2020-03-28', 'KE', 'Kenya', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (43687, '2020-03-29', 'KE', 'Kenya', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (43688, '2020-03-30', 'KE', 'Kenya', 'AFRO', '13', '38', '0', '1');
INSERT INTO public.who_global_data_import VALUES (43689, '2020-03-31', 'KE', 'Kenya', 'AFRO', '12', '50', '0', '1');
INSERT INTO public.who_global_data_import VALUES (43690, '2020-04-01', 'KE', 'Kenya', 'AFRO', '9', '59', '0', '1');
INSERT INTO public.who_global_data_import VALUES (43691, '2020-04-02', 'KE', 'Kenya', 'AFRO', '22', '81', '0', '1');
INSERT INTO public.who_global_data_import VALUES (43692, '2020-04-03', 'KE', 'Kenya', 'AFRO', '29', '110', '2', '3');
INSERT INTO public.who_global_data_import VALUES (43693, '2020-04-04', 'KE', 'Kenya', 'AFRO', '12', '122', '1', '4');
INSERT INTO public.who_global_data_import VALUES (43694, '2020-04-05', 'KE', 'Kenya', 'AFRO', '0', '122', '0', '4');
INSERT INTO public.who_global_data_import VALUES (43695, '2020-04-06', 'KE', 'Kenya', 'AFRO', '20', '142', '0', '4');
INSERT INTO public.who_global_data_import VALUES (43696, '2020-04-07', 'KE', 'Kenya', 'AFRO', '0', '142', '0', '4');
INSERT INTO public.who_global_data_import VALUES (43697, '2020-04-08', 'KE', 'Kenya', 'AFRO', '30', '172', '2', '6');
INSERT INTO public.who_global_data_import VALUES (43698, '2020-04-09', 'KE', 'Kenya', 'AFRO', '7', '179', '0', '6');
INSERT INTO public.who_global_data_import VALUES (43699, '2020-04-10', 'KE', 'Kenya', 'AFRO', '5', '184', '1', '7');
INSERT INTO public.who_global_data_import VALUES (43700, '2020-04-11', 'KE', 'Kenya', 'AFRO', '5', '189', '0', '7');
INSERT INTO public.who_global_data_import VALUES (43701, '2020-04-12', 'KE', 'Kenya', 'AFRO', '2', '191', '0', '7');
INSERT INTO public.who_global_data_import VALUES (43702, '2020-04-13', 'KE', 'Kenya', 'AFRO', '6', '197', '1', '8');
INSERT INTO public.who_global_data_import VALUES (43703, '2020-04-14', 'KE', 'Kenya', 'AFRO', '11', '208', '1', '9');
INSERT INTO public.who_global_data_import VALUES (43704, '2020-04-15', 'KE', 'Kenya', 'AFRO', '8', '216', '0', '9');
INSERT INTO public.who_global_data_import VALUES (43705, '2020-04-16', 'KE', 'Kenya', 'AFRO', '9', '225', '1', '10');
INSERT INTO public.who_global_data_import VALUES (43706, '2020-04-17', 'KE', 'Kenya', 'AFRO', '9', '234', '1', '11');
INSERT INTO public.who_global_data_import VALUES (43707, '2020-04-18', 'KE', 'Kenya', 'AFRO', '12', '246', '0', '11');
INSERT INTO public.who_global_data_import VALUES (43708, '2020-04-19', 'KE', 'Kenya', 'AFRO', '16', '262', '1', '12');
INSERT INTO public.who_global_data_import VALUES (43709, '2020-04-20', 'KE', 'Kenya', 'AFRO', '8', '270', '2', '14');
INSERT INTO public.who_global_data_import VALUES (43710, '2020-04-21', 'KE', 'Kenya', 'AFRO', '11', '281', '0', '14');
INSERT INTO public.who_global_data_import VALUES (43711, '2020-04-22', 'KE', 'Kenya', 'AFRO', '15', '296', '0', '14');
INSERT INTO public.who_global_data_import VALUES (43712, '2020-04-23', 'KE', 'Kenya', 'AFRO', '7', '303', '0', '14');
INSERT INTO public.who_global_data_import VALUES (43713, '2020-04-24', 'KE', 'Kenya', 'AFRO', '17', '320', '0', '14');
INSERT INTO public.who_global_data_import VALUES (43714, '2020-04-25', 'KE', 'Kenya', 'AFRO', '16', '336', '0', '14');
INSERT INTO public.who_global_data_import VALUES (43715, '2020-04-26', 'KE', 'Kenya', 'AFRO', '7', '343', '0', '14');
INSERT INTO public.who_global_data_import VALUES (43716, '2020-04-27', 'KE', 'Kenya', 'AFRO', '12', '355', '0', '14');
INSERT INTO public.who_global_data_import VALUES (43717, '2020-04-28', 'KE', 'Kenya', 'AFRO', '8', '363', '0', '14');
INSERT INTO public.who_global_data_import VALUES (43718, '2020-04-29', 'KE', 'Kenya', 'AFRO', '11', '374', '0', '14');
INSERT INTO public.who_global_data_import VALUES (43719, '2020-04-30', 'KE', 'Kenya', 'AFRO', '10', '384', '1', '15');
INSERT INTO public.who_global_data_import VALUES (43720, '2020-05-01', 'KE', 'Kenya', 'AFRO', '12', '396', '2', '17');
INSERT INTO public.who_global_data_import VALUES (43721, '2020-05-02', 'KE', 'Kenya', 'AFRO', '15', '411', '4', '21');
INSERT INTO public.who_global_data_import VALUES (43722, '2020-05-03', 'KE', 'Kenya', 'AFRO', '24', '435', '1', '22');
INSERT INTO public.who_global_data_import VALUES (43723, '2020-05-04', 'KE', 'Kenya', 'AFRO', '31', '466', '2', '24');
INSERT INTO public.who_global_data_import VALUES (43724, '2020-05-05', 'KE', 'Kenya', 'AFRO', '24', '490', '0', '24');
INSERT INTO public.who_global_data_import VALUES (43725, '2020-05-06', 'KE', 'Kenya', 'AFRO', '45', '535', '2', '26');
INSERT INTO public.who_global_data_import VALUES (43726, '2020-05-07', 'KE', 'Kenya', 'AFRO', '47', '582', '0', '26');
INSERT INTO public.who_global_data_import VALUES (43727, '2020-05-08', 'KE', 'Kenya', 'AFRO', '25', '607', '3', '29');
INSERT INTO public.who_global_data_import VALUES (43728, '2020-05-09', 'KE', 'Kenya', 'AFRO', '14', '621', '0', '29');
INSERT INTO public.who_global_data_import VALUES (43729, '2020-05-10', 'KE', 'Kenya', 'AFRO', '28', '649', '1', '30');
INSERT INTO public.who_global_data_import VALUES (43730, '2020-05-11', 'KE', 'Kenya', 'AFRO', '23', '672', '2', '32');
INSERT INTO public.who_global_data_import VALUES (43731, '2020-05-12', 'KE', 'Kenya', 'AFRO', '28', '700', '1', '33');
INSERT INTO public.who_global_data_import VALUES (43732, '2020-05-13', 'KE', 'Kenya', 'AFRO', '15', '715', '3', '36');
INSERT INTO public.who_global_data_import VALUES (43733, '2020-05-14', 'KE', 'Kenya', 'AFRO', '22', '737', '4', '40');
INSERT INTO public.who_global_data_import VALUES (43734, '2020-05-15', 'KE', 'Kenya', 'AFRO', '21', '758', '2', '42');
INSERT INTO public.who_global_data_import VALUES (43735, '2020-05-16', 'KE', 'Kenya', 'AFRO', '23', '781', '4', '46');
INSERT INTO public.who_global_data_import VALUES (43736, '2020-05-17', 'KE', 'Kenya', 'AFRO', '49', '830', '4', '50');
INSERT INTO public.who_global_data_import VALUES (43737, '2020-05-18', 'KE', 'Kenya', 'AFRO', '57', '887', '0', '50');
INSERT INTO public.who_global_data_import VALUES (43738, '2020-05-19', 'KE', 'Kenya', 'AFRO', '25', '912', '0', '50');
INSERT INTO public.who_global_data_import VALUES (43739, '2020-05-20', 'KE', 'Kenya', 'AFRO', '51', '963', '0', '50');
INSERT INTO public.who_global_data_import VALUES (43740, '2020-05-21', 'KE', 'Kenya', 'AFRO', '66', '1029', '0', '50');
INSERT INTO public.who_global_data_import VALUES (43741, '2020-05-22', 'KE', 'Kenya', 'AFRO', '80', '1109', '0', '50');
INSERT INTO public.who_global_data_import VALUES (43742, '2020-05-23', 'KE', 'Kenya', 'AFRO', '52', '1161', '0', '50');
INSERT INTO public.who_global_data_import VALUES (43743, '2020-05-24', 'KE', 'Kenya', 'AFRO', '31', '1192', '0', '50');
INSERT INTO public.who_global_data_import VALUES (43744, '2020-05-25', 'KE', 'Kenya', 'AFRO', '22', '1214', '1', '51');
INSERT INTO public.who_global_data_import VALUES (43745, '2020-05-26', 'KE', 'Kenya', 'AFRO', '72', '1286', '1', '52');
INSERT INTO public.who_global_data_import VALUES (43746, '2020-05-27', 'KE', 'Kenya', 'AFRO', '62', '1348', '0', '52');
INSERT INTO public.who_global_data_import VALUES (43747, '2020-05-28', 'KE', 'Kenya', 'AFRO', '123', '1471', '3', '55');
INSERT INTO public.who_global_data_import VALUES (43748, '2020-05-29', 'KE', 'Kenya', 'AFRO', '147', '1618', '3', '58');
INSERT INTO public.who_global_data_import VALUES (43749, '2020-05-30', 'KE', 'Kenya', 'AFRO', '127', '1745', '4', '62');
INSERT INTO public.who_global_data_import VALUES (43750, '2020-05-31', 'KE', 'Kenya', 'AFRO', '143', '1888', '1', '63');
INSERT INTO public.who_global_data_import VALUES (43751, '2020-06-01', 'KE', 'Kenya', 'AFRO', '74', '1962', '1', '64');
INSERT INTO public.who_global_data_import VALUES (43752, '2020-06-02', 'KE', 'Kenya', 'AFRO', '59', '2021', '5', '69');
INSERT INTO public.who_global_data_import VALUES (43753, '2020-06-03', 'KE', 'Kenya', 'AFRO', '72', '2093', '2', '71');
INSERT INTO public.who_global_data_import VALUES (43754, '2020-06-04', 'KE', 'Kenya', 'AFRO', '123', '2216', '3', '74');
INSERT INTO public.who_global_data_import VALUES (43755, '2020-06-05', 'KE', 'Kenya', 'AFRO', '124', '2340', '4', '78');
INSERT INTO public.who_global_data_import VALUES (43756, '2020-06-06', 'KE', 'Kenya', 'AFRO', '134', '2474', '1', '79');
INSERT INTO public.who_global_data_import VALUES (43757, '2020-06-07', 'KE', 'Kenya', 'AFRO', '126', '2600', '4', '83');
INSERT INTO public.who_global_data_import VALUES (43758, '2020-06-08', 'KE', 'Kenya', 'AFRO', '167', '2767', '1', '84');
INSERT INTO public.who_global_data_import VALUES (43759, '2020-06-09', 'KE', 'Kenya', 'AFRO', '95', '2862', '1', '85');
INSERT INTO public.who_global_data_import VALUES (43760, '2020-06-10', 'KE', 'Kenya', 'AFRO', '127', '2989', '3', '88');
INSERT INTO public.who_global_data_import VALUES (43761, '2020-06-11', 'KE', 'Kenya', 'AFRO', '105', '3094', '1', '89');
INSERT INTO public.who_global_data_import VALUES (43762, '2020-06-12', 'KE', 'Kenya', 'AFRO', '121', '3215', '3', '92');
INSERT INTO public.who_global_data_import VALUES (43763, '2020-06-13', 'KE', 'Kenya', 'AFRO', '90', '3305', '4', '96');
INSERT INTO public.who_global_data_import VALUES (43764, '2020-06-14', 'KE', 'Kenya', 'AFRO', '152', '3457', '4', '100');
INSERT INTO public.who_global_data_import VALUES (43765, '2020-06-15', 'KE', 'Kenya', 'AFRO', '137', '3594', '3', '103');
INSERT INTO public.who_global_data_import VALUES (43766, '2020-06-16', 'KE', 'Kenya', 'AFRO', '133', '3727', '1', '104');
INSERT INTO public.who_global_data_import VALUES (43767, '2020-06-17', 'KE', 'Kenya', 'AFRO', '133', '3860', '1', '105');
INSERT INTO public.who_global_data_import VALUES (43768, '2020-06-18', 'KE', 'Kenya', 'AFRO', '184', '4044', '2', '107');
INSERT INTO public.who_global_data_import VALUES (43769, '2020-06-19', 'KE', 'Kenya', 'AFRO', '213', '4257', '10', '117');
INSERT INTO public.who_global_data_import VALUES (43770, '2020-06-20', 'KE', 'Kenya', 'AFRO', '117', '4374', '2', '119');
INSERT INTO public.who_global_data_import VALUES (43771, '2020-06-21', 'KE', 'Kenya', 'AFRO', '104', '4478', '2', '121');
INSERT INTO public.who_global_data_import VALUES (43772, '2020-06-22', 'KE', 'Kenya', 'AFRO', '260', '4738', '2', '123');
INSERT INTO public.who_global_data_import VALUES (43773, '2020-06-23', 'KE', 'Kenya', 'AFRO', '59', '4797', '2', '125');
INSERT INTO public.who_global_data_import VALUES (43774, '2020-06-24', 'KE', 'Kenya', 'AFRO', '155', '4952', '3', '128');
INSERT INTO public.who_global_data_import VALUES (43775, '2020-06-25', 'KE', 'Kenya', 'AFRO', '254', '5206', '2', '130');
INSERT INTO public.who_global_data_import VALUES (43776, '2020-06-26', 'KE', 'Kenya', 'AFRO', '178', '5384', '2', '132');
INSERT INTO public.who_global_data_import VALUES (43777, '2020-06-27', 'KE', 'Kenya', 'AFRO', '149', '5533', '5', '137');
INSERT INTO public.who_global_data_import VALUES (43778, '2020-06-28', 'KE', 'Kenya', 'AFRO', '278', '5811', '4', '141');
INSERT INTO public.who_global_data_import VALUES (43779, '2020-06-29', 'KE', 'Kenya', 'AFRO', '259', '6070', '3', '144');
INSERT INTO public.who_global_data_import VALUES (43780, '2020-06-30', 'KE', 'Kenya', 'AFRO', '120', '6190', '0', '144');
INSERT INTO public.who_global_data_import VALUES (43781, '2020-07-01', 'KE', 'Kenya', 'AFRO', '176', '6366', '4', '148');
INSERT INTO public.who_global_data_import VALUES (43782, '2020-07-02', 'KE', 'Kenya', 'AFRO', '307', '6673', '1', '149');
INSERT INTO public.who_global_data_import VALUES (43783, '2020-07-03', 'KE', 'Kenya', 'AFRO', '268', '6941', '3', '152');
INSERT INTO public.who_global_data_import VALUES (43784, '2020-07-04', 'KE', 'Kenya', 'AFRO', '247', '7188', '2', '154');
INSERT INTO public.who_global_data_import VALUES (43785, '2020-07-05', 'KE', 'Kenya', 'AFRO', '389', '7577', '5', '159');
INSERT INTO public.who_global_data_import VALUES (43786, '2020-07-06', 'KE', 'Kenya', 'AFRO', '309', '7886', '1', '160');
INSERT INTO public.who_global_data_import VALUES (43787, '2020-07-07', 'KE', 'Kenya', 'AFRO', '181', '8067', '4', '164');
INSERT INTO public.who_global_data_import VALUES (43788, '2020-07-08', 'KE', 'Kenya', 'AFRO', '183', '8250', '3', '167');
INSERT INTO public.who_global_data_import VALUES (43789, '2020-07-09', 'KE', 'Kenya', 'AFRO', '278', '8528', '2', '169');
INSERT INTO public.who_global_data_import VALUES (43790, '2020-07-10', 'KE', 'Kenya', 'AFRO', '447', '8975', '4', '173');
INSERT INTO public.who_global_data_import VALUES (43791, '2020-07-11', 'KE', 'Kenya', 'AFRO', '473', '9448', '8', '181');
INSERT INTO public.who_global_data_import VALUES (43792, '2020-07-12', 'KE', 'Kenya', 'AFRO', '278', '9726', '3', '184');
INSERT INTO public.who_global_data_import VALUES (43793, '2020-07-13', 'KE', 'Kenya', 'AFRO', '379', '10105', '1', '185');
INSERT INTO public.who_global_data_import VALUES (43794, '2020-07-14', 'KE', 'Kenya', 'AFRO', '189', '10294', '12', '197');
INSERT INTO public.who_global_data_import VALUES (43795, '2020-07-15', 'KE', 'Kenya', 'AFRO', '497', '10791', '5', '202');
INSERT INTO public.who_global_data_import VALUES (43796, '2020-07-16', 'KE', 'Kenya', 'AFRO', '461', '11252', '7', '209');
INSERT INTO public.who_global_data_import VALUES (43797, '2020-07-17', 'KE', 'Kenya', 'AFRO', '421', '11673', '8', '217');
INSERT INTO public.who_global_data_import VALUES (43798, '2020-07-18', 'KE', 'Kenya', 'AFRO', '389', '12062', '5', '222');
INSERT INTO public.who_global_data_import VALUES (43799, '2020-07-19', 'KE', 'Kenya', 'AFRO', '688', '12750', '3', '225');
INSERT INTO public.who_global_data_import VALUES (43800, '2020-07-20', 'KE', 'Kenya', 'AFRO', '603', '13353', '9', '234');
INSERT INTO public.who_global_data_import VALUES (43801, '2020-07-21', 'KE', 'Kenya', 'AFRO', '418', '13771', '4', '238');
INSERT INTO public.who_global_data_import VALUES (43802, '2020-07-22', 'KE', 'Kenya', 'AFRO', '397', '14168', '12', '250');
INSERT INTO public.who_global_data_import VALUES (43803, '2020-07-23', 'KE', 'Kenya', 'AFRO', '637', '14805', '10', '260');
INSERT INTO public.who_global_data_import VALUES (43804, '2020-07-24', 'KE', 'Kenya', 'AFRO', '796', '15601', '3', '263');
INSERT INTO public.who_global_data_import VALUES (43805, '2020-07-25', 'KE', 'Kenya', 'AFRO', '667', '16268', '11', '274');
INSERT INTO public.who_global_data_import VALUES (43806, '2020-07-26', 'KE', 'Kenya', 'AFRO', '375', '16643', '4', '278');
INSERT INTO public.who_global_data_import VALUES (43807, '2020-07-27', 'KE', 'Kenya', 'AFRO', '0', '16643', '0', '278');
INSERT INTO public.who_global_data_import VALUES (43808, '2020-07-28', 'KE', 'Kenya', 'AFRO', '1332', '17975', '7', '285');
INSERT INTO public.who_global_data_import VALUES (43809, '2020-07-29', 'KE', 'Kenya', 'AFRO', '606', '18581', '14', '299');
INSERT INTO public.who_global_data_import VALUES (43810, '2020-07-30', 'KE', 'Kenya', 'AFRO', '544', '19125', '12', '311');
INSERT INTO public.who_global_data_import VALUES (43811, '2020-07-31', 'KE', 'Kenya', 'AFRO', '788', '19913', '14', '325');
INSERT INTO public.who_global_data_import VALUES (43812, '2020-08-01', 'KE', 'Kenya', 'AFRO', '723', '20636', '16', '341');
INSERT INTO public.who_global_data_import VALUES (43813, '2020-08-02', 'KE', 'Kenya', 'AFRO', '727', '21363', '23', '364');
INSERT INTO public.who_global_data_import VALUES (43814, '2020-08-03', 'KE', 'Kenya', 'AFRO', '690', '22053', '5', '369');
INSERT INTO public.who_global_data_import VALUES (43815, '2020-08-04', 'KE', 'Kenya', 'AFRO', '544', '22597', '13', '382');
INSERT INTO public.who_global_data_import VALUES (43816, '2020-08-05', 'KE', 'Kenya', 'AFRO', '605', '23202', '6', '388');
INSERT INTO public.who_global_data_import VALUES (43817, '2020-08-06', 'KE', 'Kenya', 'AFRO', '671', '23873', '3', '391');
INSERT INTO public.who_global_data_import VALUES (43818, '2020-08-07', 'KE', 'Kenya', 'AFRO', '538', '24411', '8', '399');
INSERT INTO public.who_global_data_import VALUES (43819, '2020-08-08', 'KE', 'Kenya', 'AFRO', '727', '25138', '14', '413');
INSERT INTO public.who_global_data_import VALUES (43820, '2020-08-09', 'KE', 'Kenya', 'AFRO', '699', '25837', '5', '418');
INSERT INTO public.who_global_data_import VALUES (43821, '2020-08-10', 'KE', 'Kenya', 'AFRO', '599', '26436', '2', '420');
INSERT INTO public.who_global_data_import VALUES (43822, '2020-08-11', 'KE', 'Kenya', 'AFRO', '492', '26928', '3', '423');
INSERT INTO public.who_global_data_import VALUES (43823, '2020-08-12', 'KE', 'Kenya', 'AFRO', '497', '27425', '15', '438');
INSERT INTO public.who_global_data_import VALUES (43824, '2020-08-13', 'KE', 'Kenya', 'AFRO', '679', '28104', '18', '456');
INSERT INTO public.who_global_data_import VALUES (43825, '2020-08-14', 'KE', 'Kenya', 'AFRO', '650', '28754', '4', '460');
INSERT INTO public.who_global_data_import VALUES (43826, '2020-08-15', 'KE', 'Kenya', 'AFRO', '580', '29334', '5', '465');
INSERT INTO public.who_global_data_import VALUES (43827, '2020-08-16', 'KE', 'Kenya', 'AFRO', '515', '29849', '7', '472');
INSERT INTO public.who_global_data_import VALUES (43828, '2020-08-17', 'KE', 'Kenya', 'AFRO', '271', '30120', '2', '474');
INSERT INTO public.who_global_data_import VALUES (43829, '2020-08-18', 'KE', 'Kenya', 'AFRO', '245', '30365', '8', '482');
INSERT INTO public.who_global_data_import VALUES (43830, '2020-08-19', 'KE', 'Kenya', 'AFRO', '271', '30636', '5', '487');
INSERT INTO public.who_global_data_import VALUES (43831, '2020-08-20', 'KE', 'Kenya', 'AFRO', '379', '31015', '19', '506');
INSERT INTO public.who_global_data_import VALUES (43832, '2020-08-21', 'KE', 'Kenya', 'AFRO', '426', '31441', '10', '516');
INSERT INTO public.who_global_data_import VALUES (43833, '2020-08-22', 'KE', 'Kenya', 'AFRO', '322', '31763', '16', '532');
INSERT INTO public.who_global_data_import VALUES (43834, '2020-08-23', 'KE', 'Kenya', 'AFRO', '355', '32118', '10', '542');
INSERT INTO public.who_global_data_import VALUES (43835, '2020-08-24', 'KE', 'Kenya', 'AFRO', '246', '32364', '6', '548');
INSERT INTO public.who_global_data_import VALUES (43836, '2020-08-25', 'KE', 'Kenya', 'AFRO', '193', '32557', '6', '554');
INSERT INTO public.who_global_data_import VALUES (43837, '2020-08-26', 'KE', 'Kenya', 'AFRO', '246', '32803', '6', '560');
INSERT INTO public.who_global_data_import VALUES (43838, '2020-08-27', 'KE', 'Kenya', 'AFRO', '213', '33016', '4', '564');
INSERT INTO public.who_global_data_import VALUES (43839, '2020-08-28', 'KE', 'Kenya', 'AFRO', '373', '33389', '3', '567');
INSERT INTO public.who_global_data_import VALUES (43840, '2020-08-29', 'KE', 'Kenya', 'AFRO', '241', '33630', '0', '567');
INSERT INTO public.who_global_data_import VALUES (43841, '2020-08-30', 'KE', 'Kenya', 'AFRO', '164', '33794', '5', '572');
INSERT INTO public.who_global_data_import VALUES (43842, '2020-08-31', 'KE', 'Kenya', 'AFRO', '263', '34057', '2', '574');
INSERT INTO public.who_global_data_import VALUES (43843, '2020-09-01', 'KE', 'Kenya', 'AFRO', '144', '34201', '3', '577');
INSERT INTO public.who_global_data_import VALUES (43844, '2020-09-02', 'KE', 'Kenya', 'AFRO', '114', '34315', '0', '577');
INSERT INTO public.who_global_data_import VALUES (43845, '2020-09-03', 'KE', 'Kenya', 'AFRO', '178', '34493', '4', '581');
INSERT INTO public.who_global_data_import VALUES (43846, '2020-09-04', 'KE', 'Kenya', 'AFRO', '212', '34705', '4', '585');
INSERT INTO public.who_global_data_import VALUES (43847, '2020-09-05', 'KE', 'Kenya', 'AFRO', '179', '34884', '4', '589');
INSERT INTO public.who_global_data_import VALUES (43848, '2020-09-06', 'KE', 'Kenya', 'AFRO', '136', '35020', '5', '594');
INSERT INTO public.who_global_data_import VALUES (43849, '2020-09-07', 'KE', 'Kenya', 'AFRO', '83', '35103', '3', '597');
INSERT INTO public.who_global_data_import VALUES (43850, '2020-09-08', 'KE', 'Kenya', 'AFRO', '102', '35205', '2', '599');
INSERT INTO public.who_global_data_import VALUES (43851, '2020-09-09', 'KE', 'Kenya', 'AFRO', '151', '35356', '0', '599');
INSERT INTO public.who_global_data_import VALUES (43852, '2020-09-10', 'KE', 'Kenya', 'AFRO', '104', '35460', '8', '607');
INSERT INTO public.who_global_data_import VALUES (43853, '2020-09-11', 'KE', 'Kenya', 'AFRO', '143', '35603', '5', '612');
INSERT INTO public.who_global_data_import VALUES (43854, '2020-09-12', 'KE', 'Kenya', 'AFRO', '190', '35793', '4', '616');
INSERT INTO public.who_global_data_import VALUES (43855, '2020-09-13', 'KE', 'Kenya', 'AFRO', '170', '35963', '3', '619');
INSERT INTO public.who_global_data_import VALUES (43856, '2020-09-14', 'KE', 'Kenya', 'AFRO', '194', '36157', '3', '622');
INSERT INTO public.who_global_data_import VALUES (43857, '2020-09-15', 'KE', 'Kenya', 'AFRO', '48', '36205', '2', '624');
INSERT INTO public.who_global_data_import VALUES (43858, '2020-09-16', 'KE', 'Kenya', 'AFRO', '96', '36301', '10', '634');
INSERT INTO public.who_global_data_import VALUES (43859, '2020-09-17', 'KE', 'Kenya', 'AFRO', '0', '36301', '0', '634');
INSERT INTO public.who_global_data_import VALUES (43860, '2020-09-18', 'KE', 'Kenya', 'AFRO', '275', '36576', '8', '642');
INSERT INTO public.who_global_data_import VALUES (43861, '2020-09-19', 'KE', 'Kenya', 'AFRO', '148', '36724', '4', '646');
INSERT INTO public.who_global_data_import VALUES (43862, '2020-09-20', 'KE', 'Kenya', 'AFRO', '105', '36829', '0', '646');
INSERT INTO public.who_global_data_import VALUES (43863, '2020-09-21', 'KE', 'Kenya', 'AFRO', '152', '36981', '2', '648');
INSERT INTO public.who_global_data_import VALUES (43864, '2020-09-22', 'KE', 'Kenya', 'AFRO', '98', '37079', '2', '650');
INSERT INTO public.who_global_data_import VALUES (43865, '2020-09-23', 'KE', 'Kenya', 'AFRO', '139', '37218', '9', '659');
INSERT INTO public.who_global_data_import VALUES (43866, '2020-09-24', 'KE', 'Kenya', 'AFRO', '130', '37348', '5', '664');
INSERT INTO public.who_global_data_import VALUES (43867, '2020-09-25', 'KE', 'Kenya', 'AFRO', '141', '37489', '5', '669');
INSERT INTO public.who_global_data_import VALUES (43868, '2020-09-26', 'KE', 'Kenya', 'AFRO', '218', '37707', '13', '682');
INSERT INTO public.who_global_data_import VALUES (43869, '2020-09-27', 'KE', 'Kenya', 'AFRO', '164', '37871', '7', '689');
INSERT INTO public.who_global_data_import VALUES (43870, '2020-09-28', 'KE', 'Kenya', 'AFRO', '244', '38115', '2', '691');
INSERT INTO public.who_global_data_import VALUES (43871, '2020-09-29', 'KE', 'Kenya', 'AFRO', '53', '38168', '9', '700');
INSERT INTO public.who_global_data_import VALUES (43872, '2020-09-30', 'KE', 'Kenya', 'AFRO', '210', '38378', '7', '707');
INSERT INTO public.who_global_data_import VALUES (43873, '2020-10-01', 'KE', 'Kenya', 'AFRO', '151', '38529', '4', '711');
INSERT INTO public.who_global_data_import VALUES (43874, '2020-10-02', 'KE', 'Kenya', 'AFRO', '184', '38713', '7', '718');
INSERT INTO public.who_global_data_import VALUES (43875, '2020-10-03', 'KE', 'Kenya', 'AFRO', '210', '38923', '7', '725');
INSERT INTO public.who_global_data_import VALUES (43876, '2020-10-04', 'KE', 'Kenya', 'AFRO', '0', '38923', '0', '725');
INSERT INTO public.who_global_data_import VALUES (43877, '2020-10-05', 'KE', 'Kenya', 'AFRO', '504', '39427', '6', '731');
INSERT INTO public.who_global_data_import VALUES (43878, '2020-10-06', 'KE', 'Kenya', 'AFRO', '22', '39449', '4', '735');
INSERT INTO public.who_global_data_import VALUES (43879, '2020-10-07', 'KE', 'Kenya', 'AFRO', '137', '39586', '8', '743');
INSERT INTO public.who_global_data_import VALUES (43880, '2020-10-08', 'KE', 'Kenya', 'AFRO', '321', '39907', '5', '748');
INSERT INTO public.who_global_data_import VALUES (43881, '2020-10-09', 'KE', 'Kenya', 'AFRO', '271', '40178', '3', '751');
INSERT INTO public.who_global_data_import VALUES (43882, '2020-10-10', 'KE', 'Kenya', 'AFRO', '442', '40620', '4', '755');
INSERT INTO public.who_global_data_import VALUES (43883, '2020-10-11', 'KE', 'Kenya', 'AFRO', '538', '41158', '5', '760');
INSERT INTO public.who_global_data_import VALUES (43884, '2020-10-12', 'KE', 'Kenya', 'AFRO', '388', '41546', '6', '766');
INSERT INTO public.who_global_data_import VALUES (43885, '2020-10-13', 'KE', 'Kenya', 'AFRO', '73', '41619', '11', '777');
INSERT INTO public.who_global_data_import VALUES (43886, '2020-10-14', 'KE', 'Kenya', 'AFRO', '320', '41939', '10', '787');
INSERT INTO public.who_global_data_import VALUES (43887, '2020-10-15', 'KE', 'Kenya', 'AFRO', '602', '42541', '10', '797');
INSERT INTO public.who_global_data_import VALUES (43888, '2020-10-16', 'KE', 'Kenya', 'AFRO', '602', '43143', '8', '805');
INSERT INTO public.who_global_data_import VALUES (43889, '2020-10-17', 'KE', 'Kenya', 'AFRO', '437', '43580', '8', '813');
INSERT INTO public.who_global_data_import VALUES (43890, '2020-10-18', 'KE', 'Kenya', 'AFRO', '616', '44196', '12', '825');
INSERT INTO public.who_global_data_import VALUES (43891, '2020-10-19', 'KE', 'Kenya', 'AFRO', '685', '44881', '7', '832');
INSERT INTO public.who_global_data_import VALUES (43892, '2020-10-20', 'KE', 'Kenya', 'AFRO', '195', '45076', '7', '839');
INSERT INTO public.who_global_data_import VALUES (43893, '2020-10-21', 'KE', 'Kenya', 'AFRO', '571', '45647', '3', '842');
INSERT INTO public.who_global_data_import VALUES (43894, '2020-10-22', 'KE', 'Kenya', 'AFRO', '497', '46144', '16', '858');
INSERT INTO public.who_global_data_import VALUES (43895, '2020-10-23', 'KE', 'Kenya', 'AFRO', '1068', '47212', '12', '870');
INSERT INTO public.who_global_data_import VALUES (43896, '2020-10-24', 'KE', 'Kenya', 'AFRO', '631', '47843', '14', '884');
INSERT INTO public.who_global_data_import VALUES (43897, '2020-10-25', 'KE', 'Kenya', 'AFRO', '947', '48790', '12', '896');
INSERT INTO public.who_global_data_import VALUES (43898, '2020-10-26', 'KE', 'Kenya', 'AFRO', '931', '49721', '6', '902');
INSERT INTO public.who_global_data_import VALUES (43899, '2020-10-27', 'KE', 'Kenya', 'AFRO', '276', '49997', '18', '920');
INSERT INTO public.who_global_data_import VALUES (43900, '2020-10-28', 'KE', 'Kenya', 'AFRO', '836', '50833', '14', '934');
INSERT INTO public.who_global_data_import VALUES (43901, '2020-10-29', 'KE', 'Kenya', 'AFRO', '1018', '51851', '16', '950');
INSERT INTO public.who_global_data_import VALUES (43902, '2020-10-30', 'KE', 'Kenya', 'AFRO', '761', '52612', '14', '964');
INSERT INTO public.who_global_data_import VALUES (43903, '2020-10-31', 'KE', 'Kenya', 'AFRO', '1185', '53797', '17', '981');
INSERT INTO public.who_global_data_import VALUES (43904, '2020-11-01', 'KE', 'Kenya', 'AFRO', '1395', '55192', '15', '996');
INSERT INTO public.who_global_data_import VALUES (43905, '2020-11-02', 'KE', 'Kenya', 'AFRO', '685', '55877', '17', '1013');
INSERT INTO public.who_global_data_import VALUES (43906, '2020-11-03', 'KE', 'Kenya', 'AFRO', '724', '56601', '14', '1027');
INSERT INTO public.who_global_data_import VALUES (43907, '2020-11-04', 'KE', 'Kenya', 'AFRO', '492', '57093', '12', '1039');
INSERT INTO public.who_global_data_import VALUES (43908, '2020-11-05', 'KE', 'Kenya', 'AFRO', '1494', '58587', '12', '1051');
INSERT INTO public.who_global_data_import VALUES (43909, '2020-11-06', 'KE', 'Kenya', 'AFRO', '1008', '59595', '21', '1072');
INSERT INTO public.who_global_data_import VALUES (43910, '2020-11-07', 'KE', 'Kenya', 'AFRO', '1109', '60704', '21', '1093');
INSERT INTO public.who_global_data_import VALUES (43911, '2020-11-08', 'KE', 'Kenya', 'AFRO', '1065', '61769', '10', '1103');
INSERT INTO public.who_global_data_import VALUES (43912, '2020-11-09', 'KE', 'Kenya', 'AFRO', '719', '62488', '8', '1111');
INSERT INTO public.who_global_data_import VALUES (43913, '2020-11-10', 'KE', 'Kenya', 'AFRO', '756', '63244', '19', '1130');
INSERT INTO public.who_global_data_import VALUES (43914, '2020-11-11', 'KE', 'Kenya', 'AFRO', '1344', '64588', '24', '1154');
INSERT INTO public.who_global_data_import VALUES (43915, '2020-11-12', 'KE', 'Kenya', 'AFRO', '1216', '65804', '26', '1180');
INSERT INTO public.who_global_data_import VALUES (43916, '2020-11-13', 'KE', 'Kenya', 'AFRO', '919', '66723', '23', '1203');
INSERT INTO public.who_global_data_import VALUES (43917, '2020-11-14', 'KE', 'Kenya', 'AFRO', '1470', '68193', '25', '1228');
INSERT INTO public.who_global_data_import VALUES (43918, '2020-11-15', 'KE', 'Kenya', 'AFRO', '1080', '69273', '21', '1249');
INSERT INTO public.who_global_data_import VALUES (43919, '2020-11-16', 'KE', 'Kenya', 'AFRO', '972', '70245', '20', '1269');
INSERT INTO public.who_global_data_import VALUES (43920, '2020-11-17', 'KE', 'Kenya', 'AFRO', '559', '70804', '18', '1287');
INSERT INTO public.who_global_data_import VALUES (43921, '2020-11-18', 'KE', 'Kenya', 'AFRO', '925', '71729', '15', '1302');
INSERT INTO public.who_global_data_import VALUES (43922, '2020-11-19', 'KE', 'Kenya', 'AFRO', '957', '72686', '11', '1313');
INSERT INTO public.who_global_data_import VALUES (43923, '2020-11-20', 'KE', 'Kenya', 'AFRO', '1459', '74145', '17', '1330');
INSERT INTO public.who_global_data_import VALUES (43924, '2020-11-21', 'KE', 'Kenya', 'AFRO', '1048', '75193', '19', '1349');
INSERT INTO public.who_global_data_import VALUES (43925, '2020-11-22', 'KE', 'Kenya', 'AFRO', '1211', '76404', '17', '1366');
INSERT INTO public.who_global_data_import VALUES (43926, '2020-11-23', 'KE', 'Kenya', 'AFRO', '968', '77372', '14', '1380');
INSERT INTO public.who_global_data_import VALUES (43927, '2020-11-24', 'KE', 'Kenya', 'AFRO', '413', '77785', '12', '1392');
INSERT INTO public.who_global_data_import VALUES (43928, '2020-11-25', 'KE', 'Kenya', 'AFRO', '727', '78512', '17', '1409');
INSERT INTO public.who_global_data_import VALUES (43929, '2020-11-26', 'KE', 'Kenya', 'AFRO', '810', '79322', '8', '1417');
INSERT INTO public.who_global_data_import VALUES (43930, '2020-11-27', 'KE', 'Kenya', 'AFRO', '780', '80102', '10', '1427');
INSERT INTO public.who_global_data_import VALUES (43931, '2020-11-28', 'KE', 'Kenya', 'AFRO', '1554', '81656', '14', '1441');
INSERT INTO public.who_global_data_import VALUES (43932, '2020-11-29', 'KE', 'Kenya', 'AFRO', '949', '82605', '4', '1445');
INSERT INTO public.who_global_data_import VALUES (43933, '2020-11-30', 'KE', 'Kenya', 'AFRO', '711', '83316', '7', '1452');
INSERT INTO public.who_global_data_import VALUES (43934, '2020-12-01', 'KE', 'Kenya', 'AFRO', '302', '83618', '17', '1469');
INSERT INTO public.who_global_data_import VALUES (43935, '2020-12-02', 'KE', 'Kenya', 'AFRO', '551', '84169', '5', '1474');
INSERT INTO public.who_global_data_import VALUES (43936, '2020-12-03', 'KE', 'Kenya', 'AFRO', '961', '85130', '10', '1484');
INSERT INTO public.who_global_data_import VALUES (43937, '2020-12-04', 'KE', 'Kenya', 'AFRO', '1253', '86383', '16', '1500');
INSERT INTO public.who_global_data_import VALUES (43938, '2020-12-05', 'KE', 'Kenya', 'AFRO', '866', '87249', '6', '1506');
INSERT INTO public.who_global_data_import VALUES (43939, '2020-12-06', 'KE', 'Kenya', 'AFRO', '735', '87984', '12', '1518');
INSERT INTO public.who_global_data_import VALUES (43940, '2020-12-07', 'KE', 'Kenya', 'AFRO', '396', '88380', '8', '1526');
INSERT INTO public.who_global_data_import VALUES (43941, '2020-12-08', 'KE', 'Kenya', 'AFRO', '199', '88579', '5', '1531');
INSERT INTO public.who_global_data_import VALUES (43942, '2020-12-09', 'KE', 'Kenya', 'AFRO', '0', '88579', '0', '1531');
INSERT INTO public.who_global_data_import VALUES (43943, '2020-12-10', 'KE', 'Kenya', 'AFRO', '1082', '89661', '21', '1552');
INSERT INTO public.who_global_data_import VALUES (43944, '2020-12-11', 'KE', 'Kenya', 'AFRO', '644', '90305', '16', '1568');
INSERT INTO public.who_global_data_import VALUES (43945, '2020-12-12', 'KE', 'Kenya', 'AFRO', '0', '90305', '0', '1568');
INSERT INTO public.who_global_data_import VALUES (43946, '2020-12-13', 'KE', 'Kenya', 'AFRO', '0', '90305', '0', '1568');
INSERT INTO public.who_global_data_import VALUES (43947, '2020-12-14', 'KE', 'Kenya', 'AFRO', '1587', '91892', '19', '1587');
INSERT INTO public.who_global_data_import VALUES (43948, '2020-12-15', 'KE', 'Kenya', 'AFRO', '163', '92055', '6', '1593');
INSERT INTO public.who_global_data_import VALUES (43949, '2020-12-16', 'KE', 'Kenya', 'AFRO', '404', '92459', '11', '1604');
INSERT INTO public.who_global_data_import VALUES (43950, '2020-12-17', 'KE', 'Kenya', 'AFRO', '0', '92459', '0', '1604');
INSERT INTO public.who_global_data_import VALUES (43951, '2020-12-18', 'KE', 'Kenya', 'AFRO', '946', '93405', '14', '1618');
INSERT INTO public.who_global_data_import VALUES (43952, '2020-12-19', 'KE', 'Kenya', 'AFRO', '356', '93761', '11', '1629');
INSERT INTO public.who_global_data_import VALUES (43953, '2020-12-20', 'KE', 'Kenya', 'AFRO', '390', '94151', '4', '1633');
INSERT INTO public.who_global_data_import VALUES (43954, '2020-12-21', 'KE', 'Kenya', 'AFRO', '349', '94500', '6', '1639');
INSERT INTO public.who_global_data_import VALUES (43955, '2020-12-22', 'KE', 'Kenya', 'AFRO', '114', '94614', '5', '1644');
INSERT INTO public.who_global_data_import VALUES (43956, '2020-12-23', 'KE', 'Kenya', 'AFRO', '154', '94768', '3', '1647');
INSERT INTO public.who_global_data_import VALUES (43957, '2020-12-24', 'KE', 'Kenya', 'AFRO', '0', '94768', '0', '1647');
INSERT INTO public.who_global_data_import VALUES (43958, '2020-12-25', 'KE', 'Kenya', 'AFRO', '663', '95431', '5', '1652');
INSERT INTO public.who_global_data_import VALUES (43959, '2020-12-26', 'KE', 'Kenya', 'AFRO', '282', '95713', '1', '1653');
INSERT INTO public.who_global_data_import VALUES (43960, '2020-12-27', 'KE', 'Kenya', 'AFRO', '130', '95843', '2', '1655');
INSERT INTO public.who_global_data_import VALUES (43961, '2020-12-28', 'KE', 'Kenya', 'AFRO', '0', '95843', '0', '1655');
INSERT INTO public.who_global_data_import VALUES (43962, '2020-12-29', 'KE', 'Kenya', 'AFRO', '149', '95992', '9', '1664');
INSERT INTO public.who_global_data_import VALUES (43963, '2020-12-30', 'KE', 'Kenya', 'AFRO', '0', '95992', '0', '1664');
INSERT INTO public.who_global_data_import VALUES (43964, '2020-12-31', 'KE', 'Kenya', 'AFRO', '259', '96251', '3', '1667');
INSERT INTO public.who_global_data_import VALUES (43965, '2021-01-01', 'KE', 'Kenya', 'AFRO', '207', '96458', '3', '1670');
INSERT INTO public.who_global_data_import VALUES (43966, '2021-01-02', 'KE', 'Kenya', 'AFRO', '0', '96458', '0', '1670');
INSERT INTO public.who_global_data_import VALUES (43967, '2021-01-03', 'KE', 'Kenya', 'AFRO', '220', '96678', '15', '1685');
INSERT INTO public.who_global_data_import VALUES (43968, '2021-01-04', 'KE', 'Kenya', 'AFRO', '124', '96802', '0', '1685');
INSERT INTO public.who_global_data_import VALUES (43969, '2021-01-05', 'KE', 'Kenya', 'AFRO', '106', '96908', '1', '1686');
INSERT INTO public.who_global_data_import VALUES (43970, '2021-01-06', 'KE', 'Kenya', 'AFRO', '219', '97127', '4', '1690');
INSERT INTO public.who_global_data_import VALUES (43971, '2021-01-07', 'KE', 'Kenya', 'AFRO', '271', '97398', '4', '1694');
INSERT INTO public.who_global_data_import VALUES (43972, '2021-01-08', 'KE', 'Kenya', 'AFRO', '335', '97733', '8', '1702');
INSERT INTO public.who_global_data_import VALUES (43973, '2021-01-09', 'KE', 'Kenya', 'AFRO', '221', '97954', '1', '1703');
INSERT INTO public.who_global_data_import VALUES (43974, '2021-01-10', 'KE', 'Kenya', 'AFRO', '230', '98184', '1', '1704');
INSERT INTO public.who_global_data_import VALUES (43975, '2021-01-11', 'KE', 'Kenya', 'AFRO', '87', '98271', '6', '1710');
INSERT INTO public.who_global_data_import VALUES (43976, '2021-01-12', 'KE', 'Kenya', 'AFRO', '63', '98334', '3', '1713');
INSERT INTO public.who_global_data_import VALUES (43977, '2021-01-13', 'KE', 'Kenya', 'AFRO', '98', '98432', '3', '1716');
INSERT INTO public.who_global_data_import VALUES (43978, '2021-01-14', 'KE', 'Kenya', 'AFRO', '123', '98555', '4', '1720');
INSERT INTO public.who_global_data_import VALUES (43979, '2021-01-15', 'KE', 'Kenya', 'AFRO', '138', '98693', '3', '1723');
INSERT INTO public.who_global_data_import VALUES (43980, '2021-01-16', 'KE', 'Kenya', 'AFRO', '166', '98859', '3', '1726');
INSERT INTO public.who_global_data_import VALUES (43981, '2021-01-17', 'KE', 'Kenya', 'AFRO', '223', '99082', '2', '1728');
INSERT INTO public.who_global_data_import VALUES (43982, '2021-01-18', 'KE', 'Kenya', 'AFRO', '80', '99162', '3', '1731');
INSERT INTO public.who_global_data_import VALUES (43983, '2021-01-19', 'KE', 'Kenya', 'AFRO', '65', '99227', '3', '1734');
INSERT INTO public.who_global_data_import VALUES (43984, '2021-01-20', 'KE', 'Kenya', 'AFRO', '81', '99308', '0', '1734');
INSERT INTO public.who_global_data_import VALUES (43985, '2021-01-21', 'KE', 'Kenya', 'AFRO', '136', '99444', '2', '1736');
INSERT INTO public.who_global_data_import VALUES (43986, '2021-01-22', 'KE', 'Kenya', 'AFRO', '186', '99630', '3', '1739');
INSERT INTO public.who_global_data_import VALUES (43987, '2021-01-23', 'KE', 'Kenya', 'AFRO', '139', '99769', '1', '1740');
INSERT INTO public.who_global_data_import VALUES (43988, '2021-01-24', 'KE', 'Kenya', 'AFRO', '129', '99898', '0', '1740');
INSERT INTO public.who_global_data_import VALUES (43989, '2021-01-25', 'KE', 'Kenya', 'AFRO', '85', '99983', '4', '1744');
INSERT INTO public.who_global_data_import VALUES (43990, '2021-01-26', 'KE', 'Kenya', 'AFRO', '69', '100052', '0', '1744');
INSERT INTO public.who_global_data_import VALUES (43991, '2021-01-27', 'KE', 'Kenya', 'AFRO', '141', '100193', '6', '1750');
INSERT INTO public.who_global_data_import VALUES (43992, '2021-01-28', 'KE', 'Kenya', 'AFRO', '130', '100323', '1', '1751');
INSERT INTO public.who_global_data_import VALUES (43993, '2021-01-29', 'KE', 'Kenya', 'AFRO', '99', '100422', '2', '1753');
INSERT INTO public.who_global_data_import VALUES (43994, '2021-01-30', 'KE', 'Kenya', 'AFRO', '141', '100563', '0', '1753');
INSERT INTO public.who_global_data_import VALUES (43995, '2021-01-31', 'KE', 'Kenya', 'AFRO', '112', '100675', '2', '1755');
INSERT INTO public.who_global_data_import VALUES (43996, '2021-02-01', 'KE', 'Kenya', 'AFRO', '98', '100773', '8', '1763');
INSERT INTO public.who_global_data_import VALUES (43997, '2021-02-02', 'KE', 'Kenya', 'AFRO', '83', '100856', '3', '1766');
INSERT INTO public.who_global_data_import VALUES (43998, '2021-02-03', 'KE', 'Kenya', 'AFRO', '153', '101009', '0', '1766');
INSERT INTO public.who_global_data_import VALUES (43999, '2021-02-04', 'KE', 'Kenya', 'AFRO', '150', '101159', '3', '1769');
INSERT INTO public.who_global_data_import VALUES (44000, '2021-02-05', 'KE', 'Kenya', 'AFRO', '180', '101339', '4', '1773');
INSERT INTO public.who_global_data_import VALUES (44001, '2020-01-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44002, '2020-01-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44003, '2020-01-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44004, '2020-01-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44005, '2020-01-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44006, '2020-01-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44007, '2020-01-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44008, '2020-01-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44009, '2020-01-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44010, '2020-01-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44011, '2020-01-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44012, '2020-01-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44013, '2020-01-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44014, '2020-01-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44015, '2020-01-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44016, '2020-01-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44017, '2020-01-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44018, '2020-01-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44019, '2020-01-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44020, '2020-01-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44021, '2020-01-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44022, '2020-01-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44023, '2020-01-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44024, '2020-01-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44025, '2020-01-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44026, '2020-01-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44027, '2020-01-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44028, '2020-01-30', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44029, '2020-01-31', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44030, '2020-02-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44031, '2020-02-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44032, '2020-02-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44033, '2020-02-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44034, '2020-02-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44035, '2020-02-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44036, '2020-02-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44037, '2020-02-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44038, '2020-02-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44039, '2020-02-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44040, '2020-02-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44041, '2020-02-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44042, '2020-02-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44043, '2020-02-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44044, '2020-02-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44045, '2020-02-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44046, '2020-02-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44047, '2020-02-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44048, '2020-02-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44049, '2020-02-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44050, '2020-02-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44051, '2020-02-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44052, '2020-02-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44053, '2020-02-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44054, '2020-02-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44055, '2020-02-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44056, '2020-02-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44057, '2020-02-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44058, '2020-02-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44059, '2020-03-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44060, '2020-03-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44061, '2020-03-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44062, '2020-03-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44063, '2020-03-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44064, '2020-03-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44065, '2020-03-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44066, '2020-03-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44067, '2020-03-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44068, '2020-03-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44069, '2020-03-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44070, '2020-03-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44071, '2020-03-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44072, '2020-03-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44073, '2020-03-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44074, '2020-03-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44075, '2020-03-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44076, '2020-03-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44077, '2020-03-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44078, '2020-03-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44079, '2020-03-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44080, '2020-03-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44081, '2020-03-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44082, '2020-03-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44083, '2020-03-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44084, '2020-03-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44085, '2020-03-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44086, '2020-03-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44087, '2020-03-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44088, '2020-03-30', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44089, '2020-03-31', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44090, '2020-04-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44091, '2020-04-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44092, '2020-04-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44093, '2020-04-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44094, '2020-04-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44095, '2020-04-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44096, '2020-04-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44097, '2020-04-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44098, '2020-04-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44099, '2020-04-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44100, '2020-04-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44101, '2020-04-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44102, '2020-04-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44103, '2020-04-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44104, '2020-04-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44105, '2020-04-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44106, '2020-04-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44107, '2020-04-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44108, '2020-04-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44109, '2020-04-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44110, '2020-04-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44111, '2020-04-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44112, '2020-04-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44113, '2020-04-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44114, '2020-04-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44115, '2020-04-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44116, '2020-04-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44117, '2020-04-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44118, '2020-04-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44119, '2020-04-30', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44120, '2020-05-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44121, '2020-05-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44122, '2020-05-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44123, '2020-05-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44124, '2020-05-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44125, '2020-05-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44126, '2020-05-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44127, '2020-05-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44128, '2020-05-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44129, '2020-05-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44130, '2020-05-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44131, '2020-05-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44132, '2020-05-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44133, '2020-05-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44134, '2020-05-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44135, '2020-05-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44136, '2020-05-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44137, '2020-05-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44138, '2020-05-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44139, '2020-05-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44140, '2020-05-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44141, '2020-05-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44142, '2020-05-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44143, '2020-05-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44144, '2020-05-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44145, '2020-05-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44146, '2020-05-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44147, '2020-05-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44148, '2020-05-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44149, '2020-05-30', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44150, '2020-05-31', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44151, '2020-06-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44152, '2020-06-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44153, '2020-06-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44154, '2020-06-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44155, '2020-06-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44156, '2020-06-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44157, '2020-06-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44158, '2020-06-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44159, '2020-06-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44160, '2020-06-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44161, '2020-06-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44162, '2020-06-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44163, '2020-06-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44164, '2020-06-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44165, '2020-06-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44166, '2020-06-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44167, '2020-06-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44168, '2020-06-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44169, '2020-06-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44170, '2020-06-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44171, '2020-06-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44172, '2020-06-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44173, '2020-06-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44174, '2020-06-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44175, '2020-06-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44176, '2020-06-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44177, '2020-06-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44178, '2020-06-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44179, '2020-06-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44180, '2020-06-30', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44181, '2020-07-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44182, '2020-07-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44183, '2020-07-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44184, '2020-07-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44185, '2020-07-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44186, '2020-07-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44187, '2020-07-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44188, '2020-07-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44189, '2020-07-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44190, '2020-07-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44191, '2020-07-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44192, '2020-07-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44193, '2020-07-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44194, '2020-07-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44195, '2020-07-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44196, '2020-07-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44197, '2020-07-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44198, '2020-07-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44199, '2020-07-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44200, '2020-07-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44201, '2020-07-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44202, '2020-07-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44203, '2020-07-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44204, '2020-07-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44205, '2020-07-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44206, '2020-07-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44207, '2020-07-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44208, '2020-07-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44209, '2020-07-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44210, '2020-07-30', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44211, '2020-07-31', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44212, '2020-08-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44213, '2020-08-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44214, '2020-08-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44215, '2020-08-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44216, '2020-08-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44217, '2020-08-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44218, '2020-08-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44219, '2020-08-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44220, '2020-08-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44221, '2020-08-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44222, '2020-08-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44223, '2020-08-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44224, '2020-08-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44225, '2020-08-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44226, '2020-08-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44227, '2020-08-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44228, '2020-08-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44229, '2020-08-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44230, '2020-08-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44231, '2020-08-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44232, '2020-08-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44233, '2020-08-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44234, '2020-08-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44235, '2020-08-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44236, '2020-08-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44237, '2020-08-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44238, '2020-08-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44239, '2020-08-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44240, '2020-08-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44241, '2020-08-30', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44242, '2020-08-31', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44243, '2020-09-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44244, '2020-09-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44245, '2020-09-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44246, '2020-09-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44247, '2020-09-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44248, '2020-09-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44249, '2020-09-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44250, '2020-09-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44251, '2020-09-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44252, '2020-09-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44253, '2020-09-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44254, '2020-09-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44255, '2020-09-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44256, '2020-09-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44257, '2020-09-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44258, '2020-09-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44259, '2020-09-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44260, '2020-09-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44261, '2020-09-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44262, '2020-09-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44263, '2020-09-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44264, '2020-09-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44265, '2020-09-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44266, '2020-09-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44267, '2020-09-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44268, '2020-09-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44269, '2020-09-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44270, '2020-09-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44271, '2020-09-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44272, '2020-09-30', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44273, '2020-10-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44274, '2020-10-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44275, '2020-10-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44276, '2020-10-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44277, '2020-10-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44278, '2020-10-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44279, '2020-10-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44280, '2020-10-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44281, '2020-10-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44282, '2020-10-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44283, '2020-10-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44284, '2020-10-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44285, '2020-10-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44286, '2020-10-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44287, '2020-10-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44288, '2020-10-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44289, '2020-10-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44290, '2020-10-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44291, '2020-10-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44292, '2020-10-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44293, '2020-10-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44294, '2020-10-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44295, '2020-10-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44296, '2020-10-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44297, '2020-10-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44298, '2020-10-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44299, '2020-10-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44300, '2020-10-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44301, '2020-10-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44302, '2020-10-30', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44303, '2020-10-31', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44304, '2020-11-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44305, '2020-11-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44306, '2020-11-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44307, '2020-11-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44308, '2020-11-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44309, '2020-11-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44310, '2020-11-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44311, '2020-11-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44312, '2020-11-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44313, '2020-11-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44314, '2020-11-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44315, '2020-11-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44316, '2020-11-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44317, '2020-11-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44318, '2020-11-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44319, '2020-11-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44320, '2020-11-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44321, '2020-11-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44322, '2020-11-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44323, '2020-11-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44324, '2020-11-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44325, '2020-11-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44326, '2020-11-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44327, '2020-11-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44328, '2020-11-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44329, '2020-11-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44330, '2020-11-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44331, '2020-11-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44332, '2020-11-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44333, '2020-11-30', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44334, '2020-12-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44335, '2020-12-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44336, '2020-12-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44337, '2020-12-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44338, '2020-12-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44339, '2020-12-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44340, '2020-12-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44341, '2020-12-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44342, '2020-12-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44343, '2020-12-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44344, '2020-12-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44345, '2020-12-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44346, '2020-12-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44347, '2020-12-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44348, '2020-12-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44349, '2020-12-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44350, '2020-12-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44351, '2020-12-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44352, '2020-12-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44353, '2020-12-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44354, '2020-12-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44355, '2020-12-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44356, '2020-12-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44357, '2020-12-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44358, '2020-12-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44359, '2020-12-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44360, '2020-12-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44361, '2020-12-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44362, '2020-12-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44363, '2020-12-30', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44364, '2020-12-31', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44365, '2021-01-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44366, '2021-01-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44367, '2021-01-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44368, '2021-01-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44369, '2021-01-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44370, '2021-01-06', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44371, '2021-01-07', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44372, '2021-01-08', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44373, '2021-01-09', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44374, '2021-01-10', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44375, '2021-01-11', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44376, '2021-01-12', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44377, '2021-01-13', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44378, '2021-01-14', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44379, '2021-01-15', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44380, '2021-01-16', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44381, '2021-01-17', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44382, '2021-01-18', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44383, '2021-01-19', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44384, '2021-01-20', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44385, '2021-01-21', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44386, '2021-01-22', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44387, '2021-01-23', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44388, '2021-01-24', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44389, '2021-01-25', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44390, '2021-01-26', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44391, '2021-01-27', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44392, '2021-01-28', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44393, '2021-01-29', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44394, '2021-01-30', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44395, '2021-01-31', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44396, '2021-02-01', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44397, '2021-02-02', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44398, '2021-02-03', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44399, '2021-02-04', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44400, '2021-02-05', 'KI', 'Kiribati', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44401, '2020-01-03', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44402, '2020-01-04', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44403, '2020-01-05', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44404, '2020-01-06', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44405, '2020-01-07', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44406, '2020-01-08', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44407, '2020-01-09', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44408, '2020-01-10', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44409, '2020-01-11', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44410, '2020-01-12', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44411, '2020-01-13', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44412, '2020-01-14', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44413, '2020-01-15', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44414, '2020-01-16', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44415, '2020-01-17', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44416, '2020-01-18', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44417, '2020-01-19', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44418, '2020-01-20', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44419, '2020-01-21', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44420, '2020-01-22', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44421, '2020-01-23', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44422, '2020-01-24', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44423, '2020-01-25', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44424, '2020-01-26', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44425, '2020-01-27', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44426, '2020-01-28', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44427, '2020-01-29', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44428, '2020-01-30', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44429, '2020-01-31', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44430, '2020-02-01', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44431, '2020-02-02', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44432, '2020-02-03', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44433, '2020-02-04', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44434, '2020-02-05', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44435, '2020-02-06', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44436, '2020-02-07', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44437, '2020-02-08', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44438, '2020-02-09', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44439, '2020-02-10', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44440, '2020-02-11', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44441, '2020-02-12', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44442, '2020-02-13', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44443, '2020-02-14', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44444, '2020-02-15', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44445, '2020-02-16', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44446, '2020-02-17', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44447, '2020-02-18', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44448, '2020-02-19', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44449, '2020-02-20', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44450, '2020-02-21', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44451, '2020-02-22', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44452, '2020-02-23', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44453, '2020-02-24', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44454, '2020-02-25', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44455, '2020-02-26', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44456, '2020-02-27', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44457, '2020-02-28', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44458, '2020-02-29', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44459, '2020-03-01', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44460, '2020-03-02', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44461, '2020-03-03', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44462, '2020-03-04', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44463, '2020-03-05', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44464, '2020-03-06', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44465, '2020-03-07', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44466, '2020-03-08', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44467, '2020-03-09', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44468, '2020-03-10', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44469, '2020-03-11', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44470, '2020-03-12', 'XK', 'Kosovo[1]', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44471, '2020-03-13', 'XK', 'Kosovo[1]', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44472, '2020-03-14', 'XK', 'Kosovo[1]', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44473, '2020-03-15', 'XK', 'Kosovo[1]', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44474, '2020-03-16', 'XK', 'Kosovo[1]', 'EURO', '3', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44475, '2020-03-17', 'XK', 'Kosovo[1]', 'EURO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44476, '2020-03-18', 'XK', 'Kosovo[1]', 'EURO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44477, '2020-03-19', 'XK', 'Kosovo[1]', 'EURO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44478, '2020-03-20', 'XK', 'Kosovo[1]', 'EURO', '15', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44479, '2020-03-21', 'XK', 'Kosovo[1]', 'EURO', '4', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44480, '2020-03-22', 'XK', 'Kosovo[1]', 'EURO', '7', '31', '1', '1');
INSERT INTO public.who_global_data_import VALUES (44481, '2020-03-23', 'XK', 'Kosovo[1]', 'EURO', '4', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44482, '2020-03-24', 'XK', 'Kosovo[1]', 'EURO', '28', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44483, '2020-03-25', 'XK', 'Kosovo[1]', 'EURO', '8', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44484, '2020-03-26', 'XK', 'Kosovo[1]', 'EURO', '8', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44485, '2020-03-27', 'XK', 'Kosovo[1]', 'EURO', '9', '88', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44486, '2020-03-28', 'XK', 'Kosovo[1]', 'EURO', '3', '91', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44487, '2020-03-29', 'XK', 'Kosovo[1]', 'EURO', '0', '91', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44488, '2020-03-30', 'XK', 'Kosovo[1]', 'EURO', '15', '106', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44489, '2020-03-31', 'XK', 'Kosovo[1]', 'EURO', '6', '112', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44490, '2020-04-01', 'XK', 'Kosovo[1]', 'EURO', '13', '125', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44491, '2020-04-02', 'XK', 'Kosovo[1]', 'EURO', '0', '125', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44492, '2020-04-03', 'XK', 'Kosovo[1]', 'EURO', '1', '126', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44493, '2020-04-04', 'XK', 'Kosovo[1]', 'EURO', '6', '132', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44494, '2020-04-05', 'XK', 'Kosovo[1]', 'EURO', '8', '140', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44495, '2020-04-06', 'XK', 'Kosovo[1]', 'EURO', '5', '145', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44496, '2020-04-07', 'XK', 'Kosovo[1]', 'EURO', '20', '165', '2', '3');
INSERT INTO public.who_global_data_import VALUES (44497, '2020-04-08', 'XK', 'Kosovo[1]', 'EURO', '19', '184', '3', '6');
INSERT INTO public.who_global_data_import VALUES (44498, '2020-04-09', 'XK', 'Kosovo[1]', 'EURO', '40', '224', '1', '7');
INSERT INTO public.who_global_data_import VALUES (44499, '2020-04-10', 'XK', 'Kosovo[1]', 'EURO', '3', '227', '0', '7');
INSERT INTO public.who_global_data_import VALUES (44500, '2020-04-11', 'XK', 'Kosovo[1]', 'EURO', '23', '250', '0', '7');
INSERT INTO public.who_global_data_import VALUES (44501, '2020-04-12', 'XK', 'Kosovo[1]', 'EURO', '33', '283', '0', '7');
INSERT INTO public.who_global_data_import VALUES (44502, '2020-04-13', 'XK', 'Kosovo[1]', 'EURO', '79', '362', '1', '8');
INSERT INTO public.who_global_data_import VALUES (44503, '2020-04-14', 'XK', 'Kosovo[1]', 'EURO', '15', '377', '1', '9');
INSERT INTO public.who_global_data_import VALUES (44504, '2020-04-15', 'XK', 'Kosovo[1]', 'EURO', '10', '387', '1', '10');
INSERT INTO public.who_global_data_import VALUES (44505, '2020-04-16', 'XK', 'Kosovo[1]', 'EURO', '10', '397', '2', '12');
INSERT INTO public.who_global_data_import VALUES (44506, '2020-04-17', 'XK', 'Kosovo[1]', 'EURO', '52', '449', '1', '13');
INSERT INTO public.who_global_data_import VALUES (44507, '2020-04-18', 'XK', 'Kosovo[1]', 'EURO', '31', '480', '0', '13');
INSERT INTO public.who_global_data_import VALUES (44508, '2020-04-19', 'XK', 'Kosovo[1]', 'EURO', '30', '510', '0', '13');
INSERT INTO public.who_global_data_import VALUES (44509, '2020-04-20', 'XK', 'Kosovo[1]', 'EURO', '25', '535', '0', '13');
INSERT INTO public.who_global_data_import VALUES (44510, '2020-04-21', 'XK', 'Kosovo[1]', 'EURO', '37', '572', '1', '14');
INSERT INTO public.who_global_data_import VALUES (44511, '2020-04-22', 'XK', 'Kosovo[1]', 'EURO', '32', '604', '0', '14');
INSERT INTO public.who_global_data_import VALUES (44512, '2020-04-23', 'XK', 'Kosovo[1]', 'EURO', '26', '630', '1', '15');
INSERT INTO public.who_global_data_import VALUES (44513, '2020-04-24', 'XK', 'Kosovo[1]', 'EURO', '39', '669', '0', '15');
INSERT INTO public.who_global_data_import VALUES (44514, '2020-04-25', 'XK', 'Kosovo[1]', 'EURO', '34', '703', '1', '16');
INSERT INTO public.who_global_data_import VALUES (44515, '2020-04-26', 'XK', 'Kosovo[1]', 'EURO', '28', '731', '0', '16');
INSERT INTO public.who_global_data_import VALUES (44516, '2020-04-27', 'XK', 'Kosovo[1]', 'EURO', '32', '763', '1', '17');
INSERT INTO public.who_global_data_import VALUES (44517, '2020-04-28', 'XK', 'Kosovo[1]', 'EURO', '17', '780', '0', '17');
INSERT INTO public.who_global_data_import VALUES (44518, '2020-04-29', 'XK', 'Kosovo[1]', 'EURO', '10', '790', '0', '17');
INSERT INTO public.who_global_data_import VALUES (44519, '2020-04-30', 'XK', 'Kosovo[1]', 'EURO', '9', '799', '0', '17');
INSERT INTO public.who_global_data_import VALUES (44520, '2020-05-01', 'XK', 'Kosovo[1]', 'EURO', '0', '799', '0', '17');
INSERT INTO public.who_global_data_import VALUES (44521, '2020-05-02', 'XK', 'Kosovo[1]', 'EURO', '14', '813', '0', '17');
INSERT INTO public.who_global_data_import VALUES (44522, '2020-05-03', 'XK', 'Kosovo[1]', 'EURO', '10', '823', '0', '17');
INSERT INTO public.who_global_data_import VALUES (44523, '2020-05-04', 'XK', 'Kosovo[1]', 'EURO', '28', '851', '0', '17');
INSERT INTO public.who_global_data_import VALUES (44524, '2020-05-05', 'XK', 'Kosovo[1]', 'EURO', '4', '855', '0', '17');
INSERT INTO public.who_global_data_import VALUES (44525, '2020-05-06', 'XK', 'Kosovo[1]', 'EURO', '1', '856', '0', '17');
INSERT INTO public.who_global_data_import VALUES (44526, '2020-05-07', 'XK', 'Kosovo[1]', 'EURO', '4', '860', '1', '18');
INSERT INTO public.who_global_data_import VALUES (44527, '2020-05-08', 'XK', 'Kosovo[1]', 'EURO', '1', '861', '1', '19');
INSERT INTO public.who_global_data_import VALUES (44528, '2020-05-09', 'XK', 'Kosovo[1]', 'EURO', '1', '862', '0', '19');
INSERT INTO public.who_global_data_import VALUES (44529, '2020-05-10', 'XK', 'Kosovo[1]', 'EURO', '8', '870', '0', '19');
INSERT INTO public.who_global_data_import VALUES (44530, '2020-05-11', 'XK', 'Kosovo[1]', 'EURO', '0', '870', '0', '19');
INSERT INTO public.who_global_data_import VALUES (44531, '2020-05-12', 'XK', 'Kosovo[1]', 'EURO', '14', '884', '1', '20');
INSERT INTO public.who_global_data_import VALUES (44532, '2020-05-13', 'XK', 'Kosovo[1]', 'EURO', '35', '919', '0', '20');
INSERT INTO public.who_global_data_import VALUES (44533, '2020-05-14', 'XK', 'Kosovo[1]', 'EURO', '0', '919', '0', '20');
INSERT INTO public.who_global_data_import VALUES (44534, '2020-05-15', 'XK', 'Kosovo[1]', 'EURO', '25', '944', '0', '20');
INSERT INTO public.who_global_data_import VALUES (44535, '2020-05-16', 'XK', 'Kosovo[1]', 'EURO', '0', '944', '0', '20');
INSERT INTO public.who_global_data_import VALUES (44536, '2020-05-17', 'XK', 'Kosovo[1]', 'EURO', '0', '944', '0', '20');
INSERT INTO public.who_global_data_import VALUES (44537, '2020-05-18', 'XK', 'Kosovo[1]', 'EURO', '11', '955', '0', '20');
INSERT INTO public.who_global_data_import VALUES (44538, '2020-05-19', 'XK', 'Kosovo[1]', 'EURO', '0', '955', '0', '20');
INSERT INTO public.who_global_data_import VALUES (44539, '2020-05-20', 'XK', 'Kosovo[1]', 'EURO', '34', '989', '0', '20');
INSERT INTO public.who_global_data_import VALUES (44540, '2020-05-21', 'XK', 'Kosovo[1]', 'EURO', '0', '989', '0', '20');
INSERT INTO public.who_global_data_import VALUES (44541, '2020-05-22', 'XK', 'Kosovo[1]', 'EURO', '14', '1003', '0', '20');
INSERT INTO public.who_global_data_import VALUES (44542, '2020-05-23', 'XK', 'Kosovo[1]', 'EURO', '1', '1004', '0', '20');
INSERT INTO public.who_global_data_import VALUES (44543, '2020-05-24', 'XK', 'Kosovo[1]', 'EURO', '21', '1025', '0', '20');
INSERT INTO public.who_global_data_import VALUES (44544, '2020-05-25', 'XK', 'Kosovo[1]', 'EURO', '7', '1032', '1', '21');
INSERT INTO public.who_global_data_import VALUES (44545, '2020-05-26', 'XK', 'Kosovo[1]', 'EURO', '6', '1038', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44546, '2020-05-27', 'XK', 'Kosovo[1]', 'EURO', '0', '1038', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44547, '2020-05-28', 'XK', 'Kosovo[1]', 'EURO', '9', '1047', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44548, '2020-05-29', 'XK', 'Kosovo[1]', 'EURO', '1', '1048', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44549, '2020-05-30', 'XK', 'Kosovo[1]', 'EURO', '0', '1048', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44550, '2020-05-31', 'XK', 'Kosovo[1]', 'EURO', '16', '1064', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44551, '2020-06-01', 'XK', 'Kosovo[1]', 'EURO', '0', '1064', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44552, '2020-06-02', 'XK', 'Kosovo[1]', 'EURO', '3', '1067', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44553, '2020-06-03', 'XK', 'Kosovo[1]', 'EURO', '13', '1080', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44554, '2020-06-04', 'XK', 'Kosovo[1]', 'EURO', '62', '1142', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44555, '2020-06-05', 'XK', 'Kosovo[1]', 'EURO', '0', '1142', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44556, '2020-06-06', 'XK', 'Kosovo[1]', 'EURO', '0', '1142', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44557, '2020-06-07', 'XK', 'Kosovo[1]', 'EURO', '9', '1151', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44558, '2020-06-08', 'XK', 'Kosovo[1]', 'EURO', '40', '1191', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44559, '2020-06-09', 'XK', 'Kosovo[1]', 'EURO', '72', '1263', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44560, '2020-06-10', 'XK', 'Kosovo[1]', 'EURO', '0', '1263', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44561, '2020-06-11', 'XK', 'Kosovo[1]', 'EURO', '35', '1298', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44562, '2020-06-12', 'XK', 'Kosovo[1]', 'EURO', '28', '1326', '0', '21');
INSERT INTO public.who_global_data_import VALUES (44563, '2020-06-13', 'XK', 'Kosovo[1]', 'EURO', '0', '1326', '1', '22');
INSERT INTO public.who_global_data_import VALUES (44564, '2020-06-14', 'XK', 'Kosovo[1]', 'EURO', '111', '1437', '1', '23');
INSERT INTO public.who_global_data_import VALUES (44565, '2020-06-15', 'XK', 'Kosovo[1]', 'EURO', '6', '1443', '0', '23');
INSERT INTO public.who_global_data_import VALUES (44566, '2020-06-16', 'XK', 'Kosovo[1]', 'EURO', '129', '1572', '0', '23');
INSERT INTO public.who_global_data_import VALUES (44567, '2020-06-17', 'XK', 'Kosovo[1]', 'EURO', '141', '1713', '1', '24');
INSERT INTO public.who_global_data_import VALUES (44568, '2020-06-18', 'XK', 'Kosovo[1]', 'EURO', '77', '1790', '0', '24');
INSERT INTO public.who_global_data_import VALUES (44569, '2020-06-19', 'XK', 'Kosovo[1]', 'EURO', '83', '1873', '0', '24');
INSERT INTO public.who_global_data_import VALUES (44570, '2020-06-20', 'XK', 'Kosovo[1]', 'EURO', '82', '1955', '0', '24');
INSERT INTO public.who_global_data_import VALUES (44571, '2020-06-21', 'XK', 'Kosovo[1]', 'EURO', '75', '2030', '1', '25');
INSERT INTO public.who_global_data_import VALUES (44572, '2020-06-22', 'XK', 'Kosovo[1]', 'EURO', '96', '2126', '1', '26');
INSERT INTO public.who_global_data_import VALUES (44573, '2020-06-23', 'XK', 'Kosovo[1]', 'EURO', '47', '2173', '1', '27');
INSERT INTO public.who_global_data_import VALUES (44574, '2020-06-24', 'XK', 'Kosovo[1]', 'EURO', '52', '2225', '1', '28');
INSERT INTO public.who_global_data_import VALUES (44575, '2020-06-25', 'XK', 'Kosovo[1]', 'EURO', '95', '2320', '1', '29');
INSERT INTO public.who_global_data_import VALUES (44576, '2020-06-26', 'XK', 'Kosovo[1]', 'EURO', '69', '2389', '2', '31');
INSERT INTO public.who_global_data_import VALUES (44577, '2020-06-27', 'XK', 'Kosovo[1]', 'EURO', '62', '2451', '3', '34');
INSERT INTO public.who_global_data_import VALUES (44578, '2020-06-28', 'XK', 'Kosovo[1]', 'EURO', '96', '2547', '3', '37');
INSERT INTO public.who_global_data_import VALUES (44579, '2020-06-29', 'XK', 'Kosovo[1]', 'EURO', '87', '2634', '1', '38');
INSERT INTO public.who_global_data_import VALUES (44580, '2020-06-30', 'XK', 'Kosovo[1]', 'EURO', '122', '2756', '1', '39');
INSERT INTO public.who_global_data_import VALUES (44581, '2020-07-01', 'XK', 'Kosovo[1]', 'EURO', '79', '2835', '2', '41');
INSERT INTO public.who_global_data_import VALUES (44582, '2020-07-02', 'XK', 'Kosovo[1]', 'EURO', '113', '2948', '3', '44');
INSERT INTO public.who_global_data_import VALUES (44583, '2020-07-03', 'XK', 'Kosovo[1]', 'EURO', '73', '3021', '1', '45');
INSERT INTO public.who_global_data_import VALUES (44584, '2020-07-04', 'XK', 'Kosovo[1]', 'EURO', '114', '3135', '0', '45');
INSERT INTO public.who_global_data_import VALUES (44585, '2020-07-05', 'XK', 'Kosovo[1]', 'EURO', '178', '3313', '9', '54');
INSERT INTO public.who_global_data_import VALUES (44586, '2020-07-06', 'XK', 'Kosovo[1]', 'EURO', '152', '3465', '11', '65');
INSERT INTO public.who_global_data_import VALUES (44587, '2020-07-07', 'XK', 'Kosovo[1]', 'EURO', '195', '3660', '4', '69');
INSERT INTO public.who_global_data_import VALUES (44588, '2020-07-08', 'XK', 'Kosovo[1]', 'EURO', '183', '3843', '3', '72');
INSERT INTO public.who_global_data_import VALUES (44589, '2020-07-09', 'XK', 'Kosovo[1]', 'EURO', '214', '4057', '4', '76');
INSERT INTO public.who_global_data_import VALUES (44590, '2020-07-10', 'XK', 'Kosovo[1]', 'EURO', '207', '4264', '8', '84');
INSERT INTO public.who_global_data_import VALUES (44591, '2020-07-11', 'XK', 'Kosovo[1]', 'EURO', '205', '4469', '3', '87');
INSERT INTO public.who_global_data_import VALUES (44592, '2020-07-12', 'XK', 'Kosovo[1]', 'EURO', '203', '4672', '4', '91');
INSERT INTO public.who_global_data_import VALUES (44593, '2020-07-13', 'XK', 'Kosovo[1]', 'EURO', '216', '4888', '1', '92');
INSERT INTO public.who_global_data_import VALUES (44594, '2020-07-14', 'XK', 'Kosovo[1]', 'EURO', '187', '5075', '6', '98');
INSERT INTO public.who_global_data_import VALUES (44595, '2020-07-15', 'XK', 'Kosovo[1]', 'EURO', '0', '5075', '0', '98');
INSERT INTO public.who_global_data_import VALUES (44596, '2020-07-16', 'XK', 'Kosovo[1]', 'EURO', '119', '5194', '4', '102');
INSERT INTO public.who_global_data_import VALUES (44597, '2020-07-17', 'XK', 'Kosovo[1]', 'EURO', '135', '5329', '6', '108');
INSERT INTO public.who_global_data_import VALUES (44598, '2020-07-18', 'XK', 'Kosovo[1]', 'EURO', '81', '5410', '6', '114');
INSERT INTO public.who_global_data_import VALUES (44599, '2020-07-19', 'XK', 'Kosovo[1]', 'EURO', '164', '5574', '6', '120');
INSERT INTO public.who_global_data_import VALUES (44600, '2020-07-20', 'XK', 'Kosovo[1]', 'EURO', '118', '5692', '5', '125');
INSERT INTO public.who_global_data_import VALUES (44601, '2020-07-21', 'XK', 'Kosovo[1]', 'EURO', '142', '5834', '4', '129');
INSERT INTO public.who_global_data_import VALUES (44602, '2020-07-22', 'XK', 'Kosovo[1]', 'EURO', '168', '6002', '5', '134');
INSERT INTO public.who_global_data_import VALUES (44603, '2020-07-23', 'XK', 'Kosovo[1]', 'EURO', '140', '6142', '6', '140');
INSERT INTO public.who_global_data_import VALUES (44604, '2020-07-24', 'XK', 'Kosovo[1]', 'EURO', '282', '6424', '8', '148');
INSERT INTO public.who_global_data_import VALUES (44605, '2020-07-25', 'XK', 'Kosovo[1]', 'EURO', '213', '6637', '6', '154');
INSERT INTO public.who_global_data_import VALUES (44606, '2020-07-26', 'XK', 'Kosovo[1]', 'EURO', '237', '6874', '5', '159');
INSERT INTO public.who_global_data_import VALUES (44607, '2020-07-27', 'XK', 'Kosovo[1]', 'EURO', '220', '7094', '8', '167');
INSERT INTO public.who_global_data_import VALUES (44608, '2020-07-28', 'XK', 'Kosovo[1]', 'EURO', '276', '7370', '8', '175');
INSERT INTO public.who_global_data_import VALUES (44609, '2020-07-29', 'XK', 'Kosovo[1]', 'EURO', '239', '7609', '7', '182');
INSERT INTO public.who_global_data_import VALUES (44610, '2020-07-30', 'XK', 'Kosovo[1]', 'EURO', '194', '7803', '4', '186');
INSERT INTO public.who_global_data_import VALUES (44611, '2020-07-31', 'XK', 'Kosovo[1]', 'EURO', '258', '8061', '16', '202');
INSERT INTO public.who_global_data_import VALUES (44612, '2020-08-01', 'XK', 'Kosovo[1]', 'EURO', '226', '8287', '15', '217');
INSERT INTO public.who_global_data_import VALUES (44613, '2020-08-02', 'XK', 'Kosovo[1]', 'EURO', '224', '8511', '10', '227');
INSERT INTO public.who_global_data_import VALUES (44614, '2020-08-03', 'XK', 'Kosovo[1]', 'EURO', '245', '8756', '12', '239');
INSERT INTO public.who_global_data_import VALUES (44615, '2020-08-04', 'XK', 'Kosovo[1]', 'EURO', '250', '9006', '7', '246');
INSERT INTO public.who_global_data_import VALUES (44616, '2020-08-05', 'XK', 'Kosovo[1]', 'EURO', '225', '9231', '13', '259');
INSERT INTO public.who_global_data_import VALUES (44617, '2020-08-06', 'XK', 'Kosovo[1]', 'EURO', '218', '9449', '5', '264');
INSERT INTO public.who_global_data_import VALUES (44618, '2020-08-07', 'XK', 'Kosovo[1]', 'EURO', '196', '9645', '26', '290');
INSERT INTO public.who_global_data_import VALUES (44619, '2020-08-08', 'XK', 'Kosovo[1]', 'EURO', '181', '9826', '3', '293');
INSERT INTO public.who_global_data_import VALUES (44620, '2020-08-09', 'XK', 'Kosovo[1]', 'EURO', '190', '10016', '12', '305');
INSERT INTO public.who_global_data_import VALUES (44621, '2020-08-10', 'XK', 'Kosovo[1]', 'EURO', '188', '10204', '12', '317');
INSERT INTO public.who_global_data_import VALUES (44622, '2020-08-11', 'XK', 'Kosovo[1]', 'EURO', '172', '10376', '14', '331');
INSERT INTO public.who_global_data_import VALUES (44623, '2020-08-12', 'XK', 'Kosovo[1]', 'EURO', '171', '10547', '13', '344');
INSERT INTO public.who_global_data_import VALUES (44624, '2020-08-13', 'XK', 'Kosovo[1]', 'EURO', '205', '10752', '11', '355');
INSERT INTO public.who_global_data_import VALUES (44625, '2020-08-14', 'XK', 'Kosovo[1]', 'EURO', '193', '10945', '8', '363');
INSERT INTO public.who_global_data_import VALUES (44626, '2020-08-15', 'XK', 'Kosovo[1]', 'EURO', '142', '11087', '8', '371');
INSERT INTO public.who_global_data_import VALUES (44627, '2020-08-16', 'XK', 'Kosovo[1]', 'EURO', '145', '11232', '9', '380');
INSERT INTO public.who_global_data_import VALUES (44628, '2020-08-17', 'XK', 'Kosovo[1]', 'EURO', '141', '11373', '11', '391');
INSERT INTO public.who_global_data_import VALUES (44629, '2020-08-18', 'XK', 'Kosovo[1]', 'EURO', '129', '11502', '9', '400');
INSERT INTO public.who_global_data_import VALUES (44630, '2020-08-19', 'XK', 'Kosovo[1]', 'EURO', '141', '11643', '6', '406');
INSERT INTO public.who_global_data_import VALUES (44631, '2020-08-20', 'XK', 'Kosovo[1]', 'EURO', '162', '11805', '9', '415');
INSERT INTO public.who_global_data_import VALUES (44632, '2020-08-21', 'XK', 'Kosovo[1]', 'EURO', '158', '11963', '13', '428');
INSERT INTO public.who_global_data_import VALUES (44633, '2020-08-22', 'XK', 'Kosovo[1]', 'EURO', '162', '12125', '10', '438');
INSERT INTO public.who_global_data_import VALUES (44634, '2020-08-23', 'XK', 'Kosovo[1]', 'EURO', '169', '12294', '9', '447');
INSERT INTO public.who_global_data_import VALUES (44635, '2020-08-24', 'XK', 'Kosovo[1]', 'EURO', '111', '12405', '10', '457');
INSERT INTO public.who_global_data_import VALUES (44636, '2020-08-25', 'XK', 'Kosovo[1]', 'EURO', '99', '12504', '13', '470');
INSERT INTO public.who_global_data_import VALUES (44637, '2020-08-26', 'XK', 'Kosovo[1]', 'EURO', '136', '12640', '8', '478');
INSERT INTO public.who_global_data_import VALUES (44638, '2020-08-27', 'XK', 'Kosovo[1]', 'EURO', '157', '12797', '4', '482');
INSERT INTO public.who_global_data_import VALUES (44639, '2020-08-28', 'XK', 'Kosovo[1]', 'EURO', '141', '12938', '6', '488');
INSERT INTO public.who_global_data_import VALUES (44640, '2020-08-29', 'XK', 'Kosovo[1]', 'EURO', '119', '13057', '1', '489');
INSERT INTO public.who_global_data_import VALUES (44641, '2020-08-30', 'XK', 'Kosovo[1]', 'EURO', '115', '13172', '9', '498');
INSERT INTO public.who_global_data_import VALUES (44642, '2020-08-31', 'XK', 'Kosovo[1]', 'EURO', '119', '13291', '8', '506');
INSERT INTO public.who_global_data_import VALUES (44643, '2020-09-01', 'XK', 'Kosovo[1]', 'EURO', '120', '13411', '9', '515');
INSERT INTO public.who_global_data_import VALUES (44644, '2020-09-02', 'XK', 'Kosovo[1]', 'EURO', '147', '13558', '8', '523');
INSERT INTO public.who_global_data_import VALUES (44645, '2020-09-03', 'XK', 'Kosovo[1]', 'EURO', '112', '13670', '6', '529');
INSERT INTO public.who_global_data_import VALUES (44646, '2020-09-04', 'XK', 'Kosovo[1]', 'EURO', '78', '13748', '9', '538');
INSERT INTO public.who_global_data_import VALUES (44647, '2020-09-05', 'XK', 'Kosovo[1]', 'EURO', '119', '13867', '3', '541');
INSERT INTO public.who_global_data_import VALUES (44648, '2020-09-06', 'XK', 'Kosovo[1]', 'EURO', '117', '13984', '5', '546');
INSERT INTO public.who_global_data_import VALUES (44649, '2020-09-07', 'XK', 'Kosovo[1]', 'EURO', '92', '14076', '7', '553');
INSERT INTO public.who_global_data_import VALUES (44858, '2020-02-29', 'KW', 'Kuwait', 'EMRO', '0', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44650, '2020-09-08', 'XK', 'Kosovo[1]', 'EURO', '85', '14161', '5', '558');
INSERT INTO public.who_global_data_import VALUES (44651, '2020-09-09', 'XK', 'Kosovo[1]', 'EURO', '97', '14258', '0', '558');
INSERT INTO public.who_global_data_import VALUES (44652, '2020-09-10', 'XK', 'Kosovo[1]', 'EURO', '76', '14334', '6', '564');
INSERT INTO public.who_global_data_import VALUES (44653, '2020-09-11', 'XK', 'Kosovo[1]', 'EURO', '69', '14403', '7', '571');
INSERT INTO public.who_global_data_import VALUES (44654, '2020-09-12', 'XK', 'Kosovo[1]', 'EURO', '50', '14453', '5', '576');
INSERT INTO public.who_global_data_import VALUES (44655, '2020-09-13', 'XK', 'Kosovo[1]', 'EURO', '70', '14523', '3', '579');
INSERT INTO public.who_global_data_import VALUES (44656, '2020-09-14', 'XK', 'Kosovo[1]', 'EURO', '71', '14594', '7', '586');
INSERT INTO public.who_global_data_import VALUES (44657, '2020-09-15', 'XK', 'Kosovo[1]', 'EURO', '55', '14649', '4', '590');
INSERT INTO public.who_global_data_import VALUES (44658, '2020-09-16', 'XK', 'Kosovo[1]', 'EURO', '71', '14720', '1', '591');
INSERT INTO public.who_global_data_import VALUES (44659, '2020-09-17', 'XK', 'Kosovo[1]', 'EURO', '76', '14796', '3', '594');
INSERT INTO public.who_global_data_import VALUES (44660, '2020-09-18', 'XK', 'Kosovo[1]', 'EURO', '43', '14839', '3', '597');
INSERT INTO public.who_global_data_import VALUES (44661, '2020-09-19', 'XK', 'Kosovo[1]', 'EURO', '57', '14896', '4', '601');
INSERT INTO public.who_global_data_import VALUES (44662, '2020-09-20', 'XK', 'Kosovo[1]', 'EURO', '63', '14959', '0', '601');
INSERT INTO public.who_global_data_import VALUES (44663, '2020-09-21', 'XK', 'Kosovo[1]', 'EURO', '61', '15020', '2', '603');
INSERT INTO public.who_global_data_import VALUES (44664, '2020-09-22', 'XK', 'Kosovo[1]', 'EURO', '79', '15099', '2', '605');
INSERT INTO public.who_global_data_import VALUES (44665, '2020-09-23', 'XK', 'Kosovo[1]', 'EURO', '66', '15165', '0', '605');
INSERT INTO public.who_global_data_import VALUES (44666, '2020-09-24', 'XK', 'Kosovo[1]', 'EURO', '62', '15227', '1', '606');
INSERT INTO public.who_global_data_import VALUES (44667, '2020-09-25', 'XK', 'Kosovo[1]', 'EURO', '63', '15290', '0', '606');
INSERT INTO public.who_global_data_import VALUES (44668, '2020-09-26', 'XK', 'Kosovo[1]', 'EURO', '46', '15336', '1', '607');
INSERT INTO public.who_global_data_import VALUES (44669, '2020-09-27', 'XK', 'Kosovo[1]', 'EURO', '46', '15382', '2', '609');
INSERT INTO public.who_global_data_import VALUES (44670, '2020-09-28', 'XK', 'Kosovo[1]', 'EURO', '47', '15429', '3', '612');
INSERT INTO public.who_global_data_import VALUES (44671, '2020-09-29', 'XK', 'Kosovo[1]', 'EURO', '48', '15477', '3', '615');
INSERT INTO public.who_global_data_import VALUES (44672, '2020-09-30', 'XK', 'Kosovo[1]', 'EURO', '54', '15531', '0', '615');
INSERT INTO public.who_global_data_import VALUES (44673, '2020-10-01', 'XK', 'Kosovo[1]', 'EURO', '46', '15577', '0', '615');
INSERT INTO public.who_global_data_import VALUES (44674, '2020-10-02', 'XK', 'Kosovo[1]', 'EURO', '43', '15620', '2', '617');
INSERT INTO public.who_global_data_import VALUES (44675, '2020-10-03', 'XK', 'Kosovo[1]', 'EURO', '42', '15662', '0', '617');
INSERT INTO public.who_global_data_import VALUES (44676, '2020-10-04', 'XK', 'Kosovo[1]', 'EURO', '53', '15715', '3', '620');
INSERT INTO public.who_global_data_import VALUES (44677, '2020-10-05', 'XK', 'Kosovo[1]', 'EURO', '56', '15771', '0', '620');
INSERT INTO public.who_global_data_import VALUES (44678, '2020-10-06', 'XK', 'Kosovo[1]', 'EURO', '41', '15812', '2', '622');
INSERT INTO public.who_global_data_import VALUES (44679, '2020-10-07', 'XK', 'Kosovo[1]', 'EURO', '34', '15846', '3', '625');
INSERT INTO public.who_global_data_import VALUES (44680, '2020-10-08', 'XK', 'Kosovo[1]', 'EURO', '49', '15895', '3', '628');
INSERT INTO public.who_global_data_import VALUES (44681, '2020-10-09', 'XK', 'Kosovo[1]', 'EURO', '33', '15928', '0', '628');
INSERT INTO public.who_global_data_import VALUES (44682, '2020-10-10', 'XK', 'Kosovo[1]', 'EURO', '79', '16007', '3', '631');
INSERT INTO public.who_global_data_import VALUES (44683, '2020-10-11', 'XK', 'Kosovo[1]', 'EURO', '80', '16087', '4', '635');
INSERT INTO public.who_global_data_import VALUES (44684, '2020-10-12', 'XK', 'Kosovo[1]', 'EURO', '49', '16136', '2', '637');
INSERT INTO public.who_global_data_import VALUES (44685, '2020-10-13', 'XK', 'Kosovo[1]', 'EURO', '68', '16204', '1', '638');
INSERT INTO public.who_global_data_import VALUES (44686, '2020-10-14', 'XK', 'Kosovo[1]', 'EURO', '98', '16302', '1', '639');
INSERT INTO public.who_global_data_import VALUES (44687, '2020-10-15', 'XK', 'Kosovo[1]', 'EURO', '80', '16382', '1', '640');
INSERT INTO public.who_global_data_import VALUES (44688, '2020-10-16', 'XK', 'Kosovo[1]', 'EURO', '77', '16459', '0', '640');
INSERT INTO public.who_global_data_import VALUES (44689, '2020-10-17', 'XK', 'Kosovo[1]', 'EURO', '104', '16563', '2', '642');
INSERT INTO public.who_global_data_import VALUES (44690, '2020-10-18', 'XK', 'Kosovo[1]', 'EURO', '148', '16711', '0', '642');
INSERT INTO public.who_global_data_import VALUES (44691, '2020-10-19', 'XK', 'Kosovo[1]', 'EURO', '137', '16848', '1', '643');
INSERT INTO public.who_global_data_import VALUES (44692, '2020-10-20', 'XK', 'Kosovo[1]', 'EURO', '118', '16966', '3', '646');
INSERT INTO public.who_global_data_import VALUES (44693, '2020-10-21', 'XK', 'Kosovo[1]', 'EURO', '130', '17096', '1', '647');
INSERT INTO public.who_global_data_import VALUES (44694, '2020-10-22', 'XK', 'Kosovo[1]', 'EURO', '124', '17220', '0', '647');
INSERT INTO public.who_global_data_import VALUES (44695, '2020-10-23', 'XK', 'Kosovo[1]', 'EURO', '159', '17379', '0', '647');
INSERT INTO public.who_global_data_import VALUES (44696, '2020-10-24', 'XK', 'Kosovo[1]', 'EURO', '169', '17548', '2', '649');
INSERT INTO public.who_global_data_import VALUES (44697, '2020-10-25', 'XK', 'Kosovo[1]', 'EURO', '166', '17714', '2', '651');
INSERT INTO public.who_global_data_import VALUES (44698, '2020-10-26', 'XK', 'Kosovo[1]', 'EURO', '186', '17900', '2', '653');
INSERT INTO public.who_global_data_import VALUES (44699, '2020-10-27', 'XK', 'Kosovo[1]', 'EURO', '205', '18105', '3', '656');
INSERT INTO public.who_global_data_import VALUES (44700, '2020-10-28', 'XK', 'Kosovo[1]', 'EURO', '197', '18302', '3', '659');
INSERT INTO public.who_global_data_import VALUES (44701, '2020-10-29', 'XK', 'Kosovo[1]', 'EURO', '281', '18583', '4', '663');
INSERT INTO public.who_global_data_import VALUES (44702, '2020-10-30', 'XK', 'Kosovo[1]', 'EURO', '284', '18867', '1', '664');
INSERT INTO public.who_global_data_import VALUES (44703, '2020-10-31', 'XK', 'Kosovo[1]', 'EURO', '418', '19285', '4', '668');
INSERT INTO public.who_global_data_import VALUES (44704, '2020-11-01', 'XK', 'Kosovo[1]', 'EURO', '514', '19799', '3', '671');
INSERT INTO public.who_global_data_import VALUES (44705, '2020-11-02', 'XK', 'Kosovo[1]', 'EURO', '337', '20136', '7', '678');
INSERT INTO public.who_global_data_import VALUES (44706, '2020-11-03', 'XK', 'Kosovo[1]', 'EURO', '486', '20622', '9', '687');
INSERT INTO public.who_global_data_import VALUES (44707, '2020-11-04', 'XK', 'Kosovo[1]', 'EURO', '334', '20956', '8', '695');
INSERT INTO public.who_global_data_import VALUES (44708, '2020-11-05', 'XK', 'Kosovo[1]', 'EURO', '546', '21502', '9', '704');
INSERT INTO public.who_global_data_import VALUES (44709, '2020-11-06', 'XK', 'Kosovo[1]', 'EURO', '661', '22163', '6', '710');
INSERT INTO public.who_global_data_import VALUES (44710, '2020-11-07', 'XK', 'Kosovo[1]', 'EURO', '728', '22891', '12', '722');
INSERT INTO public.who_global_data_import VALUES (44711, '2020-11-08', 'XK', 'Kosovo[1]', 'EURO', '491', '23382', '12', '734');
INSERT INTO public.who_global_data_import VALUES (44712, '2020-11-09', 'XK', 'Kosovo[1]', 'EURO', '730', '24112', '11', '745');
INSERT INTO public.who_global_data_import VALUES (44713, '2020-11-10', 'XK', 'Kosovo[1]', 'EURO', '637', '24749', '13', '758');
INSERT INTO public.who_global_data_import VALUES (44714, '2020-11-11', 'XK', 'Kosovo[1]', 'EURO', '596', '25345', '5', '763');
INSERT INTO public.who_global_data_import VALUES (44715, '2020-11-12', 'XK', 'Kosovo[1]', 'EURO', '733', '26078', '4', '767');
INSERT INTO public.who_global_data_import VALUES (44716, '2020-11-13', 'XK', 'Kosovo[1]', 'EURO', '767', '26845', '8', '775');
INSERT INTO public.who_global_data_import VALUES (44717, '2020-11-14', 'XK', 'Kosovo[1]', 'EURO', '963', '27808', '13', '788');
INSERT INTO public.who_global_data_import VALUES (44718, '2020-11-15', 'XK', 'Kosovo[1]', 'EURO', '765', '28573', '11', '799');
INSERT INTO public.who_global_data_import VALUES (44719, '2020-11-16', 'XK', 'Kosovo[1]', 'EURO', '501', '29074', '13', '812');
INSERT INTO public.who_global_data_import VALUES (44720, '2020-11-17', 'XK', 'Kosovo[1]', 'EURO', '688', '29762', '11', '823');
INSERT INTO public.who_global_data_import VALUES (44721, '2020-11-18', 'XK', 'Kosovo[1]', 'EURO', '690', '30452', '16', '839');
INSERT INTO public.who_global_data_import VALUES (44722, '2020-11-19', 'XK', 'Kosovo[1]', 'EURO', '720', '31172', '11', '850');
INSERT INTO public.who_global_data_import VALUES (44723, '2020-11-20', 'XK', 'Kosovo[1]', 'EURO', '807', '31979', '14', '864');
INSERT INTO public.who_global_data_import VALUES (44724, '2020-11-21', 'XK', 'Kosovo[1]', 'EURO', '855', '32834', '11', '875');
INSERT INTO public.who_global_data_import VALUES (44725, '2020-11-22', 'XK', 'Kosovo[1]', 'EURO', '711', '33545', '19', '894');
INSERT INTO public.who_global_data_import VALUES (44726, '2020-11-23', 'XK', 'Kosovo[1]', 'EURO', '707', '34252', '10', '904');
INSERT INTO public.who_global_data_import VALUES (44727, '2020-11-24', 'XK', 'Kosovo[1]', 'EURO', '645', '34897', '12', '916');
INSERT INTO public.who_global_data_import VALUES (44728, '2020-11-25', 'XK', 'Kosovo[1]', 'EURO', '609', '35506', '13', '929');
INSERT INTO public.who_global_data_import VALUES (44729, '2020-11-26', 'XK', 'Kosovo[1]', 'EURO', '704', '36210', '9', '938');
INSERT INTO public.who_global_data_import VALUES (44730, '2020-11-27', 'XK', 'Kosovo[1]', 'EURO', '775', '36985', '15', '953');
INSERT INTO public.who_global_data_import VALUES (44731, '2020-11-28', 'XK', 'Kosovo[1]', 'EURO', '764', '37749', '12', '965');
INSERT INTO public.who_global_data_import VALUES (44732, '2020-11-29', 'XK', 'Kosovo[1]', 'EURO', '639', '38388', '14', '979');
INSERT INTO public.who_global_data_import VALUES (44733, '2020-11-30', 'XK', 'Kosovo[1]', 'EURO', '626', '39014', '16', '995');
INSERT INTO public.who_global_data_import VALUES (44734, '2020-12-01', 'XK', 'Kosovo[1]', 'EURO', '539', '39553', '11', '1006');
INSERT INTO public.who_global_data_import VALUES (44735, '2020-12-02', 'XK', 'Kosovo[1]', 'EURO', '521', '40074', '10', '1016');
INSERT INTO public.who_global_data_import VALUES (44736, '2020-12-03', 'XK', 'Kosovo[1]', 'EURO', '555', '40629', '14', '1030');
INSERT INTO public.who_global_data_import VALUES (44737, '2020-12-04', 'XK', 'Kosovo[1]', 'EURO', '627', '41256', '22', '1052');
INSERT INTO public.who_global_data_import VALUES (44738, '2020-12-05', 'XK', 'Kosovo[1]', 'EURO', '478', '41734', '11', '1063');
INSERT INTO public.who_global_data_import VALUES (44739, '2020-12-06', 'XK', 'Kosovo[1]', 'EURO', '560', '42294', '14', '1077');
INSERT INTO public.who_global_data_import VALUES (44740, '2020-12-07', 'XK', 'Kosovo[1]', 'EURO', '468', '42762', '19', '1096');
INSERT INTO public.who_global_data_import VALUES (44741, '2020-12-08', 'XK', 'Kosovo[1]', 'EURO', '519', '43281', '14', '1110');
INSERT INTO public.who_global_data_import VALUES (44742, '2020-12-09', 'XK', 'Kosovo[1]', 'EURO', '557', '43838', '17', '1127');
INSERT INTO public.who_global_data_import VALUES (44743, '2020-12-10', 'XK', 'Kosovo[1]', 'EURO', '561', '44399', '11', '1138');
INSERT INTO public.who_global_data_import VALUES (44744, '2020-12-11', 'XK', 'Kosovo[1]', 'EURO', '562', '44961', '13', '1151');
INSERT INTO public.who_global_data_import VALUES (44745, '2020-12-12', 'XK', 'Kosovo[1]', 'EURO', '590', '45551', '13', '1164');
INSERT INTO public.who_global_data_import VALUES (44746, '2020-12-13', 'XK', 'Kosovo[1]', 'EURO', '524', '46075', '12', '1176');
INSERT INTO public.who_global_data_import VALUES (44747, '2020-12-14', 'XK', 'Kosovo[1]', 'EURO', '462', '46537', '12', '1188');
INSERT INTO public.who_global_data_import VALUES (44748, '2020-12-15', 'XK', 'Kosovo[1]', 'EURO', '329', '46866', '5', '1193');
INSERT INTO public.who_global_data_import VALUES (44749, '2020-12-16', 'XK', 'Kosovo[1]', 'EURO', '294', '47160', '17', '1210');
INSERT INTO public.who_global_data_import VALUES (44859, '2020-03-01', 'KW', 'Kuwait', 'EMRO', '0', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44750, '2020-12-17', 'XK', 'Kosovo[1]', 'EURO', '296', '47456', '5', '1215');
INSERT INTO public.who_global_data_import VALUES (44751, '2020-12-18', 'XK', 'Kosovo[1]', 'EURO', '453', '47909', '8', '1223');
INSERT INTO public.who_global_data_import VALUES (44752, '2020-12-19', 'XK', 'Kosovo[1]', 'EURO', '385', '48294', '7', '1230');
INSERT INTO public.who_global_data_import VALUES (44753, '2020-12-20', 'XK', 'Kosovo[1]', 'EURO', '345', '48639', '8', '1238');
INSERT INTO public.who_global_data_import VALUES (44754, '2020-12-21', 'XK', 'Kosovo[1]', 'EURO', '223', '48862', '8', '1246');
INSERT INTO public.who_global_data_import VALUES (44755, '2020-12-22', 'XK', 'Kosovo[1]', 'EURO', '264', '49126', '6', '1252');
INSERT INTO public.who_global_data_import VALUES (44756, '2020-12-23', 'XK', 'Kosovo[1]', 'EURO', '137', '49263', '10', '1262');
INSERT INTO public.who_global_data_import VALUES (44757, '2020-12-24', 'XK', 'Kosovo[1]', 'EURO', '271', '49534', '12', '1274');
INSERT INTO public.who_global_data_import VALUES (44758, '2020-12-25', 'XK', 'Kosovo[1]', 'EURO', '309', '49843', '6', '1280');
INSERT INTO public.who_global_data_import VALUES (44759, '2020-12-26', 'XK', 'Kosovo[1]', 'EURO', '249', '50092', '8', '1288');
INSERT INTO public.who_global_data_import VALUES (44760, '2020-12-27', 'XK', 'Kosovo[1]', 'EURO', '270', '50362', '7', '1295');
INSERT INTO public.who_global_data_import VALUES (44761, '2020-12-28', 'XK', 'Kosovo[1]', 'EURO', '215', '50577', '4', '1299');
INSERT INTO public.who_global_data_import VALUES (44762, '2020-12-29', 'XK', 'Kosovo[1]', 'EURO', '181', '50758', '8', '1307');
INSERT INTO public.who_global_data_import VALUES (44763, '2020-12-30', 'XK', 'Kosovo[1]', 'EURO', '109', '50867', '8', '1315');
INSERT INTO public.who_global_data_import VALUES (44764, '2020-12-31', 'XK', 'Kosovo[1]', 'EURO', '234', '51101', '7', '1322');
INSERT INTO public.who_global_data_import VALUES (44765, '2021-01-01', 'XK', 'Kosovo[1]', 'EURO', '184', '51285', '3', '1325');
INSERT INTO public.who_global_data_import VALUES (44766, '2021-01-02', 'XK', 'Kosovo[1]', 'EURO', '174', '51459', '1', '1326');
INSERT INTO public.who_global_data_import VALUES (44767, '2021-01-03', 'XK', 'Kosovo[1]', 'EURO', '229', '51688', '4', '1330');
INSERT INTO public.who_global_data_import VALUES (44768, '2021-01-04', 'XK', 'Kosovo[1]', 'EURO', '234', '51922', '4', '1334');
INSERT INTO public.who_global_data_import VALUES (44769, '2021-01-05', 'XK', 'Kosovo[1]', 'EURO', '169', '52091', '7', '1341');
INSERT INTO public.who_global_data_import VALUES (44770, '2021-01-06', 'XK', 'Kosovo[1]', 'EURO', '199', '52290', '4', '1345');
INSERT INTO public.who_global_data_import VALUES (44771, '2021-01-07', 'XK', 'Kosovo[1]', 'EURO', '301', '52591', '2', '1347');
INSERT INTO public.who_global_data_import VALUES (44772, '2021-01-08', 'XK', 'Kosovo[1]', 'EURO', '309', '52900', '6', '1353');
INSERT INTO public.who_global_data_import VALUES (44773, '2021-01-09', 'XK', 'Kosovo[1]', 'EURO', '321', '53221', '5', '1358');
INSERT INTO public.who_global_data_import VALUES (44774, '2021-01-10', 'XK', 'Kosovo[1]', 'EURO', '259', '53480', '7', '1365');
INSERT INTO public.who_global_data_import VALUES (44775, '2021-01-11', 'XK', 'Kosovo[1]', 'EURO', '253', '53733', '2', '1367');
INSERT INTO public.who_global_data_import VALUES (44776, '2021-01-12', 'XK', 'Kosovo[1]', 'EURO', '206', '53939', '6', '1373');
INSERT INTO public.who_global_data_import VALUES (44777, '2021-01-13', 'XK', 'Kosovo[1]', 'EURO', '279', '54218', '4', '1377');
INSERT INTO public.who_global_data_import VALUES (44778, '2021-01-14', 'XK', 'Kosovo[1]', 'EURO', '299', '54517', '1', '1378');
INSERT INTO public.who_global_data_import VALUES (44779, '2021-01-15', 'XK', 'Kosovo[1]', 'EURO', '279', '54796', '4', '1382');
INSERT INTO public.who_global_data_import VALUES (44780, '2021-01-16', 'XK', 'Kosovo[1]', 'EURO', '296', '55092', '7', '1389');
INSERT INTO public.who_global_data_import VALUES (44781, '2021-01-17', 'XK', 'Kosovo[1]', 'EURO', '363', '55455', '6', '1395');
INSERT INTO public.who_global_data_import VALUES (44782, '2021-01-18', 'XK', 'Kosovo[1]', 'EURO', '353', '55808', '5', '1400');
INSERT INTO public.who_global_data_import VALUES (44783, '2021-01-19', 'XK', 'Kosovo[1]', 'EURO', '267', '56075', '1', '1401');
INSERT INTO public.who_global_data_import VALUES (44784, '2021-01-20', 'XK', 'Kosovo[1]', 'EURO', '297', '56372', '9', '1410');
INSERT INTO public.who_global_data_import VALUES (44785, '2021-01-21', 'XK', 'Kosovo[1]', 'EURO', '320', '56692', '6', '1416');
INSERT INTO public.who_global_data_import VALUES (44786, '2021-01-22', 'XK', 'Kosovo[1]', 'EURO', '296', '56988', '7', '1423');
INSERT INTO public.who_global_data_import VALUES (44787, '2021-01-23', 'XK', 'Kosovo[1]', 'EURO', '289', '57277', '14', '1437');
INSERT INTO public.who_global_data_import VALUES (44788, '2021-01-24', 'XK', 'Kosovo[1]', 'EURO', '379', '57656', '3', '1440');
INSERT INTO public.who_global_data_import VALUES (44789, '2021-01-25', 'XK', 'Kosovo[1]', 'EURO', '392', '58048', '6', '1446');
INSERT INTO public.who_global_data_import VALUES (44790, '2021-01-26', 'XK', 'Kosovo[1]', 'EURO', '311', '58359', '10', '1456');
INSERT INTO public.who_global_data_import VALUES (44791, '2021-01-27', 'XK', 'Kosovo[1]', 'EURO', '288', '58647', '5', '1461');
INSERT INTO public.who_global_data_import VALUES (44792, '2021-01-28', 'XK', 'Kosovo[1]', 'EURO', '301', '58948', '8', '1469');
INSERT INTO public.who_global_data_import VALUES (44793, '2021-01-29', 'XK', 'Kosovo[1]', 'EURO', '316', '59264', '3', '1472');
INSERT INTO public.who_global_data_import VALUES (44794, '2021-01-30', 'XK', 'Kosovo[1]', 'EURO', '342', '59606', '5', '1477');
INSERT INTO public.who_global_data_import VALUES (44795, '2021-01-31', 'XK', 'Kosovo[1]', 'EURO', '285', '59891', '5', '1482');
INSERT INTO public.who_global_data_import VALUES (44796, '2021-02-01', 'XK', 'Kosovo[1]', 'EURO', '287', '60178', '6', '1488');
INSERT INTO public.who_global_data_import VALUES (44797, '2021-02-02', 'XK', 'Kosovo[1]', 'EURO', '282', '60460', '5', '1493');
INSERT INTO public.who_global_data_import VALUES (44798, '2021-02-03', 'XK', 'Kosovo[1]', 'EURO', '245', '60705', '3', '1496');
INSERT INTO public.who_global_data_import VALUES (44799, '2021-02-04', 'XK', 'Kosovo[1]', 'EURO', '314', '61019', '3', '1499');
INSERT INTO public.who_global_data_import VALUES (44800, '2021-02-05', 'XK', 'Kosovo[1]', 'EURO', '318', '61337', '5', '1504');
INSERT INTO public.who_global_data_import VALUES (44801, '2020-01-03', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44802, '2020-01-04', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44803, '2020-01-05', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44804, '2020-01-06', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44805, '2020-01-07', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44806, '2020-01-08', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44807, '2020-01-09', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44808, '2020-01-10', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44809, '2020-01-11', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44810, '2020-01-12', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44811, '2020-01-13', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44812, '2020-01-14', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44813, '2020-01-15', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44814, '2020-01-16', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44815, '2020-01-17', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44816, '2020-01-18', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44817, '2020-01-19', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44818, '2020-01-20', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44819, '2020-01-21', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44820, '2020-01-22', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44821, '2020-01-23', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44822, '2020-01-24', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44823, '2020-01-25', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44824, '2020-01-26', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44825, '2020-01-27', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44826, '2020-01-28', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44827, '2020-01-29', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44828, '2020-01-30', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44829, '2020-01-31', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44830, '2020-02-01', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44831, '2020-02-02', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44832, '2020-02-03', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44833, '2020-02-04', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44834, '2020-02-05', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44835, '2020-02-06', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44836, '2020-02-07', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44837, '2020-02-08', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44838, '2020-02-09', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44839, '2020-02-10', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44840, '2020-02-11', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44841, '2020-02-12', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44842, '2020-02-13', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44843, '2020-02-14', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44844, '2020-02-15', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44845, '2020-02-16', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44846, '2020-02-17', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44847, '2020-02-18', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44848, '2020-02-19', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44849, '2020-02-20', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44850, '2020-02-21', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44851, '2020-02-22', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44852, '2020-02-23', 'KW', 'Kuwait', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44853, '2020-02-24', 'KW', 'Kuwait', 'EMRO', '9', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44854, '2020-02-25', 'KW', 'Kuwait', 'EMRO', '4', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44855, '2020-02-26', 'KW', 'Kuwait', 'EMRO', '17', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44856, '2020-02-27', 'KW', 'Kuwait', 'EMRO', '17', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44857, '2020-02-28', 'KW', 'Kuwait', 'EMRO', '2', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44860, '2020-03-02', 'KW', 'Kuwait', 'EMRO', '11', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44861, '2020-03-03', 'KW', 'Kuwait', 'EMRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44862, '2020-03-04', 'KW', 'Kuwait', 'EMRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44863, '2020-03-05', 'KW', 'Kuwait', 'EMRO', '2', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44864, '2020-03-06', 'KW', 'Kuwait', 'EMRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44865, '2020-03-07', 'KW', 'Kuwait', 'EMRO', '3', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44866, '2020-03-08', 'KW', 'Kuwait', 'EMRO', '3', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44867, '2020-03-09', 'KW', 'Kuwait', 'EMRO', '0', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44868, '2020-03-10', 'KW', 'Kuwait', 'EMRO', '5', '73', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44869, '2020-03-11', 'KW', 'Kuwait', 'EMRO', '3', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44870, '2020-03-12', 'KW', 'Kuwait', 'EMRO', '8', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44871, '2020-03-13', 'KW', 'Kuwait', 'EMRO', '20', '104', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44872, '2020-03-14', 'KW', 'Kuwait', 'EMRO', '4', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44873, '2020-03-15', 'KW', 'Kuwait', 'EMRO', '8', '116', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44874, '2020-03-16', 'KW', 'Kuwait', 'EMRO', '11', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44875, '2020-03-17', 'KW', 'Kuwait', 'EMRO', '7', '134', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44876, '2020-03-18', 'KW', 'Kuwait', 'EMRO', '12', '146', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44877, '2020-03-19', 'KW', 'Kuwait', 'EMRO', '6', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44878, '2020-03-20', 'KW', 'Kuwait', 'EMRO', '7', '159', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44879, '2020-03-21', 'KW', 'Kuwait', 'EMRO', '17', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44880, '2020-03-22', 'KW', 'Kuwait', 'EMRO', '12', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44881, '2020-03-23', 'KW', 'Kuwait', 'EMRO', '1', '189', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44882, '2020-03-24', 'KW', 'Kuwait', 'EMRO', '2', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44883, '2020-03-25', 'KW', 'Kuwait', 'EMRO', '4', '195', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44884, '2020-03-26', 'KW', 'Kuwait', 'EMRO', '13', '208', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44885, '2020-03-27', 'KW', 'Kuwait', 'EMRO', '17', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44886, '2020-03-28', 'KW', 'Kuwait', 'EMRO', '10', '235', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44887, '2020-03-29', 'KW', 'Kuwait', 'EMRO', '20', '255', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44888, '2020-03-30', 'KW', 'Kuwait', 'EMRO', '11', '266', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44889, '2020-03-31', 'KW', 'Kuwait', 'EMRO', '23', '289', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44890, '2020-04-01', 'KW', 'Kuwait', 'EMRO', '28', '317', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44891, '2020-04-02', 'KW', 'Kuwait', 'EMRO', '25', '342', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44892, '2020-04-03', 'KW', 'Kuwait', 'EMRO', '75', '417', '0', '0');
INSERT INTO public.who_global_data_import VALUES (44893, '2020-04-04', 'KW', 'Kuwait', 'EMRO', '62', '479', '1', '1');
INSERT INTO public.who_global_data_import VALUES (44894, '2020-04-05', 'KW', 'Kuwait', 'EMRO', '77', '556', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44895, '2020-04-06', 'KW', 'Kuwait', 'EMRO', '109', '665', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44896, '2020-04-07', 'KW', 'Kuwait', 'EMRO', '78', '743', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44897, '2020-04-08', 'KW', 'Kuwait', 'EMRO', '112', '855', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44898, '2020-04-09', 'KW', 'Kuwait', 'EMRO', '55', '910', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44899, '2020-04-10', 'KW', 'Kuwait', 'EMRO', '83', '993', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44900, '2020-04-11', 'KW', 'Kuwait', 'EMRO', '161', '1154', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44901, '2020-04-12', 'KW', 'Kuwait', 'EMRO', '80', '1234', '0', '1');
INSERT INTO public.who_global_data_import VALUES (44902, '2020-04-13', 'KW', 'Kuwait', 'EMRO', '66', '1300', '1', '2');
INSERT INTO public.who_global_data_import VALUES (44903, '2020-04-14', 'KW', 'Kuwait', 'EMRO', '55', '1355', '1', '3');
INSERT INTO public.who_global_data_import VALUES (44904, '2020-04-15', 'KW', 'Kuwait', 'EMRO', '50', '1405', '0', '3');
INSERT INTO public.who_global_data_import VALUES (44905, '2020-04-16', 'KW', 'Kuwait', 'EMRO', '119', '1524', '0', '3');
INSERT INTO public.who_global_data_import VALUES (44906, '2020-04-17', 'KW', 'Kuwait', 'EMRO', '134', '1658', '2', '5');
INSERT INTO public.who_global_data_import VALUES (44907, '2020-04-18', 'KW', 'Kuwait', 'EMRO', '93', '1751', '1', '6');
INSERT INTO public.who_global_data_import VALUES (44908, '2020-04-19', 'KW', 'Kuwait', 'EMRO', '164', '1915', '1', '7');
INSERT INTO public.who_global_data_import VALUES (44909, '2020-04-20', 'KW', 'Kuwait', 'EMRO', '80', '1995', '2', '9');
INSERT INTO public.who_global_data_import VALUES (44910, '2020-04-21', 'KW', 'Kuwait', 'EMRO', '85', '2080', '2', '11');
INSERT INTO public.who_global_data_import VALUES (44911, '2020-04-22', 'KW', 'Kuwait', 'EMRO', '168', '2248', '2', '13');
INSERT INTO public.who_global_data_import VALUES (44912, '2020-04-23', 'KW', 'Kuwait', 'EMRO', '151', '2399', '1', '14');
INSERT INTO public.who_global_data_import VALUES (44913, '2020-04-24', 'KW', 'Kuwait', 'EMRO', '215', '2614', '1', '15');
INSERT INTO public.who_global_data_import VALUES (44914, '2020-04-25', 'KW', 'Kuwait', 'EMRO', '278', '2892', '4', '19');
INSERT INTO public.who_global_data_import VALUES (44915, '2020-04-26', 'KW', 'Kuwait', 'EMRO', '183', '3075', '1', '20');
INSERT INTO public.who_global_data_import VALUES (44916, '2020-04-27', 'KW', 'Kuwait', 'EMRO', '213', '3288', '2', '22');
INSERT INTO public.who_global_data_import VALUES (44917, '2020-04-28', 'KW', 'Kuwait', 'EMRO', '152', '3440', '1', '23');
INSERT INTO public.who_global_data_import VALUES (44918, '2020-04-29', 'KW', 'Kuwait', 'EMRO', '300', '3740', '1', '24');
INSERT INTO public.who_global_data_import VALUES (44919, '2020-04-30', 'KW', 'Kuwait', 'EMRO', '284', '4024', '2', '26');
INSERT INTO public.who_global_data_import VALUES (44920, '2020-05-01', 'KW', 'Kuwait', 'EMRO', '353', '4377', '4', '30');
INSERT INTO public.who_global_data_import VALUES (44921, '2020-05-02', 'KW', 'Kuwait', 'EMRO', '242', '4619', '3', '33');
INSERT INTO public.who_global_data_import VALUES (44922, '2020-05-03', 'KW', 'Kuwait', 'EMRO', '364', '4983', '5', '38');
INSERT INTO public.who_global_data_import VALUES (44923, '2020-05-04', 'KW', 'Kuwait', 'EMRO', '295', '5278', '2', '40');
INSERT INTO public.who_global_data_import VALUES (44924, '2020-05-05', 'KW', 'Kuwait', 'EMRO', '526', '5804', '0', '40');
INSERT INTO public.who_global_data_import VALUES (44925, '2020-05-06', 'KW', 'Kuwait', 'EMRO', '485', '6289', '2', '42');
INSERT INTO public.who_global_data_import VALUES (44926, '2020-05-07', 'KW', 'Kuwait', 'EMRO', '278', '6567', '2', '44');
INSERT INTO public.who_global_data_import VALUES (44927, '2020-05-08', 'KW', 'Kuwait', 'EMRO', '641', '7208', '3', '47');
INSERT INTO public.who_global_data_import VALUES (44928, '2020-05-09', 'KW', 'Kuwait', 'EMRO', '415', '7623', '2', '49');
INSERT INTO public.who_global_data_import VALUES (44929, '2020-05-10', 'KW', 'Kuwait', 'EMRO', '1065', '8688', '9', '58');
INSERT INTO public.who_global_data_import VALUES (44930, '2020-05-11', 'KW', 'Kuwait', 'EMRO', '598', '9286', '7', '65');
INSERT INTO public.who_global_data_import VALUES (44931, '2020-05-12', 'KW', 'Kuwait', 'EMRO', '991', '10277', '10', '75');
INSERT INTO public.who_global_data_import VALUES (44932, '2020-05-13', 'KW', 'Kuwait', 'EMRO', '751', '11028', '7', '82');
INSERT INTO public.who_global_data_import VALUES (44933, '2020-05-14', 'KW', 'Kuwait', 'EMRO', '947', '11975', '6', '88');
INSERT INTO public.who_global_data_import VALUES (44934, '2020-05-15', 'KW', 'Kuwait', 'EMRO', '885', '12860', '8', '96');
INSERT INTO public.who_global_data_import VALUES (44935, '2020-05-16', 'KW', 'Kuwait', 'EMRO', '942', '13802', '11', '107');
INSERT INTO public.who_global_data_import VALUES (44936, '2020-05-17', 'KW', 'Kuwait', 'EMRO', '1048', '14850', '5', '112');
INSERT INTO public.who_global_data_import VALUES (44937, '2020-05-18', 'KW', 'Kuwait', 'EMRO', '841', '15691', '6', '118');
INSERT INTO public.who_global_data_import VALUES (44938, '2020-05-19', 'KW', 'Kuwait', 'EMRO', '1073', '16764', '3', '121');
INSERT INTO public.who_global_data_import VALUES (44939, '2020-05-20', 'KW', 'Kuwait', 'EMRO', '804', '17568', '3', '124');
INSERT INTO public.who_global_data_import VALUES (44940, '2020-05-21', 'KW', 'Kuwait', 'EMRO', '1041', '18609', '5', '129');
INSERT INTO public.who_global_data_import VALUES (44941, '2020-05-22', 'KW', 'Kuwait', 'EMRO', '0', '18609', '0', '129');
INSERT INTO public.who_global_data_import VALUES (44942, '2020-05-23', 'KW', 'Kuwait', 'EMRO', '955', '19564', '9', '138');
INSERT INTO public.who_global_data_import VALUES (44943, '2020-05-24', 'KW', 'Kuwait', 'EMRO', '900', '20464', '10', '148');
INSERT INTO public.who_global_data_import VALUES (44944, '2020-05-25', 'KW', 'Kuwait', 'EMRO', '838', '21302', '8', '156');
INSERT INTO public.who_global_data_import VALUES (44945, '2020-05-26', 'KW', 'Kuwait', 'EMRO', '665', '21967', '9', '165');
INSERT INTO public.who_global_data_import VALUES (44946, '2020-05-27', 'KW', 'Kuwait', 'EMRO', '608', '22575', '7', '172');
INSERT INTO public.who_global_data_import VALUES (44947, '2020-05-28', 'KW', 'Kuwait', 'EMRO', '692', '23267', '3', '175');
INSERT INTO public.who_global_data_import VALUES (44948, '2020-05-29', 'KW', 'Kuwait', 'EMRO', '845', '24112', '10', '185');
INSERT INTO public.who_global_data_import VALUES (44949, '2020-05-30', 'KW', 'Kuwait', 'EMRO', '1072', '25184', '9', '194');
INSERT INTO public.who_global_data_import VALUES (44950, '2020-05-31', 'KW', 'Kuwait', 'EMRO', '1008', '26192', '11', '205');
INSERT INTO public.who_global_data_import VALUES (44951, '2020-06-01', 'KW', 'Kuwait', 'EMRO', '851', '27043', '7', '212');
INSERT INTO public.who_global_data_import VALUES (44952, '2020-06-02', 'KW', 'Kuwait', 'EMRO', '719', '27762', '8', '220');
INSERT INTO public.who_global_data_import VALUES (44953, '2020-06-03', 'KW', 'Kuwait', 'EMRO', '887', '28649', '6', '226');
INSERT INTO public.who_global_data_import VALUES (44954, '2020-06-04', 'KW', 'Kuwait', 'EMRO', '710', '29359', '4', '230');
INSERT INTO public.who_global_data_import VALUES (44955, '2020-06-05', 'KW', 'Kuwait', 'EMRO', '562', '29921', '6', '236');
INSERT INTO public.who_global_data_import VALUES (44956, '2020-06-06', 'KW', 'Kuwait', 'EMRO', '723', '30644', '8', '244');
INSERT INTO public.who_global_data_import VALUES (44957, '2020-06-07', 'KW', 'Kuwait', 'EMRO', '487', '31131', '10', '254');
INSERT INTO public.who_global_data_import VALUES (44958, '2020-06-08', 'KW', 'Kuwait', 'EMRO', '717', '31848', '10', '264');
INSERT INTO public.who_global_data_import VALUES (44959, '2020-06-09', 'KW', 'Kuwait', 'EMRO', '662', '32510', '5', '269');
INSERT INTO public.who_global_data_import VALUES (44960, '2020-06-10', 'KW', 'Kuwait', 'EMRO', '630', '33140', '4', '273');
INSERT INTO public.who_global_data_import VALUES (44961, '2020-06-11', 'KW', 'Kuwait', 'EMRO', '683', '33823', '2', '275');
INSERT INTO public.who_global_data_import VALUES (44962, '2020-06-12', 'KW', 'Kuwait', 'EMRO', '609', '34432', '4', '279');
INSERT INTO public.who_global_data_import VALUES (44963, '2020-06-13', 'KW', 'Kuwait', 'EMRO', '520', '34952', '6', '285');
INSERT INTO public.who_global_data_import VALUES (44964, '2020-06-14', 'KW', 'Kuwait', 'EMRO', '514', '35466', '4', '289');
INSERT INTO public.who_global_data_import VALUES (44965, '2020-06-15', 'KW', 'Kuwait', 'EMRO', '454', '35920', '7', '296');
INSERT INTO public.who_global_data_import VALUES (44966, '2020-06-16', 'KW', 'Kuwait', 'EMRO', '511', '36431', '2', '298');
INSERT INTO public.who_global_data_import VALUES (44967, '2020-06-17', 'KW', 'Kuwait', 'EMRO', '527', '36958', '5', '303');
INSERT INTO public.who_global_data_import VALUES (44968, '2020-06-18', 'KW', 'Kuwait', 'EMRO', '575', '37533', '3', '306');
INSERT INTO public.who_global_data_import VALUES (44969, '2020-06-19', 'KW', 'Kuwait', 'EMRO', '541', '38074', '2', '308');
INSERT INTO public.who_global_data_import VALUES (44970, '2020-06-20', 'KW', 'Kuwait', 'EMRO', '604', '38678', '5', '313');
INSERT INTO public.who_global_data_import VALUES (44971, '2020-06-21', 'KW', 'Kuwait', 'EMRO', '467', '39145', '6', '319');
INSERT INTO public.who_global_data_import VALUES (44972, '2020-06-22', 'KW', 'Kuwait', 'EMRO', '505', '39650', '7', '326');
INSERT INTO public.who_global_data_import VALUES (44973, '2020-06-23', 'KW', 'Kuwait', 'EMRO', '641', '40291', '4', '330');
INSERT INTO public.who_global_data_import VALUES (44974, '2020-06-24', 'KW', 'Kuwait', 'EMRO', '742', '41033', '4', '334');
INSERT INTO public.who_global_data_import VALUES (44975, '2020-06-25', 'KW', 'Kuwait', 'EMRO', '846', '41879', '3', '337');
INSERT INTO public.who_global_data_import VALUES (44976, '2020-06-26', 'KW', 'Kuwait', 'EMRO', '909', '42788', '2', '339');
INSERT INTO public.who_global_data_import VALUES (44977, '2020-06-27', 'KW', 'Kuwait', 'EMRO', '915', '43703', '2', '341');
INSERT INTO public.who_global_data_import VALUES (44978, '2020-06-28', 'KW', 'Kuwait', 'EMRO', '688', '44391', '3', '344');
INSERT INTO public.who_global_data_import VALUES (44979, '2020-06-29', 'KW', 'Kuwait', 'EMRO', '551', '44942', '4', '348');
INSERT INTO public.who_global_data_import VALUES (44980, '2020-06-30', 'KW', 'Kuwait', 'EMRO', '582', '45524', '2', '350');
INSERT INTO public.who_global_data_import VALUES (44981, '2020-07-01', 'KW', 'Kuwait', 'EMRO', '671', '46195', '4', '354');
INSERT INTO public.who_global_data_import VALUES (44982, '2020-07-02', 'KW', 'Kuwait', 'EMRO', '745', '46940', '4', '358');
INSERT INTO public.who_global_data_import VALUES (44983, '2020-07-03', 'KW', 'Kuwait', 'EMRO', '919', '47859', '1', '359');
INSERT INTO public.who_global_data_import VALUES (44984, '2020-07-04', 'KW', 'Kuwait', 'EMRO', '813', '48672', '1', '360');
INSERT INTO public.who_global_data_import VALUES (44985, '2020-07-05', 'KW', 'Kuwait', 'EMRO', '631', '49303', '5', '365');
INSERT INTO public.who_global_data_import VALUES (44986, '2020-07-06', 'KW', 'Kuwait', 'EMRO', '638', '49941', '3', '368');
INSERT INTO public.who_global_data_import VALUES (44987, '2020-07-07', 'KW', 'Kuwait', 'EMRO', '703', '50644', '5', '373');
INSERT INTO public.who_global_data_import VALUES (44988, '2020-07-08', 'KW', 'Kuwait', 'EMRO', '601', '51245', '4', '377');
INSERT INTO public.who_global_data_import VALUES (44989, '2020-07-09', 'KW', 'Kuwait', 'EMRO', '762', '52007', '2', '379');
INSERT INTO public.who_global_data_import VALUES (44990, '2020-07-10', 'KW', 'Kuwait', 'EMRO', '833', '52840', '3', '382');
INSERT INTO public.who_global_data_import VALUES (44991, '2020-07-11', 'KW', 'Kuwait', 'EMRO', '740', '53580', '1', '383');
INSERT INTO public.who_global_data_import VALUES (44992, '2020-07-12', 'KW', 'Kuwait', 'EMRO', '478', '54058', '3', '386');
INSERT INTO public.who_global_data_import VALUES (44993, '2020-07-13', 'KW', 'Kuwait', 'EMRO', '836', '54894', '4', '390');
INSERT INTO public.who_global_data_import VALUES (44994, '2020-07-14', 'KW', 'Kuwait', 'EMRO', '614', '55508', '3', '393');
INSERT INTO public.who_global_data_import VALUES (44995, '2020-07-15', 'KW', 'Kuwait', 'EMRO', '666', '56174', '3', '396');
INSERT INTO public.who_global_data_import VALUES (44996, '2020-07-16', 'KW', 'Kuwait', 'EMRO', '703', '56877', '3', '399');
INSERT INTO public.who_global_data_import VALUES (44997, '2020-07-17', 'KW', 'Kuwait', 'EMRO', '791', '57668', '3', '402');
INSERT INTO public.who_global_data_import VALUES (44998, '2020-07-18', 'KW', 'Kuwait', 'EMRO', '553', '58221', '2', '404');
INSERT INTO public.who_global_data_import VALUES (44999, '2020-07-19', 'KW', 'Kuwait', 'EMRO', '683', '58904', '3', '407');
INSERT INTO public.who_global_data_import VALUES (45000, '2020-07-20', 'KW', 'Kuwait', 'EMRO', '300', '59204', '1', '408');
INSERT INTO public.who_global_data_import VALUES (45001, '2020-07-21', 'KW', 'Kuwait', 'EMRO', '559', '59763', '0', '408');
INSERT INTO public.who_global_data_import VALUES (45002, '2020-07-22', 'KW', 'Kuwait', 'EMRO', '671', '60434', '4', '412');
INSERT INTO public.who_global_data_import VALUES (45003, '2020-07-23', 'KW', 'Kuwait', 'EMRO', '751', '61185', '5', '417');
INSERT INTO public.who_global_data_import VALUES (45004, '2020-07-24', 'KW', 'Kuwait', 'EMRO', '687', '61872', '4', '421');
INSERT INTO public.who_global_data_import VALUES (45005, '2020-07-25', 'KW', 'Kuwait', 'EMRO', '753', '62625', '4', '425');
INSERT INTO public.who_global_data_import VALUES (45006, '2020-07-26', 'KW', 'Kuwait', 'EMRO', '684', '63309', '4', '429');
INSERT INTO public.who_global_data_import VALUES (45007, '2020-07-27', 'KW', 'Kuwait', 'EMRO', '464', '63773', '4', '433');
INSERT INTO public.who_global_data_import VALUES (45008, '2020-07-28', 'KW', 'Kuwait', 'EMRO', '606', '64379', '5', '438');
INSERT INTO public.who_global_data_import VALUES (45009, '2020-07-29', 'KW', 'Kuwait', 'EMRO', '770', '65149', '4', '442');
INSERT INTO public.who_global_data_import VALUES (45010, '2020-07-30', 'KW', 'Kuwait', 'EMRO', '754', '65903', '2', '444');
INSERT INTO public.who_global_data_import VALUES (45011, '2020-07-31', 'KW', 'Kuwait', 'EMRO', '626', '66529', '1', '445');
INSERT INTO public.who_global_data_import VALUES (45012, '2020-08-01', 'KW', 'Kuwait', 'EMRO', '428', '66957', '2', '447');
INSERT INTO public.who_global_data_import VALUES (45013, '2020-08-02', 'KW', 'Kuwait', 'EMRO', '491', '67448', '6', '453');
INSERT INTO public.who_global_data_import VALUES (45014, '2020-08-03', 'KW', 'Kuwait', 'EMRO', '463', '67911', '4', '457');
INSERT INTO public.who_global_data_import VALUES (45015, '2020-08-04', 'KW', 'Kuwait', 'EMRO', '388', '68299', '4', '461');
INSERT INTO public.who_global_data_import VALUES (45016, '2020-08-05', 'KW', 'Kuwait', 'EMRO', '475', '68774', '4', '465');
INSERT INTO public.who_global_data_import VALUES (45017, '2020-08-06', 'KW', 'Kuwait', 'EMRO', '651', '69425', '3', '468');
INSERT INTO public.who_global_data_import VALUES (45018, '2020-08-07', 'KW', 'Kuwait', 'EMRO', '620', '70045', '1', '469');
INSERT INTO public.who_global_data_import VALUES (45019, '2020-08-08', 'KW', 'Kuwait', 'EMRO', '682', '70727', '2', '471');
INSERT INTO public.who_global_data_import VALUES (45020, '2020-08-09', 'KW', 'Kuwait', 'EMRO', '472', '71199', '3', '474');
INSERT INTO public.who_global_data_import VALUES (45021, '2020-08-10', 'KW', 'Kuwait', 'EMRO', '514', '71713', '4', '478');
INSERT INTO public.who_global_data_import VALUES (45022, '2020-08-11', 'KW', 'Kuwait', 'EMRO', '687', '72400', '4', '482');
INSERT INTO public.who_global_data_import VALUES (45023, '2020-08-12', 'KW', 'Kuwait', 'EMRO', '668', '73068', '4', '486');
INSERT INTO public.who_global_data_import VALUES (45024, '2020-08-13', 'KW', 'Kuwait', 'EMRO', '717', '73785', '3', '489');
INSERT INTO public.who_global_data_import VALUES (45025, '2020-08-14', 'KW', 'Kuwait', 'EMRO', '701', '74486', '0', '489');
INSERT INTO public.who_global_data_import VALUES (45026, '2020-08-15', 'KW', 'Kuwait', 'EMRO', '699', '75185', '5', '494');
INSERT INTO public.who_global_data_import VALUES (45027, '2020-08-16', 'KW', 'Kuwait', 'EMRO', '512', '75697', '4', '498');
INSERT INTO public.who_global_data_import VALUES (45028, '2020-08-17', 'KW', 'Kuwait', 'EMRO', '508', '76205', '3', '501');
INSERT INTO public.who_global_data_import VALUES (45029, '2020-08-18', 'KW', 'Kuwait', 'EMRO', '622', '76827', '1', '502');
INSERT INTO public.who_global_data_import VALUES (45030, '2020-08-19', 'KW', 'Kuwait', 'EMRO', '643', '77470', '3', '505');
INSERT INTO public.who_global_data_import VALUES (45031, '2020-08-20', 'KW', 'Kuwait', 'EMRO', '675', '78145', '2', '507');
INSERT INTO public.who_global_data_import VALUES (45032, '2020-08-21', 'KW', 'Kuwait', 'EMRO', '622', '78767', '2', '509');
INSERT INTO public.who_global_data_import VALUES (45033, '2020-08-22', 'KW', 'Kuwait', 'EMRO', '502', '79269', '2', '511');
INSERT INTO public.who_global_data_import VALUES (45034, '2020-08-23', 'KW', 'Kuwait', 'EMRO', '688', '79957', '2', '513');
INSERT INTO public.who_global_data_import VALUES (45035, '2020-08-24', 'KW', 'Kuwait', 'EMRO', '571', '80528', '2', '515');
INSERT INTO public.who_global_data_import VALUES (45036, '2020-08-25', 'KW', 'Kuwait', 'EMRO', '432', '80960', '3', '518');
INSERT INTO public.who_global_data_import VALUES (45037, '2020-08-26', 'KW', 'Kuwait', 'EMRO', '613', '81573', '1', '519');
INSERT INTO public.who_global_data_import VALUES (45038, '2020-08-27', 'KW', 'Kuwait', 'EMRO', '698', '82271', '2', '521');
INSERT INTO public.who_global_data_import VALUES (45039, '2020-08-28', 'KW', 'Kuwait', 'EMRO', '674', '82945', '1', '522');
INSERT INTO public.who_global_data_import VALUES (45040, '2020-08-29', 'KW', 'Kuwait', 'EMRO', '633', '83578', '3', '525');
INSERT INTO public.who_global_data_import VALUES (45041, '2020-08-30', 'KW', 'Kuwait', 'EMRO', '646', '84224', '3', '528');
INSERT INTO public.who_global_data_import VALUES (45042, '2020-08-31', 'KW', 'Kuwait', 'EMRO', '412', '84636', '2', '530');
INSERT INTO public.who_global_data_import VALUES (45043, '2020-09-01', 'KW', 'Kuwait', 'EMRO', '473', '85109', '1', '531');
INSERT INTO public.who_global_data_import VALUES (45044, '2020-09-02', 'KW', 'Kuwait', 'EMRO', '702', '85811', '3', '534');
INSERT INTO public.who_global_data_import VALUES (45045, '2020-09-03', 'KW', 'Kuwait', 'EMRO', '667', '86478', '1', '535');
INSERT INTO public.who_global_data_import VALUES (45046, '2020-09-04', 'KW', 'Kuwait', 'EMRO', '900', '87378', '1', '536');
INSERT INTO public.who_global_data_import VALUES (45047, '2020-09-05', 'KW', 'Kuwait', 'EMRO', '865', '88243', '1', '537');
INSERT INTO public.who_global_data_import VALUES (45048, '2020-09-06', 'KW', 'Kuwait', 'EMRO', '720', '88963', '3', '540');
INSERT INTO public.who_global_data_import VALUES (45049, '2020-09-07', 'KW', 'Kuwait', 'EMRO', '619', '89582', '4', '544');
INSERT INTO public.who_global_data_import VALUES (45050, '2020-09-08', 'KW', 'Kuwait', 'EMRO', '805', '90387', '2', '546');
INSERT INTO public.who_global_data_import VALUES (45051, '2020-09-09', 'KW', 'Kuwait', 'EMRO', '857', '91244', '2', '548');
INSERT INTO public.who_global_data_import VALUES (45052, '2020-09-10', 'KW', 'Kuwait', 'EMRO', '838', '92082', '4', '552');
INSERT INTO public.who_global_data_import VALUES (45053, '2020-09-11', 'KW', 'Kuwait', 'EMRO', '740', '92822', '4', '556');
INSERT INTO public.who_global_data_import VALUES (45054, '2020-09-12', 'KW', 'Kuwait', 'EMRO', '653', '93475', '1', '557');
INSERT INTO public.who_global_data_import VALUES (45055, '2020-09-13', 'KW', 'Kuwait', 'EMRO', '736', '94211', '1', '558');
INSERT INTO public.who_global_data_import VALUES (45056, '2020-09-14', 'KW', 'Kuwait', 'EMRO', '553', '94764', '2', '560');
INSERT INTO public.who_global_data_import VALUES (45057, '2020-09-15', 'KW', 'Kuwait', 'EMRO', '708', '95472', '3', '563');
INSERT INTO public.who_global_data_import VALUES (45058, '2020-09-16', 'KW', 'Kuwait', 'EMRO', '829', '96301', '5', '568');
INSERT INTO public.who_global_data_import VALUES (45059, '2020-09-17', 'KW', 'Kuwait', 'EMRO', '698', '96999', '3', '571');
INSERT INTO public.who_global_data_import VALUES (45060, '2020-09-18', 'KW', 'Kuwait', 'EMRO', '825', '97824', '4', '575');
INSERT INTO public.who_global_data_import VALUES (45061, '2020-09-19', 'KW', 'Kuwait', 'EMRO', '704', '98528', '5', '580');
INSERT INTO public.who_global_data_import VALUES (45062, '2020-09-20', 'KW', 'Kuwait', 'EMRO', '521', '99049', '1', '581');
INSERT INTO public.who_global_data_import VALUES (45063, '2020-09-21', 'KW', 'Kuwait', 'EMRO', '385', '99434', '3', '584');
INSERT INTO public.who_global_data_import VALUES (45064, '2020-09-22', 'KW', 'Kuwait', 'EMRO', '530', '99964', '1', '585');
INSERT INTO public.who_global_data_import VALUES (45065, '2020-09-23', 'KW', 'Kuwait', 'EMRO', '719', '100683', '3', '588');
INSERT INTO public.who_global_data_import VALUES (45066, '2020-09-24', 'KW', 'Kuwait', 'EMRO', '616', '101299', '2', '590');
INSERT INTO public.who_global_data_import VALUES (45067, '2020-09-25', 'KW', 'Kuwait', 'EMRO', '552', '101851', '2', '592');
INSERT INTO public.who_global_data_import VALUES (45068, '2020-09-26', 'KW', 'Kuwait', 'EMRO', '590', '102441', '3', '595');
INSERT INTO public.who_global_data_import VALUES (45069, '2020-09-27', 'KW', 'Kuwait', 'EMRO', '758', '103199', '2', '597');
INSERT INTO public.who_global_data_import VALUES (45070, '2020-09-28', 'KW', 'Kuwait', 'EMRO', '345', '103544', '4', '601');
INSERT INTO public.who_global_data_import VALUES (45071, '2020-09-29', 'KW', 'Kuwait', 'EMRO', '437', '103981', '4', '605');
INSERT INTO public.who_global_data_import VALUES (45072, '2020-09-30', 'KW', 'Kuwait', 'EMRO', '587', '104568', '2', '607');
INSERT INTO public.who_global_data_import VALUES (45073, '2020-10-01', 'KW', 'Kuwait', 'EMRO', '614', '105182', '3', '610');
INSERT INTO public.who_global_data_import VALUES (45074, '2020-10-02', 'KW', 'Kuwait', 'EMRO', '494', '105676', '2', '612');
INSERT INTO public.who_global_data_import VALUES (45075, '2020-10-03', 'KW', 'Kuwait', 'EMRO', '411', '106087', '3', '615');
INSERT INTO public.who_global_data_import VALUES (45076, '2020-10-04', 'KW', 'Kuwait', 'EMRO', '371', '106458', '5', '620');
INSERT INTO public.who_global_data_import VALUES (45077, '2020-10-05', 'KW', 'Kuwait', 'EMRO', '567', '107025', '4', '624');
INSERT INTO public.who_global_data_import VALUES (45078, '2020-10-06', 'KW', 'Kuwait', 'EMRO', '567', '107592', '4', '628');
INSERT INTO public.who_global_data_import VALUES (45079, '2020-10-07', 'KW', 'Kuwait', 'EMRO', '676', '108268', '4', '632');
INSERT INTO public.who_global_data_import VALUES (45080, '2020-10-08', 'KW', 'Kuwait', 'EMRO', '475', '108743', '7', '639');
INSERT INTO public.who_global_data_import VALUES (45081, '2020-10-09', 'KW', 'Kuwait', 'EMRO', '698', '109441', '3', '642');
INSERT INTO public.who_global_data_import VALUES (45082, '2020-10-10', 'KW', 'Kuwait', 'EMRO', '635', '110076', '7', '649');
INSERT INTO public.who_global_data_import VALUES (45083, '2020-10-11', 'KW', 'Kuwait', 'EMRO', '492', '110568', '6', '655');
INSERT INTO public.who_global_data_import VALUES (45084, '2020-10-12', 'KW', 'Kuwait', 'EMRO', '548', '111116', '3', '658');
INSERT INTO public.who_global_data_import VALUES (45085, '2020-10-13', 'KW', 'Kuwait', 'EMRO', '777', '111893', '6', '664');
INSERT INTO public.who_global_data_import VALUES (45086, '2020-10-14', 'KW', 'Kuwait', 'EMRO', '844', '112737', '8', '672');
INSERT INTO public.who_global_data_import VALUES (45087, '2020-10-15', 'KW', 'Kuwait', 'EMRO', '532', '113269', '4', '676');
INSERT INTO public.who_global_data_import VALUES (45088, '2020-10-16', 'KW', 'Kuwait', 'EMRO', '746', '114015', '8', '684');
INSERT INTO public.who_global_data_import VALUES (45089, '2020-10-17', 'KW', 'Kuwait', 'EMRO', '729', '114744', '6', '690');
INSERT INTO public.who_global_data_import VALUES (45090, '2020-10-18', 'KW', 'Kuwait', 'EMRO', '739', '115483', '4', '694');
INSERT INTO public.who_global_data_import VALUES (45091, '2020-10-19', 'KW', 'Kuwait', 'EMRO', '663', '116146', '7', '701');
INSERT INTO public.who_global_data_import VALUES (45092, '2020-10-20', 'KW', 'Kuwait', 'EMRO', '686', '116832', '9', '710');
INSERT INTO public.who_global_data_import VALUES (45093, '2020-10-21', 'KW', 'Kuwait', 'EMRO', '886', '117718', '4', '714');
INSERT INTO public.who_global_data_import VALUES (45094, '2020-10-22', 'KW', 'Kuwait', 'EMRO', '813', '118531', '7', '721');
INSERT INTO public.who_global_data_import VALUES (45095, '2020-10-23', 'KW', 'Kuwait', 'EMRO', '889', '119420', '9', '730');
INSERT INTO public.who_global_data_import VALUES (45096, '2020-10-24', 'KW', 'Kuwait', 'EMRO', '812', '120232', '10', '740');
INSERT INTO public.who_global_data_import VALUES (45097, '2020-10-25', 'KW', 'Kuwait', 'EMRO', '695', '120927', '4', '744');
INSERT INTO public.who_global_data_import VALUES (45098, '2020-10-26', 'KW', 'Kuwait', 'EMRO', '708', '121635', '2', '746');
INSERT INTO public.who_global_data_import VALUES (45099, '2020-10-27', 'KW', 'Kuwait', 'EMRO', '682', '122317', '3', '749');
INSERT INTO public.who_global_data_import VALUES (45100, '2020-10-28', 'KW', 'Kuwait', 'EMRO', '775', '123092', '7', '756');
INSERT INTO public.who_global_data_import VALUES (45101, '2020-10-29', 'KW', 'Kuwait', 'EMRO', '814', '123906', '7', '763');
INSERT INTO public.who_global_data_import VALUES (45102, '2020-10-30', 'KW', 'Kuwait', 'EMRO', '760', '124666', '4', '767');
INSERT INTO public.who_global_data_import VALUES (45103, '2020-10-31', 'KW', 'Kuwait', 'EMRO', '671', '125337', '6', '773');
INSERT INTO public.who_global_data_import VALUES (45104, '2020-11-01', 'KW', 'Kuwait', 'EMRO', '589', '125926', '6', '779');
INSERT INTO public.who_global_data_import VALUES (45105, '2020-11-02', 'KW', 'Kuwait', 'EMRO', '608', '126534', '3', '782');
INSERT INTO public.who_global_data_import VALUES (45106, '2020-11-03', 'KW', 'Kuwait', 'EMRO', '759', '127293', '4', '786');
INSERT INTO public.who_global_data_import VALUES (45107, '2020-11-04', 'KW', 'Kuwait', 'EMRO', '787', '128080', '3', '789');
INSERT INTO public.who_global_data_import VALUES (45108, '2020-11-05', 'KW', 'Kuwait', 'EMRO', '763', '128843', '5', '794');
INSERT INTO public.who_global_data_import VALUES (45109, '2020-11-06', 'KW', 'Kuwait', 'EMRO', '795', '129638', '5', '799');
INSERT INTO public.who_global_data_import VALUES (45110, '2020-11-07', 'KW', 'Kuwait', 'EMRO', '825', '130463', '5', '804');
INSERT INTO public.who_global_data_import VALUES (45111, '2020-11-08', 'KW', 'Kuwait', 'EMRO', '742', '131205', '4', '808');
INSERT INTO public.who_global_data_import VALUES (45112, '2020-11-09', 'KW', 'Kuwait', 'EMRO', '538', '131743', '3', '811');
INSERT INTO public.who_global_data_import VALUES (45113, '2020-11-10', 'KW', 'Kuwait', 'EMRO', '735', '132478', '5', '816');
INSERT INTO public.who_global_data_import VALUES (45114, '2020-11-11', 'KW', 'Kuwait', 'EMRO', '903', '133381', '5', '821');
INSERT INTO public.who_global_data_import VALUES (45115, '2020-11-12', 'KW', 'Kuwait', 'EMRO', '778', '134159', '5', '826');
INSERT INTO public.who_global_data_import VALUES (45116, '2020-11-13', 'KW', 'Kuwait', 'EMRO', '773', '134932', '4', '830');
INSERT INTO public.who_global_data_import VALUES (45117, '2020-11-14', 'KW', 'Kuwait', 'EMRO', '718', '135650', '3', '833');
INSERT INTO public.who_global_data_import VALUES (45118, '2020-11-15', 'KW', 'Kuwait', 'EMRO', '691', '136341', '2', '835');
INSERT INTO public.who_global_data_import VALUES (45119, '2020-11-16', 'KW', 'Kuwait', 'EMRO', '499', '136840', '3', '838');
INSERT INTO public.who_global_data_import VALUES (45120, '2020-11-17', 'KW', 'Kuwait', 'EMRO', '489', '137329', '4', '842');
INSERT INTO public.who_global_data_import VALUES (45121, '2020-11-18', 'KW', 'Kuwait', 'EMRO', '556', '137885', '6', '848');
INSERT INTO public.who_global_data_import VALUES (45122, '2020-11-19', 'KW', 'Kuwait', 'EMRO', '452', '138337', '9', '857');
INSERT INTO public.who_global_data_import VALUES (45123, '2020-11-20', 'KW', 'Kuwait', 'EMRO', '485', '138822', '2', '859');
INSERT INTO public.who_global_data_import VALUES (45124, '2020-11-21', 'KW', 'Kuwait', 'EMRO', '486', '139308', '2', '861');
INSERT INTO public.who_global_data_import VALUES (45125, '2020-11-22', 'KW', 'Kuwait', 'EMRO', '426', '139734', '2', '863');
INSERT INTO public.who_global_data_import VALUES (45126, '2020-11-23', 'KW', 'Kuwait', 'EMRO', '322', '140056', '3', '866');
INSERT INTO public.who_global_data_import VALUES (45127, '2020-11-24', 'KW', 'Kuwait', 'EMRO', '337', '140393', '2', '868');
INSERT INTO public.who_global_data_import VALUES (45128, '2020-11-25', 'KW', 'Kuwait', 'EMRO', '402', '140795', '2', '870');
INSERT INTO public.who_global_data_import VALUES (45129, '2020-11-26', 'KW', 'Kuwait', 'EMRO', '422', '141217', '1', '871');
INSERT INTO public.who_global_data_import VALUES (45130, '2020-11-27', 'KW', 'Kuwait', 'EMRO', '330', '141547', '1', '872');
INSERT INTO public.who_global_data_import VALUES (45131, '2020-11-28', 'KW', 'Kuwait', 'EMRO', '329', '141876', '2', '874');
INSERT INTO public.who_global_data_import VALUES (45132, '2020-11-29', 'KW', 'Kuwait', 'EMRO', '319', '142195', '1', '875');
INSERT INTO public.who_global_data_import VALUES (45133, '2020-11-30', 'KW', 'Kuwait', 'EMRO', '231', '142426', '3', '878');
INSERT INTO public.who_global_data_import VALUES (45134, '2020-12-01', 'KW', 'Kuwait', 'EMRO', '209', '142635', '2', '880');
INSERT INTO public.who_global_data_import VALUES (45135, '2020-12-02', 'KW', 'Kuwait', 'EMRO', '357', '142992', '1', '881');
INSERT INTO public.who_global_data_import VALUES (45136, '2020-12-03', 'KW', 'Kuwait', 'EMRO', '268', '143260', '1', '882');
INSERT INTO public.who_global_data_import VALUES (45137, '2020-12-04', 'KW', 'Kuwait', 'EMRO', '314', '143574', '2', '884');
INSERT INTO public.who_global_data_import VALUES (45138, '2020-12-05', 'KW', 'Kuwait', 'EMRO', '343', '143917', '2', '886');
INSERT INTO public.who_global_data_import VALUES (45139, '2020-12-06', 'KW', 'Kuwait', 'EMRO', '247', '144164', '3', '889');
INSERT INTO public.who_global_data_import VALUES (45140, '2020-12-07', 'KW', 'Kuwait', 'EMRO', '205', '144369', '2', '891');
INSERT INTO public.who_global_data_import VALUES (45141, '2020-12-08', 'KW', 'Kuwait', 'EMRO', '230', '144599', '6', '897');
INSERT INTO public.who_global_data_import VALUES (45142, '2020-12-09', 'KW', 'Kuwait', 'EMRO', '301', '144900', '3', '900');
INSERT INTO public.who_global_data_import VALUES (45143, '2020-12-10', 'KW', 'Kuwait', 'EMRO', '304', '145204', '5', '905');
INSERT INTO public.who_global_data_import VALUES (45144, '2020-12-11', 'KW', 'Kuwait', 'EMRO', '291', '145495', '5', '910');
INSERT INTO public.who_global_data_import VALUES (45145, '2020-12-12', 'KW', 'Kuwait', 'EMRO', '294', '145789', '0', '910');
INSERT INTO public.who_global_data_import VALUES (45146, '2020-12-13', 'KW', 'Kuwait', 'EMRO', '255', '146044', '1', '911');
INSERT INTO public.who_global_data_import VALUES (45147, '2020-12-14', 'KW', 'Kuwait', 'EMRO', '174', '146218', '0', '911');
INSERT INTO public.who_global_data_import VALUES (45148, '2020-12-15', 'KW', 'Kuwait', 'EMRO', '231', '146449', '1', '912');
INSERT INTO public.who_global_data_import VALUES (45149, '2020-12-16', 'KW', 'Kuwait', 'EMRO', '261', '146710', '1', '913');
INSERT INTO public.who_global_data_import VALUES (45150, '2020-12-17', 'KW', 'Kuwait', 'EMRO', '261', '146971', '0', '913');
INSERT INTO public.who_global_data_import VALUES (45151, '2020-12-18', 'KW', 'Kuwait', 'EMRO', '221', '147192', '0', '913');
INSERT INTO public.who_global_data_import VALUES (45152, '2020-12-19', 'KW', 'Kuwait', 'EMRO', '339', '147531', '3', '916');
INSERT INTO public.who_global_data_import VALUES (45153, '2020-12-20', 'KW', 'Kuwait', 'EMRO', '244', '147775', '2', '918');
INSERT INTO public.who_global_data_import VALUES (45154, '2020-12-21', 'KW', 'Kuwait', 'EMRO', '204', '147979', '3', '921');
INSERT INTO public.who_global_data_import VALUES (45155, '2020-12-22', 'KW', 'Kuwait', 'EMRO', '230', '148209', '1', '922');
INSERT INTO public.who_global_data_import VALUES (45156, '2020-12-23', 'KW', 'Kuwait', 'EMRO', '298', '148507', '1', '923');
INSERT INTO public.who_global_data_import VALUES (45157, '2020-12-24', 'KW', 'Kuwait', 'EMRO', '266', '148773', '1', '924');
INSERT INTO public.who_global_data_import VALUES (45158, '2020-12-25', 'KW', 'Kuwait', 'EMRO', '244', '149017', '2', '926');
INSERT INTO public.who_global_data_import VALUES (45159, '2020-12-26', 'KW', 'Kuwait', 'EMRO', '260', '149277', '0', '926');
INSERT INTO public.who_global_data_import VALUES (45160, '2020-12-27', 'KW', 'Kuwait', 'EMRO', '172', '149449', '3', '929');
INSERT INTO public.who_global_data_import VALUES (45161, '2020-12-28', 'KW', 'Kuwait', 'EMRO', '204', '149653', '2', '931');
INSERT INTO public.who_global_data_import VALUES (45162, '2020-12-29', 'KW', 'Kuwait', 'EMRO', '204', '149857', '1', '932');
INSERT INTO public.who_global_data_import VALUES (45163, '2020-12-30', 'KW', 'Kuwait', 'EMRO', '236', '150093', '0', '932');
INSERT INTO public.who_global_data_import VALUES (45164, '2020-12-31', 'KW', 'Kuwait', 'EMRO', '205', '150298', '1', '933');
INSERT INTO public.who_global_data_import VALUES (45165, '2021-01-01', 'KW', 'Kuwait', 'EMRO', '286', '150584', '1', '934');
INSERT INTO public.who_global_data_import VALUES (45166, '2021-01-02', 'KW', 'Kuwait', 'EMRO', '285', '150869', '2', '936');
INSERT INTO public.who_global_data_import VALUES (45167, '2021-01-03', 'KW', 'Kuwait', 'EMRO', '205', '151074', '1', '937');
INSERT INTO public.who_global_data_import VALUES (45168, '2021-01-04', 'KW', 'Kuwait', 'EMRO', '269', '151343', '0', '937');
INSERT INTO public.who_global_data_import VALUES (45169, '2021-01-05', 'KW', 'Kuwait', 'EMRO', '372', '151715', '1', '938');
INSERT INTO public.who_global_data_import VALUES (45170, '2021-01-06', 'KW', 'Kuwait', 'EMRO', '312', '152027', '0', '938');
INSERT INTO public.who_global_data_import VALUES (45171, '2021-01-07', 'KW', 'Kuwait', 'EMRO', '411', '152438', '0', '938');
INSERT INTO public.who_global_data_import VALUES (45172, '2021-01-08', 'KW', 'Kuwait', 'EMRO', '540', '152978', '0', '938');
INSERT INTO public.who_global_data_import VALUES (45173, '2021-01-09', 'KW', 'Kuwait', 'EMRO', '495', '153473', '2', '940');
INSERT INTO public.who_global_data_import VALUES (45174, '2021-01-10', 'KW', 'Kuwait', 'EMRO', '427', '153900', '2', '942');
INSERT INTO public.who_global_data_import VALUES (45175, '2021-01-11', 'KW', 'Kuwait', 'EMRO', '414', '154314', '1', '943');
INSERT INTO public.who_global_data_import VALUES (45176, '2021-01-12', 'KW', 'Kuwait', 'EMRO', '527', '154841', '2', '945');
INSERT INTO public.who_global_data_import VALUES (45177, '2021-01-13', 'KW', 'Kuwait', 'EMRO', '494', '155335', '1', '946');
INSERT INTO public.who_global_data_import VALUES (45178, '2021-01-14', 'KW', 'Kuwait', 'EMRO', '539', '155874', '0', '946');
INSERT INTO public.who_global_data_import VALUES (45179, '2021-01-15', 'KW', 'Kuwait', 'EMRO', '560', '156434', '0', '946');
INSERT INTO public.who_global_data_import VALUES (45180, '2021-01-16', 'KW', 'Kuwait', 'EMRO', '530', '156964', '1', '947');
INSERT INTO public.who_global_data_import VALUES (45181, '2021-01-17', 'KW', 'Kuwait', 'EMRO', '435', '157399', '0', '947');
INSERT INTO public.who_global_data_import VALUES (45182, '2021-01-18', 'KW', 'Kuwait', 'EMRO', '378', '157777', '0', '947');
INSERT INTO public.who_global_data_import VALUES (45183, '2021-01-19', 'KW', 'Kuwait', 'EMRO', '467', '158244', '1', '948');
INSERT INTO public.who_global_data_import VALUES (45184, '2021-01-20', 'KW', 'Kuwait', 'EMRO', '578', '158822', '2', '950');
INSERT INTO public.who_global_data_import VALUES (45185, '2021-01-21', 'KW', 'Kuwait', 'EMRO', '442', '159264', '1', '951');
INSERT INTO public.who_global_data_import VALUES (45186, '2021-01-22', 'KW', 'Kuwait', 'EMRO', '570', '159834', '0', '951');
INSERT INTO public.who_global_data_import VALUES (45187, '2021-01-23', 'KW', 'Kuwait', 'EMRO', '533', '160367', '1', '952');
INSERT INTO public.who_global_data_import VALUES (45188, '2021-01-24', 'KW', 'Kuwait', 'EMRO', '534', '160901', '0', '952');
INSERT INTO public.who_global_data_import VALUES (45189, '2021-01-25', 'KW', 'Kuwait', 'EMRO', '384', '161285', '0', '952');
INSERT INTO public.who_global_data_import VALUES (45190, '2021-01-26', 'KW', 'Kuwait', 'EMRO', '492', '161777', '2', '954');
INSERT INTO public.who_global_data_import VALUES (45191, '2021-01-27', 'KW', 'Kuwait', 'EMRO', '505', '162282', '3', '957');
INSERT INTO public.who_global_data_import VALUES (45192, '2021-01-28', 'KW', 'Kuwait', 'EMRO', '580', '162862', '0', '957');
INSERT INTO public.who_global_data_import VALUES (45193, '2021-01-29', 'KW', 'Kuwait', 'EMRO', '588', '163450', '1', '958');
INSERT INTO public.who_global_data_import VALUES (45194, '2021-01-30', 'KW', 'Kuwait', 'EMRO', '658', '164108', '0', '958');
INSERT INTO public.who_global_data_import VALUES (45195, '2021-01-31', 'KW', 'Kuwait', 'EMRO', '514', '164622', '1', '959');
INSERT INTO public.who_global_data_import VALUES (45196, '2021-02-01', 'KW', 'Kuwait', 'EMRO', '635', '165257', '0', '959');
INSERT INTO public.who_global_data_import VALUES (45197, '2021-02-02', 'KW', 'Kuwait', 'EMRO', '586', '165843', '0', '959');
INSERT INTO public.who_global_data_import VALUES (45198, '2021-02-03', 'KW', 'Kuwait', 'EMRO', '811', '166654', '0', '959');
INSERT INTO public.who_global_data_import VALUES (45199, '2021-02-04', 'KW', 'Kuwait', 'EMRO', '756', '167410', '2', '961');
INSERT INTO public.who_global_data_import VALUES (45200, '2021-02-05', 'KW', 'Kuwait', 'EMRO', '840', '168250', '1', '962');
INSERT INTO public.who_global_data_import VALUES (45201, '2020-01-03', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45202, '2020-01-04', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45203, '2020-01-05', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45204, '2020-01-06', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45205, '2020-01-07', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45206, '2020-01-08', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45207, '2020-01-09', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45208, '2020-01-10', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45209, '2020-01-11', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45210, '2020-01-12', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45211, '2020-01-13', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45212, '2020-01-14', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45213, '2020-01-15', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45214, '2020-01-16', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45215, '2020-01-17', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45216, '2020-01-18', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45217, '2020-01-19', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45218, '2020-01-20', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45219, '2020-01-21', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45220, '2020-01-22', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45221, '2020-01-23', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45222, '2020-01-24', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45223, '2020-01-25', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45224, '2020-01-26', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45225, '2020-01-27', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45226, '2020-01-28', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45227, '2020-01-29', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45228, '2020-01-30', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45229, '2020-01-31', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45230, '2020-02-01', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45231, '2020-02-02', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45232, '2020-02-03', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45233, '2020-02-04', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45234, '2020-02-05', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45235, '2020-02-06', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45236, '2020-02-07', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45237, '2020-02-08', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45238, '2020-02-09', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45239, '2020-02-10', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45240, '2020-02-11', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45241, '2020-02-12', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45242, '2020-02-13', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45243, '2020-02-14', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45244, '2020-02-15', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45245, '2020-02-16', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45246, '2020-02-17', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45247, '2020-02-18', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45248, '2020-02-19', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45249, '2020-02-20', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45250, '2020-02-21', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45251, '2020-02-22', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45252, '2020-02-23', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45253, '2020-02-24', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45254, '2020-02-25', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45255, '2020-02-26', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45256, '2020-02-27', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45257, '2020-02-28', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45258, '2020-02-29', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45259, '2020-03-01', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45260, '2020-03-02', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45261, '2020-03-03', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45262, '2020-03-04', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45263, '2020-03-05', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45264, '2020-03-06', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45265, '2020-03-07', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45266, '2020-03-08', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45267, '2020-03-09', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45268, '2020-03-10', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45269, '2020-03-11', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45270, '2020-03-12', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45271, '2020-03-13', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45272, '2020-03-14', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45273, '2020-03-15', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45274, '2020-03-16', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45275, '2020-03-17', 'KG', 'Kyrgyzstan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45276, '2020-03-18', 'KG', 'Kyrgyzstan', 'EURO', '3', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45277, '2020-03-19', 'KG', 'Kyrgyzstan', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45278, '2020-03-20', 'KG', 'Kyrgyzstan', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45279, '2020-03-21', 'KG', 'Kyrgyzstan', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45280, '2020-03-22', 'KG', 'Kyrgyzstan', 'EURO', '11', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45281, '2020-03-23', 'KG', 'Kyrgyzstan', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45282, '2020-03-24', 'KG', 'Kyrgyzstan', 'EURO', '2', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45283, '2020-03-25', 'KG', 'Kyrgyzstan', 'EURO', '26', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45284, '2020-03-26', 'KG', 'Kyrgyzstan', 'EURO', '2', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45285, '2020-03-27', 'KG', 'Kyrgyzstan', 'EURO', '14', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45286, '2020-03-28', 'KG', 'Kyrgyzstan', 'EURO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45287, '2020-03-29', 'KG', 'Kyrgyzstan', 'EURO', '26', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45288, '2020-03-30', 'KG', 'Kyrgyzstan', 'EURO', '0', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45289, '2020-03-31', 'KG', 'Kyrgyzstan', 'EURO', '23', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45290, '2020-04-01', 'KG', 'Kyrgyzstan', 'EURO', '4', '111', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45291, '2020-04-02', 'KG', 'Kyrgyzstan', 'EURO', '4', '115', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45292, '2020-04-03', 'KG', 'Kyrgyzstan', 'EURO', '15', '130', '1', '1');
INSERT INTO public.who_global_data_import VALUES (45293, '2020-04-04', 'KG', 'Kyrgyzstan', 'EURO', '14', '144', '0', '1');
INSERT INTO public.who_global_data_import VALUES (45294, '2020-04-05', 'KG', 'Kyrgyzstan', 'EURO', '3', '147', '0', '1');
INSERT INTO public.who_global_data_import VALUES (45295, '2020-04-06', 'KG', 'Kyrgyzstan', 'EURO', '69', '216', '3', '4');
INSERT INTO public.who_global_data_import VALUES (45296, '2020-04-07', 'KG', 'Kyrgyzstan', 'EURO', '12', '228', '0', '4');
INSERT INTO public.who_global_data_import VALUES (45297, '2020-04-08', 'KG', 'Kyrgyzstan', 'EURO', '42', '270', '0', '4');
INSERT INTO public.who_global_data_import VALUES (45298, '2020-04-09', 'KG', 'Kyrgyzstan', 'EURO', '10', '280', '0', '4');
INSERT INTO public.who_global_data_import VALUES (45299, '2020-04-10', 'KG', 'Kyrgyzstan', 'EURO', '18', '298', '1', '5');
INSERT INTO public.who_global_data_import VALUES (45300, '2020-04-11', 'KG', 'Kyrgyzstan', 'EURO', '41', '339', '0', '5');
INSERT INTO public.who_global_data_import VALUES (45301, '2020-04-12', 'KG', 'Kyrgyzstan', 'EURO', '38', '377', '0', '5');
INSERT INTO public.who_global_data_import VALUES (45302, '2020-04-13', 'KG', 'Kyrgyzstan', 'EURO', '42', '419', '0', '5');
INSERT INTO public.who_global_data_import VALUES (45303, '2020-04-14', 'KG', 'Kyrgyzstan', 'EURO', '11', '430', '0', '5');
INSERT INTO public.who_global_data_import VALUES (45304, '2020-04-15', 'KG', 'Kyrgyzstan', 'EURO', '19', '449', '0', '5');
INSERT INTO public.who_global_data_import VALUES (45305, '2020-04-16', 'KG', 'Kyrgyzstan', 'EURO', '17', '466', '0', '5');
INSERT INTO public.who_global_data_import VALUES (45306, '2020-04-17', 'KG', 'Kyrgyzstan', 'EURO', '23', '489', '0', '5');
INSERT INTO public.who_global_data_import VALUES (45307, '2020-04-18', 'KG', 'Kyrgyzstan', 'EURO', '17', '506', '0', '5');
INSERT INTO public.who_global_data_import VALUES (45308, '2020-04-19', 'KG', 'Kyrgyzstan', 'EURO', '48', '554', '0', '5');
INSERT INTO public.who_global_data_import VALUES (45309, '2020-04-20', 'KG', 'Kyrgyzstan', 'EURO', '14', '568', '2', '7');
INSERT INTO public.who_global_data_import VALUES (45310, '2020-04-21', 'KG', 'Kyrgyzstan', 'EURO', '22', '590', '0', '7');
INSERT INTO public.who_global_data_import VALUES (45311, '2020-04-22', 'KG', 'Kyrgyzstan', 'EURO', '22', '612', '0', '7');
INSERT INTO public.who_global_data_import VALUES (45312, '2020-04-23', 'KG', 'Kyrgyzstan', 'EURO', '19', '631', '1', '8');
INSERT INTO public.who_global_data_import VALUES (45313, '2020-04-24', 'KG', 'Kyrgyzstan', 'EURO', '25', '656', '0', '8');
INSERT INTO public.who_global_data_import VALUES (45314, '2020-04-25', 'KG', 'Kyrgyzstan', 'EURO', '9', '665', '0', '8');
INSERT INTO public.who_global_data_import VALUES (45315, '2020-04-26', 'KG', 'Kyrgyzstan', 'EURO', '17', '682', '0', '8');
INSERT INTO public.who_global_data_import VALUES (45316, '2020-04-27', 'KG', 'Kyrgyzstan', 'EURO', '13', '695', '0', '8');
INSERT INTO public.who_global_data_import VALUES (45317, '2020-04-28', 'KG', 'Kyrgyzstan', 'EURO', '13', '708', '0', '8');
INSERT INTO public.who_global_data_import VALUES (45318, '2020-04-29', 'KG', 'Kyrgyzstan', 'EURO', '21', '729', '0', '8');
INSERT INTO public.who_global_data_import VALUES (45319, '2020-04-30', 'KG', 'Kyrgyzstan', 'EURO', '17', '746', '0', '8');
INSERT INTO public.who_global_data_import VALUES (45320, '2020-05-01', 'KG', 'Kyrgyzstan', 'EURO', '10', '756', '0', '8');
INSERT INTO public.who_global_data_import VALUES (45321, '2020-05-02', 'KG', 'Kyrgyzstan', 'EURO', '13', '769', '0', '8');
INSERT INTO public.who_global_data_import VALUES (45322, '2020-05-03', 'KG', 'Kyrgyzstan', 'EURO', '26', '795', '2', '10');
INSERT INTO public.who_global_data_import VALUES (45323, '2020-05-04', 'KG', 'Kyrgyzstan', 'EURO', '35', '830', '0', '10');
INSERT INTO public.who_global_data_import VALUES (45324, '2020-05-05', 'KG', 'Kyrgyzstan', 'EURO', '13', '843', '0', '10');
INSERT INTO public.who_global_data_import VALUES (45325, '2020-05-06', 'KG', 'Kyrgyzstan', 'EURO', '28', '871', '2', '12');
INSERT INTO public.who_global_data_import VALUES (45326, '2020-05-07', 'KG', 'Kyrgyzstan', 'EURO', '24', '895', '0', '12');
INSERT INTO public.who_global_data_import VALUES (45327, '2020-05-08', 'KG', 'Kyrgyzstan', 'EURO', '11', '906', '0', '12');
INSERT INTO public.who_global_data_import VALUES (45328, '2020-05-09', 'KG', 'Kyrgyzstan', 'EURO', '25', '931', '0', '12');
INSERT INTO public.who_global_data_import VALUES (45329, '2020-05-10', 'KG', 'Kyrgyzstan', 'EURO', '71', '1002', '0', '12');
INSERT INTO public.who_global_data_import VALUES (45330, '2020-05-11', 'KG', 'Kyrgyzstan', 'EURO', '14', '1016', '0', '12');
INSERT INTO public.who_global_data_import VALUES (45331, '2020-05-12', 'KG', 'Kyrgyzstan', 'EURO', '21', '1037', '0', '12');
INSERT INTO public.who_global_data_import VALUES (45332, '2020-05-13', 'KG', 'Kyrgyzstan', 'EURO', '7', '1044', '0', '12');
INSERT INTO public.who_global_data_import VALUES (45333, '2020-05-14', 'KG', 'Kyrgyzstan', 'EURO', '38', '1082', '0', '12');
INSERT INTO public.who_global_data_import VALUES (45334, '2020-05-15', 'KG', 'Kyrgyzstan', 'EURO', '29', '1111', '2', '14');
INSERT INTO public.who_global_data_import VALUES (45335, '2020-05-16', 'KG', 'Kyrgyzstan', 'EURO', '6', '1117', '0', '14');
INSERT INTO public.who_global_data_import VALUES (45336, '2020-05-17', 'KG', 'Kyrgyzstan', 'EURO', '21', '1138', '0', '14');
INSERT INTO public.who_global_data_import VALUES (45337, '2020-05-18', 'KG', 'Kyrgyzstan', 'EURO', '78', '1216', '0', '14');
INSERT INTO public.who_global_data_import VALUES (45338, '2020-05-19', 'KG', 'Kyrgyzstan', 'EURO', '27', '1243', '0', '14');
INSERT INTO public.who_global_data_import VALUES (45339, '2020-05-20', 'KG', 'Kyrgyzstan', 'EURO', '27', '1270', '0', '14');
INSERT INTO public.who_global_data_import VALUES (45340, '2020-05-21', 'KG', 'Kyrgyzstan', 'EURO', '43', '1313', '0', '14');
INSERT INTO public.who_global_data_import VALUES (45341, '2020-05-22', 'KG', 'Kyrgyzstan', 'EURO', '37', '1350', '0', '14');
INSERT INTO public.who_global_data_import VALUES (45342, '2020-05-23', 'KG', 'Kyrgyzstan', 'EURO', '15', '1365', '0', '14');
INSERT INTO public.who_global_data_import VALUES (45343, '2020-05-24', 'KG', 'Kyrgyzstan', 'EURO', '38', '1403', '0', '14');
INSERT INTO public.who_global_data_import VALUES (45344, '2020-05-25', 'KG', 'Kyrgyzstan', 'EURO', '30', '1433', '2', '16');
INSERT INTO public.who_global_data_import VALUES (45345, '2020-05-26', 'KG', 'Kyrgyzstan', 'EURO', '35', '1468', '0', '16');
INSERT INTO public.who_global_data_import VALUES (45346, '2020-05-27', 'KG', 'Kyrgyzstan', 'EURO', '52', '1520', '0', '16');
INSERT INTO public.who_global_data_import VALUES (45347, '2020-05-28', 'KG', 'Kyrgyzstan', 'EURO', '74', '1594', '0', '16');
INSERT INTO public.who_global_data_import VALUES (45348, '2020-05-29', 'KG', 'Kyrgyzstan', 'EURO', '68', '1662', '0', '16');
INSERT INTO public.who_global_data_import VALUES (45349, '2020-05-30', 'KG', 'Kyrgyzstan', 'EURO', '60', '1722', '0', '16');
INSERT INTO public.who_global_data_import VALUES (45350, '2020-05-31', 'KG', 'Kyrgyzstan', 'EURO', '26', '1748', '0', '16');
INSERT INTO public.who_global_data_import VALUES (45351, '2020-06-01', 'KG', 'Kyrgyzstan', 'EURO', '69', '1817', '0', '16');
INSERT INTO public.who_global_data_import VALUES (45352, '2020-06-02', 'KG', 'Kyrgyzstan', 'EURO', '28', '1845', '1', '17');
INSERT INTO public.who_global_data_import VALUES (45353, '2020-06-03', 'KG', 'Kyrgyzstan', 'EURO', '26', '1871', '3', '20');
INSERT INTO public.who_global_data_import VALUES (45354, '2020-06-04', 'KG', 'Kyrgyzstan', 'EURO', '28', '1899', '0', '20');
INSERT INTO public.who_global_data_import VALUES (45355, '2020-06-05', 'KG', 'Kyrgyzstan', 'EURO', '37', '1936', '2', '22');
INSERT INTO public.who_global_data_import VALUES (45356, '2020-06-06', 'KG', 'Kyrgyzstan', 'EURO', '38', '1974', '0', '22');
INSERT INTO public.who_global_data_import VALUES (45357, '2020-06-07', 'KG', 'Kyrgyzstan', 'EURO', '33', '2007', '0', '22');
INSERT INTO public.who_global_data_import VALUES (45358, '2020-06-08', 'KG', 'Kyrgyzstan', 'EURO', '25', '2032', '1', '23');
INSERT INTO public.who_global_data_import VALUES (45359, '2020-06-09', 'KG', 'Kyrgyzstan', 'EURO', '23', '2055', '1', '24');
INSERT INTO public.who_global_data_import VALUES (45360, '2020-06-10', 'KG', 'Kyrgyzstan', 'EURO', '38', '2093', '2', '26');
INSERT INTO public.who_global_data_import VALUES (45361, '2020-06-11', 'KG', 'Kyrgyzstan', 'EURO', '36', '2129', '0', '26');
INSERT INTO public.who_global_data_import VALUES (45362, '2020-06-12', 'KG', 'Kyrgyzstan', 'EURO', '37', '2166', '0', '26');
INSERT INTO public.who_global_data_import VALUES (45363, '2020-06-13', 'KG', 'Kyrgyzstan', 'EURO', '41', '2207', '1', '27');
INSERT INTO public.who_global_data_import VALUES (45364, '2020-06-14', 'KG', 'Kyrgyzstan', 'EURO', '78', '2285', '0', '27');
INSERT INTO public.who_global_data_import VALUES (45365, '2020-06-15', 'KG', 'Kyrgyzstan', 'EURO', '87', '2372', '0', '27');
INSERT INTO public.who_global_data_import VALUES (45366, '2020-06-16', 'KG', 'Kyrgyzstan', 'EURO', '100', '2472', '2', '29');
INSERT INTO public.who_global_data_import VALUES (45367, '2020-06-17', 'KG', 'Kyrgyzstan', 'EURO', '90', '2562', '1', '30');
INSERT INTO public.who_global_data_import VALUES (45368, '2020-06-18', 'KG', 'Kyrgyzstan', 'EURO', '95', '2657', '1', '31');
INSERT INTO public.who_global_data_import VALUES (45369, '2020-06-19', 'KG', 'Kyrgyzstan', 'EURO', '132', '2789', '1', '32');
INSERT INTO public.who_global_data_import VALUES (45370, '2020-06-20', 'KG', 'Kyrgyzstan', 'EURO', '192', '2981', '3', '35');
INSERT INTO public.who_global_data_import VALUES (45371, '2020-06-21', 'KG', 'Kyrgyzstan', 'EURO', '170', '3151', '0', '35');
INSERT INTO public.who_global_data_import VALUES (45372, '2020-06-22', 'KG', 'Kyrgyzstan', 'EURO', '205', '3356', '5', '40');
INSERT INTO public.who_global_data_import VALUES (45373, '2020-06-23', 'KG', 'Kyrgyzstan', 'EURO', '163', '3519', '1', '41');
INSERT INTO public.who_global_data_import VALUES (45374, '2020-06-24', 'KG', 'Kyrgyzstan', 'EURO', '207', '3726', '1', '42');
INSERT INTO public.who_global_data_import VALUES (45375, '2020-06-25', 'KG', 'Kyrgyzstan', 'EURO', '228', '3954', '1', '43');
INSERT INTO public.who_global_data_import VALUES (45376, '2020-06-26', 'KG', 'Kyrgyzstan', 'EURO', '250', '4204', '0', '43');
INSERT INTO public.who_global_data_import VALUES (45377, '2020-06-27', 'KG', 'Kyrgyzstan', 'EURO', '309', '4513', '3', '46');
INSERT INTO public.who_global_data_import VALUES (45378, '2020-06-28', 'KG', 'Kyrgyzstan', 'EURO', '0', '4513', '0', '46');
INSERT INTO public.who_global_data_import VALUES (45379, '2020-06-29', 'KG', 'Kyrgyzstan', 'EURO', '504', '5017', '4', '50');
INSERT INTO public.who_global_data_import VALUES (45380, '2020-06-30', 'KG', 'Kyrgyzstan', 'EURO', '279', '5296', '7', '57');
INSERT INTO public.who_global_data_import VALUES (45381, '2020-07-01', 'KG', 'Kyrgyzstan', 'EURO', '439', '5735', '5', '62');
INSERT INTO public.who_global_data_import VALUES (45382, '2020-07-02', 'KG', 'Kyrgyzstan', 'EURO', '526', '6261', '4', '66');
INSERT INTO public.who_global_data_import VALUES (45383, '2020-07-03', 'KG', 'Kyrgyzstan', 'EURO', '506', '6767', '10', '76');
INSERT INTO public.who_global_data_import VALUES (45384, '2020-07-04', 'KG', 'Kyrgyzstan', 'EURO', '327', '7094', '2', '78');
INSERT INTO public.who_global_data_import VALUES (45385, '2020-07-05', 'KG', 'Kyrgyzstan', 'EURO', '0', '7094', '0', '78');
INSERT INTO public.who_global_data_import VALUES (45386, '2020-07-06', 'KG', 'Kyrgyzstan', 'EURO', '597', '7691', '14', '92');
INSERT INTO public.who_global_data_import VALUES (45387, '2020-07-07', 'KG', 'Kyrgyzstan', 'EURO', '450', '8141', '7', '99');
INSERT INTO public.who_global_data_import VALUES (45388, '2020-07-08', 'KG', 'Kyrgyzstan', 'EURO', '345', '8486', '13', '112');
INSERT INTO public.who_global_data_import VALUES (45389, '2020-07-09', 'KG', 'Kyrgyzstan', 'EURO', '361', '8847', '4', '116');
INSERT INTO public.who_global_data_import VALUES (45390, '2020-07-10', 'KG', 'Kyrgyzstan', 'EURO', '511', '9358', '6', '122');
INSERT INTO public.who_global_data_import VALUES (45391, '2020-07-11', 'KG', 'Kyrgyzstan', 'EURO', '552', '9910', '3', '125');
INSERT INTO public.who_global_data_import VALUES (45392, '2020-07-12', 'KG', 'Kyrgyzstan', 'EURO', '719', '10629', '7', '132');
INSERT INTO public.who_global_data_import VALUES (45393, '2020-07-13', 'KG', 'Kyrgyzstan', 'EURO', '488', '11117', '15', '147');
INSERT INTO public.who_global_data_import VALUES (45394, '2020-07-14', 'KG', 'Kyrgyzstan', 'EURO', '421', '11538', '2', '149');
INSERT INTO public.who_global_data_import VALUES (45395, '2020-07-15', 'KG', 'Kyrgyzstan', 'EURO', '439', '11977', '11', '160');
INSERT INTO public.who_global_data_import VALUES (45396, '2020-07-16', 'KG', 'Kyrgyzstan', 'EURO', '521', '12498', '7', '167');
INSERT INTO public.who_global_data_import VALUES (45397, '2020-07-17', 'KG', 'Kyrgyzstan', 'EURO', '603', '13101', '5', '172');
INSERT INTO public.who_global_data_import VALUES (45398, '2020-07-18', 'KG', 'Kyrgyzstan', 'EURO', '11883', '24984', '306', '478');
INSERT INTO public.who_global_data_import VALUES (45399, '2020-07-19', 'KG', 'Kyrgyzstan', 'EURO', '1548', '26532', '80', '558');
INSERT INTO public.who_global_data_import VALUES (45400, '2020-07-20', 'KG', 'Kyrgyzstan', 'EURO', '611', '27143', '34', '592');
INSERT INTO public.who_global_data_import VALUES (45401, '2020-07-21', 'KG', 'Kyrgyzstan', 'EURO', '1108', '28251', '42', '634');
INSERT INTO public.who_global_data_import VALUES (45402, '2020-07-22', 'KG', 'Kyrgyzstan', 'EURO', '1108', '29359', '44', '678');
INSERT INTO public.who_global_data_import VALUES (45403, '2020-07-23', 'KG', 'Kyrgyzstan', 'EURO', '967', '30326', '46', '724');
INSERT INTO public.who_global_data_import VALUES (45404, '2020-07-24', 'KG', 'Kyrgyzstan', 'EURO', '921', '31247', '42', '766');
INSERT INTO public.who_global_data_import VALUES (45405, '2020-07-25', 'KG', 'Kyrgyzstan', 'EURO', '0', '31247', '38', '804');
INSERT INTO public.who_global_data_import VALUES (45406, '2020-07-26', 'KG', 'Kyrgyzstan', 'EURO', '1566', '32813', '28', '832');
INSERT INTO public.who_global_data_import VALUES (45407, '2020-07-27', 'KG', 'Kyrgyzstan', 'EURO', '483', '33296', '24', '856');
INSERT INTO public.who_global_data_import VALUES (45408, '2020-07-28', 'KG', 'Kyrgyzstan', 'EURO', '548', '33844', '28', '884');
INSERT INTO public.who_global_data_import VALUES (45409, '2020-07-29', 'KG', 'Kyrgyzstan', 'EURO', '668', '34512', '18', '902');
INSERT INTO public.who_global_data_import VALUES (45410, '2020-07-30', 'KG', 'Kyrgyzstan', 'EURO', '631', '35143', '17', '919');
INSERT INTO public.who_global_data_import VALUES (45411, '2020-07-31', 'KG', 'Kyrgyzstan', 'EURO', '662', '35805', '14', '933');
INSERT INTO public.who_global_data_import VALUES (45412, '2020-08-01', 'KG', 'Kyrgyzstan', 'EURO', '494', '36299', '19', '952');
INSERT INTO public.who_global_data_import VALUES (45413, '2020-08-02', 'KG', 'Kyrgyzstan', 'EURO', '420', '36719', '12', '964');
INSERT INTO public.who_global_data_import VALUES (45414, '2020-08-03', 'KG', 'Kyrgyzstan', 'EURO', '410', '37129', '11', '975');
INSERT INTO public.who_global_data_import VALUES (45415, '2020-08-04', 'KG', 'Kyrgyzstan', 'EURO', '412', '37541', '7', '982');
INSERT INTO public.who_global_data_import VALUES (45416, '2020-08-05', 'KG', 'Kyrgyzstan', 'EURO', '569', '38110', '11', '993');
INSERT INTO public.who_global_data_import VALUES (45417, '2020-08-06', 'KG', 'Kyrgyzstan', 'EURO', '549', '38659', '9', '1002');
INSERT INTO public.who_global_data_import VALUES (45418, '2020-08-07', 'KG', 'Kyrgyzstan', 'EURO', '503', '39162', '4', '1006');
INSERT INTO public.who_global_data_import VALUES (45419, '2020-08-08', 'KG', 'Kyrgyzstan', 'EURO', '425', '39587', '9', '1015');
INSERT INTO public.who_global_data_import VALUES (45420, '2020-08-09', 'KG', 'Kyrgyzstan', 'EURO', '332', '39919', '8', '1023');
INSERT INTO public.who_global_data_import VALUES (45421, '2020-08-10', 'KG', 'Kyrgyzstan', 'EURO', '258', '40177', '6', '1029');
INSERT INTO public.who_global_data_import VALUES (45422, '2020-08-11', 'KG', 'Kyrgyzstan', 'EURO', '278', '40455', '4', '1033');
INSERT INTO public.who_global_data_import VALUES (45423, '2020-08-12', 'KG', 'Kyrgyzstan', 'EURO', '304', '40759', '6', '1039');
INSERT INTO public.who_global_data_import VALUES (45424, '2020-08-13', 'KG', 'Kyrgyzstan', 'EURO', '310', '41069', '3', '1042');
INSERT INTO public.who_global_data_import VALUES (45425, '2020-08-14', 'KG', 'Kyrgyzstan', 'EURO', '304', '41373', '4', '1046');
INSERT INTO public.who_global_data_import VALUES (45426, '2020-08-15', 'KG', 'Kyrgyzstan', 'EURO', '272', '41645', '2', '1048');
INSERT INTO public.who_global_data_import VALUES (45427, '2020-08-16', 'KG', 'Kyrgyzstan', 'EURO', '211', '41856', '2', '1050');
INSERT INTO public.who_global_data_import VALUES (45428, '2020-08-17', 'KG', 'Kyrgyzstan', 'EURO', '135', '41991', '1', '1051');
INSERT INTO public.who_global_data_import VALUES (45429, '2020-08-18', 'KG', 'Kyrgyzstan', 'EURO', '155', '42146', '2', '1053');
INSERT INTO public.who_global_data_import VALUES (45430, '2020-08-19', 'KG', 'Kyrgyzstan', 'EURO', '179', '42325', '1', '1054');
INSERT INTO public.who_global_data_import VALUES (45431, '2020-08-20', 'KG', 'Kyrgyzstan', 'EURO', '182', '42507', '0', '1054');
INSERT INTO public.who_global_data_import VALUES (45432, '2020-08-21', 'KG', 'Kyrgyzstan', 'EURO', '196', '42703', '1', '1055');
INSERT INTO public.who_global_data_import VALUES (45433, '2020-08-22', 'KG', 'Kyrgyzstan', 'EURO', '186', '42889', '0', '1055');
INSERT INTO public.who_global_data_import VALUES (45434, '2020-08-23', 'KG', 'Kyrgyzstan', 'EURO', '134', '43023', '1', '1056');
INSERT INTO public.who_global_data_import VALUES (45435, '2020-08-24', 'KG', 'Kyrgyzstan', 'EURO', '103', '43126', '1', '1057');
INSERT INTO public.who_global_data_import VALUES (45436, '2020-08-25', 'KG', 'Kyrgyzstan', 'EURO', '119', '43245', '0', '1057');
INSERT INTO public.who_global_data_import VALUES (45437, '2020-08-26', 'KG', 'Kyrgyzstan', 'EURO', '113', '43358', '1', '1058');
INSERT INTO public.who_global_data_import VALUES (45438, '2020-08-27', 'KG', 'Kyrgyzstan', 'EURO', '101', '43459', '0', '1058');
INSERT INTO public.who_global_data_import VALUES (45439, '2020-08-28', 'KG', 'Kyrgyzstan', 'EURO', '128', '43587', '0', '1058');
INSERT INTO public.who_global_data_import VALUES (45440, '2020-08-29', 'KG', 'Kyrgyzstan', 'EURO', '125', '43712', '0', '1058');
INSERT INTO public.who_global_data_import VALUES (45441, '2020-08-30', 'KG', 'Kyrgyzstan', 'EURO', '108', '43820', '1', '1059');
INSERT INTO public.who_global_data_import VALUES (45442, '2020-08-31', 'KG', 'Kyrgyzstan', 'EURO', '78', '43898', '0', '1059');
INSERT INTO public.who_global_data_import VALUES (45443, '2020-09-01', 'KG', 'Kyrgyzstan', 'EURO', '60', '43958', '1', '1060');
INSERT INTO public.who_global_data_import VALUES (45444, '2020-09-02', 'KG', 'Kyrgyzstan', 'EURO', '78', '44036', '0', '1060');
INSERT INTO public.who_global_data_import VALUES (45445, '2020-09-03', 'KG', 'Kyrgyzstan', 'EURO', '99', '44135', '0', '1060');
INSERT INTO public.who_global_data_import VALUES (45446, '2020-09-04', 'KG', 'Kyrgyzstan', 'EURO', '92', '44227', '1', '1061');
INSERT INTO public.who_global_data_import VALUES (45447, '2020-09-05', 'KG', 'Kyrgyzstan', 'EURO', '89', '44316', '0', '1061');
INSERT INTO public.who_global_data_import VALUES (45448, '2020-09-06', 'KG', 'Kyrgyzstan', 'EURO', '87', '44403', '0', '1061');
INSERT INTO public.who_global_data_import VALUES (45449, '2020-09-07', 'KG', 'Kyrgyzstan', 'EURO', '55', '44458', '0', '1061');
INSERT INTO public.who_global_data_import VALUES (45450, '2020-09-08', 'KG', 'Kyrgyzstan', 'EURO', '68', '44526', '1', '1062');
INSERT INTO public.who_global_data_import VALUES (45451, '2020-09-09', 'KG', 'Kyrgyzstan', 'EURO', '87', '44613', '1', '1063');
INSERT INTO public.who_global_data_import VALUES (45452, '2020-09-10', 'KG', 'Kyrgyzstan', 'EURO', '71', '44684', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45453, '2020-09-11', 'KG', 'Kyrgyzstan', 'EURO', '77', '44761', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45454, '2020-09-12', 'KG', 'Kyrgyzstan', 'EURO', '67', '44828', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45455, '2020-09-13', 'KG', 'Kyrgyzstan', 'EURO', '53', '44881', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45456, '2020-09-14', 'KG', 'Kyrgyzstan', 'EURO', '47', '44928', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45457, '2020-09-15', 'KG', 'Kyrgyzstan', 'EURO', '71', '44999', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45458, '2020-09-16', 'KG', 'Kyrgyzstan', 'EURO', '73', '45072', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45459, '2020-09-17', 'KG', 'Kyrgyzstan', 'EURO', '81', '45153', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45460, '2020-09-18', 'KG', 'Kyrgyzstan', 'EURO', '91', '45244', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45461, '2020-09-19', 'KG', 'Kyrgyzstan', 'EURO', '91', '45335', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45462, '2020-09-20', 'KG', 'Kyrgyzstan', 'EURO', '81', '45416', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45463, '2020-09-21', 'KG', 'Kyrgyzstan', 'EURO', '55', '45471', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45464, '2020-09-22', 'KG', 'Kyrgyzstan', 'EURO', '71', '45542', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45465, '2020-09-23', 'KG', 'Kyrgyzstan', 'EURO', '88', '45630', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45466, '2020-09-24', 'KG', 'Kyrgyzstan', 'EURO', '127', '45757', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45467, '2020-09-25', 'KG', 'Kyrgyzstan', 'EURO', '175', '45932', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45468, '2020-09-26', 'KG', 'Kyrgyzstan', 'EURO', '158', '46090', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45469, '2020-09-27', 'KG', 'Kyrgyzstan', 'EURO', '161', '46251', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (45470, '2020-09-28', 'KG', 'Kyrgyzstan', 'EURO', '104', '46355', '1', '1064');
INSERT INTO public.who_global_data_import VALUES (45471, '2020-09-29', 'KG', 'Kyrgyzstan', 'EURO', '167', '46522', '0', '1064');
INSERT INTO public.who_global_data_import VALUES (45472, '2020-09-30', 'KG', 'Kyrgyzstan', 'EURO', '147', '46669', '0', '1064');
INSERT INTO public.who_global_data_import VALUES (45473, '2020-10-01', 'KG', 'Kyrgyzstan', 'EURO', '172', '46841', '1', '1065');
INSERT INTO public.who_global_data_import VALUES (45474, '2020-10-02', 'KG', 'Kyrgyzstan', 'EURO', '215', '47056', '0', '1065');
INSERT INTO public.who_global_data_import VALUES (45475, '2020-10-03', 'KG', 'Kyrgyzstan', 'EURO', '128', '47184', '1', '1066');
INSERT INTO public.who_global_data_import VALUES (45476, '2020-10-04', 'KG', 'Kyrgyzstan', 'EURO', '244', '47428', '0', '1066');
INSERT INTO public.who_global_data_import VALUES (45477, '2020-10-05', 'KG', 'Kyrgyzstan', 'EURO', '207', '47635', '0', '1066');
INSERT INTO public.who_global_data_import VALUES (45478, '2020-10-06', 'KG', 'Kyrgyzstan', 'EURO', '164', '47799', '0', '1066');
INSERT INTO public.who_global_data_import VALUES (45479, '2020-10-07', 'KG', 'Kyrgyzstan', 'EURO', '298', '48097', '3', '1069');
INSERT INTO public.who_global_data_import VALUES (45480, '2020-10-08', 'KG', 'Kyrgyzstan', 'EURO', '245', '48342', '4', '1073');
INSERT INTO public.who_global_data_import VALUES (45481, '2020-10-09', 'KG', 'Kyrgyzstan', 'EURO', '275', '48617', '4', '1077');
INSERT INTO public.who_global_data_import VALUES (45482, '2020-10-10', 'KG', 'Kyrgyzstan', 'EURO', '307', '48924', '5', '1082');
INSERT INTO public.who_global_data_import VALUES (45483, '2020-10-11', 'KG', 'Kyrgyzstan', 'EURO', '306', '49230', '3', '1085');
INSERT INTO public.who_global_data_import VALUES (45484, '2020-10-12', 'KG', 'Kyrgyzstan', 'EURO', '298', '49528', '5', '1090');
INSERT INTO public.who_global_data_import VALUES (45485, '2020-10-13', 'KG', 'Kyrgyzstan', 'EURO', '343', '49871', '2', '1092');
INSERT INTO public.who_global_data_import VALUES (45486, '2020-10-14', 'KG', 'Kyrgyzstan', 'EURO', '330', '50201', '2', '1094');
INSERT INTO public.who_global_data_import VALUES (45487, '2020-10-15', 'KG', 'Kyrgyzstan', 'EURO', '388', '50589', '5', '1099');
INSERT INTO public.who_global_data_import VALUES (45488, '2020-10-16', 'KG', 'Kyrgyzstan', 'EURO', '431', '51020', '4', '1103');
INSERT INTO public.who_global_data_import VALUES (45489, '2020-10-17', 'KG', 'Kyrgyzstan', 'EURO', '470', '51490', '5', '1108');
INSERT INTO public.who_global_data_import VALUES (45490, '2020-10-18', 'KG', 'Kyrgyzstan', 'EURO', '554', '52044', '3', '1111');
INSERT INTO public.who_global_data_import VALUES (45491, '2020-10-19', 'KG', 'Kyrgyzstan', 'EURO', '482', '52526', '0', '1111');
INSERT INTO public.who_global_data_import VALUES (45492, '2020-10-20', 'KG', 'Kyrgyzstan', 'EURO', '384', '52910', '2', '1113');
INSERT INTO public.who_global_data_import VALUES (45493, '2020-10-21', 'KG', 'Kyrgyzstan', 'EURO', '549', '53459', '5', '1118');
INSERT INTO public.who_global_data_import VALUES (45494, '2020-10-22', 'KG', 'Kyrgyzstan', 'EURO', '547', '54006', '4', '1122');
INSERT INTO public.who_global_data_import VALUES (45495, '2020-10-23', 'KG', 'Kyrgyzstan', 'EURO', '582', '54588', '4', '1126');
INSERT INTO public.who_global_data_import VALUES (45496, '2020-10-24', 'KG', 'Kyrgyzstan', 'EURO', '556', '55144', '4', '1130');
INSERT INTO public.who_global_data_import VALUES (45497, '2020-10-25', 'KG', 'Kyrgyzstan', 'EURO', '606', '55750', '4', '1134');
INSERT INTO public.who_global_data_import VALUES (45498, '2020-10-26', 'KG', 'Kyrgyzstan', 'EURO', '420', '56170', '0', '1134');
INSERT INTO public.who_global_data_import VALUES (45499, '2020-10-27', 'KG', 'Kyrgyzstan', 'EURO', '568', '56738', '2', '1136');
INSERT INTO public.who_global_data_import VALUES (45500, '2020-10-28', 'KG', 'Kyrgyzstan', 'EURO', '538', '57276', '2', '1138');
INSERT INTO public.who_global_data_import VALUES (45501, '2020-10-29', 'KG', 'Kyrgyzstan', 'EURO', '522', '57798', '1', '1139');
INSERT INTO public.who_global_data_import VALUES (45502, '2020-10-30', 'KG', 'Kyrgyzstan', 'EURO', '596', '58394', '3', '1142');
INSERT INTO public.who_global_data_import VALUES (45503, '2020-10-31', 'KG', 'Kyrgyzstan', 'EURO', '484', '58878', '3', '1145');
INSERT INTO public.who_global_data_import VALUES (45504, '2020-11-01', 'KG', 'Kyrgyzstan', 'EURO', '565', '59443', '5', '1150');
INSERT INTO public.who_global_data_import VALUES (45505, '2020-11-02', 'KG', 'Kyrgyzstan', 'EURO', '436', '59879', '5', '1155');
INSERT INTO public.who_global_data_import VALUES (45506, '2020-11-03', 'KG', 'Kyrgyzstan', 'EURO', '400', '60279', '4', '1159');
INSERT INTO public.who_global_data_import VALUES (45507, '2020-11-04', 'KG', 'Kyrgyzstan', 'EURO', '495', '60774', '4', '1163');
INSERT INTO public.who_global_data_import VALUES (45508, '2020-11-05', 'KG', 'Kyrgyzstan', 'EURO', '535', '61309', '4', '1167');
INSERT INTO public.who_global_data_import VALUES (45509, '2020-11-06', 'KG', 'Kyrgyzstan', 'EURO', '439', '61748', '3', '1170');
INSERT INTO public.who_global_data_import VALUES (45510, '2020-11-07', 'KG', 'Kyrgyzstan', 'EURO', '556', '62304', '2', '1172');
INSERT INTO public.who_global_data_import VALUES (45511, '2020-11-08', 'KG', 'Kyrgyzstan', 'EURO', '515', '62819', '5', '1177');
INSERT INTO public.who_global_data_import VALUES (45512, '2020-11-09', 'KG', 'Kyrgyzstan', 'EURO', '571', '63390', '5', '1182');
INSERT INTO public.who_global_data_import VALUES (45513, '2020-11-10', 'KG', 'Kyrgyzstan', 'EURO', '570', '63960', '3', '1185');
INSERT INTO public.who_global_data_import VALUES (45514, '2020-11-11', 'KG', 'Kyrgyzstan', 'EURO', '400', '64360', '3', '1188');
INSERT INTO public.who_global_data_import VALUES (45515, '2020-11-12', 'KG', 'Kyrgyzstan', 'EURO', '527', '64887', '5', '1193');
INSERT INTO public.who_global_data_import VALUES (45516, '2020-11-13', 'KG', 'Kyrgyzstan', 'EURO', '567', '65454', '2', '1195');
INSERT INTO public.who_global_data_import VALUES (45517, '2020-11-14', 'KG', 'Kyrgyzstan', 'EURO', '499', '65953', '1', '1196');
INSERT INTO public.who_global_data_import VALUES (45518, '2020-11-15', 'KG', 'Kyrgyzstan', 'EURO', '551', '66504', '3', '1199');
INSERT INTO public.who_global_data_import VALUES (45519, '2020-11-16', 'KG', 'Kyrgyzstan', 'EURO', '479', '66983', '4', '1203');
INSERT INTO public.who_global_data_import VALUES (45520, '2020-11-17', 'KG', 'Kyrgyzstan', 'EURO', '486', '67469', '4', '1207');
INSERT INTO public.who_global_data_import VALUES (45521, '2020-11-18', 'KG', 'Kyrgyzstan', 'EURO', '425', '67894', '5', '1212');
INSERT INTO public.who_global_data_import VALUES (45522, '2020-11-19', 'KG', 'Kyrgyzstan', 'EURO', '422', '68316', '5', '1217');
INSERT INTO public.who_global_data_import VALUES (45523, '2020-11-20', 'KG', 'Kyrgyzstan', 'EURO', '386', '68702', '6', '1223');
INSERT INTO public.who_global_data_import VALUES (45524, '2020-11-21', 'KG', 'Kyrgyzstan', 'EURO', '447', '69149', '4', '1227');
INSERT INTO public.who_global_data_import VALUES (45525, '2020-11-22', 'KG', 'Kyrgyzstan', 'EURO', '432', '69581', '4', '1231');
INSERT INTO public.who_global_data_import VALUES (45526, '2020-11-23', 'KG', 'Kyrgyzstan', 'EURO', '304', '69885', '6', '1237');
INSERT INTO public.who_global_data_import VALUES (45527, '2020-11-24', 'KG', 'Kyrgyzstan', 'EURO', '481', '70366', '4', '1241');
INSERT INTO public.who_global_data_import VALUES (45528, '2020-11-25', 'KG', 'Kyrgyzstan', 'EURO', '378', '70744', '4', '1245');
INSERT INTO public.who_global_data_import VALUES (45529, '2020-11-26', 'KG', 'Kyrgyzstan', 'EURO', '427', '71171', '6', '1251');
INSERT INTO public.who_global_data_import VALUES (45530, '2020-11-27', 'KG', 'Kyrgyzstan', 'EURO', '377', '71548', '5', '1256');
INSERT INTO public.who_global_data_import VALUES (45531, '2020-11-28', 'KG', 'Kyrgyzstan', 'EURO', '423', '71971', '6', '1262');
INSERT INTO public.who_global_data_import VALUES (45532, '2020-11-29', 'KG', 'Kyrgyzstan', 'EURO', '456', '72427', '4', '1266');
INSERT INTO public.who_global_data_import VALUES (45533, '2020-11-30', 'KG', 'Kyrgyzstan', 'EURO', '380', '72807', '5', '1271');
INSERT INTO public.who_global_data_import VALUES (45534, '2020-12-01', 'KG', 'Kyrgyzstan', 'EURO', '371', '73178', '4', '1275');
INSERT INTO public.who_global_data_import VALUES (45535, '2020-12-02', 'KG', 'Kyrgyzstan', 'EURO', '335', '73513', '2', '1277');
INSERT INTO public.who_global_data_import VALUES (45536, '2020-12-03', 'KG', 'Kyrgyzstan', 'EURO', '420', '73933', '4', '1281');
INSERT INTO public.who_global_data_import VALUES (45537, '2020-12-04', 'KG', 'Kyrgyzstan', 'EURO', '440', '74373', '4', '1285');
INSERT INTO public.who_global_data_import VALUES (45538, '2020-12-05', 'KG', 'Kyrgyzstan', 'EURO', '401', '74774', '5', '1290');
INSERT INTO public.who_global_data_import VALUES (45539, '2020-12-06', 'KG', 'Kyrgyzstan', 'EURO', '328', '75102', '5', '1295');
INSERT INTO public.who_global_data_import VALUES (45540, '2020-12-07', 'KG', 'Kyrgyzstan', 'EURO', '293', '75395', '2', '1297');
INSERT INTO public.who_global_data_import VALUES (45541, '2020-12-08', 'KG', 'Kyrgyzstan', 'EURO', '295', '75690', '4', '1301');
INSERT INTO public.who_global_data_import VALUES (45542, '2020-12-09', 'KG', 'Kyrgyzstan', 'EURO', '322', '76012', '2', '1303');
INSERT INTO public.who_global_data_import VALUES (45543, '2020-12-10', 'KG', 'Kyrgyzstan', 'EURO', '379', '76391', '3', '1306');
INSERT INTO public.who_global_data_import VALUES (45544, '2020-12-11', 'KG', 'Kyrgyzstan', 'EURO', '327', '76718', '1', '1307');
INSERT INTO public.who_global_data_import VALUES (45545, '2020-12-12', 'KG', 'Kyrgyzstan', 'EURO', '341', '77059', '0', '1307');
INSERT INTO public.who_global_data_import VALUES (45546, '2020-12-13', 'KG', 'Kyrgyzstan', 'EURO', '297', '77356', '0', '1307');
INSERT INTO public.who_global_data_import VALUES (45547, '2020-12-14', 'KG', 'Kyrgyzstan', 'EURO', '318', '77674', '5', '1312');
INSERT INTO public.who_global_data_import VALUES (45548, '2020-12-15', 'KG', 'Kyrgyzstan', 'EURO', '236', '77910', '4', '1316');
INSERT INTO public.who_global_data_import VALUES (45549, '2020-12-16', 'KG', 'Kyrgyzstan', 'EURO', '241', '78151', '1', '1317');
INSERT INTO public.who_global_data_import VALUES (45550, '2020-12-17', 'KG', 'Kyrgyzstan', 'EURO', '264', '78415', '4', '1321');
INSERT INTO public.who_global_data_import VALUES (45551, '2020-12-18', 'KG', 'Kyrgyzstan', 'EURO', '264', '78679', '3', '1324');
INSERT INTO public.who_global_data_import VALUES (45552, '2020-12-19', 'KG', 'Kyrgyzstan', 'EURO', '232', '78911', '4', '1328');
INSERT INTO public.who_global_data_import VALUES (45553, '2020-12-20', 'KG', 'Kyrgyzstan', 'EURO', '211', '79122', '2', '1330');
INSERT INTO public.who_global_data_import VALUES (45554, '2020-12-21', 'KG', 'Kyrgyzstan', 'EURO', '132', '79254', '0', '1330');
INSERT INTO public.who_global_data_import VALUES (45555, '2020-12-22', 'KG', 'Kyrgyzstan', 'EURO', '175', '79429', '5', '1335');
INSERT INTO public.who_global_data_import VALUES (45556, '2020-12-23', 'KG', 'Kyrgyzstan', 'EURO', '230', '79659', '2', '1337');
INSERT INTO public.who_global_data_import VALUES (45557, '2020-12-24', 'KG', 'Kyrgyzstan', 'EURO', '186', '79845', '3', '1340');
INSERT INTO public.who_global_data_import VALUES (45558, '2020-12-25', 'KG', 'Kyrgyzstan', 'EURO', '180', '80025', '0', '1340');
INSERT INTO public.who_global_data_import VALUES (45559, '2020-12-26', 'KG', 'Kyrgyzstan', 'EURO', '157', '80182', '4', '1344');
INSERT INTO public.who_global_data_import VALUES (45560, '2020-12-27', 'KG', 'Kyrgyzstan', 'EURO', '191', '80373', '4', '1348');
INSERT INTO public.who_global_data_import VALUES (45561, '2020-12-28', 'KG', 'Kyrgyzstan', 'EURO', '162', '80535', '1', '1349');
INSERT INTO public.who_global_data_import VALUES (45562, '2020-12-29', 'KG', 'Kyrgyzstan', 'EURO', '119', '80654', '4', '1353');
INSERT INTO public.who_global_data_import VALUES (45563, '2020-12-30', 'KG', 'Kyrgyzstan', 'EURO', '189', '80843', '1', '1354');
INSERT INTO public.who_global_data_import VALUES (45564, '2020-12-31', 'KG', 'Kyrgyzstan', 'EURO', '191', '81034', '1', '1355');
INSERT INTO public.who_global_data_import VALUES (45565, '2021-01-01', 'KG', 'Kyrgyzstan', 'EURO', '122', '81156', '1', '1356');
INSERT INTO public.who_global_data_import VALUES (45566, '2021-01-02', 'KG', 'Kyrgyzstan', 'EURO', '58', '81214', '2', '1358');
INSERT INTO public.who_global_data_import VALUES (45567, '2021-01-03', 'KG', 'Kyrgyzstan', 'EURO', '91', '81305', '1', '1359');
INSERT INTO public.who_global_data_import VALUES (45568, '2021-01-04', 'KG', 'Kyrgyzstan', 'EURO', '83', '81388', '1', '1360');
INSERT INTO public.who_global_data_import VALUES (45569, '2021-01-05', 'KG', 'Kyrgyzstan', 'EURO', '124', '81512', '0', '1360');
INSERT INTO public.who_global_data_import VALUES (45570, '2021-01-06', 'KG', 'Kyrgyzstan', 'EURO', '144', '81656', '1', '1361');
INSERT INTO public.who_global_data_import VALUES (45571, '2021-01-07', 'KG', 'Kyrgyzstan', 'EURO', '170', '81826', '2', '1363');
INSERT INTO public.who_global_data_import VALUES (45572, '2021-01-08', 'KG', 'Kyrgyzstan', 'EURO', '165', '81991', '2', '1365');
INSERT INTO public.who_global_data_import VALUES (45573, '2021-01-09', 'KG', 'Kyrgyzstan', 'EURO', '147', '82138', '2', '1367');
INSERT INTO public.who_global_data_import VALUES (45574, '2021-01-10', 'KG', 'Kyrgyzstan', 'EURO', '135', '82273', '2', '1369');
INSERT INTO public.who_global_data_import VALUES (45575, '2021-01-11', 'KG', 'Kyrgyzstan', 'EURO', '107', '82380', '2', '1371');
INSERT INTO public.who_global_data_import VALUES (45576, '2021-01-12', 'KG', 'Kyrgyzstan', 'EURO', '115', '82495', '3', '1374');
INSERT INTO public.who_global_data_import VALUES (45577, '2021-01-13', 'KG', 'Kyrgyzstan', 'EURO', '92', '82587', '1', '1375');
INSERT INTO public.who_global_data_import VALUES (45578, '2021-01-14', 'KG', 'Kyrgyzstan', 'EURO', '136', '82723', '3', '1378');
INSERT INTO public.who_global_data_import VALUES (45579, '2021-01-15', 'KG', 'Kyrgyzstan', 'EURO', '134', '82857', '3', '1381');
INSERT INTO public.who_global_data_import VALUES (45580, '2021-01-16', 'KG', 'Kyrgyzstan', 'EURO', '129', '82986', '1', '1382');
INSERT INTO public.who_global_data_import VALUES (45581, '2021-01-17', 'KG', 'Kyrgyzstan', 'EURO', '123', '83109', '2', '1384');
INSERT INTO public.who_global_data_import VALUES (45582, '2021-01-18', 'KG', 'Kyrgyzstan', 'EURO', '69', '83178', '3', '1387');
INSERT INTO public.who_global_data_import VALUES (45583, '2021-01-19', 'KG', 'Kyrgyzstan', 'EURO', '90', '83268', '3', '1390');
INSERT INTO public.who_global_data_import VALUES (45584, '2021-01-20', 'KG', 'Kyrgyzstan', 'EURO', '162', '83430', '2', '1392');
INSERT INTO public.who_global_data_import VALUES (45585, '2021-01-21', 'KG', 'Kyrgyzstan', 'EURO', '155', '83585', '2', '1394');
INSERT INTO public.who_global_data_import VALUES (45586, '2021-01-22', 'KG', 'Kyrgyzstan', 'EURO', '118', '83703', '2', '1396');
INSERT INTO public.who_global_data_import VALUES (45587, '2021-01-23', 'KG', 'Kyrgyzstan', 'EURO', '93', '83796', '2', '1398');
INSERT INTO public.who_global_data_import VALUES (45588, '2021-01-24', 'KG', 'Kyrgyzstan', 'EURO', '104', '83900', '2', '1400');
INSERT INTO public.who_global_data_import VALUES (45589, '2021-01-25', 'KG', 'Kyrgyzstan', 'EURO', '71', '83971', '1', '1401');
INSERT INTO public.who_global_data_import VALUES (45590, '2021-01-26', 'KG', 'Kyrgyzstan', 'EURO', '97', '84068', '1', '1402');
INSERT INTO public.who_global_data_import VALUES (45591, '2021-01-27', 'KG', 'Kyrgyzstan', 'EURO', '107', '84175', '3', '1405');
INSERT INTO public.who_global_data_import VALUES (45592, '2021-01-28', 'KG', 'Kyrgyzstan', 'EURO', '128', '84303', '3', '1408');
INSERT INTO public.who_global_data_import VALUES (45593, '2021-01-29', 'KG', 'Kyrgyzstan', 'EURO', '74', '84377', '1', '1409');
INSERT INTO public.who_global_data_import VALUES (45594, '2021-01-30', 'KG', 'Kyrgyzstan', 'EURO', '76', '84453', '2', '1411');
INSERT INTO public.who_global_data_import VALUES (45595, '2021-01-31', 'KG', 'Kyrgyzstan', 'EURO', '76', '84529', '1', '1412');
INSERT INTO public.who_global_data_import VALUES (45596, '2021-02-01', 'KG', 'Kyrgyzstan', 'EURO', '59', '84588', '0', '1412');
INSERT INTO public.who_global_data_import VALUES (45597, '2021-02-02', 'KG', 'Kyrgyzstan', 'EURO', '58', '84646', '2', '1414');
INSERT INTO public.who_global_data_import VALUES (45598, '2021-02-03', 'KG', 'Kyrgyzstan', 'EURO', '116', '84762', '1', '1415');
INSERT INTO public.who_global_data_import VALUES (45599, '2021-02-04', 'KG', 'Kyrgyzstan', 'EURO', '70', '84832', '3', '1418');
INSERT INTO public.who_global_data_import VALUES (45600, '2021-02-05', 'KG', 'Kyrgyzstan', 'EURO', '88', '84920', '2', '1420');
INSERT INTO public.who_global_data_import VALUES (45601, '2020-01-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45602, '2020-01-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45603, '2020-01-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45604, '2020-01-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45605, '2020-01-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45606, '2020-01-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45607, '2020-01-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45608, '2020-01-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45609, '2020-01-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45610, '2020-01-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45611, '2020-01-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45612, '2020-01-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45613, '2020-01-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45614, '2020-01-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45615, '2020-01-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45616, '2020-01-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45617, '2020-01-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45618, '2020-01-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45619, '2020-01-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45620, '2020-01-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45621, '2020-01-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45622, '2020-01-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45623, '2020-01-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45624, '2020-01-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45625, '2020-01-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45626, '2020-01-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45627, '2020-01-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45628, '2020-01-30', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45629, '2020-01-31', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45630, '2020-02-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45631, '2020-02-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45632, '2020-02-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45633, '2020-02-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45634, '2020-02-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45635, '2020-02-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45636, '2020-02-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45637, '2020-02-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45638, '2020-02-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45639, '2020-02-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45640, '2020-02-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45641, '2020-02-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45642, '2020-02-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45643, '2020-02-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45644, '2020-02-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45645, '2020-02-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45646, '2020-02-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45647, '2020-02-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45648, '2020-02-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45649, '2020-02-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45650, '2020-02-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45651, '2020-02-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45652, '2020-02-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45653, '2020-02-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45654, '2020-02-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45655, '2020-02-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45656, '2020-02-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45657, '2020-02-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45658, '2020-02-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45659, '2020-03-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45660, '2020-03-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45661, '2020-03-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45662, '2020-03-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45663, '2020-03-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45664, '2020-03-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45665, '2020-03-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45666, '2020-03-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45667, '2020-03-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45668, '2020-03-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45669, '2020-03-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45670, '2020-03-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45671, '2020-03-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45672, '2020-03-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45673, '2020-03-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45674, '2020-03-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45675, '2020-03-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45676, '2020-03-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45677, '2020-03-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45678, '2020-03-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46006, '2020-01-08', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45679, '2020-03-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45680, '2020-03-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45681, '2020-03-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45682, '2020-03-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45683, '2020-03-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45684, '2020-03-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45685, '2020-03-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '3', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45686, '2020-03-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45687, '2020-03-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45688, '2020-03-30', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45689, '2020-03-31', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45690, '2020-04-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45691, '2020-04-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45692, '2020-04-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45693, '2020-04-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45694, '2020-04-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45695, '2020-04-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45696, '2020-04-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45697, '2020-04-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45698, '2020-04-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45699, '2020-04-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45700, '2020-04-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45701, '2020-04-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '2', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45702, '2020-04-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45703, '2020-04-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45704, '2020-04-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45705, '2020-04-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45706, '2020-04-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45707, '2020-04-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45708, '2020-04-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45709, '2020-04-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45710, '2020-04-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45711, '2020-04-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45712, '2020-04-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45713, '2020-04-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45714, '2020-04-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45715, '2020-04-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45716, '2020-04-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45717, '2020-04-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45718, '2020-04-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45719, '2020-04-30', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45720, '2020-05-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45721, '2020-05-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45722, '2020-05-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45723, '2020-05-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45724, '2020-05-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45725, '2020-05-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45726, '2020-05-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45727, '2020-05-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45728, '2020-05-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45729, '2020-05-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45730, '2020-05-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45731, '2020-05-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45732, '2020-05-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45733, '2020-05-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45734, '2020-05-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45735, '2020-05-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45736, '2020-05-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45737, '2020-05-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45738, '2020-05-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45739, '2020-05-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45740, '2020-05-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45741, '2020-05-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45742, '2020-05-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45743, '2020-05-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45744, '2020-05-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45745, '2020-05-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45746, '2020-05-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45747, '2020-05-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45748, '2020-05-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45749, '2020-05-30', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45750, '2020-05-31', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45751, '2020-06-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45752, '2020-06-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45753, '2020-06-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45754, '2020-06-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45755, '2020-06-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45756, '2020-06-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45757, '2020-06-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45758, '2020-06-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45759, '2020-06-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45760, '2020-06-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45761, '2020-06-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45762, '2020-06-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45763, '2020-06-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45764, '2020-06-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45765, '2020-06-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45766, '2020-06-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45767, '2020-06-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45768, '2020-06-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45769, '2020-06-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45770, '2020-06-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45771, '2020-06-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45772, '2020-06-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45773, '2020-06-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45774, '2020-06-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45775, '2020-06-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45776, '2020-06-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45777, '2020-06-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45778, '2020-06-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45779, '2020-06-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45780, '2020-06-30', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45781, '2020-07-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45782, '2020-07-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45783, '2020-07-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45784, '2020-07-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45785, '2020-07-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45786, '2020-07-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45787, '2020-07-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45788, '2020-07-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45789, '2020-07-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45790, '2020-07-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45791, '2020-07-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45792, '2020-07-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45793, '2020-07-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45794, '2020-07-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45795, '2020-07-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45796, '2020-07-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45797, '2020-07-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45798, '2020-07-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45799, '2020-07-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45800, '2020-07-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45801, '2020-07-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45802, '2020-07-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45803, '2020-07-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45804, '2020-07-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45805, '2020-07-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45806, '2020-07-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45807, '2020-07-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45808, '2020-07-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45809, '2020-07-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45810, '2020-07-30', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45811, '2020-07-31', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45812, '2020-08-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45813, '2020-08-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45814, '2020-08-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45815, '2020-08-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45816, '2020-08-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45817, '2020-08-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45818, '2020-08-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45819, '2020-08-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45820, '2020-08-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45821, '2020-08-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45822, '2020-08-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45823, '2020-08-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45824, '2020-08-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45825, '2020-08-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45826, '2020-08-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45827, '2020-08-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '2', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45828, '2020-08-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45829, '2020-08-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45830, '2020-08-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45831, '2020-08-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45832, '2020-08-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45833, '2020-08-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45834, '2020-08-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45835, '2020-08-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45836, '2020-08-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45837, '2020-08-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45838, '2020-08-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45839, '2020-08-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45840, '2020-08-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45841, '2020-08-30', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46007, '2020-01-09', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45842, '2020-08-31', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45843, '2020-09-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45844, '2020-09-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45845, '2020-09-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45846, '2020-09-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45847, '2020-09-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45848, '2020-09-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45849, '2020-09-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45850, '2020-09-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45851, '2020-09-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45852, '2020-09-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45853, '2020-09-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45854, '2020-09-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45855, '2020-09-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45856, '2020-09-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45857, '2020-09-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45858, '2020-09-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45859, '2020-09-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45860, '2020-09-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45861, '2020-09-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45862, '2020-09-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45863, '2020-09-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45864, '2020-09-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45865, '2020-09-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45866, '2020-09-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45867, '2020-09-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45868, '2020-09-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45869, '2020-09-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45870, '2020-09-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45871, '2020-09-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45872, '2020-09-30', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45873, '2020-10-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45874, '2020-10-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45875, '2020-10-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45876, '2020-10-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45877, '2020-10-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45878, '2020-10-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45879, '2020-10-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45880, '2020-10-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45881, '2020-10-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45882, '2020-10-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45883, '2020-10-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45884, '2020-10-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45885, '2020-10-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45886, '2020-10-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45887, '2020-10-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45888, '2020-10-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45889, '2020-10-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45890, '2020-10-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45891, '2020-10-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45892, '2020-10-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45893, '2020-10-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45894, '2020-10-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45895, '2020-10-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45896, '2020-10-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45897, '2020-10-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45898, '2020-10-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45899, '2020-10-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45900, '2020-10-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45901, '2020-10-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45902, '2020-10-30', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45903, '2020-10-31', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45904, '2020-11-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45905, '2020-11-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45906, '2020-11-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45907, '2020-11-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45908, '2020-11-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45909, '2020-11-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45910, '2020-11-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45911, '2020-11-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45912, '2020-11-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45913, '2020-11-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45914, '2020-11-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45915, '2020-11-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45916, '2020-11-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45917, '2020-11-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45918, '2020-11-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45919, '2020-11-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45920, '2020-11-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45921, '2020-11-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45922, '2020-11-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46008, '2020-01-10', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45923, '2020-11-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45924, '2020-11-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45925, '2020-11-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45926, '2020-11-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45927, '2020-11-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '14', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45928, '2020-11-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45929, '2020-11-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45930, '2020-11-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45931, '2020-11-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45932, '2020-11-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45933, '2020-11-30', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45934, '2020-12-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45935, '2020-12-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45936, '2020-12-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45937, '2020-12-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45938, '2020-12-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45939, '2020-12-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45940, '2020-12-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45941, '2020-12-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '2', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45942, '2020-12-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45943, '2020-12-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45944, '2020-12-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45945, '2020-12-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45946, '2020-12-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45947, '2020-12-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45948, '2020-12-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45949, '2020-12-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45950, '2020-12-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45951, '2020-12-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45952, '2020-12-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45953, '2020-12-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45954, '2020-12-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45955, '2020-12-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45956, '2020-12-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45957, '2020-12-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45958, '2020-12-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45959, '2020-12-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45960, '2020-12-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45961, '2020-12-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45962, '2020-12-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45963, '2020-12-30', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45964, '2020-12-31', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45965, '2021-01-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45966, '2021-01-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45967, '2021-01-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45968, '2021-01-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45969, '2021-01-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45970, '2021-01-06', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45971, '2021-01-07', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45972, '2021-01-08', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45973, '2021-01-09', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45974, '2021-01-10', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45975, '2021-01-11', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45976, '2021-01-12', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45977, '2021-01-13', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45978, '2021-01-14', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45979, '2021-01-15', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45980, '2021-01-16', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45981, '2021-01-17', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45982, '2021-01-18', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45983, '2021-01-19', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45984, '2021-01-20', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45985, '2021-01-21', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45986, '2021-01-22', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45987, '2021-01-23', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '2', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45988, '2021-01-24', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45989, '2021-01-25', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45990, '2021-01-26', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45991, '2021-01-27', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45992, '2021-01-28', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45993, '2021-01-29', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45994, '2021-01-30', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45995, '2021-01-31', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45996, '2021-02-01', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45997, '2021-02-02', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45998, '2021-02-03', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (45999, '2021-02-04', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '1', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46000, '2021-02-05', 'LA', 'Lao People''s Democratic Republic', 'WPRO', '0', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46001, '2020-01-03', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46002, '2020-01-04', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46003, '2020-01-05', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46004, '2020-01-06', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46005, '2020-01-07', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46009, '2020-01-11', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46010, '2020-01-12', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46011, '2020-01-13', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46012, '2020-01-14', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46013, '2020-01-15', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46014, '2020-01-16', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46015, '2020-01-17', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46016, '2020-01-18', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46017, '2020-01-19', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46018, '2020-01-20', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46019, '2020-01-21', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46020, '2020-01-22', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46021, '2020-01-23', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46022, '2020-01-24', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46023, '2020-01-25', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46024, '2020-01-26', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46025, '2020-01-27', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46026, '2020-01-28', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46027, '2020-01-29', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46028, '2020-01-30', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46029, '2020-01-31', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46030, '2020-02-01', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46031, '2020-02-02', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46032, '2020-02-03', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46033, '2020-02-04', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46034, '2020-02-05', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46035, '2020-02-06', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46036, '2020-02-07', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46037, '2020-02-08', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46038, '2020-02-09', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46039, '2020-02-10', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46040, '2020-02-11', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46041, '2020-02-12', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46042, '2020-02-13', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46043, '2020-02-14', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46044, '2020-02-15', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46045, '2020-02-16', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46046, '2020-02-17', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46047, '2020-02-18', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46048, '2020-02-19', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46049, '2020-02-20', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46050, '2020-02-21', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46051, '2020-02-22', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46052, '2020-02-23', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46053, '2020-02-24', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46054, '2020-02-25', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46055, '2020-02-26', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46056, '2020-02-27', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46057, '2020-02-28', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46058, '2020-02-29', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46059, '2020-03-01', 'LV', 'Latvia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46060, '2020-03-02', 'LV', 'Latvia', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46061, '2020-03-03', 'LV', 'Latvia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46062, '2020-03-04', 'LV', 'Latvia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46063, '2020-03-05', 'LV', 'Latvia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46064, '2020-03-06', 'LV', 'Latvia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46065, '2020-03-07', 'LV', 'Latvia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46066, '2020-03-08', 'LV', 'Latvia', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46067, '2020-03-09', 'LV', 'Latvia', 'EURO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46068, '2020-03-10', 'LV', 'Latvia', 'EURO', '3', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46069, '2020-03-11', 'LV', 'Latvia', 'EURO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46070, '2020-03-12', 'LV', 'Latvia', 'EURO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46071, '2020-03-13', 'LV', 'Latvia', 'EURO', '6', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46072, '2020-03-14', 'LV', 'Latvia', 'EURO', '3', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46073, '2020-03-15', 'LV', 'Latvia', 'EURO', '7', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46074, '2020-03-16', 'LV', 'Latvia', 'EURO', '5', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46075, '2020-03-17', 'LV', 'Latvia', 'EURO', '5', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46076, '2020-03-18', 'LV', 'Latvia', 'EURO', '25', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46077, '2020-03-19', 'LV', 'Latvia', 'EURO', '10', '71', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46078, '2020-03-20', 'LV', 'Latvia', 'EURO', '15', '86', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46079, '2020-03-21', 'LV', 'Latvia', 'EURO', '25', '111', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46080, '2020-03-22', 'LV', 'Latvia', 'EURO', '13', '124', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46081, '2020-03-23', 'LV', 'Latvia', 'EURO', '15', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46082, '2020-03-24', 'LV', 'Latvia', 'EURO', '41', '180', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46083, '2020-03-25', 'LV', 'Latvia', 'EURO', '17', '197', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46084, '2020-03-26', 'LV', 'Latvia', 'EURO', '24', '221', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46085, '2020-03-27', 'LV', 'Latvia', 'EURO', '23', '244', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46086, '2020-03-28', 'LV', 'Latvia', 'EURO', '36', '280', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46087, '2020-03-29', 'LV', 'Latvia', 'EURO', '25', '305', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46088, '2020-03-30', 'LV', 'Latvia', 'EURO', '71', '376', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46089, '2020-03-31', 'LV', 'Latvia', 'EURO', '0', '376', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46090, '2020-04-01', 'LV', 'Latvia', 'EURO', '22', '398', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46091, '2020-04-02', 'LV', 'Latvia', 'EURO', '48', '446', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46092, '2020-04-03', 'LV', 'Latvia', 'EURO', '12', '458', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46093, '2020-04-04', 'LV', 'Latvia', 'EURO', '35', '493', '1', '1');
INSERT INTO public.who_global_data_import VALUES (46094, '2020-04-05', 'LV', 'Latvia', 'EURO', '16', '509', '0', '1');
INSERT INTO public.who_global_data_import VALUES (46095, '2020-04-06', 'LV', 'Latvia', 'EURO', '24', '533', '0', '1');
INSERT INTO public.who_global_data_import VALUES (46096, '2020-04-07', 'LV', 'Latvia', 'EURO', '9', '542', '0', '1');
INSERT INTO public.who_global_data_import VALUES (46097, '2020-04-08', 'LV', 'Latvia', 'EURO', '6', '548', '1', '2');
INSERT INTO public.who_global_data_import VALUES (46098, '2020-04-09', 'LV', 'Latvia', 'EURO', '29', '577', '0', '2');
INSERT INTO public.who_global_data_import VALUES (46099, '2020-04-10', 'LV', 'Latvia', 'EURO', '12', '589', '0', '2');
INSERT INTO public.who_global_data_import VALUES (46100, '2020-04-11', 'LV', 'Latvia', 'EURO', '23', '612', '0', '2');
INSERT INTO public.who_global_data_import VALUES (46101, '2020-04-12', 'LV', 'Latvia', 'EURO', '18', '630', '1', '3');
INSERT INTO public.who_global_data_import VALUES (46102, '2020-04-13', 'LV', 'Latvia', 'EURO', '21', '651', '2', '5');
INSERT INTO public.who_global_data_import VALUES (46103, '2020-04-14', 'LV', 'Latvia', 'EURO', '4', '655', '0', '5');
INSERT INTO public.who_global_data_import VALUES (46104, '2020-04-15', 'LV', 'Latvia', 'EURO', '2', '657', '0', '5');
INSERT INTO public.who_global_data_import VALUES (46105, '2020-04-16', 'LV', 'Latvia', 'EURO', '9', '666', '0', '5');
INSERT INTO public.who_global_data_import VALUES (46106, '2020-04-17', 'LV', 'Latvia', 'EURO', '9', '675', '0', '5');
INSERT INTO public.who_global_data_import VALUES (46107, '2020-04-18', 'LV', 'Latvia', 'EURO', '7', '682', '0', '5');
INSERT INTO public.who_global_data_import VALUES (46108, '2020-04-19', 'LV', 'Latvia', 'EURO', '30', '712', '0', '5');
INSERT INTO public.who_global_data_import VALUES (46109, '2020-04-20', 'LV', 'Latvia', 'EURO', '15', '727', '0', '5');
INSERT INTO public.who_global_data_import VALUES (46110, '2020-04-21', 'LV', 'Latvia', 'EURO', '12', '739', '0', '5');
INSERT INTO public.who_global_data_import VALUES (46111, '2020-04-22', 'LV', 'Latvia', 'EURO', '9', '748', '4', '9');
INSERT INTO public.who_global_data_import VALUES (46112, '2020-04-23', 'LV', 'Latvia', 'EURO', '13', '761', '2', '11');
INSERT INTO public.who_global_data_import VALUES (46113, '2020-04-24', 'LV', 'Latvia', 'EURO', '17', '778', '0', '11');
INSERT INTO public.who_global_data_import VALUES (46114, '2020-04-25', 'LV', 'Latvia', 'EURO', '6', '784', '1', '12');
INSERT INTO public.who_global_data_import VALUES (46115, '2020-04-26', 'LV', 'Latvia', 'EURO', '20', '804', '0', '12');
INSERT INTO public.who_global_data_import VALUES (46116, '2020-04-27', 'LV', 'Latvia', 'EURO', '8', '812', '0', '12');
INSERT INTO public.who_global_data_import VALUES (46117, '2020-04-28', 'LV', 'Latvia', 'EURO', '6', '818', '1', '13');
INSERT INTO public.who_global_data_import VALUES (46118, '2020-04-29', 'LV', 'Latvia', 'EURO', '18', '836', '0', '13');
INSERT INTO public.who_global_data_import VALUES (46119, '2020-04-30', 'LV', 'Latvia', 'EURO', '13', '849', '2', '15');
INSERT INTO public.who_global_data_import VALUES (46120, '2020-05-01', 'LV', 'Latvia', 'EURO', '9', '858', '0', '15');
INSERT INTO public.who_global_data_import VALUES (46121, '2020-05-02', 'LV', 'Latvia', 'EURO', '12', '870', '1', '16');
INSERT INTO public.who_global_data_import VALUES (46122, '2020-05-03', 'LV', 'Latvia', 'EURO', '1', '871', '0', '16');
INSERT INTO public.who_global_data_import VALUES (46123, '2020-05-04', 'LV', 'Latvia', 'EURO', '8', '879', '0', '16');
INSERT INTO public.who_global_data_import VALUES (46124, '2020-05-05', 'LV', 'Latvia', 'EURO', '17', '896', '0', '16');
INSERT INTO public.who_global_data_import VALUES (46125, '2020-05-06', 'LV', 'Latvia', 'EURO', '0', '896', '1', '17');
INSERT INTO public.who_global_data_import VALUES (46126, '2020-05-07', 'LV', 'Latvia', 'EURO', '4', '900', '0', '17');
INSERT INTO public.who_global_data_import VALUES (46127, '2020-05-08', 'LV', 'Latvia', 'EURO', '9', '909', '1', '18');
INSERT INTO public.who_global_data_import VALUES (46128, '2020-05-09', 'LV', 'Latvia', 'EURO', '19', '928', '0', '18');
INSERT INTO public.who_global_data_import VALUES (46129, '2020-05-10', 'LV', 'Latvia', 'EURO', '2', '930', '0', '18');
INSERT INTO public.who_global_data_import VALUES (46130, '2020-05-11', 'LV', 'Latvia', 'EURO', '9', '939', '0', '18');
INSERT INTO public.who_global_data_import VALUES (46131, '2020-05-12', 'LV', 'Latvia', 'EURO', '7', '946', '0', '18');
INSERT INTO public.who_global_data_import VALUES (46132, '2020-05-13', 'LV', 'Latvia', 'EURO', '4', '950', '0', '18');
INSERT INTO public.who_global_data_import VALUES (46133, '2020-05-14', 'LV', 'Latvia', 'EURO', '1', '951', '1', '19');
INSERT INTO public.who_global_data_import VALUES (46134, '2020-05-15', 'LV', 'Latvia', 'EURO', '11', '962', '0', '19');
INSERT INTO public.who_global_data_import VALUES (46135, '2020-05-16', 'LV', 'Latvia', 'EURO', '8', '970', '0', '19');
INSERT INTO public.who_global_data_import VALUES (46136, '2020-05-17', 'LV', 'Latvia', 'EURO', '27', '997', '0', '19');
INSERT INTO public.who_global_data_import VALUES (46137, '2020-05-18', 'LV', 'Latvia', 'EURO', '11', '1008', '0', '19');
INSERT INTO public.who_global_data_import VALUES (46138, '2020-05-19', 'LV', 'Latvia', 'EURO', '1', '1009', '0', '19');
INSERT INTO public.who_global_data_import VALUES (46139, '2020-05-20', 'LV', 'Latvia', 'EURO', '3', '1012', '2', '21');
INSERT INTO public.who_global_data_import VALUES (46140, '2020-05-21', 'LV', 'Latvia', 'EURO', '4', '1016', '0', '21');
INSERT INTO public.who_global_data_import VALUES (46141, '2020-05-22', 'LV', 'Latvia', 'EURO', '9', '1025', '1', '22');
INSERT INTO public.who_global_data_import VALUES (46142, '2020-05-23', 'LV', 'Latvia', 'EURO', '5', '1030', '0', '22');
INSERT INTO public.who_global_data_import VALUES (46143, '2020-05-24', 'LV', 'Latvia', 'EURO', '16', '1046', '0', '22');
INSERT INTO public.who_global_data_import VALUES (46144, '2020-05-25', 'LV', 'Latvia', 'EURO', '1', '1047', '0', '22');
INSERT INTO public.who_global_data_import VALUES (46145, '2020-05-26', 'LV', 'Latvia', 'EURO', '2', '1049', '0', '22');
INSERT INTO public.who_global_data_import VALUES (46146, '2020-05-27', 'LV', 'Latvia', 'EURO', '4', '1053', '0', '22');
INSERT INTO public.who_global_data_import VALUES (46147, '2020-05-28', 'LV', 'Latvia', 'EURO', '4', '1057', '1', '23');
INSERT INTO public.who_global_data_import VALUES (46148, '2020-05-29', 'LV', 'Latvia', 'EURO', '4', '1061', '1', '24');
INSERT INTO public.who_global_data_import VALUES (46149, '2020-05-30', 'LV', 'Latvia', 'EURO', '3', '1064', '0', '24');
INSERT INTO public.who_global_data_import VALUES (46150, '2020-05-31', 'LV', 'Latvia', 'EURO', '1', '1065', '0', '24');
INSERT INTO public.who_global_data_import VALUES (46151, '2020-06-01', 'LV', 'Latvia', 'EURO', '1', '1066', '0', '24');
INSERT INTO public.who_global_data_import VALUES (46152, '2020-06-02', 'LV', 'Latvia', 'EURO', '5', '1071', '0', '24');
INSERT INTO public.who_global_data_import VALUES (46153, '2020-06-03', 'LV', 'Latvia', 'EURO', '8', '1079', '0', '24');
INSERT INTO public.who_global_data_import VALUES (46154, '2020-06-04', 'LV', 'Latvia', 'EURO', '0', '1079', '0', '24');
INSERT INTO public.who_global_data_import VALUES (46155, '2020-06-05', 'LV', 'Latvia', 'EURO', '3', '1082', '1', '25');
INSERT INTO public.who_global_data_import VALUES (46156, '2020-06-06', 'LV', 'Latvia', 'EURO', '0', '1082', '0', '25');
INSERT INTO public.who_global_data_import VALUES (46157, '2020-06-07', 'LV', 'Latvia', 'EURO', '4', '1086', '0', '25');
INSERT INTO public.who_global_data_import VALUES (46158, '2020-06-08', 'LV', 'Latvia', 'EURO', '2', '1088', '0', '25');
INSERT INTO public.who_global_data_import VALUES (46159, '2020-06-09', 'LV', 'Latvia', 'EURO', '0', '1088', '1', '26');
INSERT INTO public.who_global_data_import VALUES (46160, '2020-06-10', 'LV', 'Latvia', 'EURO', '1', '1089', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46161, '2020-06-11', 'LV', 'Latvia', 'EURO', '3', '1092', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46162, '2020-06-12', 'LV', 'Latvia', 'EURO', '2', '1094', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46163, '2020-06-13', 'LV', 'Latvia', 'EURO', '2', '1096', '1', '27');
INSERT INTO public.who_global_data_import VALUES (46164, '2020-06-14', 'LV', 'Latvia', 'EURO', '1', '1097', '1', '28');
INSERT INTO public.who_global_data_import VALUES (46165, '2020-06-15', 'LV', 'Latvia', 'EURO', '0', '1097', '0', '28');
INSERT INTO public.who_global_data_import VALUES (46166, '2020-06-16', 'LV', 'Latvia', 'EURO', '0', '1097', '0', '28');
INSERT INTO public.who_global_data_import VALUES (46167, '2020-06-17', 'LV', 'Latvia', 'EURO', '1', '1098', '0', '28');
INSERT INTO public.who_global_data_import VALUES (46168, '2020-06-18', 'LV', 'Latvia', 'EURO', '6', '1104', '2', '30');
INSERT INTO public.who_global_data_import VALUES (46169, '2020-06-19', 'LV', 'Latvia', 'EURO', '4', '1108', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46170, '2020-06-20', 'LV', 'Latvia', 'EURO', '2', '1110', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46171, '2020-06-21', 'LV', 'Latvia', 'EURO', '1', '1111', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46172, '2020-06-22', 'LV', 'Latvia', 'EURO', '0', '1111', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46173, '2020-06-23', 'LV', 'Latvia', 'EURO', '0', '1111', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46174, '2020-06-24', 'LV', 'Latvia', 'EURO', '0', '1111', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46175, '2020-06-25', 'LV', 'Latvia', 'EURO', '0', '1111', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46176, '2020-06-26', 'LV', 'Latvia', 'EURO', '0', '1111', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46177, '2020-06-27', 'LV', 'Latvia', 'EURO', '1', '1112', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46178, '2020-06-28', 'LV', 'Latvia', 'EURO', '3', '1115', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46179, '2020-06-29', 'LV', 'Latvia', 'EURO', '1', '1116', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46180, '2020-06-30', 'LV', 'Latvia', 'EURO', '1', '1117', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46181, '2020-07-01', 'LV', 'Latvia', 'EURO', '1', '1118', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46182, '2020-07-02', 'LV', 'Latvia', 'EURO', '3', '1121', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46183, '2020-07-03', 'LV', 'Latvia', 'EURO', '1', '1122', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46184, '2020-07-04', 'LV', 'Latvia', 'EURO', '0', '1122', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46185, '2020-07-05', 'LV', 'Latvia', 'EURO', '1', '1123', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46186, '2020-07-06', 'LV', 'Latvia', 'EURO', '1', '1124', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46187, '2020-07-07', 'LV', 'Latvia', 'EURO', '3', '1127', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46188, '2020-07-08', 'LV', 'Latvia', 'EURO', '7', '1134', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46189, '2020-07-09', 'LV', 'Latvia', 'EURO', '7', '1141', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46190, '2020-07-10', 'LV', 'Latvia', 'EURO', '13', '1154', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46191, '2020-07-11', 'LV', 'Latvia', 'EURO', '0', '1154', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46192, '2020-07-12', 'LV', 'Latvia', 'EURO', '19', '1173', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46193, '2020-07-13', 'LV', 'Latvia', 'EURO', '0', '1173', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46194, '2020-07-14', 'LV', 'Latvia', 'EURO', '1', '1174', '1', '31');
INSERT INTO public.who_global_data_import VALUES (46195, '2020-07-15', 'LV', 'Latvia', 'EURO', '4', '1178', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46196, '2020-07-16', 'LV', 'Latvia', 'EURO', '0', '1178', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46197, '2020-07-17', 'LV', 'Latvia', 'EURO', '1', '1179', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46198, '2020-07-18', 'LV', 'Latvia', 'EURO', '6', '1185', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46199, '2020-07-19', 'LV', 'Latvia', 'EURO', '4', '1189', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46200, '2020-07-20', 'LV', 'Latvia', 'EURO', '3', '1192', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46201, '2020-07-21', 'LV', 'Latvia', 'EURO', '0', '1192', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46202, '2020-07-22', 'LV', 'Latvia', 'EURO', '1', '1193', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46203, '2020-07-23', 'LV', 'Latvia', 'EURO', '4', '1197', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46204, '2020-07-24', 'LV', 'Latvia', 'EURO', '6', '1203', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46205, '2020-07-25', 'LV', 'Latvia', 'EURO', '2', '1205', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46206, '2020-07-26', 'LV', 'Latvia', 'EURO', '1', '1206', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46207, '2020-07-27', 'LV', 'Latvia', 'EURO', '13', '1219', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46208, '2020-07-28', 'LV', 'Latvia', 'EURO', '1', '1220', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46209, '2020-07-29', 'LV', 'Latvia', 'EURO', '0', '1220', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46210, '2020-07-30', 'LV', 'Latvia', 'EURO', '4', '1224', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46211, '2020-07-31', 'LV', 'Latvia', 'EURO', '4', '1228', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46212, '2020-08-01', 'LV', 'Latvia', 'EURO', '3', '1231', '1', '32');
INSERT INTO public.who_global_data_import VALUES (46213, '2020-08-02', 'LV', 'Latvia', 'EURO', '7', '1238', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46214, '2020-08-03', 'LV', 'Latvia', 'EURO', '5', '1243', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46215, '2020-08-04', 'LV', 'Latvia', 'EURO', '3', '1246', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46216, '2020-08-05', 'LV', 'Latvia', 'EURO', '3', '1249', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46217, '2020-08-06', 'LV', 'Latvia', 'EURO', '8', '1257', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46218, '2020-08-07', 'LV', 'Latvia', 'EURO', '18', '1275', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46219, '2020-08-08', 'LV', 'Latvia', 'EURO', '6', '1281', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46220, '2020-08-09', 'LV', 'Latvia', 'EURO', '7', '1288', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46221, '2020-08-10', 'LV', 'Latvia', 'EURO', '2', '1290', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46222, '2020-08-11', 'LV', 'Latvia', 'EURO', '3', '1293', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46223, '2020-08-12', 'LV', 'Latvia', 'EURO', '10', '1303', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46224, '2020-08-13', 'LV', 'Latvia', 'EURO', '0', '1303', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46225, '2020-08-14', 'LV', 'Latvia', 'EURO', '4', '1307', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46226, '2020-08-15', 'LV', 'Latvia', 'EURO', '1', '1308', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46227, '2020-08-16', 'LV', 'Latvia', 'EURO', '7', '1315', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46228, '2020-08-17', 'LV', 'Latvia', 'EURO', '7', '1322', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46229, '2020-08-18', 'LV', 'Latvia', 'EURO', '1', '1323', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46230, '2020-08-19', 'LV', 'Latvia', 'EURO', '0', '1323', '1', '33');
INSERT INTO public.who_global_data_import VALUES (46231, '2020-08-20', 'LV', 'Latvia', 'EURO', '3', '1326', '0', '33');
INSERT INTO public.who_global_data_import VALUES (46232, '2020-08-21', 'LV', 'Latvia', 'EURO', '1', '1327', '0', '33');
INSERT INTO public.who_global_data_import VALUES (46233, '2020-08-22', 'LV', 'Latvia', 'EURO', '3', '1330', '0', '33');
INSERT INTO public.who_global_data_import VALUES (46234, '2020-08-23', 'LV', 'Latvia', 'EURO', '3', '1333', '0', '33');
INSERT INTO public.who_global_data_import VALUES (46235, '2020-08-24', 'LV', 'Latvia', 'EURO', '4', '1337', '0', '33');
INSERT INTO public.who_global_data_import VALUES (46236, '2020-08-25', 'LV', 'Latvia', 'EURO', '0', '1337', '0', '33');
INSERT INTO public.who_global_data_import VALUES (46237, '2020-08-26', 'LV', 'Latvia', 'EURO', '5', '1342', '0', '33');
INSERT INTO public.who_global_data_import VALUES (46238, '2020-08-27', 'LV', 'Latvia', 'EURO', '18', '1360', '0', '33');
INSERT INTO public.who_global_data_import VALUES (46239, '2020-08-28', 'LV', 'Latvia', 'EURO', '6', '1366', '1', '34');
INSERT INTO public.who_global_data_import VALUES (46240, '2020-08-29', 'LV', 'Latvia', 'EURO', '9', '1375', '0', '34');
INSERT INTO public.who_global_data_import VALUES (46241, '2020-08-30', 'LV', 'Latvia', 'EURO', '0', '1375', '0', '34');
INSERT INTO public.who_global_data_import VALUES (46242, '2020-08-31', 'LV', 'Latvia', 'EURO', '18', '1393', '0', '34');
INSERT INTO public.who_global_data_import VALUES (46243, '2020-09-01', 'LV', 'Latvia', 'EURO', '3', '1396', '0', '34');
INSERT INTO public.who_global_data_import VALUES (46244, '2020-09-02', 'LV', 'Latvia', 'EURO', '8', '1404', '0', '34');
INSERT INTO public.who_global_data_import VALUES (46245, '2020-09-03', 'LV', 'Latvia', 'EURO', '2', '1406', '0', '34');
INSERT INTO public.who_global_data_import VALUES (46246, '2020-09-04', 'LV', 'Latvia', 'EURO', '4', '1410', '0', '34');
INSERT INTO public.who_global_data_import VALUES (46247, '2020-09-05', 'LV', 'Latvia', 'EURO', '6', '1416', '1', '35');
INSERT INTO public.who_global_data_import VALUES (46248, '2020-09-06', 'LV', 'Latvia', 'EURO', '9', '1425', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46249, '2020-09-07', 'LV', 'Latvia', 'EURO', '3', '1428', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46250, '2020-09-08', 'LV', 'Latvia', 'EURO', '1', '1429', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46251, '2020-09-09', 'LV', 'Latvia', 'EURO', '3', '1432', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46252, '2020-09-10', 'LV', 'Latvia', 'EURO', '11', '1443', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46253, '2020-09-11', 'LV', 'Latvia', 'EURO', '5', '1448', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46254, '2020-09-12', 'LV', 'Latvia', 'EURO', '11', '1459', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46255, '2020-09-13', 'LV', 'Latvia', 'EURO', '5', '1464', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46256, '2020-09-14', 'LV', 'Latvia', 'EURO', '10', '1474', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46257, '2020-09-15', 'LV', 'Latvia', 'EURO', '3', '1477', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46258, '2020-09-16', 'LV', 'Latvia', 'EURO', '5', '1482', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46259, '2020-09-17', 'LV', 'Latvia', 'EURO', '4', '1486', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46260, '2020-09-18', 'LV', 'Latvia', 'EURO', '8', '1494', '1', '36');
INSERT INTO public.who_global_data_import VALUES (46261, '2020-09-19', 'LV', 'Latvia', 'EURO', '4', '1498', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46262, '2020-09-20', 'LV', 'Latvia', 'EURO', '17', '1515', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46263, '2020-09-21', 'LV', 'Latvia', 'EURO', '10', '1525', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46264, '2020-09-22', 'LV', 'Latvia', 'EURO', '1', '1526', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46265, '2020-09-23', 'LV', 'Latvia', 'EURO', '34', '1560', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46266, '2020-09-24', 'LV', 'Latvia', 'EURO', '12', '1572', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46267, '2020-09-25', 'LV', 'Latvia', 'EURO', '22', '1594', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46268, '2020-09-26', 'LV', 'Latvia', 'EURO', '31', '1625', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46269, '2020-09-27', 'LV', 'Latvia', 'EURO', '29', '1654', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46270, '2020-09-28', 'LV', 'Latvia', 'EURO', '22', '1676', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46271, '2020-09-29', 'LV', 'Latvia', 'EURO', '21', '1697', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46272, '2020-09-30', 'LV', 'Latvia', 'EURO', '32', '1729', '1', '37');
INSERT INTO public.who_global_data_import VALUES (46273, '2020-10-01', 'LV', 'Latvia', 'EURO', '95', '1824', '0', '37');
INSERT INTO public.who_global_data_import VALUES (46274, '2020-10-02', 'LV', 'Latvia', 'EURO', '44', '1868', '0', '37');
INSERT INTO public.who_global_data_import VALUES (46275, '2020-10-03', 'LV', 'Latvia', 'EURO', '77', '1945', '1', '38');
INSERT INTO public.who_global_data_import VALUES (46276, '2020-10-04', 'LV', 'Latvia', 'EURO', '74', '2019', '0', '38');
INSERT INTO public.who_global_data_import VALUES (46277, '2020-10-05', 'LV', 'Latvia', 'EURO', '67', '2086', '0', '38');
INSERT INTO public.who_global_data_import VALUES (46278, '2020-10-06', 'LV', 'Latvia', 'EURO', '40', '2126', '1', '39');
INSERT INTO public.who_global_data_import VALUES (46279, '2020-10-07', 'LV', 'Latvia', 'EURO', '68', '2194', '0', '39');
INSERT INTO public.who_global_data_import VALUES (46280, '2020-10-08', 'LV', 'Latvia', 'EURO', '67', '2261', '1', '40');
INSERT INTO public.who_global_data_import VALUES (46281, '2020-10-09', 'LV', 'Latvia', 'EURO', '109', '2370', '0', '40');
INSERT INTO public.who_global_data_import VALUES (46282, '2020-10-10', 'LV', 'Latvia', 'EURO', '137', '2507', '0', '40');
INSERT INTO public.who_global_data_import VALUES (46283, '2020-10-11', 'LV', 'Latvia', 'EURO', '89', '2596', '0', '40');
INSERT INTO public.who_global_data_import VALUES (46284, '2020-10-12', 'LV', 'Latvia', 'EURO', '74', '2670', '0', '40');
INSERT INTO public.who_global_data_import VALUES (46285, '2020-10-13', 'LV', 'Latvia', 'EURO', '95', '2765', '0', '40');
INSERT INTO public.who_global_data_import VALUES (46286, '2020-10-14', 'LV', 'Latvia', 'EURO', '75', '2840', '1', '41');
INSERT INTO public.who_global_data_import VALUES (46287, '2020-10-15', 'LV', 'Latvia', 'EURO', '102', '2942', '0', '41');
INSERT INTO public.who_global_data_import VALUES (46288, '2020-10-16', 'LV', 'Latvia', 'EURO', '114', '3056', '0', '41');
INSERT INTO public.who_global_data_import VALUES (46289, '2020-10-17', 'LV', 'Latvia', 'EURO', '148', '3204', '1', '42');
INSERT INTO public.who_global_data_import VALUES (46290, '2020-10-18', 'LV', 'Latvia', 'EURO', '188', '3392', '0', '42');
INSERT INTO public.who_global_data_import VALUES (46291, '2020-10-19', 'LV', 'Latvia', 'EURO', '58', '3450', '0', '42');
INSERT INTO public.who_global_data_import VALUES (46292, '2020-10-20', 'LV', 'Latvia', 'EURO', '44', '3494', '0', '42');
INSERT INTO public.who_global_data_import VALUES (46293, '2020-10-21', 'LV', 'Latvia', 'EURO', '115', '3609', '4', '46');
INSERT INTO public.who_global_data_import VALUES (46294, '2020-10-22', 'LV', 'Latvia', 'EURO', '188', '3797', '2', '48');
INSERT INTO public.who_global_data_import VALUES (46295, '2020-10-23', 'LV', 'Latvia', 'EURO', '161', '3958', '1', '49');
INSERT INTO public.who_global_data_import VALUES (46296, '2020-10-24', 'LV', 'Latvia', 'EURO', '250', '4208', '1', '50');
INSERT INTO public.who_global_data_import VALUES (46297, '2020-10-25', 'LV', 'Latvia', 'EURO', '259', '4467', '4', '54');
INSERT INTO public.who_global_data_import VALUES (46298, '2020-10-26', 'LV', 'Latvia', 'EURO', '211', '4678', '2', '56');
INSERT INTO public.who_global_data_import VALUES (46299, '2020-10-27', 'LV', 'Latvia', 'EURO', '79', '4757', '4', '60');
INSERT INTO public.who_global_data_import VALUES (46300, '2020-10-28', 'LV', 'Latvia', 'EURO', '136', '4893', '3', '63');
INSERT INTO public.who_global_data_import VALUES (46301, '2020-10-29', 'LV', 'Latvia', 'EURO', '251', '5144', '0', '63');
INSERT INTO public.who_global_data_import VALUES (46302, '2020-10-30', 'LV', 'Latvia', 'EURO', '251', '5395', '1', '64');
INSERT INTO public.who_global_data_import VALUES (46303, '2020-10-31', 'LV', 'Latvia', 'EURO', '284', '5679', '5', '69');
INSERT INTO public.who_global_data_import VALUES (46304, '2020-11-01', 'LV', 'Latvia', 'EURO', '215', '5894', '2', '71');
INSERT INTO public.who_global_data_import VALUES (46305, '2020-11-02', 'LV', 'Latvia', 'EURO', '242', '6136', '3', '74');
INSERT INTO public.who_global_data_import VALUES (46306, '2020-11-03', 'LV', 'Latvia', 'EURO', '132', '6268', '3', '77');
INSERT INTO public.who_global_data_import VALUES (46307, '2020-11-04', 'LV', 'Latvia', 'EURO', '171', '6439', '2', '79');
INSERT INTO public.who_global_data_import VALUES (46308, '2020-11-05', 'LV', 'Latvia', 'EURO', '313', '6752', '6', '85');
INSERT INTO public.who_global_data_import VALUES (46309, '2020-11-06', 'LV', 'Latvia', 'EURO', '367', '7119', '3', '88');
INSERT INTO public.who_global_data_import VALUES (46310, '2020-11-07', 'LV', 'Latvia', 'EURO', '357', '7476', '7', '95');
INSERT INTO public.who_global_data_import VALUES (46311, '2020-11-08', 'LV', 'Latvia', 'EURO', '404', '7880', '1', '96');
INSERT INTO public.who_global_data_import VALUES (46312, '2020-11-09', 'LV', 'Latvia', 'EURO', '215', '8095', '3', '99');
INSERT INTO public.who_global_data_import VALUES (46313, '2020-11-10', 'LV', 'Latvia', 'EURO', '92', '8187', '2', '101');
INSERT INTO public.who_global_data_import VALUES (46314, '2020-11-11', 'LV', 'Latvia', 'EURO', '208', '8395', '2', '103');
INSERT INTO public.who_global_data_import VALUES (46315, '2020-11-12', 'LV', 'Latvia', 'EURO', '453', '8848', '0', '103');
INSERT INTO public.who_global_data_import VALUES (46316, '2020-11-13', 'LV', 'Latvia', 'EURO', '533', '9381', '4', '107');
INSERT INTO public.who_global_data_import VALUES (46317, '2020-11-14', 'LV', 'Latvia', 'EURO', '455', '9836', '9', '116');
INSERT INTO public.who_global_data_import VALUES (46318, '2020-11-15', 'LV', 'Latvia', 'EURO', '395', '10231', '5', '121');
INSERT INTO public.who_global_data_import VALUES (46319, '2020-11-16', 'LV', 'Latvia', 'EURO', '316', '10547', '2', '123');
INSERT INTO public.who_global_data_import VALUES (46320, '2020-11-17', 'LV', 'Latvia', 'EURO', '89', '10636', '3', '126');
INSERT INTO public.who_global_data_import VALUES (46321, '2020-11-18', 'LV', 'Latvia', 'EURO', '278', '10914', '6', '132');
INSERT INTO public.who_global_data_import VALUES (46322, '2020-11-19', 'LV', 'Latvia', 'EURO', '442', '11356', '5', '137');
INSERT INTO public.who_global_data_import VALUES (46323, '2020-11-20', 'LV', 'Latvia', 'EURO', '366', '11722', '4', '141');
INSERT INTO public.who_global_data_import VALUES (46324, '2020-11-21', 'LV', 'Latvia', 'EURO', '380', '12102', '5', '146');
INSERT INTO public.who_global_data_import VALUES (46325, '2020-11-22', 'LV', 'Latvia', 'EURO', '642', '12744', '7', '153');
INSERT INTO public.who_global_data_import VALUES (46326, '2020-11-23', 'LV', 'Latvia', 'EURO', '376', '13120', '0', '153');
INSERT INTO public.who_global_data_import VALUES (46327, '2020-11-24', 'LV', 'Latvia', 'EURO', '116', '13236', '9', '162');
INSERT INTO public.who_global_data_import VALUES (46328, '2020-11-25', 'LV', 'Latvia', 'EURO', '457', '13693', '13', '175');
INSERT INTO public.who_global_data_import VALUES (46329, '2020-11-26', 'LV', 'Latvia', 'EURO', '580', '14273', '9', '184');
INSERT INTO public.who_global_data_import VALUES (46330, '2020-11-27', 'LV', 'Latvia', 'EURO', '898', '15171', '4', '188');
INSERT INTO public.who_global_data_import VALUES (46331, '2020-11-28', 'LV', 'Latvia', 'EURO', '637', '15808', '2', '190');
INSERT INTO public.who_global_data_import VALUES (46332, '2020-11-29', 'LV', 'Latvia', 'EURO', '753', '16561', '3', '193');
INSERT INTO public.who_global_data_import VALUES (46333, '2020-11-30', 'LV', 'Latvia', 'EURO', '414', '16975', '4', '197');
INSERT INTO public.who_global_data_import VALUES (46334, '2020-12-01', 'LV', 'Latvia', 'EURO', '100', '17075', '9', '206');
INSERT INTO public.who_global_data_import VALUES (46335, '2020-12-02', 'LV', 'Latvia', 'EURO', '612', '17687', '4', '210');
INSERT INTO public.who_global_data_import VALUES (46336, '2020-12-03', 'LV', 'Latvia', 'EURO', '690', '18377', '14', '224');
INSERT INTO public.who_global_data_import VALUES (46337, '2020-12-04', 'LV', 'Latvia', 'EURO', '930', '19307', '11', '235');
INSERT INTO public.who_global_data_import VALUES (46338, '2020-12-05', 'LV', 'Latvia', 'EURO', '686', '19993', '7', '242');
INSERT INTO public.who_global_data_import VALUES (46339, '2020-12-06', 'LV', 'Latvia', 'EURO', '794', '20787', '11', '253');
INSERT INTO public.who_global_data_import VALUES (46340, '2020-12-07', 'LV', 'Latvia', 'EURO', '526', '21313', '9', '262');
INSERT INTO public.who_global_data_import VALUES (46341, '2020-12-08', 'LV', 'Latvia', 'EURO', '207', '21520', '10', '272');
INSERT INTO public.who_global_data_import VALUES (46342, '2020-12-09', 'LV', 'Latvia', 'EURO', '584', '22104', '16', '288');
INSERT INTO public.who_global_data_import VALUES (46343, '2020-12-10', 'LV', 'Latvia', 'EURO', '712', '22816', '5', '293');
INSERT INTO public.who_global_data_import VALUES (46344, '2020-12-11', 'LV', 'Latvia', 'EURO', '890', '23706', '11', '304');
INSERT INTO public.who_global_data_import VALUES (46345, '2020-12-12', 'LV', 'Latvia', 'EURO', '680', '24386', '15', '319');
INSERT INTO public.who_global_data_import VALUES (46346, '2020-12-13', 'LV', 'Latvia', 'EURO', '660', '25046', '5', '324');
INSERT INTO public.who_global_data_import VALUES (46347, '2020-12-14', 'LV', 'Latvia', 'EURO', '629', '25675', '25', '349');
INSERT INTO public.who_global_data_import VALUES (46348, '2020-12-15', 'LV', 'Latvia', 'EURO', '210', '25885', '3', '352');
INSERT INTO public.who_global_data_import VALUES (46349, '2020-12-16', 'LV', 'Latvia', 'EURO', '587', '26472', '5', '357');
INSERT INTO public.who_global_data_import VALUES (46350, '2020-12-17', 'LV', 'Latvia', 'EURO', '1023', '27495', '25', '382');
INSERT INTO public.who_global_data_import VALUES (46351, '2020-12-18', 'LV', 'Latvia', 'EURO', '1040', '28535', '12', '394');
INSERT INTO public.who_global_data_import VALUES (46352, '2020-12-19', 'LV', 'Latvia', 'EURO', '892', '29427', '15', '409');
INSERT INTO public.who_global_data_import VALUES (46353, '2020-12-20', 'LV', 'Latvia', 'EURO', '870', '30297', '18', '427');
INSERT INTO public.who_global_data_import VALUES (46354, '2020-12-21', 'LV', 'Latvia', 'EURO', '643', '30940', '12', '439');
INSERT INTO public.who_global_data_import VALUES (46355, '2020-12-22', 'LV', 'Latvia', 'EURO', '395', '31335', '4', '443');
INSERT INTO public.who_global_data_import VALUES (46356, '2020-12-23', 'LV', 'Latvia', 'EURO', '1004', '32339', '16', '459');
INSERT INTO public.who_global_data_import VALUES (46357, '2020-12-24', 'LV', 'Latvia', 'EURO', '1145', '33484', '20', '479');
INSERT INTO public.who_global_data_import VALUES (46358, '2020-12-25', 'LV', 'Latvia', 'EURO', '1270', '34754', '7', '486');
INSERT INTO public.who_global_data_import VALUES (46359, '2020-12-26', 'LV', 'Latvia', 'EURO', '666', '35420', '16', '502');
INSERT INTO public.who_global_data_import VALUES (46360, '2020-12-27', 'LV', 'Latvia', 'EURO', '399', '35819', '13', '515');
INSERT INTO public.who_global_data_import VALUES (46361, '2020-12-28', 'LV', 'Latvia', 'EURO', '511', '36330', '44', '559');
INSERT INTO public.who_global_data_import VALUES (46362, '2020-12-29', 'LV', 'Latvia', 'EURO', '508', '36838', '19', '578');
INSERT INTO public.who_global_data_import VALUES (46363, '2020-12-30', 'LV', 'Latvia', 'EURO', '838', '37676', '25', '603');
INSERT INTO public.who_global_data_import VALUES (46364, '2020-12-31', 'LV', 'Latvia', 'EURO', '1367', '39043', '23', '626');
INSERT INTO public.who_global_data_import VALUES (46365, '2021-01-01', 'LV', 'Latvia', 'EURO', '1861', '40904', '9', '635');
INSERT INTO public.who_global_data_import VALUES (46366, '2021-01-02', 'LV', 'Latvia', 'EURO', '711', '41615', '9', '644');
INSERT INTO public.who_global_data_import VALUES (46367, '2021-01-03', 'LV', 'Latvia', 'EURO', '314', '41929', '24', '668');
INSERT INTO public.who_global_data_import VALUES (46368, '2021-01-04', 'LV', 'Latvia', 'EURO', '568', '42497', '12', '680');
INSERT INTO public.who_global_data_import VALUES (46369, '2021-01-05', 'LV', 'Latvia', 'EURO', '621', '43118', '12', '692');
INSERT INTO public.who_global_data_import VALUES (46370, '2021-01-06', 'LV', 'Latvia', 'EURO', '824', '43942', '30', '722');
INSERT INTO public.who_global_data_import VALUES (46371, '2021-01-07', 'LV', 'Latvia', 'EURO', '1229', '45171', '32', '754');
INSERT INTO public.who_global_data_import VALUES (46372, '2021-01-08', 'LV', 'Latvia', 'EURO', '1374', '46545', '36', '790');
INSERT INTO public.who_global_data_import VALUES (46373, '2021-01-09', 'LV', 'Latvia', 'EURO', '1237', '47782', '11', '801');
INSERT INTO public.who_global_data_import VALUES (46374, '2021-01-10', 'LV', 'Latvia', 'EURO', '1170', '48952', '17', '818');
INSERT INTO public.who_global_data_import VALUES (46375, '2021-01-11', 'LV', 'Latvia', 'EURO', '616', '49568', '31', '849');
INSERT INTO public.who_global_data_import VALUES (46376, '2021-01-12', 'LV', 'Latvia', 'EURO', '331', '49899', '15', '864');
INSERT INTO public.who_global_data_import VALUES (46377, '2021-01-13', 'LV', 'Latvia', 'EURO', '878', '50777', '18', '882');
INSERT INTO public.who_global_data_import VALUES (46378, '2021-01-14', 'LV', 'Latvia', 'EURO', '1255', '52032', '27', '909');
INSERT INTO public.who_global_data_import VALUES (46379, '2021-01-15', 'LV', 'Latvia', 'EURO', '950', '52982', '11', '920');
INSERT INTO public.who_global_data_import VALUES (46380, '2021-01-16', 'LV', 'Latvia', 'EURO', '1084', '54066', '0', '920');
INSERT INTO public.who_global_data_import VALUES (46381, '2021-01-17', 'LV', 'Latvia', 'EURO', '1031', '55097', '41', '961');
INSERT INTO public.who_global_data_import VALUES (46382, '2021-01-18', 'LV', 'Latvia', 'EURO', '567', '55664', '17', '978');
INSERT INTO public.who_global_data_import VALUES (46383, '2021-01-19', 'LV', 'Latvia', 'EURO', '244', '55908', '5', '983');
INSERT INTO public.who_global_data_import VALUES (46384, '2021-01-20', 'LV', 'Latvia', 'EURO', '812', '56720', '29', '1012');
INSERT INTO public.who_global_data_import VALUES (46385, '2021-01-21', 'LV', 'Latvia', 'EURO', '1088', '57808', '20', '1032');
INSERT INTO public.who_global_data_import VALUES (46386, '2021-01-22', 'LV', 'Latvia', 'EURO', '902', '58710', '25', '1057');
INSERT INTO public.who_global_data_import VALUES (46387, '2021-01-23', 'LV', 'Latvia', 'EURO', '876', '59586', '19', '1076');
INSERT INTO public.who_global_data_import VALUES (46388, '2021-01-24', 'LV', 'Latvia', 'EURO', '910', '60496', '21', '1097');
INSERT INTO public.who_global_data_import VALUES (46389, '2021-01-25', 'LV', 'Latvia', 'EURO', '512', '61008', '14', '1111');
INSERT INTO public.who_global_data_import VALUES (46390, '2021-01-26', 'LV', 'Latvia', 'EURO', '223', '61231', '3', '1114');
INSERT INTO public.who_global_data_import VALUES (46391, '2021-01-27', 'LV', 'Latvia', 'EURO', '693', '61924', '12', '1126');
INSERT INTO public.who_global_data_import VALUES (46392, '2021-01-28', 'LV', 'Latvia', 'EURO', '1103', '63027', '12', '1138');
INSERT INTO public.who_global_data_import VALUES (46393, '2021-01-29', 'LV', 'Latvia', 'EURO', '965', '63992', '10', '1148');
INSERT INTO public.who_global_data_import VALUES (46394, '2021-01-30', 'LV', 'Latvia', 'EURO', '931', '64923', '18', '1166');
INSERT INTO public.who_global_data_import VALUES (46395, '2021-01-31', 'LV', 'Latvia', 'EURO', '785', '65708', '14', '1180');
INSERT INTO public.who_global_data_import VALUES (46396, '2021-02-01', 'LV', 'Latvia', 'EURO', '533', '66241', '15', '1195');
INSERT INTO public.who_global_data_import VALUES (46397, '2021-02-02', 'LV', 'Latvia', 'EURO', '411', '66652', '7', '1202');
INSERT INTO public.who_global_data_import VALUES (46398, '2021-02-03', 'LV', 'Latvia', 'EURO', '775', '67427', '17', '1219');
INSERT INTO public.who_global_data_import VALUES (46399, '2021-02-04', 'LV', 'Latvia', 'EURO', '1231', '68658', '31', '1250');
INSERT INTO public.who_global_data_import VALUES (46400, '2021-02-05', 'LV', 'Latvia', 'EURO', '742', '69400', '31', '1281');
INSERT INTO public.who_global_data_import VALUES (46401, '2020-01-03', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46402, '2020-01-04', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46403, '2020-01-05', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46404, '2020-01-06', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46405, '2020-01-07', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46406, '2020-01-08', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46407, '2020-01-09', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46408, '2020-01-10', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46409, '2020-01-11', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46410, '2020-01-12', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46411, '2020-01-13', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46412, '2020-01-14', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46413, '2020-01-15', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46414, '2020-01-16', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46415, '2020-01-17', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46416, '2020-01-18', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46417, '2020-01-19', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46418, '2020-01-20', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46419, '2020-01-21', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46420, '2020-01-22', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46421, '2020-01-23', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46422, '2020-01-24', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46423, '2020-01-25', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46424, '2020-01-26', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46425, '2020-01-27', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46426, '2020-01-28', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46427, '2020-01-29', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46428, '2020-01-30', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46429, '2020-01-31', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46430, '2020-02-01', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46431, '2020-02-02', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46432, '2020-02-03', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46433, '2020-02-04', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46434, '2020-02-05', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46435, '2020-02-06', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46436, '2020-02-07', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46437, '2020-02-08', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46438, '2020-02-09', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46439, '2020-02-10', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46440, '2020-02-11', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46441, '2020-02-12', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46442, '2020-02-13', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46443, '2020-02-14', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46444, '2020-02-15', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46445, '2020-02-16', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46446, '2020-02-17', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46447, '2020-02-18', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46448, '2020-02-19', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46449, '2020-02-20', 'LB', 'Lebanon', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46450, '2020-02-21', 'LB', 'Lebanon', 'EMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46451, '2020-02-22', 'LB', 'Lebanon', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46452, '2020-02-23', 'LB', 'Lebanon', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46453, '2020-02-24', 'LB', 'Lebanon', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46454, '2020-02-25', 'LB', 'Lebanon', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46455, '2020-02-26', 'LB', 'Lebanon', 'EMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46456, '2020-02-27', 'LB', 'Lebanon', 'EMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46457, '2020-02-28', 'LB', 'Lebanon', 'EMRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46458, '2020-02-29', 'LB', 'Lebanon', 'EMRO', '3', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46459, '2020-03-01', 'LB', 'Lebanon', 'EMRO', '3', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46460, '2020-03-02', 'LB', 'Lebanon', 'EMRO', '3', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46461, '2020-03-03', 'LB', 'Lebanon', 'EMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46462, '2020-03-04', 'LB', 'Lebanon', 'EMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46463, '2020-03-05', 'LB', 'Lebanon', 'EMRO', '3', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46464, '2020-03-06', 'LB', 'Lebanon', 'EMRO', '6', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46465, '2020-03-07', 'LB', 'Lebanon', 'EMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46466, '2020-03-08', 'LB', 'Lebanon', 'EMRO', '10', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46467, '2020-03-09', 'LB', 'Lebanon', 'EMRO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46468, '2020-03-10', 'LB', 'Lebanon', 'EMRO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46469, '2020-03-11', 'LB', 'Lebanon', 'EMRO', '29', '65', '1', '1');
INSERT INTO public.who_global_data_import VALUES (46470, '2020-03-12', 'LB', 'Lebanon', 'EMRO', '5', '70', '2', '3');
INSERT INTO public.who_global_data_import VALUES (46471, '2020-03-13', 'LB', 'Lebanon', 'EMRO', '0', '70', '0', '3');
INSERT INTO public.who_global_data_import VALUES (46472, '2020-03-14', 'LB', 'Lebanon', 'EMRO', '27', '97', '0', '3');
INSERT INTO public.who_global_data_import VALUES (46473, '2020-03-15', 'LB', 'Lebanon', 'EMRO', '6', '103', '0', '3');
INSERT INTO public.who_global_data_import VALUES (46474, '2020-03-16', 'LB', 'Lebanon', 'EMRO', '0', '103', '0', '3');
INSERT INTO public.who_global_data_import VALUES (46475, '2020-03-17', 'LB', 'Lebanon', 'EMRO', '21', '124', '0', '3');
INSERT INTO public.who_global_data_import VALUES (46476, '2020-03-18', 'LB', 'Lebanon', 'EMRO', '0', '124', '1', '4');
INSERT INTO public.who_global_data_import VALUES (46477, '2020-03-19', 'LB', 'Lebanon', 'EMRO', '29', '153', '0', '4');
INSERT INTO public.who_global_data_import VALUES (46478, '2020-03-20', 'LB', 'Lebanon', 'EMRO', '10', '163', '0', '4');
INSERT INTO public.who_global_data_import VALUES (46479, '2020-03-21', 'LB', 'Lebanon', 'EMRO', '43', '206', '0', '4');
INSERT INTO public.who_global_data_import VALUES (46480, '2020-03-22', 'LB', 'Lebanon', 'EMRO', '42', '248', '0', '4');
INSERT INTO public.who_global_data_import VALUES (46481, '2020-03-23', 'LB', 'Lebanon', 'EMRO', '19', '267', '0', '4');
INSERT INTO public.who_global_data_import VALUES (46482, '2020-03-24', 'LB', 'Lebanon', 'EMRO', '37', '304', '0', '4');
INSERT INTO public.who_global_data_import VALUES (46483, '2020-03-25', 'LB', 'Lebanon', 'EMRO', '29', '333', '0', '4');
INSERT INTO public.who_global_data_import VALUES (46484, '2020-03-26', 'LB', 'Lebanon', 'EMRO', '35', '368', '2', '6');
INSERT INTO public.who_global_data_import VALUES (46485, '2020-03-27', 'LB', 'Lebanon', 'EMRO', '23', '391', '1', '7');
INSERT INTO public.who_global_data_import VALUES (46486, '2020-03-28', 'LB', 'Lebanon', 'EMRO', '21', '412', '1', '8');
INSERT INTO public.who_global_data_import VALUES (46487, '2020-03-29', 'LB', 'Lebanon', 'EMRO', '26', '438', '2', '10');
INSERT INTO public.who_global_data_import VALUES (46488, '2020-03-30', 'LB', 'Lebanon', 'EMRO', '8', '446', '1', '11');
INSERT INTO public.who_global_data_import VALUES (46489, '2020-03-31', 'LB', 'Lebanon', 'EMRO', '17', '463', '1', '12');
INSERT INTO public.who_global_data_import VALUES (46490, '2020-04-01', 'LB', 'Lebanon', 'EMRO', '16', '479', '0', '12');
INSERT INTO public.who_global_data_import VALUES (46491, '2020-04-02', 'LB', 'Lebanon', 'EMRO', '15', '494', '4', '16');
INSERT INTO public.who_global_data_import VALUES (46492, '2020-04-03', 'LB', 'Lebanon', 'EMRO', '14', '508', '1', '17');
INSERT INTO public.who_global_data_import VALUES (46493, '2020-04-04', 'LB', 'Lebanon', 'EMRO', '12', '520', '0', '17');
INSERT INTO public.who_global_data_import VALUES (46494, '2020-04-05', 'LB', 'Lebanon', 'EMRO', '7', '527', '1', '18');
INSERT INTO public.who_global_data_import VALUES (46495, '2020-04-06', 'LB', 'Lebanon', 'EMRO', '14', '541', '1', '19');
INSERT INTO public.who_global_data_import VALUES (46496, '2020-04-07', 'LB', 'Lebanon', 'EMRO', '7', '548', '0', '19');
INSERT INTO public.who_global_data_import VALUES (46497, '2020-04-08', 'LB', 'Lebanon', 'EMRO', '27', '575', '0', '19');
INSERT INTO public.who_global_data_import VALUES (46498, '2020-04-09', 'LB', 'Lebanon', 'EMRO', '7', '582', '0', '19');
INSERT INTO public.who_global_data_import VALUES (46499, '2020-04-10', 'LB', 'Lebanon', 'EMRO', '27', '609', '1', '20');
INSERT INTO public.who_global_data_import VALUES (46500, '2020-04-11', 'LB', 'Lebanon', 'EMRO', '10', '619', '0', '20');
INSERT INTO public.who_global_data_import VALUES (46501, '2020-04-12', 'LB', 'Lebanon', 'EMRO', '11', '630', '0', '20');
INSERT INTO public.who_global_data_import VALUES (46502, '2020-04-13', 'LB', 'Lebanon', 'EMRO', '2', '632', '0', '20');
INSERT INTO public.who_global_data_import VALUES (46503, '2020-04-14', 'LB', 'Lebanon', 'EMRO', '9', '641', '1', '21');
INSERT INTO public.who_global_data_import VALUES (46504, '2020-04-15', 'LB', 'Lebanon', 'EMRO', '17', '658', '0', '21');
INSERT INTO public.who_global_data_import VALUES (46505, '2020-04-16', 'LB', 'Lebanon', 'EMRO', '5', '663', '0', '21');
INSERT INTO public.who_global_data_import VALUES (46506, '2020-04-17', 'LB', 'Lebanon', 'EMRO', '5', '668', '0', '21');
INSERT INTO public.who_global_data_import VALUES (46507, '2020-04-18', 'LB', 'Lebanon', 'EMRO', '4', '672', '0', '21');
INSERT INTO public.who_global_data_import VALUES (46508, '2020-04-19', 'LB', 'Lebanon', 'EMRO', '1', '673', '0', '21');
INSERT INTO public.who_global_data_import VALUES (46509, '2020-04-20', 'LB', 'Lebanon', 'EMRO', '4', '677', '0', '21');
INSERT INTO public.who_global_data_import VALUES (46510, '2020-04-21', 'LB', 'Lebanon', 'EMRO', '0', '677', '0', '21');
INSERT INTO public.who_global_data_import VALUES (46511, '2020-04-22', 'LB', 'Lebanon', 'EMRO', '5', '682', '1', '22');
INSERT INTO public.who_global_data_import VALUES (46512, '2020-04-23', 'LB', 'Lebanon', 'EMRO', '6', '688', '0', '22');
INSERT INTO public.who_global_data_import VALUES (46513, '2020-04-24', 'LB', 'Lebanon', 'EMRO', '8', '696', '0', '22');
INSERT INTO public.who_global_data_import VALUES (46514, '2020-04-25', 'LB', 'Lebanon', 'EMRO', '8', '704', '2', '24');
INSERT INTO public.who_global_data_import VALUES (46515, '2020-04-26', 'LB', 'Lebanon', 'EMRO', '3', '707', '0', '24');
INSERT INTO public.who_global_data_import VALUES (46516, '2020-04-27', 'LB', 'Lebanon', 'EMRO', '3', '710', '0', '24');
INSERT INTO public.who_global_data_import VALUES (46517, '2020-04-28', 'LB', 'Lebanon', 'EMRO', '7', '717', '0', '24');
INSERT INTO public.who_global_data_import VALUES (46518, '2020-04-29', 'LB', 'Lebanon', 'EMRO', '4', '721', '0', '24');
INSERT INTO public.who_global_data_import VALUES (46519, '2020-04-30', 'LB', 'Lebanon', 'EMRO', '4', '725', '0', '24');
INSERT INTO public.who_global_data_import VALUES (46520, '2020-05-01', 'LB', 'Lebanon', 'EMRO', '4', '729', '0', '24');
INSERT INTO public.who_global_data_import VALUES (46521, '2020-05-02', 'LB', 'Lebanon', 'EMRO', '4', '733', '1', '25');
INSERT INTO public.who_global_data_import VALUES (46522, '2020-05-03', 'LB', 'Lebanon', 'EMRO', '4', '737', '0', '25');
INSERT INTO public.who_global_data_import VALUES (46523, '2020-05-04', 'LB', 'Lebanon', 'EMRO', '3', '740', '0', '25');
INSERT INTO public.who_global_data_import VALUES (46524, '2020-05-05', 'LB', 'Lebanon', 'EMRO', '1', '741', '0', '25');
INSERT INTO public.who_global_data_import VALUES (46525, '2020-05-06', 'LB', 'Lebanon', 'EMRO', '9', '750', '0', '25');
INSERT INTO public.who_global_data_import VALUES (46526, '2020-05-07', 'LB', 'Lebanon', 'EMRO', '34', '784', '0', '25');
INSERT INTO public.who_global_data_import VALUES (46527, '2020-05-08', 'LB', 'Lebanon', 'EMRO', '12', '796', '1', '26');
INSERT INTO public.who_global_data_import VALUES (46528, '2020-05-09', 'LB', 'Lebanon', 'EMRO', '13', '809', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46529, '2020-05-10', 'LB', 'Lebanon', 'EMRO', '36', '845', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46530, '2020-05-11', 'LB', 'Lebanon', 'EMRO', '14', '859', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46531, '2020-05-12', 'LB', 'Lebanon', 'EMRO', '11', '870', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46532, '2020-05-13', 'LB', 'Lebanon', 'EMRO', '8', '878', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46533, '2020-05-14', 'LB', 'Lebanon', 'EMRO', '8', '886', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46534, '2020-05-15', 'LB', 'Lebanon', 'EMRO', '5', '891', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46535, '2020-05-16', 'LB', 'Lebanon', 'EMRO', '11', '902', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46536, '2020-05-17', 'LB', 'Lebanon', 'EMRO', '9', '911', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46537, '2020-05-18', 'LB', 'Lebanon', 'EMRO', '20', '931', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46538, '2020-05-19', 'LB', 'Lebanon', 'EMRO', '23', '954', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46539, '2020-05-20', 'LB', 'Lebanon', 'EMRO', '7', '961', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46540, '2020-05-21', 'LB', 'Lebanon', 'EMRO', '63', '1024', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46541, '2020-05-22', 'LB', 'Lebanon', 'EMRO', '0', '1024', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46542, '2020-05-23', 'LB', 'Lebanon', 'EMRO', '62', '1086', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46543, '2020-05-24', 'LB', 'Lebanon', 'EMRO', '11', '1097', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46544, '2020-05-25', 'LB', 'Lebanon', 'EMRO', '17', '1114', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46545, '2020-05-26', 'LB', 'Lebanon', 'EMRO', '5', '1119', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46546, '2020-05-27', 'LB', 'Lebanon', 'EMRO', '21', '1140', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46547, '2020-05-28', 'LB', 'Lebanon', 'EMRO', '21', '1161', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46548, '2020-05-29', 'LB', 'Lebanon', 'EMRO', '7', '1168', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46549, '2020-05-30', 'LB', 'Lebanon', 'EMRO', '4', '1172', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46550, '2020-05-31', 'LB', 'Lebanon', 'EMRO', '19', '1191', '0', '26');
INSERT INTO public.who_global_data_import VALUES (46551, '2020-06-01', 'LB', 'Lebanon', 'EMRO', '29', '1220', '1', '27');
INSERT INTO public.who_global_data_import VALUES (46552, '2020-06-02', 'LB', 'Lebanon', 'EMRO', '13', '1233', '0', '27');
INSERT INTO public.who_global_data_import VALUES (46553, '2020-06-03', 'LB', 'Lebanon', 'EMRO', '9', '1242', '0', '27');
INSERT INTO public.who_global_data_import VALUES (46554, '2020-06-04', 'LB', 'Lebanon', 'EMRO', '14', '1256', '0', '27');
INSERT INTO public.who_global_data_import VALUES (46555, '2020-06-05', 'LB', 'Lebanon', 'EMRO', '50', '1306', '1', '28');
INSERT INTO public.who_global_data_import VALUES (46556, '2020-06-06', 'LB', 'Lebanon', 'EMRO', '6', '1312', '0', '28');
INSERT INTO public.who_global_data_import VALUES (46557, '2020-06-07', 'LB', 'Lebanon', 'EMRO', '8', '1320', '1', '29');
INSERT INTO public.who_global_data_import VALUES (46558, '2020-06-08', 'LB', 'Lebanon', 'EMRO', '11', '1331', '1', '30');
INSERT INTO public.who_global_data_import VALUES (46559, '2020-06-09', 'LB', 'Lebanon', 'EMRO', '19', '1350', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46560, '2020-06-10', 'LB', 'Lebanon', 'EMRO', '18', '1368', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46561, '2020-06-11', 'LB', 'Lebanon', 'EMRO', '20', '1388', '0', '30');
INSERT INTO public.who_global_data_import VALUES (46562, '2020-06-12', 'LB', 'Lebanon', 'EMRO', '14', '1402', '1', '31');
INSERT INTO public.who_global_data_import VALUES (46563, '2020-06-13', 'LB', 'Lebanon', 'EMRO', '20', '1422', '0', '31');
INSERT INTO public.who_global_data_import VALUES (46564, '2020-06-14', 'LB', 'Lebanon', 'EMRO', '20', '1442', '1', '32');
INSERT INTO public.who_global_data_import VALUES (46565, '2020-06-15', 'LB', 'Lebanon', 'EMRO', '4', '1446', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46566, '2020-06-16', 'LB', 'Lebanon', 'EMRO', '18', '1464', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46567, '2020-06-17', 'LB', 'Lebanon', 'EMRO', '9', '1473', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46568, '2020-06-18', 'LB', 'Lebanon', 'EMRO', '16', '1489', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46569, '2020-06-19', 'LB', 'Lebanon', 'EMRO', '6', '1495', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46570, '2020-06-20', 'LB', 'Lebanon', 'EMRO', '15', '1510', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46571, '2020-06-21', 'LB', 'Lebanon', 'EMRO', '26', '1536', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46572, '2020-06-22', 'LB', 'Lebanon', 'EMRO', '51', '1587', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46573, '2020-06-23', 'LB', 'Lebanon', 'EMRO', '16', '1603', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46574, '2020-06-24', 'LB', 'Lebanon', 'EMRO', '19', '1622', '0', '32');
INSERT INTO public.who_global_data_import VALUES (46575, '2020-06-25', 'LB', 'Lebanon', 'EMRO', '22', '1644', '1', '33');
INSERT INTO public.who_global_data_import VALUES (46576, '2020-06-26', 'LB', 'Lebanon', 'EMRO', '18', '1662', '0', '33');
INSERT INTO public.who_global_data_import VALUES (46577, '2020-06-27', 'LB', 'Lebanon', 'EMRO', '35', '1697', '0', '33');
INSERT INTO public.who_global_data_import VALUES (46578, '2020-06-28', 'LB', 'Lebanon', 'EMRO', '22', '1719', '0', '33');
INSERT INTO public.who_global_data_import VALUES (46579, '2020-06-29', 'LB', 'Lebanon', 'EMRO', '21', '1740', '0', '33');
INSERT INTO public.who_global_data_import VALUES (46580, '2020-06-30', 'LB', 'Lebanon', 'EMRO', '5', '1745', '1', '34');
INSERT INTO public.who_global_data_import VALUES (46581, '2020-07-01', 'LB', 'Lebanon', 'EMRO', '33', '1778', '0', '34');
INSERT INTO public.who_global_data_import VALUES (46582, '2020-07-02', 'LB', 'Lebanon', 'EMRO', '10', '1788', '0', '34');
INSERT INTO public.who_global_data_import VALUES (46583, '2020-07-03', 'LB', 'Lebanon', 'EMRO', '8', '1796', '1', '35');
INSERT INTO public.who_global_data_import VALUES (46584, '2020-07-04', 'LB', 'Lebanon', 'EMRO', '34', '1830', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46585, '2020-07-05', 'LB', 'Lebanon', 'EMRO', '25', '1855', '0', '35');
INSERT INTO public.who_global_data_import VALUES (46586, '2020-07-06', 'LB', 'Lebanon', 'EMRO', '18', '1873', '1', '36');
INSERT INTO public.who_global_data_import VALUES (46587, '2020-07-07', 'LB', 'Lebanon', 'EMRO', '12', '1885', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46588, '2020-07-08', 'LB', 'Lebanon', 'EMRO', '22', '1907', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46589, '2020-07-09', 'LB', 'Lebanon', 'EMRO', '38', '1945', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46590, '2020-07-10', 'LB', 'Lebanon', 'EMRO', '66', '2011', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46591, '2020-07-11', 'LB', 'Lebanon', 'EMRO', '71', '2082', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46592, '2020-07-12', 'LB', 'Lebanon', 'EMRO', '86', '2168', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46593, '2020-07-13', 'LB', 'Lebanon', 'EMRO', '166', '2334', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46594, '2020-07-14', 'LB', 'Lebanon', 'EMRO', '85', '2419', '0', '36');
INSERT INTO public.who_global_data_import VALUES (46595, '2020-07-15', 'LB', 'Lebanon', 'EMRO', '32', '2451', '1', '37');
INSERT INTO public.who_global_data_import VALUES (46596, '2020-07-16', 'LB', 'Lebanon', 'EMRO', '91', '2542', '1', '38');
INSERT INTO public.who_global_data_import VALUES (46597, '2020-07-17', 'LB', 'Lebanon', 'EMRO', '57', '2599', '2', '40');
INSERT INTO public.who_global_data_import VALUES (46598, '2020-07-18', 'LB', 'Lebanon', 'EMRO', '101', '2700', '0', '40');
INSERT INTO public.who_global_data_import VALUES (46599, '2020-07-19', 'LB', 'Lebanon', 'EMRO', '75', '2775', '0', '40');
INSERT INTO public.who_global_data_import VALUES (46600, '2020-07-20', 'LB', 'Lebanon', 'EMRO', '84', '2859', '0', '40');
INSERT INTO public.who_global_data_import VALUES (46601, '2020-07-21', 'LB', 'Lebanon', 'EMRO', '46', '2905', '1', '41');
INSERT INTO public.who_global_data_import VALUES (46602, '2020-07-22', 'LB', 'Lebanon', 'EMRO', '75', '2980', '0', '41');
INSERT INTO public.who_global_data_import VALUES (46603, '2020-07-23', 'LB', 'Lebanon', 'EMRO', '124', '3104', '2', '43');
INSERT INTO public.who_global_data_import VALUES (46604, '2020-07-24', 'LB', 'Lebanon', 'EMRO', '156', '3260', '0', '43');
INSERT INTO public.who_global_data_import VALUES (46605, '2020-07-25', 'LB', 'Lebanon', 'EMRO', '147', '3407', '3', '46');
INSERT INTO public.who_global_data_import VALUES (46606, '2020-07-26', 'LB', 'Lebanon', 'EMRO', '175', '3582', '1', '47');
INSERT INTO public.who_global_data_import VALUES (46607, '2020-07-27', 'LB', 'Lebanon', 'EMRO', '168', '3750', '4', '51');
INSERT INTO public.who_global_data_import VALUES (46608, '2020-07-28', 'LB', 'Lebanon', 'EMRO', '132', '3882', '0', '51');
INSERT INTO public.who_global_data_import VALUES (46609, '2020-07-29', 'LB', 'Lebanon', 'EMRO', '141', '4023', '3', '54');
INSERT INTO public.who_global_data_import VALUES (46610, '2020-07-30', 'LB', 'Lebanon', 'EMRO', '182', '4205', '1', '55');
INSERT INTO public.who_global_data_import VALUES (46611, '2020-07-31', 'LB', 'Lebanon', 'EMRO', '129', '4334', '2', '57');
INSERT INTO public.who_global_data_import VALUES (46612, '2020-08-01', 'LB', 'Lebanon', 'EMRO', '221', '4555', '2', '59');
INSERT INTO public.who_global_data_import VALUES (46613, '2020-08-02', 'LB', 'Lebanon', 'EMRO', '175', '4730', '2', '61');
INSERT INTO public.who_global_data_import VALUES (46614, '2020-08-03', 'LB', 'Lebanon', 'EMRO', '155', '4885', '1', '62');
INSERT INTO public.who_global_data_import VALUES (46615, '2020-08-04', 'LB', 'Lebanon', 'EMRO', '177', '5062', '3', '65');
INSERT INTO public.who_global_data_import VALUES (46616, '2020-08-05', 'LB', 'Lebanon', 'EMRO', '209', '5271', '1', '66');
INSERT INTO public.who_global_data_import VALUES (46617, '2020-08-06', 'LB', 'Lebanon', 'EMRO', '146', '5417', '2', '68');
INSERT INTO public.who_global_data_import VALUES (46618, '2020-08-07', 'LB', 'Lebanon', 'EMRO', '255', '5672', '2', '70');
INSERT INTO public.who_global_data_import VALUES (46619, '2020-08-08', 'LB', 'Lebanon', 'EMRO', '279', '5951', '0', '70');
INSERT INTO public.who_global_data_import VALUES (46620, '2020-08-09', 'LB', 'Lebanon', 'EMRO', '272', '6223', '4', '74');
INSERT INTO public.who_global_data_import VALUES (46621, '2020-08-10', 'LB', 'Lebanon', 'EMRO', '294', '6517', '2', '76');
INSERT INTO public.who_global_data_import VALUES (46622, '2020-08-11', 'LB', 'Lebanon', 'EMRO', '295', '6812', '4', '80');
INSERT INTO public.who_global_data_import VALUES (46623, '2020-08-12', 'LB', 'Lebanon', 'EMRO', '309', '7121', '7', '87');
INSERT INTO public.who_global_data_import VALUES (46624, '2020-08-13', 'LB', 'Lebanon', 'EMRO', '292', '7413', '2', '89');
INSERT INTO public.who_global_data_import VALUES (46625, '2020-08-14', 'LB', 'Lebanon', 'EMRO', '298', '7711', '3', '92');
INSERT INTO public.who_global_data_import VALUES (46626, '2020-08-15', 'LB', 'Lebanon', 'EMRO', '334', '8045', '2', '94');
INSERT INTO public.who_global_data_import VALUES (46627, '2020-08-16', 'LB', 'Lebanon', 'EMRO', '397', '8442', '3', '97');
INSERT INTO public.who_global_data_import VALUES (46628, '2020-08-17', 'LB', 'Lebanon', 'EMRO', '439', '8881', '6', '103');
INSERT INTO public.who_global_data_import VALUES (46629, '2020-08-18', 'LB', 'Lebanon', 'EMRO', '456', '9337', '2', '105');
INSERT INTO public.who_global_data_import VALUES (46630, '2020-08-19', 'LB', 'Lebanon', 'EMRO', '421', '9758', '2', '107');
INSERT INTO public.who_global_data_import VALUES (46631, '2020-08-20', 'LB', 'Lebanon', 'EMRO', '589', '10347', '2', '109');
INSERT INTO public.who_global_data_import VALUES (46632, '2020-08-21', 'LB', 'Lebanon', 'EMRO', '605', '10952', '4', '113');
INSERT INTO public.who_global_data_import VALUES (46633, '2020-08-22', 'LB', 'Lebanon', 'EMRO', '628', '11580', '3', '116');
INSERT INTO public.who_global_data_import VALUES (46634, '2020-08-23', 'LB', 'Lebanon', 'EMRO', '611', '12191', '5', '121');
INSERT INTO public.who_global_data_import VALUES (46635, '2020-08-24', 'LB', 'Lebanon', 'EMRO', '507', '12698', '2', '123');
INSERT INTO public.who_global_data_import VALUES (46636, '2020-08-25', 'LB', 'Lebanon', 'EMRO', '457', '13155', '3', '126');
INSERT INTO public.who_global_data_import VALUES (46637, '2020-08-26', 'LB', 'Lebanon', 'EMRO', '532', '13687', '12', '138');
INSERT INTO public.who_global_data_import VALUES (46638, '2020-08-27', 'LB', 'Lebanon', 'EMRO', '561', '14248', '1', '139');
INSERT INTO public.who_global_data_import VALUES (46639, '2020-08-28', 'LB', 'Lebanon', 'EMRO', '689', '14937', '7', '146');
INSERT INTO public.who_global_data_import VALUES (46640, '2020-08-29', 'LB', 'Lebanon', 'EMRO', '676', '15613', '2', '148');
INSERT INTO public.who_global_data_import VALUES (46641, '2020-08-30', 'LB', 'Lebanon', 'EMRO', '662', '16275', '7', '155');
INSERT INTO public.who_global_data_import VALUES (46642, '2020-08-31', 'LB', 'Lebanon', 'EMRO', '595', '16870', '5', '160');
INSERT INTO public.who_global_data_import VALUES (46643, '2020-09-01', 'LB', 'Lebanon', 'EMRO', '438', '17308', '7', '167');
INSERT INTO public.who_global_data_import VALUES (46644, '2020-09-02', 'LB', 'Lebanon', 'EMRO', '459', '17767', '4', '171');
INSERT INTO public.who_global_data_import VALUES (46645, '2020-09-03', 'LB', 'Lebanon', 'EMRO', '598', '18365', '6', '177');
INSERT INTO public.who_global_data_import VALUES (46646, '2020-09-04', 'LB', 'Lebanon', 'EMRO', '588', '18953', '2', '179');
INSERT INTO public.who_global_data_import VALUES (46647, '2020-09-05', 'LB', 'Lebanon', 'EMRO', '527', '19480', '4', '183');
INSERT INTO public.who_global_data_import VALUES (46648, '2020-09-06', 'LB', 'Lebanon', 'EMRO', '531', '20011', '4', '187');
INSERT INTO public.who_global_data_import VALUES (46649, '2020-09-07', 'LB', 'Lebanon', 'EMRO', '415', '20426', '4', '191');
INSERT INTO public.who_global_data_import VALUES (46650, '2020-09-08', 'LB', 'Lebanon', 'EMRO', '400', '20826', '9', '200');
INSERT INTO public.who_global_data_import VALUES (46651, '2020-09-09', 'LB', 'Lebanon', 'EMRO', '498', '21324', '7', '207');
INSERT INTO public.who_global_data_import VALUES (46652, '2020-09-10', 'LB', 'Lebanon', 'EMRO', '553', '21877', '5', '212');
INSERT INTO public.who_global_data_import VALUES (46653, '2020-09-11', 'LB', 'Lebanon', 'EMRO', '560', '22437', '7', '219');
INSERT INTO public.who_global_data_import VALUES (46654, '2020-09-12', 'LB', 'Lebanon', 'EMRO', '546', '22983', '10', '229');
INSERT INTO public.who_global_data_import VALUES (46655, '2020-09-13', 'LB', 'Lebanon', 'EMRO', '686', '23669', '10', '239');
INSERT INTO public.who_global_data_import VALUES (46656, '2020-09-14', 'LB', 'Lebanon', 'EMRO', '641', '24310', '2', '241');
INSERT INTO public.who_global_data_import VALUES (46657, '2020-09-15', 'LB', 'Lebanon', 'EMRO', '547', '24857', '5', '246');
INSERT INTO public.who_global_data_import VALUES (46658, '2020-09-16', 'LB', 'Lebanon', 'EMRO', '592', '25449', '6', '252');
INSERT INTO public.who_global_data_import VALUES (46659, '2020-09-17', 'LB', 'Lebanon', 'EMRO', '634', '26083', '7', '259');
INSERT INTO public.who_global_data_import VALUES (46660, '2020-09-18', 'LB', 'Lebanon', 'EMRO', '685', '26768', '4', '263');
INSERT INTO public.who_global_data_import VALUES (46661, '2020-09-19', 'LB', 'Lebanon', 'EMRO', '750', '27518', '18', '281');
INSERT INTO public.who_global_data_import VALUES (46662, '2020-09-20', 'LB', 'Lebanon', 'EMRO', '779', '28297', '5', '286');
INSERT INTO public.who_global_data_import VALUES (46663, '2020-09-21', 'LB', 'Lebanon', 'EMRO', '1006', '29303', '11', '297');
INSERT INTO public.who_global_data_import VALUES (46664, '2020-09-22', 'LB', 'Lebanon', 'EMRO', '684', '29987', '10', '307');
INSERT INTO public.who_global_data_import VALUES (46665, '2020-09-23', 'LB', 'Lebanon', 'EMRO', '851', '30838', '8', '315');
INSERT INTO public.who_global_data_import VALUES (46666, '2020-09-24', 'LB', 'Lebanon', 'EMRO', '940', '31778', '13', '328');
INSERT INTO public.who_global_data_import VALUES (46667, '2020-09-25', 'LB', 'Lebanon', 'EMRO', '1027', '32805', '1', '329');
INSERT INTO public.who_global_data_import VALUES (46668, '2020-09-26', 'LB', 'Lebanon', 'EMRO', '1143', '33948', '4', '333');
INSERT INTO public.who_global_data_import VALUES (46669, '2020-09-27', 'LB', 'Lebanon', 'EMRO', '1280', '35228', '7', '340');
INSERT INTO public.who_global_data_import VALUES (46670, '2020-09-28', 'LB', 'Lebanon', 'EMRO', '1012', '36240', '7', '347');
INSERT INTO public.who_global_data_import VALUES (46671, '2020-09-29', 'LB', 'Lebanon', 'EMRO', '1018', '37258', '4', '351');
INSERT INTO public.who_global_data_import VALUES (46672, '2020-09-30', 'LB', 'Lebanon', 'EMRO', '1105', '38363', '10', '361');
INSERT INTO public.who_global_data_import VALUES (46673, '2020-10-01', 'LB', 'Lebanon', 'EMRO', '1257', '39620', '6', '367');
INSERT INTO public.who_global_data_import VALUES (46674, '2020-10-02', 'LB', 'Lebanon', 'EMRO', '1248', '40868', '7', '374');
INSERT INTO public.who_global_data_import VALUES (46675, '2020-10-03', 'LB', 'Lebanon', 'EMRO', '1291', '42159', '12', '386');
INSERT INTO public.who_global_data_import VALUES (46676, '2020-10-04', 'LB', 'Lebanon', 'EMRO', '1321', '43480', '12', '398');
INSERT INTO public.who_global_data_import VALUES (46677, '2020-10-05', 'LB', 'Lebanon', 'EMRO', '1002', '44482', '8', '406');
INSERT INTO public.who_global_data_import VALUES (46678, '2020-10-06', 'LB', 'Lebanon', 'EMRO', '1175', '45657', '8', '414');
INSERT INTO public.who_global_data_import VALUES (46679, '2020-10-07', 'LB', 'Lebanon', 'EMRO', '1261', '46918', '10', '424');
INSERT INTO public.who_global_data_import VALUES (46680, '2020-10-08', 'LB', 'Lebanon', 'EMRO', '1459', '48377', '9', '433');
INSERT INTO public.who_global_data_import VALUES (46681, '2020-10-09', 'LB', 'Lebanon', 'EMRO', '1367', '49744', '6', '439');
INSERT INTO public.who_global_data_import VALUES (46682, '2020-10-10', 'LB', 'Lebanon', 'EMRO', '1426', '51170', '11', '450');
INSERT INTO public.who_global_data_import VALUES (46683, '2020-10-11', 'LB', 'Lebanon', 'EMRO', '1388', '52558', '5', '455');
INSERT INTO public.who_global_data_import VALUES (46684, '2020-10-12', 'LB', 'Lebanon', 'EMRO', '1010', '53568', '4', '459');
INSERT INTO public.who_global_data_import VALUES (46685, '2020-10-13', 'LB', 'Lebanon', 'EMRO', '1056', '54624', '7', '466');
INSERT INTO public.who_global_data_import VALUES (46686, '2020-10-14', 'LB', 'Lebanon', 'EMRO', '1245', '55869', '13', '479');
INSERT INTO public.who_global_data_import VALUES (46687, '2020-10-15', 'LB', 'Lebanon', 'EMRO', '1226', '57095', '20', '499');
INSERT INTO public.who_global_data_import VALUES (46688, '2020-10-16', 'LB', 'Lebanon', 'EMRO', '1418', '58513', '2', '501');
INSERT INTO public.who_global_data_import VALUES (46689, '2020-10-17', 'LB', 'Lebanon', 'EMRO', '1366', '59879', '8', '509');
INSERT INTO public.who_global_data_import VALUES (46690, '2020-10-18', 'LB', 'Lebanon', 'EMRO', '1068', '60947', '8', '517');
INSERT INTO public.who_global_data_import VALUES (46691, '2020-10-19', 'LB', 'Lebanon', 'EMRO', '1002', '61949', '3', '520');
INSERT INTO public.who_global_data_import VALUES (46692, '2020-10-20', 'LB', 'Lebanon', 'EMRO', '995', '62944', '6', '526');
INSERT INTO public.who_global_data_import VALUES (46693, '2020-10-21', 'LB', 'Lebanon', 'EMRO', '1392', '64336', '5', '531');
INSERT INTO public.who_global_data_import VALUES (46694, '2020-10-22', 'LB', 'Lebanon', 'EMRO', '1241', '65577', '5', '536');
INSERT INTO public.who_global_data_import VALUES (46695, '2020-10-23', 'LB', 'Lebanon', 'EMRO', '1368', '66945', '16', '552');
INSERT INTO public.who_global_data_import VALUES (46696, '2020-10-24', 'LB', 'Lebanon', 'EMRO', '1534', '68479', '7', '559');
INSERT INTO public.who_global_data_import VALUES (46697, '2020-10-25', 'LB', 'Lebanon', 'EMRO', '1427', '69906', '3', '562');
INSERT INTO public.who_global_data_import VALUES (46698, '2020-10-26', 'LB', 'Lebanon', 'EMRO', '1484', '71390', '3', '565');
INSERT INTO public.who_global_data_import VALUES (46699, '2020-10-27', 'LB', 'Lebanon', 'EMRO', '796', '72186', '14', '579');
INSERT INTO public.who_global_data_import VALUES (46700, '2020-10-28', 'LB', 'Lebanon', 'EMRO', '1809', '73995', '11', '590');
INSERT INTO public.who_global_data_import VALUES (46701, '2020-10-29', 'LB', 'Lebanon', 'EMRO', '1850', '75845', '12', '602');
INSERT INTO public.who_global_data_import VALUES (46702, '2020-10-30', 'LB', 'Lebanon', 'EMRO', '1933', '77778', '8', '610');
INSERT INTO public.who_global_data_import VALUES (46703, '2020-10-31', 'LB', 'Lebanon', 'EMRO', '1751', '79529', '15', '625');
INSERT INTO public.who_global_data_import VALUES (46704, '2020-11-01', 'LB', 'Lebanon', 'EMRO', '1699', '81228', '12', '637');
INSERT INTO public.who_global_data_import VALUES (46705, '2020-11-02', 'LB', 'Lebanon', 'EMRO', '1389', '82617', '6', '643');
INSERT INTO public.who_global_data_import VALUES (46706, '2020-11-03', 'LB', 'Lebanon', 'EMRO', '1080', '83697', '9', '652');
INSERT INTO public.who_global_data_import VALUES (46707, '2020-11-04', 'LB', 'Lebanon', 'EMRO', '1512', '85209', '15', '667');
INSERT INTO public.who_global_data_import VALUES (46708, '2020-11-05', 'LB', 'Lebanon', 'EMRO', '1888', '87097', '9', '676');
INSERT INTO public.who_global_data_import VALUES (46709, '2020-11-06', 'LB', 'Lebanon', 'EMRO', '2089', '89186', '7', '683');
INSERT INTO public.who_global_data_import VALUES (46710, '2020-11-07', 'LB', 'Lebanon', 'EMRO', '2142', '91328', '17', '700');
INSERT INTO public.who_global_data_import VALUES (46711, '2020-11-08', 'LB', 'Lebanon', 'EMRO', '1769', '93097', '13', '713');
INSERT INTO public.who_global_data_import VALUES (46712, '2020-11-09', 'LB', 'Lebanon', 'EMRO', '1139', '94236', '10', '723');
INSERT INTO public.who_global_data_import VALUES (46713, '2020-11-10', 'LB', 'Lebanon', 'EMRO', '1119', '95355', '9', '732');
INSERT INTO public.who_global_data_import VALUES (46714, '2020-11-11', 'LB', 'Lebanon', 'EMRO', '1552', '96907', '17', '749');
INSERT INTO public.who_global_data_import VALUES (46715, '2020-11-12', 'LB', 'Lebanon', 'EMRO', '1922', '98829', '14', '763');
INSERT INTO public.who_global_data_import VALUES (46716, '2020-11-13', 'LB', 'Lebanon', 'EMRO', '1874', '100703', '12', '775');
INSERT INTO public.who_global_data_import VALUES (46717, '2020-11-14', 'LB', 'Lebanon', 'EMRO', '1904', '102607', '21', '796');
INSERT INTO public.who_global_data_import VALUES (46718, '2020-11-15', 'LB', 'Lebanon', 'EMRO', '1660', '104267', '10', '806');
INSERT INTO public.who_global_data_import VALUES (46719, '2020-11-16', 'LB', 'Lebanon', 'EMRO', '1163', '105430', '11', '817');
INSERT INTO public.who_global_data_import VALUES (46720, '2020-11-17', 'LB', 'Lebanon', 'EMRO', '1016', '106446', '10', '827');
INSERT INTO public.who_global_data_import VALUES (46721, '2020-11-18', 'LB', 'Lebanon', 'EMRO', '1507', '107953', '12', '839');
INSERT INTO public.who_global_data_import VALUES (46722, '2020-11-19', 'LB', 'Lebanon', 'EMRO', '2084', '110037', '13', '852');
INSERT INTO public.who_global_data_import VALUES (46723, '2020-11-20', 'LB', 'Lebanon', 'EMRO', '1909', '111946', '16', '868');
INSERT INTO public.who_global_data_import VALUES (46724, '2020-11-21', 'LB', 'Lebanon', 'EMRO', '1668', '113614', '16', '884');
INSERT INTO public.who_global_data_import VALUES (46725, '2020-11-22', 'LB', 'Lebanon', 'EMRO', '1628', '115242', '10', '894');
INSERT INTO public.who_global_data_import VALUES (46726, '2020-11-23', 'LB', 'Lebanon', 'EMRO', '1193', '116435', '6', '900');
INSERT INTO public.who_global_data_import VALUES (46727, '2020-11-24', 'LB', 'Lebanon', 'EMRO', '1041', '117476', '11', '911');
INSERT INTO public.who_global_data_import VALUES (46728, '2020-11-25', 'LB', 'Lebanon', 'EMRO', '1188', '118664', '23', '934');
INSERT INTO public.who_global_data_import VALUES (46729, '2020-11-26', 'LB', 'Lebanon', 'EMRO', '1636', '120300', '16', '950');
INSERT INTO public.who_global_data_import VALUES (46730, '2020-11-27', 'LB', 'Lebanon', 'EMRO', '1859', '122159', '24', '974');
INSERT INTO public.who_global_data_import VALUES (46731, '2020-11-28', 'LB', 'Lebanon', 'EMRO', '1782', '123941', '6', '980');
INSERT INTO public.who_global_data_import VALUES (46732, '2020-11-29', 'LB', 'Lebanon', 'EMRO', '1696', '125637', '11', '991');
INSERT INTO public.who_global_data_import VALUES (46733, '2020-11-30', 'LB', 'Lebanon', 'EMRO', '1266', '126903', '13', '1004');
INSERT INTO public.who_global_data_import VALUES (46734, '2020-12-01', 'LB', 'Lebanon', 'EMRO', '1000', '127903', '14', '1018');
INSERT INTO public.who_global_data_import VALUES (46735, '2020-12-02', 'LB', 'Lebanon', 'EMRO', '1511', '129414', '15', '1033');
INSERT INTO public.who_global_data_import VALUES (46736, '2020-12-03', 'LB', 'Lebanon', 'EMRO', '1842', '131256', '22', '1055');
INSERT INTO public.who_global_data_import VALUES (46737, '2020-12-04', 'LB', 'Lebanon', 'EMRO', '1520', '132776', '12', '1067');
INSERT INTO public.who_global_data_import VALUES (46738, '2020-12-05', 'LB', 'Lebanon', 'EMRO', '1478', '134254', '11', '1078');
INSERT INTO public.who_global_data_import VALUES (46739, '2020-12-06', 'LB', 'Lebanon', 'EMRO', '1622', '135876', '12', '1090');
INSERT INTO public.who_global_data_import VALUES (46740, '2020-12-07', 'LB', 'Lebanon', 'EMRO', '1236', '137112', '9', '1099');
INSERT INTO public.who_global_data_import VALUES (46741, '2020-12-08', 'LB', 'Lebanon', 'EMRO', '984', '138096', '16', '1115');
INSERT INTO public.who_global_data_import VALUES (46742, '2020-12-09', 'LB', 'Lebanon', 'EMRO', '1039', '139135', '21', '1136');
INSERT INTO public.who_global_data_import VALUES (46743, '2020-12-10', 'LB', 'Lebanon', 'EMRO', '1274', '140409', '20', '1156');
INSERT INTO public.who_global_data_import VALUES (46744, '2020-12-11', 'LB', 'Lebanon', 'EMRO', '1778', '142187', '14', '1170');
INSERT INTO public.who_global_data_import VALUES (46745, '2020-12-12', 'LB', 'Lebanon', 'EMRO', '1518', '143705', '12', '1182');
INSERT INTO public.who_global_data_import VALUES (46746, '2020-12-13', 'LB', 'Lebanon', 'EMRO', '1540', '145245', '8', '1190');
INSERT INTO public.who_global_data_import VALUES (46747, '2020-12-14', 'LB', 'Lebanon', 'EMRO', '1275', '146520', '10', '1200');
INSERT INTO public.who_global_data_import VALUES (46748, '2020-12-15', 'LB', 'Lebanon', 'EMRO', '1093', '147613', '10', '1210');
INSERT INTO public.who_global_data_import VALUES (46749, '2020-12-16', 'LB', 'Lebanon', 'EMRO', '1264', '148877', '13', '1223');
INSERT INTO public.who_global_data_import VALUES (46750, '2020-12-17', 'LB', 'Lebanon', 'EMRO', '2056', '150933', '11', '1234');
INSERT INTO public.who_global_data_import VALUES (46751, '2020-12-18', 'LB', 'Lebanon', 'EMRO', '1960', '152893', '14', '1248');
INSERT INTO public.who_global_data_import VALUES (46752, '2020-12-19', 'LB', 'Lebanon', 'EMRO', '2051', '154944', '11', '1259');
INSERT INTO public.who_global_data_import VALUES (46753, '2020-12-20', 'LB', 'Lebanon', 'EMRO', '1626', '156570', '11', '1270');
INSERT INTO public.who_global_data_import VALUES (46754, '2020-12-21', 'LB', 'Lebanon', 'EMRO', '1534', '158104', '11', '1281');
INSERT INTO public.who_global_data_import VALUES (46755, '2020-12-22', 'LB', 'Lebanon', 'EMRO', '1182', '159286', '13', '1294');
INSERT INTO public.who_global_data_import VALUES (46756, '2020-12-23', 'LB', 'Lebanon', 'EMRO', '1693', '160979', '17', '1311');
INSERT INTO public.who_global_data_import VALUES (46757, '2020-12-24', 'LB', 'Lebanon', 'EMRO', '2246', '163225', '22', '1333');
INSERT INTO public.who_global_data_import VALUES (46758, '2020-12-25', 'LB', 'Lebanon', 'EMRO', '2708', '165933', '20', '1353');
INSERT INTO public.who_global_data_import VALUES (46759, '2020-12-26', 'LB', 'Lebanon', 'EMRO', '2136', '168069', '14', '1367');
INSERT INTO public.who_global_data_import VALUES (46760, '2020-12-27', 'LB', 'Lebanon', 'EMRO', '1403', '169472', '12', '1379');
INSERT INTO public.who_global_data_import VALUES (46761, '2020-12-28', 'LB', 'Lebanon', 'EMRO', '1754', '171226', '15', '1394');
INSERT INTO public.who_global_data_import VALUES (46762, '2020-12-29', 'LB', 'Lebanon', 'EMRO', '1594', '172820', '15', '1409');
INSERT INTO public.who_global_data_import VALUES (46763, '2020-12-30', 'LB', 'Lebanon', 'EMRO', '2298', '175118', '21', '1430');
INSERT INTO public.who_global_data_import VALUES (46764, '2020-12-31', 'LB', 'Lebanon', 'EMRO', '2878', '177996', '13', '1443');
INSERT INTO public.who_global_data_import VALUES (46765, '2021-01-01', 'LB', 'Lebanon', 'EMRO', '3507', '181503', '12', '1455');
INSERT INTO public.who_global_data_import VALUES (46766, '2021-01-02', 'LB', 'Lebanon', 'EMRO', '2385', '183888', '11', '1466');
INSERT INTO public.who_global_data_import VALUES (46767, '2021-01-03', 'LB', 'Lebanon', 'EMRO', '2520', '186408', '10', '1476');
INSERT INTO public.who_global_data_import VALUES (46768, '2021-01-04', 'LB', 'Lebanon', 'EMRO', '2870', '189278', '10', '1486');
INSERT INTO public.who_global_data_import VALUES (46769, '2021-01-05', 'LB', 'Lebanon', 'EMRO', '2861', '192139', '13', '1499');
INSERT INTO public.who_global_data_import VALUES (46770, '2021-01-06', 'LB', 'Lebanon', 'EMRO', '3620', '195759', '17', '1516');
INSERT INTO public.who_global_data_import VALUES (46771, '2021-01-07', 'LB', 'Lebanon', 'EMRO', '4166', '199925', '21', '1537');
INSERT INTO public.who_global_data_import VALUES (46772, '2021-01-08', 'LB', 'Lebanon', 'EMRO', '4774', '204699', '16', '1553');
INSERT INTO public.who_global_data_import VALUES (46773, '2021-01-09', 'LB', 'Lebanon', 'EMRO', '5440', '210139', '17', '1570');
INSERT INTO public.who_global_data_import VALUES (46774, '2021-01-10', 'LB', 'Lebanon', 'EMRO', '5414', '215553', '20', '1590');
INSERT INTO public.who_global_data_import VALUES (46775, '2021-01-11', 'LB', 'Lebanon', 'EMRO', '3743', '219296', '16', '1606');
INSERT INTO public.who_global_data_import VALUES (46776, '2021-01-12', 'LB', 'Lebanon', 'EMRO', '3095', '222391', '23', '1629');
INSERT INTO public.who_global_data_import VALUES (46777, '2021-01-13', 'LB', 'Lebanon', 'EMRO', '4557', '226948', '76', '1705');
INSERT INTO public.who_global_data_import VALUES (46778, '2021-01-14', 'LB', 'Lebanon', 'EMRO', '4988', '231936', '35', '1740');
INSERT INTO public.who_global_data_import VALUES (46779, '2021-01-15', 'LB', 'Lebanon', 'EMRO', '5196', '237132', '41', '1781');
INSERT INTO public.who_global_data_import VALUES (46780, '2021-01-16', 'LB', 'Lebanon', 'EMRO', '6154', '243286', '44', '1825');
INSERT INTO public.who_global_data_import VALUES (46781, '2021-01-17', 'LB', 'Lebanon', 'EMRO', '5872', '249158', '41', '1866');
INSERT INTO public.who_global_data_import VALUES (46782, '2021-01-18', 'LB', 'Lebanon', 'EMRO', '3654', '252812', '40', '1906');
INSERT INTO public.who_global_data_import VALUES (46783, '2021-01-19', 'LB', 'Lebanon', 'EMRO', '3144', '255956', '53', '1959');
INSERT INTO public.who_global_data_import VALUES (46784, '2021-01-20', 'LB', 'Lebanon', 'EMRO', '4359', '260315', '61', '2020');
INSERT INTO public.who_global_data_import VALUES (46785, '2021-01-21', 'LB', 'Lebanon', 'EMRO', '4332', '264647', '64', '2084');
INSERT INTO public.who_global_data_import VALUES (46786, '2021-01-22', 'LB', 'Lebanon', 'EMRO', '4594', '269241', '67', '2151');
INSERT INTO public.who_global_data_import VALUES (46787, '2021-01-23', 'LB', 'Lebanon', 'EMRO', '3170', '272411', '67', '2218');
INSERT INTO public.who_global_data_import VALUES (46788, '2021-01-24', 'LB', 'Lebanon', 'EMRO', '4176', '276587', '62', '2280');
INSERT INTO public.who_global_data_import VALUES (46789, '2021-01-25', 'LB', 'Lebanon', 'EMRO', '3010', '279597', '60', '2340');
INSERT INTO public.who_global_data_import VALUES (46790, '2021-01-26', 'LB', 'Lebanon', 'EMRO', '2652', '282249', '54', '2394');
INSERT INTO public.who_global_data_import VALUES (46791, '2021-01-27', 'LB', 'Lebanon', 'EMRO', '3505', '285754', '83', '2477');
INSERT INTO public.who_global_data_import VALUES (46792, '2021-01-28', 'LB', 'Lebanon', 'EMRO', '3906', '289660', '76', '2553');
INSERT INTO public.who_global_data_import VALUES (46793, '2021-01-29', 'LB', 'Lebanon', 'EMRO', '3497', '293157', '68', '2621');
INSERT INTO public.who_global_data_import VALUES (46794, '2021-01-30', 'LB', 'Lebanon', 'EMRO', '3125', '296282', '59', '2680');
INSERT INTO public.who_global_data_import VALUES (46795, '2021-01-31', 'LB', 'Lebanon', 'EMRO', '2631', '298913', '351', '3031');
INSERT INTO public.who_global_data_import VALUES (46796, '2021-02-01', 'LB', 'Lebanon', 'EMRO', '2139', '301052', '51', '3082');
INSERT INTO public.who_global_data_import VALUES (46797, '2021-02-02', 'LB', 'Lebanon', 'EMRO', '2020', '303072', '63', '3145');
INSERT INTO public.who_global_data_import VALUES (46798, '2021-02-03', 'LB', 'Lebanon', 'EMRO', '2770', '305842', '81', '3226');
INSERT INTO public.who_global_data_import VALUES (46799, '2021-02-04', 'LB', 'Lebanon', 'EMRO', '3320', '309162', '89', '3315');
INSERT INTO public.who_global_data_import VALUES (46800, '2021-02-05', 'LB', 'Lebanon', 'EMRO', '3107', '312269', '82', '3397');
INSERT INTO public.who_global_data_import VALUES (46801, '2020-01-03', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46802, '2020-01-04', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46803, '2020-01-05', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46804, '2020-01-06', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46805, '2020-01-07', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46806, '2020-01-08', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46807, '2020-01-09', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46808, '2020-01-10', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46809, '2020-01-11', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46810, '2020-01-12', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46811, '2020-01-13', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46812, '2020-01-14', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46813, '2020-01-15', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46814, '2020-01-16', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46815, '2020-01-17', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46816, '2020-01-18', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46817, '2020-01-19', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46818, '2020-01-20', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46819, '2020-01-21', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46820, '2020-01-22', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46821, '2020-01-23', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46822, '2020-01-24', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46823, '2020-01-25', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46824, '2020-01-26', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46825, '2020-01-27', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46826, '2020-01-28', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46827, '2020-01-29', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46828, '2020-01-30', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46829, '2020-01-31', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46830, '2020-02-01', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46831, '2020-02-02', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46832, '2020-02-03', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46833, '2020-02-04', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46834, '2020-02-05', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46835, '2020-02-06', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46836, '2020-02-07', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46837, '2020-02-08', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46838, '2020-02-09', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46839, '2020-02-10', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46840, '2020-02-11', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46841, '2020-02-12', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46842, '2020-02-13', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46843, '2020-02-14', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46844, '2020-02-15', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46845, '2020-02-16', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46846, '2020-02-17', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46847, '2020-02-18', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46848, '2020-02-19', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46849, '2020-02-20', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46850, '2020-02-21', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46851, '2020-02-22', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46852, '2020-02-23', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46853, '2020-02-24', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46854, '2020-02-25', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46855, '2020-02-26', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46856, '2020-02-27', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46857, '2020-02-28', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46858, '2020-02-29', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46859, '2020-03-01', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46860, '2020-03-02', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46861, '2020-03-03', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46862, '2020-03-04', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46863, '2020-03-05', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46864, '2020-03-06', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46865, '2020-03-07', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46866, '2020-03-08', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46867, '2020-03-09', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46868, '2020-03-10', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46869, '2020-03-11', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46870, '2020-03-12', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46871, '2020-03-13', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46872, '2020-03-14', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46873, '2020-03-15', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46874, '2020-03-16', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46875, '2020-03-17', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46876, '2020-03-18', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46877, '2020-03-19', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46878, '2020-03-20', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46879, '2020-03-21', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46880, '2020-03-22', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46881, '2020-03-23', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46882, '2020-03-24', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46883, '2020-03-25', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46884, '2020-03-26', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46885, '2020-03-27', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46886, '2020-03-28', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46887, '2020-03-29', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46888, '2020-03-30', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46889, '2020-03-31', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46890, '2020-04-01', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46891, '2020-04-02', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46892, '2020-04-03', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46893, '2020-04-04', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46894, '2020-04-05', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46895, '2020-04-06', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46896, '2020-04-07', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46897, '2020-04-08', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46898, '2020-04-09', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46899, '2020-04-10', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46900, '2020-04-11', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46901, '2020-04-12', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46902, '2020-04-13', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46903, '2020-04-14', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46904, '2020-04-15', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46905, '2020-04-16', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46906, '2020-04-17', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46907, '2020-04-18', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46908, '2020-04-19', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46909, '2020-04-20', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46910, '2020-04-21', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46911, '2020-04-22', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46912, '2020-04-23', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46913, '2020-04-24', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46914, '2020-04-25', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46915, '2020-04-26', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46916, '2020-04-27', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46917, '2020-04-28', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46918, '2020-04-29', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46919, '2020-04-30', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46920, '2020-05-01', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46921, '2020-05-02', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46922, '2020-05-03', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46923, '2020-05-04', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46924, '2020-05-05', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46925, '2020-05-06', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46926, '2020-05-07', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46927, '2020-05-08', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46928, '2020-05-09', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46929, '2020-05-10', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46930, '2020-05-11', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46931, '2020-05-12', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46932, '2020-05-13', 'LS', 'Lesotho', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46933, '2020-05-14', 'LS', 'Lesotho', 'AFRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46934, '2020-05-15', 'LS', 'Lesotho', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46935, '2020-05-16', 'LS', 'Lesotho', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46936, '2020-05-17', 'LS', 'Lesotho', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46937, '2020-05-18', 'LS', 'Lesotho', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46938, '2020-05-19', 'LS', 'Lesotho', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46939, '2020-05-20', 'LS', 'Lesotho', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46940, '2020-05-21', 'LS', 'Lesotho', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46941, '2020-05-22', 'LS', 'Lesotho', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46942, '2020-05-23', 'LS', 'Lesotho', 'AFRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46943, '2020-05-24', 'LS', 'Lesotho', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46944, '2020-05-25', 'LS', 'Lesotho', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46945, '2020-05-26', 'LS', 'Lesotho', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46946, '2020-05-27', 'LS', 'Lesotho', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46947, '2020-05-28', 'LS', 'Lesotho', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46948, '2020-05-29', 'LS', 'Lesotho', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46949, '2020-05-30', 'LS', 'Lesotho', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46950, '2020-05-31', 'LS', 'Lesotho', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46951, '2020-06-01', 'LS', 'Lesotho', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46952, '2020-06-02', 'LS', 'Lesotho', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46953, '2020-06-03', 'LS', 'Lesotho', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46954, '2020-06-04', 'LS', 'Lesotho', 'AFRO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46955, '2020-06-05', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46956, '2020-06-06', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46957, '2020-06-07', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46958, '2020-06-08', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46959, '2020-06-09', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46960, '2020-06-10', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46961, '2020-06-11', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46962, '2020-06-12', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46963, '2020-06-13', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46964, '2020-06-14', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46965, '2020-06-15', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46966, '2020-06-16', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46967, '2020-06-17', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46968, '2020-06-18', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46969, '2020-06-19', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46970, '2020-06-20', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46971, '2020-06-21', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46972, '2020-06-22', 'LS', 'Lesotho', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46973, '2020-06-23', 'LS', 'Lesotho', 'AFRO', '8', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46974, '2020-06-24', 'LS', 'Lesotho', 'AFRO', '5', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46975, '2020-06-25', 'LS', 'Lesotho', 'AFRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46976, '2020-06-26', 'LS', 'Lesotho', 'AFRO', '3', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46977, '2020-06-27', 'LS', 'Lesotho', 'AFRO', '4', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46978, '2020-06-28', 'LS', 'Lesotho', 'AFRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46979, '2020-06-29', 'LS', 'Lesotho', 'AFRO', '3', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46980, '2020-06-30', 'LS', 'Lesotho', 'AFRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46981, '2020-07-01', 'LS', 'Lesotho', 'AFRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46982, '2020-07-02', 'LS', 'Lesotho', 'AFRO', '8', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46983, '2020-07-03', 'LS', 'Lesotho', 'AFRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46984, '2020-07-04', 'LS', 'Lesotho', 'AFRO', '28', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46985, '2020-07-05', 'LS', 'Lesotho', 'AFRO', '16', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46986, '2020-07-06', 'LS', 'Lesotho', 'AFRO', '12', '91', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46987, '2020-07-07', 'LS', 'Lesotho', 'AFRO', '0', '91', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46988, '2020-07-08', 'LS', 'Lesotho', 'AFRO', '0', '91', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46989, '2020-07-09', 'LS', 'Lesotho', 'AFRO', '43', '134', '1', '1');
INSERT INTO public.who_global_data_import VALUES (46990, '2020-07-10', 'LS', 'Lesotho', 'AFRO', '0', '134', '0', '1');
INSERT INTO public.who_global_data_import VALUES (46991, '2020-07-11', 'LS', 'Lesotho', 'AFRO', '50', '184', '0', '1');
INSERT INTO public.who_global_data_import VALUES (46992, '2020-07-12', 'LS', 'Lesotho', 'AFRO', '0', '184', '0', '1');
INSERT INTO public.who_global_data_import VALUES (46993, '2020-07-13', 'LS', 'Lesotho', 'AFRO', '49', '233', '1', '2');
INSERT INTO public.who_global_data_import VALUES (46994, '2020-07-14', 'LS', 'Lesotho', 'AFRO', '12', '245', '1', '3');
INSERT INTO public.who_global_data_import VALUES (47210, '2020-01-12', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (46995, '2020-07-15', 'LS', 'Lesotho', 'AFRO', '11', '256', '0', '3');
INSERT INTO public.who_global_data_import VALUES (46996, '2020-07-16', 'LS', 'Lesotho', 'AFRO', '0', '256', '0', '3');
INSERT INTO public.who_global_data_import VALUES (46997, '2020-07-17', 'LS', 'Lesotho', 'AFRO', '0', '256', '0', '3');
INSERT INTO public.who_global_data_import VALUES (46998, '2020-07-18', 'LS', 'Lesotho', 'AFRO', '103', '359', '3', '6');
INSERT INTO public.who_global_data_import VALUES (46999, '2020-07-19', 'LS', 'Lesotho', 'AFRO', '0', '359', '0', '6');
INSERT INTO public.who_global_data_import VALUES (47000, '2020-07-20', 'LS', 'Lesotho', 'AFRO', '0', '359', '0', '6');
INSERT INTO public.who_global_data_import VALUES (47001, '2020-07-21', 'LS', 'Lesotho', 'AFRO', '0', '359', '0', '6');
INSERT INTO public.who_global_data_import VALUES (47002, '2020-07-22', 'LS', 'Lesotho', 'AFRO', '0', '359', '0', '6');
INSERT INTO public.who_global_data_import VALUES (47003, '2020-07-23', 'LS', 'Lesotho', 'AFRO', '0', '359', '0', '6');
INSERT INTO public.who_global_data_import VALUES (47004, '2020-07-24', 'LS', 'Lesotho', 'AFRO', '0', '359', '0', '6');
INSERT INTO public.who_global_data_import VALUES (47005, '2020-07-25', 'LS', 'Lesotho', 'AFRO', '60', '419', '3', '9');
INSERT INTO public.who_global_data_import VALUES (47006, '2020-07-26', 'LS', 'Lesotho', 'AFRO', '27', '446', '2', '11');
INSERT INTO public.who_global_data_import VALUES (47007, '2020-07-27', 'LS', 'Lesotho', 'AFRO', '59', '505', '1', '12');
INSERT INTO public.who_global_data_import VALUES (47008, '2020-07-28', 'LS', 'Lesotho', 'AFRO', '0', '505', '0', '12');
INSERT INTO public.who_global_data_import VALUES (47009, '2020-07-29', 'LS', 'Lesotho', 'AFRO', '0', '505', '0', '12');
INSERT INTO public.who_global_data_import VALUES (47010, '2020-07-30', 'LS', 'Lesotho', 'AFRO', '71', '576', '1', '13');
INSERT INTO public.who_global_data_import VALUES (47011, '2020-07-31', 'LS', 'Lesotho', 'AFRO', '28', '604', '0', '13');
INSERT INTO public.who_global_data_import VALUES (47012, '2020-08-01', 'LS', 'Lesotho', 'AFRO', '0', '604', '0', '13');
INSERT INTO public.who_global_data_import VALUES (47013, '2020-08-02', 'LS', 'Lesotho', 'AFRO', '98', '702', '1', '14');
INSERT INTO public.who_global_data_import VALUES (47014, '2020-08-03', 'LS', 'Lesotho', 'AFRO', '16', '718', '5', '19');
INSERT INTO public.who_global_data_import VALUES (47015, '2020-08-04', 'LS', 'Lesotho', 'AFRO', '0', '718', '0', '19');
INSERT INTO public.who_global_data_import VALUES (47016, '2020-08-05', 'LS', 'Lesotho', 'AFRO', '8', '726', '2', '21');
INSERT INTO public.who_global_data_import VALUES (47017, '2020-08-06', 'LS', 'Lesotho', 'AFRO', '0', '726', '0', '21');
INSERT INTO public.who_global_data_import VALUES (47018, '2020-08-07', 'LS', 'Lesotho', 'AFRO', '16', '742', '2', '23');
INSERT INTO public.who_global_data_import VALUES (47019, '2020-08-08', 'LS', 'Lesotho', 'AFRO', '0', '742', '0', '23');
INSERT INTO public.who_global_data_import VALUES (47020, '2020-08-09', 'LS', 'Lesotho', 'AFRO', '0', '742', '0', '23');
INSERT INTO public.who_global_data_import VALUES (47021, '2020-08-10', 'LS', 'Lesotho', 'AFRO', '39', '781', '1', '24');
INSERT INTO public.who_global_data_import VALUES (47022, '2020-08-11', 'LS', 'Lesotho', 'AFRO', '0', '781', '0', '24');
INSERT INTO public.who_global_data_import VALUES (47023, '2020-08-12', 'LS', 'Lesotho', 'AFRO', '17', '798', '0', '24');
INSERT INTO public.who_global_data_import VALUES (47024, '2020-08-13', 'LS', 'Lesotho', 'AFRO', '17', '815', '0', '24');
INSERT INTO public.who_global_data_import VALUES (47025, '2020-08-14', 'LS', 'Lesotho', 'AFRO', '69', '884', '1', '25');
INSERT INTO public.who_global_data_import VALUES (47026, '2020-08-15', 'LS', 'Lesotho', 'AFRO', '19', '903', '0', '25');
INSERT INTO public.who_global_data_import VALUES (47027, '2020-08-16', 'LS', 'Lesotho', 'AFRO', '0', '903', '0', '25');
INSERT INTO public.who_global_data_import VALUES (47028, '2020-08-17', 'LS', 'Lesotho', 'AFRO', '43', '946', '5', '30');
INSERT INTO public.who_global_data_import VALUES (47029, '2020-08-18', 'LS', 'Lesotho', 'AFRO', '0', '946', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47030, '2020-08-19', 'LS', 'Lesotho', 'AFRO', '0', '946', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47031, '2020-08-20', 'LS', 'Lesotho', 'AFRO', '50', '996', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47032, '2020-08-21', 'LS', 'Lesotho', 'AFRO', '0', '996', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47033, '2020-08-22', 'LS', 'Lesotho', 'AFRO', '19', '1015', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47034, '2020-08-23', 'LS', 'Lesotho', 'AFRO', '0', '1015', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47035, '2020-08-24', 'LS', 'Lesotho', 'AFRO', '0', '1015', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47036, '2020-08-25', 'LS', 'Lesotho', 'AFRO', '34', '1049', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47037, '2020-08-26', 'LS', 'Lesotho', 'AFRO', '0', '1049', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47038, '2020-08-27', 'LS', 'Lesotho', 'AFRO', '2', '1051', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47039, '2020-08-28', 'LS', 'Lesotho', 'AFRO', '0', '1051', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47040, '2020-08-29', 'LS', 'Lesotho', 'AFRO', '0', '1051', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47041, '2020-08-30', 'LS', 'Lesotho', 'AFRO', '15', '1066', '1', '31');
INSERT INTO public.who_global_data_import VALUES (47042, '2020-08-31', 'LS', 'Lesotho', 'AFRO', '0', '1066', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47043, '2020-09-01', 'LS', 'Lesotho', 'AFRO', '19', '1085', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47044, '2020-09-02', 'LS', 'Lesotho', 'AFRO', '0', '1085', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47045, '2020-09-03', 'LS', 'Lesotho', 'AFRO', '0', '1085', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47046, '2020-09-04', 'LS', 'Lesotho', 'AFRO', '63', '1148', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47047, '2020-09-05', 'LS', 'Lesotho', 'AFRO', '0', '1148', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47048, '2020-09-06', 'LS', 'Lesotho', 'AFRO', '0', '1148', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47049, '2020-09-07', 'LS', 'Lesotho', 'AFRO', '0', '1148', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47050, '2020-09-08', 'LS', 'Lesotho', 'AFRO', '16', '1164', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47051, '2020-09-09', 'LS', 'Lesotho', 'AFRO', '0', '1164', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47052, '2020-09-10', 'LS', 'Lesotho', 'AFRO', '0', '1164', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47053, '2020-09-11', 'LS', 'Lesotho', 'AFRO', '81', '1245', '2', '33');
INSERT INTO public.who_global_data_import VALUES (47054, '2020-09-12', 'LS', 'Lesotho', 'AFRO', '0', '1245', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47055, '2020-09-13', 'LS', 'Lesotho', 'AFRO', '0', '1245', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47056, '2020-09-14', 'LS', 'Lesotho', 'AFRO', '0', '1245', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47057, '2020-09-15', 'LS', 'Lesotho', 'AFRO', '0', '1245', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47058, '2020-09-16', 'LS', 'Lesotho', 'AFRO', '82', '1327', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47059, '2020-09-17', 'LS', 'Lesotho', 'AFRO', '0', '1327', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47060, '2020-09-18', 'LS', 'Lesotho', 'AFRO', '0', '1327', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47061, '2020-09-19', 'LS', 'Lesotho', 'AFRO', '63', '1390', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47062, '2020-09-20', 'LS', 'Lesotho', 'AFRO', '0', '1390', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47063, '2020-09-21', 'LS', 'Lesotho', 'AFRO', '0', '1390', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47064, '2020-09-22', 'LS', 'Lesotho', 'AFRO', '0', '1390', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47065, '2020-09-23', 'LS', 'Lesotho', 'AFRO', '0', '1390', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47066, '2020-09-24', 'LS', 'Lesotho', 'AFRO', '117', '1507', '2', '35');
INSERT INTO public.who_global_data_import VALUES (47067, '2020-09-25', 'LS', 'Lesotho', 'AFRO', '47', '1554', '0', '35');
INSERT INTO public.who_global_data_import VALUES (47068, '2020-09-26', 'LS', 'Lesotho', 'AFRO', '0', '1554', '0', '35');
INSERT INTO public.who_global_data_import VALUES (47069, '2020-09-27', 'LS', 'Lesotho', 'AFRO', '4', '1558', '0', '35');
INSERT INTO public.who_global_data_import VALUES (47070, '2020-09-28', 'LS', 'Lesotho', 'AFRO', '0', '1558', '0', '35');
INSERT INTO public.who_global_data_import VALUES (47071, '2020-09-29', 'LS', 'Lesotho', 'AFRO', '7', '1565', '0', '35');
INSERT INTO public.who_global_data_import VALUES (47072, '2020-09-30', 'LS', 'Lesotho', 'AFRO', '0', '1565', '0', '35');
INSERT INTO public.who_global_data_import VALUES (47073, '2020-10-01', 'LS', 'Lesotho', 'AFRO', '30', '1595', '1', '36');
INSERT INTO public.who_global_data_import VALUES (47074, '2020-10-02', 'LS', 'Lesotho', 'AFRO', '0', '1595', '0', '36');
INSERT INTO public.who_global_data_import VALUES (47075, '2020-10-03', 'LS', 'Lesotho', 'AFRO', '44', '1639', '2', '38');
INSERT INTO public.who_global_data_import VALUES (47076, '2020-10-04', 'LS', 'Lesotho', 'AFRO', '0', '1639', '0', '38');
INSERT INTO public.who_global_data_import VALUES (47077, '2020-10-05', 'LS', 'Lesotho', 'AFRO', '0', '1639', '0', '38');
INSERT INTO public.who_global_data_import VALUES (47078, '2020-10-06', 'LS', 'Lesotho', 'AFRO', '0', '1639', '0', '38');
INSERT INTO public.who_global_data_import VALUES (47079, '2020-10-07', 'LS', 'Lesotho', 'AFRO', '0', '1639', '0', '38');
INSERT INTO public.who_global_data_import VALUES (47080, '2020-10-08', 'LS', 'Lesotho', 'AFRO', '44', '1683', '1', '39');
INSERT INTO public.who_global_data_import VALUES (47081, '2020-10-09', 'LS', 'Lesotho', 'AFRO', '84', '1767', '1', '40');
INSERT INTO public.who_global_data_import VALUES (47082, '2020-10-10', 'LS', 'Lesotho', 'AFRO', '0', '1767', '0', '40');
INSERT INTO public.who_global_data_import VALUES (47083, '2020-10-11', 'LS', 'Lesotho', 'AFRO', '0', '1767', '0', '40');
INSERT INTO public.who_global_data_import VALUES (47084, '2020-10-12', 'LS', 'Lesotho', 'AFRO', '0', '1767', '0', '40');
INSERT INTO public.who_global_data_import VALUES (47085, '2020-10-13', 'LS', 'Lesotho', 'AFRO', '38', '1805', '2', '42');
INSERT INTO public.who_global_data_import VALUES (47086, '2020-10-14', 'LS', 'Lesotho', 'AFRO', '0', '1805', '0', '42');
INSERT INTO public.who_global_data_import VALUES (47087, '2020-10-15', 'LS', 'Lesotho', 'AFRO', '28', '1833', '0', '42');
INSERT INTO public.who_global_data_import VALUES (47088, '2020-10-16', 'LS', 'Lesotho', 'AFRO', '0', '1833', '0', '42');
INSERT INTO public.who_global_data_import VALUES (47089, '2020-10-17', 'LS', 'Lesotho', 'AFRO', '0', '1833', '0', '42');
INSERT INTO public.who_global_data_import VALUES (47090, '2020-10-18', 'LS', 'Lesotho', 'AFRO', '0', '1833', '0', '42');
INSERT INTO public.who_global_data_import VALUES (47091, '2020-10-19', 'LS', 'Lesotho', 'AFRO', '0', '1833', '0', '42');
INSERT INTO public.who_global_data_import VALUES (47092, '2020-10-20', 'LS', 'Lesotho', 'AFRO', '0', '1833', '0', '42');
INSERT INTO public.who_global_data_import VALUES (47093, '2020-10-21', 'LS', 'Lesotho', 'AFRO', '0', '1833', '0', '42');
INSERT INTO public.who_global_data_import VALUES (47094, '2020-10-22', 'LS', 'Lesotho', 'AFRO', '0', '1833', '0', '42');
INSERT INTO public.who_global_data_import VALUES (47095, '2020-10-23', 'LS', 'Lesotho', 'AFRO', '90', '1923', '1', '43');
INSERT INTO public.who_global_data_import VALUES (47096, '2020-10-24', 'LS', 'Lesotho', 'AFRO', '11', '1934', '0', '43');
INSERT INTO public.who_global_data_import VALUES (47097, '2020-10-25', 'LS', 'Lesotho', 'AFRO', '0', '1934', '0', '43');
INSERT INTO public.who_global_data_import VALUES (47098, '2020-10-26', 'LS', 'Lesotho', 'AFRO', '6', '1940', '0', '43');
INSERT INTO public.who_global_data_import VALUES (47099, '2020-10-27', 'LS', 'Lesotho', 'AFRO', '0', '1940', '0', '43');
INSERT INTO public.who_global_data_import VALUES (47100, '2020-10-28', 'LS', 'Lesotho', 'AFRO', '7', '1947', '0', '43');
INSERT INTO public.who_global_data_import VALUES (47101, '2020-10-29', 'LS', 'Lesotho', 'AFRO', '0', '1947', '0', '43');
INSERT INTO public.who_global_data_import VALUES (47102, '2020-10-30', 'LS', 'Lesotho', 'AFRO', '0', '1947', '0', '43');
INSERT INTO public.who_global_data_import VALUES (47103, '2020-10-31', 'LS', 'Lesotho', 'AFRO', '0', '1947', '0', '43');
INSERT INTO public.who_global_data_import VALUES (47104, '2020-11-01', 'LS', 'Lesotho', 'AFRO', '0', '1947', '0', '43');
INSERT INTO public.who_global_data_import VALUES (47105, '2020-11-02', 'LS', 'Lesotho', 'AFRO', '6', '1953', '1', '44');
INSERT INTO public.who_global_data_import VALUES (47106, '2020-11-03', 'LS', 'Lesotho', 'AFRO', '8', '1961', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47107, '2020-11-04', 'LS', 'Lesotho', 'AFRO', '0', '1961', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47108, '2020-11-05', 'LS', 'Lesotho', 'AFRO', '0', '1961', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47109, '2020-11-06', 'LS', 'Lesotho', 'AFRO', '2', '1963', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47110, '2020-11-07', 'LS', 'Lesotho', 'AFRO', '0', '1963', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47111, '2020-11-08', 'LS', 'Lesotho', 'AFRO', '0', '1963', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47112, '2020-11-09', 'LS', 'Lesotho', 'AFRO', '0', '1963', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47113, '2020-11-10', 'LS', 'Lesotho', 'AFRO', '4', '1967', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47114, '2020-11-11', 'LS', 'Lesotho', 'AFRO', '0', '1967', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47115, '2020-11-12', 'LS', 'Lesotho', 'AFRO', '0', '1967', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47116, '2020-11-13', 'LS', 'Lesotho', 'AFRO', '0', '1967', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47117, '2020-11-14', 'LS', 'Lesotho', 'AFRO', '0', '1967', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47118, '2020-11-15', 'LS', 'Lesotho', 'AFRO', '0', '1967', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47119, '2020-11-16', 'LS', 'Lesotho', 'AFRO', '0', '1967', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47120, '2020-11-17', 'LS', 'Lesotho', 'AFRO', '0', '1967', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47121, '2020-11-18', 'LS', 'Lesotho', 'AFRO', '0', '1967', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47122, '2020-11-19', 'LS', 'Lesotho', 'AFRO', '74', '2041', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47123, '2020-11-20', 'LS', 'Lesotho', 'AFRO', '17', '2058', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47124, '2020-11-21', 'LS', 'Lesotho', 'AFRO', '0', '2058', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47125, '2020-11-22', 'LS', 'Lesotho', 'AFRO', '0', '2058', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47126, '2020-11-23', 'LS', 'Lesotho', 'AFRO', '27', '2085', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47127, '2020-11-24', 'LS', 'Lesotho', 'AFRO', '0', '2085', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47128, '2020-11-25', 'LS', 'Lesotho', 'AFRO', '0', '2085', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47129, '2020-11-26', 'LS', 'Lesotho', 'AFRO', '7', '2092', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47130, '2020-11-27', 'LS', 'Lesotho', 'AFRO', '17', '2109', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47131, '2020-11-28', 'LS', 'Lesotho', 'AFRO', '0', '2109', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47132, '2020-11-29', 'LS', 'Lesotho', 'AFRO', '0', '2109', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47133, '2020-11-30', 'LS', 'Lesotho', 'AFRO', '0', '2109', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47134, '2020-12-01', 'LS', 'Lesotho', 'AFRO', '0', '2109', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47135, '2020-12-02', 'LS', 'Lesotho', 'AFRO', '0', '2109', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47136, '2020-12-03', 'LS', 'Lesotho', 'AFRO', '0', '2109', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47137, '2020-12-04', 'LS', 'Lesotho', 'AFRO', '28', '2137', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47138, '2020-12-05', 'LS', 'Lesotho', 'AFRO', '0', '2137', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47139, '2020-12-06', 'LS', 'Lesotho', 'AFRO', '0', '2137', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47140, '2020-12-07', 'LS', 'Lesotho', 'AFRO', '0', '2137', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47141, '2020-12-08', 'LS', 'Lesotho', 'AFRO', '13', '2150', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47142, '2020-12-09', 'LS', 'Lesotho', 'AFRO', '0', '2150', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47143, '2020-12-10', 'LS', 'Lesotho', 'AFRO', '0', '2150', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47144, '2020-12-11', 'LS', 'Lesotho', 'AFRO', '0', '2150', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47145, '2020-12-12', 'LS', 'Lesotho', 'AFRO', '0', '2150', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47146, '2020-12-13', 'LS', 'Lesotho', 'AFRO', '0', '2150', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47147, '2020-12-14', 'LS', 'Lesotho', 'AFRO', '0', '2150', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47148, '2020-12-15', 'LS', 'Lesotho', 'AFRO', '0', '2150', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47149, '2020-12-16', 'LS', 'Lesotho', 'AFRO', '135', '2285', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47150, '2020-12-17', 'LS', 'Lesotho', 'AFRO', '0', '2285', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47151, '2020-12-18', 'LS', 'Lesotho', 'AFRO', '0', '2285', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47152, '2020-12-19', 'LS', 'Lesotho', 'AFRO', '0', '2285', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47153, '2020-12-20', 'LS', 'Lesotho', 'AFRO', '0', '2285', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47154, '2020-12-21', 'LS', 'Lesotho', 'AFRO', '0', '2285', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47155, '2020-12-22', 'LS', 'Lesotho', 'AFRO', '0', '2285', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47156, '2020-12-23', 'LS', 'Lesotho', 'AFRO', '0', '2285', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47157, '2020-12-24', 'LS', 'Lesotho', 'AFRO', '0', '2285', '0', '44');
INSERT INTO public.who_global_data_import VALUES (47158, '2020-12-25', 'LS', 'Lesotho', 'AFRO', '292', '2577', '6', '50');
INSERT INTO public.who_global_data_import VALUES (47159, '2020-12-26', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47160, '2020-12-27', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47161, '2020-12-28', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47162, '2020-12-29', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47163, '2020-12-30', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47164, '2020-12-31', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47165, '2021-01-01', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47166, '2021-01-02', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47167, '2021-01-03', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47168, '2021-01-04', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47169, '2021-01-05', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47170, '2021-01-06', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47171, '2021-01-07', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47172, '2021-01-08', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47173, '2021-01-09', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47174, '2021-01-10', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47175, '2021-01-11', 'LS', 'Lesotho', 'AFRO', '0', '2577', '0', '50');
INSERT INTO public.who_global_data_import VALUES (47176, '2021-01-12', 'LS', 'Lesotho', 'AFRO', '2593', '5170', '29', '79');
INSERT INTO public.who_global_data_import VALUES (47177, '2021-01-13', 'LS', 'Lesotho', 'AFRO', '764', '5934', '6', '85');
INSERT INTO public.who_global_data_import VALUES (47178, '2021-01-14', 'LS', 'Lesotho', 'AFRO', '307', '6241', '2', '87');
INSERT INTO public.who_global_data_import VALUES (47179, '2021-01-15', 'LS', 'Lesotho', 'AFRO', '115', '6356', '2', '89');
INSERT INTO public.who_global_data_import VALUES (47180, '2021-01-16', 'LS', 'Lesotho', 'AFRO', '15', '6371', '4', '93');
INSERT INTO public.who_global_data_import VALUES (47181, '2021-01-17', 'LS', 'Lesotho', 'AFRO', '0', '6371', '4', '97');
INSERT INTO public.who_global_data_import VALUES (47182, '2021-01-18', 'LS', 'Lesotho', 'AFRO', '0', '6371', '-4', '93');
INSERT INTO public.who_global_data_import VALUES (47183, '2021-01-19', 'LS', 'Lesotho', 'AFRO', '0', '6371', '0', '93');
INSERT INTO public.who_global_data_import VALUES (47184, '2021-01-20', 'LS', 'Lesotho', 'AFRO', '647', '7018', '8', '101');
INSERT INTO public.who_global_data_import VALUES (47185, '2021-01-21', 'LS', 'Lesotho', 'AFRO', '17', '7035', '0', '101');
INSERT INTO public.who_global_data_import VALUES (47186, '2021-01-22', 'LS', 'Lesotho', 'AFRO', '520', '7555', '12', '113');
INSERT INTO public.who_global_data_import VALUES (47187, '2021-01-23', 'LS', 'Lesotho', 'AFRO', '0', '7555', '0', '113');
INSERT INTO public.who_global_data_import VALUES (47188, '2021-01-24', 'LS', 'Lesotho', 'AFRO', '101', '7656', '10', '123');
INSERT INTO public.who_global_data_import VALUES (47189, '2021-01-25', 'LS', 'Lesotho', 'AFRO', '0', '7656', '0', '123');
INSERT INTO public.who_global_data_import VALUES (47190, '2021-01-26', 'LS', 'Lesotho', 'AFRO', '388', '8044', '11', '134');
INSERT INTO public.who_global_data_import VALUES (47191, '2021-01-27', 'LS', 'Lesotho', 'AFRO', '3', '8047', '12', '146');
INSERT INTO public.who_global_data_import VALUES (47192, '2021-01-28', 'LS', 'Lesotho', 'AFRO', '95', '8142', '14', '160');
INSERT INTO public.who_global_data_import VALUES (47193, '2021-01-29', 'LS', 'Lesotho', 'AFRO', '0', '8142', '0', '160');
INSERT INTO public.who_global_data_import VALUES (47194, '2021-01-30', 'LS', 'Lesotho', 'AFRO', '136', '8278', '0', '160');
INSERT INTO public.who_global_data_import VALUES (47195, '2021-01-31', 'LS', 'Lesotho', 'AFRO', '0', '8278', '0', '160');
INSERT INTO public.who_global_data_import VALUES (47196, '2021-02-01', 'LS', 'Lesotho', 'AFRO', '0', '8278', '0', '160');
INSERT INTO public.who_global_data_import VALUES (47197, '2021-02-02', 'LS', 'Lesotho', 'AFRO', '622', '8900', '12', '172');
INSERT INTO public.who_global_data_import VALUES (47198, '2021-02-03', 'LS', 'Lesotho', 'AFRO', '0', '8900', '0', '172');
INSERT INTO public.who_global_data_import VALUES (47199, '2021-02-04', 'LS', 'Lesotho', 'AFRO', '69', '8969', '6', '178');
INSERT INTO public.who_global_data_import VALUES (47200, '2021-02-05', 'LS', 'Lesotho', 'AFRO', '0', '8969', '0', '178');
INSERT INTO public.who_global_data_import VALUES (47201, '2020-01-03', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47202, '2020-01-04', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47203, '2020-01-05', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47204, '2020-01-06', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47205, '2020-01-07', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47206, '2020-01-08', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47207, '2020-01-09', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47208, '2020-01-10', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47209, '2020-01-11', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47211, '2020-01-13', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47212, '2020-01-14', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47213, '2020-01-15', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47214, '2020-01-16', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47215, '2020-01-17', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47216, '2020-01-18', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47217, '2020-01-19', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47218, '2020-01-20', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47219, '2020-01-21', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47220, '2020-01-22', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47221, '2020-01-23', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47222, '2020-01-24', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47223, '2020-01-25', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47224, '2020-01-26', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47225, '2020-01-27', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47226, '2020-01-28', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47227, '2020-01-29', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47228, '2020-01-30', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47229, '2020-01-31', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47230, '2020-02-01', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47231, '2020-02-02', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47232, '2020-02-03', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47233, '2020-02-04', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47234, '2020-02-05', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47235, '2020-02-06', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47236, '2020-02-07', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47237, '2020-02-08', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47238, '2020-02-09', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47239, '2020-02-10', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47240, '2020-02-11', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47241, '2020-02-12', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47242, '2020-02-13', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47243, '2020-02-14', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47244, '2020-02-15', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47245, '2020-02-16', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47246, '2020-02-17', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47247, '2020-02-18', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47248, '2020-02-19', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47249, '2020-02-20', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47250, '2020-02-21', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47251, '2020-02-22', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47252, '2020-02-23', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47253, '2020-02-24', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47254, '2020-02-25', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47255, '2020-02-26', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47256, '2020-02-27', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47257, '2020-02-28', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47258, '2020-02-29', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47259, '2020-03-01', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47260, '2020-03-02', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47261, '2020-03-03', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47262, '2020-03-04', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47263, '2020-03-05', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47264, '2020-03-06', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47265, '2020-03-07', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47266, '2020-03-08', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47267, '2020-03-09', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47268, '2020-03-10', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47269, '2020-03-11', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47270, '2020-03-12', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47271, '2020-03-13', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47272, '2020-03-14', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47273, '2020-03-15', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47274, '2020-03-16', 'LR', 'Liberia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47275, '2020-03-17', 'LR', 'Liberia', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47276, '2020-03-18', 'LR', 'Liberia', 'AFRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47277, '2020-03-19', 'LR', 'Liberia', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47278, '2020-03-20', 'LR', 'Liberia', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47279, '2020-03-21', 'LR', 'Liberia', 'AFRO', '-3', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47280, '2020-03-22', 'LR', 'Liberia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47281, '2020-03-23', 'LR', 'Liberia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47282, '2020-03-24', 'LR', 'Liberia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47283, '2020-03-25', 'LR', 'Liberia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47284, '2020-03-26', 'LR', 'Liberia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47285, '2020-03-27', 'LR', 'Liberia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47286, '2020-03-28', 'LR', 'Liberia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47287, '2020-03-29', 'LR', 'Liberia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47288, '2020-03-30', 'LR', 'Liberia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47289, '2020-03-31', 'LR', 'Liberia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47290, '2020-04-01', 'LR', 'Liberia', 'AFRO', '3', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47291, '2020-04-02', 'LR', 'Liberia', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47292, '2020-04-03', 'LR', 'Liberia', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47293, '2020-04-04', 'LR', 'Liberia', 'AFRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47294, '2020-04-05', 'LR', 'Liberia', 'AFRO', '3', '10', '1', '1');
INSERT INTO public.who_global_data_import VALUES (47295, '2020-04-06', 'LR', 'Liberia', 'AFRO', '3', '13', '2', '3');
INSERT INTO public.who_global_data_import VALUES (47296, '2020-04-07', 'LR', 'Liberia', 'AFRO', '1', '14', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47297, '2020-04-08', 'LR', 'Liberia', 'AFRO', '0', '14', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47298, '2020-04-09', 'LR', 'Liberia', 'AFRO', '17', '31', '1', '4');
INSERT INTO public.who_global_data_import VALUES (47299, '2020-04-10', 'LR', 'Liberia', 'AFRO', '0', '31', '0', '4');
INSERT INTO public.who_global_data_import VALUES (47300, '2020-04-11', 'LR', 'Liberia', 'AFRO', '6', '37', '1', '5');
INSERT INTO public.who_global_data_import VALUES (47301, '2020-04-12', 'LR', 'Liberia', 'AFRO', '11', '48', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47302, '2020-04-13', 'LR', 'Liberia', 'AFRO', '2', '50', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47303, '2020-04-14', 'LR', 'Liberia', 'AFRO', '1', '51', '1', '6');
INSERT INTO public.who_global_data_import VALUES (47304, '2020-04-15', 'LR', 'Liberia', 'AFRO', '8', '59', '0', '6');
INSERT INTO public.who_global_data_import VALUES (47305, '2020-04-16', 'LR', 'Liberia', 'AFRO', '0', '59', '0', '6');
INSERT INTO public.who_global_data_import VALUES (47306, '2020-04-17', 'LR', 'Liberia', 'AFRO', '14', '73', '0', '6');
INSERT INTO public.who_global_data_import VALUES (47307, '2020-04-18', 'LR', 'Liberia', 'AFRO', '3', '76', '1', '7');
INSERT INTO public.who_global_data_import VALUES (47308, '2020-04-19', 'LR', 'Liberia', 'AFRO', '5', '81', '0', '7');
INSERT INTO public.who_global_data_import VALUES (47309, '2020-04-20', 'LR', 'Liberia', 'AFRO', '10', '91', '1', '8');
INSERT INTO public.who_global_data_import VALUES (47310, '2020-04-21', 'LR', 'Liberia', 'AFRO', '8', '99', '0', '8');
INSERT INTO public.who_global_data_import VALUES (47311, '2020-04-22', 'LR', 'Liberia', 'AFRO', '2', '101', '0', '8');
INSERT INTO public.who_global_data_import VALUES (47312, '2020-04-23', 'LR', 'Liberia', 'AFRO', '0', '101', '0', '8');
INSERT INTO public.who_global_data_import VALUES (47313, '2020-04-24', 'LR', 'Liberia', 'AFRO', '0', '101', '0', '8');
INSERT INTO public.who_global_data_import VALUES (47314, '2020-04-25', 'LR', 'Liberia', 'AFRO', '16', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (47315, '2020-04-26', 'LR', 'Liberia', 'AFRO', '3', '120', '3', '11');
INSERT INTO public.who_global_data_import VALUES (47316, '2020-04-27', 'LR', 'Liberia', 'AFRO', '4', '124', '1', '12');
INSERT INTO public.who_global_data_import VALUES (47317, '2020-04-28', 'LR', 'Liberia', 'AFRO', '9', '133', '4', '16');
INSERT INTO public.who_global_data_import VALUES (47318, '2020-04-29', 'LR', 'Liberia', 'AFRO', '8', '141', '0', '16');
INSERT INTO public.who_global_data_import VALUES (47319, '2020-04-30', 'LR', 'Liberia', 'AFRO', '0', '141', '0', '16');
INSERT INTO public.who_global_data_import VALUES (47320, '2020-05-01', 'LR', 'Liberia', 'AFRO', '0', '141', '0', '16');
INSERT INTO public.who_global_data_import VALUES (47321, '2020-05-02', 'LR', 'Liberia', 'AFRO', '11', '152', '2', '18');
INSERT INTO public.who_global_data_import VALUES (47322, '2020-05-03', 'LR', 'Liberia', 'AFRO', '2', '154', '0', '18');
INSERT INTO public.who_global_data_import VALUES (47323, '2020-05-04', 'LR', 'Liberia', 'AFRO', '4', '158', '0', '18');
INSERT INTO public.who_global_data_import VALUES (47324, '2020-05-05', 'LR', 'Liberia', 'AFRO', '8', '166', '0', '18');
INSERT INTO public.who_global_data_import VALUES (47325, '2020-05-06', 'LR', 'Liberia', 'AFRO', '4', '170', '2', '20');
INSERT INTO public.who_global_data_import VALUES (47326, '2020-05-07', 'LR', 'Liberia', 'AFRO', '8', '178', '0', '20');
INSERT INTO public.who_global_data_import VALUES (47327, '2020-05-08', 'LR', 'Liberia', 'AFRO', '11', '189', '0', '20');
INSERT INTO public.who_global_data_import VALUES (47328, '2020-05-09', 'LR', 'Liberia', 'AFRO', '10', '199', '0', '20');
INSERT INTO public.who_global_data_import VALUES (47329, '2020-05-10', 'LR', 'Liberia', 'AFRO', '0', '199', '0', '20');
INSERT INTO public.who_global_data_import VALUES (47330, '2020-05-11', 'LR', 'Liberia', 'AFRO', '5', '204', '0', '20');
INSERT INTO public.who_global_data_import VALUES (47331, '2020-05-12', 'LR', 'Liberia', 'AFRO', '7', '211', '0', '20');
INSERT INTO public.who_global_data_import VALUES (47332, '2020-05-13', 'LR', 'Liberia', 'AFRO', '1', '212', '0', '20');
INSERT INTO public.who_global_data_import VALUES (47333, '2020-05-14', 'LR', 'Liberia', 'AFRO', '1', '213', '0', '20');
INSERT INTO public.who_global_data_import VALUES (47334, '2020-05-15', 'LR', 'Liberia', 'AFRO', '2', '215', '0', '20');
INSERT INTO public.who_global_data_import VALUES (47335, '2020-05-16', 'LR', 'Liberia', 'AFRO', '4', '219', '0', '20');
INSERT INTO public.who_global_data_import VALUES (47336, '2020-05-17', 'LR', 'Liberia', 'AFRO', '4', '223', '0', '20');
INSERT INTO public.who_global_data_import VALUES (47337, '2020-05-18', 'LR', 'Liberia', 'AFRO', '3', '226', '1', '21');
INSERT INTO public.who_global_data_import VALUES (47338, '2020-05-19', 'LR', 'Liberia', 'AFRO', '3', '229', '1', '22');
INSERT INTO public.who_global_data_import VALUES (47339, '2020-05-20', 'LR', 'Liberia', 'AFRO', '4', '233', '1', '23');
INSERT INTO public.who_global_data_import VALUES (47340, '2020-05-21', 'LR', 'Liberia', 'AFRO', '5', '238', '0', '23');
INSERT INTO public.who_global_data_import VALUES (47341, '2020-05-22', 'LR', 'Liberia', 'AFRO', '2', '240', '0', '23');
INSERT INTO public.who_global_data_import VALUES (47342, '2020-05-23', 'LR', 'Liberia', 'AFRO', '9', '249', '1', '24');
INSERT INTO public.who_global_data_import VALUES (47343, '2020-05-24', 'LR', 'Liberia', 'AFRO', '6', '255', '2', '26');
INSERT INTO public.who_global_data_import VALUES (47344, '2020-05-25', 'LR', 'Liberia', 'AFRO', '10', '265', '0', '26');
INSERT INTO public.who_global_data_import VALUES (47345, '2020-05-26', 'LR', 'Liberia', 'AFRO', '0', '265', '0', '26');
INSERT INTO public.who_global_data_import VALUES (47346, '2020-05-27', 'LR', 'Liberia', 'AFRO', '1', '266', '0', '26');
INSERT INTO public.who_global_data_import VALUES (47347, '2020-05-28', 'LR', 'Liberia', 'AFRO', '0', '266', '1', '27');
INSERT INTO public.who_global_data_import VALUES (47348, '2020-05-29', 'LR', 'Liberia', 'AFRO', '3', '269', '0', '27');
INSERT INTO public.who_global_data_import VALUES (47349, '2020-05-30', 'LR', 'Liberia', 'AFRO', '4', '273', '0', '27');
INSERT INTO public.who_global_data_import VALUES (47350, '2020-05-31', 'LR', 'Liberia', 'AFRO', '7', '280', '0', '27');
INSERT INTO public.who_global_data_import VALUES (47351, '2020-06-01', 'LR', 'Liberia', 'AFRO', '8', '288', '0', '27');
INSERT INTO public.who_global_data_import VALUES (47352, '2020-06-02', 'LR', 'Liberia', 'AFRO', '8', '296', '0', '27');
INSERT INTO public.who_global_data_import VALUES (47353, '2020-06-03', 'LR', 'Liberia', 'AFRO', '15', '311', '1', '28');
INSERT INTO public.who_global_data_import VALUES (47354, '2020-06-04', 'LR', 'Liberia', 'AFRO', '5', '316', '0', '28');
INSERT INTO public.who_global_data_import VALUES (47355, '2020-06-05', 'LR', 'Liberia', 'AFRO', '5', '321', '0', '28');
INSERT INTO public.who_global_data_import VALUES (47356, '2020-06-06', 'LR', 'Liberia', 'AFRO', '13', '334', '2', '30');
INSERT INTO public.who_global_data_import VALUES (47357, '2020-06-07', 'LR', 'Liberia', 'AFRO', '11', '345', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47358, '2020-06-08', 'LR', 'Liberia', 'AFRO', '14', '359', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47359, '2020-06-09', 'LR', 'Liberia', 'AFRO', '11', '370', '0', '30');
INSERT INTO public.who_global_data_import VALUES (47360, '2020-06-10', 'LR', 'Liberia', 'AFRO', '13', '383', '1', '31');
INSERT INTO public.who_global_data_import VALUES (47361, '2020-06-11', 'LR', 'Liberia', 'AFRO', '14', '397', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47362, '2020-06-12', 'LR', 'Liberia', 'AFRO', '13', '410', '0', '31');
INSERT INTO public.who_global_data_import VALUES (47363, '2020-06-13', 'LR', 'Liberia', 'AFRO', '11', '421', '1', '32');
INSERT INTO public.who_global_data_import VALUES (47364, '2020-06-14', 'LR', 'Liberia', 'AFRO', '25', '446', '0', '32');
INSERT INTO public.who_global_data_import VALUES (47365, '2020-06-15', 'LR', 'Liberia', 'AFRO', '12', '458', '0', '32');
INSERT INTO public.who_global_data_import VALUES (47366, '2020-06-16', 'LR', 'Liberia', 'AFRO', '40', '498', '1', '33');
INSERT INTO public.who_global_data_import VALUES (47367, '2020-06-17', 'LR', 'Liberia', 'AFRO', '11', '509', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47368, '2020-06-18', 'LR', 'Liberia', 'AFRO', '7', '516', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47369, '2020-06-19', 'LR', 'Liberia', 'AFRO', '26', '542', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47370, '2020-06-20', 'LR', 'Liberia', 'AFRO', '39', '581', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47371, '2020-06-21', 'LR', 'Liberia', 'AFRO', '20', '601', '0', '33');
INSERT INTO public.who_global_data_import VALUES (47372, '2020-06-22', 'LR', 'Liberia', 'AFRO', '25', '626', '1', '34');
INSERT INTO public.who_global_data_import VALUES (47373, '2020-06-23', 'LR', 'Liberia', 'AFRO', '24', '650', '0', '34');
INSERT INTO public.who_global_data_import VALUES (47374, '2020-06-24', 'LR', 'Liberia', 'AFRO', '2', '652', '0', '34');
INSERT INTO public.who_global_data_import VALUES (47375, '2020-06-25', 'LR', 'Liberia', 'AFRO', '10', '662', '0', '34');
INSERT INTO public.who_global_data_import VALUES (47376, '2020-06-26', 'LR', 'Liberia', 'AFRO', '19', '681', '0', '34');
INSERT INTO public.who_global_data_import VALUES (47377, '2020-06-27', 'LR', 'Liberia', 'AFRO', '3', '684', '0', '34');
INSERT INTO public.who_global_data_import VALUES (47378, '2020-06-28', 'LR', 'Liberia', 'AFRO', '0', '684', '0', '34');
INSERT INTO public.who_global_data_import VALUES (47379, '2020-06-29', 'LR', 'Liberia', 'AFRO', '84', '768', '0', '34');
INSERT INTO public.who_global_data_import VALUES (47380, '2020-06-30', 'LR', 'Liberia', 'AFRO', '2', '770', '2', '36');
INSERT INTO public.who_global_data_import VALUES (47381, '2020-07-01', 'LR', 'Liberia', 'AFRO', '10', '780', '0', '36');
INSERT INTO public.who_global_data_import VALUES (47382, '2020-07-02', 'LR', 'Liberia', 'AFRO', '24', '804', '1', '37');
INSERT INTO public.who_global_data_import VALUES (47383, '2020-07-03', 'LR', 'Liberia', 'AFRO', '15', '819', '0', '37');
INSERT INTO public.who_global_data_import VALUES (47384, '2020-07-04', 'LR', 'Liberia', 'AFRO', '14', '833', '0', '37');
INSERT INTO public.who_global_data_import VALUES (47385, '2020-07-05', 'LR', 'Liberia', 'AFRO', '0', '833', '0', '37');
INSERT INTO public.who_global_data_import VALUES (47386, '2020-07-06', 'LR', 'Liberia', 'AFRO', '41', '874', '0', '37');
INSERT INTO public.who_global_data_import VALUES (47387, '2020-07-07', 'LR', 'Liberia', 'AFRO', '17', '891', '2', '39');
INSERT INTO public.who_global_data_import VALUES (47388, '2020-07-08', 'LR', 'Liberia', 'AFRO', '26', '917', '2', '41');
INSERT INTO public.who_global_data_import VALUES (47389, '2020-07-09', 'LR', 'Liberia', 'AFRO', '9', '926', '0', '41');
INSERT INTO public.who_global_data_import VALUES (47390, '2020-07-10', 'LR', 'Liberia', 'AFRO', '31', '957', '1', '42');
INSERT INTO public.who_global_data_import VALUES (47391, '2020-07-11', 'LR', 'Liberia', 'AFRO', '6', '963', '5', '47');
INSERT INTO public.who_global_data_import VALUES (47392, '2020-07-12', 'LR', 'Liberia', 'AFRO', '35', '998', '0', '47');
INSERT INTO public.who_global_data_import VALUES (47393, '2020-07-13', 'LR', 'Liberia', 'AFRO', '12', '1010', '4', '51');
INSERT INTO public.who_global_data_import VALUES (47394, '2020-07-14', 'LR', 'Liberia', 'AFRO', '14', '1024', '0', '51');
INSERT INTO public.who_global_data_import VALUES (47395, '2020-07-15', 'LR', 'Liberia', 'AFRO', '14', '1038', '0', '51');
INSERT INTO public.who_global_data_import VALUES (47396, '2020-07-16', 'LR', 'Liberia', 'AFRO', '18', '1056', '15', '66');
INSERT INTO public.who_global_data_import VALUES (47397, '2020-07-17', 'LR', 'Liberia', 'AFRO', '14', '1070', '2', '68');
INSERT INTO public.who_global_data_import VALUES (47398, '2020-07-18', 'LR', 'Liberia', 'AFRO', '0', '1070', '0', '68');
INSERT INTO public.who_global_data_import VALUES (47399, '2020-07-19', 'LR', 'Liberia', 'AFRO', '18', '1088', '2', '70');
INSERT INTO public.who_global_data_import VALUES (47400, '2020-07-20', 'LR', 'Liberia', 'AFRO', '3', '1091', '0', '70');
INSERT INTO public.who_global_data_import VALUES (47401, '2020-07-21', 'LR', 'Liberia', 'AFRO', '16', '1107', '0', '70');
INSERT INTO public.who_global_data_import VALUES (47402, '2020-07-22', 'LR', 'Liberia', 'AFRO', '1', '1108', '0', '70');
INSERT INTO public.who_global_data_import VALUES (47403, '2020-07-23', 'LR', 'Liberia', 'AFRO', '6', '1114', '0', '70');
INSERT INTO public.who_global_data_import VALUES (47404, '2020-07-24', 'LR', 'Liberia', 'AFRO', '3', '1117', '1', '71');
INSERT INTO public.who_global_data_import VALUES (47405, '2020-07-25', 'LR', 'Liberia', 'AFRO', '18', '1135', '0', '71');
INSERT INTO public.who_global_data_import VALUES (47406, '2020-07-26', 'LR', 'Liberia', 'AFRO', '0', '1135', '0', '71');
INSERT INTO public.who_global_data_import VALUES (47407, '2020-07-27', 'LR', 'Liberia', 'AFRO', '27', '1162', '1', '72');
INSERT INTO public.who_global_data_import VALUES (47408, '2020-07-28', 'LR', 'Liberia', 'AFRO', '5', '1167', '0', '72');
INSERT INTO public.who_global_data_import VALUES (47409, '2020-07-29', 'LR', 'Liberia', 'AFRO', '0', '1167', '0', '72');
INSERT INTO public.who_global_data_import VALUES (47410, '2020-07-30', 'LR', 'Liberia', 'AFRO', '12', '1179', '0', '72');
INSERT INTO public.who_global_data_import VALUES (47411, '2020-07-31', 'LR', 'Liberia', 'AFRO', '2', '1181', '1', '73');
INSERT INTO public.who_global_data_import VALUES (47412, '2020-08-01', 'LR', 'Liberia', 'AFRO', '5', '1186', '2', '75');
INSERT INTO public.who_global_data_import VALUES (47413, '2020-08-02', 'LR', 'Liberia', 'AFRO', '3', '1189', '0', '75');
INSERT INTO public.who_global_data_import VALUES (47414, '2020-08-03', 'LR', 'Liberia', 'AFRO', '18', '1207', '2', '77');
INSERT INTO public.who_global_data_import VALUES (47415, '2020-08-04', 'LR', 'Liberia', 'AFRO', '7', '1214', '1', '78');
INSERT INTO public.who_global_data_import VALUES (47416, '2020-08-05', 'LR', 'Liberia', 'AFRO', '2', '1216', '0', '78');
INSERT INTO public.who_global_data_import VALUES (47417, '2020-08-06', 'LR', 'Liberia', 'AFRO', '5', '1221', '0', '78');
INSERT INTO public.who_global_data_import VALUES (47418, '2020-08-07', 'LR', 'Liberia', 'AFRO', '3', '1224', '0', '78');
INSERT INTO public.who_global_data_import VALUES (47419, '2020-08-08', 'LR', 'Liberia', 'AFRO', '6', '1230', '0', '78');
INSERT INTO public.who_global_data_import VALUES (47420, '2020-08-09', 'LR', 'Liberia', 'AFRO', '4', '1234', '1', '79');
INSERT INTO public.who_global_data_import VALUES (47421, '2020-08-10', 'LR', 'Liberia', 'AFRO', '3', '1237', '0', '79');
INSERT INTO public.who_global_data_import VALUES (47422, '2020-08-11', 'LR', 'Liberia', 'AFRO', '3', '1240', '0', '79');
INSERT INTO public.who_global_data_import VALUES (47423, '2020-08-12', 'LR', 'Liberia', 'AFRO', '0', '1240', '0', '79');
INSERT INTO public.who_global_data_import VALUES (47424, '2020-08-13', 'LR', 'Liberia', 'AFRO', '12', '1252', '3', '82');
INSERT INTO public.who_global_data_import VALUES (47425, '2020-08-14', 'LR', 'Liberia', 'AFRO', '0', '1252', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47426, '2020-08-15', 'LR', 'Liberia', 'AFRO', '2', '1254', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47427, '2020-08-16', 'LR', 'Liberia', 'AFRO', '3', '1257', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47428, '2020-08-17', 'LR', 'Liberia', 'AFRO', '0', '1257', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47429, '2020-08-18', 'LR', 'Liberia', 'AFRO', '20', '1277', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47430, '2020-08-19', 'LR', 'Liberia', 'AFRO', '0', '1277', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47431, '2020-08-20', 'LR', 'Liberia', 'AFRO', '5', '1282', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47432, '2020-08-21', 'LR', 'Liberia', 'AFRO', '2', '1284', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47433, '2020-08-22', 'LR', 'Liberia', 'AFRO', '1', '1285', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47434, '2020-08-23', 'LR', 'Liberia', 'AFRO', '0', '1285', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47435, '2020-08-24', 'LR', 'Liberia', 'AFRO', '1', '1286', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47436, '2020-08-25', 'LR', 'Liberia', 'AFRO', '0', '1286', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47437, '2020-08-26', 'LR', 'Liberia', 'AFRO', '4', '1290', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47438, '2020-08-27', 'LR', 'Liberia', 'AFRO', '0', '1290', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47439, '2020-08-28', 'LR', 'Liberia', 'AFRO', '0', '1290', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47440, '2020-08-29', 'LR', 'Liberia', 'AFRO', '0', '1290', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47441, '2020-08-30', 'LR', 'Liberia', 'AFRO', '13', '1303', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47442, '2020-08-31', 'LR', 'Liberia', 'AFRO', '0', '1303', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47443, '2020-09-01', 'LR', 'Liberia', 'AFRO', '2', '1305', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47444, '2020-09-02', 'LR', 'Liberia', 'AFRO', '0', '1305', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47445, '2020-09-03', 'LR', 'Liberia', 'AFRO', '0', '1305', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47446, '2020-09-04', 'LR', 'Liberia', 'AFRO', '1', '1306', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47447, '2020-09-05', 'LR', 'Liberia', 'AFRO', '0', '1306', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47448, '2020-09-06', 'LR', 'Liberia', 'AFRO', '0', '1306', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47449, '2020-09-07', 'LR', 'Liberia', 'AFRO', '0', '1306', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47450, '2020-09-08', 'LR', 'Liberia', 'AFRO', '5', '1311', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47451, '2020-09-09', 'LR', 'Liberia', 'AFRO', '0', '1311', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47452, '2020-09-10', 'LR', 'Liberia', 'AFRO', '0', '1311', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47453, '2020-09-11', 'LR', 'Liberia', 'AFRO', '0', '1311', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47454, '2020-09-12', 'LR', 'Liberia', 'AFRO', '0', '1311', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47455, '2020-09-13', 'LR', 'Liberia', 'AFRO', '0', '1311', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47456, '2020-09-14', 'LR', 'Liberia', 'AFRO', '0', '1311', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47457, '2020-09-15', 'LR', 'Liberia', 'AFRO', '0', '1311', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47458, '2020-09-16', 'LR', 'Liberia', 'AFRO', '16', '1327', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47459, '2020-09-17', 'LR', 'Liberia', 'AFRO', '0', '1327', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47460, '2020-09-18', 'LR', 'Liberia', 'AFRO', '6', '1333', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47461, '2020-09-19', 'LR', 'Liberia', 'AFRO', '1', '1334', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47462, '2020-09-20', 'LR', 'Liberia', 'AFRO', '1', '1335', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47463, '2020-09-21', 'LR', 'Liberia', 'AFRO', '1', '1336', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47464, '2020-09-22', 'LR', 'Liberia', 'AFRO', '0', '1336', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47465, '2020-09-23', 'LR', 'Liberia', 'AFRO', '0', '1336', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47466, '2020-09-24', 'LR', 'Liberia', 'AFRO', '1', '1337', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47467, '2020-09-25', 'LR', 'Liberia', 'AFRO', '1', '1338', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47468, '2020-09-26', 'LR', 'Liberia', 'AFRO', '0', '1338', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47469, '2020-09-27', 'LR', 'Liberia', 'AFRO', '0', '1338', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47470, '2020-09-28', 'LR', 'Liberia', 'AFRO', '1', '1339', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47471, '2020-09-29', 'LR', 'Liberia', 'AFRO', '0', '1339', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47472, '2020-09-30', 'LR', 'Liberia', 'AFRO', '0', '1339', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47473, '2020-10-01', 'LR', 'Liberia', 'AFRO', '4', '1343', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47474, '2020-10-02', 'LR', 'Liberia', 'AFRO', '0', '1343', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47475, '2020-10-03', 'LR', 'Liberia', 'AFRO', '0', '1343', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47476, '2020-10-04', 'LR', 'Liberia', 'AFRO', '4', '1347', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47477, '2020-10-05', 'LR', 'Liberia', 'AFRO', '1', '1348', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47478, '2020-10-06', 'LR', 'Liberia', 'AFRO', '6', '1354', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47479, '2020-10-07', 'LR', 'Liberia', 'AFRO', '0', '1354', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47480, '2020-10-08', 'LR', 'Liberia', 'AFRO', '0', '1354', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47481, '2020-10-09', 'LR', 'Liberia', 'AFRO', '6', '1360', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47482, '2020-10-10', 'LR', 'Liberia', 'AFRO', '0', '1360', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47483, '2020-10-11', 'LR', 'Liberia', 'AFRO', '3', '1363', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47484, '2020-10-12', 'LR', 'Liberia', 'AFRO', '7', '1370', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47485, '2020-10-13', 'LR', 'Liberia', 'AFRO', '0', '1370', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47486, '2020-10-14', 'LR', 'Liberia', 'AFRO', '2', '1372', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47487, '2020-10-15', 'LR', 'Liberia', 'AFRO', '0', '1372', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47488, '2020-10-16', 'LR', 'Liberia', 'AFRO', '0', '1372', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47489, '2020-10-17', 'LR', 'Liberia', 'AFRO', '5', '1377', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47490, '2020-10-18', 'LR', 'Liberia', 'AFRO', '0', '1377', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47491, '2020-10-19', 'LR', 'Liberia', 'AFRO', '3', '1380', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47492, '2020-10-20', 'LR', 'Liberia', 'AFRO', '1', '1381', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47493, '2020-10-21', 'LR', 'Liberia', 'AFRO', '3', '1384', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47494, '2020-10-22', 'LR', 'Liberia', 'AFRO', '1', '1385', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47495, '2020-10-23', 'LR', 'Liberia', 'AFRO', '0', '1385', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47496, '2020-10-24', 'LR', 'Liberia', 'AFRO', '8', '1393', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47497, '2020-10-25', 'LR', 'Liberia', 'AFRO', '2', '1395', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47498, '2020-10-26', 'LR', 'Liberia', 'AFRO', '0', '1395', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47499, '2020-10-27', 'LR', 'Liberia', 'AFRO', '21', '1416', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47500, '2020-10-28', 'LR', 'Liberia', 'AFRO', '3', '1419', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47501, '2020-10-29', 'LR', 'Liberia', 'AFRO', '0', '1419', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47502, '2020-10-30', 'LR', 'Liberia', 'AFRO', '7', '1426', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47503, '2020-10-31', 'LR', 'Liberia', 'AFRO', '0', '1426', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47504, '2020-11-01', 'LR', 'Liberia', 'AFRO', '0', '1426', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47505, '2020-11-02', 'LR', 'Liberia', 'AFRO', '0', '1426', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47506, '2020-11-03', 'LR', 'Liberia', 'AFRO', '0', '1426', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47507, '2020-11-04', 'LR', 'Liberia', 'AFRO', '10', '1436', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47508, '2020-11-05', 'LR', 'Liberia', 'AFRO', '0', '1436', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47509, '2020-11-06', 'LR', 'Liberia', 'AFRO', '0', '1436', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47510, '2020-11-07', 'LR', 'Liberia', 'AFRO', '0', '1436', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47511, '2020-11-08', 'LR', 'Liberia', 'AFRO', '6', '1442', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47512, '2020-11-09', 'LR', 'Liberia', 'AFRO', '6', '1448', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47513, '2020-11-10', 'LR', 'Liberia', 'AFRO', '0', '1448', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47514, '2020-11-11', 'LR', 'Liberia', 'AFRO', '13', '1461', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47515, '2020-11-12', 'LR', 'Liberia', 'AFRO', '0', '1461', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47516, '2020-11-13', 'LR', 'Liberia', 'AFRO', '7', '1468', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47517, '2020-11-14', 'LR', 'Liberia', 'AFRO', '23', '1491', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47518, '2020-11-15', 'LR', 'Liberia', 'AFRO', '7', '1498', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47519, '2020-11-16', 'LR', 'Liberia', 'AFRO', '9', '1507', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47520, '2020-11-17', 'LR', 'Liberia', 'AFRO', '5', '1512', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47521, '2020-11-18', 'LR', 'Liberia', 'AFRO', '0', '1512', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47522, '2020-11-19', 'LR', 'Liberia', 'AFRO', '5', '1517', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47523, '2020-11-20', 'LR', 'Liberia', 'AFRO', '22', '1539', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47524, '2020-11-21', 'LR', 'Liberia', 'AFRO', '0', '1539', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47525, '2020-11-22', 'LR', 'Liberia', 'AFRO', '15', '1554', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47526, '2020-11-23', 'LR', 'Liberia', 'AFRO', '0', '1554', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47527, '2020-11-24', 'LR', 'Liberia', 'AFRO', '0', '1554', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47528, '2020-11-25', 'LR', 'Liberia', 'AFRO', '0', '1554', '0', '82');
INSERT INTO public.who_global_data_import VALUES (47529, '2020-11-26', 'LR', 'Liberia', 'AFRO', '24', '1578', '1', '83');
INSERT INTO public.who_global_data_import VALUES (47530, '2020-11-27', 'LR', 'Liberia', 'AFRO', '13', '1591', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47531, '2020-11-28', 'LR', 'Liberia', 'AFRO', '4', '1595', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47532, '2020-11-29', 'LR', 'Liberia', 'AFRO', '0', '1595', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47533, '2020-11-30', 'LR', 'Liberia', 'AFRO', '3', '1598', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47534, '2020-12-01', 'LR', 'Liberia', 'AFRO', '0', '1598', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47535, '2020-12-02', 'LR', 'Liberia', 'AFRO', '0', '1598', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47536, '2020-12-03', 'LR', 'Liberia', 'AFRO', '0', '1598', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47537, '2020-12-04', 'LR', 'Liberia', 'AFRO', '0', '1598', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47538, '2020-12-05', 'LR', 'Liberia', 'AFRO', '65', '1663', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47539, '2020-12-06', 'LR', 'Liberia', 'AFRO', '13', '1676', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47540, '2020-12-07', 'LR', 'Liberia', 'AFRO', '0', '1676', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47541, '2020-12-08', 'LR', 'Liberia', 'AFRO', '0', '1676', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47542, '2020-12-09', 'LR', 'Liberia', 'AFRO', '0', '1676', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47543, '2020-12-10', 'LR', 'Liberia', 'AFRO', '0', '1676', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47544, '2020-12-11', 'LR', 'Liberia', 'AFRO', '0', '1676', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47545, '2020-12-12', 'LR', 'Liberia', 'AFRO', '0', '1676', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47546, '2020-12-13', 'LR', 'Liberia', 'AFRO', '0', '1676', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47547, '2020-12-14', 'LR', 'Liberia', 'AFRO', '95', '1771', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47548, '2020-12-15', 'LR', 'Liberia', 'AFRO', '0', '1771', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47549, '2020-12-16', 'LR', 'Liberia', 'AFRO', '0', '1771', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47550, '2020-12-17', 'LR', 'Liberia', 'AFRO', '0', '1771', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47551, '2020-12-18', 'LR', 'Liberia', 'AFRO', '0', '1771', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47552, '2020-12-19', 'LR', 'Liberia', 'AFRO', '8', '1779', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47553, '2020-12-20', 'LR', 'Liberia', 'AFRO', '0', '1779', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47554, '2020-12-21', 'LR', 'Liberia', 'AFRO', '9', '1788', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47555, '2020-12-22', 'LR', 'Liberia', 'AFRO', '0', '1788', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47556, '2020-12-23', 'LR', 'Liberia', 'AFRO', '10', '1798', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47557, '2020-12-24', 'LR', 'Liberia', 'AFRO', '0', '1798', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47558, '2020-12-25', 'LR', 'Liberia', 'AFRO', '0', '1798', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47559, '2020-12-26', 'LR', 'Liberia', 'AFRO', '2', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47560, '2020-12-27', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47561, '2020-12-28', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47562, '2020-12-29', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47563, '2020-12-30', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47564, '2020-12-31', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47565, '2021-01-01', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47566, '2021-01-02', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47567, '2021-01-03', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47568, '2021-01-04', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47569, '2021-01-05', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47570, '2021-01-06', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47571, '2021-01-07', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47572, '2021-01-08', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47573, '2021-01-09', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47574, '2021-01-10', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47575, '2021-01-11', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47576, '2021-01-12', 'LR', 'Liberia', 'AFRO', '0', '1800', '0', '83');
INSERT INTO public.who_global_data_import VALUES (47577, '2021-01-13', 'LR', 'Liberia', 'AFRO', '76', '1876', '1', '84');
INSERT INTO public.who_global_data_import VALUES (47578, '2021-01-14', 'LR', 'Liberia', 'AFRO', '1', '1877', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47579, '2021-01-15', 'LR', 'Liberia', 'AFRO', '0', '1877', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47580, '2021-01-16', 'LR', 'Liberia', 'AFRO', '5', '1882', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47581, '2021-01-17', 'LR', 'Liberia', 'AFRO', '5', '1887', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47582, '2021-01-18', 'LR', 'Liberia', 'AFRO', '0', '1887', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47583, '2021-01-19', 'LR', 'Liberia', 'AFRO', '9', '1896', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47584, '2021-01-20', 'LR', 'Liberia', 'AFRO', '2', '1898', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47585, '2021-01-21', 'LR', 'Liberia', 'AFRO', '3', '1901', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47586, '2021-01-22', 'LR', 'Liberia', 'AFRO', '0', '1901', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47587, '2021-01-23', 'LR', 'Liberia', 'AFRO', '13', '1914', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47588, '2021-01-24', 'LR', 'Liberia', 'AFRO', '0', '1914', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47589, '2021-01-25', 'LR', 'Liberia', 'AFRO', '0', '1914', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47590, '2021-01-26', 'LR', 'Liberia', 'AFRO', '13', '1927', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47591, '2021-01-27', 'LR', 'Liberia', 'AFRO', '5', '1932', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47592, '2021-01-28', 'LR', 'Liberia', 'AFRO', '4', '1936', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47593, '2021-01-29', 'LR', 'Liberia', 'AFRO', '0', '1936', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47594, '2021-01-30', 'LR', 'Liberia', 'AFRO', '3', '1939', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47595, '2021-01-31', 'LR', 'Liberia', 'AFRO', '0', '1939', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47596, '2021-02-01', 'LR', 'Liberia', 'AFRO', '0', '1939', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47597, '2021-02-02', 'LR', 'Liberia', 'AFRO', '5', '1944', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47598, '2021-02-03', 'LR', 'Liberia', 'AFRO', '0', '1944', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47599, '2021-02-04', 'LR', 'Liberia', 'AFRO', '1', '1945', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47600, '2021-02-05', 'LR', 'Liberia', 'AFRO', '0', '1945', '0', '84');
INSERT INTO public.who_global_data_import VALUES (47601, '2020-01-03', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47602, '2020-01-04', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47603, '2020-01-05', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47604, '2020-01-06', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47605, '2020-01-07', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47606, '2020-01-08', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47607, '2020-01-09', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47608, '2020-01-10', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47609, '2020-01-11', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47610, '2020-01-12', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47611, '2020-01-13', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47612, '2020-01-14', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47613, '2020-01-15', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47614, '2020-01-16', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47615, '2020-01-17', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47616, '2020-01-18', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47617, '2020-01-19', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47618, '2020-01-20', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47619, '2020-01-21', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47620, '2020-01-22', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47621, '2020-01-23', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47622, '2020-01-24', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47623, '2020-01-25', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47624, '2020-01-26', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47625, '2020-01-27', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47626, '2020-01-28', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47627, '2020-01-29', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47628, '2020-01-30', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47629, '2020-01-31', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47630, '2020-02-01', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47631, '2020-02-02', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47632, '2020-02-03', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47633, '2020-02-04', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47634, '2020-02-05', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47635, '2020-02-06', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47636, '2020-02-07', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47637, '2020-02-08', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47638, '2020-02-09', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47639, '2020-02-10', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47640, '2020-02-11', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47641, '2020-02-12', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47642, '2020-02-13', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47643, '2020-02-14', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47644, '2020-02-15', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47645, '2020-02-16', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47646, '2020-02-17', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47647, '2020-02-18', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47648, '2020-02-19', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47649, '2020-02-20', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47650, '2020-02-21', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47651, '2020-02-22', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47652, '2020-02-23', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47653, '2020-02-24', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47654, '2020-02-25', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47655, '2020-02-26', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47656, '2020-02-27', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47657, '2020-02-28', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47658, '2020-02-29', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47659, '2020-03-01', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47660, '2020-03-02', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47661, '2020-03-03', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47662, '2020-03-04', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47663, '2020-03-05', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47664, '2020-03-06', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47665, '2020-03-07', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47666, '2020-03-08', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47667, '2020-03-09', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47668, '2020-03-10', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47669, '2020-03-11', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47670, '2020-03-12', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47671, '2020-03-13', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47672, '2020-03-14', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47673, '2020-03-15', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47674, '2020-03-16', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47675, '2020-03-17', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47676, '2020-03-18', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47677, '2020-03-19', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47678, '2020-03-20', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47679, '2020-03-21', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47680, '2020-03-22', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47681, '2020-03-23', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47682, '2020-03-24', 'LY', 'Libya', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47683, '2020-03-25', 'LY', 'Libya', 'EMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47684, '2020-03-26', 'LY', 'Libya', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47685, '2020-03-27', 'LY', 'Libya', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47686, '2020-03-28', 'LY', 'Libya', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47687, '2020-03-29', 'LY', 'Libya', 'EMRO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47688, '2020-03-30', 'LY', 'Libya', 'EMRO', '5', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47689, '2020-03-31', 'LY', 'Libya', 'EMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47690, '2020-04-01', 'LY', 'Libya', 'EMRO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47691, '2020-04-02', 'LY', 'Libya', 'EMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (47692, '2020-04-03', 'LY', 'Libya', 'EMRO', '1', '11', '1', '1');
INSERT INTO public.who_global_data_import VALUES (47693, '2020-04-04', 'LY', 'Libya', 'EMRO', '6', '17', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47694, '2020-04-05', 'LY', 'Libya', 'EMRO', '1', '18', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47695, '2020-04-06', 'LY', 'Libya', 'EMRO', '0', '18', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47696, '2020-04-07', 'LY', 'Libya', 'EMRO', '1', '19', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47697, '2020-04-08', 'LY', 'Libya', 'EMRO', '2', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47698, '2020-04-09', 'LY', 'Libya', 'EMRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47699, '2020-04-10', 'LY', 'Libya', 'EMRO', '3', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47700, '2020-04-11', 'LY', 'Libya', 'EMRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47701, '2020-04-12', 'LY', 'Libya', 'EMRO', '1', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47702, '2020-04-13', 'LY', 'Libya', 'EMRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47703, '2020-04-14', 'LY', 'Libya', 'EMRO', '1', '26', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47704, '2020-04-15', 'LY', 'Libya', 'EMRO', '9', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47705, '2020-04-16', 'LY', 'Libya', 'EMRO', '13', '48', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47706, '2020-04-17', 'LY', 'Libya', 'EMRO', '1', '49', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47707, '2020-04-18', 'LY', 'Libya', 'EMRO', '0', '49', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47708, '2020-04-19', 'LY', 'Libya', 'EMRO', '0', '49', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47709, '2020-04-20', 'LY', 'Libya', 'EMRO', '2', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47710, '2020-04-21', 'LY', 'Libya', 'EMRO', '0', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47711, '2020-04-22', 'LY', 'Libya', 'EMRO', '8', '59', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47712, '2020-04-23', 'LY', 'Libya', 'EMRO', '1', '60', '0', '1');
INSERT INTO public.who_global_data_import VALUES (47713, '2020-04-24', 'LY', 'Libya', 'EMRO', '0', '60', '1', '2');
INSERT INTO public.who_global_data_import VALUES (47714, '2020-04-25', 'LY', 'Libya', 'EMRO', '1', '61', '0', '2');
INSERT INTO public.who_global_data_import VALUES (47715, '2020-04-26', 'LY', 'Libya', 'EMRO', '0', '61', '0', '2');
INSERT INTO public.who_global_data_import VALUES (47716, '2020-04-27', 'LY', 'Libya', 'EMRO', '0', '61', '0', '2');
INSERT INTO public.who_global_data_import VALUES (47717, '2020-04-28', 'LY', 'Libya', 'EMRO', '0', '61', '0', '2');
INSERT INTO public.who_global_data_import VALUES (47718, '2020-04-29', 'LY', 'Libya', 'EMRO', '0', '61', '0', '2');
INSERT INTO public.who_global_data_import VALUES (47719, '2020-04-30', 'LY', 'Libya', 'EMRO', '0', '61', '0', '2');
INSERT INTO public.who_global_data_import VALUES (47720, '2020-05-01', 'LY', 'Libya', 'EMRO', '2', '63', '1', '3');
INSERT INTO public.who_global_data_import VALUES (47721, '2020-05-02', 'LY', 'Libya', 'EMRO', '0', '63', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47722, '2020-05-03', 'LY', 'Libya', 'EMRO', '0', '63', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47723, '2020-05-04', 'LY', 'Libya', 'EMRO', '0', '63', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47724, '2020-05-05', 'LY', 'Libya', 'EMRO', '0', '63', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47725, '2020-05-06', 'LY', 'Libya', 'EMRO', '1', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47726, '2020-05-07', 'LY', 'Libya', 'EMRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47727, '2020-05-08', 'LY', 'Libya', 'EMRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47728, '2020-05-09', 'LY', 'Libya', 'EMRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47729, '2020-05-10', 'LY', 'Libya', 'EMRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47730, '2020-05-11', 'LY', 'Libya', 'EMRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47731, '2020-05-12', 'LY', 'Libya', 'EMRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47732, '2020-05-13', 'LY', 'Libya', 'EMRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47733, '2020-05-14', 'LY', 'Libya', 'EMRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47734, '2020-05-15', 'LY', 'Libya', 'EMRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47735, '2020-05-16', 'LY', 'Libya', 'EMRO', '0', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47736, '2020-05-17', 'LY', 'Libya', 'EMRO', '1', '65', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47737, '2020-05-18', 'LY', 'Libya', 'EMRO', '0', '65', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47738, '2020-05-19', 'LY', 'Libya', 'EMRO', '0', '65', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47739, '2020-05-20', 'LY', 'Libya', 'EMRO', '3', '68', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47740, '2020-05-21', 'LY', 'Libya', 'EMRO', '3', '71', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47741, '2020-05-22', 'LY', 'Libya', 'EMRO', '0', '71', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47742, '2020-05-23', 'LY', 'Libya', 'EMRO', '1', '72', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47743, '2020-05-24', 'LY', 'Libya', 'EMRO', '3', '75', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47744, '2020-05-25', 'LY', 'Libya', 'EMRO', '0', '75', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47745, '2020-05-26', 'LY', 'Libya', 'EMRO', '0', '75', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47746, '2020-05-27', 'LY', 'Libya', 'EMRO', '2', '77', '0', '3');
INSERT INTO public.who_global_data_import VALUES (47747, '2020-05-28', 'LY', 'Libya', 'EMRO', '22', '99', '1', '4');
INSERT INTO public.who_global_data_import VALUES (47748, '2020-05-29', 'LY', 'Libya', 'EMRO', '6', '105', '1', '5');
INSERT INTO public.who_global_data_import VALUES (47749, '2020-05-30', 'LY', 'Libya', 'EMRO', '13', '118', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47750, '2020-05-31', 'LY', 'Libya', 'EMRO', '12', '130', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47751, '2020-06-01', 'LY', 'Libya', 'EMRO', '26', '156', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47752, '2020-06-02', 'LY', 'Libya', 'EMRO', '12', '168', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47753, '2020-06-03', 'LY', 'Libya', 'EMRO', '14', '182', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47754, '2020-06-04', 'LY', 'Libya', 'EMRO', '14', '196', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47755, '2020-06-05', 'LY', 'Libya', 'EMRO', '13', '209', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47756, '2020-06-06', 'LY', 'Libya', 'EMRO', '30', '239', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47757, '2020-06-07', 'LY', 'Libya', 'EMRO', '17', '256', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47758, '2020-06-08', 'LY', 'Libya', 'EMRO', '14', '270', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47759, '2020-06-09', 'LY', 'Libya', 'EMRO', '62', '332', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47760, '2020-06-10', 'LY', 'Libya', 'EMRO', '27', '359', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47761, '2020-06-11', 'LY', 'Libya', 'EMRO', '19', '378', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47762, '2020-06-12', 'LY', 'Libya', 'EMRO', '15', '393', '0', '5');
INSERT INTO public.who_global_data_import VALUES (47763, '2020-06-13', 'LY', 'Libya', 'EMRO', '16', '409', '1', '6');
INSERT INTO public.who_global_data_import VALUES (47764, '2020-06-14', 'LY', 'Libya', 'EMRO', '9', '418', '2', '8');
INSERT INTO public.who_global_data_import VALUES (47765, '2020-06-15', 'LY', 'Libya', 'EMRO', '0', '418', '0', '8');
INSERT INTO public.who_global_data_import VALUES (47766, '2020-06-16', 'LY', 'Libya', 'EMRO', '49', '467', '2', '10');
INSERT INTO public.who_global_data_import VALUES (47767, '2020-06-17', 'LY', 'Libya', 'EMRO', '0', '467', '0', '10');
INSERT INTO public.who_global_data_import VALUES (47768, '2020-06-18', 'LY', 'Libya', 'EMRO', '17', '484', '0', '10');
INSERT INTO public.who_global_data_import VALUES (47769, '2020-06-19', 'LY', 'Libya', 'EMRO', '26', '510', '0', '10');
INSERT INTO public.who_global_data_import VALUES (47770, '2020-06-20', 'LY', 'Libya', 'EMRO', '10', '520', '0', '10');
INSERT INTO public.who_global_data_import VALUES (47771, '2020-06-21', 'LY', 'Libya', 'EMRO', '24', '544', '0', '10');
INSERT INTO public.who_global_data_import VALUES (47772, '2020-06-22', 'LY', 'Libya', 'EMRO', '27', '571', '0', '10');
INSERT INTO public.who_global_data_import VALUES (47773, '2020-06-23', 'LY', 'Libya', 'EMRO', '0', '571', '0', '10');
INSERT INTO public.who_global_data_import VALUES (47774, '2020-06-24', 'LY', 'Libya', 'EMRO', '68', '639', '7', '17');
INSERT INTO public.who_global_data_import VALUES (47775, '2020-06-25', 'LY', 'Libya', 'EMRO', '0', '639', '1', '18');
INSERT INTO public.who_global_data_import VALUES (47776, '2020-06-26', 'LY', 'Libya', 'EMRO', '59', '698', '0', '18');
INSERT INTO public.who_global_data_import VALUES (47777, '2020-06-27', 'LY', 'Libya', 'EMRO', '15', '713', '0', '18');
INSERT INTO public.who_global_data_import VALUES (47778, '2020-06-28', 'LY', 'Libya', 'EMRO', '14', '727', '0', '18');
INSERT INTO public.who_global_data_import VALUES (47779, '2020-06-29', 'LY', 'Libya', 'EMRO', '35', '762', '3', '21');
INSERT INTO public.who_global_data_import VALUES (47780, '2020-06-30', 'LY', 'Libya', 'EMRO', '40', '802', '2', '23');
INSERT INTO public.who_global_data_import VALUES (47781, '2020-07-01', 'LY', 'Libya', 'EMRO', '22', '824', '1', '24');
INSERT INTO public.who_global_data_import VALUES (47782, '2020-07-02', 'LY', 'Libya', 'EMRO', '50', '874', '1', '25');
INSERT INTO public.who_global_data_import VALUES (47783, '2020-07-03', 'LY', 'Libya', 'EMRO', '17', '891', '1', '26');
INSERT INTO public.who_global_data_import VALUES (47784, '2020-07-04', 'LY', 'Libya', 'EMRO', '27', '918', '1', '27');
INSERT INTO public.who_global_data_import VALUES (47785, '2020-07-05', 'LY', 'Libya', 'EMRO', '71', '989', '0', '27');
INSERT INTO public.who_global_data_import VALUES (47786, '2020-07-06', 'LY', 'Libya', 'EMRO', '57', '1046', '5', '32');
INSERT INTO public.who_global_data_import VALUES (47787, '2020-07-07', 'LY', 'Libya', 'EMRO', '71', '1117', '2', '34');
INSERT INTO public.who_global_data_import VALUES (47788, '2020-07-08', 'LY', 'Libya', 'EMRO', '65', '1182', '1', '35');
INSERT INTO public.who_global_data_import VALUES (47789, '2020-07-09', 'LY', 'Libya', 'EMRO', '86', '1268', '1', '36');
INSERT INTO public.who_global_data_import VALUES (47790, '2020-07-10', 'LY', 'Libya', 'EMRO', '74', '1342', '2', '38');
INSERT INTO public.who_global_data_import VALUES (47791, '2020-07-11', 'LY', 'Libya', 'EMRO', '0', '1342', '0', '38');
INSERT INTO public.who_global_data_import VALUES (47792, '2020-07-12', 'LY', 'Libya', 'EMRO', '47', '1389', '0', '38');
INSERT INTO public.who_global_data_import VALUES (47793, '2020-07-13', 'LY', 'Libya', 'EMRO', '44', '1433', '1', '39');
INSERT INTO public.who_global_data_import VALUES (47794, '2020-07-14', 'LY', 'Libya', 'EMRO', '79', '1512', '1', '40');
INSERT INTO public.who_global_data_import VALUES (47795, '2020-07-15', 'LY', 'Libya', 'EMRO', '51', '1563', '2', '42');
INSERT INTO public.who_global_data_import VALUES (47796, '2020-07-16', 'LY', 'Libya', 'EMRO', '26', '1589', '1', '43');
INSERT INTO public.who_global_data_import VALUES (47797, '2020-07-17', 'LY', 'Libya', 'EMRO', '63', '1652', '3', '46');
INSERT INTO public.who_global_data_import VALUES (47798, '2020-07-18', 'LY', 'Libya', 'EMRO', '52', '1704', '1', '47');
INSERT INTO public.who_global_data_import VALUES (47799, '2020-07-19', 'LY', 'Libya', 'EMRO', '87', '1791', '1', '48');
INSERT INTO public.who_global_data_import VALUES (47800, '2020-07-20', 'LY', 'Libya', 'EMRO', '75', '1866', '0', '48');
INSERT INTO public.who_global_data_import VALUES (47801, '2020-07-21', 'LY', 'Libya', 'EMRO', '114', '1980', '1', '49');
INSERT INTO public.who_global_data_import VALUES (47802, '2020-07-22', 'LY', 'Libya', 'EMRO', '108', '2088', '1', '50');
INSERT INTO public.who_global_data_import VALUES (47803, '2020-07-23', 'LY', 'Libya', 'EMRO', '88', '2176', '3', '53');
INSERT INTO public.who_global_data_import VALUES (47804, '2020-07-24', 'LY', 'Libya', 'EMRO', '138', '2314', '3', '56');
INSERT INTO public.who_global_data_import VALUES (47805, '2020-07-25', 'LY', 'Libya', 'EMRO', '111', '2425', '1', '57');
INSERT INTO public.who_global_data_import VALUES (47806, '2020-07-26', 'LY', 'Libya', 'EMRO', '122', '2547', '1', '58');
INSERT INTO public.who_global_data_import VALUES (47807, '2020-07-27', 'LY', 'Libya', 'EMRO', '122', '2669', '2', '60');
INSERT INTO public.who_global_data_import VALUES (47808, '2020-07-28', 'LY', 'Libya', 'EMRO', '158', '2827', '4', '64');
INSERT INTO public.who_global_data_import VALUES (47809, '2020-07-29', 'LY', 'Libya', 'EMRO', '190', '3017', '3', '67');
INSERT INTO public.who_global_data_import VALUES (47810, '2020-07-30', 'LY', 'Libya', 'EMRO', '205', '3222', '4', '71');
INSERT INTO public.who_global_data_import VALUES (47811, '2020-07-31', 'LY', 'Libya', 'EMRO', '216', '3438', '2', '73');
INSERT INTO public.who_global_data_import VALUES (47812, '2020-08-01', 'LY', 'Libya', 'EMRO', '183', '3621', '1', '74');
INSERT INTO public.who_global_data_import VALUES (47813, '2020-08-02', 'LY', 'Libya', 'EMRO', '70', '3691', '6', '80');
INSERT INTO public.who_global_data_import VALUES (47814, '2020-08-03', 'LY', 'Libya', 'EMRO', '146', '3837', '3', '83');
INSERT INTO public.who_global_data_import VALUES (47815, '2020-08-04', 'LY', 'Libya', 'EMRO', '226', '4063', '10', '93');
INSERT INTO public.who_global_data_import VALUES (47816, '2020-08-05', 'LY', 'Libya', 'EMRO', '161', '4224', '3', '96');
INSERT INTO public.who_global_data_import VALUES (47817, '2020-08-06', 'LY', 'Libya', 'EMRO', '251', '4475', '3', '99');
INSERT INTO public.who_global_data_import VALUES (47818, '2020-08-07', 'LY', 'Libya', 'EMRO', '404', '4879', '8', '107');
INSERT INTO public.who_global_data_import VALUES (47819, '2020-08-08', 'LY', 'Libya', 'EMRO', '199', '5078', '1', '108');
INSERT INTO public.who_global_data_import VALUES (47820, '2020-08-09', 'LY', 'Libya', 'EMRO', '154', '5232', '5', '113');
INSERT INTO public.who_global_data_import VALUES (47821, '2020-08-10', 'LY', 'Libya', 'EMRO', '309', '5541', '7', '120');
INSERT INTO public.who_global_data_import VALUES (47822, '2020-08-11', 'LY', 'Libya', 'EMRO', '388', '5929', '5', '125');
INSERT INTO public.who_global_data_import VALUES (47823, '2020-08-12', 'LY', 'Libya', 'EMRO', '373', '6302', '7', '132');
INSERT INTO public.who_global_data_import VALUES (47824, '2020-08-13', 'LY', 'Libya', 'EMRO', '309', '6611', '0', '132');
INSERT INTO public.who_global_data_import VALUES (47825, '2020-08-14', 'LY', 'Libya', 'EMRO', '439', '7050', '3', '135');
INSERT INTO public.who_global_data_import VALUES (47826, '2020-08-15', 'LY', 'Libya', 'EMRO', '277', '7327', '4', '139');
INSERT INTO public.who_global_data_import VALUES (47827, '2020-08-16', 'LY', 'Libya', 'EMRO', '411', '7738', '6', '145');
INSERT INTO public.who_global_data_import VALUES (47828, '2020-08-17', 'LY', 'Libya', 'EMRO', '434', '8172', '8', '153');
INSERT INTO public.who_global_data_import VALUES (47829, '2020-08-18', 'LY', 'Libya', 'EMRO', '407', '8579', '4', '157');
INSERT INTO public.who_global_data_import VALUES (47830, '2020-08-19', 'LY', 'Libya', 'EMRO', '489', '9068', '7', '164');
INSERT INTO public.who_global_data_import VALUES (47831, '2020-08-20', 'LY', 'Libya', 'EMRO', '395', '9463', '5', '169');
INSERT INTO public.who_global_data_import VALUES (47832, '2020-08-21', 'LY', 'Libya', 'EMRO', '244', '9707', '4', '173');
INSERT INTO public.who_global_data_import VALUES (47833, '2020-08-22', 'LY', 'Libya', 'EMRO', '414', '10121', '7', '180');
INSERT INTO public.who_global_data_import VALUES (47834, '2020-08-23', 'LY', 'Libya', 'EMRO', '316', '10437', '8', '188');
INSERT INTO public.who_global_data_import VALUES (47835, '2020-08-24', 'LY', 'Libya', 'EMRO', '572', '11009', '11', '199');
INSERT INTO public.who_global_data_import VALUES (47836, '2020-08-25', 'LY', 'Libya', 'EMRO', '272', '11281', '4', '203');
INSERT INTO public.who_global_data_import VALUES (47837, '2020-08-26', 'LY', 'Libya', 'EMRO', '553', '11834', '7', '210');
INSERT INTO public.who_global_data_import VALUES (47838, '2020-08-27', 'LY', 'Libya', 'EMRO', '440', '12274', '9', '219');
INSERT INTO public.who_global_data_import VALUES (47839, '2020-08-28', 'LY', 'Libya', 'EMRO', '355', '12629', '7', '226');
INSERT INTO public.who_global_data_import VALUES (47840, '2020-08-29', 'LY', 'Libya', 'EMRO', '329', '12958', '5', '231');
INSERT INTO public.who_global_data_import VALUES (47841, '2020-08-30', 'LY', 'Libya', 'EMRO', '465', '13423', '1', '232');
INSERT INTO public.who_global_data_import VALUES (47842, '2020-08-31', 'LY', 'Libya', 'EMRO', '543', '13966', '5', '237');
INSERT INTO public.who_global_data_import VALUES (47843, '2020-09-01', 'LY', 'Libya', 'EMRO', '658', '14624', '5', '242');
INSERT INTO public.who_global_data_import VALUES (47844, '2020-09-02', 'LY', 'Libya', 'EMRO', '532', '15156', '8', '250');
INSERT INTO public.who_global_data_import VALUES (47845, '2020-09-03', 'LY', 'Libya', 'EMRO', '617', '15773', '4', '254');
INSERT INTO public.who_global_data_import VALUES (47846, '2020-09-04', 'LY', 'Libya', 'EMRO', '672', '16445', '8', '262');
INSERT INTO public.who_global_data_import VALUES (47847, '2020-09-05', 'LY', 'Libya', 'EMRO', '649', '17094', '10', '272');
INSERT INTO public.who_global_data_import VALUES (47848, '2020-09-06', 'LY', 'Libya', 'EMRO', '655', '17749', '13', '285');
INSERT INTO public.who_global_data_import VALUES (47849, '2020-09-07', 'LY', 'Libya', 'EMRO', '1085', '18834', '11', '296');
INSERT INTO public.who_global_data_import VALUES (47850, '2020-09-08', 'LY', 'Libya', 'EMRO', '749', '19583', '18', '314');
INSERT INTO public.who_global_data_import VALUES (47851, '2020-09-09', 'LY', 'Libya', 'EMRO', '879', '20462', '10', '324');
INSERT INTO public.who_global_data_import VALUES (47852, '2020-09-10', 'LY', 'Libya', 'EMRO', '477', '20939', '15', '339');
INSERT INTO public.who_global_data_import VALUES (47853, '2020-09-11', 'LY', 'Libya', 'EMRO', '969', '21908', '13', '352');
INSERT INTO public.who_global_data_import VALUES (47854, '2020-09-12', 'LY', 'Libya', 'EMRO', '440', '22348', '2', '354');
INSERT INTO public.who_global_data_import VALUES (47855, '2020-09-13', 'LY', 'Libya', 'EMRO', '433', '22781', '8', '362');
INSERT INTO public.who_global_data_import VALUES (47856, '2020-09-14', 'LY', 'Libya', 'EMRO', '734', '23515', '6', '368');
INSERT INTO public.who_global_data_import VALUES (47857, '2020-09-15', 'LY', 'Libya', 'EMRO', '629', '24144', '15', '383');
INSERT INTO public.who_global_data_import VALUES (47858, '2020-09-16', 'LY', 'Libya', 'EMRO', '792', '24936', '11', '394');
INSERT INTO public.who_global_data_import VALUES (47859, '2020-09-17', 'LY', 'Libya', 'EMRO', '886', '25822', '11', '405');
INSERT INTO public.who_global_data_import VALUES (47860, '2020-09-18', 'LY', 'Libya', 'EMRO', '616', '26438', '13', '418');
INSERT INTO public.who_global_data_import VALUES (47861, '2020-09-19', 'LY', 'Libya', 'EMRO', '796', '27234', '8', '426');
INSERT INTO public.who_global_data_import VALUES (47862, '2020-09-20', 'LY', 'Libya', 'EMRO', '715', '27949', '8', '434');
INSERT INTO public.who_global_data_import VALUES (47863, '2020-09-21', 'LY', 'Libya', 'EMRO', '847', '28796', '16', '450');
INSERT INTO public.who_global_data_import VALUES (47864, '2020-09-22', 'LY', 'Libya', 'EMRO', '650', '29446', '10', '460');
INSERT INTO public.who_global_data_import VALUES (47865, '2020-09-23', 'LY', 'Libya', 'EMRO', '651', '30097', '9', '469');
INSERT INTO public.who_global_data_import VALUES (47866, '2020-09-24', 'LY', 'Libya', 'EMRO', '535', '30632', '5', '474');
INSERT INTO public.who_global_data_import VALUES (47867, '2020-09-25', 'LY', 'Libya', 'EMRO', '658', '31290', '17', '491');
INSERT INTO public.who_global_data_import VALUES (47868, '2020-09-26', 'LY', 'Libya', 'EMRO', '538', '31828', '8', '499');
INSERT INTO public.who_global_data_import VALUES (47869, '2020-09-27', 'LY', 'Libya', 'EMRO', '536', '32364', '21', '520');
INSERT INTO public.who_global_data_import VALUES (47870, '2020-09-28', 'LY', 'Libya', 'EMRO', '849', '33213', '7', '527');
INSERT INTO public.who_global_data_import VALUES (47871, '2020-09-29', 'LY', 'Libya', 'EMRO', '801', '34014', '13', '540');
INSERT INTO public.who_global_data_import VALUES (47872, '2020-09-30', 'LY', 'Libya', 'EMRO', '511', '34525', '11', '551');
INSERT INTO public.who_global_data_import VALUES (47873, '2020-10-01', 'LY', 'Libya', 'EMRO', '683', '35208', '8', '559');
INSERT INTO public.who_global_data_import VALUES (47874, '2020-10-02', 'LY', 'Libya', 'EMRO', '509', '35717', '11', '570');
INSERT INTO public.who_global_data_import VALUES (47875, '2020-10-03', 'LY', 'Libya', 'EMRO', '370', '36087', '8', '578');
INSERT INTO public.who_global_data_import VALUES (47876, '2020-10-04', 'LY', 'Libya', 'EMRO', '722', '36809', '14', '592');
INSERT INTO public.who_global_data_import VALUES (47877, '2020-10-05', 'LY', 'Libya', 'EMRO', '628', '37437', '4', '596');
INSERT INTO public.who_global_data_import VALUES (47878, '2020-10-06', 'LY', 'Libya', 'EMRO', '1031', '38468', '6', '602');
INSERT INTO public.who_global_data_import VALUES (47879, '2020-10-07', 'LY', 'Libya', 'EMRO', '1045', '39513', '6', '608');
INSERT INTO public.who_global_data_import VALUES (47880, '2020-10-08', 'LY', 'Libya', 'EMRO', '779', '40292', '8', '616');
INSERT INTO public.who_global_data_import VALUES (47881, '2020-10-09', 'LY', 'Libya', 'EMRO', '1076', '41368', '5', '621');
INSERT INTO public.who_global_data_import VALUES (47882, '2020-10-10', 'LY', 'Libya', 'EMRO', '318', '41686', '2', '623');
INSERT INTO public.who_global_data_import VALUES (47883, '2020-10-11', 'LY', 'Libya', 'EMRO', '1026', '42712', '8', '631');
INSERT INTO public.who_global_data_import VALUES (47884, '2020-10-12', 'LY', 'Libya', 'EMRO', '1109', '43821', '13', '644');
INSERT INTO public.who_global_data_import VALUES (47885, '2020-10-13', 'LY', 'Libya', 'EMRO', '1164', '44985', '12', '656');
INSERT INTO public.who_global_data_import VALUES (47886, '2020-10-14', 'LY', 'Libya', 'EMRO', '836', '45821', '13', '669');
INSERT INTO public.who_global_data_import VALUES (47887, '2020-10-15', 'LY', 'Libya', 'EMRO', '855', '46676', '12', '681');
INSERT INTO public.who_global_data_import VALUES (47888, '2020-10-16', 'LY', 'Libya', 'EMRO', '1169', '47845', '18', '699');
INSERT INTO public.who_global_data_import VALUES (47889, '2020-10-17', 'LY', 'Libya', 'EMRO', '0', '47845', '0', '699');
INSERT INTO public.who_global_data_import VALUES (47890, '2020-10-18', 'LY', 'Libya', 'EMRO', '945', '48790', '26', '725');
INSERT INTO public.who_global_data_import VALUES (47891, '2020-10-19', 'LY', 'Libya', 'EMRO', '1159', '49949', '7', '732');
INSERT INTO public.who_global_data_import VALUES (47892, '2020-10-20', 'LY', 'Libya', 'EMRO', '957', '50906', '14', '746');
INSERT INTO public.who_global_data_import VALUES (47893, '2020-10-21', 'LY', 'Libya', 'EMRO', '0', '50906', '0', '746');
INSERT INTO public.who_global_data_import VALUES (47894, '2020-10-22', 'LY', 'Libya', 'EMRO', '719', '51625', '19', '765');
INSERT INTO public.who_global_data_import VALUES (47895, '2020-10-23', 'LY', 'Libya', 'EMRO', '995', '52620', '3', '768');
INSERT INTO public.who_global_data_import VALUES (47896, '2020-10-24', 'LY', 'Libya', 'EMRO', '764', '53384', '6', '774');
INSERT INTO public.who_global_data_import VALUES (47897, '2020-10-25', 'LY', 'Libya', 'EMRO', '990', '54374', '16', '790');
INSERT INTO public.who_global_data_import VALUES (47898, '2020-10-26', 'LY', 'Libya', 'EMRO', '1639', '56013', '5', '795');
INSERT INTO public.who_global_data_import VALUES (47899, '2020-10-27', 'LY', 'Libya', 'EMRO', '1210', '57223', '6', '801');
INSERT INTO public.who_global_data_import VALUES (47900, '2020-10-28', 'LY', 'Libya', 'EMRO', '752', '57975', '11', '812');
INSERT INTO public.who_global_data_import VALUES (47901, '2020-10-29', 'LY', 'Libya', 'EMRO', '899', '58874', '11', '823');
INSERT INTO public.who_global_data_import VALUES (47902, '2020-10-30', 'LY', 'Libya', 'EMRO', '782', '59656', '8', '831');
INSERT INTO public.who_global_data_import VALUES (47903, '2020-10-31', 'LY', 'Libya', 'EMRO', '972', '60628', '16', '847');
INSERT INTO public.who_global_data_import VALUES (47904, '2020-11-01', 'LY', 'Libya', 'EMRO', '467', '61095', '10', '857');
INSERT INTO public.who_global_data_import VALUES (47905, '2020-11-02', 'LY', 'Libya', 'EMRO', '950', '62045', '14', '871');
INSERT INTO public.who_global_data_import VALUES (47906, '2020-11-03', 'LY', 'Libya', 'EMRO', '862', '62907', '9', '880');
INSERT INTO public.who_global_data_import VALUES (47907, '2020-11-04', 'LY', 'Libya', 'EMRO', '781', '63688', '13', '893');
INSERT INTO public.who_global_data_import VALUES (47908, '2020-11-05', 'LY', 'Libya', 'EMRO', '899', '64587', '7', '900');
INSERT INTO public.who_global_data_import VALUES (47909, '2020-11-06', 'LY', 'Libya', 'EMRO', '853', '65440', '7', '907');
INSERT INTO public.who_global_data_import VALUES (47910, '2020-11-07', 'LY', 'Libya', 'EMRO', '1004', '66444', '8', '915');
INSERT INTO public.who_global_data_import VALUES (47911, '2020-11-08', 'LY', 'Libya', 'EMRO', '595', '67039', '5', '920');
INSERT INTO public.who_global_data_import VALUES (47912, '2020-11-09', 'LY', 'Libya', 'EMRO', '1078', '68117', '9', '929');
INSERT INTO public.who_global_data_import VALUES (47913, '2020-11-10', 'LY', 'Libya', 'EMRO', '923', '69040', '15', '944');
INSERT INTO public.who_global_data_import VALUES (47914, '2020-11-11', 'LY', 'Libya', 'EMRO', '970', '70010', '13', '957');
INSERT INTO public.who_global_data_import VALUES (47915, '2020-11-12', 'LY', 'Libya', 'EMRO', '875', '70885', '13', '970');
INSERT INTO public.who_global_data_import VALUES (47916, '2020-11-13', 'LY', 'Libya', 'EMRO', '919', '71804', '15', '985');
INSERT INTO public.who_global_data_import VALUES (47917, '2020-11-14', 'LY', 'Libya', 'EMRO', '824', '72628', '10', '995');
INSERT INTO public.who_global_data_import VALUES (47918, '2020-11-15', 'LY', 'Libya', 'EMRO', '0', '72628', '0', '995');
INSERT INTO public.who_global_data_import VALUES (47919, '2020-11-16', 'LY', 'Libya', 'EMRO', '974', '73602', '22', '1017');
INSERT INTO public.who_global_data_import VALUES (47920, '2020-11-17', 'LY', 'Libya', 'EMRO', '722', '74324', '8', '1025');
INSERT INTO public.who_global_data_import VALUES (47921, '2020-11-18', 'LY', 'Libya', 'EMRO', '612', '74936', '16', '1041');
INSERT INTO public.who_global_data_import VALUES (47922, '2020-11-19', 'LY', 'Libya', 'EMRO', '529', '75465', '12', '1053');
INSERT INTO public.who_global_data_import VALUES (47923, '2020-11-20', 'LY', 'Libya', 'EMRO', '541', '76006', '9', '1062');
INSERT INTO public.who_global_data_import VALUES (47924, '2020-11-21', 'LY', 'Libya', 'EMRO', '802', '76808', '6', '1068');
INSERT INTO public.who_global_data_import VALUES (47925, '2020-11-22', 'LY', 'Libya', 'EMRO', '0', '76808', '0', '1068');
INSERT INTO public.who_global_data_import VALUES (47926, '2020-11-23', 'LY', 'Libya', 'EMRO', '1015', '77823', '21', '1089');
INSERT INTO public.who_global_data_import VALUES (47927, '2020-11-24', 'LY', 'Libya', 'EMRO', '650', '78473', '13', '1102');
INSERT INTO public.who_global_data_import VALUES (47928, '2020-11-25', 'LY', 'Libya', 'EMRO', '707', '79180', '8', '1110');
INSERT INTO public.who_global_data_import VALUES (47929, '2020-11-26', 'LY', 'Libya', 'EMRO', '617', '79797', '15', '1125');
INSERT INTO public.who_global_data_import VALUES (47930, '2020-11-27', 'LY', 'Libya', 'EMRO', '610', '80407', '15', '1140');
INSERT INTO public.who_global_data_import VALUES (47931, '2020-11-28', 'LY', 'Libya', 'EMRO', '866', '81273', '13', '1153');
INSERT INTO public.who_global_data_import VALUES (47932, '2020-11-29', 'LY', 'Libya', 'EMRO', '0', '81273', '0', '1153');
INSERT INTO public.who_global_data_import VALUES (47933, '2020-11-30', 'LY', 'Libya', 'EMRO', '1157', '82430', '13', '1166');
INSERT INTO public.who_global_data_import VALUES (47934, '2020-12-01', 'LY', 'Libya', 'EMRO', '379', '82809', '17', '1183');
INSERT INTO public.who_global_data_import VALUES (47935, '2020-12-02', 'LY', 'Libya', 'EMRO', '608', '83417', '13', '1196');
INSERT INTO public.who_global_data_import VALUES (47936, '2020-12-03', 'LY', 'Libya', 'EMRO', '670', '84087', '4', '1200');
INSERT INTO public.who_global_data_import VALUES (47937, '2020-12-04', 'LY', 'Libya', 'EMRO', '762', '84849', '12', '1212');
INSERT INTO public.who_global_data_import VALUES (47938, '2020-12-05', 'LY', 'Libya', 'EMRO', '680', '85529', '7', '1219');
INSERT INTO public.who_global_data_import VALUES (47939, '2020-12-06', 'LY', 'Libya', 'EMRO', '0', '85529', '0', '1219');
INSERT INTO public.who_global_data_import VALUES (47940, '2020-12-07', 'LY', 'Libya', 'EMRO', '1051', '86580', '12', '1231');
INSERT INTO public.who_global_data_import VALUES (47941, '2020-12-08', 'LY', 'Libya', 'EMRO', '517', '87097', '12', '1243');
INSERT INTO public.who_global_data_import VALUES (47942, '2020-12-09', 'LY', 'Libya', 'EMRO', '889', '87986', '12', '1255');
INSERT INTO public.who_global_data_import VALUES (47943, '2020-12-10', 'LY', 'Libya', 'EMRO', '536', '88522', '6', '1261');
INSERT INTO public.who_global_data_import VALUES (47944, '2020-12-11', 'LY', 'Libya', 'EMRO', '661', '89183', '12', '1273');
INSERT INTO public.who_global_data_import VALUES (47945, '2020-12-12', 'LY', 'Libya', 'EMRO', '697', '89880', '5', '1278');
INSERT INTO public.who_global_data_import VALUES (47946, '2020-12-13', 'LY', 'Libya', 'EMRO', '0', '89880', '0', '1278');
INSERT INTO public.who_global_data_import VALUES (47947, '2020-12-14', 'LY', 'Libya', 'EMRO', '899', '90779', '21', '1299');
INSERT INTO public.who_global_data_import VALUES (47948, '2020-12-15', 'LY', 'Libya', 'EMRO', '578', '91357', '15', '1314');
INSERT INTO public.who_global_data_import VALUES (47949, '2020-12-16', 'LY', 'Libya', 'EMRO', '660', '92017', '5', '1319');
INSERT INTO public.who_global_data_import VALUES (47950, '2020-12-17', 'LY', 'Libya', 'EMRO', '560', '92577', '5', '1324');
INSERT INTO public.who_global_data_import VALUES (47951, '2020-12-18', 'LY', 'Libya', 'EMRO', '706', '93283', '13', '1337');
INSERT INTO public.who_global_data_import VALUES (47952, '2020-12-19', 'LY', 'Libya', 'EMRO', '489', '93772', '9', '1346');
INSERT INTO public.who_global_data_import VALUES (47953, '2020-12-20', 'LY', 'Libya', 'EMRO', '0', '93772', '0', '1346');
INSERT INTO public.who_global_data_import VALUES (47954, '2020-12-21', 'LY', 'Libya', 'EMRO', '788', '94560', '7', '1353');
INSERT INTO public.who_global_data_import VALUES (47955, '2020-12-22', 'LY', 'Libya', 'EMRO', '640', '95200', '16', '1369');
INSERT INTO public.who_global_data_import VALUES (47956, '2020-12-23', 'LY', 'Libya', 'EMRO', '506', '95706', '16', '1385');
INSERT INTO public.who_global_data_import VALUES (47957, '2020-12-24', 'LY', 'Libya', 'EMRO', '640', '96346', '8', '1393');
INSERT INTO public.who_global_data_import VALUES (47958, '2020-12-25', 'LY', 'Libya', 'EMRO', '846', '97192', '6', '1399');
INSERT INTO public.who_global_data_import VALUES (47959, '2020-12-26', 'LY', 'Libya', 'EMRO', '461', '97653', '16', '1415');
INSERT INTO public.who_global_data_import VALUES (47960, '2020-12-27', 'LY', 'Libya', 'EMRO', '0', '97653', '0', '1415');
INSERT INTO public.who_global_data_import VALUES (47961, '2020-12-28', 'LY', 'Libya', 'EMRO', '728', '98381', '21', '1436');
INSERT INTO public.who_global_data_import VALUES (47962, '2020-12-29', 'LY', 'Libya', 'EMRO', '532', '98913', '4', '1440');
INSERT INTO public.who_global_data_import VALUES (47963, '2020-12-30', 'LY', 'Libya', 'EMRO', '437', '99350', '4', '1444');
INSERT INTO public.who_global_data_import VALUES (47964, '2020-12-31', 'LY', 'Libya', 'EMRO', '585', '99935', '15', '1459');
INSERT INTO public.who_global_data_import VALUES (47965, '2021-01-01', 'LY', 'Libya', 'EMRO', '342', '100277', '19', '1478');
INSERT INTO public.who_global_data_import VALUES (47966, '2021-01-02', 'LY', 'Libya', 'EMRO', '467', '100744', '9', '1487');
INSERT INTO public.who_global_data_import VALUES (47967, '2021-01-03', 'LY', 'Libya', 'EMRO', '0', '100744', '0', '1487');
INSERT INTO public.who_global_data_import VALUES (47968, '2021-01-04', 'LY', 'Libya', 'EMRO', '670', '101414', '23', '1510');
INSERT INTO public.who_global_data_import VALUES (47969, '2021-01-05', 'LY', 'Libya', 'EMRO', '561', '101975', '16', '1526');
INSERT INTO public.who_global_data_import VALUES (47970, '2021-01-06', 'LY', 'Libya', 'EMRO', '481', '102456', '10', '1536');
INSERT INTO public.who_global_data_import VALUES (47971, '2021-01-07', 'LY', 'Libya', 'EMRO', '424', '102880', '10', '1546');
INSERT INTO public.who_global_data_import VALUES (47972, '2021-01-08', 'LY', 'Libya', 'EMRO', '635', '103515', '12', '1558');
INSERT INTO public.who_global_data_import VALUES (47973, '2021-01-09', 'LY', 'Libya', 'EMRO', '487', '104002', '10', '1568');
INSERT INTO public.who_global_data_import VALUES (47974, '2021-01-10', 'LY', 'Libya', 'EMRO', '0', '104002', '0', '1568');
INSERT INTO public.who_global_data_import VALUES (47975, '2021-01-11', 'LY', 'Libya', 'EMRO', '743', '104745', '13', '1581');
INSERT INTO public.who_global_data_import VALUES (47976, '2021-01-12', 'LY', 'Libya', 'EMRO', '633', '105378', '8', '1589');
INSERT INTO public.who_global_data_import VALUES (47977, '2021-01-13', 'LY', 'Libya', 'EMRO', '652', '106030', '33', '1622');
INSERT INTO public.who_global_data_import VALUES (47978, '2021-01-14', 'LY', 'Libya', 'EMRO', '640', '106670', '7', '1629');
INSERT INTO public.who_global_data_import VALUES (47979, '2021-01-15', 'LY', 'Libya', 'EMRO', '764', '107434', '16', '1645');
INSERT INTO public.who_global_data_import VALUES (47980, '2021-01-16', 'LY', 'Libya', 'EMRO', '583', '108017', '6', '1651');
INSERT INTO public.who_global_data_import VALUES (47981, '2021-01-17', 'LY', 'Libya', 'EMRO', '0', '108017', '0', '1651');
INSERT INTO public.who_global_data_import VALUES (47982, '2021-01-18', 'LY', 'Libya', 'EMRO', '1071', '109088', '14', '1665');
INSERT INTO public.who_global_data_import VALUES (47983, '2021-01-19', 'LY', 'Libya', 'EMRO', '781', '109869', '33', '1698');
INSERT INTO public.who_global_data_import VALUES (47984, '2021-01-20', 'LY', 'Libya', 'EMRO', '596', '110465', '2', '1700');
INSERT INTO public.who_global_data_import VALUES (47985, '2021-01-21', 'LY', 'Libya', 'EMRO', '659', '111124', '15', '1715');
INSERT INTO public.who_global_data_import VALUES (47986, '2021-01-22', 'LY', 'Libya', 'EMRO', '622', '111746', '1', '1716');
INSERT INTO public.who_global_data_import VALUES (47987, '2021-01-23', 'LY', 'Libya', 'EMRO', '794', '112540', '21', '1737');
INSERT INTO public.who_global_data_import VALUES (47988, '2021-01-24', 'LY', 'Libya', 'EMRO', '0', '112540', '0', '1737');
INSERT INTO public.who_global_data_import VALUES (47989, '2021-01-25', 'LY', 'Libya', 'EMRO', '1148', '113688', '26', '1763');
INSERT INTO public.who_global_data_import VALUES (47990, '2021-01-26', 'LY', 'Libya', 'EMRO', '742', '114430', '19', '1782');
INSERT INTO public.who_global_data_import VALUES (47991, '2021-01-27', 'LY', 'Libya', 'EMRO', '869', '115299', '7', '1789');
INSERT INTO public.who_global_data_import VALUES (47992, '2021-01-28', 'LY', 'Libya', 'EMRO', '765', '116064', '13', '1802');
INSERT INTO public.who_global_data_import VALUES (47993, '2021-01-29', 'LY', 'Libya', 'EMRO', '715', '116779', '30', '1832');
INSERT INTO public.who_global_data_import VALUES (47994, '2021-01-30', 'LY', 'Libya', 'EMRO', '871', '117650', '10', '1842');
INSERT INTO public.who_global_data_import VALUES (47995, '2021-01-31', 'LY', 'Libya', 'EMRO', '0', '117650', '0', '1842');
INSERT INTO public.who_global_data_import VALUES (47996, '2021-02-01', 'LY', 'Libya', 'EMRO', '981', '118631', '35', '1877');
INSERT INTO public.who_global_data_import VALUES (47997, '2021-02-02', 'LY', 'Libya', 'EMRO', '771', '119402', '6', '1883');
INSERT INTO public.who_global_data_import VALUES (47998, '2021-02-03', 'LY', 'Libya', 'EMRO', '1032', '120434', '13', '1896');
INSERT INTO public.who_global_data_import VALUES (47999, '2021-02-04', 'LY', 'Libya', 'EMRO', '809', '121243', '18', '1914');
INSERT INTO public.who_global_data_import VALUES (48000, '2021-02-05', 'LY', 'Libya', 'EMRO', '770', '122013', '5', '1919');
INSERT INTO public.who_global_data_import VALUES (48001, '2020-01-03', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48002, '2020-01-04', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48003, '2020-01-05', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48004, '2020-01-06', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48005, '2020-01-07', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48006, '2020-01-08', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48007, '2020-01-09', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48008, '2020-01-10', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48009, '2020-01-11', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48010, '2020-01-12', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48011, '2020-01-13', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48012, '2020-01-14', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48013, '2020-01-15', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48014, '2020-01-16', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48015, '2020-01-17', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48016, '2020-01-18', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48017, '2020-01-19', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48018, '2020-01-20', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48019, '2020-01-21', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48020, '2020-01-22', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48021, '2020-01-23', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48022, '2020-01-24', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48023, '2020-01-25', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48024, '2020-01-26', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48025, '2020-01-27', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48026, '2020-01-28', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48027, '2020-01-29', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48028, '2020-01-30', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48029, '2020-01-31', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48030, '2020-02-01', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48031, '2020-02-02', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48032, '2020-02-03', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48033, '2020-02-04', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48034, '2020-02-05', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48035, '2020-02-06', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48036, '2020-02-07', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48037, '2020-02-08', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48038, '2020-02-09', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48039, '2020-02-10', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48040, '2020-02-11', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48041, '2020-02-12', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48042, '2020-02-13', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48043, '2020-02-14', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48044, '2020-02-15', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48045, '2020-02-16', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48046, '2020-02-17', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48047, '2020-02-18', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48048, '2020-02-19', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48049, '2020-02-20', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48050, '2020-02-21', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48051, '2020-02-22', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48052, '2020-02-23', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48053, '2020-02-24', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48054, '2020-02-25', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48055, '2020-02-26', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48056, '2020-02-27', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48057, '2020-02-28', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48058, '2020-02-29', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48059, '2020-03-01', 'LI', 'Liechtenstein', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48060, '2020-03-02', 'LI', 'Liechtenstein', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48061, '2020-03-03', 'LI', 'Liechtenstein', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48062, '2020-03-04', 'LI', 'Liechtenstein', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48063, '2020-03-05', 'LI', 'Liechtenstein', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48064, '2020-03-06', 'LI', 'Liechtenstein', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48065, '2020-03-07', 'LI', 'Liechtenstein', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48066, '2020-03-08', 'LI', 'Liechtenstein', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48067, '2020-03-09', 'LI', 'Liechtenstein', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48068, '2020-03-10', 'LI', 'Liechtenstein', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48069, '2020-03-11', 'LI', 'Liechtenstein', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48070, '2020-03-12', 'LI', 'Liechtenstein', 'EURO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48071, '2020-03-13', 'LI', 'Liechtenstein', 'EURO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48072, '2020-03-14', 'LI', 'Liechtenstein', 'EURO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48073, '2020-03-15', 'LI', 'Liechtenstein', 'EURO', '4', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48074, '2020-03-16', 'LI', 'Liechtenstein', 'EURO', '3', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48075, '2020-03-17', 'LI', 'Liechtenstein', 'EURO', '5', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48076, '2020-03-18', 'LI', 'Liechtenstein', 'EURO', '6', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48077, '2020-03-19', 'LI', 'Liechtenstein', 'EURO', '9', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48078, '2020-03-20', 'LI', 'Liechtenstein', 'EURO', '2', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48079, '2020-03-21', 'LI', 'Liechtenstein', 'EURO', '8', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48080, '2020-03-22', 'LI', 'Liechtenstein', 'EURO', '2', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48081, '2020-03-23', 'LI', 'Liechtenstein', 'EURO', '2', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48082, '2020-03-24', 'LI', 'Liechtenstein', 'EURO', '3', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48083, '2020-03-25', 'LI', 'Liechtenstein', 'EURO', '2', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48084, '2020-03-26', 'LI', 'Liechtenstein', 'EURO', '4', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48085, '2020-03-27', 'LI', 'Liechtenstein', 'EURO', '4', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48086, '2020-03-28', 'LI', 'Liechtenstein', 'EURO', '1', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48087, '2020-03-29', 'LI', 'Liechtenstein', 'EURO', '1', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48088, '2020-03-30', 'LI', 'Liechtenstein', 'EURO', '2', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48089, '2020-03-31', 'LI', 'Liechtenstein', 'EURO', '4', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48090, '2020-04-01', 'LI', 'Liechtenstein', 'EURO', '4', '73', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48091, '2020-04-02', 'LI', 'Liechtenstein', 'EURO', '3', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48092, '2020-04-03', 'LI', 'Liechtenstein', 'EURO', '1', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48093, '2020-04-04', 'LI', 'Liechtenstein', 'EURO', '1', '78', '1', '1');
INSERT INTO public.who_global_data_import VALUES (48094, '2020-04-05', 'LI', 'Liechtenstein', 'EURO', '0', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48095, '2020-04-06', 'LI', 'Liechtenstein', 'EURO', '0', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48096, '2020-04-07', 'LI', 'Liechtenstein', 'EURO', '1', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48097, '2020-04-08', 'LI', 'Liechtenstein', 'EURO', '0', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48098, '2020-04-09', 'LI', 'Liechtenstein', 'EURO', '1', '80', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48099, '2020-04-10', 'LI', 'Liechtenstein', 'EURO', '0', '80', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48100, '2020-04-11', 'LI', 'Liechtenstein', 'EURO', '0', '80', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48101, '2020-04-12', 'LI', 'Liechtenstein', 'EURO', '1', '81', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48102, '2020-04-13', 'LI', 'Liechtenstein', 'EURO', '0', '81', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48103, '2020-04-14', 'LI', 'Liechtenstein', 'EURO', '0', '81', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48104, '2020-04-15', 'LI', 'Liechtenstein', 'EURO', '0', '81', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48105, '2020-04-16', 'LI', 'Liechtenstein', 'EURO', '0', '81', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48106, '2020-04-17', 'LI', 'Liechtenstein', 'EURO', '1', '82', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48107, '2020-04-18', 'LI', 'Liechtenstein', 'EURO', '0', '82', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48108, '2020-04-19', 'LI', 'Liechtenstein', 'EURO', '0', '82', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48109, '2020-04-20', 'LI', 'Liechtenstein', 'EURO', '0', '82', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48110, '2020-04-21', 'LI', 'Liechtenstein', 'EURO', '0', '82', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48111, '2020-04-22', 'LI', 'Liechtenstein', 'EURO', '0', '82', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48112, '2020-04-23', 'LI', 'Liechtenstein', 'EURO', '0', '82', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48113, '2020-04-24', 'LI', 'Liechtenstein', 'EURO', '1', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48114, '2020-04-25', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48115, '2020-04-26', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48116, '2020-04-27', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48117, '2020-04-28', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48118, '2020-04-29', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48119, '2020-04-30', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48120, '2020-05-01', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48121, '2020-05-02', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48122, '2020-05-03', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48123, '2020-05-04', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48124, '2020-05-05', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48125, '2020-05-06', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48126, '2020-05-07', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48127, '2020-05-08', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48128, '2020-05-09', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48129, '2020-05-10', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48130, '2020-05-11', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48131, '2020-05-12', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48132, '2020-05-13', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48133, '2020-05-14', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48134, '2020-05-15', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48135, '2020-05-16', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48136, '2020-05-17', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48137, '2020-05-18', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48138, '2020-05-19', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48139, '2020-05-20', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48140, '2020-05-21', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48141, '2020-05-22', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48142, '2020-05-23', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48143, '2020-05-24', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48144, '2020-05-25', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48145, '2020-05-26', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48146, '2020-05-27', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48147, '2020-05-28', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48148, '2020-05-29', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48149, '2020-05-30', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48150, '2020-05-31', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48151, '2020-06-01', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48152, '2020-06-02', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48153, '2020-06-03', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48154, '2020-06-04', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48155, '2020-06-05', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48156, '2020-06-06', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48157, '2020-06-07', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48158, '2020-06-08', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48159, '2020-06-09', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48160, '2020-06-10', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48161, '2020-06-11', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48162, '2020-06-12', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48163, '2020-06-13', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48164, '2020-06-14', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48165, '2020-06-15', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48166, '2020-06-16', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48167, '2020-06-17', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48168, '2020-06-18', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48169, '2020-06-19', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48170, '2020-06-20', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48171, '2020-06-21', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48172, '2020-06-22', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48173, '2020-06-23', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48174, '2020-06-24', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48175, '2020-06-25', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48176, '2020-06-26', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48177, '2020-06-27', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48178, '2020-06-28', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48179, '2020-06-29', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48180, '2020-06-30', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48181, '2020-07-01', 'LI', 'Liechtenstein', 'EURO', '0', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48182, '2020-07-02', 'LI', 'Liechtenstein', 'EURO', '1', '84', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48183, '2020-07-03', 'LI', 'Liechtenstein', 'EURO', '0', '84', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48184, '2020-07-04', 'LI', 'Liechtenstein', 'EURO', '0', '84', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48185, '2020-07-05', 'LI', 'Liechtenstein', 'EURO', '0', '84', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48186, '2020-07-06', 'LI', 'Liechtenstein', 'EURO', '1', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48187, '2020-07-07', 'LI', 'Liechtenstein', 'EURO', '0', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48188, '2020-07-08', 'LI', 'Liechtenstein', 'EURO', '0', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48189, '2020-07-09', 'LI', 'Liechtenstein', 'EURO', '0', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48190, '2020-07-10', 'LI', 'Liechtenstein', 'EURO', '0', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48191, '2020-07-11', 'LI', 'Liechtenstein', 'EURO', '0', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48192, '2020-07-12', 'LI', 'Liechtenstein', 'EURO', '0', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48193, '2020-07-13', 'LI', 'Liechtenstein', 'EURO', '0', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48194, '2020-07-14', 'LI', 'Liechtenstein', 'EURO', '0', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48195, '2020-07-15', 'LI', 'Liechtenstein', 'EURO', '0', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48196, '2020-07-16', 'LI', 'Liechtenstein', 'EURO', '0', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48197, '2020-07-17', 'LI', 'Liechtenstein', 'EURO', '1', '86', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48198, '2020-07-18', 'LI', 'Liechtenstein', 'EURO', '1', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48199, '2020-07-19', 'LI', 'Liechtenstein', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48200, '2020-07-20', 'LI', 'Liechtenstein', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48201, '2020-07-21', 'LI', 'Liechtenstein', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48202, '2020-07-22', 'LI', 'Liechtenstein', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48203, '2020-07-23', 'LI', 'Liechtenstein', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48204, '2020-07-24', 'LI', 'Liechtenstein', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48205, '2020-07-25', 'LI', 'Liechtenstein', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48206, '2020-07-26', 'LI', 'Liechtenstein', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48207, '2020-07-27', 'LI', 'Liechtenstein', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48208, '2020-07-28', 'LI', 'Liechtenstein', 'EURO', '1', '88', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48209, '2020-07-29', 'LI', 'Liechtenstein', 'EURO', '1', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48210, '2020-07-30', 'LI', 'Liechtenstein', 'EURO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48211, '2020-07-31', 'LI', 'Liechtenstein', 'EURO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48212, '2020-08-01', 'LI', 'Liechtenstein', 'EURO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48213, '2020-08-02', 'LI', 'Liechtenstein', 'EURO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48214, '2020-08-03', 'LI', 'Liechtenstein', 'EURO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48215, '2020-08-04', 'LI', 'Liechtenstein', 'EURO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48216, '2020-08-05', 'LI', 'Liechtenstein', 'EURO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48217, '2020-08-06', 'LI', 'Liechtenstein', 'EURO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48218, '2020-08-07', 'LI', 'Liechtenstein', 'EURO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48219, '2020-08-08', 'LI', 'Liechtenstein', 'EURO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48220, '2020-08-09', 'LI', 'Liechtenstein', 'EURO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48221, '2020-08-10', 'LI', 'Liechtenstein', 'EURO', '0', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48222, '2020-08-11', 'LI', 'Liechtenstein', 'EURO', '1', '90', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48223, '2020-08-12', 'LI', 'Liechtenstein', 'EURO', '1', '91', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48224, '2020-08-13', 'LI', 'Liechtenstein', 'EURO', '1', '92', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48225, '2020-08-14', 'LI', 'Liechtenstein', 'EURO', '1', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48226, '2020-08-15', 'LI', 'Liechtenstein', 'EURO', '1', '94', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48227, '2020-08-16', 'LI', 'Liechtenstein', 'EURO', '0', '94', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48228, '2020-08-17', 'LI', 'Liechtenstein', 'EURO', '3', '97', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48229, '2020-08-18', 'LI', 'Liechtenstein', 'EURO', '1', '98', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48230, '2020-08-19', 'LI', 'Liechtenstein', 'EURO', '1', '99', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48231, '2020-08-20', 'LI', 'Liechtenstein', 'EURO', '0', '99', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48232, '2020-08-21', 'LI', 'Liechtenstein', 'EURO', '1', '100', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48233, '2020-08-22', 'LI', 'Liechtenstein', 'EURO', '0', '100', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48234, '2020-08-23', 'LI', 'Liechtenstein', 'EURO', '1', '101', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48235, '2020-08-24', 'LI', 'Liechtenstein', 'EURO', '0', '101', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48236, '2020-08-25', 'LI', 'Liechtenstein', 'EURO', '2', '103', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48237, '2020-08-26', 'LI', 'Liechtenstein', 'EURO', '2', '105', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48238, '2020-08-27', 'LI', 'Liechtenstein', 'EURO', '1', '106', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48239, '2020-08-28', 'LI', 'Liechtenstein', 'EURO', '1', '107', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48240, '2020-08-29', 'LI', 'Liechtenstein', 'EURO', '0', '107', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48241, '2020-08-30', 'LI', 'Liechtenstein', 'EURO', '1', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48242, '2020-08-31', 'LI', 'Liechtenstein', 'EURO', '0', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48243, '2020-09-01', 'LI', 'Liechtenstein', 'EURO', '0', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48244, '2020-09-02', 'LI', 'Liechtenstein', 'EURO', '0', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48245, '2020-09-03', 'LI', 'Liechtenstein', 'EURO', '0', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48246, '2020-09-04', 'LI', 'Liechtenstein', 'EURO', '0', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48247, '2020-09-05', 'LI', 'Liechtenstein', 'EURO', '0', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48248, '2020-09-06', 'LI', 'Liechtenstein', 'EURO', '0', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48249, '2020-09-07', 'LI', 'Liechtenstein', 'EURO', '0', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48250, '2020-09-08', 'LI', 'Liechtenstein', 'EURO', '0', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48251, '2020-09-09', 'LI', 'Liechtenstein', 'EURO', '1', '109', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48252, '2020-09-10', 'LI', 'Liechtenstein', 'EURO', '0', '109', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48253, '2020-09-11', 'LI', 'Liechtenstein', 'EURO', '0', '109', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48254, '2020-09-12', 'LI', 'Liechtenstein', 'EURO', '2', '111', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48255, '2020-09-13', 'LI', 'Liechtenstein', 'EURO', '0', '111', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48256, '2020-09-14', 'LI', 'Liechtenstein', 'EURO', '0', '111', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48257, '2020-09-15', 'LI', 'Liechtenstein', 'EURO', '0', '111', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48258, '2020-09-16', 'LI', 'Liechtenstein', 'EURO', '0', '111', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48259, '2020-09-17', 'LI', 'Liechtenstein', 'EURO', '1', '112', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48260, '2020-09-18', 'LI', 'Liechtenstein', 'EURO', '0', '112', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48261, '2020-09-19', 'LI', 'Liechtenstein', 'EURO', '1', '113', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48262, '2020-09-20', 'LI', 'Liechtenstein', 'EURO', '1', '114', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48263, '2020-09-21', 'LI', 'Liechtenstein', 'EURO', '1', '115', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48264, '2020-09-22', 'LI', 'Liechtenstein', 'EURO', '1', '116', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48265, '2020-09-23', 'LI', 'Liechtenstein', 'EURO', '1', '117', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48266, '2020-09-24', 'LI', 'Liechtenstein', 'EURO', '0', '117', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48267, '2020-09-25', 'LI', 'Liechtenstein', 'EURO', '1', '118', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48268, '2020-09-26', 'LI', 'Liechtenstein', 'EURO', '1', '119', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48269, '2020-09-27', 'LI', 'Liechtenstein', 'EURO', '0', '119', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48270, '2020-09-28', 'LI', 'Liechtenstein', 'EURO', '0', '119', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48271, '2020-09-29', 'LI', 'Liechtenstein', 'EURO', '1', '120', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48272, '2020-09-30', 'LI', 'Liechtenstein', 'EURO', '0', '120', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48273, '2020-10-01', 'LI', 'Liechtenstein', 'EURO', '1', '121', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48274, '2020-10-02', 'LI', 'Liechtenstein', 'EURO', '1', '122', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48275, '2020-10-03', 'LI', 'Liechtenstein', 'EURO', '3', '125', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48276, '2020-10-04', 'LI', 'Liechtenstein', 'EURO', '3', '128', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48277, '2020-10-05', 'LI', 'Liechtenstein', 'EURO', '1', '129', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48278, '2020-10-06', 'LI', 'Liechtenstein', 'EURO', '3', '132', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48279, '2020-10-07', 'LI', 'Liechtenstein', 'EURO', '1', '133', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48280, '2020-10-08', 'LI', 'Liechtenstein', 'EURO', '3', '136', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48281, '2020-10-09', 'LI', 'Liechtenstein', 'EURO', '3', '139', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48282, '2020-10-10', 'LI', 'Liechtenstein', 'EURO', '6', '145', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48283, '2020-10-11', 'LI', 'Liechtenstein', 'EURO', '5', '150', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48284, '2020-10-12', 'LI', 'Liechtenstein', 'EURO', '0', '150', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48285, '2020-10-13', 'LI', 'Liechtenstein', 'EURO', '14', '164', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48286, '2020-10-14', 'LI', 'Liechtenstein', 'EURO', '13', '177', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48287, '2020-10-15', 'LI', 'Liechtenstein', 'EURO', '8', '185', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48288, '2020-10-16', 'LI', 'Liechtenstein', 'EURO', '17', '202', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48289, '2020-10-17', 'LI', 'Liechtenstein', 'EURO', '18', '220', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48290, '2020-10-18', 'LI', 'Liechtenstein', 'EURO', '6', '226', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48291, '2020-10-19', 'LI', 'Liechtenstein', 'EURO', '2', '228', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48292, '2020-10-20', 'LI', 'Liechtenstein', 'EURO', '30', '258', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48293, '2020-10-21', 'LI', 'Liechtenstein', 'EURO', '31', '289', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48294, '2020-10-22', 'LI', 'Liechtenstein', 'EURO', '37', '326', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48295, '2020-10-23', 'LI', 'Liechtenstein', 'EURO', '26', '352', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48296, '2020-10-24', 'LI', 'Liechtenstein', 'EURO', '23', '375', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48297, '2020-10-25', 'LI', 'Liechtenstein', 'EURO', '37', '412', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48298, '2020-10-26', 'LI', 'Liechtenstein', 'EURO', '23', '435', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48299, '2020-10-27', 'LI', 'Liechtenstein', 'EURO', '26', '461', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48300, '2020-10-28', 'LI', 'Liechtenstein', 'EURO', '23', '484', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48301, '2020-10-29', 'LI', 'Liechtenstein', 'EURO', '36', '520', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48302, '2020-10-30', 'LI', 'Liechtenstein', 'EURO', '27', '547', '1', '2');
INSERT INTO public.who_global_data_import VALUES (48303, '2020-10-31', 'LI', 'Liechtenstein', 'EURO', '29', '576', '1', '3');
INSERT INTO public.who_global_data_import VALUES (48304, '2020-11-01', 'LI', 'Liechtenstein', 'EURO', '25', '601', '0', '3');
INSERT INTO public.who_global_data_import VALUES (48305, '2020-11-02', 'LI', 'Liechtenstein', 'EURO', '22', '623', '0', '3');
INSERT INTO public.who_global_data_import VALUES (48306, '2020-11-03', 'LI', 'Liechtenstein', 'EURO', '45', '668', '0', '3');
INSERT INTO public.who_global_data_import VALUES (48307, '2020-11-04', 'LI', 'Liechtenstein', 'EURO', '35', '703', '0', '3');
INSERT INTO public.who_global_data_import VALUES (48308, '2020-11-05', 'LI', 'Liechtenstein', 'EURO', '39', '742', '0', '3');
INSERT INTO public.who_global_data_import VALUES (48309, '2020-11-06', 'LI', 'Liechtenstein', 'EURO', '39', '781', '0', '3');
INSERT INTO public.who_global_data_import VALUES (48310, '2020-11-07', 'LI', 'Liechtenstein', 'EURO', '22', '803', '0', '3');
INSERT INTO public.who_global_data_import VALUES (48311, '2020-11-08', 'LI', 'Liechtenstein', 'EURO', '15', '818', '0', '3');
INSERT INTO public.who_global_data_import VALUES (48312, '2020-11-09', 'LI', 'Liechtenstein', 'EURO', '22', '840', '1', '4');
INSERT INTO public.who_global_data_import VALUES (48313, '2020-11-10', 'LI', 'Liechtenstein', 'EURO', '49', '889', '0', '4');
INSERT INTO public.who_global_data_import VALUES (48314, '2020-11-11', 'LI', 'Liechtenstein', 'EURO', '35', '924', '0', '4');
INSERT INTO public.who_global_data_import VALUES (48315, '2020-11-12', 'LI', 'Liechtenstein', 'EURO', '23', '947', '0', '4');
INSERT INTO public.who_global_data_import VALUES (48316, '2020-11-13', 'LI', 'Liechtenstein', 'EURO', '21', '968', '1', '5');
INSERT INTO public.who_global_data_import VALUES (48317, '2020-11-14', 'LI', 'Liechtenstein', 'EURO', '25', '993', '0', '5');
INSERT INTO public.who_global_data_import VALUES (48318, '2020-11-15', 'LI', 'Liechtenstein', 'EURO', '18', '1011', '0', '5');
INSERT INTO public.who_global_data_import VALUES (48319, '2020-11-16', 'LI', 'Liechtenstein', 'EURO', '11', '1022', '2', '7');
INSERT INTO public.who_global_data_import VALUES (48320, '2020-11-17', 'LI', 'Liechtenstein', 'EURO', '26', '1048', '1', '8');
INSERT INTO public.who_global_data_import VALUES (48321, '2020-11-18', 'LI', 'Liechtenstein', 'EURO', '35', '1083', '0', '8');
INSERT INTO public.who_global_data_import VALUES (48322, '2020-11-19', 'LI', 'Liechtenstein', 'EURO', '19', '1102', '0', '8');
INSERT INTO public.who_global_data_import VALUES (48323, '2020-11-20', 'LI', 'Liechtenstein', 'EURO', '19', '1121', '0', '8');
INSERT INTO public.who_global_data_import VALUES (48324, '2020-11-21', 'LI', 'Liechtenstein', 'EURO', '16', '1137', '0', '8');
INSERT INTO public.who_global_data_import VALUES (48325, '2020-11-22', 'LI', 'Liechtenstein', 'EURO', '14', '1151', '1', '9');
INSERT INTO public.who_global_data_import VALUES (48326, '2020-11-23', 'LI', 'Liechtenstein', 'EURO', '31', '1182', '3', '12');
INSERT INTO public.who_global_data_import VALUES (48327, '2020-11-24', 'LI', 'Liechtenstein', 'EURO', '28', '1210', '1', '13');
INSERT INTO public.who_global_data_import VALUES (48328, '2020-11-25', 'LI', 'Liechtenstein', 'EURO', '22', '1232', '1', '14');
INSERT INTO public.who_global_data_import VALUES (48329, '2020-11-26', 'LI', 'Liechtenstein', 'EURO', '30', '1262', '0', '14');
INSERT INTO public.who_global_data_import VALUES (48330, '2020-11-27', 'LI', 'Liechtenstein', 'EURO', '17', '1279', '1', '15');
INSERT INTO public.who_global_data_import VALUES (48331, '2020-11-28', 'LI', 'Liechtenstein', 'EURO', '6', '1285', '1', '16');
INSERT INTO public.who_global_data_import VALUES (48332, '2020-11-29', 'LI', 'Liechtenstein', 'EURO', '16', '1301', '0', '16');
INSERT INTO public.who_global_data_import VALUES (48333, '2020-11-30', 'LI', 'Liechtenstein', 'EURO', '11', '1312', '0', '16');
INSERT INTO public.who_global_data_import VALUES (48334, '2020-12-01', 'LI', 'Liechtenstein', 'EURO', '33', '1345', '0', '16');
INSERT INTO public.who_global_data_import VALUES (48335, '2020-12-02', 'LI', 'Liechtenstein', 'EURO', '24', '1369', '0', '16');
INSERT INTO public.who_global_data_import VALUES (48336, '2020-12-03', 'LI', 'Liechtenstein', 'EURO', '15', '1384', '1', '17');
INSERT INTO public.who_global_data_import VALUES (48337, '2020-12-04', 'LI', 'Liechtenstein', 'EURO', '17', '1401', '0', '17');
INSERT INTO public.who_global_data_import VALUES (48338, '2020-12-05', 'LI', 'Liechtenstein', 'EURO', '17', '1418', '0', '17');
INSERT INTO public.who_global_data_import VALUES (48339, '2020-12-06', 'LI', 'Liechtenstein', 'EURO', '13', '1431', '1', '18');
INSERT INTO public.who_global_data_import VALUES (48340, '2020-12-07', 'LI', 'Liechtenstein', 'EURO', '4', '1435', '1', '19');
INSERT INTO public.who_global_data_import VALUES (48341, '2020-12-08', 'LI', 'Liechtenstein', 'EURO', '23', '1458', '0', '19');
INSERT INTO public.who_global_data_import VALUES (48342, '2020-12-09', 'LI', 'Liechtenstein', 'EURO', '16', '1474', '0', '19');
INSERT INTO public.who_global_data_import VALUES (48343, '2020-12-10', 'LI', 'Liechtenstein', 'EURO', '21', '1495', '0', '19');
INSERT INTO public.who_global_data_import VALUES (48344, '2020-12-11', 'LI', 'Liechtenstein', 'EURO', '23', '1518', '1', '20');
INSERT INTO public.who_global_data_import VALUES (48345, '2020-12-12', 'LI', 'Liechtenstein', 'EURO', '30', '1548', '0', '20');
INSERT INTO public.who_global_data_import VALUES (48346, '2020-12-13', 'LI', 'Liechtenstein', 'EURO', '27', '1575', '0', '20');
INSERT INTO public.who_global_data_import VALUES (48347, '2020-12-14', 'LI', 'Liechtenstein', 'EURO', '31', '1606', '1', '21');
INSERT INTO public.who_global_data_import VALUES (48348, '2020-12-15', 'LI', 'Liechtenstein', 'EURO', '32', '1638', '0', '21');
INSERT INTO public.who_global_data_import VALUES (48349, '2020-12-16', 'LI', 'Liechtenstein', 'EURO', '40', '1678', '0', '21');
INSERT INTO public.who_global_data_import VALUES (48350, '2020-12-17', 'LI', 'Liechtenstein', 'EURO', '35', '1713', '0', '21');
INSERT INTO public.who_global_data_import VALUES (48351, '2020-12-18', 'LI', 'Liechtenstein', 'EURO', '36', '1749', '2', '23');
INSERT INTO public.who_global_data_import VALUES (48352, '2020-12-19', 'LI', 'Liechtenstein', 'EURO', '48', '1797', '2', '25');
INSERT INTO public.who_global_data_import VALUES (48353, '2020-12-20', 'LI', 'Liechtenstein', 'EURO', '32', '1829', '0', '25');
INSERT INTO public.who_global_data_import VALUES (48354, '2020-12-21', 'LI', 'Liechtenstein', 'EURO', '20', '1849', '2', '27');
INSERT INTO public.who_global_data_import VALUES (48355, '2020-12-22', 'LI', 'Liechtenstein', 'EURO', '42', '1891', '1', '28');
INSERT INTO public.who_global_data_import VALUES (48356, '2020-12-23', 'LI', 'Liechtenstein', 'EURO', '59', '1950', '1', '29');
INSERT INTO public.who_global_data_import VALUES (48357, '2020-12-24', 'LI', 'Liechtenstein', 'EURO', '50', '2000', '0', '29');
INSERT INTO public.who_global_data_import VALUES (48358, '2020-12-25', 'LI', 'Liechtenstein', 'EURO', '34', '2034', '1', '30');
INSERT INTO public.who_global_data_import VALUES (48359, '2020-12-26', 'LI', 'Liechtenstein', 'EURO', '29', '2063', '2', '32');
INSERT INTO public.who_global_data_import VALUES (48360, '2020-12-27', 'LI', 'Liechtenstein', 'EURO', '23', '2086', '1', '33');
INSERT INTO public.who_global_data_import VALUES (48361, '2020-12-28', 'LI', 'Liechtenstein', 'EURO', '29', '2115', '1', '34');
INSERT INTO public.who_global_data_import VALUES (48362, '2020-12-29', 'LI', 'Liechtenstein', 'EURO', '38', '2153', '1', '35');
INSERT INTO public.who_global_data_import VALUES (48363, '2020-12-30', 'LI', 'Liechtenstein', 'EURO', '37', '2190', '2', '37');
INSERT INTO public.who_global_data_import VALUES (48364, '2020-12-31', 'LI', 'Liechtenstein', 'EURO', '31', '2221', '1', '38');
INSERT INTO public.who_global_data_import VALUES (48365, '2021-01-01', 'LI', 'Liechtenstein', 'EURO', '24', '2245', '0', '38');
INSERT INTO public.who_global_data_import VALUES (48366, '2021-01-02', 'LI', 'Liechtenstein', 'EURO', '14', '2259', '0', '38');
INSERT INTO public.who_global_data_import VALUES (48367, '2021-01-03', 'LI', 'Liechtenstein', 'EURO', '23', '2282', '0', '38');
INSERT INTO public.who_global_data_import VALUES (48368, '2021-01-04', 'LI', 'Liechtenstein', 'EURO', '19', '2301', '2', '40');
INSERT INTO public.who_global_data_import VALUES (48369, '2021-01-05', 'LI', 'Liechtenstein', 'EURO', '31', '2332', '2', '42');
INSERT INTO public.who_global_data_import VALUES (48370, '2021-01-06', 'LI', 'Liechtenstein', 'EURO', '30', '2362', '0', '42');
INSERT INTO public.who_global_data_import VALUES (48371, '2021-01-07', 'LI', 'Liechtenstein', 'EURO', '10', '2372', '0', '42');
INSERT INTO public.who_global_data_import VALUES (48372, '2021-01-08', 'LI', 'Liechtenstein', 'EURO', '10', '2382', '2', '44');
INSERT INTO public.who_global_data_import VALUES (48373, '2021-01-09', 'LI', 'Liechtenstein', 'EURO', '13', '2395', '0', '44');
INSERT INTO public.who_global_data_import VALUES (48374, '2021-01-10', 'LI', 'Liechtenstein', 'EURO', '8', '2403', '0', '44');
INSERT INTO public.who_global_data_import VALUES (48375, '2021-01-11', 'LI', 'Liechtenstein', 'EURO', '9', '2412', '0', '44');
INSERT INTO public.who_global_data_import VALUES (48376, '2021-01-12', 'LI', 'Liechtenstein', 'EURO', '16', '2428', '0', '44');
INSERT INTO public.who_global_data_import VALUES (48377, '2021-01-13', 'LI', 'Liechtenstein', 'EURO', '9', '2437', '0', '44');
INSERT INTO public.who_global_data_import VALUES (48378, '2021-01-14', 'LI', 'Liechtenstein', 'EURO', '4', '2441', '0', '44');
INSERT INTO public.who_global_data_import VALUES (48379, '2021-01-15', 'LI', 'Liechtenstein', 'EURO', '1', '2442', '0', '44');
INSERT INTO public.who_global_data_import VALUES (48380, '2021-01-16', 'LI', 'Liechtenstein', 'EURO', '4', '2446', '0', '44');
INSERT INTO public.who_global_data_import VALUES (48381, '2021-01-17', 'LI', 'Liechtenstein', 'EURO', '6', '2452', '0', '44');
INSERT INTO public.who_global_data_import VALUES (48382, '2021-01-18', 'LI', 'Liechtenstein', 'EURO', '6', '2458', '1', '45');
INSERT INTO public.who_global_data_import VALUES (48383, '2021-01-19', 'LI', 'Liechtenstein', 'EURO', '10', '2468', '0', '45');
INSERT INTO public.who_global_data_import VALUES (48384, '2021-01-20', 'LI', 'Liechtenstein', 'EURO', '10', '2478', '1', '46');
INSERT INTO public.who_global_data_import VALUES (48385, '2021-01-21', 'LI', 'Liechtenstein', 'EURO', '17', '2495', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48386, '2021-01-22', 'LI', 'Liechtenstein', 'EURO', '5', '2500', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48387, '2021-01-23', 'LI', 'Liechtenstein', 'EURO', '6', '2506', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48388, '2021-01-24', 'LI', 'Liechtenstein', 'EURO', '5', '2511', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48389, '2021-01-25', 'LI', 'Liechtenstein', 'EURO', '11', '2522', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48390, '2021-01-26', 'LI', 'Liechtenstein', 'EURO', '4', '2526', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48391, '2021-01-27', 'LI', 'Liechtenstein', 'EURO', '17', '2543', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48392, '2021-01-28', 'LI', 'Liechtenstein', 'EURO', '7', '2550', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48393, '2021-01-29', 'LI', 'Liechtenstein', 'EURO', '0', '2550', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48394, '2021-01-30', 'LI', 'Liechtenstein', 'EURO', '13', '2563', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48395, '2021-01-31', 'LI', 'Liechtenstein', 'EURO', '2', '2565', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48396, '2021-02-01', 'LI', 'Liechtenstein', 'EURO', '2', '2567', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48397, '2021-02-02', 'LI', 'Liechtenstein', 'EURO', '12', '2579', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48398, '2021-02-03', 'LI', 'Liechtenstein', 'EURO', '0', '2579', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48399, '2021-02-04', 'LI', 'Liechtenstein', 'EURO', '1', '2580', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48400, '2021-02-05', 'LI', 'Liechtenstein', 'EURO', '6', '2586', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48401, '2020-01-03', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48402, '2020-01-04', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48403, '2020-01-05', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48404, '2020-01-06', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48405, '2020-01-07', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48406, '2020-01-08', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48407, '2020-01-09', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48408, '2020-01-10', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48409, '2020-01-11', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48410, '2020-01-12', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48411, '2020-01-13', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48412, '2020-01-14', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48413, '2020-01-15', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48414, '2020-01-16', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48415, '2020-01-17', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48416, '2020-01-18', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48417, '2020-01-19', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48418, '2020-01-20', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48419, '2020-01-21', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48420, '2020-01-22', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48421, '2020-01-23', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48422, '2020-01-24', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48423, '2020-01-25', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48424, '2020-01-26', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48425, '2020-01-27', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48426, '2020-01-28', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48427, '2020-01-29', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48428, '2020-01-30', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48429, '2020-01-31', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48430, '2020-02-01', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48431, '2020-02-02', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48432, '2020-02-03', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48433, '2020-02-04', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48434, '2020-02-05', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48435, '2020-02-06', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48436, '2020-02-07', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48437, '2020-02-08', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48438, '2020-02-09', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48439, '2020-02-10', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48440, '2020-02-11', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48441, '2020-02-12', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48442, '2020-02-13', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48443, '2020-02-14', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48444, '2020-02-15', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48445, '2020-02-16', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48446, '2020-02-17', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48447, '2020-02-18', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48448, '2020-02-19', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48449, '2020-02-20', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48450, '2020-02-21', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48451, '2020-02-22', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48452, '2020-02-23', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48453, '2020-02-24', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48454, '2020-02-25', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48455, '2020-02-26', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48456, '2020-02-27', 'LT', 'Lithuania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48457, '2020-02-28', 'LT', 'Lithuania', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48458, '2020-02-29', 'LT', 'Lithuania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48459, '2020-03-01', 'LT', 'Lithuania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48460, '2020-03-02', 'LT', 'Lithuania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48461, '2020-03-03', 'LT', 'Lithuania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48462, '2020-03-04', 'LT', 'Lithuania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48463, '2020-03-05', 'LT', 'Lithuania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48464, '2020-03-06', 'LT', 'Lithuania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48465, '2020-03-07', 'LT', 'Lithuania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48466, '2020-03-08', 'LT', 'Lithuania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48467, '2020-03-09', 'LT', 'Lithuania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48468, '2020-03-10', 'LT', 'Lithuania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48469, '2020-03-11', 'LT', 'Lithuania', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48470, '2020-03-12', 'LT', 'Lithuania', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48471, '2020-03-13', 'LT', 'Lithuania', 'EURO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48472, '2020-03-14', 'LT', 'Lithuania', 'EURO', '2', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48473, '2020-03-15', 'LT', 'Lithuania', 'EURO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48474, '2020-03-16', 'LT', 'Lithuania', 'EURO', '3', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48475, '2020-03-17', 'LT', 'Lithuania', 'EURO', '7', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48476, '2020-03-18', 'LT', 'Lithuania', 'EURO', '8', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48477, '2020-03-19', 'LT', 'Lithuania', 'EURO', '9', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48478, '2020-03-20', 'LT', 'Lithuania', 'EURO', '11', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48479, '2020-03-21', 'LT', 'Lithuania', 'EURO', '22', '69', '1', '1');
INSERT INTO public.who_global_data_import VALUES (48480, '2020-03-22', 'LT', 'Lithuania', 'EURO', '28', '97', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48481, '2020-03-23', 'LT', 'Lithuania', 'EURO', '31', '128', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48482, '2020-03-24', 'LT', 'Lithuania', 'EURO', '38', '166', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48483, '2020-03-25', 'LT', 'Lithuania', 'EURO', '42', '208', '2', '3');
INSERT INTO public.who_global_data_import VALUES (48484, '2020-03-26', 'LT', 'Lithuania', 'EURO', '55', '263', '1', '4');
INSERT INTO public.who_global_data_import VALUES (48485, '2020-03-27', 'LT', 'Lithuania', 'EURO', '29', '292', '1', '5');
INSERT INTO public.who_global_data_import VALUES (48486, '2020-03-28', 'LT', 'Lithuania', 'EURO', '47', '339', '0', '5');
INSERT INTO public.who_global_data_import VALUES (48487, '2020-03-29', 'LT', 'Lithuania', 'EURO', '39', '378', '2', '7');
INSERT INTO public.who_global_data_import VALUES (48488, '2020-03-30', 'LT', 'Lithuania', 'EURO', '46', '424', '0', '7');
INSERT INTO public.who_global_data_import VALUES (48489, '2020-03-31', 'LT', 'Lithuania', 'EURO', '44', '468', '0', '7');
INSERT INTO public.who_global_data_import VALUES (48490, '2020-04-01', 'LT', 'Lithuania', 'EURO', '44', '512', '1', '8');
INSERT INTO public.who_global_data_import VALUES (48491, '2020-04-02', 'LT', 'Lithuania', 'EURO', '67', '579', '1', '9');
INSERT INTO public.who_global_data_import VALUES (48492, '2020-04-03', 'LT', 'Lithuania', 'EURO', '52', '631', '0', '9');
INSERT INTO public.who_global_data_import VALUES (48493, '2020-04-04', 'LT', 'Lithuania', 'EURO', '52', '683', '2', '11');
INSERT INTO public.who_global_data_import VALUES (48494, '2020-04-05', 'LT', 'Lithuania', 'EURO', '33', '716', '1', '12');
INSERT INTO public.who_global_data_import VALUES (48495, '2020-04-06', 'LT', 'Lithuania', 'EURO', '34', '750', '2', '14');
INSERT INTO public.who_global_data_import VALUES (48496, '2020-04-07', 'LT', 'Lithuania', 'EURO', '33', '783', '6', '20');
INSERT INTO public.who_global_data_import VALUES (48497, '2020-04-08', 'LT', 'Lithuania', 'EURO', '38', '821', '0', '20');
INSERT INTO public.who_global_data_import VALUES (48498, '2020-04-09', 'LT', 'Lithuania', 'EURO', '37', '858', '1', '21');
INSERT INTO public.who_global_data_import VALUES (48499, '2020-04-10', 'LT', 'Lithuania', 'EURO', '38', '896', '1', '22');
INSERT INTO public.who_global_data_import VALUES (48500, '2020-04-11', 'LT', 'Lithuania', 'EURO', '30', '926', '2', '24');
INSERT INTO public.who_global_data_import VALUES (48501, '2020-04-12', 'LT', 'Lithuania', 'EURO', '26', '952', '1', '25');
INSERT INTO public.who_global_data_import VALUES (48502, '2020-04-13', 'LT', 'Lithuania', 'EURO', '18', '970', '0', '25');
INSERT INTO public.who_global_data_import VALUES (48503, '2020-04-14', 'LT', 'Lithuania', 'EURO', '7', '977', '1', '26');
INSERT INTO public.who_global_data_import VALUES (48504, '2020-04-15', 'LT', 'Lithuania', 'EURO', '18', '995', '4', '30');
INSERT INTO public.who_global_data_import VALUES (48505, '2020-04-16', 'LT', 'Lithuania', 'EURO', '27', '1022', '0', '30');
INSERT INTO public.who_global_data_import VALUES (48506, '2020-04-17', 'LT', 'Lithuania', 'EURO', '28', '1050', '2', '32');
INSERT INTO public.who_global_data_import VALUES (48507, '2020-04-18', 'LT', 'Lithuania', 'EURO', '41', '1091', '1', '33');
INSERT INTO public.who_global_data_import VALUES (48508, '2020-04-19', 'LT', 'Lithuania', 'EURO', '62', '1153', '1', '34');
INSERT INTO public.who_global_data_import VALUES (48509, '2020-04-20', 'LT', 'Lithuania', 'EURO', '20', '1173', '3', '37');
INSERT INTO public.who_global_data_import VALUES (48510, '2020-04-21', 'LT', 'Lithuania', 'EURO', '53', '1226', '1', '38');
INSERT INTO public.who_global_data_import VALUES (48511, '2020-04-22', 'LT', 'Lithuania', 'EURO', '24', '1250', '1', '39');
INSERT INTO public.who_global_data_import VALUES (48512, '2020-04-23', 'LT', 'Lithuania', 'EURO', '22', '1272', '0', '39');
INSERT INTO public.who_global_data_import VALUES (48513, '2020-04-24', 'LT', 'Lithuania', 'EURO', '19', '1291', '1', '40');
INSERT INTO public.who_global_data_import VALUES (48514, '2020-04-25', 'LT', 'Lithuania', 'EURO', '10', '1301', '1', '41');
INSERT INTO public.who_global_data_import VALUES (48515, '2020-04-26', 'LT', 'Lithuania', 'EURO', '15', '1316', '2', '43');
INSERT INTO public.who_global_data_import VALUES (48516, '2020-04-27', 'LT', 'Lithuania', 'EURO', '12', '1328', '1', '44');
INSERT INTO public.who_global_data_import VALUES (48517, '2020-04-28', 'LT', 'Lithuania', 'EURO', '9', '1337', '0', '44');
INSERT INTO public.who_global_data_import VALUES (48518, '2020-04-29', 'LT', 'Lithuania', 'EURO', '27', '1364', '1', '45');
INSERT INTO public.who_global_data_import VALUES (48519, '2020-04-30', 'LT', 'Lithuania', 'EURO', '11', '1375', '0', '45');
INSERT INTO public.who_global_data_import VALUES (48520, '2020-05-01', 'LT', 'Lithuania', 'EURO', '14', '1389', '0', '45');
INSERT INTO public.who_global_data_import VALUES (48521, '2020-05-02', 'LT', 'Lithuania', 'EURO', '5', '1394', '1', '46');
INSERT INTO public.who_global_data_import VALUES (48522, '2020-05-03', 'LT', 'Lithuania', 'EURO', '5', '1399', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48523, '2020-05-04', 'LT', 'Lithuania', 'EURO', '8', '1407', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48524, '2020-05-05', 'LT', 'Lithuania', 'EURO', '3', '1410', '0', '46');
INSERT INTO public.who_global_data_import VALUES (48525, '2020-05-06', 'LT', 'Lithuania', 'EURO', '6', '1416', '2', '48');
INSERT INTO public.who_global_data_import VALUES (48526, '2020-05-07', 'LT', 'Lithuania', 'EURO', '5', '1421', '1', '49');
INSERT INTO public.who_global_data_import VALUES (48527, '2020-05-08', 'LT', 'Lithuania', 'EURO', '9', '1430', '0', '49');
INSERT INTO public.who_global_data_import VALUES (48528, '2020-05-09', 'LT', 'Lithuania', 'EURO', '29', '1459', '1', '50');
INSERT INTO public.who_global_data_import VALUES (48529, '2020-05-10', 'LT', 'Lithuania', 'EURO', '12', '1471', '1', '51');
INSERT INTO public.who_global_data_import VALUES (48530, '2020-05-11', 'LT', 'Lithuania', 'EURO', '8', '1479', '0', '51');
INSERT INTO public.who_global_data_import VALUES (48531, '2020-05-12', 'LT', 'Lithuania', 'EURO', '9', '1488', '3', '54');
INSERT INTO public.who_global_data_import VALUES (48532, '2020-05-13', 'LT', 'Lithuania', 'EURO', '14', '1502', '0', '54');
INSERT INTO public.who_global_data_import VALUES (48533, '2020-05-14', 'LT', 'Lithuania', 'EURO', '9', '1511', '0', '54');
INSERT INTO public.who_global_data_import VALUES (48534, '2020-05-15', 'LT', 'Lithuania', 'EURO', '10', '1521', '1', '55');
INSERT INTO public.who_global_data_import VALUES (48535, '2020-05-16', 'LT', 'Lithuania', 'EURO', '15', '1536', '1', '56');
INSERT INTO public.who_global_data_import VALUES (48536, '2020-05-17', 'LT', 'Lithuania', 'EURO', '9', '1545', '2', '58');
INSERT INTO public.who_global_data_import VALUES (48537, '2020-05-18', 'LT', 'Lithuania', 'EURO', '6', '1551', '2', '60');
INSERT INTO public.who_global_data_import VALUES (48538, '2020-05-19', 'LT', 'Lithuania', 'EURO', '8', '1559', '0', '60');
INSERT INTO public.who_global_data_import VALUES (48539, '2020-05-20', 'LT', 'Lithuania', 'EURO', '21', '1580', '1', '61');
INSERT INTO public.who_global_data_import VALUES (48540, '2020-05-21', 'LT', 'Lithuania', 'EURO', '12', '1592', '0', '61');
INSERT INTO public.who_global_data_import VALUES (48541, '2020-05-22', 'LT', 'Lithuania', 'EURO', '6', '1598', '0', '61');
INSERT INTO public.who_global_data_import VALUES (48542, '2020-05-23', 'LT', 'Lithuania', 'EURO', '14', '1612', '2', '63');
INSERT INTO public.who_global_data_import VALUES (48543, '2020-05-24', 'LT', 'Lithuania', 'EURO', '6', '1618', '1', '64');
INSERT INTO public.who_global_data_import VALUES (48544, '2020-05-25', 'LT', 'Lithuania', 'EURO', '10', '1628', '1', '65');
INSERT INTO public.who_global_data_import VALUES (48545, '2020-05-26', 'LT', 'Lithuania', 'EURO', '4', '1632', '1', '66');
INSERT INTO public.who_global_data_import VALUES (48546, '2020-05-27', 'LT', 'Lithuania', 'EURO', '8', '1640', '0', '66');
INSERT INTO public.who_global_data_import VALUES (48547, '2020-05-28', 'LT', 'Lithuania', 'EURO', '9', '1649', '2', '68');
INSERT INTO public.who_global_data_import VALUES (48548, '2020-05-29', 'LT', 'Lithuania', 'EURO', '5', '1654', '0', '68');
INSERT INTO public.who_global_data_import VALUES (48549, '2020-05-30', 'LT', 'Lithuania', 'EURO', '8', '1662', '2', '70');
INSERT INTO public.who_global_data_import VALUES (48550, '2020-05-31', 'LT', 'Lithuania', 'EURO', '5', '1667', '0', '70');
INSERT INTO public.who_global_data_import VALUES (48551, '2020-06-01', 'LT', 'Lithuania', 'EURO', '4', '1671', '1', '71');
INSERT INTO public.who_global_data_import VALUES (48552, '2020-06-02', 'LT', 'Lithuania', 'EURO', '5', '1676', '0', '71');
INSERT INTO public.who_global_data_import VALUES (48553, '2020-06-03', 'LT', 'Lithuania', 'EURO', '3', '1679', '0', '71');
INSERT INTO public.who_global_data_import VALUES (48554, '2020-06-04', 'LT', 'Lithuania', 'EURO', '5', '1684', '0', '71');
INSERT INTO public.who_global_data_import VALUES (48555, '2020-06-05', 'LT', 'Lithuania', 'EURO', '5', '1689', '0', '71');
INSERT INTO public.who_global_data_import VALUES (48556, '2020-06-06', 'LT', 'Lithuania', 'EURO', '11', '1700', '0', '71');
INSERT INTO public.who_global_data_import VALUES (48557, '2020-06-07', 'LT', 'Lithuania', 'EURO', '9', '1709', '0', '71');
INSERT INTO public.who_global_data_import VALUES (48558, '2020-06-08', 'LT', 'Lithuania', 'EURO', '7', '1716', '0', '71');
INSERT INTO public.who_global_data_import VALUES (48559, '2020-06-09', 'LT', 'Lithuania', 'EURO', '6', '1722', '0', '71');
INSERT INTO public.who_global_data_import VALUES (48560, '2020-06-10', 'LT', 'Lithuania', 'EURO', '6', '1728', '3', '74');
INSERT INTO public.who_global_data_import VALUES (48561, '2020-06-11', 'LT', 'Lithuania', 'EURO', '19', '1747', '0', '74');
INSERT INTO public.who_global_data_import VALUES (48562, '2020-06-12', 'LT', 'Lithuania', 'EURO', '4', '1751', '1', '75');
INSERT INTO public.who_global_data_import VALUES (48563, '2020-06-13', 'LT', 'Lithuania', 'EURO', '7', '1758', '0', '75');
INSERT INTO public.who_global_data_import VALUES (48564, '2020-06-14', 'LT', 'Lithuania', 'EURO', '5', '1763', '0', '75');
INSERT INTO public.who_global_data_import VALUES (48565, '2020-06-15', 'LT', 'Lithuania', 'EURO', '5', '1768', '1', '76');
INSERT INTO public.who_global_data_import VALUES (48566, '2020-06-16', 'LT', 'Lithuania', 'EURO', '3', '1771', '0', '76');
INSERT INTO public.who_global_data_import VALUES (48567, '2020-06-17', 'LT', 'Lithuania', 'EURO', '2', '1773', '0', '76');
INSERT INTO public.who_global_data_import VALUES (48568, '2020-06-18', 'LT', 'Lithuania', 'EURO', '6', '1779', '0', '76');
INSERT INTO public.who_global_data_import VALUES (48569, '2020-06-19', 'LT', 'Lithuania', 'EURO', '8', '1787', '0', '76');
INSERT INTO public.who_global_data_import VALUES (48570, '2020-06-20', 'LT', 'Lithuania', 'EURO', '3', '1790', '0', '76');
INSERT INTO public.who_global_data_import VALUES (48571, '2020-06-21', 'LT', 'Lithuania', 'EURO', '3', '1793', '0', '76');
INSERT INTO public.who_global_data_import VALUES (48572, '2020-06-22', 'LT', 'Lithuania', 'EURO', '3', '1796', '0', '76');
INSERT INTO public.who_global_data_import VALUES (48573, '2020-06-23', 'LT', 'Lithuania', 'EURO', '2', '1798', '1', '77');
INSERT INTO public.who_global_data_import VALUES (48574, '2020-06-24', 'LT', 'Lithuania', 'EURO', '1', '1799', '1', '78');
INSERT INTO public.who_global_data_import VALUES (48575, '2020-06-25', 'LT', 'Lithuania', 'EURO', '2', '1801', '0', '78');
INSERT INTO public.who_global_data_import VALUES (48576, '2020-06-26', 'LT', 'Lithuania', 'EURO', '2', '1803', '0', '78');
INSERT INTO public.who_global_data_import VALUES (48577, '2020-06-27', 'LT', 'Lithuania', 'EURO', '5', '1808', '0', '78');
INSERT INTO public.who_global_data_import VALUES (48578, '2020-06-28', 'LT', 'Lithuania', 'EURO', '2', '1810', '0', '78');
INSERT INTO public.who_global_data_import VALUES (48579, '2020-06-29', 'LT', 'Lithuania', 'EURO', '1', '1811', '0', '78');
INSERT INTO public.who_global_data_import VALUES (48580, '2020-06-30', 'LT', 'Lithuania', 'EURO', '1', '1812', '0', '78');
INSERT INTO public.who_global_data_import VALUES (48581, '2020-07-01', 'LT', 'Lithuania', 'EURO', '1', '1813', '0', '78');
INSERT INTO public.who_global_data_import VALUES (48582, '2020-07-02', 'LT', 'Lithuania', 'EURO', '7', '1820', '1', '79');
INSERT INTO public.who_global_data_import VALUES (48583, '2020-07-03', 'LT', 'Lithuania', 'EURO', '3', '1823', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48584, '2020-07-04', 'LT', 'Lithuania', 'EURO', '3', '1826', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48585, '2020-07-05', 'LT', 'Lithuania', 'EURO', '5', '1831', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48586, '2020-07-06', 'LT', 'Lithuania', 'EURO', '5', '1836', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48587, '2020-07-07', 'LT', 'Lithuania', 'EURO', '3', '1839', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48588, '2020-07-08', 'LT', 'Lithuania', 'EURO', '10', '1849', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48589, '2020-07-09', 'LT', 'Lithuania', 'EURO', '3', '1852', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48590, '2020-07-10', 'LT', 'Lithuania', 'EURO', '4', '1856', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48591, '2020-07-11', 'LT', 'Lithuania', 'EURO', '4', '1860', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48592, '2020-07-12', 'LT', 'Lithuania', 'EURO', '4', '1864', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48593, '2020-07-13', 'LT', 'Lithuania', 'EURO', '5', '1869', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48594, '2020-07-14', 'LT', 'Lithuania', 'EURO', '1', '1870', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48595, '2020-07-15', 'LT', 'Lithuania', 'EURO', '21', '1891', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48596, '2020-07-16', 'LT', 'Lithuania', 'EURO', '6', '1897', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48597, '2020-07-17', 'LT', 'Lithuania', 'EURO', '6', '1903', '0', '79');
INSERT INTO public.who_global_data_import VALUES (48598, '2020-07-18', 'LT', 'Lithuania', 'EURO', '7', '1910', '1', '80');
INSERT INTO public.who_global_data_import VALUES (48599, '2020-07-19', 'LT', 'Lithuania', 'EURO', '18', '1928', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48600, '2020-07-20', 'LT', 'Lithuania', 'EURO', '14', '1942', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48601, '2020-07-21', 'LT', 'Lithuania', 'EURO', '2', '1944', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48602, '2020-07-22', 'LT', 'Lithuania', 'EURO', '2', '1946', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48603, '2020-07-23', 'LT', 'Lithuania', 'EURO', '10', '1956', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48604, '2020-07-24', 'LT', 'Lithuania', 'EURO', '26', '1982', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48605, '2020-07-25', 'LT', 'Lithuania', 'EURO', '14', '1996', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48606, '2020-07-26', 'LT', 'Lithuania', 'EURO', '7', '2003', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48607, '2020-07-27', 'LT', 'Lithuania', 'EURO', '11', '2014', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48608, '2020-07-28', 'LT', 'Lithuania', 'EURO', '8', '2022', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48609, '2020-07-29', 'LT', 'Lithuania', 'EURO', '15', '2037', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48610, '2020-07-30', 'LT', 'Lithuania', 'EURO', '19', '2056', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48611, '2020-07-31', 'LT', 'Lithuania', 'EURO', '13', '2069', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48612, '2020-08-01', 'LT', 'Lithuania', 'EURO', '18', '2087', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48613, '2020-08-02', 'LT', 'Lithuania', 'EURO', '17', '2104', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48614, '2020-08-03', 'LT', 'Lithuania', 'EURO', '10', '2114', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48615, '2020-08-04', 'LT', 'Lithuania', 'EURO', '17', '2131', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48616, '2020-08-05', 'LT', 'Lithuania', 'EURO', '10', '2141', '0', '80');
INSERT INTO public.who_global_data_import VALUES (48617, '2020-08-06', 'LT', 'Lithuania', 'EURO', '24', '2165', '1', '81');
INSERT INTO public.who_global_data_import VALUES (48618, '2020-08-07', 'LT', 'Lithuania', 'EURO', '24', '2189', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48619, '2020-08-08', 'LT', 'Lithuania', 'EURO', '36', '2225', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48620, '2020-08-09', 'LT', 'Lithuania', 'EURO', '22', '2247', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48621, '2020-08-10', 'LT', 'Lithuania', 'EURO', '12', '2259', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48622, '2020-08-11', 'LT', 'Lithuania', 'EURO', '18', '2277', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48623, '2020-08-12', 'LT', 'Lithuania', 'EURO', '26', '2303', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48624, '2020-08-13', 'LT', 'Lithuania', 'EURO', '21', '2324', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48625, '2020-08-14', 'LT', 'Lithuania', 'EURO', '22', '2346', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48626, '2020-08-15', 'LT', 'Lithuania', 'EURO', '33', '2379', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48627, '2020-08-16', 'LT', 'Lithuania', 'EURO', '30', '2409', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48628, '2020-08-17', 'LT', 'Lithuania', 'EURO', '21', '2430', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48629, '2020-08-18', 'LT', 'Lithuania', 'EURO', '37', '2467', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48630, '2020-08-19', 'LT', 'Lithuania', 'EURO', '22', '2489', '0', '81');
INSERT INTO public.who_global_data_import VALUES (48631, '2020-08-20', 'LT', 'Lithuania', 'EURO', '32', '2521', '1', '82');
INSERT INTO public.who_global_data_import VALUES (48632, '2020-08-21', 'LT', 'Lithuania', 'EURO', '37', '2558', '0', '82');
INSERT INTO public.who_global_data_import VALUES (48633, '2020-08-22', 'LT', 'Lithuania', 'EURO', '30', '2588', '2', '84');
INSERT INTO public.who_global_data_import VALUES (48634, '2020-08-23', 'LT', 'Lithuania', 'EURO', '41', '2629', '0', '84');
INSERT INTO public.who_global_data_import VALUES (48635, '2020-08-24', 'LT', 'Lithuania', 'EURO', '38', '2667', '1', '85');
INSERT INTO public.who_global_data_import VALUES (48636, '2020-08-25', 'LT', 'Lithuania', 'EURO', '21', '2688', '0', '85');
INSERT INTO public.who_global_data_import VALUES (48637, '2020-08-26', 'LT', 'Lithuania', 'EURO', '32', '2720', '0', '85');
INSERT INTO public.who_global_data_import VALUES (48638, '2020-08-27', 'LT', 'Lithuania', 'EURO', '36', '2756', '0', '85');
INSERT INTO public.who_global_data_import VALUES (48639, '2020-08-28', 'LT', 'Lithuania', 'EURO', '48', '2804', '1', '86');
INSERT INTO public.who_global_data_import VALUES (48640, '2020-08-29', 'LT', 'Lithuania', 'EURO', '29', '2833', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48641, '2020-08-30', 'LT', 'Lithuania', 'EURO', '35', '2868', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48642, '2020-08-31', 'LT', 'Lithuania', 'EURO', '32', '2900', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48643, '2020-09-01', 'LT', 'Lithuania', 'EURO', '23', '2923', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48644, '2020-09-02', 'LT', 'Lithuania', 'EURO', '29', '2952', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48645, '2020-09-03', 'LT', 'Lithuania', 'EURO', '20', '2972', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48646, '2020-09-04', 'LT', 'Lithuania', 'EURO', '26', '2998', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48647, '2020-09-05', 'LT', 'Lithuania', 'EURO', '36', '3034', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48648, '2020-09-06', 'LT', 'Lithuania', 'EURO', '43', '3077', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48649, '2020-09-07', 'LT', 'Lithuania', 'EURO', '17', '3094', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48650, '2020-09-08', 'LT', 'Lithuania', 'EURO', '32', '3126', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48651, '2020-09-09', 'LT', 'Lithuania', 'EURO', '32', '3158', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48652, '2020-09-10', 'LT', 'Lithuania', 'EURO', '36', '3194', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48653, '2020-09-11', 'LT', 'Lithuania', 'EURO', '44', '3238', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48654, '2020-09-12', 'LT', 'Lithuania', 'EURO', '53', '3291', '0', '86');
INSERT INTO public.who_global_data_import VALUES (48655, '2020-09-13', 'LT', 'Lithuania', 'EURO', '39', '3330', '1', '87');
INSERT INTO public.who_global_data_import VALUES (48656, '2020-09-14', 'LT', 'Lithuania', 'EURO', '51', '3381', '0', '87');
INSERT INTO public.who_global_data_import VALUES (48657, '2020-09-15', 'LT', 'Lithuania', 'EURO', '11', '3392', '0', '87');
INSERT INTO public.who_global_data_import VALUES (48658, '2020-09-16', 'LT', 'Lithuania', 'EURO', '45', '3437', '1', '88');
INSERT INTO public.who_global_data_import VALUES (48659, '2020-09-17', 'LT', 'Lithuania', 'EURO', '62', '3499', '0', '88');
INSERT INTO public.who_global_data_import VALUES (48660, '2020-09-18', 'LT', 'Lithuania', 'EURO', '61', '3560', '0', '88');
INSERT INTO public.who_global_data_import VALUES (48661, '2020-09-19', 'LT', 'Lithuania', 'EURO', '99', '3659', '0', '88');
INSERT INTO public.who_global_data_import VALUES (48662, '2020-09-20', 'LT', 'Lithuania', 'EURO', '80', '3739', '0', '88');
INSERT INTO public.who_global_data_import VALUES (48663, '2020-09-21', 'LT', 'Lithuania', 'EURO', '70', '3809', '0', '88');
INSERT INTO public.who_global_data_import VALUES (48664, '2020-09-22', 'LT', 'Lithuania', 'EURO', '45', '3854', '0', '88');
INSERT INTO public.who_global_data_import VALUES (48665, '2020-09-23', 'LT', 'Lithuania', 'EURO', '73', '3927', '0', '88');
INSERT INTO public.who_global_data_import VALUES (48666, '2020-09-24', 'LT', 'Lithuania', 'EURO', '138', '4065', '2', '90');
INSERT INTO public.who_global_data_import VALUES (48667, '2020-09-25', 'LT', 'Lithuania', 'EURO', '114', '4179', '0', '90');
INSERT INTO public.who_global_data_import VALUES (48668, '2020-09-26', 'LT', 'Lithuania', 'EURO', '111', '4290', '0', '90');
INSERT INTO public.who_global_data_import VALUES (48669, '2020-09-27', 'LT', 'Lithuania', 'EURO', '91', '4381', '2', '92');
INSERT INTO public.who_global_data_import VALUES (48670, '2020-09-28', 'LT', 'Lithuania', 'EURO', '104', '4485', '0', '92');
INSERT INTO public.who_global_data_import VALUES (48671, '2020-09-29', 'LT', 'Lithuania', 'EURO', '88', '4573', '0', '92');
INSERT INTO public.who_global_data_import VALUES (48672, '2020-09-30', 'LT', 'Lithuania', 'EURO', '115', '4688', '0', '92');
INSERT INTO public.who_global_data_import VALUES (48673, '2020-10-01', 'LT', 'Lithuania', 'EURO', '91', '4779', '0', '92');
INSERT INTO public.who_global_data_import VALUES (48674, '2020-10-02', 'LT', 'Lithuania', 'EURO', '172', '4951', '-14', '78');
INSERT INTO public.who_global_data_import VALUES (48675, '2020-10-03', 'LT', 'Lithuania', 'EURO', '125', '5076', '2', '80');
INSERT INTO public.who_global_data_import VALUES (48676, '2020-10-04', 'LT', 'Lithuania', 'EURO', '105', '5181', '1', '81');
INSERT INTO public.who_global_data_import VALUES (48677, '2020-10-05', 'LT', 'Lithuania', 'EURO', '100', '5281', '1', '82');
INSERT INTO public.who_global_data_import VALUES (48678, '2020-10-06', 'LT', 'Lithuania', 'EURO', '80', '5361', '2', '84');
INSERT INTO public.who_global_data_import VALUES (48679, '2020-10-07', 'LT', 'Lithuania', 'EURO', '116', '5477', '1', '85');
INSERT INTO public.who_global_data_import VALUES (48680, '2020-10-08', 'LT', 'Lithuania', 'EURO', '142', '5619', '1', '86');
INSERT INTO public.who_global_data_import VALUES (48681, '2020-10-09', 'LT', 'Lithuania', 'EURO', '133', '5752', '1', '87');
INSERT INTO public.who_global_data_import VALUES (48682, '2020-10-10', 'LT', 'Lithuania', 'EURO', '204', '5956', '0', '87');
INSERT INTO public.who_global_data_import VALUES (48683, '2020-10-11', 'LT', 'Lithuania', 'EURO', '160', '6116', '2', '89');
INSERT INTO public.who_global_data_import VALUES (48684, '2020-10-12', 'LT', 'Lithuania', 'EURO', '126', '6242', '0', '89');
INSERT INTO public.who_global_data_import VALUES (48685, '2020-10-13', 'LT', 'Lithuania', 'EURO', '118', '6360', '1', '90');
INSERT INTO public.who_global_data_import VALUES (48686, '2020-10-14', 'LT', 'Lithuania', 'EURO', '137', '6497', '4', '94');
INSERT INTO public.who_global_data_import VALUES (48687, '2020-10-15', 'LT', 'Lithuania', 'EURO', '255', '6752', '0', '94');
INSERT INTO public.who_global_data_import VALUES (48688, '2020-10-16', 'LT', 'Lithuania', 'EURO', '281', '7033', '3', '97');
INSERT INTO public.who_global_data_import VALUES (48689, '2020-10-17', 'LT', 'Lithuania', 'EURO', '228', '7261', '1', '98');
INSERT INTO public.who_global_data_import VALUES (48690, '2020-10-18', 'LT', 'Lithuania', 'EURO', '253', '7514', '2', '100');
INSERT INTO public.who_global_data_import VALUES (48691, '2020-10-19', 'LT', 'Lithuania', 'EURO', '206', '7720', '2', '102');
INSERT INTO public.who_global_data_import VALUES (48692, '2020-10-20', 'LT', 'Lithuania', 'EURO', '203', '7923', '3', '105');
INSERT INTO public.who_global_data_import VALUES (48693, '2020-10-21', 'LT', 'Lithuania', 'EURO', '313', '8236', '4', '109');
INSERT INTO public.who_global_data_import VALUES (48694, '2020-10-22', 'LT', 'Lithuania', 'EURO', '427', '8663', '4', '113');
INSERT INTO public.who_global_data_import VALUES (48695, '2020-10-23', 'LT', 'Lithuania', 'EURO', '445', '9108', '3', '116');
INSERT INTO public.who_global_data_import VALUES (48696, '2020-10-24', 'LT', 'Lithuania', 'EURO', '480', '9588', '1', '117');
INSERT INTO public.who_global_data_import VALUES (48697, '2020-10-25', 'LT', 'Lithuania', 'EURO', '596', '10184', '6', '123');
INSERT INTO public.who_global_data_import VALUES (48698, '2020-10-26', 'LT', 'Lithuania', 'EURO', '765', '10949', '2', '125');
INSERT INTO public.who_global_data_import VALUES (48699, '2020-10-27', 'LT', 'Lithuania', 'EURO', '422', '11371', '5', '130');
INSERT INTO public.who_global_data_import VALUES (48700, '2020-10-28', 'LT', 'Lithuania', 'EURO', '771', '12142', '5', '135');
INSERT INTO public.who_global_data_import VALUES (48701, '2020-10-29', 'LT', 'Lithuania', 'EURO', '948', '13090', '4', '139');
INSERT INTO public.who_global_data_import VALUES (48702, '2020-10-30', 'LT', 'Lithuania', 'EURO', '725', '13815', '6', '145');
INSERT INTO public.who_global_data_import VALUES (48703, '2020-10-31', 'LT', 'Lithuania', 'EURO', '1000', '14815', '8', '153');
INSERT INTO public.who_global_data_import VALUES (48704, '2020-11-01', 'LT', 'Lithuania', 'EURO', '883', '15698', '3', '156');
INSERT INTO public.who_global_data_import VALUES (48705, '2020-11-02', 'LT', 'Lithuania', 'EURO', '834', '16532', '4', '160');
INSERT INTO public.who_global_data_import VALUES (48706, '2020-11-03', 'LT', 'Lithuania', 'EURO', '893', '17425', '11', '171');
INSERT INTO public.who_global_data_import VALUES (48707, '2020-11-04', 'LT', 'Lithuania', 'EURO', '653', '18078', '6', '177');
INSERT INTO public.who_global_data_import VALUES (48708, '2020-11-05', 'LT', 'Lithuania', 'EURO', '993', '19071', '2', '179');
INSERT INTO public.who_global_data_import VALUES (48709, '2020-11-06', 'LT', 'Lithuania', 'EURO', '1649', '20720', '7', '186');
INSERT INTO public.who_global_data_import VALUES (48710, '2020-11-07', 'LT', 'Lithuania', 'EURO', '1939', '22659', '10', '196');
INSERT INTO public.who_global_data_import VALUES (48711, '2020-11-08', 'LT', 'Lithuania', 'EURO', '1975', '24634', '9', '205');
INSERT INTO public.who_global_data_import VALUES (48712, '2020-11-09', 'LT', 'Lithuania', 'EURO', '1038', '25672', '8', '213');
INSERT INTO public.who_global_data_import VALUES (48713, '2020-11-10', 'LT', 'Lithuania', 'EURO', '1109', '26781', '17', '230');
INSERT INTO public.who_global_data_import VALUES (48714, '2020-11-11', 'LT', 'Lithuania', 'EURO', '1435', '28216', '10', '240');
INSERT INTO public.who_global_data_import VALUES (48715, '2020-11-12', 'LT', 'Lithuania', 'EURO', '1555', '29771', '11', '251');
INSERT INTO public.who_global_data_import VALUES (48716, '2020-11-13', 'LT', 'Lithuania', 'EURO', '2057', '31828', '14', '265');
INSERT INTO public.who_global_data_import VALUES (48717, '2020-11-14', 'LT', 'Lithuania', 'EURO', '1528', '33356', '17', '282');
INSERT INTO public.who_global_data_import VALUES (48718, '2020-11-15', 'LT', 'Lithuania', 'EURO', '1374', '34730', '14', '296');
INSERT INTO public.who_global_data_import VALUES (48719, '2020-11-16', 'LT', 'Lithuania', 'EURO', '1148', '35878', '15', '311');
INSERT INTO public.who_global_data_import VALUES (48720, '2020-11-17', 'LT', 'Lithuania', 'EURO', '966', '36844', '20', '331');
INSERT INTO public.who_global_data_import VALUES (48721, '2020-11-18', 'LT', 'Lithuania', 'EURO', '1943', '38787', '21', '352');
INSERT INTO public.who_global_data_import VALUES (48722, '2020-11-19', 'LT', 'Lithuania', 'EURO', '1668', '40455', '23', '375');
INSERT INTO public.who_global_data_import VALUES (48723, '2020-11-20', 'LT', 'Lithuania', 'EURO', '2269', '42724', '19', '394');
INSERT INTO public.who_global_data_import VALUES (48724, '2020-11-21', 'LT', 'Lithuania', 'EURO', '1978', '44702', '20', '414');
INSERT INTO public.who_global_data_import VALUES (48725, '2020-11-22', 'LT', 'Lithuania', 'EURO', '2309', '47011', '27', '441');
INSERT INTO public.who_global_data_import VALUES (48726, '2020-11-23', 'LT', 'Lithuania', 'EURO', '1190', '48201', '20', '461');
INSERT INTO public.who_global_data_import VALUES (48727, '2020-11-24', 'LT', 'Lithuania', 'EURO', '1171', '49372', '18', '479');
INSERT INTO public.who_global_data_import VALUES (48728, '2020-11-25', 'LT', 'Lithuania', 'EURO', '2288', '51660', '22', '501');
INSERT INTO public.who_global_data_import VALUES (48729, '2020-11-26', 'LT', 'Lithuania', 'EURO', '2101', '53761', '27', '528');
INSERT INTO public.who_global_data_import VALUES (48730, '2020-11-27', 'LT', 'Lithuania', 'EURO', '2333', '56094', '23', '551');
INSERT INTO public.who_global_data_import VALUES (48731, '2020-11-28', 'LT', 'Lithuania', 'EURO', '2124', '58218', '22', '573');
INSERT INTO public.who_global_data_import VALUES (48732, '2020-11-29', 'LT', 'Lithuania', 'EURO', '1967', '60185', '22', '595');
INSERT INTO public.who_global_data_import VALUES (48733, '2020-11-30', 'LT', 'Lithuania', 'EURO', '1136', '61321', '27', '622');
INSERT INTO public.who_global_data_import VALUES (48734, '2020-12-01', 'LT', 'Lithuania', 'EURO', '1188', '62509', '20', '642');
INSERT INTO public.who_global_data_import VALUES (48735, '2020-12-02', 'LT', 'Lithuania', 'EURO', '2107', '64616', '34', '676');
INSERT INTO public.who_global_data_import VALUES (48736, '2020-12-03', 'LT', 'Lithuania', 'EURO', '2452', '67068', '19', '695');
INSERT INTO public.who_global_data_import VALUES (48737, '2020-12-04', 'LT', 'Lithuania', 'EURO', '2513', '69581', '38', '733');
INSERT INTO public.who_global_data_import VALUES (48738, '2020-12-05', 'LT', 'Lithuania', 'EURO', '2849', '72430', '34', '767');
INSERT INTO public.who_global_data_import VALUES (48739, '2020-12-06', 'LT', 'Lithuania', 'EURO', '2217', '74647', '24', '791');
INSERT INTO public.who_global_data_import VALUES (48740, '2020-12-07', 'LT', 'Lithuania', 'EURO', '1390', '76037', '44', '835');
INSERT INTO public.who_global_data_import VALUES (48741, '2020-12-08', 'LT', 'Lithuania', 'EURO', '1393', '77430', '25', '860');
INSERT INTO public.who_global_data_import VALUES (48742, '2020-12-09', 'LT', 'Lithuania', 'EURO', '3127', '80557', '27', '887');
INSERT INTO public.who_global_data_import VALUES (48743, '2020-12-10', 'LT', 'Lithuania', 'EURO', '3325', '83882', '17', '904');
INSERT INTO public.who_global_data_import VALUES (48744, '2020-12-11', 'LT', 'Lithuania', 'EURO', '3071', '86953', '35', '939');
INSERT INTO public.who_global_data_import VALUES (48745, '2020-12-12', 'LT', 'Lithuania', 'EURO', '3302', '90255', '48', '987');
INSERT INTO public.who_global_data_import VALUES (48746, '2020-12-13', 'LT', 'Lithuania', 'EURO', '2841', '93096', '54', '1041');
INSERT INTO public.who_global_data_import VALUES (48747, '2020-12-14', 'LT', 'Lithuania', 'EURO', '1920', '95016', '28', '1069');
INSERT INTO public.who_global_data_import VALUES (48748, '2020-12-15', 'LT', 'Lithuania', 'EURO', '1436', '96452', '45', '1114');
INSERT INTO public.who_global_data_import VALUES (48749, '2020-12-16', 'LT', 'Lithuania', 'EURO', '3422', '99874', '25', '1139');
INSERT INTO public.who_global_data_import VALUES (48750, '2020-12-17', 'LT', 'Lithuania', 'EURO', '3163', '103037', '43', '1182');
INSERT INTO public.who_global_data_import VALUES (48751, '2020-12-18', 'LT', 'Lithuania', 'EURO', '3183', '106220', '39', '1221');
INSERT INTO public.who_global_data_import VALUES (48752, '2020-12-19', 'LT', 'Lithuania', 'EURO', '3222', '109442', '46', '1267');
INSERT INTO public.who_global_data_import VALUES (48753, '2020-12-20', 'LT', 'Lithuania', 'EURO', '2917', '112359', '28', '1295');
INSERT INTO public.who_global_data_import VALUES (48754, '2020-12-21', 'LT', 'Lithuania', 'EURO', '2133', '114492', '46', '1341');
INSERT INTO public.who_global_data_import VALUES (48755, '2020-12-22', 'LT', 'Lithuania', 'EURO', '1883', '116375', '56', '1397');
INSERT INTO public.who_global_data_import VALUES (48756, '2020-12-23', 'LT', 'Lithuania', 'EURO', '3719', '120094', '35', '1432');
INSERT INTO public.who_global_data_import VALUES (48757, '2020-12-24', 'LT', 'Lithuania', 'EURO', '3806', '123900', '36', '1468');
INSERT INTO public.who_global_data_import VALUES (48758, '2020-12-25', 'LT', 'Lithuania', 'EURO', '2688', '126588', '44', '1512');
INSERT INTO public.who_global_data_import VALUES (48759, '2020-12-26', 'LT', 'Lithuania', 'EURO', '2344', '128932', '61', '1573');
INSERT INTO public.who_global_data_import VALUES (48760, '2020-12-27', 'LT', 'Lithuania', 'EURO', '1665', '130597', '42', '1615');
INSERT INTO public.who_global_data_import VALUES (48761, '2020-12-28', 'LT', 'Lithuania', 'EURO', '1767', '132364', '39', '1654');
INSERT INTO public.who_global_data_import VALUES (48762, '2020-12-29', 'LT', 'Lithuania', 'EURO', '1923', '134287', '43', '1697');
INSERT INTO public.who_global_data_import VALUES (48763, '2020-12-30', 'LT', 'Lithuania', 'EURO', '3911', '138198', '44', '1741');
INSERT INTO public.who_global_data_import VALUES (48764, '2020-12-31', 'LT', 'Lithuania', 'EURO', '2375', '140573', '56', '1797');
INSERT INTO public.who_global_data_import VALUES (48765, '2021-01-01', 'LT', 'Lithuania', 'EURO', '3322', '143895', '41', '1838');
INSERT INTO public.who_global_data_import VALUES (48766, '2021-01-02', 'LT', 'Lithuania', 'EURO', '1492', '145387', '51', '1889');
INSERT INTO public.who_global_data_import VALUES (48767, '2021-01-03', 'LT', 'Lithuania', 'EURO', '1238', '146625', '49', '1938');
INSERT INTO public.who_global_data_import VALUES (48768, '2021-01-04', 'LT', 'Lithuania', 'EURO', '1362', '147987', '37', '1975');
INSERT INTO public.who_global_data_import VALUES (48769, '2021-01-05', 'LT', 'Lithuania', 'EURO', '1510', '149497', '40', '2015');
INSERT INTO public.who_global_data_import VALUES (48770, '2021-01-06', 'LT', 'Lithuania', 'EURO', '2717', '152214', '34', '2049');
INSERT INTO public.who_global_data_import VALUES (48771, '2021-01-07', 'LT', 'Lithuania', 'EURO', '2334', '154548', '43', '2092');
INSERT INTO public.who_global_data_import VALUES (48772, '2021-01-08', 'LT', 'Lithuania', 'EURO', '1994', '156542', '41', '2133');
INSERT INTO public.who_global_data_import VALUES (48773, '2021-01-09', 'LT', 'Lithuania', 'EURO', '1640', '158182', '40', '2173');
INSERT INTO public.who_global_data_import VALUES (48774, '2021-01-10', 'LT', 'Lithuania', 'EURO', '1489', '159671', '27', '2200');
INSERT INTO public.who_global_data_import VALUES (48775, '2021-01-11', 'LT', 'Lithuania', 'EURO', '775', '160446', '32', '2232');
INSERT INTO public.who_global_data_import VALUES (48776, '2021-01-12', 'LT', 'Lithuania', 'EURO', '902', '161348', '40', '2272');
INSERT INTO public.who_global_data_import VALUES (48777, '2021-01-13', 'LT', 'Lithuania', 'EURO', '1694', '163042', '45', '2317');
INSERT INTO public.who_global_data_import VALUES (48778, '2021-01-14', 'LT', 'Lithuania', 'EURO', '1372', '164414', '29', '2346');
INSERT INTO public.who_global_data_import VALUES (48779, '2021-01-15', 'LT', 'Lithuania', 'EURO', '1146', '165560', '30', '2376');
INSERT INTO public.who_global_data_import VALUES (48780, '2021-01-16', 'LT', 'Lithuania', 'EURO', '1120', '166680', '38', '2414');
INSERT INTO public.who_global_data_import VALUES (48781, '2021-01-17', 'LT', 'Lithuania', 'EURO', '836', '167516', '31', '2445');
INSERT INTO public.who_global_data_import VALUES (48782, '2021-01-18', 'LT', 'Lithuania', 'EURO', '476', '167992', '24', '2469');
INSERT INTO public.who_global_data_import VALUES (48783, '2021-01-19', 'LT', 'Lithuania', 'EURO', '716', '168708', '25', '2494');
INSERT INTO public.who_global_data_import VALUES (48784, '2021-01-20', 'LT', 'Lithuania', 'EURO', '3352', '172060', '20', '2514');
INSERT INTO public.who_global_data_import VALUES (48785, '2021-01-21', 'LT', 'Lithuania', 'EURO', '1759', '173819', '40', '2554');
INSERT INTO public.who_global_data_import VALUES (48786, '2021-01-22', 'LT', 'Lithuania', 'EURO', '1027', '174846', '37', '2591');
INSERT INTO public.who_global_data_import VALUES (48787, '2021-01-23', 'LT', 'Lithuania', 'EURO', '1005', '175851', '37', '2628');
INSERT INTO public.who_global_data_import VALUES (48788, '2021-01-24', 'LT', 'Lithuania', 'EURO', '773', '176624', '21', '2649');
INSERT INTO public.who_global_data_import VALUES (48789, '2021-01-25', 'LT', 'Lithuania', 'EURO', '542', '177166', '15', '2664');
INSERT INTO public.who_global_data_import VALUES (48790, '2021-01-26', 'LT', 'Lithuania', 'EURO', '768', '177934', '24', '2688');
INSERT INTO public.who_global_data_import VALUES (48791, '2021-01-27', 'LT', 'Lithuania', 'EURO', '1278', '179212', '28', '2716');
INSERT INTO public.who_global_data_import VALUES (48792, '2021-01-28', 'LT', 'Lithuania', 'EURO', '958', '180170', '30', '2746');
INSERT INTO public.who_global_data_import VALUES (48793, '2021-01-29', 'LT', 'Lithuania', 'EURO', '858', '181028', '16', '2762');
INSERT INTO public.who_global_data_import VALUES (48794, '2021-01-30', 'LT', 'Lithuania', 'EURO', '706', '181734', '25', '2787');
INSERT INTO public.who_global_data_import VALUES (48795, '2021-01-31', 'LT', 'Lithuania', 'EURO', '805', '182539', '16', '2803');
INSERT INTO public.who_global_data_import VALUES (48796, '2021-02-01', 'LT', 'Lithuania', 'EURO', '354', '182893', '22', '2825');
INSERT INTO public.who_global_data_import VALUES (48797, '2021-02-02', 'LT', 'Lithuania', 'EURO', '551', '183444', '22', '2847');
INSERT INTO public.who_global_data_import VALUES (48798, '2021-02-03', 'LT', 'Lithuania', 'EURO', '764', '184208', '20', '2867');
INSERT INTO public.who_global_data_import VALUES (48799, '2021-02-04', 'LT', 'Lithuania', 'EURO', '740', '184948', '18', '2885');
INSERT INTO public.who_global_data_import VALUES (48800, '2021-02-05', 'LT', 'Lithuania', 'EURO', '653', '185601', '23', '2908');
INSERT INTO public.who_global_data_import VALUES (48801, '2020-01-03', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48802, '2020-01-04', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48803, '2020-01-05', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48804, '2020-01-06', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48805, '2020-01-07', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48806, '2020-01-08', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48807, '2020-01-09', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48808, '2020-01-10', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48809, '2020-01-11', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48810, '2020-01-12', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48811, '2020-01-13', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48812, '2020-01-14', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48813, '2020-01-15', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48814, '2020-01-16', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48815, '2020-01-17', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48816, '2020-01-18', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48817, '2020-01-19', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48818, '2020-01-20', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48819, '2020-01-21', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48820, '2020-01-22', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48821, '2020-01-23', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48822, '2020-01-24', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48823, '2020-01-25', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48824, '2020-01-26', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48825, '2020-01-27', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48826, '2020-01-28', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48827, '2020-01-29', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48828, '2020-01-30', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48829, '2020-01-31', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48830, '2020-02-01', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48831, '2020-02-02', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48832, '2020-02-03', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48833, '2020-02-04', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48834, '2020-02-05', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48835, '2020-02-06', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48836, '2020-02-07', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48837, '2020-02-08', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48838, '2020-02-09', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48839, '2020-02-10', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48840, '2020-02-11', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48841, '2020-02-12', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48842, '2020-02-13', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48843, '2020-02-14', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48844, '2020-02-15', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48845, '2020-02-16', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48846, '2020-02-17', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48847, '2020-02-18', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48848, '2020-02-19', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48849, '2020-02-20', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48850, '2020-02-21', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48851, '2020-02-22', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48852, '2020-02-23', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48853, '2020-02-24', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48854, '2020-02-25', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48855, '2020-02-26', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48856, '2020-02-27', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48857, '2020-02-28', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48858, '2020-02-29', 'LU', 'Luxembourg', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48859, '2020-03-01', 'LU', 'Luxembourg', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48860, '2020-03-02', 'LU', 'Luxembourg', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48861, '2020-03-03', 'LU', 'Luxembourg', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48862, '2020-03-04', 'LU', 'Luxembourg', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48863, '2020-03-05', 'LU', 'Luxembourg', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48864, '2020-03-06', 'LU', 'Luxembourg', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48865, '2020-03-07', 'LU', 'Luxembourg', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48866, '2020-03-08', 'LU', 'Luxembourg', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48867, '2020-03-09', 'LU', 'Luxembourg', 'EURO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48868, '2020-03-10', 'LU', 'Luxembourg', 'EURO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48869, '2020-03-11', 'LU', 'Luxembourg', 'EURO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48870, '2020-03-12', 'LU', 'Luxembourg', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48871, '2020-03-13', 'LU', 'Luxembourg', 'EURO', '19', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (48872, '2020-03-14', 'LU', 'Luxembourg', 'EURO', '12', '38', '1', '1');
INSERT INTO public.who_global_data_import VALUES (48873, '2020-03-15', 'LU', 'Luxembourg', 'EURO', '0', '38', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48874, '2020-03-16', 'LU', 'Luxembourg', 'EURO', '39', '77', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48875, '2020-03-17', 'LU', 'Luxembourg', 'EURO', '4', '81', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48876, '2020-03-18', 'LU', 'Luxembourg', 'EURO', '59', '140', '0', '1');
INSERT INTO public.who_global_data_import VALUES (48877, '2020-03-19', 'LU', 'Luxembourg', 'EURO', '70', '210', '1', '2');
INSERT INTO public.who_global_data_import VALUES (48878, '2020-03-20', 'LU', 'Luxembourg', 'EURO', '135', '345', '2', '4');
INSERT INTO public.who_global_data_import VALUES (48879, '2020-03-21', 'LU', 'Luxembourg', 'EURO', '139', '484', '1', '5');
INSERT INTO public.who_global_data_import VALUES (48880, '2020-03-22', 'LU', 'Luxembourg', 'EURO', '186', '670', '3', '8');
INSERT INTO public.who_global_data_import VALUES (48881, '2020-03-23', 'LU', 'Luxembourg', 'EURO', '128', '798', '0', '8');
INSERT INTO public.who_global_data_import VALUES (48882, '2020-03-24', 'LU', 'Luxembourg', 'EURO', '77', '875', '0', '8');
INSERT INTO public.who_global_data_import VALUES (48883, '2020-03-25', 'LU', 'Luxembourg', 'EURO', '224', '1099', '0', '8');
INSERT INTO public.who_global_data_import VALUES (48884, '2020-03-26', 'LU', 'Luxembourg', 'EURO', '234', '1333', '0', '8');
INSERT INTO public.who_global_data_import VALUES (48885, '2020-03-27', 'LU', 'Luxembourg', 'EURO', '120', '1453', '1', '9');
INSERT INTO public.who_global_data_import VALUES (48886, '2020-03-28', 'LU', 'Luxembourg', 'EURO', '152', '1605', '6', '15');
INSERT INTO public.who_global_data_import VALUES (48887, '2020-03-29', 'LU', 'Luxembourg', 'EURO', '226', '1831', '3', '18');
INSERT INTO public.who_global_data_import VALUES (48888, '2020-03-30', 'LU', 'Luxembourg', 'EURO', '119', '1950', '3', '21');
INSERT INTO public.who_global_data_import VALUES (48889, '2020-03-31', 'LU', 'Luxembourg', 'EURO', '38', '1988', '1', '22');
INSERT INTO public.who_global_data_import VALUES (48890, '2020-04-01', 'LU', 'Luxembourg', 'EURO', '190', '2178', '1', '23');
INSERT INTO public.who_global_data_import VALUES (48891, '2020-04-02', 'LU', 'Luxembourg', 'EURO', '141', '2319', '6', '29');
INSERT INTO public.who_global_data_import VALUES (48892, '2020-04-03', 'LU', 'Luxembourg', 'EURO', '168', '2487', '1', '30');
INSERT INTO public.who_global_data_import VALUES (48893, '2020-04-04', 'LU', 'Luxembourg', 'EURO', '125', '2612', '1', '31');
INSERT INTO public.who_global_data_import VALUES (48894, '2020-04-05', 'LU', 'Luxembourg', 'EURO', '117', '2729', '0', '31');
INSERT INTO public.who_global_data_import VALUES (48895, '2020-04-06', 'LU', 'Luxembourg', 'EURO', '75', '2804', '5', '36');
INSERT INTO public.who_global_data_import VALUES (48896, '2020-04-07', 'LU', 'Luxembourg', 'EURO', '39', '2843', '5', '41');
INSERT INTO public.who_global_data_import VALUES (48897, '2020-04-08', 'LU', 'Luxembourg', 'EURO', '127', '2970', '3', '44');
INSERT INTO public.who_global_data_import VALUES (48898, '2020-04-09', 'LU', 'Luxembourg', 'EURO', '64', '3034', '2', '46');
INSERT INTO public.who_global_data_import VALUES (48899, '2020-04-10', 'LU', 'Luxembourg', 'EURO', '81', '3115', '6', '52');
INSERT INTO public.who_global_data_import VALUES (48900, '2020-04-11', 'LU', 'Luxembourg', 'EURO', '108', '3223', '2', '54');
INSERT INTO public.who_global_data_import VALUES (48901, '2020-04-12', 'LU', 'Luxembourg', 'EURO', '47', '3270', '8', '62');
INSERT INTO public.who_global_data_import VALUES (48902, '2020-04-13', 'LU', 'Luxembourg', 'EURO', '11', '3281', '4', '66');
INSERT INTO public.who_global_data_import VALUES (48903, '2020-04-14', 'LU', 'Luxembourg', 'EURO', '11', '3292', '1', '67');
INSERT INTO public.who_global_data_import VALUES (48904, '2020-04-15', 'LU', 'Luxembourg', 'EURO', '15', '3307', '0', '67');
INSERT INTO public.who_global_data_import VALUES (48905, '2020-04-16', 'LU', 'Luxembourg', 'EURO', '66', '3373', '2', '69');
INSERT INTO public.who_global_data_import VALUES (48906, '2020-04-17', 'LU', 'Luxembourg', 'EURO', '71', '3444', '0', '69');
INSERT INTO public.who_global_data_import VALUES (48907, '2020-04-18', 'LU', 'Luxembourg', 'EURO', '36', '3480', '3', '72');
INSERT INTO public.who_global_data_import VALUES (48908, '2020-04-19', 'LU', 'Luxembourg', 'EURO', '57', '3537', '0', '72');
INSERT INTO public.who_global_data_import VALUES (48909, '2020-04-20', 'LU', 'Luxembourg', 'EURO', '13', '3550', '1', '73');
INSERT INTO public.who_global_data_import VALUES (48910, '2020-04-21', 'LU', 'Luxembourg', 'EURO', '8', '3558', '2', '75');
INSERT INTO public.who_global_data_import VALUES (48911, '2020-04-22', 'LU', 'Luxembourg', 'EURO', '60', '3618', '3', '78');
INSERT INTO public.who_global_data_import VALUES (48912, '2020-04-23', 'LU', 'Luxembourg', 'EURO', '36', '3654', '2', '80');
INSERT INTO public.who_global_data_import VALUES (48913, '2020-04-24', 'LU', 'Luxembourg', 'EURO', '11', '3665', '3', '83');
INSERT INTO public.who_global_data_import VALUES (48914, '2020-04-25', 'LU', 'Luxembourg', 'EURO', '30', '3695', '2', '85');
INSERT INTO public.who_global_data_import VALUES (48915, '2020-04-26', 'LU', 'Luxembourg', 'EURO', '16', '3711', '0', '85');
INSERT INTO public.who_global_data_import VALUES (48916, '2020-04-27', 'LU', 'Luxembourg', 'EURO', '12', '3723', '3', '88');
INSERT INTO public.who_global_data_import VALUES (48917, '2020-04-28', 'LU', 'Luxembourg', 'EURO', '6', '3729', '0', '88');
INSERT INTO public.who_global_data_import VALUES (48918, '2020-04-29', 'LU', 'Luxembourg', 'EURO', '12', '3741', '1', '89');
INSERT INTO public.who_global_data_import VALUES (48919, '2020-04-30', 'LU', 'Luxembourg', 'EURO', '28', '3769', '0', '89');
INSERT INTO public.who_global_data_import VALUES (48920, '2020-05-01', 'LU', 'Luxembourg', 'EURO', '15', '3784', '1', '90');
INSERT INTO public.who_global_data_import VALUES (48921, '2020-05-02', 'LU', 'Luxembourg', 'EURO', '18', '3802', '2', '92');
INSERT INTO public.who_global_data_import VALUES (48922, '2020-05-03', 'LU', 'Luxembourg', 'EURO', '10', '3812', '0', '92');
INSERT INTO public.who_global_data_import VALUES (48923, '2020-05-04', 'LU', 'Luxembourg', 'EURO', '12', '3824', '4', '96');
INSERT INTO public.who_global_data_import VALUES (48924, '2020-05-05', 'LU', 'Luxembourg', 'EURO', '4', '3828', '0', '96');
INSERT INTO public.who_global_data_import VALUES (48925, '2020-05-06', 'LU', 'Luxembourg', 'EURO', '12', '3840', '0', '96');
INSERT INTO public.who_global_data_import VALUES (48926, '2020-05-07', 'LU', 'Luxembourg', 'EURO', '11', '3851', '2', '98');
INSERT INTO public.who_global_data_import VALUES (48927, '2020-05-08', 'LU', 'Luxembourg', 'EURO', '8', '3859', '2', '100');
INSERT INTO public.who_global_data_import VALUES (48928, '2020-05-09', 'LU', 'Luxembourg', 'EURO', '12', '3871', '0', '100');
INSERT INTO public.who_global_data_import VALUES (48929, '2020-05-10', 'LU', 'Luxembourg', 'EURO', '6', '3877', '1', '101');
INSERT INTO public.who_global_data_import VALUES (48930, '2020-05-11', 'LU', 'Luxembourg', 'EURO', '9', '3886', '0', '101');
INSERT INTO public.who_global_data_import VALUES (48931, '2020-05-12', 'LU', 'Luxembourg', 'EURO', '2', '3888', '0', '101');
INSERT INTO public.who_global_data_import VALUES (48932, '2020-05-13', 'LU', 'Luxembourg', 'EURO', '6', '3894', '1', '102');
INSERT INTO public.who_global_data_import VALUES (48933, '2020-05-14', 'LU', 'Luxembourg', 'EURO', '10', '3904', '1', '103');
INSERT INTO public.who_global_data_import VALUES (48934, '2020-05-15', 'LU', 'Luxembourg', 'EURO', '11', '3915', '0', '103');
INSERT INTO public.who_global_data_import VALUES (48935, '2020-05-16', 'LU', 'Luxembourg', 'EURO', '8', '3923', '1', '104');
INSERT INTO public.who_global_data_import VALUES (48936, '2020-05-17', 'LU', 'Luxembourg', 'EURO', '7', '3930', '0', '104');
INSERT INTO public.who_global_data_import VALUES (48937, '2020-05-18', 'LU', 'Luxembourg', 'EURO', '15', '3945', '3', '107');
INSERT INTO public.who_global_data_import VALUES (48938, '2020-05-19', 'LU', 'Luxembourg', 'EURO', '2', '3947', '0', '107');
INSERT INTO public.who_global_data_import VALUES (48939, '2020-05-20', 'LU', 'Luxembourg', 'EURO', '11', '3958', '2', '109');
INSERT INTO public.who_global_data_import VALUES (48940, '2020-05-21', 'LU', 'Luxembourg', 'EURO', '13', '3971', '0', '109');
INSERT INTO public.who_global_data_import VALUES (48941, '2020-05-22', 'LU', 'Luxembourg', 'EURO', '9', '3980', '0', '109');
INSERT INTO public.who_global_data_import VALUES (48942, '2020-05-23', 'LU', 'Luxembourg', 'EURO', '1', '3981', '0', '109');
INSERT INTO public.who_global_data_import VALUES (48943, '2020-05-24', 'LU', 'Luxembourg', 'EURO', '9', '3990', '0', '109');
INSERT INTO public.who_global_data_import VALUES (48944, '2020-05-25', 'LU', 'Luxembourg', 'EURO', '2', '3992', '1', '110');
INSERT INTO public.who_global_data_import VALUES (48945, '2020-05-26', 'LU', 'Luxembourg', 'EURO', '1', '3993', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48946, '2020-05-27', 'LU', 'Luxembourg', 'EURO', '2', '3995', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48947, '2020-05-28', 'LU', 'Luxembourg', 'EURO', '6', '4001', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48948, '2020-05-29', 'LU', 'Luxembourg', 'EURO', '7', '4008', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48949, '2020-05-30', 'LU', 'Luxembourg', 'EURO', '4', '4012', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48950, '2020-05-31', 'LU', 'Luxembourg', 'EURO', '4', '4016', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48951, '2020-06-01', 'LU', 'Luxembourg', 'EURO', '2', '4018', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48952, '2020-06-02', 'LU', 'Luxembourg', 'EURO', '1', '4019', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48953, '2020-06-03', 'LU', 'Luxembourg', 'EURO', '1', '4020', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48954, '2020-06-04', 'LU', 'Luxembourg', 'EURO', '0', '4020', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48955, '2020-06-05', 'LU', 'Luxembourg', 'EURO', '7', '4027', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48956, '2020-06-06', 'LU', 'Luxembourg', 'EURO', '5', '4032', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48957, '2020-06-07', 'LU', 'Luxembourg', 'EURO', '3', '4035', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48958, '2020-06-08', 'LU', 'Luxembourg', 'EURO', '4', '4039', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48959, '2020-06-09', 'LU', 'Luxembourg', 'EURO', '1', '4040', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48960, '2020-06-10', 'LU', 'Luxembourg', 'EURO', '6', '4046', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48961, '2020-06-11', 'LU', 'Luxembourg', 'EURO', '3', '4049', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48962, '2020-06-12', 'LU', 'Luxembourg', 'EURO', '3', '4052', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48963, '2020-06-13', 'LU', 'Luxembourg', 'EURO', '3', '4055', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48964, '2020-06-14', 'LU', 'Luxembourg', 'EURO', '8', '4063', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48965, '2020-06-15', 'LU', 'Luxembourg', 'EURO', '7', '4070', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48966, '2020-06-16', 'LU', 'Luxembourg', 'EURO', '2', '4072', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48967, '2020-06-17', 'LU', 'Luxembourg', 'EURO', '3', '4075', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48968, '2020-06-18', 'LU', 'Luxembourg', 'EURO', '10', '4085', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48969, '2020-06-19', 'LU', 'Luxembourg', 'EURO', '6', '4091', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48970, '2020-06-20', 'LU', 'Luxembourg', 'EURO', '8', '4099', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48971, '2020-06-21', 'LU', 'Luxembourg', 'EURO', '6', '4105', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48972, '2020-06-22', 'LU', 'Luxembourg', 'EURO', '15', '4120', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48973, '2020-06-23', 'LU', 'Luxembourg', 'EURO', '1', '4121', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48974, '2020-06-24', 'LU', 'Luxembourg', 'EURO', '12', '4133', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48975, '2020-06-25', 'LU', 'Luxembourg', 'EURO', '7', '4140', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48976, '2020-06-26', 'LU', 'Luxembourg', 'EURO', '11', '4151', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48977, '2020-06-27', 'LU', 'Luxembourg', 'EURO', '22', '4173', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48978, '2020-06-28', 'LU', 'Luxembourg', 'EURO', '44', '4217', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48979, '2020-06-29', 'LU', 'Luxembourg', 'EURO', '25', '4242', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48980, '2020-06-30', 'LU', 'Luxembourg', 'EURO', '14', '4256', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48981, '2020-07-01', 'LU', 'Luxembourg', 'EURO', '43', '4299', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48982, '2020-07-02', 'LU', 'Luxembourg', 'EURO', '46', '4345', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48983, '2020-07-03', 'LU', 'Luxembourg', 'EURO', '50', '4395', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48984, '2020-07-04', 'LU', 'Luxembourg', 'EURO', '52', '4447', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48985, '2020-07-05', 'LU', 'Luxembourg', 'EURO', '29', '4476', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48986, '2020-07-06', 'LU', 'Luxembourg', 'EURO', '46', '4522', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48987, '2020-07-07', 'LU', 'Luxembourg', 'EURO', '20', '4542', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48988, '2020-07-08', 'LU', 'Luxembourg', 'EURO', '61', '4603', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48989, '2020-07-09', 'LU', 'Luxembourg', 'EURO', '47', '4650', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48990, '2020-07-10', 'LU', 'Luxembourg', 'EURO', '69', '4719', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48991, '2020-07-11', 'LU', 'Luxembourg', 'EURO', '58', '4777', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48992, '2020-07-12', 'LU', 'Luxembourg', 'EURO', '65', '4842', '0', '110');
INSERT INTO public.who_global_data_import VALUES (48993, '2020-07-13', 'LU', 'Luxembourg', 'EURO', '83', '4925', '1', '111');
INSERT INTO public.who_global_data_import VALUES (48994, '2020-07-14', 'LU', 'Luxembourg', 'EURO', '31', '4956', '0', '111');
INSERT INTO public.who_global_data_import VALUES (48995, '2020-07-15', 'LU', 'Luxembourg', 'EURO', '100', '5056', '0', '111');
INSERT INTO public.who_global_data_import VALUES (48996, '2020-07-16', 'LU', 'Luxembourg', 'EURO', '0', '5056', '0', '111');
INSERT INTO public.who_global_data_import VALUES (48997, '2020-07-17', 'LU', 'Luxembourg', 'EURO', '66', '5122', '0', '111');
INSERT INTO public.who_global_data_import VALUES (48998, '2020-07-18', 'LU', 'Luxembourg', 'EURO', '163', '5285', '0', '111');
INSERT INTO public.who_global_data_import VALUES (48999, '2020-07-19', 'LU', 'Luxembourg', 'EURO', '124', '5409', '0', '111');
INSERT INTO public.who_global_data_import VALUES (49000, '2020-07-20', 'LU', 'Luxembourg', 'EURO', '74', '5483', '0', '111');
INSERT INTO public.who_global_data_import VALUES (49001, '2020-07-21', 'LU', 'Luxembourg', 'EURO', '122', '5605', '0', '111');
INSERT INTO public.who_global_data_import VALUES (49002, '2020-07-22', 'LU', 'Luxembourg', 'EURO', '120', '5725', '0', '111');
INSERT INTO public.who_global_data_import VALUES (49003, '2020-07-23', 'LU', 'Luxembourg', 'EURO', '129', '5854', '0', '111');
INSERT INTO public.who_global_data_import VALUES (49004, '2020-07-24', 'LU', 'Luxembourg', 'EURO', '98', '5952', '1', '112');
INSERT INTO public.who_global_data_import VALUES (49005, '2020-07-25', 'LU', 'Luxembourg', 'EURO', '104', '6056', '0', '112');
INSERT INTO public.who_global_data_import VALUES (49006, '2020-07-26', 'LU', 'Luxembourg', 'EURO', '133', '6189', '0', '112');
INSERT INTO public.who_global_data_import VALUES (49007, '2020-07-27', 'LU', 'Luxembourg', 'EURO', '83', '6272', '0', '112');
INSERT INTO public.who_global_data_import VALUES (49008, '2020-07-28', 'LU', 'Luxembourg', 'EURO', '49', '6321', '0', '112');
INSERT INTO public.who_global_data_import VALUES (49009, '2020-07-29', 'LU', 'Luxembourg', 'EURO', '54', '6375', '1', '113');
INSERT INTO public.who_global_data_import VALUES (49010, '2020-07-30', 'LU', 'Luxembourg', 'EURO', '158', '6533', '1', '114');
INSERT INTO public.who_global_data_import VALUES (49011, '2020-07-31', 'LU', 'Luxembourg', 'EURO', '83', '6616', '0', '114');
INSERT INTO public.who_global_data_import VALUES (49012, '2020-08-01', 'LU', 'Luxembourg', 'EURO', '79', '6695', '0', '114');
INSERT INTO public.who_global_data_import VALUES (49013, '2020-08-02', 'LU', 'Luxembourg', 'EURO', '0', '6695', '0', '114');
INSERT INTO public.who_global_data_import VALUES (49014, '2020-08-03', 'LU', 'Luxembourg', 'EURO', '0', '6695', '3', '117');
INSERT INTO public.who_global_data_import VALUES (49015, '2020-08-04', 'LU', 'Luxembourg', 'EURO', '169', '6864', '1', '118');
INSERT INTO public.who_global_data_import VALUES (49016, '2020-08-05', 'LU', 'Luxembourg', 'EURO', '53', '6917', '0', '118');
INSERT INTO public.who_global_data_import VALUES (49017, '2020-08-06', 'LU', 'Luxembourg', 'EURO', '90', '7007', '0', '118');
INSERT INTO public.who_global_data_import VALUES (49018, '2020-08-07', 'LU', 'Luxembourg', 'EURO', '66', '7073', '1', '119');
INSERT INTO public.who_global_data_import VALUES (49019, '2020-08-08', 'LU', 'Luxembourg', 'EURO', '40', '7113', '0', '119');
INSERT INTO public.who_global_data_import VALUES (49020, '2020-08-09', 'LU', 'Luxembourg', 'EURO', '0', '7113', '0', '119');
INSERT INTO public.who_global_data_import VALUES (49021, '2020-08-10', 'LU', 'Luxembourg', 'EURO', '0', '7113', '0', '119');
INSERT INTO public.who_global_data_import VALUES (49022, '2020-08-11', 'LU', 'Luxembourg', 'EURO', '103', '7216', '2', '121');
INSERT INTO public.who_global_data_import VALUES (49023, '2020-08-12', 'LU', 'Luxembourg', 'EURO', '26', '7242', '1', '122');
INSERT INTO public.who_global_data_import VALUES (49024, '2020-08-13', 'LU', 'Luxembourg', 'EURO', '58', '7300', '0', '122');
INSERT INTO public.who_global_data_import VALUES (49025, '2020-08-14', 'LU', 'Luxembourg', 'EURO', '68', '7368', '0', '122');
INSERT INTO public.who_global_data_import VALUES (49026, '2020-08-15', 'LU', 'Luxembourg', 'EURO', '37', '7405', '0', '122');
INSERT INTO public.who_global_data_import VALUES (49027, '2020-08-16', 'LU', 'Luxembourg', 'EURO', '34', '7439', '1', '123');
INSERT INTO public.who_global_data_import VALUES (49028, '2020-08-17', 'LU', 'Luxembourg', 'EURO', '0', '7439', '0', '123');
INSERT INTO public.who_global_data_import VALUES (49029, '2020-08-18', 'LU', 'Luxembourg', 'EURO', '30', '7469', '1', '124');
INSERT INTO public.who_global_data_import VALUES (49030, '2020-08-19', 'LU', 'Luxembourg', 'EURO', '30', '7499', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49031, '2020-08-20', 'LU', 'Luxembourg', 'EURO', '67', '7566', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49032, '2020-08-21', 'LU', 'Luxembourg', 'EURO', '71', '7637', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49033, '2020-08-22', 'LU', 'Luxembourg', 'EURO', '67', '7704', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49034, '2020-08-23', 'LU', 'Luxembourg', 'EURO', '0', '7704', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49035, '2020-08-24', 'LU', 'Luxembourg', 'EURO', '0', '7704', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49036, '2020-08-25', 'LU', 'Luxembourg', 'EURO', '90', '7794', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49037, '2020-08-26', 'LU', 'Luxembourg', 'EURO', '44', '7838', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49038, '2020-08-27', 'LU', 'Luxembourg', 'EURO', '90', '7928', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49039, '2020-08-28', 'LU', 'Luxembourg', 'EURO', '-1385', '6543', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49040, '2020-08-29', 'LU', 'Luxembourg', 'EURO', '37', '6580', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49041, '2020-08-30', 'LU', 'Luxembourg', 'EURO', '0', '6580', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49042, '2020-08-31', 'LU', 'Luxembourg', 'EURO', '45', '6625', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49043, '2020-09-01', 'LU', 'Luxembourg', 'EURO', '52', '6677', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49044, '2020-09-02', 'LU', 'Luxembourg', 'EURO', '0', '6677', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49045, '2020-09-03', 'LU', 'Luxembourg', 'EURO', '68', '6745', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49046, '2020-09-04', 'LU', 'Luxembourg', 'EURO', '0', '6745', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49047, '2020-09-05', 'LU', 'Luxembourg', 'EURO', '109', '6854', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49048, '2020-09-06', 'LU', 'Luxembourg', 'EURO', '0', '6854', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49049, '2020-09-07', 'LU', 'Luxembourg', 'EURO', '42', '6896', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49050, '2020-09-08', 'LU', 'Luxembourg', 'EURO', '54', '6950', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49051, '2020-09-09', 'LU', 'Luxembourg', 'EURO', '24', '6974', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49052, '2020-09-10', 'LU', 'Luxembourg', 'EURO', '49', '7023', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49053, '2020-09-11', 'LU', 'Luxembourg', 'EURO', '65', '7088', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49054, '2020-09-12', 'LU', 'Luxembourg', 'EURO', '71', '7159', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49055, '2020-09-13', 'LU', 'Luxembourg', 'EURO', '0', '7159', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49056, '2020-09-14', 'LU', 'Luxembourg', 'EURO', '35', '7194', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49057, '2020-09-15', 'LU', 'Luxembourg', 'EURO', '50', '7244', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49058, '2020-09-16', 'LU', 'Luxembourg', 'EURO', '40', '7284', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49059, '2020-09-17', 'LU', 'Luxembourg', 'EURO', '110', '7394', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49060, '2020-09-18', 'LU', 'Luxembourg', 'EURO', '147', '7541', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49061, '2020-09-19', 'LU', 'Luxembourg', 'EURO', '177', '7718', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49062, '2020-09-20', 'LU', 'Luxembourg', 'EURO', '0', '7718', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49063, '2020-09-21', 'LU', 'Luxembourg', 'EURO', '86', '7804', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49064, '2020-09-22', 'LU', 'Luxembourg', 'EURO', '112', '7916', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49065, '2020-09-23', 'LU', 'Luxembourg', 'EURO', '100', '8016', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49066, '2020-09-24', 'LU', 'Luxembourg', 'EURO', '74', '8090', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49067, '2020-09-25', 'LU', 'Luxembourg', 'EURO', '68', '8158', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49068, '2020-09-26', 'LU', 'Luxembourg', 'EURO', '75', '8233', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49069, '2020-09-27', 'LU', 'Luxembourg', 'EURO', '78', '8311', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49070, '2020-09-28', 'LU', 'Luxembourg', 'EURO', '46', '8357', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49071, '2020-09-29', 'LU', 'Luxembourg', 'EURO', '19', '8376', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49072, '2020-09-30', 'LU', 'Luxembourg', 'EURO', '55', '8431', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49073, '2020-10-01', 'LU', 'Luxembourg', 'EURO', '78', '8509', '0', '124');
INSERT INTO public.who_global_data_import VALUES (49074, '2020-10-02', 'LU', 'Luxembourg', 'EURO', '86', '8595', '1', '125');
INSERT INTO public.who_global_data_import VALUES (49075, '2020-10-03', 'LU', 'Luxembourg', 'EURO', '114', '8709', '0', '125');
INSERT INTO public.who_global_data_import VALUES (49076, '2020-10-04', 'LU', 'Luxembourg', 'EURO', '0', '8709', '0', '125');
INSERT INTO public.who_global_data_import VALUES (49077, '2020-10-05', 'LU', 'Luxembourg', 'EURO', '0', '8709', '0', '125');
INSERT INTO public.who_global_data_import VALUES (49078, '2020-10-06', 'LU', 'Luxembourg', 'EURO', '216', '8925', '2', '127');
INSERT INTO public.who_global_data_import VALUES (49079, '2020-10-07', 'LU', 'Luxembourg', 'EURO', '54', '8979', '1', '128');
INSERT INTO public.who_global_data_import VALUES (49080, '2020-10-08', 'LU', 'Luxembourg', 'EURO', '140', '9119', '0', '128');
INSERT INTO public.who_global_data_import VALUES (49081, '2020-10-09', 'LU', 'Luxembourg', 'EURO', '100', '9219', '1', '129');
INSERT INTO public.who_global_data_import VALUES (49082, '2020-10-10', 'LU', 'Luxembourg', 'EURO', '141', '9360', '1', '130');
INSERT INTO public.who_global_data_import VALUES (49083, '2020-10-11', 'LU', 'Luxembourg', 'EURO', '0', '9360', '0', '130');
INSERT INTO public.who_global_data_import VALUES (49084, '2020-10-12', 'LU', 'Luxembourg', 'EURO', '0', '9360', '0', '130');
INSERT INTO public.who_global_data_import VALUES (49085, '2020-10-13', 'LU', 'Luxembourg', 'EURO', '371', '9731', '3', '133');
INSERT INTO public.who_global_data_import VALUES (49086, '2020-10-14', 'LU', 'Luxembourg', 'EURO', '109', '9840', '0', '133');
INSERT INTO public.who_global_data_import VALUES (49087, '2020-10-15', 'LU', 'Luxembourg', 'EURO', '190', '10030', '0', '133');
INSERT INTO public.who_global_data_import VALUES (49088, '2020-10-16', 'LU', 'Luxembourg', 'EURO', '214', '10244', '0', '133');
INSERT INTO public.who_global_data_import VALUES (49089, '2020-10-17', 'LU', 'Luxembourg', 'EURO', '227', '10471', '0', '133');
INSERT INTO public.who_global_data_import VALUES (49090, '2020-10-18', 'LU', 'Luxembourg', 'EURO', '0', '10471', '0', '133');
INSERT INTO public.who_global_data_import VALUES (49091, '2020-10-19', 'LU', 'Luxembourg', 'EURO', '175', '10646', '0', '133');
INSERT INTO public.who_global_data_import VALUES (49092, '2020-10-20', 'LU', 'Luxembourg', 'EURO', '242', '10888', '0', '133');
INSERT INTO public.who_global_data_import VALUES (49093, '2020-10-21', 'LU', 'Luxembourg', 'EURO', '353', '11241', '3', '136');
INSERT INTO public.who_global_data_import VALUES (49094, '2020-10-22', 'LU', 'Luxembourg', 'EURO', '430', '11671', '2', '138');
INSERT INTO public.who_global_data_import VALUES (49095, '2020-10-23', 'LU', 'Luxembourg', 'EURO', '662', '12333', '2', '140');
INSERT INTO public.who_global_data_import VALUES (49096, '2020-10-24', 'LU', 'Luxembourg', 'EURO', '518', '12851', '1', '141');
INSERT INTO public.who_global_data_import VALUES (49097, '2020-10-25', 'LU', 'Luxembourg', 'EURO', '862', '13713', '3', '144');
INSERT INTO public.who_global_data_import VALUES (49098, '2020-10-26', 'LU', 'Luxembourg', 'EURO', '491', '14204', '1', '145');
INSERT INTO public.who_global_data_import VALUES (49099, '2020-10-27', 'LU', 'Luxembourg', 'EURO', '195', '14399', '2', '147');
INSERT INTO public.who_global_data_import VALUES (49100, '2020-10-28', 'LU', 'Luxembourg', 'EURO', '485', '14884', '0', '147');
INSERT INTO public.who_global_data_import VALUES (49101, '2020-10-29', 'LU', 'Luxembourg', 'EURO', '774', '15658', '0', '147');
INSERT INTO public.who_global_data_import VALUES (49102, '2020-10-30', 'LU', 'Luxembourg', 'EURO', '698', '16356', '3', '150');
INSERT INTO public.who_global_data_import VALUES (49103, '2020-10-31', 'LU', 'Luxembourg', 'EURO', '778', '17134', '2', '152');
INSERT INTO public.who_global_data_import VALUES (49104, '2020-11-01', 'LU', 'Luxembourg', 'EURO', '799', '17933', '5', '157');
INSERT INTO public.who_global_data_import VALUES (49105, '2020-11-02', 'LU', 'Luxembourg', 'EURO', '849', '18782', '3', '160');
INSERT INTO public.who_global_data_import VALUES (49106, '2020-11-03', 'LU', 'Luxembourg', 'EURO', '319', '19101', '0', '160');
INSERT INTO public.who_global_data_import VALUES (49107, '2020-11-04', 'LU', 'Luxembourg', 'EURO', '533', '19634', '7', '167');
INSERT INTO public.who_global_data_import VALUES (49108, '2020-11-05', 'LU', 'Luxembourg', 'EURO', '710', '20344', '4', '171');
INSERT INTO public.who_global_data_import VALUES (49109, '2020-11-06', 'LU', 'Luxembourg', 'EURO', '803', '21147', '6', '177');
INSERT INTO public.who_global_data_import VALUES (49110, '2020-11-07', 'LU', 'Luxembourg', 'EURO', '659', '21806', '3', '180');
INSERT INTO public.who_global_data_import VALUES (49111, '2020-11-08', 'LU', 'Luxembourg', 'EURO', '675', '22481', '5', '185');
INSERT INTO public.who_global_data_import VALUES (49112, '2020-11-09', 'LU', 'Luxembourg', 'EURO', '0', '22481', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49113, '2020-11-10', 'LU', 'Luxembourg', 'EURO', '570', '23051', '3', '188');
INSERT INTO public.who_global_data_import VALUES (49114, '2020-11-11', 'LU', 'Luxembourg', 'EURO', '176', '23227', '5', '193');
INSERT INTO public.who_global_data_import VALUES (49115, '2020-11-12', 'LU', 'Luxembourg', 'EURO', '483', '23710', '5', '198');
INSERT INTO public.who_global_data_import VALUES (49116, '2020-11-13', 'LU', 'Luxembourg', 'EURO', '795', '24505', '8', '206');
INSERT INTO public.who_global_data_import VALUES (49117, '2020-11-14', 'LU', 'Luxembourg', 'EURO', '713', '25218', '5', '211');
INSERT INTO public.who_global_data_import VALUES (49118, '2020-11-15', 'LU', 'Luxembourg', 'EURO', '713', '25931', '8', '219');
INSERT INTO public.who_global_data_import VALUES (49119, '2020-11-16', 'LU', 'Luxembourg', 'EURO', '613', '26544', '3', '222');
INSERT INTO public.who_global_data_import VALUES (49120, '2020-11-17', 'LU', 'Luxembourg', 'EURO', '548', '27092', '4', '226');
INSERT INTO public.who_global_data_import VALUES (49121, '2020-11-18', 'LU', 'Luxembourg', 'EURO', '164', '27256', '10', '236');
INSERT INTO public.who_global_data_import VALUES (49122, '2020-11-19', 'LU', 'Luxembourg', 'EURO', '425', '27681', '4', '240');
INSERT INTO public.who_global_data_import VALUES (49123, '2020-11-20', 'LU', 'Luxembourg', 'EURO', '892', '28573', '8', '248');
INSERT INTO public.who_global_data_import VALUES (49124, '2020-11-21', 'LU', 'Luxembourg', 'EURO', '670', '29243', '6', '254');
INSERT INTO public.who_global_data_import VALUES (49125, '2020-11-22', 'LU', 'Luxembourg', 'EURO', '519', '29762', '6', '260');
INSERT INTO public.who_global_data_import VALUES (49126, '2020-11-23', 'LU', 'Luxembourg', 'EURO', '571', '30333', '2', '262');
INSERT INTO public.who_global_data_import VALUES (49127, '2020-11-24', 'LU', 'Luxembourg', 'EURO', '602', '30935', '4', '266');
INSERT INTO public.who_global_data_import VALUES (49128, '2020-11-25', 'LU', 'Luxembourg', 'EURO', '176', '31111', '7', '273');
INSERT INTO public.who_global_data_import VALUES (49129, '2020-11-26', 'LU', 'Luxembourg', 'EURO', '373', '31484', '10', '283');
INSERT INTO public.who_global_data_import VALUES (49130, '2020-11-27', 'LU', 'Luxembourg', 'EURO', '616', '32100', '5', '288');
INSERT INTO public.who_global_data_import VALUES (49131, '2020-11-28', 'LU', 'Luxembourg', 'EURO', '1309', '33409', '12', '300');
INSERT INTO public.who_global_data_import VALUES (49132, '2020-11-29', 'LU', 'Luxembourg', 'EURO', '0', '33409', '0', '300');
INSERT INTO public.who_global_data_import VALUES (49133, '2020-11-30', 'LU', 'Luxembourg', 'EURO', '564', '33973', '6', '306');
INSERT INTO public.who_global_data_import VALUES (49134, '2020-12-01', 'LU', 'Luxembourg', 'EURO', '565', '34538', '6', '312');
INSERT INTO public.who_global_data_import VALUES (49135, '2020-12-02', 'LU', 'Luxembourg', 'EURO', '140', '34678', '9', '321');
INSERT INTO public.who_global_data_import VALUES (49136, '2020-12-03', 'LU', 'Luxembourg', 'EURO', '451', '35129', '9', '330');
INSERT INTO public.who_global_data_import VALUES (49662, '2020-03-04', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49137, '2020-12-04', 'LU', 'Luxembourg', 'EURO', '673', '35802', '4', '334');
INSERT INTO public.who_global_data_import VALUES (49138, '2020-12-05', 'LU', 'Luxembourg', 'EURO', '627', '36429', '5', '339');
INSERT INTO public.who_global_data_import VALUES (49139, '2020-12-06', 'LU', 'Luxembourg', 'EURO', '588', '37017', '6', '345');
INSERT INTO public.who_global_data_import VALUES (49140, '2020-12-07', 'LU', 'Luxembourg', 'EURO', '667', '37684', '5', '350');
INSERT INTO public.who_global_data_import VALUES (49141, '2020-12-08', 'LU', 'Luxembourg', 'EURO', '531', '38215', '3', '353');
INSERT INTO public.who_global_data_import VALUES (49142, '2020-12-09', 'LU', 'Luxembourg', 'EURO', '261', '38476', '7', '360');
INSERT INTO public.who_global_data_import VALUES (49143, '2020-12-10', 'LU', 'Luxembourg', 'EURO', '388', '38864', '9', '369');
INSERT INTO public.who_global_data_import VALUES (49144, '2020-12-11', 'LU', 'Luxembourg', 'EURO', '1173', '40037', '15', '384');
INSERT INTO public.who_global_data_import VALUES (49145, '2020-12-12', 'LU', 'Luxembourg', 'EURO', '718', '40755', '8', '392');
INSERT INTO public.who_global_data_import VALUES (49146, '2020-12-13', 'LU', 'Luxembourg', 'EURO', '517', '41272', '4', '396');
INSERT INTO public.who_global_data_import VALUES (49147, '2020-12-14', 'LU', 'Luxembourg', 'EURO', '446', '41718', '6', '402');
INSERT INTO public.who_global_data_import VALUES (49148, '2020-12-15', 'LU', 'Luxembourg', 'EURO', '182', '41900', '8', '410');
INSERT INTO public.who_global_data_import VALUES (49149, '2020-12-16', 'LU', 'Luxembourg', 'EURO', '349', '42249', '8', '418');
INSERT INTO public.who_global_data_import VALUES (49150, '2020-12-17', 'LU', 'Luxembourg', 'EURO', '595', '42844', '3', '421');
INSERT INTO public.who_global_data_import VALUES (49151, '2020-12-18', 'LU', 'Luxembourg', 'EURO', '434', '43278', '7', '428');
INSERT INTO public.who_global_data_import VALUES (49152, '2020-12-19', 'LU', 'Luxembourg', 'EURO', '449', '43727', '6', '434');
INSERT INTO public.who_global_data_import VALUES (49153, '2020-12-20', 'LU', 'Luxembourg', 'EURO', '340', '44067', '6', '440');
INSERT INTO public.who_global_data_import VALUES (49154, '2020-12-21', 'LU', 'Luxembourg', 'EURO', '424', '44491', '4', '444');
INSERT INTO public.who_global_data_import VALUES (49155, '2020-12-22', 'LU', 'Luxembourg', 'EURO', '91', '44582', '6', '450');
INSERT INTO public.who_global_data_import VALUES (49156, '2020-12-23', 'LU', 'Luxembourg', 'EURO', '227', '44809', '3', '453');
INSERT INTO public.who_global_data_import VALUES (49157, '2020-12-24', 'LU', 'Luxembourg', 'EURO', '400', '45209', '5', '458');
INSERT INTO public.who_global_data_import VALUES (49158, '2020-12-25', 'LU', 'Luxembourg', 'EURO', '262', '45471', '3', '461');
INSERT INTO public.who_global_data_import VALUES (49159, '2020-12-26', 'LU', 'Luxembourg', 'EURO', '253', '45724', '4', '465');
INSERT INTO public.who_global_data_import VALUES (49160, '2020-12-27', 'LU', 'Luxembourg', 'EURO', '52', '45776', '5', '470');
INSERT INTO public.who_global_data_import VALUES (49161, '2020-12-28', 'LU', 'Luxembourg', 'EURO', '54', '45830', '8', '478');
INSERT INTO public.who_global_data_import VALUES (49162, '2020-12-29', 'LU', 'Luxembourg', 'EURO', '16', '45846', '9', '487');
INSERT INTO public.who_global_data_import VALUES (49163, '2020-12-30', 'LU', 'Luxembourg', 'EURO', '239', '46085', '2', '489');
INSERT INTO public.who_global_data_import VALUES (49164, '2020-12-31', 'LU', 'Luxembourg', 'EURO', '326', '46411', '6', '495');
INSERT INTO public.who_global_data_import VALUES (49165, '2021-01-01', 'LU', 'Luxembourg', 'EURO', '187', '46598', '3', '498');
INSERT INTO public.who_global_data_import VALUES (49166, '2021-01-02', 'LU', 'Luxembourg', 'EURO', '215', '46813', '3', '501');
INSERT INTO public.who_global_data_import VALUES (49167, '2021-01-03', 'LU', 'Luxembourg', 'EURO', '25', '46838', '2', '503');
INSERT INTO public.who_global_data_import VALUES (49168, '2021-01-04', 'LU', 'Luxembourg', 'EURO', '81', '46919', '3', '506');
INSERT INTO public.who_global_data_import VALUES (49169, '2021-01-05', 'LU', 'Luxembourg', 'EURO', '66', '46985', '2', '508');
INSERT INTO public.who_global_data_import VALUES (49170, '2021-01-06', 'LU', 'Luxembourg', 'EURO', '163', '47148', '6', '514');
INSERT INTO public.who_global_data_import VALUES (49171, '2021-01-07', 'LU', 'Luxembourg', 'EURO', '282', '47430', '3', '517');
INSERT INTO public.who_global_data_import VALUES (49172, '2021-01-08', 'LU', 'Luxembourg', 'EURO', '161', '47591', '4', '521');
INSERT INTO public.who_global_data_import VALUES (49173, '2021-01-09', 'LU', 'Luxembourg', 'EURO', '149', '47740', '6', '527');
INSERT INTO public.who_global_data_import VALUES (49174, '2021-01-10', 'LU', 'Luxembourg', 'EURO', '136', '47876', '3', '530');
INSERT INTO public.who_global_data_import VALUES (49175, '2021-01-11', 'LU', 'Luxembourg', 'EURO', '104', '47980', '3', '533');
INSERT INTO public.who_global_data_import VALUES (49176, '2021-01-12', 'LU', 'Luxembourg', 'EURO', '42', '48022', '2', '535');
INSERT INTO public.who_global_data_import VALUES (49177, '2021-01-13', 'LU', 'Luxembourg', 'EURO', '153', '48175', '3', '538');
INSERT INTO public.who_global_data_import VALUES (49178, '2021-01-14', 'LU', 'Luxembourg', 'EURO', '190', '48365', '4', '542');
INSERT INTO public.who_global_data_import VALUES (49179, '2021-01-15', 'LU', 'Luxembourg', 'EURO', '114', '48479', '3', '545');
INSERT INTO public.who_global_data_import VALUES (49180, '2021-01-16', 'LU', 'Luxembourg', 'EURO', '143', '48622', '4', '549');
INSERT INTO public.who_global_data_import VALUES (49181, '2021-01-17', 'LU', 'Luxembourg', 'EURO', '135', '48757', '3', '552');
INSERT INTO public.who_global_data_import VALUES (49182, '2021-01-18', 'LU', 'Luxembourg', 'EURO', '87', '48844', '0', '552');
INSERT INTO public.who_global_data_import VALUES (49183, '2021-01-19', 'LU', 'Luxembourg', 'EURO', '37', '48881', '5', '557');
INSERT INTO public.who_global_data_import VALUES (49184, '2021-01-20', 'LU', 'Luxembourg', 'EURO', '85', '48966', '3', '560');
INSERT INTO public.who_global_data_import VALUES (49185, '2021-01-21', 'LU', 'Luxembourg', 'EURO', '238', '49204', '2', '562');
INSERT INTO public.who_global_data_import VALUES (49186, '2021-01-22', 'LU', 'Luxembourg', 'EURO', '115', '49319', '0', '562');
INSERT INTO public.who_global_data_import VALUES (49187, '2021-01-23', 'LU', 'Luxembourg', 'EURO', '119', '49438', '0', '562');
INSERT INTO public.who_global_data_import VALUES (49188, '2021-01-24', 'LU', 'Luxembourg', 'EURO', '143', '49581', '2', '564');
INSERT INTO public.who_global_data_import VALUES (49189, '2021-01-25', 'LU', 'Luxembourg', 'EURO', '123', '49704', '0', '564');
INSERT INTO public.who_global_data_import VALUES (49190, '2021-01-26', 'LU', 'Luxembourg', 'EURO', '29', '49733', '2', '566');
INSERT INTO public.who_global_data_import VALUES (49191, '2021-01-27', 'LU', 'Luxembourg', 'EURO', '119', '49852', '4', '570');
INSERT INTO public.who_global_data_import VALUES (49192, '2021-01-28', 'LU', 'Luxembourg', 'EURO', '237', '50089', '1', '571');
INSERT INTO public.who_global_data_import VALUES (49193, '2021-01-29', 'LU', 'Luxembourg', 'EURO', '139', '50228', '3', '574');
INSERT INTO public.who_global_data_import VALUES (49194, '2021-01-30', 'LU', 'Luxembourg', 'EURO', '160', '50388', '3', '577');
INSERT INTO public.who_global_data_import VALUES (49195, '2021-01-31', 'LU', 'Luxembourg', 'EURO', '159', '50547', '2', '579');
INSERT INTO public.who_global_data_import VALUES (49196, '2021-02-01', 'LU', 'Luxembourg', 'EURO', '152', '50699', '1', '580');
INSERT INTO public.who_global_data_import VALUES (49197, '2021-02-02', 'LU', 'Luxembourg', 'EURO', '34', '50733', '4', '584');
INSERT INTO public.who_global_data_import VALUES (49198, '2021-02-03', 'LU', 'Luxembourg', 'EURO', '190', '50923', '2', '586');
INSERT INTO public.who_global_data_import VALUES (49199, '2021-02-04', 'LU', 'Luxembourg', 'EURO', '205', '51128', '1', '587');
INSERT INTO public.who_global_data_import VALUES (49200, '2021-02-05', 'LU', 'Luxembourg', 'EURO', '202', '51330', '1', '588');
INSERT INTO public.who_global_data_import VALUES (49201, '2020-01-03', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49202, '2020-01-04', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49203, '2020-01-05', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49204, '2020-01-06', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49205, '2020-01-07', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49206, '2020-01-08', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49207, '2020-01-09', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49208, '2020-01-10', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49209, '2020-01-11', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49210, '2020-01-12', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49211, '2020-01-13', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49212, '2020-01-14', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49213, '2020-01-15', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49214, '2020-01-16', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49215, '2020-01-17', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49216, '2020-01-18', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49217, '2020-01-19', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49218, '2020-01-20', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49219, '2020-01-21', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49220, '2020-01-22', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49221, '2020-01-23', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49222, '2020-01-24', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49223, '2020-01-25', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49224, '2020-01-26', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49225, '2020-01-27', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49226, '2020-01-28', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49227, '2020-01-29', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49228, '2020-01-30', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49229, '2020-01-31', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49230, '2020-02-01', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49231, '2020-02-02', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49232, '2020-02-03', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49233, '2020-02-04', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49234, '2020-02-05', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49235, '2020-02-06', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49236, '2020-02-07', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49237, '2020-02-08', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49238, '2020-02-09', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49239, '2020-02-10', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49240, '2020-02-11', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49241, '2020-02-12', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49242, '2020-02-13', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49243, '2020-02-14', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49244, '2020-02-15', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49245, '2020-02-16', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49246, '2020-02-17', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49247, '2020-02-18', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49248, '2020-02-19', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49249, '2020-02-20', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49250, '2020-02-21', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49251, '2020-02-22', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49252, '2020-02-23', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49253, '2020-02-24', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49254, '2020-02-25', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49255, '2020-02-26', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49256, '2020-02-27', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49257, '2020-02-28', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49258, '2020-02-29', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49259, '2020-03-01', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49260, '2020-03-02', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49261, '2020-03-03', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49262, '2020-03-04', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49263, '2020-03-05', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49264, '2020-03-06', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49265, '2020-03-07', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49266, '2020-03-08', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49267, '2020-03-09', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49268, '2020-03-10', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49269, '2020-03-11', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49270, '2020-03-12', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49271, '2020-03-13', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49272, '2020-03-14', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49273, '2020-03-15', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49274, '2020-03-16', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49275, '2020-03-17', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49276, '2020-03-18', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49277, '2020-03-19', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49278, '2020-03-20', 'MG', 'Madagascar', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49279, '2020-03-21', 'MG', 'Madagascar', 'AFRO', '3', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49280, '2020-03-22', 'MG', 'Madagascar', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49281, '2020-03-23', 'MG', 'Madagascar', 'AFRO', '9', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49282, '2020-03-24', 'MG', 'Madagascar', 'AFRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49283, '2020-03-25', 'MG', 'Madagascar', 'AFRO', '6', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49284, '2020-03-26', 'MG', 'Madagascar', 'AFRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49285, '2020-03-27', 'MG', 'Madagascar', 'AFRO', '5', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49286, '2020-03-28', 'MG', 'Madagascar', 'AFRO', '2', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49287, '2020-03-29', 'MG', 'Madagascar', 'AFRO', '11', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49288, '2020-03-30', 'MG', 'Madagascar', 'AFRO', '7', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49289, '2020-03-31', 'MG', 'Madagascar', 'AFRO', '2', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49290, '2020-04-01', 'MG', 'Madagascar', 'AFRO', '7', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49291, '2020-04-02', 'MG', 'Madagascar', 'AFRO', '6', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49292, '2020-04-03', 'MG', 'Madagascar', 'AFRO', '6', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49293, '2020-04-04', 'MG', 'Madagascar', 'AFRO', '5', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49294, '2020-04-05', 'MG', 'Madagascar', 'AFRO', '0', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49295, '2020-04-06', 'MG', 'Madagascar', 'AFRO', '7', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49296, '2020-04-07', 'MG', 'Madagascar', 'AFRO', '8', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49297, '2020-04-08', 'MG', 'Madagascar', 'AFRO', '7', '92', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49298, '2020-04-09', 'MG', 'Madagascar', 'AFRO', '1', '93', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49299, '2020-04-10', 'MG', 'Madagascar', 'AFRO', '2', '95', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49300, '2020-04-11', 'MG', 'Madagascar', 'AFRO', '0', '95', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49301, '2020-04-12', 'MG', 'Madagascar', 'AFRO', '9', '104', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49302, '2020-04-13', 'MG', 'Madagascar', 'AFRO', '2', '106', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49303, '2020-04-14', 'MG', 'Madagascar', 'AFRO', '0', '106', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49304, '2020-04-15', 'MG', 'Madagascar', 'AFRO', '4', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49305, '2020-04-16', 'MG', 'Madagascar', 'AFRO', '0', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49306, '2020-04-17', 'MG', 'Madagascar', 'AFRO', '7', '117', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49307, '2020-04-18', 'MG', 'Madagascar', 'AFRO', '0', '117', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49308, '2020-04-19', 'MG', 'Madagascar', 'AFRO', '3', '120', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49309, '2020-04-20', 'MG', 'Madagascar', 'AFRO', '1', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49310, '2020-04-21', 'MG', 'Madagascar', 'AFRO', '0', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49311, '2020-04-22', 'MG', 'Madagascar', 'AFRO', '0', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49312, '2020-04-23', 'MG', 'Madagascar', 'AFRO', '0', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49313, '2020-04-24', 'MG', 'Madagascar', 'AFRO', '0', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49314, '2020-04-25', 'MG', 'Madagascar', 'AFRO', '1', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49315, '2020-04-26', 'MG', 'Madagascar', 'AFRO', '2', '124', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49316, '2020-04-27', 'MG', 'Madagascar', 'AFRO', '4', '128', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49317, '2020-04-28', 'MG', 'Madagascar', 'AFRO', '0', '128', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49318, '2020-04-29', 'MG', 'Madagascar', 'AFRO', '0', '128', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49319, '2020-04-30', 'MG', 'Madagascar', 'AFRO', '0', '128', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49320, '2020-05-01', 'MG', 'Madagascar', 'AFRO', '4', '132', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49321, '2020-05-02', 'MG', 'Madagascar', 'AFRO', '3', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49322, '2020-05-03', 'MG', 'Madagascar', 'AFRO', '14', '149', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49323, '2020-05-04', 'MG', 'Madagascar', 'AFRO', '2', '151', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49324, '2020-05-05', 'MG', 'Madagascar', 'AFRO', '7', '158', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49325, '2020-05-06', 'MG', 'Madagascar', 'AFRO', '0', '158', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49326, '2020-05-07', 'MG', 'Madagascar', 'AFRO', '35', '193', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49327, '2020-05-08', 'MG', 'Madagascar', 'AFRO', '0', '193', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49328, '2020-05-09', 'MG', 'Madagascar', 'AFRO', '-24', '169', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49329, '2020-05-10', 'MG', 'Madagascar', 'AFRO', '0', '169', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49330, '2020-05-11', 'MG', 'Madagascar', 'AFRO', '0', '169', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49331, '2020-05-12', 'MG', 'Madagascar', 'AFRO', '17', '186', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49332, '2020-05-13', 'MG', 'Madagascar', 'AFRO', '6', '192', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49333, '2020-05-14', 'MG', 'Madagascar', 'AFRO', '20', '212', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49334, '2020-05-15', 'MG', 'Madagascar', 'AFRO', '18', '230', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49335, '2020-05-16', 'MG', 'Madagascar', 'AFRO', '8', '238', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49336, '2020-05-17', 'MG', 'Madagascar', 'AFRO', '45', '283', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49337, '2020-05-18', 'MG', 'Madagascar', 'AFRO', '21', '304', '1', '1');
INSERT INTO public.who_global_data_import VALUES (49338, '2020-05-19', 'MG', 'Madagascar', 'AFRO', '18', '322', '0', '1');
INSERT INTO public.who_global_data_import VALUES (49339, '2020-05-20', 'MG', 'Madagascar', 'AFRO', '4', '326', '1', '2');
INSERT INTO public.who_global_data_import VALUES (49340, '2020-05-21', 'MG', 'Madagascar', 'AFRO', '45', '371', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49341, '2020-05-22', 'MG', 'Madagascar', 'AFRO', '34', '405', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49342, '2020-05-23', 'MG', 'Madagascar', 'AFRO', '43', '448', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49343, '2020-05-24', 'MG', 'Madagascar', 'AFRO', '40', '488', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49344, '2020-05-25', 'MG', 'Madagascar', 'AFRO', '39', '527', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49345, '2020-05-26', 'MG', 'Madagascar', 'AFRO', '15', '542', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49346, '2020-05-27', 'MG', 'Madagascar', 'AFRO', '44', '586', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49347, '2020-05-28', 'MG', 'Madagascar', 'AFRO', '26', '612', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49348, '2020-05-29', 'MG', 'Madagascar', 'AFRO', '44', '656', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49349, '2020-05-30', 'MG', 'Madagascar', 'AFRO', '42', '698', '3', '5');
INSERT INTO public.who_global_data_import VALUES (49350, '2020-05-31', 'MG', 'Madagascar', 'AFRO', '60', '758', '1', '6');
INSERT INTO public.who_global_data_import VALUES (49351, '2020-06-01', 'MG', 'Madagascar', 'AFRO', '13', '771', '0', '6');
INSERT INTO public.who_global_data_import VALUES (49352, '2020-06-02', 'MG', 'Madagascar', 'AFRO', '55', '826', '0', '6');
INSERT INTO public.who_global_data_import VALUES (49353, '2020-06-03', 'MG', 'Madagascar', 'AFRO', '19', '845', '0', '6');
INSERT INTO public.who_global_data_import VALUES (49354, '2020-06-04', 'MG', 'Madagascar', 'AFRO', '63', '908', '0', '6');
INSERT INTO public.who_global_data_import VALUES (49355, '2020-06-05', 'MG', 'Madagascar', 'AFRO', '49', '957', '1', '7');
INSERT INTO public.who_global_data_import VALUES (49356, '2020-06-06', 'MG', 'Madagascar', 'AFRO', '18', '975', '0', '7');
INSERT INTO public.who_global_data_import VALUES (49357, '2020-06-07', 'MG', 'Madagascar', 'AFRO', '51', '1026', '1', '8');
INSERT INTO public.who_global_data_import VALUES (49358, '2020-06-08', 'MG', 'Madagascar', 'AFRO', '26', '1052', '1', '9');
INSERT INTO public.who_global_data_import VALUES (49359, '2020-06-09', 'MG', 'Madagascar', 'AFRO', '42', '1094', '0', '9');
INSERT INTO public.who_global_data_import VALUES (49360, '2020-06-10', 'MG', 'Madagascar', 'AFRO', '44', '1138', '0', '9');
INSERT INTO public.who_global_data_import VALUES (49361, '2020-06-11', 'MG', 'Madagascar', 'AFRO', '24', '1162', '1', '10');
INSERT INTO public.who_global_data_import VALUES (49362, '2020-06-12', 'MG', 'Madagascar', 'AFRO', '41', '1203', '0', '10');
INSERT INTO public.who_global_data_import VALUES (49363, '2020-06-13', 'MG', 'Madagascar', 'AFRO', '27', '1230', '0', '10');
INSERT INTO public.who_global_data_import VALUES (49364, '2020-06-14', 'MG', 'Madagascar', 'AFRO', '22', '1252', '0', '10');
INSERT INTO public.who_global_data_import VALUES (49365, '2020-06-15', 'MG', 'Madagascar', 'AFRO', '20', '1272', '0', '10');
INSERT INTO public.who_global_data_import VALUES (49366, '2020-06-16', 'MG', 'Madagascar', 'AFRO', '18', '1290', '0', '10');
INSERT INTO public.who_global_data_import VALUES (49367, '2020-06-17', 'MG', 'Madagascar', 'AFRO', '27', '1317', '2', '12');
INSERT INTO public.who_global_data_import VALUES (49368, '2020-06-18', 'MG', 'Madagascar', 'AFRO', '61', '1378', '0', '12');
INSERT INTO public.who_global_data_import VALUES (49369, '2020-06-19', 'MG', 'Madagascar', 'AFRO', '25', '1403', '1', '13');
INSERT INTO public.who_global_data_import VALUES (49370, '2020-06-20', 'MG', 'Madagascar', 'AFRO', '40', '1443', '0', '13');
INSERT INTO public.who_global_data_import VALUES (49371, '2020-06-21', 'MG', 'Madagascar', 'AFRO', '60', '1503', '0', '13');
INSERT INTO public.who_global_data_import VALUES (49372, '2020-06-22', 'MG', 'Madagascar', 'AFRO', '93', '1596', '1', '14');
INSERT INTO public.who_global_data_import VALUES (49373, '2020-06-23', 'MG', 'Madagascar', 'AFRO', '44', '1640', '1', '15');
INSERT INTO public.who_global_data_import VALUES (49374, '2020-06-24', 'MG', 'Madagascar', 'AFRO', '0', '1640', '0', '15');
INSERT INTO public.who_global_data_import VALUES (49375, '2020-06-25', 'MG', 'Madagascar', 'AFRO', '147', '1787', '1', '16');
INSERT INTO public.who_global_data_import VALUES (49376, '2020-06-26', 'MG', 'Madagascar', 'AFRO', '42', '1829', '0', '16');
INSERT INTO public.who_global_data_import VALUES (49377, '2020-06-27', 'MG', 'Madagascar', 'AFRO', '0', '1829', '0', '16');
INSERT INTO public.who_global_data_import VALUES (49378, '2020-06-28', 'MG', 'Madagascar', 'AFRO', '176', '2005', '0', '16');
INSERT INTO public.who_global_data_import VALUES (49379, '2020-06-29', 'MG', 'Madagascar', 'AFRO', '73', '2078', '2', '18');
INSERT INTO public.who_global_data_import VALUES (49380, '2020-06-30', 'MG', 'Madagascar', 'AFRO', '60', '2138', '2', '20');
INSERT INTO public.who_global_data_import VALUES (49381, '2020-07-01', 'MG', 'Madagascar', 'AFRO', '76', '2214', '0', '20');
INSERT INTO public.who_global_data_import VALUES (49382, '2020-07-02', 'MG', 'Madagascar', 'AFRO', '89', '2303', '2', '22');
INSERT INTO public.who_global_data_import VALUES (49383, '2020-07-03', 'MG', 'Madagascar', 'AFRO', '100', '2403', '2', '24');
INSERT INTO public.who_global_data_import VALUES (49384, '2020-07-04', 'MG', 'Madagascar', 'AFRO', '109', '2512', '2', '26');
INSERT INTO public.who_global_data_import VALUES (49385, '2020-07-05', 'MG', 'Madagascar', 'AFRO', '216', '2728', '3', '29');
INSERT INTO public.who_global_data_import VALUES (49386, '2020-07-06', 'MG', 'Madagascar', 'AFRO', '213', '2941', '3', '32');
INSERT INTO public.who_global_data_import VALUES (49387, '2020-07-07', 'MG', 'Madagascar', 'AFRO', '309', '3250', '1', '33');
INSERT INTO public.who_global_data_import VALUES (49388, '2020-07-08', 'MG', 'Madagascar', 'AFRO', '222', '3472', '0', '33');
INSERT INTO public.who_global_data_import VALUES (49389, '2020-07-09', 'MG', 'Madagascar', 'AFRO', '101', '3573', '0', '33');
INSERT INTO public.who_global_data_import VALUES (49390, '2020-07-10', 'MG', 'Madagascar', 'AFRO', '209', '3782', '0', '33');
INSERT INTO public.who_global_data_import VALUES (49391, '2020-07-11', 'MG', 'Madagascar', 'AFRO', '361', '4143', '1', '34');
INSERT INTO public.who_global_data_import VALUES (49392, '2020-07-12', 'MG', 'Madagascar', 'AFRO', '435', '4578', '0', '34');
INSERT INTO public.who_global_data_import VALUES (49393, '2020-07-13', 'MG', 'Madagascar', 'AFRO', '289', '4867', '1', '35');
INSERT INTO public.who_global_data_import VALUES (49394, '2020-07-14', 'MG', 'Madagascar', 'AFRO', '213', '5080', '2', '37');
INSERT INTO public.who_global_data_import VALUES (49395, '2020-07-15', 'MG', 'Madagascar', 'AFRO', '263', '5343', '2', '39');
INSERT INTO public.who_global_data_import VALUES (49396, '2020-07-16', 'MG', 'Madagascar', 'AFRO', '262', '5605', '4', '43');
INSERT INTO public.who_global_data_import VALUES (49397, '2020-07-17', 'MG', 'Madagascar', 'AFRO', '484', '6089', '10', '53');
INSERT INTO public.who_global_data_import VALUES (49398, '2020-07-18', 'MG', 'Madagascar', 'AFRO', '378', '6467', '1', '54');
INSERT INTO public.who_global_data_import VALUES (49399, '2020-07-19', 'MG', 'Madagascar', 'AFRO', '382', '6849', '1', '55');
INSERT INTO public.who_global_data_import VALUES (49400, '2020-07-20', 'MG', 'Madagascar', 'AFRO', '200', '7049', '4', '59');
INSERT INTO public.who_global_data_import VALUES (49401, '2020-07-21', 'MG', 'Madagascar', 'AFRO', '104', '7153', '3', '62');
INSERT INTO public.who_global_data_import VALUES (49402, '2020-07-22', 'MG', 'Madagascar', 'AFRO', '395', '7548', '3', '65');
INSERT INTO public.who_global_data_import VALUES (49403, '2020-07-23', 'MG', 'Madagascar', 'AFRO', '614', '8162', '4', '69');
INSERT INTO public.who_global_data_import VALUES (49404, '2020-07-24', 'MG', 'Madagascar', 'AFRO', '219', '8381', '1', '70');
INSERT INTO public.who_global_data_import VALUES (49405, '2020-07-25', 'MG', 'Madagascar', 'AFRO', '360', '8741', '6', '76');
INSERT INTO public.who_global_data_import VALUES (49406, '2020-07-26', 'MG', 'Madagascar', 'AFRO', '125', '8866', '2', '78');
INSERT INTO public.who_global_data_import VALUES (49407, '2020-07-27', 'MG', 'Madagascar', 'AFRO', '429', '9295', '7', '85');
INSERT INTO public.who_global_data_import VALUES (49408, '2020-07-28', 'MG', 'Madagascar', 'AFRO', '395', '9690', '6', '91');
INSERT INTO public.who_global_data_import VALUES (49409, '2020-07-29', 'MG', 'Madagascar', 'AFRO', '414', '10104', '2', '93');
INSERT INTO public.who_global_data_import VALUES (49410, '2020-07-30', 'MG', 'Madagascar', 'AFRO', '213', '10317', '6', '99');
INSERT INTO public.who_global_data_import VALUES (49411, '2020-07-31', 'MG', 'Madagascar', 'AFRO', '431', '10748', '6', '105');
INSERT INTO public.who_global_data_import VALUES (49412, '2020-08-01', 'MG', 'Madagascar', 'AFRO', '120', '10868', '1', '106');
INSERT INTO public.who_global_data_import VALUES (49413, '2020-08-02', 'MG', 'Madagascar', 'AFRO', '405', '11273', '1', '107');
INSERT INTO public.who_global_data_import VALUES (49414, '2020-08-03', 'MG', 'Madagascar', 'AFRO', '255', '11528', '7', '114');
INSERT INTO public.who_global_data_import VALUES (49415, '2020-08-04', 'MG', 'Madagascar', 'AFRO', '132', '11660', '4', '118');
INSERT INTO public.who_global_data_import VALUES (49416, '2020-08-05', 'MG', 'Madagascar', 'AFRO', '235', '11895', '5', '123');
INSERT INTO public.who_global_data_import VALUES (49417, '2020-08-06', 'MG', 'Madagascar', 'AFRO', '327', '12222', '4', '127');
INSERT INTO public.who_global_data_import VALUES (49418, '2020-08-07', 'MG', 'Madagascar', 'AFRO', '304', '12526', '7', '134');
INSERT INTO public.who_global_data_import VALUES (49419, '2020-08-08', 'MG', 'Madagascar', 'AFRO', '182', '12708', '1', '135');
INSERT INTO public.who_global_data_import VALUES (49420, '2020-08-09', 'MG', 'Madagascar', 'AFRO', '214', '12922', '6', '141');
INSERT INTO public.who_global_data_import VALUES (49421, '2020-08-10', 'MG', 'Madagascar', 'AFRO', '164', '13086', '7', '148');
INSERT INTO public.who_global_data_import VALUES (49422, '2020-08-11', 'MG', 'Madagascar', 'AFRO', '116', '13202', '3', '151');
INSERT INTO public.who_global_data_import VALUES (49423, '2020-08-12', 'MG', 'Madagascar', 'AFRO', '115', '13317', '1', '152');
INSERT INTO public.who_global_data_import VALUES (49424, '2020-08-13', 'MG', 'Madagascar', 'AFRO', '80', '13397', '4', '156');
INSERT INTO public.who_global_data_import VALUES (49425, '2020-08-14', 'MG', 'Madagascar', 'AFRO', '125', '13522', '6', '162');
INSERT INTO public.who_global_data_import VALUES (49426, '2020-08-15', 'MG', 'Madagascar', 'AFRO', '121', '13643', '2', '164');
INSERT INTO public.who_global_data_import VALUES (49427, '2020-08-16', 'MG', 'Madagascar', 'AFRO', '81', '13724', '2', '166');
INSERT INTO public.who_global_data_import VALUES (49428, '2020-08-17', 'MG', 'Madagascar', 'AFRO', '103', '13827', '4', '170');
INSERT INTO public.who_global_data_import VALUES (49429, '2020-08-18', 'MG', 'Madagascar', 'AFRO', '59', '13886', '1', '171');
INSERT INTO public.who_global_data_import VALUES (49430, '2020-08-19', 'MG', 'Madagascar', 'AFRO', '123', '14009', '2', '173');
INSERT INTO public.who_global_data_import VALUES (49431, '2020-08-20', 'MG', 'Madagascar', 'AFRO', '65', '14074', '0', '173');
INSERT INTO public.who_global_data_import VALUES (49432, '2020-08-21', 'MG', 'Madagascar', 'AFRO', '80', '14154', '4', '177');
INSERT INTO public.who_global_data_import VALUES (49433, '2020-08-22', 'MG', 'Madagascar', 'AFRO', '64', '14218', '1', '178');
INSERT INTO public.who_global_data_import VALUES (49434, '2020-08-23', 'MG', 'Madagascar', 'AFRO', '59', '14277', '0', '178');
INSERT INTO public.who_global_data_import VALUES (49435, '2020-08-24', 'MG', 'Madagascar', 'AFRO', '50', '14327', '0', '178');
INSERT INTO public.who_global_data_import VALUES (49436, '2020-08-25', 'MG', 'Madagascar', 'AFRO', '75', '14402', '0', '178');
INSERT INTO public.who_global_data_import VALUES (49437, '2020-08-26', 'MG', 'Madagascar', 'AFRO', '73', '14475', '0', '178');
INSERT INTO public.who_global_data_import VALUES (49438, '2020-08-27', 'MG', 'Madagascar', 'AFRO', '79', '14554', '3', '181');
INSERT INTO public.who_global_data_import VALUES (49439, '2020-08-28', 'MG', 'Madagascar', 'AFRO', '38', '14592', '3', '184');
INSERT INTO public.who_global_data_import VALUES (49440, '2020-08-29', 'MG', 'Madagascar', 'AFRO', '104', '14696', '3', '187');
INSERT INTO public.who_global_data_import VALUES (49441, '2020-08-30', 'MG', 'Madagascar', 'AFRO', '95', '14791', '3', '190');
INSERT INTO public.who_global_data_import VALUES (49442, '2020-08-31', 'MG', 'Madagascar', 'AFRO', '52', '14843', '1', '191');
INSERT INTO public.who_global_data_import VALUES (49443, '2020-09-01', 'MG', 'Madagascar', 'AFRO', '20', '14863', '1', '192');
INSERT INTO public.who_global_data_import VALUES (49444, '2020-09-02', 'MG', 'Madagascar', 'AFRO', '94', '14957', '3', '195');
INSERT INTO public.who_global_data_import VALUES (49445, '2020-09-03', 'MG', 'Madagascar', 'AFRO', '66', '15023', '1', '196');
INSERT INTO public.who_global_data_import VALUES (49446, '2020-09-04', 'MG', 'Madagascar', 'AFRO', '83', '15106', '1', '197');
INSERT INTO public.who_global_data_import VALUES (49447, '2020-09-05', 'MG', 'Madagascar', 'AFRO', '81', '15187', '1', '198');
INSERT INTO public.who_global_data_import VALUES (49448, '2020-09-06', 'MG', 'Madagascar', 'AFRO', '82', '15269', '1', '199');
INSERT INTO public.who_global_data_import VALUES (49449, '2020-09-07', 'MG', 'Madagascar', 'AFRO', '50', '15319', '1', '200');
INSERT INTO public.who_global_data_import VALUES (49450, '2020-09-08', 'MG', 'Madagascar', 'AFRO', '33', '15352', '2', '202');
INSERT INTO public.who_global_data_import VALUES (49451, '2020-09-09', 'MG', 'Madagascar', 'AFRO', '83', '15435', '4', '206');
INSERT INTO public.who_global_data_import VALUES (49452, '2020-09-10', 'MG', 'Madagascar', 'AFRO', '85', '15520', '0', '206');
INSERT INTO public.who_global_data_import VALUES (49453, '2020-09-11', 'MG', 'Madagascar', 'AFRO', '0', '15520', '0', '206');
INSERT INTO public.who_global_data_import VALUES (49454, '2020-09-12', 'MG', 'Madagascar', 'AFRO', '149', '15669', '3', '209');
INSERT INTO public.who_global_data_import VALUES (49455, '2020-09-13', 'MG', 'Madagascar', 'AFRO', '68', '15737', '1', '210');
INSERT INTO public.who_global_data_import VALUES (49456, '2020-09-14', 'MG', 'Madagascar', 'AFRO', '20', '15757', '1', '211');
INSERT INTO public.who_global_data_import VALUES (49457, '2020-09-15', 'MG', 'Madagascar', 'AFRO', '12', '15769', '2', '213');
INSERT INTO public.who_global_data_import VALUES (49458, '2020-09-16', 'MG', 'Madagascar', 'AFRO', '34', '15803', '1', '214');
INSERT INTO public.who_global_data_import VALUES (49459, '2020-09-17', 'MG', 'Madagascar', 'AFRO', '68', '15871', '1', '215');
INSERT INTO public.who_global_data_import VALUES (49460, '2020-09-18', 'MG', 'Madagascar', 'AFRO', '54', '15925', '1', '216');
INSERT INTO public.who_global_data_import VALUES (49461, '2020-09-19', 'MG', 'Madagascar', 'AFRO', '46', '15971', '1', '217');
INSERT INTO public.who_global_data_import VALUES (49462, '2020-09-20', 'MG', 'Madagascar', 'AFRO', '49', '16020', '2', '219');
INSERT INTO public.who_global_data_import VALUES (49463, '2020-09-21', 'MG', 'Madagascar', 'AFRO', '33', '16053', '4', '223');
INSERT INTO public.who_global_data_import VALUES (49464, '2020-09-22', 'MG', 'Madagascar', 'AFRO', '20', '16073', '2', '225');
INSERT INTO public.who_global_data_import VALUES (49465, '2020-09-23', 'MG', 'Madagascar', 'AFRO', '63', '16136', '1', '226');
INSERT INTO public.who_global_data_import VALUES (49466, '2020-09-24', 'MG', 'Madagascar', 'AFRO', '31', '16167', '0', '226');
INSERT INTO public.who_global_data_import VALUES (49467, '2020-09-25', 'MG', 'Madagascar', 'AFRO', '24', '16191', '1', '227');
INSERT INTO public.who_global_data_import VALUES (49468, '2020-09-26', 'MG', 'Madagascar', 'AFRO', '30', '16221', '1', '228');
INSERT INTO public.who_global_data_import VALUES (49469, '2020-09-27', 'MG', 'Madagascar', 'AFRO', '36', '16257', '1', '229');
INSERT INTO public.who_global_data_import VALUES (49470, '2020-09-28', 'MG', 'Madagascar', 'AFRO', '28', '16285', '0', '229');
INSERT INTO public.who_global_data_import VALUES (49471, '2020-09-29', 'MG', 'Madagascar', 'AFRO', '63', '16348', '0', '229');
INSERT INTO public.who_global_data_import VALUES (49472, '2020-09-30', 'MG', 'Madagascar', 'AFRO', '29', '16377', '0', '229');
INSERT INTO public.who_global_data_import VALUES (49473, '2020-10-01', 'MG', 'Madagascar', 'AFRO', '31', '16408', '1', '230');
INSERT INTO public.who_global_data_import VALUES (49474, '2020-10-02', 'MG', 'Madagascar', 'AFRO', '46', '16454', '2', '232');
INSERT INTO public.who_global_data_import VALUES (49475, '2020-10-03', 'MG', 'Madagascar', 'AFRO', '39', '16493', '0', '232');
INSERT INTO public.who_global_data_import VALUES (49476, '2020-10-04', 'MG', 'Madagascar', 'AFRO', '36', '16529', '0', '232');
INSERT INTO public.who_global_data_import VALUES (49477, '2020-10-05', 'MG', 'Madagascar', 'AFRO', '29', '16558', '0', '232');
INSERT INTO public.who_global_data_import VALUES (49478, '2020-10-06', 'MG', 'Madagascar', 'AFRO', '12', '16570', '1', '233');
INSERT INTO public.who_global_data_import VALUES (49479, '2020-10-07', 'MG', 'Madagascar', 'AFRO', '0', '16570', '0', '233');
INSERT INTO public.who_global_data_import VALUES (49480, '2020-10-08', 'MG', 'Madagascar', 'AFRO', '63', '16633', '2', '235');
INSERT INTO public.who_global_data_import VALUES (49481, '2020-10-09', 'MG', 'Madagascar', 'AFRO', '21', '16654', '0', '235');
INSERT INTO public.who_global_data_import VALUES (49482, '2020-10-10', 'MG', 'Madagascar', 'AFRO', '22', '16676', '2', '237');
INSERT INTO public.who_global_data_import VALUES (49483, '2020-10-11', 'MG', 'Madagascar', 'AFRO', '26', '16702', '0', '237');
INSERT INTO public.who_global_data_import VALUES (49484, '2020-10-12', 'MG', 'Madagascar', 'AFRO', '16', '16718', '0', '237');
INSERT INTO public.who_global_data_import VALUES (49485, '2020-10-13', 'MG', 'Madagascar', 'AFRO', '8', '16726', '0', '237');
INSERT INTO public.who_global_data_import VALUES (49486, '2020-10-14', 'MG', 'Madagascar', 'AFRO', '28', '16754', '0', '237');
INSERT INTO public.who_global_data_import VALUES (49487, '2020-10-15', 'MG', 'Madagascar', 'AFRO', '0', '16754', '0', '237');
INSERT INTO public.who_global_data_import VALUES (49488, '2020-10-16', 'MG', 'Madagascar', 'AFRO', '0', '16754', '0', '237');
INSERT INTO public.who_global_data_import VALUES (49489, '2020-10-17', 'MG', 'Madagascar', 'AFRO', '60', '16814', '1', '238');
INSERT INTO public.who_global_data_import VALUES (49490, '2020-10-18', 'MG', 'Madagascar', 'AFRO', '0', '16814', '0', '238');
INSERT INTO public.who_global_data_import VALUES (49491, '2020-10-19', 'MG', 'Madagascar', 'AFRO', '-4', '16810', '0', '238');
INSERT INTO public.who_global_data_import VALUES (49492, '2020-10-20', 'MG', 'Madagascar', 'AFRO', '0', '16810', '0', '238');
INSERT INTO public.who_global_data_import VALUES (49493, '2020-10-21', 'MG', 'Madagascar', 'AFRO', '0', '16810', '0', '238');
INSERT INTO public.who_global_data_import VALUES (49494, '2020-10-22', 'MG', 'Madagascar', 'AFRO', '0', '16810', '0', '238');
INSERT INTO public.who_global_data_import VALUES (49495, '2020-10-23', 'MG', 'Madagascar', 'AFRO', '0', '16810', '0', '238');
INSERT INTO public.who_global_data_import VALUES (49496, '2020-10-24', 'MG', 'Madagascar', 'AFRO', '0', '16810', '0', '238');
INSERT INTO public.who_global_data_import VALUES (49497, '2020-10-25', 'MG', 'Madagascar', 'AFRO', '158', '16968', '6', '244');
INSERT INTO public.who_global_data_import VALUES (49498, '2020-10-26', 'MG', 'Madagascar', 'AFRO', '0', '16968', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49499, '2020-10-27', 'MG', 'Madagascar', 'AFRO', '0', '16968', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49500, '2020-10-28', 'MG', 'Madagascar', 'AFRO', '0', '16968', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49501, '2020-10-29', 'MG', 'Madagascar', 'AFRO', '0', '16968', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49502, '2020-10-30', 'MG', 'Madagascar', 'AFRO', '0', '16968', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49503, '2020-10-31', 'MG', 'Madagascar', 'AFRO', '0', '16968', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49504, '2020-11-01', 'MG', 'Madagascar', 'AFRO', '143', '17111', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49505, '2020-11-02', 'MG', 'Madagascar', 'AFRO', '0', '17111', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49506, '2020-11-03', 'MG', 'Madagascar', 'AFRO', '0', '17111', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49507, '2020-11-04', 'MG', 'Madagascar', 'AFRO', '0', '17111', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49508, '2020-11-05', 'MG', 'Madagascar', 'AFRO', '0', '17111', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49509, '2020-11-06', 'MG', 'Madagascar', 'AFRO', '0', '17111', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49510, '2020-11-07', 'MG', 'Madagascar', 'AFRO', '0', '17111', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49511, '2020-11-08', 'MG', 'Madagascar', 'AFRO', '0', '17111', '0', '244');
INSERT INTO public.who_global_data_import VALUES (49512, '2020-11-09', 'MG', 'Madagascar', 'AFRO', '122', '17233', '5', '249');
INSERT INTO public.who_global_data_import VALUES (49513, '2020-11-10', 'MG', 'Madagascar', 'AFRO', '0', '17233', '0', '249');
INSERT INTO public.who_global_data_import VALUES (49514, '2020-11-11', 'MG', 'Madagascar', 'AFRO', '0', '17233', '0', '249');
INSERT INTO public.who_global_data_import VALUES (49515, '2020-11-12', 'MG', 'Madagascar', 'AFRO', '0', '17233', '0', '249');
INSERT INTO public.who_global_data_import VALUES (49516, '2020-11-13', 'MG', 'Madagascar', 'AFRO', '0', '17233', '0', '249');
INSERT INTO public.who_global_data_import VALUES (49517, '2020-11-14', 'MG', 'Madagascar', 'AFRO', '0', '17233', '0', '249');
INSERT INTO public.who_global_data_import VALUES (49518, '2020-11-15', 'MG', 'Madagascar', 'AFRO', '0', '17233', '0', '249');
INSERT INTO public.who_global_data_import VALUES (49519, '2020-11-16', 'MG', 'Madagascar', 'AFRO', '0', '17233', '0', '249');
INSERT INTO public.who_global_data_import VALUES (49520, '2020-11-17', 'MG', 'Madagascar', 'AFRO', '77', '17310', '1', '250');
INSERT INTO public.who_global_data_import VALUES (49521, '2020-11-18', 'MG', 'Madagascar', 'AFRO', '0', '17310', '0', '250');
INSERT INTO public.who_global_data_import VALUES (49522, '2020-11-19', 'MG', 'Madagascar', 'AFRO', '0', '17310', '0', '250');
INSERT INTO public.who_global_data_import VALUES (49523, '2020-11-20', 'MG', 'Madagascar', 'AFRO', '0', '17310', '0', '250');
INSERT INTO public.who_global_data_import VALUES (49524, '2020-11-21', 'MG', 'Madagascar', 'AFRO', '0', '17310', '0', '250');
INSERT INTO public.who_global_data_import VALUES (49525, '2020-11-22', 'MG', 'Madagascar', 'AFRO', '0', '17310', '0', '250');
INSERT INTO public.who_global_data_import VALUES (49526, '2020-11-23', 'MG', 'Madagascar', 'AFRO', '31', '17341', '1', '251');
INSERT INTO public.who_global_data_import VALUES (49527, '2020-11-24', 'MG', 'Madagascar', 'AFRO', '0', '17341', '0', '251');
INSERT INTO public.who_global_data_import VALUES (49528, '2020-11-25', 'MG', 'Madagascar', 'AFRO', '0', '17341', '0', '251');
INSERT INTO public.who_global_data_import VALUES (49529, '2020-11-26', 'MG', 'Madagascar', 'AFRO', '0', '17341', '0', '251');
INSERT INTO public.who_global_data_import VALUES (49530, '2020-11-27', 'MG', 'Madagascar', 'AFRO', '0', '17341', '0', '251');
INSERT INTO public.who_global_data_import VALUES (49531, '2020-11-28', 'MG', 'Madagascar', 'AFRO', '0', '17341', '0', '251');
INSERT INTO public.who_global_data_import VALUES (49532, '2020-11-29', 'MG', 'Madagascar', 'AFRO', '0', '17341', '0', '251');
INSERT INTO public.who_global_data_import VALUES (49533, '2020-11-30', 'MG', 'Madagascar', 'AFRO', '0', '17341', '0', '251');
INSERT INTO public.who_global_data_import VALUES (49534, '2020-12-01', 'MG', 'Madagascar', 'AFRO', '0', '17341', '0', '251');
INSERT INTO public.who_global_data_import VALUES (49535, '2020-12-02', 'MG', 'Madagascar', 'AFRO', '0', '17341', '0', '251');
INSERT INTO public.who_global_data_import VALUES (49536, '2020-12-03', 'MG', 'Madagascar', 'AFRO', '0', '17341', '0', '251');
INSERT INTO public.who_global_data_import VALUES (49537, '2020-12-04', 'MG', 'Madagascar', 'AFRO', '0', '17341', '0', '251');
INSERT INTO public.who_global_data_import VALUES (49538, '2020-12-05', 'MG', 'Madagascar', 'AFRO', '0', '17341', '0', '251');
INSERT INTO public.who_global_data_import VALUES (49539, '2020-12-06', 'MG', 'Madagascar', 'AFRO', '132', '17473', '4', '255');
INSERT INTO public.who_global_data_import VALUES (49540, '2020-12-07', 'MG', 'Madagascar', 'AFRO', '0', '17473', '0', '255');
INSERT INTO public.who_global_data_import VALUES (49541, '2020-12-08', 'MG', 'Madagascar', 'AFRO', '0', '17473', '0', '255');
INSERT INTO public.who_global_data_import VALUES (49542, '2020-12-09', 'MG', 'Madagascar', 'AFRO', '0', '17473', '0', '255');
INSERT INTO public.who_global_data_import VALUES (49543, '2020-12-10', 'MG', 'Madagascar', 'AFRO', '0', '17473', '0', '255');
INSERT INTO public.who_global_data_import VALUES (49544, '2020-12-11', 'MG', 'Madagascar', 'AFRO', '0', '17473', '0', '255');
INSERT INTO public.who_global_data_import VALUES (49545, '2020-12-12', 'MG', 'Madagascar', 'AFRO', '0', '17473', '0', '255');
INSERT INTO public.who_global_data_import VALUES (49546, '2020-12-13', 'MG', 'Madagascar', 'AFRO', '114', '17587', '4', '259');
INSERT INTO public.who_global_data_import VALUES (49547, '2020-12-14', 'MG', 'Madagascar', 'AFRO', '0', '17587', '0', '259');
INSERT INTO public.who_global_data_import VALUES (49548, '2020-12-15', 'MG', 'Madagascar', 'AFRO', '0', '17587', '0', '259');
INSERT INTO public.who_global_data_import VALUES (49549, '2020-12-16', 'MG', 'Madagascar', 'AFRO', '0', '17587', '0', '259');
INSERT INTO public.who_global_data_import VALUES (49550, '2020-12-17', 'MG', 'Madagascar', 'AFRO', '0', '17587', '0', '259');
INSERT INTO public.who_global_data_import VALUES (49551, '2020-12-18', 'MG', 'Madagascar', 'AFRO', '0', '17587', '0', '259');
INSERT INTO public.who_global_data_import VALUES (49552, '2020-12-19', 'MG', 'Madagascar', 'AFRO', '0', '17587', '0', '259');
INSERT INTO public.who_global_data_import VALUES (49553, '2020-12-20', 'MG', 'Madagascar', 'AFRO', '0', '17587', '0', '259');
INSERT INTO public.who_global_data_import VALUES (49554, '2020-12-21', 'MG', 'Madagascar', 'AFRO', '46', '17633', '1', '260');
INSERT INTO public.who_global_data_import VALUES (49555, '2020-12-22', 'MG', 'Madagascar', 'AFRO', '0', '17633', '0', '260');
INSERT INTO public.who_global_data_import VALUES (49556, '2020-12-23', 'MG', 'Madagascar', 'AFRO', '0', '17633', '0', '260');
INSERT INTO public.who_global_data_import VALUES (49557, '2020-12-24', 'MG', 'Madagascar', 'AFRO', '0', '17633', '0', '260');
INSERT INTO public.who_global_data_import VALUES (49558, '2020-12-25', 'MG', 'Madagascar', 'AFRO', '0', '17633', '0', '260');
INSERT INTO public.who_global_data_import VALUES (49559, '2020-12-26', 'MG', 'Madagascar', 'AFRO', '0', '17633', '0', '260');
INSERT INTO public.who_global_data_import VALUES (49560, '2020-12-27', 'MG', 'Madagascar', 'AFRO', '0', '17633', '0', '260');
INSERT INTO public.who_global_data_import VALUES (49561, '2020-12-28', 'MG', 'Madagascar', 'AFRO', '81', '17714', '1', '261');
INSERT INTO public.who_global_data_import VALUES (49562, '2020-12-29', 'MG', 'Madagascar', 'AFRO', '0', '17714', '0', '261');
INSERT INTO public.who_global_data_import VALUES (49563, '2020-12-30', 'MG', 'Madagascar', 'AFRO', '0', '17714', '0', '261');
INSERT INTO public.who_global_data_import VALUES (49564, '2020-12-31', 'MG', 'Madagascar', 'AFRO', '0', '17714', '0', '261');
INSERT INTO public.who_global_data_import VALUES (49565, '2021-01-01', 'MG', 'Madagascar', 'AFRO', '0', '17714', '0', '261');
INSERT INTO public.who_global_data_import VALUES (49566, '2021-01-02', 'MG', 'Madagascar', 'AFRO', '0', '17714', '0', '261');
INSERT INTO public.who_global_data_import VALUES (49567, '2021-01-03', 'MG', 'Madagascar', 'AFRO', '53', '17767', '1', '262');
INSERT INTO public.who_global_data_import VALUES (49568, '2021-01-04', 'MG', 'Madagascar', 'AFRO', '0', '17767', '0', '262');
INSERT INTO public.who_global_data_import VALUES (49569, '2021-01-05', 'MG', 'Madagascar', 'AFRO', '0', '17767', '0', '262');
INSERT INTO public.who_global_data_import VALUES (49570, '2021-01-06', 'MG', 'Madagascar', 'AFRO', '0', '17767', '0', '262');
INSERT INTO public.who_global_data_import VALUES (49571, '2021-01-07', 'MG', 'Madagascar', 'AFRO', '0', '17767', '0', '262');
INSERT INTO public.who_global_data_import VALUES (49572, '2021-01-08', 'MG', 'Madagascar', 'AFRO', '0', '17767', '0', '262');
INSERT INTO public.who_global_data_import VALUES (49573, '2021-01-09', 'MG', 'Madagascar', 'AFRO', '0', '17767', '0', '262');
INSERT INTO public.who_global_data_import VALUES (49574, '2021-01-10', 'MG', 'Madagascar', 'AFRO', '0', '17767', '0', '262');
INSERT INTO public.who_global_data_import VALUES (49575, '2021-01-11', 'MG', 'Madagascar', 'AFRO', '0', '17767', '0', '262');
INSERT INTO public.who_global_data_import VALUES (49576, '2021-01-12', 'MG', 'Madagascar', 'AFRO', '234', '18001', '5', '267');
INSERT INTO public.who_global_data_import VALUES (49577, '2021-01-13', 'MG', 'Madagascar', 'AFRO', '0', '18001', '0', '267');
INSERT INTO public.who_global_data_import VALUES (49578, '2021-01-14', 'MG', 'Madagascar', 'AFRO', '0', '18001', '0', '267');
INSERT INTO public.who_global_data_import VALUES (49579, '2021-01-15', 'MG', 'Madagascar', 'AFRO', '0', '18001', '0', '267');
INSERT INTO public.who_global_data_import VALUES (49580, '2021-01-16', 'MG', 'Madagascar', 'AFRO', '0', '18001', '0', '267');
INSERT INTO public.who_global_data_import VALUES (49581, '2021-01-17', 'MG', 'Madagascar', 'AFRO', '0', '18001', '0', '267');
INSERT INTO public.who_global_data_import VALUES (49582, '2021-01-18', 'MG', 'Madagascar', 'AFRO', '300', '18301', '6', '273');
INSERT INTO public.who_global_data_import VALUES (49583, '2021-01-19', 'MG', 'Madagascar', 'AFRO', '0', '18301', '0', '273');
INSERT INTO public.who_global_data_import VALUES (49584, '2021-01-20', 'MG', 'Madagascar', 'AFRO', '0', '18301', '0', '273');
INSERT INTO public.who_global_data_import VALUES (49585, '2021-01-21', 'MG', 'Madagascar', 'AFRO', '0', '18301', '0', '273');
INSERT INTO public.who_global_data_import VALUES (49586, '2021-01-22', 'MG', 'Madagascar', 'AFRO', '0', '18301', '0', '273');
INSERT INTO public.who_global_data_import VALUES (49587, '2021-01-23', 'MG', 'Madagascar', 'AFRO', '0', '18301', '0', '273');
INSERT INTO public.who_global_data_import VALUES (49588, '2021-01-24', 'MG', 'Madagascar', 'AFRO', '0', '18301', '0', '273');
INSERT INTO public.who_global_data_import VALUES (49589, '2021-01-25', 'MG', 'Madagascar', 'AFRO', '442', '18743', '6', '279');
INSERT INTO public.who_global_data_import VALUES (49590, '2021-01-26', 'MG', 'Madagascar', 'AFRO', '0', '18743', '0', '279');
INSERT INTO public.who_global_data_import VALUES (49591, '2021-01-27', 'MG', 'Madagascar', 'AFRO', '0', '18743', '0', '279');
INSERT INTO public.who_global_data_import VALUES (49592, '2021-01-28', 'MG', 'Madagascar', 'AFRO', '0', '18743', '0', '279');
INSERT INTO public.who_global_data_import VALUES (49593, '2021-01-29', 'MG', 'Madagascar', 'AFRO', '0', '18743', '0', '279');
INSERT INTO public.who_global_data_import VALUES (49594, '2021-01-30', 'MG', 'Madagascar', 'AFRO', '0', '18743', '0', '279');
INSERT INTO public.who_global_data_import VALUES (49595, '2021-01-31', 'MG', 'Madagascar', 'AFRO', '0', '18743', '0', '279');
INSERT INTO public.who_global_data_import VALUES (49596, '2021-02-01', 'MG', 'Madagascar', 'AFRO', '322', '19065', '2', '281');
INSERT INTO public.who_global_data_import VALUES (49597, '2021-02-02', 'MG', 'Madagascar', 'AFRO', '0', '19065', '0', '281');
INSERT INTO public.who_global_data_import VALUES (49598, '2021-02-03', 'MG', 'Madagascar', 'AFRO', '0', '19065', '0', '281');
INSERT INTO public.who_global_data_import VALUES (49599, '2021-02-04', 'MG', 'Madagascar', 'AFRO', '0', '19065', '0', '281');
INSERT INTO public.who_global_data_import VALUES (49600, '2021-02-05', 'MG', 'Madagascar', 'AFRO', '0', '19065', '0', '281');
INSERT INTO public.who_global_data_import VALUES (49601, '2020-01-03', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49602, '2020-01-04', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49603, '2020-01-05', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49604, '2020-01-06', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49605, '2020-01-07', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49606, '2020-01-08', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49607, '2020-01-09', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49608, '2020-01-10', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49609, '2020-01-11', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49610, '2020-01-12', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49611, '2020-01-13', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49612, '2020-01-14', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49613, '2020-01-15', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49614, '2020-01-16', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49615, '2020-01-17', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49616, '2020-01-18', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49617, '2020-01-19', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49618, '2020-01-20', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49619, '2020-01-21', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49620, '2020-01-22', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49621, '2020-01-23', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49622, '2020-01-24', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49623, '2020-01-25', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49624, '2020-01-26', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49625, '2020-01-27', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49626, '2020-01-28', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49627, '2020-01-29', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49628, '2020-01-30', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49629, '2020-01-31', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49630, '2020-02-01', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49631, '2020-02-02', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49632, '2020-02-03', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49633, '2020-02-04', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49634, '2020-02-05', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49635, '2020-02-06', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49636, '2020-02-07', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49637, '2020-02-08', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49638, '2020-02-09', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49639, '2020-02-10', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49640, '2020-02-11', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49641, '2020-02-12', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49642, '2020-02-13', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49643, '2020-02-14', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49644, '2020-02-15', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49645, '2020-02-16', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49646, '2020-02-17', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49647, '2020-02-18', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49648, '2020-02-19', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49649, '2020-02-20', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49650, '2020-02-21', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49651, '2020-02-22', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49652, '2020-02-23', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49653, '2020-02-24', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49654, '2020-02-25', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49655, '2020-02-26', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49656, '2020-02-27', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49657, '2020-02-28', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49658, '2020-02-29', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49659, '2020-03-01', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49660, '2020-03-02', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49661, '2020-03-03', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49663, '2020-03-05', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49664, '2020-03-06', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49665, '2020-03-07', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49666, '2020-03-08', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49667, '2020-03-09', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49668, '2020-03-10', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49669, '2020-03-11', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49670, '2020-03-12', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49671, '2020-03-13', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49672, '2020-03-14', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49673, '2020-03-15', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49674, '2020-03-16', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49675, '2020-03-17', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49676, '2020-03-18', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49677, '2020-03-19', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49678, '2020-03-20', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49679, '2020-03-21', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49680, '2020-03-22', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49681, '2020-03-23', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49682, '2020-03-24', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49683, '2020-03-25', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49684, '2020-03-26', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49685, '2020-03-27', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49686, '2020-03-28', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49687, '2020-03-29', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49688, '2020-03-30', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49689, '2020-03-31', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49690, '2020-04-01', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49691, '2020-04-02', 'MW', 'Malawi', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49692, '2020-04-03', 'MW', 'Malawi', 'AFRO', '3', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49693, '2020-04-04', 'MW', 'Malawi', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49694, '2020-04-05', 'MW', 'Malawi', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49695, '2020-04-06', 'MW', 'Malawi', 'AFRO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49696, '2020-04-07', 'MW', 'Malawi', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (49697, '2020-04-08', 'MW', 'Malawi', 'AFRO', '4', '8', '1', '1');
INSERT INTO public.who_global_data_import VALUES (49698, '2020-04-09', 'MW', 'Malawi', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (49699, '2020-04-10', 'MW', 'Malawi', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (49700, '2020-04-11', 'MW', 'Malawi', 'AFRO', '1', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (49701, '2020-04-12', 'MW', 'Malawi', 'AFRO', '3', '12', '1', '2');
INSERT INTO public.who_global_data_import VALUES (49702, '2020-04-13', 'MW', 'Malawi', 'AFRO', '1', '13', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49703, '2020-04-14', 'MW', 'Malawi', 'AFRO', '3', '16', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49704, '2020-04-15', 'MW', 'Malawi', 'AFRO', '0', '16', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49705, '2020-04-16', 'MW', 'Malawi', 'AFRO', '0', '16', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49706, '2020-04-17', 'MW', 'Malawi', 'AFRO', '0', '16', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49707, '2020-04-18', 'MW', 'Malawi', 'AFRO', '1', '17', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49708, '2020-04-19', 'MW', 'Malawi', 'AFRO', '0', '17', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49709, '2020-04-20', 'MW', 'Malawi', 'AFRO', '0', '17', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49710, '2020-04-21', 'MW', 'Malawi', 'AFRO', '0', '17', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49711, '2020-04-22', 'MW', 'Malawi', 'AFRO', '1', '18', '0', '2');
INSERT INTO public.who_global_data_import VALUES (49712, '2020-04-23', 'MW', 'Malawi', 'AFRO', '5', '23', '1', '3');
INSERT INTO public.who_global_data_import VALUES (49713, '2020-04-24', 'MW', 'Malawi', 'AFRO', '10', '33', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49714, '2020-04-25', 'MW', 'Malawi', 'AFRO', '0', '33', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49715, '2020-04-26', 'MW', 'Malawi', 'AFRO', '0', '33', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49716, '2020-04-27', 'MW', 'Malawi', 'AFRO', '1', '34', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49717, '2020-04-28', 'MW', 'Malawi', 'AFRO', '2', '36', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49718, '2020-04-29', 'MW', 'Malawi', 'AFRO', '0', '36', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49719, '2020-04-30', 'MW', 'Malawi', 'AFRO', '0', '36', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49720, '2020-05-01', 'MW', 'Malawi', 'AFRO', '1', '37', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49721, '2020-05-02', 'MW', 'Malawi', 'AFRO', '0', '37', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49722, '2020-05-03', 'MW', 'Malawi', 'AFRO', '1', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49723, '2020-05-04', 'MW', 'Malawi', 'AFRO', '1', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49724, '2020-05-05', 'MW', 'Malawi', 'AFRO', '2', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49725, '2020-05-06', 'MW', 'Malawi', 'AFRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49726, '2020-05-07', 'MW', 'Malawi', 'AFRO', '2', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49727, '2020-05-08', 'MW', 'Malawi', 'AFRO', '0', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49728, '2020-05-09', 'MW', 'Malawi', 'AFRO', '0', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49729, '2020-05-10', 'MW', 'Malawi', 'AFRO', '13', '56', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49730, '2020-05-11', 'MW', 'Malawi', 'AFRO', '0', '56', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49731, '2020-05-12', 'MW', 'Malawi', 'AFRO', '1', '57', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49732, '2020-05-13', 'MW', 'Malawi', 'AFRO', '1', '58', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49733, '2020-05-14', 'MW', 'Malawi', 'AFRO', '5', '63', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49734, '2020-05-15', 'MW', 'Malawi', 'AFRO', '0', '63', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49735, '2020-05-16', 'MW', 'Malawi', 'AFRO', '0', '63', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49736, '2020-05-17', 'MW', 'Malawi', 'AFRO', '2', '65', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49737, '2020-05-18', 'MW', 'Malawi', 'AFRO', '5', '70', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49738, '2020-05-19', 'MW', 'Malawi', 'AFRO', '0', '70', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49739, '2020-05-20', 'MW', 'Malawi', 'AFRO', '1', '71', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49740, '2020-05-21', 'MW', 'Malawi', 'AFRO', '1', '72', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49741, '2020-05-22', 'MW', 'Malawi', 'AFRO', '0', '72', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49742, '2020-05-23', 'MW', 'Malawi', 'AFRO', '10', '82', '0', '3');
INSERT INTO public.who_global_data_import VALUES (49743, '2020-05-24', 'MW', 'Malawi', 'AFRO', '1', '83', '1', '4');
INSERT INTO public.who_global_data_import VALUES (49744, '2020-05-25', 'MW', 'Malawi', 'AFRO', '0', '83', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49745, '2020-05-26', 'MW', 'Malawi', 'AFRO', '18', '101', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49746, '2020-05-27', 'MW', 'Malawi', 'AFRO', '0', '101', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49747, '2020-05-28', 'MW', 'Malawi', 'AFRO', '0', '101', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49748, '2020-05-29', 'MW', 'Malawi', 'AFRO', '102', '203', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49749, '2020-05-30', 'MW', 'Malawi', 'AFRO', '70', '273', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49750, '2020-05-31', 'MW', 'Malawi', 'AFRO', '6', '279', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49751, '2020-06-01', 'MW', 'Malawi', 'AFRO', '5', '284', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49752, '2020-06-02', 'MW', 'Malawi', 'AFRO', '52', '336', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49753, '2020-06-03', 'MW', 'Malawi', 'AFRO', '22', '358', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49754, '2020-06-04', 'MW', 'Malawi', 'AFRO', '11', '369', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49755, '2020-06-05', 'MW', 'Malawi', 'AFRO', '24', '393', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49756, '2020-06-06', 'MW', 'Malawi', 'AFRO', '16', '409', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49757, '2020-06-07', 'MW', 'Malawi', 'AFRO', '0', '409', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49758, '2020-06-08', 'MW', 'Malawi', 'AFRO', '29', '438', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49759, '2020-06-09', 'MW', 'Malawi', 'AFRO', '5', '443', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49760, '2020-06-10', 'MW', 'Malawi', 'AFRO', '12', '455', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49761, '2020-06-11', 'MW', 'Malawi', 'AFRO', '0', '455', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49762, '2020-06-12', 'MW', 'Malawi', 'AFRO', '26', '481', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49763, '2020-06-13', 'MW', 'Malawi', 'AFRO', '0', '481', '0', '4');
INSERT INTO public.who_global_data_import VALUES (49764, '2020-06-14', 'MW', 'Malawi', 'AFRO', '48', '529', '1', '5');
INSERT INTO public.who_global_data_import VALUES (49765, '2020-06-15', 'MW', 'Malawi', 'AFRO', '18', '547', '1', '6');
INSERT INTO public.who_global_data_import VALUES (49766, '2020-06-16', 'MW', 'Malawi', 'AFRO', '9', '556', '0', '6');
INSERT INTO public.who_global_data_import VALUES (49767, '2020-06-17', 'MW', 'Malawi', 'AFRO', '8', '564', '0', '6');
INSERT INTO public.who_global_data_import VALUES (49768, '2020-06-18', 'MW', 'Malawi', 'AFRO', '8', '572', '0', '6');
INSERT INTO public.who_global_data_import VALUES (49769, '2020-06-19', 'MW', 'Malawi', 'AFRO', '20', '592', '2', '8');
INSERT INTO public.who_global_data_import VALUES (49770, '2020-06-20', 'MW', 'Malawi', 'AFRO', '56', '648', '0', '8');
INSERT INTO public.who_global_data_import VALUES (49771, '2020-06-21', 'MW', 'Malawi', 'AFRO', '82', '730', '3', '11');
INSERT INTO public.who_global_data_import VALUES (49772, '2020-06-22', 'MW', 'Malawi', 'AFRO', '0', '730', '0', '11');
INSERT INTO public.who_global_data_import VALUES (49773, '2020-06-23', 'MW', 'Malawi', 'AFRO', '15', '745', '0', '11');
INSERT INTO public.who_global_data_import VALUES (49774, '2020-06-24', 'MW', 'Malawi', 'AFRO', '58', '803', '0', '11');
INSERT INTO public.who_global_data_import VALUES (49775, '2020-06-25', 'MW', 'Malawi', 'AFRO', '45', '848', '0', '11');
INSERT INTO public.who_global_data_import VALUES (49776, '2020-06-26', 'MW', 'Malawi', 'AFRO', '112', '960', '1', '12');
INSERT INTO public.who_global_data_import VALUES (49777, '2020-06-27', 'MW', 'Malawi', 'AFRO', '45', '1005', '1', '13');
INSERT INTO public.who_global_data_import VALUES (49778, '2020-06-28', 'MW', 'Malawi', 'AFRO', '33', '1038', '0', '13');
INSERT INTO public.who_global_data_import VALUES (49779, '2020-06-29', 'MW', 'Malawi', 'AFRO', '114', '1152', '0', '13');
INSERT INTO public.who_global_data_import VALUES (49780, '2020-06-30', 'MW', 'Malawi', 'AFRO', '72', '1224', '1', '14');
INSERT INTO public.who_global_data_import VALUES (49781, '2020-07-01', 'MW', 'Malawi', 'AFRO', '41', '1265', '2', '16');
INSERT INTO public.who_global_data_import VALUES (49782, '2020-07-02', 'MW', 'Malawi', 'AFRO', '77', '1342', '0', '16');
INSERT INTO public.who_global_data_import VALUES (49783, '2020-07-03', 'MW', 'Malawi', 'AFRO', '60', '1402', '0', '16');
INSERT INTO public.who_global_data_import VALUES (49784, '2020-07-04', 'MW', 'Malawi', 'AFRO', '96', '1498', '0', '16');
INSERT INTO public.who_global_data_import VALUES (49785, '2020-07-05', 'MW', 'Malawi', 'AFRO', '115', '1613', '1', '17');
INSERT INTO public.who_global_data_import VALUES (49786, '2020-07-06', 'MW', 'Malawi', 'AFRO', '129', '1742', '2', '19');
INSERT INTO public.who_global_data_import VALUES (49787, '2020-07-07', 'MW', 'Malawi', 'AFRO', '76', '1818', '0', '19');
INSERT INTO public.who_global_data_import VALUES (49788, '2020-07-08', 'MW', 'Malawi', 'AFRO', '59', '1877', '5', '24');
INSERT INTO public.who_global_data_import VALUES (49789, '2020-07-09', 'MW', 'Malawi', 'AFRO', '65', '1942', '1', '25');
INSERT INTO public.who_global_data_import VALUES (49790, '2020-07-10', 'MW', 'Malawi', 'AFRO', '44', '1986', '4', '29');
INSERT INTO public.who_global_data_import VALUES (49791, '2020-07-11', 'MW', 'Malawi', 'AFRO', '83', '2069', '2', '31');
INSERT INTO public.who_global_data_import VALUES (49792, '2020-07-12', 'MW', 'Malawi', 'AFRO', '192', '2261', '2', '33');
INSERT INTO public.who_global_data_import VALUES (49793, '2020-07-13', 'MW', 'Malawi', 'AFRO', '103', '2364', '5', '38');
INSERT INTO public.who_global_data_import VALUES (49794, '2020-07-14', 'MW', 'Malawi', 'AFRO', '66', '2430', '1', '39');
INSERT INTO public.who_global_data_import VALUES (49795, '2020-07-15', 'MW', 'Malawi', 'AFRO', '67', '2497', '1', '40');
INSERT INTO public.who_global_data_import VALUES (49796, '2020-07-16', 'MW', 'Malawi', 'AFRO', '117', '2614', '3', '43');
INSERT INTO public.who_global_data_import VALUES (49797, '2020-07-17', 'MW', 'Malawi', 'AFRO', '102', '2716', '8', '51');
INSERT INTO public.who_global_data_import VALUES (49798, '2020-07-18', 'MW', 'Malawi', 'AFRO', '94', '2810', '4', '55');
INSERT INTO public.who_global_data_import VALUES (49799, '2020-07-19', 'MW', 'Malawi', 'AFRO', '97', '2907', '4', '59');
INSERT INTO public.who_global_data_import VALUES (49800, '2020-07-20', 'MW', 'Malawi', 'AFRO', '85', '2992', '3', '62');
INSERT INTO public.who_global_data_import VALUES (49801, '2020-07-21', 'MW', 'Malawi', 'AFRO', '53', '3045', '2', '64');
INSERT INTO public.who_global_data_import VALUES (49802, '2020-07-22', 'MW', 'Malawi', 'AFRO', '104', '3149', '7', '71');
INSERT INTO public.who_global_data_import VALUES (49803, '2020-07-23', 'MW', 'Malawi', 'AFRO', '153', '3302', '5', '76');
INSERT INTO public.who_global_data_import VALUES (49804, '2020-07-24', 'MW', 'Malawi', 'AFRO', '84', '3386', '3', '79');
INSERT INTO public.who_global_data_import VALUES (49805, '2020-07-25', 'MW', 'Malawi', 'AFRO', '68', '3454', '8', '87');
INSERT INTO public.who_global_data_import VALUES (49806, '2020-07-26', 'MW', 'Malawi', 'AFRO', '103', '3557', '7', '94');
INSERT INTO public.who_global_data_import VALUES (49807, '2020-07-27', 'MW', 'Malawi', 'AFRO', '107', '3664', '5', '99');
INSERT INTO public.who_global_data_import VALUES (49808, '2020-07-28', 'MW', 'Malawi', 'AFRO', '45', '3709', '4', '103');
INSERT INTO public.who_global_data_import VALUES (49809, '2020-07-29', 'MW', 'Malawi', 'AFRO', '29', '3738', '0', '103');
INSERT INTO public.who_global_data_import VALUES (49810, '2020-07-30', 'MW', 'Malawi', 'AFRO', '120', '3858', '4', '107');
INSERT INTO public.who_global_data_import VALUES (49811, '2020-07-31', 'MW', 'Malawi', 'AFRO', '123', '3981', '2', '109');
INSERT INTO public.who_global_data_import VALUES (49812, '2020-08-01', 'MW', 'Malawi', 'AFRO', '97', '4078', '5', '114');
INSERT INTO public.who_global_data_import VALUES (49813, '2020-08-02', 'MW', 'Malawi', 'AFRO', '108', '4186', '6', '120');
INSERT INTO public.who_global_data_import VALUES (49814, '2020-08-03', 'MW', 'Malawi', 'AFRO', '45', '4231', '3', '123');
INSERT INTO public.who_global_data_import VALUES (49815, '2020-08-04', 'MW', 'Malawi', 'AFRO', '42', '4273', '0', '123');
INSERT INTO public.who_global_data_import VALUES (49816, '2020-08-05', 'MW', 'Malawi', 'AFRO', '88', '4361', '5', '128');
INSERT INTO public.who_global_data_import VALUES (49817, '2020-08-06', 'MW', 'Malawi', 'AFRO', '65', '4426', '8', '136');
INSERT INTO public.who_global_data_import VALUES (49818, '2020-08-07', 'MW', 'Malawi', 'AFRO', '65', '4491', '1', '137');
INSERT INTO public.who_global_data_import VALUES (49819, '2020-08-08', 'MW', 'Malawi', 'AFRO', '84', '4575', '0', '137');
INSERT INTO public.who_global_data_import VALUES (49820, '2020-08-09', 'MW', 'Malawi', 'AFRO', '49', '4624', '6', '143');
INSERT INTO public.who_global_data_import VALUES (49821, '2020-08-10', 'MW', 'Malawi', 'AFRO', '34', '4658', '3', '146');
INSERT INTO public.who_global_data_import VALUES (49822, '2020-08-11', 'MW', 'Malawi', 'AFRO', '16', '4674', '0', '146');
INSERT INTO public.who_global_data_import VALUES (49823, '2020-08-12', 'MW', 'Malawi', 'AFRO', '40', '4714', '6', '152');
INSERT INTO public.who_global_data_import VALUES (49824, '2020-08-13', 'MW', 'Malawi', 'AFRO', '38', '4752', '0', '152');
INSERT INTO public.who_global_data_import VALUES (49825, '2020-08-14', 'MW', 'Malawi', 'AFRO', '160', '4912', '1', '153');
INSERT INTO public.who_global_data_import VALUES (49826, '2020-08-15', 'MW', 'Malawi', 'AFRO', '76', '4988', '3', '156');
INSERT INTO public.who_global_data_import VALUES (49827, '2020-08-16', 'MW', 'Malawi', 'AFRO', '38', '5026', '1', '157');
INSERT INTO public.who_global_data_import VALUES (49828, '2020-08-17', 'MW', 'Malawi', 'AFRO', '46', '5072', '4', '161');
INSERT INTO public.who_global_data_import VALUES (49829, '2020-08-18', 'MW', 'Malawi', 'AFRO', '53', '5125', '1', '162');
INSERT INTO public.who_global_data_import VALUES (49830, '2020-08-19', 'MW', 'Malawi', 'AFRO', '68', '5193', '1', '163');
INSERT INTO public.who_global_data_import VALUES (49831, '2020-08-20', 'MW', 'Malawi', 'AFRO', '47', '5240', '1', '164');
INSERT INTO public.who_global_data_import VALUES (49832, '2020-08-21', 'MW', 'Malawi', 'AFRO', '42', '5282', '1', '165');
INSERT INTO public.who_global_data_import VALUES (49833, '2020-08-22', 'MW', 'Malawi', 'AFRO', '40', '5322', '1', '166');
INSERT INTO public.who_global_data_import VALUES (49834, '2020-08-23', 'MW', 'Malawi', 'AFRO', '60', '5382', '2', '168');
INSERT INTO public.who_global_data_import VALUES (49835, '2020-08-24', 'MW', 'Malawi', 'AFRO', '32', '5414', '0', '168');
INSERT INTO public.who_global_data_import VALUES (49836, '2020-08-25', 'MW', 'Malawi', 'AFRO', '5', '5419', '1', '169');
INSERT INTO public.who_global_data_import VALUES (49837, '2020-08-26', 'MW', 'Malawi', 'AFRO', '4', '5423', '1', '170');
INSERT INTO public.who_global_data_import VALUES (49838, '2020-08-27', 'MW', 'Malawi', 'AFRO', '51', '5474', '3', '173');
INSERT INTO public.who_global_data_import VALUES (49839, '2020-08-28', 'MW', 'Malawi', 'AFRO', '22', '5496', '0', '173');
INSERT INTO public.who_global_data_import VALUES (49840, '2020-08-29', 'MW', 'Malawi', 'AFRO', '27', '5523', '1', '174');
INSERT INTO public.who_global_data_import VALUES (49841, '2020-08-30', 'MW', 'Malawi', 'AFRO', '5', '5528', '0', '174');
INSERT INTO public.who_global_data_import VALUES (49842, '2020-08-31', 'MW', 'Malawi', 'AFRO', '8', '5536', '0', '174');
INSERT INTO public.who_global_data_import VALUES (49843, '2020-09-01', 'MW', 'Malawi', 'AFRO', '30', '5566', '1', '175');
INSERT INTO public.who_global_data_import VALUES (49844, '2020-09-02', 'MW', 'Malawi', 'AFRO', '10', '5576', '0', '175');
INSERT INTO public.who_global_data_import VALUES (49845, '2020-09-03', 'MW', 'Malawi', 'AFRO', '3', '5579', '0', '175');
INSERT INTO public.who_global_data_import VALUES (49846, '2020-09-04', 'MW', 'Malawi', 'AFRO', '14', '5593', '0', '175');
INSERT INTO public.who_global_data_import VALUES (49847, '2020-09-05', 'MW', 'Malawi', 'AFRO', '15', '5608', '0', '175');
INSERT INTO public.who_global_data_import VALUES (49848, '2020-09-06', 'MW', 'Malawi', 'AFRO', '3', '5611', '0', '175');
INSERT INTO public.who_global_data_import VALUES (49849, '2020-09-07', 'MW', 'Malawi', 'AFRO', '3', '5614', '0', '175');
INSERT INTO public.who_global_data_import VALUES (49850, '2020-09-08', 'MW', 'Malawi', 'AFRO', '7', '5621', '1', '176');
INSERT INTO public.who_global_data_import VALUES (49851, '2020-09-09', 'MW', 'Malawi', 'AFRO', '9', '5630', '0', '176');
INSERT INTO public.who_global_data_import VALUES (49852, '2020-09-10', 'MW', 'Malawi', 'AFRO', '23', '5653', '0', '176');
INSERT INTO public.who_global_data_import VALUES (49853, '2020-09-11', 'MW', 'Malawi', 'AFRO', '2', '5655', '0', '176');
INSERT INTO public.who_global_data_import VALUES (49854, '2020-09-12', 'MW', 'Malawi', 'AFRO', '14', '5669', '1', '177');
INSERT INTO public.who_global_data_import VALUES (49855, '2020-09-13', 'MW', 'Malawi', 'AFRO', '0', '5669', '0', '177');
INSERT INTO public.who_global_data_import VALUES (49856, '2020-09-14', 'MW', 'Malawi', 'AFRO', '21', '5690', '0', '177');
INSERT INTO public.who_global_data_import VALUES (49857, '2020-09-15', 'MW', 'Malawi', 'AFRO', '7', '5697', '1', '178');
INSERT INTO public.who_global_data_import VALUES (49858, '2020-09-16', 'MW', 'Malawi', 'AFRO', '4', '5701', '0', '178');
INSERT INTO public.who_global_data_import VALUES (49859, '2020-09-17', 'MW', 'Malawi', 'AFRO', '3', '5704', '0', '178');
INSERT INTO public.who_global_data_import VALUES (49860, '2020-09-18', 'MW', 'Malawi', 'AFRO', '7', '5711', '1', '179');
INSERT INTO public.who_global_data_import VALUES (49861, '2020-09-19', 'MW', 'Malawi', 'AFRO', '5', '5716', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49862, '2020-09-20', 'MW', 'Malawi', 'AFRO', '2', '5718', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49863, '2020-09-21', 'MW', 'Malawi', 'AFRO', '13', '5731', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49864, '2020-09-22', 'MW', 'Malawi', 'AFRO', '2', '5733', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49865, '2020-09-23', 'MW', 'Malawi', 'AFRO', '6', '5739', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49866, '2020-09-24', 'MW', 'Malawi', 'AFRO', '7', '5746', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49867, '2020-09-25', 'MW', 'Malawi', 'AFRO', '1', '5747', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49868, '2020-09-26', 'MW', 'Malawi', 'AFRO', '17', '5764', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49869, '2020-09-27', 'MW', 'Malawi', 'AFRO', '2', '5766', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49870, '2020-09-28', 'MW', 'Malawi', 'AFRO', '2', '5768', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49871, '2020-09-29', 'MW', 'Malawi', 'AFRO', '2', '5770', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49872, '2020-09-30', 'MW', 'Malawi', 'AFRO', '2', '5772', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49873, '2020-10-01', 'MW', 'Malawi', 'AFRO', '1', '5773', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49874, '2020-10-02', 'MW', 'Malawi', 'AFRO', '6', '5779', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49875, '2020-10-03', 'MW', 'Malawi', 'AFRO', '4', '5783', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49876, '2020-10-04', 'MW', 'Malawi', 'AFRO', '0', '5783', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49877, '2020-10-05', 'MW', 'Malawi', 'AFRO', '3', '5786', '0', '179');
INSERT INTO public.who_global_data_import VALUES (49878, '2020-10-06', 'MW', 'Malawi', 'AFRO', '8', '5794', '1', '180');
INSERT INTO public.who_global_data_import VALUES (49879, '2020-10-07', 'MW', 'Malawi', 'AFRO', '2', '5796', '0', '180');
INSERT INTO public.who_global_data_import VALUES (49880, '2020-10-08', 'MW', 'Malawi', 'AFRO', '7', '5803', '0', '180');
INSERT INTO public.who_global_data_import VALUES (49881, '2020-10-09', 'MW', 'Malawi', 'AFRO', '6', '5809', '0', '180');
INSERT INTO public.who_global_data_import VALUES (49882, '2020-10-10', 'MW', 'Malawi', 'AFRO', '4', '5813', '0', '180');
INSERT INTO public.who_global_data_import VALUES (49883, '2020-10-11', 'MW', 'Malawi', 'AFRO', '8', '5821', '0', '180');
INSERT INTO public.who_global_data_import VALUES (49884, '2020-10-12', 'MW', 'Malawi', 'AFRO', '0', '5821', '0', '180');
INSERT INTO public.who_global_data_import VALUES (49885, '2020-10-13', 'MW', 'Malawi', 'AFRO', '3', '5824', '0', '180');
INSERT INTO public.who_global_data_import VALUES (49886, '2020-10-14', 'MW', 'Malawi', 'AFRO', '3', '5827', '1', '181');
INSERT INTO public.who_global_data_import VALUES (49887, '2020-10-15', 'MW', 'Malawi', 'AFRO', '2', '5829', '0', '181');
INSERT INTO public.who_global_data_import VALUES (49888, '2020-10-16', 'MW', 'Malawi', 'AFRO', '7', '5836', '0', '181');
INSERT INTO public.who_global_data_import VALUES (49889, '2020-10-17', 'MW', 'Malawi', 'AFRO', '6', '5842', '0', '181');
INSERT INTO public.who_global_data_import VALUES (49890, '2020-10-18', 'MW', 'Malawi', 'AFRO', '10', '5852', '0', '181');
INSERT INTO public.who_global_data_import VALUES (49891, '2020-10-19', 'MW', 'Malawi', 'AFRO', '5', '5857', '0', '181');
INSERT INTO public.who_global_data_import VALUES (49892, '2020-10-20', 'MW', 'Malawi', 'AFRO', '3', '5860', '0', '181');
INSERT INTO public.who_global_data_import VALUES (49893, '2020-10-21', 'MW', 'Malawi', 'AFRO', '1', '5861', '1', '182');
INSERT INTO public.who_global_data_import VALUES (49894, '2020-10-22', 'MW', 'Malawi', 'AFRO', '3', '5864', '1', '183');
INSERT INTO public.who_global_data_import VALUES (49895, '2020-10-23', 'MW', 'Malawi', 'AFRO', '10', '5874', '0', '183');
INSERT INTO public.who_global_data_import VALUES (49896, '2020-10-24', 'MW', 'Malawi', 'AFRO', '11', '5885', '0', '183');
INSERT INTO public.who_global_data_import VALUES (49897, '2020-10-25', 'MW', 'Malawi', 'AFRO', '2', '5887', '0', '183');
INSERT INTO public.who_global_data_import VALUES (49898, '2020-10-26', 'MW', 'Malawi', 'AFRO', '3', '5890', '0', '183');
INSERT INTO public.who_global_data_import VALUES (49899, '2020-10-27', 'MW', 'Malawi', 'AFRO', '4', '5894', '0', '183');
INSERT INTO public.who_global_data_import VALUES (49900, '2020-10-28', 'MW', 'Malawi', 'AFRO', '3', '5897', '0', '183');
INSERT INTO public.who_global_data_import VALUES (49901, '2020-10-29', 'MW', 'Malawi', 'AFRO', '7', '5904', '1', '184');
INSERT INTO public.who_global_data_import VALUES (49902, '2020-10-30', 'MW', 'Malawi', 'AFRO', '12', '5916', '0', '184');
INSERT INTO public.who_global_data_import VALUES (49903, '2020-10-31', 'MW', 'Malawi', 'AFRO', '7', '5923', '0', '184');
INSERT INTO public.who_global_data_import VALUES (49904, '2020-11-01', 'MW', 'Malawi', 'AFRO', '7', '5930', '0', '184');
INSERT INTO public.who_global_data_import VALUES (49905, '2020-11-02', 'MW', 'Malawi', 'AFRO', '2', '5932', '0', '184');
INSERT INTO public.who_global_data_import VALUES (49906, '2020-11-03', 'MW', 'Malawi', 'AFRO', '1', '5933', '0', '184');
INSERT INTO public.who_global_data_import VALUES (49907, '2020-11-04', 'MW', 'Malawi', 'AFRO', '1', '5934', '0', '184');
INSERT INTO public.who_global_data_import VALUES (49908, '2020-11-05', 'MW', 'Malawi', 'AFRO', '0', '5934', '0', '184');
INSERT INTO public.who_global_data_import VALUES (49909, '2020-11-06', 'MW', 'Malawi', 'AFRO', '6', '5940', '0', '184');
INSERT INTO public.who_global_data_import VALUES (49910, '2020-11-07', 'MW', 'Malawi', 'AFRO', '2', '5942', '0', '184');
INSERT INTO public.who_global_data_import VALUES (49911, '2020-11-08', 'MW', 'Malawi', 'AFRO', '6', '5948', '0', '184');
INSERT INTO public.who_global_data_import VALUES (49912, '2020-11-09', 'MW', 'Malawi', 'AFRO', '3', '5951', '0', '184');
INSERT INTO public.who_global_data_import VALUES (49913, '2020-11-10', 'MW', 'Malawi', 'AFRO', '2', '5953', '1', '185');
INSERT INTO public.who_global_data_import VALUES (49914, '2020-11-11', 'MW', 'Malawi', 'AFRO', '0', '5953', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49915, '2020-11-12', 'MW', 'Malawi', 'AFRO', '2', '5955', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49916, '2020-11-13', 'MW', 'Malawi', 'AFRO', '3', '5958', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49917, '2020-11-14', 'MW', 'Malawi', 'AFRO', '4', '5962', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49918, '2020-11-15', 'MW', 'Malawi', 'AFRO', '2', '5964', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49919, '2020-11-16', 'MW', 'Malawi', 'AFRO', '1', '5965', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49920, '2020-11-17', 'MW', 'Malawi', 'AFRO', '6', '5971', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49921, '2020-11-18', 'MW', 'Malawi', 'AFRO', '0', '5971', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49922, '2020-11-19', 'MW', 'Malawi', 'AFRO', '27', '5998', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49923, '2020-11-20', 'MW', 'Malawi', 'AFRO', '4', '6002', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49924, '2020-11-21', 'MW', 'Malawi', 'AFRO', '1', '6003', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49925, '2020-11-22', 'MW', 'Malawi', 'AFRO', '0', '6003', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49926, '2020-11-23', 'MW', 'Malawi', 'AFRO', '0', '6003', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49927, '2020-11-24', 'MW', 'Malawi', 'AFRO', '6', '6009', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49928, '2020-11-25', 'MW', 'Malawi', 'AFRO', '8', '6017', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49929, '2020-11-26', 'MW', 'Malawi', 'AFRO', '1', '6018', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49930, '2020-11-27', 'MW', 'Malawi', 'AFRO', '2', '6020', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49931, '2020-11-28', 'MW', 'Malawi', 'AFRO', '4', '6024', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49932, '2020-11-29', 'MW', 'Malawi', 'AFRO', '1', '6025', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49933, '2020-11-30', 'MW', 'Malawi', 'AFRO', '0', '6025', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49934, '2020-12-01', 'MW', 'Malawi', 'AFRO', '3', '6028', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49935, '2020-12-02', 'MW', 'Malawi', 'AFRO', '0', '6028', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49936, '2020-12-03', 'MW', 'Malawi', 'AFRO', '12', '6040', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49937, '2020-12-04', 'MW', 'Malawi', 'AFRO', '3', '6043', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49938, '2020-12-05', 'MW', 'Malawi', 'AFRO', '4', '6047', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49939, '2020-12-06', 'MW', 'Malawi', 'AFRO', '2', '6049', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49940, '2020-12-07', 'MW', 'Malawi', 'AFRO', '2', '6051', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49941, '2020-12-08', 'MW', 'Malawi', 'AFRO', '0', '6051', '0', '185');
INSERT INTO public.who_global_data_import VALUES (49942, '2020-12-09', 'MW', 'Malawi', 'AFRO', '0', '6051', '1', '186');
INSERT INTO public.who_global_data_import VALUES (49943, '2020-12-10', 'MW', 'Malawi', 'AFRO', '0', '6051', '0', '186');
INSERT INTO public.who_global_data_import VALUES (49944, '2020-12-11', 'MW', 'Malawi', 'AFRO', '2', '6053', '0', '186');
INSERT INTO public.who_global_data_import VALUES (49945, '2020-12-12', 'MW', 'Malawi', 'AFRO', '2', '6055', '0', '186');
INSERT INTO public.who_global_data_import VALUES (49946, '2020-12-13', 'MW', 'Malawi', 'AFRO', '11', '6066', '0', '186');
INSERT INTO public.who_global_data_import VALUES (49947, '2020-12-14', 'MW', 'Malawi', 'AFRO', '0', '6066', '1', '187');
INSERT INTO public.who_global_data_import VALUES (49948, '2020-12-15', 'MW', 'Malawi', 'AFRO', '4', '6070', '0', '187');
INSERT INTO public.who_global_data_import VALUES (49949, '2020-12-16', 'MW', 'Malawi', 'AFRO', '10', '6080', '0', '187');
INSERT INTO public.who_global_data_import VALUES (49950, '2020-12-17', 'MW', 'Malawi', 'AFRO', '11', '6091', '0', '187');
INSERT INTO public.who_global_data_import VALUES (49951, '2020-12-18', 'MW', 'Malawi', 'AFRO', '47', '6138', '0', '187');
INSERT INTO public.who_global_data_import VALUES (49952, '2020-12-19', 'MW', 'Malawi', 'AFRO', '10', '6148', '0', '187');
INSERT INTO public.who_global_data_import VALUES (49953, '2020-12-20', 'MW', 'Malawi', 'AFRO', '5', '6153', '0', '187');
INSERT INTO public.who_global_data_import VALUES (49954, '2020-12-21', 'MW', 'Malawi', 'AFRO', '8', '6161', '0', '187');
INSERT INTO public.who_global_data_import VALUES (49955, '2020-12-22', 'MW', 'Malawi', 'AFRO', '41', '6202', '0', '187');
INSERT INTO public.who_global_data_import VALUES (49956, '2020-12-23', 'MW', 'Malawi', 'AFRO', '46', '6248', '0', '187');
INSERT INTO public.who_global_data_import VALUES (49957, '2020-12-24', 'MW', 'Malawi', 'AFRO', '13', '6261', '0', '187');
INSERT INTO public.who_global_data_import VALUES (49958, '2020-12-25', 'MW', 'Malawi', 'AFRO', '16', '6277', '0', '187');
INSERT INTO public.who_global_data_import VALUES (49959, '2020-12-26', 'MW', 'Malawi', 'AFRO', '62', '6339', '0', '187');
INSERT INTO public.who_global_data_import VALUES (49960, '2020-12-27', 'MW', 'Malawi', 'AFRO', '4', '6343', '1', '188');
INSERT INTO public.who_global_data_import VALUES (49961, '2020-12-28', 'MW', 'Malawi', 'AFRO', '11', '6354', '0', '188');
INSERT INTO public.who_global_data_import VALUES (49962, '2020-12-29', 'MW', 'Malawi', 'AFRO', '0', '6354', '0', '188');
INSERT INTO public.who_global_data_import VALUES (49963, '2020-12-30', 'MW', 'Malawi', 'AFRO', '35', '6389', '0', '188');
INSERT INTO public.who_global_data_import VALUES (49964, '2020-12-31', 'MW', 'Malawi', 'AFRO', '82', '6471', '1', '189');
INSERT INTO public.who_global_data_import VALUES (49965, '2021-01-01', 'MW', 'Malawi', 'AFRO', '112', '6583', '0', '189');
INSERT INTO public.who_global_data_import VALUES (49966, '2021-01-02', 'MW', 'Malawi', 'AFRO', '0', '6583', '0', '189');
INSERT INTO public.who_global_data_import VALUES (49967, '2021-01-03', 'MW', 'Malawi', 'AFRO', '128', '6711', '3', '192');
INSERT INTO public.who_global_data_import VALUES (49968, '2021-01-04', 'MW', 'Malawi', 'AFRO', '133', '6844', '3', '195');
INSERT INTO public.who_global_data_import VALUES (49969, '2021-01-05', 'MW', 'Malawi', 'AFRO', '91', '6935', '1', '196');
INSERT INTO public.who_global_data_import VALUES (49970, '2021-01-06', 'MW', 'Malawi', 'AFRO', '175', '7110', '3', '199');
INSERT INTO public.who_global_data_import VALUES (49971, '2021-01-07', 'MW', 'Malawi', 'AFRO', '227', '7337', '0', '199');
INSERT INTO public.who_global_data_import VALUES (49972, '2021-01-08', 'MW', 'Malawi', 'AFRO', '274', '7611', '4', '203');
INSERT INTO public.who_global_data_import VALUES (49973, '2021-01-09', 'MW', 'Malawi', 'AFRO', '314', '7925', '5', '208');
INSERT INTO public.who_global_data_import VALUES (49974, '2021-01-10', 'MW', 'Malawi', 'AFRO', '381', '8306', '12', '220');
INSERT INTO public.who_global_data_import VALUES (49975, '2021-01-11', 'MW', 'Malawi', 'AFRO', '269', '8575', '5', '225');
INSERT INTO public.who_global_data_import VALUES (49976, '2021-01-12', 'MW', 'Malawi', 'AFRO', '452', '9027', '10', '235');
INSERT INTO public.who_global_data_import VALUES (49977, '2021-01-13', 'MW', 'Malawi', 'AFRO', '373', '9400', '19', '254');
INSERT INTO public.who_global_data_import VALUES (49978, '2021-01-14', 'MW', 'Malawi', 'AFRO', '591', '9991', '21', '275');
INSERT INTO public.who_global_data_import VALUES (49979, '2021-01-15', 'MW', 'Malawi', 'AFRO', '503', '10494', '10', '285');
INSERT INTO public.who_global_data_import VALUES (49980, '2021-01-16', 'MW', 'Malawi', 'AFRO', '0', '10494', '0', '285');
INSERT INTO public.who_global_data_import VALUES (49981, '2021-01-17', 'MW', 'Malawi', 'AFRO', '1291', '11785', '15', '300');
INSERT INTO public.who_global_data_import VALUES (49982, '2021-01-18', 'MW', 'Malawi', 'AFRO', '685', '12470', '14', '314');
INSERT INTO public.who_global_data_import VALUES (49983, '2021-01-19', 'MW', 'Malawi', 'AFRO', '557', '13027', '7', '321');
INSERT INTO public.who_global_data_import VALUES (49984, '2021-01-20', 'MW', 'Malawi', 'AFRO', '853', '13880', '15', '336');
INSERT INTO public.who_global_data_import VALUES (49985, '2021-01-21', 'MW', 'Malawi', 'AFRO', '971', '14851', '18', '354');
INSERT INTO public.who_global_data_import VALUES (49986, '2021-01-22', 'MW', 'Malawi', 'AFRO', '1197', '16048', '42', '396');
INSERT INTO public.who_global_data_import VALUES (49987, '2021-01-23', 'MW', 'Malawi', 'AFRO', '1315', '17363', '49', '445');
INSERT INTO public.who_global_data_import VALUES (49988, '2021-01-24', 'MW', 'Malawi', 'AFRO', '1076', '18439', '25', '470');
INSERT INTO public.who_global_data_import VALUES (49989, '2021-01-25', 'MW', 'Malawi', 'AFRO', '956', '19395', '38', '508');
INSERT INTO public.who_global_data_import VALUES (49990, '2021-01-26', 'MW', 'Malawi', 'AFRO', '592', '19987', '10', '518');
INSERT INTO public.who_global_data_import VALUES (49991, '2021-01-27', 'MW', 'Malawi', 'AFRO', '843', '20830', '22', '540');
INSERT INTO public.who_global_data_import VALUES (49992, '2021-01-28', 'MW', 'Malawi', 'AFRO', '830', '21660', '15', '555');
INSERT INTO public.who_global_data_import VALUES (49993, '2021-01-29', 'MW', 'Malawi', 'AFRO', '644', '22304', '73', '628');
INSERT INTO public.who_global_data_import VALUES (49994, '2021-01-30', 'MW', 'Malawi', 'AFRO', '716', '23020', '15', '643');
INSERT INTO public.who_global_data_import VALUES (49995, '2021-01-31', 'MW', 'Malawi', 'AFRO', '477', '23497', '44', '687');
INSERT INTO public.who_global_data_import VALUES (49996, '2021-02-01', 'MW', 'Malawi', 'AFRO', '466', '23963', '15', '702');
INSERT INTO public.who_global_data_import VALUES (49997, '2021-02-02', 'MW', 'Malawi', 'AFRO', '402', '24365', '10', '712');
INSERT INTO public.who_global_data_import VALUES (49998, '2021-02-03', 'MW', 'Malawi', 'AFRO', '538', '24903', '14', '726');
INSERT INTO public.who_global_data_import VALUES (49999, '2021-02-04', 'MW', 'Malawi', 'AFRO', '546', '25449', '35', '761');
INSERT INTO public.who_global_data_import VALUES (50000, '2021-02-05', 'MW', 'Malawi', 'AFRO', '435', '25884', '18', '779');
INSERT INTO public.who_global_data_import VALUES (50001, '2020-01-03', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50002, '2020-01-04', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50003, '2020-01-05', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50004, '2020-01-06', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50005, '2020-01-07', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50006, '2020-01-08', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50007, '2020-01-09', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50008, '2020-01-10', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50009, '2020-01-11', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50010, '2020-01-12', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50011, '2020-01-13', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50012, '2020-01-14', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50013, '2020-01-15', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50014, '2020-01-16', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50015, '2020-01-17', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50016, '2020-01-18', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50017, '2020-01-19', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50018, '2020-01-20', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50019, '2020-01-21', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50020, '2020-01-22', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50021, '2020-01-23', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50022, '2020-01-24', 'MY', 'Malaysia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50023, '2020-01-25', 'MY', 'Malaysia', 'WPRO', '7', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50024, '2020-01-26', 'MY', 'Malaysia', 'WPRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50025, '2020-01-27', 'MY', 'Malaysia', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50026, '2020-01-28', 'MY', 'Malaysia', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50027, '2020-01-29', 'MY', 'Malaysia', 'WPRO', '3', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50028, '2020-01-30', 'MY', 'Malaysia', 'WPRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50029, '2020-01-31', 'MY', 'Malaysia', 'WPRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50030, '2020-02-01', 'MY', 'Malaysia', 'WPRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50031, '2020-02-02', 'MY', 'Malaysia', 'WPRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50032, '2020-02-03', 'MY', 'Malaysia', 'WPRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50033, '2020-02-04', 'MY', 'Malaysia', 'WPRO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50034, '2020-02-05', 'MY', 'Malaysia', 'WPRO', '2', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50035, '2020-02-06', 'MY', 'Malaysia', 'WPRO', '2', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50036, '2020-02-07', 'MY', 'Malaysia', 'WPRO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50037, '2020-02-08', 'MY', 'Malaysia', 'WPRO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50038, '2020-02-09', 'MY', 'Malaysia', 'WPRO', '1', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50039, '2020-02-10', 'MY', 'Malaysia', 'WPRO', '1', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50040, '2020-02-11', 'MY', 'Malaysia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50041, '2020-02-12', 'MY', 'Malaysia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50042, '2020-02-13', 'MY', 'Malaysia', 'WPRO', '1', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50043, '2020-02-14', 'MY', 'Malaysia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50044, '2020-02-15', 'MY', 'Malaysia', 'WPRO', '3', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50045, '2020-02-16', 'MY', 'Malaysia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50046, '2020-02-17', 'MY', 'Malaysia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50047, '2020-02-18', 'MY', 'Malaysia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50048, '2020-02-19', 'MY', 'Malaysia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50049, '2020-02-20', 'MY', 'Malaysia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50050, '2020-02-21', 'MY', 'Malaysia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50051, '2020-02-22', 'MY', 'Malaysia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50052, '2020-02-23', 'MY', 'Malaysia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50053, '2020-02-24', 'MY', 'Malaysia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50054, '2020-02-25', 'MY', 'Malaysia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50055, '2020-02-26', 'MY', 'Malaysia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50056, '2020-02-27', 'MY', 'Malaysia', 'WPRO', '2', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50057, '2020-02-28', 'MY', 'Malaysia', 'WPRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50058, '2020-02-29', 'MY', 'Malaysia', 'WPRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50059, '2020-03-01', 'MY', 'Malaysia', 'WPRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50060, '2020-03-02', 'MY', 'Malaysia', 'WPRO', '5', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50061, '2020-03-03', 'MY', 'Malaysia', 'WPRO', '7', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50062, '2020-03-04', 'MY', 'Malaysia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50063, '2020-03-05', 'MY', 'Malaysia', 'WPRO', '14', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50064, '2020-03-06', 'MY', 'Malaysia', 'WPRO', '33', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50065, '2020-03-07', 'MY', 'Malaysia', 'WPRO', '10', '97', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50066, '2020-03-08', 'MY', 'Malaysia', 'WPRO', '0', '97', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50067, '2020-03-09', 'MY', 'Malaysia', 'WPRO', '24', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50068, '2020-03-10', 'MY', 'Malaysia', 'WPRO', '0', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50069, '2020-03-11', 'MY', 'Malaysia', 'WPRO', '12', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50070, '2020-03-12', 'MY', 'Malaysia', 'WPRO', '0', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50071, '2020-03-13', 'MY', 'Malaysia', 'WPRO', '0', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50072, '2020-03-14', 'MY', 'Malaysia', 'WPRO', '68', '201', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50073, '2020-03-15', 'MY', 'Malaysia', 'WPRO', '41', '242', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50074, '2020-03-16', 'MY', 'Malaysia', 'WPRO', '315', '557', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50075, '2020-03-17', 'MY', 'Malaysia', 'WPRO', '0', '557', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50076, '2020-03-18', 'MY', 'Malaysia', 'WPRO', '120', '677', '2', '2');
INSERT INTO public.who_global_data_import VALUES (50077, '2020-03-19', 'MY', 'Malaysia', 'WPRO', '223', '900', '0', '2');
INSERT INTO public.who_global_data_import VALUES (50078, '2020-03-20', 'MY', 'Malaysia', 'WPRO', '130', '1030', '1', '3');
INSERT INTO public.who_global_data_import VALUES (50079, '2020-03-21', 'MY', 'Malaysia', 'WPRO', '153', '1183', '0', '3');
INSERT INTO public.who_global_data_import VALUES (50080, '2020-03-22', 'MY', 'Malaysia', 'WPRO', '0', '1183', '6', '9');
INSERT INTO public.who_global_data_import VALUES (50081, '2020-03-23', 'MY', 'Malaysia', 'WPRO', '123', '1306', '2', '11');
INSERT INTO public.who_global_data_import VALUES (50082, '2020-03-24', 'MY', 'Malaysia', 'WPRO', '212', '1518', '4', '15');
INSERT INTO public.who_global_data_import VALUES (50083, '2020-03-25', 'MY', 'Malaysia', 'WPRO', '278', '1796', '1', '16');
INSERT INTO public.who_global_data_import VALUES (50084, '2020-03-26', 'MY', 'Malaysia', 'WPRO', '0', '1796', '5', '21');
INSERT INTO public.who_global_data_import VALUES (50085, '2020-03-27', 'MY', 'Malaysia', 'WPRO', '235', '2031', '2', '23');
INSERT INTO public.who_global_data_import VALUES (50086, '2020-03-28', 'MY', 'Malaysia', 'WPRO', '130', '2161', '3', '26');
INSERT INTO public.who_global_data_import VALUES (50087, '2020-03-29', 'MY', 'Malaysia', 'WPRO', '159', '2320', '1', '27');
INSERT INTO public.who_global_data_import VALUES (50088, '2020-03-30', 'MY', 'Malaysia', 'WPRO', '150', '2470', '7', '34');
INSERT INTO public.who_global_data_import VALUES (50089, '2020-03-31', 'MY', 'Malaysia', 'WPRO', '156', '2626', '3', '37');
INSERT INTO public.who_global_data_import VALUES (50090, '2020-04-01', 'MY', 'Malaysia', 'WPRO', '140', '2766', '6', '43');
INSERT INTO public.who_global_data_import VALUES (50091, '2020-04-02', 'MY', 'Malaysia', 'WPRO', '142', '2908', '2', '45');
INSERT INTO public.who_global_data_import VALUES (50092, '2020-04-03', 'MY', 'Malaysia', 'WPRO', '208', '3116', '5', '50');
INSERT INTO public.who_global_data_import VALUES (50093, '2020-04-04', 'MY', 'Malaysia', 'WPRO', '217', '3333', '3', '53');
INSERT INTO public.who_global_data_import VALUES (50094, '2020-04-05', 'MY', 'Malaysia', 'WPRO', '150', '3483', '4', '57');
INSERT INTO public.who_global_data_import VALUES (50095, '2020-04-06', 'MY', 'Malaysia', 'WPRO', '179', '3662', '4', '61');
INSERT INTO public.who_global_data_import VALUES (50096, '2020-04-07', 'MY', 'Malaysia', 'WPRO', '131', '3793', '1', '62');
INSERT INTO public.who_global_data_import VALUES (50097, '2020-04-08', 'MY', 'Malaysia', 'WPRO', '170', '3963', '1', '63');
INSERT INTO public.who_global_data_import VALUES (50098, '2020-04-09', 'MY', 'Malaysia', 'WPRO', '156', '4119', '2', '65');
INSERT INTO public.who_global_data_import VALUES (50099, '2020-04-10', 'MY', 'Malaysia', 'WPRO', '109', '4228', '2', '67');
INSERT INTO public.who_global_data_import VALUES (50100, '2020-04-11', 'MY', 'Malaysia', 'WPRO', '118', '4346', '3', '70');
INSERT INTO public.who_global_data_import VALUES (50101, '2020-04-12', 'MY', 'Malaysia', 'WPRO', '184', '4530', '3', '73');
INSERT INTO public.who_global_data_import VALUES (50102, '2020-04-13', 'MY', 'Malaysia', 'WPRO', '153', '4683', '3', '76');
INSERT INTO public.who_global_data_import VALUES (50103, '2020-04-14', 'MY', 'Malaysia', 'WPRO', '134', '4817', '1', '77');
INSERT INTO public.who_global_data_import VALUES (50104, '2020-04-15', 'MY', 'Malaysia', 'WPRO', '170', '4987', '5', '82');
INSERT INTO public.who_global_data_import VALUES (50105, '2020-04-16', 'MY', 'Malaysia', 'WPRO', '85', '5072', '1', '83');
INSERT INTO public.who_global_data_import VALUES (50106, '2020-04-17', 'MY', 'Malaysia', 'WPRO', '110', '5182', '1', '84');
INSERT INTO public.who_global_data_import VALUES (50107, '2020-04-18', 'MY', 'Malaysia', 'WPRO', '69', '5251', '2', '86');
INSERT INTO public.who_global_data_import VALUES (50108, '2020-04-19', 'MY', 'Malaysia', 'WPRO', '54', '5305', '2', '88');
INSERT INTO public.who_global_data_import VALUES (50109, '2020-04-20', 'MY', 'Malaysia', 'WPRO', '84', '5389', '1', '89');
INSERT INTO public.who_global_data_import VALUES (50110, '2020-04-21', 'MY', 'Malaysia', 'WPRO', '35', '5424', '0', '89');
INSERT INTO public.who_global_data_import VALUES (50111, '2020-04-22', 'MY', 'Malaysia', 'WPRO', '58', '5482', '3', '92');
INSERT INTO public.who_global_data_import VALUES (50112, '2020-04-23', 'MY', 'Malaysia', 'WPRO', '50', '5532', '1', '93');
INSERT INTO public.who_global_data_import VALUES (50113, '2020-04-24', 'MY', 'Malaysia', 'WPRO', '71', '5603', '2', '95');
INSERT INTO public.who_global_data_import VALUES (50114, '2020-04-25', 'MY', 'Malaysia', 'WPRO', '88', '5691', '1', '96');
INSERT INTO public.who_global_data_import VALUES (50115, '2020-04-26', 'MY', 'Malaysia', 'WPRO', '51', '5742', '2', '98');
INSERT INTO public.who_global_data_import VALUES (50116, '2020-04-27', 'MY', 'Malaysia', 'WPRO', '38', '5780', '0', '98');
INSERT INTO public.who_global_data_import VALUES (50117, '2020-04-28', 'MY', 'Malaysia', 'WPRO', '40', '5820', '1', '99');
INSERT INTO public.who_global_data_import VALUES (50118, '2020-04-29', 'MY', 'Malaysia', 'WPRO', '31', '5851', '1', '100');
INSERT INTO public.who_global_data_import VALUES (50119, '2020-04-30', 'MY', 'Malaysia', 'WPRO', '94', '5945', '0', '100');
INSERT INTO public.who_global_data_import VALUES (50120, '2020-05-01', 'MY', 'Malaysia', 'WPRO', '57', '6002', '2', '102');
INSERT INTO public.who_global_data_import VALUES (50121, '2020-05-02', 'MY', 'Malaysia', 'WPRO', '69', '6071', '1', '103');
INSERT INTO public.who_global_data_import VALUES (50122, '2020-05-03', 'MY', 'Malaysia', 'WPRO', '105', '6176', '0', '103');
INSERT INTO public.who_global_data_import VALUES (50123, '2020-05-04', 'MY', 'Malaysia', 'WPRO', '122', '6298', '2', '105');
INSERT INTO public.who_global_data_import VALUES (50124, '2020-05-05', 'MY', 'Malaysia', 'WPRO', '55', '6353', '0', '105');
INSERT INTO public.who_global_data_import VALUES (50125, '2020-05-06', 'MY', 'Malaysia', 'WPRO', '30', '6383', '1', '106');
INSERT INTO public.who_global_data_import VALUES (50126, '2020-05-07', 'MY', 'Malaysia', 'WPRO', '45', '6428', '1', '107');
INSERT INTO public.who_global_data_import VALUES (50127, '2020-05-08', 'MY', 'Malaysia', 'WPRO', '39', '6467', '0', '107');
INSERT INTO public.who_global_data_import VALUES (50128, '2020-05-09', 'MY', 'Malaysia', 'WPRO', '68', '6535', '0', '107');
INSERT INTO public.who_global_data_import VALUES (50129, '2020-05-10', 'MY', 'Malaysia', 'WPRO', '54', '6589', '1', '108');
INSERT INTO public.who_global_data_import VALUES (50130, '2020-05-11', 'MY', 'Malaysia', 'WPRO', '67', '6656', '0', '108');
INSERT INTO public.who_global_data_import VALUES (50131, '2020-05-12', 'MY', 'Malaysia', 'WPRO', '70', '6726', '1', '109');
INSERT INTO public.who_global_data_import VALUES (50132, '2020-05-13', 'MY', 'Malaysia', 'WPRO', '16', '6742', '0', '109');
INSERT INTO public.who_global_data_import VALUES (50133, '2020-05-14', 'MY', 'Malaysia', 'WPRO', '37', '6779', '2', '111');
INSERT INTO public.who_global_data_import VALUES (50134, '2020-05-15', 'MY', 'Malaysia', 'WPRO', '40', '6819', '1', '112');
INSERT INTO public.who_global_data_import VALUES (50135, '2020-05-16', 'MY', 'Malaysia', 'WPRO', '36', '6855', '0', '112');
INSERT INTO public.who_global_data_import VALUES (50136, '2020-05-17', 'MY', 'Malaysia', 'WPRO', '17', '6872', '1', '113');
INSERT INTO public.who_global_data_import VALUES (50137, '2020-05-18', 'MY', 'Malaysia', 'WPRO', '22', '6894', '0', '113');
INSERT INTO public.who_global_data_import VALUES (50138, '2020-05-19', 'MY', 'Malaysia', 'WPRO', '47', '6941', '0', '113');
INSERT INTO public.who_global_data_import VALUES (50139, '2020-05-20', 'MY', 'Malaysia', 'WPRO', '37', '6978', '1', '114');
INSERT INTO public.who_global_data_import VALUES (50140, '2020-05-21', 'MY', 'Malaysia', 'WPRO', '31', '7009', '0', '114');
INSERT INTO public.who_global_data_import VALUES (50141, '2020-05-22', 'MY', 'Malaysia', 'WPRO', '50', '7059', '0', '114');
INSERT INTO public.who_global_data_import VALUES (50142, '2020-05-23', 'MY', 'Malaysia', 'WPRO', '78', '7137', '1', '115');
INSERT INTO public.who_global_data_import VALUES (50143, '2020-05-24', 'MY', 'Malaysia', 'WPRO', '48', '7185', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50144, '2020-05-25', 'MY', 'Malaysia', 'WPRO', '60', '7245', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50145, '2020-05-26', 'MY', 'Malaysia', 'WPRO', '172', '7417', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50146, '2020-05-27', 'MY', 'Malaysia', 'WPRO', '187', '7604', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50147, '2020-05-28', 'MY', 'Malaysia', 'WPRO', '15', '7619', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50148, '2020-05-29', 'MY', 'Malaysia', 'WPRO', '10', '7629', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50149, '2020-05-30', 'MY', 'Malaysia', 'WPRO', '103', '7732', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50150, '2020-05-31', 'MY', 'Malaysia', 'WPRO', '30', '7762', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50151, '2020-06-01', 'MY', 'Malaysia', 'WPRO', '57', '7819', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50152, '2020-06-02', 'MY', 'Malaysia', 'WPRO', '38', '7857', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50153, '2020-06-03', 'MY', 'Malaysia', 'WPRO', '20', '7877', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50154, '2020-06-04', 'MY', 'Malaysia', 'WPRO', '93', '7970', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50155, '2020-06-05', 'MY', 'Malaysia', 'WPRO', '277', '8247', '0', '115');
INSERT INTO public.who_global_data_import VALUES (50156, '2020-06-06', 'MY', 'Malaysia', 'WPRO', '19', '8266', '1', '116');
INSERT INTO public.who_global_data_import VALUES (50157, '2020-06-07', 'MY', 'Malaysia', 'WPRO', '37', '8303', '1', '117');
INSERT INTO public.who_global_data_import VALUES (50158, '2020-06-08', 'MY', 'Malaysia', 'WPRO', '19', '8322', '0', '117');
INSERT INTO public.who_global_data_import VALUES (50159, '2020-06-09', 'MY', 'Malaysia', 'WPRO', '7', '8329', '0', '117');
INSERT INTO public.who_global_data_import VALUES (50160, '2020-06-10', 'MY', 'Malaysia', 'WPRO', '7', '8336', '0', '117');
INSERT INTO public.who_global_data_import VALUES (50161, '2020-06-11', 'MY', 'Malaysia', 'WPRO', '2', '8338', '1', '118');
INSERT INTO public.who_global_data_import VALUES (50162, '2020-06-12', 'MY', 'Malaysia', 'WPRO', '31', '8369', '0', '118');
INSERT INTO public.who_global_data_import VALUES (50163, '2020-06-13', 'MY', 'Malaysia', 'WPRO', '33', '8402', '1', '119');
INSERT INTO public.who_global_data_import VALUES (50164, '2020-06-14', 'MY', 'Malaysia', 'WPRO', '43', '8445', '1', '120');
INSERT INTO public.who_global_data_import VALUES (50165, '2020-06-15', 'MY', 'Malaysia', 'WPRO', '8', '8453', '1', '121');
INSERT INTO public.who_global_data_import VALUES (50166, '2020-06-16', 'MY', 'Malaysia', 'WPRO', '41', '8494', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50167, '2020-06-17', 'MY', 'Malaysia', 'WPRO', '11', '8505', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50168, '2020-06-18', 'MY', 'Malaysia', 'WPRO', '10', '8515', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50169, '2020-06-19', 'MY', 'Malaysia', 'WPRO', '14', '8529', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50170, '2020-06-20', 'MY', 'Malaysia', 'WPRO', '6', '8535', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50171, '2020-06-21', 'MY', 'Malaysia', 'WPRO', '21', '8556', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50172, '2020-06-22', 'MY', 'Malaysia', 'WPRO', '16', '8572', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50173, '2020-06-23', 'MY', 'Malaysia', 'WPRO', '15', '8587', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50174, '2020-06-24', 'MY', 'Malaysia', 'WPRO', '3', '8590', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50175, '2020-06-25', 'MY', 'Malaysia', 'WPRO', '6', '8596', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50176, '2020-06-26', 'MY', 'Malaysia', 'WPRO', '4', '8600', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50177, '2020-06-27', 'MY', 'Malaysia', 'WPRO', '6', '8606', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50178, '2020-06-28', 'MY', 'Malaysia', 'WPRO', '10', '8616', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50179, '2020-06-29', 'MY', 'Malaysia', 'WPRO', '18', '8634', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50180, '2020-06-30', 'MY', 'Malaysia', 'WPRO', '3', '8637', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50181, '2020-07-01', 'MY', 'Malaysia', 'WPRO', '2', '8639', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50182, '2020-07-02', 'MY', 'Malaysia', 'WPRO', '1', '8640', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50183, '2020-07-03', 'MY', 'Malaysia', 'WPRO', '3', '8643', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50184, '2020-07-04', 'MY', 'Malaysia', 'WPRO', '5', '8648', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50185, '2020-07-05', 'MY', 'Malaysia', 'WPRO', '10', '8658', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50186, '2020-07-06', 'MY', 'Malaysia', 'WPRO', '5', '8663', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50187, '2020-07-07', 'MY', 'Malaysia', 'WPRO', '5', '8668', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50188, '2020-07-08', 'MY', 'Malaysia', 'WPRO', '6', '8674', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50189, '2020-07-09', 'MY', 'Malaysia', 'WPRO', '3', '8677', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50190, '2020-07-10', 'MY', 'Malaysia', 'WPRO', '6', '8683', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50191, '2020-07-11', 'MY', 'Malaysia', 'WPRO', '13', '8696', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50192, '2020-07-12', 'MY', 'Malaysia', 'WPRO', '8', '8704', '1', '122');
INSERT INTO public.who_global_data_import VALUES (50193, '2020-07-13', 'MY', 'Malaysia', 'WPRO', '14', '8718', '0', '122');
INSERT INTO public.who_global_data_import VALUES (50194, '2020-07-14', 'MY', 'Malaysia', 'WPRO', '7', '8725', '0', '122');
INSERT INTO public.who_global_data_import VALUES (50195, '2020-07-15', 'MY', 'Malaysia', 'WPRO', '4', '8729', '0', '122');
INSERT INTO public.who_global_data_import VALUES (50196, '2020-07-16', 'MY', 'Malaysia', 'WPRO', '5', '8734', '0', '122');
INSERT INTO public.who_global_data_import VALUES (50197, '2020-07-17', 'MY', 'Malaysia', 'WPRO', '3', '8737', '0', '122');
INSERT INTO public.who_global_data_import VALUES (50198, '2020-07-18', 'MY', 'Malaysia', 'WPRO', '18', '8755', '0', '122');
INSERT INTO public.who_global_data_import VALUES (50199, '2020-07-19', 'MY', 'Malaysia', 'WPRO', '9', '8764', '0', '122');
INSERT INTO public.who_global_data_import VALUES (50200, '2020-07-20', 'MY', 'Malaysia', 'WPRO', '15', '8779', '1', '123');
INSERT INTO public.who_global_data_import VALUES (50201, '2020-07-21', 'MY', 'Malaysia', 'WPRO', '21', '8800', '0', '123');
INSERT INTO public.who_global_data_import VALUES (50202, '2020-07-22', 'MY', 'Malaysia', 'WPRO', '15', '8815', '0', '123');
INSERT INTO public.who_global_data_import VALUES (50203, '2020-07-23', 'MY', 'Malaysia', 'WPRO', '16', '8831', '0', '123');
INSERT INTO public.who_global_data_import VALUES (50204, '2020-07-24', 'MY', 'Malaysia', 'WPRO', '9', '8840', '0', '123');
INSERT INTO public.who_global_data_import VALUES (50205, '2020-07-25', 'MY', 'Malaysia', 'WPRO', '21', '8861', '0', '123');
INSERT INTO public.who_global_data_import VALUES (50206, '2020-07-26', 'MY', 'Malaysia', 'WPRO', '23', '8884', '0', '123');
INSERT INTO public.who_global_data_import VALUES (50207, '2020-07-27', 'MY', 'Malaysia', 'WPRO', '13', '8897', '1', '124');
INSERT INTO public.who_global_data_import VALUES (50208, '2020-07-28', 'MY', 'Malaysia', 'WPRO', '7', '8904', '0', '124');
INSERT INTO public.who_global_data_import VALUES (50209, '2020-07-29', 'MY', 'Malaysia', 'WPRO', '39', '8943', '0', '124');
INSERT INTO public.who_global_data_import VALUES (50210, '2020-07-30', 'MY', 'Malaysia', 'WPRO', '13', '8956', '0', '124');
INSERT INTO public.who_global_data_import VALUES (50211, '2020-07-31', 'MY', 'Malaysia', 'WPRO', '8', '8964', '0', '124');
INSERT INTO public.who_global_data_import VALUES (50212, '2020-08-01', 'MY', 'Malaysia', 'WPRO', '12', '8976', '1', '125');
INSERT INTO public.who_global_data_import VALUES (50213, '2020-08-02', 'MY', 'Malaysia', 'WPRO', '9', '8985', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50214, '2020-08-03', 'MY', 'Malaysia', 'WPRO', '14', '8999', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50215, '2020-08-04', 'MY', 'Malaysia', 'WPRO', '2', '9001', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50216, '2020-08-05', 'MY', 'Malaysia', 'WPRO', '1', '9002', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50217, '2020-08-06', 'MY', 'Malaysia', 'WPRO', '21', '9023', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50218, '2020-08-07', 'MY', 'Malaysia', 'WPRO', '15', '9038', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50219, '2020-08-08', 'MY', 'Malaysia', 'WPRO', '25', '9063', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50220, '2020-08-09', 'MY', 'Malaysia', 'WPRO', '7', '9070', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50221, '2020-08-10', 'MY', 'Malaysia', 'WPRO', '13', '9083', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50222, '2020-08-11', 'MY', 'Malaysia', 'WPRO', '11', '9094', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50223, '2020-08-12', 'MY', 'Malaysia', 'WPRO', '9', '9103', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50224, '2020-08-13', 'MY', 'Malaysia', 'WPRO', '11', '9114', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50225, '2020-08-14', 'MY', 'Malaysia', 'WPRO', '15', '9129', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50226, '2020-08-15', 'MY', 'Malaysia', 'WPRO', '20', '9149', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50227, '2020-08-16', 'MY', 'Malaysia', 'WPRO', '26', '9175', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50228, '2020-08-17', 'MY', 'Malaysia', 'WPRO', '25', '9200', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50229, '2020-08-18', 'MY', 'Malaysia', 'WPRO', '12', '9212', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50230, '2020-08-19', 'MY', 'Malaysia', 'WPRO', '7', '9219', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50231, '2020-08-20', 'MY', 'Malaysia', 'WPRO', '16', '9235', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50232, '2020-08-21', 'MY', 'Malaysia', 'WPRO', '5', '9240', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50233, '2020-08-22', 'MY', 'Malaysia', 'WPRO', '9', '9249', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50234, '2020-08-23', 'MY', 'Malaysia', 'WPRO', '8', '9257', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50235, '2020-08-24', 'MY', 'Malaysia', 'WPRO', '10', '9267', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50236, '2020-08-25', 'MY', 'Malaysia', 'WPRO', '7', '9274', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50237, '2020-08-26', 'MY', 'Malaysia', 'WPRO', '11', '9285', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50238, '2020-08-27', 'MY', 'Malaysia', 'WPRO', '6', '9291', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50239, '2020-08-28', 'MY', 'Malaysia', 'WPRO', '5', '9296', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50240, '2020-08-29', 'MY', 'Malaysia', 'WPRO', '10', '9306', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50241, '2020-08-30', 'MY', 'Malaysia', 'WPRO', '11', '9317', '0', '125');
INSERT INTO public.who_global_data_import VALUES (50242, '2020-08-31', 'MY', 'Malaysia', 'WPRO', '17', '9334', '1', '126');
INSERT INTO public.who_global_data_import VALUES (50243, '2020-09-01', 'MY', 'Malaysia', 'WPRO', '6', '9340', '1', '127');
INSERT INTO public.who_global_data_import VALUES (50244, '2020-09-02', 'MY', 'Malaysia', 'WPRO', '14', '9354', '1', '128');
INSERT INTO public.who_global_data_import VALUES (50245, '2020-09-03', 'MY', 'Malaysia', 'WPRO', '6', '9360', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50246, '2020-09-04', 'MY', 'Malaysia', 'WPRO', '14', '9374', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50247, '2020-09-05', 'MY', 'Malaysia', 'WPRO', '11', '9385', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50248, '2020-09-06', 'MY', 'Malaysia', 'WPRO', '6', '9391', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50249, '2020-09-07', 'MY', 'Malaysia', 'WPRO', '6', '9397', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50250, '2020-09-08', 'MY', 'Malaysia', 'WPRO', '62', '9459', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50251, '2020-09-09', 'MY', 'Malaysia', 'WPRO', '100', '9559', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50252, '2020-09-10', 'MY', 'Malaysia', 'WPRO', '24', '9583', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50253, '2020-09-11', 'MY', 'Malaysia', 'WPRO', '45', '9628', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50254, '2020-09-12', 'MY', 'Malaysia', 'WPRO', '182', '9810', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50255, '2020-09-13', 'MY', 'Malaysia', 'WPRO', '58', '9868', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50256, '2020-09-14', 'MY', 'Malaysia', 'WPRO', '47', '9915', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50257, '2020-09-15', 'MY', 'Malaysia', 'WPRO', '31', '9946', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50258, '2020-09-16', 'MY', 'Malaysia', 'WPRO', '23', '9969', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50259, '2020-09-17', 'MY', 'Malaysia', 'WPRO', '62', '10031', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50260, '2020-09-18', 'MY', 'Malaysia', 'WPRO', '21', '10052', '0', '128');
INSERT INTO public.who_global_data_import VALUES (50261, '2020-09-19', 'MY', 'Malaysia', 'WPRO', '95', '10147', '1', '129');
INSERT INTO public.who_global_data_import VALUES (50262, '2020-09-20', 'MY', 'Malaysia', 'WPRO', '20', '10167', '1', '130');
INSERT INTO public.who_global_data_import VALUES (50263, '2020-09-21', 'MY', 'Malaysia', 'WPRO', '52', '10219', '0', '130');
INSERT INTO public.who_global_data_import VALUES (50264, '2020-09-22', 'MY', 'Malaysia', 'WPRO', '57', '10276', '0', '130');
INSERT INTO public.who_global_data_import VALUES (50265, '2020-09-23', 'MY', 'Malaysia', 'WPRO', '82', '10358', '0', '130');
INSERT INTO public.who_global_data_import VALUES (50266, '2020-09-24', 'MY', 'Malaysia', 'WPRO', '147', '10505', '3', '133');
INSERT INTO public.who_global_data_import VALUES (50267, '2020-09-25', 'MY', 'Malaysia', 'WPRO', '71', '10576', '0', '133');
INSERT INTO public.who_global_data_import VALUES (50268, '2020-09-26', 'MY', 'Malaysia', 'WPRO', '111', '10687', '0', '133');
INSERT INTO public.who_global_data_import VALUES (50269, '2020-09-27', 'MY', 'Malaysia', 'WPRO', '82', '10769', '0', '133');
INSERT INTO public.who_global_data_import VALUES (50270, '2020-09-28', 'MY', 'Malaysia', 'WPRO', '150', '10919', '1', '134');
INSERT INTO public.who_global_data_import VALUES (50271, '2020-09-29', 'MY', 'Malaysia', 'WPRO', '115', '11034', '0', '134');
INSERT INTO public.who_global_data_import VALUES (50272, '2020-09-30', 'MY', 'Malaysia', 'WPRO', '101', '11135', '0', '134');
INSERT INTO public.who_global_data_import VALUES (50273, '2020-10-01', 'MY', 'Malaysia', 'WPRO', '89', '11224', '2', '136');
INSERT INTO public.who_global_data_import VALUES (50274, '2020-10-02', 'MY', 'Malaysia', 'WPRO', '260', '11484', '0', '136');
INSERT INTO public.who_global_data_import VALUES (50275, '2020-10-03', 'MY', 'Malaysia', 'WPRO', '287', '11771', '0', '136');
INSERT INTO public.who_global_data_import VALUES (50276, '2020-10-04', 'MY', 'Malaysia', 'WPRO', '317', '12088', '1', '137');
INSERT INTO public.who_global_data_import VALUES (50277, '2020-10-05', 'MY', 'Malaysia', 'WPRO', '293', '12381', '0', '137');
INSERT INTO public.who_global_data_import VALUES (50278, '2020-10-06', 'MY', 'Malaysia', 'WPRO', '432', '12813', '0', '137');
INSERT INTO public.who_global_data_import VALUES (50279, '2020-10-07', 'MY', 'Malaysia', 'WPRO', '691', '13504', '4', '141');
INSERT INTO public.who_global_data_import VALUES (50280, '2020-10-08', 'MY', 'Malaysia', 'WPRO', '489', '13993', '0', '141');
INSERT INTO public.who_global_data_import VALUES (50281, '2020-10-09', 'MY', 'Malaysia', 'WPRO', '375', '14368', '5', '146');
INSERT INTO public.who_global_data_import VALUES (50282, '2020-10-10', 'MY', 'Malaysia', 'WPRO', '354', '14722', '6', '152');
INSERT INTO public.who_global_data_import VALUES (50283, '2020-10-11', 'MY', 'Malaysia', 'WPRO', '374', '15096', '3', '155');
INSERT INTO public.who_global_data_import VALUES (50284, '2020-10-12', 'MY', 'Malaysia', 'WPRO', '561', '15657', '2', '157');
INSERT INTO public.who_global_data_import VALUES (50285, '2020-10-13', 'MY', 'Malaysia', 'WPRO', '563', '16220', '2', '159');
INSERT INTO public.who_global_data_import VALUES (50286, '2020-10-14', 'MY', 'Malaysia', 'WPRO', '660', '16880', '4', '163');
INSERT INTO public.who_global_data_import VALUES (50287, '2020-10-15', 'MY', 'Malaysia', 'WPRO', '660', '17540', '4', '167');
INSERT INTO public.who_global_data_import VALUES (50288, '2020-10-16', 'MY', 'Malaysia', 'WPRO', '589', '18129', '3', '170');
INSERT INTO public.who_global_data_import VALUES (50289, '2020-10-17', 'MY', 'Malaysia', 'WPRO', '629', '18758', '6', '176');
INSERT INTO public.who_global_data_import VALUES (50290, '2020-10-18', 'MY', 'Malaysia', 'WPRO', '869', '19627', '4', '180');
INSERT INTO public.who_global_data_import VALUES (50291, '2020-10-19', 'MY', 'Malaysia', 'WPRO', '871', '20498', '7', '187');
INSERT INTO public.who_global_data_import VALUES (50292, '2020-10-20', 'MY', 'Malaysia', 'WPRO', '865', '21363', '3', '190');
INSERT INTO public.who_global_data_import VALUES (50293, '2020-10-21', 'MY', 'Malaysia', 'WPRO', '862', '22225', '3', '193');
INSERT INTO public.who_global_data_import VALUES (50294, '2020-10-22', 'MY', 'Malaysia', 'WPRO', '732', '22957', '6', '199');
INSERT INTO public.who_global_data_import VALUES (50295, '2020-10-23', 'MY', 'Malaysia', 'WPRO', '847', '23804', '5', '204');
INSERT INTO public.who_global_data_import VALUES (50296, '2020-10-24', 'MY', 'Malaysia', 'WPRO', '710', '24514', '10', '214');
INSERT INTO public.who_global_data_import VALUES (50297, '2020-10-25', 'MY', 'Malaysia', 'WPRO', '1228', '25742', '7', '221');
INSERT INTO public.who_global_data_import VALUES (50298, '2020-10-26', 'MY', 'Malaysia', 'WPRO', '823', '26565', '8', '229');
INSERT INTO public.who_global_data_import VALUES (50299, '2020-10-27', 'MY', 'Malaysia', 'WPRO', '1240', '27805', '7', '236');
INSERT INTO public.who_global_data_import VALUES (50300, '2020-10-28', 'MY', 'Malaysia', 'WPRO', '835', '28640', '2', '238');
INSERT INTO public.who_global_data_import VALUES (50301, '2020-10-29', 'MY', 'Malaysia', 'WPRO', '801', '29441', '8', '246');
INSERT INTO public.who_global_data_import VALUES (50302, '2020-10-30', 'MY', 'Malaysia', 'WPRO', '649', '30090', '0', '246');
INSERT INTO public.who_global_data_import VALUES (50303, '2020-10-31', 'MY', 'Malaysia', 'WPRO', '799', '30889', '3', '249');
INSERT INTO public.who_global_data_import VALUES (50304, '2020-11-01', 'MY', 'Malaysia', 'WPRO', '659', '31548', '0', '249');
INSERT INTO public.who_global_data_import VALUES (50305, '2020-11-02', 'MY', 'Malaysia', 'WPRO', '957', '32505', '0', '249');
INSERT INTO public.who_global_data_import VALUES (50306, '2020-11-03', 'MY', 'Malaysia', 'WPRO', '834', '33339', '2', '251');
INSERT INTO public.who_global_data_import VALUES (50307, '2020-11-04', 'MY', 'Malaysia', 'WPRO', '1054', '34393', '12', '263');
INSERT INTO public.who_global_data_import VALUES (50308, '2020-11-05', 'MY', 'Malaysia', 'WPRO', '1032', '35425', '8', '271');
INSERT INTO public.who_global_data_import VALUES (50309, '2020-11-06', 'MY', 'Malaysia', 'WPRO', '1009', '36434', '6', '277');
INSERT INTO public.who_global_data_import VALUES (50310, '2020-11-07', 'MY', 'Malaysia', 'WPRO', '1755', '38189', '2', '279');
INSERT INTO public.who_global_data_import VALUES (50311, '2020-11-08', 'MY', 'Malaysia', 'WPRO', '1168', '39357', '3', '282');
INSERT INTO public.who_global_data_import VALUES (50312, '2020-11-09', 'MY', 'Malaysia', 'WPRO', '852', '40209', '4', '286');
INSERT INTO public.who_global_data_import VALUES (50313, '2020-11-10', 'MY', 'Malaysia', 'WPRO', '972', '41181', '8', '294');
INSERT INTO public.who_global_data_import VALUES (50314, '2020-11-11', 'MY', 'Malaysia', 'WPRO', '869', '42050', '6', '300');
INSERT INTO public.who_global_data_import VALUES (50315, '2020-11-12', 'MY', 'Malaysia', 'WPRO', '822', '42872', '2', '302');
INSERT INTO public.who_global_data_import VALUES (50316, '2020-11-13', 'MY', 'Malaysia', 'WPRO', '919', '43791', '1', '303');
INSERT INTO public.who_global_data_import VALUES (50317, '2020-11-14', 'MY', 'Malaysia', 'WPRO', '1304', '45095', '1', '304');
INSERT INTO public.who_global_data_import VALUES (50318, '2020-11-15', 'MY', 'Malaysia', 'WPRO', '1114', '46209', '2', '306');
INSERT INTO public.who_global_data_import VALUES (50319, '2020-11-16', 'MY', 'Malaysia', 'WPRO', '1208', '47417', '3', '309');
INSERT INTO public.who_global_data_import VALUES (50320, '2020-11-17', 'MY', 'Malaysia', 'WPRO', '1103', '48520', '4', '313');
INSERT INTO public.who_global_data_import VALUES (50321, '2020-11-18', 'MY', 'Malaysia', 'WPRO', '1210', '49730', '5', '318');
INSERT INTO public.who_global_data_import VALUES (50322, '2020-11-19', 'MY', 'Malaysia', 'WPRO', '660', '50390', '4', '322');
INSERT INTO public.who_global_data_import VALUES (50323, '2020-11-20', 'MY', 'Malaysia', 'WPRO', '1290', '51680', '4', '326');
INSERT INTO public.who_global_data_import VALUES (50324, '2020-11-21', 'MY', 'Malaysia', 'WPRO', '958', '52638', '3', '329');
INSERT INTO public.who_global_data_import VALUES (50325, '2020-11-22', 'MY', 'Malaysia', 'WPRO', '1041', '53679', '3', '332');
INSERT INTO public.who_global_data_import VALUES (50326, '2020-11-23', 'MY', 'Malaysia', 'WPRO', '1096', '54775', '3', '335');
INSERT INTO public.who_global_data_import VALUES (50327, '2020-11-24', 'MY', 'Malaysia', 'WPRO', '1884', '56659', '2', '337');
INSERT INTO public.who_global_data_import VALUES (50328, '2020-11-25', 'MY', 'Malaysia', 'WPRO', '2188', '58847', '4', '341');
INSERT INTO public.who_global_data_import VALUES (50329, '2020-11-26', 'MY', 'Malaysia', 'WPRO', '970', '59817', '4', '345');
INSERT INTO public.who_global_data_import VALUES (50330, '2020-11-27', 'MY', 'Malaysia', 'WPRO', '935', '60752', '3', '348');
INSERT INTO public.who_global_data_import VALUES (50331, '2020-11-28', 'MY', 'Malaysia', 'WPRO', '1109', '61861', '2', '350');
INSERT INTO public.who_global_data_import VALUES (50332, '2020-11-29', 'MY', 'Malaysia', 'WPRO', '1315', '63176', '4', '354');
INSERT INTO public.who_global_data_import VALUES (50333, '2020-11-30', 'MY', 'Malaysia', 'WPRO', '1309', '64485', '3', '357');
INSERT INTO public.who_global_data_import VALUES (50334, '2020-12-01', 'MY', 'Malaysia', 'WPRO', '1212', '65697', '3', '360');
INSERT INTO public.who_global_data_import VALUES (50335, '2020-12-02', 'MY', 'Malaysia', 'WPRO', '1472', '67169', '3', '363');
INSERT INTO public.who_global_data_import VALUES (50336, '2020-12-03', 'MY', 'Malaysia', 'WPRO', '851', '68020', '2', '365');
INSERT INTO public.who_global_data_import VALUES (50337, '2020-12-04', 'MY', 'Malaysia', 'WPRO', '1075', '69095', '11', '376');
INSERT INTO public.who_global_data_import VALUES (50338, '2020-12-05', 'MY', 'Malaysia', 'WPRO', '1141', '70236', '0', '376');
INSERT INTO public.who_global_data_import VALUES (50339, '2020-12-06', 'MY', 'Malaysia', 'WPRO', '1123', '71359', '4', '380');
INSERT INTO public.who_global_data_import VALUES (50340, '2020-12-07', 'MY', 'Malaysia', 'WPRO', '1335', '72694', '2', '382');
INSERT INTO public.who_global_data_import VALUES (50341, '2020-12-08', 'MY', 'Malaysia', 'WPRO', '1600', '74294', '2', '384');
INSERT INTO public.who_global_data_import VALUES (50342, '2020-12-09', 'MY', 'Malaysia', 'WPRO', '1012', '75306', '4', '388');
INSERT INTO public.who_global_data_import VALUES (50343, '2020-12-10', 'MY', 'Malaysia', 'WPRO', '959', '76265', '5', '393');
INSERT INTO public.who_global_data_import VALUES (50344, '2020-12-11', 'MY', 'Malaysia', 'WPRO', '2234', '78499', '3', '396');
INSERT INTO public.who_global_data_import VALUES (50345, '2020-12-12', 'MY', 'Malaysia', 'WPRO', '1810', '80309', '6', '402');
INSERT INTO public.who_global_data_import VALUES (50346, '2020-12-13', 'MY', 'Malaysia', 'WPRO', '1937', '82246', '9', '411');
INSERT INTO public.who_global_data_import VALUES (50347, '2020-12-14', 'MY', 'Malaysia', 'WPRO', '1229', '83475', '4', '415');
INSERT INTO public.who_global_data_import VALUES (50348, '2020-12-15', 'MY', 'Malaysia', 'WPRO', '1371', '84846', '4', '419');
INSERT INTO public.who_global_data_import VALUES (50349, '2020-12-16', 'MY', 'Malaysia', 'WPRO', '1772', '86618', '3', '422');
INSERT INTO public.who_global_data_import VALUES (50350, '2020-12-17', 'MY', 'Malaysia', 'WPRO', '1295', '87913', '7', '429');
INSERT INTO public.who_global_data_import VALUES (50351, '2020-12-18', 'MY', 'Malaysia', 'WPRO', '1220', '89133', '3', '432');
INSERT INTO public.who_global_data_import VALUES (50352, '2020-12-19', 'MY', 'Malaysia', 'WPRO', '1683', '90816', '0', '432');
INSERT INTO public.who_global_data_import VALUES (50353, '2020-12-20', 'MY', 'Malaysia', 'WPRO', '1153', '91969', '1', '433');
INSERT INTO public.who_global_data_import VALUES (50354, '2020-12-21', 'MY', 'Malaysia', 'WPRO', '1340', '93309', '4', '437');
INSERT INTO public.who_global_data_import VALUES (50355, '2020-12-22', 'MY', 'Malaysia', 'WPRO', '2018', '95327', '1', '438');
INSERT INTO public.who_global_data_import VALUES (50356, '2020-12-23', 'MY', 'Malaysia', 'WPRO', '2062', '97389', '1', '439');
INSERT INTO public.who_global_data_import VALUES (50357, '2020-12-24', 'MY', 'Malaysia', 'WPRO', '1348', '98737', '5', '444');
INSERT INTO public.who_global_data_import VALUES (50358, '2020-12-25', 'MY', 'Malaysia', 'WPRO', '1581', '100318', '2', '446');
INSERT INTO public.who_global_data_import VALUES (50359, '2020-12-26', 'MY', 'Malaysia', 'WPRO', '1247', '101565', '3', '449');
INSERT INTO public.who_global_data_import VALUES (50360, '2020-12-27', 'MY', 'Malaysia', 'WPRO', '2335', '103900', '2', '451');
INSERT INTO public.who_global_data_import VALUES (50361, '2020-12-28', 'MY', 'Malaysia', 'WPRO', '1196', '105096', '1', '452');
INSERT INTO public.who_global_data_import VALUES (50362, '2020-12-29', 'MY', 'Malaysia', 'WPRO', '1594', '106690', '3', '455');
INSERT INTO public.who_global_data_import VALUES (50363, '2020-12-30', 'MY', 'Malaysia', 'WPRO', '1925', '108615', '2', '457');
INSERT INTO public.who_global_data_import VALUES (50364, '2020-12-31', 'MY', 'Malaysia', 'WPRO', '1870', '110485', '6', '463');
INSERT INTO public.who_global_data_import VALUES (50365, '2021-01-01', 'MY', 'Malaysia', 'WPRO', '2525', '113010', '8', '471');
INSERT INTO public.who_global_data_import VALUES (50366, '2021-01-02', 'MY', 'Malaysia', 'WPRO', '2068', '115078', '3', '474');
INSERT INTO public.who_global_data_import VALUES (50367, '2021-01-03', 'MY', 'Malaysia', 'WPRO', '2295', '117373', '9', '483');
INSERT INTO public.who_global_data_import VALUES (50368, '2021-01-04', 'MY', 'Malaysia', 'WPRO', '1704', '119077', '11', '494');
INSERT INTO public.who_global_data_import VALUES (50369, '2021-01-05', 'MY', 'Malaysia', 'WPRO', '1741', '120818', '7', '501');
INSERT INTO public.who_global_data_import VALUES (50370, '2021-01-06', 'MY', 'Malaysia', 'WPRO', '2027', '122845', '8', '509');
INSERT INTO public.who_global_data_import VALUES (50371, '2021-01-07', 'MY', 'Malaysia', 'WPRO', '2593', '125438', '4', '513');
INSERT INTO public.who_global_data_import VALUES (50372, '2021-01-08', 'MY', 'Malaysia', 'WPRO', '3027', '128465', '8', '521');
INSERT INTO public.who_global_data_import VALUES (50373, '2021-01-09', 'MY', 'Malaysia', 'WPRO', '2643', '131108', '16', '537');
INSERT INTO public.who_global_data_import VALUES (50374, '2021-01-10', 'MY', 'Malaysia', 'WPRO', '2451', '133559', '5', '542');
INSERT INTO public.who_global_data_import VALUES (50375, '2021-01-11', 'MY', 'Malaysia', 'WPRO', '2433', '135992', '9', '551');
INSERT INTO public.who_global_data_import VALUES (50376, '2021-01-12', 'MY', 'Malaysia', 'WPRO', '2232', '138224', '4', '555');
INSERT INTO public.who_global_data_import VALUES (50377, '2021-01-13', 'MY', 'Malaysia', 'WPRO', '3309', '141533', '4', '559');
INSERT INTO public.who_global_data_import VALUES (50378, '2021-01-14', 'MY', 'Malaysia', 'WPRO', '2985', '144518', '4', '563');
INSERT INTO public.who_global_data_import VALUES (50379, '2021-01-15', 'MY', 'Malaysia', 'WPRO', '3337', '147855', '15', '578');
INSERT INTO public.who_global_data_import VALUES (50380, '2021-01-16', 'MY', 'Malaysia', 'WPRO', '3211', '151066', '8', '586');
INSERT INTO public.who_global_data_import VALUES (50381, '2021-01-17', 'MY', 'Malaysia', 'WPRO', '4029', '155095', '8', '594');
INSERT INTO public.who_global_data_import VALUES (50382, '2021-01-18', 'MY', 'Malaysia', 'WPRO', '3339', '158434', '7', '601');
INSERT INTO public.who_global_data_import VALUES (50383, '2021-01-19', 'MY', 'Malaysia', 'WPRO', '3306', '161740', '4', '605');
INSERT INTO public.who_global_data_import VALUES (50384, '2021-01-20', 'MY', 'Malaysia', 'WPRO', '3631', '165371', '14', '619');
INSERT INTO public.who_global_data_import VALUES (50385, '2021-01-21', 'MY', 'Malaysia', 'WPRO', '4008', '169379', '11', '630');
INSERT INTO public.who_global_data_import VALUES (50386, '2021-01-22', 'MY', 'Malaysia', 'WPRO', '3170', '172549', '12', '642');
INSERT INTO public.who_global_data_import VALUES (50387, '2021-01-23', 'MY', 'Malaysia', 'WPRO', '3631', '176180', '18', '660');
INSERT INTO public.who_global_data_import VALUES (50388, '2021-01-24', 'MY', 'Malaysia', 'WPRO', '4275', '180455', '7', '667');
INSERT INTO public.who_global_data_import VALUES (50389, '2021-01-25', 'MY', 'Malaysia', 'WPRO', '3346', '183801', '11', '678');
INSERT INTO public.who_global_data_import VALUES (50390, '2021-01-26', 'MY', 'Malaysia', 'WPRO', '3048', '186849', '11', '689');
INSERT INTO public.who_global_data_import VALUES (50391, '2021-01-27', 'MY', 'Malaysia', 'WPRO', '3585', '190434', '11', '700');
INSERT INTO public.who_global_data_import VALUES (50392, '2021-01-28', 'MY', 'Malaysia', 'WPRO', '3680', '194114', '7', '707');
INSERT INTO public.who_global_data_import VALUES (50393, '2021-01-29', 'MY', 'Malaysia', 'WPRO', '4094', '198208', '10', '717');
INSERT INTO public.who_global_data_import VALUES (50394, '2021-01-30', 'MY', 'Malaysia', 'WPRO', '5725', '203933', '16', '733');
INSERT INTO public.who_global_data_import VALUES (50395, '2021-01-31', 'MY', 'Malaysia', 'WPRO', '5728', '209661', '13', '746');
INSERT INTO public.who_global_data_import VALUES (50396, '2021-02-01', 'MY', 'Malaysia', 'WPRO', '5298', '214959', '14', '760');
INSERT INTO public.who_global_data_import VALUES (50397, '2021-02-02', 'MY', 'Malaysia', 'WPRO', '4214', '219173', '10', '770');
INSERT INTO public.who_global_data_import VALUES (50398, '2021-02-03', 'MY', 'Malaysia', 'WPRO', '3455', '222628', '21', '791');
INSERT INTO public.who_global_data_import VALUES (50399, '2021-02-04', 'MY', 'Malaysia', 'WPRO', '4284', '226912', '18', '809');
INSERT INTO public.who_global_data_import VALUES (50400, '2021-02-05', 'MY', 'Malaysia', 'WPRO', '4571', '231483', '17', '826');
INSERT INTO public.who_global_data_import VALUES (50401, '2020-01-03', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50402, '2020-01-04', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50403, '2020-01-05', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50404, '2020-01-06', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50405, '2020-01-07', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50406, '2020-01-08', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50407, '2020-01-09', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50408, '2020-01-10', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50409, '2020-01-11', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50410, '2020-01-12', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50411, '2020-01-13', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50412, '2020-01-14', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50413, '2020-01-15', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50414, '2020-01-16', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50415, '2020-01-17', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50416, '2020-01-18', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50417, '2020-01-19', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50418, '2020-01-20', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50419, '2020-01-21', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50420, '2020-01-22', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50421, '2020-01-23', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50422, '2020-01-24', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50423, '2020-01-25', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50424, '2020-01-26', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50425, '2020-01-27', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50426, '2020-01-28', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50427, '2020-01-29', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50428, '2020-01-30', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50429, '2020-01-31', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50430, '2020-02-01', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50431, '2020-02-02', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50432, '2020-02-03', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50433, '2020-02-04', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50434, '2020-02-05', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50435, '2020-02-06', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50436, '2020-02-07', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50437, '2020-02-08', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50438, '2020-02-09', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50439, '2020-02-10', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50440, '2020-02-11', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50441, '2020-02-12', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50442, '2020-02-13', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50443, '2020-02-14', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50444, '2020-02-15', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50445, '2020-02-16', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50446, '2020-02-17', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50447, '2020-02-18', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50448, '2020-02-19', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50449, '2020-02-20', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50450, '2020-02-21', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50451, '2020-02-22', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50452, '2020-02-23', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50453, '2020-02-24', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50454, '2020-02-25', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50455, '2020-02-26', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50456, '2020-02-27', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50457, '2020-02-28', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50458, '2020-02-29', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50459, '2020-03-01', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50460, '2020-03-02', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50461, '2020-03-03', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50462, '2020-03-04', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50463, '2020-03-05', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50464, '2020-03-06', 'MV', 'Maldives', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50465, '2020-03-07', 'MV', 'Maldives', 'SEARO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50466, '2020-03-08', 'MV', 'Maldives', 'SEARO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50467, '2020-03-09', 'MV', 'Maldives', 'SEARO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50468, '2020-03-10', 'MV', 'Maldives', 'SEARO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50469, '2020-03-11', 'MV', 'Maldives', 'SEARO', '2', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50470, '2020-03-12', 'MV', 'Maldives', 'SEARO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50471, '2020-03-13', 'MV', 'Maldives', 'SEARO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50472, '2020-03-14', 'MV', 'Maldives', 'SEARO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50473, '2020-03-15', 'MV', 'Maldives', 'SEARO', '4', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50474, '2020-03-16', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50475, '2020-03-17', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50476, '2020-03-18', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50477, '2020-03-19', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50478, '2020-03-20', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50479, '2020-03-21', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50480, '2020-03-22', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50481, '2020-03-23', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50482, '2020-03-24', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50483, '2020-03-25', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50484, '2020-03-26', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50485, '2020-03-27', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50486, '2020-03-28', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50487, '2020-03-29', 'MV', 'Maldives', 'SEARO', '-1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50488, '2020-03-30', 'MV', 'Maldives', 'SEARO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50489, '2020-03-31', 'MV', 'Maldives', 'SEARO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50490, '2020-04-01', 'MV', 'Maldives', 'SEARO', '1', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50491, '2020-04-02', 'MV', 'Maldives', 'SEARO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50492, '2020-04-03', 'MV', 'Maldives', 'SEARO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50493, '2020-04-04', 'MV', 'Maldives', 'SEARO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50494, '2020-04-05', 'MV', 'Maldives', 'SEARO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50495, '2020-04-06', 'MV', 'Maldives', 'SEARO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50496, '2020-04-07', 'MV', 'Maldives', 'SEARO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50497, '2020-04-08', 'MV', 'Maldives', 'SEARO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50498, '2020-04-09', 'MV', 'Maldives', 'SEARO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50499, '2020-04-10', 'MV', 'Maldives', 'SEARO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50500, '2020-04-11', 'MV', 'Maldives', 'SEARO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50501, '2020-04-12', 'MV', 'Maldives', 'SEARO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50502, '2020-04-13', 'MV', 'Maldives', 'SEARO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50503, '2020-04-14', 'MV', 'Maldives', 'SEARO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50504, '2020-04-15', 'MV', 'Maldives', 'SEARO', '1', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50505, '2020-04-16', 'MV', 'Maldives', 'SEARO', '2', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50506, '2020-04-17', 'MV', 'Maldives', 'SEARO', '5', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50507, '2020-04-18', 'MV', 'Maldives', 'SEARO', '6', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50508, '2020-04-19', 'MV', 'Maldives', 'SEARO', '17', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50509, '2020-04-20', 'MV', 'Maldives', 'SEARO', '9', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50510, '2020-04-21', 'MV', 'Maldives', 'SEARO', '23', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50511, '2020-04-22', 'MV', 'Maldives', 'SEARO', '2', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50512, '2020-04-23', 'MV', 'Maldives', 'SEARO', '9', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50513, '2020-04-24', 'MV', 'Maldives', 'SEARO', '22', '116', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50514, '2020-04-25', 'MV', 'Maldives', 'SEARO', '21', '137', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50515, '2020-04-26', 'MV', 'Maldives', 'SEARO', '51', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50516, '2020-04-27', 'MV', 'Maldives', 'SEARO', '26', '214', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50517, '2020-04-28', 'MV', 'Maldives', 'SEARO', '31', '245', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50518, '2020-04-29', 'MV', 'Maldives', 'SEARO', '11', '256', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50519, '2020-04-30', 'MV', 'Maldives', 'SEARO', '140', '396', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50520, '2020-05-01', 'MV', 'Maldives', 'SEARO', '72', '468', '1', '1');
INSERT INTO public.who_global_data_import VALUES (50521, '2020-05-02', 'MV', 'Maldives', 'SEARO', '23', '491', '0', '1');
INSERT INTO public.who_global_data_import VALUES (50522, '2020-05-03', 'MV', 'Maldives', 'SEARO', '28', '519', '0', '1');
INSERT INTO public.who_global_data_import VALUES (50523, '2020-05-04', 'MV', 'Maldives', 'SEARO', '8', '527', '0', '1');
INSERT INTO public.who_global_data_import VALUES (50524, '2020-05-05', 'MV', 'Maldives', 'SEARO', '30', '557', '0', '1');
INSERT INTO public.who_global_data_import VALUES (50525, '2020-05-06', 'MV', 'Maldives', 'SEARO', '61', '618', '1', '2');
INSERT INTO public.who_global_data_import VALUES (50526, '2020-05-07', 'MV', 'Maldives', 'SEARO', '0', '618', '0', '2');
INSERT INTO public.who_global_data_import VALUES (50527, '2020-05-08', 'MV', 'Maldives', 'SEARO', '30', '648', '1', '3');
INSERT INTO public.who_global_data_import VALUES (50528, '2020-05-09', 'MV', 'Maldives', 'SEARO', '96', '744', '0', '3');
INSERT INTO public.who_global_data_import VALUES (50529, '2020-05-10', 'MV', 'Maldives', 'SEARO', '41', '785', '0', '3');
INSERT INTO public.who_global_data_import VALUES (50530, '2020-05-11', 'MV', 'Maldives', 'SEARO', '50', '835', '0', '3');
INSERT INTO public.who_global_data_import VALUES (50531, '2020-05-12', 'MV', 'Maldives', 'SEARO', '62', '897', '0', '3');
INSERT INTO public.who_global_data_import VALUES (50532, '2020-05-13', 'MV', 'Maldives', 'SEARO', '7', '904', '0', '3');
INSERT INTO public.who_global_data_import VALUES (50533, '2020-05-14', 'MV', 'Maldives', 'SEARO', '64', '968', '1', '4');
INSERT INTO public.who_global_data_import VALUES (50534, '2020-05-15', 'MV', 'Maldives', 'SEARO', '52', '1020', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50535, '2020-05-16', 'MV', 'Maldives', 'SEARO', '58', '1078', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50536, '2020-05-17', 'MV', 'Maldives', 'SEARO', '0', '1078', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50537, '2020-05-18', 'MV', 'Maldives', 'SEARO', '16', '1094', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50538, '2020-05-19', 'MV', 'Maldives', 'SEARO', '49', '1143', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50539, '2020-05-20', 'MV', 'Maldives', 'SEARO', '43', '1186', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50540, '2020-05-21', 'MV', 'Maldives', 'SEARO', '30', '1216', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50541, '2020-05-22', 'MV', 'Maldives', 'SEARO', '0', '1216', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50542, '2020-05-23', 'MV', 'Maldives', 'SEARO', '58', '1274', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50543, '2020-05-24', 'MV', 'Maldives', 'SEARO', '39', '1313', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50544, '2020-05-25', 'MV', 'Maldives', 'SEARO', '82', '1395', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50545, '2020-05-26', 'MV', 'Maldives', 'SEARO', '0', '1395', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50546, '2020-05-27', 'MV', 'Maldives', 'SEARO', '62', '1457', '1', '5');
INSERT INTO public.who_global_data_import VALUES (50547, '2020-05-28', 'MV', 'Maldives', 'SEARO', '0', '1457', '0', '5');
INSERT INTO public.who_global_data_import VALUES (50548, '2020-05-29', 'MV', 'Maldives', 'SEARO', '56', '1513', '0', '5');
INSERT INTO public.who_global_data_import VALUES (50549, '2020-05-30', 'MV', 'Maldives', 'SEARO', '120', '1633', '0', '5');
INSERT INTO public.who_global_data_import VALUES (50550, '2020-05-31', 'MV', 'Maldives', 'SEARO', '39', '1672', '0', '5');
INSERT INTO public.who_global_data_import VALUES (50551, '2020-06-01', 'MV', 'Maldives', 'SEARO', '101', '1773', '0', '5');
INSERT INTO public.who_global_data_import VALUES (50552, '2020-06-02', 'MV', 'Maldives', 'SEARO', '56', '1829', '1', '6');
INSERT INTO public.who_global_data_import VALUES (50553, '2020-06-03', 'MV', 'Maldives', 'SEARO', '12', '1841', '1', '7');
INSERT INTO public.who_global_data_import VALUES (50554, '2020-06-04', 'MV', 'Maldives', 'SEARO', '9', '1850', '0', '7');
INSERT INTO public.who_global_data_import VALUES (50555, '2020-06-05', 'MV', 'Maldives', 'SEARO', '22', '1872', '0', '7');
INSERT INTO public.who_global_data_import VALUES (50556, '2020-06-06', 'MV', 'Maldives', 'SEARO', '11', '1883', '0', '7');
INSERT INTO public.who_global_data_import VALUES (50557, '2020-06-07', 'MV', 'Maldives', 'SEARO', '18', '1901', '1', '8');
INSERT INTO public.who_global_data_import VALUES (50558, '2020-06-08', 'MV', 'Maldives', 'SEARO', '2', '1903', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50559, '2020-06-09', 'MV', 'Maldives', 'SEARO', '13', '1916', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50560, '2020-06-10', 'MV', 'Maldives', 'SEARO', '26', '1942', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50561, '2020-06-11', 'MV', 'Maldives', 'SEARO', '20', '1962', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50562, '2020-06-12', 'MV', 'Maldives', 'SEARO', '14', '1976', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50563, '2020-06-13', 'MV', 'Maldives', 'SEARO', '27', '2003', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50564, '2020-06-14', 'MV', 'Maldives', 'SEARO', '10', '2013', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50565, '2020-06-15', 'MV', 'Maldives', 'SEARO', '22', '2035', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50566, '2020-06-16', 'MV', 'Maldives', 'SEARO', '30', '2065', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50567, '2020-06-17', 'MV', 'Maldives', 'SEARO', '29', '2094', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50568, '2020-06-18', 'MV', 'Maldives', 'SEARO', '26', '2120', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50569, '2020-06-19', 'MV', 'Maldives', 'SEARO', '17', '2137', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50570, '2020-06-20', 'MV', 'Maldives', 'SEARO', '13', '2150', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50571, '2020-06-21', 'MV', 'Maldives', 'SEARO', '37', '2187', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50572, '2020-06-22', 'MV', 'Maldives', 'SEARO', '16', '2203', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50573, '2020-06-23', 'MV', 'Maldives', 'SEARO', '14', '2217', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50574, '2020-06-24', 'MV', 'Maldives', 'SEARO', '21', '2238', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50575, '2020-06-25', 'MV', 'Maldives', 'SEARO', '22', '2260', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50576, '2020-06-26', 'MV', 'Maldives', 'SEARO', '17', '2277', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50577, '2020-06-27', 'MV', 'Maldives', 'SEARO', '6', '2283', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50578, '2020-06-28', 'MV', 'Maldives', 'SEARO', '22', '2305', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50579, '2020-06-29', 'MV', 'Maldives', 'SEARO', '19', '2324', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50580, '2020-06-30', 'MV', 'Maldives', 'SEARO', '13', '2337', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50581, '2020-07-01', 'MV', 'Maldives', 'SEARO', '24', '2361', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50582, '2020-07-02', 'MV', 'Maldives', 'SEARO', '21', '2382', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50583, '2020-07-03', 'MV', 'Maldives', 'SEARO', '18', '2400', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50584, '2020-07-04', 'MV', 'Maldives', 'SEARO', '10', '2410', '0', '8');
INSERT INTO public.who_global_data_import VALUES (50585, '2020-07-05', 'MV', 'Maldives', 'SEARO', '25', '2435', '2', '10');
INSERT INTO public.who_global_data_import VALUES (50586, '2020-07-06', 'MV', 'Maldives', 'SEARO', '33', '2468', '1', '11');
INSERT INTO public.who_global_data_import VALUES (50587, '2020-07-07', 'MV', 'Maldives', 'SEARO', '23', '2491', '1', '12');
INSERT INTO public.who_global_data_import VALUES (50588, '2020-07-08', 'MV', 'Maldives', 'SEARO', '10', '2501', '0', '12');
INSERT INTO public.who_global_data_import VALUES (50589, '2020-07-09', 'MV', 'Maldives', 'SEARO', '16', '2517', '1', '13');
INSERT INTO public.who_global_data_import VALUES (50590, '2020-07-10', 'MV', 'Maldives', 'SEARO', '36', '2553', '0', '13');
INSERT INTO public.who_global_data_import VALUES (50591, '2020-07-11', 'MV', 'Maldives', 'SEARO', '64', '2617', '0', '13');
INSERT INTO public.who_global_data_import VALUES (50592, '2020-07-12', 'MV', 'Maldives', 'SEARO', '47', '2664', '0', '13');
INSERT INTO public.who_global_data_import VALUES (50593, '2020-07-13', 'MV', 'Maldives', 'SEARO', '67', '2731', '0', '13');
INSERT INTO public.who_global_data_import VALUES (50594, '2020-07-14', 'MV', 'Maldives', 'SEARO', '31', '2762', '0', '13');
INSERT INTO public.who_global_data_import VALUES (50595, '2020-07-15', 'MV', 'Maldives', 'SEARO', '39', '2801', '1', '14');
INSERT INTO public.who_global_data_import VALUES (50596, '2020-07-16', 'MV', 'Maldives', 'SEARO', '30', '2831', '0', '14');
INSERT INTO public.who_global_data_import VALUES (50597, '2020-07-17', 'MV', 'Maldives', 'SEARO', '68', '2899', '1', '15');
INSERT INTO public.who_global_data_import VALUES (50598, '2020-07-18', 'MV', 'Maldives', 'SEARO', '14', '2913', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50599, '2020-07-19', 'MV', 'Maldives', 'SEARO', '17', '2930', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50600, '2020-07-20', 'MV', 'Maldives', 'SEARO', '36', '2966', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50601, '2020-07-21', 'MV', 'Maldives', 'SEARO', '33', '2999', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50602, '2020-07-22', 'MV', 'Maldives', 'SEARO', '45', '3044', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50603, '2020-07-23', 'MV', 'Maldives', 'SEARO', '59', '3103', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50604, '2020-07-24', 'MV', 'Maldives', 'SEARO', '17', '3120', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50605, '2020-07-25', 'MV', 'Maldives', 'SEARO', '55', '3175', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50606, '2020-07-26', 'MV', 'Maldives', 'SEARO', '77', '3252', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50607, '2020-07-27', 'MV', 'Maldives', 'SEARO', '50', '3302', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50608, '2020-07-28', 'MV', 'Maldives', 'SEARO', '67', '3369', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50609, '2020-07-29', 'MV', 'Maldives', 'SEARO', '137', '3506', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50610, '2020-07-30', 'MV', 'Maldives', 'SEARO', '61', '3567', '0', '15');
INSERT INTO public.who_global_data_import VALUES (50611, '2020-07-31', 'MV', 'Maldives', 'SEARO', '152', '3719', '1', '16');
INSERT INTO public.who_global_data_import VALUES (50612, '2020-08-01', 'MV', 'Maldives', 'SEARO', '74', '3793', '0', '16');
INSERT INTO public.who_global_data_import VALUES (50613, '2020-08-02', 'MV', 'Maldives', 'SEARO', '156', '3949', '1', '17');
INSERT INTO public.who_global_data_import VALUES (50614, '2020-08-03', 'MV', 'Maldives', 'SEARO', '215', '4164', '1', '18');
INSERT INTO public.who_global_data_import VALUES (50615, '2020-08-04', 'MV', 'Maldives', 'SEARO', '129', '4293', '0', '18');
INSERT INTO public.who_global_data_import VALUES (50616, '2020-08-05', 'MV', 'Maldives', 'SEARO', '153', '4446', '1', '19');
INSERT INTO public.who_global_data_import VALUES (50617, '2020-08-06', 'MV', 'Maldives', 'SEARO', '148', '4594', '0', '19');
INSERT INTO public.who_global_data_import VALUES (50618, '2020-08-07', 'MV', 'Maldives', 'SEARO', '86', '4680', '0', '19');
INSERT INTO public.who_global_data_import VALUES (50619, '2020-08-08', 'MV', 'Maldives', 'SEARO', '89', '4769', '0', '19');
INSERT INTO public.who_global_data_import VALUES (50620, '2020-08-09', 'MV', 'Maldives', 'SEARO', '129', '4898', '0', '19');
INSERT INTO public.who_global_data_import VALUES (50621, '2020-08-10', 'MV', 'Maldives', 'SEARO', '143', '5041', '0', '19');
INSERT INTO public.who_global_data_import VALUES (50622, '2020-08-11', 'MV', 'Maldives', 'SEARO', '116', '5157', '0', '19');
INSERT INTO public.who_global_data_import VALUES (50623, '2020-08-12', 'MV', 'Maldives', 'SEARO', '66', '5223', '1', '20');
INSERT INTO public.who_global_data_import VALUES (50624, '2020-08-13', 'MV', 'Maldives', 'SEARO', '143', '5366', '1', '21');
INSERT INTO public.who_global_data_import VALUES (50625, '2020-08-14', 'MV', 'Maldives', 'SEARO', '128', '5494', '0', '21');
INSERT INTO public.who_global_data_import VALUES (50626, '2020-08-15', 'MV', 'Maldives', 'SEARO', '78', '5572', '1', '22');
INSERT INTO public.who_global_data_import VALUES (50627, '2020-08-16', 'MV', 'Maldives', 'SEARO', '107', '5679', '0', '22');
INSERT INTO public.who_global_data_import VALUES (50628, '2020-08-17', 'MV', 'Maldives', 'SEARO', '106', '5785', '0', '22');
INSERT INTO public.who_global_data_import VALUES (50629, '2020-08-18', 'MV', 'Maldives', 'SEARO', '124', '5909', '1', '23');
INSERT INTO public.who_global_data_import VALUES (50630, '2020-08-19', 'MV', 'Maldives', 'SEARO', '170', '6079', '1', '24');
INSERT INTO public.who_global_data_import VALUES (50631, '2020-08-20', 'MV', 'Maldives', 'SEARO', '146', '6225', '0', '24');
INSERT INTO public.who_global_data_import VALUES (50632, '2020-08-21', 'MV', 'Maldives', 'SEARO', '145', '6370', '0', '24');
INSERT INTO public.who_global_data_import VALUES (50633, '2020-08-22', 'MV', 'Maldives', 'SEARO', '194', '6564', '1', '25');
INSERT INTO public.who_global_data_import VALUES (50634, '2020-08-23', 'MV', 'Maldives', 'SEARO', '96', '6660', '1', '26');
INSERT INTO public.who_global_data_import VALUES (50635, '2020-08-24', 'MV', 'Maldives', 'SEARO', '119', '6779', '0', '26');
INSERT INTO public.who_global_data_import VALUES (50636, '2020-08-25', 'MV', 'Maldives', 'SEARO', '133', '6912', '1', '27');
INSERT INTO public.who_global_data_import VALUES (50637, '2020-08-26', 'MV', 'Maldives', 'SEARO', '135', '7047', '1', '28');
INSERT INTO public.who_global_data_import VALUES (50638, '2020-08-27', 'MV', 'Maldives', 'SEARO', '178', '7225', '0', '28');
INSERT INTO public.who_global_data_import VALUES (50639, '2020-08-28', 'MV', 'Maldives', 'SEARO', '104', '7329', '0', '28');
INSERT INTO public.who_global_data_import VALUES (50640, '2020-08-29', 'MV', 'Maldives', 'SEARO', '140', '7469', '0', '28');
INSERT INTO public.who_global_data_import VALUES (50641, '2020-08-30', 'MV', 'Maldives', 'SEARO', '109', '7578', '0', '28');
INSERT INTO public.who_global_data_import VALUES (50642, '2020-08-31', 'MV', 'Maldives', 'SEARO', '89', '7667', '0', '28');
INSERT INTO public.who_global_data_import VALUES (50643, '2020-09-01', 'MV', 'Maldives', 'SEARO', '137', '7804', '0', '28');
INSERT INTO public.who_global_data_import VALUES (50644, '2020-09-02', 'MV', 'Maldives', 'SEARO', '199', '8003', '1', '29');
INSERT INTO public.who_global_data_import VALUES (50645, '2020-09-03', 'MV', 'Maldives', 'SEARO', '137', '8140', '0', '29');
INSERT INTO public.who_global_data_import VALUES (50646, '2020-09-04', 'MV', 'Maldives', 'SEARO', '141', '8281', '0', '29');
INSERT INTO public.who_global_data_import VALUES (50647, '2020-09-05', 'MV', 'Maldives', 'SEARO', '80', '8361', '0', '29');
INSERT INTO public.who_global_data_import VALUES (50648, '2020-09-06', 'MV', 'Maldives', 'SEARO', '125', '8486', '0', '29');
INSERT INTO public.who_global_data_import VALUES (50649, '2020-09-07', 'MV', 'Maldives', 'SEARO', '98', '8584', '0', '29');
INSERT INTO public.who_global_data_import VALUES (50650, '2020-09-08', 'MV', 'Maldives', 'SEARO', '83', '8667', '0', '29');
INSERT INTO public.who_global_data_import VALUES (50651, '2020-09-09', 'MV', 'Maldives', 'SEARO', '74', '8741', '0', '29');
INSERT INTO public.who_global_data_import VALUES (50652, '2020-09-10', 'MV', 'Maldives', 'SEARO', '93', '8834', '2', '31');
INSERT INTO public.who_global_data_import VALUES (50653, '2020-09-11', 'MV', 'Maldives', 'SEARO', '66', '8900', '0', '31');
INSERT INTO public.who_global_data_import VALUES (50654, '2020-09-12', 'MV', 'Maldives', 'SEARO', '90', '8990', '0', '31');
INSERT INTO public.who_global_data_import VALUES (50655, '2020-09-13', 'MV', 'Maldives', 'SEARO', '62', '9052', '0', '31');
INSERT INTO public.who_global_data_import VALUES (50656, '2020-09-14', 'MV', 'Maldives', 'SEARO', '121', '9173', '1', '32');
INSERT INTO public.who_global_data_import VALUES (50657, '2020-09-15', 'MV', 'Maldives', 'SEARO', '70', '9243', '1', '33');
INSERT INTO public.who_global_data_import VALUES (50658, '2020-09-16', 'MV', 'Maldives', 'SEARO', '85', '9328', '0', '33');
INSERT INTO public.who_global_data_import VALUES (50659, '2020-09-17', 'MV', 'Maldives', 'SEARO', '99', '9427', '0', '33');
INSERT INTO public.who_global_data_import VALUES (50660, '2020-09-18', 'MV', 'Maldives', 'SEARO', '67', '9494', '0', '33');
INSERT INTO public.who_global_data_import VALUES (50661, '2020-09-19', 'MV', 'Maldives', 'SEARO', '74', '9568', '0', '33');
INSERT INTO public.who_global_data_import VALUES (50662, '2020-09-20', 'MV', 'Maldives', 'SEARO', '81', '9649', '0', '33');
INSERT INTO public.who_global_data_import VALUES (50663, '2020-09-21', 'MV', 'Maldives', 'SEARO', '75', '9724', '0', '33');
INSERT INTO public.who_global_data_import VALUES (50664, '2020-09-22', 'MV', 'Maldives', 'SEARO', '46', '9770', '1', '34');
INSERT INTO public.who_global_data_import VALUES (50665, '2020-09-23', 'MV', 'Maldives', 'SEARO', '48', '9818', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50666, '2020-09-24', 'MV', 'Maldives', 'SEARO', '67', '9885', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50667, '2020-09-25', 'MV', 'Maldives', 'SEARO', '54', '9939', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50668, '2020-09-26', 'MV', 'Maldives', 'SEARO', '75', '10014', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50669, '2020-09-27', 'MV', 'Maldives', 'SEARO', '31', '10045', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50670, '2020-09-28', 'MV', 'Maldives', 'SEARO', '53', '10098', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50671, '2020-09-29', 'MV', 'Maldives', 'SEARO', '59', '10157', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50672, '2020-09-30', 'MV', 'Maldives', 'SEARO', '37', '10194', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50673, '2020-10-01', 'MV', 'Maldives', 'SEARO', '97', '10291', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50674, '2020-10-02', 'MV', 'Maldives', 'SEARO', '63', '10354', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50675, '2020-10-03', 'MV', 'Maldives', 'SEARO', '44', '10398', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50676, '2020-10-04', 'MV', 'Maldives', 'SEARO', '67', '10465', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50677, '2020-10-05', 'MV', 'Maldives', 'SEARO', '65', '10530', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50678, '2020-10-06', 'MV', 'Maldives', 'SEARO', '37', '10567', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50679, '2020-10-07', 'MV', 'Maldives', 'SEARO', '54', '10621', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50680, '2020-10-08', 'MV', 'Maldives', 'SEARO', '35', '10656', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50681, '2020-10-09', 'MV', 'Maldives', 'SEARO', '86', '10742', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50682, '2020-10-10', 'MV', 'Maldives', 'SEARO', '66', '10808', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50683, '2020-10-11', 'MV', 'Maldives', 'SEARO', '51', '10859', '0', '34');
INSERT INTO public.who_global_data_import VALUES (50684, '2020-10-12', 'MV', 'Maldives', 'SEARO', '35', '10894', '1', '35');
INSERT INTO public.who_global_data_import VALUES (50685, '2020-10-13', 'MV', 'Maldives', 'SEARO', '49', '10943', '0', '35');
INSERT INTO public.who_global_data_import VALUES (50686, '2020-10-14', 'MV', 'Maldives', 'SEARO', '50', '10993', '0', '35');
INSERT INTO public.who_global_data_import VALUES (50687, '2020-10-15', 'MV', 'Maldives', 'SEARO', '69', '11062', '0', '35');
INSERT INTO public.who_global_data_import VALUES (50688, '2020-10-16', 'MV', 'Maldives', 'SEARO', '51', '11113', '0', '35');
INSERT INTO public.who_global_data_import VALUES (50689, '2020-10-17', 'MV', 'Maldives', 'SEARO', '41', '11154', '0', '35');
INSERT INTO public.who_global_data_import VALUES (50690, '2020-10-18', 'MV', 'Maldives', 'SEARO', '24', '11178', '1', '36');
INSERT INTO public.who_global_data_import VALUES (50691, '2020-10-19', 'MV', 'Maldives', 'SEARO', '32', '11210', '1', '37');
INSERT INTO public.who_global_data_import VALUES (50692, '2020-10-20', 'MV', 'Maldives', 'SEARO', '22', '11232', '0', '37');
INSERT INTO public.who_global_data_import VALUES (50693, '2020-10-21', 'MV', 'Maldives', 'SEARO', '39', '11271', '0', '37');
INSERT INTO public.who_global_data_import VALUES (50694, '2020-10-22', 'MV', 'Maldives', 'SEARO', '45', '11316', '0', '37');
INSERT INTO public.who_global_data_import VALUES (50695, '2020-10-23', 'MV', 'Maldives', 'SEARO', '42', '11358', '0', '37');
INSERT INTO public.who_global_data_import VALUES (50696, '2020-10-24', 'MV', 'Maldives', 'SEARO', '33', '11391', '0', '37');
INSERT INTO public.who_global_data_import VALUES (50697, '2020-10-25', 'MV', 'Maldives', 'SEARO', '30', '11421', '0', '37');
INSERT INTO public.who_global_data_import VALUES (50698, '2020-10-26', 'MV', 'Maldives', 'SEARO', '84', '11505', '0', '37');
INSERT INTO public.who_global_data_import VALUES (50699, '2020-10-27', 'MV', 'Maldives', 'SEARO', '27', '11532', '0', '37');
INSERT INTO public.who_global_data_import VALUES (50700, '2020-10-28', 'MV', 'Maldives', 'SEARO', '35', '11567', '0', '37');
INSERT INTO public.who_global_data_import VALUES (50701, '2020-10-29', 'MV', 'Maldives', 'SEARO', '24', '11591', '0', '37');
INSERT INTO public.who_global_data_import VALUES (50702, '2020-10-30', 'MV', 'Maldives', 'SEARO', '25', '11616', '0', '37');
INSERT INTO public.who_global_data_import VALUES (50703, '2020-10-31', 'MV', 'Maldives', 'SEARO', '27', '11643', '0', '37');
INSERT INTO public.who_global_data_import VALUES (50704, '2020-11-01', 'MV', 'Maldives', 'SEARO', '16', '11659', '1', '38');
INSERT INTO public.who_global_data_import VALUES (50705, '2020-11-02', 'MV', 'Maldives', 'SEARO', '42', '11701', '0', '38');
INSERT INTO public.who_global_data_import VALUES (50706, '2020-11-03', 'MV', 'Maldives', 'SEARO', '36', '11737', '0', '38');
INSERT INTO public.who_global_data_import VALUES (50707, '2020-11-04', 'MV', 'Maldives', 'SEARO', '59', '11796', '0', '38');
INSERT INTO public.who_global_data_import VALUES (50708, '2020-11-05', 'MV', 'Maldives', 'SEARO', '26', '11822', '0', '38');
INSERT INTO public.who_global_data_import VALUES (50709, '2020-11-06', 'MV', 'Maldives', 'SEARO', '71', '11893', '0', '38');
INSERT INTO public.who_global_data_import VALUES (50710, '2020-11-07', 'MV', 'Maldives', 'SEARO', '39', '11932', '1', '39');
INSERT INTO public.who_global_data_import VALUES (50711, '2020-11-08', 'MV', 'Maldives', 'SEARO', '30', '11962', '0', '39');
INSERT INTO public.who_global_data_import VALUES (50712, '2020-11-09', 'MV', 'Maldives', 'SEARO', '24', '11986', '1', '40');
INSERT INTO public.who_global_data_import VALUES (50713, '2020-11-10', 'MV', 'Maldives', 'SEARO', '23', '12009', '0', '40');
INSERT INTO public.who_global_data_import VALUES (50714, '2020-11-11', 'MV', 'Maldives', 'SEARO', '21', '12030', '1', '41');
INSERT INTO public.who_global_data_import VALUES (50715, '2020-11-12', 'MV', 'Maldives', 'SEARO', '29', '12059', '0', '41');
INSERT INTO public.who_global_data_import VALUES (50716, '2020-11-13', 'MV', 'Maldives', 'SEARO', '26', '12085', '0', '41');
INSERT INTO public.who_global_data_import VALUES (50717, '2020-11-14', 'MV', 'Maldives', 'SEARO', '27', '12112', '0', '41');
INSERT INTO public.who_global_data_import VALUES (50718, '2020-11-15', 'MV', 'Maldives', 'SEARO', '42', '12154', '1', '42');
INSERT INTO public.who_global_data_import VALUES (50719, '2020-11-16', 'MV', 'Maldives', 'SEARO', '50', '12204', '1', '43');
INSERT INTO public.who_global_data_import VALUES (50720, '2020-11-17', 'MV', 'Maldives', 'SEARO', '110', '12314', '1', '44');
INSERT INTO public.who_global_data_import VALUES (50721, '2020-11-18', 'MV', 'Maldives', 'SEARO', '41', '12355', '1', '45');
INSERT INTO public.who_global_data_import VALUES (50722, '2020-11-19', 'MV', 'Maldives', 'SEARO', '29', '12384', '0', '45');
INSERT INTO public.who_global_data_import VALUES (50723, '2020-11-20', 'MV', 'Maldives', 'SEARO', '68', '12452', '0', '45');
INSERT INTO public.who_global_data_import VALUES (50724, '2020-11-21', 'MV', 'Maldives', 'SEARO', '94', '12546', '0', '45');
INSERT INTO public.who_global_data_import VALUES (50725, '2020-11-22', 'MV', 'Maldives', 'SEARO', '32', '12578', '0', '45');
INSERT INTO public.who_global_data_import VALUES (50726, '2020-11-23', 'MV', 'Maldives', 'SEARO', '30', '12608', '1', '46');
INSERT INTO public.who_global_data_import VALUES (50727, '2020-11-24', 'MV', 'Maldives', 'SEARO', '150', '12758', '0', '46');
INSERT INTO public.who_global_data_import VALUES (50728, '2020-11-25', 'MV', 'Maldives', 'SEARO', '52', '12810', '0', '46');
INSERT INTO public.who_global_data_import VALUES (50729, '2020-11-26', 'MV', 'Maldives', 'SEARO', '44', '12854', '0', '46');
INSERT INTO public.who_global_data_import VALUES (50730, '2020-11-27', 'MV', 'Maldives', 'SEARO', '35', '12889', '0', '46');
INSERT INTO public.who_global_data_import VALUES (50731, '2020-11-28', 'MV', 'Maldives', 'SEARO', '44', '12933', '0', '46');
INSERT INTO public.who_global_data_import VALUES (50732, '2020-11-29', 'MV', 'Maldives', 'SEARO', '14', '12947', '0', '46');
INSERT INTO public.who_global_data_import VALUES (50733, '2020-11-30', 'MV', 'Maldives', 'SEARO', '47', '12994', '0', '46');
INSERT INTO public.who_global_data_import VALUES (50734, '2020-12-01', 'MV', 'Maldives', 'SEARO', '17', '13011', '0', '46');
INSERT INTO public.who_global_data_import VALUES (50735, '2020-12-02', 'MV', 'Maldives', 'SEARO', '38', '13049', '1', '47');
INSERT INTO public.who_global_data_import VALUES (50736, '2020-12-03', 'MV', 'Maldives', 'SEARO', '21', '13070', '0', '47');
INSERT INTO public.who_global_data_import VALUES (50737, '2020-12-04', 'MV', 'Maldives', 'SEARO', '36', '13106', '0', '47');
INSERT INTO public.who_global_data_import VALUES (50738, '2020-12-05', 'MV', 'Maldives', 'SEARO', '37', '13143', '0', '47');
INSERT INTO public.who_global_data_import VALUES (50739, '2020-12-06', 'MV', 'Maldives', 'SEARO', '16', '13159', '0', '47');
INSERT INTO public.who_global_data_import VALUES (50740, '2020-12-07', 'MV', 'Maldives', 'SEARO', '39', '13198', '0', '47');
INSERT INTO public.who_global_data_import VALUES (50741, '2020-12-08', 'MV', 'Maldives', 'SEARO', '0', '13198', '0', '47');
INSERT INTO public.who_global_data_import VALUES (50742, '2020-12-09', 'MV', 'Maldives', 'SEARO', '50', '13248', '0', '47');
INSERT INTO public.who_global_data_import VALUES (50743, '2020-12-10', 'MV', 'Maldives', 'SEARO', '26', '13274', '0', '47');
INSERT INTO public.who_global_data_import VALUES (50744, '2020-12-11', 'MV', 'Maldives', 'SEARO', '34', '13308', '0', '47');
INSERT INTO public.who_global_data_import VALUES (50745, '2020-12-12', 'MV', 'Maldives', 'SEARO', '18', '13326', '1', '48');
INSERT INTO public.who_global_data_import VALUES (50746, '2020-12-13', 'MV', 'Maldives', 'SEARO', '22', '13348', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50747, '2020-12-14', 'MV', 'Maldives', 'SEARO', '20', '13368', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50748, '2020-12-15', 'MV', 'Maldives', 'SEARO', '11', '13379', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50749, '2020-12-16', 'MV', 'Maldives', 'SEARO', '13', '13392', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50750, '2020-12-17', 'MV', 'Maldives', 'SEARO', '10', '13402', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50751, '2020-12-18', 'MV', 'Maldives', 'SEARO', '16', '13418', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50752, '2020-12-19', 'MV', 'Maldives', 'SEARO', '26', '13444', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50753, '2020-12-20', 'MV', 'Maldives', 'SEARO', '30', '13474', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50754, '2020-12-21', 'MV', 'Maldives', 'SEARO', '19', '13493', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50755, '2020-12-22', 'MV', 'Maldives', 'SEARO', '8', '13501', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50756, '2020-12-23', 'MV', 'Maldives', 'SEARO', '23', '13524', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50757, '2020-12-24', 'MV', 'Maldives', 'SEARO', '13', '13537', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50758, '2020-12-25', 'MV', 'Maldives', 'SEARO', '21', '13558', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50759, '2020-12-26', 'MV', 'Maldives', 'SEARO', '25', '13583', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50760, '2020-12-27', 'MV', 'Maldives', 'SEARO', '35', '13618', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50761, '2020-12-28', 'MV', 'Maldives', 'SEARO', '26', '13644', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50762, '2020-12-29', 'MV', 'Maldives', 'SEARO', '16', '13660', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50763, '2020-12-30', 'MV', 'Maldives', 'SEARO', '31', '13691', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50764, '2020-12-31', 'MV', 'Maldives', 'SEARO', '47', '13738', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50765, '2021-01-01', 'MV', 'Maldives', 'SEARO', '19', '13757', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50766, '2021-01-02', 'MV', 'Maldives', 'SEARO', '47', '13804', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50767, '2021-01-03', 'MV', 'Maldives', 'SEARO', '30', '13834', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50768, '2021-01-04', 'MV', 'Maldives', 'SEARO', '33', '13867', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50769, '2021-01-05', 'MV', 'Maldives', 'SEARO', '26', '13893', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50770, '2021-01-06', 'MV', 'Maldives', 'SEARO', '37', '13930', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50771, '2021-01-07', 'MV', 'Maldives', 'SEARO', '37', '13967', '0', '48');
INSERT INTO public.who_global_data_import VALUES (50772, '2021-01-08', 'MV', 'Maldives', 'SEARO', '21', '13988', '1', '49');
INSERT INTO public.who_global_data_import VALUES (50773, '2021-01-09', 'MV', 'Maldives', 'SEARO', '52', '14040', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50774, '2021-01-10', 'MV', 'Maldives', 'SEARO', '25', '14065', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50775, '2021-01-11', 'MV', 'Maldives', 'SEARO', '44', '14109', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50776, '2021-01-12', 'MV', 'Maldives', 'SEARO', '50', '14159', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50777, '2021-01-13', 'MV', 'Maldives', 'SEARO', '59', '14218', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50778, '2021-01-14', 'MV', 'Maldives', 'SEARO', '59', '14277', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50779, '2021-01-15', 'MV', 'Maldives', 'SEARO', '48', '14325', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50780, '2021-01-16', 'MV', 'Maldives', 'SEARO', '50', '14375', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50781, '2021-01-17', 'MV', 'Maldives', 'SEARO', '87', '14462', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50782, '2021-01-18', 'MV', 'Maldives', 'SEARO', '51', '14513', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50783, '2021-01-19', 'MV', 'Maldives', 'SEARO', '69', '14582', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50784, '2021-01-20', 'MV', 'Maldives', 'SEARO', '51', '14633', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50785, '2021-01-21', 'MV', 'Maldives', 'SEARO', '79', '14712', '0', '49');
INSERT INTO public.who_global_data_import VALUES (50786, '2021-01-22', 'MV', 'Maldives', 'SEARO', '53', '14765', '1', '50');
INSERT INTO public.who_global_data_import VALUES (50787, '2021-01-23', 'MV', 'Maldives', 'SEARO', '65', '14830', '0', '50');
INSERT INTO public.who_global_data_import VALUES (50788, '2021-01-24', 'MV', 'Maldives', 'SEARO', '55', '14885', '0', '50');
INSERT INTO public.who_global_data_import VALUES (50789, '2021-01-25', 'MV', 'Maldives', 'SEARO', '108', '14993', '1', '51');
INSERT INTO public.who_global_data_import VALUES (50790, '2021-01-26', 'MV', 'Maldives', 'SEARO', '109', '15102', '0', '51');
INSERT INTO public.who_global_data_import VALUES (50791, '2021-01-27', 'MV', 'Maldives', 'SEARO', '145', '15247', '0', '51');
INSERT INTO public.who_global_data_import VALUES (50792, '2021-01-28', 'MV', 'Maldives', 'SEARO', '143', '15390', '0', '51');
INSERT INTO public.who_global_data_import VALUES (50793, '2021-01-29', 'MV', 'Maldives', 'SEARO', '106', '15496', '0', '51');
INSERT INTO public.who_global_data_import VALUES (50794, '2021-01-30', 'MV', 'Maldives', 'SEARO', '118', '15614', '0', '51');
INSERT INTO public.who_global_data_import VALUES (50795, '2021-01-31', 'MV', 'Maldives', 'SEARO', '122', '15736', '0', '51');
INSERT INTO public.who_global_data_import VALUES (50796, '2021-02-01', 'MV', 'Maldives', 'SEARO', '105', '15841', '1', '52');
INSERT INTO public.who_global_data_import VALUES (50797, '2021-02-02', 'MV', 'Maldives', 'SEARO', '215', '16056', '0', '52');
INSERT INTO public.who_global_data_import VALUES (50798, '2021-02-03', 'MV', 'Maldives', 'SEARO', '99', '16155', '0', '52');
INSERT INTO public.who_global_data_import VALUES (50799, '2021-02-04', 'MV', 'Maldives', 'SEARO', '121', '16276', '1', '53');
INSERT INTO public.who_global_data_import VALUES (50800, '2021-02-05', 'MV', 'Maldives', 'SEARO', '134', '16410', '1', '54');
INSERT INTO public.who_global_data_import VALUES (50801, '2020-01-03', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50802, '2020-01-04', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50803, '2020-01-05', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50804, '2020-01-06', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50805, '2020-01-07', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50806, '2020-01-08', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50807, '2020-01-09', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50808, '2020-01-10', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50809, '2020-01-11', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50810, '2020-01-12', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50811, '2020-01-13', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50812, '2020-01-14', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50813, '2020-01-15', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50814, '2020-01-16', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50815, '2020-01-17', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50816, '2020-01-18', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50817, '2020-01-19', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50818, '2020-01-20', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50819, '2020-01-21', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50820, '2020-01-22', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50821, '2020-01-23', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50822, '2020-01-24', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50823, '2020-01-25', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50824, '2020-01-26', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50825, '2020-01-27', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50826, '2020-01-28', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50827, '2020-01-29', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50828, '2020-01-30', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50829, '2020-01-31', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50830, '2020-02-01', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50831, '2020-02-02', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50832, '2020-02-03', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50833, '2020-02-04', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50834, '2020-02-05', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50835, '2020-02-06', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50836, '2020-02-07', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50837, '2020-02-08', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50838, '2020-02-09', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50839, '2020-02-10', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50840, '2020-02-11', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50841, '2020-02-12', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50842, '2020-02-13', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50843, '2020-02-14', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50844, '2020-02-15', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50845, '2020-02-16', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50846, '2020-02-17', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50847, '2020-02-18', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50848, '2020-02-19', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50849, '2020-02-20', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50850, '2020-02-21', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50851, '2020-02-22', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50852, '2020-02-23', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50853, '2020-02-24', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50854, '2020-02-25', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50855, '2020-02-26', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50856, '2020-02-27', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50857, '2020-02-28', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50858, '2020-02-29', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50859, '2020-03-01', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50860, '2020-03-02', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50861, '2020-03-03', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50862, '2020-03-04', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50863, '2020-03-05', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50864, '2020-03-06', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50865, '2020-03-07', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50866, '2020-03-08', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50867, '2020-03-09', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50868, '2020-03-10', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50869, '2020-03-11', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50870, '2020-03-12', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50871, '2020-03-13', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50872, '2020-03-14', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50873, '2020-03-15', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50874, '2020-03-16', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50875, '2020-03-17', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50876, '2020-03-18', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50877, '2020-03-19', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50878, '2020-03-20', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50879, '2020-03-21', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50880, '2020-03-22', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50881, '2020-03-23', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50882, '2020-03-24', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50883, '2020-03-25', 'ML', 'Mali', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50884, '2020-03-26', 'ML', 'Mali', 'AFRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50885, '2020-03-27', 'ML', 'Mali', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50886, '2020-03-28', 'ML', 'Mali', 'AFRO', '7', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50887, '2020-03-29', 'ML', 'Mali', 'AFRO', '9', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50888, '2020-03-30', 'ML', 'Mali', 'AFRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50889, '2020-03-31', 'ML', 'Mali', 'AFRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50890, '2020-04-01', 'ML', 'Mali', 'AFRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50891, '2020-04-02', 'ML', 'Mali', 'AFRO', '10', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (50892, '2020-04-03', 'ML', 'Mali', 'AFRO', '0', '28', '3', '3');
INSERT INTO public.who_global_data_import VALUES (50893, '2020-04-04', 'ML', 'Mali', 'AFRO', '8', '36', '0', '3');
INSERT INTO public.who_global_data_import VALUES (50894, '2020-04-05', 'ML', 'Mali', 'AFRO', '3', '39', '1', '4');
INSERT INTO public.who_global_data_import VALUES (50895, '2020-04-06', 'ML', 'Mali', 'AFRO', '0', '39', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50896, '2020-04-07', 'ML', 'Mali', 'AFRO', '0', '39', '0', '4');
INSERT INTO public.who_global_data_import VALUES (50897, '2020-04-08', 'ML', 'Mali', 'AFRO', '8', '47', '1', '5');
INSERT INTO public.who_global_data_import VALUES (50898, '2020-04-09', 'ML', 'Mali', 'AFRO', '9', '56', '1', '6');
INSERT INTO public.who_global_data_import VALUES (50899, '2020-04-10', 'ML', 'Mali', 'AFRO', '3', '59', '1', '7');
INSERT INTO public.who_global_data_import VALUES (50900, '2020-04-11', 'ML', 'Mali', 'AFRO', '15', '74', '0', '7');
INSERT INTO public.who_global_data_import VALUES (50901, '2020-04-12', 'ML', 'Mali', 'AFRO', '13', '87', '0', '7');
INSERT INTO public.who_global_data_import VALUES (50902, '2020-04-13', 'ML', 'Mali', 'AFRO', '0', '87', '0', '7');
INSERT INTO public.who_global_data_import VALUES (50903, '2020-04-14', 'ML', 'Mali', 'AFRO', '29', '116', '2', '9');
INSERT INTO public.who_global_data_import VALUES (50904, '2020-04-15', 'ML', 'Mali', 'AFRO', '7', '123', '1', '10');
INSERT INTO public.who_global_data_import VALUES (50905, '2020-04-16', 'ML', 'Mali', 'AFRO', '21', '144', '3', '13');
INSERT INTO public.who_global_data_import VALUES (50906, '2020-04-17', 'ML', 'Mali', 'AFRO', '27', '171', '0', '13');
INSERT INTO public.who_global_data_import VALUES (50907, '2020-04-18', 'ML', 'Mali', 'AFRO', '19', '190', '0', '13');
INSERT INTO public.who_global_data_import VALUES (50908, '2020-04-19', 'ML', 'Mali', 'AFRO', '26', '216', '0', '13');
INSERT INTO public.who_global_data_import VALUES (50909, '2020-04-20', 'ML', 'Mali', 'AFRO', '8', '224', '1', '14');
INSERT INTO public.who_global_data_import VALUES (50910, '2020-04-21', 'ML', 'Mali', 'AFRO', '22', '246', '0', '14');
INSERT INTO public.who_global_data_import VALUES (50911, '2020-04-22', 'ML', 'Mali', 'AFRO', '12', '258', '0', '14');
INSERT INTO public.who_global_data_import VALUES (50912, '2020-04-23', 'ML', 'Mali', 'AFRO', '35', '293', '3', '17');
INSERT INTO public.who_global_data_import VALUES (50913, '2020-04-24', 'ML', 'Mali', 'AFRO', '16', '309', '4', '21');
INSERT INTO public.who_global_data_import VALUES (50914, '2020-04-25', 'ML', 'Mali', 'AFRO', '16', '325', '0', '21');
INSERT INTO public.who_global_data_import VALUES (50915, '2020-04-26', 'ML', 'Mali', 'AFRO', '45', '370', '0', '21');
INSERT INTO public.who_global_data_import VALUES (50916, '2020-04-27', 'ML', 'Mali', 'AFRO', '19', '389', '2', '23');
INSERT INTO public.who_global_data_import VALUES (50917, '2020-04-28', 'ML', 'Mali', 'AFRO', '19', '408', '0', '23');
INSERT INTO public.who_global_data_import VALUES (50918, '2020-04-29', 'ML', 'Mali', 'AFRO', '16', '424', '1', '24');
INSERT INTO public.who_global_data_import VALUES (50919, '2020-04-30', 'ML', 'Mali', 'AFRO', '58', '482', '1', '25');
INSERT INTO public.who_global_data_import VALUES (50920, '2020-05-01', 'ML', 'Mali', 'AFRO', '8', '490', '1', '26');
INSERT INTO public.who_global_data_import VALUES (50921, '2020-05-02', 'ML', 'Mali', 'AFRO', '18', '508', '0', '26');
INSERT INTO public.who_global_data_import VALUES (50922, '2020-05-03', 'ML', 'Mali', 'AFRO', '36', '544', '0', '26');
INSERT INTO public.who_global_data_import VALUES (50923, '2020-05-04', 'ML', 'Mali', 'AFRO', '19', '563', '1', '27');
INSERT INTO public.who_global_data_import VALUES (50924, '2020-05-05', 'ML', 'Mali', 'AFRO', '17', '580', '2', '29');
INSERT INTO public.who_global_data_import VALUES (50925, '2020-05-06', 'ML', 'Mali', 'AFRO', '32', '612', '3', '32');
INSERT INTO public.who_global_data_import VALUES (50926, '2020-05-07', 'ML', 'Mali', 'AFRO', '19', '631', '0', '32');
INSERT INTO public.who_global_data_import VALUES (50927, '2020-05-08', 'ML', 'Mali', 'AFRO', '19', '650', '0', '32');
INSERT INTO public.who_global_data_import VALUES (50928, '2020-05-09', 'ML', 'Mali', 'AFRO', '18', '668', '3', '35');
INSERT INTO public.who_global_data_import VALUES (50929, '2020-05-10', 'ML', 'Mali', 'AFRO', '24', '692', '2', '37');
INSERT INTO public.who_global_data_import VALUES (50930, '2020-05-11', 'ML', 'Mali', 'AFRO', '12', '704', '1', '38');
INSERT INTO public.who_global_data_import VALUES (50931, '2020-05-12', 'ML', 'Mali', 'AFRO', '8', '712', '1', '39');
INSERT INTO public.who_global_data_import VALUES (50932, '2020-05-13', 'ML', 'Mali', 'AFRO', '18', '730', '1', '40');
INSERT INTO public.who_global_data_import VALUES (50933, '2020-05-14', 'ML', 'Mali', 'AFRO', '28', '758', '4', '44');
INSERT INTO public.who_global_data_import VALUES (50934, '2020-05-15', 'ML', 'Mali', 'AFRO', '21', '779', '2', '46');
INSERT INTO public.who_global_data_import VALUES (50935, '2020-05-16', 'ML', 'Mali', 'AFRO', '27', '806', '0', '46');
INSERT INTO public.who_global_data_import VALUES (50936, '2020-05-17', 'ML', 'Mali', 'AFRO', '29', '835', '2', '48');
INSERT INTO public.who_global_data_import VALUES (50937, '2020-05-18', 'ML', 'Mali', 'AFRO', '25', '860', '4', '52');
INSERT INTO public.who_global_data_import VALUES (50938, '2020-05-19', 'ML', 'Mali', 'AFRO', '14', '874', '0', '52');
INSERT INTO public.who_global_data_import VALUES (50939, '2020-05-20', 'ML', 'Mali', 'AFRO', '27', '901', '1', '53');
INSERT INTO public.who_global_data_import VALUES (50940, '2020-05-21', 'ML', 'Mali', 'AFRO', '30', '931', '2', '55');
INSERT INTO public.who_global_data_import VALUES (50941, '2020-05-22', 'ML', 'Mali', 'AFRO', '0', '931', '0', '55');
INSERT INTO public.who_global_data_import VALUES (50942, '2020-05-23', 'ML', 'Mali', 'AFRO', '38', '969', '7', '62');
INSERT INTO public.who_global_data_import VALUES (50943, '2020-05-24', 'ML', 'Mali', 'AFRO', '46', '1015', '0', '62');
INSERT INTO public.who_global_data_import VALUES (50944, '2020-05-25', 'ML', 'Mali', 'AFRO', '15', '1030', '3', '65');
INSERT INTO public.who_global_data_import VALUES (50945, '2020-05-26', 'ML', 'Mali', 'AFRO', '29', '1059', '2', '67');
INSERT INTO public.who_global_data_import VALUES (50946, '2020-05-27', 'ML', 'Mali', 'AFRO', '18', '1077', '3', '70');
INSERT INTO public.who_global_data_import VALUES (50947, '2020-05-28', 'ML', 'Mali', 'AFRO', '39', '1116', '0', '70');
INSERT INTO public.who_global_data_import VALUES (50948, '2020-05-29', 'ML', 'Mali', 'AFRO', '78', '1194', '2', '72');
INSERT INTO public.who_global_data_import VALUES (50949, '2020-05-30', 'ML', 'Mali', 'AFRO', '32', '1226', '1', '73');
INSERT INTO public.who_global_data_import VALUES (50950, '2020-05-31', 'ML', 'Mali', 'AFRO', '24', '1250', '3', '76');
INSERT INTO public.who_global_data_import VALUES (50951, '2020-06-01', 'ML', 'Mali', 'AFRO', '15', '1265', '1', '77');
INSERT INTO public.who_global_data_import VALUES (50952, '2020-06-02', 'ML', 'Mali', 'AFRO', '50', '1315', '1', '78');
INSERT INTO public.who_global_data_import VALUES (50953, '2020-06-03', 'ML', 'Mali', 'AFRO', '36', '1351', '0', '78');
INSERT INTO public.who_global_data_import VALUES (50954, '2020-06-04', 'ML', 'Mali', 'AFRO', '35', '1386', '1', '79');
INSERT INTO public.who_global_data_import VALUES (50955, '2020-06-05', 'ML', 'Mali', 'AFRO', '75', '1461', '6', '85');
INSERT INTO public.who_global_data_import VALUES (50956, '2020-06-06', 'ML', 'Mali', 'AFRO', '24', '1485', '2', '87');
INSERT INTO public.who_global_data_import VALUES (50957, '2020-06-07', 'ML', 'Mali', 'AFRO', '38', '1523', '3', '90');
INSERT INTO public.who_global_data_import VALUES (50958, '2020-06-08', 'ML', 'Mali', 'AFRO', '10', '1533', '2', '92');
INSERT INTO public.who_global_data_import VALUES (50959, '2020-06-09', 'ML', 'Mali', 'AFRO', '14', '1547', '0', '92');
INSERT INTO public.who_global_data_import VALUES (50960, '2020-06-10', 'ML', 'Mali', 'AFRO', '39', '1586', '2', '94');
INSERT INTO public.who_global_data_import VALUES (50961, '2020-06-11', 'ML', 'Mali', 'AFRO', '81', '1667', '2', '96');
INSERT INTO public.who_global_data_import VALUES (50962, '2020-06-12', 'ML', 'Mali', 'AFRO', '55', '1722', '1', '97');
INSERT INTO public.who_global_data_import VALUES (50963, '2020-06-13', 'ML', 'Mali', 'AFRO', '30', '1752', '4', '101');
INSERT INTO public.who_global_data_import VALUES (50964, '2020-06-14', 'ML', 'Mali', 'AFRO', '24', '1776', '3', '104');
INSERT INTO public.who_global_data_import VALUES (50965, '2020-06-15', 'ML', 'Mali', 'AFRO', '33', '1809', '0', '104');
INSERT INTO public.who_global_data_import VALUES (50966, '2020-06-16', 'ML', 'Mali', 'AFRO', '51', '1860', '0', '104');
INSERT INTO public.who_global_data_import VALUES (50967, '2020-06-17', 'ML', 'Mali', 'AFRO', '25', '1885', '2', '106');
INSERT INTO public.who_global_data_import VALUES (50968, '2020-06-18', 'ML', 'Mali', 'AFRO', '5', '1890', '1', '107');
INSERT INTO public.who_global_data_import VALUES (50969, '2020-06-19', 'ML', 'Mali', 'AFRO', '16', '1906', '0', '107');
INSERT INTO public.who_global_data_import VALUES (50970, '2020-06-20', 'ML', 'Mali', 'AFRO', '17', '1923', '1', '108');
INSERT INTO public.who_global_data_import VALUES (50971, '2020-06-21', 'ML', 'Mali', 'AFRO', '10', '1933', '1', '109');
INSERT INTO public.who_global_data_import VALUES (50972, '2020-06-22', 'ML', 'Mali', 'AFRO', '28', '1961', '2', '111');
INSERT INTO public.who_global_data_import VALUES (50973, '2020-06-23', 'ML', 'Mali', 'AFRO', '0', '1961', '0', '111');
INSERT INTO public.who_global_data_import VALUES (50974, '2020-06-24', 'ML', 'Mali', 'AFRO', '17', '1978', '0', '111');
INSERT INTO public.who_global_data_import VALUES (50975, '2020-06-25', 'ML', 'Mali', 'AFRO', '27', '2005', '2', '113');
INSERT INTO public.who_global_data_import VALUES (50976, '2020-06-26', 'ML', 'Mali', 'AFRO', '34', '2039', '0', '113');
INSERT INTO public.who_global_data_import VALUES (50977, '2020-06-27', 'ML', 'Mali', 'AFRO', '21', '2060', '0', '113');
INSERT INTO public.who_global_data_import VALUES (50978, '2020-06-28', 'ML', 'Mali', 'AFRO', '0', '2060', '0', '113');
INSERT INTO public.who_global_data_import VALUES (50979, '2020-06-29', 'ML', 'Mali', 'AFRO', '87', '2147', '1', '114');
INSERT INTO public.who_global_data_import VALUES (50980, '2020-06-30', 'ML', 'Mali', 'AFRO', '26', '2173', '1', '115');
INSERT INTO public.who_global_data_import VALUES (50981, '2020-07-01', 'ML', 'Mali', 'AFRO', '8', '2181', '1', '116');
INSERT INTO public.who_global_data_import VALUES (50982, '2020-07-02', 'ML', 'Mali', 'AFRO', '0', '2181', '0', '116');
INSERT INTO public.who_global_data_import VALUES (50983, '2020-07-03', 'ML', 'Mali', 'AFRO', '79', '2260', '1', '117');
INSERT INTO public.who_global_data_import VALUES (50984, '2020-07-04', 'ML', 'Mali', 'AFRO', '25', '2285', '0', '117');
INSERT INTO public.who_global_data_import VALUES (50985, '2020-07-05', 'ML', 'Mali', 'AFRO', '18', '2303', '1', '118');
INSERT INTO public.who_global_data_import VALUES (50986, '2020-07-06', 'ML', 'Mali', 'AFRO', '27', '2330', '1', '119');
INSERT INTO public.who_global_data_import VALUES (50987, '2020-07-07', 'ML', 'Mali', 'AFRO', '1', '2331', '0', '119');
INSERT INTO public.who_global_data_import VALUES (50988, '2020-07-08', 'ML', 'Mali', 'AFRO', '17', '2348', '0', '119');
INSERT INTO public.who_global_data_import VALUES (50989, '2020-07-09', 'ML', 'Mali', 'AFRO', '10', '2358', '1', '120');
INSERT INTO public.who_global_data_import VALUES (50990, '2020-07-10', 'ML', 'Mali', 'AFRO', '12', '2370', '0', '120');
INSERT INTO public.who_global_data_import VALUES (50991, '2020-07-11', 'ML', 'Mali', 'AFRO', '34', '2404', '1', '121');
INSERT INTO public.who_global_data_import VALUES (50992, '2020-07-12', 'ML', 'Mali', 'AFRO', '2', '2406', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50993, '2020-07-13', 'ML', 'Mali', 'AFRO', '5', '2411', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50994, '2020-07-14', 'ML', 'Mali', 'AFRO', '1', '2412', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50995, '2020-07-15', 'ML', 'Mali', 'AFRO', '11', '2423', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50996, '2020-07-16', 'ML', 'Mali', 'AFRO', '10', '2433', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50997, '2020-07-17', 'ML', 'Mali', 'AFRO', '7', '2440', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50998, '2020-07-18', 'ML', 'Mali', 'AFRO', '27', '2467', '0', '121');
INSERT INTO public.who_global_data_import VALUES (50999, '2020-07-19', 'ML', 'Mali', 'AFRO', '5', '2472', '0', '121');
INSERT INTO public.who_global_data_import VALUES (51000, '2020-07-20', 'ML', 'Mali', 'AFRO', '3', '2475', '0', '121');
INSERT INTO public.who_global_data_import VALUES (51001, '2020-07-21', 'ML', 'Mali', 'AFRO', '0', '2475', '0', '121');
INSERT INTO public.who_global_data_import VALUES (51002, '2020-07-22', 'ML', 'Mali', 'AFRO', '2', '2477', '1', '122');
INSERT INTO public.who_global_data_import VALUES (51003, '2020-07-23', 'ML', 'Mali', 'AFRO', '17', '2494', '1', '123');
INSERT INTO public.who_global_data_import VALUES (51004, '2020-07-24', 'ML', 'Mali', 'AFRO', '0', '2494', '0', '123');
INSERT INTO public.who_global_data_import VALUES (51005, '2020-07-25', 'ML', 'Mali', 'AFRO', '9', '2503', '0', '123');
INSERT INTO public.who_global_data_import VALUES (51006, '2020-07-26', 'ML', 'Mali', 'AFRO', '0', '2503', '0', '123');
INSERT INTO public.who_global_data_import VALUES (51007, '2020-07-27', 'ML', 'Mali', 'AFRO', '7', '2510', '0', '123');
INSERT INTO public.who_global_data_import VALUES (51008, '2020-07-28', 'ML', 'Mali', 'AFRO', '3', '2513', '1', '124');
INSERT INTO public.who_global_data_import VALUES (51009, '2020-07-29', 'ML', 'Mali', 'AFRO', '7', '2520', '0', '124');
INSERT INTO public.who_global_data_import VALUES (51010, '2020-07-30', 'ML', 'Mali', 'AFRO', '1', '2521', '0', '124');
INSERT INTO public.who_global_data_import VALUES (51011, '2020-07-31', 'ML', 'Mali', 'AFRO', '1', '2522', '0', '124');
INSERT INTO public.who_global_data_import VALUES (51012, '2020-08-01', 'ML', 'Mali', 'AFRO', '0', '2522', '0', '124');
INSERT INTO public.who_global_data_import VALUES (51013, '2020-08-02', 'ML', 'Mali', 'AFRO', '13', '2535', '0', '124');
INSERT INTO public.who_global_data_import VALUES (51014, '2020-08-03', 'ML', 'Mali', 'AFRO', '0', '2535', '0', '124');
INSERT INTO public.who_global_data_import VALUES (51015, '2020-08-04', 'ML', 'Mali', 'AFRO', '8', '2543', '0', '124');
INSERT INTO public.who_global_data_import VALUES (51016, '2020-08-05', 'ML', 'Mali', 'AFRO', '0', '2543', '0', '124');
INSERT INTO public.who_global_data_import VALUES (51017, '2020-08-06', 'ML', 'Mali', 'AFRO', '3', '2546', '0', '124');
INSERT INTO public.who_global_data_import VALUES (51018, '2020-08-07', 'ML', 'Mali', 'AFRO', '6', '2552', '0', '124');
INSERT INTO public.who_global_data_import VALUES (51019, '2020-08-08', 'ML', 'Mali', 'AFRO', '9', '2561', '1', '125');
INSERT INTO public.who_global_data_import VALUES (51020, '2020-08-09', 'ML', 'Mali', 'AFRO', '4', '2565', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51021, '2020-08-10', 'ML', 'Mali', 'AFRO', '2', '2567', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51022, '2020-08-11', 'ML', 'Mali', 'AFRO', '6', '2573', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51023, '2020-08-12', 'ML', 'Mali', 'AFRO', '4', '2577', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51024, '2020-08-13', 'ML', 'Mali', 'AFRO', '5', '2582', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51025, '2020-08-14', 'ML', 'Mali', 'AFRO', '15', '2597', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51026, '2020-08-15', 'ML', 'Mali', 'AFRO', '8', '2605', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51027, '2020-08-16', 'ML', 'Mali', 'AFRO', '9', '2614', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51028, '2020-08-17', 'ML', 'Mali', 'AFRO', '26', '2640', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51029, '2020-08-18', 'ML', 'Mali', 'AFRO', '0', '2640', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51030, '2020-08-19', 'ML', 'Mali', 'AFRO', '26', '2666', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51031, '2020-08-20', 'ML', 'Mali', 'AFRO', '1', '2667', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51032, '2020-08-21', 'ML', 'Mali', 'AFRO', '0', '2667', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51033, '2020-08-22', 'ML', 'Mali', 'AFRO', '21', '2688', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51034, '2020-08-23', 'ML', 'Mali', 'AFRO', '11', '2699', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51035, '2020-08-24', 'ML', 'Mali', 'AFRO', '6', '2705', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51036, '2020-08-25', 'ML', 'Mali', 'AFRO', '3', '2708', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51037, '2020-08-26', 'ML', 'Mali', 'AFRO', '0', '2708', '0', '125');
INSERT INTO public.who_global_data_import VALUES (51038, '2020-08-27', 'ML', 'Mali', 'AFRO', '9', '2717', '1', '126');
INSERT INTO public.who_global_data_import VALUES (51039, '2020-08-28', 'ML', 'Mali', 'AFRO', '13', '2730', '0', '126');
INSERT INTO public.who_global_data_import VALUES (51040, '2020-08-29', 'ML', 'Mali', 'AFRO', '6', '2736', '0', '126');
INSERT INTO public.who_global_data_import VALUES (51041, '2020-08-30', 'ML', 'Mali', 'AFRO', '21', '2757', '0', '126');
INSERT INTO public.who_global_data_import VALUES (51042, '2020-08-31', 'ML', 'Mali', 'AFRO', '16', '2773', '0', '126');
INSERT INTO public.who_global_data_import VALUES (51043, '2020-09-01', 'ML', 'Mali', 'AFRO', '3', '2776', '0', '126');
INSERT INTO public.who_global_data_import VALUES (51044, '2020-09-02', 'ML', 'Mali', 'AFRO', '1', '2777', '0', '126');
INSERT INTO public.who_global_data_import VALUES (51045, '2020-09-03', 'ML', 'Mali', 'AFRO', '25', '2802', '0', '126');
INSERT INTO public.who_global_data_import VALUES (51046, '2020-09-04', 'ML', 'Mali', 'AFRO', '5', '2807', '0', '126');
INSERT INTO public.who_global_data_import VALUES (51047, '2020-09-05', 'ML', 'Mali', 'AFRO', '7', '2814', '0', '126');
INSERT INTO public.who_global_data_import VALUES (51048, '2020-09-06', 'ML', 'Mali', 'AFRO', '19', '2833', '0', '126');
INSERT INTO public.who_global_data_import VALUES (51049, '2020-09-07', 'ML', 'Mali', 'AFRO', '9', '2842', '1', '127');
INSERT INTO public.who_global_data_import VALUES (51050, '2020-09-08', 'ML', 'Mali', 'AFRO', '28', '2870', '0', '127');
INSERT INTO public.who_global_data_import VALUES (51051, '2020-09-09', 'ML', 'Mali', 'AFRO', '12', '2882', '0', '127');
INSERT INTO public.who_global_data_import VALUES (51052, '2020-09-10', 'ML', 'Mali', 'AFRO', '16', '2898', '1', '128');
INSERT INTO public.who_global_data_import VALUES (51053, '2020-09-11', 'ML', 'Mali', 'AFRO', '11', '2909', '0', '128');
INSERT INTO public.who_global_data_import VALUES (51054, '2020-09-12', 'ML', 'Mali', 'AFRO', '3', '2912', '0', '128');
INSERT INTO public.who_global_data_import VALUES (51055, '2020-09-13', 'ML', 'Mali', 'AFRO', '4', '2916', '0', '128');
INSERT INTO public.who_global_data_import VALUES (51056, '2020-09-14', 'ML', 'Mali', 'AFRO', '8', '2924', '0', '128');
INSERT INTO public.who_global_data_import VALUES (51057, '2020-09-15', 'ML', 'Mali', 'AFRO', '11', '2935', '0', '128');
INSERT INTO public.who_global_data_import VALUES (51058, '2020-09-16', 'ML', 'Mali', 'AFRO', '5', '2940', '0', '128');
INSERT INTO public.who_global_data_import VALUES (51059, '2020-09-17', 'ML', 'Mali', 'AFRO', '26', '2966', '0', '128');
INSERT INTO public.who_global_data_import VALUES (51060, '2020-09-18', 'ML', 'Mali', 'AFRO', '17', '2983', '0', '128');
INSERT INTO public.who_global_data_import VALUES (51061, '2020-09-19', 'ML', 'Mali', 'AFRO', '8', '2991', '0', '128');
INSERT INTO public.who_global_data_import VALUES (51062, '2020-09-20', 'ML', 'Mali', 'AFRO', '15', '3006', '0', '128');
INSERT INTO public.who_global_data_import VALUES (51063, '2020-09-21', 'ML', 'Mali', 'AFRO', '7', '3013', '0', '128');
INSERT INTO public.who_global_data_import VALUES (51064, '2020-09-22', 'ML', 'Mali', 'AFRO', '11', '3024', '0', '128');
INSERT INTO public.who_global_data_import VALUES (51065, '2020-09-23', 'ML', 'Mali', 'AFRO', '6', '3030', '1', '129');
INSERT INTO public.who_global_data_import VALUES (51066, '2020-09-24', 'ML', 'Mali', 'AFRO', '4', '3034', '1', '130');
INSERT INTO public.who_global_data_import VALUES (51067, '2020-09-25', 'ML', 'Mali', 'AFRO', '7', '3041', '0', '130');
INSERT INTO public.who_global_data_import VALUES (51068, '2020-09-26', 'ML', 'Mali', 'AFRO', '23', '3064', '0', '130');
INSERT INTO public.who_global_data_import VALUES (51069, '2020-09-27', 'ML', 'Mali', 'AFRO', '16', '3080', '0', '130');
INSERT INTO public.who_global_data_import VALUES (51070, '2020-09-28', 'ML', 'Mali', 'AFRO', '6', '3086', '0', '130');
INSERT INTO public.who_global_data_import VALUES (51071, '2020-09-29', 'ML', 'Mali', 'AFRO', '4', '3090', '0', '130');
INSERT INTO public.who_global_data_import VALUES (51072, '2020-09-30', 'ML', 'Mali', 'AFRO', '11', '3101', '1', '131');
INSERT INTO public.who_global_data_import VALUES (51073, '2020-10-01', 'ML', 'Mali', 'AFRO', '17', '3118', '0', '131');
INSERT INTO public.who_global_data_import VALUES (51074, '2020-10-02', 'ML', 'Mali', 'AFRO', '13', '3131', '0', '131');
INSERT INTO public.who_global_data_import VALUES (51075, '2020-10-03', 'ML', 'Mali', 'AFRO', '25', '3156', '0', '131');
INSERT INTO public.who_global_data_import VALUES (51076, '2020-10-04', 'ML', 'Mali', 'AFRO', '14', '3170', '0', '131');
INSERT INTO public.who_global_data_import VALUES (51077, '2020-10-05', 'ML', 'Mali', 'AFRO', '14', '3184', '0', '131');
INSERT INTO public.who_global_data_import VALUES (51078, '2020-10-06', 'ML', 'Mali', 'AFRO', '5', '3189', '0', '131');
INSERT INTO public.who_global_data_import VALUES (51079, '2020-10-07', 'ML', 'Mali', 'AFRO', '6', '3195', '0', '131');
INSERT INTO public.who_global_data_import VALUES (51080, '2020-10-08', 'ML', 'Mali', 'AFRO', '15', '3210', '0', '131');
INSERT INTO public.who_global_data_import VALUES (51081, '2020-10-09', 'ML', 'Mali', 'AFRO', '25', '3235', '0', '131');
INSERT INTO public.who_global_data_import VALUES (51082, '2020-10-10', 'ML', 'Mali', 'AFRO', '13', '3248', '0', '131');
INSERT INTO public.who_global_data_import VALUES (51083, '2020-10-11', 'ML', 'Mali', 'AFRO', '25', '3273', '1', '132');
INSERT INTO public.who_global_data_import VALUES (51084, '2020-10-12', 'ML', 'Mali', 'AFRO', '13', '3286', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51085, '2020-10-13', 'ML', 'Mali', 'AFRO', '10', '3296', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51086, '2020-10-14', 'ML', 'Mali', 'AFRO', '1', '3297', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51087, '2020-10-15', 'ML', 'Mali', 'AFRO', '55', '3352', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51088, '2020-10-16', 'ML', 'Mali', 'AFRO', '16', '3368', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51089, '2020-10-17', 'ML', 'Mali', 'AFRO', '0', '3368', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51090, '2020-10-18', 'ML', 'Mali', 'AFRO', '11', '3379', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51091, '2020-10-19', 'ML', 'Mali', 'AFRO', '9', '3388', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51092, '2020-10-20', 'ML', 'Mali', 'AFRO', '19', '3407', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51093, '2020-10-21', 'ML', 'Mali', 'AFRO', '4', '3411', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51094, '2020-10-22', 'ML', 'Mali', 'AFRO', '17', '3428', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51095, '2020-10-23', 'ML', 'Mali', 'AFRO', '12', '3440', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51096, '2020-10-24', 'ML', 'Mali', 'AFRO', '0', '3440', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51097, '2020-10-25', 'ML', 'Mali', 'AFRO', '32', '3472', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51098, '2020-10-26', 'ML', 'Mali', 'AFRO', '0', '3472', '0', '132');
INSERT INTO public.who_global_data_import VALUES (51099, '2020-10-27', 'ML', 'Mali', 'AFRO', '27', '3499', '1', '133');
INSERT INTO public.who_global_data_import VALUES (51100, '2020-10-28', 'ML', 'Mali', 'AFRO', '16', '3515', '3', '136');
INSERT INTO public.who_global_data_import VALUES (51101, '2020-10-29', 'ML', 'Mali', 'AFRO', '15', '3530', '0', '136');
INSERT INTO public.who_global_data_import VALUES (51102, '2020-10-30', 'ML', 'Mali', 'AFRO', '7', '3537', '0', '136');
INSERT INTO public.who_global_data_import VALUES (51103, '2020-10-31', 'ML', 'Mali', 'AFRO', '8', '3545', '0', '136');
INSERT INTO public.who_global_data_import VALUES (51104, '2020-11-01', 'ML', 'Mali', 'AFRO', '9', '3554', '0', '136');
INSERT INTO public.who_global_data_import VALUES (51105, '2020-11-02', 'ML', 'Mali', 'AFRO', '11', '3565', '0', '136');
INSERT INTO public.who_global_data_import VALUES (51106, '2020-11-03', 'ML', 'Mali', 'AFRO', '8', '3573', '0', '136');
INSERT INTO public.who_global_data_import VALUES (51107, '2020-11-04', 'ML', 'Mali', 'AFRO', '11', '3584', '0', '136');
INSERT INTO public.who_global_data_import VALUES (51108, '2020-11-05', 'ML', 'Mali', 'AFRO', '0', '3584', '0', '136');
INSERT INTO public.who_global_data_import VALUES (51109, '2020-11-06', 'ML', 'Mali', 'AFRO', '49', '3633', '1', '137');
INSERT INTO public.who_global_data_import VALUES (51110, '2020-11-07', 'ML', 'Mali', 'AFRO', '0', '3633', '0', '137');
INSERT INTO public.who_global_data_import VALUES (51111, '2020-11-08', 'ML', 'Mali', 'AFRO', '43', '3676', '0', '137');
INSERT INTO public.who_global_data_import VALUES (51112, '2020-11-09', 'ML', 'Mali', 'AFRO', '30', '3706', '0', '137');
INSERT INTO public.who_global_data_import VALUES (51113, '2020-11-10', 'ML', 'Mali', 'AFRO', '0', '3706', '0', '137');
INSERT INTO public.who_global_data_import VALUES (51114, '2020-11-11', 'ML', 'Mali', 'AFRO', '39', '3745', '0', '137');
INSERT INTO public.who_global_data_import VALUES (51115, '2020-11-12', 'ML', 'Mali', 'AFRO', '8', '3753', '1', '138');
INSERT INTO public.who_global_data_import VALUES (51116, '2020-11-13', 'ML', 'Mali', 'AFRO', '39', '3792', '0', '138');
INSERT INTO public.who_global_data_import VALUES (51117, '2020-11-14', 'ML', 'Mali', 'AFRO', '14', '3806', '1', '139');
INSERT INTO public.who_global_data_import VALUES (51118, '2020-11-15', 'ML', 'Mali', 'AFRO', '62', '3868', '0', '139');
INSERT INTO public.who_global_data_import VALUES (51119, '2020-11-16', 'ML', 'Mali', 'AFRO', '32', '3900', '2', '141');
INSERT INTO public.who_global_data_import VALUES (51120, '2020-11-17', 'ML', 'Mali', 'AFRO', '48', '3948', '0', '141');
INSERT INTO public.who_global_data_import VALUES (51121, '2020-11-18', 'ML', 'Mali', 'AFRO', '32', '3980', '0', '141');
INSERT INTO public.who_global_data_import VALUES (51122, '2020-11-19', 'ML', 'Mali', 'AFRO', '0', '3980', '0', '141');
INSERT INTO public.who_global_data_import VALUES (51123, '2020-11-20', 'ML', 'Mali', 'AFRO', '113', '4093', '1', '142');
INSERT INTO public.who_global_data_import VALUES (51124, '2020-11-21', 'ML', 'Mali', 'AFRO', '76', '4169', '1', '143');
INSERT INTO public.who_global_data_import VALUES (51125, '2020-11-22', 'ML', 'Mali', 'AFRO', '37', '4206', '0', '143');
INSERT INTO public.who_global_data_import VALUES (51126, '2020-11-23', 'ML', 'Mali', 'AFRO', '49', '4255', '2', '145');
INSERT INTO public.who_global_data_import VALUES (51127, '2020-11-24', 'ML', 'Mali', 'AFRO', '71', '4326', '1', '146');
INSERT INTO public.who_global_data_import VALUES (51128, '2020-11-25', 'ML', 'Mali', 'AFRO', '0', '4326', '0', '146');
INSERT INTO public.who_global_data_import VALUES (51129, '2020-11-26', 'ML', 'Mali', 'AFRO', '135', '4461', '2', '148');
INSERT INTO public.who_global_data_import VALUES (51130, '2020-11-27', 'ML', 'Mali', 'AFRO', '44', '4505', '0', '148');
INSERT INTO public.who_global_data_import VALUES (51131, '2020-11-28', 'ML', 'Mali', 'AFRO', '62', '4567', '1', '149');
INSERT INTO public.who_global_data_import VALUES (51132, '2020-11-29', 'ML', 'Mali', 'AFRO', '0', '4567', '0', '149');
INSERT INTO public.who_global_data_import VALUES (51133, '2020-11-30', 'ML', 'Mali', 'AFRO', '121', '4688', '3', '152');
INSERT INTO public.who_global_data_import VALUES (51134, '2020-12-01', 'ML', 'Mali', 'AFRO', '0', '4688', '0', '152');
INSERT INTO public.who_global_data_import VALUES (51135, '2020-12-02', 'ML', 'Mali', 'AFRO', '74', '4762', '8', '160');
INSERT INTO public.who_global_data_import VALUES (51136, '2020-12-03', 'ML', 'Mali', 'AFRO', '75', '4837', '1', '161');
INSERT INTO public.who_global_data_import VALUES (51137, '2020-12-04', 'ML', 'Mali', 'AFRO', '43', '4880', '1', '162');
INSERT INTO public.who_global_data_import VALUES (51138, '2020-12-05', 'ML', 'Mali', 'AFRO', '58', '4938', '1', '163');
INSERT INTO public.who_global_data_import VALUES (51139, '2020-12-06', 'ML', 'Mali', 'AFRO', '124', '5062', '0', '163');
INSERT INTO public.who_global_data_import VALUES (51140, '2020-12-07', 'ML', 'Mali', 'AFRO', '73', '5135', '5', '168');
INSERT INTO public.who_global_data_import VALUES (51141, '2020-12-08', 'ML', 'Mali', 'AFRO', '155', '5290', '7', '175');
INSERT INTO public.who_global_data_import VALUES (51142, '2020-12-09', 'ML', 'Mali', 'AFRO', '152', '5442', '5', '180');
INSERT INTO public.who_global_data_import VALUES (51143, '2020-12-10', 'ML', 'Mali', 'AFRO', '0', '5442', '0', '180');
INSERT INTO public.who_global_data_import VALUES (51144, '2020-12-11', 'ML', 'Mali', 'AFRO', '134', '5576', '4', '184');
INSERT INTO public.who_global_data_import VALUES (51145, '2020-12-12', 'ML', 'Mali', 'AFRO', '73', '5649', '1', '185');
INSERT INTO public.who_global_data_import VALUES (51146, '2020-12-13', 'ML', 'Mali', 'AFRO', '72', '5721', '6', '191');
INSERT INTO public.who_global_data_import VALUES (51147, '2020-12-14', 'ML', 'Mali', 'AFRO', '93', '5814', '3', '194');
INSERT INTO public.who_global_data_import VALUES (51148, '2020-12-15', 'ML', 'Mali', 'AFRO', '22', '5836', '7', '201');
INSERT INTO public.who_global_data_import VALUES (51149, '2020-12-16', 'ML', 'Mali', 'AFRO', '42', '5878', '4', '205');
INSERT INTO public.who_global_data_import VALUES (51150, '2020-12-17', 'ML', 'Mali', 'AFRO', '91', '5969', '4', '209');
INSERT INTO public.who_global_data_import VALUES (51151, '2020-12-18', 'ML', 'Mali', 'AFRO', '80', '6049', '2', '211');
INSERT INTO public.who_global_data_import VALUES (51152, '2020-12-19', 'ML', 'Mali', 'AFRO', '0', '6049', '0', '211');
INSERT INTO public.who_global_data_import VALUES (51153, '2020-12-20', 'ML', 'Mali', 'AFRO', '115', '6164', '9', '220');
INSERT INTO public.who_global_data_import VALUES (51154, '2020-12-21', 'ML', 'Mali', 'AFRO', '27', '6191', '2', '222');
INSERT INTO public.who_global_data_import VALUES (51155, '2020-12-22', 'ML', 'Mali', 'AFRO', '41', '6232', '3', '225');
INSERT INTO public.who_global_data_import VALUES (51156, '2020-12-23', 'ML', 'Mali', 'AFRO', '59', '6291', '0', '225');
INSERT INTO public.who_global_data_import VALUES (51157, '2020-12-24', 'ML', 'Mali', 'AFRO', '0', '6291', '0', '225');
INSERT INTO public.who_global_data_import VALUES (51158, '2020-12-25', 'ML', 'Mali', 'AFRO', '0', '6291', '0', '225');
INSERT INTO public.who_global_data_import VALUES (51159, '2020-12-26', 'ML', 'Mali', 'AFRO', '0', '6291', '0', '225');
INSERT INTO public.who_global_data_import VALUES (51160, '2020-12-27', 'ML', 'Mali', 'AFRO', '283', '6574', '24', '249');
INSERT INTO public.who_global_data_import VALUES (51161, '2020-12-28', 'ML', 'Mali', 'AFRO', '55', '6629', '4', '253');
INSERT INTO public.who_global_data_import VALUES (51162, '2020-12-29', 'ML', 'Mali', 'AFRO', '74', '6703', '3', '256');
INSERT INTO public.who_global_data_import VALUES (51163, '2020-12-30', 'ML', 'Mali', 'AFRO', '0', '6703', '0', '256');
INSERT INTO public.who_global_data_import VALUES (51164, '2020-12-31', 'ML', 'Mali', 'AFRO', '326', '7029', '13', '269');
INSERT INTO public.who_global_data_import VALUES (51165, '2021-01-01', 'ML', 'Mali', 'AFRO', '61', '7090', '0', '269');
INSERT INTO public.who_global_data_import VALUES (51166, '2021-01-02', 'ML', 'Mali', 'AFRO', '0', '7090', '0', '269');
INSERT INTO public.who_global_data_import VALUES (51167, '2021-01-03', 'ML', 'Mali', 'AFRO', '136', '7226', '7', '276');
INSERT INTO public.who_global_data_import VALUES (51168, '2021-01-04', 'ML', 'Mali', 'AFRO', '27', '7253', '2', '278');
INSERT INTO public.who_global_data_import VALUES (51169, '2021-01-05', 'ML', 'Mali', 'AFRO', '7', '7260', '1', '279');
INSERT INTO public.who_global_data_import VALUES (51170, '2021-01-06', 'ML', 'Mali', 'AFRO', '0', '7260', '0', '279');
INSERT INTO public.who_global_data_import VALUES (51171, '2021-01-07', 'ML', 'Mali', 'AFRO', '135', '7395', '6', '285');
INSERT INTO public.who_global_data_import VALUES (51172, '2021-01-08', 'ML', 'Mali', 'AFRO', '0', '7395', '0', '285');
INSERT INTO public.who_global_data_import VALUES (51173, '2021-01-09', 'ML', 'Mali', 'AFRO', '32', '7427', '1', '286');
INSERT INTO public.who_global_data_import VALUES (51174, '2021-01-10', 'ML', 'Mali', 'AFRO', '138', '7565', '9', '295');
INSERT INTO public.who_global_data_import VALUES (51175, '2021-01-11', 'ML', 'Mali', 'AFRO', '35', '7600', '3', '298');
INSERT INTO public.who_global_data_import VALUES (51176, '2021-01-12', 'ML', 'Mali', 'AFRO', '64', '7664', '1', '299');
INSERT INTO public.who_global_data_import VALUES (51177, '2021-01-13', 'ML', 'Mali', 'AFRO', '23', '7687', '4', '303');
INSERT INTO public.who_global_data_import VALUES (51178, '2021-01-14', 'ML', 'Mali', 'AFRO', '51', '7738', '0', '303');
INSERT INTO public.who_global_data_import VALUES (51179, '2021-01-15', 'ML', 'Mali', 'AFRO', '0', '7738', '0', '303');
INSERT INTO public.who_global_data_import VALUES (51180, '2021-01-16', 'ML', 'Mali', 'AFRO', '62', '7800', '5', '308');
INSERT INTO public.who_global_data_import VALUES (51181, '2021-01-17', 'ML', 'Mali', 'AFRO', '23', '7823', '0', '308');
INSERT INTO public.who_global_data_import VALUES (51182, '2021-01-18', 'ML', 'Mali', 'AFRO', '16', '7839', '2', '310');
INSERT INTO public.who_global_data_import VALUES (51183, '2021-01-19', 'ML', 'Mali', 'AFRO', '16', '7855', '1', '311');
INSERT INTO public.who_global_data_import VALUES (51184, '2021-01-20', 'ML', 'Mali', 'AFRO', '25', '7880', '6', '317');
INSERT INTO public.who_global_data_import VALUES (51185, '2021-01-21', 'ML', 'Mali', 'AFRO', '17', '7897', '1', '318');
INSERT INTO public.who_global_data_import VALUES (51186, '2021-01-22', 'ML', 'Mali', 'AFRO', '14', '7911', '2', '320');
INSERT INTO public.who_global_data_import VALUES (51187, '2021-01-23', 'ML', 'Mali', 'AFRO', '26', '7937', '1', '321');
INSERT INTO public.who_global_data_import VALUES (51188, '2021-01-24', 'ML', 'Mali', 'AFRO', '28', '7965', '2', '323');
INSERT INTO public.who_global_data_import VALUES (51189, '2021-01-25', 'ML', 'Mali', 'AFRO', '18', '7983', '0', '323');
INSERT INTO public.who_global_data_import VALUES (51190, '2021-01-26', 'ML', 'Mali', 'AFRO', '0', '7983', '0', '323');
INSERT INTO public.who_global_data_import VALUES (51191, '2021-01-27', 'ML', 'Mali', 'AFRO', '23', '8006', '4', '327');
INSERT INTO public.who_global_data_import VALUES (51192, '2021-01-28', 'ML', 'Mali', 'AFRO', '31', '8037', '0', '327');
INSERT INTO public.who_global_data_import VALUES (51193, '2021-01-29', 'ML', 'Mali', 'AFRO', '19', '8056', '2', '329');
INSERT INTO public.who_global_data_import VALUES (51194, '2021-01-30', 'ML', 'Mali', 'AFRO', '7', '8063', '0', '329');
INSERT INTO public.who_global_data_import VALUES (51195, '2021-01-31', 'ML', 'Mali', 'AFRO', '6', '8069', '1', '330');
INSERT INTO public.who_global_data_import VALUES (51196, '2021-02-01', 'ML', 'Mali', 'AFRO', '22', '8091', '0', '330');
INSERT INTO public.who_global_data_import VALUES (51197, '2021-02-02', 'ML', 'Mali', 'AFRO', '9', '8100', '0', '330');
INSERT INTO public.who_global_data_import VALUES (51198, '2021-02-03', 'ML', 'Mali', 'AFRO', '11', '8111', '3', '333');
INSERT INTO public.who_global_data_import VALUES (51199, '2021-02-04', 'ML', 'Mali', 'AFRO', '8', '8119', '0', '333');
INSERT INTO public.who_global_data_import VALUES (51200, '2021-02-05', 'ML', 'Mali', 'AFRO', '11', '8130', '0', '333');
INSERT INTO public.who_global_data_import VALUES (51201, '2020-01-03', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51202, '2020-01-04', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51203, '2020-01-05', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51204, '2020-01-06', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51205, '2020-01-07', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51206, '2020-01-08', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51207, '2020-01-09', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51208, '2020-01-10', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51209, '2020-01-11', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51210, '2020-01-12', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51211, '2020-01-13', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51212, '2020-01-14', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51213, '2020-01-15', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51214, '2020-01-16', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51215, '2020-01-17', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51216, '2020-01-18', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51217, '2020-01-19', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51218, '2020-01-20', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51219, '2020-01-21', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51220, '2020-01-22', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51221, '2020-01-23', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51222, '2020-01-24', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51223, '2020-01-25', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51224, '2020-01-26', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51225, '2020-01-27', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51226, '2020-01-28', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51227, '2020-01-29', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51228, '2020-01-30', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51229, '2020-01-31', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51230, '2020-02-01', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51231, '2020-02-02', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51232, '2020-02-03', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51233, '2020-02-04', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51234, '2020-02-05', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51235, '2020-02-06', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51236, '2020-02-07', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51237, '2020-02-08', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51238, '2020-02-09', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51239, '2020-02-10', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51240, '2020-02-11', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51241, '2020-02-12', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51242, '2020-02-13', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51243, '2020-02-14', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51244, '2020-02-15', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51245, '2020-02-16', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51246, '2020-02-17', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51247, '2020-02-18', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51248, '2020-02-19', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51249, '2020-02-20', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51250, '2020-02-21', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51251, '2020-02-22', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51252, '2020-02-23', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51253, '2020-02-24', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51254, '2020-02-25', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51255, '2020-02-26', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51256, '2020-02-27', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51257, '2020-02-28', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51258, '2020-02-29', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51259, '2020-03-01', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51260, '2020-03-02', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51261, '2020-03-03', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51262, '2020-03-04', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51263, '2020-03-05', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51264, '2020-03-06', 'MT', 'Malta', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51265, '2020-03-07', 'MT', 'Malta', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51266, '2020-03-08', 'MT', 'Malta', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51267, '2020-03-09', 'MT', 'Malta', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51268, '2020-03-10', 'MT', 'Malta', 'EURO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51269, '2020-03-11', 'MT', 'Malta', 'EURO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51270, '2020-03-12', 'MT', 'Malta', 'EURO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51271, '2020-03-13', 'MT', 'Malta', 'EURO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51272, '2020-03-14', 'MT', 'Malta', 'EURO', '10', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51273, '2020-03-15', 'MT', 'Malta', 'EURO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51274, '2020-03-16', 'MT', 'Malta', 'EURO', '11', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51275, '2020-03-17', 'MT', 'Malta', 'EURO', '8', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51276, '2020-03-18', 'MT', 'Malta', 'EURO', '10', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51277, '2020-03-19', 'MT', 'Malta', 'EURO', '4', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51278, '2020-03-20', 'MT', 'Malta', 'EURO', '12', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51279, '2020-03-21', 'MT', 'Malta', 'EURO', '9', '73', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51280, '2020-03-22', 'MT', 'Malta', 'EURO', '17', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51281, '2020-03-23', 'MT', 'Malta', 'EURO', '17', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51282, '2020-03-24', 'MT', 'Malta', 'EURO', '7', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51283, '2020-03-25', 'MT', 'Malta', 'EURO', '15', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51284, '2020-03-26', 'MT', 'Malta', 'EURO', '5', '134', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51285, '2020-03-27', 'MT', 'Malta', 'EURO', '5', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51286, '2020-03-28', 'MT', 'Malta', 'EURO', '10', '149', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51287, '2020-03-29', 'MT', 'Malta', 'EURO', '2', '151', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51288, '2020-03-30', 'MT', 'Malta', 'EURO', '5', '156', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51289, '2020-03-31', 'MT', 'Malta', 'EURO', '13', '169', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51290, '2020-04-01', 'MT', 'Malta', 'EURO', '19', '188', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51291, '2020-04-02', 'MT', 'Malta', 'EURO', '7', '195', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51292, '2020-04-03', 'MT', 'Malta', 'EURO', '7', '202', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51293, '2020-04-04', 'MT', 'Malta', 'EURO', '11', '213', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51294, '2020-04-05', 'MT', 'Malta', 'EURO', '14', '227', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51295, '2020-04-06', 'MT', 'Malta', 'EURO', '14', '241', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51296, '2020-04-07', 'MT', 'Malta', 'EURO', '52', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51297, '2020-04-08', 'MT', 'Malta', 'EURO', '6', '299', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51298, '2020-04-09', 'MT', 'Malta', 'EURO', '38', '337', '1', '1');
INSERT INTO public.who_global_data_import VALUES (51299, '2020-04-10', 'MT', 'Malta', 'EURO', '13', '350', '1', '2');
INSERT INTO public.who_global_data_import VALUES (51300, '2020-04-11', 'MT', 'Malta', 'EURO', '20', '370', '0', '2');
INSERT INTO public.who_global_data_import VALUES (51301, '2020-04-12', 'MT', 'Malta', 'EURO', '8', '378', '1', '3');
INSERT INTO public.who_global_data_import VALUES (51302, '2020-04-13', 'MT', 'Malta', 'EURO', '6', '384', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51303, '2020-04-14', 'MT', 'Malta', 'EURO', '9', '393', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51304, '2020-04-15', 'MT', 'Malta', 'EURO', '6', '399', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51305, '2020-04-16', 'MT', 'Malta', 'EURO', '13', '412', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51306, '2020-04-17', 'MT', 'Malta', 'EURO', '10', '422', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51307, '2020-04-18', 'MT', 'Malta', 'EURO', '4', '426', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51308, '2020-04-19', 'MT', 'Malta', 'EURO', '1', '427', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51309, '2020-04-20', 'MT', 'Malta', 'EURO', '4', '431', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51310, '2020-04-21', 'MT', 'Malta', 'EURO', '12', '443', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51311, '2020-04-22', 'MT', 'Malta', 'EURO', '1', '444', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51312, '2020-04-23', 'MT', 'Malta', 'EURO', '0', '444', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51313, '2020-04-24', 'MT', 'Malta', 'EURO', '2', '446', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51314, '2020-04-25', 'MT', 'Malta', 'EURO', '1', '447', '0', '3');
INSERT INTO public.who_global_data_import VALUES (51315, '2020-04-26', 'MT', 'Malta', 'EURO', '2', '449', '1', '4');
INSERT INTO public.who_global_data_import VALUES (51316, '2020-04-27', 'MT', 'Malta', 'EURO', '0', '449', '0', '4');
INSERT INTO public.who_global_data_import VALUES (51317, '2020-04-28', 'MT', 'Malta', 'EURO', '8', '457', '0', '4');
INSERT INTO public.who_global_data_import VALUES (51318, '2020-04-29', 'MT', 'Malta', 'EURO', '5', '462', '0', '4');
INSERT INTO public.who_global_data_import VALUES (51319, '2020-04-30', 'MT', 'Malta', 'EURO', '2', '464', '0', '4');
INSERT INTO public.who_global_data_import VALUES (51320, '2020-05-01', 'MT', 'Malta', 'EURO', '2', '466', '0', '4');
INSERT INTO public.who_global_data_import VALUES (51321, '2020-05-02', 'MT', 'Malta', 'EURO', '1', '467', '0', '4');
INSERT INTO public.who_global_data_import VALUES (51322, '2020-05-03', 'MT', 'Malta', 'EURO', '9', '476', '0', '4');
INSERT INTO public.who_global_data_import VALUES (51323, '2020-05-04', 'MT', 'Malta', 'EURO', '3', '479', '0', '4');
INSERT INTO public.who_global_data_import VALUES (51324, '2020-05-05', 'MT', 'Malta', 'EURO', '1', '480', '0', '4');
INSERT INTO public.who_global_data_import VALUES (51325, '2020-05-06', 'MT', 'Malta', 'EURO', '3', '483', '1', '5');
INSERT INTO public.who_global_data_import VALUES (51326, '2020-05-07', 'MT', 'Malta', 'EURO', '2', '485', '0', '5');
INSERT INTO public.who_global_data_import VALUES (51327, '2020-05-08', 'MT', 'Malta', 'EURO', '3', '488', '0', '5');
INSERT INTO public.who_global_data_import VALUES (51328, '2020-05-09', 'MT', 'Malta', 'EURO', '1', '489', '0', '5');
INSERT INTO public.who_global_data_import VALUES (51329, '2020-05-10', 'MT', 'Malta', 'EURO', '6', '495', '0', '5');
INSERT INTO public.who_global_data_import VALUES (51330, '2020-05-11', 'MT', 'Malta', 'EURO', '7', '502', '0', '5');
INSERT INTO public.who_global_data_import VALUES (51331, '2020-05-12', 'MT', 'Malta', 'EURO', '3', '505', '0', '5');
INSERT INTO public.who_global_data_import VALUES (51332, '2020-05-13', 'MT', 'Malta', 'EURO', '2', '507', '1', '6');
INSERT INTO public.who_global_data_import VALUES (51333, '2020-05-14', 'MT', 'Malta', 'EURO', '14', '521', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51334, '2020-05-15', 'MT', 'Malta', 'EURO', '10', '531', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51335, '2020-05-16', 'MT', 'Malta', 'EURO', '14', '545', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51336, '2020-05-17', 'MT', 'Malta', 'EURO', '7', '552', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51337, '2020-05-18', 'MT', 'Malta', 'EURO', '5', '557', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51338, '2020-05-19', 'MT', 'Malta', 'EURO', '11', '568', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51339, '2020-05-20', 'MT', 'Malta', 'EURO', '15', '583', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51340, '2020-05-21', 'MT', 'Malta', 'EURO', '15', '598', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51341, '2020-05-22', 'MT', 'Malta', 'EURO', '1', '599', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51342, '2020-05-23', 'MT', 'Malta', 'EURO', '9', '608', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51343, '2020-05-24', 'MT', 'Malta', 'EURO', '1', '609', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51344, '2020-05-25', 'MT', 'Malta', 'EURO', '1', '610', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51345, '2020-05-26', 'MT', 'Malta', 'EURO', '0', '610', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51346, '2020-05-27', 'MT', 'Malta', 'EURO', '1', '611', '0', '6');
INSERT INTO public.who_global_data_import VALUES (51347, '2020-05-28', 'MT', 'Malta', 'EURO', '4', '615', '1', '7');
INSERT INTO public.who_global_data_import VALUES (51348, '2020-05-29', 'MT', 'Malta', 'EURO', '0', '615', '0', '7');
INSERT INTO public.who_global_data_import VALUES (51349, '2020-05-30', 'MT', 'Malta', 'EURO', '2', '617', '2', '9');
INSERT INTO public.who_global_data_import VALUES (51350, '2020-05-31', 'MT', 'Malta', 'EURO', '0', '617', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51351, '2020-06-01', 'MT', 'Malta', 'EURO', '1', '618', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51352, '2020-06-02', 'MT', 'Malta', 'EURO', '1', '619', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51353, '2020-06-03', 'MT', 'Malta', 'EURO', '2', '621', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51354, '2020-06-04', 'MT', 'Malta', 'EURO', '0', '621', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51355, '2020-06-05', 'MT', 'Malta', 'EURO', '3', '624', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51356, '2020-06-06', 'MT', 'Malta', 'EURO', '2', '626', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51357, '2020-06-07', 'MT', 'Malta', 'EURO', '2', '628', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51358, '2020-06-08', 'MT', 'Malta', 'EURO', '1', '629', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51359, '2020-06-09', 'MT', 'Malta', 'EURO', '2', '631', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51360, '2020-06-10', 'MT', 'Malta', 'EURO', '3', '634', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51361, '2020-06-11', 'MT', 'Malta', 'EURO', '5', '639', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51362, '2020-06-12', 'MT', 'Malta', 'EURO', '5', '644', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51363, '2020-06-13', 'MT', 'Malta', 'EURO', '1', '645', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51364, '2020-06-14', 'MT', 'Malta', 'EURO', '2', '647', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51365, '2020-06-15', 'MT', 'Malta', 'EURO', '2', '649', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51366, '2020-06-16', 'MT', 'Malta', 'EURO', '6', '655', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51367, '2020-06-17', 'MT', 'Malta', 'EURO', '6', '661', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51368, '2020-06-18', 'MT', 'Malta', 'EURO', '1', '662', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51369, '2020-06-19', 'MT', 'Malta', 'EURO', '0', '662', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51370, '2020-06-20', 'MT', 'Malta', 'EURO', '1', '663', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51371, '2020-06-21', 'MT', 'Malta', 'EURO', '1', '664', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51372, '2020-06-22', 'MT', 'Malta', 'EURO', '0', '664', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51373, '2020-06-23', 'MT', 'Malta', 'EURO', '0', '664', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51374, '2020-06-24', 'MT', 'Malta', 'EURO', '0', '664', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51375, '2020-06-25', 'MT', 'Malta', 'EURO', '3', '667', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51376, '2020-06-26', 'MT', 'Malta', 'EURO', '2', '669', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51377, '2020-06-27', 'MT', 'Malta', 'EURO', '0', '669', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51378, '2020-06-28', 'MT', 'Malta', 'EURO', '0', '669', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51379, '2020-06-29', 'MT', 'Malta', 'EURO', '0', '669', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51380, '2020-06-30', 'MT', 'Malta', 'EURO', '0', '669', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51381, '2020-07-01', 'MT', 'Malta', 'EURO', '1', '670', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51382, '2020-07-02', 'MT', 'Malta', 'EURO', '0', '670', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51383, '2020-07-03', 'MT', 'Malta', 'EURO', '1', '671', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51384, '2020-07-04', 'MT', 'Malta', 'EURO', '0', '671', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51385, '2020-07-05', 'MT', 'Malta', 'EURO', '0', '671', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51386, '2020-07-06', 'MT', 'Malta', 'EURO', '0', '671', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51387, '2020-07-07', 'MT', 'Malta', 'EURO', '1', '672', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51388, '2020-07-08', 'MT', 'Malta', 'EURO', '0', '672', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51389, '2020-07-09', 'MT', 'Malta', 'EURO', '1', '673', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51390, '2020-07-10', 'MT', 'Malta', 'EURO', '0', '673', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51391, '2020-07-11', 'MT', 'Malta', 'EURO', '0', '673', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51392, '2020-07-12', 'MT', 'Malta', 'EURO', '0', '673', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51393, '2020-07-13', 'MT', 'Malta', 'EURO', '0', '673', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51394, '2020-07-14', 'MT', 'Malta', 'EURO', '0', '673', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51395, '2020-07-15', 'MT', 'Malta', 'EURO', '0', '673', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51396, '2020-07-16', 'MT', 'Malta', 'EURO', '0', '673', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51397, '2020-07-17', 'MT', 'Malta', 'EURO', '0', '673', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51398, '2020-07-18', 'MT', 'Malta', 'EURO', '1', '674', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51399, '2020-07-19', 'MT', 'Malta', 'EURO', '0', '674', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51400, '2020-07-20', 'MT', 'Malta', 'EURO', '1', '675', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51401, '2020-07-21', 'MT', 'Malta', 'EURO', '0', '675', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51402, '2020-07-22', 'MT', 'Malta', 'EURO', '2', '677', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51403, '2020-07-23', 'MT', 'Malta', 'EURO', '1', '678', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51404, '2020-07-24', 'MT', 'Malta', 'EURO', '2', '680', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51405, '2020-07-25', 'MT', 'Malta', 'EURO', '4', '684', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51406, '2020-07-26', 'MT', 'Malta', 'EURO', '14', '698', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51407, '2020-07-27', 'MT', 'Malta', 'EURO', '1', '699', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51408, '2020-07-28', 'MT', 'Malta', 'EURO', '6', '705', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51409, '2020-07-29', 'MT', 'Malta', 'EURO', '13', '718', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51410, '2020-07-30', 'MT', 'Malta', 'EURO', '9', '727', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51411, '2020-07-31', 'MT', 'Malta', 'EURO', '9', '736', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51412, '2020-08-01', 'MT', 'Malta', 'EURO', '18', '754', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51413, '2020-08-02', 'MT', 'Malta', 'EURO', '15', '769', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51414, '2020-08-03', 'MT', 'Malta', 'EURO', '14', '783', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51415, '2020-08-04', 'MT', 'Malta', 'EURO', '16', '799', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51416, '2020-08-05', 'MT', 'Malta', 'EURO', '21', '820', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51417, '2020-08-06', 'MT', 'Malta', 'EURO', '19', '839', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51418, '2020-08-07', 'MT', 'Malta', 'EURO', '50', '889', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51419, '2020-08-08', 'MT', 'Malta', 'EURO', '40', '929', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51420, '2020-08-09', 'MT', 'Malta', 'EURO', '54', '983', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51421, '2020-08-10', 'MT', 'Malta', 'EURO', '23', '1006', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51422, '2020-08-11', 'MT', 'Malta', 'EURO', '29', '1035', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51423, '2020-08-12', 'MT', 'Malta', 'EURO', '49', '1084', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51424, '2020-08-13', 'MT', 'Malta', 'EURO', '55', '1139', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51425, '2020-08-14', 'MT', 'Malta', 'EURO', '31', '1170', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51426, '2020-08-15', 'MT', 'Malta', 'EURO', '72', '1242', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51427, '2020-08-16', 'MT', 'Malta', 'EURO', '63', '1305', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51428, '2020-08-17', 'MT', 'Malta', 'EURO', '68', '1373', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51429, '2020-08-18', 'MT', 'Malta', 'EURO', '49', '1422', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51430, '2020-08-19', 'MT', 'Malta', 'EURO', '47', '1469', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51431, '2020-08-20', 'MT', 'Malta', 'EURO', '40', '1509', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51432, '2020-08-21', 'MT', 'Malta', 'EURO', '36', '1545', '0', '9');
INSERT INTO public.who_global_data_import VALUES (51433, '2020-08-22', 'MT', 'Malta', 'EURO', '31', '1576', '1', '10');
INSERT INTO public.who_global_data_import VALUES (51434, '2020-08-23', 'MT', 'Malta', 'EURO', '35', '1611', '0', '10');
INSERT INTO public.who_global_data_import VALUES (51435, '2020-08-24', 'MT', 'Malta', 'EURO', '57', '1668', '0', '10');
INSERT INTO public.who_global_data_import VALUES (51436, '2020-08-25', 'MT', 'Malta', 'EURO', '38', '1706', '0', '10');
INSERT INTO public.who_global_data_import VALUES (51437, '2020-08-26', 'MT', 'Malta', 'EURO', '46', '1752', '0', '10');
INSERT INTO public.who_global_data_import VALUES (51438, '2020-08-27', 'MT', 'Malta', 'EURO', '37', '1789', '0', '10');
INSERT INTO public.who_global_data_import VALUES (51439, '2020-08-28', 'MT', 'Malta', 'EURO', '32', '1821', '0', '10');
INSERT INTO public.who_global_data_import VALUES (51440, '2020-08-29', 'MT', 'Malta', 'EURO', '28', '1849', '0', '10');
INSERT INTO public.who_global_data_import VALUES (51441, '2020-08-30', 'MT', 'Malta', 'EURO', '15', '1864', '1', '11');
INSERT INTO public.who_global_data_import VALUES (51442, '2020-08-31', 'MT', 'Malta', 'EURO', '21', '1885', '1', '12');
INSERT INTO public.who_global_data_import VALUES (51443, '2020-09-01', 'MT', 'Malta', 'EURO', '26', '1911', '0', '12');
INSERT INTO public.who_global_data_import VALUES (51444, '2020-09-02', 'MT', 'Malta', 'EURO', '21', '1932', '1', '13');
INSERT INTO public.who_global_data_import VALUES (51445, '2020-09-03', 'MT', 'Malta', 'EURO', '34', '1966', '0', '13');
INSERT INTO public.who_global_data_import VALUES (51446, '2020-09-04', 'MT', 'Malta', 'EURO', '19', '1985', '0', '13');
INSERT INTO public.who_global_data_import VALUES (51447, '2020-09-05', 'MT', 'Malta', 'EURO', '30', '2015', '0', '13');
INSERT INTO public.who_global_data_import VALUES (51448, '2020-09-06', 'MT', 'Malta', 'EURO', '25', '2040', '1', '14');
INSERT INTO public.who_global_data_import VALUES (51449, '2020-09-07', 'MT', 'Malta', 'EURO', '37', '2077', '0', '14');
INSERT INTO public.who_global_data_import VALUES (51450, '2020-09-08', 'MT', 'Malta', 'EURO', '23', '2100', '0', '14');
INSERT INTO public.who_global_data_import VALUES (51451, '2020-09-09', 'MT', 'Malta', 'EURO', '63', '2163', '0', '14');
INSERT INTO public.who_global_data_import VALUES (51452, '2020-09-10', 'MT', 'Malta', 'EURO', '42', '2205', '0', '14');
INSERT INTO public.who_global_data_import VALUES (51453, '2020-09-11', 'MT', 'Malta', 'EURO', '43', '2248', '1', '15');
INSERT INTO public.who_global_data_import VALUES (51454, '2020-09-12', 'MT', 'Malta', 'EURO', '27', '2275', '0', '15');
INSERT INTO public.who_global_data_import VALUES (51455, '2020-09-13', 'MT', 'Malta', 'EURO', '78', '2353', '0', '15');
INSERT INTO public.who_global_data_import VALUES (51456, '2020-09-14', 'MT', 'Malta', 'EURO', '53', '2406', '0', '15');
INSERT INTO public.who_global_data_import VALUES (51457, '2020-09-15', 'MT', 'Malta', 'EURO', '49', '2455', '1', '16');
INSERT INTO public.who_global_data_import VALUES (51458, '2020-09-16', 'MT', 'Malta', 'EURO', '106', '2561', '0', '16');
INSERT INTO public.who_global_data_import VALUES (51459, '2020-09-17', 'MT', 'Malta', 'EURO', '35', '2596', '0', '16');
INSERT INTO public.who_global_data_import VALUES (51460, '2020-09-18', 'MT', 'Malta', 'EURO', '38', '2634', '1', '17');
INSERT INTO public.who_global_data_import VALUES (51461, '2020-09-19', 'MT', 'Malta', 'EURO', '65', '2699', '2', '19');
INSERT INTO public.who_global_data_import VALUES (51462, '2020-09-20', 'MT', 'Malta', 'EURO', '32', '2731', '1', '20');
INSERT INTO public.who_global_data_import VALUES (51463, '2020-09-21', 'MT', 'Malta', 'EURO', '46', '2777', '1', '21');
INSERT INTO public.who_global_data_import VALUES (51464, '2020-09-22', 'MT', 'Malta', 'EURO', '38', '2815', '2', '23');
INSERT INTO public.who_global_data_import VALUES (51465, '2020-09-23', 'MT', 'Malta', 'EURO', '42', '2857', '2', '25');
INSERT INTO public.who_global_data_import VALUES (51466, '2020-09-24', 'MT', 'Malta', 'EURO', '42', '2899', '1', '26');
INSERT INTO public.who_global_data_import VALUES (51467, '2020-09-25', 'MT', 'Malta', 'EURO', '31', '2930', '2', '28');
INSERT INTO public.who_global_data_import VALUES (51468, '2020-09-26', 'MT', 'Malta', 'EURO', '29', '2959', '2', '30');
INSERT INTO public.who_global_data_import VALUES (51469, '2020-09-27', 'MT', 'Malta', 'EURO', '21', '2980', '1', '31');
INSERT INTO public.who_global_data_import VALUES (51470, '2020-09-28', 'MT', 'Malta', 'EURO', '27', '3007', '1', '32');
INSERT INTO public.who_global_data_import VALUES (51471, '2020-09-29', 'MT', 'Malta', 'EURO', '19', '3026', '2', '34');
INSERT INTO public.who_global_data_import VALUES (51472, '2020-09-30', 'MT', 'Malta', 'EURO', '23', '3049', '0', '34');
INSERT INTO public.who_global_data_import VALUES (51473, '2020-10-01', 'MT', 'Malta', 'EURO', '37', '3086', '1', '35');
INSERT INTO public.who_global_data_import VALUES (51474, '2020-10-02', 'MT', 'Malta', 'EURO', '44', '3130', '2', '37');
INSERT INTO public.who_global_data_import VALUES (51475, '2020-10-03', 'MT', 'Malta', 'EURO', '65', '3195', '1', '38');
INSERT INTO public.who_global_data_import VALUES (51476, '2020-10-04', 'MT', 'Malta', 'EURO', '66', '3261', '1', '39');
INSERT INTO public.who_global_data_import VALUES (51477, '2020-10-05', 'MT', 'Malta', 'EURO', '57', '3318', '0', '39');
INSERT INTO public.who_global_data_import VALUES (51478, '2020-10-06', 'MT', 'Malta', 'EURO', '47', '3365', '1', '40');
INSERT INTO public.who_global_data_import VALUES (51479, '2020-10-07', 'MT', 'Malta', 'EURO', '68', '3433', '1', '41');
INSERT INTO public.who_global_data_import VALUES (51480, '2020-10-08', 'MT', 'Malta', 'EURO', '64', '3497', '0', '41');
INSERT INTO public.who_global_data_import VALUES (51481, '2020-10-09', 'MT', 'Malta', 'EURO', '75', '3572', '0', '41');
INSERT INTO public.who_global_data_import VALUES (51482, '2020-10-10', 'MT', 'Malta', 'EURO', '100', '3672', '0', '41');
INSERT INTO public.who_global_data_import VALUES (51483, '2020-10-11', 'MT', 'Malta', 'EURO', '95', '3767', '0', '41');
INSERT INTO public.who_global_data_import VALUES (51484, '2020-10-12', 'MT', 'Malta', 'EURO', '68', '3835', '2', '43');
INSERT INTO public.who_global_data_import VALUES (51485, '2020-10-13', 'MT', 'Malta', 'EURO', '94', '3929', '1', '44');
INSERT INTO public.who_global_data_import VALUES (51486, '2020-10-14', 'MT', 'Malta', 'EURO', '111', '4040', '0', '44');
INSERT INTO public.who_global_data_import VALUES (51487, '2020-10-15', 'MT', 'Malta', 'EURO', '112', '4152', '1', '45');
INSERT INTO public.who_global_data_import VALUES (51488, '2020-10-16', 'MT', 'Malta', 'EURO', '122', '4274', '0', '45');
INSERT INTO public.who_global_data_import VALUES (51489, '2020-10-17', 'MT', 'Malta', 'EURO', '204', '4478', '0', '45');
INSERT INTO public.who_global_data_import VALUES (51490, '2020-10-18', 'MT', 'Malta', 'EURO', '142', '4620', '0', '45');
INSERT INTO public.who_global_data_import VALUES (51491, '2020-10-19', 'MT', 'Malta', 'EURO', '109', '4729', '0', '45');
INSERT INTO public.who_global_data_import VALUES (51492, '2020-10-20', 'MT', 'Malta', 'EURO', '134', '4863', '0', '45');
INSERT INTO public.who_global_data_import VALUES (51493, '2020-10-21', 'MT', 'Malta', 'EURO', '155', '5018', '1', '46');
INSERT INTO public.who_global_data_import VALUES (51494, '2020-10-22', 'MT', 'Malta', 'EURO', '111', '5129', '3', '49');
INSERT INTO public.who_global_data_import VALUES (51495, '2020-10-23', 'MT', 'Malta', 'EURO', '121', '5250', '0', '49');
INSERT INTO public.who_global_data_import VALUES (51496, '2020-10-24', 'MT', 'Malta', 'EURO', '115', '5365', '1', '50');
INSERT INTO public.who_global_data_import VALUES (51497, '2020-10-25', 'MT', 'Malta', 'EURO', '122', '5487', '1', '51');
INSERT INTO public.who_global_data_import VALUES (51498, '2020-10-26', 'MT', 'Malta', 'EURO', '80', '5567', '2', '53');
INSERT INTO public.who_global_data_import VALUES (51499, '2020-10-27', 'MT', 'Malta', 'EURO', '107', '5674', '1', '54');
INSERT INTO public.who_global_data_import VALUES (51500, '2020-10-28', 'MT', 'Malta', 'EURO', '76', '5750', '2', '56');
INSERT INTO public.who_global_data_import VALUES (51501, '2020-10-29', 'MT', 'Malta', 'EURO', '106', '5856', '0', '56');
INSERT INTO public.who_global_data_import VALUES (51502, '2020-10-30', 'MT', 'Malta', 'EURO', '76', '5932', '1', '57');
INSERT INTO public.who_global_data_import VALUES (51503, '2020-10-31', 'MT', 'Malta', 'EURO', '100', '6032', '2', '59');
INSERT INTO public.who_global_data_import VALUES (51504, '2020-11-01', 'MT', 'Malta', 'EURO', '140', '6172', '2', '61');
INSERT INTO public.who_global_data_import VALUES (51505, '2020-11-02', 'MT', 'Malta', 'EURO', '218', '6390', '0', '61');
INSERT INTO public.who_global_data_import VALUES (51506, '2020-11-03', 'MT', 'Malta', 'EURO', '106', '6496', '1', '62');
INSERT INTO public.who_global_data_import VALUES (51507, '2020-11-04', 'MT', 'Malta', 'EURO', '84', '6580', '0', '62');
INSERT INTO public.who_global_data_import VALUES (51508, '2020-11-05', 'MT', 'Malta', 'EURO', '173', '6753', '4', '66');
INSERT INTO public.who_global_data_import VALUES (51509, '2020-11-06', 'MT', 'Malta', 'EURO', '129', '6882', '4', '70');
INSERT INTO public.who_global_data_import VALUES (51510, '2020-11-07', 'MT', 'Malta', 'EURO', '146', '7028', '0', '70');
INSERT INTO public.who_global_data_import VALUES (51511, '2020-11-08', 'MT', 'Malta', 'EURO', '102', '7130', '2', '72');
INSERT INTO public.who_global_data_import VALUES (51512, '2020-11-09', 'MT', 'Malta', 'EURO', '102', '7232', '3', '75');
INSERT INTO public.who_global_data_import VALUES (51513, '2020-11-10', 'MT', 'Malta', 'EURO', '153', '7385', '4', '79');
INSERT INTO public.who_global_data_import VALUES (51514, '2020-11-11', 'MT', 'Malta', 'EURO', '141', '7526', '3', '82');
INSERT INTO public.who_global_data_import VALUES (51515, '2020-11-12', 'MT', 'Malta', 'EURO', '109', '7635', '4', '86');
INSERT INTO public.who_global_data_import VALUES (51516, '2020-11-13', 'MT', 'Malta', 'EURO', '150', '7785', '1', '87');
INSERT INTO public.who_global_data_import VALUES (51517, '2020-11-14', 'MT', 'Malta', 'EURO', '121', '7906', '4', '91');
INSERT INTO public.who_global_data_import VALUES (51518, '2020-11-15', 'MT', 'Malta', 'EURO', '117', '8023', '3', '94');
INSERT INTO public.who_global_data_import VALUES (51519, '2020-11-16', 'MT', 'Malta', 'EURO', '103', '8126', '1', '95');
INSERT INTO public.who_global_data_import VALUES (51520, '2020-11-17', 'MT', 'Malta', 'EURO', '110', '8236', '3', '98');
INSERT INTO public.who_global_data_import VALUES (51521, '2020-11-18', 'MT', 'Malta', 'EURO', '173', '8409', '1', '99');
INSERT INTO public.who_global_data_import VALUES (51522, '2020-11-19', 'MT', 'Malta', 'EURO', '140', '8549', '2', '101');
INSERT INTO public.who_global_data_import VALUES (51523, '2020-11-20', 'MT', 'Malta', 'EURO', '121', '8670', '2', '103');
INSERT INTO public.who_global_data_import VALUES (53237, '2020-02-08', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51524, '2020-11-21', 'MT', 'Malta', 'EURO', '141', '8811', '2', '105');
INSERT INTO public.who_global_data_import VALUES (51525, '2020-11-22', 'MT', 'Malta', 'EURO', '102', '8913', '2', '107');
INSERT INTO public.who_global_data_import VALUES (51526, '2020-11-23', 'MT', 'Malta', 'EURO', '80', '8993', '3', '110');
INSERT INTO public.who_global_data_import VALUES (51527, '2020-11-24', 'MT', 'Malta', 'EURO', '133', '9126', '4', '114');
INSERT INTO public.who_global_data_import VALUES (51528, '2020-11-25', 'MT', 'Malta', 'EURO', '166', '9292', '3', '117');
INSERT INTO public.who_global_data_import VALUES (51529, '2020-11-26', 'MT', 'Malta', 'EURO', '69', '9361', '5', '122');
INSERT INTO public.who_global_data_import VALUES (51530, '2020-11-27', 'MT', 'Malta', 'EURO', '70', '9431', '0', '122');
INSERT INTO public.who_global_data_import VALUES (51531, '2020-11-28', 'MT', 'Malta', 'EURO', '70', '9501', '6', '128');
INSERT INTO public.who_global_data_import VALUES (51532, '2020-11-29', 'MT', 'Malta', 'EURO', '108', '9609', '4', '132');
INSERT INTO public.who_global_data_import VALUES (51533, '2020-11-30', 'MT', 'Malta', 'EURO', '143', '9752', '1', '133');
INSERT INTO public.who_global_data_import VALUES (51534, '2020-12-01', 'MT', 'Malta', 'EURO', '121', '9873', '4', '137');
INSERT INTO public.who_global_data_import VALUES (51535, '2020-12-02', 'MT', 'Malta', 'EURO', '102', '9975', '4', '141');
INSERT INTO public.who_global_data_import VALUES (51536, '2020-12-03', 'MT', 'Malta', 'EURO', '126', '10101', '5', '146');
INSERT INTO public.who_global_data_import VALUES (51537, '2020-12-04', 'MT', 'Malta', 'EURO', '96', '10197', '2', '148');
INSERT INTO public.who_global_data_import VALUES (51538, '2020-12-05', 'MT', 'Malta', 'EURO', '123', '10320', '1', '149');
INSERT INTO public.who_global_data_import VALUES (51539, '2020-12-06', 'MT', 'Malta', 'EURO', '103', '10423', '0', '149');
INSERT INTO public.who_global_data_import VALUES (51540, '2020-12-07', 'MT', 'Malta', 'EURO', '97', '10520', '2', '151');
INSERT INTO public.who_global_data_import VALUES (51541, '2020-12-08', 'MT', 'Malta', 'EURO', '139', '10659', '4', '155');
INSERT INTO public.who_global_data_import VALUES (51542, '2020-12-09', 'MT', 'Malta', 'EURO', '40', '10699', '2', '157');
INSERT INTO public.who_global_data_import VALUES (51543, '2020-12-10', 'MT', 'Malta', 'EURO', '79', '10778', '3', '160');
INSERT INTO public.who_global_data_import VALUES (51544, '2020-12-11', 'MT', 'Malta', 'EURO', '106', '10884', '4', '164');
INSERT INTO public.who_global_data_import VALUES (51545, '2020-12-12', 'MT', 'Malta', 'EURO', '96', '10980', '2', '166');
INSERT INTO public.who_global_data_import VALUES (51546, '2020-12-13', 'MT', 'Malta', 'EURO', '121', '11101', '0', '166');
INSERT INTO public.who_global_data_import VALUES (51547, '2020-12-14', 'MT', 'Malta', 'EURO', '52', '11153', '3', '169');
INSERT INTO public.who_global_data_import VALUES (51548, '2020-12-15', 'MT', 'Malta', 'EURO', '101', '11254', '5', '174');
INSERT INTO public.who_global_data_import VALUES (51549, '2020-12-16', 'MT', 'Malta', 'EURO', '49', '11303', '3', '177');
INSERT INTO public.who_global_data_import VALUES (51550, '2020-12-17', 'MT', 'Malta', 'EURO', '112', '11415', '3', '180');
INSERT INTO public.who_global_data_import VALUES (51551, '2020-12-18', 'MT', 'Malta', 'EURO', '60', '11475', '2', '182');
INSERT INTO public.who_global_data_import VALUES (51552, '2020-12-19', 'MT', 'Malta', 'EURO', '94', '11569', '1', '183');
INSERT INTO public.who_global_data_import VALUES (51553, '2020-12-20', 'MT', 'Malta', 'EURO', '52', '11621', '4', '187');
INSERT INTO public.who_global_data_import VALUES (51554, '2020-12-21', 'MT', 'Malta', 'EURO', '93', '11714', '3', '190');
INSERT INTO public.who_global_data_import VALUES (51555, '2020-12-22', 'MT', 'Malta', 'EURO', '88', '11802', '0', '190');
INSERT INTO public.who_global_data_import VALUES (51556, '2020-12-23', 'MT', 'Malta', 'EURO', '108', '11910', '6', '196');
INSERT INTO public.who_global_data_import VALUES (51557, '2020-12-24', 'MT', 'Malta', 'EURO', '82', '11992', '5', '201');
INSERT INTO public.who_global_data_import VALUES (51558, '2020-12-25', 'MT', 'Malta', 'EURO', '70', '12062', '2', '203');
INSERT INTO public.who_global_data_import VALUES (51559, '2020-12-26', 'MT', 'Malta', 'EURO', '50', '12112', '0', '203');
INSERT INTO public.who_global_data_import VALUES (51560, '2020-12-27', 'MT', 'Malta', 'EURO', '129', '12241', '3', '206');
INSERT INTO public.who_global_data_import VALUES (51561, '2020-12-28', 'MT', 'Malta', 'EURO', '84', '12325', '4', '210');
INSERT INTO public.who_global_data_import VALUES (51562, '2020-12-29', 'MT', 'Malta', 'EURO', '101', '12426', '5', '215');
INSERT INTO public.who_global_data_import VALUES (51563, '2020-12-30', 'MT', 'Malta', 'EURO', '115', '12541', '0', '215');
INSERT INTO public.who_global_data_import VALUES (51564, '2020-12-31', 'MT', 'Malta', 'EURO', '124', '12665', '0', '215');
INSERT INTO public.who_global_data_import VALUES (51565, '2021-01-01', 'MT', 'Malta', 'EURO', '109', '12774', '4', '219');
INSERT INTO public.who_global_data_import VALUES (51566, '2021-01-02', 'MT', 'Malta', 'EURO', '135', '12909', '0', '219');
INSERT INTO public.who_global_data_import VALUES (51567, '2021-01-03', 'MT', 'Malta', 'EURO', '88', '12997', '1', '220');
INSERT INTO public.who_global_data_import VALUES (51568, '2021-01-04', 'MT', 'Malta', 'EURO', '233', '13230', '2', '222');
INSERT INTO public.who_global_data_import VALUES (51569, '2021-01-05', 'MT', 'Malta', 'EURO', '158', '13388', '4', '226');
INSERT INTO public.who_global_data_import VALUES (51570, '2021-01-06', 'MT', 'Malta', 'EURO', '224', '13612', '1', '227');
INSERT INTO public.who_global_data_import VALUES (51571, '2021-01-07', 'MT', 'Malta', 'EURO', '164', '13776', '1', '228');
INSERT INTO public.who_global_data_import VALUES (51572, '2021-01-08', 'MT', 'Malta', 'EURO', '191', '13967', '2', '230');
INSERT INTO public.who_global_data_import VALUES (51573, '2021-01-09', 'MT', 'Malta', 'EURO', '245', '14212', '2', '232');
INSERT INTO public.who_global_data_import VALUES (51574, '2021-01-10', 'MT', 'Malta', 'EURO', '184', '14396', '1', '233');
INSERT INTO public.who_global_data_import VALUES (51575, '2021-01-11', 'MT', 'Malta', 'EURO', '133', '14529', '0', '233');
INSERT INTO public.who_global_data_import VALUES (51576, '2021-01-12', 'MT', 'Malta', 'EURO', '240', '14769', '1', '234');
INSERT INTO public.who_global_data_import VALUES (51577, '2021-01-13', 'MT', 'Malta', 'EURO', '189', '14958', '0', '234');
INSERT INTO public.who_global_data_import VALUES (51578, '2021-01-14', 'MT', 'Malta', 'EURO', '121', '15079', '1', '235');
INSERT INTO public.who_global_data_import VALUES (51579, '2021-01-15', 'MT', 'Malta', 'EURO', '193', '15272', '1', '236');
INSERT INTO public.who_global_data_import VALUES (51580, '2021-01-16', 'MT', 'Malta', 'EURO', '175', '15447', '2', '238');
INSERT INTO public.who_global_data_import VALUES (51581, '2021-01-17', 'MT', 'Malta', 'EURO', '141', '15588', '1', '239');
INSERT INTO public.who_global_data_import VALUES (51582, '2021-01-18', 'MT', 'Malta', 'EURO', '154', '15742', '2', '241');
INSERT INTO public.who_global_data_import VALUES (51583, '2021-01-19', 'MT', 'Malta', 'EURO', '200', '15942', '1', '242');
INSERT INTO public.who_global_data_import VALUES (51584, '2021-01-20', 'MT', 'Malta', 'EURO', '187', '16129', '2', '244');
INSERT INTO public.who_global_data_import VALUES (51585, '2021-01-21', 'MT', 'Malta', 'EURO', '151', '16280', '1', '245');
INSERT INTO public.who_global_data_import VALUES (51586, '2021-01-22', 'MT', 'Malta', 'EURO', '143', '16423', '3', '248');
INSERT INTO public.who_global_data_import VALUES (51587, '2021-01-23', 'MT', 'Malta', 'EURO', '119', '16542', '2', '250');
INSERT INTO public.who_global_data_import VALUES (51588, '2021-01-24', 'MT', 'Malta', 'EURO', '116', '16658', '1', '251');
INSERT INTO public.who_global_data_import VALUES (51589, '2021-01-25', 'MT', 'Malta', 'EURO', '203', '16861', '2', '253');
INSERT INTO public.who_global_data_import VALUES (51590, '2021-01-26', 'MT', 'Malta', 'EURO', '138', '16999', '2', '255');
INSERT INTO public.who_global_data_import VALUES (51591, '2021-01-27', 'MT', 'Malta', 'EURO', '193', '17192', '3', '258');
INSERT INTO public.who_global_data_import VALUES (51592, '2021-01-28', 'MT', 'Malta', 'EURO', '208', '17400', '3', '261');
INSERT INTO public.who_global_data_import VALUES (51593, '2021-01-29', 'MT', 'Malta', 'EURO', '185', '17585', '3', '264');
INSERT INTO public.who_global_data_import VALUES (51594, '2021-01-30', 'MT', 'Malta', 'EURO', '136', '17721', '1', '265');
INSERT INTO public.who_global_data_import VALUES (51595, '2021-01-31', 'MT', 'Malta', 'EURO', '182', '17903', '2', '267');
INSERT INTO public.who_global_data_import VALUES (51596, '2021-02-01', 'MT', 'Malta', 'EURO', '124', '18027', '2', '269');
INSERT INTO public.who_global_data_import VALUES (51597, '2021-02-02', 'MT', 'Malta', 'EURO', '141', '18168', '1', '270');
INSERT INTO public.who_global_data_import VALUES (51598, '2021-02-03', 'MT', 'Malta', 'EURO', '138', '18306', '3', '273');
INSERT INTO public.who_global_data_import VALUES (51599, '2021-02-04', 'MT', 'Malta', 'EURO', '79', '18385', '0', '273');
INSERT INTO public.who_global_data_import VALUES (51600, '2021-02-05', 'MT', 'Malta', 'EURO', '57', '18442', '4', '277');
INSERT INTO public.who_global_data_import VALUES (51601, '2020-01-03', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51602, '2020-01-04', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51603, '2020-01-05', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51604, '2020-01-06', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51605, '2020-01-07', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51606, '2020-01-08', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51607, '2020-01-09', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51608, '2020-01-10', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51609, '2020-01-11', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51610, '2020-01-12', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51611, '2020-01-13', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51612, '2020-01-14', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51613, '2020-01-15', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51614, '2020-01-16', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51615, '2020-01-17', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51616, '2020-01-18', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51617, '2020-01-19', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51618, '2020-01-20', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51619, '2020-01-21', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51620, '2020-01-22', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51621, '2020-01-23', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51622, '2020-01-24', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51623, '2020-01-25', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51624, '2020-01-26', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51625, '2020-01-27', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51626, '2020-01-28', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51627, '2020-01-29', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51628, '2020-01-30', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51629, '2020-01-31', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51630, '2020-02-01', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51631, '2020-02-02', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51632, '2020-02-03', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51633, '2020-02-04', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51634, '2020-02-05', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51635, '2020-02-06', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51636, '2020-02-07', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51637, '2020-02-08', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51638, '2020-02-09', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51639, '2020-02-10', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51640, '2020-02-11', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51641, '2020-02-12', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51642, '2020-02-13', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51643, '2020-02-14', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51644, '2020-02-15', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51645, '2020-02-16', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51646, '2020-02-17', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51647, '2020-02-18', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51648, '2020-02-19', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51649, '2020-02-20', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51650, '2020-02-21', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51651, '2020-02-22', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51652, '2020-02-23', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51653, '2020-02-24', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51654, '2020-02-25', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51655, '2020-02-26', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51656, '2020-02-27', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51657, '2020-02-28', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51658, '2020-02-29', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51659, '2020-03-01', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51660, '2020-03-02', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51661, '2020-03-03', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51662, '2020-03-04', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51663, '2020-03-05', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51664, '2020-03-06', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51665, '2020-03-07', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51666, '2020-03-08', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51667, '2020-03-09', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51668, '2020-03-10', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51669, '2020-03-11', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51670, '2020-03-12', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51671, '2020-03-13', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51672, '2020-03-14', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51673, '2020-03-15', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51674, '2020-03-16', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51675, '2020-03-17', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51676, '2020-03-18', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51677, '2020-03-19', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51678, '2020-03-20', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51679, '2020-03-21', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51680, '2020-03-22', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51681, '2020-03-23', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51682, '2020-03-24', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51683, '2020-03-25', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51684, '2020-03-26', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51685, '2020-03-27', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51686, '2020-03-28', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51687, '2020-03-29', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51688, '2020-03-30', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51689, '2020-03-31', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51690, '2020-04-01', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51691, '2020-04-02', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51692, '2020-04-03', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51693, '2020-04-04', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51694, '2020-04-05', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51695, '2020-04-06', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51696, '2020-04-07', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51697, '2020-04-08', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51698, '2020-04-09', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51699, '2020-04-10', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51700, '2020-04-11', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51701, '2020-04-12', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51702, '2020-04-13', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51703, '2020-04-14', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51704, '2020-04-15', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51705, '2020-04-16', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51706, '2020-04-17', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51707, '2020-04-18', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51708, '2020-04-19', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51709, '2020-04-20', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51710, '2020-04-21', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51711, '2020-04-22', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51712, '2020-04-23', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51713, '2020-04-24', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51714, '2020-04-25', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51715, '2020-04-26', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51716, '2020-04-27', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51717, '2020-04-28', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51718, '2020-04-29', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51719, '2020-04-30', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51720, '2020-05-01', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51721, '2020-05-02', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51722, '2020-05-03', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51723, '2020-05-04', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51724, '2020-05-05', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51725, '2020-05-06', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51726, '2020-05-07', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51727, '2020-05-08', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51728, '2020-05-09', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51729, '2020-05-10', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51730, '2020-05-11', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51731, '2020-05-12', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51732, '2020-05-13', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51733, '2020-05-14', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51734, '2020-05-15', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51735, '2020-05-16', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51736, '2020-05-17', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51737, '2020-05-18', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51738, '2020-05-19', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51739, '2020-05-20', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51740, '2020-05-21', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51741, '2020-05-22', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51742, '2020-05-23', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51743, '2020-05-24', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51744, '2020-05-25', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51745, '2020-05-26', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51746, '2020-05-27', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51747, '2020-05-28', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51748, '2020-05-29', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51749, '2020-05-30', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51750, '2020-05-31', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51751, '2020-06-01', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51752, '2020-06-02', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51753, '2020-06-03', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51754, '2020-06-04', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51755, '2020-06-05', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51756, '2020-06-06', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51757, '2020-06-07', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51758, '2020-06-08', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51759, '2020-06-09', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51760, '2020-06-10', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51761, '2020-06-11', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51762, '2020-06-12', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51763, '2020-06-13', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51764, '2020-06-14', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51765, '2020-06-15', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51766, '2020-06-16', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51767, '2020-06-17', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51768, '2020-06-18', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51769, '2020-06-19', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51770, '2020-06-20', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51771, '2020-06-21', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51772, '2020-06-22', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51773, '2020-06-23', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51774, '2020-06-24', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51775, '2020-06-25', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51776, '2020-06-26', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51777, '2020-06-27', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51778, '2020-06-28', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51779, '2020-06-29', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51780, '2020-06-30', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51781, '2020-07-01', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51782, '2020-07-02', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51783, '2020-07-03', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51784, '2020-07-04', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51785, '2020-07-05', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51786, '2020-07-06', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51787, '2020-07-07', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51788, '2020-07-08', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51789, '2020-07-09', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51790, '2020-07-10', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51791, '2020-07-11', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51792, '2020-07-12', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51793, '2020-07-13', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51794, '2020-07-14', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51795, '2020-07-15', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51796, '2020-07-16', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51797, '2020-07-17', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51798, '2020-07-18', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51799, '2020-07-19', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51800, '2020-07-20', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51801, '2020-07-21', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51802, '2020-07-22', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51803, '2020-07-23', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51804, '2020-07-24', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51805, '2020-07-25', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51806, '2020-07-26', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51807, '2020-07-27', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51808, '2020-07-28', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51809, '2020-07-29', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51810, '2020-07-30', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51811, '2020-07-31', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51812, '2020-08-01', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51813, '2020-08-02', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51814, '2020-08-03', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51815, '2020-08-04', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51816, '2020-08-05', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51817, '2020-08-06', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51818, '2020-08-07', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51819, '2020-08-08', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51820, '2020-08-09', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51821, '2020-08-10', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51822, '2020-08-11', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51823, '2020-08-12', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51824, '2020-08-13', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51825, '2020-08-14', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51826, '2020-08-15', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51827, '2020-08-16', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51828, '2020-08-17', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51829, '2020-08-18', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51830, '2020-08-19', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51831, '2020-08-20', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51832, '2020-08-21', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51833, '2020-08-22', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51834, '2020-08-23', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51835, '2020-08-24', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51836, '2020-08-25', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51837, '2020-08-26', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51838, '2020-08-27', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51839, '2020-08-28', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51840, '2020-08-29', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51841, '2020-08-30', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51842, '2020-08-31', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51843, '2020-09-01', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51844, '2020-09-02', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51845, '2020-09-03', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51846, '2020-09-04', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51847, '2020-09-05', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51848, '2020-09-06', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51849, '2020-09-07', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51850, '2020-09-08', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51851, '2020-09-09', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51852, '2020-09-10', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51853, '2020-09-11', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51854, '2020-09-12', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51855, '2020-09-13', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51856, '2020-09-14', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51857, '2020-09-15', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51858, '2020-09-16', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51859, '2020-09-17', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51860, '2020-09-18', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51861, '2020-09-19', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51862, '2020-09-20', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51863, '2020-09-21', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51864, '2020-09-22', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51865, '2020-09-23', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51866, '2020-09-24', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51867, '2020-09-25', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51868, '2020-09-26', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51869, '2020-09-27', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51870, '2020-09-28', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51871, '2020-09-29', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51872, '2020-09-30', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51873, '2020-10-01', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51874, '2020-10-02', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51875, '2020-10-03', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51876, '2020-10-04', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51877, '2020-10-05', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51878, '2020-10-06', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51879, '2020-10-07', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51880, '2020-10-08', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51881, '2020-10-09', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51882, '2020-10-10', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51883, '2020-10-11', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51884, '2020-10-12', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51885, '2020-10-13', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51886, '2020-10-14', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51887, '2020-10-15', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51888, '2020-10-16', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51889, '2020-10-17', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51890, '2020-10-18', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51891, '2020-10-19', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51892, '2020-10-20', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51893, '2020-10-21', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51894, '2020-10-22', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51895, '2020-10-23', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51896, '2020-10-24', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51897, '2020-10-25', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51898, '2020-10-26', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51899, '2020-10-27', 'MH', 'Marshall Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51900, '2020-10-28', 'MH', 'Marshall Islands', 'WPRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51901, '2020-10-29', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51902, '2020-10-30', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51903, '2020-10-31', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51904, '2020-11-01', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51905, '2020-11-02', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51906, '2020-11-03', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51907, '2020-11-04', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51908, '2020-11-05', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51909, '2020-11-06', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51910, '2020-11-07', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51911, '2020-11-08', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51912, '2020-11-09', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51913, '2020-11-10', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51914, '2020-11-11', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51915, '2020-11-12', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51916, '2020-11-13', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51917, '2020-11-14', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51918, '2020-11-15', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51919, '2020-11-16', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51920, '2020-11-17', 'MH', 'Marshall Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51921, '2020-11-18', 'MH', 'Marshall Islands', 'WPRO', '3', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51922, '2020-11-19', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51923, '2020-11-20', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51924, '2020-11-21', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51925, '2020-11-22', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51926, '2020-11-23', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51927, '2020-11-24', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51928, '2020-11-25', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51929, '2020-11-26', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51930, '2020-11-27', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51931, '2020-11-28', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51932, '2020-11-29', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51933, '2020-11-30', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51934, '2020-12-01', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51935, '2020-12-02', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51936, '2020-12-03', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51937, '2020-12-04', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51938, '2020-12-05', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51939, '2020-12-06', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51940, '2020-12-07', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51941, '2020-12-08', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51942, '2020-12-09', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51943, '2020-12-10', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51944, '2020-12-11', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51945, '2020-12-12', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51946, '2020-12-13', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51947, '2020-12-14', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51948, '2020-12-15', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51949, '2020-12-16', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51950, '2020-12-17', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51951, '2020-12-18', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51952, '2020-12-19', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51953, '2020-12-20', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51954, '2020-12-21', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51955, '2020-12-22', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51956, '2020-12-23', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51957, '2020-12-24', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51958, '2020-12-25', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51959, '2020-12-26', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51960, '2020-12-27', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51961, '2020-12-28', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51962, '2020-12-29', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51963, '2020-12-30', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51964, '2020-12-31', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51965, '2021-01-01', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51966, '2021-01-02', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51967, '2021-01-03', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51968, '2021-01-04', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51969, '2021-01-05', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51970, '2021-01-06', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51971, '2021-01-07', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51972, '2021-01-08', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51973, '2021-01-09', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51974, '2021-01-10', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51975, '2021-01-11', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51976, '2021-01-12', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51977, '2021-01-13', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51978, '2021-01-14', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51979, '2021-01-15', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51980, '2021-01-16', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51981, '2021-01-17', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51982, '2021-01-18', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51983, '2021-01-19', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51984, '2021-01-20', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51985, '2021-01-21', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51986, '2021-01-22', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51987, '2021-01-23', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51988, '2021-01-24', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51989, '2021-01-25', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51990, '2021-01-26', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51991, '2021-01-27', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51992, '2021-01-28', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51993, '2021-01-29', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51994, '2021-01-30', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51995, '2021-01-31', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51996, '2021-02-01', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51997, '2021-02-02', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51998, '2021-02-03', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (51999, '2021-02-04', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52000, '2021-02-05', 'MH', 'Marshall Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52001, '2020-01-03', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52002, '2020-01-04', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52003, '2020-01-05', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52004, '2020-01-06', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52005, '2020-01-07', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52006, '2020-01-08', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52007, '2020-01-09', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52008, '2020-01-10', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52009, '2020-01-11', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52010, '2020-01-12', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52011, '2020-01-13', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52012, '2020-01-14', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52013, '2020-01-15', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52014, '2020-01-16', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52015, '2020-01-17', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52016, '2020-01-18', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52017, '2020-01-19', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52018, '2020-01-20', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52019, '2020-01-21', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52020, '2020-01-22', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52021, '2020-01-23', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52022, '2020-01-24', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52023, '2020-01-25', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52024, '2020-01-26', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52025, '2020-01-27', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52026, '2020-01-28', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52027, '2020-01-29', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52028, '2020-01-30', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52029, '2020-01-31', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52030, '2020-02-01', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52031, '2020-02-02', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52032, '2020-02-03', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52033, '2020-02-04', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52034, '2020-02-05', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52035, '2020-02-06', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52036, '2020-02-07', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52037, '2020-02-08', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52038, '2020-02-09', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52039, '2020-02-10', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52040, '2020-02-11', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52041, '2020-02-12', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52042, '2020-02-13', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52043, '2020-02-14', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52044, '2020-02-15', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52045, '2020-02-16', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52046, '2020-02-17', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52047, '2020-02-18', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52048, '2020-02-19', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52049, '2020-02-20', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52050, '2020-02-21', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52051, '2020-02-22', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52052, '2020-02-23', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52053, '2020-02-24', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52054, '2020-02-25', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52055, '2020-02-26', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52056, '2020-02-27', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52057, '2020-02-28', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52058, '2020-02-29', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52059, '2020-03-01', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52060, '2020-03-02', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52061, '2020-03-03', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52062, '2020-03-04', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52063, '2020-03-05', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52064, '2020-03-06', 'MQ', 'Martinique', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52065, '2020-03-07', 'MQ', 'Martinique', 'AMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52066, '2020-03-08', 'MQ', 'Martinique', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52067, '2020-03-09', 'MQ', 'Martinique', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52068, '2020-03-10', 'MQ', 'Martinique', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52069, '2020-03-11', 'MQ', 'Martinique', 'AMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52070, '2020-03-12', 'MQ', 'Martinique', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52071, '2020-03-13', 'MQ', 'Martinique', 'AMRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52072, '2020-03-14', 'MQ', 'Martinique', 'AMRO', '6', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52073, '2020-03-15', 'MQ', 'Martinique', 'AMRO', '5', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52074, '2020-03-16', 'MQ', 'Martinique', 'AMRO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52075, '2020-03-17', 'MQ', 'Martinique', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52076, '2020-03-18', 'MQ', 'Martinique', 'AMRO', '7', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52077, '2020-03-19', 'MQ', 'Martinique', 'AMRO', '5', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52078, '2020-03-20', 'MQ', 'Martinique', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52079, '2020-03-21', 'MQ', 'Martinique', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52080, '2020-03-22', 'MQ', 'Martinique', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52081, '2020-03-23', 'MQ', 'Martinique', 'AMRO', '5', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52082, '2020-03-24', 'MQ', 'Martinique', 'AMRO', '20', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52083, '2020-03-25', 'MQ', 'Martinique', 'AMRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52084, '2020-03-26', 'MQ', 'Martinique', 'AMRO', '9', '66', '1', '1');
INSERT INTO public.who_global_data_import VALUES (52085, '2020-03-27', 'MQ', 'Martinique', 'AMRO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52086, '2020-03-28', 'MQ', 'Martinique', 'AMRO', '27', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52087, '2020-03-29', 'MQ', 'Martinique', 'AMRO', '0', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52088, '2020-03-30', 'MQ', 'Martinique', 'AMRO', '12', '105', '1', '2');
INSERT INTO public.who_global_data_import VALUES (52089, '2020-03-31', 'MQ', 'Martinique', 'AMRO', '6', '111', '0', '2');
INSERT INTO public.who_global_data_import VALUES (52090, '2020-04-01', 'MQ', 'Martinique', 'AMRO', '8', '119', '0', '2');
INSERT INTO public.who_global_data_import VALUES (52091, '2020-04-02', 'MQ', 'Martinique', 'AMRO', '9', '128', '1', '3');
INSERT INTO public.who_global_data_import VALUES (52092, '2020-04-03', 'MQ', 'Martinique', 'AMRO', '3', '131', '0', '3');
INSERT INTO public.who_global_data_import VALUES (52093, '2020-04-04', 'MQ', 'Martinique', 'AMRO', '7', '138', '0', '3');
INSERT INTO public.who_global_data_import VALUES (52094, '2020-04-05', 'MQ', 'Martinique', 'AMRO', '7', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (52095, '2020-04-06', 'MQ', 'Martinique', 'AMRO', '0', '145', '0', '3');
INSERT INTO public.who_global_data_import VALUES (52096, '2020-04-07', 'MQ', 'Martinique', 'AMRO', '4', '149', '1', '4');
INSERT INTO public.who_global_data_import VALUES (52097, '2020-04-08', 'MQ', 'Martinique', 'AMRO', '2', '151', '0', '4');
INSERT INTO public.who_global_data_import VALUES (52098, '2020-04-09', 'MQ', 'Martinique', 'AMRO', '1', '152', '0', '4');
INSERT INTO public.who_global_data_import VALUES (52099, '2020-04-10', 'MQ', 'Martinique', 'AMRO', '2', '154', '2', '6');
INSERT INTO public.who_global_data_import VALUES (52100, '2020-04-11', 'MQ', 'Martinique', 'AMRO', '0', '154', '0', '6');
INSERT INTO public.who_global_data_import VALUES (52101, '2020-04-12', 'MQ', 'Martinique', 'AMRO', '1', '155', '0', '6');
INSERT INTO public.who_global_data_import VALUES (52102, '2020-04-13', 'MQ', 'Martinique', 'AMRO', '1', '156', '0', '6');
INSERT INTO public.who_global_data_import VALUES (52103, '2020-04-14', 'MQ', 'Martinique', 'AMRO', '1', '157', '2', '8');
INSERT INTO public.who_global_data_import VALUES (52104, '2020-04-15', 'MQ', 'Martinique', 'AMRO', '0', '157', '0', '8');
INSERT INTO public.who_global_data_import VALUES (52105, '2020-04-16', 'MQ', 'Martinique', 'AMRO', '1', '158', '0', '8');
INSERT INTO public.who_global_data_import VALUES (52106, '2020-04-17', 'MQ', 'Martinique', 'AMRO', '1', '159', '0', '8');
INSERT INTO public.who_global_data_import VALUES (52107, '2020-04-18', 'MQ', 'Martinique', 'AMRO', '0', '159', '0', '8');
INSERT INTO public.who_global_data_import VALUES (52108, '2020-04-19', 'MQ', 'Martinique', 'AMRO', '4', '163', '4', '12');
INSERT INTO public.who_global_data_import VALUES (52109, '2020-04-20', 'MQ', 'Martinique', 'AMRO', '0', '163', '0', '12');
INSERT INTO public.who_global_data_import VALUES (52110, '2020-04-21', 'MQ', 'Martinique', 'AMRO', '0', '163', '2', '14');
INSERT INTO public.who_global_data_import VALUES (52111, '2020-04-22', 'MQ', 'Martinique', 'AMRO', '0', '163', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52112, '2020-04-23', 'MQ', 'Martinique', 'AMRO', '1', '164', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52113, '2020-04-24', 'MQ', 'Martinique', 'AMRO', '6', '170', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52114, '2020-04-25', 'MQ', 'Martinique', 'AMRO', '0', '170', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52115, '2020-04-26', 'MQ', 'Martinique', 'AMRO', '0', '170', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52116, '2020-04-27', 'MQ', 'Martinique', 'AMRO', '5', '175', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52117, '2020-04-28', 'MQ', 'Martinique', 'AMRO', '0', '175', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52118, '2020-04-29', 'MQ', 'Martinique', 'AMRO', '0', '175', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52119, '2020-04-30', 'MQ', 'Martinique', 'AMRO', '0', '175', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52120, '2020-05-01', 'MQ', 'Martinique', 'AMRO', '3', '178', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52121, '2020-05-02', 'MQ', 'Martinique', 'AMRO', '1', '179', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52122, '2020-05-03', 'MQ', 'Martinique', 'AMRO', '1', '180', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52123, '2020-05-04', 'MQ', 'Martinique', 'AMRO', '1', '181', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52124, '2020-05-05', 'MQ', 'Martinique', 'AMRO', '0', '181', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52125, '2020-05-06', 'MQ', 'Martinique', 'AMRO', '0', '181', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52126, '2020-05-07', 'MQ', 'Martinique', 'AMRO', '1', '182', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52127, '2020-05-08', 'MQ', 'Martinique', 'AMRO', '0', '182', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52128, '2020-05-09', 'MQ', 'Martinique', 'AMRO', '1', '183', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52129, '2020-05-10', 'MQ', 'Martinique', 'AMRO', '3', '186', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52130, '2020-05-11', 'MQ', 'Martinique', 'AMRO', '1', '187', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52131, '2020-05-12', 'MQ', 'Martinique', 'AMRO', '0', '187', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52132, '2020-05-13', 'MQ', 'Martinique', 'AMRO', '0', '187', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52133, '2020-05-14', 'MQ', 'Martinique', 'AMRO', '2', '189', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52134, '2020-05-15', 'MQ', 'Martinique', 'AMRO', '0', '189', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52135, '2020-05-16', 'MQ', 'Martinique', 'AMRO', '0', '189', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52136, '2020-05-17', 'MQ', 'Martinique', 'AMRO', '3', '192', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52137, '2020-05-18', 'MQ', 'Martinique', 'AMRO', '0', '192', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52138, '2020-05-19', 'MQ', 'Martinique', 'AMRO', '0', '192', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52139, '2020-05-20', 'MQ', 'Martinique', 'AMRO', '0', '192', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52140, '2020-05-21', 'MQ', 'Martinique', 'AMRO', '0', '192', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52141, '2020-05-22', 'MQ', 'Martinique', 'AMRO', '0', '192', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52142, '2020-05-23', 'MQ', 'Martinique', 'AMRO', '5', '197', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52143, '2020-05-24', 'MQ', 'Martinique', 'AMRO', '0', '197', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52144, '2020-05-25', 'MQ', 'Martinique', 'AMRO', '0', '197', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52145, '2020-05-26', 'MQ', 'Martinique', 'AMRO', '0', '197', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52146, '2020-05-27', 'MQ', 'Martinique', 'AMRO', '0', '197', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52147, '2020-05-28', 'MQ', 'Martinique', 'AMRO', '0', '197', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52148, '2020-05-29', 'MQ', 'Martinique', 'AMRO', '0', '197', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52149, '2020-05-30', 'MQ', 'Martinique', 'AMRO', '0', '197', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52150, '2020-05-31', 'MQ', 'Martinique', 'AMRO', '3', '200', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52151, '2020-06-01', 'MQ', 'Martinique', 'AMRO', '0', '200', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52152, '2020-06-02', 'MQ', 'Martinique', 'AMRO', '0', '200', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52153, '2020-06-03', 'MQ', 'Martinique', 'AMRO', '0', '200', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52154, '2020-06-04', 'MQ', 'Martinique', 'AMRO', '0', '200', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52155, '2020-06-05', 'MQ', 'Martinique', 'AMRO', '0', '200', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52156, '2020-06-06', 'MQ', 'Martinique', 'AMRO', '0', '200', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52157, '2020-06-07', 'MQ', 'Martinique', 'AMRO', '2', '202', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52158, '2020-06-08', 'MQ', 'Martinique', 'AMRO', '0', '202', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52159, '2020-06-09', 'MQ', 'Martinique', 'AMRO', '0', '202', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52160, '2020-06-10', 'MQ', 'Martinique', 'AMRO', '0', '202', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52161, '2020-06-11', 'MQ', 'Martinique', 'AMRO', '0', '202', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52162, '2020-06-12', 'MQ', 'Martinique', 'AMRO', '0', '202', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52163, '2020-06-13', 'MQ', 'Martinique', 'AMRO', '0', '202', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52164, '2020-06-14', 'MQ', 'Martinique', 'AMRO', '0', '202', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52165, '2020-06-15', 'MQ', 'Martinique', 'AMRO', '0', '202', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52166, '2020-06-16', 'MQ', 'Martinique', 'AMRO', '0', '202', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52167, '2020-06-17', 'MQ', 'Martinique', 'AMRO', '0', '202', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52168, '2020-06-18', 'MQ', 'Martinique', 'AMRO', '0', '202', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52169, '2020-06-19', 'MQ', 'Martinique', 'AMRO', '19', '221', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52170, '2020-06-20', 'MQ', 'Martinique', 'AMRO', '0', '221', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52171, '2020-06-21', 'MQ', 'Martinique', 'AMRO', '15', '236', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52172, '2020-06-22', 'MQ', 'Martinique', 'AMRO', '0', '236', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52173, '2020-06-23', 'MQ', 'Martinique', 'AMRO', '0', '236', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52174, '2020-06-24', 'MQ', 'Martinique', 'AMRO', '0', '236', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52175, '2020-06-25', 'MQ', 'Martinique', 'AMRO', '0', '236', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52176, '2020-06-26', 'MQ', 'Martinique', 'AMRO', '0', '236', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52177, '2020-06-27', 'MQ', 'Martinique', 'AMRO', '0', '236', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52178, '2020-06-28', 'MQ', 'Martinique', 'AMRO', '6', '242', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52179, '2020-06-29', 'MQ', 'Martinique', 'AMRO', '0', '242', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52180, '2020-06-30', 'MQ', 'Martinique', 'AMRO', '0', '242', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52181, '2020-07-01', 'MQ', 'Martinique', 'AMRO', '0', '242', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52182, '2020-07-02', 'MQ', 'Martinique', 'AMRO', '0', '242', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52183, '2020-07-03', 'MQ', 'Martinique', 'AMRO', '0', '242', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52184, '2020-07-04', 'MQ', 'Martinique', 'AMRO', '0', '242', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52185, '2020-07-05', 'MQ', 'Martinique', 'AMRO', '7', '249', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52186, '2020-07-06', 'MQ', 'Martinique', 'AMRO', '0', '249', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52187, '2020-07-07', 'MQ', 'Martinique', 'AMRO', '0', '249', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52188, '2020-07-08', 'MQ', 'Martinique', 'AMRO', '0', '249', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52189, '2020-07-09', 'MQ', 'Martinique', 'AMRO', '0', '249', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52190, '2020-07-10', 'MQ', 'Martinique', 'AMRO', '0', '249', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52191, '2020-07-11', 'MQ', 'Martinique', 'AMRO', '0', '249', '0', '14');
INSERT INTO public.who_global_data_import VALUES (52192, '2020-07-12', 'MQ', 'Martinique', 'AMRO', '6', '255', '1', '15');
INSERT INTO public.who_global_data_import VALUES (52193, '2020-07-13', 'MQ', 'Martinique', 'AMRO', '0', '255', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52194, '2020-07-14', 'MQ', 'Martinique', 'AMRO', '0', '255', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52195, '2020-07-15', 'MQ', 'Martinique', 'AMRO', '0', '255', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52196, '2020-07-16', 'MQ', 'Martinique', 'AMRO', '0', '255', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52197, '2020-07-17', 'MQ', 'Martinique', 'AMRO', '0', '255', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52198, '2020-07-18', 'MQ', 'Martinique', 'AMRO', '6', '261', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52199, '2020-07-19', 'MQ', 'Martinique', 'AMRO', '1', '262', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52200, '2020-07-20', 'MQ', 'Martinique', 'AMRO', '0', '262', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52201, '2020-07-21', 'MQ', 'Martinique', 'AMRO', '0', '262', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52202, '2020-07-22', 'MQ', 'Martinique', 'AMRO', '0', '262', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52203, '2020-07-23', 'MQ', 'Martinique', 'AMRO', '0', '262', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52204, '2020-07-24', 'MQ', 'Martinique', 'AMRO', '0', '262', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52205, '2020-07-25', 'MQ', 'Martinique', 'AMRO', '7', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52206, '2020-07-26', 'MQ', 'Martinique', 'AMRO', '0', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52207, '2020-07-27', 'MQ', 'Martinique', 'AMRO', '0', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52208, '2020-07-28', 'MQ', 'Martinique', 'AMRO', '0', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52209, '2020-07-29', 'MQ', 'Martinique', 'AMRO', '0', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52210, '2020-07-30', 'MQ', 'Martinique', 'AMRO', '0', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52211, '2020-07-31', 'MQ', 'Martinique', 'AMRO', '0', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52212, '2020-08-01', 'MQ', 'Martinique', 'AMRO', '0', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52213, '2020-08-02', 'MQ', 'Martinique', 'AMRO', '0', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52214, '2020-08-03', 'MQ', 'Martinique', 'AMRO', '0', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52215, '2020-08-04', 'MQ', 'Martinique', 'AMRO', '0', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52216, '2020-08-05', 'MQ', 'Martinique', 'AMRO', '0', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52217, '2020-08-06', 'MQ', 'Martinique', 'AMRO', '0', '269', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52218, '2020-08-07', 'MQ', 'Martinique', 'AMRO', '7', '276', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52219, '2020-08-08', 'MQ', 'Martinique', 'AMRO', '0', '276', '0', '15');
INSERT INTO public.who_global_data_import VALUES (52220, '2020-08-09', 'MQ', 'Martinique', 'AMRO', '60', '336', '1', '16');
INSERT INTO public.who_global_data_import VALUES (52221, '2020-08-10', 'MQ', 'Martinique', 'AMRO', '0', '336', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52222, '2020-08-11', 'MQ', 'Martinique', 'AMRO', '0', '336', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52223, '2020-08-12', 'MQ', 'Martinique', 'AMRO', '0', '336', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52224, '2020-08-13', 'MQ', 'Martinique', 'AMRO', '0', '336', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52225, '2020-08-14', 'MQ', 'Martinique', 'AMRO', '0', '336', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52226, '2020-08-15', 'MQ', 'Martinique', 'AMRO', '0', '336', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52227, '2020-08-16', 'MQ', 'Martinique', 'AMRO', '0', '336', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52228, '2020-08-17', 'MQ', 'Martinique', 'AMRO', '0', '336', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52229, '2020-08-18', 'MQ', 'Martinique', 'AMRO', '14', '350', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52230, '2020-08-19', 'MQ', 'Martinique', 'AMRO', '0', '350', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52231, '2020-08-20', 'MQ', 'Martinique', 'AMRO', '0', '350', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52232, '2020-08-21', 'MQ', 'Martinique', 'AMRO', '0', '350', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52233, '2020-08-22', 'MQ', 'Martinique', 'AMRO', '0', '350', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52234, '2020-08-23', 'MQ', 'Martinique', 'AMRO', '114', '464', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52235, '2020-08-24', 'MQ', 'Martinique', 'AMRO', '0', '464', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52236, '2020-08-25', 'MQ', 'Martinique', 'AMRO', '0', '464', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52237, '2020-08-26', 'MQ', 'Martinique', 'AMRO', '0', '464', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52238, '2020-08-27', 'MQ', 'Martinique', 'AMRO', '132', '596', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52239, '2020-08-28', 'MQ', 'Martinique', 'AMRO', '0', '596', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52240, '2020-08-29', 'MQ', 'Martinique', 'AMRO', '0', '596', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52241, '2020-08-30', 'MQ', 'Martinique', 'AMRO', '0', '596', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52242, '2020-08-31', 'MQ', 'Martinique', 'AMRO', '0', '596', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52243, '2020-09-01', 'MQ', 'Martinique', 'AMRO', '0', '596', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52244, '2020-09-02', 'MQ', 'Martinique', 'AMRO', '19', '615', '0', '16');
INSERT INTO public.who_global_data_import VALUES (52245, '2020-09-03', 'MQ', 'Martinique', 'AMRO', '132', '747', '2', '18');
INSERT INTO public.who_global_data_import VALUES (52246, '2020-09-04', 'MQ', 'Martinique', 'AMRO', '7', '754', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52247, '2020-09-05', 'MQ', 'Martinique', 'AMRO', '0', '754', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52248, '2020-09-06', 'MQ', 'Martinique', 'AMRO', '4', '758', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52249, '2020-09-07', 'MQ', 'Martinique', 'AMRO', '0', '758', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52250, '2020-09-08', 'MQ', 'Martinique', 'AMRO', '0', '758', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52251, '2020-09-09', 'MQ', 'Martinique', 'AMRO', '0', '758', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52252, '2020-09-10', 'MQ', 'Martinique', 'AMRO', '181', '939', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52253, '2020-09-11', 'MQ', 'Martinique', 'AMRO', '0', '939', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52254, '2020-09-12', 'MQ', 'Martinique', 'AMRO', '0', '939', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52255, '2020-09-13', 'MQ', 'Martinique', 'AMRO', '0', '939', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52256, '2020-09-14', 'MQ', 'Martinique', 'AMRO', '0', '939', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52257, '2020-09-15', 'MQ', 'Martinique', 'AMRO', '0', '939', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52258, '2020-09-16', 'MQ', 'Martinique', 'AMRO', '0', '939', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52259, '2020-09-17', 'MQ', 'Martinique', 'AMRO', '183', '1122', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52260, '2020-09-18', 'MQ', 'Martinique', 'AMRO', '0', '1122', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52261, '2020-09-19', 'MQ', 'Martinique', 'AMRO', '0', '1122', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52262, '2020-09-20', 'MQ', 'Martinique', 'AMRO', '0', '1122', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52263, '2020-09-21', 'MQ', 'Martinique', 'AMRO', '0', '1122', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52264, '2020-09-22', 'MQ', 'Martinique', 'AMRO', '0', '1122', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52265, '2020-09-23', 'MQ', 'Martinique', 'AMRO', '0', '1122', '0', '18');
INSERT INTO public.who_global_data_import VALUES (52266, '2020-09-24', 'MQ', 'Martinique', 'AMRO', '168', '1290', '2', '20');
INSERT INTO public.who_global_data_import VALUES (52267, '2020-09-25', 'MQ', 'Martinique', 'AMRO', '0', '1290', '0', '20');
INSERT INTO public.who_global_data_import VALUES (52268, '2020-09-26', 'MQ', 'Martinique', 'AMRO', '0', '1290', '0', '20');
INSERT INTO public.who_global_data_import VALUES (52269, '2020-09-27', 'MQ', 'Martinique', 'AMRO', '8', '1298', '0', '20');
INSERT INTO public.who_global_data_import VALUES (52270, '2020-09-28', 'MQ', 'Martinique', 'AMRO', '0', '1298', '0', '20');
INSERT INTO public.who_global_data_import VALUES (52271, '2020-09-29', 'MQ', 'Martinique', 'AMRO', '0', '1298', '0', '20');
INSERT INTO public.who_global_data_import VALUES (52272, '2020-09-30', 'MQ', 'Martinique', 'AMRO', '0', '1298', '0', '20');
INSERT INTO public.who_global_data_import VALUES (52273, '2020-10-01', 'MQ', 'Martinique', 'AMRO', '245', '1543', '1', '21');
INSERT INTO public.who_global_data_import VALUES (52274, '2020-10-02', 'MQ', 'Martinique', 'AMRO', '0', '1543', '0', '21');
INSERT INTO public.who_global_data_import VALUES (52275, '2020-10-03', 'MQ', 'Martinique', 'AMRO', '0', '1543', '0', '21');
INSERT INTO public.who_global_data_import VALUES (52276, '2020-10-04', 'MQ', 'Martinique', 'AMRO', '0', '1543', '0', '21');
INSERT INTO public.who_global_data_import VALUES (52277, '2020-10-05', 'MQ', 'Martinique', 'AMRO', '0', '1543', '0', '21');
INSERT INTO public.who_global_data_import VALUES (52278, '2020-10-06', 'MQ', 'Martinique', 'AMRO', '0', '1543', '0', '21');
INSERT INTO public.who_global_data_import VALUES (52279, '2020-10-07', 'MQ', 'Martinique', 'AMRO', '0', '1543', '0', '21');
INSERT INTO public.who_global_data_import VALUES (52280, '2020-10-08', 'MQ', 'Martinique', 'AMRO', '308', '1851', '1', '22');
INSERT INTO public.who_global_data_import VALUES (52281, '2020-10-09', 'MQ', 'Martinique', 'AMRO', '0', '1851', '0', '22');
INSERT INTO public.who_global_data_import VALUES (52282, '2020-10-10', 'MQ', 'Martinique', 'AMRO', '0', '1851', '0', '22');
INSERT INTO public.who_global_data_import VALUES (52283, '2020-10-11', 'MQ', 'Martinique', 'AMRO', '0', '1851', '0', '22');
INSERT INTO public.who_global_data_import VALUES (52284, '2020-10-12', 'MQ', 'Martinique', 'AMRO', '0', '1851', '0', '22');
INSERT INTO public.who_global_data_import VALUES (52285, '2020-10-13', 'MQ', 'Martinique', 'AMRO', '0', '1851', '0', '22');
INSERT INTO public.who_global_data_import VALUES (52286, '2020-10-14', 'MQ', 'Martinique', 'AMRO', '0', '1851', '0', '22');
INSERT INTO public.who_global_data_import VALUES (52287, '2020-10-15', 'MQ', 'Martinique', 'AMRO', '406', '2257', '2', '24');
INSERT INTO public.who_global_data_import VALUES (52288, '2020-10-16', 'MQ', 'Martinique', 'AMRO', '0', '2257', '0', '24');
INSERT INTO public.who_global_data_import VALUES (52289, '2020-10-17', 'MQ', 'Martinique', 'AMRO', '9', '2266', '1', '25');
INSERT INTO public.who_global_data_import VALUES (52290, '2020-10-18', 'MQ', 'Martinique', 'AMRO', '0', '2266', '0', '25');
INSERT INTO public.who_global_data_import VALUES (52291, '2020-10-19', 'MQ', 'Martinique', 'AMRO', '0', '2266', '0', '25');
INSERT INTO public.who_global_data_import VALUES (52292, '2020-10-20', 'MQ', 'Martinique', 'AMRO', '0', '2266', '0', '25');
INSERT INTO public.who_global_data_import VALUES (52293, '2020-10-21', 'MQ', 'Martinique', 'AMRO', '0', '2266', '0', '25');
INSERT INTO public.who_global_data_import VALUES (52294, '2020-10-22', 'MQ', 'Martinique', 'AMRO', '528', '2794', '2', '27');
INSERT INTO public.who_global_data_import VALUES (52295, '2020-10-23', 'MQ', 'Martinique', 'AMRO', '0', '2794', '0', '27');
INSERT INTO public.who_global_data_import VALUES (52296, '2020-10-24', 'MQ', 'Martinique', 'AMRO', '0', '2794', '0', '27');
INSERT INTO public.who_global_data_import VALUES (52297, '2020-10-25', 'MQ', 'Martinique', 'AMRO', '0', '2794', '0', '27');
INSERT INTO public.who_global_data_import VALUES (52298, '2020-10-26', 'MQ', 'Martinique', 'AMRO', '6', '2800', '0', '27');
INSERT INTO public.who_global_data_import VALUES (52299, '2020-10-27', 'MQ', 'Martinique', 'AMRO', '0', '2800', '0', '27');
INSERT INTO public.who_global_data_import VALUES (52300, '2020-10-28', 'MQ', 'Martinique', 'AMRO', '0', '2800', '0', '27');
INSERT INTO public.who_global_data_import VALUES (52301, '2020-10-29', 'MQ', 'Martinique', 'AMRO', '752', '3552', '3', '30');
INSERT INTO public.who_global_data_import VALUES (52302, '2020-10-30', 'MQ', 'Martinique', 'AMRO', '0', '3552', '0', '30');
INSERT INTO public.who_global_data_import VALUES (52303, '2020-10-31', 'MQ', 'Martinique', 'AMRO', '266', '3818', '1', '31');
INSERT INTO public.who_global_data_import VALUES (52304, '2020-11-01', 'MQ', 'Martinique', 'AMRO', '0', '3818', '0', '31');
INSERT INTO public.who_global_data_import VALUES (52305, '2020-11-02', 'MQ', 'Martinique', 'AMRO', '0', '3818', '0', '31');
INSERT INTO public.who_global_data_import VALUES (52306, '2020-11-03', 'MQ', 'Martinique', 'AMRO', '0', '3818', '0', '31');
INSERT INTO public.who_global_data_import VALUES (52307, '2020-11-04', 'MQ', 'Martinique', 'AMRO', '0', '3818', '0', '31');
INSERT INTO public.who_global_data_import VALUES (52308, '2020-11-05', 'MQ', 'Martinique', 'AMRO', '397', '4215', '2', '33');
INSERT INTO public.who_global_data_import VALUES (52309, '2020-11-06', 'MQ', 'Martinique', 'AMRO', '0', '4215', '0', '33');
INSERT INTO public.who_global_data_import VALUES (52310, '2020-11-07', 'MQ', 'Martinique', 'AMRO', '0', '4215', '0', '33');
INSERT INTO public.who_global_data_import VALUES (52311, '2020-11-08', 'MQ', 'Martinique', 'AMRO', '0', '4215', '0', '33');
INSERT INTO public.who_global_data_import VALUES (52312, '2020-11-09', 'MQ', 'Martinique', 'AMRO', '0', '4215', '0', '33');
INSERT INTO public.who_global_data_import VALUES (52313, '2020-11-10', 'MQ', 'Martinique', 'AMRO', '0', '4215', '0', '33');
INSERT INTO public.who_global_data_import VALUES (52314, '2020-11-11', 'MQ', 'Martinique', 'AMRO', '0', '4215', '0', '33');
INSERT INTO public.who_global_data_import VALUES (52315, '2020-11-12', 'MQ', 'Martinique', 'AMRO', '517', '4732', '4', '37');
INSERT INTO public.who_global_data_import VALUES (52316, '2020-11-13', 'MQ', 'Martinique', 'AMRO', '0', '4732', '0', '37');
INSERT INTO public.who_global_data_import VALUES (52317, '2020-11-14', 'MQ', 'Martinique', 'AMRO', '0', '4732', '0', '37');
INSERT INTO public.who_global_data_import VALUES (52318, '2020-11-15', 'MQ', 'Martinique', 'AMRO', '0', '4732', '0', '37');
INSERT INTO public.who_global_data_import VALUES (52319, '2020-11-16', 'MQ', 'Martinique', 'AMRO', '0', '4732', '0', '37');
INSERT INTO public.who_global_data_import VALUES (52320, '2020-11-17', 'MQ', 'Martinique', 'AMRO', '0', '4732', '0', '37');
INSERT INTO public.who_global_data_import VALUES (52321, '2020-11-18', 'MQ', 'Martinique', 'AMRO', '0', '4732', '0', '37');
INSERT INTO public.who_global_data_import VALUES (52322, '2020-11-19', 'MQ', 'Martinique', 'AMRO', '359', '5091', '2', '39');
INSERT INTO public.who_global_data_import VALUES (52323, '2020-11-20', 'MQ', 'Martinique', 'AMRO', '0', '5091', '0', '39');
INSERT INTO public.who_global_data_import VALUES (52324, '2020-11-21', 'MQ', 'Martinique', 'AMRO', '0', '5091', '0', '39');
INSERT INTO public.who_global_data_import VALUES (52325, '2020-11-22', 'MQ', 'Martinique', 'AMRO', '0', '5091', '0', '39');
INSERT INTO public.who_global_data_import VALUES (52326, '2020-11-23', 'MQ', 'Martinique', 'AMRO', '0', '5091', '0', '39');
INSERT INTO public.who_global_data_import VALUES (52327, '2020-11-24', 'MQ', 'Martinique', 'AMRO', '0', '5091', '0', '39');
INSERT INTO public.who_global_data_import VALUES (52328, '2020-11-25', 'MQ', 'Martinique', 'AMRO', '0', '5091', '0', '39');
INSERT INTO public.who_global_data_import VALUES (52329, '2020-11-26', 'MQ', 'Martinique', 'AMRO', '322', '5413', '1', '40');
INSERT INTO public.who_global_data_import VALUES (52330, '2020-11-27', 'MQ', 'Martinique', 'AMRO', '0', '5413', '0', '40');
INSERT INTO public.who_global_data_import VALUES (52331, '2020-11-28', 'MQ', 'Martinique', 'AMRO', '0', '5413', '0', '40');
INSERT INTO public.who_global_data_import VALUES (52332, '2020-11-29', 'MQ', 'Martinique', 'AMRO', '0', '5413', '0', '40');
INSERT INTO public.who_global_data_import VALUES (52333, '2020-11-30', 'MQ', 'Martinique', 'AMRO', '0', '5413', '0', '40');
INSERT INTO public.who_global_data_import VALUES (52334, '2020-12-01', 'MQ', 'Martinique', 'AMRO', '73', '5486', '0', '40');
INSERT INTO public.who_global_data_import VALUES (52335, '2020-12-02', 'MQ', 'Martinique', 'AMRO', '0', '5486', '0', '40');
INSERT INTO public.who_global_data_import VALUES (52336, '2020-12-03', 'MQ', 'Martinique', 'AMRO', '34', '5520', '1', '41');
INSERT INTO public.who_global_data_import VALUES (52337, '2020-12-04', 'MQ', 'Martinique', 'AMRO', '0', '5520', '0', '41');
INSERT INTO public.who_global_data_import VALUES (52338, '2020-12-05', 'MQ', 'Martinique', 'AMRO', '0', '5520', '0', '41');
INSERT INTO public.who_global_data_import VALUES (52339, '2020-12-06', 'MQ', 'Martinique', 'AMRO', '0', '5520', '0', '41');
INSERT INTO public.who_global_data_import VALUES (52340, '2020-12-07', 'MQ', 'Martinique', 'AMRO', '0', '5520', '0', '41');
INSERT INTO public.who_global_data_import VALUES (52341, '2020-12-08', 'MQ', 'Martinique', 'AMRO', '33', '5553', '0', '41');
INSERT INTO public.who_global_data_import VALUES (52342, '2020-12-09', 'MQ', 'Martinique', 'AMRO', '0', '5553', '0', '41');
INSERT INTO public.who_global_data_import VALUES (52343, '2020-12-10', 'MQ', 'Martinique', 'AMRO', '0', '5553', '0', '41');
INSERT INTO public.who_global_data_import VALUES (52344, '2020-12-11', 'MQ', 'Martinique', 'AMRO', '0', '5553', '0', '41');
INSERT INTO public.who_global_data_import VALUES (52345, '2020-12-12', 'MQ', 'Martinique', 'AMRO', '0', '5553', '0', '41');
INSERT INTO public.who_global_data_import VALUES (52346, '2020-12-13', 'MQ', 'Martinique', 'AMRO', '0', '5553', '0', '41');
INSERT INTO public.who_global_data_import VALUES (52347, '2020-12-14', 'MQ', 'Martinique', 'AMRO', '0', '5553', '0', '41');
INSERT INTO public.who_global_data_import VALUES (52348, '2020-12-15', 'MQ', 'Martinique', 'AMRO', '48', '5601', '1', '42');
INSERT INTO public.who_global_data_import VALUES (52349, '2020-12-16', 'MQ', 'Martinique', 'AMRO', '0', '5601', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52350, '2020-12-17', 'MQ', 'Martinique', 'AMRO', '0', '5601', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52351, '2020-12-18', 'MQ', 'Martinique', 'AMRO', '0', '5601', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52352, '2020-12-19', 'MQ', 'Martinique', 'AMRO', '0', '5601', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52353, '2020-12-20', 'MQ', 'Martinique', 'AMRO', '33', '5634', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52354, '2020-12-21', 'MQ', 'Martinique', 'AMRO', '0', '5634', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52355, '2020-12-22', 'MQ', 'Martinique', 'AMRO', '0', '5634', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52356, '2020-12-23', 'MQ', 'Martinique', 'AMRO', '0', '5634', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52357, '2020-12-24', 'MQ', 'Martinique', 'AMRO', '0', '5634', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52358, '2020-12-25', 'MQ', 'Martinique', 'AMRO', '0', '5634', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52359, '2020-12-26', 'MQ', 'Martinique', 'AMRO', '0', '5634', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52360, '2020-12-27', 'MQ', 'Martinique', 'AMRO', '438', '6072', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52361, '2020-12-28', 'MQ', 'Martinique', 'AMRO', '0', '6072', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52362, '2020-12-29', 'MQ', 'Martinique', 'AMRO', '0', '6072', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52363, '2020-12-30', 'MQ', 'Martinique', 'AMRO', '0', '6072', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52364, '2020-12-31', 'MQ', 'Martinique', 'AMRO', '0', '6072', '0', '42');
INSERT INTO public.who_global_data_import VALUES (52365, '2021-01-01', 'MQ', 'Martinique', 'AMRO', '19', '6091', '1', '43');
INSERT INTO public.who_global_data_import VALUES (52366, '2021-01-02', 'MQ', 'Martinique', 'AMRO', '0', '6091', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52367, '2021-01-03', 'MQ', 'Martinique', 'AMRO', '0', '6091', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52368, '2021-01-04', 'MQ', 'Martinique', 'AMRO', '0', '6091', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52369, '2021-01-05', 'MQ', 'Martinique', 'AMRO', '26', '6117', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52370, '2021-01-06', 'MQ', 'Martinique', 'AMRO', '0', '6117', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52371, '2021-01-07', 'MQ', 'Martinique', 'AMRO', '0', '6117', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52372, '2021-01-08', 'MQ', 'Martinique', 'AMRO', '0', '6117', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52373, '2021-01-09', 'MQ', 'Martinique', 'AMRO', '0', '6117', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52374, '2021-01-10', 'MQ', 'Martinique', 'AMRO', '0', '6117', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52375, '2021-01-11', 'MQ', 'Martinique', 'AMRO', '0', '6117', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52376, '2021-01-12', 'MQ', 'Martinique', 'AMRO', '110', '6227', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52377, '2021-01-13', 'MQ', 'Martinique', 'AMRO', '0', '6227', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52378, '2021-01-14', 'MQ', 'Martinique', 'AMRO', '0', '6227', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52379, '2021-01-15', 'MQ', 'Martinique', 'AMRO', '0', '6227', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52380, '2021-01-16', 'MQ', 'Martinique', 'AMRO', '0', '6227', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52381, '2021-01-17', 'MQ', 'Martinique', 'AMRO', '0', '6227', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52382, '2021-01-18', 'MQ', 'Martinique', 'AMRO', '0', '6227', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52383, '2021-01-19', 'MQ', 'Martinique', 'AMRO', '75', '6302', '1', '44');
INSERT INTO public.who_global_data_import VALUES (52384, '2021-01-20', 'MQ', 'Martinique', 'AMRO', '0', '6302', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52385, '2021-01-21', 'MQ', 'Martinique', 'AMRO', '0', '6302', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52386, '2021-01-22', 'MQ', 'Martinique', 'AMRO', '0', '6302', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52387, '2021-01-23', 'MQ', 'Martinique', 'AMRO', '68', '6370', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52388, '2021-01-24', 'MQ', 'Martinique', 'AMRO', '0', '6370', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52389, '2021-01-25', 'MQ', 'Martinique', 'AMRO', '0', '6370', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52390, '2021-01-26', 'MQ', 'Martinique', 'AMRO', '0', '6370', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52391, '2021-01-27', 'MQ', 'Martinique', 'AMRO', '0', '6370', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52392, '2021-01-28', 'MQ', 'Martinique', 'AMRO', '0', '6370', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52393, '2021-01-29', 'MQ', 'Martinique', 'AMRO', '0', '6370', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52394, '2021-01-30', 'MQ', 'Martinique', 'AMRO', '0', '6370', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52395, '2021-01-31', 'MQ', 'Martinique', 'AMRO', '0', '6370', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52396, '2021-02-01', 'MQ', 'Martinique', 'AMRO', '0', '6370', '0', '44');
INSERT INTO public.who_global_data_import VALUES (52397, '2021-02-02', 'MQ', 'Martinique', 'AMRO', '72', '6442', '1', '45');
INSERT INTO public.who_global_data_import VALUES (52398, '2021-02-03', 'MQ', 'Martinique', 'AMRO', '0', '6442', '0', '45');
INSERT INTO public.who_global_data_import VALUES (52399, '2021-02-04', 'MQ', 'Martinique', 'AMRO', '0', '6442', '0', '45');
INSERT INTO public.who_global_data_import VALUES (52400, '2021-02-05', 'MQ', 'Martinique', 'AMRO', '0', '6442', '0', '45');
INSERT INTO public.who_global_data_import VALUES (52401, '2020-01-03', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52402, '2020-01-04', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52403, '2020-01-05', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52404, '2020-01-06', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52405, '2020-01-07', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52406, '2020-01-08', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52407, '2020-01-09', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52408, '2020-01-10', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52409, '2020-01-11', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52410, '2020-01-12', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52411, '2020-01-13', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52412, '2020-01-14', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52413, '2020-01-15', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52414, '2020-01-16', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52415, '2020-01-17', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52416, '2020-01-18', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52417, '2020-01-19', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52418, '2020-01-20', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52419, '2020-01-21', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52420, '2020-01-22', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52421, '2020-01-23', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52422, '2020-01-24', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52423, '2020-01-25', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52424, '2020-01-26', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52425, '2020-01-27', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52426, '2020-01-28', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52427, '2020-01-29', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52428, '2020-01-30', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52429, '2020-01-31', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52430, '2020-02-01', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52431, '2020-02-02', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52432, '2020-02-03', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52433, '2020-02-04', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52434, '2020-02-05', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52435, '2020-02-06', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52436, '2020-02-07', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52437, '2020-02-08', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52438, '2020-02-09', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52439, '2020-02-10', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52440, '2020-02-11', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52441, '2020-02-12', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52442, '2020-02-13', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52443, '2020-02-14', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52444, '2020-02-15', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52445, '2020-02-16', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52446, '2020-02-17', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52447, '2020-02-18', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52448, '2020-02-19', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52449, '2020-02-20', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52450, '2020-02-21', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52451, '2020-02-22', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52452, '2020-02-23', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52453, '2020-02-24', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52454, '2020-02-25', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52455, '2020-02-26', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52456, '2020-02-27', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52457, '2020-02-28', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52458, '2020-02-29', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52459, '2020-03-01', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52460, '2020-03-02', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52461, '2020-03-03', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52462, '2020-03-04', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52463, '2020-03-05', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52464, '2020-03-06', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52465, '2020-03-07', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52466, '2020-03-08', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52467, '2020-03-09', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52468, '2020-03-10', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52469, '2020-03-11', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52470, '2020-03-12', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52471, '2020-03-13', 'MR', 'Mauritania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52472, '2020-03-14', 'MR', 'Mauritania', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52473, '2020-03-15', 'MR', 'Mauritania', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52474, '2020-03-16', 'MR', 'Mauritania', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52475, '2020-03-17', 'MR', 'Mauritania', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52476, '2020-03-18', 'MR', 'Mauritania', 'AFRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52477, '2020-03-19', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52478, '2020-03-20', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52479, '2020-03-21', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52480, '2020-03-22', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52481, '2020-03-23', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52482, '2020-03-24', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52483, '2020-03-25', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52484, '2020-03-26', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52485, '2020-03-27', 'MR', 'Mauritania', 'AFRO', '-3', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52486, '2020-03-28', 'MR', 'Mauritania', 'AFRO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52487, '2020-03-29', 'MR', 'Mauritania', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52488, '2020-03-30', 'MR', 'Mauritania', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52489, '2020-03-31', 'MR', 'Mauritania', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52490, '2020-04-01', 'MR', 'Mauritania', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52491, '2020-04-02', 'MR', 'Mauritania', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52492, '2020-04-03', 'MR', 'Mauritania', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52493, '2020-04-04', 'MR', 'Mauritania', 'AFRO', '1', '6', '1', '1');
INSERT INTO public.who_global_data_import VALUES (52494, '2020-04-05', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52495, '2020-04-06', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52496, '2020-04-07', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52497, '2020-04-08', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52498, '2020-04-09', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52499, '2020-04-10', 'MR', 'Mauritania', 'AFRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52500, '2020-04-11', 'MR', 'Mauritania', 'AFRO', '1', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52501, '2020-04-12', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52502, '2020-04-13', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52503, '2020-04-14', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52504, '2020-04-15', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52505, '2020-04-16', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52506, '2020-04-17', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52507, '2020-04-18', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52508, '2020-04-19', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52509, '2020-04-20', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52510, '2020-04-21', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52511, '2020-04-22', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52512, '2020-04-23', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52513, '2020-04-24', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52514, '2020-04-25', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52515, '2020-04-26', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52516, '2020-04-27', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52517, '2020-04-28', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52518, '2020-04-29', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52519, '2020-04-30', 'MR', 'Mauritania', 'AFRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52520, '2020-05-01', 'MR', 'Mauritania', 'AFRO', '1', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52521, '2020-05-02', 'MR', 'Mauritania', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52522, '2020-05-03', 'MR', 'Mauritania', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52523, '2020-05-04', 'MR', 'Mauritania', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52524, '2020-05-05', 'MR', 'Mauritania', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52525, '2020-05-06', 'MR', 'Mauritania', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52526, '2020-05-07', 'MR', 'Mauritania', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52527, '2020-05-08', 'MR', 'Mauritania', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52528, '2020-05-09', 'MR', 'Mauritania', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52529, '2020-05-10', 'MR', 'Mauritania', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52530, '2020-05-11', 'MR', 'Mauritania', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52531, '2020-05-12', 'MR', 'Mauritania', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52532, '2020-05-13', 'MR', 'Mauritania', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52533, '2020-05-14', 'MR', 'Mauritania', 'AFRO', '1', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (52534, '2020-05-15', 'MR', 'Mauritania', 'AFRO', '7', '16', '1', '2');
INSERT INTO public.who_global_data_import VALUES (52535, '2020-05-16', 'MR', 'Mauritania', 'AFRO', '13', '29', '1', '3');
INSERT INTO public.who_global_data_import VALUES (52536, '2020-05-17', 'MR', 'Mauritania', 'AFRO', '11', '40', '1', '4');
INSERT INTO public.who_global_data_import VALUES (52537, '2020-05-18', 'MR', 'Mauritania', 'AFRO', '22', '62', '0', '4');
INSERT INTO public.who_global_data_import VALUES (52538, '2020-05-19', 'MR', 'Mauritania', 'AFRO', '19', '81', '0', '4');
INSERT INTO public.who_global_data_import VALUES (52539, '2020-05-20', 'MR', 'Mauritania', 'AFRO', '50', '131', '0', '4');
INSERT INTO public.who_global_data_import VALUES (52540, '2020-05-21', 'MR', 'Mauritania', 'AFRO', '10', '141', '0', '4');
INSERT INTO public.who_global_data_import VALUES (52541, '2020-05-22', 'MR', 'Mauritania', 'AFRO', '32', '173', '1', '5');
INSERT INTO public.who_global_data_import VALUES (52542, '2020-05-23', 'MR', 'Mauritania', 'AFRO', '0', '173', '0', '5');
INSERT INTO public.who_global_data_import VALUES (52543, '2020-05-24', 'MR', 'Mauritania', 'AFRO', '54', '227', '1', '6');
INSERT INTO public.who_global_data_import VALUES (52544, '2020-05-25', 'MR', 'Mauritania', 'AFRO', '10', '237', '0', '6');
INSERT INTO public.who_global_data_import VALUES (52545, '2020-05-26', 'MR', 'Mauritania', 'AFRO', '25', '262', '3', '9');
INSERT INTO public.who_global_data_import VALUES (52546, '2020-05-27', 'MR', 'Mauritania', 'AFRO', '0', '262', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52547, '2020-05-28', 'MR', 'Mauritania', 'AFRO', '30', '292', '7', '16');
INSERT INTO public.who_global_data_import VALUES (52548, '2020-05-29', 'MR', 'Mauritania', 'AFRO', '54', '346', '3', '19');
INSERT INTO public.who_global_data_import VALUES (52549, '2020-05-30', 'MR', 'Mauritania', 'AFRO', '77', '423', '1', '20');
INSERT INTO public.who_global_data_import VALUES (52550, '2020-05-31', 'MR', 'Mauritania', 'AFRO', '60', '483', '1', '21');
INSERT INTO public.who_global_data_import VALUES (52551, '2020-06-01', 'MR', 'Mauritania', 'AFRO', '47', '530', '2', '23');
INSERT INTO public.who_global_data_import VALUES (52552, '2020-06-02', 'MR', 'Mauritania', 'AFRO', '0', '530', '0', '23');
INSERT INTO public.who_global_data_import VALUES (52553, '2020-06-03', 'MR', 'Mauritania', 'AFRO', '58', '588', '3', '26');
INSERT INTO public.who_global_data_import VALUES (52554, '2020-06-04', 'MR', 'Mauritania', 'AFRO', '80', '668', '5', '31');
INSERT INTO public.who_global_data_import VALUES (52555, '2020-06-05', 'MR', 'Mauritania', 'AFRO', '116', '784', '8', '39');
INSERT INTO public.who_global_data_import VALUES (52556, '2020-06-06', 'MR', 'Mauritania', 'AFRO', '99', '883', '4', '43');
INSERT INTO public.who_global_data_import VALUES (52557, '2020-06-07', 'MR', 'Mauritania', 'AFRO', '64', '947', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52558, '2020-06-08', 'MR', 'Mauritania', 'AFRO', '0', '947', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52559, '2020-06-09', 'MR', 'Mauritania', 'AFRO', '102', '1049', '0', '43');
INSERT INTO public.who_global_data_import VALUES (52560, '2020-06-10', 'MR', 'Mauritania', 'AFRO', '113', '1162', '20', '63');
INSERT INTO public.who_global_data_import VALUES (52561, '2020-06-11', 'MR', 'Mauritania', 'AFRO', '121', '1283', '8', '71');
INSERT INTO public.who_global_data_import VALUES (52562, '2020-06-12', 'MR', 'Mauritania', 'AFRO', '0', '1283', '0', '71');
INSERT INTO public.who_global_data_import VALUES (52563, '2020-06-13', 'MR', 'Mauritania', 'AFRO', '156', '1439', '3', '74');
INSERT INTO public.who_global_data_import VALUES (52564, '2020-06-14', 'MR', 'Mauritania', 'AFRO', '134', '1573', '7', '81');
INSERT INTO public.who_global_data_import VALUES (52565, '2020-06-15', 'MR', 'Mauritania', 'AFRO', '210', '1783', '6', '87');
INSERT INTO public.who_global_data_import VALUES (52566, '2020-06-16', 'MR', 'Mauritania', 'AFRO', '0', '1783', '0', '87');
INSERT INTO public.who_global_data_import VALUES (52567, '2020-06-17', 'MR', 'Mauritania', 'AFRO', '104', '1887', '4', '91');
INSERT INTO public.who_global_data_import VALUES (52568, '2020-06-18', 'MR', 'Mauritania', 'AFRO', '170', '2057', '2', '93');
INSERT INTO public.who_global_data_import VALUES (52569, '2020-06-19', 'MR', 'Mauritania', 'AFRO', '166', '2223', '2', '95');
INSERT INTO public.who_global_data_import VALUES (52570, '2020-06-20', 'MR', 'Mauritania', 'AFRO', '201', '2424', '2', '97');
INSERT INTO public.who_global_data_import VALUES (52571, '2020-06-21', 'MR', 'Mauritania', 'AFRO', '197', '2621', '5', '102');
INSERT INTO public.who_global_data_import VALUES (52572, '2020-06-22', 'MR', 'Mauritania', 'AFRO', '192', '2813', '6', '108');
INSERT INTO public.who_global_data_import VALUES (52573, '2020-06-23', 'MR', 'Mauritania', 'AFRO', '171', '2984', '3', '111');
INSERT INTO public.who_global_data_import VALUES (52574, '2020-06-24', 'MR', 'Mauritania', 'AFRO', '137', '3121', '1', '112');
INSERT INTO public.who_global_data_import VALUES (52575, '2020-06-25', 'MR', 'Mauritania', 'AFRO', '171', '3292', '2', '114');
INSERT INTO public.who_global_data_import VALUES (52576, '2020-06-26', 'MR', 'Mauritania', 'AFRO', '227', '3519', '2', '116');
INSERT INTO public.who_global_data_import VALUES (52577, '2020-06-27', 'MR', 'Mauritania', 'AFRO', '220', '3739', '3', '119');
INSERT INTO public.who_global_data_import VALUES (52578, '2020-06-28', 'MR', 'Mauritania', 'AFRO', '168', '3907', '1', '120');
INSERT INTO public.who_global_data_import VALUES (52579, '2020-06-29', 'MR', 'Mauritania', 'AFRO', '0', '3907', '0', '120');
INSERT INTO public.who_global_data_import VALUES (52580, '2020-06-30', 'MR', 'Mauritania', 'AFRO', '242', '4149', '6', '126');
INSERT INTO public.who_global_data_import VALUES (52581, '2020-07-01', 'MR', 'Mauritania', 'AFRO', '88', '4237', '2', '128');
INSERT INTO public.who_global_data_import VALUES (52582, '2020-07-02', 'MR', 'Mauritania', 'AFRO', '235', '4472', '1', '129');
INSERT INTO public.who_global_data_import VALUES (52583, '2020-07-03', 'MR', 'Mauritania', 'AFRO', '134', '4606', '0', '129');
INSERT INTO public.who_global_data_import VALUES (52584, '2020-07-04', 'MR', 'Mauritania', 'AFRO', '99', '4705', '0', '129');
INSERT INTO public.who_global_data_import VALUES (52585, '2020-07-05', 'MR', 'Mauritania', 'AFRO', '0', '4705', '0', '129');
INSERT INTO public.who_global_data_import VALUES (52586, '2020-07-06', 'MR', 'Mauritania', 'AFRO', '174', '4879', '1', '130');
INSERT INTO public.who_global_data_import VALUES (52587, '2020-07-07', 'MR', 'Mauritania', 'AFRO', '0', '4879', '0', '130');
INSERT INTO public.who_global_data_import VALUES (52588, '2020-07-08', 'MR', 'Mauritania', 'AFRO', '69', '4948', '3', '133');
INSERT INTO public.who_global_data_import VALUES (52589, '2020-07-09', 'MR', 'Mauritania', 'AFRO', '76', '5024', '2', '135');
INSERT INTO public.who_global_data_import VALUES (52590, '2020-07-10', 'MR', 'Mauritania', 'AFRO', '63', '5087', '4', '139');
INSERT INTO public.who_global_data_import VALUES (52591, '2020-07-11', 'MR', 'Mauritania', 'AFRO', '39', '5126', '5', '144');
INSERT INTO public.who_global_data_import VALUES (52592, '2020-07-12', 'MR', 'Mauritania', 'AFRO', '0', '5126', '0', '144');
INSERT INTO public.who_global_data_import VALUES (52593, '2020-07-13', 'MR', 'Mauritania', 'AFRO', '149', '5275', '3', '147');
INSERT INTO public.who_global_data_import VALUES (52594, '2020-07-14', 'MR', 'Mauritania', 'AFRO', '80', '5355', '0', '147');
INSERT INTO public.who_global_data_import VALUES (52595, '2020-07-15', 'MR', 'Mauritania', 'AFRO', '91', '5446', '2', '149');
INSERT INTO public.who_global_data_import VALUES (52596, '2020-07-16', 'MR', 'Mauritania', 'AFRO', '72', '5518', '0', '149');
INSERT INTO public.who_global_data_import VALUES (52597, '2020-07-17', 'MR', 'Mauritania', 'AFRO', '46', '5564', '0', '149');
INSERT INTO public.who_global_data_import VALUES (52598, '2020-07-18', 'MR', 'Mauritania', 'AFRO', '95', '5659', '1', '150');
INSERT INTO public.who_global_data_import VALUES (52599, '2020-07-19', 'MR', 'Mauritania', 'AFRO', '51', '5710', '1', '151');
INSERT INTO public.who_global_data_import VALUES (52600, '2020-07-20', 'MR', 'Mauritania', 'AFRO', '163', '5873', '4', '155');
INSERT INTO public.who_global_data_import VALUES (52601, '2020-07-21', 'MR', 'Mauritania', 'AFRO', '50', '5923', '0', '155');
INSERT INTO public.who_global_data_import VALUES (52602, '2020-07-22', 'MR', 'Mauritania', 'AFRO', '62', '5985', '0', '155');
INSERT INTO public.who_global_data_import VALUES (52603, '2020-07-23', 'MR', 'Mauritania', 'AFRO', '0', '5985', '0', '155');
INSERT INTO public.who_global_data_import VALUES (52604, '2020-07-24', 'MR', 'Mauritania', 'AFRO', '42', '6027', '0', '155');
INSERT INTO public.who_global_data_import VALUES (52605, '2020-07-25', 'MR', 'Mauritania', 'AFRO', '89', '6116', '1', '156');
INSERT INTO public.who_global_data_import VALUES (52606, '2020-07-26', 'MR', 'Mauritania', 'AFRO', '0', '6116', '0', '156');
INSERT INTO public.who_global_data_import VALUES (52607, '2020-07-27', 'MR', 'Mauritania', 'AFRO', '55', '6171', '0', '156');
INSERT INTO public.who_global_data_import VALUES (52608, '2020-07-28', 'MR', 'Mauritania', 'AFRO', '37', '6208', '0', '156');
INSERT INTO public.who_global_data_import VALUES (52609, '2020-07-29', 'MR', 'Mauritania', 'AFRO', '41', '6249', '0', '156');
INSERT INTO public.who_global_data_import VALUES (52610, '2020-07-30', 'MR', 'Mauritania', 'AFRO', '21', '6270', '0', '156');
INSERT INTO public.who_global_data_import VALUES (52611, '2020-07-31', 'MR', 'Mauritania', 'AFRO', '0', '6270', '0', '156');
INSERT INTO public.who_global_data_import VALUES (52612, '2020-08-01', 'MR', 'Mauritania', 'AFRO', '40', '6310', '1', '157');
INSERT INTO public.who_global_data_import VALUES (52613, '2020-08-02', 'MR', 'Mauritania', 'AFRO', '0', '6310', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52614, '2020-08-03', 'MR', 'Mauritania', 'AFRO', '13', '6323', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52615, '2020-08-04', 'MR', 'Mauritania', 'AFRO', '59', '6382', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52616, '2020-08-05', 'MR', 'Mauritania', 'AFRO', '36', '6418', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52617, '2020-08-06', 'MR', 'Mauritania', 'AFRO', '26', '6444', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52618, '2020-08-07', 'MR', 'Mauritania', 'AFRO', '29', '6473', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52619, '2020-08-08', 'MR', 'Mauritania', 'AFRO', '25', '6498', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52620, '2020-08-09', 'MR', 'Mauritania', 'AFRO', '0', '6498', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52621, '2020-08-10', 'MR', 'Mauritania', 'AFRO', '12', '6510', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52622, '2020-08-11', 'MR', 'Mauritania', 'AFRO', '40', '6550', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52623, '2020-08-12', 'MR', 'Mauritania', 'AFRO', '48', '6598', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52624, '2020-08-13', 'MR', 'Mauritania', 'AFRO', '24', '6622', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52625, '2020-08-14', 'MR', 'Mauritania', 'AFRO', '0', '6622', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52626, '2020-08-15', 'MR', 'Mauritania', 'AFRO', '31', '6653', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52627, '2020-08-16', 'MR', 'Mauritania', 'AFRO', '40', '6693', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52628, '2020-08-17', 'MR', 'Mauritania', 'AFRO', '8', '6701', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52629, '2020-08-18', 'MR', 'Mauritania', 'AFRO', '61', '6762', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52630, '2020-08-19', 'MR', 'Mauritania', 'AFRO', '27', '6789', '0', '157');
INSERT INTO public.who_global_data_import VALUES (52631, '2020-08-20', 'MR', 'Mauritania', 'AFRO', '40', '6829', '1', '158');
INSERT INTO public.who_global_data_import VALUES (52632, '2020-08-21', 'MR', 'Mauritania', 'AFRO', '19', '6848', '0', '158');
INSERT INTO public.who_global_data_import VALUES (52633, '2020-08-22', 'MR', 'Mauritania', 'AFRO', '37', '6885', '0', '158');
INSERT INTO public.who_global_data_import VALUES (52634, '2020-08-23', 'MR', 'Mauritania', 'AFRO', '9', '6894', '0', '158');
INSERT INTO public.who_global_data_import VALUES (52635, '2020-08-24', 'MR', 'Mauritania', 'AFRO', '11', '6905', '0', '158');
INSERT INTO public.who_global_data_import VALUES (52636, '2020-08-25', 'MR', 'Mauritania', 'AFRO', '23', '6928', '0', '158');
INSERT INTO public.who_global_data_import VALUES (52637, '2020-08-26', 'MR', 'Mauritania', 'AFRO', '32', '6960', '0', '158');
INSERT INTO public.who_global_data_import VALUES (52638, '2020-08-27', 'MR', 'Mauritania', 'AFRO', '17', '6977', '0', '158');
INSERT INTO public.who_global_data_import VALUES (52639, '2020-08-28', 'MR', 'Mauritania', 'AFRO', '0', '6977', '0', '158');
INSERT INTO public.who_global_data_import VALUES (52640, '2020-08-29', 'MR', 'Mauritania', 'AFRO', '35', '7012', '0', '158');
INSERT INTO public.who_global_data_import VALUES (52641, '2020-08-30', 'MR', 'Mauritania', 'AFRO', '0', '7012', '0', '158');
INSERT INTO public.who_global_data_import VALUES (52642, '2020-08-31', 'MR', 'Mauritania', 'AFRO', '10', '7022', '1', '159');
INSERT INTO public.who_global_data_import VALUES (52643, '2020-09-01', 'MR', 'Mauritania', 'AFRO', '26', '7048', '0', '159');
INSERT INTO public.who_global_data_import VALUES (52644, '2020-09-02', 'MR', 'Mauritania', 'AFRO', '27', '7075', '0', '159');
INSERT INTO public.who_global_data_import VALUES (52645, '2020-09-03', 'MR', 'Mauritania', 'AFRO', '14', '7089', '0', '159');
INSERT INTO public.who_global_data_import VALUES (52646, '2020-09-04', 'MR', 'Mauritania', 'AFRO', '17', '7106', '1', '160');
INSERT INTO public.who_global_data_import VALUES (52647, '2020-09-05', 'MR', 'Mauritania', 'AFRO', '20', '7126', '0', '160');
INSERT INTO public.who_global_data_import VALUES (52648, '2020-09-06', 'MR', 'Mauritania', 'AFRO', '8', '7134', '0', '160');
INSERT INTO public.who_global_data_import VALUES (52649, '2020-09-07', 'MR', 'Mauritania', 'AFRO', '8', '7142', '0', '160');
INSERT INTO public.who_global_data_import VALUES (52650, '2020-09-08', 'MR', 'Mauritania', 'AFRO', '22', '7164', '0', '160');
INSERT INTO public.who_global_data_import VALUES (52651, '2020-09-09', 'MR', 'Mauritania', 'AFRO', '0', '7164', '0', '160');
INSERT INTO public.who_global_data_import VALUES (52652, '2020-09-10', 'MR', 'Mauritania', 'AFRO', '38', '7202', '1', '161');
INSERT INTO public.who_global_data_import VALUES (52653, '2020-09-11', 'MR', 'Mauritania', 'AFRO', '20', '7222', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52654, '2020-09-12', 'MR', 'Mauritania', 'AFRO', '44', '7266', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52655, '2020-09-13', 'MR', 'Mauritania', 'AFRO', '8', '7274', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52656, '2020-09-14', 'MR', 'Mauritania', 'AFRO', '2', '7276', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52657, '2020-09-15', 'MR', 'Mauritania', 'AFRO', '19', '7295', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52658, '2020-09-16', 'MR', 'Mauritania', 'AFRO', '24', '7319', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52659, '2020-09-17', 'MR', 'Mauritania', 'AFRO', '13', '7332', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52660, '2020-09-18', 'MR', 'Mauritania', 'AFRO', '14', '7346', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52661, '2020-09-19', 'MR', 'Mauritania', 'AFRO', '15', '7361', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52662, '2020-09-20', 'MR', 'Mauritania', 'AFRO', '4', '7365', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52663, '2020-09-21', 'MR', 'Mauritania', 'AFRO', '3', '7368', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52664, '2020-09-22', 'MR', 'Mauritania', 'AFRO', '16', '7384', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52665, '2020-09-23', 'MR', 'Mauritania', 'AFRO', '19', '7403', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52666, '2020-09-24', 'MR', 'Mauritania', 'AFRO', '22', '7425', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52667, '2020-09-25', 'MR', 'Mauritania', 'AFRO', '8', '7433', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52668, '2020-09-26', 'MR', 'Mauritania', 'AFRO', '24', '7457', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52669, '2020-09-27', 'MR', 'Mauritania', 'AFRO', '5', '7462', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52670, '2020-09-28', 'MR', 'Mauritania', 'AFRO', '0', '7462', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52671, '2020-09-29', 'MR', 'Mauritania', 'AFRO', '12', '7474', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52672, '2020-09-30', 'MR', 'Mauritania', 'AFRO', '14', '7488', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52673, '2020-10-01', 'MR', 'Mauritania', 'AFRO', '14', '7502', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52674, '2020-10-02', 'MR', 'Mauritania', 'AFRO', '3', '7505', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52675, '2020-10-03', 'MR', 'Mauritania', 'AFRO', '6', '7511', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52676, '2020-10-04', 'MR', 'Mauritania', 'AFRO', '0', '7511', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52677, '2020-10-05', 'MR', 'Mauritania', 'AFRO', '9', '7520', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52678, '2020-10-06', 'MR', 'Mauritania', 'AFRO', '3', '7523', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52679, '2020-10-07', 'MR', 'Mauritania', 'AFRO', '0', '7523', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52680, '2020-10-08', 'MR', 'Mauritania', 'AFRO', '0', '7523', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52681, '2020-10-09', 'MR', 'Mauritania', 'AFRO', '0', '7523', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52682, '2020-10-10', 'MR', 'Mauritania', 'AFRO', '0', '7523', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52683, '2020-10-11', 'MR', 'Mauritania', 'AFRO', '0', '7523', '0', '161');
INSERT INTO public.who_global_data_import VALUES (52684, '2020-10-12', 'MR', 'Mauritania', 'AFRO', '27', '7550', '2', '163');
INSERT INTO public.who_global_data_import VALUES (52685, '2020-10-13', 'MR', 'Mauritania', 'AFRO', '4', '7554', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52686, '2020-10-14', 'MR', 'Mauritania', 'AFRO', '11', '7565', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52687, '2020-10-15', 'MR', 'Mauritania', 'AFRO', '0', '7565', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52688, '2020-10-16', 'MR', 'Mauritania', 'AFRO', '20', '7585', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52689, '2020-10-17', 'MR', 'Mauritania', 'AFRO', '18', '7603', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52690, '2020-10-18', 'MR', 'Mauritania', 'AFRO', '0', '7603', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52691, '2020-10-19', 'MR', 'Mauritania', 'AFRO', '5', '7608', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52692, '2020-10-20', 'MR', 'Mauritania', 'AFRO', '13', '7621', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52693, '2020-10-21', 'MR', 'Mauritania', 'AFRO', '13', '7634', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52694, '2020-10-22', 'MR', 'Mauritania', 'AFRO', '4', '7638', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52695, '2020-10-23', 'MR', 'Mauritania', 'AFRO', '0', '7638', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52696, '2020-10-24', 'MR', 'Mauritania', 'AFRO', '24', '7662', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52697, '2020-10-25', 'MR', 'Mauritania', 'AFRO', '0', '7662', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52698, '2020-10-26', 'MR', 'Mauritania', 'AFRO', '1', '7663', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52699, '2020-10-27', 'MR', 'Mauritania', 'AFRO', '0', '7663', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52700, '2020-10-28', 'MR', 'Mauritania', 'AFRO', '0', '7663', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52701, '2020-10-29', 'MR', 'Mauritania', 'AFRO', '0', '7663', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52702, '2020-10-30', 'MR', 'Mauritania', 'AFRO', '0', '7663', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52703, '2020-10-31', 'MR', 'Mauritania', 'AFRO', '0', '7663', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52704, '2020-11-01', 'MR', 'Mauritania', 'AFRO', '0', '7663', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52705, '2020-11-02', 'MR', 'Mauritania', 'AFRO', '0', '7663', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52706, '2020-11-03', 'MR', 'Mauritania', 'AFRO', '62', '7725', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52707, '2020-11-04', 'MR', 'Mauritania', 'AFRO', '0', '7725', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52708, '2020-11-05', 'MR', 'Mauritania', 'AFRO', '0', '7725', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52709, '2020-11-06', 'MR', 'Mauritania', 'AFRO', '0', '7725', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52710, '2020-11-07', 'MR', 'Mauritania', 'AFRO', '0', '7725', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52711, '2020-11-08', 'MR', 'Mauritania', 'AFRO', '0', '7725', '0', '163');
INSERT INTO public.who_global_data_import VALUES (52712, '2020-11-09', 'MR', 'Mauritania', 'AFRO', '95', '7820', '2', '165');
INSERT INTO public.who_global_data_import VALUES (52713, '2020-11-10', 'MR', 'Mauritania', 'AFRO', '0', '7820', '0', '165');
INSERT INTO public.who_global_data_import VALUES (52714, '2020-11-11', 'MR', 'Mauritania', 'AFRO', '28', '7848', '0', '165');
INSERT INTO public.who_global_data_import VALUES (52715, '2020-11-12', 'MR', 'Mauritania', 'AFRO', '37', '7885', '0', '165');
INSERT INTO public.who_global_data_import VALUES (52716, '2020-11-13', 'MR', 'Mauritania', 'AFRO', '0', '7885', '0', '165');
INSERT INTO public.who_global_data_import VALUES (52717, '2020-11-14', 'MR', 'Mauritania', 'AFRO', '0', '7885', '0', '165');
INSERT INTO public.who_global_data_import VALUES (52718, '2020-11-15', 'MR', 'Mauritania', 'AFRO', '0', '7885', '0', '165');
INSERT INTO public.who_global_data_import VALUES (52719, '2020-11-16', 'MR', 'Mauritania', 'AFRO', '0', '7885', '0', '165');
INSERT INTO public.who_global_data_import VALUES (52720, '2020-11-17', 'MR', 'Mauritania', 'AFRO', '67', '7952', '0', '165');
INSERT INTO public.who_global_data_import VALUES (52721, '2020-11-18', 'MR', 'Mauritania', 'AFRO', '0', '7952', '0', '165');
INSERT INTO public.who_global_data_import VALUES (52722, '2020-11-19', 'MR', 'Mauritania', 'AFRO', '0', '7952', '0', '165');
INSERT INTO public.who_global_data_import VALUES (52723, '2020-11-20', 'MR', 'Mauritania', 'AFRO', '0', '7952', '0', '165');
INSERT INTO public.who_global_data_import VALUES (52724, '2020-11-21', 'MR', 'Mauritania', 'AFRO', '123', '8075', '4', '169');
INSERT INTO public.who_global_data_import VALUES (52725, '2020-11-22', 'MR', 'Mauritania', 'AFRO', '0', '8075', '0', '169');
INSERT INTO public.who_global_data_import VALUES (52726, '2020-11-23', 'MR', 'Mauritania', 'AFRO', '0', '8075', '0', '169');
INSERT INTO public.who_global_data_import VALUES (52727, '2020-11-24', 'MR', 'Mauritania', 'AFRO', '0', '8075', '0', '169');
INSERT INTO public.who_global_data_import VALUES (52728, '2020-11-25', 'MR', 'Mauritania', 'AFRO', '0', '8075', '0', '169');
INSERT INTO public.who_global_data_import VALUES (52729, '2020-11-26', 'MR', 'Mauritania', 'AFRO', '0', '8075', '0', '169');
INSERT INTO public.who_global_data_import VALUES (52730, '2020-11-27', 'MR', 'Mauritania', 'AFRO', '0', '8075', '0', '169');
INSERT INTO public.who_global_data_import VALUES (52731, '2020-11-28', 'MR', 'Mauritania', 'AFRO', '349', '8424', '3', '172');
INSERT INTO public.who_global_data_import VALUES (52732, '2020-11-29', 'MR', 'Mauritania', 'AFRO', '0', '8424', '0', '172');
INSERT INTO public.who_global_data_import VALUES (52733, '2020-11-30', 'MR', 'Mauritania', 'AFRO', '0', '8424', '0', '172');
INSERT INTO public.who_global_data_import VALUES (52734, '2020-12-01', 'MR', 'Mauritania', 'AFRO', '0', '8424', '0', '172');
INSERT INTO public.who_global_data_import VALUES (52735, '2020-12-02', 'MR', 'Mauritania', 'AFRO', '0', '8424', '0', '172');
INSERT INTO public.who_global_data_import VALUES (52736, '2020-12-03', 'MR', 'Mauritania', 'AFRO', '0', '8424', '0', '172');
INSERT INTO public.who_global_data_import VALUES (52737, '2020-12-04', 'MR', 'Mauritania', 'AFRO', '0', '8424', '0', '172');
INSERT INTO public.who_global_data_import VALUES (52738, '2020-12-05', 'MR', 'Mauritania', 'AFRO', '0', '8424', '0', '172');
INSERT INTO public.who_global_data_import VALUES (52739, '2020-12-06', 'MR', 'Mauritania', 'AFRO', '0', '8424', '0', '172');
INSERT INTO public.who_global_data_import VALUES (52740, '2020-12-07', 'MR', 'Mauritania', 'AFRO', '0', '8424', '0', '172');
INSERT INTO public.who_global_data_import VALUES (52741, '2020-12-08', 'MR', 'Mauritania', 'AFRO', '1092', '9516', '16', '188');
INSERT INTO public.who_global_data_import VALUES (52742, '2020-12-09', 'MR', 'Mauritania', 'AFRO', '0', '9516', '0', '188');
INSERT INTO public.who_global_data_import VALUES (52743, '2020-12-10', 'MR', 'Mauritania', 'AFRO', '163', '9679', '6', '194');
INSERT INTO public.who_global_data_import VALUES (52744, '2020-12-11', 'MR', 'Mauritania', 'AFRO', '0', '9679', '0', '194');
INSERT INTO public.who_global_data_import VALUES (52745, '2020-12-12', 'MR', 'Mauritania', 'AFRO', '0', '9679', '0', '194');
INSERT INTO public.who_global_data_import VALUES (52746, '2020-12-13', 'MR', 'Mauritania', 'AFRO', '0', '9679', '0', '194');
INSERT INTO public.who_global_data_import VALUES (52747, '2020-12-14', 'MR', 'Mauritania', 'AFRO', '1292', '10971', '31', '225');
INSERT INTO public.who_global_data_import VALUES (52748, '2020-12-15', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52749, '2020-12-16', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52750, '2020-12-17', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52751, '2020-12-18', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52752, '2020-12-19', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52753, '2020-12-20', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52754, '2020-12-21', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52755, '2020-12-22', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52756, '2020-12-23', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52757, '2020-12-24', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52758, '2020-12-25', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52759, '2020-12-26', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52760, '2020-12-27', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52761, '2020-12-28', 'MR', 'Mauritania', 'AFRO', '0', '10971', '0', '225');
INSERT INTO public.who_global_data_import VALUES (52762, '2020-12-29', 'MR', 'Mauritania', 'AFRO', '2671', '13642', '99', '324');
INSERT INTO public.who_global_data_import VALUES (52763, '2020-12-30', 'MR', 'Mauritania', 'AFRO', '0', '13642', '0', '324');
INSERT INTO public.who_global_data_import VALUES (52764, '2020-12-31', 'MR', 'Mauritania', 'AFRO', '0', '13642', '0', '324');
INSERT INTO public.who_global_data_import VALUES (52765, '2021-01-01', 'MR', 'Mauritania', 'AFRO', '0', '13642', '0', '324');
INSERT INTO public.who_global_data_import VALUES (52766, '2021-01-02', 'MR', 'Mauritania', 'AFRO', '0', '13642', '0', '324');
INSERT INTO public.who_global_data_import VALUES (52767, '2021-01-03', 'MR', 'Mauritania', 'AFRO', '722', '14364', '23', '347');
INSERT INTO public.who_global_data_import VALUES (52768, '2021-01-04', 'MR', 'Mauritania', 'AFRO', '0', '14364', '0', '347');
INSERT INTO public.who_global_data_import VALUES (52769, '2021-01-05', 'MR', 'Mauritania', 'AFRO', '0', '14364', '0', '347');
INSERT INTO public.who_global_data_import VALUES (52770, '2021-01-06', 'MR', 'Mauritania', 'AFRO', '617', '14981', '20', '367');
INSERT INTO public.who_global_data_import VALUES (52771, '2021-01-07', 'MR', 'Mauritania', 'AFRO', '130', '15111', '6', '373');
INSERT INTO public.who_global_data_import VALUES (52772, '2021-01-08', 'MR', 'Mauritania', 'AFRO', '103', '15214', '5', '378');
INSERT INTO public.who_global_data_import VALUES (52773, '2021-01-09', 'MR', 'Mauritania', 'AFRO', '0', '15214', '0', '378');
INSERT INTO public.who_global_data_import VALUES (52774, '2021-01-10', 'MR', 'Mauritania', 'AFRO', '0', '15214', '0', '378');
INSERT INTO public.who_global_data_import VALUES (52775, '2021-01-11', 'MR', 'Mauritania', 'AFRO', '298', '15512', '6', '384');
INSERT INTO public.who_global_data_import VALUES (52776, '2021-01-12', 'MR', 'Mauritania', 'AFRO', '0', '15512', '0', '384');
INSERT INTO public.who_global_data_import VALUES (52777, '2021-01-13', 'MR', 'Mauritania', 'AFRO', '99', '15611', '3', '387');
INSERT INTO public.who_global_data_import VALUES (52778, '2021-01-14', 'MR', 'Mauritania', 'AFRO', '0', '15611', '0', '387');
INSERT INTO public.who_global_data_import VALUES (52779, '2021-01-15', 'MR', 'Mauritania', 'AFRO', '282', '15893', '9', '396');
INSERT INTO public.who_global_data_import VALUES (52780, '2021-01-16', 'MR', 'Mauritania', 'AFRO', '0', '15893', '0', '396');
INSERT INTO public.who_global_data_import VALUES (52781, '2021-01-17', 'MR', 'Mauritania', 'AFRO', '0', '15893', '0', '396');
INSERT INTO public.who_global_data_import VALUES (52782, '2021-01-18', 'MR', 'Mauritania', 'AFRO', '146', '16039', '6', '402');
INSERT INTO public.who_global_data_import VALUES (52783, '2021-01-19', 'MR', 'Mauritania', 'AFRO', '0', '16039', '0', '402');
INSERT INTO public.who_global_data_import VALUES (52784, '2021-01-20', 'MR', 'Mauritania', 'AFRO', '0', '16039', '0', '402');
INSERT INTO public.who_global_data_import VALUES (52785, '2021-01-21', 'MR', 'Mauritania', 'AFRO', '0', '16039', '0', '402');
INSERT INTO public.who_global_data_import VALUES (52786, '2021-01-22', 'MR', 'Mauritania', 'AFRO', '0', '16039', '0', '402');
INSERT INTO public.who_global_data_import VALUES (52787, '2021-01-23', 'MR', 'Mauritania', 'AFRO', '183', '16222', '8', '410');
INSERT INTO public.who_global_data_import VALUES (52788, '2021-01-24', 'MR', 'Mauritania', 'AFRO', '0', '16222', '0', '410');
INSERT INTO public.who_global_data_import VALUES (52789, '2021-01-25', 'MR', 'Mauritania', 'AFRO', '0', '16222', '0', '410');
INSERT INTO public.who_global_data_import VALUES (52790, '2021-01-26', 'MR', 'Mauritania', 'AFRO', '0', '16222', '0', '410');
INSERT INTO public.who_global_data_import VALUES (52791, '2021-01-27', 'MR', 'Mauritania', 'AFRO', '0', '16222', '0', '410');
INSERT INTO public.who_global_data_import VALUES (52792, '2021-01-28', 'MR', 'Mauritania', 'AFRO', '0', '16222', '0', '410');
INSERT INTO public.who_global_data_import VALUES (52793, '2021-01-29', 'MR', 'Mauritania', 'AFRO', '238', '16460', '8', '418');
INSERT INTO public.who_global_data_import VALUES (52794, '2021-01-30', 'MR', 'Mauritania', 'AFRO', '0', '16460', '0', '418');
INSERT INTO public.who_global_data_import VALUES (52795, '2021-01-31', 'MR', 'Mauritania', 'AFRO', '0', '16460', '0', '418');
INSERT INTO public.who_global_data_import VALUES (52796, '2021-02-01', 'MR', 'Mauritania', 'AFRO', '0', '16460', '0', '418');
INSERT INTO public.who_global_data_import VALUES (52797, '2021-02-02', 'MR', 'Mauritania', 'AFRO', '0', '16460', '0', '418');
INSERT INTO public.who_global_data_import VALUES (52798, '2021-02-03', 'MR', 'Mauritania', 'AFRO', '0', '16460', '0', '418');
INSERT INTO public.who_global_data_import VALUES (52799, '2021-02-04', 'MR', 'Mauritania', 'AFRO', '202', '16662', '4', '422');
INSERT INTO public.who_global_data_import VALUES (52800, '2021-02-05', 'MR', 'Mauritania', 'AFRO', '0', '16662', '0', '422');
INSERT INTO public.who_global_data_import VALUES (52801, '2020-01-03', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52802, '2020-01-04', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52803, '2020-01-05', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52804, '2020-01-06', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52805, '2020-01-07', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52806, '2020-01-08', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52807, '2020-01-09', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52808, '2020-01-10', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52809, '2020-01-11', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52810, '2020-01-12', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52811, '2020-01-13', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52812, '2020-01-14', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52813, '2020-01-15', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52814, '2020-01-16', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52815, '2020-01-17', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52816, '2020-01-18', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52817, '2020-01-19', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52818, '2020-01-20', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52819, '2020-01-21', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52820, '2020-01-22', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52821, '2020-01-23', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52822, '2020-01-24', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52823, '2020-01-25', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52824, '2020-01-26', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52825, '2020-01-27', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52826, '2020-01-28', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52827, '2020-01-29', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52828, '2020-01-30', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52829, '2020-01-31', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52830, '2020-02-01', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52831, '2020-02-02', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52832, '2020-02-03', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52833, '2020-02-04', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52834, '2020-02-05', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52835, '2020-02-06', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52836, '2020-02-07', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52837, '2020-02-08', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52838, '2020-02-09', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52839, '2020-02-10', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52840, '2020-02-11', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52841, '2020-02-12', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52842, '2020-02-13', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52843, '2020-02-14', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52844, '2020-02-15', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52845, '2020-02-16', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52846, '2020-02-17', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52847, '2020-02-18', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52848, '2020-02-19', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52849, '2020-02-20', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52850, '2020-02-21', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52851, '2020-02-22', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52852, '2020-02-23', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52853, '2020-02-24', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52854, '2020-02-25', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52855, '2020-02-26', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52856, '2020-02-27', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52857, '2020-02-28', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52858, '2020-02-29', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52859, '2020-03-01', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52860, '2020-03-02', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52861, '2020-03-03', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52862, '2020-03-04', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52863, '2020-03-05', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52864, '2020-03-06', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52865, '2020-03-07', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52866, '2020-03-08', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52867, '2020-03-09', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52868, '2020-03-10', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52869, '2020-03-11', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52870, '2020-03-12', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52871, '2020-03-13', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52872, '2020-03-14', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52873, '2020-03-15', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52874, '2020-03-16', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52875, '2020-03-17', 'MU', 'Mauritius', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52876, '2020-03-18', 'MU', 'Mauritius', 'AFRO', '7', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52877, '2020-03-19', 'MU', 'Mauritius', 'AFRO', '4', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52878, '2020-03-20', 'MU', 'Mauritius', 'AFRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52879, '2020-03-21', 'MU', 'Mauritius', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52880, '2020-03-22', 'MU', 'Mauritius', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52881, '2020-03-23', 'MU', 'Mauritius', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52882, '2020-03-24', 'MU', 'Mauritius', 'AFRO', '24', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (52883, '2020-03-25', 'MU', 'Mauritius', 'AFRO', '6', '42', '2', '2');
INSERT INTO public.who_global_data_import VALUES (52884, '2020-03-26', 'MU', 'Mauritius', 'AFRO', '5', '47', '0', '2');
INSERT INTO public.who_global_data_import VALUES (52885, '2020-03-27', 'MU', 'Mauritius', 'AFRO', '34', '81', '0', '2');
INSERT INTO public.who_global_data_import VALUES (52886, '2020-03-28', 'MU', 'Mauritius', 'AFRO', '15', '96', '0', '2');
INSERT INTO public.who_global_data_import VALUES (52887, '2020-03-29', 'MU', 'Mauritius', 'AFRO', '6', '102', '0', '2');
INSERT INTO public.who_global_data_import VALUES (52888, '2020-03-30', 'MU', 'Mauritius', 'AFRO', '0', '102', '0', '2');
INSERT INTO public.who_global_data_import VALUES (52889, '2020-03-31', 'MU', 'Mauritius', 'AFRO', '26', '128', '0', '2');
INSERT INTO public.who_global_data_import VALUES (52890, '2020-04-01', 'MU', 'Mauritius', 'AFRO', '15', '143', '3', '5');
INSERT INTO public.who_global_data_import VALUES (52891, '2020-04-02', 'MU', 'Mauritius', 'AFRO', '11', '154', '0', '5');
INSERT INTO public.who_global_data_import VALUES (52892, '2020-04-03', 'MU', 'Mauritius', 'AFRO', '15', '169', '2', '7');
INSERT INTO public.who_global_data_import VALUES (52893, '2020-04-04', 'MU', 'Mauritius', 'AFRO', '17', '186', '0', '7');
INSERT INTO public.who_global_data_import VALUES (52894, '2020-04-05', 'MU', 'Mauritius', 'AFRO', '10', '196', '0', '7');
INSERT INTO public.who_global_data_import VALUES (52895, '2020-04-06', 'MU', 'Mauritius', 'AFRO', '31', '227', '0', '7');
INSERT INTO public.who_global_data_import VALUES (52896, '2020-04-07', 'MU', 'Mauritius', 'AFRO', '17', '244', '0', '7');
INSERT INTO public.who_global_data_import VALUES (52897, '2020-04-08', 'MU', 'Mauritius', 'AFRO', '24', '268', '0', '7');
INSERT INTO public.who_global_data_import VALUES (52898, '2020-04-09', 'MU', 'Mauritius', 'AFRO', '5', '273', '0', '7');
INSERT INTO public.who_global_data_import VALUES (52899, '2020-04-10', 'MU', 'Mauritius', 'AFRO', '41', '314', '0', '7');
INSERT INTO public.who_global_data_import VALUES (52900, '2020-04-11', 'MU', 'Mauritius', 'AFRO', '4', '318', '2', '9');
INSERT INTO public.who_global_data_import VALUES (52901, '2020-04-12', 'MU', 'Mauritius', 'AFRO', '1', '319', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52902, '2020-04-13', 'MU', 'Mauritius', 'AFRO', '5', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52903, '2020-04-14', 'MU', 'Mauritius', 'AFRO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52904, '2020-04-15', 'MU', 'Mauritius', 'AFRO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52905, '2020-04-16', 'MU', 'Mauritius', 'AFRO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52906, '2020-04-17', 'MU', 'Mauritius', 'AFRO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52907, '2020-04-18', 'MU', 'Mauritius', 'AFRO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52908, '2020-04-19', 'MU', 'Mauritius', 'AFRO', '1', '325', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52909, '2020-04-20', 'MU', 'Mauritius', 'AFRO', '3', '328', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52910, '2020-04-21', 'MU', 'Mauritius', 'AFRO', '0', '328', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52911, '2020-04-22', 'MU', 'Mauritius', 'AFRO', '0', '328', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52912, '2020-04-23', 'MU', 'Mauritius', 'AFRO', '1', '329', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52913, '2020-04-24', 'MU', 'Mauritius', 'AFRO', '2', '331', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52914, '2020-04-25', 'MU', 'Mauritius', 'AFRO', '0', '331', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52915, '2020-04-26', 'MU', 'Mauritius', 'AFRO', '0', '331', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52916, '2020-04-27', 'MU', 'Mauritius', 'AFRO', '1', '332', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52917, '2020-04-28', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '9');
INSERT INTO public.who_global_data_import VALUES (52918, '2020-04-29', 'MU', 'Mauritius', 'AFRO', '0', '332', '1', '10');
INSERT INTO public.who_global_data_import VALUES (52919, '2020-04-30', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52920, '2020-05-01', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52921, '2020-05-02', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52922, '2020-05-03', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52923, '2020-05-04', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52924, '2020-05-05', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52925, '2020-05-06', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52926, '2020-05-07', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52927, '2020-05-08', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52928, '2020-05-09', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52929, '2020-05-10', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52930, '2020-05-11', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52931, '2020-05-12', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52932, '2020-05-13', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52933, '2020-05-14', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52934, '2020-05-15', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52935, '2020-05-16', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52936, '2020-05-17', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52937, '2020-05-18', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52938, '2020-05-19', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52939, '2020-05-20', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52940, '2020-05-21', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52941, '2020-05-22', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52942, '2020-05-23', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52943, '2020-05-24', 'MU', 'Mauritius', 'AFRO', '0', '332', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52944, '2020-05-25', 'MU', 'Mauritius', 'AFRO', '2', '334', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52945, '2020-05-26', 'MU', 'Mauritius', 'AFRO', '0', '334', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52946, '2020-05-27', 'MU', 'Mauritius', 'AFRO', '0', '334', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52947, '2020-05-28', 'MU', 'Mauritius', 'AFRO', '0', '334', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52948, '2020-05-29', 'MU', 'Mauritius', 'AFRO', '0', '334', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52949, '2020-05-30', 'MU', 'Mauritius', 'AFRO', '1', '335', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52950, '2020-05-31', 'MU', 'Mauritius', 'AFRO', '0', '335', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52951, '2020-06-01', 'MU', 'Mauritius', 'AFRO', '0', '335', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52952, '2020-06-02', 'MU', 'Mauritius', 'AFRO', '0', '335', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52953, '2020-06-03', 'MU', 'Mauritius', 'AFRO', '0', '335', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52954, '2020-06-04', 'MU', 'Mauritius', 'AFRO', '0', '335', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52955, '2020-06-05', 'MU', 'Mauritius', 'AFRO', '0', '335', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52956, '2020-06-06', 'MU', 'Mauritius', 'AFRO', '2', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52957, '2020-06-07', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52958, '2020-06-08', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52959, '2020-06-09', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52960, '2020-06-10', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52961, '2020-06-11', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52962, '2020-06-12', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52963, '2020-06-13', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52964, '2020-06-14', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52965, '2020-06-15', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52966, '2020-06-16', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52967, '2020-06-17', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52968, '2020-06-18', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52969, '2020-06-19', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52970, '2020-06-20', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52971, '2020-06-21', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52972, '2020-06-22', 'MU', 'Mauritius', 'AFRO', '0', '337', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52973, '2020-06-23', 'MU', 'Mauritius', 'AFRO', '3', '340', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52974, '2020-06-24', 'MU', 'Mauritius', 'AFRO', '0', '340', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52975, '2020-06-25', 'MU', 'Mauritius', 'AFRO', '1', '341', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52976, '2020-06-26', 'MU', 'Mauritius', 'AFRO', '0', '341', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52977, '2020-06-27', 'MU', 'Mauritius', 'AFRO', '0', '341', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52978, '2020-06-28', 'MU', 'Mauritius', 'AFRO', '0', '341', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52979, '2020-06-29', 'MU', 'Mauritius', 'AFRO', '0', '341', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52980, '2020-06-30', 'MU', 'Mauritius', 'AFRO', '0', '341', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52981, '2020-07-01', 'MU', 'Mauritius', 'AFRO', '0', '341', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52982, '2020-07-02', 'MU', 'Mauritius', 'AFRO', '0', '341', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52983, '2020-07-03', 'MU', 'Mauritius', 'AFRO', '0', '341', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52984, '2020-07-04', 'MU', 'Mauritius', 'AFRO', '0', '341', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52985, '2020-07-05', 'MU', 'Mauritius', 'AFRO', '0', '341', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52986, '2020-07-06', 'MU', 'Mauritius', 'AFRO', '0', '341', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52987, '2020-07-07', 'MU', 'Mauritius', 'AFRO', '1', '342', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52988, '2020-07-08', 'MU', 'Mauritius', 'AFRO', '0', '342', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52989, '2020-07-09', 'MU', 'Mauritius', 'AFRO', '0', '342', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52990, '2020-07-10', 'MU', 'Mauritius', 'AFRO', '0', '342', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52991, '2020-07-11', 'MU', 'Mauritius', 'AFRO', '0', '342', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52992, '2020-07-12', 'MU', 'Mauritius', 'AFRO', '0', '342', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52993, '2020-07-13', 'MU', 'Mauritius', 'AFRO', '0', '342', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52994, '2020-07-14', 'MU', 'Mauritius', 'AFRO', '1', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52995, '2020-07-15', 'MU', 'Mauritius', 'AFRO', '0', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52996, '2020-07-16', 'MU', 'Mauritius', 'AFRO', '0', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52997, '2020-07-17', 'MU', 'Mauritius', 'AFRO', '0', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52998, '2020-07-18', 'MU', 'Mauritius', 'AFRO', '0', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (52999, '2020-07-19', 'MU', 'Mauritius', 'AFRO', '0', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53000, '2020-07-20', 'MU', 'Mauritius', 'AFRO', '0', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53001, '2020-07-21', 'MU', 'Mauritius', 'AFRO', '0', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53002, '2020-07-22', 'MU', 'Mauritius', 'AFRO', '0', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53003, '2020-07-23', 'MU', 'Mauritius', 'AFRO', '0', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53004, '2020-07-24', 'MU', 'Mauritius', 'AFRO', '0', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53005, '2020-07-25', 'MU', 'Mauritius', 'AFRO', '1', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53006, '2020-07-26', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53007, '2020-07-27', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53008, '2020-07-28', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53009, '2020-07-29', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53010, '2020-07-30', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53011, '2020-07-31', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53012, '2020-08-01', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53013, '2020-08-02', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53014, '2020-08-03', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53015, '2020-08-04', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53016, '2020-08-05', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53017, '2020-08-06', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53018, '2020-08-07', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53019, '2020-08-08', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53020, '2020-08-09', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53021, '2020-08-10', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53022, '2020-08-11', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53023, '2020-08-12', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53024, '2020-08-13', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53025, '2020-08-14', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53026, '2020-08-15', 'MU', 'Mauritius', 'AFRO', '0', '344', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53027, '2020-08-16', 'MU', 'Mauritius', 'AFRO', '2', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53028, '2020-08-17', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53029, '2020-08-18', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53030, '2020-08-19', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53031, '2020-08-20', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53032, '2020-08-21', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53033, '2020-08-22', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53034, '2020-08-23', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53035, '2020-08-24', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53036, '2020-08-25', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53037, '2020-08-26', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53038, '2020-08-27', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53039, '2020-08-28', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53040, '2020-08-29', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53041, '2020-08-30', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53042, '2020-08-31', 'MU', 'Mauritius', 'AFRO', '0', '346', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53043, '2020-09-01', 'MU', 'Mauritius', 'AFRO', '10', '356', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53044, '2020-09-02', 'MU', 'Mauritius', 'AFRO', '0', '356', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53045, '2020-09-03', 'MU', 'Mauritius', 'AFRO', '0', '356', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53046, '2020-09-04', 'MU', 'Mauritius', 'AFRO', '0', '356', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53047, '2020-09-05', 'MU', 'Mauritius', 'AFRO', '0', '356', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53048, '2020-09-06', 'MU', 'Mauritius', 'AFRO', '0', '356', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53049, '2020-09-07', 'MU', 'Mauritius', 'AFRO', '0', '356', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53050, '2020-09-08', 'MU', 'Mauritius', 'AFRO', '0', '356', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53051, '2020-09-09', 'MU', 'Mauritius', 'AFRO', '1', '357', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53052, '2020-09-10', 'MU', 'Mauritius', 'AFRO', '0', '357', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53053, '2020-09-11', 'MU', 'Mauritius', 'AFRO', '4', '361', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53054, '2020-09-12', 'MU', 'Mauritius', 'AFRO', '0', '361', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53055, '2020-09-13', 'MU', 'Mauritius', 'AFRO', '0', '361', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53056, '2020-09-14', 'MU', 'Mauritius', 'AFRO', '0', '361', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53057, '2020-09-15', 'MU', 'Mauritius', 'AFRO', '1', '362', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53058, '2020-09-16', 'MU', 'Mauritius', 'AFRO', '3', '365', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53059, '2020-09-17', 'MU', 'Mauritius', 'AFRO', '0', '365', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53060, '2020-09-18', 'MU', 'Mauritius', 'AFRO', '1', '366', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53061, '2020-09-19', 'MU', 'Mauritius', 'AFRO', '1', '367', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53062, '2020-09-20', 'MU', 'Mauritius', 'AFRO', '0', '367', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53063, '2020-09-21', 'MU', 'Mauritius', 'AFRO', '0', '367', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53064, '2020-09-22', 'MU', 'Mauritius', 'AFRO', '0', '367', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53065, '2020-09-23', 'MU', 'Mauritius', 'AFRO', '0', '367', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53066, '2020-09-24', 'MU', 'Mauritius', 'AFRO', '0', '367', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53067, '2020-09-25', 'MU', 'Mauritius', 'AFRO', '0', '367', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53068, '2020-09-26', 'MU', 'Mauritius', 'AFRO', '0', '367', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53069, '2020-09-27', 'MU', 'Mauritius', 'AFRO', '0', '367', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53070, '2020-09-28', 'MU', 'Mauritius', 'AFRO', '0', '367', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53071, '2020-09-29', 'MU', 'Mauritius', 'AFRO', '3', '370', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53072, '2020-09-30', 'MU', 'Mauritius', 'AFRO', '11', '381', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53073, '2020-10-01', 'MU', 'Mauritius', 'AFRO', '0', '381', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53074, '2020-10-02', 'MU', 'Mauritius', 'AFRO', '0', '381', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53075, '2020-10-03', 'MU', 'Mauritius', 'AFRO', '0', '381', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53076, '2020-10-04', 'MU', 'Mauritius', 'AFRO', '0', '381', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53077, '2020-10-05', 'MU', 'Mauritius', 'AFRO', '4', '385', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53078, '2020-10-06', 'MU', 'Mauritius', 'AFRO', '2', '387', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53079, '2020-10-07', 'MU', 'Mauritius', 'AFRO', '8', '395', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53080, '2020-10-08', 'MU', 'Mauritius', 'AFRO', '0', '395', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53081, '2020-10-09', 'MU', 'Mauritius', 'AFRO', '0', '395', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53082, '2020-10-10', 'MU', 'Mauritius', 'AFRO', '0', '395', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53083, '2020-10-11', 'MU', 'Mauritius', 'AFRO', '0', '395', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53084, '2020-10-12', 'MU', 'Mauritius', 'AFRO', '0', '395', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53085, '2020-10-13', 'MU', 'Mauritius', 'AFRO', '9', '404', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53086, '2020-10-14', 'MU', 'Mauritius', 'AFRO', '0', '404', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53087, '2020-10-15', 'MU', 'Mauritius', 'AFRO', '0', '404', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53088, '2020-10-16', 'MU', 'Mauritius', 'AFRO', '0', '404', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53089, '2020-10-17', 'MU', 'Mauritius', 'AFRO', '3', '407', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53090, '2020-10-18', 'MU', 'Mauritius', 'AFRO', '0', '407', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53091, '2020-10-19', 'MU', 'Mauritius', 'AFRO', '0', '407', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53092, '2020-10-20', 'MU', 'Mauritius', 'AFRO', '0', '407', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53093, '2020-10-21', 'MU', 'Mauritius', 'AFRO', '14', '421', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53094, '2020-10-22', 'MU', 'Mauritius', 'AFRO', '0', '421', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53095, '2020-10-23', 'MU', 'Mauritius', 'AFRO', '0', '421', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53096, '2020-10-24', 'MU', 'Mauritius', 'AFRO', '14', '435', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53097, '2020-10-25', 'MU', 'Mauritius', 'AFRO', '0', '435', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53098, '2020-10-26', 'MU', 'Mauritius', 'AFRO', '0', '435', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53099, '2020-10-27', 'MU', 'Mauritius', 'AFRO', '4', '439', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53100, '2020-10-28', 'MU', 'Mauritius', 'AFRO', '0', '439', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53101, '2020-10-29', 'MU', 'Mauritius', 'AFRO', '2', '441', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53102, '2020-10-30', 'MU', 'Mauritius', 'AFRO', '0', '441', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53103, '2020-10-31', 'MU', 'Mauritius', 'AFRO', '0', '441', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53104, '2020-11-01', 'MU', 'Mauritius', 'AFRO', '0', '441', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53105, '2020-11-02', 'MU', 'Mauritius', 'AFRO', '0', '441', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53106, '2020-11-03', 'MU', 'Mauritius', 'AFRO', '11', '452', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53107, '2020-11-04', 'MU', 'Mauritius', 'AFRO', '0', '452', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53108, '2020-11-05', 'MU', 'Mauritius', 'AFRO', '0', '452', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53109, '2020-11-06', 'MU', 'Mauritius', 'AFRO', '0', '452', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53110, '2020-11-07', 'MU', 'Mauritius', 'AFRO', '0', '452', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53111, '2020-11-08', 'MU', 'Mauritius', 'AFRO', '0', '452', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53112, '2020-11-09', 'MU', 'Mauritius', 'AFRO', '0', '452', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53113, '2020-11-10', 'MU', 'Mauritius', 'AFRO', '3', '455', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53114, '2020-11-11', 'MU', 'Mauritius', 'AFRO', '12', '467', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53115, '2020-11-12', 'MU', 'Mauritius', 'AFRO', '0', '467', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53116, '2020-11-13', 'MU', 'Mauritius', 'AFRO', '3', '470', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53117, '2020-11-14', 'MU', 'Mauritius', 'AFRO', '0', '470', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53118, '2020-11-15', 'MU', 'Mauritius', 'AFRO', '0', '470', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53119, '2020-11-16', 'MU', 'Mauritius', 'AFRO', '0', '470', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53120, '2020-11-17', 'MU', 'Mauritius', 'AFRO', '21', '491', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53121, '2020-11-18', 'MU', 'Mauritius', 'AFRO', '0', '491', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53122, '2020-11-19', 'MU', 'Mauritius', 'AFRO', '0', '491', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53123, '2020-11-20', 'MU', 'Mauritius', 'AFRO', '0', '491', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53124, '2020-11-21', 'MU', 'Mauritius', 'AFRO', '0', '491', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53125, '2020-11-22', 'MU', 'Mauritius', 'AFRO', '0', '491', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53126, '2020-11-23', 'MU', 'Mauritius', 'AFRO', '0', '491', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53127, '2020-11-24', 'MU', 'Mauritius', 'AFRO', '0', '491', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53128, '2020-11-25', 'MU', 'Mauritius', 'AFRO', '6', '497', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53129, '2020-11-26', 'MU', 'Mauritius', 'AFRO', '0', '497', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53130, '2020-11-27', 'MU', 'Mauritius', 'AFRO', '0', '497', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53131, '2020-11-28', 'MU', 'Mauritius', 'AFRO', '4', '501', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53132, '2020-11-29', 'MU', 'Mauritius', 'AFRO', '0', '501', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53133, '2020-11-30', 'MU', 'Mauritius', 'AFRO', '0', '501', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53134, '2020-12-01', 'MU', 'Mauritius', 'AFRO', '3', '504', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53135, '2020-12-02', 'MU', 'Mauritius', 'AFRO', '1', '505', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53136, '2020-12-03', 'MU', 'Mauritius', 'AFRO', '0', '505', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53137, '2020-12-04', 'MU', 'Mauritius', 'AFRO', '0', '505', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53138, '2020-12-05', 'MU', 'Mauritius', 'AFRO', '0', '505', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53139, '2020-12-06', 'MU', 'Mauritius', 'AFRO', '0', '505', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53140, '2020-12-07', 'MU', 'Mauritius', 'AFRO', '0', '505', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53141, '2020-12-08', 'MU', 'Mauritius', 'AFRO', '0', '505', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53142, '2020-12-09', 'MU', 'Mauritius', 'AFRO', '0', '505', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53143, '2020-12-10', 'MU', 'Mauritius', 'AFRO', '9', '514', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53144, '2020-12-11', 'MU', 'Mauritius', 'AFRO', '0', '514', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53145, '2020-12-12', 'MU', 'Mauritius', 'AFRO', '0', '514', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53146, '2020-12-13', 'MU', 'Mauritius', 'AFRO', '0', '514', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53147, '2020-12-14', 'MU', 'Mauritius', 'AFRO', '0', '514', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53148, '2020-12-15', 'MU', 'Mauritius', 'AFRO', '0', '514', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53149, '2020-12-16', 'MU', 'Mauritius', 'AFRO', '0', '514', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53150, '2020-12-17', 'MU', 'Mauritius', 'AFRO', '0', '514', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53151, '2020-12-18', 'MU', 'Mauritius', 'AFRO', '10', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53152, '2020-12-19', 'MU', 'Mauritius', 'AFRO', '0', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53153, '2020-12-20', 'MU', 'Mauritius', 'AFRO', '0', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53154, '2020-12-21', 'MU', 'Mauritius', 'AFRO', '0', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53155, '2020-12-22', 'MU', 'Mauritius', 'AFRO', '0', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53156, '2020-12-23', 'MU', 'Mauritius', 'AFRO', '0', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53157, '2020-12-24', 'MU', 'Mauritius', 'AFRO', '0', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53158, '2020-12-25', 'MU', 'Mauritius', 'AFRO', '0', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53159, '2020-12-26', 'MU', 'Mauritius', 'AFRO', '0', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53160, '2020-12-27', 'MU', 'Mauritius', 'AFRO', '0', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53161, '2020-12-28', 'MU', 'Mauritius', 'AFRO', '0', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53162, '2020-12-29', 'MU', 'Mauritius', 'AFRO', '0', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53163, '2020-12-30', 'MU', 'Mauritius', 'AFRO', '0', '524', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53164, '2020-12-31', 'MU', 'Mauritius', 'AFRO', '3', '527', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53165, '2021-01-01', 'MU', 'Mauritius', 'AFRO', '0', '527', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53166, '2021-01-02', 'MU', 'Mauritius', 'AFRO', '0', '527', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53167, '2021-01-03', 'MU', 'Mauritius', 'AFRO', '0', '527', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53168, '2021-01-04', 'MU', 'Mauritius', 'AFRO', '0', '527', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53169, '2021-01-05', 'MU', 'Mauritius', 'AFRO', '4', '531', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53170, '2021-01-06', 'MU', 'Mauritius', 'AFRO', '0', '531', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53171, '2021-01-07', 'MU', 'Mauritius', 'AFRO', '0', '531', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53172, '2021-01-08', 'MU', 'Mauritius', 'AFRO', '8', '539', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53173, '2021-01-09', 'MU', 'Mauritius', 'AFRO', '0', '539', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53174, '2021-01-10', 'MU', 'Mauritius', 'AFRO', '0', '539', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53175, '2021-01-11', 'MU', 'Mauritius', 'AFRO', '0', '539', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53176, '2021-01-12', 'MU', 'Mauritius', 'AFRO', '6', '545', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53177, '2021-01-13', 'MU', 'Mauritius', 'AFRO', '1', '546', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53178, '2021-01-14', 'MU', 'Mauritius', 'AFRO', '0', '546', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53179, '2021-01-15', 'MU', 'Mauritius', 'AFRO', '0', '546', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53180, '2021-01-16', 'MU', 'Mauritius', 'AFRO', '1', '547', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53181, '2021-01-17', 'MU', 'Mauritius', 'AFRO', '0', '547', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53182, '2021-01-18', 'MU', 'Mauritius', 'AFRO', '0', '547', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53183, '2021-01-19', 'MU', 'Mauritius', 'AFRO', '0', '547', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53184, '2021-01-20', 'MU', 'Mauritius', 'AFRO', '9', '556', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53185, '2021-01-21', 'MU', 'Mauritius', 'AFRO', '0', '556', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53186, '2021-01-22', 'MU', 'Mauritius', 'AFRO', '0', '556', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53187, '2021-01-23', 'MU', 'Mauritius', 'AFRO', '0', '556', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53188, '2021-01-24', 'MU', 'Mauritius', 'AFRO', '0', '556', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53189, '2021-01-25', 'MU', 'Mauritius', 'AFRO', '0', '556', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53190, '2021-01-26', 'MU', 'Mauritius', 'AFRO', '12', '568', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53191, '2021-01-27', 'MU', 'Mauritius', 'AFRO', '0', '568', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53192, '2021-01-28', 'MU', 'Mauritius', 'AFRO', '0', '568', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53193, '2021-01-29', 'MU', 'Mauritius', 'AFRO', '0', '568', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53194, '2021-01-30', 'MU', 'Mauritius', 'AFRO', '0', '568', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53195, '2021-01-31', 'MU', 'Mauritius', 'AFRO', '0', '568', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53196, '2021-02-01', 'MU', 'Mauritius', 'AFRO', '0', '568', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53197, '2021-02-02', 'MU', 'Mauritius', 'AFRO', '0', '568', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53198, '2021-02-03', 'MU', 'Mauritius', 'AFRO', '15', '583', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53199, '2021-02-04', 'MU', 'Mauritius', 'AFRO', '1', '584', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53200, '2021-02-05', 'MU', 'Mauritius', 'AFRO', '0', '584', '0', '10');
INSERT INTO public.who_global_data_import VALUES (53201, '2020-01-03', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53202, '2020-01-04', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53203, '2020-01-05', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53204, '2020-01-06', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53205, '2020-01-07', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53206, '2020-01-08', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53207, '2020-01-09', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53208, '2020-01-10', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53209, '2020-01-11', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53210, '2020-01-12', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53211, '2020-01-13', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53212, '2020-01-14', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53213, '2020-01-15', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53214, '2020-01-16', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53215, '2020-01-17', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53216, '2020-01-18', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53217, '2020-01-19', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53218, '2020-01-20', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53219, '2020-01-21', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53220, '2020-01-22', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53221, '2020-01-23', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53222, '2020-01-24', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53223, '2020-01-25', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53224, '2020-01-26', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53225, '2020-01-27', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53226, '2020-01-28', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53227, '2020-01-29', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53228, '2020-01-30', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53229, '2020-01-31', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53230, '2020-02-01', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53231, '2020-02-02', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53232, '2020-02-03', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53233, '2020-02-04', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53234, '2020-02-05', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53235, '2020-02-06', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53236, '2020-02-07', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53238, '2020-02-09', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53239, '2020-02-10', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53240, '2020-02-11', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53241, '2020-02-12', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53242, '2020-02-13', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53243, '2020-02-14', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53244, '2020-02-15', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53245, '2020-02-16', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53246, '2020-02-17', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53247, '2020-02-18', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53248, '2020-02-19', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53249, '2020-02-20', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53250, '2020-02-21', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53251, '2020-02-22', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53252, '2020-02-23', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53253, '2020-02-24', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53254, '2020-02-25', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53255, '2020-02-26', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53256, '2020-02-27', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53257, '2020-02-28', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53258, '2020-02-29', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53259, '2020-03-01', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53260, '2020-03-02', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53261, '2020-03-03', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53262, '2020-03-04', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53263, '2020-03-05', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53264, '2020-03-06', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53265, '2020-03-07', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53266, '2020-03-08', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53267, '2020-03-09', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53268, '2020-03-10', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53269, '2020-03-11', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53270, '2020-03-12', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53271, '2020-03-13', 'YT', 'Mayotte', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53272, '2020-03-14', 'YT', 'Mayotte', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53273, '2020-03-15', 'YT', 'Mayotte', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53274, '2020-03-16', 'YT', 'Mayotte', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53275, '2020-03-17', 'YT', 'Mayotte', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53276, '2020-03-18', 'YT', 'Mayotte', 'AFRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53277, '2020-03-19', 'YT', 'Mayotte', 'AFRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53278, '2020-03-20', 'YT', 'Mayotte', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53279, '2020-03-21', 'YT', 'Mayotte', 'AFRO', '3', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53280, '2020-03-22', 'YT', 'Mayotte', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53281, '2020-03-23', 'YT', 'Mayotte', 'AFRO', '3', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53282, '2020-03-24', 'YT', 'Mayotte', 'AFRO', '10', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53283, '2020-03-25', 'YT', 'Mayotte', 'AFRO', '6', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53284, '2020-03-26', 'YT', 'Mayotte', 'AFRO', '5', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53285, '2020-03-27', 'YT', 'Mayotte', 'AFRO', '15', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53286, '2020-03-28', 'YT', 'Mayotte', 'AFRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53287, '2020-03-29', 'YT', 'Mayotte', 'AFRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53288, '2020-03-30', 'YT', 'Mayotte', 'AFRO', '32', '82', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53289, '2020-03-31', 'YT', 'Mayotte', 'AFRO', '0', '82', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53290, '2020-04-01', 'YT', 'Mayotte', 'AFRO', '19', '101', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53291, '2020-04-02', 'YT', 'Mayotte', 'AFRO', '15', '116', '2', '2');
INSERT INTO public.who_global_data_import VALUES (53292, '2020-04-03', 'YT', 'Mayotte', 'AFRO', '12', '128', '0', '2');
INSERT INTO public.who_global_data_import VALUES (53293, '2020-04-04', 'YT', 'Mayotte', 'AFRO', '0', '128', '0', '2');
INSERT INTO public.who_global_data_import VALUES (53294, '2020-04-05', 'YT', 'Mayotte', 'AFRO', '19', '147', '0', '2');
INSERT INTO public.who_global_data_import VALUES (53295, '2020-04-06', 'YT', 'Mayotte', 'AFRO', '0', '147', '0', '2');
INSERT INTO public.who_global_data_import VALUES (53296, '2020-04-07', 'YT', 'Mayotte', 'AFRO', '17', '164', '0', '2');
INSERT INTO public.who_global_data_import VALUES (53297, '2020-04-08', 'YT', 'Mayotte', 'AFRO', '20', '184', '0', '2');
INSERT INTO public.who_global_data_import VALUES (53298, '2020-04-09', 'YT', 'Mayotte', 'AFRO', '2', '186', '0', '2');
INSERT INTO public.who_global_data_import VALUES (53299, '2020-04-10', 'YT', 'Mayotte', 'AFRO', '5', '191', '0', '2');
INSERT INTO public.who_global_data_import VALUES (53300, '2020-04-11', 'YT', 'Mayotte', 'AFRO', '0', '191', '0', '2');
INSERT INTO public.who_global_data_import VALUES (53301, '2020-04-12', 'YT', 'Mayotte', 'AFRO', '0', '191', '0', '2');
INSERT INTO public.who_global_data_import VALUES (53302, '2020-04-13', 'YT', 'Mayotte', 'AFRO', '16', '207', '1', '3');
INSERT INTO public.who_global_data_import VALUES (53303, '2020-04-14', 'YT', 'Mayotte', 'AFRO', '0', '207', '0', '3');
INSERT INTO public.who_global_data_import VALUES (53304, '2020-04-15', 'YT', 'Mayotte', 'AFRO', '10', '217', '0', '3');
INSERT INTO public.who_global_data_import VALUES (53305, '2020-04-16', 'YT', 'Mayotte', 'AFRO', '4', '221', '0', '3');
INSERT INTO public.who_global_data_import VALUES (53306, '2020-04-17', 'YT', 'Mayotte', 'AFRO', '12', '233', '0', '3');
INSERT INTO public.who_global_data_import VALUES (53307, '2020-04-18', 'YT', 'Mayotte', 'AFRO', '12', '245', '1', '4');
INSERT INTO public.who_global_data_import VALUES (53308, '2020-04-19', 'YT', 'Mayotte', 'AFRO', '0', '245', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53309, '2020-04-20', 'YT', 'Mayotte', 'AFRO', '39', '284', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53310, '2020-04-21', 'YT', 'Mayotte', 'AFRO', '0', '284', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53311, '2020-04-22', 'YT', 'Mayotte', 'AFRO', '27', '311', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53312, '2020-04-23', 'YT', 'Mayotte', 'AFRO', '15', '326', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53313, '2020-04-24', 'YT', 'Mayotte', 'AFRO', '13', '339', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53314, '2020-04-25', 'YT', 'Mayotte', 'AFRO', '15', '354', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53315, '2020-04-26', 'YT', 'Mayotte', 'AFRO', '0', '354', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53316, '2020-04-27', 'YT', 'Mayotte', 'AFRO', '47', '401', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53317, '2020-04-28', 'YT', 'Mayotte', 'AFRO', '32', '433', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53318, '2020-04-29', 'YT', 'Mayotte', 'AFRO', '27', '460', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53319, '2020-04-30', 'YT', 'Mayotte', 'AFRO', '0', '460', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53320, '2020-05-01', 'YT', 'Mayotte', 'AFRO', '79', '539', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53321, '2020-05-02', 'YT', 'Mayotte', 'AFRO', '0', '539', '0', '4');
INSERT INTO public.who_global_data_import VALUES (53322, '2020-05-03', 'YT', 'Mayotte', 'AFRO', '57', '596', '2', '6');
INSERT INTO public.who_global_data_import VALUES (53323, '2020-05-04', 'YT', 'Mayotte', 'AFRO', '54', '650', '0', '6');
INSERT INTO public.who_global_data_import VALUES (53324, '2020-05-05', 'YT', 'Mayotte', 'AFRO', '36', '686', '0', '6');
INSERT INTO public.who_global_data_import VALUES (53325, '2020-05-06', 'YT', 'Mayotte', 'AFRO', '53', '739', '3', '9');
INSERT INTO public.who_global_data_import VALUES (53326, '2020-05-07', 'YT', 'Mayotte', 'AFRO', '0', '739', '0', '9');
INSERT INTO public.who_global_data_import VALUES (53327, '2020-05-08', 'YT', 'Mayotte', 'AFRO', '115', '854', '1', '10');
INSERT INTO public.who_global_data_import VALUES (53328, '2020-05-09', 'YT', 'Mayotte', 'AFRO', '36', '890', '1', '11');
INSERT INTO public.who_global_data_import VALUES (53329, '2020-05-10', 'YT', 'Mayotte', 'AFRO', '0', '890', '0', '11');
INSERT INTO public.who_global_data_import VALUES (53330, '2020-05-11', 'YT', 'Mayotte', 'AFRO', '133', '1023', '0', '11');
INSERT INTO public.who_global_data_import VALUES (53331, '2020-05-12', 'YT', 'Mayotte', 'AFRO', '38', '1061', '1', '12');
INSERT INTO public.who_global_data_import VALUES (53332, '2020-05-13', 'YT', 'Mayotte', 'AFRO', '34', '1095', '0', '12');
INSERT INTO public.who_global_data_import VALUES (53333, '2020-05-14', 'YT', 'Mayotte', 'AFRO', '48', '1143', '2', '14');
INSERT INTO public.who_global_data_import VALUES (53334, '2020-05-15', 'YT', 'Mayotte', 'AFRO', '67', '1210', '2', '16');
INSERT INTO public.who_global_data_import VALUES (53335, '2020-05-16', 'YT', 'Mayotte', 'AFRO', '48', '1258', '0', '16');
INSERT INTO public.who_global_data_import VALUES (53336, '2020-05-17', 'YT', 'Mayotte', 'AFRO', '0', '1258', '0', '16');
INSERT INTO public.who_global_data_import VALUES (53337, '2020-05-18', 'YT', 'Mayotte', 'AFRO', '84', '1342', '2', '18');
INSERT INTO public.who_global_data_import VALUES (53338, '2020-05-19', 'YT', 'Mayotte', 'AFRO', '28', '1370', '0', '18');
INSERT INTO public.who_global_data_import VALUES (53339, '2020-05-20', 'YT', 'Mayotte', 'AFRO', '49', '1419', '1', '19');
INSERT INTO public.who_global_data_import VALUES (53340, '2020-05-21', 'YT', 'Mayotte', 'AFRO', '56', '1475', '0', '19');
INSERT INTO public.who_global_data_import VALUES (53341, '2020-05-22', 'YT', 'Mayotte', 'AFRO', '19', '1494', '0', '19');
INSERT INTO public.who_global_data_import VALUES (53342, '2020-05-23', 'YT', 'Mayotte', 'AFRO', '27', '1521', '0', '19');
INSERT INTO public.who_global_data_import VALUES (53343, '2020-05-24', 'YT', 'Mayotte', 'AFRO', '0', '1521', '0', '19');
INSERT INTO public.who_global_data_import VALUES (53344, '2020-05-25', 'YT', 'Mayotte', 'AFRO', '66', '1587', '1', '20');
INSERT INTO public.who_global_data_import VALUES (53345, '2020-05-26', 'YT', 'Mayotte', 'AFRO', '22', '1609', '0', '20');
INSERT INTO public.who_global_data_import VALUES (53346, '2020-05-27', 'YT', 'Mayotte', 'AFRO', '25', '1634', '0', '20');
INSERT INTO public.who_global_data_import VALUES (53347, '2020-05-28', 'YT', 'Mayotte', 'AFRO', '11', '1645', '0', '20');
INSERT INTO public.who_global_data_import VALUES (53348, '2020-05-29', 'YT', 'Mayotte', 'AFRO', '25', '1670', '1', '21');
INSERT INTO public.who_global_data_import VALUES (53349, '2020-05-30', 'YT', 'Mayotte', 'AFRO', '29', '1699', '0', '21');
INSERT INTO public.who_global_data_import VALUES (53350, '2020-05-31', 'YT', 'Mayotte', 'AFRO', '44', '1743', '0', '21');
INSERT INTO public.who_global_data_import VALUES (53351, '2020-06-01', 'YT', 'Mayotte', 'AFRO', '128', '1871', '2', '23');
INSERT INTO public.who_global_data_import VALUES (53352, '2020-06-02', 'YT', 'Mayotte', 'AFRO', '63', '1934', '1', '24');
INSERT INTO public.who_global_data_import VALUES (53353, '2020-06-03', 'YT', 'Mayotte', 'AFRO', '52', '1986', '0', '24');
INSERT INTO public.who_global_data_import VALUES (53354, '2020-06-04', 'YT', 'Mayotte', 'AFRO', '7', '1993', '0', '24');
INSERT INTO public.who_global_data_import VALUES (53355, '2020-06-05', 'YT', 'Mayotte', 'AFRO', '65', '2058', '1', '25');
INSERT INTO public.who_global_data_import VALUES (53356, '2020-06-06', 'YT', 'Mayotte', 'AFRO', '21', '2079', '0', '25');
INSERT INTO public.who_global_data_import VALUES (53357, '2020-06-07', 'YT', 'Mayotte', 'AFRO', '0', '2079', '0', '25');
INSERT INTO public.who_global_data_import VALUES (53358, '2020-06-08', 'YT', 'Mayotte', 'AFRO', '0', '2079', '0', '25');
INSERT INTO public.who_global_data_import VALUES (53359, '2020-06-09', 'YT', 'Mayotte', 'AFRO', '72', '2151', '1', '26');
INSERT INTO public.who_global_data_import VALUES (53360, '2020-06-10', 'YT', 'Mayotte', 'AFRO', '24', '2175', '2', '28');
INSERT INTO public.who_global_data_import VALUES (53361, '2020-06-11', 'YT', 'Mayotte', 'AFRO', '31', '2206', '0', '28');
INSERT INTO public.who_global_data_import VALUES (53362, '2020-06-12', 'YT', 'Mayotte', 'AFRO', '34', '2240', '0', '28');
INSERT INTO public.who_global_data_import VALUES (53363, '2020-06-13', 'YT', 'Mayotte', 'AFRO', '28', '2268', '0', '28');
INSERT INTO public.who_global_data_import VALUES (53364, '2020-06-14', 'YT', 'Mayotte', 'AFRO', '14', '2282', '1', '29');
INSERT INTO public.who_global_data_import VALUES (53365, '2020-06-15', 'YT', 'Mayotte', 'AFRO', '0', '2282', '0', '29');
INSERT INTO public.who_global_data_import VALUES (53366, '2020-06-16', 'YT', 'Mayotte', 'AFRO', '28', '2310', '-1', '28');
INSERT INTO public.who_global_data_import VALUES (53367, '2020-06-17', 'YT', 'Mayotte', 'AFRO', '23', '2333', '1', '29');
INSERT INTO public.who_global_data_import VALUES (53368, '2020-06-18', 'YT', 'Mayotte', 'AFRO', '12', '2345', '0', '29');
INSERT INTO public.who_global_data_import VALUES (53369, '2020-06-19', 'YT', 'Mayotte', 'AFRO', '38', '2383', '0', '29');
INSERT INTO public.who_global_data_import VALUES (53370, '2020-06-20', 'YT', 'Mayotte', 'AFRO', '11', '2394', '0', '29');
INSERT INTO public.who_global_data_import VALUES (53371, '2020-06-21', 'YT', 'Mayotte', 'AFRO', '10', '2404', '2', '31');
INSERT INTO public.who_global_data_import VALUES (53372, '2020-06-22', 'YT', 'Mayotte', 'AFRO', '0', '2404', '0', '31');
INSERT INTO public.who_global_data_import VALUES (53373, '2020-06-23', 'YT', 'Mayotte', 'AFRO', '30', '2434', '1', '32');
INSERT INTO public.who_global_data_import VALUES (53374, '2020-06-24', 'YT', 'Mayotte', 'AFRO', '18', '2452', '0', '32');
INSERT INTO public.who_global_data_import VALUES (53375, '2020-06-25', 'YT', 'Mayotte', 'AFRO', '15', '2467', '2', '34');
INSERT INTO public.who_global_data_import VALUES (53376, '2020-06-26', 'YT', 'Mayotte', 'AFRO', '41', '2508', '0', '34');
INSERT INTO public.who_global_data_import VALUES (53377, '2020-06-27', 'YT', 'Mayotte', 'AFRO', '18', '2526', '0', '34');
INSERT INTO public.who_global_data_import VALUES (53378, '2020-06-28', 'YT', 'Mayotte', 'AFRO', '14', '2540', '1', '35');
INSERT INTO public.who_global_data_import VALUES (53379, '2020-06-29', 'YT', 'Mayotte', 'AFRO', '0', '2540', '0', '35');
INSERT INTO public.who_global_data_import VALUES (53380, '2020-06-30', 'YT', 'Mayotte', 'AFRO', '63', '2603', '0', '35');
INSERT INTO public.who_global_data_import VALUES (53381, '2020-07-01', 'YT', 'Mayotte', 'AFRO', '0', '2603', '0', '35');
INSERT INTO public.who_global_data_import VALUES (53382, '2020-07-02', 'YT', 'Mayotte', 'AFRO', '40', '2643', '0', '35');
INSERT INTO public.who_global_data_import VALUES (53383, '2020-07-03', 'YT', 'Mayotte', 'AFRO', '0', '2643', '0', '35');
INSERT INTO public.who_global_data_import VALUES (53384, '2020-07-04', 'YT', 'Mayotte', 'AFRO', '18', '2661', '1', '36');
INSERT INTO public.who_global_data_import VALUES (53385, '2020-07-05', 'YT', 'Mayotte', 'AFRO', '7', '2668', '0', '36');
INSERT INTO public.who_global_data_import VALUES (53386, '2020-07-06', 'YT', 'Mayotte', 'AFRO', '0', '2668', '0', '36');
INSERT INTO public.who_global_data_import VALUES (53387, '2020-07-07', 'YT', 'Mayotte', 'AFRO', '11', '2679', '0', '36');
INSERT INTO public.who_global_data_import VALUES (53388, '2020-07-08', 'YT', 'Mayotte', 'AFRO', '9', '2688', '0', '36');
INSERT INTO public.who_global_data_import VALUES (53389, '2020-07-09', 'YT', 'Mayotte', 'AFRO', '0', '2688', '0', '36');
INSERT INTO public.who_global_data_import VALUES (53390, '2020-07-10', 'YT', 'Mayotte', 'AFRO', '14', '2702', '1', '37');
INSERT INTO public.who_global_data_import VALUES (53391, '2020-07-11', 'YT', 'Mayotte', 'AFRO', '9', '2711', '0', '37');
INSERT INTO public.who_global_data_import VALUES (53392, '2020-07-12', 'YT', 'Mayotte', 'AFRO', '0', '2711', '0', '37');
INSERT INTO public.who_global_data_import VALUES (53393, '2020-07-13', 'YT', 'Mayotte', 'AFRO', '0', '2711', '0', '37');
INSERT INTO public.who_global_data_import VALUES (53394, '2020-07-14', 'YT', 'Mayotte', 'AFRO', '13', '2724', '0', '37');
INSERT INTO public.who_global_data_import VALUES (53395, '2020-07-15', 'YT', 'Mayotte', 'AFRO', '0', '2724', '0', '37');
INSERT INTO public.who_global_data_import VALUES (53396, '2020-07-16', 'YT', 'Mayotte', 'AFRO', '19', '2743', '0', '37');
INSERT INTO public.who_global_data_import VALUES (53397, '2020-07-17', 'YT', 'Mayotte', 'AFRO', '39', '2782', '0', '37');
INSERT INTO public.who_global_data_import VALUES (53398, '2020-07-18', 'YT', 'Mayotte', 'AFRO', '0', '2782', '0', '37');
INSERT INTO public.who_global_data_import VALUES (53399, '2020-07-19', 'YT', 'Mayotte', 'AFRO', '0', '2782', '0', '37');
INSERT INTO public.who_global_data_import VALUES (53400, '2020-07-20', 'YT', 'Mayotte', 'AFRO', '0', '2782', '0', '37');
INSERT INTO public.who_global_data_import VALUES (53401, '2020-07-21', 'YT', 'Mayotte', 'AFRO', '26', '2808', '1', '38');
INSERT INTO public.who_global_data_import VALUES (53402, '2020-07-22', 'YT', 'Mayotte', 'AFRO', '16', '2824', '0', '38');
INSERT INTO public.who_global_data_import VALUES (53403, '2020-07-23', 'YT', 'Mayotte', 'AFRO', '15', '2839', '0', '38');
INSERT INTO public.who_global_data_import VALUES (53404, '2020-07-24', 'YT', 'Mayotte', 'AFRO', '23', '2862', '0', '38');
INSERT INTO public.who_global_data_import VALUES (53405, '2020-07-25', 'YT', 'Mayotte', 'AFRO', '11', '2873', '0', '38');
INSERT INTO public.who_global_data_import VALUES (53406, '2020-07-26', 'YT', 'Mayotte', 'AFRO', '0', '2873', '0', '38');
INSERT INTO public.who_global_data_import VALUES (53407, '2020-07-27', 'YT', 'Mayotte', 'AFRO', '0', '2873', '0', '38');
INSERT INTO public.who_global_data_import VALUES (53408, '2020-07-28', 'YT', 'Mayotte', 'AFRO', '27', '2900', '0', '38');
INSERT INTO public.who_global_data_import VALUES (53409, '2020-07-29', 'YT', 'Mayotte', 'AFRO', '5', '2905', '1', '39');
INSERT INTO public.who_global_data_import VALUES (53410, '2020-07-30', 'YT', 'Mayotte', 'AFRO', '0', '2905', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53411, '2020-07-31', 'YT', 'Mayotte', 'AFRO', '57', '2962', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53412, '2020-08-01', 'YT', 'Mayotte', 'AFRO', '0', '2962', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53413, '2020-08-02', 'YT', 'Mayotte', 'AFRO', '0', '2962', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53414, '2020-08-03', 'YT', 'Mayotte', 'AFRO', '0', '2962', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53415, '2020-08-04', 'YT', 'Mayotte', 'AFRO', '46', '3008', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53416, '2020-08-05', 'YT', 'Mayotte', 'AFRO', '15', '3023', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53417, '2020-08-06', 'YT', 'Mayotte', 'AFRO', '8', '3031', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53418, '2020-08-07', 'YT', 'Mayotte', 'AFRO', '11', '3042', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53419, '2020-08-08', 'YT', 'Mayotte', 'AFRO', '26', '3068', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53420, '2020-08-09', 'YT', 'Mayotte', 'AFRO', '0', '3068', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53421, '2020-08-10', 'YT', 'Mayotte', 'AFRO', '0', '3068', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53422, '2020-08-11', 'YT', 'Mayotte', 'AFRO', '0', '3068', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53423, '2020-08-12', 'YT', 'Mayotte', 'AFRO', '23', '3091', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53424, '2020-08-13', 'YT', 'Mayotte', 'AFRO', '0', '3091', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53425, '2020-08-14', 'YT', 'Mayotte', 'AFRO', '28', '3119', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53426, '2020-08-15', 'YT', 'Mayotte', 'AFRO', '0', '3119', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53427, '2020-08-16', 'YT', 'Mayotte', 'AFRO', '0', '3119', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53428, '2020-08-17', 'YT', 'Mayotte', 'AFRO', '0', '3119', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53429, '2020-08-18', 'YT', 'Mayotte', 'AFRO', '41', '3160', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53430, '2020-08-19', 'YT', 'Mayotte', 'AFRO', '0', '3160', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53431, '2020-08-20', 'YT', 'Mayotte', 'AFRO', '0', '3160', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53432, '2020-08-21', 'YT', 'Mayotte', 'AFRO', '0', '3160', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53433, '2020-08-22', 'YT', 'Mayotte', 'AFRO', '77', '3237', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53434, '2020-08-23', 'YT', 'Mayotte', 'AFRO', '0', '3237', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53435, '2020-08-24', 'YT', 'Mayotte', 'AFRO', '0', '3237', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53436, '2020-08-25', 'YT', 'Mayotte', 'AFRO', '0', '3237', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53437, '2020-08-26', 'YT', 'Mayotte', 'AFRO', '0', '3237', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53438, '2020-08-27', 'YT', 'Mayotte', 'AFRO', '0', '3237', '0', '39');
INSERT INTO public.who_global_data_import VALUES (53439, '2020-08-28', 'YT', 'Mayotte', 'AFRO', '64', '3301', '1', '40');
INSERT INTO public.who_global_data_import VALUES (53440, '2020-08-29', 'YT', 'Mayotte', 'AFRO', '0', '3301', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53441, '2020-08-30', 'YT', 'Mayotte', 'AFRO', '0', '3301', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53442, '2020-08-31', 'YT', 'Mayotte', 'AFRO', '0', '3301', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53443, '2020-09-01', 'YT', 'Mayotte', 'AFRO', '0', '3301', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53444, '2020-09-02', 'YT', 'Mayotte', 'AFRO', '0', '3301', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53445, '2020-09-03', 'YT', 'Mayotte', 'AFRO', '0', '3301', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53446, '2020-09-04', 'YT', 'Mayotte', 'AFRO', '73', '3374', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53447, '2020-09-05', 'YT', 'Mayotte', 'AFRO', '0', '3374', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53448, '2020-09-06', 'YT', 'Mayotte', 'AFRO', '0', '3374', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53449, '2020-09-07', 'YT', 'Mayotte', 'AFRO', '0', '3374', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53450, '2020-09-08', 'YT', 'Mayotte', 'AFRO', '0', '3374', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53451, '2020-09-09', 'YT', 'Mayotte', 'AFRO', '0', '3374', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53452, '2020-09-10', 'YT', 'Mayotte', 'AFRO', '0', '3374', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53453, '2020-09-11', 'YT', 'Mayotte', 'AFRO', '0', '3374', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53454, '2020-09-12', 'YT', 'Mayotte', 'AFRO', '0', '3374', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53455, '2020-09-13', 'YT', 'Mayotte', 'AFRO', '0', '3374', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53456, '2020-09-14', 'YT', 'Mayotte', 'AFRO', '0', '3374', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53457, '2020-09-15', 'YT', 'Mayotte', 'AFRO', '167', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53458, '2020-09-16', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53459, '2020-09-17', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53460, '2020-09-18', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53461, '2020-09-19', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53462, '2020-09-20', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53463, '2020-09-21', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53464, '2020-09-22', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53465, '2020-09-23', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53466, '2020-09-24', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53467, '2020-09-25', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53468, '2020-09-26', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53469, '2020-09-27', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53470, '2020-09-28', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53471, '2020-09-29', 'YT', 'Mayotte', 'AFRO', '0', '3541', '0', '40');
INSERT INTO public.who_global_data_import VALUES (53472, '2020-09-30', 'YT', 'Mayotte', 'AFRO', '238', '3779', '2', '42');
INSERT INTO public.who_global_data_import VALUES (53473, '2020-10-01', 'YT', 'Mayotte', 'AFRO', '0', '3779', '0', '42');
INSERT INTO public.who_global_data_import VALUES (53474, '2020-10-02', 'YT', 'Mayotte', 'AFRO', '0', '3779', '0', '42');
INSERT INTO public.who_global_data_import VALUES (53475, '2020-10-03', 'YT', 'Mayotte', 'AFRO', '0', '3779', '0', '42');
INSERT INTO public.who_global_data_import VALUES (53476, '2020-10-04', 'YT', 'Mayotte', 'AFRO', '0', '3779', '0', '42');
INSERT INTO public.who_global_data_import VALUES (53477, '2020-10-05', 'YT', 'Mayotte', 'AFRO', '0', '3779', '0', '42');
INSERT INTO public.who_global_data_import VALUES (53478, '2020-10-06', 'YT', 'Mayotte', 'AFRO', '113', '3892', '0', '42');
INSERT INTO public.who_global_data_import VALUES (53479, '2020-10-07', 'YT', 'Mayotte', 'AFRO', '0', '3892', '0', '42');
INSERT INTO public.who_global_data_import VALUES (53480, '2020-10-08', 'YT', 'Mayotte', 'AFRO', '0', '3892', '0', '42');
INSERT INTO public.who_global_data_import VALUES (53481, '2020-10-09', 'YT', 'Mayotte', 'AFRO', '0', '3892', '0', '42');
INSERT INTO public.who_global_data_import VALUES (53482, '2020-10-10', 'YT', 'Mayotte', 'AFRO', '97', '3989', '1', '43');
INSERT INTO public.who_global_data_import VALUES (53483, '2020-10-11', 'YT', 'Mayotte', 'AFRO', '0', '3989', '0', '43');
INSERT INTO public.who_global_data_import VALUES (53484, '2020-10-12', 'YT', 'Mayotte', 'AFRO', '0', '3989', '0', '43');
INSERT INTO public.who_global_data_import VALUES (53485, '2020-10-13', 'YT', 'Mayotte', 'AFRO', '41', '4030', '0', '43');
INSERT INTO public.who_global_data_import VALUES (53486, '2020-10-14', 'YT', 'Mayotte', 'AFRO', '0', '4030', '0', '43');
INSERT INTO public.who_global_data_import VALUES (53487, '2020-10-15', 'YT', 'Mayotte', 'AFRO', '0', '4030', '0', '43');
INSERT INTO public.who_global_data_import VALUES (53488, '2020-10-16', 'YT', 'Mayotte', 'AFRO', '0', '4030', '0', '43');
INSERT INTO public.who_global_data_import VALUES (53489, '2020-10-17', 'YT', 'Mayotte', 'AFRO', '0', '4030', '0', '43');
INSERT INTO public.who_global_data_import VALUES (53490, '2020-10-18', 'YT', 'Mayotte', 'AFRO', '0', '4030', '0', '43');
INSERT INTO public.who_global_data_import VALUES (53491, '2020-10-19', 'YT', 'Mayotte', 'AFRO', '0', '4030', '0', '43');
INSERT INTO public.who_global_data_import VALUES (53492, '2020-10-20', 'YT', 'Mayotte', 'AFRO', '129', '4159', '0', '43');
INSERT INTO public.who_global_data_import VALUES (53493, '2020-10-21', 'YT', 'Mayotte', 'AFRO', '44', '4203', '1', '44');
INSERT INTO public.who_global_data_import VALUES (53494, '2020-10-22', 'YT', 'Mayotte', 'AFRO', '0', '4203', '0', '44');
INSERT INTO public.who_global_data_import VALUES (53495, '2020-10-23', 'YT', 'Mayotte', 'AFRO', '0', '4203', '0', '44');
INSERT INTO public.who_global_data_import VALUES (53496, '2020-10-24', 'YT', 'Mayotte', 'AFRO', '73', '4276', '0', '44');
INSERT INTO public.who_global_data_import VALUES (53497, '2020-10-25', 'YT', 'Mayotte', 'AFRO', '0', '4276', '0', '44');
INSERT INTO public.who_global_data_import VALUES (53498, '2020-10-26', 'YT', 'Mayotte', 'AFRO', '0', '4276', '0', '44');
INSERT INTO public.who_global_data_import VALUES (53499, '2020-10-27', 'YT', 'Mayotte', 'AFRO', '45', '4321', '0', '44');
INSERT INTO public.who_global_data_import VALUES (53500, '2020-10-28', 'YT', 'Mayotte', 'AFRO', '0', '4321', '0', '44');
INSERT INTO public.who_global_data_import VALUES (53501, '2020-10-29', 'YT', 'Mayotte', 'AFRO', '45', '4366', '0', '44');
INSERT INTO public.who_global_data_import VALUES (53502, '2020-10-30', 'YT', 'Mayotte', 'AFRO', '0', '4366', '0', '44');
INSERT INTO public.who_global_data_import VALUES (53503, '2020-10-31', 'YT', 'Mayotte', 'AFRO', '0', '4366', '0', '44');
INSERT INTO public.who_global_data_import VALUES (53504, '2020-11-01', 'YT', 'Mayotte', 'AFRO', '0', '4366', '0', '44');
INSERT INTO public.who_global_data_import VALUES (53505, '2020-11-02', 'YT', 'Mayotte', 'AFRO', '0', '4366', '0', '44');
INSERT INTO public.who_global_data_import VALUES (53506, '2020-11-03', 'YT', 'Mayotte', 'AFRO', '123', '4489', '1', '45');
INSERT INTO public.who_global_data_import VALUES (53507, '2020-11-04', 'YT', 'Mayotte', 'AFRO', '35', '4524', '0', '45');
INSERT INTO public.who_global_data_import VALUES (53508, '2020-11-05', 'YT', 'Mayotte', 'AFRO', '26', '4550', '0', '45');
INSERT INTO public.who_global_data_import VALUES (53509, '2020-11-06', 'YT', 'Mayotte', 'AFRO', '0', '4550', '0', '45');
INSERT INTO public.who_global_data_import VALUES (53510, '2020-11-07', 'YT', 'Mayotte', 'AFRO', '0', '4550', '0', '45');
INSERT INTO public.who_global_data_import VALUES (53511, '2020-11-08', 'YT', 'Mayotte', 'AFRO', '0', '4550', '0', '45');
INSERT INTO public.who_global_data_import VALUES (53512, '2020-11-09', 'YT', 'Mayotte', 'AFRO', '0', '4550', '0', '45');
INSERT INTO public.who_global_data_import VALUES (53513, '2020-11-10', 'YT', 'Mayotte', 'AFRO', '265', '4815', '1', '46');
INSERT INTO public.who_global_data_import VALUES (53514, '2020-11-11', 'YT', 'Mayotte', 'AFRO', '0', '4815', '0', '46');
INSERT INTO public.who_global_data_import VALUES (53515, '2020-11-12', 'YT', 'Mayotte', 'AFRO', '0', '4815', '0', '46');
INSERT INTO public.who_global_data_import VALUES (53516, '2020-11-13', 'YT', 'Mayotte', 'AFRO', '106', '4921', '0', '46');
INSERT INTO public.who_global_data_import VALUES (53517, '2020-11-14', 'YT', 'Mayotte', 'AFRO', '0', '4921', '0', '46');
INSERT INTO public.who_global_data_import VALUES (53518, '2020-11-15', 'YT', 'Mayotte', 'AFRO', '0', '4921', '0', '46');
INSERT INTO public.who_global_data_import VALUES (53519, '2020-11-16', 'YT', 'Mayotte', 'AFRO', '22', '4943', '0', '46');
INSERT INTO public.who_global_data_import VALUES (53520, '2020-11-17', 'YT', 'Mayotte', 'AFRO', '0', '4943', '0', '46');
INSERT INTO public.who_global_data_import VALUES (53521, '2020-11-18', 'YT', 'Mayotte', 'AFRO', '0', '4943', '0', '46');
INSERT INTO public.who_global_data_import VALUES (53522, '2020-11-19', 'YT', 'Mayotte', 'AFRO', '93', '5036', '2', '48');
INSERT INTO public.who_global_data_import VALUES (53523, '2020-11-20', 'YT', 'Mayotte', 'AFRO', '0', '5036', '0', '48');
INSERT INTO public.who_global_data_import VALUES (53524, '2020-11-21', 'YT', 'Mayotte', 'AFRO', '0', '5036', '0', '48');
INSERT INTO public.who_global_data_import VALUES (53525, '2020-11-22', 'YT', 'Mayotte', 'AFRO', '0', '5036', '0', '48');
INSERT INTO public.who_global_data_import VALUES (53526, '2020-11-23', 'YT', 'Mayotte', 'AFRO', '0', '5036', '0', '48');
INSERT INTO public.who_global_data_import VALUES (53527, '2020-11-24', 'YT', 'Mayotte', 'AFRO', '86', '5122', '1', '49');
INSERT INTO public.who_global_data_import VALUES (53528, '2020-11-25', 'YT', 'Mayotte', 'AFRO', '0', '5122', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53529, '2020-11-26', 'YT', 'Mayotte', 'AFRO', '59', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53530, '2020-11-27', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53531, '2020-11-28', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53532, '2020-11-29', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53533, '2020-11-30', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53534, '2020-12-01', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53535, '2020-12-02', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53536, '2020-12-03', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53537, '2020-12-04', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53538, '2020-12-05', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53539, '2020-12-06', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53540, '2020-12-07', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53541, '2020-12-08', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53542, '2020-12-09', 'YT', 'Mayotte', 'AFRO', '0', '5181', '0', '49');
INSERT INTO public.who_global_data_import VALUES (53543, '2020-12-10', 'YT', 'Mayotte', 'AFRO', '318', '5499', '2', '51');
INSERT INTO public.who_global_data_import VALUES (53544, '2020-12-11', 'YT', 'Mayotte', 'AFRO', '0', '5499', '0', '51');
INSERT INTO public.who_global_data_import VALUES (53545, '2020-12-12', 'YT', 'Mayotte', 'AFRO', '52', '5551', '1', '52');
INSERT INTO public.who_global_data_import VALUES (53546, '2020-12-13', 'YT', 'Mayotte', 'AFRO', '0', '5551', '0', '52');
INSERT INTO public.who_global_data_import VALUES (53547, '2020-12-14', 'YT', 'Mayotte', 'AFRO', '0', '5551', '0', '52');
INSERT INTO public.who_global_data_import VALUES (53548, '2020-12-15', 'YT', 'Mayotte', 'AFRO', '65', '5616', '1', '53');
INSERT INTO public.who_global_data_import VALUES (53549, '2020-12-16', 'YT', 'Mayotte', 'AFRO', '0', '5616', '0', '53');
INSERT INTO public.who_global_data_import VALUES (53550, '2020-12-17', 'YT', 'Mayotte', 'AFRO', '0', '5616', '0', '53');
INSERT INTO public.who_global_data_import VALUES (53551, '2020-12-18', 'YT', 'Mayotte', 'AFRO', '92', '5708', '0', '53');
INSERT INTO public.who_global_data_import VALUES (53552, '2020-12-19', 'YT', 'Mayotte', 'AFRO', '0', '5708', '0', '53');
INSERT INTO public.who_global_data_import VALUES (53553, '2020-12-20', 'YT', 'Mayotte', 'AFRO', '0', '5708', '0', '53');
INSERT INTO public.who_global_data_import VALUES (53554, '2020-12-21', 'YT', 'Mayotte', 'AFRO', '0', '5708', '0', '53');
INSERT INTO public.who_global_data_import VALUES (53555, '2020-12-22', 'YT', 'Mayotte', 'AFRO', '0', '5708', '0', '53');
INSERT INTO public.who_global_data_import VALUES (53556, '2020-12-23', 'YT', 'Mayotte', 'AFRO', '59', '5767', '1', '54');
INSERT INTO public.who_global_data_import VALUES (53557, '2020-12-24', 'YT', 'Mayotte', 'AFRO', '0', '5767', '0', '54');
INSERT INTO public.who_global_data_import VALUES (53558, '2020-12-25', 'YT', 'Mayotte', 'AFRO', '0', '5767', '0', '54');
INSERT INTO public.who_global_data_import VALUES (53559, '2020-12-26', 'YT', 'Mayotte', 'AFRO', '0', '5767', '0', '54');
INSERT INTO public.who_global_data_import VALUES (53560, '2020-12-27', 'YT', 'Mayotte', 'AFRO', '0', '5767', '0', '54');
INSERT INTO public.who_global_data_import VALUES (53561, '2020-12-28', 'YT', 'Mayotte', 'AFRO', '0', '5767', '0', '54');
INSERT INTO public.who_global_data_import VALUES (53562, '2020-12-29', 'YT', 'Mayotte', 'AFRO', '123', '5890', '1', '55');
INSERT INTO public.who_global_data_import VALUES (53563, '2020-12-30', 'YT', 'Mayotte', 'AFRO', '0', '5890', '0', '55');
INSERT INTO public.who_global_data_import VALUES (53564, '2020-12-31', 'YT', 'Mayotte', 'AFRO', '0', '5890', '0', '55');
INSERT INTO public.who_global_data_import VALUES (53565, '2021-01-01', 'YT', 'Mayotte', 'AFRO', '0', '5890', '0', '55');
INSERT INTO public.who_global_data_import VALUES (53566, '2021-01-02', 'YT', 'Mayotte', 'AFRO', '0', '5890', '0', '55');
INSERT INTO public.who_global_data_import VALUES (53567, '2021-01-03', 'YT', 'Mayotte', 'AFRO', '0', '5890', '0', '55');
INSERT INTO public.who_global_data_import VALUES (53568, '2021-01-04', 'YT', 'Mayotte', 'AFRO', '0', '5890', '0', '55');
INSERT INTO public.who_global_data_import VALUES (53569, '2021-01-05', 'YT', 'Mayotte', 'AFRO', '155', '6045', '1', '56');
INSERT INTO public.who_global_data_import VALUES (53570, '2021-01-06', 'YT', 'Mayotte', 'AFRO', '0', '6045', '0', '56');
INSERT INTO public.who_global_data_import VALUES (53571, '2021-01-07', 'YT', 'Mayotte', 'AFRO', '0', '6045', '0', '56');
INSERT INTO public.who_global_data_import VALUES (53572, '2021-01-08', 'YT', 'Mayotte', 'AFRO', '0', '6045', '0', '56');
INSERT INTO public.who_global_data_import VALUES (53573, '2021-01-09', 'YT', 'Mayotte', 'AFRO', '187', '6232', '0', '56');
INSERT INTO public.who_global_data_import VALUES (53574, '2021-01-10', 'YT', 'Mayotte', 'AFRO', '0', '6232', '0', '56');
INSERT INTO public.who_global_data_import VALUES (53575, '2021-01-11', 'YT', 'Mayotte', 'AFRO', '23', '6255', '0', '56');
INSERT INTO public.who_global_data_import VALUES (53576, '2021-01-12', 'YT', 'Mayotte', 'AFRO', '0', '6255', '0', '56');
INSERT INTO public.who_global_data_import VALUES (53577, '2021-01-13', 'YT', 'Mayotte', 'AFRO', '0', '6255', '0', '56');
INSERT INTO public.who_global_data_import VALUES (53578, '2021-01-14', 'YT', 'Mayotte', 'AFRO', '0', '6255', '0', '56');
INSERT INTO public.who_global_data_import VALUES (53579, '2021-01-15', 'YT', 'Mayotte', 'AFRO', '356', '6611', '2', '58');
INSERT INTO public.who_global_data_import VALUES (53580, '2021-01-16', 'YT', 'Mayotte', 'AFRO', '0', '6611', '0', '58');
INSERT INTO public.who_global_data_import VALUES (53581, '2021-01-17', 'YT', 'Mayotte', 'AFRO', '0', '6611', '0', '58');
INSERT INTO public.who_global_data_import VALUES (53582, '2021-01-18', 'YT', 'Mayotte', 'AFRO', '0', '6611', '0', '58');
INSERT INTO public.who_global_data_import VALUES (53583, '2021-01-19', 'YT', 'Mayotte', 'AFRO', '178', '6789', '0', '58');
INSERT INTO public.who_global_data_import VALUES (53584, '2021-01-20', 'YT', 'Mayotte', 'AFRO', '129', '6918', '0', '58');
INSERT INTO public.who_global_data_import VALUES (53585, '2021-01-21', 'YT', 'Mayotte', 'AFRO', '63', '6981', '0', '58');
INSERT INTO public.who_global_data_import VALUES (53586, '2021-01-22', 'YT', 'Mayotte', 'AFRO', '177', '7158', '0', '58');
INSERT INTO public.who_global_data_import VALUES (53587, '2021-01-23', 'YT', 'Mayotte', 'AFRO', '92', '7250', '0', '58');
INSERT INTO public.who_global_data_import VALUES (53588, '2021-01-24', 'YT', 'Mayotte', 'AFRO', '294', '7544', '1', '59');
INSERT INTO public.who_global_data_import VALUES (53589, '2021-01-25', 'YT', 'Mayotte', 'AFRO', '0', '7544', '0', '59');
INSERT INTO public.who_global_data_import VALUES (53590, '2021-01-26', 'YT', 'Mayotte', 'AFRO', '46', '7590', '0', '59');
INSERT INTO public.who_global_data_import VALUES (53591, '2021-01-27', 'YT', 'Mayotte', 'AFRO', '0', '7590', '0', '59');
INSERT INTO public.who_global_data_import VALUES (53592, '2021-01-28', 'YT', 'Mayotte', 'AFRO', '294', '7884', '1', '60');
INSERT INTO public.who_global_data_import VALUES (53593, '2021-01-29', 'YT', 'Mayotte', 'AFRO', '347', '8231', '1', '61');
INSERT INTO public.who_global_data_import VALUES (53594, '2021-01-30', 'YT', 'Mayotte', 'AFRO', '0', '8231', '0', '61');
INSERT INTO public.who_global_data_import VALUES (53595, '2021-01-31', 'YT', 'Mayotte', 'AFRO', '0', '8231', '0', '61');
INSERT INTO public.who_global_data_import VALUES (53596, '2021-02-01', 'YT', 'Mayotte', 'AFRO', '0', '8231', '0', '61');
INSERT INTO public.who_global_data_import VALUES (53597, '2021-02-02', 'YT', 'Mayotte', 'AFRO', '357', '8588', '0', '61');
INSERT INTO public.who_global_data_import VALUES (53598, '2021-02-03', 'YT', 'Mayotte', 'AFRO', '415', '9003', '0', '61');
INSERT INTO public.who_global_data_import VALUES (53599, '2021-02-04', 'YT', 'Mayotte', 'AFRO', '289', '9292', '1', '62');
INSERT INTO public.who_global_data_import VALUES (53600, '2021-02-05', 'YT', 'Mayotte', 'AFRO', '254', '9546', '1', '63');
INSERT INTO public.who_global_data_import VALUES (53601, '2020-01-03', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53602, '2020-01-04', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53603, '2020-01-05', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53604, '2020-01-06', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53605, '2020-01-07', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53606, '2020-01-08', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53607, '2020-01-09', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53608, '2020-01-10', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53609, '2020-01-11', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53610, '2020-01-12', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53611, '2020-01-13', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53612, '2020-01-14', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53613, '2020-01-15', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53614, '2020-01-16', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53615, '2020-01-17', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53616, '2020-01-18', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53617, '2020-01-19', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53618, '2020-01-20', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53619, '2020-01-21', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53620, '2020-01-22', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53621, '2020-01-23', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53622, '2020-01-24', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53623, '2020-01-25', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53624, '2020-01-26', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53625, '2020-01-27', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53626, '2020-01-28', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53627, '2020-01-29', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53628, '2020-01-30', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53629, '2020-01-31', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53630, '2020-02-01', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53631, '2020-02-02', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53632, '2020-02-03', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53633, '2020-02-04', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53634, '2020-02-05', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53635, '2020-02-06', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53636, '2020-02-07', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53637, '2020-02-08', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53638, '2020-02-09', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53639, '2020-02-10', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53640, '2020-02-11', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53641, '2020-02-12', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53642, '2020-02-13', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53643, '2020-02-14', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53644, '2020-02-15', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53645, '2020-02-16', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53646, '2020-02-17', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53647, '2020-02-18', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53648, '2020-02-19', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53649, '2020-02-20', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53650, '2020-02-21', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53651, '2020-02-22', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53652, '2020-02-23', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53653, '2020-02-24', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53654, '2020-02-25', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53655, '2020-02-26', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53656, '2020-02-27', 'MX', 'Mexico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53657, '2020-02-28', 'MX', 'Mexico', 'AMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53658, '2020-02-29', 'MX', 'Mexico', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53659, '2020-03-01', 'MX', 'Mexico', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53660, '2020-03-02', 'MX', 'Mexico', 'AMRO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53661, '2020-03-03', 'MX', 'Mexico', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53662, '2020-03-04', 'MX', 'Mexico', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53663, '2020-03-05', 'MX', 'Mexico', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53664, '2020-03-06', 'MX', 'Mexico', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53665, '2020-03-07', 'MX', 'Mexico', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53666, '2020-03-08', 'MX', 'Mexico', 'AMRO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53667, '2020-03-09', 'MX', 'Mexico', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53668, '2020-03-10', 'MX', 'Mexico', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53669, '2020-03-11', 'MX', 'Mexico', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53670, '2020-03-12', 'MX', 'Mexico', 'AMRO', '4', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53671, '2020-03-13', 'MX', 'Mexico', 'AMRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53672, '2020-03-14', 'MX', 'Mexico', 'AMRO', '14', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53673, '2020-03-15', 'MX', 'Mexico', 'AMRO', '15', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53674, '2020-03-16', 'MX', 'Mexico', 'AMRO', '12', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53675, '2020-03-17', 'MX', 'Mexico', 'AMRO', '29', '86', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53676, '2020-03-18', 'MX', 'Mexico', 'AMRO', '11', '97', '0', '0');
INSERT INTO public.who_global_data_import VALUES (53677, '2020-03-19', 'MX', 'Mexico', 'AMRO', '21', '118', '1', '1');
INSERT INTO public.who_global_data_import VALUES (53678, '2020-03-20', 'MX', 'Mexico', 'AMRO', '46', '164', '0', '1');
INSERT INTO public.who_global_data_import VALUES (53679, '2020-03-21', 'MX', 'Mexico', 'AMRO', '0', '164', '0', '1');
INSERT INTO public.who_global_data_import VALUES (53680, '2020-03-22', 'MX', 'Mexico', 'AMRO', '0', '164', '0', '1');
INSERT INTO public.who_global_data_import VALUES (53681, '2020-03-23', 'MX', 'Mexico', 'AMRO', '87', '251', '1', '2');
INSERT INTO public.who_global_data_import VALUES (53682, '2020-03-24', 'MX', 'Mexico', 'AMRO', '65', '316', '0', '2');
INSERT INTO public.who_global_data_import VALUES (53683, '2020-03-25', 'MX', 'Mexico', 'AMRO', '0', '316', '0', '2');
INSERT INTO public.who_global_data_import VALUES (53684, '2020-03-26', 'MX', 'Mexico', 'AMRO', '162', '478', '3', '5');
INSERT INTO public.who_global_data_import VALUES (53685, '2020-03-27', 'MX', 'Mexico', 'AMRO', '0', '478', '0', '5');
INSERT INTO public.who_global_data_import VALUES (53686, '2020-03-28', 'MX', 'Mexico', 'AMRO', '111', '589', '3', '8');
INSERT INTO public.who_global_data_import VALUES (53687, '2020-03-29', 'MX', 'Mexico', 'AMRO', '128', '717', '4', '12');
INSERT INTO public.who_global_data_import VALUES (53688, '2020-03-30', 'MX', 'Mexico', 'AMRO', '131', '848', '4', '16');
INSERT INTO public.who_global_data_import VALUES (53689, '2020-03-31', 'MX', 'Mexico', 'AMRO', '145', '993', '4', '20');
INSERT INTO public.who_global_data_import VALUES (53690, '2020-04-01', 'MX', 'Mexico', 'AMRO', '101', '1094', '8', '28');
INSERT INTO public.who_global_data_import VALUES (53691, '2020-04-02', 'MX', 'Mexico', 'AMRO', '121', '1215', '1', '29');
INSERT INTO public.who_global_data_import VALUES (53692, '2020-04-03', 'MX', 'Mexico', 'AMRO', '163', '1378', '8', '37');
INSERT INTO public.who_global_data_import VALUES (53693, '2020-04-04', 'MX', 'Mexico', 'AMRO', '132', '1510', '13', '50');
INSERT INTO public.who_global_data_import VALUES (53694, '2020-04-05', 'MX', 'Mexico', 'AMRO', '178', '1688', '10', '60');
INSERT INTO public.who_global_data_import VALUES (53695, '2020-04-06', 'MX', 'Mexico', 'AMRO', '202', '1890', '19', '79');
INSERT INTO public.who_global_data_import VALUES (53696, '2020-04-07', 'MX', 'Mexico', 'AMRO', '253', '2143', '15', '94');
INSERT INTO public.who_global_data_import VALUES (53697, '2020-04-08', 'MX', 'Mexico', 'AMRO', '296', '2439', '31', '125');
INSERT INTO public.who_global_data_import VALUES (53698, '2020-04-09', 'MX', 'Mexico', 'AMRO', '346', '2785', '16', '141');
INSERT INTO public.who_global_data_import VALUES (53699, '2020-04-10', 'MX', 'Mexico', 'AMRO', '396', '3181', '33', '174');
INSERT INTO public.who_global_data_import VALUES (53700, '2020-04-11', 'MX', 'Mexico', 'AMRO', '260', '3441', '20', '194');
INSERT INTO public.who_global_data_import VALUES (53701, '2020-04-12', 'MX', 'Mexico', 'AMRO', '403', '3844', '39', '233');
INSERT INTO public.who_global_data_import VALUES (53702, '2020-04-13', 'MX', 'Mexico', 'AMRO', '375', '4219', '40', '273');
INSERT INTO public.who_global_data_import VALUES (53703, '2020-04-14', 'MX', 'Mexico', 'AMRO', '442', '4661', '23', '296');
INSERT INTO public.who_global_data_import VALUES (53704, '2020-04-15', 'MX', 'Mexico', 'AMRO', '353', '5014', '36', '332');
INSERT INTO public.who_global_data_import VALUES (53705, '2020-04-16', 'MX', 'Mexico', 'AMRO', '385', '5399', '74', '406');
INSERT INTO public.who_global_data_import VALUES (53706, '2020-04-17', 'MX', 'Mexico', 'AMRO', '448', '5847', '43', '449');
INSERT INTO public.who_global_data_import VALUES (53707, '2020-04-18', 'MX', 'Mexico', 'AMRO', '450', '6297', '37', '486');
INSERT INTO public.who_global_data_import VALUES (53708, '2020-04-19', 'MX', 'Mexico', 'AMRO', '578', '6875', '60', '546');
INSERT INTO public.who_global_data_import VALUES (53709, '2020-04-20', 'MX', 'Mexico', 'AMRO', '622', '7497', '104', '650');
INSERT INTO public.who_global_data_import VALUES (53710, '2020-04-21', 'MX', 'Mexico', 'AMRO', '764', '8261', '36', '686');
INSERT INTO public.who_global_data_import VALUES (53711, '2020-04-22', 'MX', 'Mexico', 'AMRO', '511', '8772', '26', '712');
INSERT INTO public.who_global_data_import VALUES (53712, '2020-04-23', 'MX', 'Mexico', 'AMRO', '729', '9501', '145', '857');
INSERT INTO public.who_global_data_import VALUES (53713, '2020-04-24', 'MX', 'Mexico', 'AMRO', '1043', '10544', '113', '970');
INSERT INTO public.who_global_data_import VALUES (53714, '2020-04-25', 'MX', 'Mexico', 'AMRO', '1089', '11633', '99', '1069');
INSERT INTO public.who_global_data_import VALUES (53715, '2020-04-26', 'MX', 'Mexico', 'AMRO', '1239', '12872', '152', '1221');
INSERT INTO public.who_global_data_import VALUES (53716, '2020-04-27', 'MX', 'Mexico', 'AMRO', '970', '13842', '84', '1305');
INSERT INTO public.who_global_data_import VALUES (53717, '2020-04-28', 'MX', 'Mexico', 'AMRO', '835', '14677', '46', '1351');
INSERT INTO public.who_global_data_import VALUES (53718, '2020-04-29', 'MX', 'Mexico', 'AMRO', '852', '15529', '83', '1434');
INSERT INTO public.who_global_data_import VALUES (53719, '2020-04-30', 'MX', 'Mexico', 'AMRO', '1223', '16752', '135', '1569');
INSERT INTO public.who_global_data_import VALUES (53720, '2020-05-01', 'MX', 'Mexico', 'AMRO', '1047', '17799', '163', '1732');
INSERT INTO public.who_global_data_import VALUES (53721, '2020-05-02', 'MX', 'Mexico', 'AMRO', '1425', '19224', '127', '1859');
INSERT INTO public.who_global_data_import VALUES (53722, '2020-05-03', 'MX', 'Mexico', 'AMRO', '1515', '20739', '113', '1972');
INSERT INTO public.who_global_data_import VALUES (53723, '2020-05-04', 'MX', 'Mexico', 'AMRO', '1349', '22088', '89', '2061');
INSERT INTO public.who_global_data_import VALUES (53724, '2020-05-05', 'MX', 'Mexico', 'AMRO', '1383', '23471', '93', '2154');
INSERT INTO public.who_global_data_import VALUES (53725, '2020-05-06', 'MX', 'Mexico', 'AMRO', '1434', '24905', '117', '2271');
INSERT INTO public.who_global_data_import VALUES (53726, '2020-05-07', 'MX', 'Mexico', 'AMRO', '1120', '26025', '236', '2507');
INSERT INTO public.who_global_data_import VALUES (53727, '2020-05-08', 'MX', 'Mexico', 'AMRO', '1609', '27634', '197', '2704');
INSERT INTO public.who_global_data_import VALUES (53728, '2020-05-09', 'MX', 'Mexico', 'AMRO', '1982', '29616', '257', '2961');
INSERT INTO public.who_global_data_import VALUES (53729, '2020-05-10', 'MX', 'Mexico', 'AMRO', '1906', '31522', '199', '3160');
INSERT INTO public.who_global_data_import VALUES (53730, '2020-05-11', 'MX', 'Mexico', 'AMRO', '1938', '33460', '193', '3353');
INSERT INTO public.who_global_data_import VALUES (53731, '2020-05-12', 'MX', 'Mexico', 'AMRO', '1562', '35022', '112', '3465');
INSERT INTO public.who_global_data_import VALUES (53732, '2020-05-13', 'MX', 'Mexico', 'AMRO', '1305', '36327', '108', '3573');
INSERT INTO public.who_global_data_import VALUES (53733, '2020-05-14', 'MX', 'Mexico', 'AMRO', '1997', '38324', '353', '3926');
INSERT INTO public.who_global_data_import VALUES (53734, '2020-05-15', 'MX', 'Mexico', 'AMRO', '1862', '40186', '294', '4220');
INSERT INTO public.who_global_data_import VALUES (53735, '2020-05-16', 'MX', 'Mexico', 'AMRO', '2409', '42595', '257', '4477');
INSERT INTO public.who_global_data_import VALUES (53736, '2020-05-17', 'MX', 'Mexico', 'AMRO', '2437', '45032', '290', '4767');
INSERT INTO public.who_global_data_import VALUES (53737, '2020-05-18', 'MX', 'Mexico', 'AMRO', '2112', '47144', '278', '5045');
INSERT INTO public.who_global_data_import VALUES (53738, '2020-05-19', 'MX', 'Mexico', 'AMRO', '2075', '49219', '132', '5177');
INSERT INTO public.who_global_data_import VALUES (53739, '2020-05-20', 'MX', 'Mexico', 'AMRO', '2414', '51633', '155', '5332');
INSERT INTO public.who_global_data_import VALUES (53740, '2020-05-21', 'MX', 'Mexico', 'AMRO', '2713', '54346', '334', '5666');
INSERT INTO public.who_global_data_import VALUES (53741, '2020-05-22', 'MX', 'Mexico', 'AMRO', '2248', '56594', '424', '6090');
INSERT INTO public.who_global_data_import VALUES (53742, '2020-05-23', 'MX', 'Mexico', 'AMRO', '2973', '59567', '420', '6510');
INSERT INTO public.who_global_data_import VALUES (53743, '2020-05-24', 'MX', 'Mexico', 'AMRO', '2960', '62527', '479', '6989');
INSERT INTO public.who_global_data_import VALUES (53744, '2020-05-25', 'MX', 'Mexico', 'AMRO', '3329', '65856', '190', '7179');
INSERT INTO public.who_global_data_import VALUES (53745, '2020-05-26', 'MX', 'Mexico', 'AMRO', '2764', '68620', '215', '7394');
INSERT INTO public.who_global_data_import VALUES (53746, '2020-05-27', 'MX', 'Mexico', 'AMRO', '2485', '71105', '239', '7633');
INSERT INTO public.who_global_data_import VALUES (53747, '2020-05-28', 'MX', 'Mexico', 'AMRO', '3455', '74560', '501', '8134');
INSERT INTO public.who_global_data_import VALUES (53748, '2020-05-29', 'MX', 'Mexico', 'AMRO', '3463', '78023', '463', '8597');
INSERT INTO public.who_global_data_import VALUES (53749, '2020-05-30', 'MX', 'Mexico', 'AMRO', '3377', '81400', '447', '9044');
INSERT INTO public.who_global_data_import VALUES (53750, '2020-05-31', 'MX', 'Mexico', 'AMRO', '3227', '84627', '371', '9415');
INSERT INTO public.who_global_data_import VALUES (53751, '2020-06-01', 'MX', 'Mexico', 'AMRO', '2885', '87512', '364', '9779');
INSERT INTO public.who_global_data_import VALUES (53752, '2020-06-02', 'MX', 'Mexico', 'AMRO', '3152', '90664', '151', '9930');
INSERT INTO public.who_global_data_import VALUES (53753, '2020-06-03', 'MX', 'Mexico', 'AMRO', '2771', '93435', '237', '10167');
INSERT INTO public.who_global_data_import VALUES (53754, '2020-06-04', 'MX', 'Mexico', 'AMRO', '3891', '97326', '470', '10637');
INSERT INTO public.who_global_data_import VALUES (53755, '2020-06-05', 'MX', 'Mexico', 'AMRO', '3912', '101238', '1091', '11728');
INSERT INTO public.who_global_data_import VALUES (53756, '2020-06-06', 'MX', 'Mexico', 'AMRO', '4442', '105680', '817', '12545');
INSERT INTO public.who_global_data_import VALUES (53757, '2020-06-07', 'MX', 'Mexico', 'AMRO', '4346', '110026', '625', '13170');
INSERT INTO public.who_global_data_import VALUES (53758, '2020-06-08', 'MX', 'Mexico', 'AMRO', '3593', '113619', '341', '13511');
INSERT INTO public.who_global_data_import VALUES (53759, '2020-06-09', 'MX', 'Mexico', 'AMRO', '3484', '117103', '188', '13699');
INSERT INTO public.who_global_data_import VALUES (53760, '2020-06-10', 'MX', 'Mexico', 'AMRO', '2999', '120102', '354', '14053');
INSERT INTO public.who_global_data_import VALUES (53761, '2020-06-11', 'MX', 'Mexico', 'AMRO', '4199', '124301', '596', '14649');
INSERT INTO public.who_global_data_import VALUES (53762, '2020-06-12', 'MX', 'Mexico', 'AMRO', '4883', '129184', '708', '15357');
INSERT INTO public.who_global_data_import VALUES (53763, '2020-06-13', 'MX', 'Mexico', 'AMRO', '4790', '133974', '587', '15944');
INSERT INTO public.who_global_data_import VALUES (53764, '2020-06-14', 'MX', 'Mexico', 'AMRO', '5222', '139196', '504', '16448');
INSERT INTO public.who_global_data_import VALUES (53765, '2020-06-15', 'MX', 'Mexico', 'AMRO', '3494', '142690', '424', '16872');
INSERT INTO public.who_global_data_import VALUES (53766, '2020-06-16', 'MX', 'Mexico', 'AMRO', '4147', '146837', '269', '17141');
INSERT INTO public.who_global_data_import VALUES (53767, '2020-06-17', 'MX', 'Mexico', 'AMRO', '3427', '150264', '439', '17580');
INSERT INTO public.who_global_data_import VALUES (53768, '2020-06-18', 'MX', 'Mexico', 'AMRO', '4599', '154863', '730', '18310');
INSERT INTO public.who_global_data_import VALUES (53769, '2020-06-19', 'MX', 'Mexico', 'AMRO', '4930', '159793', '770', '19080');
INSERT INTO public.who_global_data_import VALUES (53770, '2020-06-20', 'MX', 'Mexico', 'AMRO', '5662', '165455', '667', '19747');
INSERT INTO public.who_global_data_import VALUES (53771, '2020-06-21', 'MX', 'Mexico', 'AMRO', '5030', '170485', '647', '20394');
INSERT INTO public.who_global_data_import VALUES (53772, '2020-06-22', 'MX', 'Mexico', 'AMRO', '4717', '175202', '387', '20781');
INSERT INTO public.who_global_data_import VALUES (53773, '2020-06-23', 'MX', 'Mexico', 'AMRO', '5343', '180545', '1044', '21825');
INSERT INTO public.who_global_data_import VALUES (53774, '2020-06-24', 'MX', 'Mexico', 'AMRO', '4577', '185122', '759', '22584');
INSERT INTO public.who_global_data_import VALUES (53775, '2020-06-25', 'MX', 'Mexico', 'AMRO', '6288', '191410', '793', '23377');
INSERT INTO public.who_global_data_import VALUES (53776, '2020-06-26', 'MX', 'Mexico', 'AMRO', '5437', '196847', '947', '24324');
INSERT INTO public.who_global_data_import VALUES (53777, '2020-06-27', 'MX', 'Mexico', 'AMRO', '6104', '202951', '736', '25060');
INSERT INTO public.who_global_data_import VALUES (53778, '2020-06-28', 'MX', 'Mexico', 'AMRO', '5441', '208392', '719', '25779');
INSERT INTO public.who_global_data_import VALUES (53779, '2020-06-29', 'MX', 'Mexico', 'AMRO', '4410', '212802', '602', '26381');
INSERT INTO public.who_global_data_import VALUES (53780, '2020-06-30', 'MX', 'Mexico', 'AMRO', '4050', '216852', '267', '26648');
INSERT INTO public.who_global_data_import VALUES (53781, '2020-07-01', 'MX', 'Mexico', 'AMRO', '3805', '220657', '473', '27121');
INSERT INTO public.who_global_data_import VALUES (53782, '2020-07-02', 'MX', 'Mexico', 'AMRO', '5432', '226089', '648', '27769');
INSERT INTO public.who_global_data_import VALUES (53783, '2020-07-03', 'MX', 'Mexico', 'AMRO', '5681', '231770', '741', '28510');
INSERT INTO public.who_global_data_import VALUES (53784, '2020-07-04', 'MX', 'Mexico', 'AMRO', '6741', '238511', '679', '29189');
INSERT INTO public.who_global_data_import VALUES (53785, '2020-07-05', 'MX', 'Mexico', 'AMRO', '6740', '245251', '654', '29843');
INSERT INTO public.who_global_data_import VALUES (53786, '2020-07-06', 'MX', 'Mexico', 'AMRO', '6914', '252165', '523', '30366');
INSERT INTO public.who_global_data_import VALUES (53787, '2020-07-07', 'MX', 'Mexico', 'AMRO', '4683', '256848', '273', '30639');
INSERT INTO public.who_global_data_import VALUES (53788, '2020-07-08', 'MX', 'Mexico', 'AMRO', '4902', '261750', '480', '31119');
INSERT INTO public.who_global_data_import VALUES (53789, '2020-07-09', 'MX', 'Mexico', 'AMRO', '6258', '268008', '895', '32014');
INSERT INTO public.who_global_data_import VALUES (53790, '2020-07-10', 'MX', 'Mexico', 'AMRO', '6995', '275003', '782', '32796');
INSERT INTO public.who_global_data_import VALUES (53791, '2020-07-11', 'MX', 'Mexico', 'AMRO', '7280', '282283', '730', '33526');
INSERT INTO public.who_global_data_import VALUES (53792, '2020-07-12', 'MX', 'Mexico', 'AMRO', '6891', '289174', '665', '34191');
INSERT INTO public.who_global_data_import VALUES (53793, '2020-07-13', 'MX', 'Mexico', 'AMRO', '6094', '295268', '539', '34730');
INSERT INTO public.who_global_data_import VALUES (53794, '2020-07-14', 'MX', 'Mexico', 'AMRO', '4482', '299750', '276', '35006');
INSERT INTO public.who_global_data_import VALUES (53795, '2020-07-15', 'MX', 'Mexico', 'AMRO', '4685', '304435', '485', '35491');
INSERT INTO public.who_global_data_import VALUES (53796, '2020-07-16', 'MX', 'Mexico', 'AMRO', '7051', '311486', '836', '36327');
INSERT INTO public.who_global_data_import VALUES (53797, '2020-07-17', 'MX', 'Mexico', 'AMRO', '6149', '317635', '579', '36906');
INSERT INTO public.who_global_data_import VALUES (53798, '2020-07-18', 'MX', 'Mexico', 'AMRO', '6406', '324041', '668', '37574');
INSERT INTO public.who_global_data_import VALUES (53799, '2020-07-19', 'MX', 'Mexico', 'AMRO', '7257', '331298', '736', '38310');
INSERT INTO public.who_global_data_import VALUES (53800, '2020-07-20', 'MX', 'Mexico', 'AMRO', '7615', '338913', '578', '38888');
INSERT INTO public.who_global_data_import VALUES (53801, '2020-07-21', 'MX', 'Mexico', 'AMRO', '5311', '344224', '296', '39184');
INSERT INTO public.who_global_data_import VALUES (53802, '2020-07-22', 'MX', 'Mexico', 'AMRO', '5172', '349396', '301', '39485');
INSERT INTO public.who_global_data_import VALUES (53803, '2020-07-23', 'MX', 'Mexico', 'AMRO', '6859', '356255', '915', '40400');
INSERT INTO public.who_global_data_import VALUES (53804, '2020-07-24', 'MX', 'Mexico', 'AMRO', '6019', '362274', '790', '41190');
INSERT INTO public.who_global_data_import VALUES (53805, '2020-07-25', 'MX', 'Mexico', 'AMRO', '8438', '370712', '718', '41908');
INSERT INTO public.who_global_data_import VALUES (53806, '2020-07-26', 'MX', 'Mexico', 'AMRO', '7573', '378285', '737', '42645');
INSERT INTO public.who_global_data_import VALUES (53807, '2020-07-27', 'MX', 'Mexico', 'AMRO', '6751', '385036', '729', '43374');
INSERT INTO public.who_global_data_import VALUES (53808, '2020-07-28', 'MX', 'Mexico', 'AMRO', '5480', '390516', '306', '43680');
INSERT INTO public.who_global_data_import VALUES (53809, '2020-07-29', 'MX', 'Mexico', 'AMRO', '4973', '395489', '342', '44022');
INSERT INTO public.who_global_data_import VALUES (53810, '2020-07-30', 'MX', 'Mexico', 'AMRO', '7208', '402697', '854', '44876');
INSERT INTO public.who_global_data_import VALUES (53811, '2020-07-31', 'MX', 'Mexico', 'AMRO', '5752', '408449', '485', '45361');
INSERT INTO public.who_global_data_import VALUES (53812, '2020-08-01', 'MX', 'Mexico', 'AMRO', '7730', '416179', '639', '46000');
INSERT INTO public.who_global_data_import VALUES (53813, '2020-08-02', 'MX', 'Mexico', 'AMRO', '8458', '424637', '688', '46688');
INSERT INTO public.who_global_data_import VALUES (53814, '2020-08-03', 'MX', 'Mexico', 'AMRO', '9556', '434193', '784', '47472');
INSERT INTO public.who_global_data_import VALUES (53815, '2020-08-04', 'MX', 'Mexico', 'AMRO', '4853', '439046', '274', '47746');
INSERT INTO public.who_global_data_import VALUES (53816, '2020-08-05', 'MX', 'Mexico', 'AMRO', '4767', '443813', '266', '48012');
INSERT INTO public.who_global_data_import VALUES (53817, '2020-08-06', 'MX', 'Mexico', 'AMRO', '6148', '449961', '857', '48869');
INSERT INTO public.who_global_data_import VALUES (53818, '2020-08-07', 'MX', 'Mexico', 'AMRO', '6139', '456100', '829', '49698');
INSERT INTO public.who_global_data_import VALUES (53819, '2020-08-08', 'MX', 'Mexico', 'AMRO', '6590', '462690', '819', '50517');
INSERT INTO public.who_global_data_import VALUES (53820, '2020-08-09', 'MX', 'Mexico', 'AMRO', '6717', '469407', '794', '51311');
INSERT INTO public.who_global_data_import VALUES (53821, '2020-08-10', 'MX', 'Mexico', 'AMRO', '6495', '475902', '695', '52006');
INSERT INTO public.who_global_data_import VALUES (53822, '2020-08-11', 'MX', 'Mexico', 'AMRO', '4376', '480278', '292', '52298');
INSERT INTO public.who_global_data_import VALUES (53823, '2020-08-12', 'MX', 'Mexico', 'AMRO', '5558', '485836', '705', '53003');
INSERT INTO public.who_global_data_import VALUES (53824, '2020-08-13', 'MX', 'Mexico', 'AMRO', '6686', '492522', '926', '53929');
INSERT INTO public.who_global_data_import VALUES (53825, '2020-08-14', 'MX', 'Mexico', 'AMRO', '5858', '498380', '737', '54666');
INSERT INTO public.who_global_data_import VALUES (53826, '2020-08-15', 'MX', 'Mexico', 'AMRO', '7371', '505751', '627', '55293');
INSERT INTO public.who_global_data_import VALUES (53827, '2020-08-16', 'MX', 'Mexico', 'AMRO', '5618', '511369', '615', '55908');
INSERT INTO public.who_global_data_import VALUES (53828, '2020-08-17', 'MX', 'Mexico', 'AMRO', '6345', '517714', '635', '56543');
INSERT INTO public.who_global_data_import VALUES (53829, '2020-08-18', 'MX', 'Mexico', 'AMRO', '4448', '522162', '214', '56757');
INSERT INTO public.who_global_data_import VALUES (53830, '2020-08-19', 'MX', 'Mexico', 'AMRO', '3571', '525733', '266', '57023');
INSERT INTO public.who_global_data_import VALUES (53831, '2020-08-20', 'MX', 'Mexico', 'AMRO', '5506', '531239', '751', '57774');
INSERT INTO public.who_global_data_import VALUES (53832, '2020-08-21', 'MX', 'Mexico', 'AMRO', '5792', '537031', '707', '58481');
INSERT INTO public.who_global_data_import VALUES (53833, '2020-08-22', 'MX', 'Mexico', 'AMRO', '6775', '543806', '625', '59106');
INSERT INTO public.who_global_data_import VALUES (53834, '2020-08-23', 'MX', 'Mexico', 'AMRO', '5928', '549734', '504', '59610');
INSERT INTO public.who_global_data_import VALUES (53835, '2020-08-24', 'MX', 'Mexico', 'AMRO', '6482', '556216', '644', '60254');
INSERT INTO public.who_global_data_import VALUES (53836, '2020-08-25', 'MX', 'Mexico', 'AMRO', '3948', '560164', '226', '60480');
INSERT INTO public.who_global_data_import VALUES (53837, '2020-08-26', 'MX', 'Mexico', 'AMRO', '3541', '563705', '320', '60800');
INSERT INTO public.who_global_data_import VALUES (53838, '2020-08-27', 'MX', 'Mexico', 'AMRO', '4916', '568621', '650', '61450');
INSERT INTO public.who_global_data_import VALUES (53839, '2020-08-28', 'MX', 'Mexico', 'AMRO', '5267', '573888', '626', '62076');
INSERT INTO public.who_global_data_import VALUES (53840, '2020-08-29', 'MX', 'Mexico', 'AMRO', '6026', '579914', '518', '62594');
INSERT INTO public.who_global_data_import VALUES (53841, '2020-08-30', 'MX', 'Mexico', 'AMRO', '5824', '585738', '552', '63146');
INSERT INTO public.who_global_data_import VALUES (53842, '2020-08-31', 'MX', 'Mexico', 'AMRO', '5974', '591712', '673', '63819');
INSERT INTO public.who_global_data_import VALUES (53843, '2020-09-01', 'MX', 'Mexico', 'AMRO', '4129', '595841', '339', '64158');
INSERT INTO public.who_global_data_import VALUES (53844, '2020-09-02', 'MX', 'Mexico', 'AMRO', '3719', '599560', '256', '64414');
INSERT INTO public.who_global_data_import VALUES (53845, '2020-09-03', 'MX', 'Mexico', 'AMRO', '6476', '606036', '827', '65241');
INSERT INTO public.who_global_data_import VALUES (53846, '2020-09-04', 'MX', 'Mexico', 'AMRO', '4921', '610957', '575', '65816');
INSERT INTO public.who_global_data_import VALUES (53847, '2020-09-05', 'MX', 'Mexico', 'AMRO', '5937', '616894', '513', '66329');
INSERT INTO public.who_global_data_import VALUES (53848, '2020-09-06', 'MX', 'Mexico', 'AMRO', '6196', '623090', '522', '66851');
INSERT INTO public.who_global_data_import VALUES (53849, '2020-09-07', 'MX', 'Mexico', 'AMRO', '6319', '629409', '475', '67326');
INSERT INTO public.who_global_data_import VALUES (53850, '2020-09-08', 'MX', 'Mexico', 'AMRO', '4614', '634023', '232', '67558');
INSERT INTO public.who_global_data_import VALUES (53851, '2020-09-09', 'MX', 'Mexico', 'AMRO', '3486', '637509', '223', '67781');
INSERT INTO public.who_global_data_import VALUES (53852, '2020-09-10', 'MX', 'Mexico', 'AMRO', '5351', '642860', '703', '68484');
INSERT INTO public.who_global_data_import VALUES (53853, '2020-09-11', 'MX', 'Mexico', 'AMRO', '4647', '647507', '611', '69095');
INSERT INTO public.who_global_data_import VALUES (53854, '2020-09-12', 'MX', 'Mexico', 'AMRO', '4857', '652364', '554', '69649');
INSERT INTO public.who_global_data_import VALUES (53855, '2020-09-13', 'MX', 'Mexico', 'AMRO', '5935', '658299', '534', '70183');
INSERT INTO public.who_global_data_import VALUES (53856, '2020-09-14', 'MX', 'Mexico', 'AMRO', '5674', '663973', '421', '70604');
INSERT INTO public.who_global_data_import VALUES (53857, '2020-09-15', 'MX', 'Mexico', 'AMRO', '4408', '668381', '217', '70821');
INSERT INTO public.who_global_data_import VALUES (53858, '2020-09-16', 'MX', 'Mexico', 'AMRO', '3335', '671716', '228', '71049');
INSERT INTO public.who_global_data_import VALUES (53859, '2020-09-17', 'MX', 'Mexico', 'AMRO', '4771', '676487', '629', '71678');
INSERT INTO public.who_global_data_import VALUES (53860, '2020-09-18', 'MX', 'Mexico', 'AMRO', '4444', '680931', '300', '71978');
INSERT INTO public.who_global_data_import VALUES (53861, '2020-09-19', 'MX', 'Mexico', 'AMRO', '3182', '684113', '201', '72179');
INSERT INTO public.who_global_data_import VALUES (53862, '2020-09-20', 'MX', 'Mexico', 'AMRO', '4841', '688954', '624', '72803');
INSERT INTO public.who_global_data_import VALUES (53863, '2020-09-21', 'MX', 'Mexico', 'AMRO', '5167', '694121', '455', '73258');
INSERT INTO public.who_global_data_import VALUES (53864, '2020-09-22', 'MX', 'Mexico', 'AMRO', '3542', '697663', '235', '73493');
INSERT INTO public.who_global_data_import VALUES (53865, '2020-09-23', 'MX', 'Mexico', 'AMRO', '2917', '700580', '204', '73697');
INSERT INTO public.who_global_data_import VALUES (53866, '2020-09-24', 'MX', 'Mexico', 'AMRO', '4683', '705263', '651', '74348');
INSERT INTO public.who_global_data_import VALUES (53867, '2020-09-25', 'MX', 'Mexico', 'AMRO', '4786', '710049', '601', '74949');
INSERT INTO public.who_global_data_import VALUES (53868, '2020-09-26', 'MX', 'Mexico', 'AMRO', '5408', '715457', '490', '75439');
INSERT INTO public.who_global_data_import VALUES (53869, '2020-09-27', 'MX', 'Mexico', 'AMRO', '5401', '720858', '405', '75844');
INSERT INTO public.who_global_data_import VALUES (53870, '2020-09-28', 'MX', 'Mexico', 'AMRO', '5573', '726431', '399', '76243');
INSERT INTO public.who_global_data_import VALUES (53871, '2020-09-29', 'MX', 'Mexico', 'AMRO', '3886', '730317', '187', '76430');
INSERT INTO public.who_global_data_import VALUES (53872, '2020-09-30', 'MX', 'Mexico', 'AMRO', '3400', '733717', '173', '76603');
INSERT INTO public.who_global_data_import VALUES (53873, '2020-10-01', 'MX', 'Mexico', 'AMRO', '4446', '738163', '560', '77163');
INSERT INTO public.who_global_data_import VALUES (53874, '2020-10-02', 'MX', 'Mexico', 'AMRO', '5053', '743216', '483', '77646');
INSERT INTO public.who_global_data_import VALUES (53875, '2020-10-03', 'MX', 'Mexico', 'AMRO', '5099', '748315', '432', '78078');
INSERT INTO public.who_global_data_import VALUES (53876, '2020-10-04', 'MX', 'Mexico', 'AMRO', '4775', '753090', '414', '78492');
INSERT INTO public.who_global_data_import VALUES (53877, '2020-10-05', 'MX', 'Mexico', 'AMRO', '4863', '757953', '388', '78880');
INSERT INTO public.who_global_data_import VALUES (53878, '2020-10-06', 'MX', 'Mexico', 'AMRO', '3712', '761665', '208', '79088');
INSERT INTO public.who_global_data_import VALUES (53879, '2020-10-07', 'MX', 'Mexico', 'AMRO', '3417', '765082', '180', '79268');
INSERT INTO public.who_global_data_import VALUES (53880, '2020-10-08', 'MX', 'Mexico', 'AMRO', '4476', '769558', '446', '79714');
INSERT INTO public.who_global_data_import VALUES (53881, '2020-10-09', 'MX', 'Mexico', 'AMRO', '4462', '774020', '369', '80083');
INSERT INTO public.who_global_data_import VALUES (53882, '2020-10-10', 'MX', 'Mexico', 'AMRO', '30468', '804488', '3013', '83096');
INSERT INTO public.who_global_data_import VALUES (53883, '2020-10-11', 'MX', 'Mexico', 'AMRO', '5263', '809751', '411', '83507');
INSERT INTO public.who_global_data_import VALUES (53884, '2020-10-12', 'MX', 'Mexico', 'AMRO', '4577', '814328', '135', '83642');
INSERT INTO public.who_global_data_import VALUES (53885, '2020-10-13', 'MX', 'Mexico', 'AMRO', '3175', '817503', '139', '83781');
INSERT INTO public.who_global_data_import VALUES (53886, '2020-10-14', 'MX', 'Mexico', 'AMRO', '3542', '821045', '164', '83945');
INSERT INTO public.who_global_data_import VALUES (53887, '2020-10-15', 'MX', 'Mexico', 'AMRO', '4295', '825340', '475', '84420');
INSERT INTO public.who_global_data_import VALUES (53888, '2020-10-16', 'MX', 'Mexico', 'AMRO', '4056', '829396', '478', '84898');
INSERT INTO public.who_global_data_import VALUES (53889, '2020-10-17', 'MX', 'Mexico', 'AMRO', '5514', '834910', '387', '85285');
INSERT INTO public.who_global_data_import VALUES (53890, '2020-10-18', 'MX', 'Mexico', 'AMRO', '6751', '841661', '419', '85704');
INSERT INTO public.who_global_data_import VALUES (53891, '2020-10-19', 'MX', 'Mexico', 'AMRO', '5447', '847108', '355', '86059');
INSERT INTO public.who_global_data_import VALUES (53892, '2020-10-20', 'MX', 'Mexico', 'AMRO', '4119', '851227', '108', '86167');
INSERT INTO public.who_global_data_import VALUES (53893, '2020-10-21', 'MX', 'Mexico', 'AMRO', '3699', '854926', '171', '86338');
INSERT INTO public.who_global_data_import VALUES (53894, '2020-10-22', 'MX', 'Mexico', 'AMRO', '5788', '860714', '555', '86893');
INSERT INTO public.who_global_data_import VALUES (53895, '2020-10-23', 'MX', 'Mexico', 'AMRO', '6845', '867559', '522', '87415');
INSERT INTO public.who_global_data_import VALUES (53896, '2020-10-24', 'MX', 'Mexico', 'AMRO', '6612', '874171', '479', '87894');
INSERT INTO public.who_global_data_import VALUES (53897, '2020-10-25', 'MX', 'Mexico', 'AMRO', '6604', '880775', '418', '88312');
INSERT INTO public.who_global_data_import VALUES (53898, '2020-10-26', 'MX', 'Mexico', 'AMRO', '6025', '886800', '431', '88743');
INSERT INTO public.who_global_data_import VALUES (53899, '2020-10-27', 'MX', 'Mexico', 'AMRO', '4360', '891160', '181', '88924');
INSERT INTO public.who_global_data_import VALUES (53900, '2020-10-28', 'MX', 'Mexico', 'AMRO', '4166', '895326', '247', '89171');
INSERT INTO public.who_global_data_import VALUES (53901, '2020-10-29', 'MX', 'Mexico', 'AMRO', '5942', '901268', '643', '89814');
INSERT INTO public.who_global_data_import VALUES (53902, '2020-10-30', 'MX', 'Mexico', 'AMRO', '5595', '906863', '495', '90309');
INSERT INTO public.who_global_data_import VALUES (53903, '2020-10-31', 'MX', 'Mexico', 'AMRO', '5948', '912811', '464', '90773');
INSERT INTO public.who_global_data_import VALUES (53904, '2020-11-01', 'MX', 'Mexico', 'AMRO', '6000', '918811', '516', '91289');
INSERT INTO public.who_global_data_import VALUES (53905, '2020-11-02', 'MX', 'Mexico', 'AMRO', '6151', '924962', '464', '91753');
INSERT INTO public.who_global_data_import VALUES (53906, '2020-11-03', 'MX', 'Mexico', 'AMRO', '4430', '929392', '142', '91895');
INSERT INTO public.who_global_data_import VALUES (53907, '2020-11-04', 'MX', 'Mexico', 'AMRO', '3763', '933155', '205', '92100');
INSERT INTO public.who_global_data_import VALUES (53908, '2020-11-05', 'MX', 'Mexico', 'AMRO', '5250', '938405', '493', '92593');
INSERT INTO public.who_global_data_import VALUES (53909, '2020-11-06', 'MX', 'Mexico', 'AMRO', '5225', '943630', '635', '93228');
INSERT INTO public.who_global_data_import VALUES (53910, '2020-11-07', 'MX', 'Mexico', 'AMRO', '5567', '949197', '544', '93772');
INSERT INTO public.who_global_data_import VALUES (53911, '2020-11-08', 'MX', 'Mexico', 'AMRO', '5931', '955128', '551', '94323');
INSERT INTO public.who_global_data_import VALUES (53912, '2020-11-09', 'MX', 'Mexico', 'AMRO', '6810', '961938', '485', '94808');
INSERT INTO public.who_global_data_import VALUES (53913, '2020-11-10', 'MX', 'Mexico', 'AMRO', '5887', '967825', '219', '95027');
INSERT INTO public.who_global_data_import VALUES (53914, '2020-11-11', 'MX', 'Mexico', 'AMRO', '4960', '972785', '198', '95225');
INSERT INTO public.who_global_data_import VALUES (53915, '2020-11-12', 'MX', 'Mexico', 'AMRO', '5746', '978531', '617', '95842');
INSERT INTO public.who_global_data_import VALUES (53916, '2020-11-13', 'MX', 'Mexico', 'AMRO', '7646', '986177', '588', '96430');
INSERT INTO public.who_global_data_import VALUES (53917, '2020-11-14', 'MX', 'Mexico', 'AMRO', '5658', '991835', '626', '97056');
INSERT INTO public.who_global_data_import VALUES (53918, '2020-11-15', 'MX', 'Mexico', 'AMRO', '5558', '997393', '568', '97624');
INSERT INTO public.who_global_data_import VALUES (53919, '2020-11-16', 'MX', 'Mexico', 'AMRO', '5860', '1003253', '635', '98259');
INSERT INTO public.who_global_data_import VALUES (53920, '2020-11-17', 'MX', 'Mexico', 'AMRO', '3269', '1006522', '283', '98542');
INSERT INTO public.who_global_data_import VALUES (53921, '2020-11-18', 'MX', 'Mexico', 'AMRO', '2874', '1009396', '319', '98861');
INSERT INTO public.who_global_data_import VALUES (53922, '2020-11-19', 'MX', 'Mexico', 'AMRO', '1757', '1011153', '165', '99026');
INSERT INTO public.who_global_data_import VALUES (53923, '2020-11-20', 'MX', 'Mexico', 'AMRO', '3918', '1015071', '502', '99528');
INSERT INTO public.who_global_data_import VALUES (53924, '2020-11-21', 'MX', 'Mexico', 'AMRO', '4472', '1019543', '576', '100104');
INSERT INTO public.who_global_data_import VALUES (53925, '2020-11-22', 'MX', 'Mexico', 'AMRO', '6426', '1025969', '719', '100823');
INSERT INTO public.who_global_data_import VALUES (53926, '2020-11-23', 'MX', 'Mexico', 'AMRO', '6719', '1032688', '550', '101373');
INSERT INTO public.who_global_data_import VALUES (53927, '2020-11-24', 'MX', 'Mexico', 'AMRO', '9187', '1041875', '303', '101676');
INSERT INTO public.who_global_data_import VALUES (53928, '2020-11-25', 'MX', 'Mexico', 'AMRO', '7483', '1049358', '250', '101926');
INSERT INTO public.who_global_data_import VALUES (53929, '2020-11-26', 'MX', 'Mexico', 'AMRO', '10794', '1060152', '813', '102739');
INSERT INTO public.who_global_data_import VALUES (53930, '2020-11-27', 'MX', 'Mexico', 'AMRO', '10335', '1070487', '858', '103597');
INSERT INTO public.who_global_data_import VALUES (53931, '2020-11-28', 'MX', 'Mexico', 'AMRO', '8107', '1078594', '645', '104242');
INSERT INTO public.who_global_data_import VALUES (53932, '2020-11-29', 'MX', 'Mexico', 'AMRO', '12081', '1090675', '631', '104873');
INSERT INTO public.who_global_data_import VALUES (53933, '2020-11-30', 'MX', 'Mexico', 'AMRO', '10008', '1100683', '586', '105459');
INSERT INTO public.who_global_data_import VALUES (53934, '2020-12-01', 'MX', 'Mexico', 'AMRO', '6388', '1107071', '196', '105655');
INSERT INTO public.who_global_data_import VALUES (53935, '2020-12-02', 'MX', 'Mexico', 'AMRO', '6472', '1113543', '285', '105940');
INSERT INTO public.who_global_data_import VALUES (53936, '2020-12-03', 'MX', 'Mexico', 'AMRO', '8819', '1122362', '825', '106765');
INSERT INTO public.who_global_data_import VALUES (53937, '2020-12-04', 'MX', 'Mexico', 'AMRO', '11251', '1133613', '800', '107565');
INSERT INTO public.who_global_data_import VALUES (53938, '2020-12-05', 'MX', 'Mexico', 'AMRO', '11030', '1144643', '608', '108173');
INSERT INTO public.who_global_data_import VALUES (53939, '2020-12-06', 'MX', 'Mexico', 'AMRO', '12127', '1156770', '690', '108863');
INSERT INTO public.who_global_data_import VALUES (53940, '2020-12-07', 'MX', 'Mexico', 'AMRO', '11625', '1168395', '593', '109456');
INSERT INTO public.who_global_data_import VALUES (53941, '2020-12-08', 'MX', 'Mexico', 'AMRO', '7455', '1175850', '261', '109717');
INSERT INTO public.who_global_data_import VALUES (53942, '2020-12-09', 'MX', 'Mexico', 'AMRO', '6399', '1182249', '357', '110074');
INSERT INTO public.who_global_data_import VALUES (53943, '2020-12-10', 'MX', 'Mexico', 'AMRO', '11006', '1193255', '800', '110874');
INSERT INTO public.who_global_data_import VALUES (53944, '2020-12-11', 'MX', 'Mexico', 'AMRO', '11974', '1205229', '781', '111655');
INSERT INTO public.who_global_data_import VALUES (53945, '2020-12-12', 'MX', 'Mexico', 'AMRO', '11897', '1217126', '671', '112326');
INSERT INTO public.who_global_data_import VALUES (53946, '2020-12-13', 'MX', 'Mexico', 'AMRO', '12253', '1229379', '693', '113019');
INSERT INTO public.who_global_data_import VALUES (53947, '2020-12-14', 'MX', 'Mexico', 'AMRO', '12057', '1241436', '685', '113704');
INSERT INTO public.who_global_data_import VALUES (53948, '2020-12-15', 'MX', 'Mexico', 'AMRO', '8608', '1250044', '249', '113953');
INSERT INTO public.who_global_data_import VALUES (53949, '2020-12-16', 'MX', 'Mexico', 'AMRO', '5930', '1255974', '345', '114298');
INSERT INTO public.who_global_data_import VALUES (53950, '2020-12-17', 'MX', 'Mexico', 'AMRO', '11228', '1267202', '801', '115099');
INSERT INTO public.who_global_data_import VALUES (53951, '2020-12-18', 'MX', 'Mexico', 'AMRO', '10297', '1277499', '670', '115769');
INSERT INTO public.who_global_data_import VALUES (53952, '2020-12-19', 'MX', 'Mexico', 'AMRO', '11799', '1289298', '718', '116487');
INSERT INTO public.who_global_data_import VALUES (53953, '2020-12-20', 'MX', 'Mexico', 'AMRO', '12248', '1301546', '762', '117249');
INSERT INTO public.who_global_data_import VALUES (53954, '2020-12-21', 'MX', 'Mexico', 'AMRO', '12129', '1313675', '627', '117876');
INSERT INTO public.who_global_data_import VALUES (53955, '2020-12-22', 'MX', 'Mexico', 'AMRO', '6870', '1320545', '326', '118202');
INSERT INTO public.who_global_data_import VALUES (53956, '2020-12-23', 'MX', 'Mexico', 'AMRO', '5370', '1325915', '396', '118598');
INSERT INTO public.who_global_data_import VALUES (53957, '2020-12-24', 'MX', 'Mexico', 'AMRO', '12511', '1338426', '897', '119495');
INSERT INTO public.who_global_data_import VALUES (53958, '2020-12-25', 'MX', 'Mexico', 'AMRO', '11653', '1350079', '816', '120311');
INSERT INTO public.who_global_data_import VALUES (53959, '2020-12-26', 'MX', 'Mexico', 'AMRO', '12485', '1362564', '861', '121172');
INSERT INTO public.who_global_data_import VALUES (53960, '2020-12-27', 'MX', 'Mexico', 'AMRO', '9679', '1372243', '665', '121837');
INSERT INTO public.who_global_data_import VALUES (53961, '2020-12-28', 'MX', 'Mexico', 'AMRO', '4974', '1377217', '189', '122026');
INSERT INTO public.who_global_data_import VALUES (53962, '2020-12-29', 'MX', 'Mexico', 'AMRO', '6217', '1383434', '400', '122426');
INSERT INTO public.who_global_data_import VALUES (53963, '2020-12-30', 'MX', 'Mexico', 'AMRO', '5996', '1389430', '429', '122855');
INSERT INTO public.who_global_data_import VALUES (53964, '2020-12-31', 'MX', 'Mexico', 'AMRO', '12099', '1401529', '990', '123845');
INSERT INTO public.who_global_data_import VALUES (53965, '2021-01-01', 'MX', 'Mexico', 'AMRO', '12406', '1413935', '1052', '124897');
INSERT INTO public.who_global_data_import VALUES (53966, '2021-01-02', 'MX', 'Mexico', 'AMRO', '12159', '1426094', '910', '125807');
INSERT INTO public.who_global_data_import VALUES (53967, '2021-01-03', 'MX', 'Mexico', 'AMRO', '11091', '1437185', '700', '126507');
INSERT INTO public.who_global_data_import VALUES (53968, '2021-01-04', 'MX', 'Mexico', 'AMRO', '6359', '1443544', '344', '126851');
INSERT INTO public.who_global_data_import VALUES (53969, '2021-01-05', 'MX', 'Mexico', 'AMRO', '5211', '1448755', '362', '127213');
INSERT INTO public.who_global_data_import VALUES (53970, '2021-01-06', 'MX', 'Mexico', 'AMRO', '6464', '1455219', '544', '127757');
INSERT INTO public.who_global_data_import VALUES (53971, '2021-01-07', 'MX', 'Mexico', 'AMRO', '11271', '1466490', '1065', '128822');
INSERT INTO public.who_global_data_import VALUES (53972, '2021-01-08', 'MX', 'Mexico', 'AMRO', '13345', '1479835', '1165', '129987');
INSERT INTO public.who_global_data_import VALUES (53973, '2021-01-09', 'MX', 'Mexico', 'AMRO', '13734', '1493569', '1044', '131031');
INSERT INTO public.who_global_data_import VALUES (53974, '2021-01-10', 'MX', 'Mexico', 'AMRO', '14362', '1507931', '1038', '132069');
INSERT INTO public.who_global_data_import VALUES (53975, '2021-01-11', 'MX', 'Mexico', 'AMRO', '16105', '1524036', '1135', '133204');
INSERT INTO public.who_global_data_import VALUES (53976, '2021-01-12', 'MX', 'Mexico', 'AMRO', '10003', '1534039', '502', '133706');
INSERT INTO public.who_global_data_import VALUES (53977, '2021-01-13', 'MX', 'Mexico', 'AMRO', '7594', '1541633', '662', '134368');
INSERT INTO public.who_global_data_import VALUES (53978, '2021-01-14', 'MX', 'Mexico', 'AMRO', '14395', '1556028', '1314', '135682');
INSERT INTO public.who_global_data_import VALUES (53979, '2021-01-15', 'MX', 'Mexico', 'AMRO', '15873', '1571901', '1235', '136917');
INSERT INTO public.who_global_data_import VALUES (53980, '2021-01-16', 'MX', 'Mexico', 'AMRO', '16468', '1588369', '999', '137916');
INSERT INTO public.who_global_data_import VALUES (53981, '2021-01-17', 'MX', 'Mexico', 'AMRO', '21366', '1609735', '1106', '139022');
INSERT INTO public.who_global_data_import VALUES (53982, '2021-01-18', 'MX', 'Mexico', 'AMRO', '20523', '1630258', '1219', '140241');
INSERT INTO public.who_global_data_import VALUES (53983, '2021-01-19', 'MX', 'Mexico', 'AMRO', '11170', '1641428', '463', '140704');
INSERT INTO public.who_global_data_import VALUES (53984, '2021-01-20', 'MX', 'Mexico', 'AMRO', '8074', '1649502', '544', '141248');
INSERT INTO public.who_global_data_import VALUES (53985, '2021-01-21', 'MX', 'Mexico', 'AMRO', '18894', '1668396', '1584', '142832');
INSERT INTO public.who_global_data_import VALUES (53986, '2021-01-22', 'MX', 'Mexico', 'AMRO', '20548', '1688944', '1539', '144371');
INSERT INTO public.who_global_data_import VALUES (53987, '2021-01-23', 'MX', 'Mexico', 'AMRO', '22339', '1711283', '1803', '146174');
INSERT INTO public.who_global_data_import VALUES (53988, '2021-01-24', 'MX', 'Mexico', 'AMRO', '21007', '1732290', '1440', '147614');
INSERT INTO public.who_global_data_import VALUES (53989, '2021-01-25', 'MX', 'Mexico', 'AMRO', '20057', '1752347', '1470', '149084');
INSERT INTO public.who_global_data_import VALUES (53990, '2021-01-26', 'MX', 'Mexico', 'AMRO', '10872', '1763219', '530', '149614');
INSERT INTO public.who_global_data_import VALUES (53991, '2021-01-27', 'MX', 'Mexico', 'AMRO', '8521', '1771740', '659', '150273');
INSERT INTO public.who_global_data_import VALUES (53992, '2021-01-28', 'MX', 'Mexico', 'AMRO', '17165', '1788905', '1743', '152016');
INSERT INTO public.who_global_data_import VALUES (53993, '2021-01-29', 'MX', 'Mexico', 'AMRO', '17944', '1806849', '1623', '153639');
INSERT INTO public.who_global_data_import VALUES (53994, '2021-01-30', 'MX', 'Mexico', 'AMRO', '18670', '1825519', '1506', '155145');
INSERT INTO public.who_global_data_import VALUES (53995, '2021-01-31', 'MX', 'Mexico', 'AMRO', '16374', '1841893', '1434', '156579');
INSERT INTO public.who_global_data_import VALUES (53996, '2021-02-01', 'MX', 'Mexico', 'AMRO', '15337', '1857230', '1495', '158074');
INSERT INTO public.who_global_data_import VALUES (53997, '2021-02-02', 'MX', 'Mexico', 'AMRO', '7030', '1864260', '462', '158536');
INSERT INTO public.who_global_data_import VALUES (53998, '2021-02-03', 'MX', 'Mexico', 'AMRO', '5448', '1869708', '564', '159100');
INSERT INTO public.who_global_data_import VALUES (53999, '2021-02-04', 'MX', 'Mexico', 'AMRO', '4384', '1874092', '433', '159533');
INSERT INTO public.who_global_data_import VALUES (54000, '2021-02-05', 'MX', 'Mexico', 'AMRO', '12153', '1886245', '1707', '161240');
INSERT INTO public.who_global_data_import VALUES (54001, '2020-01-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54002, '2020-01-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54003, '2020-01-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54004, '2020-01-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54005, '2020-01-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54006, '2020-01-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54007, '2020-01-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54008, '2020-01-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54009, '2020-01-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54010, '2020-01-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54011, '2020-01-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54012, '2020-01-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54013, '2020-01-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54014, '2020-01-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54015, '2020-01-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54016, '2020-01-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54017, '2020-01-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54018, '2020-01-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54019, '2020-01-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54020, '2020-01-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54021, '2020-01-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54022, '2020-01-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54023, '2020-01-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54024, '2020-01-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54025, '2020-01-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54026, '2020-01-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54027, '2020-01-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54028, '2020-01-30', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54029, '2020-01-31', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54030, '2020-02-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54031, '2020-02-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54032, '2020-02-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54033, '2020-02-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54034, '2020-02-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54035, '2020-02-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54036, '2020-02-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54037, '2020-02-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54038, '2020-02-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54039, '2020-02-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54040, '2020-02-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54041, '2020-02-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54042, '2020-02-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54043, '2020-02-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54044, '2020-02-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54045, '2020-02-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54046, '2020-02-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54047, '2020-02-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54048, '2020-02-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54049, '2020-02-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54050, '2020-02-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54051, '2020-02-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54052, '2020-02-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54053, '2020-02-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54054, '2020-02-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54055, '2020-02-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54056, '2020-02-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54057, '2020-02-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54058, '2020-02-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54059, '2020-03-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54060, '2020-03-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54061, '2020-03-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54062, '2020-03-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54063, '2020-03-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54064, '2020-03-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54065, '2020-03-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54066, '2020-03-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54067, '2020-03-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54068, '2020-03-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54069, '2020-03-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54070, '2020-03-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54071, '2020-03-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54072, '2020-03-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54073, '2020-03-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54074, '2020-03-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54075, '2020-03-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54076, '2020-03-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54077, '2020-03-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54078, '2020-03-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54079, '2020-03-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54080, '2020-03-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54081, '2020-03-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54082, '2020-03-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54083, '2020-03-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54084, '2020-03-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54085, '2020-03-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54086, '2020-03-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54087, '2020-03-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54088, '2020-03-30', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54089, '2020-03-31', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54090, '2020-04-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54091, '2020-04-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54092, '2020-04-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54093, '2020-04-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54094, '2020-04-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54095, '2020-04-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54096, '2020-04-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54097, '2020-04-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54098, '2020-04-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54099, '2020-04-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54100, '2020-04-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54101, '2020-04-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54102, '2020-04-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54103, '2020-04-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54104, '2020-04-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54105, '2020-04-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54106, '2020-04-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54107, '2020-04-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54108, '2020-04-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54109, '2020-04-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54110, '2020-04-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54111, '2020-04-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54112, '2020-04-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54113, '2020-04-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54114, '2020-04-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54115, '2020-04-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54116, '2020-04-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54117, '2020-04-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54118, '2020-04-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54119, '2020-04-30', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54120, '2020-05-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54121, '2020-05-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54122, '2020-05-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54123, '2020-05-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54124, '2020-05-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54125, '2020-05-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54126, '2020-05-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54127, '2020-05-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54128, '2020-05-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54129, '2020-05-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54130, '2020-05-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54131, '2020-05-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54132, '2020-05-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54133, '2020-05-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54134, '2020-05-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54135, '2020-05-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54136, '2020-05-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54137, '2020-05-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54138, '2020-05-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54139, '2020-05-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54140, '2020-05-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54141, '2020-05-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54142, '2020-05-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54143, '2020-05-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54144, '2020-05-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54145, '2020-05-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54146, '2020-05-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54147, '2020-05-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54148, '2020-05-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54149, '2020-05-30', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54150, '2020-05-31', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54151, '2020-06-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54152, '2020-06-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54423, '2020-01-25', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54153, '2020-06-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54154, '2020-06-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54155, '2020-06-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54156, '2020-06-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54157, '2020-06-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54158, '2020-06-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54159, '2020-06-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54160, '2020-06-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54161, '2020-06-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54162, '2020-06-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54163, '2020-06-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54164, '2020-06-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54165, '2020-06-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54166, '2020-06-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54167, '2020-06-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54168, '2020-06-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54169, '2020-06-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54170, '2020-06-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54171, '2020-06-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54172, '2020-06-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54173, '2020-06-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54174, '2020-06-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54175, '2020-06-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54176, '2020-06-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54177, '2020-06-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54178, '2020-06-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54179, '2020-06-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54180, '2020-06-30', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54181, '2020-07-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54182, '2020-07-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54183, '2020-07-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54184, '2020-07-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54185, '2020-07-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54186, '2020-07-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54187, '2020-07-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54188, '2020-07-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54189, '2020-07-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54190, '2020-07-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54191, '2020-07-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54192, '2020-07-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54193, '2020-07-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54194, '2020-07-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54195, '2020-07-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54196, '2020-07-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54197, '2020-07-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54198, '2020-07-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54199, '2020-07-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54200, '2020-07-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54201, '2020-07-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54202, '2020-07-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54203, '2020-07-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54204, '2020-07-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54205, '2020-07-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54206, '2020-07-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54207, '2020-07-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54208, '2020-07-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54209, '2020-07-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54210, '2020-07-30', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54211, '2020-07-31', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54212, '2020-08-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54213, '2020-08-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54214, '2020-08-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54215, '2020-08-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54216, '2020-08-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54217, '2020-08-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54218, '2020-08-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54219, '2020-08-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54220, '2020-08-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54221, '2020-08-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54222, '2020-08-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54223, '2020-08-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54224, '2020-08-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54225, '2020-08-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54226, '2020-08-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54227, '2020-08-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54228, '2020-08-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54229, '2020-08-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54230, '2020-08-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54231, '2020-08-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54232, '2020-08-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54233, '2020-08-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54234, '2020-08-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54235, '2020-08-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54236, '2020-08-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54237, '2020-08-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54238, '2020-08-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54239, '2020-08-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54240, '2020-08-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54424, '2020-01-26', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54241, '2020-08-30', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54242, '2020-08-31', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54243, '2020-09-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54244, '2020-09-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54245, '2020-09-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54246, '2020-09-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54247, '2020-09-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54248, '2020-09-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54249, '2020-09-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54250, '2020-09-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54251, '2020-09-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54252, '2020-09-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54253, '2020-09-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54254, '2020-09-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54255, '2020-09-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54256, '2020-09-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54257, '2020-09-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54258, '2020-09-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54259, '2020-09-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54260, '2020-09-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54261, '2020-09-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54262, '2020-09-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54263, '2020-09-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54264, '2020-09-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54265, '2020-09-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54266, '2020-09-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54267, '2020-09-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54268, '2020-09-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54269, '2020-09-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54270, '2020-09-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54271, '2020-09-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54272, '2020-09-30', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54273, '2020-10-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54274, '2020-10-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54275, '2020-10-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54276, '2020-10-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54277, '2020-10-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54278, '2020-10-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54279, '2020-10-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54280, '2020-10-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54281, '2020-10-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54282, '2020-10-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54283, '2020-10-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54284, '2020-10-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54285, '2020-10-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54286, '2020-10-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54287, '2020-10-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54288, '2020-10-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54289, '2020-10-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54290, '2020-10-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54291, '2020-10-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54292, '2020-10-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54293, '2020-10-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54294, '2020-10-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54295, '2020-10-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54296, '2020-10-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54297, '2020-10-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54298, '2020-10-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54299, '2020-10-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54300, '2020-10-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54301, '2020-10-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54302, '2020-10-30', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54303, '2020-10-31', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54304, '2020-11-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54305, '2020-11-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54306, '2020-11-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54307, '2020-11-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54308, '2020-11-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54309, '2020-11-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54310, '2020-11-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54311, '2020-11-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54312, '2020-11-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54313, '2020-11-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54314, '2020-11-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54315, '2020-11-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54316, '2020-11-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54317, '2020-11-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54318, '2020-11-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54319, '2020-11-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54320, '2020-11-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54321, '2020-11-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54322, '2020-11-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54323, '2020-11-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54324, '2020-11-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54325, '2020-11-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54326, '2020-11-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54327, '2020-11-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54328, '2020-11-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54425, '2020-01-27', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54329, '2020-11-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54330, '2020-11-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54331, '2020-11-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54332, '2020-11-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54333, '2020-11-30', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54334, '2020-12-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54335, '2020-12-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54336, '2020-12-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54337, '2020-12-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54338, '2020-12-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54339, '2020-12-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54340, '2020-12-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54341, '2020-12-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54342, '2020-12-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54343, '2020-12-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54344, '2020-12-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54345, '2020-12-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54346, '2020-12-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54347, '2020-12-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54348, '2020-12-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54349, '2020-12-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54350, '2020-12-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54351, '2020-12-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54352, '2020-12-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54353, '2020-12-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54354, '2020-12-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54355, '2020-12-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54356, '2020-12-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54357, '2020-12-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54358, '2020-12-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54359, '2020-12-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54360, '2020-12-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54361, '2020-12-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54362, '2020-12-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54363, '2020-12-30', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54364, '2020-12-31', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54365, '2021-01-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54366, '2021-01-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54367, '2021-01-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54368, '2021-01-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54369, '2021-01-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54370, '2021-01-06', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54371, '2021-01-07', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54372, '2021-01-08', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54373, '2021-01-09', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54374, '2021-01-10', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54375, '2021-01-11', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54376, '2021-01-12', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54377, '2021-01-13', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54378, '2021-01-14', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54379, '2021-01-15', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54380, '2021-01-16', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54381, '2021-01-17', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54382, '2021-01-18', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54383, '2021-01-19', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54384, '2021-01-20', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54385, '2021-01-21', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54386, '2021-01-22', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54387, '2021-01-23', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54388, '2021-01-24', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54389, '2021-01-25', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54390, '2021-01-26', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54391, '2021-01-27', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54392, '2021-01-28', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54393, '2021-01-29', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54394, '2021-01-30', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54395, '2021-01-31', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54396, '2021-02-01', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54397, '2021-02-02', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54398, '2021-02-03', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54399, '2021-02-04', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54400, '2021-02-05', 'FM', 'Micronesia (Federated States of)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54401, '2020-01-03', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54402, '2020-01-04', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54403, '2020-01-05', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54404, '2020-01-06', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54405, '2020-01-07', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54406, '2020-01-08', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54407, '2020-01-09', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54408, '2020-01-10', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54409, '2020-01-11', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54410, '2020-01-12', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54411, '2020-01-13', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54412, '2020-01-14', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54413, '2020-01-15', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54414, '2020-01-16', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54415, '2020-01-17', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54416, '2020-01-18', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54417, '2020-01-19', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54418, '2020-01-20', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54419, '2020-01-21', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54420, '2020-01-22', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54421, '2020-01-23', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54422, '2020-01-24', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54426, '2020-01-28', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54427, '2020-01-29', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54428, '2020-01-30', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54429, '2020-01-31', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54430, '2020-02-01', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54431, '2020-02-02', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54432, '2020-02-03', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54433, '2020-02-04', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54434, '2020-02-05', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54435, '2020-02-06', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54436, '2020-02-07', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54437, '2020-02-08', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54438, '2020-02-09', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54439, '2020-02-10', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54440, '2020-02-11', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54441, '2020-02-12', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54442, '2020-02-13', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54443, '2020-02-14', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54444, '2020-02-15', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54445, '2020-02-16', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54446, '2020-02-17', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54447, '2020-02-18', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54448, '2020-02-19', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54449, '2020-02-20', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54450, '2020-02-21', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54451, '2020-02-22', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54452, '2020-02-23', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54453, '2020-02-24', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54454, '2020-02-25', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54455, '2020-02-26', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54456, '2020-02-27', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54457, '2020-02-28', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54458, '2020-02-29', 'MC', 'Monaco', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54459, '2020-03-01', 'MC', 'Monaco', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54460, '2020-03-02', 'MC', 'Monaco', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54461, '2020-03-03', 'MC', 'Monaco', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54462, '2020-03-04', 'MC', 'Monaco', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54463, '2020-03-05', 'MC', 'Monaco', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54464, '2020-03-06', 'MC', 'Monaco', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54465, '2020-03-07', 'MC', 'Monaco', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54466, '2020-03-08', 'MC', 'Monaco', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54467, '2020-03-09', 'MC', 'Monaco', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54468, '2020-03-10', 'MC', 'Monaco', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54469, '2020-03-11', 'MC', 'Monaco', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54470, '2020-03-12', 'MC', 'Monaco', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54471, '2020-03-13', 'MC', 'Monaco', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54472, '2020-03-14', 'MC', 'Monaco', 'EURO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54473, '2020-03-15', 'MC', 'Monaco', 'EURO', '4', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54474, '2020-03-16', 'MC', 'Monaco', 'EURO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54475, '2020-03-17', 'MC', 'Monaco', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54476, '2020-03-18', 'MC', 'Monaco', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54477, '2020-03-19', 'MC', 'Monaco', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54478, '2020-03-20', 'MC', 'Monaco', 'EURO', '3', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54479, '2020-03-21', 'MC', 'Monaco', 'EURO', '6', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54480, '2020-03-22', 'MC', 'Monaco', 'EURO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54481, '2020-03-23', 'MC', 'Monaco', 'EURO', '2', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54482, '2020-03-24', 'MC', 'Monaco', 'EURO', '2', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54483, '2020-03-25', 'MC', 'Monaco', 'EURO', '1', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54484, '2020-03-26', 'MC', 'Monaco', 'EURO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54485, '2020-03-27', 'MC', 'Monaco', 'EURO', '3', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54486, '2020-03-28', 'MC', 'Monaco', 'EURO', '6', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54487, '2020-03-29', 'MC', 'Monaco', 'EURO', '1', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54488, '2020-03-30', 'MC', 'Monaco', 'EURO', '2', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54489, '2020-03-31', 'MC', 'Monaco', 'EURO', '1', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54490, '2020-04-01', 'MC', 'Monaco', 'EURO', '1', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54491, '2020-04-02', 'MC', 'Monaco', 'EURO', '3', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54492, '2020-04-03', 'MC', 'Monaco', 'EURO', '3', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54493, '2020-04-04', 'MC', 'Monaco', 'EURO', '4', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54494, '2020-04-05', 'MC', 'Monaco', 'EURO', '1', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54495, '2020-04-06', 'MC', 'Monaco', 'EURO', '3', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54496, '2020-04-07', 'MC', 'Monaco', 'EURO', '1', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54497, '2020-04-08', 'MC', 'Monaco', 'EURO', '2', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54498, '2020-04-09', 'MC', 'Monaco', 'EURO', '0', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54499, '2020-04-10', 'MC', 'Monaco', 'EURO', '3', '57', '1', '1');
INSERT INTO public.who_global_data_import VALUES (54500, '2020-04-11', 'MC', 'Monaco', 'EURO', '6', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54501, '2020-04-12', 'MC', 'Monaco', 'EURO', '0', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54502, '2020-04-13', 'MC', 'Monaco', 'EURO', '1', '64', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54503, '2020-04-14', 'MC', 'Monaco', 'EURO', '0', '64', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54504, '2020-04-15', 'MC', 'Monaco', 'EURO', '0', '64', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54505, '2020-04-16', 'MC', 'Monaco', 'EURO', '0', '64', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54506, '2020-04-17', 'MC', 'Monaco', 'EURO', '0', '64', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54507, '2020-04-18', 'MC', 'Monaco', 'EURO', '1', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54508, '2020-04-19', 'MC', 'Monaco', 'EURO', '0', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54509, '2020-04-20', 'MC', 'Monaco', 'EURO', '0', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54510, '2020-04-21', 'MC', 'Monaco', 'EURO', '0', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54511, '2020-04-22', 'MC', 'Monaco', 'EURO', '0', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54512, '2020-04-23', 'MC', 'Monaco', 'EURO', '0', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54513, '2020-04-24', 'MC', 'Monaco', 'EURO', '0', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54514, '2020-04-25', 'MC', 'Monaco', 'EURO', '0', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54515, '2020-04-26', 'MC', 'Monaco', 'EURO', '0', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54516, '2020-04-27', 'MC', 'Monaco', 'EURO', '0', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54517, '2020-04-28', 'MC', 'Monaco', 'EURO', '1', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54518, '2020-04-29', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54519, '2020-04-30', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54520, '2020-05-01', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54521, '2020-05-02', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54522, '2020-05-03', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54523, '2020-05-04', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54524, '2020-05-05', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54525, '2020-05-06', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54526, '2020-05-07', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54527, '2020-05-08', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54528, '2020-05-09', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54529, '2020-05-10', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54530, '2020-05-11', 'MC', 'Monaco', 'EURO', '0', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54531, '2020-05-12', 'MC', 'Monaco', 'EURO', '1', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54532, '2020-05-13', 'MC', 'Monaco', 'EURO', '0', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54533, '2020-05-14', 'MC', 'Monaco', 'EURO', '0', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54534, '2020-05-15', 'MC', 'Monaco', 'EURO', '0', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54535, '2020-05-16', 'MC', 'Monaco', 'EURO', '0', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54536, '2020-05-17', 'MC', 'Monaco', 'EURO', '0', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54537, '2020-05-18', 'MC', 'Monaco', 'EURO', '0', '67', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54538, '2020-05-19', 'MC', 'Monaco', 'EURO', '1', '68', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54539, '2020-05-20', 'MC', 'Monaco', 'EURO', '0', '68', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54540, '2020-05-21', 'MC', 'Monaco', 'EURO', '0', '68', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54541, '2020-05-22', 'MC', 'Monaco', 'EURO', '0', '68', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54542, '2020-05-23', 'MC', 'Monaco', 'EURO', '0', '68', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54543, '2020-05-24', 'MC', 'Monaco', 'EURO', '0', '68', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54544, '2020-05-25', 'MC', 'Monaco', 'EURO', '2', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54545, '2020-05-26', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54546, '2020-05-27', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54547, '2020-05-28', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54548, '2020-05-29', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54549, '2020-05-30', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54550, '2020-05-31', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54551, '2020-06-01', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54552, '2020-06-02', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54553, '2020-06-03', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54554, '2020-06-04', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54555, '2020-06-05', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54556, '2020-06-06', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54557, '2020-06-07', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54558, '2020-06-08', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54559, '2020-06-09', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54560, '2020-06-10', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54561, '2020-06-11', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54562, '2020-06-12', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54563, '2020-06-13', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54564, '2020-06-14', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54565, '2020-06-15', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54566, '2020-06-16', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54567, '2020-06-17', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54568, '2020-06-18', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54569, '2020-06-19', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54570, '2020-06-20', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54571, '2020-06-21', 'MC', 'Monaco', 'EURO', '0', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54572, '2020-06-22', 'MC', 'Monaco', 'EURO', '1', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54573, '2020-06-23', 'MC', 'Monaco', 'EURO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54574, '2020-06-24', 'MC', 'Monaco', 'EURO', '0', '71', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54575, '2020-06-25', 'MC', 'Monaco', 'EURO', '1', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54576, '2020-06-26', 'MC', 'Monaco', 'EURO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54577, '2020-06-27', 'MC', 'Monaco', 'EURO', '0', '72', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54578, '2020-06-28', 'MC', 'Monaco', 'EURO', '1', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54579, '2020-06-29', 'MC', 'Monaco', 'EURO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54580, '2020-06-30', 'MC', 'Monaco', 'EURO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54581, '2020-07-01', 'MC', 'Monaco', 'EURO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54582, '2020-07-02', 'MC', 'Monaco', 'EURO', '0', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54583, '2020-07-03', 'MC', 'Monaco', 'EURO', '3', '76', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54584, '2020-07-04', 'MC', 'Monaco', 'EURO', '0', '76', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54585, '2020-07-05', 'MC', 'Monaco', 'EURO', '0', '76', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54586, '2020-07-06', 'MC', 'Monaco', 'EURO', '2', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54587, '2020-07-07', 'MC', 'Monaco', 'EURO', '0', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54588, '2020-07-08', 'MC', 'Monaco', 'EURO', '0', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54589, '2020-07-09', 'MC', 'Monaco', 'EURO', '0', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54590, '2020-07-10', 'MC', 'Monaco', 'EURO', '0', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54591, '2020-07-11', 'MC', 'Monaco', 'EURO', '0', '78', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54592, '2020-07-12', 'MC', 'Monaco', 'EURO', '1', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54593, '2020-07-13', 'MC', 'Monaco', 'EURO', '0', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54594, '2020-07-14', 'MC', 'Monaco', 'EURO', '0', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54595, '2020-07-15', 'MC', 'Monaco', 'EURO', '0', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54596, '2020-07-16', 'MC', 'Monaco', 'EURO', '0', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54597, '2020-07-17', 'MC', 'Monaco', 'EURO', '0', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54598, '2020-07-18', 'MC', 'Monaco', 'EURO', '0', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54599, '2020-07-19', 'MC', 'Monaco', 'EURO', '0', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54600, '2020-07-20', 'MC', 'Monaco', 'EURO', '0', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54601, '2020-07-21', 'MC', 'Monaco', 'EURO', '0', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54602, '2020-07-22', 'MC', 'Monaco', 'EURO', '2', '81', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54603, '2020-07-23', 'MC', 'Monaco', 'EURO', '1', '82', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54604, '2020-07-24', 'MC', 'Monaco', 'EURO', '1', '83', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54605, '2020-07-25', 'MC', 'Monaco', 'EURO', '1', '84', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54606, '2020-07-26', 'MC', 'Monaco', 'EURO', '0', '84', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54607, '2020-07-27', 'MC', 'Monaco', 'EURO', '0', '84', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54608, '2020-07-28', 'MC', 'Monaco', 'EURO', '0', '84', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54609, '2020-07-29', 'MC', 'Monaco', 'EURO', '1', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54610, '2020-07-30', 'MC', 'Monaco', 'EURO', '2', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54611, '2020-07-31', 'MC', 'Monaco', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54612, '2020-08-01', 'MC', 'Monaco', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54613, '2020-08-02', 'MC', 'Monaco', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54614, '2020-08-03', 'MC', 'Monaco', 'EURO', '0', '87', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54615, '2020-08-04', 'MC', 'Monaco', 'EURO', '1', '88', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54616, '2020-08-05', 'MC', 'Monaco', 'EURO', '2', '90', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54617, '2020-08-06', 'MC', 'Monaco', 'EURO', '3', '93', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54618, '2020-08-07', 'MC', 'Monaco', 'EURO', '1', '94', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54619, '2020-08-08', 'MC', 'Monaco', 'EURO', '2', '96', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54620, '2020-08-09', 'MC', 'Monaco', 'EURO', '1', '97', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54621, '2020-08-10', 'MC', 'Monaco', 'EURO', '0', '97', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54622, '2020-08-11', 'MC', 'Monaco', 'EURO', '0', '97', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54623, '2020-08-12', 'MC', 'Monaco', 'EURO', '1', '98', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54624, '2020-08-13', 'MC', 'Monaco', 'EURO', '2', '100', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54625, '2020-08-14', 'MC', 'Monaco', 'EURO', '2', '102', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54626, '2020-08-15', 'MC', 'Monaco', 'EURO', '0', '102', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54627, '2020-08-16', 'MC', 'Monaco', 'EURO', '0', '102', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54628, '2020-08-17', 'MC', 'Monaco', 'EURO', '0', '102', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54629, '2020-08-18', 'MC', 'Monaco', 'EURO', '1', '103', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54630, '2020-08-19', 'MC', 'Monaco', 'EURO', '0', '103', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54631, '2020-08-20', 'MC', 'Monaco', 'EURO', '0', '103', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54632, '2020-08-21', 'MC', 'Monaco', 'EURO', '2', '105', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54633, '2020-08-22', 'MC', 'Monaco', 'EURO', '4', '109', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54634, '2020-08-23', 'MC', 'Monaco', 'EURO', '2', '111', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54635, '2020-08-24', 'MC', 'Monaco', 'EURO', '3', '114', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54636, '2020-08-25', 'MC', 'Monaco', 'EURO', '4', '118', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54637, '2020-08-26', 'MC', 'Monaco', 'EURO', '6', '124', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54638, '2020-08-27', 'MC', 'Monaco', 'EURO', '1', '125', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54639, '2020-08-28', 'MC', 'Monaco', 'EURO', '3', '128', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54640, '2020-08-29', 'MC', 'Monaco', 'EURO', '0', '128', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54641, '2020-08-30', 'MC', 'Monaco', 'EURO', '5', '133', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54642, '2020-08-31', 'MC', 'Monaco', 'EURO', '1', '134', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54643, '2020-09-01', 'MC', 'Monaco', 'EURO', '7', '141', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54644, '2020-09-02', 'MC', 'Monaco', 'EURO', '2', '143', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54645, '2020-09-03', 'MC', 'Monaco', 'EURO', '2', '145', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54646, '2020-09-04', 'MC', 'Monaco', 'EURO', '1', '146', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54647, '2020-09-05', 'MC', 'Monaco', 'EURO', '4', '150', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54648, '2020-09-06', 'MC', 'Monaco', 'EURO', '0', '150', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54649, '2020-09-07', 'MC', 'Monaco', 'EURO', '1', '151', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54650, '2020-09-08', 'MC', 'Monaco', 'EURO', '5', '156', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54651, '2020-09-09', 'MC', 'Monaco', 'EURO', '3', '159', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54652, '2020-09-10', 'MC', 'Monaco', 'EURO', '5', '164', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54653, '2020-09-11', 'MC', 'Monaco', 'EURO', '4', '168', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54654, '2020-09-12', 'MC', 'Monaco', 'EURO', '3', '171', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54655, '2020-09-13', 'MC', 'Monaco', 'EURO', '1', '172', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54656, '2020-09-14', 'MC', 'Monaco', 'EURO', '2', '174', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54657, '2020-09-15', 'MC', 'Monaco', 'EURO', '6', '180', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54658, '2020-09-16', 'MC', 'Monaco', 'EURO', '1', '181', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54659, '2020-09-17', 'MC', 'Monaco', 'EURO', '3', '184', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54660, '2020-09-18', 'MC', 'Monaco', 'EURO', '5', '189', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54661, '2020-09-19', 'MC', 'Monaco', 'EURO', '5', '194', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54662, '2020-09-20', 'MC', 'Monaco', 'EURO', '1', '195', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54663, '2020-09-21', 'MC', 'Monaco', 'EURO', '1', '196', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54664, '2020-09-22', 'MC', 'Monaco', 'EURO', '2', '198', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54665, '2020-09-23', 'MC', 'Monaco', 'EURO', '2', '200', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54666, '2020-09-24', 'MC', 'Monaco', 'EURO', '2', '202', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54667, '2020-09-25', 'MC', 'Monaco', 'EURO', '6', '208', '0', '1');
INSERT INTO public.who_global_data_import VALUES (54668, '2020-09-26', 'MC', 'Monaco', 'EURO', '5', '213', '1', '2');
INSERT INTO public.who_global_data_import VALUES (54669, '2020-09-27', 'MC', 'Monaco', 'EURO', '0', '213', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54670, '2020-09-28', 'MC', 'Monaco', 'EURO', '0', '213', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54671, '2020-09-29', 'MC', 'Monaco', 'EURO', '2', '215', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54672, '2020-09-30', 'MC', 'Monaco', 'EURO', '2', '217', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54673, '2020-10-01', 'MC', 'Monaco', 'EURO', '4', '221', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54674, '2020-10-02', 'MC', 'Monaco', 'EURO', '1', '222', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54675, '2020-10-03', 'MC', 'Monaco', 'EURO', '2', '224', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54676, '2020-10-04', 'MC', 'Monaco', 'EURO', '1', '225', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54677, '2020-10-05', 'MC', 'Monaco', 'EURO', '0', '225', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54678, '2020-10-06', 'MC', 'Monaco', 'EURO', '1', '226', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54679, '2020-10-07', 'MC', 'Monaco', 'EURO', '1', '227', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54680, '2020-10-08', 'MC', 'Monaco', 'EURO', '3', '230', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54681, '2020-10-09', 'MC', 'Monaco', 'EURO', '2', '232', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54682, '2020-10-10', 'MC', 'Monaco', 'EURO', '4', '236', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54683, '2020-10-11', 'MC', 'Monaco', 'EURO', '0', '236', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54684, '2020-10-12', 'MC', 'Monaco', 'EURO', '1', '237', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54685, '2020-10-13', 'MC', 'Monaco', 'EURO', '2', '239', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54686, '2020-10-14', 'MC', 'Monaco', 'EURO', '5', '244', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54687, '2020-10-15', 'MC', 'Monaco', 'EURO', '7', '251', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54688, '2020-10-16', 'MC', 'Monaco', 'EURO', '5', '256', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54689, '2020-10-17', 'MC', 'Monaco', 'EURO', '2', '258', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54690, '2020-10-18', 'MC', 'Monaco', 'EURO', '5', '263', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54691, '2020-10-19', 'MC', 'Monaco', 'EURO', '5', '268', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54692, '2020-10-20', 'MC', 'Monaco', 'EURO', '3', '271', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54693, '2020-10-21', 'MC', 'Monaco', 'EURO', '3', '274', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54694, '2020-10-22', 'MC', 'Monaco', 'EURO', '2', '276', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54695, '2020-10-23', 'MC', 'Monaco', 'EURO', '8', '284', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54696, '2020-10-24', 'MC', 'Monaco', 'EURO', '14', '298', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54697, '2020-10-25', 'MC', 'Monaco', 'EURO', '1', '299', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54698, '2020-10-26', 'MC', 'Monaco', 'EURO', '10', '309', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54699, '2020-10-27', 'MC', 'Monaco', 'EURO', '4', '313', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54700, '2020-10-28', 'MC', 'Monaco', 'EURO', '10', '323', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54701, '2020-10-29', 'MC', 'Monaco', 'EURO', '17', '340', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54702, '2020-10-30', 'MC', 'Monaco', 'EURO', '10', '350', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54703, '2020-10-31', 'MC', 'Monaco', 'EURO', '8', '358', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54704, '2020-11-01', 'MC', 'Monaco', 'EURO', '4', '362', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54705, '2020-11-02', 'MC', 'Monaco', 'EURO', '7', '369', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54706, '2020-11-03', 'MC', 'Monaco', 'EURO', '9', '378', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54707, '2020-11-04', 'MC', 'Monaco', 'EURO', '22', '400', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54708, '2020-11-05', 'MC', 'Monaco', 'EURO', '15', '415', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54709, '2020-11-06', 'MC', 'Monaco', 'EURO', '18', '433', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54710, '2020-11-07', 'MC', 'Monaco', 'EURO', '24', '457', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54711, '2020-11-08', 'MC', 'Monaco', 'EURO', '29', '486', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54712, '2020-11-09', 'MC', 'Monaco', 'EURO', '3', '489', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54713, '2020-11-10', 'MC', 'Monaco', 'EURO', '4', '493', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54714, '2020-11-11', 'MC', 'Monaco', 'EURO', '22', '515', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54715, '2020-11-12', 'MC', 'Monaco', 'EURO', '12', '527', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54716, '2020-11-13', 'MC', 'Monaco', 'EURO', '8', '535', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54717, '2020-11-14', 'MC', 'Monaco', 'EURO', '8', '543', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54718, '2020-11-15', 'MC', 'Monaco', 'EURO', '5', '548', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54719, '2020-11-16', 'MC', 'Monaco', 'EURO', '3', '551', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54720, '2020-11-17', 'MC', 'Monaco', 'EURO', '4', '555', '0', '2');
INSERT INTO public.who_global_data_import VALUES (54721, '2020-11-18', 'MC', 'Monaco', 'EURO', '5', '560', '1', '3');
INSERT INTO public.who_global_data_import VALUES (54722, '2020-11-19', 'MC', 'Monaco', 'EURO', '8', '568', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54723, '2020-11-20', 'MC', 'Monaco', 'EURO', '8', '576', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54724, '2020-11-21', 'MC', 'Monaco', 'EURO', '4', '580', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54725, '2020-11-22', 'MC', 'Monaco', 'EURO', '4', '584', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54726, '2020-11-23', 'MC', 'Monaco', 'EURO', '1', '585', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54727, '2020-11-24', 'MC', 'Monaco', 'EURO', '1', '586', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54728, '2020-11-25', 'MC', 'Monaco', 'EURO', '4', '590', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54729, '2020-11-26', 'MC', 'Monaco', 'EURO', '7', '597', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54730, '2020-11-27', 'MC', 'Monaco', 'EURO', '6', '603', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54731, '2020-11-28', 'MC', 'Monaco', 'EURO', '3', '606', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54732, '2020-11-29', 'MC', 'Monaco', 'EURO', '4', '610', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54733, '2020-11-30', 'MC', 'Monaco', 'EURO', '1', '611', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54734, '2020-12-01', 'MC', 'Monaco', 'EURO', '1', '612', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54735, '2020-12-02', 'MC', 'Monaco', 'EURO', '8', '620', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54736, '2020-12-03', 'MC', 'Monaco', 'EURO', '4', '624', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54737, '2020-12-04', 'MC', 'Monaco', 'EURO', '9', '633', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54738, '2020-12-05', 'MC', 'Monaco', 'EURO', '0', '633', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54739, '2020-12-06', 'MC', 'Monaco', 'EURO', '7', '640', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54740, '2020-12-07', 'MC', 'Monaco', 'EURO', '1', '641', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54741, '2020-12-08', 'MC', 'Monaco', 'EURO', '3', '644', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54742, '2020-12-09', 'MC', 'Monaco', 'EURO', '7', '651', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54743, '2020-12-10', 'MC', 'Monaco', 'EURO', '7', '658', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54744, '2020-12-11', 'MC', 'Monaco', 'EURO', '2', '660', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54745, '2020-12-12', 'MC', 'Monaco', 'EURO', '2', '662', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54746, '2020-12-13', 'MC', 'Monaco', 'EURO', '9', '671', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54747, '2020-12-14', 'MC', 'Monaco', 'EURO', '0', '671', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54748, '2020-12-15', 'MC', 'Monaco', 'EURO', '4', '675', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54749, '2020-12-16', 'MC', 'Monaco', 'EURO', '6', '681', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54750, '2020-12-17', 'MC', 'Monaco', 'EURO', '7', '688', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54751, '2020-12-18', 'MC', 'Monaco', 'EURO', '15', '703', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54752, '2020-12-19', 'MC', 'Monaco', 'EURO', '15', '718', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54753, '2020-12-20', 'MC', 'Monaco', 'EURO', '8', '726', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54754, '2020-12-21', 'MC', 'Monaco', 'EURO', '5', '731', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54755, '2020-12-22', 'MC', 'Monaco', 'EURO', '14', '745', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54756, '2020-12-23', 'MC', 'Monaco', 'EURO', '14', '759', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54757, '2020-12-24', 'MC', 'Monaco', 'EURO', '11', '770', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54758, '2020-12-25', 'MC', 'Monaco', 'EURO', '16', '786', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54759, '2020-12-26', 'MC', 'Monaco', 'EURO', '6', '792', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54760, '2020-12-27', 'MC', 'Monaco', 'EURO', '8', '800', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54761, '2020-12-28', 'MC', 'Monaco', 'EURO', '2', '802', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54762, '2020-12-29', 'MC', 'Monaco', 'EURO', '4', '806', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54763, '2020-12-30', 'MC', 'Monaco', 'EURO', '24', '830', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54764, '2020-12-31', 'MC', 'Monaco', 'EURO', '26', '856', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54765, '2021-01-01', 'MC', 'Monaco', 'EURO', '22', '878', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54766, '2021-01-02', 'MC', 'Monaco', 'EURO', '10', '888', '0', '3');
INSERT INTO public.who_global_data_import VALUES (54767, '2021-01-03', 'MC', 'Monaco', 'EURO', '16', '904', '1', '4');
INSERT INTO public.who_global_data_import VALUES (54768, '2021-01-04', 'MC', 'Monaco', 'EURO', '6', '910', '0', '4');
INSERT INTO public.who_global_data_import VALUES (54769, '2021-01-05', 'MC', 'Monaco', 'EURO', '10', '920', '0', '4');
INSERT INTO public.who_global_data_import VALUES (54770, '2021-01-06', 'MC', 'Monaco', 'EURO', '30', '950', '0', '4');
INSERT INTO public.who_global_data_import VALUES (54771, '2021-01-07', 'MC', 'Monaco', 'EURO', '31', '981', '0', '4');
INSERT INTO public.who_global_data_import VALUES (54772, '2021-01-08', 'MC', 'Monaco', 'EURO', '40', '1021', '1', '5');
INSERT INTO public.who_global_data_import VALUES (54773, '2021-01-09', 'MC', 'Monaco', 'EURO', '23', '1044', '0', '5');
INSERT INTO public.who_global_data_import VALUES (54774, '2021-01-10', 'MC', 'Monaco', 'EURO', '12', '1056', '0', '5');
INSERT INTO public.who_global_data_import VALUES (54775, '2021-01-11', 'MC', 'Monaco', 'EURO', '4', '1060', '0', '5');
INSERT INTO public.who_global_data_import VALUES (54776, '2021-01-12', 'MC', 'Monaco', 'EURO', '13', '1073', '1', '6');
INSERT INTO public.who_global_data_import VALUES (54777, '2021-01-13', 'MC', 'Monaco', 'EURO', '25', '1098', '1', '7');
INSERT INTO public.who_global_data_import VALUES (54778, '2021-01-14', 'MC', 'Monaco', 'EURO', '33', '1131', '0', '7');
INSERT INTO public.who_global_data_import VALUES (54779, '2021-01-15', 'MC', 'Monaco', 'EURO', '17', '1148', '1', '8');
INSERT INTO public.who_global_data_import VALUES (54780, '2021-01-16', 'MC', 'Monaco', 'EURO', '24', '1172', '0', '8');
INSERT INTO public.who_global_data_import VALUES (56064, '2020-03-06', 'MA', 'Morocco', 'EMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54781, '2021-01-17', 'MC', 'Monaco', 'EURO', '25', '1197', '0', '8');
INSERT INTO public.who_global_data_import VALUES (54782, '2021-01-18', 'MC', 'Monaco', 'EURO', '11', '1208', '0', '8');
INSERT INTO public.who_global_data_import VALUES (54783, '2021-01-19', 'MC', 'Monaco', 'EURO', '7', '1215', '0', '8');
INSERT INTO public.who_global_data_import VALUES (54784, '2021-01-20', 'MC', 'Monaco', 'EURO', '25', '1240', '0', '8');
INSERT INTO public.who_global_data_import VALUES (54785, '2021-01-21', 'MC', 'Monaco', 'EURO', '22', '1262', '0', '8');
INSERT INTO public.who_global_data_import VALUES (54786, '2021-01-22', 'MC', 'Monaco', 'EURO', '25', '1287', '0', '8');
INSERT INTO public.who_global_data_import VALUES (54787, '2021-01-23', 'MC', 'Monaco', 'EURO', '24', '1311', '0', '8');
INSERT INTO public.who_global_data_import VALUES (54788, '2021-01-24', 'MC', 'Monaco', 'EURO', '34', '1345', '0', '8');
INSERT INTO public.who_global_data_import VALUES (54789, '2021-01-25', 'MC', 'Monaco', 'EURO', '12', '1357', '0', '8');
INSERT INTO public.who_global_data_import VALUES (54790, '2021-01-26', 'MC', 'Monaco', 'EURO', '11', '1368', '0', '8');
INSERT INTO public.who_global_data_import VALUES (54791, '2021-01-27', 'MC', 'Monaco', 'EURO', '31', '1399', '0', '8');
INSERT INTO public.who_global_data_import VALUES (54792, '2021-01-28', 'MC', 'Monaco', 'EURO', '14', '1413', '2', '10');
INSERT INTO public.who_global_data_import VALUES (54793, '2021-01-29', 'MC', 'Monaco', 'EURO', '17', '1430', '1', '11');
INSERT INTO public.who_global_data_import VALUES (54794, '2021-01-30', 'MC', 'Monaco', 'EURO', '27', '1457', '1', '12');
INSERT INTO public.who_global_data_import VALUES (54795, '2021-01-31', 'MC', 'Monaco', 'EURO', '18', '1475', '0', '12');
INSERT INTO public.who_global_data_import VALUES (54796, '2021-02-01', 'MC', 'Monaco', 'EURO', '14', '1489', '0', '12');
INSERT INTO public.who_global_data_import VALUES (54797, '2021-02-02', 'MC', 'Monaco', 'EURO', '10', '1499', '2', '14');
INSERT INTO public.who_global_data_import VALUES (54798, '2021-02-03', 'MC', 'Monaco', 'EURO', '44', '1543', '3', '17');
INSERT INTO public.who_global_data_import VALUES (54799, '2021-02-04', 'MC', 'Monaco', 'EURO', '29', '1572', '1', '18');
INSERT INTO public.who_global_data_import VALUES (54800, '2021-02-05', 'MC', 'Monaco', 'EURO', '24', '1596', '0', '18');
INSERT INTO public.who_global_data_import VALUES (54801, '2020-01-03', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54802, '2020-01-04', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54803, '2020-01-05', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54804, '2020-01-06', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54805, '2020-01-07', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54806, '2020-01-08', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54807, '2020-01-09', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54808, '2020-01-10', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54809, '2020-01-11', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54810, '2020-01-12', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54811, '2020-01-13', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54812, '2020-01-14', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54813, '2020-01-15', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54814, '2020-01-16', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54815, '2020-01-17', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54816, '2020-01-18', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54817, '2020-01-19', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54818, '2020-01-20', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54819, '2020-01-21', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54820, '2020-01-22', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54821, '2020-01-23', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54822, '2020-01-24', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54823, '2020-01-25', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54824, '2020-01-26', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54825, '2020-01-27', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54826, '2020-01-28', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54827, '2020-01-29', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54828, '2020-01-30', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54829, '2020-01-31', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54830, '2020-02-01', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54831, '2020-02-02', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54832, '2020-02-03', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54833, '2020-02-04', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54834, '2020-02-05', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54835, '2020-02-06', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54836, '2020-02-07', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54837, '2020-02-08', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54838, '2020-02-09', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54839, '2020-02-10', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54840, '2020-02-11', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54841, '2020-02-12', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54842, '2020-02-13', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54843, '2020-02-14', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54844, '2020-02-15', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54845, '2020-02-16', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54846, '2020-02-17', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54847, '2020-02-18', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54848, '2020-02-19', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54849, '2020-02-20', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54850, '2020-02-21', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54851, '2020-02-22', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54852, '2020-02-23', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54853, '2020-02-24', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54854, '2020-02-25', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54855, '2020-02-26', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54856, '2020-02-27', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54857, '2020-02-28', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54858, '2020-02-29', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54859, '2020-03-01', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54860, '2020-03-02', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54861, '2020-03-03', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54862, '2020-03-04', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54863, '2020-03-05', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54864, '2020-03-06', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54865, '2020-03-07', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54866, '2020-03-08', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54867, '2020-03-09', 'MN', 'Mongolia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54868, '2020-03-10', 'MN', 'Mongolia', 'WPRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54869, '2020-03-11', 'MN', 'Mongolia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54870, '2020-03-12', 'MN', 'Mongolia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54871, '2020-03-13', 'MN', 'Mongolia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54872, '2020-03-14', 'MN', 'Mongolia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54873, '2020-03-15', 'MN', 'Mongolia', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54874, '2020-03-16', 'MN', 'Mongolia', 'WPRO', '3', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54875, '2020-03-17', 'MN', 'Mongolia', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54876, '2020-03-18', 'MN', 'Mongolia', 'WPRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54877, '2020-03-19', 'MN', 'Mongolia', 'WPRO', '-3', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54878, '2020-03-20', 'MN', 'Mongolia', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54879, '2020-03-21', 'MN', 'Mongolia', 'WPRO', '4', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54880, '2020-03-22', 'MN', 'Mongolia', 'WPRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54881, '2020-03-23', 'MN', 'Mongolia', 'WPRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54882, '2020-03-24', 'MN', 'Mongolia', 'WPRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54883, '2020-03-25', 'MN', 'Mongolia', 'WPRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54884, '2020-03-26', 'MN', 'Mongolia', 'WPRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54885, '2020-03-27', 'MN', 'Mongolia', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54886, '2020-03-28', 'MN', 'Mongolia', 'WPRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54887, '2020-03-29', 'MN', 'Mongolia', 'WPRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54888, '2020-03-30', 'MN', 'Mongolia', 'WPRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54889, '2020-03-31', 'MN', 'Mongolia', 'WPRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54890, '2020-04-01', 'MN', 'Mongolia', 'WPRO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54891, '2020-04-02', 'MN', 'Mongolia', 'WPRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54892, '2020-04-03', 'MN', 'Mongolia', 'WPRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54893, '2020-04-04', 'MN', 'Mongolia', 'WPRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54894, '2020-04-05', 'MN', 'Mongolia', 'WPRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54895, '2020-04-06', 'MN', 'Mongolia', 'WPRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54896, '2020-04-07', 'MN', 'Mongolia', 'WPRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54897, '2020-04-08', 'MN', 'Mongolia', 'WPRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54898, '2020-04-09', 'MN', 'Mongolia', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54899, '2020-04-10', 'MN', 'Mongolia', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54900, '2020-04-11', 'MN', 'Mongolia', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54901, '2020-04-12', 'MN', 'Mongolia', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54902, '2020-04-13', 'MN', 'Mongolia', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54903, '2020-04-14', 'MN', 'Mongolia', 'WPRO', '14', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54904, '2020-04-15', 'MN', 'Mongolia', 'WPRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54905, '2020-04-16', 'MN', 'Mongolia', 'WPRO', '1', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54906, '2020-04-17', 'MN', 'Mongolia', 'WPRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54907, '2020-04-18', 'MN', 'Mongolia', 'WPRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54908, '2020-04-19', 'MN', 'Mongolia', 'WPRO', '1', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54909, '2020-04-20', 'MN', 'Mongolia', 'WPRO', '1', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54910, '2020-04-21', 'MN', 'Mongolia', 'WPRO', '1', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54911, '2020-04-22', 'MN', 'Mongolia', 'WPRO', '1', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54912, '2020-04-23', 'MN', 'Mongolia', 'WPRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54913, '2020-04-24', 'MN', 'Mongolia', 'WPRO', '1', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54914, '2020-04-25', 'MN', 'Mongolia', 'WPRO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54915, '2020-04-26', 'MN', 'Mongolia', 'WPRO', '1', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54916, '2020-04-27', 'MN', 'Mongolia', 'WPRO', '1', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54917, '2020-04-28', 'MN', 'Mongolia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54918, '2020-04-29', 'MN', 'Mongolia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54919, '2020-04-30', 'MN', 'Mongolia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54920, '2020-05-01', 'MN', 'Mongolia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54921, '2020-05-02', 'MN', 'Mongolia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54922, '2020-05-03', 'MN', 'Mongolia', 'WPRO', '1', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54923, '2020-05-04', 'MN', 'Mongolia', 'WPRO', '1', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54924, '2020-05-05', 'MN', 'Mongolia', 'WPRO', '1', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54925, '2020-05-06', 'MN', 'Mongolia', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54926, '2020-05-07', 'MN', 'Mongolia', 'WPRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54927, '2020-05-08', 'MN', 'Mongolia', 'WPRO', '1', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54928, '2020-05-09', 'MN', 'Mongolia', 'WPRO', '0', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54929, '2020-05-10', 'MN', 'Mongolia', 'WPRO', '0', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54930, '2020-05-11', 'MN', 'Mongolia', 'WPRO', '0', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54931, '2020-05-12', 'MN', 'Mongolia', 'WPRO', '0', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54932, '2020-05-13', 'MN', 'Mongolia', 'WPRO', '0', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54933, '2020-05-14', 'MN', 'Mongolia', 'WPRO', '0', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54934, '2020-05-15', 'MN', 'Mongolia', 'WPRO', '56', '98', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54935, '2020-05-16', 'MN', 'Mongolia', 'WPRO', '37', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54936, '2020-05-17', 'MN', 'Mongolia', 'WPRO', '1', '136', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54937, '2020-05-18', 'MN', 'Mongolia', 'WPRO', '4', '140', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54938, '2020-05-19', 'MN', 'Mongolia', 'WPRO', '0', '140', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54939, '2020-05-20', 'MN', 'Mongolia', 'WPRO', '0', '140', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54940, '2020-05-21', 'MN', 'Mongolia', 'WPRO', '0', '140', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54941, '2020-05-22', 'MN', 'Mongolia', 'WPRO', '1', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54942, '2020-05-23', 'MN', 'Mongolia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54943, '2020-05-24', 'MN', 'Mongolia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54944, '2020-05-25', 'MN', 'Mongolia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54945, '2020-05-26', 'MN', 'Mongolia', 'WPRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54946, '2020-05-27', 'MN', 'Mongolia', 'WPRO', '7', '148', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54947, '2020-05-28', 'MN', 'Mongolia', 'WPRO', '13', '161', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54948, '2020-05-29', 'MN', 'Mongolia', 'WPRO', '18', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54949, '2020-05-30', 'MN', 'Mongolia', 'WPRO', '0', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54950, '2020-05-31', 'MN', 'Mongolia', 'WPRO', '0', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54951, '2020-06-01', 'MN', 'Mongolia', 'WPRO', '0', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54952, '2020-06-02', 'MN', 'Mongolia', 'WPRO', '6', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54953, '2020-06-03', 'MN', 'Mongolia', 'WPRO', '0', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54954, '2020-06-04', 'MN', 'Mongolia', 'WPRO', '0', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54955, '2020-06-05', 'MN', 'Mongolia', 'WPRO', '1', '186', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54956, '2020-06-06', 'MN', 'Mongolia', 'WPRO', '5', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54957, '2020-06-07', 'MN', 'Mongolia', 'WPRO', '2', '193', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54958, '2020-06-08', 'MN', 'Mongolia', 'WPRO', '0', '193', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54959, '2020-06-09', 'MN', 'Mongolia', 'WPRO', '1', '194', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54960, '2020-06-10', 'MN', 'Mongolia', 'WPRO', '0', '194', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54961, '2020-06-11', 'MN', 'Mongolia', 'WPRO', '0', '194', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54962, '2020-06-12', 'MN', 'Mongolia', 'WPRO', '0', '194', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54963, '2020-06-13', 'MN', 'Mongolia', 'WPRO', '3', '197', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54964, '2020-06-14', 'MN', 'Mongolia', 'WPRO', '0', '197', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54965, '2020-06-15', 'MN', 'Mongolia', 'WPRO', '0', '197', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54966, '2020-06-16', 'MN', 'Mongolia', 'WPRO', '0', '197', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54967, '2020-06-17', 'MN', 'Mongolia', 'WPRO', '0', '197', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54968, '2020-06-18', 'MN', 'Mongolia', 'WPRO', '0', '197', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54969, '2020-06-19', 'MN', 'Mongolia', 'WPRO', '4', '201', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54970, '2020-06-20', 'MN', 'Mongolia', 'WPRO', '3', '204', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54971, '2020-06-21', 'MN', 'Mongolia', 'WPRO', '0', '204', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54972, '2020-06-22', 'MN', 'Mongolia', 'WPRO', '2', '206', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54973, '2020-06-23', 'MN', 'Mongolia', 'WPRO', '7', '213', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54974, '2020-06-24', 'MN', 'Mongolia', 'WPRO', '2', '215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54975, '2020-06-25', 'MN', 'Mongolia', 'WPRO', '0', '215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54976, '2020-06-26', 'MN', 'Mongolia', 'WPRO', '1', '216', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54977, '2020-06-27', 'MN', 'Mongolia', 'WPRO', '3', '219', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54978, '2020-06-28', 'MN', 'Mongolia', 'WPRO', '0', '219', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54979, '2020-06-29', 'MN', 'Mongolia', 'WPRO', '0', '219', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54980, '2020-06-30', 'MN', 'Mongolia', 'WPRO', '1', '220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54981, '2020-07-01', 'MN', 'Mongolia', 'WPRO', '0', '220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54982, '2020-07-02', 'MN', 'Mongolia', 'WPRO', '0', '220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54983, '2020-07-03', 'MN', 'Mongolia', 'WPRO', '0', '220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54984, '2020-07-04', 'MN', 'Mongolia', 'WPRO', '0', '220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54985, '2020-07-05', 'MN', 'Mongolia', 'WPRO', '0', '220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54986, '2020-07-06', 'MN', 'Mongolia', 'WPRO', '0', '220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54987, '2020-07-07', 'MN', 'Mongolia', 'WPRO', '0', '220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54988, '2020-07-08', 'MN', 'Mongolia', 'WPRO', '5', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54989, '2020-07-09', 'MN', 'Mongolia', 'WPRO', '2', '227', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54990, '2020-07-10', 'MN', 'Mongolia', 'WPRO', '0', '227', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54991, '2020-07-11', 'MN', 'Mongolia', 'WPRO', '0', '227', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54992, '2020-07-12', 'MN', 'Mongolia', 'WPRO', '0', '227', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54993, '2020-07-13', 'MN', 'Mongolia', 'WPRO', '3', '230', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54994, '2020-07-14', 'MN', 'Mongolia', 'WPRO', '0', '230', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54995, '2020-07-15', 'MN', 'Mongolia', 'WPRO', '13', '243', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54996, '2020-07-16', 'MN', 'Mongolia', 'WPRO', '18', '261', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54997, '2020-07-17', 'MN', 'Mongolia', 'WPRO', '0', '261', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54998, '2020-07-18', 'MN', 'Mongolia', 'WPRO', '1', '262', '0', '0');
INSERT INTO public.who_global_data_import VALUES (54999, '2020-07-19', 'MN', 'Mongolia', 'WPRO', '25', '287', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55000, '2020-07-20', 'MN', 'Mongolia', 'WPRO', '0', '287', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55001, '2020-07-21', 'MN', 'Mongolia', 'WPRO', '0', '287', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55002, '2020-07-22', 'MN', 'Mongolia', 'WPRO', '0', '287', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55003, '2020-07-23', 'MN', 'Mongolia', 'WPRO', '0', '287', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55004, '2020-07-24', 'MN', 'Mongolia', 'WPRO', '0', '287', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55005, '2020-07-25', 'MN', 'Mongolia', 'WPRO', '1', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55006, '2020-07-26', 'MN', 'Mongolia', 'WPRO', '0', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55007, '2020-07-27', 'MN', 'Mongolia', 'WPRO', '0', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55008, '2020-07-28', 'MN', 'Mongolia', 'WPRO', '0', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55009, '2020-07-29', 'MN', 'Mongolia', 'WPRO', '1', '289', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55010, '2020-07-30', 'MN', 'Mongolia', 'WPRO', '2', '291', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55011, '2020-07-31', 'MN', 'Mongolia', 'WPRO', '0', '291', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55012, '2020-08-01', 'MN', 'Mongolia', 'WPRO', '0', '291', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55013, '2020-08-02', 'MN', 'Mongolia', 'WPRO', '0', '291', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55014, '2020-08-03', 'MN', 'Mongolia', 'WPRO', '2', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55015, '2020-08-04', 'MN', 'Mongolia', 'WPRO', '0', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55016, '2020-08-05', 'MN', 'Mongolia', 'WPRO', '0', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55017, '2020-08-06', 'MN', 'Mongolia', 'WPRO', '0', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55018, '2020-08-07', 'MN', 'Mongolia', 'WPRO', '0', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55019, '2020-08-08', 'MN', 'Mongolia', 'WPRO', '0', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55020, '2020-08-09', 'MN', 'Mongolia', 'WPRO', '0', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55021, '2020-08-10', 'MN', 'Mongolia', 'WPRO', '0', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55022, '2020-08-11', 'MN', 'Mongolia', 'WPRO', '0', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55023, '2020-08-12', 'MN', 'Mongolia', 'WPRO', '0', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55024, '2020-08-13', 'MN', 'Mongolia', 'WPRO', '0', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55025, '2020-08-14', 'MN', 'Mongolia', 'WPRO', '4', '297', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55026, '2020-08-15', 'MN', 'Mongolia', 'WPRO', '0', '297', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55027, '2020-08-16', 'MN', 'Mongolia', 'WPRO', '1', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55028, '2020-08-17', 'MN', 'Mongolia', 'WPRO', '0', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55029, '2020-08-18', 'MN', 'Mongolia', 'WPRO', '0', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55030, '2020-08-19', 'MN', 'Mongolia', 'WPRO', '0', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55031, '2020-08-20', 'MN', 'Mongolia', 'WPRO', '0', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55032, '2020-08-21', 'MN', 'Mongolia', 'WPRO', '0', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55033, '2020-08-22', 'MN', 'Mongolia', 'WPRO', '0', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55034, '2020-08-23', 'MN', 'Mongolia', 'WPRO', '0', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55035, '2020-08-24', 'MN', 'Mongolia', 'WPRO', '0', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55036, '2020-08-25', 'MN', 'Mongolia', 'WPRO', '0', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55037, '2020-08-26', 'MN', 'Mongolia', 'WPRO', '0', '298', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55038, '2020-08-27', 'MN', 'Mongolia', 'WPRO', '2', '300', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55039, '2020-08-28', 'MN', 'Mongolia', 'WPRO', '1', '301', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55040, '2020-08-29', 'MN', 'Mongolia', 'WPRO', '0', '301', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55041, '2020-08-30', 'MN', 'Mongolia', 'WPRO', '0', '301', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55042, '2020-08-31', 'MN', 'Mongolia', 'WPRO', '0', '301', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55043, '2020-09-01', 'MN', 'Mongolia', 'WPRO', '0', '301', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55044, '2020-09-02', 'MN', 'Mongolia', 'WPRO', '3', '304', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55045, '2020-09-03', 'MN', 'Mongolia', 'WPRO', '2', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55046, '2020-09-04', 'MN', 'Mongolia', 'WPRO', '0', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55047, '2020-09-05', 'MN', 'Mongolia', 'WPRO', '4', '310', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55048, '2020-09-06', 'MN', 'Mongolia', 'WPRO', '0', '310', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55049, '2020-09-07', 'MN', 'Mongolia', 'WPRO', '0', '310', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55050, '2020-09-08', 'MN', 'Mongolia', 'WPRO', '0', '310', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55051, '2020-09-09', 'MN', 'Mongolia', 'WPRO', '0', '310', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55052, '2020-09-10', 'MN', 'Mongolia', 'WPRO', '0', '310', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55053, '2020-09-11', 'MN', 'Mongolia', 'WPRO', '0', '310', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55054, '2020-09-12', 'MN', 'Mongolia', 'WPRO', '1', '311', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55055, '2020-09-13', 'MN', 'Mongolia', 'WPRO', '0', '311', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55056, '2020-09-14', 'MN', 'Mongolia', 'WPRO', '0', '311', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55057, '2020-09-15', 'MN', 'Mongolia', 'WPRO', '0', '311', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55058, '2020-09-16', 'MN', 'Mongolia', 'WPRO', '0', '311', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55059, '2020-09-17', 'MN', 'Mongolia', 'WPRO', '0', '311', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55060, '2020-09-18', 'MN', 'Mongolia', 'WPRO', '0', '311', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55061, '2020-09-19', 'MN', 'Mongolia', 'WPRO', '0', '311', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55062, '2020-09-20', 'MN', 'Mongolia', 'WPRO', '0', '311', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55063, '2020-09-21', 'MN', 'Mongolia', 'WPRO', '1', '312', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55064, '2020-09-22', 'MN', 'Mongolia', 'WPRO', '0', '312', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55065, '2020-09-23', 'MN', 'Mongolia', 'WPRO', '1', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55066, '2020-09-24', 'MN', 'Mongolia', 'WPRO', '0', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55067, '2020-09-25', 'MN', 'Mongolia', 'WPRO', '0', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55068, '2020-09-26', 'MN', 'Mongolia', 'WPRO', '0', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55069, '2020-09-27', 'MN', 'Mongolia', 'WPRO', '0', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55070, '2020-09-28', 'MN', 'Mongolia', 'WPRO', '0', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55071, '2020-09-29', 'MN', 'Mongolia', 'WPRO', '0', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55072, '2020-09-30', 'MN', 'Mongolia', 'WPRO', '0', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55073, '2020-10-01', 'MN', 'Mongolia', 'WPRO', '0', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55074, '2020-10-02', 'MN', 'Mongolia', 'WPRO', '0', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55075, '2020-10-03', 'MN', 'Mongolia', 'WPRO', '0', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55076, '2020-10-04', 'MN', 'Mongolia', 'WPRO', '0', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55077, '2020-10-05', 'MN', 'Mongolia', 'WPRO', '0', '313', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55078, '2020-10-06', 'MN', 'Mongolia', 'WPRO', '1', '314', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55079, '2020-10-07', 'MN', 'Mongolia', 'WPRO', '1', '315', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55080, '2020-10-08', 'MN', 'Mongolia', 'WPRO', '0', '315', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55081, '2020-10-09', 'MN', 'Mongolia', 'WPRO', '0', '315', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55082, '2020-10-10', 'MN', 'Mongolia', 'WPRO', '0', '315', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55083, '2020-10-11', 'MN', 'Mongolia', 'WPRO', '0', '315', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55084, '2020-10-12', 'MN', 'Mongolia', 'WPRO', '1', '316', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55085, '2020-10-13', 'MN', 'Mongolia', 'WPRO', '2', '318', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55086, '2020-10-14', 'MN', 'Mongolia', 'WPRO', '2', '320', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55087, '2020-10-15', 'MN', 'Mongolia', 'WPRO', '0', '320', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55088, '2020-10-16', 'MN', 'Mongolia', 'WPRO', '0', '320', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55089, '2020-10-17', 'MN', 'Mongolia', 'WPRO', '0', '320', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55090, '2020-10-18', 'MN', 'Mongolia', 'WPRO', '0', '320', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55091, '2020-10-19', 'MN', 'Mongolia', 'WPRO', '4', '324', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55092, '2020-10-20', 'MN', 'Mongolia', 'WPRO', '0', '324', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55093, '2020-10-21', 'MN', 'Mongolia', 'WPRO', '2', '326', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55094, '2020-10-22', 'MN', 'Mongolia', 'WPRO', '1', '327', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55095, '2020-10-23', 'MN', 'Mongolia', 'WPRO', '1', '328', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55096, '2020-10-24', 'MN', 'Mongolia', 'WPRO', '0', '328', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55097, '2020-10-25', 'MN', 'Mongolia', 'WPRO', '9', '337', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55098, '2020-10-26', 'MN', 'Mongolia', 'WPRO', '1', '338', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55099, '2020-10-27', 'MN', 'Mongolia', 'WPRO', '1', '339', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55100, '2020-10-28', 'MN', 'Mongolia', 'WPRO', '1', '340', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55101, '2020-10-29', 'MN', 'Mongolia', 'WPRO', '0', '340', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55102, '2020-10-30', 'MN', 'Mongolia', 'WPRO', '0', '340', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55103, '2020-10-31', 'MN', 'Mongolia', 'WPRO', '0', '340', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55104, '2020-11-01', 'MN', 'Mongolia', 'WPRO', '6', '346', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55105, '2020-11-02', 'MN', 'Mongolia', 'WPRO', '0', '346', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55106, '2020-11-03', 'MN', 'Mongolia', 'WPRO', '3', '349', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55107, '2020-11-04', 'MN', 'Mongolia', 'WPRO', '1', '350', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55108, '2020-11-05', 'MN', 'Mongolia', 'WPRO', '2', '352', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55109, '2020-11-06', 'MN', 'Mongolia', 'WPRO', '1', '353', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55110, '2020-11-07', 'MN', 'Mongolia', 'WPRO', '3', '356', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55111, '2020-11-08', 'MN', 'Mongolia', 'WPRO', '1', '357', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55112, '2020-11-09', 'MN', 'Mongolia', 'WPRO', '5', '362', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55113, '2020-11-10', 'MN', 'Mongolia', 'WPRO', '6', '368', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55114, '2020-11-11', 'MN', 'Mongolia', 'WPRO', '6', '374', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55115, '2020-11-12', 'MN', 'Mongolia', 'WPRO', '8', '382', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55116, '2020-11-13', 'MN', 'Mongolia', 'WPRO', '24', '406', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55117, '2020-11-14', 'MN', 'Mongolia', 'WPRO', '6', '412', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55118, '2020-11-15', 'MN', 'Mongolia', 'WPRO', '4', '416', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55119, '2020-11-16', 'MN', 'Mongolia', 'WPRO', '12', '428', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55120, '2020-11-17', 'MN', 'Mongolia', 'WPRO', '3', '431', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55121, '2020-11-18', 'MN', 'Mongolia', 'WPRO', '9', '440', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55122, '2020-11-19', 'MN', 'Mongolia', 'WPRO', '33', '473', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55123, '2020-11-20', 'MN', 'Mongolia', 'WPRO', '45', '518', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55124, '2020-11-21', 'MN', 'Mongolia', 'WPRO', '39', '557', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55125, '2020-11-22', 'MN', 'Mongolia', 'WPRO', '25', '582', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55126, '2020-11-23', 'MN', 'Mongolia', 'WPRO', '47', '629', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55127, '2020-11-24', 'MN', 'Mongolia', 'WPRO', '11', '640', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55128, '2020-11-25', 'MN', 'Mongolia', 'WPRO', '32', '672', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55129, '2020-11-26', 'MN', 'Mongolia', 'WPRO', '27', '699', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55130, '2020-11-27', 'MN', 'Mongolia', 'WPRO', '13', '712', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55131, '2020-11-28', 'MN', 'Mongolia', 'WPRO', '26', '738', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55132, '2020-11-29', 'MN', 'Mongolia', 'WPRO', '22', '760', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55133, '2020-11-30', 'MN', 'Mongolia', 'WPRO', '24', '784', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55134, '2020-12-01', 'MN', 'Mongolia', 'WPRO', '7', '791', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55135, '2020-12-02', 'MN', 'Mongolia', 'WPRO', '10', '801', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55136, '2020-12-03', 'MN', 'Mongolia', 'WPRO', '11', '812', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55137, '2020-12-04', 'MN', 'Mongolia', 'WPRO', '7', '819', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55138, '2020-12-05', 'MN', 'Mongolia', 'WPRO', '12', '831', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55139, '2020-12-06', 'MN', 'Mongolia', 'WPRO', '11', '842', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55140, '2020-12-07', 'MN', 'Mongolia', 'WPRO', '7', '849', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55141, '2020-12-08', 'MN', 'Mongolia', 'WPRO', '38', '887', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55142, '2020-12-09', 'MN', 'Mongolia', 'WPRO', '1', '888', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55143, '2020-12-10', 'MN', 'Mongolia', 'WPRO', '5', '893', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55144, '2020-12-11', 'MN', 'Mongolia', 'WPRO', '5', '898', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55145, '2020-12-12', 'MN', 'Mongolia', 'WPRO', '7', '905', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55146, '2020-12-13', 'MN', 'Mongolia', 'WPRO', '1', '906', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55147, '2020-12-14', 'MN', 'Mongolia', 'WPRO', '1', '907', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55148, '2020-12-15', 'MN', 'Mongolia', 'WPRO', '5', '912', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55149, '2020-12-16', 'MN', 'Mongolia', 'WPRO', '5', '917', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55150, '2020-12-17', 'MN', 'Mongolia', 'WPRO', '1', '918', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55151, '2020-12-18', 'MN', 'Mongolia', 'WPRO', '5', '923', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55152, '2020-12-19', 'MN', 'Mongolia', 'WPRO', '18', '941', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55153, '2020-12-20', 'MN', 'Mongolia', 'WPRO', '12', '953', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55154, '2020-12-21', 'MN', 'Mongolia', 'WPRO', '8', '961', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55155, '2020-12-22', 'MN', 'Mongolia', 'WPRO', '32', '993', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55156, '2020-12-23', 'MN', 'Mongolia', 'WPRO', '13', '1006', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55157, '2020-12-24', 'MN', 'Mongolia', 'WPRO', '57', '1063', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55158, '2020-12-25', 'MN', 'Mongolia', 'WPRO', '6', '1069', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55159, '2020-12-26', 'MN', 'Mongolia', 'WPRO', '6', '1075', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55160, '2020-12-27', 'MN', 'Mongolia', 'WPRO', '7', '1082', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55161, '2020-12-28', 'MN', 'Mongolia', 'WPRO', '39', '1121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55162, '2020-12-29', 'MN', 'Mongolia', 'WPRO', '16', '1137', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55163, '2020-12-30', 'MN', 'Mongolia', 'WPRO', '38', '1175', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55164, '2020-12-31', 'MN', 'Mongolia', 'WPRO', '20', '1195', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55165, '2021-01-01', 'MN', 'Mongolia', 'WPRO', '20', '1215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55166, '2021-01-02', 'MN', 'Mongolia', 'WPRO', '5', '1220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55167, '2021-01-03', 'MN', 'Mongolia', 'WPRO', '22', '1242', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55168, '2021-01-04', 'MN', 'Mongolia', 'WPRO', '21', '1263', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55169, '2021-01-05', 'MN', 'Mongolia', 'WPRO', '23', '1286', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55170, '2021-01-06', 'MN', 'Mongolia', 'WPRO', '22', '1308', '1', '1');
INSERT INTO public.who_global_data_import VALUES (55171, '2021-01-07', 'MN', 'Mongolia', 'WPRO', '41', '1349', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55172, '2021-01-08', 'MN', 'Mongolia', 'WPRO', '13', '1362', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55173, '2021-01-09', 'MN', 'Mongolia', 'WPRO', '33', '1395', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55174, '2021-01-10', 'MN', 'Mongolia', 'WPRO', '13', '1408', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55175, '2021-01-11', 'MN', 'Mongolia', 'WPRO', '21', '1429', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55176, '2021-01-12', 'MN', 'Mongolia', 'WPRO', '13', '1442', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55177, '2021-01-13', 'MN', 'Mongolia', 'WPRO', '14', '1456', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55178, '2021-01-14', 'MN', 'Mongolia', 'WPRO', '13', '1469', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55179, '2021-01-15', 'MN', 'Mongolia', 'WPRO', '10', '1479', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55180, '2021-01-16', 'MN', 'Mongolia', 'WPRO', '12', '1491', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55181, '2021-01-17', 'MN', 'Mongolia', 'WPRO', '21', '1512', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55182, '2021-01-18', 'MN', 'Mongolia', 'WPRO', '5', '1517', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55183, '2021-01-19', 'MN', 'Mongolia', 'WPRO', '9', '1526', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55184, '2021-01-20', 'MN', 'Mongolia', 'WPRO', '10', '1536', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55185, '2021-01-21', 'MN', 'Mongolia', 'WPRO', '32', '1568', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55186, '2021-01-22', 'MN', 'Mongolia', 'WPRO', '16', '1584', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55187, '2021-01-23', 'MN', 'Mongolia', 'WPRO', '8', '1592', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55188, '2021-01-24', 'MN', 'Mongolia', 'WPRO', '19', '1611', '1', '2');
INSERT INTO public.who_global_data_import VALUES (55189, '2021-01-25', 'MN', 'Mongolia', 'WPRO', '16', '1627', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55190, '2021-01-26', 'MN', 'Mongolia', 'WPRO', '16', '1643', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55191, '2021-01-27', 'MN', 'Mongolia', 'WPRO', '13', '1656', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55192, '2021-01-28', 'MN', 'Mongolia', 'WPRO', '11', '1667', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55193, '2021-01-29', 'MN', 'Mongolia', 'WPRO', '25', '1692', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55194, '2021-01-30', 'MN', 'Mongolia', 'WPRO', '18', '1710', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55195, '2021-01-31', 'MN', 'Mongolia', 'WPRO', '32', '1742', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55196, '2021-02-01', 'MN', 'Mongolia', 'WPRO', '37', '1779', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55197, '2021-02-02', 'MN', 'Mongolia', 'WPRO', '35', '1814', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55198, '2021-02-03', 'MN', 'Mongolia', 'WPRO', '18', '1832', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55199, '2021-02-04', 'MN', 'Mongolia', 'WPRO', '27', '1859', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55200, '2021-02-05', 'MN', 'Mongolia', 'WPRO', '31', '1890', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55201, '2020-01-03', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55202, '2020-01-04', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55203, '2020-01-05', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55204, '2020-01-06', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55205, '2020-01-07', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55206, '2020-01-08', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55207, '2020-01-09', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55208, '2020-01-10', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55209, '2020-01-11', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55210, '2020-01-12', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55211, '2020-01-13', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55212, '2020-01-14', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55213, '2020-01-15', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55214, '2020-01-16', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55215, '2020-01-17', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55216, '2020-01-18', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55217, '2020-01-19', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55218, '2020-01-20', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55219, '2020-01-21', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55220, '2020-01-22', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55221, '2020-01-23', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55222, '2020-01-24', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55223, '2020-01-25', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55224, '2020-01-26', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55225, '2020-01-27', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55226, '2020-01-28', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55227, '2020-01-29', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55228, '2020-01-30', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55229, '2020-01-31', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55230, '2020-02-01', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55231, '2020-02-02', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55232, '2020-02-03', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55233, '2020-02-04', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55234, '2020-02-05', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55235, '2020-02-06', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55236, '2020-02-07', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55237, '2020-02-08', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55238, '2020-02-09', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55239, '2020-02-10', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55240, '2020-02-11', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55241, '2020-02-12', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55242, '2020-02-13', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55243, '2020-02-14', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55244, '2020-02-15', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55245, '2020-02-16', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55246, '2020-02-17', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55247, '2020-02-18', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55248, '2020-02-19', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55249, '2020-02-20', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55250, '2020-02-21', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55251, '2020-02-22', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55252, '2020-02-23', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55253, '2020-02-24', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55254, '2020-02-25', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55255, '2020-02-26', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55256, '2020-02-27', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55257, '2020-02-28', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55258, '2020-02-29', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55259, '2020-03-01', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55260, '2020-03-02', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55261, '2020-03-03', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55262, '2020-03-04', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55263, '2020-03-05', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55264, '2020-03-06', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55265, '2020-03-07', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55266, '2020-03-08', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55267, '2020-03-09', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55268, '2020-03-10', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55269, '2020-03-11', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55270, '2020-03-12', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55271, '2020-03-13', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55272, '2020-03-14', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55273, '2020-03-15', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55274, '2020-03-16', 'ME', 'Montenegro', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55275, '2020-03-17', 'ME', 'Montenegro', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55276, '2020-03-18', 'ME', 'Montenegro', 'EURO', '6', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55277, '2020-03-19', 'ME', 'Montenegro', 'EURO', '5', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55278, '2020-03-20', 'ME', 'Montenegro', 'EURO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55279, '2020-03-21', 'ME', 'Montenegro', 'EURO', '2', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55280, '2020-03-22', 'ME', 'Montenegro', 'EURO', '6', '22', '1', '1');
INSERT INTO public.who_global_data_import VALUES (55281, '2020-03-23', 'ME', 'Montenegro', 'EURO', '7', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55282, '2020-03-24', 'ME', 'Montenegro', 'EURO', '22', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55283, '2020-03-25', 'ME', 'Montenegro', 'EURO', '15', '66', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55284, '2020-03-26', 'ME', 'Montenegro', 'EURO', '4', '70', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55285, '2020-03-27', 'ME', 'Montenegro', 'EURO', '12', '82', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55286, '2020-03-28', 'ME', 'Montenegro', 'EURO', '3', '85', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55287, '2020-03-29', 'ME', 'Montenegro', 'EURO', '6', '91', '1', '2');
INSERT INTO public.who_global_data_import VALUES (55288, '2020-03-30', 'ME', 'Montenegro', 'EURO', '14', '105', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55289, '2020-03-31', 'ME', 'Montenegro', 'EURO', '15', '120', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55290, '2020-04-01', 'ME', 'Montenegro', 'EURO', '20', '140', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55291, '2020-04-02', 'ME', 'Montenegro', 'EURO', '20', '160', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55292, '2020-04-03', 'ME', 'Montenegro', 'EURO', '37', '197', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55293, '2020-04-04', 'ME', 'Montenegro', 'EURO', '6', '203', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55294, '2020-04-05', 'ME', 'Montenegro', 'EURO', '20', '223', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55295, '2020-04-06', 'ME', 'Montenegro', 'EURO', '16', '239', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55296, '2020-04-07', 'ME', 'Montenegro', 'EURO', '9', '248', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55297, '2020-04-08', 'ME', 'Montenegro', 'EURO', '4', '252', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55298, '2020-04-09', 'ME', 'Montenegro', 'EURO', '3', '255', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55299, '2020-04-10', 'ME', 'Montenegro', 'EURO', '7', '262', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55300, '2020-04-11', 'ME', 'Montenegro', 'EURO', '5', '267', '0', '2');
INSERT INTO public.who_global_data_import VALUES (55301, '2020-04-12', 'ME', 'Montenegro', 'EURO', '6', '273', '1', '3');
INSERT INTO public.who_global_data_import VALUES (55302, '2020-04-13', 'ME', 'Montenegro', 'EURO', '5', '278', '1', '4');
INSERT INTO public.who_global_data_import VALUES (55303, '2020-04-14', 'ME', 'Montenegro', 'EURO', '10', '288', '0', '4');
INSERT INTO public.who_global_data_import VALUES (55304, '2020-04-15', 'ME', 'Montenegro', 'EURO', '2', '290', '0', '4');
INSERT INTO public.who_global_data_import VALUES (55305, '2020-04-16', 'ME', 'Montenegro', 'EURO', '13', '303', '0', '4');
INSERT INTO public.who_global_data_import VALUES (55306, '2020-04-17', 'ME', 'Montenegro', 'EURO', '2', '305', '1', '5');
INSERT INTO public.who_global_data_import VALUES (55307, '2020-04-18', 'ME', 'Montenegro', 'EURO', '3', '308', '0', '5');
INSERT INTO public.who_global_data_import VALUES (55308, '2020-04-19', 'ME', 'Montenegro', 'EURO', '3', '311', '0', '5');
INSERT INTO public.who_global_data_import VALUES (55309, '2020-04-20', 'ME', 'Montenegro', 'EURO', '2', '313', '0', '5');
INSERT INTO public.who_global_data_import VALUES (55310, '2020-04-21', 'ME', 'Montenegro', 'EURO', '1', '314', '0', '5');
INSERT INTO public.who_global_data_import VALUES (55311, '2020-04-22', 'ME', 'Montenegro', 'EURO', '2', '316', '0', '5');
INSERT INTO public.who_global_data_import VALUES (55312, '2020-04-23', 'ME', 'Montenegro', 'EURO', '3', '319', '0', '5');
INSERT INTO public.who_global_data_import VALUES (55313, '2020-04-24', 'ME', 'Montenegro', 'EURO', '0', '319', '1', '6');
INSERT INTO public.who_global_data_import VALUES (55314, '2020-04-25', 'ME', 'Montenegro', 'EURO', '2', '321', '0', '6');
INSERT INTO public.who_global_data_import VALUES (55315, '2020-04-26', 'ME', 'Montenegro', 'EURO', '0', '321', '1', '7');
INSERT INTO public.who_global_data_import VALUES (55316, '2020-04-27', 'ME', 'Montenegro', 'EURO', '0', '321', '0', '7');
INSERT INTO public.who_global_data_import VALUES (55317, '2020-04-28', 'ME', 'Montenegro', 'EURO', '0', '321', '0', '7');
INSERT INTO public.who_global_data_import VALUES (55318, '2020-04-29', 'ME', 'Montenegro', 'EURO', '1', '322', '0', '7');
INSERT INTO public.who_global_data_import VALUES (55319, '2020-04-30', 'ME', 'Montenegro', 'EURO', '0', '322', '0', '7');
INSERT INTO public.who_global_data_import VALUES (55320, '2020-05-01', 'ME', 'Montenegro', 'EURO', '0', '322', '0', '7');
INSERT INTO public.who_global_data_import VALUES (55321, '2020-05-02', 'ME', 'Montenegro', 'EURO', '0', '322', '1', '8');
INSERT INTO public.who_global_data_import VALUES (55322, '2020-05-03', 'ME', 'Montenegro', 'EURO', '1', '323', '0', '8');
INSERT INTO public.who_global_data_import VALUES (55323, '2020-05-04', 'ME', 'Montenegro', 'EURO', '1', '324', '0', '8');
INSERT INTO public.who_global_data_import VALUES (55324, '2020-05-05', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '8');
INSERT INTO public.who_global_data_import VALUES (55325, '2020-05-06', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '8');
INSERT INTO public.who_global_data_import VALUES (55326, '2020-05-07', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '8');
INSERT INTO public.who_global_data_import VALUES (55327, '2020-05-08', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '8');
INSERT INTO public.who_global_data_import VALUES (55328, '2020-05-09', 'ME', 'Montenegro', 'EURO', '0', '324', '1', '9');
INSERT INTO public.who_global_data_import VALUES (55329, '2020-05-10', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55330, '2020-05-11', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55331, '2020-05-12', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55332, '2020-05-13', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55333, '2020-05-14', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55334, '2020-05-15', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55335, '2020-05-16', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55336, '2020-05-17', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55337, '2020-05-18', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55338, '2020-05-19', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55339, '2020-05-20', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55340, '2020-05-21', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55341, '2020-05-22', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55342, '2020-05-23', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55343, '2020-05-24', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55344, '2020-05-25', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55345, '2020-05-26', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55346, '2020-05-27', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55347, '2020-05-28', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55348, '2020-05-29', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55349, '2020-05-30', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55350, '2020-05-31', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55351, '2020-06-01', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55352, '2020-06-02', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55353, '2020-06-03', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55354, '2020-06-04', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55355, '2020-06-05', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55356, '2020-06-06', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55357, '2020-06-07', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55358, '2020-06-08', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55359, '2020-06-09', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55360, '2020-06-10', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55361, '2020-06-11', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55362, '2020-06-12', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55363, '2020-06-13', 'ME', 'Montenegro', 'EURO', '0', '324', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55364, '2020-06-14', 'ME', 'Montenegro', 'EURO', '1', '325', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55365, '2020-06-15', 'ME', 'Montenegro', 'EURO', '1', '326', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55366, '2020-06-16', 'ME', 'Montenegro', 'EURO', '0', '326', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55367, '2020-06-17', 'ME', 'Montenegro', 'EURO', '7', '333', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55368, '2020-06-18', 'ME', 'Montenegro', 'EURO', '4', '337', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55369, '2020-06-19', 'ME', 'Montenegro', 'EURO', '17', '354', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55370, '2020-06-20', 'ME', 'Montenegro', 'EURO', '4', '358', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55371, '2020-06-21', 'ME', 'Montenegro', 'EURO', '3', '361', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55372, '2020-06-22', 'ME', 'Montenegro', 'EURO', '6', '367', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55373, '2020-06-23', 'ME', 'Montenegro', 'EURO', '16', '383', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55374, '2020-06-24', 'ME', 'Montenegro', 'EURO', '12', '395', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55375, '2020-06-25', 'ME', 'Montenegro', 'EURO', '29', '424', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55376, '2020-06-26', 'ME', 'Montenegro', 'EURO', '25', '449', '0', '9');
INSERT INTO public.who_global_data_import VALUES (55377, '2020-06-27', 'ME', 'Montenegro', 'EURO', '26', '475', '1', '10');
INSERT INTO public.who_global_data_import VALUES (55378, '2020-06-28', 'ME', 'Montenegro', 'EURO', '23', '498', '2', '12');
INSERT INTO public.who_global_data_import VALUES (55379, '2020-06-29', 'ME', 'Montenegro', 'EURO', '28', '526', '1', '13');
INSERT INTO public.who_global_data_import VALUES (55380, '2020-06-30', 'ME', 'Montenegro', 'EURO', '28', '554', '0', '13');
INSERT INTO public.who_global_data_import VALUES (55381, '2020-07-01', 'ME', 'Montenegro', 'EURO', '56', '610', '0', '13');
INSERT INTO public.who_global_data_import VALUES (55382, '2020-07-02', 'ME', 'Montenegro', 'EURO', '43', '653', '0', '13');
INSERT INTO public.who_global_data_import VALUES (55383, '2020-07-03', 'ME', 'Montenegro', 'EURO', '55', '708', '1', '14');
INSERT INTO public.who_global_data_import VALUES (55384, '2020-07-04', 'ME', 'Montenegro', 'EURO', '34', '742', '0', '14');
INSERT INTO public.who_global_data_import VALUES (55385, '2020-07-05', 'ME', 'Montenegro', 'EURO', '151', '893', '0', '14');
INSERT INTO public.who_global_data_import VALUES (55386, '2020-07-06', 'ME', 'Montenegro', 'EURO', '130', '1023', '3', '17');
INSERT INTO public.who_global_data_import VALUES (55387, '2020-07-07', 'ME', 'Montenegro', 'EURO', '174', '1197', '1', '18');
INSERT INTO public.who_global_data_import VALUES (55388, '2020-07-08', 'ME', 'Montenegro', 'EURO', '184', '1381', '0', '18');
INSERT INTO public.who_global_data_import VALUES (55389, '2020-07-09', 'ME', 'Montenegro', 'EURO', '134', '1515', '2', '20');
INSERT INTO public.who_global_data_import VALUES (55390, '2020-07-10', 'ME', 'Montenegro', 'EURO', '108', '1623', '1', '21');
INSERT INTO public.who_global_data_import VALUES (55391, '2020-07-11', 'ME', 'Montenegro', 'EURO', '52', '1675', '4', '25');
INSERT INTO public.who_global_data_import VALUES (55392, '2020-07-12', 'ME', 'Montenegro', 'EURO', '51', '1726', '0', '25');
INSERT INTO public.who_global_data_import VALUES (55393, '2020-07-13', 'ME', 'Montenegro', 'EURO', '37', '1763', '0', '25');
INSERT INTO public.who_global_data_import VALUES (55394, '2020-07-14', 'ME', 'Montenegro', 'EURO', '105', '1868', '0', '25');
INSERT INTO public.who_global_data_import VALUES (55395, '2020-07-15', 'ME', 'Montenegro', 'EURO', '70', '1938', '0', '25');
INSERT INTO public.who_global_data_import VALUES (55396, '2020-07-16', 'ME', 'Montenegro', 'EURO', '59', '1997', '1', '26');
INSERT INTO public.who_global_data_import VALUES (55397, '2020-07-17', 'ME', 'Montenegro', 'EURO', '40', '2037', '2', '28');
INSERT INTO public.who_global_data_import VALUES (55398, '2020-07-18', 'ME', 'Montenegro', 'EURO', '97', '2134', '3', '31');
INSERT INTO public.who_global_data_import VALUES (55399, '2020-07-19', 'ME', 'Montenegro', 'EURO', '134', '2268', '2', '33');
INSERT INTO public.who_global_data_import VALUES (55400, '2020-07-20', 'ME', 'Montenegro', 'EURO', '111', '2379', '2', '35');
INSERT INTO public.who_global_data_import VALUES (55401, '2020-07-21', 'ME', 'Montenegro', 'EURO', '91', '2470', '0', '35');
INSERT INTO public.who_global_data_import VALUES (55402, '2020-07-22', 'ME', 'Montenegro', 'EURO', '97', '2567', '4', '39');
INSERT INTO public.who_global_data_import VALUES (55403, '2020-07-23', 'ME', 'Montenegro', 'EURO', '72', '2639', '1', '40');
INSERT INTO public.who_global_data_import VALUES (55404, '2020-07-24', 'ME', 'Montenegro', 'EURO', '86', '2725', '3', '43');
INSERT INTO public.who_global_data_import VALUES (55405, '2020-07-25', 'ME', 'Montenegro', 'EURO', '69', '2794', '0', '43');
INSERT INTO public.who_global_data_import VALUES (55406, '2020-07-26', 'ME', 'Montenegro', 'EURO', '55', '2849', '0', '43');
INSERT INTO public.who_global_data_import VALUES (55407, '2020-07-27', 'ME', 'Montenegro', 'EURO', '85', '2934', '2', '45');
INSERT INTO public.who_global_data_import VALUES (55408, '2020-07-28', 'ME', 'Montenegro', 'EURO', '63', '2997', '0', '45');
INSERT INTO public.who_global_data_import VALUES (55409, '2020-07-29', 'ME', 'Montenegro', 'EURO', '66', '3063', '2', '47');
INSERT INTO public.who_global_data_import VALUES (55410, '2020-07-30', 'ME', 'Montenegro', 'EURO', '46', '3109', '1', '48');
INSERT INTO public.who_global_data_import VALUES (55411, '2020-07-31', 'ME', 'Montenegro', 'EURO', '73', '3182', '1', '49');
INSERT INTO public.who_global_data_import VALUES (55412, '2020-08-01', 'ME', 'Montenegro', 'EURO', '69', '3251', '2', '51');
INSERT INTO public.who_global_data_import VALUES (55413, '2020-08-02', 'ME', 'Montenegro', 'EURO', '27', '3278', '0', '51');
INSERT INTO public.who_global_data_import VALUES (55414, '2020-08-03', 'ME', 'Montenegro', 'EURO', '46', '3324', '2', '53');
INSERT INTO public.who_global_data_import VALUES (55415, '2020-08-04', 'ME', 'Montenegro', 'EURO', '60', '3384', '1', '54');
INSERT INTO public.who_global_data_import VALUES (55416, '2020-08-05', 'ME', 'Montenegro', 'EURO', '54', '3438', '3', '57');
INSERT INTO public.who_global_data_import VALUES (55417, '2020-08-06', 'ME', 'Montenegro', 'EURO', '80', '3518', '3', '60');
INSERT INTO public.who_global_data_import VALUES (55418, '2020-08-07', 'ME', 'Montenegro', 'EURO', '48', '3566', '1', '61');
INSERT INTO public.who_global_data_import VALUES (55419, '2020-08-08', 'ME', 'Montenegro', 'EURO', '41', '3607', '1', '62');
INSERT INTO public.who_global_data_import VALUES (55420, '2020-08-09', 'ME', 'Montenegro', 'EURO', '55', '3662', '5', '67');
INSERT INTO public.who_global_data_import VALUES (55421, '2020-08-10', 'ME', 'Montenegro', 'EURO', '49', '3711', '3', '70');
INSERT INTO public.who_global_data_import VALUES (55422, '2020-08-11', 'ME', 'Montenegro', 'EURO', '62', '3773', '3', '73');
INSERT INTO public.who_global_data_import VALUES (55423, '2020-08-12', 'ME', 'Montenegro', 'EURO', '59', '3832', '0', '73');
INSERT INTO public.who_global_data_import VALUES (55424, '2020-08-13', 'ME', 'Montenegro', 'EURO', '46', '3878', '0', '73');
INSERT INTO public.who_global_data_import VALUES (55425, '2020-08-14', 'ME', 'Montenegro', 'EURO', '80', '3958', '0', '73');
INSERT INTO public.who_global_data_import VALUES (55426, '2020-08-15', 'ME', 'Montenegro', 'EURO', '53', '4011', '2', '75');
INSERT INTO public.who_global_data_import VALUES (55427, '2020-08-16', 'ME', 'Montenegro', 'EURO', '45', '4056', '3', '78');
INSERT INTO public.who_global_data_import VALUES (55428, '2020-08-17', 'ME', 'Montenegro', 'EURO', '44', '4100', '2', '80');
INSERT INTO public.who_global_data_import VALUES (55429, '2020-08-18', 'ME', 'Montenegro', 'EURO', '51', '4151', '0', '80');
INSERT INTO public.who_global_data_import VALUES (55430, '2020-08-19', 'ME', 'Montenegro', 'EURO', '58', '4209', '1', '81');
INSERT INTO public.who_global_data_import VALUES (55431, '2020-08-20', 'ME', 'Montenegro', 'EURO', '38', '4247', '0', '81');
INSERT INTO public.who_global_data_import VALUES (55432, '2020-08-21', 'ME', 'Montenegro', 'EURO', '41', '4288', '1', '82');
INSERT INTO public.who_global_data_import VALUES (55433, '2020-08-22', 'ME', 'Montenegro', 'EURO', '25', '4313', '2', '84');
INSERT INTO public.who_global_data_import VALUES (55434, '2020-08-23', 'ME', 'Montenegro', 'EURO', '43', '4356', '0', '84');
INSERT INTO public.who_global_data_import VALUES (55435, '2020-08-24', 'ME', 'Montenegro', 'EURO', '33', '4389', '1', '85');
INSERT INTO public.who_global_data_import VALUES (55436, '2020-08-25', 'ME', 'Montenegro', 'EURO', '75', '4464', '3', '88');
INSERT INTO public.who_global_data_import VALUES (55437, '2020-08-26', 'ME', 'Montenegro', 'EURO', '59', '4523', '0', '88');
INSERT INTO public.who_global_data_import VALUES (55438, '2020-08-27', 'ME', 'Montenegro', 'EURO', '94', '4617', '2', '90');
INSERT INTO public.who_global_data_import VALUES (55439, '2020-08-28', 'ME', 'Montenegro', 'EURO', '71', '4688', '2', '92');
INSERT INTO public.who_global_data_import VALUES (55440, '2020-08-29', 'ME', 'Montenegro', 'EURO', '89', '4777', '4', '96');
INSERT INTO public.who_global_data_import VALUES (55441, '2020-08-30', 'ME', 'Montenegro', 'EURO', '40', '4817', '3', '99');
INSERT INTO public.who_global_data_import VALUES (55442, '2020-08-31', 'ME', 'Montenegro', 'EURO', '88', '4905', '1', '100');
INSERT INTO public.who_global_data_import VALUES (55443, '2020-09-01', 'ME', 'Montenegro', 'EURO', '72', '4977', '2', '102');
INSERT INTO public.who_global_data_import VALUES (55444, '2020-09-02', 'ME', 'Montenegro', 'EURO', '125', '5102', '2', '104');
INSERT INTO public.who_global_data_import VALUES (55445, '2020-09-03', 'ME', 'Montenegro', 'EURO', '123', '5225', '0', '104');
INSERT INTO public.who_global_data_import VALUES (55446, '2020-09-04', 'ME', 'Montenegro', 'EURO', '154', '5379', '2', '106');
INSERT INTO public.who_global_data_import VALUES (55447, '2020-09-05', 'ME', 'Montenegro', 'EURO', '139', '5518', '1', '107');
INSERT INTO public.who_global_data_import VALUES (55448, '2020-09-06', 'ME', 'Montenegro', 'EURO', '87', '5605', '1', '108');
INSERT INTO public.who_global_data_import VALUES (55449, '2020-09-07', 'ME', 'Montenegro', 'EURO', '248', '5853', '1', '109');
INSERT INTO public.who_global_data_import VALUES (55450, '2020-09-08', 'ME', 'Montenegro', 'EURO', '172', '6025', '5', '114');
INSERT INTO public.who_global_data_import VALUES (55451, '2020-09-09', 'ME', 'Montenegro', 'EURO', '140', '6165', '0', '114');
INSERT INTO public.who_global_data_import VALUES (55452, '2020-09-10', 'ME', 'Montenegro', 'EURO', '169', '6334', '0', '114');
INSERT INTO public.who_global_data_import VALUES (55453, '2020-09-11', 'ME', 'Montenegro', 'EURO', '140', '6474', '3', '117');
INSERT INTO public.who_global_data_import VALUES (55454, '2020-09-12', 'ME', 'Montenegro', 'EURO', '351', '6825', '1', '118');
INSERT INTO public.who_global_data_import VALUES (55455, '2020-09-13', 'ME', 'Montenegro', 'EURO', '348', '7173', '2', '120');
INSERT INTO public.who_global_data_import VALUES (55456, '2020-09-14', 'ME', 'Montenegro', 'EURO', '334', '7507', '1', '121');
INSERT INTO public.who_global_data_import VALUES (55457, '2020-09-15', 'ME', 'Montenegro', 'EURO', '174', '7681', '2', '123');
INSERT INTO public.who_global_data_import VALUES (55458, '2020-09-16', 'ME', 'Montenegro', 'EURO', '202', '7883', '4', '127');
INSERT INTO public.who_global_data_import VALUES (55459, '2020-09-17', 'ME', 'Montenegro', 'EURO', '201', '8084', '2', '129');
INSERT INTO public.who_global_data_import VALUES (55460, '2020-09-18', 'ME', 'Montenegro', 'EURO', '233', '8317', '4', '133');
INSERT INTO public.who_global_data_import VALUES (55461, '2020-09-19', 'ME', 'Montenegro', 'EURO', '284', '8601', '1', '134');
INSERT INTO public.who_global_data_import VALUES (55462, '2020-09-20', 'ME', 'Montenegro', 'EURO', '238', '8839', '2', '136');
INSERT INTO public.who_global_data_import VALUES (55463, '2020-09-21', 'ME', 'Montenegro', 'EURO', '199', '9038', '2', '138');
INSERT INTO public.who_global_data_import VALUES (55464, '2020-09-22', 'ME', 'Montenegro', 'EURO', '320', '9358', '8', '146');
INSERT INTO public.who_global_data_import VALUES (55465, '2020-09-23', 'ME', 'Montenegro', 'EURO', '269', '9627', '5', '151');
INSERT INTO public.who_global_data_import VALUES (55466, '2020-09-24', 'ME', 'Montenegro', 'EURO', '279', '9906', '3', '154');
INSERT INTO public.who_global_data_import VALUES (55467, '2020-09-25', 'ME', 'Montenegro', 'EURO', '196', '10102', '2', '156');
INSERT INTO public.who_global_data_import VALUES (55468, '2020-09-26', 'ME', 'Montenegro', 'EURO', '255', '10357', '2', '158');
INSERT INTO public.who_global_data_import VALUES (55469, '2020-09-27', 'ME', 'Montenegro', 'EURO', '212', '10569', '0', '158');
INSERT INTO public.who_global_data_import VALUES (55470, '2020-09-28', 'ME', 'Montenegro', 'EURO', '371', '10940', '5', '163');
INSERT INTO public.who_global_data_import VALUES (55471, '2020-09-29', 'ME', 'Montenegro', 'EURO', '266', '11206', '1', '164');
INSERT INTO public.who_global_data_import VALUES (55472, '2020-09-30', 'ME', 'Montenegro', 'EURO', '247', '11453', '5', '169');
INSERT INTO public.who_global_data_import VALUES (55473, '2020-10-01', 'ME', 'Montenegro', 'EURO', '203', '11656', '1', '170');
INSERT INTO public.who_global_data_import VALUES (55474, '2020-10-02', 'ME', 'Montenegro', 'EURO', '186', '11842', '3', '173');
INSERT INTO public.who_global_data_import VALUES (55475, '2020-10-03', 'ME', 'Montenegro', 'EURO', '241', '12083', '2', '175');
INSERT INTO public.who_global_data_import VALUES (55476, '2020-10-04', 'ME', 'Montenegro', 'EURO', '165', '12248', '5', '180');
INSERT INTO public.who_global_data_import VALUES (55477, '2020-10-05', 'ME', 'Montenegro', 'EURO', '259', '12507', '4', '184');
INSERT INTO public.who_global_data_import VALUES (55478, '2020-10-06', 'ME', 'Montenegro', 'EURO', '192', '12699', '5', '189');
INSERT INTO public.who_global_data_import VALUES (55479, '2020-10-07', 'ME', 'Montenegro', 'EURO', '218', '12917', '2', '191');
INSERT INTO public.who_global_data_import VALUES (55480, '2020-10-08', 'ME', 'Montenegro', 'EURO', '279', '13196', '1', '192');
INSERT INTO public.who_global_data_import VALUES (55481, '2020-10-09', 'ME', 'Montenegro', 'EURO', '362', '13558', '3', '195');
INSERT INTO public.who_global_data_import VALUES (55482, '2020-10-10', 'ME', 'Montenegro', 'EURO', '203', '13761', '4', '199');
INSERT INTO public.who_global_data_import VALUES (55483, '2020-10-11', 'ME', 'Montenegro', 'EURO', '223', '13984', '5', '204');
INSERT INTO public.who_global_data_import VALUES (55484, '2020-10-12', 'ME', 'Montenegro', 'EURO', '288', '14272', '9', '213');
INSERT INTO public.who_global_data_import VALUES (55485, '2020-10-13', 'ME', 'Montenegro', 'EURO', '462', '14734', '2', '215');
INSERT INTO public.who_global_data_import VALUES (55486, '2020-10-14', 'ME', 'Montenegro', 'EURO', '319', '15053', '4', '219');
INSERT INTO public.who_global_data_import VALUES (55487, '2020-10-15', 'ME', 'Montenegro', 'EURO', '221', '15274', '2', '221');
INSERT INTO public.who_global_data_import VALUES (55488, '2020-10-16', 'ME', 'Montenegro', 'EURO', '233', '15507', '7', '228');
INSERT INTO public.who_global_data_import VALUES (55489, '2020-10-17', 'ME', 'Montenegro', 'EURO', '84', '15591', '3', '231');
INSERT INTO public.who_global_data_import VALUES (55490, '2020-10-18', 'ME', 'Montenegro', 'EURO', '139', '15730', '5', '236');
INSERT INTO public.who_global_data_import VALUES (55491, '2020-10-19', 'ME', 'Montenegro', 'EURO', '118', '15848', '4', '240');
INSERT INTO public.who_global_data_import VALUES (55492, '2020-10-20', 'ME', 'Montenegro', 'EURO', '180', '16028', '7', '247');
INSERT INTO public.who_global_data_import VALUES (55493, '2020-10-21', 'ME', 'Montenegro', 'EURO', '164', '16192', '3', '250');
INSERT INTO public.who_global_data_import VALUES (55494, '2020-10-22', 'ME', 'Montenegro', 'EURO', '155', '16347', '3', '253');
INSERT INTO public.who_global_data_import VALUES (55495, '2020-10-23', 'ME', 'Montenegro', 'EURO', '189', '16536', '2', '255');
INSERT INTO public.who_global_data_import VALUES (55496, '2020-10-24', 'ME', 'Montenegro', 'EURO', '194', '16730', '8', '263');
INSERT INTO public.who_global_data_import VALUES (55497, '2020-10-25', 'ME', 'Montenegro', 'EURO', '292', '17022', '3', '266');
INSERT INTO public.who_global_data_import VALUES (55498, '2020-10-26', 'ME', 'Montenegro', 'EURO', '332', '17354', '4', '270');
INSERT INTO public.who_global_data_import VALUES (55499, '2020-10-27', 'ME', 'Montenegro', 'EURO', '237', '17591', '5', '275');
INSERT INTO public.who_global_data_import VALUES (55500, '2020-10-28', 'ME', 'Montenegro', 'EURO', '519', '18110', '7', '282');
INSERT INTO public.who_global_data_import VALUES (55501, '2020-10-29', 'ME', 'Montenegro', 'EURO', '347', '18457', '8', '290');
INSERT INTO public.who_global_data_import VALUES (55502, '2020-10-30', 'ME', 'Montenegro', 'EURO', '550', '19007', '4', '294');
INSERT INTO public.who_global_data_import VALUES (55503, '2020-10-31', 'ME', 'Montenegro', 'EURO', '342', '19349', '7', '301');
INSERT INTO public.who_global_data_import VALUES (55504, '2020-11-01', 'ME', 'Montenegro', 'EURO', '357', '19706', '11', '312');
INSERT INTO public.who_global_data_import VALUES (55505, '2020-11-02', 'ME', 'Montenegro', 'EURO', '550', '20256', '7', '319');
INSERT INTO public.who_global_data_import VALUES (55506, '2020-11-03', 'ME', 'Montenegro', 'EURO', '533', '20789', '2', '321');
INSERT INTO public.who_global_data_import VALUES (55507, '2020-11-04', 'ME', 'Montenegro', 'EURO', '526', '21315', '4', '325');
INSERT INTO public.who_global_data_import VALUES (55508, '2020-11-05', 'ME', 'Montenegro', 'EURO', '504', '21819', '3', '328');
INSERT INTO public.who_global_data_import VALUES (55509, '2020-11-06', 'ME', 'Montenegro', 'EURO', '465', '22284', '1', '329');
INSERT INTO public.who_global_data_import VALUES (55510, '2020-11-07', 'ME', 'Montenegro', 'EURO', '429', '22713', '3', '332');
INSERT INTO public.who_global_data_import VALUES (55511, '2020-11-08', 'ME', 'Montenegro', 'EURO', '382', '23095', '4', '336');
INSERT INTO public.who_global_data_import VALUES (55512, '2020-11-09', 'ME', 'Montenegro', 'EURO', '956', '24051', '5', '341');
INSERT INTO public.who_global_data_import VALUES (55513, '2020-11-10', 'ME', 'Montenegro', 'EURO', '617', '24668', '7', '348');
INSERT INTO public.who_global_data_import VALUES (55514, '2020-11-11', 'ME', 'Montenegro', 'EURO', '719', '25387', '7', '355');
INSERT INTO public.who_global_data_import VALUES (55515, '2020-11-12', 'ME', 'Montenegro', 'EURO', '666', '26053', '8', '363');
INSERT INTO public.who_global_data_import VALUES (55516, '2020-11-13', 'ME', 'Montenegro', 'EURO', '620', '26673', '13', '376');
INSERT INTO public.who_global_data_import VALUES (55517, '2020-11-14', 'ME', 'Montenegro', 'EURO', '541', '27214', '8', '384');
INSERT INTO public.who_global_data_import VALUES (55518, '2020-11-15', 'ME', 'Montenegro', 'EURO', '463', '27677', '6', '390');
INSERT INTO public.who_global_data_import VALUES (55519, '2020-11-16', 'ME', 'Montenegro', 'EURO', '625', '28302', '5', '395');
INSERT INTO public.who_global_data_import VALUES (55520, '2020-11-17', 'ME', 'Montenegro', 'EURO', '585', '28887', '9', '404');
INSERT INTO public.who_global_data_import VALUES (55521, '2020-11-18', 'ME', 'Montenegro', 'EURO', '565', '29452', '9', '413');
INSERT INTO public.who_global_data_import VALUES (55522, '2020-11-19', 'ME', 'Montenegro', 'EURO', '536', '29988', '6', '419');
INSERT INTO public.who_global_data_import VALUES (55523, '2020-11-20', 'ME', 'Montenegro', 'EURO', '621', '30609', '9', '428');
INSERT INTO public.who_global_data_import VALUES (55524, '2020-11-21', 'ME', 'Montenegro', 'EURO', '467', '31076', '5', '433');
INSERT INTO public.who_global_data_import VALUES (55525, '2020-11-22', 'ME', 'Montenegro', 'EURO', '409', '31485', '5', '438');
INSERT INTO public.who_global_data_import VALUES (55526, '2020-11-23', 'ME', 'Montenegro', 'EURO', '639', '32124', '5', '443');
INSERT INTO public.who_global_data_import VALUES (55527, '2020-11-24', 'ME', 'Montenegro', 'EURO', '538', '32662', '6', '449');
INSERT INTO public.who_global_data_import VALUES (55528, '2020-11-25', 'ME', 'Montenegro', 'EURO', '558', '33220', '9', '458');
INSERT INTO public.who_global_data_import VALUES (55529, '2020-11-26', 'ME', 'Montenegro', 'EURO', '592', '33812', '10', '468');
INSERT INTO public.who_global_data_import VALUES (55530, '2020-11-27', 'ME', 'Montenegro', 'EURO', '569', '34381', '5', '473');
INSERT INTO public.who_global_data_import VALUES (55531, '2020-11-28', 'ME', 'Montenegro', 'EURO', '393', '34774', '7', '480');
INSERT INTO public.who_global_data_import VALUES (55532, '2020-11-29', 'ME', 'Montenegro', 'EURO', '453', '35227', '6', '486');
INSERT INTO public.who_global_data_import VALUES (55533, '2020-11-30', 'ME', 'Montenegro', 'EURO', '558', '35785', '12', '498');
INSERT INTO public.who_global_data_import VALUES (55534, '2020-12-01', 'ME', 'Montenegro', 'EURO', '492', '36277', '5', '503');
INSERT INTO public.who_global_data_import VALUES (55535, '2020-12-02', 'ME', 'Montenegro', 'EURO', '568', '36845', '6', '509');
INSERT INTO public.who_global_data_import VALUES (55536, '2020-12-03', 'ME', 'Montenegro', 'EURO', '529', '37374', '6', '515');
INSERT INTO public.who_global_data_import VALUES (55537, '2020-12-04', 'ME', 'Montenegro', 'EURO', '488', '37862', '6', '521');
INSERT INTO public.who_global_data_import VALUES (55538, '2020-12-05', 'ME', 'Montenegro', 'EURO', '396', '38258', '8', '529');
INSERT INTO public.who_global_data_import VALUES (55539, '2020-12-06', 'ME', 'Montenegro', 'EURO', '289', '38547', '3', '532');
INSERT INTO public.who_global_data_import VALUES (55540, '2020-12-07', 'ME', 'Montenegro', 'EURO', '529', '39076', '10', '542');
INSERT INTO public.who_global_data_import VALUES (55541, '2020-12-08', 'ME', 'Montenegro', 'EURO', '528', '39604', '6', '548');
INSERT INTO public.who_global_data_import VALUES (55542, '2020-12-09', 'ME', 'Montenegro', 'EURO', '492', '40096', '7', '555');
INSERT INTO public.who_global_data_import VALUES (55543, '2020-12-10', 'ME', 'Montenegro', 'EURO', '417', '40513', '10', '565');
INSERT INTO public.who_global_data_import VALUES (55544, '2020-12-11', 'ME', 'Montenegro', 'EURO', '375', '40888', '3', '568');
INSERT INTO public.who_global_data_import VALUES (55545, '2020-12-12', 'ME', 'Montenegro', 'EURO', '465', '41353', '9', '577');
INSERT INTO public.who_global_data_import VALUES (55546, '2020-12-13', 'ME', 'Montenegro', 'EURO', '352', '41705', '4', '581');
INSERT INTO public.who_global_data_import VALUES (55547, '2020-12-14', 'ME', 'Montenegro', 'EURO', '432', '42137', '3', '584');
INSERT INTO public.who_global_data_import VALUES (55548, '2020-12-15', 'ME', 'Montenegro', 'EURO', '378', '42515', '12', '596');
INSERT INTO public.who_global_data_import VALUES (55549, '2020-12-16', 'ME', 'Montenegro', 'EURO', '405', '42920', '13', '609');
INSERT INTO public.who_global_data_import VALUES (55550, '2020-12-17', 'ME', 'Montenegro', 'EURO', '380', '43300', '4', '613');
INSERT INTO public.who_global_data_import VALUES (55551, '2020-12-18', 'ME', 'Montenegro', 'EURO', '399', '43699', '6', '619');
INSERT INTO public.who_global_data_import VALUES (55552, '2020-12-19', 'ME', 'Montenegro', 'EURO', '304', '44003', '4', '623');
INSERT INTO public.who_global_data_import VALUES (55553, '2020-12-20', 'ME', 'Montenegro', 'EURO', '268', '44271', '2', '625');
INSERT INTO public.who_global_data_import VALUES (55554, '2020-12-21', 'ME', 'Montenegro', 'EURO', '350', '44621', '5', '630');
INSERT INTO public.who_global_data_import VALUES (55555, '2020-12-22', 'ME', 'Montenegro', 'EURO', '380', '45001', '7', '637');
INSERT INTO public.who_global_data_import VALUES (55556, '2020-12-23', 'ME', 'Montenegro', 'EURO', '379', '45380', '2', '639');
INSERT INTO public.who_global_data_import VALUES (55557, '2020-12-24', 'ME', 'Montenegro', 'EURO', '440', '45820', '9', '648');
INSERT INTO public.who_global_data_import VALUES (55558, '2020-12-25', 'ME', 'Montenegro', 'EURO', '457', '46277', '4', '652');
INSERT INTO public.who_global_data_import VALUES (55559, '2020-12-26', 'ME', 'Montenegro', 'EURO', '356', '46633', '6', '658');
INSERT INTO public.who_global_data_import VALUES (55560, '2020-12-27', 'ME', 'Montenegro', 'EURO', '296', '46929', '8', '666');
INSERT INTO public.who_global_data_import VALUES (55561, '2020-12-28', 'ME', 'Montenegro', 'EURO', '388', '47317', '9', '675');
INSERT INTO public.who_global_data_import VALUES (55562, '2020-12-29', 'ME', 'Montenegro', 'EURO', '352', '47669', '2', '677');
INSERT INTO public.who_global_data_import VALUES (55563, '2020-12-30', 'ME', 'Montenegro', 'EURO', '436', '48105', '4', '681');
INSERT INTO public.who_global_data_import VALUES (55564, '2020-12-31', 'ME', 'Montenegro', 'EURO', '439', '48544', '1', '682');
INSERT INTO public.who_global_data_import VALUES (55565, '2021-01-01', 'ME', 'Montenegro', 'EURO', '249', '48793', '2', '684');
INSERT INTO public.who_global_data_import VALUES (55566, '2021-01-02', 'ME', 'Montenegro', 'EURO', '386', '49179', '0', '684');
INSERT INTO public.who_global_data_import VALUES (55567, '2021-01-03', 'ME', 'Montenegro', 'EURO', '300', '49479', '5', '689');
INSERT INTO public.who_global_data_import VALUES (55568, '2021-01-04', 'ME', 'Montenegro', 'EURO', '520', '49999', '3', '692');
INSERT INTO public.who_global_data_import VALUES (55569, '2021-01-05', 'ME', 'Montenegro', 'EURO', '526', '50525', '7', '699');
INSERT INTO public.who_global_data_import VALUES (55570, '2021-01-06', 'ME', 'Montenegro', 'EURO', '497', '51022', '6', '705');
INSERT INTO public.who_global_data_import VALUES (55571, '2021-01-07', 'ME', 'Montenegro', 'EURO', '479', '51501', '7', '712');
INSERT INTO public.who_global_data_import VALUES (55572, '2021-01-08', 'ME', 'Montenegro', 'EURO', '410', '51911', '6', '718');
INSERT INTO public.who_global_data_import VALUES (55573, '2021-01-09', 'ME', 'Montenegro', 'EURO', '490', '52401', '3', '721');
INSERT INTO public.who_global_data_import VALUES (55574, '2021-01-10', 'ME', 'Montenegro', 'EURO', '343', '52744', '4', '725');
INSERT INTO public.who_global_data_import VALUES (55575, '2021-01-11', 'ME', 'Montenegro', 'EURO', '515', '53259', '4', '729');
INSERT INTO public.who_global_data_import VALUES (55576, '2021-01-12', 'ME', 'Montenegro', 'EURO', '524', '53783', '1', '730');
INSERT INTO public.who_global_data_import VALUES (55577, '2021-01-13', 'ME', 'Montenegro', 'EURO', '447', '54230', '7', '737');
INSERT INTO public.who_global_data_import VALUES (55578, '2021-01-14', 'ME', 'Montenegro', 'EURO', '422', '54652', '3', '740');
INSERT INTO public.who_global_data_import VALUES (55579, '2021-01-15', 'ME', 'Montenegro', 'EURO', '429', '55081', '1', '741');
INSERT INTO public.who_global_data_import VALUES (55580, '2021-01-16', 'ME', 'Montenegro', 'EURO', '403', '55484', '2', '743');
INSERT INTO public.who_global_data_import VALUES (55581, '2021-01-17', 'ME', 'Montenegro', 'EURO', '286', '55770', '2', '745');
INSERT INTO public.who_global_data_import VALUES (55582, '2021-01-18', 'ME', 'Montenegro', 'EURO', '406', '56176', '1', '746');
INSERT INTO public.who_global_data_import VALUES (55583, '2021-01-19', 'ME', 'Montenegro', 'EURO', '351', '56527', '3', '749');
INSERT INTO public.who_global_data_import VALUES (55584, '2021-01-20', 'ME', 'Montenegro', 'EURO', '452', '56979', '9', '758');
INSERT INTO public.who_global_data_import VALUES (55585, '2021-01-21', 'ME', 'Montenegro', 'EURO', '476', '57455', '4', '762');
INSERT INTO public.who_global_data_import VALUES (55586, '2021-01-22', 'ME', 'Montenegro', 'EURO', '421', '57876', '3', '765');
INSERT INTO public.who_global_data_import VALUES (55587, '2021-01-23', 'ME', 'Montenegro', 'EURO', '425', '58301', '1', '766');
INSERT INTO public.who_global_data_import VALUES (55588, '2021-01-24', 'ME', 'Montenegro', 'EURO', '384', '58685', '2', '768');
INSERT INTO public.who_global_data_import VALUES (55589, '2021-01-25', 'ME', 'Montenegro', 'EURO', '566', '59251', '2', '770');
INSERT INTO public.who_global_data_import VALUES (55590, '2021-01-26', 'ME', 'Montenegro', 'EURO', '507', '59758', '7', '777');
INSERT INTO public.who_global_data_import VALUES (55591, '2021-01-27', 'ME', 'Montenegro', 'EURO', '498', '60256', '6', '783');
INSERT INTO public.who_global_data_import VALUES (55592, '2021-01-28', 'ME', 'Montenegro', 'EURO', '460', '60716', '7', '790');
INSERT INTO public.who_global_data_import VALUES (55593, '2021-01-29', 'ME', 'Montenegro', 'EURO', '459', '61175', '10', '800');
INSERT INTO public.who_global_data_import VALUES (55594, '2021-01-30', 'ME', 'Montenegro', 'EURO', '450', '61625', '2', '802');
INSERT INTO public.who_global_data_import VALUES (55595, '2021-01-31', 'ME', 'Montenegro', 'EURO', '365', '61990', '3', '805');
INSERT INTO public.who_global_data_import VALUES (55596, '2021-02-01', 'ME', 'Montenegro', 'EURO', '523', '62513', '6', '811');
INSERT INTO public.who_global_data_import VALUES (55597, '2021-02-02', 'ME', 'Montenegro', 'EURO', '601', '63114', '7', '818');
INSERT INTO public.who_global_data_import VALUES (55598, '2021-02-03', 'ME', 'Montenegro', 'EURO', '510', '63624', '7', '825');
INSERT INTO public.who_global_data_import VALUES (55599, '2021-02-04', 'ME', 'Montenegro', 'EURO', '383', '64007', '1', '826');
INSERT INTO public.who_global_data_import VALUES (55600, '2021-02-05', 'ME', 'Montenegro', 'EURO', '0', '64007', '0', '826');
INSERT INTO public.who_global_data_import VALUES (55601, '2020-01-03', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55602, '2020-01-04', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55603, '2020-01-05', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55604, '2020-01-06', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55605, '2020-01-07', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55606, '2020-01-08', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55607, '2020-01-09', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55608, '2020-01-10', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55609, '2020-01-11', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55610, '2020-01-12', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55611, '2020-01-13', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55612, '2020-01-14', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55613, '2020-01-15', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55614, '2020-01-16', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55615, '2020-01-17', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55616, '2020-01-18', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55617, '2020-01-19', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55618, '2020-01-20', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55619, '2020-01-21', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55620, '2020-01-22', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55621, '2020-01-23', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55622, '2020-01-24', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55623, '2020-01-25', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55624, '2020-01-26', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55625, '2020-01-27', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55626, '2020-01-28', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55627, '2020-01-29', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55628, '2020-01-30', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55629, '2020-01-31', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55630, '2020-02-01', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55631, '2020-02-02', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55632, '2020-02-03', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55633, '2020-02-04', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55634, '2020-02-05', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55635, '2020-02-06', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55636, '2020-02-07', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55637, '2020-02-08', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55638, '2020-02-09', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55639, '2020-02-10', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55640, '2020-02-11', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55641, '2020-02-12', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55642, '2020-02-13', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55643, '2020-02-14', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55644, '2020-02-15', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55645, '2020-02-16', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55646, '2020-02-17', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55647, '2020-02-18', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55648, '2020-02-19', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55649, '2020-02-20', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55650, '2020-02-21', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55651, '2020-02-22', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55652, '2020-02-23', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55653, '2020-02-24', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55654, '2020-02-25', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55655, '2020-02-26', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55656, '2020-02-27', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55657, '2020-02-28', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55658, '2020-02-29', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55659, '2020-03-01', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55660, '2020-03-02', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55661, '2020-03-03', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55662, '2020-03-04', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55663, '2020-03-05', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55664, '2020-03-06', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55665, '2020-03-07', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55666, '2020-03-08', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55667, '2020-03-09', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55668, '2020-03-10', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55669, '2020-03-11', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55670, '2020-03-12', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55671, '2020-03-13', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55672, '2020-03-14', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55673, '2020-03-15', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55674, '2020-03-16', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55675, '2020-03-17', 'MS', 'Montserrat', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55676, '2020-03-18', 'MS', 'Montserrat', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55677, '2020-03-19', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55678, '2020-03-20', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55679, '2020-03-21', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55680, '2020-03-22', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55681, '2020-03-23', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55682, '2020-03-24', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55683, '2020-03-25', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55684, '2020-03-26', 'MS', 'Montserrat', 'AMRO', '-3', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55685, '2020-03-27', 'MS', 'Montserrat', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55686, '2020-03-28', 'MS', 'Montserrat', 'AMRO', '3', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55687, '2020-03-29', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55688, '2020-03-30', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55689, '2020-03-31', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55690, '2020-04-01', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55691, '2020-04-02', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55692, '2020-04-03', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55693, '2020-04-04', 'MS', 'Montserrat', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55694, '2020-04-05', 'MS', 'Montserrat', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55695, '2020-04-06', 'MS', 'Montserrat', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55696, '2020-04-07', 'MS', 'Montserrat', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55697, '2020-04-08', 'MS', 'Montserrat', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55698, '2020-04-09', 'MS', 'Montserrat', 'AMRO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55699, '2020-04-10', 'MS', 'Montserrat', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55700, '2020-04-11', 'MS', 'Montserrat', 'AMRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55701, '2020-04-12', 'MS', 'Montserrat', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55702, '2020-04-13', 'MS', 'Montserrat', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55703, '2020-04-14', 'MS', 'Montserrat', 'AMRO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55704, '2020-04-15', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55705, '2020-04-16', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55706, '2020-04-17', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55707, '2020-04-18', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55708, '2020-04-19', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55709, '2020-04-20', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55710, '2020-04-21', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55711, '2020-04-22', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55712, '2020-04-23', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55713, '2020-04-24', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55714, '2020-04-25', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (55715, '2020-04-26', 'MS', 'Montserrat', 'AMRO', '0', '11', '1', '1');
INSERT INTO public.who_global_data_import VALUES (55716, '2020-04-27', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55717, '2020-04-28', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55718, '2020-04-29', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55719, '2020-04-30', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55720, '2020-05-01', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55721, '2020-05-02', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55722, '2020-05-03', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55723, '2020-05-04', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55724, '2020-05-05', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55725, '2020-05-06', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55726, '2020-05-07', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55727, '2020-05-08', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55728, '2020-05-09', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55729, '2020-05-10', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55730, '2020-05-11', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55731, '2020-05-12', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55732, '2020-05-13', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55733, '2020-05-14', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55734, '2020-05-15', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55735, '2020-05-16', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55736, '2020-05-17', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55737, '2020-05-18', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55738, '2020-05-19', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55739, '2020-05-20', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55740, '2020-05-21', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55741, '2020-05-22', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55742, '2020-05-23', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55743, '2020-05-24', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55744, '2020-05-25', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55745, '2020-05-26', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55746, '2020-05-27', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55747, '2020-05-28', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55748, '2020-05-29', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55749, '2020-05-30', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55750, '2020-05-31', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55751, '2020-06-01', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55752, '2020-06-02', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55753, '2020-06-03', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55754, '2020-06-04', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55755, '2020-06-05', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55756, '2020-06-06', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55757, '2020-06-07', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55758, '2020-06-08', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55759, '2020-06-09', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55760, '2020-06-10', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55761, '2020-06-11', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55762, '2020-06-12', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55763, '2020-06-13', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55764, '2020-06-14', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55765, '2020-06-15', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55766, '2020-06-16', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55767, '2020-06-17', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55768, '2020-06-18', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55769, '2020-06-19', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55770, '2020-06-20', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55771, '2020-06-21', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55772, '2020-06-22', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55773, '2020-06-23', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55774, '2020-06-24', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55775, '2020-06-25', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55776, '2020-06-26', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55777, '2020-06-27', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55778, '2020-06-28', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55779, '2020-06-29', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55780, '2020-06-30', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55781, '2020-07-01', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55782, '2020-07-02', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55783, '2020-07-03', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55784, '2020-07-04', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55785, '2020-07-05', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55786, '2020-07-06', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55787, '2020-07-07', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55788, '2020-07-08', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55789, '2020-07-09', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55790, '2020-07-10', 'MS', 'Montserrat', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55791, '2020-07-11', 'MS', 'Montserrat', 'AMRO', '1', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55792, '2020-07-12', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55793, '2020-07-13', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55794, '2020-07-14', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55795, '2020-07-15', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55796, '2020-07-16', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55797, '2020-07-17', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55798, '2020-07-18', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55799, '2020-07-19', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55800, '2020-07-20', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55801, '2020-07-21', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55802, '2020-07-22', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55803, '2020-07-23', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55804, '2020-07-24', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55805, '2020-07-25', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55806, '2020-07-26', 'MS', 'Montserrat', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55807, '2020-07-27', 'MS', 'Montserrat', 'AMRO', '1', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55808, '2020-07-28', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55809, '2020-07-29', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55810, '2020-07-30', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55811, '2020-07-31', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55812, '2020-08-01', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55813, '2020-08-02', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55814, '2020-08-03', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55815, '2020-08-04', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55816, '2020-08-05', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55817, '2020-08-06', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55818, '2020-08-07', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55819, '2020-08-08', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55820, '2020-08-09', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55821, '2020-08-10', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55822, '2020-08-11', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55823, '2020-08-12', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55824, '2020-08-13', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55825, '2020-08-14', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55826, '2020-08-15', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55827, '2020-08-16', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55828, '2020-08-17', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55829, '2020-08-18', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55830, '2020-08-19', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55831, '2020-08-20', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55832, '2020-08-21', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55833, '2020-08-22', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55834, '2020-08-23', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55835, '2020-08-24', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55836, '2020-08-25', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55837, '2020-08-26', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55838, '2020-08-27', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55839, '2020-08-28', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55840, '2020-08-29', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55841, '2020-08-30', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55842, '2020-08-31', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55843, '2020-09-01', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55844, '2020-09-02', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55845, '2020-09-03', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55846, '2020-09-04', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55847, '2020-09-05', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55848, '2020-09-06', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55849, '2020-09-07', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55850, '2020-09-08', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55851, '2020-09-09', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55852, '2020-09-10', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55853, '2020-09-11', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55854, '2020-09-12', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55855, '2020-09-13', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55856, '2020-09-14', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55857, '2020-09-15', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55858, '2020-09-16', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55859, '2020-09-17', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55860, '2020-09-18', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55861, '2020-09-19', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55862, '2020-09-20', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55863, '2020-09-21', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55864, '2020-09-22', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55865, '2020-09-23', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55866, '2020-09-24', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55867, '2020-09-25', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55868, '2020-09-26', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55869, '2020-09-27', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55870, '2020-09-28', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55871, '2020-09-29', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55872, '2020-09-30', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55873, '2020-10-01', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55874, '2020-10-02', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55875, '2020-10-03', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55876, '2020-10-04', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55877, '2020-10-05', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55878, '2020-10-06', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55879, '2020-10-07', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55880, '2020-10-08', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55881, '2020-10-09', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55882, '2020-10-10', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55883, '2020-10-11', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55884, '2020-10-12', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55885, '2020-10-13', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55886, '2020-10-14', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55887, '2020-10-15', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55888, '2020-10-16', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55889, '2020-10-17', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55890, '2020-10-18', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55891, '2020-10-19', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55892, '2020-10-20', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55893, '2020-10-21', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55894, '2020-10-22', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55895, '2020-10-23', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55896, '2020-10-24', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55897, '2020-10-25', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55898, '2020-10-26', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55899, '2020-10-27', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55900, '2020-10-28', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55901, '2020-10-29', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55902, '2020-10-30', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55903, '2020-10-31', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55904, '2020-11-01', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55905, '2020-11-02', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55906, '2020-11-03', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55907, '2020-11-04', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55908, '2020-11-05', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55909, '2020-11-06', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55910, '2020-11-07', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55911, '2020-11-08', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55912, '2020-11-09', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55913, '2020-11-10', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55914, '2020-11-11', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55915, '2020-11-12', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55916, '2020-11-13', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55917, '2020-11-14', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55918, '2020-11-15', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55919, '2020-11-16', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55920, '2020-11-17', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55921, '2020-11-18', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55922, '2020-11-19', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55923, '2020-11-20', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55924, '2020-11-21', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55925, '2020-11-22', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55926, '2020-11-23', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55927, '2020-11-24', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55928, '2020-11-25', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55929, '2020-11-26', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55930, '2020-11-27', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55931, '2020-11-28', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55932, '2020-11-29', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55933, '2020-11-30', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55934, '2020-12-01', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55935, '2020-12-02', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55936, '2020-12-03', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55937, '2020-12-04', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55938, '2020-12-05', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55939, '2020-12-06', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55940, '2020-12-07', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55941, '2020-12-08', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55942, '2020-12-09', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55943, '2020-12-10', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55944, '2020-12-11', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55945, '2020-12-12', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55946, '2020-12-13', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55947, '2020-12-14', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55948, '2020-12-15', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55949, '2020-12-16', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55950, '2020-12-17', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55951, '2020-12-18', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55952, '2020-12-19', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55953, '2020-12-20', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55954, '2020-12-21', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55955, '2020-12-22', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55956, '2020-12-23', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55957, '2020-12-24', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55958, '2020-12-25', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55959, '2020-12-26', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55960, '2020-12-27', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55961, '2020-12-28', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55962, '2020-12-29', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55963, '2020-12-30', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55964, '2020-12-31', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55965, '2021-01-01', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55966, '2021-01-02', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55967, '2021-01-03', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55968, '2021-01-04', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55969, '2021-01-05', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55970, '2021-01-06', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55971, '2021-01-07', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55972, '2021-01-08', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55973, '2021-01-09', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55974, '2021-01-10', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55975, '2021-01-11', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55976, '2021-01-12', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55977, '2021-01-13', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55978, '2021-01-14', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55979, '2021-01-15', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55980, '2021-01-16', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55981, '2021-01-17', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55982, '2021-01-18', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55983, '2021-01-19', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55984, '2021-01-20', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55985, '2021-01-21', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55986, '2021-01-22', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55987, '2021-01-23', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55988, '2021-01-24', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55989, '2021-01-25', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55990, '2021-01-26', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55991, '2021-01-27', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55992, '2021-01-28', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55993, '2021-01-29', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55994, '2021-01-30', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55995, '2021-01-31', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55996, '2021-02-01', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55997, '2021-02-02', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55998, '2021-02-03', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (55999, '2021-02-04', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56000, '2021-02-05', 'MS', 'Montserrat', 'AMRO', '0', '13', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56001, '2020-01-03', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56002, '2020-01-04', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56003, '2020-01-05', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56004, '2020-01-06', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56005, '2020-01-07', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56006, '2020-01-08', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56007, '2020-01-09', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56008, '2020-01-10', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56009, '2020-01-11', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56010, '2020-01-12', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56011, '2020-01-13', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56012, '2020-01-14', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56013, '2020-01-15', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56014, '2020-01-16', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56015, '2020-01-17', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56016, '2020-01-18', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56017, '2020-01-19', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56018, '2020-01-20', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56019, '2020-01-21', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56020, '2020-01-22', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56021, '2020-01-23', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56022, '2020-01-24', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56023, '2020-01-25', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56024, '2020-01-26', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56025, '2020-01-27', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56026, '2020-01-28', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56027, '2020-01-29', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56028, '2020-01-30', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56029, '2020-01-31', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56030, '2020-02-01', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56031, '2020-02-02', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56032, '2020-02-03', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56033, '2020-02-04', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56034, '2020-02-05', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56035, '2020-02-06', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56036, '2020-02-07', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56037, '2020-02-08', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56038, '2020-02-09', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56039, '2020-02-10', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56040, '2020-02-11', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56041, '2020-02-12', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56042, '2020-02-13', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56043, '2020-02-14', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56044, '2020-02-15', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56045, '2020-02-16', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56046, '2020-02-17', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56047, '2020-02-18', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56048, '2020-02-19', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56049, '2020-02-20', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56050, '2020-02-21', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56051, '2020-02-22', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56052, '2020-02-23', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56053, '2020-02-24', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56054, '2020-02-25', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56055, '2020-02-26', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56056, '2020-02-27', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56057, '2020-02-28', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56058, '2020-02-29', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56059, '2020-03-01', 'MA', 'Morocco', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56060, '2020-03-02', 'MA', 'Morocco', 'EMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56061, '2020-03-03', 'MA', 'Morocco', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56062, '2020-03-04', 'MA', 'Morocco', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56063, '2020-03-05', 'MA', 'Morocco', 'EMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56065, '2020-03-07', 'MA', 'Morocco', 'EMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56066, '2020-03-08', 'MA', 'Morocco', 'EMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56067, '2020-03-09', 'MA', 'Morocco', 'EMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56068, '2020-03-10', 'MA', 'Morocco', 'EMRO', '1', '7', '1', '1');
INSERT INTO public.who_global_data_import VALUES (56069, '2020-03-11', 'MA', 'Morocco', 'EMRO', '2', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56070, '2020-03-12', 'MA', 'Morocco', 'EMRO', '1', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56071, '2020-03-13', 'MA', 'Morocco', 'EMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56072, '2020-03-14', 'MA', 'Morocco', 'EMRO', '12', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56073, '2020-03-15', 'MA', 'Morocco', 'EMRO', '10', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56074, '2020-03-16', 'MA', 'Morocco', 'EMRO', '1', '33', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56075, '2020-03-17', 'MA', 'Morocco', 'EMRO', '9', '42', '1', '2');
INSERT INTO public.who_global_data_import VALUES (56076, '2020-03-18', 'MA', 'Morocco', 'EMRO', '11', '53', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56077, '2020-03-19', 'MA', 'Morocco', 'EMRO', '12', '65', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56078, '2020-03-20', 'MA', 'Morocco', 'EMRO', '9', '74', '1', '3');
INSERT INTO public.who_global_data_import VALUES (56079, '2020-03-21', 'MA', 'Morocco', 'EMRO', '12', '86', '0', '3');
INSERT INTO public.who_global_data_import VALUES (56080, '2020-03-22', 'MA', 'Morocco', 'EMRO', '23', '109', '0', '3');
INSERT INTO public.who_global_data_import VALUES (56081, '2020-03-23', 'MA', 'Morocco', 'EMRO', '25', '134', '1', '4');
INSERT INTO public.who_global_data_import VALUES (56082, '2020-03-24', 'MA', 'Morocco', 'EMRO', '9', '143', '0', '4');
INSERT INTO public.who_global_data_import VALUES (56083, '2020-03-25', 'MA', 'Morocco', 'EMRO', '27', '170', '1', '5');
INSERT INTO public.who_global_data_import VALUES (56084, '2020-03-26', 'MA', 'Morocco', 'EMRO', '55', '225', '1', '6');
INSERT INTO public.who_global_data_import VALUES (56085, '2020-03-27', 'MA', 'Morocco', 'EMRO', '50', '275', '4', '10');
INSERT INTO public.who_global_data_import VALUES (56086, '2020-03-28', 'MA', 'Morocco', 'EMRO', '83', '358', '13', '23');
INSERT INTO public.who_global_data_import VALUES (56087, '2020-03-29', 'MA', 'Morocco', 'EMRO', '92', '450', '3', '26');
INSERT INTO public.who_global_data_import VALUES (56088, '2020-03-30', 'MA', 'Morocco', 'EMRO', '66', '516', '3', '29');
INSERT INTO public.who_global_data_import VALUES (56089, '2020-03-31', 'MA', 'Morocco', 'EMRO', '58', '574', '4', '33');
INSERT INTO public.who_global_data_import VALUES (56090, '2020-04-01', 'MA', 'Morocco', 'EMRO', '64', '638', '4', '37');
INSERT INTO public.who_global_data_import VALUES (56091, '2020-04-02', 'MA', 'Morocco', 'EMRO', '38', '676', '3', '40');
INSERT INTO public.who_global_data_import VALUES (56092, '2020-04-03', 'MA', 'Morocco', 'EMRO', '59', '735', '7', '47');
INSERT INTO public.who_global_data_import VALUES (56093, '2020-04-04', 'MA', 'Morocco', 'EMRO', '123', '858', '3', '50');
INSERT INTO public.who_global_data_import VALUES (56094, '2020-04-05', 'MA', 'Morocco', 'EMRO', '102', '960', '16', '66');
INSERT INTO public.who_global_data_import VALUES (56095, '2020-04-06', 'MA', 'Morocco', 'EMRO', '153', '1113', '5', '71');
INSERT INTO public.who_global_data_import VALUES (56096, '2020-04-07', 'MA', 'Morocco', 'EMRO', '28', '1141', '12', '83');
INSERT INTO public.who_global_data_import VALUES (56097, '2020-04-08', 'MA', 'Morocco', 'EMRO', '101', '1242', '8', '91');
INSERT INTO public.who_global_data_import VALUES (56098, '2020-04-09', 'MA', 'Morocco', 'EMRO', '104', '1346', '5', '96');
INSERT INTO public.who_global_data_import VALUES (56099, '2020-04-10', 'MA', 'Morocco', 'EMRO', '85', '1431', '9', '105');
INSERT INTO public.who_global_data_import VALUES (56100, '2020-04-11', 'MA', 'Morocco', 'EMRO', '96', '1527', '5', '110');
INSERT INTO public.who_global_data_import VALUES (56101, '2020-04-12', 'MA', 'Morocco', 'EMRO', '90', '1617', '3', '113');
INSERT INTO public.who_global_data_import VALUES (56102, '2020-04-13', 'MA', 'Morocco', 'EMRO', '129', '1746', '7', '120');
INSERT INTO public.who_global_data_import VALUES (56103, '2020-04-14', 'MA', 'Morocco', 'EMRO', '92', '1838', '6', '126');
INSERT INTO public.who_global_data_import VALUES (56104, '2020-04-15', 'MA', 'Morocco', 'EMRO', '150', '1988', '1', '127');
INSERT INTO public.who_global_data_import VALUES (56105, '2020-04-16', 'MA', 'Morocco', 'EMRO', '263', '2251', '1', '128');
INSERT INTO public.who_global_data_import VALUES (56106, '2020-04-17', 'MA', 'Morocco', 'EMRO', '277', '2528', '5', '133');
INSERT INTO public.who_global_data_import VALUES (56107, '2020-04-18', 'MA', 'Morocco', 'EMRO', '142', '2670', '4', '137');
INSERT INTO public.who_global_data_import VALUES (56108, '2020-04-19', 'MA', 'Morocco', 'EMRO', '150', '2820', '1', '138');
INSERT INTO public.who_global_data_import VALUES (56109, '2020-04-20', 'MA', 'Morocco', 'EMRO', '170', '2990', '5', '143');
INSERT INTO public.who_global_data_import VALUES (56110, '2020-04-21', 'MA', 'Morocco', 'EMRO', '196', '3186', '1', '144');
INSERT INTO public.who_global_data_import VALUES (56111, '2020-04-22', 'MA', 'Morocco', 'EMRO', '191', '3377', '5', '149');
INSERT INTO public.who_global_data_import VALUES (56112, '2020-04-23', 'MA', 'Morocco', 'EMRO', '160', '3537', '2', '151');
INSERT INTO public.who_global_data_import VALUES (56113, '2020-04-24', 'MA', 'Morocco', 'EMRO', '155', '3692', '4', '155');
INSERT INTO public.who_global_data_import VALUES (56114, '2020-04-25', 'MA', 'Morocco', 'EMRO', '197', '3889', '4', '159');
INSERT INTO public.who_global_data_import VALUES (56115, '2020-04-26', 'MA', 'Morocco', 'EMRO', '158', '4047', '1', '160');
INSERT INTO public.who_global_data_import VALUES (56116, '2020-04-27', 'MA', 'Morocco', 'EMRO', '68', '4115', '1', '161');
INSERT INTO public.who_global_data_import VALUES (56117, '2020-04-28', 'MA', 'Morocco', 'EMRO', '131', '4246', '2', '163');
INSERT INTO public.who_global_data_import VALUES (56118, '2020-04-29', 'MA', 'Morocco', 'EMRO', '43', '4289', '4', '167');
INSERT INTO public.who_global_data_import VALUES (56119, '2020-04-30', 'MA', 'Morocco', 'EMRO', '70', '4359', '1', '168');
INSERT INTO public.who_global_data_import VALUES (56120, '2020-05-01', 'MA', 'Morocco', 'EMRO', '170', '4529', '3', '171');
INSERT INTO public.who_global_data_import VALUES (56121, '2020-05-02', 'MA', 'Morocco', 'EMRO', '158', '4687', '1', '172');
INSERT INTO public.who_global_data_import VALUES (56122, '2020-05-03', 'MA', 'Morocco', 'EMRO', '193', '4880', '2', '174');
INSERT INTO public.who_global_data_import VALUES (56123, '2020-05-04', 'MA', 'Morocco', 'EMRO', '120', '5000', '3', '177');
INSERT INTO public.who_global_data_import VALUES (56124, '2020-05-05', 'MA', 'Morocco', 'EMRO', '153', '5153', '3', '180');
INSERT INTO public.who_global_data_import VALUES (56125, '2020-05-06', 'MA', 'Morocco', 'EMRO', '229', '5382', '2', '182');
INSERT INTO public.who_global_data_import VALUES (56126, '2020-05-07', 'MA', 'Morocco', 'EMRO', '123', '5505', '1', '183');
INSERT INTO public.who_global_data_import VALUES (56127, '2020-05-08', 'MA', 'Morocco', 'EMRO', '156', '5661', '2', '185');
INSERT INTO public.who_global_data_import VALUES (56128, '2020-05-09', 'MA', 'Morocco', 'EMRO', '212', '5873', '1', '186');
INSERT INTO public.who_global_data_import VALUES (56129, '2020-05-10', 'MA', 'Morocco', 'EMRO', '165', '6038', '2', '188');
INSERT INTO public.who_global_data_import VALUES (56130, '2020-05-11', 'MA', 'Morocco', 'EMRO', '188', '6226', '0', '188');
INSERT INTO public.who_global_data_import VALUES (56131, '2020-05-12', 'MA', 'Morocco', 'EMRO', '154', '6380', '0', '188');
INSERT INTO public.who_global_data_import VALUES (56132, '2020-05-13', 'MA', 'Morocco', 'EMRO', '86', '6466', '0', '188');
INSERT INTO public.who_global_data_import VALUES (56133, '2020-05-14', 'MA', 'Morocco', 'EMRO', '127', '6593', '1', '189');
INSERT INTO public.who_global_data_import VALUES (56134, '2020-05-15', 'MA', 'Morocco', 'EMRO', '30', '6623', '1', '190');
INSERT INTO public.who_global_data_import VALUES (56135, '2020-05-16', 'MA', 'Morocco', 'EMRO', '58', '6681', '2', '192');
INSERT INTO public.who_global_data_import VALUES (56136, '2020-05-17', 'MA', 'Morocco', 'EMRO', '117', '6798', '0', '192');
INSERT INTO public.who_global_data_import VALUES (56137, '2020-05-18', 'MA', 'Morocco', 'EMRO', '132', '6930', '0', '192');
INSERT INTO public.who_global_data_import VALUES (56138, '2020-05-19', 'MA', 'Morocco', 'EMRO', '42', '6972', '1', '193');
INSERT INTO public.who_global_data_import VALUES (56139, '2020-05-20', 'MA', 'Morocco', 'EMRO', '76', '7048', '1', '194');
INSERT INTO public.who_global_data_import VALUES (56140, '2020-05-21', 'MA', 'Morocco', 'EMRO', '137', '7185', '2', '196');
INSERT INTO public.who_global_data_import VALUES (56141, '2020-05-22', 'MA', 'Morocco', 'EMRO', '26', '7211', '0', '196');
INSERT INTO public.who_global_data_import VALUES (56142, '2020-05-23', 'MA', 'Morocco', 'EMRO', '121', '7332', '1', '197');
INSERT INTO public.who_global_data_import VALUES (56143, '2020-05-24', 'MA', 'Morocco', 'EMRO', '74', '7406', '1', '198');
INSERT INTO public.who_global_data_import VALUES (56144, '2020-05-25', 'MA', 'Morocco', 'EMRO', '27', '7433', '1', '199');
INSERT INTO public.who_global_data_import VALUES (56145, '2020-05-26', 'MA', 'Morocco', 'EMRO', '99', '7532', '1', '200');
INSERT INTO public.who_global_data_import VALUES (56146, '2020-05-27', 'MA', 'Morocco', 'EMRO', '45', '7577', '2', '202');
INSERT INTO public.who_global_data_import VALUES (56147, '2020-05-28', 'MA', 'Morocco', 'EMRO', '24', '7601', '0', '202');
INSERT INTO public.who_global_data_import VALUES (56148, '2020-05-29', 'MA', 'Morocco', 'EMRO', '42', '7643', '0', '202');
INSERT INTO public.who_global_data_import VALUES (56149, '2020-05-30', 'MA', 'Morocco', 'EMRO', '71', '7714', '0', '202');
INSERT INTO public.who_global_data_import VALUES (56150, '2020-05-31', 'MA', 'Morocco', 'EMRO', '66', '7780', '2', '204');
INSERT INTO public.who_global_data_import VALUES (56151, '2020-06-01', 'MA', 'Morocco', 'EMRO', '27', '7807', '1', '205');
INSERT INTO public.who_global_data_import VALUES (56152, '2020-06-02', 'MA', 'Morocco', 'EMRO', '26', '7833', '0', '205');
INSERT INTO public.who_global_data_import VALUES (56153, '2020-06-03', 'MA', 'Morocco', 'EMRO', '33', '7866', '1', '206');
INSERT INTO public.who_global_data_import VALUES (56154, '2020-06-04', 'MA', 'Morocco', 'EMRO', '56', '7922', '0', '206');
INSERT INTO public.who_global_data_import VALUES (56155, '2020-06-05', 'MA', 'Morocco', 'EMRO', '81', '8003', '2', '208');
INSERT INTO public.who_global_data_import VALUES (56156, '2020-06-06', 'MA', 'Morocco', 'EMRO', '68', '8071', '0', '208');
INSERT INTO public.who_global_data_import VALUES (56157, '2020-06-07', 'MA', 'Morocco', 'EMRO', '80', '8151', '0', '208');
INSERT INTO public.who_global_data_import VALUES (56158, '2020-06-08', 'MA', 'Morocco', 'EMRO', '73', '8224', '0', '208');
INSERT INTO public.who_global_data_import VALUES (56159, '2020-06-09', 'MA', 'Morocco', 'EMRO', '78', '8302', '0', '208');
INSERT INTO public.who_global_data_import VALUES (56160, '2020-06-10', 'MA', 'Morocco', 'EMRO', '135', '8437', '2', '210');
INSERT INTO public.who_global_data_import VALUES (56161, '2020-06-11', 'MA', 'Morocco', 'EMRO', '71', '8508', '1', '211');
INSERT INTO public.who_global_data_import VALUES (56162, '2020-06-12', 'MA', 'Morocco', 'EMRO', '29', '8537', '0', '211');
INSERT INTO public.who_global_data_import VALUES (56163, '2020-06-13', 'MA', 'Morocco', 'EMRO', '73', '8610', '1', '212');
INSERT INTO public.who_global_data_import VALUES (56164, '2020-06-14', 'MA', 'Morocco', 'EMRO', '82', '8692', '0', '212');
INSERT INTO public.who_global_data_import VALUES (56165, '2020-06-15', 'MA', 'Morocco', 'EMRO', '101', '8793', '0', '212');
INSERT INTO public.who_global_data_import VALUES (56166, '2020-06-16', 'MA', 'Morocco', 'EMRO', '92', '8885', '0', '212');
INSERT INTO public.who_global_data_import VALUES (56167, '2020-06-17', 'MA', 'Morocco', 'EMRO', '46', '8931', '0', '212');
INSERT INTO public.who_global_data_import VALUES (56168, '2020-06-18', 'MA', 'Morocco', 'EMRO', '66', '8997', '1', '213');
INSERT INTO public.who_global_data_import VALUES (56169, '2020-06-19', 'MA', 'Morocco', 'EMRO', '77', '9074', '0', '213');
INSERT INTO public.who_global_data_import VALUES (56170, '2020-06-20', 'MA', 'Morocco', 'EMRO', '539', '9613', '0', '213');
INSERT INTO public.who_global_data_import VALUES (56171, '2020-06-21', 'MA', 'Morocco', 'EMRO', '226', '9839', '0', '213');
INSERT INTO public.who_global_data_import VALUES (56172, '2020-06-22', 'MA', 'Morocco', 'EMRO', '138', '9977', '1', '214');
INSERT INTO public.who_global_data_import VALUES (56173, '2020-06-23', 'MA', 'Morocco', 'EMRO', '195', '10172', '0', '214');
INSERT INTO public.who_global_data_import VALUES (56174, '2020-06-24', 'MA', 'Morocco', 'EMRO', '172', '10344', '0', '214');
INSERT INTO public.who_global_data_import VALUES (56175, '2020-06-25', 'MA', 'Morocco', 'EMRO', '563', '10907', '2', '216');
INSERT INTO public.who_global_data_import VALUES (56176, '2020-06-26', 'MA', 'Morocco', 'EMRO', '431', '11338', '1', '217');
INSERT INTO public.who_global_data_import VALUES (56177, '2020-06-27', 'MA', 'Morocco', 'EMRO', '295', '11633', '1', '218');
INSERT INTO public.who_global_data_import VALUES (56178, '2020-06-28', 'MA', 'Morocco', 'EMRO', '244', '11877', '2', '220');
INSERT INTO public.who_global_data_import VALUES (56179, '2020-06-29', 'MA', 'Morocco', 'EMRO', '175', '12052', '1', '221');
INSERT INTO public.who_global_data_import VALUES (56180, '2020-06-30', 'MA', 'Morocco', 'EMRO', '238', '12290', '4', '225');
INSERT INTO public.who_global_data_import VALUES (56181, '2020-07-01', 'MA', 'Morocco', 'EMRO', '243', '12533', '3', '228');
INSERT INTO public.who_global_data_import VALUES (56182, '2020-07-02', 'MA', 'Morocco', 'EMRO', '103', '12636', '0', '228');
INSERT INTO public.who_global_data_import VALUES (56183, '2020-07-03', 'MA', 'Morocco', 'EMRO', '333', '12969', '1', '229');
INSERT INTO public.who_global_data_import VALUES (56184, '2020-07-04', 'MA', 'Morocco', 'EMRO', '319', '13288', '1', '230');
INSERT INTO public.who_global_data_import VALUES (56185, '2020-07-05', 'MA', 'Morocco', 'EMRO', '534', '13822', '2', '232');
INSERT INTO public.who_global_data_import VALUES (56186, '2020-07-06', 'MA', 'Morocco', 'EMRO', '393', '14215', '3', '235');
INSERT INTO public.who_global_data_import VALUES (56187, '2020-07-07', 'MA', 'Morocco', 'EMRO', '164', '14379', '2', '237');
INSERT INTO public.who_global_data_import VALUES (56188, '2020-07-08', 'MA', 'Morocco', 'EMRO', '228', '14607', '3', '240');
INSERT INTO public.who_global_data_import VALUES (56189, '2020-07-09', 'MA', 'Morocco', 'EMRO', '164', '14771', '2', '242');
INSERT INTO public.who_global_data_import VALUES (56190, '2020-07-10', 'MA', 'Morocco', 'EMRO', '308', '15079', '0', '242');
INSERT INTO public.who_global_data_import VALUES (56191, '2020-07-11', 'MA', 'Morocco', 'EMRO', '249', '15328', '1', '243');
INSERT INTO public.who_global_data_import VALUES (56192, '2020-07-12', 'MA', 'Morocco', 'EMRO', '214', '15542', '2', '245');
INSERT INTO public.who_global_data_import VALUES (56193, '2020-07-13', 'MA', 'Morocco', 'EMRO', '203', '15745', '5', '250');
INSERT INTO public.who_global_data_import VALUES (56194, '2020-07-14', 'MA', 'Morocco', 'EMRO', '191', '15936', '5', '255');
INSERT INTO public.who_global_data_import VALUES (56195, '2020-07-15', 'MA', 'Morocco', 'EMRO', '161', '16097', '2', '257');
INSERT INTO public.who_global_data_import VALUES (56196, '2020-07-16', 'MA', 'Morocco', 'EMRO', '165', '16262', '2', '259');
INSERT INTO public.who_global_data_import VALUES (56197, '2020-07-17', 'MA', 'Morocco', 'EMRO', '283', '16545', '4', '263');
INSERT INTO public.who_global_data_import VALUES (56198, '2020-07-18', 'MA', 'Morocco', 'EMRO', '181', '16726', '1', '264');
INSERT INTO public.who_global_data_import VALUES (56199, '2020-07-19', 'MA', 'Morocco', 'EMRO', '289', '17015', '5', '269');
INSERT INTO public.who_global_data_import VALUES (56200, '2020-07-20', 'MA', 'Morocco', 'EMRO', '221', '17236', '4', '273');
INSERT INTO public.who_global_data_import VALUES (56201, '2020-07-21', 'MA', 'Morocco', 'EMRO', '326', '17562', '3', '276');
INSERT INTO public.who_global_data_import VALUES (56202, '2020-07-22', 'MA', 'Morocco', 'EMRO', '180', '17742', '4', '280');
INSERT INTO public.who_global_data_import VALUES (56203, '2020-07-23', 'MA', 'Morocco', 'EMRO', '220', '17962', '5', '285');
INSERT INTO public.who_global_data_import VALUES (56204, '2020-07-24', 'MA', 'Morocco', 'EMRO', '302', '18264', '7', '292');
INSERT INTO public.who_global_data_import VALUES (56205, '2020-07-25', 'MA', 'Morocco', 'EMRO', '570', '18834', '7', '299');
INSERT INTO public.who_global_data_import VALUES (56206, '2020-07-26', 'MA', 'Morocco', 'EMRO', '811', '19645', '6', '305');
INSERT INTO public.who_global_data_import VALUES (56207, '2020-07-27', 'MA', 'Morocco', 'EMRO', '633', '20278', '8', '313');
INSERT INTO public.who_global_data_import VALUES (56208, '2020-07-28', 'MA', 'Morocco', 'EMRO', '609', '20887', '3', '316');
INSERT INTO public.who_global_data_import VALUES (56209, '2020-07-29', 'MA', 'Morocco', 'EMRO', '500', '21387', '11', '327');
INSERT INTO public.who_global_data_import VALUES (56210, '2020-07-30', 'MA', 'Morocco', 'EMRO', '826', '22213', '7', '334');
INSERT INTO public.who_global_data_import VALUES (56211, '2020-07-31', 'MA', 'Morocco', 'EMRO', '1046', '23259', '12', '346');
INSERT INTO public.who_global_data_import VALUES (56212, '2020-08-01', 'MA', 'Morocco', 'EMRO', '1063', '24322', '7', '353');
INSERT INTO public.who_global_data_import VALUES (56213, '2020-08-02', 'MA', 'Morocco', 'EMRO', '729', '25051', '14', '367');
INSERT INTO public.who_global_data_import VALUES (56214, '2020-08-03', 'MA', 'Morocco', 'EMRO', '486', '25537', '15', '382');
INSERT INTO public.who_global_data_import VALUES (56215, '2020-08-04', 'MA', 'Morocco', 'EMRO', '659', '26196', '19', '401');
INSERT INTO public.who_global_data_import VALUES (56216, '2020-08-05', 'MA', 'Morocco', 'EMRO', '1021', '27217', '16', '417');
INSERT INTO public.who_global_data_import VALUES (56217, '2020-08-06', 'MA', 'Morocco', 'EMRO', '1283', '28500', '18', '435');
INSERT INTO public.who_global_data_import VALUES (56218, '2020-08-07', 'MA', 'Morocco', 'EMRO', '1144', '29644', '14', '449');
INSERT INTO public.who_global_data_import VALUES (56219, '2020-08-08', 'MA', 'Morocco', 'EMRO', '1018', '30662', '12', '461');
INSERT INTO public.who_global_data_import VALUES (56220, '2020-08-09', 'MA', 'Morocco', 'EMRO', '1345', '32007', '19', '480');
INSERT INTO public.who_global_data_import VALUES (56221, '2020-08-10', 'MA', 'Morocco', 'EMRO', '1230', '33237', '18', '498');
INSERT INTO public.who_global_data_import VALUES (56222, '2020-08-11', 'MA', 'Morocco', 'EMRO', '826', '34063', '18', '516');
INSERT INTO public.who_global_data_import VALUES (56223, '2020-08-12', 'MA', 'Morocco', 'EMRO', '1132', '35195', '17', '533');
INSERT INTO public.who_global_data_import VALUES (56224, '2020-08-13', 'MA', 'Morocco', 'EMRO', '1499', '36694', '23', '556');
INSERT INTO public.who_global_data_import VALUES (56225, '2020-08-14', 'MA', 'Morocco', 'EMRO', '1241', '37935', '28', '584');
INSERT INTO public.who_global_data_import VALUES (56226, '2020-08-15', 'MA', 'Morocco', 'EMRO', '1306', '39241', '27', '611');
INSERT INTO public.who_global_data_import VALUES (56227, '2020-08-16', 'MA', 'Morocco', 'EMRO', '1776', '41017', '21', '632');
INSERT INTO public.who_global_data_import VALUES (56228, '2020-08-17', 'MA', 'Morocco', 'EMRO', '1472', '42489', '26', '658');
INSERT INTO public.who_global_data_import VALUES (56229, '2020-08-18', 'MA', 'Morocco', 'EMRO', '1069', '43558', '23', '681');
INSERT INTO public.who_global_data_import VALUES (56230, '2020-08-19', 'MA', 'Morocco', 'EMRO', '1245', '44803', '33', '714');
INSERT INTO public.who_global_data_import VALUES (56231, '2020-08-20', 'MA', 'Morocco', 'EMRO', '1510', '46313', '29', '743');
INSERT INTO public.who_global_data_import VALUES (56232, '2020-08-21', 'MA', 'Morocco', 'EMRO', '1325', '47638', '32', '775');
INSERT INTO public.who_global_data_import VALUES (56233, '2020-08-22', 'MA', 'Morocco', 'EMRO', '1609', '49247', '42', '817');
INSERT INTO public.who_global_data_import VALUES (56234, '2020-08-23', 'MA', 'Morocco', 'EMRO', '1565', '50812', '41', '858');
INSERT INTO public.who_global_data_import VALUES (56235, '2020-08-24', 'MA', 'Morocco', 'EMRO', '1537', '52349', '30', '888');
INSERT INTO public.who_global_data_import VALUES (56236, '2020-08-25', 'MA', 'Morocco', 'EMRO', '903', '53252', '32', '920');
INSERT INTO public.who_global_data_import VALUES (56237, '2020-08-26', 'MA', 'Morocco', 'EMRO', '1276', '54528', '35', '955');
INSERT INTO public.who_global_data_import VALUES (56238, '2020-08-27', 'MA', 'Morocco', 'EMRO', '1336', '55864', '29', '984');
INSERT INTO public.who_global_data_import VALUES (56239, '2020-08-28', 'MA', 'Morocco', 'EMRO', '1221', '57085', '27', '1011');
INSERT INTO public.who_global_data_import VALUES (56240, '2020-08-29', 'MA', 'Morocco', 'EMRO', '1404', '58489', '41', '1052');
INSERT INTO public.who_global_data_import VALUES (56241, '2020-08-30', 'MA', 'Morocco', 'EMRO', '1567', '60056', '26', '1078');
INSERT INTO public.who_global_data_import VALUES (56242, '2020-08-31', 'MA', 'Morocco', 'EMRO', '1343', '61399', '33', '1111');
INSERT INTO public.who_global_data_import VALUES (56243, '2020-09-01', 'MA', 'Morocco', 'EMRO', '1191', '62590', '30', '1141');
INSERT INTO public.who_global_data_import VALUES (56244, '2020-09-02', 'MA', 'Morocco', 'EMRO', '1191', '63781', '43', '1184');
INSERT INTO public.who_global_data_import VALUES (56245, '2020-09-03', 'MA', 'Morocco', 'EMRO', '1672', '65453', '32', '1216');
INSERT INTO public.who_global_data_import VALUES (56246, '2020-09-04', 'MA', 'Morocco', 'EMRO', '1402', '66855', '37', '1253');
INSERT INTO public.who_global_data_import VALUES (56247, '2020-09-05', 'MA', 'Morocco', 'EMRO', '1750', '68605', '39', '1292');
INSERT INTO public.who_global_data_import VALUES (56248, '2020-09-06', 'MA', 'Morocco', 'EMRO', '1555', '70160', '37', '1329');
INSERT INTO public.who_global_data_import VALUES (56249, '2020-09-07', 'MA', 'Morocco', 'EMRO', '2234', '72394', '32', '1361');
INSERT INTO public.who_global_data_import VALUES (56250, '2020-09-08', 'MA', 'Morocco', 'EMRO', '1386', '73780', '33', '1394');
INSERT INTO public.who_global_data_import VALUES (56251, '2020-09-09', 'MA', 'Morocco', 'EMRO', '1941', '75721', '33', '1427');
INSERT INTO public.who_global_data_import VALUES (56252, '2020-09-10', 'MA', 'Morocco', 'EMRO', '2157', '77878', '26', '1453');
INSERT INTO public.who_global_data_import VALUES (56253, '2020-09-11', 'MA', 'Morocco', 'EMRO', '1889', '79767', '38', '1491');
INSERT INTO public.who_global_data_import VALUES (56254, '2020-09-12', 'MA', 'Morocco', 'EMRO', '2430', '82197', '33', '1524');
INSERT INTO public.who_global_data_import VALUES (56255, '2020-09-13', 'MA', 'Morocco', 'EMRO', '2238', '84435', '29', '1553');
INSERT INTO public.who_global_data_import VALUES (56256, '2020-09-14', 'MA', 'Morocco', 'EMRO', '2251', '86686', '25', '1578');
INSERT INTO public.who_global_data_import VALUES (56257, '2020-09-15', 'MA', 'Morocco', 'EMRO', '1517', '88203', '36', '1614');
INSERT INTO public.who_global_data_import VALUES (56258, '2020-09-16', 'MA', 'Morocco', 'EMRO', '2121', '90324', '34', '1648');
INSERT INTO public.who_global_data_import VALUES (56259, '2020-09-17', 'MA', 'Morocco', 'EMRO', '1692', '92016', '38', '1686');
INSERT INTO public.who_global_data_import VALUES (56260, '2020-09-18', 'MA', 'Morocco', 'EMRO', '2488', '94504', '28', '1714');
INSERT INTO public.who_global_data_import VALUES (56261, '2020-09-19', 'MA', 'Morocco', 'EMRO', '2760', '97264', '41', '1755');
INSERT INTO public.who_global_data_import VALUES (56262, '2020-09-20', 'MA', 'Morocco', 'EMRO', '2552', '99816', '40', '1795');
INSERT INTO public.who_global_data_import VALUES (56263, '2020-09-21', 'MA', 'Morocco', 'EMRO', '1927', '101743', '35', '1830');
INSERT INTO public.who_global_data_import VALUES (56264, '2020-09-22', 'MA', 'Morocco', 'EMRO', '1376', '103119', '25', '1855');
INSERT INTO public.who_global_data_import VALUES (56265, '2020-09-23', 'MA', 'Morocco', 'EMRO', '2227', '105346', '34', '1889');
INSERT INTO public.who_global_data_import VALUES (56266, '2020-09-24', 'MA', 'Morocco', 'EMRO', '2397', '107743', '29', '1918');
INSERT INTO public.who_global_data_import VALUES (56267, '2020-09-25', 'MA', 'Morocco', 'EMRO', '2356', '110099', '38', '1956');
INSERT INTO public.who_global_data_import VALUES (56268, '2020-09-26', 'MA', 'Morocco', 'EMRO', '2423', '112522', '42', '1998');
INSERT INTO public.who_global_data_import VALUES (56269, '2020-09-27', 'MA', 'Morocco', 'EMRO', '2719', '115241', '43', '2041');
INSERT INTO public.who_global_data_import VALUES (56270, '2020-09-28', 'MA', 'Morocco', 'EMRO', '2444', '117685', '28', '2069');
INSERT INTO public.who_global_data_import VALUES (56271, '2020-09-29', 'MA', 'Morocco', 'EMRO', '1422', '119107', '44', '2113');
INSERT INTO public.who_global_data_import VALUES (56272, '2020-09-30', 'MA', 'Morocco', 'EMRO', '2076', '121183', '39', '2152');
INSERT INTO public.who_global_data_import VALUES (56273, '2020-10-01', 'MA', 'Morocco', 'EMRO', '2470', '123653', '42', '2194');
INSERT INTO public.who_global_data_import VALUES (56274, '2020-10-02', 'MA', 'Morocco', 'EMRO', '2391', '126044', '35', '2229');
INSERT INTO public.who_global_data_import VALUES (56275, '2020-10-03', 'MA', 'Morocco', 'EMRO', '2521', '128565', '34', '2263');
INSERT INTO public.who_global_data_import VALUES (56276, '2020-10-04', 'MA', 'Morocco', 'EMRO', '2663', '131228', '30', '2293');
INSERT INTO public.who_global_data_import VALUES (56277, '2020-10-05', 'MA', 'Morocco', 'EMRO', '2044', '133272', '37', '2330');
INSERT INTO public.who_global_data_import VALUES (56278, '2020-10-06', 'MA', 'Morocco', 'EMRO', '1423', '134695', '39', '2369');
INSERT INTO public.who_global_data_import VALUES (56279, '2020-10-07', 'MA', 'Morocco', 'EMRO', '2553', '137248', '41', '2410');
INSERT INTO public.who_global_data_import VALUES (56280, '2020-10-08', 'MA', 'Morocco', 'EMRO', '2776', '140024', '29', '2439');
INSERT INTO public.who_global_data_import VALUES (56281, '2020-10-09', 'MA', 'Morocco', 'EMRO', '2929', '142953', '47', '2486');
INSERT INTO public.who_global_data_import VALUES (56282, '2020-10-10', 'MA', 'Morocco', 'EMRO', '3445', '146398', '44', '2530');
INSERT INTO public.who_global_data_import VALUES (56283, '2020-10-11', 'MA', 'Morocco', 'EMRO', '3443', '149841', '42', '2572');
INSERT INTO public.who_global_data_import VALUES (56284, '2020-10-12', 'MA', 'Morocco', 'EMRO', '2563', '152404', '33', '2605');
INSERT INTO public.who_global_data_import VALUES (56285, '2020-10-13', 'MA', 'Morocco', 'EMRO', '1357', '153761', '31', '2636');
INSERT INTO public.who_global_data_import VALUES (56286, '2020-10-14', 'MA', 'Morocco', 'EMRO', '3185', '156946', '49', '2685');
INSERT INTO public.who_global_data_import VALUES (56287, '2020-10-15', 'MA', 'Morocco', 'EMRO', '3387', '160333', '41', '2726');
INSERT INTO public.who_global_data_import VALUES (56288, '2020-10-16', 'MA', 'Morocco', 'EMRO', '3317', '163650', '46', '2772');
INSERT INTO public.who_global_data_import VALUES (56289, '2020-10-17', 'MA', 'Morocco', 'EMRO', '3498', '167148', '46', '2818');
INSERT INTO public.who_global_data_import VALUES (56290, '2020-10-18', 'MA', 'Morocco', 'EMRO', '3763', '170911', '60', '2878');
INSERT INTO public.who_global_data_import VALUES (56291, '2020-10-19', 'MA', 'Morocco', 'EMRO', '2721', '173632', '50', '2928');
INSERT INTO public.who_global_data_import VALUES (56292, '2020-10-20', 'MA', 'Morocco', 'EMRO', '2117', '175749', '48', '2976');
INSERT INTO public.who_global_data_import VALUES (56293, '2020-10-21', 'MA', 'Morocco', 'EMRO', '3254', '179003', '51', '3027');
INSERT INTO public.who_global_data_import VALUES (56294, '2020-10-22', 'MA', 'Morocco', 'EMRO', '3577', '182580', '70', '3097');
INSERT INTO public.who_global_data_import VALUES (56295, '2020-10-23', 'MA', 'Morocco', 'EMRO', '4151', '186731', '35', '3132');
INSERT INTO public.who_global_data_import VALUES (56296, '2020-10-24', 'MA', 'Morocco', 'EMRO', '3685', '190416', '73', '3205');
INSERT INTO public.who_global_data_import VALUES (56297, '2020-10-25', 'MA', 'Morocco', 'EMRO', '4045', '194461', '50', '3255');
INSERT INTO public.who_global_data_import VALUES (56298, '2020-10-26', 'MA', 'Morocco', 'EMRO', '3020', '197481', '46', '3301');
INSERT INTO public.who_global_data_import VALUES (56299, '2020-10-27', 'MA', 'Morocco', 'EMRO', '2264', '199745', '72', '3373');
INSERT INTO public.who_global_data_import VALUES (56300, '2020-10-28', 'MA', 'Morocco', 'EMRO', '3988', '203733', '72', '3445');
INSERT INTO public.who_global_data_import VALUES (56301, '2020-10-29', 'MA', 'Morocco', 'EMRO', '3985', '207718', '61', '3506');
INSERT INTO public.who_global_data_import VALUES (56302, '2020-10-30', 'MA', 'Morocco', 'EMRO', '4320', '212038', '66', '3572');
INSERT INTO public.who_global_data_import VALUES (56303, '2020-10-31', 'MA', 'Morocco', 'EMRO', '3256', '215294', '53', '3625');
INSERT INTO public.who_global_data_import VALUES (56304, '2020-11-01', 'MA', 'Morocco', 'EMRO', '3790', '219084', '70', '3695');
INSERT INTO public.who_global_data_import VALUES (56305, '2020-11-02', 'MA', 'Morocco', 'EMRO', '3460', '222544', '67', '3762');
INSERT INTO public.who_global_data_import VALUES (56306, '2020-11-03', 'MA', 'Morocco', 'EMRO', '2526', '225070', '64', '3826');
INSERT INTO public.who_global_data_import VALUES (56307, '2020-11-04', 'MA', 'Morocco', 'EMRO', '4495', '229565', '74', '3900');
INSERT INTO public.who_global_data_import VALUES (56308, '2020-11-05', 'MA', 'Morocco', 'EMRO', '5745', '235310', '82', '3982');
INSERT INTO public.who_global_data_import VALUES (56309, '2020-11-06', 'MA', 'Morocco', 'EMRO', '5641', '240951', '77', '4059');
INSERT INTO public.who_global_data_import VALUES (56310, '2020-11-07', 'MA', 'Morocco', 'EMRO', '5398', '246349', '68', '4127');
INSERT INTO public.who_global_data_import VALUES (56311, '2020-11-08', 'MA', 'Morocco', 'EMRO', '5836', '252185', '70', '4197');
INSERT INTO public.who_global_data_import VALUES (56312, '2020-11-09', 'MA', 'Morocco', 'EMRO', '4596', '256781', '75', '4272');
INSERT INTO public.who_global_data_import VALUES (56313, '2020-11-10', 'MA', 'Morocco', 'EMRO', '3170', '259951', '84', '4356');
INSERT INTO public.who_global_data_import VALUES (56314, '2020-11-11', 'MA', 'Morocco', 'EMRO', '5214', '265165', '69', '4425');
INSERT INTO public.who_global_data_import VALUES (56315, '2020-11-12', 'MA', 'Morocco', 'EMRO', '5461', '270626', '81', '4506');
INSERT INTO public.who_global_data_import VALUES (56316, '2020-11-13', 'MA', 'Morocco', 'EMRO', '6195', '276821', '64', '4570');
INSERT INTO public.who_global_data_import VALUES (56317, '2020-11-14', 'MA', 'Morocco', 'EMRO', '5515', '282336', '61', '4631');
INSERT INTO public.who_global_data_import VALUES (56318, '2020-11-15', 'MA', 'Morocco', 'EMRO', '5875', '288211', '66', '4697');
INSERT INTO public.who_global_data_import VALUES (56319, '2020-11-16', 'MA', 'Morocco', 'EMRO', '4966', '293177', '82', '4779');
INSERT INTO public.who_global_data_import VALUES (56320, '2020-11-17', 'MA', 'Morocco', 'EMRO', '3012', '296189', '71', '4850');
INSERT INTO public.who_global_data_import VALUES (56321, '2020-11-18', 'MA', 'Morocco', 'EMRO', '5415', '301604', '82', '4932');
INSERT INTO public.who_global_data_import VALUES (56322, '2020-11-19', 'MA', 'Morocco', 'EMRO', '5391', '306995', '81', '5013');
INSERT INTO public.who_global_data_import VALUES (56323, '2020-11-20', 'MA', 'Morocco', 'EMRO', '4559', '311554', '77', '5090');
INSERT INTO public.who_global_data_import VALUES (56324, '2020-11-21', 'MA', 'Morocco', 'EMRO', '4706', '316260', '92', '5182');
INSERT INTO public.who_global_data_import VALUES (56325, '2020-11-22', 'MA', 'Morocco', 'EMRO', '4702', '320962', '74', '5256');
INSERT INTO public.who_global_data_import VALUES (56326, '2020-11-23', 'MA', 'Morocco', 'EMRO', '3979', '324941', '60', '5316');
INSERT INTO public.who_global_data_import VALUES (56327, '2020-11-24', 'MA', 'Morocco', 'EMRO', '2587', '327528', '80', '5396');
INSERT INTO public.who_global_data_import VALUES (56328, '2020-11-25', 'MA', 'Morocco', 'EMRO', '3999', '331527', '100', '5496');
INSERT INTO public.who_global_data_import VALUES (56329, '2020-11-26', 'MA', 'Morocco', 'EMRO', '4979', '336506', '43', '5539');
INSERT INTO public.who_global_data_import VALUES (56330, '2020-11-27', 'MA', 'Morocco', 'EMRO', '4178', '340684', '80', '5619');
INSERT INTO public.who_global_data_import VALUES (56331, '2020-11-28', 'MA', 'Morocco', 'EMRO', '4592', '345276', '70', '5689');
INSERT INTO public.who_global_data_import VALUES (56332, '2020-11-29', 'MA', 'Morocco', 'EMRO', '4412', '349688', '50', '5739');
INSERT INTO public.who_global_data_import VALUES (56333, '2020-11-30', 'MA', 'Morocco', 'EMRO', '4115', '353803', '50', '5789');
INSERT INTO public.who_global_data_import VALUES (56334, '2020-12-01', 'MA', 'Morocco', 'EMRO', '2532', '356335', '57', '5846');
INSERT INTO public.who_global_data_import VALUES (56335, '2020-12-02', 'MA', 'Morocco', 'EMRO', '3509', '359844', '69', '5915');
INSERT INTO public.who_global_data_import VALUES (56336, '2020-12-03', 'MA', 'Morocco', 'EMRO', '4346', '364190', '70', '5985');
INSERT INTO public.who_global_data_import VALUES (56337, '2020-12-04', 'MA', 'Morocco', 'EMRO', '4434', '368624', '78', '6063');
INSERT INTO public.who_global_data_import VALUES (56338, '2020-12-05', 'MA', 'Morocco', 'EMRO', '3996', '372620', '73', '6136');
INSERT INTO public.who_global_data_import VALUES (56339, '2020-12-06', 'MA', 'Morocco', 'EMRO', '4118', '376738', '48', '6184');
INSERT INTO public.who_global_data_import VALUES (56340, '2020-12-07', 'MA', 'Morocco', 'EMRO', '2919', '379657', '61', '6245');
INSERT INTO public.who_global_data_import VALUES (56341, '2020-12-08', 'MA', 'Morocco', 'EMRO', '1531', '381188', '75', '6320');
INSERT INTO public.who_global_data_import VALUES (56342, '2020-12-09', 'MA', 'Morocco', 'EMRO', '2900', '384088', '50', '6370');
INSERT INTO public.who_global_data_import VALUES (56343, '2020-12-10', 'MA', 'Morocco', 'EMRO', '4096', '388184', '57', '6427');
INSERT INTO public.who_global_data_import VALUES (56344, '2020-12-11', 'MA', 'Morocco', 'EMRO', '3345', '391529', '65', '6492');
INSERT INTO public.who_global_data_import VALUES (56345, '2020-12-12', 'MA', 'Morocco', 'EMRO', '3035', '394564', '50', '6542');
INSERT INTO public.who_global_data_import VALUES (56346, '2020-12-13', 'MA', 'Morocco', 'EMRO', '3033', '397597', '47', '6589');
INSERT INTO public.who_global_data_import VALUES (56347, '2020-12-14', 'MA', 'Morocco', 'EMRO', '2012', '399609', '35', '6624');
INSERT INTO public.who_global_data_import VALUES (56348, '2020-12-15', 'MA', 'Morocco', 'EMRO', '1217', '400826', '35', '6659');
INSERT INTO public.who_global_data_import VALUES (56349, '2020-12-16', 'MA', 'Morocco', 'EMRO', '2793', '403619', '52', '6711');
INSERT INTO public.who_global_data_import VALUES (56350, '2020-12-17', 'MA', 'Morocco', 'EMRO', '3351', '406970', '38', '6749');
INSERT INTO public.who_global_data_import VALUES (56351, '2020-12-18', 'MA', 'Morocco', 'EMRO', '2776', '409746', '55', '6804');
INSERT INTO public.who_global_data_import VALUES (56352, '2020-12-19', 'MA', 'Morocco', 'EMRO', '2647', '412393', '50', '6854');
INSERT INTO public.who_global_data_import VALUES (56353, '2020-12-20', 'MA', 'Morocco', 'EMRO', '2833', '415226', '55', '6909');
INSERT INTO public.who_global_data_import VALUES (56354, '2020-12-21', 'MA', 'Morocco', 'EMRO', '1899', '417125', '48', '6957');
INSERT INTO public.who_global_data_import VALUES (56355, '2020-12-22', 'MA', 'Morocco', 'EMRO', '877', '418002', '43', '7000');
INSERT INTO public.who_global_data_import VALUES (56356, '2020-12-23', 'MA', 'Morocco', 'EMRO', '2646', '420648', '30', '7030');
INSERT INTO public.who_global_data_import VALUES (56357, '2020-12-24', 'MA', 'Morocco', 'EMRO', '2566', '423214', '56', '7086');
INSERT INTO public.who_global_data_import VALUES (56358, '2020-12-25', 'MA', 'Morocco', 'EMRO', '2650', '425864', '44', '7130');
INSERT INTO public.who_global_data_import VALUES (56359, '2020-12-26', 'MA', 'Morocco', 'EMRO', '2329', '428193', '40', '7170');
INSERT INTO public.who_global_data_import VALUES (56360, '2020-12-27', 'MA', 'Morocco', 'EMRO', '2369', '430562', '34', '7204');
INSERT INTO public.who_global_data_import VALUES (56361, '2020-12-28', 'MA', 'Morocco', 'EMRO', '1517', '432079', '36', '7240');
INSERT INTO public.who_global_data_import VALUES (56362, '2020-12-29', 'MA', 'Morocco', 'EMRO', '950', '433029', '32', '7272');
INSERT INTO public.who_global_data_import VALUES (56363, '2020-12-30', 'MA', 'Morocco', 'EMRO', '2160', '435189', '42', '7314');
INSERT INTO public.who_global_data_import VALUES (56364, '2020-12-31', 'MA', 'Morocco', 'EMRO', '2143', '437332', '41', '7355');
INSERT INTO public.who_global_data_import VALUES (56365, '2021-01-01', 'MA', 'Morocco', 'EMRO', '1861', '439193', '33', '7388');
INSERT INTO public.who_global_data_import VALUES (56366, '2021-01-02', 'MA', 'Morocco', 'EMRO', '1777', '440970', '37', '7425');
INSERT INTO public.who_global_data_import VALUES (56367, '2021-01-03', 'MA', 'Morocco', 'EMRO', '1171', '442141', '27', '7452');
INSERT INTO public.who_global_data_import VALUES (56368, '2021-01-04', 'MA', 'Morocco', 'EMRO', '1005', '443146', '33', '7485');
INSERT INTO public.who_global_data_import VALUES (56369, '2021-01-05', 'MA', 'Morocco', 'EMRO', '656', '443802', '53', '7538');
INSERT INTO public.who_global_data_import VALUES (56370, '2021-01-06', 'MA', 'Morocco', 'EMRO', '1637', '445439', '43', '7581');
INSERT INTO public.who_global_data_import VALUES (56371, '2021-01-07', 'MA', 'Morocco', 'EMRO', '1642', '447081', '37', '7618');
INSERT INTO public.who_global_data_import VALUES (56372, '2021-01-08', 'MA', 'Morocco', 'EMRO', '1597', '448678', '27', '7645');
INSERT INTO public.who_global_data_import VALUES (56373, '2021-01-09', 'MA', 'Morocco', 'EMRO', '1543', '450221', '40', '7685');
INSERT INTO public.who_global_data_import VALUES (56374, '2021-01-10', 'MA', 'Morocco', 'EMRO', '1416', '451637', '24', '7709');
INSERT INTO public.who_global_data_import VALUES (56375, '2021-01-11', 'MA', 'Morocco', 'EMRO', '895', '452532', '34', '7743');
INSERT INTO public.who_global_data_import VALUES (56376, '2021-01-12', 'MA', 'Morocco', 'EMRO', '456', '452988', '24', '7767');
INSERT INTO public.who_global_data_import VALUES (56377, '2021-01-13', 'MA', 'Morocco', 'EMRO', '801', '453789', '17', '7784');
INSERT INTO public.who_global_data_import VALUES (56378, '2021-01-14', 'MA', 'Morocco', 'EMRO', '1266', '455055', '26', '7810');
INSERT INTO public.who_global_data_import VALUES (56379, '2021-01-15', 'MA', 'Morocco', 'EMRO', '1279', '456334', '44', '7854');
INSERT INTO public.who_global_data_import VALUES (56380, '2021-01-16', 'MA', 'Morocco', 'EMRO', '1291', '457625', '34', '7888');
INSERT INTO public.who_global_data_import VALUES (56381, '2021-01-17', 'MA', 'Morocco', 'EMRO', '1240', '458865', '23', '7911');
INSERT INTO public.who_global_data_import VALUES (56382, '2021-01-18', 'MA', 'Morocco', 'EMRO', '806', '459671', '31', '7942');
INSERT INTO public.who_global_data_import VALUES (56383, '2021-01-19', 'MA', 'Morocco', 'EMRO', '473', '460144', '35', '7977');
INSERT INTO public.who_global_data_import VALUES (56384, '2021-01-20', 'MA', 'Morocco', 'EMRO', '1246', '461390', '34', '8011');
INSERT INTO public.who_global_data_import VALUES (56385, '2021-01-21', 'MA', 'Morocco', 'EMRO', '1152', '462542', '32', '8043');
INSERT INTO public.who_global_data_import VALUES (56386, '2021-01-22', 'MA', 'Morocco', 'EMRO', '1164', '463706', '33', '8076');
INSERT INTO public.who_global_data_import VALUES (56387, '2021-01-23', 'MA', 'Morocco', 'EMRO', '1138', '464844', '29', '8105');
INSERT INTO public.who_global_data_import VALUES (56388, '2021-01-24', 'MA', 'Morocco', 'EMRO', '925', '465769', '23', '8128');
INSERT INTO public.who_global_data_import VALUES (56389, '2021-01-25', 'MA', 'Morocco', 'EMRO', '520', '466289', '22', '8150');
INSERT INTO public.who_global_data_import VALUES (56390, '2021-01-26', 'MA', 'Morocco', 'EMRO', '337', '466626', '22', '8172');
INSERT INTO public.who_global_data_import VALUES (56391, '2021-01-27', 'MA', 'Morocco', 'EMRO', '867', '467493', '15', '8187');
INSERT INTO public.who_global_data_import VALUES (56392, '2021-01-28', 'MA', 'Morocco', 'EMRO', '890', '468383', '20', '8207');
INSERT INTO public.who_global_data_import VALUES (56393, '2021-01-29', 'MA', 'Morocco', 'EMRO', '756', '469139', '17', '8224');
INSERT INTO public.who_global_data_import VALUES (56394, '2021-01-30', 'MA', 'Morocco', 'EMRO', '851', '469990', '22', '8246');
INSERT INTO public.who_global_data_import VALUES (56395, '2021-01-31', 'MA', 'Morocco', 'EMRO', '701', '470691', '13', '8259');
INSERT INTO public.who_global_data_import VALUES (56396, '2021-02-01', 'MA', 'Morocco', 'EMRO', '466', '471157', '16', '8275');
INSERT INTO public.who_global_data_import VALUES (56397, '2021-02-02', 'MA', 'Morocco', 'EMRO', '281', '471438', '12', '8287');
INSERT INTO public.who_global_data_import VALUES (56398, '2021-02-03', 'MA', 'Morocco', 'EMRO', '835', '472273', '22', '8309');
INSERT INTO public.who_global_data_import VALUES (56399, '2021-02-04', 'MA', 'Morocco', 'EMRO', '774', '473047', '14', '8323');
INSERT INTO public.who_global_data_import VALUES (56400, '2021-02-05', 'MA', 'Morocco', 'EMRO', '620', '473667', '28', '8351');
INSERT INTO public.who_global_data_import VALUES (56401, '2020-01-03', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56402, '2020-01-04', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56403, '2020-01-05', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56404, '2020-01-06', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56405, '2020-01-07', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56406, '2020-01-08', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56407, '2020-01-09', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56408, '2020-01-10', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56409, '2020-01-11', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56410, '2020-01-12', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56411, '2020-01-13', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56412, '2020-01-14', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56413, '2020-01-15', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56414, '2020-01-16', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56415, '2020-01-17', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56416, '2020-01-18', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56417, '2020-01-19', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56418, '2020-01-20', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56419, '2020-01-21', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56420, '2020-01-22', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56421, '2020-01-23', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56422, '2020-01-24', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56423, '2020-01-25', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56424, '2020-01-26', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56425, '2020-01-27', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56426, '2020-01-28', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56427, '2020-01-29', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56428, '2020-01-30', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56429, '2020-01-31', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56430, '2020-02-01', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56431, '2020-02-02', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56432, '2020-02-03', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56433, '2020-02-04', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56434, '2020-02-05', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56435, '2020-02-06', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56436, '2020-02-07', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56437, '2020-02-08', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56438, '2020-02-09', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56439, '2020-02-10', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56440, '2020-02-11', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56441, '2020-02-12', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56442, '2020-02-13', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56443, '2020-02-14', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56444, '2020-02-15', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56445, '2020-02-16', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56446, '2020-02-17', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56447, '2020-02-18', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56448, '2020-02-19', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56449, '2020-02-20', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56450, '2020-02-21', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56451, '2020-02-22', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56452, '2020-02-23', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56453, '2020-02-24', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56454, '2020-02-25', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56455, '2020-02-26', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56456, '2020-02-27', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56457, '2020-02-28', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56458, '2020-02-29', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56459, '2020-03-01', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56460, '2020-03-02', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56461, '2020-03-03', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56462, '2020-03-04', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56463, '2020-03-05', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56464, '2020-03-06', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56465, '2020-03-07', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56466, '2020-03-08', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56467, '2020-03-09', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56468, '2020-03-10', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56469, '2020-03-11', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56470, '2020-03-12', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56471, '2020-03-13', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56472, '2020-03-14', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56473, '2020-03-15', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56474, '2020-03-16', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56475, '2020-03-17', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56476, '2020-03-18', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56477, '2020-03-19', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56478, '2020-03-20', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56479, '2020-03-21', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56480, '2020-03-22', 'MZ', 'Mozambique', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56481, '2020-03-23', 'MZ', 'Mozambique', 'AFRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56482, '2020-03-24', 'MZ', 'Mozambique', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56483, '2020-03-25', 'MZ', 'Mozambique', 'AFRO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56484, '2020-03-26', 'MZ', 'Mozambique', 'AFRO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56485, '2020-03-27', 'MZ', 'Mozambique', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56486, '2020-03-28', 'MZ', 'Mozambique', 'AFRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56487, '2020-03-29', 'MZ', 'Mozambique', 'AFRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56488, '2020-03-30', 'MZ', 'Mozambique', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56489, '2020-03-31', 'MZ', 'Mozambique', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56490, '2020-04-01', 'MZ', 'Mozambique', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56491, '2020-04-02', 'MZ', 'Mozambique', 'AFRO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56492, '2020-04-03', 'MZ', 'Mozambique', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56493, '2020-04-04', 'MZ', 'Mozambique', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56494, '2020-04-05', 'MZ', 'Mozambique', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56495, '2020-04-06', 'MZ', 'Mozambique', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56496, '2020-04-07', 'MZ', 'Mozambique', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56497, '2020-04-08', 'MZ', 'Mozambique', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56498, '2020-04-09', 'MZ', 'Mozambique', 'AFRO', '7', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56499, '2020-04-10', 'MZ', 'Mozambique', 'AFRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56500, '2020-04-11', 'MZ', 'Mozambique', 'AFRO', '3', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56501, '2020-04-12', 'MZ', 'Mozambique', 'AFRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56502, '2020-04-13', 'MZ', 'Mozambique', 'AFRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56503, '2020-04-14', 'MZ', 'Mozambique', 'AFRO', '1', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56504, '2020-04-15', 'MZ', 'Mozambique', 'AFRO', '7', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56505, '2020-04-16', 'MZ', 'Mozambique', 'AFRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56506, '2020-04-17', 'MZ', 'Mozambique', 'AFRO', '1', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56507, '2020-04-18', 'MZ', 'Mozambique', 'AFRO', '2', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56508, '2020-04-19', 'MZ', 'Mozambique', 'AFRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56509, '2020-04-20', 'MZ', 'Mozambique', 'AFRO', '4', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56510, '2020-04-21', 'MZ', 'Mozambique', 'AFRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56511, '2020-04-22', 'MZ', 'Mozambique', 'AFRO', '4', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56512, '2020-04-23', 'MZ', 'Mozambique', 'AFRO', '2', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56513, '2020-04-24', 'MZ', 'Mozambique', 'AFRO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56514, '2020-04-25', 'MZ', 'Mozambique', 'AFRO', '24', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56515, '2020-04-26', 'MZ', 'Mozambique', 'AFRO', '5', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56516, '2020-04-27', 'MZ', 'Mozambique', 'AFRO', '6', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56517, '2020-04-28', 'MZ', 'Mozambique', 'AFRO', '0', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56518, '2020-04-29', 'MZ', 'Mozambique', 'AFRO', '0', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56519, '2020-04-30', 'MZ', 'Mozambique', 'AFRO', '0', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56520, '2020-05-01', 'MZ', 'Mozambique', 'AFRO', '0', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56521, '2020-05-02', 'MZ', 'Mozambique', 'AFRO', '3', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56522, '2020-05-03', 'MZ', 'Mozambique', 'AFRO', '0', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56523, '2020-05-04', 'MZ', 'Mozambique', 'AFRO', '1', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56524, '2020-05-05', 'MZ', 'Mozambique', 'AFRO', '0', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56525, '2020-05-06', 'MZ', 'Mozambique', 'AFRO', '0', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56526, '2020-05-07', 'MZ', 'Mozambique', 'AFRO', '1', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56527, '2020-05-08', 'MZ', 'Mozambique', 'AFRO', '0', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56528, '2020-05-09', 'MZ', 'Mozambique', 'AFRO', '1', '82', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56529, '2020-05-10', 'MZ', 'Mozambique', 'AFRO', '5', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56530, '2020-05-11', 'MZ', 'Mozambique', 'AFRO', '4', '91', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56531, '2020-05-12', 'MZ', 'Mozambique', 'AFRO', '12', '103', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56532, '2020-05-13', 'MZ', 'Mozambique', 'AFRO', '1', '104', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56533, '2020-05-14', 'MZ', 'Mozambique', 'AFRO', '3', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56534, '2020-05-15', 'MZ', 'Mozambique', 'AFRO', '8', '115', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56535, '2020-05-16', 'MZ', 'Mozambique', 'AFRO', '4', '119', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56536, '2020-05-17', 'MZ', 'Mozambique', 'AFRO', '10', '129', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56537, '2020-05-18', 'MZ', 'Mozambique', 'AFRO', '8', '137', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56538, '2020-05-19', 'MZ', 'Mozambique', 'AFRO', '8', '145', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56539, '2020-05-20', 'MZ', 'Mozambique', 'AFRO', '1', '146', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56540, '2020-05-21', 'MZ', 'Mozambique', 'AFRO', '10', '156', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56541, '2020-05-22', 'MZ', 'Mozambique', 'AFRO', '6', '162', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56542, '2020-05-23', 'MZ', 'Mozambique', 'AFRO', '2', '164', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56543, '2020-05-24', 'MZ', 'Mozambique', 'AFRO', '4', '168', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56544, '2020-05-25', 'MZ', 'Mozambique', 'AFRO', '26', '194', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56545, '2020-05-26', 'MZ', 'Mozambique', 'AFRO', '15', '209', '1', '1');
INSERT INTO public.who_global_data_import VALUES (56546, '2020-05-27', 'MZ', 'Mozambique', 'AFRO', '4', '213', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56547, '2020-05-28', 'MZ', 'Mozambique', 'AFRO', '14', '227', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56548, '2020-05-29', 'MZ', 'Mozambique', 'AFRO', '6', '233', '1', '2');
INSERT INTO public.who_global_data_import VALUES (56549, '2020-05-30', 'MZ', 'Mozambique', 'AFRO', '1', '234', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56550, '2020-05-31', 'MZ', 'Mozambique', 'AFRO', '10', '244', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56551, '2020-06-01', 'MZ', 'Mozambique', 'AFRO', '10', '254', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56552, '2020-06-02', 'MZ', 'Mozambique', 'AFRO', '0', '254', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56553, '2020-06-03', 'MZ', 'Mozambique', 'AFRO', '53', '307', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56554, '2020-06-04', 'MZ', 'Mozambique', 'AFRO', '9', '316', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56555, '2020-06-05', 'MZ', 'Mozambique', 'AFRO', '36', '352', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56556, '2020-06-06', 'MZ', 'Mozambique', 'AFRO', '0', '352', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56557, '2020-06-07', 'MZ', 'Mozambique', 'AFRO', '57', '409', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56558, '2020-06-08', 'MZ', 'Mozambique', 'AFRO', '15', '424', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56559, '2020-06-09', 'MZ', 'Mozambique', 'AFRO', '9', '433', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56560, '2020-06-10', 'MZ', 'Mozambique', 'AFRO', '20', '453', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56561, '2020-06-11', 'MZ', 'Mozambique', 'AFRO', '19', '472', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56562, '2020-06-12', 'MZ', 'Mozambique', 'AFRO', '17', '489', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56563, '2020-06-13', 'MZ', 'Mozambique', 'AFRO', '20', '509', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56564, '2020-06-14', 'MZ', 'Mozambique', 'AFRO', '44', '553', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56565, '2020-06-15', 'MZ', 'Mozambique', 'AFRO', '30', '583', '0', '2');
INSERT INTO public.who_global_data_import VALUES (56566, '2020-06-16', 'MZ', 'Mozambique', 'AFRO', '26', '609', '1', '3');
INSERT INTO public.who_global_data_import VALUES (56567, '2020-06-17', 'MZ', 'Mozambique', 'AFRO', '29', '638', '1', '4');
INSERT INTO public.who_global_data_import VALUES (56568, '2020-06-18', 'MZ', 'Mozambique', 'AFRO', '13', '651', '0', '4');
INSERT INTO public.who_global_data_import VALUES (56569, '2020-06-19', 'MZ', 'Mozambique', 'AFRO', '11', '662', '0', '4');
INSERT INTO public.who_global_data_import VALUES (56570, '2020-06-20', 'MZ', 'Mozambique', 'AFRO', '6', '668', '0', '4');
INSERT INTO public.who_global_data_import VALUES (56571, '2020-06-21', 'MZ', 'Mozambique', 'AFRO', '20', '688', '0', '4');
INSERT INTO public.who_global_data_import VALUES (56572, '2020-06-22', 'MZ', 'Mozambique', 'AFRO', '45', '733', '1', '5');
INSERT INTO public.who_global_data_import VALUES (56573, '2020-06-23', 'MZ', 'Mozambique', 'AFRO', '4', '737', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56574, '2020-06-24', 'MZ', 'Mozambique', 'AFRO', '20', '757', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56575, '2020-06-25', 'MZ', 'Mozambique', 'AFRO', '5', '762', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56576, '2020-06-26', 'MZ', 'Mozambique', 'AFRO', '26', '788', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56577, '2020-06-27', 'MZ', 'Mozambique', 'AFRO', '0', '788', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56578, '2020-06-28', 'MZ', 'Mozambique', 'AFRO', '51', '839', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56579, '2020-06-29', 'MZ', 'Mozambique', 'AFRO', '20', '859', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56580, '2020-06-30', 'MZ', 'Mozambique', 'AFRO', '24', '883', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56581, '2020-07-01', 'MZ', 'Mozambique', 'AFRO', '6', '889', '1', '6');
INSERT INTO public.who_global_data_import VALUES (56582, '2020-07-02', 'MZ', 'Mozambique', 'AFRO', '14', '903', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56583, '2020-07-03', 'MZ', 'Mozambique', 'AFRO', '15', '918', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56584, '2020-07-04', 'MZ', 'Mozambique', 'AFRO', '21', '939', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56585, '2020-07-05', 'MZ', 'Mozambique', 'AFRO', '30', '969', '1', '7');
INSERT INTO public.who_global_data_import VALUES (56586, '2020-07-06', 'MZ', 'Mozambique', 'AFRO', '18', '987', '1', '8');
INSERT INTO public.who_global_data_import VALUES (56587, '2020-07-07', 'MZ', 'Mozambique', 'AFRO', '25', '1012', '0', '8');
INSERT INTO public.who_global_data_import VALUES (56588, '2020-07-08', 'MZ', 'Mozambique', 'AFRO', '28', '1040', '0', '8');
INSERT INTO public.who_global_data_import VALUES (56589, '2020-07-09', 'MZ', 'Mozambique', 'AFRO', '31', '1071', '0', '8');
INSERT INTO public.who_global_data_import VALUES (56590, '2020-07-10', 'MZ', 'Mozambique', 'AFRO', '21', '1092', '1', '9');
INSERT INTO public.who_global_data_import VALUES (56591, '2020-07-11', 'MZ', 'Mozambique', 'AFRO', '19', '1111', '0', '9');
INSERT INTO public.who_global_data_import VALUES (56592, '2020-07-12', 'MZ', 'Mozambique', 'AFRO', '24', '1135', '0', '9');
INSERT INTO public.who_global_data_import VALUES (56593, '2020-07-13', 'MZ', 'Mozambique', 'AFRO', '22', '1157', '0', '9');
INSERT INTO public.who_global_data_import VALUES (56594, '2020-07-14', 'MZ', 'Mozambique', 'AFRO', '62', '1219', '0', '9');
INSERT INTO public.who_global_data_import VALUES (56595, '2020-07-15', 'MZ', 'Mozambique', 'AFRO', '49', '1268', '0', '9');
INSERT INTO public.who_global_data_import VALUES (56596, '2020-07-16', 'MZ', 'Mozambique', 'AFRO', '62', '1330', '0', '9');
INSERT INTO public.who_global_data_import VALUES (56597, '2020-07-17', 'MZ', 'Mozambique', 'AFRO', '53', '1383', '0', '9');
INSERT INTO public.who_global_data_import VALUES (56598, '2020-07-18', 'MZ', 'Mozambique', 'AFRO', '19', '1402', '0', '9');
INSERT INTO public.who_global_data_import VALUES (56599, '2020-07-19', 'MZ', 'Mozambique', 'AFRO', '33', '1435', '1', '10');
INSERT INTO public.who_global_data_import VALUES (56600, '2020-07-20', 'MZ', 'Mozambique', 'AFRO', '56', '1491', '0', '10');
INSERT INTO public.who_global_data_import VALUES (56601, '2020-07-21', 'MZ', 'Mozambique', 'AFRO', '16', '1507', '1', '11');
INSERT INTO public.who_global_data_import VALUES (56602, '2020-07-22', 'MZ', 'Mozambique', 'AFRO', '29', '1536', '0', '11');
INSERT INTO public.who_global_data_import VALUES (56603, '2020-07-23', 'MZ', 'Mozambique', 'AFRO', '21', '1557', '0', '11');
INSERT INTO public.who_global_data_import VALUES (56604, '2020-07-24', 'MZ', 'Mozambique', 'AFRO', '25', '1582', '0', '11');
INSERT INTO public.who_global_data_import VALUES (56605, '2020-07-25', 'MZ', 'Mozambique', 'AFRO', '8', '1590', '0', '11');
INSERT INTO public.who_global_data_import VALUES (56606, '2020-07-26', 'MZ', 'Mozambique', 'AFRO', '26', '1616', '0', '11');
INSERT INTO public.who_global_data_import VALUES (56607, '2020-07-27', 'MZ', 'Mozambique', 'AFRO', '53', '1669', '0', '11');
INSERT INTO public.who_global_data_import VALUES (56608, '2020-07-28', 'MZ', 'Mozambique', 'AFRO', '32', '1701', '0', '11');
INSERT INTO public.who_global_data_import VALUES (56609, '2020-07-29', 'MZ', 'Mozambique', 'AFRO', '19', '1720', '0', '11');
INSERT INTO public.who_global_data_import VALUES (56610, '2020-07-30', 'MZ', 'Mozambique', 'AFRO', '28', '1748', '0', '11');
INSERT INTO public.who_global_data_import VALUES (56611, '2020-07-31', 'MZ', 'Mozambique', 'AFRO', '60', '1808', '0', '11');
INSERT INTO public.who_global_data_import VALUES (56612, '2020-08-01', 'MZ', 'Mozambique', 'AFRO', '56', '1864', '0', '11');
INSERT INTO public.who_global_data_import VALUES (56613, '2020-08-02', 'MZ', 'Mozambique', 'AFRO', '43', '1907', '1', '12');
INSERT INTO public.who_global_data_import VALUES (56614, '2020-08-03', 'MZ', 'Mozambique', 'AFRO', '39', '1946', '1', '13');
INSERT INTO public.who_global_data_import VALUES (56615, '2020-08-04', 'MZ', 'Mozambique', 'AFRO', '27', '1973', '1', '14');
INSERT INTO public.who_global_data_import VALUES (56616, '2020-08-05', 'MZ', 'Mozambique', 'AFRO', '56', '2029', '1', '15');
INSERT INTO public.who_global_data_import VALUES (56617, '2020-08-06', 'MZ', 'Mozambique', 'AFRO', '50', '2079', '0', '15');
INSERT INTO public.who_global_data_import VALUES (56618, '2020-08-07', 'MZ', 'Mozambique', 'AFRO', '41', '2120', '0', '15');
INSERT INTO public.who_global_data_import VALUES (56619, '2020-08-08', 'MZ', 'Mozambique', 'AFRO', '93', '2213', '0', '15');
INSERT INTO public.who_global_data_import VALUES (56620, '2020-08-09', 'MZ', 'Mozambique', 'AFRO', '28', '2241', '1', '16');
INSERT INTO public.who_global_data_import VALUES (56621, '2020-08-10', 'MZ', 'Mozambique', 'AFRO', '28', '2269', '0', '16');
INSERT INTO public.who_global_data_import VALUES (56622, '2020-08-11', 'MZ', 'Mozambique', 'AFRO', '142', '2411', '0', '16');
INSERT INTO public.who_global_data_import VALUES (56623, '2020-08-12', 'MZ', 'Mozambique', 'AFRO', '70', '2481', '1', '17');
INSERT INTO public.who_global_data_import VALUES (56624, '2020-08-13', 'MZ', 'Mozambique', 'AFRO', '78', '2559', '2', '19');
INSERT INTO public.who_global_data_import VALUES (56625, '2020-08-14', 'MZ', 'Mozambique', 'AFRO', '79', '2638', '0', '19');
INSERT INTO public.who_global_data_import VALUES (56626, '2020-08-15', 'MZ', 'Mozambique', 'AFRO', '70', '2708', '0', '19');
INSERT INTO public.who_global_data_import VALUES (56627, '2020-08-16', 'MZ', 'Mozambique', 'AFRO', '83', '2791', '0', '19');
INSERT INTO public.who_global_data_import VALUES (56628, '2020-08-17', 'MZ', 'Mozambique', 'AFRO', '64', '2855', '0', '19');
INSERT INTO public.who_global_data_import VALUES (56629, '2020-08-18', 'MZ', 'Mozambique', 'AFRO', '59', '2914', '0', '19');
INSERT INTO public.who_global_data_import VALUES (56630, '2020-08-19', 'MZ', 'Mozambique', 'AFRO', '77', '2991', '0', '19');
INSERT INTO public.who_global_data_import VALUES (56631, '2020-08-20', 'MZ', 'Mozambique', 'AFRO', '54', '3045', '0', '19');
INSERT INTO public.who_global_data_import VALUES (56632, '2020-08-21', 'MZ', 'Mozambique', 'AFRO', '70', '3115', '1', '20');
INSERT INTO public.who_global_data_import VALUES (56633, '2020-08-22', 'MZ', 'Mozambique', 'AFRO', '80', '3195', '0', '20');
INSERT INTO public.who_global_data_import VALUES (56634, '2020-08-23', 'MZ', 'Mozambique', 'AFRO', '109', '3304', '0', '20');
INSERT INTO public.who_global_data_import VALUES (56635, '2020-08-24', 'MZ', 'Mozambique', 'AFRO', '91', '3395', '0', '20');
INSERT INTO public.who_global_data_import VALUES (56636, '2020-08-25', 'MZ', 'Mozambique', 'AFRO', '45', '3440', '1', '21');
INSERT INTO public.who_global_data_import VALUES (56637, '2020-08-26', 'MZ', 'Mozambique', 'AFRO', '68', '3508', '0', '21');
INSERT INTO public.who_global_data_import VALUES (56638, '2020-08-27', 'MZ', 'Mozambique', 'AFRO', '82', '3590', '0', '21');
INSERT INTO public.who_global_data_import VALUES (56639, '2020-08-28', 'MZ', 'Mozambique', 'AFRO', '61', '3651', '0', '21');
INSERT INTO public.who_global_data_import VALUES (56640, '2020-08-29', 'MZ', 'Mozambique', 'AFRO', '46', '3697', '0', '21');
INSERT INTO public.who_global_data_import VALUES (56641, '2020-08-30', 'MZ', 'Mozambique', 'AFRO', '63', '3760', '1', '22');
INSERT INTO public.who_global_data_import VALUES (56642, '2020-08-31', 'MZ', 'Mozambique', 'AFRO', '61', '3821', '1', '23');
INSERT INTO public.who_global_data_import VALUES (56643, '2020-09-01', 'MZ', 'Mozambique', 'AFRO', '95', '3916', '0', '23');
INSERT INTO public.who_global_data_import VALUES (56644, '2020-09-02', 'MZ', 'Mozambique', 'AFRO', '123', '4039', '0', '23');
INSERT INTO public.who_global_data_import VALUES (56645, '2020-09-03', 'MZ', 'Mozambique', 'AFRO', '78', '4117', '2', '25');
INSERT INTO public.who_global_data_import VALUES (56646, '2020-09-04', 'MZ', 'Mozambique', 'AFRO', '90', '4207', '1', '26');
INSERT INTO public.who_global_data_import VALUES (56647, '2020-09-05', 'MZ', 'Mozambique', 'AFRO', '58', '4265', '0', '26');
INSERT INTO public.who_global_data_import VALUES (56648, '2020-09-06', 'MZ', 'Mozambique', 'AFRO', '76', '4341', '0', '26');
INSERT INTO public.who_global_data_import VALUES (56649, '2020-09-07', 'MZ', 'Mozambique', 'AFRO', '103', '4444', '1', '27');
INSERT INTO public.who_global_data_import VALUES (56650, '2020-09-08', 'MZ', 'Mozambique', 'AFRO', '113', '4557', '0', '27');
INSERT INTO public.who_global_data_import VALUES (56651, '2020-09-09', 'MZ', 'Mozambique', 'AFRO', '90', '4647', '1', '28');
INSERT INTO public.who_global_data_import VALUES (56652, '2020-09-10', 'MZ', 'Mozambique', 'AFRO', '117', '4764', '0', '28');
INSERT INTO public.who_global_data_import VALUES (56653, '2020-09-11', 'MZ', 'Mozambique', 'AFRO', '68', '4832', '3', '31');
INSERT INTO public.who_global_data_import VALUES (56654, '2020-09-12', 'MZ', 'Mozambique', 'AFRO', '86', '4918', '0', '31');
INSERT INTO public.who_global_data_import VALUES (56655, '2020-09-13', 'MZ', 'Mozambique', 'AFRO', '122', '5040', '4', '35');
INSERT INTO public.who_global_data_import VALUES (56656, '2020-09-14', 'MZ', 'Mozambique', 'AFRO', '229', '5269', '0', '35');
INSERT INTO public.who_global_data_import VALUES (56657, '2020-09-15', 'MZ', 'Mozambique', 'AFRO', '213', '5482', '0', '35');
INSERT INTO public.who_global_data_import VALUES (56658, '2020-09-16', 'MZ', 'Mozambique', 'AFRO', '231', '5713', '2', '37');
INSERT INTO public.who_global_data_import VALUES (56659, '2020-09-17', 'MZ', 'Mozambique', 'AFRO', '281', '5994', '2', '39');
INSERT INTO public.who_global_data_import VALUES (56660, '2020-09-18', 'MZ', 'Mozambique', 'AFRO', '167', '6161', '0', '39');
INSERT INTO public.who_global_data_import VALUES (56661, '2020-09-19', 'MZ', 'Mozambique', 'AFRO', '103', '6264', '1', '40');
INSERT INTO public.who_global_data_import VALUES (56662, '2020-09-20', 'MZ', 'Mozambique', 'AFRO', '273', '6537', '1', '41');
INSERT INTO public.who_global_data_import VALUES (56663, '2020-09-21', 'MZ', 'Mozambique', 'AFRO', '234', '6771', '2', '43');
INSERT INTO public.who_global_data_import VALUES (56664, '2020-09-22', 'MZ', 'Mozambique', 'AFRO', '141', '6912', '1', '44');
INSERT INTO public.who_global_data_import VALUES (56665, '2020-09-23', 'MZ', 'Mozambique', 'AFRO', '202', '7114', '1', '45');
INSERT INTO public.who_global_data_import VALUES (56666, '2020-09-24', 'MZ', 'Mozambique', 'AFRO', '148', '7262', '4', '49');
INSERT INTO public.who_global_data_import VALUES (56667, '2020-09-25', 'MZ', 'Mozambique', 'AFRO', '137', '7399', '2', '51');
INSERT INTO public.who_global_data_import VALUES (56668, '2020-09-26', 'MZ', 'Mozambique', 'AFRO', '190', '7589', '2', '53');
INSERT INTO public.who_global_data_import VALUES (56669, '2020-09-27', 'MZ', 'Mozambique', 'AFRO', '168', '7757', '1', '54');
INSERT INTO public.who_global_data_import VALUES (56670, '2020-09-28', 'MZ', 'Mozambique', 'AFRO', '226', '7983', '4', '58');
INSERT INTO public.who_global_data_import VALUES (56671, '2020-09-29', 'MZ', 'Mozambique', 'AFRO', '305', '8288', '1', '59');
INSERT INTO public.who_global_data_import VALUES (56672, '2020-09-30', 'MZ', 'Mozambique', 'AFRO', '268', '8556', '0', '59');
INSERT INTO public.who_global_data_import VALUES (56673, '2020-10-01', 'MZ', 'Mozambique', 'AFRO', '172', '8728', '2', '61');
INSERT INTO public.who_global_data_import VALUES (56674, '2020-10-02', 'MZ', 'Mozambique', 'AFRO', '160', '8888', '1', '62');
INSERT INTO public.who_global_data_import VALUES (56675, '2020-10-03', 'MZ', 'Mozambique', 'AFRO', '91', '8979', '2', '64');
INSERT INTO public.who_global_data_import VALUES (56676, '2020-10-04', 'MZ', 'Mozambique', 'AFRO', '70', '9049', '0', '64');
INSERT INTO public.who_global_data_import VALUES (56677, '2020-10-05', 'MZ', 'Mozambique', 'AFRO', '147', '9196', '2', '66');
INSERT INTO public.who_global_data_import VALUES (56678, '2020-10-06', 'MZ', 'Mozambique', 'AFRO', '0', '9196', '0', '66');
INSERT INTO public.who_global_data_import VALUES (56679, '2020-10-07', 'MZ', 'Mozambique', 'AFRO', '0', '9196', '0', '66');
INSERT INTO public.who_global_data_import VALUES (56680, '2020-10-08', 'MZ', 'Mozambique', 'AFRO', '298', '9494', '2', '68');
INSERT INTO public.who_global_data_import VALUES (56681, '2020-10-09', 'MZ', 'Mozambique', 'AFRO', '145', '9639', '0', '68');
INSERT INTO public.who_global_data_import VALUES (56682, '2020-10-10', 'MZ', 'Mozambique', 'AFRO', '103', '9742', '1', '69');
INSERT INTO public.who_global_data_import VALUES (56683, '2020-10-11', 'MZ', 'Mozambique', 'AFRO', '102', '9844', '1', '70');
INSERT INTO public.who_global_data_import VALUES (56684, '2020-10-12', 'MZ', 'Mozambique', 'AFRO', '157', '10001', '1', '71');
INSERT INTO public.who_global_data_import VALUES (56685, '2020-10-13', 'MZ', 'Mozambique', 'AFRO', '87', '10088', '1', '72');
INSERT INTO public.who_global_data_import VALUES (56686, '2020-10-14', 'MZ', 'Mozambique', 'AFRO', '170', '10258', '1', '73');
INSERT INTO public.who_global_data_import VALUES (56687, '2020-10-15', 'MZ', 'Mozambique', 'AFRO', '134', '10392', '0', '73');
INSERT INTO public.who_global_data_import VALUES (56688, '2020-10-16', 'MZ', 'Mozambique', 'AFRO', '145', '10537', '0', '73');
INSERT INTO public.who_global_data_import VALUES (56689, '2020-10-17', 'MZ', 'Mozambique', 'AFRO', '75', '10612', '0', '73');
INSERT INTO public.who_global_data_import VALUES (56690, '2020-10-18', 'MZ', 'Mozambique', 'AFRO', '95', '10707', '1', '74');
INSERT INTO public.who_global_data_import VALUES (56691, '2020-10-19', 'MZ', 'Mozambique', 'AFRO', '159', '10866', '1', '75');
INSERT INTO public.who_global_data_import VALUES (56692, '2020-10-20', 'MZ', 'Mozambique', 'AFRO', '214', '11080', '0', '75');
INSERT INTO public.who_global_data_import VALUES (56693, '2020-10-21', 'MZ', 'Mozambique', 'AFRO', '110', '11190', '3', '78');
INSERT INTO public.who_global_data_import VALUES (56694, '2020-10-22', 'MZ', 'Mozambique', 'AFRO', '141', '11331', '1', '79');
INSERT INTO public.who_global_data_import VALUES (56695, '2020-10-23', 'MZ', 'Mozambique', 'AFRO', '228', '11559', '2', '81');
INSERT INTO public.who_global_data_import VALUES (56696, '2020-10-24', 'MZ', 'Mozambique', 'AFRO', '189', '11748', '1', '82');
INSERT INTO public.who_global_data_import VALUES (56697, '2020-10-25', 'MZ', 'Mozambique', 'AFRO', '147', '11895', '3', '85');
INSERT INTO public.who_global_data_import VALUES (56698, '2020-10-26', 'MZ', 'Mozambique', 'AFRO', '91', '11986', '1', '86');
INSERT INTO public.who_global_data_import VALUES (56699, '2020-10-27', 'MZ', 'Mozambique', 'AFRO', '175', '12161', '2', '88');
INSERT INTO public.who_global_data_import VALUES (56700, '2020-10-28', 'MZ', 'Mozambique', 'AFRO', '112', '12273', '1', '89');
INSERT INTO public.who_global_data_import VALUES (56701, '2020-10-29', 'MZ', 'Mozambique', 'AFRO', '142', '12415', '2', '91');
INSERT INTO public.who_global_data_import VALUES (56702, '2020-10-30', 'MZ', 'Mozambique', 'AFRO', '110', '12525', '0', '91');
INSERT INTO public.who_global_data_import VALUES (56703, '2020-10-31', 'MZ', 'Mozambique', 'AFRO', '252', '12777', '0', '91');
INSERT INTO public.who_global_data_import VALUES (56704, '2020-11-01', 'MZ', 'Mozambique', 'AFRO', '92', '12869', '1', '92');
INSERT INTO public.who_global_data_import VALUES (56705, '2020-11-02', 'MZ', 'Mozambique', 'AFRO', '119', '12988', '1', '93');
INSERT INTO public.who_global_data_import VALUES (56706, '2020-11-03', 'MZ', 'Mozambique', 'AFRO', '142', '13130', '1', '94');
INSERT INTO public.who_global_data_import VALUES (56707, '2020-11-04', 'MZ', 'Mozambique', 'AFRO', '72', '13202', '1', '95');
INSERT INTO public.who_global_data_import VALUES (56708, '2020-11-05', 'MZ', 'Mozambique', 'AFRO', '81', '13283', '0', '95');
INSERT INTO public.who_global_data_import VALUES (56709, '2020-11-06', 'MZ', 'Mozambique', 'AFRO', '108', '13391', '2', '97');
INSERT INTO public.who_global_data_import VALUES (56710, '2020-11-07', 'MZ', 'Mozambique', 'AFRO', '94', '13485', '2', '99');
INSERT INTO public.who_global_data_import VALUES (56711, '2020-11-08', 'MZ', 'Mozambique', 'AFRO', '92', '13577', '0', '99');
INSERT INTO public.who_global_data_import VALUES (56712, '2020-11-09', 'MZ', 'Mozambique', 'AFRO', '191', '13768', '0', '99');
INSERT INTO public.who_global_data_import VALUES (56713, '2020-11-10', 'MZ', 'Mozambique', 'AFRO', '55', '13823', '0', '99');
INSERT INTO public.who_global_data_import VALUES (56714, '2020-11-11', 'MZ', 'Mozambique', 'AFRO', '69', '13892', '0', '99');
INSERT INTO public.who_global_data_import VALUES (56715, '2020-11-12', 'MZ', 'Mozambique', 'AFRO', '99', '13991', '5', '104');
INSERT INTO public.who_global_data_import VALUES (56716, '2020-11-13', 'MZ', 'Mozambique', 'AFRO', '103', '14094', '0', '104');
INSERT INTO public.who_global_data_import VALUES (56717, '2020-11-14', 'MZ', 'Mozambique', 'AFRO', '133', '14227', '6', '110');
INSERT INTO public.who_global_data_import VALUES (56718, '2020-11-15', 'MZ', 'Mozambique', 'AFRO', '113', '14340', '0', '110');
INSERT INTO public.who_global_data_import VALUES (56719, '2020-11-16', 'MZ', 'Mozambique', 'AFRO', '108', '14448', '3', '113');
INSERT INTO public.who_global_data_import VALUES (56720, '2020-11-17', 'MZ', 'Mozambique', 'AFRO', '66', '14514', '3', '116');
INSERT INTO public.who_global_data_import VALUES (56721, '2020-11-18', 'MZ', 'Mozambique', 'AFRO', '52', '14566', '2', '118');
INSERT INTO public.who_global_data_import VALUES (56722, '2020-11-19', 'MZ', 'Mozambique', 'AFRO', '63', '14629', '1', '119');
INSERT INTO public.who_global_data_import VALUES (56723, '2020-11-20', 'MZ', 'Mozambique', 'AFRO', '94', '14723', '1', '120');
INSERT INTO public.who_global_data_import VALUES (56724, '2020-11-21', 'MZ', 'Mozambique', 'AFRO', '154', '14877', '1', '121');
INSERT INTO public.who_global_data_import VALUES (56725, '2020-11-22', 'MZ', 'Mozambique', 'AFRO', '104', '14981', '2', '123');
INSERT INTO public.who_global_data_import VALUES (56726, '2020-11-23', 'MZ', 'Mozambique', 'AFRO', '56', '15037', '1', '124');
INSERT INTO public.who_global_data_import VALUES (56727, '2020-11-24', 'MZ', 'Mozambique', 'AFRO', '72', '15109', '2', '126');
INSERT INTO public.who_global_data_import VALUES (56728, '2020-11-25', 'MZ', 'Mozambique', 'AFRO', '122', '15231', '1', '127');
INSERT INTO public.who_global_data_import VALUES (56729, '2020-11-26', 'MZ', 'Mozambique', 'AFRO', '71', '15302', '1', '128');
INSERT INTO public.who_global_data_import VALUES (56730, '2020-11-27', 'MZ', 'Mozambique', 'AFRO', '165', '15467', '0', '128');
INSERT INTO public.who_global_data_import VALUES (56731, '2020-11-28', 'MZ', 'Mozambique', 'AFRO', '39', '15506', '0', '128');
INSERT INTO public.who_global_data_import VALUES (56732, '2020-11-29', 'MZ', 'Mozambique', 'AFRO', '80', '15586', '1', '129');
INSERT INTO public.who_global_data_import VALUES (56733, '2020-11-30', 'MZ', 'Mozambique', 'AFRO', '27', '15613', '1', '130');
INSERT INTO public.who_global_data_import VALUES (56734, '2020-12-01', 'MZ', 'Mozambique', 'AFRO', '88', '15701', '1', '131');
INSERT INTO public.who_global_data_import VALUES (56735, '2020-12-02', 'MZ', 'Mozambique', 'AFRO', '69', '15770', '0', '131');
INSERT INTO public.who_global_data_import VALUES (56736, '2020-12-03', 'MZ', 'Mozambique', 'AFRO', '96', '15866', '1', '132');
INSERT INTO public.who_global_data_import VALUES (56737, '2020-12-04', 'MZ', 'Mozambique', 'AFRO', '52', '15918', '0', '132');
INSERT INTO public.who_global_data_import VALUES (56738, '2020-12-05', 'MZ', 'Mozambique', 'AFRO', '120', '16038', '1', '133');
INSERT INTO public.who_global_data_import VALUES (56739, '2020-12-06', 'MZ', 'Mozambique', 'AFRO', '95', '16133', '0', '133');
INSERT INTO public.who_global_data_import VALUES (56740, '2020-12-07', 'MZ', 'Mozambique', 'AFRO', '111', '16244', '0', '133');
INSERT INTO public.who_global_data_import VALUES (56741, '2020-12-08', 'MZ', 'Mozambique', 'AFRO', '82', '16326', '3', '136');
INSERT INTO public.who_global_data_import VALUES (56742, '2020-12-09', 'MZ', 'Mozambique', 'AFRO', '47', '16373', '0', '136');
INSERT INTO public.who_global_data_import VALUES (56743, '2020-12-10', 'MZ', 'Mozambique', 'AFRO', '67', '16440', '2', '138');
INSERT INTO public.who_global_data_import VALUES (56744, '2020-12-11', 'MZ', 'Mozambique', 'AFRO', '81', '16521', '1', '139');
INSERT INTO public.who_global_data_import VALUES (56745, '2020-12-12', 'MZ', 'Mozambique', 'AFRO', '159', '16680', '0', '139');
INSERT INTO public.who_global_data_import VALUES (56746, '2020-12-13', 'MZ', 'Mozambique', 'AFRO', '132', '16812', '1', '140');
INSERT INTO public.who_global_data_import VALUES (56747, '2020-12-14', 'MZ', 'Mozambique', 'AFRO', '142', '16954', '2', '142');
INSERT INTO public.who_global_data_import VALUES (56748, '2020-12-15', 'MZ', 'Mozambique', 'AFRO', '48', '17002', '1', '143');
INSERT INTO public.who_global_data_import VALUES (56749, '2020-12-16', 'MZ', 'Mozambique', 'AFRO', '40', '17042', '1', '144');
INSERT INTO public.who_global_data_import VALUES (56750, '2020-12-17', 'MZ', 'Mozambique', 'AFRO', '101', '17143', '1', '145');
INSERT INTO public.who_global_data_import VALUES (56751, '2020-12-18', 'MZ', 'Mozambique', 'AFRO', '113', '17256', '0', '145');
INSERT INTO public.who_global_data_import VALUES (56752, '2020-12-19', 'MZ', 'Mozambique', 'AFRO', '0', '17256', '0', '145');
INSERT INTO public.who_global_data_import VALUES (56753, '2020-12-20', 'MZ', 'Mozambique', 'AFRO', '221', '17477', '2', '147');
INSERT INTO public.who_global_data_import VALUES (56754, '2020-12-21', 'MZ', 'Mozambique', 'AFRO', '91', '17568', '1', '148');
INSERT INTO public.who_global_data_import VALUES (56755, '2020-12-22', 'MZ', 'Mozambique', 'AFRO', '127', '17695', '1', '149');
INSERT INTO public.who_global_data_import VALUES (56756, '2020-12-23', 'MZ', 'Mozambique', 'AFRO', '72', '17767', '1', '150');
INSERT INTO public.who_global_data_import VALUES (56757, '2020-12-24', 'MZ', 'Mozambique', 'AFRO', '189', '17956', '3', '153');
INSERT INTO public.who_global_data_import VALUES (56758, '2020-12-25', 'MZ', 'Mozambique', 'AFRO', '75', '18031', '3', '156');
INSERT INTO public.who_global_data_import VALUES (56759, '2020-12-26', 'MZ', 'Mozambique', 'AFRO', '77', '18108', '0', '156');
INSERT INTO public.who_global_data_import VALUES (56760, '2020-12-27', 'MZ', 'Mozambique', 'AFRO', '54', '18162', '3', '159');
INSERT INTO public.who_global_data_import VALUES (56761, '2020-12-28', 'MZ', 'Mozambique', 'AFRO', '103', '18265', '2', '161');
INSERT INTO public.who_global_data_import VALUES (56762, '2020-12-29', 'MZ', 'Mozambique', 'AFRO', '0', '18265', '0', '161');
INSERT INTO public.who_global_data_import VALUES (56763, '2020-12-30', 'MZ', 'Mozambique', 'AFRO', '45', '18310', '1', '162');
INSERT INTO public.who_global_data_import VALUES (56764, '2020-12-31', 'MZ', 'Mozambique', 'AFRO', '63', '18373', '1', '163');
INSERT INTO public.who_global_data_import VALUES (56765, '2021-01-01', 'MZ', 'Mozambique', 'AFRO', '269', '18642', '3', '166');
INSERT INTO public.who_global_data_import VALUES (56766, '2021-01-02', 'MZ', 'Mozambique', 'AFRO', '0', '18642', '0', '166');
INSERT INTO public.who_global_data_import VALUES (56767, '2021-01-03', 'MZ', 'Mozambique', 'AFRO', '326', '18968', '2', '168');
INSERT INTO public.who_global_data_import VALUES (56768, '2021-01-04', 'MZ', 'Mozambique', 'AFRO', '341', '19309', '1', '169');
INSERT INTO public.who_global_data_import VALUES (56769, '2021-01-05', 'MZ', 'Mozambique', 'AFRO', '154', '19463', '2', '171');
INSERT INTO public.who_global_data_import VALUES (56770, '2021-01-06', 'MZ', 'Mozambique', 'AFRO', '0', '19463', '0', '171');
INSERT INTO public.who_global_data_import VALUES (56771, '2021-01-07', 'MZ', 'Mozambique', 'AFRO', '204', '19667', '1', '172');
INSERT INTO public.who_global_data_import VALUES (56772, '2021-01-08', 'MZ', 'Mozambique', 'AFRO', '294', '19961', '4', '176');
INSERT INTO public.who_global_data_import VALUES (56773, '2021-01-09', 'MZ', 'Mozambique', 'AFRO', '521', '20482', '5', '181');
INSERT INTO public.who_global_data_import VALUES (56774, '2021-01-10', 'MZ', 'Mozambique', 'AFRO', '879', '21361', '6', '187');
INSERT INTO public.who_global_data_import VALUES (56775, '2021-01-11', 'MZ', 'Mozambique', 'AFRO', '578', '21939', '5', '192');
INSERT INTO public.who_global_data_import VALUES (56776, '2021-01-12', 'MZ', 'Mozambique', 'AFRO', '395', '22334', '5', '197');
INSERT INTO public.who_global_data_import VALUES (56777, '2021-01-13', 'MZ', 'Mozambique', 'AFRO', '662', '22996', '4', '201');
INSERT INTO public.who_global_data_import VALUES (56778, '2021-01-14', 'MZ', 'Mozambique', 'AFRO', '730', '23726', '4', '205');
INSERT INTO public.who_global_data_import VALUES (56779, '2021-01-15', 'MZ', 'Mozambique', 'AFRO', '543', '24269', '6', '211');
INSERT INTO public.who_global_data_import VALUES (56780, '2021-01-16', 'MZ', 'Mozambique', 'AFRO', '0', '24269', '0', '211');
INSERT INTO public.who_global_data_import VALUES (56781, '2021-01-17', 'MZ', 'Mozambique', 'AFRO', '1593', '25862', '23', '234');
INSERT INTO public.who_global_data_import VALUES (56782, '2021-01-18', 'MZ', 'Mozambique', 'AFRO', '689', '26551', '7', '241');
INSERT INTO public.who_global_data_import VALUES (56783, '2021-01-19', 'MZ', 'Mozambique', 'AFRO', '895', '27446', '8', '249');
INSERT INTO public.who_global_data_import VALUES (56784, '2021-01-20', 'MZ', 'Mozambique', 'AFRO', '824', '28270', '4', '253');
INSERT INTO public.who_global_data_import VALUES (56785, '2021-01-21', 'MZ', 'Mozambique', 'AFRO', '1126', '29396', '18', '271');
INSERT INTO public.who_global_data_import VALUES (56786, '2021-01-22', 'MZ', 'Mozambique', 'AFRO', '829', '30225', '12', '283');
INSERT INTO public.who_global_data_import VALUES (56787, '2021-01-23', 'MZ', 'Mozambique', 'AFRO', '623', '30848', '7', '290');
INSERT INTO public.who_global_data_import VALUES (56788, '2021-01-24', 'MZ', 'Mozambique', 'AFRO', '780', '31628', '7', '297');
INSERT INTO public.who_global_data_import VALUES (56789, '2021-01-25', 'MZ', 'Mozambique', 'AFRO', '790', '32418', '8', '305');
INSERT INTO public.who_global_data_import VALUES (56790, '2021-01-26', 'MZ', 'Mozambique', 'AFRO', '363', '32781', '14', '319');
INSERT INTO public.who_global_data_import VALUES (56791, '2021-01-27', 'MZ', 'Mozambique', 'AFRO', '1274', '34055', '10', '329');
INSERT INTO public.who_global_data_import VALUES (56792, '2021-01-28', 'MZ', 'Mozambique', 'AFRO', '871', '34926', '7', '336');
INSERT INTO public.who_global_data_import VALUES (56793, '2021-01-29', 'MZ', 'Mozambique', 'AFRO', '907', '35833', '11', '347');
INSERT INTO public.who_global_data_import VALUES (56794, '2021-01-30', 'MZ', 'Mozambique', 'AFRO', '1275', '37108', '9', '356');
INSERT INTO public.who_global_data_import VALUES (56795, '2021-01-31', 'MZ', 'Mozambique', 'AFRO', '597', '37705', '7', '363');
INSERT INTO public.who_global_data_import VALUES (56796, '2021-02-01', 'MZ', 'Mozambique', 'AFRO', '949', '38654', '4', '367');
INSERT INTO public.who_global_data_import VALUES (56797, '2021-02-02', 'MZ', 'Mozambique', 'AFRO', '806', '39460', '19', '386');
INSERT INTO public.who_global_data_import VALUES (56798, '2021-02-03', 'MZ', 'Mozambique', 'AFRO', '800', '40260', '17', '403');
INSERT INTO public.who_global_data_import VALUES (56799, '2021-02-04', 'MZ', 'Mozambique', 'AFRO', '1173', '41433', '12', '415');
INSERT INTO public.who_global_data_import VALUES (56800, '2021-02-05', 'MZ', 'Mozambique', 'AFRO', '1055', '42488', '12', '427');
INSERT INTO public.who_global_data_import VALUES (56801, '2020-01-03', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56802, '2020-01-04', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56803, '2020-01-05', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56804, '2020-01-06', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56805, '2020-01-07', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56806, '2020-01-08', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56807, '2020-01-09', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56808, '2020-01-10', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56809, '2020-01-11', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56810, '2020-01-12', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56811, '2020-01-13', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56812, '2020-01-14', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56813, '2020-01-15', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56814, '2020-01-16', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56815, '2020-01-17', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56816, '2020-01-18', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56817, '2020-01-19', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56818, '2020-01-20', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56819, '2020-01-21', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56820, '2020-01-22', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56821, '2020-01-23', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56822, '2020-01-24', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56823, '2020-01-25', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56824, '2020-01-26', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56825, '2020-01-27', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56826, '2020-01-28', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56827, '2020-01-29', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56828, '2020-01-30', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56829, '2020-01-31', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56830, '2020-02-01', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56831, '2020-02-02', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56832, '2020-02-03', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56833, '2020-02-04', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56834, '2020-02-05', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56835, '2020-02-06', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56836, '2020-02-07', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56837, '2020-02-08', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56838, '2020-02-09', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56839, '2020-02-10', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56840, '2020-02-11', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56841, '2020-02-12', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56842, '2020-02-13', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56843, '2020-02-14', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56844, '2020-02-15', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56845, '2020-02-16', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56846, '2020-02-17', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56847, '2020-02-18', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56848, '2020-02-19', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56849, '2020-02-20', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56850, '2020-02-21', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56851, '2020-02-22', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56852, '2020-02-23', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56853, '2020-02-24', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56854, '2020-02-25', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56855, '2020-02-26', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56856, '2020-02-27', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56857, '2020-02-28', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56858, '2020-02-29', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56859, '2020-03-01', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56860, '2020-03-02', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56861, '2020-03-03', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56862, '2020-03-04', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56863, '2020-03-05', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56864, '2020-03-06', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56865, '2020-03-07', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56866, '2020-03-08', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56867, '2020-03-09', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56868, '2020-03-10', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56869, '2020-03-11', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56870, '2020-03-12', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56871, '2020-03-13', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56872, '2020-03-14', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56873, '2020-03-15', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56874, '2020-03-16', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56875, '2020-03-17', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56876, '2020-03-18', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56877, '2020-03-19', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56878, '2020-03-20', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56879, '2020-03-21', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56880, '2020-03-22', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56881, '2020-03-23', 'MM', 'Myanmar', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56882, '2020-03-24', 'MM', 'Myanmar', 'SEARO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56883, '2020-03-25', 'MM', 'Myanmar', 'SEARO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56884, '2020-03-26', 'MM', 'Myanmar', 'SEARO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56885, '2020-03-27', 'MM', 'Myanmar', 'SEARO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56886, '2020-03-28', 'MM', 'Myanmar', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56887, '2020-03-29', 'MM', 'Myanmar', 'SEARO', '3', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56888, '2020-03-30', 'MM', 'Myanmar', 'SEARO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56889, '2020-03-31', 'MM', 'Myanmar', 'SEARO', '4', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (56890, '2020-04-01', 'MM', 'Myanmar', 'SEARO', '1', '15', '1', '1');
INSERT INTO public.who_global_data_import VALUES (56891, '2020-04-02', 'MM', 'Myanmar', 'SEARO', '1', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56892, '2020-04-03', 'MM', 'Myanmar', 'SEARO', '4', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56893, '2020-04-04', 'MM', 'Myanmar', 'SEARO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56894, '2020-04-05', 'MM', 'Myanmar', 'SEARO', '1', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56895, '2020-04-06', 'MM', 'Myanmar', 'SEARO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56896, '2020-04-07', 'MM', 'Myanmar', 'SEARO', '1', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (56897, '2020-04-08', 'MM', 'Myanmar', 'SEARO', '0', '22', '2', '3');
INSERT INTO public.who_global_data_import VALUES (56898, '2020-04-09', 'MM', 'Myanmar', 'SEARO', '0', '22', '0', '3');
INSERT INTO public.who_global_data_import VALUES (56899, '2020-04-10', 'MM', 'Myanmar', 'SEARO', '5', '27', '0', '3');
INSERT INTO public.who_global_data_import VALUES (56900, '2020-04-11', 'MM', 'Myanmar', 'SEARO', '1', '28', '0', '3');
INSERT INTO public.who_global_data_import VALUES (56901, '2020-04-12', 'MM', 'Myanmar', 'SEARO', '10', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (56902, '2020-04-13', 'MM', 'Myanmar', 'SEARO', '3', '41', '1', '4');
INSERT INTO public.who_global_data_import VALUES (56903, '2020-04-14', 'MM', 'Myanmar', 'SEARO', '21', '62', '0', '4');
INSERT INTO public.who_global_data_import VALUES (56904, '2020-04-15', 'MM', 'Myanmar', 'SEARO', '12', '74', '0', '4');
INSERT INTO public.who_global_data_import VALUES (56905, '2020-04-16', 'MM', 'Myanmar', 'SEARO', '11', '85', '0', '4');
INSERT INTO public.who_global_data_import VALUES (56906, '2020-04-17', 'MM', 'Myanmar', 'SEARO', '0', '85', '0', '4');
INSERT INTO public.who_global_data_import VALUES (56907, '2020-04-18', 'MM', 'Myanmar', 'SEARO', '9', '94', '1', '5');
INSERT INTO public.who_global_data_import VALUES (56908, '2020-04-19', 'MM', 'Myanmar', 'SEARO', '13', '107', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56909, '2020-04-20', 'MM', 'Myanmar', 'SEARO', '4', '111', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56910, '2020-04-21', 'MM', 'Myanmar', 'SEARO', '8', '119', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56911, '2020-04-22', 'MM', 'Myanmar', 'SEARO', '2', '121', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56912, '2020-04-23', 'MM', 'Myanmar', 'SEARO', '6', '127', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56913, '2020-04-24', 'MM', 'Myanmar', 'SEARO', '12', '139', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56914, '2020-04-25', 'MM', 'Myanmar', 'SEARO', '5', '144', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56915, '2020-04-26', 'MM', 'Myanmar', 'SEARO', '2', '146', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56916, '2020-04-27', 'MM', 'Myanmar', 'SEARO', '0', '146', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56917, '2020-04-28', 'MM', 'Myanmar', 'SEARO', '0', '146', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56918, '2020-04-29', 'MM', 'Myanmar', 'SEARO', '4', '150', '0', '5');
INSERT INTO public.who_global_data_import VALUES (56919, '2020-04-30', 'MM', 'Myanmar', 'SEARO', '0', '150', '1', '6');
INSERT INTO public.who_global_data_import VALUES (56920, '2020-05-01', 'MM', 'Myanmar', 'SEARO', '1', '151', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56921, '2020-05-02', 'MM', 'Myanmar', 'SEARO', '0', '151', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56922, '2020-05-03', 'MM', 'Myanmar', 'SEARO', '0', '151', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56923, '2020-05-04', 'MM', 'Myanmar', 'SEARO', '4', '155', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56924, '2020-05-05', 'MM', 'Myanmar', 'SEARO', '6', '161', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56925, '2020-05-06', 'MM', 'Myanmar', 'SEARO', '0', '161', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56926, '2020-05-07', 'MM', 'Myanmar', 'SEARO', '1', '162', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56927, '2020-05-08', 'MM', 'Myanmar', 'SEARO', '14', '176', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56928, '2020-05-09', 'MM', 'Myanmar', 'SEARO', '1', '177', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56929, '2020-05-10', 'MM', 'Myanmar', 'SEARO', '1', '178', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56930, '2020-05-11', 'MM', 'Myanmar', 'SEARO', '2', '180', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56931, '2020-05-12', 'MM', 'Myanmar', 'SEARO', '0', '180', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56932, '2020-05-13', 'MM', 'Myanmar', 'SEARO', '0', '180', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56933, '2020-05-14', 'MM', 'Myanmar', 'SEARO', '1', '181', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56934, '2020-05-15', 'MM', 'Myanmar', 'SEARO', '0', '181', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56935, '2020-05-16', 'MM', 'Myanmar', 'SEARO', '1', '182', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56936, '2020-05-17', 'MM', 'Myanmar', 'SEARO', '2', '184', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56937, '2020-05-18', 'MM', 'Myanmar', 'SEARO', '4', '188', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56938, '2020-05-19', 'MM', 'Myanmar', 'SEARO', '3', '191', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56939, '2020-05-20', 'MM', 'Myanmar', 'SEARO', '2', '193', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56940, '2020-05-21', 'MM', 'Myanmar', 'SEARO', '6', '199', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56941, '2020-05-22', 'MM', 'Myanmar', 'SEARO', '0', '199', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56942, '2020-05-23', 'MM', 'Myanmar', 'SEARO', '2', '201', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56943, '2020-05-24', 'MM', 'Myanmar', 'SEARO', '0', '201', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56944, '2020-05-25', 'MM', 'Myanmar', 'SEARO', '0', '201', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56945, '2020-05-26', 'MM', 'Myanmar', 'SEARO', '5', '206', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56946, '2020-05-27', 'MM', 'Myanmar', 'SEARO', '0', '206', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56947, '2020-05-28', 'MM', 'Myanmar', 'SEARO', '0', '206', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56948, '2020-05-29', 'MM', 'Myanmar', 'SEARO', '0', '206', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56949, '2020-05-30', 'MM', 'Myanmar', 'SEARO', '18', '224', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56950, '2020-05-31', 'MM', 'Myanmar', 'SEARO', '0', '224', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56951, '2020-06-01', 'MM', 'Myanmar', 'SEARO', '0', '224', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56952, '2020-06-02', 'MM', 'Myanmar', 'SEARO', '4', '228', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56953, '2020-06-03', 'MM', 'Myanmar', 'SEARO', '5', '233', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56954, '2020-06-04', 'MM', 'Myanmar', 'SEARO', '1', '234', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56955, '2020-06-05', 'MM', 'Myanmar', 'SEARO', '2', '236', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56956, '2020-06-06', 'MM', 'Myanmar', 'SEARO', '0', '236', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56957, '2020-06-07', 'MM', 'Myanmar', 'SEARO', '4', '240', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56958, '2020-06-08', 'MM', 'Myanmar', 'SEARO', '2', '242', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56959, '2020-06-09', 'MM', 'Myanmar', 'SEARO', '2', '244', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56960, '2020-06-10', 'MM', 'Myanmar', 'SEARO', '2', '246', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56961, '2020-06-11', 'MM', 'Myanmar', 'SEARO', '2', '248', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56962, '2020-06-12', 'MM', 'Myanmar', 'SEARO', '13', '261', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56963, '2020-06-13', 'MM', 'Myanmar', 'SEARO', '0', '261', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56964, '2020-06-14', 'MM', 'Myanmar', 'SEARO', '0', '261', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56965, '2020-06-15', 'MM', 'Myanmar', 'SEARO', '1', '262', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56966, '2020-06-16', 'MM', 'Myanmar', 'SEARO', '0', '262', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56967, '2020-06-17', 'MM', 'Myanmar', 'SEARO', '0', '262', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56968, '2020-06-18', 'MM', 'Myanmar', 'SEARO', '1', '263', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56969, '2020-06-19', 'MM', 'Myanmar', 'SEARO', '23', '286', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56970, '2020-06-20', 'MM', 'Myanmar', 'SEARO', '0', '286', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56971, '2020-06-21', 'MM', 'Myanmar', 'SEARO', '0', '286', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56972, '2020-06-22', 'MM', 'Myanmar', 'SEARO', '4', '290', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56973, '2020-06-23', 'MM', 'Myanmar', 'SEARO', '1', '291', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56974, '2020-06-24', 'MM', 'Myanmar', 'SEARO', '1', '292', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56975, '2020-06-25', 'MM', 'Myanmar', 'SEARO', '1', '293', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56976, '2020-06-26', 'MM', 'Myanmar', 'SEARO', '0', '293', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56977, '2020-06-27', 'MM', 'Myanmar', 'SEARO', '0', '293', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56978, '2020-06-28', 'MM', 'Myanmar', 'SEARO', '3', '296', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56979, '2020-06-29', 'MM', 'Myanmar', 'SEARO', '3', '299', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56980, '2020-06-30', 'MM', 'Myanmar', 'SEARO', '0', '299', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56981, '2020-07-01', 'MM', 'Myanmar', 'SEARO', '0', '299', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56982, '2020-07-02', 'MM', 'Myanmar', 'SEARO', '5', '304', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56983, '2020-07-03', 'MM', 'Myanmar', 'SEARO', '0', '304', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56984, '2020-07-04', 'MM', 'Myanmar', 'SEARO', '2', '306', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56985, '2020-07-05', 'MM', 'Myanmar', 'SEARO', '7', '313', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56986, '2020-07-06', 'MM', 'Myanmar', 'SEARO', '0', '313', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56987, '2020-07-07', 'MM', 'Myanmar', 'SEARO', '3', '316', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56988, '2020-07-08', 'MM', 'Myanmar', 'SEARO', '0', '316', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56989, '2020-07-09', 'MM', 'Myanmar', 'SEARO', '2', '318', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56990, '2020-07-10', 'MM', 'Myanmar', 'SEARO', '3', '321', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56991, '2020-07-11', 'MM', 'Myanmar', 'SEARO', '5', '326', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56992, '2020-07-12', 'MM', 'Myanmar', 'SEARO', '4', '330', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56993, '2020-07-13', 'MM', 'Myanmar', 'SEARO', '1', '331', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56994, '2020-07-14', 'MM', 'Myanmar', 'SEARO', '5', '336', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56995, '2020-07-15', 'MM', 'Myanmar', 'SEARO', '1', '337', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56996, '2020-07-16', 'MM', 'Myanmar', 'SEARO', '0', '337', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56997, '2020-07-17', 'MM', 'Myanmar', 'SEARO', '2', '339', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56998, '2020-07-18', 'MM', 'Myanmar', 'SEARO', '0', '339', '0', '6');
INSERT INTO public.who_global_data_import VALUES (56999, '2020-07-19', 'MM', 'Myanmar', 'SEARO', '2', '341', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57000, '2020-07-20', 'MM', 'Myanmar', 'SEARO', '0', '341', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57001, '2020-07-21', 'MM', 'Myanmar', 'SEARO', '0', '341', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57002, '2020-07-22', 'MM', 'Myanmar', 'SEARO', '0', '341', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57003, '2020-07-23', 'MM', 'Myanmar', 'SEARO', '2', '343', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57004, '2020-07-24', 'MM', 'Myanmar', 'SEARO', '0', '343', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57005, '2020-07-25', 'MM', 'Myanmar', 'SEARO', '3', '346', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57006, '2020-07-26', 'MM', 'Myanmar', 'SEARO', '3', '349', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57007, '2020-07-27', 'MM', 'Myanmar', 'SEARO', '1', '350', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57008, '2020-07-28', 'MM', 'Myanmar', 'SEARO', '0', '350', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57009, '2020-07-29', 'MM', 'Myanmar', 'SEARO', '1', '351', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57010, '2020-07-30', 'MM', 'Myanmar', 'SEARO', '2', '353', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57011, '2020-07-31', 'MM', 'Myanmar', 'SEARO', '0', '353', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57012, '2020-08-01', 'MM', 'Myanmar', 'SEARO', '0', '353', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57013, '2020-08-02', 'MM', 'Myanmar', 'SEARO', '0', '353', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57014, '2020-08-03', 'MM', 'Myanmar', 'SEARO', '0', '353', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57015, '2020-08-04', 'MM', 'Myanmar', 'SEARO', '2', '355', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57016, '2020-08-05', 'MM', 'Myanmar', 'SEARO', '1', '356', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57017, '2020-08-06', 'MM', 'Myanmar', 'SEARO', '1', '357', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57018, '2020-08-07', 'MM', 'Myanmar', 'SEARO', '2', '359', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57019, '2020-08-08', 'MM', 'Myanmar', 'SEARO', '0', '359', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57020, '2020-08-09', 'MM', 'Myanmar', 'SEARO', '0', '359', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57021, '2020-08-10', 'MM', 'Myanmar', 'SEARO', '1', '360', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57022, '2020-08-11', 'MM', 'Myanmar', 'SEARO', '0', '360', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57023, '2020-08-12', 'MM', 'Myanmar', 'SEARO', '0', '360', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57024, '2020-08-13', 'MM', 'Myanmar', 'SEARO', '1', '361', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57025, '2020-08-14', 'MM', 'Myanmar', 'SEARO', '0', '361', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57026, '2020-08-15', 'MM', 'Myanmar', 'SEARO', '8', '369', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57027, '2020-08-16', 'MM', 'Myanmar', 'SEARO', '5', '374', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57028, '2020-08-17', 'MM', 'Myanmar', 'SEARO', '1', '375', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57029, '2020-08-18', 'MM', 'Myanmar', 'SEARO', '0', '375', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57030, '2020-08-19', 'MM', 'Myanmar', 'SEARO', '4', '379', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57031, '2020-08-20', 'MM', 'Myanmar', 'SEARO', '17', '396', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57032, '2020-08-21', 'MM', 'Myanmar', 'SEARO', '13', '409', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57033, '2020-08-22', 'MM', 'Myanmar', 'SEARO', '26', '435', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57034, '2020-08-23', 'MM', 'Myanmar', 'SEARO', '9', '444', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57035, '2020-08-24', 'MM', 'Myanmar', 'SEARO', '19', '463', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57036, '2020-08-25', 'MM', 'Myanmar', 'SEARO', '11', '474', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57037, '2020-08-26', 'MM', 'Myanmar', 'SEARO', '30', '504', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57038, '2020-08-27', 'MM', 'Myanmar', 'SEARO', '76', '580', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57039, '2020-08-28', 'MM', 'Myanmar', 'SEARO', '48', '628', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57040, '2020-08-29', 'MM', 'Myanmar', 'SEARO', '28', '656', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57041, '2020-08-30', 'MM', 'Myanmar', 'SEARO', '93', '749', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57042, '2020-08-31', 'MM', 'Myanmar', 'SEARO', '26', '775', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57043, '2020-09-01', 'MM', 'Myanmar', 'SEARO', '112', '887', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57044, '2020-09-02', 'MM', 'Myanmar', 'SEARO', '51', '938', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57045, '2020-09-03', 'MM', 'Myanmar', 'SEARO', '120', '1058', '0', '6');
INSERT INTO public.who_global_data_import VALUES (57046, '2020-09-04', 'MM', 'Myanmar', 'SEARO', '75', '1133', '1', '7');
INSERT INTO public.who_global_data_import VALUES (57047, '2020-09-05', 'MM', 'Myanmar', 'SEARO', '83', '1216', '0', '7');
INSERT INTO public.who_global_data_import VALUES (57048, '2020-09-06', 'MM', 'Myanmar', 'SEARO', '103', '1319', '1', '8');
INSERT INTO public.who_global_data_import VALUES (57049, '2020-09-07', 'MM', 'Myanmar', 'SEARO', '145', '1464', '0', '8');
INSERT INTO public.who_global_data_import VALUES (57050, '2020-09-08', 'MM', 'Myanmar', 'SEARO', '146', '1610', '0', '8');
INSERT INTO public.who_global_data_import VALUES (57051, '2020-09-09', 'MM', 'Myanmar', 'SEARO', '197', '1807', '4', '12');
INSERT INTO public.who_global_data_import VALUES (57052, '2020-09-10', 'MM', 'Myanmar', 'SEARO', '202', '2009', '2', '14');
INSERT INTO public.who_global_data_import VALUES (57053, '2020-09-11', 'MM', 'Myanmar', 'SEARO', '256', '2265', '0', '14');
INSERT INTO public.who_global_data_import VALUES (57054, '2020-09-12', 'MM', 'Myanmar', 'SEARO', '180', '2445', '0', '14');
INSERT INTO public.who_global_data_import VALUES (57055, '2020-09-13', 'MM', 'Myanmar', 'SEARO', '351', '2796', '2', '16');
INSERT INTO public.who_global_data_import VALUES (57056, '2020-09-14', 'MM', 'Myanmar', 'SEARO', '219', '3015', '8', '24');
INSERT INTO public.who_global_data_import VALUES (57057, '2020-09-15', 'MM', 'Myanmar', 'SEARO', '284', '3299', '8', '32');
INSERT INTO public.who_global_data_import VALUES (57058, '2020-09-16', 'MM', 'Myanmar', 'SEARO', '337', '3636', '7', '39');
INSERT INTO public.who_global_data_import VALUES (57059, '2020-09-17', 'MM', 'Myanmar', 'SEARO', '258', '3894', '7', '46');
INSERT INTO public.who_global_data_import VALUES (57060, '2020-09-18', 'MM', 'Myanmar', 'SEARO', '405', '4299', '15', '61');
INSERT INTO public.who_global_data_import VALUES (57061, '2020-09-19', 'MM', 'Myanmar', 'SEARO', '322', '4621', '14', '75');
INSERT INTO public.who_global_data_import VALUES (57062, '2020-09-20', 'MM', 'Myanmar', 'SEARO', '642', '5263', '6', '81');
INSERT INTO public.who_global_data_import VALUES (57063, '2020-09-21', 'MM', 'Myanmar', 'SEARO', '542', '5805', '13', '94');
INSERT INTO public.who_global_data_import VALUES (57064, '2020-09-22', 'MM', 'Myanmar', 'SEARO', '666', '6471', '6', '100');
INSERT INTO public.who_global_data_import VALUES (57065, '2020-09-23', 'MM', 'Myanmar', 'SEARO', '488', '6959', '16', '116');
INSERT INTO public.who_global_data_import VALUES (57066, '2020-09-24', 'MM', 'Myanmar', 'SEARO', '868', '7827', '14', '130');
INSERT INTO public.who_global_data_import VALUES (57067, '2020-09-25', 'MM', 'Myanmar', 'SEARO', '688', '8515', '25', '155');
INSERT INTO public.who_global_data_import VALUES (57068, '2020-09-26', 'MM', 'Myanmar', 'SEARO', '597', '9112', '19', '174');
INSERT INTO public.who_global_data_import VALUES (57069, '2020-09-27', 'MM', 'Myanmar', 'SEARO', '879', '9991', '24', '198');
INSERT INTO public.who_global_data_import VALUES (57070, '2020-09-28', 'MM', 'Myanmar', 'SEARO', '743', '10734', '28', '226');
INSERT INTO public.who_global_data_import VALUES (57071, '2020-09-29', 'MM', 'Myanmar', 'SEARO', '897', '11631', '30', '256');
INSERT INTO public.who_global_data_import VALUES (57072, '2020-09-30', 'MM', 'Myanmar', 'SEARO', '794', '12425', '28', '284');
INSERT INTO public.who_global_data_import VALUES (57073, '2020-10-01', 'MM', 'Myanmar', 'SEARO', '948', '13373', '26', '310');
INSERT INTO public.who_global_data_import VALUES (57074, '2020-10-02', 'MM', 'Myanmar', 'SEARO', '1010', '14383', '11', '321');
INSERT INTO public.who_global_data_import VALUES (57075, '2020-10-03', 'MM', 'Myanmar', 'SEARO', '1142', '15525', '32', '353');
INSERT INTO public.who_global_data_import VALUES (57076, '2020-10-04', 'MM', 'Myanmar', 'SEARO', '978', '16503', '18', '371');
INSERT INTO public.who_global_data_import VALUES (57077, '2020-10-05', 'MM', 'Myanmar', 'SEARO', '1291', '17794', '41', '412');
INSERT INTO public.who_global_data_import VALUES (57078, '2020-10-06', 'MM', 'Myanmar', 'SEARO', '987', '18781', '32', '444');
INSERT INTO public.who_global_data_import VALUES (57079, '2020-10-07', 'MM', 'Myanmar', 'SEARO', '1252', '20033', '27', '471');
INSERT INTO public.who_global_data_import VALUES (57080, '2020-10-08', 'MM', 'Myanmar', 'SEARO', '1400', '21433', '39', '510');
INSERT INTO public.who_global_data_import VALUES (57081, '2020-10-09', 'MM', 'Myanmar', 'SEARO', '1012', '22445', '25', '535');
INSERT INTO public.who_global_data_import VALUES (57082, '2020-10-10', 'MM', 'Myanmar', 'SEARO', '1461', '23906', '31', '566');
INSERT INTO public.who_global_data_import VALUES (57083, '2020-10-11', 'MM', 'Myanmar', 'SEARO', '2158', '26064', '32', '598');
INSERT INTO public.who_global_data_import VALUES (57084, '2020-10-12', 'MM', 'Myanmar', 'SEARO', '1910', '27974', '48', '646');
INSERT INTO public.who_global_data_import VALUES (57085, '2020-10-13', 'MM', 'Myanmar', 'SEARO', '1340', '29314', '18', '664');
INSERT INTO public.who_global_data_import VALUES (57086, '2020-10-14', 'MM', 'Myanmar', 'SEARO', '1123', '30437', '29', '693');
INSERT INTO public.who_global_data_import VALUES (57087, '2020-10-15', 'MM', 'Myanmar', 'SEARO', '888', '31325', '39', '732');
INSERT INTO public.who_global_data_import VALUES (57088, '2020-10-16', 'MM', 'Myanmar', 'SEARO', '1026', '32351', '33', '765');
INSERT INTO public.who_global_data_import VALUES (57089, '2020-10-17', 'MM', 'Myanmar', 'SEARO', '1137', '33488', '34', '799');
INSERT INTO public.who_global_data_import VALUES (57090, '2020-10-18', 'MM', 'Myanmar', 'SEARO', '1387', '34875', '39', '838');
INSERT INTO public.who_global_data_import VALUES (57091, '2020-10-19', 'MM', 'Myanmar', 'SEARO', '1150', '36025', '42', '880');
INSERT INTO public.who_global_data_import VALUES (57092, '2020-10-20', 'MM', 'Myanmar', 'SEARO', '1180', '37205', '34', '914');
INSERT INTO public.who_global_data_import VALUES (57093, '2020-10-21', 'MM', 'Myanmar', 'SEARO', '1297', '38502', '31', '945');
INSERT INTO public.who_global_data_import VALUES (57094, '2020-10-22', 'MM', 'Myanmar', 'SEARO', '1194', '39696', '27', '972');
INSERT INTO public.who_global_data_import VALUES (57095, '2020-10-23', 'MM', 'Myanmar', 'SEARO', '1312', '41008', '33', '1005');
INSERT INTO public.who_global_data_import VALUES (57096, '2020-10-24', 'MM', 'Myanmar', 'SEARO', '1357', '42365', '33', '1038');
INSERT INTO public.who_global_data_import VALUES (57097, '2020-10-25', 'MM', 'Myanmar', 'SEARO', '1423', '43788', '28', '1066');
INSERT INTO public.who_global_data_import VALUES (57098, '2020-10-26', 'MM', 'Myanmar', 'SEARO', '986', '44774', '29', '1095');
INSERT INTO public.who_global_data_import VALUES (57099, '2020-10-27', 'MM', 'Myanmar', 'SEARO', '1426', '46200', '27', '1122');
INSERT INTO public.who_global_data_import VALUES (57100, '2020-10-28', 'MM', 'Myanmar', 'SEARO', '1466', '47666', '25', '1147');
INSERT INTO public.who_global_data_import VALUES (57101, '2020-10-29', 'MM', 'Myanmar', 'SEARO', '1406', '49072', '25', '1172');
INSERT INTO public.who_global_data_import VALUES (57102, '2020-10-30', 'MM', 'Myanmar', 'SEARO', '1331', '50403', '27', '1199');
INSERT INTO public.who_global_data_import VALUES (57103, '2020-10-31', 'MM', 'Myanmar', 'SEARO', '1093', '51496', '20', '1219');
INSERT INTO public.who_global_data_import VALUES (57104, '2020-11-01', 'MM', 'Myanmar', 'SEARO', '1210', '52706', '18', '1237');
INSERT INTO public.who_global_data_import VALUES (57105, '2020-11-02', 'MM', 'Myanmar', 'SEARO', '699', '53405', '21', '1258');
INSERT INTO public.who_global_data_import VALUES (57106, '2020-11-03', 'MM', 'Myanmar', 'SEARO', '1202', '54607', '24', '1282');
INSERT INTO public.who_global_data_import VALUES (57107, '2020-11-04', 'MM', 'Myanmar', 'SEARO', '1197', '55804', '25', '1307');
INSERT INTO public.who_global_data_import VALUES (57108, '2020-11-05', 'MM', 'Myanmar', 'SEARO', '1136', '56940', '23', '1330');
INSERT INTO public.who_global_data_import VALUES (57109, '2020-11-06', 'MM', 'Myanmar', 'SEARO', '995', '57935', '22', '1352');
INSERT INTO public.who_global_data_import VALUES (57110, '2020-11-07', 'MM', 'Myanmar', 'SEARO', '1342', '59277', '24', '1376');
INSERT INTO public.who_global_data_import VALUES (57111, '2020-11-08', 'MM', 'Myanmar', 'SEARO', '1071', '60348', '20', '1396');
INSERT INTO public.who_global_data_import VALUES (57112, '2020-11-09', 'MM', 'Myanmar', 'SEARO', '1029', '61377', '24', '1420');
INSERT INTO public.who_global_data_import VALUES (57113, '2020-11-10', 'MM', 'Myanmar', 'SEARO', '598', '61975', '17', '1437');
INSERT INTO public.who_global_data_import VALUES (57114, '2020-11-11', 'MM', 'Myanmar', 'SEARO', '1266', '63241', '24', '1461');
INSERT INTO public.who_global_data_import VALUES (57115, '2020-11-12', 'MM', 'Myanmar', 'SEARO', '1212', '64453', '19', '1480');
INSERT INTO public.who_global_data_import VALUES (57116, '2020-11-13', 'MM', 'Myanmar', 'SEARO', '0', '64453', '0', '1480');
INSERT INTO public.who_global_data_import VALUES (57117, '2020-11-14', 'MM', 'Myanmar', 'SEARO', '1145', '65598', '28', '1508');
INSERT INTO public.who_global_data_import VALUES (57118, '2020-11-15', 'MM', 'Myanmar', 'SEARO', '1136', '66734', '26', '1534');
INSERT INTO public.who_global_data_import VALUES (57119, '2020-11-16', 'MM', 'Myanmar', 'SEARO', '2260', '68994', '43', '1577');
INSERT INTO public.who_global_data_import VALUES (57120, '2020-11-17', 'MM', 'Myanmar', 'SEARO', '1167', '70161', '22', '1599');
INSERT INTO public.who_global_data_import VALUES (57121, '2020-11-18', 'MM', 'Myanmar', 'SEARO', '1569', '71730', '26', '1625');
INSERT INTO public.who_global_data_import VALUES (57122, '2020-11-19', 'MM', 'Myanmar', 'SEARO', '1592', '73322', '25', '1650');
INSERT INTO public.who_global_data_import VALUES (57123, '2020-11-20', 'MM', 'Myanmar', 'SEARO', '1560', '74882', '26', '1676');
INSERT INTO public.who_global_data_import VALUES (57124, '2020-11-21', 'MM', 'Myanmar', 'SEARO', '1532', '76414', '19', '1695');
INSERT INTO public.who_global_data_import VALUES (57125, '2020-11-22', 'MM', 'Myanmar', 'SEARO', '1434', '77848', '27', '1722');
INSERT INTO public.who_global_data_import VALUES (57126, '2020-11-23', 'MM', 'Myanmar', 'SEARO', '1398', '79246', '17', '1739');
INSERT INTO public.who_global_data_import VALUES (57127, '2020-11-24', 'MM', 'Myanmar', 'SEARO', '1259', '80505', '26', '1765');
INSERT INTO public.who_global_data_import VALUES (57128, '2020-11-25', 'MM', 'Myanmar', 'SEARO', '1731', '82236', '19', '1784');
INSERT INTO public.who_global_data_import VALUES (57129, '2020-11-26', 'MM', 'Myanmar', 'SEARO', '1330', '83566', '26', '1810');
INSERT INTO public.who_global_data_import VALUES (57130, '2020-11-27', 'MM', 'Myanmar', 'SEARO', '1639', '85205', '36', '1846');
INSERT INTO public.who_global_data_import VALUES (57131, '2020-11-28', 'MM', 'Myanmar', 'SEARO', '1428', '86633', '19', '1865');
INSERT INTO public.who_global_data_import VALUES (57132, '2020-11-29', 'MM', 'Myanmar', 'SEARO', '0', '86633', '0', '1865');
INSERT INTO public.who_global_data_import VALUES (57133, '2020-11-30', 'MM', 'Myanmar', 'SEARO', '1344', '87977', '22', '1887');
INSERT INTO public.who_global_data_import VALUES (57134, '2020-12-01', 'MM', 'Myanmar', 'SEARO', '1509', '89486', '31', '1918');
INSERT INTO public.who_global_data_import VALUES (57135, '2020-12-02', 'MM', 'Myanmar', 'SEARO', '1227', '90713', '23', '1941');
INSERT INTO public.who_global_data_import VALUES (57136, '2020-12-03', 'MM', 'Myanmar', 'SEARO', '1476', '92189', '31', '1972');
INSERT INTO public.who_global_data_import VALUES (57137, '2020-12-04', 'MM', 'Myanmar', 'SEARO', '1411', '93600', '26', '1998');
INSERT INTO public.who_global_data_import VALUES (57138, '2020-12-05', 'MM', 'Myanmar', 'SEARO', '1418', '95018', '30', '2028');
INSERT INTO public.who_global_data_import VALUES (57139, '2020-12-06', 'MM', 'Myanmar', 'SEARO', '1502', '96520', '31', '2059');
INSERT INTO public.who_global_data_import VALUES (57140, '2020-12-07', 'MM', 'Myanmar', 'SEARO', '1527', '98047', '22', '2081');
INSERT INTO public.who_global_data_import VALUES (57141, '2020-12-08', 'MM', 'Myanmar', 'SEARO', '1108', '99155', '29', '2110');
INSERT INTO public.who_global_data_import VALUES (57142, '2020-12-09', 'MM', 'Myanmar', 'SEARO', '1276', '100431', '22', '2132');
INSERT INTO public.who_global_data_import VALUES (57143, '2020-12-10', 'MM', 'Myanmar', 'SEARO', '1308', '101739', '19', '2151');
INSERT INTO public.who_global_data_import VALUES (57144, '2020-12-11', 'MM', 'Myanmar', 'SEARO', '1427', '103166', '23', '2174');
INSERT INTO public.who_global_data_import VALUES (57145, '2020-12-12', 'MM', 'Myanmar', 'SEARO', '1321', '104487', '27', '2201');
INSERT INTO public.who_global_data_import VALUES (57146, '2020-12-13', 'MM', 'Myanmar', 'SEARO', '1376', '105863', '19', '2220');
INSERT INTO public.who_global_data_import VALUES (57147, '2020-12-14', 'MM', 'Myanmar', 'SEARO', '1352', '107215', '25', '2245');
INSERT INTO public.who_global_data_import VALUES (57148, '2020-12-15', 'MM', 'Myanmar', 'SEARO', '1127', '108342', '23', '2268');
INSERT INTO public.who_global_data_import VALUES (57149, '2020-12-16', 'MM', 'Myanmar', 'SEARO', '1170', '109512', '24', '2292');
INSERT INTO public.who_global_data_import VALUES (57150, '2020-12-17', 'MM', 'Myanmar', 'SEARO', '1155', '110667', '27', '2319');
INSERT INTO public.who_global_data_import VALUES (57151, '2020-12-18', 'MM', 'Myanmar', 'SEARO', '1233', '111900', '27', '2346');
INSERT INTO public.who_global_data_import VALUES (57152, '2020-12-19', 'MM', 'Myanmar', 'SEARO', '1182', '113082', '31', '2377');
INSERT INTO public.who_global_data_import VALUES (57153, '2020-12-20', 'MM', 'Myanmar', 'SEARO', '1116', '114198', '21', '2398');
INSERT INTO public.who_global_data_import VALUES (57154, '2020-12-21', 'MM', 'Myanmar', 'SEARO', '989', '115187', '26', '2424');
INSERT INTO public.who_global_data_import VALUES (57155, '2020-12-22', 'MM', 'Myanmar', 'SEARO', '947', '116134', '19', '2443');
INSERT INTO public.who_global_data_import VALUES (57156, '2020-12-23', 'MM', 'Myanmar', 'SEARO', '848', '116982', '22', '2465');
INSERT INTO public.who_global_data_import VALUES (57157, '2020-12-24', 'MM', 'Myanmar', 'SEARO', '964', '117946', '19', '2484');
INSERT INTO public.who_global_data_import VALUES (57158, '2020-12-25', 'MM', 'Myanmar', 'SEARO', '923', '118869', '23', '2507');
INSERT INTO public.who_global_data_import VALUES (57159, '2020-12-26', 'MM', 'Myanmar', 'SEARO', '919', '119788', '25', '2532');
INSERT INTO public.who_global_data_import VALUES (57160, '2020-12-27', 'MM', 'Myanmar', 'SEARO', '1492', '121280', '47', '2579');
INSERT INTO public.who_global_data_import VALUES (57161, '2020-12-28', 'MM', 'Myanmar', 'SEARO', '606', '121886', '22', '2601');
INSERT INTO public.who_global_data_import VALUES (57162, '2020-12-29', 'MM', 'Myanmar', 'SEARO', '648', '122534', '17', '2618');
INSERT INTO public.who_global_data_import VALUES (57163, '2020-12-30', 'MM', 'Myanmar', 'SEARO', '619', '123153', '19', '2637');
INSERT INTO public.who_global_data_import VALUES (57164, '2020-12-31', 'MM', 'Myanmar', 'SEARO', '587', '123740', '27', '2664');
INSERT INTO public.who_global_data_import VALUES (57165, '2021-01-01', 'MM', 'Myanmar', 'SEARO', '890', '124630', '18', '2682');
INSERT INTO public.who_global_data_import VALUES (57166, '2021-01-02', 'MM', 'Myanmar', 'SEARO', '423', '125053', '15', '2697');
INSERT INTO public.who_global_data_import VALUES (57167, '2021-01-03', 'MM', 'Myanmar', 'SEARO', '563', '125616', '14', '2711');
INSERT INTO public.who_global_data_import VALUES (57168, '2021-01-04', 'MM', 'Myanmar', 'SEARO', '729', '126345', '17', '2728');
INSERT INTO public.who_global_data_import VALUES (57169, '2021-01-05', 'MM', 'Myanmar', 'SEARO', '590', '126935', '16', '2744');
INSERT INTO public.who_global_data_import VALUES (57170, '2021-01-06', 'MM', 'Myanmar', 'SEARO', '647', '127582', '22', '2766');
INSERT INTO public.who_global_data_import VALUES (57171, '2021-01-07', 'MM', 'Myanmar', 'SEARO', '596', '128178', '19', '2785');
INSERT INTO public.who_global_data_import VALUES (57172, '2021-01-08', 'MM', 'Myanmar', 'SEARO', '594', '128772', '14', '2799');
INSERT INTO public.who_global_data_import VALUES (57173, '2021-01-09', 'MM', 'Myanmar', 'SEARO', '711', '129483', '13', '2812');
INSERT INTO public.who_global_data_import VALUES (57174, '2021-01-10', 'MM', 'Myanmar', 'SEARO', '566', '130049', '14', '2826');
INSERT INTO public.who_global_data_import VALUES (57175, '2021-01-11', 'MM', 'Myanmar', 'SEARO', '555', '130604', '20', '2846');
INSERT INTO public.who_global_data_import VALUES (57176, '2021-01-12', 'MM', 'Myanmar', 'SEARO', '582', '131186', '12', '2858');
INSERT INTO public.who_global_data_import VALUES (57177, '2021-01-13', 'MM', 'Myanmar', 'SEARO', '551', '131737', '20', '2878');
INSERT INTO public.who_global_data_import VALUES (57178, '2021-01-14', 'MM', 'Myanmar', 'SEARO', '523', '132260', '24', '2902');
INSERT INTO public.who_global_data_import VALUES (57179, '2021-01-15', 'MM', 'Myanmar', 'SEARO', '605', '132865', '10', '2912');
INSERT INTO public.who_global_data_import VALUES (57180, '2021-01-16', 'MM', 'Myanmar', 'SEARO', '513', '133378', '14', '2926');
INSERT INTO public.who_global_data_import VALUES (57181, '2021-01-17', 'MM', 'Myanmar', 'SEARO', '491', '133869', '16', '2942');
INSERT INTO public.who_global_data_import VALUES (57182, '2021-01-18', 'MM', 'Myanmar', 'SEARO', '449', '134318', '13', '2955');
INSERT INTO public.who_global_data_import VALUES (57183, '2021-01-19', 'MM', 'Myanmar', 'SEARO', '477', '134795', '18', '2973');
INSERT INTO public.who_global_data_import VALUES (57184, '2021-01-20', 'MM', 'Myanmar', 'SEARO', '448', '135243', '13', '2986');
INSERT INTO public.who_global_data_import VALUES (57185, '2021-01-21', 'MM', 'Myanmar', 'SEARO', '478', '135721', '11', '2997');
INSERT INTO public.who_global_data_import VALUES (57186, '2021-01-22', 'MM', 'Myanmar', 'SEARO', '445', '136166', '16', '3013');
INSERT INTO public.who_global_data_import VALUES (57187, '2021-01-23', 'MM', 'Myanmar', 'SEARO', '425', '136591', '18', '3031');
INSERT INTO public.who_global_data_import VALUES (57188, '2021-01-24', 'MM', 'Myanmar', 'SEARO', '507', '137098', '14', '3045');
INSERT INTO public.who_global_data_import VALUES (57189, '2021-01-25', 'MM', 'Myanmar', 'SEARO', '476', '137574', '17', '3062');
INSERT INTO public.who_global_data_import VALUES (57190, '2021-01-26', 'MM', 'Myanmar', 'SEARO', '383', '137957', '7', '3069');
INSERT INTO public.who_global_data_import VALUES (57191, '2021-01-27', 'MM', 'Myanmar', 'SEARO', '411', '138368', '13', '3082');
INSERT INTO public.who_global_data_import VALUES (57192, '2021-01-28', 'MM', 'Myanmar', 'SEARO', '434', '138802', '7', '3089');
INSERT INTO public.who_global_data_import VALUES (57193, '2021-01-29', 'MM', 'Myanmar', 'SEARO', '350', '139152', '14', '3103');
INSERT INTO public.who_global_data_import VALUES (57194, '2021-01-30', 'MM', 'Myanmar', 'SEARO', '363', '139515', '12', '3115');
INSERT INTO public.who_global_data_import VALUES (57195, '2021-01-31', 'MM', 'Myanmar', 'SEARO', '349', '139864', '10', '3125');
INSERT INTO public.who_global_data_import VALUES (57196, '2021-02-01', 'MM', 'Myanmar', 'SEARO', '281', '140145', '6', '3131');
INSERT INTO public.who_global_data_import VALUES (57197, '2021-02-02', 'MM', 'Myanmar', 'SEARO', '209', '140354', '7', '3138');
INSERT INTO public.who_global_data_import VALUES (57198, '2021-02-03', 'MM', 'Myanmar', 'SEARO', '310', '140664', '8', '3146');
INSERT INTO public.who_global_data_import VALUES (57199, '2021-02-04', 'MM', 'Myanmar', 'SEARO', '263', '140927', '14', '3160');
INSERT INTO public.who_global_data_import VALUES (57200, '2021-02-05', 'MM', 'Myanmar', 'SEARO', '177', '141104', '3', '3163');
INSERT INTO public.who_global_data_import VALUES (57201, '2020-01-03', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57202, '2020-01-04', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57203, '2020-01-05', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57204, '2020-01-06', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57205, '2020-01-07', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57206, '2020-01-08', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57207, '2020-01-09', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57208, '2020-01-10', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57209, '2020-01-11', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57210, '2020-01-12', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57211, '2020-01-13', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57212, '2020-01-14', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57213, '2020-01-15', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57214, '2020-01-16', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57215, '2020-01-17', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57216, '2020-01-18', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57217, '2020-01-19', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57218, '2020-01-20', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57219, '2020-01-21', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57220, '2020-01-22', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57221, '2020-01-23', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57222, '2020-01-24', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57223, '2020-01-25', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57224, '2020-01-26', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57225, '2020-01-27', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57226, '2020-01-28', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57227, '2020-01-29', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57228, '2020-01-30', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57229, '2020-01-31', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57230, '2020-02-01', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57231, '2020-02-02', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57232, '2020-02-03', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57233, '2020-02-04', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57234, '2020-02-05', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57235, '2020-02-06', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57236, '2020-02-07', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57237, '2020-02-08', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57238, '2020-02-09', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57239, '2020-02-10', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57240, '2020-02-11', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57241, '2020-02-12', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57242, '2020-02-13', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57243, '2020-02-14', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57244, '2020-02-15', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57245, '2020-02-16', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57246, '2020-02-17', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57247, '2020-02-18', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57248, '2020-02-19', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57249, '2020-02-20', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57250, '2020-02-21', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57251, '2020-02-22', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57252, '2020-02-23', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57253, '2020-02-24', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57254, '2020-02-25', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57255, '2020-02-26', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57256, '2020-02-27', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57257, '2020-02-28', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57258, '2020-02-29', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57259, '2020-03-01', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57260, '2020-03-02', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57261, '2020-03-03', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57262, '2020-03-04', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57263, '2020-03-05', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57264, '2020-03-06', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57265, '2020-03-07', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57266, '2020-03-08', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57267, '2020-03-09', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57268, '2020-03-10', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57269, '2020-03-11', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57270, '2020-03-12', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57271, '2020-03-13', 'NA', 'Namibia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57272, '2020-03-14', 'NA', 'Namibia', 'AFRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57273, '2020-03-15', 'NA', 'Namibia', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57274, '2020-03-16', 'NA', 'Namibia', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57275, '2020-03-17', 'NA', 'Namibia', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57276, '2020-03-18', 'NA', 'Namibia', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57277, '2020-03-19', 'NA', 'Namibia', 'AFRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57278, '2020-03-20', 'NA', 'Namibia', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57279, '2020-03-21', 'NA', 'Namibia', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57280, '2020-03-22', 'NA', 'Namibia', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57281, '2020-03-23', 'NA', 'Namibia', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57282, '2020-03-24', 'NA', 'Namibia', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57283, '2020-03-25', 'NA', 'Namibia', 'AFRO', '-3', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57284, '2020-03-26', 'NA', 'Namibia', 'AFRO', '4', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57285, '2020-03-27', 'NA', 'Namibia', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57286, '2020-03-28', 'NA', 'Namibia', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57287, '2020-03-29', 'NA', 'Namibia', 'AFRO', '3', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57288, '2020-03-30', 'NA', 'Namibia', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57289, '2020-03-31', 'NA', 'Namibia', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57290, '2020-04-01', 'NA', 'Namibia', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57291, '2020-04-02', 'NA', 'Namibia', 'AFRO', '2', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57292, '2020-04-03', 'NA', 'Namibia', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57293, '2020-04-04', 'NA', 'Namibia', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57294, '2020-04-05', 'NA', 'Namibia', 'AFRO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57295, '2020-04-06', 'NA', 'Namibia', 'AFRO', '2', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57296, '2020-04-07', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57297, '2020-04-08', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57298, '2020-04-09', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57299, '2020-04-10', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57300, '2020-04-11', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57301, '2020-04-12', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57302, '2020-04-13', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57303, '2020-04-14', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57304, '2020-04-15', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57305, '2020-04-16', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57306, '2020-04-17', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57307, '2020-04-18', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57308, '2020-04-19', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57309, '2020-04-20', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57310, '2020-04-21', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57311, '2020-04-22', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57312, '2020-04-23', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57313, '2020-04-24', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57314, '2020-04-25', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57315, '2020-04-26', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57316, '2020-04-27', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57317, '2020-04-28', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57318, '2020-04-29', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57319, '2020-04-30', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57320, '2020-05-01', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57321, '2020-05-02', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57322, '2020-05-03', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57323, '2020-05-04', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57324, '2020-05-05', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57325, '2020-05-06', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57326, '2020-05-07', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57327, '2020-05-08', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57328, '2020-05-09', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57329, '2020-05-10', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57330, '2020-05-11', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57331, '2020-05-12', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57332, '2020-05-13', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57333, '2020-05-14', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57334, '2020-05-15', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57335, '2020-05-16', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57336, '2020-05-17', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57337, '2020-05-18', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57338, '2020-05-19', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57339, '2020-05-20', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57340, '2020-05-21', 'NA', 'Namibia', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57341, '2020-05-22', 'NA', 'Namibia', 'AFRO', '2', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57342, '2020-05-23', 'NA', 'Namibia', 'AFRO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57343, '2020-05-24', 'NA', 'Namibia', 'AFRO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57344, '2020-05-25', 'NA', 'Namibia', 'AFRO', '1', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57345, '2020-05-26', 'NA', 'Namibia', 'AFRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57346, '2020-05-27', 'NA', 'Namibia', 'AFRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57347, '2020-05-28', 'NA', 'Namibia', 'AFRO', '1', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57348, '2020-05-29', 'NA', 'Namibia', 'AFRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57349, '2020-05-30', 'NA', 'Namibia', 'AFRO', '1', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57350, '2020-05-31', 'NA', 'Namibia', 'AFRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57351, '2020-06-01', 'NA', 'Namibia', 'AFRO', '1', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57352, '2020-06-02', 'NA', 'Namibia', 'AFRO', '1', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57353, '2020-06-03', 'NA', 'Namibia', 'AFRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57354, '2020-06-04', 'NA', 'Namibia', 'AFRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57355, '2020-06-05', 'NA', 'Namibia', 'AFRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57356, '2020-06-06', 'NA', 'Namibia', 'AFRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57357, '2020-06-07', 'NA', 'Namibia', 'AFRO', '4', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57358, '2020-06-08', 'NA', 'Namibia', 'AFRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57359, '2020-06-09', 'NA', 'Namibia', 'AFRO', '2', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57360, '2020-06-10', 'NA', 'Namibia', 'AFRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57361, '2020-06-11', 'NA', 'Namibia', 'AFRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57362, '2020-06-12', 'NA', 'Namibia', 'AFRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57363, '2020-06-13', 'NA', 'Namibia', 'AFRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57364, '2020-06-14', 'NA', 'Namibia', 'AFRO', '1', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57365, '2020-06-15', 'NA', 'Namibia', 'AFRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57366, '2020-06-16', 'NA', 'Namibia', 'AFRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57367, '2020-06-17', 'NA', 'Namibia', 'AFRO', '2', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57368, '2020-06-18', 'NA', 'Namibia', 'AFRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57369, '2020-06-19', 'NA', 'Namibia', 'AFRO', '5', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57370, '2020-06-20', 'NA', 'Namibia', 'AFRO', '6', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57371, '2020-06-21', 'NA', 'Namibia', 'AFRO', '1', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57372, '2020-06-22', 'NA', 'Namibia', 'AFRO', '9', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57373, '2020-06-23', 'NA', 'Namibia', 'AFRO', '8', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57374, '2020-06-24', 'NA', 'Namibia', 'AFRO', '9', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57375, '2020-06-25', 'NA', 'Namibia', 'AFRO', '4', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57376, '2020-06-26', 'NA', 'Namibia', 'AFRO', '26', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57377, '2020-06-27', 'NA', 'Namibia', 'AFRO', '0', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57378, '2020-06-28', 'NA', 'Namibia', 'AFRO', '34', '136', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57379, '2020-06-29', 'NA', 'Namibia', 'AFRO', '14', '150', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57380, '2020-06-30', 'NA', 'Namibia', 'AFRO', '33', '183', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57381, '2020-07-01', 'NA', 'Namibia', 'AFRO', '20', '203', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57382, '2020-07-02', 'NA', 'Namibia', 'AFRO', '82', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57383, '2020-07-03', 'NA', 'Namibia', 'AFRO', '8', '293', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57384, '2020-07-04', 'NA', 'Namibia', 'AFRO', '57', '350', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57385, '2020-07-05', 'NA', 'Namibia', 'AFRO', '25', '375', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57386, '2020-07-06', 'NA', 'Namibia', 'AFRO', '37', '412', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57387, '2020-07-07', 'NA', 'Namibia', 'AFRO', '73', '485', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57388, '2020-07-08', 'NA', 'Namibia', 'AFRO', '54', '539', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57389, '2020-07-09', 'NA', 'Namibia', 'AFRO', '54', '593', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57390, '2020-07-10', 'NA', 'Namibia', 'AFRO', '22', '615', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57391, '2020-07-11', 'NA', 'Namibia', 'AFRO', '53', '668', '1', '1');
INSERT INTO public.who_global_data_import VALUES (57392, '2020-07-12', 'NA', 'Namibia', 'AFRO', '45', '713', '0', '1');
INSERT INTO public.who_global_data_import VALUES (57393, '2020-07-13', 'NA', 'Namibia', 'AFRO', '72', '785', '0', '1');
INSERT INTO public.who_global_data_import VALUES (57394, '2020-07-14', 'NA', 'Namibia', 'AFRO', '76', '861', '0', '1');
INSERT INTO public.who_global_data_import VALUES (57395, '2020-07-15', 'NA', 'Namibia', 'AFRO', '3', '864', '1', '2');
INSERT INTO public.who_global_data_import VALUES (57396, '2020-07-16', 'NA', 'Namibia', 'AFRO', '96', '960', '0', '2');
INSERT INTO public.who_global_data_import VALUES (57397, '2020-07-17', 'NA', 'Namibia', 'AFRO', '72', '1032', '0', '2');
INSERT INTO public.who_global_data_import VALUES (57398, '2020-07-18', 'NA', 'Namibia', 'AFRO', '46', '1078', '0', '2');
INSERT INTO public.who_global_data_import VALUES (57399, '2020-07-19', 'NA', 'Namibia', 'AFRO', '125', '1203', '0', '2');
INSERT INTO public.who_global_data_import VALUES (57400, '2020-07-20', 'NA', 'Namibia', 'AFRO', '44', '1247', '1', '3');
INSERT INTO public.who_global_data_import VALUES (57401, '2020-07-21', 'NA', 'Namibia', 'AFRO', '97', '1344', '1', '4');
INSERT INTO public.who_global_data_import VALUES (57402, '2020-07-22', 'NA', 'Namibia', 'AFRO', '22', '1366', '3', '7');
INSERT INTO public.who_global_data_import VALUES (57403, '2020-07-23', 'NA', 'Namibia', 'AFRO', '36', '1402', '0', '7');
INSERT INTO public.who_global_data_import VALUES (57404, '2020-07-24', 'NA', 'Namibia', 'AFRO', '120', '1522', '0', '7');
INSERT INTO public.who_global_data_import VALUES (57405, '2020-07-25', 'NA', 'Namibia', 'AFRO', '17', '1539', '0', '7');
INSERT INTO public.who_global_data_import VALUES (57406, '2020-07-26', 'NA', 'Namibia', 'AFRO', '148', '1687', '0', '7');
INSERT INTO public.who_global_data_import VALUES (57407, '2020-07-27', 'NA', 'Namibia', 'AFRO', '87', '1774', '1', '8');
INSERT INTO public.who_global_data_import VALUES (57408, '2020-07-28', 'NA', 'Namibia', 'AFRO', '68', '1842', '0', '8');
INSERT INTO public.who_global_data_import VALUES (57409, '2020-07-29', 'NA', 'Namibia', 'AFRO', '75', '1917', '0', '8');
INSERT INTO public.who_global_data_import VALUES (57410, '2020-07-30', 'NA', 'Namibia', 'AFRO', '69', '1986', '1', '9');
INSERT INTO public.who_global_data_import VALUES (57411, '2020-07-31', 'NA', 'Namibia', 'AFRO', '66', '2052', '1', '10');
INSERT INTO public.who_global_data_import VALUES (57412, '2020-08-01', 'NA', 'Namibia', 'AFRO', '77', '2129', '0', '10');
INSERT INTO public.who_global_data_import VALUES (57413, '2020-08-02', 'NA', 'Namibia', 'AFRO', '95', '2224', '1', '11');
INSERT INTO public.who_global_data_import VALUES (57414, '2020-08-03', 'NA', 'Namibia', 'AFRO', '70', '2294', '0', '11');
INSERT INTO public.who_global_data_import VALUES (57415, '2020-08-04', 'NA', 'Namibia', 'AFRO', '112', '2406', '1', '12');
INSERT INTO public.who_global_data_import VALUES (57416, '2020-08-05', 'NA', 'Namibia', 'AFRO', '64', '2470', '0', '12');
INSERT INTO public.who_global_data_import VALUES (57417, '2020-08-06', 'NA', 'Namibia', 'AFRO', '70', '2540', '0', '12');
INSERT INTO public.who_global_data_import VALUES (57418, '2020-08-07', 'NA', 'Namibia', 'AFRO', '112', '2652', '3', '15');
INSERT INTO public.who_global_data_import VALUES (57419, '2020-08-08', 'NA', 'Namibia', 'AFRO', '150', '2802', '1', '16');
INSERT INTO public.who_global_data_import VALUES (57420, '2020-08-09', 'NA', 'Namibia', 'AFRO', '50', '2852', '0', '16');
INSERT INTO public.who_global_data_import VALUES (57421, '2020-08-10', 'NA', 'Namibia', 'AFRO', '97', '2949', '3', '19');
INSERT INTO public.who_global_data_import VALUES (57422, '2020-08-11', 'NA', 'Namibia', 'AFRO', '152', '3101', '0', '19');
INSERT INTO public.who_global_data_import VALUES (57423, '2020-08-12', 'NA', 'Namibia', 'AFRO', '128', '3229', '0', '19');
INSERT INTO public.who_global_data_import VALUES (57424, '2020-08-13', 'NA', 'Namibia', 'AFRO', '177', '3406', '3', '22');
INSERT INTO public.who_global_data_import VALUES (57425, '2020-08-14', 'NA', 'Namibia', 'AFRO', '138', '3544', '5', '27');
INSERT INTO public.who_global_data_import VALUES (57426, '2020-08-15', 'NA', 'Namibia', 'AFRO', '182', '3726', '4', '31');
INSERT INTO public.who_global_data_import VALUES (57427, '2020-08-16', 'NA', 'Namibia', 'AFRO', '181', '3907', '4', '35');
INSERT INTO public.who_global_data_import VALUES (57428, '2020-08-17', 'NA', 'Namibia', 'AFRO', '247', '4154', '0', '35');
INSERT INTO public.who_global_data_import VALUES (57429, '2020-08-18', 'NA', 'Namibia', 'AFRO', '190', '4344', '1', '36');
INSERT INTO public.who_global_data_import VALUES (57430, '2020-08-19', 'NA', 'Namibia', 'AFRO', '120', '4464', '1', '37');
INSERT INTO public.who_global_data_import VALUES (57431, '2020-08-20', 'NA', 'Namibia', 'AFRO', '201', '4665', '2', '39');
INSERT INTO public.who_global_data_import VALUES (57432, '2020-08-21', 'NA', 'Namibia', 'AFRO', '247', '4912', '3', '42');
INSERT INTO public.who_global_data_import VALUES (57433, '2020-08-22', 'NA', 'Namibia', 'AFRO', '315', '5227', '1', '43');
INSERT INTO public.who_global_data_import VALUES (57434, '2020-08-23', 'NA', 'Namibia', 'AFRO', '311', '5538', '3', '46');
INSERT INTO public.who_global_data_import VALUES (57435, '2020-08-24', 'NA', 'Namibia', 'AFRO', '316', '5854', '6', '52');
INSERT INTO public.who_global_data_import VALUES (57436, '2020-08-25', 'NA', 'Namibia', 'AFRO', '176', '6030', '4', '56');
INSERT INTO public.who_global_data_import VALUES (57437, '2020-08-26', 'NA', 'Namibia', 'AFRO', '130', '6160', '1', '57');
INSERT INTO public.who_global_data_import VALUES (57438, '2020-08-27', 'NA', 'Namibia', 'AFRO', '271', '6431', '2', '59');
INSERT INTO public.who_global_data_import VALUES (57439, '2020-08-28', 'NA', 'Namibia', 'AFRO', '281', '6712', '1', '60');
INSERT INTO public.who_global_data_import VALUES (57440, '2020-08-29', 'NA', 'Namibia', 'AFRO', '194', '6906', '5', '65');
INSERT INTO public.who_global_data_import VALUES (57441, '2020-08-30', 'NA', 'Namibia', 'AFRO', '210', '7116', '4', '69');
INSERT INTO public.who_global_data_import VALUES (57442, '2020-08-31', 'NA', 'Namibia', 'AFRO', '249', '7365', '3', '72');
INSERT INTO public.who_global_data_import VALUES (57443, '2020-09-01', 'NA', 'Namibia', 'AFRO', '185', '7550', '3', '75');
INSERT INTO public.who_global_data_import VALUES (57444, '2020-09-02', 'NA', 'Namibia', 'AFRO', '142', '7692', '6', '81');
INSERT INTO public.who_global_data_import VALUES (57445, '2020-09-03', 'NA', 'Namibia', 'AFRO', '152', '7844', '1', '82');
INSERT INTO public.who_global_data_import VALUES (57446, '2020-09-04', 'NA', 'Namibia', 'AFRO', '238', '8082', '4', '86');
INSERT INTO public.who_global_data_import VALUES (57447, '2020-09-05', 'NA', 'Namibia', 'AFRO', '241', '8323', '1', '87');
INSERT INTO public.who_global_data_import VALUES (57448, '2020-09-06', 'NA', 'Namibia', 'AFRO', '191', '8514', '0', '87');
INSERT INTO public.who_global_data_import VALUES (57449, '2020-09-07', 'NA', 'Namibia', 'AFRO', '171', '8685', '2', '89');
INSERT INTO public.who_global_data_import VALUES (57450, '2020-09-08', 'NA', 'Namibia', 'AFRO', '125', '8810', '2', '91');
INSERT INTO public.who_global_data_import VALUES (57451, '2020-09-09', 'NA', 'Namibia', 'AFRO', '118', '8928', '-2', '89');
INSERT INTO public.who_global_data_import VALUES (57452, '2020-09-10', 'NA', 'Namibia', 'AFRO', '180', '9108', '4', '93');
INSERT INTO public.who_global_data_import VALUES (57453, '2020-09-11', 'NA', 'Namibia', 'AFRO', '148', '9256', '3', '96');
INSERT INTO public.who_global_data_import VALUES (57454, '2020-09-12', 'NA', 'Namibia', 'AFRO', '181', '9437', '2', '98');
INSERT INTO public.who_global_data_import VALUES (57455, '2020-09-13', 'NA', 'Namibia', 'AFRO', '167', '9604', '0', '98');
INSERT INTO public.who_global_data_import VALUES (57456, '2020-09-14', 'NA', 'Namibia', 'AFRO', '115', '9719', '3', '101');
INSERT INTO public.who_global_data_import VALUES (57457, '2020-09-15', 'NA', 'Namibia', 'AFRO', '99', '9818', '2', '103');
INSERT INTO public.who_global_data_import VALUES (57458, '2020-09-16', 'NA', 'Namibia', 'AFRO', '83', '9901', '3', '106');
INSERT INTO public.who_global_data_import VALUES (57459, '2020-09-17', 'NA', 'Namibia', 'AFRO', '63', '9964', '2', '108');
INSERT INTO public.who_global_data_import VALUES (57460, '2020-09-18', 'NA', 'Namibia', 'AFRO', '114', '10078', '0', '108');
INSERT INTO public.who_global_data_import VALUES (57461, '2020-09-19', 'NA', 'Namibia', 'AFRO', '129', '10207', '0', '108');
INSERT INTO public.who_global_data_import VALUES (57462, '2020-09-20', 'NA', 'Namibia', 'AFRO', '85', '10292', '3', '111');
INSERT INTO public.who_global_data_import VALUES (57463, '2020-09-21', 'NA', 'Namibia', 'AFRO', '85', '10377', '1', '112');
INSERT INTO public.who_global_data_import VALUES (57464, '2020-09-22', 'NA', 'Namibia', 'AFRO', '149', '10526', '1', '113');
INSERT INTO public.who_global_data_import VALUES (57465, '2020-09-23', 'NA', 'Namibia', 'AFRO', '81', '10607', '3', '116');
INSERT INTO public.who_global_data_import VALUES (57466, '2020-09-24', 'NA', 'Namibia', 'AFRO', '56', '10663', '1', '117');
INSERT INTO public.who_global_data_import VALUES (57467, '2020-09-25', 'NA', 'Namibia', 'AFRO', '77', '10740', '2', '119');
INSERT INTO public.who_global_data_import VALUES (57468, '2020-09-26', 'NA', 'Namibia', 'AFRO', '95', '10835', '0', '119');
INSERT INTO public.who_global_data_import VALUES (57469, '2020-09-27', 'NA', 'Namibia', 'AFRO', '83', '10918', '1', '120');
INSERT INTO public.who_global_data_import VALUES (57470, '2020-09-28', 'NA', 'Namibia', 'AFRO', '115', '11033', '0', '120');
INSERT INTO public.who_global_data_import VALUES (57471, '2020-09-29', 'NA', 'Namibia', 'AFRO', '88', '11121', '1', '121');
INSERT INTO public.who_global_data_import VALUES (57472, '2020-09-30', 'NA', 'Namibia', 'AFRO', '19', '11140', '0', '121');
INSERT INTO public.who_global_data_import VALUES (57473, '2020-10-01', 'NA', 'Namibia', 'AFRO', '125', '11265', '0', '121');
INSERT INTO public.who_global_data_import VALUES (57474, '2020-10-02', 'NA', 'Namibia', 'AFRO', '114', '11379', '2', '123');
INSERT INTO public.who_global_data_import VALUES (57475, '2020-10-03', 'NA', 'Namibia', 'AFRO', '101', '11480', '0', '123');
INSERT INTO public.who_global_data_import VALUES (57476, '2020-10-04', 'NA', 'Namibia', 'AFRO', '92', '11572', '0', '123');
INSERT INTO public.who_global_data_import VALUES (57477, '2020-10-05', 'NA', 'Namibia', 'AFRO', '54', '11626', '0', '123');
INSERT INTO public.who_global_data_import VALUES (57478, '2020-10-06', 'NA', 'Namibia', 'AFRO', '28', '11654', '2', '125');
INSERT INTO public.who_global_data_import VALUES (57479, '2020-10-07', 'NA', 'Namibia', 'AFRO', '19', '11673', '0', '125');
INSERT INTO public.who_global_data_import VALUES (57480, '2020-10-08', 'NA', 'Namibia', 'AFRO', '41', '11714', '1', '126');
INSERT INTO public.who_global_data_import VALUES (57481, '2020-10-09', 'NA', 'Namibia', 'AFRO', '67', '11781', '1', '127');
INSERT INTO public.who_global_data_import VALUES (57482, '2020-10-10', 'NA', 'Namibia', 'AFRO', '48', '11829', '0', '127');
INSERT INTO public.who_global_data_import VALUES (57483, '2020-10-11', 'NA', 'Namibia', 'AFRO', '62', '11891', '1', '128');
INSERT INTO public.who_global_data_import VALUES (57484, '2020-10-12', 'NA', 'Namibia', 'AFRO', '45', '11936', '0', '128');
INSERT INTO public.who_global_data_import VALUES (57485, '2020-10-13', 'NA', 'Namibia', 'AFRO', '53', '11989', '1', '129');
INSERT INTO public.who_global_data_import VALUES (57486, '2020-10-14', 'NA', 'Namibia', 'AFRO', '11', '12000', '0', '129');
INSERT INTO public.who_global_data_import VALUES (57487, '2020-10-15', 'NA', 'Namibia', 'AFRO', '69', '12069', '1', '130');
INSERT INTO public.who_global_data_import VALUES (57488, '2020-10-16', 'NA', 'Namibia', 'AFRO', '34', '12103', '0', '130');
INSERT INTO public.who_global_data_import VALUES (57489, '2020-10-17', 'NA', 'Namibia', 'AFRO', '112', '12215', '1', '131');
INSERT INTO public.who_global_data_import VALUES (57490, '2020-10-18', 'NA', 'Namibia', 'AFRO', '48', '12263', '0', '131');
INSERT INTO public.who_global_data_import VALUES (57491, '2020-10-19', 'NA', 'Namibia', 'AFRO', '30', '12293', '0', '131');
INSERT INTO public.who_global_data_import VALUES (57492, '2020-10-20', 'NA', 'Namibia', 'AFRO', '33', '12326', '0', '131');
INSERT INTO public.who_global_data_import VALUES (57493, '2020-10-21', 'NA', 'Namibia', 'AFRO', '41', '12367', '1', '132');
INSERT INTO public.who_global_data_import VALUES (57494, '2020-10-22', 'NA', 'Namibia', 'AFRO', '39', '12406', '1', '133');
INSERT INTO public.who_global_data_import VALUES (57495, '2020-10-23', 'NA', 'Namibia', 'AFRO', '54', '12460', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57496, '2020-10-24', 'NA', 'Namibia', 'AFRO', '41', '12501', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57497, '2020-10-25', 'NA', 'Namibia', 'AFRO', '78', '12579', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57498, '2020-10-26', 'NA', 'Namibia', 'AFRO', '81', '12660', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57499, '2020-10-27', 'NA', 'Namibia', 'AFRO', '15', '12675', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57500, '2020-10-28', 'NA', 'Namibia', 'AFRO', '54', '12729', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57501, '2020-10-29', 'NA', 'Namibia', 'AFRO', '77', '12806', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57502, '2020-10-30', 'NA', 'Namibia', 'AFRO', '52', '12858', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57503, '2020-10-31', 'NA', 'Namibia', 'AFRO', '49', '12907', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57504, '2020-11-01', 'NA', 'Namibia', 'AFRO', '28', '12935', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57505, '2020-11-02', 'NA', 'Namibia', 'AFRO', '53', '12988', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57506, '2020-11-03', 'NA', 'Namibia', 'AFRO', '24', '13012', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57507, '2020-11-04', 'NA', 'Namibia', 'AFRO', '18', '13030', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57508, '2020-11-05', 'NA', 'Namibia', 'AFRO', '16', '13046', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57509, '2020-11-06', 'NA', 'Namibia', 'AFRO', '45', '13091', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57510, '2020-11-07', 'NA', 'Namibia', 'AFRO', '52', '13143', '0', '133');
INSERT INTO public.who_global_data_import VALUES (57511, '2020-11-08', 'NA', 'Namibia', 'AFRO', '27', '13170', '1', '134');
INSERT INTO public.who_global_data_import VALUES (57512, '2020-11-09', 'NA', 'Namibia', 'AFRO', '41', '13211', '0', '134');
INSERT INTO public.who_global_data_import VALUES (57513, '2020-11-10', 'NA', 'Namibia', 'AFRO', '29', '13240', '0', '134');
INSERT INTO public.who_global_data_import VALUES (57514, '2020-11-11', 'NA', 'Namibia', 'AFRO', '13', '13253', '0', '134');
INSERT INTO public.who_global_data_import VALUES (57515, '2020-11-12', 'NA', 'Namibia', 'AFRO', '39', '13292', '0', '134');
INSERT INTO public.who_global_data_import VALUES (57516, '2020-11-13', 'NA', 'Namibia', 'AFRO', '53', '13345', '1', '135');
INSERT INTO public.who_global_data_import VALUES (57517, '2020-11-14', 'NA', 'Namibia', 'AFRO', '27', '13372', '3', '138');
INSERT INTO public.who_global_data_import VALUES (57518, '2020-11-15', 'NA', 'Namibia', 'AFRO', '77', '13449', '0', '138');
INSERT INTO public.who_global_data_import VALUES (57519, '2020-11-16', 'NA', 'Namibia', 'AFRO', '59', '13508', '0', '138');
INSERT INTO public.who_global_data_import VALUES (57520, '2020-11-17', 'NA', 'Namibia', 'AFRO', '47', '13555', '0', '138');
INSERT INTO public.who_global_data_import VALUES (57521, '2020-11-18', 'NA', 'Namibia', 'AFRO', '11', '13566', '2', '140');
INSERT INTO public.who_global_data_import VALUES (57522, '2020-11-19', 'NA', 'Namibia', 'AFRO', '44', '13610', '0', '140');
INSERT INTO public.who_global_data_import VALUES (57523, '2020-11-20', 'NA', 'Namibia', 'AFRO', '52', '13662', '1', '141');
INSERT INTO public.who_global_data_import VALUES (57524, '2020-11-21', 'NA', 'Namibia', 'AFRO', '50', '13712', '2', '143');
INSERT INTO public.who_global_data_import VALUES (57525, '2020-11-22', 'NA', 'Namibia', 'AFRO', '99', '13811', '0', '143');
INSERT INTO public.who_global_data_import VALUES (57526, '2020-11-23', 'NA', 'Namibia', 'AFRO', '54', '13865', '1', '144');
INSERT INTO public.who_global_data_import VALUES (57527, '2020-11-24', 'NA', 'Namibia', 'AFRO', '32', '13897', '1', '145');
INSERT INTO public.who_global_data_import VALUES (57528, '2020-11-25', 'NA', 'Namibia', 'AFRO', '41', '13938', '0', '145');
INSERT INTO public.who_global_data_import VALUES (57529, '2020-11-26', 'NA', 'Namibia', 'AFRO', '68', '14006', '0', '145');
INSERT INTO public.who_global_data_import VALUES (57530, '2020-11-27', 'NA', 'Namibia', 'AFRO', '149', '14155', '2', '147');
INSERT INTO public.who_global_data_import VALUES (57531, '2020-11-28', 'NA', 'Namibia', 'AFRO', '52', '14207', '2', '149');
INSERT INTO public.who_global_data_import VALUES (57532, '2020-11-29', 'NA', 'Namibia', 'AFRO', '78', '14285', '1', '150');
INSERT INTO public.who_global_data_import VALUES (57533, '2020-11-30', 'NA', 'Namibia', 'AFRO', '60', '14345', '1', '151');
INSERT INTO public.who_global_data_import VALUES (57534, '2020-12-01', 'NA', 'Namibia', 'AFRO', '35', '14380', '1', '152');
INSERT INTO public.who_global_data_import VALUES (57535, '2020-12-02', 'NA', 'Namibia', 'AFRO', '36', '14416', '0', '152');
INSERT INTO public.who_global_data_import VALUES (57536, '2020-12-03', 'NA', 'Namibia', 'AFRO', '61', '14477', '0', '152');
INSERT INTO public.who_global_data_import VALUES (57537, '2020-12-04', 'NA', 'Namibia', 'AFRO', '122', '14599', '0', '152');
INSERT INTO public.who_global_data_import VALUES (57538, '2020-12-05', 'NA', 'Namibia', 'AFRO', '181', '14780', '1', '153');
INSERT INTO public.who_global_data_import VALUES (57539, '2020-12-06', 'NA', 'Namibia', 'AFRO', '170', '14950', '0', '153');
INSERT INTO public.who_global_data_import VALUES (57540, '2020-12-07', 'NA', 'Namibia', 'AFRO', '128', '15078', '0', '153');
INSERT INTO public.who_global_data_import VALUES (57541, '2020-12-08', 'NA', 'Namibia', 'AFRO', '141', '15219', '0', '153');
INSERT INTO public.who_global_data_import VALUES (57542, '2020-12-09', 'NA', 'Namibia', 'AFRO', '79', '15298', '1', '154');
INSERT INTO public.who_global_data_import VALUES (57543, '2020-12-10', 'NA', 'Namibia', 'AFRO', '174', '15472', '1', '155');
INSERT INTO public.who_global_data_import VALUES (57544, '2020-12-11', 'NA', 'Namibia', 'AFRO', '301', '15773', '3', '158');
INSERT INTO public.who_global_data_import VALUES (57545, '2020-12-12', 'NA', 'Namibia', 'AFRO', '324', '16097', '2', '160');
INSERT INTO public.who_global_data_import VALUES (57546, '2020-12-13', 'NA', 'Namibia', 'AFRO', '0', '16097', '0', '160');
INSERT INTO public.who_global_data_import VALUES (57547, '2020-12-14', 'NA', 'Namibia', 'AFRO', '439', '16536', '0', '160');
INSERT INTO public.who_global_data_import VALUES (57548, '2020-12-15', 'NA', 'Namibia', 'AFRO', '190', '16726', '3', '163');
INSERT INTO public.who_global_data_import VALUES (57549, '2020-12-16', 'NA', 'Namibia', 'AFRO', '187', '16913', '1', '164');
INSERT INTO public.who_global_data_import VALUES (57550, '2020-12-17', 'NA', 'Namibia', 'AFRO', '363', '17276', '0', '164');
INSERT INTO public.who_global_data_import VALUES (57551, '2020-12-18', 'NA', 'Namibia', 'AFRO', '331', '17607', '0', '164');
INSERT INTO public.who_global_data_import VALUES (57552, '2020-12-19', 'NA', 'Namibia', 'AFRO', '434', '18041', '5', '169');
INSERT INTO public.who_global_data_import VALUES (57553, '2020-12-20', 'NA', 'Namibia', 'AFRO', '396', '18437', '2', '171');
INSERT INTO public.who_global_data_import VALUES (57554, '2020-12-21', 'NA', 'Namibia', 'AFRO', '277', '18714', '6', '177');
INSERT INTO public.who_global_data_import VALUES (57555, '2020-12-22', 'NA', 'Namibia', 'AFRO', '585', '19299', '3', '180');
INSERT INTO public.who_global_data_import VALUES (57556, '2020-12-23', 'NA', 'Namibia', 'AFRO', '330', '19629', '1', '181');
INSERT INTO public.who_global_data_import VALUES (57557, '2020-12-24', 'NA', 'Namibia', 'AFRO', '355', '19984', '2', '183');
INSERT INTO public.who_global_data_import VALUES (57558, '2020-12-25', 'NA', 'Namibia', 'AFRO', '595', '20579', '4', '187');
INSERT INTO public.who_global_data_import VALUES (57559, '2020-12-26', 'NA', 'Namibia', 'AFRO', '683', '21262', '0', '187');
INSERT INTO public.who_global_data_import VALUES (57560, '2020-12-27', 'NA', 'Namibia', 'AFRO', '136', '21398', '0', '187');
INSERT INTO public.who_global_data_import VALUES (57561, '2020-12-28', 'NA', 'Namibia', 'AFRO', '525', '21923', '4', '191');
INSERT INTO public.who_global_data_import VALUES (57562, '2020-12-29', 'NA', 'Namibia', 'AFRO', '0', '21923', '0', '191');
INSERT INTO public.who_global_data_import VALUES (57563, '2020-12-30', 'NA', 'Namibia', 'AFRO', '928', '22851', '4', '195');
INSERT INTO public.who_global_data_import VALUES (57564, '2020-12-31', 'NA', 'Namibia', 'AFRO', '482', '23333', '1', '196');
INSERT INTO public.who_global_data_import VALUES (57565, '2021-01-01', 'NA', 'Namibia', 'AFRO', '608', '23941', '9', '205');
INSERT INTO public.who_global_data_import VALUES (57566, '2021-01-02', 'NA', 'Namibia', 'AFRO', '0', '23941', '0', '205');
INSERT INTO public.who_global_data_import VALUES (57567, '2021-01-03', 'NA', 'Namibia', 'AFRO', '713', '24654', '8', '213');
INSERT INTO public.who_global_data_import VALUES (57568, '2021-01-04', 'NA', 'Namibia', 'AFRO', '462', '25116', '2', '215');
INSERT INTO public.who_global_data_import VALUES (57569, '2021-01-05', 'NA', 'Namibia', 'AFRO', '270', '25386', '3', '218');
INSERT INTO public.who_global_data_import VALUES (57570, '2021-01-06', 'NA', 'Namibia', 'AFRO', '501', '25887', '4', '222');
INSERT INTO public.who_global_data_import VALUES (57571, '2021-01-07', 'NA', 'Namibia', 'AFRO', '423', '26310', '13', '235');
INSERT INTO public.who_global_data_import VALUES (57572, '2021-01-08', 'NA', 'Namibia', 'AFRO', '372', '26682', '5', '240');
INSERT INTO public.who_global_data_import VALUES (57573, '2021-01-09', 'NA', 'Namibia', 'AFRO', '573', '27255', '0', '240');
INSERT INTO public.who_global_data_import VALUES (57574, '2021-01-10', 'NA', 'Namibia', 'AFRO', '468', '27723', '11', '251');
INSERT INTO public.who_global_data_import VALUES (57575, '2021-01-11', 'NA', 'Namibia', 'AFRO', '536', '28259', '3', '254');
INSERT INTO public.who_global_data_import VALUES (57576, '2021-01-12', 'NA', 'Namibia', 'AFRO', '343', '28602', '7', '261');
INSERT INTO public.who_global_data_import VALUES (57577, '2021-01-13', 'NA', 'Namibia', 'AFRO', '269', '28871', '3', '264');
INSERT INTO public.who_global_data_import VALUES (57578, '2021-01-14', 'NA', 'Namibia', 'AFRO', '312', '29183', '7', '271');
INSERT INTO public.who_global_data_import VALUES (57579, '2021-01-15', 'NA', 'Namibia', 'AFRO', '387', '29570', '4', '275');
INSERT INTO public.who_global_data_import VALUES (57580, '2021-01-16', 'NA', 'Namibia', 'AFRO', '0', '29570', '0', '275');
INSERT INTO public.who_global_data_import VALUES (57581, '2021-01-17', 'NA', 'Namibia', 'AFRO', '628', '30198', '5', '280');
INSERT INTO public.who_global_data_import VALUES (57582, '2021-01-18', 'NA', 'Namibia', 'AFRO', '165', '30363', '5', '285');
INSERT INTO public.who_global_data_import VALUES (57583, '2021-01-19', 'NA', 'Namibia', 'AFRO', '390', '30753', '8', '293');
INSERT INTO public.who_global_data_import VALUES (57584, '2021-01-20', 'NA', 'Namibia', 'AFRO', '242', '30995', '3', '296');
INSERT INTO public.who_global_data_import VALUES (57585, '2021-01-21', 'NA', 'Namibia', 'AFRO', '258', '31253', '5', '301');
INSERT INTO public.who_global_data_import VALUES (57586, '2021-01-22', 'NA', 'Namibia', 'AFRO', '262', '31515', '9', '310');
INSERT INTO public.who_global_data_import VALUES (57587, '2021-01-23', 'NA', 'Namibia', 'AFRO', '333', '31848', '1', '311');
INSERT INTO public.who_global_data_import VALUES (57588, '2021-01-24', 'NA', 'Namibia', 'AFRO', '365', '32213', '6', '317');
INSERT INTO public.who_global_data_import VALUES (57589, '2021-01-25', 'NA', 'Namibia', 'AFRO', '212', '32425', '2', '319');
INSERT INTO public.who_global_data_import VALUES (57590, '2021-01-26', 'NA', 'Namibia', 'AFRO', '225', '32650', '0', '319');
INSERT INTO public.who_global_data_import VALUES (57591, '2021-01-27', 'NA', 'Namibia', 'AFRO', '307', '32957', '9', '328');
INSERT INTO public.who_global_data_import VALUES (57592, '2021-01-28', 'NA', 'Namibia', 'AFRO', '298', '33255', '4', '332');
INSERT INTO public.who_global_data_import VALUES (57593, '2021-01-29', 'NA', 'Namibia', 'AFRO', '194', '33449', '0', '332');
INSERT INTO public.who_global_data_import VALUES (57594, '2021-01-30', 'NA', 'Namibia', 'AFRO', '243', '33692', '10', '342');
INSERT INTO public.who_global_data_import VALUES (57595, '2021-01-31', 'NA', 'Namibia', 'AFRO', '136', '33828', '8', '350');
INSERT INTO public.who_global_data_import VALUES (57596, '2021-02-01', 'NA', 'Namibia', 'AFRO', '112', '33940', '2', '352');
INSERT INTO public.who_global_data_import VALUES (57597, '2021-02-02', 'NA', 'Namibia', 'AFRO', '228', '34168', '1', '353');
INSERT INTO public.who_global_data_import VALUES (57598, '2021-02-03', 'NA', 'Namibia', 'AFRO', '102', '34270', '2', '355');
INSERT INTO public.who_global_data_import VALUES (57599, '2021-02-04', 'NA', 'Namibia', 'AFRO', '102', '34372', '4', '359');
INSERT INTO public.who_global_data_import VALUES (57600, '2021-02-05', 'NA', 'Namibia', 'AFRO', '147', '34519', '5', '364');
INSERT INTO public.who_global_data_import VALUES (57601, '2020-01-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57602, '2020-01-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57603, '2020-01-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57604, '2020-01-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57605, '2020-01-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57606, '2020-01-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57607, '2020-01-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57608, '2020-01-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57609, '2020-01-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57610, '2020-01-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57611, '2020-01-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57612, '2020-01-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57613, '2020-01-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57614, '2020-01-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57615, '2020-01-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57616, '2020-01-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57617, '2020-01-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57618, '2020-01-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57619, '2020-01-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57620, '2020-01-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57621, '2020-01-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57622, '2020-01-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57623, '2020-01-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57624, '2020-01-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57625, '2020-01-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57626, '2020-01-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57627, '2020-01-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57628, '2020-01-30', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57629, '2020-01-31', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57630, '2020-02-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57631, '2020-02-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57632, '2020-02-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57633, '2020-02-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57634, '2020-02-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57635, '2020-02-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57636, '2020-02-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57637, '2020-02-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57638, '2020-02-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57639, '2020-02-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57640, '2020-02-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57641, '2020-02-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57642, '2020-02-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57643, '2020-02-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57644, '2020-02-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57645, '2020-02-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57646, '2020-02-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57647, '2020-02-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57648, '2020-02-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57649, '2020-02-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57650, '2020-02-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57651, '2020-02-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57652, '2020-02-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57653, '2020-02-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57654, '2020-02-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57655, '2020-02-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57656, '2020-02-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57657, '2020-02-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57658, '2020-02-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57659, '2020-03-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57660, '2020-03-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57661, '2020-03-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57662, '2020-03-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57663, '2020-03-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57664, '2020-03-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57665, '2020-03-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57666, '2020-03-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57667, '2020-03-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57668, '2020-03-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57669, '2020-03-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57670, '2020-03-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57671, '2020-03-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57672, '2020-03-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57673, '2020-03-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57674, '2020-03-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57675, '2020-03-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57676, '2020-03-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57677, '2020-03-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57678, '2020-03-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57679, '2020-03-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57680, '2020-03-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57681, '2020-03-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57682, '2020-03-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57683, '2020-03-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57684, '2020-03-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57685, '2020-03-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57686, '2020-03-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57687, '2020-03-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57688, '2020-03-30', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57689, '2020-03-31', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57690, '2020-04-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57691, '2020-04-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57692, '2020-04-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57693, '2020-04-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57694, '2020-04-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57695, '2020-04-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57696, '2020-04-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57697, '2020-04-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57698, '2020-04-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57699, '2020-04-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57700, '2020-04-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57701, '2020-04-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57702, '2020-04-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57703, '2020-04-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57704, '2020-04-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57705, '2020-04-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57706, '2020-04-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57707, '2020-04-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57708, '2020-04-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57709, '2020-04-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57710, '2020-04-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57711, '2020-04-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57712, '2020-04-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57713, '2020-04-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57714, '2020-04-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57715, '2020-04-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57716, '2020-04-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57717, '2020-04-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57718, '2020-04-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57719, '2020-04-30', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57720, '2020-05-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57721, '2020-05-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57722, '2020-05-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57723, '2020-05-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57724, '2020-05-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57725, '2020-05-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57726, '2020-05-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57727, '2020-05-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57728, '2020-05-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57729, '2020-05-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57730, '2020-05-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57731, '2020-05-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57732, '2020-05-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57733, '2020-05-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57734, '2020-05-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57735, '2020-05-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57736, '2020-05-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57737, '2020-05-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57738, '2020-05-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57739, '2020-05-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57740, '2020-05-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57741, '2020-05-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57742, '2020-05-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57743, '2020-05-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57744, '2020-05-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57745, '2020-05-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57746, '2020-05-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57747, '2020-05-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57748, '2020-05-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57749, '2020-05-30', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57750, '2020-05-31', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57751, '2020-06-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57752, '2020-06-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57753, '2020-06-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57754, '2020-06-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57755, '2020-06-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57756, '2020-06-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57757, '2020-06-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57758, '2020-06-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57759, '2020-06-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57760, '2020-06-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57761, '2020-06-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57762, '2020-06-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57763, '2020-06-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57764, '2020-06-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57765, '2020-06-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57766, '2020-06-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57767, '2020-06-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57768, '2020-06-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57769, '2020-06-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57770, '2020-06-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57771, '2020-06-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57772, '2020-06-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57773, '2020-06-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57774, '2020-06-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57775, '2020-06-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57776, '2020-06-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57777, '2020-06-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57778, '2020-06-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57779, '2020-06-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57780, '2020-06-30', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57781, '2020-07-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57782, '2020-07-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57783, '2020-07-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57784, '2020-07-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57785, '2020-07-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57786, '2020-07-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57787, '2020-07-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57788, '2020-07-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57789, '2020-07-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57790, '2020-07-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57791, '2020-07-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57792, '2020-07-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57793, '2020-07-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57794, '2020-07-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57795, '2020-07-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57796, '2020-07-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57797, '2020-07-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57798, '2020-07-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57799, '2020-07-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57800, '2020-07-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57801, '2020-07-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57802, '2020-07-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57803, '2020-07-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57804, '2020-07-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57805, '2020-07-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57806, '2020-07-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57807, '2020-07-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57808, '2020-07-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57809, '2020-07-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57810, '2020-07-30', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57811, '2020-07-31', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57812, '2020-08-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57813, '2020-08-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57814, '2020-08-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57815, '2020-08-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57816, '2020-08-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57817, '2020-08-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57818, '2020-08-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57819, '2020-08-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57820, '2020-08-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57821, '2020-08-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57822, '2020-08-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57823, '2020-08-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57824, '2020-08-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57825, '2020-08-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57826, '2020-08-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57827, '2020-08-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57828, '2020-08-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57829, '2020-08-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57830, '2020-08-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57831, '2020-08-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57832, '2020-08-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57833, '2020-08-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57834, '2020-08-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57835, '2020-08-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57836, '2020-08-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57837, '2020-08-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57838, '2020-08-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57839, '2020-08-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57840, '2020-08-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57841, '2020-08-30', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57842, '2020-08-31', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57843, '2020-09-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57844, '2020-09-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57845, '2020-09-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57846, '2020-09-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57847, '2020-09-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57848, '2020-09-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57849, '2020-09-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57850, '2020-09-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57851, '2020-09-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57852, '2020-09-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57853, '2020-09-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57854, '2020-09-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57855, '2020-09-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57856, '2020-09-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57857, '2020-09-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57858, '2020-09-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57859, '2020-09-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57860, '2020-09-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57861, '2020-09-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57862, '2020-09-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57863, '2020-09-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57864, '2020-09-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57865, '2020-09-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57866, '2020-09-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57867, '2020-09-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57868, '2020-09-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57869, '2020-09-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57870, '2020-09-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57871, '2020-09-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57872, '2020-09-30', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57873, '2020-10-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57874, '2020-10-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57875, '2020-10-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57876, '2020-10-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57877, '2020-10-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57878, '2020-10-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57879, '2020-10-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57880, '2020-10-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57881, '2020-10-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57882, '2020-10-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57883, '2020-10-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57884, '2020-10-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57885, '2020-10-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57886, '2020-10-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57887, '2020-10-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57888, '2020-10-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57889, '2020-10-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57890, '2020-10-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57891, '2020-10-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57892, '2020-10-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57893, '2020-10-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57894, '2020-10-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57895, '2020-10-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57896, '2020-10-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57897, '2020-10-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57898, '2020-10-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57899, '2020-10-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57900, '2020-10-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57901, '2020-10-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57902, '2020-10-30', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57903, '2020-10-31', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57904, '2020-11-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57905, '2020-11-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57906, '2020-11-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57907, '2020-11-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57908, '2020-11-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57909, '2020-11-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57910, '2020-11-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57911, '2020-11-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57912, '2020-11-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57913, '2020-11-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57914, '2020-11-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57915, '2020-11-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57916, '2020-11-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57917, '2020-11-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57918, '2020-11-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57919, '2020-11-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57920, '2020-11-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57921, '2020-11-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57922, '2020-11-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57923, '2020-11-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57924, '2020-11-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57925, '2020-11-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57926, '2020-11-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57927, '2020-11-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57928, '2020-11-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57929, '2020-11-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57930, '2020-11-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57931, '2020-11-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57932, '2020-11-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57933, '2020-11-30', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57934, '2020-12-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57935, '2020-12-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57936, '2020-12-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57937, '2020-12-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57938, '2020-12-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57939, '2020-12-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57940, '2020-12-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57941, '2020-12-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57942, '2020-12-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57943, '2020-12-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57944, '2020-12-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57945, '2020-12-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57946, '2020-12-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57947, '2020-12-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57948, '2020-12-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57949, '2020-12-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57950, '2020-12-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57951, '2020-12-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57952, '2020-12-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57953, '2020-12-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57954, '2020-12-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57955, '2020-12-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57956, '2020-12-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57957, '2020-12-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57958, '2020-12-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57959, '2020-12-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57960, '2020-12-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57961, '2020-12-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57962, '2020-12-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57963, '2020-12-30', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57964, '2020-12-31', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57965, '2021-01-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57966, '2021-01-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57967, '2021-01-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57968, '2021-01-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57969, '2021-01-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57970, '2021-01-06', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57971, '2021-01-07', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57972, '2021-01-08', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57973, '2021-01-09', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57974, '2021-01-10', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57975, '2021-01-11', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57976, '2021-01-12', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57977, '2021-01-13', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57978, '2021-01-14', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57979, '2021-01-15', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57980, '2021-01-16', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57981, '2021-01-17', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57982, '2021-01-18', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57983, '2021-01-19', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57984, '2021-01-20', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57985, '2021-01-21', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57986, '2021-01-22', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57987, '2021-01-23', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57988, '2021-01-24', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57989, '2021-01-25', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57990, '2021-01-26', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57991, '2021-01-27', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57992, '2021-01-28', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57993, '2021-01-29', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57994, '2021-01-30', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57995, '2021-01-31', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57996, '2021-02-01', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57997, '2021-02-02', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57998, '2021-02-03', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (57999, '2021-02-04', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58000, '2021-02-05', 'NR', 'Nauru', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58001, '2020-01-03', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58002, '2020-01-04', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58003, '2020-01-05', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58004, '2020-01-06', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58005, '2020-01-07', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58006, '2020-01-08', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58007, '2020-01-09', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58008, '2020-01-10', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58009, '2020-01-11', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58010, '2020-01-12', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58011, '2020-01-13', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58012, '2020-01-14', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58013, '2020-01-15', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58014, '2020-01-16', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58015, '2020-01-17', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58016, '2020-01-18', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58017, '2020-01-19', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58018, '2020-01-20', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58019, '2020-01-21', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58020, '2020-01-22', 'NP', 'Nepal', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58021, '2020-01-23', 'NP', 'Nepal', 'SEARO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58022, '2020-01-24', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58023, '2020-01-25', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58024, '2020-01-26', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58025, '2020-01-27', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58026, '2020-01-28', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58027, '2020-01-29', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58028, '2020-01-30', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58029, '2020-01-31', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58030, '2020-02-01', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58031, '2020-02-02', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58032, '2020-02-03', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58033, '2020-02-04', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58034, '2020-02-05', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58035, '2020-02-06', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58036, '2020-02-07', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58037, '2020-02-08', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58038, '2020-02-09', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58039, '2020-02-10', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58040, '2020-02-11', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58041, '2020-02-12', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58042, '2020-02-13', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58043, '2020-02-14', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58044, '2020-02-15', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58045, '2020-02-16', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58046, '2020-02-17', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58047, '2020-02-18', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58048, '2020-02-19', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58049, '2020-02-20', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58050, '2020-02-21', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58051, '2020-02-22', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58052, '2020-02-23', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58053, '2020-02-24', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58054, '2020-02-25', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58055, '2020-02-26', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58056, '2020-02-27', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58057, '2020-02-28', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58058, '2020-02-29', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58059, '2020-03-01', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58060, '2020-03-02', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58061, '2020-03-03', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58062, '2020-03-04', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58063, '2020-03-05', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58064, '2020-03-06', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58065, '2020-03-07', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58066, '2020-03-08', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58067, '2020-03-09', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58068, '2020-03-10', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58069, '2020-03-11', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58070, '2020-03-12', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58071, '2020-03-13', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58072, '2020-03-14', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58073, '2020-03-15', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58074, '2020-03-16', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58075, '2020-03-17', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58076, '2020-03-18', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58077, '2020-03-19', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58078, '2020-03-20', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58079, '2020-03-21', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58080, '2020-03-22', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58081, '2020-03-23', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58082, '2020-03-24', 'NP', 'Nepal', 'SEARO', '-3', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58083, '2020-03-25', 'NP', 'Nepal', 'SEARO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58084, '2020-03-26', 'NP', 'Nepal', 'SEARO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58085, '2020-03-27', 'NP', 'Nepal', 'SEARO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58086, '2020-03-28', 'NP', 'Nepal', 'SEARO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58087, '2020-03-29', 'NP', 'Nepal', 'SEARO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58088, '2020-03-30', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58089, '2020-03-31', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58090, '2020-04-01', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58091, '2020-04-02', 'NP', 'Nepal', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58092, '2020-04-03', 'NP', 'Nepal', 'SEARO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58093, '2020-04-04', 'NP', 'Nepal', 'SEARO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58094, '2020-04-05', 'NP', 'Nepal', 'SEARO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58095, '2020-04-06', 'NP', 'Nepal', 'SEARO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58096, '2020-04-07', 'NP', 'Nepal', 'SEARO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58097, '2020-04-08', 'NP', 'Nepal', 'SEARO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58098, '2020-04-09', 'NP', 'Nepal', 'SEARO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58099, '2020-04-10', 'NP', 'Nepal', 'SEARO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58100, '2020-04-11', 'NP', 'Nepal', 'SEARO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58101, '2020-04-12', 'NP', 'Nepal', 'SEARO', '3', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58102, '2020-04-13', 'NP', 'Nepal', 'SEARO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58103, '2020-04-14', 'NP', 'Nepal', 'SEARO', '2', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58104, '2020-04-15', 'NP', 'Nepal', 'SEARO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58105, '2020-04-16', 'NP', 'Nepal', 'SEARO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58106, '2020-04-17', 'NP', 'Nepal', 'SEARO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58107, '2020-04-18', 'NP', 'Nepal', 'SEARO', '14', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58108, '2020-04-19', 'NP', 'Nepal', 'SEARO', '1', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58109, '2020-04-20', 'NP', 'Nepal', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58110, '2020-04-21', 'NP', 'Nepal', 'SEARO', '1', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58111, '2020-04-22', 'NP', 'Nepal', 'SEARO', '10', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58112, '2020-04-23', 'NP', 'Nepal', 'SEARO', '3', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58113, '2020-04-24', 'NP', 'Nepal', 'SEARO', '3', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58114, '2020-04-25', 'NP', 'Nepal', 'SEARO', '1', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58115, '2020-04-26', 'NP', 'Nepal', 'SEARO', '2', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58116, '2020-04-27', 'NP', 'Nepal', 'SEARO', '1', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58117, '2020-04-28', 'NP', 'Nepal', 'SEARO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58118, '2020-04-29', 'NP', 'Nepal', 'SEARO', '5', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58119, '2020-04-30', 'NP', 'Nepal', 'SEARO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58120, '2020-05-01', 'NP', 'Nepal', 'SEARO', '2', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58121, '2020-05-02', 'NP', 'Nepal', 'SEARO', '0', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58122, '2020-05-03', 'NP', 'Nepal', 'SEARO', '10', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58123, '2020-05-04', 'NP', 'Nepal', 'SEARO', '6', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58124, '2020-05-05', 'NP', 'Nepal', 'SEARO', '7', '82', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58125, '2020-05-06', 'NP', 'Nepal', 'SEARO', '17', '99', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58126, '2020-05-07', 'NP', 'Nepal', 'SEARO', '0', '99', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58127, '2020-05-08', 'NP', 'Nepal', 'SEARO', '3', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58128, '2020-05-09', 'NP', 'Nepal', 'SEARO', '7', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58129, '2020-05-10', 'NP', 'Nepal', 'SEARO', '1', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58130, '2020-05-11', 'NP', 'Nepal', 'SEARO', '11', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58131, '2020-05-12', 'NP', 'Nepal', 'SEARO', '70', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58132, '2020-05-13', 'NP', 'Nepal', 'SEARO', '52', '243', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58133, '2020-05-14', 'NP', 'Nepal', 'SEARO', '6', '249', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58134, '2020-05-15', 'NP', 'Nepal', 'SEARO', '9', '258', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58135, '2020-05-16', 'NP', 'Nepal', 'SEARO', '23', '281', '1', '1');
INSERT INTO public.who_global_data_import VALUES (58136, '2020-05-17', 'NP', 'Nepal', 'SEARO', '14', '295', '1', '2');
INSERT INTO public.who_global_data_import VALUES (58137, '2020-05-18', 'NP', 'Nepal', 'SEARO', '62', '357', '0', '2');
INSERT INTO public.who_global_data_import VALUES (58138, '2020-05-19', 'NP', 'Nepal', 'SEARO', '45', '402', '0', '2');
INSERT INTO public.who_global_data_import VALUES (58139, '2020-05-20', 'NP', 'Nepal', 'SEARO', '25', '427', '0', '2');
INSERT INTO public.who_global_data_import VALUES (58140, '2020-05-21', 'NP', 'Nepal', 'SEARO', '27', '454', '1', '3');
INSERT INTO public.who_global_data_import VALUES (58141, '2020-05-22', 'NP', 'Nepal', 'SEARO', '62', '516', '0', '3');
INSERT INTO public.who_global_data_import VALUES (58142, '2020-05-23', 'NP', 'Nepal', 'SEARO', '68', '584', '0', '3');
INSERT INTO public.who_global_data_import VALUES (58143, '2020-05-24', 'NP', 'Nepal', 'SEARO', '19', '603', '0', '3');
INSERT INTO public.who_global_data_import VALUES (58144, '2020-05-25', 'NP', 'Nepal', 'SEARO', '79', '682', '1', '4');
INSERT INTO public.who_global_data_import VALUES (58145, '2020-05-26', 'NP', 'Nepal', 'SEARO', '90', '772', '0', '4');
INSERT INTO public.who_global_data_import VALUES (58146, '2020-05-27', 'NP', 'Nepal', 'SEARO', '114', '886', '0', '4');
INSERT INTO public.who_global_data_import VALUES (58147, '2020-05-28', 'NP', 'Nepal', 'SEARO', '156', '1042', '1', '5');
INSERT INTO public.who_global_data_import VALUES (58148, '2020-05-29', 'NP', 'Nepal', 'SEARO', '170', '1212', '1', '6');
INSERT INTO public.who_global_data_import VALUES (58149, '2020-05-30', 'NP', 'Nepal', 'SEARO', '189', '1401', '0', '6');
INSERT INTO public.who_global_data_import VALUES (58150, '2020-05-31', 'NP', 'Nepal', 'SEARO', '171', '1572', '2', '8');
INSERT INTO public.who_global_data_import VALUES (58151, '2020-06-01', 'NP', 'Nepal', 'SEARO', '0', '1572', '0', '8');
INSERT INTO public.who_global_data_import VALUES (58152, '2020-06-02', 'NP', 'Nepal', 'SEARO', '239', '1811', '0', '8');
INSERT INTO public.who_global_data_import VALUES (58153, '2020-06-03', 'NP', 'Nepal', 'SEARO', '288', '2099', '0', '8');
INSERT INTO public.who_global_data_import VALUES (58154, '2020-06-04', 'NP', 'Nepal', 'SEARO', '201', '2300', '1', '9');
INSERT INTO public.who_global_data_import VALUES (58155, '2020-06-05', 'NP', 'Nepal', 'SEARO', '334', '2634', '1', '10');
INSERT INTO public.who_global_data_import VALUES (58156, '2020-06-06', 'NP', 'Nepal', 'SEARO', '278', '2912', '1', '11');
INSERT INTO public.who_global_data_import VALUES (58157, '2020-06-07', 'NP', 'Nepal', 'SEARO', '323', '3235', '2', '13');
INSERT INTO public.who_global_data_import VALUES (58158, '2020-06-08', 'NP', 'Nepal', 'SEARO', '213', '3448', '0', '13');
INSERT INTO public.who_global_data_import VALUES (58159, '2020-06-09', 'NP', 'Nepal', 'SEARO', '314', '3762', '1', '14');
INSERT INTO public.who_global_data_import VALUES (58160, '2020-06-10', 'NP', 'Nepal', 'SEARO', '323', '4085', '1', '15');
INSERT INTO public.who_global_data_import VALUES (58161, '2020-06-11', 'NP', 'Nepal', 'SEARO', '279', '4364', '0', '15');
INSERT INTO public.who_global_data_import VALUES (58162, '2020-06-12', 'NP', 'Nepal', 'SEARO', '250', '4614', '0', '15');
INSERT INTO public.who_global_data_import VALUES (58163, '2020-06-13', 'NP', 'Nepal', 'SEARO', '448', '5062', '1', '16');
INSERT INTO public.who_global_data_import VALUES (58164, '2020-06-14', 'NP', 'Nepal', 'SEARO', '273', '5335', '2', '18');
INSERT INTO public.who_global_data_import VALUES (58165, '2020-06-15', 'NP', 'Nepal', 'SEARO', '425', '5760', '1', '19');
INSERT INTO public.who_global_data_import VALUES (58166, '2020-06-16', 'NP', 'Nepal', 'SEARO', '451', '6211', '0', '19');
INSERT INTO public.who_global_data_import VALUES (58167, '2020-06-17', 'NP', 'Nepal', 'SEARO', '380', '6591', '0', '19');
INSERT INTO public.who_global_data_import VALUES (58168, '2020-06-18', 'NP', 'Nepal', 'SEARO', '586', '7177', '1', '20');
INSERT INTO public.who_global_data_import VALUES (58169, '2020-06-19', 'NP', 'Nepal', 'SEARO', '671', '7848', '2', '22');
INSERT INTO public.who_global_data_import VALUES (58170, '2020-06-20', 'NP', 'Nepal', 'SEARO', '426', '8274', '0', '22');
INSERT INTO public.who_global_data_import VALUES (58171, '2020-06-21', 'NP', 'Nepal', 'SEARO', '331', '8605', '0', '22');
INSERT INTO public.who_global_data_import VALUES (58172, '2020-06-22', 'NP', 'Nepal', 'SEARO', '421', '9026', '1', '23');
INSERT INTO public.who_global_data_import VALUES (58173, '2020-06-23', 'NP', 'Nepal', 'SEARO', '535', '9561', '0', '23');
INSERT INTO public.who_global_data_import VALUES (58174, '2020-06-24', 'NP', 'Nepal', 'SEARO', '538', '10099', '1', '24');
INSERT INTO public.who_global_data_import VALUES (58175, '2020-06-25', 'NP', 'Nepal', 'SEARO', '629', '10728', '0', '24');
INSERT INTO public.who_global_data_import VALUES (58176, '2020-06-26', 'NP', 'Nepal', 'SEARO', '434', '11162', '2', '26');
INSERT INTO public.who_global_data_import VALUES (58177, '2020-06-27', 'NP', 'Nepal', 'SEARO', '593', '11755', '1', '27');
INSERT INTO public.who_global_data_import VALUES (58178, '2020-06-28', 'NP', 'Nepal', 'SEARO', '554', '12309', '1', '28');
INSERT INTO public.who_global_data_import VALUES (58179, '2020-06-29', 'NP', 'Nepal', 'SEARO', '463', '12772', '0', '28');
INSERT INTO public.who_global_data_import VALUES (58180, '2020-06-30', 'NP', 'Nepal', 'SEARO', '476', '13248', '1', '29');
INSERT INTO public.who_global_data_import VALUES (58181, '2020-07-01', 'NP', 'Nepal', 'SEARO', '316', '13564', '0', '29');
INSERT INTO public.who_global_data_import VALUES (58182, '2020-07-02', 'NP', 'Nepal', 'SEARO', '482', '14046', '1', '30');
INSERT INTO public.who_global_data_import VALUES (58183, '2020-07-03', 'NP', 'Nepal', 'SEARO', '473', '14519', '1', '31');
INSERT INTO public.who_global_data_import VALUES (58184, '2020-07-04', 'NP', 'Nepal', 'SEARO', '740', '15259', '1', '32');
INSERT INTO public.who_global_data_import VALUES (58185, '2020-07-05', 'NP', 'Nepal', 'SEARO', '232', '15491', '2', '34');
INSERT INTO public.who_global_data_import VALUES (58186, '2020-07-06', 'NP', 'Nepal', 'SEARO', '293', '15784', '0', '34');
INSERT INTO public.who_global_data_import VALUES (58187, '2020-07-07', 'NP', 'Nepal', 'SEARO', '180', '15964', '1', '35');
INSERT INTO public.who_global_data_import VALUES (58188, '2020-07-08', 'NP', 'Nepal', 'SEARO', '204', '16168', '0', '35');
INSERT INTO public.who_global_data_import VALUES (58189, '2020-07-09', 'NP', 'Nepal', 'SEARO', '255', '16423', '0', '35');
INSERT INTO public.who_global_data_import VALUES (58190, '2020-07-10', 'NP', 'Nepal', 'SEARO', '108', '16531', '0', '35');
INSERT INTO public.who_global_data_import VALUES (58191, '2020-07-11', 'NP', 'Nepal', 'SEARO', '118', '16649', '0', '35');
INSERT INTO public.who_global_data_import VALUES (58192, '2020-07-12', 'NP', 'Nepal', 'SEARO', '70', '16719', '3', '38');
INSERT INTO public.who_global_data_import VALUES (58193, '2020-07-13', 'NP', 'Nepal', 'SEARO', '82', '16801', '0', '38');
INSERT INTO public.who_global_data_import VALUES (58194, '2020-07-14', 'NP', 'Nepal', 'SEARO', '144', '16945', '0', '38');
INSERT INTO public.who_global_data_import VALUES (58195, '2020-07-15', 'NP', 'Nepal', 'SEARO', '116', '17061', '0', '38');
INSERT INTO public.who_global_data_import VALUES (58196, '2020-07-16', 'NP', 'Nepal', 'SEARO', '116', '17177', '1', '39');
INSERT INTO public.who_global_data_import VALUES (58197, '2020-07-17', 'NP', 'Nepal', 'SEARO', '167', '17344', '0', '39');
INSERT INTO public.who_global_data_import VALUES (58198, '2020-07-18', 'NP', 'Nepal', 'SEARO', '101', '17445', '1', '40');
INSERT INTO public.who_global_data_import VALUES (58199, '2020-07-19', 'NP', 'Nepal', 'SEARO', '57', '17502', '0', '40');
INSERT INTO public.who_global_data_import VALUES (58200, '2020-07-20', 'NP', 'Nepal', 'SEARO', '156', '17658', '0', '40');
INSERT INTO public.who_global_data_import VALUES (58201, '2020-07-21', 'NP', 'Nepal', 'SEARO', '186', '17844', '0', '40');
INSERT INTO public.who_global_data_import VALUES (58202, '2020-07-22', 'NP', 'Nepal', 'SEARO', '150', '17994', '0', '40');
INSERT INTO public.who_global_data_import VALUES (58203, '2020-07-23', 'NP', 'Nepal', 'SEARO', '100', '18094', '2', '42');
INSERT INTO public.who_global_data_import VALUES (58204, '2020-07-24', 'NP', 'Nepal', 'SEARO', '147', '18241', '1', '43');
INSERT INTO public.who_global_data_import VALUES (58205, '2020-07-25', 'NP', 'Nepal', 'SEARO', '133', '18374', '1', '44');
INSERT INTO public.who_global_data_import VALUES (58206, '2020-07-26', 'NP', 'Nepal', 'SEARO', '109', '18483', '1', '45');
INSERT INTO public.who_global_data_import VALUES (58207, '2020-07-27', 'NP', 'Nepal', 'SEARO', '130', '18613', '0', '45');
INSERT INTO public.who_global_data_import VALUES (58208, '2020-07-28', 'NP', 'Nepal', 'SEARO', '139', '18752', '3', '48');
INSERT INTO public.who_global_data_import VALUES (58209, '2020-07-29', 'NP', 'Nepal', 'SEARO', '311', '19063', '1', '49');
INSERT INTO public.who_global_data_import VALUES (58210, '2020-07-30', 'NP', 'Nepal', 'SEARO', '210', '19273', '0', '49');
INSERT INTO public.who_global_data_import VALUES (58211, '2020-07-31', 'NP', 'Nepal', 'SEARO', '274', '19547', '3', '52');
INSERT INTO public.who_global_data_import VALUES (58212, '2020-08-01', 'NP', 'Nepal', 'SEARO', '224', '19771', '4', '56');
INSERT INTO public.who_global_data_import VALUES (58213, '2020-08-02', 'NP', 'Nepal', 'SEARO', '315', '20086', '0', '56');
INSERT INTO public.who_global_data_import VALUES (58214, '2020-08-03', 'NP', 'Nepal', 'SEARO', '246', '20332', '1', '57');
INSERT INTO public.who_global_data_import VALUES (58215, '2020-08-04', 'NP', 'Nepal', 'SEARO', '418', '20750', '0', '57');
INSERT INTO public.who_global_data_import VALUES (58216, '2020-08-05', 'NP', 'Nepal', 'SEARO', '259', '21009', '1', '58');
INSERT INTO public.who_global_data_import VALUES (58217, '2020-08-06', 'NP', 'Nepal', 'SEARO', '381', '21390', '2', '60');
INSERT INTO public.who_global_data_import VALUES (58218, '2020-08-07', 'NP', 'Nepal', 'SEARO', '360', '21750', '5', '65');
INSERT INTO public.who_global_data_import VALUES (58219, '2020-08-08', 'NP', 'Nepal', 'SEARO', '464', '22214', '5', '70');
INSERT INTO public.who_global_data_import VALUES (58220, '2020-08-09', 'NP', 'Nepal', 'SEARO', '378', '22592', '3', '73');
INSERT INTO public.who_global_data_import VALUES (58221, '2020-08-10', 'NP', 'Nepal', 'SEARO', '380', '22972', '2', '75');
INSERT INTO public.who_global_data_import VALUES (58222, '2020-08-11', 'NP', 'Nepal', 'SEARO', '338', '23310', '4', '79');
INSERT INTO public.who_global_data_import VALUES (58223, '2020-08-12', 'NP', 'Nepal', 'SEARO', '638', '23948', '4', '83');
INSERT INTO public.who_global_data_import VALUES (58224, '2020-08-13', 'NP', 'Nepal', 'SEARO', '484', '24432', '8', '91');
INSERT INTO public.who_global_data_import VALUES (58225, '2020-08-14', 'NP', 'Nepal', 'SEARO', '525', '24957', '4', '95');
INSERT INTO public.who_global_data_import VALUES (58226, '2020-08-15', 'NP', 'Nepal', 'SEARO', '594', '25551', '4', '99');
INSERT INTO public.who_global_data_import VALUES (58227, '2020-08-16', 'NP', 'Nepal', 'SEARO', '468', '26019', '3', '102');
INSERT INTO public.who_global_data_import VALUES (58228, '2020-08-17', 'NP', 'Nepal', 'SEARO', '641', '26660', '2', '104');
INSERT INTO public.who_global_data_import VALUES (58229, '2020-08-18', 'NP', 'Nepal', 'SEARO', '581', '27241', '3', '107');
INSERT INTO public.who_global_data_import VALUES (58230, '2020-08-19', 'NP', 'Nepal', 'SEARO', '1016', '28257', '7', '114');
INSERT INTO public.who_global_data_import VALUES (58231, '2020-08-20', 'NP', 'Nepal', 'SEARO', '681', '28938', '6', '120');
INSERT INTO public.who_global_data_import VALUES (58232, '2020-08-21', 'NP', 'Nepal', 'SEARO', '707', '29645', '6', '126');
INSERT INTO public.who_global_data_import VALUES (58233, '2020-08-22', 'NP', 'Nepal', 'SEARO', '838', '30483', '11', '137');
INSERT INTO public.who_global_data_import VALUES (58234, '2020-08-23', 'NP', 'Nepal', 'SEARO', '634', '31117', '9', '146');
INSERT INTO public.who_global_data_import VALUES (58235, '2020-08-24', 'NP', 'Nepal', 'SEARO', '818', '31935', '3', '149');
INSERT INTO public.who_global_data_import VALUES (58236, '2020-08-25', 'NP', 'Nepal', 'SEARO', '743', '32678', '8', '157');
INSERT INTO public.who_global_data_import VALUES (58237, '2020-08-26', 'NP', 'Nepal', 'SEARO', '855', '33533', '7', '164');
INSERT INTO public.who_global_data_import VALUES (58238, '2020-08-27', 'NP', 'Nepal', 'SEARO', '885', '34418', '11', '175');
INSERT INTO public.who_global_data_import VALUES (58239, '2020-08-28', 'NP', 'Nepal', 'SEARO', '1111', '35529', '8', '183');
INSERT INTO public.who_global_data_import VALUES (58240, '2020-08-29', 'NP', 'Nepal', 'SEARO', '927', '36456', '12', '195');
INSERT INTO public.who_global_data_import VALUES (58241, '2020-08-30', 'NP', 'Nepal', 'SEARO', '884', '37340', '12', '207');
INSERT INTO public.who_global_data_import VALUES (58242, '2020-08-31', 'NP', 'Nepal', 'SEARO', '1221', '38561', '14', '221');
INSERT INTO public.who_global_data_import VALUES (58243, '2020-09-01', 'NP', 'Nepal', 'SEARO', '899', '39460', '7', '228');
INSERT INTO public.who_global_data_import VALUES (58244, '2020-09-02', 'NP', 'Nepal', 'SEARO', '1069', '40529', '11', '239');
INSERT INTO public.who_global_data_import VALUES (58245, '2020-09-03', 'NP', 'Nepal', 'SEARO', '1120', '41649', '12', '251');
INSERT INTO public.who_global_data_import VALUES (58246, '2020-09-04', 'NP', 'Nepal', 'SEARO', '1228', '42877', '6', '257');
INSERT INTO public.who_global_data_import VALUES (58247, '2020-09-05', 'NP', 'Nepal', 'SEARO', '1359', '44236', '14', '271');
INSERT INTO public.who_global_data_import VALUES (58248, '2020-09-06', 'NP', 'Nepal', 'SEARO', '1041', '45277', '9', '280');
INSERT INTO public.who_global_data_import VALUES (58249, '2020-09-07', 'NP', 'Nepal', 'SEARO', '980', '46257', '9', '289');
INSERT INTO public.who_global_data_import VALUES (58250, '2020-09-08', 'NP', 'Nepal', 'SEARO', '979', '47236', '11', '300');
INSERT INTO public.who_global_data_import VALUES (58251, '2020-09-09', 'NP', 'Nepal', 'SEARO', '902', '48138', '6', '306');
INSERT INTO public.who_global_data_import VALUES (58252, '2020-09-10', 'NP', 'Nepal', 'SEARO', '1081', '49219', '6', '312');
INSERT INTO public.who_global_data_import VALUES (58253, '2020-09-11', 'NP', 'Nepal', 'SEARO', '1246', '50465', '5', '317');
INSERT INTO public.who_global_data_import VALUES (58254, '2020-09-12', 'NP', 'Nepal', 'SEARO', '1454', '51919', '5', '322');
INSERT INTO public.who_global_data_import VALUES (58255, '2020-09-13', 'NP', 'Nepal', 'SEARO', '1201', '53120', '14', '336');
INSERT INTO public.who_global_data_import VALUES (58256, '2020-09-14', 'NP', 'Nepal', 'SEARO', '1039', '54159', '9', '345');
INSERT INTO public.who_global_data_import VALUES (58257, '2020-09-15', 'NP', 'Nepal', 'SEARO', '1170', '55329', '15', '360');
INSERT INTO public.who_global_data_import VALUES (58258, '2020-09-16', 'NP', 'Nepal', 'SEARO', '1459', '56788', '11', '371');
INSERT INTO public.who_global_data_import VALUES (58259, '2020-09-17', 'NP', 'Nepal', 'SEARO', '1539', '58327', '8', '379');
INSERT INTO public.who_global_data_import VALUES (58260, '2020-09-18', 'NP', 'Nepal', 'SEARO', '1246', '59573', '4', '383');
INSERT INTO public.who_global_data_import VALUES (58261, '2020-09-19', 'NP', 'Nepal', 'SEARO', '2020', '61593', '7', '390');
INSERT INTO public.who_global_data_import VALUES (58262, '2020-09-20', 'NP', 'Nepal', 'SEARO', '1204', '62797', '11', '401');
INSERT INTO public.who_global_data_import VALUES (58263, '2020-09-21', 'NP', 'Nepal', 'SEARO', '1325', '64122', '10', '411');
INSERT INTO public.who_global_data_import VALUES (58264, '2020-09-22', 'NP', 'Nepal', 'SEARO', '1154', '65276', '16', '427');
INSERT INTO public.who_global_data_import VALUES (58265, '2020-09-23', 'NP', 'Nepal', 'SEARO', '1356', '66632', '2', '429');
INSERT INTO public.who_global_data_import VALUES (58266, '2020-09-24', 'NP', 'Nepal', 'SEARO', '1172', '67804', '7', '436');
INSERT INTO public.who_global_data_import VALUES (58267, '2020-09-25', 'NP', 'Nepal', 'SEARO', '1497', '69301', '17', '453');
INSERT INTO public.who_global_data_import VALUES (58268, '2020-09-26', 'NP', 'Nepal', 'SEARO', '1313', '70614', '6', '459');
INSERT INTO public.who_global_data_import VALUES (58269, '2020-09-27', 'NP', 'Nepal', 'SEARO', '1207', '71821', '8', '467');
INSERT INTO public.who_global_data_import VALUES (58270, '2020-09-28', 'NP', 'Nepal', 'SEARO', '1573', '73394', '10', '477');
INSERT INTO public.who_global_data_import VALUES (58271, '2020-09-29', 'NP', 'Nepal', 'SEARO', '1351', '74745', '4', '481');
INSERT INTO public.who_global_data_import VALUES (58272, '2020-09-30', 'NP', 'Nepal', 'SEARO', '1513', '76258', '10', '491');
INSERT INTO public.who_global_data_import VALUES (58273, '2020-10-01', 'NP', 'Nepal', 'SEARO', '1559', '77817', '7', '498');
INSERT INTO public.who_global_data_import VALUES (58274, '2020-10-02', 'NP', 'Nepal', 'SEARO', '1911', '79728', '11', '509');
INSERT INTO public.who_global_data_import VALUES (58275, '2020-10-03', 'NP', 'Nepal', 'SEARO', '2722', '82450', '11', '520');
INSERT INTO public.who_global_data_import VALUES (58276, '2020-10-04', 'NP', 'Nepal', 'SEARO', '2120', '84570', '8', '528');
INSERT INTO public.who_global_data_import VALUES (58277, '2020-10-05', 'NP', 'Nepal', 'SEARO', '2253', '86823', '7', '535');
INSERT INTO public.who_global_data_import VALUES (58278, '2020-10-06', 'NP', 'Nepal', 'SEARO', '2440', '89263', '19', '554');
INSERT INTO public.who_global_data_import VALUES (58279, '2020-10-07', 'NP', 'Nepal', 'SEARO', '1551', '90814', '9', '563');
INSERT INTO public.who_global_data_import VALUES (58280, '2020-10-08', 'NP', 'Nepal', 'SEARO', '3439', '94253', '15', '578');
INSERT INTO public.who_global_data_import VALUES (58281, '2020-10-09', 'NP', 'Nepal', 'SEARO', '4364', '98617', '12', '590');
INSERT INTO public.who_global_data_import VALUES (58282, '2020-10-10', 'NP', 'Nepal', 'SEARO', '2059', '100676', '10', '600');
INSERT INTO public.who_global_data_import VALUES (58283, '2020-10-11', 'NP', 'Nepal', 'SEARO', '5008', '105684', '14', '614');
INSERT INTO public.who_global_data_import VALUES (58284, '2020-10-12', 'NP', 'Nepal', 'SEARO', '2071', '107755', '22', '636');
INSERT INTO public.who_global_data_import VALUES (58285, '2020-10-13', 'NP', 'Nepal', 'SEARO', '4047', '111802', '9', '645');
INSERT INTO public.who_global_data_import VALUES (58286, '2020-10-14', 'NP', 'Nepal', 'SEARO', '3556', '115358', '18', '663');
INSERT INTO public.who_global_data_import VALUES (58287, '2020-10-15', 'NP', 'Nepal', 'SEARO', '2638', '117996', '12', '675');
INSERT INTO public.who_global_data_import VALUES (58288, '2020-10-16', 'NP', 'Nepal', 'SEARO', '3749', '121745', '19', '694');
INSERT INTO public.who_global_data_import VALUES (58289, '2020-10-17', 'NP', 'Nepal', 'SEARO', '4392', '126137', '21', '715');
INSERT INTO public.who_global_data_import VALUES (58290, '2020-10-18', 'NP', 'Nepal', 'SEARO', '3167', '129304', '12', '727');
INSERT INTO public.who_global_data_import VALUES (58291, '2020-10-19', 'NP', 'Nepal', 'SEARO', '2942', '132246', '12', '739');
INSERT INTO public.who_global_data_import VALUES (58292, '2020-10-20', 'NP', 'Nepal', 'SEARO', '3790', '136036', '18', '757');
INSERT INTO public.who_global_data_import VALUES (58293, '2020-10-21', 'NP', 'Nepal', 'SEARO', '3093', '139129', '8', '765');
INSERT INTO public.who_global_data_import VALUES (58294, '2020-10-22', 'NP', 'Nepal', 'SEARO', '5743', '144872', '26', '791');
INSERT INTO public.who_global_data_import VALUES (58295, '2020-10-23', 'NP', 'Nepal', 'SEARO', '3637', '148509', '21', '812');
INSERT INTO public.who_global_data_import VALUES (58296, '2020-10-24', 'NP', 'Nepal', 'SEARO', '4499', '153008', '17', '829');
INSERT INTO public.who_global_data_import VALUES (58297, '2020-10-25', 'NP', 'Nepal', 'SEARO', '2225', '155233', '13', '842');
INSERT INTO public.who_global_data_import VALUES (58298, '2020-10-26', 'NP', 'Nepal', 'SEARO', '2856', '158089', '5', '847');
INSERT INTO public.who_global_data_import VALUES (58299, '2020-10-27', 'NP', 'Nepal', 'SEARO', '1741', '159830', '15', '862');
INSERT INTO public.who_global_data_import VALUES (58300, '2020-10-28', 'NP', 'Nepal', 'SEARO', '570', '160400', '14', '876');
INSERT INTO public.who_global_data_import VALUES (58301, '2020-10-29', 'NP', 'Nepal', 'SEARO', '1954', '162354', '11', '887');
INSERT INTO public.who_global_data_import VALUES (58302, '2020-10-30', 'NP', 'Nepal', 'SEARO', '2364', '164718', '17', '904');
INSERT INTO public.who_global_data_import VALUES (58303, '2020-10-31', 'NP', 'Nepal', 'SEARO', '3517', '168235', '16', '920');
INSERT INTO public.who_global_data_import VALUES (58304, '2020-11-01', 'NP', 'Nepal', 'SEARO', '2508', '170743', '17', '937');
INSERT INTO public.who_global_data_import VALUES (58305, '2020-11-02', 'NP', 'Nepal', 'SEARO', '2824', '173567', '23', '960');
INSERT INTO public.who_global_data_import VALUES (58306, '2020-11-03', 'NP', 'Nepal', 'SEARO', '2933', '176500', '24', '984');
INSERT INTO public.who_global_data_import VALUES (58307, '2020-11-04', 'NP', 'Nepal', 'SEARO', '3114', '179614', '20', '1004');
INSERT INTO public.who_global_data_import VALUES (58308, '2020-11-05', 'NP', 'Nepal', 'SEARO', '3309', '182923', '30', '1034');
INSERT INTO public.who_global_data_import VALUES (58309, '2020-11-06', 'NP', 'Nepal', 'SEARO', '3051', '185974', '18', '1052');
INSERT INTO public.who_global_data_import VALUES (58310, '2020-11-07', 'NP', 'Nepal', 'SEARO', '2909', '188883', '18', '1070');
INSERT INTO public.who_global_data_import VALUES (58311, '2020-11-08', 'NP', 'Nepal', 'SEARO', '2753', '191636', '17', '1087');
INSERT INTO public.who_global_data_import VALUES (58312, '2020-11-09', 'NP', 'Nepal', 'SEARO', '2817', '194453', '21', '1108');
INSERT INTO public.who_global_data_import VALUES (58313, '2020-11-10', 'NP', 'Nepal', 'SEARO', '2571', '197024', '18', '1126');
INSERT INTO public.who_global_data_import VALUES (58314, '2020-11-11', 'NP', 'Nepal', 'SEARO', '2736', '199760', '22', '1148');
INSERT INTO public.who_global_data_import VALUES (58315, '2020-11-12', 'NP', 'Nepal', 'SEARO', '2569', '202329', '26', '1174');
INSERT INTO public.who_global_data_import VALUES (58316, '2020-11-13', 'NP', 'Nepal', 'SEARO', '1913', '204242', '15', '1189');
INSERT INTO public.who_global_data_import VALUES (58317, '2020-11-14', 'NP', 'Nepal', 'SEARO', '2111', '206353', '13', '1202');
INSERT INTO public.who_global_data_import VALUES (58318, '2020-11-15', 'NP', 'Nepal', 'SEARO', '1946', '208299', '13', '1215');
INSERT INTO public.who_global_data_import VALUES (58319, '2020-11-16', 'NP', 'Nepal', 'SEARO', '1477', '209776', '6', '1221');
INSERT INTO public.who_global_data_import VALUES (58320, '2020-11-17', 'NP', 'Nepal', 'SEARO', '1197', '210973', '9', '1230');
INSERT INTO public.who_global_data_import VALUES (58321, '2020-11-18', 'NP', 'Nepal', 'SEARO', '502', '211475', '17', '1247');
INSERT INTO public.who_global_data_import VALUES (58322, '2020-11-19', 'NP', 'Nepal', 'SEARO', '1442', '212917', '12', '1259');
INSERT INTO public.who_global_data_import VALUES (58323, '2020-11-20', 'NP', 'Nepal', 'SEARO', '2103', '215020', '17', '1276');
INSERT INTO public.who_global_data_import VALUES (58324, '2020-11-21', 'NP', 'Nepal', 'SEARO', '1945', '216965', '22', '1298');
INSERT INTO public.who_global_data_import VALUES (58325, '2020-11-22', 'NP', 'Nepal', 'SEARO', '1674', '218639', '7', '1305');
INSERT INTO public.who_global_data_import VALUES (58326, '2020-11-23', 'NP', 'Nepal', 'SEARO', '1669', '220308', '16', '1321');
INSERT INTO public.who_global_data_import VALUES (58327, '2020-11-24', 'NP', 'Nepal', 'SEARO', '1980', '222288', '16', '1337');
INSERT INTO public.who_global_data_import VALUES (58328, '2020-11-25', 'NP', 'Nepal', 'SEARO', '1790', '224078', '24', '1361');
INSERT INTO public.who_global_data_import VALUES (58329, '2020-11-26', 'NP', 'Nepal', 'SEARO', '1948', '226026', '28', '1389');
INSERT INTO public.who_global_data_import VALUES (58330, '2020-11-27', 'NP', 'Nepal', 'SEARO', '1614', '227640', '23', '1412');
INSERT INTO public.who_global_data_import VALUES (58331, '2020-11-28', 'NP', 'Nepal', 'SEARO', '1703', '229343', '23', '1435');
INSERT INTO public.who_global_data_import VALUES (58332, '2020-11-29', 'NP', 'Nepal', 'SEARO', '1380', '230723', '19', '1454');
INSERT INTO public.who_global_data_import VALUES (58333, '2020-11-30', 'NP', 'Nepal', 'SEARO', '1255', '231978', '25', '1479');
INSERT INTO public.who_global_data_import VALUES (58334, '2020-12-01', 'NP', 'Nepal', 'SEARO', '1474', '233452', '29', '1508');
INSERT INTO public.who_global_data_import VALUES (58335, '2020-12-02', 'NP', 'Nepal', 'SEARO', '1304', '234756', '21', '1529');
INSERT INTO public.who_global_data_import VALUES (58336, '2020-12-03', 'NP', 'Nepal', 'SEARO', '1490', '236246', '9', '1538');
INSERT INTO public.who_global_data_import VALUES (58337, '2020-12-04', 'NP', 'Nepal', 'SEARO', '1343', '237589', '13', '1551');
INSERT INTO public.who_global_data_import VALUES (58338, '2020-12-05', 'NP', 'Nepal', 'SEARO', '1272', '238861', '16', '1567');
INSERT INTO public.who_global_data_import VALUES (58339, '2020-12-06', 'NP', 'Nepal', 'SEARO', '1024', '239885', '10', '1577');
INSERT INTO public.who_global_data_import VALUES (58340, '2020-12-07', 'NP', 'Nepal', 'SEARO', '1096', '240981', '17', '1594');
INSERT INTO public.who_global_data_import VALUES (58341, '2020-12-08', 'NP', 'Nepal', 'SEARO', '1014', '241995', '20', '1614');
INSERT INTO public.who_global_data_import VALUES (58342, '2020-12-09', 'NP', 'Nepal', 'SEARO', '1382', '243377', '23', '1637');
INSERT INTO public.who_global_data_import VALUES (58343, '2020-12-10', 'NP', 'Nepal', 'SEARO', '1056', '244433', '14', '1651');
INSERT INTO public.who_global_data_import VALUES (58344, '2020-12-11', 'NP', 'Nepal', 'SEARO', '1217', '245650', '12', '1663');
INSERT INTO public.who_global_data_import VALUES (58345, '2020-12-12', 'NP', 'Nepal', 'SEARO', '1044', '246694', '11', '1674');
INSERT INTO public.who_global_data_import VALUES (58346, '2020-12-13', 'NP', 'Nepal', 'SEARO', '899', '247593', '15', '1689');
INSERT INTO public.who_global_data_import VALUES (58347, '2020-12-14', 'NP', 'Nepal', 'SEARO', '830', '248423', '9', '1698');
INSERT INTO public.who_global_data_import VALUES (58348, '2020-12-15', 'NP', 'Nepal', 'SEARO', '821', '249244', '18', '1716');
INSERT INTO public.who_global_data_import VALUES (60027, '2020-01-29', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58349, '2020-12-16', 'NP', 'Nepal', 'SEARO', '936', '250180', '14', '1730');
INSERT INTO public.who_global_data_import VALUES (58350, '2020-12-17', 'NP', 'Nepal', 'SEARO', '736', '250916', '13', '1743');
INSERT INTO public.who_global_data_import VALUES (58351, '2020-12-18', 'NP', 'Nepal', 'SEARO', '776', '251692', '6', '1749');
INSERT INTO public.who_global_data_import VALUES (58352, '2020-12-19', 'NP', 'Nepal', 'SEARO', '782', '252474', '16', '1765');
INSERT INTO public.who_global_data_import VALUES (58353, '2020-12-20', 'NP', 'Nepal', 'SEARO', '710', '253184', '12', '1777');
INSERT INTO public.who_global_data_import VALUES (58354, '2020-12-21', 'NP', 'Nepal', 'SEARO', '588', '253772', '11', '1788');
INSERT INTO public.who_global_data_import VALUES (58355, '2020-12-22', 'NP', 'Nepal', 'SEARO', '742', '254514', '7', '1795');
INSERT INTO public.who_global_data_import VALUES (58356, '2020-12-23', 'NP', 'Nepal', 'SEARO', '722', '255236', '3', '1798');
INSERT INTO public.who_global_data_import VALUES (58357, '2020-12-24', 'NP', 'Nepal', 'SEARO', '743', '255979', '5', '1803');
INSERT INTO public.who_global_data_import VALUES (58358, '2020-12-25', 'NP', 'Nepal', 'SEARO', '613', '256592', '5', '1808');
INSERT INTO public.who_global_data_import VALUES (58359, '2020-12-26', 'NP', 'Nepal', 'SEARO', '608', '257200', '9', '1817');
INSERT INTO public.who_global_data_import VALUES (58360, '2020-12-27', 'NP', 'Nepal', 'SEARO', '500', '257700', '2', '1819');
INSERT INTO public.who_global_data_import VALUES (58361, '2020-12-28', 'NP', 'Nepal', 'SEARO', '481', '258181', '6', '1825');
INSERT INTO public.who_global_data_import VALUES (58362, '2020-12-29', 'NP', 'Nepal', 'SEARO', '659', '258840', '7', '1832');
INSERT INTO public.who_global_data_import VALUES (58363, '2020-12-30', 'NP', 'Nepal', 'SEARO', '708', '259548', '8', '1840');
INSERT INTO public.who_global_data_import VALUES (58364, '2020-12-31', 'NP', 'Nepal', 'SEARO', '511', '260059', '7', '1847');
INSERT INTO public.who_global_data_import VALUES (58365, '2021-01-01', 'NP', 'Nepal', 'SEARO', '534', '260593', '9', '1856');
INSERT INTO public.who_global_data_import VALUES (58366, '2021-01-02', 'NP', 'Nepal', 'SEARO', '426', '261019', '8', '1864');
INSERT INTO public.who_global_data_import VALUES (58367, '2021-01-03', 'NP', 'Nepal', 'SEARO', '419', '261438', '6', '1870');
INSERT INTO public.who_global_data_import VALUES (58368, '2021-01-04', 'NP', 'Nepal', 'SEARO', '421', '261859', '8', '1878');
INSERT INTO public.who_global_data_import VALUES (58369, '2021-01-05', 'NP', 'Nepal', 'SEARO', '403', '262262', '7', '1885');
INSERT INTO public.who_global_data_import VALUES (58370, '2021-01-06', 'NP', 'Nepal', 'SEARO', '522', '262784', '8', '1893');
INSERT INTO public.who_global_data_import VALUES (58371, '2021-01-07', 'NP', 'Nepal', 'SEARO', '409', '263193', '6', '1899');
INSERT INTO public.who_global_data_import VALUES (58372, '2021-01-08', 'NP', 'Nepal', 'SEARO', '412', '263605', '4', '1903');
INSERT INTO public.who_global_data_import VALUES (58373, '2021-01-09', 'NP', 'Nepal', 'SEARO', '554', '264159', '6', '1909');
INSERT INTO public.who_global_data_import VALUES (58374, '2021-01-10', 'NP', 'Nepal', 'SEARO', '362', '264521', '3', '1912');
INSERT INTO public.who_global_data_import VALUES (58375, '2021-01-11', 'NP', 'Nepal', 'SEARO', '259', '264780', '5', '1917');
INSERT INTO public.who_global_data_import VALUES (58376, '2021-01-12', 'NP', 'Nepal', 'SEARO', '488', '265268', '10', '1927');
INSERT INTO public.who_global_data_import VALUES (58377, '2021-01-13', 'NP', 'Nepal', 'SEARO', '430', '265698', '5', '1932');
INSERT INTO public.who_global_data_import VALUES (58378, '2021-01-14', 'NP', 'Nepal', 'SEARO', '445', '266143', '5', '1937');
INSERT INTO public.who_global_data_import VALUES (58379, '2021-01-15', 'NP', 'Nepal', 'SEARO', '403', '266546', '6', '1943');
INSERT INTO public.who_global_data_import VALUES (58380, '2021-01-16', 'NP', 'Nepal', 'SEARO', '270', '266816', '5', '1948');
INSERT INTO public.who_global_data_import VALUES (58381, '2021-01-17', 'NP', 'Nepal', 'SEARO', '240', '267056', '6', '1954');
INSERT INTO public.who_global_data_import VALUES (58382, '2021-01-18', 'NP', 'Nepal', 'SEARO', '266', '267322', '5', '1959');
INSERT INTO public.who_global_data_import VALUES (58383, '2021-01-19', 'NP', 'Nepal', 'SEARO', '322', '267644', '6', '1965');
INSERT INTO public.who_global_data_import VALUES (58384, '2021-01-20', 'NP', 'Nepal', 'SEARO', '348', '267992', '4', '1969');
INSERT INTO public.who_global_data_import VALUES (58385, '2021-01-21', 'NP', 'Nepal', 'SEARO', '318', '268310', '6', '1975');
INSERT INTO public.who_global_data_import VALUES (58386, '2021-01-22', 'NP', 'Nepal', 'SEARO', '336', '268646', '4', '1979');
INSERT INTO public.who_global_data_import VALUES (58387, '2021-01-23', 'NP', 'Nepal', 'SEARO', '302', '268948', '7', '1986');
INSERT INTO public.who_global_data_import VALUES (58388, '2021-01-24', 'NP', 'Nepal', 'SEARO', '232', '269180', '8', '1994');
INSERT INTO public.who_global_data_import VALUES (58389, '2021-01-25', 'NP', 'Nepal', 'SEARO', '270', '269450', '7', '2001');
INSERT INTO public.who_global_data_import VALUES (58390, '2021-01-26', 'NP', 'Nepal', 'SEARO', '339', '269789', '10', '2011');
INSERT INTO public.who_global_data_import VALUES (58391, '2021-01-27', 'NP', 'Nepal', 'SEARO', '303', '270092', '6', '2017');
INSERT INTO public.who_global_data_import VALUES (58392, '2021-01-28', 'NP', 'Nepal', 'SEARO', '283', '270375', '3', '2020');
INSERT INTO public.who_global_data_import VALUES (58393, '2021-01-29', 'NP', 'Nepal', 'SEARO', '213', '270588', '0', '2020');
INSERT INTO public.who_global_data_import VALUES (58394, '2021-01-30', 'NP', 'Nepal', 'SEARO', '157', '270745', '5', '2025');
INSERT INTO public.who_global_data_import VALUES (58395, '2021-01-31', 'NP', 'Nepal', 'SEARO', '109', '270854', '2', '2027');
INSERT INTO public.who_global_data_import VALUES (58396, '2021-02-01', 'NP', 'Nepal', 'SEARO', '105', '270959', '2', '2029');
INSERT INTO public.who_global_data_import VALUES (58397, '2021-02-02', 'NP', 'Nepal', 'SEARO', '159', '271118', '0', '2029');
INSERT INTO public.who_global_data_import VALUES (58398, '2021-02-03', 'NP', 'Nepal', 'SEARO', '171', '271289', '1', '2030');
INSERT INTO public.who_global_data_import VALUES (58399, '2021-02-04', 'NP', 'Nepal', 'SEARO', '142', '271431', '1', '2031');
INSERT INTO public.who_global_data_import VALUES (58400, '2021-02-05', 'NP', 'Nepal', 'SEARO', '171', '271602', '2', '2033');
INSERT INTO public.who_global_data_import VALUES (58401, '2020-01-03', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58402, '2020-01-04', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58403, '2020-01-05', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58404, '2020-01-06', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58405, '2020-01-07', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58406, '2020-01-08', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58407, '2020-01-09', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58408, '2020-01-10', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58409, '2020-01-11', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58410, '2020-01-12', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58411, '2020-01-13', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58412, '2020-01-14', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58413, '2020-01-15', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58414, '2020-01-16', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58415, '2020-01-17', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58416, '2020-01-18', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58417, '2020-01-19', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58418, '2020-01-20', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58419, '2020-01-21', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58420, '2020-01-22', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58421, '2020-01-23', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58422, '2020-01-24', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58423, '2020-01-25', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58424, '2020-01-26', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58425, '2020-01-27', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58426, '2020-01-28', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58427, '2020-01-29', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58428, '2020-01-30', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58429, '2020-01-31', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58430, '2020-02-01', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58431, '2020-02-02', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58432, '2020-02-03', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58433, '2020-02-04', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58434, '2020-02-05', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58435, '2020-02-06', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58436, '2020-02-07', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58437, '2020-02-08', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58438, '2020-02-09', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58439, '2020-02-10', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58440, '2020-02-11', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58441, '2020-02-12', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58442, '2020-02-13', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58443, '2020-02-14', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58444, '2020-02-15', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58445, '2020-02-16', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58446, '2020-02-17', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58447, '2020-02-18', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58448, '2020-02-19', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58449, '2020-02-20', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58450, '2020-02-21', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58451, '2020-02-22', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58452, '2020-02-23', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58453, '2020-02-24', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58454, '2020-02-25', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58455, '2020-02-26', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58456, '2020-02-27', 'NL', 'Netherlands', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58457, '2020-02-28', 'NL', 'Netherlands', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58458, '2020-02-29', 'NL', 'Netherlands', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58459, '2020-03-01', 'NL', 'Netherlands', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58460, '2020-03-02', 'NL', 'Netherlands', 'EURO', '3', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58461, '2020-03-03', 'NL', 'Netherlands', 'EURO', '5', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58462, '2020-03-04', 'NL', 'Netherlands', 'EURO', '4', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58463, '2020-03-05', 'NL', 'Netherlands', 'EURO', '10', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58464, '2020-03-06', 'NL', 'Netherlands', 'EURO', '17', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58465, '2020-03-07', 'NL', 'Netherlands', 'EURO', '40', '81', '1', '1');
INSERT INTO public.who_global_data_import VALUES (58466, '2020-03-08', 'NL', 'Netherlands', 'EURO', '50', '131', '0', '1');
INSERT INTO public.who_global_data_import VALUES (58467, '2020-03-09', 'NL', 'Netherlands', 'EURO', '32', '163', '1', '2');
INSERT INTO public.who_global_data_import VALUES (58468, '2020-03-10', 'NL', 'Netherlands', 'EURO', '61', '224', '1', '3');
INSERT INTO public.who_global_data_import VALUES (58469, '2020-03-11', 'NL', 'Netherlands', 'EURO', '130', '354', '0', '3');
INSERT INTO public.who_global_data_import VALUES (58470, '2020-03-12', 'NL', 'Netherlands', 'EURO', '123', '477', '1', '4');
INSERT INTO public.who_global_data_import VALUES (58471, '2020-03-13', 'NL', 'Netherlands', 'EURO', '127', '604', '0', '4');
INSERT INTO public.who_global_data_import VALUES (58472, '2020-03-14', 'NL', 'Netherlands', 'EURO', '113', '717', '2', '6');
INSERT INTO public.who_global_data_import VALUES (58473, '2020-03-15', 'NL', 'Netherlands', 'EURO', '219', '936', '4', '10');
INSERT INTO public.who_global_data_import VALUES (58474, '2020-03-16', 'NL', 'Netherlands', 'EURO', '173', '1109', '7', '17');
INSERT INTO public.who_global_data_import VALUES (58475, '2020-03-17', 'NL', 'Netherlands', 'EURO', '270', '1379', '4', '21');
INSERT INTO public.who_global_data_import VALUES (58476, '2020-03-18', 'NL', 'Netherlands', 'EURO', '288', '1667', '17', '38');
INSERT INTO public.who_global_data_import VALUES (58477, '2020-03-19', 'NL', 'Netherlands', 'EURO', '347', '2014', '15', '53');
INSERT INTO public.who_global_data_import VALUES (58478, '2020-03-20', 'NL', 'Netherlands', 'EURO', '396', '2410', '23', '76');
INSERT INTO public.who_global_data_import VALUES (58479, '2020-03-21', 'NL', 'Netherlands', 'EURO', '533', '2943', '28', '104');
INSERT INTO public.who_global_data_import VALUES (58480, '2020-03-22', 'NL', 'Netherlands', 'EURO', '637', '3580', '30', '134');
INSERT INTO public.who_global_data_import VALUES (58481, '2020-03-23', 'NL', 'Netherlands', 'EURO', '605', '4185', '44', '178');
INSERT INTO public.who_global_data_import VALUES (58482, '2020-03-24', 'NL', 'Netherlands', 'EURO', '553', '4738', '32', '210');
INSERT INTO public.who_global_data_import VALUES (58483, '2020-03-25', 'NL', 'Netherlands', 'EURO', '749', '5487', '62', '272');
INSERT INTO public.who_global_data_import VALUES (58484, '2020-03-26', 'NL', 'Netherlands', 'EURO', '843', '6330', '76', '348');
INSERT INTO public.who_global_data_import VALUES (58485, '2020-03-27', 'NL', 'Netherlands', 'EURO', '1007', '7337', '71', '419');
INSERT INTO public.who_global_data_import VALUES (58486, '2020-03-28', 'NL', 'Netherlands', 'EURO', '1167', '8504', '122', '541');
INSERT INTO public.who_global_data_import VALUES (58487, '2020-03-29', 'NL', 'Netherlands', 'EURO', '1146', '9650', '89', '630');
INSERT INTO public.who_global_data_import VALUES (58488, '2020-03-30', 'NL', 'Netherlands', 'EURO', '1092', '10742', '122', '752');
INSERT INTO public.who_global_data_import VALUES (58489, '2020-03-31', 'NL', 'Netherlands', 'EURO', '874', '11616', '84', '836');
INSERT INTO public.who_global_data_import VALUES (58490, '2020-04-01', 'NL', 'Netherlands', 'EURO', '836', '12452', '168', '1004');
INSERT INTO public.who_global_data_import VALUES (58491, '2020-04-02', 'NL', 'Netherlands', 'EURO', '1008', '13460', '133', '1137');
INSERT INTO public.who_global_data_import VALUES (58492, '2020-04-03', 'NL', 'Netherlands', 'EURO', '1083', '14543', '155', '1292');
INSERT INTO public.who_global_data_import VALUES (58493, '2020-04-04', 'NL', 'Netherlands', 'EURO', '1020', '15563', '145', '1437');
INSERT INTO public.who_global_data_import VALUES (58494, '2020-04-05', 'NL', 'Netherlands', 'EURO', '1002', '16565', '187', '1624');
INSERT INTO public.who_global_data_import VALUES (58495, '2020-04-06', 'NL', 'Netherlands', 'EURO', '1099', '17664', '103', '1727');
INSERT INTO public.who_global_data_import VALUES (58496, '2020-04-07', 'NL', 'Netherlands', 'EURO', '945', '18609', '91', '1818');
INSERT INTO public.who_global_data_import VALUES (58497, '2020-04-08', 'NL', 'Netherlands', 'EURO', '782', '19391', '231', '2049');
INSERT INTO public.who_global_data_import VALUES (58498, '2020-04-09', 'NL', 'Netherlands', 'EURO', '959', '20350', '157', '2206');
INSERT INTO public.who_global_data_import VALUES (58499, '2020-04-10', 'NL', 'Netherlands', 'EURO', '1209', '21559', '143', '2349');
INSERT INTO public.who_global_data_import VALUES (58500, '2020-04-11', 'NL', 'Netherlands', 'EURO', '1327', '22886', '119', '2468');
INSERT INTO public.who_global_data_import VALUES (58501, '2020-04-12', 'NL', 'Netherlands', 'EURO', '1301', '24187', '142', '2610');
INSERT INTO public.who_global_data_import VALUES (58502, '2020-04-13', 'NL', 'Netherlands', 'EURO', '1171', '25358', '96', '2706');
INSERT INTO public.who_global_data_import VALUES (58503, '2020-04-14', 'NL', 'Netherlands', 'EURO', '959', '26317', '74', '2780');
INSERT INTO public.who_global_data_import VALUES (58504, '2020-04-15', 'NL', 'Netherlands', 'EURO', '862', '27179', '107', '2887');
INSERT INTO public.who_global_data_import VALUES (58505, '2020-04-16', 'NL', 'Netherlands', 'EURO', '730', '27909', '202', '3089');
INSERT INTO public.who_global_data_import VALUES (58506, '2020-04-17', 'NL', 'Netherlands', 'EURO', '1071', '28980', '177', '3266');
INSERT INTO public.who_global_data_import VALUES (58507, '2020-04-18', 'NL', 'Netherlands', 'EURO', '1234', '30214', '153', '3419');
INSERT INTO public.who_global_data_import VALUES (58508, '2020-04-19', 'NL', 'Netherlands', 'EURO', '1186', '31400', '149', '3568');
INSERT INTO public.who_global_data_import VALUES (58509, '2020-04-20', 'NL', 'Netherlands', 'EURO', '1023', '32423', '79', '3647');
INSERT INTO public.who_global_data_import VALUES (58510, '2020-04-21', 'NL', 'Netherlands', 'EURO', '748', '33171', '59', '3706');
INSERT INTO public.who_global_data_import VALUES (58511, '2020-04-22', 'NL', 'Netherlands', 'EURO', '716', '33887', '163', '3869');
INSERT INTO public.who_global_data_import VALUES (58512, '2020-04-23', 'NL', 'Netherlands', 'EURO', '708', '34595', '134', '4003');
INSERT INTO public.who_global_data_import VALUES (58513, '2020-04-24', 'NL', 'Netherlands', 'EURO', '876', '35471', '133', '4136');
INSERT INTO public.who_global_data_import VALUES (58514, '2020-04-25', 'NL', 'Netherlands', 'EURO', '805', '36276', '111', '4247');
INSERT INTO public.who_global_data_import VALUES (58515, '2020-04-26', 'NL', 'Netherlands', 'EURO', '647', '36923', '127', '4374');
INSERT INTO public.who_global_data_import VALUES (58516, '2020-04-27', 'NL', 'Netherlands', 'EURO', '651', '37574', '64', '4438');
INSERT INTO public.who_global_data_import VALUES (58517, '2020-04-28', 'NL', 'Netherlands', 'EURO', '405', '37979', '44', '4482');
INSERT INTO public.who_global_data_import VALUES (58518, '2020-04-29', 'NL', 'Netherlands', 'EURO', '193', '38172', '47', '4529');
INSERT INTO public.who_global_data_import VALUES (58519, '2020-04-30', 'NL', 'Netherlands', 'EURO', '388', '38560', '141', '4670');
INSERT INTO public.who_global_data_import VALUES (58520, '2020-05-01', 'NL', 'Netherlands', 'EURO', '507', '39067', '85', '4755');
INSERT INTO public.who_global_data_import VALUES (58521, '2020-05-02', 'NL', 'Netherlands', 'EURO', '478', '39545', '101', '4856');
INSERT INTO public.who_global_data_import VALUES (58522, '2020-05-03', 'NL', 'Netherlands', 'EURO', '437', '39982', '87', '4943');
INSERT INTO public.who_global_data_import VALUES (58523, '2020-05-04', 'NL', 'Netherlands', 'EURO', '338', '40320', '82', '5025');
INSERT INTO public.who_global_data_import VALUES (58524, '2020-05-05', 'NL', 'Netherlands', 'EURO', '201', '40521', '15', '5040');
INSERT INTO public.who_global_data_import VALUES (58525, '2020-05-06', 'NL', 'Netherlands', 'EURO', '319', '40840', '90', '5130');
INSERT INTO public.who_global_data_import VALUES (58526, '2020-05-07', 'NL', 'Netherlands', 'EURO', '319', '41159', '33', '5163');
INSERT INTO public.who_global_data_import VALUES (58527, '2020-05-08', 'NL', 'Netherlands', 'EURO', '361', '41520', '89', '5252');
INSERT INTO public.who_global_data_import VALUES (58528, '2020-05-09', 'NL', 'Netherlands', 'EURO', '320', '41840', '76', '5328');
INSERT INTO public.who_global_data_import VALUES (58529, '2020-05-10', 'NL', 'Netherlands', 'EURO', '288', '42128', '66', '5394');
INSERT INTO public.who_global_data_import VALUES (58530, '2020-05-11', 'NL', 'Netherlands', 'EURO', '242', '42370', '19', '5413');
INSERT INTO public.who_global_data_import VALUES (58531, '2020-05-12', 'NL', 'Netherlands', 'EURO', '179', '42549', '7', '5420');
INSERT INTO public.who_global_data_import VALUES (58532, '2020-05-13', 'NL', 'Netherlands', 'EURO', '195', '42744', '56', '5476');
INSERT INTO public.who_global_data_import VALUES (58533, '2020-05-14', 'NL', 'Netherlands', 'EURO', '223', '42967', '52', '5528');
INSERT INTO public.who_global_data_import VALUES (58534, '2020-05-15', 'NL', 'Netherlands', 'EURO', '274', '43241', '30', '5558');
INSERT INTO public.who_global_data_import VALUES (58535, '2020-05-16', 'NL', 'Netherlands', 'EURO', '202', '43443', '50', '5608');
INSERT INTO public.who_global_data_import VALUES (58536, '2020-05-17', 'NL', 'Netherlands', 'EURO', '194', '43637', '34', '5642');
INSERT INTO public.who_global_data_import VALUES (58537, '2020-05-18', 'NL', 'Netherlands', 'EURO', '125', '43762', '10', '5652');
INSERT INTO public.who_global_data_import VALUES (58538, '2020-05-19', 'NL', 'Netherlands', 'EURO', '148', '43910', '13', '5665');
INSERT INTO public.who_global_data_import VALUES (58539, '2020-05-20', 'NL', 'Netherlands', 'EURO', '111', '44021', '24', '5689');
INSERT INTO public.who_global_data_import VALUES (58540, '2020-05-21', 'NL', 'Netherlands', 'EURO', '187', '44208', '33', '5722');
INSERT INTO public.who_global_data_import VALUES (58541, '2020-05-22', 'NL', 'Netherlands', 'EURO', '254', '44462', '29', '5751');
INSERT INTO public.who_global_data_import VALUES (58542, '2020-05-23', 'NL', 'Netherlands', 'EURO', '184', '44646', '10', '5761');
INSERT INTO public.who_global_data_import VALUES (58543, '2020-05-24', 'NL', 'Netherlands', 'EURO', '177', '44823', '23', '5784');
INSERT INTO public.who_global_data_import VALUES (58544, '2020-05-25', 'NL', 'Netherlands', 'EURO', '173', '44996', '11', '5795');
INSERT INTO public.who_global_data_import VALUES (58545, '2020-05-26', 'NL', 'Netherlands', 'EURO', '213', '45209', '9', '5804');
INSERT INTO public.who_global_data_import VALUES (58546, '2020-05-27', 'NL', 'Netherlands', 'EURO', '129', '45338', '20', '5824');
INSERT INTO public.who_global_data_import VALUES (58547, '2020-05-28', 'NL', 'Netherlands', 'EURO', '194', '45532', '19', '5843');
INSERT INTO public.who_global_data_import VALUES (58548, '2020-05-29', 'NL', 'Netherlands', 'EURO', '179', '45711', '27', '5870');
INSERT INTO public.who_global_data_import VALUES (58549, '2020-05-30', 'NL', 'Netherlands', 'EURO', '178', '45889', '29', '5899');
INSERT INTO public.who_global_data_import VALUES (58550, '2020-05-31', 'NL', 'Netherlands', 'EURO', '141', '46030', '20', '5919');
INSERT INTO public.who_global_data_import VALUES (58551, '2020-06-01', 'NL', 'Netherlands', 'EURO', '176', '46206', '4', '5923');
INSERT INTO public.who_global_data_import VALUES (58552, '2020-06-02', 'NL', 'Netherlands', 'EURO', '105', '46311', '5', '5928');
INSERT INTO public.who_global_data_import VALUES (58553, '2020-06-03', 'NL', 'Netherlands', 'EURO', '95', '46406', '4', '5932');
INSERT INTO public.who_global_data_import VALUES (58554, '2020-06-04', 'NL', 'Netherlands', 'EURO', '93', '46499', '13', '5945');
INSERT INTO public.who_global_data_import VALUES (58555, '2020-06-05', 'NL', 'Netherlands', 'EURO', '188', '46687', '12', '5957');
INSERT INTO public.who_global_data_import VALUES (58556, '2020-06-06', 'NL', 'Netherlands', 'EURO', '217', '46904', '15', '5972');
INSERT INTO public.who_global_data_import VALUES (58557, '2020-06-07', 'NL', 'Netherlands', 'EURO', '190', '47094', '8', '5980');
INSERT INTO public.who_global_data_import VALUES (58558, '2020-06-08', 'NL', 'Netherlands', 'EURO', '239', '47333', '3', '5983');
INSERT INTO public.who_global_data_import VALUES (58559, '2020-06-09', 'NL', 'Netherlands', 'EURO', '166', '47499', '3', '5986');
INSERT INTO public.who_global_data_import VALUES (58560, '2020-06-10', 'NL', 'Netherlands', 'EURO', '164', '47663', '13', '5999');
INSERT INTO public.who_global_data_import VALUES (58561, '2020-06-11', 'NL', 'Netherlands', 'EURO', '181', '47844', '14', '6013');
INSERT INTO public.who_global_data_import VALUES (58562, '2020-06-12', 'NL', 'Netherlands', 'EURO', '162', '48006', '4', '6017');
INSERT INTO public.who_global_data_import VALUES (58563, '2020-06-13', 'NL', 'Netherlands', 'EURO', '207', '48213', '7', '6024');
INSERT INTO public.who_global_data_import VALUES (58564, '2020-06-14', 'NL', 'Netherlands', 'EURO', '181', '48394', '6', '6030');
INSERT INTO public.who_global_data_import VALUES (58565, '2020-06-15', 'NL', 'Netherlands', 'EURO', '144', '48538', '1', '6031');
INSERT INTO public.who_global_data_import VALUES (58566, '2020-06-16', 'NL', 'Netherlands', 'EURO', '159', '48697', '7', '6038');
INSERT INTO public.who_global_data_import VALUES (58567, '2020-06-17', 'NL', 'Netherlands', 'EURO', '134', '48831', '4', '6042');
INSERT INTO public.who_global_data_import VALUES (58568, '2020-06-18', 'NL', 'Netherlands', 'EURO', '113', '48944', '5', '6047');
INSERT INTO public.who_global_data_import VALUES (58569, '2020-06-19', 'NL', 'Netherlands', 'EURO', '125', '49069', '3', '6050');
INSERT INTO public.who_global_data_import VALUES (58570, '2020-06-20', 'NL', 'Netherlands', 'EURO', '108', '49177', '4', '6054');
INSERT INTO public.who_global_data_import VALUES (58571, '2020-06-21', 'NL', 'Netherlands', 'EURO', '90', '49267', '8', '6062');
INSERT INTO public.who_global_data_import VALUES (58572, '2020-06-22', 'NL', 'Netherlands', 'EURO', '95', '49362', '1', '6063');
INSERT INTO public.who_global_data_import VALUES (58573, '2020-06-23', 'NL', 'Netherlands', 'EURO', '68', '49430', '0', '6063');
INSERT INTO public.who_global_data_import VALUES (58574, '2020-06-24', 'NL', 'Netherlands', 'EURO', '70', '49500', '5', '6068');
INSERT INTO public.who_global_data_import VALUES (58575, '2020-06-25', 'NL', 'Netherlands', 'EURO', '80', '49580', '3', '6071');
INSERT INTO public.who_global_data_import VALUES (58576, '2020-06-26', 'NL', 'Netherlands', 'EURO', '110', '49690', '3', '6074');
INSERT INTO public.who_global_data_import VALUES (58577, '2020-06-27', 'NL', 'Netherlands', 'EURO', '93', '49783', '2', '6076');
INSERT INTO public.who_global_data_import VALUES (58578, '2020-06-28', 'NL', 'Netherlands', 'EURO', '77', '49860', '3', '6079');
INSERT INTO public.who_global_data_import VALUES (58579, '2020-06-29', 'NL', 'Netherlands', 'EURO', '66', '49926', '0', '6079');
INSERT INTO public.who_global_data_import VALUES (58580, '2020-06-30', 'NL', 'Netherlands', 'EURO', '76', '50002', '2', '6081');
INSERT INTO public.who_global_data_import VALUES (58581, '2020-07-01', 'NL', 'Netherlands', 'EURO', '57', '50059', '5', '6086');
INSERT INTO public.who_global_data_import VALUES (58582, '2020-07-02', 'NL', 'Netherlands', 'EURO', '62', '50121', '3', '6089');
INSERT INTO public.who_global_data_import VALUES (58583, '2020-07-03', 'NL', 'Netherlands', 'EURO', '75', '50196', '3', '6092');
INSERT INTO public.who_global_data_import VALUES (58584, '2020-07-04', 'NL', 'Netherlands', 'EURO', '76', '50272', '1', '6093');
INSERT INTO public.who_global_data_import VALUES (58585, '2020-07-05', 'NL', 'Netherlands', 'EURO', '65', '50337', '7', '6100');
INSERT INTO public.who_global_data_import VALUES (58586, '2020-07-06', 'NL', 'Netherlands', 'EURO', '72', '50409', '1', '6101');
INSERT INTO public.who_global_data_import VALUES (58587, '2020-07-07', 'NL', 'Netherlands', 'EURO', '41', '50450', '0', '6101');
INSERT INTO public.who_global_data_import VALUES (58588, '2020-07-08', 'NL', 'Netherlands', 'EURO', '34', '50484', '4', '6105');
INSERT INTO public.who_global_data_import VALUES (58589, '2020-07-09', 'NL', 'Netherlands', 'EURO', '57', '50541', '4', '6109');
INSERT INTO public.who_global_data_import VALUES (58590, '2020-07-10', 'NL', 'Netherlands', 'EURO', '60', '50601', '2', '6111');
INSERT INTO public.who_global_data_import VALUES (58591, '2020-07-11', 'NL', 'Netherlands', 'EURO', '65', '50666', '0', '6111');
INSERT INTO public.who_global_data_import VALUES (58592, '2020-07-12', 'NL', 'Netherlands', 'EURO', '84', '50750', '5', '6116');
INSERT INTO public.who_global_data_import VALUES (58593, '2020-07-13', 'NL', 'Netherlands', 'EURO', '95', '50845', '0', '6116');
INSERT INTO public.who_global_data_import VALUES (58594, '2020-07-14', 'NL', 'Netherlands', 'EURO', '72', '50917', '0', '6116');
INSERT INTO public.who_global_data_import VALUES (58595, '2020-07-15', 'NL', 'Netherlands', 'EURO', '98', '51015', '10', '6126');
INSERT INTO public.who_global_data_import VALUES (58596, '2020-07-16', 'NL', 'Netherlands', 'EURO', '109', '51124', '2', '6128');
INSERT INTO public.who_global_data_import VALUES (58597, '2020-07-17', 'NL', 'Netherlands', 'EURO', '119', '51243', '2', '6130');
INSERT INTO public.who_global_data_import VALUES (58598, '2020-07-18', 'NL', 'Netherlands', 'EURO', '109', '51352', '2', '6132');
INSERT INTO public.who_global_data_import VALUES (58599, '2020-07-19', 'NL', 'Netherlands', 'EURO', '145', '51497', '1', '6133');
INSERT INTO public.who_global_data_import VALUES (58600, '2020-07-20', 'NL', 'Netherlands', 'EURO', '145', '51642', '0', '6133');
INSERT INTO public.who_global_data_import VALUES (58601, '2020-07-21', 'NL', 'Netherlands', 'EURO', '183', '51825', '0', '6133');
INSERT INTO public.who_global_data_import VALUES (58602, '2020-07-22', 'NL', 'Netherlands', 'EURO', '169', '51994', '1', '6134');
INSERT INTO public.who_global_data_import VALUES (58603, '2020-07-23', 'NL', 'Netherlands', 'EURO', '170', '52164', '2', '6136');
INSERT INTO public.who_global_data_import VALUES (58604, '2020-07-24', 'NL', 'Netherlands', 'EURO', '164', '52328', '1', '6137');
INSERT INTO public.who_global_data_import VALUES (58605, '2020-07-25', 'NL', 'Netherlands', 'EURO', '155', '52483', '0', '6137');
INSERT INTO public.who_global_data_import VALUES (58606, '2020-07-26', 'NL', 'Netherlands', 'EURO', '184', '52667', '1', '6138');
INSERT INTO public.who_global_data_import VALUES (58607, '2020-07-27', 'NL', 'Netherlands', 'EURO', '213', '52880', '0', '6138');
INSERT INTO public.who_global_data_import VALUES (58608, '2020-07-28', 'NL', 'Netherlands', 'EURO', '209', '53089', '1', '6139');
INSERT INTO public.who_global_data_import VALUES (58609, '2020-07-29', 'NL', 'Netherlands', 'EURO', '224', '53313', '4', '6143');
INSERT INTO public.who_global_data_import VALUES (58610, '2020-07-30', 'NL', 'Netherlands', 'EURO', '248', '53561', '2', '6145');
INSERT INTO public.who_global_data_import VALUES (58611, '2020-07-31', 'NL', 'Netherlands', 'EURO', '341', '53902', '0', '6145');
INSERT INTO public.who_global_data_import VALUES (58612, '2020-08-01', 'NL', 'Netherlands', 'EURO', '341', '54243', '0', '6145');
INSERT INTO public.who_global_data_import VALUES (58613, '2020-08-02', 'NL', 'Netherlands', 'EURO', '431', '54674', '1', '6146');
INSERT INTO public.who_global_data_import VALUES (58614, '2020-08-03', 'NL', 'Netherlands', 'EURO', '361', '55035', '1', '6147');
INSERT INTO public.who_global_data_import VALUES (58615, '2020-08-04', 'NL', 'Netherlands', 'EURO', '372', '55407', '0', '6147');
INSERT INTO public.who_global_data_import VALUES (58616, '2020-08-05', 'NL', 'Netherlands', 'EURO', '487', '55894', '2', '6149');
INSERT INTO public.who_global_data_import VALUES (58617, '2020-08-06', 'NL', 'Netherlands', 'EURO', '428', '56322', '3', '6152');
INSERT INTO public.who_global_data_import VALUES (58618, '2020-08-07', 'NL', 'Netherlands', 'EURO', '605', '56927', '0', '6152');
INSERT INTO public.who_global_data_import VALUES (58619, '2020-08-08', 'NL', 'Netherlands', 'EURO', '517', '57444', '1', '6153');
INSERT INTO public.who_global_data_import VALUES (58620, '2020-08-09', 'NL', 'Netherlands', 'EURO', '484', '57928', '3', '6156');
INSERT INTO public.who_global_data_import VALUES (58621, '2020-08-10', 'NL', 'Netherlands', 'EURO', '577', '58505', '0', '6156');
INSERT INTO public.who_global_data_import VALUES (58622, '2020-08-11', 'NL', 'Netherlands', 'EURO', '787', '59292', '0', '6156');
INSERT INTO public.who_global_data_import VALUES (58623, '2020-08-12', 'NL', 'Netherlands', 'EURO', '620', '59912', '2', '6158');
INSERT INTO public.who_global_data_import VALUES (58624, '2020-08-13', 'NL', 'Netherlands', 'EURO', '651', '60563', '2', '6160');
INSERT INTO public.who_global_data_import VALUES (58625, '2020-08-14', 'NL', 'Netherlands', 'EURO', '576', '61139', '4', '6164');
INSERT INTO public.who_global_data_import VALUES (58626, '2020-08-15', 'NL', 'Netherlands', 'EURO', '627', '61766', '2', '6166');
INSERT INTO public.who_global_data_import VALUES (58627, '2020-08-16', 'NL', 'Netherlands', 'EURO', '656', '62422', '2', '6168');
INSERT INTO public.who_global_data_import VALUES (58628, '2020-08-17', 'NL', 'Netherlands', 'EURO', '499', '62921', '3', '6171');
INSERT INTO public.who_global_data_import VALUES (58629, '2020-08-18', 'NL', 'Netherlands', 'EURO', '487', '63408', '0', '6171');
INSERT INTO public.who_global_data_import VALUES (58630, '2020-08-19', 'NL', 'Netherlands', 'EURO', '493', '63901', '3', '6174');
INSERT INTO public.who_global_data_import VALUES (58631, '2020-08-20', 'NL', 'Netherlands', 'EURO', '553', '64454', '6', '6180');
INSERT INTO public.who_global_data_import VALUES (58632, '2020-08-21', 'NL', 'Netherlands', 'EURO', '532', '64986', '9', '6189');
INSERT INTO public.who_global_data_import VALUES (58633, '2020-08-22', 'NL', 'Netherlands', 'EURO', '533', '65519', '1', '6190');
INSERT INTO public.who_global_data_import VALUES (58634, '2020-08-23', 'NL', 'Netherlands', 'EURO', '507', '66026', '5', '6195');
INSERT INTO public.who_global_data_import VALUES (58635, '2020-08-24', 'NL', 'Netherlands', 'EURO', '455', '66481', '0', '6195');
INSERT INTO public.who_global_data_import VALUES (58636, '2020-08-25', 'NL', 'Netherlands', 'EURO', '573', '67054', '2', '6197');
INSERT INTO public.who_global_data_import VALUES (58637, '2020-08-26', 'NL', 'Netherlands', 'EURO', '416', '67470', '5', '6202');
INSERT INTO public.who_global_data_import VALUES (58638, '2020-08-27', 'NL', 'Netherlands', 'EURO', '572', '68042', '8', '6210');
INSERT INTO public.who_global_data_import VALUES (58639, '2020-08-28', 'NL', 'Netherlands', 'EURO', '508', '68550', '3', '6213');
INSERT INTO public.who_global_data_import VALUES (58640, '2020-08-29', 'NL', 'Netherlands', 'EURO', '501', '69051', '3', '6216');
INSERT INTO public.who_global_data_import VALUES (58641, '2020-08-30', 'NL', 'Netherlands', 'EURO', '503', '69554', '4', '6220');
INSERT INTO public.who_global_data_import VALUES (58642, '2020-08-31', 'NL', 'Netherlands', 'EURO', '506', '70060', '0', '6220');
INSERT INTO public.who_global_data_import VALUES (58643, '2020-09-01', 'NL', 'Netherlands', 'EURO', '526', '70586', '0', '6220');
INSERT INTO public.who_global_data_import VALUES (58644, '2020-09-02', 'NL', 'Netherlands', 'EURO', '467', '71053', '6', '6226');
INSERT INTO public.who_global_data_import VALUES (58645, '2020-09-03', 'NL', 'Netherlands', 'EURO', '720', '71773', '5', '6231');
INSERT INTO public.who_global_data_import VALUES (58646, '2020-09-04', 'NL', 'Netherlands', 'EURO', '599', '72372', '2', '6233');
INSERT INTO public.who_global_data_import VALUES (58647, '2020-09-05', 'NL', 'Netherlands', 'EURO', '743', '73115', '2', '6235');
INSERT INTO public.who_global_data_import VALUES (58648, '2020-09-06', 'NL', 'Netherlands', 'EURO', '649', '73764', '5', '6240');
INSERT INTO public.who_global_data_import VALUES (58649, '2020-09-07', 'NL', 'Netherlands', 'EURO', '920', '74684', '2', '6242');
INSERT INTO public.who_global_data_import VALUES (58650, '2020-09-08', 'NL', 'Netherlands', 'EURO', '795', '75479', '0', '6242');
INSERT INTO public.who_global_data_import VALUES (58651, '2020-09-09', 'NL', 'Netherlands', 'EURO', '969', '76448', '1', '6243');
INSERT INTO public.who_global_data_import VALUES (58652, '2020-09-10', 'NL', 'Netherlands', 'EURO', '1140', '77588', '2', '6245');
INSERT INTO public.who_global_data_import VALUES (58653, '2020-09-11', 'NL', 'Netherlands', 'EURO', '837', '78425', '3', '6248');
INSERT INTO public.who_global_data_import VALUES (58654, '2020-09-12', 'NL', 'Netherlands', 'EURO', '1272', '79697', '3', '6251');
INSERT INTO public.who_global_data_import VALUES (58655, '2020-09-13', 'NL', 'Netherlands', 'EURO', '1222', '80919', '1', '6252');
INSERT INTO public.who_global_data_import VALUES (58656, '2020-09-14', 'NL', 'Netherlands', 'EURO', '1088', '82007', '1', '6253');
INSERT INTO public.who_global_data_import VALUES (58657, '2020-09-15', 'NL', 'Netherlands', 'EURO', '1297', '83304', '2', '6255');
INSERT INTO public.who_global_data_import VALUES (58658, '2020-09-16', 'NL', 'Netherlands', 'EURO', '1376', '84680', '2', '6257');
INSERT INTO public.who_global_data_import VALUES (58659, '2020-09-17', 'NL', 'Netherlands', 'EURO', '1537', '86217', '2', '6259');
INSERT INTO public.who_global_data_import VALUES (58660, '2020-09-18', 'NL', 'Netherlands', 'EURO', '1739', '87956', '6', '6265');
INSERT INTO public.who_global_data_import VALUES (58661, '2020-09-19', 'NL', 'Netherlands', 'EURO', '1958', '89914', '6', '6271');
INSERT INTO public.who_global_data_import VALUES (58662, '2020-09-20', 'NL', 'Netherlands', 'EURO', '1892', '91806', '3', '6274');
INSERT INTO public.who_global_data_import VALUES (58663, '2020-09-21', 'NL', 'Netherlands', 'EURO', '1844', '93650', '4', '6278');
INSERT INTO public.who_global_data_import VALUES (58664, '2020-09-22', 'NL', 'Netherlands', 'EURO', '2212', '95862', '2', '6280');
INSERT INTO public.who_global_data_import VALUES (58665, '2020-09-23', 'NL', 'Netherlands', 'EURO', '2237', '98099', '10', '6290');
INSERT INTO public.who_global_data_import VALUES (58666, '2020-09-24', 'NL', 'Netherlands', 'EURO', '2335', '100434', '5', '6295');
INSERT INTO public.who_global_data_import VALUES (58667, '2020-09-25', 'NL', 'Netherlands', 'EURO', '2537', '102971', '16', '6311');
INSERT INTO public.who_global_data_import VALUES (58668, '2020-09-26', 'NL', 'Netherlands', 'EURO', '2764', '105735', '16', '6327');
INSERT INTO public.who_global_data_import VALUES (58669, '2020-09-27', 'NL', 'Netherlands', 'EURO', '2701', '108436', '38', '6365');
INSERT INTO public.who_global_data_import VALUES (58670, '2020-09-28', 'NL', 'Netherlands', 'EURO', '2976', '111412', '8', '6373');
INSERT INTO public.who_global_data_import VALUES (58671, '2020-09-29', 'NL', 'Netherlands', 'EURO', '2903', '114315', '6', '6379');
INSERT INTO public.who_global_data_import VALUES (58672, '2020-09-30', 'NL', 'Netherlands', 'EURO', '3004', '117319', '13', '6392');
INSERT INTO public.who_global_data_import VALUES (58673, '2020-10-01', 'NL', 'Netherlands', 'EURO', '3286', '120605', '13', '6405');
INSERT INTO public.who_global_data_import VALUES (58674, '2020-10-02', 'NL', 'Netherlands', 'EURO', '3255', '123860', '13', '6418');
INSERT INTO public.who_global_data_import VALUES (58675, '2020-10-03', 'NL', 'Netherlands', 'EURO', '3805', '127665', '9', '6427');
INSERT INTO public.who_global_data_import VALUES (58676, '2020-10-04', 'NL', 'Netherlands', 'EURO', '3937', '131602', '20', '6447');
INSERT INTO public.who_global_data_import VALUES (58677, '2020-10-05', 'NL', 'Netherlands', 'EURO', '3987', '135589', '4', '6451');
INSERT INTO public.who_global_data_import VALUES (58678, '2020-10-06', 'NL', 'Netherlands', 'EURO', '4556', '140145', '7', '6458');
INSERT INTO public.who_global_data_import VALUES (58679, '2020-10-07', 'NL', 'Netherlands', 'EURO', '4525', '144670', '21', '6479');
INSERT INTO public.who_global_data_import VALUES (58680, '2020-10-08', 'NL', 'Netherlands', 'EURO', '4976', '149646', '36', '6515');
INSERT INTO public.who_global_data_import VALUES (58681, '2020-10-09', 'NL', 'Netherlands', 'EURO', '5789', '155435', '12', '6527');
INSERT INTO public.who_global_data_import VALUES (58682, '2020-10-10', 'NL', 'Netherlands', 'EURO', '5962', '161397', '14', '6541');
INSERT INTO public.who_global_data_import VALUES (58683, '2020-10-11', 'NL', 'Netherlands', 'EURO', '6481', '167878', '23', '6564');
INSERT INTO public.who_global_data_import VALUES (58684, '2020-10-12', 'NL', 'Netherlands', 'EURO', '6346', '174224', '16', '6580');
INSERT INTO public.who_global_data_import VALUES (58685, '2020-10-13', 'NL', 'Netherlands', 'EURO', '6804', '181028', '13', '6593');
INSERT INTO public.who_global_data_import VALUES (58686, '2020-10-14', 'NL', 'Netherlands', 'EURO', '7336', '188364', '33', '6626');
INSERT INTO public.who_global_data_import VALUES (58687, '2020-10-15', 'NL', 'Netherlands', 'EURO', '7253', '195617', '32', '6658');
INSERT INTO public.who_global_data_import VALUES (58688, '2020-10-16', 'NL', 'Netherlands', 'EURO', '7790', '203407', '29', '6687');
INSERT INTO public.who_global_data_import VALUES (58689, '2020-10-17', 'NL', 'Netherlands', 'EURO', '7956', '211363', '18', '6705');
INSERT INTO public.who_global_data_import VALUES (58690, '2020-10-18', 'NL', 'Netherlands', 'EURO', '8108', '219471', '28', '6733');
INSERT INTO public.who_global_data_import VALUES (58691, '2020-10-19', 'NL', 'Netherlands', 'EURO', '8149', '227620', '14', '6747');
INSERT INTO public.who_global_data_import VALUES (58692, '2020-10-20', 'NL', 'Netherlands', 'EURO', '7991', '235611', '17', '6764');
INSERT INTO public.who_global_data_import VALUES (58693, '2020-10-21', 'NL', 'Netherlands', 'EURO', '8147', '243758', '46', '6810');
INSERT INTO public.who_global_data_import VALUES (58694, '2020-10-22', 'NL', 'Netherlands', 'EURO', '8719', '252477', '57', '6867');
INSERT INTO public.who_global_data_import VALUES (58695, '2020-10-23', 'NL', 'Netherlands', 'EURO', '9252', '261729', '46', '6913');
INSERT INTO public.who_global_data_import VALUES (58696, '2020-10-24', 'NL', 'Netherlands', 'EURO', '9978', '271707', '47', '6960');
INSERT INTO public.who_global_data_import VALUES (58697, '2020-10-25', 'NL', 'Netherlands', 'EURO', '8643', '280350', '55', '7015');
INSERT INTO public.who_global_data_import VALUES (58698, '2020-10-26', 'NL', 'Netherlands', 'EURO', '10171', '290521', '27', '7042');
INSERT INTO public.who_global_data_import VALUES (58699, '2020-10-27', 'NL', 'Netherlands', 'EURO', '10303', '300824', '26', '7068');
INSERT INTO public.who_global_data_import VALUES (58700, '2020-10-28', 'NL', 'Netherlands', 'EURO', '10267', '311091', '69', '7137');
INSERT INTO public.who_global_data_import VALUES (58701, '2020-10-29', 'NL', 'Netherlands', 'EURO', '8077', '319168', '54', '7191');
INSERT INTO public.who_global_data_import VALUES (58702, '2020-10-30', 'NL', 'Netherlands', 'EURO', '10248', '329416', '62', '7253');
INSERT INTO public.who_global_data_import VALUES (58703, '2020-10-31', 'NL', 'Netherlands', 'EURO', '11071', '340487', '86', '7339');
INSERT INTO public.who_global_data_import VALUES (58704, '2020-11-01', 'NL', 'Netherlands', 'EURO', '9773', '350260', '51', '7390');
INSERT INTO public.who_global_data_import VALUES (58705, '2020-11-02', 'NL', 'Netherlands', 'EURO', '8682', '358942', '39', '7429');
INSERT INTO public.who_global_data_import VALUES (58706, '2020-11-03', 'NL', 'Netherlands', 'EURO', '8267', '367209', '29', '7458');
INSERT INTO public.who_global_data_import VALUES (58707, '2020-11-04', 'NL', 'Netherlands', 'EURO', '7739', '374948', '112', '7570');
INSERT INTO public.who_global_data_import VALUES (58708, '2020-11-05', 'NL', 'Netherlands', 'EURO', '7601', '382549', '102', '7672');
INSERT INTO public.who_global_data_import VALUES (58709, '2020-11-06', 'NL', 'Netherlands', 'EURO', '6948', '389497', '87', '7759');
INSERT INTO public.who_global_data_import VALUES (58710, '2020-11-07', 'NL', 'Netherlands', 'EURO', '7229', '396726', '116', '7875');
INSERT INTO public.who_global_data_import VALUES (58711, '2020-11-08', 'NL', 'Netherlands', 'EURO', '6618', '403344', '72', '7947');
INSERT INTO public.who_global_data_import VALUES (58712, '2020-11-09', 'NL', 'Netherlands', 'EURO', '5657', '409001', '43', '7990');
INSERT INTO public.who_global_data_import VALUES (58713, '2020-11-10', 'NL', 'Netherlands', 'EURO', '4672', '413673', '38', '8028');
INSERT INTO public.who_global_data_import VALUES (58714, '2020-11-11', 'NL', 'Netherlands', 'EURO', '4646', '418319', '95', '8123');
INSERT INTO public.who_global_data_import VALUES (58715, '2020-11-12', 'NL', 'Netherlands', 'EURO', '5384', '423703', '76', '8199');
INSERT INTO public.who_global_data_import VALUES (58716, '2020-11-13', 'NL', 'Netherlands', 'EURO', '5619', '429322', '85', '8284');
INSERT INTO public.who_global_data_import VALUES (58717, '2020-11-14', 'NL', 'Netherlands', 'EURO', '6069', '435391', '54', '8338');
INSERT INTO public.who_global_data_import VALUES (58718, '2020-11-15', 'NL', 'Netherlands', 'EURO', '5901', '441292', '84', '8422');
INSERT INTO public.who_global_data_import VALUES (58719, '2020-11-16', 'NL', 'Netherlands', 'EURO', '5419', '446711', '44', '8466');
INSERT INTO public.who_global_data_import VALUES (58720, '2020-11-17', 'NL', 'Netherlands', 'EURO', '4843', '451554', '45', '8511');
INSERT INTO public.who_global_data_import VALUES (58721, '2020-11-18', 'NL', 'Netherlands', 'EURO', '4282', '455836', '85', '8596');
INSERT INTO public.who_global_data_import VALUES (58722, '2020-11-19', 'NL', 'Netherlands', 'EURO', '4587', '460423', '82', '8678');
INSERT INTO public.who_global_data_import VALUES (58723, '2020-11-20', 'NL', 'Netherlands', 'EURO', '5688', '466111', '75', '8753');
INSERT INTO public.who_global_data_import VALUES (58724, '2020-11-21', 'NL', 'Netherlands', 'EURO', '5934', '472045', '49', '8802');
INSERT INTO public.who_global_data_import VALUES (58725, '2020-11-22', 'NL', 'Netherlands', 'EURO', '6006', '478051', '47', '8849');
INSERT INTO public.who_global_data_import VALUES (58726, '2020-11-23', 'NL', 'Netherlands', 'EURO', '5362', '483413', '21', '8870');
INSERT INTO public.who_global_data_import VALUES (58727, '2020-11-24', 'NL', 'Netherlands', 'EURO', '5184', '488597', '54', '8924');
INSERT INTO public.who_global_data_import VALUES (58728, '2020-11-25', 'NL', 'Netherlands', 'EURO', '3947', '492544', '90', '9014');
INSERT INTO public.who_global_data_import VALUES (58729, '2020-11-26', 'NL', 'Netherlands', 'EURO', '4912', '497456', '74', '9088');
INSERT INTO public.who_global_data_import VALUES (58730, '2020-11-27', 'NL', 'Netherlands', 'EURO', '4472', '501928', '74', '9162');
INSERT INTO public.who_global_data_import VALUES (58731, '2020-11-28', 'NL', 'Netherlands', 'EURO', '5754', '507682', '83', '9245');
INSERT INTO public.who_global_data_import VALUES (58732, '2020-11-29', 'NL', 'Netherlands', 'EURO', '4469', '512151', '56', '9301');
INSERT INTO public.who_global_data_import VALUES (58733, '2020-11-30', 'NL', 'Netherlands', 'EURO', '5565', '517716', '25', '9326');
INSERT INTO public.who_global_data_import VALUES (58734, '2020-12-01', 'NL', 'Netherlands', 'EURO', '4573', '522289', '28', '9354');
INSERT INTO public.who_global_data_import VALUES (58735, '2020-12-02', 'NL', 'Netherlands', 'EURO', '4038', '526327', '61', '9415');
INSERT INTO public.who_global_data_import VALUES (58736, '2020-12-03', 'NL', 'Netherlands', 'EURO', '4908', '531235', '66', '9481');
INSERT INTO public.who_global_data_import VALUES (58737, '2020-12-04', 'NL', 'Netherlands', 'EURO', '5596', '536831', '59', '9540');
INSERT INTO public.who_global_data_import VALUES (58738, '2020-12-05', 'NL', 'Netherlands', 'EURO', '5893', '542724', '57', '9597');
INSERT INTO public.who_global_data_import VALUES (58739, '2020-12-06', 'NL', 'Netherlands', 'EURO', '6531', '549255', '39', '9636');
INSERT INTO public.who_global_data_import VALUES (58740, '2020-12-07', 'NL', 'Netherlands', 'EURO', '6764', '556019', '24', '9660');
INSERT INTO public.who_global_data_import VALUES (58741, '2020-12-08', 'NL', 'Netherlands', 'EURO', '7094', '563113', '19', '9679');
INSERT INTO public.who_global_data_import VALUES (58742, '2020-12-09', 'NL', 'Netherlands', 'EURO', '6124', '569237', '68', '9747');
INSERT INTO public.who_global_data_import VALUES (58743, '2020-12-10', 'NL', 'Netherlands', 'EURO', '6548', '575785', '66', '9813');
INSERT INTO public.who_global_data_import VALUES (58744, '2020-12-11', 'NL', 'Netherlands', 'EURO', '8712', '584497', '63', '9876');
INSERT INTO public.who_global_data_import VALUES (58745, '2020-12-12', 'NL', 'Netherlands', 'EURO', '8839', '593336', '64', '9940');
INSERT INTO public.who_global_data_import VALUES (58746, '2020-12-13', 'NL', 'Netherlands', 'EURO', '9124', '602460', '53', '9993');
INSERT INTO public.who_global_data_import VALUES (58747, '2020-12-14', 'NL', 'Netherlands', 'EURO', '9881', '612341', '29', '10022');
INSERT INTO public.who_global_data_import VALUES (58748, '2020-12-15', 'NL', 'Netherlands', 'EURO', '8465', '620806', '35', '10057');
INSERT INTO public.who_global_data_import VALUES (58749, '2020-12-16', 'NL', 'Netherlands', 'EURO', '6640', '627446', '86', '10143');
INSERT INTO public.who_global_data_import VALUES (58750, '2020-12-17', 'NL', 'Netherlands', 'EURO', '11170', '638616', '76', '10219');
INSERT INTO public.who_global_data_import VALUES (58751, '2020-12-18', 'NL', 'Netherlands', 'EURO', '12784', '651400', '76', '10295');
INSERT INTO public.who_global_data_import VALUES (58752, '2020-12-19', 'NL', 'Netherlands', 'EURO', '11962', '663362', '83', '10378');
INSERT INTO public.who_global_data_import VALUES (58753, '2020-12-20', 'NL', 'Netherlands', 'EURO', '12229', '675591', '55', '10433');
INSERT INTO public.who_global_data_import VALUES (58754, '2020-12-21', 'NL', 'Netherlands', 'EURO', '12998', '688589', '31', '10464');
INSERT INTO public.who_global_data_import VALUES (58755, '2020-12-22', 'NL', 'Netherlands', 'EURO', '11162', '699751', '30', '10494');
INSERT INTO public.who_global_data_import VALUES (58756, '2020-12-23', 'NL', 'Netherlands', 'EURO', '9828', '709579', '113', '10607');
INSERT INTO public.who_global_data_import VALUES (58757, '2020-12-24', 'NL', 'Netherlands', 'EURO', '10401', '719980', '105', '10712');
INSERT INTO public.who_global_data_import VALUES (58758, '2020-12-25', 'NL', 'Netherlands', 'EURO', '11502', '731482', '88', '10800');
INSERT INTO public.who_global_data_import VALUES (58759, '2020-12-26', 'NL', 'Netherlands', 'EURO', '11498', '742980', '93', '10893');
INSERT INTO public.who_global_data_import VALUES (58760, '2020-12-27', 'NL', 'Netherlands', 'EURO', '9831', '752811', '49', '10942');
INSERT INTO public.who_global_data_import VALUES (58761, '2020-12-28', 'NL', 'Netherlands', 'EURO', '9020', '761831', '28', '10970');
INSERT INTO public.who_global_data_import VALUES (58762, '2020-12-29', 'NL', 'Netherlands', 'EURO', '7408', '769239', '44', '11014');
INSERT INTO public.who_global_data_import VALUES (58763, '2020-12-30', 'NL', 'Netherlands', 'EURO', '7527', '776766', '169', '11183');
INSERT INTO public.who_global_data_import VALUES (58764, '2020-12-31', 'NL', 'Netherlands', 'EURO', '9459', '786225', '112', '11295');
INSERT INTO public.who_global_data_import VALUES (58765, '2021-01-01', 'NL', 'Netherlands', 'EURO', '9669', '795894', '109', '11404');
INSERT INTO public.who_global_data_import VALUES (58766, '2021-01-02', 'NL', 'Netherlands', 'EURO', '8173', '804067', '98', '11502');
INSERT INTO public.who_global_data_import VALUES (58767, '2021-01-03', 'NL', 'Netherlands', 'EURO', '8593', '812660', '38', '11540');
INSERT INTO public.who_global_data_import VALUES (58768, '2021-01-04', 'NL', 'Netherlands', 'EURO', '7407', '820067', '47', '11587');
INSERT INTO public.who_global_data_import VALUES (58769, '2021-01-05', 'NL', 'Netherlands', 'EURO', '6641', '826708', '65', '11652');
INSERT INTO public.who_global_data_import VALUES (58770, '2021-01-06', 'NL', 'Netherlands', 'EURO', '6381', '833089', '152', '11804');
INSERT INTO public.who_global_data_import VALUES (58771, '2021-01-07', 'NL', 'Netherlands', 'EURO', '7101', '840190', '175', '11979');
INSERT INTO public.who_global_data_import VALUES (58772, '2021-01-08', 'NL', 'Netherlands', 'EURO', '9690', '849880', '81', '12060');
INSERT INTO public.who_global_data_import VALUES (58773, '2021-01-09', 'NL', 'Netherlands', 'EURO', '8124', '858004', '88', '12148');
INSERT INTO public.who_global_data_import VALUES (58774, '2021-01-10', 'NL', 'Netherlands', 'EURO', '7341', '865345', '138', '12286');
INSERT INTO public.who_global_data_import VALUES (58775, '2021-01-11', 'NL', 'Netherlands', 'EURO', '6610', '871955', '53', '12339');
INSERT INTO public.who_global_data_import VALUES (58776, '2021-01-12', 'NL', 'Netherlands', 'EURO', '5464', '877419', '48', '12387');
INSERT INTO public.who_global_data_import VALUES (58777, '2021-01-13', 'NL', 'Netherlands', 'EURO', '4949', '882368', '153', '12540');
INSERT INTO public.who_global_data_import VALUES (58778, '2021-01-14', 'NL', 'Netherlands', 'EURO', '6102', '888470', '121', '12661');
INSERT INTO public.who_global_data_import VALUES (58779, '2021-01-15', 'NL', 'Netherlands', 'EURO', '6504', '894974', '86', '12747');
INSERT INTO public.who_global_data_import VALUES (58780, '2021-01-16', 'NL', 'Netherlands', 'EURO', '6035', '901009', '94', '12841');
INSERT INTO public.who_global_data_import VALUES (58781, '2021-01-17', 'NL', 'Netherlands', 'EURO', '5304', '906313', '97', '12938');
INSERT INTO public.who_global_data_import VALUES (58782, '2021-01-18', 'NL', 'Netherlands', 'EURO', '5589', '911902', '43', '12981');
INSERT INTO public.who_global_data_import VALUES (58783, '2021-01-19', 'NL', 'Netherlands', 'EURO', '4796', '916698', '59', '13040');
INSERT INTO public.who_global_data_import VALUES (58784, '2021-01-20', 'NL', 'Netherlands', 'EURO', '4304', '921002', '106', '13146');
INSERT INTO public.who_global_data_import VALUES (58785, '2021-01-21', 'NL', 'Netherlands', 'EURO', '5577', '926579', '86', '13232');
INSERT INTO public.who_global_data_import VALUES (58786, '2021-01-22', 'NL', 'Netherlands', 'EURO', '5816', '932395', '91', '13323');
INSERT INTO public.who_global_data_import VALUES (58787, '2021-01-23', 'NL', 'Netherlands', 'EURO', '5755', '938150', '89', '13412');
INSERT INTO public.who_global_data_import VALUES (58788, '2021-01-24', 'NL', 'Netherlands', 'EURO', '5459', '943609', '88', '13500');
INSERT INTO public.who_global_data_import VALUES (58789, '2021-01-25', 'NL', 'Netherlands', 'EURO', '4893', '948502', '30', '13530');
INSERT INTO public.who_global_data_import VALUES (58790, '2021-01-26', 'NL', 'Netherlands', 'EURO', '4103', '952605', '40', '13570');
INSERT INTO public.who_global_data_import VALUES (58791, '2021-01-27', 'NL', 'Netherlands', 'EURO', '3964', '956569', '87', '13657');
INSERT INTO public.who_global_data_import VALUES (58792, '2021-01-28', 'NL', 'Netherlands', 'EURO', '4738', '961307', '69', '13726');
INSERT INTO public.who_global_data_import VALUES (58793, '2021-01-29', 'NL', 'Netherlands', 'EURO', '4711', '966018', '84', '13810');
INSERT INTO public.who_global_data_import VALUES (58794, '2021-01-30', 'NL', 'Netherlands', 'EURO', '4421', '970439', '57', '13867');
INSERT INTO public.who_global_data_import VALUES (58795, '2021-01-31', 'NL', 'Netherlands', 'EURO', '4187', '974626', '88', '13955');
INSERT INTO public.who_global_data_import VALUES (58796, '2021-02-01', 'NL', 'Netherlands', 'EURO', '3692', '978318', '40', '13995');
INSERT INTO public.who_global_data_import VALUES (58797, '2021-02-02', 'NL', 'Netherlands', 'EURO', '3258', '981576', '27', '14022');
INSERT INTO public.who_global_data_import VALUES (58798, '2021-02-03', 'NL', 'Netherlands', 'EURO', '3570', '985146', '83', '14105');
INSERT INTO public.who_global_data_import VALUES (58799, '2021-02-04', 'NL', 'Netherlands', 'EURO', '4038', '989184', '62', '14167');
INSERT INTO public.who_global_data_import VALUES (58800, '2021-02-05', 'NL', 'Netherlands', 'EURO', '4246', '993430', '67', '14234');
INSERT INTO public.who_global_data_import VALUES (58801, '2020-01-03', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58802, '2020-01-04', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58803, '2020-01-05', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58804, '2020-01-06', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58805, '2020-01-07', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58806, '2020-01-08', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58807, '2020-01-09', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58808, '2020-01-10', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58809, '2020-01-11', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58810, '2020-01-12', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58811, '2020-01-13', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58812, '2020-01-14', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58813, '2020-01-15', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58814, '2020-01-16', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58815, '2020-01-17', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58816, '2020-01-18', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58817, '2020-01-19', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58818, '2020-01-20', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58819, '2020-01-21', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58820, '2020-01-22', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58821, '2020-01-23', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58822, '2020-01-24', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58823, '2020-01-25', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58824, '2020-01-26', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58825, '2020-01-27', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58826, '2020-01-28', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58827, '2020-01-29', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58828, '2020-01-30', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58829, '2020-01-31', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58830, '2020-02-01', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58831, '2020-02-02', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58832, '2020-02-03', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58833, '2020-02-04', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58834, '2020-02-05', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58835, '2020-02-06', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58836, '2020-02-07', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58837, '2020-02-08', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58838, '2020-02-09', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58839, '2020-02-10', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58840, '2020-02-11', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58841, '2020-02-12', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58842, '2020-02-13', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58843, '2020-02-14', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58844, '2020-02-15', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58845, '2020-02-16', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58846, '2020-02-17', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60028, '2020-01-30', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58847, '2020-02-18', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58848, '2020-02-19', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58849, '2020-02-20', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58850, '2020-02-21', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58851, '2020-02-22', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58852, '2020-02-23', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58853, '2020-02-24', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58854, '2020-02-25', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58855, '2020-02-26', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58856, '2020-02-27', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58857, '2020-02-28', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58858, '2020-02-29', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58859, '2020-03-01', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58860, '2020-03-02', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58861, '2020-03-03', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58862, '2020-03-04', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58863, '2020-03-05', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58864, '2020-03-06', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58865, '2020-03-07', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58866, '2020-03-08', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58867, '2020-03-09', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58868, '2020-03-10', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58869, '2020-03-11', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58870, '2020-03-12', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58871, '2020-03-13', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58872, '2020-03-14', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58873, '2020-03-15', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58874, '2020-03-16', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58875, '2020-03-17', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58876, '2020-03-18', 'NC', 'New Caledonia', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58877, '2020-03-19', 'NC', 'New Caledonia', 'WPRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58878, '2020-03-20', 'NC', 'New Caledonia', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58879, '2020-03-21', 'NC', 'New Caledonia', 'WPRO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58880, '2020-03-22', 'NC', 'New Caledonia', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58881, '2020-03-23', 'NC', 'New Caledonia', 'WPRO', '3', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58882, '2020-03-24', 'NC', 'New Caledonia', 'WPRO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58883, '2020-03-25', 'NC', 'New Caledonia', 'WPRO', '3', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58884, '2020-03-26', 'NC', 'New Caledonia', 'WPRO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58885, '2020-03-27', 'NC', 'New Caledonia', 'WPRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58886, '2020-03-28', 'NC', 'New Caledonia', 'WPRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58887, '2020-03-29', 'NC', 'New Caledonia', 'WPRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58888, '2020-03-30', 'NC', 'New Caledonia', 'WPRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58889, '2020-03-31', 'NC', 'New Caledonia', 'WPRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58890, '2020-04-01', 'NC', 'New Caledonia', 'WPRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58891, '2020-04-02', 'NC', 'New Caledonia', 'WPRO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58892, '2020-04-03', 'NC', 'New Caledonia', 'WPRO', '1', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58893, '2020-04-04', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58894, '2020-04-05', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58895, '2020-04-06', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58896, '2020-04-07', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58897, '2020-04-08', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58898, '2020-04-09', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58899, '2020-04-10', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58900, '2020-04-11', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58901, '2020-04-12', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58902, '2020-04-13', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58903, '2020-04-14', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58904, '2020-04-15', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58905, '2020-04-16', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58906, '2020-04-17', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58907, '2020-04-18', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58908, '2020-04-19', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58909, '2020-04-20', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58910, '2020-04-21', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58911, '2020-04-22', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58912, '2020-04-23', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58913, '2020-04-24', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58914, '2020-04-25', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58915, '2020-04-26', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58916, '2020-04-27', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58917, '2020-04-28', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58918, '2020-04-29', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58919, '2020-04-30', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58920, '2020-05-01', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58921, '2020-05-02', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58922, '2020-05-03', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58923, '2020-05-04', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58924, '2020-05-05', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58925, '2020-05-06', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58926, '2020-05-07', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58927, '2020-05-08', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58928, '2020-05-09', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58929, '2020-05-10', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58930, '2020-05-11', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58931, '2020-05-12', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58932, '2020-05-13', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58933, '2020-05-14', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58934, '2020-05-15', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58935, '2020-05-16', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58936, '2020-05-17', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58937, '2020-05-18', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58938, '2020-05-19', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58939, '2020-05-20', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58940, '2020-05-21', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58941, '2020-05-22', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58942, '2020-05-23', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58943, '2020-05-24', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58944, '2020-05-25', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58945, '2020-05-26', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58946, '2020-05-27', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58947, '2020-05-28', 'NC', 'New Caledonia', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58948, '2020-05-29', 'NC', 'New Caledonia', 'WPRO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58949, '2020-05-30', 'NC', 'New Caledonia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58950, '2020-05-31', 'NC', 'New Caledonia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58951, '2020-06-01', 'NC', 'New Caledonia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58952, '2020-06-02', 'NC', 'New Caledonia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58953, '2020-06-03', 'NC', 'New Caledonia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58954, '2020-06-04', 'NC', 'New Caledonia', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58955, '2020-06-05', 'NC', 'New Caledonia', 'WPRO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58956, '2020-06-06', 'NC', 'New Caledonia', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58957, '2020-06-07', 'NC', 'New Caledonia', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58958, '2020-06-08', 'NC', 'New Caledonia', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58959, '2020-06-09', 'NC', 'New Caledonia', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58960, '2020-06-10', 'NC', 'New Caledonia', 'WPRO', '1', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58961, '2020-06-11', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58962, '2020-06-12', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58963, '2020-06-13', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58964, '2020-06-14', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58965, '2020-06-15', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58966, '2020-06-16', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58967, '2020-06-17', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58968, '2020-06-18', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58969, '2020-06-19', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58970, '2020-06-20', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58971, '2020-06-21', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58972, '2020-06-22', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58973, '2020-06-23', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58974, '2020-06-24', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58975, '2020-06-25', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58976, '2020-06-26', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58977, '2020-06-27', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58978, '2020-06-28', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58979, '2020-06-29', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58980, '2020-06-30', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58981, '2020-07-01', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58982, '2020-07-02', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58983, '2020-07-03', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58984, '2020-07-04', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58985, '2020-07-05', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58986, '2020-07-06', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58987, '2020-07-07', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58988, '2020-07-08', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58989, '2020-07-09', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58990, '2020-07-10', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58991, '2020-07-11', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58992, '2020-07-12', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58993, '2020-07-13', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58994, '2020-07-14', 'NC', 'New Caledonia', 'WPRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58995, '2020-07-15', 'NC', 'New Caledonia', 'WPRO', '1', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58996, '2020-07-16', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58997, '2020-07-17', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58998, '2020-07-18', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (58999, '2020-07-19', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59000, '2020-07-20', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59001, '2020-07-21', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59002, '2020-07-22', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59003, '2020-07-23', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59004, '2020-07-24', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59005, '2020-07-25', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59006, '2020-07-26', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59007, '2020-07-27', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59008, '2020-07-28', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59009, '2020-07-29', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59010, '2020-07-30', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59011, '2020-07-31', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59012, '2020-08-01', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59013, '2020-08-02', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59014, '2020-08-03', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59015, '2020-08-04', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59016, '2020-08-05', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59017, '2020-08-06', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59018, '2020-08-07', 'NC', 'New Caledonia', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59019, '2020-08-08', 'NC', 'New Caledonia', 'WPRO', '1', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59020, '2020-08-09', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59021, '2020-08-10', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59022, '2020-08-11', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59023, '2020-08-12', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59024, '2020-08-13', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59025, '2020-08-14', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59026, '2020-08-15', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59027, '2020-08-16', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59028, '2020-08-17', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59029, '2020-08-18', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59030, '2020-08-19', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59031, '2020-08-20', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59032, '2020-08-21', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59033, '2020-08-22', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59034, '2020-08-23', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59035, '2020-08-24', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59036, '2020-08-25', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59037, '2020-08-26', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59038, '2020-08-27', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59039, '2020-08-28', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59040, '2020-08-29', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59041, '2020-08-30', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59042, '2020-08-31', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59043, '2020-09-01', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59044, '2020-09-02', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59045, '2020-09-03', 'NC', 'New Caledonia', 'WPRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59046, '2020-09-04', 'NC', 'New Caledonia', 'WPRO', '3', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59047, '2020-09-05', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59048, '2020-09-06', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59049, '2020-09-07', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59050, '2020-09-08', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59051, '2020-09-09', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59052, '2020-09-10', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59053, '2020-09-11', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59054, '2020-09-12', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59055, '2020-09-13', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59056, '2020-09-14', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59057, '2020-09-15', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59058, '2020-09-16', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59059, '2020-09-17', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59060, '2020-09-18', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59061, '2020-09-19', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59062, '2020-09-20', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59063, '2020-09-21', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59064, '2020-09-22', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59065, '2020-09-23', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59066, '2020-09-24', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59067, '2020-09-25', 'NC', 'New Caledonia', 'WPRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59068, '2020-09-26', 'NC', 'New Caledonia', 'WPRO', '1', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59069, '2020-09-27', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59070, '2020-09-28', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59071, '2020-09-29', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59072, '2020-09-30', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59073, '2020-10-01', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59074, '2020-10-02', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59075, '2020-10-03', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59076, '2020-10-04', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59077, '2020-10-05', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59078, '2020-10-06', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59079, '2020-10-07', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59080, '2020-10-08', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59081, '2020-10-09', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59082, '2020-10-10', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59083, '2020-10-11', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59084, '2020-10-12', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59085, '2020-10-13', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59086, '2020-10-14', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59087, '2020-10-15', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59088, '2020-10-16', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59089, '2020-10-17', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59090, '2020-10-18', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59091, '2020-10-19', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59092, '2020-10-20', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59093, '2020-10-21', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59094, '2020-10-22', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59095, '2020-10-23', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59096, '2020-10-24', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59097, '2020-10-25', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59098, '2020-10-26', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59099, '2020-10-27', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59100, '2020-10-28', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59101, '2020-10-29', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59102, '2020-10-30', 'NC', 'New Caledonia', 'WPRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59103, '2020-10-31', 'NC', 'New Caledonia', 'WPRO', '1', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59104, '2020-11-01', 'NC', 'New Caledonia', 'WPRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59105, '2020-11-02', 'NC', 'New Caledonia', 'WPRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59106, '2020-11-03', 'NC', 'New Caledonia', 'WPRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59107, '2020-11-04', 'NC', 'New Caledonia', 'WPRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59108, '2020-11-05', 'NC', 'New Caledonia', 'WPRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59109, '2020-11-06', 'NC', 'New Caledonia', 'WPRO', '1', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59110, '2020-11-07', 'NC', 'New Caledonia', 'WPRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59111, '2020-11-08', 'NC', 'New Caledonia', 'WPRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59112, '2020-11-09', 'NC', 'New Caledonia', 'WPRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59113, '2020-11-10', 'NC', 'New Caledonia', 'WPRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59114, '2020-11-11', 'NC', 'New Caledonia', 'WPRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59115, '2020-11-12', 'NC', 'New Caledonia', 'WPRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59116, '2020-11-13', 'NC', 'New Caledonia', 'WPRO', '1', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59117, '2020-11-14', 'NC', 'New Caledonia', 'WPRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59118, '2020-11-15', 'NC', 'New Caledonia', 'WPRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59119, '2020-11-16', 'NC', 'New Caledonia', 'WPRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59120, '2020-11-17', 'NC', 'New Caledonia', 'WPRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59121, '2020-11-18', 'NC', 'New Caledonia', 'WPRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59122, '2020-11-19', 'NC', 'New Caledonia', 'WPRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59123, '2020-11-20', 'NC', 'New Caledonia', 'WPRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59124, '2020-11-21', 'NC', 'New Caledonia', 'WPRO', '2', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59125, '2020-11-22', 'NC', 'New Caledonia', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59126, '2020-11-23', 'NC', 'New Caledonia', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59127, '2020-11-24', 'NC', 'New Caledonia', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59128, '2020-11-25', 'NC', 'New Caledonia', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59129, '2020-11-26', 'NC', 'New Caledonia', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59130, '2020-11-27', 'NC', 'New Caledonia', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59131, '2020-11-28', 'NC', 'New Caledonia', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59132, '2020-11-29', 'NC', 'New Caledonia', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59133, '2020-11-30', 'NC', 'New Caledonia', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59134, '2020-12-01', 'NC', 'New Caledonia', 'WPRO', '1', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59135, '2020-12-02', 'NC', 'New Caledonia', 'WPRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59136, '2020-12-03', 'NC', 'New Caledonia', 'WPRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59137, '2020-12-04', 'NC', 'New Caledonia', 'WPRO', '1', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59138, '2020-12-05', 'NC', 'New Caledonia', 'WPRO', '1', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59139, '2020-12-06', 'NC', 'New Caledonia', 'WPRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59140, '2020-12-07', 'NC', 'New Caledonia', 'WPRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59141, '2020-12-08', 'NC', 'New Caledonia', 'WPRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59142, '2020-12-09', 'NC', 'New Caledonia', 'WPRO', '1', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59143, '2020-12-10', 'NC', 'New Caledonia', 'WPRO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59144, '2020-12-11', 'NC', 'New Caledonia', 'WPRO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59145, '2020-12-12', 'NC', 'New Caledonia', 'WPRO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59146, '2020-12-13', 'NC', 'New Caledonia', 'WPRO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59147, '2020-12-14', 'NC', 'New Caledonia', 'WPRO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59148, '2020-12-15', 'NC', 'New Caledonia', 'WPRO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59149, '2020-12-16', 'NC', 'New Caledonia', 'WPRO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59150, '2020-12-17', 'NC', 'New Caledonia', 'WPRO', '1', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59151, '2020-12-18', 'NC', 'New Caledonia', 'WPRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59152, '2020-12-19', 'NC', 'New Caledonia', 'WPRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59153, '2020-12-20', 'NC', 'New Caledonia', 'WPRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59154, '2020-12-21', 'NC', 'New Caledonia', 'WPRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59155, '2020-12-22', 'NC', 'New Caledonia', 'WPRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59156, '2020-12-23', 'NC', 'New Caledonia', 'WPRO', '1', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59157, '2020-12-24', 'NC', 'New Caledonia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59158, '2020-12-25', 'NC', 'New Caledonia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59159, '2020-12-26', 'NC', 'New Caledonia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59160, '2020-12-27', 'NC', 'New Caledonia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59161, '2020-12-28', 'NC', 'New Caledonia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59162, '2020-12-29', 'NC', 'New Caledonia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59163, '2020-12-30', 'NC', 'New Caledonia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59164, '2020-12-31', 'NC', 'New Caledonia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59165, '2021-01-01', 'NC', 'New Caledonia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59166, '2021-01-02', 'NC', 'New Caledonia', 'WPRO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59167, '2021-01-03', 'NC', 'New Caledonia', 'WPRO', '2', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59168, '2021-01-04', 'NC', 'New Caledonia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59169, '2021-01-05', 'NC', 'New Caledonia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59170, '2021-01-06', 'NC', 'New Caledonia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59171, '2021-01-07', 'NC', 'New Caledonia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59172, '2021-01-08', 'NC', 'New Caledonia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59173, '2021-01-09', 'NC', 'New Caledonia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59174, '2021-01-10', 'NC', 'New Caledonia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59175, '2021-01-11', 'NC', 'New Caledonia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59176, '2021-01-12', 'NC', 'New Caledonia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59177, '2021-01-13', 'NC', 'New Caledonia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59178, '2021-01-14', 'NC', 'New Caledonia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59179, '2021-01-15', 'NC', 'New Caledonia', 'WPRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59180, '2021-01-16', 'NC', 'New Caledonia', 'WPRO', '1', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59181, '2021-01-17', 'NC', 'New Caledonia', 'WPRO', '3', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59182, '2021-01-18', 'NC', 'New Caledonia', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59183, '2021-01-19', 'NC', 'New Caledonia', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59184, '2021-01-20', 'NC', 'New Caledonia', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59185, '2021-01-21', 'NC', 'New Caledonia', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59186, '2021-01-22', 'NC', 'New Caledonia', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59187, '2021-01-23', 'NC', 'New Caledonia', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59188, '2021-01-24', 'NC', 'New Caledonia', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59189, '2021-01-25', 'NC', 'New Caledonia', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59190, '2021-01-26', 'NC', 'New Caledonia', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59191, '2021-01-27', 'NC', 'New Caledonia', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59192, '2021-01-28', 'NC', 'New Caledonia', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59193, '2021-01-29', 'NC', 'New Caledonia', 'WPRO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59194, '2021-01-30', 'NC', 'New Caledonia', 'WPRO', '3', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59195, '2021-01-31', 'NC', 'New Caledonia', 'WPRO', '0', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59196, '2021-02-01', 'NC', 'New Caledonia', 'WPRO', '0', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59197, '2021-02-02', 'NC', 'New Caledonia', 'WPRO', '0', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59198, '2021-02-03', 'NC', 'New Caledonia', 'WPRO', '0', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59199, '2021-02-04', 'NC', 'New Caledonia', 'WPRO', '0', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59200, '2021-02-05', 'NC', 'New Caledonia', 'WPRO', '0', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59201, '2020-01-03', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59202, '2020-01-04', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59203, '2020-01-05', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59204, '2020-01-06', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59205, '2020-01-07', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59206, '2020-01-08', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59207, '2020-01-09', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59208, '2020-01-10', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59209, '2020-01-11', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59210, '2020-01-12', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59211, '2020-01-13', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59212, '2020-01-14', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59213, '2020-01-15', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59214, '2020-01-16', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59215, '2020-01-17', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59216, '2020-01-18', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59217, '2020-01-19', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59218, '2020-01-20', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59219, '2020-01-21', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59220, '2020-01-22', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59221, '2020-01-23', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59222, '2020-01-24', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59223, '2020-01-25', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59224, '2020-01-26', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59225, '2020-01-27', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59226, '2020-01-28', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59227, '2020-01-29', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59228, '2020-01-30', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59229, '2020-01-31', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59230, '2020-02-01', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59231, '2020-02-02', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59232, '2020-02-03', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59233, '2020-02-04', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59234, '2020-02-05', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59235, '2020-02-06', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59236, '2020-02-07', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59237, '2020-02-08', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59238, '2020-02-09', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59239, '2020-02-10', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59240, '2020-02-11', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59241, '2020-02-12', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59242, '2020-02-13', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59243, '2020-02-14', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59244, '2020-02-15', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59245, '2020-02-16', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59246, '2020-02-17', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59247, '2020-02-18', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59248, '2020-02-19', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59249, '2020-02-20', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59250, '2020-02-21', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59251, '2020-02-22', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59252, '2020-02-23', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59253, '2020-02-24', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59254, '2020-02-25', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59255, '2020-02-26', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59256, '2020-02-27', 'NZ', 'New Zealand', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59257, '2020-02-28', 'NZ', 'New Zealand', 'WPRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59258, '2020-02-29', 'NZ', 'New Zealand', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59259, '2020-03-01', 'NZ', 'New Zealand', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59260, '2020-03-02', 'NZ', 'New Zealand', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59261, '2020-03-03', 'NZ', 'New Zealand', 'WPRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59262, '2020-03-04', 'NZ', 'New Zealand', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59263, '2020-03-05', 'NZ', 'New Zealand', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59264, '2020-03-06', 'NZ', 'New Zealand', 'WPRO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59265, '2020-03-07', 'NZ', 'New Zealand', 'WPRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59266, '2020-03-08', 'NZ', 'New Zealand', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59267, '2020-03-09', 'NZ', 'New Zealand', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59268, '2020-03-10', 'NZ', 'New Zealand', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59269, '2020-03-11', 'NZ', 'New Zealand', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59270, '2020-03-12', 'NZ', 'New Zealand', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59271, '2020-03-13', 'NZ', 'New Zealand', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59272, '2020-03-14', 'NZ', 'New Zealand', 'WPRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59273, '2020-03-15', 'NZ', 'New Zealand', 'WPRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59274, '2020-03-16', 'NZ', 'New Zealand', 'WPRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59275, '2020-03-17', 'NZ', 'New Zealand', 'WPRO', '5', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59276, '2020-03-18', 'NZ', 'New Zealand', 'WPRO', '9', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59277, '2020-03-19', 'NZ', 'New Zealand', 'WPRO', '15', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59278, '2020-03-20', 'NZ', 'New Zealand', 'WPRO', '14', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59279, '2020-03-21', 'NZ', 'New Zealand', 'WPRO', '13', '66', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59280, '2020-03-22', 'NZ', 'New Zealand', 'WPRO', '0', '66', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59281, '2020-03-23', 'NZ', 'New Zealand', 'WPRO', '36', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59282, '2020-03-24', 'NZ', 'New Zealand', 'WPRO', '40', '142', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59283, '2020-03-25', 'NZ', 'New Zealand', 'WPRO', '47', '189', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59284, '2020-03-26', 'NZ', 'New Zealand', 'WPRO', '73', '262', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59285, '2020-03-27', 'NZ', 'New Zealand', 'WPRO', '76', '338', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59286, '2020-03-28', 'NZ', 'New Zealand', 'WPRO', '78', '416', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59287, '2020-03-29', 'NZ', 'New Zealand', 'WPRO', '60', '476', '1', '1');
INSERT INTO public.who_global_data_import VALUES (59288, '2020-03-30', 'NZ', 'New Zealand', 'WPRO', '76', '552', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59289, '2020-03-31', 'NZ', 'New Zealand', 'WPRO', '48', '600', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59290, '2020-04-01', 'NZ', 'New Zealand', 'WPRO', '47', '647', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59291, '2020-04-02', 'NZ', 'New Zealand', 'WPRO', '76', '723', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59292, '2020-04-03', 'NZ', 'New Zealand', 'WPRO', '51', '774', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59293, '2020-04-04', 'NZ', 'New Zealand', 'WPRO', '50', '824', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59294, '2020-04-05', 'NZ', 'New Zealand', 'WPRO', '48', '872', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59295, '2020-04-06', 'NZ', 'New Zealand', 'WPRO', '39', '911', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59296, '2020-04-07', 'NZ', 'New Zealand', 'WPRO', '32', '943', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59297, '2020-04-08', 'NZ', 'New Zealand', 'WPRO', '26', '969', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59298, '2020-04-09', 'NZ', 'New Zealand', 'WPRO', '23', '992', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59299, '2020-04-10', 'NZ', 'New Zealand', 'WPRO', '23', '1015', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59300, '2020-04-11', 'NZ', 'New Zealand', 'WPRO', '20', '1035', '3', '4');
INSERT INTO public.who_global_data_import VALUES (59301, '2020-04-12', 'NZ', 'New Zealand', 'WPRO', '14', '1049', '0', '4');
INSERT INTO public.who_global_data_import VALUES (59302, '2020-04-13', 'NZ', 'New Zealand', 'WPRO', '15', '1064', '1', '5');
INSERT INTO public.who_global_data_import VALUES (59303, '2020-04-14', 'NZ', 'New Zealand', 'WPRO', '8', '1072', '4', '9');
INSERT INTO public.who_global_data_import VALUES (59304, '2020-04-15', 'NZ', 'New Zealand', 'WPRO', '6', '1078', '0', '9');
INSERT INTO public.who_global_data_import VALUES (59305, '2020-04-16', 'NZ', 'New Zealand', 'WPRO', '6', '1084', '0', '9');
INSERT INTO public.who_global_data_import VALUES (59306, '2020-04-17', 'NZ', 'New Zealand', 'WPRO', '2', '1086', '2', '11');
INSERT INTO public.who_global_data_import VALUES (59307, '2020-04-18', 'NZ', 'New Zealand', 'WPRO', '8', '1094', '0', '11');
INSERT INTO public.who_global_data_import VALUES (59308, '2020-04-19', 'NZ', 'New Zealand', 'WPRO', '4', '1098', '0', '11');
INSERT INTO public.who_global_data_import VALUES (59309, '2020-04-20', 'NZ', 'New Zealand', 'WPRO', '7', '1105', '1', '12');
INSERT INTO public.who_global_data_import VALUES (59310, '2020-04-21', 'NZ', 'New Zealand', 'WPRO', '2', '1107', '1', '13');
INSERT INTO public.who_global_data_import VALUES (59311, '2020-04-22', 'NZ', 'New Zealand', 'WPRO', '5', '1112', '1', '14');
INSERT INTO public.who_global_data_import VALUES (59312, '2020-04-23', 'NZ', 'New Zealand', 'WPRO', '0', '1112', '2', '16');
INSERT INTO public.who_global_data_import VALUES (59313, '2020-04-24', 'NZ', 'New Zealand', 'WPRO', '2', '1114', '1', '17');
INSERT INTO public.who_global_data_import VALUES (59314, '2020-04-25', 'NZ', 'New Zealand', 'WPRO', '3', '1117', '1', '18');
INSERT INTO public.who_global_data_import VALUES (59315, '2020-04-26', 'NZ', 'New Zealand', 'WPRO', '4', '1121', '0', '18');
INSERT INTO public.who_global_data_import VALUES (59316, '2020-04-27', 'NZ', 'New Zealand', 'WPRO', '1', '1122', '1', '19');
INSERT INTO public.who_global_data_import VALUES (59317, '2020-04-28', 'NZ', 'New Zealand', 'WPRO', '2', '1124', '0', '19');
INSERT INTO public.who_global_data_import VALUES (59318, '2020-04-29', 'NZ', 'New Zealand', 'WPRO', '2', '1126', '0', '19');
INSERT INTO public.who_global_data_import VALUES (59319, '2020-04-30', 'NZ', 'New Zealand', 'WPRO', '3', '1129', '0', '19');
INSERT INTO public.who_global_data_import VALUES (59320, '2020-05-01', 'NZ', 'New Zealand', 'WPRO', '3', '1132', '0', '19');
INSERT INTO public.who_global_data_import VALUES (59321, '2020-05-02', 'NZ', 'New Zealand', 'WPRO', '2', '1134', '1', '20');
INSERT INTO public.who_global_data_import VALUES (59322, '2020-05-03', 'NZ', 'New Zealand', 'WPRO', '2', '1136', '0', '20');
INSERT INTO public.who_global_data_import VALUES (59323, '2020-05-04', 'NZ', 'New Zealand', 'WPRO', '1', '1137', '0', '20');
INSERT INTO public.who_global_data_import VALUES (59324, '2020-05-05', 'NZ', 'New Zealand', 'WPRO', '0', '1137', '0', '20');
INSERT INTO public.who_global_data_import VALUES (59325, '2020-05-06', 'NZ', 'New Zealand', 'WPRO', '1', '1138', '1', '21');
INSERT INTO public.who_global_data_import VALUES (59326, '2020-05-07', 'NZ', 'New Zealand', 'WPRO', '1', '1139', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59327, '2020-05-08', 'NZ', 'New Zealand', 'WPRO', '2', '1141', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59328, '2020-05-09', 'NZ', 'New Zealand', 'WPRO', '1', '1142', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59329, '2020-05-10', 'NZ', 'New Zealand', 'WPRO', '2', '1144', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59330, '2020-05-11', 'NZ', 'New Zealand', 'WPRO', '3', '1147', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59331, '2020-05-12', 'NZ', 'New Zealand', 'WPRO', '0', '1147', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59332, '2020-05-13', 'NZ', 'New Zealand', 'WPRO', '0', '1147', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59333, '2020-05-14', 'NZ', 'New Zealand', 'WPRO', '0', '1147', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59334, '2020-05-15', 'NZ', 'New Zealand', 'WPRO', '1', '1148', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59335, '2020-05-16', 'NZ', 'New Zealand', 'WPRO', '0', '1148', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59336, '2020-05-17', 'NZ', 'New Zealand', 'WPRO', '1', '1149', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59337, '2020-05-18', 'NZ', 'New Zealand', 'WPRO', '0', '1149', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59338, '2020-05-19', 'NZ', 'New Zealand', 'WPRO', '4', '1153', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59339, '2020-05-20', 'NZ', 'New Zealand', 'WPRO', '0', '1153', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59340, '2020-05-21', 'NZ', 'New Zealand', 'WPRO', '0', '1153', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59341, '2020-05-22', 'NZ', 'New Zealand', 'WPRO', '1', '1154', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59342, '2020-05-23', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59343, '2020-05-24', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59344, '2020-05-25', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59345, '2020-05-26', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59346, '2020-05-27', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '21');
INSERT INTO public.who_global_data_import VALUES (59347, '2020-05-28', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '1', '22');
INSERT INTO public.who_global_data_import VALUES (59348, '2020-05-29', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59349, '2020-05-30', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59350, '2020-05-31', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59351, '2020-06-01', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59352, '2020-06-02', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59353, '2020-06-03', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59354, '2020-06-04', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59355, '2020-06-05', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59356, '2020-06-06', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59357, '2020-06-07', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59358, '2020-06-08', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59359, '2020-06-09', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59360, '2020-06-10', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59361, '2020-06-11', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59362, '2020-06-12', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59363, '2020-06-13', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59364, '2020-06-14', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59365, '2020-06-15', 'NZ', 'New Zealand', 'WPRO', '0', '1154', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59366, '2020-06-16', 'NZ', 'New Zealand', 'WPRO', '2', '1156', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59367, '2020-06-17', 'NZ', 'New Zealand', 'WPRO', '0', '1156', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59368, '2020-06-18', 'NZ', 'New Zealand', 'WPRO', '1', '1157', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59369, '2020-06-19', 'NZ', 'New Zealand', 'WPRO', '0', '1157', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59370, '2020-06-20', 'NZ', 'New Zealand', 'WPRO', '2', '1159', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59371, '2020-06-21', 'NZ', 'New Zealand', 'WPRO', '0', '1159', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59372, '2020-06-22', 'NZ', 'New Zealand', 'WPRO', '4', '1163', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59373, '2020-06-23', 'NZ', 'New Zealand', 'WPRO', '2', '1165', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59374, '2020-06-24', 'NZ', 'New Zealand', 'WPRO', '1', '1166', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59375, '2020-06-25', 'NZ', 'New Zealand', 'WPRO', '3', '1169', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59376, '2020-06-26', 'NZ', 'New Zealand', 'WPRO', '1', '1170', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59377, '2020-06-27', 'NZ', 'New Zealand', 'WPRO', '2', '1172', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59378, '2020-06-28', 'NZ', 'New Zealand', 'WPRO', '4', '1176', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59379, '2020-06-29', 'NZ', 'New Zealand', 'WPRO', '2', '1178', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59380, '2020-06-30', 'NZ', 'New Zealand', 'WPRO', '0', '1178', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59381, '2020-07-01', 'NZ', 'New Zealand', 'WPRO', '0', '1178', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59382, '2020-07-02', 'NZ', 'New Zealand', 'WPRO', '2', '1180', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59383, '2020-07-03', 'NZ', 'New Zealand', 'WPRO', '0', '1180', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59384, '2020-07-04', 'NZ', 'New Zealand', 'WPRO', '0', '1180', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59385, '2020-07-05', 'NZ', 'New Zealand', 'WPRO', '3', '1183', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59386, '2020-07-06', 'NZ', 'New Zealand', 'WPRO', '1', '1184', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59387, '2020-07-07', 'NZ', 'New Zealand', 'WPRO', '2', '1186', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59388, '2020-07-08', 'NZ', 'New Zealand', 'WPRO', '1', '1187', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59389, '2020-07-09', 'NZ', 'New Zealand', 'WPRO', '3', '1190', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59390, '2020-07-10', 'NZ', 'New Zealand', 'WPRO', '2', '1192', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59391, '2020-07-11', 'NZ', 'New Zealand', 'WPRO', '1', '1193', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59392, '2020-07-12', 'NZ', 'New Zealand', 'WPRO', '1', '1194', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59393, '2020-07-13', 'NZ', 'New Zealand', 'WPRO', '0', '1194', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59394, '2020-07-14', 'NZ', 'New Zealand', 'WPRO', '1', '1195', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59395, '2020-07-15', 'NZ', 'New Zealand', 'WPRO', '2', '1197', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59396, '2020-07-16', 'NZ', 'New Zealand', 'WPRO', '1', '1198', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59397, '2020-07-17', 'NZ', 'New Zealand', 'WPRO', '1', '1199', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59398, '2020-07-18', 'NZ', 'New Zealand', 'WPRO', '1', '1200', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59399, '2020-07-19', 'NZ', 'New Zealand', 'WPRO', '3', '1203', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59400, '2020-07-20', 'NZ', 'New Zealand', 'WPRO', '1', '1204', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59401, '2020-07-21', 'NZ', 'New Zealand', 'WPRO', '1', '1205', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59402, '2020-07-22', 'NZ', 'New Zealand', 'WPRO', '0', '1205', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59403, '2020-07-23', 'NZ', 'New Zealand', 'WPRO', '0', '1205', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59404, '2020-07-24', 'NZ', 'New Zealand', 'WPRO', '1', '1206', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59405, '2020-07-25', 'NZ', 'New Zealand', 'WPRO', '0', '1206', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59406, '2020-07-26', 'NZ', 'New Zealand', 'WPRO', '0', '1206', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59407, '2020-07-27', 'NZ', 'New Zealand', 'WPRO', '0', '1206', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59408, '2020-07-28', 'NZ', 'New Zealand', 'WPRO', '1', '1207', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59409, '2020-07-29', 'NZ', 'New Zealand', 'WPRO', '1', '1208', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59410, '2020-07-30', 'NZ', 'New Zealand', 'WPRO', '2', '1210', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59411, '2020-07-31', 'NZ', 'New Zealand', 'WPRO', '0', '1210', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59412, '2020-08-01', 'NZ', 'New Zealand', 'WPRO', '2', '1212', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59413, '2020-08-02', 'NZ', 'New Zealand', 'WPRO', '3', '1215', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59414, '2020-08-03', 'NZ', 'New Zealand', 'WPRO', '2', '1217', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59415, '2020-08-04', 'NZ', 'New Zealand', 'WPRO', '0', '1217', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59416, '2020-08-05', 'NZ', 'New Zealand', 'WPRO', '2', '1219', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59417, '2020-08-06', 'NZ', 'New Zealand', 'WPRO', '0', '1219', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59418, '2020-08-07', 'NZ', 'New Zealand', 'WPRO', '0', '1219', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59419, '2020-08-08', 'NZ', 'New Zealand', 'WPRO', '0', '1219', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59420, '2020-08-09', 'NZ', 'New Zealand', 'WPRO', '0', '1219', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59421, '2020-08-10', 'NZ', 'New Zealand', 'WPRO', '0', '1219', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59422, '2020-08-11', 'NZ', 'New Zealand', 'WPRO', '1', '1220', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59423, '2020-08-12', 'NZ', 'New Zealand', 'WPRO', '4', '1224', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59424, '2020-08-13', 'NZ', 'New Zealand', 'WPRO', '14', '1238', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59425, '2020-08-14', 'NZ', 'New Zealand', 'WPRO', '13', '1251', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59426, '2020-08-15', 'NZ', 'New Zealand', 'WPRO', '7', '1258', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59427, '2020-08-16', 'NZ', 'New Zealand', 'WPRO', '13', '1271', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59428, '2020-08-17', 'NZ', 'New Zealand', 'WPRO', '9', '1280', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59429, '2020-08-18', 'NZ', 'New Zealand', 'WPRO', '13', '1293', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59430, '2020-08-19', 'NZ', 'New Zealand', 'WPRO', '6', '1299', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59431, '2020-08-20', 'NZ', 'New Zealand', 'WPRO', '5', '1304', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59432, '2020-08-21', 'NZ', 'New Zealand', 'WPRO', '11', '1315', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59433, '2020-08-22', 'NZ', 'New Zealand', 'WPRO', '6', '1321', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59434, '2020-08-23', 'NZ', 'New Zealand', 'WPRO', '3', '1324', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59435, '2020-08-24', 'NZ', 'New Zealand', 'WPRO', '8', '1332', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59436, '2020-08-25', 'NZ', 'New Zealand', 'WPRO', '7', '1339', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59437, '2020-08-26', 'NZ', 'New Zealand', 'WPRO', '5', '1344', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59438, '2020-08-27', 'NZ', 'New Zealand', 'WPRO', '7', '1351', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59439, '2020-08-28', 'NZ', 'New Zealand', 'WPRO', '12', '1363', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59440, '2020-08-29', 'NZ', 'New Zealand', 'WPRO', '13', '1376', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59441, '2020-08-30', 'NZ', 'New Zealand', 'WPRO', '2', '1378', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59442, '2020-08-31', 'NZ', 'New Zealand', 'WPRO', '9', '1387', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59443, '2020-09-01', 'NZ', 'New Zealand', 'WPRO', '14', '1401', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59444, '2020-09-02', 'NZ', 'New Zealand', 'WPRO', '5', '1406', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59445, '2020-09-03', 'NZ', 'New Zealand', 'WPRO', '2', '1408', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59446, '2020-09-04', 'NZ', 'New Zealand', 'WPRO', '5', '1413', '0', '22');
INSERT INTO public.who_global_data_import VALUES (59447, '2020-09-05', 'NZ', 'New Zealand', 'WPRO', '3', '1416', '2', '24');
INSERT INTO public.who_global_data_import VALUES (59448, '2020-09-06', 'NZ', 'New Zealand', 'WPRO', '5', '1421', '0', '24');
INSERT INTO public.who_global_data_import VALUES (59449, '2020-09-07', 'NZ', 'New Zealand', 'WPRO', '4', '1425', '0', '24');
INSERT INTO public.who_global_data_import VALUES (59450, '2020-09-08', 'NZ', 'New Zealand', 'WPRO', '6', '1431', '0', '24');
INSERT INTO public.who_global_data_import VALUES (59451, '2020-09-09', 'NZ', 'New Zealand', 'WPRO', '6', '1437', '0', '24');
INSERT INTO public.who_global_data_import VALUES (59452, '2020-09-10', 'NZ', 'New Zealand', 'WPRO', '4', '1441', '0', '24');
INSERT INTO public.who_global_data_import VALUES (59453, '2020-09-11', 'NZ', 'New Zealand', 'WPRO', '1', '1442', '0', '24');
INSERT INTO public.who_global_data_import VALUES (59454, '2020-09-12', 'NZ', 'New Zealand', 'WPRO', '2', '1444', '0', '24');
INSERT INTO public.who_global_data_import VALUES (59455, '2020-09-13', 'NZ', 'New Zealand', 'WPRO', '2', '1446', '0', '24');
INSERT INTO public.who_global_data_import VALUES (59456, '2020-09-14', 'NZ', 'New Zealand', 'WPRO', '1', '1447', '0', '24');
INSERT INTO public.who_global_data_import VALUES (59457, '2020-09-15', 'NZ', 'New Zealand', 'WPRO', '3', '1450', '0', '24');
INSERT INTO public.who_global_data_import VALUES (59458, '2020-09-16', 'NZ', 'New Zealand', 'WPRO', '1', '1451', '1', '25');
INSERT INTO public.who_global_data_import VALUES (59459, '2020-09-17', 'NZ', 'New Zealand', 'WPRO', '7', '1458', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59460, '2020-09-18', 'NZ', 'New Zealand', 'WPRO', '0', '1458', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59461, '2020-09-19', 'NZ', 'New Zealand', 'WPRO', '2', '1460', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59462, '2020-09-20', 'NZ', 'New Zealand', 'WPRO', '4', '1464', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59463, '2020-09-21', 'NZ', 'New Zealand', 'WPRO', '0', '1464', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59464, '2020-09-22', 'NZ', 'New Zealand', 'WPRO', '0', '1464', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59465, '2020-09-23', 'NZ', 'New Zealand', 'WPRO', '4', '1468', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59466, '2020-09-24', 'NZ', 'New Zealand', 'WPRO', '3', '1471', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59467, '2020-09-25', 'NZ', 'New Zealand', 'WPRO', '2', '1473', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59468, '2020-09-26', 'NZ', 'New Zealand', 'WPRO', '2', '1475', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59469, '2020-09-27', 'NZ', 'New Zealand', 'WPRO', '2', '1477', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59470, '2020-09-28', 'NZ', 'New Zealand', 'WPRO', '0', '1477', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59471, '2020-09-29', 'NZ', 'New Zealand', 'WPRO', '2', '1479', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59472, '2020-09-30', 'NZ', 'New Zealand', 'WPRO', '1', '1480', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59473, '2020-10-01', 'NZ', 'New Zealand', 'WPRO', '12', '1492', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59474, '2020-10-02', 'NZ', 'New Zealand', 'WPRO', '0', '1492', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59475, '2020-10-03', 'NZ', 'New Zealand', 'WPRO', '1', '1493', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59476, '2020-10-04', 'NZ', 'New Zealand', 'WPRO', '5', '1498', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59477, '2020-10-05', 'NZ', 'New Zealand', 'WPRO', '1', '1499', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59478, '2020-10-06', 'NZ', 'New Zealand', 'WPRO', '3', '1502', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59479, '2020-10-07', 'NZ', 'New Zealand', 'WPRO', '3', '1505', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59480, '2020-10-08', 'NZ', 'New Zealand', 'WPRO', '3', '1508', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59481, '2020-10-09', 'NZ', 'New Zealand', 'WPRO', '2', '1510', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59482, '2020-10-10', 'NZ', 'New Zealand', 'WPRO', '4', '1514', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59483, '2020-10-11', 'NZ', 'New Zealand', 'WPRO', '1', '1515', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59484, '2020-10-12', 'NZ', 'New Zealand', 'WPRO', '0', '1515', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59485, '2020-10-13', 'NZ', 'New Zealand', 'WPRO', '1', '1516', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59486, '2020-10-14', 'NZ', 'New Zealand', 'WPRO', '2', '1518', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59487, '2020-10-15', 'NZ', 'New Zealand', 'WPRO', '2', '1520', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59488, '2020-10-16', 'NZ', 'New Zealand', 'WPRO', '4', '1524', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59489, '2020-10-17', 'NZ', 'New Zealand', 'WPRO', '3', '1527', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59490, '2020-10-18', 'NZ', 'New Zealand', 'WPRO', '3', '1530', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59491, '2020-10-19', 'NZ', 'New Zealand', 'WPRO', '0', '1530', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59492, '2020-10-20', 'NZ', 'New Zealand', 'WPRO', '1', '1531', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59493, '2020-10-21', 'NZ', 'New Zealand', 'WPRO', '25', '1556', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59494, '2020-10-22', 'NZ', 'New Zealand', 'WPRO', '2', '1558', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59495, '2020-10-23', 'NZ', 'New Zealand', 'WPRO', '9', '1567', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59496, '2020-10-24', 'NZ', 'New Zealand', 'WPRO', '11', '1578', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59497, '2020-10-25', 'NZ', 'New Zealand', 'WPRO', '1', '1579', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59498, '2020-10-26', 'NZ', 'New Zealand', 'WPRO', '5', '1584', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59499, '2020-10-27', 'NZ', 'New Zealand', 'WPRO', '1', '1585', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59500, '2020-10-28', 'NZ', 'New Zealand', 'WPRO', '2', '1587', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59501, '2020-10-29', 'NZ', 'New Zealand', 'WPRO', '6', '1593', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59502, '2020-10-30', 'NZ', 'New Zealand', 'WPRO', '1', '1594', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59503, '2020-10-31', 'NZ', 'New Zealand', 'WPRO', '7', '1601', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59504, '2020-11-01', 'NZ', 'New Zealand', 'WPRO', '2', '1603', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59505, '2020-11-02', 'NZ', 'New Zealand', 'WPRO', '4', '1607', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59506, '2020-11-03', 'NZ', 'New Zealand', 'WPRO', '5', '1612', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59507, '2020-11-04', 'NZ', 'New Zealand', 'WPRO', '3', '1615', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59508, '2020-11-05', 'NZ', 'New Zealand', 'WPRO', '2', '1617', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59509, '2020-11-06', 'NZ', 'New Zealand', 'WPRO', '1', '1618', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59510, '2020-11-07', 'NZ', 'New Zealand', 'WPRO', '2', '1620', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59511, '2020-11-08', 'NZ', 'New Zealand', 'WPRO', '6', '1626', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59512, '2020-11-09', 'NZ', 'New Zealand', 'WPRO', '4', '1630', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59513, '2020-11-10', 'NZ', 'New Zealand', 'WPRO', '1', '1631', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59514, '2020-11-11', 'NZ', 'New Zealand', 'WPRO', '1', '1632', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59515, '2020-11-12', 'NZ', 'New Zealand', 'WPRO', '3', '1635', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59516, '2020-11-13', 'NZ', 'New Zealand', 'WPRO', '4', '1639', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59517, '2020-11-14', 'NZ', 'New Zealand', 'WPRO', '3', '1642', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59518, '2020-11-15', 'NZ', 'New Zealand', 'WPRO', '3', '1645', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59519, '2020-11-16', 'NZ', 'New Zealand', 'WPRO', '0', '1645', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59520, '2020-11-17', 'NZ', 'New Zealand', 'WPRO', '4', '1649', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59521, '2020-11-18', 'NZ', 'New Zealand', 'WPRO', '3', '1652', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59522, '2020-11-19', 'NZ', 'New Zealand', 'WPRO', '2', '1654', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59523, '2020-11-20', 'NZ', 'New Zealand', 'WPRO', '3', '1657', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59524, '2020-11-21', 'NZ', 'New Zealand', 'WPRO', '6', '1663', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59525, '2020-11-22', 'NZ', 'New Zealand', 'WPRO', '9', '1672', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59526, '2020-11-23', 'NZ', 'New Zealand', 'WPRO', '1', '1673', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59527, '2020-11-24', 'NZ', 'New Zealand', 'WPRO', '2', '1675', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59528, '2020-11-25', 'NZ', 'New Zealand', 'WPRO', '8', '1683', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59529, '2020-11-26', 'NZ', 'New Zealand', 'WPRO', '1', '1684', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59530, '2020-11-27', 'NZ', 'New Zealand', 'WPRO', '7', '1691', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59531, '2020-11-28', 'NZ', 'New Zealand', 'WPRO', '3', '1694', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59532, '2020-11-29', 'NZ', 'New Zealand', 'WPRO', '2', '1696', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59533, '2020-11-30', 'NZ', 'New Zealand', 'WPRO', '4', '1700', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59534, '2020-12-01', 'NZ', 'New Zealand', 'WPRO', '3', '1703', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59535, '2020-12-02', 'NZ', 'New Zealand', 'WPRO', '1', '1704', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59536, '2020-12-03', 'NZ', 'New Zealand', 'WPRO', '9', '1713', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59537, '2020-12-04', 'NZ', 'New Zealand', 'WPRO', '0', '1713', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59538, '2020-12-05', 'NZ', 'New Zealand', 'WPRO', '9', '1722', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59539, '2020-12-06', 'NZ', 'New Zealand', 'WPRO', '0', '1722', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59540, '2020-12-07', 'NZ', 'New Zealand', 'WPRO', '1', '1723', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59541, '2020-12-08', 'NZ', 'New Zealand', 'WPRO', '6', '1729', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59542, '2020-12-09', 'NZ', 'New Zealand', 'WPRO', '1', '1730', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59543, '2020-12-10', 'NZ', 'New Zealand', 'WPRO', '0', '1730', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59544, '2020-12-11', 'NZ', 'New Zealand', 'WPRO', '6', '1736', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59545, '2020-12-12', 'NZ', 'New Zealand', 'WPRO', '0', '1736', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59546, '2020-12-13', 'NZ', 'New Zealand', 'WPRO', '4', '1740', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59547, '2020-12-14', 'NZ', 'New Zealand', 'WPRO', '0', '1740', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59548, '2020-12-15', 'NZ', 'New Zealand', 'WPRO', '0', '1740', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59549, '2020-12-16', 'NZ', 'New Zealand', 'WPRO', '4', '1744', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59550, '2020-12-17', 'NZ', 'New Zealand', 'WPRO', '0', '1744', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59551, '2020-12-18', 'NZ', 'New Zealand', 'WPRO', '10', '1754', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59552, '2020-12-19', 'NZ', 'New Zealand', 'WPRO', '0', '1754', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59553, '2020-12-20', 'NZ', 'New Zealand', 'WPRO', '6', '1760', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59554, '2020-12-21', 'NZ', 'New Zealand', 'WPRO', '5', '1765', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59555, '2020-12-22', 'NZ', 'New Zealand', 'WPRO', '0', '1765', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59556, '2020-12-23', 'NZ', 'New Zealand', 'WPRO', '7', '1772', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59557, '2020-12-24', 'NZ', 'New Zealand', 'WPRO', '0', '1772', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59558, '2020-12-25', 'NZ', 'New Zealand', 'WPRO', '0', '1772', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59559, '2020-12-26', 'NZ', 'New Zealand', 'WPRO', '0', '1772', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59560, '2020-12-27', 'NZ', 'New Zealand', 'WPRO', '16', '1788', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59561, '2020-12-28', 'NZ', 'New Zealand', 'WPRO', '0', '1788', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59562, '2020-12-29', 'NZ', 'New Zealand', 'WPRO', '7', '1795', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59563, '2020-12-30', 'NZ', 'New Zealand', 'WPRO', '0', '1795', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59564, '2020-12-31', 'NZ', 'New Zealand', 'WPRO', '11', '1806', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59565, '2021-01-01', 'NZ', 'New Zealand', 'WPRO', '0', '1806', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59566, '2021-01-02', 'NZ', 'New Zealand', 'WPRO', '0', '1806', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59567, '2021-01-03', 'NZ', 'New Zealand', 'WPRO', '19', '1825', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59568, '2021-01-04', 'NZ', 'New Zealand', 'WPRO', '0', '1825', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59569, '2021-01-05', 'NZ', 'New Zealand', 'WPRO', '3', '1828', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59570, '2021-01-06', 'NZ', 'New Zealand', 'WPRO', '0', '1828', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59571, '2021-01-07', 'NZ', 'New Zealand', 'WPRO', '4', '1832', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59572, '2021-01-08', 'NZ', 'New Zealand', 'WPRO', '0', '1832', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59573, '2021-01-09', 'NZ', 'New Zealand', 'WPRO', '0', '1832', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59574, '2021-01-10', 'NZ', 'New Zealand', 'WPRO', '29', '1861', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59575, '2021-01-11', 'NZ', 'New Zealand', 'WPRO', '4', '1865', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59576, '2021-01-12', 'NZ', 'New Zealand', 'WPRO', '0', '1865', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59577, '2021-01-13', 'NZ', 'New Zealand', 'WPRO', '7', '1872', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59578, '2021-01-14', 'NZ', 'New Zealand', 'WPRO', '0', '1872', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59579, '2021-01-15', 'NZ', 'New Zealand', 'WPRO', '18', '1890', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59580, '2021-01-16', 'NZ', 'New Zealand', 'WPRO', '0', '1890', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59581, '2021-01-17', 'NZ', 'New Zealand', 'WPRO', '10', '1900', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59582, '2021-01-18', 'NZ', 'New Zealand', 'WPRO', '5', '1905', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59583, '2021-01-19', 'NZ', 'New Zealand', 'WPRO', '0', '1905', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59584, '2021-01-20', 'NZ', 'New Zealand', 'WPRO', '6', '1911', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59585, '2021-01-21', 'NZ', 'New Zealand', 'WPRO', '0', '1911', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59586, '2021-01-22', 'NZ', 'New Zealand', 'WPRO', '8', '1919', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59587, '2021-01-23', 'NZ', 'New Zealand', 'WPRO', '0', '1919', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59588, '2021-01-24', 'NZ', 'New Zealand', 'WPRO', '7', '1926', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59589, '2021-01-25', 'NZ', 'New Zealand', 'WPRO', '6', '1932', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59590, '2021-01-26', 'NZ', 'New Zealand', 'WPRO', '1', '1933', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59591, '2021-01-27', 'NZ', 'New Zealand', 'WPRO', '5', '1938', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59592, '2021-01-28', 'NZ', 'New Zealand', 'WPRO', '5', '1943', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59593, '2021-01-29', 'NZ', 'New Zealand', 'WPRO', '3', '1946', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59594, '2021-01-30', 'NZ', 'New Zealand', 'WPRO', '1', '1947', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59595, '2021-01-31', 'NZ', 'New Zealand', 'WPRO', '0', '1947', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59596, '2021-02-01', 'NZ', 'New Zealand', 'WPRO', '0', '1947', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59597, '2021-02-02', 'NZ', 'New Zealand', 'WPRO', '2', '1949', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59598, '2021-02-03', 'NZ', 'New Zealand', 'WPRO', '2', '1951', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59599, '2021-02-04', 'NZ', 'New Zealand', 'WPRO', '6', '1957', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59600, '2021-02-05', 'NZ', 'New Zealand', 'WPRO', '2', '1959', '0', '25');
INSERT INTO public.who_global_data_import VALUES (59601, '2020-01-03', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59602, '2020-01-04', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59603, '2020-01-05', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59604, '2020-01-06', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59605, '2020-01-07', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59606, '2020-01-08', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59607, '2020-01-09', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59608, '2020-01-10', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59609, '2020-01-11', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59610, '2020-01-12', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59611, '2020-01-13', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59612, '2020-01-14', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59613, '2020-01-15', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59614, '2020-01-16', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59615, '2020-01-17', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59616, '2020-01-18', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59617, '2020-01-19', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59618, '2020-01-20', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59619, '2020-01-21', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59620, '2020-01-22', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59621, '2020-01-23', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59622, '2020-01-24', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59623, '2020-01-25', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59624, '2020-01-26', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59625, '2020-01-27', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59626, '2020-01-28', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59627, '2020-01-29', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59628, '2020-01-30', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59629, '2020-01-31', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59630, '2020-02-01', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59631, '2020-02-02', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59632, '2020-02-03', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59633, '2020-02-04', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59634, '2020-02-05', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59635, '2020-02-06', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59636, '2020-02-07', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59637, '2020-02-08', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59638, '2020-02-09', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59639, '2020-02-10', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59640, '2020-02-11', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59641, '2020-02-12', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59642, '2020-02-13', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59643, '2020-02-14', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59644, '2020-02-15', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59645, '2020-02-16', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59646, '2020-02-17', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59647, '2020-02-18', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59648, '2020-02-19', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59649, '2020-02-20', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59650, '2020-02-21', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59651, '2020-02-22', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59652, '2020-02-23', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59653, '2020-02-24', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59654, '2020-02-25', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59655, '2020-02-26', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59656, '2020-02-27', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59657, '2020-02-28', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59658, '2020-02-29', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59659, '2020-03-01', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59660, '2020-03-02', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59661, '2020-03-03', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59662, '2020-03-04', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59663, '2020-03-05', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59664, '2020-03-06', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59665, '2020-03-07', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59666, '2020-03-08', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59667, '2020-03-09', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59668, '2020-03-10', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59669, '2020-03-11', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59670, '2020-03-12', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59671, '2020-03-13', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59672, '2020-03-14', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59673, '2020-03-15', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59674, '2020-03-16', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59675, '2020-03-17', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59676, '2020-03-18', 'NI', 'Nicaragua', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59677, '2020-03-19', 'NI', 'Nicaragua', 'AMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59678, '2020-03-20', 'NI', 'Nicaragua', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59679, '2020-03-21', 'NI', 'Nicaragua', 'AMRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59680, '2020-03-22', 'NI', 'Nicaragua', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59681, '2020-03-23', 'NI', 'Nicaragua', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59682, '2020-03-24', 'NI', 'Nicaragua', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59683, '2020-03-25', 'NI', 'Nicaragua', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59684, '2020-03-26', 'NI', 'Nicaragua', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59685, '2020-03-27', 'NI', 'Nicaragua', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (59686, '2020-03-28', 'NI', 'Nicaragua', 'AMRO', '0', '2', '1', '1');
INSERT INTO public.who_global_data_import VALUES (59687, '2020-03-29', 'NI', 'Nicaragua', 'AMRO', '2', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59688, '2020-03-30', 'NI', 'Nicaragua', 'AMRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59689, '2020-03-31', 'NI', 'Nicaragua', 'AMRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59690, '2020-04-01', 'NI', 'Nicaragua', 'AMRO', '0', '4', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59691, '2020-04-02', 'NI', 'Nicaragua', 'AMRO', '1', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59692, '2020-04-03', 'NI', 'Nicaragua', 'AMRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59693, '2020-04-04', 'NI', 'Nicaragua', 'AMRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59694, '2020-04-05', 'NI', 'Nicaragua', 'AMRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59695, '2020-04-06', 'NI', 'Nicaragua', 'AMRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59696, '2020-04-07', 'NI', 'Nicaragua', 'AMRO', '1', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59697, '2020-04-08', 'NI', 'Nicaragua', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59698, '2020-04-09', 'NI', 'Nicaragua', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59699, '2020-04-10', 'NI', 'Nicaragua', 'AMRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59700, '2020-04-11', 'NI', 'Nicaragua', 'AMRO', '1', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59701, '2020-04-12', 'NI', 'Nicaragua', 'AMRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59702, '2020-04-13', 'NI', 'Nicaragua', 'AMRO', '2', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59703, '2020-04-14', 'NI', 'Nicaragua', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59704, '2020-04-15', 'NI', 'Nicaragua', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59705, '2020-04-16', 'NI', 'Nicaragua', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59706, '2020-04-17', 'NI', 'Nicaragua', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59707, '2020-04-18', 'NI', 'Nicaragua', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59708, '2020-04-19', 'NI', 'Nicaragua', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59709, '2020-04-20', 'NI', 'Nicaragua', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (59710, '2020-04-21', 'NI', 'Nicaragua', 'AMRO', '0', '9', '1', '2');
INSERT INTO public.who_global_data_import VALUES (59711, '2020-04-22', 'NI', 'Nicaragua', 'AMRO', '1', '10', '0', '2');
INSERT INTO public.who_global_data_import VALUES (59712, '2020-04-23', 'NI', 'Nicaragua', 'AMRO', '0', '10', '0', '2');
INSERT INTO public.who_global_data_import VALUES (59713, '2020-04-24', 'NI', 'Nicaragua', 'AMRO', '0', '10', '0', '2');
INSERT INTO public.who_global_data_import VALUES (59714, '2020-04-25', 'NI', 'Nicaragua', 'AMRO', '1', '11', '1', '3');
INSERT INTO public.who_global_data_import VALUES (59715, '2020-04-26', 'NI', 'Nicaragua', 'AMRO', '0', '11', '0', '3');
INSERT INTO public.who_global_data_import VALUES (59716, '2020-04-27', 'NI', 'Nicaragua', 'AMRO', '2', '13', '0', '3');
INSERT INTO public.who_global_data_import VALUES (59717, '2020-04-28', 'NI', 'Nicaragua', 'AMRO', '0', '13', '0', '3');
INSERT INTO public.who_global_data_import VALUES (59718, '2020-04-29', 'NI', 'Nicaragua', 'AMRO', '0', '13', '0', '3');
INSERT INTO public.who_global_data_import VALUES (59719, '2020-04-30', 'NI', 'Nicaragua', 'AMRO', '0', '13', '0', '3');
INSERT INTO public.who_global_data_import VALUES (59720, '2020-05-01', 'NI', 'Nicaragua', 'AMRO', '1', '14', '1', '4');
INSERT INTO public.who_global_data_import VALUES (59721, '2020-05-02', 'NI', 'Nicaragua', 'AMRO', '0', '14', '0', '4');
INSERT INTO public.who_global_data_import VALUES (59722, '2020-05-03', 'NI', 'Nicaragua', 'AMRO', '0', '14', '0', '4');
INSERT INTO public.who_global_data_import VALUES (59723, '2020-05-04', 'NI', 'Nicaragua', 'AMRO', '0', '14', '0', '4');
INSERT INTO public.who_global_data_import VALUES (59724, '2020-05-05', 'NI', 'Nicaragua', 'AMRO', '1', '15', '1', '5');
INSERT INTO public.who_global_data_import VALUES (59725, '2020-05-06', 'NI', 'Nicaragua', 'AMRO', '0', '15', '0', '5');
INSERT INTO public.who_global_data_import VALUES (59726, '2020-05-07', 'NI', 'Nicaragua', 'AMRO', '1', '16', '0', '5');
INSERT INTO public.who_global_data_import VALUES (59727, '2020-05-08', 'NI', 'Nicaragua', 'AMRO', '0', '16', '0', '5');
INSERT INTO public.who_global_data_import VALUES (59728, '2020-05-09', 'NI', 'Nicaragua', 'AMRO', '0', '16', '0', '5');
INSERT INTO public.who_global_data_import VALUES (59729, '2020-05-10', 'NI', 'Nicaragua', 'AMRO', '0', '16', '0', '5');
INSERT INTO public.who_global_data_import VALUES (59730, '2020-05-11', 'NI', 'Nicaragua', 'AMRO', '0', '16', '0', '5');
INSERT INTO public.who_global_data_import VALUES (59731, '2020-05-12', 'NI', 'Nicaragua', 'AMRO', '0', '16', '0', '5');
INSERT INTO public.who_global_data_import VALUES (59732, '2020-05-13', 'NI', 'Nicaragua', 'AMRO', '0', '16', '0', '5');
INSERT INTO public.who_global_data_import VALUES (59733, '2020-05-14', 'NI', 'Nicaragua', 'AMRO', '9', '25', '3', '8');
INSERT INTO public.who_global_data_import VALUES (59734, '2020-05-15', 'NI', 'Nicaragua', 'AMRO', '0', '25', '0', '8');
INSERT INTO public.who_global_data_import VALUES (59735, '2020-05-16', 'NI', 'Nicaragua', 'AMRO', '0', '25', '0', '8');
INSERT INTO public.who_global_data_import VALUES (59736, '2020-05-17', 'NI', 'Nicaragua', 'AMRO', '0', '25', '0', '8');
INSERT INTO public.who_global_data_import VALUES (59737, '2020-05-18', 'NI', 'Nicaragua', 'AMRO', '0', '25', '0', '8');
INSERT INTO public.who_global_data_import VALUES (59738, '2020-05-19', 'NI', 'Nicaragua', 'AMRO', '0', '25', '0', '8');
INSERT INTO public.who_global_data_import VALUES (59739, '2020-05-20', 'NI', 'Nicaragua', 'AMRO', '0', '25', '0', '8');
INSERT INTO public.who_global_data_import VALUES (59740, '2020-05-21', 'NI', 'Nicaragua', 'AMRO', '254', '279', '9', '17');
INSERT INTO public.who_global_data_import VALUES (59741, '2020-05-22', 'NI', 'Nicaragua', 'AMRO', '0', '279', '0', '17');
INSERT INTO public.who_global_data_import VALUES (59742, '2020-05-23', 'NI', 'Nicaragua', 'AMRO', '0', '279', '0', '17');
INSERT INTO public.who_global_data_import VALUES (59743, '2020-05-24', 'NI', 'Nicaragua', 'AMRO', '0', '279', '0', '17');
INSERT INTO public.who_global_data_import VALUES (59744, '2020-05-25', 'NI', 'Nicaragua', 'AMRO', '0', '279', '0', '17');
INSERT INTO public.who_global_data_import VALUES (59745, '2020-05-26', 'NI', 'Nicaragua', 'AMRO', '0', '279', '0', '17');
INSERT INTO public.who_global_data_import VALUES (59746, '2020-05-27', 'NI', 'Nicaragua', 'AMRO', '0', '279', '0', '17');
INSERT INTO public.who_global_data_import VALUES (59747, '2020-05-28', 'NI', 'Nicaragua', 'AMRO', '480', '759', '18', '35');
INSERT INTO public.who_global_data_import VALUES (59748, '2020-05-29', 'NI', 'Nicaragua', 'AMRO', '126', '885', '0', '35');
INSERT INTO public.who_global_data_import VALUES (59749, '2020-05-30', 'NI', 'Nicaragua', 'AMRO', '0', '885', '0', '35');
INSERT INTO public.who_global_data_import VALUES (59750, '2020-05-31', 'NI', 'Nicaragua', 'AMRO', '0', '885', '0', '35');
INSERT INTO public.who_global_data_import VALUES (59751, '2020-06-01', 'NI', 'Nicaragua', 'AMRO', '0', '885', '0', '35');
INSERT INTO public.who_global_data_import VALUES (59752, '2020-06-02', 'NI', 'Nicaragua', 'AMRO', '0', '885', '0', '35');
INSERT INTO public.who_global_data_import VALUES (59753, '2020-06-03', 'NI', 'Nicaragua', 'AMRO', '65', '950', '0', '35');
INSERT INTO public.who_global_data_import VALUES (59754, '2020-06-04', 'NI', 'Nicaragua', 'AMRO', '359', '1309', '11', '46');
INSERT INTO public.who_global_data_import VALUES (59755, '2020-06-05', 'NI', 'Nicaragua', 'AMRO', '0', '1309', '0', '46');
INSERT INTO public.who_global_data_import VALUES (59756, '2020-06-06', 'NI', 'Nicaragua', 'AMRO', '0', '1309', '0', '46');
INSERT INTO public.who_global_data_import VALUES (59757, '2020-06-07', 'NI', 'Nicaragua', 'AMRO', '0', '1309', '0', '46');
INSERT INTO public.who_global_data_import VALUES (59758, '2020-06-08', 'NI', 'Nicaragua', 'AMRO', '0', '1309', '0', '46');
INSERT INTO public.who_global_data_import VALUES (59759, '2020-06-09', 'NI', 'Nicaragua', 'AMRO', '0', '1309', '0', '46');
INSERT INTO public.who_global_data_import VALUES (59760, '2020-06-10', 'NI', 'Nicaragua', 'AMRO', '0', '1309', '0', '46');
INSERT INTO public.who_global_data_import VALUES (59761, '2020-06-11', 'NI', 'Nicaragua', 'AMRO', '346', '1655', '9', '55');
INSERT INTO public.who_global_data_import VALUES (59762, '2020-06-12', 'NI', 'Nicaragua', 'AMRO', '0', '1655', '0', '55');
INSERT INTO public.who_global_data_import VALUES (59763, '2020-06-13', 'NI', 'Nicaragua', 'AMRO', '0', '1655', '0', '55');
INSERT INTO public.who_global_data_import VALUES (59764, '2020-06-14', 'NI', 'Nicaragua', 'AMRO', '0', '1655', '0', '55');
INSERT INTO public.who_global_data_import VALUES (59765, '2020-06-15', 'NI', 'Nicaragua', 'AMRO', '0', '1655', '0', '55');
INSERT INTO public.who_global_data_import VALUES (59766, '2020-06-16', 'NI', 'Nicaragua', 'AMRO', '0', '1655', '0', '55');
INSERT INTO public.who_global_data_import VALUES (59767, '2020-06-17', 'NI', 'Nicaragua', 'AMRO', '0', '1655', '0', '55');
INSERT INTO public.who_global_data_import VALUES (59768, '2020-06-18', 'NI', 'Nicaragua', 'AMRO', '359', '2014', '9', '64');
INSERT INTO public.who_global_data_import VALUES (59769, '2020-06-19', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '0', '64');
INSERT INTO public.who_global_data_import VALUES (59770, '2020-06-20', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '0', '64');
INSERT INTO public.who_global_data_import VALUES (59771, '2020-06-21', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '0', '64');
INSERT INTO public.who_global_data_import VALUES (59772, '2020-06-22', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '0', '64');
INSERT INTO public.who_global_data_import VALUES (59773, '2020-06-23', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '0', '64');
INSERT INTO public.who_global_data_import VALUES (59774, '2020-06-24', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '0', '64');
INSERT INTO public.who_global_data_import VALUES (59775, '2020-06-25', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '10', '74');
INSERT INTO public.who_global_data_import VALUES (59776, '2020-06-26', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '0', '74');
INSERT INTO public.who_global_data_import VALUES (59777, '2020-06-27', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '0', '74');
INSERT INTO public.who_global_data_import VALUES (59778, '2020-06-28', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '0', '74');
INSERT INTO public.who_global_data_import VALUES (59779, '2020-06-29', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '0', '74');
INSERT INTO public.who_global_data_import VALUES (59780, '2020-06-30', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '0', '74');
INSERT INTO public.who_global_data_import VALUES (59781, '2020-07-01', 'NI', 'Nicaragua', 'AMRO', '0', '2014', '0', '74');
INSERT INTO public.who_global_data_import VALUES (59782, '2020-07-02', 'NI', 'Nicaragua', 'AMRO', '168', '2182', '9', '83');
INSERT INTO public.who_global_data_import VALUES (59783, '2020-07-03', 'NI', 'Nicaragua', 'AMRO', '0', '2182', '0', '83');
INSERT INTO public.who_global_data_import VALUES (59784, '2020-07-04', 'NI', 'Nicaragua', 'AMRO', '0', '2182', '0', '83');
INSERT INTO public.who_global_data_import VALUES (59785, '2020-07-05', 'NI', 'Nicaragua', 'AMRO', '0', '2182', '0', '83');
INSERT INTO public.who_global_data_import VALUES (59786, '2020-07-06', 'NI', 'Nicaragua', 'AMRO', '0', '2182', '0', '83');
INSERT INTO public.who_global_data_import VALUES (59787, '2020-07-07', 'NI', 'Nicaragua', 'AMRO', '0', '2182', '0', '83');
INSERT INTO public.who_global_data_import VALUES (59788, '2020-07-08', 'NI', 'Nicaragua', 'AMRO', '0', '2182', '0', '83');
INSERT INTO public.who_global_data_import VALUES (59789, '2020-07-09', 'NI', 'Nicaragua', 'AMRO', '229', '2411', '8', '91');
INSERT INTO public.who_global_data_import VALUES (59790, '2020-07-10', 'NI', 'Nicaragua', 'AMRO', '0', '2411', '0', '91');
INSERT INTO public.who_global_data_import VALUES (59791, '2020-07-11', 'NI', 'Nicaragua', 'AMRO', '0', '2411', '0', '91');
INSERT INTO public.who_global_data_import VALUES (59792, '2020-07-12', 'NI', 'Nicaragua', 'AMRO', '0', '2411', '0', '91');
INSERT INTO public.who_global_data_import VALUES (59793, '2020-07-13', 'NI', 'Nicaragua', 'AMRO', '0', '2411', '0', '91');
INSERT INTO public.who_global_data_import VALUES (59794, '2020-07-14', 'NI', 'Nicaragua', 'AMRO', '0', '2411', '0', '91');
INSERT INTO public.who_global_data_import VALUES (59795, '2020-07-15', 'NI', 'Nicaragua', 'AMRO', '301', '2712', '8', '99');
INSERT INTO public.who_global_data_import VALUES (59796, '2020-07-16', 'NI', 'Nicaragua', 'AMRO', '0', '2712', '0', '99');
INSERT INTO public.who_global_data_import VALUES (59797, '2020-07-17', 'NI', 'Nicaragua', 'AMRO', '0', '2712', '0', '99');
INSERT INTO public.who_global_data_import VALUES (59798, '2020-07-18', 'NI', 'Nicaragua', 'AMRO', '0', '2712', '0', '99');
INSERT INTO public.who_global_data_import VALUES (59799, '2020-07-19', 'NI', 'Nicaragua', 'AMRO', '0', '2712', '0', '99');
INSERT INTO public.who_global_data_import VALUES (59800, '2020-07-20', 'NI', 'Nicaragua', 'AMRO', '0', '2712', '0', '99');
INSERT INTO public.who_global_data_import VALUES (59801, '2020-07-21', 'NI', 'Nicaragua', 'AMRO', '0', '2712', '0', '99');
INSERT INTO public.who_global_data_import VALUES (59802, '2020-07-22', 'NI', 'Nicaragua', 'AMRO', '292', '3004', '9', '108');
INSERT INTO public.who_global_data_import VALUES (59803, '2020-07-23', 'NI', 'Nicaragua', 'AMRO', '0', '3004', '0', '108');
INSERT INTO public.who_global_data_import VALUES (59804, '2020-07-24', 'NI', 'Nicaragua', 'AMRO', '0', '3004', '0', '108');
INSERT INTO public.who_global_data_import VALUES (59805, '2020-07-25', 'NI', 'Nicaragua', 'AMRO', '0', '3004', '0', '108');
INSERT INTO public.who_global_data_import VALUES (59806, '2020-07-26', 'NI', 'Nicaragua', 'AMRO', '0', '3004', '0', '108');
INSERT INTO public.who_global_data_import VALUES (59807, '2020-07-27', 'NI', 'Nicaragua', 'AMRO', '0', '3004', '0', '108');
INSERT INTO public.who_global_data_import VALUES (59808, '2020-07-28', 'NI', 'Nicaragua', 'AMRO', '0', '3004', '0', '108');
INSERT INTO public.who_global_data_import VALUES (59809, '2020-07-29', 'NI', 'Nicaragua', 'AMRO', '76', '3080', '8', '116');
INSERT INTO public.who_global_data_import VALUES (59810, '2020-07-30', 'NI', 'Nicaragua', 'AMRO', '0', '3080', '0', '116');
INSERT INTO public.who_global_data_import VALUES (59811, '2020-07-31', 'NI', 'Nicaragua', 'AMRO', '0', '3080', '0', '116');
INSERT INTO public.who_global_data_import VALUES (59812, '2020-08-01', 'NI', 'Nicaragua', 'AMRO', '0', '3080', '0', '116');
INSERT INTO public.who_global_data_import VALUES (59813, '2020-08-02', 'NI', 'Nicaragua', 'AMRO', '0', '3080', '0', '116');
INSERT INTO public.who_global_data_import VALUES (59814, '2020-08-03', 'NI', 'Nicaragua', 'AMRO', '0', '3080', '0', '116');
INSERT INTO public.who_global_data_import VALUES (59815, '2020-08-04', 'NI', 'Nicaragua', 'AMRO', '0', '3080', '0', '116');
INSERT INTO public.who_global_data_import VALUES (59816, '2020-08-05', 'NI', 'Nicaragua', 'AMRO', '186', '3266', '7', '123');
INSERT INTO public.who_global_data_import VALUES (59817, '2020-08-06', 'NI', 'Nicaragua', 'AMRO', '0', '3266', '0', '123');
INSERT INTO public.who_global_data_import VALUES (59818, '2020-08-07', 'NI', 'Nicaragua', 'AMRO', '0', '3266', '0', '123');
INSERT INTO public.who_global_data_import VALUES (59819, '2020-08-08', 'NI', 'Nicaragua', 'AMRO', '0', '3266', '0', '123');
INSERT INTO public.who_global_data_import VALUES (59820, '2020-08-09', 'NI', 'Nicaragua', 'AMRO', '0', '3266', '0', '123');
INSERT INTO public.who_global_data_import VALUES (59821, '2020-08-10', 'NI', 'Nicaragua', 'AMRO', '0', '3266', '0', '123');
INSERT INTO public.who_global_data_import VALUES (59822, '2020-08-11', 'NI', 'Nicaragua', 'AMRO', '0', '3266', '0', '123');
INSERT INTO public.who_global_data_import VALUES (59823, '2020-08-12', 'NI', 'Nicaragua', 'AMRO', '147', '3413', '5', '128');
INSERT INTO public.who_global_data_import VALUES (59824, '2020-08-13', 'NI', 'Nicaragua', 'AMRO', '0', '3413', '0', '128');
INSERT INTO public.who_global_data_import VALUES (59825, '2020-08-14', 'NI', 'Nicaragua', 'AMRO', '0', '3413', '0', '128');
INSERT INTO public.who_global_data_import VALUES (59826, '2020-08-15', 'NI', 'Nicaragua', 'AMRO', '0', '3413', '0', '128');
INSERT INTO public.who_global_data_import VALUES (59827, '2020-08-16', 'NI', 'Nicaragua', 'AMRO', '0', '3413', '0', '128');
INSERT INTO public.who_global_data_import VALUES (59828, '2020-08-17', 'NI', 'Nicaragua', 'AMRO', '0', '3413', '0', '128');
INSERT INTO public.who_global_data_import VALUES (59829, '2020-08-18', 'NI', 'Nicaragua', 'AMRO', '0', '3413', '0', '128');
INSERT INTO public.who_global_data_import VALUES (59830, '2020-08-19', 'NI', 'Nicaragua', 'AMRO', '127', '3540', '5', '133');
INSERT INTO public.who_global_data_import VALUES (59831, '2020-08-20', 'NI', 'Nicaragua', 'AMRO', '0', '3540', '0', '133');
INSERT INTO public.who_global_data_import VALUES (59832, '2020-08-21', 'NI', 'Nicaragua', 'AMRO', '0', '3540', '0', '133');
INSERT INTO public.who_global_data_import VALUES (59833, '2020-08-22', 'NI', 'Nicaragua', 'AMRO', '0', '3540', '0', '133');
INSERT INTO public.who_global_data_import VALUES (59834, '2020-08-23', 'NI', 'Nicaragua', 'AMRO', '0', '3540', '0', '133');
INSERT INTO public.who_global_data_import VALUES (59835, '2020-08-24', 'NI', 'Nicaragua', 'AMRO', '0', '3540', '0', '133');
INSERT INTO public.who_global_data_import VALUES (59836, '2020-08-25', 'NI', 'Nicaragua', 'AMRO', '0', '3540', '0', '133');
INSERT INTO public.who_global_data_import VALUES (59837, '2020-08-26', 'NI', 'Nicaragua', 'AMRO', '119', '3659', '4', '137');
INSERT INTO public.who_global_data_import VALUES (59838, '2020-08-27', 'NI', 'Nicaragua', 'AMRO', '0', '3659', '0', '137');
INSERT INTO public.who_global_data_import VALUES (59839, '2020-08-28', 'NI', 'Nicaragua', 'AMRO', '0', '3659', '0', '137');
INSERT INTO public.who_global_data_import VALUES (59840, '2020-08-29', 'NI', 'Nicaragua', 'AMRO', '0', '3659', '0', '137');
INSERT INTO public.who_global_data_import VALUES (59841, '2020-08-30', 'NI', 'Nicaragua', 'AMRO', '0', '3659', '0', '137');
INSERT INTO public.who_global_data_import VALUES (59842, '2020-08-31', 'NI', 'Nicaragua', 'AMRO', '0', '3659', '0', '137');
INSERT INTO public.who_global_data_import VALUES (59843, '2020-09-01', 'NI', 'Nicaragua', 'AMRO', '0', '3659', '0', '137');
INSERT INTO public.who_global_data_import VALUES (59844, '2020-09-02', 'NI', 'Nicaragua', 'AMRO', '114', '3773', '4', '141');
INSERT INTO public.who_global_data_import VALUES (59845, '2020-09-03', 'NI', 'Nicaragua', 'AMRO', '0', '3773', '0', '141');
INSERT INTO public.who_global_data_import VALUES (59846, '2020-09-04', 'NI', 'Nicaragua', 'AMRO', '0', '3773', '0', '141');
INSERT INTO public.who_global_data_import VALUES (59847, '2020-09-05', 'NI', 'Nicaragua', 'AMRO', '0', '3773', '0', '141');
INSERT INTO public.who_global_data_import VALUES (59848, '2020-09-06', 'NI', 'Nicaragua', 'AMRO', '0', '3773', '0', '141');
INSERT INTO public.who_global_data_import VALUES (59849, '2020-09-07', 'NI', 'Nicaragua', 'AMRO', '0', '3773', '0', '141');
INSERT INTO public.who_global_data_import VALUES (59850, '2020-09-08', 'NI', 'Nicaragua', 'AMRO', '0', '3773', '0', '141');
INSERT INTO public.who_global_data_import VALUES (59851, '2020-09-09', 'NI', 'Nicaragua', 'AMRO', '104', '3877', '3', '144');
INSERT INTO public.who_global_data_import VALUES (59852, '2020-09-10', 'NI', 'Nicaragua', 'AMRO', '0', '3877', '0', '144');
INSERT INTO public.who_global_data_import VALUES (59853, '2020-09-11', 'NI', 'Nicaragua', 'AMRO', '0', '3877', '0', '144');
INSERT INTO public.who_global_data_import VALUES (59854, '2020-09-12', 'NI', 'Nicaragua', 'AMRO', '0', '3877', '0', '144');
INSERT INTO public.who_global_data_import VALUES (59855, '2020-09-13', 'NI', 'Nicaragua', 'AMRO', '0', '3877', '0', '144');
INSERT INTO public.who_global_data_import VALUES (59856, '2020-09-14', 'NI', 'Nicaragua', 'AMRO', '0', '3877', '0', '144');
INSERT INTO public.who_global_data_import VALUES (59857, '2020-09-15', 'NI', 'Nicaragua', 'AMRO', '0', '3877', '0', '144');
INSERT INTO public.who_global_data_import VALUES (59858, '2020-09-16', 'NI', 'Nicaragua', 'AMRO', '102', '3979', '3', '147');
INSERT INTO public.who_global_data_import VALUES (59859, '2020-09-17', 'NI', 'Nicaragua', 'AMRO', '0', '3979', '0', '147');
INSERT INTO public.who_global_data_import VALUES (59860, '2020-09-18', 'NI', 'Nicaragua', 'AMRO', '0', '3979', '0', '147');
INSERT INTO public.who_global_data_import VALUES (59861, '2020-09-19', 'NI', 'Nicaragua', 'AMRO', '0', '3979', '0', '147');
INSERT INTO public.who_global_data_import VALUES (59862, '2020-09-20', 'NI', 'Nicaragua', 'AMRO', '0', '3979', '0', '147');
INSERT INTO public.who_global_data_import VALUES (59863, '2020-09-21', 'NI', 'Nicaragua', 'AMRO', '0', '3979', '0', '147');
INSERT INTO public.who_global_data_import VALUES (59864, '2020-09-22', 'NI', 'Nicaragua', 'AMRO', '0', '3979', '0', '147');
INSERT INTO public.who_global_data_import VALUES (59865, '2020-09-23', 'NI', 'Nicaragua', 'AMRO', '86', '4065', '2', '149');
INSERT INTO public.who_global_data_import VALUES (59866, '2020-09-24', 'NI', 'Nicaragua', 'AMRO', '0', '4065', '0', '149');
INSERT INTO public.who_global_data_import VALUES (59867, '2020-09-25', 'NI', 'Nicaragua', 'AMRO', '0', '4065', '0', '149');
INSERT INTO public.who_global_data_import VALUES (59868, '2020-09-26', 'NI', 'Nicaragua', 'AMRO', '0', '4065', '0', '149');
INSERT INTO public.who_global_data_import VALUES (59869, '2020-09-27', 'NI', 'Nicaragua', 'AMRO', '0', '4065', '0', '149');
INSERT INTO public.who_global_data_import VALUES (59870, '2020-09-28', 'NI', 'Nicaragua', 'AMRO', '0', '4065', '0', '149');
INSERT INTO public.who_global_data_import VALUES (59871, '2020-09-29', 'NI', 'Nicaragua', 'AMRO', '0', '4065', '0', '149');
INSERT INTO public.who_global_data_import VALUES (59872, '2020-09-30', 'NI', 'Nicaragua', 'AMRO', '81', '4146', '2', '151');
INSERT INTO public.who_global_data_import VALUES (59873, '2020-10-01', 'NI', 'Nicaragua', 'AMRO', '0', '4146', '0', '151');
INSERT INTO public.who_global_data_import VALUES (59874, '2020-10-02', 'NI', 'Nicaragua', 'AMRO', '0', '4146', '0', '151');
INSERT INTO public.who_global_data_import VALUES (59875, '2020-10-03', 'NI', 'Nicaragua', 'AMRO', '0', '4146', '0', '151');
INSERT INTO public.who_global_data_import VALUES (59876, '2020-10-04', 'NI', 'Nicaragua', 'AMRO', '0', '4146', '0', '151');
INSERT INTO public.who_global_data_import VALUES (59877, '2020-10-05', 'NI', 'Nicaragua', 'AMRO', '0', '4146', '0', '151');
INSERT INTO public.who_global_data_import VALUES (59878, '2020-10-06', 'NI', 'Nicaragua', 'AMRO', '0', '4146', '0', '151');
INSERT INTO public.who_global_data_import VALUES (59879, '2020-10-07', 'NI', 'Nicaragua', 'AMRO', '79', '4225', '2', '153');
INSERT INTO public.who_global_data_import VALUES (59880, '2020-10-08', 'NI', 'Nicaragua', 'AMRO', '0', '4225', '0', '153');
INSERT INTO public.who_global_data_import VALUES (59881, '2020-10-09', 'NI', 'Nicaragua', 'AMRO', '0', '4225', '0', '153');
INSERT INTO public.who_global_data_import VALUES (59882, '2020-10-10', 'NI', 'Nicaragua', 'AMRO', '0', '4225', '0', '153');
INSERT INTO public.who_global_data_import VALUES (59883, '2020-10-11', 'NI', 'Nicaragua', 'AMRO', '0', '4225', '0', '153');
INSERT INTO public.who_global_data_import VALUES (59884, '2020-10-12', 'NI', 'Nicaragua', 'AMRO', '0', '4225', '0', '153');
INSERT INTO public.who_global_data_import VALUES (59885, '2020-10-13', 'NI', 'Nicaragua', 'AMRO', '0', '4225', '0', '153');
INSERT INTO public.who_global_data_import VALUES (59886, '2020-10-14', 'NI', 'Nicaragua', 'AMRO', '72', '4297', '1', '154');
INSERT INTO public.who_global_data_import VALUES (59887, '2020-10-15', 'NI', 'Nicaragua', 'AMRO', '0', '4297', '0', '154');
INSERT INTO public.who_global_data_import VALUES (59888, '2020-10-16', 'NI', 'Nicaragua', 'AMRO', '0', '4297', '0', '154');
INSERT INTO public.who_global_data_import VALUES (59889, '2020-10-17', 'NI', 'Nicaragua', 'AMRO', '0', '4297', '0', '154');
INSERT INTO public.who_global_data_import VALUES (59890, '2020-10-18', 'NI', 'Nicaragua', 'AMRO', '0', '4297', '0', '154');
INSERT INTO public.who_global_data_import VALUES (59891, '2020-10-19', 'NI', 'Nicaragua', 'AMRO', '0', '4297', '0', '154');
INSERT INTO public.who_global_data_import VALUES (59892, '2020-10-20', 'NI', 'Nicaragua', 'AMRO', '0', '4297', '0', '154');
INSERT INTO public.who_global_data_import VALUES (59893, '2020-10-21', 'NI', 'Nicaragua', 'AMRO', '65', '4362', '1', '155');
INSERT INTO public.who_global_data_import VALUES (59894, '2020-10-22', 'NI', 'Nicaragua', 'AMRO', '0', '4362', '0', '155');
INSERT INTO public.who_global_data_import VALUES (59895, '2020-10-23', 'NI', 'Nicaragua', 'AMRO', '0', '4362', '0', '155');
INSERT INTO public.who_global_data_import VALUES (59896, '2020-10-24', 'NI', 'Nicaragua', 'AMRO', '0', '4362', '0', '155');
INSERT INTO public.who_global_data_import VALUES (59897, '2020-10-25', 'NI', 'Nicaragua', 'AMRO', '0', '4362', '0', '155');
INSERT INTO public.who_global_data_import VALUES (59898, '2020-10-26', 'NI', 'Nicaragua', 'AMRO', '0', '4362', '0', '155');
INSERT INTO public.who_global_data_import VALUES (59899, '2020-10-27', 'NI', 'Nicaragua', 'AMRO', '0', '4362', '0', '155');
INSERT INTO public.who_global_data_import VALUES (59900, '2020-10-28', 'NI', 'Nicaragua', 'AMRO', '62', '4424', '1', '156');
INSERT INTO public.who_global_data_import VALUES (59901, '2020-10-29', 'NI', 'Nicaragua', 'AMRO', '0', '4424', '0', '156');
INSERT INTO public.who_global_data_import VALUES (59902, '2020-10-30', 'NI', 'Nicaragua', 'AMRO', '0', '4424', '0', '156');
INSERT INTO public.who_global_data_import VALUES (59903, '2020-10-31', 'NI', 'Nicaragua', 'AMRO', '0', '4424', '0', '156');
INSERT INTO public.who_global_data_import VALUES (59904, '2020-11-01', 'NI', 'Nicaragua', 'AMRO', '0', '4424', '0', '156');
INSERT INTO public.who_global_data_import VALUES (59905, '2020-11-02', 'NI', 'Nicaragua', 'AMRO', '0', '4424', '0', '156');
INSERT INTO public.who_global_data_import VALUES (59906, '2020-11-03', 'NI', 'Nicaragua', 'AMRO', '0', '4424', '0', '156');
INSERT INTO public.who_global_data_import VALUES (59907, '2020-11-04', 'NI', 'Nicaragua', 'AMRO', '56', '4480', '1', '157');
INSERT INTO public.who_global_data_import VALUES (59908, '2020-11-05', 'NI', 'Nicaragua', 'AMRO', '0', '4480', '0', '157');
INSERT INTO public.who_global_data_import VALUES (59909, '2020-11-06', 'NI', 'Nicaragua', 'AMRO', '0', '4480', '0', '157');
INSERT INTO public.who_global_data_import VALUES (59910, '2020-11-07', 'NI', 'Nicaragua', 'AMRO', '0', '4480', '0', '157');
INSERT INTO public.who_global_data_import VALUES (59911, '2020-11-08', 'NI', 'Nicaragua', 'AMRO', '0', '4480', '0', '157');
INSERT INTO public.who_global_data_import VALUES (59912, '2020-11-09', 'NI', 'Nicaragua', 'AMRO', '0', '4480', '0', '157');
INSERT INTO public.who_global_data_import VALUES (59913, '2020-11-10', 'NI', 'Nicaragua', 'AMRO', '0', '4480', '0', '157');
INSERT INTO public.who_global_data_import VALUES (59914, '2020-11-11', 'NI', 'Nicaragua', 'AMRO', '53', '4533', '1', '158');
INSERT INTO public.who_global_data_import VALUES (59915, '2020-11-12', 'NI', 'Nicaragua', 'AMRO', '0', '4533', '0', '158');
INSERT INTO public.who_global_data_import VALUES (59916, '2020-11-13', 'NI', 'Nicaragua', 'AMRO', '0', '4533', '0', '158');
INSERT INTO public.who_global_data_import VALUES (59917, '2020-11-14', 'NI', 'Nicaragua', 'AMRO', '0', '4533', '0', '158');
INSERT INTO public.who_global_data_import VALUES (59918, '2020-11-15', 'NI', 'Nicaragua', 'AMRO', '0', '4533', '0', '158');
INSERT INTO public.who_global_data_import VALUES (59919, '2020-11-16', 'NI', 'Nicaragua', 'AMRO', '0', '4533', '0', '158');
INSERT INTO public.who_global_data_import VALUES (59920, '2020-11-17', 'NI', 'Nicaragua', 'AMRO', '0', '4533', '0', '158');
INSERT INTO public.who_global_data_import VALUES (59921, '2020-11-18', 'NI', 'Nicaragua', 'AMRO', '50', '4583', '1', '159');
INSERT INTO public.who_global_data_import VALUES (59922, '2020-11-19', 'NI', 'Nicaragua', 'AMRO', '0', '4583', '0', '159');
INSERT INTO public.who_global_data_import VALUES (59923, '2020-11-20', 'NI', 'Nicaragua', 'AMRO', '0', '4583', '0', '159');
INSERT INTO public.who_global_data_import VALUES (59924, '2020-11-21', 'NI', 'Nicaragua', 'AMRO', '0', '4583', '0', '159');
INSERT INTO public.who_global_data_import VALUES (59925, '2020-11-22', 'NI', 'Nicaragua', 'AMRO', '0', '4583', '0', '159');
INSERT INTO public.who_global_data_import VALUES (59926, '2020-11-23', 'NI', 'Nicaragua', 'AMRO', '0', '4583', '0', '159');
INSERT INTO public.who_global_data_import VALUES (59927, '2020-11-24', 'NI', 'Nicaragua', 'AMRO', '0', '4583', '0', '159');
INSERT INTO public.who_global_data_import VALUES (59928, '2020-11-25', 'NI', 'Nicaragua', 'AMRO', '46', '4629', '1', '160');
INSERT INTO public.who_global_data_import VALUES (59929, '2020-11-26', 'NI', 'Nicaragua', 'AMRO', '0', '4629', '0', '160');
INSERT INTO public.who_global_data_import VALUES (59930, '2020-11-27', 'NI', 'Nicaragua', 'AMRO', '0', '4629', '0', '160');
INSERT INTO public.who_global_data_import VALUES (59931, '2020-11-28', 'NI', 'Nicaragua', 'AMRO', '0', '4629', '0', '160');
INSERT INTO public.who_global_data_import VALUES (59932, '2020-11-29', 'NI', 'Nicaragua', 'AMRO', '0', '4629', '0', '160');
INSERT INTO public.who_global_data_import VALUES (59933, '2020-11-30', 'NI', 'Nicaragua', 'AMRO', '0', '4629', '0', '160');
INSERT INTO public.who_global_data_import VALUES (59934, '2020-12-01', 'NI', 'Nicaragua', 'AMRO', '0', '4629', '0', '160');
INSERT INTO public.who_global_data_import VALUES (59935, '2020-12-02', 'NI', 'Nicaragua', 'AMRO', '42', '4671', '1', '161');
INSERT INTO public.who_global_data_import VALUES (59936, '2020-12-03', 'NI', 'Nicaragua', 'AMRO', '0', '4671', '0', '161');
INSERT INTO public.who_global_data_import VALUES (59937, '2020-12-04', 'NI', 'Nicaragua', 'AMRO', '0', '4671', '0', '161');
INSERT INTO public.who_global_data_import VALUES (59938, '2020-12-05', 'NI', 'Nicaragua', 'AMRO', '0', '4671', '0', '161');
INSERT INTO public.who_global_data_import VALUES (59939, '2020-12-06', 'NI', 'Nicaragua', 'AMRO', '0', '4671', '0', '161');
INSERT INTO public.who_global_data_import VALUES (59940, '2020-12-07', 'NI', 'Nicaragua', 'AMRO', '0', '4671', '0', '161');
INSERT INTO public.who_global_data_import VALUES (59941, '2020-12-08', 'NI', 'Nicaragua', 'AMRO', '0', '4671', '0', '161');
INSERT INTO public.who_global_data_import VALUES (59942, '2020-12-09', 'NI', 'Nicaragua', 'AMRO', '38', '4709', '1', '162');
INSERT INTO public.who_global_data_import VALUES (59943, '2020-12-10', 'NI', 'Nicaragua', 'AMRO', '0', '4709', '0', '162');
INSERT INTO public.who_global_data_import VALUES (59944, '2020-12-11', 'NI', 'Nicaragua', 'AMRO', '0', '4709', '0', '162');
INSERT INTO public.who_global_data_import VALUES (59945, '2020-12-12', 'NI', 'Nicaragua', 'AMRO', '0', '4709', '0', '162');
INSERT INTO public.who_global_data_import VALUES (59946, '2020-12-13', 'NI', 'Nicaragua', 'AMRO', '0', '4709', '0', '162');
INSERT INTO public.who_global_data_import VALUES (59947, '2020-12-14', 'NI', 'Nicaragua', 'AMRO', '0', '4709', '0', '162');
INSERT INTO public.who_global_data_import VALUES (59948, '2020-12-15', 'NI', 'Nicaragua', 'AMRO', '0', '4709', '0', '162');
INSERT INTO public.who_global_data_import VALUES (59949, '2020-12-16', 'NI', 'Nicaragua', 'AMRO', '39', '4748', '1', '163');
INSERT INTO public.who_global_data_import VALUES (59950, '2020-12-17', 'NI', 'Nicaragua', 'AMRO', '0', '4748', '0', '163');
INSERT INTO public.who_global_data_import VALUES (59951, '2020-12-18', 'NI', 'Nicaragua', 'AMRO', '0', '4748', '0', '163');
INSERT INTO public.who_global_data_import VALUES (59952, '2020-12-19', 'NI', 'Nicaragua', 'AMRO', '0', '4748', '0', '163');
INSERT INTO public.who_global_data_import VALUES (59953, '2020-12-20', 'NI', 'Nicaragua', 'AMRO', '0', '4748', '0', '163');
INSERT INTO public.who_global_data_import VALUES (59954, '2020-12-21', 'NI', 'Nicaragua', 'AMRO', '0', '4748', '0', '163');
INSERT INTO public.who_global_data_import VALUES (59955, '2020-12-22', 'NI', 'Nicaragua', 'AMRO', '42', '4790', '1', '164');
INSERT INTO public.who_global_data_import VALUES (59956, '2020-12-23', 'NI', 'Nicaragua', 'AMRO', '0', '4790', '0', '164');
INSERT INTO public.who_global_data_import VALUES (59957, '2020-12-24', 'NI', 'Nicaragua', 'AMRO', '0', '4790', '0', '164');
INSERT INTO public.who_global_data_import VALUES (59958, '2020-12-25', 'NI', 'Nicaragua', 'AMRO', '0', '4790', '0', '164');
INSERT INTO public.who_global_data_import VALUES (59959, '2020-12-26', 'NI', 'Nicaragua', 'AMRO', '0', '4790', '0', '164');
INSERT INTO public.who_global_data_import VALUES (59960, '2020-12-27', 'NI', 'Nicaragua', 'AMRO', '0', '4790', '0', '164');
INSERT INTO public.who_global_data_import VALUES (59961, '2020-12-28', 'NI', 'Nicaragua', 'AMRO', '0', '4790', '0', '164');
INSERT INTO public.who_global_data_import VALUES (59962, '2020-12-29', 'NI', 'Nicaragua', 'AMRO', '0', '4790', '0', '164');
INSERT INTO public.who_global_data_import VALUES (59963, '2020-12-30', 'NI', 'Nicaragua', 'AMRO', '39', '4829', '1', '165');
INSERT INTO public.who_global_data_import VALUES (59964, '2020-12-31', 'NI', 'Nicaragua', 'AMRO', '0', '4829', '0', '165');
INSERT INTO public.who_global_data_import VALUES (59965, '2021-01-01', 'NI', 'Nicaragua', 'AMRO', '0', '4829', '0', '165');
INSERT INTO public.who_global_data_import VALUES (59966, '2021-01-02', 'NI', 'Nicaragua', 'AMRO', '0', '4829', '0', '165');
INSERT INTO public.who_global_data_import VALUES (59967, '2021-01-03', 'NI', 'Nicaragua', 'AMRO', '0', '4829', '0', '165');
INSERT INTO public.who_global_data_import VALUES (59968, '2021-01-04', 'NI', 'Nicaragua', 'AMRO', '0', '4829', '0', '165');
INSERT INTO public.who_global_data_import VALUES (59969, '2021-01-05', 'NI', 'Nicaragua', 'AMRO', '0', '4829', '0', '165');
INSERT INTO public.who_global_data_import VALUES (59970, '2021-01-06', 'NI', 'Nicaragua', 'AMRO', '38', '4867', '1', '166');
INSERT INTO public.who_global_data_import VALUES (59971, '2021-01-07', 'NI', 'Nicaragua', 'AMRO', '0', '4867', '0', '166');
INSERT INTO public.who_global_data_import VALUES (59972, '2021-01-08', 'NI', 'Nicaragua', 'AMRO', '0', '4867', '0', '166');
INSERT INTO public.who_global_data_import VALUES (59973, '2021-01-09', 'NI', 'Nicaragua', 'AMRO', '0', '4867', '0', '166');
INSERT INTO public.who_global_data_import VALUES (59974, '2021-01-10', 'NI', 'Nicaragua', 'AMRO', '0', '4867', '0', '166');
INSERT INTO public.who_global_data_import VALUES (59975, '2021-01-11', 'NI', 'Nicaragua', 'AMRO', '0', '4867', '0', '166');
INSERT INTO public.who_global_data_import VALUES (59976, '2021-01-12', 'NI', 'Nicaragua', 'AMRO', '0', '4867', '0', '166');
INSERT INTO public.who_global_data_import VALUES (59977, '2021-01-13', 'NI', 'Nicaragua', 'AMRO', '49', '4916', '1', '167');
INSERT INTO public.who_global_data_import VALUES (59978, '2021-01-14', 'NI', 'Nicaragua', 'AMRO', '0', '4916', '0', '167');
INSERT INTO public.who_global_data_import VALUES (59979, '2021-01-15', 'NI', 'Nicaragua', 'AMRO', '0', '4916', '0', '167');
INSERT INTO public.who_global_data_import VALUES (59980, '2021-01-16', 'NI', 'Nicaragua', 'AMRO', '0', '4916', '0', '167');
INSERT INTO public.who_global_data_import VALUES (59981, '2021-01-17', 'NI', 'Nicaragua', 'AMRO', '0', '4916', '0', '167');
INSERT INTO public.who_global_data_import VALUES (59982, '2021-01-18', 'NI', 'Nicaragua', 'AMRO', '0', '4916', '0', '167');
INSERT INTO public.who_global_data_import VALUES (59983, '2021-01-19', 'NI', 'Nicaragua', 'AMRO', '0', '4916', '0', '167');
INSERT INTO public.who_global_data_import VALUES (59984, '2021-01-20', 'NI', 'Nicaragua', 'AMRO', '37', '4953', '1', '168');
INSERT INTO public.who_global_data_import VALUES (59985, '2021-01-21', 'NI', 'Nicaragua', 'AMRO', '0', '4953', '0', '168');
INSERT INTO public.who_global_data_import VALUES (59986, '2021-01-22', 'NI', 'Nicaragua', 'AMRO', '0', '4953', '0', '168');
INSERT INTO public.who_global_data_import VALUES (59987, '2021-01-23', 'NI', 'Nicaragua', 'AMRO', '0', '4953', '0', '168');
INSERT INTO public.who_global_data_import VALUES (59988, '2021-01-24', 'NI', 'Nicaragua', 'AMRO', '0', '4953', '0', '168');
INSERT INTO public.who_global_data_import VALUES (59989, '2021-01-25', 'NI', 'Nicaragua', 'AMRO', '0', '4953', '0', '168');
INSERT INTO public.who_global_data_import VALUES (59990, '2021-01-26', 'NI', 'Nicaragua', 'AMRO', '0', '4953', '0', '168');
INSERT INTO public.who_global_data_import VALUES (59991, '2021-01-27', 'NI', 'Nicaragua', 'AMRO', '39', '4992', '1', '169');
INSERT INTO public.who_global_data_import VALUES (59992, '2021-01-28', 'NI', 'Nicaragua', 'AMRO', '0', '4992', '0', '169');
INSERT INTO public.who_global_data_import VALUES (59993, '2021-01-29', 'NI', 'Nicaragua', 'AMRO', '0', '4992', '0', '169');
INSERT INTO public.who_global_data_import VALUES (59994, '2021-01-30', 'NI', 'Nicaragua', 'AMRO', '0', '4992', '0', '169');
INSERT INTO public.who_global_data_import VALUES (59995, '2021-01-31', 'NI', 'Nicaragua', 'AMRO', '0', '4992', '0', '169');
INSERT INTO public.who_global_data_import VALUES (59996, '2021-02-01', 'NI', 'Nicaragua', 'AMRO', '0', '4992', '0', '169');
INSERT INTO public.who_global_data_import VALUES (59997, '2021-02-02', 'NI', 'Nicaragua', 'AMRO', '0', '4992', '0', '169');
INSERT INTO public.who_global_data_import VALUES (59998, '2021-02-03', 'NI', 'Nicaragua', 'AMRO', '35', '5027', '1', '170');
INSERT INTO public.who_global_data_import VALUES (59999, '2021-02-04', 'NI', 'Nicaragua', 'AMRO', '0', '5027', '0', '170');
INSERT INTO public.who_global_data_import VALUES (60000, '2021-02-05', 'NI', 'Nicaragua', 'AMRO', '0', '5027', '0', '170');
INSERT INTO public.who_global_data_import VALUES (60001, '2020-01-03', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60002, '2020-01-04', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60003, '2020-01-05', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60004, '2020-01-06', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60005, '2020-01-07', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60006, '2020-01-08', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60007, '2020-01-09', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60008, '2020-01-10', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60009, '2020-01-11', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60010, '2020-01-12', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60011, '2020-01-13', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60012, '2020-01-14', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60013, '2020-01-15', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60014, '2020-01-16', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60015, '2020-01-17', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60016, '2020-01-18', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60017, '2020-01-19', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60018, '2020-01-20', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60019, '2020-01-21', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60020, '2020-01-22', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60021, '2020-01-23', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60022, '2020-01-24', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60023, '2020-01-25', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60024, '2020-01-26', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60025, '2020-01-27', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60026, '2020-01-28', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60029, '2020-01-31', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60030, '2020-02-01', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60031, '2020-02-02', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60032, '2020-02-03', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60033, '2020-02-04', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60034, '2020-02-05', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60035, '2020-02-06', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60036, '2020-02-07', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60037, '2020-02-08', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60038, '2020-02-09', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60039, '2020-02-10', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60040, '2020-02-11', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60041, '2020-02-12', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60042, '2020-02-13', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60043, '2020-02-14', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60044, '2020-02-15', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60045, '2020-02-16', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60046, '2020-02-17', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60047, '2020-02-18', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60048, '2020-02-19', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60049, '2020-02-20', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60050, '2020-02-21', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60051, '2020-02-22', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60052, '2020-02-23', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60053, '2020-02-24', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60054, '2020-02-25', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60055, '2020-02-26', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60056, '2020-02-27', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60057, '2020-02-28', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60058, '2020-02-29', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60059, '2020-03-01', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60060, '2020-03-02', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60061, '2020-03-03', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60062, '2020-03-04', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60063, '2020-03-05', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60064, '2020-03-06', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60065, '2020-03-07', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60066, '2020-03-08', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60067, '2020-03-09', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60068, '2020-03-10', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60069, '2020-03-11', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60070, '2020-03-12', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60071, '2020-03-13', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60072, '2020-03-14', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60073, '2020-03-15', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60074, '2020-03-16', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60075, '2020-03-17', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60076, '2020-03-18', 'NE', 'Niger', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60077, '2020-03-19', 'NE', 'Niger', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60078, '2020-03-20', 'NE', 'Niger', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60079, '2020-03-21', 'NE', 'Niger', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60080, '2020-03-22', 'NE', 'Niger', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60081, '2020-03-23', 'NE', 'Niger', 'AFRO', '-3', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60082, '2020-03-24', 'NE', 'Niger', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60083, '2020-03-25', 'NE', 'Niger', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60084, '2020-03-26', 'NE', 'Niger', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60085, '2020-03-27', 'NE', 'Niger', 'AFRO', '8', '10', '1', '1');
INSERT INTO public.who_global_data_import VALUES (60086, '2020-03-28', 'NE', 'Niger', 'AFRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (60087, '2020-03-29', 'NE', 'Niger', 'AFRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (60088, '2020-03-30', 'NE', 'Niger', 'AFRO', '10', '20', '2', '3');
INSERT INTO public.who_global_data_import VALUES (60089, '2020-03-31', 'NE', 'Niger', 'AFRO', '0', '20', '0', '3');
INSERT INTO public.who_global_data_import VALUES (60090, '2020-04-01', 'NE', 'Niger', 'AFRO', '0', '20', '0', '3');
INSERT INTO public.who_global_data_import VALUES (60091, '2020-04-02', 'NE', 'Niger', 'AFRO', '54', '74', '2', '5');
INSERT INTO public.who_global_data_import VALUES (60092, '2020-04-03', 'NE', 'Niger', 'AFRO', '24', '98', '0', '5');
INSERT INTO public.who_global_data_import VALUES (60093, '2020-04-04', 'NE', 'Niger', 'AFRO', '22', '120', '0', '5');
INSERT INTO public.who_global_data_import VALUES (60094, '2020-04-05', 'NE', 'Niger', 'AFRO', '24', '144', '3', '8');
INSERT INTO public.who_global_data_import VALUES (60095, '2020-04-06', 'NE', 'Niger', 'AFRO', '40', '184', '2', '10');
INSERT INTO public.who_global_data_import VALUES (60096, '2020-04-07', 'NE', 'Niger', 'AFRO', '69', '253', '0', '10');
INSERT INTO public.who_global_data_import VALUES (60097, '2020-04-08', 'NE', 'Niger', 'AFRO', '25', '278', '1', '11');
INSERT INTO public.who_global_data_import VALUES (60098, '2020-04-09', 'NE', 'Niger', 'AFRO', '64', '342', '0', '11');
INSERT INTO public.who_global_data_import VALUES (60099, '2020-04-10', 'NE', 'Niger', 'AFRO', '68', '410', '0', '11');
INSERT INTO public.who_global_data_import VALUES (60100, '2020-04-11', 'NE', 'Niger', 'AFRO', '28', '438', '0', '11');
INSERT INTO public.who_global_data_import VALUES (60101, '2020-04-12', 'NE', 'Niger', 'AFRO', '53', '491', '0', '11');
INSERT INTO public.who_global_data_import VALUES (60102, '2020-04-13', 'NE', 'Niger', 'AFRO', '38', '529', '1', '12');
INSERT INTO public.who_global_data_import VALUES (60103, '2020-04-14', 'NE', 'Niger', 'AFRO', '19', '548', '1', '13');
INSERT INTO public.who_global_data_import VALUES (60104, '2020-04-15', 'NE', 'Niger', 'AFRO', '22', '570', '1', '14');
INSERT INTO public.who_global_data_import VALUES (60105, '2020-04-16', 'NE', 'Niger', 'AFRO', '14', '584', '0', '14');
INSERT INTO public.who_global_data_import VALUES (60106, '2020-04-17', 'NE', 'Niger', 'AFRO', '25', '609', '1', '15');
INSERT INTO public.who_global_data_import VALUES (60107, '2020-04-18', 'NE', 'Niger', 'AFRO', '18', '627', '3', '18');
INSERT INTO public.who_global_data_import VALUES (60108, '2020-04-19', 'NE', 'Niger', 'AFRO', '12', '639', '1', '19');
INSERT INTO public.who_global_data_import VALUES (60109, '2020-04-20', 'NE', 'Niger', 'AFRO', '9', '648', '1', '20');
INSERT INTO public.who_global_data_import VALUES (60110, '2020-04-21', 'NE', 'Niger', 'AFRO', '7', '655', '0', '20');
INSERT INTO public.who_global_data_import VALUES (60111, '2020-04-22', 'NE', 'Niger', 'AFRO', '2', '657', '0', '20');
INSERT INTO public.who_global_data_import VALUES (60112, '2020-04-23', 'NE', 'Niger', 'AFRO', '5', '662', '2', '22');
INSERT INTO public.who_global_data_import VALUES (60113, '2020-04-24', 'NE', 'Niger', 'AFRO', '9', '671', '2', '24');
INSERT INTO public.who_global_data_import VALUES (60114, '2020-04-25', 'NE', 'Niger', 'AFRO', '10', '681', '0', '24');
INSERT INTO public.who_global_data_import VALUES (60115, '2020-04-26', 'NE', 'Niger', 'AFRO', '3', '684', '3', '27');
INSERT INTO public.who_global_data_import VALUES (60116, '2020-04-27', 'NE', 'Niger', 'AFRO', '12', '696', '2', '29');
INSERT INTO public.who_global_data_import VALUES (60117, '2020-04-28', 'NE', 'Niger', 'AFRO', '5', '701', '0', '29');
INSERT INTO public.who_global_data_import VALUES (60118, '2020-04-29', 'NE', 'Niger', 'AFRO', '8', '709', '2', '31');
INSERT INTO public.who_global_data_import VALUES (60119, '2020-04-30', 'NE', 'Niger', 'AFRO', '4', '713', '1', '32');
INSERT INTO public.who_global_data_import VALUES (60120, '2020-05-01', 'NE', 'Niger', 'AFRO', '6', '719', '0', '32');
INSERT INTO public.who_global_data_import VALUES (60121, '2020-05-02', 'NE', 'Niger', 'AFRO', '9', '728', '1', '33');
INSERT INTO public.who_global_data_import VALUES (60122, '2020-05-03', 'NE', 'Niger', 'AFRO', '8', '736', '2', '35');
INSERT INTO public.who_global_data_import VALUES (60123, '2020-05-04', 'NE', 'Niger', 'AFRO', '14', '750', '1', '36');
INSERT INTO public.who_global_data_import VALUES (60124, '2020-05-05', 'NE', 'Niger', 'AFRO', '5', '755', '1', '37');
INSERT INTO public.who_global_data_import VALUES (60125, '2020-05-06', 'NE', 'Niger', 'AFRO', '8', '763', '1', '38');
INSERT INTO public.who_global_data_import VALUES (60126, '2020-05-07', 'NE', 'Niger', 'AFRO', '7', '770', '0', '38');
INSERT INTO public.who_global_data_import VALUES (60127, '2020-05-08', 'NE', 'Niger', 'AFRO', '11', '781', '4', '42');
INSERT INTO public.who_global_data_import VALUES (60128, '2020-05-09', 'NE', 'Niger', 'AFRO', '14', '795', '2', '44');
INSERT INTO public.who_global_data_import VALUES (60129, '2020-05-10', 'NE', 'Niger', 'AFRO', '20', '815', '1', '45');
INSERT INTO public.who_global_data_import VALUES (60130, '2020-05-11', 'NE', 'Niger', 'AFRO', '6', '821', '1', '46');
INSERT INTO public.who_global_data_import VALUES (60131, '2020-05-12', 'NE', 'Niger', 'AFRO', '11', '832', '0', '46');
INSERT INTO public.who_global_data_import VALUES (60132, '2020-05-13', 'NE', 'Niger', 'AFRO', '22', '854', '1', '47');
INSERT INTO public.who_global_data_import VALUES (60133, '2020-05-14', 'NE', 'Niger', 'AFRO', '6', '860', '2', '49');
INSERT INTO public.who_global_data_import VALUES (60134, '2020-05-15', 'NE', 'Niger', 'AFRO', '16', '876', '1', '50');
INSERT INTO public.who_global_data_import VALUES (60135, '2020-05-16', 'NE', 'Niger', 'AFRO', '9', '885', '1', '51');
INSERT INTO public.who_global_data_import VALUES (60136, '2020-05-17', 'NE', 'Niger', 'AFRO', '4', '889', '0', '51');
INSERT INTO public.who_global_data_import VALUES (60137, '2020-05-18', 'NE', 'Niger', 'AFRO', '15', '904', '3', '54');
INSERT INTO public.who_global_data_import VALUES (60138, '2020-05-19', 'NE', 'Niger', 'AFRO', '5', '909', '1', '55');
INSERT INTO public.who_global_data_import VALUES (60139, '2020-05-20', 'NE', 'Niger', 'AFRO', '5', '914', '0', '55');
INSERT INTO public.who_global_data_import VALUES (60140, '2020-05-21', 'NE', 'Niger', 'AFRO', '6', '920', '3', '58');
INSERT INTO public.who_global_data_import VALUES (60141, '2020-05-22', 'NE', 'Niger', 'AFRO', '4', '924', '2', '60');
INSERT INTO public.who_global_data_import VALUES (60142, '2020-05-23', 'NE', 'Niger', 'AFRO', '13', '937', '0', '60');
INSERT INTO public.who_global_data_import VALUES (60143, '2020-05-24', 'NE', 'Niger', 'AFRO', '6', '943', '1', '61');
INSERT INTO public.who_global_data_import VALUES (60144, '2020-05-25', 'NE', 'Niger', 'AFRO', '2', '945', '0', '61');
INSERT INTO public.who_global_data_import VALUES (60145, '2020-05-26', 'NE', 'Niger', 'AFRO', '6', '951', '1', '62');
INSERT INTO public.who_global_data_import VALUES (60146, '2020-05-27', 'NE', 'Niger', 'AFRO', '1', '952', '1', '63');
INSERT INTO public.who_global_data_import VALUES (60147, '2020-05-28', 'NE', 'Niger', 'AFRO', '3', '955', '1', '64');
INSERT INTO public.who_global_data_import VALUES (60148, '2020-05-29', 'NE', 'Niger', 'AFRO', '0', '955', '0', '64');
INSERT INTO public.who_global_data_import VALUES (60149, '2020-05-30', 'NE', 'Niger', 'AFRO', '0', '955', '0', '64');
INSERT INTO public.who_global_data_import VALUES (60150, '2020-05-31', 'NE', 'Niger', 'AFRO', '1', '956', '0', '64');
INSERT INTO public.who_global_data_import VALUES (60151, '2020-06-01', 'NE', 'Niger', 'AFRO', '2', '958', '0', '64');
INSERT INTO public.who_global_data_import VALUES (60152, '2020-06-02', 'NE', 'Niger', 'AFRO', '0', '958', '0', '64');
INSERT INTO public.who_global_data_import VALUES (60153, '2020-06-03', 'NE', 'Niger', 'AFRO', '2', '960', '1', '65');
INSERT INTO public.who_global_data_import VALUES (60154, '2020-06-04', 'NE', 'Niger', 'AFRO', '1', '961', '0', '65');
INSERT INTO public.who_global_data_import VALUES (60155, '2020-06-05', 'NE', 'Niger', 'AFRO', '2', '963', '0', '65');
INSERT INTO public.who_global_data_import VALUES (60156, '2020-06-06', 'NE', 'Niger', 'AFRO', '3', '966', '0', '65');
INSERT INTO public.who_global_data_import VALUES (60157, '2020-06-07', 'NE', 'Niger', 'AFRO', '4', '970', '0', '65');
INSERT INTO public.who_global_data_import VALUES (60158, '2020-06-08', 'NE', 'Niger', 'AFRO', '3', '973', '0', '65');
INSERT INTO public.who_global_data_import VALUES (60159, '2020-06-09', 'NE', 'Niger', 'AFRO', '0', '973', '0', '65');
INSERT INTO public.who_global_data_import VALUES (60160, '2020-06-10', 'NE', 'Niger', 'AFRO', '1', '974', '0', '65');
INSERT INTO public.who_global_data_import VALUES (60161, '2020-06-11', 'NE', 'Niger', 'AFRO', '0', '974', '0', '65');
INSERT INTO public.who_global_data_import VALUES (60162, '2020-06-12', 'NE', 'Niger', 'AFRO', '0', '974', '0', '65');
INSERT INTO public.who_global_data_import VALUES (60163, '2020-06-13', 'NE', 'Niger', 'AFRO', '4', '978', '0', '65');
INSERT INTO public.who_global_data_import VALUES (60164, '2020-06-14', 'NE', 'Niger', 'AFRO', '0', '978', '0', '65');
INSERT INTO public.who_global_data_import VALUES (60165, '2020-06-15', 'NE', 'Niger', 'AFRO', '2', '980', '1', '66');
INSERT INTO public.who_global_data_import VALUES (60166, '2020-06-16', 'NE', 'Niger', 'AFRO', '0', '980', '0', '66');
INSERT INTO public.who_global_data_import VALUES (60167, '2020-06-17', 'NE', 'Niger', 'AFRO', '36', '1016', '0', '66');
INSERT INTO public.who_global_data_import VALUES (60168, '2020-06-18', 'NE', 'Niger', 'AFRO', '4', '1020', '1', '67');
INSERT INTO public.who_global_data_import VALUES (60169, '2020-06-19', 'NE', 'Niger', 'AFRO', '0', '1020', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60170, '2020-06-20', 'NE', 'Niger', 'AFRO', '6', '1026', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60171, '2020-06-21', 'NE', 'Niger', 'AFRO', '9', '1035', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60172, '2020-06-22', 'NE', 'Niger', 'AFRO', '1', '1036', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60173, '2020-06-23', 'NE', 'Niger', 'AFRO', '10', '1046', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60174, '2020-06-24', 'NE', 'Niger', 'AFRO', '5', '1051', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60175, '2020-06-25', 'NE', 'Niger', 'AFRO', '5', '1056', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60176, '2020-06-26', 'NE', 'Niger', 'AFRO', '3', '1059', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60177, '2020-06-27', 'NE', 'Niger', 'AFRO', '0', '1059', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60178, '2020-06-28', 'NE', 'Niger', 'AFRO', '0', '1059', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60179, '2020-06-29', 'NE', 'Niger', 'AFRO', '15', '1074', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60180, '2020-06-30', 'NE', 'Niger', 'AFRO', '1', '1075', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60181, '2020-07-01', 'NE', 'Niger', 'AFRO', '0', '1075', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60182, '2020-07-02', 'NE', 'Niger', 'AFRO', '0', '1075', '0', '67');
INSERT INTO public.who_global_data_import VALUES (60183, '2020-07-03', 'NE', 'Niger', 'AFRO', '6', '1081', '1', '68');
INSERT INTO public.who_global_data_import VALUES (60184, '2020-07-04', 'NE', 'Niger', 'AFRO', '1', '1082', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60185, '2020-07-05', 'NE', 'Niger', 'AFRO', '0', '1082', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60186, '2020-07-06', 'NE', 'Niger', 'AFRO', '11', '1093', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60187, '2020-07-07', 'NE', 'Niger', 'AFRO', '0', '1093', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60188, '2020-07-08', 'NE', 'Niger', 'AFRO', '1', '1094', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60189, '2020-07-09', 'NE', 'Niger', 'AFRO', '3', '1097', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60190, '2020-07-10', 'NE', 'Niger', 'AFRO', '0', '1097', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60191, '2020-07-11', 'NE', 'Niger', 'AFRO', '2', '1099', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60192, '2020-07-12', 'NE', 'Niger', 'AFRO', '0', '1099', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60193, '2020-07-13', 'NE', 'Niger', 'AFRO', '0', '1099', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60194, '2020-07-14', 'NE', 'Niger', 'AFRO', '0', '1099', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60195, '2020-07-15', 'NE', 'Niger', 'AFRO', '0', '1099', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60196, '2020-07-16', 'NE', 'Niger', 'AFRO', '0', '1099', '0', '68');
INSERT INTO public.who_global_data_import VALUES (60197, '2020-07-17', 'NE', 'Niger', 'AFRO', '3', '1102', '1', '69');
INSERT INTO public.who_global_data_import VALUES (60198, '2020-07-18', 'NE', 'Niger', 'AFRO', '0', '1102', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60199, '2020-07-19', 'NE', 'Niger', 'AFRO', '2', '1104', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60200, '2020-07-20', 'NE', 'Niger', 'AFRO', '0', '1104', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60201, '2020-07-21', 'NE', 'Niger', 'AFRO', '1', '1105', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60202, '2020-07-22', 'NE', 'Niger', 'AFRO', '3', '1108', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60203, '2020-07-23', 'NE', 'Niger', 'AFRO', '14', '1122', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60204, '2020-07-24', 'NE', 'Niger', 'AFRO', '2', '1124', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60205, '2020-07-25', 'NE', 'Niger', 'AFRO', '0', '1124', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60206, '2020-07-26', 'NE', 'Niger', 'AFRO', '0', '1124', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60207, '2020-07-27', 'NE', 'Niger', 'AFRO', '8', '1132', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60208, '2020-07-28', 'NE', 'Niger', 'AFRO', '0', '1132', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60209, '2020-07-29', 'NE', 'Niger', 'AFRO', '0', '1132', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60210, '2020-07-30', 'NE', 'Niger', 'AFRO', '2', '1134', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60211, '2020-07-31', 'NE', 'Niger', 'AFRO', '0', '1134', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60212, '2020-08-01', 'NE', 'Niger', 'AFRO', '2', '1136', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60213, '2020-08-02', 'NE', 'Niger', 'AFRO', '0', '1136', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60214, '2020-08-03', 'NE', 'Niger', 'AFRO', '2', '1138', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60215, '2020-08-04', 'NE', 'Niger', 'AFRO', '9', '1147', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60216, '2020-08-05', 'NE', 'Niger', 'AFRO', '5', '1152', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60217, '2020-08-06', 'NE', 'Niger', 'AFRO', '0', '1152', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60218, '2020-08-07', 'NE', 'Niger', 'AFRO', '1', '1153', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60219, '2020-08-08', 'NE', 'Niger', 'AFRO', '0', '1153', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60220, '2020-08-09', 'NE', 'Niger', 'AFRO', '4', '1157', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60221, '2020-08-10', 'NE', 'Niger', 'AFRO', '1', '1158', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60222, '2020-08-11', 'NE', 'Niger', 'AFRO', '0', '1158', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60223, '2020-08-12', 'NE', 'Niger', 'AFRO', '0', '1158', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60224, '2020-08-13', 'NE', 'Niger', 'AFRO', '3', '1161', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60225, '2020-08-14', 'NE', 'Niger', 'AFRO', '0', '1161', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60226, '2020-08-15', 'NE', 'Niger', 'AFRO', '4', '1165', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60227, '2020-08-16', 'NE', 'Niger', 'AFRO', '0', '1165', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60228, '2020-08-17', 'NE', 'Niger', 'AFRO', '2', '1167', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60229, '2020-08-18', 'NE', 'Niger', 'AFRO', '0', '1167', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60230, '2020-08-19', 'NE', 'Niger', 'AFRO', '0', '1167', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60231, '2020-08-20', 'NE', 'Niger', 'AFRO', '0', '1167', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60232, '2020-08-21', 'NE', 'Niger', 'AFRO', '2', '1169', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60233, '2020-08-22', 'NE', 'Niger', 'AFRO', '3', '1172', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60234, '2020-08-23', 'NE', 'Niger', 'AFRO', '0', '1172', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60235, '2020-08-24', 'NE', 'Niger', 'AFRO', '0', '1172', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60236, '2020-08-25', 'NE', 'Niger', 'AFRO', '0', '1172', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60237, '2020-08-26', 'NE', 'Niger', 'AFRO', '1', '1173', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60238, '2020-08-27', 'NE', 'Niger', 'AFRO', '0', '1173', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60239, '2020-08-28', 'NE', 'Niger', 'AFRO', '0', '1173', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60240, '2020-08-29', 'NE', 'Niger', 'AFRO', '0', '1173', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60241, '2020-08-30', 'NE', 'Niger', 'AFRO', '2', '1175', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60242, '2020-08-31', 'NE', 'Niger', 'AFRO', '0', '1175', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60243, '2020-09-01', 'NE', 'Niger', 'AFRO', '1', '1176', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60244, '2020-09-02', 'NE', 'Niger', 'AFRO', '0', '1176', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60245, '2020-09-03', 'NE', 'Niger', 'AFRO', '0', '1176', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60246, '2020-09-04', 'NE', 'Niger', 'AFRO', '1', '1177', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60247, '2020-09-05', 'NE', 'Niger', 'AFRO', '0', '1177', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60248, '2020-09-06', 'NE', 'Niger', 'AFRO', '0', '1177', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60249, '2020-09-07', 'NE', 'Niger', 'AFRO', '0', '1177', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60250, '2020-09-08', 'NE', 'Niger', 'AFRO', '1', '1178', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60251, '2020-09-09', 'NE', 'Niger', 'AFRO', '0', '1178', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60252, '2020-09-10', 'NE', 'Niger', 'AFRO', '0', '1178', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60253, '2020-09-11', 'NE', 'Niger', 'AFRO', '0', '1178', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60254, '2020-09-12', 'NE', 'Niger', 'AFRO', '0', '1178', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60255, '2020-09-13', 'NE', 'Niger', 'AFRO', '0', '1178', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60256, '2020-09-14', 'NE', 'Niger', 'AFRO', '0', '1178', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60257, '2020-09-15', 'NE', 'Niger', 'AFRO', '0', '1178', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60258, '2020-09-16', 'NE', 'Niger', 'AFRO', '2', '1180', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60259, '2020-09-17', 'NE', 'Niger', 'AFRO', '0', '1180', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60260, '2020-09-18', 'NE', 'Niger', 'AFRO', '0', '1180', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60261, '2020-09-19', 'NE', 'Niger', 'AFRO', '2', '1182', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60262, '2020-09-20', 'NE', 'Niger', 'AFRO', '0', '1182', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60263, '2020-09-21', 'NE', 'Niger', 'AFRO', '1', '1183', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60264, '2020-09-22', 'NE', 'Niger', 'AFRO', '6', '1189', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60265, '2020-09-23', 'NE', 'Niger', 'AFRO', '0', '1189', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60266, '2020-09-24', 'NE', 'Niger', 'AFRO', '4', '1193', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60267, '2020-09-25', 'NE', 'Niger', 'AFRO', '0', '1193', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60268, '2020-09-26', 'NE', 'Niger', 'AFRO', '1', '1194', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60269, '2020-09-27', 'NE', 'Niger', 'AFRO', '0', '1194', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60270, '2020-09-28', 'NE', 'Niger', 'AFRO', '2', '1196', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60271, '2020-09-29', 'NE', 'Niger', 'AFRO', '0', '1196', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60272, '2020-09-30', 'NE', 'Niger', 'AFRO', '0', '1196', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60273, '2020-10-01', 'NE', 'Niger', 'AFRO', '1', '1197', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60274, '2020-10-02', 'NE', 'Niger', 'AFRO', '0', '1197', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60275, '2020-10-03', 'NE', 'Niger', 'AFRO', '0', '1197', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60276, '2020-10-04', 'NE', 'Niger', 'AFRO', '3', '1200', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60277, '2020-10-05', 'NE', 'Niger', 'AFRO', '0', '1200', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60278, '2020-10-06', 'NE', 'Niger', 'AFRO', '0', '1200', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60279, '2020-10-07', 'NE', 'Niger', 'AFRO', '0', '1200', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60280, '2020-10-08', 'NE', 'Niger', 'AFRO', '0', '1200', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60281, '2020-10-09', 'NE', 'Niger', 'AFRO', '0', '1200', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60282, '2020-10-10', 'NE', 'Niger', 'AFRO', '0', '1200', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60283, '2020-10-11', 'NE', 'Niger', 'AFRO', '0', '1200', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60284, '2020-10-12', 'NE', 'Niger', 'AFRO', '1', '1201', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60285, '2020-10-13', 'NE', 'Niger', 'AFRO', '0', '1201', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60286, '2020-10-14', 'NE', 'Niger', 'AFRO', '0', '1201', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60287, '2020-10-15', 'NE', 'Niger', 'AFRO', '4', '1205', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60288, '2020-10-16', 'NE', 'Niger', 'AFRO', '0', '1205', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60289, '2020-10-17', 'NE', 'Niger', 'AFRO', '4', '1209', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60290, '2020-10-18', 'NE', 'Niger', 'AFRO', '0', '1209', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60291, '2020-10-19', 'NE', 'Niger', 'AFRO', '1', '1210', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60292, '2020-10-20', 'NE', 'Niger', 'AFRO', '1', '1211', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60293, '2020-10-21', 'NE', 'Niger', 'AFRO', '1', '1212', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60294, '2020-10-22', 'NE', 'Niger', 'AFRO', '2', '1214', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60295, '2020-10-23', 'NE', 'Niger', 'AFRO', '1', '1215', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60296, '2020-10-24', 'NE', 'Niger', 'AFRO', '0', '1215', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60297, '2020-10-25', 'NE', 'Niger', 'AFRO', '0', '1215', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60298, '2020-10-26', 'NE', 'Niger', 'AFRO', '0', '1215', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60299, '2020-10-27', 'NE', 'Niger', 'AFRO', '0', '1215', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60300, '2020-10-28', 'NE', 'Niger', 'AFRO', '3', '1218', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60301, '2020-10-29', 'NE', 'Niger', 'AFRO', '0', '1218', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60302, '2020-10-30', 'NE', 'Niger', 'AFRO', '1', '1219', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60303, '2020-10-31', 'NE', 'Niger', 'AFRO', '1', '1220', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60304, '2020-11-01', 'NE', 'Niger', 'AFRO', '0', '1220', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60305, '2020-11-02', 'NE', 'Niger', 'AFRO', '1', '1221', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60306, '2020-11-03', 'NE', 'Niger', 'AFRO', '0', '1221', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60307, '2020-11-04', 'NE', 'Niger', 'AFRO', '1', '1222', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60308, '2020-11-05', 'NE', 'Niger', 'AFRO', '0', '1222', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60309, '2020-11-06', 'NE', 'Niger', 'AFRO', '0', '1222', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60310, '2020-11-07', 'NE', 'Niger', 'AFRO', '0', '1222', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60311, '2020-11-08', 'NE', 'Niger', 'AFRO', '20', '1242', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60312, '2020-11-09', 'NE', 'Niger', 'AFRO', '1', '1243', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60313, '2020-11-10', 'NE', 'Niger', 'AFRO', '0', '1243', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60314, '2020-11-11', 'NE', 'Niger', 'AFRO', '13', '1256', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60315, '2020-11-12', 'NE', 'Niger', 'AFRO', '0', '1256', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60316, '2020-11-13', 'NE', 'Niger', 'AFRO', '7', '1263', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60317, '2020-11-14', 'NE', 'Niger', 'AFRO', '19', '1282', '0', '69');
INSERT INTO public.who_global_data_import VALUES (60318, '2020-11-15', 'NE', 'Niger', 'AFRO', '19', '1301', '1', '70');
INSERT INTO public.who_global_data_import VALUES (60319, '2020-11-16', 'NE', 'Niger', 'AFRO', '6', '1307', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60320, '2020-11-17', 'NE', 'Niger', 'AFRO', '9', '1316', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60321, '2020-11-18', 'NE', 'Niger', 'AFRO', '11', '1327', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60322, '2020-11-19', 'NE', 'Niger', 'AFRO', '4', '1331', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60323, '2020-11-20', 'NE', 'Niger', 'AFRO', '4', '1335', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60324, '2020-11-21', 'NE', 'Niger', 'AFRO', '0', '1335', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60325, '2020-11-22', 'NE', 'Niger', 'AFRO', '16', '1351', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60326, '2020-11-23', 'NE', 'Niger', 'AFRO', '17', '1368', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60327, '2020-11-24', 'NE', 'Niger', 'AFRO', '13', '1381', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60328, '2020-11-25', 'NE', 'Niger', 'AFRO', '0', '1381', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60329, '2020-11-26', 'NE', 'Niger', 'AFRO', '38', '1419', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60330, '2020-11-27', 'NE', 'Niger', 'AFRO', '24', '1443', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60331, '2020-11-28', 'NE', 'Niger', 'AFRO', '29', '1472', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60332, '2020-11-29', 'NE', 'Niger', 'AFRO', '0', '1472', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60333, '2020-11-30', 'NE', 'Niger', 'AFRO', '44', '1516', '0', '70');
INSERT INTO public.who_global_data_import VALUES (60334, '2020-12-01', 'NE', 'Niger', 'AFRO', '32', '1548', '2', '72');
INSERT INTO public.who_global_data_import VALUES (60335, '2020-12-02', 'NE', 'Niger', 'AFRO', '0', '1548', '0', '72');
INSERT INTO public.who_global_data_import VALUES (60336, '2020-12-03', 'NE', 'Niger', 'AFRO', '92', '1640', '4', '76');
INSERT INTO public.who_global_data_import VALUES (60337, '2020-12-04', 'NE', 'Niger', 'AFRO', '0', '1640', '0', '76');
INSERT INTO public.who_global_data_import VALUES (60338, '2020-12-05', 'NE', 'Niger', 'AFRO', '0', '1640', '0', '76');
INSERT INTO public.who_global_data_import VALUES (60339, '2020-12-06', 'NE', 'Niger', 'AFRO', '149', '1789', '1', '77');
INSERT INTO public.who_global_data_import VALUES (60340, '2020-12-07', 'NE', 'Niger', 'AFRO', '0', '1789', '0', '77');
INSERT INTO public.who_global_data_import VALUES (60341, '2020-12-08', 'NE', 'Niger', 'AFRO', '0', '1789', '0', '77');
INSERT INTO public.who_global_data_import VALUES (60342, '2020-12-09', 'NE', 'Niger', 'AFRO', '67', '1856', '0', '77');
INSERT INTO public.who_global_data_import VALUES (60343, '2020-12-10', 'NE', 'Niger', 'AFRO', '0', '1856', '0', '77');
INSERT INTO public.who_global_data_import VALUES (60344, '2020-12-11', 'NE', 'Niger', 'AFRO', '0', '1856', '0', '77');
INSERT INTO public.who_global_data_import VALUES (60345, '2020-12-12', 'NE', 'Niger', 'AFRO', '0', '1856', '0', '77');
INSERT INTO public.who_global_data_import VALUES (60346, '2020-12-13', 'NE', 'Niger', 'AFRO', '0', '1856', '0', '77');
INSERT INTO public.who_global_data_import VALUES (60347, '2020-12-14', 'NE', 'Niger', 'AFRO', '222', '2078', '0', '77');
INSERT INTO public.who_global_data_import VALUES (60348, '2020-12-15', 'NE', 'Niger', 'AFRO', '0', '2078', '0', '77');
INSERT INTO public.who_global_data_import VALUES (60349, '2020-12-16', 'NE', 'Niger', 'AFRO', '0', '2078', '0', '77');
INSERT INTO public.who_global_data_import VALUES (60350, '2020-12-17', 'NE', 'Niger', 'AFRO', '0', '2078', '0', '77');
INSERT INTO public.who_global_data_import VALUES (60351, '2020-12-18', 'NE', 'Niger', 'AFRO', '0', '2078', '0', '77');
INSERT INTO public.who_global_data_import VALUES (60352, '2020-12-19', 'NE', 'Niger', 'AFRO', '283', '2361', '5', '82');
INSERT INTO public.who_global_data_import VALUES (60353, '2020-12-20', 'NE', 'Niger', 'AFRO', '0', '2361', '0', '82');
INSERT INTO public.who_global_data_import VALUES (60354, '2020-12-21', 'NE', 'Niger', 'AFRO', '0', '2361', '0', '82');
INSERT INTO public.who_global_data_import VALUES (60355, '2020-12-22', 'NE', 'Niger', 'AFRO', '0', '2361', '0', '82');
INSERT INTO public.who_global_data_import VALUES (60356, '2020-12-23', 'NE', 'Niger', 'AFRO', '0', '2361', '0', '82');
INSERT INTO public.who_global_data_import VALUES (60357, '2020-12-24', 'NE', 'Niger', 'AFRO', '442', '2803', '7', '89');
INSERT INTO public.who_global_data_import VALUES (60358, '2020-12-25', 'NE', 'Niger', 'AFRO', '0', '2803', '0', '89');
INSERT INTO public.who_global_data_import VALUES (60359, '2020-12-26', 'NE', 'Niger', 'AFRO', '0', '2803', '0', '89');
INSERT INTO public.who_global_data_import VALUES (60360, '2020-12-27', 'NE', 'Niger', 'AFRO', '0', '2803', '0', '89');
INSERT INTO public.who_global_data_import VALUES (60361, '2020-12-28', 'NE', 'Niger', 'AFRO', '202', '3005', '2', '91');
INSERT INTO public.who_global_data_import VALUES (60362, '2020-12-29', 'NE', 'Niger', 'AFRO', '0', '3005', '0', '91');
INSERT INTO public.who_global_data_import VALUES (60363, '2020-12-30', 'NE', 'Niger', 'AFRO', '105', '3110', '5', '96');
INSERT INTO public.who_global_data_import VALUES (60364, '2020-12-31', 'NE', 'Niger', 'AFRO', '0', '3110', '0', '96');
INSERT INTO public.who_global_data_import VALUES (60365, '2021-01-01', 'NE', 'Niger', 'AFRO', '98', '3208', '6', '102');
INSERT INTO public.who_global_data_import VALUES (60366, '2021-01-02', 'NE', 'Niger', 'AFRO', '0', '3208', '0', '102');
INSERT INTO public.who_global_data_import VALUES (60367, '2021-01-03', 'NE', 'Niger', 'AFRO', '0', '3208', '0', '102');
INSERT INTO public.who_global_data_import VALUES (60368, '2021-01-04', 'NE', 'Niger', 'AFRO', '0', '3208', '0', '102');
INSERT INTO public.who_global_data_import VALUES (60369, '2021-01-05', 'NE', 'Niger', 'AFRO', '114', '3322', '2', '104');
INSERT INTO public.who_global_data_import VALUES (60370, '2021-01-06', 'NE', 'Niger', 'AFRO', '0', '3322', '0', '104');
INSERT INTO public.who_global_data_import VALUES (60371, '2021-01-07', 'NE', 'Niger', 'AFRO', '0', '3322', '0', '104');
INSERT INTO public.who_global_data_import VALUES (60372, '2021-01-08', 'NE', 'Niger', 'AFRO', '0', '3322', '0', '104');
INSERT INTO public.who_global_data_import VALUES (60373, '2021-01-09', 'NE', 'Niger', 'AFRO', '0', '3322', '0', '104');
INSERT INTO public.who_global_data_import VALUES (60374, '2021-01-10', 'NE', 'Niger', 'AFRO', '0', '3322', '0', '104');
INSERT INTO public.who_global_data_import VALUES (60375, '2021-01-11', 'NE', 'Niger', 'AFRO', '555', '3877', '22', '126');
INSERT INTO public.who_global_data_import VALUES (60376, '2021-01-12', 'NE', 'Niger', 'AFRO', '0', '3877', '0', '126');
INSERT INTO public.who_global_data_import VALUES (60377, '2021-01-13', 'NE', 'Niger', 'AFRO', '92', '3969', '9', '135');
INSERT INTO public.who_global_data_import VALUES (60378, '2021-01-14', 'NE', 'Niger', 'AFRO', '29', '3998', '1', '136');
INSERT INTO public.who_global_data_import VALUES (60379, '2021-01-15', 'NE', 'Niger', 'AFRO', '60', '4058', '1', '137');
INSERT INTO public.who_global_data_import VALUES (60380, '2021-01-16', 'NE', 'Niger', 'AFRO', '47', '4105', '1', '138');
INSERT INTO public.who_global_data_import VALUES (60381, '2021-01-17', 'NE', 'Niger', 'AFRO', '27', '4132', '0', '138');
INSERT INTO public.who_global_data_import VALUES (60382, '2021-01-18', 'NE', 'Niger', 'AFRO', '24', '4156', '2', '140');
INSERT INTO public.who_global_data_import VALUES (60383, '2021-01-19', 'NE', 'Niger', 'AFRO', '48', '4204', '5', '145');
INSERT INTO public.who_global_data_import VALUES (60384, '2021-01-20', 'NE', 'Niger', 'AFRO', '21', '4225', '1', '146');
INSERT INTO public.who_global_data_import VALUES (60385, '2021-01-21', 'NE', 'Niger', 'AFRO', '24', '4249', '1', '147');
INSERT INTO public.who_global_data_import VALUES (60386, '2021-01-22', 'NE', 'Niger', 'AFRO', '18', '4267', '0', '147');
INSERT INTO public.who_global_data_import VALUES (60387, '2021-01-23', 'NE', 'Niger', 'AFRO', '0', '4267', '0', '147');
INSERT INTO public.who_global_data_import VALUES (60388, '2021-01-24', 'NE', 'Niger', 'AFRO', '54', '4321', '4', '151');
INSERT INTO public.who_global_data_import VALUES (60389, '2021-01-25', 'NE', 'Niger', 'AFRO', '32', '4353', '0', '151');
INSERT INTO public.who_global_data_import VALUES (60390, '2021-01-26', 'NE', 'Niger', 'AFRO', '21', '4374', '0', '151');
INSERT INTO public.who_global_data_import VALUES (60391, '2021-01-27', 'NE', 'Niger', 'AFRO', '0', '4374', '0', '151');
INSERT INTO public.who_global_data_import VALUES (60392, '2021-01-28', 'NE', 'Niger', 'AFRO', '59', '4433', '2', '153');
INSERT INTO public.who_global_data_import VALUES (60393, '2021-01-29', 'NE', 'Niger', 'AFRO', '41', '4474', '4', '157');
INSERT INTO public.who_global_data_import VALUES (60394, '2021-01-30', 'NE', 'Niger', 'AFRO', '15', '4489', '2', '159');
INSERT INTO public.who_global_data_import VALUES (60395, '2021-01-31', 'NE', 'Niger', 'AFRO', '27', '4516', '0', '159');
INSERT INTO public.who_global_data_import VALUES (60396, '2021-02-01', 'NE', 'Niger', 'AFRO', '1', '4517', '0', '159');
INSERT INTO public.who_global_data_import VALUES (60397, '2021-02-02', 'NE', 'Niger', 'AFRO', '20', '4537', '2', '161');
INSERT INTO public.who_global_data_import VALUES (60398, '2021-02-03', 'NE', 'Niger', 'AFRO', '11', '4548', '1', '162');
INSERT INTO public.who_global_data_import VALUES (60399, '2021-02-04', 'NE', 'Niger', 'AFRO', '17', '4565', '1', '163');
INSERT INTO public.who_global_data_import VALUES (60400, '2021-02-05', 'NE', 'Niger', 'AFRO', '10', '4575', '1', '164');
INSERT INTO public.who_global_data_import VALUES (60401, '2020-01-03', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60402, '2020-01-04', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60403, '2020-01-05', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60404, '2020-01-06', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60405, '2020-01-07', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60406, '2020-01-08', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60407, '2020-01-09', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60408, '2020-01-10', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60409, '2020-01-11', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60410, '2020-01-12', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60411, '2020-01-13', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60412, '2020-01-14', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60413, '2020-01-15', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60414, '2020-01-16', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60415, '2020-01-17', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60416, '2020-01-18', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60417, '2020-01-19', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60418, '2020-01-20', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60419, '2020-01-21', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60420, '2020-01-22', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60421, '2020-01-23', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60422, '2020-01-24', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60423, '2020-01-25', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60424, '2020-01-26', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60425, '2020-01-27', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60426, '2020-01-28', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60427, '2020-01-29', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60428, '2020-01-30', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60429, '2020-01-31', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60430, '2020-02-01', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60431, '2020-02-02', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60432, '2020-02-03', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60433, '2020-02-04', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60434, '2020-02-05', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60435, '2020-02-06', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60436, '2020-02-07', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60437, '2020-02-08', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60438, '2020-02-09', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60439, '2020-02-10', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60440, '2020-02-11', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60441, '2020-02-12', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60442, '2020-02-13', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60443, '2020-02-14', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60444, '2020-02-15', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60445, '2020-02-16', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60446, '2020-02-17', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60447, '2020-02-18', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60448, '2020-02-19', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60449, '2020-02-20', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60450, '2020-02-21', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60451, '2020-02-22', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60452, '2020-02-23', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60453, '2020-02-24', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60454, '2020-02-25', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60455, '2020-02-26', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60456, '2020-02-27', 'NG', 'Nigeria', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60457, '2020-02-28', 'NG', 'Nigeria', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60458, '2020-02-29', 'NG', 'Nigeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60459, '2020-03-01', 'NG', 'Nigeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60460, '2020-03-02', 'NG', 'Nigeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60461, '2020-03-03', 'NG', 'Nigeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60462, '2020-03-04', 'NG', 'Nigeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60463, '2020-03-05', 'NG', 'Nigeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60464, '2020-03-06', 'NG', 'Nigeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60465, '2020-03-07', 'NG', 'Nigeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60466, '2020-03-08', 'NG', 'Nigeria', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60467, '2020-03-09', 'NG', 'Nigeria', 'AFRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60468, '2020-03-10', 'NG', 'Nigeria', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60469, '2020-03-11', 'NG', 'Nigeria', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60470, '2020-03-12', 'NG', 'Nigeria', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60471, '2020-03-13', 'NG', 'Nigeria', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60472, '2020-03-14', 'NG', 'Nigeria', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60473, '2020-03-15', 'NG', 'Nigeria', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60474, '2020-03-16', 'NG', 'Nigeria', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60475, '2020-03-17', 'NG', 'Nigeria', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60476, '2020-03-18', 'NG', 'Nigeria', 'AFRO', '6', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60477, '2020-03-19', 'NG', 'Nigeria', 'AFRO', '4', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60478, '2020-03-20', 'NG', 'Nigeria', 'AFRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60479, '2020-03-21', 'NG', 'Nigeria', 'AFRO', '6', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60480, '2020-03-22', 'NG', 'Nigeria', 'AFRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60481, '2020-03-23', 'NG', 'Nigeria', 'AFRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60482, '2020-03-24', 'NG', 'Nigeria', 'AFRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60483, '2020-03-25', 'NG', 'Nigeria', 'AFRO', '20', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60484, '2020-03-26', 'NG', 'Nigeria', 'AFRO', '4', '46', '1', '1');
INSERT INTO public.who_global_data_import VALUES (60485, '2020-03-27', 'NG', 'Nigeria', 'AFRO', '19', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (60486, '2020-03-28', 'NG', 'Nigeria', 'AFRO', '0', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (60487, '2020-03-29', 'NG', 'Nigeria', 'AFRO', '0', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (60488, '2020-03-30', 'NG', 'Nigeria', 'AFRO', '0', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (60489, '2020-03-31', 'NG', 'Nigeria', 'AFRO', '46', '111', '0', '1');
INSERT INTO public.who_global_data_import VALUES (60490, '2020-04-01', 'NG', 'Nigeria', 'AFRO', '28', '139', '1', '2');
INSERT INTO public.who_global_data_import VALUES (60491, '2020-04-02', 'NG', 'Nigeria', 'AFRO', '35', '174', '0', '2');
INSERT INTO public.who_global_data_import VALUES (60492, '2020-04-03', 'NG', 'Nigeria', 'AFRO', '16', '190', '0', '2');
INSERT INTO public.who_global_data_import VALUES (60493, '2020-04-04', 'NG', 'Nigeria', 'AFRO', '18', '208', '2', '4');
INSERT INTO public.who_global_data_import VALUES (60494, '2020-04-05', 'NG', 'Nigeria', 'AFRO', '0', '208', '0', '4');
INSERT INTO public.who_global_data_import VALUES (60495, '2020-04-06', 'NG', 'Nigeria', 'AFRO', '24', '232', '1', '5');
INSERT INTO public.who_global_data_import VALUES (60496, '2020-04-07', 'NG', 'Nigeria', 'AFRO', '0', '232', '0', '5');
INSERT INTO public.who_global_data_import VALUES (60497, '2020-04-08', 'NG', 'Nigeria', 'AFRO', '22', '254', '1', '6');
INSERT INTO public.who_global_data_import VALUES (60498, '2020-04-09', 'NG', 'Nigeria', 'AFRO', '22', '276', '0', '6');
INSERT INTO public.who_global_data_import VALUES (60499, '2020-04-10', 'NG', 'Nigeria', 'AFRO', '12', '288', '1', '7');
INSERT INTO public.who_global_data_import VALUES (60500, '2020-04-11', 'NG', 'Nigeria', 'AFRO', '17', '305', '0', '7');
INSERT INTO public.who_global_data_import VALUES (60501, '2020-04-12', 'NG', 'Nigeria', 'AFRO', '13', '318', '3', '10');
INSERT INTO public.who_global_data_import VALUES (60502, '2020-04-13', 'NG', 'Nigeria', 'AFRO', '5', '323', '0', '10');
INSERT INTO public.who_global_data_import VALUES (60503, '2020-04-14', 'NG', 'Nigeria', 'AFRO', '20', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (60504, '2020-04-15', 'NG', 'Nigeria', 'AFRO', '0', '343', '0', '10');
INSERT INTO public.who_global_data_import VALUES (60505, '2020-04-16', 'NG', 'Nigeria', 'AFRO', '30', '373', '1', '11');
INSERT INTO public.who_global_data_import VALUES (60506, '2020-04-17', 'NG', 'Nigeria', 'AFRO', '0', '373', '0', '11');
INSERT INTO public.who_global_data_import VALUES (60507, '2020-04-18', 'NG', 'Nigeria', 'AFRO', '0', '373', '0', '11');
INSERT INTO public.who_global_data_import VALUES (60508, '2020-04-19', 'NG', 'Nigeria', 'AFRO', '0', '373', '0', '11');
INSERT INTO public.who_global_data_import VALUES (60509, '2020-04-20', 'NG', 'Nigeria', 'AFRO', '168', '541', '8', '19');
INSERT INTO public.who_global_data_import VALUES (60510, '2020-04-21', 'NG', 'Nigeria', 'AFRO', '0', '541', '0', '19');
INSERT INTO public.who_global_data_import VALUES (60511, '2020-04-22', 'NG', 'Nigeria', 'AFRO', '0', '541', '0', '19');
INSERT INTO public.who_global_data_import VALUES (60512, '2020-04-23', 'NG', 'Nigeria', 'AFRO', '0', '541', '0', '19');
INSERT INTO public.who_global_data_import VALUES (60513, '2020-04-24', 'NG', 'Nigeria', 'AFRO', '440', '981', '12', '31');
INSERT INTO public.who_global_data_import VALUES (60514, '2020-04-25', 'NG', 'Nigeria', 'AFRO', '114', '1095', '1', '32');
INSERT INTO public.who_global_data_import VALUES (60515, '2020-04-26', 'NG', 'Nigeria', 'AFRO', '87', '1182', '3', '35');
INSERT INTO public.who_global_data_import VALUES (60516, '2020-04-27', 'NG', 'Nigeria', 'AFRO', '91', '1273', '5', '40');
INSERT INTO public.who_global_data_import VALUES (60517, '2020-04-28', 'NG', 'Nigeria', 'AFRO', '64', '1337', '0', '40');
INSERT INTO public.who_global_data_import VALUES (60518, '2020-04-29', 'NG', 'Nigeria', 'AFRO', '0', '1337', '0', '40');
INSERT INTO public.who_global_data_import VALUES (60519, '2020-04-30', 'NG', 'Nigeria', 'AFRO', '195', '1532', '4', '44');
INSERT INTO public.who_global_data_import VALUES (60520, '2020-05-01', 'NG', 'Nigeria', 'AFRO', '400', '1932', '14', '58');
INSERT INTO public.who_global_data_import VALUES (60521, '2020-05-02', 'NG', 'Nigeria', 'AFRO', '238', '2170', '10', '68');
INSERT INTO public.who_global_data_import VALUES (60522, '2020-05-03', 'NG', 'Nigeria', 'AFRO', '218', '2388', '17', '85');
INSERT INTO public.who_global_data_import VALUES (60523, '2020-05-04', 'NG', 'Nigeria', 'AFRO', '0', '2388', '0', '85');
INSERT INTO public.who_global_data_import VALUES (60524, '2020-05-05', 'NG', 'Nigeria', 'AFRO', '414', '2802', '8', '93');
INSERT INTO public.who_global_data_import VALUES (60525, '2020-05-06', 'NG', 'Nigeria', 'AFRO', '148', '2950', '5', '98');
INSERT INTO public.who_global_data_import VALUES (60526, '2020-05-07', 'NG', 'Nigeria', 'AFRO', '195', '3145', '5', '103');
INSERT INTO public.who_global_data_import VALUES (60527, '2020-05-08', 'NG', 'Nigeria', 'AFRO', '381', '3526', '4', '107');
INSERT INTO public.who_global_data_import VALUES (60528, '2020-05-09', 'NG', 'Nigeria', 'AFRO', '386', '3912', '10', '117');
INSERT INTO public.who_global_data_import VALUES (60529, '2020-05-10', 'NG', 'Nigeria', 'AFRO', '239', '4151', '11', '128');
INSERT INTO public.who_global_data_import VALUES (60530, '2020-05-11', 'NG', 'Nigeria', 'AFRO', '248', '4399', '15', '143');
INSERT INTO public.who_global_data_import VALUES (60531, '2020-05-12', 'NG', 'Nigeria', 'AFRO', '242', '4641', '7', '150');
INSERT INTO public.who_global_data_import VALUES (60532, '2020-05-13', 'NG', 'Nigeria', 'AFRO', '146', '4787', '8', '158');
INSERT INTO public.who_global_data_import VALUES (60533, '2020-05-14', 'NG', 'Nigeria', 'AFRO', '184', '4971', '6', '164');
INSERT INTO public.who_global_data_import VALUES (60534, '2020-05-15', 'NG', 'Nigeria', 'AFRO', '191', '5162', '3', '167');
INSERT INTO public.who_global_data_import VALUES (60535, '2020-05-16', 'NG', 'Nigeria', 'AFRO', '288', '5450', '4', '171');
INSERT INTO public.who_global_data_import VALUES (60536, '2020-05-17', 'NG', 'Nigeria', 'AFRO', '171', '5621', '5', '176');
INSERT INTO public.who_global_data_import VALUES (60537, '2020-05-18', 'NG', 'Nigeria', 'AFRO', '338', '5959', '6', '182');
INSERT INTO public.who_global_data_import VALUES (60538, '2020-05-19', 'NG', 'Nigeria', 'AFRO', '216', '6175', '9', '191');
INSERT INTO public.who_global_data_import VALUES (60539, '2020-05-20', 'NG', 'Nigeria', 'AFRO', '226', '6401', '1', '192');
INSERT INTO public.who_global_data_import VALUES (60540, '2020-05-21', 'NG', 'Nigeria', 'AFRO', '276', '6677', '8', '200');
INSERT INTO public.who_global_data_import VALUES (60541, '2020-05-22', 'NG', 'Nigeria', 'AFRO', '339', '7016', '11', '211');
INSERT INTO public.who_global_data_import VALUES (60542, '2020-05-23', 'NG', 'Nigeria', 'AFRO', '245', '7261', '10', '221');
INSERT INTO public.who_global_data_import VALUES (60543, '2020-05-24', 'NG', 'Nigeria', 'AFRO', '265', '7526', '0', '221');
INSERT INTO public.who_global_data_import VALUES (60544, '2020-05-25', 'NG', 'Nigeria', 'AFRO', '313', '7839', '5', '226');
INSERT INTO public.who_global_data_import VALUES (60545, '2020-05-26', 'NG', 'Nigeria', 'AFRO', '229', '8068', '7', '233');
INSERT INTO public.who_global_data_import VALUES (60546, '2020-05-27', 'NG', 'Nigeria', 'AFRO', '276', '8344', '16', '249');
INSERT INTO public.who_global_data_import VALUES (60547, '2020-05-28', 'NG', 'Nigeria', 'AFRO', '389', '8733', '5', '254');
INSERT INTO public.who_global_data_import VALUES (60548, '2020-05-29', 'NG', 'Nigeria', 'AFRO', '182', '8915', '5', '259');
INSERT INTO public.who_global_data_import VALUES (60549, '2020-05-30', 'NG', 'Nigeria', 'AFRO', '387', '9302', '2', '261');
INSERT INTO public.who_global_data_import VALUES (60550, '2020-05-31', 'NG', 'Nigeria', 'AFRO', '553', '9855', '12', '273');
INSERT INTO public.who_global_data_import VALUES (60551, '2020-06-01', 'NG', 'Nigeria', 'AFRO', '307', '10162', '14', '287');
INSERT INTO public.who_global_data_import VALUES (60552, '2020-06-02', 'NG', 'Nigeria', 'AFRO', '416', '10578', '12', '299');
INSERT INTO public.who_global_data_import VALUES (60553, '2020-06-03', 'NG', 'Nigeria', 'AFRO', '241', '10819', '15', '314');
INSERT INTO public.who_global_data_import VALUES (60554, '2020-06-04', 'NG', 'Nigeria', 'AFRO', '347', '11166', '1', '315');
INSERT INTO public.who_global_data_import VALUES (60555, '2020-06-05', 'NG', 'Nigeria', 'AFRO', '350', '11516', '8', '323');
INSERT INTO public.who_global_data_import VALUES (60556, '2020-06-06', 'NG', 'Nigeria', 'AFRO', '328', '11844', '10', '333');
INSERT INTO public.who_global_data_import VALUES (60557, '2020-06-07', 'NG', 'Nigeria', 'AFRO', '389', '12233', '9', '342');
INSERT INTO public.who_global_data_import VALUES (60558, '2020-06-08', 'NG', 'Nigeria', 'AFRO', '253', '12486', '12', '354');
INSERT INTO public.who_global_data_import VALUES (60559, '2020-06-09', 'NG', 'Nigeria', 'AFRO', '315', '12801', '7', '361');
INSERT INTO public.who_global_data_import VALUES (60560, '2020-06-10', 'NG', 'Nigeria', 'AFRO', '663', '13464', '4', '365');
INSERT INTO public.who_global_data_import VALUES (60561, '2020-06-11', 'NG', 'Nigeria', 'AFRO', '409', '13873', '17', '382');
INSERT INTO public.who_global_data_import VALUES (60562, '2020-06-12', 'NG', 'Nigeria', 'AFRO', '681', '14554', '5', '387');
INSERT INTO public.who_global_data_import VALUES (60563, '2020-06-13', 'NG', 'Nigeria', 'AFRO', '0', '14554', '0', '387');
INSERT INTO public.who_global_data_import VALUES (60564, '2020-06-14', 'NG', 'Nigeria', 'AFRO', '627', '15181', '12', '399');
INSERT INTO public.who_global_data_import VALUES (60565, '2020-06-15', 'NG', 'Nigeria', 'AFRO', '904', '16085', '21', '420');
INSERT INTO public.who_global_data_import VALUES (60566, '2020-06-16', 'NG', 'Nigeria', 'AFRO', '573', '16658', '4', '424');
INSERT INTO public.who_global_data_import VALUES (60567, '2020-06-17', 'NG', 'Nigeria', 'AFRO', '490', '17148', '0', '424');
INSERT INTO public.who_global_data_import VALUES (60568, '2020-06-18', 'NG', 'Nigeria', 'AFRO', '587', '17735', '45', '469');
INSERT INTO public.who_global_data_import VALUES (60569, '2020-06-19', 'NG', 'Nigeria', 'AFRO', '745', '18480', '6', '475');
INSERT INTO public.who_global_data_import VALUES (60570, '2020-06-20', 'NG', 'Nigeria', 'AFRO', '667', '19147', '12', '487');
INSERT INTO public.who_global_data_import VALUES (60571, '2020-06-21', 'NG', 'Nigeria', 'AFRO', '661', '19808', '19', '506');
INSERT INTO public.who_global_data_import VALUES (60572, '2020-06-22', 'NG', 'Nigeria', 'AFRO', '436', '20244', '12', '518');
INSERT INTO public.who_global_data_import VALUES (60573, '2020-06-23', 'NG', 'Nigeria', 'AFRO', '675', '20919', '7', '525');
INSERT INTO public.who_global_data_import VALUES (60574, '2020-06-24', 'NG', 'Nigeria', 'AFRO', '452', '21371', '8', '533');
INSERT INTO public.who_global_data_import VALUES (60575, '2020-06-25', 'NG', 'Nigeria', 'AFRO', '649', '22020', '9', '542');
INSERT INTO public.who_global_data_import VALUES (60576, '2020-06-26', 'NG', 'Nigeria', 'AFRO', '594', '22614', '7', '549');
INSERT INTO public.who_global_data_import VALUES (60577, '2020-06-27', 'NG', 'Nigeria', 'AFRO', '684', '23298', '5', '554');
INSERT INTO public.who_global_data_import VALUES (60578, '2020-06-28', 'NG', 'Nigeria', 'AFRO', '779', '24077', '4', '558');
INSERT INTO public.who_global_data_import VALUES (60579, '2020-06-29', 'NG', 'Nigeria', 'AFRO', '490', '24567', '7', '565');
INSERT INTO public.who_global_data_import VALUES (60580, '2020-06-30', 'NG', 'Nigeria', 'AFRO', '566', '25133', '8', '573');
INSERT INTO public.who_global_data_import VALUES (60581, '2020-07-01', 'NG', 'Nigeria', 'AFRO', '561', '25694', '17', '590');
INSERT INTO public.who_global_data_import VALUES (60582, '2020-07-02', 'NG', 'Nigeria', 'AFRO', '790', '26484', '13', '603');
INSERT INTO public.who_global_data_import VALUES (60583, '2020-07-03', 'NG', 'Nigeria', 'AFRO', '626', '27110', '13', '616');
INSERT INTO public.who_global_data_import VALUES (60584, '2020-07-04', 'NG', 'Nigeria', 'AFRO', '454', '27564', '12', '628');
INSERT INTO public.who_global_data_import VALUES (60585, '2020-07-05', 'NG', 'Nigeria', 'AFRO', '603', '28167', '6', '634');
INSERT INTO public.who_global_data_import VALUES (60586, '2020-07-06', 'NG', 'Nigeria', 'AFRO', '544', '28711', '11', '645');
INSERT INTO public.who_global_data_import VALUES (60587, '2020-07-07', 'NG', 'Nigeria', 'AFRO', '575', '29286', '9', '654');
INSERT INTO public.who_global_data_import VALUES (60588, '2020-07-08', 'NG', 'Nigeria', 'AFRO', '503', '29789', '15', '669');
INSERT INTO public.who_global_data_import VALUES (60589, '2020-07-09', 'NG', 'Nigeria', 'AFRO', '460', '30249', '15', '684');
INSERT INTO public.who_global_data_import VALUES (60590, '2020-07-10', 'NG', 'Nigeria', 'AFRO', '499', '30748', '5', '689');
INSERT INTO public.who_global_data_import VALUES (60591, '2020-07-11', 'NG', 'Nigeria', 'AFRO', '575', '31323', '20', '709');
INSERT INTO public.who_global_data_import VALUES (60592, '2020-07-12', 'NG', 'Nigeria', 'AFRO', '664', '31987', '15', '724');
INSERT INTO public.who_global_data_import VALUES (60593, '2020-07-13', 'NG', 'Nigeria', 'AFRO', '571', '32558', '16', '740');
INSERT INTO public.who_global_data_import VALUES (60594, '2020-07-14', 'NG', 'Nigeria', 'AFRO', '595', '33153', '4', '744');
INSERT INTO public.who_global_data_import VALUES (60595, '2020-07-15', 'NG', 'Nigeria', 'AFRO', '463', '33616', '10', '754');
INSERT INTO public.who_global_data_import VALUES (60596, '2020-07-16', 'NG', 'Nigeria', 'AFRO', '643', '34259', '6', '760');
INSERT INTO public.who_global_data_import VALUES (60597, '2020-07-17', 'NG', 'Nigeria', 'AFRO', '595', '34854', '9', '769');
INSERT INTO public.who_global_data_import VALUES (60598, '2020-07-18', 'NG', 'Nigeria', 'AFRO', '600', '35454', '3', '772');
INSERT INTO public.who_global_data_import VALUES (60599, '2020-07-19', 'NG', 'Nigeria', 'AFRO', '653', '36107', '6', '778');
INSERT INTO public.who_global_data_import VALUES (60600, '2020-07-20', 'NG', 'Nigeria', 'AFRO', '556', '36663', '11', '789');
INSERT INTO public.who_global_data_import VALUES (60601, '2020-07-21', 'NG', 'Nigeria', 'AFRO', '562', '37225', '12', '801');
INSERT INTO public.who_global_data_import VALUES (60602, '2020-07-22', 'NG', 'Nigeria', 'AFRO', '576', '37801', '4', '805');
INSERT INTO public.who_global_data_import VALUES (60603, '2020-07-23', 'NG', 'Nigeria', 'AFRO', '543', '38344', '8', '813');
INSERT INTO public.who_global_data_import VALUES (60604, '2020-07-24', 'NG', 'Nigeria', 'AFRO', '604', '38948', '20', '833');
INSERT INTO public.who_global_data_import VALUES (60605, '2020-07-25', 'NG', 'Nigeria', 'AFRO', '591', '39539', '12', '845');
INSERT INTO public.who_global_data_import VALUES (60606, '2020-07-26', 'NG', 'Nigeria', 'AFRO', '438', '39977', '11', '856');
INSERT INTO public.who_global_data_import VALUES (60607, '2020-07-27', 'NG', 'Nigeria', 'AFRO', '555', '40532', '2', '858');
INSERT INTO public.who_global_data_import VALUES (60608, '2020-07-28', 'NG', 'Nigeria', 'AFRO', '648', '41180', '2', '860');
INSERT INTO public.who_global_data_import VALUES (60609, '2020-07-29', 'NG', 'Nigeria', 'AFRO', '624', '41804', '8', '868');
INSERT INTO public.who_global_data_import VALUES (60610, '2020-07-30', 'NG', 'Nigeria', 'AFRO', '404', '42208', '5', '873');
INSERT INTO public.who_global_data_import VALUES (60611, '2020-07-31', 'NG', 'Nigeria', 'AFRO', '481', '42689', '5', '878');
INSERT INTO public.who_global_data_import VALUES (60612, '2020-08-01', 'NG', 'Nigeria', 'AFRO', '462', '43151', '1', '879');
INSERT INTO public.who_global_data_import VALUES (60613, '2020-08-02', 'NG', 'Nigeria', 'AFRO', '386', '43537', '4', '883');
INSERT INTO public.who_global_data_import VALUES (60614, '2020-08-03', 'NG', 'Nigeria', 'AFRO', '304', '43841', '5', '888');
INSERT INTO public.who_global_data_import VALUES (60615, '2020-08-04', 'NG', 'Nigeria', 'AFRO', '288', '44129', '8', '896');
INSERT INTO public.who_global_data_import VALUES (60616, '2020-08-05', 'NG', 'Nigeria', 'AFRO', '304', '44433', '14', '910');
INSERT INTO public.who_global_data_import VALUES (60617, '2020-08-06', 'NG', 'Nigeria', 'AFRO', '457', '44890', '17', '927');
INSERT INTO public.who_global_data_import VALUES (60618, '2020-08-07', 'NG', 'Nigeria', 'AFRO', '354', '45244', '3', '930');
INSERT INTO public.who_global_data_import VALUES (60619, '2020-08-08', 'NG', 'Nigeria', 'AFRO', '443', '45687', '6', '936');
INSERT INTO public.who_global_data_import VALUES (60620, '2020-08-09', 'NG', 'Nigeria', 'AFRO', '453', '46140', '6', '942');
INSERT INTO public.who_global_data_import VALUES (60621, '2020-08-10', 'NG', 'Nigeria', 'AFRO', '437', '46577', '3', '945');
INSERT INTO public.who_global_data_import VALUES (60622, '2020-08-11', 'NG', 'Nigeria', 'AFRO', '290', '46867', '5', '950');
INSERT INTO public.who_global_data_import VALUES (60623, '2020-08-12', 'NG', 'Nigeria', 'AFRO', '423', '47290', '6', '956');
INSERT INTO public.who_global_data_import VALUES (60624, '2020-08-13', 'NG', 'Nigeria', 'AFRO', '453', '47743', '0', '956');
INSERT INTO public.who_global_data_import VALUES (60625, '2020-08-14', 'NG', 'Nigeria', 'AFRO', '373', '48116', '10', '966');
INSERT INTO public.who_global_data_import VALUES (60626, '2020-08-15', 'NG', 'Nigeria', 'AFRO', '329', '48445', '7', '973');
INSERT INTO public.who_global_data_import VALUES (60627, '2020-08-16', 'NG', 'Nigeria', 'AFRO', '325', '48770', '1', '974');
INSERT INTO public.who_global_data_import VALUES (60628, '2020-08-17', 'NG', 'Nigeria', 'AFRO', '298', '49068', '1', '975');
INSERT INTO public.who_global_data_import VALUES (60629, '2020-08-18', 'NG', 'Nigeria', 'AFRO', '417', '49485', '2', '977');
INSERT INTO public.who_global_data_import VALUES (60630, '2020-08-19', 'NG', 'Nigeria', 'AFRO', '410', '49895', '4', '981');
INSERT INTO public.who_global_data_import VALUES (60631, '2020-08-20', 'NG', 'Nigeria', 'AFRO', '593', '50488', '4', '985');
INSERT INTO public.who_global_data_import VALUES (60632, '2020-08-21', 'NG', 'Nigeria', 'AFRO', '476', '50964', '7', '992');
INSERT INTO public.who_global_data_import VALUES (60633, '2020-08-22', 'NG', 'Nigeria', 'AFRO', '340', '51304', '4', '996');
INSERT INTO public.who_global_data_import VALUES (60634, '2020-08-23', 'NG', 'Nigeria', 'AFRO', '601', '51905', '1', '997');
INSERT INTO public.who_global_data_import VALUES (60635, '2020-08-24', 'NG', 'Nigeria', 'AFRO', '322', '52227', '5', '1002');
INSERT INTO public.who_global_data_import VALUES (60636, '2020-08-25', 'NG', 'Nigeria', 'AFRO', '321', '52548', '2', '1004');
INSERT INTO public.who_global_data_import VALUES (60637, '2020-08-26', 'NG', 'Nigeria', 'AFRO', '252', '52800', '3', '1007');
INSERT INTO public.who_global_data_import VALUES (60638, '2020-08-27', 'NG', 'Nigeria', 'AFRO', '221', '53021', '3', '1010');
INSERT INTO public.who_global_data_import VALUES (60639, '2020-08-28', 'NG', 'Nigeria', 'AFRO', '296', '53317', '1', '1011');
INSERT INTO public.who_global_data_import VALUES (60640, '2020-08-29', 'NG', 'Nigeria', 'AFRO', '160', '53477', '0', '1011');
INSERT INTO public.who_global_data_import VALUES (60641, '2020-08-30', 'NG', 'Nigeria', 'AFRO', '250', '53727', '0', '1011');
INSERT INTO public.who_global_data_import VALUES (60642, '2020-08-31', 'NG', 'Nigeria', 'AFRO', '138', '53865', '2', '1013');
INSERT INTO public.who_global_data_import VALUES (60643, '2020-09-01', 'NG', 'Nigeria', 'AFRO', '143', '54008', '0', '1013');
INSERT INTO public.who_global_data_import VALUES (60644, '2020-09-02', 'NG', 'Nigeria', 'AFRO', '239', '54247', '10', '1023');
INSERT INTO public.who_global_data_import VALUES (60645, '2020-09-03', 'NG', 'Nigeria', 'AFRO', '216', '54463', '4', '1027');
INSERT INTO public.who_global_data_import VALUES (60646, '2020-09-04', 'NG', 'Nigeria', 'AFRO', '125', '54588', '21', '1048');
INSERT INTO public.who_global_data_import VALUES (60647, '2020-09-05', 'NG', 'Nigeria', 'AFRO', '155', '54743', '3', '1051');
INSERT INTO public.who_global_data_import VALUES (60648, '2020-09-06', 'NG', 'Nigeria', 'AFRO', '162', '54905', '3', '1054');
INSERT INTO public.who_global_data_import VALUES (60649, '2020-09-07', 'NG', 'Nigeria', 'AFRO', '100', '55005', '3', '1057');
INSERT INTO public.who_global_data_import VALUES (60650, '2020-09-08', 'NG', 'Nigeria', 'AFRO', '155', '55160', '4', '1061');
INSERT INTO public.who_global_data_import VALUES (60651, '2020-09-09', 'NG', 'Nigeria', 'AFRO', '296', '55456', '6', '1067');
INSERT INTO public.who_global_data_import VALUES (60652, '2020-09-10', 'NG', 'Nigeria', 'AFRO', '176', '55632', '3', '1070');
INSERT INTO public.who_global_data_import VALUES (60653, '2020-09-11', 'NG', 'Nigeria', 'AFRO', '197', '55829', '5', '1075');
INSERT INTO public.who_global_data_import VALUES (60654, '2020-09-12', 'NG', 'Nigeria', 'AFRO', '188', '56017', '1', '1076');
INSERT INTO public.who_global_data_import VALUES (60655, '2020-09-13', 'NG', 'Nigeria', 'AFRO', '160', '56177', '2', '1078');
INSERT INTO public.who_global_data_import VALUES (60656, '2020-09-14', 'NG', 'Nigeria', 'AFRO', '79', '56256', '4', '1082');
INSERT INTO public.who_global_data_import VALUES (60657, '2020-09-15', 'NG', 'Nigeria', 'AFRO', '132', '56388', '1', '1083');
INSERT INTO public.who_global_data_import VALUES (60658, '2020-09-16', 'NG', 'Nigeria', 'AFRO', '90', '56478', '5', '1088');
INSERT INTO public.who_global_data_import VALUES (60659, '2020-09-17', 'NG', 'Nigeria', 'AFRO', '126', '56604', '3', '1091');
INSERT INTO public.who_global_data_import VALUES (60660, '2020-09-18', 'NG', 'Nigeria', 'AFRO', '131', '56735', '2', '1093');
INSERT INTO public.who_global_data_import VALUES (60661, '2020-09-19', 'NG', 'Nigeria', 'AFRO', '221', '56956', '1', '1094');
INSERT INTO public.who_global_data_import VALUES (60662, '2020-09-20', 'NG', 'Nigeria', 'AFRO', '189', '57145', '1', '1095');
INSERT INTO public.who_global_data_import VALUES (60663, '2020-09-21', 'NG', 'Nigeria', 'AFRO', '97', '57242', '3', '1098');
INSERT INTO public.who_global_data_import VALUES (60664, '2020-09-22', 'NG', 'Nigeria', 'AFRO', '195', '57437', '2', '1100');
INSERT INTO public.who_global_data_import VALUES (60665, '2020-09-23', 'NG', 'Nigeria', 'AFRO', '176', '57613', '0', '1100');
INSERT INTO public.who_global_data_import VALUES (60666, '2020-09-24', 'NG', 'Nigeria', 'AFRO', '111', '57724', '2', '1102');
INSERT INTO public.who_global_data_import VALUES (60667, '2020-09-25', 'NG', 'Nigeria', 'AFRO', '125', '57849', '0', '1102');
INSERT INTO public.who_global_data_import VALUES (60668, '2020-09-26', 'NG', 'Nigeria', 'AFRO', '213', '58062', '1', '1103');
INSERT INTO public.who_global_data_import VALUES (60669, '2020-09-27', 'NG', 'Nigeria', 'AFRO', '136', '58198', '3', '1106');
INSERT INTO public.who_global_data_import VALUES (60670, '2020-09-28', 'NG', 'Nigeria', 'AFRO', '126', '58324', '2', '1108');
INSERT INTO public.who_global_data_import VALUES (60671, '2020-09-29', 'NG', 'Nigeria', 'AFRO', '136', '58460', '3', '1111');
INSERT INTO public.who_global_data_import VALUES (60672, '2020-09-30', 'NG', 'Nigeria', 'AFRO', '187', '58647', '0', '1111');
INSERT INTO public.who_global_data_import VALUES (60673, '2020-10-01', 'NG', 'Nigeria', 'AFRO', '201', '58848', '1', '1112');
INSERT INTO public.who_global_data_import VALUES (60674, '2020-10-02', 'NG', 'Nigeria', 'AFRO', '153', '59001', '0', '1112');
INSERT INTO public.who_global_data_import VALUES (60675, '2020-10-03', 'NG', 'Nigeria', 'AFRO', '126', '59127', '0', '1112');
INSERT INTO public.who_global_data_import VALUES (60676, '2020-10-04', 'NG', 'Nigeria', 'AFRO', '160', '59287', '1', '1113');
INSERT INTO public.who_global_data_import VALUES (60677, '2020-10-05', 'NG', 'Nigeria', 'AFRO', '58', '59345', '0', '1113');
INSERT INTO public.who_global_data_import VALUES (60678, '2020-10-06', 'NG', 'Nigeria', 'AFRO', '120', '59465', '0', '1113');
INSERT INTO public.who_global_data_import VALUES (60679, '2020-10-07', 'NG', 'Nigeria', 'AFRO', '118', '59583', '0', '1113');
INSERT INTO public.who_global_data_import VALUES (60680, '2020-10-08', 'NG', 'Nigeria', 'AFRO', '155', '59738', '0', '1113');
INSERT INTO public.who_global_data_import VALUES (60681, '2020-10-09', 'NG', 'Nigeria', 'AFRO', '103', '59841', '0', '1113');
INSERT INTO public.who_global_data_import VALUES (60682, '2020-10-10', 'NG', 'Nigeria', 'AFRO', '151', '59992', '0', '1113');
INSERT INTO public.who_global_data_import VALUES (60683, '2020-10-11', 'NG', 'Nigeria', 'AFRO', '111', '60103', '2', '1115');
INSERT INTO public.who_global_data_import VALUES (60684, '2020-10-12', 'NG', 'Nigeria', 'AFRO', '163', '60266', '0', '1115');
INSERT INTO public.who_global_data_import VALUES (60685, '2020-10-13', 'NG', 'Nigeria', 'AFRO', '164', '60430', '0', '1115');
INSERT INTO public.who_global_data_import VALUES (60686, '2020-10-14', 'NG', 'Nigeria', 'AFRO', '225', '60655', '1', '1116');
INSERT INTO public.who_global_data_import VALUES (60687, '2020-10-15', 'NG', 'Nigeria', 'AFRO', '179', '60834', '0', '1116');
INSERT INTO public.who_global_data_import VALUES (60688, '2020-10-16', 'NG', 'Nigeria', 'AFRO', '148', '60982', '0', '1116');
INSERT INTO public.who_global_data_import VALUES (60689, '2020-10-17', 'NG', 'Nigeria', 'AFRO', '212', '61194', '3', '1119');
INSERT INTO public.who_global_data_import VALUES (60690, '2020-10-18', 'NG', 'Nigeria', 'AFRO', '113', '61307', '4', '1123');
INSERT INTO public.who_global_data_import VALUES (60691, '2020-10-19', 'NG', 'Nigeria', 'AFRO', '133', '61440', '2', '1125');
INSERT INTO public.who_global_data_import VALUES (60692, '2020-10-20', 'NG', 'Nigeria', 'AFRO', '118', '61558', '0', '1125');
INSERT INTO public.who_global_data_import VALUES (60693, '2020-10-21', 'NG', 'Nigeria', 'AFRO', '72', '61630', '0', '1125');
INSERT INTO public.who_global_data_import VALUES (60694, '2020-10-22', 'NG', 'Nigeria', 'AFRO', '37', '61667', '0', '1125');
INSERT INTO public.who_global_data_import VALUES (60695, '2020-10-23', 'NG', 'Nigeria', 'AFRO', '138', '61805', '2', '1127');
INSERT INTO public.who_global_data_import VALUES (60696, '2020-10-24', 'NG', 'Nigeria', 'AFRO', '77', '61882', '2', '1129');
INSERT INTO public.who_global_data_import VALUES (60697, '2020-10-25', 'NG', 'Nigeria', 'AFRO', '48', '61930', '0', '1129');
INSERT INTO public.who_global_data_import VALUES (60698, '2020-10-26', 'NG', 'Nigeria', 'AFRO', '62', '61992', '1', '1130');
INSERT INTO public.who_global_data_import VALUES (60699, '2020-10-27', 'NG', 'Nigeria', 'AFRO', '119', '62111', '2', '1132');
INSERT INTO public.who_global_data_import VALUES (60700, '2020-10-28', 'NG', 'Nigeria', 'AFRO', '113', '62224', '3', '1135');
INSERT INTO public.who_global_data_import VALUES (60701, '2020-10-29', 'NG', 'Nigeria', 'AFRO', '147', '62371', '4', '1139');
INSERT INTO public.who_global_data_import VALUES (60702, '2020-10-30', 'NG', 'Nigeria', 'AFRO', '150', '62521', '2', '1141');
INSERT INTO public.who_global_data_import VALUES (60703, '2020-10-31', 'NG', 'Nigeria', 'AFRO', '170', '62691', '3', '1144');
INSERT INTO public.who_global_data_import VALUES (60704, '2020-11-01', 'NG', 'Nigeria', 'AFRO', '162', '62853', '0', '1144');
INSERT INTO public.who_global_data_import VALUES (60705, '2020-11-02', 'NG', 'Nigeria', 'AFRO', '111', '62964', '2', '1146');
INSERT INTO public.who_global_data_import VALUES (60706, '2020-11-03', 'NG', 'Nigeria', 'AFRO', '72', '63036', '1', '1147');
INSERT INTO public.who_global_data_import VALUES (60707, '2020-11-04', 'NG', 'Nigeria', 'AFRO', '137', '63173', '4', '1151');
INSERT INTO public.who_global_data_import VALUES (60708, '2020-11-05', 'NG', 'Nigeria', 'AFRO', '155', '63328', '4', '1155');
INSERT INTO public.who_global_data_import VALUES (60709, '2020-11-06', 'NG', 'Nigeria', 'AFRO', '180', '63508', '0', '1155');
INSERT INTO public.who_global_data_import VALUES (60710, '2020-11-07', 'NG', 'Nigeria', 'AFRO', '223', '63731', '1', '1156');
INSERT INTO public.who_global_data_import VALUES (60711, '2020-11-08', 'NG', 'Nigeria', 'AFRO', '59', '63790', '0', '1156');
INSERT INTO public.who_global_data_import VALUES (60712, '2020-11-09', 'NG', 'Nigeria', 'AFRO', '300', '64090', '0', '1156');
INSERT INTO public.who_global_data_import VALUES (60713, '2020-11-10', 'NG', 'Nigeria', 'AFRO', '94', '64184', '2', '1158');
INSERT INTO public.who_global_data_import VALUES (60714, '2020-11-11', 'NG', 'Nigeria', 'AFRO', '152', '64336', '2', '1160');
INSERT INTO public.who_global_data_import VALUES (60715, '2020-11-12', 'NG', 'Nigeria', 'AFRO', '180', '64516', '2', '1162');
INSERT INTO public.who_global_data_import VALUES (60716, '2020-11-13', 'NG', 'Nigeria', 'AFRO', '212', '64728', '0', '1162');
INSERT INTO public.who_global_data_import VALUES (60717, '2020-11-14', 'NG', 'Nigeria', 'AFRO', '156', '64884', '1', '1163');
INSERT INTO public.who_global_data_import VALUES (60718, '2020-11-15', 'NG', 'Nigeria', 'AFRO', '112', '64996', '0', '1163');
INSERT INTO public.who_global_data_import VALUES (60719, '2020-11-16', 'NG', 'Nigeria', 'AFRO', '152', '65148', '0', '1163');
INSERT INTO public.who_global_data_import VALUES (60720, '2020-11-17', 'NG', 'Nigeria', 'AFRO', '157', '65305', '0', '1163');
INSERT INTO public.who_global_data_import VALUES (60721, '2020-11-18', 'NG', 'Nigeria', 'AFRO', '152', '65457', '0', '1163');
INSERT INTO public.who_global_data_import VALUES (60722, '2020-11-19', 'NG', 'Nigeria', 'AFRO', '236', '65693', '0', '1163');
INSERT INTO public.who_global_data_import VALUES (60723, '2020-11-20', 'NG', 'Nigeria', 'AFRO', '146', '65839', '2', '1165');
INSERT INTO public.who_global_data_import VALUES (60724, '2020-11-21', 'NG', 'Nigeria', 'AFRO', '143', '65982', '0', '1165');
INSERT INTO public.who_global_data_import VALUES (60725, '2020-11-22', 'NG', 'Nigeria', 'AFRO', '246', '66228', '1', '1166');
INSERT INTO public.who_global_data_import VALUES (60726, '2020-11-23', 'NG', 'Nigeria', 'AFRO', '155', '66383', '1', '1167');
INSERT INTO public.who_global_data_import VALUES (60727, '2020-11-24', 'NG', 'Nigeria', 'AFRO', '56', '66439', '1', '1168');
INSERT INTO public.who_global_data_import VALUES (60728, '2020-11-25', 'NG', 'Nigeria', 'AFRO', '168', '66607', '1', '1169');
INSERT INTO public.who_global_data_import VALUES (60729, '2020-11-26', 'NG', 'Nigeria', 'AFRO', '198', '66805', '0', '1169');
INSERT INTO public.who_global_data_import VALUES (60730, '2020-11-27', 'NG', 'Nigeria', 'AFRO', '169', '66974', '0', '1169');
INSERT INTO public.who_global_data_import VALUES (60731, '2020-11-28', 'NG', 'Nigeria', 'AFRO', '246', '67220', '2', '1171');
INSERT INTO public.who_global_data_import VALUES (60732, '2020-11-29', 'NG', 'Nigeria', 'AFRO', '110', '67330', '0', '1171');
INSERT INTO public.who_global_data_import VALUES (60733, '2020-11-30', 'NG', 'Nigeria', 'AFRO', '82', '67412', '2', '1173');
INSERT INTO public.who_global_data_import VALUES (60734, '2020-12-01', 'NG', 'Nigeria', 'AFRO', '145', '67557', '0', '1173');
INSERT INTO public.who_global_data_import VALUES (60735, '2020-12-02', 'NG', 'Nigeria', 'AFRO', '281', '67838', '3', '1176');
INSERT INTO public.who_global_data_import VALUES (60736, '2020-12-03', 'NG', 'Nigeria', 'AFRO', '122', '67960', '1', '1177');
INSERT INTO public.who_global_data_import VALUES (60737, '2020-12-04', 'NG', 'Nigeria', 'AFRO', '343', '68303', '2', '1179');
INSERT INTO public.who_global_data_import VALUES (60738, '2020-12-05', 'NG', 'Nigeria', 'AFRO', '324', '68627', '0', '1179');
INSERT INTO public.who_global_data_import VALUES (60739, '2020-12-06', 'NG', 'Nigeria', 'AFRO', '310', '68937', '1', '1180');
INSERT INTO public.who_global_data_import VALUES (60740, '2020-12-07', 'NG', 'Nigeria', 'AFRO', '318', '69255', '0', '1180');
INSERT INTO public.who_global_data_import VALUES (60741, '2020-12-08', 'NG', 'Nigeria', 'AFRO', '390', '69645', '1', '1181');
INSERT INTO public.who_global_data_import VALUES (60742, '2020-12-09', 'NG', 'Nigeria', 'AFRO', '550', '70195', '1', '1182');
INSERT INTO public.who_global_data_import VALUES (60743, '2020-12-10', 'NG', 'Nigeria', 'AFRO', '474', '70669', '2', '1184');
INSERT INTO public.who_global_data_import VALUES (60744, '2020-12-11', 'NG', 'Nigeria', 'AFRO', '675', '71344', '6', '1190');
INSERT INTO public.who_global_data_import VALUES (60745, '2020-12-12', 'NG', 'Nigeria', 'AFRO', '796', '72140', '0', '1190');
INSERT INTO public.who_global_data_import VALUES (60746, '2020-12-13', 'NG', 'Nigeria', 'AFRO', '617', '72757', '4', '1194');
INSERT INTO public.who_global_data_import VALUES (60747, '2020-12-14', 'NG', 'Nigeria', 'AFRO', '418', '73175', '3', '1197');
INSERT INTO public.who_global_data_import VALUES (60748, '2020-12-15', 'NG', 'Nigeria', 'AFRO', '199', '73374', '0', '1197');
INSERT INTO public.who_global_data_import VALUES (60749, '2020-12-16', 'NG', 'Nigeria', 'AFRO', '758', '74132', '3', '1200');
INSERT INTO public.who_global_data_import VALUES (60750, '2020-12-17', 'NG', 'Nigeria', 'AFRO', '930', '75062', '0', '1200');
INSERT INTO public.who_global_data_import VALUES (60751, '2020-12-18', 'NG', 'Nigeria', 'AFRO', '1145', '76207', '1', '1201');
INSERT INTO public.who_global_data_import VALUES (60752, '2020-12-19', 'NG', 'Nigeria', 'AFRO', '806', '77013', '11', '1212');
INSERT INTO public.who_global_data_import VALUES (60753, '2020-12-20', 'NG', 'Nigeria', 'AFRO', '920', '77933', '6', '1218');
INSERT INTO public.who_global_data_import VALUES (60754, '2020-12-21', 'NG', 'Nigeria', 'AFRO', '501', '78434', '3', '1221');
INSERT INTO public.who_global_data_import VALUES (60755, '2020-12-22', 'NG', 'Nigeria', 'AFRO', '356', '78790', '6', '1227');
INSERT INTO public.who_global_data_import VALUES (60756, '2020-12-23', 'NG', 'Nigeria', 'AFRO', '999', '79789', '4', '1231');
INSERT INTO public.who_global_data_import VALUES (60757, '2020-12-24', 'NG', 'Nigeria', 'AFRO', '1133', '80922', '5', '1236');
INSERT INTO public.who_global_data_import VALUES (60758, '2020-12-25', 'NG', 'Nigeria', 'AFRO', '0', '80922', '0', '1236');
INSERT INTO public.who_global_data_import VALUES (60759, '2020-12-26', 'NG', 'Nigeria', 'AFRO', '1825', '82747', '10', '1246');
INSERT INTO public.who_global_data_import VALUES (60760, '2020-12-27', 'NG', 'Nigeria', 'AFRO', '829', '83576', '1', '1247');
INSERT INTO public.who_global_data_import VALUES (60761, '2020-12-28', 'NG', 'Nigeria', 'AFRO', '838', '84414', '7', '1254');
INSERT INTO public.who_global_data_import VALUES (60762, '2020-12-29', 'NG', 'Nigeria', 'AFRO', '397', '84811', '10', '1264');
INSERT INTO public.who_global_data_import VALUES (60763, '2020-12-30', 'NG', 'Nigeria', 'AFRO', '749', '85560', '3', '1267');
INSERT INTO public.who_global_data_import VALUES (60764, '2020-12-31', 'NG', 'Nigeria', 'AFRO', '1016', '86576', '11', '1278');
INSERT INTO public.who_global_data_import VALUES (60765, '2021-01-01', 'NG', 'Nigeria', 'AFRO', '934', '87510', '11', '1289');
INSERT INTO public.who_global_data_import VALUES (60766, '2021-01-02', 'NG', 'Nigeria', 'AFRO', '0', '87510', '0', '1289');
INSERT INTO public.who_global_data_import VALUES (60767, '2021-01-03', 'NG', 'Nigeria', 'AFRO', '1653', '89163', '13', '1302');
INSERT INTO public.who_global_data_import VALUES (60768, '2021-01-04', 'NG', 'Nigeria', 'AFRO', '917', '90080', '9', '1311');
INSERT INTO public.who_global_data_import VALUES (60769, '2021-01-05', 'NG', 'Nigeria', 'AFRO', '1204', '91284', '7', '1318');
INSERT INTO public.who_global_data_import VALUES (60770, '2021-01-06', 'NG', 'Nigeria', 'AFRO', '1421', '92705', '1', '1319');
INSERT INTO public.who_global_data_import VALUES (60771, '2021-01-07', 'NG', 'Nigeria', 'AFRO', '1664', '94369', '5', '1324');
INSERT INTO public.who_global_data_import VALUES (60772, '2021-01-08', 'NG', 'Nigeria', 'AFRO', '1565', '95934', '6', '1330');
INSERT INTO public.who_global_data_import VALUES (60773, '2021-01-09', 'NG', 'Nigeria', 'AFRO', '1544', '97478', '12', '1342');
INSERT INTO public.who_global_data_import VALUES (60774, '2021-01-10', 'NG', 'Nigeria', 'AFRO', '0', '97478', '0', '1342');
INSERT INTO public.who_global_data_import VALUES (60775, '2021-01-11', 'NG', 'Nigeria', 'AFRO', '2609', '100087', '16', '1358');
INSERT INTO public.who_global_data_import VALUES (60776, '2021-01-12', 'NG', 'Nigeria', 'AFRO', '1244', '101331', '3', '1361');
INSERT INTO public.who_global_data_import VALUES (60777, '2021-01-13', 'NG', 'Nigeria', 'AFRO', '1270', '102601', '12', '1373');
INSERT INTO public.who_global_data_import VALUES (60778, '2021-01-14', 'NG', 'Nigeria', 'AFRO', '1398', '103999', '9', '1382');
INSERT INTO public.who_global_data_import VALUES (60779, '2021-01-15', 'NG', 'Nigeria', 'AFRO', '1479', '105478', '23', '1405');
INSERT INTO public.who_global_data_import VALUES (60780, '2021-01-16', 'NG', 'Nigeria', 'AFRO', '1867', '107345', '8', '1413');
INSERT INTO public.who_global_data_import VALUES (60781, '2021-01-17', 'NG', 'Nigeria', 'AFRO', '1598', '108943', '7', '1420');
INSERT INTO public.who_global_data_import VALUES (60782, '2021-01-18', 'NG', 'Nigeria', 'AFRO', '1444', '110387', '15', '1435');
INSERT INTO public.who_global_data_import VALUES (60783, '2021-01-19', 'NG', 'Nigeria', 'AFRO', '1617', '112004', '14', '1449');
INSERT INTO public.who_global_data_import VALUES (60784, '2021-01-20', 'NG', 'Nigeria', 'AFRO', '1301', '113305', '15', '1464');
INSERT INTO public.who_global_data_import VALUES (60785, '2021-01-21', 'NG', 'Nigeria', 'AFRO', '1386', '114691', '14', '1478');
INSERT INTO public.who_global_data_import VALUES (60786, '2021-01-22', 'NG', 'Nigeria', 'AFRO', '1962', '116653', '7', '1485');
INSERT INTO public.who_global_data_import VALUES (60787, '2021-01-23', 'NG', 'Nigeria', 'AFRO', '1485', '118138', '5', '1490');
INSERT INTO public.who_global_data_import VALUES (60788, '2021-01-24', 'NG', 'Nigeria', 'AFRO', '2464', '120602', '5', '1495');
INSERT INTO public.who_global_data_import VALUES (60789, '2021-01-25', 'NG', 'Nigeria', 'AFRO', '964', '121566', '2', '1497');
INSERT INTO public.who_global_data_import VALUES (60790, '2021-01-26', 'NG', 'Nigeria', 'AFRO', '1430', '122996', '10', '1507');
INSERT INTO public.who_global_data_import VALUES (60791, '2021-01-27', 'NG', 'Nigeria', 'AFRO', '1303', '124299', '15', '1522');
INSERT INTO public.who_global_data_import VALUES (60792, '2021-01-28', 'NG', 'Nigeria', 'AFRO', '1861', '126160', '21', '1543');
INSERT INTO public.who_global_data_import VALUES (60793, '2021-01-29', 'NG', 'Nigeria', 'AFRO', '864', '127024', '4', '1547');
INSERT INTO public.who_global_data_import VALUES (60794, '2021-01-30', 'NG', 'Nigeria', 'AFRO', '1650', '128674', '30', '1577');
INSERT INTO public.who_global_data_import VALUES (60913, '2020-04-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60795, '2021-01-31', 'NG', 'Nigeria', 'AFRO', '1883', '130557', '1', '1578');
INSERT INTO public.who_global_data_import VALUES (60796, '2021-02-01', 'NG', 'Nigeria', 'AFRO', '685', '131242', '8', '1586');
INSERT INTO public.who_global_data_import VALUES (60797, '2021-02-02', 'NG', 'Nigeria', 'AFRO', '676', '131918', '21', '1607');
INSERT INTO public.who_global_data_import VALUES (60798, '2021-02-03', 'NG', 'Nigeria', 'AFRO', '1634', '133552', '6', '1613');
INSERT INTO public.who_global_data_import VALUES (60799, '2021-02-04', 'NG', 'Nigeria', 'AFRO', '1138', '134690', '5', '1618');
INSERT INTO public.who_global_data_import VALUES (60800, '2021-02-05', 'NG', 'Nigeria', 'AFRO', '1340', '136030', '14', '1632');
INSERT INTO public.who_global_data_import VALUES (60801, '2020-01-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60802, '2020-01-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60803, '2020-01-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60804, '2020-01-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60805, '2020-01-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60806, '2020-01-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60807, '2020-01-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60808, '2020-01-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60809, '2020-01-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60810, '2020-01-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60811, '2020-01-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60812, '2020-01-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60813, '2020-01-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60814, '2020-01-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60815, '2020-01-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60816, '2020-01-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60817, '2020-01-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60818, '2020-01-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60819, '2020-01-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60820, '2020-01-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60821, '2020-01-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60822, '2020-01-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60823, '2020-01-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60824, '2020-01-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60825, '2020-01-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60826, '2020-01-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60827, '2020-01-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60828, '2020-01-30', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60829, '2020-01-31', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60830, '2020-02-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60831, '2020-02-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60832, '2020-02-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60833, '2020-02-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60834, '2020-02-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60835, '2020-02-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60836, '2020-02-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60837, '2020-02-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60838, '2020-02-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60839, '2020-02-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60840, '2020-02-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60841, '2020-02-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60842, '2020-02-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60843, '2020-02-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60844, '2020-02-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60845, '2020-02-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60846, '2020-02-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60847, '2020-02-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60848, '2020-02-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60849, '2020-02-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60850, '2020-02-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60851, '2020-02-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60852, '2020-02-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60853, '2020-02-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60854, '2020-02-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60855, '2020-02-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60856, '2020-02-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60857, '2020-02-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60858, '2020-02-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60859, '2020-03-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60860, '2020-03-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60861, '2020-03-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60862, '2020-03-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60863, '2020-03-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60864, '2020-03-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60865, '2020-03-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60866, '2020-03-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60867, '2020-03-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60868, '2020-03-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60869, '2020-03-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60870, '2020-03-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60871, '2020-03-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60872, '2020-03-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60873, '2020-03-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60874, '2020-03-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60875, '2020-03-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60876, '2020-03-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60877, '2020-03-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60878, '2020-03-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60879, '2020-03-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60880, '2020-03-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60881, '2020-03-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60882, '2020-03-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60883, '2020-03-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60884, '2020-03-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60885, '2020-03-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60886, '2020-03-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60887, '2020-03-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60888, '2020-03-30', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60889, '2020-03-31', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60890, '2020-04-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60891, '2020-04-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60892, '2020-04-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60893, '2020-04-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60894, '2020-04-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60895, '2020-04-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60896, '2020-04-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60897, '2020-04-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60898, '2020-04-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60899, '2020-04-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60900, '2020-04-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60901, '2020-04-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60902, '2020-04-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60903, '2020-04-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60904, '2020-04-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60905, '2020-04-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60906, '2020-04-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60907, '2020-04-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60908, '2020-04-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60909, '2020-04-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60910, '2020-04-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60911, '2020-04-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60912, '2020-04-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60914, '2020-04-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60915, '2020-04-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60916, '2020-04-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60917, '2020-04-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60918, '2020-04-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60919, '2020-04-30', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60920, '2020-05-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60921, '2020-05-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60922, '2020-05-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60923, '2020-05-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60924, '2020-05-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60925, '2020-05-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60926, '2020-05-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60927, '2020-05-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60928, '2020-05-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60929, '2020-05-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60930, '2020-05-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60931, '2020-05-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60932, '2020-05-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60933, '2020-05-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60934, '2020-05-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60935, '2020-05-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60936, '2020-05-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60937, '2020-05-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60938, '2020-05-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60939, '2020-05-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60940, '2020-05-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60941, '2020-05-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60942, '2020-05-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60943, '2020-05-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60944, '2020-05-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60945, '2020-05-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60946, '2020-05-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60947, '2020-05-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60948, '2020-05-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60949, '2020-05-30', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60950, '2020-05-31', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60951, '2020-06-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60952, '2020-06-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60953, '2020-06-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60954, '2020-06-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60955, '2020-06-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60956, '2020-06-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60957, '2020-06-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60958, '2020-06-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60959, '2020-06-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60960, '2020-06-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60961, '2020-06-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60962, '2020-06-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60963, '2020-06-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60964, '2020-06-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60965, '2020-06-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60966, '2020-06-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60967, '2020-06-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60968, '2020-06-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60969, '2020-06-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60970, '2020-06-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60971, '2020-06-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60972, '2020-06-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60973, '2020-06-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60974, '2020-06-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60975, '2020-06-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60976, '2020-06-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60977, '2020-06-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60978, '2020-06-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60979, '2020-06-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60980, '2020-06-30', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60981, '2020-07-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60982, '2020-07-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60983, '2020-07-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60984, '2020-07-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60985, '2020-07-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60986, '2020-07-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60987, '2020-07-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60988, '2020-07-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60989, '2020-07-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60990, '2020-07-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60991, '2020-07-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60992, '2020-07-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60993, '2020-07-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60994, '2020-07-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60995, '2020-07-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60996, '2020-07-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60997, '2020-07-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60998, '2020-07-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (60999, '2020-07-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61000, '2020-07-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61001, '2020-07-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61002, '2020-07-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61003, '2020-07-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61004, '2020-07-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61005, '2020-07-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61006, '2020-07-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61007, '2020-07-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61008, '2020-07-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61009, '2020-07-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61010, '2020-07-30', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61011, '2020-07-31', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61012, '2020-08-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61013, '2020-08-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61014, '2020-08-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61015, '2020-08-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61016, '2020-08-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61017, '2020-08-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61018, '2020-08-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61019, '2020-08-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61020, '2020-08-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61021, '2020-08-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61022, '2020-08-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61023, '2020-08-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61024, '2020-08-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61025, '2020-08-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61026, '2020-08-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61027, '2020-08-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61028, '2020-08-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61029, '2020-08-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61030, '2020-08-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61031, '2020-08-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61032, '2020-08-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61033, '2020-08-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61034, '2020-08-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61035, '2020-08-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61036, '2020-08-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61037, '2020-08-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61038, '2020-08-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61039, '2020-08-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61040, '2020-08-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61041, '2020-08-30', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61042, '2020-08-31', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61043, '2020-09-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61044, '2020-09-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61045, '2020-09-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61046, '2020-09-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61047, '2020-09-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61048, '2020-09-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61049, '2020-09-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61050, '2020-09-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61051, '2020-09-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61052, '2020-09-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61053, '2020-09-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61054, '2020-09-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61055, '2020-09-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61056, '2020-09-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61057, '2020-09-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61058, '2020-09-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61059, '2020-09-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61060, '2020-09-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61061, '2020-09-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61062, '2020-09-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61063, '2020-09-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61064, '2020-09-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61065, '2020-09-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61066, '2020-09-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61067, '2020-09-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61068, '2020-09-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61069, '2020-09-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61070, '2020-09-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61071, '2020-09-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61072, '2020-09-30', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61073, '2020-10-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61074, '2020-10-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61075, '2020-10-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61076, '2020-10-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61077, '2020-10-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61078, '2020-10-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61079, '2020-10-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61080, '2020-10-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61081, '2020-10-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61082, '2020-10-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61083, '2020-10-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61084, '2020-10-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61085, '2020-10-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61086, '2020-10-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61087, '2020-10-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61088, '2020-10-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61089, '2020-10-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61090, '2020-10-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61091, '2020-10-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61092, '2020-10-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61093, '2020-10-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61094, '2020-10-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61095, '2020-10-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61096, '2020-10-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61097, '2020-10-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61098, '2020-10-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61099, '2020-10-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61100, '2020-10-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61101, '2020-10-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61102, '2020-10-30', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61103, '2020-10-31', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61104, '2020-11-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61105, '2020-11-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61106, '2020-11-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61107, '2020-11-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61108, '2020-11-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61109, '2020-11-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61110, '2020-11-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61111, '2020-11-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61112, '2020-11-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61113, '2020-11-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61114, '2020-11-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61115, '2020-11-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61116, '2020-11-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61117, '2020-11-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61118, '2020-11-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61119, '2020-11-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61120, '2020-11-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61121, '2020-11-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61122, '2020-11-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61123, '2020-11-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61124, '2020-11-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61125, '2020-11-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61126, '2020-11-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61127, '2020-11-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61128, '2020-11-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61129, '2020-11-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61130, '2020-11-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61131, '2020-11-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61132, '2020-11-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61133, '2020-11-30', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61134, '2020-12-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61135, '2020-12-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61136, '2020-12-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61137, '2020-12-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61138, '2020-12-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61139, '2020-12-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61140, '2020-12-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61141, '2020-12-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61142, '2020-12-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61143, '2020-12-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61144, '2020-12-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61145, '2020-12-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61146, '2020-12-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61147, '2020-12-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61148, '2020-12-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61149, '2020-12-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61150, '2020-12-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61151, '2020-12-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61152, '2020-12-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61153, '2020-12-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61154, '2020-12-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61155, '2020-12-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61156, '2020-12-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61157, '2020-12-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61158, '2020-12-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61159, '2020-12-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61160, '2020-12-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61161, '2020-12-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61162, '2020-12-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61163, '2020-12-30', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61164, '2020-12-31', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61165, '2021-01-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61166, '2021-01-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61167, '2021-01-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61168, '2021-01-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61169, '2021-01-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61170, '2021-01-06', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61171, '2021-01-07', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61172, '2021-01-08', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61173, '2021-01-09', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61174, '2021-01-10', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61175, '2021-01-11', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61176, '2021-01-12', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61177, '2021-01-13', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61178, '2021-01-14', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61179, '2021-01-15', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61180, '2021-01-16', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61181, '2021-01-17', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61182, '2021-01-18', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61183, '2021-01-19', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61184, '2021-01-20', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61185, '2021-01-21', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61186, '2021-01-22', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61187, '2021-01-23', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61188, '2021-01-24', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61189, '2021-01-25', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61190, '2021-01-26', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61191, '2021-01-27', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61192, '2021-01-28', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61193, '2021-01-29', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61194, '2021-01-30', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61195, '2021-01-31', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61196, '2021-02-01', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61197, '2021-02-02', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61198, '2021-02-03', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61199, '2021-02-04', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61200, '2021-02-05', 'NU', 'Niue', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61201, '2020-01-03', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61202, '2020-01-04', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61203, '2020-01-05', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61204, '2020-01-06', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61205, '2020-01-07', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61206, '2020-01-08', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61207, '2020-01-09', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61208, '2020-01-10', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61209, '2020-01-11', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61210, '2020-01-12', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61211, '2020-01-13', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61212, '2020-01-14', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61213, '2020-01-15', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61214, '2020-01-16', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61215, '2020-01-17', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61216, '2020-01-18', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61217, '2020-01-19', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61218, '2020-01-20', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61219, '2020-01-21', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61220, '2020-01-22', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61221, '2020-01-23', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61222, '2020-01-24', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61223, '2020-01-25', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61224, '2020-01-26', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61225, '2020-01-27', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61226, '2020-01-28', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61227, '2020-01-29', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61228, '2020-01-30', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61229, '2020-01-31', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61230, '2020-02-01', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61231, '2020-02-02', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61232, '2020-02-03', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61233, '2020-02-04', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61234, '2020-02-05', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61235, '2020-02-06', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61236, '2020-02-07', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61237, '2020-02-08', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61238, '2020-02-09', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61239, '2020-02-10', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61240, '2020-02-11', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61241, '2020-02-12', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61242, '2020-02-13', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61243, '2020-02-14', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61244, '2020-02-15', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61245, '2020-02-16', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61246, '2020-02-17', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61247, '2020-02-18', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61248, '2020-02-19', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61249, '2020-02-20', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61250, '2020-02-21', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61251, '2020-02-22', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61252, '2020-02-23', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61253, '2020-02-24', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61254, '2020-02-25', 'MK', 'North Macedonia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61255, '2020-02-26', 'MK', 'North Macedonia', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61256, '2020-02-27', 'MK', 'North Macedonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61257, '2020-02-28', 'MK', 'North Macedonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61258, '2020-02-29', 'MK', 'North Macedonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61259, '2020-03-01', 'MK', 'North Macedonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61260, '2020-03-02', 'MK', 'North Macedonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61261, '2020-03-03', 'MK', 'North Macedonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61262, '2020-03-04', 'MK', 'North Macedonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61263, '2020-03-05', 'MK', 'North Macedonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61264, '2020-03-06', 'MK', 'North Macedonia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61265, '2020-03-07', 'MK', 'North Macedonia', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61266, '2020-03-08', 'MK', 'North Macedonia', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61267, '2020-03-09', 'MK', 'North Macedonia', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61268, '2020-03-10', 'MK', 'North Macedonia', 'EURO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61269, '2020-03-11', 'MK', 'North Macedonia', 'EURO', '3', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61270, '2020-03-12', 'MK', 'North Macedonia', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61271, '2020-03-13', 'MK', 'North Macedonia', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61272, '2020-03-14', 'MK', 'North Macedonia', 'EURO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61273, '2020-03-15', 'MK', 'North Macedonia', 'EURO', '4', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61274, '2020-03-16', 'MK', 'North Macedonia', 'EURO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61275, '2020-03-17', 'MK', 'North Macedonia', 'EURO', '6', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61276, '2020-03-18', 'MK', 'North Macedonia', 'EURO', '12', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61277, '2020-03-19', 'MK', 'North Macedonia', 'EURO', '4', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61278, '2020-03-20', 'MK', 'North Macedonia', 'EURO', '13', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61279, '2020-03-21', 'MK', 'North Macedonia', 'EURO', '37', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61280, '2020-03-22', 'MK', 'North Macedonia', 'EURO', '29', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61281, '2020-03-23', 'MK', 'North Macedonia', 'EURO', '22', '136', '2', '2');
INSERT INTO public.who_global_data_import VALUES (61282, '2020-03-24', 'MK', 'North Macedonia', 'EURO', '12', '148', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61283, '2020-03-25', 'MK', 'North Macedonia', 'EURO', '29', '177', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61284, '2020-03-26', 'MK', 'North Macedonia', 'EURO', '24', '201', '1', '3');
INSERT INTO public.who_global_data_import VALUES (61285, '2020-03-27', 'MK', 'North Macedonia', 'EURO', '18', '219', '0', '3');
INSERT INTO public.who_global_data_import VALUES (61286, '2020-03-28', 'MK', 'North Macedonia', 'EURO', '22', '241', '1', '4');
INSERT INTO public.who_global_data_import VALUES (61287, '2020-03-29', 'MK', 'North Macedonia', 'EURO', '0', '241', '0', '4');
INSERT INTO public.who_global_data_import VALUES (61288, '2020-03-30', 'MK', 'North Macedonia', 'EURO', '44', '285', '3', '7');
INSERT INTO public.who_global_data_import VALUES (61289, '2020-03-31', 'MK', 'North Macedonia', 'EURO', '44', '329', '2', '9');
INSERT INTO public.who_global_data_import VALUES (61290, '2020-04-01', 'MK', 'North Macedonia', 'EURO', '25', '354', '2', '11');
INSERT INTO public.who_global_data_import VALUES (61291, '2020-04-02', 'MK', 'North Macedonia', 'EURO', '0', '354', '0', '11');
INSERT INTO public.who_global_data_import VALUES (61292, '2020-04-03', 'MK', 'North Macedonia', 'EURO', '30', '384', '0', '11');
INSERT INTO public.who_global_data_import VALUES (61293, '2020-04-04', 'MK', 'North Macedonia', 'EURO', '46', '430', '1', '12');
INSERT INTO public.who_global_data_import VALUES (61294, '2020-04-05', 'MK', 'North Macedonia', 'EURO', '53', '483', '5', '17');
INSERT INTO public.who_global_data_import VALUES (61295, '2020-04-06', 'MK', 'North Macedonia', 'EURO', '72', '555', '1', '18');
INSERT INTO public.who_global_data_import VALUES (61296, '2020-04-07', 'MK', 'North Macedonia', 'EURO', '15', '570', '3', '21');
INSERT INTO public.who_global_data_import VALUES (61297, '2020-04-08', 'MK', 'North Macedonia', 'EURO', '29', '599', '6', '27');
INSERT INTO public.who_global_data_import VALUES (61298, '2020-04-09', 'MK', 'North Macedonia', 'EURO', '18', '617', '3', '30');
INSERT INTO public.who_global_data_import VALUES (61299, '2020-04-10', 'MK', 'North Macedonia', 'EURO', '46', '663', '0', '30');
INSERT INTO public.who_global_data_import VALUES (61300, '2020-04-11', 'MK', 'North Macedonia', 'EURO', '48', '711', '2', '32');
INSERT INTO public.who_global_data_import VALUES (61301, '2020-04-12', 'MK', 'North Macedonia', 'EURO', '117', '828', '2', '34');
INSERT INTO public.who_global_data_import VALUES (61302, '2020-04-13', 'MK', 'North Macedonia', 'EURO', '0', '828', '0', '34');
INSERT INTO public.who_global_data_import VALUES (61303, '2020-04-14', 'MK', 'North Macedonia', 'EURO', '26', '854', '4', '38');
INSERT INTO public.who_global_data_import VALUES (61304, '2020-04-15', 'MK', 'North Macedonia', 'EURO', '54', '908', '6', '44');
INSERT INTO public.who_global_data_import VALUES (61305, '2020-04-16', 'MK', 'North Macedonia', 'EURO', '66', '974', '1', '45');
INSERT INTO public.who_global_data_import VALUES (61306, '2020-04-17', 'MK', 'North Macedonia', 'EURO', '107', '1081', '1', '46');
INSERT INTO public.who_global_data_import VALUES (61307, '2020-04-18', 'MK', 'North Macedonia', 'EURO', '36', '1117', '3', '49');
INSERT INTO public.who_global_data_import VALUES (61308, '2020-04-19', 'MK', 'North Macedonia', 'EURO', '53', '1170', '0', '49');
INSERT INTO public.who_global_data_import VALUES (61309, '2020-04-20', 'MK', 'North Macedonia', 'EURO', '37', '1207', '2', '51');
INSERT INTO public.who_global_data_import VALUES (61310, '2020-04-21', 'MK', 'North Macedonia', 'EURO', '18', '1225', '3', '54');
INSERT INTO public.who_global_data_import VALUES (61311, '2020-04-22', 'MK', 'North Macedonia', 'EURO', '6', '1231', '1', '55');
INSERT INTO public.who_global_data_import VALUES (61312, '2020-04-23', 'MK', 'North Macedonia', 'EURO', '28', '1259', '1', '56');
INSERT INTO public.who_global_data_import VALUES (61313, '2020-04-24', 'MK', 'North Macedonia', 'EURO', '41', '1300', '0', '56');
INSERT INTO public.who_global_data_import VALUES (61314, '2020-04-25', 'MK', 'North Macedonia', 'EURO', '26', '1326', '1', '57');
INSERT INTO public.who_global_data_import VALUES (61315, '2020-04-26', 'MK', 'North Macedonia', 'EURO', '41', '1367', '2', '59');
INSERT INTO public.who_global_data_import VALUES (61316, '2020-04-27', 'MK', 'North Macedonia', 'EURO', '19', '1386', '2', '61');
INSERT INTO public.who_global_data_import VALUES (61317, '2020-04-28', 'MK', 'North Macedonia', 'EURO', '13', '1399', '4', '65');
INSERT INTO public.who_global_data_import VALUES (61318, '2020-04-29', 'MK', 'North Macedonia', 'EURO', '22', '1421', '6', '71');
INSERT INTO public.who_global_data_import VALUES (61319, '2020-04-30', 'MK', 'North Macedonia', 'EURO', '21', '1442', '2', '73');
INSERT INTO public.who_global_data_import VALUES (61320, '2020-05-01', 'MK', 'North Macedonia', 'EURO', '23', '1465', '4', '77');
INSERT INTO public.who_global_data_import VALUES (61321, '2020-05-02', 'MK', 'North Macedonia', 'EURO', '29', '1494', '4', '81');
INSERT INTO public.who_global_data_import VALUES (61322, '2020-05-03', 'MK', 'North Macedonia', 'EURO', '12', '1506', '1', '82');
INSERT INTO public.who_global_data_import VALUES (61323, '2020-05-04', 'MK', 'North Macedonia', 'EURO', '5', '1511', '2', '84');
INSERT INTO public.who_global_data_import VALUES (61324, '2020-05-05', 'MK', 'North Macedonia', 'EURO', '7', '1518', '1', '85');
INSERT INTO public.who_global_data_import VALUES (61325, '2020-05-06', 'MK', 'North Macedonia', 'EURO', '8', '1526', '1', '86');
INSERT INTO public.who_global_data_import VALUES (61326, '2020-05-07', 'MK', 'North Macedonia', 'EURO', '13', '1539', '2', '88');
INSERT INTO public.who_global_data_import VALUES (61327, '2020-05-08', 'MK', 'North Macedonia', 'EURO', '33', '1572', '1', '89');
INSERT INTO public.who_global_data_import VALUES (61328, '2020-05-09', 'MK', 'North Macedonia', 'EURO', '14', '1586', '1', '90');
INSERT INTO public.who_global_data_import VALUES (61329, '2020-05-10', 'MK', 'North Macedonia', 'EURO', '36', '1622', '1', '91');
INSERT INTO public.who_global_data_import VALUES (61330, '2020-05-11', 'MK', 'North Macedonia', 'EURO', '20', '1642', '0', '91');
INSERT INTO public.who_global_data_import VALUES (61331, '2020-05-12', 'MK', 'North Macedonia', 'EURO', '22', '1664', '0', '91');
INSERT INTO public.who_global_data_import VALUES (61332, '2020-05-13', 'MK', 'North Macedonia', 'EURO', '10', '1674', '1', '92');
INSERT INTO public.who_global_data_import VALUES (61333, '2020-05-14', 'MK', 'North Macedonia', 'EURO', '20', '1694', '3', '95');
INSERT INTO public.who_global_data_import VALUES (61334, '2020-05-15', 'MK', 'North Macedonia', 'EURO', '29', '1723', '0', '95');
INSERT INTO public.who_global_data_import VALUES (61335, '2020-05-16', 'MK', 'North Macedonia', 'EURO', '17', '1740', '2', '97');
INSERT INTO public.who_global_data_import VALUES (61336, '2020-05-17', 'MK', 'North Macedonia', 'EURO', '22', '1762', '1', '98');
INSERT INTO public.who_global_data_import VALUES (61337, '2020-05-18', 'MK', 'North Macedonia', 'EURO', '30', '1792', '3', '101');
INSERT INTO public.who_global_data_import VALUES (61338, '2020-05-19', 'MK', 'North Macedonia', 'EURO', '25', '1817', '3', '104');
INSERT INTO public.who_global_data_import VALUES (61339, '2020-05-20', 'MK', 'North Macedonia', 'EURO', '22', '1839', '2', '106');
INSERT INTO public.who_global_data_import VALUES (61340, '2020-05-21', 'MK', 'North Macedonia', 'EURO', '19', '1858', '4', '110');
INSERT INTO public.who_global_data_import VALUES (61341, '2020-05-22', 'MK', 'North Macedonia', 'EURO', '40', '1898', '1', '111');
INSERT INTO public.who_global_data_import VALUES (61342, '2020-05-23', 'MK', 'North Macedonia', 'EURO', '23', '1921', '1', '112');
INSERT INTO public.who_global_data_import VALUES (61343, '2020-05-24', 'MK', 'North Macedonia', 'EURO', '20', '1941', '1', '113');
INSERT INTO public.who_global_data_import VALUES (61344, '2020-05-25', 'MK', 'North Macedonia', 'EURO', '37', '1978', '0', '113');
INSERT INTO public.who_global_data_import VALUES (61345, '2020-05-26', 'MK', 'North Macedonia', 'EURO', '21', '1999', '0', '113');
INSERT INTO public.who_global_data_import VALUES (61346, '2020-05-27', 'MK', 'North Macedonia', 'EURO', '16', '2015', '3', '116');
INSERT INTO public.who_global_data_import VALUES (61347, '2020-05-28', 'MK', 'North Macedonia', 'EURO', '25', '2040', '3', '119');
INSERT INTO public.who_global_data_import VALUES (61348, '2020-05-29', 'MK', 'North Macedonia', 'EURO', '38', '2078', '3', '122');
INSERT INTO public.who_global_data_import VALUES (61349, '2020-05-30', 'MK', 'North Macedonia', 'EURO', '52', '2130', '4', '126');
INSERT INTO public.who_global_data_import VALUES (61350, '2020-05-31', 'MK', 'North Macedonia', 'EURO', '34', '2164', '5', '131');
INSERT INTO public.who_global_data_import VALUES (61351, '2020-06-01', 'MK', 'North Macedonia', 'EURO', '62', '2226', '2', '133');
INSERT INTO public.who_global_data_import VALUES (61352, '2020-06-02', 'MK', 'North Macedonia', 'EURO', '89', '2315', '7', '140');
INSERT INTO public.who_global_data_import VALUES (61353, '2020-06-03', 'MK', 'North Macedonia', 'EURO', '76', '2391', '1', '141');
INSERT INTO public.who_global_data_import VALUES (61354, '2020-06-04', 'MK', 'North Macedonia', 'EURO', '101', '2492', '4', '145');
INSERT INTO public.who_global_data_import VALUES (61355, '2020-06-05', 'MK', 'North Macedonia', 'EURO', '120', '2612', '2', '147');
INSERT INTO public.who_global_data_import VALUES (61356, '2020-06-06', 'MK', 'North Macedonia', 'EURO', '180', '2792', '2', '149');
INSERT INTO public.who_global_data_import VALUES (61357, '2020-06-07', 'MK', 'North Macedonia', 'EURO', '123', '2915', '2', '151');
INSERT INTO public.who_global_data_import VALUES (61358, '2020-06-08', 'MK', 'North Macedonia', 'EURO', '113', '3028', '2', '153');
INSERT INTO public.who_global_data_import VALUES (61359, '2020-06-09', 'MK', 'North Macedonia', 'EURO', '127', '3155', '3', '156');
INSERT INTO public.who_global_data_import VALUES (61360, '2020-06-10', 'MK', 'North Macedonia', 'EURO', '87', '3242', '1', '157');
INSERT INTO public.who_global_data_import VALUES (61361, '2020-06-11', 'MK', 'North Macedonia', 'EURO', '125', '3367', '7', '164');
INSERT INTO public.who_global_data_import VALUES (61362, '2020-06-12', 'MK', 'North Macedonia', 'EURO', '175', '3542', '5', '169');
INSERT INTO public.who_global_data_import VALUES (61363, '2020-06-13', 'MK', 'North Macedonia', 'EURO', '164', '3706', '2', '171');
INSERT INTO public.who_global_data_import VALUES (61364, '2020-06-14', 'MK', 'North Macedonia', 'EURO', '196', '3902', '8', '179');
INSERT INTO public.who_global_data_import VALUES (61365, '2020-06-15', 'MK', 'North Macedonia', 'EURO', '155', '4057', '9', '188');
INSERT INTO public.who_global_data_import VALUES (61366, '2020-06-16', 'MK', 'North Macedonia', 'EURO', '100', '4157', '5', '193');
INSERT INTO public.who_global_data_import VALUES (61367, '2020-06-17', 'MK', 'North Macedonia', 'EURO', '132', '4289', '8', '201');
INSERT INTO public.who_global_data_import VALUES (61368, '2020-06-18', 'MK', 'North Macedonia', 'EURO', '193', '4482', '9', '210');
INSERT INTO public.who_global_data_import VALUES (61369, '2020-06-19', 'MK', 'North Macedonia', 'EURO', '182', '4664', '6', '216');
INSERT INTO public.who_global_data_import VALUES (61370, '2020-06-20', 'MK', 'North Macedonia', 'EURO', '156', '4820', '6', '222');
INSERT INTO public.who_global_data_import VALUES (61371, '2020-06-21', 'MK', 'North Macedonia', 'EURO', '185', '5005', '11', '233');
INSERT INTO public.who_global_data_import VALUES (61372, '2020-06-22', 'MK', 'North Macedonia', 'EURO', '101', '5106', '5', '238');
INSERT INTO public.who_global_data_import VALUES (61373, '2020-06-23', 'MK', 'North Macedonia', 'EURO', '90', '5196', '9', '247');
INSERT INTO public.who_global_data_import VALUES (61374, '2020-06-24', 'MK', 'North Macedonia', 'EURO', '118', '5314', '4', '251');
INSERT INTO public.who_global_data_import VALUES (61375, '2020-06-25', 'MK', 'North Macedonia', 'EURO', '136', '5450', '8', '259');
INSERT INTO public.who_global_data_import VALUES (61376, '2020-06-26', 'MK', 'North Macedonia', 'EURO', '153', '5603', '6', '265');
INSERT INTO public.who_global_data_import VALUES (61377, '2020-06-27', 'MK', 'North Macedonia', 'EURO', '155', '5758', '3', '268');
INSERT INTO public.who_global_data_import VALUES (61378, '2020-06-28', 'MK', 'North Macedonia', 'EURO', '148', '5906', '9', '277');
INSERT INTO public.who_global_data_import VALUES (61379, '2020-06-29', 'MK', 'North Macedonia', 'EURO', '186', '6092', '9', '286');
INSERT INTO public.who_global_data_import VALUES (61380, '2020-06-30', 'MK', 'North Macedonia', 'EURO', '132', '6224', '12', '298');
INSERT INTO public.who_global_data_import VALUES (61381, '2020-07-01', 'MK', 'North Macedonia', 'EURO', '126', '6350', '4', '302');
INSERT INTO public.who_global_data_import VALUES (61382, '2020-07-02', 'MK', 'North Macedonia', 'EURO', '120', '6470', '4', '306');
INSERT INTO public.who_global_data_import VALUES (61383, '2020-07-03', 'MK', 'North Macedonia', 'EURO', '173', '6643', '15', '321');
INSERT INTO public.who_global_data_import VALUES (61384, '2020-07-04', 'MK', 'North Macedonia', 'EURO', '144', '6787', '7', '328');
INSERT INTO public.who_global_data_import VALUES (61385, '2020-07-05', 'MK', 'North Macedonia', 'EURO', '145', '6932', '6', '334');
INSERT INTO public.who_global_data_import VALUES (61386, '2020-07-06', 'MK', 'North Macedonia', 'EURO', '114', '7046', '7', '341');
INSERT INTO public.who_global_data_import VALUES (61387, '2020-07-07', 'MK', 'North Macedonia', 'EURO', '78', '7124', '5', '346');
INSERT INTO public.who_global_data_import VALUES (61388, '2020-07-08', 'MK', 'North Macedonia', 'EURO', '119', '7243', '5', '351');
INSERT INTO public.who_global_data_import VALUES (61389, '2020-07-09', 'MK', 'North Macedonia', 'EURO', '162', '7405', '8', '359');
INSERT INTO public.who_global_data_import VALUES (61390, '2020-07-10', 'MK', 'North Macedonia', 'EURO', '167', '7572', '3', '362');
INSERT INTO public.who_global_data_import VALUES (61391, '2020-07-11', 'MK', 'North Macedonia', 'EURO', '198', '7770', '5', '367');
INSERT INTO public.who_global_data_import VALUES (61392, '2020-07-12', 'MK', 'North Macedonia', 'EURO', '197', '7967', '8', '375');
INSERT INTO public.who_global_data_import VALUES (61393, '2020-07-13', 'MK', 'North Macedonia', 'EURO', '144', '8111', '7', '382');
INSERT INTO public.who_global_data_import VALUES (61394, '2020-07-14', 'MK', 'North Macedonia', 'EURO', '86', '8197', '3', '385');
INSERT INTO public.who_global_data_import VALUES (61395, '2020-07-15', 'MK', 'North Macedonia', 'EURO', '134', '8331', '4', '389');
INSERT INTO public.who_global_data_import VALUES (61396, '2020-07-16', 'MK', 'North Macedonia', 'EURO', '191', '8522', '4', '393');
INSERT INTO public.who_global_data_import VALUES (61397, '2020-07-17', 'MK', 'North Macedonia', 'EURO', '90', '8612', '8', '401');
INSERT INTO public.who_global_data_import VALUES (61398, '2020-07-18', 'MK', 'North Macedonia', 'EURO', '174', '8786', '5', '406');
INSERT INTO public.who_global_data_import VALUES (61399, '2020-07-19', 'MK', 'North Macedonia', 'EURO', '240', '9026', '8', '414');
INSERT INTO public.who_global_data_import VALUES (61400, '2020-07-20', 'MK', 'North Macedonia', 'EURO', '127', '9153', '8', '422');
INSERT INTO public.who_global_data_import VALUES (61401, '2020-07-21', 'MK', 'North Macedonia', 'EURO', '96', '9249', '10', '432');
INSERT INTO public.who_global_data_import VALUES (61402, '2020-07-22', 'MK', 'North Macedonia', 'EURO', '163', '9412', '0', '432');
INSERT INTO public.who_global_data_import VALUES (61403, '2020-07-23', 'MK', 'North Macedonia', 'EURO', '135', '9547', '10', '442');
INSERT INTO public.who_global_data_import VALUES (61404, '2020-07-24', 'MK', 'North Macedonia', 'EURO', '121', '9668', '3', '445');
INSERT INTO public.who_global_data_import VALUES (61405, '2020-07-25', 'MK', 'North Macedonia', 'EURO', '129', '9797', '6', '451');
INSERT INTO public.who_global_data_import VALUES (61406, '2020-07-26', 'MK', 'North Macedonia', 'EURO', '137', '9934', '9', '460');
INSERT INTO public.who_global_data_import VALUES (61407, '2020-07-27', 'MK', 'North Macedonia', 'EURO', '152', '10086', '0', '460');
INSERT INTO public.who_global_data_import VALUES (61408, '2020-07-28', 'MK', 'North Macedonia', 'EURO', '127', '10213', '6', '466');
INSERT INTO public.who_global_data_import VALUES (61409, '2020-07-29', 'MK', 'North Macedonia', 'EURO', '102', '10315', '5', '471');
INSERT INTO public.who_global_data_import VALUES (61410, '2020-07-30', 'MK', 'North Macedonia', 'EURO', '185', '10500', '5', '476');
INSERT INTO public.who_global_data_import VALUES (61411, '2020-07-31', 'MK', 'North Macedonia', 'EURO', '117', '10617', '4', '480');
INSERT INTO public.who_global_data_import VALUES (61412, '2020-08-01', 'MK', 'North Macedonia', 'EURO', '145', '10762', '6', '486');
INSERT INTO public.who_global_data_import VALUES (61413, '2020-08-02', 'MK', 'North Macedonia', 'EURO', '138', '10900', '7', '493');
INSERT INTO public.who_global_data_import VALUES (61414, '2020-08-03', 'MK', 'North Macedonia', 'EURO', '166', '11066', '4', '497');
INSERT INTO public.who_global_data_import VALUES (61415, '2020-08-04', 'MK', 'North Macedonia', 'EURO', '74', '11140', '3', '500');
INSERT INTO public.who_global_data_import VALUES (61416, '2020-08-05', 'MK', 'North Macedonia', 'EURO', '61', '11201', '5', '505');
INSERT INTO public.who_global_data_import VALUES (61417, '2020-08-06', 'MK', 'North Macedonia', 'EURO', '88', '11289', '6', '511');
INSERT INTO public.who_global_data_import VALUES (61418, '2020-08-07', 'MK', 'North Macedonia', 'EURO', '110', '11399', '6', '517');
INSERT INTO public.who_global_data_import VALUES (61419, '2020-08-08', 'MK', 'North Macedonia', 'EURO', '172', '11571', '2', '519');
INSERT INTO public.who_global_data_import VALUES (61420, '2020-08-09', 'MK', 'North Macedonia', 'EURO', '200', '11771', '4', '523');
INSERT INTO public.who_global_data_import VALUES (61421, '2020-08-10', 'MK', 'North Macedonia', 'EURO', '85', '11856', '4', '527');
INSERT INTO public.who_global_data_import VALUES (61422, '2020-08-11', 'MK', 'North Macedonia', 'EURO', '109', '11965', '1', '528');
INSERT INTO public.who_global_data_import VALUES (61423, '2020-08-12', 'MK', 'North Macedonia', 'EURO', '141', '12106', '1', '529');
INSERT INTO public.who_global_data_import VALUES (61424, '2020-08-13', 'MK', 'North Macedonia', 'EURO', '139', '12245', '1', '530');
INSERT INTO public.who_global_data_import VALUES (61425, '2020-08-14', 'MK', 'North Macedonia', 'EURO', '141', '12386', '2', '532');
INSERT INTO public.who_global_data_import VALUES (61426, '2020-08-15', 'MK', 'North Macedonia', 'EURO', '0', '12386', '0', '532');
INSERT INTO public.who_global_data_import VALUES (61427, '2020-08-16', 'MK', 'North Macedonia', 'EURO', '160', '12546', '3', '535');
INSERT INTO public.who_global_data_import VALUES (61428, '2020-08-17', 'MK', 'North Macedonia', 'EURO', '193', '12739', '9', '544');
INSERT INTO public.who_global_data_import VALUES (61429, '2020-08-18', 'MK', 'North Macedonia', 'EURO', '101', '12840', '3', '547');
INSERT INTO public.who_global_data_import VALUES (61430, '2020-08-19', 'MK', 'North Macedonia', 'EURO', '130', '12970', '2', '549');
INSERT INTO public.who_global_data_import VALUES (61431, '2020-08-20', 'MK', 'North Macedonia', 'EURO', '106', '13076', '2', '551');
INSERT INTO public.who_global_data_import VALUES (61432, '2020-08-21', 'MK', 'North Macedonia', 'EURO', '118', '13194', '3', '554');
INSERT INTO public.who_global_data_import VALUES (61433, '2020-08-22', 'MK', 'North Macedonia', 'EURO', '114', '13308', '3', '557');
INSERT INTO public.who_global_data_import VALUES (61434, '2020-08-23', 'MK', 'North Macedonia', 'EURO', '0', '13308', '0', '557');
INSERT INTO public.who_global_data_import VALUES (61435, '2020-08-24', 'MK', 'North Macedonia', 'EURO', '287', '13595', '7', '564');
INSERT INTO public.who_global_data_import VALUES (61436, '2020-08-25', 'MK', 'North Macedonia', 'EURO', '78', '13673', '4', '568');
INSERT INTO public.who_global_data_import VALUES (61437, '2020-08-26', 'MK', 'North Macedonia', 'EURO', '126', '13799', '5', '573');
INSERT INTO public.who_global_data_import VALUES (61438, '2020-08-27', 'MK', 'North Macedonia', 'EURO', '115', '13914', '5', '578');
INSERT INTO public.who_global_data_import VALUES (61439, '2020-08-28', 'MK', 'North Macedonia', 'EURO', '90', '14004', '7', '585');
INSERT INTO public.who_global_data_import VALUES (61440, '2020-08-29', 'MK', 'North Macedonia', 'EURO', '159', '14163', '5', '590');
INSERT INTO public.who_global_data_import VALUES (61441, '2020-08-30', 'MK', 'North Macedonia', 'EURO', '130', '14293', '6', '596');
INSERT INTO public.who_global_data_import VALUES (61442, '2020-08-31', 'MK', 'North Macedonia', 'EURO', '37', '14330', '4', '600');
INSERT INTO public.who_global_data_import VALUES (61443, '2020-09-01', 'MK', 'North Macedonia', 'EURO', '11', '14341', '3', '603');
INSERT INTO public.who_global_data_import VALUES (61444, '2020-09-02', 'MK', 'North Macedonia', 'EURO', '114', '14455', '1', '604');
INSERT INTO public.who_global_data_import VALUES (61445, '2020-09-03', 'MK', 'North Macedonia', 'EURO', '145', '14600', '2', '606');
INSERT INTO public.who_global_data_import VALUES (61446, '2020-09-04', 'MK', 'North Macedonia', 'EURO', '162', '14762', '0', '606');
INSERT INTO public.who_global_data_import VALUES (61447, '2020-09-05', 'MK', 'North Macedonia', 'EURO', '109', '14871', '3', '609');
INSERT INTO public.who_global_data_import VALUES (61448, '2020-09-06', 'MK', 'North Macedonia', 'EURO', '127', '14998', '5', '614');
INSERT INTO public.who_global_data_import VALUES (61449, '2020-09-07', 'MK', 'North Macedonia', 'EURO', '92', '15090', '3', '617');
INSERT INTO public.who_global_data_import VALUES (61450, '2020-09-08', 'MK', 'North Macedonia', 'EURO', '37', '15127', '6', '623');
INSERT INTO public.who_global_data_import VALUES (61451, '2020-09-09', 'MK', 'North Macedonia', 'EURO', '99', '15226', '8', '631');
INSERT INTO public.who_global_data_import VALUES (61452, '2020-09-10', 'MK', 'North Macedonia', 'EURO', '67', '15293', '3', '634');
INSERT INTO public.who_global_data_import VALUES (61453, '2020-09-11', 'MK', 'North Macedonia', 'EURO', '121', '15414', '3', '637');
INSERT INTO public.who_global_data_import VALUES (61454, '2020-09-12', 'MK', 'North Macedonia', 'EURO', '141', '15555', '5', '642');
INSERT INTO public.who_global_data_import VALUES (61455, '2020-09-13', 'MK', 'North Macedonia', 'EURO', '139', '15694', '4', '646');
INSERT INTO public.who_global_data_import VALUES (61456, '2020-09-14', 'MK', 'North Macedonia', 'EURO', '97', '15791', '2', '648');
INSERT INTO public.who_global_data_import VALUES (61457, '2020-09-15', 'MK', 'North Macedonia', 'EURO', '36', '15827', '4', '652');
INSERT INTO public.who_global_data_import VALUES (61458, '2020-09-16', 'MK', 'North Macedonia', 'EURO', '98', '15925', '9', '661');
INSERT INTO public.who_global_data_import VALUES (61459, '2020-09-17', 'MK', 'North Macedonia', 'EURO', '163', '16088', '7', '668');
INSERT INTO public.who_global_data_import VALUES (61460, '2020-09-18', 'MK', 'North Macedonia', 'EURO', '186', '16274', '7', '675');
INSERT INTO public.who_global_data_import VALUES (61461, '2020-09-19', 'MK', 'North Macedonia', 'EURO', '143', '16417', '8', '683');
INSERT INTO public.who_global_data_import VALUES (61462, '2020-09-20', 'MK', 'North Macedonia', 'EURO', '140', '16557', '6', '689');
INSERT INTO public.who_global_data_import VALUES (61463, '2020-09-21', 'MK', 'North Macedonia', 'EURO', '178', '16735', '4', '693');
INSERT INTO public.who_global_data_import VALUES (61464, '2020-09-22', 'MK', 'North Macedonia', 'EURO', '45', '16780', '7', '700');
INSERT INTO public.who_global_data_import VALUES (61465, '2020-09-23', 'MK', 'North Macedonia', 'EURO', '87', '16867', '5', '705');
INSERT INTO public.who_global_data_import VALUES (61466, '2020-09-24', 'MK', 'North Macedonia', 'EURO', '182', '17049', '5', '710');
INSERT INTO public.who_global_data_import VALUES (61467, '2020-09-25', 'MK', 'North Macedonia', 'EURO', '151', '17200', '2', '712');
INSERT INTO public.who_global_data_import VALUES (61468, '2020-09-26', 'MK', 'North Macedonia', 'EURO', '143', '17343', '9', '721');
INSERT INTO public.who_global_data_import VALUES (61469, '2020-09-27', 'MK', 'North Macedonia', 'EURO', '0', '17343', '0', '721');
INSERT INTO public.who_global_data_import VALUES (61470, '2020-09-28', 'MK', 'North Macedonia', 'EURO', '286', '17629', '4', '725');
INSERT INTO public.who_global_data_import VALUES (61471, '2020-09-29', 'MK', 'North Macedonia', 'EURO', '45', '17674', '4', '729');
INSERT INTO public.who_global_data_import VALUES (61472, '2020-09-30', 'MK', 'North Macedonia', 'EURO', '112', '17786', '8', '737');
INSERT INTO public.who_global_data_import VALUES (61473, '2020-10-01', 'MK', 'North Macedonia', 'EURO', '191', '17977', '2', '739');
INSERT INTO public.who_global_data_import VALUES (61474, '2020-10-02', 'MK', 'North Macedonia', 'EURO', '161', '18138', '4', '743');
INSERT INTO public.who_global_data_import VALUES (61475, '2020-10-03', 'MK', 'North Macedonia', 'EURO', '225', '18363', '6', '749');
INSERT INTO public.who_global_data_import VALUES (61476, '2020-10-04', 'MK', 'North Macedonia', 'EURO', '239', '18602', '4', '753');
INSERT INTO public.who_global_data_import VALUES (61477, '2020-10-05', 'MK', 'North Macedonia', 'EURO', '188', '18790', '3', '756');
INSERT INTO public.who_global_data_import VALUES (61478, '2020-10-06', 'MK', 'North Macedonia', 'EURO', '83', '18873', '4', '760');
INSERT INTO public.who_global_data_import VALUES (61479, '2020-10-07', 'MK', 'North Macedonia', 'EURO', '223', '19096', '8', '768');
INSERT INTO public.who_global_data_import VALUES (61480, '2020-10-08', 'MK', 'North Macedonia', 'EURO', '317', '19413', '4', '772');
INSERT INTO public.who_global_data_import VALUES (61481, '2020-10-09', 'MK', 'North Macedonia', 'EURO', '364', '19777', '3', '775');
INSERT INTO public.who_global_data_import VALUES (61482, '2020-10-10', 'MK', 'North Macedonia', 'EURO', '386', '20163', '6', '781');
INSERT INTO public.who_global_data_import VALUES (61483, '2020-10-11', 'MK', 'North Macedonia', 'EURO', '392', '20555', '4', '785');
INSERT INTO public.who_global_data_import VALUES (61484, '2020-10-12', 'MK', 'North Macedonia', 'EURO', '382', '20937', '7', '792');
INSERT INTO public.who_global_data_import VALUES (61485, '2020-10-13', 'MK', 'North Macedonia', 'EURO', '176', '21113', '5', '797');
INSERT INTO public.who_global_data_import VALUES (61486, '2020-10-14', 'MK', 'North Macedonia', 'EURO', '80', '21193', '3', '800');
INSERT INTO public.who_global_data_import VALUES (61487, '2020-10-15', 'MK', 'North Macedonia', 'EURO', '443', '21636', '9', '809');
INSERT INTO public.who_global_data_import VALUES (61488, '2020-10-16', 'MK', 'North Macedonia', 'EURO', '534', '22170', '6', '815');
INSERT INTO public.who_global_data_import VALUES (61489, '2020-10-17', 'MK', 'North Macedonia', 'EURO', '437', '22607', '6', '821');
INSERT INTO public.who_global_data_import VALUES (61490, '2020-10-18', 'MK', 'North Macedonia', 'EURO', '594', '23201', '3', '824');
INSERT INTO public.who_global_data_import VALUES (61491, '2020-10-19', 'MK', 'North Macedonia', 'EURO', '427', '23628', '10', '834');
INSERT INTO public.who_global_data_import VALUES (61492, '2020-10-20', 'MK', 'North Macedonia', 'EURO', '160', '23788', '12', '846');
INSERT INTO public.who_global_data_import VALUES (61493, '2020-10-21', 'MK', 'North Macedonia', 'EURO', '408', '24196', '4', '850');
INSERT INTO public.who_global_data_import VALUES (61494, '2020-10-22', 'MK', 'North Macedonia', 'EURO', '640', '24836', '12', '862');
INSERT INTO public.who_global_data_import VALUES (61495, '2020-10-23', 'MK', 'North Macedonia', 'EURO', '637', '25473', '12', '874');
INSERT INTO public.who_global_data_import VALUES (61496, '2020-10-24', 'MK', 'North Macedonia', 'EURO', '518', '25991', '9', '883');
INSERT INTO public.who_global_data_import VALUES (61497, '2020-10-25', 'MK', 'North Macedonia', 'EURO', '403', '26394', '14', '897');
INSERT INTO public.who_global_data_import VALUES (61498, '2020-10-26', 'MK', 'North Macedonia', 'EURO', '560', '26954', '22', '919');
INSERT INTO public.who_global_data_import VALUES (61499, '2020-10-27', 'MK', 'North Macedonia', 'EURO', '245', '27199', '15', '934');
INSERT INTO public.who_global_data_import VALUES (61500, '2020-10-28', 'MK', 'North Macedonia', 'EURO', '628', '27827', '15', '949');
INSERT INTO public.who_global_data_import VALUES (61501, '2020-10-29', 'MK', 'North Macedonia', 'EURO', '870', '28697', '14', '963');
INSERT INTO public.who_global_data_import VALUES (61502, '2020-10-30', 'MK', 'North Macedonia', 'EURO', '861', '29558', '14', '977');
INSERT INTO public.who_global_data_import VALUES (61503, '2020-10-31', 'MK', 'North Macedonia', 'EURO', '930', '30488', '5', '982');
INSERT INTO public.who_global_data_import VALUES (61504, '2020-11-01', 'MK', 'North Macedonia', 'EURO', '1089', '31577', '12', '994');
INSERT INTO public.who_global_data_import VALUES (61505, '2020-11-02', 'MK', 'North Macedonia', 'EURO', '859', '32436', '10', '1004');
INSERT INTO public.who_global_data_import VALUES (61506, '2020-11-03', 'MK', 'North Macedonia', 'EURO', '561', '32997', '21', '1025');
INSERT INTO public.who_global_data_import VALUES (61507, '2020-11-04', 'MK', 'North Macedonia', 'EURO', '911', '33908', '24', '1049');
INSERT INTO public.who_global_data_import VALUES (61508, '2020-11-05', 'MK', 'North Macedonia', 'EURO', '1189', '35097', '22', '1071');
INSERT INTO public.who_global_data_import VALUES (61509, '2020-11-06', 'MK', 'North Macedonia', 'EURO', '1275', '36372', '13', '1084');
INSERT INTO public.who_global_data_import VALUES (61510, '2020-11-07', 'MK', 'North Macedonia', 'EURO', '1127', '37499', '12', '1096');
INSERT INTO public.who_global_data_import VALUES (61511, '2020-11-08', 'MK', 'North Macedonia', 'EURO', '1283', '38782', '14', '1110');
INSERT INTO public.who_global_data_import VALUES (61512, '2020-11-09', 'MK', 'North Macedonia', 'EURO', '978', '39760', '26', '1136');
INSERT INTO public.who_global_data_import VALUES (61513, '2020-11-10', 'MK', 'North Macedonia', 'EURO', '515', '40275', '20', '1156');
INSERT INTO public.who_global_data_import VALUES (61514, '2020-11-11', 'MK', 'North Macedonia', 'EURO', '947', '41222', '30', '1186');
INSERT INTO public.who_global_data_import VALUES (61515, '2020-11-12', 'MK', 'North Macedonia', 'EURO', '1318', '42540', '26', '1212');
INSERT INTO public.who_global_data_import VALUES (61516, '2020-11-13', 'MK', 'North Macedonia', 'EURO', '1295', '43835', '26', '1238');
INSERT INTO public.who_global_data_import VALUES (61517, '2020-11-14', 'MK', 'North Macedonia', 'EURO', '1063', '44898', '25', '1263');
INSERT INTO public.who_global_data_import VALUES (61518, '2020-11-15', 'MK', 'North Macedonia', 'EURO', '1164', '46062', '18', '1281');
INSERT INTO public.who_global_data_import VALUES (61519, '2020-11-16', 'MK', 'North Macedonia', 'EURO', '988', '47050', '24', '1305');
INSERT INTO public.who_global_data_import VALUES (61520, '2020-11-17', 'MK', 'North Macedonia', 'EURO', '586', '47636', '40', '1345');
INSERT INTO public.who_global_data_import VALUES (61521, '2020-11-18', 'MK', 'North Macedonia', 'EURO', '977', '48613', '31', '1376');
INSERT INTO public.who_global_data_import VALUES (61522, '2020-11-19', 'MK', 'North Macedonia', 'EURO', '1402', '50015', '21', '1397');
INSERT INTO public.who_global_data_import VALUES (61523, '2020-11-20', 'MK', 'North Macedonia', 'EURO', '1198', '51213', '26', '1423');
INSERT INTO public.who_global_data_import VALUES (61524, '2020-11-21', 'MK', 'North Macedonia', 'EURO', '1236', '52449', '39', '1462');
INSERT INTO public.who_global_data_import VALUES (61525, '2020-11-22', 'MK', 'North Macedonia', 'EURO', '1182', '53631', '25', '1487');
INSERT INTO public.who_global_data_import VALUES (61526, '2020-11-23', 'MK', 'North Macedonia', 'EURO', '1112', '54743', '24', '1511');
INSERT INTO public.who_global_data_import VALUES (61527, '2020-11-24', 'MK', 'North Macedonia', 'EURO', '384', '55127', '35', '1546');
INSERT INTO public.who_global_data_import VALUES (61528, '2020-11-25', 'MK', 'North Macedonia', 'EURO', '1037', '56164', '15', '1561');
INSERT INTO public.who_global_data_import VALUES (61529, '2020-11-26', 'MK', 'North Macedonia', 'EURO', '1287', '57451', '39', '1600');
INSERT INTO public.who_global_data_import VALUES (61530, '2020-11-27', 'MK', 'North Macedonia', 'EURO', '1157', '58608', '30', '1630');
INSERT INTO public.who_global_data_import VALUES (61531, '2020-11-28', 'MK', 'North Macedonia', 'EURO', '1093', '59701', '28', '1658');
INSERT INTO public.who_global_data_import VALUES (61532, '2020-11-29', 'MK', 'North Macedonia', 'EURO', '1022', '60723', '41', '1699');
INSERT INTO public.who_global_data_import VALUES (61533, '2020-11-30', 'MK', 'North Macedonia', 'EURO', '820', '61543', '32', '1731');
INSERT INTO public.who_global_data_import VALUES (61534, '2020-12-01', 'MK', 'North Macedonia', 'EURO', '335', '61878', '32', '1763');
INSERT INTO public.who_global_data_import VALUES (61535, '2020-12-02', 'MK', 'North Macedonia', 'EURO', '1067', '62945', '29', '1792');
INSERT INTO public.who_global_data_import VALUES (61536, '2020-12-03', 'MK', 'North Macedonia', 'EURO', '945', '63890', '33', '1825');
INSERT INTO public.who_global_data_import VALUES (61537, '2020-12-04', 'MK', 'North Macedonia', 'EURO', '1341', '65231', '22', '1847');
INSERT INTO public.who_global_data_import VALUES (61538, '2020-12-05', 'MK', 'North Macedonia', 'EURO', '1099', '66330', '30', '1877');
INSERT INTO public.who_global_data_import VALUES (61539, '2020-12-06', 'MK', 'North Macedonia', 'EURO', '981', '67311', '24', '1901');
INSERT INTO public.who_global_data_import VALUES (61540, '2020-12-07', 'MK', 'North Macedonia', 'EURO', '657', '67968', '23', '1924');
INSERT INTO public.who_global_data_import VALUES (61541, '2020-12-08', 'MK', 'North Macedonia', 'EURO', '364', '68332', '25', '1949');
INSERT INTO public.who_global_data_import VALUES (61542, '2020-12-09', 'MK', 'North Macedonia', 'EURO', '1120', '69452', '28', '1977');
INSERT INTO public.who_global_data_import VALUES (61543, '2020-12-10', 'MK', 'North Macedonia', 'EURO', '502', '69954', '46', '2023');
INSERT INTO public.who_global_data_import VALUES (61544, '2020-12-11', 'MK', 'North Macedonia', 'EURO', '929', '70883', '28', '2051');
INSERT INTO public.who_global_data_import VALUES (61545, '2020-12-12', 'MK', 'North Macedonia', 'EURO', '1161', '72044', '26', '2077');
INSERT INTO public.who_global_data_import VALUES (61546, '2020-12-13', 'MK', 'North Macedonia', 'EURO', '1043', '73087', '19', '2096');
INSERT INTO public.who_global_data_import VALUES (61547, '2020-12-14', 'MK', 'North Macedonia', 'EURO', '551', '73638', '25', '2121');
INSERT INTO public.who_global_data_import VALUES (61548, '2020-12-15', 'MK', 'North Macedonia', 'EURO', '213', '73851', '26', '2147');
INSERT INTO public.who_global_data_import VALUES (61549, '2020-12-16', 'MK', 'North Macedonia', 'EURO', '881', '74732', '22', '2169');
INSERT INTO public.who_global_data_import VALUES (61550, '2020-12-17', 'MK', 'North Macedonia', 'EURO', '865', '75597', '25', '2194');
INSERT INTO public.who_global_data_import VALUES (61551, '2020-12-18', 'MK', 'North Macedonia', 'EURO', '654', '76251', '31', '2225');
INSERT INTO public.who_global_data_import VALUES (61552, '2020-12-19', 'MK', 'North Macedonia', 'EURO', '883', '77134', '29', '2254');
INSERT INTO public.who_global_data_import VALUES (61553, '2020-12-20', 'MK', 'North Macedonia', 'EURO', '815', '77949', '20', '2274');
INSERT INTO public.who_global_data_import VALUES (61554, '2020-12-21', 'MK', 'North Macedonia', 'EURO', '356', '78305', '18', '2292');
INSERT INTO public.who_global_data_import VALUES (61555, '2020-12-22', 'MK', 'North Macedonia', 'EURO', '129', '78434', '22', '2314');
INSERT INTO public.who_global_data_import VALUES (61556, '2020-12-23', 'MK', 'North Macedonia', 'EURO', '756', '79190', '26', '2340');
INSERT INTO public.who_global_data_import VALUES (61557, '2020-12-24', 'MK', 'North Macedonia', 'EURO', '625', '79815', '14', '2354');
INSERT INTO public.who_global_data_import VALUES (61558, '2020-12-25', 'MK', 'North Macedonia', 'EURO', '592', '80407', '21', '2375');
INSERT INTO public.who_global_data_import VALUES (61559, '2020-12-26', 'MK', 'North Macedonia', 'EURO', '489', '80896', '26', '2401');
INSERT INTO public.who_global_data_import VALUES (61560, '2020-12-27', 'MK', 'North Macedonia', 'EURO', '529', '81425', '26', '2427');
INSERT INTO public.who_global_data_import VALUES (61561, '2020-12-28', 'MK', 'North Macedonia', 'EURO', '296', '81721', '18', '2445');
INSERT INTO public.who_global_data_import VALUES (61562, '2020-12-29', 'MK', 'North Macedonia', 'EURO', '83', '81804', '11', '2456');
INSERT INTO public.who_global_data_import VALUES (61563, '2020-12-30', 'MK', 'North Macedonia', 'EURO', '497', '82301', '17', '2473');
INSERT INTO public.who_global_data_import VALUES (61564, '2020-12-31', 'MK', 'North Macedonia', 'EURO', '493', '82794', '15', '2488');
INSERT INTO public.who_global_data_import VALUES (61565, '2021-01-01', 'MK', 'North Macedonia', 'EURO', '535', '83329', '15', '2503');
INSERT INTO public.who_global_data_import VALUES (61566, '2021-01-02', 'MK', 'North Macedonia', 'EURO', '414', '83743', '7', '2510');
INSERT INTO public.who_global_data_import VALUES (61567, '2021-01-03', 'MK', 'North Macedonia', 'EURO', '46', '83789', '12', '2522');
INSERT INTO public.who_global_data_import VALUES (61568, '2021-01-04', 'MK', 'North Macedonia', 'EURO', '235', '84024', '8', '2530');
INSERT INTO public.who_global_data_import VALUES (61569, '2021-01-05', 'MK', 'North Macedonia', 'EURO', '105', '84129', '20', '2550');
INSERT INTO public.who_global_data_import VALUES (61570, '2021-01-06', 'MK', 'North Macedonia', 'EURO', '580', '84709', '9', '2559');
INSERT INTO public.who_global_data_import VALUES (61571, '2021-01-07', 'MK', 'North Macedonia', 'EURO', '619', '85328', '12', '2571');
INSERT INTO public.who_global_data_import VALUES (61572, '2021-01-08', 'MK', 'North Macedonia', 'EURO', '166', '85494', '10', '2581');
INSERT INTO public.who_global_data_import VALUES (61573, '2021-01-09', 'MK', 'North Macedonia', 'EURO', '100', '85594', '11', '2592');
INSERT INTO public.who_global_data_import VALUES (61574, '2021-01-10', 'MK', 'North Macedonia', 'EURO', '556', '86150', '22', '2614');
INSERT INTO public.who_global_data_import VALUES (61575, '2021-01-11', 'MK', 'North Macedonia', 'EURO', '344', '86494', '8', '2622');
INSERT INTO public.who_global_data_import VALUES (61576, '2021-01-12', 'MK', 'North Macedonia', 'EURO', '103', '86597', '13', '2635');
INSERT INTO public.who_global_data_import VALUES (61577, '2021-01-13', 'MK', 'North Macedonia', 'EURO', '520', '87117', '12', '2647');
INSERT INTO public.who_global_data_import VALUES (61578, '2021-01-14', 'MK', 'North Macedonia', 'EURO', '473', '87590', '10', '2657');
INSERT INTO public.who_global_data_import VALUES (61579, '2021-01-15', 'MK', 'North Macedonia', 'EURO', '396', '87986', '15', '2672');
INSERT INTO public.who_global_data_import VALUES (61580, '2021-01-16', 'MK', 'North Macedonia', 'EURO', '403', '88389', '10', '2682');
INSERT INTO public.who_global_data_import VALUES (61581, '2021-01-17', 'MK', 'North Macedonia', 'EURO', '360', '88749', '14', '2696');
INSERT INTO public.who_global_data_import VALUES (61582, '2021-01-18', 'MK', 'North Macedonia', 'EURO', '189', '88938', '6', '2702');
INSERT INTO public.who_global_data_import VALUES (61583, '2021-01-19', 'MK', 'North Macedonia', 'EURO', '54', '88992', '13', '2715');
INSERT INTO public.who_global_data_import VALUES (61584, '2021-01-20', 'MK', 'North Macedonia', 'EURO', '400', '89392', '11', '2726');
INSERT INTO public.who_global_data_import VALUES (61585, '2021-01-21', 'MK', 'North Macedonia', 'EURO', '71', '89463', '13', '2739');
INSERT INTO public.who_global_data_import VALUES (61586, '2021-01-22', 'MK', 'North Macedonia', 'EURO', '354', '89817', '15', '2754');
INSERT INTO public.who_global_data_import VALUES (61587, '2021-01-23', 'MK', 'North Macedonia', 'EURO', '307', '90124', '14', '2768');
INSERT INTO public.who_global_data_import VALUES (61588, '2021-01-24', 'MK', 'North Macedonia', 'EURO', '347', '90471', '11', '2779');
INSERT INTO public.who_global_data_import VALUES (61589, '2021-01-25', 'MK', 'North Macedonia', 'EURO', '183', '90654', '6', '2785');
INSERT INTO public.who_global_data_import VALUES (61590, '2021-01-26', 'MK', 'North Macedonia', 'EURO', '63', '90717', '6', '2791');
INSERT INTO public.who_global_data_import VALUES (61591, '2021-01-27', 'MK', 'North Macedonia', 'EURO', '444', '91161', '21', '2812');
INSERT INTO public.who_global_data_import VALUES (61592, '2021-01-28', 'MK', 'North Macedonia', 'EURO', '394', '91555', '9', '2821');
INSERT INTO public.who_global_data_import VALUES (61593, '2021-01-29', 'MK', 'North Macedonia', 'EURO', '336', '91891', '10', '2831');
INSERT INTO public.who_global_data_import VALUES (61594, '2021-01-30', 'MK', 'North Macedonia', 'EURO', '302', '92193', '10', '2841');
INSERT INTO public.who_global_data_import VALUES (61595, '2021-01-31', 'MK', 'North Macedonia', 'EURO', '325', '92518', '7', '2848');
INSERT INTO public.who_global_data_import VALUES (61596, '2021-02-01', 'MK', 'North Macedonia', 'EURO', '175', '92693', '7', '2855');
INSERT INTO public.who_global_data_import VALUES (61597, '2021-02-02', 'MK', 'North Macedonia', 'EURO', '60', '92753', '11', '2866');
INSERT INTO public.who_global_data_import VALUES (61598, '2021-02-03', 'MK', 'North Macedonia', 'EURO', '407', '93160', '7', '2873');
INSERT INTO public.who_global_data_import VALUES (61599, '2021-02-04', 'MK', 'North Macedonia', 'EURO', '350', '93510', '20', '2893');
INSERT INTO public.who_global_data_import VALUES (61600, '2021-02-05', 'MK', 'North Macedonia', 'EURO', '372', '93882', '7', '2900');
INSERT INTO public.who_global_data_import VALUES (61601, '2020-01-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61602, '2020-01-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61603, '2020-01-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61604, '2020-01-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61605, '2020-01-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61606, '2020-01-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61607, '2020-01-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61608, '2020-01-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61609, '2020-01-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61610, '2020-01-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61611, '2020-01-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61612, '2020-01-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61613, '2020-01-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61614, '2020-01-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61615, '2020-01-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61616, '2020-01-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61617, '2020-01-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61618, '2020-01-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61619, '2020-01-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61620, '2020-01-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61621, '2020-01-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61622, '2020-01-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61623, '2020-01-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61624, '2020-01-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61625, '2020-01-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61626, '2020-01-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61627, '2020-01-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61628, '2020-01-30', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61629, '2020-01-31', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61630, '2020-02-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61631, '2020-02-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61632, '2020-02-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61633, '2020-02-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61634, '2020-02-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61635, '2020-02-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61636, '2020-02-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61637, '2020-02-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61638, '2020-02-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61639, '2020-02-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61640, '2020-02-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61641, '2020-02-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61642, '2020-02-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61643, '2020-02-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61644, '2020-02-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61645, '2020-02-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61646, '2020-02-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61647, '2020-02-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61648, '2020-02-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61649, '2020-02-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61650, '2020-02-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61651, '2020-02-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61652, '2020-02-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61653, '2020-02-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61654, '2020-02-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61655, '2020-02-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61656, '2020-02-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61657, '2020-02-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61658, '2020-02-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61659, '2020-03-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61660, '2020-03-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61661, '2020-03-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61662, '2020-03-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61663, '2020-03-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61664, '2020-03-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61665, '2020-03-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61666, '2020-03-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61667, '2020-03-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61668, '2020-03-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61669, '2020-03-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61670, '2020-03-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61671, '2020-03-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61672, '2020-03-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61673, '2020-03-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61674, '2020-03-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61675, '2020-03-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61676, '2020-03-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61677, '2020-03-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61678, '2020-03-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61679, '2020-03-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61680, '2020-03-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61681, '2020-03-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61682, '2020-03-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61683, '2020-03-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61684, '2020-03-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61685, '2020-03-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61686, '2020-03-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61687, '2020-03-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61688, '2020-03-30', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61689, '2020-03-31', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61690, '2020-04-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '4', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61691, '2020-04-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61692, '2020-04-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '8', '1', '1');
INSERT INTO public.who_global_data_import VALUES (61693, '2020-04-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (61694, '2020-04-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (61695, '2020-04-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (61696, '2020-04-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (61697, '2020-04-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '3', '11', '1', '2');
INSERT INTO public.who_global_data_import VALUES (61698, '2020-04-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '11', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61699, '2020-04-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '11', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61700, '2020-04-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '11', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61701, '2020-04-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '11', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61702, '2020-04-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '11', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61703, '2020-04-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '11', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61704, '2020-04-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '13', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61705, '2020-04-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '13', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61706, '2020-04-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '13', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61707, '2020-04-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61708, '2020-04-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61709, '2020-04-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61710, '2020-04-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61711, '2020-04-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62019, '2020-01-21', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61712, '2020-04-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61713, '2020-04-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61714, '2020-04-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61715, '2020-04-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61716, '2020-04-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61717, '2020-04-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61718, '2020-04-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61719, '2020-04-30', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61720, '2020-05-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61721, '2020-05-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61722, '2020-05-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61723, '2020-05-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61724, '2020-05-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61725, '2020-05-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61726, '2020-05-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '15', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61727, '2020-05-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '15', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61728, '2020-05-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '15', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61729, '2020-05-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '16', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61730, '2020-05-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '16', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61731, '2020-05-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '3', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61732, '2020-05-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61733, '2020-05-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61734, '2020-05-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61735, '2020-05-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61736, '2020-05-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '21', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61737, '2020-05-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '21', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61738, '2020-05-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '21', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61739, '2020-05-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '21', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61740, '2020-05-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '21', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61741, '2020-05-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61742, '2020-05-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61743, '2020-05-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61744, '2020-05-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61745, '2020-05-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61746, '2020-05-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61747, '2020-05-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61748, '2020-05-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61749, '2020-05-30', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61750, '2020-05-31', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61751, '2020-06-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61752, '2020-06-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61753, '2020-06-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61754, '2020-06-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '24', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61755, '2020-06-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '26', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61756, '2020-06-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '26', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61757, '2020-06-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '26', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61758, '2020-06-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '27', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61759, '2020-06-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '28', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61760, '2020-06-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61761, '2020-06-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61762, '2020-06-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61763, '2020-06-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61764, '2020-06-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61765, '2020-06-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61766, '2020-06-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61767, '2020-06-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61768, '2020-06-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61769, '2020-06-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61770, '2020-06-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61771, '2020-06-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61772, '2020-06-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61773, '2020-06-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61774, '2020-06-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61775, '2020-06-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61776, '2020-06-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61777, '2020-06-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61778, '2020-06-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61779, '2020-06-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61780, '2020-06-30', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61781, '2020-07-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61782, '2020-07-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '30', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61783, '2020-07-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61784, '2020-07-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61785, '2020-07-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61786, '2020-07-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62020, '2020-01-22', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61787, '2020-07-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61788, '2020-07-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61789, '2020-07-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61790, '2020-07-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61791, '2020-07-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61792, '2020-07-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61793, '2020-07-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61794, '2020-07-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61795, '2020-07-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '3', '36', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61796, '2020-07-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '36', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61797, '2020-07-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61798, '2020-07-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61799, '2020-07-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61800, '2020-07-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61801, '2020-07-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61802, '2020-07-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61803, '2020-07-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61804, '2020-07-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61805, '2020-07-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61806, '2020-07-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '39', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61807, '2020-07-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '40', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61808, '2020-07-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '40', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61809, '2020-07-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '40', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61810, '2020-07-30', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '40', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61811, '2020-07-31', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '42', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61812, '2020-08-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '42', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61813, '2020-08-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61814, '2020-08-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '45', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61815, '2020-08-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61816, '2020-08-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61817, '2020-08-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '46', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61818, '2020-08-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '47', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61819, '2020-08-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '47', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61820, '2020-08-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61821, '2020-08-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61822, '2020-08-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61823, '2020-08-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61824, '2020-08-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61825, '2020-08-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61826, '2020-08-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '50', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61827, '2020-08-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '50', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61828, '2020-08-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '50', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61829, '2020-08-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '4', '54', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61830, '2020-08-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '54', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61831, '2020-08-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '54', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61832, '2020-08-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '54', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61833, '2020-08-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '54', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61834, '2020-08-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '54', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61835, '2020-08-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '54', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61836, '2020-08-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '54', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61837, '2020-08-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '54', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61838, '2020-08-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '54', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61839, '2020-08-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '54', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61840, '2020-08-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '54', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61841, '2020-08-30', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '56', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61842, '2020-08-31', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '56', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61843, '2020-09-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '56', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61844, '2020-09-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '57', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61845, '2020-09-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '57', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61846, '2020-09-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '57', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61847, '2020-09-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '57', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61848, '2020-09-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '58', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61849, '2020-09-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '58', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61850, '2020-09-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '59', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61851, '2020-09-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '59', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61852, '2020-09-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '59', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61853, '2020-09-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '59', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61854, '2020-09-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '59', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61855, '2020-09-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '60', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61856, '2020-09-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '60', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61857, '2020-09-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '61', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61858, '2020-09-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '61', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61859, '2020-09-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '61', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61860, '2020-09-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '62', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61861, '2020-09-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '62', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62021, '2020-01-23', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61862, '2020-09-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '6', '68', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61863, '2020-09-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '68', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61864, '2020-09-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '69', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61865, '2020-09-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '69', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61866, '2020-09-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '69', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61867, '2020-09-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '69', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61868, '2020-09-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '69', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61869, '2020-09-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '70', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61870, '2020-09-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '70', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61871, '2020-09-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '70', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61872, '2020-09-30', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '70', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61873, '2020-10-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '70', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61874, '2020-10-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '3', '73', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61875, '2020-10-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '73', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61876, '2020-10-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '73', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61877, '2020-10-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '73', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61878, '2020-10-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '75', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61879, '2020-10-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '75', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61880, '2020-10-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '75', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61881, '2020-10-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '75', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61882, '2020-10-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '75', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61883, '2020-10-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '77', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61884, '2020-10-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '77', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61885, '2020-10-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '77', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61886, '2020-10-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '77', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61887, '2020-10-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '77', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61888, '2020-10-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '3', '80', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61889, '2020-10-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '80', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61890, '2020-10-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '6', '86', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61891, '2020-10-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '86', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61892, '2020-10-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '86', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61893, '2020-10-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '88', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61894, '2020-10-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '88', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61895, '2020-10-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '88', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61896, '2020-10-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '88', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61897, '2020-10-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '88', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61898, '2020-10-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '88', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61899, '2020-10-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '4', '92', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61900, '2020-10-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '92', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61901, '2020-10-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '92', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61902, '2020-10-30', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '92', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61903, '2020-10-31', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '92', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61904, '2020-11-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '4', '96', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61905, '2020-11-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '96', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61906, '2020-11-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '96', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61907, '2020-11-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '96', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61908, '2020-11-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '96', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61909, '2020-11-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '98', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61910, '2020-11-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '98', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61911, '2020-11-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '98', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61912, '2020-11-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '98', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61913, '2020-11-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61914, '2020-11-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61915, '2020-11-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61916, '2020-11-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61917, '2020-11-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '100', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61918, '2020-11-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '102', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61919, '2020-11-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '102', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61920, '2020-11-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '103', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61921, '2020-11-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '103', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61922, '2020-11-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '103', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61923, '2020-11-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '103', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61924, '2020-11-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '103', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61925, '2020-11-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '104', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61926, '2020-11-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '104', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61927, '2020-11-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '104', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61928, '2020-11-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '104', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61929, '2020-11-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '104', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61930, '2020-11-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '104', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61931, '2020-11-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '104', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61932, '2020-11-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '105', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61933, '2020-11-30', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '105', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61934, '2020-12-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '106', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61935, '2020-12-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '106', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61936, '2020-12-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '106', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62022, '2020-01-24', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (61937, '2020-12-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '106', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61938, '2020-12-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '106', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61939, '2020-12-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '3', '109', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61940, '2020-12-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '109', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61941, '2020-12-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '111', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61942, '2020-12-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61943, '2020-12-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61944, '2020-12-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61945, '2020-12-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61946, '2020-12-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61947, '2020-12-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61948, '2020-12-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61949, '2020-12-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61950, '2020-12-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61951, '2020-12-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '115', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61952, '2020-12-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '115', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61953, '2020-12-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '116', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61954, '2020-12-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '116', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61955, '2020-12-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '116', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61956, '2020-12-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '118', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61957, '2020-12-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '118', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61958, '2020-12-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '4', '122', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61959, '2020-12-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '122', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61960, '2020-12-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '122', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61961, '2020-12-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '122', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61962, '2020-12-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '122', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61963, '2020-12-30', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '122', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61964, '2020-12-31', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '122', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61965, '2021-01-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '122', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61966, '2021-01-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '122', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61967, '2021-01-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '122', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61968, '2021-01-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '2', '124', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61969, '2021-01-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '125', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61970, '2021-01-06', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '125', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61971, '2021-01-07', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '125', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61972, '2021-01-08', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '125', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61973, '2021-01-09', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '125', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61974, '2021-01-10', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '125', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61975, '2021-01-11', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '125', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61976, '2021-01-12', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '3', '128', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61977, '2021-01-13', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '128', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61978, '2021-01-14', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '128', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61979, '2021-01-15', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '128', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61980, '2021-01-16', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '128', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61981, '2021-01-17', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '128', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61982, '2021-01-18', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '129', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61983, '2021-01-19', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '129', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61984, '2021-01-20', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '129', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61985, '2021-01-21', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '129', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61986, '2021-01-22', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '129', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61987, '2021-01-23', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '129', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61988, '2021-01-24', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '3', '132', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61989, '2021-01-25', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '132', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61990, '2021-01-26', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '132', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61991, '2021-01-27', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '132', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61992, '2021-01-28', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '132', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61993, '2021-01-29', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '132', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61994, '2021-01-30', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '132', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61995, '2021-01-31', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '132', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61996, '2021-02-01', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '132', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61997, '2021-02-02', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '1', '133', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61998, '2021-02-03', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '133', '0', '2');
INSERT INTO public.who_global_data_import VALUES (61999, '2021-02-04', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '133', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62000, '2021-02-05', 'MP', 'Northern Mariana Islands (Commonwealth of the)', 'WPRO', '0', '133', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62001, '2020-01-03', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62002, '2020-01-04', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62003, '2020-01-05', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62004, '2020-01-06', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62005, '2020-01-07', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62006, '2020-01-08', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62007, '2020-01-09', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62008, '2020-01-10', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62009, '2020-01-11', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62010, '2020-01-12', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62011, '2020-01-13', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62012, '2020-01-14', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62013, '2020-01-15', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62014, '2020-01-16', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62015, '2020-01-17', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62016, '2020-01-18', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62017, '2020-01-19', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62018, '2020-01-20', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62023, '2020-01-25', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62024, '2020-01-26', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62025, '2020-01-27', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62026, '2020-01-28', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62027, '2020-01-29', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62028, '2020-01-30', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62029, '2020-01-31', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62030, '2020-02-01', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62031, '2020-02-02', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62032, '2020-02-03', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62033, '2020-02-04', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62034, '2020-02-05', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62035, '2020-02-06', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62036, '2020-02-07', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62037, '2020-02-08', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62038, '2020-02-09', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62039, '2020-02-10', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62040, '2020-02-11', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62041, '2020-02-12', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62042, '2020-02-13', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62043, '2020-02-14', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62044, '2020-02-15', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62045, '2020-02-16', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62046, '2020-02-17', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62047, '2020-02-18', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62048, '2020-02-19', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62049, '2020-02-20', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62050, '2020-02-21', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62051, '2020-02-22', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62052, '2020-02-23', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62053, '2020-02-24', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62054, '2020-02-25', 'NO', 'Norway', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62055, '2020-02-26', 'NO', 'Norway', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62056, '2020-02-27', 'NO', 'Norway', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62057, '2020-02-28', 'NO', 'Norway', 'EURO', '3', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62058, '2020-02-29', 'NO', 'Norway', 'EURO', '2', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62059, '2020-03-01', 'NO', 'Norway', 'EURO', '9', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62060, '2020-03-02', 'NO', 'Norway', 'EURO', '4', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62061, '2020-03-03', 'NO', 'Norway', 'EURO', '6', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62062, '2020-03-04', 'NO', 'Norway', 'EURO', '8', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62063, '2020-03-05', 'NO', 'Norway', 'EURO', '23', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62064, '2020-03-06', 'NO', 'Norway', 'EURO', '30', '86', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62065, '2020-03-07', 'NO', 'Norway', 'EURO', '27', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62066, '2020-03-08', 'NO', 'Norway', 'EURO', '34', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62067, '2020-03-09', 'NO', 'Norway', 'EURO', '22', '169', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62068, '2020-03-10', 'NO', 'Norway', 'EURO', '23', '192', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62069, '2020-03-11', 'NO', 'Norway', 'EURO', '85', '277', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62070, '2020-03-12', 'NO', 'Norway', 'EURO', '212', '489', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62071, '2020-03-13', 'NO', 'Norway', 'EURO', '132', '621', '1', '1');
INSERT INTO public.who_global_data_import VALUES (62072, '2020-03-14', 'NO', 'Norway', 'EURO', '0', '621', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62073, '2020-03-15', 'NO', 'Norway', 'EURO', '286', '907', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62074, '2020-03-16', 'NO', 'Norway', 'EURO', '170', '1077', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62075, '2020-03-17', 'NO', 'Norway', 'EURO', '92', '1169', '2', '3');
INSERT INTO public.who_global_data_import VALUES (62076, '2020-03-18', 'NO', 'Norway', 'EURO', '139', '1308', '0', '3');
INSERT INTO public.who_global_data_import VALUES (62077, '2020-03-19', 'NO', 'Norway', 'EURO', '115', '1423', '0', '3');
INSERT INTO public.who_global_data_import VALUES (62078, '2020-03-20', 'NO', 'Norway', 'EURO', '129', '1552', '3', '6');
INSERT INTO public.who_global_data_import VALUES (62079, '2020-03-21', 'NO', 'Norway', 'EURO', '190', '1742', '1', '7');
INSERT INTO public.who_global_data_import VALUES (62080, '2020-03-22', 'NO', 'Norway', 'EURO', '184', '1926', '0', '7');
INSERT INTO public.who_global_data_import VALUES (62081, '2020-03-23', 'NO', 'Norway', 'EURO', '206', '2132', '0', '7');
INSERT INTO public.who_global_data_import VALUES (62082, '2020-03-24', 'NO', 'Norway', 'EURO', '239', '2371', '1', '8');
INSERT INTO public.who_global_data_import VALUES (62083, '2020-03-25', 'NO', 'Norway', 'EURO', '195', '2566', '2', '10');
INSERT INTO public.who_global_data_import VALUES (62084, '2020-03-26', 'NO', 'Norway', 'EURO', '350', '2916', '2', '12');
INSERT INTO public.who_global_data_import VALUES (62085, '2020-03-27', 'NO', 'Norway', 'EURO', '240', '3156', '2', '14');
INSERT INTO public.who_global_data_import VALUES (62086, '2020-03-28', 'NO', 'Norway', 'EURO', '425', '3581', '2', '16');
INSERT INTO public.who_global_data_import VALUES (62087, '2020-03-29', 'NO', 'Norway', 'EURO', '264', '3845', '4', '20');
INSERT INTO public.who_global_data_import VALUES (62088, '2020-03-30', 'NO', 'Norway', 'EURO', '257', '4102', '2', '22');
INSERT INTO public.who_global_data_import VALUES (62089, '2020-03-31', 'NO', 'Norway', 'EURO', '124', '4226', '4', '26');
INSERT INTO public.who_global_data_import VALUES (62090, '2020-04-01', 'NO', 'Norway', 'EURO', '221', '4447', '2', '28');
INSERT INTO public.who_global_data_import VALUES (62091, '2020-04-02', 'NO', 'Norway', 'EURO', '218', '4665', '4', '32');
INSERT INTO public.who_global_data_import VALUES (62092, '2020-04-03', 'NO', 'Norway', 'EURO', '270', '4935', '10', '42');
INSERT INTO public.who_global_data_import VALUES (62093, '2020-04-04', 'NO', 'Norway', 'EURO', '273', '5208', '2', '44');
INSERT INTO public.who_global_data_import VALUES (62094, '2020-04-05', 'NO', 'Norway', 'EURO', '302', '5510', '6', '50');
INSERT INTO public.who_global_data_import VALUES (62095, '2020-04-06', 'NO', 'Norway', 'EURO', '130', '5640', '8', '58');
INSERT INTO public.who_global_data_import VALUES (62096, '2020-04-07', 'NO', 'Norway', 'EURO', '115', '5755', '1', '59');
INSERT INTO public.who_global_data_import VALUES (62097, '2020-04-08', 'NO', 'Norway', 'EURO', '108', '5863', '10', '69');
INSERT INTO public.who_global_data_import VALUES (62098, '2020-04-09', 'NO', 'Norway', 'EURO', '147', '6010', '11', '80');
INSERT INTO public.who_global_data_import VALUES (62099, '2020-04-10', 'NO', 'Norway', 'EURO', '150', '6160', '8', '88');
INSERT INTO public.who_global_data_import VALUES (62100, '2020-04-11', 'NO', 'Norway', 'EURO', '84', '6244', '4', '92');
INSERT INTO public.who_global_data_import VALUES (62101, '2020-04-12', 'NO', 'Norway', 'EURO', '76', '6320', '6', '98');
INSERT INTO public.who_global_data_import VALUES (62102, '2020-04-13', 'NO', 'Norway', 'EURO', '95', '6415', '5', '103');
INSERT INTO public.who_global_data_import VALUES (62103, '2020-04-14', 'NO', 'Norway', 'EURO', '73', '6488', '11', '114');
INSERT INTO public.who_global_data_import VALUES (62104, '2020-04-15', 'NO', 'Norway', 'EURO', '78', '6566', '13', '127');
INSERT INTO public.who_global_data_import VALUES (62105, '2020-04-16', 'NO', 'Norway', 'EURO', '111', '6677', '3', '130');
INSERT INTO public.who_global_data_import VALUES (62106, '2020-04-17', 'NO', 'Norway', 'EURO', '114', '6791', '6', '136');
INSERT INTO public.who_global_data_import VALUES (62107, '2020-04-18', 'NO', 'Norway', 'EURO', '0', '6791', '0', '136');
INSERT INTO public.who_global_data_import VALUES (62108, '2020-04-19', 'NO', 'Norway', 'EURO', '193', '6984', '12', '148');
INSERT INTO public.who_global_data_import VALUES (62109, '2020-04-20', 'NO', 'Norway', 'EURO', '84', '7068', '6', '154');
INSERT INTO public.who_global_data_import VALUES (62110, '2020-04-21', 'NO', 'Norway', 'EURO', '45', '7113', '0', '154');
INSERT INTO public.who_global_data_import VALUES (62111, '2020-04-22', 'NO', 'Norway', 'EURO', '53', '7166', '9', '163');
INSERT INTO public.who_global_data_import VALUES (62112, '2020-04-23', 'NO', 'Norway', 'EURO', '84', '7250', '6', '169');
INSERT INTO public.who_global_data_import VALUES (62113, '2020-04-24', 'NO', 'Norway', 'EURO', '95', '7345', '11', '180');
INSERT INTO public.who_global_data_import VALUES (62114, '2020-04-25', 'NO', 'Norway', 'EURO', '63', '7408', '11', '191');
INSERT INTO public.who_global_data_import VALUES (62115, '2020-04-26', 'NO', 'Norway', 'EURO', '59', '7467', '2', '193');
INSERT INTO public.who_global_data_import VALUES (62116, '2020-04-27', 'NO', 'Norway', 'EURO', '38', '7505', '0', '193');
INSERT INTO public.who_global_data_import VALUES (62117, '2020-04-28', 'NO', 'Norway', 'EURO', '28', '7533', '0', '193');
INSERT INTO public.who_global_data_import VALUES (62118, '2020-04-29', 'NO', 'Norway', 'EURO', '72', '7605', '2', '195');
INSERT INTO public.who_global_data_import VALUES (62119, '2020-04-30', 'NO', 'Norway', 'EURO', '62', '7667', '7', '202');
INSERT INTO public.who_global_data_import VALUES (62120, '2020-05-01', 'NO', 'Norway', 'EURO', '43', '7710', '2', '204');
INSERT INTO public.who_global_data_import VALUES (62121, '2020-05-02', 'NO', 'Norway', 'EURO', '49', '7759', '0', '204');
INSERT INTO public.who_global_data_import VALUES (62122, '2020-05-03', 'NO', 'Norway', 'EURO', '0', '7759', '0', '204');
INSERT INTO public.who_global_data_import VALUES (62123, '2020-05-04', 'NO', 'Norway', 'EURO', '50', '7809', '4', '208');
INSERT INTO public.who_global_data_import VALUES (62124, '2020-05-05', 'NO', 'Norway', 'EURO', '38', '7847', '0', '208');
INSERT INTO public.who_global_data_import VALUES (62125, '2020-05-06', 'NO', 'Norway', 'EURO', '56', '7903', '1', '209');
INSERT INTO public.who_global_data_import VALUES (62126, '2020-05-07', 'NO', 'Norway', 'EURO', '50', '7953', '0', '209');
INSERT INTO public.who_global_data_import VALUES (62127, '2020-05-08', 'NO', 'Norway', 'EURO', '42', '7995', '0', '209');
INSERT INTO public.who_global_data_import VALUES (62128, '2020-05-09', 'NO', 'Norway', 'EURO', '39', '8034', '4', '213');
INSERT INTO public.who_global_data_import VALUES (62129, '2020-05-10', 'NO', 'Norway', 'EURO', '35', '8069', '0', '213');
INSERT INTO public.who_global_data_import VALUES (62130, '2020-05-11', 'NO', 'Norway', 'EURO', '30', '8099', '4', '217');
INSERT INTO public.who_global_data_import VALUES (62131, '2020-05-12', 'NO', 'Norway', 'EURO', '7', '8106', '7', '224');
INSERT INTO public.who_global_data_import VALUES (62132, '2020-05-13', 'NO', 'Norway', 'EURO', '29', '8135', '4', '228');
INSERT INTO public.who_global_data_import VALUES (62133, '2020-05-14', 'NO', 'Norway', 'EURO', '23', '8158', '1', '229');
INSERT INTO public.who_global_data_import VALUES (62134, '2020-05-15', 'NO', 'Norway', 'EURO', '17', '8175', '3', '232');
INSERT INTO public.who_global_data_import VALUES (62135, '2020-05-16', 'NO', 'Norway', 'EURO', '22', '8197', '0', '232');
INSERT INTO public.who_global_data_import VALUES (62136, '2020-05-17', 'NO', 'Norway', 'EURO', '0', '8197', '0', '232');
INSERT INTO public.who_global_data_import VALUES (62137, '2020-05-18', 'NO', 'Norway', 'EURO', '0', '8197', '0', '232');
INSERT INTO public.who_global_data_import VALUES (62138, '2020-05-19', 'NO', 'Norway', 'EURO', '52', '8249', '1', '233');
INSERT INTO public.who_global_data_import VALUES (62139, '2020-05-20', 'NO', 'Norway', 'EURO', '8', '8257', '0', '233');
INSERT INTO public.who_global_data_import VALUES (62140, '2020-05-21', 'NO', 'Norway', 'EURO', '11', '8268', '1', '234');
INSERT INTO public.who_global_data_import VALUES (62141, '2020-05-22', 'NO', 'Norway', 'EURO', '0', '8268', '0', '234');
INSERT INTO public.who_global_data_import VALUES (62142, '2020-05-23', 'NO', 'Norway', 'EURO', '41', '8309', '1', '235');
INSERT INTO public.who_global_data_import VALUES (62143, '2020-05-24', 'NO', 'Norway', 'EURO', '0', '8309', '0', '235');
INSERT INTO public.who_global_data_import VALUES (62144, '2020-05-25', 'NO', 'Norway', 'EURO', '0', '8309', '0', '235');
INSERT INTO public.who_global_data_import VALUES (62145, '2020-05-26', 'NO', 'Norway', 'EURO', '43', '8352', '0', '235');
INSERT INTO public.who_global_data_import VALUES (62146, '2020-05-27', 'NO', 'Norway', 'EURO', '12', '8364', '0', '235');
INSERT INTO public.who_global_data_import VALUES (62147, '2020-05-28', 'NO', 'Norway', 'EURO', '19', '8383', '0', '235');
INSERT INTO public.who_global_data_import VALUES (62148, '2020-05-29', 'NO', 'Norway', 'EURO', '18', '8401', '1', '236');
INSERT INTO public.who_global_data_import VALUES (62149, '2020-05-30', 'NO', 'Norway', 'EURO', '10', '8411', '0', '236');
INSERT INTO public.who_global_data_import VALUES (62150, '2020-05-31', 'NO', 'Norway', 'EURO', '0', '8411', '0', '236');
INSERT INTO public.who_global_data_import VALUES (62151, '2020-06-01', 'NO', 'Norway', 'EURO', '0', '8411', '0', '236');
INSERT INTO public.who_global_data_import VALUES (62152, '2020-06-02', 'NO', 'Norway', 'EURO', '0', '8411', '0', '236');
INSERT INTO public.who_global_data_import VALUES (62153, '2020-06-03', 'NO', 'Norway', 'EURO', '35', '8446', '1', '237');
INSERT INTO public.who_global_data_import VALUES (62154, '2020-06-04', 'NO', 'Norway', 'EURO', '0', '8446', '0', '237');
INSERT INTO public.who_global_data_import VALUES (62155, '2020-06-05', 'NO', 'Norway', 'EURO', '31', '8477', '1', '238');
INSERT INTO public.who_global_data_import VALUES (62156, '2020-06-06', 'NO', 'Norway', 'EURO', '27', '8504', '0', '238');
INSERT INTO public.who_global_data_import VALUES (62157, '2020-06-07', 'NO', 'Norway', 'EURO', '0', '8504', '0', '238');
INSERT INTO public.who_global_data_import VALUES (62158, '2020-06-08', 'NO', 'Norway', 'EURO', '0', '8504', '0', '238');
INSERT INTO public.who_global_data_import VALUES (62159, '2020-06-09', 'NO', 'Norway', 'EURO', '43', '8547', '1', '239');
INSERT INTO public.who_global_data_import VALUES (62160, '2020-06-10', 'NO', 'Norway', 'EURO', '16', '8563', '0', '239');
INSERT INTO public.who_global_data_import VALUES (62161, '2020-06-11', 'NO', 'Norway', 'EURO', '13', '8576', '0', '239');
INSERT INTO public.who_global_data_import VALUES (62162, '2020-06-12', 'NO', 'Norway', 'EURO', '18', '8594', '3', '242');
INSERT INTO public.who_global_data_import VALUES (62163, '2020-06-13', 'NO', 'Norway', 'EURO', '12', '8606', '0', '242');
INSERT INTO public.who_global_data_import VALUES (62164, '2020-06-14', 'NO', 'Norway', 'EURO', '0', '8606', '0', '242');
INSERT INTO public.who_global_data_import VALUES (62165, '2020-06-15', 'NO', 'Norway', 'EURO', '0', '8606', '0', '242');
INSERT INTO public.who_global_data_import VALUES (62166, '2020-06-16', 'NO', 'Norway', 'EURO', '25', '8631', '0', '242');
INSERT INTO public.who_global_data_import VALUES (62167, '2020-06-17', 'NO', 'Norway', 'EURO', '0', '8631', '0', '242');
INSERT INTO public.who_global_data_import VALUES (62168, '2020-06-18', 'NO', 'Norway', 'EURO', '29', '8660', '1', '243');
INSERT INTO public.who_global_data_import VALUES (62169, '2020-06-19', 'NO', 'Norway', 'EURO', '32', '8692', '1', '244');
INSERT INTO public.who_global_data_import VALUES (62170, '2020-06-20', 'NO', 'Norway', 'EURO', '0', '8692', '0', '244');
INSERT INTO public.who_global_data_import VALUES (62171, '2020-06-21', 'NO', 'Norway', 'EURO', '16', '8708', '0', '244');
INSERT INTO public.who_global_data_import VALUES (62172, '2020-06-22', 'NO', 'Norway', 'EURO', '0', '8708', '0', '244');
INSERT INTO public.who_global_data_import VALUES (62173, '2020-06-23', 'NO', 'Norway', 'EURO', '37', '8745', '4', '248');
INSERT INTO public.who_global_data_import VALUES (62174, '2020-06-24', 'NO', 'Norway', 'EURO', '6', '8751', '0', '248');
INSERT INTO public.who_global_data_import VALUES (62175, '2020-06-25', 'NO', 'Norway', 'EURO', '26', '8777', '1', '249');
INSERT INTO public.who_global_data_import VALUES (62176, '2020-06-26', 'NO', 'Norway', 'EURO', '16', '8793', '0', '249');
INSERT INTO public.who_global_data_import VALUES (62177, '2020-06-27', 'NO', 'Norway', 'EURO', '22', '8815', '0', '249');
INSERT INTO public.who_global_data_import VALUES (62178, '2020-06-28', 'NO', 'Norway', 'EURO', '0', '8815', '0', '249');
INSERT INTO public.who_global_data_import VALUES (62179, '2020-06-29', 'NO', 'Norway', 'EURO', '0', '8815', '0', '249');
INSERT INTO public.who_global_data_import VALUES (62180, '2020-06-30', 'NO', 'Norway', 'EURO', '40', '8855', '0', '249');
INSERT INTO public.who_global_data_import VALUES (62181, '2020-07-01', 'NO', 'Norway', 'EURO', '10', '8865', '1', '250');
INSERT INTO public.who_global_data_import VALUES (62182, '2020-07-02', 'NO', 'Norway', 'EURO', '22', '8887', '1', '251');
INSERT INTO public.who_global_data_import VALUES (62183, '2020-07-03', 'NO', 'Norway', 'EURO', '8', '8895', '0', '251');
INSERT INTO public.who_global_data_import VALUES (62184, '2020-07-04', 'NO', 'Norway', 'EURO', '0', '8895', '0', '251');
INSERT INTO public.who_global_data_import VALUES (62185, '2020-07-05', 'NO', 'Norway', 'EURO', '0', '8895', '0', '251');
INSERT INTO public.who_global_data_import VALUES (62186, '2020-07-06', 'NO', 'Norway', 'EURO', '0', '8895', '0', '251');
INSERT INTO public.who_global_data_import VALUES (62187, '2020-07-07', 'NO', 'Norway', 'EURO', '35', '8930', '0', '251');
INSERT INTO public.who_global_data_import VALUES (62188, '2020-07-08', 'NO', 'Norway', 'EURO', '6', '8936', '0', '251');
INSERT INTO public.who_global_data_import VALUES (62189, '2020-07-09', 'NO', 'Norway', 'EURO', '11', '8947', '0', '251');
INSERT INTO public.who_global_data_import VALUES (62190, '2020-07-10', 'NO', 'Norway', 'EURO', '7', '8954', '1', '252');
INSERT INTO public.who_global_data_import VALUES (62191, '2020-07-11', 'NO', 'Norway', 'EURO', '11', '8965', '0', '252');
INSERT INTO public.who_global_data_import VALUES (62192, '2020-07-12', 'NO', 'Norway', 'EURO', '0', '8965', '0', '252');
INSERT INTO public.who_global_data_import VALUES (62193, '2020-07-13', 'NO', 'Norway', 'EURO', '0', '8965', '0', '252');
INSERT INTO public.who_global_data_import VALUES (62194, '2020-07-14', 'NO', 'Norway', 'EURO', '16', '8981', '1', '253');
INSERT INTO public.who_global_data_import VALUES (62195, '2020-07-15', 'NO', 'Norway', 'EURO', '3', '8984', '0', '253');
INSERT INTO public.who_global_data_import VALUES (62196, '2020-07-16', 'NO', 'Norway', 'EURO', '17', '9001', '0', '253');
INSERT INTO public.who_global_data_import VALUES (62197, '2020-07-17', 'NO', 'Norway', 'EURO', '10', '9011', '1', '254');
INSERT INTO public.who_global_data_import VALUES (62198, '2020-07-18', 'NO', 'Norway', 'EURO', '4', '9015', '1', '255');
INSERT INTO public.who_global_data_import VALUES (62199, '2020-07-19', 'NO', 'Norway', 'EURO', '0', '9015', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62200, '2020-07-20', 'NO', 'Norway', 'EURO', '0', '9015', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62201, '2020-07-21', 'NO', 'Norway', 'EURO', '13', '9028', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62202, '2020-07-22', 'NO', 'Norway', 'EURO', '10', '9038', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62203, '2020-07-23', 'NO', 'Norway', 'EURO', '15', '9053', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62204, '2020-07-24', 'NO', 'Norway', 'EURO', '9', '9062', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62205, '2020-07-25', 'NO', 'Norway', 'EURO', '23', '9085', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62206, '2020-07-26', 'NO', 'Norway', 'EURO', '0', '9085', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62207, '2020-07-27', 'NO', 'Norway', 'EURO', '0', '9085', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62208, '2020-07-28', 'NO', 'Norway', 'EURO', '32', '9117', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62209, '2020-07-29', 'NO', 'Norway', 'EURO', '15', '9132', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62210, '2020-07-30', 'NO', 'Norway', 'EURO', '18', '9150', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62211, '2020-07-31', 'NO', 'Norway', 'EURO', '22', '9172', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62212, '2020-08-01', 'NO', 'Norway', 'EURO', '36', '9208', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62213, '2020-08-02', 'NO', 'Norway', 'EURO', '0', '9208', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62214, '2020-08-03', 'NO', 'Norway', 'EURO', '0', '9208', '0', '255');
INSERT INTO public.who_global_data_import VALUES (62215, '2020-08-04', 'NO', 'Norway', 'EURO', '60', '9268', '1', '256');
INSERT INTO public.who_global_data_import VALUES (62216, '2020-08-05', 'NO', 'Norway', 'EURO', '65', '9333', '0', '256');
INSERT INTO public.who_global_data_import VALUES (62217, '2020-08-06', 'NO', 'Norway', 'EURO', '29', '9362', '0', '256');
INSERT INTO public.who_global_data_import VALUES (62218, '2020-08-07', 'NO', 'Norway', 'EURO', '47', '9409', '0', '256');
INSERT INTO public.who_global_data_import VALUES (62219, '2020-08-08', 'NO', 'Norway', 'EURO', '59', '9468', '0', '256');
INSERT INTO public.who_global_data_import VALUES (62220, '2020-08-09', 'NO', 'Norway', 'EURO', '0', '9468', '0', '256');
INSERT INTO public.who_global_data_import VALUES (62221, '2020-08-10', 'NO', 'Norway', 'EURO', '0', '9468', '0', '256');
INSERT INTO public.who_global_data_import VALUES (62222, '2020-08-11', 'NO', 'Norway', 'EURO', '170', '9638', '0', '256');
INSERT INTO public.who_global_data_import VALUES (62223, '2020-08-12', 'NO', 'Norway', 'EURO', '46', '9684', '0', '256');
INSERT INTO public.who_global_data_import VALUES (62224, '2020-08-13', 'NO', 'Norway', 'EURO', '66', '9750', '0', '256');
INSERT INTO public.who_global_data_import VALUES (62225, '2020-08-14', 'NO', 'Norway', 'EURO', '33', '9783', '1', '257');
INSERT INTO public.who_global_data_import VALUES (62226, '2020-08-15', 'NO', 'Norway', 'EURO', '67', '9850', '4', '261');
INSERT INTO public.who_global_data_import VALUES (62227, '2020-08-16', 'NO', 'Norway', 'EURO', '0', '9850', '0', '261');
INSERT INTO public.who_global_data_import VALUES (62228, '2020-08-17', 'NO', 'Norway', 'EURO', '0', '9850', '0', '261');
INSERT INTO public.who_global_data_import VALUES (62229, '2020-08-18', 'NO', 'Norway', 'EURO', '154', '10004', '0', '261');
INSERT INTO public.who_global_data_import VALUES (62230, '2020-08-19', 'NO', 'Norway', 'EURO', '56', '10060', '1', '262');
INSERT INTO public.who_global_data_import VALUES (62231, '2020-08-20', 'NO', 'Norway', 'EURO', '51', '10111', '0', '262');
INSERT INTO public.who_global_data_import VALUES (62232, '2020-08-21', 'NO', 'Norway', 'EURO', '51', '10162', '2', '264');
INSERT INTO public.who_global_data_import VALUES (62233, '2020-08-22', 'NO', 'Norway', 'EURO', '35', '10197', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62234, '2020-08-23', 'NO', 'Norway', 'EURO', '0', '10197', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62235, '2020-08-24', 'NO', 'Norway', 'EURO', '0', '10197', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62236, '2020-08-25', 'NO', 'Norway', 'EURO', '126', '10323', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62237, '2020-08-26', 'NO', 'Norway', 'EURO', '72', '10395', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62238, '2020-08-27', 'NO', 'Norway', 'EURO', '59', '10454', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62239, '2020-08-28', 'NO', 'Norway', 'EURO', '51', '10505', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62240, '2020-08-29', 'NO', 'Norway', 'EURO', '38', '10543', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62241, '2020-08-30', 'NO', 'Norway', 'EURO', '0', '10543', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62242, '2020-08-31', 'NO', 'Norway', 'EURO', '0', '10543', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62243, '2020-09-01', 'NO', 'Norway', 'EURO', '101', '10644', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62244, '2020-09-02', 'NO', 'Norway', 'EURO', '139', '10783', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62245, '2020-09-03', 'NO', 'Norway', 'EURO', '88', '10871', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62246, '2020-09-04', 'NO', 'Norway', 'EURO', '164', '11035', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62247, '2020-09-05', 'NO', 'Norway', 'EURO', '85', '11120', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62248, '2020-09-06', 'NO', 'Norway', 'EURO', '0', '11120', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62249, '2020-09-07', 'NO', 'Norway', 'EURO', '0', '11120', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62250, '2020-09-08', 'NO', 'Norway', 'EURO', '267', '11387', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62251, '2020-09-09', 'NO', 'Norway', 'EURO', '132', '11519', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62252, '2020-09-10', 'NO', 'Norway', 'EURO', '105', '11624', '0', '264');
INSERT INTO public.who_global_data_import VALUES (62253, '2020-09-11', 'NO', 'Norway', 'EURO', '122', '11746', '1', '265');
INSERT INTO public.who_global_data_import VALUES (62254, '2020-09-12', 'NO', 'Norway', 'EURO', '120', '11866', '0', '265');
INSERT INTO public.who_global_data_import VALUES (62255, '2020-09-13', 'NO', 'Norway', 'EURO', '0', '11866', '0', '265');
INSERT INTO public.who_global_data_import VALUES (62256, '2020-09-14', 'NO', 'Norway', 'EURO', '0', '11866', '0', '265');
INSERT INTO public.who_global_data_import VALUES (62257, '2020-09-15', 'NO', 'Norway', 'EURO', '289', '12155', '0', '265');
INSERT INTO public.who_global_data_import VALUES (62258, '2020-09-16', 'NO', 'Norway', 'EURO', '122', '12277', '0', '265');
INSERT INTO public.who_global_data_import VALUES (62259, '2020-09-17', 'NO', 'Norway', 'EURO', '116', '12393', '0', '265');
INSERT INTO public.who_global_data_import VALUES (62260, '2020-09-18', 'NO', 'Norway', 'EURO', '106', '12499', '1', '266');
INSERT INTO public.who_global_data_import VALUES (62261, '2020-09-19', 'NO', 'Norway', 'EURO', '146', '12645', '1', '267');
INSERT INTO public.who_global_data_import VALUES (62262, '2020-09-20', 'NO', 'Norway', 'EURO', '0', '12645', '0', '267');
INSERT INTO public.who_global_data_import VALUES (62263, '2020-09-21', 'NO', 'Norway', 'EURO', '0', '12645', '0', '267');
INSERT INTO public.who_global_data_import VALUES (62264, '2020-09-22', 'NO', 'Norway', 'EURO', '251', '12896', '0', '267');
INSERT INTO public.who_global_data_import VALUES (62265, '2020-09-23', 'NO', 'Norway', 'EURO', '104', '13000', '0', '267');
INSERT INTO public.who_global_data_import VALUES (62266, '2020-09-24', 'NO', 'Norway', 'EURO', '152', '13152', '0', '267');
INSERT INTO public.who_global_data_import VALUES (62267, '2020-09-25', 'NO', 'Norway', 'EURO', '123', '13275', '3', '270');
INSERT INTO public.who_global_data_import VALUES (62268, '2020-09-26', 'NO', 'Norway', 'EURO', '131', '13406', '0', '270');
INSERT INTO public.who_global_data_import VALUES (62269, '2020-09-27', 'NO', 'Norway', 'EURO', '0', '13406', '0', '270');
INSERT INTO public.who_global_data_import VALUES (62270, '2020-09-28', 'NO', 'Norway', 'EURO', '0', '13406', '0', '270');
INSERT INTO public.who_global_data_import VALUES (62271, '2020-09-29', 'NO', 'Norway', 'EURO', '292', '13698', '4', '274');
INSERT INTO public.who_global_data_import VALUES (62272, '2020-09-30', 'NO', 'Norway', 'EURO', '90', '13788', '0', '274');
INSERT INTO public.who_global_data_import VALUES (62273, '2020-10-01', 'NO', 'Norway', 'EURO', '126', '13914', '0', '274');
INSERT INTO public.who_global_data_import VALUES (62274, '2020-10-02', 'NO', 'Norway', 'EURO', '113', '14027', '0', '274');
INSERT INTO public.who_global_data_import VALUES (62275, '2020-10-03', 'NO', 'Norway', 'EURO', '122', '14149', '1', '275');
INSERT INTO public.who_global_data_import VALUES (62276, '2020-10-04', 'NO', 'Norway', 'EURO', '0', '14149', '0', '275');
INSERT INTO public.who_global_data_import VALUES (62277, '2020-10-05', 'NO', 'Norway', 'EURO', '0', '14149', '0', '275');
INSERT INTO public.who_global_data_import VALUES (62278, '2020-10-06', 'NO', 'Norway', 'EURO', '308', '14457', '0', '275');
INSERT INTO public.who_global_data_import VALUES (62279, '2020-10-07', 'NO', 'Norway', 'EURO', '147', '14604', '0', '275');
INSERT INTO public.who_global_data_import VALUES (62280, '2020-10-08', 'NO', 'Norway', 'EURO', '180', '14784', '0', '275');
INSERT INTO public.who_global_data_import VALUES (62281, '2020-10-09', 'NO', 'Norway', 'EURO', '228', '15012', '0', '275');
INSERT INTO public.who_global_data_import VALUES (62282, '2020-10-10', 'NO', 'Norway', 'EURO', '209', '15221', '0', '275');
INSERT INTO public.who_global_data_import VALUES (62283, '2020-10-11', 'NO', 'Norway', 'EURO', '0', '15221', '0', '275');
INSERT INTO public.who_global_data_import VALUES (62284, '2020-10-12', 'NO', 'Norway', 'EURO', '0', '15221', '0', '275');
INSERT INTO public.who_global_data_import VALUES (62285, '2020-10-13', 'NO', 'Norway', 'EURO', '303', '15524', '1', '276');
INSERT INTO public.who_global_data_import VALUES (62286, '2020-10-14', 'NO', 'Norway', 'EURO', '115', '15639', '1', '277');
INSERT INTO public.who_global_data_import VALUES (62287, '2020-10-15', 'NO', 'Norway', 'EURO', '152', '15791', '0', '277');
INSERT INTO public.who_global_data_import VALUES (62288, '2020-10-16', 'NO', 'Norway', 'EURO', '162', '15953', '1', '278');
INSERT INTO public.who_global_data_import VALUES (62289, '2020-10-17', 'NO', 'Norway', 'EURO', '183', '16136', '0', '278');
INSERT INTO public.who_global_data_import VALUES (62290, '2020-10-18', 'NO', 'Norway', 'EURO', '0', '16136', '0', '278');
INSERT INTO public.who_global_data_import VALUES (62291, '2020-10-19', 'NO', 'Norway', 'EURO', '0', '16136', '0', '278');
INSERT INTO public.who_global_data_import VALUES (62292, '2020-10-20', 'NO', 'Norway', 'EURO', '320', '16456', '0', '278');
INSERT INTO public.who_global_data_import VALUES (62293, '2020-10-21', 'NO', 'Norway', 'EURO', '147', '16603', '0', '278');
INSERT INTO public.who_global_data_import VALUES (62294, '2020-10-22', 'NO', 'Norway', 'EURO', '168', '16771', '1', '279');
INSERT INTO public.who_global_data_import VALUES (62295, '2020-10-23', 'NO', 'Norway', 'EURO', '193', '16964', '0', '279');
INSERT INTO public.who_global_data_import VALUES (62296, '2020-10-24', 'NO', 'Norway', 'EURO', '268', '17232', '0', '279');
INSERT INTO public.who_global_data_import VALUES (62297, '2020-10-25', 'NO', 'Norway', 'EURO', '0', '17232', '0', '279');
INSERT INTO public.who_global_data_import VALUES (62298, '2020-10-26', 'NO', 'Norway', 'EURO', '0', '17232', '0', '279');
INSERT INTO public.who_global_data_import VALUES (62299, '2020-10-27', 'NO', 'Norway', 'EURO', '676', '17908', '0', '279');
INSERT INTO public.who_global_data_import VALUES (62300, '2020-10-28', 'NO', 'Norway', 'EURO', '433', '18341', '1', '280');
INSERT INTO public.who_global_data_import VALUES (62301, '2020-10-29', 'NO', 'Norway', 'EURO', '322', '18663', '0', '280');
INSERT INTO public.who_global_data_import VALUES (62302, '2020-10-30', 'NO', 'Norway', 'EURO', '403', '19066', '1', '281');
INSERT INTO public.who_global_data_import VALUES (62303, '2020-10-31', 'NO', 'Norway', 'EURO', '497', '19563', '1', '282');
INSERT INTO public.who_global_data_import VALUES (62304, '2020-11-01', 'NO', 'Norway', 'EURO', '0', '19563', '0', '282');
INSERT INTO public.who_global_data_import VALUES (62305, '2020-11-02', 'NO', 'Norway', 'EURO', '0', '19563', '0', '282');
INSERT INTO public.who_global_data_import VALUES (62306, '2020-11-03', 'NO', 'Norway', 'EURO', '1071', '20634', '0', '282');
INSERT INTO public.who_global_data_import VALUES (62307, '2020-11-04', 'NO', 'Norway', 'EURO', '700', '21334', '0', '282');
INSERT INTO public.who_global_data_import VALUES (62308, '2020-11-05', 'NO', 'Norway', 'EURO', '620', '21954', '0', '282');
INSERT INTO public.who_global_data_import VALUES (62309, '2020-11-06', 'NO', 'Norway', 'EURO', '621', '22575', '2', '284');
INSERT INTO public.who_global_data_import VALUES (62310, '2020-11-07', 'NO', 'Norway', 'EURO', '650', '23225', '1', '285');
INSERT INTO public.who_global_data_import VALUES (62311, '2020-11-08', 'NO', 'Norway', 'EURO', '0', '23225', '0', '285');
INSERT INTO public.who_global_data_import VALUES (62312, '2020-11-09', 'NO', 'Norway', 'EURO', '0', '23225', '0', '285');
INSERT INTO public.who_global_data_import VALUES (62313, '2020-11-10', 'NO', 'Norway', 'EURO', '1502', '24727', '0', '285');
INSERT INTO public.who_global_data_import VALUES (62314, '2020-11-11', 'NO', 'Norway', 'EURO', '594', '25321', '0', '285');
INSERT INTO public.who_global_data_import VALUES (62315, '2020-11-12', 'NO', 'Norway', 'EURO', '564', '25885', '0', '285');
INSERT INTO public.who_global_data_import VALUES (62316, '2020-11-13', 'NO', 'Norway', 'EURO', '618', '26503', '6', '291');
INSERT INTO public.who_global_data_import VALUES (62317, '2020-11-14', 'NO', 'Norway', 'EURO', '723', '27226', '3', '294');
INSERT INTO public.who_global_data_import VALUES (62318, '2020-11-15', 'NO', 'Norway', 'EURO', '0', '27226', '0', '294');
INSERT INTO public.who_global_data_import VALUES (62319, '2020-11-16', 'NO', 'Norway', 'EURO', '0', '27226', '0', '294');
INSERT INTO public.who_global_data_import VALUES (62320, '2020-11-17', 'NO', 'Norway', 'EURO', '1737', '28963', '0', '294');
INSERT INTO public.who_global_data_import VALUES (62321, '2020-11-18', 'NO', 'Norway', 'EURO', '547', '29510', '4', '298');
INSERT INTO public.who_global_data_import VALUES (62322, '2020-11-19', 'NO', 'Norway', 'EURO', '603', '30113', '1', '299');
INSERT INTO public.who_global_data_import VALUES (62323, '2020-11-20', 'NO', 'Norway', 'EURO', '655', '30768', '6', '305');
INSERT INTO public.who_global_data_import VALUES (62324, '2020-11-21', 'NO', 'Norway', 'EURO', '670', '31438', '1', '306');
INSERT INTO public.who_global_data_import VALUES (62325, '2020-11-22', 'NO', 'Norway', 'EURO', '0', '31438', '0', '306');
INSERT INTO public.who_global_data_import VALUES (62326, '2020-11-23', 'NO', 'Norway', 'EURO', '0', '31438', '0', '306');
INSERT INTO public.who_global_data_import VALUES (62327, '2020-11-24', 'NO', 'Norway', 'EURO', '1329', '32767', '5', '311');
INSERT INTO public.who_global_data_import VALUES (62328, '2020-11-25', 'NO', 'Norway', 'EURO', '416', '33183', '3', '314');
INSERT INTO public.who_global_data_import VALUES (62329, '2020-11-26', 'NO', 'Norway', 'EURO', '531', '33714', '2', '316');
INSERT INTO public.who_global_data_import VALUES (62330, '2020-11-27', 'NO', 'Norway', 'EURO', '553', '34267', '0', '316');
INSERT INTO public.who_global_data_import VALUES (62331, '2020-11-28', 'NO', 'Norway', 'EURO', '480', '34747', '12', '328');
INSERT INTO public.who_global_data_import VALUES (62332, '2020-11-29', 'NO', 'Norway', 'EURO', '0', '34747', '0', '328');
INSERT INTO public.who_global_data_import VALUES (62333, '2020-11-30', 'NO', 'Norway', 'EURO', '0', '34747', '0', '328');
INSERT INTO public.who_global_data_import VALUES (62334, '2020-12-01', 'NO', 'Norway', 'EURO', '1079', '35826', '4', '332');
INSERT INTO public.who_global_data_import VALUES (62335, '2020-12-02', 'NO', 'Norway', 'EURO', '324', '36150', '2', '334');
INSERT INTO public.who_global_data_import VALUES (62336, '2020-12-03', 'NO', 'Norway', 'EURO', '441', '36591', '17', '351');
INSERT INTO public.who_global_data_import VALUES (62337, '2020-12-04', 'NO', 'Norway', 'EURO', '377', '36968', '2', '353');
INSERT INTO public.who_global_data_import VALUES (62338, '2020-12-05', 'NO', 'Norway', 'EURO', '403', '37371', '1', '354');
INSERT INTO public.who_global_data_import VALUES (62339, '2020-12-06', 'NO', 'Norway', 'EURO', '0', '37371', '0', '354');
INSERT INTO public.who_global_data_import VALUES (62340, '2020-12-07', 'NO', 'Norway', 'EURO', '0', '37371', '0', '354');
INSERT INTO public.who_global_data_import VALUES (62341, '2020-12-08', 'NO', 'Norway', 'EURO', '951', '38322', '5', '359');
INSERT INTO public.who_global_data_import VALUES (62342, '2020-12-09', 'NO', 'Norway', 'EURO', '381', '38703', '2', '361');
INSERT INTO public.who_global_data_import VALUES (62343, '2020-12-10', 'NO', 'Norway', 'EURO', '459', '39162', '0', '361');
INSERT INTO public.who_global_data_import VALUES (62344, '2020-12-11', 'NO', 'Norway', 'EURO', '362', '39524', '21', '382');
INSERT INTO public.who_global_data_import VALUES (62345, '2020-12-12', 'NO', 'Norway', 'EURO', '498', '40022', '5', '387');
INSERT INTO public.who_global_data_import VALUES (62346, '2020-12-13', 'NO', 'Norway', 'EURO', '0', '40022', '0', '387');
INSERT INTO public.who_global_data_import VALUES (62347, '2020-12-14', 'NO', 'Norway', 'EURO', '0', '40022', '0', '387');
INSERT INTO public.who_global_data_import VALUES (62348, '2020-12-15', 'NO', 'Norway', 'EURO', '981', '41003', '6', '393');
INSERT INTO public.who_global_data_import VALUES (62349, '2020-12-16', 'NO', 'Norway', 'EURO', '331', '41334', '2', '395');
INSERT INTO public.who_global_data_import VALUES (62350, '2020-12-17', 'NO', 'Norway', 'EURO', '518', '41852', '7', '402');
INSERT INTO public.who_global_data_import VALUES (62351, '2020-12-18', 'NO', 'Norway', 'EURO', '460', '42312', '2', '404');
INSERT INTO public.who_global_data_import VALUES (62352, '2020-12-19', 'NO', 'Norway', 'EURO', '463', '42775', '0', '404');
INSERT INTO public.who_global_data_import VALUES (62353, '2020-12-20', 'NO', 'Norway', 'EURO', '0', '42775', '0', '404');
INSERT INTO public.who_global_data_import VALUES (62354, '2020-12-21', 'NO', 'Norway', 'EURO', '0', '42775', '0', '404');
INSERT INTO public.who_global_data_import VALUES (62355, '2020-12-22', 'NO', 'Norway', 'EURO', '1130', '43905', '1', '405');
INSERT INTO public.who_global_data_import VALUES (62356, '2020-12-23', 'NO', 'Norway', 'EURO', '431', '44336', '0', '405');
INSERT INTO public.who_global_data_import VALUES (62357, '2020-12-24', 'NO', 'Norway', 'EURO', '596', '44932', '16', '421');
INSERT INTO public.who_global_data_import VALUES (62358, '2020-12-25', 'NO', 'Norway', 'EURO', '0', '44932', '0', '421');
INSERT INTO public.who_global_data_import VALUES (62359, '2020-12-26', 'NO', 'Norway', 'EURO', '0', '44932', '0', '421');
INSERT INTO public.who_global_data_import VALUES (62360, '2020-12-27', 'NO', 'Norway', 'EURO', '0', '44932', '0', '421');
INSERT INTO public.who_global_data_import VALUES (62361, '2020-12-28', 'NO', 'Norway', 'EURO', '0', '44932', '0', '421');
INSERT INTO public.who_global_data_import VALUES (62362, '2020-12-29', 'NO', 'Norway', 'EURO', '2125', '47057', '8', '429');
INSERT INTO public.who_global_data_import VALUES (62363, '2020-12-30', 'NO', 'Norway', 'EURO', '526', '47583', '4', '433');
INSERT INTO public.who_global_data_import VALUES (62364, '2020-12-31', 'NO', 'Norway', 'EURO', '695', '48278', '3', '436');
INSERT INTO public.who_global_data_import VALUES (62365, '2021-01-01', 'NO', 'Norway', 'EURO', '0', '48278', '0', '436');
INSERT INTO public.who_global_data_import VALUES (62366, '2021-01-02', 'NO', 'Norway', 'EURO', '0', '48278', '0', '436');
INSERT INTO public.who_global_data_import VALUES (62367, '2021-01-03', 'NO', 'Norway', 'EURO', '0', '48278', '0', '436');
INSERT INTO public.who_global_data_import VALUES (62368, '2021-01-04', 'NO', 'Norway', 'EURO', '0', '48278', '0', '436');
INSERT INTO public.who_global_data_import VALUES (62369, '2021-01-05', 'NO', 'Norway', 'EURO', '2437', '50715', '13', '449');
INSERT INTO public.who_global_data_import VALUES (62370, '2021-01-06', 'NO', 'Norway', 'EURO', '525', '51240', '3', '452');
INSERT INTO public.who_global_data_import VALUES (62371, '2021-01-07', 'NO', 'Norway', 'EURO', '940', '52180', '14', '466');
INSERT INTO public.who_global_data_import VALUES (62372, '2021-01-08', 'NO', 'Norway', 'EURO', '787', '52967', '1', '467');
INSERT INTO public.who_global_data_import VALUES (62373, '2021-01-09', 'NO', 'Norway', 'EURO', '825', '53792', '4', '471');
INSERT INTO public.who_global_data_import VALUES (62374, '2021-01-10', 'NO', 'Norway', 'EURO', '0', '53792', '0', '471');
INSERT INTO public.who_global_data_import VALUES (62375, '2021-01-11', 'NO', 'Norway', 'EURO', '1681', '55473', '7', '478');
INSERT INTO public.who_global_data_import VALUES (62376, '2021-01-12', 'NO', 'Norway', 'EURO', '428', '55901', '4', '482');
INSERT INTO public.who_global_data_import VALUES (62377, '2021-01-13', 'NO', 'Norway', 'EURO', '713', '56614', '27', '509');
INSERT INTO public.who_global_data_import VALUES (62378, '2021-01-14', 'NO', 'Norway', 'EURO', '665', '57279', '2', '511');
INSERT INTO public.who_global_data_import VALUES (62379, '2021-01-15', 'NO', 'Norway', 'EURO', '455', '57734', '6', '517');
INSERT INTO public.who_global_data_import VALUES (62380, '2021-01-16', 'NO', 'Norway', 'EURO', '0', '57734', '0', '517');
INSERT INTO public.who_global_data_import VALUES (62381, '2021-01-17', 'NO', 'Norway', 'EURO', '0', '57734', '0', '517');
INSERT INTO public.who_global_data_import VALUES (62382, '2021-01-18', 'NO', 'Norway', 'EURO', '711', '58445', '0', '517');
INSERT INTO public.who_global_data_import VALUES (62383, '2021-01-19', 'NO', 'Norway', 'EURO', '206', '58651', '4', '521');
INSERT INTO public.who_global_data_import VALUES (62384, '2021-01-20', 'NO', 'Norway', 'EURO', '382', '59033', '4', '525');
INSERT INTO public.who_global_data_import VALUES (62385, '2021-01-21', 'NO', 'Norway', 'EURO', '423', '59456', '18', '543');
INSERT INTO public.who_global_data_import VALUES (62386, '2021-01-22', 'NO', 'Norway', 'EURO', '431', '59887', '1', '544');
INSERT INTO public.who_global_data_import VALUES (62387, '2021-01-23', 'NO', 'Norway', 'EURO', '372', '60259', '0', '544');
INSERT INTO public.who_global_data_import VALUES (62388, '2021-01-24', 'NO', 'Norway', 'EURO', '306', '60565', '0', '544');
INSERT INTO public.who_global_data_import VALUES (62389, '2021-01-25', 'NO', 'Norway', 'EURO', '238', '60803', '0', '544');
INSERT INTO public.who_global_data_import VALUES (62390, '2021-01-26', 'NO', 'Norway', 'EURO', '279', '61082', '4', '548');
INSERT INTO public.who_global_data_import VALUES (62391, '2021-01-27', 'NO', 'Norway', 'EURO', '232', '61314', '2', '550');
INSERT INTO public.who_global_data_import VALUES (62392, '2021-01-28', 'NO', 'Norway', 'EURO', '280', '61594', '6', '556');
INSERT INTO public.who_global_data_import VALUES (62393, '2021-01-29', 'NO', 'Norway', 'EURO', '366', '61960', '1', '557');
INSERT INTO public.who_global_data_import VALUES (62394, '2021-01-30', 'NO', 'Norway', 'EURO', '316', '62276', '6', '563');
INSERT INTO public.who_global_data_import VALUES (62395, '2021-01-31', 'NO', 'Norway', 'EURO', '299', '62575', '0', '563');
INSERT INTO public.who_global_data_import VALUES (62396, '2021-02-01', 'NO', 'Norway', 'EURO', '218', '62793', '0', '563');
INSERT INTO public.who_global_data_import VALUES (62397, '2021-02-02', 'NO', 'Norway', 'EURO', '173', '62966', '4', '567');
INSERT INTO public.who_global_data_import VALUES (62398, '2021-02-03', 'NO', 'Norway', 'EURO', '294', '63260', '1', '568');
INSERT INTO public.who_global_data_import VALUES (62399, '2021-02-04', 'NO', 'Norway', 'EURO', '293', '63553', '6', '574');
INSERT INTO public.who_global_data_import VALUES (62400, '2021-02-05', 'NO', 'Norway', 'EURO', '284', '63837', '8', '582');
INSERT INTO public.who_global_data_import VALUES (62401, '2020-01-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62402, '2020-01-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62403, '2020-01-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62404, '2020-01-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62405, '2020-01-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62406, '2020-01-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62407, '2020-01-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62408, '2020-01-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62409, '2020-01-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62410, '2020-01-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62411, '2020-01-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62412, '2020-01-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62413, '2020-01-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62414, '2020-01-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62415, '2020-01-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62416, '2020-01-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62417, '2020-01-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62418, '2020-01-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62419, '2020-01-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62420, '2020-01-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62421, '2020-01-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62422, '2020-01-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62423, '2020-01-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62424, '2020-01-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62425, '2020-01-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62426, '2020-01-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62427, '2020-01-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62428, '2020-01-30', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62429, '2020-01-31', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62430, '2020-02-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62431, '2020-02-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62432, '2020-02-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62433, '2020-02-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62434, '2020-02-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62435, '2020-02-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62436, '2020-02-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62437, '2020-02-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62438, '2020-02-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62439, '2020-02-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62440, '2020-02-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62441, '2020-02-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62442, '2020-02-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62443, '2020-02-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62444, '2020-02-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62445, '2020-02-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62446, '2020-02-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62447, '2020-02-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62448, '2020-02-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62449, '2020-02-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62450, '2020-02-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62451, '2020-02-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62452, '2020-02-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62453, '2020-02-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62454, '2020-02-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62455, '2020-02-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62456, '2020-02-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62457, '2020-02-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62458, '2020-02-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62459, '2020-03-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62460, '2020-03-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62461, '2020-03-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62462, '2020-03-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62463, '2020-03-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '11', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62464, '2020-03-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '9', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62465, '2020-03-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62466, '2020-03-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '3', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62467, '2020-03-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '6', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62468, '2020-03-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '4', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62469, '2020-03-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62470, '2020-03-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62471, '2020-03-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '4', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62472, '2020-03-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '3', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62473, '2020-03-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62474, '2020-03-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62475, '2020-03-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62476, '2020-03-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62477, '2020-03-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '6', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62478, '2020-03-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '-3', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62479, '2020-03-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '4', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62480, '2020-03-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '7', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62481, '2020-03-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62482, '2020-03-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62483, '2020-03-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62484, '2020-03-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '22', '84', '1', '1');
INSERT INTO public.who_global_data_import VALUES (62485, '2020-03-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '7', '91', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62486, '2020-03-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '6', '97', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62487, '2020-03-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '9', '106', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62488, '2020-03-30', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '9', '115', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62489, '2020-03-31', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2', '117', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62490, '2020-04-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '17', '134', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62491, '2020-04-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '21', '155', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62492, '2020-04-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '16', '171', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62493, '2020-04-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '34', '205', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62494, '2020-04-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '12', '217', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62495, '2020-04-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '36', '253', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62496, '2020-04-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '254', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62497, '2020-04-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '9', '263', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62498, '2020-04-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '263', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62499, '2020-04-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '3', '266', '1', '2');
INSERT INTO public.who_global_data_import VALUES (62500, '2020-04-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2', '268', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62501, '2020-04-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '268', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62502, '2020-04-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '5', '273', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62503, '2020-04-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '14', '287', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62845, '2020-02-16', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62504, '2020-04-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '4', '291', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62505, '2020-04-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '3', '294', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62506, '2020-04-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '13', '307', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62507, '2020-04-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '6', '313', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62508, '2020-04-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '9', '322', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62509, '2020-04-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '7', '329', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62510, '2020-04-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '329', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62511, '2020-04-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '6', '335', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62512, '2020-04-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '336', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62513, '2020-04-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '4', '340', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62514, '2020-04-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2', '342', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62515, '2020-04-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '342', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62516, '2020-04-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '342', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62517, '2020-04-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '343', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62518, '2020-04-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '343', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62519, '2020-04-30', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '344', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62520, '2020-05-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '9', '353', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62521, '2020-05-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '353', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62522, '2020-05-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '353', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62523, '2020-05-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '171', '524', '2', '4');
INSERT INTO public.who_global_data_import VALUES (62524, '2020-05-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '14', '538', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62525, '2020-05-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '8', '546', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62526, '2020-05-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '547', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62527, '2020-05-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '547', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62528, '2020-05-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '547', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62529, '2020-05-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '547', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62530, '2020-05-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '547', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62531, '2020-05-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '547', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62532, '2020-05-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '548', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62533, '2020-05-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '548', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62534, '2020-05-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '6', '554', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62535, '2020-05-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '554', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62536, '2020-05-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '6', '560', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62537, '2020-05-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '560', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62538, '2020-05-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '7', '567', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62539, '2020-05-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '10', '577', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62540, '2020-05-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '19', '596', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62541, '2020-05-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '6', '602', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62542, '2020-05-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '602', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62543, '2020-05-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '602', '1', '5');
INSERT INTO public.who_global_data_import VALUES (62544, '2020-05-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '602', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62545, '2020-05-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '602', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62546, '2020-05-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '3', '605', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62547, '2020-05-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '8', '613', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62548, '2020-05-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '12', '625', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62549, '2020-05-30', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '625', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62550, '2020-05-31', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '626', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62551, '2020-06-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '627', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62552, '2020-06-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1', '628', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62553, '2020-06-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2', '630', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62554, '2020-06-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '6', '636', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62555, '2020-06-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '7', '643', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62556, '2020-06-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '643', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62557, '2020-06-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '643', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62558, '2020-06-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '0', '643', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62559, '2020-06-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '9', '652', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62560, '2020-06-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '9', '661', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62561, '2020-06-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '4', '665', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62562, '2020-06-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2', '667', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62563, '2020-06-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2', '669', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62564, '2020-06-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '4', '673', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62565, '2020-06-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '3', '676', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62566, '2020-06-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '13', '689', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62567, '2020-06-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '6', '695', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62568, '2020-06-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '50', '745', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62846, '2020-02-17', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62569, '2020-06-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '50', '795', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62570, '2020-06-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '75', '870', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62571, '2020-06-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '109', '979', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62572, '2020-06-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '49', '1028', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62573, '2020-06-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '168', '1196', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62574, '2020-06-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '179', '1375', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62575, '2020-06-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '159', '1534', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62576, '2020-06-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '54', '1588', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62577, '2020-06-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '207', '1795', '0', '5');
INSERT INTO public.who_global_data_import VALUES (62578, '2020-06-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '258', '2053', '2', '7');
INSERT INTO public.who_global_data_import VALUES (62579, '2020-06-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '195', '2248', '0', '7');
INSERT INTO public.who_global_data_import VALUES (62580, '2020-06-30', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '195', '2443', '1', '8');
INSERT INTO public.who_global_data_import VALUES (62581, '2020-07-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '322', '2765', '3', '11');
INSERT INTO public.who_global_data_import VALUES (62582, '2020-07-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '330', '3095', '0', '11');
INSERT INTO public.who_global_data_import VALUES (62583, '2020-07-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '322', '3417', '0', '11');
INSERT INTO public.who_global_data_import VALUES (62584, '2020-07-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '272', '3689', '4', '15');
INSERT INTO public.who_global_data_import VALUES (62585, '2020-07-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '561', '4250', '4', '19');
INSERT INTO public.who_global_data_import VALUES (62586, '2020-07-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '472', '4722', '1', '20');
INSERT INTO public.who_global_data_import VALUES (62587, '2020-07-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '64', '4786', '1', '21');
INSERT INTO public.who_global_data_import VALUES (62588, '2020-07-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '306', '5092', '1', '22');
INSERT INTO public.who_global_data_import VALUES (62589, '2020-07-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '475', '5567', '2', '24');
INSERT INTO public.who_global_data_import VALUES (62590, '2020-07-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '262', '5829', '3', '27');
INSERT INTO public.who_global_data_import VALUES (62591, '2020-07-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '396', '6225', '3', '30');
INSERT INTO public.who_global_data_import VALUES (62592, '2020-07-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '463', '6688', '2', '32');
INSERT INTO public.who_global_data_import VALUES (62593, '2020-07-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '349', '7037', '7', '39');
INSERT INTO public.who_global_data_import VALUES (62594, '2020-07-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '404', '7441', '2', '41');
INSERT INTO public.who_global_data_import VALUES (62595, '2020-07-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '293', '7734', '6', '47');
INSERT INTO public.who_global_data_import VALUES (62596, '2020-07-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '419', '8153', '0', '47');
INSERT INTO public.who_global_data_import VALUES (62597, '2020-07-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '463', '8616', '5', '52');
INSERT INTO public.who_global_data_import VALUES (62598, '2020-07-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '439', '9055', '5', '57');
INSERT INTO public.who_global_data_import VALUES (62599, '2020-07-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '532', '9587', '5', '62');
INSERT INTO public.who_global_data_import VALUES (62600, '2020-07-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '465', '10052', '3', '65');
INSERT INTO public.who_global_data_import VALUES (62601, '2020-07-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '468', '10520', '1', '66');
INSERT INTO public.who_global_data_import VALUES (62602, '2020-07-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '403', '10923', '1', '67');
INSERT INTO public.who_global_data_import VALUES (62603, '2020-07-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '356', '11279', '2', '69');
INSERT INTO public.who_global_data_import VALUES (62604, '2020-07-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '596', '11875', '1', '70');
INSERT INTO public.who_global_data_import VALUES (62605, '2020-07-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '537', '12412', '3', '73');
INSERT INTO public.who_global_data_import VALUES (62606, '2020-07-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '383', '12795', '5', '78');
INSERT INTO public.who_global_data_import VALUES (62607, '2020-07-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '330', '13125', '1', '79');
INSERT INTO public.who_global_data_import VALUES (62608, '2020-07-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '332', '13457', '2', '81');
INSERT INTO public.who_global_data_import VALUES (62609, '2020-07-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '481', '13938', '0', '81');
INSERT INTO public.who_global_data_import VALUES (62610, '2020-07-30', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '520', '14458', '2', '83');
INSERT INTO public.who_global_data_import VALUES (62611, '2020-07-31', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '380', '14838', '1', '84');
INSERT INTO public.who_global_data_import VALUES (62612, '2020-08-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '394', '15232', '1', '85');
INSERT INTO public.who_global_data_import VALUES (62613, '2020-08-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '323', '15555', '1', '86');
INSERT INTO public.who_global_data_import VALUES (62614, '2020-08-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '225', '15780', '1', '87');
INSERT INTO public.who_global_data_import VALUES (62615, '2020-08-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '244', '16024', '0', '87');
INSERT INTO public.who_global_data_import VALUES (62616, '2020-08-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '604', '16628', '2', '89');
INSERT INTO public.who_global_data_import VALUES (62617, '2020-08-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '353', '16981', '3', '92');
INSERT INTO public.who_global_data_import VALUES (62618, '2020-08-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '453', '17434', '3', '95');
INSERT INTO public.who_global_data_import VALUES (62619, '2020-08-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '514', '17948', '2', '97');
INSERT INTO public.who_global_data_import VALUES (62620, '2020-08-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '426', '18374', '6', '103');
INSERT INTO public.who_global_data_import VALUES (62621, '2020-08-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '277', '18651', '0', '103');
INSERT INTO public.who_global_data_import VALUES (62622, '2020-08-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '470', '19121', '7', '110');
INSERT INTO public.who_global_data_import VALUES (62623, '2020-08-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '473', '19594', '4', '114');
INSERT INTO public.who_global_data_import VALUES (62624, '2020-08-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '499', '20093', '1', '115');
INSERT INTO public.who_global_data_import VALUES (62625, '2020-08-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '432', '20525', '1', '116');
INSERT INTO public.who_global_data_import VALUES (62626, '2020-08-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '531', '21056', '0', '116');
INSERT INTO public.who_global_data_import VALUES (62627, '2020-08-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '498', '21554', '3', '119');
INSERT INTO public.who_global_data_import VALUES (62628, '2020-08-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '381', '21935', '2', '121');
INSERT INTO public.who_global_data_import VALUES (62629, '2020-08-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '456', '22391', '2', '123');
INSERT INTO public.who_global_data_import VALUES (62630, '2020-08-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '612', '23003', '1', '124');
INSERT INTO public.who_global_data_import VALUES (62631, '2020-08-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '424', '23427', '3', '127');
INSERT INTO public.who_global_data_import VALUES (62632, '2020-08-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '503', '23930', '4', '131');
INSERT INTO public.who_global_data_import VALUES (62633, '2020-08-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '457', '24387', '4', '135');
INSERT INTO public.who_global_data_import VALUES (62847, '2020-02-18', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62634, '2020-08-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '311', '24698', '3', '138');
INSERT INTO public.who_global_data_import VALUES (62635, '2020-08-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '326', '25024', '5', '143');
INSERT INTO public.who_global_data_import VALUES (62636, '2020-08-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '553', '25577', '7', '150');
INSERT INTO public.who_global_data_import VALUES (62637, '2020-08-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '585', '26162', '0', '150');
INSERT INTO public.who_global_data_import VALUES (62638, '2020-08-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '602', '26764', '2', '152');
INSERT INTO public.who_global_data_import VALUES (62639, '2020-08-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '622', '27386', '6', '158');
INSERT INTO public.who_global_data_import VALUES (62640, '2020-08-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '724', '28110', '4', '162');
INSERT INTO public.who_global_data_import VALUES (62641, '2020-08-30', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '417', '28527', '2', '164');
INSERT INTO public.who_global_data_import VALUES (62642, '2020-08-31', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '536', '29063', '5', '169');
INSERT INTO public.who_global_data_import VALUES (62643, '2020-09-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '875', '29938', '4', '173');
INSERT INTO public.who_global_data_import VALUES (62644, '2020-09-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '552', '30490', '7', '180');
INSERT INTO public.who_global_data_import VALUES (62645, '2020-09-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '843', '31333', '4', '184');
INSERT INTO public.who_global_data_import VALUES (62646, '2020-09-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '596', '31929', '5', '189');
INSERT INTO public.who_global_data_import VALUES (62647, '2020-09-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '888', '32817', '3', '192');
INSERT INTO public.who_global_data_import VALUES (62648, '2020-09-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '433', '33250', '7', '199');
INSERT INTO public.who_global_data_import VALUES (62649, '2020-09-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '762', '34012', '4', '203');
INSERT INTO public.who_global_data_import VALUES (62650, '2020-09-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '789', '34801', '3', '206');
INSERT INTO public.who_global_data_import VALUES (62651, '2020-09-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '717', '35518', '9', '215');
INSERT INTO public.who_global_data_import VALUES (62652, '2020-09-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '696', '36214', '2', '217');
INSERT INTO public.who_global_data_import VALUES (62653, '2020-09-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1000', '37214', '7', '224');
INSERT INTO public.who_global_data_import VALUES (62654, '2020-09-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '652', '37866', '8', '232');
INSERT INTO public.who_global_data_import VALUES (62655, '2020-09-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '650', '38516', '6', '238');
INSERT INTO public.who_global_data_import VALUES (62656, '2020-09-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '994', '39510', '12', '250');
INSERT INTO public.who_global_data_import VALUES (62657, '2020-09-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '788', '40298', '5', '255');
INSERT INTO public.who_global_data_import VALUES (62658, '2020-09-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1118', '41416', '6', '261');
INSERT INTO public.who_global_data_import VALUES (62659, '2020-09-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '963', '42379', '15', '276');
INSERT INTO public.who_global_data_import VALUES (62660, '2020-09-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '966', '43345', '2', '278');
INSERT INTO public.who_global_data_import VALUES (62661, '2020-09-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '692', '44037', '8', '286');
INSERT INTO public.who_global_data_import VALUES (62662, '2020-09-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '726', '44763', '5', '291');
INSERT INTO public.who_global_data_import VALUES (62663, '2020-09-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '683', '45446', '9', '300');
INSERT INTO public.who_global_data_import VALUES (62664, '2020-09-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '611', '46057', '9', '309');
INSERT INTO public.who_global_data_import VALUES (62665, '2020-09-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '557', '46614', '5', '314');
INSERT INTO public.who_global_data_import VALUES (62666, '2020-09-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '503', '47117', '3', '317');
INSERT INTO public.who_global_data_import VALUES (62667, '2020-09-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '713', '47830', '5', '322');
INSERT INTO public.who_global_data_import VALUES (62668, '2020-09-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '452', '48282', '5', '327');
INSERT INTO public.who_global_data_import VALUES (62669, '2020-09-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '290', '48572', '7', '334');
INSERT INTO public.who_global_data_import VALUES (62670, '2020-09-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '620', '49192', '9', '343');
INSERT INTO public.who_global_data_import VALUES (62671, '2020-09-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '503', '49695', '10', '353');
INSERT INTO public.who_global_data_import VALUES (62672, '2020-09-30', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '420', '50115', '7', '360');
INSERT INTO public.who_global_data_import VALUES (62673, '2020-10-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '426', '50541', '8', '368');
INSERT INTO public.who_global_data_import VALUES (62674, '2020-10-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '521', '51062', '8', '376');
INSERT INTO public.who_global_data_import VALUES (62675, '2020-10-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '545', '51607', '3', '379');
INSERT INTO public.who_global_data_import VALUES (62676, '2020-10-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '406', '52013', '11', '390');
INSERT INTO public.who_global_data_import VALUES (62677, '2020-10-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '420', '52433', '1', '391');
INSERT INTO public.who_global_data_import VALUES (62678, '2020-10-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '521', '52954', '11', '402');
INSERT INTO public.who_global_data_import VALUES (62679, '2020-10-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '475', '53429', '10', '412');
INSERT INTO public.who_global_data_import VALUES (62680, '2020-10-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '510', '53939', '6', '418');
INSERT INTO public.who_global_data_import VALUES (62681, '2020-10-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '416', '54355', '4', '422');
INSERT INTO public.who_global_data_import VALUES (62682, '2020-10-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '498', '54853', '9', '431');
INSERT INTO public.who_global_data_import VALUES (62683, '2020-10-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '281', '55134', '11', '442');
INSERT INTO public.who_global_data_import VALUES (62684, '2020-10-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '422', '55556', '3', '445');
INSERT INTO public.who_global_data_import VALUES (62685, '2020-10-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '395', '55951', '10', '455');
INSERT INTO public.who_global_data_import VALUES (62686, '2020-10-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '516', '56467', '4', '459');
INSERT INTO public.who_global_data_import VALUES (62687, '2020-10-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '532', '56999', '4', '463');
INSERT INTO public.who_global_data_import VALUES (62688, '2020-10-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '442', '57441', '8', '471');
INSERT INTO public.who_global_data_import VALUES (62689, '2020-10-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '397', '57838', '1', '472');
INSERT INTO public.who_global_data_import VALUES (62690, '2020-10-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '312', '58150', '0', '472');
INSERT INTO public.who_global_data_import VALUES (62691, '2020-10-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '389', '58539', '6', '478');
INSERT INTO public.who_global_data_import VALUES (62692, '2020-10-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '543', '59082', '6', '484');
INSERT INTO public.who_global_data_import VALUES (62693, '2020-10-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '513', '59595', '8', '492');
INSERT INTO public.who_global_data_import VALUES (62694, '2020-10-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '569', '60164', '6', '498');
INSERT INTO public.who_global_data_import VALUES (62695, '2020-10-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '506', '60670', '8', '506');
INSERT INTO public.who_global_data_import VALUES (62696, '2020-10-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '513', '61183', '4', '510');
INSERT INTO public.who_global_data_import VALUES (62697, '2020-10-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '410', '61593', '4', '514');
INSERT INTO public.who_global_data_import VALUES (62698, '2020-10-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '453', '62046', '5', '519');
INSERT INTO public.who_global_data_import VALUES (62699, '2020-10-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '542', '62588', '6', '525');
INSERT INTO public.who_global_data_import VALUES (62700, '2020-10-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '576', '63164', '4', '529');
INSERT INTO public.who_global_data_import VALUES (62701, '2020-10-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '450', '63614', '8', '537');
INSERT INTO public.who_global_data_import VALUES (62702, '2020-10-30', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '623', '64237', '8', '545');
INSERT INTO public.who_global_data_import VALUES (62703, '2020-10-31', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '504', '64741', '8', '553');
INSERT INTO public.who_global_data_import VALUES (62704, '2020-11-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '521', '65262', '2', '555');
INSERT INTO public.who_global_data_import VALUES (62705, '2020-11-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '540', '65802', '6', '561');
INSERT INTO public.who_global_data_import VALUES (62706, '2020-11-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '749', '66551', '4', '565');
INSERT INTO public.who_global_data_import VALUES (62707, '2020-11-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '633', '67184', '8', '573');
INSERT INTO public.who_global_data_import VALUES (62708, '2020-11-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '734', '67918', '3', '576');
INSERT INTO public.who_global_data_import VALUES (62709, '2020-11-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '582', '68500', '4', '580');
INSERT INTO public.who_global_data_import VALUES (62710, '2020-11-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '681', '69181', '3', '583');
INSERT INTO public.who_global_data_import VALUES (62711, '2020-11-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '431', '69612', '1', '584');
INSERT INTO public.who_global_data_import VALUES (62712, '2020-11-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '549', '70161', '3', '587');
INSERT INTO public.who_global_data_import VALUES (62713, '2020-11-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '680', '70841', '6', '593');
INSERT INTO public.who_global_data_import VALUES (62714, '2020-11-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '660', '71501', '14', '607');
INSERT INTO public.who_global_data_import VALUES (62715, '2020-11-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '643', '72144', '5', '612');
INSERT INTO public.who_global_data_import VALUES (62716, '2020-11-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '823', '72967', '5', '617');
INSERT INTO public.who_global_data_import VALUES (62717, '2020-11-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '730', '73697', '6', '623');
INSERT INTO public.who_global_data_import VALUES (62718, '2020-11-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '653', '74350', '10', '633');
INSERT INTO public.who_global_data_import VALUES (62719, '2020-11-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '976', '75326', '7', '640');
INSERT INTO public.who_global_data_import VALUES (62720, '2020-11-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '836', '76162', '7', '647');
INSERT INTO public.who_global_data_import VALUES (62721, '2020-11-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1158', '77320', '11', '658');
INSERT INTO public.who_global_data_import VALUES (62722, '2020-11-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1251', '78571', '9', '667');
INSERT INTO public.who_global_data_import VALUES (62723, '2020-11-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1251', '79822', '9', '676');
INSERT INTO public.who_global_data_import VALUES (62724, '2020-11-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1472', '81294', '8', '684');
INSERT INTO public.who_global_data_import VALUES (62725, '2020-11-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1486', '82780', '14', '698');
INSERT INTO public.who_global_data_import VALUES (62726, '2020-11-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1560', '84340', '16', '714');
INSERT INTO public.who_global_data_import VALUES (62727, '2020-11-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1552', '85892', '9', '723');
INSERT INTO public.who_global_data_import VALUES (62728, '2020-11-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1946', '87838', '17', '740');
INSERT INTO public.who_global_data_import VALUES (62729, '2020-11-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1720', '89558', '9', '749');
INSERT INTO public.who_global_data_import VALUES (62730, '2020-11-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1906', '91464', '18', '767');
INSERT INTO public.who_global_data_import VALUES (62731, '2020-11-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1936', '93400', '9', '776');
INSERT INTO public.who_global_data_import VALUES (62732, '2020-11-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1461', '94861', '15', '791');
INSERT INTO public.who_global_data_import VALUES (62733, '2020-11-30', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1927', '96788', '16', '807');
INSERT INTO public.who_global_data_import VALUES (62734, '2020-12-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2062', '98850', '15', '822');
INSERT INTO public.who_global_data_import VALUES (62735, '2020-12-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2536', '101386', '16', '838');
INSERT INTO public.who_global_data_import VALUES (62736, '2020-12-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2188', '103574', '16', '854');
INSERT INTO public.who_global_data_import VALUES (62737, '2020-12-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2738', '106312', '19', '873');
INSERT INTO public.who_global_data_import VALUES (62738, '2020-12-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1968', '108280', '17', '890');
INSERT INTO public.who_global_data_import VALUES (62739, '2020-12-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1422', '109702', '15', '905');
INSERT INTO public.who_global_data_import VALUES (62740, '2020-12-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2333', '112035', '17', '922');
INSERT INTO public.who_global_data_import VALUES (62741, '2020-12-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1720', '113755', '20', '942');
INSERT INTO public.who_global_data_import VALUES (62742, '2020-12-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1595', '115350', '19', '961');
INSERT INTO public.who_global_data_import VALUES (62743, '2020-12-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1883', '117233', '23', '984');
INSERT INTO public.who_global_data_import VALUES (62744, '2020-12-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2181', '119414', '24', '1008');
INSERT INTO public.who_global_data_import VALUES (62745, '2020-12-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1743', '121157', '21', '1029');
INSERT INTO public.who_global_data_import VALUES (62746, '2020-12-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1845', '123002', '33', '1062');
INSERT INTO public.who_global_data_import VALUES (62747, '2020-12-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1639', '124641', '17', '1079');
INSERT INTO public.who_global_data_import VALUES (62748, '2020-12-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1564', '126205', '28', '1107');
INSERT INTO public.who_global_data_import VALUES (62749, '2020-12-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2307', '128512', '23', '1130');
INSERT INTO public.who_global_data_import VALUES (62750, '2020-12-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2525', '131037', '26', '1156');
INSERT INTO public.who_global_data_import VALUES (62751, '2020-12-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2149', '133186', '30', '1186');
INSERT INTO public.who_global_data_import VALUES (62752, '2020-12-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2170', '135356', '21', '1207');
INSERT INTO public.who_global_data_import VALUES (62753, '2020-12-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1750', '137106', '25', '1232');
INSERT INTO public.who_global_data_import VALUES (62754, '2020-12-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1427', '138533', '24', '1256');
INSERT INTO public.who_global_data_import VALUES (62755, '2020-12-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1514', '140047', '31', '1287');
INSERT INTO public.who_global_data_import VALUES (62756, '2020-12-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1561', '141608', '29', '1316');
INSERT INTO public.who_global_data_import VALUES (62757, '2020-12-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '2110', '143718', '31', '1347');
INSERT INTO public.who_global_data_import VALUES (62758, '2020-12-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1704', '145422', '17', '1364');
INSERT INTO public.who_global_data_import VALUES (62759, '2020-12-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1812', '147234', '21', '1385');
INSERT INTO public.who_global_data_import VALUES (62760, '2020-12-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1306', '148540', '21', '1406');
INSERT INTO public.who_global_data_import VALUES (62761, '2020-12-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1506', '150046', '28', '1434');
INSERT INTO public.who_global_data_import VALUES (62762, '2020-12-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1363', '151409', '26', '1460');
INSERT INTO public.who_global_data_import VALUES (62763, '2020-12-30', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1149', '152558', '19', '1479');
INSERT INTO public.who_global_data_import VALUES (62764, '2020-12-31', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1539', '154097', '21', '1500');
INSERT INTO public.who_global_data_import VALUES (62765, '2021-01-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1268', '155365', '29', '1529');
INSERT INTO public.who_global_data_import VALUES (62766, '2021-01-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1450', '156815', '21', '1550');
INSERT INTO public.who_global_data_import VALUES (62767, '2021-01-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1064', '157879', '28', '1578');
INSERT INTO public.who_global_data_import VALUES (62768, '2021-01-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1155', '159034', '31', '1609');
INSERT INTO public.who_global_data_import VALUES (62769, '2021-01-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1009', '160043', '20', '1629');
INSERT INTO public.who_global_data_import VALUES (62770, '2021-01-06', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1191', '161234', '20', '1649');
INSERT INTO public.who_global_data_import VALUES (62771, '2021-01-07', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1088', '162322', '14', '1663');
INSERT INTO public.who_global_data_import VALUES (62772, '2021-01-08', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '1251', '163573', '21', '1684');
INSERT INTO public.who_global_data_import VALUES (62773, '2021-01-09', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '822', '164395', '23', '1707');
INSERT INTO public.who_global_data_import VALUES (62774, '2021-01-10', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '855', '165250', '28', '1735');
INSERT INTO public.who_global_data_import VALUES (62775, '2021-01-11', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '699', '165949', '21', '1756');
INSERT INTO public.who_global_data_import VALUES (62776, '2021-01-12', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '928', '166877', '12', '1768');
INSERT INTO public.who_global_data_import VALUES (62777, '2021-01-13', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '797', '167674', '16', '1784');
INSERT INTO public.who_global_data_import VALUES (62778, '2021-01-14', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '978', '168652', '30', '1814');
INSERT INTO public.who_global_data_import VALUES (62779, '2021-01-15', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '736', '169388', '7', '1821');
INSERT INTO public.who_global_data_import VALUES (62780, '2021-01-16', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '822', '170210', '27', '1848');
INSERT INTO public.who_global_data_import VALUES (62781, '2021-01-17', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '427', '170637', '13', '1861');
INSERT INTO public.who_global_data_import VALUES (62782, '2021-01-18', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '578', '171215', '20', '1881');
INSERT INTO public.who_global_data_import VALUES (62783, '2021-01-19', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '524', '171739', '8', '1889');
INSERT INTO public.who_global_data_import VALUES (62784, '2021-01-20', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '660', '172399', '19', '1908');
INSERT INTO public.who_global_data_import VALUES (62785, '2021-01-21', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '497', '172896', '10', '1918');
INSERT INTO public.who_global_data_import VALUES (62786, '2021-01-22', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '574', '173470', '7', '1925');
INSERT INTO public.who_global_data_import VALUES (62787, '2021-01-23', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '494', '173964', '12', '1937');
INSERT INTO public.who_global_data_import VALUES (62788, '2021-01-24', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '449', '174413', '14', '1951');
INSERT INTO public.who_global_data_import VALUES (62789, '2021-01-25', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '533', '174946', '11', '1962');
INSERT INTO public.who_global_data_import VALUES (62790, '2021-01-26', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '470', '175416', '5', '1967');
INSERT INTO public.who_global_data_import VALUES (62791, '2021-01-27', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '660', '176076', '10', '1977');
INSERT INTO public.who_global_data_import VALUES (62792, '2021-01-28', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '603', '176679', '5', '1982');
INSERT INTO public.who_global_data_import VALUES (62793, '2021-01-29', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '747', '177426', '8', '1990');
INSERT INTO public.who_global_data_import VALUES (62794, '2021-01-30', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '575', '178001', '11', '2001');
INSERT INTO public.who_global_data_import VALUES (62795, '2021-01-31', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '515', '178516', '9', '2010');
INSERT INTO public.who_global_data_import VALUES (62796, '2021-02-01', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '403', '178919', '2', '2012');
INSERT INTO public.who_global_data_import VALUES (62797, '2021-02-02', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '586', '179505', '11', '2023');
INSERT INTO public.who_global_data_import VALUES (62798, '2021-02-03', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '513', '180018', '9', '2032');
INSERT INTO public.who_global_data_import VALUES (62799, '2021-02-04', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '670', '180688', '10', '2042');
INSERT INTO public.who_global_data_import VALUES (62800, '2021-02-05', 'PS', 'occupied Palestinian territory, including east Jerusalem', 'EMRO', '661', '181349', '8', '2050');
INSERT INTO public.who_global_data_import VALUES (62801, '2020-01-03', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62802, '2020-01-04', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62803, '2020-01-05', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62804, '2020-01-06', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62805, '2020-01-07', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62806, '2020-01-08', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62807, '2020-01-09', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62808, '2020-01-10', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62809, '2020-01-11', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62810, '2020-01-12', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62811, '2020-01-13', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62812, '2020-01-14', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62813, '2020-01-15', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62814, '2020-01-16', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62815, '2020-01-17', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62816, '2020-01-18', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62817, '2020-01-19', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62818, '2020-01-20', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62819, '2020-01-21', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62820, '2020-01-22', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62821, '2020-01-23', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62822, '2020-01-24', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62823, '2020-01-25', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62824, '2020-01-26', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62825, '2020-01-27', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62826, '2020-01-28', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62827, '2020-01-29', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62828, '2020-01-30', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62829, '2020-01-31', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62830, '2020-02-01', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62831, '2020-02-02', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62832, '2020-02-03', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62833, '2020-02-04', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62834, '2020-02-05', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62835, '2020-02-06', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62836, '2020-02-07', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62837, '2020-02-08', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62838, '2020-02-09', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62839, '2020-02-10', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62840, '2020-02-11', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62841, '2020-02-12', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62842, '2020-02-13', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62843, '2020-02-14', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62844, '2020-02-15', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62848, '2020-02-19', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62849, '2020-02-20', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62850, '2020-02-21', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62851, '2020-02-22', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62852, '2020-02-23', 'OM', 'Oman', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62853, '2020-02-24', 'OM', 'Oman', 'EMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62854, '2020-02-25', 'OM', 'Oman', 'EMRO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62855, '2020-02-26', 'OM', 'Oman', 'EMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62856, '2020-02-27', 'OM', 'Oman', 'EMRO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62857, '2020-02-28', 'OM', 'Oman', 'EMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62858, '2020-02-29', 'OM', 'Oman', 'EMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62859, '2020-03-01', 'OM', 'Oman', 'EMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62860, '2020-03-02', 'OM', 'Oman', 'EMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62861, '2020-03-03', 'OM', 'Oman', 'EMRO', '6', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62862, '2020-03-04', 'OM', 'Oman', 'EMRO', '3', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62863, '2020-03-05', 'OM', 'Oman', 'EMRO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62864, '2020-03-06', 'OM', 'Oman', 'EMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62865, '2020-03-07', 'OM', 'Oman', 'EMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62866, '2020-03-08', 'OM', 'Oman', 'EMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62867, '2020-03-09', 'OM', 'Oman', 'EMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62868, '2020-03-10', 'OM', 'Oman', 'EMRO', '2', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62869, '2020-03-11', 'OM', 'Oman', 'EMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62870, '2020-03-12', 'OM', 'Oman', 'EMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62871, '2020-03-13', 'OM', 'Oman', 'EMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62872, '2020-03-14', 'OM', 'Oman', 'EMRO', '2', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62873, '2020-03-15', 'OM', 'Oman', 'EMRO', '2', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62874, '2020-03-16', 'OM', 'Oman', 'EMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62875, '2020-03-17', 'OM', 'Oman', 'EMRO', '2', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62876, '2020-03-18', 'OM', 'Oman', 'EMRO', '9', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62877, '2020-03-19', 'OM', 'Oman', 'EMRO', '6', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62878, '2020-03-20', 'OM', 'Oman', 'EMRO', '5', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62879, '2020-03-21', 'OM', 'Oman', 'EMRO', '4', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62880, '2020-03-22', 'OM', 'Oman', 'EMRO', '3', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62881, '2020-03-23', 'OM', 'Oman', 'EMRO', '11', '66', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62882, '2020-03-24', 'OM', 'Oman', 'EMRO', '18', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62883, '2020-03-25', 'OM', 'Oman', 'EMRO', '15', '99', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62884, '2020-03-26', 'OM', 'Oman', 'EMRO', '10', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62885, '2020-03-27', 'OM', 'Oman', 'EMRO', '22', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62886, '2020-03-28', 'OM', 'Oman', 'EMRO', '21', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62887, '2020-03-29', 'OM', 'Oman', 'EMRO', '15', '167', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62888, '2020-03-30', 'OM', 'Oman', 'EMRO', '12', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62889, '2020-03-31', 'OM', 'Oman', 'EMRO', '13', '192', '0', '0');
INSERT INTO public.who_global_data_import VALUES (62890, '2020-04-01', 'OM', 'Oman', 'EMRO', '18', '210', '1', '1');
INSERT INTO public.who_global_data_import VALUES (62891, '2020-04-02', 'OM', 'Oman', 'EMRO', '21', '231', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62892, '2020-04-03', 'OM', 'Oman', 'EMRO', '21', '252', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62893, '2020-04-04', 'OM', 'Oman', 'EMRO', '25', '277', '0', '1');
INSERT INTO public.who_global_data_import VALUES (62894, '2020-04-05', 'OM', 'Oman', 'EMRO', '21', '298', '1', '2');
INSERT INTO public.who_global_data_import VALUES (62895, '2020-04-06', 'OM', 'Oman', 'EMRO', '33', '331', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62896, '2020-04-07', 'OM', 'Oman', 'EMRO', '40', '371', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62897, '2020-04-08', 'OM', 'Oman', 'EMRO', '48', '419', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62898, '2020-04-09', 'OM', 'Oman', 'EMRO', '38', '457', '0', '2');
INSERT INTO public.who_global_data_import VALUES (62899, '2020-04-10', 'OM', 'Oman', 'EMRO', '27', '484', '1', '3');
INSERT INTO public.who_global_data_import VALUES (62900, '2020-04-11', 'OM', 'Oman', 'EMRO', '62', '546', '0', '3');
INSERT INTO public.who_global_data_import VALUES (62901, '2020-04-12', 'OM', 'Oman', 'EMRO', '53', '599', '1', '4');
INSERT INTO public.who_global_data_import VALUES (62902, '2020-04-13', 'OM', 'Oman', 'EMRO', '128', '727', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62903, '2020-04-14', 'OM', 'Oman', 'EMRO', '86', '813', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62904, '2020-04-15', 'OM', 'Oman', 'EMRO', '97', '910', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62905, '2020-04-16', 'OM', 'Oman', 'EMRO', '109', '1019', '0', '4');
INSERT INTO public.who_global_data_import VALUES (62906, '2020-04-17', 'OM', 'Oman', 'EMRO', '50', '1069', '1', '5');
INSERT INTO public.who_global_data_import VALUES (62907, '2020-04-18', 'OM', 'Oman', 'EMRO', '111', '1180', '1', '6');
INSERT INTO public.who_global_data_import VALUES (62908, '2020-04-19', 'OM', 'Oman', 'EMRO', '86', '1266', '0', '6');
INSERT INTO public.who_global_data_import VALUES (62909, '2020-04-20', 'OM', 'Oman', 'EMRO', '144', '1410', '1', '7');
INSERT INTO public.who_global_data_import VALUES (62910, '2020-04-21', 'OM', 'Oman', 'EMRO', '98', '1508', '1', '8');
INSERT INTO public.who_global_data_import VALUES (62911, '2020-04-22', 'OM', 'Oman', 'EMRO', '106', '1614', '0', '8');
INSERT INTO public.who_global_data_import VALUES (62912, '2020-04-23', 'OM', 'Oman', 'EMRO', '102', '1716', '0', '8');
INSERT INTO public.who_global_data_import VALUES (62913, '2020-04-24', 'OM', 'Oman', 'EMRO', '74', '1790', '1', '9');
INSERT INTO public.who_global_data_import VALUES (62914, '2020-04-25', 'OM', 'Oman', 'EMRO', '115', '1905', '1', '10');
INSERT INTO public.who_global_data_import VALUES (62915, '2020-04-26', 'OM', 'Oman', 'EMRO', '93', '1998', '0', '10');
INSERT INTO public.who_global_data_import VALUES (62916, '2020-04-27', 'OM', 'Oman', 'EMRO', '51', '2049', '0', '10');
INSERT INTO public.who_global_data_import VALUES (62917, '2020-04-28', 'OM', 'Oman', 'EMRO', '82', '2131', '0', '10');
INSERT INTO public.who_global_data_import VALUES (62918, '2020-04-29', 'OM', 'Oman', 'EMRO', '143', '2274', '0', '10');
INSERT INTO public.who_global_data_import VALUES (62919, '2020-04-30', 'OM', 'Oman', 'EMRO', '74', '2348', '1', '11');
INSERT INTO public.who_global_data_import VALUES (62920, '2020-05-01', 'OM', 'Oman', 'EMRO', '99', '2447', '0', '11');
INSERT INTO public.who_global_data_import VALUES (62921, '2020-05-02', 'OM', 'Oman', 'EMRO', '36', '2483', '1', '12');
INSERT INTO public.who_global_data_import VALUES (62922, '2020-05-03', 'OM', 'Oman', 'EMRO', '85', '2568', '0', '12');
INSERT INTO public.who_global_data_import VALUES (62923, '2020-05-04', 'OM', 'Oman', 'EMRO', '69', '2637', '0', '12');
INSERT INTO public.who_global_data_import VALUES (62924, '2020-05-05', 'OM', 'Oman', 'EMRO', '98', '2735', '0', '12');
INSERT INTO public.who_global_data_import VALUES (62925, '2020-05-06', 'OM', 'Oman', 'EMRO', '168', '2903', '1', '13');
INSERT INTO public.who_global_data_import VALUES (62926, '2020-05-07', 'OM', 'Oman', 'EMRO', '55', '2958', '1', '14');
INSERT INTO public.who_global_data_import VALUES (62927, '2020-05-08', 'OM', 'Oman', 'EMRO', '154', '3112', '1', '15');
INSERT INTO public.who_global_data_import VALUES (62928, '2020-05-09', 'OM', 'Oman', 'EMRO', '112', '3224', '2', '17');
INSERT INTO public.who_global_data_import VALUES (62929, '2020-05-10', 'OM', 'Oman', 'EMRO', '176', '3400', '0', '17');
INSERT INTO public.who_global_data_import VALUES (62930, '2020-05-11', 'OM', 'Oman', 'EMRO', '174', '3574', '0', '17');
INSERT INTO public.who_global_data_import VALUES (62931, '2020-05-12', 'OM', 'Oman', 'EMRO', '147', '3721', '0', '17');
INSERT INTO public.who_global_data_import VALUES (62932, '2020-05-13', 'OM', 'Oman', 'EMRO', '298', '4019', '0', '17');
INSERT INTO public.who_global_data_import VALUES (62933, '2020-05-14', 'OM', 'Oman', 'EMRO', '322', '4341', '0', '17');
INSERT INTO public.who_global_data_import VALUES (62934, '2020-05-15', 'OM', 'Oman', 'EMRO', '284', '4625', '3', '20');
INSERT INTO public.who_global_data_import VALUES (62935, '2020-05-16', 'OM', 'Oman', 'EMRO', '404', '5029', '1', '21');
INSERT INTO public.who_global_data_import VALUES (62936, '2020-05-17', 'OM', 'Oman', 'EMRO', '157', '5186', '1', '22');
INSERT INTO public.who_global_data_import VALUES (62937, '2020-05-18', 'OM', 'Oman', 'EMRO', '193', '5379', '1', '23');
INSERT INTO public.who_global_data_import VALUES (62938, '2020-05-19', 'OM', 'Oman', 'EMRO', '292', '5671', '4', '27');
INSERT INTO public.who_global_data_import VALUES (62939, '2020-05-20', 'OM', 'Oman', 'EMRO', '372', '6043', '2', '29');
INSERT INTO public.who_global_data_import VALUES (62940, '2020-05-21', 'OM', 'Oman', 'EMRO', '327', '6370', '1', '30');
INSERT INTO public.who_global_data_import VALUES (62941, '2020-05-22', 'OM', 'Oman', 'EMRO', '0', '6370', '2', '32');
INSERT INTO public.who_global_data_import VALUES (62942, '2020-05-23', 'OM', 'Oman', 'EMRO', '424', '6794', '2', '34');
INSERT INTO public.who_global_data_import VALUES (62943, '2020-05-24', 'OM', 'Oman', 'EMRO', '463', '7257', '2', '36');
INSERT INTO public.who_global_data_import VALUES (62944, '2020-05-25', 'OM', 'Oman', 'EMRO', '513', '7770', '1', '37');
INSERT INTO public.who_global_data_import VALUES (62945, '2020-05-26', 'OM', 'Oman', 'EMRO', '0', '7770', '0', '37');
INSERT INTO public.who_global_data_import VALUES (62946, '2020-05-27', 'OM', 'Oman', 'EMRO', '348', '8118', '0', '37');
INSERT INTO public.who_global_data_import VALUES (62947, '2020-05-28', 'OM', 'Oman', 'EMRO', '255', '8373', '2', '39');
INSERT INTO public.who_global_data_import VALUES (62948, '2020-05-29', 'OM', 'Oman', 'EMRO', '636', '9009', '1', '40');
INSERT INTO public.who_global_data_import VALUES (62949, '2020-05-30', 'OM', 'Oman', 'EMRO', '811', '9820', '1', '41');
INSERT INTO public.who_global_data_import VALUES (62950, '2020-05-31', 'OM', 'Oman', 'EMRO', '603', '10423', '1', '42');
INSERT INTO public.who_global_data_import VALUES (62951, '2020-06-01', 'OM', 'Oman', 'EMRO', '1014', '11437', '7', '49');
INSERT INTO public.who_global_data_import VALUES (62952, '2020-06-02', 'OM', 'Oman', 'EMRO', '786', '12223', '1', '50');
INSERT INTO public.who_global_data_import VALUES (62953, '2020-06-03', 'OM', 'Oman', 'EMRO', '576', '12799', '9', '59');
INSERT INTO public.who_global_data_import VALUES (62954, '2020-06-04', 'OM', 'Oman', 'EMRO', '738', '13537', '8', '67');
INSERT INTO public.who_global_data_import VALUES (62955, '2020-06-05', 'OM', 'Oman', 'EMRO', '779', '14316', '0', '67');
INSERT INTO public.who_global_data_import VALUES (62956, '2020-06-06', 'OM', 'Oman', 'EMRO', '770', '15086', '5', '72');
INSERT INTO public.who_global_data_import VALUES (62957, '2020-06-07', 'OM', 'Oman', 'EMRO', '930', '16016', '0', '72');
INSERT INTO public.who_global_data_import VALUES (62958, '2020-06-08', 'OM', 'Oman', 'EMRO', '866', '16882', '3', '75');
INSERT INTO public.who_global_data_import VALUES (62959, '2020-06-09', 'OM', 'Oman', 'EMRO', '604', '17486', '6', '81');
INSERT INTO public.who_global_data_import VALUES (62960, '2020-06-10', 'OM', 'Oman', 'EMRO', '712', '18198', '2', '83');
INSERT INTO public.who_global_data_import VALUES (62961, '2020-06-11', 'OM', 'Oman', 'EMRO', '689', '18887', '1', '84');
INSERT INTO public.who_global_data_import VALUES (62962, '2020-06-12', 'OM', 'Oman', 'EMRO', '1067', '19954', '5', '89');
INSERT INTO public.who_global_data_import VALUES (62963, '2020-06-13', 'OM', 'Oman', 'EMRO', '1117', '21071', '7', '96');
INSERT INTO public.who_global_data_import VALUES (62964, '2020-06-14', 'OM', 'Oman', 'EMRO', '1006', '22077', '3', '99');
INSERT INTO public.who_global_data_import VALUES (62965, '2020-06-15', 'OM', 'Oman', 'EMRO', '1404', '23481', '5', '104');
INSERT INTO public.who_global_data_import VALUES (62966, '2020-06-16', 'OM', 'Oman', 'EMRO', '1043', '24524', '4', '108');
INSERT INTO public.who_global_data_import VALUES (62967, '2020-06-17', 'OM', 'Oman', 'EMRO', '745', '25269', '6', '114');
INSERT INTO public.who_global_data_import VALUES (62968, '2020-06-18', 'OM', 'Oman', 'EMRO', '810', '26079', '2', '116');
INSERT INTO public.who_global_data_import VALUES (62969, '2020-06-19', 'OM', 'Oman', 'EMRO', '739', '26818', '3', '119');
INSERT INTO public.who_global_data_import VALUES (62970, '2020-06-20', 'OM', 'Oman', 'EMRO', '852', '27670', '6', '125');
INSERT INTO public.who_global_data_import VALUES (62971, '2020-06-21', 'OM', 'Oman', 'EMRO', '896', '28566', '3', '128');
INSERT INTO public.who_global_data_import VALUES (62972, '2020-06-22', 'OM', 'Oman', 'EMRO', '905', '29471', '3', '131');
INSERT INTO public.who_global_data_import VALUES (62973, '2020-06-23', 'OM', 'Oman', 'EMRO', '1605', '31076', '6', '137');
INSERT INTO public.who_global_data_import VALUES (62974, '2020-06-24', 'OM', 'Oman', 'EMRO', '1318', '32394', '3', '140');
INSERT INTO public.who_global_data_import VALUES (62975, '2020-06-25', 'OM', 'Oman', 'EMRO', '1142', '33536', '2', '142');
INSERT INTO public.who_global_data_import VALUES (62976, '2020-06-26', 'OM', 'Oman', 'EMRO', '1366', '34902', '2', '144');
INSERT INTO public.who_global_data_import VALUES (62977, '2020-06-27', 'OM', 'Oman', 'EMRO', '1132', '36034', '9', '153');
INSERT INTO public.who_global_data_import VALUES (62978, '2020-06-28', 'OM', 'Oman', 'EMRO', '919', '36953', '6', '159');
INSERT INTO public.who_global_data_import VALUES (62979, '2020-06-29', 'OM', 'Oman', 'EMRO', '1197', '38150', '4', '163');
INSERT INTO public.who_global_data_import VALUES (62980, '2020-06-30', 'OM', 'Oman', 'EMRO', '910', '39060', '6', '169');
INSERT INTO public.who_global_data_import VALUES (62981, '2020-07-01', 'OM', 'Oman', 'EMRO', '1010', '40070', '7', '176');
INSERT INTO public.who_global_data_import VALUES (62982, '2020-07-02', 'OM', 'Oman', 'EMRO', '1124', '41194', '9', '185');
INSERT INTO public.who_global_data_import VALUES (62983, '2020-07-03', 'OM', 'Oman', 'EMRO', '1361', '42555', '3', '188');
INSERT INTO public.who_global_data_import VALUES (62984, '2020-07-04', 'OM', 'Oman', 'EMRO', '1374', '43929', '5', '193');
INSERT INTO public.who_global_data_import VALUES (62985, '2020-07-05', 'OM', 'Oman', 'EMRO', '1177', '45106', '10', '203');
INSERT INTO public.who_global_data_import VALUES (62986, '2020-07-06', 'OM', 'Oman', 'EMRO', '1072', '46178', '10', '213');
INSERT INTO public.who_global_data_import VALUES (62987, '2020-07-07', 'OM', 'Oman', 'EMRO', '1557', '47735', '5', '218');
INSERT INTO public.who_global_data_import VALUES (62988, '2020-07-08', 'OM', 'Oman', 'EMRO', '1262', '48997', '6', '224');
INSERT INTO public.who_global_data_import VALUES (62989, '2020-07-09', 'OM', 'Oman', 'EMRO', '1210', '50207', '9', '233');
INSERT INTO public.who_global_data_import VALUES (62990, '2020-07-10', 'OM', 'Oman', 'EMRO', '1518', '51725', '3', '236');
INSERT INTO public.who_global_data_import VALUES (62991, '2020-07-11', 'OM', 'Oman', 'EMRO', '1889', '53614', '8', '244');
INSERT INTO public.who_global_data_import VALUES (62992, '2020-07-12', 'OM', 'Oman', 'EMRO', '1083', '54697', '4', '248');
INSERT INTO public.who_global_data_import VALUES (62993, '2020-07-13', 'OM', 'Oman', 'EMRO', '1318', '56015', '9', '257');
INSERT INTO public.who_global_data_import VALUES (62994, '2020-07-14', 'OM', 'Oman', 'EMRO', '2164', '58179', '2', '259');
INSERT INTO public.who_global_data_import VALUES (62995, '2020-07-15', 'OM', 'Oman', 'EMRO', '1389', '59568', '14', '273');
INSERT INTO public.who_global_data_import VALUES (62996, '2020-07-16', 'OM', 'Oman', 'EMRO', '1679', '61247', '8', '281');
INSERT INTO public.who_global_data_import VALUES (62997, '2020-07-17', 'OM', 'Oman', 'EMRO', '1327', '62574', '9', '290');
INSERT INTO public.who_global_data_import VALUES (62998, '2020-07-18', 'OM', 'Oman', 'EMRO', '1619', '64193', '8', '298');
INSERT INTO public.who_global_data_import VALUES (62999, '2020-07-19', 'OM', 'Oman', 'EMRO', '1311', '65504', '10', '308');
INSERT INTO public.who_global_data_import VALUES (63000, '2020-07-20', 'OM', 'Oman', 'EMRO', '1157', '66661', '10', '318');
INSERT INTO public.who_global_data_import VALUES (63001, '2020-07-21', 'OM', 'Oman', 'EMRO', '1739', '68400', '8', '326');
INSERT INTO public.who_global_data_import VALUES (63002, '2020-07-22', 'OM', 'Oman', 'EMRO', '1487', '69887', '11', '337');
INSERT INTO public.who_global_data_import VALUES (63003, '2020-07-23', 'OM', 'Oman', 'EMRO', '1660', '71547', '12', '349');
INSERT INTO public.who_global_data_import VALUES (63004, '2020-07-24', 'OM', 'Oman', 'EMRO', '1099', '72646', '6', '355');
INSERT INTO public.who_global_data_import VALUES (63005, '2020-07-25', 'OM', 'Oman', 'EMRO', '1145', '73791', '4', '359');
INSERT INTO public.who_global_data_import VALUES (63006, '2020-07-26', 'OM', 'Oman', 'EMRO', '1067', '74858', '12', '371');
INSERT INTO public.who_global_data_import VALUES (63007, '2020-07-27', 'OM', 'Oman', 'EMRO', '1147', '76005', '13', '384');
INSERT INTO public.who_global_data_import VALUES (63008, '2020-07-28', 'OM', 'Oman', 'EMRO', '1053', '77058', '9', '393');
INSERT INTO public.who_global_data_import VALUES (63009, '2020-07-29', 'OM', 'Oman', 'EMRO', '846', '77904', '9', '402');
INSERT INTO public.who_global_data_import VALUES (63010, '2020-07-30', 'OM', 'Oman', 'EMRO', '665', '78569', '10', '412');
INSERT INTO public.who_global_data_import VALUES (63011, '2020-07-31', 'OM', 'Oman', 'EMRO', '590', '79159', '9', '421');
INSERT INTO public.who_global_data_import VALUES (63012, '2020-08-01', 'OM', 'Oman', 'EMRO', '0', '79159', '0', '421');
INSERT INTO public.who_global_data_import VALUES (63013, '2020-08-02', 'OM', 'Oman', 'EMRO', '0', '79159', '0', '421');
INSERT INTO public.who_global_data_import VALUES (63014, '2020-08-03', 'OM', 'Oman', 'EMRO', '0', '79159', '0', '421');
INSERT INTO public.who_global_data_import VALUES (63015, '2020-08-04', 'OM', 'Oman', 'EMRO', '542', '79701', '62', '483');
INSERT INTO public.who_global_data_import VALUES (63016, '2020-08-05', 'OM', 'Oman', 'EMRO', '0', '79701', '0', '483');
INSERT INTO public.who_global_data_import VALUES (63017, '2020-08-06', 'OM', 'Oman', 'EMRO', '585', '80286', '5', '488');
INSERT INTO public.who_global_data_import VALUES (63018, '2020-08-07', 'OM', 'Oman', 'EMRO', '427', '80713', '4', '492');
INSERT INTO public.who_global_data_import VALUES (63019, '2020-08-08', 'OM', 'Oman', 'EMRO', '354', '81067', '10', '502');
INSERT INTO public.who_global_data_import VALUES (63020, '2020-08-09', 'OM', 'Oman', 'EMRO', '290', '81357', '7', '509');
INSERT INTO public.who_global_data_import VALUES (63021, '2020-08-10', 'OM', 'Oman', 'EMRO', '223', '81580', '4', '513');
INSERT INTO public.who_global_data_import VALUES (63022, '2020-08-11', 'OM', 'Oman', 'EMRO', '207', '81787', '8', '521');
INSERT INTO public.who_global_data_import VALUES (63023, '2020-08-12', 'OM', 'Oman', 'EMRO', '263', '82050', '12', '533');
INSERT INTO public.who_global_data_import VALUES (63024, '2020-08-13', 'OM', 'Oman', 'EMRO', '249', '82299', '6', '539');
INSERT INTO public.who_global_data_import VALUES (63025, '2020-08-14', 'OM', 'Oman', 'EMRO', '232', '82531', '12', '551');
INSERT INTO public.who_global_data_import VALUES (63026, '2020-08-15', 'OM', 'Oman', 'EMRO', '212', '82743', '6', '557');
INSERT INTO public.who_global_data_import VALUES (63027, '2020-08-16', 'OM', 'Oman', 'EMRO', '181', '82924', '5', '562');
INSERT INTO public.who_global_data_import VALUES (63028, '2020-08-17', 'OM', 'Oman', 'EMRO', '162', '83086', '10', '572');
INSERT INTO public.who_global_data_import VALUES (63029, '2020-08-18', 'OM', 'Oman', 'EMRO', '140', '83226', '16', '588');
INSERT INTO public.who_global_data_import VALUES (63030, '2020-08-19', 'OM', 'Oman', 'EMRO', '192', '83418', '9', '597');
INSERT INTO public.who_global_data_import VALUES (63031, '2020-08-20', 'OM', 'Oman', 'EMRO', '188', '83606', '6', '603');
INSERT INTO public.who_global_data_import VALUES (63032, '2020-08-21', 'OM', 'Oman', 'EMRO', '163', '83769', '6', '609');
INSERT INTO public.who_global_data_import VALUES (63033, '2020-08-22', 'OM', 'Oman', 'EMRO', '0', '83769', '0', '609');
INSERT INTO public.who_global_data_import VALUES (63034, '2020-08-23', 'OM', 'Oman', 'EMRO', '0', '83769', '0', '609');
INSERT INTO public.who_global_data_import VALUES (63035, '2020-08-24', 'OM', 'Oman', 'EMRO', '0', '83769', '0', '609');
INSERT INTO public.who_global_data_import VALUES (63036, '2020-08-25', 'OM', 'Oman', 'EMRO', '740', '84509', '28', '637');
INSERT INTO public.who_global_data_import VALUES (63037, '2020-08-26', 'OM', 'Oman', 'EMRO', '143', '84652', '5', '642');
INSERT INTO public.who_global_data_import VALUES (63038, '2020-08-27', 'OM', 'Oman', 'EMRO', '166', '84818', '4', '646');
INSERT INTO public.who_global_data_import VALUES (63039, '2020-08-28', 'OM', 'Oman', 'EMRO', '187', '85005', '4', '650');
INSERT INTO public.who_global_data_import VALUES (63040, '2020-08-29', 'OM', 'Oman', 'EMRO', '0', '85005', '0', '650');
INSERT INTO public.who_global_data_import VALUES (63041, '2020-08-30', 'OM', 'Oman', 'EMRO', '0', '85005', '0', '650');
INSERT INTO public.who_global_data_import VALUES (63042, '2020-08-31', 'OM', 'Oman', 'EMRO', '539', '85544', '27', '677');
INSERT INTO public.who_global_data_import VALUES (63043, '2020-09-01', 'OM', 'Oman', 'EMRO', '178', '85722', '8', '685');
INSERT INTO public.who_global_data_import VALUES (63044, '2020-09-02', 'OM', 'Oman', 'EMRO', '206', '85928', '4', '689');
INSERT INTO public.who_global_data_import VALUES (63045, '2020-09-03', 'OM', 'Oman', 'EMRO', '0', '85928', '0', '689');
INSERT INTO public.who_global_data_import VALUES (63046, '2020-09-04', 'OM', 'Oman', 'EMRO', '452', '86380', '16', '705');
INSERT INTO public.who_global_data_import VALUES (63047, '2020-09-05', 'OM', 'Oman', 'EMRO', '0', '86380', '0', '705');
INSERT INTO public.who_global_data_import VALUES (63048, '2020-09-06', 'OM', 'Oman', 'EMRO', '0', '86380', '0', '705');
INSERT INTO public.who_global_data_import VALUES (63049, '2020-09-07', 'OM', 'Oman', 'EMRO', '692', '87072', '23', '728');
INSERT INTO public.who_global_data_import VALUES (63050, '2020-09-08', 'OM', 'Oman', 'EMRO', '256', '87328', '6', '734');
INSERT INTO public.who_global_data_import VALUES (63051, '2020-09-09', 'OM', 'Oman', 'EMRO', '262', '87590', '8', '742');
INSERT INTO public.who_global_data_import VALUES (63052, '2020-09-10', 'OM', 'Oman', 'EMRO', '349', '87939', '9', '751');
INSERT INTO public.who_global_data_import VALUES (63053, '2020-09-11', 'OM', 'Oman', 'EMRO', '398', '88337', '11', '762');
INSERT INTO public.who_global_data_import VALUES (63054, '2020-09-12', 'OM', 'Oman', 'EMRO', '0', '88337', '0', '762');
INSERT INTO public.who_global_data_import VALUES (63055, '2020-09-13', 'OM', 'Oman', 'EMRO', '0', '88337', '0', '762');
INSERT INTO public.who_global_data_import VALUES (63056, '2020-09-14', 'OM', 'Oman', 'EMRO', '1409', '89746', '18', '780');
INSERT INTO public.who_global_data_import VALUES (63057, '2020-09-15', 'OM', 'Oman', 'EMRO', '476', '90222', '10', '790');
INSERT INTO public.who_global_data_import VALUES (63058, '2020-09-16', 'OM', 'Oman', 'EMRO', '438', '90660', '7', '797');
INSERT INTO public.who_global_data_import VALUES (63059, '2020-09-17', 'OM', 'Oman', 'EMRO', '536', '91196', '8', '805');
INSERT INTO public.who_global_data_import VALUES (63060, '2020-09-18', 'OM', 'Oman', 'EMRO', '557', '91753', '13', '818');
INSERT INTO public.who_global_data_import VALUES (63061, '2020-09-19', 'OM', 'Oman', 'EMRO', '0', '91753', '0', '818');
INSERT INTO public.who_global_data_import VALUES (63062, '2020-09-20', 'OM', 'Oman', 'EMRO', '0', '91753', '0', '818');
INSERT INTO public.who_global_data_import VALUES (63063, '2020-09-21', 'OM', 'Oman', 'EMRO', '1722', '93475', '28', '846');
INSERT INTO public.who_global_data_import VALUES (63064, '2020-09-22', 'OM', 'Oman', 'EMRO', '576', '94051', '7', '853');
INSERT INTO public.who_global_data_import VALUES (63065, '2020-09-23', 'OM', 'Oman', 'EMRO', '660', '94711', '12', '865');
INSERT INTO public.who_global_data_import VALUES (63066, '2020-09-24', 'OM', 'Oman', 'EMRO', '628', '95339', '10', '875');
INSERT INTO public.who_global_data_import VALUES (63067, '2020-09-25', 'OM', 'Oman', 'EMRO', '568', '95907', '10', '885');
INSERT INTO public.who_global_data_import VALUES (63068, '2020-09-26', 'OM', 'Oman', 'EMRO', '0', '95907', '0', '885');
INSERT INTO public.who_global_data_import VALUES (63069, '2020-09-27', 'OM', 'Oman', 'EMRO', '0', '95907', '0', '885');
INSERT INTO public.who_global_data_import VALUES (63070, '2020-09-28', 'OM', 'Oman', 'EMRO', '1543', '97450', '24', '909');
INSERT INTO public.who_global_data_import VALUES (63071, '2020-09-29', 'OM', 'Oman', 'EMRO', '607', '98057', '15', '924');
INSERT INTO public.who_global_data_import VALUES (63072, '2020-09-30', 'OM', 'Oman', 'EMRO', '528', '98585', '11', '935');
INSERT INTO public.who_global_data_import VALUES (63073, '2020-10-01', 'OM', 'Oman', 'EMRO', '0', '98585', '0', '935');
INSERT INTO public.who_global_data_import VALUES (63074, '2020-10-02', 'OM', 'Oman', 'EMRO', '0', '98585', '0', '935');
INSERT INTO public.who_global_data_import VALUES (63075, '2020-10-03', 'OM', 'Oman', 'EMRO', '0', '98585', '0', '935');
INSERT INTO public.who_global_data_import VALUES (63076, '2020-10-04', 'OM', 'Oman', 'EMRO', '0', '98585', '0', '935');
INSERT INTO public.who_global_data_import VALUES (63077, '2020-10-05', 'OM', 'Oman', 'EMRO', '2685', '101270', '42', '977');
INSERT INTO public.who_global_data_import VALUES (63078, '2020-10-06', 'OM', 'Oman', 'EMRO', '544', '101814', '8', '985');
INSERT INTO public.who_global_data_import VALUES (63079, '2020-10-07', 'OM', 'Oman', 'EMRO', '834', '102648', '5', '990');
INSERT INTO public.who_global_data_import VALUES (63080, '2020-10-08', 'OM', 'Oman', 'EMRO', '817', '103465', '10', '1000');
INSERT INTO public.who_global_data_import VALUES (63081, '2020-10-09', 'OM', 'Oman', 'EMRO', '664', '104129', '9', '1009');
INSERT INTO public.who_global_data_import VALUES (63082, '2020-10-10', 'OM', 'Oman', 'EMRO', '0', '104129', '0', '1009');
INSERT INTO public.who_global_data_import VALUES (63083, '2020-10-11', 'OM', 'Oman', 'EMRO', '0', '104129', '0', '1009');
INSERT INTO public.who_global_data_import VALUES (63084, '2020-10-12', 'OM', 'Oman', 'EMRO', '1761', '105890', '29', '1038');
INSERT INTO public.who_global_data_import VALUES (63085, '2020-10-13', 'OM', 'Oman', 'EMRO', '685', '106575', '8', '1046');
INSERT INTO public.who_global_data_import VALUES (63086, '2020-10-14', 'OM', 'Oman', 'EMRO', '638', '107213', '7', '1053');
INSERT INTO public.who_global_data_import VALUES (63087, '2020-10-15', 'OM', 'Oman', 'EMRO', '563', '107776', '8', '1061');
INSERT INTO public.who_global_data_import VALUES (63088, '2020-10-16', 'OM', 'Oman', 'EMRO', '520', '108296', '10', '1071');
INSERT INTO public.who_global_data_import VALUES (63089, '2020-10-17', 'OM', 'Oman', 'EMRO', '0', '108296', '0', '1071');
INSERT INTO public.who_global_data_import VALUES (63090, '2020-10-18', 'OM', 'Oman', 'EMRO', '0', '108296', '0', '1071');
INSERT INTO public.who_global_data_import VALUES (63091, '2020-10-19', 'OM', 'Oman', 'EMRO', '1657', '109953', '30', '1101');
INSERT INTO public.who_global_data_import VALUES (63092, '2020-10-20', 'OM', 'Oman', 'EMRO', '641', '110594', '13', '1114');
INSERT INTO public.who_global_data_import VALUES (63093, '2020-10-21', 'OM', 'Oman', 'EMRO', '439', '111033', '8', '1122');
INSERT INTO public.who_global_data_import VALUES (63094, '2020-10-22', 'OM', 'Oman', 'EMRO', '451', '111484', '15', '1137');
INSERT INTO public.who_global_data_import VALUES (63095, '2020-10-23', 'OM', 'Oman', 'EMRO', '353', '111837', '10', '1147');
INSERT INTO public.who_global_data_import VALUES (63096, '2020-10-24', 'OM', 'Oman', 'EMRO', '0', '111837', '0', '1147');
INSERT INTO public.who_global_data_import VALUES (63097, '2020-10-25', 'OM', 'Oman', 'EMRO', '0', '111837', '0', '1147');
INSERT INTO public.who_global_data_import VALUES (63098, '2020-10-26', 'OM', 'Oman', 'EMRO', '1095', '112932', '27', '1174');
INSERT INTO public.who_global_data_import VALUES (63099, '2020-10-27', 'OM', 'Oman', 'EMRO', '422', '113354', '16', '1190');
INSERT INTO public.who_global_data_import VALUES (63100, '2020-10-28', 'OM', 'Oman', 'EMRO', '466', '113820', '13', '1203');
INSERT INTO public.who_global_data_import VALUES (63101, '2020-10-29', 'OM', 'Oman', 'EMRO', '614', '114434', '5', '1208');
INSERT INTO public.who_global_data_import VALUES (63102, '2020-10-30', 'OM', 'Oman', 'EMRO', '0', '114434', '0', '1208');
INSERT INTO public.who_global_data_import VALUES (63103, '2020-10-31', 'OM', 'Oman', 'EMRO', '0', '114434', '0', '1208');
INSERT INTO public.who_global_data_import VALUES (63104, '2020-11-01', 'OM', 'Oman', 'EMRO', '0', '114434', '0', '1208');
INSERT INTO public.who_global_data_import VALUES (63105, '2020-11-02', 'OM', 'Oman', 'EMRO', '1300', '115734', '38', '1246');
INSERT INTO public.who_global_data_import VALUES (63106, '2020-11-03', 'OM', 'Oman', 'EMRO', '418', '116152', '10', '1256');
INSERT INTO public.who_global_data_import VALUES (63107, '2020-11-04', 'OM', 'Oman', 'EMRO', '376', '116528', '8', '1264');
INSERT INTO public.who_global_data_import VALUES (63108, '2020-11-05', 'OM', 'Oman', 'EMRO', '319', '116847', '11', '1275');
INSERT INTO public.who_global_data_import VALUES (63109, '2020-11-06', 'OM', 'Oman', 'EMRO', '320', '117167', '11', '1286');
INSERT INTO public.who_global_data_import VALUES (63110, '2020-11-07', 'OM', 'Oman', 'EMRO', '0', '117167', '0', '1286');
INSERT INTO public.who_global_data_import VALUES (63111, '2020-11-08', 'OM', 'Oman', 'EMRO', '0', '117167', '0', '1286');
INSERT INTO public.who_global_data_import VALUES (63112, '2020-11-09', 'OM', 'Oman', 'EMRO', '973', '118140', '15', '1301');
INSERT INTO public.who_global_data_import VALUES (63113, '2020-11-10', 'OM', 'Oman', 'EMRO', '363', '118503', '9', '1310');
INSERT INTO public.who_global_data_import VALUES (63114, '2020-11-11', 'OM', 'Oman', 'EMRO', '381', '118884', '6', '1316');
INSERT INTO public.who_global_data_import VALUES (63115, '2020-11-12', 'OM', 'Oman', 'EMRO', '302', '119186', '5', '1321');
INSERT INTO public.who_global_data_import VALUES (63116, '2020-11-13', 'OM', 'Oman', 'EMRO', '256', '119442', '5', '1326');
INSERT INTO public.who_global_data_import VALUES (63117, '2020-11-14', 'OM', 'Oman', 'EMRO', '0', '119442', '0', '1326');
INSERT INTO public.who_global_data_import VALUES (63118, '2020-11-15', 'OM', 'Oman', 'EMRO', '0', '119442', '0', '1326');
INSERT INTO public.who_global_data_import VALUES (63119, '2020-11-16', 'OM', 'Oman', 'EMRO', '947', '120389', '12', '1338');
INSERT INTO public.who_global_data_import VALUES (63120, '2020-11-17', 'OM', 'Oman', 'EMRO', '329', '120718', '12', '1350');
INSERT INTO public.who_global_data_import VALUES (63121, '2020-11-18', 'OM', 'Oman', 'EMRO', '0', '120718', '0', '1350');
INSERT INTO public.who_global_data_import VALUES (63122, '2020-11-19', 'OM', 'Oman', 'EMRO', '411', '121129', '10', '1360');
INSERT INTO public.who_global_data_import VALUES (63123, '2020-11-20', 'OM', 'Oman', 'EMRO', '231', '121360', '5', '1365');
INSERT INTO public.who_global_data_import VALUES (63124, '2020-11-21', 'OM', 'Oman', 'EMRO', '0', '121360', '0', '1365');
INSERT INTO public.who_global_data_import VALUES (63125, '2020-11-22', 'OM', 'Oman', 'EMRO', '0', '121360', '0', '1365');
INSERT INTO public.who_global_data_import VALUES (63126, '2020-11-23', 'OM', 'Oman', 'EMRO', '721', '122081', '15', '1380');
INSERT INTO public.who_global_data_import VALUES (63127, '2020-11-24', 'OM', 'Oman', 'EMRO', '275', '122356', '6', '1386');
INSERT INTO public.who_global_data_import VALUES (63128, '2020-11-25', 'OM', 'Oman', 'EMRO', '223', '122579', '5', '1391');
INSERT INTO public.who_global_data_import VALUES (63129, '2020-11-26', 'OM', 'Oman', 'EMRO', '0', '122579', '0', '1391');
INSERT INTO public.who_global_data_import VALUES (63130, '2020-11-27', 'OM', 'Oman', 'EMRO', '0', '122579', '0', '1391');
INSERT INTO public.who_global_data_import VALUES (63131, '2020-11-28', 'OM', 'Oman', 'EMRO', '0', '122579', '0', '1391');
INSERT INTO public.who_global_data_import VALUES (63132, '2020-11-29', 'OM', 'Oman', 'EMRO', '0', '122579', '0', '1391');
INSERT INTO public.who_global_data_import VALUES (63133, '2020-11-30', 'OM', 'Oman', 'EMRO', '905', '123484', '27', '1418');
INSERT INTO public.who_global_data_import VALUES (63134, '2020-12-01', 'OM', 'Oman', 'EMRO', '215', '123699', '5', '1423');
INSERT INTO public.who_global_data_import VALUES (63135, '2020-12-02', 'OM', 'Oman', 'EMRO', '209', '123908', '7', '1430');
INSERT INTO public.who_global_data_import VALUES (63136, '2020-12-03', 'OM', 'Oman', 'EMRO', '237', '124145', '0', '1430');
INSERT INTO public.who_global_data_import VALUES (63137, '2020-12-04', 'OM', 'Oman', 'EMRO', '184', '124329', '5', '1435');
INSERT INTO public.who_global_data_import VALUES (63138, '2020-12-05', 'OM', 'Oman', 'EMRO', '0', '124329', '0', '1435');
INSERT INTO public.who_global_data_import VALUES (63139, '2020-12-06', 'OM', 'Oman', 'EMRO', '0', '124329', '0', '1435');
INSERT INTO public.who_global_data_import VALUES (63140, '2020-12-07', 'OM', 'Oman', 'EMRO', '557', '124886', '9', '1444');
INSERT INTO public.who_global_data_import VALUES (63141, '2020-12-08', 'OM', 'Oman', 'EMRO', '229', '125115', '8', '1452');
INSERT INTO public.who_global_data_import VALUES (63142, '2020-12-09', 'OM', 'Oman', 'EMRO', '211', '125326', '2', '1454');
INSERT INTO public.who_global_data_import VALUES (63143, '2020-12-10', 'OM', 'Oman', 'EMRO', '164', '125490', '7', '1461');
INSERT INTO public.who_global_data_import VALUES (63144, '2020-12-11', 'OM', 'Oman', 'EMRO', '179', '125669', '2', '1463');
INSERT INTO public.who_global_data_import VALUES (63145, '2020-12-12', 'OM', 'Oman', 'EMRO', '0', '125669', '0', '1463');
INSERT INTO public.who_global_data_import VALUES (63146, '2020-12-13', 'OM', 'Oman', 'EMRO', '0', '125669', '0', '1463');
INSERT INTO public.who_global_data_import VALUES (63147, '2020-12-14', 'OM', 'Oman', 'EMRO', '571', '126240', '8', '1471');
INSERT INTO public.who_global_data_import VALUES (63148, '2020-12-15', 'OM', 'Oman', 'EMRO', '264', '126504', '1', '1472');
INSERT INTO public.who_global_data_import VALUES (63149, '2020-12-16', 'OM', 'Oman', 'EMRO', '215', '126719', '3', '1475');
INSERT INTO public.who_global_data_import VALUES (63150, '2020-12-17', 'OM', 'Oman', 'EMRO', '116', '126835', '5', '1480');
INSERT INTO public.who_global_data_import VALUES (63151, '2020-12-18', 'OM', 'Oman', 'EMRO', '184', '127019', '3', '1483');
INSERT INTO public.who_global_data_import VALUES (63152, '2020-12-19', 'OM', 'Oman', 'EMRO', '0', '127019', '0', '1483');
INSERT INTO public.who_global_data_import VALUES (63153, '2020-12-20', 'OM', 'Oman', 'EMRO', '0', '127019', '0', '1483');
INSERT INTO public.who_global_data_import VALUES (63154, '2020-12-21', 'OM', 'Oman', 'EMRO', '648', '127667', '5', '1488');
INSERT INTO public.who_global_data_import VALUES (63155, '2020-12-22', 'OM', 'Oman', 'EMRO', '264', '127931', '1', '1489');
INSERT INTO public.who_global_data_import VALUES (63156, '2020-12-23', 'OM', 'Oman', 'EMRO', '212', '128143', '1', '1490');
INSERT INTO public.who_global_data_import VALUES (63157, '2020-12-24', 'OM', 'Oman', 'EMRO', '93', '128236', '1', '1491');
INSERT INTO public.who_global_data_import VALUES (63158, '2020-12-25', 'OM', 'Oman', 'EMRO', '54', '128290', '0', '1491');
INSERT INTO public.who_global_data_import VALUES (63159, '2020-12-26', 'OM', 'Oman', 'EMRO', '0', '128290', '0', '1491');
INSERT INTO public.who_global_data_import VALUES (63160, '2020-12-27', 'OM', 'Oman', 'EMRO', '0', '128290', '0', '1491');
INSERT INTO public.who_global_data_import VALUES (63161, '2020-12-28', 'OM', 'Oman', 'EMRO', '182', '128472', '4', '1495');
INSERT INTO public.who_global_data_import VALUES (63162, '2020-12-29', 'OM', 'Oman', 'EMRO', '91', '128563', '0', '1495');
INSERT INTO public.who_global_data_import VALUES (63163, '2020-12-30', 'OM', 'Oman', 'EMRO', '70', '128633', '2', '1497');
INSERT INTO public.who_global_data_import VALUES (63164, '2020-12-31', 'OM', 'Oman', 'EMRO', '86', '128719', '0', '1497');
INSERT INTO public.who_global_data_import VALUES (63165, '2021-01-01', 'OM', 'Oman', 'EMRO', '148', '128867', '2', '1499');
INSERT INTO public.who_global_data_import VALUES (63166, '2021-01-02', 'OM', 'Oman', 'EMRO', '0', '128867', '0', '1499');
INSERT INTO public.who_global_data_import VALUES (63167, '2021-01-03', 'OM', 'Oman', 'EMRO', '0', '128867', '0', '1499');
INSERT INTO public.who_global_data_import VALUES (63168, '2021-01-04', 'OM', 'Oman', 'EMRO', '537', '129404', '2', '1501');
INSERT INTO public.who_global_data_import VALUES (63169, '2021-01-05', 'OM', 'Oman', 'EMRO', '180', '129584', '1', '1502');
INSERT INTO public.who_global_data_import VALUES (63170, '2021-01-06', 'OM', 'Oman', 'EMRO', '190', '129774', '0', '1502');
INSERT INTO public.who_global_data_import VALUES (63171, '2021-01-07', 'OM', 'Oman', 'EMRO', '114', '129888', '2', '1504');
INSERT INTO public.who_global_data_import VALUES (63172, '2021-01-08', 'OM', 'Oman', 'EMRO', '182', '130070', '1', '1505');
INSERT INTO public.who_global_data_import VALUES (63173, '2021-01-09', 'OM', 'Oman', 'EMRO', '0', '130070', '0', '1505');
INSERT INTO public.who_global_data_import VALUES (63174, '2021-01-10', 'OM', 'Oman', 'EMRO', '0', '130070', '0', '1505');
INSERT INTO public.who_global_data_import VALUES (63175, '2021-01-11', 'OM', 'Oman', 'EMRO', '538', '130608', '3', '1508');
INSERT INTO public.who_global_data_import VALUES (63176, '2021-01-12', 'OM', 'Oman', 'EMRO', '172', '130780', '0', '1508');
INSERT INTO public.who_global_data_import VALUES (63177, '2021-01-13', 'OM', 'Oman', 'EMRO', '164', '130944', '0', '1508');
INSERT INTO public.who_global_data_import VALUES (63178, '2021-01-14', 'OM', 'Oman', 'EMRO', '142', '131086', '0', '1508');
INSERT INTO public.who_global_data_import VALUES (63179, '2021-01-15', 'OM', 'Oman', 'EMRO', '178', '131264', '1', '1509');
INSERT INTO public.who_global_data_import VALUES (63180, '2021-01-16', 'OM', 'Oman', 'EMRO', '0', '131264', '0', '1509');
INSERT INTO public.who_global_data_import VALUES (63181, '2021-01-17', 'OM', 'Oman', 'EMRO', '0', '131264', '0', '1509');
INSERT INTO public.who_global_data_import VALUES (63182, '2021-01-18', 'OM', 'Oman', 'EMRO', '526', '131790', '3', '1512');
INSERT INTO public.who_global_data_import VALUES (63183, '2021-01-19', 'OM', 'Oman', 'EMRO', '221', '132011', '2', '1514');
INSERT INTO public.who_global_data_import VALUES (63184, '2021-01-20', 'OM', 'Oman', 'EMRO', '135', '132146', '2', '1516');
INSERT INTO public.who_global_data_import VALUES (63185, '2021-01-21', 'OM', 'Oman', 'EMRO', '171', '132317', '0', '1516');
INSERT INTO public.who_global_data_import VALUES (63186, '2021-01-22', 'OM', 'Oman', 'EMRO', '169', '132486', '1', '1517');
INSERT INTO public.who_global_data_import VALUES (63187, '2021-01-23', 'OM', 'Oman', 'EMRO', '0', '132486', '0', '1517');
INSERT INTO public.who_global_data_import VALUES (63188, '2021-01-24', 'OM', 'Oman', 'EMRO', '0', '132486', '0', '1517');
INSERT INTO public.who_global_data_import VALUES (63189, '2021-01-25', 'OM', 'Oman', 'EMRO', '558', '133044', '4', '1521');
INSERT INTO public.who_global_data_import VALUES (63190, '2021-01-26', 'OM', 'Oman', 'EMRO', '209', '133253', '1', '1522');
INSERT INTO public.who_global_data_import VALUES (63191, '2021-01-27', 'OM', 'Oman', 'EMRO', '154', '133407', '2', '1524');
INSERT INTO public.who_global_data_import VALUES (63192, '2021-01-28', 'OM', 'Oman', 'EMRO', '167', '133574', '1', '1525');
INSERT INTO public.who_global_data_import VALUES (63193, '2021-01-29', 'OM', 'Oman', 'EMRO', '154', '133728', '2', '1527');
INSERT INTO public.who_global_data_import VALUES (63194, '2021-01-30', 'OM', 'Oman', 'EMRO', '0', '133728', '0', '1527');
INSERT INTO public.who_global_data_import VALUES (63195, '2021-01-31', 'OM', 'Oman', 'EMRO', '0', '133728', '0', '1527');
INSERT INTO public.who_global_data_import VALUES (63196, '2021-02-01', 'OM', 'Oman', 'EMRO', '598', '134326', '2', '1529');
INSERT INTO public.who_global_data_import VALUES (63197, '2021-02-02', 'OM', 'Oman', 'EMRO', '198', '134524', '3', '1532');
INSERT INTO public.who_global_data_import VALUES (63198, '2021-02-03', 'OM', 'Oman', 'EMRO', '161', '134685', '0', '1532');
INSERT INTO public.who_global_data_import VALUES (63199, '2021-02-04', 'OM', 'Oman', 'EMRO', '171', '134856', '0', '1532');
INSERT INTO public.who_global_data_import VALUES (63200, '2021-02-05', 'OM', 'Oman', 'EMRO', '185', '135041', '0', '1532');
INSERT INTO public.who_global_data_import VALUES (63201, '2020-01-03', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63202, '2020-01-04', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63203, '2020-01-05', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63204, '2020-01-06', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63205, '2020-01-07', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63206, '2020-01-08', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63207, '2020-01-09', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63208, '2020-01-10', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63209, '2020-01-11', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63210, '2020-01-12', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63211, '2020-01-13', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63212, '2020-01-14', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63213, '2020-01-15', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63214, '2020-01-16', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63215, '2020-01-17', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63216, '2020-01-18', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63217, '2020-01-19', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63218, '2020-01-20', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63219, '2020-01-21', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63220, '2020-01-22', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63221, '2020-01-23', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63222, '2020-01-24', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63223, '2020-01-25', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63224, '2020-01-26', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63225, '2020-01-27', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63226, '2020-01-28', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63227, '2020-01-29', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63228, '2020-01-30', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63229, '2020-01-31', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63230, '2020-02-01', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63231, '2020-02-02', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63232, '2020-02-03', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63233, '2020-02-04', ' ', 'Other', 'Other', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63234, '2020-02-05', ' ', 'Other', 'Other', '14', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63235, '2020-02-06', ' ', 'Other', 'Other', '10', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63236, '2020-02-07', ' ', 'Other', 'Other', '41', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63237, '2020-02-08', ' ', 'Other', 'Other', '3', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63238, '2020-02-09', ' ', 'Other', 'Other', '6', '74', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63239, '2020-02-10', ' ', 'Other', 'Other', '65', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63240, '2020-02-11', ' ', 'Other', 'Other', '0', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63241, '2020-02-12', ' ', 'Other', 'Other', '39', '178', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63242, '2020-02-13', ' ', 'Other', 'Other', '44', '222', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63243, '2020-02-14', ' ', 'Other', 'Other', '0', '222', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63244, '2020-02-15', ' ', 'Other', 'Other', '67', '289', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63245, '2020-02-16', ' ', 'Other', 'Other', '70', '359', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63246, '2020-02-17', ' ', 'Other', 'Other', '99', '458', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63247, '2020-02-18', ' ', 'Other', 'Other', '88', '546', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63248, '2020-02-19', ' ', 'Other', 'Other', '79', '625', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63249, '2020-02-20', ' ', 'Other', 'Other', '13', '638', '2', '2');
INSERT INTO public.who_global_data_import VALUES (63250, '2020-02-21', ' ', 'Other', 'Other', '0', '638', '0', '2');
INSERT INTO public.who_global_data_import VALUES (63251, '2020-02-22', ' ', 'Other', 'Other', '0', '638', '0', '2');
INSERT INTO public.who_global_data_import VALUES (63252, '2020-02-23', ' ', 'Other', 'Other', '57', '695', '1', '3');
INSERT INTO public.who_global_data_import VALUES (63253, '2020-02-24', ' ', 'Other', 'Other', '0', '695', '0', '3');
INSERT INTO public.who_global_data_import VALUES (63254, '2020-02-25', ' ', 'Other', 'Other', '0', '695', '1', '4');
INSERT INTO public.who_global_data_import VALUES (63255, '2020-02-26', ' ', 'Other', 'Other', '4', '699', '0', '4');
INSERT INTO public.who_global_data_import VALUES (63256, '2020-02-27', ' ', 'Other', 'Other', '0', '699', '0', '4');
INSERT INTO public.who_global_data_import VALUES (63257, '2020-02-28', ' ', 'Other', 'Other', '0', '699', '2', '6');
INSERT INTO public.who_global_data_import VALUES (63258, '2020-02-29', ' ', 'Other', 'Other', '0', '699', '0', '6');
INSERT INTO public.who_global_data_import VALUES (63259, '2020-03-01', ' ', 'Other', 'Other', '1', '700', '0', '6');
INSERT INTO public.who_global_data_import VALUES (63260, '2020-03-02', ' ', 'Other', 'Other', '0', '700', '0', '6');
INSERT INTO public.who_global_data_import VALUES (63261, '2020-03-03', ' ', 'Other', 'Other', '0', '700', '0', '6');
INSERT INTO public.who_global_data_import VALUES (63262, '2020-03-04', ' ', 'Other', 'Other', '0', '700', '0', '6');
INSERT INTO public.who_global_data_import VALUES (63263, '2020-03-05', ' ', 'Other', 'Other', '0', '700', '0', '6');
INSERT INTO public.who_global_data_import VALUES (63264, '2020-03-06', ' ', 'Other', 'Other', '0', '700', '0', '6');
INSERT INTO public.who_global_data_import VALUES (63265, '2020-03-07', ' ', 'Other', 'Other', '0', '700', '0', '6');
INSERT INTO public.who_global_data_import VALUES (63266, '2020-03-08', ' ', 'Other', 'Other', '0', '700', '1', '7');
INSERT INTO public.who_global_data_import VALUES (63267, '2020-03-09', ' ', 'Other', 'Other', '0', '700', '0', '7');
INSERT INTO public.who_global_data_import VALUES (63268, '2020-03-10', ' ', 'Other', 'Other', '0', '700', '0', '7');
INSERT INTO public.who_global_data_import VALUES (63269, '2020-03-11', ' ', 'Other', 'Other', '0', '700', '0', '7');
INSERT INTO public.who_global_data_import VALUES (63270, '2020-03-12', ' ', 'Other', 'Other', '0', '700', '0', '7');
INSERT INTO public.who_global_data_import VALUES (63271, '2020-03-13', ' ', 'Other', 'Other', '1', '701', '0', '7');
INSERT INTO public.who_global_data_import VALUES (63272, '2020-03-14', ' ', 'Other', 'Other', '0', '701', '0', '7');
INSERT INTO public.who_global_data_import VALUES (63273, '2020-03-15', ' ', 'Other', 'Other', '15', '716', '0', '7');
INSERT INTO public.who_global_data_import VALUES (63274, '2020-03-16', ' ', 'Other', 'Other', '0', '716', '0', '7');
INSERT INTO public.who_global_data_import VALUES (63275, '2020-03-17', ' ', 'Other', 'Other', '0', '716', '0', '7');
INSERT INTO public.who_global_data_import VALUES (63276, '2020-03-18', ' ', 'Other', 'Other', '0', '716', '0', '7');
INSERT INTO public.who_global_data_import VALUES (63277, '2020-03-19', ' ', 'Other', 'Other', '0', '716', '0', '7');
INSERT INTO public.who_global_data_import VALUES (63278, '2020-03-20', ' ', 'Other', 'Other', '-4', '712', '1', '8');
INSERT INTO public.who_global_data_import VALUES (63279, '2020-03-21', ' ', 'Other', 'Other', '0', '712', '0', '8');
INSERT INTO public.who_global_data_import VALUES (63280, '2020-03-22', ' ', 'Other', 'Other', '0', '712', '0', '8');
INSERT INTO public.who_global_data_import VALUES (63281, '2020-03-23', ' ', 'Other', 'Other', '0', '712', '0', '8');
INSERT INTO public.who_global_data_import VALUES (63282, '2020-03-24', ' ', 'Other', 'Other', '0', '712', '2', '10');
INSERT INTO public.who_global_data_import VALUES (63283, '2020-03-25', ' ', 'Other', 'Other', '0', '712', '0', '10');
INSERT INTO public.who_global_data_import VALUES (63284, '2020-03-26', ' ', 'Other', 'Other', '0', '712', '0', '10');
INSERT INTO public.who_global_data_import VALUES (63285, '2020-03-27', ' ', 'Other', 'Other', '0', '712', '0', '10');
INSERT INTO public.who_global_data_import VALUES (63286, '2020-03-28', ' ', 'Other', 'Other', '0', '712', '0', '10');
INSERT INTO public.who_global_data_import VALUES (63287, '2020-03-29', ' ', 'Other', 'Other', '0', '712', '0', '10');
INSERT INTO public.who_global_data_import VALUES (63288, '2020-03-30', ' ', 'Other', 'Other', '0', '712', '0', '10');
INSERT INTO public.who_global_data_import VALUES (63289, '2020-03-31', ' ', 'Other', 'Other', '0', '712', '1', '11');
INSERT INTO public.who_global_data_import VALUES (63290, '2020-04-01', ' ', 'Other', 'Other', '0', '712', '0', '11');
INSERT INTO public.who_global_data_import VALUES (63291, '2020-04-02', ' ', 'Other', 'Other', '0', '712', '0', '11');
INSERT INTO public.who_global_data_import VALUES (63292, '2020-04-03', ' ', 'Other', 'Other', '0', '712', '0', '11');
INSERT INTO public.who_global_data_import VALUES (63293, '2020-04-04', ' ', 'Other', 'Other', '0', '712', '0', '11');
INSERT INTO public.who_global_data_import VALUES (63294, '2020-04-05', ' ', 'Other', 'Other', '0', '712', '0', '11');
INSERT INTO public.who_global_data_import VALUES (63295, '2020-04-06', ' ', 'Other', 'Other', '0', '712', '0', '11');
INSERT INTO public.who_global_data_import VALUES (63296, '2020-04-07', ' ', 'Other', 'Other', '0', '712', '0', '11');
INSERT INTO public.who_global_data_import VALUES (63297, '2020-04-08', ' ', 'Other', 'Other', '0', '712', '0', '11');
INSERT INTO public.who_global_data_import VALUES (63298, '2020-04-09', ' ', 'Other', 'Other', '0', '712', '0', '11');
INSERT INTO public.who_global_data_import VALUES (63299, '2020-04-10', ' ', 'Other', 'Other', '0', '712', '0', '11');
INSERT INTO public.who_global_data_import VALUES (63300, '2020-04-11', ' ', 'Other', 'Other', '0', '712', '0', '11');
INSERT INTO public.who_global_data_import VALUES (63301, '2020-04-12', ' ', 'Other', 'Other', '0', '712', '0', '11');
INSERT INTO public.who_global_data_import VALUES (63302, '2020-04-13', ' ', 'Other', 'Other', '0', '712', '1', '12');
INSERT INTO public.who_global_data_import VALUES (63303, '2020-04-14', ' ', 'Other', 'Other', '0', '712', '0', '12');
INSERT INTO public.who_global_data_import VALUES (63304, '2020-04-15', ' ', 'Other', 'Other', '0', '712', '0', '12');
INSERT INTO public.who_global_data_import VALUES (63305, '2020-04-16', ' ', 'Other', 'Other', '0', '712', '0', '12');
INSERT INTO public.who_global_data_import VALUES (63306, '2020-04-17', ' ', 'Other', 'Other', '0', '712', '1', '13');
INSERT INTO public.who_global_data_import VALUES (63307, '2020-04-18', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63308, '2020-04-19', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63309, '2020-04-20', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63310, '2020-04-21', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63311, '2020-04-22', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63312, '2020-04-23', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63313, '2020-04-24', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63314, '2020-04-25', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63315, '2020-04-26', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63316, '2020-04-27', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63317, '2020-04-28', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63318, '2020-04-29', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63319, '2020-04-30', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63320, '2020-05-01', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63321, '2020-05-02', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63322, '2020-05-03', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63323, '2020-05-04', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63324, '2020-05-05', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63325, '2020-05-06', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63326, '2020-05-07', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63327, '2020-05-08', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63328, '2020-05-09', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63329, '2020-05-10', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63330, '2020-05-11', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63331, '2020-05-12', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63332, '2020-05-13', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63333, '2020-05-14', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63334, '2020-05-15', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63335, '2020-05-16', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63336, '2020-05-17', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63337, '2020-05-18', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63338, '2020-05-19', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63339, '2020-05-20', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63340, '2020-05-21', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63341, '2020-05-22', ' ', 'Other', 'Other', '0', '712', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63342, '2020-05-23', ' ', 'Other', 'Other', '29', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63343, '2020-05-24', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63344, '2020-05-25', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63345, '2020-05-26', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63346, '2020-05-27', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63347, '2020-05-28', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63348, '2020-05-29', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63349, '2020-05-30', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63350, '2020-05-31', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63351, '2020-06-01', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63352, '2020-06-02', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63353, '2020-06-03', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63354, '2020-06-04', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63355, '2020-06-05', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63356, '2020-06-06', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63357, '2020-06-07', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63358, '2020-06-08', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63359, '2020-06-09', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63360, '2020-06-10', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63361, '2020-06-11', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63362, '2020-06-12', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63363, '2020-06-13', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63364, '2020-06-14', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63365, '2020-06-15', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63366, '2020-06-16', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63367, '2020-06-17', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63368, '2020-06-18', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63369, '2020-06-19', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63370, '2020-06-20', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63371, '2020-06-21', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63372, '2020-06-22', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63373, '2020-06-23', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63374, '2020-06-24', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63375, '2020-06-25', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63376, '2020-06-26', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63377, '2020-06-27', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63378, '2020-06-28', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63379, '2020-06-29', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63380, '2020-06-30', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63381, '2020-07-01', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63382, '2020-07-02', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63383, '2020-07-03', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63384, '2020-07-04', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63385, '2020-07-05', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63386, '2020-07-06', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63387, '2020-07-07', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63388, '2020-07-08', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63389, '2020-07-09', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63390, '2020-07-10', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63391, '2020-07-11', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63392, '2020-07-12', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63393, '2020-07-13', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63394, '2020-07-14', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63395, '2020-07-15', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63396, '2020-07-16', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63397, '2020-07-17', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63398, '2020-07-18', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63399, '2020-07-19', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63400, '2020-07-20', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63401, '2020-07-21', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63402, '2020-07-22', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63403, '2020-07-23', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63404, '2020-07-24', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63405, '2020-07-25', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63406, '2020-07-26', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63407, '2020-07-27', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63408, '2020-07-28', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63409, '2020-07-29', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63410, '2020-07-30', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63411, '2020-07-31', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63412, '2020-08-01', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63413, '2020-08-02', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63414, '2020-08-03', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63415, '2020-08-04', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63416, '2020-08-05', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63417, '2020-08-06', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63418, '2020-08-07', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63419, '2020-08-08', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63420, '2020-08-09', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63421, '2020-08-10', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63422, '2020-08-11', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63423, '2020-08-12', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63424, '2020-08-13', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63425, '2020-08-14', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63426, '2020-08-15', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63427, '2020-08-16', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63428, '2020-08-17', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63429, '2020-08-18', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63430, '2020-08-19', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63431, '2020-08-20', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63432, '2020-08-21', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63433, '2020-08-22', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63434, '2020-08-23', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63435, '2020-08-24', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63436, '2020-08-25', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63437, '2020-08-26', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63438, '2020-08-27', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63439, '2020-08-28', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63440, '2020-08-29', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63441, '2020-08-30', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63442, '2020-08-31', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63443, '2020-09-01', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63444, '2020-09-02', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63445, '2020-09-03', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63446, '2020-09-04', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63447, '2020-09-05', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63448, '2020-09-06', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63449, '2020-09-07', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63450, '2020-09-08', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63451, '2020-09-09', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63452, '2020-09-10', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63453, '2020-09-11', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63454, '2020-09-12', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63455, '2020-09-13', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63456, '2020-09-14', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63457, '2020-09-15', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63458, '2020-09-16', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63459, '2020-09-17', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63460, '2020-09-18', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63461, '2020-09-19', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63462, '2020-09-20', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63463, '2020-09-21', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63464, '2020-09-22', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63465, '2020-09-23', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63466, '2020-09-24', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63467, '2020-09-25', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63468, '2020-09-26', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63469, '2020-09-27', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63470, '2020-09-28', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63471, '2020-09-29', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63472, '2020-09-30', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63473, '2020-10-01', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63474, '2020-10-02', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63475, '2020-10-03', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63476, '2020-10-04', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63477, '2020-10-05', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63478, '2020-10-06', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63479, '2020-10-07', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63480, '2020-10-08', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63481, '2020-10-09', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63482, '2020-10-10', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63483, '2020-10-11', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63484, '2020-10-12', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63485, '2020-10-13', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63486, '2020-10-14', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63487, '2020-10-15', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63488, '2020-10-16', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63489, '2020-10-17', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63490, '2020-10-18', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63491, '2020-10-19', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63492, '2020-10-20', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63493, '2020-10-21', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63494, '2020-10-22', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63495, '2020-10-23', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63496, '2020-10-24', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63497, '2020-10-25', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63498, '2020-10-26', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63499, '2020-10-27', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63500, '2020-10-28', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63501, '2020-10-29', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63502, '2020-10-30', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63503, '2020-10-31', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63504, '2020-11-01', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63505, '2020-11-02', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63506, '2020-11-03', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63507, '2020-11-04', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63508, '2020-11-05', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63509, '2020-11-06', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63510, '2020-11-07', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63511, '2020-11-08', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63512, '2020-11-09', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63513, '2020-11-10', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63514, '2020-11-11', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63515, '2020-11-12', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63516, '2020-11-13', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63517, '2020-11-14', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63518, '2020-11-15', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63519, '2020-11-16', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63520, '2020-11-17', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63521, '2020-11-18', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63522, '2020-11-19', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63523, '2020-11-20', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63524, '2020-11-21', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63525, '2020-11-22', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63526, '2020-11-23', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63527, '2020-11-24', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63528, '2020-11-25', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63529, '2020-11-26', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63530, '2020-11-27', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63531, '2020-11-28', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63532, '2020-11-29', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63533, '2020-11-30', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63534, '2020-12-01', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63535, '2020-12-02', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63536, '2020-12-03', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63537, '2020-12-04', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63538, '2020-12-05', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63539, '2020-12-06', ' ', 'Other', 'Other', '0', '741', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63540, '2020-12-07', ' ', 'Other', 'Other', '3', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63541, '2020-12-08', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63542, '2020-12-09', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63543, '2020-12-10', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63544, '2020-12-11', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63545, '2020-12-12', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63546, '2020-12-13', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63547, '2020-12-14', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63548, '2020-12-15', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63549, '2020-12-16', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63550, '2020-12-17', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63551, '2020-12-18', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63552, '2020-12-19', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63553, '2020-12-20', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63554, '2020-12-21', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63555, '2020-12-22', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63556, '2020-12-23', ' ', 'Other', 'Other', '0', '744', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63557, '2020-12-24', ' ', 'Other', 'Other', '1', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63558, '2020-12-25', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63559, '2020-12-26', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63560, '2020-12-27', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63561, '2020-12-28', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63562, '2020-12-29', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63563, '2020-12-30', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63564, '2020-12-31', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63565, '2021-01-01', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63566, '2021-01-02', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63567, '2021-01-03', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63568, '2021-01-04', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63569, '2021-01-05', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63570, '2021-01-06', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63571, '2021-01-07', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63572, '2021-01-08', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63573, '2021-01-09', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63574, '2021-01-10', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63575, '2021-01-11', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63576, '2021-01-12', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63577, '2021-01-13', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63578, '2021-01-14', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63579, '2021-01-15', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63580, '2021-01-16', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63581, '2021-01-17', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63582, '2021-01-18', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63583, '2021-01-19', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63584, '2021-01-20', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63585, '2021-01-21', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63586, '2021-01-22', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63587, '2021-01-23', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63588, '2021-01-24', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63589, '2021-01-25', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63590, '2021-01-26', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63591, '2021-01-27', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63592, '2021-01-28', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63593, '2021-01-29', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63594, '2021-01-30', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63595, '2021-01-31', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63596, '2021-02-01', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63597, '2021-02-02', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63598, '2021-02-03', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63599, '2021-02-04', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63600, '2021-02-05', ' ', 'Other', 'Other', '0', '745', '0', '13');
INSERT INTO public.who_global_data_import VALUES (63601, '2020-01-03', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63602, '2020-01-04', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63603, '2020-01-05', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63604, '2020-01-06', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63605, '2020-01-07', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63606, '2020-01-08', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63607, '2020-01-09', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63608, '2020-01-10', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63609, '2020-01-11', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63610, '2020-01-12', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63611, '2020-01-13', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63612, '2020-01-14', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63613, '2020-01-15', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63614, '2020-01-16', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63615, '2020-01-17', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63616, '2020-01-18', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63617, '2020-01-19', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63618, '2020-01-20', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63619, '2020-01-21', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63620, '2020-01-22', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63621, '2020-01-23', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63622, '2020-01-24', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63623, '2020-01-25', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63624, '2020-01-26', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63625, '2020-01-27', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63626, '2020-01-28', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63627, '2020-01-29', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63628, '2020-01-30', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63629, '2020-01-31', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63630, '2020-02-01', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63631, '2020-02-02', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63632, '2020-02-03', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63633, '2020-02-04', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63634, '2020-02-05', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63635, '2020-02-06', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63636, '2020-02-07', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63637, '2020-02-08', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63638, '2020-02-09', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63639, '2020-02-10', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63640, '2020-02-11', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63641, '2020-02-12', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63642, '2020-02-13', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63643, '2020-02-14', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63644, '2020-02-15', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63645, '2020-02-16', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63646, '2020-02-17', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63647, '2020-02-18', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63648, '2020-02-19', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63649, '2020-02-20', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63650, '2020-02-21', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63651, '2020-02-22', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63652, '2020-02-23', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63653, '2020-02-24', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63654, '2020-02-25', 'PK', 'Pakistan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63655, '2020-02-26', 'PK', 'Pakistan', 'EMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63656, '2020-02-27', 'PK', 'Pakistan', 'EMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63657, '2020-02-28', 'PK', 'Pakistan', 'EMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63658, '2020-02-29', 'PK', 'Pakistan', 'EMRO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63659, '2020-03-01', 'PK', 'Pakistan', 'EMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63660, '2020-03-02', 'PK', 'Pakistan', 'EMRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63661, '2020-03-03', 'PK', 'Pakistan', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63662, '2020-03-04', 'PK', 'Pakistan', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63663, '2020-03-05', 'PK', 'Pakistan', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63664, '2020-03-06', 'PK', 'Pakistan', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63665, '2020-03-07', 'PK', 'Pakistan', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63666, '2020-03-08', 'PK', 'Pakistan', 'EMRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63667, '2020-03-09', 'PK', 'Pakistan', 'EMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63668, '2020-03-10', 'PK', 'Pakistan', 'EMRO', '10', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63669, '2020-03-11', 'PK', 'Pakistan', 'EMRO', '3', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63670, '2020-03-12', 'PK', 'Pakistan', 'EMRO', '1', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63671, '2020-03-13', 'PK', 'Pakistan', 'EMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63672, '2020-03-14', 'PK', 'Pakistan', 'EMRO', '8', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63673, '2020-03-15', 'PK', 'Pakistan', 'EMRO', '24', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63674, '2020-03-16', 'PK', 'Pakistan', 'EMRO', '1', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63675, '2020-03-17', 'PK', 'Pakistan', 'EMRO', '134', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63676, '2020-03-18', 'PK', 'Pakistan', 'EMRO', '54', '245', '0', '0');
INSERT INTO public.who_global_data_import VALUES (63677, '2020-03-19', 'PK', 'Pakistan', 'EMRO', '61', '306', '2', '2');
INSERT INTO public.who_global_data_import VALUES (63678, '2020-03-20', 'PK', 'Pakistan', 'EMRO', '155', '461', '0', '2');
INSERT INTO public.who_global_data_import VALUES (63679, '2020-03-21', 'PK', 'Pakistan', 'EMRO', '34', '495', '1', '3');
INSERT INTO public.who_global_data_import VALUES (63680, '2020-03-22', 'PK', 'Pakistan', 'EMRO', '151', '646', '0', '3');
INSERT INTO public.who_global_data_import VALUES (63681, '2020-03-23', 'PK', 'Pakistan', 'EMRO', '138', '784', '2', '5');
INSERT INTO public.who_global_data_import VALUES (63682, '2020-03-24', 'PK', 'Pakistan', 'EMRO', '103', '887', '1', '6');
INSERT INTO public.who_global_data_import VALUES (63683, '2020-03-25', 'PK', 'Pakistan', 'EMRO', '104', '991', '1', '7');
INSERT INTO public.who_global_data_import VALUES (63684, '2020-03-26', 'PK', 'Pakistan', 'EMRO', '66', '1057', '1', '8');
INSERT INTO public.who_global_data_import VALUES (63685, '2020-03-27', 'PK', 'Pakistan', 'EMRO', '140', '1197', '1', '9');
INSERT INTO public.who_global_data_import VALUES (63686, '2020-03-28', 'PK', 'Pakistan', 'EMRO', '211', '1408', '2', '11');
INSERT INTO public.who_global_data_import VALUES (63687, '2020-03-29', 'PK', 'Pakistan', 'EMRO', '118', '1526', '2', '13');
INSERT INTO public.who_global_data_import VALUES (63688, '2020-03-30', 'PK', 'Pakistan', 'EMRO', '99', '1625', '5', '18');
INSERT INTO public.who_global_data_import VALUES (63689, '2020-03-31', 'PK', 'Pakistan', 'EMRO', '240', '1865', '7', '25');
INSERT INTO public.who_global_data_import VALUES (63690, '2020-04-01', 'PK', 'Pakistan', 'EMRO', '174', '2039', '1', '26');
INSERT INTO public.who_global_data_import VALUES (63691, '2020-04-02', 'PK', 'Pakistan', 'EMRO', '252', '2291', '5', '31');
INSERT INTO public.who_global_data_import VALUES (63692, '2020-04-03', 'PK', 'Pakistan', 'EMRO', '159', '2450', '4', '35');
INSERT INTO public.who_global_data_import VALUES (63693, '2020-04-04', 'PK', 'Pakistan', 'EMRO', '0', '2450', '0', '35');
INSERT INTO public.who_global_data_import VALUES (63694, '2020-04-05', 'PK', 'Pakistan', 'EMRO', '609', '3059', '10', '45');
INSERT INTO public.who_global_data_import VALUES (63695, '2020-04-06', 'PK', 'Pakistan', 'EMRO', '365', '3424', '5', '50');
INSERT INTO public.who_global_data_import VALUES (63696, '2020-04-07', 'PK', 'Pakistan', 'EMRO', '581', '4005', '4', '54');
INSERT INTO public.who_global_data_import VALUES (63697, '2020-04-08', 'PK', 'Pakistan', 'EMRO', '178', '4183', '4', '58');
INSERT INTO public.who_global_data_import VALUES (63698, '2020-04-09', 'PK', 'Pakistan', 'EMRO', '306', '4489', '5', '63');
INSERT INTO public.who_global_data_import VALUES (63699, '2020-04-10', 'PK', 'Pakistan', 'EMRO', '206', '4695', '3', '66');
INSERT INTO public.who_global_data_import VALUES (63700, '2020-04-11', 'PK', 'Pakistan', 'EMRO', '275', '4970', '11', '77');
INSERT INTO public.who_global_data_import VALUES (63701, '2020-04-12', 'PK', 'Pakistan', 'EMRO', '213', '5183', '11', '88');
INSERT INTO public.who_global_data_import VALUES (63702, '2020-04-13', 'PK', 'Pakistan', 'EMRO', '313', '5496', '5', '93');
INSERT INTO public.who_global_data_import VALUES (63703, '2020-04-14', 'PK', 'Pakistan', 'EMRO', '341', '5837', '3', '96');
INSERT INTO public.who_global_data_import VALUES (63704, '2020-04-15', 'PK', 'Pakistan', 'EMRO', '151', '5988', '11', '107');
INSERT INTO public.who_global_data_import VALUES (63705, '2020-04-16', 'PK', 'Pakistan', 'EMRO', '931', '6919', '21', '128');
INSERT INTO public.who_global_data_import VALUES (63706, '2020-04-17', 'PK', 'Pakistan', 'EMRO', '106', '7025', '7', '135');
INSERT INTO public.who_global_data_import VALUES (63707, '2020-04-18', 'PK', 'Pakistan', 'EMRO', '613', '7638', '8', '143');
INSERT INTO public.who_global_data_import VALUES (63708, '2020-04-19', 'PK', 'Pakistan', 'EMRO', '355', '7993', '16', '159');
INSERT INTO public.who_global_data_import VALUES (63709, '2020-04-20', 'PK', 'Pakistan', 'EMRO', '425', '8418', '17', '176');
INSERT INTO public.who_global_data_import VALUES (63710, '2020-04-21', 'PK', 'Pakistan', 'EMRO', '1087', '9505', '21', '197');
INSERT INTO public.who_global_data_import VALUES (63711, '2020-04-22', 'PK', 'Pakistan', 'EMRO', '244', '9749', '12', '209');
INSERT INTO public.who_global_data_import VALUES (63712, '2020-04-23', 'PK', 'Pakistan', 'EMRO', '1066', '10815', '19', '228');
INSERT INTO public.who_global_data_import VALUES (63713, '2020-04-24', 'PK', 'Pakistan', 'EMRO', '340', '11155', '9', '237');
INSERT INTO public.who_global_data_import VALUES (63714, '2020-04-25', 'PK', 'Pakistan', 'EMRO', '1072', '12227', '19', '256');
INSERT INTO public.who_global_data_import VALUES (63715, '2020-04-26', 'PK', 'Pakistan', 'EMRO', '970', '13197', '21', '277');
INSERT INTO public.who_global_data_import VALUES (63716, '2020-04-27', 'PK', 'Pakistan', 'EMRO', '718', '13915', '15', '292');
INSERT INTO public.who_global_data_import VALUES (63717, '2020-04-28', 'PK', 'Pakistan', 'EMRO', '164', '14079', '9', '301');
INSERT INTO public.who_global_data_import VALUES (63718, '2020-04-29', 'PK', 'Pakistan', 'EMRO', '1210', '15289', '34', '335');
INSERT INTO public.who_global_data_import VALUES (63719, '2020-04-30', 'PK', 'Pakistan', 'EMRO', '828', '16117', '23', '358');
INSERT INTO public.who_global_data_import VALUES (63720, '2020-05-01', 'PK', 'Pakistan', 'EMRO', '1494', '17611', '48', '406');
INSERT INTO public.who_global_data_import VALUES (63721, '2020-05-02', 'PK', 'Pakistan', 'EMRO', '1159', '18770', '26', '432');
INSERT INTO public.who_global_data_import VALUES (63722, '2020-05-03', 'PK', 'Pakistan', 'EMRO', '1314', '20084', '25', '457');
INSERT INTO public.who_global_data_import VALUES (63723, '2020-05-04', 'PK', 'Pakistan', 'EMRO', '800', '20884', '19', '476');
INSERT INTO public.who_global_data_import VALUES (63724, '2020-05-05', 'PK', 'Pakistan', 'EMRO', '617', '21501', '10', '486');
INSERT INTO public.who_global_data_import VALUES (63725, '2020-05-06', 'PK', 'Pakistan', 'EMRO', '1049', '22550', '40', '526');
INSERT INTO public.who_global_data_import VALUES (63726, '2020-05-07', 'PK', 'Pakistan', 'EMRO', '2094', '24644', '59', '585');
INSERT INTO public.who_global_data_import VALUES (63727, '2020-05-08', 'PK', 'Pakistan', 'EMRO', '1791', '26435', '14', '599');
INSERT INTO public.who_global_data_import VALUES (63728, '2020-05-09', 'PK', 'Pakistan', 'EMRO', '1039', '27474', '19', '618');
INSERT INTO public.who_global_data_import VALUES (63729, '2020-05-10', 'PK', 'Pakistan', 'EMRO', '1991', '29465', '21', '639');
INSERT INTO public.who_global_data_import VALUES (63730, '2020-05-11', 'PK', 'Pakistan', 'EMRO', '1476', '30941', '28', '667');
INSERT INTO public.who_global_data_import VALUES (63731, '2020-05-12', 'PK', 'Pakistan', 'EMRO', '1733', '32674', '57', '724');
INSERT INTO public.who_global_data_import VALUES (63732, '2020-05-13', 'PK', 'Pakistan', 'EMRO', '1662', '34336', '13', '737');
INSERT INTO public.who_global_data_import VALUES (63733, '2020-05-14', 'PK', 'Pakistan', 'EMRO', '1452', '35788', '33', '770');
INSERT INTO public.who_global_data_import VALUES (63734, '2020-05-15', 'PK', 'Pakistan', 'EMRO', '1430', '37218', '33', '803');
INSERT INTO public.who_global_data_import VALUES (63735, '2020-05-16', 'PK', 'Pakistan', 'EMRO', '1581', '38799', '31', '834');
INSERT INTO public.who_global_data_import VALUES (63736, '2020-05-17', 'PK', 'Pakistan', 'EMRO', '1352', '40151', '39', '873');
INSERT INTO public.who_global_data_import VALUES (63737, '2020-05-18', 'PK', 'Pakistan', 'EMRO', '1974', '42125', '30', '903');
INSERT INTO public.who_global_data_import VALUES (63738, '2020-05-19', 'PK', 'Pakistan', 'EMRO', '1841', '43966', '36', '939');
INSERT INTO public.who_global_data_import VALUES (63739, '2020-05-20', 'PK', 'Pakistan', 'EMRO', '1932', '45898', '46', '985');
INSERT INTO public.who_global_data_import VALUES (63740, '2020-05-21', 'PK', 'Pakistan', 'EMRO', '2193', '48091', '32', '1017');
INSERT INTO public.who_global_data_import VALUES (63741, '2020-05-22', 'PK', 'Pakistan', 'EMRO', '2603', '50694', '50', '1067');
INSERT INTO public.who_global_data_import VALUES (63742, '2020-05-23', 'PK', 'Pakistan', 'EMRO', '1743', '52437', '34', '1101');
INSERT INTO public.who_global_data_import VALUES (63743, '2020-05-24', 'PK', 'Pakistan', 'EMRO', '2164', '54601', '32', '1133');
INSERT INTO public.who_global_data_import VALUES (63744, '2020-05-25', 'PK', 'Pakistan', 'EMRO', '1748', '56349', '34', '1167');
INSERT INTO public.who_global_data_import VALUES (63745, '2020-05-26', 'PK', 'Pakistan', 'EMRO', '1356', '57705', '30', '1197');
INSERT INTO public.who_global_data_import VALUES (63746, '2020-05-27', 'PK', 'Pakistan', 'EMRO', '1446', '59151', '28', '1225');
INSERT INTO public.who_global_data_import VALUES (63747, '2020-05-28', 'PK', 'Pakistan', 'EMRO', '2076', '61227', '35', '1260');
INSERT INTO public.who_global_data_import VALUES (63748, '2020-05-29', 'PK', 'Pakistan', 'EMRO', '2801', '64028', '57', '1317');
INSERT INTO public.who_global_data_import VALUES (63749, '2020-05-30', 'PK', 'Pakistan', 'EMRO', '2429', '66457', '78', '1395');
INSERT INTO public.who_global_data_import VALUES (63750, '2020-05-31', 'PK', 'Pakistan', 'EMRO', '3039', '69496', '88', '1483');
INSERT INTO public.who_global_data_import VALUES (63751, '2020-06-01', 'PK', 'Pakistan', 'EMRO', '2964', '72460', '60', '1543');
INSERT INTO public.who_global_data_import VALUES (63752, '2020-06-02', 'PK', 'Pakistan', 'EMRO', '3938', '76398', '78', '1621');
INSERT INTO public.who_global_data_import VALUES (63753, '2020-06-03', 'PK', 'Pakistan', 'EMRO', '4065', '80463', '67', '1688');
INSERT INTO public.who_global_data_import VALUES (63754, '2020-06-04', 'PK', 'Pakistan', 'EMRO', '4801', '85264', '82', '1770');
INSERT INTO public.who_global_data_import VALUES (63755, '2020-06-05', 'PK', 'Pakistan', 'EMRO', '3985', '89249', '68', '1838');
INSERT INTO public.who_global_data_import VALUES (63756, '2020-06-06', 'PK', 'Pakistan', 'EMRO', '4734', '93983', '97', '1935');
INSERT INTO public.who_global_data_import VALUES (63757, '2020-06-07', 'PK', 'Pakistan', 'EMRO', '4960', '98943', '67', '2002');
INSERT INTO public.who_global_data_import VALUES (63758, '2020-06-08', 'PK', 'Pakistan', 'EMRO', '4728', '103671', '65', '2067');
INSERT INTO public.who_global_data_import VALUES (63759, '2020-06-09', 'PK', 'Pakistan', 'EMRO', '4646', '108317', '105', '2172');
INSERT INTO public.who_global_data_import VALUES (63760, '2020-06-10', 'PK', 'Pakistan', 'EMRO', '5385', '113702', '83', '2255');
INSERT INTO public.who_global_data_import VALUES (63761, '2020-06-11', 'PK', 'Pakistan', 'EMRO', '5834', '119536', '101', '2356');
INSERT INTO public.who_global_data_import VALUES (63762, '2020-06-12', 'PK', 'Pakistan', 'EMRO', '5985', '125521', '107', '2463');
INSERT INTO public.who_global_data_import VALUES (63763, '2020-06-13', 'PK', 'Pakistan', 'EMRO', '6884', '132405', '88', '2551');
INSERT INTO public.who_global_data_import VALUES (63764, '2020-06-14', 'PK', 'Pakistan', 'EMRO', '6825', '139230', '81', '2632');
INSERT INTO public.who_global_data_import VALUES (63765, '2020-06-15', 'PK', 'Pakistan', 'EMRO', '5248', '144478', '97', '2729');
INSERT INTO public.who_global_data_import VALUES (63766, '2020-06-16', 'PK', 'Pakistan', 'EMRO', '4443', '148921', '110', '2839');
INSERT INTO public.who_global_data_import VALUES (63767, '2020-06-17', 'PK', 'Pakistan', 'EMRO', '5839', '154760', '136', '2975');
INSERT INTO public.who_global_data_import VALUES (63768, '2020-06-18', 'PK', 'Pakistan', 'EMRO', '5358', '160118', '118', '3093');
INSERT INTO public.who_global_data_import VALUES (63769, '2020-06-19', 'PK', 'Pakistan', 'EMRO', '4944', '165062', '136', '3229');
INSERT INTO public.who_global_data_import VALUES (63770, '2020-06-20', 'PK', 'Pakistan', 'EMRO', '6604', '171666', '153', '3382');
INSERT INTO public.who_global_data_import VALUES (63771, '2020-06-21', 'PK', 'Pakistan', 'EMRO', '4951', '176617', '119', '3501');
INSERT INTO public.who_global_data_import VALUES (63772, '2020-06-22', 'PK', 'Pakistan', 'EMRO', '4471', '181088', '89', '3590');
INSERT INTO public.who_global_data_import VALUES (63773, '2020-06-23', 'PK', 'Pakistan', 'EMRO', '3946', '185034', '105', '3695');
INSERT INTO public.who_global_data_import VALUES (63774, '2020-06-24', 'PK', 'Pakistan', 'EMRO', '3892', '188926', '60', '3755');
INSERT INTO public.who_global_data_import VALUES (63775, '2020-06-25', 'PK', 'Pakistan', 'EMRO', '4044', '192970', '148', '3903');
INSERT INTO public.who_global_data_import VALUES (63776, '2020-06-26', 'PK', 'Pakistan', 'EMRO', '2775', '195745', '59', '3962');
INSERT INTO public.who_global_data_import VALUES (63777, '2020-06-27', 'PK', 'Pakistan', 'EMRO', '3138', '198883', '73', '4035');
INSERT INTO public.who_global_data_import VALUES (63778, '2020-06-28', 'PK', 'Pakistan', 'EMRO', '4072', '202955', '83', '4118');
INSERT INTO public.who_global_data_import VALUES (63779, '2020-06-29', 'PK', 'Pakistan', 'EMRO', '3557', '206512', '49', '4167');
INSERT INTO public.who_global_data_import VALUES (63780, '2020-06-30', 'PK', 'Pakistan', 'EMRO', '2825', '209337', '137', '4304');
INSERT INTO public.who_global_data_import VALUES (63781, '2020-07-01', 'PK', 'Pakistan', 'EMRO', '4133', '213470', '91', '4395');
INSERT INTO public.who_global_data_import VALUES (63782, '2020-07-02', 'PK', 'Pakistan', 'EMRO', '4339', '217809', '78', '4473');
INSERT INTO public.who_global_data_import VALUES (63783, '2020-07-03', 'PK', 'Pakistan', 'EMRO', '4087', '221896', '78', '4551');
INSERT INTO public.who_global_data_import VALUES (63784, '2020-07-04', 'PK', 'Pakistan', 'EMRO', '3387', '225283', '68', '4619');
INSERT INTO public.who_global_data_import VALUES (63785, '2020-07-05', 'PK', 'Pakistan', 'EMRO', '3191', '228474', '93', '4712');
INSERT INTO public.who_global_data_import VALUES (63786, '2020-07-06', 'PK', 'Pakistan', 'EMRO', '3344', '231818', '50', '4762');
INSERT INTO public.who_global_data_import VALUES (63787, '2020-07-07', 'PK', 'Pakistan', 'EMRO', '2691', '234509', '77', '4839');
INSERT INTO public.who_global_data_import VALUES (63788, '2020-07-08', 'PK', 'Pakistan', 'EMRO', '2980', '237489', '83', '4922');
INSERT INTO public.who_global_data_import VALUES (63789, '2020-07-09', 'PK', 'Pakistan', 'EMRO', '3359', '240848', '61', '4983');
INSERT INTO public.who_global_data_import VALUES (63790, '2020-07-10', 'PK', 'Pakistan', 'EMRO', '2748', '243596', '75', '5058');
INSERT INTO public.who_global_data_import VALUES (63791, '2020-07-11', 'PK', 'Pakistan', 'EMRO', '2755', '246351', '65', '5123');
INSERT INTO public.who_global_data_import VALUES (63792, '2020-07-12', 'PK', 'Pakistan', 'EMRO', '2521', '248872', '74', '5197');
INSERT INTO public.who_global_data_import VALUES (63793, '2020-07-13', 'PK', 'Pakistan', 'EMRO', '2753', '251625', '73', '5270');
INSERT INTO public.who_global_data_import VALUES (63794, '2020-07-14', 'PK', 'Pakistan', 'EMRO', '1979', '253604', '49', '5319');
INSERT INTO public.who_global_data_import VALUES (63795, '2020-07-15', 'PK', 'Pakistan', 'EMRO', '2165', '255769', '67', '5386');
INSERT INTO public.who_global_data_import VALUES (63796, '2020-07-16', 'PK', 'Pakistan', 'EMRO', '2145', '257914', '40', '5426');
INSERT INTO public.who_global_data_import VALUES (63797, '2020-07-17', 'PK', 'Pakistan', 'EMRO', '2085', '259999', '49', '5475');
INSERT INTO public.who_global_data_import VALUES (63798, '2020-07-18', 'PK', 'Pakistan', 'EMRO', '1918', '261917', '47', '5522');
INSERT INTO public.who_global_data_import VALUES (63799, '2020-07-19', 'PK', 'Pakistan', 'EMRO', '1579', '263496', '46', '5568');
INSERT INTO public.who_global_data_import VALUES (63800, '2020-07-20', 'PK', 'Pakistan', 'EMRO', '1587', '265083', '31', '5599');
INSERT INTO public.who_global_data_import VALUES (63801, '2020-07-21', 'PK', 'Pakistan', 'EMRO', '1013', '266096', '40', '5639');
INSERT INTO public.who_global_data_import VALUES (63802, '2020-07-22', 'PK', 'Pakistan', 'EMRO', '1332', '267428', '38', '5677');
INSERT INTO public.who_global_data_import VALUES (63803, '2020-07-23', 'PK', 'Pakistan', 'EMRO', '1763', '269191', '32', '5709');
INSERT INTO public.who_global_data_import VALUES (63804, '2020-07-24', 'PK', 'Pakistan', 'EMRO', '1209', '270400', '54', '5763');
INSERT INTO public.who_global_data_import VALUES (63805, '2020-07-25', 'PK', 'Pakistan', 'EMRO', '1487', '271887', '24', '5787');
INSERT INTO public.who_global_data_import VALUES (63806, '2020-07-26', 'PK', 'Pakistan', 'EMRO', '1226', '273113', '35', '5822');
INSERT INTO public.who_global_data_import VALUES (63807, '2020-07-27', 'PK', 'Pakistan', 'EMRO', '1176', '274289', '20', '5842');
INSERT INTO public.who_global_data_import VALUES (63808, '2020-07-28', 'PK', 'Pakistan', 'EMRO', '936', '275225', '23', '5865');
INSERT INTO public.who_global_data_import VALUES (63809, '2020-07-29', 'PK', 'Pakistan', 'EMRO', '1063', '276288', '27', '5892');
INSERT INTO public.who_global_data_import VALUES (63810, '2020-07-30', 'PK', 'Pakistan', 'EMRO', '1114', '277402', '32', '5924');
INSERT INTO public.who_global_data_import VALUES (63811, '2020-07-31', 'PK', 'Pakistan', 'EMRO', '903', '278305', '27', '5951');
INSERT INTO public.who_global_data_import VALUES (63812, '2020-08-01', 'PK', 'Pakistan', 'EMRO', '841', '279146', '19', '5970');
INSERT INTO public.who_global_data_import VALUES (63813, '2020-08-02', 'PK', 'Pakistan', 'EMRO', '553', '279699', '6', '5976');
INSERT INTO public.who_global_data_import VALUES (63814, '2020-08-03', 'PK', 'Pakistan', 'EMRO', '330', '280029', '8', '5984');
INSERT INTO public.who_global_data_import VALUES (63815, '2020-08-04', 'PK', 'Pakistan', 'EMRO', '432', '280461', '15', '5999');
INSERT INTO public.who_global_data_import VALUES (63816, '2020-08-05', 'PK', 'Pakistan', 'EMRO', '675', '281136', '15', '6014');
INSERT INTO public.who_global_data_import VALUES (63817, '2020-08-06', 'PK', 'Pakistan', 'EMRO', '727', '281863', '21', '6035');
INSERT INTO public.who_global_data_import VALUES (63818, '2020-08-07', 'PK', 'Pakistan', 'EMRO', '782', '282645', '19', '6054');
INSERT INTO public.who_global_data_import VALUES (63819, '2020-08-08', 'PK', 'Pakistan', 'EMRO', '842', '283487', '20', '6074');
INSERT INTO public.who_global_data_import VALUES (63820, '2020-08-09', 'PK', 'Pakistan', 'EMRO', '634', '284121', '8', '6082');
INSERT INTO public.who_global_data_import VALUES (63821, '2020-08-10', 'PK', 'Pakistan', 'EMRO', '539', '284660', '15', '6097');
INSERT INTO public.who_global_data_import VALUES (63822, '2020-08-11', 'PK', 'Pakistan', 'EMRO', '531', '285191', '15', '6112');
INSERT INTO public.who_global_data_import VALUES (63823, '2020-08-12', 'PK', 'Pakistan', 'EMRO', '730', '285921', '17', '6129');
INSERT INTO public.who_global_data_import VALUES (63824, '2020-08-13', 'PK', 'Pakistan', 'EMRO', '753', '286674', '10', '6139');
INSERT INTO public.who_global_data_import VALUES (63825, '2020-08-14', 'PK', 'Pakistan', 'EMRO', '626', '287300', '14', '6153');
INSERT INTO public.who_global_data_import VALUES (63826, '2020-08-15', 'PK', 'Pakistan', 'EMRO', '747', '288047', '9', '6162');
INSERT INTO public.who_global_data_import VALUES (63827, '2020-08-16', 'PK', 'Pakistan', 'EMRO', '670', '288717', '6', '6168');
INSERT INTO public.who_global_data_import VALUES (63828, '2020-08-17', 'PK', 'Pakistan', 'EMRO', '498', '289215', '7', '6175');
INSERT INTO public.who_global_data_import VALUES (63829, '2020-08-18', 'PK', 'Pakistan', 'EMRO', '617', '289832', '15', '6190');
INSERT INTO public.who_global_data_import VALUES (63830, '2020-08-19', 'PK', 'Pakistan', 'EMRO', '613', '290445', '11', '6201');
INSERT INTO public.who_global_data_import VALUES (63831, '2020-08-20', 'PK', 'Pakistan', 'EMRO', '513', '290958', '8', '6209');
INSERT INTO public.who_global_data_import VALUES (63832, '2020-08-21', 'PK', 'Pakistan', 'EMRO', '630', '291588', '10', '6219');
INSERT INTO public.who_global_data_import VALUES (63833, '2020-08-22', 'PK', 'Pakistan', 'EMRO', '586', '292174', '12', '6231');
INSERT INTO public.who_global_data_import VALUES (63834, '2020-08-23', 'PK', 'Pakistan', 'EMRO', '591', '292765', '4', '6235');
INSERT INTO public.who_global_data_import VALUES (63835, '2020-08-24', 'PK', 'Pakistan', 'EMRO', '496', '293261', '9', '6244');
INSERT INTO public.who_global_data_import VALUES (63836, '2020-08-25', 'PK', 'Pakistan', 'EMRO', '450', '293711', '11', '6255');
INSERT INTO public.who_global_data_import VALUES (63837, '2020-08-26', 'PK', 'Pakistan', 'EMRO', '482', '294193', '12', '6267');
INSERT INTO public.who_global_data_import VALUES (63838, '2020-08-27', 'PK', 'Pakistan', 'EMRO', '445', '294638', '7', '6274');
INSERT INTO public.who_global_data_import VALUES (63839, '2020-08-28', 'PK', 'Pakistan', 'EMRO', '415', '295053', '9', '6283');
INSERT INTO public.who_global_data_import VALUES (63840, '2020-08-29', 'PK', 'Pakistan', 'EMRO', '319', '295372', '1', '6284');
INSERT INTO public.who_global_data_import VALUES (63841, '2020-08-30', 'PK', 'Pakistan', 'EMRO', '264', '295636', '4', '6288');
INSERT INTO public.who_global_data_import VALUES (63842, '2020-08-31', 'PK', 'Pakistan', 'EMRO', '213', '295849', '6', '6294');
INSERT INTO public.who_global_data_import VALUES (63843, '2020-09-01', 'PK', 'Pakistan', 'EMRO', '300', '296149', '4', '6298');
INSERT INTO public.who_global_data_import VALUES (63844, '2020-09-02', 'PK', 'Pakistan', 'EMRO', '441', '296590', '20', '6318');
INSERT INTO public.who_global_data_import VALUES (63845, '2020-09-03', 'PK', 'Pakistan', 'EMRO', '424', '297014', '10', '6328');
INSERT INTO public.who_global_data_import VALUES (63846, '2020-09-04', 'PK', 'Pakistan', 'EMRO', '498', '297512', '7', '6335');
INSERT INTO public.who_global_data_import VALUES (63847, '2020-09-05', 'PK', 'Pakistan', 'EMRO', '513', '298025', '5', '6340');
INSERT INTO public.who_global_data_import VALUES (63848, '2020-09-06', 'PK', 'Pakistan', 'EMRO', '484', '298509', '2', '6342');
INSERT INTO public.who_global_data_import VALUES (63849, '2020-09-07', 'PK', 'Pakistan', 'EMRO', '394', '298903', '3', '6345');
INSERT INTO public.who_global_data_import VALUES (63850, '2020-09-08', 'PK', 'Pakistan', 'EMRO', '330', '299233', '5', '6350');
INSERT INTO public.who_global_data_import VALUES (63851, '2020-09-09', 'PK', 'Pakistan', 'EMRO', '426', '299659', '9', '6359');
INSERT INTO public.who_global_data_import VALUES (63852, '2020-09-10', 'PK', 'Pakistan', 'EMRO', '196', '299855', '6', '6365');
INSERT INTO public.who_global_data_import VALUES (63853, '2020-09-11', 'PK', 'Pakistan', 'EMRO', '516', '300371', '5', '6370');
INSERT INTO public.who_global_data_import VALUES (63854, '2020-09-12', 'PK', 'Pakistan', 'EMRO', '584', '300955', '3', '6373');
INSERT INTO public.who_global_data_import VALUES (63855, '2020-09-13', 'PK', 'Pakistan', 'EMRO', '526', '301481', '6', '6379');
INSERT INTO public.who_global_data_import VALUES (63856, '2020-09-14', 'PK', 'Pakistan', 'EMRO', '539', '302020', '4', '6383');
INSERT INTO public.who_global_data_import VALUES (63857, '2020-09-15', 'PK', 'Pakistan', 'EMRO', '404', '302424', '6', '6389');
INSERT INTO public.who_global_data_import VALUES (63858, '2020-09-16', 'PK', 'Pakistan', 'EMRO', '665', '303089', '4', '6393');
INSERT INTO public.who_global_data_import VALUES (63859, '2020-09-17', 'PK', 'Pakistan', 'EMRO', '545', '303634', '6', '6399');
INSERT INTO public.who_global_data_import VALUES (63860, '2020-09-18', 'PK', 'Pakistan', 'EMRO', '752', '304386', '9', '6408');
INSERT INTO public.who_global_data_import VALUES (63861, '2020-09-19', 'PK', 'Pakistan', 'EMRO', '645', '305031', '7', '6415');
INSERT INTO public.who_global_data_import VALUES (63862, '2020-09-20', 'PK', 'Pakistan', 'EMRO', '640', '305671', '1', '6416');
INSERT INTO public.who_global_data_import VALUES (63863, '2020-09-21', 'PK', 'Pakistan', 'EMRO', '633', '306304', '4', '6420');
INSERT INTO public.who_global_data_import VALUES (63864, '2020-09-22', 'PK', 'Pakistan', 'EMRO', '582', '306886', '4', '6424');
INSERT INTO public.who_global_data_import VALUES (63865, '2020-09-23', 'PK', 'Pakistan', 'EMRO', '532', '307418', '8', '6432');
INSERT INTO public.who_global_data_import VALUES (63866, '2020-09-24', 'PK', 'Pakistan', 'EMRO', '799', '308217', '5', '6437');
INSERT INTO public.who_global_data_import VALUES (63867, '2020-09-25', 'PK', 'Pakistan', 'EMRO', '798', '309015', '7', '6444');
INSERT INTO public.who_global_data_import VALUES (63868, '2020-09-26', 'PK', 'Pakistan', 'EMRO', '566', '309581', '7', '6451');
INSERT INTO public.who_global_data_import VALUES (63869, '2020-09-27', 'PK', 'Pakistan', 'EMRO', '694', '310275', '6', '6457');
INSERT INTO public.who_global_data_import VALUES (63870, '2020-09-28', 'PK', 'Pakistan', 'EMRO', '566', '310841', '9', '6466');
INSERT INTO public.who_global_data_import VALUES (63871, '2020-09-29', 'PK', 'Pakistan', 'EMRO', '675', '311516', '8', '6474');
INSERT INTO public.who_global_data_import VALUES (63872, '2020-09-30', 'PK', 'Pakistan', 'EMRO', '747', '312263', '5', '6479');
INSERT INTO public.who_global_data_import VALUES (63873, '2020-10-01', 'PK', 'Pakistan', 'EMRO', '543', '312806', '5', '6484');
INSERT INTO public.who_global_data_import VALUES (63874, '2020-10-02', 'PK', 'Pakistan', 'EMRO', '625', '313431', '15', '6499');
INSERT INTO public.who_global_data_import VALUES (63875, '2020-10-03', 'PK', 'Pakistan', 'EMRO', '553', '313984', '8', '6507');
INSERT INTO public.who_global_data_import VALUES (63876, '2020-10-04', 'PK', 'Pakistan', 'EMRO', '632', '314616', '6', '6513');
INSERT INTO public.who_global_data_import VALUES (63877, '2020-10-05', 'PK', 'Pakistan', 'EMRO', '644', '315260', '4', '6517');
INSERT INTO public.who_global_data_import VALUES (63878, '2020-10-06', 'PK', 'Pakistan', 'EMRO', '467', '315727', '6', '6523');
INSERT INTO public.who_global_data_import VALUES (63879, '2020-10-07', 'PK', 'Pakistan', 'EMRO', '624', '316351', '12', '6535');
INSERT INTO public.who_global_data_import VALUES (63880, '2020-10-08', 'PK', 'Pakistan', 'EMRO', '583', '316934', '9', '6544');
INSERT INTO public.who_global_data_import VALUES (63881, '2020-10-09', 'PK', 'Pakistan', 'EMRO', '661', '317595', '8', '6552');
INSERT INTO public.who_global_data_import VALUES (63882, '2020-10-10', 'PK', 'Pakistan', 'EMRO', '671', '318266', '6', '6558');
INSERT INTO public.who_global_data_import VALUES (63883, '2020-10-11', 'PK', 'Pakistan', 'EMRO', '666', '318932', '12', '6570');
INSERT INTO public.who_global_data_import VALUES (63884, '2020-10-12', 'PK', 'Pakistan', 'EMRO', '385', '319317', '10', '6580');
INSERT INTO public.who_global_data_import VALUES (63885, '2020-10-13', 'PK', 'Pakistan', 'EMRO', '531', '319848', '8', '6588');
INSERT INTO public.who_global_data_import VALUES (63886, '2020-10-14', 'PK', 'Pakistan', 'EMRO', '615', '320463', '13', '6601');
INSERT INTO public.who_global_data_import VALUES (63887, '2020-10-15', 'PK', 'Pakistan', 'EMRO', '755', '321218', '13', '6614');
INSERT INTO public.who_global_data_import VALUES (63888, '2020-10-16', 'PK', 'Pakistan', 'EMRO', '593', '321811', '7', '6621');
INSERT INTO public.who_global_data_import VALUES (63889, '2020-10-17', 'PK', 'Pakistan', 'EMRO', '641', '322452', '17', '6638');
INSERT INTO public.who_global_data_import VALUES (63890, '2020-10-18', 'PK', 'Pakistan', 'EMRO', '567', '323019', '16', '6654');
INSERT INTO public.who_global_data_import VALUES (63891, '2020-10-19', 'PK', 'Pakistan', 'EMRO', '440', '323459', '5', '6659');
INSERT INTO public.who_global_data_import VALUES (63892, '2020-10-20', 'PK', 'Pakistan', 'EMRO', '618', '324077', '14', '6673');
INSERT INTO public.who_global_data_import VALUES (63893, '2020-10-21', 'PK', 'Pakistan', 'EMRO', '0', '324077', '0', '6673');
INSERT INTO public.who_global_data_import VALUES (63894, '2020-10-22', 'PK', 'Pakistan', 'EMRO', '660', '324737', '19', '6692');
INSERT INTO public.who_global_data_import VALUES (63895, '2020-10-23', 'PK', 'Pakistan', 'EMRO', '736', '325473', '10', '6702');
INSERT INTO public.who_global_data_import VALUES (63896, '2020-10-24', 'PK', 'Pakistan', 'EMRO', '736', '326209', '13', '6715');
INSERT INTO public.who_global_data_import VALUES (63897, '2020-10-25', 'PK', 'Pakistan', 'EMRO', '847', '327056', '12', '6727');
INSERT INTO public.who_global_data_import VALUES (63898, '2020-10-26', 'PK', 'Pakistan', 'EMRO', '839', '327895', '9', '6736');
INSERT INTO public.who_global_data_import VALUES (63899, '2020-10-27', 'PK', 'Pakistan', 'EMRO', '707', '328602', '3', '6739');
INSERT INTO public.who_global_data_import VALUES (63900, '2020-10-28', 'PK', 'Pakistan', 'EMRO', '773', '329375', '6', '6745');
INSERT INTO public.who_global_data_import VALUES (63901, '2020-10-29', 'PK', 'Pakistan', 'EMRO', '825', '330200', '14', '6759');
INSERT INTO public.who_global_data_import VALUES (63902, '2020-10-30', 'PK', 'Pakistan', 'EMRO', '908', '331108', '16', '6775');
INSERT INTO public.who_global_data_import VALUES (63903, '2020-10-31', 'PK', 'Pakistan', 'EMRO', '1078', '332186', '20', '6795');
INSERT INTO public.who_global_data_import VALUES (63904, '2020-11-01', 'PK', 'Pakistan', 'EMRO', '807', '332993', '11', '6806');
INSERT INTO public.who_global_data_import VALUES (63905, '2020-11-02', 'PK', 'Pakistan', 'EMRO', '977', '333970', '17', '6823');
INSERT INTO public.who_global_data_import VALUES (63906, '2020-11-03', 'PK', 'Pakistan', 'EMRO', '1123', '335093', '12', '6835');
INSERT INTO public.who_global_data_import VALUES (63907, '2020-11-04', 'PK', 'Pakistan', 'EMRO', '1167', '336260', '14', '6849');
INSERT INTO public.who_global_data_import VALUES (63908, '2020-11-05', 'PK', 'Pakistan', 'EMRO', '1313', '337573', '18', '6867');
INSERT INTO public.who_global_data_import VALUES (63909, '2020-11-06', 'PK', 'Pakistan', 'EMRO', '1302', '338875', '26', '6893');
INSERT INTO public.who_global_data_import VALUES (63910, '2020-11-07', 'PK', 'Pakistan', 'EMRO', '1376', '340251', '30', '6923');
INSERT INTO public.who_global_data_import VALUES (63911, '2020-11-08', 'PK', 'Pakistan', 'EMRO', '1502', '341753', '20', '6943');
INSERT INTO public.who_global_data_import VALUES (63912, '2020-11-09', 'PK', 'Pakistan', 'EMRO', '1436', '343189', '25', '6968');
INSERT INTO public.who_global_data_import VALUES (63913, '2020-11-10', 'PK', 'Pakistan', 'EMRO', '1650', '344839', '9', '6977');
INSERT INTO public.who_global_data_import VALUES (63914, '2020-11-11', 'PK', 'Pakistan', 'EMRO', '1637', '346476', '23', '7000');
INSERT INTO public.who_global_data_import VALUES (63915, '2020-11-12', 'PK', 'Pakistan', 'EMRO', '1708', '348184', '21', '7021');
INSERT INTO public.who_global_data_import VALUES (63916, '2020-11-13', 'PK', 'Pakistan', 'EMRO', '1808', '349992', '34', '7055');
INSERT INTO public.who_global_data_import VALUES (63917, '2020-11-14', 'PK', 'Pakistan', 'EMRO', '2304', '352296', '37', '7092');
INSERT INTO public.who_global_data_import VALUES (63918, '2020-11-15', 'PK', 'Pakistan', 'EMRO', '2165', '354461', '17', '7109');
INSERT INTO public.who_global_data_import VALUES (63919, '2020-11-16', 'PK', 'Pakistan', 'EMRO', '2443', '356904', '32', '7141');
INSERT INTO public.who_global_data_import VALUES (63920, '2020-11-17', 'PK', 'Pakistan', 'EMRO', '2128', '359032', '19', '7160');
INSERT INTO public.who_global_data_import VALUES (63921, '2020-11-18', 'PK', 'Pakistan', 'EMRO', '2050', '361082', '33', '7193');
INSERT INTO public.who_global_data_import VALUES (63922, '2020-11-19', 'PK', 'Pakistan', 'EMRO', '2298', '363380', '37', '7230');
INSERT INTO public.who_global_data_import VALUES (63923, '2020-11-20', 'PK', 'Pakistan', 'EMRO', '2547', '365927', '18', '7248');
INSERT INTO public.who_global_data_import VALUES (63924, '2020-11-21', 'PK', 'Pakistan', 'EMRO', '2738', '368665', '313', '7561');
INSERT INTO public.who_global_data_import VALUES (63925, '2020-11-22', 'PK', 'Pakistan', 'EMRO', '2843', '371508', '42', '7603');
INSERT INTO public.who_global_data_import VALUES (63926, '2020-11-23', 'PK', 'Pakistan', 'EMRO', '2665', '374173', '59', '7662');
INSERT INTO public.who_global_data_import VALUES (63927, '2020-11-24', 'PK', 'Pakistan', 'EMRO', '2756', '376929', '34', '7696');
INSERT INTO public.who_global_data_import VALUES (63928, '2020-11-25', 'PK', 'Pakistan', 'EMRO', '2954', '379883', '48', '7744');
INSERT INTO public.who_global_data_import VALUES (63929, '2020-11-26', 'PK', 'Pakistan', 'EMRO', '3009', '382892', '59', '7803');
INSERT INTO public.who_global_data_import VALUES (63930, '2020-11-27', 'PK', 'Pakistan', 'EMRO', '3306', '386198', '40', '7843');
INSERT INTO public.who_global_data_import VALUES (63931, '2020-11-28', 'PK', 'Pakistan', 'EMRO', '3113', '389311', '54', '7897');
INSERT INTO public.who_global_data_import VALUES (63932, '2020-11-29', 'PK', 'Pakistan', 'EMRO', '3045', '392356', '45', '7942');
INSERT INTO public.who_global_data_import VALUES (63933, '2020-11-30', 'PK', 'Pakistan', 'EMRO', '2829', '395185', '43', '7985');
INSERT INTO public.who_global_data_import VALUES (63934, '2020-12-01', 'PK', 'Pakistan', 'EMRO', '2839', '398024', '40', '8025');
INSERT INTO public.who_global_data_import VALUES (63935, '2020-12-02', 'PK', 'Pakistan', 'EMRO', '2458', '400482', '66', '8091');
INSERT INTO public.who_global_data_import VALUES (63936, '2020-12-03', 'PK', 'Pakistan', 'EMRO', '2829', '403311', '75', '8166');
INSERT INTO public.who_global_data_import VALUES (63937, '2020-12-04', 'PK', 'Pakistan', 'EMRO', '3499', '406810', '39', '8205');
INSERT INTO public.who_global_data_import VALUES (63938, '2020-12-05', 'PK', 'Pakistan', 'EMRO', '3262', '410072', '55', '8260');
INSERT INTO public.who_global_data_import VALUES (63939, '2020-12-06', 'PK', 'Pakistan', 'EMRO', '3119', '413191', '43', '8303');
INSERT INTO public.who_global_data_import VALUES (63940, '2020-12-07', 'PK', 'Pakistan', 'EMRO', '3308', '416499', '58', '8361');
INSERT INTO public.who_global_data_import VALUES (63941, '2020-12-08', 'PK', 'Pakistan', 'EMRO', '3795', '420294', '37', '8398');
INSERT INTO public.who_global_data_import VALUES (63942, '2020-12-09', 'PK', 'Pakistan', 'EMRO', '2885', '423179', '89', '8487');
INSERT INTO public.who_global_data_import VALUES (63943, '2020-12-10', 'PK', 'Pakistan', 'EMRO', '2963', '426142', '60', '8547');
INSERT INTO public.who_global_data_import VALUES (63944, '2020-12-11', 'PK', 'Pakistan', 'EMRO', '3138', '429280', '56', '8603');
INSERT INTO public.who_global_data_import VALUES (63945, '2020-12-12', 'PK', 'Pakistan', 'EMRO', '3047', '432327', '50', '8653');
INSERT INTO public.who_global_data_import VALUES (63946, '2020-12-13', 'PK', 'Pakistan', 'EMRO', '2729', '435056', '71', '8724');
INSERT INTO public.who_global_data_import VALUES (63947, '2020-12-14', 'PK', 'Pakistan', 'EMRO', '3369', '438425', '72', '8796');
INSERT INTO public.who_global_data_import VALUES (63948, '2020-12-15', 'PK', 'Pakistan', 'EMRO', '2362', '440787', '36', '8832');
INSERT INTO public.who_global_data_import VALUES (63949, '2020-12-16', 'PK', 'Pakistan', 'EMRO', '2459', '443246', '73', '8905');
INSERT INTO public.who_global_data_import VALUES (63950, '2020-12-17', 'PK', 'Pakistan', 'EMRO', '2731', '445977', '105', '9010');
INSERT INTO public.who_global_data_import VALUES (63951, '2020-12-18', 'PK', 'Pakistan', 'EMRO', '2545', '448522', '70', '9080');
INSERT INTO public.who_global_data_import VALUES (63952, '2020-12-19', 'PK', 'Pakistan', 'EMRO', '2972', '451494', '84', '9164');
INSERT INTO public.who_global_data_import VALUES (63953, '2020-12-20', 'PK', 'Pakistan', 'EMRO', '3179', '454673', '86', '9250');
INSERT INTO public.who_global_data_import VALUES (63954, '2020-12-21', 'PK', 'Pakistan', 'EMRO', '2615', '457288', '80', '9330');
INSERT INTO public.who_global_data_import VALUES (63955, '2020-12-22', 'PK', 'Pakistan', 'EMRO', '1680', '458968', '62', '9392');
INSERT INTO public.who_global_data_import VALUES (63956, '2020-12-23', 'PK', 'Pakistan', 'EMRO', '1704', '460672', '82', '9474');
INSERT INTO public.who_global_data_import VALUES (63957, '2020-12-24', 'PK', 'Pakistan', 'EMRO', '2142', '462814', '83', '9557');
INSERT INTO public.who_global_data_import VALUES (63958, '2020-12-25', 'PK', 'Pakistan', 'EMRO', '2256', '465070', '111', '9668');
INSERT INTO public.who_global_data_import VALUES (63959, '2020-12-26', 'PK', 'Pakistan', 'EMRO', '2152', '467222', '85', '9753');
INSERT INTO public.who_global_data_import VALUES (63960, '2020-12-27', 'PK', 'Pakistan', 'EMRO', '2260', '469482', '63', '9816');
INSERT INTO public.who_global_data_import VALUES (63961, '2020-12-28', 'PK', 'Pakistan', 'EMRO', '1853', '471335', '58', '9874');
INSERT INTO public.who_global_data_import VALUES (63962, '2020-12-29', 'PK', 'Pakistan', 'EMRO', '1974', '473309', '55', '9929');
INSERT INTO public.who_global_data_import VALUES (63963, '2020-12-30', 'PK', 'Pakistan', 'EMRO', '1776', '475085', '63', '9992');
INSERT INTO public.who_global_data_import VALUES (63964, '2020-12-31', 'PK', 'Pakistan', 'EMRO', '2155', '477240', '55', '10047');
INSERT INTO public.who_global_data_import VALUES (63965, '2021-01-01', 'PK', 'Pakistan', 'EMRO', '2475', '479715', '58', '10105');
INSERT INTO public.who_global_data_import VALUES (63966, '2021-01-02', 'PK', 'Pakistan', 'EMRO', '2463', '482178', '71', '10176');
INSERT INTO public.who_global_data_import VALUES (63967, '2021-01-03', 'PK', 'Pakistan', 'EMRO', '2184', '484362', '82', '10258');
INSERT INTO public.who_global_data_import VALUES (63968, '2021-01-04', 'PK', 'Pakistan', 'EMRO', '2272', '486634', '53', '10311');
INSERT INTO public.who_global_data_import VALUES (63969, '2021-01-05', 'PK', 'Pakistan', 'EMRO', '1895', '488529', '39', '10350');
INSERT INTO public.who_global_data_import VALUES (63970, '2021-01-06', 'PK', 'Pakistan', 'EMRO', '1947', '490476', '59', '10409');
INSERT INTO public.who_global_data_import VALUES (63971, '2021-01-07', 'PK', 'Pakistan', 'EMRO', '2118', '492594', '52', '10461');
INSERT INTO public.who_global_data_import VALUES (63972, '2021-01-08', 'PK', 'Pakistan', 'EMRO', '2481', '495075', '50', '10511');
INSERT INTO public.who_global_data_import VALUES (63973, '2021-01-09', 'PK', 'Pakistan', 'EMRO', '2435', '497510', '47', '10558');
INSERT INTO public.who_global_data_import VALUES (63974, '2021-01-10', 'PK', 'Pakistan', 'EMRO', '2007', '499517', '40', '10598');
INSERT INTO public.who_global_data_import VALUES (63975, '2021-01-11', 'PK', 'Pakistan', 'EMRO', '2899', '502416', '46', '10644');
INSERT INTO public.who_global_data_import VALUES (63976, '2021-01-12', 'PK', 'Pakistan', 'EMRO', '1877', '504293', '32', '10676');
INSERT INTO public.who_global_data_import VALUES (63977, '2021-01-13', 'PK', 'Pakistan', 'EMRO', '2408', '506701', '41', '10717');
INSERT INTO public.who_global_data_import VALUES (63978, '2021-01-14', 'PK', 'Pakistan', 'EMRO', '2123', '508824', '55', '10772');
INSERT INTO public.who_global_data_import VALUES (63979, '2021-01-15', 'PK', 'Pakistan', 'EMRO', '3097', '511921', '46', '10818');
INSERT INTO public.who_global_data_import VALUES (63980, '2021-01-16', 'PK', 'Pakistan', 'EMRO', '2417', '514338', '45', '10863');
INSERT INTO public.who_global_data_import VALUES (63981, '2021-01-17', 'PK', 'Pakistan', 'EMRO', '2432', '516770', '45', '10908');
INSERT INTO public.who_global_data_import VALUES (63982, '2021-01-18', 'PK', 'Pakistan', 'EMRO', '2521', '519291', '43', '10951');
INSERT INTO public.who_global_data_import VALUES (63983, '2021-01-19', 'PK', 'Pakistan', 'EMRO', '1920', '521211', '46', '10997');
INSERT INTO public.who_global_data_import VALUES (63984, '2021-01-20', 'PK', 'Pakistan', 'EMRO', '1800', '523011', '58', '11055');
INSERT INTO public.who_global_data_import VALUES (63985, '2021-01-21', 'PK', 'Pakistan', 'EMRO', '1772', '524783', '48', '11103');
INSERT INTO public.who_global_data_import VALUES (63986, '2021-01-22', 'PK', 'Pakistan', 'EMRO', '2363', '527146', '54', '11157');
INSERT INTO public.who_global_data_import VALUES (63987, '2021-01-23', 'PK', 'Pakistan', 'EMRO', '1745', '528891', '47', '11204');
INSERT INTO public.who_global_data_import VALUES (63988, '2021-01-24', 'PK', 'Pakistan', 'EMRO', '1927', '530818', '43', '11247');
INSERT INTO public.who_global_data_import VALUES (63989, '2021-01-25', 'PK', 'Pakistan', 'EMRO', '1594', '532412', '48', '11295');
INSERT INTO public.who_global_data_import VALUES (63990, '2021-01-26', 'PK', 'Pakistan', 'EMRO', '1629', '534041', '23', '11318');
INSERT INTO public.who_global_data_import VALUES (63991, '2021-01-27', 'PK', 'Pakistan', 'EMRO', '1873', '535914', '58', '11376');
INSERT INTO public.who_global_data_import VALUES (63992, '2021-01-28', 'PK', 'Pakistan', 'EMRO', '1563', '537477', '74', '11450');
INSERT INTO public.who_global_data_import VALUES (63993, '2021-01-29', 'PK', 'Pakistan', 'EMRO', '1910', '539387', '64', '11514');
INSERT INTO public.who_global_data_import VALUES (63994, '2021-01-30', 'PK', 'Pakistan', 'EMRO', '1644', '541031', '46', '11560');
INSERT INTO public.who_global_data_import VALUES (63995, '2021-01-31', 'PK', 'Pakistan', 'EMRO', '2183', '543214', '63', '11623');
INSERT INTO public.who_global_data_import VALUES (63996, '2021-02-01', 'PK', 'Pakistan', 'EMRO', '1599', '544813', '34', '11657');
INSERT INTO public.who_global_data_import VALUES (63997, '2021-02-02', 'PK', 'Pakistan', 'EMRO', '1615', '546428', '26', '11683');
INSERT INTO public.who_global_data_import VALUES (63998, '2021-02-03', 'PK', 'Pakistan', 'EMRO', '1220', '547648', '63', '11746');
INSERT INTO public.who_global_data_import VALUES (63999, '2021-02-04', 'PK', 'Pakistan', 'EMRO', '1384', '549032', '56', '11802');
INSERT INTO public.who_global_data_import VALUES (64000, '2021-02-05', 'PK', 'Pakistan', 'EMRO', '1508', '550540', '31', '11833');
INSERT INTO public.who_global_data_import VALUES (64001, '2020-01-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64002, '2020-01-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64003, '2020-01-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64004, '2020-01-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64005, '2020-01-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64006, '2020-01-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64007, '2020-01-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64008, '2020-01-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64009, '2020-01-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64010, '2020-01-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64011, '2020-01-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64012, '2020-01-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64013, '2020-01-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64014, '2020-01-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64015, '2020-01-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64016, '2020-01-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64017, '2020-01-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64018, '2020-01-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64019, '2020-01-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64020, '2020-01-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64021, '2020-01-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64022, '2020-01-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64023, '2020-01-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64024, '2020-01-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64025, '2020-01-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64026, '2020-01-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64027, '2020-01-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64028, '2020-01-30', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64029, '2020-01-31', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64030, '2020-02-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64031, '2020-02-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64032, '2020-02-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64033, '2020-02-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64034, '2020-02-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64035, '2020-02-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64036, '2020-02-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64037, '2020-02-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64038, '2020-02-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64039, '2020-02-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64040, '2020-02-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64041, '2020-02-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64042, '2020-02-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64043, '2020-02-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64044, '2020-02-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64045, '2020-02-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64046, '2020-02-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64047, '2020-02-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64048, '2020-02-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64049, '2020-02-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64050, '2020-02-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64051, '2020-02-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64052, '2020-02-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64053, '2020-02-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64054, '2020-02-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64055, '2020-02-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64056, '2020-02-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64057, '2020-02-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64058, '2020-02-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64059, '2020-03-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64060, '2020-03-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64061, '2020-03-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64062, '2020-03-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64063, '2020-03-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64064, '2020-03-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64065, '2020-03-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64066, '2020-03-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64067, '2020-03-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64068, '2020-03-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64069, '2020-03-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64070, '2020-03-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64071, '2020-03-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64072, '2020-03-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64073, '2020-03-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64074, '2020-03-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64075, '2020-03-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64076, '2020-03-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64077, '2020-03-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64078, '2020-03-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64079, '2020-03-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64080, '2020-03-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64081, '2020-03-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64082, '2020-03-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64083, '2020-03-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64084, '2020-03-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64085, '2020-03-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64086, '2020-03-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64087, '2020-03-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64088, '2020-03-30', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64089, '2020-03-31', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64090, '2020-04-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64091, '2020-04-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64092, '2020-04-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64093, '2020-04-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64094, '2020-04-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64095, '2020-04-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64096, '2020-04-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64097, '2020-04-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64098, '2020-04-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64099, '2020-04-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64100, '2020-04-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64101, '2020-04-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64102, '2020-04-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64103, '2020-04-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64104, '2020-04-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64105, '2020-04-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64106, '2020-04-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64107, '2020-04-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64108, '2020-04-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64109, '2020-04-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64110, '2020-04-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64111, '2020-04-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64112, '2020-04-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64113, '2020-04-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64114, '2020-04-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64115, '2020-04-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64116, '2020-04-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64117, '2020-04-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64118, '2020-04-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64119, '2020-04-30', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64120, '2020-05-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64121, '2020-05-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64122, '2020-05-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64123, '2020-05-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64124, '2020-05-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64125, '2020-05-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64126, '2020-05-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64127, '2020-05-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64128, '2020-05-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64129, '2020-05-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64130, '2020-05-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64131, '2020-05-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64132, '2020-05-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64133, '2020-05-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64134, '2020-05-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64135, '2020-05-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64136, '2020-05-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64137, '2020-05-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64138, '2020-05-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64139, '2020-05-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64140, '2020-05-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64141, '2020-05-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64142, '2020-05-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64143, '2020-05-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64144, '2020-05-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64145, '2020-05-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64146, '2020-05-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64147, '2020-05-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64148, '2020-05-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64149, '2020-05-30', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64150, '2020-05-31', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64151, '2020-06-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64152, '2020-06-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64153, '2020-06-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64154, '2020-06-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64155, '2020-06-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64156, '2020-06-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64157, '2020-06-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64158, '2020-06-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64159, '2020-06-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64160, '2020-06-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64161, '2020-06-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64162, '2020-06-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64163, '2020-06-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64164, '2020-06-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64165, '2020-06-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64166, '2020-06-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64167, '2020-06-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64168, '2020-06-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64169, '2020-06-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64170, '2020-06-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64171, '2020-06-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64172, '2020-06-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64173, '2020-06-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64174, '2020-06-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64175, '2020-06-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64176, '2020-06-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64177, '2020-06-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64178, '2020-06-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64179, '2020-06-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64180, '2020-06-30', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64181, '2020-07-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64182, '2020-07-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64183, '2020-07-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64184, '2020-07-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64185, '2020-07-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64186, '2020-07-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64187, '2020-07-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64188, '2020-07-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64189, '2020-07-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64190, '2020-07-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64191, '2020-07-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64192, '2020-07-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64193, '2020-07-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64194, '2020-07-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64195, '2020-07-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64196, '2020-07-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64197, '2020-07-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64198, '2020-07-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64199, '2020-07-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64200, '2020-07-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64201, '2020-07-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64202, '2020-07-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64203, '2020-07-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64204, '2020-07-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64205, '2020-07-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64206, '2020-07-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64207, '2020-07-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64208, '2020-07-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64209, '2020-07-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64210, '2020-07-30', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64211, '2020-07-31', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64212, '2020-08-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64213, '2020-08-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64214, '2020-08-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64215, '2020-08-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64216, '2020-08-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64217, '2020-08-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64218, '2020-08-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64219, '2020-08-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64220, '2020-08-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64221, '2020-08-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64222, '2020-08-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64223, '2020-08-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64224, '2020-08-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64225, '2020-08-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64226, '2020-08-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64227, '2020-08-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64228, '2020-08-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64229, '2020-08-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64230, '2020-08-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64231, '2020-08-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64232, '2020-08-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64233, '2020-08-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64234, '2020-08-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64235, '2020-08-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64236, '2020-08-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64237, '2020-08-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64238, '2020-08-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64239, '2020-08-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64240, '2020-08-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64241, '2020-08-30', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64242, '2020-08-31', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64243, '2020-09-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64244, '2020-09-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64245, '2020-09-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64246, '2020-09-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64247, '2020-09-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64248, '2020-09-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64249, '2020-09-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64250, '2020-09-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64251, '2020-09-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64252, '2020-09-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64253, '2020-09-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64254, '2020-09-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64255, '2020-09-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64256, '2020-09-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64257, '2020-09-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64258, '2020-09-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64259, '2020-09-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64260, '2020-09-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64261, '2020-09-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64262, '2020-09-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64263, '2020-09-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64264, '2020-09-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64265, '2020-09-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64266, '2020-09-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64267, '2020-09-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64268, '2020-09-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64269, '2020-09-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64270, '2020-09-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64271, '2020-09-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64272, '2020-09-30', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64273, '2020-10-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64274, '2020-10-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64275, '2020-10-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64276, '2020-10-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64277, '2020-10-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64278, '2020-10-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64279, '2020-10-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64280, '2020-10-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64281, '2020-10-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64282, '2020-10-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64283, '2020-10-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64284, '2020-10-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64285, '2020-10-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64286, '2020-10-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64287, '2020-10-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64288, '2020-10-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64289, '2020-10-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64290, '2020-10-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64291, '2020-10-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64292, '2020-10-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64293, '2020-10-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64294, '2020-10-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64295, '2020-10-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64296, '2020-10-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64297, '2020-10-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64298, '2020-10-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64299, '2020-10-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64300, '2020-10-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64301, '2020-10-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64302, '2020-10-30', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64303, '2020-10-31', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64304, '2020-11-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64305, '2020-11-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64306, '2020-11-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64307, '2020-11-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64308, '2020-11-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64309, '2020-11-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64310, '2020-11-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64311, '2020-11-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64312, '2020-11-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64313, '2020-11-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64314, '2020-11-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64315, '2020-11-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64316, '2020-11-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64317, '2020-11-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64318, '2020-11-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64319, '2020-11-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64320, '2020-11-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64321, '2020-11-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64322, '2020-11-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64323, '2020-11-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64324, '2020-11-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64325, '2020-11-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64326, '2020-11-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64327, '2020-11-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64328, '2020-11-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64329, '2020-11-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64330, '2020-11-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64331, '2020-11-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64332, '2020-11-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64333, '2020-11-30', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64334, '2020-12-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64335, '2020-12-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64336, '2020-12-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64337, '2020-12-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64338, '2020-12-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64339, '2020-12-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64340, '2020-12-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64341, '2020-12-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64342, '2020-12-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64343, '2020-12-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64344, '2020-12-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64345, '2020-12-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64346, '2020-12-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64347, '2020-12-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64348, '2020-12-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64349, '2020-12-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64350, '2020-12-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64351, '2020-12-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64352, '2020-12-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64353, '2020-12-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64354, '2020-12-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64355, '2020-12-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64356, '2020-12-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64357, '2020-12-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64358, '2020-12-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64359, '2020-12-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64360, '2020-12-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64361, '2020-12-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64362, '2020-12-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64363, '2020-12-30', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64364, '2020-12-31', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64365, '2021-01-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64366, '2021-01-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64367, '2021-01-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64368, '2021-01-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64369, '2021-01-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64370, '2021-01-06', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64371, '2021-01-07', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64372, '2021-01-08', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64373, '2021-01-09', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64374, '2021-01-10', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64375, '2021-01-11', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64376, '2021-01-12', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64377, '2021-01-13', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64378, '2021-01-14', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64379, '2021-01-15', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64380, '2021-01-16', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64381, '2021-01-17', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64382, '2021-01-18', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64383, '2021-01-19', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64384, '2021-01-20', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64385, '2021-01-21', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64386, '2021-01-22', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64387, '2021-01-23', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64388, '2021-01-24', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64389, '2021-01-25', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64390, '2021-01-26', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64391, '2021-01-27', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64392, '2021-01-28', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64393, '2021-01-29', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64394, '2021-01-30', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64395, '2021-01-31', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64396, '2021-02-01', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64397, '2021-02-02', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64398, '2021-02-03', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64399, '2021-02-04', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64400, '2021-02-05', 'PW', 'Palau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64401, '2020-01-03', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64402, '2020-01-04', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64403, '2020-01-05', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64404, '2020-01-06', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64405, '2020-01-07', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64406, '2020-01-08', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64407, '2020-01-09', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64408, '2020-01-10', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64409, '2020-01-11', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64410, '2020-01-12', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64411, '2020-01-13', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64412, '2020-01-14', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64413, '2020-01-15', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64414, '2020-01-16', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64415, '2020-01-17', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64416, '2020-01-18', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64417, '2020-01-19', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64418, '2020-01-20', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64419, '2020-01-21', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64420, '2020-01-22', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64421, '2020-01-23', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64422, '2020-01-24', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64423, '2020-01-25', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64424, '2020-01-26', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64425, '2020-01-27', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64426, '2020-01-28', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64427, '2020-01-29', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64428, '2020-01-30', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64429, '2020-01-31', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64430, '2020-02-01', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64431, '2020-02-02', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64432, '2020-02-03', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64433, '2020-02-04', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64434, '2020-02-05', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64435, '2020-02-06', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64436, '2020-02-07', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64437, '2020-02-08', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64438, '2020-02-09', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64439, '2020-02-10', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64440, '2020-02-11', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64441, '2020-02-12', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64442, '2020-02-13', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64443, '2020-02-14', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64444, '2020-02-15', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64445, '2020-02-16', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64446, '2020-02-17', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64447, '2020-02-18', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64448, '2020-02-19', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64449, '2020-02-20', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64450, '2020-02-21', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64451, '2020-02-22', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64452, '2020-02-23', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64453, '2020-02-24', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64454, '2020-02-25', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64455, '2020-02-26', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64456, '2020-02-27', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64457, '2020-02-28', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64458, '2020-02-29', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64459, '2020-03-01', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64460, '2020-03-02', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64461, '2020-03-03', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64462, '2020-03-04', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64463, '2020-03-05', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64464, '2020-03-06', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64465, '2020-03-07', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64466, '2020-03-08', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64467, '2020-03-09', 'PA', 'Panama', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64468, '2020-03-10', 'PA', 'Panama', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64469, '2020-03-11', 'PA', 'Panama', 'AMRO', '7', '12', '1', '1');
INSERT INTO public.who_global_data_import VALUES (64470, '2020-03-12', 'PA', 'Panama', 'AMRO', '2', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (64471, '2020-03-13', 'PA', 'Panama', 'AMRO', '4', '18', '0', '1');
INSERT INTO public.who_global_data_import VALUES (64472, '2020-03-14', 'PA', 'Panama', 'AMRO', '13', '31', '0', '1');
INSERT INTO public.who_global_data_import VALUES (64473, '2020-03-15', 'PA', 'Panama', 'AMRO', '0', '31', '0', '1');
INSERT INTO public.who_global_data_import VALUES (64474, '2020-03-16', 'PA', 'Panama', 'AMRO', '16', '47', '0', '1');
INSERT INTO public.who_global_data_import VALUES (64475, '2020-03-17', 'PA', 'Panama', 'AMRO', '26', '73', '0', '1');
INSERT INTO public.who_global_data_import VALUES (64476, '2020-03-18', 'PA', 'Panama', 'AMRO', '17', '90', '0', '1');
INSERT INTO public.who_global_data_import VALUES (64477, '2020-03-19', 'PA', 'Panama', 'AMRO', '19', '109', '0', '1');
INSERT INTO public.who_global_data_import VALUES (64478, '2020-03-20', 'PA', 'Panama', 'AMRO', '28', '137', '0', '1');
INSERT INTO public.who_global_data_import VALUES (64479, '2020-03-21', 'PA', 'Panama', 'AMRO', '0', '137', '0', '1');
INSERT INTO public.who_global_data_import VALUES (64480, '2020-03-22', 'PA', 'Panama', 'AMRO', '0', '137', '0', '1');
INSERT INTO public.who_global_data_import VALUES (64481, '2020-03-23', 'PA', 'Panama', 'AMRO', '108', '245', '2', '3');
INSERT INTO public.who_global_data_import VALUES (64482, '2020-03-24', 'PA', 'Panama', 'AMRO', '100', '345', '3', '6');
INSERT INTO public.who_global_data_import VALUES (64483, '2020-03-25', 'PA', 'Panama', 'AMRO', '0', '345', '0', '6');
INSERT INTO public.who_global_data_import VALUES (64484, '2020-03-26', 'PA', 'Panama', 'AMRO', '213', '558', '2', '8');
INSERT INTO public.who_global_data_import VALUES (64485, '2020-03-27', 'PA', 'Panama', 'AMRO', '0', '558', '0', '8');
INSERT INTO public.who_global_data_import VALUES (64486, '2020-03-28', 'PA', 'Panama', 'AMRO', '116', '674', '1', '9');
INSERT INTO public.who_global_data_import VALUES (64487, '2020-03-29', 'PA', 'Panama', 'AMRO', '112', '786', '5', '14');
INSERT INTO public.who_global_data_import VALUES (64488, '2020-03-30', 'PA', 'Panama', 'AMRO', '115', '901', '3', '17');
INSERT INTO public.who_global_data_import VALUES (64489, '2020-03-31', 'PA', 'Panama', 'AMRO', '88', '989', '7', '24');
INSERT INTO public.who_global_data_import VALUES (64490, '2020-04-01', 'PA', 'Panama', 'AMRO', '0', '989', '0', '24');
INSERT INTO public.who_global_data_import VALUES (64491, '2020-04-02', 'PA', 'Panama', 'AMRO', '192', '1181', '6', '30');
INSERT INTO public.who_global_data_import VALUES (64492, '2020-04-03', 'PA', 'Panama', 'AMRO', '136', '1317', '2', '32');
INSERT INTO public.who_global_data_import VALUES (64493, '2020-04-04', 'PA', 'Panama', 'AMRO', '158', '1475', '5', '37');
INSERT INTO public.who_global_data_import VALUES (64494, '2020-04-05', 'PA', 'Panama', 'AMRO', '198', '1673', '4', '41');
INSERT INTO public.who_global_data_import VALUES (64495, '2020-04-06', 'PA', 'Panama', 'AMRO', '128', '1801', '5', '46');
INSERT INTO public.who_global_data_import VALUES (64496, '2020-04-07', 'PA', 'Panama', 'AMRO', '187', '1988', '8', '54');
INSERT INTO public.who_global_data_import VALUES (64497, '2020-04-08', 'PA', 'Panama', 'AMRO', '112', '2100', '1', '55');
INSERT INTO public.who_global_data_import VALUES (64498, '2020-04-09', 'PA', 'Panama', 'AMRO', '149', '2249', '4', '59');
INSERT INTO public.who_global_data_import VALUES (64499, '2020-04-10', 'PA', 'Panama', 'AMRO', '279', '2528', '4', '63');
INSERT INTO public.who_global_data_import VALUES (64500, '2020-04-11', 'PA', 'Panama', 'AMRO', '224', '2752', '3', '66');
INSERT INTO public.who_global_data_import VALUES (64501, '2020-04-12', 'PA', 'Panama', 'AMRO', '222', '2974', '8', '74');
INSERT INTO public.who_global_data_import VALUES (64502, '2020-04-13', 'PA', 'Panama', 'AMRO', '260', '3234', '5', '79');
INSERT INTO public.who_global_data_import VALUES (64503, '2020-04-14', 'PA', 'Panama', 'AMRO', '166', '3400', '8', '87');
INSERT INTO public.who_global_data_import VALUES (64504, '2020-04-15', 'PA', 'Panama', 'AMRO', '72', '3472', '7', '94');
INSERT INTO public.who_global_data_import VALUES (64505, '2020-04-16', 'PA', 'Panama', 'AMRO', '102', '3574', '1', '95');
INSERT INTO public.who_global_data_import VALUES (64506, '2020-04-17', 'PA', 'Panama', 'AMRO', '177', '3751', '8', '103');
INSERT INTO public.who_global_data_import VALUES (64507, '2020-04-18', 'PA', 'Panama', 'AMRO', '265', '4016', '6', '109');
INSERT INTO public.who_global_data_import VALUES (64508, '2020-04-19', 'PA', 'Panama', 'AMRO', '194', '4210', '6', '115');
INSERT INTO public.who_global_data_import VALUES (64509, '2020-04-20', 'PA', 'Panama', 'AMRO', '63', '4273', '5', '120');
INSERT INTO public.who_global_data_import VALUES (64510, '2020-04-21', 'PA', 'Panama', 'AMRO', '194', '4467', '6', '126');
INSERT INTO public.who_global_data_import VALUES (64511, '2020-04-22', 'PA', 'Panama', 'AMRO', '191', '4658', '10', '136');
INSERT INTO public.who_global_data_import VALUES (64512, '2020-04-23', 'PA', 'Panama', 'AMRO', '163', '4821', '5', '141');
INSERT INTO public.who_global_data_import VALUES (64513, '2020-04-24', 'PA', 'Panama', 'AMRO', '171', '4992', '3', '144');
INSERT INTO public.who_global_data_import VALUES (64514, '2020-04-25', 'PA', 'Panama', 'AMRO', '174', '5166', '2', '146');
INSERT INTO public.who_global_data_import VALUES (64515, '2020-04-26', 'PA', 'Panama', 'AMRO', '172', '5338', '8', '154');
INSERT INTO public.who_global_data_import VALUES (64516, '2020-04-27', 'PA', 'Panama', 'AMRO', '200', '5538', '5', '159');
INSERT INTO public.who_global_data_import VALUES (64517, '2020-04-28', 'PA', 'Panama', 'AMRO', '241', '5779', '6', '165');
INSERT INTO public.who_global_data_import VALUES (64518, '2020-04-29', 'PA', 'Panama', 'AMRO', '242', '6021', '2', '167');
INSERT INTO public.who_global_data_import VALUES (64519, '2020-04-30', 'PA', 'Panama', 'AMRO', '179', '6200', '9', '176');
INSERT INTO public.who_global_data_import VALUES (64520, '2020-05-01', 'PA', 'Panama', 'AMRO', '178', '6378', '2', '178');
INSERT INTO public.who_global_data_import VALUES (64521, '2020-05-02', 'PA', 'Panama', 'AMRO', '154', '6532', '10', '188');
INSERT INTO public.who_global_data_import VALUES (64522, '2020-05-03', 'PA', 'Panama', 'AMRO', '188', '6720', '4', '192');
INSERT INTO public.who_global_data_import VALUES (64523, '2020-05-04', 'PA', 'Panama', 'AMRO', '370', '7090', '5', '197');
INSERT INTO public.who_global_data_import VALUES (64524, '2020-05-05', 'PA', 'Panama', 'AMRO', '107', '7197', '3', '200');
INSERT INTO public.who_global_data_import VALUES (64525, '2020-05-06', 'PA', 'Panama', 'AMRO', '190', '7387', '3', '203');
INSERT INTO public.who_global_data_import VALUES (64526, '2020-05-07', 'PA', 'Panama', 'AMRO', '136', '7523', '7', '210');
INSERT INTO public.who_global_data_import VALUES (64527, '2020-05-08', 'PA', 'Panama', 'AMRO', '208', '7731', '8', '218');
INSERT INTO public.who_global_data_import VALUES (64528, '2020-05-09', 'PA', 'Panama', 'AMRO', '137', '7868', '7', '225');
INSERT INTO public.who_global_data_import VALUES (64529, '2020-05-10', 'PA', 'Panama', 'AMRO', '202', '8070', '6', '231');
INSERT INTO public.who_global_data_import VALUES (64530, '2020-05-11', 'PA', 'Panama', 'AMRO', '212', '8282', '6', '237');
INSERT INTO public.who_global_data_import VALUES (64531, '2020-05-12', 'PA', 'Panama', 'AMRO', '166', '8448', '7', '244');
INSERT INTO public.who_global_data_import VALUES (64532, '2020-05-13', 'PA', 'Panama', 'AMRO', '168', '8616', '5', '249');
INSERT INTO public.who_global_data_import VALUES (64533, '2020-05-14', 'PA', 'Panama', 'AMRO', '0', '8616', '0', '249');
INSERT INTO public.who_global_data_import VALUES (64534, '2020-05-15', 'PA', 'Panama', 'AMRO', '328', '8944', '7', '256');
INSERT INTO public.who_global_data_import VALUES (64535, '2020-05-16', 'PA', 'Panama', 'AMRO', '174', '9118', '4', '260');
INSERT INTO public.who_global_data_import VALUES (64536, '2020-05-17', 'PA', 'Panama', 'AMRO', '150', '9268', '6', '266');
INSERT INTO public.who_global_data_import VALUES (64537, '2020-05-18', 'PA', 'Panama', 'AMRO', '181', '9449', '3', '269');
INSERT INTO public.who_global_data_import VALUES (64538, '2020-05-19', 'PA', 'Panama', 'AMRO', '157', '9606', '6', '275');
INSERT INTO public.who_global_data_import VALUES (64539, '2020-05-20', 'PA', 'Panama', 'AMRO', '120', '9726', '4', '279');
INSERT INTO public.who_global_data_import VALUES (64540, '2020-05-21', 'PA', 'Panama', 'AMRO', '141', '9867', '2', '281');
INSERT INTO public.who_global_data_import VALUES (64541, '2020-05-22', 'PA', 'Panama', 'AMRO', '110', '9977', '6', '287');
INSERT INTO public.who_global_data_import VALUES (64542, '2020-05-23', 'PA', 'Panama', 'AMRO', '139', '10116', '4', '291');
INSERT INTO public.who_global_data_import VALUES (64543, '2020-05-24', 'PA', 'Panama', 'AMRO', '151', '10267', '4', '295');
INSERT INTO public.who_global_data_import VALUES (64544, '2020-05-25', 'PA', 'Panama', 'AMRO', '310', '10577', '4', '299');
INSERT INTO public.who_global_data_import VALUES (64545, '2020-05-26', 'PA', 'Panama', 'AMRO', '349', '10926', '7', '306');
INSERT INTO public.who_global_data_import VALUES (64546, '2020-05-27', 'PA', 'Panama', 'AMRO', '257', '11183', '4', '310');
INSERT INTO public.who_global_data_import VALUES (64547, '2020-05-28', 'PA', 'Panama', 'AMRO', '264', '11447', '3', '313');
INSERT INTO public.who_global_data_import VALUES (64548, '2020-05-29', 'PA', 'Panama', 'AMRO', '281', '11728', '2', '315');
INSERT INTO public.who_global_data_import VALUES (64549, '2020-05-30', 'PA', 'Panama', 'AMRO', '403', '12131', '5', '320');
INSERT INTO public.who_global_data_import VALUES (64550, '2020-05-31', 'PA', 'Panama', 'AMRO', '400', '12531', '6', '326');
INSERT INTO public.who_global_data_import VALUES (64551, '2020-06-01', 'PA', 'Panama', 'AMRO', '487', '13018', '4', '330');
INSERT INTO public.who_global_data_import VALUES (64552, '2020-06-02', 'PA', 'Panama', 'AMRO', '445', '13463', '6', '336');
INSERT INTO public.who_global_data_import VALUES (64553, '2020-06-03', 'PA', 'Panama', 'AMRO', '374', '13837', '8', '344');
INSERT INTO public.who_global_data_import VALUES (64554, '2020-06-04', 'PA', 'Panama', 'AMRO', '258', '14095', '8', '352');
INSERT INTO public.who_global_data_import VALUES (64555, '2020-06-05', 'PA', 'Panama', 'AMRO', '514', '14609', '5', '357');
INSERT INTO public.who_global_data_import VALUES (64556, '2020-06-06', 'PA', 'Panama', 'AMRO', '435', '15044', '6', '363');
INSERT INTO public.who_global_data_import VALUES (64557, '2020-06-07', 'PA', 'Panama', 'AMRO', '419', '15463', '7', '370');
INSERT INTO public.who_global_data_import VALUES (64558, '2020-06-08', 'PA', 'Panama', 'AMRO', '541', '16004', '16', '386');
INSERT INTO public.who_global_data_import VALUES (64559, '2020-06-09', 'PA', 'Panama', 'AMRO', '421', '16425', '7', '393');
INSERT INTO public.who_global_data_import VALUES (64560, '2020-06-10', 'PA', 'Panama', 'AMRO', '429', '16854', '5', '398');
INSERT INTO public.who_global_data_import VALUES (64561, '2020-06-11', 'PA', 'Panama', 'AMRO', '379', '17233', '5', '403');
INSERT INTO public.who_global_data_import VALUES (64562, '2020-06-12', 'PA', 'Panama', 'AMRO', '656', '17889', '10', '413');
INSERT INTO public.who_global_data_import VALUES (64563, '2020-06-13', 'PA', 'Panama', 'AMRO', '697', '18586', '5', '418');
INSERT INTO public.who_global_data_import VALUES (64564, '2020-06-14', 'PA', 'Panama', 'AMRO', '625', '19211', '3', '421');
INSERT INTO public.who_global_data_import VALUES (64565, '2020-06-15', 'PA', 'Panama', 'AMRO', '848', '20059', '8', '429');
INSERT INTO public.who_global_data_import VALUES (64566, '2020-06-16', 'PA', 'Panama', 'AMRO', '627', '20686', '8', '437');
INSERT INTO public.who_global_data_import VALUES (64567, '2020-06-17', 'PA', 'Panama', 'AMRO', '736', '21422', '11', '448');
INSERT INTO public.who_global_data_import VALUES (64568, '2020-06-18', 'PA', 'Panama', 'AMRO', '540', '21962', '9', '457');
INSERT INTO public.who_global_data_import VALUES (64569, '2020-06-19', 'PA', 'Panama', 'AMRO', '635', '22597', '13', '470');
INSERT INTO public.who_global_data_import VALUES (64570, '2020-06-20', 'PA', 'Panama', 'AMRO', '754', '23351', '5', '475');
INSERT INTO public.who_global_data_import VALUES (64571, '2020-06-21', 'PA', 'Panama', 'AMRO', '923', '24274', '10', '485');
INSERT INTO public.who_global_data_import VALUES (64572, '2020-06-22', 'PA', 'Panama', 'AMRO', '948', '25222', '8', '493');
INSERT INTO public.who_global_data_import VALUES (64573, '2020-06-23', 'PA', 'Panama', 'AMRO', '808', '26030', '8', '501');
INSERT INTO public.who_global_data_import VALUES (64574, '2020-06-24', 'PA', 'Panama', 'AMRO', '722', '26752', '20', '521');
INSERT INTO public.who_global_data_import VALUES (64575, '2020-06-25', 'PA', 'Panama', 'AMRO', '562', '27314', '15', '536');
INSERT INTO public.who_global_data_import VALUES (64576, '2020-06-26', 'PA', 'Panama', 'AMRO', '716', '28030', '11', '547');
INSERT INTO public.who_global_data_import VALUES (64577, '2020-06-27', 'PA', 'Panama', 'AMRO', '1007', '29037', '17', '564');
INSERT INTO public.who_global_data_import VALUES (64578, '2020-06-28', 'PA', 'Panama', 'AMRO', '868', '29905', '11', '575');
INSERT INTO public.who_global_data_import VALUES (64579, '2020-06-29', 'PA', 'Panama', 'AMRO', '753', '30658', '17', '592');
INSERT INTO public.who_global_data_import VALUES (64580, '2020-06-30', 'PA', 'Panama', 'AMRO', '1028', '31686', '12', '604');
INSERT INTO public.who_global_data_import VALUES (64581, '2020-07-01', 'PA', 'Panama', 'AMRO', '1099', '32785', '16', '620');
INSERT INTO public.who_global_data_import VALUES (64582, '2020-07-02', 'PA', 'Panama', 'AMRO', '765', '33550', '11', '631');
INSERT INTO public.who_global_data_import VALUES (64583, '2020-07-03', 'PA', 'Panama', 'AMRO', '913', '34463', '14', '645');
INSERT INTO public.who_global_data_import VALUES (64584, '2020-07-04', 'PA', 'Panama', 'AMRO', '774', '35237', '22', '667');
INSERT INTO public.who_global_data_import VALUES (64585, '2020-07-05', 'PA', 'Panama', 'AMRO', '758', '35995', '31', '698');
INSERT INTO public.who_global_data_import VALUES (64586, '2020-07-06', 'PA', 'Panama', 'AMRO', '988', '36983', '22', '720');
INSERT INTO public.who_global_data_import VALUES (64587, '2020-07-07', 'PA', 'Panama', 'AMRO', '1166', '38149', '27', '747');
INSERT INTO public.who_global_data_import VALUES (64588, '2020-07-08', 'PA', 'Panama', 'AMRO', '1185', '39334', '23', '770');
INSERT INTO public.who_global_data_import VALUES (64589, '2020-07-09', 'PA', 'Panama', 'AMRO', '957', '40291', '29', '799');
INSERT INTO public.who_global_data_import VALUES (64590, '2020-07-10', 'PA', 'Panama', 'AMRO', '960', '41251', '20', '819');
INSERT INTO public.who_global_data_import VALUES (64591, '2020-07-11', 'PA', 'Panama', 'AMRO', '965', '42216', '20', '839');
INSERT INTO public.who_global_data_import VALUES (64592, '2020-07-12', 'PA', 'Panama', 'AMRO', '1041', '43257', '24', '863');
INSERT INTO public.who_global_data_import VALUES (64593, '2020-07-13', 'PA', 'Panama', 'AMRO', '1075', '44332', '30', '893');
INSERT INTO public.who_global_data_import VALUES (64594, '2020-07-14', 'PA', 'Panama', 'AMRO', '1301', '45633', '16', '909');
INSERT INTO public.who_global_data_import VALUES (64595, '2020-07-15', 'PA', 'Panama', 'AMRO', '1540', '47173', '23', '932');
INSERT INTO public.who_global_data_import VALUES (64596, '2020-07-16', 'PA', 'Panama', 'AMRO', '923', '48096', '28', '960');
INSERT INTO public.who_global_data_import VALUES (64597, '2020-07-17', 'PA', 'Panama', 'AMRO', '1147', '49243', '22', '982');
INSERT INTO public.who_global_data_import VALUES (64598, '2020-07-18', 'PA', 'Panama', 'AMRO', '1130', '50373', '18', '1000');
INSERT INTO public.who_global_data_import VALUES (64599, '2020-07-19', 'PA', 'Panama', 'AMRO', '1035', '51408', '38', '1038');
INSERT INTO public.who_global_data_import VALUES (64600, '2020-07-20', 'PA', 'Panama', 'AMRO', '853', '52261', '33', '1071');
INSERT INTO public.who_global_data_import VALUES (64601, '2020-07-21', 'PA', 'Panama', 'AMRO', '1207', '53468', '25', '1096');
INSERT INTO public.who_global_data_import VALUES (64602, '2020-07-22', 'PA', 'Panama', 'AMRO', '958', '54426', '31', '1127');
INSERT INTO public.who_global_data_import VALUES (64603, '2020-07-23', 'PA', 'Panama', 'AMRO', '727', '55153', '32', '1159');
INSERT INTO public.who_global_data_import VALUES (64604, '2020-07-24', 'PA', 'Panama', 'AMRO', '753', '55906', '21', '1180');
INSERT INTO public.who_global_data_import VALUES (64605, '2020-07-25', 'PA', 'Panama', 'AMRO', '911', '56817', '29', '1209');
INSERT INTO public.who_global_data_import VALUES (64606, '2020-07-26', 'PA', 'Panama', 'AMRO', '1176', '57993', '41', '1250');
INSERT INTO public.who_global_data_import VALUES (64607, '2020-07-27', 'PA', 'Panama', 'AMRO', '871', '58864', '25', '1275');
INSERT INTO public.who_global_data_import VALUES (64608, '2020-07-28', 'PA', 'Panama', 'AMRO', '1432', '60296', '19', '1294');
INSERT INTO public.who_global_data_import VALUES (64609, '2020-07-29', 'PA', 'Panama', 'AMRO', '1146', '61442', '28', '1322');
INSERT INTO public.who_global_data_import VALUES (64610, '2020-07-30', 'PA', 'Panama', 'AMRO', '781', '62223', '27', '1349');
INSERT INTO public.who_global_data_import VALUES (64611, '2020-07-31', 'PA', 'Panama', 'AMRO', '1046', '63269', '25', '1374');
INSERT INTO public.who_global_data_import VALUES (64612, '2020-08-01', 'PA', 'Panama', 'AMRO', '922', '64191', '23', '1397');
INSERT INTO public.who_global_data_import VALUES (64613, '2020-08-02', 'PA', 'Panama', 'AMRO', '1065', '65256', '24', '1421');
INSERT INTO public.who_global_data_import VALUES (64614, '2020-08-03', 'PA', 'Panama', 'AMRO', '1127', '66383', '28', '1449');
INSERT INTO public.who_global_data_import VALUES (64615, '2020-08-04', 'PA', 'Panama', 'AMRO', '1070', '67453', '22', '1471');
INSERT INTO public.who_global_data_import VALUES (64616, '2020-08-05', 'PA', 'Panama', 'AMRO', '1003', '68456', '26', '1497');
INSERT INTO public.who_global_data_import VALUES (64617, '2020-08-06', 'PA', 'Panama', 'AMRO', '968', '69424', '25', '1522');
INSERT INTO public.who_global_data_import VALUES (64618, '2020-08-07', 'PA', 'Panama', 'AMRO', '807', '70231', '31', '1553');
INSERT INTO public.who_global_data_import VALUES (64619, '2020-08-08', 'PA', 'Panama', 'AMRO', '1187', '71418', '21', '1574');
INSERT INTO public.who_global_data_import VALUES (64620, '2020-08-09', 'PA', 'Panama', 'AMRO', '1142', '72560', '17', '1591');
INSERT INTO public.who_global_data_import VALUES (64621, '2020-08-10', 'PA', 'Panama', 'AMRO', '1091', '73651', '18', '1609');
INSERT INTO public.who_global_data_import VALUES (64622, '2020-08-11', 'PA', 'Panama', 'AMRO', '841', '74492', '30', '1639');
INSERT INTO public.who_global_data_import VALUES (64623, '2020-08-12', 'PA', 'Panama', 'AMRO', '902', '75394', '25', '1664');
INSERT INTO public.who_global_data_import VALUES (64624, '2020-08-13', 'PA', 'Panama', 'AMRO', '1070', '76464', '16', '1680');
INSERT INTO public.who_global_data_import VALUES (64625, '2020-08-14', 'PA', 'Panama', 'AMRO', '913', '77377', '23', '1703');
INSERT INTO public.who_global_data_import VALUES (64626, '2020-08-15', 'PA', 'Panama', 'AMRO', '1069', '78446', '19', '1722');
INSERT INTO public.who_global_data_import VALUES (64627, '2020-08-16', 'PA', 'Panama', 'AMRO', '956', '79402', '12', '1734');
INSERT INTO public.who_global_data_import VALUES (64628, '2020-08-17', 'PA', 'Panama', 'AMRO', '1263', '80665', '12', '1746');
INSERT INTO public.who_global_data_import VALUES (64629, '2020-08-18', 'PA', 'Panama', 'AMRO', '1275', '81940', '21', '1767');
INSERT INTO public.who_global_data_import VALUES (64630, '2020-08-19', 'PA', 'Panama', 'AMRO', '603', '82543', '21', '1788');
INSERT INTO public.who_global_data_import VALUES (64631, '2020-08-20', 'PA', 'Panama', 'AMRO', '247', '82790', '21', '1809');
INSERT INTO public.who_global_data_import VALUES (64632, '2020-08-21', 'PA', 'Panama', 'AMRO', '964', '83754', '18', '1827');
INSERT INTO public.who_global_data_import VALUES (64633, '2020-08-22', 'PA', 'Panama', 'AMRO', '101', '83855', '17', '1844');
INSERT INTO public.who_global_data_import VALUES (64634, '2020-08-23', 'PA', 'Panama', 'AMRO', '537', '84392', '15', '1859');
INSERT INTO public.who_global_data_import VALUES (64635, '2020-08-24', 'PA', 'Panama', 'AMRO', '1088', '85480', '19', '1878');
INSERT INTO public.who_global_data_import VALUES (64636, '2020-08-25', 'PA', 'Panama', 'AMRO', '1420', '86900', '14', '1892');
INSERT INTO public.who_global_data_import VALUES (64637, '2020-08-26', 'PA', 'Panama', 'AMRO', '585', '87485', '14', '1906');
INSERT INTO public.who_global_data_import VALUES (64638, '2020-08-27', 'PA', 'Panama', 'AMRO', '896', '88381', '13', '1919');
INSERT INTO public.who_global_data_import VALUES (64639, '2020-08-28', 'PA', 'Panama', 'AMRO', '701', '89082', '13', '1932');
INSERT INTO public.who_global_data_import VALUES (64640, '2020-08-29', 'PA', 'Panama', 'AMRO', '900', '89982', '16', '1948');
INSERT INTO public.who_global_data_import VALUES (64641, '2020-08-30', 'PA', 'Panama', 'AMRO', '642', '90624', '18', '1966');
INSERT INTO public.who_global_data_import VALUES (64642, '2020-08-31', 'PA', 'Panama', 'AMRO', '713', '91337', '17', '1983');
INSERT INTO public.who_global_data_import VALUES (64643, '2020-09-01', 'PA', 'Panama', 'AMRO', '728', '92065', '12', '1995');
INSERT INTO public.who_global_data_import VALUES (64644, '2020-09-02', 'PA', 'Panama', 'AMRO', '917', '92982', '7', '2002');
INSERT INTO public.who_global_data_import VALUES (64645, '2020-09-03', 'PA', 'Panama', 'AMRO', '570', '93552', '16', '2018');
INSERT INTO public.who_global_data_import VALUES (64646, '2020-09-04', 'PA', 'Panama', 'AMRO', '532', '94084', '12', '2030');
INSERT INTO public.who_global_data_import VALUES (64647, '2020-09-05', 'PA', 'Panama', 'AMRO', '830', '94914', '16', '2046');
INSERT INTO public.who_global_data_import VALUES (64648, '2020-09-06', 'PA', 'Panama', 'AMRO', '682', '95596', '17', '2063');
INSERT INTO public.who_global_data_import VALUES (64649, '2020-09-07', 'PA', 'Panama', 'AMRO', '709', '96305', '12', '2075');
INSERT INTO public.who_global_data_import VALUES (64650, '2020-09-08', 'PA', 'Panama', 'AMRO', '738', '97043', '11', '2086');
INSERT INTO public.who_global_data_import VALUES (64651, '2020-09-09', 'PA', 'Panama', 'AMRO', '535', '97578', '13', '2099');
INSERT INTO public.who_global_data_import VALUES (64652, '2020-09-10', 'PA', 'Panama', 'AMRO', '829', '98407', '8', '2107');
INSERT INTO public.who_global_data_import VALUES (64653, '2020-09-11', 'PA', 'Panama', 'AMRO', '635', '99042', '9', '2116');
INSERT INTO public.who_global_data_import VALUES (64654, '2020-09-12', 'PA', 'Panama', 'AMRO', '673', '99715', '11', '2127');
INSERT INTO public.who_global_data_import VALUES (64655, '2020-09-13', 'PA', 'Panama', 'AMRO', '615', '100330', '13', '2140');
INSERT INTO public.who_global_data_import VALUES (64656, '2020-09-14', 'PA', 'Panama', 'AMRO', '711', '101041', '15', '2155');
INSERT INTO public.who_global_data_import VALUES (64657, '2020-09-15', 'PA', 'Panama', 'AMRO', '704', '101745', '11', '2166');
INSERT INTO public.who_global_data_import VALUES (64658, '2020-09-16', 'PA', 'Panama', 'AMRO', '459', '102204', '7', '2173');
INSERT INTO public.who_global_data_import VALUES (64659, '2020-09-17', 'PA', 'Panama', 'AMRO', '628', '102832', '14', '2187');
INSERT INTO public.who_global_data_import VALUES (64660, '2020-09-18', 'PA', 'Panama', 'AMRO', '634', '103466', '11', '2198');
INSERT INTO public.who_global_data_import VALUES (64661, '2020-09-19', 'PA', 'Panama', 'AMRO', '672', '104138', '15', '2213');
INSERT INTO public.who_global_data_import VALUES (64662, '2020-09-20', 'PA', 'Panama', 'AMRO', '741', '104879', '16', '2229');
INSERT INTO public.who_global_data_import VALUES (64663, '2020-09-21', 'PA', 'Panama', 'AMRO', '722', '105601', '18', '2247');
INSERT INTO public.who_global_data_import VALUES (64664, '2020-09-22', 'PA', 'Panama', 'AMRO', '602', '106203', '10', '2257');
INSERT INTO public.who_global_data_import VALUES (64665, '2020-09-23', 'PA', 'Panama', 'AMRO', '607', '106810', '15', '2272');
INSERT INTO public.who_global_data_import VALUES (64666, '2020-09-24', 'PA', 'Panama', 'AMRO', '474', '107284', '13', '2285');
INSERT INTO public.who_global_data_import VALUES (64667, '2020-09-25', 'PA', 'Panama', 'AMRO', '706', '107990', '6', '2291');
INSERT INTO public.who_global_data_import VALUES (64668, '2020-09-26', 'PA', 'Panama', 'AMRO', '736', '108726', '6', '2297');
INSERT INTO public.who_global_data_import VALUES (64669, '2020-09-27', 'PA', 'Panama', 'AMRO', '705', '109431', '14', '2311');
INSERT INTO public.who_global_data_import VALUES (64670, '2020-09-28', 'PA', 'Panama', 'AMRO', '677', '110108', '12', '2323');
INSERT INTO public.who_global_data_import VALUES (64671, '2020-09-29', 'PA', 'Panama', 'AMRO', '447', '110555', '17', '2340');
INSERT INTO public.who_global_data_import VALUES (64672, '2020-09-30', 'PA', 'Panama', 'AMRO', '722', '111277', '8', '2348');
INSERT INTO public.who_global_data_import VALUES (64673, '2020-10-01', 'PA', 'Panama', 'AMRO', '576', '111853', '16', '2364');
INSERT INTO public.who_global_data_import VALUES (64674, '2020-10-02', 'PA', 'Panama', 'AMRO', '742', '112595', '8', '2372');
INSERT INTO public.who_global_data_import VALUES (64675, '2020-10-03', 'PA', 'Panama', 'AMRO', '747', '113342', '15', '2387');
INSERT INTO public.who_global_data_import VALUES (64676, '2020-10-04', 'PA', 'Panama', 'AMRO', '620', '113962', '19', '2406');
INSERT INTO public.who_global_data_import VALUES (64677, '2020-10-05', 'PA', 'Panama', 'AMRO', '691', '114653', '8', '2414');
INSERT INTO public.who_global_data_import VALUES (64678, '2020-10-06', 'PA', 'Panama', 'AMRO', '633', '115286', '9', '2423');
INSERT INTO public.who_global_data_import VALUES (64679, '2020-10-07', 'PA', 'Panama', 'AMRO', '633', '115919', '7', '2430');
INSERT INTO public.who_global_data_import VALUES (64680, '2020-10-08', 'PA', 'Panama', 'AMRO', '683', '116602', '10', '2440');
INSERT INTO public.who_global_data_import VALUES (64681, '2020-10-09', 'PA', 'Panama', 'AMRO', '698', '117300', '8', '2448');
INSERT INTO public.who_global_data_import VALUES (64682, '2020-10-10', 'PA', 'Panama', 'AMRO', '754', '118054', '15', '2463');
INSERT INTO public.who_global_data_import VALUES (64683, '2020-10-11', 'PA', 'Panama', 'AMRO', '787', '118841', '11', '2474');
INSERT INTO public.who_global_data_import VALUES (64684, '2020-10-12', 'PA', 'Panama', 'AMRO', '825', '119666', '8', '2482');
INSERT INTO public.who_global_data_import VALUES (64685, '2020-10-13', 'PA', 'Panama', 'AMRO', '647', '120313', '9', '2491');
INSERT INTO public.who_global_data_import VALUES (64686, '2020-10-14', 'PA', 'Panama', 'AMRO', '489', '120802', '11', '2502');
INSERT INTO public.who_global_data_import VALUES (64687, '2020-10-15', 'PA', 'Panama', 'AMRO', '494', '121296', '9', '2511');
INSERT INTO public.who_global_data_import VALUES (64688, '2020-10-16', 'PA', 'Panama', 'AMRO', '832', '122128', '8', '2519');
INSERT INTO public.who_global_data_import VALUES (64689, '2020-10-17', 'PA', 'Panama', 'AMRO', '755', '122883', '10', '2529');
INSERT INTO public.who_global_data_import VALUES (64690, '2020-10-18', 'PA', 'Panama', 'AMRO', '615', '123498', '17', '2546');
INSERT INTO public.who_global_data_import VALUES (64691, '2020-10-19', 'PA', 'Panama', 'AMRO', '609', '124107', '11', '2557');
INSERT INTO public.who_global_data_import VALUES (64692, '2020-10-20', 'PA', 'Panama', 'AMRO', '638', '124745', '7', '2564');
INSERT INTO public.who_global_data_import VALUES (64693, '2020-10-21', 'PA', 'Panama', 'AMRO', '436', '125181', '10', '2574');
INSERT INTO public.who_global_data_import VALUES (64694, '2020-10-22', 'PA', 'Panama', 'AMRO', '558', '125739', '11', '2585');
INSERT INTO public.who_global_data_import VALUES (64695, '2020-10-23', 'PA', 'Panama', 'AMRO', '696', '126435', '12', '2597');
INSERT INTO public.who_global_data_import VALUES (64696, '2020-10-24', 'PA', 'Panama', 'AMRO', '792', '127227', '15', '2612');
INSERT INTO public.who_global_data_import VALUES (64697, '2020-10-25', 'PA', 'Panama', 'AMRO', '639', '127866', '10', '2622');
INSERT INTO public.who_global_data_import VALUES (64698, '2020-10-26', 'PA', 'Panama', 'AMRO', '649', '128515', '6', '2628');
INSERT INTO public.who_global_data_import VALUES (64699, '2020-10-27', 'PA', 'Panama', 'AMRO', '685', '129200', '5', '2633');
INSERT INTO public.who_global_data_import VALUES (64700, '2020-10-28', 'PA', 'Panama', 'AMRO', '551', '129751', '5', '2638');
INSERT INTO public.who_global_data_import VALUES (64701, '2020-10-29', 'PA', 'Panama', 'AMRO', '671', '130422', '12', '2650');
INSERT INTO public.who_global_data_import VALUES (64702, '2020-10-30', 'PA', 'Panama', 'AMRO', '825', '131247', '13', '2663');
INSERT INTO public.who_global_data_import VALUES (64703, '2020-10-31', 'PA', 'Panama', 'AMRO', '798', '132045', '15', '2678');
INSERT INTO public.who_global_data_import VALUES (64704, '2020-11-01', 'PA', 'Panama', 'AMRO', '822', '132867', '10', '2688');
INSERT INTO public.who_global_data_import VALUES (64705, '2020-11-02', 'PA', 'Panama', 'AMRO', '731', '133598', '12', '2700');
INSERT INTO public.who_global_data_import VALUES (64706, '2020-11-03', 'PA', 'Panama', 'AMRO', '738', '134336', '6', '2706');
INSERT INTO public.who_global_data_import VALUES (64707, '2020-11-04', 'PA', 'Panama', 'AMRO', '579', '134915', '14', '2720');
INSERT INTO public.who_global_data_import VALUES (64708, '2020-11-05', 'PA', 'Panama', 'AMRO', '677', '135592', '11', '2731');
INSERT INTO public.who_global_data_import VALUES (64709, '2020-11-06', 'PA', 'Panama', 'AMRO', '432', '136024', '13', '2744');
INSERT INTO public.who_global_data_import VALUES (64710, '2020-11-07', 'PA', 'Panama', 'AMRO', '543', '136567', '12', '2756');
INSERT INTO public.who_global_data_import VALUES (64711, '2020-11-08', 'PA', 'Panama', 'AMRO', '1193', '137760', '14', '2770');
INSERT INTO public.who_global_data_import VALUES (64712, '2020-11-09', 'PA', 'Panama', 'AMRO', '746', '138506', '11', '2781');
INSERT INTO public.who_global_data_import VALUES (64713, '2020-11-10', 'PA', 'Panama', 'AMRO', '1021', '139527', '17', '2798');
INSERT INTO public.who_global_data_import VALUES (64714, '2020-11-11', 'PA', 'Panama', 'AMRO', '804', '140331', '10', '2808');
INSERT INTO public.who_global_data_import VALUES (64715, '2020-11-12', 'PA', 'Panama', 'AMRO', '971', '141302', '9', '2817');
INSERT INTO public.who_global_data_import VALUES (64716, '2020-11-13', 'PA', 'Panama', 'AMRO', '1163', '142465', '6', '2823');
INSERT INTO public.who_global_data_import VALUES (64717, '2020-11-14', 'PA', 'Panama', 'AMRO', '887', '143352', '7', '2830');
INSERT INTO public.who_global_data_import VALUES (64718, '2020-11-15', 'PA', 'Panama', 'AMRO', '1125', '144477', '26', '2856');
INSERT INTO public.who_global_data_import VALUES (64719, '2020-11-16', 'PA', 'Panama', 'AMRO', '832', '145309', '11', '2867');
INSERT INTO public.who_global_data_import VALUES (64720, '2020-11-17', 'PA', 'Panama', 'AMRO', '1344', '146653', '6', '2873');
INSERT INTO public.who_global_data_import VALUES (64721, '2020-11-18', 'PA', 'Panama', 'AMRO', '1014', '147667', '8', '2881');
INSERT INTO public.who_global_data_import VALUES (64722, '2020-11-19', 'PA', 'Panama', 'AMRO', '1054', '148721', '12', '2893');
INSERT INTO public.who_global_data_import VALUES (64723, '2020-11-20', 'PA', 'Panama', 'AMRO', '1112', '149833', '14', '2907');
INSERT INTO public.who_global_data_import VALUES (64724, '2020-11-21', 'PA', 'Panama', 'AMRO', '1256', '151089', '15', '2922');
INSERT INTO public.who_global_data_import VALUES (64725, '2020-11-22', 'PA', 'Panama', 'AMRO', '1200', '152289', '10', '2932');
INSERT INTO public.who_global_data_import VALUES (64726, '2020-11-23', 'PA', 'Panama', 'AMRO', '1288', '153577', '14', '2946');
INSERT INTO public.who_global_data_import VALUES (64727, '2020-11-24', 'PA', 'Panama', 'AMRO', '1206', '154783', '11', '2957');
INSERT INTO public.who_global_data_import VALUES (64728, '2020-11-25', 'PA', 'Panama', 'AMRO', '875', '155658', '16', '2973');
INSERT INTO public.who_global_data_import VALUES (64729, '2020-11-26', 'PA', 'Panama', 'AMRO', '1272', '156930', '13', '2986');
INSERT INTO public.who_global_data_import VALUES (64730, '2020-11-27', 'PA', 'Panama', 'AMRO', '1602', '158532', '16', '3002');
INSERT INTO public.who_global_data_import VALUES (64731, '2020-11-28', 'PA', 'Panama', 'AMRO', '1755', '160287', '16', '3018');
INSERT INTO public.who_global_data_import VALUES (64732, '2020-11-29', 'PA', 'Panama', 'AMRO', '1457', '161744', '12', '3030');
INSERT INTO public.who_global_data_import VALUES (64733, '2020-11-30', 'PA', 'Panama', 'AMRO', '1709', '163453', '9', '3039');
INSERT INTO public.who_global_data_import VALUES (64734, '2020-12-01', 'PA', 'Panama', 'AMRO', '1276', '164729', '21', '3060');
INSERT INTO public.who_global_data_import VALUES (64735, '2020-12-02', 'PA', 'Panama', 'AMRO', '1077', '165806', '19', '3079');
INSERT INTO public.who_global_data_import VALUES (64736, '2020-12-03', 'PA', 'Panama', 'AMRO', '1505', '167311', '19', '3098');
INSERT INTO public.who_global_data_import VALUES (64737, '2020-12-04', 'PA', 'Panama', 'AMRO', '2028', '169339', '16', '3114');
INSERT INTO public.who_global_data_import VALUES (64738, '2020-12-05', 'PA', 'Panama', 'AMRO', '1880', '171219', '27', '3141');
INSERT INTO public.who_global_data_import VALUES (64739, '2020-12-06', 'PA', 'Panama', 'AMRO', '2388', '173607', '13', '3154');
INSERT INTO public.who_global_data_import VALUES (64740, '2020-12-07', 'PA', 'Panama', 'AMRO', '2300', '175907', '19', '3173');
INSERT INTO public.who_global_data_import VALUES (64741, '2020-12-08', 'PA', 'Panama', 'AMRO', '1812', '177719', '20', '3193');
INSERT INTO public.who_global_data_import VALUES (64742, '2020-12-09', 'PA', 'Panama', 'AMRO', '1511', '179230', '19', '3212');
INSERT INTO public.who_global_data_import VALUES (64743, '2020-12-10', 'PA', 'Panama', 'AMRO', '1936', '181166', '29', '3241');
INSERT INTO public.who_global_data_import VALUES (64744, '2020-12-11', 'PA', 'Panama', 'AMRO', '1811', '182977', '23', '3264');
INSERT INTO public.who_global_data_import VALUES (64745, '2020-12-12', 'PA', 'Panama', 'AMRO', '2447', '185424', '23', '3287');
INSERT INTO public.who_global_data_import VALUES (64746, '2020-12-13', 'PA', 'Panama', 'AMRO', '2355', '187779', '22', '3309');
INSERT INTO public.who_global_data_import VALUES (64747, '2020-12-14', 'PA', 'Panama', 'AMRO', '2806', '190585', '22', '3331');
INSERT INTO public.who_global_data_import VALUES (64748, '2020-12-15', 'PA', 'Panama', 'AMRO', '2422', '193007', '25', '3356');
INSERT INTO public.who_global_data_import VALUES (64749, '2020-12-16', 'PA', 'Panama', 'AMRO', '1612', '194619', '26', '3382');
INSERT INTO public.who_global_data_import VALUES (64750, '2020-12-17', 'PA', 'Panama', 'AMRO', '2368', '196987', '29', '3411');
INSERT INTO public.who_global_data_import VALUES (64751, '2020-12-18', 'PA', 'Panama', 'AMRO', '2960', '199947', '28', '3439');
INSERT INTO public.who_global_data_import VALUES (64752, '2020-12-19', 'PA', 'Panama', 'AMRO', '3348', '203295', '42', '3481');
INSERT INTO public.who_global_data_import VALUES (64753, '2020-12-20', 'PA', 'Panama', 'AMRO', '3015', '206310', '23', '3504');
INSERT INTO public.who_global_data_import VALUES (64754, '2020-12-21', 'PA', 'Panama', 'AMRO', '3274', '209584', '23', '3527');
INSERT INTO public.who_global_data_import VALUES (64755, '2020-12-22', 'PA', 'Panama', 'AMRO', '2755', '212339', '39', '3566');
INSERT INTO public.who_global_data_import VALUES (64756, '2020-12-23', 'PA', 'Panama', 'AMRO', '1699', '214038', '31', '3597');
INSERT INTO public.who_global_data_import VALUES (64757, '2020-12-24', 'PA', 'Panama', 'AMRO', '3164', '217202', '35', '3632');
INSERT INTO public.who_global_data_import VALUES (64758, '2020-12-25', 'PA', 'Panama', 'AMRO', '3059', '220261', '32', '3664');
INSERT INTO public.who_global_data_import VALUES (64759, '2020-12-26', 'PA', 'Panama', 'AMRO', '3413', '223674', '51', '3715');
INSERT INTO public.who_global_data_import VALUES (64760, '2020-12-27', 'PA', 'Panama', 'AMRO', '2986', '226660', '41', '3756');
INSERT INTO public.who_global_data_import VALUES (64761, '2020-12-28', 'PA', 'Panama', 'AMRO', '2064', '228724', '43', '3799');
INSERT INTO public.who_global_data_import VALUES (64762, '2020-12-29', 'PA', 'Panama', 'AMRO', '2633', '231357', '41', '3840');
INSERT INTO public.who_global_data_import VALUES (64763, '2020-12-30', 'PA', 'Panama', 'AMRO', '2348', '233705', '52', '3892');
INSERT INTO public.who_global_data_import VALUES (64764, '2020-12-31', 'PA', 'Panama', 'AMRO', '4574', '238279', '41', '3933');
INSERT INTO public.who_global_data_import VALUES (64765, '2021-01-01', 'PA', 'Panama', 'AMRO', '4465', '242744', '42', '3975');
INSERT INTO public.who_global_data_import VALUES (64766, '2021-01-02', 'PA', 'Panama', 'AMRO', '4046', '246790', '47', '4022');
INSERT INTO public.who_global_data_import VALUES (64767, '2021-01-03', 'PA', 'Panama', 'AMRO', '2943', '249733', '42', '4064');
INSERT INTO public.who_global_data_import VALUES (64768, '2021-01-04', 'PA', 'Panama', 'AMRO', '2031', '251764', '39', '4103');
INSERT INTO public.who_global_data_import VALUES (64769, '2021-01-05', 'PA', 'Panama', 'AMRO', '1972', '253736', '37', '4140');
INSERT INTO public.who_global_data_import VALUES (64770, '2021-01-06', 'PA', 'Panama', 'AMRO', '2494', '256230', '57', '4197');
INSERT INTO public.who_global_data_import VALUES (64771, '2021-01-07', 'PA', 'Panama', 'AMRO', '3540', '259770', '41', '4238');
INSERT INTO public.who_global_data_import VALUES (64772, '2021-01-08', 'PA', 'Panama', 'AMRO', '5186', '264956', '45', '4283');
INSERT INTO public.who_global_data_import VALUES (64773, '2021-01-09', 'PA', 'Panama', 'AMRO', '4135', '269091', '38', '4321');
INSERT INTO public.who_global_data_import VALUES (64774, '2021-01-10', 'PA', 'Panama', 'AMRO', '3946', '273037', '42', '4363');
INSERT INTO public.who_global_data_import VALUES (64775, '2021-01-11', 'PA', 'Panama', 'AMRO', '3735', '276772', '47', '4410');
INSERT INTO public.who_global_data_import VALUES (64776, '2021-01-12', 'PA', 'Panama', 'AMRO', '2424', '279196', '45', '4455');
INSERT INTO public.who_global_data_import VALUES (64777, '2021-01-13', 'PA', 'Panama', 'AMRO', '2157', '281353', '45', '4500');
INSERT INTO public.who_global_data_import VALUES (64778, '2021-01-14', 'PA', 'Panama', 'AMRO', '3740', '285093', '61', '4561');
INSERT INTO public.who_global_data_import VALUES (64779, '2021-01-15', 'PA', 'Panama', 'AMRO', '3315', '288408', '33', '4594');
INSERT INTO public.who_global_data_import VALUES (64780, '2021-01-16', 'PA', 'Panama', 'AMRO', '2877', '291285', '57', '4651');
INSERT INTO public.who_global_data_import VALUES (64781, '2021-01-17', 'PA', 'Panama', 'AMRO', '2307', '293592', '38', '4689');
INSERT INTO public.who_global_data_import VALUES (64782, '2021-01-18', 'PA', 'Panama', 'AMRO', '2677', '296269', '49', '4738');
INSERT INTO public.who_global_data_import VALUES (64783, '2021-01-19', 'PA', 'Panama', 'AMRO', '1750', '298019', '49', '4787');
INSERT INTO public.who_global_data_import VALUES (64784, '2021-01-20', 'PA', 'Panama', 'AMRO', '1342', '299361', '41', '4828');
INSERT INTO public.who_global_data_import VALUES (64785, '2021-01-21', 'PA', 'Panama', 'AMRO', '2173', '301534', '36', '4864');
INSERT INTO public.who_global_data_import VALUES (64786, '2021-01-22', 'PA', 'Panama', 'AMRO', '2243', '303777', '48', '4912');
INSERT INTO public.who_global_data_import VALUES (64787, '2021-01-23', 'PA', 'Panama', 'AMRO', '1975', '305752', '32', '4944');
INSERT INTO public.who_global_data_import VALUES (64788, '2021-01-24', 'PA', 'Panama', 'AMRO', '2041', '307793', '36', '4980');
INSERT INTO public.who_global_data_import VALUES (64789, '2021-01-25', 'PA', 'Panama', 'AMRO', '2058', '309851', '54', '5034');
INSERT INTO public.who_global_data_import VALUES (64790, '2021-01-26', 'PA', 'Panama', 'AMRO', '1393', '311244', '29', '5063');
INSERT INTO public.who_global_data_import VALUES (64791, '2021-01-27', 'PA', 'Panama', 'AMRO', '914', '312158', '35', '5098');
INSERT INTO public.who_global_data_import VALUES (64792, '2021-01-28', 'PA', 'Panama', 'AMRO', '1676', '313834', '39', '5137');
INSERT INTO public.who_global_data_import VALUES (64793, '2021-01-29', 'PA', 'Panama', 'AMRO', '1566', '315400', '39', '5176');
INSERT INTO public.who_global_data_import VALUES (64794, '2021-01-30', 'PA', 'Panama', 'AMRO', '1408', '316808', '20', '5196');
INSERT INTO public.who_global_data_import VALUES (64795, '2021-01-31', 'PA', 'Panama', 'AMRO', '1445', '318253', '25', '5221');
INSERT INTO public.who_global_data_import VALUES (64796, '2021-02-01', 'PA', 'Panama', 'AMRO', '1200', '319453', '23', '5244');
INSERT INTO public.who_global_data_import VALUES (64797, '2021-02-02', 'PA', 'Panama', 'AMRO', '926', '320379', '26', '5270');
INSERT INTO public.who_global_data_import VALUES (64798, '2021-02-03', 'PA', 'Panama', 'AMRO', '724', '321103', '26', '5296');
INSERT INTO public.who_global_data_import VALUES (64799, '2021-02-04', 'PA', 'Panama', 'AMRO', '1098', '322201', '43', '5339');
INSERT INTO public.who_global_data_import VALUES (64800, '2021-02-05', 'PA', 'Panama', 'AMRO', '1181', '323382', '27', '5366');
INSERT INTO public.who_global_data_import VALUES (64801, '2020-01-03', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64802, '2020-01-04', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64803, '2020-01-05', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64804, '2020-01-06', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64805, '2020-01-07', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64806, '2020-01-08', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64807, '2020-01-09', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64808, '2020-01-10', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64809, '2020-01-11', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64810, '2020-01-12', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64811, '2020-01-13', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64812, '2020-01-14', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64813, '2020-01-15', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64814, '2020-01-16', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64815, '2020-01-17', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64816, '2020-01-18', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64817, '2020-01-19', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64818, '2020-01-20', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64819, '2020-01-21', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64820, '2020-01-22', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64821, '2020-01-23', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64822, '2020-01-24', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64823, '2020-01-25', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64824, '2020-01-26', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64825, '2020-01-27', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64826, '2020-01-28', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64827, '2020-01-29', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64828, '2020-01-30', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64829, '2020-01-31', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64830, '2020-02-01', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64831, '2020-02-02', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64832, '2020-02-03', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64833, '2020-02-04', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64834, '2020-02-05', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64835, '2020-02-06', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64836, '2020-02-07', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64837, '2020-02-08', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64838, '2020-02-09', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64839, '2020-02-10', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64840, '2020-02-11', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64841, '2020-02-12', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64842, '2020-02-13', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64843, '2020-02-14', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64844, '2020-02-15', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64845, '2020-02-16', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64846, '2020-02-17', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64847, '2020-02-18', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64848, '2020-02-19', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64849, '2020-02-20', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64850, '2020-02-21', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64851, '2020-02-22', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64852, '2020-02-23', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64853, '2020-02-24', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64854, '2020-02-25', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64855, '2020-02-26', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64856, '2020-02-27', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64857, '2020-02-28', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64858, '2020-02-29', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64859, '2020-03-01', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64860, '2020-03-02', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64861, '2020-03-03', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64862, '2020-03-04', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64863, '2020-03-05', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64864, '2020-03-06', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64865, '2020-03-07', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64866, '2020-03-08', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64867, '2020-03-09', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64868, '2020-03-10', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64869, '2020-03-11', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64870, '2020-03-12', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64871, '2020-03-13', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64872, '2020-03-14', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64873, '2020-03-15', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64874, '2020-03-16', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64875, '2020-03-17', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64876, '2020-03-18', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64877, '2020-03-19', 'PG', 'Papua New Guinea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64878, '2020-03-20', 'PG', 'Papua New Guinea', 'WPRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64879, '2020-03-21', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64880, '2020-03-22', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64881, '2020-03-23', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64882, '2020-03-24', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64883, '2020-03-25', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64884, '2020-03-26', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64885, '2020-03-27', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64886, '2020-03-28', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64887, '2020-03-29', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64888, '2020-03-30', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64889, '2020-03-31', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64890, '2020-04-01', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64891, '2020-04-02', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64892, '2020-04-03', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64893, '2020-04-04', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64894, '2020-04-05', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64895, '2020-04-06', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64896, '2020-04-07', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64897, '2020-04-08', 'PG', 'Papua New Guinea', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64898, '2020-04-09', 'PG', 'Papua New Guinea', 'WPRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64899, '2020-04-10', 'PG', 'Papua New Guinea', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64900, '2020-04-11', 'PG', 'Papua New Guinea', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64901, '2020-04-12', 'PG', 'Papua New Guinea', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64902, '2020-04-13', 'PG', 'Papua New Guinea', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64903, '2020-04-14', 'PG', 'Papua New Guinea', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64904, '2020-04-15', 'PG', 'Papua New Guinea', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64905, '2020-04-16', 'PG', 'Papua New Guinea', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64906, '2020-04-17', 'PG', 'Papua New Guinea', 'WPRO', '5', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64907, '2020-04-18', 'PG', 'Papua New Guinea', 'WPRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64908, '2020-04-19', 'PG', 'Papua New Guinea', 'WPRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64909, '2020-04-20', 'PG', 'Papua New Guinea', 'WPRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64910, '2020-04-21', 'PG', 'Papua New Guinea', 'WPRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64911, '2020-04-22', 'PG', 'Papua New Guinea', 'WPRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64912, '2020-04-23', 'PG', 'Papua New Guinea', 'WPRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64913, '2020-04-24', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64914, '2020-04-25', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64915, '2020-04-26', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64916, '2020-04-27', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64917, '2020-04-28', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64918, '2020-04-29', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64919, '2020-04-30', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64920, '2020-05-01', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64921, '2020-05-02', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64922, '2020-05-03', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64923, '2020-05-04', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64924, '2020-05-05', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64925, '2020-05-06', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64926, '2020-05-07', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64927, '2020-05-08', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64928, '2020-05-09', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64929, '2020-05-10', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64930, '2020-05-11', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64931, '2020-05-12', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64932, '2020-05-13', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64933, '2020-05-14', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64934, '2020-05-15', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64935, '2020-05-16', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64936, '2020-05-17', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64937, '2020-05-18', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64938, '2020-05-19', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64939, '2020-05-20', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64940, '2020-05-21', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64941, '2020-05-22', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64942, '2020-05-23', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64943, '2020-05-24', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64944, '2020-05-25', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64945, '2020-05-26', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64946, '2020-05-27', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64947, '2020-05-28', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64948, '2020-05-29', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64949, '2020-05-30', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64950, '2020-05-31', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64951, '2020-06-01', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64952, '2020-06-02', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64953, '2020-06-03', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64954, '2020-06-04', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64955, '2020-06-05', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64956, '2020-06-06', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64957, '2020-06-07', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64958, '2020-06-08', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64959, '2020-06-09', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64960, '2020-06-10', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64961, '2020-06-11', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64962, '2020-06-12', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64963, '2020-06-13', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64964, '2020-06-14', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64965, '2020-06-15', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64966, '2020-06-16', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64967, '2020-06-17', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64968, '2020-06-18', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64969, '2020-06-19', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64970, '2020-06-20', 'PG', 'Papua New Guinea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64971, '2020-06-21', 'PG', 'Papua New Guinea', 'WPRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64972, '2020-06-22', 'PG', 'Papua New Guinea', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64973, '2020-06-23', 'PG', 'Papua New Guinea', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64974, '2020-06-24', 'PG', 'Papua New Guinea', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64975, '2020-06-25', 'PG', 'Papua New Guinea', 'WPRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64976, '2020-06-26', 'PG', 'Papua New Guinea', 'WPRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64977, '2020-06-27', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64978, '2020-06-28', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64979, '2020-06-29', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64980, '2020-06-30', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64981, '2020-07-01', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64982, '2020-07-02', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64983, '2020-07-03', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64984, '2020-07-04', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64985, '2020-07-05', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64986, '2020-07-06', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64987, '2020-07-07', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64988, '2020-07-08', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64989, '2020-07-09', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64990, '2020-07-10', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64991, '2020-07-11', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64992, '2020-07-12', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64993, '2020-07-13', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64994, '2020-07-14', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64995, '2020-07-15', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64996, '2020-07-16', 'PG', 'Papua New Guinea', 'WPRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64997, '2020-07-17', 'PG', 'Papua New Guinea', 'WPRO', '4', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64998, '2020-07-18', 'PG', 'Papua New Guinea', 'WPRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (64999, '2020-07-19', 'PG', 'Papua New Guinea', 'WPRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65000, '2020-07-20', 'PG', 'Papua New Guinea', 'WPRO', '2', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65001, '2020-07-21', 'PG', 'Papua New Guinea', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65002, '2020-07-22', 'PG', 'Papua New Guinea', 'WPRO', '10', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65003, '2020-07-23', 'PG', 'Papua New Guinea', 'WPRO', '3', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65004, '2020-07-24', 'PG', 'Papua New Guinea', 'WPRO', '1', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65005, '2020-07-25', 'PG', 'Papua New Guinea', 'WPRO', '1', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65006, '2020-07-26', 'PG', 'Papua New Guinea', 'WPRO', '7', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65007, '2020-07-27', 'PG', 'Papua New Guinea', 'WPRO', '23', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65008, '2020-07-28', 'PG', 'Papua New Guinea', 'WPRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65009, '2020-07-29', 'PG', 'Papua New Guinea', 'WPRO', '1', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65010, '2020-07-30', 'PG', 'Papua New Guinea', 'WPRO', '0', '63', '1', '1');
INSERT INTO public.who_global_data_import VALUES (65011, '2020-07-31', 'PG', 'Papua New Guinea', 'WPRO', '0', '63', '1', '2');
INSERT INTO public.who_global_data_import VALUES (65012, '2020-08-01', 'PG', 'Papua New Guinea', 'WPRO', '9', '72', '0', '2');
INSERT INTO public.who_global_data_import VALUES (65013, '2020-08-02', 'PG', 'Papua New Guinea', 'WPRO', '19', '91', '0', '2');
INSERT INTO public.who_global_data_import VALUES (65014, '2020-08-03', 'PG', 'Papua New Guinea', 'WPRO', '19', '110', '0', '2');
INSERT INTO public.who_global_data_import VALUES (65015, '2020-08-04', 'PG', 'Papua New Guinea', 'WPRO', '1', '111', '0', '2');
INSERT INTO public.who_global_data_import VALUES (65016, '2020-08-05', 'PG', 'Papua New Guinea', 'WPRO', '3', '114', '0', '2');
INSERT INTO public.who_global_data_import VALUES (65017, '2020-08-06', 'PG', 'Papua New Guinea', 'WPRO', '39', '153', '0', '2');
INSERT INTO public.who_global_data_import VALUES (65018, '2020-08-07', 'PG', 'Papua New Guinea', 'WPRO', '10', '163', '1', '3');
INSERT INTO public.who_global_data_import VALUES (65019, '2020-08-08', 'PG', 'Papua New Guinea', 'WPRO', '25', '188', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65020, '2020-08-09', 'PG', 'Papua New Guinea', 'WPRO', '0', '188', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65021, '2020-08-10', 'PG', 'Papua New Guinea', 'WPRO', '26', '214', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65022, '2020-08-11', 'PG', 'Papua New Guinea', 'WPRO', '0', '214', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65023, '2020-08-12', 'PG', 'Papua New Guinea', 'WPRO', '0', '214', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65024, '2020-08-13', 'PG', 'Papua New Guinea', 'WPRO', '55', '269', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65025, '2020-08-14', 'PG', 'Papua New Guinea', 'WPRO', '2', '271', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65026, '2020-08-15', 'PG', 'Papua New Guinea', 'WPRO', '4', '275', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65027, '2020-08-16', 'PG', 'Papua New Guinea', 'WPRO', '0', '275', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65028, '2020-08-17', 'PG', 'Papua New Guinea', 'WPRO', '48', '323', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65029, '2020-08-18', 'PG', 'Papua New Guinea', 'WPRO', '10', '333', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65030, '2020-08-19', 'PG', 'Papua New Guinea', 'WPRO', '14', '347', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65031, '2020-08-20', 'PG', 'Papua New Guinea', 'WPRO', '12', '359', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65032, '2020-08-21', 'PG', 'Papua New Guinea', 'WPRO', '2', '361', '1', '4');
INSERT INTO public.who_global_data_import VALUES (65033, '2020-08-22', 'PG', 'Papua New Guinea', 'WPRO', '0', '361', '0', '4');
INSERT INTO public.who_global_data_import VALUES (65034, '2020-08-23', 'PG', 'Papua New Guinea', 'WPRO', '0', '361', '0', '4');
INSERT INTO public.who_global_data_import VALUES (65035, '2020-08-24', 'PG', 'Papua New Guinea', 'WPRO', '40', '401', '0', '4');
INSERT INTO public.who_global_data_import VALUES (65036, '2020-08-25', 'PG', 'Papua New Guinea', 'WPRO', '0', '401', '0', '4');
INSERT INTO public.who_global_data_import VALUES (65037, '2020-08-26', 'PG', 'Papua New Guinea', 'WPRO', '18', '419', '0', '4');
INSERT INTO public.who_global_data_import VALUES (65038, '2020-08-27', 'PG', 'Papua New Guinea', 'WPRO', '0', '419', '0', '4');
INSERT INTO public.who_global_data_import VALUES (65039, '2020-08-28', 'PG', 'Papua New Guinea', 'WPRO', '5', '424', '0', '4');
INSERT INTO public.who_global_data_import VALUES (65040, '2020-08-29', 'PG', 'Papua New Guinea', 'WPRO', '29', '453', '1', '5');
INSERT INTO public.who_global_data_import VALUES (65041, '2020-08-30', 'PG', 'Papua New Guinea', 'WPRO', '6', '459', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65042, '2020-08-31', 'PG', 'Papua New Guinea', 'WPRO', '0', '459', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65043, '2020-09-01', 'PG', 'Papua New Guinea', 'WPRO', '0', '459', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65044, '2020-09-02', 'PG', 'Papua New Guinea', 'WPRO', '1', '460', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65045, '2020-09-03', 'PG', 'Papua New Guinea', 'WPRO', '11', '471', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65046, '2020-09-04', 'PG', 'Papua New Guinea', 'WPRO', '0', '471', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65047, '2020-09-05', 'PG', 'Papua New Guinea', 'WPRO', '8', '479', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65048, '2020-09-06', 'PG', 'Papua New Guinea', 'WPRO', '9', '488', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65049, '2020-09-07', 'PG', 'Papua New Guinea', 'WPRO', '9', '497', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65050, '2020-09-08', 'PG', 'Papua New Guinea', 'WPRO', '0', '497', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65051, '2020-09-09', 'PG', 'Papua New Guinea', 'WPRO', '6', '503', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65052, '2020-09-10', 'PG', 'Papua New Guinea', 'WPRO', '1', '504', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65053, '2020-09-11', 'PG', 'Papua New Guinea', 'WPRO', '3', '507', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65054, '2020-09-12', 'PG', 'Papua New Guinea', 'WPRO', '1', '508', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65055, '2020-09-13', 'PG', 'Papua New Guinea', 'WPRO', '0', '508', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65056, '2020-09-14', 'PG', 'Papua New Guinea', 'WPRO', '3', '511', '1', '6');
INSERT INTO public.who_global_data_import VALUES (65057, '2020-09-15', 'PG', 'Papua New Guinea', 'WPRO', '0', '511', '0', '6');
INSERT INTO public.who_global_data_import VALUES (65058, '2020-09-16', 'PG', 'Papua New Guinea', 'WPRO', '0', '511', '0', '6');
INSERT INTO public.who_global_data_import VALUES (65059, '2020-09-17', 'PG', 'Papua New Guinea', 'WPRO', '5', '516', '0', '6');
INSERT INTO public.who_global_data_import VALUES (65060, '2020-09-18', 'PG', 'Papua New Guinea', 'WPRO', '0', '516', '0', '6');
INSERT INTO public.who_global_data_import VALUES (65061, '2020-09-19', 'PG', 'Papua New Guinea', 'WPRO', '0', '516', '0', '6');
INSERT INTO public.who_global_data_import VALUES (65062, '2020-09-20', 'PG', 'Papua New Guinea', 'WPRO', '0', '516', '0', '6');
INSERT INTO public.who_global_data_import VALUES (65063, '2020-09-21', 'PG', 'Papua New Guinea', 'WPRO', '1', '517', '1', '7');
INSERT INTO public.who_global_data_import VALUES (65064, '2020-09-22', 'PG', 'Papua New Guinea', 'WPRO', '9', '526', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65065, '2020-09-23', 'PG', 'Papua New Guinea', 'WPRO', '1', '527', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65066, '2020-09-24', 'PG', 'Papua New Guinea', 'WPRO', '4', '531', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65067, '2020-09-25', 'PG', 'Papua New Guinea', 'WPRO', '0', '531', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65068, '2020-09-26', 'PG', 'Papua New Guinea', 'WPRO', '0', '531', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65069, '2020-09-27', 'PG', 'Papua New Guinea', 'WPRO', '1', '532', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65070, '2020-09-28', 'PG', 'Papua New Guinea', 'WPRO', '2', '534', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65071, '2020-09-29', 'PG', 'Papua New Guinea', 'WPRO', '0', '534', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65072, '2020-09-30', 'PG', 'Papua New Guinea', 'WPRO', '0', '534', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65073, '2020-10-01', 'PG', 'Papua New Guinea', 'WPRO', '0', '534', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65074, '2020-10-02', 'PG', 'Papua New Guinea', 'WPRO', '5', '539', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65075, '2020-10-03', 'PG', 'Papua New Guinea', 'WPRO', '0', '539', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65076, '2020-10-04', 'PG', 'Papua New Guinea', 'WPRO', '1', '540', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65077, '2020-10-05', 'PG', 'Papua New Guinea', 'WPRO', '0', '540', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65078, '2020-10-06', 'PG', 'Papua New Guinea', 'WPRO', '1', '541', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65079, '2020-10-07', 'PG', 'Papua New Guinea', 'WPRO', '0', '541', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65080, '2020-10-08', 'PG', 'Papua New Guinea', 'WPRO', '0', '541', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65081, '2020-10-09', 'PG', 'Papua New Guinea', 'WPRO', '8', '549', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65082, '2020-10-10', 'PG', 'Papua New Guinea', 'WPRO', '1', '550', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65083, '2020-10-11', 'PG', 'Papua New Guinea', 'WPRO', '0', '550', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65084, '2020-10-12', 'PG', 'Papua New Guinea', 'WPRO', '4', '554', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65085, '2020-10-13', 'PG', 'Papua New Guinea', 'WPRO', '11', '565', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65086, '2020-10-14', 'PG', 'Papua New Guinea', 'WPRO', '0', '565', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65087, '2020-10-15', 'PG', 'Papua New Guinea', 'WPRO', '13', '578', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65088, '2020-10-16', 'PG', 'Papua New Guinea', 'WPRO', '0', '578', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65089, '2020-10-17', 'PG', 'Papua New Guinea', 'WPRO', '0', '578', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65090, '2020-10-18', 'PG', 'Papua New Guinea', 'WPRO', '3', '581', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65091, '2020-10-19', 'PG', 'Papua New Guinea', 'WPRO', '0', '581', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65092, '2020-10-20', 'PG', 'Papua New Guinea', 'WPRO', '0', '581', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65093, '2020-10-21', 'PG', 'Papua New Guinea', 'WPRO', '0', '581', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65094, '2020-10-22', 'PG', 'Papua New Guinea', 'WPRO', '0', '581', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65095, '2020-10-23', 'PG', 'Papua New Guinea', 'WPRO', '2', '583', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65096, '2020-10-24', 'PG', 'Papua New Guinea', 'WPRO', '0', '583', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65097, '2020-10-25', 'PG', 'Papua New Guinea', 'WPRO', '0', '583', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65098, '2020-10-26', 'PG', 'Papua New Guinea', 'WPRO', '5', '588', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65099, '2020-10-27', 'PG', 'Papua New Guinea', 'WPRO', '0', '588', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65100, '2020-10-28', 'PG', 'Papua New Guinea', 'WPRO', '0', '588', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65101, '2020-10-29', 'PG', 'Papua New Guinea', 'WPRO', '1', '589', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65102, '2020-10-30', 'PG', 'Papua New Guinea', 'WPRO', '0', '589', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65103, '2020-10-31', 'PG', 'Papua New Guinea', 'WPRO', '0', '589', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65104, '2020-11-01', 'PG', 'Papua New Guinea', 'WPRO', '0', '589', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65105, '2020-11-02', 'PG', 'Papua New Guinea', 'WPRO', '1', '590', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65106, '2020-11-03', 'PG', 'Papua New Guinea', 'WPRO', '2', '592', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65107, '2020-11-04', 'PG', 'Papua New Guinea', 'WPRO', '5', '597', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65108, '2020-11-05', 'PG', 'Papua New Guinea', 'WPRO', '0', '597', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65109, '2020-11-06', 'PG', 'Papua New Guinea', 'WPRO', '0', '597', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65110, '2020-11-07', 'PG', 'Papua New Guinea', 'WPRO', '0', '597', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65111, '2020-11-08', 'PG', 'Papua New Guinea', 'WPRO', '0', '597', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65112, '2020-11-09', 'PG', 'Papua New Guinea', 'WPRO', '2', '599', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65113, '2020-11-10', 'PG', 'Papua New Guinea', 'WPRO', '0', '599', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65114, '2020-11-11', 'PG', 'Papua New Guinea', 'WPRO', '0', '599', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65115, '2020-11-12', 'PG', 'Papua New Guinea', 'WPRO', '0', '599', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65116, '2020-11-13', 'PG', 'Papua New Guinea', 'WPRO', '1', '600', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65117, '2020-11-14', 'PG', 'Papua New Guinea', 'WPRO', '0', '600', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65118, '2020-11-15', 'PG', 'Papua New Guinea', 'WPRO', '0', '600', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65119, '2020-11-16', 'PG', 'Papua New Guinea', 'WPRO', '2', '602', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65120, '2020-11-17', 'PG', 'Papua New Guinea', 'WPRO', '0', '602', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65121, '2020-11-18', 'PG', 'Papua New Guinea', 'WPRO', '2', '604', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65122, '2020-11-19', 'PG', 'Papua New Guinea', 'WPRO', '0', '604', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65123, '2020-11-20', 'PG', 'Papua New Guinea', 'WPRO', '0', '604', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65124, '2020-11-21', 'PG', 'Papua New Guinea', 'WPRO', '0', '604', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65125, '2020-11-22', 'PG', 'Papua New Guinea', 'WPRO', '0', '604', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65126, '2020-11-23', 'PG', 'Papua New Guinea', 'WPRO', '0', '604', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65127, '2020-11-24', 'PG', 'Papua New Guinea', 'WPRO', '8', '612', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65128, '2020-11-25', 'PG', 'Papua New Guinea', 'WPRO', '18', '630', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65129, '2020-11-26', 'PG', 'Papua New Guinea', 'WPRO', '15', '645', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65130, '2020-11-27', 'PG', 'Papua New Guinea', 'WPRO', '0', '645', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65131, '2020-11-28', 'PG', 'Papua New Guinea', 'WPRO', '0', '645', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65132, '2020-11-29', 'PG', 'Papua New Guinea', 'WPRO', '0', '645', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65133, '2020-11-30', 'PG', 'Papua New Guinea', 'WPRO', '10', '655', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65134, '2020-12-01', 'PG', 'Papua New Guinea', 'WPRO', '1', '656', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65135, '2020-12-02', 'PG', 'Papua New Guinea', 'WPRO', '0', '656', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65136, '2020-12-03', 'PG', 'Papua New Guinea', 'WPRO', '13', '669', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65137, '2020-12-04', 'PG', 'Papua New Guinea', 'WPRO', '2', '671', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65138, '2020-12-05', 'PG', 'Papua New Guinea', 'WPRO', '0', '671', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65139, '2020-12-06', 'PG', 'Papua New Guinea', 'WPRO', '0', '671', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65140, '2020-12-07', 'PG', 'Papua New Guinea', 'WPRO', '0', '671', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65141, '2020-12-08', 'PG', 'Papua New Guinea', 'WPRO', '13', '684', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65142, '2020-12-09', 'PG', 'Papua New Guinea', 'WPRO', '0', '684', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65143, '2020-12-10', 'PG', 'Papua New Guinea', 'WPRO', '0', '684', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65144, '2020-12-11', 'PG', 'Papua New Guinea', 'WPRO', '0', '684', '0', '7');
INSERT INTO public.who_global_data_import VALUES (65145, '2020-12-12', 'PG', 'Papua New Guinea', 'WPRO', '36', '720', '1', '8');
INSERT INTO public.who_global_data_import VALUES (65146, '2020-12-13', 'PG', 'Papua New Guinea', 'WPRO', '0', '720', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65147, '2020-12-14', 'PG', 'Papua New Guinea', 'WPRO', '5', '725', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65148, '2020-12-15', 'PG', 'Papua New Guinea', 'WPRO', '0', '725', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65149, '2020-12-16', 'PG', 'Papua New Guinea', 'WPRO', '4', '729', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65150, '2020-12-17', 'PG', 'Papua New Guinea', 'WPRO', '0', '729', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65151, '2020-12-18', 'PG', 'Papua New Guinea', 'WPRO', '31', '760', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65152, '2020-12-19', 'PG', 'Papua New Guinea', 'WPRO', '0', '760', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65153, '2020-12-20', 'PG', 'Papua New Guinea', 'WPRO', '0', '760', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65154, '2020-12-21', 'PG', 'Papua New Guinea', 'WPRO', '0', '760', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65155, '2020-12-22', 'PG', 'Papua New Guinea', 'WPRO', '1', '761', '1', '9');
INSERT INTO public.who_global_data_import VALUES (65156, '2020-12-23', 'PG', 'Papua New Guinea', 'WPRO', '0', '761', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65157, '2020-12-24', 'PG', 'Papua New Guinea', 'WPRO', '0', '761', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65158, '2020-12-25', 'PG', 'Papua New Guinea', 'WPRO', '19', '780', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65159, '2020-12-26', 'PG', 'Papua New Guinea', 'WPRO', '0', '780', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65160, '2020-12-27', 'PG', 'Papua New Guinea', 'WPRO', '0', '780', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65161, '2020-12-28', 'PG', 'Papua New Guinea', 'WPRO', '0', '780', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65162, '2020-12-29', 'PG', 'Papua New Guinea', 'WPRO', '0', '780', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65163, '2020-12-30', 'PG', 'Papua New Guinea', 'WPRO', '0', '780', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65164, '2020-12-31', 'PG', 'Papua New Guinea', 'WPRO', '0', '780', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65165, '2021-01-01', 'PG', 'Papua New Guinea', 'WPRO', '0', '780', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65166, '2021-01-02', 'PG', 'Papua New Guinea', 'WPRO', '0', '780', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65167, '2021-01-03', 'PG', 'Papua New Guinea', 'WPRO', '0', '780', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65168, '2021-01-04', 'PG', 'Papua New Guinea', 'WPRO', '19', '799', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65169, '2021-01-05', 'PG', 'Papua New Guinea', 'WPRO', '0', '799', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65170, '2021-01-06', 'PG', 'Papua New Guinea', 'WPRO', '0', '799', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65171, '2021-01-07', 'PG', 'Papua New Guinea', 'WPRO', '0', '799', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65172, '2021-01-08', 'PG', 'Papua New Guinea', 'WPRO', '0', '799', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65173, '2021-01-09', 'PG', 'Papua New Guinea', 'WPRO', '12', '811', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65174, '2021-01-10', 'PG', 'Papua New Guinea', 'WPRO', '0', '811', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65175, '2021-01-11', 'PG', 'Papua New Guinea', 'WPRO', '0', '811', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65176, '2021-01-12', 'PG', 'Papua New Guinea', 'WPRO', '8', '819', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65177, '2021-01-13', 'PG', 'Papua New Guinea', 'WPRO', '4', '823', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65178, '2021-01-14', 'PG', 'Papua New Guinea', 'WPRO', '10', '833', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65179, '2021-01-15', 'PG', 'Papua New Guinea', 'WPRO', '1', '834', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65180, '2021-01-16', 'PG', 'Papua New Guinea', 'WPRO', '0', '834', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65181, '2021-01-17', 'PG', 'Papua New Guinea', 'WPRO', '0', '834', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65182, '2021-01-18', 'PG', 'Papua New Guinea', 'WPRO', '0', '834', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65183, '2021-01-19', 'PG', 'Papua New Guinea', 'WPRO', '0', '834', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65184, '2021-01-20', 'PG', 'Papua New Guinea', 'WPRO', '9', '843', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65185, '2021-01-21', 'PG', 'Papua New Guinea', 'WPRO', '1', '844', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65186, '2021-01-22', 'PG', 'Papua New Guinea', 'WPRO', '5', '849', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65187, '2021-01-23', 'PG', 'Papua New Guinea', 'WPRO', '0', '849', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65188, '2021-01-24', 'PG', 'Papua New Guinea', 'WPRO', '0', '849', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65189, '2021-01-25', 'PG', 'Papua New Guinea', 'WPRO', '0', '849', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65190, '2021-01-26', 'PG', 'Papua New Guinea', 'WPRO', '0', '849', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65191, '2021-01-27', 'PG', 'Papua New Guinea', 'WPRO', '1', '850', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65192, '2021-01-28', 'PG', 'Papua New Guinea', 'WPRO', '1', '851', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65193, '2021-01-29', 'PG', 'Papua New Guinea', 'WPRO', '0', '851', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65194, '2021-01-30', 'PG', 'Papua New Guinea', 'WPRO', '0', '851', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65195, '2021-01-31', 'PG', 'Papua New Guinea', 'WPRO', '0', '851', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65196, '2021-02-01', 'PG', 'Papua New Guinea', 'WPRO', '16', '867', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65197, '2021-02-02', 'PG', 'Papua New Guinea', 'WPRO', '0', '867', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65198, '2021-02-03', 'PG', 'Papua New Guinea', 'WPRO', '0', '867', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65199, '2021-02-04', 'PG', 'Papua New Guinea', 'WPRO', '0', '867', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65200, '2021-02-05', 'PG', 'Papua New Guinea', 'WPRO', '24', '891', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65201, '2020-01-03', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65202, '2020-01-04', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65203, '2020-01-05', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65204, '2020-01-06', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65205, '2020-01-07', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65206, '2020-01-08', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65207, '2020-01-09', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65208, '2020-01-10', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65209, '2020-01-11', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65210, '2020-01-12', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65211, '2020-01-13', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65212, '2020-01-14', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65213, '2020-01-15', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65214, '2020-01-16', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65215, '2020-01-17', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65216, '2020-01-18', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65217, '2020-01-19', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65218, '2020-01-20', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65219, '2020-01-21', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65220, '2020-01-22', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65221, '2020-01-23', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65222, '2020-01-24', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65223, '2020-01-25', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65224, '2020-01-26', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65225, '2020-01-27', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65226, '2020-01-28', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65227, '2020-01-29', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65228, '2020-01-30', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65229, '2020-01-31', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65230, '2020-02-01', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65231, '2020-02-02', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65232, '2020-02-03', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65233, '2020-02-04', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65234, '2020-02-05', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65235, '2020-02-06', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65236, '2020-02-07', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65237, '2020-02-08', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65238, '2020-02-09', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65239, '2020-02-10', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65240, '2020-02-11', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65241, '2020-02-12', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65242, '2020-02-13', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65243, '2020-02-14', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65244, '2020-02-15', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65245, '2020-02-16', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65246, '2020-02-17', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65247, '2020-02-18', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65248, '2020-02-19', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65249, '2020-02-20', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65250, '2020-02-21', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65251, '2020-02-22', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65252, '2020-02-23', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65253, '2020-02-24', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65254, '2020-02-25', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65255, '2020-02-26', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65256, '2020-02-27', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65257, '2020-02-28', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65258, '2020-02-29', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65259, '2020-03-01', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65260, '2020-03-02', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65261, '2020-03-03', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65262, '2020-03-04', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65263, '2020-03-05', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65264, '2020-03-06', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65265, '2020-03-07', 'PY', 'Paraguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65266, '2020-03-08', 'PY', 'Paraguay', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65267, '2020-03-09', 'PY', 'Paraguay', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65268, '2020-03-10', 'PY', 'Paraguay', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65269, '2020-03-11', 'PY', 'Paraguay', 'AMRO', '4', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65270, '2020-03-12', 'PY', 'Paraguay', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65271, '2020-03-13', 'PY', 'Paraguay', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65272, '2020-03-14', 'PY', 'Paraguay', 'AMRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65273, '2020-03-15', 'PY', 'Paraguay', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65274, '2020-03-16', 'PY', 'Paraguay', 'AMRO', '2', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65275, '2020-03-17', 'PY', 'Paraguay', 'AMRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65276, '2020-03-18', 'PY', 'Paraguay', 'AMRO', '2', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65277, '2020-03-19', 'PY', 'Paraguay', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65278, '2020-03-20', 'PY', 'Paraguay', 'AMRO', '-2', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65279, '2020-03-21', 'PY', 'Paraguay', 'AMRO', '5', '18', '1', '1');
INSERT INTO public.who_global_data_import VALUES (65280, '2020-03-22', 'PY', 'Paraguay', 'AMRO', '0', '18', '0', '1');
INSERT INTO public.who_global_data_import VALUES (65281, '2020-03-23', 'PY', 'Paraguay', 'AMRO', '4', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (65282, '2020-03-24', 'PY', 'Paraguay', 'AMRO', '5', '27', '1', '2');
INSERT INTO public.who_global_data_import VALUES (65283, '2020-03-25', 'PY', 'Paraguay', 'AMRO', '0', '27', '0', '2');
INSERT INTO public.who_global_data_import VALUES (65284, '2020-03-26', 'PY', 'Paraguay', 'AMRO', '14', '41', '1', '3');
INSERT INTO public.who_global_data_import VALUES (65285, '2020-03-27', 'PY', 'Paraguay', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65286, '2020-03-28', 'PY', 'Paraguay', 'AMRO', '11', '52', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65287, '2020-03-29', 'PY', 'Paraguay', 'AMRO', '4', '56', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65288, '2020-03-30', 'PY', 'Paraguay', 'AMRO', '3', '59', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65289, '2020-03-31', 'PY', 'Paraguay', 'AMRO', '5', '64', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65290, '2020-04-01', 'PY', 'Paraguay', 'AMRO', '1', '65', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65291, '2020-04-02', 'PY', 'Paraguay', 'AMRO', '4', '69', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65292, '2020-04-03', 'PY', 'Paraguay', 'AMRO', '8', '77', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65293, '2020-04-04', 'PY', 'Paraguay', 'AMRO', '15', '92', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65294, '2020-04-05', 'PY', 'Paraguay', 'AMRO', '4', '96', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65295, '2020-04-06', 'PY', 'Paraguay', 'AMRO', '8', '104', '0', '3');
INSERT INTO public.who_global_data_import VALUES (65296, '2020-04-07', 'PY', 'Paraguay', 'AMRO', '9', '113', '2', '5');
INSERT INTO public.who_global_data_import VALUES (65297, '2020-04-08', 'PY', 'Paraguay', 'AMRO', '2', '115', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65298, '2020-04-09', 'PY', 'Paraguay', 'AMRO', '4', '119', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65299, '2020-04-10', 'PY', 'Paraguay', 'AMRO', '5', '124', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65300, '2020-04-11', 'PY', 'Paraguay', 'AMRO', '5', '129', '1', '6');
INSERT INTO public.who_global_data_import VALUES (65301, '2020-04-12', 'PY', 'Paraguay', 'AMRO', '4', '133', '0', '6');
INSERT INTO public.who_global_data_import VALUES (65302, '2020-04-13', 'PY', 'Paraguay', 'AMRO', '1', '134', '0', '6');
INSERT INTO public.who_global_data_import VALUES (65303, '2020-04-14', 'PY', 'Paraguay', 'AMRO', '13', '147', '0', '6');
INSERT INTO public.who_global_data_import VALUES (65304, '2020-04-15', 'PY', 'Paraguay', 'AMRO', '12', '159', '1', '7');
INSERT INTO public.who_global_data_import VALUES (65305, '2020-04-16', 'PY', 'Paraguay', 'AMRO', '2', '161', '1', '8');
INSERT INTO public.who_global_data_import VALUES (65306, '2020-04-17', 'PY', 'Paraguay', 'AMRO', '13', '174', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65307, '2020-04-18', 'PY', 'Paraguay', 'AMRO', '25', '199', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65308, '2020-04-19', 'PY', 'Paraguay', 'AMRO', '3', '202', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65309, '2020-04-20', 'PY', 'Paraguay', 'AMRO', '4', '206', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65310, '2020-04-21', 'PY', 'Paraguay', 'AMRO', '2', '208', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65311, '2020-04-22', 'PY', 'Paraguay', 'AMRO', '0', '208', '0', '8');
INSERT INTO public.who_global_data_import VALUES (65312, '2020-04-23', 'PY', 'Paraguay', 'AMRO', '5', '213', '1', '9');
INSERT INTO public.who_global_data_import VALUES (65313, '2020-04-24', 'PY', 'Paraguay', 'AMRO', '0', '213', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65314, '2020-04-25', 'PY', 'Paraguay', 'AMRO', '7', '220', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65315, '2020-04-26', 'PY', 'Paraguay', 'AMRO', '3', '223', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65316, '2020-04-27', 'PY', 'Paraguay', 'AMRO', '5', '228', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65317, '2020-04-28', 'PY', 'Paraguay', 'AMRO', '0', '228', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65318, '2020-04-29', 'PY', 'Paraguay', 'AMRO', '2', '230', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65319, '2020-04-30', 'PY', 'Paraguay', 'AMRO', '9', '239', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65320, '2020-05-01', 'PY', 'Paraguay', 'AMRO', '10', '249', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65321, '2020-05-02', 'PY', 'Paraguay', 'AMRO', '17', '266', '1', '10');
INSERT INTO public.who_global_data_import VALUES (65322, '2020-05-03', 'PY', 'Paraguay', 'AMRO', '67', '333', '0', '10');
INSERT INTO public.who_global_data_import VALUES (65323, '2020-05-04', 'PY', 'Paraguay', 'AMRO', '37', '370', '0', '10');
INSERT INTO public.who_global_data_import VALUES (65324, '2020-05-05', 'PY', 'Paraguay', 'AMRO', '26', '396', '0', '10');
INSERT INTO public.who_global_data_import VALUES (65325, '2020-05-06', 'PY', 'Paraguay', 'AMRO', '35', '431', '0', '10');
INSERT INTO public.who_global_data_import VALUES (65326, '2020-05-07', 'PY', 'Paraguay', 'AMRO', '9', '440', '0', '10');
INSERT INTO public.who_global_data_import VALUES (65327, '2020-05-08', 'PY', 'Paraguay', 'AMRO', '22', '462', '0', '10');
INSERT INTO public.who_global_data_import VALUES (65328, '2020-05-09', 'PY', 'Paraguay', 'AMRO', '101', '563', '0', '10');
INSERT INTO public.who_global_data_import VALUES (65329, '2020-05-10', 'PY', 'Paraguay', 'AMRO', '126', '689', '0', '10');
INSERT INTO public.who_global_data_import VALUES (65330, '2020-05-11', 'PY', 'Paraguay', 'AMRO', '24', '713', '0', '10');
INSERT INTO public.who_global_data_import VALUES (65331, '2020-05-12', 'PY', 'Paraguay', 'AMRO', '11', '724', '0', '10');
INSERT INTO public.who_global_data_import VALUES (65332, '2020-05-13', 'PY', 'Paraguay', 'AMRO', '13', '737', '0', '10');
INSERT INTO public.who_global_data_import VALUES (65333, '2020-05-14', 'PY', 'Paraguay', 'AMRO', '3', '740', '1', '11');
INSERT INTO public.who_global_data_import VALUES (65334, '2020-05-15', 'PY', 'Paraguay', 'AMRO', '14', '754', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65335, '2020-05-16', 'PY', 'Paraguay', 'AMRO', '5', '759', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65336, '2020-05-17', 'PY', 'Paraguay', 'AMRO', '19', '778', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65337, '2020-05-18', 'PY', 'Paraguay', 'AMRO', '8', '786', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65338, '2020-05-19', 'PY', 'Paraguay', 'AMRO', '2', '788', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65339, '2020-05-20', 'PY', 'Paraguay', 'AMRO', '41', '829', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65340, '2020-05-21', 'PY', 'Paraguay', 'AMRO', '4', '833', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65341, '2020-05-22', 'PY', 'Paraguay', 'AMRO', '3', '836', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65342, '2020-05-23', 'PY', 'Paraguay', 'AMRO', '2', '838', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65343, '2020-05-24', 'PY', 'Paraguay', 'AMRO', '12', '850', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65344, '2020-05-25', 'PY', 'Paraguay', 'AMRO', '12', '862', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65345, '2020-05-26', 'PY', 'Paraguay', 'AMRO', '3', '865', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65346, '2020-05-27', 'PY', 'Paraguay', 'AMRO', '12', '877', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65347, '2020-05-28', 'PY', 'Paraguay', 'AMRO', '7', '884', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65348, '2020-05-29', 'PY', 'Paraguay', 'AMRO', '16', '900', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65349, '2020-05-30', 'PY', 'Paraguay', 'AMRO', '17', '917', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65350, '2020-05-31', 'PY', 'Paraguay', 'AMRO', '47', '964', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65351, '2020-06-01', 'PY', 'Paraguay', 'AMRO', '22', '986', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65352, '2020-06-02', 'PY', 'Paraguay', 'AMRO', '9', '995', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65353, '2020-06-03', 'PY', 'Paraguay', 'AMRO', '18', '1013', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65354, '2020-06-04', 'PY', 'Paraguay', 'AMRO', '57', '1070', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65355, '2020-06-05', 'PY', 'Paraguay', 'AMRO', '16', '1086', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65356, '2020-06-06', 'PY', 'Paraguay', 'AMRO', '1', '1087', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65357, '2020-06-07', 'PY', 'Paraguay', 'AMRO', '3', '1090', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65358, '2020-06-08', 'PY', 'Paraguay', 'AMRO', '45', '1135', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65359, '2020-06-09', 'PY', 'Paraguay', 'AMRO', '10', '1145', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65360, '2020-06-10', 'PY', 'Paraguay', 'AMRO', '42', '1187', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65361, '2020-06-11', 'PY', 'Paraguay', 'AMRO', '15', '1202', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65362, '2020-06-12', 'PY', 'Paraguay', 'AMRO', '28', '1230', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65363, '2020-06-13', 'PY', 'Paraguay', 'AMRO', '24', '1254', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65364, '2020-06-14', 'PY', 'Paraguay', 'AMRO', '7', '1261', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65365, '2020-06-15', 'PY', 'Paraguay', 'AMRO', '28', '1289', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65366, '2020-06-16', 'PY', 'Paraguay', 'AMRO', '7', '1296', '1', '12');
INSERT INTO public.who_global_data_import VALUES (65367, '2020-06-17', 'PY', 'Paraguay', 'AMRO', '7', '1303', '0', '12');
INSERT INTO public.who_global_data_import VALUES (65368, '2020-06-18', 'PY', 'Paraguay', 'AMRO', '5', '1308', '1', '13');
INSERT INTO public.who_global_data_import VALUES (65369, '2020-06-19', 'PY', 'Paraguay', 'AMRO', '22', '1330', '0', '13');
INSERT INTO public.who_global_data_import VALUES (65370, '2020-06-20', 'PY', 'Paraguay', 'AMRO', '6', '1336', '0', '13');
INSERT INTO public.who_global_data_import VALUES (65371, '2020-06-21', 'PY', 'Paraguay', 'AMRO', '26', '1362', '0', '13');
INSERT INTO public.who_global_data_import VALUES (65372, '2020-06-22', 'PY', 'Paraguay', 'AMRO', '17', '1379', '0', '13');
INSERT INTO public.who_global_data_import VALUES (65373, '2020-06-23', 'PY', 'Paraguay', 'AMRO', '13', '1392', '0', '13');
INSERT INTO public.who_global_data_import VALUES (65374, '2020-06-24', 'PY', 'Paraguay', 'AMRO', '30', '1422', '0', '13');
INSERT INTO public.who_global_data_import VALUES (65375, '2020-06-25', 'PY', 'Paraguay', 'AMRO', '106', '1528', '0', '13');
INSERT INTO public.who_global_data_import VALUES (65376, '2020-06-26', 'PY', 'Paraguay', 'AMRO', '41', '1569', '0', '13');
INSERT INTO public.who_global_data_import VALUES (65377, '2020-06-27', 'PY', 'Paraguay', 'AMRO', '142', '1711', '0', '13');
INSERT INTO public.who_global_data_import VALUES (65378, '2020-06-28', 'PY', 'Paraguay', 'AMRO', '0', '1711', '0', '13');
INSERT INTO public.who_global_data_import VALUES (65379, '2020-06-29', 'PY', 'Paraguay', 'AMRO', '231', '1942', '2', '15');
INSERT INTO public.who_global_data_import VALUES (65380, '2020-06-30', 'PY', 'Paraguay', 'AMRO', '185', '2127', '0', '15');
INSERT INTO public.who_global_data_import VALUES (65381, '2020-07-01', 'PY', 'Paraguay', 'AMRO', '94', '2221', '2', '17');
INSERT INTO public.who_global_data_import VALUES (65382, '2020-07-02', 'PY', 'Paraguay', 'AMRO', '39', '2260', '2', '19');
INSERT INTO public.who_global_data_import VALUES (65383, '2020-07-03', 'PY', 'Paraguay', 'AMRO', '43', '2303', '0', '19');
INSERT INTO public.who_global_data_import VALUES (65384, '2020-07-04', 'PY', 'Paraguay', 'AMRO', '46', '2349', '0', '19');
INSERT INTO public.who_global_data_import VALUES (65385, '2020-07-05', 'PY', 'Paraguay', 'AMRO', '36', '2385', '1', '20');
INSERT INTO public.who_global_data_import VALUES (65386, '2020-07-06', 'PY', 'Paraguay', 'AMRO', '42', '2427', '0', '20');
INSERT INTO public.who_global_data_import VALUES (65387, '2020-07-07', 'PY', 'Paraguay', 'AMRO', '29', '2456', '0', '20');
INSERT INTO public.who_global_data_import VALUES (65388, '2020-07-08', 'PY', 'Paraguay', 'AMRO', '46', '2502', '0', '20');
INSERT INTO public.who_global_data_import VALUES (65389, '2020-07-09', 'PY', 'Paraguay', 'AMRO', '52', '2554', '0', '20');
INSERT INTO public.who_global_data_import VALUES (65390, '2020-07-10', 'PY', 'Paraguay', 'AMRO', '84', '2638', '0', '20');
INSERT INTO public.who_global_data_import VALUES (65391, '2020-07-11', 'PY', 'Paraguay', 'AMRO', '98', '2736', '0', '20');
INSERT INTO public.who_global_data_import VALUES (65392, '2020-07-12', 'PY', 'Paraguay', 'AMRO', '0', '2736', '0', '20');
INSERT INTO public.who_global_data_import VALUES (65393, '2020-07-13', 'PY', 'Paraguay', 'AMRO', '84', '2820', '1', '21');
INSERT INTO public.who_global_data_import VALUES (65394, '2020-07-14', 'PY', 'Paraguay', 'AMRO', '160', '2980', '4', '25');
INSERT INTO public.who_global_data_import VALUES (65395, '2020-07-15', 'PY', 'Paraguay', 'AMRO', '0', '2980', '0', '25');
INSERT INTO public.who_global_data_import VALUES (65396, '2020-07-16', 'PY', 'Paraguay', 'AMRO', '94', '3074', '0', '25');
INSERT INTO public.who_global_data_import VALUES (65397, '2020-07-17', 'PY', 'Paraguay', 'AMRO', '124', '3198', '0', '25');
INSERT INTO public.who_global_data_import VALUES (65398, '2020-07-18', 'PY', 'Paraguay', 'AMRO', '144', '3342', '2', '27');
INSERT INTO public.who_global_data_import VALUES (65399, '2020-07-19', 'PY', 'Paraguay', 'AMRO', '115', '3457', '1', '28');
INSERT INTO public.who_global_data_import VALUES (65400, '2020-07-20', 'PY', 'Paraguay', 'AMRO', '172', '3629', '1', '29');
INSERT INTO public.who_global_data_import VALUES (65401, '2020-07-21', 'PY', 'Paraguay', 'AMRO', '92', '3721', '2', '31');
INSERT INTO public.who_global_data_import VALUES (65402, '2020-07-22', 'PY', 'Paraguay', 'AMRO', '27', '3748', '2', '33');
INSERT INTO public.who_global_data_import VALUES (65403, '2020-07-23', 'PY', 'Paraguay', 'AMRO', '69', '3817', '2', '35');
INSERT INTO public.who_global_data_import VALUES (65404, '2020-07-24', 'PY', 'Paraguay', 'AMRO', '183', '4000', '1', '36');
INSERT INTO public.who_global_data_import VALUES (65405, '2020-07-25', 'PY', 'Paraguay', 'AMRO', '113', '4113', '0', '36');
INSERT INTO public.who_global_data_import VALUES (65406, '2020-07-26', 'PY', 'Paraguay', 'AMRO', '111', '4224', '2', '38');
INSERT INTO public.who_global_data_import VALUES (65407, '2020-07-27', 'PY', 'Paraguay', 'AMRO', '104', '4328', '2', '40');
INSERT INTO public.who_global_data_import VALUES (65408, '2020-07-28', 'PY', 'Paraguay', 'AMRO', '116', '4444', '1', '41');
INSERT INTO public.who_global_data_import VALUES (65409, '2020-07-29', 'PY', 'Paraguay', 'AMRO', '104', '4548', '2', '43');
INSERT INTO public.who_global_data_import VALUES (65410, '2020-07-30', 'PY', 'Paraguay', 'AMRO', '126', '4674', '2', '45');
INSERT INTO public.who_global_data_import VALUES (65411, '2020-07-31', 'PY', 'Paraguay', 'AMRO', '192', '4866', '1', '46');
INSERT INTO public.who_global_data_import VALUES (65412, '2020-08-01', 'PY', 'Paraguay', 'AMRO', '341', '5207', '1', '47');
INSERT INTO public.who_global_data_import VALUES (65413, '2020-08-02', 'PY', 'Paraguay', 'AMRO', '131', '5338', '2', '49');
INSERT INTO public.who_global_data_import VALUES (65414, '2020-08-03', 'PY', 'Paraguay', 'AMRO', '147', '5485', '3', '52');
INSERT INTO public.who_global_data_import VALUES (65415, '2020-08-04', 'PY', 'Paraguay', 'AMRO', '159', '5644', '0', '52');
INSERT INTO public.who_global_data_import VALUES (65416, '2020-08-05', 'PY', 'Paraguay', 'AMRO', '80', '5724', '3', '55');
INSERT INTO public.who_global_data_import VALUES (65417, '2020-08-06', 'PY', 'Paraguay', 'AMRO', '128', '5852', '4', '59');
INSERT INTO public.who_global_data_import VALUES (65418, '2020-08-07', 'PY', 'Paraguay', 'AMRO', '208', '6060', '2', '61');
INSERT INTO public.who_global_data_import VALUES (65419, '2020-08-08', 'PY', 'Paraguay', 'AMRO', '315', '6375', '5', '66');
INSERT INTO public.who_global_data_import VALUES (65420, '2020-08-09', 'PY', 'Paraguay', 'AMRO', '133', '6508', '3', '69');
INSERT INTO public.who_global_data_import VALUES (65421, '2020-08-10', 'PY', 'Paraguay', 'AMRO', '197', '6705', '3', '72');
INSERT INTO public.who_global_data_import VALUES (65422, '2020-08-11', 'PY', 'Paraguay', 'AMRO', '202', '6907', '3', '75');
INSERT INTO public.who_global_data_import VALUES (65423, '2020-08-12', 'PY', 'Paraguay', 'AMRO', '327', '7234', '7', '82');
INSERT INTO public.who_global_data_import VALUES (65424, '2020-08-13', 'PY', 'Paraguay', 'AMRO', '285', '7519', '4', '86');
INSERT INTO public.who_global_data_import VALUES (65425, '2020-08-14', 'PY', 'Paraguay', 'AMRO', '499', '8018', '7', '93');
INSERT INTO public.who_global_data_import VALUES (65426, '2020-08-15', 'PY', 'Paraguay', 'AMRO', '371', '8389', '4', '97');
INSERT INTO public.who_global_data_import VALUES (65427, '2020-08-16', 'PY', 'Paraguay', 'AMRO', '633', '9022', '11', '108');
INSERT INTO public.who_global_data_import VALUES (65428, '2020-08-17', 'PY', 'Paraguay', 'AMRO', '359', '9381', '19', '127');
INSERT INTO public.who_global_data_import VALUES (65429, '2020-08-18', 'PY', 'Paraguay', 'AMRO', '410', '9791', '11', '138');
INSERT INTO public.who_global_data_import VALUES (65430, '2020-08-19', 'PY', 'Paraguay', 'AMRO', '344', '10135', '7', '145');
INSERT INTO public.who_global_data_import VALUES (65431, '2020-08-20', 'PY', 'Paraguay', 'AMRO', '471', '10606', '16', '161');
INSERT INTO public.who_global_data_import VALUES (65432, '2020-08-21', 'PY', 'Paraguay', 'AMRO', '527', '11133', '4', '165');
INSERT INTO public.who_global_data_import VALUES (65433, '2020-08-22', 'PY', 'Paraguay', 'AMRO', '684', '11817', '5', '170');
INSERT INTO public.who_global_data_import VALUES (65434, '2020-08-23', 'PY', 'Paraguay', 'AMRO', '719', '12536', '12', '182');
INSERT INTO public.who_global_data_import VALUES (65435, '2020-08-24', 'PY', 'Paraguay', 'AMRO', '438', '12974', '10', '192');
INSERT INTO public.who_global_data_import VALUES (65436, '2020-08-25', 'PY', 'Paraguay', 'AMRO', '259', '13233', '13', '205');
INSERT INTO public.who_global_data_import VALUES (65437, '2020-08-26', 'PY', 'Paraguay', 'AMRO', '369', '13602', '14', '219');
INSERT INTO public.who_global_data_import VALUES (65438, '2020-08-27', 'PY', 'Paraguay', 'AMRO', '626', '14228', '12', '231');
INSERT INTO public.who_global_data_import VALUES (65439, '2020-08-28', 'PY', 'Paraguay', 'AMRO', '644', '14872', '16', '247');
INSERT INTO public.who_global_data_import VALUES (65440, '2020-08-29', 'PY', 'Paraguay', 'AMRO', '418', '15290', '18', '265');
INSERT INTO public.who_global_data_import VALUES (65441, '2020-08-30', 'PY', 'Paraguay', 'AMRO', '584', '15874', '15', '280');
INSERT INTO public.who_global_data_import VALUES (65442, '2020-08-31', 'PY', 'Paraguay', 'AMRO', '600', '16474', '14', '294');
INSERT INTO public.who_global_data_import VALUES (65443, '2020-09-01', 'PY', 'Paraguay', 'AMRO', '631', '17105', '14', '308');
INSERT INTO public.who_global_data_import VALUES (65444, '2020-09-02', 'PY', 'Paraguay', 'AMRO', '557', '17662', '18', '326');
INSERT INTO public.who_global_data_import VALUES (65445, '2020-09-03', 'PY', 'Paraguay', 'AMRO', '676', '18338', '22', '348');
INSERT INTO public.who_global_data_import VALUES (65446, '2020-09-04', 'PY', 'Paraguay', 'AMRO', '800', '19138', '10', '358');
INSERT INTO public.who_global_data_import VALUES (65447, '2020-09-05', 'PY', 'Paraguay', 'AMRO', '821', '19959', '15', '373');
INSERT INTO public.who_global_data_import VALUES (65448, '2020-09-06', 'PY', 'Paraguay', 'AMRO', '695', '20654', '25', '398');
INSERT INTO public.who_global_data_import VALUES (65449, '2020-09-07', 'PY', 'Paraguay', 'AMRO', '1217', '21871', '14', '412');
INSERT INTO public.who_global_data_import VALUES (65450, '2020-09-08', 'PY', 'Paraguay', 'AMRO', '615', '22486', '23', '435');
INSERT INTO public.who_global_data_import VALUES (65451, '2020-09-09', 'PY', 'Paraguay', 'AMRO', '867', '23353', '14', '449');
INSERT INTO public.who_global_data_import VALUES (65452, '2020-09-10', 'PY', 'Paraguay', 'AMRO', '861', '24214', '14', '463');
INSERT INTO public.who_global_data_import VALUES (65453, '2020-09-11', 'PY', 'Paraguay', 'AMRO', '812', '25026', '11', '474');
INSERT INTO public.who_global_data_import VALUES (65454, '2020-09-12', 'PY', 'Paraguay', 'AMRO', '605', '25631', '11', '485');
INSERT INTO public.who_global_data_import VALUES (65455, '2020-09-13', 'PY', 'Paraguay', 'AMRO', '881', '26512', '11', '496');
INSERT INTO public.who_global_data_import VALUES (65456, '2020-09-14', 'PY', 'Paraguay', 'AMRO', '812', '27324', '18', '514');
INSERT INTO public.who_global_data_import VALUES (65457, '2020-09-15', 'PY', 'Paraguay', 'AMRO', '493', '27817', '11', '525');
INSERT INTO public.who_global_data_import VALUES (65458, '2020-09-16', 'PY', 'Paraguay', 'AMRO', '670', '28487', '14', '539');
INSERT INTO public.who_global_data_import VALUES (65459, '2020-09-17', 'PY', 'Paraguay', 'AMRO', '811', '29298', '13', '552');
INSERT INTO public.who_global_data_import VALUES (65460, '2020-09-18', 'PY', 'Paraguay', 'AMRO', '1121', '30419', '14', '566');
INSERT INTO public.who_global_data_import VALUES (65461, '2020-09-19', 'PY', 'Paraguay', 'AMRO', '694', '31113', '18', '584');
INSERT INTO public.who_global_data_import VALUES (65462, '2020-09-20', 'PY', 'Paraguay', 'AMRO', '1014', '32127', '27', '611');
INSERT INTO public.who_global_data_import VALUES (65463, '2020-09-21', 'PY', 'Paraguay', 'AMRO', '888', '33015', '25', '636');
INSERT INTO public.who_global_data_import VALUES (65464, '2020-09-22', 'PY', 'Paraguay', 'AMRO', '505', '33520', '23', '659');
INSERT INTO public.who_global_data_import VALUES (65465, '2020-09-23', 'PY', 'Paraguay', 'AMRO', '740', '34260', '17', '676');
INSERT INTO public.who_global_data_import VALUES (65466, '2020-09-24', 'PY', 'Paraguay', 'AMRO', '568', '34828', '29', '705');
INSERT INTO public.who_global_data_import VALUES (65467, '2020-09-25', 'PY', 'Paraguay', 'AMRO', '743', '35571', '22', '727');
INSERT INTO public.who_global_data_import VALUES (65468, '2020-09-26', 'PY', 'Paraguay', 'AMRO', '833', '36404', '16', '743');
INSERT INTO public.who_global_data_import VALUES (65469, '2020-09-27', 'PY', 'Paraguay', 'AMRO', '822', '37226', '18', '761');
INSERT INTO public.who_global_data_import VALUES (65470, '2020-09-28', 'PY', 'Paraguay', 'AMRO', '696', '37922', '21', '782');
INSERT INTO public.who_global_data_import VALUES (65471, '2020-09-29', 'PY', 'Paraguay', 'AMRO', '762', '38684', '21', '803');
INSERT INTO public.who_global_data_import VALUES (65472, '2020-09-30', 'PY', 'Paraguay', 'AMRO', '748', '39432', '15', '818');
INSERT INTO public.who_global_data_import VALUES (65473, '2020-10-01', 'PY', 'Paraguay', 'AMRO', '669', '40101', '23', '841');
INSERT INTO public.who_global_data_import VALUES (65474, '2020-10-02', 'PY', 'Paraguay', 'AMRO', '657', '40758', '16', '857');
INSERT INTO public.who_global_data_import VALUES (65475, '2020-10-03', 'PY', 'Paraguay', 'AMRO', '1041', '41799', '12', '869');
INSERT INTO public.who_global_data_import VALUES (65476, '2020-10-04', 'PY', 'Paraguay', 'AMRO', '885', '42684', '21', '890');
INSERT INTO public.who_global_data_import VALUES (65477, '2020-10-05', 'PY', 'Paraguay', 'AMRO', '768', '43452', '23', '913');
INSERT INTO public.who_global_data_import VALUES (65478, '2020-10-06', 'PY', 'Paraguay', 'AMRO', '730', '44182', '16', '929');
INSERT INTO public.who_global_data_import VALUES (65479, '2020-10-07', 'PY', 'Paraguay', 'AMRO', '533', '44715', '18', '947');
INSERT INTO public.who_global_data_import VALUES (65480, '2020-10-08', 'PY', 'Paraguay', 'AMRO', '932', '45647', '19', '966');
INSERT INTO public.who_global_data_import VALUES (65481, '2020-10-09', 'PY', 'Paraguay', 'AMRO', '788', '46435', '23', '989');
INSERT INTO public.who_global_data_import VALUES (65482, '2020-10-10', 'PY', 'Paraguay', 'AMRO', '881', '47316', '23', '1012');
INSERT INTO public.who_global_data_import VALUES (65483, '2020-10-11', 'PY', 'Paraguay', 'AMRO', '959', '48275', '33', '1045');
INSERT INTO public.who_global_data_import VALUES (65484, '2020-10-12', 'PY', 'Paraguay', 'AMRO', '703', '48978', '20', '1065');
INSERT INTO public.who_global_data_import VALUES (65485, '2020-10-13', 'PY', 'Paraguay', 'AMRO', '697', '49675', '12', '1077');
INSERT INTO public.who_global_data_import VALUES (65486, '2020-10-14', 'PY', 'Paraguay', 'AMRO', '669', '50344', '19', '1096');
INSERT INTO public.who_global_data_import VALUES (65487, '2020-10-15', 'PY', 'Paraguay', 'AMRO', '853', '51197', '12', '1108');
INSERT INTO public.who_global_data_import VALUES (65488, '2020-10-16', 'PY', 'Paraguay', 'AMRO', '648', '51845', '23', '1131');
INSERT INTO public.who_global_data_import VALUES (65489, '2020-10-17', 'PY', 'Paraguay', 'AMRO', '751', '52596', '19', '1150');
INSERT INTO public.who_global_data_import VALUES (65490, '2020-10-18', 'PY', 'Paraguay', 'AMRO', '886', '53482', '16', '1166');
INSERT INTO public.who_global_data_import VALUES (65491, '2020-10-19', 'PY', 'Paraguay', 'AMRO', '533', '54015', '13', '1179');
INSERT INTO public.who_global_data_import VALUES (65492, '2020-10-20', 'PY', 'Paraguay', 'AMRO', '709', '54724', '9', '1188');
INSERT INTO public.who_global_data_import VALUES (65493, '2020-10-21', 'PY', 'Paraguay', 'AMRO', '728', '55452', '19', '1207');
INSERT INTO public.who_global_data_import VALUES (65494, '2020-10-22', 'PY', 'Paraguay', 'AMRO', '621', '56073', '24', '1231');
INSERT INTO public.who_global_data_import VALUES (65495, '2020-10-23', 'PY', 'Paraguay', 'AMRO', '746', '56819', '19', '1250');
INSERT INTO public.who_global_data_import VALUES (65496, '2020-10-24', 'PY', 'Paraguay', 'AMRO', '707', '57526', '17', '1267');
INSERT INTO public.who_global_data_import VALUES (65497, '2020-10-25', 'PY', 'Paraguay', 'AMRO', '733', '58259', '11', '1278');
INSERT INTO public.who_global_data_import VALUES (65498, '2020-10-26', 'PY', 'Paraguay', 'AMRO', '784', '59043', '15', '1293');
INSERT INTO public.who_global_data_import VALUES (65499, '2020-10-27', 'PY', 'Paraguay', 'AMRO', '551', '59594', '16', '1309');
INSERT INTO public.who_global_data_import VALUES (65500, '2020-10-28', 'PY', 'Paraguay', 'AMRO', '515', '60109', '24', '1333');
INSERT INTO public.who_global_data_import VALUES (65501, '2020-10-29', 'PY', 'Paraguay', 'AMRO', '448', '60557', '14', '1347');
INSERT INTO public.who_global_data_import VALUES (65502, '2020-10-30', 'PY', 'Paraguay', 'AMRO', '733', '61290', '12', '1359');
INSERT INTO public.who_global_data_import VALUES (65503, '2020-10-31', 'PY', 'Paraguay', 'AMRO', '760', '62050', '14', '1373');
INSERT INTO public.who_global_data_import VALUES (65504, '2020-11-01', 'PY', 'Paraguay', 'AMRO', '546', '62596', '14', '1387');
INSERT INTO public.who_global_data_import VALUES (65505, '2020-11-02', 'PY', 'Paraguay', 'AMRO', '589', '63185', '17', '1404');
INSERT INTO public.who_global_data_import VALUES (65506, '2020-11-03', 'PY', 'Paraguay', 'AMRO', '546', '63731', '14', '1418');
INSERT INTO public.who_global_data_import VALUES (65507, '2020-11-04', 'PY', 'Paraguay', 'AMRO', '425', '64156', '11', '1429');
INSERT INTO public.who_global_data_import VALUES (65508, '2020-11-05', 'PY', 'Paraguay', 'AMRO', '472', '64628', '12', '1441');
INSERT INTO public.who_global_data_import VALUES (65509, '2020-11-06', 'PY', 'Paraguay', 'AMRO', '630', '65258', '13', '1454');
INSERT INTO public.who_global_data_import VALUES (65510, '2020-11-07', 'PY', 'Paraguay', 'AMRO', '520', '65778', '8', '1462');
INSERT INTO public.who_global_data_import VALUES (65511, '2020-11-08', 'PY', 'Paraguay', 'AMRO', '703', '66481', '10', '1472');
INSERT INTO public.who_global_data_import VALUES (65512, '2020-11-09', 'PY', 'Paraguay', 'AMRO', '460', '66941', '7', '1479');
INSERT INTO public.who_global_data_import VALUES (65513, '2020-11-10', 'PY', 'Paraguay', 'AMRO', '648', '67589', '11', '1490');
INSERT INTO public.who_global_data_import VALUES (65514, '2020-11-11', 'PY', 'Paraguay', 'AMRO', '359', '67948', '12', '1502');
INSERT INTO public.who_global_data_import VALUES (65515, '2020-11-12', 'PY', 'Paraguay', 'AMRO', '549', '68497', '14', '1516');
INSERT INTO public.who_global_data_import VALUES (65516, '2020-11-13', 'PY', 'Paraguay', 'AMRO', '609', '69106', '16', '1532');
INSERT INTO public.who_global_data_import VALUES (65517, '2020-11-14', 'PY', 'Paraguay', 'AMRO', '547', '69653', '11', '1543');
INSERT INTO public.who_global_data_import VALUES (65518, '2020-11-15', 'PY', 'Paraguay', 'AMRO', '739', '70392', '13', '1556');
INSERT INTO public.who_global_data_import VALUES (65519, '2020-11-16', 'PY', 'Paraguay', 'AMRO', '673', '71065', '13', '1569');
INSERT INTO public.who_global_data_import VALUES (65520, '2020-11-17', 'PY', 'Paraguay', 'AMRO', '509', '71574', '18', '1587');
INSERT INTO public.who_global_data_import VALUES (65521, '2020-11-18', 'PY', 'Paraguay', 'AMRO', '525', '72099', '15', '1602');
INSERT INTO public.who_global_data_import VALUES (65522, '2020-11-19', 'PY', 'Paraguay', 'AMRO', '758', '72857', '11', '1613');
INSERT INTO public.who_global_data_import VALUES (65523, '2020-11-20', 'PY', 'Paraguay', 'AMRO', '782', '73639', '11', '1624');
INSERT INTO public.who_global_data_import VALUES (65524, '2020-11-21', 'PY', 'Paraguay', 'AMRO', '856', '74495', '12', '1636');
INSERT INTO public.who_global_data_import VALUES (65525, '2020-11-22', 'PY', 'Paraguay', 'AMRO', '563', '75058', '11', '1647');
INSERT INTO public.who_global_data_import VALUES (65526, '2020-11-23', 'PY', 'Paraguay', 'AMRO', '799', '75857', '5', '1652');
INSERT INTO public.who_global_data_import VALUES (65527, '2020-11-24', 'PY', 'Paraguay', 'AMRO', '619', '76476', '5', '1657');
INSERT INTO public.who_global_data_import VALUES (65528, '2020-11-25', 'PY', 'Paraguay', 'AMRO', '596', '77072', '8', '1665');
INSERT INTO public.who_global_data_import VALUES (65529, '2020-11-26', 'PY', 'Paraguay', 'AMRO', '819', '77891', '12', '1677');
INSERT INTO public.who_global_data_import VALUES (65530, '2020-11-27', 'PY', 'Paraguay', 'AMRO', '987', '78878', '14', '1691');
INSERT INTO public.who_global_data_import VALUES (65531, '2020-11-28', 'PY', 'Paraguay', 'AMRO', '639', '79517', '13', '1704');
INSERT INTO public.who_global_data_import VALUES (65532, '2020-11-29', 'PY', 'Paraguay', 'AMRO', '919', '80436', '16', '1720');
INSERT INTO public.who_global_data_import VALUES (65533, '2020-11-30', 'PY', 'Paraguay', 'AMRO', '695', '81131', '11', '1731');
INSERT INTO public.who_global_data_import VALUES (65534, '2020-12-01', 'PY', 'Paraguay', 'AMRO', '775', '81906', '12', '1743');
INSERT INTO public.who_global_data_import VALUES (65535, '2020-12-02', 'PY', 'Paraguay', 'AMRO', '518', '82424', '13', '1756');
INSERT INTO public.who_global_data_import VALUES (65536, '2020-12-03', 'PY', 'Paraguay', 'AMRO', '1055', '83479', '15', '1771');
INSERT INTO public.who_global_data_import VALUES (65537, '2020-12-04', 'PY', 'Paraguay', 'AMRO', '1003', '84482', '12', '1783');
INSERT INTO public.who_global_data_import VALUES (65538, '2020-12-05', 'PY', 'Paraguay', 'AMRO', '995', '85477', '13', '1796');
INSERT INTO public.who_global_data_import VALUES (65539, '2020-12-06', 'PY', 'Paraguay', 'AMRO', '1022', '86499', '17', '1813');
INSERT INTO public.who_global_data_import VALUES (65540, '2020-12-07', 'PY', 'Paraguay', 'AMRO', '714', '87213', '20', '1833');
INSERT INTO public.who_global_data_import VALUES (65541, '2020-12-08', 'PY', 'Paraguay', 'AMRO', '707', '87920', '20', '1853');
INSERT INTO public.who_global_data_import VALUES (65542, '2020-12-09', 'PY', 'Paraguay', 'AMRO', '803', '88723', '19', '1872');
INSERT INTO public.who_global_data_import VALUES (65543, '2020-12-10', 'PY', 'Paraguay', 'AMRO', '698', '89421', '15', '1887');
INSERT INTO public.who_global_data_import VALUES (65544, '2020-12-11', 'PY', 'Paraguay', 'AMRO', '725', '90146', '14', '1901');
INSERT INTO public.who_global_data_import VALUES (65545, '2020-12-12', 'PY', 'Paraguay', 'AMRO', '812', '90958', '13', '1914');
INSERT INTO public.who_global_data_import VALUES (65546, '2020-12-13', 'PY', 'Paraguay', 'AMRO', '1155', '92113', '13', '1927');
INSERT INTO public.who_global_data_import VALUES (65547, '2020-12-14', 'PY', 'Paraguay', 'AMRO', '800', '92913', '10', '1937');
INSERT INTO public.who_global_data_import VALUES (65548, '2020-12-15', 'PY', 'Paraguay', 'AMRO', '669', '93582', '16', '1953');
INSERT INTO public.who_global_data_import VALUES (65549, '2020-12-16', 'PY', 'Paraguay', 'AMRO', '641', '94223', '18', '1971');
INSERT INTO public.who_global_data_import VALUES (65550, '2020-12-17', 'PY', 'Paraguay', 'AMRO', '1130', '95353', '20', '1991');
INSERT INTO public.who_global_data_import VALUES (65551, '2020-12-18', 'PY', 'Paraguay', 'AMRO', '856', '96209', '23', '2014');
INSERT INTO public.who_global_data_import VALUES (65552, '2020-12-19', 'PY', 'Paraguay', 'AMRO', '819', '97028', '18', '2032');
INSERT INTO public.who_global_data_import VALUES (65553, '2020-12-20', 'PY', 'Paraguay', 'AMRO', '1268', '98296', '18', '2050');
INSERT INTO public.who_global_data_import VALUES (65554, '2020-12-21', 'PY', 'Paraguay', 'AMRO', '861', '99157', '22', '2072');
INSERT INTO public.who_global_data_import VALUES (65555, '2020-12-22', 'PY', 'Paraguay', 'AMRO', '632', '99789', '16', '2088');
INSERT INTO public.who_global_data_import VALUES (65556, '2020-12-23', 'PY', 'Paraguay', 'AMRO', '823', '100612', '15', '2103');
INSERT INTO public.who_global_data_import VALUES (65557, '2020-12-24', 'PY', 'Paraguay', 'AMRO', '932', '101544', '17', '2120');
INSERT INTO public.who_global_data_import VALUES (65558, '2020-12-25', 'PY', 'Paraguay', 'AMRO', '827', '102371', '18', '2138');
INSERT INTO public.who_global_data_import VALUES (65559, '2020-12-26', 'PY', 'Paraguay', 'AMRO', '958', '103329', '16', '2154');
INSERT INTO public.who_global_data_import VALUES (65560, '2020-12-27', 'PY', 'Paraguay', 'AMRO', '559', '103888', '0', '2154');
INSERT INTO public.who_global_data_import VALUES (65561, '2020-12-28', 'PY', 'Paraguay', 'AMRO', '274', '104162', '20', '2174');
INSERT INTO public.who_global_data_import VALUES (65562, '2020-12-29', 'PY', 'Paraguay', 'AMRO', '260', '104422', '14', '2188');
INSERT INTO public.who_global_data_import VALUES (65563, '2020-12-30', 'PY', 'Paraguay', 'AMRO', '952', '105374', '14', '2202');
INSERT INTO public.who_global_data_import VALUES (65564, '2020-12-31', 'PY', 'Paraguay', 'AMRO', '762', '106136', '18', '2220');
INSERT INTO public.who_global_data_import VALUES (65565, '2021-01-01', 'PY', 'Paraguay', 'AMRO', '822', '106958', '22', '2242');
INSERT INTO public.who_global_data_import VALUES (65566, '2021-01-02', 'PY', 'Paraguay', 'AMRO', '974', '107932', '20', '2262');
INSERT INTO public.who_global_data_import VALUES (65567, '2021-01-03', 'PY', 'Paraguay', 'AMRO', '417', '108349', '0', '2262');
INSERT INTO public.who_global_data_import VALUES (65568, '2021-01-04', 'PY', 'Paraguay', 'AMRO', '369', '108718', '17', '2279');
INSERT INTO public.who_global_data_import VALUES (65569, '2021-01-05', 'PY', 'Paraguay', 'AMRO', '355', '109073', '13', '2292');
INSERT INTO public.who_global_data_import VALUES (65570, '2021-01-06', 'PY', 'Paraguay', 'AMRO', '764', '109837', '13', '2305');
INSERT INTO public.who_global_data_import VALUES (65571, '2021-01-07', 'PY', 'Paraguay', 'AMRO', '959', '110796', '16', '2321');
INSERT INTO public.who_global_data_import VALUES (65572, '2021-01-08', 'PY', 'Paraguay', 'AMRO', '898', '111694', '16', '2337');
INSERT INTO public.who_global_data_import VALUES (65573, '2021-01-09', 'PY', 'Paraguay', 'AMRO', '1162', '112856', '15', '2352');
INSERT INTO public.who_global_data_import VALUES (65574, '2021-01-10', 'PY', 'Paraguay', 'AMRO', '1138', '113994', '20', '2372');
INSERT INTO public.who_global_data_import VALUES (65575, '2021-01-11', 'PY', 'Paraguay', 'AMRO', '1032', '115026', '15', '2387');
INSERT INTO public.who_global_data_import VALUES (65576, '2021-01-12', 'PY', 'Paraguay', 'AMRO', '707', '115733', '18', '2405');
INSERT INTO public.who_global_data_import VALUES (65577, '2021-01-13', 'PY', 'Paraguay', 'AMRO', '802', '116535', '15', '2420');
INSERT INTO public.who_global_data_import VALUES (65578, '2021-01-14', 'PY', 'Paraguay', 'AMRO', '1055', '117590', '17', '2437');
INSERT INTO public.who_global_data_import VALUES (65579, '2021-01-15', 'PY', 'Paraguay', 'AMRO', '1002', '118592', '15', '2452');
INSERT INTO public.who_global_data_import VALUES (65580, '2021-01-16', 'PY', 'Paraguay', 'AMRO', '1048', '119640', '15', '2467');
INSERT INTO public.who_global_data_import VALUES (65581, '2021-01-17', 'PY', 'Paraguay', 'AMRO', '1149', '120789', '12', '2479');
INSERT INTO public.who_global_data_import VALUES (65582, '2021-01-18', 'PY', 'Paraguay', 'AMRO', '859', '121648', '16', '2495');
INSERT INTO public.who_global_data_import VALUES (65583, '2021-01-19', 'PY', 'Paraguay', 'AMRO', '512', '122160', '10', '2505');
INSERT INTO public.who_global_data_import VALUES (65584, '2021-01-20', 'PY', 'Paraguay', 'AMRO', '428', '122588', '13', '2518');
INSERT INTO public.who_global_data_import VALUES (65585, '2021-01-21', 'PY', 'Paraguay', 'AMRO', '771', '123359', '17', '2535');
INSERT INTO public.who_global_data_import VALUES (65586, '2021-01-22', 'PY', 'Paraguay', 'AMRO', '1088', '124447', '22', '2557');
INSERT INTO public.who_global_data_import VALUES (65587, '2021-01-23', 'PY', 'Paraguay', 'AMRO', '1071', '125518', '13', '2570');
INSERT INTO public.who_global_data_import VALUES (65588, '2021-01-24', 'PY', 'Paraguay', 'AMRO', '852', '126370', '15', '2585');
INSERT INTO public.who_global_data_import VALUES (65589, '2021-01-25', 'PY', 'Paraguay', 'AMRO', '711', '127081', '22', '2607');
INSERT INTO public.who_global_data_import VALUES (65590, '2021-01-26', 'PY', 'Paraguay', 'AMRO', '571', '127652', '10', '2617');
INSERT INTO public.who_global_data_import VALUES (65591, '2021-01-27', 'PY', 'Paraguay', 'AMRO', '714', '128366', '15', '2632');
INSERT INTO public.who_global_data_import VALUES (65592, '2021-01-28', 'PY', 'Paraguay', 'AMRO', '1028', '129394', '19', '2651');
INSERT INTO public.who_global_data_import VALUES (65593, '2021-01-29', 'PY', 'Paraguay', 'AMRO', '769', '130163', '17', '2668');
INSERT INTO public.who_global_data_import VALUES (65594, '2021-01-30', 'PY', 'Paraguay', 'AMRO', '754', '130917', '13', '2681');
INSERT INTO public.who_global_data_import VALUES (65595, '2021-01-31', 'PY', 'Paraguay', 'AMRO', '969', '131886', '12', '2693');
INSERT INTO public.who_global_data_import VALUES (65596, '2021-02-01', 'PY', 'Paraguay', 'AMRO', '662', '132548', '11', '2704');
INSERT INTO public.who_global_data_import VALUES (65597, '2021-02-02', 'PY', 'Paraguay', 'AMRO', '679', '133227', '15', '2719');
INSERT INTO public.who_global_data_import VALUES (65598, '2021-02-03', 'PY', 'Paraguay', 'AMRO', '554', '133781', '14', '2733');
INSERT INTO public.who_global_data_import VALUES (65599, '2021-02-04', 'PY', 'Paraguay', 'AMRO', '701', '134482', '17', '2750');
INSERT INTO public.who_global_data_import VALUES (65600, '2021-02-05', 'PY', 'Paraguay', 'AMRO', '747', '135229', '15', '2765');
INSERT INTO public.who_global_data_import VALUES (65601, '2020-01-03', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65602, '2020-01-04', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65603, '2020-01-05', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65604, '2020-01-06', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65605, '2020-01-07', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65606, '2020-01-08', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65607, '2020-01-09', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65608, '2020-01-10', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65609, '2020-01-11', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65610, '2020-01-12', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65611, '2020-01-13', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65612, '2020-01-14', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65613, '2020-01-15', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65614, '2020-01-16', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65615, '2020-01-17', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65616, '2020-01-18', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65617, '2020-01-19', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65618, '2020-01-20', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65619, '2020-01-21', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65620, '2020-01-22', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65621, '2020-01-23', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65622, '2020-01-24', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65623, '2020-01-25', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65624, '2020-01-26', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65625, '2020-01-27', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65626, '2020-01-28', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65627, '2020-01-29', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65628, '2020-01-30', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65629, '2020-01-31', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65630, '2020-02-01', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65631, '2020-02-02', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65632, '2020-02-03', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65633, '2020-02-04', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65634, '2020-02-05', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65635, '2020-02-06', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65636, '2020-02-07', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65637, '2020-02-08', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65638, '2020-02-09', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65639, '2020-02-10', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65640, '2020-02-11', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65641, '2020-02-12', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65642, '2020-02-13', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65643, '2020-02-14', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65644, '2020-02-15', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65645, '2020-02-16', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65646, '2020-02-17', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65647, '2020-02-18', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65648, '2020-02-19', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65649, '2020-02-20', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65650, '2020-02-21', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65651, '2020-02-22', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65652, '2020-02-23', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65653, '2020-02-24', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65654, '2020-02-25', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65655, '2020-02-26', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65656, '2020-02-27', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65657, '2020-02-28', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65658, '2020-02-29', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65659, '2020-03-01', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65660, '2020-03-02', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65661, '2020-03-03', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65662, '2020-03-04', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65663, '2020-03-05', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65664, '2020-03-06', 'PE', 'Peru', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65665, '2020-03-07', 'PE', 'Peru', 'AMRO', '10', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65666, '2020-03-08', 'PE', 'Peru', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65667, '2020-03-09', 'PE', 'Peru', 'AMRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65668, '2020-03-10', 'PE', 'Peru', 'AMRO', '2', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65669, '2020-03-11', 'PE', 'Peru', 'AMRO', '2', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65670, '2020-03-12', 'PE', 'Peru', 'AMRO', '6', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65671, '2020-03-13', 'PE', 'Peru', 'AMRO', '5', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65672, '2020-03-14', 'PE', 'Peru', 'AMRO', '6', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65673, '2020-03-15', 'PE', 'Peru', 'AMRO', '15', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65674, '2020-03-16', 'PE', 'Peru', 'AMRO', '28', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65675, '2020-03-17', 'PE', 'Peru', 'AMRO', '15', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65676, '2020-03-18', 'PE', 'Peru', 'AMRO', '59', '149', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65677, '2020-03-19', 'PE', 'Peru', 'AMRO', '85', '234', '0', '0');
INSERT INTO public.who_global_data_import VALUES (65678, '2020-03-20', 'PE', 'Peru', 'AMRO', '0', '234', '2', '2');
INSERT INTO public.who_global_data_import VALUES (65679, '2020-03-21', 'PE', 'Peru', 'AMRO', '84', '318', '0', '2');
INSERT INTO public.who_global_data_import VALUES (65680, '2020-03-22', 'PE', 'Peru', 'AMRO', '0', '318', '0', '2');
INSERT INTO public.who_global_data_import VALUES (65681, '2020-03-23', 'PE', 'Peru', 'AMRO', '0', '318', '0', '2');
INSERT INTO public.who_global_data_import VALUES (65682, '2020-03-24', 'PE', 'Peru', 'AMRO', '98', '416', '3', '5');
INSERT INTO public.who_global_data_import VALUES (65683, '2020-03-25', 'PE', 'Peru', 'AMRO', '0', '416', '0', '5');
INSERT INTO public.who_global_data_import VALUES (65684, '2020-03-26', 'PE', 'Peru', 'AMRO', '164', '580', '4', '9');
INSERT INTO public.who_global_data_import VALUES (65685, '2020-03-27', 'PE', 'Peru', 'AMRO', '0', '580', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65686, '2020-03-28', 'PE', 'Peru', 'AMRO', '0', '580', '0', '9');
INSERT INTO public.who_global_data_import VALUES (65687, '2020-03-29', 'PE', 'Peru', 'AMRO', '55', '635', '2', '11');
INSERT INTO public.who_global_data_import VALUES (65688, '2020-03-30', 'PE', 'Peru', 'AMRO', '36', '671', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65689, '2020-03-31', 'PE', 'Peru', 'AMRO', '181', '852', '0', '11');
INSERT INTO public.who_global_data_import VALUES (65690, '2020-04-01', 'PE', 'Peru', 'AMRO', '213', '1065', '13', '24');
INSERT INTO public.who_global_data_import VALUES (65691, '2020-04-02', 'PE', 'Peru', 'AMRO', '258', '1323', '0', '24');
INSERT INTO public.who_global_data_import VALUES (65692, '2020-04-03', 'PE', 'Peru', 'AMRO', '0', '1323', '17', '41');
INSERT INTO public.who_global_data_import VALUES (65693, '2020-04-04', 'PE', 'Peru', 'AMRO', '91', '1414', '10', '51');
INSERT INTO public.who_global_data_import VALUES (65694, '2020-04-05', 'PE', 'Peru', 'AMRO', '181', '1595', '10', '61');
INSERT INTO public.who_global_data_import VALUES (65695, '2020-04-06', 'PE', 'Peru', 'AMRO', '151', '1746', '12', '73');
INSERT INTO public.who_global_data_import VALUES (65696, '2020-04-07', 'PE', 'Peru', 'AMRO', '535', '2281', '10', '83');
INSERT INTO public.who_global_data_import VALUES (65697, '2020-04-08', 'PE', 'Peru', 'AMRO', '280', '2561', '9', '92');
INSERT INTO public.who_global_data_import VALUES (65698, '2020-04-09', 'PE', 'Peru', 'AMRO', '393', '2954', '15', '107');
INSERT INTO public.who_global_data_import VALUES (65699, '2020-04-10', 'PE', 'Peru', 'AMRO', '1388', '4342', '14', '121');
INSERT INTO public.who_global_data_import VALUES (65700, '2020-04-11', 'PE', 'Peru', 'AMRO', '914', '5256', '17', '138');
INSERT INTO public.who_global_data_import VALUES (65701, '2020-04-12', 'PE', 'Peru', 'AMRO', '641', '5897', '31', '169');
INSERT INTO public.who_global_data_import VALUES (65702, '2020-04-13', 'PE', 'Peru', 'AMRO', '951', '6848', '12', '181');
INSERT INTO public.who_global_data_import VALUES (65703, '2020-04-14', 'PE', 'Peru', 'AMRO', '671', '7519', '12', '193');
INSERT INTO public.who_global_data_import VALUES (65704, '2020-04-15', 'PE', 'Peru', 'AMRO', '0', '7519', '0', '193');
INSERT INTO public.who_global_data_import VALUES (65705, '2020-04-16', 'PE', 'Peru', 'AMRO', '2784', '10303', '37', '230');
INSERT INTO public.who_global_data_import VALUES (65706, '2020-04-17', 'PE', 'Peru', 'AMRO', '1172', '11475', '24', '254');
INSERT INTO public.who_global_data_import VALUES (65707, '2020-04-18', 'PE', 'Peru', 'AMRO', '2014', '13489', '46', '300');
INSERT INTO public.who_global_data_import VALUES (65708, '2020-04-19', 'PE', 'Peru', 'AMRO', '0', '13489', '0', '300');
INSERT INTO public.who_global_data_import VALUES (65709, '2020-04-20', 'PE', 'Peru', 'AMRO', '931', '14420', '48', '348');
INSERT INTO public.who_global_data_import VALUES (65710, '2020-04-21', 'PE', 'Peru', 'AMRO', '1208', '15628', '52', '400');
INSERT INTO public.who_global_data_import VALUES (65711, '2020-04-22', 'PE', 'Peru', 'AMRO', '697', '16325', '45', '445');
INSERT INTO public.who_global_data_import VALUES (65712, '2020-04-23', 'PE', 'Peru', 'AMRO', '1512', '17837', '39', '484');
INSERT INTO public.who_global_data_import VALUES (65713, '2020-04-24', 'PE', 'Peru', 'AMRO', '1413', '19250', '46', '530');
INSERT INTO public.who_global_data_import VALUES (65714, '2020-04-25', 'PE', 'Peru', 'AMRO', '1664', '20914', '42', '572');
INSERT INTO public.who_global_data_import VALUES (65715, '2020-04-26', 'PE', 'Peru', 'AMRO', '734', '21648', '62', '634');
INSERT INTO public.who_global_data_import VALUES (65716, '2020-04-27', 'PE', 'Peru', 'AMRO', '3683', '25331', '66', '700');
INSERT INTO public.who_global_data_import VALUES (65717, '2020-04-28', 'PE', 'Peru', 'AMRO', '2186', '27517', '28', '728');
INSERT INTO public.who_global_data_import VALUES (65718, '2020-04-29', 'PE', 'Peru', 'AMRO', '1182', '28699', '54', '782');
INSERT INTO public.who_global_data_import VALUES (65719, '2020-04-30', 'PE', 'Peru', 'AMRO', '2491', '31190', '72', '854');
INSERT INTO public.who_global_data_import VALUES (65720, '2020-05-01', 'PE', 'Peru', 'AMRO', '2741', '33931', '89', '943');
INSERT INTO public.who_global_data_import VALUES (65721, '2020-05-02', 'PE', 'Peru', 'AMRO', '3045', '36976', '108', '1051');
INSERT INTO public.who_global_data_import VALUES (65722, '2020-05-03', 'PE', 'Peru', 'AMRO', '3483', '40459', '73', '1124');
INSERT INTO public.who_global_data_import VALUES (65723, '2020-05-04', 'PE', 'Peru', 'AMRO', '2075', '42534', '76', '1200');
INSERT INTO public.who_global_data_import VALUES (65724, '2020-05-05', 'PE', 'Peru', 'AMRO', '3394', '45928', '86', '1286');
INSERT INTO public.who_global_data_import VALUES (65725, '2020-05-06', 'PE', 'Peru', 'AMRO', '1444', '47372', '58', '1344');
INSERT INTO public.who_global_data_import VALUES (65726, '2020-05-07', 'PE', 'Peru', 'AMRO', '3817', '51189', '100', '1444');
INSERT INTO public.who_global_data_import VALUES (65727, '2020-05-08', 'PE', 'Peru', 'AMRO', '3628', '54817', '89', '1533');
INSERT INTO public.who_global_data_import VALUES (65728, '2020-05-09', 'PE', 'Peru', 'AMRO', '3709', '58526', '94', '1627');
INSERT INTO public.who_global_data_import VALUES (65729, '2020-05-10', 'PE', 'Peru', 'AMRO', '3321', '61847', '87', '1714');
INSERT INTO public.who_global_data_import VALUES (65730, '2020-05-11', 'PE', 'Peru', 'AMRO', '3168', '65015', '100', '1814');
INSERT INTO public.who_global_data_import VALUES (65731, '2020-05-12', 'PE', 'Peru', 'AMRO', '2292', '67307', '75', '1889');
INSERT INTO public.who_global_data_import VALUES (65732, '2020-05-13', 'PE', 'Peru', 'AMRO', '1515', '68822', '72', '1961');
INSERT INTO public.who_global_data_import VALUES (65733, '2020-05-14', 'PE', 'Peru', 'AMRO', '3237', '72059', '96', '2057');
INSERT INTO public.who_global_data_import VALUES (65734, '2020-05-15', 'PE', 'Peru', 'AMRO', '4247', '76306', '112', '2169');
INSERT INTO public.who_global_data_import VALUES (65735, '2020-05-16', 'PE', 'Peru', 'AMRO', '4298', '80604', '98', '2267');
INSERT INTO public.who_global_data_import VALUES (65736, '2020-05-17', 'PE', 'Peru', 'AMRO', '3891', '84495', '125', '2392');
INSERT INTO public.who_global_data_import VALUES (65737, '2020-05-18', 'PE', 'Peru', 'AMRO', '4046', '88541', '131', '2523');
INSERT INTO public.who_global_data_import VALUES (65738, '2020-05-19', 'PE', 'Peru', 'AMRO', '3732', '92273', '125', '2648');
INSERT INTO public.who_global_data_import VALUES (65739, '2020-05-20', 'PE', 'Peru', 'AMRO', '2660', '94933', '141', '2789');
INSERT INTO public.who_global_data_import VALUES (65740, '2020-05-21', 'PE', 'Peru', 'AMRO', '4550', '99483', '125', '2914');
INSERT INTO public.who_global_data_import VALUES (65741, '2020-05-22', 'PE', 'Peru', 'AMRO', '4537', '104020', '110', '3024');
INSERT INTO public.who_global_data_import VALUES (65742, '2020-05-23', 'PE', 'Peru', 'AMRO', '4749', '108769', '124', '3148');
INSERT INTO public.who_global_data_import VALUES (65743, '2020-05-24', 'PE', 'Peru', 'AMRO', '2929', '111698', '96', '3244');
INSERT INTO public.who_global_data_import VALUES (65744, '2020-05-25', 'PE', 'Peru', 'AMRO', '4056', '115754', '129', '3373');
INSERT INTO public.who_global_data_import VALUES (65745, '2020-05-26', 'PE', 'Peru', 'AMRO', '4205', '119959', '83', '3456');
INSERT INTO public.who_global_data_import VALUES (65746, '2020-05-27', 'PE', 'Peru', 'AMRO', '4020', '123979', '173', '3629');
INSERT INTO public.who_global_data_import VALUES (65747, '2020-05-28', 'PE', 'Peru', 'AMRO', '5772', '129751', '159', '3788');
INSERT INTO public.who_global_data_import VALUES (65748, '2020-05-29', 'PE', 'Peru', 'AMRO', '6154', '135905', '195', '3983');
INSERT INTO public.who_global_data_import VALUES (65749, '2020-05-30', 'PE', 'Peru', 'AMRO', '5874', '141779', '116', '4099');
INSERT INTO public.who_global_data_import VALUES (65750, '2020-05-31', 'PE', 'Peru', 'AMRO', '6506', '148285', '131', '4230');
INSERT INTO public.who_global_data_import VALUES (65751, '2020-06-01', 'PE', 'Peru', 'AMRO', '7386', '155671', '141', '4371');
INSERT INTO public.who_global_data_import VALUES (65752, '2020-06-02', 'PE', 'Peru', 'AMRO', '8805', '164476', '135', '4506');
INSERT INTO public.who_global_data_import VALUES (65753, '2020-06-03', 'PE', 'Peru', 'AMRO', '5563', '170039', '128', '4634');
INSERT INTO public.who_global_data_import VALUES (65754, '2020-06-04', 'PE', 'Peru', 'AMRO', '4845', '174884', '133', '4767');
INSERT INTO public.who_global_data_import VALUES (65755, '2020-06-05', 'PE', 'Peru', 'AMRO', '4030', '178914', '127', '4894');
INSERT INTO public.who_global_data_import VALUES (65756, '2020-06-06', 'PE', 'Peru', 'AMRO', '4284', '183198', '137', '5031');
INSERT INTO public.who_global_data_import VALUES (65757, '2020-06-07', 'PE', 'Peru', 'AMRO', '4202', '187400', '131', '5162');
INSERT INTO public.who_global_data_import VALUES (65758, '2020-06-08', 'PE', 'Peru', 'AMRO', '4358', '191758', '139', '5301');
INSERT INTO public.who_global_data_import VALUES (65759, '2020-06-09', 'PE', 'Peru', 'AMRO', '4757', '196515', '164', '5465');
INSERT INTO public.who_global_data_import VALUES (65760, '2020-06-10', 'PE', 'Peru', 'AMRO', '3181', '199696', '106', '5571');
INSERT INTO public.who_global_data_import VALUES (65761, '2020-06-11', 'PE', 'Peru', 'AMRO', '4040', '203736', '167', '5738');
INSERT INTO public.who_global_data_import VALUES (65762, '2020-06-12', 'PE', 'Peru', 'AMRO', '5087', '208823', '165', '5903');
INSERT INTO public.who_global_data_import VALUES (65763, '2020-06-13', 'PE', 'Peru', 'AMRO', '5965', '214788', '206', '6109');
INSERT INTO public.who_global_data_import VALUES (65764, '2020-06-14', 'PE', 'Peru', 'AMRO', '5961', '220749', '199', '6308');
INSERT INTO public.who_global_data_import VALUES (65765, '2020-06-15', 'PE', 'Peru', 'AMRO', '4383', '225132', '190', '6498');
INSERT INTO public.who_global_data_import VALUES (65766, '2020-06-16', 'PE', 'Peru', 'AMRO', '4604', '229736', '190', '6688');
INSERT INTO public.who_global_data_import VALUES (65767, '2020-06-17', 'PE', 'Peru', 'AMRO', '3256', '232992', '172', '6860');
INSERT INTO public.who_global_data_import VALUES (65768, '2020-06-18', 'PE', 'Peru', 'AMRO', '4164', '237156', '196', '7056');
INSERT INTO public.who_global_data_import VALUES (65769, '2020-06-19', 'PE', 'Peru', 'AMRO', '3752', '240908', '201', '7257');
INSERT INTO public.who_global_data_import VALUES (65770, '2020-06-20', 'PE', 'Peru', 'AMRO', '3480', '244388', '204', '7461');
INSERT INTO public.who_global_data_import VALUES (65771, '2020-06-21', 'PE', 'Peru', 'AMRO', '3537', '247925', '199', '7660');
INSERT INTO public.who_global_data_import VALUES (65772, '2020-06-22', 'PE', 'Peru', 'AMRO', '3413', '251338', '201', '7861');
INSERT INTO public.who_global_data_import VALUES (65773, '2020-06-23', 'PE', 'Peru', 'AMRO', '3598', '254936', '184', '8045');
INSERT INTO public.who_global_data_import VALUES (65774, '2020-06-24', 'PE', 'Peru', 'AMRO', '2511', '257447', '178', '8223');
INSERT INTO public.who_global_data_import VALUES (65775, '2020-06-25', 'PE', 'Peru', 'AMRO', '3363', '260810', '181', '8404');
INSERT INTO public.who_global_data_import VALUES (65776, '2020-06-26', 'PE', 'Peru', 'AMRO', '3879', '264689', '182', '8586');
INSERT INTO public.who_global_data_import VALUES (65777, '2020-06-27', 'PE', 'Peru', 'AMRO', '3913', '268602', '175', '8761');
INSERT INTO public.who_global_data_import VALUES (65778, '2020-06-28', 'PE', 'Peru', 'AMRO', '3762', '272364', '178', '8939');
INSERT INTO public.who_global_data_import VALUES (65779, '2020-06-29', 'PE', 'Peru', 'AMRO', '3625', '275989', '196', '9135');
INSERT INTO public.who_global_data_import VALUES (65780, '2020-06-30', 'PE', 'Peru', 'AMRO', '3430', '279419', '182', '9317');
INSERT INTO public.who_global_data_import VALUES (65781, '2020-07-01', 'PE', 'Peru', 'AMRO', '2946', '282365', '187', '9504');
INSERT INTO public.who_global_data_import VALUES (65782, '2020-07-02', 'PE', 'Peru', 'AMRO', '2848', '285213', '173', '9677');
INSERT INTO public.who_global_data_import VALUES (65783, '2020-07-03', 'PE', 'Peru', 'AMRO', '3264', '288477', '183', '9860');
INSERT INTO public.who_global_data_import VALUES (65784, '2020-07-04', 'PE', 'Peru', 'AMRO', '3527', '292004', '185', '10045');
INSERT INTO public.who_global_data_import VALUES (65785, '2020-07-05', 'PE', 'Peru', 'AMRO', '3595', '295599', '181', '10226');
INSERT INTO public.who_global_data_import VALUES (65786, '2020-07-06', 'PE', 'Peru', 'AMRO', '3481', '299080', '186', '10412');
INSERT INTO public.who_global_data_import VALUES (65787, '2020-07-07', 'PE', 'Peru', 'AMRO', '3638', '302718', '177', '10589');
INSERT INTO public.who_global_data_import VALUES (65788, '2020-07-08', 'PE', 'Peru', 'AMRO', '2985', '305703', '183', '10772');
INSERT INTO public.who_global_data_import VALUES (65789, '2020-07-09', 'PE', 'Peru', 'AMRO', '3575', '309278', '180', '10952');
INSERT INTO public.who_global_data_import VALUES (65790, '2020-07-10', 'PE', 'Peru', 'AMRO', '3633', '312911', '181', '11133');
INSERT INTO public.who_global_data_import VALUES (65791, '2020-07-11', 'PE', 'Peru', 'AMRO', '3537', '316448', '181', '11314');
INSERT INTO public.who_global_data_import VALUES (65792, '2020-07-12', 'PE', 'Peru', 'AMRO', '3198', '319646', '186', '11500');
INSERT INTO public.who_global_data_import VALUES (65793, '2020-07-13', 'PE', 'Peru', 'AMRO', '3064', '322710', '182', '11682');
INSERT INTO public.who_global_data_import VALUES (65794, '2020-07-14', 'PE', 'Peru', 'AMRO', '3616', '326326', '188', '11870');
INSERT INTO public.who_global_data_import VALUES (65795, '2020-07-15', 'PE', 'Peru', 'AMRO', '3797', '330123', '184', '12054');
INSERT INTO public.who_global_data_import VALUES (65796, '2020-07-16', 'PE', 'Peru', 'AMRO', '3744', '333867', '175', '12229');
INSERT INTO public.who_global_data_import VALUES (65797, '2020-07-17', 'PE', 'Peru', 'AMRO', '3857', '337724', '188', '12417');
INSERT INTO public.who_global_data_import VALUES (65798, '2020-07-18', 'PE', 'Peru', 'AMRO', '3862', '341586', '198', '12615');
INSERT INTO public.who_global_data_import VALUES (65799, '2020-07-19', 'PE', 'Peru', 'AMRO', '3951', '345537', '184', '12799');
INSERT INTO public.who_global_data_import VALUES (65800, '2020-07-20', 'PE', 'Peru', 'AMRO', '3963', '349500', '199', '12998');
INSERT INTO public.who_global_data_import VALUES (65801, '2020-07-21', 'PE', 'Peru', 'AMRO', '4090', '353590', '189', '13187');
INSERT INTO public.who_global_data_import VALUES (65802, '2020-07-22', 'PE', 'Peru', 'AMRO', '4091', '357681', '197', '13384');
INSERT INTO public.who_global_data_import VALUES (65803, '2020-07-23', 'PE', 'Peru', 'AMRO', '4406', '362087', '195', '13579');
INSERT INTO public.who_global_data_import VALUES (65804, '2020-07-24', 'PE', 'Peru', 'AMRO', '4463', '366550', '3876', '17455');
INSERT INTO public.who_global_data_import VALUES (65805, '2020-07-25', 'PE', 'Peru', 'AMRO', '4546', '371096', '199', '17654');
INSERT INTO public.who_global_data_import VALUES (65806, '2020-07-26', 'PE', 'Peru', 'AMRO', '4865', '375961', '189', '17843');
INSERT INTO public.who_global_data_import VALUES (65807, '2020-07-27', 'PE', 'Peru', 'AMRO', '3923', '379884', '187', '18030');
INSERT INTO public.who_global_data_import VALUES (65808, '2020-07-28', 'PE', 'Peru', 'AMRO', '4913', '384797', '199', '18229');
INSERT INTO public.who_global_data_import VALUES (65809, '2020-07-29', 'PE', 'Peru', 'AMRO', '4920', '389717', '189', '18418');
INSERT INTO public.who_global_data_import VALUES (65810, '2020-07-30', 'PE', 'Peru', 'AMRO', '5288', '395005', '194', '18612');
INSERT INTO public.who_global_data_import VALUES (65811, '2020-07-31', 'PE', 'Peru', 'AMRO', '5678', '400683', '204', '18816');
INSERT INTO public.who_global_data_import VALUES (65812, '2020-08-01', 'PE', 'Peru', 'AMRO', '6809', '407492', '205', '19021');
INSERT INTO public.who_global_data_import VALUES (65813, '2020-08-02', 'PE', 'Peru', 'AMRO', '0', '407492', '0', '19021');
INSERT INTO public.who_global_data_import VALUES (65814, '2020-08-03', 'PE', 'Peru', 'AMRO', '14691', '422183', '387', '19408');
INSERT INTO public.who_global_data_import VALUES (65815, '2020-08-04', 'PE', 'Peru', 'AMRO', '6667', '428850', '206', '19614');
INSERT INTO public.who_global_data_import VALUES (65816, '2020-08-05', 'PE', 'Peru', 'AMRO', '4250', '433100', '197', '19811');
INSERT INTO public.who_global_data_import VALUES (65817, '2020-08-06', 'PE', 'Peru', 'AMRO', '6790', '439890', '196', '20007');
INSERT INTO public.who_global_data_import VALUES (65818, '2020-08-07', 'PE', 'Peru', 'AMRO', '7734', '447624', '221', '20228');
INSERT INTO public.who_global_data_import VALUES (65819, '2020-08-08', 'PE', 'Peru', 'AMRO', '7785', '455409', '196', '20424');
INSERT INTO public.who_global_data_import VALUES (65820, '2020-08-09', 'PE', 'Peru', 'AMRO', '8466', '463875', '225', '20649');
INSERT INTO public.who_global_data_import VALUES (65821, '2020-08-10', 'PE', 'Peru', 'AMRO', '7137', '471012', '195', '20844');
INSERT INTO public.who_global_data_import VALUES (65822, '2020-08-11', 'PE', 'Peru', 'AMRO', '7012', '478024', '228', '21072');
INSERT INTO public.who_global_data_import VALUES (65823, '2020-08-12', 'PE', 'Peru', 'AMRO', '5109', '483133', '204', '21276');
INSERT INTO public.who_global_data_import VALUES (65824, '2020-08-13', 'PE', 'Peru', 'AMRO', '6547', '489680', '225', '21501');
INSERT INTO public.who_global_data_import VALUES (65825, '2020-08-14', 'PE', 'Peru', 'AMRO', '8875', '498555', '212', '21713');
INSERT INTO public.who_global_data_import VALUES (65826, '2020-08-15', 'PE', 'Peru', 'AMRO', '9441', '507996', '3935', '25648');
INSERT INTO public.who_global_data_import VALUES (65827, '2020-08-16', 'PE', 'Peru', 'AMRO', '8300', '516296', '208', '25856');
INSERT INTO public.who_global_data_import VALUES (65828, '2020-08-17', 'PE', 'Peru', 'AMRO', '9507', '525803', '219', '26075');
INSERT INTO public.who_global_data_import VALUES (65829, '2020-08-18', 'PE', 'Peru', 'AMRO', '10143', '535946', '206', '26281');
INSERT INTO public.who_global_data_import VALUES (65830, '2020-08-19', 'PE', 'Peru', 'AMRO', '5547', '541493', '200', '26481');
INSERT INTO public.who_global_data_import VALUES (65831, '2020-08-20', 'PE', 'Peru', 'AMRO', '7828', '549321', '177', '26658');
INSERT INTO public.who_global_data_import VALUES (65832, '2020-08-21', 'PE', 'Peru', 'AMRO', '9099', '558420', '176', '26834');
INSERT INTO public.who_global_data_import VALUES (65833, '2020-08-22', 'PE', 'Peru', 'AMRO', '8639', '567059', '200', '27034');
INSERT INTO public.who_global_data_import VALUES (65834, '2020-08-23', 'PE', 'Peru', 'AMRO', '9008', '576067', '211', '27245');
INSERT INTO public.who_global_data_import VALUES (65835, '2020-08-24', 'PE', 'Peru', 'AMRO', '9169', '585236', '208', '27453');
INSERT INTO public.who_global_data_import VALUES (65836, '2020-08-25', 'PE', 'Peru', 'AMRO', '9090', '594326', '210', '27663');
INSERT INTO public.who_global_data_import VALUES (65837, '2020-08-26', 'PE', 'Peru', 'AMRO', '6112', '600438', '150', '27813');
INSERT INTO public.who_global_data_import VALUES (65838, '2020-08-27', 'PE', 'Peru', 'AMRO', '6944', '607382', '188', '28001');
INSERT INTO public.who_global_data_import VALUES (65839, '2020-08-28', 'PE', 'Peru', 'AMRO', '5996', '613378', '123', '28124');
INSERT INTO public.who_global_data_import VALUES (65840, '2020-08-29', 'PE', 'Peru', 'AMRO', '8619', '621997', '153', '28277');
INSERT INTO public.who_global_data_import VALUES (65841, '2020-08-30', 'PE', 'Peru', 'AMRO', '7964', '629961', '194', '28471');
INSERT INTO public.who_global_data_import VALUES (65842, '2020-08-31', 'PE', 'Peru', 'AMRO', '9474', '639435', '136', '28607');
INSERT INTO public.who_global_data_import VALUES (65843, '2020-09-01', 'PE', 'Peru', 'AMRO', '7731', '647166', '181', '28788');
INSERT INTO public.who_global_data_import VALUES (65844, '2020-09-02', 'PE', 'Peru', 'AMRO', '4871', '652037', '156', '28944');
INSERT INTO public.who_global_data_import VALUES (65845, '2020-09-03', 'PE', 'Peru', 'AMRO', '5092', '657129', '124', '29068');
INSERT INTO public.who_global_data_import VALUES (65846, '2020-09-04', 'PE', 'Peru', 'AMRO', '6308', '663437', '191', '29259');
INSERT INTO public.who_global_data_import VALUES (65847, '2020-09-05', 'PE', 'Peru', 'AMRO', '6708', '670145', '146', '29405');
INSERT INTO public.who_global_data_import VALUES (65848, '2020-09-06', 'PE', 'Peru', 'AMRO', '6703', '676848', '149', '29554');
INSERT INTO public.who_global_data_import VALUES (65849, '2020-09-07', 'PE', 'Peru', 'AMRO', '6854', '683702', '133', '29687');
INSERT INTO public.who_global_data_import VALUES (65850, '2020-09-08', 'PE', 'Peru', 'AMRO', '6275', '689977', '151', '29838');
INSERT INTO public.who_global_data_import VALUES (65851, '2020-09-09', 'PE', 'Peru', 'AMRO', '1598', '691575', '138', '29976');
INSERT INTO public.who_global_data_import VALUES (65852, '2020-09-10', 'PE', 'Peru', 'AMRO', '4615', '696190', '147', '30123');
INSERT INTO public.who_global_data_import VALUES (65853, '2020-09-11', 'PE', 'Peru', 'AMRO', '6586', '702776', '113', '30236');
INSERT INTO public.who_global_data_import VALUES (65854, '2020-09-12', 'PE', 'Peru', 'AMRO', '7291', '710067', '108', '30344');
INSERT INTO public.who_global_data_import VALUES (65855, '2020-09-13', 'PE', 'Peru', 'AMRO', '6603', '716670', '126', '30470');
INSERT INTO public.who_global_data_import VALUES (65856, '2020-09-14', 'PE', 'Peru', 'AMRO', '6162', '722832', '123', '30593');
INSERT INTO public.who_global_data_import VALUES (65857, '2020-09-15', 'PE', 'Peru', 'AMRO', '6787', '729619', '117', '30710');
INSERT INTO public.who_global_data_import VALUES (65858, '2020-09-16', 'PE', 'Peru', 'AMRO', '4241', '733860', '102', '30812');
INSERT INTO public.who_global_data_import VALUES (65859, '2020-09-17', 'PE', 'Peru', 'AMRO', '4160', '738020', '115', '30927');
INSERT INTO public.who_global_data_import VALUES (65860, '2020-09-18', 'PE', 'Peru', 'AMRO', '6380', '744400', '124', '31051');
INSERT INTO public.who_global_data_import VALUES (65861, '2020-09-19', 'PE', 'Peru', 'AMRO', '5698', '750098', '95', '31146');
INSERT INTO public.who_global_data_import VALUES (65862, '2020-09-20', 'PE', 'Peru', 'AMRO', '6314', '756412', '137', '31283');
INSERT INTO public.who_global_data_import VALUES (65863, '2020-09-21', 'PE', 'Peru', 'AMRO', '6453', '762865', '86', '31369');
INSERT INTO public.who_global_data_import VALUES (65864, '2020-09-22', 'PE', 'Peru', 'AMRO', '6030', '768895', '0', '31369');
INSERT INTO public.who_global_data_import VALUES (65865, '2020-09-23', 'PE', 'Peru', 'AMRO', '4001', '772896', '105', '31474');
INSERT INTO public.who_global_data_import VALUES (65866, '2020-09-24', 'PE', 'Peru', 'AMRO', '3650', '776546', '94', '31568');
INSERT INTO public.who_global_data_import VALUES (65867, '2020-09-25', 'PE', 'Peru', 'AMRO', '6149', '782695', '302', '31870');
INSERT INTO public.who_global_data_import VALUES (65868, '2020-09-26', 'PE', 'Peru', 'AMRO', '6235', '788930', '68', '31938');
INSERT INTO public.who_global_data_import VALUES (65869, '2020-09-27', 'PE', 'Peru', 'AMRO', '5654', '794584', '99', '32037');
INSERT INTO public.who_global_data_import VALUES (65870, '2020-09-28', 'PE', 'Peru', 'AMRO', '5558', '800142', '105', '32142');
INSERT INTO public.who_global_data_import VALUES (65871, '2020-09-29', 'PE', 'Peru', 'AMRO', '5160', '805302', '120', '32262');
INSERT INTO public.who_global_data_import VALUES (65872, '2020-09-30', 'PE', 'Peru', 'AMRO', '3412', '808714', '62', '32324');
INSERT INTO public.who_global_data_import VALUES (65873, '2020-10-01', 'PE', 'Peru', 'AMRO', '3054', '811768', '72', '32396');
INSERT INTO public.who_global_data_import VALUES (65874, '2020-10-02', 'PE', 'Peru', 'AMRO', '3061', '814829', '67', '32463');
INSERT INTO public.who_global_data_import VALUES (65875, '2020-10-03', 'PE', 'Peru', 'AMRO', '3468', '818297', '72', '32535');
INSERT INTO public.who_global_data_import VALUES (65876, '2020-10-04', 'PE', 'Peru', 'AMRO', '3267', '821564', '74', '32609');
INSERT INTO public.who_global_data_import VALUES (65877, '2020-10-05', 'PE', 'Peru', 'AMRO', '3421', '824985', '56', '32665');
INSERT INTO public.who_global_data_import VALUES (65878, '2020-10-06', 'PE', 'Peru', 'AMRO', '3184', '828169', '77', '32742');
INSERT INTO public.who_global_data_import VALUES (65879, '2020-10-07', 'PE', 'Peru', 'AMRO', '1830', '829999', '92', '32834');
INSERT INTO public.who_global_data_import VALUES (65880, '2020-10-08', 'PE', 'Peru', 'AMRO', '2930', '832929', '80', '32914');
INSERT INTO public.who_global_data_import VALUES (65881, '2020-10-09', 'PE', 'Peru', 'AMRO', '2733', '835662', '95', '33009');
INSERT INTO public.who_global_data_import VALUES (65882, '2020-10-10', 'PE', 'Peru', 'AMRO', '2952', '838614', '89', '33098');
INSERT INTO public.who_global_data_import VALUES (65883, '2020-10-11', 'PE', 'Peru', 'AMRO', '4741', '843355', '60', '33158');
INSERT INTO public.who_global_data_import VALUES (65884, '2020-10-12', 'PE', 'Peru', 'AMRO', '2733', '846088', '65', '33223');
INSERT INTO public.who_global_data_import VALUES (65885, '2020-10-13', 'PE', 'Peru', 'AMRO', '3283', '849371', '82', '33305');
INSERT INTO public.who_global_data_import VALUES (65886, '2020-10-14', 'PE', 'Peru', 'AMRO', '1800', '851171', '52', '33357');
INSERT INTO public.who_global_data_import VALUES (65887, '2020-10-15', 'PE', 'Peru', 'AMRO', '2803', '853974', '62', '33419');
INSERT INTO public.who_global_data_import VALUES (65888, '2020-10-16', 'PE', 'Peru', 'AMRO', '2977', '856951', '93', '33512');
INSERT INTO public.who_global_data_import VALUES (65889, '2020-10-17', 'PE', 'Peru', 'AMRO', '2789', '859740', '65', '33577');
INSERT INTO public.who_global_data_import VALUES (65890, '2020-10-18', 'PE', 'Peru', 'AMRO', '2677', '862417', '71', '33648');
INSERT INTO public.who_global_data_import VALUES (65891, '2020-10-19', 'PE', 'Peru', 'AMRO', '3132', '865549', '54', '33702');
INSERT INTO public.who_global_data_import VALUES (65892, '2020-10-20', 'PE', 'Peru', 'AMRO', '3126', '868675', '57', '33759');
INSERT INTO public.who_global_data_import VALUES (65893, '2020-10-21', 'PE', 'Peru', 'AMRO', '2201', '870876', '61', '33820');
INSERT INTO public.who_global_data_import VALUES (65894, '2020-10-22', 'PE', 'Peru', 'AMRO', '3242', '874118', '55', '33875');
INSERT INTO public.who_global_data_import VALUES (65895, '2020-10-23', 'PE', 'Peru', 'AMRO', '2767', '876885', '62', '33937');
INSERT INTO public.who_global_data_import VALUES (65896, '2020-10-24', 'PE', 'Peru', 'AMRO', '2991', '879876', '47', '33984');
INSERT INTO public.who_global_data_import VALUES (65897, '2020-10-25', 'PE', 'Peru', 'AMRO', '3240', '883116', '49', '34033');
INSERT INTO public.who_global_data_import VALUES (65898, '2020-10-26', 'PE', 'Peru', 'AMRO', '3098', '886214', '62', '34095');
INSERT INTO public.who_global_data_import VALUES (65899, '2020-10-27', 'PE', 'Peru', 'AMRO', '2501', '888715', '54', '34149');
INSERT INTO public.who_global_data_import VALUES (65900, '2020-10-28', 'PE', 'Peru', 'AMRO', '1859', '890574', '48', '34197');
INSERT INTO public.who_global_data_import VALUES (65901, '2020-10-29', 'PE', 'Peru', 'AMRO', '1923', '892497', '60', '34257');
INSERT INTO public.who_global_data_import VALUES (65902, '2020-10-30', 'PE', 'Peru', 'AMRO', '2431', '894928', '58', '34315');
INSERT INTO public.who_global_data_import VALUES (65903, '2020-10-31', 'PE', 'Peru', 'AMRO', '2666', '897594', '47', '34362');
INSERT INTO public.who_global_data_import VALUES (65904, '2020-11-01', 'PE', 'Peru', 'AMRO', '2586', '900180', '49', '34411');
INSERT INTO public.who_global_data_import VALUES (65905, '2020-11-02', 'PE', 'Peru', 'AMRO', '2323', '902503', '65', '34476');
INSERT INTO public.who_global_data_import VALUES (65906, '2020-11-03', 'PE', 'Peru', 'AMRO', '2408', '904911', '53', '34529');
INSERT INTO public.who_global_data_import VALUES (65907, '2020-11-04', 'PE', 'Peru', 'AMRO', '1634', '906545', '56', '34585');
INSERT INTO public.who_global_data_import VALUES (65908, '2020-11-05', 'PE', 'Peru', 'AMRO', '2357', '908902', '38', '34623');
INSERT INTO public.who_global_data_import VALUES (65909, '2020-11-06', 'PE', 'Peru', 'AMRO', '2885', '911787', '48', '34671');
INSERT INTO public.who_global_data_import VALUES (65910, '2020-11-07', 'PE', 'Peru', 'AMRO', '2935', '914722', '59', '34730');
INSERT INTO public.who_global_data_import VALUES (65911, '2020-11-08', 'PE', 'Peru', 'AMRO', '2781', '917503', '53', '34783');
INSERT INTO public.who_global_data_import VALUES (65912, '2020-11-09', 'PE', 'Peru', 'AMRO', '2507', '920010', '57', '34840');
INSERT INTO public.who_global_data_import VALUES (65913, '2020-11-10', 'PE', 'Peru', 'AMRO', '2323', '922333', '39', '34879');
INSERT INTO public.who_global_data_import VALUES (65914, '2020-11-11', 'PE', 'Peru', 'AMRO', '1194', '923527', '64', '34943');
INSERT INTO public.who_global_data_import VALUES (65915, '2020-11-12', 'PE', 'Peru', 'AMRO', '1904', '925431', '49', '34992');
INSERT INTO public.who_global_data_import VALUES (65916, '2020-11-13', 'PE', 'Peru', 'AMRO', '2575', '928006', '39', '35031');
INSERT INTO public.who_global_data_import VALUES (65917, '2020-11-14', 'PE', 'Peru', 'AMRO', '2231', '930237', '36', '35067');
INSERT INTO public.who_global_data_import VALUES (65918, '2020-11-15', 'PE', 'Peru', 'AMRO', '2413', '932650', '39', '35106');
INSERT INTO public.who_global_data_import VALUES (65919, '2020-11-16', 'PE', 'Peru', 'AMRO', '2249', '934899', '71', '35177');
INSERT INTO public.who_global_data_import VALUES (65920, '2020-11-17', 'PE', 'Peru', 'AMRO', '2112', '937011', '54', '35231');
INSERT INTO public.who_global_data_import VALUES (65921, '2020-11-18', 'PE', 'Peru', 'AMRO', '1257', '938268', '40', '35271');
INSERT INTO public.who_global_data_import VALUES (65922, '2020-11-19', 'PE', 'Peru', 'AMRO', '1663', '939931', '46', '35317');
INSERT INTO public.who_global_data_import VALUES (65923, '2020-11-20', 'PE', 'Peru', 'AMRO', '2020', '941951', '85', '35402');
INSERT INTO public.who_global_data_import VALUES (65924, '2020-11-21', 'PE', 'Peru', 'AMRO', '1966', '943917', '44', '35446');
INSERT INTO public.who_global_data_import VALUES (65925, '2020-11-22', 'PE', 'Peru', 'AMRO', '2170', '946087', '38', '35484');
INSERT INTO public.who_global_data_import VALUES (65926, '2020-11-23', 'PE', 'Peru', 'AMRO', '1994', '948081', '65', '35549');
INSERT INTO public.who_global_data_import VALUES (65927, '2020-11-24', 'PE', 'Peru', 'AMRO', '1589', '949670', '46', '35595');
INSERT INTO public.who_global_data_import VALUES (65928, '2020-11-25', 'PE', 'Peru', 'AMRO', '887', '950557', '46', '35641');
INSERT INTO public.who_global_data_import VALUES (65929, '2020-11-26', 'PE', 'Peru', 'AMRO', '1882', '952439', '44', '35685');
INSERT INTO public.who_global_data_import VALUES (65930, '2020-11-27', 'PE', 'Peru', 'AMRO', '2020', '954459', '42', '35727');
INSERT INTO public.who_global_data_import VALUES (65931, '2020-11-28', 'PE', 'Peru', 'AMRO', '1888', '956347', '58', '35785');
INSERT INTO public.who_global_data_import VALUES (65932, '2020-11-29', 'PE', 'Peru', 'AMRO', '1977', '958324', '54', '35839');
INSERT INTO public.who_global_data_import VALUES (65933, '2020-11-30', 'PE', 'Peru', 'AMRO', '2044', '960368', '40', '35879');
INSERT INTO public.who_global_data_import VALUES (65934, '2020-12-01', 'PE', 'Peru', 'AMRO', '2162', '962530', '44', '35923');
INSERT INTO public.who_global_data_import VALUES (65935, '2020-12-02', 'PE', 'Peru', 'AMRO', '1075', '963605', '43', '35966');
INSERT INTO public.who_global_data_import VALUES (65936, '2020-12-03', 'PE', 'Peru', 'AMRO', '1623', '965228', '65', '36031');
INSERT INTO public.who_global_data_import VALUES (65937, '2020-12-04', 'PE', 'Peru', 'AMRO', '1847', '967075', '45', '36076');
INSERT INTO public.who_global_data_import VALUES (65938, '2020-12-05', 'PE', 'Peru', 'AMRO', '1771', '968846', '28', '36104');
INSERT INTO public.who_global_data_import VALUES (65939, '2020-12-06', 'PE', 'Peru', 'AMRO', '2014', '970860', '91', '36195');
INSERT INTO public.who_global_data_import VALUES (65940, '2020-12-07', 'PE', 'Peru', 'AMRO', '1828', '972688', '36', '36231');
INSERT INTO public.who_global_data_import VALUES (65941, '2020-12-08', 'PE', 'Peru', 'AMRO', '1224', '973912', '43', '36274');
INSERT INTO public.who_global_data_import VALUES (65942, '2020-12-09', 'PE', 'Peru', 'AMRO', '1204', '975116', '50', '36324');
INSERT INTO public.who_global_data_import VALUES (65943, '2020-12-10', 'PE', 'Peru', 'AMRO', '1505', '976621', '77', '36401');
INSERT INTO public.who_global_data_import VALUES (65944, '2020-12-11', 'PE', 'Peru', 'AMRO', '691', '977312', '54', '36455');
INSERT INTO public.who_global_data_import VALUES (65945, '2020-12-12', 'PE', 'Peru', 'AMRO', '1799', '979111', '44', '36499');
INSERT INTO public.who_global_data_import VALUES (65946, '2020-12-13', 'PE', 'Peru', 'AMRO', '1832', '980943', '45', '36544');
INSERT INTO public.who_global_data_import VALUES (65947, '2020-12-14', 'PE', 'Peru', 'AMRO', '2102', '983045', '65', '36609');
INSERT INTO public.who_global_data_import VALUES (65948, '2020-12-15', 'PE', 'Peru', 'AMRO', '1928', '984973', '68', '36677');
INSERT INTO public.who_global_data_import VALUES (65949, '2020-12-16', 'PE', 'Peru', 'AMRO', '1157', '986130', '77', '36754');
INSERT INTO public.who_global_data_import VALUES (65950, '2020-12-17', 'PE', 'Peru', 'AMRO', '1545', '987675', '63', '36817');
INSERT INTO public.who_global_data_import VALUES (65951, '2020-12-18', 'PE', 'Peru', 'AMRO', '1782', '989457', '41', '36858');
INSERT INTO public.who_global_data_import VALUES (65952, '2020-12-19', 'PE', 'Peru', 'AMRO', '2061', '991518', '43', '36901');
INSERT INTO public.who_global_data_import VALUES (65953, '2020-12-20', 'PE', 'Peru', 'AMRO', '2242', '993760', '68', '36969');
INSERT INTO public.who_global_data_import VALUES (65954, '2020-12-21', 'PE', 'Peru', 'AMRO', '2139', '995899', '65', '37034');
INSERT INTO public.who_global_data_import VALUES (65955, '2020-12-22', 'PE', 'Peru', 'AMRO', '1618', '997517', '69', '37103');
INSERT INTO public.who_global_data_import VALUES (65956, '2020-12-23', 'PE', 'Peru', 'AMRO', '958', '998475', '70', '37173');
INSERT INTO public.who_global_data_import VALUES (65957, '2020-12-24', 'PE', 'Peru', 'AMRO', '1678', '1000153', '45', '37218');
INSERT INTO public.who_global_data_import VALUES (65958, '2020-12-25', 'PE', 'Peru', 'AMRO', '3829', '1003982', '99', '37317');
INSERT INTO public.who_global_data_import VALUES (65959, '2020-12-26', 'PE', 'Peru', 'AMRO', '0', '1003982', '0', '37317');
INSERT INTO public.who_global_data_import VALUES (65960, '2020-12-27', 'PE', 'Peru', 'AMRO', '1564', '1005546', '51', '37368');
INSERT INTO public.who_global_data_import VALUES (65961, '2020-12-28', 'PE', 'Peru', 'AMRO', '772', '1006318', '46', '37414');
INSERT INTO public.who_global_data_import VALUES (65962, '2020-12-29', 'PE', 'Peru', 'AMRO', '1339', '1007657', '60', '37474');
INSERT INTO public.who_global_data_import VALUES (65963, '2020-12-30', 'PE', 'Peru', 'AMRO', '1251', '1008908', '51', '37525');
INSERT INTO public.who_global_data_import VALUES (65964, '2020-12-31', 'PE', 'Peru', 'AMRO', '1588', '1010496', '49', '37574');
INSERT INTO public.who_global_data_import VALUES (65965, '2021-01-01', 'PE', 'Peru', 'AMRO', '2118', '1012614', '47', '37621');
INSERT INTO public.who_global_data_import VALUES (65966, '2021-01-02', 'PE', 'Peru', 'AMRO', '2523', '1015137', '59', '37680');
INSERT INTO public.who_global_data_import VALUES (65967, '2021-01-03', 'PE', 'Peru', 'AMRO', '2062', '1017199', '44', '37724');
INSERT INTO public.who_global_data_import VALUES (65968, '2021-01-04', 'PE', 'Peru', 'AMRO', '900', '1018099', '49', '37773');
INSERT INTO public.who_global_data_import VALUES (65969, '2021-01-05', 'PE', 'Peru', 'AMRO', '1376', '1019475', '57', '37830');
INSERT INTO public.who_global_data_import VALUES (65970, '2021-01-06', 'PE', 'Peru', 'AMRO', '1583', '1021058', '43', '37873');
INSERT INTO public.who_global_data_import VALUES (65971, '2021-01-07', 'PE', 'Peru', 'AMRO', '960', '1022018', '52', '37925');
INSERT INTO public.who_global_data_import VALUES (65972, '2021-01-08', 'PE', 'Peru', 'AMRO', '2414', '1024432', '66', '37991');
INSERT INTO public.who_global_data_import VALUES (65973, '2021-01-09', 'PE', 'Peru', 'AMRO', '2258', '1026690', '58', '38049');
INSERT INTO public.who_global_data_import VALUES (65974, '2021-01-10', 'PE', 'Peru', 'AMRO', '2781', '1029471', '96', '38145');
INSERT INTO public.who_global_data_import VALUES (65975, '2021-01-11', 'PE', 'Peru', 'AMRO', '2804', '1032275', '68', '38213');
INSERT INTO public.who_global_data_import VALUES (65976, '2021-01-12', 'PE', 'Peru', 'AMRO', '2909', '1035184', '67', '38280');
INSERT INTO public.who_global_data_import VALUES (65977, '2021-01-13', 'PE', 'Peru', 'AMRO', '2166', '1037350', '55', '38335');
INSERT INTO public.who_global_data_import VALUES (65978, '2021-01-14', 'PE', 'Peru', 'AMRO', '2881', '1040231', '4', '38339');
INSERT INTO public.who_global_data_import VALUES (65979, '2021-01-15', 'PE', 'Peru', 'AMRO', '3409', '1043640', '134', '38473');
INSERT INTO public.who_global_data_import VALUES (65980, '2021-01-16', 'PE', 'Peru', 'AMRO', '5022', '1048662', '91', '38564');
INSERT INTO public.who_global_data_import VALUES (65981, '2021-01-17', 'PE', 'Peru', 'AMRO', '7361', '1056023', '90', '38654');
INSERT INTO public.who_global_data_import VALUES (65982, '2021-01-18', 'PE', 'Peru', 'AMRO', '4544', '1060567', '116', '38770');
INSERT INTO public.who_global_data_import VALUES (65983, '2021-01-19', 'PE', 'Peru', 'AMRO', '4342', '1064909', '101', '38871');
INSERT INTO public.who_global_data_import VALUES (65984, '2021-01-20', 'PE', 'Peru', 'AMRO', '3893', '1068802', '60', '38931');
INSERT INTO public.who_global_data_import VALUES (65985, '2021-01-21', 'PE', 'Peru', 'AMRO', '4412', '1073214', '113', '39044');
INSERT INTO public.who_global_data_import VALUES (65986, '2021-01-22', 'PE', 'Peru', 'AMRO', '5461', '1078675', '113', '39157');
INSERT INTO public.who_global_data_import VALUES (65987, '2021-01-23', 'PE', 'Peru', 'AMRO', '4232', '1082907', '117', '39274');
INSERT INTO public.who_global_data_import VALUES (65988, '2021-01-24', 'PE', 'Peru', 'AMRO', '5189', '1088096', '153', '39427');
INSERT INTO public.who_global_data_import VALUES (65989, '2021-01-25', 'PE', 'Peru', 'AMRO', '5842', '1093938', '181', '39608');
INSERT INTO public.who_global_data_import VALUES (65990, '2021-01-26', 'PE', 'Peru', 'AMRO', '5075', '1099013', '169', '39777');
INSERT INTO public.who_global_data_import VALUES (65991, '2021-01-27', 'PE', 'Peru', 'AMRO', '3782', '1102795', '110', '39887');
INSERT INTO public.who_global_data_import VALUES (65992, '2021-01-28', 'PE', 'Peru', 'AMRO', '4444', '1107239', '220', '40107');
INSERT INTO public.who_global_data_import VALUES (65993, '2021-01-29', 'PE', 'Peru', 'AMRO', '6731', '1113970', '165', '40272');
INSERT INTO public.who_global_data_import VALUES (65994, '2021-01-30', 'PE', 'Peru', 'AMRO', '5715', '1119685', '212', '40484');
INSERT INTO public.who_global_data_import VALUES (65995, '2021-01-31', 'PE', 'Peru', 'AMRO', '6190', '1125875', '202', '40686');
INSERT INTO public.who_global_data_import VALUES (65996, '2021-02-01', 'PE', 'Peru', 'AMRO', '7147', '1133022', '171', '40857');
INSERT INTO public.who_global_data_import VALUES (65997, '2021-02-02', 'PE', 'Peru', 'AMRO', '5217', '1138239', '169', '41026');
INSERT INTO public.who_global_data_import VALUES (65998, '2021-02-03', 'PE', 'Peru', 'AMRO', '4477', '1142716', '155', '41181');
INSERT INTO public.who_global_data_import VALUES (65999, '2021-02-04', 'PE', 'Peru', 'AMRO', '7048', '1149764', '173', '41354');
INSERT INTO public.who_global_data_import VALUES (66000, '2021-02-05', 'PE', 'Peru', 'AMRO', '8573', '1158337', '184', '41538');
INSERT INTO public.who_global_data_import VALUES (66001, '2020-01-03', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66002, '2020-01-04', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66003, '2020-01-05', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66004, '2020-01-06', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66005, '2020-01-07', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66006, '2020-01-08', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66007, '2020-01-09', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66008, '2020-01-10', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66009, '2020-01-11', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66010, '2020-01-12', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66011, '2020-01-13', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66012, '2020-01-14', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66013, '2020-01-15', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66014, '2020-01-16', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66015, '2020-01-17', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66016, '2020-01-18', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66017, '2020-01-19', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66018, '2020-01-20', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66019, '2020-01-21', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66020, '2020-01-22', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66021, '2020-01-23', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66022, '2020-01-24', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66023, '2020-01-25', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66024, '2020-01-26', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66025, '2020-01-27', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66026, '2020-01-28', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66027, '2020-01-29', 'PH', 'Philippines', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66028, '2020-01-30', 'PH', 'Philippines', 'WPRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66029, '2020-01-31', 'PH', 'Philippines', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66030, '2020-02-01', 'PH', 'Philippines', 'WPRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66031, '2020-02-02', 'PH', 'Philippines', 'WPRO', '0', '6', '1', '1');
INSERT INTO public.who_global_data_import VALUES (66032, '2020-02-03', 'PH', 'Philippines', 'WPRO', '0', '6', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66033, '2020-02-04', 'PH', 'Philippines', 'WPRO', '1', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66034, '2020-02-05', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66035, '2020-02-06', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66036, '2020-02-07', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66037, '2020-02-08', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66038, '2020-02-09', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66039, '2020-02-10', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66040, '2020-02-11', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66041, '2020-02-12', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66042, '2020-02-13', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66043, '2020-02-14', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66044, '2020-02-15', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66045, '2020-02-16', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66046, '2020-02-17', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66047, '2020-02-18', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66048, '2020-02-19', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66049, '2020-02-20', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66050, '2020-02-21', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66051, '2020-02-22', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66052, '2020-02-23', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66053, '2020-02-24', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66054, '2020-02-25', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66055, '2020-02-26', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66056, '2020-02-27', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66057, '2020-02-28', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66058, '2020-02-29', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66059, '2020-03-01', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66060, '2020-03-02', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66061, '2020-03-03', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66062, '2020-03-04', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66063, '2020-03-05', 'PH', 'Philippines', 'WPRO', '0', '7', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66064, '2020-03-06', 'PH', 'Philippines', 'WPRO', '2', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66065, '2020-03-07', 'PH', 'Philippines', 'WPRO', '1', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66066, '2020-03-08', 'PH', 'Philippines', 'WPRO', '4', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66067, '2020-03-09', 'PH', 'Philippines', 'WPRO', '14', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66068, '2020-03-10', 'PH', 'Philippines', 'WPRO', '9', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66069, '2020-03-11', 'PH', 'Philippines', 'WPRO', '16', '53', '0', '1');
INSERT INTO public.who_global_data_import VALUES (66070, '2020-03-12', 'PH', 'Philippines', 'WPRO', '3', '56', '1', '2');
INSERT INTO public.who_global_data_import VALUES (66071, '2020-03-13', 'PH', 'Philippines', 'WPRO', '0', '56', '0', '2');
INSERT INTO public.who_global_data_import VALUES (66072, '2020-03-14', 'PH', 'Philippines', 'WPRO', '12', '68', '0', '2');
INSERT INTO public.who_global_data_import VALUES (66073, '2020-03-15', 'PH', 'Philippines', 'WPRO', '76', '144', '10', '12');
INSERT INTO public.who_global_data_import VALUES (66074, '2020-03-16', 'PH', 'Philippines', 'WPRO', '2', '146', '0', '12');
INSERT INTO public.who_global_data_import VALUES (66075, '2020-03-17', 'PH', 'Philippines', 'WPRO', '45', '191', '0', '12');
INSERT INTO public.who_global_data_import VALUES (66076, '2020-03-18', 'PH', 'Philippines', 'WPRO', '0', '191', '2', '14');
INSERT INTO public.who_global_data_import VALUES (66077, '2020-03-19', 'PH', 'Philippines', 'WPRO', '26', '217', '3', '17');
INSERT INTO public.who_global_data_import VALUES (66078, '2020-03-20', 'PH', 'Philippines', 'WPRO', '13', '230', '1', '18');
INSERT INTO public.who_global_data_import VALUES (66079, '2020-03-21', 'PH', 'Philippines', 'WPRO', '77', '307', '1', '19');
INSERT INTO public.who_global_data_import VALUES (66080, '2020-03-22', 'PH', 'Philippines', 'WPRO', '73', '380', '6', '25');
INSERT INTO public.who_global_data_import VALUES (66081, '2020-03-23', 'PH', 'Philippines', 'WPRO', '16', '396', '8', '33');
INSERT INTO public.who_global_data_import VALUES (66082, '2020-03-24', 'PH', 'Philippines', 'WPRO', '66', '462', '0', '33');
INSERT INTO public.who_global_data_import VALUES (66083, '2020-03-25', 'PH', 'Philippines', 'WPRO', '174', '636', '5', '38');
INSERT INTO public.who_global_data_import VALUES (66084, '2020-03-26', 'PH', 'Philippines', 'WPRO', '71', '707', '7', '45');
INSERT INTO public.who_global_data_import VALUES (66085, '2020-03-27', 'PH', 'Philippines', 'WPRO', '0', '707', '0', '45');
INSERT INTO public.who_global_data_import VALUES (66086, '2020-03-28', 'PH', 'Philippines', 'WPRO', '368', '1075', '23', '68');
INSERT INTO public.who_global_data_import VALUES (66087, '2020-03-29', 'PH', 'Philippines', 'WPRO', '0', '1075', '0', '68');
INSERT INTO public.who_global_data_import VALUES (66088, '2020-03-30', 'PH', 'Philippines', 'WPRO', '471', '1546', '10', '78');
INSERT INTO public.who_global_data_import VALUES (66089, '2020-03-31', 'PH', 'Philippines', 'WPRO', '0', '1546', '0', '78');
INSERT INTO public.who_global_data_import VALUES (66090, '2020-04-01', 'PH', 'Philippines', 'WPRO', '765', '2311', '18', '96');
INSERT INTO public.who_global_data_import VALUES (66091, '2020-04-02', 'PH', 'Philippines', 'WPRO', '0', '2311', '0', '96');
INSERT INTO public.who_global_data_import VALUES (66092, '2020-04-03', 'PH', 'Philippines', 'WPRO', '322', '2633', '11', '107');
INSERT INTO public.who_global_data_import VALUES (66093, '2020-04-04', 'PH', 'Philippines', 'WPRO', '385', '3018', '29', '136');
INSERT INTO public.who_global_data_import VALUES (66094, '2020-04-05', 'PH', 'Philippines', 'WPRO', '76', '3094', '8', '144');
INSERT INTO public.who_global_data_import VALUES (66095, '2020-04-06', 'PH', 'Philippines', 'WPRO', '152', '3246', '8', '152');
INSERT INTO public.who_global_data_import VALUES (66096, '2020-04-07', 'PH', 'Philippines', 'WPRO', '414', '3660', '11', '163');
INSERT INTO public.who_global_data_import VALUES (66097, '2020-04-08', 'PH', 'Philippines', 'WPRO', '210', '3870', '19', '182');
INSERT INTO public.who_global_data_import VALUES (66098, '2020-04-09', 'PH', 'Philippines', 'WPRO', '206', '4076', '21', '203');
INSERT INTO public.who_global_data_import VALUES (66099, '2020-04-10', 'PH', 'Philippines', 'WPRO', '0', '4076', '0', '203');
INSERT INTO public.who_global_data_import VALUES (66100, '2020-04-11', 'PH', 'Philippines', 'WPRO', '352', '4428', '44', '247');
INSERT INTO public.who_global_data_import VALUES (66101, '2020-04-12', 'PH', 'Philippines', 'WPRO', '220', '4648', '50', '297');
INSERT INTO public.who_global_data_import VALUES (66102, '2020-04-13', 'PH', 'Philippines', 'WPRO', '284', '4932', '18', '315');
INSERT INTO public.who_global_data_import VALUES (66103, '2020-04-14', 'PH', 'Philippines', 'WPRO', '291', '5223', '20', '335');
INSERT INTO public.who_global_data_import VALUES (66104, '2020-04-15', 'PH', 'Philippines', 'WPRO', '0', '5223', '0', '335');
INSERT INTO public.who_global_data_import VALUES (66105, '2020-04-16', 'PH', 'Philippines', 'WPRO', '437', '5660', '27', '362');
INSERT INTO public.who_global_data_import VALUES (66106, '2020-04-17', 'PH', 'Philippines', 'WPRO', '0', '5660', '0', '362');
INSERT INTO public.who_global_data_import VALUES (66107, '2020-04-18', 'PH', 'Philippines', 'WPRO', '218', '5878', '25', '387');
INSERT INTO public.who_global_data_import VALUES (66108, '2020-04-19', 'PH', 'Philippines', 'WPRO', '209', '6087', '10', '397');
INSERT INTO public.who_global_data_import VALUES (66109, '2020-04-20', 'PH', 'Philippines', 'WPRO', '172', '6259', '12', '409');
INSERT INTO public.who_global_data_import VALUES (66110, '2020-04-21', 'PH', 'Philippines', 'WPRO', '200', '6459', '19', '428');
INSERT INTO public.who_global_data_import VALUES (66111, '2020-04-22', 'PH', 'Philippines', 'WPRO', '140', '6599', '9', '437');
INSERT INTO public.who_global_data_import VALUES (66112, '2020-04-23', 'PH', 'Philippines', 'WPRO', '111', '6710', '9', '446');
INSERT INTO public.who_global_data_import VALUES (66113, '2020-04-24', 'PH', 'Philippines', 'WPRO', '271', '6981', '16', '462');
INSERT INTO public.who_global_data_import VALUES (66114, '2020-04-25', 'PH', 'Philippines', 'WPRO', '211', '7192', '15', '477');
INSERT INTO public.who_global_data_import VALUES (66115, '2020-04-26', 'PH', 'Philippines', 'WPRO', '102', '7294', '17', '494');
INSERT INTO public.who_global_data_import VALUES (66116, '2020-04-27', 'PH', 'Philippines', 'WPRO', '285', '7579', '7', '501');
INSERT INTO public.who_global_data_import VALUES (66117, '2020-04-28', 'PH', 'Philippines', 'WPRO', '198', '7777', '10', '511');
INSERT INTO public.who_global_data_import VALUES (66118, '2020-04-29', 'PH', 'Philippines', 'WPRO', '181', '7958', '19', '530');
INSERT INTO public.who_global_data_import VALUES (66119, '2020-04-30', 'PH', 'Philippines', 'WPRO', '254', '8212', '28', '558');
INSERT INTO public.who_global_data_import VALUES (66120, '2020-05-01', 'PH', 'Philippines', 'WPRO', '276', '8488', '10', '568');
INSERT INTO public.who_global_data_import VALUES (66121, '2020-05-02', 'PH', 'Philippines', 'WPRO', '284', '8772', '11', '579');
INSERT INTO public.who_global_data_import VALUES (66122, '2020-05-03', 'PH', 'Philippines', 'WPRO', '156', '8928', '24', '603');
INSERT INTO public.who_global_data_import VALUES (66123, '2020-05-04', 'PH', 'Philippines', 'WPRO', '295', '9223', '4', '607');
INSERT INTO public.who_global_data_import VALUES (66124, '2020-05-05', 'PH', 'Philippines', 'WPRO', '262', '9485', '16', '623');
INSERT INTO public.who_global_data_import VALUES (66125, '2020-05-06', 'PH', 'Philippines', 'WPRO', '199', '9684', '14', '637');
INSERT INTO public.who_global_data_import VALUES (66126, '2020-05-07', 'PH', 'Philippines', 'WPRO', '320', '10004', '21', '658');
INSERT INTO public.who_global_data_import VALUES (66127, '2020-05-08', 'PH', 'Philippines', 'WPRO', '339', '10343', '27', '685');
INSERT INTO public.who_global_data_import VALUES (66128, '2020-05-09', 'PH', 'Philippines', 'WPRO', '120', '10463', '11', '696');
INSERT INTO public.who_global_data_import VALUES (66129, '2020-05-10', 'PH', 'Philippines', 'WPRO', '147', '10610', '8', '704');
INSERT INTO public.who_global_data_import VALUES (66130, '2020-05-11', 'PH', 'Philippines', 'WPRO', '184', '10794', '15', '719');
INSERT INTO public.who_global_data_import VALUES (66131, '2020-05-12', 'PH', 'Philippines', 'WPRO', '292', '11086', '7', '726');
INSERT INTO public.who_global_data_import VALUES (66132, '2020-05-13', 'PH', 'Philippines', 'WPRO', '264', '11350', '25', '751');
INSERT INTO public.who_global_data_import VALUES (66133, '2020-05-14', 'PH', 'Philippines', 'WPRO', '268', '11618', '21', '772');
INSERT INTO public.who_global_data_import VALUES (66134, '2020-05-15', 'PH', 'Philippines', 'WPRO', '258', '11876', '18', '790');
INSERT INTO public.who_global_data_import VALUES (66135, '2020-05-16', 'PH', 'Philippines', 'WPRO', '429', '12305', '27', '817');
INSERT INTO public.who_global_data_import VALUES (66136, '2020-05-17', 'PH', 'Philippines', 'WPRO', '208', '12513', '7', '824');
INSERT INTO public.who_global_data_import VALUES (66137, '2020-05-18', 'PH', 'Philippines', 'WPRO', '205', '12718', '7', '831');
INSERT INTO public.who_global_data_import VALUES (66138, '2020-05-19', 'PH', 'Philippines', 'WPRO', '0', '12718', '0', '831');
INSERT INTO public.who_global_data_import VALUES (66139, '2020-05-20', 'PH', 'Philippines', 'WPRO', '224', '12942', '6', '837');
INSERT INTO public.who_global_data_import VALUES (66140, '2020-05-21', 'PH', 'Philippines', 'WPRO', '492', '13434', '9', '846');
INSERT INTO public.who_global_data_import VALUES (66141, '2020-05-22', 'PH', 'Philippines', 'WPRO', '163', '13597', '11', '857');
INSERT INTO public.who_global_data_import VALUES (66142, '2020-05-23', 'PH', 'Philippines', 'WPRO', '0', '13597', '0', '857');
INSERT INTO public.who_global_data_import VALUES (66143, '2020-05-24', 'PH', 'Philippines', 'WPRO', '180', '13777', '6', '863');
INSERT INTO public.who_global_data_import VALUES (66144, '2020-05-25', 'PH', 'Philippines', 'WPRO', '258', '14035', '5', '868');
INSERT INTO public.who_global_data_import VALUES (66145, '2020-05-26', 'PH', 'Philippines', 'WPRO', '284', '14319', '5', '873');
INSERT INTO public.who_global_data_import VALUES (66146, '2020-05-27', 'PH', 'Philippines', 'WPRO', '350', '14669', '13', '886');
INSERT INTO public.who_global_data_import VALUES (66147, '2020-05-28', 'PH', 'Philippines', 'WPRO', '380', '15049', '18', '904');
INSERT INTO public.who_global_data_import VALUES (66148, '2020-05-29', 'PH', 'Philippines', 'WPRO', '539', '15588', '17', '921');
INSERT INTO public.who_global_data_import VALUES (66149, '2020-05-30', 'PH', 'Philippines', 'WPRO', '1046', '16634', '21', '942');
INSERT INTO public.who_global_data_import VALUES (66150, '2020-05-31', 'PH', 'Philippines', 'WPRO', '1452', '18086', '15', '957');
INSERT INTO public.who_global_data_import VALUES (66151, '2020-06-01', 'PH', 'Philippines', 'WPRO', '0', '18086', '0', '957');
INSERT INTO public.who_global_data_import VALUES (66152, '2020-06-02', 'PH', 'Philippines', 'WPRO', '552', '18638', '3', '960');
INSERT INTO public.who_global_data_import VALUES (66153, '2020-06-03', 'PH', 'Philippines', 'WPRO', '359', '18997', '6', '966');
INSERT INTO public.who_global_data_import VALUES (66154, '2020-06-04', 'PH', 'Philippines', 'WPRO', '751', '19748', '8', '974');
INSERT INTO public.who_global_data_import VALUES (66155, '2020-06-05', 'PH', 'Philippines', 'WPRO', '634', '20382', '10', '984');
INSERT INTO public.who_global_data_import VALUES (66156, '2020-06-06', 'PH', 'Philippines', 'WPRO', '244', '20626', '3', '987');
INSERT INTO public.who_global_data_import VALUES (66157, '2020-06-07', 'PH', 'Philippines', 'WPRO', '714', '21340', '7', '994');
INSERT INTO public.who_global_data_import VALUES (66158, '2020-06-08', 'PH', 'Philippines', 'WPRO', '555', '21895', '9', '1003');
INSERT INTO public.who_global_data_import VALUES (66159, '2020-06-09', 'PH', 'Philippines', 'WPRO', '579', '22474', '8', '1011');
INSERT INTO public.who_global_data_import VALUES (66160, '2020-06-10', 'PH', 'Philippines', 'WPRO', '518', '22992', '6', '1017');
INSERT INTO public.who_global_data_import VALUES (66161, '2020-06-11', 'PH', 'Philippines', 'WPRO', '740', '23732', '10', '1027');
INSERT INTO public.who_global_data_import VALUES (66162, '2020-06-12', 'PH', 'Philippines', 'WPRO', '443', '24175', '9', '1036');
INSERT INTO public.who_global_data_import VALUES (66163, '2020-06-13', 'PH', 'Philippines', 'WPRO', '612', '24787', '16', '1052');
INSERT INTO public.who_global_data_import VALUES (66164, '2020-06-14', 'PH', 'Philippines', 'WPRO', '605', '25392', '22', '1074');
INSERT INTO public.who_global_data_import VALUES (66165, '2020-06-15', 'PH', 'Philippines', 'WPRO', '538', '25930', '14', '1088');
INSERT INTO public.who_global_data_import VALUES (66166, '2020-06-16', 'PH', 'Philippines', 'WPRO', '490', '26420', '10', '1098');
INSERT INTO public.who_global_data_import VALUES (66167, '2020-06-17', 'PH', 'Philippines', 'WPRO', '361', '26781', '5', '1103');
INSERT INTO public.who_global_data_import VALUES (66168, '2020-06-18', 'PH', 'Philippines', 'WPRO', '457', '27238', '5', '1108');
INSERT INTO public.who_global_data_import VALUES (66169, '2020-06-19', 'PH', 'Philippines', 'WPRO', '561', '27799', '8', '1116');
INSERT INTO public.who_global_data_import VALUES (66170, '2020-06-20', 'PH', 'Philippines', 'WPRO', '660', '28459', '14', '1130');
INSERT INTO public.who_global_data_import VALUES (66171, '2020-06-21', 'PH', 'Philippines', 'WPRO', '941', '29400', '20', '1150');
INSERT INTO public.who_global_data_import VALUES (66172, '2020-06-22', 'PH', 'Philippines', 'WPRO', '652', '30052', '19', '1169');
INSERT INTO public.who_global_data_import VALUES (66173, '2020-06-23', 'PH', 'Philippines', 'WPRO', '630', '30682', '8', '1177');
INSERT INTO public.who_global_data_import VALUES (66174, '2020-06-24', 'PH', 'Philippines', 'WPRO', '1143', '31825', '9', '1186');
INSERT INTO public.who_global_data_import VALUES (66175, '2020-06-25', 'PH', 'Philippines', 'WPRO', '470', '32295', '18', '1204');
INSERT INTO public.who_global_data_import VALUES (66176, '2020-06-26', 'PH', 'Philippines', 'WPRO', '774', '33069', '8', '1212');
INSERT INTO public.who_global_data_import VALUES (66177, '2020-06-27', 'PH', 'Philippines', 'WPRO', '1004', '34073', '12', '1224');
INSERT INTO public.who_global_data_import VALUES (66178, '2020-06-28', 'PH', 'Philippines', 'WPRO', '730', '34803', '12', '1236');
INSERT INTO public.who_global_data_import VALUES (66179, '2020-06-29', 'PH', 'Philippines', 'WPRO', '652', '35455', '8', '1244');
INSERT INTO public.who_global_data_import VALUES (66180, '2020-06-30', 'PH', 'Philippines', 'WPRO', '983', '36438', '11', '1255');
INSERT INTO public.who_global_data_import VALUES (66181, '2020-07-01', 'PH', 'Philippines', 'WPRO', '1076', '37514', '11', '1266');
INSERT INTO public.who_global_data_import VALUES (66182, '2020-07-02', 'PH', 'Philippines', 'WPRO', '997', '38511', '4', '1270');
INSERT INTO public.who_global_data_import VALUES (66183, '2020-07-03', 'PH', 'Philippines', 'WPRO', '294', '38805', '4', '1274');
INSERT INTO public.who_global_data_import VALUES (66184, '2020-07-04', 'PH', 'Philippines', 'WPRO', '1531', '40336', '6', '1280');
INSERT INTO public.who_global_data_import VALUES (66185, '2020-07-05', 'PH', 'Philippines', 'WPRO', '1494', '41830', '10', '1290');
INSERT INTO public.who_global_data_import VALUES (66186, '2020-07-06', 'PH', 'Philippines', 'WPRO', '2424', '44254', '7', '1297');
INSERT INTO public.who_global_data_import VALUES (66187, '2020-07-07', 'PH', 'Philippines', 'WPRO', '2079', '46333', '6', '1303');
INSERT INTO public.who_global_data_import VALUES (66188, '2020-07-08', 'PH', 'Philippines', 'WPRO', '1540', '47873', '6', '1309');
INSERT INTO public.who_global_data_import VALUES (66189, '2020-07-09', 'PH', 'Philippines', 'WPRO', '2486', '50359', '5', '1314');
INSERT INTO public.who_global_data_import VALUES (66190, '2020-07-10', 'PH', 'Philippines', 'WPRO', '1395', '51754', '4', '1318');
INSERT INTO public.who_global_data_import VALUES (66191, '2020-07-11', 'PH', 'Philippines', 'WPRO', '1160', '52914', '42', '1360');
INSERT INTO public.who_global_data_import VALUES (66192, '2020-07-12', 'PH', 'Philippines', 'WPRO', '1308', '54222', '12', '1372');
INSERT INTO public.who_global_data_import VALUES (66193, '2020-07-13', 'PH', 'Philippines', 'WPRO', '2037', '56259', '162', '1534');
INSERT INTO public.who_global_data_import VALUES (66194, '2020-07-14', 'PH', 'Philippines', 'WPRO', '747', '57006', '65', '1599');
INSERT INTO public.who_global_data_import VALUES (66195, '2020-07-15', 'PH', 'Philippines', 'WPRO', '539', '57545', '4', '1603');
INSERT INTO public.who_global_data_import VALUES (66196, '2020-07-16', 'PH', 'Philippines', 'WPRO', '1305', '58850', '11', '1614');
INSERT INTO public.who_global_data_import VALUES (66197, '2020-07-17', 'PH', 'Philippines', 'WPRO', '2416', '61266', '29', '1643');
INSERT INTO public.who_global_data_import VALUES (66198, '2020-07-18', 'PH', 'Philippines', 'WPRO', '1735', '63001', '17', '1660');
INSERT INTO public.who_global_data_import VALUES (66199, '2020-07-19', 'PH', 'Philippines', 'WPRO', '2303', '65304', '113', '1773');
INSERT INTO public.who_global_data_import VALUES (66200, '2020-07-20', 'PH', 'Philippines', 'WPRO', '2152', '67456', '58', '1831');
INSERT INTO public.who_global_data_import VALUES (66201, '2020-07-21', 'PH', 'Philippines', 'WPRO', '1442', '68898', '4', '1835');
INSERT INTO public.who_global_data_import VALUES (66202, '2020-07-22', 'PH', 'Philippines', 'WPRO', '1866', '70764', '2', '1837');
INSERT INTO public.who_global_data_import VALUES (66203, '2020-07-23', 'PH', 'Philippines', 'WPRO', '1505', '72269', '6', '1843');
INSERT INTO public.who_global_data_import VALUES (66204, '2020-07-24', 'PH', 'Philippines', 'WPRO', '2121', '74390', '28', '1871');
INSERT INTO public.who_global_data_import VALUES (66205, '2020-07-25', 'PH', 'Philippines', 'WPRO', '2054', '76444', '8', '1879');
INSERT INTO public.who_global_data_import VALUES (66206, '2020-07-26', 'PH', 'Philippines', 'WPRO', '1968', '78412', '18', '1897');
INSERT INTO public.who_global_data_import VALUES (66207, '2020-07-27', 'PH', 'Philippines', 'WPRO', '2036', '80448', '35', '1932');
INSERT INTO public.who_global_data_import VALUES (66208, '2020-07-28', 'PH', 'Philippines', 'WPRO', '1592', '82040', '13', '1945');
INSERT INTO public.who_global_data_import VALUES (66209, '2020-07-29', 'PH', 'Philippines', 'WPRO', '1633', '83673', '2', '1947');
INSERT INTO public.who_global_data_import VALUES (66210, '2020-07-30', 'PH', 'Philippines', 'WPRO', '1813', '85486', '15', '1962');
INSERT INTO public.who_global_data_import VALUES (66211, '2020-07-31', 'PH', 'Philippines', 'WPRO', '3888', '89374', '21', '1983');
INSERT INTO public.who_global_data_import VALUES (66212, '2020-08-01', 'PH', 'Philippines', 'WPRO', '3980', '93354', '40', '2023');
INSERT INTO public.who_global_data_import VALUES (66213, '2020-08-02', 'PH', 'Philippines', 'WPRO', '4878', '98232', '16', '2039');
INSERT INTO public.who_global_data_import VALUES (66214, '2020-08-03', 'PH', 'Philippines', 'WPRO', '4953', '103185', '20', '2059');
INSERT INTO public.who_global_data_import VALUES (66215, '2020-08-04', 'PH', 'Philippines', 'WPRO', '3145', '106330', '45', '2104');
INSERT INTO public.who_global_data_import VALUES (66216, '2020-08-05', 'PH', 'Philippines', 'WPRO', '6263', '112593', '11', '2115');
INSERT INTO public.who_global_data_import VALUES (66217, '2020-08-06', 'PH', 'Philippines', 'WPRO', '3387', '115980', '8', '2123');
INSERT INTO public.who_global_data_import VALUES (66218, '2020-08-07', 'PH', 'Philippines', 'WPRO', '3480', '119460', '27', '2150');
INSERT INTO public.who_global_data_import VALUES (66219, '2020-08-08', 'PH', 'Philippines', 'WPRO', '3294', '122754', '18', '2168');
INSERT INTO public.who_global_data_import VALUES (66220, '2020-08-09', 'PH', 'Philippines', 'WPRO', '4131', '126885', '41', '2209');
INSERT INTO public.who_global_data_import VALUES (66221, '2020-08-10', 'PH', 'Philippines', 'WPRO', '3028', '129913', '61', '2270');
INSERT INTO public.who_global_data_import VALUES (66222, '2020-08-11', 'PH', 'Philippines', 'WPRO', '6725', '136638', '23', '2293');
INSERT INTO public.who_global_data_import VALUES (66223, '2020-08-12', 'PH', 'Philippines', 'WPRO', '2900', '139538', '19', '2312');
INSERT INTO public.who_global_data_import VALUES (66224, '2020-08-13', 'PH', 'Philippines', 'WPRO', '4211', '143749', '92', '2404');
INSERT INTO public.who_global_data_import VALUES (66225, '2020-08-14', 'PH', 'Philippines', 'WPRO', '3777', '147526', '22', '2426');
INSERT INTO public.who_global_data_import VALUES (66226, '2020-08-15', 'PH', 'Philippines', 'WPRO', '6134', '153660', '16', '2442');
INSERT INTO public.who_global_data_import VALUES (66227, '2020-08-16', 'PH', 'Philippines', 'WPRO', '4258', '157918', '158', '2600');
INSERT INTO public.who_global_data_import VALUES (66228, '2020-08-17', 'PH', 'Philippines', 'WPRO', '3335', '161253', '65', '2665');
INSERT INTO public.who_global_data_import VALUES (66229, '2020-08-18', 'PH', 'Philippines', 'WPRO', '3221', '164474', '16', '2681');
INSERT INTO public.who_global_data_import VALUES (66230, '2020-08-19', 'PH', 'Philippines', 'WPRO', '4739', '169213', '6', '2687');
INSERT INTO public.who_global_data_import VALUES (66231, '2020-08-20', 'PH', 'Philippines', 'WPRO', '4561', '173774', '108', '2795');
INSERT INTO public.who_global_data_import VALUES (66232, '2020-08-21', 'PH', 'Philippines', 'WPRO', '4248', '178022', '88', '2883');
INSERT INTO public.who_global_data_import VALUES (66233, '2020-08-22', 'PH', 'Philippines', 'WPRO', '4343', '182365', '57', '2940');
INSERT INTO public.who_global_data_import VALUES (66234, '2020-08-23', 'PH', 'Philippines', 'WPRO', '4884', '187249', '26', '2966');
INSERT INTO public.who_global_data_import VALUES (66235, '2020-08-24', 'PH', 'Philippines', 'WPRO', '2352', '189601', '32', '2998');
INSERT INTO public.who_global_data_import VALUES (66236, '2020-08-25', 'PH', 'Philippines', 'WPRO', '4651', '194252', '12', '3010');
INSERT INTO public.who_global_data_import VALUES (66237, '2020-08-26', 'PH', 'Philippines', 'WPRO', '2912', '197164', '28', '3038');
INSERT INTO public.who_global_data_import VALUES (66238, '2020-08-27', 'PH', 'Philippines', 'WPRO', '5197', '202361', '99', '3137');
INSERT INTO public.who_global_data_import VALUES (66239, '2020-08-28', 'PH', 'Philippines', 'WPRO', '3220', '205581', '97', '3234');
INSERT INTO public.who_global_data_import VALUES (66240, '2020-08-29', 'PH', 'Philippines', 'WPRO', '3963', '209544', '91', '3325');
INSERT INTO public.who_global_data_import VALUES (66241, '2020-08-30', 'PH', 'Philippines', 'WPRO', '3587', '213131', '94', '3419');
INSERT INTO public.who_global_data_import VALUES (66242, '2020-08-31', 'PH', 'Philippines', 'WPRO', '4265', '217396', '101', '3520');
INSERT INTO public.who_global_data_import VALUES (66243, '2020-09-01', 'PH', 'Philippines', 'WPRO', '3423', '220819', '38', '3558');
INSERT INTO public.who_global_data_import VALUES (66244, '2020-09-02', 'PH', 'Philippines', 'WPRO', '3445', '224264', '39', '3597');
INSERT INTO public.who_global_data_import VALUES (66245, '2020-09-03', 'PH', 'Philippines', 'WPRO', '2176', '226440', '26', '3623');
INSERT INTO public.who_global_data_import VALUES (66246, '2020-09-04', 'PH', 'Philippines', 'WPRO', '1963', '228403', '65', '3688');
INSERT INTO public.who_global_data_import VALUES (66247, '2020-09-05', 'PH', 'Philippines', 'WPRO', '3669', '232072', '49', '3737');
INSERT INTO public.who_global_data_import VALUES (66248, '2020-09-06', 'PH', 'Philippines', 'WPRO', '2498', '234570', '53', '3790');
INSERT INTO public.who_global_data_import VALUES (66249, '2020-09-07', 'PH', 'Philippines', 'WPRO', '2795', '237365', '85', '3875');
INSERT INTO public.who_global_data_import VALUES (66250, '2020-09-08', 'PH', 'Philippines', 'WPRO', '1362', '238727', '15', '3890');
INSERT INTO public.who_global_data_import VALUES (66251, '2020-09-09', 'PH', 'Philippines', 'WPRO', '3260', '241987', '26', '3916');
INSERT INTO public.who_global_data_import VALUES (66252, '2020-09-10', 'PH', 'Philippines', 'WPRO', '3156', '245143', '70', '3986');
INSERT INTO public.who_global_data_import VALUES (66253, '2020-09-11', 'PH', 'Philippines', 'WPRO', '3804', '248947', '80', '4066');
INSERT INTO public.who_global_data_import VALUES (66254, '2020-09-12', 'PH', 'Philippines', 'WPRO', '4017', '252964', '42', '4108');
INSERT INTO public.who_global_data_import VALUES (66255, '2020-09-13', 'PH', 'Philippines', 'WPRO', '4899', '257863', '184', '4292');
INSERT INTO public.who_global_data_import VALUES (66256, '2020-09-14', 'PH', 'Philippines', 'WPRO', '3353', '261216', '79', '4371');
INSERT INTO public.who_global_data_import VALUES (66257, '2020-09-15', 'PH', 'Philippines', 'WPRO', '4672', '265888', '259', '4630');
INSERT INTO public.who_global_data_import VALUES (66258, '2020-09-16', 'PH', 'Philippines', 'WPRO', '3519', '269407', '33', '4663');
INSERT INTO public.who_global_data_import VALUES (66259, '2020-09-17', 'PH', 'Philippines', 'WPRO', '3527', '272934', '69', '4732');
INSERT INTO public.who_global_data_import VALUES (66260, '2020-09-18', 'PH', 'Philippines', 'WPRO', '3355', '276289', '53', '4785');
INSERT INTO public.who_global_data_import VALUES (66261, '2020-09-19', 'PH', 'Philippines', 'WPRO', '3237', '279526', '45', '4830');
INSERT INTO public.who_global_data_import VALUES (66262, '2020-09-20', 'PH', 'Philippines', 'WPRO', '3934', '283460', '100', '4930');
INSERT INTO public.who_global_data_import VALUES (66263, '2020-09-21', 'PH', 'Philippines', 'WPRO', '3283', '286743', '54', '4984');
INSERT INTO public.who_global_data_import VALUES (66264, '2020-09-22', 'PH', 'Philippines', 'WPRO', '3447', '290190', '15', '4999');
INSERT INTO public.who_global_data_import VALUES (66265, '2020-09-23', 'PH', 'Philippines', 'WPRO', '1599', '291789', '50', '5049');
INSERT INTO public.who_global_data_import VALUES (66266, '2020-09-24', 'PH', 'Philippines', 'WPRO', '2802', '294591', '42', '5091');
INSERT INTO public.who_global_data_import VALUES (66267, '2020-09-25', 'PH', 'Philippines', 'WPRO', '2164', '296755', '36', '5127');
INSERT INTO public.who_global_data_import VALUES (66268, '2020-09-26', 'PH', 'Philippines', 'WPRO', '2606', '299361', '69', '5196');
INSERT INTO public.who_global_data_import VALUES (66269, '2020-09-27', 'PH', 'Philippines', 'WPRO', '1895', '301256', '88', '5284');
INSERT INTO public.who_global_data_import VALUES (66270, '2020-09-28', 'PH', 'Philippines', 'WPRO', '2970', '304226', '60', '5344');
INSERT INTO public.who_global_data_import VALUES (66271, '2020-09-29', 'PH', 'Philippines', 'WPRO', '3062', '307288', '37', '5381');
INSERT INTO public.who_global_data_import VALUES (66272, '2020-09-30', 'PH', 'Philippines', 'WPRO', '2015', '309303', '67', '5448');
INSERT INTO public.who_global_data_import VALUES (66273, '2020-10-01', 'PH', 'Philippines', 'WPRO', '2391', '311694', '56', '5504');
INSERT INTO public.who_global_data_import VALUES (66274, '2020-10-02', 'PH', 'Philippines', 'WPRO', '2385', '314079', '58', '5562');
INSERT INTO public.who_global_data_import VALUES (66275, '2020-10-03', 'PH', 'Philippines', 'WPRO', '2599', '316678', '54', '5616');
INSERT INTO public.who_global_data_import VALUES (66276, '2020-10-04', 'PH', 'Philippines', 'WPRO', '2652', '319330', '62', '5678');
INSERT INTO public.who_global_data_import VALUES (66277, '2020-10-05', 'PH', 'Philippines', 'WPRO', '3167', '322497', '98', '5776');
INSERT INTO public.who_global_data_import VALUES (66278, '2020-10-06', 'PH', 'Philippines', 'WPRO', '2265', '324762', '64', '5840');
INSERT INTO public.who_global_data_import VALUES (66279, '2020-10-07', 'PH', 'Philippines', 'WPRO', '2071', '326833', '25', '5865');
INSERT INTO public.who_global_data_import VALUES (66280, '2020-10-08', 'PH', 'Philippines', 'WPRO', '2804', '329637', '60', '5925');
INSERT INTO public.who_global_data_import VALUES (66281, '2020-10-09', 'PH', 'Philippines', 'WPRO', '2232', '331869', '144', '6069');
INSERT INTO public.who_global_data_import VALUES (66282, '2020-10-10', 'PH', 'Philippines', 'WPRO', '2901', '334770', '83', '6152');
INSERT INTO public.who_global_data_import VALUES (66283, '2020-10-11', 'PH', 'Philippines', 'WPRO', '2156', '336926', '86', '6238');
INSERT INTO public.who_global_data_import VALUES (66284, '2020-10-12', 'PH', 'Philippines', 'WPRO', '2415', '339341', '83', '6321');
INSERT INTO public.who_global_data_import VALUES (66285, '2020-10-13', 'PH', 'Philippines', 'WPRO', '3475', '342816', '11', '6332');
INSERT INTO public.who_global_data_import VALUES (66286, '2020-10-14', 'PH', 'Philippines', 'WPRO', '1897', '344713', '40', '6372');
INSERT INTO public.who_global_data_import VALUES (66287, '2020-10-15', 'PH', 'Philippines', 'WPRO', '1823', '346536', '77', '6449');
INSERT INTO public.who_global_data_import VALUES (66288, '2020-10-16', 'PH', 'Philippines', 'WPRO', '2162', '348698', '48', '6497');
INSERT INTO public.who_global_data_import VALUES (66289, '2020-10-17', 'PH', 'Philippines', 'WPRO', '3052', '351750', '34', '6531');
INSERT INTO public.who_global_data_import VALUES (66290, '2020-10-18', 'PH', 'Philippines', 'WPRO', '2588', '354338', '72', '6603');
INSERT INTO public.who_global_data_import VALUES (66291, '2020-10-19', 'PH', 'Philippines', 'WPRO', '2280', '356618', '49', '6652');
INSERT INTO public.who_global_data_import VALUES (66292, '2020-10-20', 'PH', 'Philippines', 'WPRO', '2551', '359169', '23', '6675');
INSERT INTO public.who_global_data_import VALUES (66293, '2020-10-21', 'PH', 'Philippines', 'WPRO', '1606', '360775', '15', '6690');
INSERT INTO public.who_global_data_import VALUES (66294, '2020-10-22', 'PH', 'Philippines', 'WPRO', '1468', '362243', '57', '6747');
INSERT INTO public.who_global_data_import VALUES (66295, '2020-10-23', 'PH', 'Philippines', 'WPRO', '1645', '363888', '36', '6783');
INSERT INTO public.who_global_data_import VALUES (66296, '2020-10-24', 'PH', 'Philippines', 'WPRO', '1911', '365799', '132', '6915');
INSERT INTO public.who_global_data_import VALUES (66297, '2020-10-25', 'PH', 'Philippines', 'WPRO', '2020', '367819', '19', '6934');
INSERT INTO public.who_global_data_import VALUES (66298, '2020-10-26', 'PH', 'Philippines', 'WPRO', '2209', '370028', '43', '6977');
INSERT INTO public.who_global_data_import VALUES (66299, '2020-10-27', 'PH', 'Philippines', 'WPRO', '1602', '371630', '62', '7039');
INSERT INTO public.who_global_data_import VALUES (66300, '2020-10-28', 'PH', 'Philippines', 'WPRO', '1514', '373144', '14', '7053');
INSERT INTO public.who_global_data_import VALUES (66301, '2020-10-29', 'PH', 'Philippines', 'WPRO', '2036', '375180', '61', '7114');
INSERT INTO public.who_global_data_import VALUES (66302, '2020-10-30', 'PH', 'Philippines', 'WPRO', '1755', '376935', '33', '7147');
INSERT INTO public.who_global_data_import VALUES (66303, '2020-10-31', 'PH', 'Philippines', 'WPRO', '1998', '378933', '38', '7185');
INSERT INTO public.who_global_data_import VALUES (66304, '2020-11-01', 'PH', 'Philippines', 'WPRO', '1796', '380729', '36', '7221');
INSERT INTO public.who_global_data_import VALUES (66305, '2020-11-02', 'PH', 'Philippines', 'WPRO', '2384', '383113', '17', '7238');
INSERT INTO public.who_global_data_import VALUES (66306, '2020-11-03', 'PH', 'Philippines', 'WPRO', '2287', '385400', '31', '7269');
INSERT INTO public.who_global_data_import VALUES (66307, '2020-11-04', 'PH', 'Philippines', 'WPRO', '1761', '387161', '49', '7318');
INSERT INTO public.who_global_data_import VALUES (66308, '2020-11-05', 'PH', 'Philippines', 'WPRO', '976', '388137', '49', '7367');
INSERT INTO public.who_global_data_import VALUES (66309, '2020-11-06', 'PH', 'Philippines', 'WPRO', '1588', '389725', '42', '7409');
INSERT INTO public.who_global_data_import VALUES (66310, '2020-11-07', 'PH', 'Philippines', 'WPRO', '2084', '391809', '52', '7461');
INSERT INTO public.who_global_data_import VALUES (66311, '2020-11-08', 'PH', 'Philippines', 'WPRO', '2152', '393961', '24', '7485');
INSERT INTO public.who_global_data_import VALUES (66312, '2020-11-09', 'PH', 'Philippines', 'WPRO', '2434', '396395', '54', '7539');
INSERT INTO public.who_global_data_import VALUES (66313, '2020-11-10', 'PH', 'Philippines', 'WPRO', '2054', '398449', '108', '7647');
INSERT INTO public.who_global_data_import VALUES (66314, '2020-11-11', 'PH', 'Philippines', 'WPRO', '1300', '399749', '14', '7661');
INSERT INTO public.who_global_data_import VALUES (66315, '2020-11-12', 'PH', 'Philippines', 'WPRO', '1667', '401416', '49', '7710');
INSERT INTO public.who_global_data_import VALUES (66316, '2020-11-13', 'PH', 'Philippines', 'WPRO', '1404', '402820', '11', '7721');
INSERT INTO public.who_global_data_import VALUES (66317, '2020-11-14', 'PH', 'Philippines', 'WPRO', '1893', '404713', '31', '7752');
INSERT INTO public.who_global_data_import VALUES (66318, '2020-11-15', 'PH', 'Philippines', 'WPRO', '1624', '406337', '39', '7791');
INSERT INTO public.who_global_data_import VALUES (66319, '2020-11-16', 'PH', 'Philippines', 'WPRO', '1501', '407838', '41', '7832');
INSERT INTO public.who_global_data_import VALUES (66320, '2020-11-17', 'PH', 'Philippines', 'WPRO', '1736', '409574', '7', '7839');
INSERT INTO public.who_global_data_import VALUES (66321, '2020-11-18', 'PH', 'Philippines', 'WPRO', '1144', '410718', '23', '7862');
INSERT INTO public.who_global_data_import VALUES (66322, '2020-11-19', 'PH', 'Philippines', 'WPRO', '1379', '412097', '95', '7957');
INSERT INTO public.who_global_data_import VALUES (66323, '2020-11-20', 'PH', 'Philippines', 'WPRO', '1333', '413430', '41', '7998');
INSERT INTO public.who_global_data_import VALUES (66324, '2020-11-21', 'PH', 'Philippines', 'WPRO', '1637', '415067', '27', '8025');
INSERT INTO public.who_global_data_import VALUES (66325, '2020-11-22', 'PH', 'Philippines', 'WPRO', '1785', '416852', '55', '8080');
INSERT INTO public.who_global_data_import VALUES (66326, '2020-11-23', 'PH', 'Philippines', 'WPRO', '1966', '418818', '43', '8123');
INSERT INTO public.who_global_data_import VALUES (66327, '2020-11-24', 'PH', 'Philippines', 'WPRO', '1796', '420614', '50', '8173');
INSERT INTO public.who_global_data_import VALUES (66328, '2020-11-25', 'PH', 'Philippines', 'WPRO', '1108', '421722', '12', '8185');
INSERT INTO public.who_global_data_import VALUES (66329, '2020-11-26', 'PH', 'Philippines', 'WPRO', '1193', '422915', '30', '8215');
INSERT INTO public.who_global_data_import VALUES (66330, '2020-11-27', 'PH', 'Philippines', 'WPRO', '1382', '424297', '27', '8242');
INSERT INTO public.who_global_data_import VALUES (66331, '2020-11-28', 'PH', 'Philippines', 'WPRO', '1621', '425918', '13', '8255');
INSERT INTO public.who_global_data_import VALUES (66332, '2020-11-29', 'PH', 'Philippines', 'WPRO', '1879', '427797', '78', '8333');
INSERT INTO public.who_global_data_import VALUES (66333, '2020-11-30', 'PH', 'Philippines', 'WPRO', '2067', '429864', '40', '8373');
INSERT INTO public.who_global_data_import VALUES (66334, '2020-12-01', 'PH', 'Philippines', 'WPRO', '1766', '431630', '19', '8392');
INSERT INTO public.who_global_data_import VALUES (66335, '2020-12-02', 'PH', 'Philippines', 'WPRO', '1295', '432925', '26', '8418');
INSERT INTO public.who_global_data_import VALUES (66336, '2020-12-03', 'PH', 'Philippines', 'WPRO', '1432', '434357', '18', '8436');
INSERT INTO public.who_global_data_import VALUES (66337, '2020-12-04', 'PH', 'Philippines', 'WPRO', '1056', '435413', '10', '8446');
INSERT INTO public.who_global_data_import VALUES (66338, '2020-12-05', 'PH', 'Philippines', 'WPRO', '932', '436345', '63', '8509');
INSERT INTO public.who_global_data_import VALUES (66339, '2020-12-06', 'PH', 'Philippines', 'WPRO', '1724', '438069', '17', '8526');
INSERT INTO public.who_global_data_import VALUES (66340, '2020-12-07', 'PH', 'Philippines', 'WPRO', '1765', '439834', '28', '8554');
INSERT INTO public.who_global_data_import VALUES (66341, '2020-12-08', 'PH', 'Philippines', 'WPRO', '1565', '441399', '18', '8572');
INSERT INTO public.who_global_data_import VALUES (66342, '2020-12-09', 'PH', 'Philippines', 'WPRO', '1386', '442785', '98', '8670');
INSERT INTO public.who_global_data_import VALUES (66343, '2020-12-10', 'PH', 'Philippines', 'WPRO', '1379', '444164', '7', '8677');
INSERT INTO public.who_global_data_import VALUES (66344, '2020-12-11', 'PH', 'Philippines', 'WPRO', '1376', '445540', '24', '8701');
INSERT INTO public.who_global_data_import VALUES (66345, '2020-12-12', 'PH', 'Philippines', 'WPRO', '1499', '447039', '8', '8709');
INSERT INTO public.who_global_data_import VALUES (66346, '2020-12-13', 'PH', 'Philippines', 'WPRO', '1292', '448331', '21', '8730');
INSERT INTO public.who_global_data_import VALUES (66347, '2020-12-14', 'PH', 'Philippines', 'WPRO', '1069', '449400', '3', '8733');
INSERT INTO public.who_global_data_import VALUES (66348, '2020-12-15', 'PH', 'Philippines', 'WPRO', '1333', '450733', '24', '8757');
INSERT INTO public.who_global_data_import VALUES (66349, '2020-12-16', 'PH', 'Philippines', 'WPRO', '1106', '451839', '55', '8812');
INSERT INTO public.who_global_data_import VALUES (66350, '2020-12-17', 'PH', 'Philippines', 'WPRO', '1149', '452988', '21', '8833');
INSERT INTO public.who_global_data_import VALUES (66351, '2020-12-18', 'PH', 'Philippines', 'WPRO', '1459', '454447', '17', '8850');
INSERT INTO public.who_global_data_import VALUES (66352, '2020-12-19', 'PH', 'Philippines', 'WPRO', '2115', '456562', '25', '8875');
INSERT INTO public.who_global_data_import VALUES (66353, '2020-12-20', 'PH', 'Philippines', 'WPRO', '1482', '458044', '36', '8911');
INSERT INTO public.who_global_data_import VALUES (66354, '2020-12-21', 'PH', 'Philippines', 'WPRO', '1745', '459789', '36', '8947');
INSERT INTO public.who_global_data_import VALUES (66355, '2020-12-22', 'PH', 'Philippines', 'WPRO', '1716', '461505', '10', '8957');
INSERT INTO public.who_global_data_import VALUES (66356, '2020-12-23', 'PH', 'Philippines', 'WPRO', '1310', '462815', '64', '9021');
INSERT INTO public.who_global_data_import VALUES (66357, '2020-12-24', 'PH', 'Philippines', 'WPRO', '1189', '464004', '27', '9048');
INSERT INTO public.who_global_data_import VALUES (66358, '2020-12-25', 'PH', 'Philippines', 'WPRO', '1720', '465724', '7', '9055');
INSERT INTO public.who_global_data_import VALUES (66359, '2020-12-26', 'PH', 'Philippines', 'WPRO', '1877', '467601', '7', '9062');
INSERT INTO public.who_global_data_import VALUES (66360, '2020-12-27', 'PH', 'Philippines', 'WPRO', '1404', '469005', '5', '9067');
INSERT INTO public.who_global_data_import VALUES (66361, '2020-12-28', 'PH', 'Philippines', 'WPRO', '881', '469886', '42', '9109');
INSERT INTO public.who_global_data_import VALUES (66362, '2020-12-29', 'PH', 'Philippines', 'WPRO', '764', '470650', '15', '9124');
INSERT INTO public.who_global_data_import VALUES (66363, '2020-12-30', 'PH', 'Philippines', 'WPRO', '876', '471526', '38', '9162');
INSERT INTO public.who_global_data_import VALUES (66364, '2020-12-31', 'PH', 'Philippines', 'WPRO', '1006', '472532', '68', '9230');
INSERT INTO public.who_global_data_import VALUES (66365, '2021-01-01', 'PH', 'Philippines', 'WPRO', '1532', '474064', '14', '9244');
INSERT INTO public.who_global_data_import VALUES (66366, '2021-01-02', 'PH', 'Philippines', 'WPRO', '1756', '475820', '4', '9248');
INSERT INTO public.who_global_data_import VALUES (66367, '2021-01-03', 'PH', 'Philippines', 'WPRO', '1096', '476916', '5', '9253');
INSERT INTO public.who_global_data_import VALUES (66368, '2021-01-04', 'PH', 'Philippines', 'WPRO', '891', '477807', '4', '9257');
INSERT INTO public.who_global_data_import VALUES (66369, '2021-01-05', 'PH', 'Philippines', 'WPRO', '954', '478761', '6', '9263');
INSERT INTO public.who_global_data_import VALUES (66370, '2021-01-06', 'PH', 'Philippines', 'WPRO', '932', '479693', '58', '9321');
INSERT INTO public.who_global_data_import VALUES (66371, '2021-01-07', 'PH', 'Philippines', 'WPRO', '1044', '480737', '26', '9347');
INSERT INTO public.who_global_data_import VALUES (66372, '2021-01-08', 'PH', 'Philippines', 'WPRO', '1346', '482083', '9', '9356');
INSERT INTO public.who_global_data_import VALUES (66373, '2021-01-09', 'PH', 'Philippines', 'WPRO', '1769', '483852', '8', '9364');
INSERT INTO public.who_global_data_import VALUES (66374, '2021-01-10', 'PH', 'Philippines', 'WPRO', '1945', '485797', '34', '9398');
INSERT INTO public.who_global_data_import VALUES (66375, '2021-01-11', 'PH', 'Philippines', 'WPRO', '1893', '487690', '7', '9405');
INSERT INTO public.who_global_data_import VALUES (66376, '2021-01-12', 'PH', 'Philippines', 'WPRO', '2046', '489736', '11', '9416');
INSERT INTO public.who_global_data_import VALUES (66377, '2021-01-13', 'PH', 'Philippines', 'WPRO', '1522', '491258', '138', '9554');
INSERT INTO public.who_global_data_import VALUES (66378, '2021-01-14', 'PH', 'Philippines', 'WPRO', '1442', '492700', '145', '9699');
INSERT INTO public.who_global_data_import VALUES (66379, '2021-01-15', 'PH', 'Philippines', 'WPRO', '1905', '494605', '40', '9739');
INSERT INTO public.who_global_data_import VALUES (66380, '2021-01-16', 'PH', 'Philippines', 'WPRO', '2041', '496646', '137', '9876');
INSERT INTO public.who_global_data_import VALUES (66381, '2021-01-17', 'PH', 'Philippines', 'WPRO', '2045', '498691', '8', '9884');
INSERT INTO public.who_global_data_import VALUES (66382, '2021-01-18', 'PH', 'Philippines', 'WPRO', '1886', '500577', '11', '9895');
INSERT INTO public.who_global_data_import VALUES (66383, '2021-01-19', 'PH', 'Philippines', 'WPRO', '2159', '502736', '14', '9909');
INSERT INTO public.who_global_data_import VALUES (66384, '2021-01-20', 'PH', 'Philippines', 'WPRO', '1348', '504084', '69', '9978');
INSERT INTO public.who_global_data_import VALUES (66385, '2021-01-21', 'PH', 'Philippines', 'WPRO', '1855', '505939', '64', '10042');
INSERT INTO public.who_global_data_import VALUES (66386, '2021-01-22', 'PH', 'Philippines', 'WPRO', '1778', '507717', '74', '10116');
INSERT INTO public.who_global_data_import VALUES (66387, '2021-01-23', 'PH', 'Philippines', 'WPRO', '2170', '509887', '20', '10136');
INSERT INTO public.who_global_data_import VALUES (66388, '2021-01-24', 'PH', 'Philippines', 'WPRO', '1792', '511679', '54', '10190');
INSERT INTO public.who_global_data_import VALUES (66389, '2021-01-25', 'PH', 'Philippines', 'WPRO', '1940', '513619', '52', '10242');
INSERT INTO public.who_global_data_import VALUES (66390, '2021-01-26', 'PH', 'Philippines', 'WPRO', '1377', '514996', '50', '10292');
INSERT INTO public.who_global_data_import VALUES (66391, '2021-01-27', 'PH', 'Philippines', 'WPRO', '1170', '516166', '94', '10386');
INSERT INTO public.who_global_data_import VALUES (66392, '2021-01-28', 'PH', 'Philippines', 'WPRO', '2241', '518407', '95', '10481');
INSERT INTO public.who_global_data_import VALUES (66393, '2021-01-29', 'PH', 'Philippines', 'WPRO', '1168', '519575', '71', '10552');
INSERT INTO public.who_global_data_import VALUES (66394, '2021-01-30', 'PH', 'Philippines', 'WPRO', '1838', '521413', '48', '10600');
INSERT INTO public.who_global_data_import VALUES (66395, '2021-01-31', 'PH', 'Philippines', 'WPRO', '2103', '523516', '69', '10669');
INSERT INTO public.who_global_data_import VALUES (66396, '2021-02-01', 'PH', 'Philippines', 'WPRO', '2102', '525618', '80', '10749');
INSERT INTO public.who_global_data_import VALUES (66397, '2021-02-02', 'PH', 'Philippines', 'WPRO', '1654', '527272', '58', '10807');
INSERT INTO public.who_global_data_import VALUES (66398, '2021-02-03', 'PH', 'Philippines', 'WPRO', '1581', '528853', '67', '10874');
INSERT INTO public.who_global_data_import VALUES (66399, '2021-02-04', 'PH', 'Philippines', 'WPRO', '1265', '530118', '68', '10942');
INSERT INTO public.who_global_data_import VALUES (66400, '2021-02-05', 'PH', 'Philippines', 'WPRO', '1581', '531699', '55', '10997');
INSERT INTO public.who_global_data_import VALUES (66401, '2020-01-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66402, '2020-01-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66403, '2020-01-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66404, '2020-01-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66405, '2020-01-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66406, '2020-01-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66407, '2020-01-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66408, '2020-01-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66409, '2020-01-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66410, '2020-01-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66411, '2020-01-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66412, '2020-01-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66413, '2020-01-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66414, '2020-01-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66415, '2020-01-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66416, '2020-01-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66417, '2020-01-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66418, '2020-01-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66419, '2020-01-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66420, '2020-01-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66421, '2020-01-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66422, '2020-01-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66423, '2020-01-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66424, '2020-01-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66425, '2020-01-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66426, '2020-01-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66427, '2020-01-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66428, '2020-01-30', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66429, '2020-01-31', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66430, '2020-02-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66431, '2020-02-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66432, '2020-02-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66433, '2020-02-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66434, '2020-02-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66435, '2020-02-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66436, '2020-02-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66437, '2020-02-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66438, '2020-02-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66439, '2020-02-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66440, '2020-02-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66441, '2020-02-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66442, '2020-02-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66443, '2020-02-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66444, '2020-02-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66445, '2020-02-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66446, '2020-02-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66447, '2020-02-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66448, '2020-02-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66449, '2020-02-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66450, '2020-02-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66451, '2020-02-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66452, '2020-02-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66453, '2020-02-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66454, '2020-02-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66455, '2020-02-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66456, '2020-02-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66457, '2020-02-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66458, '2020-02-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66459, '2020-03-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66460, '2020-03-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66461, '2020-03-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66462, '2020-03-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66463, '2020-03-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66464, '2020-03-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66465, '2020-03-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66466, '2020-03-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66467, '2020-03-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66468, '2020-03-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66469, '2020-03-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66470, '2020-03-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66471, '2020-03-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66472, '2020-03-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66473, '2020-03-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66474, '2020-03-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66475, '2020-03-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66476, '2020-03-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66477, '2020-03-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66478, '2020-03-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66479, '2020-03-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66480, '2020-03-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66481, '2020-03-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66482, '2020-03-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66483, '2020-03-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66484, '2020-03-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66485, '2020-03-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66486, '2020-03-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66487, '2020-03-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66488, '2020-03-30', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66489, '2020-03-31', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66490, '2020-04-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66491, '2020-04-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66492, '2020-04-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66493, '2020-04-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66494, '2020-04-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66495, '2020-04-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66496, '2020-04-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66497, '2020-04-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66498, '2020-04-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66499, '2020-04-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66500, '2020-04-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66501, '2020-04-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66502, '2020-04-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66503, '2020-04-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66504, '2020-04-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66505, '2020-04-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66506, '2020-04-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66507, '2020-04-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66508, '2020-04-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66509, '2020-04-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66510, '2020-04-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66511, '2020-04-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66512, '2020-04-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66513, '2020-04-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66514, '2020-04-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66515, '2020-04-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66516, '2020-04-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66517, '2020-04-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66518, '2020-04-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66519, '2020-04-30', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66520, '2020-05-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66521, '2020-05-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66522, '2020-05-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66523, '2020-05-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66524, '2020-05-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66525, '2020-05-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66526, '2020-05-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66527, '2020-05-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66528, '2020-05-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66529, '2020-05-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66530, '2020-05-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66531, '2020-05-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66532, '2020-05-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66533, '2020-05-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66534, '2020-05-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66535, '2020-05-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66536, '2020-05-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66537, '2020-05-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66538, '2020-05-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66539, '2020-05-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66540, '2020-05-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66541, '2020-05-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66542, '2020-05-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66543, '2020-05-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66544, '2020-05-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66545, '2020-05-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66546, '2020-05-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66547, '2020-05-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66548, '2020-05-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66549, '2020-05-30', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66550, '2020-05-31', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66551, '2020-06-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66552, '2020-06-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66553, '2020-06-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66554, '2020-06-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66555, '2020-06-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66556, '2020-06-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66557, '2020-06-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66558, '2020-06-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66559, '2020-06-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66560, '2020-06-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66561, '2020-06-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66562, '2020-06-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66563, '2020-06-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66564, '2020-06-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66565, '2020-06-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66566, '2020-06-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66567, '2020-06-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66568, '2020-06-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66569, '2020-06-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66570, '2020-06-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66571, '2020-06-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66572, '2020-06-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66573, '2020-06-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66574, '2020-06-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66575, '2020-06-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66576, '2020-06-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66577, '2020-06-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66578, '2020-06-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66579, '2020-06-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66580, '2020-06-30', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66581, '2020-07-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66582, '2020-07-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66583, '2020-07-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66584, '2020-07-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66585, '2020-07-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66586, '2020-07-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66587, '2020-07-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66588, '2020-07-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66589, '2020-07-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66590, '2020-07-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66591, '2020-07-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66592, '2020-07-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66593, '2020-07-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66594, '2020-07-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66595, '2020-07-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66596, '2020-07-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66597, '2020-07-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66598, '2020-07-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66599, '2020-07-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66600, '2020-07-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66601, '2020-07-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66602, '2020-07-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66603, '2020-07-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66604, '2020-07-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66605, '2020-07-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66606, '2020-07-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66607, '2020-07-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66608, '2020-07-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66609, '2020-07-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66610, '2020-07-30', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66611, '2020-07-31', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66612, '2020-08-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66613, '2020-08-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66614, '2020-08-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66615, '2020-08-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66616, '2020-08-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66617, '2020-08-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66618, '2020-08-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66619, '2020-08-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66620, '2020-08-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66621, '2020-08-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66622, '2020-08-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66623, '2020-08-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66624, '2020-08-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66625, '2020-08-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66626, '2020-08-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66627, '2020-08-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66628, '2020-08-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66629, '2020-08-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66630, '2020-08-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66631, '2020-08-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66632, '2020-08-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66633, '2020-08-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66634, '2020-08-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66635, '2020-08-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66636, '2020-08-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66637, '2020-08-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66638, '2020-08-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66639, '2020-08-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66640, '2020-08-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66641, '2020-08-30', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66642, '2020-08-31', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66643, '2020-09-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66644, '2020-09-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66645, '2020-09-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66646, '2020-09-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66647, '2020-09-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66648, '2020-09-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66649, '2020-09-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66650, '2020-09-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66651, '2020-09-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66652, '2020-09-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66653, '2020-09-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66654, '2020-09-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66655, '2020-09-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66656, '2020-09-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66657, '2020-09-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66658, '2020-09-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66659, '2020-09-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66660, '2020-09-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66661, '2020-09-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66662, '2020-09-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66663, '2020-09-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66664, '2020-09-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66665, '2020-09-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66666, '2020-09-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66667, '2020-09-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66668, '2020-09-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66669, '2020-09-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66670, '2020-09-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66671, '2020-09-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66672, '2020-09-30', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66673, '2020-10-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66674, '2020-10-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66675, '2020-10-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66676, '2020-10-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66677, '2020-10-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66678, '2020-10-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66679, '2020-10-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66680, '2020-10-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66681, '2020-10-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66682, '2020-10-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66683, '2020-10-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66684, '2020-10-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66685, '2020-10-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66686, '2020-10-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66687, '2020-10-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66688, '2020-10-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66689, '2020-10-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66690, '2020-10-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66691, '2020-10-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66692, '2020-10-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66693, '2020-10-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66694, '2020-10-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66695, '2020-10-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66696, '2020-10-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66697, '2020-10-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66698, '2020-10-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66699, '2020-10-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66700, '2020-10-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66701, '2020-10-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66702, '2020-10-30', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66703, '2020-10-31', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66704, '2020-11-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66705, '2020-11-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66706, '2020-11-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66707, '2020-11-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66708, '2020-11-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66709, '2020-11-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66710, '2020-11-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66711, '2020-11-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66712, '2020-11-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66713, '2020-11-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66714, '2020-11-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66715, '2020-11-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66716, '2020-11-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66717, '2020-11-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66718, '2020-11-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66719, '2020-11-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66720, '2020-11-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66721, '2020-11-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66722, '2020-11-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66723, '2020-11-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66724, '2020-11-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66725, '2020-11-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66726, '2020-11-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66727, '2020-11-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66728, '2020-11-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66729, '2020-11-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66730, '2020-11-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66731, '2020-11-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66732, '2020-11-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66733, '2020-11-30', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66734, '2020-12-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66735, '2020-12-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66736, '2020-12-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66737, '2020-12-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66738, '2020-12-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66739, '2020-12-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66740, '2020-12-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66741, '2020-12-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66742, '2020-12-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66743, '2020-12-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66744, '2020-12-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66745, '2020-12-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66746, '2020-12-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66747, '2020-12-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66748, '2020-12-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66749, '2020-12-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66750, '2020-12-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66751, '2020-12-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66752, '2020-12-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66753, '2020-12-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66754, '2020-12-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66755, '2020-12-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66756, '2020-12-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66757, '2020-12-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66758, '2020-12-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66759, '2020-12-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66760, '2020-12-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66761, '2020-12-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66762, '2020-12-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66763, '2020-12-30', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66764, '2020-12-31', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66765, '2021-01-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66766, '2021-01-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66767, '2021-01-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66768, '2021-01-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66769, '2021-01-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66770, '2021-01-06', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66771, '2021-01-07', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66772, '2021-01-08', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66773, '2021-01-09', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66774, '2021-01-10', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66775, '2021-01-11', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66776, '2021-01-12', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66777, '2021-01-13', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66778, '2021-01-14', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66779, '2021-01-15', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66780, '2021-01-16', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66781, '2021-01-17', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66782, '2021-01-18', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66783, '2021-01-19', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66784, '2021-01-20', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66785, '2021-01-21', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66786, '2021-01-22', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66787, '2021-01-23', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66788, '2021-01-24', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66789, '2021-01-25', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66790, '2021-01-26', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66791, '2021-01-27', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66792, '2021-01-28', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66793, '2021-01-29', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66794, '2021-01-30', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66795, '2021-01-31', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66796, '2021-02-01', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66797, '2021-02-02', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66798, '2021-02-03', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66799, '2021-02-04', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66800, '2021-02-05', 'PN', 'Pitcairn Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66801, '2020-01-03', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66802, '2020-01-04', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66803, '2020-01-05', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66804, '2020-01-06', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66805, '2020-01-07', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66806, '2020-01-08', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66807, '2020-01-09', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66808, '2020-01-10', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66809, '2020-01-11', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66810, '2020-01-12', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66811, '2020-01-13', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66812, '2020-01-14', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66813, '2020-01-15', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66814, '2020-01-16', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66815, '2020-01-17', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66816, '2020-01-18', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66817, '2020-01-19', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66818, '2020-01-20', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66819, '2020-01-21', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66820, '2020-01-22', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66821, '2020-01-23', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66822, '2020-01-24', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66823, '2020-01-25', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66824, '2020-01-26', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66825, '2020-01-27', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66826, '2020-01-28', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66827, '2020-01-29', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66828, '2020-01-30', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66829, '2020-01-31', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66830, '2020-02-01', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66831, '2020-02-02', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66832, '2020-02-03', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66833, '2020-02-04', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66834, '2020-02-05', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66835, '2020-02-06', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66836, '2020-02-07', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66837, '2020-02-08', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66838, '2020-02-09', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66839, '2020-02-10', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66840, '2020-02-11', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66841, '2020-02-12', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66842, '2020-02-13', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66843, '2020-02-14', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66844, '2020-02-15', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66845, '2020-02-16', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66846, '2020-02-17', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66847, '2020-02-18', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66848, '2020-02-19', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66849, '2020-02-20', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66850, '2020-02-21', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66851, '2020-02-22', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66852, '2020-02-23', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66853, '2020-02-24', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66854, '2020-02-25', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66855, '2020-02-26', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66856, '2020-02-27', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66857, '2020-02-28', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66858, '2020-02-29', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66859, '2020-03-01', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66860, '2020-03-02', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66861, '2020-03-03', 'PL', 'Poland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66862, '2020-03-04', 'PL', 'Poland', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66863, '2020-03-05', 'PL', 'Poland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66864, '2020-03-06', 'PL', 'Poland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66865, '2020-03-07', 'PL', 'Poland', 'EURO', '4', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66866, '2020-03-08', 'PL', 'Poland', 'EURO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66867, '2020-03-09', 'PL', 'Poland', 'EURO', '5', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66868, '2020-03-10', 'PL', 'Poland', 'EURO', '6', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66869, '2020-03-11', 'PL', 'Poland', 'EURO', '5', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66870, '2020-03-12', 'PL', 'Poland', 'EURO', '9', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (66871, '2020-03-13', 'PL', 'Poland', 'EURO', '18', '49', '1', '1');
INSERT INTO public.who_global_data_import VALUES (66872, '2020-03-14', 'PL', 'Poland', 'EURO', '19', '68', '1', '2');
INSERT INTO public.who_global_data_import VALUES (66873, '2020-03-15', 'PL', 'Poland', 'EURO', '36', '104', '1', '3');
INSERT INTO public.who_global_data_import VALUES (66874, '2020-03-16', 'PL', 'Poland', 'EURO', '21', '125', '0', '3');
INSERT INTO public.who_global_data_import VALUES (66875, '2020-03-17', 'PL', 'Poland', 'EURO', '52', '177', '1', '4');
INSERT INTO public.who_global_data_import VALUES (66876, '2020-03-18', 'PL', 'Poland', 'EURO', '61', '238', '1', '5');
INSERT INTO public.who_global_data_import VALUES (66877, '2020-03-19', 'PL', 'Poland', 'EURO', '49', '287', '0', '5');
INSERT INTO public.who_global_data_import VALUES (66878, '2020-03-20', 'PL', 'Poland', 'EURO', '68', '355', '0', '5');
INSERT INTO public.who_global_data_import VALUES (66879, '2020-03-21', 'PL', 'Poland', 'EURO', '70', '425', '0', '5');
INSERT INTO public.who_global_data_import VALUES (66880, '2020-03-22', 'PL', 'Poland', 'EURO', '111', '536', '0', '5');
INSERT INTO public.who_global_data_import VALUES (66881, '2020-03-23', 'PL', 'Poland', 'EURO', '98', '634', '2', '7');
INSERT INTO public.who_global_data_import VALUES (66882, '2020-03-24', 'PL', 'Poland', 'EURO', '115', '749', '1', '8');
INSERT INTO public.who_global_data_import VALUES (66883, '2020-03-25', 'PL', 'Poland', 'EURO', '152', '901', '2', '10');
INSERT INTO public.who_global_data_import VALUES (66884, '2020-03-26', 'PL', 'Poland', 'EURO', '150', '1051', '4', '14');
INSERT INTO public.who_global_data_import VALUES (66885, '2020-03-27', 'PL', 'Poland', 'EURO', '170', '1221', '2', '16');
INSERT INTO public.who_global_data_import VALUES (66886, '2020-03-28', 'PL', 'Poland', 'EURO', '168', '1389', '0', '16');
INSERT INTO public.who_global_data_import VALUES (66887, '2020-03-29', 'PL', 'Poland', 'EURO', '249', '1638', '2', '18');
INSERT INTO public.who_global_data_import VALUES (66888, '2020-03-30', 'PL', 'Poland', 'EURO', '224', '1862', '4', '22');
INSERT INTO public.who_global_data_import VALUES (66889, '2020-03-31', 'PL', 'Poland', 'EURO', '193', '2055', '9', '31');
INSERT INTO public.who_global_data_import VALUES (66890, '2020-04-01', 'PL', 'Poland', 'EURO', '256', '2311', '2', '33');
INSERT INTO public.who_global_data_import VALUES (66891, '2020-04-02', 'PL', 'Poland', 'EURO', '243', '2554', '10', '43');
INSERT INTO public.who_global_data_import VALUES (66892, '2020-04-03', 'PL', 'Poland', 'EURO', '392', '2946', '14', '57');
INSERT INTO public.who_global_data_import VALUES (66893, '2020-04-04', 'PL', 'Poland', 'EURO', '437', '3383', '14', '71');
INSERT INTO public.who_global_data_import VALUES (66894, '2020-04-05', 'PL', 'Poland', 'EURO', '244', '3627', '8', '79');
INSERT INTO public.who_global_data_import VALUES (66895, '2020-04-06', 'PL', 'Poland', 'EURO', '475', '4102', '15', '94');
INSERT INTO public.who_global_data_import VALUES (66896, '2020-04-07', 'PL', 'Poland', 'EURO', '311', '4413', '13', '107');
INSERT INTO public.who_global_data_import VALUES (66897, '2020-04-08', 'PL', 'Poland', 'EURO', '435', '4848', '22', '129');
INSERT INTO public.who_global_data_import VALUES (66898, '2020-04-09', 'PL', 'Poland', 'EURO', '357', '5205', '30', '159');
INSERT INTO public.who_global_data_import VALUES (66899, '2020-04-10', 'PL', 'Poland', 'EURO', '370', '5575', '15', '174');
INSERT INTO public.who_global_data_import VALUES (66900, '2020-04-11', 'PL', 'Poland', 'EURO', '380', '5955', '7', '181');
INSERT INTO public.who_global_data_import VALUES (66901, '2020-04-12', 'PL', 'Poland', 'EURO', '401', '6356', '27', '208');
INSERT INTO public.who_global_data_import VALUES (66902, '2020-04-13', 'PL', 'Poland', 'EURO', '318', '6674', '24', '232');
INSERT INTO public.who_global_data_import VALUES (66903, '2020-04-14', 'PL', 'Poland', 'EURO', '260', '6934', '13', '245');
INSERT INTO public.who_global_data_import VALUES (66904, '2020-04-15', 'PL', 'Poland', 'EURO', '268', '7202', '18', '263');
INSERT INTO public.who_global_data_import VALUES (66905, '2020-04-16', 'PL', 'Poland', 'EURO', '380', '7582', '23', '286');
INSERT INTO public.who_global_data_import VALUES (66906, '2020-04-17', 'PL', 'Poland', 'EURO', '336', '7918', '28', '314');
INSERT INTO public.who_global_data_import VALUES (66907, '2020-04-18', 'PL', 'Poland', 'EURO', '461', '8379', '18', '332');
INSERT INTO public.who_global_data_import VALUES (66908, '2020-04-19', 'PL', 'Poland', 'EURO', '363', '8742', '15', '347');
INSERT INTO public.who_global_data_import VALUES (66909, '2020-04-20', 'PL', 'Poland', 'EURO', '545', '9287', '13', '360');
INSERT INTO public.who_global_data_import VALUES (66910, '2020-04-21', 'PL', 'Poland', 'EURO', '306', '9593', '20', '380');
INSERT INTO public.who_global_data_import VALUES (66911, '2020-04-22', 'PL', 'Poland', 'EURO', '263', '9856', '21', '401');
INSERT INTO public.who_global_data_import VALUES (66912, '2020-04-23', 'PL', 'Poland', 'EURO', '313', '10169', '25', '426');
INSERT INTO public.who_global_data_import VALUES (66913, '2020-04-24', 'PL', 'Poland', 'EURO', '342', '10511', '28', '454');
INSERT INTO public.who_global_data_import VALUES (66914, '2020-04-25', 'PL', 'Poland', 'EURO', '381', '10892', '40', '494');
INSERT INTO public.who_global_data_import VALUES (66915, '2020-04-26', 'PL', 'Poland', 'EURO', '381', '11273', '30', '524');
INSERT INTO public.who_global_data_import VALUES (66916, '2020-04-27', 'PL', 'Poland', 'EURO', '344', '11617', '11', '535');
INSERT INTO public.who_global_data_import VALUES (66917, '2020-04-28', 'PL', 'Poland', 'EURO', '285', '11902', '27', '562');
INSERT INTO public.who_global_data_import VALUES (66918, '2020-04-29', 'PL', 'Poland', 'EURO', '316', '12218', '34', '596');
INSERT INTO public.who_global_data_import VALUES (66919, '2020-04-30', 'PL', 'Poland', 'EURO', '422', '12640', '28', '624');
INSERT INTO public.who_global_data_import VALUES (66920, '2020-05-01', 'PL', 'Poland', 'EURO', '237', '12877', '20', '644');
INSERT INTO public.who_global_data_import VALUES (66921, '2020-05-02', 'PL', 'Poland', 'EURO', '228', '13105', '7', '651');
INSERT INTO public.who_global_data_import VALUES (66922, '2020-05-03', 'PL', 'Poland', 'EURO', '270', '13375', '13', '664');
INSERT INTO public.who_global_data_import VALUES (66923, '2020-05-04', 'PL', 'Poland', 'EURO', '318', '13693', '14', '678');
INSERT INTO public.who_global_data_import VALUES (66924, '2020-05-05', 'PL', 'Poland', 'EURO', '313', '14006', '20', '698');
INSERT INTO public.who_global_data_import VALUES (66925, '2020-05-06', 'PL', 'Poland', 'EURO', '425', '14431', '18', '716');
INSERT INTO public.who_global_data_import VALUES (66926, '2020-05-07', 'PL', 'Poland', 'EURO', '309', '14740', '17', '733');
INSERT INTO public.who_global_data_import VALUES (66927, '2020-05-08', 'PL', 'Poland', 'EURO', '307', '15047', '22', '755');
INSERT INTO public.who_global_data_import VALUES (66928, '2020-05-09', 'PL', 'Poland', 'EURO', '319', '15366', '21', '776');
INSERT INTO public.who_global_data_import VALUES (66929, '2020-05-10', 'PL', 'Poland', 'EURO', '285', '15651', '9', '785');
INSERT INTO public.who_global_data_import VALUES (66930, '2020-05-11', 'PL', 'Poland', 'EURO', '345', '15996', '15', '800');
INSERT INTO public.who_global_data_import VALUES (66931, '2020-05-12', 'PL', 'Poland', 'EURO', '330', '16326', '11', '811');
INSERT INTO public.who_global_data_import VALUES (66932, '2020-05-13', 'PL', 'Poland', 'EURO', '595', '16921', '28', '839');
INSERT INTO public.who_global_data_import VALUES (66933, '2020-05-14', 'PL', 'Poland', 'EURO', '283', '17204', '22', '861');
INSERT INTO public.who_global_data_import VALUES (66934, '2020-05-15', 'PL', 'Poland', 'EURO', '411', '17615', '22', '883');
INSERT INTO public.who_global_data_import VALUES (66935, '2020-05-16', 'PL', 'Poland', 'EURO', '401', '18016', '24', '907');
INSERT INTO public.who_global_data_import VALUES (66936, '2020-05-17', 'PL', 'Poland', 'EURO', '241', '18257', '8', '915');
INSERT INTO public.who_global_data_import VALUES (66937, '2020-05-18', 'PL', 'Poland', 'EURO', '272', '18529', '10', '925');
INSERT INTO public.who_global_data_import VALUES (66938, '2020-05-19', 'PL', 'Poland', 'EURO', '356', '18885', '11', '936');
INSERT INTO public.who_global_data_import VALUES (66939, '2020-05-20', 'PL', 'Poland', 'EURO', '383', '19268', '12', '948');
INSERT INTO public.who_global_data_import VALUES (66940, '2020-05-21', 'PL', 'Poland', 'EURO', '471', '19739', '14', '962');
INSERT INTO public.who_global_data_import VALUES (66941, '2020-05-22', 'PL', 'Poland', 'EURO', '404', '20143', '10', '972');
INSERT INTO public.who_global_data_import VALUES (66942, '2020-05-23', 'PL', 'Poland', 'EURO', '476', '20619', '10', '982');
INSERT INTO public.who_global_data_import VALUES (66943, '2020-05-24', 'PL', 'Poland', 'EURO', '312', '20931', '11', '993');
INSERT INTO public.who_global_data_import VALUES (66944, '2020-05-25', 'PL', 'Poland', 'EURO', '395', '21326', '3', '996');
INSERT INTO public.who_global_data_import VALUES (66945, '2020-05-26', 'PL', 'Poland', 'EURO', '305', '21631', '11', '1007');
INSERT INTO public.who_global_data_import VALUES (66946, '2020-05-27', 'PL', 'Poland', 'EURO', '443', '22074', '17', '1024');
INSERT INTO public.who_global_data_import VALUES (66947, '2020-05-28', 'PL', 'Poland', 'EURO', '399', '22473', '4', '1028');
INSERT INTO public.who_global_data_import VALUES (66948, '2020-05-29', 'PL', 'Poland', 'EURO', '352', '22825', '10', '1038');
INSERT INTO public.who_global_data_import VALUES (66949, '2020-05-30', 'PL', 'Poland', 'EURO', '330', '23155', '13', '1051');
INSERT INTO public.who_global_data_import VALUES (66950, '2020-05-31', 'PL', 'Poland', 'EURO', '416', '23571', '10', '1061');
INSERT INTO public.who_global_data_import VALUES (66951, '2020-06-01', 'PL', 'Poland', 'EURO', '215', '23786', '3', '1064');
INSERT INTO public.who_global_data_import VALUES (66952, '2020-06-02', 'PL', 'Poland', 'EURO', '379', '24165', '10', '1074');
INSERT INTO public.who_global_data_import VALUES (66953, '2020-06-03', 'PL', 'Poland', 'EURO', '230', '24395', '18', '1092');
INSERT INTO public.who_global_data_import VALUES (66954, '2020-06-04', 'PL', 'Poland', 'EURO', '292', '24687', '23', '1115');
INSERT INTO public.who_global_data_import VALUES (66955, '2020-06-05', 'PL', 'Poland', 'EURO', '361', '25048', '2', '1117');
INSERT INTO public.who_global_data_import VALUES (66956, '2020-06-06', 'PL', 'Poland', 'EURO', '371', '25419', '20', '1137');
INSERT INTO public.who_global_data_import VALUES (66957, '2020-06-07', 'PL', 'Poland', 'EURO', '567', '25986', '16', '1153');
INSERT INTO public.who_global_data_import VALUES (66958, '2020-06-08', 'PL', 'Poland', 'EURO', '575', '26561', '4', '1157');
INSERT INTO public.who_global_data_import VALUES (66959, '2020-06-09', 'PL', 'Poland', 'EURO', '599', '27160', '9', '1166');
INSERT INTO public.who_global_data_import VALUES (66960, '2020-06-10', 'PL', 'Poland', 'EURO', '400', '27560', '17', '1183');
INSERT INTO public.who_global_data_import VALUES (66961, '2020-06-11', 'PL', 'Poland', 'EURO', '197', '27757', '23', '1206');
INSERT INTO public.who_global_data_import VALUES (66962, '2020-06-12', 'PL', 'Poland', 'EURO', '444', '28201', '9', '1215');
INSERT INTO public.who_global_data_import VALUES (66963, '2020-06-13', 'PL', 'Poland', 'EURO', '376', '28577', '7', '1222');
INSERT INTO public.who_global_data_import VALUES (66964, '2020-06-14', 'PL', 'Poland', 'EURO', '440', '29017', '15', '1237');
INSERT INTO public.who_global_data_import VALUES (66965, '2020-06-15', 'PL', 'Poland', 'EURO', '375', '29392', '10', '1247');
INSERT INTO public.who_global_data_import VALUES (66966, '2020-06-16', 'PL', 'Poland', 'EURO', '396', '29788', '9', '1256');
INSERT INTO public.who_global_data_import VALUES (66967, '2020-06-17', 'PL', 'Poland', 'EURO', '407', '30195', '16', '1272');
INSERT INTO public.who_global_data_import VALUES (66968, '2020-06-18', 'PL', 'Poland', 'EURO', '506', '30701', '14', '1286');
INSERT INTO public.who_global_data_import VALUES (66969, '2020-06-19', 'PL', 'Poland', 'EURO', '314', '31015', '30', '1316');
INSERT INTO public.who_global_data_import VALUES (66970, '2020-06-20', 'PL', 'Poland', 'EURO', '301', '31316', '18', '1334');
INSERT INTO public.who_global_data_import VALUES (66971, '2020-06-21', 'PL', 'Poland', 'EURO', '304', '31620', '12', '1346');
INSERT INTO public.who_global_data_import VALUES (66972, '2020-06-22', 'PL', 'Poland', 'EURO', '311', '31931', '10', '1356');
INSERT INTO public.who_global_data_import VALUES (66973, '2020-06-23', 'PL', 'Poland', 'EURO', '296', '32227', '3', '1359');
INSERT INTO public.who_global_data_import VALUES (66974, '2020-06-24', 'PL', 'Poland', 'EURO', '300', '32527', '16', '1375');
INSERT INTO public.who_global_data_import VALUES (66975, '2020-06-25', 'PL', 'Poland', 'EURO', '294', '32821', '21', '1396');
INSERT INTO public.who_global_data_import VALUES (66976, '2020-06-26', 'PL', 'Poland', 'EURO', '298', '33119', '16', '1412');
INSERT INTO public.who_global_data_import VALUES (66977, '2020-06-27', 'PL', 'Poland', 'EURO', '276', '33395', '17', '1429');
INSERT INTO public.who_global_data_import VALUES (66978, '2020-06-28', 'PL', 'Poland', 'EURO', '319', '33714', '6', '1435');
INSERT INTO public.who_global_data_import VALUES (66979, '2020-06-29', 'PL', 'Poland', 'EURO', '193', '33907', '3', '1438');
INSERT INTO public.who_global_data_import VALUES (66980, '2020-06-30', 'PL', 'Poland', 'EURO', '247', '34154', '6', '1444');
INSERT INTO public.who_global_data_import VALUES (66981, '2020-07-01', 'PL', 'Poland', 'EURO', '239', '34393', '19', '1463');
INSERT INTO public.who_global_data_import VALUES (66982, '2020-07-02', 'PL', 'Poland', 'EURO', '382', '34775', '14', '1477');
INSERT INTO public.who_global_data_import VALUES (66983, '2020-07-03', 'PL', 'Poland', 'EURO', '371', '35146', '15', '1492');
INSERT INTO public.who_global_data_import VALUES (66984, '2020-07-04', 'PL', 'Poland', 'EURO', '259', '35405', '15', '1507');
INSERT INTO public.who_global_data_import VALUES (66985, '2020-07-05', 'PL', 'Poland', 'EURO', '314', '35719', '5', '1512');
INSERT INTO public.who_global_data_import VALUES (66986, '2020-07-06', 'PL', 'Poland', 'EURO', '231', '35950', '5', '1517');
INSERT INTO public.who_global_data_import VALUES (66987, '2020-07-07', 'PL', 'Poland', 'EURO', '205', '36155', '4', '1521');
INSERT INTO public.who_global_data_import VALUES (66988, '2020-07-08', 'PL', 'Poland', 'EURO', '257', '36412', '7', '1528');
INSERT INTO public.who_global_data_import VALUES (66989, '2020-07-09', 'PL', 'Poland', 'EURO', '277', '36689', '14', '1542');
INSERT INTO public.who_global_data_import VALUES (66990, '2020-07-10', 'PL', 'Poland', 'EURO', '262', '36951', '9', '1551');
INSERT INTO public.who_global_data_import VALUES (66991, '2020-07-11', 'PL', 'Poland', 'EURO', '265', '37216', '11', '1562');
INSERT INTO public.who_global_data_import VALUES (66992, '2020-07-12', 'PL', 'Poland', 'EURO', '305', '37521', '6', '1568');
INSERT INTO public.who_global_data_import VALUES (66993, '2020-07-13', 'PL', 'Poland', 'EURO', '370', '37891', '3', '1571');
INSERT INTO public.who_global_data_import VALUES (66994, '2020-07-14', 'PL', 'Poland', 'EURO', '299', '38190', '5', '1576');
INSERT INTO public.who_global_data_import VALUES (66995, '2020-07-15', 'PL', 'Poland', 'EURO', '267', '38457', '12', '1588');
INSERT INTO public.who_global_data_import VALUES (66996, '2020-07-16', 'PL', 'Poland', 'EURO', '323', '38780', '6', '1594');
INSERT INTO public.who_global_data_import VALUES (66997, '2020-07-17', 'PL', 'Poland', 'EURO', '274', '39054', '11', '1605');
INSERT INTO public.who_global_data_import VALUES (66998, '2020-07-18', 'PL', 'Poland', 'EURO', '353', '39407', '7', '1612');
INSERT INTO public.who_global_data_import VALUES (66999, '2020-07-19', 'PL', 'Poland', 'EURO', '339', '39746', '6', '1618');
INSERT INTO public.who_global_data_import VALUES (67000, '2020-07-20', 'PL', 'Poland', 'EURO', '358', '40104', '6', '1624');
INSERT INTO public.who_global_data_import VALUES (67001, '2020-07-21', 'PL', 'Poland', 'EURO', '279', '40383', '3', '1627');
INSERT INTO public.who_global_data_import VALUES (67002, '2020-07-22', 'PL', 'Poland', 'EURO', '399', '40782', '9', '1636');
INSERT INTO public.who_global_data_import VALUES (67003, '2020-07-23', 'PL', 'Poland', 'EURO', '380', '41162', '6', '1642');
INSERT INTO public.who_global_data_import VALUES (67004, '2020-07-24', 'PL', 'Poland', 'EURO', '418', '41580', '9', '1651');
INSERT INTO public.who_global_data_import VALUES (67005, '2020-07-25', 'PL', 'Poland', 'EURO', '458', '42038', '4', '1655');
INSERT INTO public.who_global_data_import VALUES (67006, '2020-07-26', 'PL', 'Poland', 'EURO', '584', '42622', '9', '1664');
INSERT INTO public.who_global_data_import VALUES (67007, '2020-07-27', 'PL', 'Poland', 'EURO', '443', '43065', '7', '1671');
INSERT INTO public.who_global_data_import VALUES (67008, '2020-07-28', 'PL', 'Poland', 'EURO', '337', '43402', '5', '1676');
INSERT INTO public.who_global_data_import VALUES (67009, '2020-07-29', 'PL', 'Poland', 'EURO', '502', '43904', '6', '1682');
INSERT INTO public.who_global_data_import VALUES (67010, '2020-07-30', 'PL', 'Poland', 'EURO', '512', '44416', '12', '1694');
INSERT INTO public.who_global_data_import VALUES (67011, '2020-07-31', 'PL', 'Poland', 'EURO', '615', '45031', '15', '1709');
INSERT INTO public.who_global_data_import VALUES (67012, '2020-08-01', 'PL', 'Poland', 'EURO', '657', '45688', '7', '1716');
INSERT INTO public.who_global_data_import VALUES (67013, '2020-08-02', 'PL', 'Poland', 'EURO', '658', '46346', '5', '1721');
INSERT INTO public.who_global_data_import VALUES (67014, '2020-08-03', 'PL', 'Poland', 'EURO', '548', '46894', '10', '1731');
INSERT INTO public.who_global_data_import VALUES (67015, '2020-08-04', 'PL', 'Poland', 'EURO', '575', '47469', '1', '1732');
INSERT INTO public.who_global_data_import VALUES (67016, '2020-08-05', 'PL', 'Poland', 'EURO', '680', '48149', '6', '1738');
INSERT INTO public.who_global_data_import VALUES (67017, '2020-08-06', 'PL', 'Poland', 'EURO', '640', '48789', '18', '1756');
INSERT INTO public.who_global_data_import VALUES (67018, '2020-08-07', 'PL', 'Poland', 'EURO', '726', '49515', '18', '1774');
INSERT INTO public.who_global_data_import VALUES (67019, '2020-08-08', 'PL', 'Poland', 'EURO', '809', '50324', '13', '1787');
INSERT INTO public.who_global_data_import VALUES (67020, '2020-08-09', 'PL', 'Poland', 'EURO', '843', '51167', '13', '1800');
INSERT INTO public.who_global_data_import VALUES (67021, '2020-08-10', 'PL', 'Poland', 'EURO', '624', '51791', '7', '1807');
INSERT INTO public.who_global_data_import VALUES (67022, '2020-08-11', 'PL', 'Poland', 'EURO', '619', '52410', '2', '1809');
INSERT INTO public.who_global_data_import VALUES (67023, '2020-08-12', 'PL', 'Poland', 'EURO', '551', '52961', '12', '1821');
INSERT INTO public.who_global_data_import VALUES (67024, '2020-08-13', 'PL', 'Poland', 'EURO', '715', '53676', '9', '1830');
INSERT INTO public.who_global_data_import VALUES (67025, '2020-08-14', 'PL', 'Poland', 'EURO', '811', '54487', '14', '1844');
INSERT INTO public.who_global_data_import VALUES (67026, '2020-08-15', 'PL', 'Poland', 'EURO', '832', '55319', '14', '1858');
INSERT INTO public.who_global_data_import VALUES (67027, '2020-08-16', 'PL', 'Poland', 'EURO', '771', '56090', '11', '1869');
INSERT INTO public.who_global_data_import VALUES (67028, '2020-08-17', 'PL', 'Poland', 'EURO', '594', '56684', '8', '1877');
INSERT INTO public.who_global_data_import VALUES (67029, '2020-08-18', 'PL', 'Poland', 'EURO', '595', '57279', '8', '1885');
INSERT INTO public.who_global_data_import VALUES (67030, '2020-08-19', 'PL', 'Poland', 'EURO', '597', '57876', '11', '1896');
INSERT INTO public.who_global_data_import VALUES (67031, '2020-08-20', 'PL', 'Poland', 'EURO', '735', '58611', '17', '1913');
INSERT INTO public.who_global_data_import VALUES (67032, '2020-08-21', 'PL', 'Poland', 'EURO', '767', '59378', '12', '1925');
INSERT INTO public.who_global_data_import VALUES (67033, '2020-08-22', 'PL', 'Poland', 'EURO', '903', '60281', '13', '1938');
INSERT INTO public.who_global_data_import VALUES (67034, '2020-08-23', 'PL', 'Poland', 'EURO', '900', '61181', '13', '1951');
INSERT INTO public.who_global_data_import VALUES (67035, '2020-08-24', 'PL', 'Poland', 'EURO', '581', '61762', '4', '1955');
INSERT INTO public.who_global_data_import VALUES (67036, '2020-08-25', 'PL', 'Poland', 'EURO', '548', '62310', '5', '1960');
INSERT INTO public.who_global_data_import VALUES (67037, '2020-08-26', 'PL', 'Poland', 'EURO', '763', '63073', '17', '1977');
INSERT INTO public.who_global_data_import VALUES (67038, '2020-08-27', 'PL', 'Poland', 'EURO', '729', '63802', '17', '1994');
INSERT INTO public.who_global_data_import VALUES (67039, '2020-08-28', 'PL', 'Poland', 'EURO', '887', '64689', '16', '2010');
INSERT INTO public.who_global_data_import VALUES (67040, '2020-08-29', 'PL', 'Poland', 'EURO', '791', '65480', '8', '2018');
INSERT INTO public.who_global_data_import VALUES (67041, '2020-08-30', 'PL', 'Poland', 'EURO', '759', '66239', '14', '2032');
INSERT INTO public.who_global_data_import VALUES (67042, '2020-08-31', 'PL', 'Poland', 'EURO', '631', '66870', '1', '2033');
INSERT INTO public.who_global_data_import VALUES (67043, '2020-09-01', 'PL', 'Poland', 'EURO', '502', '67372', '6', '2039');
INSERT INTO public.who_global_data_import VALUES (67044, '2020-09-02', 'PL', 'Poland', 'EURO', '550', '67922', '19', '2058');
INSERT INTO public.who_global_data_import VALUES (67045, '2020-09-03', 'PL', 'Poland', 'EURO', '595', '68517', '20', '2078');
INSERT INTO public.who_global_data_import VALUES (67046, '2020-09-04', 'PL', 'Poland', 'EURO', '612', '69129', '14', '2092');
INSERT INTO public.who_global_data_import VALUES (67047, '2020-09-05', 'PL', 'Poland', 'EURO', '691', '69820', '8', '2100');
INSERT INTO public.who_global_data_import VALUES (67048, '2020-09-06', 'PL', 'Poland', 'EURO', '567', '70387', '13', '2113');
INSERT INTO public.who_global_data_import VALUES (67049, '2020-09-07', 'PL', 'Poland', 'EURO', '437', '70824', '7', '2120');
INSERT INTO public.who_global_data_import VALUES (67050, '2020-09-08', 'PL', 'Poland', 'EURO', '302', '71126', '4', '2124');
INSERT INTO public.who_global_data_import VALUES (67051, '2020-09-09', 'PL', 'Poland', 'EURO', '400', '71526', '12', '2136');
INSERT INTO public.who_global_data_import VALUES (67052, '2020-09-10', 'PL', 'Poland', 'EURO', '421', '71947', '11', '2147');
INSERT INTO public.who_global_data_import VALUES (67053, '2020-09-11', 'PL', 'Poland', 'EURO', '506', '72453', '12', '2159');
INSERT INTO public.who_global_data_import VALUES (67054, '2020-09-12', 'PL', 'Poland', 'EURO', '594', '73047', '10', '2169');
INSERT INTO public.who_global_data_import VALUES (67055, '2020-09-13', 'PL', 'Poland', 'EURO', '603', '73650', '13', '2182');
INSERT INTO public.who_global_data_import VALUES (67056, '2020-09-14', 'PL', 'Poland', 'EURO', '502', '74152', '6', '2188');
INSERT INTO public.who_global_data_import VALUES (67057, '2020-09-15', 'PL', 'Poland', 'EURO', '377', '74529', '15', '2203');
INSERT INTO public.who_global_data_import VALUES (67058, '2020-09-16', 'PL', 'Poland', 'EURO', '605', '75134', '24', '2227');
INSERT INTO public.who_global_data_import VALUES (67059, '2020-09-17', 'PL', 'Poland', 'EURO', '600', '75734', '10', '2237');
INSERT INTO public.who_global_data_import VALUES (67060, '2020-09-18', 'PL', 'Poland', 'EURO', '837', '76571', '16', '2253');
INSERT INTO public.who_global_data_import VALUES (67061, '2020-09-19', 'PL', 'Poland', 'EURO', '757', '77328', '17', '2270');
INSERT INTO public.who_global_data_import VALUES (67062, '2020-09-20', 'PL', 'Poland', 'EURO', '1002', '78330', '12', '2282');
INSERT INTO public.who_global_data_import VALUES (67063, '2020-09-21', 'PL', 'Poland', 'EURO', '910', '79240', '11', '2293');
INSERT INTO public.who_global_data_import VALUES (67064, '2020-09-22', 'PL', 'Poland', 'EURO', '748', '79988', '5', '2298');
INSERT INTO public.who_global_data_import VALUES (67065, '2020-09-23', 'PL', 'Poland', 'EURO', '711', '80699', '18', '2316');
INSERT INTO public.who_global_data_import VALUES (67066, '2020-09-24', 'PL', 'Poland', 'EURO', '974', '81673', '28', '2344');
INSERT INTO public.who_global_data_import VALUES (67067, '2020-09-25', 'PL', 'Poland', 'EURO', '1136', '82809', '25', '2369');
INSERT INTO public.who_global_data_import VALUES (67068, '2020-09-26', 'PL', 'Poland', 'EURO', '1587', '84396', '23', '2392');
INSERT INTO public.who_global_data_import VALUES (67069, '2020-09-27', 'PL', 'Poland', 'EURO', '1584', '85980', '32', '2424');
INSERT INTO public.who_global_data_import VALUES (67070, '2020-09-28', 'PL', 'Poland', 'EURO', '1350', '87330', '8', '2432');
INSERT INTO public.who_global_data_import VALUES (67071, '2020-09-29', 'PL', 'Poland', 'EURO', '1306', '88636', '15', '2447');
INSERT INTO public.who_global_data_import VALUES (67072, '2020-09-30', 'PL', 'Poland', 'EURO', '1326', '89962', '36', '2483');
INSERT INTO public.who_global_data_import VALUES (67073, '2020-10-01', 'PL', 'Poland', 'EURO', '1552', '91514', '30', '2513');
INSERT INTO public.who_global_data_import VALUES (67074, '2020-10-02', 'PL', 'Poland', 'EURO', '1967', '93481', '30', '2543');
INSERT INTO public.who_global_data_import VALUES (67075, '2020-10-03', 'PL', 'Poland', 'EURO', '2292', '95773', '27', '2570');
INSERT INTO public.who_global_data_import VALUES (67076, '2020-10-04', 'PL', 'Poland', 'EURO', '2367', '98140', '34', '2604');
INSERT INTO public.who_global_data_import VALUES (67077, '2020-10-05', 'PL', 'Poland', 'EURO', '0', '98140', '0', '2604');
INSERT INTO public.who_global_data_import VALUES (67078, '2020-10-06', 'PL', 'Poland', 'EURO', '3940', '102080', '55', '2659');
INSERT INTO public.who_global_data_import VALUES (67079, '2020-10-07', 'PL', 'Poland', 'EURO', '2236', '104316', '58', '2717');
INSERT INTO public.who_global_data_import VALUES (67080, '2020-10-08', 'PL', 'Poland', 'EURO', '3003', '107319', '75', '2792');
INSERT INTO public.who_global_data_import VALUES (67081, '2020-10-09', 'PL', 'Poland', 'EURO', '4280', '111599', '75', '2867');
INSERT INTO public.who_global_data_import VALUES (67082, '2020-10-10', 'PL', 'Poland', 'EURO', '4739', '116338', '52', '2919');
INSERT INTO public.who_global_data_import VALUES (67083, '2020-10-11', 'PL', 'Poland', 'EURO', '5300', '121638', '53', '2972');
INSERT INTO public.who_global_data_import VALUES (67084, '2020-10-12', 'PL', 'Poland', 'EURO', '4178', '125816', '32', '3004');
INSERT INTO public.who_global_data_import VALUES (67085, '2020-10-13', 'PL', 'Poland', 'EURO', '4394', '130210', '35', '3039');
INSERT INTO public.who_global_data_import VALUES (67086, '2020-10-14', 'PL', 'Poland', 'EURO', '5068', '135278', '62', '3101');
INSERT INTO public.who_global_data_import VALUES (67087, '2020-10-15', 'PL', 'Poland', 'EURO', '6526', '141804', '116', '3217');
INSERT INTO public.who_global_data_import VALUES (67088, '2020-10-16', 'PL', 'Poland', 'EURO', '8099', '149903', '91', '3308');
INSERT INTO public.who_global_data_import VALUES (67089, '2020-10-17', 'PL', 'Poland', 'EURO', '7705', '157608', '132', '3440');
INSERT INTO public.who_global_data_import VALUES (67090, '2020-10-18', 'PL', 'Poland', 'EURO', '9622', '167230', '84', '3524');
INSERT INTO public.who_global_data_import VALUES (67091, '2020-10-19', 'PL', 'Poland', 'EURO', '8536', '175766', '49', '3573');
INSERT INTO public.who_global_data_import VALUES (67092, '2020-10-20', 'PL', 'Poland', 'EURO', '7482', '183248', '41', '3614');
INSERT INTO public.who_global_data_import VALUES (67093, '2020-10-21', 'PL', 'Poland', 'EURO', '9291', '192539', '107', '3721');
INSERT INTO public.who_global_data_import VALUES (67094, '2020-10-22', 'PL', 'Poland', 'EURO', '10040', '202579', '130', '3851');
INSERT INTO public.who_global_data_import VALUES (67095, '2020-10-23', 'PL', 'Poland', 'EURO', '12107', '214686', '168', '4019');
INSERT INTO public.who_global_data_import VALUES (67096, '2020-10-24', 'PL', 'Poland', 'EURO', '13632', '228318', '153', '4172');
INSERT INTO public.who_global_data_import VALUES (67097, '2020-10-25', 'PL', 'Poland', 'EURO', '13628', '241946', '179', '4351');
INSERT INTO public.who_global_data_import VALUES (67098, '2020-10-26', 'PL', 'Poland', 'EURO', '11742', '253688', '87', '4438');
INSERT INTO public.who_global_data_import VALUES (67099, '2020-10-27', 'PL', 'Poland', 'EURO', '10241', '263929', '45', '4483');
INSERT INTO public.who_global_data_import VALUES (67100, '2020-10-28', 'PL', 'Poland', 'EURO', '16300', '280229', '132', '4615');
INSERT INTO public.who_global_data_import VALUES (67101, '2020-10-29', 'PL', 'Poland', 'EURO', '18820', '299049', '236', '4851');
INSERT INTO public.who_global_data_import VALUES (67102, '2020-10-30', 'PL', 'Poland', 'EURO', '20156', '319205', '298', '5149');
INSERT INTO public.who_global_data_import VALUES (67103, '2020-10-31', 'PL', 'Poland', 'EURO', '21629', '340834', '202', '5351');
INSERT INTO public.who_global_data_import VALUES (67104, '2020-11-01', 'PL', 'Poland', 'EURO', '21897', '362731', '280', '5631');
INSERT INTO public.who_global_data_import VALUES (67105, '2020-11-02', 'PL', 'Poland', 'EURO', '17171', '379902', '152', '5783');
INSERT INTO public.who_global_data_import VALUES (67106, '2020-11-03', 'PL', 'Poland', 'EURO', '15578', '395480', '92', '5875');
INSERT INTO public.who_global_data_import VALUES (67107, '2020-11-04', 'PL', 'Poland', 'EURO', '19364', '414844', '227', '6102');
INSERT INTO public.who_global_data_import VALUES (67108, '2020-11-05', 'PL', 'Poland', 'EURO', '24692', '439536', '373', '6475');
INSERT INTO public.who_global_data_import VALUES (67109, '2020-11-06', 'PL', 'Poland', 'EURO', '27143', '466679', '367', '6842');
INSERT INTO public.who_global_data_import VALUES (67110, '2020-11-07', 'PL', 'Poland', 'EURO', '27086', '493765', '445', '7287');
INSERT INTO public.who_global_data_import VALUES (67111, '2020-11-08', 'PL', 'Poland', 'EURO', '27875', '521640', '349', '7636');
INSERT INTO public.who_global_data_import VALUES (67112, '2020-11-09', 'PL', 'Poland', 'EURO', '24785', '546425', '236', '7872');
INSERT INTO public.who_global_data_import VALUES (67113, '2020-11-10', 'PL', 'Poland', 'EURO', '21713', '568138', '173', '8045');
INSERT INTO public.who_global_data_import VALUES (67114, '2020-11-11', 'PL', 'Poland', 'EURO', '25454', '593592', '330', '8375');
INSERT INTO public.who_global_data_import VALUES (67115, '2020-11-12', 'PL', 'Poland', 'EURO', '25221', '618813', '430', '8805');
INSERT INTO public.who_global_data_import VALUES (67116, '2020-11-13', 'PL', 'Poland', 'EURO', '22683', '641496', '275', '9080');
INSERT INTO public.who_global_data_import VALUES (67117, '2020-11-14', 'PL', 'Poland', 'EURO', '24051', '665547', '419', '9499');
INSERT INTO public.who_global_data_import VALUES (67118, '2020-11-15', 'PL', 'Poland', 'EURO', '25571', '691118', '546', '10045');
INSERT INTO public.who_global_data_import VALUES (67119, '2020-11-16', 'PL', 'Poland', 'EURO', '21854', '712972', '303', '10348');
INSERT INTO public.who_global_data_import VALUES (67120, '2020-11-17', 'PL', 'Poland', 'EURO', '20816', '733788', '143', '10491');
INSERT INTO public.who_global_data_import VALUES (67121, '2020-11-18', 'PL', 'Poland', 'EURO', '19152', '752940', '357', '10848');
INSERT INTO public.who_global_data_import VALUES (67122, '2020-11-19', 'PL', 'Poland', 'EURO', '19883', '772823', '603', '11451');
INSERT INTO public.who_global_data_import VALUES (67123, '2020-11-20', 'PL', 'Poland', 'EURO', '23975', '796798', '637', '12088');
INSERT INTO public.who_global_data_import VALUES (67124, '2020-11-21', 'PL', 'Poland', 'EURO', '22464', '819262', '626', '12714');
INSERT INTO public.who_global_data_import VALUES (67125, '2020-11-22', 'PL', 'Poland', 'EURO', '24213', '843475', '574', '13288');
INSERT INTO public.who_global_data_import VALUES (67126, '2020-11-23', 'PL', 'Poland', 'EURO', '17856', '861331', '330', '13618');
INSERT INTO public.who_global_data_import VALUES (67127, '2020-11-24', 'PL', 'Poland', 'EURO', '15002', '876333', '156', '13774');
INSERT INTO public.who_global_data_import VALUES (67128, '2020-11-25', 'PL', 'Poland', 'EURO', '32733', '909066', '540', '14314');
INSERT INTO public.who_global_data_import VALUES (67129, '2020-11-26', 'PL', 'Poland', 'EURO', '15356', '924422', '674', '14988');
INSERT INTO public.who_global_data_import VALUES (67130, '2020-11-27', 'PL', 'Poland', 'EURO', '16690', '941112', '580', '15568');
INSERT INTO public.who_global_data_import VALUES (67131, '2020-11-28', 'PL', 'Poland', 'EURO', '17304', '958416', '579', '16147');
INSERT INTO public.who_global_data_import VALUES (67132, '2020-11-29', 'PL', 'Poland', 'EURO', '15177', '973593', '599', '16746');
INSERT INTO public.who_global_data_import VALUES (67133, '2020-11-30', 'PL', 'Poland', 'EURO', '11482', '985075', '283', '17029');
INSERT INTO public.who_global_data_import VALUES (67134, '2020-12-01', 'PL', 'Poland', 'EURO', '5736', '990811', '121', '17150');
INSERT INTO public.who_global_data_import VALUES (67135, '2020-12-02', 'PL', 'Poland', 'EURO', '9113', '999924', '449', '17599');
INSERT INTO public.who_global_data_import VALUES (67136, '2020-12-03', 'PL', 'Poland', 'EURO', '13823', '1013747', '609', '18208');
INSERT INTO public.who_global_data_import VALUES (67137, '2020-12-04', 'PL', 'Poland', 'EURO', '14863', '1028610', '620', '18828');
INSERT INTO public.who_global_data_import VALUES (67138, '2020-12-05', 'PL', 'Poland', 'EURO', '13236', '1041846', '531', '19359');
INSERT INTO public.who_global_data_import VALUES (67139, '2020-12-06', 'PL', 'Poland', 'EURO', '12427', '1054273', '502', '19861');
INSERT INTO public.who_global_data_import VALUES (67140, '2020-12-07', 'PL', 'Poland', 'EURO', '9176', '1063449', '228', '20089');
INSERT INTO public.who_global_data_import VALUES (67141, '2020-12-08', 'PL', 'Poland', 'EURO', '4421', '1067870', '92', '20181');
INSERT INTO public.who_global_data_import VALUES (67142, '2020-12-09', 'PL', 'Poland', 'EURO', '8310', '1076180', '411', '20592');
INSERT INTO public.who_global_data_import VALUES (67143, '2020-12-10', 'PL', 'Poland', 'EURO', '12166', '1088346', '568', '21160');
INSERT INTO public.who_global_data_import VALUES (67144, '2020-12-11', 'PL', 'Poland', 'EURO', '13750', '1102096', '470', '21630');
INSERT INTO public.who_global_data_import VALUES (67145, '2020-12-12', 'PL', 'Poland', 'EURO', '13105', '1115201', '544', '22174');
INSERT INTO public.who_global_data_import VALUES (67146, '2020-12-13', 'PL', 'Poland', 'EURO', '11499', '1126700', '502', '22676');
INSERT INTO public.who_global_data_import VALUES (67147, '2020-12-14', 'PL', 'Poland', 'EURO', '8976', '1135676', '188', '22864');
INSERT INTO public.who_global_data_import VALUES (67148, '2020-12-15', 'PL', 'Poland', 'EURO', '11770', '1147446', '445', '23309');
INSERT INTO public.who_global_data_import VALUES (67149, '2020-12-16', 'PL', 'Poland', 'EURO', '12455', '1159901', '605', '23914');
INSERT INTO public.who_global_data_import VALUES (67150, '2020-12-17', 'PL', 'Poland', 'EURO', '11953', '1171854', '431', '24345');
INSERT INTO public.who_global_data_import VALUES (67151, '2020-12-18', 'PL', 'Poland', 'EURO', '11010', '1182864', '426', '24771');
INSERT INTO public.who_global_data_import VALUES (67152, '2020-12-19', 'PL', 'Poland', 'EURO', '11246', '1194110', '483', '25254');
INSERT INTO public.who_global_data_import VALUES (67153, '2020-12-20', 'PL', 'Poland', 'EURO', '8590', '1202700', '143', '25397');
INSERT INTO public.who_global_data_import VALUES (67154, '2020-12-21', 'PL', 'Poland', 'EURO', '4633', '1207333', '77', '25474');
INSERT INTO public.who_global_data_import VALUES (67155, '2020-12-22', 'PL', 'Poland', 'EURO', '7192', '1214525', '309', '25783');
INSERT INTO public.who_global_data_import VALUES (67156, '2020-12-23', 'PL', 'Poland', 'EURO', '12358', '1226883', '472', '26255');
INSERT INTO public.who_global_data_import VALUES (67157, '2020-12-24', 'PL', 'Poland', 'EURO', '13115', '1239998', '497', '26752');
INSERT INTO public.who_global_data_import VALUES (67158, '2020-12-25', 'PL', 'Poland', 'EURO', '9081', '1249079', '240', '26992');
INSERT INTO public.who_global_data_import VALUES (67159, '2020-12-26', 'PL', 'Poland', 'EURO', '4878', '1253957', '69', '27061');
INSERT INTO public.who_global_data_import VALUES (67160, '2020-12-27', 'PL', 'Poland', 'EURO', '3842', '1257799', '57', '27118');
INSERT INTO public.who_global_data_import VALUES (67161, '2020-12-28', 'PL', 'Poland', 'EURO', '3211', '1261010', '29', '27147');
INSERT INTO public.who_global_data_import VALUES (67162, '2020-12-29', 'PL', 'Poland', 'EURO', '7624', '1268634', '307', '27454');
INSERT INTO public.who_global_data_import VALUES (67163, '2020-12-30', 'PL', 'Poland', 'EURO', '12780', '1281414', '565', '28019');
INSERT INTO public.who_global_data_import VALUES (67164, '2020-12-31', 'PL', 'Poland', 'EURO', '13464', '1294878', '535', '28554');
INSERT INTO public.who_global_data_import VALUES (67165, '2021-01-01', 'PL', 'Poland', 'EURO', '10896', '1305774', '402', '28956');
INSERT INTO public.who_global_data_import VALUES (67166, '2021-01-02', 'PL', 'Poland', 'EURO', '7006', '1312780', '102', '29058');
INSERT INTO public.who_global_data_import VALUES (67167, '2021-01-03', 'PL', 'Poland', 'EURO', '5782', '1318562', '61', '29119');
INSERT INTO public.who_global_data_import VALUES (67168, '2021-01-04', 'PL', 'Poland', 'EURO', '4385', '1322947', '42', '29161');
INSERT INTO public.who_global_data_import VALUES (67169, '2021-01-05', 'PL', 'Poland', 'EURO', '7596', '1330543', '341', '29502');
INSERT INTO public.who_global_data_import VALUES (67170, '2021-01-06', 'PL', 'Poland', 'EURO', '14220', '1344763', '553', '30055');
INSERT INTO public.who_global_data_import VALUES (67171, '2021-01-07', 'PL', 'Poland', 'EURO', '12119', '1356882', '186', '30241');
INSERT INTO public.who_global_data_import VALUES (67172, '2021-01-08', 'PL', 'Poland', 'EURO', '8763', '1365645', '333', '30574');
INSERT INTO public.who_global_data_import VALUES (67173, '2021-01-09', 'PL', 'Poland', 'EURO', '10744', '1376389', '437', '31011');
INSERT INTO public.who_global_data_import VALUES (67174, '2021-01-10', 'PL', 'Poland', 'EURO', '9133', '1385522', '178', '31189');
INSERT INTO public.who_global_data_import VALUES (67175, '2021-01-11', 'PL', 'Poland', 'EURO', '4863', '1390385', '75', '31264');
INSERT INTO public.who_global_data_import VALUES (67176, '2021-01-12', 'PL', 'Poland', 'EURO', '5467', '1395852', '329', '31593');
INSERT INTO public.who_global_data_import VALUES (67177, '2021-01-13', 'PL', 'Poland', 'EURO', '9053', '1404905', '481', '32074');
INSERT INTO public.who_global_data_import VALUES (67178, '2021-01-14', 'PL', 'Poland', 'EURO', '9457', '1414362', '382', '32456');
INSERT INTO public.who_global_data_import VALUES (67179, '2021-01-15', 'PL', 'Poland', 'EURO', '7958', '1422320', '388', '32844');
INSERT INTO public.who_global_data_import VALUES (67180, '2021-01-16', 'PL', 'Poland', 'EURO', '7292', '1429612', '369', '33213');
INSERT INTO public.who_global_data_import VALUES (67181, '2021-01-17', 'PL', 'Poland', 'EURO', '5970', '1435582', '142', '33355');
INSERT INTO public.who_global_data_import VALUES (67182, '2021-01-18', 'PL', 'Poland', 'EURO', '3332', '1438914', '52', '33407');
INSERT INTO public.who_global_data_import VALUES (67183, '2021-01-19', 'PL', 'Poland', 'EURO', '4890', '1443804', '291', '33698');
INSERT INTO public.who_global_data_import VALUES (67184, '2021-01-20', 'PL', 'Poland', 'EURO', '6943', '1450747', '443', '34141');
INSERT INTO public.who_global_data_import VALUES (67185, '2021-01-21', 'PL', 'Poland', 'EURO', '7008', '1457755', '420', '34561');
INSERT INTO public.who_global_data_import VALUES (67186, '2021-01-22', 'PL', 'Poland', 'EURO', '6693', '1464448', '347', '34908');
INSERT INTO public.who_global_data_import VALUES (67187, '2021-01-23', 'PL', 'Poland', 'EURO', '6431', '1470879', '345', '35253');
INSERT INTO public.who_global_data_import VALUES (67188, '2021-01-24', 'PL', 'Poland', 'EURO', '4566', '1475445', '110', '35363');
INSERT INTO public.who_global_data_import VALUES (67189, '2021-01-25', 'PL', 'Poland', 'EURO', '2674', '1478119', '38', '35401');
INSERT INTO public.who_global_data_import VALUES (67190, '2021-01-26', 'PL', 'Poland', 'EURO', '4603', '1482722', '264', '35665');
INSERT INTO public.who_global_data_import VALUES (67191, '2021-01-27', 'PL', 'Poland', 'EURO', '6790', '1489512', '389', '36054');
INSERT INTO public.who_global_data_import VALUES (67192, '2021-01-28', 'PL', 'Poland', 'EURO', '7153', '1496665', '389', '36443');
INSERT INTO public.who_global_data_import VALUES (67193, '2021-01-29', 'PL', 'Poland', 'EURO', '6145', '1502810', '337', '36780');
INSERT INTO public.who_global_data_import VALUES (67194, '2021-01-30', 'PL', 'Poland', 'EURO', '5864', '1508674', '302', '37082');
INSERT INTO public.who_global_data_import VALUES (67195, '2021-01-31', 'PL', 'Poland', 'EURO', '4711', '1513385', '98', '37180');
INSERT INTO public.who_global_data_import VALUES (67196, '2021-02-01', 'PL', 'Poland', 'EURO', '2504', '1515889', '42', '37222');
INSERT INTO public.who_global_data_import VALUES (67197, '2021-02-02', 'PL', 'Poland', 'EURO', '4326', '1520215', '254', '37476');
INSERT INTO public.who_global_data_import VALUES (67198, '2021-02-03', 'PL', 'Poland', 'EURO', '6801', '1527016', '421', '37897');
INSERT INTO public.who_global_data_import VALUES (67199, '2021-02-04', 'PL', 'Poland', 'EURO', '6495', '1533511', '447', '38344');
INSERT INTO public.who_global_data_import VALUES (67200, '2021-02-05', 'PL', 'Poland', 'EURO', '6053', '1539564', '368', '38712');
INSERT INTO public.who_global_data_import VALUES (67201, '2020-01-03', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67202, '2020-01-04', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67203, '2020-01-05', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67204, '2020-01-06', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67205, '2020-01-07', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67206, '2020-01-08', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67207, '2020-01-09', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67208, '2020-01-10', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67209, '2020-01-11', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67210, '2020-01-12', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67211, '2020-01-13', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67212, '2020-01-14', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67213, '2020-01-15', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67214, '2020-01-16', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67215, '2020-01-17', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67216, '2020-01-18', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67217, '2020-01-19', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67218, '2020-01-20', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67219, '2020-01-21', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67220, '2020-01-22', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67221, '2020-01-23', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67222, '2020-01-24', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67223, '2020-01-25', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67224, '2020-01-26', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67225, '2020-01-27', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67226, '2020-01-28', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67227, '2020-01-29', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67228, '2020-01-30', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67229, '2020-01-31', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67230, '2020-02-01', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67231, '2020-02-02', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67232, '2020-02-03', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67233, '2020-02-04', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67234, '2020-02-05', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67235, '2020-02-06', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67236, '2020-02-07', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67237, '2020-02-08', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67238, '2020-02-09', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67239, '2020-02-10', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67240, '2020-02-11', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67241, '2020-02-12', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67242, '2020-02-13', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67243, '2020-02-14', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67244, '2020-02-15', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67245, '2020-02-16', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67246, '2020-02-17', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67247, '2020-02-18', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67248, '2020-02-19', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67249, '2020-02-20', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67250, '2020-02-21', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67251, '2020-02-22', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67252, '2020-02-23', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67253, '2020-02-24', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67254, '2020-02-25', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67255, '2020-02-26', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67256, '2020-02-27', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67257, '2020-02-28', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67258, '2020-02-29', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67259, '2020-03-01', 'PT', 'Portugal', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67260, '2020-03-02', 'PT', 'Portugal', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67261, '2020-03-03', 'PT', 'Portugal', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67262, '2020-03-04', 'PT', 'Portugal', 'EURO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67263, '2020-03-05', 'PT', 'Portugal', 'EURO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67264, '2020-03-06', 'PT', 'Portugal', 'EURO', '4', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67265, '2020-03-07', 'PT', 'Portugal', 'EURO', '4', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67266, '2020-03-08', 'PT', 'Portugal', 'EURO', '8', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67267, '2020-03-09', 'PT', 'Portugal', 'EURO', '9', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67268, '2020-03-10', 'PT', 'Portugal', 'EURO', '9', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67269, '2020-03-11', 'PT', 'Portugal', 'EURO', '2', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67270, '2020-03-12', 'PT', 'Portugal', 'EURO', '18', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67271, '2020-03-13', 'PT', 'Portugal', 'EURO', '19', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67272, '2020-03-14', 'PT', 'Portugal', 'EURO', '34', '112', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67273, '2020-03-15', 'PT', 'Portugal', 'EURO', '57', '169', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67274, '2020-03-16', 'PT', 'Portugal', 'EURO', '76', '245', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67275, '2020-03-17', 'PT', 'Portugal', 'EURO', '86', '331', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67276, '2020-03-18', 'PT', 'Portugal', 'EURO', '117', '448', '1', '1');
INSERT INTO public.who_global_data_import VALUES (67277, '2020-03-19', 'PT', 'Portugal', 'EURO', '194', '642', '1', '2');
INSERT INTO public.who_global_data_import VALUES (67278, '2020-03-20', 'PT', 'Portugal', 'EURO', '143', '785', '1', '3');
INSERT INTO public.who_global_data_import VALUES (67279, '2020-03-21', 'PT', 'Portugal', 'EURO', '235', '1020', '3', '6');
INSERT INTO public.who_global_data_import VALUES (67280, '2020-03-22', 'PT', 'Portugal', 'EURO', '260', '1280', '6', '12');
INSERT INTO public.who_global_data_import VALUES (67281, '2020-03-23', 'PT', 'Portugal', 'EURO', '320', '1600', '2', '14');
INSERT INTO public.who_global_data_import VALUES (67282, '2020-03-24', 'PT', 'Portugal', 'EURO', '460', '2060', '9', '23');
INSERT INTO public.who_global_data_import VALUES (67283, '2020-03-25', 'PT', 'Portugal', 'EURO', '302', '2362', '10', '33');
INSERT INTO public.who_global_data_import VALUES (67284, '2020-03-26', 'PT', 'Portugal', 'EURO', '633', '2995', '10', '43');
INSERT INTO public.who_global_data_import VALUES (67285, '2020-03-27', 'PT', 'Portugal', 'EURO', '549', '3544', '17', '60');
INSERT INTO public.who_global_data_import VALUES (67286, '2020-03-28', 'PT', 'Portugal', 'EURO', '724', '4268', '16', '76');
INSERT INTO public.who_global_data_import VALUES (67287, '2020-03-29', 'PT', 'Portugal', 'EURO', '902', '5170', '24', '100');
INSERT INTO public.who_global_data_import VALUES (67288, '2020-03-30', 'PT', 'Portugal', 'EURO', '792', '5962', '19', '119');
INSERT INTO public.who_global_data_import VALUES (67289, '2020-03-31', 'PT', 'Portugal', 'EURO', '446', '6408', '21', '140');
INSERT INTO public.who_global_data_import VALUES (67290, '2020-04-01', 'PT', 'Portugal', 'EURO', '1035', '7443', '20', '160');
INSERT INTO public.who_global_data_import VALUES (67291, '2020-04-02', 'PT', 'Portugal', 'EURO', '808', '8251', '27', '187');
INSERT INTO public.who_global_data_import VALUES (67292, '2020-04-03', 'PT', 'Portugal', 'EURO', '783', '9034', '22', '209');
INSERT INTO public.who_global_data_import VALUES (67293, '2020-04-04', 'PT', 'Portugal', 'EURO', '852', '9886', '37', '246');
INSERT INTO public.who_global_data_import VALUES (67294, '2020-04-05', 'PT', 'Portugal', 'EURO', '638', '10524', '20', '266');
INSERT INTO public.who_global_data_import VALUES (67295, '2020-04-06', 'PT', 'Portugal', 'EURO', '754', '11278', '29', '295');
INSERT INTO public.who_global_data_import VALUES (67296, '2020-04-07', 'PT', 'Portugal', 'EURO', '452', '11730', '16', '311');
INSERT INTO public.who_global_data_import VALUES (67297, '2020-04-08', 'PT', 'Portugal', 'EURO', '712', '12442', '34', '345');
INSERT INTO public.who_global_data_import VALUES (67298, '2020-04-09', 'PT', 'Portugal', 'EURO', '699', '13141', '35', '380');
INSERT INTO public.who_global_data_import VALUES (67299, '2020-04-10', 'PT', 'Portugal', 'EURO', '815', '13956', '29', '409');
INSERT INTO public.who_global_data_import VALUES (67300, '2020-04-11', 'PT', 'Portugal', 'EURO', '1516', '15472', '26', '435');
INSERT INTO public.who_global_data_import VALUES (67301, '2020-04-12', 'PT', 'Portugal', 'EURO', '515', '15987', '35', '470');
INSERT INTO public.who_global_data_import VALUES (67302, '2020-04-13', 'PT', 'Portugal', 'EURO', '598', '16585', '34', '504');
INSERT INTO public.who_global_data_import VALUES (67303, '2020-04-14', 'PT', 'Portugal', 'EURO', '349', '16934', '31', '535');
INSERT INTO public.who_global_data_import VALUES (67304, '2020-04-15', 'PT', 'Portugal', 'EURO', '514', '17448', '32', '567');
INSERT INTO public.who_global_data_import VALUES (67305, '2020-04-16', 'PT', 'Portugal', 'EURO', '643', '18091', '32', '599');
INSERT INTO public.who_global_data_import VALUES (67306, '2020-04-17', 'PT', 'Portugal', 'EURO', '750', '18841', '30', '629');
INSERT INTO public.who_global_data_import VALUES (67307, '2020-04-18', 'PT', 'Portugal', 'EURO', '181', '19022', '28', '657');
INSERT INTO public.who_global_data_import VALUES (67308, '2020-04-19', 'PT', 'Portugal', 'EURO', '663', '19685', '30', '687');
INSERT INTO public.who_global_data_import VALUES (67309, '2020-04-20', 'PT', 'Portugal', 'EURO', '521', '20206', '27', '714');
INSERT INTO public.who_global_data_import VALUES (67310, '2020-04-21', 'PT', 'Portugal', 'EURO', '657', '20863', '21', '735');
INSERT INTO public.who_global_data_import VALUES (67311, '2020-04-22', 'PT', 'Portugal', 'EURO', '516', '21379', '27', '762');
INSERT INTO public.who_global_data_import VALUES (67312, '2020-04-23', 'PT', 'Portugal', 'EURO', '603', '21982', '23', '785');
INSERT INTO public.who_global_data_import VALUES (67313, '2020-04-24', 'PT', 'Portugal', 'EURO', '371', '22353', '35', '820');
INSERT INTO public.who_global_data_import VALUES (67314, '2020-04-25', 'PT', 'Portugal', 'EURO', '918', '23271', '60', '880');
INSERT INTO public.who_global_data_import VALUES (67315, '2020-04-26', 'PT', 'Portugal', 'EURO', '412', '23683', '23', '903');
INSERT INTO public.who_global_data_import VALUES (67316, '2020-04-27', 'PT', 'Portugal', 'EURO', '163', '23846', '25', '928');
INSERT INTO public.who_global_data_import VALUES (67317, '2020-04-28', 'PT', 'Portugal', 'EURO', '298', '24144', '20', '948');
INSERT INTO public.who_global_data_import VALUES (67318, '2020-04-29', 'PT', 'Portugal', 'EURO', '180', '24324', '25', '973');
INSERT INTO public.who_global_data_import VALUES (67319, '2020-04-30', 'PT', 'Portugal', 'EURO', '368', '24692', '16', '989');
INSERT INTO public.who_global_data_import VALUES (67320, '2020-05-01', 'PT', 'Portugal', 'EURO', '295', '24987', '18', '1007');
INSERT INTO public.who_global_data_import VALUES (67321, '2020-05-02', 'PT', 'Portugal', 'EURO', '364', '25351', '0', '1007');
INSERT INTO public.who_global_data_import VALUES (68014, '2020-01-16', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67322, '2020-05-03', 'PT', 'Portugal', 'EURO', '-161', '25190', '16', '1023');
INSERT INTO public.who_global_data_import VALUES (67323, '2020-05-04', 'PT', 'Portugal', 'EURO', '334', '25524', '40', '1063');
INSERT INTO public.who_global_data_import VALUES (67324, '2020-05-05', 'PT', 'Portugal', 'EURO', '0', '25524', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (67325, '2020-05-06', 'PT', 'Portugal', 'EURO', '178', '25702', '11', '1074');
INSERT INTO public.who_global_data_import VALUES (67326, '2020-05-07', 'PT', 'Portugal', 'EURO', '480', '26182', '15', '1089');
INSERT INTO public.who_global_data_import VALUES (67327, '2020-05-08', 'PT', 'Portugal', 'EURO', '533', '26715', '16', '1105');
INSERT INTO public.who_global_data_import VALUES (67328, '2020-05-09', 'PT', 'Portugal', 'EURO', '553', '27268', '9', '1114');
INSERT INTO public.who_global_data_import VALUES (67329, '2020-05-10', 'PT', 'Portugal', 'EURO', '138', '27406', '12', '1126');
INSERT INTO public.who_global_data_import VALUES (67330, '2020-05-11', 'PT', 'Portugal', 'EURO', '175', '27581', '9', '1135');
INSERT INTO public.who_global_data_import VALUES (67331, '2020-05-12', 'PT', 'Portugal', 'EURO', '98', '27679', '9', '1144');
INSERT INTO public.who_global_data_import VALUES (67332, '2020-05-13', 'PT', 'Portugal', 'EURO', '234', '27913', '19', '1163');
INSERT INTO public.who_global_data_import VALUES (67333, '2020-05-14', 'PT', 'Portugal', 'EURO', '219', '28132', '12', '1175');
INSERT INTO public.who_global_data_import VALUES (67334, '2020-05-15', 'PT', 'Portugal', 'EURO', '187', '28319', '9', '1184');
INSERT INTO public.who_global_data_import VALUES (67335, '2020-05-16', 'PT', 'Portugal', 'EURO', '264', '28583', '6', '1190');
INSERT INTO public.who_global_data_import VALUES (67336, '2020-05-17', 'PT', 'Portugal', 'EURO', '227', '28810', '13', '1203');
INSERT INTO public.who_global_data_import VALUES (67337, '2020-05-18', 'PT', 'Portugal', 'EURO', '226', '29036', '15', '1218');
INSERT INTO public.who_global_data_import VALUES (67338, '2020-05-19', 'PT', 'Portugal', 'EURO', '173', '29209', '13', '1231');
INSERT INTO public.who_global_data_import VALUES (67339, '2020-05-20', 'PT', 'Portugal', 'EURO', '223', '29432', '16', '1247');
INSERT INTO public.who_global_data_import VALUES (67340, '2020-05-21', 'PT', 'Portugal', 'EURO', '228', '29660', '16', '1263');
INSERT INTO public.who_global_data_import VALUES (67341, '2020-05-22', 'PT', 'Portugal', 'EURO', '252', '29912', '14', '1277');
INSERT INTO public.who_global_data_import VALUES (67342, '2020-05-23', 'PT', 'Portugal', 'EURO', '288', '30200', '12', '1289');
INSERT INTO public.who_global_data_import VALUES (67343, '2020-05-24', 'PT', 'Portugal', 'EURO', '271', '30471', '13', '1302');
INSERT INTO public.who_global_data_import VALUES (67344, '2020-05-25', 'PT', 'Portugal', 'EURO', '152', '30623', '14', '1316');
INSERT INTO public.who_global_data_import VALUES (67345, '2020-05-26', 'PT', 'Portugal', 'EURO', '165', '30788', '14', '1330');
INSERT INTO public.who_global_data_import VALUES (67346, '2020-05-27', 'PT', 'Portugal', 'EURO', '219', '31007', '12', '1342');
INSERT INTO public.who_global_data_import VALUES (67347, '2020-05-28', 'PT', 'Portugal', 'EURO', '285', '31292', '14', '1356');
INSERT INTO public.who_global_data_import VALUES (67348, '2020-05-29', 'PT', 'Portugal', 'EURO', '304', '31596', '13', '1369');
INSERT INTO public.who_global_data_import VALUES (67349, '2020-05-30', 'PT', 'Portugal', 'EURO', '350', '31946', '14', '1383');
INSERT INTO public.who_global_data_import VALUES (67350, '2020-05-31', 'PT', 'Portugal', 'EURO', '257', '32203', '13', '1396');
INSERT INTO public.who_global_data_import VALUES (67351, '2020-06-01', 'PT', 'Portugal', 'EURO', '297', '32500', '14', '1410');
INSERT INTO public.who_global_data_import VALUES (67352, '2020-06-02', 'PT', 'Portugal', 'EURO', '200', '32700', '14', '1424');
INSERT INTO public.who_global_data_import VALUES (67353, '2020-06-03', 'PT', 'Portugal', 'EURO', '195', '32895', '12', '1436');
INSERT INTO public.who_global_data_import VALUES (67354, '2020-06-04', 'PT', 'Portugal', 'EURO', '366', '33261', '11', '1447');
INSERT INTO public.who_global_data_import VALUES (67355, '2020-06-05', 'PT', 'Portugal', 'EURO', '331', '33592', '8', '1455');
INSERT INTO public.who_global_data_import VALUES (67356, '2020-06-06', 'PT', 'Portugal', 'EURO', '377', '33969', '10', '1465');
INSERT INTO public.who_global_data_import VALUES (67357, '2020-06-07', 'PT', 'Portugal', 'EURO', '382', '34351', '9', '1474');
INSERT INTO public.who_global_data_import VALUES (67358, '2020-06-08', 'PT', 'Portugal', 'EURO', '142', '34493', '5', '1479');
INSERT INTO public.who_global_data_import VALUES (67359, '2020-06-09', 'PT', 'Portugal', 'EURO', '392', '34885', '6', '1485');
INSERT INTO public.who_global_data_import VALUES (67360, '2020-06-10', 'PT', 'Portugal', 'EURO', '421', '35306', '7', '1492');
INSERT INTO public.who_global_data_import VALUES (67361, '2020-06-11', 'PT', 'Portugal', 'EURO', '294', '35600', '3', '1495');
INSERT INTO public.who_global_data_import VALUES (67362, '2020-06-12', 'PT', 'Portugal', 'EURO', '310', '35910', '9', '1504');
INSERT INTO public.who_global_data_import VALUES (67363, '2020-06-13', 'PT', 'Portugal', 'EURO', '270', '36180', '1', '1505');
INSERT INTO public.who_global_data_import VALUES (67364, '2020-06-14', 'PT', 'Portugal', 'EURO', '283', '36463', '7', '1512');
INSERT INTO public.who_global_data_import VALUES (67365, '2020-06-15', 'PT', 'Portugal', 'EURO', '227', '36690', '5', '1517');
INSERT INTO public.who_global_data_import VALUES (67366, '2020-06-16', 'PT', 'Portugal', 'EURO', '346', '37036', '3', '1520');
INSERT INTO public.who_global_data_import VALUES (67367, '2020-06-17', 'PT', 'Portugal', 'EURO', '300', '37336', '2', '1522');
INSERT INTO public.who_global_data_import VALUES (67368, '2020-06-18', 'PT', 'Portugal', 'EURO', '336', '37672', '1', '1523');
INSERT INTO public.who_global_data_import VALUES (67369, '2020-06-19', 'PT', 'Portugal', 'EURO', '417', '38089', '1', '1524');
INSERT INTO public.who_global_data_import VALUES (67370, '2020-06-20', 'PT', 'Portugal', 'EURO', '375', '38464', '3', '1527');
INSERT INTO public.who_global_data_import VALUES (67371, '2020-06-21', 'PT', 'Portugal', 'EURO', '377', '38841', '1', '1528');
INSERT INTO public.who_global_data_import VALUES (67372, '2020-06-22', 'PT', 'Portugal', 'EURO', '292', '39133', '2', '1530');
INSERT INTO public.who_global_data_import VALUES (67373, '2020-06-23', 'PT', 'Portugal', 'EURO', '259', '39392', '4', '1534');
INSERT INTO public.who_global_data_import VALUES (67374, '2020-06-24', 'PT', 'Portugal', 'EURO', '345', '39737', '6', '1540');
INSERT INTO public.who_global_data_import VALUES (67375, '2020-06-25', 'PT', 'Portugal', 'EURO', '367', '40104', '3', '1543');
INSERT INTO public.who_global_data_import VALUES (67376, '2020-06-26', 'PT', 'Portugal', 'EURO', '311', '40415', '6', '1549');
INSERT INTO public.who_global_data_import VALUES (67377, '2020-06-27', 'PT', 'Portugal', 'EURO', '451', '40866', '6', '1555');
INSERT INTO public.who_global_data_import VALUES (67378, '2020-06-28', 'PT', 'Portugal', 'EURO', '323', '41189', '6', '1561');
INSERT INTO public.who_global_data_import VALUES (67379, '2020-06-29', 'PT', 'Portugal', 'EURO', '457', '41646', '3', '1564');
INSERT INTO public.who_global_data_import VALUES (67380, '2020-06-30', 'PT', 'Portugal', 'EURO', '266', '41912', '4', '1568');
INSERT INTO public.who_global_data_import VALUES (67381, '2020-07-01', 'PT', 'Portugal', 'EURO', '229', '42141', '8', '1576');
INSERT INTO public.who_global_data_import VALUES (67382, '2020-07-02', 'PT', 'Portugal', 'EURO', '313', '42454', '3', '1579');
INSERT INTO public.who_global_data_import VALUES (67383, '2020-07-03', 'PT', 'Portugal', 'EURO', '328', '42782', '8', '1587');
INSERT INTO public.who_global_data_import VALUES (67384, '2020-07-04', 'PT', 'Portugal', 'EURO', '374', '43156', '11', '1598');
INSERT INTO public.who_global_data_import VALUES (67385, '2020-07-05', 'PT', 'Portugal', 'EURO', '413', '43569', '7', '1605');
INSERT INTO public.who_global_data_import VALUES (67386, '2020-07-06', 'PT', 'Portugal', 'EURO', '328', '43897', '9', '1614');
INSERT INTO public.who_global_data_import VALUES (67387, '2020-07-07', 'PT', 'Portugal', 'EURO', '232', '44129', '6', '1620');
INSERT INTO public.who_global_data_import VALUES (67388, '2020-07-08', 'PT', 'Portugal', 'EURO', '287', '44416', '9', '1629');
INSERT INTO public.who_global_data_import VALUES (67389, '2020-07-09', 'PT', 'Portugal', 'EURO', '443', '44859', '2', '1631');
INSERT INTO public.who_global_data_import VALUES (67390, '2020-07-10', 'PT', 'Portugal', 'EURO', '418', '45277', '13', '1644');
INSERT INTO public.who_global_data_import VALUES (67391, '2020-07-11', 'PT', 'Portugal', 'EURO', '402', '45679', '2', '1646');
INSERT INTO public.who_global_data_import VALUES (67392, '2020-07-12', 'PT', 'Portugal', 'EURO', '542', '46221', '8', '1654');
INSERT INTO public.who_global_data_import VALUES (67393, '2020-07-13', 'PT', 'Portugal', 'EURO', '291', '46512', '6', '1660');
INSERT INTO public.who_global_data_import VALUES (67394, '2020-07-14', 'PT', 'Portugal', 'EURO', '306', '46818', '2', '1662');
INSERT INTO public.who_global_data_import VALUES (67395, '2020-07-15', 'PT', 'Portugal', 'EURO', '233', '47051', '6', '1668');
INSERT INTO public.who_global_data_import VALUES (67396, '2020-07-16', 'PT', 'Portugal', 'EURO', '375', '47426', '8', '1676');
INSERT INTO public.who_global_data_import VALUES (67397, '2020-07-17', 'PT', 'Portugal', 'EURO', '339', '47765', '3', '1679');
INSERT INTO public.who_global_data_import VALUES (67398, '2020-07-18', 'PT', 'Portugal', 'EURO', '312', '48077', '3', '1682');
INSERT INTO public.who_global_data_import VALUES (67399, '2020-07-19', 'PT', 'Portugal', 'EURO', '313', '48390', '2', '1684');
INSERT INTO public.who_global_data_import VALUES (67400, '2020-07-20', 'PT', 'Portugal', 'EURO', '246', '48636', '5', '1689');
INSERT INTO public.who_global_data_import VALUES (67401, '2020-07-21', 'PT', 'Portugal', 'EURO', '135', '48771', '2', '1691');
INSERT INTO public.who_global_data_import VALUES (67402, '2020-07-22', 'PT', 'Portugal', 'EURO', '127', '48898', '6', '1697');
INSERT INTO public.who_global_data_import VALUES (67403, '2020-07-23', 'PT', 'Portugal', 'EURO', '252', '49150', '5', '1702');
INSERT INTO public.who_global_data_import VALUES (67404, '2020-07-24', 'PT', 'Portugal', 'EURO', '229', '49379', '3', '1705');
INSERT INTO public.who_global_data_import VALUES (67405, '2020-07-25', 'PT', 'Portugal', 'EURO', '313', '49692', '7', '1712');
INSERT INTO public.who_global_data_import VALUES (67406, '2020-07-26', 'PT', 'Portugal', 'EURO', '263', '49955', '4', '1716');
INSERT INTO public.who_global_data_import VALUES (67407, '2020-07-27', 'PT', 'Portugal', 'EURO', '209', '50164', '1', '1717');
INSERT INTO public.who_global_data_import VALUES (67408, '2020-07-28', 'PT', 'Portugal', 'EURO', '135', '50299', '2', '1719');
INSERT INTO public.who_global_data_import VALUES (67409, '2020-07-29', 'PT', 'Portugal', 'EURO', '111', '50410', '3', '1722');
INSERT INTO public.who_global_data_import VALUES (67410, '2020-07-30', 'PT', 'Portugal', 'EURO', '203', '50613', '3', '1725');
INSERT INTO public.who_global_data_import VALUES (67411, '2020-07-31', 'PT', 'Portugal', 'EURO', '255', '50868', '2', '1727');
INSERT INTO public.who_global_data_import VALUES (67412, '2020-08-01', 'PT', 'Portugal', 'EURO', '204', '51072', '8', '1735');
INSERT INTO public.who_global_data_import VALUES (67413, '2020-08-02', 'PT', 'Portugal', 'EURO', '238', '51310', '2', '1737');
INSERT INTO public.who_global_data_import VALUES (67414, '2020-08-03', 'PT', 'Portugal', 'EURO', '153', '51463', '1', '1738');
INSERT INTO public.who_global_data_import VALUES (67415, '2020-08-04', 'PT', 'Portugal', 'EURO', '106', '51569', '0', '1738');
INSERT INTO public.who_global_data_import VALUES (67416, '2020-08-05', 'PT', 'Portugal', 'EURO', '112', '51681', '1', '1739');
INSERT INTO public.who_global_data_import VALUES (67417, '2020-08-06', 'PT', 'Portugal', 'EURO', '167', '51848', '1', '1740');
INSERT INTO public.who_global_data_import VALUES (67418, '2020-08-07', 'PT', 'Portugal', 'EURO', '213', '52061', '3', '1743');
INSERT INTO public.who_global_data_import VALUES (67419, '2020-08-08', 'PT', 'Portugal', 'EURO', '290', '52351', '3', '1746');
INSERT INTO public.who_global_data_import VALUES (67420, '2020-08-09', 'PT', 'Portugal', 'EURO', '186', '52537', '4', '1750');
INSERT INTO public.who_global_data_import VALUES (67421, '2020-08-10', 'PT', 'Portugal', 'EURO', '131', '52668', '6', '1756');
INSERT INTO public.who_global_data_import VALUES (67422, '2020-08-11', 'PT', 'Portugal', 'EURO', '157', '52825', '3', '1759');
INSERT INTO public.who_global_data_import VALUES (67423, '2020-08-12', 'PT', 'Portugal', 'EURO', '120', '52945', '2', '1761');
INSERT INTO public.who_global_data_import VALUES (67424, '2020-08-13', 'PT', 'Portugal', 'EURO', '278', '53223', '3', '1764');
INSERT INTO public.who_global_data_import VALUES (67425, '2020-08-14', 'PT', 'Portugal', 'EURO', '325', '53548', '6', '1770');
INSERT INTO public.who_global_data_import VALUES (67426, '2020-08-15', 'PT', 'Portugal', 'EURO', '235', '53783', '2', '1772');
INSERT INTO public.who_global_data_import VALUES (67427, '2020-08-16', 'PT', 'Portugal', 'EURO', '198', '53981', '3', '1775');
INSERT INTO public.who_global_data_import VALUES (67428, '2020-08-17', 'PT', 'Portugal', 'EURO', '121', '54102', '3', '1778');
INSERT INTO public.who_global_data_import VALUES (67429, '2020-08-18', 'PT', 'Portugal', 'EURO', '132', '54234', '1', '1779');
INSERT INTO public.who_global_data_import VALUES (67430, '2020-08-19', 'PT', 'Portugal', 'EURO', '214', '54448', '5', '1784');
INSERT INTO public.who_global_data_import VALUES (67431, '2020-08-20', 'PT', 'Portugal', 'EURO', '253', '54701', '2', '1786');
INSERT INTO public.who_global_data_import VALUES (67432, '2020-08-21', 'PT', 'Portugal', 'EURO', '291', '54992', '2', '1788');
INSERT INTO public.who_global_data_import VALUES (67433, '2020-08-22', 'PT', 'Portugal', 'EURO', '219', '55211', '4', '1792');
INSERT INTO public.who_global_data_import VALUES (67434, '2020-08-23', 'PT', 'Portugal', 'EURO', '241', '55452', '2', '1794');
INSERT INTO public.who_global_data_import VALUES (67435, '2020-08-24', 'PT', 'Portugal', 'EURO', '145', '55597', '2', '1796');
INSERT INTO public.who_global_data_import VALUES (67436, '2020-08-25', 'PT', 'Portugal', 'EURO', '123', '55720', '5', '1801');
INSERT INTO public.who_global_data_import VALUES (67437, '2020-08-26', 'PT', 'Portugal', 'EURO', '192', '55912', '4', '1805');
INSERT INTO public.who_global_data_import VALUES (67438, '2020-08-27', 'PT', 'Portugal', 'EURO', '362', '56274', '2', '1807');
INSERT INTO public.who_global_data_import VALUES (67439, '2020-08-28', 'PT', 'Portugal', 'EURO', '399', '56673', '2', '1809');
INSERT INTO public.who_global_data_import VALUES (67440, '2020-08-29', 'PT', 'Portugal', 'EURO', '401', '57074', '6', '1815');
INSERT INTO public.who_global_data_import VALUES (67441, '2020-08-30', 'PT', 'Portugal', 'EURO', '374', '57448', '3', '1818');
INSERT INTO public.who_global_data_import VALUES (67442, '2020-08-31', 'PT', 'Portugal', 'EURO', '320', '57768', '1', '1819');
INSERT INTO public.who_global_data_import VALUES (67443, '2020-09-01', 'PT', 'Portugal', 'EURO', '244', '58012', '3', '1822');
INSERT INTO public.who_global_data_import VALUES (67444, '2020-09-02', 'PT', 'Portugal', 'EURO', '231', '58243', '2', '1824');
INSERT INTO public.who_global_data_import VALUES (67445, '2020-09-03', 'PT', 'Portugal', 'EURO', '390', '58633', '3', '1827');
INSERT INTO public.who_global_data_import VALUES (67446, '2020-09-04', 'PT', 'Portugal', 'EURO', '418', '59051', '2', '1829');
INSERT INTO public.who_global_data_import VALUES (67447, '2020-09-05', 'PT', 'Portugal', 'EURO', '406', '59457', '4', '1833');
INSERT INTO public.who_global_data_import VALUES (67448, '2020-09-06', 'PT', 'Portugal', 'EURO', '486', '59943', '5', '1838');
INSERT INTO public.who_global_data_import VALUES (67449, '2020-09-07', 'PT', 'Portugal', 'EURO', '315', '60258', '2', '1840');
INSERT INTO public.who_global_data_import VALUES (67450, '2020-09-08', 'PT', 'Portugal', 'EURO', '249', '60507', '3', '1843');
INSERT INTO public.who_global_data_import VALUES (67451, '2020-09-09', 'PT', 'Portugal', 'EURO', '388', '60895', '3', '1846');
INSERT INTO public.who_global_data_import VALUES (67452, '2020-09-10', 'PT', 'Portugal', 'EURO', '646', '61541', '3', '1849');
INSERT INTO public.who_global_data_import VALUES (67453, '2020-09-11', 'PT', 'Portugal', 'EURO', '585', '62126', '3', '1852');
INSERT INTO public.who_global_data_import VALUES (67454, '2020-09-12', 'PT', 'Portugal', 'EURO', '687', '62813', '3', '1855');
INSERT INTO public.who_global_data_import VALUES (67455, '2020-09-13', 'PT', 'Portugal', 'EURO', '497', '63310', '5', '1860');
INSERT INTO public.who_global_data_import VALUES (67456, '2020-09-14', 'PT', 'Portugal', 'EURO', '673', '63983', '7', '1867');
INSERT INTO public.who_global_data_import VALUES (67457, '2020-09-15', 'PT', 'Portugal', 'EURO', '613', '64596', '4', '1871');
INSERT INTO public.who_global_data_import VALUES (67458, '2020-09-16', 'PT', 'Portugal', 'EURO', '425', '65021', '4', '1875');
INSERT INTO public.who_global_data_import VALUES (67459, '2020-09-17', 'PT', 'Portugal', 'EURO', '605', '65626', '3', '1878');
INSERT INTO public.who_global_data_import VALUES (67460, '2020-09-18', 'PT', 'Portugal', 'EURO', '770', '66396', '10', '1888');
INSERT INTO public.who_global_data_import VALUES (67461, '2020-09-19', 'PT', 'Portugal', 'EURO', '780', '67176', '6', '1894');
INSERT INTO public.who_global_data_import VALUES (67462, '2020-09-20', 'PT', 'Portugal', 'EURO', '849', '68025', '5', '1899');
INSERT INTO public.who_global_data_import VALUES (67463, '2020-09-21', 'PT', 'Portugal', 'EURO', '552', '68577', '13', '1912');
INSERT INTO public.who_global_data_import VALUES (67464, '2020-09-22', 'PT', 'Portugal', 'EURO', '623', '69200', '8', '1920');
INSERT INTO public.who_global_data_import VALUES (67465, '2020-09-23', 'PT', 'Portugal', 'EURO', '463', '69663', '5', '1925');
INSERT INTO public.who_global_data_import VALUES (67466, '2020-09-24', 'PT', 'Portugal', 'EURO', '802', '70465', '3', '1928');
INSERT INTO public.who_global_data_import VALUES (67467, '2020-09-25', 'PT', 'Portugal', 'EURO', '691', '71156', '3', '1931');
INSERT INTO public.who_global_data_import VALUES (67468, '2020-09-26', 'PT', 'Portugal', 'EURO', '899', '72055', '5', '1936');
INSERT INTO public.who_global_data_import VALUES (67469, '2020-09-27', 'PT', 'Portugal', 'EURO', '884', '72939', '8', '1944');
INSERT INTO public.who_global_data_import VALUES (67470, '2020-09-28', 'PT', 'Portugal', 'EURO', '665', '73604', '9', '1953');
INSERT INTO public.who_global_data_import VALUES (67471, '2020-09-29', 'PT', 'Portugal', 'EURO', '425', '74029', '4', '1957');
INSERT INTO public.who_global_data_import VALUES (67472, '2020-09-30', 'PT', 'Portugal', 'EURO', '688', '74717', '6', '1963');
INSERT INTO public.who_global_data_import VALUES (67473, '2020-10-01', 'PT', 'Portugal', 'EURO', '825', '75542', '8', '1971');
INSERT INTO public.who_global_data_import VALUES (67474, '2020-10-02', 'PT', 'Portugal', 'EURO', '854', '76396', '6', '1977');
INSERT INTO public.who_global_data_import VALUES (67475, '2020-10-03', 'PT', 'Portugal', 'EURO', '888', '77284', '6', '1983');
INSERT INTO public.who_global_data_import VALUES (67476, '2020-10-04', 'PT', 'Portugal', 'EURO', '963', '78247', '12', '1995');
INSERT INTO public.who_global_data_import VALUES (67477, '2020-10-05', 'PT', 'Portugal', 'EURO', '0', '78247', '0', '1995');
INSERT INTO public.who_global_data_import VALUES (67478, '2020-10-06', 'PT', 'Portugal', 'EURO', '1638', '79885', '23', '2018');
INSERT INTO public.who_global_data_import VALUES (67479, '2020-10-07', 'PT', 'Portugal', 'EURO', '427', '80312', '14', '2032');
INSERT INTO public.who_global_data_import VALUES (67480, '2020-10-08', 'PT', 'Portugal', 'EURO', '944', '81256', '8', '2040');
INSERT INTO public.who_global_data_import VALUES (67481, '2020-10-09', 'PT', 'Portugal', 'EURO', '1278', '82534', '10', '2050');
INSERT INTO public.who_global_data_import VALUES (67482, '2020-10-10', 'PT', 'Portugal', 'EURO', '1394', '83928', '12', '2062');
INSERT INTO public.who_global_data_import VALUES (67483, '2020-10-11', 'PT', 'Portugal', 'EURO', '1646', '85574', '5', '2067');
INSERT INTO public.who_global_data_import VALUES (67484, '2020-10-12', 'PT', 'Portugal', 'EURO', '1090', '86664', '13', '2080');
INSERT INTO public.who_global_data_import VALUES (67485, '2020-10-13', 'PT', 'Portugal', 'EURO', '1249', '87913', '14', '2094');
INSERT INTO public.who_global_data_import VALUES (67486, '2020-10-14', 'PT', 'Portugal', 'EURO', '1208', '89121', '16', '2110');
INSERT INTO public.who_global_data_import VALUES (67487, '2020-10-15', 'PT', 'Portugal', 'EURO', '2072', '91193', '7', '2117');
INSERT INTO public.who_global_data_import VALUES (67488, '2020-10-16', 'PT', 'Portugal', 'EURO', '2101', '93294', '11', '2128');
INSERT INTO public.who_global_data_import VALUES (67489, '2020-10-17', 'PT', 'Portugal', 'EURO', '2608', '95902', '21', '2149');
INSERT INTO public.who_global_data_import VALUES (67490, '2020-10-18', 'PT', 'Portugal', 'EURO', '2153', '98055', '13', '2162');
INSERT INTO public.who_global_data_import VALUES (67491, '2020-10-19', 'PT', 'Portugal', 'EURO', '1856', '99911', '19', '2181');
INSERT INTO public.who_global_data_import VALUES (67492, '2020-10-20', 'PT', 'Portugal', 'EURO', '1949', '101860', '17', '2198');
INSERT INTO public.who_global_data_import VALUES (67493, '2020-10-21', 'PT', 'Portugal', 'EURO', '1876', '103736', '15', '2213');
INSERT INTO public.who_global_data_import VALUES (67494, '2020-10-22', 'PT', 'Portugal', 'EURO', '2535', '106271', '16', '2229');
INSERT INTO public.who_global_data_import VALUES (67495, '2020-10-23', 'PT', 'Portugal', 'EURO', '3270', '109541', '16', '2245');
INSERT INTO public.who_global_data_import VALUES (67496, '2020-10-24', 'PT', 'Portugal', 'EURO', '2899', '112440', '31', '2276');
INSERT INTO public.who_global_data_import VALUES (67497, '2020-10-25', 'PT', 'Portugal', 'EURO', '3669', '116109', '21', '2297');
INSERT INTO public.who_global_data_import VALUES (67498, '2020-10-26', 'PT', 'Portugal', 'EURO', '2577', '118686', '19', '2316');
INSERT INTO public.who_global_data_import VALUES (67499, '2020-10-27', 'PT', 'Portugal', 'EURO', '2447', '121133', '27', '2343');
INSERT INTO public.who_global_data_import VALUES (67500, '2020-10-28', 'PT', 'Portugal', 'EURO', '3299', '124432', '28', '2371');
INSERT INTO public.who_global_data_import VALUES (67501, '2020-10-29', 'PT', 'Portugal', 'EURO', '3960', '128392', '24', '2395');
INSERT INTO public.who_global_data_import VALUES (67502, '2020-10-30', 'PT', 'Portugal', 'EURO', '4224', '132616', '33', '2428');
INSERT INTO public.who_global_data_import VALUES (67503, '2020-10-31', 'PT', 'Portugal', 'EURO', '4656', '137272', '40', '2468');
INSERT INTO public.who_global_data_import VALUES (67504, '2020-11-01', 'PT', 'Portugal', 'EURO', '4007', '141279', '39', '2507');
INSERT INTO public.who_global_data_import VALUES (67505, '2020-11-02', 'PT', 'Portugal', 'EURO', '3062', '144341', '37', '2544');
INSERT INTO public.who_global_data_import VALUES (67506, '2020-11-03', 'PT', 'Portugal', 'EURO', '2506', '146847', '46', '2590');
INSERT INTO public.who_global_data_import VALUES (67507, '2020-11-04', 'PT', 'Portugal', 'EURO', '2596', '149443', '45', '2635');
INSERT INTO public.who_global_data_import VALUES (67508, '2020-11-05', 'PT', 'Portugal', 'EURO', '7497', '156940', '59', '2694');
INSERT INTO public.who_global_data_import VALUES (67509, '2020-11-06', 'PT', 'Portugal', 'EURO', '4410', '161350', '46', '2740');
INSERT INTO public.who_global_data_import VALUES (67510, '2020-11-07', 'PT', 'Portugal', 'EURO', '5550', '166900', '52', '2792');
INSERT INTO public.who_global_data_import VALUES (67511, '2020-11-08', 'PT', 'Portugal', 'EURO', '6640', '173540', '56', '2848');
INSERT INTO public.who_global_data_import VALUES (67512, '2020-11-09', 'PT', 'Portugal', 'EURO', '5784', '179324', '48', '2896');
INSERT INTO public.who_global_data_import VALUES (67513, '2020-11-10', 'PT', 'Portugal', 'EURO', '4096', '183420', '63', '2959');
INSERT INTO public.who_global_data_import VALUES (67514, '2020-11-11', 'PT', 'Portugal', 'EURO', '3817', '187237', '62', '3021');
INSERT INTO public.who_global_data_import VALUES (67515, '2020-11-12', 'PT', 'Portugal', 'EURO', '4935', '192172', '82', '3103');
INSERT INTO public.who_global_data_import VALUES (67516, '2020-11-13', 'PT', 'Portugal', 'EURO', '5839', '198011', '78', '3181');
INSERT INTO public.who_global_data_import VALUES (67517, '2020-11-14', 'PT', 'Portugal', 'EURO', '6653', '204664', '69', '3250');
INSERT INTO public.who_global_data_import VALUES (67518, '2020-11-15', 'PT', 'Portugal', 'EURO', '6602', '211266', '55', '3305');
INSERT INTO public.who_global_data_import VALUES (67519, '2020-11-16', 'PT', 'Portugal', 'EURO', '6035', '217301', '76', '3381');
INSERT INTO public.who_global_data_import VALUES (67520, '2020-11-17', 'PT', 'Portugal', 'EURO', '8371', '225672', '91', '3472');
INSERT INTO public.who_global_data_import VALUES (67521, '2020-11-18', 'PT', 'Portugal', 'EURO', '4452', '230124', '81', '3553');
INSERT INTO public.who_global_data_import VALUES (67522, '2020-11-19', 'PT', 'Portugal', 'EURO', '5891', '236015', '79', '3632');
INSERT INTO public.who_global_data_import VALUES (67523, '2020-11-20', 'PT', 'Portugal', 'EURO', '6994', '243009', '69', '3701');
INSERT INTO public.who_global_data_import VALUES (67524, '2020-11-21', 'PT', 'Portugal', 'EURO', '6489', '249498', '61', '3762');
INSERT INTO public.who_global_data_import VALUES (67525, '2020-11-22', 'PT', 'Portugal', 'EURO', '6472', '255970', '62', '3824');
INSERT INTO public.who_global_data_import VALUES (67526, '2020-11-23', 'PT', 'Portugal', 'EURO', '4788', '260758', '73', '3897');
INSERT INTO public.who_global_data_import VALUES (67527, '2020-11-24', 'PT', 'Portugal', 'EURO', '4044', '264802', '74', '3971');
INSERT INTO public.who_global_data_import VALUES (67528, '2020-11-25', 'PT', 'Portugal', 'EURO', '3919', '268721', '85', '4056');
INSERT INTO public.who_global_data_import VALUES (67529, '2020-11-26', 'PT', 'Portugal', 'EURO', '5290', '274011', '71', '4127');
INSERT INTO public.who_global_data_import VALUES (67530, '2020-11-27', 'PT', 'Portugal', 'EURO', '6383', '280394', '82', '4209');
INSERT INTO public.who_global_data_import VALUES (67531, '2020-11-28', 'PT', 'Portugal', 'EURO', '5444', '285838', '67', '4276');
INSERT INTO public.who_global_data_import VALUES (67532, '2020-11-29', 'PT', 'Portugal', 'EURO', '4868', '290706', '87', '4363');
INSERT INTO public.who_global_data_import VALUES (67533, '2020-11-30', 'PT', 'Portugal', 'EURO', '4093', '294799', '64', '4427');
INSERT INTO public.who_global_data_import VALUES (67534, '2020-12-01', 'PT', 'Portugal', 'EURO', '3262', '298061', '78', '4505');
INSERT INTO public.who_global_data_import VALUES (67535, '2020-12-02', 'PT', 'Portugal', 'EURO', '2401', '300462', '72', '4577');
INSERT INTO public.who_global_data_import VALUES (67536, '2020-12-03', 'PT', 'Portugal', 'EURO', '3384', '303846', '68', '4645');
INSERT INTO public.who_global_data_import VALUES (67537, '2020-12-04', 'PT', 'Portugal', 'EURO', '3772', '307618', '79', '4724');
INSERT INTO public.who_global_data_import VALUES (67538, '2020-12-05', 'PT', 'Portugal', 'EURO', '4935', '312553', '79', '4803');
INSERT INTO public.who_global_data_import VALUES (67539, '2020-12-06', 'PT', 'Portugal', 'EURO', '6087', '318640', '73', '4876');
INSERT INTO public.who_global_data_import VALUES (67540, '2020-12-07', 'PT', 'Portugal', 'EURO', '3834', '322474', '87', '4963');
INSERT INTO public.who_global_data_import VALUES (67541, '2020-12-08', 'PT', 'Portugal', 'EURO', '2597', '325071', '78', '5041');
INSERT INTO public.who_global_data_import VALUES (67542, '2020-12-09', 'PT', 'Portugal', 'EURO', '2905', '327976', '81', '5122');
INSERT INTO public.who_global_data_import VALUES (67543, '2020-12-10', 'PT', 'Portugal', 'EURO', '4097', '332073', '70', '5192');
INSERT INTO public.who_global_data_import VALUES (67544, '2020-12-11', 'PT', 'Portugal', 'EURO', '3134', '335207', '86', '5278');
INSERT INTO public.who_global_data_import VALUES (67545, '2020-12-12', 'PT', 'Portugal', 'EURO', '5080', '340287', '95', '5373');
INSERT INTO public.who_global_data_import VALUES (67546, '2020-12-13', 'PT', 'Portugal', 'EURO', '4413', '344700', '88', '5461');
INSERT INTO public.who_global_data_import VALUES (67547, '2020-12-14', 'PT', 'Portugal', 'EURO', '4044', '348744', '98', '5559');
INSERT INTO public.who_global_data_import VALUES (67548, '2020-12-15', 'PT', 'Portugal', 'EURO', '2194', '350938', '90', '5649');
INSERT INTO public.who_global_data_import VALUES (67549, '2020-12-16', 'PT', 'Portugal', 'EURO', '2638', '353576', '84', '5733');
INSERT INTO public.who_global_data_import VALUES (67550, '2020-12-17', 'PT', 'Portugal', 'EURO', '4720', '358296', '82', '5815');
INSERT INTO public.who_global_data_import VALUES (67551, '2020-12-18', 'PT', 'Portugal', 'EURO', '4320', '362616', '87', '5902');
INSERT INTO public.who_global_data_import VALUES (67552, '2020-12-19', 'PT', 'Portugal', 'EURO', '4336', '366952', '75', '5977');
INSERT INTO public.who_global_data_import VALUES (67553, '2020-12-20', 'PT', 'Portugal', 'EURO', '3835', '370787', '86', '6063');
INSERT INTO public.who_global_data_import VALUES (67554, '2020-12-21', 'PT', 'Portugal', 'EURO', '3334', '374121', '71', '6134');
INSERT INTO public.who_global_data_import VALUES (67555, '2020-12-22', 'PT', 'Portugal', 'EURO', '2099', '376220', '57', '6191');
INSERT INTO public.who_global_data_import VALUES (67556, '2020-12-23', 'PT', 'Portugal', 'EURO', '2436', '378656', '63', '6254');
INSERT INTO public.who_global_data_import VALUES (67557, '2020-12-24', 'PT', 'Portugal', 'EURO', '4602', '383258', '89', '6343');
INSERT INTO public.who_global_data_import VALUES (67558, '2020-12-25', 'PT', 'Portugal', 'EURO', '4378', '387636', '70', '6413');
INSERT INTO public.who_global_data_import VALUES (67559, '2020-12-26', 'PT', 'Portugal', 'EURO', '4146', '391782', '65', '6478');
INSERT INTO public.who_global_data_import VALUES (67560, '2020-12-27', 'PT', 'Portugal', 'EURO', '1214', '392996', '78', '6556');
INSERT INTO public.who_global_data_import VALUES (67561, '2020-12-28', 'PT', 'Portugal', 'EURO', '1577', '394573', '63', '6619');
INSERT INTO public.who_global_data_import VALUES (67562, '2020-12-29', 'PT', 'Portugal', 'EURO', '2093', '396666', '58', '6677');
INSERT INTO public.who_global_data_import VALUES (67563, '2020-12-30', 'PT', 'Portugal', 'EURO', '3336', '400002', '74', '6751');
INSERT INTO public.who_global_data_import VALUES (67564, '2020-12-31', 'PT', 'Portugal', 'EURO', '6049', '406051', '79', '6830');
INSERT INTO public.who_global_data_import VALUES (67565, '2021-01-01', 'PT', 'Portugal', 'EURO', '7627', '413678', '76', '6906');
INSERT INTO public.who_global_data_import VALUES (67566, '2021-01-02', 'PT', 'Portugal', 'EURO', '6951', '420629', '66', '6972');
INSERT INTO public.who_global_data_import VALUES (67567, '2021-01-03', 'PT', 'Portugal', 'EURO', '3241', '423870', '73', '7045');
INSERT INTO public.who_global_data_import VALUES (67568, '2021-01-04', 'PT', 'Portugal', 'EURO', '3384', '427254', '73', '7118');
INSERT INTO public.who_global_data_import VALUES (67569, '2021-01-05', 'PT', 'Portugal', 'EURO', '4369', '431623', '78', '7196');
INSERT INTO public.who_global_data_import VALUES (67570, '2021-01-06', 'PT', 'Portugal', 'EURO', '4956', '436579', '90', '7286');
INSERT INTO public.who_global_data_import VALUES (67571, '2021-01-07', 'PT', 'Portugal', 'EURO', '10027', '446606', '91', '7377');
INSERT INTO public.who_global_data_import VALUES (67572, '2021-01-08', 'PT', 'Portugal', 'EURO', '9927', '456533', '95', '7472');
INSERT INTO public.who_global_data_import VALUES (67573, '2021-01-09', 'PT', 'Portugal', 'EURO', '10176', '466709', '118', '7590');
INSERT INTO public.who_global_data_import VALUES (67574, '2021-01-10', 'PT', 'Portugal', 'EURO', '9478', '476187', '111', '7701');
INSERT INTO public.who_global_data_import VALUES (67575, '2021-01-11', 'PT', 'Portugal', 'EURO', '7502', '483689', '102', '7803');
INSERT INTO public.who_global_data_import VALUES (67576, '2021-01-12', 'PT', 'Portugal', 'EURO', '5604', '489293', '122', '7925');
INSERT INTO public.who_global_data_import VALUES (67577, '2021-01-13', 'PT', 'Portugal', 'EURO', '7259', '496552', '155', '8080');
INSERT INTO public.who_global_data_import VALUES (67578, '2021-01-14', 'PT', 'Portugal', 'EURO', '10556', '507108', '156', '8236');
INSERT INTO public.who_global_data_import VALUES (67579, '2021-01-15', 'PT', 'Portugal', 'EURO', '10698', '517806', '148', '8384');
INSERT INTO public.who_global_data_import VALUES (67580, '2021-01-16', 'PT', 'Portugal', 'EURO', '10663', '528469', '159', '8543');
INSERT INTO public.who_global_data_import VALUES (67581, '2021-01-17', 'PT', 'Portugal', 'EURO', '10947', '539416', '166', '8709');
INSERT INTO public.who_global_data_import VALUES (67582, '2021-01-18', 'PT', 'Portugal', 'EURO', '10385', '549801', '152', '8861');
INSERT INTO public.who_global_data_import VALUES (67583, '2021-01-19', 'PT', 'Portugal', 'EURO', '6702', '556503', '167', '9028');
INSERT INTO public.who_global_data_import VALUES (67584, '2021-01-20', 'PT', 'Portugal', 'EURO', '10455', '566958', '218', '9246');
INSERT INTO public.who_global_data_import VALUES (67585, '2021-01-21', 'PT', 'Portugal', 'EURO', '14647', '581605', '219', '9465');
INSERT INTO public.who_global_data_import VALUES (67586, '2021-01-22', 'PT', 'Portugal', 'EURO', '13544', '595149', '221', '9686');
INSERT INTO public.who_global_data_import VALUES (67587, '2021-01-23', 'PT', 'Portugal', 'EURO', '13987', '609136', '234', '9920');
INSERT INTO public.who_global_data_import VALUES (67588, '2021-01-24', 'PT', 'Portugal', 'EURO', '15333', '624469', '274', '10194');
INSERT INTO public.who_global_data_import VALUES (67589, '2021-01-25', 'PT', 'Portugal', 'EURO', '11721', '636190', '275', '10469');
INSERT INTO public.who_global_data_import VALUES (67590, '2021-01-26', 'PT', 'Portugal', 'EURO', '6923', '643113', '252', '10721');
INSERT INTO public.who_global_data_import VALUES (67591, '2021-01-27', 'PT', 'Portugal', 'EURO', '10765', '653878', '291', '11012');
INSERT INTO public.who_global_data_import VALUES (67592, '2021-01-28', 'PT', 'Portugal', 'EURO', '15073', '668951', '293', '11305');
INSERT INTO public.who_global_data_import VALUES (67593, '2021-01-29', 'PT', 'Portugal', 'EURO', '16432', '685383', '303', '11608');
INSERT INTO public.who_global_data_import VALUES (67594, '2021-01-30', 'PT', 'Portugal', 'EURO', '13200', '698583', '278', '11886');
INSERT INTO public.who_global_data_import VALUES (67595, '2021-01-31', 'PT', 'Portugal', 'EURO', '12435', '711018', '293', '12179');
INSERT INTO public.who_global_data_import VALUES (67596, '2021-02-01', 'PT', 'Portugal', 'EURO', '9498', '720516', '303', '12482');
INSERT INTO public.who_global_data_import VALUES (67597, '2021-02-02', 'PT', 'Portugal', 'EURO', '5805', '726321', '275', '12757');
INSERT INTO public.who_global_data_import VALUES (67598, '2021-02-03', 'PT', 'Portugal', 'EURO', '5540', '731861', '260', '13017');
INSERT INTO public.who_global_data_import VALUES (67599, '2021-02-04', 'PT', 'Portugal', 'EURO', '9083', '740944', '240', '13257');
INSERT INTO public.who_global_data_import VALUES (67600, '2021-02-05', 'PT', 'Portugal', 'EURO', '7914', '748858', '225', '13482');
INSERT INTO public.who_global_data_import VALUES (67601, '2020-01-03', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67602, '2020-01-04', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67603, '2020-01-05', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67604, '2020-01-06', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67605, '2020-01-07', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67606, '2020-01-08', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67607, '2020-01-09', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67608, '2020-01-10', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67609, '2020-01-11', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67610, '2020-01-12', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67611, '2020-01-13', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67612, '2020-01-14', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67613, '2020-01-15', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67614, '2020-01-16', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67615, '2020-01-17', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67616, '2020-01-18', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67617, '2020-01-19', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67618, '2020-01-20', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67619, '2020-01-21', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67620, '2020-01-22', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67621, '2020-01-23', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67622, '2020-01-24', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67623, '2020-01-25', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67624, '2020-01-26', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67625, '2020-01-27', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67626, '2020-01-28', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67627, '2020-01-29', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67628, '2020-01-30', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67629, '2020-01-31', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67630, '2020-02-01', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67631, '2020-02-02', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67632, '2020-02-03', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67633, '2020-02-04', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67634, '2020-02-05', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67635, '2020-02-06', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67636, '2020-02-07', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67637, '2020-02-08', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67638, '2020-02-09', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67639, '2020-02-10', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67640, '2020-02-11', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67641, '2020-02-12', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67642, '2020-02-13', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67643, '2020-02-14', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67644, '2020-02-15', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67645, '2020-02-16', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67646, '2020-02-17', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67647, '2020-02-18', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67648, '2020-02-19', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67649, '2020-02-20', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67650, '2020-02-21', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67651, '2020-02-22', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67652, '2020-02-23', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67653, '2020-02-24', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67654, '2020-02-25', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67655, '2020-02-26', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67656, '2020-02-27', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67657, '2020-02-28', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67658, '2020-02-29', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67659, '2020-03-01', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67660, '2020-03-02', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67661, '2020-03-03', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67662, '2020-03-04', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67663, '2020-03-05', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67664, '2020-03-06', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67665, '2020-03-07', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67666, '2020-03-08', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67667, '2020-03-09', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67668, '2020-03-10', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67669, '2020-03-11', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67670, '2020-03-12', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67671, '2020-03-13', 'PR', 'Puerto Rico', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67672, '2020-03-14', 'PR', 'Puerto Rico', 'AMRO', '7', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67673, '2020-03-15', 'PR', 'Puerto Rico', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67674, '2020-03-16', 'PR', 'Puerto Rico', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67675, '2020-03-17', 'PR', 'Puerto Rico', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67676, '2020-03-18', 'PR', 'Puerto Rico', 'AMRO', '2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67677, '2020-03-19', 'PR', 'Puerto Rico', 'AMRO', '-3', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67678, '2020-03-20', 'PR', 'Puerto Rico', 'AMRO', '8', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (67679, '2020-03-21', 'PR', 'Puerto Rico', 'AMRO', '7', '21', '1', '1');
INSERT INTO public.who_global_data_import VALUES (67680, '2020-03-22', 'PR', 'Puerto Rico', 'AMRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (67681, '2020-03-23', 'PR', 'Puerto Rico', 'AMRO', '2', '23', '0', '1');
INSERT INTO public.who_global_data_import VALUES (67682, '2020-03-24', 'PR', 'Puerto Rico', 'AMRO', '16', '39', '1', '2');
INSERT INTO public.who_global_data_import VALUES (67683, '2020-03-25', 'PR', 'Puerto Rico', 'AMRO', '0', '39', '0', '2');
INSERT INTO public.who_global_data_import VALUES (67684, '2020-03-26', 'PR', 'Puerto Rico', 'AMRO', '25', '64', '0', '2');
INSERT INTO public.who_global_data_import VALUES (67685, '2020-03-27', 'PR', 'Puerto Rico', 'AMRO', '0', '64', '0', '2');
INSERT INTO public.who_global_data_import VALUES (67686, '2020-03-28', 'PR', 'Puerto Rico', 'AMRO', '0', '64', '0', '2');
INSERT INTO public.who_global_data_import VALUES (67687, '2020-03-29', 'PR', 'Puerto Rico', 'AMRO', '0', '64', '0', '2');
INSERT INTO public.who_global_data_import VALUES (67688, '2020-03-30', 'PR', 'Puerto Rico', 'AMRO', '0', '64', '0', '2');
INSERT INTO public.who_global_data_import VALUES (67689, '2020-03-31', 'PR', 'Puerto Rico', 'AMRO', '110', '174', '4', '6');
INSERT INTO public.who_global_data_import VALUES (67690, '2020-04-01', 'PR', 'Puerto Rico', 'AMRO', '65', '239', '2', '8');
INSERT INTO public.who_global_data_import VALUES (67691, '2020-04-02', 'PR', 'Puerto Rico', 'AMRO', '47', '286', '3', '11');
INSERT INTO public.who_global_data_import VALUES (67692, '2020-04-03', 'PR', 'Puerto Rico', 'AMRO', '30', '316', '1', '12');
INSERT INTO public.who_global_data_import VALUES (67693, '2020-04-04', 'PR', 'Puerto Rico', 'AMRO', '62', '378', '3', '15');
INSERT INTO public.who_global_data_import VALUES (67694, '2020-04-05', 'PR', 'Puerto Rico', 'AMRO', '74', '452', '3', '18');
INSERT INTO public.who_global_data_import VALUES (67695, '2020-04-06', 'PR', 'Puerto Rico', 'AMRO', '0', '452', '0', '18');
INSERT INTO public.who_global_data_import VALUES (67696, '2020-04-07', 'PR', 'Puerto Rico', 'AMRO', '61', '513', '3', '21');
INSERT INTO public.who_global_data_import VALUES (67697, '2020-04-08', 'PR', 'Puerto Rico', 'AMRO', '60', '573', '2', '23');
INSERT INTO public.who_global_data_import VALUES (67698, '2020-04-09', 'PR', 'Puerto Rico', 'AMRO', '47', '620', '1', '24');
INSERT INTO public.who_global_data_import VALUES (67699, '2020-04-10', 'PR', 'Puerto Rico', 'AMRO', '63', '683', '9', '33');
INSERT INTO public.who_global_data_import VALUES (67700, '2020-04-11', 'PR', 'Puerto Rico', 'AMRO', '42', '725', '6', '39');
INSERT INTO public.who_global_data_import VALUES (67701, '2020-04-12', 'PR', 'Puerto Rico', 'AMRO', '63', '788', '3', '42');
INSERT INTO public.who_global_data_import VALUES (67702, '2020-04-13', 'PR', 'Puerto Rico', 'AMRO', '109', '897', '2', '44');
INSERT INTO public.who_global_data_import VALUES (67703, '2020-04-14', 'PR', 'Puerto Rico', 'AMRO', '6', '903', '1', '45');
INSERT INTO public.who_global_data_import VALUES (67704, '2020-04-15', 'PR', 'Puerto Rico', 'AMRO', '20', '923', '0', '45');
INSERT INTO public.who_global_data_import VALUES (67705, '2020-04-16', 'PR', 'Puerto Rico', 'AMRO', '51', '974', '3', '48');
INSERT INTO public.who_global_data_import VALUES (67706, '2020-04-17', 'PR', 'Puerto Rico', 'AMRO', '69', '1043', '0', '48');
INSERT INTO public.who_global_data_import VALUES (67707, '2020-04-18', 'PR', 'Puerto Rico', 'AMRO', '25', '1068', '0', '48');
INSERT INTO public.who_global_data_import VALUES (67708, '2020-04-19', 'PR', 'Puerto Rico', 'AMRO', '50', '1118', '0', '48');
INSERT INTO public.who_global_data_import VALUES (67709, '2020-04-20', 'PR', 'Puerto Rico', 'AMRO', '95', '1213', '0', '48');
INSERT INTO public.who_global_data_import VALUES (67710, '2020-04-21', 'PR', 'Puerto Rico', 'AMRO', '39', '1252', '0', '48');
INSERT INTO public.who_global_data_import VALUES (67711, '2020-04-22', 'PR', 'Puerto Rico', 'AMRO', '24', '1276', '0', '48');
INSERT INTO public.who_global_data_import VALUES (67712, '2020-04-23', 'PR', 'Puerto Rico', 'AMRO', '0', '1276', '0', '48');
INSERT INTO public.who_global_data_import VALUES (67713, '2020-04-24', 'PR', 'Puerto Rico', 'AMRO', '0', '1276', '0', '48');
INSERT INTO public.who_global_data_import VALUES (67714, '2020-04-25', 'PR', 'Puerto Rico', 'AMRO', '0', '1276', '3', '51');
INSERT INTO public.who_global_data_import VALUES (67715, '2020-04-26', 'PR', 'Puerto Rico', 'AMRO', '0', '1276', '2', '53');
INSERT INTO public.who_global_data_import VALUES (67716, '2020-04-27', 'PR', 'Puerto Rico', 'AMRO', '95', '1371', '0', '53');
INSERT INTO public.who_global_data_import VALUES (67717, '2020-04-28', 'PR', 'Puerto Rico', 'AMRO', '18', '1389', '0', '53');
INSERT INTO public.who_global_data_import VALUES (67718, '2020-04-29', 'PR', 'Puerto Rico', 'AMRO', '11', '1400', '1', '54');
INSERT INTO public.who_global_data_import VALUES (67719, '2020-04-30', 'PR', 'Puerto Rico', 'AMRO', '33', '1433', '0', '54');
INSERT INTO public.who_global_data_import VALUES (67720, '2020-05-01', 'PR', 'Puerto Rico', 'AMRO', '106', '1539', '0', '54');
INSERT INTO public.who_global_data_import VALUES (67721, '2020-05-02', 'PR', 'Puerto Rico', 'AMRO', '36', '1575', '0', '54');
INSERT INTO public.who_global_data_import VALUES (67722, '2020-05-03', 'PR', 'Puerto Rico', 'AMRO', '182', '1757', '0', '54');
INSERT INTO public.who_global_data_import VALUES (67723, '2020-05-04', 'PR', 'Puerto Rico', 'AMRO', '51', '1808', '43', '97');
INSERT INTO public.who_global_data_import VALUES (67724, '2020-05-05', 'PR', 'Puerto Rico', 'AMRO', '35', '1843', '-43', '54');
INSERT INTO public.who_global_data_import VALUES (67725, '2020-05-06', 'PR', 'Puerto Rico', 'AMRO', '81', '1924', '2', '56');
INSERT INTO public.who_global_data_import VALUES (67726, '2020-05-07', 'PR', 'Puerto Rico', 'AMRO', '44', '1968', '0', '56');
INSERT INTO public.who_global_data_import VALUES (67727, '2020-05-08', 'PR', 'Puerto Rico', 'AMRO', '63', '2031', '0', '56');
INSERT INTO public.who_global_data_import VALUES (67728, '2020-05-09', 'PR', 'Puerto Rico', 'AMRO', '125', '2156', '0', '56');
INSERT INTO public.who_global_data_import VALUES (67729, '2020-05-10', 'PR', 'Puerto Rico', 'AMRO', '17', '2173', '52', '108');
INSERT INTO public.who_global_data_import VALUES (67730, '2020-05-11', 'PR', 'Puerto Rico', 'AMRO', '25', '2198', '3', '111');
INSERT INTO public.who_global_data_import VALUES (67731, '2020-05-12', 'PR', 'Puerto Rico', 'AMRO', '58', '2256', '2', '113');
INSERT INTO public.who_global_data_import VALUES (67732, '2020-05-13', 'PR', 'Puerto Rico', 'AMRO', '43', '2299', '1', '114');
INSERT INTO public.who_global_data_import VALUES (67733, '2020-05-14', 'PR', 'Puerto Rico', 'AMRO', '30', '2329', '1', '115');
INSERT INTO public.who_global_data_import VALUES (67734, '2020-05-15', 'PR', 'Puerto Rico', 'AMRO', '98', '2427', '2', '117');
INSERT INTO public.who_global_data_import VALUES (67735, '2020-05-16', 'PR', 'Puerto Rico', 'AMRO', '115', '2542', '5', '122');
INSERT INTO public.who_global_data_import VALUES (67736, '2020-05-17', 'PR', 'Puerto Rico', 'AMRO', '47', '2589', '0', '122');
INSERT INTO public.who_global_data_import VALUES (67737, '2020-05-18', 'PR', 'Puerto Rico', 'AMRO', '57', '2646', '1', '123');
INSERT INTO public.who_global_data_import VALUES (67738, '2020-05-19', 'PR', 'Puerto Rico', 'AMRO', '64', '2710', '1', '124');
INSERT INTO public.who_global_data_import VALUES (67739, '2020-05-20', 'PR', 'Puerto Rico', 'AMRO', '95', '2805', '0', '124');
INSERT INTO public.who_global_data_import VALUES (67740, '2020-05-21', 'PR', 'Puerto Rico', 'AMRO', '61', '2866', '1', '125');
INSERT INTO public.who_global_data_import VALUES (67741, '2020-05-22', 'PR', 'Puerto Rico', 'AMRO', '47', '2913', '1', '126');
INSERT INTO public.who_global_data_import VALUES (67742, '2020-05-23', 'PR', 'Puerto Rico', 'AMRO', '117', '3030', '0', '126');
INSERT INTO public.who_global_data_import VALUES (67743, '2020-05-24', 'PR', 'Puerto Rico', 'AMRO', '70', '3100', '1', '127');
INSERT INTO public.who_global_data_import VALUES (67744, '2020-05-25', 'PR', 'Puerto Rico', 'AMRO', '89', '3189', '0', '127');
INSERT INTO public.who_global_data_import VALUES (67745, '2020-05-26', 'PR', 'Puerto Rico', 'AMRO', '71', '3260', '2', '129');
INSERT INTO public.who_global_data_import VALUES (67746, '2020-05-27', 'PR', 'Puerto Rico', 'AMRO', '64', '3324', '0', '129');
INSERT INTO public.who_global_data_import VALUES (67747, '2020-05-28', 'PR', 'Puerto Rico', 'AMRO', '73', '3397', '0', '129');
INSERT INTO public.who_global_data_import VALUES (67748, '2020-05-29', 'PR', 'Puerto Rico', 'AMRO', '89', '3486', '2', '131');
INSERT INTO public.who_global_data_import VALUES (67749, '2020-05-30', 'PR', 'Puerto Rico', 'AMRO', '161', '3647', '1', '132');
INSERT INTO public.who_global_data_import VALUES (67750, '2020-05-31', 'PR', 'Puerto Rico', 'AMRO', '71', '3718', '1', '133');
INSERT INTO public.who_global_data_import VALUES (67751, '2020-06-01', 'PR', 'Puerto Rico', 'AMRO', '58', '3776', '3', '136');
INSERT INTO public.who_global_data_import VALUES (67752, '2020-06-02', 'PR', 'Puerto Rico', 'AMRO', '97', '3873', '0', '136');
INSERT INTO public.who_global_data_import VALUES (67753, '2020-06-03', 'PR', 'Puerto Rico', 'AMRO', '62', '3935', '2', '138');
INSERT INTO public.who_global_data_import VALUES (67754, '2020-06-04', 'PR', 'Puerto Rico', 'AMRO', '88', '4023', '2', '140');
INSERT INTO public.who_global_data_import VALUES (67755, '2020-06-05', 'PR', 'Puerto Rico', 'AMRO', '485', '4508', '0', '140');
INSERT INTO public.who_global_data_import VALUES (67756, '2020-06-06', 'PR', 'Puerto Rico', 'AMRO', '112', '4620', '1', '141');
INSERT INTO public.who_global_data_import VALUES (67757, '2020-06-07', 'PR', 'Puerto Rico', 'AMRO', '295', '4915', '1', '142');
INSERT INTO public.who_global_data_import VALUES (67758, '2020-06-08', 'PR', 'Puerto Rico', 'AMRO', '70', '4985', '0', '142');
INSERT INTO public.who_global_data_import VALUES (67759, '2020-06-09', 'PR', 'Puerto Rico', 'AMRO', '61', '5046', '0', '142');
INSERT INTO public.who_global_data_import VALUES (67760, '2020-06-10', 'PR', 'Puerto Rico', 'AMRO', '139', '5185', '0', '142');
INSERT INTO public.who_global_data_import VALUES (67761, '2020-06-11', 'PR', 'Puerto Rico', 'AMRO', '144', '5329', '1', '143');
INSERT INTO public.who_global_data_import VALUES (67762, '2020-06-12', 'PR', 'Puerto Rico', 'AMRO', '23', '5352', '1', '144');
INSERT INTO public.who_global_data_import VALUES (67763, '2020-06-13', 'PR', 'Puerto Rico', 'AMRO', '184', '5536', '2', '146');
INSERT INTO public.who_global_data_import VALUES (67764, '2020-06-14', 'PR', 'Puerto Rico', 'AMRO', '154', '5690', '0', '146');
INSERT INTO public.who_global_data_import VALUES (67765, '2020-06-15', 'PR', 'Puerto Rico', 'AMRO', '121', '5811', '1', '147');
INSERT INTO public.who_global_data_import VALUES (67766, '2020-06-16', 'PR', 'Puerto Rico', 'AMRO', '79', '5890', '0', '147');
INSERT INTO public.who_global_data_import VALUES (67767, '2020-06-17', 'PR', 'Puerto Rico', 'AMRO', '61', '5951', '0', '147');
INSERT INTO public.who_global_data_import VALUES (67768, '2020-06-18', 'PR', 'Puerto Rico', 'AMRO', '52', '6003', '0', '147');
INSERT INTO public.who_global_data_import VALUES (67769, '2020-06-19', 'PR', 'Puerto Rico', 'AMRO', '108', '6111', '0', '147');
INSERT INTO public.who_global_data_import VALUES (67770, '2020-06-20', 'PR', 'Puerto Rico', 'AMRO', '84', '6195', '0', '147');
INSERT INTO public.who_global_data_import VALUES (67771, '2020-06-21', 'PR', 'Puerto Rico', 'AMRO', '268', '6463', '0', '147');
INSERT INTO public.who_global_data_import VALUES (67772, '2020-06-22', 'PR', 'Puerto Rico', 'AMRO', '62', '6525', '2', '149');
INSERT INTO public.who_global_data_import VALUES (67773, '2020-06-23', 'PR', 'Puerto Rico', 'AMRO', '39', '6564', '0', '149');
INSERT INTO public.who_global_data_import VALUES (67774, '2020-06-24', 'PR', 'Puerto Rico', 'AMRO', '121', '6685', '0', '149');
INSERT INTO public.who_global_data_import VALUES (67775, '2020-06-25', 'PR', 'Puerto Rico', 'AMRO', '135', '6820', '0', '149');
INSERT INTO public.who_global_data_import VALUES (67776, '2020-06-26', 'PR', 'Puerto Rico', 'AMRO', '57', '6877', '2', '151');
INSERT INTO public.who_global_data_import VALUES (67777, '2020-06-27', 'PR', 'Puerto Rico', 'AMRO', '45', '6922', '0', '151');
INSERT INTO public.who_global_data_import VALUES (67778, '2020-06-28', 'PR', 'Puerto Rico', 'AMRO', '144', '7066', '1', '152');
INSERT INTO public.who_global_data_import VALUES (67779, '2020-06-29', 'PR', 'Puerto Rico', 'AMRO', '123', '7189', '1', '153');
INSERT INTO public.who_global_data_import VALUES (67780, '2020-06-30', 'PR', 'Puerto Rico', 'AMRO', '61', '7250', '0', '153');
INSERT INTO public.who_global_data_import VALUES (67781, '2020-07-01', 'PR', 'Puerto Rico', 'AMRO', '215', '7465', '0', '153');
INSERT INTO public.who_global_data_import VALUES (67782, '2020-07-02', 'PR', 'Puerto Rico', 'AMRO', '72', '7537', '0', '153');
INSERT INTO public.who_global_data_import VALUES (67783, '2020-07-03', 'PR', 'Puerto Rico', 'AMRO', '71', '7608', '0', '153');
INSERT INTO public.who_global_data_import VALUES (67784, '2020-07-04', 'PR', 'Puerto Rico', 'AMRO', '75', '7683', '1', '154');
INSERT INTO public.who_global_data_import VALUES (67785, '2020-07-05', 'PR', 'Puerto Rico', 'AMRO', '104', '7787', '1', '155');
INSERT INTO public.who_global_data_import VALUES (67786, '2020-07-06', 'PR', 'Puerto Rico', 'AMRO', '129', '7916', '0', '155');
INSERT INTO public.who_global_data_import VALUES (67787, '2020-07-07', 'PR', 'Puerto Rico', 'AMRO', '669', '8585', '0', '155');
INSERT INTO public.who_global_data_import VALUES (67788, '2020-07-08', 'PR', 'Puerto Rico', 'AMRO', '129', '8714', '2', '157');
INSERT INTO public.who_global_data_import VALUES (67789, '2020-07-09', 'PR', 'Puerto Rico', 'AMRO', '31', '8745', '2', '159');
INSERT INTO public.who_global_data_import VALUES (67790, '2020-07-10', 'PR', 'Puerto Rico', 'AMRO', '117', '8862', '0', '159');
INSERT INTO public.who_global_data_import VALUES (67791, '2020-07-11', 'PR', 'Puerto Rico', 'AMRO', '275', '9137', '0', '159');
INSERT INTO public.who_global_data_import VALUES (67792, '2020-07-12', 'PR', 'Puerto Rico', 'AMRO', '229', '9366', '8', '167');
INSERT INTO public.who_global_data_import VALUES (67793, '2020-07-13', 'PR', 'Puerto Rico', 'AMRO', '288', '9654', '0', '167');
INSERT INTO public.who_global_data_import VALUES (67794, '2020-07-14', 'PR', 'Puerto Rico', 'AMRO', '356', '10010', '0', '167');
INSERT INTO public.who_global_data_import VALUES (67795, '2020-07-15', 'PR', 'Puerto Rico', 'AMRO', '113', '10123', '2', '169');
INSERT INTO public.who_global_data_import VALUES (67796, '2020-07-16', 'PR', 'Puerto Rico', 'AMRO', '256', '10379', '2', '171');
INSERT INTO public.who_global_data_import VALUES (67797, '2020-07-17', 'PR', 'Puerto Rico', 'AMRO', '195', '10574', '1', '172');
INSERT INTO public.who_global_data_import VALUES (67798, '2020-07-18', 'PR', 'Puerto Rico', 'AMRO', '546', '11120', '5', '177');
INSERT INTO public.who_global_data_import VALUES (67799, '2020-07-19', 'PR', 'Puerto Rico', 'AMRO', '333', '11453', '1', '178');
INSERT INTO public.who_global_data_import VALUES (67800, '2020-07-20', 'PR', 'Puerto Rico', 'AMRO', '610', '12063', '0', '178');
INSERT INTO public.who_global_data_import VALUES (67801, '2020-07-21', 'PR', 'Puerto Rico', 'AMRO', '398', '12461', '2', '180');
INSERT INTO public.who_global_data_import VALUES (67802, '2020-07-22', 'PR', 'Puerto Rico', 'AMRO', '479', '12940', '0', '180');
INSERT INTO public.who_global_data_import VALUES (67803, '2020-07-23', 'PR', 'Puerto Rico', 'AMRO', '98', '13038', '5', '185');
INSERT INTO public.who_global_data_import VALUES (67804, '2020-07-24', 'PR', 'Puerto Rico', 'AMRO', '435', '13473', '3', '188');
INSERT INTO public.who_global_data_import VALUES (67805, '2020-07-25', 'PR', 'Puerto Rico', 'AMRO', '494', '13967', '3', '191');
INSERT INTO public.who_global_data_import VALUES (67806, '2020-07-26', 'PR', 'Puerto Rico', 'AMRO', '573', '14540', '10', '201');
INSERT INTO public.who_global_data_import VALUES (67807, '2020-07-27', 'PR', 'Puerto Rico', 'AMRO', '603', '15143', '0', '201');
INSERT INTO public.who_global_data_import VALUES (67808, '2020-07-28', 'PR', 'Puerto Rico', 'AMRO', '288', '15431', '0', '201');
INSERT INTO public.who_global_data_import VALUES (67809, '2020-07-29', 'PR', 'Puerto Rico', 'AMRO', '409', '15840', '8', '209');
INSERT INTO public.who_global_data_import VALUES (67810, '2020-07-30', 'PR', 'Puerto Rico', 'AMRO', '221', '16061', '2', '211');
INSERT INTO public.who_global_data_import VALUES (67811, '2020-07-31', 'PR', 'Puerto Rico', 'AMRO', '511', '16572', '3', '214');
INSERT INTO public.who_global_data_import VALUES (67812, '2020-08-01', 'PR', 'Puerto Rico', 'AMRO', '209', '16781', '5', '219');
INSERT INTO public.who_global_data_import VALUES (67813, '2020-08-02', 'PR', 'Puerto Rico', 'AMRO', '1091', '17872', '6', '225');
INSERT INTO public.who_global_data_import VALUES (67814, '2020-08-03', 'PR', 'Puerto Rico', 'AMRO', '539', '18411', '5', '230');
INSERT INTO public.who_global_data_import VALUES (67815, '2020-08-04', 'PR', 'Puerto Rico', 'AMRO', '380', '18791', '0', '230');
INSERT INTO public.who_global_data_import VALUES (67816, '2020-08-05', 'PR', 'Puerto Rico', 'AMRO', '533', '19324', '7', '237');
INSERT INTO public.who_global_data_import VALUES (67817, '2020-08-06', 'PR', 'Puerto Rico', 'AMRO', '327', '19651', '9', '246');
INSERT INTO public.who_global_data_import VALUES (67818, '2020-08-07', 'PR', 'Puerto Rico', 'AMRO', '283', '19934', '12', '258');
INSERT INTO public.who_global_data_import VALUES (67819, '2020-08-08', 'PR', 'Puerto Rico', 'AMRO', '752', '20686', '7', '265');
INSERT INTO public.who_global_data_import VALUES (67820, '2020-08-09', 'PR', 'Puerto Rico', 'AMRO', '738', '21424', '9', '274');
INSERT INTO public.who_global_data_import VALUES (67821, '2020-08-10', 'PR', 'Puerto Rico', 'AMRO', '697', '22121', '5', '279');
INSERT INTO public.who_global_data_import VALUES (67822, '2020-08-11', 'PR', 'Puerto Rico', 'AMRO', '700', '22821', '0', '279');
INSERT INTO public.who_global_data_import VALUES (67823, '2020-08-12', 'PR', 'Puerto Rico', 'AMRO', '582', '23403', '8', '287');
INSERT INTO public.who_global_data_import VALUES (67824, '2020-08-13', 'PR', 'Puerto Rico', 'AMRO', '671', '24074', '8', '295');
INSERT INTO public.who_global_data_import VALUES (67825, '2020-08-14', 'PR', 'Puerto Rico', 'AMRO', '372', '24446', '11', '306');
INSERT INTO public.who_global_data_import VALUES (67826, '2020-08-15', 'PR', 'Puerto Rico', 'AMRO', '682', '25128', '11', '317');
INSERT INTO public.who_global_data_import VALUES (67827, '2020-08-16', 'PR', 'Puerto Rico', 'AMRO', '567', '25695', '12', '329');
INSERT INTO public.who_global_data_import VALUES (67828, '2020-08-17', 'PR', 'Puerto Rico', 'AMRO', '311', '26006', '6', '335');
INSERT INTO public.who_global_data_import VALUES (67829, '2020-08-18', 'PR', 'Puerto Rico', 'AMRO', '754', '26760', '0', '335');
INSERT INTO public.who_global_data_import VALUES (67830, '2020-08-19', 'PR', 'Puerto Rico', 'AMRO', '953', '27713', '11', '346');
INSERT INTO public.who_global_data_import VALUES (67831, '2020-08-20', 'PR', 'Puerto Rico', 'AMRO', '221', '27934', '10', '356');
INSERT INTO public.who_global_data_import VALUES (67832, '2020-08-21', 'PR', 'Puerto Rico', 'AMRO', '209', '28143', '11', '367');
INSERT INTO public.who_global_data_import VALUES (67833, '2020-08-22', 'PR', 'Puerto Rico', 'AMRO', '703', '28846', '7', '374');
INSERT INTO public.who_global_data_import VALUES (67834, '2020-08-23', 'PR', 'Puerto Rico', 'AMRO', '731', '29577', '7', '381');
INSERT INTO public.who_global_data_import VALUES (67835, '2020-08-24', 'PR', 'Puerto Rico', 'AMRO', '319', '29896', '9', '390');
INSERT INTO public.who_global_data_import VALUES (67836, '2020-08-25', 'PR', 'Puerto Rico', 'AMRO', '722', '30618', '0', '390');
INSERT INTO public.who_global_data_import VALUES (67837, '2020-08-26', 'PR', 'Puerto Rico', 'AMRO', '102', '30720', '5', '395');
INSERT INTO public.who_global_data_import VALUES (67838, '2020-08-27', 'PR', 'Puerto Rico', 'AMRO', '24', '30744', '9', '404');
INSERT INTO public.who_global_data_import VALUES (67839, '2020-08-28', 'PR', 'Puerto Rico', 'AMRO', '639', '31383', '8', '412');
INSERT INTO public.who_global_data_import VALUES (67840, '2020-08-29', 'PR', 'Puerto Rico', 'AMRO', '605', '31988', '12', '424');
INSERT INTO public.who_global_data_import VALUES (67841, '2020-08-30', 'PR', 'Puerto Rico', 'AMRO', '562', '32550', '4', '428');
INSERT INTO public.who_global_data_import VALUES (67842, '2020-08-31', 'PR', 'Puerto Rico', 'AMRO', '298', '32848', '6', '434');
INSERT INTO public.who_global_data_import VALUES (67843, '2020-09-01', 'PR', 'Puerto Rico', 'AMRO', '351', '33199', '0', '434');
INSERT INTO public.who_global_data_import VALUES (67844, '2020-09-02', 'PR', 'Puerto Rico', 'AMRO', '222', '33421', '1', '435');
INSERT INTO public.who_global_data_import VALUES (67845, '2020-09-03', 'PR', 'Puerto Rico', 'AMRO', '582', '34003', '8', '443');
INSERT INTO public.who_global_data_import VALUES (67846, '2020-09-04', 'PR', 'Puerto Rico', 'AMRO', '195', '34198', '5', '448');
INSERT INTO public.who_global_data_import VALUES (67847, '2020-09-05', 'PR', 'Puerto Rico', 'AMRO', '43', '34241', '7', '455');
INSERT INTO public.who_global_data_import VALUES (67848, '2020-09-06', 'PR', 'Puerto Rico', 'AMRO', '251', '34492', '9', '464');
INSERT INTO public.who_global_data_import VALUES (67849, '2020-09-07', 'PR', 'Puerto Rico', 'AMRO', '41', '34533', '13', '477');
INSERT INTO public.who_global_data_import VALUES (67850, '2020-09-08', 'PR', 'Puerto Rico', 'AMRO', '842', '35375', '0', '477');
INSERT INTO public.who_global_data_import VALUES (67851, '2020-09-09', 'PR', 'Puerto Rico', 'AMRO', '129', '35504', '5', '482');
INSERT INTO public.who_global_data_import VALUES (67852, '2020-09-10', 'PR', 'Puerto Rico', 'AMRO', '3', '35507', '18', '500');
INSERT INTO public.who_global_data_import VALUES (67853, '2020-09-11', 'PR', 'Puerto Rico', 'AMRO', '772', '36279', '12', '512');
INSERT INTO public.who_global_data_import VALUES (67854, '2020-09-12', 'PR', 'Puerto Rico', 'AMRO', '302', '36581', '11', '523');
INSERT INTO public.who_global_data_import VALUES (67855, '2020-09-13', 'PR', 'Puerto Rico', 'AMRO', '511', '37092', '12', '535');
INSERT INTO public.who_global_data_import VALUES (67856, '2020-09-14', 'PR', 'Puerto Rico', 'AMRO', '288', '37380', '4', '539');
INSERT INTO public.who_global_data_import VALUES (67857, '2020-09-15', 'PR', 'Puerto Rico', 'AMRO', '370', '37750', '3', '542');
INSERT INTO public.who_global_data_import VALUES (67858, '2020-09-16', 'PR', 'Puerto Rico', 'AMRO', '422', '38172', '9', '551');
INSERT INTO public.who_global_data_import VALUES (67859, '2020-09-17', 'PR', 'Puerto Rico', 'AMRO', '112', '38284', '19', '570');
INSERT INTO public.who_global_data_import VALUES (67860, '2020-09-18', 'PR', 'Puerto Rico', 'AMRO', '583', '38867', '18', '588');
INSERT INTO public.who_global_data_import VALUES (67861, '2020-09-19', 'PR', 'Puerto Rico', 'AMRO', '817', '39684', '11', '599');
INSERT INTO public.who_global_data_import VALUES (67862, '2020-09-20', 'PR', 'Puerto Rico', 'AMRO', '1309', '40993', '6', '605');
INSERT INTO public.who_global_data_import VALUES (67863, '2020-09-21', 'PR', 'Puerto Rico', 'AMRO', '845', '41838', '3', '608');
INSERT INTO public.who_global_data_import VALUES (67864, '2020-09-22', 'PR', 'Puerto Rico', 'AMRO', '638', '42476', '1', '609');
INSERT INTO public.who_global_data_import VALUES (67865, '2020-09-23', 'PR', 'Puerto Rico', 'AMRO', '120', '42596', '4', '613');
INSERT INTO public.who_global_data_import VALUES (67866, '2020-09-24', 'PR', 'Puerto Rico', 'AMRO', '64', '42660', '4', '617');
INSERT INTO public.who_global_data_import VALUES (67867, '2020-09-25', 'PR', 'Puerto Rico', 'AMRO', '1182', '43842', '10', '627');
INSERT INTO public.who_global_data_import VALUES (67868, '2020-09-26', 'PR', 'Puerto Rico', 'AMRO', '1063', '44905', '8', '635');
INSERT INTO public.who_global_data_import VALUES (67869, '2020-09-27', 'PR', 'Puerto Rico', 'AMRO', '508', '45413', '7', '642');
INSERT INTO public.who_global_data_import VALUES (67870, '2020-09-28', 'PR', 'Puerto Rico', 'AMRO', '891', '46304', '2', '644');
INSERT INTO public.who_global_data_import VALUES (67871, '2020-09-29', 'PR', 'Puerto Rico', 'AMRO', '1118', '47422', '4', '648');
INSERT INTO public.who_global_data_import VALUES (67872, '2020-09-30', 'PR', 'Puerto Rico', 'AMRO', '1045', '48467', '6', '654');
INSERT INTO public.who_global_data_import VALUES (67873, '2020-10-01', 'PR', 'Puerto Rico', 'AMRO', '288', '48755', '7', '661');
INSERT INTO public.who_global_data_import VALUES (67874, '2020-10-02', 'PR', 'Puerto Rico', 'AMRO', '312', '49067', '4', '665');
INSERT INTO public.who_global_data_import VALUES (67875, '2020-10-03', 'PR', 'Puerto Rico', 'AMRO', '680', '49747', '8', '673');
INSERT INTO public.who_global_data_import VALUES (67876, '2020-10-04', 'PR', 'Puerto Rico', 'AMRO', '628', '50375', '8', '681');
INSERT INTO public.who_global_data_import VALUES (67877, '2020-10-05', 'PR', 'Puerto Rico', 'AMRO', '300', '50675', '5', '686');
INSERT INTO public.who_global_data_import VALUES (67878, '2020-10-06', 'PR', 'Puerto Rico', 'AMRO', '630', '51305', '9', '695');
INSERT INTO public.who_global_data_import VALUES (67879, '2020-10-07', 'PR', 'Puerto Rico', 'AMRO', '432', '51737', '1', '696');
INSERT INTO public.who_global_data_import VALUES (67880, '2020-10-08', 'PR', 'Puerto Rico', 'AMRO', '31', '51768', '9', '705');
INSERT INTO public.who_global_data_import VALUES (67881, '2020-10-09', 'PR', 'Puerto Rico', 'AMRO', '526', '52294', '10', '715');
INSERT INTO public.who_global_data_import VALUES (67882, '2020-10-10', 'PR', 'Puerto Rico', 'AMRO', '598', '52892', '5', '720');
INSERT INTO public.who_global_data_import VALUES (67883, '2020-10-11', 'PR', 'Puerto Rico', 'AMRO', '472', '53364', '8', '728');
INSERT INTO public.who_global_data_import VALUES (67884, '2020-10-12', 'PR', 'Puerto Rico', 'AMRO', '307', '53671', '2', '730');
INSERT INTO public.who_global_data_import VALUES (67885, '2020-10-13', 'PR', 'Puerto Rico', 'AMRO', '563', '54234', '5', '735');
INSERT INTO public.who_global_data_import VALUES (67886, '2020-10-14', 'PR', 'Puerto Rico', 'AMRO', '306', '54540', '3', '738');
INSERT INTO public.who_global_data_import VALUES (67887, '2020-10-15', 'PR', 'Puerto Rico', 'AMRO', '976', '55516', '4', '742');
INSERT INTO public.who_global_data_import VALUES (67888, '2020-10-16', 'PR', 'Puerto Rico', 'AMRO', '569', '56085', '1', '743');
INSERT INTO public.who_global_data_import VALUES (67889, '2020-10-17', 'PR', 'Puerto Rico', 'AMRO', '327', '56412', '15', '758');
INSERT INTO public.who_global_data_import VALUES (67890, '2020-10-18', 'PR', 'Puerto Rico', 'AMRO', '238', '56650', '3', '761');
INSERT INTO public.who_global_data_import VALUES (67891, '2020-10-19', 'PR', 'Puerto Rico', 'AMRO', '643', '57293', '5', '766');
INSERT INTO public.who_global_data_import VALUES (67892, '2020-10-20', 'PR', 'Puerto Rico', 'AMRO', '657', '57950', '2', '768');
INSERT INTO public.who_global_data_import VALUES (67893, '2020-10-21', 'PR', 'Puerto Rico', 'AMRO', '693', '58643', '1', '769');
INSERT INTO public.who_global_data_import VALUES (67894, '2020-10-22', 'PR', 'Puerto Rico', 'AMRO', '187', '58830', '5', '774');
INSERT INTO public.who_global_data_import VALUES (67895, '2020-10-23', 'PR', 'Puerto Rico', 'AMRO', '207', '59037', '9', '783');
INSERT INTO public.who_global_data_import VALUES (67896, '2020-10-24', 'PR', 'Puerto Rico', 'AMRO', '1947', '60984', '8', '791');
INSERT INTO public.who_global_data_import VALUES (67897, '2020-10-25', 'PR', 'Puerto Rico', 'AMRO', '296', '61280', '3', '794');
INSERT INTO public.who_global_data_import VALUES (67898, '2020-10-26', 'PR', 'Puerto Rico', 'AMRO', '1223', '62503', '7', '801');
INSERT INTO public.who_global_data_import VALUES (67899, '2020-10-27', 'PR', 'Puerto Rico', 'AMRO', '632', '63135', '3', '804');
INSERT INTO public.who_global_data_import VALUES (67900, '2020-10-28', 'PR', 'Puerto Rico', 'AMRO', '362', '63497', '4', '808');
INSERT INTO public.who_global_data_import VALUES (67901, '2020-10-29', 'PR', 'Puerto Rico', 'AMRO', '90', '63587', '5', '813');
INSERT INTO public.who_global_data_import VALUES (67902, '2020-10-30', 'PR', 'Puerto Rico', 'AMRO', '1211', '64798', '1', '814');
INSERT INTO public.who_global_data_import VALUES (67903, '2020-10-31', 'PR', 'Puerto Rico', 'AMRO', '945', '65743', '6', '820');
INSERT INTO public.who_global_data_import VALUES (67904, '2020-11-01', 'PR', 'Puerto Rico', 'AMRO', '385', '66128', '2', '822');
INSERT INTO public.who_global_data_import VALUES (67905, '2020-11-02', 'PR', 'Puerto Rico', 'AMRO', '533', '66661', '10', '832');
INSERT INTO public.who_global_data_import VALUES (67906, '2020-11-03', 'PR', 'Puerto Rico', 'AMRO', '1511', '68172', '7', '839');
INSERT INTO public.who_global_data_import VALUES (67907, '2020-11-04', 'PR', 'Puerto Rico', 'AMRO', '771', '68943', '3', '842');
INSERT INTO public.who_global_data_import VALUES (67908, '2020-11-05', 'PR', 'Puerto Rico', 'AMRO', '77', '69020', '8', '850');
INSERT INTO public.who_global_data_import VALUES (67909, '2020-11-06', 'PR', 'Puerto Rico', 'AMRO', '396', '69416', '5', '855');
INSERT INTO public.who_global_data_import VALUES (67910, '2020-11-07', 'PR', 'Puerto Rico', 'AMRO', '1103', '70519', '7', '862');
INSERT INTO public.who_global_data_import VALUES (67911, '2020-11-08', 'PR', 'Puerto Rico', 'AMRO', '-32952', '37567', '0', '862');
INSERT INTO public.who_global_data_import VALUES (67912, '2020-11-09', 'PR', 'Puerto Rico', 'AMRO', '533', '38100', '10', '872');
INSERT INTO public.who_global_data_import VALUES (67913, '2020-11-10', 'PR', 'Puerto Rico', 'AMRO', '481', '38581', '10', '882');
INSERT INTO public.who_global_data_import VALUES (67914, '2020-11-11', 'PR', 'Puerto Rico', 'AMRO', '275', '38856', '7', '889');
INSERT INTO public.who_global_data_import VALUES (67915, '2020-11-12', 'PR', 'Puerto Rico', 'AMRO', '264', '39120', '12', '901');
INSERT INTO public.who_global_data_import VALUES (67916, '2020-11-13', 'PR', 'Puerto Rico', 'AMRO', '1332', '40452', '8', '909');
INSERT INTO public.who_global_data_import VALUES (67917, '2020-11-14', 'PR', 'Puerto Rico', 'AMRO', '667', '41119', '5', '914');
INSERT INTO public.who_global_data_import VALUES (67918, '2020-11-15', 'PR', 'Puerto Rico', 'AMRO', '653', '41772', '7', '921');
INSERT INTO public.who_global_data_import VALUES (67919, '2020-11-16', 'PR', 'Puerto Rico', 'AMRO', '707', '42479', '14', '935');
INSERT INTO public.who_global_data_import VALUES (67920, '2020-11-17', 'PR', 'Puerto Rico', 'AMRO', '537', '43016', '7', '942');
INSERT INTO public.who_global_data_import VALUES (67921, '2020-11-18', 'PR', 'Puerto Rico', 'AMRO', '569', '43585', '9', '951');
INSERT INTO public.who_global_data_import VALUES (67922, '2020-11-19', 'PR', 'Puerto Rico', 'AMRO', '325', '43910', '20', '971');
INSERT INTO public.who_global_data_import VALUES (67923, '2020-11-20', 'PR', 'Puerto Rico', 'AMRO', '521', '44431', '11', '982');
INSERT INTO public.who_global_data_import VALUES (67924, '2020-11-21', 'PR', 'Puerto Rico', 'AMRO', '904', '45335', '9', '991');
INSERT INTO public.who_global_data_import VALUES (67925, '2020-11-22', 'PR', 'Puerto Rico', 'AMRO', '1099', '46434', '21', '1012');
INSERT INTO public.who_global_data_import VALUES (67926, '2020-11-23', 'PR', 'Puerto Rico', 'AMRO', '1025', '47459', '5', '1017');
INSERT INTO public.who_global_data_import VALUES (67927, '2020-11-24', 'PR', 'Puerto Rico', 'AMRO', '741', '48200', '15', '1032');
INSERT INTO public.who_global_data_import VALUES (67928, '2020-11-25', 'PR', 'Puerto Rico', 'AMRO', '348', '48548', '6', '1038');
INSERT INTO public.who_global_data_import VALUES (67929, '2020-11-26', 'PR', 'Puerto Rico', 'AMRO', '177', '48725', '14', '1052');
INSERT INTO public.who_global_data_import VALUES (67930, '2020-11-27', 'PR', 'Puerto Rico', 'AMRO', '501', '49226', '17', '1069');
INSERT INTO public.who_global_data_import VALUES (67931, '2020-11-28', 'PR', 'Puerto Rico', 'AMRO', '1452', '50678', '7', '1076');
INSERT INTO public.who_global_data_import VALUES (67932, '2020-11-29', 'PR', 'Puerto Rico', 'AMRO', '903', '51581', '7', '1083');
INSERT INTO public.who_global_data_import VALUES (67933, '2020-11-30', 'PR', 'Puerto Rico', 'AMRO', '121', '51702', '11', '1094');
INSERT INTO public.who_global_data_import VALUES (67934, '2020-12-01', 'PR', 'Puerto Rico', 'AMRO', '843', '52545', '12', '1106');
INSERT INTO public.who_global_data_import VALUES (67935, '2020-12-02', 'PR', 'Puerto Rico', 'AMRO', '775', '53320', '16', '1122');
INSERT INTO public.who_global_data_import VALUES (67936, '2020-12-03', 'PR', 'Puerto Rico', 'AMRO', '388', '53708', '22', '1144');
INSERT INTO public.who_global_data_import VALUES (67937, '2020-12-04', 'PR', 'Puerto Rico', 'AMRO', '397', '54105', '11', '1155');
INSERT INTO public.who_global_data_import VALUES (67938, '2020-12-05', 'PR', 'Puerto Rico', 'AMRO', '492', '54597', '18', '1173');
INSERT INTO public.who_global_data_import VALUES (67939, '2020-12-06', 'PR', 'Puerto Rico', 'AMRO', '935', '55532', '12', '1185');
INSERT INTO public.who_global_data_import VALUES (67940, '2020-12-07', 'PR', 'Puerto Rico', 'AMRO', '1139', '56671', '7', '1192');
INSERT INTO public.who_global_data_import VALUES (67941, '2020-12-08', 'PR', 'Puerto Rico', 'AMRO', '951', '57622', '11', '1203');
INSERT INTO public.who_global_data_import VALUES (67942, '2020-12-09', 'PR', 'Puerto Rico', 'AMRO', '694', '58316', '3', '1206');
INSERT INTO public.who_global_data_import VALUES (67943, '2020-12-10', 'PR', 'Puerto Rico', 'AMRO', '646', '58962', '13', '1219');
INSERT INTO public.who_global_data_import VALUES (67944, '2020-12-11', 'PR', 'Puerto Rico', 'AMRO', '496', '59458', '19', '1238');
INSERT INTO public.who_global_data_import VALUES (67945, '2020-12-12', 'PR', 'Puerto Rico', 'AMRO', '1544', '61002', '11', '1249');
INSERT INTO public.who_global_data_import VALUES (67946, '2020-12-13', 'PR', 'Puerto Rico', 'AMRO', '721', '61723', '17', '1266');
INSERT INTO public.who_global_data_import VALUES (67947, '2020-12-14', 'PR', 'Puerto Rico', 'AMRO', '708', '62431', '6', '1272');
INSERT INTO public.who_global_data_import VALUES (67948, '2020-12-15', 'PR', 'Puerto Rico', 'AMRO', '554', '62985', '10', '1282');
INSERT INTO public.who_global_data_import VALUES (67949, '2020-12-16', 'PR', 'Puerto Rico', 'AMRO', '434', '63419', '12', '1294');
INSERT INTO public.who_global_data_import VALUES (67950, '2020-12-17', 'PR', 'Puerto Rico', 'AMRO', '267', '63686', '18', '1312');
INSERT INTO public.who_global_data_import VALUES (67951, '2020-12-18', 'PR', 'Puerto Rico', 'AMRO', '1065', '64751', '11', '1323');
INSERT INTO public.who_global_data_import VALUES (67952, '2020-12-19', 'PR', 'Puerto Rico', 'AMRO', '1381', '66132', '10', '1333');
INSERT INTO public.who_global_data_import VALUES (67953, '2020-12-20', 'PR', 'Puerto Rico', 'AMRO', '1079', '67211', '9', '1342');
INSERT INTO public.who_global_data_import VALUES (67954, '2020-12-21', 'PR', 'Puerto Rico', 'AMRO', '1222', '68433', '26', '1368');
INSERT INTO public.who_global_data_import VALUES (67955, '2020-12-22', 'PR', 'Puerto Rico', 'AMRO', '416', '68849', '14', '1382');
INSERT INTO public.who_global_data_import VALUES (67956, '2020-12-23', 'PR', 'Puerto Rico', 'AMRO', '1063', '69912', '9', '1391');
INSERT INTO public.who_global_data_import VALUES (67957, '2020-12-24', 'PR', 'Puerto Rico', 'AMRO', '576', '70488', '17', '1408');
INSERT INTO public.who_global_data_import VALUES (67958, '2020-12-25', 'PR', 'Puerto Rico', 'AMRO', '320', '70808', '15', '1423');
INSERT INTO public.who_global_data_import VALUES (67959, '2020-12-26', 'PR', 'Puerto Rico', 'AMRO', '616', '71424', '9', '1432');
INSERT INTO public.who_global_data_import VALUES (67960, '2020-12-27', 'PR', 'Puerto Rico', 'AMRO', '1019', '72443', '0', '1432');
INSERT INTO public.who_global_data_import VALUES (67961, '2020-12-28', 'PR', 'Puerto Rico', 'AMRO', '784', '73227', '13', '1445');
INSERT INTO public.who_global_data_import VALUES (67962, '2020-12-29', 'PR', 'Puerto Rico', 'AMRO', '431', '73658', '11', '1456');
INSERT INTO public.who_global_data_import VALUES (67963, '2020-12-30', 'PR', 'Puerto Rico', 'AMRO', '2132', '75790', '4', '1460');
INSERT INTO public.who_global_data_import VALUES (67964, '2020-12-31', 'PR', 'Puerto Rico', 'AMRO', '98', '75888', '24', '1484');
INSERT INTO public.who_global_data_import VALUES (67965, '2021-01-01', 'PR', 'Puerto Rico', 'AMRO', '403', '76291', '19', '1503');
INSERT INTO public.who_global_data_import VALUES (67966, '2021-01-02', 'PR', 'Puerto Rico', 'AMRO', '763', '77054', '18', '1521');
INSERT INTO public.who_global_data_import VALUES (67967, '2021-01-03', 'PR', 'Puerto Rico', 'AMRO', '878', '77932', '5', '1526');
INSERT INTO public.who_global_data_import VALUES (67968, '2021-01-04', 'PR', 'Puerto Rico', 'AMRO', '237', '78169', '19', '1545');
INSERT INTO public.who_global_data_import VALUES (67969, '2021-01-05', 'PR', 'Puerto Rico', 'AMRO', '636', '78805', '10', '1555');
INSERT INTO public.who_global_data_import VALUES (67970, '2021-01-06', 'PR', 'Puerto Rico', 'AMRO', '514', '79319', '7', '1562');
INSERT INTO public.who_global_data_import VALUES (67971, '2021-01-07', 'PR', 'Puerto Rico', 'AMRO', '293', '79612', '8', '1570');
INSERT INTO public.who_global_data_import VALUES (67972, '2021-01-08', 'PR', 'Puerto Rico', 'AMRO', '286', '79898', '18', '1588');
INSERT INTO public.who_global_data_import VALUES (67973, '2021-01-09', 'PR', 'Puerto Rico', 'AMRO', '2169', '82067', '4', '1592');
INSERT INTO public.who_global_data_import VALUES (67974, '2021-01-10', 'PR', 'Puerto Rico', 'AMRO', '563', '82630', '24', '1616');
INSERT INTO public.who_global_data_import VALUES (67975, '2021-01-11', 'PR', 'Puerto Rico', 'AMRO', '489', '83119', '14', '1630');
INSERT INTO public.who_global_data_import VALUES (67976, '2021-01-12', 'PR', 'Puerto Rico', 'AMRO', '349', '83468', '12', '1642');
INSERT INTO public.who_global_data_import VALUES (67977, '2021-01-13', 'PR', 'Puerto Rico', 'AMRO', '959', '84427', '3', '1645');
INSERT INTO public.who_global_data_import VALUES (67978, '2021-01-14', 'PR', 'Puerto Rico', 'AMRO', '212', '84639', '14', '1659');
INSERT INTO public.who_global_data_import VALUES (67979, '2021-01-15', 'PR', 'Puerto Rico', 'AMRO', '177', '84816', '20', '1679');
INSERT INTO public.who_global_data_import VALUES (67980, '2021-01-16', 'PR', 'Puerto Rico', 'AMRO', '1138', '85954', '13', '1692');
INSERT INTO public.who_global_data_import VALUES (67981, '2021-01-17', 'PR', 'Puerto Rico', 'AMRO', '569', '86523', '11', '1703');
INSERT INTO public.who_global_data_import VALUES (67982, '2021-01-18', 'PR', 'Puerto Rico', 'AMRO', '849', '87372', '0', '1703');
INSERT INTO public.who_global_data_import VALUES (67983, '2021-01-19', 'PR', 'Puerto Rico', 'AMRO', '567', '87939', '0', '1703');
INSERT INTO public.who_global_data_import VALUES (67984, '2021-01-20', 'PR', 'Puerto Rico', 'AMRO', '434', '88373', '0', '1703');
INSERT INTO public.who_global_data_import VALUES (67985, '2021-01-21', 'PR', 'Puerto Rico', 'AMRO', '140', '88513', '14', '1717');
INSERT INTO public.who_global_data_import VALUES (67986, '2021-01-22', 'PR', 'Puerto Rico', 'AMRO', '215', '88728', '15', '1732');
INSERT INTO public.who_global_data_import VALUES (67987, '2021-01-23', 'PR', 'Puerto Rico', 'AMRO', '554', '89282', '29', '1761');
INSERT INTO public.who_global_data_import VALUES (67988, '2021-01-24', 'PR', 'Puerto Rico', 'AMRO', '791', '90073', '10', '1771');
INSERT INTO public.who_global_data_import VALUES (67989, '2021-01-25', 'PR', 'Puerto Rico', 'AMRO', '955', '91028', '2', '1773');
INSERT INTO public.who_global_data_import VALUES (67990, '2021-01-26', 'PR', 'Puerto Rico', 'AMRO', '568', '91596', '5', '1778');
INSERT INTO public.who_global_data_import VALUES (67991, '2021-01-27', 'PR', 'Puerto Rico', 'AMRO', '473', '92069', '5', '1783');
INSERT INTO public.who_global_data_import VALUES (67992, '2021-01-28', 'PR', 'Puerto Rico', 'AMRO', '175', '92244', '11', '1794');
INSERT INTO public.who_global_data_import VALUES (67993, '2021-01-29', 'PR', 'Puerto Rico', 'AMRO', '297', '92541', '7', '1801');
INSERT INTO public.who_global_data_import VALUES (67994, '2021-01-30', 'PR', 'Puerto Rico', 'AMRO', '427', '92968', '11', '1812');
INSERT INTO public.who_global_data_import VALUES (67995, '2021-01-31', 'PR', 'Puerto Rico', 'AMRO', '438', '93406', '11', '1823');
INSERT INTO public.who_global_data_import VALUES (67996, '2021-02-01', 'PR', 'Puerto Rico', 'AMRO', '218', '93624', '6', '1829');
INSERT INTO public.who_global_data_import VALUES (67997, '2021-02-02', 'PR', 'Puerto Rico', 'AMRO', '614', '94238', '7', '1836');
INSERT INTO public.who_global_data_import VALUES (67998, '2021-02-03', 'PR', 'Puerto Rico', 'AMRO', '288', '94526', '10', '1846');
INSERT INTO public.who_global_data_import VALUES (67999, '2021-02-04', 'PR', 'Puerto Rico', 'AMRO', '136', '94662', '7', '1853');
INSERT INTO public.who_global_data_import VALUES (68000, '2021-02-05', 'PR', 'Puerto Rico', 'AMRO', '322', '94984', '8', '1861');
INSERT INTO public.who_global_data_import VALUES (68001, '2020-01-03', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68002, '2020-01-04', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68003, '2020-01-05', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68004, '2020-01-06', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68005, '2020-01-07', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68006, '2020-01-08', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68007, '2020-01-09', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68008, '2020-01-10', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68009, '2020-01-11', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68010, '2020-01-12', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68011, '2020-01-13', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68012, '2020-01-14', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68013, '2020-01-15', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68015, '2020-01-17', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68016, '2020-01-18', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68017, '2020-01-19', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68018, '2020-01-20', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68019, '2020-01-21', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68020, '2020-01-22', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68021, '2020-01-23', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68022, '2020-01-24', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68023, '2020-01-25', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68024, '2020-01-26', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68025, '2020-01-27', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68026, '2020-01-28', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68027, '2020-01-29', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68028, '2020-01-30', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68029, '2020-01-31', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68030, '2020-02-01', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68031, '2020-02-02', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68032, '2020-02-03', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68033, '2020-02-04', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68034, '2020-02-05', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68035, '2020-02-06', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68036, '2020-02-07', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68037, '2020-02-08', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68038, '2020-02-09', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68039, '2020-02-10', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68040, '2020-02-11', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68041, '2020-02-12', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68042, '2020-02-13', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68043, '2020-02-14', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68044, '2020-02-15', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68045, '2020-02-16', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68046, '2020-02-17', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68047, '2020-02-18', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68048, '2020-02-19', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68049, '2020-02-20', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68050, '2020-02-21', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68051, '2020-02-22', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68052, '2020-02-23', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68053, '2020-02-24', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68054, '2020-02-25', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68055, '2020-02-26', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68056, '2020-02-27', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68057, '2020-02-28', 'QA', 'Qatar', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68058, '2020-02-29', 'QA', 'Qatar', 'EMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68059, '2020-03-01', 'QA', 'Qatar', 'EMRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68060, '2020-03-02', 'QA', 'Qatar', 'EMRO', '4', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68061, '2020-03-03', 'QA', 'Qatar', 'EMRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68062, '2020-03-04', 'QA', 'Qatar', 'EMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68063, '2020-03-05', 'QA', 'Qatar', 'EMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68064, '2020-03-06', 'QA', 'Qatar', 'EMRO', '3', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68065, '2020-03-07', 'QA', 'Qatar', 'EMRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68066, '2020-03-08', 'QA', 'Qatar', 'EMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68067, '2020-03-09', 'QA', 'Qatar', 'EMRO', '3', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68068, '2020-03-10', 'QA', 'Qatar', 'EMRO', '3', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68069, '2020-03-11', 'QA', 'Qatar', 'EMRO', '244', '266', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68070, '2020-03-12', 'QA', 'Qatar', 'EMRO', '0', '266', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68071, '2020-03-13', 'QA', 'Qatar', 'EMRO', '0', '266', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68072, '2020-03-14', 'QA', 'Qatar', 'EMRO', '75', '341', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68073, '2020-03-15', 'QA', 'Qatar', 'EMRO', '0', '341', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68074, '2020-03-16', 'QA', 'Qatar', 'EMRO', '64', '405', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68075, '2020-03-17', 'QA', 'Qatar', 'EMRO', '41', '446', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68076, '2020-03-18', 'QA', 'Qatar', 'EMRO', '0', '446', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68077, '2020-03-19', 'QA', 'Qatar', 'EMRO', '10', '456', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68078, '2020-03-20', 'QA', 'Qatar', 'EMRO', '4', '460', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68079, '2020-03-21', 'QA', 'Qatar', 'EMRO', '10', '470', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68080, '2020-03-22', 'QA', 'Qatar', 'EMRO', '11', '481', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68081, '2020-03-23', 'QA', 'Qatar', 'EMRO', '13', '494', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68082, '2020-03-24', 'QA', 'Qatar', 'EMRO', '7', '501', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68083, '2020-03-25', 'QA', 'Qatar', 'EMRO', '25', '526', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68084, '2020-03-26', 'QA', 'Qatar', 'EMRO', '11', '537', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68085, '2020-03-27', 'QA', 'Qatar', 'EMRO', '12', '549', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68086, '2020-03-28', 'QA', 'Qatar', 'EMRO', '13', '562', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68087, '2020-03-29', 'QA', 'Qatar', 'EMRO', '28', '590', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68088, '2020-03-30', 'QA', 'Qatar', 'EMRO', '44', '634', '1', '1');
INSERT INTO public.who_global_data_import VALUES (68089, '2020-03-31', 'QA', 'Qatar', 'EMRO', '59', '693', '0', '1');
INSERT INTO public.who_global_data_import VALUES (68090, '2020-04-01', 'QA', 'Qatar', 'EMRO', '88', '781', '1', '2');
INSERT INTO public.who_global_data_import VALUES (68091, '2020-04-02', 'QA', 'Qatar', 'EMRO', '54', '835', '0', '2');
INSERT INTO public.who_global_data_import VALUES (68092, '2020-04-03', 'QA', 'Qatar', 'EMRO', '240', '1075', '1', '3');
INSERT INTO public.who_global_data_import VALUES (68093, '2020-04-04', 'QA', 'Qatar', 'EMRO', '0', '1075', '0', '3');
INSERT INTO public.who_global_data_import VALUES (68094, '2020-04-05', 'QA', 'Qatar', 'EMRO', '250', '1325', '0', '3');
INSERT INTO public.who_global_data_import VALUES (68095, '2020-04-06', 'QA', 'Qatar', 'EMRO', '279', '1604', '1', '4');
INSERT INTO public.who_global_data_import VALUES (68096, '2020-04-07', 'QA', 'Qatar', 'EMRO', '228', '1832', '0', '4');
INSERT INTO public.who_global_data_import VALUES (68097, '2020-04-08', 'QA', 'Qatar', 'EMRO', '378', '2210', '2', '6');
INSERT INTO public.who_global_data_import VALUES (68098, '2020-04-09', 'QA', 'Qatar', 'EMRO', '166', '2376', '0', '6');
INSERT INTO public.who_global_data_import VALUES (68099, '2020-04-10', 'QA', 'Qatar', 'EMRO', '136', '2512', '0', '6');
INSERT INTO public.who_global_data_import VALUES (68100, '2020-04-11', 'QA', 'Qatar', 'EMRO', '216', '2728', '0', '6');
INSERT INTO public.who_global_data_import VALUES (68101, '2020-04-12', 'QA', 'Qatar', 'EMRO', '251', '2979', '1', '7');
INSERT INTO public.who_global_data_import VALUES (68102, '2020-04-13', 'QA', 'Qatar', 'EMRO', '252', '3231', '0', '7');
INSERT INTO public.who_global_data_import VALUES (68103, '2020-04-14', 'QA', 'Qatar', 'EMRO', '197', '3428', '0', '7');
INSERT INTO public.who_global_data_import VALUES (68104, '2020-04-15', 'QA', 'Qatar', 'EMRO', '283', '3711', '0', '7');
INSERT INTO public.who_global_data_import VALUES (68105, '2020-04-16', 'QA', 'Qatar', 'EMRO', '392', '4103', '0', '7');
INSERT INTO public.who_global_data_import VALUES (68106, '2020-04-17', 'QA', 'Qatar', 'EMRO', '560', '4663', '0', '7');
INSERT INTO public.who_global_data_import VALUES (68107, '2020-04-18', 'QA', 'Qatar', 'EMRO', '345', '5008', '1', '8');
INSERT INTO public.who_global_data_import VALUES (68108, '2020-04-19', 'QA', 'Qatar', 'EMRO', '440', '5448', '0', '8');
INSERT INTO public.who_global_data_import VALUES (68109, '2020-04-20', 'QA', 'Qatar', 'EMRO', '567', '6015', '1', '9');
INSERT INTO public.who_global_data_import VALUES (68110, '2020-04-21', 'QA', 'Qatar', 'EMRO', '518', '6533', '0', '9');
INSERT INTO public.who_global_data_import VALUES (68111, '2020-04-22', 'QA', 'Qatar', 'EMRO', '608', '7141', '1', '10');
INSERT INTO public.who_global_data_import VALUES (68112, '2020-04-23', 'QA', 'Qatar', 'EMRO', '623', '7764', '0', '10');
INSERT INTO public.who_global_data_import VALUES (68113, '2020-04-24', 'QA', 'Qatar', 'EMRO', '761', '8525', '0', '10');
INSERT INTO public.who_global_data_import VALUES (68114, '2020-04-25', 'QA', 'Qatar', 'EMRO', '833', '9358', '0', '10');
INSERT INTO public.who_global_data_import VALUES (68115, '2020-04-26', 'QA', 'Qatar', 'EMRO', '929', '10287', '0', '10');
INSERT INTO public.who_global_data_import VALUES (68116, '2020-04-27', 'QA', 'Qatar', 'EMRO', '957', '11244', '0', '10');
INSERT INTO public.who_global_data_import VALUES (68117, '2020-04-28', 'QA', 'Qatar', 'EMRO', '677', '11921', '0', '10');
INSERT INTO public.who_global_data_import VALUES (68118, '2020-04-29', 'QA', 'Qatar', 'EMRO', '643', '12564', '0', '10');
INSERT INTO public.who_global_data_import VALUES (68119, '2020-04-30', 'QA', 'Qatar', 'EMRO', '845', '13409', '0', '10');
INSERT INTO public.who_global_data_import VALUES (68120, '2020-05-01', 'QA', 'Qatar', 'EMRO', '687', '14096', '2', '12');
INSERT INTO public.who_global_data_import VALUES (68121, '2020-05-02', 'QA', 'Qatar', 'EMRO', '776', '14872', '0', '12');
INSERT INTO public.who_global_data_import VALUES (68122, '2020-05-03', 'QA', 'Qatar', 'EMRO', '679', '15551', '0', '12');
INSERT INTO public.who_global_data_import VALUES (68123, '2020-05-04', 'QA', 'Qatar', 'EMRO', '640', '16191', '0', '12');
INSERT INTO public.who_global_data_import VALUES (68124, '2020-05-05', 'QA', 'Qatar', 'EMRO', '951', '17142', '0', '12');
INSERT INTO public.who_global_data_import VALUES (68125, '2020-05-06', 'QA', 'Qatar', 'EMRO', '830', '17972', '0', '12');
INSERT INTO public.who_global_data_import VALUES (68126, '2020-05-07', 'QA', 'Qatar', 'EMRO', '918', '18890', '0', '12');
INSERT INTO public.who_global_data_import VALUES (68127, '2020-05-08', 'QA', 'Qatar', 'EMRO', '1311', '20201', '0', '12');
INSERT INTO public.who_global_data_import VALUES (68128, '2020-05-09', 'QA', 'Qatar', 'EMRO', '1130', '21331', '1', '13');
INSERT INTO public.who_global_data_import VALUES (68129, '2020-05-10', 'QA', 'Qatar', 'EMRO', '1189', '22520', '1', '14');
INSERT INTO public.who_global_data_import VALUES (68130, '2020-05-11', 'QA', 'Qatar', 'EMRO', '1103', '23623', '0', '14');
INSERT INTO public.who_global_data_import VALUES (68131, '2020-05-12', 'QA', 'Qatar', 'EMRO', '1526', '25149', '0', '14');
INSERT INTO public.who_global_data_import VALUES (68132, '2020-05-13', 'QA', 'Qatar', 'EMRO', '1390', '26539', '0', '14');
INSERT INTO public.who_global_data_import VALUES (68133, '2020-05-14', 'QA', 'Qatar', 'EMRO', '1733', '28272', '0', '14');
INSERT INTO public.who_global_data_import VALUES (68134, '2020-05-15', 'QA', 'Qatar', 'EMRO', '1153', '29425', '0', '14');
INSERT INTO public.who_global_data_import VALUES (68135, '2020-05-16', 'QA', 'Qatar', 'EMRO', '1547', '30972', '1', '15');
INSERT INTO public.who_global_data_import VALUES (68136, '2020-05-17', 'QA', 'Qatar', 'EMRO', '1632', '32604', '0', '15');
INSERT INTO public.who_global_data_import VALUES (68137, '2020-05-18', 'QA', 'Qatar', 'EMRO', '1365', '33969', '0', '15');
INSERT INTO public.who_global_data_import VALUES (68138, '2020-05-19', 'QA', 'Qatar', 'EMRO', '1637', '35606', '0', '15');
INSERT INTO public.who_global_data_import VALUES (68139, '2020-05-20', 'QA', 'Qatar', 'EMRO', '1491', '37097', '1', '16');
INSERT INTO public.who_global_data_import VALUES (68140, '2020-05-21', 'QA', 'Qatar', 'EMRO', '1554', '38651', '1', '17');
INSERT INTO public.who_global_data_import VALUES (68141, '2020-05-22', 'QA', 'Qatar', 'EMRO', '0', '38651', '0', '17');
INSERT INTO public.who_global_data_import VALUES (68142, '2020-05-23', 'QA', 'Qatar', 'EMRO', '1830', '40481', '2', '19');
INSERT INTO public.who_global_data_import VALUES (68143, '2020-05-24', 'QA', 'Qatar', 'EMRO', '1732', '42213', '2', '21');
INSERT INTO public.who_global_data_import VALUES (68144, '2020-05-25', 'QA', 'Qatar', 'EMRO', '1501', '43714', '2', '23');
INSERT INTO public.who_global_data_import VALUES (68145, '2020-05-26', 'QA', 'Qatar', 'EMRO', '1751', '45465', '3', '26');
INSERT INTO public.who_global_data_import VALUES (68146, '2020-05-27', 'QA', 'Qatar', 'EMRO', '1742', '47207', '2', '28');
INSERT INTO public.who_global_data_import VALUES (68147, '2020-05-28', 'QA', 'Qatar', 'EMRO', '1740', '48947', '2', '30');
INSERT INTO public.who_global_data_import VALUES (68148, '2020-05-29', 'QA', 'Qatar', 'EMRO', '1967', '50914', '3', '33');
INSERT INTO public.who_global_data_import VALUES (68149, '2020-05-30', 'QA', 'Qatar', 'EMRO', '1993', '52907', '3', '36');
INSERT INTO public.who_global_data_import VALUES (68150, '2020-05-31', 'QA', 'Qatar', 'EMRO', '2355', '55262', '0', '36');
INSERT INTO public.who_global_data_import VALUES (68151, '2020-06-01', 'QA', 'Qatar', 'EMRO', '1648', '56910', '2', '38');
INSERT INTO public.who_global_data_import VALUES (68152, '2020-06-02', 'QA', 'Qatar', 'EMRO', '1523', '58433', '2', '40');
INSERT INTO public.who_global_data_import VALUES (68153, '2020-06-03', 'QA', 'Qatar', 'EMRO', '1826', '60259', '3', '43');
INSERT INTO public.who_global_data_import VALUES (68154, '2020-06-04', 'QA', 'Qatar', 'EMRO', '1901', '62160', '2', '45');
INSERT INTO public.who_global_data_import VALUES (68155, '2020-06-05', 'QA', 'Qatar', 'EMRO', '1581', '63741', '0', '45');
INSERT INTO public.who_global_data_import VALUES (68156, '2020-06-06', 'QA', 'Qatar', 'EMRO', '1754', '65495', '4', '49');
INSERT INTO public.who_global_data_import VALUES (68157, '2020-06-07', 'QA', 'Qatar', 'EMRO', '1700', '67195', '2', '51');
INSERT INTO public.who_global_data_import VALUES (68158, '2020-06-08', 'QA', 'Qatar', 'EMRO', '1595', '68790', '3', '54');
INSERT INTO public.who_global_data_import VALUES (68159, '2020-06-09', 'QA', 'Qatar', 'EMRO', '1368', '70158', '3', '57');
INSERT INTO public.who_global_data_import VALUES (68160, '2020-06-10', 'QA', 'Qatar', 'EMRO', '1721', '71879', '5', '62');
INSERT INTO public.who_global_data_import VALUES (68161, '2020-06-11', 'QA', 'Qatar', 'EMRO', '1716', '73595', '4', '66');
INSERT INTO public.who_global_data_import VALUES (68162, '2020-06-12', 'QA', 'Qatar', 'EMRO', '1476', '75071', '3', '69');
INSERT INTO public.who_global_data_import VALUES (68163, '2020-06-13', 'QA', 'Qatar', 'EMRO', '1517', '76588', '1', '70');
INSERT INTO public.who_global_data_import VALUES (68164, '2020-06-14', 'QA', 'Qatar', 'EMRO', '1828', '78416', '0', '70');
INSERT INTO public.who_global_data_import VALUES (68165, '2020-06-15', 'QA', 'Qatar', 'EMRO', '1186', '79602', '3', '73');
INSERT INTO public.who_global_data_import VALUES (68166, '2020-06-16', 'QA', 'Qatar', 'EMRO', '1274', '80876', '3', '76');
INSERT INTO public.who_global_data_import VALUES (68167, '2020-06-17', 'QA', 'Qatar', 'EMRO', '1201', '82077', '4', '80');
INSERT INTO public.who_global_data_import VALUES (68168, '2020-06-18', 'QA', 'Qatar', 'EMRO', '1097', '83174', '2', '82');
INSERT INTO public.who_global_data_import VALUES (68169, '2020-06-19', 'QA', 'Qatar', 'EMRO', '1267', '84441', '4', '86');
INSERT INTO public.who_global_data_import VALUES (68170, '2020-06-20', 'QA', 'Qatar', 'EMRO', '1021', '85462', '7', '93');
INSERT INTO public.who_global_data_import VALUES (68171, '2020-06-21', 'QA', 'Qatar', 'EMRO', '1026', '86488', '1', '94');
INSERT INTO public.who_global_data_import VALUES (68172, '2020-06-22', 'QA', 'Qatar', 'EMRO', '881', '87369', '4', '98');
INSERT INTO public.who_global_data_import VALUES (68173, '2020-06-23', 'QA', 'Qatar', 'EMRO', '1034', '88403', '1', '99');
INSERT INTO public.who_global_data_import VALUES (68174, '2020-06-24', 'QA', 'Qatar', 'EMRO', '1176', '89579', '0', '99');
INSERT INTO public.who_global_data_import VALUES (68175, '2020-06-25', 'QA', 'Qatar', 'EMRO', '1199', '90778', '5', '104');
INSERT INTO public.who_global_data_import VALUES (68176, '2020-06-26', 'QA', 'Qatar', 'EMRO', '1060', '91838', '2', '106');
INSERT INTO public.who_global_data_import VALUES (68177, '2020-06-27', 'QA', 'Qatar', 'EMRO', '946', '92784', '3', '109');
INSERT INTO public.who_global_data_import VALUES (68178, '2020-06-28', 'QA', 'Qatar', 'EMRO', '879', '93663', '1', '110');
INSERT INTO public.who_global_data_import VALUES (68179, '2020-06-29', 'QA', 'Qatar', 'EMRO', '750', '94413', '0', '110');
INSERT INTO public.who_global_data_import VALUES (68180, '2020-06-30', 'QA', 'Qatar', 'EMRO', '693', '95106', '3', '113');
INSERT INTO public.who_global_data_import VALUES (68181, '2020-07-01', 'QA', 'Qatar', 'EMRO', '982', '96088', '0', '113');
INSERT INTO public.who_global_data_import VALUES (68182, '2020-07-02', 'QA', 'Qatar', 'EMRO', '915', '97003', '2', '115');
INSERT INTO public.who_global_data_import VALUES (68183, '2020-07-03', 'QA', 'Qatar', 'EMRO', '894', '97897', '3', '118');
INSERT INTO public.who_global_data_import VALUES (68184, '2020-07-04', 'QA', 'Qatar', 'EMRO', '756', '98653', '3', '121');
INSERT INTO public.who_global_data_import VALUES (68185, '2020-07-05', 'QA', 'Qatar', 'EMRO', '530', '99183', '2', '123');
INSERT INTO public.who_global_data_import VALUES (68186, '2020-07-06', 'QA', 'Qatar', 'EMRO', '616', '99799', '5', '128');
INSERT INTO public.who_global_data_import VALUES (68187, '2020-07-07', 'QA', 'Qatar', 'EMRO', '546', '100345', '5', '133');
INSERT INTO public.who_global_data_import VALUES (68188, '2020-07-08', 'QA', 'Qatar', 'EMRO', '600', '100945', '1', '134');
INSERT INTO public.who_global_data_import VALUES (68189, '2020-07-09', 'QA', 'Qatar', 'EMRO', '608', '101553', '4', '138');
INSERT INTO public.who_global_data_import VALUES (68190, '2020-07-10', 'QA', 'Qatar', 'EMRO', '557', '102110', '4', '142');
INSERT INTO public.who_global_data_import VALUES (68191, '2020-07-11', 'QA', 'Qatar', 'EMRO', '520', '102630', '4', '146');
INSERT INTO public.who_global_data_import VALUES (68192, '2020-07-12', 'QA', 'Qatar', 'EMRO', '498', '103128', '0', '146');
INSERT INTO public.who_global_data_import VALUES (68193, '2020-07-13', 'QA', 'Qatar', 'EMRO', '470', '103598', '1', '147');
INSERT INTO public.who_global_data_import VALUES (68194, '2020-07-14', 'QA', 'Qatar', 'EMRO', '418', '104016', '2', '149');
INSERT INTO public.who_global_data_import VALUES (68195, '2020-07-15', 'QA', 'Qatar', 'EMRO', '517', '104533', '1', '150');
INSERT INTO public.who_global_data_import VALUES (68196, '2020-07-16', 'QA', 'Qatar', 'EMRO', '450', '104983', '1', '151');
INSERT INTO public.who_global_data_import VALUES (68197, '2020-07-17', 'QA', 'Qatar', 'EMRO', '494', '105477', '1', '152');
INSERT INTO public.who_global_data_import VALUES (68198, '2020-07-18', 'QA', 'Qatar', 'EMRO', '421', '105898', '1', '153');
INSERT INTO public.who_global_data_import VALUES (68199, '2020-07-19', 'QA', 'Qatar', 'EMRO', '410', '106308', '1', '154');
INSERT INTO public.who_global_data_import VALUES (68200, '2020-07-20', 'QA', 'Qatar', 'EMRO', '340', '106648', '3', '157');
INSERT INTO public.who_global_data_import VALUES (68201, '2020-07-21', 'QA', 'Qatar', 'EMRO', '389', '107037', '2', '159');
INSERT INTO public.who_global_data_import VALUES (68202, '2020-07-22', 'QA', 'Qatar', 'EMRO', '393', '107430', '1', '160');
INSERT INTO public.who_global_data_import VALUES (68203, '2020-07-23', 'QA', 'Qatar', 'EMRO', '441', '107871', '3', '163');
INSERT INTO public.who_global_data_import VALUES (68204, '2020-07-24', 'QA', 'Qatar', 'EMRO', '373', '108244', '1', '164');
INSERT INTO public.who_global_data_import VALUES (68205, '2020-07-25', 'QA', 'Qatar', 'EMRO', '394', '108638', '0', '164');
INSERT INTO public.who_global_data_import VALUES (68206, '2020-07-26', 'QA', 'Qatar', 'EMRO', '398', '109036', '0', '164');
INSERT INTO public.who_global_data_import VALUES (68207, '2020-07-27', 'QA', 'Qatar', 'EMRO', '269', '109305', '1', '165');
INSERT INTO public.who_global_data_import VALUES (68208, '2020-07-28', 'QA', 'Qatar', 'EMRO', '292', '109597', '0', '165');
INSERT INTO public.who_global_data_import VALUES (68209, '2020-07-29', 'QA', 'Qatar', 'EMRO', '283', '109880', '2', '167');
INSERT INTO public.who_global_data_import VALUES (68210, '2020-07-30', 'QA', 'Qatar', 'EMRO', '273', '110153', '2', '169');
INSERT INTO public.who_global_data_import VALUES (68211, '2020-07-31', 'QA', 'Qatar', 'EMRO', '307', '110460', '2', '171');
INSERT INTO public.who_global_data_import VALUES (68212, '2020-08-01', 'QA', 'Qatar', 'EMRO', '235', '110695', '3', '174');
INSERT INTO public.who_global_data_import VALUES (68213, '2020-08-02', 'QA', 'Qatar', 'EMRO', '216', '110911', '0', '174');
INSERT INTO public.who_global_data_import VALUES (68214, '2020-08-03', 'QA', 'Qatar', 'EMRO', '196', '111107', '3', '177');
INSERT INTO public.who_global_data_import VALUES (68215, '2020-08-04', 'QA', 'Qatar', 'EMRO', '215', '111322', '0', '177');
INSERT INTO public.who_global_data_import VALUES (68216, '2020-08-05', 'QA', 'Qatar', 'EMRO', '216', '111538', '0', '177');
INSERT INTO public.who_global_data_import VALUES (68217, '2020-08-06', 'QA', 'Qatar', 'EMRO', '267', '111805', '1', '178');
INSERT INTO public.who_global_data_import VALUES (68218, '2020-08-07', 'QA', 'Qatar', 'EMRO', '287', '112092', '0', '178');
INSERT INTO public.who_global_data_import VALUES (68219, '2020-08-08', 'QA', 'Qatar', 'EMRO', '291', '112383', '2', '180');
INSERT INTO public.who_global_data_import VALUES (68220, '2020-08-09', 'QA', 'Qatar', 'EMRO', '267', '112650', '2', '182');
INSERT INTO public.who_global_data_import VALUES (68221, '2020-08-10', 'QA', 'Qatar', 'EMRO', '297', '112947', '2', '184');
INSERT INTO public.who_global_data_import VALUES (68222, '2020-08-11', 'QA', 'Qatar', 'EMRO', '315', '113262', '4', '188');
INSERT INTO public.who_global_data_import VALUES (68223, '2020-08-12', 'QA', 'Qatar', 'EMRO', '384', '113646', '0', '188');
INSERT INTO public.who_global_data_import VALUES (68224, '2020-08-13', 'QA', 'Qatar', 'EMRO', '292', '113938', '2', '190');
INSERT INTO public.who_global_data_import VALUES (68225, '2020-08-14', 'QA', 'Qatar', 'EMRO', '343', '114281', '0', '190');
INSERT INTO public.who_global_data_import VALUES (68226, '2020-08-15', 'QA', 'Qatar', 'EMRO', '251', '114532', '0', '190');
INSERT INTO public.who_global_data_import VALUES (68227, '2020-08-16', 'QA', 'Qatar', 'EMRO', '277', '114809', '2', '192');
INSERT INTO public.who_global_data_import VALUES (68228, '2020-08-17', 'QA', 'Qatar', 'EMRO', '271', '115080', '1', '193');
INSERT INTO public.who_global_data_import VALUES (68229, '2020-08-18', 'QA', 'Qatar', 'EMRO', '288', '115368', '0', '193');
INSERT INTO public.who_global_data_import VALUES (68230, '2020-08-19', 'QA', 'Qatar', 'EMRO', '293', '115661', '0', '193');
INSERT INTO public.who_global_data_import VALUES (68231, '2020-08-20', 'QA', 'Qatar', 'EMRO', '295', '115956', '0', '193');
INSERT INTO public.who_global_data_import VALUES (68232, '2020-08-21', 'QA', 'Qatar', 'EMRO', '268', '116224', '0', '193');
INSERT INTO public.who_global_data_import VALUES (68233, '2020-08-22', 'QA', 'Qatar', 'EMRO', '257', '116481', '0', '193');
INSERT INTO public.who_global_data_import VALUES (68234, '2020-08-23', 'QA', 'Qatar', 'EMRO', '284', '116765', '0', '193');
INSERT INTO public.who_global_data_import VALUES (68235, '2020-08-24', 'QA', 'Qatar', 'EMRO', '243', '117008', '0', '193');
INSERT INTO public.who_global_data_import VALUES (68236, '2020-08-25', 'QA', 'Qatar', 'EMRO', '258', '117266', '1', '194');
INSERT INTO public.who_global_data_import VALUES (68237, '2020-08-26', 'QA', 'Qatar', 'EMRO', '232', '117498', '0', '194');
INSERT INTO public.who_global_data_import VALUES (68238, '2020-08-27', 'QA', 'Qatar', 'EMRO', '244', '117742', '0', '194');
INSERT INTO public.who_global_data_import VALUES (68239, '2020-08-28', 'QA', 'Qatar', 'EMRO', '246', '117988', '1', '195');
INSERT INTO public.who_global_data_import VALUES (68240, '2020-08-29', 'QA', 'Qatar', 'EMRO', '208', '118196', '1', '196');
INSERT INTO public.who_global_data_import VALUES (68241, '2020-08-30', 'QA', 'Qatar', 'EMRO', '211', '118407', '0', '196');
INSERT INTO public.who_global_data_import VALUES (68242, '2020-08-31', 'QA', 'Qatar', 'EMRO', '168', '118575', '1', '197');
INSERT INTO public.who_global_data_import VALUES (68243, '2020-09-01', 'QA', 'Qatar', 'EMRO', '203', '118778', '0', '197');
INSERT INTO public.who_global_data_import VALUES (68244, '2020-09-02', 'QA', 'Qatar', 'EMRO', '216', '118994', '1', '198');
INSERT INTO public.who_global_data_import VALUES (68245, '2020-09-03', 'QA', 'Qatar', 'EMRO', '212', '119206', '1', '199');
INSERT INTO public.who_global_data_import VALUES (68246, '2020-09-04', 'QA', 'Qatar', 'EMRO', '214', '119420', '2', '201');
INSERT INTO public.who_global_data_import VALUES (68247, '2020-09-05', 'QA', 'Qatar', 'EMRO', '217', '119637', '0', '201');
INSERT INTO public.who_global_data_import VALUES (68248, '2020-09-06', 'QA', 'Qatar', 'EMRO', '227', '119864', '1', '202');
INSERT INTO public.who_global_data_import VALUES (68249, '2020-09-07', 'QA', 'Qatar', 'EMRO', '231', '120095', '1', '203');
INSERT INTO public.who_global_data_import VALUES (68250, '2020-09-08', 'QA', 'Qatar', 'EMRO', '253', '120348', '2', '205');
INSERT INTO public.who_global_data_import VALUES (68251, '2020-09-09', 'QA', 'Qatar', 'EMRO', '231', '120579', '0', '205');
INSERT INTO public.who_global_data_import VALUES (68252, '2020-09-10', 'QA', 'Qatar', 'EMRO', '267', '120846', '0', '205');
INSERT INTO public.who_global_data_import VALUES (68253, '2020-09-11', 'QA', 'Qatar', 'EMRO', '206', '121052', '0', '205');
INSERT INTO public.who_global_data_import VALUES (68254, '2020-09-12', 'QA', 'Qatar', 'EMRO', '235', '121287', '0', '205');
INSERT INTO public.who_global_data_import VALUES (68255, '2020-09-13', 'QA', 'Qatar', 'EMRO', '236', '121523', '0', '205');
INSERT INTO public.who_global_data_import VALUES (68256, '2020-09-14', 'QA', 'Qatar', 'EMRO', '217', '121740', '0', '205');
INSERT INTO public.who_global_data_import VALUES (68257, '2020-09-15', 'QA', 'Qatar', 'EMRO', '235', '121975', '2', '207');
INSERT INTO public.who_global_data_import VALUES (68258, '2020-09-16', 'QA', 'Qatar', 'EMRO', '239', '122214', '1', '208');
INSERT INTO public.who_global_data_import VALUES (68259, '2020-09-17', 'QA', 'Qatar', 'EMRO', '235', '122449', '0', '208');
INSERT INTO public.who_global_data_import VALUES (68260, '2020-09-18', 'QA', 'Qatar', 'EMRO', '244', '122693', '0', '208');
INSERT INTO public.who_global_data_import VALUES (68261, '2020-09-19', 'QA', 'Qatar', 'EMRO', '224', '122917', '1', '209');
INSERT INTO public.who_global_data_import VALUES (68262, '2020-09-20', 'QA', 'Qatar', 'EMRO', '229', '123146', '0', '209');
INSERT INTO public.who_global_data_import VALUES (68263, '2020-09-21', 'QA', 'Qatar', 'EMRO', '230', '123376', '1', '210');
INSERT INTO public.who_global_data_import VALUES (68264, '2020-09-22', 'QA', 'Qatar', 'EMRO', '228', '123604', '1', '211');
INSERT INTO public.who_global_data_import VALUES (68265, '2020-09-23', 'QA', 'Qatar', 'EMRO', '313', '123917', '0', '211');
INSERT INTO public.who_global_data_import VALUES (68266, '2020-09-24', 'QA', 'Qatar', 'EMRO', '258', '124175', '1', '212');
INSERT INTO public.who_global_data_import VALUES (68267, '2020-09-25', 'QA', 'Qatar', 'EMRO', '250', '124425', '0', '212');
INSERT INTO public.who_global_data_import VALUES (68268, '2020-09-26', 'QA', 'Qatar', 'EMRO', '225', '124650', '0', '212');
INSERT INTO public.who_global_data_import VALUES (68269, '2020-09-27', 'QA', 'Qatar', 'EMRO', '200', '124850', '2', '214');
INSERT INTO public.who_global_data_import VALUES (68270, '2020-09-28', 'QA', 'Qatar', 'EMRO', '234', '125084', '0', '214');
INSERT INTO public.who_global_data_import VALUES (68271, '2020-09-29', 'QA', 'Qatar', 'EMRO', '227', '125311', '0', '214');
INSERT INTO public.who_global_data_import VALUES (68272, '2020-09-30', 'QA', 'Qatar', 'EMRO', '222', '125533', '0', '214');
INSERT INTO public.who_global_data_import VALUES (68273, '2020-10-01', 'QA', 'Qatar', 'EMRO', '227', '125760', '0', '214');
INSERT INTO public.who_global_data_import VALUES (68274, '2020-10-02', 'QA', 'Qatar', 'EMRO', '199', '125959', '0', '214');
INSERT INTO public.who_global_data_import VALUES (68275, '2020-10-03', 'QA', 'Qatar', 'EMRO', '205', '126164', '1', '215');
INSERT INTO public.who_global_data_import VALUES (68276, '2020-10-04', 'QA', 'Qatar', 'EMRO', '175', '126339', '1', '216');
INSERT INTO public.who_global_data_import VALUES (68277, '2020-10-05', 'QA', 'Qatar', 'EMRO', '159', '126498', '0', '216');
INSERT INTO public.who_global_data_import VALUES (68278, '2020-10-06', 'QA', 'Qatar', 'EMRO', '194', '126692', '0', '216');
INSERT INTO public.who_global_data_import VALUES (68279, '2020-10-07', 'QA', 'Qatar', 'EMRO', '251', '126943', '0', '216');
INSERT INTO public.who_global_data_import VALUES (68280, '2020-10-08', 'QA', 'Qatar', 'EMRO', '238', '127181', '2', '218');
INSERT INTO public.who_global_data_import VALUES (68281, '2020-10-09', 'QA', 'Qatar', 'EMRO', '213', '127394', '0', '218');
INSERT INTO public.who_global_data_import VALUES (68282, '2020-10-10', 'QA', 'Qatar', 'EMRO', '206', '127600', '1', '219');
INSERT INTO public.who_global_data_import VALUES (68283, '2020-10-11', 'QA', 'Qatar', 'EMRO', '178', '127778', '0', '219');
INSERT INTO public.who_global_data_import VALUES (68284, '2020-10-12', 'QA', 'Qatar', 'EMRO', '207', '127985', '1', '220');
INSERT INTO public.who_global_data_import VALUES (68285, '2020-10-13', 'QA', 'Qatar', 'EMRO', '206', '128191', '0', '220');
INSERT INTO public.who_global_data_import VALUES (68286, '2020-10-14', 'QA', 'Qatar', 'EMRO', '214', '128405', '0', '220');
INSERT INTO public.who_global_data_import VALUES (68287, '2020-10-15', 'QA', 'Qatar', 'EMRO', '198', '128603', '0', '220');
INSERT INTO public.who_global_data_import VALUES (68288, '2020-10-16', 'QA', 'Qatar', 'EMRO', '200', '128803', '2', '222');
INSERT INTO public.who_global_data_import VALUES (68289, '2020-10-17', 'QA', 'Qatar', 'EMRO', '189', '128992', '0', '222');
INSERT INTO public.who_global_data_import VALUES (68290, '2020-10-18', 'QA', 'Qatar', 'EMRO', '235', '129227', '1', '223');
INSERT INTO public.who_global_data_import VALUES (68291, '2020-10-19', 'QA', 'Qatar', 'EMRO', '204', '129431', '1', '224');
INSERT INTO public.who_global_data_import VALUES (68292, '2020-10-20', 'QA', 'Qatar', 'EMRO', '240', '129671', '0', '224');
INSERT INTO public.who_global_data_import VALUES (68293, '2020-10-21', 'QA', 'Qatar', 'EMRO', '273', '129944', '0', '224');
INSERT INTO public.who_global_data_import VALUES (68294, '2020-10-22', 'QA', 'Qatar', 'EMRO', '266', '130210', '1', '225');
INSERT INTO public.who_global_data_import VALUES (68295, '2020-10-23', 'QA', 'Qatar', 'EMRO', '252', '130462', '3', '228');
INSERT INTO public.who_global_data_import VALUES (68296, '2020-10-24', 'QA', 'Qatar', 'EMRO', '249', '130711', '1', '229');
INSERT INTO public.who_global_data_import VALUES (68297, '2020-10-25', 'QA', 'Qatar', 'EMRO', '254', '130965', '0', '229');
INSERT INTO public.who_global_data_import VALUES (68298, '2020-10-26', 'QA', 'Qatar', 'EMRO', '205', '131170', '1', '230');
INSERT INTO public.who_global_data_import VALUES (68299, '2020-10-27', 'QA', 'Qatar', 'EMRO', '262', '131432', '0', '230');
INSERT INTO public.who_global_data_import VALUES (68300, '2020-10-28', 'QA', 'Qatar', 'EMRO', '257', '131689', '0', '230');
INSERT INTO public.who_global_data_import VALUES (68301, '2020-10-29', 'QA', 'Qatar', 'EMRO', '250', '131939', '0', '230');
INSERT INTO public.who_global_data_import VALUES (68302, '2020-10-30', 'QA', 'Qatar', 'EMRO', '211', '132150', '1', '231');
INSERT INTO public.who_global_data_import VALUES (68303, '2020-10-31', 'QA', 'Qatar', 'EMRO', '193', '132343', '1', '232');
INSERT INTO public.who_global_data_import VALUES (68304, '2020-11-01', 'QA', 'Qatar', 'EMRO', '213', '132556', '0', '232');
INSERT INTO public.who_global_data_import VALUES (68305, '2020-11-02', 'QA', 'Qatar', 'EMRO', '164', '132720', '0', '232');
INSERT INTO public.who_global_data_import VALUES (68306, '2020-11-03', 'QA', 'Qatar', 'EMRO', '197', '132917', '0', '232');
INSERT INTO public.who_global_data_import VALUES (68307, '2020-11-04', 'QA', 'Qatar', 'EMRO', '226', '133143', '0', '232');
INSERT INTO public.who_global_data_import VALUES (68308, '2020-11-05', 'QA', 'Qatar', 'EMRO', '227', '133370', '0', '232');
INSERT INTO public.who_global_data_import VALUES (68309, '2020-11-06', 'QA', 'Qatar', 'EMRO', '249', '133619', '0', '232');
INSERT INTO public.who_global_data_import VALUES (68310, '2020-11-07', 'QA', 'Qatar', 'EMRO', '192', '133811', '0', '232');
INSERT INTO public.who_global_data_import VALUES (68311, '2020-11-08', 'QA', 'Qatar', 'EMRO', '202', '134013', '0', '232');
INSERT INTO public.who_global_data_import VALUES (68312, '2020-11-09', 'QA', 'Qatar', 'EMRO', '190', '134203', '0', '232');
INSERT INTO public.who_global_data_import VALUES (68313, '2020-11-10', 'QA', 'Qatar', 'EMRO', '230', '134433', '0', '232');
INSERT INTO public.who_global_data_import VALUES (68314, '2020-11-11', 'QA', 'Qatar', 'EMRO', '230', '134663', '1', '233');
INSERT INTO public.who_global_data_import VALUES (68315, '2020-11-12', 'QA', 'Qatar', 'EMRO', '224', '134887', '0', '233');
INSERT INTO public.who_global_data_import VALUES (68316, '2020-11-13', 'QA', 'Qatar', 'EMRO', '245', '135132', '1', '234');
INSERT INTO public.who_global_data_import VALUES (68317, '2020-11-14', 'QA', 'Qatar', 'EMRO', '235', '135367', '0', '234');
INSERT INTO public.who_global_data_import VALUES (68318, '2020-11-15', 'QA', 'Qatar', 'EMRO', '203', '135570', '0', '234');
INSERT INTO public.who_global_data_import VALUES (68319, '2020-11-16', 'QA', 'Qatar', 'EMRO', '215', '135785', '0', '234');
INSERT INTO public.who_global_data_import VALUES (68320, '2020-11-17', 'QA', 'Qatar', 'EMRO', '243', '136028', '1', '235');
INSERT INTO public.who_global_data_import VALUES (68321, '2020-11-18', 'QA', 'Qatar', 'EMRO', '194', '136222', '0', '235');
INSERT INTO public.who_global_data_import VALUES (68322, '2020-11-19', 'QA', 'Qatar', 'EMRO', '219', '136441', '0', '235');
INSERT INTO public.who_global_data_import VALUES (68323, '2020-11-20', 'QA', 'Qatar', 'EMRO', '208', '136649', '0', '235');
INSERT INTO public.who_global_data_import VALUES (68324, '2020-11-21', 'QA', 'Qatar', 'EMRO', '239', '136888', '0', '235');
INSERT INTO public.who_global_data_import VALUES (68325, '2020-11-22', 'QA', 'Qatar', 'EMRO', '174', '137062', '0', '235');
INSERT INTO public.who_global_data_import VALUES (68326, '2020-11-23', 'QA', 'Qatar', 'EMRO', '167', '137229', '1', '236');
INSERT INTO public.who_global_data_import VALUES (68327, '2020-11-24', 'QA', 'Qatar', 'EMRO', '186', '137415', '0', '236');
INSERT INTO public.who_global_data_import VALUES (68328, '2020-11-25', 'QA', 'Qatar', 'EMRO', '227', '137642', '0', '236');
INSERT INTO public.who_global_data_import VALUES (68329, '2020-11-26', 'QA', 'Qatar', 'EMRO', '209', '137851', '1', '237');
INSERT INTO public.who_global_data_import VALUES (68330, '2020-11-27', 'QA', 'Qatar', 'EMRO', '215', '138066', '0', '237');
INSERT INTO public.who_global_data_import VALUES (68331, '2020-11-28', 'QA', 'Qatar', 'EMRO', '184', '138250', '0', '237');
INSERT INTO public.who_global_data_import VALUES (68332, '2020-11-29', 'QA', 'Qatar', 'EMRO', '227', '138477', '0', '237');
INSERT INTO public.who_global_data_import VALUES (68333, '2020-11-30', 'QA', 'Qatar', 'EMRO', '171', '138648', '0', '237');
INSERT INTO public.who_global_data_import VALUES (68334, '2020-12-01', 'QA', 'Qatar', 'EMRO', '185', '138833', '0', '237');
INSERT INTO public.who_global_data_import VALUES (68335, '2020-12-02', 'QA', 'Qatar', 'EMRO', '168', '139001', '1', '238');
INSERT INTO public.who_global_data_import VALUES (68336, '2020-12-03', 'QA', 'Qatar', 'EMRO', '255', '139256', '1', '239');
INSERT INTO public.who_global_data_import VALUES (68337, '2020-12-04', 'QA', 'Qatar', 'EMRO', '221', '139477', '0', '239');
INSERT INTO public.who_global_data_import VALUES (68338, '2020-12-05', 'QA', 'Qatar', 'EMRO', '166', '139643', '0', '239');
INSERT INTO public.who_global_data_import VALUES (68339, '2020-12-06', 'QA', 'Qatar', 'EMRO', '140', '139783', '0', '239');
INSERT INTO public.who_global_data_import VALUES (68340, '2020-12-07', 'QA', 'Qatar', 'EMRO', '125', '139908', '0', '239');
INSERT INTO public.who_global_data_import VALUES (68341, '2020-12-08', 'QA', 'Qatar', 'EMRO', '178', '140086', '0', '239');
INSERT INTO public.who_global_data_import VALUES (68342, '2020-12-09', 'QA', 'Qatar', 'EMRO', '117', '140203', '0', '239');
INSERT INTO public.who_global_data_import VALUES (68343, '2020-12-10', 'QA', 'Qatar', 'EMRO', '150', '140353', '1', '240');
INSERT INTO public.who_global_data_import VALUES (68344, '2020-12-11', 'QA', 'Qatar', 'EMRO', '163', '140516', '0', '240');
INSERT INTO public.who_global_data_import VALUES (68345, '2020-12-12', 'QA', 'Qatar', 'EMRO', '164', '140680', '0', '240');
INSERT INTO public.who_global_data_import VALUES (68346, '2020-12-13', 'QA', 'Qatar', 'EMRO', '147', '140827', '0', '240');
INSERT INTO public.who_global_data_import VALUES (68347, '2020-12-14', 'QA', 'Qatar', 'EMRO', '134', '140961', '0', '240');
INSERT INTO public.who_global_data_import VALUES (68348, '2020-12-15', 'QA', 'Qatar', 'EMRO', '160', '141121', '1', '241');
INSERT INTO public.who_global_data_import VALUES (68349, '2020-12-16', 'QA', 'Qatar', 'EMRO', '151', '141272', '0', '241');
INSERT INTO public.who_global_data_import VALUES (68350, '2020-12-17', 'QA', 'Qatar', 'EMRO', '145', '141417', '1', '242');
INSERT INTO public.who_global_data_import VALUES (68351, '2020-12-18', 'QA', 'Qatar', 'EMRO', '140', '141557', '0', '242');
INSERT INTO public.who_global_data_import VALUES (68352, '2020-12-19', 'QA', 'Qatar', 'EMRO', '159', '141716', '0', '242');
INSERT INTO public.who_global_data_import VALUES (68353, '2020-12-20', 'QA', 'Qatar', 'EMRO', '142', '141858', '1', '243');
INSERT INTO public.who_global_data_import VALUES (68354, '2020-12-21', 'QA', 'Qatar', 'EMRO', '143', '142001', '0', '243');
INSERT INTO public.who_global_data_import VALUES (68355, '2020-12-22', 'QA', 'Qatar', 'EMRO', '158', '142159', '0', '243');
INSERT INTO public.who_global_data_import VALUES (68356, '2020-12-23', 'QA', 'Qatar', 'EMRO', '149', '142308', '0', '243');
INSERT INTO public.who_global_data_import VALUES (68357, '2020-12-24', 'QA', 'Qatar', 'EMRO', '140', '142448', '0', '243');
INSERT INTO public.who_global_data_import VALUES (68358, '2020-12-25', 'QA', 'Qatar', 'EMRO', '157', '142605', '0', '243');
INSERT INTO public.who_global_data_import VALUES (68359, '2020-12-26', 'QA', 'Qatar', 'EMRO', '129', '142734', '1', '244');
INSERT INTO public.who_global_data_import VALUES (68360, '2020-12-27', 'QA', 'Qatar', 'EMRO', '169', '142903', '0', '244');
INSERT INTO public.who_global_data_import VALUES (68361, '2020-12-28', 'QA', 'Qatar', 'EMRO', '159', '143062', '0', '244');
INSERT INTO public.who_global_data_import VALUES (68362, '2020-12-29', 'QA', 'Qatar', 'EMRO', '160', '143222', '0', '244');
INSERT INTO public.who_global_data_import VALUES (68363, '2020-12-30', 'QA', 'Qatar', 'EMRO', '206', '143428', '1', '245');
INSERT INTO public.who_global_data_import VALUES (68364, '2020-12-31', 'QA', 'Qatar', 'EMRO', '193', '143621', '0', '245');
INSERT INTO public.who_global_data_import VALUES (68365, '2021-01-01', 'QA', 'Qatar', 'EMRO', '213', '143834', '0', '245');
INSERT INTO public.who_global_data_import VALUES (68366, '2021-01-02', 'QA', 'Qatar', 'EMRO', '208', '144042', '0', '245');
INSERT INTO public.who_global_data_import VALUES (68367, '2021-01-03', 'QA', 'Qatar', 'EMRO', '198', '144240', '0', '245');
INSERT INTO public.who_global_data_import VALUES (68368, '2021-01-04', 'QA', 'Qatar', 'EMRO', '197', '144437', '0', '245');
INSERT INTO public.who_global_data_import VALUES (68369, '2021-01-05', 'QA', 'Qatar', 'EMRO', '207', '144644', '0', '245');
INSERT INTO public.who_global_data_import VALUES (68370, '2021-01-06', 'QA', 'Qatar', 'EMRO', '208', '144852', '0', '245');
INSERT INTO public.who_global_data_import VALUES (68371, '2021-01-07', 'QA', 'Qatar', 'EMRO', '209', '145061', '0', '245');
INSERT INTO public.who_global_data_import VALUES (68372, '2021-01-08', 'QA', 'Qatar', 'EMRO', '210', '145271', '0', '245');
INSERT INTO public.who_global_data_import VALUES (68373, '2021-01-09', 'QA', 'Qatar', 'EMRO', '195', '145466', '1', '246');
INSERT INTO public.who_global_data_import VALUES (68374, '2021-01-10', 'QA', 'Qatar', 'EMRO', '206', '145672', '0', '246');
INSERT INTO public.who_global_data_import VALUES (68375, '2021-01-11', 'QA', 'Qatar', 'EMRO', '193', '145865', '0', '246');
INSERT INTO public.who_global_data_import VALUES (68376, '2021-01-12', 'QA', 'Qatar', 'EMRO', '203', '146068', '0', '246');
INSERT INTO public.who_global_data_import VALUES (68377, '2021-01-13', 'QA', 'Qatar', 'EMRO', '211', '146279', '0', '246');
INSERT INTO public.who_global_data_import VALUES (68378, '2021-01-14', 'QA', 'Qatar', 'EMRO', '201', '146480', '0', '246');
INSERT INTO public.who_global_data_import VALUES (68379, '2021-01-15', 'QA', 'Qatar', 'EMRO', '209', '146689', '0', '246');
INSERT INTO public.who_global_data_import VALUES (68380, '2021-01-16', 'QA', 'Qatar', 'EMRO', '196', '146885', '0', '246');
INSERT INTO public.who_global_data_import VALUES (68381, '2021-01-17', 'QA', 'Qatar', 'EMRO', '204', '147089', '0', '246');
INSERT INTO public.who_global_data_import VALUES (68382, '2021-01-18', 'QA', 'Qatar', 'EMRO', '188', '147277', '0', '246');
INSERT INTO public.who_global_data_import VALUES (68383, '2021-01-19', 'QA', 'Qatar', 'EMRO', '227', '147504', '2', '248');
INSERT INTO public.who_global_data_import VALUES (68384, '2021-01-20', 'QA', 'Qatar', 'EMRO', '225', '147729', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68385, '2021-01-21', 'QA', 'Qatar', 'EMRO', '271', '148000', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68386, '2021-01-22', 'QA', 'Qatar', 'EMRO', '258', '148258', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68387, '2021-01-23', 'QA', 'Qatar', 'EMRO', '263', '148521', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68388, '2021-01-24', 'QA', 'Qatar', 'EMRO', '251', '148772', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68389, '2021-01-25', 'QA', 'Qatar', 'EMRO', '247', '149019', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68390, '2021-01-26', 'QA', 'Qatar', 'EMRO', '277', '149296', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68391, '2021-01-27', 'QA', 'Qatar', 'EMRO', '299', '149595', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68392, '2021-01-28', 'QA', 'Qatar', 'EMRO', '338', '149933', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68393, '2021-01-29', 'QA', 'Qatar', 'EMRO', '347', '150280', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68394, '2021-01-30', 'QA', 'Qatar', 'EMRO', '341', '150621', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68395, '2021-01-31', 'QA', 'Qatar', 'EMRO', '363', '150984', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68396, '2021-02-01', 'QA', 'Qatar', 'EMRO', '351', '151335', '0', '248');
INSERT INTO public.who_global_data_import VALUES (68397, '2021-02-02', 'QA', 'Qatar', 'EMRO', '385', '151720', '1', '249');
INSERT INTO public.who_global_data_import VALUES (68398, '2021-02-03', 'QA', 'Qatar', 'EMRO', '375', '152095', '0', '249');
INSERT INTO public.who_global_data_import VALUES (68399, '2021-02-04', 'QA', 'Qatar', 'EMRO', '396', '152491', '0', '249');
INSERT INTO public.who_global_data_import VALUES (68400, '2021-02-05', 'QA', 'Qatar', 'EMRO', '407', '152898', '0', '249');
INSERT INTO public.who_global_data_import VALUES (68401, '2020-01-03', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68402, '2020-01-04', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68403, '2020-01-05', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68404, '2020-01-06', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68405, '2020-01-07', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68406, '2020-01-08', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68407, '2020-01-09', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68408, '2020-01-10', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68409, '2020-01-11', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68410, '2020-01-12', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68411, '2020-01-13', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68412, '2020-01-14', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68413, '2020-01-15', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68414, '2020-01-16', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68415, '2020-01-17', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68416, '2020-01-18', 'KR', 'Republic of Korea', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68417, '2020-01-19', 'KR', 'Republic of Korea', 'WPRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68418, '2020-01-20', 'KR', 'Republic of Korea', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68419, '2020-01-21', 'KR', 'Republic of Korea', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68420, '2020-01-22', 'KR', 'Republic of Korea', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68421, '2020-01-23', 'KR', 'Republic of Korea', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68422, '2020-01-24', 'KR', 'Republic of Korea', 'WPRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68423, '2020-01-25', 'KR', 'Republic of Korea', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68424, '2020-01-26', 'KR', 'Republic of Korea', 'WPRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68425, '2020-01-27', 'KR', 'Republic of Korea', 'WPRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68426, '2020-01-28', 'KR', 'Republic of Korea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68427, '2020-01-29', 'KR', 'Republic of Korea', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68428, '2020-01-30', 'KR', 'Republic of Korea', 'WPRO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68429, '2020-01-31', 'KR', 'Republic of Korea', 'WPRO', '5', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68430, '2020-02-01', 'KR', 'Republic of Korea', 'WPRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68431, '2020-02-02', 'KR', 'Republic of Korea', 'WPRO', '3', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68432, '2020-02-03', 'KR', 'Republic of Korea', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68433, '2020-02-04', 'KR', 'Republic of Korea', 'WPRO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68434, '2020-02-05', 'KR', 'Republic of Korea', 'WPRO', '2', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68435, '2020-02-06', 'KR', 'Republic of Korea', 'WPRO', '5', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68436, '2020-02-07', 'KR', 'Republic of Korea', 'WPRO', '1', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68437, '2020-02-08', 'KR', 'Republic of Korea', 'WPRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68438, '2020-02-09', 'KR', 'Republic of Korea', 'WPRO', '3', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68439, '2020-02-10', 'KR', 'Republic of Korea', 'WPRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68440, '2020-02-11', 'KR', 'Republic of Korea', 'WPRO', '1', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68441, '2020-02-12', 'KR', 'Republic of Korea', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68442, '2020-02-13', 'KR', 'Republic of Korea', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68443, '2020-02-14', 'KR', 'Republic of Korea', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68444, '2020-02-15', 'KR', 'Republic of Korea', 'WPRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68445, '2020-02-16', 'KR', 'Republic of Korea', 'WPRO', '1', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68446, '2020-02-17', 'KR', 'Republic of Korea', 'WPRO', '1', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68447, '2020-02-18', 'KR', 'Republic of Korea', 'WPRO', '1', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68448, '2020-02-19', 'KR', 'Republic of Korea', 'WPRO', '20', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68449, '2020-02-20', 'KR', 'Republic of Korea', 'WPRO', '53', '108', '1', '1');
INSERT INTO public.who_global_data_import VALUES (68450, '2020-02-21', 'KR', 'Republic of Korea', 'WPRO', '100', '208', '0', '1');
INSERT INTO public.who_global_data_import VALUES (68451, '2020-02-22', 'KR', 'Republic of Korea', 'WPRO', '229', '437', '1', '2');
INSERT INTO public.who_global_data_import VALUES (68452, '2020-02-23', 'KR', 'Republic of Korea', 'WPRO', '169', '606', '0', '2');
INSERT INTO public.who_global_data_import VALUES (68453, '2020-02-24', 'KR', 'Republic of Korea', 'WPRO', '231', '837', '5', '7');
INSERT INTO public.who_global_data_import VALUES (68454, '2020-02-25', 'KR', 'Republic of Korea', 'WPRO', '144', '981', '3', '10');
INSERT INTO public.who_global_data_import VALUES (68455, '2020-02-26', 'KR', 'Republic of Korea', 'WPRO', '284', '1265', '2', '12');
INSERT INTO public.who_global_data_import VALUES (68456, '2020-02-27', 'KR', 'Republic of Korea', 'WPRO', '505', '1770', '1', '13');
INSERT INTO public.who_global_data_import VALUES (68457, '2020-02-28', 'KR', 'Republic of Korea', 'WPRO', '571', '2341', '0', '13');
INSERT INTO public.who_global_data_import VALUES (68458, '2020-02-29', 'KR', 'Republic of Korea', 'WPRO', '813', '3154', '4', '17');
INSERT INTO public.who_global_data_import VALUES (68459, '2020-03-01', 'KR', 'Republic of Korea', 'WPRO', '586', '3740', '1', '18');
INSERT INTO public.who_global_data_import VALUES (68460, '2020-03-02', 'KR', 'Republic of Korea', 'WPRO', '476', '4216', '4', '22');
INSERT INTO public.who_global_data_import VALUES (68461, '2020-03-03', 'KR', 'Republic of Korea', 'WPRO', '600', '4816', '6', '28');
INSERT INTO public.who_global_data_import VALUES (68462, '2020-03-04', 'KR', 'Republic of Korea', 'WPRO', '516', '5332', '4', '32');
INSERT INTO public.who_global_data_import VALUES (68463, '2020-03-05', 'KR', 'Republic of Korea', 'WPRO', '438', '5770', '3', '35');
INSERT INTO public.who_global_data_import VALUES (68464, '2020-03-06', 'KR', 'Republic of Korea', 'WPRO', '518', '6288', '7', '42');
INSERT INTO public.who_global_data_import VALUES (68465, '2020-03-07', 'KR', 'Republic of Korea', 'WPRO', '483', '6771', '2', '44');
INSERT INTO public.who_global_data_import VALUES (68466, '2020-03-08', 'KR', 'Republic of Korea', 'WPRO', '367', '7138', '6', '50');
INSERT INTO public.who_global_data_import VALUES (68467, '2020-03-09', 'KR', 'Republic of Korea', 'WPRO', '248', '7386', '1', '51');
INSERT INTO public.who_global_data_import VALUES (68468, '2020-03-10', 'KR', 'Republic of Korea', 'WPRO', '131', '7517', '3', '54');
INSERT INTO public.who_global_data_import VALUES (68469, '2020-03-11', 'KR', 'Republic of Korea', 'WPRO', '242', '7759', '6', '60');
INSERT INTO public.who_global_data_import VALUES (68470, '2020-03-12', 'KR', 'Republic of Korea', 'WPRO', '224', '7983', '6', '66');
INSERT INTO public.who_global_data_import VALUES (68471, '2020-03-13', 'KR', 'Republic of Korea', 'WPRO', '0', '7983', '1', '67');
INSERT INTO public.who_global_data_import VALUES (68472, '2020-03-14', 'KR', 'Republic of Korea', 'WPRO', '107', '8090', '5', '72');
INSERT INTO public.who_global_data_import VALUES (68473, '2020-03-15', 'KR', 'Republic of Korea', 'WPRO', '76', '8166', '3', '75');
INSERT INTO public.who_global_data_import VALUES (68474, '2020-03-16', 'KR', 'Republic of Korea', 'WPRO', '74', '8240', '0', '75');
INSERT INTO public.who_global_data_import VALUES (68475, '2020-03-17', 'KR', 'Republic of Korea', 'WPRO', '84', '8324', '6', '81');
INSERT INTO public.who_global_data_import VALUES (68476, '2020-03-18', 'KR', 'Republic of Korea', 'WPRO', '93', '8417', '3', '84');
INSERT INTO public.who_global_data_import VALUES (68477, '2020-03-19', 'KR', 'Republic of Korea', 'WPRO', '235', '8652', '10', '94');
INSERT INTO public.who_global_data_import VALUES (68478, '2020-03-20', 'KR', 'Republic of Korea', 'WPRO', '147', '8799', '8', '102');
INSERT INTO public.who_global_data_import VALUES (68479, '2020-03-21', 'KR', 'Republic of Korea', 'WPRO', '98', '8897', '2', '104');
INSERT INTO public.who_global_data_import VALUES (68480, '2020-03-22', 'KR', 'Republic of Korea', 'WPRO', '0', '8897', '0', '104');
INSERT INTO public.who_global_data_import VALUES (68481, '2020-03-23', 'KR', 'Republic of Korea', 'WPRO', '64', '8961', '7', '111');
INSERT INTO public.who_global_data_import VALUES (68482, '2020-03-24', 'KR', 'Republic of Korea', 'WPRO', '76', '9037', '9', '120');
INSERT INTO public.who_global_data_import VALUES (68483, '2020-03-25', 'KR', 'Republic of Korea', 'WPRO', '100', '9137', '6', '126');
INSERT INTO public.who_global_data_import VALUES (68484, '2020-03-26', 'KR', 'Republic of Korea', 'WPRO', '104', '9241', '5', '131');
INSERT INTO public.who_global_data_import VALUES (68485, '2020-03-27', 'KR', 'Republic of Korea', 'WPRO', '91', '9332', '8', '139');
INSERT INTO public.who_global_data_import VALUES (68486, '2020-03-28', 'KR', 'Republic of Korea', 'WPRO', '146', '9478', '5', '144');
INSERT INTO public.who_global_data_import VALUES (68487, '2020-03-29', 'KR', 'Republic of Korea', 'WPRO', '105', '9583', '8', '152');
INSERT INTO public.who_global_data_import VALUES (68488, '2020-03-30', 'KR', 'Republic of Korea', 'WPRO', '78', '9661', '6', '158');
INSERT INTO public.who_global_data_import VALUES (68489, '2020-03-31', 'KR', 'Republic of Korea', 'WPRO', '125', '9786', '4', '162');
INSERT INTO public.who_global_data_import VALUES (68490, '2020-04-01', 'KR', 'Republic of Korea', 'WPRO', '101', '9887', '3', '165');
INSERT INTO public.who_global_data_import VALUES (68491, '2020-04-02', 'KR', 'Republic of Korea', 'WPRO', '89', '9976', '4', '169');
INSERT INTO public.who_global_data_import VALUES (68492, '2020-04-03', 'KR', 'Republic of Korea', 'WPRO', '86', '10062', '5', '174');
INSERT INTO public.who_global_data_import VALUES (68493, '2020-04-04', 'KR', 'Republic of Korea', 'WPRO', '94', '10156', '3', '177');
INSERT INTO public.who_global_data_import VALUES (68494, '2020-04-05', 'KR', 'Republic of Korea', 'WPRO', '81', '10237', '6', '183');
INSERT INTO public.who_global_data_import VALUES (68495, '2020-04-06', 'KR', 'Republic of Korea', 'WPRO', '47', '10284', '3', '186');
INSERT INTO public.who_global_data_import VALUES (68496, '2020-04-07', 'KR', 'Republic of Korea', 'WPRO', '47', '10331', '6', '192');
INSERT INTO public.who_global_data_import VALUES (68497, '2020-04-08', 'KR', 'Republic of Korea', 'WPRO', '53', '10384', '8', '200');
INSERT INTO public.who_global_data_import VALUES (68498, '2020-04-09', 'KR', 'Republic of Korea', 'WPRO', '39', '10423', '4', '204');
INSERT INTO public.who_global_data_import VALUES (68499, '2020-04-10', 'KR', 'Republic of Korea', 'WPRO', '27', '10450', '4', '208');
INSERT INTO public.who_global_data_import VALUES (68500, '2020-04-11', 'KR', 'Republic of Korea', 'WPRO', '30', '10480', '3', '211');
INSERT INTO public.who_global_data_import VALUES (68501, '2020-04-12', 'KR', 'Republic of Korea', 'WPRO', '32', '10512', '3', '214');
INSERT INTO public.who_global_data_import VALUES (68502, '2020-04-13', 'KR', 'Republic of Korea', 'WPRO', '25', '10537', '3', '217');
INSERT INTO public.who_global_data_import VALUES (68503, '2020-04-14', 'KR', 'Republic of Korea', 'WPRO', '27', '10564', '5', '222');
INSERT INTO public.who_global_data_import VALUES (68504, '2020-04-15', 'KR', 'Republic of Korea', 'WPRO', '27', '10591', '3', '225');
INSERT INTO public.who_global_data_import VALUES (68505, '2020-04-16', 'KR', 'Republic of Korea', 'WPRO', '22', '10613', '4', '229');
INSERT INTO public.who_global_data_import VALUES (68506, '2020-04-17', 'KR', 'Republic of Korea', 'WPRO', '22', '10635', '1', '230');
INSERT INTO public.who_global_data_import VALUES (68507, '2020-04-18', 'KR', 'Republic of Korea', 'WPRO', '18', '10653', '2', '232');
INSERT INTO public.who_global_data_import VALUES (68508, '2020-04-19', 'KR', 'Republic of Korea', 'WPRO', '8', '10661', '2', '234');
INSERT INTO public.who_global_data_import VALUES (68509, '2020-04-20', 'KR', 'Republic of Korea', 'WPRO', '13', '10674', '2', '236');
INSERT INTO public.who_global_data_import VALUES (68510, '2020-04-21', 'KR', 'Republic of Korea', 'WPRO', '9', '10683', '1', '237');
INSERT INTO public.who_global_data_import VALUES (68511, '2020-04-22', 'KR', 'Republic of Korea', 'WPRO', '11', '10694', '1', '238');
INSERT INTO public.who_global_data_import VALUES (68512, '2020-04-23', 'KR', 'Republic of Korea', 'WPRO', '8', '10702', '2', '240');
INSERT INTO public.who_global_data_import VALUES (68513, '2020-04-24', 'KR', 'Republic of Korea', 'WPRO', '6', '10708', '0', '240');
INSERT INTO public.who_global_data_import VALUES (68514, '2020-04-25', 'KR', 'Republic of Korea', 'WPRO', '10', '10718', '0', '240');
INSERT INTO public.who_global_data_import VALUES (68515, '2020-04-26', 'KR', 'Republic of Korea', 'WPRO', '10', '10728', '2', '242');
INSERT INTO public.who_global_data_import VALUES (68516, '2020-04-27', 'KR', 'Republic of Korea', 'WPRO', '10', '10738', '1', '243');
INSERT INTO public.who_global_data_import VALUES (68517, '2020-04-28', 'KR', 'Republic of Korea', 'WPRO', '14', '10752', '1', '244');
INSERT INTO public.who_global_data_import VALUES (68518, '2020-04-29', 'KR', 'Republic of Korea', 'WPRO', '9', '10761', '2', '246');
INSERT INTO public.who_global_data_import VALUES (68519, '2020-04-30', 'KR', 'Republic of Korea', 'WPRO', '4', '10765', '1', '247');
INSERT INTO public.who_global_data_import VALUES (68520, '2020-05-01', 'KR', 'Republic of Korea', 'WPRO', '9', '10774', '1', '248');
INSERT INTO public.who_global_data_import VALUES (68521, '2020-05-02', 'KR', 'Republic of Korea', 'WPRO', '6', '10780', '2', '250');
INSERT INTO public.who_global_data_import VALUES (68522, '2020-05-03', 'KR', 'Republic of Korea', 'WPRO', '13', '10793', '0', '250');
INSERT INTO public.who_global_data_import VALUES (68523, '2020-05-04', 'KR', 'Republic of Korea', 'WPRO', '8', '10801', '2', '252');
INSERT INTO public.who_global_data_import VALUES (68524, '2020-05-05', 'KR', 'Republic of Korea', 'WPRO', '3', '10804', '2', '254');
INSERT INTO public.who_global_data_import VALUES (68525, '2020-05-06', 'KR', 'Republic of Korea', 'WPRO', '2', '10806', '1', '255');
INSERT INTO public.who_global_data_import VALUES (68526, '2020-05-07', 'KR', 'Republic of Korea', 'WPRO', '4', '10810', '1', '256');
INSERT INTO public.who_global_data_import VALUES (68527, '2020-05-08', 'KR', 'Republic of Korea', 'WPRO', '12', '10822', '0', '256');
INSERT INTO public.who_global_data_import VALUES (68528, '2020-05-09', 'KR', 'Republic of Korea', 'WPRO', '18', '10840', '0', '256');
INSERT INTO public.who_global_data_import VALUES (68529, '2020-05-10', 'KR', 'Republic of Korea', 'WPRO', '34', '10874', '0', '256');
INSERT INTO public.who_global_data_import VALUES (68530, '2020-05-11', 'KR', 'Republic of Korea', 'WPRO', '35', '10909', '0', '256');
INSERT INTO public.who_global_data_import VALUES (68531, '2020-05-12', 'KR', 'Republic of Korea', 'WPRO', '27', '10936', '2', '258');
INSERT INTO public.who_global_data_import VALUES (68532, '2020-05-13', 'KR', 'Republic of Korea', 'WPRO', '26', '10962', '1', '259');
INSERT INTO public.who_global_data_import VALUES (68533, '2020-05-14', 'KR', 'Republic of Korea', 'WPRO', '29', '10991', '1', '260');
INSERT INTO public.who_global_data_import VALUES (68534, '2020-05-15', 'KR', 'Republic of Korea', 'WPRO', '27', '11018', '0', '260');
INSERT INTO public.who_global_data_import VALUES (68535, '2020-05-16', 'KR', 'Republic of Korea', 'WPRO', '19', '11037', '2', '262');
INSERT INTO public.who_global_data_import VALUES (68536, '2020-05-17', 'KR', 'Republic of Korea', 'WPRO', '13', '11050', '0', '262');
INSERT INTO public.who_global_data_import VALUES (68537, '2020-05-18', 'KR', 'Republic of Korea', 'WPRO', '15', '11065', '1', '263');
INSERT INTO public.who_global_data_import VALUES (68538, '2020-05-19', 'KR', 'Republic of Korea', 'WPRO', '13', '11078', '0', '263');
INSERT INTO public.who_global_data_import VALUES (68539, '2020-05-20', 'KR', 'Republic of Korea', 'WPRO', '32', '11110', '0', '263');
INSERT INTO public.who_global_data_import VALUES (68540, '2020-05-21', 'KR', 'Republic of Korea', 'WPRO', '12', '11122', '1', '264');
INSERT INTO public.who_global_data_import VALUES (68541, '2020-05-22', 'KR', 'Republic of Korea', 'WPRO', '20', '11142', '0', '264');
INSERT INTO public.who_global_data_import VALUES (68542, '2020-05-23', 'KR', 'Republic of Korea', 'WPRO', '23', '11165', '2', '266');
INSERT INTO public.who_global_data_import VALUES (68543, '2020-05-24', 'KR', 'Republic of Korea', 'WPRO', '25', '11190', '0', '266');
INSERT INTO public.who_global_data_import VALUES (68544, '2020-05-25', 'KR', 'Republic of Korea', 'WPRO', '16', '11206', '1', '267');
INSERT INTO public.who_global_data_import VALUES (68545, '2020-05-26', 'KR', 'Republic of Korea', 'WPRO', '19', '11225', '2', '269');
INSERT INTO public.who_global_data_import VALUES (68546, '2020-05-27', 'KR', 'Republic of Korea', 'WPRO', '40', '11265', '0', '269');
INSERT INTO public.who_global_data_import VALUES (68547, '2020-05-28', 'KR', 'Republic of Korea', 'WPRO', '79', '11344', '0', '269');
INSERT INTO public.who_global_data_import VALUES (68548, '2020-05-29', 'KR', 'Republic of Korea', 'WPRO', '58', '11402', '0', '269');
INSERT INTO public.who_global_data_import VALUES (68549, '2020-05-30', 'KR', 'Republic of Korea', 'WPRO', '39', '11441', '0', '269');
INSERT INTO public.who_global_data_import VALUES (68550, '2020-05-31', 'KR', 'Republic of Korea', 'WPRO', '27', '11468', '1', '270');
INSERT INTO public.who_global_data_import VALUES (68551, '2020-06-01', 'KR', 'Republic of Korea', 'WPRO', '35', '11503', '1', '271');
INSERT INTO public.who_global_data_import VALUES (68552, '2020-06-02', 'KR', 'Republic of Korea', 'WPRO', '38', '11541', '1', '272');
INSERT INTO public.who_global_data_import VALUES (68553, '2020-06-03', 'KR', 'Republic of Korea', 'WPRO', '49', '11590', '1', '273');
INSERT INTO public.who_global_data_import VALUES (68554, '2020-06-04', 'KR', 'Republic of Korea', 'WPRO', '39', '11629', '0', '273');
INSERT INTO public.who_global_data_import VALUES (68555, '2020-06-05', 'KR', 'Republic of Korea', 'WPRO', '39', '11668', '0', '273');
INSERT INTO public.who_global_data_import VALUES (68556, '2020-06-06', 'KR', 'Republic of Korea', 'WPRO', '51', '11719', '0', '273');
INSERT INTO public.who_global_data_import VALUES (68557, '2020-06-07', 'KR', 'Republic of Korea', 'WPRO', '57', '11776', '0', '273');
INSERT INTO public.who_global_data_import VALUES (68558, '2020-06-08', 'KR', 'Republic of Korea', 'WPRO', '37', '11813', '0', '273');
INSERT INTO public.who_global_data_import VALUES (68559, '2020-06-09', 'KR', 'Republic of Korea', 'WPRO', '38', '11851', '1', '274');
INSERT INTO public.who_global_data_import VALUES (68560, '2020-06-10', 'KR', 'Republic of Korea', 'WPRO', '50', '11901', '2', '276');
INSERT INTO public.who_global_data_import VALUES (68561, '2020-06-11', 'KR', 'Republic of Korea', 'WPRO', '45', '11946', '0', '276');
INSERT INTO public.who_global_data_import VALUES (68562, '2020-06-12', 'KR', 'Republic of Korea', 'WPRO', '56', '12002', '1', '277');
INSERT INTO public.who_global_data_import VALUES (68563, '2020-06-13', 'KR', 'Republic of Korea', 'WPRO', '48', '12050', '0', '277');
INSERT INTO public.who_global_data_import VALUES (68564, '2020-06-14', 'KR', 'Republic of Korea', 'WPRO', '34', '12084', '0', '277');
INSERT INTO public.who_global_data_import VALUES (68565, '2020-06-15', 'KR', 'Republic of Korea', 'WPRO', '37', '12121', '0', '277');
INSERT INTO public.who_global_data_import VALUES (68566, '2020-06-16', 'KR', 'Republic of Korea', 'WPRO', '34', '12155', '1', '278');
INSERT INTO public.who_global_data_import VALUES (68567, '2020-06-17', 'KR', 'Republic of Korea', 'WPRO', '43', '12198', '1', '279');
INSERT INTO public.who_global_data_import VALUES (68568, '2020-06-18', 'KR', 'Republic of Korea', 'WPRO', '59', '12257', '1', '280');
INSERT INTO public.who_global_data_import VALUES (68569, '2020-06-19', 'KR', 'Republic of Korea', 'WPRO', '49', '12306', '0', '280');
INSERT INTO public.who_global_data_import VALUES (68570, '2020-06-20', 'KR', 'Republic of Korea', 'WPRO', '67', '12373', '0', '280');
INSERT INTO public.who_global_data_import VALUES (68571, '2020-06-21', 'KR', 'Republic of Korea', 'WPRO', '48', '12421', '0', '280');
INSERT INTO public.who_global_data_import VALUES (68572, '2020-06-22', 'KR', 'Republic of Korea', 'WPRO', '17', '12438', '0', '280');
INSERT INTO public.who_global_data_import VALUES (68573, '2020-06-23', 'KR', 'Republic of Korea', 'WPRO', '46', '12484', '1', '281');
INSERT INTO public.who_global_data_import VALUES (68574, '2020-06-24', 'KR', 'Republic of Korea', 'WPRO', '51', '12535', '0', '281');
INSERT INTO public.who_global_data_import VALUES (68575, '2020-06-25', 'KR', 'Republic of Korea', 'WPRO', '28', '12563', '1', '282');
INSERT INTO public.who_global_data_import VALUES (68576, '2020-06-26', 'KR', 'Republic of Korea', 'WPRO', '39', '12602', '0', '282');
INSERT INTO public.who_global_data_import VALUES (68577, '2020-06-27', 'KR', 'Republic of Korea', 'WPRO', '51', '12653', '0', '282');
INSERT INTO public.who_global_data_import VALUES (68578, '2020-06-28', 'KR', 'Republic of Korea', 'WPRO', '62', '12715', '0', '282');
INSERT INTO public.who_global_data_import VALUES (68579, '2020-06-29', 'KR', 'Republic of Korea', 'WPRO', '42', '12757', '0', '282');
INSERT INTO public.who_global_data_import VALUES (68580, '2020-06-30', 'KR', 'Republic of Korea', 'WPRO', '42', '12799', '0', '282');
INSERT INTO public.who_global_data_import VALUES (68581, '2020-07-01', 'KR', 'Republic of Korea', 'WPRO', '51', '12850', '0', '282');
INSERT INTO public.who_global_data_import VALUES (68582, '2020-07-02', 'KR', 'Republic of Korea', 'WPRO', '54', '12904', '0', '282');
INSERT INTO public.who_global_data_import VALUES (68583, '2020-07-03', 'KR', 'Republic of Korea', 'WPRO', '61', '12965', '0', '282');
INSERT INTO public.who_global_data_import VALUES (68584, '2020-07-04', 'KR', 'Republic of Korea', 'WPRO', '63', '13028', '1', '283');
INSERT INTO public.who_global_data_import VALUES (68585, '2020-07-05', 'KR', 'Republic of Korea', 'WPRO', '61', '13089', '0', '283');
INSERT INTO public.who_global_data_import VALUES (68586, '2020-07-06', 'KR', 'Republic of Korea', 'WPRO', '48', '13137', '1', '284');
INSERT INTO public.who_global_data_import VALUES (68587, '2020-07-07', 'KR', 'Republic of Korea', 'WPRO', '44', '13181', '1', '285');
INSERT INTO public.who_global_data_import VALUES (68588, '2020-07-08', 'KR', 'Republic of Korea', 'WPRO', '62', '13243', '0', '285');
INSERT INTO public.who_global_data_import VALUES (68589, '2020-07-09', 'KR', 'Republic of Korea', 'WPRO', '50', '13293', '2', '287');
INSERT INTO public.who_global_data_import VALUES (68590, '2020-07-10', 'KR', 'Republic of Korea', 'WPRO', '45', '13338', '1', '288');
INSERT INTO public.who_global_data_import VALUES (68591, '2020-07-11', 'KR', 'Republic of Korea', 'WPRO', '35', '13373', '0', '288');
INSERT INTO public.who_global_data_import VALUES (68592, '2020-07-12', 'KR', 'Republic of Korea', 'WPRO', '44', '13417', '1', '289');
INSERT INTO public.who_global_data_import VALUES (68593, '2020-07-13', 'KR', 'Republic of Korea', 'WPRO', '62', '13479', '0', '289');
INSERT INTO public.who_global_data_import VALUES (68594, '2020-07-14', 'KR', 'Republic of Korea', 'WPRO', '33', '13512', '0', '289');
INSERT INTO public.who_global_data_import VALUES (68595, '2020-07-15', 'KR', 'Republic of Korea', 'WPRO', '39', '13551', '0', '289');
INSERT INTO public.who_global_data_import VALUES (68596, '2020-07-16', 'KR', 'Republic of Korea', 'WPRO', '61', '13612', '2', '291');
INSERT INTO public.who_global_data_import VALUES (68597, '2020-07-17', 'KR', 'Republic of Korea', 'WPRO', '60', '13672', '2', '293');
INSERT INTO public.who_global_data_import VALUES (68598, '2020-07-18', 'KR', 'Republic of Korea', 'WPRO', '39', '13711', '1', '294');
INSERT INTO public.who_global_data_import VALUES (68599, '2020-07-19', 'KR', 'Republic of Korea', 'WPRO', '34', '13745', '1', '295');
INSERT INTO public.who_global_data_import VALUES (68600, '2020-07-20', 'KR', 'Republic of Korea', 'WPRO', '26', '13771', '1', '296');
INSERT INTO public.who_global_data_import VALUES (68601, '2020-07-21', 'KR', 'Republic of Korea', 'WPRO', '45', '13816', '0', '296');
INSERT INTO public.who_global_data_import VALUES (68602, '2020-07-22', 'KR', 'Republic of Korea', 'WPRO', '63', '13879', '1', '297');
INSERT INTO public.who_global_data_import VALUES (68603, '2020-07-23', 'KR', 'Republic of Korea', 'WPRO', '59', '13938', '0', '297');
INSERT INTO public.who_global_data_import VALUES (68604, '2020-07-24', 'KR', 'Republic of Korea', 'WPRO', '41', '13979', '1', '298');
INSERT INTO public.who_global_data_import VALUES (68605, '2020-07-25', 'KR', 'Republic of Korea', 'WPRO', '113', '14092', '0', '298');
INSERT INTO public.who_global_data_import VALUES (68606, '2020-07-26', 'KR', 'Republic of Korea', 'WPRO', '58', '14150', '0', '298');
INSERT INTO public.who_global_data_import VALUES (68607, '2020-07-27', 'KR', 'Republic of Korea', 'WPRO', '25', '14175', '1', '299');
INSERT INTO public.who_global_data_import VALUES (68608, '2020-07-28', 'KR', 'Republic of Korea', 'WPRO', '28', '14203', '1', '300');
INSERT INTO public.who_global_data_import VALUES (68609, '2020-07-29', 'KR', 'Republic of Korea', 'WPRO', '48', '14251', '0', '300');
INSERT INTO public.who_global_data_import VALUES (68610, '2020-07-30', 'KR', 'Republic of Korea', 'WPRO', '18', '14269', '0', '300');
INSERT INTO public.who_global_data_import VALUES (68611, '2020-07-31', 'KR', 'Republic of Korea', 'WPRO', '36', '14305', '1', '301');
INSERT INTO public.who_global_data_import VALUES (68612, '2020-08-01', 'KR', 'Republic of Korea', 'WPRO', '31', '14336', '0', '301');
INSERT INTO public.who_global_data_import VALUES (68613, '2020-08-02', 'KR', 'Republic of Korea', 'WPRO', '30', '14366', '0', '301');
INSERT INTO public.who_global_data_import VALUES (68614, '2020-08-03', 'KR', 'Republic of Korea', 'WPRO', '23', '14389', '0', '301');
INSERT INTO public.who_global_data_import VALUES (68615, '2020-08-04', 'KR', 'Republic of Korea', 'WPRO', '34', '14423', '0', '301');
INSERT INTO public.who_global_data_import VALUES (68616, '2020-08-05', 'KR', 'Republic of Korea', 'WPRO', '33', '14456', '1', '302');
INSERT INTO public.who_global_data_import VALUES (68617, '2020-08-06', 'KR', 'Republic of Korea', 'WPRO', '43', '14499', '0', '302');
INSERT INTO public.who_global_data_import VALUES (68618, '2020-08-07', 'KR', 'Republic of Korea', 'WPRO', '20', '14519', '1', '303');
INSERT INTO public.who_global_data_import VALUES (68619, '2020-08-08', 'KR', 'Republic of Korea', 'WPRO', '43', '14562', '1', '304');
INSERT INTO public.who_global_data_import VALUES (68620, '2020-08-09', 'KR', 'Republic of Korea', 'WPRO', '36', '14598', '1', '305');
INSERT INTO public.who_global_data_import VALUES (68621, '2020-08-10', 'KR', 'Republic of Korea', 'WPRO', '28', '14626', '0', '305');
INSERT INTO public.who_global_data_import VALUES (68622, '2020-08-11', 'KR', 'Republic of Korea', 'WPRO', '34', '14660', '0', '305');
INSERT INTO public.who_global_data_import VALUES (68623, '2020-08-12', 'KR', 'Republic of Korea', 'WPRO', '54', '14714', '0', '305');
INSERT INTO public.who_global_data_import VALUES (68624, '2020-08-13', 'KR', 'Republic of Korea', 'WPRO', '56', '14770', '0', '305');
INSERT INTO public.who_global_data_import VALUES (68625, '2020-08-14', 'KR', 'Republic of Korea', 'WPRO', '103', '14873', '0', '305');
INSERT INTO public.who_global_data_import VALUES (68626, '2020-08-15', 'KR', 'Republic of Korea', 'WPRO', '166', '15039', '0', '305');
INSERT INTO public.who_global_data_import VALUES (68627, '2020-08-16', 'KR', 'Republic of Korea', 'WPRO', '279', '15318', '0', '305');
INSERT INTO public.who_global_data_import VALUES (68628, '2020-08-17', 'KR', 'Republic of Korea', 'WPRO', '197', '15515', '0', '305');
INSERT INTO public.who_global_data_import VALUES (68629, '2020-08-18', 'KR', 'Republic of Korea', 'WPRO', '246', '15761', '1', '306');
INSERT INTO public.who_global_data_import VALUES (68630, '2020-08-19', 'KR', 'Republic of Korea', 'WPRO', '297', '16058', '0', '306');
INSERT INTO public.who_global_data_import VALUES (68631, '2020-08-20', 'KR', 'Republic of Korea', 'WPRO', '288', '16346', '1', '307');
INSERT INTO public.who_global_data_import VALUES (68632, '2020-08-21', 'KR', 'Republic of Korea', 'WPRO', '324', '16670', '2', '309');
INSERT INTO public.who_global_data_import VALUES (68633, '2020-08-22', 'KR', 'Republic of Korea', 'WPRO', '332', '17002', '0', '309');
INSERT INTO public.who_global_data_import VALUES (68634, '2020-08-23', 'KR', 'Republic of Korea', 'WPRO', '397', '17399', '0', '309');
INSERT INTO public.who_global_data_import VALUES (68635, '2020-08-24', 'KR', 'Republic of Korea', 'WPRO', '266', '17665', '0', '309');
INSERT INTO public.who_global_data_import VALUES (68636, '2020-08-25', 'KR', 'Republic of Korea', 'WPRO', '280', '17945', '1', '310');
INSERT INTO public.who_global_data_import VALUES (68637, '2020-08-26', 'KR', 'Republic of Korea', 'WPRO', '320', '18265', '2', '312');
INSERT INTO public.who_global_data_import VALUES (69611, '2020-01-13', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68638, '2020-08-27', 'KR', 'Republic of Korea', 'WPRO', '441', '18706', '1', '313');
INSERT INTO public.who_global_data_import VALUES (68639, '2020-08-28', 'KR', 'Republic of Korea', 'WPRO', '371', '19077', '3', '316');
INSERT INTO public.who_global_data_import VALUES (68640, '2020-08-29', 'KR', 'Republic of Korea', 'WPRO', '323', '19400', '5', '321');
INSERT INTO public.who_global_data_import VALUES (68641, '2020-08-30', 'KR', 'Republic of Korea', 'WPRO', '299', '19699', '2', '323');
INSERT INTO public.who_global_data_import VALUES (68642, '2020-08-31', 'KR', 'Republic of Korea', 'WPRO', '248', '19947', '1', '324');
INSERT INTO public.who_global_data_import VALUES (68643, '2020-09-01', 'KR', 'Republic of Korea', 'WPRO', '235', '20182', '0', '324');
INSERT INTO public.who_global_data_import VALUES (68644, '2020-09-02', 'KR', 'Republic of Korea', 'WPRO', '267', '20449', '2', '326');
INSERT INTO public.who_global_data_import VALUES (68645, '2020-09-03', 'KR', 'Republic of Korea', 'WPRO', '195', '20644', '3', '329');
INSERT INTO public.who_global_data_import VALUES (68646, '2020-09-04', 'KR', 'Republic of Korea', 'WPRO', '198', '20842', '2', '331');
INSERT INTO public.who_global_data_import VALUES (68647, '2020-09-05', 'KR', 'Republic of Korea', 'WPRO', '168', '21010', '2', '333');
INSERT INTO public.who_global_data_import VALUES (68648, '2020-09-06', 'KR', 'Republic of Korea', 'WPRO', '167', '21177', '1', '334');
INSERT INTO public.who_global_data_import VALUES (68649, '2020-09-07', 'KR', 'Republic of Korea', 'WPRO', '119', '21296', '2', '336');
INSERT INTO public.who_global_data_import VALUES (68650, '2020-09-08', 'KR', 'Republic of Korea', 'WPRO', '136', '21432', '5', '341');
INSERT INTO public.who_global_data_import VALUES (68651, '2020-09-09', 'KR', 'Republic of Korea', 'WPRO', '156', '21588', '3', '344');
INSERT INTO public.who_global_data_import VALUES (68652, '2020-09-10', 'KR', 'Republic of Korea', 'WPRO', '155', '21743', '2', '346');
INSERT INTO public.who_global_data_import VALUES (68653, '2020-09-11', 'KR', 'Republic of Korea', 'WPRO', '176', '21919', '4', '350');
INSERT INTO public.who_global_data_import VALUES (68654, '2020-09-12', 'KR', 'Republic of Korea', 'WPRO', '136', '22055', '5', '355');
INSERT INTO public.who_global_data_import VALUES (68655, '2020-09-13', 'KR', 'Republic of Korea', 'WPRO', '121', '22176', '3', '358');
INSERT INTO public.who_global_data_import VALUES (68656, '2020-09-14', 'KR', 'Republic of Korea', 'WPRO', '109', '22285', '5', '363');
INSERT INTO public.who_global_data_import VALUES (68657, '2020-09-15', 'KR', 'Republic of Korea', 'WPRO', '106', '22391', '4', '367');
INSERT INTO public.who_global_data_import VALUES (68658, '2020-09-16', 'KR', 'Republic of Korea', 'WPRO', '113', '22504', '0', '367');
INSERT INTO public.who_global_data_import VALUES (68659, '2020-09-17', 'KR', 'Republic of Korea', 'WPRO', '153', '22657', '5', '372');
INSERT INTO public.who_global_data_import VALUES (68660, '2020-09-18', 'KR', 'Republic of Korea', 'WPRO', '126', '22783', '5', '377');
INSERT INTO public.who_global_data_import VALUES (68661, '2020-09-19', 'KR', 'Republic of Korea', 'WPRO', '110', '22893', '1', '378');
INSERT INTO public.who_global_data_import VALUES (68662, '2020-09-20', 'KR', 'Republic of Korea', 'WPRO', '82', '22975', '5', '383');
INSERT INTO public.who_global_data_import VALUES (68663, '2020-09-21', 'KR', 'Republic of Korea', 'WPRO', '70', '23045', '2', '385');
INSERT INTO public.who_global_data_import VALUES (68664, '2020-09-22', 'KR', 'Republic of Korea', 'WPRO', '61', '23106', '3', '388');
INSERT INTO public.who_global_data_import VALUES (68665, '2020-09-23', 'KR', 'Republic of Korea', 'WPRO', '110', '23216', '0', '388');
INSERT INTO public.who_global_data_import VALUES (68666, '2020-09-24', 'KR', 'Republic of Korea', 'WPRO', '125', '23341', '5', '393');
INSERT INTO public.who_global_data_import VALUES (68667, '2020-09-25', 'KR', 'Republic of Korea', 'WPRO', '114', '23455', '2', '395');
INSERT INTO public.who_global_data_import VALUES (68668, '2020-09-26', 'KR', 'Republic of Korea', 'WPRO', '61', '23516', '4', '399');
INSERT INTO public.who_global_data_import VALUES (68669, '2020-09-27', 'KR', 'Republic of Korea', 'WPRO', '95', '23611', '2', '401');
INSERT INTO public.who_global_data_import VALUES (68670, '2020-09-28', 'KR', 'Republic of Korea', 'WPRO', '50', '23661', '5', '406');
INSERT INTO public.who_global_data_import VALUES (68671, '2020-09-29', 'KR', 'Republic of Korea', 'WPRO', '38', '23699', '1', '407');
INSERT INTO public.who_global_data_import VALUES (68672, '2020-09-30', 'KR', 'Republic of Korea', 'WPRO', '113', '23812', '6', '413');
INSERT INTO public.who_global_data_import VALUES (68673, '2020-10-01', 'KR', 'Republic of Korea', 'WPRO', '77', '23889', '2', '415');
INSERT INTO public.who_global_data_import VALUES (68674, '2020-10-02', 'KR', 'Republic of Korea', 'WPRO', '63', '23952', '1', '416');
INSERT INTO public.who_global_data_import VALUES (68675, '2020-10-03', 'KR', 'Republic of Korea', 'WPRO', '75', '24027', '4', '420');
INSERT INTO public.who_global_data_import VALUES (68676, '2020-10-04', 'KR', 'Republic of Korea', 'WPRO', '64', '24091', '1', '421');
INSERT INTO public.who_global_data_import VALUES (68677, '2020-10-05', 'KR', 'Republic of Korea', 'WPRO', '73', '24164', '1', '422');
INSERT INTO public.who_global_data_import VALUES (68678, '2020-10-06', 'KR', 'Republic of Korea', 'WPRO', '75', '24239', '0', '422');
INSERT INTO public.who_global_data_import VALUES (68679, '2020-10-07', 'KR', 'Republic of Korea', 'WPRO', '114', '24353', '3', '425');
INSERT INTO public.who_global_data_import VALUES (68680, '2020-10-08', 'KR', 'Republic of Korea', 'WPRO', '69', '24422', '2', '427');
INSERT INTO public.who_global_data_import VALUES (68681, '2020-10-09', 'KR', 'Republic of Korea', 'WPRO', '54', '24476', '1', '428');
INSERT INTO public.who_global_data_import VALUES (68682, '2020-10-10', 'KR', 'Republic of Korea', 'WPRO', '72', '24548', '2', '430');
INSERT INTO public.who_global_data_import VALUES (68683, '2020-10-11', 'KR', 'Republic of Korea', 'WPRO', '58', '24606', '2', '432');
INSERT INTO public.who_global_data_import VALUES (68684, '2020-10-12', 'KR', 'Republic of Korea', 'WPRO', '97', '24703', '1', '433');
INSERT INTO public.who_global_data_import VALUES (68685, '2020-10-13', 'KR', 'Republic of Korea', 'WPRO', '102', '24805', '1', '434');
INSERT INTO public.who_global_data_import VALUES (68686, '2020-10-14', 'KR', 'Republic of Korea', 'WPRO', '73', '24878', '4', '438');
INSERT INTO public.who_global_data_import VALUES (68687, '2020-10-15', 'KR', 'Republic of Korea', 'WPRO', '110', '24988', '1', '439');
INSERT INTO public.who_global_data_import VALUES (68688, '2020-10-16', 'KR', 'Republic of Korea', 'WPRO', '47', '25035', '2', '441');
INSERT INTO public.who_global_data_import VALUES (68689, '2020-10-17', 'KR', 'Republic of Korea', 'WPRO', '73', '25108', '2', '443');
INSERT INTO public.who_global_data_import VALUES (68690, '2020-10-18', 'KR', 'Republic of Korea', 'WPRO', '91', '25199', '1', '444');
INSERT INTO public.who_global_data_import VALUES (68691, '2020-10-19', 'KR', 'Republic of Korea', 'WPRO', '76', '25275', '0', '444');
INSERT INTO public.who_global_data_import VALUES (68692, '2020-10-20', 'KR', 'Republic of Korea', 'WPRO', '58', '25333', '3', '447');
INSERT INTO public.who_global_data_import VALUES (68693, '2020-10-21', 'KR', 'Republic of Korea', 'WPRO', '89', '25422', '3', '450');
INSERT INTO public.who_global_data_import VALUES (68694, '2020-10-22', 'KR', 'Republic of Korea', 'WPRO', '121', '25543', '3', '453');
INSERT INTO public.who_global_data_import VALUES (68695, '2020-10-23', 'KR', 'Republic of Korea', 'WPRO', '155', '25698', '2', '455');
INSERT INTO public.who_global_data_import VALUES (68696, '2020-10-24', 'KR', 'Republic of Korea', 'WPRO', '77', '25775', '2', '457');
INSERT INTO public.who_global_data_import VALUES (68697, '2020-10-25', 'KR', 'Republic of Korea', 'WPRO', '61', '25836', '0', '457');
INSERT INTO public.who_global_data_import VALUES (68698, '2020-10-26', 'KR', 'Republic of Korea', 'WPRO', '119', '25955', '0', '457');
INSERT INTO public.who_global_data_import VALUES (68699, '2020-10-27', 'KR', 'Republic of Korea', 'WPRO', '88', '26043', '3', '460');
INSERT INTO public.who_global_data_import VALUES (68700, '2020-10-28', 'KR', 'Republic of Korea', 'WPRO', '103', '26146', '1', '461');
INSERT INTO public.who_global_data_import VALUES (68701, '2020-10-29', 'KR', 'Republic of Korea', 'WPRO', '125', '26271', '1', '462');
INSERT INTO public.who_global_data_import VALUES (68702, '2020-10-30', 'KR', 'Republic of Korea', 'WPRO', '113', '26384', '1', '463');
INSERT INTO public.who_global_data_import VALUES (68703, '2020-10-31', 'KR', 'Republic of Korea', 'WPRO', '127', '26511', '1', '464');
INSERT INTO public.who_global_data_import VALUES (68704, '2020-11-01', 'KR', 'Republic of Korea', 'WPRO', '124', '26635', '2', '466');
INSERT INTO public.who_global_data_import VALUES (68705, '2020-11-02', 'KR', 'Republic of Korea', 'WPRO', '97', '26732', '2', '468');
INSERT INTO public.who_global_data_import VALUES (68706, '2020-11-03', 'KR', 'Republic of Korea', 'WPRO', '75', '26807', '4', '472');
INSERT INTO public.who_global_data_import VALUES (68707, '2020-11-04', 'KR', 'Republic of Korea', 'WPRO', '117', '26924', '2', '474');
INSERT INTO public.who_global_data_import VALUES (68708, '2020-11-05', 'KR', 'Republic of Korea', 'WPRO', '125', '27049', '1', '475');
INSERT INTO public.who_global_data_import VALUES (68709, '2020-11-06', 'KR', 'Republic of Korea', 'WPRO', '145', '27194', '1', '476');
INSERT INTO public.who_global_data_import VALUES (68710, '2020-11-07', 'KR', 'Republic of Korea', 'WPRO', '89', '27283', '1', '477');
INSERT INTO public.who_global_data_import VALUES (68711, '2020-11-08', 'KR', 'Republic of Korea', 'WPRO', '143', '27426', '1', '478');
INSERT INTO public.who_global_data_import VALUES (68712, '2020-11-09', 'KR', 'Republic of Korea', 'WPRO', '126', '27552', '2', '480');
INSERT INTO public.who_global_data_import VALUES (68713, '2020-11-10', 'KR', 'Republic of Korea', 'WPRO', '100', '27652', '5', '485');
INSERT INTO public.who_global_data_import VALUES (68714, '2020-11-11', 'KR', 'Republic of Korea', 'WPRO', '145', '27797', '2', '487');
INSERT INTO public.who_global_data_import VALUES (68715, '2020-11-12', 'KR', 'Republic of Korea', 'WPRO', '143', '27940', '0', '487');
INSERT INTO public.who_global_data_import VALUES (68716, '2020-11-13', 'KR', 'Republic of Korea', 'WPRO', '191', '28131', '1', '488');
INSERT INTO public.who_global_data_import VALUES (68717, '2020-11-14', 'KR', 'Republic of Korea', 'WPRO', '205', '28336', '4', '492');
INSERT INTO public.who_global_data_import VALUES (68718, '2020-11-15', 'KR', 'Republic of Korea', 'WPRO', '208', '28544', '1', '493');
INSERT INTO public.who_global_data_import VALUES (68719, '2020-11-16', 'KR', 'Republic of Korea', 'WPRO', '222', '28766', '1', '494');
INSERT INTO public.who_global_data_import VALUES (68720, '2020-11-17', 'KR', 'Republic of Korea', 'WPRO', '230', '28996', '0', '494');
INSERT INTO public.who_global_data_import VALUES (68721, '2020-11-18', 'KR', 'Republic of Korea', 'WPRO', '285', '29281', '2', '496');
INSERT INTO public.who_global_data_import VALUES (68722, '2020-11-19', 'KR', 'Republic of Korea', 'WPRO', '325', '29606', '2', '498');
INSERT INTO public.who_global_data_import VALUES (68723, '2020-11-20', 'KR', 'Republic of Korea', 'WPRO', '348', '29954', '3', '501');
INSERT INTO public.who_global_data_import VALUES (68724, '2020-11-21', 'KR', 'Republic of Korea', 'WPRO', '386', '30340', '2', '503');
INSERT INTO public.who_global_data_import VALUES (68725, '2020-11-22', 'KR', 'Republic of Korea', 'WPRO', '330', '30670', '2', '505');
INSERT INTO public.who_global_data_import VALUES (68726, '2020-11-23', 'KR', 'Republic of Korea', 'WPRO', '271', '30941', '4', '509');
INSERT INTO public.who_global_data_import VALUES (68727, '2020-11-24', 'KR', 'Republic of Korea', 'WPRO', '349', '31290', '1', '510');
INSERT INTO public.who_global_data_import VALUES (68728, '2020-11-25', 'KR', 'Republic of Korea', 'WPRO', '382', '31672', '3', '513');
INSERT INTO public.who_global_data_import VALUES (68729, '2020-11-26', 'KR', 'Republic of Korea', 'WPRO', '581', '32253', '2', '515');
INSERT INTO public.who_global_data_import VALUES (68730, '2020-11-27', 'KR', 'Republic of Korea', 'WPRO', '555', '32808', '1', '516');
INSERT INTO public.who_global_data_import VALUES (68731, '2020-11-28', 'KR', 'Republic of Korea', 'WPRO', '503', '33311', '6', '522');
INSERT INTO public.who_global_data_import VALUES (68732, '2020-11-29', 'KR', 'Republic of Korea', 'WPRO', '450', '33761', '1', '523');
INSERT INTO public.who_global_data_import VALUES (68733, '2020-11-30', 'KR', 'Republic of Korea', 'WPRO', '438', '34199', '3', '526');
INSERT INTO public.who_global_data_import VALUES (68734, '2020-12-01', 'KR', 'Republic of Korea', 'WPRO', '451', '34650', '0', '526');
INSERT INTO public.who_global_data_import VALUES (68735, '2020-12-02', 'KR', 'Republic of Korea', 'WPRO', '511', '35161', '0', '526');
INSERT INTO public.who_global_data_import VALUES (68736, '2020-12-03', 'KR', 'Republic of Korea', 'WPRO', '540', '35701', '3', '529');
INSERT INTO public.who_global_data_import VALUES (68737, '2020-12-04', 'KR', 'Republic of Korea', 'WPRO', '628', '36329', '7', '536');
INSERT INTO public.who_global_data_import VALUES (68738, '2020-12-05', 'KR', 'Republic of Korea', 'WPRO', '577', '36906', '4', '540');
INSERT INTO public.who_global_data_import VALUES (68739, '2020-12-06', 'KR', 'Republic of Korea', 'WPRO', '631', '37537', '5', '545');
INSERT INTO public.who_global_data_import VALUES (68740, '2020-12-07', 'KR', 'Republic of Korea', 'WPRO', '615', '38152', '4', '549');
INSERT INTO public.who_global_data_import VALUES (68741, '2020-12-08', 'KR', 'Republic of Korea', 'WPRO', '589', '38741', '3', '552');
INSERT INTO public.who_global_data_import VALUES (68742, '2020-12-09', 'KR', 'Republic of Korea', 'WPRO', '670', '39411', '4', '556');
INSERT INTO public.who_global_data_import VALUES (68743, '2020-12-10', 'KR', 'Republic of Korea', 'WPRO', '680', '40091', '8', '564');
INSERT INTO public.who_global_data_import VALUES (68744, '2020-12-11', 'KR', 'Republic of Korea', 'WPRO', '689', '40780', '8', '572');
INSERT INTO public.who_global_data_import VALUES (68745, '2020-12-12', 'KR', 'Republic of Korea', 'WPRO', '950', '41730', '6', '578');
INSERT INTO public.who_global_data_import VALUES (68746, '2020-12-13', 'KR', 'Republic of Korea', 'WPRO', '1030', '42760', '2', '580');
INSERT INTO public.who_global_data_import VALUES (68747, '2020-12-14', 'KR', 'Republic of Korea', 'WPRO', '718', '43478', '7', '587');
INSERT INTO public.who_global_data_import VALUES (68748, '2020-12-15', 'KR', 'Republic of Korea', 'WPRO', '880', '44358', '13', '600');
INSERT INTO public.who_global_data_import VALUES (68749, '2020-12-16', 'KR', 'Republic of Korea', 'WPRO', '1078', '45436', '12', '612');
INSERT INTO public.who_global_data_import VALUES (68750, '2020-12-17', 'KR', 'Republic of Korea', 'WPRO', '1014', '46450', '22', '634');
INSERT INTO public.who_global_data_import VALUES (68751, '2020-12-18', 'KR', 'Republic of Korea', 'WPRO', '1064', '47514', '11', '645');
INSERT INTO public.who_global_data_import VALUES (68752, '2020-12-19', 'KR', 'Republic of Korea', 'WPRO', '1046', '48560', '14', '659');
INSERT INTO public.who_global_data_import VALUES (68753, '2020-12-20', 'KR', 'Republic of Korea', 'WPRO', '1097', '49657', '15', '674');
INSERT INTO public.who_global_data_import VALUES (68754, '2020-12-21', 'KR', 'Republic of Korea', 'WPRO', '924', '50581', '24', '698');
INSERT INTO public.who_global_data_import VALUES (68755, '2020-12-22', 'KR', 'Republic of Korea', 'WPRO', '866', '51447', '24', '722');
INSERT INTO public.who_global_data_import VALUES (68756, '2020-12-23', 'KR', 'Republic of Korea', 'WPRO', '1090', '52537', '17', '739');
INSERT INTO public.who_global_data_import VALUES (68757, '2020-12-24', 'KR', 'Republic of Korea', 'WPRO', '985', '53522', '17', '756');
INSERT INTO public.who_global_data_import VALUES (68758, '2020-12-25', 'KR', 'Republic of Korea', 'WPRO', '1235', '54757', '17', '773');
INSERT INTO public.who_global_data_import VALUES (68759, '2020-12-26', 'KR', 'Republic of Korea', 'WPRO', '1131', '55888', '20', '793');
INSERT INTO public.who_global_data_import VALUES (68760, '2020-12-27', 'KR', 'Republic of Korea', 'WPRO', '970', '56858', '15', '808');
INSERT INTO public.who_global_data_import VALUES (68761, '2020-12-28', 'KR', 'Republic of Korea', 'WPRO', '807', '57665', '11', '819');
INSERT INTO public.who_global_data_import VALUES (68762, '2020-12-29', 'KR', 'Republic of Korea', 'WPRO', '1044', '58709', '40', '859');
INSERT INTO public.who_global_data_import VALUES (68763, '2020-12-30', 'KR', 'Republic of Korea', 'WPRO', '1050', '59759', '20', '879');
INSERT INTO public.who_global_data_import VALUES (68764, '2020-12-31', 'KR', 'Republic of Korea', 'WPRO', '967', '60726', '21', '900');
INSERT INTO public.who_global_data_import VALUES (68765, '2021-01-01', 'KR', 'Republic of Korea', 'WPRO', '1028', '61754', '17', '917');
INSERT INTO public.who_global_data_import VALUES (68766, '2021-01-02', 'KR', 'Republic of Korea', 'WPRO', '824', '62578', '25', '942');
INSERT INTO public.who_global_data_import VALUES (68767, '2021-01-03', 'KR', 'Republic of Korea', 'WPRO', '657', '63235', '20', '962');
INSERT INTO public.who_global_data_import VALUES (68768, '2021-01-04', 'KR', 'Republic of Korea', 'WPRO', '1020', '64255', '19', '981');
INSERT INTO public.who_global_data_import VALUES (68769, '2021-01-05', 'KR', 'Republic of Korea', 'WPRO', '714', '64969', '26', '1007');
INSERT INTO public.who_global_data_import VALUES (68770, '2021-01-06', 'KR', 'Republic of Korea', 'WPRO', '838', '65807', '20', '1027');
INSERT INTO public.who_global_data_import VALUES (68771, '2021-01-07', 'KR', 'Republic of Korea', 'WPRO', '869', '66676', '19', '1046');
INSERT INTO public.who_global_data_import VALUES (68772, '2021-01-08', 'KR', 'Republic of Korea', 'WPRO', '674', '67350', '35', '1081');
INSERT INTO public.who_global_data_import VALUES (68773, '2021-01-09', 'KR', 'Republic of Korea', 'WPRO', '641', '67991', '19', '1100');
INSERT INTO public.who_global_data_import VALUES (68774, '2021-01-10', 'KR', 'Republic of Korea', 'WPRO', '657', '68648', '25', '1125');
INSERT INTO public.who_global_data_import VALUES (68775, '2021-01-11', 'KR', 'Republic of Korea', 'WPRO', '451', '69099', '15', '1140');
INSERT INTO public.who_global_data_import VALUES (68776, '2021-01-12', 'KR', 'Republic of Korea', 'WPRO', '537', '69636', '25', '1165');
INSERT INTO public.who_global_data_import VALUES (68777, '2021-01-13', 'KR', 'Republic of Korea', 'WPRO', '561', '70197', '20', '1185');
INSERT INTO public.who_global_data_import VALUES (68778, '2021-01-14', 'KR', 'Republic of Korea', 'WPRO', '524', '70721', '10', '1195');
INSERT INTO public.who_global_data_import VALUES (68779, '2021-01-15', 'KR', 'Republic of Korea', 'WPRO', '512', '71233', '22', '1217');
INSERT INTO public.who_global_data_import VALUES (68780, '2021-01-16', 'KR', 'Republic of Korea', 'WPRO', '580', '71813', '19', '1236');
INSERT INTO public.who_global_data_import VALUES (68781, '2021-01-17', 'KR', 'Republic of Korea', 'WPRO', '520', '72333', '13', '1249');
INSERT INTO public.who_global_data_import VALUES (68782, '2021-01-18', 'KR', 'Republic of Korea', 'WPRO', '389', '72722', '15', '1264');
INSERT INTO public.who_global_data_import VALUES (68783, '2021-01-19', 'KR', 'Republic of Korea', 'WPRO', '386', '73108', '19', '1283');
INSERT INTO public.who_global_data_import VALUES (68784, '2021-01-20', 'KR', 'Republic of Korea', 'WPRO', '404', '73512', '17', '1300');
INSERT INTO public.who_global_data_import VALUES (68785, '2021-01-21', 'KR', 'Republic of Korea', 'WPRO', '401', '73913', '16', '1316');
INSERT INTO public.who_global_data_import VALUES (68786, '2021-01-22', 'KR', 'Republic of Korea', 'WPRO', '345', '74258', '12', '1328');
INSERT INTO public.who_global_data_import VALUES (68787, '2021-01-23', 'KR', 'Republic of Korea', 'WPRO', '431', '74689', '9', '1337');
INSERT INTO public.who_global_data_import VALUES (68788, '2021-01-24', 'KR', 'Republic of Korea', 'WPRO', '392', '75081', '12', '1349');
INSERT INTO public.who_global_data_import VALUES (68789, '2021-01-25', 'KR', 'Republic of Korea', 'WPRO', '437', '75518', '11', '1360');
INSERT INTO public.who_global_data_import VALUES (68790, '2021-01-26', 'KR', 'Republic of Korea', 'WPRO', '349', '75867', '11', '1371');
INSERT INTO public.who_global_data_import VALUES (68791, '2021-01-27', 'KR', 'Republic of Korea', 'WPRO', '559', '76426', '7', '1378');
INSERT INTO public.who_global_data_import VALUES (68792, '2021-01-28', 'KR', 'Republic of Korea', 'WPRO', '497', '76923', '8', '1386');
INSERT INTO public.who_global_data_import VALUES (68793, '2021-01-29', 'KR', 'Republic of Korea', 'WPRO', '469', '77392', '13', '1399');
INSERT INTO public.who_global_data_import VALUES (68794, '2021-01-30', 'KR', 'Republic of Korea', 'WPRO', '456', '77848', '15', '1414');
INSERT INTO public.who_global_data_import VALUES (68795, '2021-01-31', 'KR', 'Republic of Korea', 'WPRO', '354', '78202', '6', '1420');
INSERT INTO public.who_global_data_import VALUES (68796, '2021-02-01', 'KR', 'Republic of Korea', 'WPRO', '305', '78507', '5', '1425');
INSERT INTO public.who_global_data_import VALUES (68797, '2021-02-02', 'KR', 'Republic of Korea', 'WPRO', '336', '78843', '10', '1435');
INSERT INTO public.who_global_data_import VALUES (68798, '2021-02-03', 'KR', 'Republic of Korea', 'WPRO', '467', '79310', '6', '1441');
INSERT INTO public.who_global_data_import VALUES (68799, '2021-02-04', 'KR', 'Republic of Korea', 'WPRO', '451', '79761', '7', '1448');
INSERT INTO public.who_global_data_import VALUES (68800, '2021-02-05', 'KR', 'Republic of Korea', 'WPRO', '370', '80131', '11', '1459');
INSERT INTO public.who_global_data_import VALUES (68801, '2020-01-03', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68802, '2020-01-04', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68803, '2020-01-05', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68804, '2020-01-06', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68805, '2020-01-07', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68806, '2020-01-08', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68807, '2020-01-09', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68808, '2020-01-10', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68809, '2020-01-11', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68810, '2020-01-12', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68811, '2020-01-13', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68812, '2020-01-14', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68813, '2020-01-15', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68814, '2020-01-16', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68815, '2020-01-17', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68816, '2020-01-18', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68817, '2020-01-19', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68818, '2020-01-20', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68819, '2020-01-21', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68820, '2020-01-22', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68821, '2020-01-23', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68822, '2020-01-24', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68823, '2020-01-25', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68824, '2020-01-26', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68825, '2020-01-27', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68826, '2020-01-28', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68827, '2020-01-29', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68828, '2020-01-30', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68829, '2020-01-31', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68830, '2020-02-01', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68831, '2020-02-02', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68832, '2020-02-03', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68833, '2020-02-04', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68834, '2020-02-05', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68835, '2020-02-06', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68836, '2020-02-07', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68837, '2020-02-08', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68838, '2020-02-09', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68839, '2020-02-10', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68840, '2020-02-11', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68841, '2020-02-12', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68842, '2020-02-13', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68843, '2020-02-14', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68844, '2020-02-15', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68845, '2020-02-16', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68846, '2020-02-17', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68847, '2020-02-18', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68848, '2020-02-19', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68849, '2020-02-20', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68850, '2020-02-21', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68851, '2020-02-22', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68852, '2020-02-23', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68853, '2020-02-24', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68854, '2020-02-25', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68855, '2020-02-26', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68856, '2020-02-27', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68857, '2020-02-28', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68858, '2020-02-29', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68859, '2020-03-01', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68860, '2020-03-02', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68861, '2020-03-03', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68862, '2020-03-04', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68863, '2020-03-05', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68864, '2020-03-06', 'MD', 'Republic of Moldova', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68865, '2020-03-07', 'MD', 'Republic of Moldova', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68866, '2020-03-08', 'MD', 'Republic of Moldova', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68867, '2020-03-09', 'MD', 'Republic of Moldova', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68868, '2020-03-10', 'MD', 'Republic of Moldova', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68869, '2020-03-11', 'MD', 'Republic of Moldova', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68870, '2020-03-12', 'MD', 'Republic of Moldova', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68871, '2020-03-13', 'MD', 'Republic of Moldova', 'EURO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68872, '2020-03-14', 'MD', 'Republic of Moldova', 'EURO', '4', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68873, '2020-03-15', 'MD', 'Republic of Moldova', 'EURO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68874, '2020-03-16', 'MD', 'Republic of Moldova', 'EURO', '15', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68875, '2020-03-17', 'MD', 'Republic of Moldova', 'EURO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68876, '2020-03-18', 'MD', 'Republic of Moldova', 'EURO', '7', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68877, '2020-03-19', 'MD', 'Republic of Moldova', 'EURO', '6', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68878, '2020-03-20', 'MD', 'Republic of Moldova', 'EURO', '13', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (68879, '2020-03-21', 'MD', 'Republic of Moldova', 'EURO', '31', '80', '1', '1');
INSERT INTO public.who_global_data_import VALUES (68880, '2020-03-22', 'MD', 'Republic of Moldova', 'EURO', '0', '80', '0', '1');
INSERT INTO public.who_global_data_import VALUES (68881, '2020-03-23', 'MD', 'Republic of Moldova', 'EURO', '14', '94', '0', '1');
INSERT INTO public.who_global_data_import VALUES (68882, '2020-03-24', 'MD', 'Republic of Moldova', 'EURO', '15', '109', '0', '1');
INSERT INTO public.who_global_data_import VALUES (68883, '2020-03-25', 'MD', 'Republic of Moldova', 'EURO', '40', '149', '0', '1');
INSERT INTO public.who_global_data_import VALUES (68884, '2020-03-26', 'MD', 'Republic of Moldova', 'EURO', '0', '149', '0', '1');
INSERT INTO public.who_global_data_import VALUES (68885, '2020-03-27', 'MD', 'Republic of Moldova', 'EURO', '50', '199', '1', '2');
INSERT INTO public.who_global_data_import VALUES (68886, '2020-03-28', 'MD', 'Republic of Moldova', 'EURO', '0', '199', '0', '2');
INSERT INTO public.who_global_data_import VALUES (68887, '2020-03-29', 'MD', 'Republic of Moldova', 'EURO', '32', '231', '0', '2');
INSERT INTO public.who_global_data_import VALUES (68888, '2020-03-30', 'MD', 'Republic of Moldova', 'EURO', '32', '263', '0', '2');
INSERT INTO public.who_global_data_import VALUES (68889, '2020-03-31', 'MD', 'Republic of Moldova', 'EURO', '90', '353', '1', '3');
INSERT INTO public.who_global_data_import VALUES (68890, '2020-04-01', 'MD', 'Republic of Moldova', 'EURO', '70', '423', '2', '5');
INSERT INTO public.who_global_data_import VALUES (68891, '2020-04-02', 'MD', 'Republic of Moldova', 'EURO', '0', '423', '0', '5');
INSERT INTO public.who_global_data_import VALUES (68892, '2020-04-03', 'MD', 'Republic of Moldova', 'EURO', '168', '591', '3', '8');
INSERT INTO public.who_global_data_import VALUES (68893, '2020-04-04', 'MD', 'Republic of Moldova', 'EURO', '0', '591', '1', '9');
INSERT INTO public.who_global_data_import VALUES (68894, '2020-04-05', 'MD', 'Republic of Moldova', 'EURO', '161', '752', '3', '12');
INSERT INTO public.who_global_data_import VALUES (68895, '2020-04-06', 'MD', 'Republic of Moldova', 'EURO', '112', '864', '3', '15');
INSERT INTO public.who_global_data_import VALUES (68896, '2020-04-07', 'MD', 'Republic of Moldova', 'EURO', '101', '965', '4', '19');
INSERT INTO public.who_global_data_import VALUES (68897, '2020-04-08', 'MD', 'Republic of Moldova', 'EURO', '91', '1056', '3', '22');
INSERT INTO public.who_global_data_import VALUES (68898, '2020-04-09', 'MD', 'Republic of Moldova', 'EURO', '118', '1174', '6', '28');
INSERT INTO public.who_global_data_import VALUES (68899, '2020-04-10', 'MD', 'Republic of Moldova', 'EURO', '115', '1289', '1', '29');
INSERT INTO public.who_global_data_import VALUES (68900, '2020-04-11', 'MD', 'Republic of Moldova', 'EURO', '149', '1438', '0', '29');
INSERT INTO public.who_global_data_import VALUES (68901, '2020-04-12', 'MD', 'Republic of Moldova', 'EURO', '122', '1560', '1', '30');
INSERT INTO public.who_global_data_import VALUES (68902, '2020-04-13', 'MD', 'Republic of Moldova', 'EURO', '102', '1662', '3', '33');
INSERT INTO public.who_global_data_import VALUES (68903, '2020-04-14', 'MD', 'Republic of Moldova', 'EURO', '50', '1712', '3', '36');
INSERT INTO public.who_global_data_import VALUES (68904, '2020-04-15', 'MD', 'Republic of Moldova', 'EURO', '222', '1934', '5', '41');
INSERT INTO public.who_global_data_import VALUES (68905, '2020-04-16', 'MD', 'Republic of Moldova', 'EURO', '115', '2049', '5', '46');
INSERT INTO public.who_global_data_import VALUES (68906, '2020-04-17', 'MD', 'Republic of Moldova', 'EURO', '105', '2154', '8', '54');
INSERT INTO public.who_global_data_import VALUES (68907, '2020-04-18', 'MD', 'Republic of Moldova', 'EURO', '110', '2264', '2', '56');
INSERT INTO public.who_global_data_import VALUES (68908, '2020-04-19', 'MD', 'Republic of Moldova', 'EURO', '87', '2351', '4', '60');
INSERT INTO public.who_global_data_import VALUES (68909, '2020-04-20', 'MD', 'Republic of Moldova', 'EURO', '121', '2472', '7', '67');
INSERT INTO public.who_global_data_import VALUES (68910, '2020-04-21', 'MD', 'Republic of Moldova', 'EURO', '76', '2548', '3', '70');
INSERT INTO public.who_global_data_import VALUES (68911, '2020-04-22', 'MD', 'Republic of Moldova', 'EURO', '93', '2641', '3', '73');
INSERT INTO public.who_global_data_import VALUES (68912, '2020-04-23', 'MD', 'Republic of Moldova', 'EURO', '137', '2778', '3', '76');
INSERT INTO public.who_global_data_import VALUES (68913, '2020-04-24', 'MD', 'Republic of Moldova', 'EURO', '148', '2926', '4', '80');
INSERT INTO public.who_global_data_import VALUES (68914, '2020-04-25', 'MD', 'Republic of Moldova', 'EURO', '184', '3110', '7', '87');
INSERT INTO public.who_global_data_import VALUES (68915, '2020-04-26', 'MD', 'Republic of Moldova', 'EURO', '194', '3304', '7', '94');
INSERT INTO public.who_global_data_import VALUES (68916, '2020-04-27', 'MD', 'Republic of Moldova', 'EURO', '104', '3408', '2', '96');
INSERT INTO public.who_global_data_import VALUES (68917, '2020-04-28', 'MD', 'Republic of Moldova', 'EURO', '73', '3481', '7', '103');
INSERT INTO public.who_global_data_import VALUES (68918, '2020-04-29', 'MD', 'Republic of Moldova', 'EURO', '157', '3638', '6', '109');
INSERT INTO public.who_global_data_import VALUES (68919, '2020-04-30', 'MD', 'Republic of Moldova', 'EURO', '133', '3771', '7', '116');
INSERT INTO public.who_global_data_import VALUES (68920, '2020-05-01', 'MD', 'Republic of Moldova', 'EURO', '126', '3897', '3', '119');
INSERT INTO public.who_global_data_import VALUES (68921, '2020-05-02', 'MD', 'Republic of Moldova', 'EURO', '83', '3980', '3', '122');
INSERT INTO public.who_global_data_import VALUES (68922, '2020-05-03', 'MD', 'Republic of Moldova', 'EURO', '72', '4052', '2', '124');
INSERT INTO public.who_global_data_import VALUES (68923, '2020-05-04', 'MD', 'Republic of Moldova', 'EURO', '69', '4121', '4', '128');
INSERT INTO public.who_global_data_import VALUES (68924, '2020-05-05', 'MD', 'Republic of Moldova', 'EURO', '127', '4248', '5', '133');
INSERT INTO public.who_global_data_import VALUES (68925, '2020-05-06', 'MD', 'Republic of Moldova', 'EURO', '115', '4363', '7', '140');
INSERT INTO public.who_global_data_import VALUES (68926, '2020-05-07', 'MD', 'Republic of Moldova', 'EURO', '113', '4476', '3', '143');
INSERT INTO public.who_global_data_import VALUES (68927, '2020-05-08', 'MD', 'Republic of Moldova', 'EURO', '129', '4605', '2', '145');
INSERT INTO public.who_global_data_import VALUES (68928, '2020-05-09', 'MD', 'Republic of Moldova', 'EURO', '123', '4728', '14', '159');
INSERT INTO public.who_global_data_import VALUES (68929, '2020-05-10', 'MD', 'Republic of Moldova', 'EURO', '139', '4867', '6', '165');
INSERT INTO public.who_global_data_import VALUES (68930, '2020-05-11', 'MD', 'Republic of Moldova', 'EURO', '60', '4927', '6', '171');
INSERT INTO public.who_global_data_import VALUES (68931, '2020-05-12', 'MD', 'Republic of Moldova', 'EURO', '68', '4995', '8', '179');
INSERT INTO public.who_global_data_import VALUES (68932, '2020-05-13', 'MD', 'Republic of Moldova', 'EURO', '159', '5154', '3', '182');
INSERT INTO public.who_global_data_import VALUES (68933, '2020-05-14', 'MD', 'Republic of Moldova', 'EURO', '252', '5406', '8', '190');
INSERT INTO public.who_global_data_import VALUES (68934, '2020-05-15', 'MD', 'Republic of Moldova', 'EURO', '147', '5553', '6', '196');
INSERT INTO public.who_global_data_import VALUES (68935, '2020-05-16', 'MD', 'Republic of Moldova', 'EURO', '192', '5745', '8', '204');
INSERT INTO public.who_global_data_import VALUES (68936, '2020-05-17', 'MD', 'Republic of Moldova', 'EURO', '189', '5934', '5', '209');
INSERT INTO public.who_global_data_import VALUES (68937, '2020-05-18', 'MD', 'Republic of Moldova', 'EURO', '126', '6060', '2', '211');
INSERT INTO public.who_global_data_import VALUES (68938, '2020-05-19', 'MD', 'Republic of Moldova', 'EURO', '78', '6138', '8', '219');
INSERT INTO public.who_global_data_import VALUES (68939, '2020-05-20', 'MD', 'Republic of Moldova', 'EURO', '202', '6340', '5', '224');
INSERT INTO public.who_global_data_import VALUES (68940, '2020-05-21', 'MD', 'Republic of Moldova', 'EURO', '213', '6553', '8', '232');
INSERT INTO public.who_global_data_import VALUES (68941, '2020-05-22', 'MD', 'Republic of Moldova', 'EURO', '151', '6704', '1', '233');
INSERT INTO public.who_global_data_import VALUES (68942, '2020-05-23', 'MD', 'Republic of Moldova', 'EURO', '143', '6847', '5', '238');
INSERT INTO public.who_global_data_import VALUES (68943, '2020-05-24', 'MD', 'Republic of Moldova', 'EURO', '147', '6994', '12', '250');
INSERT INTO public.who_global_data_import VALUES (68944, '2020-05-25', 'MD', 'Republic of Moldova', 'EURO', '99', '7093', '6', '256');
INSERT INTO public.who_global_data_import VALUES (68945, '2020-05-26', 'MD', 'Republic of Moldova', 'EURO', '56', '7149', '9', '265');
INSERT INTO public.who_global_data_import VALUES (68946, '2020-05-27', 'MD', 'Republic of Moldova', 'EURO', '156', '7305', '8', '273');
INSERT INTO public.who_global_data_import VALUES (68947, '2020-05-28', 'MD', 'Republic of Moldova', 'EURO', '232', '7537', '3', '276');
INSERT INTO public.who_global_data_import VALUES (68948, '2020-05-29', 'MD', 'Republic of Moldova', 'EURO', '188', '7725', '6', '282');
INSERT INTO public.who_global_data_import VALUES (68949, '2020-05-30', 'MD', 'Republic of Moldova', 'EURO', '171', '7896', '7', '289');
INSERT INTO public.who_global_data_import VALUES (68950, '2020-05-31', 'MD', 'Republic of Moldova', 'EURO', '202', '8098', '5', '294');
INSERT INTO public.who_global_data_import VALUES (68951, '2020-06-01', 'MD', 'Republic of Moldova', 'EURO', '153', '8251', '1', '295');
INSERT INTO public.who_global_data_import VALUES (68952, '2020-06-02', 'MD', 'Republic of Moldova', 'EURO', '109', '8360', '12', '307');
INSERT INTO public.who_global_data_import VALUES (68953, '2020-06-03', 'MD', 'Republic of Moldova', 'EURO', '188', '8548', '2', '309');
INSERT INTO public.who_global_data_import VALUES (68954, '2020-06-04', 'MD', 'Republic of Moldova', 'EURO', '247', '8795', '5', '314');
INSERT INTO public.who_global_data_import VALUES (68955, '2020-06-05', 'MD', 'Republic of Moldova', 'EURO', '223', '9018', '1', '315');
INSERT INTO public.who_global_data_import VALUES (68956, '2020-06-06', 'MD', 'Republic of Moldova', 'EURO', '229', '9247', '8', '323');
INSERT INTO public.who_global_data_import VALUES (68957, '2020-06-07', 'MD', 'Republic of Moldova', 'EURO', '264', '9511', '12', '335');
INSERT INTO public.who_global_data_import VALUES (68958, '2020-06-08', 'MD', 'Republic of Moldova', 'EURO', '189', '9700', '11', '346');
INSERT INTO public.who_global_data_import VALUES (68959, '2020-06-09', 'MD', 'Republic of Moldova', 'EURO', '107', '9807', '13', '359');
INSERT INTO public.who_global_data_import VALUES (68960, '2020-06-10', 'MD', 'Republic of Moldova', 'EURO', '218', '10025', '8', '367');
INSERT INTO public.who_global_data_import VALUES (68961, '2020-06-11', 'MD', 'Republic of Moldova', 'EURO', '296', '10321', '4', '371');
INSERT INTO public.who_global_data_import VALUES (68962, '2020-06-12', 'MD', 'Republic of Moldova', 'EURO', '406', '10727', '4', '375');
INSERT INTO public.who_global_data_import VALUES (68963, '2020-06-13', 'MD', 'Republic of Moldova', 'EURO', '366', '11093', '20', '395');
INSERT INTO public.who_global_data_import VALUES (68964, '2020-06-14', 'MD', 'Republic of Moldova', 'EURO', '366', '11459', '4', '399');
INSERT INTO public.who_global_data_import VALUES (68965, '2020-06-15', 'MD', 'Republic of Moldova', 'EURO', '281', '11740', '7', '406');
INSERT INTO public.who_global_data_import VALUES (68966, '2020-06-16', 'MD', 'Republic of Moldova', 'EURO', '139', '11879', '11', '417');
INSERT INTO public.who_global_data_import VALUES (68967, '2020-06-17', 'MD', 'Republic of Moldova', 'EURO', '375', '12254', '10', '427');
INSERT INTO public.who_global_data_import VALUES (68968, '2020-06-18', 'MD', 'Republic of Moldova', 'EURO', '478', '12732', '6', '433');
INSERT INTO public.who_global_data_import VALUES (68969, '2020-06-19', 'MD', 'Republic of Moldova', 'EURO', '374', '13106', '16', '449');
INSERT INTO public.who_global_data_import VALUES (68970, '2020-06-20', 'MD', 'Republic of Moldova', 'EURO', '450', '13556', '9', '458');
INSERT INTO public.who_global_data_import VALUES (68971, '2020-06-21', 'MD', 'Republic of Moldova', 'EURO', '397', '13953', '6', '464');
INSERT INTO public.who_global_data_import VALUES (68972, '2020-06-22', 'MD', 'Republic of Moldova', 'EURO', '247', '14200', '11', '475');
INSERT INTO public.who_global_data_import VALUES (68973, '2020-06-23', 'MD', 'Republic of Moldova', 'EURO', '163', '14363', '9', '484');
INSERT INTO public.who_global_data_import VALUES (68974, '2020-06-24', 'MD', 'Republic of Moldova', 'EURO', '351', '14714', '8', '492');
INSERT INTO public.who_global_data_import VALUES (68975, '2020-06-25', 'MD', 'Republic of Moldova', 'EURO', '364', '15078', '10', '502');
INSERT INTO public.who_global_data_import VALUES (68976, '2020-06-26', 'MD', 'Republic of Moldova', 'EURO', '375', '15453', '0', '502');
INSERT INTO public.who_global_data_import VALUES (68977, '2020-06-27', 'MD', 'Republic of Moldova', 'EURO', '323', '15776', '13', '515');
INSERT INTO public.who_global_data_import VALUES (68978, '2020-06-28', 'MD', 'Republic of Moldova', 'EURO', '304', '16080', '11', '526');
INSERT INTO public.who_global_data_import VALUES (68979, '2020-06-29', 'MD', 'Republic of Moldova', 'EURO', '170', '16250', '7', '533');
INSERT INTO public.who_global_data_import VALUES (68980, '2020-06-30', 'MD', 'Republic of Moldova', 'EURO', '107', '16357', '8', '541');
INSERT INTO public.who_global_data_import VALUES (68981, '2020-07-01', 'MD', 'Republic of Moldova', 'EURO', '256', '16613', '6', '547');
INSERT INTO public.who_global_data_import VALUES (68982, '2020-07-02', 'MD', 'Republic of Moldova', 'EURO', '285', '16898', '2', '549');
INSERT INTO public.who_global_data_import VALUES (68983, '2020-07-03', 'MD', 'Republic of Moldova', 'EURO', '252', '17150', '14', '563');
INSERT INTO public.who_global_data_import VALUES (68984, '2020-07-04', 'MD', 'Republic of Moldova', 'EURO', '295', '17445', '13', '576');
INSERT INTO public.who_global_data_import VALUES (68985, '2020-07-05', 'MD', 'Republic of Moldova', 'EURO', '227', '17672', '6', '582');
INSERT INTO public.who_global_data_import VALUES (68986, '2020-07-06', 'MD', 'Republic of Moldova', 'EURO', '142', '17814', '6', '588');
INSERT INTO public.who_global_data_import VALUES (68987, '2020-07-07', 'MD', 'Republic of Moldova', 'EURO', '92', '17906', '10', '598');
INSERT INTO public.who_global_data_import VALUES (68988, '2020-07-08', 'MD', 'Republic of Moldova', 'EURO', '235', '18141', '6', '604');
INSERT INTO public.who_global_data_import VALUES (68989, '2020-07-09', 'MD', 'Republic of Moldova', 'EURO', '330', '18471', '10', '614');
INSERT INTO public.who_global_data_import VALUES (68990, '2020-07-10', 'MD', 'Republic of Moldova', 'EURO', '195', '18666', '13', '627');
INSERT INTO public.who_global_data_import VALUES (68991, '2020-07-11', 'MD', 'Republic of Moldova', 'EURO', '258', '18924', '8', '635');
INSERT INTO public.who_global_data_import VALUES (68992, '2020-07-12', 'MD', 'Republic of Moldova', 'EURO', '284', '19208', '5', '640');
INSERT INTO public.who_global_data_import VALUES (68993, '2020-07-13', 'MD', 'Republic of Moldova', 'EURO', '174', '19382', '2', '642');
INSERT INTO public.who_global_data_import VALUES (68994, '2020-07-14', 'MD', 'Republic of Moldova', 'EURO', '57', '19439', '10', '652');
INSERT INTO public.who_global_data_import VALUES (68995, '2020-07-15', 'MD', 'Republic of Moldova', 'EURO', '269', '19708', '6', '658');
INSERT INTO public.who_global_data_import VALUES (68996, '2020-07-16', 'MD', 'Republic of Moldova', 'EURO', '332', '20040', '4', '662');
INSERT INTO public.who_global_data_import VALUES (68997, '2020-07-17', 'MD', 'Republic of Moldova', 'EURO', '224', '20264', '4', '666');
INSERT INTO public.who_global_data_import VALUES (68998, '2020-07-18', 'MD', 'Republic of Moldova', 'EURO', '230', '20494', '9', '675');
INSERT INTO public.who_global_data_import VALUES (68999, '2020-07-19', 'MD', 'Republic of Moldova', 'EURO', '300', '20794', '5', '680');
INSERT INTO public.who_global_data_import VALUES (69000, '2020-07-20', 'MD', 'Republic of Moldova', 'EURO', '186', '20980', '8', '688');
INSERT INTO public.who_global_data_import VALUES (69001, '2020-07-21', 'MD', 'Republic of Moldova', 'EURO', '135', '21115', '9', '697');
INSERT INTO public.who_global_data_import VALUES (69002, '2020-07-22', 'MD', 'Republic of Moldova', 'EURO', '327', '21442', '11', '708');
INSERT INTO public.who_global_data_import VALUES (69612, '2020-01-14', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69003, '2020-07-23', 'MD', 'Republic of Moldova', 'EURO', '356', '21798', '5', '713');
INSERT INTO public.who_global_data_import VALUES (69004, '2020-07-24', 'MD', 'Republic of Moldova', 'EURO', '307', '22105', '8', '721');
INSERT INTO public.who_global_data_import VALUES (69005, '2020-07-25', 'MD', 'Republic of Moldova', 'EURO', '378', '22483', '5', '726');
INSERT INTO public.who_global_data_import VALUES (69006, '2020-07-26', 'MD', 'Republic of Moldova', 'EURO', '345', '22828', '7', '733');
INSERT INTO public.who_global_data_import VALUES (69007, '2020-07-27', 'MD', 'Republic of Moldova', 'EURO', '206', '23034', '7', '740');
INSERT INTO public.who_global_data_import VALUES (69008, '2020-07-28', 'MD', 'Republic of Moldova', 'EURO', '120', '23154', '11', '751');
INSERT INTO public.who_global_data_import VALUES (69009, '2020-07-29', 'MD', 'Republic of Moldova', 'EURO', '367', '23521', '6', '757');
INSERT INTO public.who_global_data_import VALUES (69010, '2020-07-30', 'MD', 'Republic of Moldova', 'EURO', '426', '23947', '5', '762');
INSERT INTO public.who_global_data_import VALUES (69011, '2020-07-31', 'MD', 'Republic of Moldova', 'EURO', '396', '24343', '9', '771');
INSERT INTO public.who_global_data_import VALUES (69012, '2020-08-01', 'MD', 'Republic of Moldova', 'EURO', '390', '24733', '7', '778');
INSERT INTO public.who_global_data_import VALUES (69013, '2020-08-02', 'MD', 'Republic of Moldova', 'EURO', '380', '25113', '11', '789');
INSERT INTO public.who_global_data_import VALUES (69014, '2020-08-03', 'MD', 'Republic of Moldova', 'EURO', '249', '25362', '3', '792');
INSERT INTO public.who_global_data_import VALUES (69015, '2020-08-04', 'MD', 'Republic of Moldova', 'EURO', '120', '25482', '8', '800');
INSERT INTO public.who_global_data_import VALUES (69016, '2020-08-05', 'MD', 'Republic of Moldova', 'EURO', '332', '25814', '10', '810');
INSERT INTO public.who_global_data_import VALUES (69017, '2020-08-06', 'MD', 'Republic of Moldova', 'EURO', '408', '26222', '13', '823');
INSERT INTO public.who_global_data_import VALUES (69018, '2020-08-07', 'MD', 'Republic of Moldova', 'EURO', '406', '26628', '5', '828');
INSERT INTO public.who_global_data_import VALUES (69019, '2020-08-08', 'MD', 'Republic of Moldova', 'EURO', '362', '26990', '7', '835');
INSERT INTO public.who_global_data_import VALUES (69020, '2020-08-09', 'MD', 'Republic of Moldova', 'EURO', '453', '27443', '6', '841');
INSERT INTO public.who_global_data_import VALUES (69021, '2020-08-10', 'MD', 'Republic of Moldova', 'EURO', '217', '27660', '4', '845');
INSERT INTO public.who_global_data_import VALUES (69022, '2020-08-11', 'MD', 'Republic of Moldova', 'EURO', '181', '27841', '5', '850');
INSERT INTO public.who_global_data_import VALUES (69023, '2020-08-12', 'MD', 'Republic of Moldova', 'EURO', '382', '28223', '7', '857');
INSERT INTO public.who_global_data_import VALUES (69024, '2020-08-13', 'MD', 'Republic of Moldova', 'EURO', '474', '28697', '6', '863');
INSERT INTO public.who_global_data_import VALUES (69025, '2020-08-14', 'MD', 'Republic of Moldova', 'EURO', '390', '29087', '15', '878');
INSERT INTO public.who_global_data_import VALUES (69026, '2020-08-15', 'MD', 'Republic of Moldova', 'EURO', '396', '29483', '6', '884');
INSERT INTO public.who_global_data_import VALUES (69027, '2020-08-16', 'MD', 'Republic of Moldova', 'EURO', '422', '29905', '11', '895');
INSERT INTO public.who_global_data_import VALUES (69028, '2020-08-17', 'MD', 'Republic of Moldova', 'EURO', '278', '30183', '1', '896');
INSERT INTO public.who_global_data_import VALUES (69029, '2020-08-18', 'MD', 'Republic of Moldova', 'EURO', '194', '30377', '12', '908');
INSERT INTO public.who_global_data_import VALUES (69030, '2020-08-19', 'MD', 'Republic of Moldova', 'EURO', '412', '30789', '0', '908');
INSERT INTO public.who_global_data_import VALUES (69031, '2020-08-20', 'MD', 'Republic of Moldova', 'EURO', '626', '31415', '6', '914');
INSERT INTO public.who_global_data_import VALUES (69032, '2020-08-21', 'MD', 'Republic of Moldova', 'EURO', '522', '31937', '7', '921');
INSERT INTO public.who_global_data_import VALUES (69033, '2020-08-22', 'MD', 'Republic of Moldova', 'EURO', '547', '32484', '8', '929');
INSERT INTO public.who_global_data_import VALUES (69034, '2020-08-23', 'MD', 'Republic of Moldova', 'EURO', '588', '33072', '6', '935');
INSERT INTO public.who_global_data_import VALUES (69035, '2020-08-24', 'MD', 'Republic of Moldova', 'EURO', '406', '33478', '5', '940');
INSERT INTO public.who_global_data_import VALUES (69036, '2020-08-25', 'MD', 'Republic of Moldova', 'EURO', '350', '33828', '5', '945');
INSERT INTO public.who_global_data_import VALUES (69037, '2020-08-26', 'MD', 'Republic of Moldova', 'EURO', '530', '34358', '15', '960');
INSERT INTO public.who_global_data_import VALUES (69038, '2020-08-27', 'MD', 'Republic of Moldova', 'EURO', '624', '34982', '7', '967');
INSERT INTO public.who_global_data_import VALUES (69039, '2020-08-28', 'MD', 'Republic of Moldova', 'EURO', '564', '35546', '10', '977');
INSERT INTO public.who_global_data_import VALUES (69040, '2020-08-29', 'MD', 'Republic of Moldova', 'EURO', '358', '35904', '4', '981');
INSERT INTO public.who_global_data_import VALUES (69041, '2020-08-30', 'MD', 'Republic of Moldova', 'EURO', '500', '36404', '9', '990');
INSERT INTO public.who_global_data_import VALUES (69042, '2020-08-31', 'MD', 'Republic of Moldova', 'EURO', '296', '36700', '2', '992');
INSERT INTO public.who_global_data_import VALUES (69043, '2020-09-01', 'MD', 'Republic of Moldova', 'EURO', '220', '36920', '3', '995');
INSERT INTO public.who_global_data_import VALUES (69044, '2020-09-02', 'MD', 'Republic of Moldova', 'EURO', '288', '37208', '13', '1008');
INSERT INTO public.who_global_data_import VALUES (69045, '2020-09-03', 'MD', 'Republic of Moldova', 'EURO', '532', '37740', '16', '1024');
INSERT INTO public.who_global_data_import VALUES (69046, '2020-09-04', 'MD', 'Republic of Moldova', 'EURO', '632', '38372', '12', '1036');
INSERT INTO public.who_global_data_import VALUES (69047, '2020-09-05', 'MD', 'Republic of Moldova', 'EURO', '534', '38906', '11', '1047');
INSERT INTO public.who_global_data_import VALUES (69048, '2020-09-06', 'MD', 'Republic of Moldova', 'EURO', '567', '39473', '16', '1063');
INSERT INTO public.who_global_data_import VALUES (69049, '2020-09-07', 'MD', 'Republic of Moldova', 'EURO', '324', '39797', '0', '1063');
INSERT INTO public.who_global_data_import VALUES (69050, '2020-09-08', 'MD', 'Republic of Moldova', 'EURO', '258', '40055', '11', '1074');
INSERT INTO public.who_global_data_import VALUES (69051, '2020-09-09', 'MD', 'Republic of Moldova', 'EURO', '501', '40556', '13', '1087');
INSERT INTO public.who_global_data_import VALUES (69052, '2020-09-10', 'MD', 'Republic of Moldova', 'EURO', '588', '41144', '9', '1096');
INSERT INTO public.who_global_data_import VALUES (69053, '2020-09-11', 'MD', 'Republic of Moldova', 'EURO', '560', '41704', '10', '1106');
INSERT INTO public.who_global_data_import VALUES (69054, '2020-09-12', 'MD', 'Republic of Moldova', 'EURO', '479', '42183', '8', '1114');
INSERT INTO public.who_global_data_import VALUES (69055, '2020-09-13', 'MD', 'Republic of Moldova', 'EURO', '531', '42714', '4', '1118');
INSERT INTO public.who_global_data_import VALUES (69056, '2020-09-14', 'MD', 'Republic of Moldova', 'EURO', '264', '42978', '5', '1123');
INSERT INTO public.who_global_data_import VALUES (69057, '2020-09-15', 'MD', 'Republic of Moldova', 'EURO', '229', '43207', '7', '1130');
INSERT INTO public.who_global_data_import VALUES (69058, '2020-09-16', 'MD', 'Republic of Moldova', 'EURO', '527', '43734', '14', '1144');
INSERT INTO public.who_global_data_import VALUES (69059, '2020-09-17', 'MD', 'Republic of Moldova', 'EURO', '627', '44361', '15', '1159');
INSERT INTO public.who_global_data_import VALUES (69060, '2020-09-18', 'MD', 'Republic of Moldova', 'EURO', '622', '44983', '11', '1170');
INSERT INTO public.who_global_data_import VALUES (69061, '2020-09-19', 'MD', 'Republic of Moldova', 'EURO', '665', '45648', '16', '1186');
INSERT INTO public.who_global_data_import VALUES (69062, '2020-09-20', 'MD', 'Republic of Moldova', 'EURO', '688', '46336', '15', '1201');
INSERT INTO public.who_global_data_import VALUES (69063, '2020-09-21', 'MD', 'Republic of Moldova', 'EURO', '260', '46596', '2', '1203');
INSERT INTO public.who_global_data_import VALUES (69064, '2020-09-22', 'MD', 'Republic of Moldova', 'EURO', '200', '46796', '8', '1211');
INSERT INTO public.who_global_data_import VALUES (69065, '2020-09-23', 'MD', 'Republic of Moldova', 'EURO', '650', '47446', '19', '1230');
INSERT INTO public.who_global_data_import VALUES (69066, '2020-09-24', 'MD', 'Republic of Moldova', 'EURO', '786', '48232', '14', '1244');
INSERT INTO public.who_global_data_import VALUES (69067, '2020-09-25', 'MD', 'Republic of Moldova', 'EURO', '721', '48953', '8', '1252');
INSERT INTO public.who_global_data_import VALUES (69068, '2020-09-26', 'MD', 'Republic of Moldova', 'EURO', '713', '49666', '12', '1264');
INSERT INTO public.who_global_data_import VALUES (69069, '2020-09-27', 'MD', 'Republic of Moldova', 'EURO', '868', '50534', '15', '1279');
INSERT INTO public.who_global_data_import VALUES (69070, '2020-09-28', 'MD', 'Republic of Moldova', 'EURO', '341', '50875', '8', '1287');
INSERT INTO public.who_global_data_import VALUES (69071, '2020-09-29', 'MD', 'Republic of Moldova', 'EURO', '319', '51194', '14', '1301');
INSERT INTO public.who_global_data_import VALUES (69072, '2020-09-30', 'MD', 'Republic of Moldova', 'EURO', '835', '52029', '9', '1310');
INSERT INTO public.who_global_data_import VALUES (69073, '2020-10-01', 'MD', 'Republic of Moldova', 'EURO', '1013', '53042', '10', '1320');
INSERT INTO public.who_global_data_import VALUES (69074, '2020-10-02', 'MD', 'Republic of Moldova', 'EURO', '1022', '54064', '16', '1336');
INSERT INTO public.who_global_data_import VALUES (69075, '2020-10-03', 'MD', 'Republic of Moldova', 'EURO', '952', '55016', '8', '1344');
INSERT INTO public.who_global_data_import VALUES (69076, '2020-10-04', 'MD', 'Republic of Moldova', 'EURO', '872', '55888', '9', '1353');
INSERT INTO public.who_global_data_import VALUES (69077, '2020-10-05', 'MD', 'Republic of Moldova', 'EURO', '691', '56579', '13', '1366');
INSERT INTO public.who_global_data_import VALUES (69078, '2020-10-06', 'MD', 'Republic of Moldova', 'EURO', '322', '56901', '9', '1375');
INSERT INTO public.who_global_data_import VALUES (69079, '2020-10-07', 'MD', 'Republic of Moldova', 'EURO', '831', '57732', '14', '1389');
INSERT INTO public.who_global_data_import VALUES (69080, '2020-10-08', 'MD', 'Republic of Moldova', 'EURO', '1062', '58794', '17', '1406');
INSERT INTO public.who_global_data_import VALUES (69081, '2020-10-09', 'MD', 'Republic of Moldova', 'EURO', '1121', '59915', '18', '1424');
INSERT INTO public.who_global_data_import VALUES (69082, '2020-10-10', 'MD', 'Republic of Moldova', 'EURO', '918', '60833', '18', '1442');
INSERT INTO public.who_global_data_import VALUES (69083, '2020-10-11', 'MD', 'Republic of Moldova', 'EURO', '929', '61762', '16', '1458');
INSERT INTO public.who_global_data_import VALUES (69084, '2020-10-12', 'MD', 'Republic of Moldova', 'EURO', '389', '62151', '3', '1461');
INSERT INTO public.who_global_data_import VALUES (69085, '2020-10-13', 'MD', 'Republic of Moldova', 'EURO', '467', '62618', '17', '1478');
INSERT INTO public.who_global_data_import VALUES (69086, '2020-10-14', 'MD', 'Republic of Moldova', 'EURO', '657', '63275', '17', '1495');
INSERT INTO public.who_global_data_import VALUES (69087, '2020-10-15', 'MD', 'Republic of Moldova', 'EURO', '1149', '64424', '19', '1514');
INSERT INTO public.who_global_data_import VALUES (69088, '2020-10-16', 'MD', 'Republic of Moldova', 'EURO', '652', '65076', '16', '1530');
INSERT INTO public.who_global_data_import VALUES (69089, '2020-10-17', 'MD', 'Republic of Moldova', 'EURO', '784', '65860', '19', '1549');
INSERT INTO public.who_global_data_import VALUES (69090, '2020-10-18', 'MD', 'Republic of Moldova', 'EURO', '792', '66652', '20', '1569');
INSERT INTO public.who_global_data_import VALUES (69613, '2020-01-15', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69091, '2020-10-19', 'MD', 'Republic of Moldova', 'EURO', '398', '67050', '15', '1584');
INSERT INTO public.who_global_data_import VALUES (69092, '2020-10-20', 'MD', 'Republic of Moldova', 'EURO', '252', '67302', '17', '1601');
INSERT INTO public.who_global_data_import VALUES (69093, '2020-10-21', 'MD', 'Republic of Moldova', 'EURO', '656', '67958', '16', '1617');
INSERT INTO public.who_global_data_import VALUES (69094, '2020-10-22', 'MD', 'Republic of Moldova', 'EURO', '833', '68791', '13', '1630');
INSERT INTO public.who_global_data_import VALUES (69095, '2020-10-23', 'MD', 'Republic of Moldova', 'EURO', '777', '69568', '11', '1641');
INSERT INTO public.who_global_data_import VALUES (69096, '2020-10-24', 'MD', 'Republic of Moldova', 'EURO', '688', '70256', '14', '1655');
INSERT INTO public.who_global_data_import VALUES (69097, '2020-10-25', 'MD', 'Republic of Moldova', 'EURO', '833', '71089', '14', '1669');
INSERT INTO public.who_global_data_import VALUES (69098, '2020-10-26', 'MD', 'Republic of Moldova', 'EURO', '414', '71503', '16', '1685');
INSERT INTO public.who_global_data_import VALUES (69099, '2020-10-27', 'MD', 'Republic of Moldova', 'EURO', '308', '71811', '15', '1700');
INSERT INTO public.who_global_data_import VALUES (69100, '2020-10-28', 'MD', 'Republic of Moldova', 'EURO', '649', '72460', '10', '1710');
INSERT INTO public.who_global_data_import VALUES (69101, '2020-10-29', 'MD', 'Republic of Moldova', 'EURO', '861', '73321', '19', '1729');
INSERT INTO public.who_global_data_import VALUES (69102, '2020-10-30', 'MD', 'Republic of Moldova', 'EURO', '912', '74233', '18', '1747');
INSERT INTO public.who_global_data_import VALUES (69103, '2020-10-31', 'MD', 'Republic of Moldova', 'EURO', '968', '75201', '19', '1766');
INSERT INTO public.who_global_data_import VALUES (69104, '2020-11-01', 'MD', 'Republic of Moldova', 'EURO', '839', '76040', '19', '1785');
INSERT INTO public.who_global_data_import VALUES (69105, '2020-11-02', 'MD', 'Republic of Moldova', 'EURO', '542', '76582', '15', '1800');
INSERT INTO public.who_global_data_import VALUES (69106, '2020-11-03', 'MD', 'Republic of Moldova', 'EURO', '195', '76777', '18', '1818');
INSERT INTO public.who_global_data_import VALUES (69107, '2020-11-04', 'MD', 'Republic of Moldova', 'EURO', '710', '77487', '20', '1838');
INSERT INTO public.who_global_data_import VALUES (69108, '2020-11-05', 'MD', 'Republic of Moldova', 'EURO', '1020', '78507', '13', '1851');
INSERT INTO public.who_global_data_import VALUES (69109, '2020-11-06', 'MD', 'Republic of Moldova', 'EURO', '1059', '79566', '15', '1866');
INSERT INTO public.who_global_data_import VALUES (69110, '2020-11-07', 'MD', 'Republic of Moldova', 'EURO', '935', '80501', '16', '1882');
INSERT INTO public.who_global_data_import VALUES (69111, '2020-11-08', 'MD', 'Republic of Moldova', 'EURO', '1174', '81675', '9', '1891');
INSERT INTO public.who_global_data_import VALUES (69112, '2020-11-09', 'MD', 'Republic of Moldova', 'EURO', '671', '82346', '2', '1893');
INSERT INTO public.who_global_data_import VALUES (69113, '2020-11-10', 'MD', 'Republic of Moldova', 'EURO', '331', '82677', '19', '1912');
INSERT INTO public.who_global_data_import VALUES (69114, '2020-11-11', 'MD', 'Republic of Moldova', 'EURO', '915', '83592', '18', '1930');
INSERT INTO public.who_global_data_import VALUES (69115, '2020-11-12', 'MD', 'Republic of Moldova', 'EURO', '1115', '84707', '20', '1950');
INSERT INTO public.who_global_data_import VALUES (69116, '2020-11-13', 'MD', 'Republic of Moldova', 'EURO', '1331', '86038', '19', '1969');
INSERT INTO public.who_global_data_import VALUES (69117, '2020-11-14', 'MD', 'Republic of Moldova', 'EURO', '1323', '87361', '18', '1987');
INSERT INTO public.who_global_data_import VALUES (69118, '2020-11-15', 'MD', 'Republic of Moldova', 'EURO', '1411', '88772', '19', '2006');
INSERT INTO public.who_global_data_import VALUES (69119, '2020-11-16', 'MD', 'Republic of Moldova', 'EURO', '507', '89279', '13', '2019');
INSERT INTO public.who_global_data_import VALUES (69120, '2020-11-17', 'MD', 'Republic of Moldova', 'EURO', '564', '89843', '16', '2035');
INSERT INTO public.who_global_data_import VALUES (69121, '2020-11-18', 'MD', 'Republic of Moldova', 'EURO', '1069', '90912', '19', '2054');
INSERT INTO public.who_global_data_import VALUES (69122, '2020-11-19', 'MD', 'Republic of Moldova', 'EURO', '1607', '92519', '18', '2072');
INSERT INTO public.who_global_data_import VALUES (69123, '2020-11-20', 'MD', 'Republic of Moldova', 'EURO', '1442', '93961', '19', '2091');
INSERT INTO public.who_global_data_import VALUES (69124, '2020-11-21', 'MD', 'Republic of Moldova', 'EURO', '1422', '95383', '20', '2111');
INSERT INTO public.who_global_data_import VALUES (69125, '2020-11-22', 'MD', 'Republic of Moldova', 'EURO', '1306', '96689', '19', '2130');
INSERT INTO public.who_global_data_import VALUES (69126, '2020-11-23', 'MD', 'Republic of Moldova', 'EURO', '1252', '97941', '19', '2149');
INSERT INTO public.who_global_data_import VALUES (69127, '2020-11-24', 'MD', 'Republic of Moldova', 'EURO', '477', '98418', '20', '2169');
INSERT INTO public.who_global_data_import VALUES (69128, '2020-11-25', 'MD', 'Republic of Moldova', 'EURO', '1215', '99633', '19', '2188');
INSERT INTO public.who_global_data_import VALUES (69129, '2020-11-26', 'MD', 'Republic of Moldova', 'EURO', '1570', '101203', '21', '2209');
INSERT INTO public.who_global_data_import VALUES (69130, '2020-11-27', 'MD', 'Republic of Moldova', 'EURO', '1691', '102894', '20', '2229');
INSERT INTO public.who_global_data_import VALUES (69131, '2020-11-28', 'MD', 'Republic of Moldova', 'EURO', '1246', '104140', '21', '2250');
INSERT INTO public.who_global_data_import VALUES (69132, '2020-11-29', 'MD', 'Republic of Moldova', 'EURO', '1712', '105852', '19', '2269');
INSERT INTO public.who_global_data_import VALUES (69133, '2020-11-30', 'MD', 'Republic of Moldova', 'EURO', '1165', '107017', '21', '2290');
INSERT INTO public.who_global_data_import VALUES (69134, '2020-12-01', 'MD', 'Republic of Moldova', 'EURO', '347', '107364', '14', '2304');
INSERT INTO public.who_global_data_import VALUES (69135, '2020-12-02', 'MD', 'Republic of Moldova', 'EURO', '1499', '108863', '19', '2323');
INSERT INTO public.who_global_data_import VALUES (69136, '2020-12-03', 'MD', 'Republic of Moldova', 'EURO', '1717', '110580', '20', '2343');
INSERT INTO public.who_global_data_import VALUES (69137, '2020-12-04', 'MD', 'Republic of Moldova', 'EURO', '1727', '112307', '20', '2363');
INSERT INTO public.who_global_data_import VALUES (69138, '2020-12-05', 'MD', 'Republic of Moldova', 'EURO', '1522', '113829', '21', '2384');
INSERT INTO public.who_global_data_import VALUES (69139, '2020-12-06', 'MD', 'Republic of Moldova', 'EURO', '1728', '115557', '19', '2403');
INSERT INTO public.who_global_data_import VALUES (69140, '2020-12-07', 'MD', 'Republic of Moldova', 'EURO', '1078', '116635', '16', '2419');
INSERT INTO public.who_global_data_import VALUES (69141, '2020-12-08', 'MD', 'Republic of Moldova', 'EURO', '860', '117495', '19', '2438');
INSERT INTO public.who_global_data_import VALUES (69142, '2020-12-09', 'MD', 'Republic of Moldova', 'EURO', '1709', '119204', '22', '2460');
INSERT INTO public.who_global_data_import VALUES (69143, '2020-12-10', 'MD', 'Republic of Moldova', 'EURO', '1766', '120970', '21', '2481');
INSERT INTO public.who_global_data_import VALUES (69144, '2020-12-11', 'MD', 'Republic of Moldova', 'EURO', '1715', '122685', '19', '2500');
INSERT INTO public.who_global_data_import VALUES (69145, '2020-12-12', 'MD', 'Republic of Moldova', 'EURO', '1579', '124264', '21', '2521');
INSERT INTO public.who_global_data_import VALUES (69146, '2020-12-13', 'MD', 'Republic of Moldova', 'EURO', '1459', '125723', '26', '2547');
INSERT INTO public.who_global_data_import VALUES (69147, '2020-12-14', 'MD', 'Republic of Moldova', 'EURO', '795', '126518', '25', '2572');
INSERT INTO public.who_global_data_import VALUES (69148, '2020-12-15', 'MD', 'Republic of Moldova', 'EURO', '735', '127253', '26', '2598');
INSERT INTO public.who_global_data_import VALUES (69149, '2020-12-16', 'MD', 'Republic of Moldova', 'EURO', '1403', '128656', '27', '2625');
INSERT INTO public.who_global_data_import VALUES (69150, '2020-12-17', 'MD', 'Republic of Moldova', 'EURO', '1673', '130329', '25', '2650');
INSERT INTO public.who_global_data_import VALUES (69151, '2020-12-18', 'MD', 'Republic of Moldova', 'EURO', '1590', '131919', '24', '2674');
INSERT INTO public.who_global_data_import VALUES (69152, '2020-12-19', 'MD', 'Republic of Moldova', 'EURO', '1441', '133360', '26', '2700');
INSERT INTO public.who_global_data_import VALUES (69153, '2020-12-20', 'MD', 'Republic of Moldova', 'EURO', '1218', '134578', '27', '2727');
INSERT INTO public.who_global_data_import VALUES (69154, '2020-12-21', 'MD', 'Republic of Moldova', 'EURO', '629', '135207', '25', '2752');
INSERT INTO public.who_global_data_import VALUES (69155, '2020-12-22', 'MD', 'Republic of Moldova', 'EURO', '703', '135910', '26', '2778');
INSERT INTO public.who_global_data_import VALUES (69156, '2020-12-23', 'MD', 'Republic of Moldova', 'EURO', '1021', '136931', '25', '2803');
INSERT INTO public.who_global_data_import VALUES (69157, '2020-12-24', 'MD', 'Republic of Moldova', 'EURO', '1282', '138213', '22', '2825');
INSERT INTO public.who_global_data_import VALUES (69158, '2020-12-25', 'MD', 'Republic of Moldova', 'EURO', '1222', '139435', '23', '2848');
INSERT INTO public.who_global_data_import VALUES (69159, '2020-12-26', 'MD', 'Republic of Moldova', 'EURO', '815', '140250', '23', '2871');
INSERT INTO public.who_global_data_import VALUES (69160, '2020-12-27', 'MD', 'Republic of Moldova', 'EURO', '746', '140996', '12', '2883');
INSERT INTO public.who_global_data_import VALUES (69161, '2020-12-28', 'MD', 'Republic of Moldova', 'EURO', '359', '141355', '8', '2891');
INSERT INTO public.who_global_data_import VALUES (69162, '2020-12-29', 'MD', 'Republic of Moldova', 'EURO', '569', '141924', '18', '2909');
INSERT INTO public.who_global_data_import VALUES (69163, '2020-12-30', 'MD', 'Republic of Moldova', 'EURO', '927', '142851', '25', '2934');
INSERT INTO public.who_global_data_import VALUES (69164, '2020-12-31', 'MD', 'Republic of Moldova', 'EURO', '990', '143841', '25', '2959');
INSERT INTO public.who_global_data_import VALUES (69165, '2021-01-01', 'MD', 'Republic of Moldova', 'EURO', '977', '144818', '26', '2985');
INSERT INTO public.who_global_data_import VALUES (69166, '2021-01-02', 'MD', 'Republic of Moldova', 'EURO', '440', '145258', '19', '3004');
INSERT INTO public.who_global_data_import VALUES (69167, '2021-01-03', 'MD', 'Republic of Moldova', 'EURO', '436', '145694', '16', '3020');
INSERT INTO public.who_global_data_import VALUES (69168, '2021-01-04', 'MD', 'Republic of Moldova', 'EURO', '179', '145873', '17', '3037');
INSERT INTO public.who_global_data_import VALUES (69169, '2021-01-05', 'MD', 'Republic of Moldova', 'EURO', '436', '146309', '17', '3054');
INSERT INTO public.who_global_data_import VALUES (69170, '2021-01-06', 'MD', 'Republic of Moldova', 'EURO', '612', '146921', '16', '3070');
INSERT INTO public.who_global_data_import VALUES (69171, '2021-01-07', 'MD', 'Republic of Moldova', 'EURO', '950', '147871', '18', '3088');
INSERT INTO public.who_global_data_import VALUES (69172, '2021-01-08', 'MD', 'Republic of Moldova', 'EURO', '423', '148294', '18', '3106');
INSERT INTO public.who_global_data_import VALUES (69173, '2021-01-09', 'MD', 'Republic of Moldova', 'EURO', '375', '148669', '16', '3122');
INSERT INTO public.who_global_data_import VALUES (69174, '2021-01-10', 'MD', 'Republic of Moldova', 'EURO', '424', '149093', '8', '3130');
INSERT INTO public.who_global_data_import VALUES (69175, '2021-01-11', 'MD', 'Republic of Moldova', 'EURO', '298', '149391', '9', '3139');
INSERT INTO public.who_global_data_import VALUES (69176, '2021-01-12', 'MD', 'Republic of Moldova', 'EURO', '271', '149662', '17', '3156');
INSERT INTO public.who_global_data_import VALUES (69177, '2021-01-13', 'MD', 'Republic of Moldova', 'EURO', '476', '150138', '20', '3176');
INSERT INTO public.who_global_data_import VALUES (69178, '2021-01-14', 'MD', 'Republic of Moldova', 'EURO', '808', '150946', '17', '3193');
INSERT INTO public.who_global_data_import VALUES (69614, '2020-01-16', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69179, '2021-01-15', 'MD', 'Republic of Moldova', 'EURO', '741', '151687', '18', '3211');
INSERT INTO public.who_global_data_import VALUES (69180, '2021-01-16', 'MD', 'Republic of Moldova', 'EURO', '576', '152263', '17', '3228');
INSERT INTO public.who_global_data_import VALUES (69181, '2021-01-17', 'MD', 'Republic of Moldova', 'EURO', '377', '152640', '17', '3245');
INSERT INTO public.who_global_data_import VALUES (69182, '2021-01-18', 'MD', 'Republic of Moldova', 'EURO', '214', '152854', '5', '3250');
INSERT INTO public.who_global_data_import VALUES (69183, '2021-01-19', 'MD', 'Republic of Moldova', 'EURO', '258', '153112', '17', '3267');
INSERT INTO public.who_global_data_import VALUES (69184, '2021-01-20', 'MD', 'Republic of Moldova', 'EURO', '394', '153506', '15', '3282');
INSERT INTO public.who_global_data_import VALUES (69185, '2021-01-21', 'MD', 'Republic of Moldova', 'EURO', '612', '154118', '17', '3299');
INSERT INTO public.who_global_data_import VALUES (69186, '2021-01-22', 'MD', 'Republic of Moldova', 'EURO', '670', '154788', '16', '3315');
INSERT INTO public.who_global_data_import VALUES (69187, '2021-01-23', 'MD', 'Republic of Moldova', 'EURO', '514', '155302', '17', '3332');
INSERT INTO public.who_global_data_import VALUES (69188, '2021-01-24', 'MD', 'Republic of Moldova', 'EURO', '635', '155937', '15', '3347');
INSERT INTO public.who_global_data_import VALUES (69189, '2021-01-25', 'MD', 'Republic of Moldova', 'EURO', '265', '156202', '14', '3361');
INSERT INTO public.who_global_data_import VALUES (69190, '2021-01-26', 'MD', 'Republic of Moldova', 'EURO', '224', '156426', '7', '3368');
INSERT INTO public.who_global_data_import VALUES (69191, '2021-01-27', 'MD', 'Republic of Moldova', 'EURO', '546', '156972', '13', '3381');
INSERT INTO public.who_global_data_import VALUES (69192, '2021-01-28', 'MD', 'Republic of Moldova', 'EURO', '654', '157626', '15', '3396');
INSERT INTO public.who_global_data_import VALUES (69193, '2021-01-29', 'MD', 'Republic of Moldova', 'EURO', '683', '158309', '17', '3413');
INSERT INTO public.who_global_data_import VALUES (69194, '2021-01-30', 'MD', 'Republic of Moldova', 'EURO', '551', '158860', '11', '3424');
INSERT INTO public.who_global_data_import VALUES (69195, '2021-01-31', 'MD', 'Republic of Moldova', 'EURO', '653', '159513', '10', '3434');
INSERT INTO public.who_global_data_import VALUES (69196, '2021-02-01', 'MD', 'Republic of Moldova', 'EURO', '291', '159804', '4', '3438');
INSERT INTO public.who_global_data_import VALUES (69197, '2021-02-02', 'MD', 'Republic of Moldova', 'EURO', '282', '160086', '8', '3446');
INSERT INTO public.who_global_data_import VALUES (69198, '2021-02-03', 'MD', 'Republic of Moldova', 'EURO', '639', '160725', '16', '3462');
INSERT INTO public.who_global_data_import VALUES (69199, '2021-02-04', 'MD', 'Republic of Moldova', 'EURO', '917', '161642', '18', '3480');
INSERT INTO public.who_global_data_import VALUES (69200, '2021-02-05', 'MD', 'Republic of Moldova', 'EURO', '982', '162624', '17', '3497');
INSERT INTO public.who_global_data_import VALUES (69201, '2020-01-03', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69202, '2020-01-04', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69203, '2020-01-05', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69204, '2020-01-06', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69205, '2020-01-07', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69206, '2020-01-08', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69207, '2020-01-09', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69208, '2020-01-10', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69209, '2020-01-11', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69210, '2020-01-12', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69211, '2020-01-13', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69212, '2020-01-14', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69213, '2020-01-15', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69214, '2020-01-16', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69215, '2020-01-17', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69216, '2020-01-18', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69217, '2020-01-19', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69218, '2020-01-20', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69219, '2020-01-21', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69220, '2020-01-22', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69221, '2020-01-23', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69222, '2020-01-24', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69223, '2020-01-25', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69224, '2020-01-26', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69225, '2020-01-27', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69226, '2020-01-28', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69227, '2020-01-29', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69228, '2020-01-30', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69229, '2020-01-31', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69230, '2020-02-01', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69231, '2020-02-02', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69232, '2020-02-03', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69233, '2020-02-04', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69234, '2020-02-05', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69235, '2020-02-06', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69236, '2020-02-07', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69237, '2020-02-08', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69238, '2020-02-09', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69239, '2020-02-10', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69240, '2020-02-11', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69241, '2020-02-12', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69242, '2020-02-13', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69243, '2020-02-14', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69244, '2020-02-15', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69245, '2020-02-16', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69246, '2020-02-17', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69247, '2020-02-18', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69248, '2020-02-19', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69249, '2020-02-20', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69250, '2020-02-21', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69251, '2020-02-22', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69252, '2020-02-23', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69253, '2020-02-24', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69254, '2020-02-25', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69255, '2020-02-26', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69256, '2020-02-27', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69257, '2020-02-28', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69258, '2020-02-29', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69259, '2020-03-01', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69260, '2020-03-02', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69261, '2020-03-03', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69262, '2020-03-04', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69263, '2020-03-05', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69264, '2020-03-06', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69265, '2020-03-07', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69266, '2020-03-08', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69267, '2020-03-09', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69268, '2020-03-10', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69269, '2020-03-11', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69270, '2020-03-12', 'RE', 'Réunion', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69271, '2020-03-13', 'RE', 'Réunion', 'AFRO', '7', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69272, '2020-03-14', 'RE', 'Réunion', 'AFRO', '3', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69273, '2020-03-15', 'RE', 'Réunion', 'AFRO', '3', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69274, '2020-03-16', 'RE', 'Réunion', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69275, '2020-03-17', 'RE', 'Réunion', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69276, '2020-03-18', 'RE', 'Réunion', 'AFRO', '3', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69277, '2020-03-19', 'RE', 'Réunion', 'AFRO', '3', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69278, '2020-03-20', 'RE', 'Réunion', 'AFRO', '9', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69279, '2020-03-21', 'RE', 'Réunion', 'AFRO', '19', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69280, '2020-03-22', 'RE', 'Réunion', 'AFRO', '0', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69281, '2020-03-23', 'RE', 'Réunion', 'AFRO', '17', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69282, '2020-03-24', 'RE', 'Réunion', 'AFRO', '7', '71', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69283, '2020-03-25', 'RE', 'Réunion', 'AFRO', '12', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69284, '2020-03-26', 'RE', 'Réunion', 'AFRO', '11', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69285, '2020-03-27', 'RE', 'Réunion', 'AFRO', '41', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69286, '2020-03-28', 'RE', 'Réunion', 'AFRO', '8', '143', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69287, '2020-03-29', 'RE', 'Réunion', 'AFRO', '0', '143', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69288, '2020-03-30', 'RE', 'Réunion', 'AFRO', '64', '207', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69289, '2020-03-31', 'RE', 'Réunion', 'AFRO', '0', '207', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69290, '2020-04-01', 'RE', 'Réunion', 'AFRO', '40', '247', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69291, '2020-04-02', 'RE', 'Réunion', 'AFRO', '34', '281', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69292, '2020-04-03', 'RE', 'Réunion', 'AFRO', '27', '308', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69293, '2020-04-04', 'RE', 'Réunion', 'AFRO', '13', '321', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69294, '2020-04-05', 'RE', 'Réunion', 'AFRO', '13', '334', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69295, '2020-04-06', 'RE', 'Réunion', 'AFRO', '10', '344', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69296, '2020-04-07', 'RE', 'Réunion', 'AFRO', '5', '349', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69297, '2020-04-08', 'RE', 'Réunion', 'AFRO', '9', '358', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69298, '2020-04-09', 'RE', 'Réunion', 'AFRO', '4', '362', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69299, '2020-04-10', 'RE', 'Réunion', 'AFRO', '14', '376', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69300, '2020-04-11', 'RE', 'Réunion', 'AFRO', '6', '382', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69301, '2020-04-12', 'RE', 'Réunion', 'AFRO', '6', '388', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69302, '2020-04-13', 'RE', 'Réunion', 'AFRO', '1', '389', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69303, '2020-04-14', 'RE', 'Réunion', 'AFRO', '1', '390', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69304, '2020-04-15', 'RE', 'Réunion', 'AFRO', '0', '390', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69305, '2020-04-16', 'RE', 'Réunion', 'AFRO', '0', '390', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69306, '2020-04-17', 'RE', 'Réunion', 'AFRO', '4', '394', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69307, '2020-04-18', 'RE', 'Réunion', 'AFRO', '8', '402', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69308, '2020-04-19', 'RE', 'Réunion', 'AFRO', '5', '407', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69309, '2020-04-20', 'RE', 'Réunion', 'AFRO', '1', '408', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69310, '2020-04-21', 'RE', 'Réunion', 'AFRO', '0', '408', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69311, '2020-04-22', 'RE', 'Réunion', 'AFRO', '2', '410', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69312, '2020-04-23', 'RE', 'Réunion', 'AFRO', '0', '410', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69313, '2020-04-24', 'RE', 'Réunion', 'AFRO', '1', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69314, '2020-04-25', 'RE', 'Réunion', 'AFRO', '0', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69315, '2020-04-26', 'RE', 'Réunion', 'AFRO', '0', '411', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69316, '2020-04-27', 'RE', 'Réunion', 'AFRO', '5', '416', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69317, '2020-04-28', 'RE', 'Réunion', 'AFRO', '1', '417', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69318, '2020-04-29', 'RE', 'Réunion', 'AFRO', '0', '417', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69319, '2020-04-30', 'RE', 'Réunion', 'AFRO', '3', '420', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69320, '2020-05-01', 'RE', 'Réunion', 'AFRO', '0', '420', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69321, '2020-05-02', 'RE', 'Réunion', 'AFRO', '0', '420', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69322, '2020-05-03', 'RE', 'Réunion', 'AFRO', '0', '420', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69323, '2020-05-04', 'RE', 'Réunion', 'AFRO', '3', '423', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69324, '2020-05-05', 'RE', 'Réunion', 'AFRO', '1', '424', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69325, '2020-05-06', 'RE', 'Réunion', 'AFRO', '1', '425', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69326, '2020-05-07', 'RE', 'Réunion', 'AFRO', '0', '425', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69327, '2020-05-08', 'RE', 'Réunion', 'AFRO', '2', '427', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69328, '2020-05-09', 'RE', 'Réunion', 'AFRO', '3', '430', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69329, '2020-05-10', 'RE', 'Réunion', 'AFRO', '0', '430', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69330, '2020-05-11', 'RE', 'Réunion', 'AFRO', '6', '436', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69331, '2020-05-12', 'RE', 'Réunion', 'AFRO', '0', '436', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69332, '2020-05-13', 'RE', 'Réunion', 'AFRO', '1', '437', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69333, '2020-05-14', 'RE', 'Réunion', 'AFRO', '2', '439', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69334, '2020-05-15', 'RE', 'Réunion', 'AFRO', '1', '440', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69335, '2020-05-16', 'RE', 'Réunion', 'AFRO', '1', '441', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69336, '2020-05-17', 'RE', 'Réunion', 'AFRO', '2', '443', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69337, '2020-05-18', 'RE', 'Réunion', 'AFRO', '0', '443', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69338, '2020-05-19', 'RE', 'Réunion', 'AFRO', '3', '446', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69339, '2020-05-20', 'RE', 'Réunion', 'AFRO', '0', '446', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69340, '2020-05-21', 'RE', 'Réunion', 'AFRO', '1', '447', '1', '1');
INSERT INTO public.who_global_data_import VALUES (69341, '2020-05-22', 'RE', 'Réunion', 'AFRO', '2', '449', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69342, '2020-05-23', 'RE', 'Réunion', 'AFRO', '0', '449', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69343, '2020-05-24', 'RE', 'Réunion', 'AFRO', '3', '452', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69344, '2020-05-25', 'RE', 'Réunion', 'AFRO', '0', '452', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69345, '2020-05-26', 'RE', 'Réunion', 'AFRO', '4', '456', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69346, '2020-05-27', 'RE', 'Réunion', 'AFRO', '3', '459', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69347, '2020-05-28', 'RE', 'Réunion', 'AFRO', '1', '460', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69348, '2020-05-29', 'RE', 'Réunion', 'AFRO', '5', '465', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69349, '2020-05-30', 'RE', 'Réunion', 'AFRO', '5', '470', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69350, '2020-05-31', 'RE', 'Réunion', 'AFRO', '1', '471', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69351, '2020-06-01', 'RE', 'Réunion', 'AFRO', '0', '471', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69352, '2020-06-02', 'RE', 'Réunion', 'AFRO', '2', '473', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69353, '2020-06-03', 'RE', 'Réunion', 'AFRO', '4', '477', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69354, '2020-06-04', 'RE', 'Réunion', 'AFRO', '1', '478', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69355, '2020-06-05', 'RE', 'Réunion', 'AFRO', '1', '479', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69356, '2020-06-06', 'RE', 'Réunion', 'AFRO', '1', '480', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69357, '2020-06-07', 'RE', 'Réunion', 'AFRO', '0', '480', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69358, '2020-06-08', 'RE', 'Réunion', 'AFRO', '0', '480', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69359, '2020-06-09', 'RE', 'Réunion', 'AFRO', '1', '481', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69360, '2020-06-10', 'RE', 'Réunion', 'AFRO', '0', '481', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69361, '2020-06-11', 'RE', 'Réunion', 'AFRO', '5', '486', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69362, '2020-06-12', 'RE', 'Réunion', 'AFRO', '1', '487', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69363, '2020-06-13', 'RE', 'Réunion', 'AFRO', '1', '488', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69364, '2020-06-14', 'RE', 'Réunion', 'AFRO', '1', '489', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69365, '2020-06-15', 'RE', 'Réunion', 'AFRO', '6', '495', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69366, '2020-06-16', 'RE', 'Réunion', 'AFRO', '1', '496', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69367, '2020-06-17', 'RE', 'Réunion', 'AFRO', '-1', '495', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69368, '2020-06-18', 'RE', 'Réunion', 'AFRO', '2', '497', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69369, '2020-06-19', 'RE', 'Réunion', 'AFRO', '5', '502', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69370, '2020-06-20', 'RE', 'Réunion', 'AFRO', '2', '504', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69371, '2020-06-21', 'RE', 'Réunion', 'AFRO', '1', '505', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69372, '2020-06-22', 'RE', 'Réunion', 'AFRO', '1', '506', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69373, '2020-06-23', 'RE', 'Réunion', 'AFRO', '1', '507', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69374, '2020-06-24', 'RE', 'Réunion', 'AFRO', '0', '507', '0', '1');
INSERT INTO public.who_global_data_import VALUES (69375, '2020-06-25', 'RE', 'Réunion', 'AFRO', '1', '508', '1', '2');
INSERT INTO public.who_global_data_import VALUES (69376, '2020-06-26', 'RE', 'Réunion', 'AFRO', '8', '516', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69377, '2020-06-27', 'RE', 'Réunion', 'AFRO', '1', '517', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69378, '2020-06-28', 'RE', 'Réunion', 'AFRO', '3', '520', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69379, '2020-06-29', 'RE', 'Réunion', 'AFRO', '1', '521', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69380, '2020-06-30', 'RE', 'Réunion', 'AFRO', '1', '522', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69381, '2020-07-01', 'RE', 'Réunion', 'AFRO', '4', '526', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69382, '2020-07-02', 'RE', 'Réunion', 'AFRO', '2', '528', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69383, '2020-07-03', 'RE', 'Réunion', 'AFRO', '3', '531', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69384, '2020-07-04', 'RE', 'Réunion', 'AFRO', '2', '533', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69385, '2020-07-05', 'RE', 'Réunion', 'AFRO', '3', '536', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69386, '2020-07-06', 'RE', 'Réunion', 'AFRO', '11', '547', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69387, '2020-07-07', 'RE', 'Réunion', 'AFRO', '3', '550', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69388, '2020-07-08', 'RE', 'Réunion', 'AFRO', '1', '551', '1', '3');
INSERT INTO public.who_global_data_import VALUES (69389, '2020-07-09', 'RE', 'Réunion', 'AFRO', '12', '563', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69390, '2020-07-10', 'RE', 'Réunion', 'AFRO', '3', '566', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69391, '2020-07-11', 'RE', 'Réunion', 'AFRO', '5', '571', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69392, '2020-07-12', 'RE', 'Réunion', 'AFRO', '6', '577', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69393, '2020-07-13', 'RE', 'Réunion', 'AFRO', '16', '593', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69394, '2020-07-14', 'RE', 'Réunion', 'AFRO', '3', '596', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69395, '2020-07-15', 'RE', 'Réunion', 'AFRO', '3', '599', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69396, '2020-07-16', 'RE', 'Réunion', 'AFRO', '9', '608', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69397, '2020-07-17', 'RE', 'Réunion', 'AFRO', '6', '614', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69398, '2020-07-18', 'RE', 'Réunion', 'AFRO', '10', '624', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69399, '2020-07-19', 'RE', 'Réunion', 'AFRO', '0', '624', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69400, '2020-07-20', 'RE', 'Réunion', 'AFRO', '4', '628', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69401, '2020-07-21', 'RE', 'Réunion', 'AFRO', '3', '631', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69402, '2020-07-22', 'RE', 'Réunion', 'AFRO', '8', '639', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69403, '2020-07-23', 'RE', 'Réunion', 'AFRO', '6', '645', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69404, '2020-07-24', 'RE', 'Réunion', 'AFRO', '1', '646', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69405, '2020-07-25', 'RE', 'Réunion', 'AFRO', '8', '654', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69406, '2020-07-26', 'RE', 'Réunion', 'AFRO', '3', '657', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69407, '2020-07-27', 'RE', 'Réunion', 'AFRO', '0', '657', '0', '3');
INSERT INTO public.who_global_data_import VALUES (69408, '2020-07-28', 'RE', 'Réunion', 'AFRO', '0', '657', '1', '4');
INSERT INTO public.who_global_data_import VALUES (69409, '2020-07-29', 'RE', 'Réunion', 'AFRO', '0', '657', '0', '4');
INSERT INTO public.who_global_data_import VALUES (69410, '2020-07-30', 'RE', 'Réunion', 'AFRO', '0', '657', '0', '4');
INSERT INTO public.who_global_data_import VALUES (69411, '2020-07-31', 'RE', 'Réunion', 'AFRO', '0', '657', '0', '4');
INSERT INTO public.who_global_data_import VALUES (69412, '2020-08-01', 'RE', 'Réunion', 'AFRO', '3', '660', '0', '4');
INSERT INTO public.who_global_data_import VALUES (69413, '2020-08-02', 'RE', 'Réunion', 'AFRO', '4', '664', '0', '4');
INSERT INTO public.who_global_data_import VALUES (69414, '2020-08-03', 'RE', 'Réunion', 'AFRO', '3', '667', '0', '4');
INSERT INTO public.who_global_data_import VALUES (69415, '2020-08-04', 'RE', 'Réunion', 'AFRO', '0', '667', '0', '4');
INSERT INTO public.who_global_data_import VALUES (69416, '2020-08-05', 'RE', 'Réunion', 'AFRO', '2', '669', '0', '4');
INSERT INTO public.who_global_data_import VALUES (69417, '2020-08-06', 'RE', 'Réunion', 'AFRO', '1', '670', '1', '5');
INSERT INTO public.who_global_data_import VALUES (69418, '2020-08-07', 'RE', 'Réunion', 'AFRO', '1', '671', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69419, '2020-08-08', 'RE', 'Réunion', 'AFRO', '4', '675', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69420, '2020-08-09', 'RE', 'Réunion', 'AFRO', '6', '681', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69421, '2020-08-10', 'RE', 'Réunion', 'AFRO', '6', '687', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69422, '2020-08-11', 'RE', 'Réunion', 'AFRO', '3', '690', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69423, '2020-08-12', 'RE', 'Réunion', 'AFRO', '12', '702', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69424, '2020-08-13', 'RE', 'Réunion', 'AFRO', '32', '734', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69425, '2020-08-14', 'RE', 'Réunion', 'AFRO', '20', '754', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69426, '2020-08-15', 'RE', 'Réunion', 'AFRO', '22', '776', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69427, '2020-08-16', 'RE', 'Réunion', 'AFRO', '12', '788', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69428, '2020-08-17', 'RE', 'Réunion', 'AFRO', '67', '855', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69429, '2020-08-18', 'RE', 'Réunion', 'AFRO', '25', '880', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69430, '2020-08-19', 'RE', 'Réunion', 'AFRO', '23', '903', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69431, '2020-08-20', 'RE', 'Réunion', 'AFRO', '42', '945', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69432, '2020-08-21', 'RE', 'Réunion', 'AFRO', '51', '996', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69433, '2020-08-22', 'RE', 'Réunion', 'AFRO', '79', '1075', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69434, '2020-08-23', 'RE', 'Réunion', 'AFRO', '42', '1117', '1', '6');
INSERT INTO public.who_global_data_import VALUES (69435, '2020-08-24', 'RE', 'Réunion', 'AFRO', '92', '1209', '0', '6');
INSERT INTO public.who_global_data_import VALUES (69436, '2020-08-25', 'RE', 'Réunion', 'AFRO', '35', '1244', '-4', '2');
INSERT INTO public.who_global_data_import VALUES (69437, '2020-08-26', 'RE', 'Réunion', 'AFRO', '48', '1292', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69438, '2020-08-27', 'RE', 'Réunion', 'AFRO', '80', '1372', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69439, '2020-08-28', 'RE', 'Réunion', 'AFRO', '38', '1410', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69440, '2020-08-29', 'RE', 'Réunion', 'AFRO', '77', '1487', '0', '2');
INSERT INTO public.who_global_data_import VALUES (69441, '2020-08-30', 'RE', 'Réunion', 'AFRO', '70', '1557', '1', '3');
INSERT INTO public.who_global_data_import VALUES (69442, '2020-08-31', 'RE', 'Réunion', 'AFRO', '77', '1634', '1', '4');
INSERT INTO public.who_global_data_import VALUES (69443, '2020-09-01', 'RE', 'Réunion', 'AFRO', '45', '1679', '1', '5');
INSERT INTO public.who_global_data_import VALUES (69444, '2020-09-02', 'RE', 'Réunion', 'AFRO', '35', '1714', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69445, '2020-09-03', 'RE', 'Réunion', 'AFRO', '82', '1796', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69446, '2020-09-04', 'RE', 'Réunion', 'AFRO', '116', '1912', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69447, '2020-09-05', 'RE', 'Réunion', 'AFRO', '90', '2002', '0', '5');
INSERT INTO public.who_global_data_import VALUES (69448, '2020-09-06', 'RE', 'Réunion', 'AFRO', '113', '2115', '1', '6');
INSERT INTO public.who_global_data_import VALUES (69449, '2020-09-07', 'RE', 'Réunion', 'AFRO', '107', '2222', '2', '8');
INSERT INTO public.who_global_data_import VALUES (69450, '2020-09-08', 'RE', 'Réunion', 'AFRO', '55', '2277', '0', '8');
INSERT INTO public.who_global_data_import VALUES (69451, '2020-09-09', 'RE', 'Réunion', 'AFRO', '69', '2346', '0', '8');
INSERT INTO public.who_global_data_import VALUES (69452, '2020-09-10', 'RE', 'Réunion', 'AFRO', '70', '2416', '1', '9');
INSERT INTO public.who_global_data_import VALUES (69453, '2020-09-11', 'RE', 'Réunion', 'AFRO', '94', '2510', '0', '9');
INSERT INTO public.who_global_data_import VALUES (69454, '2020-09-12', 'RE', 'Réunion', 'AFRO', '113', '2623', '0', '9');
INSERT INTO public.who_global_data_import VALUES (69455, '2020-09-13', 'RE', 'Réunion', 'AFRO', '100', '2723', '1', '10');
INSERT INTO public.who_global_data_import VALUES (69456, '2020-09-14', 'RE', 'Réunion', 'AFRO', '82', '2805', '0', '10');
INSERT INTO public.who_global_data_import VALUES (69457, '2020-09-15', 'RE', 'Réunion', 'AFRO', '67', '2872', '0', '10');
INSERT INTO public.who_global_data_import VALUES (69458, '2020-09-16', 'RE', 'Réunion', 'AFRO', '30', '2902', '0', '10');
INSERT INTO public.who_global_data_import VALUES (69459, '2020-09-17', 'RE', 'Réunion', 'AFRO', '100', '3002', '0', '10');
INSERT INTO public.who_global_data_import VALUES (69460, '2020-09-18', 'RE', 'Réunion', 'AFRO', '97', '3099', '0', '10');
INSERT INTO public.who_global_data_import VALUES (69461, '2020-09-19', 'RE', 'Réunion', 'AFRO', '95', '3194', '0', '10');
INSERT INTO public.who_global_data_import VALUES (69462, '2020-09-20', 'RE', 'Réunion', 'AFRO', '0', '3194', '0', '10');
INSERT INTO public.who_global_data_import VALUES (69463, '2020-09-21', 'RE', 'Réunion', 'AFRO', '0', '3194', '0', '10');
INSERT INTO public.who_global_data_import VALUES (69464, '2020-09-22', 'RE', 'Réunion', 'AFRO', '221', '3415', '1', '11');
INSERT INTO public.who_global_data_import VALUES (69465, '2020-09-23', 'RE', 'Réunion', 'AFRO', '0', '3415', '0', '11');
INSERT INTO public.who_global_data_import VALUES (69466, '2020-09-24', 'RE', 'Réunion', 'AFRO', '86', '3501', '0', '11');
INSERT INTO public.who_global_data_import VALUES (69467, '2020-09-25', 'RE', 'Réunion', 'AFRO', '0', '3501', '0', '11');
INSERT INTO public.who_global_data_import VALUES (69468, '2020-09-26', 'RE', 'Réunion', 'AFRO', '184', '3685', '0', '11');
INSERT INTO public.who_global_data_import VALUES (69469, '2020-09-27', 'RE', 'Réunion', 'AFRO', '0', '3685', '0', '11');
INSERT INTO public.who_global_data_import VALUES (69470, '2020-09-28', 'RE', 'Réunion', 'AFRO', '0', '3685', '0', '11');
INSERT INTO public.who_global_data_import VALUES (69471, '2020-09-29', 'RE', 'Réunion', 'AFRO', '197', '3882', '3', '14');
INSERT INTO public.who_global_data_import VALUES (69472, '2020-09-30', 'RE', 'Réunion', 'AFRO', '0', '3882', '0', '14');
INSERT INTO public.who_global_data_import VALUES (69473, '2020-10-01', 'RE', 'Réunion', 'AFRO', '111', '3993', '2', '16');
INSERT INTO public.who_global_data_import VALUES (69474, '2020-10-02', 'RE', 'Réunion', 'AFRO', '0', '3993', '0', '16');
INSERT INTO public.who_global_data_import VALUES (69475, '2020-10-03', 'RE', 'Réunion', 'AFRO', '185', '4178', '0', '16');
INSERT INTO public.who_global_data_import VALUES (69476, '2020-10-04', 'RE', 'Réunion', 'AFRO', '0', '4178', '0', '16');
INSERT INTO public.who_global_data_import VALUES (69477, '2020-10-05', 'RE', 'Réunion', 'AFRO', '0', '4178', '0', '16');
INSERT INTO public.who_global_data_import VALUES (69478, '2020-10-06', 'RE', 'Réunion', 'AFRO', '150', '4328', '0', '16');
INSERT INTO public.who_global_data_import VALUES (69479, '2020-10-07', 'RE', 'Réunion', 'AFRO', '0', '4328', '0', '16');
INSERT INTO public.who_global_data_import VALUES (69480, '2020-10-08', 'RE', 'Réunion', 'AFRO', '57', '4385', '0', '16');
INSERT INTO public.who_global_data_import VALUES (69481, '2020-10-09', 'RE', 'Réunion', 'AFRO', '0', '4385', '0', '16');
INSERT INTO public.who_global_data_import VALUES (69482, '2020-10-10', 'RE', 'Réunion', 'AFRO', '106', '4491', '0', '16');
INSERT INTO public.who_global_data_import VALUES (69483, '2020-10-11', 'RE', 'Réunion', 'AFRO', '0', '4491', '0', '16');
INSERT INTO public.who_global_data_import VALUES (69484, '2020-10-12', 'RE', 'Réunion', 'AFRO', '0', '4491', '0', '16');
INSERT INTO public.who_global_data_import VALUES (69485, '2020-10-13', 'RE', 'Réunion', 'AFRO', '133', '4624', '1', '17');
INSERT INTO public.who_global_data_import VALUES (69486, '2020-10-14', 'RE', 'Réunion', 'AFRO', '0', '4624', '0', '17');
INSERT INTO public.who_global_data_import VALUES (69487, '2020-10-15', 'RE', 'Réunion', 'AFRO', '54', '4678', '0', '17');
INSERT INTO public.who_global_data_import VALUES (69488, '2020-10-16', 'RE', 'Réunion', 'AFRO', '0', '4678', '0', '17');
INSERT INTO public.who_global_data_import VALUES (69489, '2020-10-17', 'RE', 'Réunion', 'AFRO', '98', '4776', '0', '17');
INSERT INTO public.who_global_data_import VALUES (69490, '2020-10-18', 'RE', 'Réunion', 'AFRO', '0', '4776', '0', '17');
INSERT INTO public.who_global_data_import VALUES (69491, '2020-10-19', 'RE', 'Réunion', 'AFRO', '0', '4776', '0', '17');
INSERT INTO public.who_global_data_import VALUES (69492, '2020-10-20', 'RE', 'Réunion', 'AFRO', '145', '4921', '0', '17');
INSERT INTO public.who_global_data_import VALUES (69493, '2020-10-21', 'RE', 'Réunion', 'AFRO', '0', '4921', '0', '17');
INSERT INTO public.who_global_data_import VALUES (69494, '2020-10-22', 'RE', 'Réunion', 'AFRO', '94', '5015', '2', '19');
INSERT INTO public.who_global_data_import VALUES (69495, '2020-10-23', 'RE', 'Réunion', 'AFRO', '0', '5015', '0', '19');
INSERT INTO public.who_global_data_import VALUES (69496, '2020-10-24', 'RE', 'Réunion', 'AFRO', '134', '5149', '1', '20');
INSERT INTO public.who_global_data_import VALUES (69497, '2020-10-25', 'RE', 'Réunion', 'AFRO', '0', '5149', '0', '20');
INSERT INTO public.who_global_data_import VALUES (69498, '2020-10-26', 'RE', 'Réunion', 'AFRO', '0', '5149', '0', '20');
INSERT INTO public.who_global_data_import VALUES (69499, '2020-10-27', 'RE', 'Réunion', 'AFRO', '212', '5361', '2', '22');
INSERT INTO public.who_global_data_import VALUES (69500, '2020-10-28', 'RE', 'Réunion', 'AFRO', '0', '5361', '0', '22');
INSERT INTO public.who_global_data_import VALUES (69501, '2020-10-29', 'RE', 'Réunion', 'AFRO', '111', '5472', '0', '22');
INSERT INTO public.who_global_data_import VALUES (69502, '2020-10-30', 'RE', 'Réunion', 'AFRO', '0', '5472', '0', '22');
INSERT INTO public.who_global_data_import VALUES (69503, '2020-10-31', 'RE', 'Réunion', 'AFRO', '187', '5659', '0', '22');
INSERT INTO public.who_global_data_import VALUES (69504, '2020-11-01', 'RE', 'Réunion', 'AFRO', '0', '5659', '0', '22');
INSERT INTO public.who_global_data_import VALUES (69505, '2020-11-02', 'RE', 'Réunion', 'AFRO', '0', '5659', '0', '22');
INSERT INTO public.who_global_data_import VALUES (69506, '2020-11-03', 'RE', 'Réunion', 'AFRO', '239', '5898', '4', '26');
INSERT INTO public.who_global_data_import VALUES (69507, '2020-11-04', 'RE', 'Réunion', 'AFRO', '0', '5898', '0', '26');
INSERT INTO public.who_global_data_import VALUES (69508, '2020-11-05', 'RE', 'Réunion', 'AFRO', '139', '6037', '0', '26');
INSERT INTO public.who_global_data_import VALUES (69509, '2020-11-06', 'RE', 'Réunion', 'AFRO', '0', '6037', '0', '26');
INSERT INTO public.who_global_data_import VALUES (69510, '2020-11-07', 'RE', 'Réunion', 'AFRO', '227', '6264', '1', '27');
INSERT INTO public.who_global_data_import VALUES (69511, '2020-11-08', 'RE', 'Réunion', 'AFRO', '0', '6264', '0', '27');
INSERT INTO public.who_global_data_import VALUES (69512, '2020-11-09', 'RE', 'Réunion', 'AFRO', '0', '6264', '0', '27');
INSERT INTO public.who_global_data_import VALUES (69513, '2020-11-10', 'RE', 'Réunion', 'AFRO', '308', '6572', '1', '28');
INSERT INTO public.who_global_data_import VALUES (69514, '2020-11-11', 'RE', 'Réunion', 'AFRO', '0', '6572', '0', '28');
INSERT INTO public.who_global_data_import VALUES (69515, '2020-11-12', 'RE', 'Réunion', 'AFRO', '163', '6735', '0', '28');
INSERT INTO public.who_global_data_import VALUES (69516, '2020-11-13', 'RE', 'Réunion', 'AFRO', '0', '6735', '0', '28');
INSERT INTO public.who_global_data_import VALUES (69517, '2020-11-14', 'RE', 'Réunion', 'AFRO', '146', '6881', '1', '29');
INSERT INTO public.who_global_data_import VALUES (69518, '2020-11-15', 'RE', 'Réunion', 'AFRO', '0', '6881', '0', '29');
INSERT INTO public.who_global_data_import VALUES (69519, '2020-11-16', 'RE', 'Réunion', 'AFRO', '0', '6881', '0', '29');
INSERT INTO public.who_global_data_import VALUES (69520, '2020-11-17', 'RE', 'Réunion', 'AFRO', '280', '7161', '2', '31');
INSERT INTO public.who_global_data_import VALUES (69521, '2020-11-18', 'RE', 'Réunion', 'AFRO', '0', '7161', '0', '31');
INSERT INTO public.who_global_data_import VALUES (69522, '2020-11-19', 'RE', 'Réunion', 'AFRO', '137', '7298', '3', '34');
INSERT INTO public.who_global_data_import VALUES (69523, '2020-11-20', 'RE', 'Réunion', 'AFRO', '0', '7298', '0', '34');
INSERT INTO public.who_global_data_import VALUES (69524, '2020-11-21', 'RE', 'Réunion', 'AFRO', '203', '7501', '1', '35');
INSERT INTO public.who_global_data_import VALUES (69525, '2020-11-22', 'RE', 'Réunion', 'AFRO', '0', '7501', '0', '35');
INSERT INTO public.who_global_data_import VALUES (69526, '2020-11-23', 'RE', 'Réunion', 'AFRO', '0', '7501', '0', '35');
INSERT INTO public.who_global_data_import VALUES (69527, '2020-11-24', 'RE', 'Réunion', 'AFRO', '188', '7689', '0', '35');
INSERT INTO public.who_global_data_import VALUES (69528, '2020-11-25', 'RE', 'Réunion', 'AFRO', '0', '7689', '0', '35');
INSERT INTO public.who_global_data_import VALUES (69529, '2020-11-26', 'RE', 'Réunion', 'AFRO', '147', '7836', '4', '39');
INSERT INTO public.who_global_data_import VALUES (69530, '2020-11-27', 'RE', 'Réunion', 'AFRO', '0', '7836', '0', '39');
INSERT INTO public.who_global_data_import VALUES (69531, '2020-11-28', 'RE', 'Réunion', 'AFRO', '104', '7940', '1', '40');
INSERT INTO public.who_global_data_import VALUES (69532, '2020-11-29', 'RE', 'Réunion', 'AFRO', '0', '7940', '0', '40');
INSERT INTO public.who_global_data_import VALUES (69533, '2020-11-30', 'RE', 'Réunion', 'AFRO', '114', '8054', '0', '40');
INSERT INTO public.who_global_data_import VALUES (69534, '2020-12-01', 'RE', 'Réunion', 'AFRO', '0', '8054', '0', '40');
INSERT INTO public.who_global_data_import VALUES (69535, '2020-12-02', 'RE', 'Réunion', 'AFRO', '48', '8102', '0', '40');
INSERT INTO public.who_global_data_import VALUES (69536, '2020-12-03', 'RE', 'Réunion', 'AFRO', '0', '8102', '0', '40');
INSERT INTO public.who_global_data_import VALUES (69537, '2020-12-04', 'RE', 'Réunion', 'AFRO', '0', '8102', '0', '40');
INSERT INTO public.who_global_data_import VALUES (69538, '2020-12-05', 'RE', 'Réunion', 'AFRO', '98', '8200', '1', '41');
INSERT INTO public.who_global_data_import VALUES (69539, '2020-12-06', 'RE', 'Réunion', 'AFRO', '0', '8200', '0', '41');
INSERT INTO public.who_global_data_import VALUES (69540, '2020-12-07', 'RE', 'Réunion', 'AFRO', '0', '8200', '0', '41');
INSERT INTO public.who_global_data_import VALUES (69541, '2020-12-08', 'RE', 'Réunion', 'AFRO', '94', '8294', '0', '41');
INSERT INTO public.who_global_data_import VALUES (69542, '2020-12-09', 'RE', 'Réunion', 'AFRO', '0', '8294', '0', '41');
INSERT INTO public.who_global_data_import VALUES (69543, '2020-12-10', 'RE', 'Réunion', 'AFRO', '51', '8345', '0', '41');
INSERT INTO public.who_global_data_import VALUES (69544, '2020-12-11', 'RE', 'Réunion', 'AFRO', '0', '8345', '0', '41');
INSERT INTO public.who_global_data_import VALUES (69545, '2020-12-12', 'RE', 'Réunion', 'AFRO', '0', '8345', '0', '41');
INSERT INTO public.who_global_data_import VALUES (69546, '2020-12-13', 'RE', 'Réunion', 'AFRO', '0', '8345', '0', '41');
INSERT INTO public.who_global_data_import VALUES (69547, '2020-12-14', 'RE', 'Réunion', 'AFRO', '0', '8345', '0', '41');
INSERT INTO public.who_global_data_import VALUES (69548, '2020-12-15', 'RE', 'Réunion', 'AFRO', '189', '8534', '1', '42');
INSERT INTO public.who_global_data_import VALUES (69549, '2020-12-16', 'RE', 'Réunion', 'AFRO', '0', '8534', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69550, '2020-12-17', 'RE', 'Réunion', 'AFRO', '54', '8588', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69551, '2020-12-18', 'RE', 'Réunion', 'AFRO', '0', '8588', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69552, '2020-12-19', 'RE', 'Réunion', 'AFRO', '116', '8704', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69553, '2020-12-20', 'RE', 'Réunion', 'AFRO', '0', '8704', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69554, '2020-12-21', 'RE', 'Réunion', 'AFRO', '0', '8704', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69555, '2020-12-22', 'RE', 'Réunion', 'AFRO', '97', '8801', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69556, '2020-12-23', 'RE', 'Réunion', 'AFRO', '0', '8801', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69557, '2020-12-24', 'RE', 'Réunion', 'AFRO', '45', '8846', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69558, '2020-12-25', 'RE', 'Réunion', 'AFRO', '0', '8846', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69559, '2020-12-26', 'RE', 'Réunion', 'AFRO', '63', '8909', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69560, '2020-12-27', 'RE', 'Réunion', 'AFRO', '0', '8909', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69561, '2020-12-28', 'RE', 'Réunion', 'AFRO', '0', '8909', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69562, '2020-12-29', 'RE', 'Réunion', 'AFRO', '27', '8936', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69563, '2020-12-30', 'RE', 'Réunion', 'AFRO', '36', '8972', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69564, '2020-12-31', 'RE', 'Réunion', 'AFRO', '0', '8972', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69565, '2021-01-01', 'RE', 'Réunion', 'AFRO', '65', '9037', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69566, '2021-01-02', 'RE', 'Réunion', 'AFRO', '0', '9037', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69567, '2021-01-03', 'RE', 'Réunion', 'AFRO', '0', '9037', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69568, '2021-01-04', 'RE', 'Réunion', 'AFRO', '0', '9037', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69569, '2021-01-05', 'RE', 'Réunion', 'AFRO', '81', '9118', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69570, '2021-01-06', 'RE', 'Réunion', 'AFRO', '0', '9118', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69571, '2021-01-07', 'RE', 'Réunion', 'AFRO', '55', '9173', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69572, '2021-01-08', 'RE', 'Réunion', 'AFRO', '0', '9173', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69573, '2021-01-09', 'RE', 'Réunion', 'AFRO', '74', '9247', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69574, '2021-01-10', 'RE', 'Réunion', 'AFRO', '0', '9247', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69575, '2021-01-11', 'RE', 'Réunion', 'AFRO', '112', '9359', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69576, '2021-01-12', 'RE', 'Réunion', 'AFRO', '0', '9359', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69577, '2021-01-13', 'RE', 'Réunion', 'AFRO', '0', '9359', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69578, '2021-01-14', 'RE', 'Réunion', 'AFRO', '47', '9406', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69579, '2021-01-15', 'RE', 'Réunion', 'AFRO', '0', '9406', '0', '42');
INSERT INTO public.who_global_data_import VALUES (69580, '2021-01-16', 'RE', 'Réunion', 'AFRO', '37', '9443', '3', '45');
INSERT INTO public.who_global_data_import VALUES (69581, '2021-01-17', 'RE', 'Réunion', 'AFRO', '0', '9443', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69582, '2021-01-18', 'RE', 'Réunion', 'AFRO', '0', '9443', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69583, '2021-01-19', 'RE', 'Réunion', 'AFRO', '109', '9552', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69584, '2021-01-20', 'RE', 'Réunion', 'AFRO', '0', '9552', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69585, '2021-01-21', 'RE', 'Réunion', 'AFRO', '32', '9584', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69586, '2021-01-22', 'RE', 'Réunion', 'AFRO', '0', '9584', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69587, '2021-01-23', 'RE', 'Réunion', 'AFRO', '117', '9701', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69588, '2021-01-24', 'RE', 'Réunion', 'AFRO', '0', '9701', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69589, '2021-01-25', 'RE', 'Réunion', 'AFRO', '0', '9701', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69590, '2021-01-26', 'RE', 'Réunion', 'AFRO', '142', '9843', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69591, '2021-01-27', 'RE', 'Réunion', 'AFRO', '0', '9843', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69592, '2021-01-28', 'RE', 'Réunion', 'AFRO', '61', '9904', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69593, '2021-01-29', 'RE', 'Réunion', 'AFRO', '0', '9904', '0', '45');
INSERT INTO public.who_global_data_import VALUES (69594, '2021-01-30', 'RE', 'Réunion', 'AFRO', '92', '9996', '1', '46');
INSERT INTO public.who_global_data_import VALUES (69595, '2021-01-31', 'RE', 'Réunion', 'AFRO', '0', '9996', '0', '46');
INSERT INTO public.who_global_data_import VALUES (69596, '2021-02-01', 'RE', 'Réunion', 'AFRO', '0', '9996', '0', '46');
INSERT INTO public.who_global_data_import VALUES (69597, '2021-02-02', 'RE', 'Réunion', 'AFRO', '198', '10194', '0', '46');
INSERT INTO public.who_global_data_import VALUES (69598, '2021-02-03', 'RE', 'Réunion', 'AFRO', '0', '10194', '0', '46');
INSERT INTO public.who_global_data_import VALUES (69599, '2021-02-04', 'RE', 'Réunion', 'AFRO', '136', '10330', '1', '47');
INSERT INTO public.who_global_data_import VALUES (69600, '2021-02-05', 'RE', 'Réunion', 'AFRO', '0', '10330', '0', '47');
INSERT INTO public.who_global_data_import VALUES (69601, '2020-01-03', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69602, '2020-01-04', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69603, '2020-01-05', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69604, '2020-01-06', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69605, '2020-01-07', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69606, '2020-01-08', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69607, '2020-01-09', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69608, '2020-01-10', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69609, '2020-01-11', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69610, '2020-01-12', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69615, '2020-01-17', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69616, '2020-01-18', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69617, '2020-01-19', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69618, '2020-01-20', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69619, '2020-01-21', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69620, '2020-01-22', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69621, '2020-01-23', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69622, '2020-01-24', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69623, '2020-01-25', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69624, '2020-01-26', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69625, '2020-01-27', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69626, '2020-01-28', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69627, '2020-01-29', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69628, '2020-01-30', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69629, '2020-01-31', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69630, '2020-02-01', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69631, '2020-02-02', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69632, '2020-02-03', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69633, '2020-02-04', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69634, '2020-02-05', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69635, '2020-02-06', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69636, '2020-02-07', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69637, '2020-02-08', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69638, '2020-02-09', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69639, '2020-02-10', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69640, '2020-02-11', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69641, '2020-02-12', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69642, '2020-02-13', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69643, '2020-02-14', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69644, '2020-02-15', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69645, '2020-02-16', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69646, '2020-02-17', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69647, '2020-02-18', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69648, '2020-02-19', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69649, '2020-02-20', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69650, '2020-02-21', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69651, '2020-02-22', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69652, '2020-02-23', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69653, '2020-02-24', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69654, '2020-02-25', 'RO', 'Romania', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69655, '2020-02-26', 'RO', 'Romania', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69656, '2020-02-27', 'RO', 'Romania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69657, '2020-02-28', 'RO', 'Romania', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69658, '2020-02-29', 'RO', 'Romania', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69659, '2020-03-01', 'RO', 'Romania', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69660, '2020-03-02', 'RO', 'Romania', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69661, '2020-03-03', 'RO', 'Romania', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69662, '2020-03-04', 'RO', 'Romania', 'EURO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69663, '2020-03-05', 'RO', 'Romania', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69664, '2020-03-06', 'RO', 'Romania', 'EURO', '2', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69665, '2020-03-07', 'RO', 'Romania', 'EURO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69666, '2020-03-08', 'RO', 'Romania', 'EURO', '6', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69667, '2020-03-09', 'RO', 'Romania', 'EURO', '2', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69668, '2020-03-10', 'RO', 'Romania', 'EURO', '2', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69669, '2020-03-11', 'RO', 'Romania', 'EURO', '8', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69670, '2020-03-12', 'RO', 'Romania', 'EURO', '20', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69671, '2020-03-13', 'RO', 'Romania', 'EURO', '19', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69672, '2020-03-14', 'RO', 'Romania', 'EURO', '25', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69673, '2020-03-15', 'RO', 'Romania', 'EURO', '24', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69674, '2020-03-16', 'RO', 'Romania', 'EURO', '26', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69675, '2020-03-17', 'RO', 'Romania', 'EURO', '45', '184', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69676, '2020-03-18', 'RO', 'Romania', 'EURO', '33', '217', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69677, '2020-03-19', 'RO', 'Romania', 'EURO', '43', '260', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69678, '2020-03-20', 'RO', 'Romania', 'EURO', '17', '277', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69679, '2020-03-21', 'RO', 'Romania', 'EURO', '31', '308', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69680, '2020-03-22', 'RO', 'Romania', 'EURO', '59', '367', '0', '0');
INSERT INTO public.who_global_data_import VALUES (69681, '2020-03-23', 'RO', 'Romania', 'EURO', '66', '433', '2', '2');
INSERT INTO public.who_global_data_import VALUES (69682, '2020-03-24', 'RO', 'Romania', 'EURO', '143', '576', '5', '7');
INSERT INTO public.who_global_data_import VALUES (69683, '2020-03-25', 'RO', 'Romania', 'EURO', '186', '762', '4', '11');
INSERT INTO public.who_global_data_import VALUES (69684, '2020-03-26', 'RO', 'Romania', 'EURO', '144', '906', '2', '13');
INSERT INTO public.who_global_data_import VALUES (69685, '2020-03-27', 'RO', 'Romania', 'EURO', '123', '1029', '4', '17');
INSERT INTO public.who_global_data_import VALUES (69686, '2020-03-28', 'RO', 'Romania', 'EURO', '263', '1292', '7', '24');
INSERT INTO public.who_global_data_import VALUES (69687, '2020-03-29', 'RO', 'Romania', 'EURO', '160', '1452', '5', '29');
INSERT INTO public.who_global_data_import VALUES (69688, '2020-03-30', 'RO', 'Romania', 'EURO', '308', '1760', '11', '40');
INSERT INTO public.who_global_data_import VALUES (69689, '2020-03-31', 'RO', 'Romania', 'EURO', '192', '1952', '4', '44');
INSERT INTO public.who_global_data_import VALUES (69690, '2020-04-01', 'RO', 'Romania', 'EURO', '293', '2245', '25', '69');
INSERT INTO public.who_global_data_import VALUES (69691, '2020-04-02', 'RO', 'Romania', 'EURO', '215', '2460', '16', '85');
INSERT INTO public.who_global_data_import VALUES (69692, '2020-04-03', 'RO', 'Romania', 'EURO', '278', '2738', '9', '94');
INSERT INTO public.who_global_data_import VALUES (69693, '2020-04-04', 'RO', 'Romania', 'EURO', '445', '3183', '39', '133');
INSERT INTO public.who_global_data_import VALUES (69694, '2020-04-05', 'RO', 'Romania', 'EURO', '430', '3613', '8', '141');
INSERT INTO public.who_global_data_import VALUES (69695, '2020-04-06', 'RO', 'Romania', 'EURO', '251', '3864', '7', '148');
INSERT INTO public.who_global_data_import VALUES (69696, '2020-04-07', 'RO', 'Romania', 'EURO', '193', '4057', '9', '157');
INSERT INTO public.who_global_data_import VALUES (69697, '2020-04-08', 'RO', 'Romania', 'EURO', '360', '4417', '25', '182');
INSERT INTO public.who_global_data_import VALUES (69698, '2020-04-09', 'RO', 'Romania', 'EURO', '344', '4761', '27', '209');
INSERT INTO public.who_global_data_import VALUES (69699, '2020-04-10', 'RO', 'Romania', 'EURO', '441', '5202', '20', '229');
INSERT INTO public.who_global_data_import VALUES (69700, '2020-04-11', 'RO', 'Romania', 'EURO', '265', '5467', '28', '257');
INSERT INTO public.who_global_data_import VALUES (69701, '2020-04-12', 'RO', 'Romania', 'EURO', '523', '5990', '25', '282');
INSERT INTO public.who_global_data_import VALUES (69702, '2020-04-13', 'RO', 'Romania', 'EURO', '310', '6300', '24', '306');
INSERT INTO public.who_global_data_import VALUES (69703, '2020-04-14', 'RO', 'Romania', 'EURO', '333', '6633', '12', '318');
INSERT INTO public.who_global_data_import VALUES (69704, '2020-04-15', 'RO', 'Romania', 'EURO', '246', '6879', '26', '344');
INSERT INTO public.who_global_data_import VALUES (69705, '2020-04-16', 'RO', 'Romania', 'EURO', '337', '7216', '28', '372');
INSERT INTO public.who_global_data_import VALUES (69706, '2020-04-17', 'RO', 'Romania', 'EURO', '491', '7707', '15', '387');
INSERT INTO public.who_global_data_import VALUES (69707, '2020-04-18', 'RO', 'Romania', 'EURO', '360', '8067', '13', '400');
INSERT INTO public.who_global_data_import VALUES (69708, '2020-04-19', 'RO', 'Romania', 'EURO', '351', '8418', '17', '417');
INSERT INTO public.who_global_data_import VALUES (69709, '2020-04-20', 'RO', 'Romania', 'EURO', '328', '8746', '17', '434');
INSERT INTO public.who_global_data_import VALUES (69710, '2020-04-21', 'RO', 'Romania', 'EURO', '190', '8936', '17', '451');
INSERT INTO public.who_global_data_import VALUES (69711, '2020-04-22', 'RO', 'Romania', 'EURO', '306', '9242', '32', '483');
INSERT INTO public.who_global_data_import VALUES (69712, '2020-04-23', 'RO', 'Romania', 'EURO', '468', '9710', '25', '508');
INSERT INTO public.who_global_data_import VALUES (69713, '2020-04-24', 'RO', 'Romania', 'EURO', '386', '10096', '19', '527');
INSERT INTO public.who_global_data_import VALUES (69714, '2020-04-25', 'RO', 'Romania', 'EURO', '321', '10417', '25', '552');
INSERT INTO public.who_global_data_import VALUES (69715, '2020-04-26', 'RO', 'Romania', 'EURO', '218', '10635', '23', '575');
INSERT INTO public.who_global_data_import VALUES (69716, '2020-04-27', 'RO', 'Romania', 'EURO', '401', '11036', '33', '608');
INSERT INTO public.who_global_data_import VALUES (69717, '2020-04-28', 'RO', 'Romania', 'EURO', '303', '11339', '23', '631');
INSERT INTO public.who_global_data_import VALUES (69718, '2020-04-29', 'RO', 'Romania', 'EURO', '277', '11616', '19', '650');
INSERT INTO public.who_global_data_import VALUES (69719, '2020-04-30', 'RO', 'Romania', 'EURO', '362', '11978', '25', '675');
INSERT INTO public.who_global_data_import VALUES (69720, '2020-05-01', 'RO', 'Romania', 'EURO', '262', '12240', '42', '717');
INSERT INTO public.who_global_data_import VALUES (69721, '2020-05-02', 'RO', 'Romania', 'EURO', '327', '12567', '27', '744');
INSERT INTO public.who_global_data_import VALUES (69722, '2020-05-03', 'RO', 'Romania', 'EURO', '165', '12732', '27', '771');
INSERT INTO public.who_global_data_import VALUES (69723, '2020-05-04', 'RO', 'Romania', 'EURO', '431', '13163', '9', '780');
INSERT INTO public.who_global_data_import VALUES (69724, '2020-05-05', 'RO', 'Romania', 'EURO', '349', '13512', '23', '803');
INSERT INTO public.who_global_data_import VALUES (69725, '2020-05-06', 'RO', 'Romania', 'EURO', '325', '13837', '24', '827');
INSERT INTO public.who_global_data_import VALUES (69726, '2020-05-07', 'RO', 'Romania', 'EURO', '270', '14107', '31', '858');
INSERT INTO public.who_global_data_import VALUES (69727, '2020-05-08', 'RO', 'Romania', 'EURO', '392', '14499', '18', '876');
INSERT INTO public.who_global_data_import VALUES (69728, '2020-05-09', 'RO', 'Romania', 'EURO', '312', '14811', '22', '898');
INSERT INTO public.who_global_data_import VALUES (69729, '2020-05-10', 'RO', 'Romania', 'EURO', '320', '15131', '28', '926');
INSERT INTO public.who_global_data_import VALUES (69730, '2020-05-11', 'RO', 'Romania', 'EURO', '231', '15362', '26', '952');
INSERT INTO public.who_global_data_import VALUES (69731, '2020-05-12', 'RO', 'Romania', 'EURO', '226', '15588', '20', '972');
INSERT INTO public.who_global_data_import VALUES (69732, '2020-05-13', 'RO', 'Romania', 'EURO', '190', '15778', '30', '1002');
INSERT INTO public.who_global_data_import VALUES (69733, '2020-05-14', 'RO', 'Romania', 'EURO', '224', '16002', '14', '1016');
INSERT INTO public.who_global_data_import VALUES (69734, '2020-05-15', 'RO', 'Romania', 'EURO', '245', '16247', '30', '1046');
INSERT INTO public.who_global_data_import VALUES (69735, '2020-05-16', 'RO', 'Romania', 'EURO', '190', '16437', '10', '1056');
INSERT INTO public.who_global_data_import VALUES (69736, '2020-05-17', 'RO', 'Romania', 'EURO', '267', '16704', '25', '1081');
INSERT INTO public.who_global_data_import VALUES (69737, '2020-05-18', 'RO', 'Romania', 'EURO', '167', '16871', '16', '1097');
INSERT INTO public.who_global_data_import VALUES (69738, '2020-05-19', 'RO', 'Romania', 'EURO', '165', '17036', '10', '1107');
INSERT INTO public.who_global_data_import VALUES (69739, '2020-05-20', 'RO', 'Romania', 'EURO', '155', '17191', '19', '1126');
INSERT INTO public.who_global_data_import VALUES (69740, '2020-05-21', 'RO', 'Romania', 'EURO', '196', '17387', '15', '1141');
INSERT INTO public.who_global_data_import VALUES (69741, '2020-05-22', 'RO', 'Romania', 'EURO', '198', '17585', '10', '1151');
INSERT INTO public.who_global_data_import VALUES (69742, '2020-05-23', 'RO', 'Romania', 'EURO', '127', '17712', '8', '1159');
INSERT INTO public.who_global_data_import VALUES (69743, '2020-05-24', 'RO', 'Romania', 'EURO', '145', '17857', '11', '1170');
INSERT INTO public.who_global_data_import VALUES (69744, '2020-05-25', 'RO', 'Romania', 'EURO', '213', '18070', '9', '1179');
INSERT INTO public.who_global_data_import VALUES (69745, '2020-05-26', 'RO', 'Romania', 'EURO', '213', '18283', '18', '1197');
INSERT INTO public.who_global_data_import VALUES (69746, '2020-05-27', 'RO', 'Romania', 'EURO', '146', '18429', '13', '1210');
INSERT INTO public.who_global_data_import VALUES (69747, '2020-05-28', 'RO', 'Romania', 'EURO', '165', '18594', '9', '1219');
INSERT INTO public.who_global_data_import VALUES (69748, '2020-05-29', 'RO', 'Romania', 'EURO', '197', '18791', '10', '1229');
INSERT INTO public.who_global_data_import VALUES (69749, '2020-05-30', 'RO', 'Romania', 'EURO', '191', '18982', '11', '1240');
INSERT INTO public.who_global_data_import VALUES (69750, '2020-05-31', 'RO', 'Romania', 'EURO', '151', '19133', '13', '1253');
INSERT INTO public.who_global_data_import VALUES (69751, '2020-06-01', 'RO', 'Romania', 'EURO', '124', '19257', '9', '1262');
INSERT INTO public.who_global_data_import VALUES (69752, '2020-06-02', 'RO', 'Romania', 'EURO', '141', '19398', '17', '1279');
INSERT INTO public.who_global_data_import VALUES (69753, '2020-06-03', 'RO', 'Romania', 'EURO', '119', '19517', '0', '1279');
INSERT INTO public.who_global_data_import VALUES (69754, '2020-06-04', 'RO', 'Romania', 'EURO', '152', '19669', '9', '1288');
INSERT INTO public.who_global_data_import VALUES (69755, '2020-06-05', 'RO', 'Romania', 'EURO', '238', '19907', '11', '1299');
INSERT INTO public.who_global_data_import VALUES (69756, '2020-06-06', 'RO', 'Romania', 'EURO', '196', '20103', '9', '1308');
INSERT INTO public.who_global_data_import VALUES (69757, '2020-06-07', 'RO', 'Romania', 'EURO', '187', '20290', '10', '1318');
INSERT INTO public.who_global_data_import VALUES (69758, '2020-06-08', 'RO', 'Romania', 'EURO', '189', '20479', '8', '1326');
INSERT INTO public.who_global_data_import VALUES (69759, '2020-06-09', 'RO', 'Romania', 'EURO', '125', '20604', '8', '1334');
INSERT INTO public.who_global_data_import VALUES (69760, '2020-06-10', 'RO', 'Romania', 'EURO', '145', '20749', '11', '1345');
INSERT INTO public.who_global_data_import VALUES (69761, '2020-06-11', 'RO', 'Romania', 'EURO', '196', '20945', '15', '1360');
INSERT INTO public.who_global_data_import VALUES (69762, '2020-06-12', 'RO', 'Romania', 'EURO', '237', '21182', '9', '1369');
INSERT INTO public.who_global_data_import VALUES (69763, '2020-06-13', 'RO', 'Romania', 'EURO', '222', '21404', '11', '1380');
INSERT INTO public.who_global_data_import VALUES (69764, '2020-06-14', 'RO', 'Romania', 'EURO', '275', '21679', '11', '1391');
INSERT INTO public.who_global_data_import VALUES (69765, '2020-06-15', 'RO', 'Romania', 'EURO', '320', '21999', '19', '1410');
INSERT INTO public.who_global_data_import VALUES (69766, '2020-06-16', 'RO', 'Romania', 'EURO', '166', '22165', '17', '1427');
INSERT INTO public.who_global_data_import VALUES (69767, '2020-06-17', 'RO', 'Romania', 'EURO', '250', '22415', '10', '1437');
INSERT INTO public.who_global_data_import VALUES (69768, '2020-06-18', 'RO', 'Romania', 'EURO', '345', '22760', '14', '1451');
INSERT INTO public.who_global_data_import VALUES (69769, '2020-06-19', 'RO', 'Romania', 'EURO', '320', '23080', '22', '1473');
INSERT INTO public.who_global_data_import VALUES (69770, '2020-06-20', 'RO', 'Romania', 'EURO', '320', '23400', '11', '1484');
INSERT INTO public.who_global_data_import VALUES (69771, '2020-06-21', 'RO', 'Romania', 'EURO', '330', '23730', '16', '1500');
INSERT INTO public.who_global_data_import VALUES (69772, '2020-06-22', 'RO', 'Romania', 'EURO', '315', '24045', '12', '1512');
INSERT INTO public.who_global_data_import VALUES (69773, '2020-06-23', 'RO', 'Romania', 'EURO', '246', '24291', '11', '1523');
INSERT INTO public.who_global_data_import VALUES (69774, '2020-06-24', 'RO', 'Romania', 'EURO', '214', '24505', '16', '1539');
INSERT INTO public.who_global_data_import VALUES (69775, '2020-06-25', 'RO', 'Romania', 'EURO', '321', '24826', '16', '1555');
INSERT INTO public.who_global_data_import VALUES (69776, '2020-06-26', 'RO', 'Romania', 'EURO', '460', '25286', '10', '1565');
INSERT INTO public.who_global_data_import VALUES (69777, '2020-06-27', 'RO', 'Romania', 'EURO', '411', '25697', '14', '1579');
INSERT INTO public.who_global_data_import VALUES (69778, '2020-06-28', 'RO', 'Romania', 'EURO', '325', '26022', '10', '1589');
INSERT INTO public.who_global_data_import VALUES (69779, '2020-06-29', 'RO', 'Romania', 'EURO', '291', '26313', '23', '1612');
INSERT INTO public.who_global_data_import VALUES (69780, '2020-06-30', 'RO', 'Romania', 'EURO', '269', '26582', '22', '1634');
INSERT INTO public.who_global_data_import VALUES (69781, '2020-07-01', 'RO', 'Romania', 'EURO', '388', '26970', '17', '1651');
INSERT INTO public.who_global_data_import VALUES (69782, '2020-07-02', 'RO', 'Romania', 'EURO', '326', '27296', '16', '1667');
INSERT INTO public.who_global_data_import VALUES (69783, '2020-07-03', 'RO', 'Romania', 'EURO', '450', '27746', '20', '1687');
INSERT INTO public.who_global_data_import VALUES (69784, '2020-07-04', 'RO', 'Romania', 'EURO', '420', '28166', '21', '1708');
INSERT INTO public.who_global_data_import VALUES (69785, '2020-07-05', 'RO', 'Romania', 'EURO', '416', '28582', '23', '1731');
INSERT INTO public.who_global_data_import VALUES (69786, '2020-07-06', 'RO', 'Romania', 'EURO', '391', '28973', '19', '1750');
INSERT INTO public.who_global_data_import VALUES (69787, '2020-07-07', 'RO', 'Romania', 'EURO', '250', '29223', '18', '1768');
INSERT INTO public.who_global_data_import VALUES (69788, '2020-07-08', 'RO', 'Romania', 'EURO', '397', '29620', '31', '1799');
INSERT INTO public.who_global_data_import VALUES (69789, '2020-07-09', 'RO', 'Romania', 'EURO', '555', '30175', '18', '1817');
INSERT INTO public.who_global_data_import VALUES (69790, '2020-07-10', 'RO', 'Romania', 'EURO', '614', '30789', '17', '1834');
INSERT INTO public.who_global_data_import VALUES (69791, '2020-07-11', 'RO', 'Romania', 'EURO', '592', '31381', '13', '1847');
INSERT INTO public.who_global_data_import VALUES (69792, '2020-07-12', 'RO', 'Romania', 'EURO', '698', '32079', '24', '1871');
INSERT INTO public.who_global_data_import VALUES (69793, '2020-07-13', 'RO', 'Romania', 'EURO', '456', '32535', '13', '1884');
INSERT INTO public.who_global_data_import VALUES (69794, '2020-07-14', 'RO', 'Romania', 'EURO', '413', '32948', '17', '1901');
INSERT INTO public.who_global_data_import VALUES (69795, '2020-07-15', 'RO', 'Romania', 'EURO', '637', '33585', '30', '1931');
INSERT INTO public.who_global_data_import VALUES (69796, '2020-07-16', 'RO', 'Romania', 'EURO', '641', '34226', '21', '1952');
INSERT INTO public.who_global_data_import VALUES (69797, '2020-07-17', 'RO', 'Romania', 'EURO', '777', '35003', '19', '1971');
INSERT INTO public.who_global_data_import VALUES (69798, '2020-07-18', 'RO', 'Romania', 'EURO', '799', '35802', '17', '1988');
INSERT INTO public.who_global_data_import VALUES (69799, '2020-07-19', 'RO', 'Romania', 'EURO', '889', '36691', '21', '2009');
INSERT INTO public.who_global_data_import VALUES (69800, '2020-07-20', 'RO', 'Romania', 'EURO', '767', '37458', '17', '2026');
INSERT INTO public.who_global_data_import VALUES (69801, '2020-07-21', 'RO', 'Romania', 'EURO', '681', '38139', '12', '2038');
INSERT INTO public.who_global_data_import VALUES (69802, '2020-07-22', 'RO', 'Romania', 'EURO', '994', '39133', '36', '2074');
INSERT INTO public.who_global_data_import VALUES (69803, '2020-07-23', 'RO', 'Romania', 'EURO', '1030', '40163', '27', '2101');
INSERT INTO public.who_global_data_import VALUES (69804, '2020-07-24', 'RO', 'Romania', 'EURO', '1112', '41275', '25', '2126');
INSERT INTO public.who_global_data_import VALUES (69805, '2020-07-25', 'RO', 'Romania', 'EURO', '1119', '42394', '24', '2150');
INSERT INTO public.who_global_data_import VALUES (69806, '2020-07-26', 'RO', 'Romania', 'EURO', '1284', '43678', '15', '2165');
INSERT INTO public.who_global_data_import VALUES (69807, '2020-07-27', 'RO', 'Romania', 'EURO', '1120', '44798', '22', '2187');
INSERT INTO public.who_global_data_import VALUES (69808, '2020-07-28', 'RO', 'Romania', 'EURO', '1104', '45902', '19', '2206');
INSERT INTO public.who_global_data_import VALUES (69809, '2020-07-29', 'RO', 'Romania', 'EURO', '1151', '47053', '33', '2239');
INSERT INTO public.who_global_data_import VALUES (69810, '2020-07-30', 'RO', 'Romania', 'EURO', '1182', '48235', '30', '2269');
INSERT INTO public.who_global_data_import VALUES (69811, '2020-07-31', 'RO', 'Romania', 'EURO', '1356', '49591', '35', '2304');
INSERT INTO public.who_global_data_import VALUES (69812, '2020-08-01', 'RO', 'Romania', 'EURO', '1295', '50886', '39', '2343');
INSERT INTO public.who_global_data_import VALUES (69813, '2020-08-02', 'RO', 'Romania', 'EURO', '1225', '52111', '36', '2379');
INSERT INTO public.who_global_data_import VALUES (69814, '2020-08-03', 'RO', 'Romania', 'EURO', '1075', '53186', '34', '2413');
INSERT INTO public.who_global_data_import VALUES (69815, '2020-08-04', 'RO', 'Romania', 'EURO', '823', '54009', '19', '2432');
INSERT INTO public.who_global_data_import VALUES (69816, '2020-08-05', 'RO', 'Romania', 'EURO', '1232', '55241', '48', '2480');
INSERT INTO public.who_global_data_import VALUES (69817, '2020-08-06', 'RO', 'Romania', 'EURO', '1309', '56550', '41', '2521');
INSERT INTO public.who_global_data_import VALUES (69818, '2020-08-07', 'RO', 'Romania', 'EURO', '1345', '57895', '45', '2566');
INSERT INTO public.who_global_data_import VALUES (69819, '2020-08-08', 'RO', 'Romania', 'EURO', '1378', '59273', '50', '2616');
INSERT INTO public.who_global_data_import VALUES (69820, '2020-08-09', 'RO', 'Romania', 'EURO', '1350', '60623', '43', '2659');
INSERT INTO public.who_global_data_import VALUES (69821, '2020-08-10', 'RO', 'Romania', 'EURO', '1145', '61768', '41', '2700');
INSERT INTO public.who_global_data_import VALUES (69822, '2020-08-11', 'RO', 'Romania', 'EURO', '779', '62547', '29', '2729');
INSERT INTO public.who_global_data_import VALUES (69823, '2020-08-12', 'RO', 'Romania', 'EURO', '1215', '63762', '35', '2764');
INSERT INTO public.who_global_data_import VALUES (69824, '2020-08-13', 'RO', 'Romania', 'EURO', '1415', '65177', '43', '2807');
INSERT INTO public.who_global_data_import VALUES (69825, '2020-08-14', 'RO', 'Romania', 'EURO', '1454', '66631', '53', '2860');
INSERT INTO public.who_global_data_import VALUES (69826, '2020-08-15', 'RO', 'Romania', 'EURO', '1415', '68046', '44', '2904');
INSERT INTO public.who_global_data_import VALUES (69827, '2020-08-16', 'RO', 'Romania', 'EURO', '1328', '69374', '50', '2954');
INSERT INTO public.who_global_data_import VALUES (69828, '2020-08-17', 'RO', 'Romania', 'EURO', '1087', '70461', '37', '2991');
INSERT INTO public.who_global_data_import VALUES (69829, '2020-08-18', 'RO', 'Romania', 'EURO', '733', '71194', '38', '3029');
INSERT INTO public.who_global_data_import VALUES (69830, '2020-08-19', 'RO', 'Romania', 'EURO', '1014', '72208', '45', '3074');
INSERT INTO public.who_global_data_import VALUES (69831, '2020-08-20', 'RO', 'Romania', 'EURO', '1409', '73617', '32', '3106');
INSERT INTO public.who_global_data_import VALUES (69832, '2020-08-21', 'RO', 'Romania', 'EURO', '1346', '74963', '48', '3154');
INSERT INTO public.who_global_data_import VALUES (69833, '2020-08-22', 'RO', 'Romania', 'EURO', '1392', '76355', '42', '3196');
INSERT INTO public.who_global_data_import VALUES (69834, '2020-08-23', 'RO', 'Romania', 'EURO', '1189', '77544', '37', '3233');
INSERT INTO public.who_global_data_import VALUES (69835, '2020-08-24', 'RO', 'Romania', 'EURO', '981', '78525', '39', '3272');
INSERT INTO public.who_global_data_import VALUES (69836, '2020-08-25', 'RO', 'Romania', 'EURO', '805', '79330', '37', '3309');
INSERT INTO public.who_global_data_import VALUES (69837, '2020-08-26', 'RO', 'Romania', 'EURO', '1060', '80390', '58', '3367');
INSERT INTO public.who_global_data_import VALUES (69838, '2020-08-27', 'RO', 'Romania', 'EURO', '1256', '81646', '54', '3421');
INSERT INTO public.who_global_data_import VALUES (69839, '2020-08-28', 'RO', 'Romania', 'EURO', '1504', '83150', '38', '3459');
INSERT INTO public.who_global_data_import VALUES (69840, '2020-08-29', 'RO', 'Romania', 'EURO', '1318', '84468', '48', '3507');
INSERT INTO public.who_global_data_import VALUES (69841, '2020-08-30', 'RO', 'Romania', 'EURO', '1365', '85833', '32', '3539');
INSERT INTO public.who_global_data_import VALUES (69842, '2020-08-31', 'RO', 'Romania', 'EURO', '952', '86785', '39', '3578');
INSERT INTO public.who_global_data_import VALUES (69843, '2020-09-01', 'RO', 'Romania', 'EURO', '755', '87540', '43', '3621');
INSERT INTO public.who_global_data_import VALUES (69844, '2020-09-02', 'RO', 'Romania', 'EURO', '1053', '88593', '60', '3681');
INSERT INTO public.who_global_data_import VALUES (69845, '2020-09-03', 'RO', 'Romania', 'EURO', '1298', '89891', '40', '3721');
INSERT INTO public.who_global_data_import VALUES (69846, '2020-09-04', 'RO', 'Romania', 'EURO', '1365', '91256', '44', '3765');
INSERT INTO public.who_global_data_import VALUES (69847, '2020-09-05', 'RO', 'Romania', 'EURO', '1339', '92595', '47', '3812');
INSERT INTO public.who_global_data_import VALUES (69848, '2020-09-06', 'RO', 'Romania', 'EURO', '1269', '93864', '38', '3850');
INSERT INTO public.who_global_data_import VALUES (69849, '2020-09-07', 'RO', 'Romania', 'EURO', '1150', '95014', '43', '3893');
INSERT INTO public.who_global_data_import VALUES (69850, '2020-09-08', 'RO', 'Romania', 'EURO', '883', '95897', '33', '3926');
INSERT INTO public.who_global_data_import VALUES (69851, '2020-09-09', 'RO', 'Romania', 'EURO', '1136', '97033', '41', '3967');
INSERT INTO public.who_global_data_import VALUES (69852, '2020-09-10', 'RO', 'Romania', 'EURO', '1271', '98304', '51', '4018');
INSERT INTO public.who_global_data_import VALUES (69853, '2020-09-11', 'RO', 'Romania', 'EURO', '1380', '99684', '47', '4065');
INSERT INTO public.who_global_data_import VALUES (69854, '2020-09-12', 'RO', 'Romania', 'EURO', '1391', '101075', '35', '4100');
INSERT INTO public.who_global_data_import VALUES (69855, '2020-09-13', 'RO', 'Romania', 'EURO', '1311', '102386', '27', '4127');
INSERT INTO public.who_global_data_import VALUES (69856, '2020-09-14', 'RO', 'Romania', 'EURO', '1109', '103495', '36', '4163');
INSERT INTO public.who_global_data_import VALUES (69857, '2020-09-15', 'RO', 'Romania', 'EURO', '692', '104187', '22', '4185');
INSERT INTO public.who_global_data_import VALUES (69858, '2020-09-16', 'RO', 'Romania', 'EURO', '1111', '105298', '51', '4236');
INSERT INTO public.who_global_data_import VALUES (69859, '2020-09-17', 'RO', 'Romania', 'EURO', '1713', '107011', '49', '4285');
INSERT INTO public.who_global_data_import VALUES (69860, '2020-09-18', 'RO', 'Romania', 'EURO', '1679', '108690', '27', '4312');
INSERT INTO public.who_global_data_import VALUES (69861, '2020-09-19', 'RO', 'Romania', 'EURO', '1527', '110217', '48', '4360');
INSERT INTO public.who_global_data_import VALUES (69862, '2020-09-20', 'RO', 'Romania', 'EURO', '1333', '111550', '42', '4402');
INSERT INTO public.who_global_data_import VALUES (69863, '2020-09-21', 'RO', 'Romania', 'EURO', '1231', '112781', '33', '4435');
INSERT INTO public.who_global_data_import VALUES (69864, '2020-09-22', 'RO', 'Romania', 'EURO', '808', '113589', '23', '4458');
INSERT INTO public.who_global_data_import VALUES (69865, '2020-09-23', 'RO', 'Romania', 'EURO', '1059', '114648', '45', '4503');
INSERT INTO public.who_global_data_import VALUES (69866, '2020-09-24', 'RO', 'Romania', 'EURO', '1767', '116415', '47', '4550');
INSERT INTO public.who_global_data_import VALUES (69867, '2020-09-25', 'RO', 'Romania', 'EURO', '1639', '118054', '41', '4591');
INSERT INTO public.who_global_data_import VALUES (69868, '2020-09-26', 'RO', 'Romania', 'EURO', '1629', '119683', '42', '4633');
INSERT INTO public.who_global_data_import VALUES (69869, '2020-09-27', 'RO', 'Romania', 'EURO', '1552', '121235', '54', '4687');
INSERT INTO public.who_global_data_import VALUES (69870, '2020-09-28', 'RO', 'Romania', 'EURO', '1438', '122673', '31', '4718');
INSERT INTO public.who_global_data_import VALUES (69871, '2020-09-29', 'RO', 'Romania', 'EURO', '1271', '123944', '30', '4748');
INSERT INTO public.who_global_data_import VALUES (69872, '2020-09-30', 'RO', 'Romania', 'EURO', '1470', '125414', '44', '4792');
INSERT INTO public.who_global_data_import VALUES (69873, '2020-10-01', 'RO', 'Romania', 'EURO', '2158', '127572', '33', '4825');
INSERT INTO public.who_global_data_import VALUES (69874, '2020-10-02', 'RO', 'Romania', 'EURO', '2086', '129658', '37', '4862');
INSERT INTO public.who_global_data_import VALUES (69875, '2020-10-03', 'RO', 'Romania', 'EURO', '2343', '132001', '53', '4915');
INSERT INTO public.who_global_data_import VALUES (69876, '2020-10-04', 'RO', 'Romania', 'EURO', '2064', '134065', '32', '4947');
INSERT INTO public.who_global_data_import VALUES (69877, '2020-10-05', 'RO', 'Romania', 'EURO', '0', '134065', '0', '4947');
INSERT INTO public.who_global_data_import VALUES (69878, '2020-10-06', 'RO', 'Romania', 'EURO', '3426', '137491', '101', '5048');
INSERT INTO public.who_global_data_import VALUES (69879, '2020-10-07', 'RO', 'Romania', 'EURO', '2121', '139612', '73', '5121');
INSERT INTO public.who_global_data_import VALUES (69880, '2020-10-08', 'RO', 'Romania', 'EURO', '2958', '142570', '82', '5203');
INSERT INTO public.who_global_data_import VALUES (69881, '2020-10-09', 'RO', 'Romania', 'EURO', '3130', '145700', '44', '5247');
INSERT INTO public.who_global_data_import VALUES (69882, '2020-10-10', 'RO', 'Romania', 'EURO', '3186', '148886', '52', '5299');
INSERT INTO public.who_global_data_import VALUES (69883, '2020-10-11', 'RO', 'Romania', 'EURO', '3517', '152403', '59', '5358');
INSERT INTO public.who_global_data_import VALUES (69884, '2020-10-12', 'RO', 'Romania', 'EURO', '2880', '155283', '53', '5411');
INSERT INTO public.who_global_data_import VALUES (69885, '2020-10-13', 'RO', 'Romania', 'EURO', '2069', '157352', '56', '5467');
INSERT INTO public.who_global_data_import VALUES (69886, '2020-10-14', 'RO', 'Romania', 'EURO', '3109', '160461', '68', '5535');
INSERT INTO public.who_global_data_import VALUES (69887, '2020-10-15', 'RO', 'Romania', 'EURO', '4016', '164477', '66', '5601');
INSERT INTO public.who_global_data_import VALUES (69888, '2020-10-16', 'RO', 'Romania', 'EURO', '4013', '168490', '73', '5674');
INSERT INTO public.who_global_data_import VALUES (69889, '2020-10-17', 'RO', 'Romania', 'EURO', '4026', '172516', '75', '5749');
INSERT INTO public.who_global_data_import VALUES (69890, '2020-10-18', 'RO', 'Romania', 'EURO', '3952', '176468', '63', '5812');
INSERT INTO public.who_global_data_import VALUES (69891, '2020-10-19', 'RO', 'Romania', 'EURO', '3920', '180388', '60', '5872');
INSERT INTO public.who_global_data_import VALUES (69892, '2020-10-20', 'RO', 'Romania', 'EURO', '2466', '182854', '59', '5931');
INSERT INTO public.who_global_data_import VALUES (69893, '2020-10-21', 'RO', 'Romania', 'EURO', '3400', '186254', '65', '5996');
INSERT INTO public.who_global_data_import VALUES (69894, '2020-10-22', 'RO', 'Romania', 'EURO', '4848', '191102', '69', '6065');
INSERT INTO public.who_global_data_import VALUES (69895, '2020-10-23', 'RO', 'Romania', 'EURO', '4902', '196004', '98', '6163');
INSERT INTO public.who_global_data_import VALUES (69896, '2020-10-24', 'RO', 'Romania', 'EURO', '5028', '201032', '82', '6245');
INSERT INTO public.who_global_data_import VALUES (69897, '2020-10-25', 'RO', 'Romania', 'EURO', '4761', '205793', '73', '6318');
INSERT INTO public.who_global_data_import VALUES (69898, '2020-10-26', 'RO', 'Romania', 'EURO', '3855', '209648', '73', '6391');
INSERT INTO public.who_global_data_import VALUES (69899, '2020-10-27', 'RO', 'Romania', 'EURO', '2844', '212492', '79', '6470');
INSERT INTO public.who_global_data_import VALUES (69900, '2020-10-28', 'RO', 'Romania', 'EURO', '4724', '217216', '104', '6574');
INSERT INTO public.who_global_data_import VALUES (69901, '2020-10-29', 'RO', 'Romania', 'EURO', '5343', '222559', '107', '6681');
INSERT INTO public.who_global_data_import VALUES (69902, '2020-10-30', 'RO', 'Romania', 'EURO', '6481', '229040', '83', '6764');
INSERT INTO public.who_global_data_import VALUES (69903, '2020-10-31', 'RO', 'Romania', 'EURO', '6546', '235586', '103', '6867');
INSERT INTO public.who_global_data_import VALUES (69904, '2020-11-01', 'RO', 'Romania', 'EURO', '5753', '241339', '101', '6968');
INSERT INTO public.who_global_data_import VALUES (69905, '2020-11-02', 'RO', 'Romania', 'EURO', '5324', '246663', '99', '7067');
INSERT INTO public.who_global_data_import VALUES (69906, '2020-11-03', 'RO', 'Romania', 'EURO', '4041', '250704', '86', '7153');
INSERT INTO public.who_global_data_import VALUES (69907, '2020-11-04', 'RO', 'Romania', 'EURO', '7733', '258437', '120', '7273');
INSERT INTO public.who_global_data_import VALUES (69908, '2020-11-05', 'RO', 'Romania', 'EURO', '8651', '267088', '146', '7419');
INSERT INTO public.who_global_data_import VALUES (69909, '2020-11-06', 'RO', 'Romania', 'EURO', '9714', '276802', '121', '7540');
INSERT INTO public.who_global_data_import VALUES (69910, '2020-11-07', 'RO', 'Romania', 'EURO', '10260', '287062', '123', '7663');
INSERT INTO public.who_global_data_import VALUES (69911, '2020-11-08', 'RO', 'Romania', 'EURO', '9937', '296999', '130', '7793');
INSERT INTO public.who_global_data_import VALUES (69912, '2020-11-09', 'RO', 'Romania', 'EURO', '6752', '303751', '86', '7879');
INSERT INTO public.who_global_data_import VALUES (69913, '2020-11-10', 'RO', 'Romania', 'EURO', '3240', '306991', '130', '8009');
INSERT INTO public.who_global_data_import VALUES (69914, '2020-11-11', 'RO', 'Romania', 'EURO', '7304', '314295', '177', '8186');
INSERT INTO public.who_global_data_import VALUES (69915, '2020-11-12', 'RO', 'Romania', 'EURO', '9799', '324094', '203', '8389');
INSERT INTO public.who_global_data_import VALUES (69916, '2020-11-13', 'RO', 'Romania', 'EURO', '10142', '334236', '121', '8510');
INSERT INTO public.who_global_data_import VALUES (69917, '2020-11-14', 'RO', 'Romania', 'EURO', '9489', '343725', '174', '8684');
INSERT INTO public.who_global_data_import VALUES (69918, '2020-11-15', 'RO', 'Romania', 'EURO', '9460', '353185', '129', '8813');
INSERT INTO public.who_global_data_import VALUES (69919, '2020-11-16', 'RO', 'Romania', 'EURO', '7096', '360281', '113', '8926');
INSERT INTO public.who_global_data_import VALUES (69920, '2020-11-17', 'RO', 'Romania', 'EURO', '4931', '365212', '149', '9075');
INSERT INTO public.who_global_data_import VALUES (69921, '2020-11-18', 'RO', 'Romania', 'EURO', '8262', '373474', '186', '9261');
INSERT INTO public.who_global_data_import VALUES (69922, '2020-11-19', 'RO', 'Romania', 'EURO', '10269', '383743', '168', '9429');
INSERT INTO public.who_global_data_import VALUES (69923, '2020-11-20', 'RO', 'Romania', 'EURO', '10108', '393851', '167', '9596');
INSERT INTO public.who_global_data_import VALUES (69924, '2020-11-21', 'RO', 'Romania', 'EURO', '9272', '403123', '160', '9756');
INSERT INTO public.who_global_data_import VALUES (69925, '2020-11-22', 'RO', 'Romania', 'EURO', '9685', '412808', '160', '9916');
INSERT INTO public.who_global_data_import VALUES (69926, '2020-11-23', 'RO', 'Romania', 'EURO', '5837', '418645', '131', '10047');
INSERT INTO public.who_global_data_import VALUES (69927, '2020-11-24', 'RO', 'Romania', 'EURO', '4207', '422852', '130', '10177');
INSERT INTO public.who_global_data_import VALUES (69928, '2020-11-25', 'RO', 'Romania', 'EURO', '7753', '430605', '196', '10373');
INSERT INTO public.who_global_data_import VALUES (69929, '2020-11-26', 'RO', 'Romania', 'EURO', '9739', '440344', '168', '10541');
INSERT INTO public.who_global_data_import VALUES (69930, '2020-11-27', 'RO', 'Romania', 'EURO', '9005', '449349', '171', '10712');
INSERT INTO public.who_global_data_import VALUES (69931, '2020-11-28', 'RO', 'Romania', 'EURO', '8499', '457848', '172', '10884');
INSERT INTO public.who_global_data_import VALUES (69932, '2020-11-29', 'RO', 'Romania', 'EURO', '8134', '465982', '161', '11045');
INSERT INTO public.who_global_data_import VALUES (69933, '2020-11-30', 'RO', 'Romania', 'EURO', '5554', '471536', '148', '11193');
INSERT INTO public.who_global_data_import VALUES (69934, '2020-12-01', 'RO', 'Romania', 'EURO', '3826', '475362', '138', '11331');
INSERT INTO public.who_global_data_import VALUES (69935, '2020-12-02', 'RO', 'Romania', 'EURO', '4272', '479634', '199', '11530');
INSERT INTO public.who_global_data_import VALUES (69936, '2020-12-03', 'RO', 'Romania', 'EURO', '4916', '484550', '135', '11665');
INSERT INTO public.who_global_data_import VALUES (69937, '2020-12-04', 'RO', 'Romania', 'EURO', '7661', '492211', '211', '11876');
INSERT INTO public.who_global_data_import VALUES (69938, '2020-12-05', 'RO', 'Romania', 'EURO', '8062', '500273', '176', '12052');
INSERT INTO public.who_global_data_import VALUES (69939, '2020-12-06', 'RO', 'Romania', 'EURO', '8072', '508345', '134', '12186');
INSERT INTO public.who_global_data_import VALUES (69940, '2020-12-07', 'RO', 'Romania', 'EURO', '5231', '513576', '134', '12320');
INSERT INTO public.who_global_data_import VALUES (69941, '2020-12-08', 'RO', 'Romania', 'EURO', '3660', '517236', '127', '12447');
INSERT INTO public.who_global_data_import VALUES (69942, '2020-12-09', 'RO', 'Romania', 'EURO', '7439', '524675', '213', '12660');
INSERT INTO public.who_global_data_import VALUES (69943, '2020-12-10', 'RO', 'Romania', 'EURO', '7365', '532040', '161', '12821');
INSERT INTO public.who_global_data_import VALUES (69944, '2020-12-11', 'RO', 'Romania', 'EURO', '7067', '539107', '127', '12948');
INSERT INTO public.who_global_data_import VALUES (69945, '2020-12-12', 'RO', 'Romania', 'EURO', '6460', '545567', '168', '13116');
INSERT INTO public.who_global_data_import VALUES (69946, '2020-12-13', 'RO', 'Romania', 'EURO', '6333', '551900', '148', '13264');
INSERT INTO public.who_global_data_import VALUES (69947, '2020-12-14', 'RO', 'Romania', 'EURO', '4435', '556335', '121', '13385');
INSERT INTO public.who_global_data_import VALUES (69948, '2020-12-15', 'RO', 'Romania', 'EURO', '3252', '559587', '109', '13494');
INSERT INTO public.who_global_data_import VALUES (69949, '2020-12-16', 'RO', 'Romania', 'EURO', '6171', '565758', '204', '13698');
INSERT INTO public.who_global_data_import VALUES (69950, '2020-12-17', 'RO', 'Romania', 'EURO', '5991', '571749', '164', '13862');
INSERT INTO public.who_global_data_import VALUES (69951, '2020-12-18', 'RO', 'Romania', 'EURO', '5697', '577446', '107', '13969');
INSERT INTO public.who_global_data_import VALUES (69952, '2020-12-19', 'RO', 'Romania', 'EURO', '5340', '582786', '188', '14157');
INSERT INTO public.who_global_data_import VALUES (69953, '2020-12-20', 'RO', 'Romania', 'EURO', '5158', '587944', '139', '14296');
INSERT INTO public.who_global_data_import VALUES (69954, '2020-12-21', 'RO', 'Romania', 'EURO', '3350', '591294', '98', '14394');
INSERT INTO public.who_global_data_import VALUES (69955, '2020-12-22', 'RO', 'Romania', 'EURO', '2489', '593783', '87', '14481');
INSERT INTO public.who_global_data_import VALUES (69956, '2020-12-23', 'RO', 'Romania', 'EURO', '5009', '598792', '155', '14636');
INSERT INTO public.who_global_data_import VALUES (69957, '2020-12-24', 'RO', 'Romania', 'EURO', '5459', '604251', '130', '14766');
INSERT INTO public.who_global_data_import VALUES (69958, '2020-12-25', 'RO', 'Romania', 'EURO', '4310', '608561', '146', '14912');
INSERT INTO public.who_global_data_import VALUES (69959, '2020-12-26', 'RO', 'Romania', 'EURO', '3812', '612373', '101', '15013');
INSERT INTO public.who_global_data_import VALUES (69960, '2020-12-27', 'RO', 'Romania', 'EURO', '1387', '613760', '95', '15108');
INSERT INTO public.who_global_data_import VALUES (69961, '2020-12-28', 'RO', 'Romania', 'EURO', '2049', '615809', '122', '15230');
INSERT INTO public.who_global_data_import VALUES (69962, '2020-12-29', 'RO', 'Romania', 'EURO', '2620', '618429', '104', '15334');
INSERT INTO public.who_global_data_import VALUES (69963, '2020-12-30', 'RO', 'Romania', 'EURO', '4637', '623066', '135', '15469');
INSERT INTO public.who_global_data_import VALUES (69964, '2020-12-31', 'RO', 'Romania', 'EURO', '4875', '627941', '127', '15596');
INSERT INTO public.who_global_data_import VALUES (69965, '2021-01-01', 'RO', 'Romania', 'EURO', '4322', '632263', '171', '15767');
INSERT INTO public.who_global_data_import VALUES (69966, '2021-01-02', 'RO', 'Romania', 'EURO', '3938', '636201', '74', '15841');
INSERT INTO public.who_global_data_import VALUES (69967, '2021-01-03', 'RO', 'Romania', 'EURO', '1194', '637395', '78', '15919');
INSERT INTO public.who_global_data_import VALUES (69968, '2021-01-04', 'RO', 'Romania', 'EURO', '3034', '640429', '60', '15979');
INSERT INTO public.who_global_data_import VALUES (69969, '2021-01-05', 'RO', 'Romania', 'EURO', '3130', '643559', '78', '16057');
INSERT INTO public.who_global_data_import VALUES (69970, '2021-01-06', 'RO', 'Romania', 'EURO', '4729', '648288', '121', '16178');
INSERT INTO public.who_global_data_import VALUES (69971, '2021-01-07', 'RO', 'Romania', 'EURO', '5719', '654007', '121', '16299');
INSERT INTO public.who_global_data_import VALUES (69972, '2021-01-08', 'RO', 'Romania', 'EURO', '4951', '658958', '111', '16410');
INSERT INTO public.who_global_data_import VALUES (69973, '2021-01-09', 'RO', 'Romania', 'EURO', '4821', '663779', '96', '16506');
INSERT INTO public.who_global_data_import VALUES (69974, '2021-01-10', 'RO', 'Romania', 'EURO', '4423', '668202', '86', '16592');
INSERT INTO public.who_global_data_import VALUES (69975, '2021-01-11', 'RO', 'Romania', 'EURO', '3082', '671284', '62', '16654');
INSERT INTO public.who_global_data_import VALUES (69976, '2021-01-12', 'RO', 'Romania', 'EURO', '1987', '673271', '71', '16725');
INSERT INTO public.who_global_data_import VALUES (69977, '2021-01-13', 'RO', 'Romania', 'EURO', '3697', '676968', '156', '16881');
INSERT INTO public.who_global_data_import VALUES (69978, '2021-01-14', 'RO', 'Romania', 'EURO', '4424', '681392', '88', '16969');
INSERT INTO public.who_global_data_import VALUES (69979, '2021-01-15', 'RO', 'Romania', 'EURO', '3525', '684917', '66', '17035');
INSERT INTO public.who_global_data_import VALUES (69980, '2021-01-16', 'RO', 'Romania', 'EURO', '3353', '688270', '63', '17098');
INSERT INTO public.who_global_data_import VALUES (69981, '2021-01-17', 'RO', 'Romania', 'EURO', '3218', '691488', '66', '17164');
INSERT INTO public.who_global_data_import VALUES (69982, '2021-01-18', 'RO', 'Romania', 'EURO', '2156', '693644', '57', '17221');
INSERT INTO public.who_global_data_import VALUES (69983, '2021-01-19', 'RO', 'Romania', 'EURO', '1509', '695153', '50', '17271');
INSERT INTO public.who_global_data_import VALUES (69984, '2021-01-20', 'RO', 'Romania', 'EURO', '2745', '697898', '98', '17369');
INSERT INTO public.who_global_data_import VALUES (69985, '2021-01-21', 'RO', 'Romania', 'EURO', '3000', '700898', '116', '17485');
INSERT INTO public.who_global_data_import VALUES (69986, '2021-01-22', 'RO', 'Romania', 'EURO', '2878', '703776', '69', '17554');
INSERT INTO public.who_global_data_import VALUES (69987, '2021-01-23', 'RO', 'Romania', 'EURO', '2699', '706475', '74', '17628');
INSERT INTO public.who_global_data_import VALUES (69988, '2021-01-24', 'RO', 'Romania', 'EURO', '2719', '709194', '94', '17722');
INSERT INTO public.who_global_data_import VALUES (69989, '2021-01-25', 'RO', 'Romania', 'EURO', '1816', '711010', '54', '17776');
INSERT INTO public.who_global_data_import VALUES (69990, '2021-01-26', 'RO', 'Romania', 'EURO', '1551', '712561', '65', '17841');
INSERT INTO public.who_global_data_import VALUES (69991, '2021-01-27', 'RO', 'Romania', 'EURO', '2877', '715438', '97', '17938');
INSERT INTO public.who_global_data_import VALUES (69992, '2021-01-28', 'RO', 'Romania', 'EURO', '3174', '718612', '77', '18015');
INSERT INTO public.who_global_data_import VALUES (69993, '2021-01-29', 'RO', 'Romania', 'EURO', '2901', '721513', '90', '18105');
INSERT INTO public.who_global_data_import VALUES (69994, '2021-01-30', 'RO', 'Romania', 'EURO', '2737', '724250', '91', '18196');
INSERT INTO public.who_global_data_import VALUES (69995, '2021-01-31', 'RO', 'Romania', 'EURO', '2668', '726918', '68', '18264');
INSERT INTO public.who_global_data_import VALUES (69996, '2021-02-01', 'RO', 'Romania', 'EURO', '1825', '728743', '71', '18335');
INSERT INTO public.who_global_data_import VALUES (69997, '2021-02-02', 'RO', 'Romania', 'EURO', '1313', '730056', '67', '18402');
INSERT INTO public.who_global_data_import VALUES (69998, '2021-02-03', 'RO', 'Romania', 'EURO', '2676', '732732', '111', '18513');
INSERT INTO public.who_global_data_import VALUES (69999, '2021-02-04', 'RO', 'Romania', 'EURO', '2752', '735484', '87', '18600');
INSERT INTO public.who_global_data_import VALUES (70000, '2021-02-05', 'RO', 'Romania', 'EURO', '2668', '738152', '75', '18675');
INSERT INTO public.who_global_data_import VALUES (70001, '2020-01-03', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70002, '2020-01-04', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70003, '2020-01-05', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70004, '2020-01-06', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70005, '2020-01-07', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70006, '2020-01-08', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70007, '2020-01-09', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70008, '2020-01-10', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70009, '2020-01-11', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70010, '2020-01-12', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70011, '2020-01-13', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70012, '2020-01-14', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70013, '2020-01-15', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70014, '2020-01-16', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70015, '2020-01-17', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70016, '2020-01-18', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70017, '2020-01-19', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70018, '2020-01-20', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70019, '2020-01-21', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70020, '2020-01-22', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70021, '2020-01-23', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70022, '2020-01-24', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70023, '2020-01-25', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70024, '2020-01-26', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70025, '2020-01-27', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70026, '2020-01-28', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70027, '2020-01-29', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70028, '2020-01-30', 'RU', 'Russian Federation', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70029, '2020-01-31', 'RU', 'Russian Federation', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70030, '2020-02-01', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70031, '2020-02-02', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70032, '2020-02-03', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70033, '2020-02-04', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70034, '2020-02-05', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70035, '2020-02-06', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70036, '2020-02-07', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70037, '2020-02-08', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70038, '2020-02-09', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70039, '2020-02-10', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70040, '2020-02-11', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70041, '2020-02-12', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70042, '2020-02-13', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70043, '2020-02-14', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70044, '2020-02-15', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70045, '2020-02-16', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70046, '2020-02-17', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70047, '2020-02-18', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70048, '2020-02-19', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70049, '2020-02-20', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70050, '2020-02-21', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70051, '2020-02-22', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70052, '2020-02-23', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70053, '2020-02-24', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70054, '2020-02-25', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70055, '2020-02-26', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70056, '2020-02-27', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70057, '2020-02-28', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70058, '2020-02-29', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70059, '2020-03-01', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70060, '2020-03-02', 'RU', 'Russian Federation', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70061, '2020-03-03', 'RU', 'Russian Federation', 'EURO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70062, '2020-03-04', 'RU', 'Russian Federation', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70063, '2020-03-05', 'RU', 'Russian Federation', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70064, '2020-03-06', 'RU', 'Russian Federation', 'EURO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70065, '2020-03-07', 'RU', 'Russian Federation', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70066, '2020-03-08', 'RU', 'Russian Federation', 'EURO', '3', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70067, '2020-03-09', 'RU', 'Russian Federation', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70068, '2020-03-10', 'RU', 'Russian Federation', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70069, '2020-03-11', 'RU', 'Russian Federation', 'EURO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70070, '2020-03-12', 'RU', 'Russian Federation', 'EURO', '13', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70071, '2020-03-13', 'RU', 'Russian Federation', 'EURO', '14', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70072, '2020-03-14', 'RU', 'Russian Federation', 'EURO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70073, '2020-03-15', 'RU', 'Russian Federation', 'EURO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70074, '2020-03-16', 'RU', 'Russian Federation', 'EURO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70075, '2020-03-17', 'RU', 'Russian Federation', 'EURO', '59', '93', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70076, '2020-03-18', 'RU', 'Russian Federation', 'EURO', '0', '93', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70077, '2020-03-19', 'RU', 'Russian Federation', 'EURO', '54', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70078, '2020-03-20', 'RU', 'Russian Federation', 'EURO', '52', '199', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70079, '2020-03-21', 'RU', 'Russian Federation', 'EURO', '54', '253', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70080, '2020-03-22', 'RU', 'Russian Federation', 'EURO', '53', '306', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70081, '2020-03-23', 'RU', 'Russian Federation', 'EURO', '132', '438', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70082, '2020-03-24', 'RU', 'Russian Federation', 'EURO', '57', '495', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70083, '2020-03-25', 'RU', 'Russian Federation', 'EURO', '163', '658', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70084, '2020-03-26', 'RU', 'Russian Federation', 'EURO', '182', '840', '2', '2');
INSERT INTO public.who_global_data_import VALUES (70085, '2020-03-27', 'RU', 'Russian Federation', 'EURO', '196', '1036', '1', '3');
INSERT INTO public.who_global_data_import VALUES (70086, '2020-03-28', 'RU', 'Russian Federation', 'EURO', '228', '1264', '1', '4');
INSERT INTO public.who_global_data_import VALUES (70087, '2020-03-29', 'RU', 'Russian Federation', 'EURO', '270', '1534', '4', '8');
INSERT INTO public.who_global_data_import VALUES (70088, '2020-03-30', 'RU', 'Russian Federation', 'EURO', '303', '1837', '1', '9');
INSERT INTO public.who_global_data_import VALUES (70089, '2020-03-31', 'RU', 'Russian Federation', 'EURO', '500', '2337', '8', '17');
INSERT INTO public.who_global_data_import VALUES (70090, '2020-04-01', 'RU', 'Russian Federation', 'EURO', '440', '2777', '7', '24');
INSERT INTO public.who_global_data_import VALUES (70091, '2020-04-02', 'RU', 'Russian Federation', 'EURO', '0', '2777', '0', '24');
INSERT INTO public.who_global_data_import VALUES (70092, '2020-04-03', 'RU', 'Russian Federation', 'EURO', '771', '3548', '6', '30');
INSERT INTO public.who_global_data_import VALUES (70093, '2020-04-04', 'RU', 'Russian Federation', 'EURO', '601', '4149', '4', '34');
INSERT INTO public.who_global_data_import VALUES (70094, '2020-04-05', 'RU', 'Russian Federation', 'EURO', '582', '4731', '9', '43');
INSERT INTO public.who_global_data_import VALUES (70095, '2020-04-06', 'RU', 'Russian Federation', 'EURO', '658', '5389', '2', '45');
INSERT INTO public.who_global_data_import VALUES (70096, '2020-04-07', 'RU', 'Russian Federation', 'EURO', '954', '6343', '2', '47');
INSERT INTO public.who_global_data_import VALUES (70097, '2020-04-08', 'RU', 'Russian Federation', 'EURO', '1154', '7497', '11', '58');
INSERT INTO public.who_global_data_import VALUES (70098, '2020-04-09', 'RU', 'Russian Federation', 'EURO', '2634', '10131', '18', '76');
INSERT INTO public.who_global_data_import VALUES (70099, '2020-04-10', 'RU', 'Russian Federation', 'EURO', '1786', '11917', '18', '94');
INSERT INTO public.who_global_data_import VALUES (70100, '2020-04-11', 'RU', 'Russian Federation', 'EURO', '1667', '13584', '12', '106');
INSERT INTO public.who_global_data_import VALUES (70101, '2020-04-12', 'RU', 'Russian Federation', 'EURO', '2186', '15770', '24', '130');
INSERT INTO public.who_global_data_import VALUES (70102, '2020-04-13', 'RU', 'Russian Federation', 'EURO', '2558', '18328', '18', '148');
INSERT INTO public.who_global_data_import VALUES (70103, '2020-04-14', 'RU', 'Russian Federation', 'EURO', '2774', '21102', '22', '170');
INSERT INTO public.who_global_data_import VALUES (70104, '2020-04-15', 'RU', 'Russian Federation', 'EURO', '3388', '24490', '28', '198');
INSERT INTO public.who_global_data_import VALUES (70105, '2020-04-16', 'RU', 'Russian Federation', 'EURO', '3448', '27938', '34', '232');
INSERT INTO public.who_global_data_import VALUES (70106, '2020-04-17', 'RU', 'Russian Federation', 'EURO', '4070', '32008', '41', '273');
INSERT INTO public.who_global_data_import VALUES (70107, '2020-04-18', 'RU', 'Russian Federation', 'EURO', '4785', '36793', '40', '313');
INSERT INTO public.who_global_data_import VALUES (70108, '2020-04-19', 'RU', 'Russian Federation', 'EURO', '6060', '42853', '48', '361');
INSERT INTO public.who_global_data_import VALUES (70109, '2020-04-20', 'RU', 'Russian Federation', 'EURO', '4268', '47121', '44', '405');
INSERT INTO public.who_global_data_import VALUES (70110, '2020-04-21', 'RU', 'Russian Federation', 'EURO', '5642', '52763', '51', '456');
INSERT INTO public.who_global_data_import VALUES (70111, '2020-04-22', 'RU', 'Russian Federation', 'EURO', '5236', '57999', '57', '513');
INSERT INTO public.who_global_data_import VALUES (70112, '2020-04-23', 'RU', 'Russian Federation', 'EURO', '4774', '62773', '42', '555');
INSERT INTO public.who_global_data_import VALUES (70113, '2020-04-24', 'RU', 'Russian Federation', 'EURO', '5849', '68622', '60', '615');
INSERT INTO public.who_global_data_import VALUES (70114, '2020-04-25', 'RU', 'Russian Federation', 'EURO', '5966', '74588', '66', '681');
INSERT INTO public.who_global_data_import VALUES (70115, '2020-04-26', 'RU', 'Russian Federation', 'EURO', '6361', '80949', '66', '747');
INSERT INTO public.who_global_data_import VALUES (70116, '2020-04-27', 'RU', 'Russian Federation', 'EURO', '6198', '87147', '47', '794');
INSERT INTO public.who_global_data_import VALUES (70117, '2020-04-28', 'RU', 'Russian Federation', 'EURO', '6411', '93558', '73', '867');
INSERT INTO public.who_global_data_import VALUES (70118, '2020-04-29', 'RU', 'Russian Federation', 'EURO', '5841', '99399', '105', '972');
INSERT INTO public.who_global_data_import VALUES (70119, '2020-04-30', 'RU', 'Russian Federation', 'EURO', '7099', '106498', '101', '1073');
INSERT INTO public.who_global_data_import VALUES (70120, '2020-05-01', 'RU', 'Russian Federation', 'EURO', '7933', '114431', '96', '1169');
INSERT INTO public.who_global_data_import VALUES (70121, '2020-05-02', 'RU', 'Russian Federation', 'EURO', '9623', '124054', '53', '1222');
INSERT INTO public.who_global_data_import VALUES (70122, '2020-05-03', 'RU', 'Russian Federation', 'EURO', '10633', '134687', '58', '1280');
INSERT INTO public.who_global_data_import VALUES (70123, '2020-05-04', 'RU', 'Russian Federation', 'EURO', '10581', '145268', '76', '1356');
INSERT INTO public.who_global_data_import VALUES (70124, '2020-05-05', 'RU', 'Russian Federation', 'EURO', '10102', '155370', '95', '1451');
INSERT INTO public.who_global_data_import VALUES (70125, '2020-05-06', 'RU', 'Russian Federation', 'EURO', '10559', '165929', '86', '1537');
INSERT INTO public.who_global_data_import VALUES (70126, '2020-05-07', 'RU', 'Russian Federation', 'EURO', '11231', '177160', '88', '1625');
INSERT INTO public.who_global_data_import VALUES (70127, '2020-05-08', 'RU', 'Russian Federation', 'EURO', '10699', '187859', '98', '1723');
INSERT INTO public.who_global_data_import VALUES (70128, '2020-05-09', 'RU', 'Russian Federation', 'EURO', '10817', '198676', '104', '1827');
INSERT INTO public.who_global_data_import VALUES (70129, '2020-05-10', 'RU', 'Russian Federation', 'EURO', '11012', '209688', '88', '1915');
INSERT INTO public.who_global_data_import VALUES (70130, '2020-05-11', 'RU', 'Russian Federation', 'EURO', '11656', '221344', '94', '2009');
INSERT INTO public.who_global_data_import VALUES (70131, '2020-05-12', 'RU', 'Russian Federation', 'EURO', '10899', '232243', '107', '2116');
INSERT INTO public.who_global_data_import VALUES (70132, '2020-05-13', 'RU', 'Russian Federation', 'EURO', '10028', '242271', '96', '2212');
INSERT INTO public.who_global_data_import VALUES (70133, '2020-05-14', 'RU', 'Russian Federation', 'EURO', '9974', '252245', '93', '2305');
INSERT INTO public.who_global_data_import VALUES (70134, '2020-05-15', 'RU', 'Russian Federation', 'EURO', '10598', '262843', '113', '2418');
INSERT INTO public.who_global_data_import VALUES (70135, '2020-05-16', 'RU', 'Russian Federation', 'EURO', '9200', '272043', '119', '2537');
INSERT INTO public.who_global_data_import VALUES (70136, '2020-05-17', 'RU', 'Russian Federation', 'EURO', '9709', '281752', '94', '2631');
INSERT INTO public.who_global_data_import VALUES (70137, '2020-05-18', 'RU', 'Russian Federation', 'EURO', '8926', '290678', '91', '2722');
INSERT INTO public.who_global_data_import VALUES (70138, '2020-05-19', 'RU', 'Russian Federation', 'EURO', '9263', '299941', '115', '2837');
INSERT INTO public.who_global_data_import VALUES (70139, '2020-05-20', 'RU', 'Russian Federation', 'EURO', '8764', '308705', '135', '2972');
INSERT INTO public.who_global_data_import VALUES (70140, '2020-05-21', 'RU', 'Russian Federation', 'EURO', '8849', '317554', '127', '3099');
INSERT INTO public.who_global_data_import VALUES (70141, '2020-05-22', 'RU', 'Russian Federation', 'EURO', '8894', '326448', '150', '3249');
INSERT INTO public.who_global_data_import VALUES (70142, '2020-05-23', 'RU', 'Russian Federation', 'EURO', '9434', '335882', '139', '3388');
INSERT INTO public.who_global_data_import VALUES (70143, '2020-05-24', 'RU', 'Russian Federation', 'EURO', '8599', '344481', '153', '3541');
INSERT INTO public.who_global_data_import VALUES (70144, '2020-05-25', 'RU', 'Russian Federation', 'EURO', '8946', '353427', '92', '3633');
INSERT INTO public.who_global_data_import VALUES (70145, '2020-05-26', 'RU', 'Russian Federation', 'EURO', '8915', '362342', '174', '3807');
INSERT INTO public.who_global_data_import VALUES (70146, '2020-05-27', 'RU', 'Russian Federation', 'EURO', '8338', '370680', '161', '3968');
INSERT INTO public.who_global_data_import VALUES (70147, '2020-05-28', 'RU', 'Russian Federation', 'EURO', '8371', '379051', '174', '4142');
INSERT INTO public.who_global_data_import VALUES (70148, '2020-05-29', 'RU', 'Russian Federation', 'EURO', '8572', '387623', '232', '4374');
INSERT INTO public.who_global_data_import VALUES (70149, '2020-05-30', 'RU', 'Russian Federation', 'EURO', '8952', '396575', '181', '4555');
INSERT INTO public.who_global_data_import VALUES (70150, '2020-05-31', 'RU', 'Russian Federation', 'EURO', '9268', '405843', '138', '4693');
INSERT INTO public.who_global_data_import VALUES (70151, '2020-06-01', 'RU', 'Russian Federation', 'EURO', '9035', '414878', '162', '4855');
INSERT INTO public.who_global_data_import VALUES (70152, '2020-06-02', 'RU', 'Russian Federation', 'EURO', '8863', '423741', '182', '5037');
INSERT INTO public.who_global_data_import VALUES (70153, '2020-06-03', 'RU', 'Russian Federation', 'EURO', '8536', '432277', '178', '5215');
INSERT INTO public.who_global_data_import VALUES (70154, '2020-06-04', 'RU', 'Russian Federation', 'EURO', '8831', '441108', '169', '5384');
INSERT INTO public.who_global_data_import VALUES (70155, '2020-06-05', 'RU', 'Russian Federation', 'EURO', '8726', '449834', '144', '5528');
INSERT INTO public.who_global_data_import VALUES (70156, '2020-06-06', 'RU', 'Russian Federation', 'EURO', '8855', '458689', '197', '5725');
INSERT INTO public.who_global_data_import VALUES (70157, '2020-06-07', 'RU', 'Russian Federation', 'EURO', '8984', '467673', '134', '5859');
INSERT INTO public.who_global_data_import VALUES (70158, '2020-06-08', 'RU', 'Russian Federation', 'EURO', '8985', '476658', '112', '5971');
INSERT INTO public.who_global_data_import VALUES (70159, '2020-06-09', 'RU', 'Russian Federation', 'EURO', '8595', '485253', '171', '6142');
INSERT INTO public.who_global_data_import VALUES (70160, '2020-06-10', 'RU', 'Russian Federation', 'EURO', '8404', '493657', '216', '6358');
INSERT INTO public.who_global_data_import VALUES (70161, '2020-06-11', 'RU', 'Russian Federation', 'EURO', '8779', '502436', '174', '6532');
INSERT INTO public.who_global_data_import VALUES (70162, '2020-06-12', 'RU', 'Russian Federation', 'EURO', '8987', '511423', '183', '6715');
INSERT INTO public.who_global_data_import VALUES (70163, '2020-06-13', 'RU', 'Russian Federation', 'EURO', '8706', '520129', '114', '6829');
INSERT INTO public.who_global_data_import VALUES (70164, '2020-06-14', 'RU', 'Russian Federation', 'EURO', '8835', '528964', '119', '6948');
INSERT INTO public.who_global_data_import VALUES (70165, '2020-06-15', 'RU', 'Russian Federation', 'EURO', '8246', '537210', '143', '7091');
INSERT INTO public.who_global_data_import VALUES (70166, '2020-06-16', 'RU', 'Russian Federation', 'EURO', '8248', '545458', '193', '7284');
INSERT INTO public.who_global_data_import VALUES (70167, '2020-06-17', 'RU', 'Russian Federation', 'EURO', '7843', '553301', '194', '7478');
INSERT INTO public.who_global_data_import VALUES (70168, '2020-06-18', 'RU', 'Russian Federation', 'EURO', '7790', '561091', '182', '7660');
INSERT INTO public.who_global_data_import VALUES (70169, '2020-06-19', 'RU', 'Russian Federation', 'EURO', '7972', '569063', '181', '7841');
INSERT INTO public.who_global_data_import VALUES (70170, '2020-06-20', 'RU', 'Russian Federation', 'EURO', '7889', '576952', '161', '8002');
INSERT INTO public.who_global_data_import VALUES (70171, '2020-06-21', 'RU', 'Russian Federation', 'EURO', '7728', '584680', '109', '8111');
INSERT INTO public.who_global_data_import VALUES (70172, '2020-06-22', 'RU', 'Russian Federation', 'EURO', '7600', '592280', '95', '8206');
INSERT INTO public.who_global_data_import VALUES (70173, '2020-06-23', 'RU', 'Russian Federation', 'EURO', '7425', '599705', '153', '8359');
INSERT INTO public.who_global_data_import VALUES (70174, '2020-06-24', 'RU', 'Russian Federation', 'EURO', '7176', '606881', '154', '8513');
INSERT INTO public.who_global_data_import VALUES (70175, '2020-06-25', 'RU', 'Russian Federation', 'EURO', '7113', '613994', '92', '8605');
INSERT INTO public.who_global_data_import VALUES (70176, '2020-06-26', 'RU', 'Russian Federation', 'EURO', '6800', '620794', '176', '8781');
INSERT INTO public.who_global_data_import VALUES (70177, '2020-06-27', 'RU', 'Russian Federation', 'EURO', '6852', '627646', '188', '8969');
INSERT INTO public.who_global_data_import VALUES (70178, '2020-06-28', 'RU', 'Russian Federation', 'EURO', '6791', '634437', '104', '9073');
INSERT INTO public.who_global_data_import VALUES (70179, '2020-06-29', 'RU', 'Russian Federation', 'EURO', '6719', '641156', '93', '9166');
INSERT INTO public.who_global_data_import VALUES (70180, '2020-06-30', 'RU', 'Russian Federation', 'EURO', '6693', '647849', '154', '9320');
INSERT INTO public.who_global_data_import VALUES (70181, '2020-07-01', 'RU', 'Russian Federation', 'EURO', '6556', '654405', '216', '9536');
INSERT INTO public.who_global_data_import VALUES (70182, '2020-07-02', 'RU', 'Russian Federation', 'EURO', '6760', '661165', '147', '9683');
INSERT INTO public.who_global_data_import VALUES (70183, '2020-07-03', 'RU', 'Russian Federation', 'EURO', '6718', '667883', '176', '9859');
INSERT INTO public.who_global_data_import VALUES (70184, '2020-07-04', 'RU', 'Russian Federation', 'EURO', '6632', '674515', '168', '10027');
INSERT INTO public.who_global_data_import VALUES (70185, '2020-07-05', 'RU', 'Russian Federation', 'EURO', '6736', '681251', '134', '10161');
INSERT INTO public.who_global_data_import VALUES (70186, '2020-07-06', 'RU', 'Russian Federation', 'EURO', '6611', '687862', '135', '10296');
INSERT INTO public.who_global_data_import VALUES (70187, '2020-07-07', 'RU', 'Russian Federation', 'EURO', '6368', '694230', '198', '10494');
INSERT INTO public.who_global_data_import VALUES (70188, '2020-07-08', 'RU', 'Russian Federation', 'EURO', '6562', '700792', '173', '10667');
INSERT INTO public.who_global_data_import VALUES (70189, '2020-07-09', 'RU', 'Russian Federation', 'EURO', '6509', '707301', '176', '10843');
INSERT INTO public.who_global_data_import VALUES (70190, '2020-07-10', 'RU', 'Russian Federation', 'EURO', '6635', '713936', '174', '11017');
INSERT INTO public.who_global_data_import VALUES (70191, '2020-07-11', 'RU', 'Russian Federation', 'EURO', '6611', '720547', '188', '11205');
INSERT INTO public.who_global_data_import VALUES (70192, '2020-07-12', 'RU', 'Russian Federation', 'EURO', '6615', '727162', '130', '11335');
INSERT INTO public.who_global_data_import VALUES (70193, '2020-07-13', 'RU', 'Russian Federation', 'EURO', '6537', '733699', '104', '11439');
INSERT INTO public.who_global_data_import VALUES (70194, '2020-07-14', 'RU', 'Russian Federation', 'EURO', '6248', '739947', '175', '11614');
INSERT INTO public.who_global_data_import VALUES (70195, '2020-07-15', 'RU', 'Russian Federation', 'EURO', '6422', '746369', '156', '11770');
INSERT INTO public.who_global_data_import VALUES (70196, '2020-07-16', 'RU', 'Russian Federation', 'EURO', '6428', '752797', '167', '11937');
INSERT INTO public.who_global_data_import VALUES (70197, '2020-07-17', 'RU', 'Russian Federation', 'EURO', '6406', '759203', '186', '12123');
INSERT INTO public.who_global_data_import VALUES (70198, '2020-07-18', 'RU', 'Russian Federation', 'EURO', '6234', '765437', '124', '12247');
INSERT INTO public.who_global_data_import VALUES (70199, '2020-07-19', 'RU', 'Russian Federation', 'EURO', '6109', '771546', '95', '12342');
INSERT INTO public.who_global_data_import VALUES (70200, '2020-07-20', 'RU', 'Russian Federation', 'EURO', '5940', '777486', '85', '12427');
INSERT INTO public.who_global_data_import VALUES (70201, '2020-07-21', 'RU', 'Russian Federation', 'EURO', '5842', '783328', '153', '12580');
INSERT INTO public.who_global_data_import VALUES (70202, '2020-07-22', 'RU', 'Russian Federation', 'EURO', '5862', '789190', '165', '12745');
INSERT INTO public.who_global_data_import VALUES (70474, '2020-03-16', 'RW', 'Rwanda', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70203, '2020-07-23', 'RU', 'Russian Federation', 'EURO', '5848', '795038', '147', '12892');
INSERT INTO public.who_global_data_import VALUES (70204, '2020-07-24', 'RU', 'Russian Federation', 'EURO', '5811', '800849', '154', '13046');
INSERT INTO public.who_global_data_import VALUES (70205, '2020-07-25', 'RU', 'Russian Federation', 'EURO', '5871', '806720', '146', '13192');
INSERT INTO public.who_global_data_import VALUES (70206, '2020-07-26', 'RU', 'Russian Federation', 'EURO', '5765', '812485', '77', '13269');
INSERT INTO public.who_global_data_import VALUES (70207, '2020-07-27', 'RU', 'Russian Federation', 'EURO', '5635', '818120', '85', '13354');
INSERT INTO public.who_global_data_import VALUES (70208, '2020-07-28', 'RU', 'Russian Federation', 'EURO', '5395', '823515', '150', '13504');
INSERT INTO public.who_global_data_import VALUES (70209, '2020-07-29', 'RU', 'Russian Federation', 'EURO', '5475', '828990', '169', '13673');
INSERT INTO public.who_global_data_import VALUES (70210, '2020-07-30', 'RU', 'Russian Federation', 'EURO', '5509', '834499', '129', '13802');
INSERT INTO public.who_global_data_import VALUES (70211, '2020-07-31', 'RU', 'Russian Federation', 'EURO', '5482', '839981', '161', '13963');
INSERT INTO public.who_global_data_import VALUES (70212, '2020-08-01', 'RU', 'Russian Federation', 'EURO', '5462', '845443', '95', '14058');
INSERT INTO public.who_global_data_import VALUES (70213, '2020-08-02', 'RU', 'Russian Federation', 'EURO', '5427', '850870', '70', '14128');
INSERT INTO public.who_global_data_import VALUES (70214, '2020-08-03', 'RU', 'Russian Federation', 'EURO', '5394', '856264', '79', '14207');
INSERT INTO public.who_global_data_import VALUES (70215, '2020-08-04', 'RU', 'Russian Federation', 'EURO', '5159', '861423', '144', '14351');
INSERT INTO public.who_global_data_import VALUES (70216, '2020-08-05', 'RU', 'Russian Federation', 'EURO', '5204', '866627', '139', '14490');
INSERT INTO public.who_global_data_import VALUES (70217, '2020-08-06', 'RU', 'Russian Federation', 'EURO', '5267', '871894', '116', '14606');
INSERT INTO public.who_global_data_import VALUES (70218, '2020-08-07', 'RU', 'Russian Federation', 'EURO', '5241', '877135', '119', '14725');
INSERT INTO public.who_global_data_import VALUES (70219, '2020-08-08', 'RU', 'Russian Federation', 'EURO', '5212', '882347', '129', '14854');
INSERT INTO public.who_global_data_import VALUES (70220, '2020-08-09', 'RU', 'Russian Federation', 'EURO', '5189', '887536', '77', '14931');
INSERT INTO public.who_global_data_import VALUES (70221, '2020-08-10', 'RU', 'Russian Federation', 'EURO', '5118', '892654', '70', '15001');
INSERT INTO public.who_global_data_import VALUES (70222, '2020-08-11', 'RU', 'Russian Federation', 'EURO', '4945', '897599', '130', '15131');
INSERT INTO public.who_global_data_import VALUES (70223, '2020-08-12', 'RU', 'Russian Federation', 'EURO', '5102', '902701', '129', '15260');
INSERT INTO public.who_global_data_import VALUES (70224, '2020-08-13', 'RU', 'Russian Federation', 'EURO', '5057', '907758', '124', '15384');
INSERT INTO public.who_global_data_import VALUES (70225, '2020-08-14', 'RU', 'Russian Federation', 'EURO', '5065', '912823', '114', '15498');
INSERT INTO public.who_global_data_import VALUES (70226, '2020-08-15', 'RU', 'Russian Federation', 'EURO', '5061', '917884', '119', '15617');
INSERT INTO public.who_global_data_import VALUES (70227, '2020-08-16', 'RU', 'Russian Federation', 'EURO', '4969', '922853', '68', '15685');
INSERT INTO public.who_global_data_import VALUES (70228, '2020-08-17', 'RU', 'Russian Federation', 'EURO', '4892', '927745', '55', '15740');
INSERT INTO public.who_global_data_import VALUES (70229, '2020-08-18', 'RU', 'Russian Federation', 'EURO', '4748', '932493', '132', '15872');
INSERT INTO public.who_global_data_import VALUES (70230, '2020-08-19', 'RU', 'Russian Federation', 'EURO', '4828', '937321', '117', '15989');
INSERT INTO public.who_global_data_import VALUES (70231, '2020-08-20', 'RU', 'Russian Federation', 'EURO', '4785', '942106', '110', '16099');
INSERT INTO public.who_global_data_import VALUES (70232, '2020-08-21', 'RU', 'Russian Federation', 'EURO', '4870', '946976', '90', '16189');
INSERT INTO public.who_global_data_import VALUES (70233, '2020-08-22', 'RU', 'Russian Federation', 'EURO', '4921', '951897', '121', '16310');
INSERT INTO public.who_global_data_import VALUES (70234, '2020-08-23', 'RU', 'Russian Federation', 'EURO', '4852', '956749', '73', '16383');
INSERT INTO public.who_global_data_import VALUES (70235, '2020-08-24', 'RU', 'Russian Federation', 'EURO', '4744', '961493', '65', '16448');
INSERT INTO public.who_global_data_import VALUES (70236, '2020-08-25', 'RU', 'Russian Federation', 'EURO', '4696', '966189', '120', '16568');
INSERT INTO public.who_global_data_import VALUES (70237, '2020-08-26', 'RU', 'Russian Federation', 'EURO', '4676', '970865', '115', '16683');
INSERT INTO public.who_global_data_import VALUES (70238, '2020-08-27', 'RU', 'Russian Federation', 'EURO', '4711', '975576', '121', '16804');
INSERT INTO public.who_global_data_import VALUES (70239, '2020-08-28', 'RU', 'Russian Federation', 'EURO', '4829', '980405', '110', '16914');
INSERT INTO public.who_global_data_import VALUES (70240, '2020-08-29', 'RU', 'Russian Federation', 'EURO', '4941', '985346', '111', '17025');
INSERT INTO public.who_global_data_import VALUES (70241, '2020-08-30', 'RU', 'Russian Federation', 'EURO', '4980', '990326', '68', '17093');
INSERT INTO public.who_global_data_import VALUES (70242, '2020-08-31', 'RU', 'Russian Federation', 'EURO', '4993', '995319', '83', '17176');
INSERT INTO public.who_global_data_import VALUES (70243, '2020-09-01', 'RU', 'Russian Federation', 'EURO', '4729', '1000048', '123', '17299');
INSERT INTO public.who_global_data_import VALUES (70244, '2020-09-02', 'RU', 'Russian Federation', 'EURO', '4952', '1005000', '115', '17414');
INSERT INTO public.who_global_data_import VALUES (70245, '2020-09-03', 'RU', 'Russian Federation', 'EURO', '4995', '1009995', '114', '17528');
INSERT INTO public.who_global_data_import VALUES (70246, '2020-09-04', 'RU', 'Russian Federation', 'EURO', '5110', '1015105', '121', '17649');
INSERT INTO public.who_global_data_import VALUES (70247, '2020-09-05', 'RU', 'Russian Federation', 'EURO', '5205', '1020310', '110', '17759');
INSERT INTO public.who_global_data_import VALUES (70248, '2020-09-06', 'RU', 'Russian Federation', 'EURO', '5195', '1025505', '61', '17820');
INSERT INTO public.who_global_data_import VALUES (70249, '2020-09-07', 'RU', 'Russian Federation', 'EURO', '5185', '1030690', '51', '17871');
INSERT INTO public.who_global_data_import VALUES (70250, '2020-09-08', 'RU', 'Russian Federation', 'EURO', '5099', '1035789', '122', '17993');
INSERT INTO public.who_global_data_import VALUES (70251, '2020-09-09', 'RU', 'Russian Federation', 'EURO', '5218', '1041007', '142', '18135');
INSERT INTO public.who_global_data_import VALUES (70252, '2020-09-10', 'RU', 'Russian Federation', 'EURO', '5363', '1046370', '128', '18263');
INSERT INTO public.who_global_data_import VALUES (70253, '2020-09-11', 'RU', 'Russian Federation', 'EURO', '5504', '1051874', '102', '18365');
INSERT INTO public.who_global_data_import VALUES (70254, '2020-09-12', 'RU', 'Russian Federation', 'EURO', '5488', '1057362', '119', '18484');
INSERT INTO public.who_global_data_import VALUES (70255, '2020-09-13', 'RU', 'Russian Federation', 'EURO', '5449', '1062811', '94', '18578');
INSERT INTO public.who_global_data_import VALUES (70256, '2020-09-14', 'RU', 'Russian Federation', 'EURO', '5509', '1068320', '57', '18635');
INSERT INTO public.who_global_data_import VALUES (70257, '2020-09-15', 'RU', 'Russian Federation', 'EURO', '5529', '1073849', '150', '18785');
INSERT INTO public.who_global_data_import VALUES (70258, '2020-09-16', 'RU', 'Russian Federation', 'EURO', '5670', '1079519', '132', '18917');
INSERT INTO public.who_global_data_import VALUES (70259, '2020-09-17', 'RU', 'Russian Federation', 'EURO', '5762', '1085281', '144', '19061');
INSERT INTO public.who_global_data_import VALUES (70260, '2020-09-18', 'RU', 'Russian Federation', 'EURO', '5905', '1091186', '134', '19195');
INSERT INTO public.who_global_data_import VALUES (70261, '2020-09-19', 'RU', 'Russian Federation', 'EURO', '6065', '1097251', '144', '19339');
INSERT INTO public.who_global_data_import VALUES (70262, '2020-09-20', 'RU', 'Russian Federation', 'EURO', '6148', '1103399', '79', '19418');
INSERT INTO public.who_global_data_import VALUES (70263, '2020-09-21', 'RU', 'Russian Federation', 'EURO', '6196', '1109595', '71', '19489');
INSERT INTO public.who_global_data_import VALUES (70264, '2020-09-22', 'RU', 'Russian Federation', 'EURO', '6215', '1115810', '160', '19649');
INSERT INTO public.who_global_data_import VALUES (70265, '2020-09-23', 'RU', 'Russian Federation', 'EURO', '6431', '1122241', '150', '19799');
INSERT INTO public.who_global_data_import VALUES (70266, '2020-09-24', 'RU', 'Russian Federation', 'EURO', '6595', '1128836', '149', '19948');
INSERT INTO public.who_global_data_import VALUES (70267, '2020-09-25', 'RU', 'Russian Federation', 'EURO', '7212', '1136048', '108', '20056');
INSERT INTO public.who_global_data_import VALUES (70268, '2020-09-26', 'RU', 'Russian Federation', 'EURO', '7523', '1143571', '169', '20225');
INSERT INTO public.who_global_data_import VALUES (70269, '2020-09-27', 'RU', 'Russian Federation', 'EURO', '7867', '1151438', '99', '20324');
INSERT INTO public.who_global_data_import VALUES (70270, '2020-09-28', 'RU', 'Russian Federation', 'EURO', '8135', '1159573', '61', '20385');
INSERT INTO public.who_global_data_import VALUES (70271, '2020-09-29', 'RU', 'Russian Federation', 'EURO', '8232', '1167805', '160', '20545');
INSERT INTO public.who_global_data_import VALUES (70272, '2020-09-30', 'RU', 'Russian Federation', 'EURO', '8481', '1176286', '177', '20722');
INSERT INTO public.who_global_data_import VALUES (70273, '2020-10-01', 'RU', 'Russian Federation', 'EURO', '8945', '1185231', '169', '20891');
INSERT INTO public.who_global_data_import VALUES (70274, '2020-10-02', 'RU', 'Russian Federation', 'EURO', '9412', '1194643', '186', '21077');
INSERT INTO public.who_global_data_import VALUES (70275, '2020-10-03', 'RU', 'Russian Federation', 'EURO', '9859', '1204502', '174', '21251');
INSERT INTO public.who_global_data_import VALUES (70276, '2020-10-04', 'RU', 'Russian Federation', 'EURO', '10499', '1215001', '107', '21358');
INSERT INTO public.who_global_data_import VALUES (70277, '2020-10-05', 'RU', 'Russian Federation', 'EURO', '10888', '1225889', '117', '21475');
INSERT INTO public.who_global_data_import VALUES (70278, '2020-10-06', 'RU', 'Russian Federation', 'EURO', '11615', '1237504', '188', '21663');
INSERT INTO public.who_global_data_import VALUES (70279, '2020-10-07', 'RU', 'Russian Federation', 'EURO', '11115', '1248619', '202', '21865');
INSERT INTO public.who_global_data_import VALUES (70280, '2020-10-08', 'RU', 'Russian Federation', 'EURO', '11493', '1260112', '191', '22056');
INSERT INTO public.who_global_data_import VALUES (70281, '2020-10-09', 'RU', 'Russian Federation', 'EURO', '12126', '1272238', '201', '22257');
INSERT INTO public.who_global_data_import VALUES (70282, '2020-10-10', 'RU', 'Russian Federation', 'EURO', '12846', '1285084', '197', '22454');
INSERT INTO public.who_global_data_import VALUES (70283, '2020-10-11', 'RU', 'Russian Federation', 'EURO', '13634', '1298718', '143', '22597');
INSERT INTO public.who_global_data_import VALUES (70284, '2020-10-12', 'RU', 'Russian Federation', 'EURO', '13592', '1312310', '125', '22722');
INSERT INTO public.who_global_data_import VALUES (70285, '2020-10-13', 'RU', 'Russian Federation', 'EURO', '13868', '1326178', '244', '22966');
INSERT INTO public.who_global_data_import VALUES (70286, '2020-10-14', 'RU', 'Russian Federation', 'EURO', '14231', '1340409', '239', '23205');
INSERT INTO public.who_global_data_import VALUES (70287, '2020-10-15', 'RU', 'Russian Federation', 'EURO', '13754', '1354163', '286', '23491');
INSERT INTO public.who_global_data_import VALUES (70288, '2020-10-16', 'RU', 'Russian Federation', 'EURO', '15150', '1369313', '232', '23723');
INSERT INTO public.who_global_data_import VALUES (70289, '2020-10-17', 'RU', 'Russian Federation', 'EURO', '14922', '1384235', '279', '24002');
INSERT INTO public.who_global_data_import VALUES (70290, '2020-10-18', 'RU', 'Russian Federation', 'EURO', '15099', '1399334', '185', '24187');
INSERT INTO public.who_global_data_import VALUES (70291, '2020-10-19', 'RU', 'Russian Federation', 'EURO', '15982', '1415316', '179', '24366');
INSERT INTO public.who_global_data_import VALUES (70292, '2020-10-20', 'RU', 'Russian Federation', 'EURO', '16319', '1431635', '269', '24635');
INSERT INTO public.who_global_data_import VALUES (70293, '2020-10-21', 'RU', 'Russian Federation', 'EURO', '15700', '1447335', '317', '24952');
INSERT INTO public.who_global_data_import VALUES (70294, '2020-10-22', 'RU', 'Russian Federation', 'EURO', '15971', '1463306', '290', '25242');
INSERT INTO public.who_global_data_import VALUES (70295, '2020-10-23', 'RU', 'Russian Federation', 'EURO', '17340', '1480646', '283', '25525');
INSERT INTO public.who_global_data_import VALUES (70296, '2020-10-24', 'RU', 'Russian Federation', 'EURO', '16521', '1497167', '296', '25821');
INSERT INTO public.who_global_data_import VALUES (70297, '2020-10-25', 'RU', 'Russian Federation', 'EURO', '16710', '1513877', '229', '26050');
INSERT INTO public.who_global_data_import VALUES (70298, '2020-10-26', 'RU', 'Russian Federation', 'EURO', '17347', '1531224', '219', '26269');
INSERT INTO public.who_global_data_import VALUES (70299, '2020-10-27', 'RU', 'Russian Federation', 'EURO', '16550', '1547774', '320', '26589');
INSERT INTO public.who_global_data_import VALUES (70300, '2020-10-28', 'RU', 'Russian Federation', 'EURO', '16202', '1563976', '346', '26935');
INSERT INTO public.who_global_data_import VALUES (70301, '2020-10-29', 'RU', 'Russian Federation', 'EURO', '17717', '1581693', '366', '27301');
INSERT INTO public.who_global_data_import VALUES (70302, '2020-10-30', 'RU', 'Russian Federation', 'EURO', '18283', '1599976', '355', '27656');
INSERT INTO public.who_global_data_import VALUES (70303, '2020-10-31', 'RU', 'Russian Federation', 'EURO', '18140', '1618116', '334', '27990');
INSERT INTO public.who_global_data_import VALUES (70304, '2020-11-01', 'RU', 'Russian Federation', 'EURO', '18665', '1636781', '245', '28235');
INSERT INTO public.who_global_data_import VALUES (70305, '2020-11-02', 'RU', 'Russian Federation', 'EURO', '18253', '1655034', '238', '28473');
INSERT INTO public.who_global_data_import VALUES (70306, '2020-11-03', 'RU', 'Russian Federation', 'EURO', '18652', '1673686', '355', '28828');
INSERT INTO public.who_global_data_import VALUES (70307, '2020-11-04', 'RU', 'Russian Federation', 'EURO', '19768', '1693454', '389', '29217');
INSERT INTO public.who_global_data_import VALUES (70308, '2020-11-05', 'RU', 'Russian Federation', 'EURO', '19404', '1712858', '292', '29509');
INSERT INTO public.who_global_data_import VALUES (70309, '2020-11-06', 'RU', 'Russian Federation', 'EURO', '20582', '1733440', '378', '29887');
INSERT INTO public.who_global_data_import VALUES (70310, '2020-11-07', 'RU', 'Russian Federation', 'EURO', '20396', '1753836', '364', '30251');
INSERT INTO public.who_global_data_import VALUES (70311, '2020-11-08', 'RU', 'Russian Federation', 'EURO', '20498', '1774334', '286', '30537');
INSERT INTO public.who_global_data_import VALUES (70312, '2020-11-09', 'RU', 'Russian Federation', 'EURO', '21798', '1796132', '256', '30793');
INSERT INTO public.who_global_data_import VALUES (70313, '2020-11-10', 'RU', 'Russian Federation', 'EURO', '20977', '1817109', '368', '31161');
INSERT INTO public.who_global_data_import VALUES (70314, '2020-11-11', 'RU', 'Russian Federation', 'EURO', '19851', '1836960', '432', '31593');
INSERT INTO public.who_global_data_import VALUES (70315, '2020-11-12', 'RU', 'Russian Federation', 'EURO', '21608', '1858568', '439', '32032');
INSERT INTO public.who_global_data_import VALUES (70316, '2020-11-13', 'RU', 'Russian Federation', 'EURO', '21983', '1880551', '411', '32443');
INSERT INTO public.who_global_data_import VALUES (70317, '2020-11-14', 'RU', 'Russian Federation', 'EURO', '22702', '1903253', '391', '32834');
INSERT INTO public.who_global_data_import VALUES (70318, '2020-11-15', 'RU', 'Russian Federation', 'EURO', '22572', '1925825', '352', '33186');
INSERT INTO public.who_global_data_import VALUES (70319, '2020-11-16', 'RU', 'Russian Federation', 'EURO', '22778', '1948603', '303', '33489');
INSERT INTO public.who_global_data_import VALUES (70320, '2020-11-17', 'RU', 'Russian Federation', 'EURO', '22410', '1971013', '442', '33931');
INSERT INTO public.who_global_data_import VALUES (70321, '2020-11-18', 'RU', 'Russian Federation', 'EURO', '20985', '1991998', '456', '34387');
INSERT INTO public.who_global_data_import VALUES (70322, '2020-11-19', 'RU', 'Russian Federation', 'EURO', '23610', '2015608', '463', '34850');
INSERT INTO public.who_global_data_import VALUES (70323, '2020-11-20', 'RU', 'Russian Federation', 'EURO', '24318', '2039926', '461', '35311');
INSERT INTO public.who_global_data_import VALUES (70324, '2020-11-21', 'RU', 'Russian Federation', 'EURO', '24822', '2064748', '467', '35778');
INSERT INTO public.who_global_data_import VALUES (70325, '2020-11-22', 'RU', 'Russian Federation', 'EURO', '24581', '2089329', '401', '36179');
INSERT INTO public.who_global_data_import VALUES (70326, '2020-11-23', 'RU', 'Russian Federation', 'EURO', '25173', '2114502', '361', '36540');
INSERT INTO public.who_global_data_import VALUES (70327, '2020-11-24', 'RU', 'Russian Federation', 'EURO', '24326', '2138828', '491', '37031');
INSERT INTO public.who_global_data_import VALUES (70328, '2020-11-25', 'RU', 'Russian Federation', 'EURO', '23675', '2162503', '507', '37538');
INSERT INTO public.who_global_data_import VALUES (70329, '2020-11-26', 'RU', 'Russian Federation', 'EURO', '25487', '2187990', '524', '38062');
INSERT INTO public.who_global_data_import VALUES (70330, '2020-11-27', 'RU', 'Russian Federation', 'EURO', '27543', '2215533', '496', '38558');
INSERT INTO public.who_global_data_import VALUES (70331, '2020-11-28', 'RU', 'Russian Federation', 'EURO', '27100', '2242633', '510', '39068');
INSERT INTO public.who_global_data_import VALUES (70332, '2020-11-29', 'RU', 'Russian Federation', 'EURO', '26683', '2269316', '459', '39527');
INSERT INTO public.who_global_data_import VALUES (70333, '2020-11-30', 'RU', 'Russian Federation', 'EURO', '26338', '2295654', '368', '39895');
INSERT INTO public.who_global_data_import VALUES (70334, '2020-12-01', 'RU', 'Russian Federation', 'EURO', '26402', '2322056', '569', '40464');
INSERT INTO public.who_global_data_import VALUES (70335, '2020-12-02', 'RU', 'Russian Federation', 'EURO', '25345', '2347401', '589', '41053');
INSERT INTO public.who_global_data_import VALUES (70336, '2020-12-03', 'RU', 'Russian Federation', 'EURO', '28145', '2375546', '554', '41607');
INSERT INTO public.who_global_data_import VALUES (70337, '2020-12-04', 'RU', 'Russian Federation', 'EURO', '27403', '2402949', '569', '42176');
INSERT INTO public.who_global_data_import VALUES (70338, '2020-12-05', 'RU', 'Russian Federation', 'EURO', '28782', '2431731', '508', '42684');
INSERT INTO public.who_global_data_import VALUES (70339, '2020-12-06', 'RU', 'Russian Federation', 'EURO', '29039', '2460770', '457', '43141');
INSERT INTO public.who_global_data_import VALUES (70340, '2020-12-07', 'RU', 'Russian Federation', 'EURO', '28142', '2488912', '456', '43597');
INSERT INTO public.who_global_data_import VALUES (70341, '2020-12-08', 'RU', 'Russian Federation', 'EURO', '26097', '2515009', '562', '44159');
INSERT INTO public.who_global_data_import VALUES (70342, '2020-12-09', 'RU', 'Russian Federation', 'EURO', '26190', '2541199', '559', '44718');
INSERT INTO public.who_global_data_import VALUES (70343, '2020-12-10', 'RU', 'Russian Federation', 'EURO', '27927', '2569126', '562', '45280');
INSERT INTO public.who_global_data_import VALUES (70344, '2020-12-11', 'RU', 'Russian Federation', 'EURO', '28585', '2597711', '613', '45893');
INSERT INTO public.who_global_data_import VALUES (70345, '2020-12-12', 'RU', 'Russian Federation', 'EURO', '28137', '2625848', '560', '46453');
INSERT INTO public.who_global_data_import VALUES (70346, '2020-12-13', 'RU', 'Russian Federation', 'EURO', '28080', '2653928', '488', '46941');
INSERT INTO public.who_global_data_import VALUES (70347, '2020-12-14', 'RU', 'Russian Federation', 'EURO', '27328', '2681256', '450', '47391');
INSERT INTO public.who_global_data_import VALUES (70348, '2020-12-15', 'RU', 'Russian Federation', 'EURO', '26689', '2707945', '577', '47968');
INSERT INTO public.who_global_data_import VALUES (70349, '2020-12-16', 'RU', 'Russian Federation', 'EURO', '26509', '2734454', '596', '48564');
INSERT INTO public.who_global_data_import VALUES (70350, '2020-12-17', 'RU', 'Russian Federation', 'EURO', '28214', '2762668', '587', '49151');
INSERT INTO public.who_global_data_import VALUES (70351, '2020-12-18', 'RU', 'Russian Federation', 'EURO', '28552', '2791220', '611', '49762');
INSERT INTO public.who_global_data_import VALUES (70352, '2020-12-19', 'RU', 'Russian Federation', 'EURO', '28209', '2819429', '585', '50347');
INSERT INTO public.who_global_data_import VALUES (70353, '2020-12-20', 'RU', 'Russian Federation', 'EURO', '28948', '2848377', '511', '50858');
INSERT INTO public.who_global_data_import VALUES (70354, '2020-12-21', 'RU', 'Russian Federation', 'EURO', '29350', '2877727', '493', '51351');
INSERT INTO public.who_global_data_import VALUES (70355, '2020-12-22', 'RU', 'Russian Federation', 'EURO', '28776', '2906503', '561', '51912');
INSERT INTO public.who_global_data_import VALUES (70356, '2020-12-23', 'RU', 'Russian Federation', 'EURO', '27250', '2933753', '549', '52461');
INSERT INTO public.who_global_data_import VALUES (70357, '2020-12-24', 'RU', 'Russian Federation', 'EURO', '29935', '2963688', '635', '53096');
INSERT INTO public.who_global_data_import VALUES (70358, '2020-12-25', 'RU', 'Russian Federation', 'EURO', '29018', '2992706', '563', '53659');
INSERT INTO public.who_global_data_import VALUES (70359, '2020-12-26', 'RU', 'Russian Federation', 'EURO', '29258', '3021964', '567', '54226');
INSERT INTO public.who_global_data_import VALUES (70360, '2020-12-27', 'RU', 'Russian Federation', 'EURO', '28284', '3050248', '552', '54778');
INSERT INTO public.who_global_data_import VALUES (70361, '2020-12-28', 'RU', 'Russian Federation', 'EURO', '27787', '3078035', '487', '55265');
INSERT INTO public.who_global_data_import VALUES (70362, '2020-12-29', 'RU', 'Russian Federation', 'EURO', '27002', '3105037', '562', '55827');
INSERT INTO public.who_global_data_import VALUES (70363, '2020-12-30', 'RU', 'Russian Federation', 'EURO', '26513', '3131550', '599', '56426');
INSERT INTO public.who_global_data_import VALUES (70364, '2020-12-31', 'RU', 'Russian Federation', 'EURO', '27747', '3159297', '593', '57019');
INSERT INTO public.who_global_data_import VALUES (70365, '2021-01-01', 'RU', 'Russian Federation', 'EURO', '27039', '3186336', '536', '57555');
INSERT INTO public.who_global_data_import VALUES (70366, '2021-01-02', 'RU', 'Russian Federation', 'EURO', '26301', '3212637', '447', '58002');
INSERT INTO public.who_global_data_import VALUES (70367, '2021-01-03', 'RU', 'Russian Federation', 'EURO', '24150', '3236787', '504', '58506');
INSERT INTO public.who_global_data_import VALUES (70368, '2021-01-04', 'RU', 'Russian Federation', 'EURO', '23351', '3260138', '482', '58988');
INSERT INTO public.who_global_data_import VALUES (70475, '2020-03-17', 'RW', 'Rwanda', 'AFRO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70369, '2021-01-05', 'RU', 'Russian Federation', 'EURO', '24246', '3284384', '518', '59506');
INSERT INTO public.who_global_data_import VALUES (70370, '2021-01-06', 'RU', 'Russian Federation', 'EURO', '24217', '3308601', '445', '59951');
INSERT INTO public.who_global_data_import VALUES (70371, '2021-01-07', 'RU', 'Russian Federation', 'EURO', '23541', '3332142', '506', '60457');
INSERT INTO public.who_global_data_import VALUES (70372, '2021-01-08', 'RU', 'Russian Federation', 'EURO', '23652', '3355794', '454', '60911');
INSERT INTO public.who_global_data_import VALUES (70373, '2021-01-09', 'RU', 'Russian Federation', 'EURO', '23309', '3379103', '470', '61381');
INSERT INTO public.who_global_data_import VALUES (70374, '2021-01-10', 'RU', 'Russian Federation', 'EURO', '22851', '3401954', '456', '61837');
INSERT INTO public.who_global_data_import VALUES (70375, '2021-01-11', 'RU', 'Russian Federation', 'EURO', '23315', '3425269', '436', '62273');
INSERT INTO public.who_global_data_import VALUES (70376, '2021-01-12', 'RU', 'Russian Federation', 'EURO', '22934', '3448203', '531', '62804');
INSERT INTO public.who_global_data_import VALUES (70377, '2021-01-13', 'RU', 'Russian Federation', 'EURO', '22850', '3471053', '566', '63370');
INSERT INTO public.who_global_data_import VALUES (70378, '2021-01-14', 'RU', 'Russian Federation', 'EURO', '24763', '3495816', '570', '63940');
INSERT INTO public.who_global_data_import VALUES (70379, '2021-01-15', 'RU', 'Russian Federation', 'EURO', '24715', '3520531', '555', '64495');
INSERT INTO public.who_global_data_import VALUES (70380, '2021-01-16', 'RU', 'Russian Federation', 'EURO', '24092', '3544623', '590', '65085');
INSERT INTO public.who_global_data_import VALUES (70381, '2021-01-17', 'RU', 'Russian Federation', 'EURO', '23586', '3568209', '481', '65566');
INSERT INTO public.who_global_data_import VALUES (70382, '2021-01-18', 'RU', 'Russian Federation', 'EURO', '22857', '3591066', '471', '66037');
INSERT INTO public.who_global_data_import VALUES (70383, '2021-01-19', 'RU', 'Russian Federation', 'EURO', '21734', '3612800', '586', '66623');
INSERT INTO public.who_global_data_import VALUES (70384, '2021-01-20', 'RU', 'Russian Federation', 'EURO', '21152', '3633952', '597', '67220');
INSERT INTO public.who_global_data_import VALUES (70385, '2021-01-21', 'RU', 'Russian Federation', 'EURO', '21887', '3655839', '612', '67832');
INSERT INTO public.who_global_data_import VALUES (70386, '2021-01-22', 'RU', 'Russian Federation', 'EURO', '21513', '3677352', '580', '68412');
INSERT INTO public.who_global_data_import VALUES (70387, '2021-01-23', 'RU', 'Russian Federation', 'EURO', '20921', '3698273', '559', '68971');
INSERT INTO public.who_global_data_import VALUES (70388, '2021-01-24', 'RU', 'Russian Federation', 'EURO', '21127', '3719400', '491', '69462');
INSERT INTO public.who_global_data_import VALUES (70389, '2021-01-25', 'RU', 'Russian Federation', 'EURO', '19290', '3738690', '456', '69918');
INSERT INTO public.who_global_data_import VALUES (70390, '2021-01-26', 'RU', 'Russian Federation', 'EURO', '18241', '3756931', '564', '70482');
INSERT INTO public.who_global_data_import VALUES (70391, '2021-01-27', 'RU', 'Russian Federation', 'EURO', '17741', '3774672', '594', '71076');
INSERT INTO public.who_global_data_import VALUES (70392, '2021-01-28', 'RU', 'Russian Federation', 'EURO', '19138', '3793810', '575', '71651');
INSERT INTO public.who_global_data_import VALUES (70393, '2021-01-29', 'RU', 'Russian Federation', 'EURO', '19238', '3813048', '534', '72185');
INSERT INTO public.who_global_data_import VALUES (70394, '2021-01-30', 'RU', 'Russian Federation', 'EURO', '19032', '3832080', '512', '72697');
INSERT INTO public.who_global_data_import VALUES (70395, '2021-01-31', 'RU', 'Russian Federation', 'EURO', '18359', '3850439', '485', '73182');
INSERT INTO public.who_global_data_import VALUES (70396, '2021-02-01', 'RU', 'Russian Federation', 'EURO', '17648', '3868087', '437', '73619');
INSERT INTO public.who_global_data_import VALUES (70397, '2021-02-02', 'RU', 'Russian Federation', 'EURO', '16643', '3884730', '539', '74158');
INSERT INTO public.who_global_data_import VALUES (70398, '2021-02-03', 'RU', 'Russian Federation', 'EURO', '16474', '3901204', '526', '74684');
INSERT INTO public.who_global_data_import VALUES (70399, '2021-02-04', 'RU', 'Russian Federation', 'EURO', '16714', '3917918', '521', '75205');
INSERT INTO public.who_global_data_import VALUES (70400, '2021-02-05', 'RU', 'Russian Federation', 'EURO', '16688', '3934606', '527', '75732');
INSERT INTO public.who_global_data_import VALUES (70401, '2020-01-03', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70402, '2020-01-04', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70403, '2020-01-05', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70404, '2020-01-06', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70405, '2020-01-07', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70406, '2020-01-08', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70407, '2020-01-09', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70408, '2020-01-10', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70409, '2020-01-11', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70410, '2020-01-12', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70411, '2020-01-13', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70412, '2020-01-14', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70413, '2020-01-15', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70414, '2020-01-16', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70415, '2020-01-17', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70416, '2020-01-18', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70417, '2020-01-19', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70418, '2020-01-20', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70419, '2020-01-21', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70420, '2020-01-22', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70421, '2020-01-23', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70422, '2020-01-24', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70423, '2020-01-25', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70424, '2020-01-26', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70425, '2020-01-27', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70426, '2020-01-28', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70427, '2020-01-29', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70428, '2020-01-30', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70429, '2020-01-31', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70430, '2020-02-01', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70431, '2020-02-02', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70432, '2020-02-03', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70433, '2020-02-04', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70434, '2020-02-05', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70435, '2020-02-06', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70436, '2020-02-07', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70437, '2020-02-08', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70438, '2020-02-09', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70439, '2020-02-10', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70440, '2020-02-11', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70441, '2020-02-12', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70442, '2020-02-13', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70443, '2020-02-14', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70444, '2020-02-15', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70445, '2020-02-16', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70446, '2020-02-17', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70447, '2020-02-18', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70448, '2020-02-19', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70449, '2020-02-20', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70450, '2020-02-21', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70451, '2020-02-22', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70452, '2020-02-23', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70453, '2020-02-24', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70454, '2020-02-25', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70455, '2020-02-26', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70456, '2020-02-27', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70457, '2020-02-28', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70458, '2020-02-29', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70459, '2020-03-01', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70460, '2020-03-02', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70461, '2020-03-03', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70462, '2020-03-04', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70463, '2020-03-05', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70464, '2020-03-06', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70465, '2020-03-07', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70466, '2020-03-08', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70467, '2020-03-09', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70468, '2020-03-10', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70469, '2020-03-11', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70470, '2020-03-12', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70471, '2020-03-13', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70472, '2020-03-14', 'RW', 'Rwanda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70473, '2020-03-15', 'RW', 'Rwanda', 'AFRO', '9', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70476, '2020-03-18', 'RW', 'Rwanda', 'AFRO', '4', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70477, '2020-03-19', 'RW', 'Rwanda', 'AFRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70478, '2020-03-20', 'RW', 'Rwanda', 'AFRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70479, '2020-03-21', 'RW', 'Rwanda', 'AFRO', '2', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70480, '2020-03-22', 'RW', 'Rwanda', 'AFRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70481, '2020-03-23', 'RW', 'Rwanda', 'AFRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70482, '2020-03-24', 'RW', 'Rwanda', 'AFRO', '19', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70483, '2020-03-25', 'RW', 'Rwanda', 'AFRO', '4', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70484, '2020-03-26', 'RW', 'Rwanda', 'AFRO', '1', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70485, '2020-03-27', 'RW', 'Rwanda', 'AFRO', '9', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70486, '2020-03-28', 'RW', 'Rwanda', 'AFRO', '4', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70487, '2020-03-29', 'RW', 'Rwanda', 'AFRO', '6', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70488, '2020-03-30', 'RW', 'Rwanda', 'AFRO', '10', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70489, '2020-03-31', 'RW', 'Rwanda', 'AFRO', '0', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70490, '2020-04-01', 'RW', 'Rwanda', 'AFRO', '5', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70491, '2020-04-02', 'RW', 'Rwanda', 'AFRO', '7', '82', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70492, '2020-04-03', 'RW', 'Rwanda', 'AFRO', '2', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70493, '2020-04-04', 'RW', 'Rwanda', 'AFRO', '5', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70494, '2020-04-05', 'RW', 'Rwanda', 'AFRO', '13', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70495, '2020-04-06', 'RW', 'Rwanda', 'AFRO', '0', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70496, '2020-04-07', 'RW', 'Rwanda', 'AFRO', '2', '104', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70497, '2020-04-08', 'RW', 'Rwanda', 'AFRO', '1', '105', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70498, '2020-04-09', 'RW', 'Rwanda', 'AFRO', '5', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70499, '2020-04-10', 'RW', 'Rwanda', 'AFRO', '3', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70500, '2020-04-11', 'RW', 'Rwanda', 'AFRO', '5', '118', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70501, '2020-04-12', 'RW', 'Rwanda', 'AFRO', '2', '120', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70502, '2020-04-13', 'RW', 'Rwanda', 'AFRO', '6', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70503, '2020-04-14', 'RW', 'Rwanda', 'AFRO', '1', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70504, '2020-04-15', 'RW', 'Rwanda', 'AFRO', '7', '134', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70505, '2020-04-16', 'RW', 'Rwanda', 'AFRO', '2', '136', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70506, '2020-04-17', 'RW', 'Rwanda', 'AFRO', '2', '138', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70507, '2020-04-18', 'RW', 'Rwanda', 'AFRO', '0', '138', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70508, '2020-04-19', 'RW', 'Rwanda', 'AFRO', '6', '144', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70509, '2020-04-20', 'RW', 'Rwanda', 'AFRO', '3', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70510, '2020-04-21', 'RW', 'Rwanda', 'AFRO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70511, '2020-04-22', 'RW', 'Rwanda', 'AFRO', '3', '150', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70512, '2020-04-23', 'RW', 'Rwanda', 'AFRO', '3', '153', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70513, '2020-04-24', 'RW', 'Rwanda', 'AFRO', '1', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70514, '2020-04-25', 'RW', 'Rwanda', 'AFRO', '22', '176', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70515, '2020-04-26', 'RW', 'Rwanda', 'AFRO', '7', '183', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70516, '2020-04-27', 'RW', 'Rwanda', 'AFRO', '8', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70517, '2020-04-28', 'RW', 'Rwanda', 'AFRO', '16', '207', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70518, '2020-04-29', 'RW', 'Rwanda', 'AFRO', '5', '212', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70519, '2020-04-30', 'RW', 'Rwanda', 'AFRO', '13', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70520, '2020-05-01', 'RW', 'Rwanda', 'AFRO', '18', '243', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70521, '2020-05-02', 'RW', 'Rwanda', 'AFRO', '6', '249', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70522, '2020-05-03', 'RW', 'Rwanda', 'AFRO', '6', '255', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70523, '2020-05-04', 'RW', 'Rwanda', 'AFRO', '4', '259', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70524, '2020-05-05', 'RW', 'Rwanda', 'AFRO', '2', '261', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70525, '2020-05-06', 'RW', 'Rwanda', 'AFRO', '0', '261', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70526, '2020-05-07', 'RW', 'Rwanda', 'AFRO', '7', '268', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70527, '2020-05-08', 'RW', 'Rwanda', 'AFRO', '3', '271', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70528, '2020-05-09', 'RW', 'Rwanda', 'AFRO', '2', '273', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70529, '2020-05-10', 'RW', 'Rwanda', 'AFRO', '7', '280', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70530, '2020-05-11', 'RW', 'Rwanda', 'AFRO', '4', '284', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70531, '2020-05-12', 'RW', 'Rwanda', 'AFRO', '1', '285', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70532, '2020-05-13', 'RW', 'Rwanda', 'AFRO', '1', '286', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70533, '2020-05-14', 'RW', 'Rwanda', 'AFRO', '1', '287', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70534, '2020-05-15', 'RW', 'Rwanda', 'AFRO', '0', '287', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70535, '2020-05-16', 'RW', 'Rwanda', 'AFRO', '0', '287', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70536, '2020-05-17', 'RW', 'Rwanda', 'AFRO', '2', '289', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70537, '2020-05-18', 'RW', 'Rwanda', 'AFRO', '3', '292', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70538, '2020-05-19', 'RW', 'Rwanda', 'AFRO', '5', '297', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70539, '2020-05-20', 'RW', 'Rwanda', 'AFRO', '11', '308', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70540, '2020-05-21', 'RW', 'Rwanda', 'AFRO', '6', '314', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70541, '2020-05-22', 'RW', 'Rwanda', 'AFRO', '6', '320', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70542, '2020-05-23', 'RW', 'Rwanda', 'AFRO', '1', '321', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70543, '2020-05-24', 'RW', 'Rwanda', 'AFRO', '4', '325', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70544, '2020-05-25', 'RW', 'Rwanda', 'AFRO', '2', '327', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70545, '2020-05-26', 'RW', 'Rwanda', 'AFRO', '9', '336', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70546, '2020-05-27', 'RW', 'Rwanda', 'AFRO', '3', '339', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70547, '2020-05-28', 'RW', 'Rwanda', 'AFRO', '7', '346', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70548, '2020-05-29', 'RW', 'Rwanda', 'AFRO', '3', '349', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70549, '2020-05-30', 'RW', 'Rwanda', 'AFRO', '6', '355', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70550, '2020-05-31', 'RW', 'Rwanda', 'AFRO', '4', '359', '1', '1');
INSERT INTO public.who_global_data_import VALUES (70551, '2020-06-01', 'RW', 'Rwanda', 'AFRO', '11', '370', '0', '1');
INSERT INTO public.who_global_data_import VALUES (70552, '2020-06-02', 'RW', 'Rwanda', 'AFRO', '7', '377', '0', '1');
INSERT INTO public.who_global_data_import VALUES (70553, '2020-06-03', 'RW', 'Rwanda', 'AFRO', '7', '384', '1', '2');
INSERT INTO public.who_global_data_import VALUES (70554, '2020-06-04', 'RW', 'Rwanda', 'AFRO', '13', '397', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70555, '2020-06-05', 'RW', 'Rwanda', 'AFRO', '13', '410', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70556, '2020-06-06', 'RW', 'Rwanda', 'AFRO', '10', '420', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70557, '2020-06-07', 'RW', 'Rwanda', 'AFRO', '11', '431', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70558, '2020-06-08', 'RW', 'Rwanda', 'AFRO', '8', '439', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70559, '2020-06-09', 'RW', 'Rwanda', 'AFRO', '12', '451', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70560, '2020-06-10', 'RW', 'Rwanda', 'AFRO', '12', '463', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70561, '2020-06-11', 'RW', 'Rwanda', 'AFRO', '13', '476', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70562, '2020-06-12', 'RW', 'Rwanda', 'AFRO', '18', '494', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70563, '2020-06-13', 'RW', 'Rwanda', 'AFRO', '16', '510', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70564, '2020-06-14', 'RW', 'Rwanda', 'AFRO', '31', '541', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70565, '2020-06-15', 'RW', 'Rwanda', 'AFRO', '41', '582', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70566, '2020-06-16', 'RW', 'Rwanda', 'AFRO', '30', '612', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70567, '2020-06-17', 'RW', 'Rwanda', 'AFRO', '24', '636', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70568, '2020-06-18', 'RW', 'Rwanda', 'AFRO', '3', '639', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70569, '2020-06-19', 'RW', 'Rwanda', 'AFRO', '7', '646', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70570, '2020-06-20', 'RW', 'Rwanda', 'AFRO', '15', '661', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70571, '2020-06-21', 'RW', 'Rwanda', 'AFRO', '41', '702', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70572, '2020-06-22', 'RW', 'Rwanda', 'AFRO', '26', '728', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70573, '2020-06-23', 'RW', 'Rwanda', 'AFRO', '59', '787', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70574, '2020-06-24', 'RW', 'Rwanda', 'AFRO', '11', '798', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70575, '2020-06-25', 'RW', 'Rwanda', 'AFRO', '32', '830', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70576, '2020-06-26', 'RW', 'Rwanda', 'AFRO', '20', '850', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70577, '2020-06-27', 'RW', 'Rwanda', 'AFRO', '8', '858', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70578, '2020-06-28', 'RW', 'Rwanda', 'AFRO', '20', '878', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70579, '2020-06-29', 'RW', 'Rwanda', 'AFRO', '22', '900', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70580, '2020-06-30', 'RW', 'Rwanda', 'AFRO', '101', '1001', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70581, '2020-07-01', 'RW', 'Rwanda', 'AFRO', '24', '1025', '0', '2');
INSERT INTO public.who_global_data_import VALUES (70582, '2020-07-02', 'RW', 'Rwanda', 'AFRO', '17', '1042', '1', '3');
INSERT INTO public.who_global_data_import VALUES (70583, '2020-07-03', 'RW', 'Rwanda', 'AFRO', '21', '1063', '0', '3');
INSERT INTO public.who_global_data_import VALUES (70584, '2020-07-04', 'RW', 'Rwanda', 'AFRO', '18', '1081', '0', '3');
INSERT INTO public.who_global_data_import VALUES (70585, '2020-07-05', 'RW', 'Rwanda', 'AFRO', '11', '1092', '0', '3');
INSERT INTO public.who_global_data_import VALUES (70586, '2020-07-06', 'RW', 'Rwanda', 'AFRO', '13', '1105', '0', '3');
INSERT INTO public.who_global_data_import VALUES (70587, '2020-07-07', 'RW', 'Rwanda', 'AFRO', '8', '1113', '0', '3');
INSERT INTO public.who_global_data_import VALUES (70588, '2020-07-08', 'RW', 'Rwanda', 'AFRO', '59', '1172', '0', '3');
INSERT INTO public.who_global_data_import VALUES (70589, '2020-07-09', 'RW', 'Rwanda', 'AFRO', '22', '1194', '0', '3');
INSERT INTO public.who_global_data_import VALUES (70590, '2020-07-10', 'RW', 'Rwanda', 'AFRO', '16', '1210', '0', '3');
INSERT INTO public.who_global_data_import VALUES (70591, '2020-07-11', 'RW', 'Rwanda', 'AFRO', '42', '1252', '0', '3');
INSERT INTO public.who_global_data_import VALUES (70592, '2020-07-12', 'RW', 'Rwanda', 'AFRO', '47', '1299', '0', '3');
INSERT INTO public.who_global_data_import VALUES (70593, '2020-07-13', 'RW', 'Rwanda', 'AFRO', '38', '1337', '1', '4');
INSERT INTO public.who_global_data_import VALUES (70594, '2020-07-14', 'RW', 'Rwanda', 'AFRO', '41', '1378', '0', '4');
INSERT INTO public.who_global_data_import VALUES (70595, '2020-07-15', 'RW', 'Rwanda', 'AFRO', '38', '1416', '0', '4');
INSERT INTO public.who_global_data_import VALUES (70596, '2020-07-16', 'RW', 'Rwanda', 'AFRO', '19', '1435', '0', '4');
INSERT INTO public.who_global_data_import VALUES (70597, '2020-07-17', 'RW', 'Rwanda', 'AFRO', '38', '1473', '0', '4');
INSERT INTO public.who_global_data_import VALUES (70598, '2020-07-18', 'RW', 'Rwanda', 'AFRO', '12', '1485', '0', '4');
INSERT INTO public.who_global_data_import VALUES (70599, '2020-07-19', 'RW', 'Rwanda', 'AFRO', '54', '1539', '1', '5');
INSERT INTO public.who_global_data_import VALUES (70600, '2020-07-20', 'RW', 'Rwanda', 'AFRO', '43', '1582', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70601, '2020-07-21', 'RW', 'Rwanda', 'AFRO', '47', '1629', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70602, '2020-07-22', 'RW', 'Rwanda', 'AFRO', '26', '1655', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70603, '2020-07-23', 'RW', 'Rwanda', 'AFRO', '34', '1689', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70604, '2020-07-24', 'RW', 'Rwanda', 'AFRO', '21', '1710', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70605, '2020-07-25', 'RW', 'Rwanda', 'AFRO', '19', '1729', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70606, '2020-07-26', 'RW', 'Rwanda', 'AFRO', '23', '1752', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70607, '2020-07-27', 'RW', 'Rwanda', 'AFRO', '71', '1823', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70608, '2020-07-28', 'RW', 'Rwanda', 'AFRO', '56', '1879', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70609, '2020-07-29', 'RW', 'Rwanda', 'AFRO', '47', '1926', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70610, '2020-07-30', 'RW', 'Rwanda', 'AFRO', '37', '1963', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70611, '2020-07-31', 'RW', 'Rwanda', 'AFRO', '31', '1994', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70612, '2020-08-01', 'RW', 'Rwanda', 'AFRO', '28', '2022', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70613, '2020-08-02', 'RW', 'Rwanda', 'AFRO', '20', '2042', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70614, '2020-08-03', 'RW', 'Rwanda', 'AFRO', '20', '2062', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70615, '2020-08-04', 'RW', 'Rwanda', 'AFRO', '30', '2092', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70616, '2020-08-05', 'RW', 'Rwanda', 'AFRO', '7', '2099', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70617, '2020-08-06', 'RW', 'Rwanda', 'AFRO', '5', '2104', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70618, '2020-08-07', 'RW', 'Rwanda', 'AFRO', '7', '2111', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70619, '2020-08-08', 'RW', 'Rwanda', 'AFRO', '17', '2128', '0', '5');
INSERT INTO public.who_global_data_import VALUES (70620, '2020-08-09', 'RW', 'Rwanda', 'AFRO', '6', '2134', '1', '6');
INSERT INTO public.who_global_data_import VALUES (70621, '2020-08-10', 'RW', 'Rwanda', 'AFRO', '6', '2140', '1', '7');
INSERT INTO public.who_global_data_import VALUES (70622, '2020-08-11', 'RW', 'Rwanda', 'AFRO', '12', '2152', '0', '7');
INSERT INTO public.who_global_data_import VALUES (70623, '2020-08-12', 'RW', 'Rwanda', 'AFRO', '19', '2171', '0', '7');
INSERT INTO public.who_global_data_import VALUES (70624, '2020-08-13', 'RW', 'Rwanda', 'AFRO', '18', '2189', '1', '8');
INSERT INTO public.who_global_data_import VALUES (70625, '2020-08-14', 'RW', 'Rwanda', 'AFRO', '11', '2200', '0', '8');
INSERT INTO public.who_global_data_import VALUES (70626, '2020-08-15', 'RW', 'Rwanda', 'AFRO', '0', '2200', '0', '8');
INSERT INTO public.who_global_data_import VALUES (70627, '2020-08-16', 'RW', 'Rwanda', 'AFRO', '152', '2352', '0', '8');
INSERT INTO public.who_global_data_import VALUES (70628, '2020-08-17', 'RW', 'Rwanda', 'AFRO', '101', '2453', '0', '8');
INSERT INTO public.who_global_data_import VALUES (70629, '2020-08-18', 'RW', 'Rwanda', 'AFRO', '87', '2540', '0', '8');
INSERT INTO public.who_global_data_import VALUES (70630, '2020-08-19', 'RW', 'Rwanda', 'AFRO', '37', '2577', '2', '10');
INSERT INTO public.who_global_data_import VALUES (70631, '2020-08-20', 'RW', 'Rwanda', 'AFRO', '67', '2644', '0', '10');
INSERT INTO public.who_global_data_import VALUES (70632, '2020-08-21', 'RW', 'Rwanda', 'AFRO', '73', '2717', '1', '11');
INSERT INTO public.who_global_data_import VALUES (70633, '2020-08-22', 'RW', 'Rwanda', 'AFRO', '63', '2780', '0', '11');
INSERT INTO public.who_global_data_import VALUES (70634, '2020-08-23', 'RW', 'Rwanda', 'AFRO', '109', '2889', '0', '11');
INSERT INTO public.who_global_data_import VALUES (70635, '2020-08-24', 'RW', 'Rwanda', 'AFRO', '200', '3089', '1', '12');
INSERT INTO public.who_global_data_import VALUES (70636, '2020-08-25', 'RW', 'Rwanda', 'AFRO', '217', '3306', '2', '14');
INSERT INTO public.who_global_data_import VALUES (70637, '2020-08-26', 'RW', 'Rwanda', 'AFRO', '231', '3537', '1', '15');
INSERT INTO public.who_global_data_import VALUES (70638, '2020-08-27', 'RW', 'Rwanda', 'AFRO', '88', '3625', '0', '15');
INSERT INTO public.who_global_data_import VALUES (70639, '2020-08-28', 'RW', 'Rwanda', 'AFRO', '47', '3672', '0', '15');
INSERT INTO public.who_global_data_import VALUES (70640, '2020-08-29', 'RW', 'Rwanda', 'AFRO', '70', '3742', '1', '16');
INSERT INTO public.who_global_data_import VALUES (70641, '2020-08-30', 'RW', 'Rwanda', 'AFRO', '101', '3843', '0', '16');
INSERT INTO public.who_global_data_import VALUES (70642, '2020-08-31', 'RW', 'Rwanda', 'AFRO', '177', '4020', '0', '16');
INSERT INTO public.who_global_data_import VALUES (70643, '2020-09-01', 'RW', 'Rwanda', 'AFRO', '43', '4063', '0', '16');
INSERT INTO public.who_global_data_import VALUES (70644, '2020-09-02', 'RW', 'Rwanda', 'AFRO', '79', '4142', '0', '16');
INSERT INTO public.who_global_data_import VALUES (70645, '2020-09-03', 'RW', 'Rwanda', 'AFRO', '76', '4218', '1', '17');
INSERT INTO public.who_global_data_import VALUES (70646, '2020-09-04', 'RW', 'Rwanda', 'AFRO', '37', '4255', '1', '18');
INSERT INTO public.who_global_data_import VALUES (70647, '2020-09-05', 'RW', 'Rwanda', 'AFRO', '49', '4304', '0', '18');
INSERT INTO public.who_global_data_import VALUES (70648, '2020-09-06', 'RW', 'Rwanda', 'AFRO', '45', '4349', '0', '18');
INSERT INTO public.who_global_data_import VALUES (70649, '2020-09-07', 'RW', 'Rwanda', 'AFRO', '25', '4374', '1', '19');
INSERT INTO public.who_global_data_import VALUES (70650, '2020-09-08', 'RW', 'Rwanda', 'AFRO', '35', '4409', '0', '19');
INSERT INTO public.who_global_data_import VALUES (70651, '2020-09-09', 'RW', 'Rwanda', 'AFRO', '30', '4439', '1', '20');
INSERT INTO public.who_global_data_import VALUES (70652, '2020-09-10', 'RW', 'Rwanda', 'AFRO', '21', '4460', '1', '21');
INSERT INTO public.who_global_data_import VALUES (70653, '2020-09-11', 'RW', 'Rwanda', 'AFRO', '19', '4479', '1', '22');
INSERT INTO public.who_global_data_import VALUES (70654, '2020-09-12', 'RW', 'Rwanda', 'AFRO', '55', '4534', '0', '22');
INSERT INTO public.who_global_data_import VALUES (70655, '2020-09-13', 'RW', 'Rwanda', 'AFRO', '31', '4565', '0', '22');
INSERT INTO public.who_global_data_import VALUES (70656, '2020-09-14', 'RW', 'Rwanda', 'AFRO', '26', '4591', '0', '22');
INSERT INTO public.who_global_data_import VALUES (70657, '2020-09-15', 'RW', 'Rwanda', 'AFRO', '11', '4602', '0', '22');
INSERT INTO public.who_global_data_import VALUES (70658, '2020-09-16', 'RW', 'Rwanda', 'AFRO', '22', '4624', '0', '22');
INSERT INTO public.who_global_data_import VALUES (70659, '2020-09-17', 'RW', 'Rwanda', 'AFRO', '10', '4634', '0', '22');
INSERT INTO public.who_global_data_import VALUES (70660, '2020-09-18', 'RW', 'Rwanda', 'AFRO', '19', '4653', '1', '23');
INSERT INTO public.who_global_data_import VALUES (70661, '2020-09-19', 'RW', 'Rwanda', 'AFRO', '18', '4671', '2', '25');
INSERT INTO public.who_global_data_import VALUES (70662, '2020-09-20', 'RW', 'Rwanda', 'AFRO', '0', '4671', '0', '25');
INSERT INTO public.who_global_data_import VALUES (70663, '2020-09-21', 'RW', 'Rwanda', 'AFRO', '40', '4711', '1', '26');
INSERT INTO public.who_global_data_import VALUES (70664, '2020-09-22', 'RW', 'Rwanda', 'AFRO', '11', '4722', '1', '27');
INSERT INTO public.who_global_data_import VALUES (70665, '2020-09-23', 'RW', 'Rwanda', 'AFRO', '16', '4738', '0', '27');
INSERT INTO public.who_global_data_import VALUES (70666, '2020-09-24', 'RW', 'Rwanda', 'AFRO', '41', '4779', '0', '27');
INSERT INTO public.who_global_data_import VALUES (70667, '2020-09-25', 'RW', 'Rwanda', 'AFRO', '10', '4789', '0', '27');
INSERT INTO public.who_global_data_import VALUES (70668, '2020-09-26', 'RW', 'Rwanda', 'AFRO', '9', '4798', '2', '29');
INSERT INTO public.who_global_data_import VALUES (70669, '2020-09-27', 'RW', 'Rwanda', 'AFRO', '13', '4811', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70670, '2020-09-28', 'RW', 'Rwanda', 'AFRO', '9', '4820', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70671, '2020-09-29', 'RW', 'Rwanda', 'AFRO', '12', '4832', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70672, '2020-09-30', 'RW', 'Rwanda', 'AFRO', '4', '4836', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70673, '2020-10-01', 'RW', 'Rwanda', 'AFRO', '4', '4840', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70674, '2020-10-02', 'RW', 'Rwanda', 'AFRO', '3', '4843', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70675, '2020-10-03', 'RW', 'Rwanda', 'AFRO', '4', '4847', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70676, '2020-10-04', 'RW', 'Rwanda', 'AFRO', '5', '4852', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70677, '2020-10-05', 'RW', 'Rwanda', 'AFRO', '14', '4866', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70678, '2020-10-06', 'RW', 'Rwanda', 'AFRO', '1', '4867', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70679, '2020-10-07', 'RW', 'Rwanda', 'AFRO', '6', '4873', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70680, '2020-10-08', 'RW', 'Rwanda', 'AFRO', '10', '4883', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70681, '2020-10-09', 'RW', 'Rwanda', 'AFRO', '2', '4885', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70682, '2020-10-10', 'RW', 'Rwanda', 'AFRO', '5', '4890', '0', '29');
INSERT INTO public.who_global_data_import VALUES (70683, '2020-10-11', 'RW', 'Rwanda', 'AFRO', '2', '4892', '1', '30');
INSERT INTO public.who_global_data_import VALUES (70684, '2020-10-12', 'RW', 'Rwanda', 'AFRO', '4', '4896', '1', '31');
INSERT INTO public.who_global_data_import VALUES (70685, '2020-10-13', 'RW', 'Rwanda', 'AFRO', '9', '4905', '1', '32');
INSERT INTO public.who_global_data_import VALUES (70686, '2020-10-14', 'RW', 'Rwanda', 'AFRO', '3', '4908', '0', '32');
INSERT INTO public.who_global_data_import VALUES (70687, '2020-10-15', 'RW', 'Rwanda', 'AFRO', '32', '4940', '1', '33');
INSERT INTO public.who_global_data_import VALUES (70688, '2020-10-16', 'RW', 'Rwanda', 'AFRO', '13', '4953', '0', '33');
INSERT INTO public.who_global_data_import VALUES (70689, '2020-10-17', 'RW', 'Rwanda', 'AFRO', '12', '4965', '1', '34');
INSERT INTO public.who_global_data_import VALUES (70690, '2020-10-18', 'RW', 'Rwanda', 'AFRO', '6', '4971', '0', '34');
INSERT INTO public.who_global_data_import VALUES (70691, '2020-10-19', 'RW', 'Rwanda', 'AFRO', '3', '4974', '0', '34');
INSERT INTO public.who_global_data_import VALUES (70692, '2020-10-20', 'RW', 'Rwanda', 'AFRO', '18', '4992', '0', '34');
INSERT INTO public.who_global_data_import VALUES (70693, '2020-10-21', 'RW', 'Rwanda', 'AFRO', '4', '4996', '0', '34');
INSERT INTO public.who_global_data_import VALUES (70694, '2020-10-22', 'RW', 'Rwanda', 'AFRO', '16', '5012', '0', '34');
INSERT INTO public.who_global_data_import VALUES (70695, '2020-10-23', 'RW', 'Rwanda', 'AFRO', '5', '5017', '0', '34');
INSERT INTO public.who_global_data_import VALUES (70696, '2020-10-24', 'RW', 'Rwanda', 'AFRO', '35', '5052', '0', '34');
INSERT INTO public.who_global_data_import VALUES (70697, '2020-10-25', 'RW', 'Rwanda', 'AFRO', '8', '5060', '0', '34');
INSERT INTO public.who_global_data_import VALUES (70698, '2020-10-26', 'RW', 'Rwanda', 'AFRO', '6', '5066', '0', '34');
INSERT INTO public.who_global_data_import VALUES (70699, '2020-10-27', 'RW', 'Rwanda', 'AFRO', '7', '5073', '0', '34');
INSERT INTO public.who_global_data_import VALUES (70700, '2020-10-28', 'RW', 'Rwanda', 'AFRO', '11', '5084', '1', '35');
INSERT INTO public.who_global_data_import VALUES (70701, '2020-10-29', 'RW', 'Rwanda', 'AFRO', '45', '5129', '0', '35');
INSERT INTO public.who_global_data_import VALUES (70702, '2020-10-30', 'RW', 'Rwanda', 'AFRO', '2', '5131', '0', '35');
INSERT INTO public.who_global_data_import VALUES (70703, '2020-10-31', 'RW', 'Rwanda', 'AFRO', '3', '5134', '0', '35');
INSERT INTO public.who_global_data_import VALUES (70704, '2020-11-01', 'RW', 'Rwanda', 'AFRO', '3', '5137', '0', '35');
INSERT INTO public.who_global_data_import VALUES (70705, '2020-11-02', 'RW', 'Rwanda', 'AFRO', '9', '5146', '0', '35');
INSERT INTO public.who_global_data_import VALUES (70706, '2020-11-03', 'RW', 'Rwanda', 'AFRO', '9', '5155', '0', '35');
INSERT INTO public.who_global_data_import VALUES (70707, '2020-11-04', 'RW', 'Rwanda', 'AFRO', '7', '5162', '0', '35');
INSERT INTO public.who_global_data_import VALUES (70708, '2020-11-05', 'RW', 'Rwanda', 'AFRO', '12', '5174', '0', '35');
INSERT INTO public.who_global_data_import VALUES (70709, '2020-11-06', 'RW', 'Rwanda', 'AFRO', '18', '5192', '1', '36');
INSERT INTO public.who_global_data_import VALUES (70710, '2020-11-07', 'RW', 'Rwanda', 'AFRO', '16', '5208', '0', '36');
INSERT INTO public.who_global_data_import VALUES (70711, '2020-11-08', 'RW', 'Rwanda', 'AFRO', '5', '5213', '0', '36');
INSERT INTO public.who_global_data_import VALUES (70712, '2020-11-09', 'RW', 'Rwanda', 'AFRO', '9', '5222', '0', '36');
INSERT INTO public.who_global_data_import VALUES (70713, '2020-11-10', 'RW', 'Rwanda', 'AFRO', '20', '5242', '2', '38');
INSERT INTO public.who_global_data_import VALUES (70714, '2020-11-11', 'RW', 'Rwanda', 'AFRO', '20', '5262', '2', '40');
INSERT INTO public.who_global_data_import VALUES (70715, '2020-11-12', 'RW', 'Rwanda', 'AFRO', '50', '5312', '1', '41');
INSERT INTO public.who_global_data_import VALUES (70716, '2020-11-13', 'RW', 'Rwanda', 'AFRO', '7', '5319', '0', '41');
INSERT INTO public.who_global_data_import VALUES (70717, '2020-11-14', 'RW', 'Rwanda', 'AFRO', '43', '5362', '1', '42');
INSERT INTO public.who_global_data_import VALUES (70718, '2020-11-15', 'RW', 'Rwanda', 'AFRO', '32', '5394', '0', '42');
INSERT INTO public.who_global_data_import VALUES (70719, '2020-11-16', 'RW', 'Rwanda', 'AFRO', '61', '5455', '0', '42');
INSERT INTO public.who_global_data_import VALUES (70720, '2020-11-17', 'RW', 'Rwanda', 'AFRO', '36', '5491', '3', '45');
INSERT INTO public.who_global_data_import VALUES (70721, '2020-11-18', 'RW', 'Rwanda', 'AFRO', '16', '5507', '1', '46');
INSERT INTO public.who_global_data_import VALUES (70722, '2020-11-19', 'RW', 'Rwanda', 'AFRO', '36', '5543', '0', '46');
INSERT INTO public.who_global_data_import VALUES (70723, '2020-11-20', 'RW', 'Rwanda', 'AFRO', '0', '5543', '0', '46');
INSERT INTO public.who_global_data_import VALUES (70724, '2020-11-21', 'RW', 'Rwanda', 'AFRO', '43', '5586', '0', '46');
INSERT INTO public.who_global_data_import VALUES (70725, '2020-11-22', 'RW', 'Rwanda', 'AFRO', '34', '5620', '0', '46');
INSERT INTO public.who_global_data_import VALUES (70726, '2020-11-23', 'RW', 'Rwanda', 'AFRO', '45', '5665', '1', '47');
INSERT INTO public.who_global_data_import VALUES (70727, '2020-11-24', 'RW', 'Rwanda', 'AFRO', '61', '5726', '0', '47');
INSERT INTO public.who_global_data_import VALUES (70728, '2020-11-25', 'RW', 'Rwanda', 'AFRO', '24', '5750', '0', '47');
INSERT INTO public.who_global_data_import VALUES (70729, '2020-11-26', 'RW', 'Rwanda', 'AFRO', '29', '5779', '0', '47');
INSERT INTO public.who_global_data_import VALUES (70730, '2020-11-27', 'RW', 'Rwanda', 'AFRO', '72', '5851', '0', '47');
INSERT INTO public.who_global_data_import VALUES (70731, '2020-11-28', 'RW', 'Rwanda', 'AFRO', '21', '5872', '0', '47');
INSERT INTO public.who_global_data_import VALUES (70732, '2020-11-29', 'RW', 'Rwanda', 'AFRO', '0', '5872', '0', '47');
INSERT INTO public.who_global_data_import VALUES (70733, '2020-11-30', 'RW', 'Rwanda', 'AFRO', '47', '5919', '1', '48');
INSERT INTO public.who_global_data_import VALUES (70734, '2020-12-01', 'RW', 'Rwanda', 'AFRO', '15', '5934', '1', '49');
INSERT INTO public.who_global_data_import VALUES (70735, '2020-12-02', 'RW', 'Rwanda', 'AFRO', '14', '5948', '0', '49');
INSERT INTO public.who_global_data_import VALUES (70736, '2020-12-03', 'RW', 'Rwanda', 'AFRO', '46', '5994', '1', '50');
INSERT INTO public.who_global_data_import VALUES (70737, '2020-12-04', 'RW', 'Rwanda', 'AFRO', '17', '6011', '0', '50');
INSERT INTO public.who_global_data_import VALUES (70738, '2020-12-05', 'RW', 'Rwanda', 'AFRO', '32', '6043', '1', '51');
INSERT INTO public.who_global_data_import VALUES (70739, '2020-12-06', 'RW', 'Rwanda', 'AFRO', '41', '6084', '0', '51');
INSERT INTO public.who_global_data_import VALUES (70740, '2020-12-07', 'RW', 'Rwanda', 'AFRO', '45', '6129', '0', '51');
INSERT INTO public.who_global_data_import VALUES (70741, '2020-12-08', 'RW', 'Rwanda', 'AFRO', '62', '6191', '0', '51');
INSERT INTO public.who_global_data_import VALUES (70742, '2020-12-09', 'RW', 'Rwanda', 'AFRO', '46', '6237', '0', '51');
INSERT INTO public.who_global_data_import VALUES (70743, '2020-12-10', 'RW', 'Rwanda', 'AFRO', '41', '6278', '2', '53');
INSERT INTO public.who_global_data_import VALUES (70744, '2020-12-11', 'RW', 'Rwanda', 'AFRO', '71', '6349', '0', '53');
INSERT INTO public.who_global_data_import VALUES (70745, '2020-12-12', 'RW', 'Rwanda', 'AFRO', '79', '6428', '1', '54');
INSERT INTO public.who_global_data_import VALUES (70746, '2020-12-13', 'RW', 'Rwanda', 'AFRO', '100', '6528', '2', '56');
INSERT INTO public.who_global_data_import VALUES (70747, '2020-12-14', 'RW', 'Rwanda', 'AFRO', '131', '6659', '0', '56');
INSERT INTO public.who_global_data_import VALUES (70748, '2020-12-15', 'RW', 'Rwanda', 'AFRO', '88', '6747', '0', '56');
INSERT INTO public.who_global_data_import VALUES (70749, '2020-12-16', 'RW', 'Rwanda', 'AFRO', '85', '6832', '1', '57');
INSERT INTO public.who_global_data_import VALUES (70750, '2020-12-17', 'RW', 'Rwanda', 'AFRO', '0', '6832', '0', '57');
INSERT INTO public.who_global_data_import VALUES (70751, '2020-12-18', 'RW', 'Rwanda', 'AFRO', '200', '7032', '0', '57');
INSERT INTO public.who_global_data_import VALUES (70752, '2020-12-19', 'RW', 'Rwanda', 'AFRO', '73', '7105', '0', '57');
INSERT INTO public.who_global_data_import VALUES (70753, '2020-12-20', 'RW', 'Rwanda', 'AFRO', '127', '7232', '2', '59');
INSERT INTO public.who_global_data_import VALUES (70754, '2020-12-21', 'RW', 'Rwanda', 'AFRO', '0', '7232', '0', '59');
INSERT INTO public.who_global_data_import VALUES (70755, '2020-12-22', 'RW', 'Rwanda', 'AFRO', '0', '7232', '0', '59');
INSERT INTO public.who_global_data_import VALUES (70756, '2020-12-23', 'RW', 'Rwanda', 'AFRO', '279', '7511', '7', '66');
INSERT INTO public.who_global_data_import VALUES (70757, '2020-12-24', 'RW', 'Rwanda', 'AFRO', '0', '7511', '0', '66');
INSERT INTO public.who_global_data_import VALUES (70758, '2020-12-25', 'RW', 'Rwanda', 'AFRO', '0', '7511', '0', '66');
INSERT INTO public.who_global_data_import VALUES (70759, '2020-12-26', 'RW', 'Rwanda', 'AFRO', '0', '7511', '0', '66');
INSERT INTO public.who_global_data_import VALUES (70760, '2020-12-27', 'RW', 'Rwanda', 'AFRO', '306', '7817', '6', '72');
INSERT INTO public.who_global_data_import VALUES (70761, '2020-12-28', 'RW', 'Rwanda', 'AFRO', '153', '7970', '2', '74');
INSERT INTO public.who_global_data_import VALUES (70762, '2020-12-29', 'RW', 'Rwanda', 'AFRO', '51', '8021', '1', '75');
INSERT INTO public.who_global_data_import VALUES (70763, '2020-12-30', 'RW', 'Rwanda', 'AFRO', '0', '8021', '0', '75');
INSERT INTO public.who_global_data_import VALUES (70764, '2020-12-31', 'RW', 'Rwanda', 'AFRO', '229', '8250', '11', '86');
INSERT INTO public.who_global_data_import VALUES (70765, '2021-01-01', 'RW', 'Rwanda', 'AFRO', '133', '8383', '6', '92');
INSERT INTO public.who_global_data_import VALUES (70766, '2021-01-02', 'RW', 'Rwanda', 'AFRO', '0', '8383', '0', '92');
INSERT INTO public.who_global_data_import VALUES (70767, '2021-01-03', 'RW', 'Rwanda', 'AFRO', '184', '8567', '6', '98');
INSERT INTO public.who_global_data_import VALUES (70768, '2021-01-04', 'RW', 'Rwanda', 'AFRO', '109', '8676', '3', '101');
INSERT INTO public.who_global_data_import VALUES (70769, '2021-01-05', 'RW', 'Rwanda', 'AFRO', '172', '8848', '4', '105');
INSERT INTO public.who_global_data_import VALUES (70770, '2021-01-06', 'RW', 'Rwanda', 'AFRO', '0', '8848', '0', '105');
INSERT INTO public.who_global_data_import VALUES (70771, '2021-01-07', 'RW', 'Rwanda', 'AFRO', '210', '9058', '7', '112');
INSERT INTO public.who_global_data_import VALUES (70772, '2021-01-08', 'RW', 'Rwanda', 'AFRO', '0', '9058', '0', '112');
INSERT INTO public.who_global_data_import VALUES (70773, '2021-01-09', 'RW', 'Rwanda', 'AFRO', '0', '9058', '0', '112');
INSERT INTO public.who_global_data_import VALUES (70774, '2021-01-10', 'RW', 'Rwanda', 'AFRO', '403', '9461', '6', '118');
INSERT INTO public.who_global_data_import VALUES (70775, '2021-01-11', 'RW', 'Rwanda', 'AFRO', '169', '9630', '2', '120');
INSERT INTO public.who_global_data_import VALUES (70776, '2021-01-12', 'RW', 'Rwanda', 'AFRO', '154', '9784', '4', '124');
INSERT INTO public.who_global_data_import VALUES (70777, '2021-01-13', 'RW', 'Rwanda', 'AFRO', '166', '9950', '1', '125');
INSERT INTO public.who_global_data_import VALUES (70778, '2021-01-14', 'RW', 'Rwanda', 'AFRO', '172', '10122', '3', '128');
INSERT INTO public.who_global_data_import VALUES (70779, '2021-01-15', 'RW', 'Rwanda', 'AFRO', '194', '10316', '5', '133');
INSERT INTO public.who_global_data_import VALUES (70780, '2021-01-16', 'RW', 'Rwanda', 'AFRO', '257', '10573', '5', '138');
INSERT INTO public.who_global_data_import VALUES (70781, '2021-01-17', 'RW', 'Rwanda', 'AFRO', '277', '10850', '2', '140');
INSERT INTO public.who_global_data_import VALUES (70782, '2021-01-18', 'RW', 'Rwanda', 'AFRO', '182', '11032', '2', '142');
INSERT INTO public.who_global_data_import VALUES (70783, '2021-01-19', 'RW', 'Rwanda', 'AFRO', '227', '11259', '4', '146');
INSERT INTO public.who_global_data_import VALUES (70784, '2021-01-20', 'RW', 'Rwanda', 'AFRO', '289', '11548', '2', '148');
INSERT INTO public.who_global_data_import VALUES (70785, '2021-01-21', 'RW', 'Rwanda', 'AFRO', '312', '11860', '5', '153');
INSERT INTO public.who_global_data_import VALUES (70786, '2021-01-22', 'RW', 'Rwanda', 'AFRO', '310', '12170', '9', '162');
INSERT INTO public.who_global_data_import VALUES (70787, '2021-01-23', 'RW', 'Rwanda', 'AFRO', '273', '12443', '3', '165');
INSERT INTO public.who_global_data_import VALUES (70788, '2021-01-24', 'RW', 'Rwanda', 'AFRO', '204', '12647', '7', '172');
INSERT INTO public.who_global_data_import VALUES (70789, '2021-01-25', 'RW', 'Rwanda', 'AFRO', '328', '12975', '2', '174');
INSERT INTO public.who_global_data_import VALUES (70790, '2021-01-26', 'RW', 'Rwanda', 'AFRO', '336', '13311', '3', '177');
INSERT INTO public.who_global_data_import VALUES (70791, '2021-01-27', 'RW', 'Rwanda', 'AFRO', '574', '13885', '4', '181');
INSERT INTO public.who_global_data_import VALUES (70792, '2021-01-28', 'RW', 'Rwanda', 'AFRO', '281', '14166', '2', '183');
INSERT INTO public.who_global_data_import VALUES (70793, '2021-01-29', 'RW', 'Rwanda', 'AFRO', '363', '14529', '0', '183');
INSERT INTO public.who_global_data_import VALUES (70794, '2021-01-30', 'RW', 'Rwanda', 'AFRO', '255', '14784', '5', '188');
INSERT INTO public.who_global_data_import VALUES (70795, '2021-01-31', 'RW', 'Rwanda', 'AFRO', '334', '15118', '5', '193');
INSERT INTO public.who_global_data_import VALUES (70796, '2021-02-01', 'RW', 'Rwanda', 'AFRO', '186', '15304', '3', '196');
INSERT INTO public.who_global_data_import VALUES (70797, '2021-02-02', 'RW', 'Rwanda', 'AFRO', '155', '15459', '2', '198');
INSERT INTO public.who_global_data_import VALUES (70798, '2021-02-03', 'RW', 'Rwanda', 'AFRO', '229', '15688', '7', '205');
INSERT INTO public.who_global_data_import VALUES (70799, '2021-02-04', 'RW', 'Rwanda', 'AFRO', '146', '15834', '3', '208');
INSERT INTO public.who_global_data_import VALUES (70800, '2021-02-05', 'RW', 'Rwanda', 'AFRO', '154', '15988', '2', '210');
INSERT INTO public.who_global_data_import VALUES (70801, '2020-01-03', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70802, '2020-01-04', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70803, '2020-01-05', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70804, '2020-01-06', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70805, '2020-01-07', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70806, '2020-01-08', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70807, '2020-01-09', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70808, '2020-01-10', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70809, '2020-01-11', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70810, '2020-01-12', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70811, '2020-01-13', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70812, '2020-01-14', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70813, '2020-01-15', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70814, '2020-01-16', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70815, '2020-01-17', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70816, '2020-01-18', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70817, '2020-01-19', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70818, '2020-01-20', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70819, '2020-01-21', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70820, '2020-01-22', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70821, '2020-01-23', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70822, '2020-01-24', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70823, '2020-01-25', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70824, '2020-01-26', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70825, '2020-01-27', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70826, '2020-01-28', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70827, '2020-01-29', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70828, '2020-01-30', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70829, '2020-01-31', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70830, '2020-02-01', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70831, '2020-02-02', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70832, '2020-02-03', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70833, '2020-02-04', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70834, '2020-02-05', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70835, '2020-02-06', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70836, '2020-02-07', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70837, '2020-02-08', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70838, '2020-02-09', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70839, '2020-02-10', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70840, '2020-02-11', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70841, '2020-02-12', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70842, '2020-02-13', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70843, '2020-02-14', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70844, '2020-02-15', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70845, '2020-02-16', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70846, '2020-02-17', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70847, '2020-02-18', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70848, '2020-02-19', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70849, '2020-02-20', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70850, '2020-02-21', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70851, '2020-02-22', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70852, '2020-02-23', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70853, '2020-02-24', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70854, '2020-02-25', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70855, '2020-02-26', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70856, '2020-02-27', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70857, '2020-02-28', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70858, '2020-02-29', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70859, '2020-03-01', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70860, '2020-03-02', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70861, '2020-03-03', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70862, '2020-03-04', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70863, '2020-03-05', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70864, '2020-03-06', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70865, '2020-03-07', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70866, '2020-03-08', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70867, '2020-03-09', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70868, '2020-03-10', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70869, '2020-03-11', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70870, '2020-03-12', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70871, '2020-03-13', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70872, '2020-03-14', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70873, '2020-03-15', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70874, '2020-03-16', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70875, '2020-03-17', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70876, '2020-03-18', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70877, '2020-03-19', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70878, '2020-03-20', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70879, '2020-03-21', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70880, '2020-03-22', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70881, '2020-03-23', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70882, '2020-03-24', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70883, '2020-03-25', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70884, '2020-03-26', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70885, '2020-03-27', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70886, '2020-03-28', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70887, '2020-03-29', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70888, '2020-03-30', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70889, '2020-03-31', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70890, '2020-04-01', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70891, '2020-04-02', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70892, '2020-04-03', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70893, '2020-04-04', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70894, '2020-04-05', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70895, '2020-04-06', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70896, '2020-04-07', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70897, '2020-04-08', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70898, '2020-04-09', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70899, '2020-04-10', 'XC', 'Saba', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70900, '2020-04-11', 'XC', 'Saba', 'AMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70901, '2020-04-12', 'XC', 'Saba', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70902, '2020-04-13', 'XC', 'Saba', 'AMRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70903, '2020-04-14', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70904, '2020-04-15', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70905, '2020-04-16', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70906, '2020-04-17', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70907, '2020-04-18', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70908, '2020-04-19', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70909, '2020-04-20', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70910, '2020-04-21', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70911, '2020-04-22', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70912, '2020-04-23', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70913, '2020-04-24', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70914, '2020-04-25', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70915, '2020-04-26', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70916, '2020-04-27', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70917, '2020-04-28', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70918, '2020-04-29', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70919, '2020-04-30', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70920, '2020-05-01', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70921, '2020-05-02', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70922, '2020-05-03', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70923, '2020-05-04', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70924, '2020-05-05', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70925, '2020-05-06', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70926, '2020-05-07', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70927, '2020-05-08', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70928, '2020-05-09', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70929, '2020-05-10', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70930, '2020-05-11', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70931, '2020-05-12', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70932, '2020-05-13', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70933, '2020-05-14', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70934, '2020-05-15', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70935, '2020-05-16', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70936, '2020-05-17', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70937, '2020-05-18', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70938, '2020-05-19', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70939, '2020-05-20', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70940, '2020-05-21', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70941, '2020-05-22', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70942, '2020-05-23', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70943, '2020-05-24', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70944, '2020-05-25', 'XC', 'Saba', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70945, '2020-05-26', 'XC', 'Saba', 'AMRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70946, '2020-05-27', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70947, '2020-05-28', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70948, '2020-05-29', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70949, '2020-05-30', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70950, '2020-05-31', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70951, '2020-06-01', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70952, '2020-06-02', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70953, '2020-06-03', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70954, '2020-06-04', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70955, '2020-06-05', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70956, '2020-06-06', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70957, '2020-06-07', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70958, '2020-06-08', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70959, '2020-06-09', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70960, '2020-06-10', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70961, '2020-06-11', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70962, '2020-06-12', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70963, '2020-06-13', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70964, '2020-06-14', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70965, '2020-06-15', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70966, '2020-06-16', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70967, '2020-06-17', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70968, '2020-06-18', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70969, '2020-06-19', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70970, '2020-06-20', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70971, '2020-06-21', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70972, '2020-06-22', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70973, '2020-06-23', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70974, '2020-06-24', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70975, '2020-06-25', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70976, '2020-06-26', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70977, '2020-06-27', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70978, '2020-06-28', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70979, '2020-06-29', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70980, '2020-06-30', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70981, '2020-07-01', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70982, '2020-07-02', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70983, '2020-07-03', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70984, '2020-07-04', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70985, '2020-07-05', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70986, '2020-07-06', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70987, '2020-07-07', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70988, '2020-07-08', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70989, '2020-07-09', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70990, '2020-07-10', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70991, '2020-07-11', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70992, '2020-07-12', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70993, '2020-07-13', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70994, '2020-07-14', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70995, '2020-07-15', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70996, '2020-07-16', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70997, '2020-07-17', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70998, '2020-07-18', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (70999, '2020-07-19', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71000, '2020-07-20', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71001, '2020-07-21', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71002, '2020-07-22', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71003, '2020-07-23', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71004, '2020-07-24', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71005, '2020-07-25', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71006, '2020-07-26', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71007, '2020-07-27', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71008, '2020-07-28', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71009, '2020-07-29', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71010, '2020-07-30', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71011, '2020-07-31', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71012, '2020-08-01', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71013, '2020-08-02', 'XC', 'Saba', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71014, '2020-08-03', 'XC', 'Saba', 'AMRO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71015, '2020-08-04', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71016, '2020-08-05', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71017, '2020-08-06', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71018, '2020-08-07', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71019, '2020-08-08', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71020, '2020-08-09', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71021, '2020-08-10', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71022, '2020-08-11', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71023, '2020-08-12', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71024, '2020-08-13', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71025, '2020-08-14', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71026, '2020-08-15', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71027, '2020-08-16', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71028, '2020-08-17', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71029, '2020-08-18', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71030, '2020-08-19', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71031, '2020-08-20', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71032, '2020-08-21', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71033, '2020-08-22', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71034, '2020-08-23', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71035, '2020-08-24', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71036, '2020-08-25', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71037, '2020-08-26', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71038, '2020-08-27', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71039, '2020-08-28', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71040, '2020-08-29', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71041, '2020-08-30', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71042, '2020-08-31', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71043, '2020-09-01', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71044, '2020-09-02', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71045, '2020-09-03', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71046, '2020-09-04', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71047, '2020-09-05', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71048, '2020-09-06', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71049, '2020-09-07', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71050, '2020-09-08', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71051, '2020-09-09', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71052, '2020-09-10', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71053, '2020-09-11', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71054, '2020-09-12', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71055, '2020-09-13', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71056, '2020-09-14', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71057, '2020-09-15', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71058, '2020-09-16', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71059, '2020-09-17', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71060, '2020-09-18', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71061, '2020-09-19', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71062, '2020-09-20', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71063, '2020-09-21', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71064, '2020-09-22', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71065, '2020-09-23', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71066, '2020-09-24', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71067, '2020-09-25', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71068, '2020-09-26', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71069, '2020-09-27', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71070, '2020-09-28', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71071, '2020-09-29', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71072, '2020-09-30', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71073, '2020-10-01', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71074, '2020-10-02', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71075, '2020-10-03', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71076, '2020-10-04', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71077, '2020-10-05', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71078, '2020-10-06', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71079, '2020-10-07', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71080, '2020-10-08', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71081, '2020-10-09', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71082, '2020-10-10', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71083, '2020-10-11', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71084, '2020-10-12', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71085, '2020-10-13', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71086, '2020-10-14', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71087, '2020-10-15', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71088, '2020-10-16', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71089, '2020-10-17', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71090, '2020-10-18', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71091, '2020-10-19', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71092, '2020-10-20', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71093, '2020-10-21', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71094, '2020-10-22', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71095, '2020-10-23', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71096, '2020-10-24', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71097, '2020-10-25', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71098, '2020-10-26', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71099, '2020-10-27', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71100, '2020-10-28', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71101, '2020-10-29', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71102, '2020-10-30', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71103, '2020-10-31', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71104, '2020-11-01', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71105, '2020-11-02', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71106, '2020-11-03', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71107, '2020-11-04', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71108, '2020-11-05', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71109, '2020-11-06', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71110, '2020-11-07', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71111, '2020-11-08', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71112, '2020-11-09', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71113, '2020-11-10', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71114, '2020-11-11', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71115, '2020-11-12', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71116, '2020-11-13', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71117, '2020-11-14', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71118, '2020-11-15', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71119, '2020-11-16', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71120, '2020-11-17', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71121, '2020-11-18', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71122, '2020-11-19', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71123, '2020-11-20', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71124, '2020-11-21', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71125, '2020-11-22', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71126, '2020-11-23', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71127, '2020-11-24', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71128, '2020-11-25', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71129, '2020-11-26', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71130, '2020-11-27', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71131, '2020-11-28', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71132, '2020-11-29', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71133, '2020-11-30', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71134, '2020-12-01', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71135, '2020-12-02', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71136, '2020-12-03', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71137, '2020-12-04', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71138, '2020-12-05', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71139, '2020-12-06', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71140, '2020-12-07', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71141, '2020-12-08', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71142, '2020-12-09', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71143, '2020-12-10', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71144, '2020-12-11', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71145, '2020-12-12', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71146, '2020-12-13', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71147, '2020-12-14', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71148, '2020-12-15', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71149, '2020-12-16', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71150, '2020-12-17', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71151, '2020-12-18', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71152, '2020-12-19', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71153, '2020-12-20', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71154, '2020-12-21', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71155, '2020-12-22', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71156, '2020-12-23', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71157, '2020-12-24', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71158, '2020-12-25', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71159, '2020-12-26', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71160, '2020-12-27', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71161, '2020-12-28', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71162, '2020-12-29', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71163, '2020-12-30', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71164, '2020-12-31', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71165, '2021-01-01', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71166, '2021-01-02', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71167, '2021-01-03', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71168, '2021-01-04', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71169, '2021-01-05', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71170, '2021-01-06', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71171, '2021-01-07', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71172, '2021-01-08', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71173, '2021-01-09', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71174, '2021-01-10', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71175, '2021-01-11', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71176, '2021-01-12', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71177, '2021-01-13', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71178, '2021-01-14', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71179, '2021-01-15', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71180, '2021-01-16', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71181, '2021-01-17', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71182, '2021-01-18', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71183, '2021-01-19', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71184, '2021-01-20', 'XC', 'Saba', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71185, '2021-01-21', 'XC', 'Saba', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71186, '2021-01-22', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71187, '2021-01-23', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71188, '2021-01-24', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71189, '2021-01-25', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71190, '2021-01-26', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71191, '2021-01-27', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71192, '2021-01-28', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71193, '2021-01-29', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71194, '2021-01-30', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71195, '2021-01-31', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71196, '2021-02-01', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71197, '2021-02-02', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71198, '2021-02-03', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71199, '2021-02-04', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71200, '2021-02-05', 'XC', 'Saba', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71201, '2020-01-03', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71202, '2020-01-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71203, '2020-01-05', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71204, '2020-01-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71205, '2020-01-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71206, '2020-01-08', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71207, '2020-01-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71208, '2020-01-10', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71209, '2020-01-11', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71210, '2020-01-12', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71211, '2020-01-13', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71212, '2020-01-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71213, '2020-01-15', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71214, '2020-01-16', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71215, '2020-01-17', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71216, '2020-01-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71217, '2020-01-19', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71218, '2020-01-20', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71219, '2020-01-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71220, '2020-01-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71221, '2020-01-23', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71222, '2020-01-24', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71223, '2020-01-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71224, '2020-01-26', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71225, '2020-01-27', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71226, '2020-01-28', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71227, '2020-01-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71228, '2020-01-30', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71229, '2020-01-31', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71230, '2020-02-01', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71231, '2020-02-02', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71232, '2020-02-03', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71233, '2020-02-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71234, '2020-02-05', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71235, '2020-02-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71236, '2020-02-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71237, '2020-02-08', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71238, '2020-02-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71239, '2020-02-10', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71240, '2020-02-11', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71241, '2020-02-12', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71242, '2020-02-13', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71243, '2020-02-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71244, '2020-02-15', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71245, '2020-02-16', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71246, '2020-02-17', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71247, '2020-02-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71248, '2020-02-19', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71249, '2020-02-20', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71250, '2020-02-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71251, '2020-02-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71252, '2020-02-23', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71253, '2020-02-24', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71254, '2020-02-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71255, '2020-02-26', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71256, '2020-02-27', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71257, '2020-02-28', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71258, '2020-02-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71259, '2020-03-01', 'BL', 'Saint Barthélemy', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71260, '2020-03-02', 'BL', 'Saint Barthélemy', 'AMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71261, '2020-03-03', 'BL', 'Saint Barthélemy', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71262, '2020-03-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71263, '2020-03-05', 'BL', 'Saint Barthélemy', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71264, '2020-03-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71265, '2020-03-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71266, '2020-03-08', 'BL', 'Saint Barthélemy', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71267, '2020-03-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71268, '2020-03-10', 'BL', 'Saint Barthélemy', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74102, '2020-04-13', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71269, '2020-03-11', 'BL', 'Saint Barthélemy', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71270, '2020-03-12', 'BL', 'Saint Barthélemy', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71271, '2020-03-13', 'BL', 'Saint Barthélemy', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71272, '2020-03-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71273, '2020-03-15', 'BL', 'Saint Barthélemy', 'AMRO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71274, '2020-03-16', 'BL', 'Saint Barthélemy', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71275, '2020-03-17', 'BL', 'Saint Barthélemy', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71276, '2020-03-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71277, '2020-03-19', 'BL', 'Saint Barthélemy', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71278, '2020-03-20', 'BL', 'Saint Barthélemy', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71279, '2020-03-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71280, '2020-03-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71281, '2020-03-23', 'BL', 'Saint Barthélemy', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71282, '2020-03-24', 'BL', 'Saint Barthélemy', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71283, '2020-03-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71284, '2020-03-26', 'BL', 'Saint Barthélemy', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71285, '2020-03-27', 'BL', 'Saint Barthélemy', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71286, '2020-03-28', 'BL', 'Saint Barthélemy', 'AMRO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71287, '2020-03-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71288, '2020-03-30', 'BL', 'Saint Barthélemy', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71289, '2020-03-31', 'BL', 'Saint Barthélemy', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71290, '2020-04-01', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71291, '2020-04-02', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71292, '2020-04-03', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71293, '2020-04-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71294, '2020-04-05', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71295, '2020-04-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71296, '2020-04-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71297, '2020-04-08', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71298, '2020-04-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71299, '2020-04-10', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71300, '2020-04-11', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71301, '2020-04-12', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71302, '2020-04-13', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71303, '2020-04-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71304, '2020-04-15', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71305, '2020-04-16', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71306, '2020-04-17', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71307, '2020-04-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71308, '2020-04-19', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71309, '2020-04-20', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71310, '2020-04-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71311, '2020-04-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71312, '2020-04-23', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71313, '2020-04-24', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71314, '2020-04-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71315, '2020-04-26', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71316, '2020-04-27', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71317, '2020-04-28', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71318, '2020-04-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71319, '2020-04-30', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71320, '2020-05-01', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71321, '2020-05-02', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71322, '2020-05-03', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71323, '2020-05-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71324, '2020-05-05', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71325, '2020-05-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71326, '2020-05-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71327, '2020-05-08', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71328, '2020-05-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71329, '2020-05-10', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71330, '2020-05-11', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71331, '2020-05-12', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71332, '2020-05-13', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71333, '2020-05-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71334, '2020-05-15', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71335, '2020-05-16', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71336, '2020-05-17', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71337, '2020-05-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71338, '2020-05-19', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71339, '2020-05-20', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71340, '2020-05-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71341, '2020-05-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71342, '2020-05-23', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71343, '2020-05-24', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71344, '2020-05-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71345, '2020-05-26', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71346, '2020-05-27', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71347, '2020-05-28', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71348, '2020-05-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71349, '2020-05-30', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71350, '2020-05-31', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71351, '2020-06-01', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71352, '2020-06-02', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71353, '2020-06-03', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71354, '2020-06-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71355, '2020-06-05', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71356, '2020-06-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71357, '2020-06-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71358, '2020-06-08', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71359, '2020-06-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71360, '2020-06-10', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71361, '2020-06-11', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71362, '2020-06-12', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71363, '2020-06-13', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71364, '2020-06-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71365, '2020-06-15', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71366, '2020-06-16', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71367, '2020-06-17', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71368, '2020-06-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71369, '2020-06-19', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71370, '2020-06-20', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71371, '2020-06-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71372, '2020-06-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71373, '2020-06-23', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71374, '2020-06-24', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71375, '2020-06-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71376, '2020-06-26', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71377, '2020-06-27', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71378, '2020-06-28', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71379, '2020-06-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71380, '2020-06-30', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71381, '2020-07-01', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71382, '2020-07-02', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71383, '2020-07-03', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71384, '2020-07-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71385, '2020-07-05', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71386, '2020-07-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71387, '2020-07-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71388, '2020-07-08', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71389, '2020-07-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71390, '2020-07-10', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71391, '2020-07-11', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71392, '2020-07-12', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71393, '2020-07-13', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71394, '2020-07-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71395, '2020-07-15', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71396, '2020-07-16', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71397, '2020-07-17', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71398, '2020-07-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71399, '2020-07-19', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71400, '2020-07-20', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71401, '2020-07-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71402, '2020-07-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71403, '2020-07-23', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71404, '2020-07-24', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71405, '2020-07-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71406, '2020-07-26', 'BL', 'Saint Barthélemy', 'AMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71407, '2020-07-27', 'BL', 'Saint Barthélemy', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71408, '2020-07-28', 'BL', 'Saint Barthélemy', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71409, '2020-07-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71410, '2020-07-30', 'BL', 'Saint Barthélemy', 'AMRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71411, '2020-07-31', 'BL', 'Saint Barthélemy', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71412, '2020-08-01', 'BL', 'Saint Barthélemy', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71413, '2020-08-02', 'BL', 'Saint Barthélemy', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71414, '2020-08-03', 'BL', 'Saint Barthélemy', 'AMRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71415, '2020-08-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71416, '2020-08-05', 'BL', 'Saint Barthélemy', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71417, '2020-08-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71418, '2020-08-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71419, '2020-08-08', 'BL', 'Saint Barthélemy', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71420, '2020-08-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71421, '2020-08-10', 'BL', 'Saint Barthélemy', 'AMRO', '4', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71422, '2020-08-11', 'BL', 'Saint Barthélemy', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71423, '2020-08-12', 'BL', 'Saint Barthélemy', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71424, '2020-08-13', 'BL', 'Saint Barthélemy', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71425, '2020-08-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71426, '2020-08-15', 'BL', 'Saint Barthélemy', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71427, '2020-08-16', 'BL', 'Saint Barthélemy', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71428, '2020-08-17', 'BL', 'Saint Barthélemy', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71429, '2020-08-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71430, '2020-08-19', 'BL', 'Saint Barthélemy', 'AMRO', '3', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71431, '2020-08-20', 'BL', 'Saint Barthélemy', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71432, '2020-08-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71433, '2020-08-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71434, '2020-08-23', 'BL', 'Saint Barthélemy', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71435, '2020-08-24', 'BL', 'Saint Barthélemy', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71436, '2020-08-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71437, '2020-08-26', 'BL', 'Saint Barthélemy', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71438, '2020-08-27', 'BL', 'Saint Barthélemy', 'AMRO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71439, '2020-08-28', 'BL', 'Saint Barthélemy', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71440, '2020-08-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71441, '2020-08-30', 'BL', 'Saint Barthélemy', 'AMRO', '1', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71442, '2020-08-31', 'BL', 'Saint Barthélemy', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71443, '2020-09-01', 'BL', 'Saint Barthélemy', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71444, '2020-09-02', 'BL', 'Saint Barthélemy', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71445, '2020-09-03', 'BL', 'Saint Barthélemy', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71446, '2020-09-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71447, '2020-09-05', 'BL', 'Saint Barthélemy', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71448, '2020-09-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71449, '2020-09-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71450, '2020-09-08', 'BL', 'Saint Barthélemy', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71451, '2020-09-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71452, '2020-09-10', 'BL', 'Saint Barthélemy', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71453, '2020-09-11', 'BL', 'Saint Barthélemy', 'AMRO', '3', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71454, '2020-09-12', 'BL', 'Saint Barthélemy', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71455, '2020-09-13', 'BL', 'Saint Barthélemy', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71456, '2020-09-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71457, '2020-09-15', 'BL', 'Saint Barthélemy', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71458, '2020-09-16', 'BL', 'Saint Barthélemy', 'AMRO', '2', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71459, '2020-09-17', 'BL', 'Saint Barthélemy', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71460, '2020-09-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71461, '2020-09-19', 'BL', 'Saint Barthélemy', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71462, '2020-09-20', 'BL', 'Saint Barthélemy', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71463, '2020-09-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71464, '2020-09-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71465, '2020-09-23', 'BL', 'Saint Barthélemy', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71466, '2020-09-24', 'BL', 'Saint Barthélemy', 'AMRO', '22', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71467, '2020-09-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71468, '2020-09-26', 'BL', 'Saint Barthélemy', 'AMRO', '0', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71469, '2020-09-27', 'BL', 'Saint Barthélemy', 'AMRO', '3', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71470, '2020-09-28', 'BL', 'Saint Barthélemy', 'AMRO', '0', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71471, '2020-09-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71472, '2020-09-30', 'BL', 'Saint Barthélemy', 'AMRO', '0', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71473, '2020-10-01', 'BL', 'Saint Barthélemy', 'AMRO', '0', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71474, '2020-10-02', 'BL', 'Saint Barthélemy', 'AMRO', '0', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71475, '2020-10-03', 'BL', 'Saint Barthélemy', 'AMRO', '14', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71476, '2020-10-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71477, '2020-10-05', 'BL', 'Saint Barthélemy', 'AMRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71478, '2020-10-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71479, '2020-10-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71480, '2020-10-08', 'BL', 'Saint Barthélemy', 'AMRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71481, '2020-10-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71482, '2020-10-10', 'BL', 'Saint Barthélemy', 'AMRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71483, '2020-10-11', 'BL', 'Saint Barthélemy', 'AMRO', '3', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71484, '2020-10-12', 'BL', 'Saint Barthélemy', 'AMRO', '0', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71485, '2020-10-13', 'BL', 'Saint Barthélemy', 'AMRO', '0', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71486, '2020-10-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71487, '2020-10-15', 'BL', 'Saint Barthélemy', 'AMRO', '0', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71488, '2020-10-16', 'BL', 'Saint Barthélemy', 'AMRO', '2', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71489, '2020-10-17', 'BL', 'Saint Barthélemy', 'AMRO', '5', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71490, '2020-10-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71491, '2020-10-19', 'BL', 'Saint Barthélemy', 'AMRO', '0', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71492, '2020-10-20', 'BL', 'Saint Barthélemy', 'AMRO', '0', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71493, '2020-10-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71494, '2020-10-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71495, '2020-10-23', 'BL', 'Saint Barthélemy', 'AMRO', '5', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71496, '2020-10-24', 'BL', 'Saint Barthélemy', 'AMRO', '0', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71497, '2020-10-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71498, '2020-10-26', 'BL', 'Saint Barthélemy', 'AMRO', '6', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71499, '2020-10-27', 'BL', 'Saint Barthélemy', 'AMRO', '0', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71500, '2020-10-28', 'BL', 'Saint Barthélemy', 'AMRO', '0', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71501, '2020-10-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71502, '2020-10-30', 'BL', 'Saint Barthélemy', 'AMRO', '0', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71503, '2020-10-31', 'BL', 'Saint Barthélemy', 'AMRO', '6', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71504, '2020-11-01', 'BL', 'Saint Barthélemy', 'AMRO', '0', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71505, '2020-11-02', 'BL', 'Saint Barthélemy', 'AMRO', '0', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71506, '2020-11-03', 'BL', 'Saint Barthélemy', 'AMRO', '0', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71507, '2020-11-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71508, '2020-11-05', 'BL', 'Saint Barthélemy', 'AMRO', '1', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71509, '2020-11-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71510, '2020-11-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71511, '2020-11-08', 'BL', 'Saint Barthélemy', 'AMRO', '0', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71512, '2020-11-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71513, '2020-11-10', 'BL', 'Saint Barthélemy', 'AMRO', '0', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71514, '2020-11-11', 'BL', 'Saint Barthélemy', 'AMRO', '0', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71515, '2020-11-12', 'BL', 'Saint Barthélemy', 'AMRO', '0', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71516, '2020-11-13', 'BL', 'Saint Barthélemy', 'AMRO', '19', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71517, '2020-11-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71518, '2020-11-15', 'BL', 'Saint Barthélemy', 'AMRO', '0', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71519, '2020-11-16', 'BL', 'Saint Barthélemy', 'AMRO', '0', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71520, '2020-11-17', 'BL', 'Saint Barthélemy', 'AMRO', '0', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71521, '2020-11-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71522, '2020-11-19', 'BL', 'Saint Barthélemy', 'AMRO', '18', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71523, '2020-11-20', 'BL', 'Saint Barthélemy', 'AMRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71524, '2020-11-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71525, '2020-11-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71526, '2020-11-23', 'BL', 'Saint Barthélemy', 'AMRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71527, '2020-11-24', 'BL', 'Saint Barthélemy', 'AMRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71528, '2020-11-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71529, '2020-11-26', 'BL', 'Saint Barthélemy', 'AMRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71530, '2020-11-27', 'BL', 'Saint Barthélemy', 'AMRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71531, '2020-11-28', 'BL', 'Saint Barthélemy', 'AMRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71532, '2020-11-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71533, '2020-11-30', 'BL', 'Saint Barthélemy', 'AMRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71534, '2020-12-01', 'BL', 'Saint Barthélemy', 'AMRO', '25', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71535, '2020-12-02', 'BL', 'Saint Barthélemy', 'AMRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71536, '2020-12-03', 'BL', 'Saint Barthélemy', 'AMRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71537, '2020-12-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71538, '2020-12-05', 'BL', 'Saint Barthélemy', 'AMRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71539, '2020-12-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71540, '2020-12-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71541, '2020-12-08', 'BL', 'Saint Barthélemy', 'AMRO', '12', '164', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71542, '2020-12-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '164', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71543, '2020-12-10', 'BL', 'Saint Barthélemy', 'AMRO', '0', '164', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71544, '2020-12-11', 'BL', 'Saint Barthélemy', 'AMRO', '0', '164', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71545, '2020-12-12', 'BL', 'Saint Barthélemy', 'AMRO', '0', '164', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71546, '2020-12-13', 'BL', 'Saint Barthélemy', 'AMRO', '0', '164', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71547, '2020-12-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '164', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71548, '2020-12-15', 'BL', 'Saint Barthélemy', 'AMRO', '8', '172', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71549, '2020-12-16', 'BL', 'Saint Barthélemy', 'AMRO', '0', '172', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71550, '2020-12-17', 'BL', 'Saint Barthélemy', 'AMRO', '0', '172', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71551, '2020-12-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '172', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71552, '2020-12-19', 'BL', 'Saint Barthélemy', 'AMRO', '0', '172', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71553, '2020-12-20', 'BL', 'Saint Barthélemy', 'AMRO', '10', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71554, '2020-12-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71555, '2020-12-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71556, '2020-12-23', 'BL', 'Saint Barthélemy', 'AMRO', '0', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71557, '2020-12-24', 'BL', 'Saint Barthélemy', 'AMRO', '0', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71558, '2020-12-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71559, '2020-12-26', 'BL', 'Saint Barthélemy', 'AMRO', '0', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71560, '2020-12-27', 'BL', 'Saint Barthélemy', 'AMRO', '7', '189', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71561, '2020-12-28', 'BL', 'Saint Barthélemy', 'AMRO', '0', '189', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71562, '2020-12-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '189', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71563, '2020-12-30', 'BL', 'Saint Barthélemy', 'AMRO', '0', '189', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71564, '2020-12-31', 'BL', 'Saint Barthélemy', 'AMRO', '0', '189', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71565, '2021-01-01', 'BL', 'Saint Barthélemy', 'AMRO', '1', '190', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71566, '2021-01-02', 'BL', 'Saint Barthélemy', 'AMRO', '0', '190', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71567, '2021-01-03', 'BL', 'Saint Barthélemy', 'AMRO', '0', '190', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71568, '2021-01-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '190', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71569, '2021-01-05', 'BL', 'Saint Barthélemy', 'AMRO', '1', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71570, '2021-01-06', 'BL', 'Saint Barthélemy', 'AMRO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71571, '2021-01-07', 'BL', 'Saint Barthélemy', 'AMRO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71572, '2021-01-08', 'BL', 'Saint Barthélemy', 'AMRO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71573, '2021-01-09', 'BL', 'Saint Barthélemy', 'AMRO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71574, '2021-01-10', 'BL', 'Saint Barthélemy', 'AMRO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71575, '2021-01-11', 'BL', 'Saint Barthélemy', 'AMRO', '0', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71576, '2021-01-12', 'BL', 'Saint Barthélemy', 'AMRO', '33', '224', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71577, '2021-01-13', 'BL', 'Saint Barthélemy', 'AMRO', '0', '224', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71578, '2021-01-14', 'BL', 'Saint Barthélemy', 'AMRO', '0', '224', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71579, '2021-01-15', 'BL', 'Saint Barthélemy', 'AMRO', '0', '224', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71580, '2021-01-16', 'BL', 'Saint Barthélemy', 'AMRO', '0', '224', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71581, '2021-01-17', 'BL', 'Saint Barthélemy', 'AMRO', '0', '224', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71582, '2021-01-18', 'BL', 'Saint Barthélemy', 'AMRO', '0', '224', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71583, '2021-01-19', 'BL', 'Saint Barthélemy', 'AMRO', '57', '281', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71584, '2021-01-20', 'BL', 'Saint Barthélemy', 'AMRO', '0', '281', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71585, '2021-01-21', 'BL', 'Saint Barthélemy', 'AMRO', '0', '281', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71586, '2021-01-22', 'BL', 'Saint Barthélemy', 'AMRO', '0', '281', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71587, '2021-01-23', 'BL', 'Saint Barthélemy', 'AMRO', '95', '376', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71588, '2021-01-24', 'BL', 'Saint Barthélemy', 'AMRO', '0', '376', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71589, '2021-01-25', 'BL', 'Saint Barthélemy', 'AMRO', '0', '376', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71590, '2021-01-26', 'BL', 'Saint Barthélemy', 'AMRO', '0', '376', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71591, '2021-01-27', 'BL', 'Saint Barthélemy', 'AMRO', '0', '376', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71592, '2021-01-28', 'BL', 'Saint Barthélemy', 'AMRO', '0', '376', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71593, '2021-01-29', 'BL', 'Saint Barthélemy', 'AMRO', '0', '376', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71594, '2021-01-30', 'BL', 'Saint Barthélemy', 'AMRO', '0', '376', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71595, '2021-01-31', 'BL', 'Saint Barthélemy', 'AMRO', '3', '379', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71596, '2021-02-01', 'BL', 'Saint Barthélemy', 'AMRO', '0', '379', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71597, '2021-02-02', 'BL', 'Saint Barthélemy', 'AMRO', '0', '379', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71598, '2021-02-03', 'BL', 'Saint Barthélemy', 'AMRO', '0', '379', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71599, '2021-02-04', 'BL', 'Saint Barthélemy', 'AMRO', '0', '379', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71600, '2021-02-05', 'BL', 'Saint Barthélemy', 'AMRO', '0', '379', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71601, '2020-01-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71602, '2020-01-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71603, '2020-01-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71604, '2020-01-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71605, '2020-01-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71606, '2020-01-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71607, '2020-01-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71608, '2020-01-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71609, '2020-01-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71610, '2020-01-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71611, '2020-01-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71612, '2020-01-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71613, '2020-01-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71614, '2020-01-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71615, '2020-01-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71616, '2020-01-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71617, '2020-01-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71618, '2020-01-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71619, '2020-01-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71620, '2020-01-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71621, '2020-01-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71622, '2020-01-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71623, '2020-01-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71624, '2020-01-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71625, '2020-01-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71626, '2020-01-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71627, '2020-01-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71628, '2020-01-30', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71629, '2020-01-31', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71630, '2020-02-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71631, '2020-02-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71632, '2020-02-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71633, '2020-02-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71634, '2020-02-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71635, '2020-02-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71636, '2020-02-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71637, '2020-02-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71638, '2020-02-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71639, '2020-02-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71640, '2020-02-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71641, '2020-02-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71642, '2020-02-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71643, '2020-02-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71644, '2020-02-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71645, '2020-02-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71646, '2020-02-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71647, '2020-02-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71648, '2020-02-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71649, '2020-02-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71650, '2020-02-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71651, '2020-02-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71652, '2020-02-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71653, '2020-02-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71654, '2020-02-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71655, '2020-02-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71656, '2020-02-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71657, '2020-02-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71658, '2020-02-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71659, '2020-03-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71660, '2020-03-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71661, '2020-03-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71662, '2020-03-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71663, '2020-03-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71664, '2020-03-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71665, '2020-03-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71666, '2020-03-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71667, '2020-03-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71668, '2020-03-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71669, '2020-03-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71670, '2020-03-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71671, '2020-03-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71672, '2020-03-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71673, '2020-03-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71674, '2020-03-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71675, '2020-03-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71676, '2020-03-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71677, '2020-03-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71678, '2020-03-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71679, '2020-03-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71680, '2020-03-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71681, '2020-03-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71682, '2020-03-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71683, '2020-03-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71684, '2020-03-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71685, '2020-03-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71686, '2020-03-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71687, '2020-03-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71688, '2020-03-30', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71689, '2020-03-31', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71690, '2020-04-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71691, '2020-04-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71692, '2020-04-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71693, '2020-04-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71694, '2020-04-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71695, '2020-04-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71696, '2020-04-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71697, '2020-04-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71698, '2020-04-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71699, '2020-04-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71700, '2020-04-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71701, '2020-04-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71702, '2020-04-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71703, '2020-04-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71704, '2020-04-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71705, '2020-04-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71706, '2020-04-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71707, '2020-04-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71708, '2020-04-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71709, '2020-04-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71710, '2020-04-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71711, '2020-04-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71712, '2020-04-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71713, '2020-04-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71714, '2020-04-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71715, '2020-04-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71716, '2020-04-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71717, '2020-04-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71718, '2020-04-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71719, '2020-04-30', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71720, '2020-05-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71721, '2020-05-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71722, '2020-05-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71723, '2020-05-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71724, '2020-05-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71725, '2020-05-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71726, '2020-05-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71727, '2020-05-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71728, '2020-05-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71729, '2020-05-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71730, '2020-05-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71731, '2020-05-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71732, '2020-05-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71733, '2020-05-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71734, '2020-05-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71735, '2020-05-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71736, '2020-05-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71737, '2020-05-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71738, '2020-05-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71739, '2020-05-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71740, '2020-05-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71741, '2020-05-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71742, '2020-05-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71743, '2020-05-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71744, '2020-05-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71745, '2020-05-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71746, '2020-05-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71747, '2020-05-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71748, '2020-05-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71749, '2020-05-30', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71750, '2020-05-31', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71751, '2020-06-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71752, '2020-06-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71753, '2020-06-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71754, '2020-06-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71755, '2020-06-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71756, '2020-06-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71757, '2020-06-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71758, '2020-06-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71759, '2020-06-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71760, '2020-06-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71761, '2020-06-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71762, '2020-06-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71763, '2020-06-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71764, '2020-06-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71765, '2020-06-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71766, '2020-06-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71767, '2020-06-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71768, '2020-06-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71769, '2020-06-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71770, '2020-06-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71771, '2020-06-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71772, '2020-06-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71773, '2020-06-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71774, '2020-06-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71775, '2020-06-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71776, '2020-06-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71777, '2020-06-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71778, '2020-06-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71779, '2020-06-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71780, '2020-06-30', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71781, '2020-07-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71782, '2020-07-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71783, '2020-07-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71784, '2020-07-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71785, '2020-07-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71786, '2020-07-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71787, '2020-07-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71788, '2020-07-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71789, '2020-07-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71790, '2020-07-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71791, '2020-07-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71792, '2020-07-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71793, '2020-07-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71794, '2020-07-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71795, '2020-07-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71796, '2020-07-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71797, '2020-07-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71798, '2020-07-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71799, '2020-07-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71800, '2020-07-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71801, '2020-07-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71802, '2020-07-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71803, '2020-07-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71804, '2020-07-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71805, '2020-07-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71806, '2020-07-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71807, '2020-07-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71808, '2020-07-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71809, '2020-07-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71810, '2020-07-30', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71811, '2020-07-31', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71812, '2020-08-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71813, '2020-08-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71814, '2020-08-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71815, '2020-08-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71816, '2020-08-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71817, '2020-08-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71818, '2020-08-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71819, '2020-08-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71820, '2020-08-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71821, '2020-08-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71822, '2020-08-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71823, '2020-08-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71824, '2020-08-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71825, '2020-08-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71826, '2020-08-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71827, '2020-08-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71828, '2020-08-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71829, '2020-08-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71830, '2020-08-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71831, '2020-08-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71832, '2020-08-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71833, '2020-08-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71834, '2020-08-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71835, '2020-08-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71836, '2020-08-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71837, '2020-08-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71838, '2020-08-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71839, '2020-08-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71840, '2020-08-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71841, '2020-08-30', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71842, '2020-08-31', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71843, '2020-09-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71844, '2020-09-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71845, '2020-09-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71846, '2020-09-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71847, '2020-09-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71848, '2020-09-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71849, '2020-09-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71850, '2020-09-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71851, '2020-09-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71852, '2020-09-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71853, '2020-09-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71854, '2020-09-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71855, '2020-09-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71856, '2020-09-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71857, '2020-09-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71858, '2020-09-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71859, '2020-09-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71860, '2020-09-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71861, '2020-09-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71862, '2020-09-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71863, '2020-09-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71864, '2020-09-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71865, '2020-09-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71866, '2020-09-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71867, '2020-09-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71868, '2020-09-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71869, '2020-09-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71870, '2020-09-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71871, '2020-09-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71872, '2020-09-30', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71873, '2020-10-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71874, '2020-10-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71875, '2020-10-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71876, '2020-10-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71877, '2020-10-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71878, '2020-10-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71879, '2020-10-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71880, '2020-10-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71881, '2020-10-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71882, '2020-10-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71883, '2020-10-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71884, '2020-10-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71885, '2020-10-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71886, '2020-10-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71887, '2020-10-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71888, '2020-10-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71889, '2020-10-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71890, '2020-10-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71891, '2020-10-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71892, '2020-10-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71893, '2020-10-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71894, '2020-10-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71895, '2020-10-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71896, '2020-10-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71897, '2020-10-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71898, '2020-10-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71899, '2020-10-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71900, '2020-10-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71901, '2020-10-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71902, '2020-10-30', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71903, '2020-10-31', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71904, '2020-11-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71905, '2020-11-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71906, '2020-11-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71907, '2020-11-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71908, '2020-11-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71909, '2020-11-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71910, '2020-11-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71911, '2020-11-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71912, '2020-11-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71913, '2020-11-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71914, '2020-11-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71915, '2020-11-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71916, '2020-11-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71917, '2020-11-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71918, '2020-11-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71919, '2020-11-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71920, '2020-11-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71921, '2020-11-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71922, '2020-11-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71923, '2020-11-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71924, '2020-11-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71925, '2020-11-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71926, '2020-11-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71927, '2020-11-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71928, '2020-11-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71929, '2020-11-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71930, '2020-11-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71931, '2020-11-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71932, '2020-11-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71933, '2020-11-30', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71934, '2020-12-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71935, '2020-12-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71936, '2020-12-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71937, '2020-12-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71938, '2020-12-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71939, '2020-12-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71940, '2020-12-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71941, '2020-12-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71942, '2020-12-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71943, '2020-12-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71944, '2020-12-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71945, '2020-12-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71946, '2020-12-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71947, '2020-12-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71948, '2020-12-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71949, '2020-12-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71950, '2020-12-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71951, '2020-12-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71952, '2020-12-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71953, '2020-12-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71954, '2020-12-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71955, '2020-12-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71956, '2020-12-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71957, '2020-12-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71958, '2020-12-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71959, '2020-12-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71960, '2020-12-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71961, '2020-12-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71962, '2020-12-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71963, '2020-12-30', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71964, '2020-12-31', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71965, '2021-01-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71966, '2021-01-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71967, '2021-01-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71968, '2021-01-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71969, '2021-01-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71970, '2021-01-06', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71971, '2021-01-07', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71972, '2021-01-08', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71973, '2021-01-09', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71974, '2021-01-10', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71975, '2021-01-11', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71976, '2021-01-12', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71977, '2021-01-13', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71978, '2021-01-14', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71979, '2021-01-15', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71980, '2021-01-16', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71981, '2021-01-17', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71982, '2021-01-18', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71983, '2021-01-19', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71984, '2021-01-20', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71985, '2021-01-21', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71986, '2021-01-22', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71987, '2021-01-23', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71988, '2021-01-24', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71989, '2021-01-25', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71990, '2021-01-26', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71991, '2021-01-27', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71992, '2021-01-28', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71993, '2021-01-29', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71994, '2021-01-30', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71995, '2021-01-31', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71996, '2021-02-01', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71997, '2021-02-02', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71998, '2021-02-03', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (71999, '2021-02-04', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72000, '2021-02-05', 'SH', 'Saint Helena', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72001, '2020-01-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72002, '2020-01-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72003, '2020-01-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72004, '2020-01-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72005, '2020-01-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72006, '2020-01-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72007, '2020-01-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72008, '2020-01-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72009, '2020-01-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72010, '2020-01-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72011, '2020-01-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72012, '2020-01-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72013, '2020-01-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72014, '2020-01-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72015, '2020-01-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72016, '2020-01-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72017, '2020-01-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72018, '2020-01-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72019, '2020-01-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72020, '2020-01-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72021, '2020-01-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72022, '2020-01-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72023, '2020-01-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72024, '2020-01-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72025, '2020-01-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72026, '2020-01-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72027, '2020-01-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72028, '2020-01-30', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72029, '2020-01-31', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72030, '2020-02-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72031, '2020-02-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72032, '2020-02-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72033, '2020-02-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72034, '2020-02-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72035, '2020-02-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72036, '2020-02-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72037, '2020-02-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72038, '2020-02-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72039, '2020-02-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72040, '2020-02-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72041, '2020-02-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72042, '2020-02-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72043, '2020-02-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72044, '2020-02-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72045, '2020-02-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72046, '2020-02-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72047, '2020-02-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72048, '2020-02-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72049, '2020-02-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72050, '2020-02-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72051, '2020-02-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72052, '2020-02-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72053, '2020-02-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72054, '2020-02-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72055, '2020-02-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72056, '2020-02-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72057, '2020-02-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72058, '2020-02-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72059, '2020-03-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72060, '2020-03-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72061, '2020-03-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72062, '2020-03-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72063, '2020-03-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72064, '2020-03-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72065, '2020-03-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72066, '2020-03-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72067, '2020-03-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72068, '2020-03-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72069, '2020-03-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72070, '2020-03-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72071, '2020-03-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72072, '2020-03-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72073, '2020-03-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72074, '2020-03-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72075, '2020-03-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72076, '2020-03-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72077, '2020-03-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72078, '2020-03-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72079, '2020-03-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72080, '2020-03-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72081, '2020-03-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74103, '2020-04-14', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72082, '2020-03-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72083, '2020-03-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72084, '2020-03-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72085, '2020-03-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72086, '2020-03-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72087, '2020-03-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72088, '2020-03-30', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72089, '2020-03-31', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72090, '2020-04-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '6', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72091, '2020-04-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72092, '2020-04-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72093, '2020-04-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72094, '2020-04-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72095, '2020-04-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72096, '2020-04-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72097, '2020-04-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72098, '2020-04-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72099, '2020-04-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72100, '2020-04-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72101, '2020-04-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72102, '2020-04-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72103, '2020-04-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72104, '2020-04-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72105, '2020-04-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72106, '2020-04-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72107, '2020-04-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72108, '2020-04-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72109, '2020-04-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72110, '2020-04-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72111, '2020-04-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72112, '2020-04-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72113, '2020-04-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72114, '2020-04-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72115, '2020-04-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72116, '2020-04-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72117, '2020-04-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72118, '2020-04-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72119, '2020-04-30', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72120, '2020-05-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72121, '2020-05-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72122, '2020-05-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72123, '2020-05-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72124, '2020-05-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72125, '2020-05-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72126, '2020-05-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72127, '2020-05-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72128, '2020-05-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72129, '2020-05-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72130, '2020-05-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72131, '2020-05-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72132, '2020-05-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72133, '2020-05-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72134, '2020-05-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72135, '2020-05-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72136, '2020-05-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72137, '2020-05-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72138, '2020-05-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72139, '2020-05-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72140, '2020-05-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72141, '2020-05-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72142, '2020-05-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72143, '2020-05-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72144, '2020-05-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72145, '2020-05-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72146, '2020-05-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72147, '2020-05-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72148, '2020-05-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72149, '2020-05-30', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72150, '2020-05-31', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72151, '2020-06-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72152, '2020-06-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72153, '2020-06-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72154, '2020-06-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72155, '2020-06-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72156, '2020-06-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72157, '2020-06-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72158, '2020-06-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72159, '2020-06-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72160, '2020-06-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72161, '2020-06-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72162, '2020-06-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72163, '2020-06-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72164, '2020-06-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72165, '2020-06-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72166, '2020-06-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72167, '2020-06-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72168, '2020-06-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72169, '2020-06-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72170, '2020-06-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72171, '2020-06-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72172, '2020-06-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72173, '2020-06-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72174, '2020-06-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72175, '2020-06-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72176, '2020-06-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72177, '2020-06-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72178, '2020-06-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72179, '2020-06-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72180, '2020-06-30', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72181, '2020-07-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72182, '2020-07-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72183, '2020-07-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72184, '2020-07-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72185, '2020-07-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72186, '2020-07-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72187, '2020-07-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72188, '2020-07-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72189, '2020-07-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72190, '2020-07-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72191, '2020-07-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72192, '2020-07-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72193, '2020-07-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72194, '2020-07-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72195, '2020-07-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72196, '2020-07-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72197, '2020-07-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72198, '2020-07-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72199, '2020-07-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72200, '2020-07-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72201, '2020-07-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72202, '2020-07-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72203, '2020-07-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72204, '2020-07-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72205, '2020-07-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72206, '2020-07-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72207, '2020-07-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72208, '2020-07-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72209, '2020-07-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72210, '2020-07-30', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72211, '2020-07-31', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72212, '2020-08-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72213, '2020-08-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72214, '2020-08-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72215, '2020-08-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72216, '2020-08-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72217, '2020-08-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72218, '2020-08-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72219, '2020-08-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72220, '2020-08-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72221, '2020-08-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72222, '2020-08-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72223, '2020-08-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72224, '2020-08-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72225, '2020-08-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72226, '2020-08-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72227, '2020-08-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72228, '2020-08-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72229, '2020-08-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72230, '2020-08-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72231, '2020-08-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72232, '2020-08-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72233, '2020-08-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72234, '2020-08-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72235, '2020-08-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72236, '2020-08-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72237, '2020-08-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72238, '2020-08-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72239, '2020-08-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72240, '2020-08-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72241, '2020-08-30', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72242, '2020-08-31', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72243, '2020-09-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72244, '2020-09-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72245, '2020-09-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72246, '2020-09-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72247, '2020-09-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72248, '2020-09-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72249, '2020-09-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72250, '2020-09-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72251, '2020-09-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72252, '2020-09-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72253, '2020-09-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72254, '2020-09-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72255, '2020-09-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72256, '2020-09-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72257, '2020-09-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72258, '2020-09-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72259, '2020-09-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72260, '2020-09-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72261, '2020-09-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72262, '2020-09-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72263, '2020-09-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72264, '2020-09-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '2', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72265, '2020-09-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72266, '2020-09-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72267, '2020-09-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72268, '2020-09-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72269, '2020-09-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72270, '2020-09-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72271, '2020-09-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72272, '2020-09-30', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72273, '2020-10-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72274, '2020-10-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72275, '2020-10-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72276, '2020-10-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72277, '2020-10-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72278, '2020-10-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72279, '2020-10-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72280, '2020-10-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72281, '2020-10-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72282, '2020-10-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72283, '2020-10-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72284, '2020-10-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72285, '2020-10-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72286, '2020-10-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72287, '2020-10-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72288, '2020-10-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72289, '2020-10-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72290, '2020-10-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72291, '2020-10-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72292, '2020-10-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72293, '2020-10-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72294, '2020-10-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72295, '2020-10-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72296, '2020-10-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72297, '2020-10-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72298, '2020-10-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72299, '2020-10-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72300, '2020-10-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72301, '2020-10-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72302, '2020-10-30', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72303, '2020-10-31', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72304, '2020-11-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72305, '2020-11-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72306, '2020-11-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72307, '2020-11-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72308, '2020-11-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72309, '2020-11-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72310, '2020-11-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72311, '2020-11-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72312, '2020-11-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72313, '2020-11-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72314, '2020-11-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72315, '2020-11-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72316, '2020-11-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72317, '2020-11-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72318, '2020-11-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72319, '2020-11-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72320, '2020-11-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72321, '2020-11-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72322, '2020-11-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72323, '2020-11-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72324, '2020-11-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72325, '2020-11-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72326, '2020-11-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72327, '2020-11-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72328, '2020-11-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '2', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72329, '2020-11-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72330, '2020-11-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72331, '2020-11-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72332, '2020-11-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72333, '2020-11-30', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72334, '2020-12-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72335, '2020-12-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72336, '2020-12-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72337, '2020-12-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72338, '2020-12-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72339, '2020-12-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72340, '2020-12-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '3', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72341, '2020-12-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72342, '2020-12-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72343, '2020-12-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72344, '2020-12-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72345, '2020-12-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72346, '2020-12-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72347, '2020-12-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72348, '2020-12-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72349, '2020-12-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72350, '2020-12-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72351, '2020-12-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72352, '2020-12-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '2', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72353, '2020-12-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72354, '2020-12-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72355, '2020-12-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72356, '2020-12-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72357, '2020-12-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72358, '2020-12-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72359, '2020-12-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72360, '2020-12-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72361, '2020-12-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72362, '2020-12-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '2', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72363, '2020-12-30', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72364, '2020-12-31', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72365, '2021-01-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72366, '2021-01-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72367, '2021-01-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72368, '2021-01-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72369, '2021-01-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72370, '2021-01-06', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72371, '2021-01-07', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72372, '2021-01-08', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72373, '2021-01-09', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72374, '2021-01-10', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72375, '2021-01-11', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72376, '2021-01-12', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72377, '2021-01-13', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72378, '2021-01-14', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72379, '2021-01-15', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72380, '2021-01-16', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72381, '2021-01-17', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72382, '2021-01-18', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72383, '2021-01-19', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72384, '2021-01-20', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72385, '2021-01-21', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72386, '2021-01-22', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72387, '2021-01-23', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72388, '2021-01-24', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72389, '2021-01-25', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72390, '2021-01-26', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72391, '2021-01-27', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72392, '2021-01-28', 'KN', 'Saint Kitts and Nevis', 'AMRO', '2', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72393, '2021-01-29', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72394, '2021-01-30', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72395, '2021-01-31', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72396, '2021-02-01', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72397, '2021-02-02', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72398, '2021-02-03', 'KN', 'Saint Kitts and Nevis', 'AMRO', '1', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72399, '2021-02-04', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72400, '2021-02-05', 'KN', 'Saint Kitts and Nevis', 'AMRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72401, '2020-01-03', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72402, '2020-01-04', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72403, '2020-01-05', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72404, '2020-01-06', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72405, '2020-01-07', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72406, '2020-01-08', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72407, '2020-01-09', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72408, '2020-01-10', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72409, '2020-01-11', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72410, '2020-01-12', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72411, '2020-01-13', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72412, '2020-01-14', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72413, '2020-01-15', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72414, '2020-01-16', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72415, '2020-01-17', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72416, '2020-01-18', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72417, '2020-01-19', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72418, '2020-01-20', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72419, '2020-01-21', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72420, '2020-01-22', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72421, '2020-01-23', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72422, '2020-01-24', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72423, '2020-01-25', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72424, '2020-01-26', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72425, '2020-01-27', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72426, '2020-01-28', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72427, '2020-01-29', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72428, '2020-01-30', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72429, '2020-01-31', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72430, '2020-02-01', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72431, '2020-02-02', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72432, '2020-02-03', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72433, '2020-02-04', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72434, '2020-02-05', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72435, '2020-02-06', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72436, '2020-02-07', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72437, '2020-02-08', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72438, '2020-02-09', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72439, '2020-02-10', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72440, '2020-02-11', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72441, '2020-02-12', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72442, '2020-02-13', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72443, '2020-02-14', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72444, '2020-02-15', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72445, '2020-02-16', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72446, '2020-02-17', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72447, '2020-02-18', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72448, '2020-02-19', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72449, '2020-02-20', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72450, '2020-02-21', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72451, '2020-02-22', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72452, '2020-02-23', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72453, '2020-02-24', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72454, '2020-02-25', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72455, '2020-02-26', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72456, '2020-02-27', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72457, '2020-02-28', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72458, '2020-02-29', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72459, '2020-03-01', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72460, '2020-03-02', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72461, '2020-03-03', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72462, '2020-03-04', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72463, '2020-03-05', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72464, '2020-03-06', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72465, '2020-03-07', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72466, '2020-03-08', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72467, '2020-03-09', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72468, '2020-03-10', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72469, '2020-03-11', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72470, '2020-03-12', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72471, '2020-03-13', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72472, '2020-03-14', 'LC', 'Saint Lucia', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72473, '2020-03-15', 'LC', 'Saint Lucia', 'AMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72474, '2020-03-16', 'LC', 'Saint Lucia', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72475, '2020-03-17', 'LC', 'Saint Lucia', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72476, '2020-03-18', 'LC', 'Saint Lucia', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72477, '2020-03-19', 'LC', 'Saint Lucia', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72478, '2020-03-20', 'LC', 'Saint Lucia', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72479, '2020-03-21', 'LC', 'Saint Lucia', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72480, '2020-03-22', 'LC', 'Saint Lucia', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72481, '2020-03-23', 'LC', 'Saint Lucia', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72482, '2020-03-24', 'LC', 'Saint Lucia', 'AMRO', '-3', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72483, '2020-03-25', 'LC', 'Saint Lucia', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72484, '2020-03-26', 'LC', 'Saint Lucia', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72485, '2020-03-27', 'LC', 'Saint Lucia', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72486, '2020-03-28', 'LC', 'Saint Lucia', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72487, '2020-03-29', 'LC', 'Saint Lucia', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72488, '2020-03-30', 'LC', 'Saint Lucia', 'AMRO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72489, '2020-03-31', 'LC', 'Saint Lucia', 'AMRO', '5', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72490, '2020-04-01', 'LC', 'Saint Lucia', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72491, '2020-04-02', 'LC', 'Saint Lucia', 'AMRO', '4', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72492, '2020-04-03', 'LC', 'Saint Lucia', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72493, '2020-04-04', 'LC', 'Saint Lucia', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72494, '2020-04-05', 'LC', 'Saint Lucia', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72495, '2020-04-06', 'LC', 'Saint Lucia', 'AMRO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72496, '2020-04-07', 'LC', 'Saint Lucia', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72497, '2020-04-08', 'LC', 'Saint Lucia', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72498, '2020-04-09', 'LC', 'Saint Lucia', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72499, '2020-04-10', 'LC', 'Saint Lucia', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72500, '2020-04-11', 'LC', 'Saint Lucia', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72501, '2020-04-12', 'LC', 'Saint Lucia', 'AMRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72502, '2020-04-13', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72503, '2020-04-14', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72504, '2020-04-15', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72505, '2020-04-16', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72506, '2020-04-17', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72507, '2020-04-18', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72508, '2020-04-19', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72509, '2020-04-20', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72510, '2020-04-21', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72511, '2020-04-22', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72512, '2020-04-23', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72513, '2020-04-24', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72514, '2020-04-25', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72515, '2020-04-26', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72516, '2020-04-27', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72517, '2020-04-28', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72518, '2020-04-29', 'LC', 'Saint Lucia', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72519, '2020-04-30', 'LC', 'Saint Lucia', 'AMRO', '2', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72520, '2020-05-01', 'LC', 'Saint Lucia', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72521, '2020-05-02', 'LC', 'Saint Lucia', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72522, '2020-05-03', 'LC', 'Saint Lucia', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72523, '2020-05-04', 'LC', 'Saint Lucia', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72524, '2020-05-05', 'LC', 'Saint Lucia', 'AMRO', '1', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72525, '2020-05-06', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72526, '2020-05-07', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72527, '2020-05-08', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72528, '2020-05-09', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72529, '2020-05-10', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72530, '2020-05-11', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72531, '2020-05-12', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72532, '2020-05-13', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72533, '2020-05-14', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72534, '2020-05-15', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72535, '2020-05-16', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72536, '2020-05-17', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72537, '2020-05-18', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72538, '2020-05-19', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72539, '2020-05-20', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72540, '2020-05-21', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72541, '2020-05-22', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72542, '2020-05-23', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72543, '2020-05-24', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72544, '2020-05-25', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72545, '2020-05-26', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72546, '2020-05-27', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72547, '2020-05-28', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72548, '2020-05-29', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72549, '2020-05-30', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72550, '2020-05-31', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72551, '2020-06-01', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72552, '2020-06-02', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72553, '2020-06-03', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72554, '2020-06-04', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72555, '2020-06-05', 'LC', 'Saint Lucia', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72556, '2020-06-06', 'LC', 'Saint Lucia', 'AMRO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72557, '2020-06-07', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72558, '2020-06-08', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72559, '2020-06-09', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72560, '2020-06-10', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72561, '2020-06-11', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72562, '2020-06-12', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72563, '2020-06-13', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72564, '2020-06-14', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72565, '2020-06-15', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72566, '2020-06-16', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72567, '2020-06-17', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72568, '2020-06-18', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72569, '2020-06-19', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72570, '2020-06-20', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72571, '2020-06-21', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72572, '2020-06-22', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72573, '2020-06-23', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72574, '2020-06-24', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72575, '2020-06-25', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72576, '2020-06-26', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72577, '2020-06-27', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72578, '2020-06-28', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72579, '2020-06-29', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72580, '2020-06-30', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72581, '2020-07-01', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72582, '2020-07-02', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72583, '2020-07-03', 'LC', 'Saint Lucia', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72584, '2020-07-04', 'LC', 'Saint Lucia', 'AMRO', '3', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72585, '2020-07-05', 'LC', 'Saint Lucia', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72586, '2020-07-06', 'LC', 'Saint Lucia', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72587, '2020-07-07', 'LC', 'Saint Lucia', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72588, '2020-07-08', 'LC', 'Saint Lucia', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72589, '2020-07-09', 'LC', 'Saint Lucia', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72590, '2020-07-10', 'LC', 'Saint Lucia', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72591, '2020-07-11', 'LC', 'Saint Lucia', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72592, '2020-07-12', 'LC', 'Saint Lucia', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72593, '2020-07-13', 'LC', 'Saint Lucia', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72594, '2020-07-14', 'LC', 'Saint Lucia', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72595, '2020-07-15', 'LC', 'Saint Lucia', 'AMRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72596, '2020-07-16', 'LC', 'Saint Lucia', 'AMRO', '1', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72597, '2020-07-17', 'LC', 'Saint Lucia', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72598, '2020-07-18', 'LC', 'Saint Lucia', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72599, '2020-07-19', 'LC', 'Saint Lucia', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72600, '2020-07-20', 'LC', 'Saint Lucia', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72601, '2020-07-21', 'LC', 'Saint Lucia', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72602, '2020-07-22', 'LC', 'Saint Lucia', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72603, '2020-07-23', 'LC', 'Saint Lucia', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72604, '2020-07-24', 'LC', 'Saint Lucia', 'AMRO', '1', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72605, '2020-07-25', 'LC', 'Saint Lucia', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72606, '2020-07-26', 'LC', 'Saint Lucia', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72607, '2020-07-27', 'LC', 'Saint Lucia', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72608, '2020-07-28', 'LC', 'Saint Lucia', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72609, '2020-07-29', 'LC', 'Saint Lucia', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72610, '2020-07-30', 'LC', 'Saint Lucia', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72611, '2020-07-31', 'LC', 'Saint Lucia', 'AMRO', '1', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72612, '2020-08-01', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72613, '2020-08-02', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72614, '2020-08-03', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72615, '2020-08-04', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72616, '2020-08-05', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72617, '2020-08-06', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72618, '2020-08-07', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72619, '2020-08-08', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72620, '2020-08-09', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72621, '2020-08-10', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72622, '2020-08-11', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72623, '2020-08-12', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72624, '2020-08-13', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72625, '2020-08-14', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72626, '2020-08-15', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72627, '2020-08-16', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72628, '2020-08-17', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72629, '2020-08-18', 'LC', 'Saint Lucia', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72630, '2020-08-19', 'LC', 'Saint Lucia', 'AMRO', '1', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72631, '2020-08-20', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72632, '2020-08-21', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72633, '2020-08-22', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72634, '2020-08-23', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72635, '2020-08-24', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72636, '2020-08-25', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72637, '2020-08-26', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72638, '2020-08-27', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72639, '2020-08-28', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72640, '2020-08-29', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72641, '2020-08-30', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72642, '2020-08-31', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72643, '2020-09-01', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72644, '2020-09-02', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72645, '2020-09-03', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72646, '2020-09-04', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72647, '2020-09-05', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72648, '2020-09-06', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72649, '2020-09-07', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72650, '2020-09-08', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72651, '2020-09-09', 'LC', 'Saint Lucia', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72652, '2020-09-10', 'LC', 'Saint Lucia', 'AMRO', '1', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72653, '2020-09-11', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72654, '2020-09-12', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72655, '2020-09-13', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72656, '2020-09-14', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72657, '2020-09-15', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72658, '2020-09-16', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72659, '2020-09-17', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72660, '2020-09-18', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72661, '2020-09-19', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72662, '2020-09-20', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72663, '2020-09-21', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72664, '2020-09-22', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72665, '2020-09-23', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72666, '2020-09-24', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72667, '2020-09-25', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72668, '2020-09-26', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72669, '2020-09-27', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72670, '2020-09-28', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72671, '2020-09-29', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72672, '2020-09-30', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72673, '2020-10-01', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72674, '2020-10-02', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72675, '2020-10-03', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72676, '2020-10-04', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72677, '2020-10-05', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72678, '2020-10-06', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72679, '2020-10-07', 'LC', 'Saint Lucia', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72680, '2020-10-08', 'LC', 'Saint Lucia', 'AMRO', '1', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72681, '2020-10-09', 'LC', 'Saint Lucia', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72682, '2020-10-10', 'LC', 'Saint Lucia', 'AMRO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72683, '2020-10-11', 'LC', 'Saint Lucia', 'AMRO', '1', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72684, '2020-10-12', 'LC', 'Saint Lucia', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72685, '2020-10-13', 'LC', 'Saint Lucia', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72686, '2020-10-14', 'LC', 'Saint Lucia', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72687, '2020-10-15', 'LC', 'Saint Lucia', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72688, '2020-10-16', 'LC', 'Saint Lucia', 'AMRO', '2', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72689, '2020-10-17', 'LC', 'Saint Lucia', 'AMRO', '1', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72690, '2020-10-18', 'LC', 'Saint Lucia', 'AMRO', '1', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72691, '2020-10-19', 'LC', 'Saint Lucia', 'AMRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72692, '2020-10-20', 'LC', 'Saint Lucia', 'AMRO', '3', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72693, '2020-10-21', 'LC', 'Saint Lucia', 'AMRO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72694, '2020-10-22', 'LC', 'Saint Lucia', 'AMRO', '2', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72695, '2020-10-23', 'LC', 'Saint Lucia', 'AMRO', '4', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72696, '2020-10-24', 'LC', 'Saint Lucia', 'AMRO', '6', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72697, '2020-10-25', 'LC', 'Saint Lucia', 'AMRO', '4', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72698, '2020-10-26', 'LC', 'Saint Lucia', 'AMRO', '2', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72699, '2020-10-27', 'LC', 'Saint Lucia', 'AMRO', '0', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72700, '2020-10-28', 'LC', 'Saint Lucia', 'AMRO', '9', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72701, '2020-10-29', 'LC', 'Saint Lucia', 'AMRO', '2', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72702, '2020-10-30', 'LC', 'Saint Lucia', 'AMRO', '11', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72703, '2020-10-31', 'LC', 'Saint Lucia', 'AMRO', '0', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72704, '2020-11-01', 'LC', 'Saint Lucia', 'AMRO', '2', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72705, '2020-11-02', 'LC', 'Saint Lucia', 'AMRO', '6', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72706, '2020-11-03', 'LC', 'Saint Lucia', 'AMRO', '0', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72707, '2020-11-04', 'LC', 'Saint Lucia', 'AMRO', '13', '97', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72708, '2020-11-05', 'LC', 'Saint Lucia', 'AMRO', '8', '105', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72709, '2020-11-06', 'LC', 'Saint Lucia', 'AMRO', '1', '106', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72710, '2020-11-07', 'LC', 'Saint Lucia', 'AMRO', '4', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72711, '2020-11-08', 'LC', 'Saint Lucia', 'AMRO', '0', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72712, '2020-11-09', 'LC', 'Saint Lucia', 'AMRO', '13', '123', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72713, '2020-11-10', 'LC', 'Saint Lucia', 'AMRO', '8', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72714, '2020-11-11', 'LC', 'Saint Lucia', 'AMRO', '11', '142', '1', '1');
INSERT INTO public.who_global_data_import VALUES (72715, '2020-11-12', 'LC', 'Saint Lucia', 'AMRO', '6', '148', '1', '2');
INSERT INTO public.who_global_data_import VALUES (72716, '2020-11-13', 'LC', 'Saint Lucia', 'AMRO', '8', '156', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72717, '2020-11-14', 'LC', 'Saint Lucia', 'AMRO', '0', '156', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72718, '2020-11-15', 'LC', 'Saint Lucia', 'AMRO', '4', '160', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72719, '2020-11-16', 'LC', 'Saint Lucia', 'AMRO', '2', '162', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72720, '2020-11-17', 'LC', 'Saint Lucia', 'AMRO', '11', '173', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72721, '2020-11-18', 'LC', 'Saint Lucia', 'AMRO', '5', '178', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72722, '2020-11-19', 'LC', 'Saint Lucia', 'AMRO', '5', '183', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72723, '2020-11-20', 'LC', 'Saint Lucia', 'AMRO', '20', '203', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72724, '2020-11-21', 'LC', 'Saint Lucia', 'AMRO', '0', '203', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72725, '2020-11-22', 'LC', 'Saint Lucia', 'AMRO', '0', '203', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72726, '2020-11-23', 'LC', 'Saint Lucia', 'AMRO', '1', '204', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72727, '2020-11-24', 'LC', 'Saint Lucia', 'AMRO', '19', '223', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72728, '2020-11-25', 'LC', 'Saint Lucia', 'AMRO', '3', '226', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72729, '2020-11-26', 'LC', 'Saint Lucia', 'AMRO', '9', '235', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72730, '2020-11-27', 'LC', 'Saint Lucia', 'AMRO', '3', '238', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72731, '2020-11-28', 'LC', 'Saint Lucia', 'AMRO', '8', '246', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72732, '2020-11-29', 'LC', 'Saint Lucia', 'AMRO', '0', '246', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72733, '2020-11-30', 'LC', 'Saint Lucia', 'AMRO', '6', '252', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72734, '2020-12-01', 'LC', 'Saint Lucia', 'AMRO', '5', '257', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72735, '2020-12-02', 'LC', 'Saint Lucia', 'AMRO', '2', '259', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72736, '2020-12-03', 'LC', 'Saint Lucia', 'AMRO', '2', '261', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72737, '2020-12-04', 'LC', 'Saint Lucia', 'AMRO', '1', '262', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72738, '2020-12-05', 'LC', 'Saint Lucia', 'AMRO', '0', '262', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72739, '2020-12-06', 'LC', 'Saint Lucia', 'AMRO', '3', '265', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72740, '2020-12-07', 'LC', 'Saint Lucia', 'AMRO', '0', '265', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72741, '2020-12-08', 'LC', 'Saint Lucia', 'AMRO', '0', '265', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72742, '2020-12-09', 'LC', 'Saint Lucia', 'AMRO', '5', '270', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72743, '2020-12-10', 'LC', 'Saint Lucia', 'AMRO', '1', '271', '1', '3');
INSERT INTO public.who_global_data_import VALUES (72744, '2020-12-11', 'LC', 'Saint Lucia', 'AMRO', '3', '274', '1', '4');
INSERT INTO public.who_global_data_import VALUES (72745, '2020-12-12', 'LC', 'Saint Lucia', 'AMRO', '0', '274', '0', '4');
INSERT INTO public.who_global_data_import VALUES (72746, '2020-12-13', 'LC', 'Saint Lucia', 'AMRO', '0', '274', '0', '4');
INSERT INTO public.who_global_data_import VALUES (72747, '2020-12-14', 'LC', 'Saint Lucia', 'AMRO', '1', '275', '0', '4');
INSERT INTO public.who_global_data_import VALUES (72748, '2020-12-15', 'LC', 'Saint Lucia', 'AMRO', '0', '275', '0', '4');
INSERT INTO public.who_global_data_import VALUES (72749, '2020-12-16', 'LC', 'Saint Lucia', 'AMRO', '3', '278', '0', '4');
INSERT INTO public.who_global_data_import VALUES (72750, '2020-12-17', 'LC', 'Saint Lucia', 'AMRO', '0', '278', '0', '4');
INSERT INTO public.who_global_data_import VALUES (72751, '2020-12-18', 'LC', 'Saint Lucia', 'AMRO', '1', '279', '0', '4');
INSERT INTO public.who_global_data_import VALUES (72752, '2020-12-19', 'LC', 'Saint Lucia', 'AMRO', '1', '280', '1', '5');
INSERT INTO public.who_global_data_import VALUES (72753, '2020-12-20', 'LC', 'Saint Lucia', 'AMRO', '0', '280', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72754, '2020-12-21', 'LC', 'Saint Lucia', 'AMRO', '2', '282', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72755, '2020-12-22', 'LC', 'Saint Lucia', 'AMRO', '5', '287', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72756, '2020-12-23', 'LC', 'Saint Lucia', 'AMRO', '16', '303', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72757, '2020-12-24', 'LC', 'Saint Lucia', 'AMRO', '2', '305', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72758, '2020-12-25', 'LC', 'Saint Lucia', 'AMRO', '0', '305', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72759, '2020-12-26', 'LC', 'Saint Lucia', 'AMRO', '0', '305', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72760, '2020-12-27', 'LC', 'Saint Lucia', 'AMRO', '0', '305', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72761, '2020-12-28', 'LC', 'Saint Lucia', 'AMRO', '0', '305', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72762, '2020-12-29', 'LC', 'Saint Lucia', 'AMRO', '26', '331', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72763, '2020-12-30', 'LC', 'Saint Lucia', 'AMRO', '0', '331', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72764, '2020-12-31', 'LC', 'Saint Lucia', 'AMRO', '9', '340', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72765, '2021-01-01', 'LC', 'Saint Lucia', 'AMRO', '13', '353', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72766, '2021-01-02', 'LC', 'Saint Lucia', 'AMRO', '0', '353', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72767, '2021-01-03', 'LC', 'Saint Lucia', 'AMRO', '0', '353', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72768, '2021-01-04', 'LC', 'Saint Lucia', 'AMRO', '0', '353', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72769, '2021-01-05', 'LC', 'Saint Lucia', 'AMRO', '0', '353', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72770, '2021-01-06', 'LC', 'Saint Lucia', 'AMRO', '7', '360', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72771, '2021-01-07', 'LC', 'Saint Lucia', 'AMRO', '20', '380', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72772, '2021-01-08', 'LC', 'Saint Lucia', 'AMRO', '2', '382', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72773, '2021-01-09', 'LC', 'Saint Lucia', 'AMRO', '1', '383', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72774, '2021-01-10', 'LC', 'Saint Lucia', 'AMRO', '12', '395', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72775, '2021-01-11', 'LC', 'Saint Lucia', 'AMRO', '43', '438', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72776, '2021-01-12', 'LC', 'Saint Lucia', 'AMRO', '0', '438', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72777, '2021-01-13', 'LC', 'Saint Lucia', 'AMRO', '40', '478', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72778, '2021-01-14', 'LC', 'Saint Lucia', 'AMRO', '12', '490', '0', '5');
INSERT INTO public.who_global_data_import VALUES (72779, '2021-01-15', 'LC', 'Saint Lucia', 'AMRO', '12', '502', '1', '6');
INSERT INTO public.who_global_data_import VALUES (72780, '2021-01-16', 'LC', 'Saint Lucia', 'AMRO', '41', '543', '0', '6');
INSERT INTO public.who_global_data_import VALUES (72781, '2021-01-17', 'LC', 'Saint Lucia', 'AMRO', '33', '576', '0', '6');
INSERT INTO public.who_global_data_import VALUES (72782, '2021-01-18', 'LC', 'Saint Lucia', 'AMRO', '35', '611', '2', '8');
INSERT INTO public.who_global_data_import VALUES (72783, '2021-01-19', 'LC', 'Saint Lucia', 'AMRO', '10', '621', '0', '8');
INSERT INTO public.who_global_data_import VALUES (72784, '2021-01-20', 'LC', 'Saint Lucia', 'AMRO', '35', '656', '0', '8');
INSERT INTO public.who_global_data_import VALUES (72785, '2021-01-21', 'LC', 'Saint Lucia', 'AMRO', '57', '713', '0', '8');
INSERT INTO public.who_global_data_import VALUES (72786, '2021-01-22', 'LC', 'Saint Lucia', 'AMRO', '5', '718', '0', '8');
INSERT INTO public.who_global_data_import VALUES (72787, '2021-01-23', 'LC', 'Saint Lucia', 'AMRO', '37', '755', '0', '8');
INSERT INTO public.who_global_data_import VALUES (72788, '2021-01-24', 'LC', 'Saint Lucia', 'AMRO', '15', '770', '2', '10');
INSERT INTO public.who_global_data_import VALUES (72789, '2021-01-25', 'LC', 'Saint Lucia', 'AMRO', '40', '810', '1', '11');
INSERT INTO public.who_global_data_import VALUES (72790, '2021-01-26', 'LC', 'Saint Lucia', 'AMRO', '76', '886', '0', '11');
INSERT INTO public.who_global_data_import VALUES (72791, '2021-01-27', 'LC', 'Saint Lucia', 'AMRO', '35', '921', '2', '13');
INSERT INTO public.who_global_data_import VALUES (72792, '2021-01-28', 'LC', 'Saint Lucia', 'AMRO', '48', '969', '0', '13');
INSERT INTO public.who_global_data_import VALUES (72793, '2021-01-29', 'LC', 'Saint Lucia', 'AMRO', '60', '1029', '0', '13');
INSERT INTO public.who_global_data_import VALUES (72794, '2021-01-30', 'LC', 'Saint Lucia', 'AMRO', '77', '1106', '0', '13');
INSERT INTO public.who_global_data_import VALUES (72795, '2021-01-31', 'LC', 'Saint Lucia', 'AMRO', '89', '1195', '0', '13');
INSERT INTO public.who_global_data_import VALUES (72796, '2021-02-01', 'LC', 'Saint Lucia', 'AMRO', '0', '1195', '0', '13');
INSERT INTO public.who_global_data_import VALUES (72797, '2021-02-02', 'LC', 'Saint Lucia', 'AMRO', '216', '1411', '2', '15');
INSERT INTO public.who_global_data_import VALUES (72798, '2021-02-03', 'LC', 'Saint Lucia', 'AMRO', '0', '1411', '0', '15');
INSERT INTO public.who_global_data_import VALUES (72799, '2021-02-04', 'LC', 'Saint Lucia', 'AMRO', '68', '1479', '1', '16');
INSERT INTO public.who_global_data_import VALUES (72800, '2021-02-05', 'LC', 'Saint Lucia', 'AMRO', '77', '1556', '2', '18');
INSERT INTO public.who_global_data_import VALUES (72801, '2020-01-03', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72802, '2020-01-04', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72803, '2020-01-05', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72804, '2020-01-06', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72805, '2020-01-07', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72806, '2020-01-08', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72807, '2020-01-09', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72808, '2020-01-10', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72809, '2020-01-11', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72810, '2020-01-12', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72811, '2020-01-13', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72812, '2020-01-14', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72813, '2020-01-15', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72814, '2020-01-16', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72815, '2020-01-17', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72816, '2020-01-18', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72817, '2020-01-19', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72818, '2020-01-20', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72819, '2020-01-21', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72820, '2020-01-22', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72821, '2020-01-23', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72822, '2020-01-24', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72823, '2020-01-25', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72824, '2020-01-26', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72825, '2020-01-27', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72826, '2020-01-28', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72827, '2020-01-29', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72828, '2020-01-30', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72829, '2020-01-31', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72830, '2020-02-01', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72831, '2020-02-02', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72832, '2020-02-03', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72833, '2020-02-04', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72834, '2020-02-05', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72835, '2020-02-06', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72836, '2020-02-07', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72837, '2020-02-08', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72838, '2020-02-09', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72839, '2020-02-10', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72840, '2020-02-11', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72841, '2020-02-12', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72842, '2020-02-13', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72843, '2020-02-14', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72844, '2020-02-15', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72845, '2020-02-16', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72846, '2020-02-17', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72847, '2020-02-18', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72848, '2020-02-19', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72849, '2020-02-20', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72850, '2020-02-21', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72851, '2020-02-22', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72852, '2020-02-23', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72853, '2020-02-24', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72854, '2020-02-25', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72855, '2020-02-26', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72856, '2020-02-27', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72857, '2020-02-28', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72858, '2020-02-29', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72859, '2020-03-01', 'MF', 'Saint Martin', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72860, '2020-03-02', 'MF', 'Saint Martin', 'AMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72861, '2020-03-03', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72862, '2020-03-04', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72863, '2020-03-05', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72864, '2020-03-06', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72865, '2020-03-07', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72866, '2020-03-08', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72867, '2020-03-09', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72868, '2020-03-10', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72869, '2020-03-11', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72870, '2020-03-12', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72871, '2020-03-13', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72872, '2020-03-14', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72873, '2020-03-15', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72874, '2020-03-16', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72875, '2020-03-17', 'MF', 'Saint Martin', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72876, '2020-03-18', 'MF', 'Saint Martin', 'AMRO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72877, '2020-03-19', 'MF', 'Saint Martin', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72878, '2020-03-20', 'MF', 'Saint Martin', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72879, '2020-03-21', 'MF', 'Saint Martin', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72880, '2020-03-22', 'MF', 'Saint Martin', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72881, '2020-03-23', 'MF', 'Saint Martin', 'AMRO', '-3', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72882, '2020-03-24', 'MF', 'Saint Martin', 'AMRO', '3', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72883, '2020-03-25', 'MF', 'Saint Martin', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72884, '2020-03-26', 'MF', 'Saint Martin', 'AMRO', '3', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72885, '2020-03-27', 'MF', 'Saint Martin', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72886, '2020-03-28', 'MF', 'Saint Martin', 'AMRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72887, '2020-03-29', 'MF', 'Saint Martin', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72888, '2020-03-30', 'MF', 'Saint Martin', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (72889, '2020-03-31', 'MF', 'Saint Martin', 'AMRO', '6', '18', '1', '1');
INSERT INTO public.who_global_data_import VALUES (72890, '2020-04-01', 'MF', 'Saint Martin', 'AMRO', '0', '18', '1', '2');
INSERT INTO public.who_global_data_import VALUES (72891, '2020-04-02', 'MF', 'Saint Martin', 'AMRO', '3', '21', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72892, '2020-04-03', 'MF', 'Saint Martin', 'AMRO', '1', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72893, '2020-04-04', 'MF', 'Saint Martin', 'AMRO', '0', '22', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72894, '2020-04-05', 'MF', 'Saint Martin', 'AMRO', '2', '24', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72895, '2020-04-06', 'MF', 'Saint Martin', 'AMRO', '5', '29', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72896, '2020-04-07', 'MF', 'Saint Martin', 'AMRO', '2', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72897, '2020-04-08', 'MF', 'Saint Martin', 'AMRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72898, '2020-04-09', 'MF', 'Saint Martin', 'AMRO', '0', '31', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72899, '2020-04-10', 'MF', 'Saint Martin', 'AMRO', '1', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72900, '2020-04-11', 'MF', 'Saint Martin', 'AMRO', '0', '32', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72901, '2020-04-12', 'MF', 'Saint Martin', 'AMRO', '1', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72902, '2020-04-13', 'MF', 'Saint Martin', 'AMRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72903, '2020-04-14', 'MF', 'Saint Martin', 'AMRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72904, '2020-04-15', 'MF', 'Saint Martin', 'AMRO', '2', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72905, '2020-04-16', 'MF', 'Saint Martin', 'AMRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72906, '2020-04-17', 'MF', 'Saint Martin', 'AMRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72907, '2020-04-18', 'MF', 'Saint Martin', 'AMRO', '0', '35', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72908, '2020-04-19', 'MF', 'Saint Martin', 'AMRO', '2', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72909, '2020-04-20', 'MF', 'Saint Martin', 'AMRO', '0', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72910, '2020-04-21', 'MF', 'Saint Martin', 'AMRO', '0', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72911, '2020-04-22', 'MF', 'Saint Martin', 'AMRO', '0', '37', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72912, '2020-04-23', 'MF', 'Saint Martin', 'AMRO', '1', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72913, '2020-04-24', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72914, '2020-04-25', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (72915, '2020-04-26', 'MF', 'Saint Martin', 'AMRO', '0', '38', '1', '3');
INSERT INTO public.who_global_data_import VALUES (72916, '2020-04-27', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72917, '2020-04-28', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72918, '2020-04-29', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72919, '2020-04-30', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72920, '2020-05-01', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72921, '2020-05-02', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72922, '2020-05-03', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72923, '2020-05-04', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72924, '2020-05-05', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72925, '2020-05-06', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72926, '2020-05-07', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72927, '2020-05-08', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72928, '2020-05-09', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72929, '2020-05-10', 'MF', 'Saint Martin', 'AMRO', '0', '38', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72930, '2020-05-11', 'MF', 'Saint Martin', 'AMRO', '1', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72931, '2020-05-12', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72932, '2020-05-13', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72933, '2020-05-14', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72934, '2020-05-15', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72935, '2020-05-16', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72936, '2020-05-17', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72937, '2020-05-18', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72938, '2020-05-19', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72939, '2020-05-20', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72940, '2020-05-21', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72941, '2020-05-22', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72942, '2020-05-23', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72943, '2020-05-24', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72944, '2020-05-25', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72945, '2020-05-26', 'MF', 'Saint Martin', 'AMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72946, '2020-05-27', 'MF', 'Saint Martin', 'AMRO', '1', '40', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72947, '2020-05-28', 'MF', 'Saint Martin', 'AMRO', '0', '40', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72948, '2020-05-29', 'MF', 'Saint Martin', 'AMRO', '0', '40', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72949, '2020-05-30', 'MF', 'Saint Martin', 'AMRO', '0', '40', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72950, '2020-05-31', 'MF', 'Saint Martin', 'AMRO', '1', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72951, '2020-06-01', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72952, '2020-06-02', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72953, '2020-06-03', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72954, '2020-06-04', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72955, '2020-06-05', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72956, '2020-06-06', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72957, '2020-06-07', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72958, '2020-06-08', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72959, '2020-06-09', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72960, '2020-06-10', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72961, '2020-06-11', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72962, '2020-06-12', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72963, '2020-06-13', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72964, '2020-06-14', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72965, '2020-06-15', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72966, '2020-06-16', 'MF', 'Saint Martin', 'AMRO', '0', '41', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72967, '2020-06-17', 'MF', 'Saint Martin', 'AMRO', '1', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72968, '2020-06-18', 'MF', 'Saint Martin', 'AMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72969, '2020-06-19', 'MF', 'Saint Martin', 'AMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72970, '2020-06-20', 'MF', 'Saint Martin', 'AMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72971, '2020-06-21', 'MF', 'Saint Martin', 'AMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72972, '2020-06-22', 'MF', 'Saint Martin', 'AMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72973, '2020-06-23', 'MF', 'Saint Martin', 'AMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72974, '2020-06-24', 'MF', 'Saint Martin', 'AMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72975, '2020-06-25', 'MF', 'Saint Martin', 'AMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72976, '2020-06-26', 'MF', 'Saint Martin', 'AMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72977, '2020-06-27', 'MF', 'Saint Martin', 'AMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72978, '2020-06-28', 'MF', 'Saint Martin', 'AMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72979, '2020-06-29', 'MF', 'Saint Martin', 'AMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72980, '2020-06-30', 'MF', 'Saint Martin', 'AMRO', '1', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72981, '2020-07-01', 'MF', 'Saint Martin', 'AMRO', '0', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72982, '2020-07-02', 'MF', 'Saint Martin', 'AMRO', '0', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72983, '2020-07-03', 'MF', 'Saint Martin', 'AMRO', '0', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72984, '2020-07-04', 'MF', 'Saint Martin', 'AMRO', '0', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72985, '2020-07-05', 'MF', 'Saint Martin', 'AMRO', '1', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72986, '2020-07-06', 'MF', 'Saint Martin', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72987, '2020-07-07', 'MF', 'Saint Martin', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72988, '2020-07-08', 'MF', 'Saint Martin', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72989, '2020-07-09', 'MF', 'Saint Martin', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72990, '2020-07-10', 'MF', 'Saint Martin', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72991, '2020-07-11', 'MF', 'Saint Martin', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72992, '2020-07-12', 'MF', 'Saint Martin', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72993, '2020-07-13', 'MF', 'Saint Martin', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72994, '2020-07-14', 'MF', 'Saint Martin', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72995, '2020-07-15', 'MF', 'Saint Martin', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72996, '2020-07-16', 'MF', 'Saint Martin', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72997, '2020-07-17', 'MF', 'Saint Martin', 'AMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72998, '2020-07-18', 'MF', 'Saint Martin', 'AMRO', '2', '46', '0', '3');
INSERT INTO public.who_global_data_import VALUES (72999, '2020-07-19', 'MF', 'Saint Martin', 'AMRO', '0', '46', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73000, '2020-07-20', 'MF', 'Saint Martin', 'AMRO', '0', '46', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73001, '2020-07-21', 'MF', 'Saint Martin', 'AMRO', '0', '46', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73002, '2020-07-22', 'MF', 'Saint Martin', 'AMRO', '0', '46', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73003, '2020-07-23', 'MF', 'Saint Martin', 'AMRO', '0', '46', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73004, '2020-07-24', 'MF', 'Saint Martin', 'AMRO', '0', '46', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73005, '2020-07-25', 'MF', 'Saint Martin', 'AMRO', '0', '46', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73006, '2020-07-26', 'MF', 'Saint Martin', 'AMRO', '3', '49', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73007, '2020-07-27', 'MF', 'Saint Martin', 'AMRO', '0', '49', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73008, '2020-07-28', 'MF', 'Saint Martin', 'AMRO', '0', '49', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73009, '2020-07-29', 'MF', 'Saint Martin', 'AMRO', '0', '49', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73010, '2020-07-30', 'MF', 'Saint Martin', 'AMRO', '4', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73011, '2020-07-31', 'MF', 'Saint Martin', 'AMRO', '0', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73012, '2020-08-01', 'MF', 'Saint Martin', 'AMRO', '0', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73013, '2020-08-02', 'MF', 'Saint Martin', 'AMRO', '0', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73014, '2020-08-03', 'MF', 'Saint Martin', 'AMRO', '0', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73015, '2020-08-04', 'MF', 'Saint Martin', 'AMRO', '0', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73016, '2020-08-05', 'MF', 'Saint Martin', 'AMRO', '0', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73017, '2020-08-06', 'MF', 'Saint Martin', 'AMRO', '0', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73018, '2020-08-07', 'MF', 'Saint Martin', 'AMRO', '0', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73019, '2020-08-08', 'MF', 'Saint Martin', 'AMRO', '0', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73020, '2020-08-09', 'MF', 'Saint Martin', 'AMRO', '0', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73021, '2020-08-10', 'MF', 'Saint Martin', 'AMRO', '25', '78', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73022, '2020-08-11', 'MF', 'Saint Martin', 'AMRO', '0', '78', '0', '3');
INSERT INTO public.who_global_data_import VALUES (73023, '2020-08-12', 'MF', 'Saint Martin', 'AMRO', '6', '84', '1', '4');
INSERT INTO public.who_global_data_import VALUES (73024, '2020-08-13', 'MF', 'Saint Martin', 'AMRO', '0', '84', '0', '4');
INSERT INTO public.who_global_data_import VALUES (73025, '2020-08-14', 'MF', 'Saint Martin', 'AMRO', '8', '92', '0', '4');
INSERT INTO public.who_global_data_import VALUES (73026, '2020-08-15', 'MF', 'Saint Martin', 'AMRO', '0', '92', '0', '4');
INSERT INTO public.who_global_data_import VALUES (73027, '2020-08-16', 'MF', 'Saint Martin', 'AMRO', '17', '109', '1', '5');
INSERT INTO public.who_global_data_import VALUES (73028, '2020-08-17', 'MF', 'Saint Martin', 'AMRO', '0', '109', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73029, '2020-08-18', 'MF', 'Saint Martin', 'AMRO', '0', '109', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73030, '2020-08-19', 'MF', 'Saint Martin', 'AMRO', '12', '121', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73031, '2020-08-20', 'MF', 'Saint Martin', 'AMRO', '0', '121', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73032, '2020-08-21', 'MF', 'Saint Martin', 'AMRO', '0', '121', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73033, '2020-08-22', 'MF', 'Saint Martin', 'AMRO', '0', '121', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73034, '2020-08-23', 'MF', 'Saint Martin', 'AMRO', '55', '176', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73035, '2020-08-24', 'MF', 'Saint Martin', 'AMRO', '0', '176', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73036, '2020-08-25', 'MF', 'Saint Martin', 'AMRO', '0', '176', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73037, '2020-08-26', 'MF', 'Saint Martin', 'AMRO', '0', '176', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73038, '2020-08-27', 'MF', 'Saint Martin', 'AMRO', '22', '198', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73039, '2020-08-28', 'MF', 'Saint Martin', 'AMRO', '0', '198', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73040, '2020-08-29', 'MF', 'Saint Martin', 'AMRO', '0', '198', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73041, '2020-08-30', 'MF', 'Saint Martin', 'AMRO', '15', '213', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73042, '2020-08-31', 'MF', 'Saint Martin', 'AMRO', '0', '213', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73043, '2020-09-01', 'MF', 'Saint Martin', 'AMRO', '0', '213', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73044, '2020-09-02', 'MF', 'Saint Martin', 'AMRO', '0', '213', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73045, '2020-09-03', 'MF', 'Saint Martin', 'AMRO', '0', '213', '0', '5');
INSERT INTO public.who_global_data_import VALUES (73046, '2020-09-04', 'MF', 'Saint Martin', 'AMRO', '26', '239', '1', '6');
INSERT INTO public.who_global_data_import VALUES (73047, '2020-09-05', 'MF', 'Saint Martin', 'AMRO', '0', '239', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73048, '2020-09-06', 'MF', 'Saint Martin', 'AMRO', '0', '239', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73049, '2020-09-07', 'MF', 'Saint Martin', 'AMRO', '0', '239', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73050, '2020-09-08', 'MF', 'Saint Martin', 'AMRO', '0', '239', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73051, '2020-09-09', 'MF', 'Saint Martin', 'AMRO', '0', '239', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73052, '2020-09-10', 'MF', 'Saint Martin', 'AMRO', '0', '239', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73053, '2020-09-11', 'MF', 'Saint Martin', 'AMRO', '17', '256', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73054, '2020-09-12', 'MF', 'Saint Martin', 'AMRO', '0', '256', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73055, '2020-09-13', 'MF', 'Saint Martin', 'AMRO', '0', '256', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73056, '2020-09-14', 'MF', 'Saint Martin', 'AMRO', '0', '256', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73057, '2020-09-15', 'MF', 'Saint Martin', 'AMRO', '0', '256', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73058, '2020-09-16', 'MF', 'Saint Martin', 'AMRO', '74', '330', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73059, '2020-09-17', 'MF', 'Saint Martin', 'AMRO', '0', '330', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73060, '2020-09-18', 'MF', 'Saint Martin', 'AMRO', '0', '330', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73061, '2020-09-19', 'MF', 'Saint Martin', 'AMRO', '0', '330', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73062, '2020-09-20', 'MF', 'Saint Martin', 'AMRO', '0', '330', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73063, '2020-09-21', 'MF', 'Saint Martin', 'AMRO', '0', '330', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73064, '2020-09-22', 'MF', 'Saint Martin', 'AMRO', '0', '330', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73065, '2020-09-23', 'MF', 'Saint Martin', 'AMRO', '0', '330', '0', '6');
INSERT INTO public.who_global_data_import VALUES (73066, '2020-09-24', 'MF', 'Saint Martin', 'AMRO', '37', '367', '2', '8');
INSERT INTO public.who_global_data_import VALUES (73067, '2020-09-25', 'MF', 'Saint Martin', 'AMRO', '0', '367', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73068, '2020-09-26', 'MF', 'Saint Martin', 'AMRO', '0', '367', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73069, '2020-09-27', 'MF', 'Saint Martin', 'AMRO', '16', '383', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73070, '2020-09-28', 'MF', 'Saint Martin', 'AMRO', '0', '383', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73071, '2020-09-29', 'MF', 'Saint Martin', 'AMRO', '0', '383', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73072, '2020-09-30', 'MF', 'Saint Martin', 'AMRO', '0', '383', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73073, '2020-10-01', 'MF', 'Saint Martin', 'AMRO', '0', '383', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73074, '2020-10-02', 'MF', 'Saint Martin', 'AMRO', '0', '383', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73075, '2020-10-03', 'MF', 'Saint Martin', 'AMRO', '29', '412', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73076, '2020-10-04', 'MF', 'Saint Martin', 'AMRO', '0', '412', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73077, '2020-10-05', 'MF', 'Saint Martin', 'AMRO', '0', '412', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73078, '2020-10-06', 'MF', 'Saint Martin', 'AMRO', '0', '412', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73079, '2020-10-07', 'MF', 'Saint Martin', 'AMRO', '0', '412', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73080, '2020-10-08', 'MF', 'Saint Martin', 'AMRO', '0', '412', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73081, '2020-10-09', 'MF', 'Saint Martin', 'AMRO', '0', '412', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73082, '2020-10-10', 'MF', 'Saint Martin', 'AMRO', '0', '412', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73083, '2020-10-11', 'MF', 'Saint Martin', 'AMRO', '54', '466', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73084, '2020-10-12', 'MF', 'Saint Martin', 'AMRO', '0', '466', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73085, '2020-10-13', 'MF', 'Saint Martin', 'AMRO', '0', '466', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73086, '2020-10-14', 'MF', 'Saint Martin', 'AMRO', '0', '466', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73087, '2020-10-15', 'MF', 'Saint Martin', 'AMRO', '0', '466', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73088, '2020-10-16', 'MF', 'Saint Martin', 'AMRO', '35', '501', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73089, '2020-10-17', 'MF', 'Saint Martin', 'AMRO', '30', '531', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73090, '2020-10-18', 'MF', 'Saint Martin', 'AMRO', '0', '531', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73091, '2020-10-19', 'MF', 'Saint Martin', 'AMRO', '0', '531', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73092, '2020-10-20', 'MF', 'Saint Martin', 'AMRO', '0', '531', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73093, '2020-10-21', 'MF', 'Saint Martin', 'AMRO', '0', '531', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73094, '2020-10-22', 'MF', 'Saint Martin', 'AMRO', '0', '531', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73095, '2020-10-23', 'MF', 'Saint Martin', 'AMRO', '7', '538', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73096, '2020-10-24', 'MF', 'Saint Martin', 'AMRO', '0', '538', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73097, '2020-10-25', 'MF', 'Saint Martin', 'AMRO', '0', '538', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73098, '2020-10-26', 'MF', 'Saint Martin', 'AMRO', '4', '542', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73099, '2020-10-27', 'MF', 'Saint Martin', 'AMRO', '0', '542', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73100, '2020-10-28', 'MF', 'Saint Martin', 'AMRO', '0', '542', '0', '8');
INSERT INTO public.who_global_data_import VALUES (73101, '2020-10-29', 'MF', 'Saint Martin', 'AMRO', '24', '566', '1', '9');
INSERT INTO public.who_global_data_import VALUES (73102, '2020-10-30', 'MF', 'Saint Martin', 'AMRO', '0', '566', '0', '9');
INSERT INTO public.who_global_data_import VALUES (73103, '2020-10-31', 'MF', 'Saint Martin', 'AMRO', '25', '591', '0', '9');
INSERT INTO public.who_global_data_import VALUES (73104, '2020-11-01', 'MF', 'Saint Martin', 'AMRO', '0', '591', '0', '9');
INSERT INTO public.who_global_data_import VALUES (73105, '2020-11-02', 'MF', 'Saint Martin', 'AMRO', '0', '591', '0', '9');
INSERT INTO public.who_global_data_import VALUES (73106, '2020-11-03', 'MF', 'Saint Martin', 'AMRO', '0', '591', '0', '9');
INSERT INTO public.who_global_data_import VALUES (73107, '2020-11-04', 'MF', 'Saint Martin', 'AMRO', '0', '591', '0', '9');
INSERT INTO public.who_global_data_import VALUES (73108, '2020-11-05', 'MF', 'Saint Martin', 'AMRO', '13', '604', '3', '12');
INSERT INTO public.who_global_data_import VALUES (73109, '2020-11-06', 'MF', 'Saint Martin', 'AMRO', '0', '604', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73110, '2020-11-07', 'MF', 'Saint Martin', 'AMRO', '0', '604', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73111, '2020-11-08', 'MF', 'Saint Martin', 'AMRO', '0', '604', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73112, '2020-11-09', 'MF', 'Saint Martin', 'AMRO', '0', '604', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73113, '2020-11-10', 'MF', 'Saint Martin', 'AMRO', '0', '604', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73114, '2020-11-11', 'MF', 'Saint Martin', 'AMRO', '0', '604', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73115, '2020-11-12', 'MF', 'Saint Martin', 'AMRO', '0', '604', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73116, '2020-11-13', 'MF', 'Saint Martin', 'AMRO', '51', '655', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73117, '2020-11-14', 'MF', 'Saint Martin', 'AMRO', '0', '655', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73118, '2020-11-15', 'MF', 'Saint Martin', 'AMRO', '0', '655', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73119, '2020-11-16', 'MF', 'Saint Martin', 'AMRO', '0', '655', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73120, '2020-11-17', 'MF', 'Saint Martin', 'AMRO', '0', '655', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73121, '2020-11-18', 'MF', 'Saint Martin', 'AMRO', '0', '655', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73122, '2020-11-19', 'MF', 'Saint Martin', 'AMRO', '35', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73123, '2020-11-20', 'MF', 'Saint Martin', 'AMRO', '0', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73124, '2020-11-21', 'MF', 'Saint Martin', 'AMRO', '0', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73125, '2020-11-22', 'MF', 'Saint Martin', 'AMRO', '0', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73126, '2020-11-23', 'MF', 'Saint Martin', 'AMRO', '0', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73127, '2020-11-24', 'MF', 'Saint Martin', 'AMRO', '0', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73128, '2020-11-25', 'MF', 'Saint Martin', 'AMRO', '0', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73129, '2020-11-26', 'MF', 'Saint Martin', 'AMRO', '0', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73130, '2020-11-27', 'MF', 'Saint Martin', 'AMRO', '0', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73131, '2020-11-28', 'MF', 'Saint Martin', 'AMRO', '0', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73132, '2020-11-29', 'MF', 'Saint Martin', 'AMRO', '0', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73133, '2020-11-30', 'MF', 'Saint Martin', 'AMRO', '0', '690', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73134, '2020-12-01', 'MF', 'Saint Martin', 'AMRO', '54', '744', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73135, '2020-12-02', 'MF', 'Saint Martin', 'AMRO', '0', '744', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73136, '2020-12-03', 'MF', 'Saint Martin', 'AMRO', '0', '744', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73137, '2020-12-04', 'MF', 'Saint Martin', 'AMRO', '0', '744', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73138, '2020-12-05', 'MF', 'Saint Martin', 'AMRO', '0', '744', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73139, '2020-12-06', 'MF', 'Saint Martin', 'AMRO', '0', '744', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73140, '2020-12-07', 'MF', 'Saint Martin', 'AMRO', '0', '744', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73141, '2020-12-08', 'MF', 'Saint Martin', 'AMRO', '94', '838', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73142, '2020-12-09', 'MF', 'Saint Martin', 'AMRO', '0', '838', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73143, '2020-12-10', 'MF', 'Saint Martin', 'AMRO', '0', '838', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73144, '2020-12-11', 'MF', 'Saint Martin', 'AMRO', '0', '838', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73145, '2020-12-12', 'MF', 'Saint Martin', 'AMRO', '0', '838', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73146, '2020-12-13', 'MF', 'Saint Martin', 'AMRO', '0', '838', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73147, '2020-12-14', 'MF', 'Saint Martin', 'AMRO', '0', '838', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73148, '2020-12-15', 'MF', 'Saint Martin', 'AMRO', '61', '899', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73149, '2020-12-16', 'MF', 'Saint Martin', 'AMRO', '0', '899', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73150, '2020-12-17', 'MF', 'Saint Martin', 'AMRO', '0', '899', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73151, '2020-12-18', 'MF', 'Saint Martin', 'AMRO', '0', '899', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73152, '2020-12-19', 'MF', 'Saint Martin', 'AMRO', '0', '899', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73153, '2020-12-20', 'MF', 'Saint Martin', 'AMRO', '49', '948', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73154, '2020-12-21', 'MF', 'Saint Martin', 'AMRO', '0', '948', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73155, '2020-12-22', 'MF', 'Saint Martin', 'AMRO', '0', '948', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73156, '2020-12-23', 'MF', 'Saint Martin', 'AMRO', '0', '948', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73157, '2020-12-24', 'MF', 'Saint Martin', 'AMRO', '0', '948', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73158, '2020-12-25', 'MF', 'Saint Martin', 'AMRO', '0', '948', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73159, '2020-12-26', 'MF', 'Saint Martin', 'AMRO', '0', '948', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73160, '2020-12-27', 'MF', 'Saint Martin', 'AMRO', '38', '986', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73161, '2020-12-28', 'MF', 'Saint Martin', 'AMRO', '0', '986', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73162, '2020-12-29', 'MF', 'Saint Martin', 'AMRO', '0', '986', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73163, '2020-12-30', 'MF', 'Saint Martin', 'AMRO', '0', '986', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73164, '2020-12-31', 'MF', 'Saint Martin', 'AMRO', '0', '986', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73165, '2021-01-01', 'MF', 'Saint Martin', 'AMRO', '9', '995', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73166, '2021-01-02', 'MF', 'Saint Martin', 'AMRO', '0', '995', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73167, '2021-01-03', 'MF', 'Saint Martin', 'AMRO', '0', '995', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73168, '2021-01-04', 'MF', 'Saint Martin', 'AMRO', '0', '995', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73169, '2021-01-05', 'MF', 'Saint Martin', 'AMRO', '7', '1002', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73170, '2021-01-06', 'MF', 'Saint Martin', 'AMRO', '0', '1002', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73171, '2021-01-07', 'MF', 'Saint Martin', 'AMRO', '0', '1002', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73172, '2021-01-08', 'MF', 'Saint Martin', 'AMRO', '0', '1002', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73173, '2021-01-09', 'MF', 'Saint Martin', 'AMRO', '0', '1002', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73174, '2021-01-10', 'MF', 'Saint Martin', 'AMRO', '0', '1002', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73175, '2021-01-11', 'MF', 'Saint Martin', 'AMRO', '0', '1002', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73176, '2021-01-12', 'MF', 'Saint Martin', 'AMRO', '44', '1046', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73177, '2021-01-13', 'MF', 'Saint Martin', 'AMRO', '0', '1046', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73178, '2021-01-14', 'MF', 'Saint Martin', 'AMRO', '0', '1046', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73179, '2021-01-15', 'MF', 'Saint Martin', 'AMRO', '0', '1046', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73180, '2021-01-16', 'MF', 'Saint Martin', 'AMRO', '0', '1046', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73181, '2021-01-17', 'MF', 'Saint Martin', 'AMRO', '0', '1046', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73182, '2021-01-18', 'MF', 'Saint Martin', 'AMRO', '0', '1046', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73183, '2021-01-19', 'MF', 'Saint Martin', 'AMRO', '71', '1117', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73184, '2021-01-20', 'MF', 'Saint Martin', 'AMRO', '0', '1117', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73185, '2021-01-21', 'MF', 'Saint Martin', 'AMRO', '0', '1117', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73186, '2021-01-22', 'MF', 'Saint Martin', 'AMRO', '0', '1117', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73187, '2021-01-23', 'MF', 'Saint Martin', 'AMRO', '74', '1191', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73188, '2021-01-24', 'MF', 'Saint Martin', 'AMRO', '0', '1191', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73189, '2021-01-25', 'MF', 'Saint Martin', 'AMRO', '0', '1191', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73190, '2021-01-26', 'MF', 'Saint Martin', 'AMRO', '0', '1191', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73191, '2021-01-27', 'MF', 'Saint Martin', 'AMRO', '0', '1191', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73192, '2021-01-28', 'MF', 'Saint Martin', 'AMRO', '0', '1191', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73193, '2021-01-29', 'MF', 'Saint Martin', 'AMRO', '0', '1191', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73194, '2021-01-30', 'MF', 'Saint Martin', 'AMRO', '0', '1191', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73195, '2021-01-31', 'MF', 'Saint Martin', 'AMRO', '98', '1289', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73196, '2021-02-01', 'MF', 'Saint Martin', 'AMRO', '0', '1289', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73197, '2021-02-02', 'MF', 'Saint Martin', 'AMRO', '0', '1289', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73198, '2021-02-03', 'MF', 'Saint Martin', 'AMRO', '0', '1289', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73199, '2021-02-04', 'MF', 'Saint Martin', 'AMRO', '0', '1289', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73200, '2021-02-05', 'MF', 'Saint Martin', 'AMRO', '0', '1289', '0', '12');
INSERT INTO public.who_global_data_import VALUES (73201, '2020-01-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73202, '2020-01-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73203, '2020-01-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73204, '2020-01-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73205, '2020-01-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73206, '2020-01-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73207, '2020-01-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73208, '2020-01-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73209, '2020-01-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73210, '2020-01-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73211, '2020-01-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73212, '2020-01-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73213, '2020-01-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73214, '2020-01-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73215, '2020-01-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73216, '2020-01-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73217, '2020-01-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73218, '2020-01-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73219, '2020-01-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73220, '2020-01-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73221, '2020-01-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73222, '2020-01-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73223, '2020-01-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73224, '2020-01-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73225, '2020-01-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73226, '2020-01-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73227, '2020-01-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73228, '2020-01-30', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73229, '2020-01-31', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73230, '2020-02-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73231, '2020-02-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73232, '2020-02-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73233, '2020-02-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73234, '2020-02-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73235, '2020-02-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73236, '2020-02-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73237, '2020-02-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73238, '2020-02-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73239, '2020-02-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73240, '2020-02-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73241, '2020-02-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73242, '2020-02-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73243, '2020-02-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73244, '2020-02-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73245, '2020-02-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73246, '2020-02-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73247, '2020-02-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73248, '2020-02-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73249, '2020-02-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73250, '2020-02-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73251, '2020-02-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73252, '2020-02-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73253, '2020-02-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73254, '2020-02-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73255, '2020-02-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73256, '2020-02-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73257, '2020-02-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73258, '2020-02-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73259, '2020-03-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73260, '2020-03-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73261, '2020-03-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73262, '2020-03-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73263, '2020-03-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73264, '2020-03-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73265, '2020-03-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73266, '2020-03-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73267, '2020-03-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73268, '2020-03-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73269, '2020-03-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73270, '2020-03-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73271, '2020-03-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73272, '2020-03-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73273, '2020-03-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73274, '2020-03-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73275, '2020-03-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73276, '2020-03-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73277, '2020-03-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73278, '2020-03-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73279, '2020-03-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73280, '2020-03-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73281, '2020-03-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73282, '2020-03-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73283, '2020-03-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73284, '2020-03-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73285, '2020-03-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73286, '2020-03-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73287, '2020-03-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73288, '2020-03-30', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73289, '2020-03-31', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73290, '2020-04-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73291, '2020-04-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73292, '2020-04-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73293, '2020-04-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73294, '2020-04-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73295, '2020-04-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73296, '2020-04-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73297, '2020-04-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73298, '2020-04-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73299, '2020-04-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73300, '2020-04-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73301, '2020-04-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73302, '2020-04-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73303, '2020-04-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73304, '2020-04-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73305, '2020-04-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73306, '2020-04-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73307, '2020-04-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73308, '2020-04-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74104, '2020-04-15', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73309, '2020-04-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73310, '2020-04-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73311, '2020-04-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73312, '2020-04-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73313, '2020-04-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73314, '2020-04-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73315, '2020-04-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73316, '2020-04-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73317, '2020-04-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73318, '2020-04-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73319, '2020-04-30', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73320, '2020-05-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73321, '2020-05-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73322, '2020-05-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73323, '2020-05-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73324, '2020-05-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73325, '2020-05-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73326, '2020-05-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73327, '2020-05-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73328, '2020-05-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73329, '2020-05-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73330, '2020-05-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73331, '2020-05-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73332, '2020-05-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73333, '2020-05-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73334, '2020-05-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73335, '2020-05-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73336, '2020-05-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73337, '2020-05-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73338, '2020-05-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73339, '2020-05-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73340, '2020-05-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73341, '2020-05-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73342, '2020-05-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73343, '2020-05-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73344, '2020-05-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73345, '2020-05-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73346, '2020-05-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73347, '2020-05-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73348, '2020-05-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73349, '2020-05-30', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73350, '2020-05-31', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73351, '2020-06-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73352, '2020-06-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73353, '2020-06-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73354, '2020-06-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73355, '2020-06-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73356, '2020-06-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73357, '2020-06-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73358, '2020-06-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73359, '2020-06-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73360, '2020-06-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73361, '2020-06-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73362, '2020-06-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73363, '2020-06-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73364, '2020-06-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73365, '2020-06-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73366, '2020-06-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73367, '2020-06-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73368, '2020-06-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73369, '2020-06-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73370, '2020-06-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73371, '2020-06-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73372, '2020-06-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73373, '2020-06-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73374, '2020-06-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73375, '2020-06-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73376, '2020-06-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73377, '2020-06-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73378, '2020-06-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73379, '2020-06-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73380, '2020-06-30', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73381, '2020-07-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73382, '2020-07-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73383, '2020-07-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73384, '2020-07-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73385, '2020-07-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73386, '2020-07-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73387, '2020-07-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73388, '2020-07-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73389, '2020-07-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73390, '2020-07-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73391, '2020-07-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73392, '2020-07-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73393, '2020-07-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73394, '2020-07-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73395, '2020-07-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73396, '2020-07-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74105, '2020-04-16', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73397, '2020-07-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73398, '2020-07-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73399, '2020-07-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73400, '2020-07-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73401, '2020-07-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73402, '2020-07-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73403, '2020-07-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73404, '2020-07-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73405, '2020-07-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73406, '2020-07-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73407, '2020-07-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73408, '2020-07-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73409, '2020-07-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73410, '2020-07-30', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73411, '2020-07-31', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73412, '2020-08-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73413, '2020-08-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73414, '2020-08-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73415, '2020-08-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73416, '2020-08-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73417, '2020-08-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73418, '2020-08-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73419, '2020-08-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73420, '2020-08-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73421, '2020-08-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73422, '2020-08-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73423, '2020-08-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73424, '2020-08-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73425, '2020-08-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73426, '2020-08-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73427, '2020-08-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73428, '2020-08-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73429, '2020-08-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73430, '2020-08-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73431, '2020-08-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73432, '2020-08-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73433, '2020-08-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73434, '2020-08-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73435, '2020-08-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73436, '2020-08-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73437, '2020-08-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73438, '2020-08-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73439, '2020-08-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73440, '2020-08-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73441, '2020-08-30', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73442, '2020-08-31', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73443, '2020-09-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73444, '2020-09-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73445, '2020-09-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73446, '2020-09-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73447, '2020-09-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73448, '2020-09-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73449, '2020-09-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73450, '2020-09-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73451, '2020-09-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73452, '2020-09-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73453, '2020-09-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73454, '2020-09-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73455, '2020-09-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73456, '2020-09-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73457, '2020-09-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73458, '2020-09-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73459, '2020-09-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73460, '2020-09-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73461, '2020-09-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73462, '2020-09-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73463, '2020-09-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73464, '2020-09-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73465, '2020-09-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73466, '2020-09-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73467, '2020-09-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73468, '2020-09-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73469, '2020-09-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73470, '2020-09-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73471, '2020-09-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73472, '2020-09-30', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73473, '2020-10-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73474, '2020-10-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73475, '2020-10-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73476, '2020-10-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73477, '2020-10-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73478, '2020-10-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73479, '2020-10-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73480, '2020-10-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73481, '2020-10-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73482, '2020-10-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73483, '2020-10-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73484, '2020-10-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74106, '2020-04-17', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73485, '2020-10-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73486, '2020-10-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73487, '2020-10-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73488, '2020-10-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73489, '2020-10-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73490, '2020-10-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73491, '2020-10-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73492, '2020-10-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73493, '2020-10-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73494, '2020-10-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73495, '2020-10-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73496, '2020-10-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73497, '2020-10-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73498, '2020-10-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73499, '2020-10-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73500, '2020-10-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73501, '2020-10-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73502, '2020-10-30', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73503, '2020-10-31', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73504, '2020-11-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73505, '2020-11-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73506, '2020-11-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73507, '2020-11-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73508, '2020-11-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73509, '2020-11-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73510, '2020-11-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73511, '2020-11-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73512, '2020-11-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73513, '2020-11-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73514, '2020-11-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73515, '2020-11-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73516, '2020-11-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73517, '2020-11-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73518, '2020-11-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73519, '2020-11-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73520, '2020-11-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73521, '2020-11-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73522, '2020-11-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73523, '2020-11-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73524, '2020-11-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73525, '2020-11-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73526, '2020-11-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73527, '2020-11-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73528, '2020-11-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73529, '2020-11-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73530, '2020-11-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73531, '2020-11-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73532, '2020-11-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73533, '2020-11-30', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73534, '2020-12-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73535, '2020-12-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73536, '2020-12-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73537, '2020-12-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73538, '2020-12-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73539, '2020-12-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73540, '2020-12-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73541, '2020-12-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73542, '2020-12-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73543, '2020-12-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73544, '2020-12-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73545, '2020-12-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73546, '2020-12-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73547, '2020-12-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73548, '2020-12-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73549, '2020-12-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73550, '2020-12-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73551, '2020-12-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73552, '2020-12-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73553, '2020-12-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73554, '2020-12-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73555, '2020-12-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73556, '2020-12-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73557, '2020-12-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73558, '2020-12-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73559, '2020-12-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73560, '2020-12-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73561, '2020-12-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73562, '2020-12-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73563, '2020-12-30', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73564, '2020-12-31', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73565, '2021-01-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73566, '2021-01-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73567, '2021-01-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73568, '2021-01-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73569, '2021-01-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73570, '2021-01-06', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73571, '2021-01-07', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73572, '2021-01-08', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74107, '2020-04-18', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73573, '2021-01-09', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73574, '2021-01-10', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73575, '2021-01-11', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73576, '2021-01-12', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73577, '2021-01-13', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73578, '2021-01-14', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73579, '2021-01-15', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73580, '2021-01-16', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73581, '2021-01-17', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73582, '2021-01-18', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73583, '2021-01-19', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73584, '2021-01-20', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73585, '2021-01-21', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73586, '2021-01-22', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73587, '2021-01-23', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73588, '2021-01-24', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '4', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73589, '2021-01-25', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73590, '2021-01-26', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '2', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73591, '2021-01-27', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73592, '2021-01-28', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73593, '2021-01-29', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '1', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73594, '2021-01-30', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73595, '2021-01-31', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73596, '2021-02-01', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73597, '2021-02-02', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73598, '2021-02-03', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73599, '2021-02-04', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73600, '2021-02-05', 'PM', 'Saint Pierre and Miquelon', 'AMRO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73601, '2020-01-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73602, '2020-01-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73603, '2020-01-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73604, '2020-01-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73605, '2020-01-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73606, '2020-01-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73607, '2020-01-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73608, '2020-01-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73609, '2020-01-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73610, '2020-01-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73611, '2020-01-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73612, '2020-01-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73613, '2020-01-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73614, '2020-01-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73615, '2020-01-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73616, '2020-01-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73617, '2020-01-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73618, '2020-01-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73619, '2020-01-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73620, '2020-01-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73621, '2020-01-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73622, '2020-01-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73623, '2020-01-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73624, '2020-01-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73625, '2020-01-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73626, '2020-01-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73627, '2020-01-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73628, '2020-01-30', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73629, '2020-01-31', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73630, '2020-02-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73631, '2020-02-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73632, '2020-02-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73633, '2020-02-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73634, '2020-02-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73635, '2020-02-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73636, '2020-02-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73637, '2020-02-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73638, '2020-02-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73639, '2020-02-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73640, '2020-02-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73641, '2020-02-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73642, '2020-02-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73643, '2020-02-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73644, '2020-02-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73645, '2020-02-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73646, '2020-02-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73647, '2020-02-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73648, '2020-02-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73649, '2020-02-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73650, '2020-02-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73651, '2020-02-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73652, '2020-02-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73653, '2020-02-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73654, '2020-02-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73655, '2020-02-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73656, '2020-02-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73657, '2020-02-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73658, '2020-02-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73659, '2020-03-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73660, '2020-03-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74108, '2020-04-19', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73661, '2020-03-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73662, '2020-03-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73663, '2020-03-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73664, '2020-03-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73665, '2020-03-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73666, '2020-03-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73667, '2020-03-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73668, '2020-03-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73669, '2020-03-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73670, '2020-03-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73671, '2020-03-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73672, '2020-03-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73673, '2020-03-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73674, '2020-03-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73675, '2020-03-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73676, '2020-03-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73677, '2020-03-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73678, '2020-03-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73679, '2020-03-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73680, '2020-03-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73681, '2020-03-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73682, '2020-03-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73683, '2020-03-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73684, '2020-03-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73685, '2020-03-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73686, '2020-03-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73687, '2020-03-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73688, '2020-03-30', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73689, '2020-03-31', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73690, '2020-04-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73691, '2020-04-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73692, '2020-04-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73693, '2020-04-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73694, '2020-04-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73695, '2020-04-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73696, '2020-04-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '4', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73697, '2020-04-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73698, '2020-04-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73699, '2020-04-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73700, '2020-04-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '4', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73701, '2020-04-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73702, '2020-04-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73703, '2020-04-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73704, '2020-04-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73705, '2020-04-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73706, '2020-04-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73707, '2020-04-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73708, '2020-04-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73709, '2020-04-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73710, '2020-04-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73711, '2020-04-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73712, '2020-04-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73713, '2020-04-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73714, '2020-04-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73715, '2020-04-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73716, '2020-04-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73717, '2020-04-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73718, '2020-04-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73719, '2020-04-30', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73720, '2020-05-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73721, '2020-05-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73722, '2020-05-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73723, '2020-05-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73724, '2020-05-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73725, '2020-05-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73726, '2020-05-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73727, '2020-05-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73728, '2020-05-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73729, '2020-05-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73730, '2020-05-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73731, '2020-05-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73732, '2020-05-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73733, '2020-05-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73734, '2020-05-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73735, '2020-05-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73736, '2020-05-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73737, '2020-05-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73738, '2020-05-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73739, '2020-05-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73740, '2020-05-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73741, '2020-05-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73742, '2020-05-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73743, '2020-05-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73744, '2020-05-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74109, '2020-04-20', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73745, '2020-05-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73746, '2020-05-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73747, '2020-05-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73748, '2020-05-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '7', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73749, '2020-05-30', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73750, '2020-05-31', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73751, '2020-06-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73752, '2020-06-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73753, '2020-06-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73754, '2020-06-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73755, '2020-06-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73756, '2020-06-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73757, '2020-06-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73758, '2020-06-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73759, '2020-06-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73760, '2020-06-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73761, '2020-06-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73762, '2020-06-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73763, '2020-06-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73764, '2020-06-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73765, '2020-06-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73766, '2020-06-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73767, '2020-06-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73768, '2020-06-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '2', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73769, '2020-06-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73770, '2020-06-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73771, '2020-06-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73772, '2020-06-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73773, '2020-06-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73774, '2020-06-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73775, '2020-06-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73776, '2020-06-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73777, '2020-06-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73778, '2020-06-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73779, '2020-06-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73780, '2020-06-30', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73781, '2020-07-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73782, '2020-07-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73783, '2020-07-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73784, '2020-07-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73785, '2020-07-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73786, '2020-07-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73787, '2020-07-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73788, '2020-07-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73789, '2020-07-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73790, '2020-07-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73791, '2020-07-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73792, '2020-07-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73793, '2020-07-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73794, '2020-07-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '6', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73795, '2020-07-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73796, '2020-07-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73797, '2020-07-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73798, '2020-07-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73799, '2020-07-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73800, '2020-07-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '3', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73801, '2020-07-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '12', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73802, '2020-07-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73803, '2020-07-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73804, '2020-07-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '2', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73805, '2020-07-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73806, '2020-07-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73807, '2020-07-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73808, '2020-07-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73809, '2020-07-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73810, '2020-07-30', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73811, '2020-07-31', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73812, '2020-08-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '2', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73813, '2020-08-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73814, '2020-08-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73815, '2020-08-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73816, '2020-08-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73817, '2020-08-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73818, '2020-08-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73819, '2020-08-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73820, '2020-08-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73821, '2020-08-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73822, '2020-08-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73823, '2020-08-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73824, '2020-08-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73825, '2020-08-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74110, '2020-04-21', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73826, '2020-08-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73827, '2020-08-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73828, '2020-08-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73829, '2020-08-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73830, '2020-08-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73831, '2020-08-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73832, '2020-08-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73833, '2020-08-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73834, '2020-08-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73835, '2020-08-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73836, '2020-08-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73837, '2020-08-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73838, '2020-08-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73839, '2020-08-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '2', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73840, '2020-08-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73841, '2020-08-30', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73842, '2020-08-31', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73843, '2020-09-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73844, '2020-09-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '60', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73845, '2020-09-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73846, '2020-09-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73847, '2020-09-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73848, '2020-09-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73849, '2020-09-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73850, '2020-09-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73851, '2020-09-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73852, '2020-09-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73853, '2020-09-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73854, '2020-09-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73855, '2020-09-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '2', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73856, '2020-09-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73857, '2020-09-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73858, '2020-09-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73859, '2020-09-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73860, '2020-09-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73861, '2020-09-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73862, '2020-09-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73863, '2020-09-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73864, '2020-09-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73865, '2020-09-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73866, '2020-09-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73867, '2020-09-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73868, '2020-09-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73869, '2020-09-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73870, '2020-09-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73871, '2020-09-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73872, '2020-09-30', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73873, '2020-10-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73874, '2020-10-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73875, '2020-10-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73876, '2020-10-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73877, '2020-10-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73878, '2020-10-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73879, '2020-10-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73880, '2020-10-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73881, '2020-10-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73882, '2020-10-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73883, '2020-10-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73884, '2020-10-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73885, '2020-10-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73886, '2020-10-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73887, '2020-10-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73888, '2020-10-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73889, '2020-10-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73890, '2020-10-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '2', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73891, '2020-10-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73892, '2020-10-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73893, '2020-10-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73894, '2020-10-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73895, '2020-10-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73896, '2020-10-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '5', '73', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73897, '2020-10-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '73', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73898, '2020-10-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '73', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73899, '2020-10-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '73', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73900, '2020-10-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '74', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73901, '2020-10-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '74', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73902, '2020-10-30', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '74', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73903, '2020-10-31', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '74', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73904, '2020-11-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '74', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73905, '2020-11-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73906, '2020-11-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74111, '2020-04-22', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73907, '2020-11-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73908, '2020-11-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73909, '2020-11-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73910, '2020-11-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73911, '2020-11-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73912, '2020-11-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73913, '2020-11-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73914, '2020-11-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73915, '2020-11-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73916, '2020-11-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73917, '2020-11-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73918, '2020-11-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73919, '2020-11-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73920, '2020-11-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73921, '2020-11-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73922, '2020-11-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '5', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73923, '2020-11-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73924, '2020-11-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73925, '2020-11-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73926, '2020-11-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73927, '2020-11-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73928, '2020-11-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73929, '2020-11-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73930, '2020-11-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73931, '2020-11-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73932, '2020-11-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73933, '2020-11-30', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73934, '2020-12-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73935, '2020-12-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73936, '2020-12-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73937, '2020-12-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73938, '2020-12-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '2', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73939, '2020-12-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73940, '2020-12-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73941, '2020-12-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73942, '2020-12-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73943, '2020-12-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '3', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73944, '2020-12-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '91', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73945, '2020-12-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '3', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73946, '2020-12-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73947, '2020-12-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '4', '98', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73948, '2020-12-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '98', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73949, '2020-12-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '98', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73950, '2020-12-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '98', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73951, '2020-12-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '2', '100', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73952, '2020-12-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '100', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73953, '2020-12-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '100', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73954, '2020-12-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '4', '104', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73955, '2020-12-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '104', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73956, '2020-12-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '3', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73957, '2020-12-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73958, '2020-12-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73959, '2020-12-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73960, '2020-12-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73961, '2020-12-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73962, '2020-12-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73963, '2020-12-30', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '4', '113', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73964, '2020-12-31', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '2', '115', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73965, '2021-01-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '4', '119', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73966, '2021-01-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '2', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73967, '2021-01-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '1', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73968, '2021-01-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '2', '124', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73969, '2021-01-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '124', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73970, '2021-01-06', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '9', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73971, '2021-01-07', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '16', '149', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73972, '2021-01-08', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '149', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73973, '2021-01-09', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '55', '204', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73974, '2021-01-10', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '0', '204', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73975, '2021-01-11', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '21', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73976, '2021-01-12', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '24', '249', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73977, '2021-01-13', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '4', '253', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73978, '2021-01-14', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '31', '284', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73979, '2021-01-15', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '56', '340', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73980, '2021-01-16', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '48', '388', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73981, '2021-01-17', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '62', '450', '1', '1');
INSERT INTO public.who_global_data_import VALUES (73982, '2021-01-18', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '28', '478', '0', '1');
INSERT INTO public.who_global_data_import VALUES (73983, '2021-01-19', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '16', '494', '1', '2');
INSERT INTO public.who_global_data_import VALUES (73984, '2021-01-20', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '46', '540', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73985, '2021-01-21', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '62', '602', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73986, '2021-01-22', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '53', '655', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73987, '2021-01-23', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '35', '690', '0', '2');
INSERT INTO public.who_global_data_import VALUES (74112, '2020-04-23', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (73988, '2021-01-24', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '30', '720', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73989, '2021-01-25', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '18', '738', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73990, '2021-01-26', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '8', '746', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73991, '2021-01-27', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '17', '763', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73992, '2021-01-28', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '35', '798', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73993, '2021-01-29', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '29', '827', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73994, '2021-01-30', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '38', '865', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73995, '2021-01-31', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '31', '896', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73996, '2021-02-01', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '5', '901', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73997, '2021-02-02', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '50', '951', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73998, '2021-02-03', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '57', '1008', '0', '2');
INSERT INTO public.who_global_data_import VALUES (73999, '2021-02-04', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '51', '1059', '0', '2');
INSERT INTO public.who_global_data_import VALUES (74000, '2021-02-05', 'VC', 'Saint Vincent and the Grenadines', 'AMRO', '8', '1067', '1', '3');
INSERT INTO public.who_global_data_import VALUES (74001, '2020-01-03', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74002, '2020-01-04', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74003, '2020-01-05', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74004, '2020-01-06', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74005, '2020-01-07', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74006, '2020-01-08', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74007, '2020-01-09', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74008, '2020-01-10', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74009, '2020-01-11', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74010, '2020-01-12', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74011, '2020-01-13', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74012, '2020-01-14', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74013, '2020-01-15', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74014, '2020-01-16', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74015, '2020-01-17', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74016, '2020-01-18', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74017, '2020-01-19', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74018, '2020-01-20', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74019, '2020-01-21', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74020, '2020-01-22', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74021, '2020-01-23', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74022, '2020-01-24', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74023, '2020-01-25', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74024, '2020-01-26', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74025, '2020-01-27', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74026, '2020-01-28', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74027, '2020-01-29', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74028, '2020-01-30', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74029, '2020-01-31', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74030, '2020-02-01', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74031, '2020-02-02', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74032, '2020-02-03', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74033, '2020-02-04', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74034, '2020-02-05', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74035, '2020-02-06', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74036, '2020-02-07', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74037, '2020-02-08', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74038, '2020-02-09', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74039, '2020-02-10', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74040, '2020-02-11', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74041, '2020-02-12', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74042, '2020-02-13', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74043, '2020-02-14', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74044, '2020-02-15', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74045, '2020-02-16', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74046, '2020-02-17', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74047, '2020-02-18', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74048, '2020-02-19', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74049, '2020-02-20', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74050, '2020-02-21', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74051, '2020-02-22', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74052, '2020-02-23', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74053, '2020-02-24', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74054, '2020-02-25', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74055, '2020-02-26', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74056, '2020-02-27', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74057, '2020-02-28', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74058, '2020-02-29', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74059, '2020-03-01', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74060, '2020-03-02', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74061, '2020-03-03', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74062, '2020-03-04', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74063, '2020-03-05', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74064, '2020-03-06', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74065, '2020-03-07', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74066, '2020-03-08', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74067, '2020-03-09', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74068, '2020-03-10', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74069, '2020-03-11', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74070, '2020-03-12', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74071, '2020-03-13', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74072, '2020-03-14', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74073, '2020-03-15', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74074, '2020-03-16', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74075, '2020-03-17', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74076, '2020-03-18', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74077, '2020-03-19', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74078, '2020-03-20', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74079, '2020-03-21', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74080, '2020-03-22', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74081, '2020-03-23', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74082, '2020-03-24', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74083, '2020-03-25', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74084, '2020-03-26', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74085, '2020-03-27', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74086, '2020-03-28', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74087, '2020-03-29', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74088, '2020-03-30', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74089, '2020-03-31', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74090, '2020-04-01', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74091, '2020-04-02', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74092, '2020-04-03', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74093, '2020-04-04', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74094, '2020-04-05', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74095, '2020-04-06', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74096, '2020-04-07', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74097, '2020-04-08', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74098, '2020-04-09', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74099, '2020-04-10', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74100, '2020-04-11', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74101, '2020-04-12', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74113, '2020-04-24', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74114, '2020-04-25', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74115, '2020-04-26', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74116, '2020-04-27', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74117, '2020-04-28', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74118, '2020-04-29', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74119, '2020-04-30', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74120, '2020-05-01', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74121, '2020-05-02', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74122, '2020-05-03', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74123, '2020-05-04', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74124, '2020-05-05', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74125, '2020-05-06', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74126, '2020-05-07', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74127, '2020-05-08', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74128, '2020-05-09', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74129, '2020-05-10', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74130, '2020-05-11', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74131, '2020-05-12', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74132, '2020-05-13', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74133, '2020-05-14', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74134, '2020-05-15', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74135, '2020-05-16', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74136, '2020-05-17', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74137, '2020-05-18', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74138, '2020-05-19', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74139, '2020-05-20', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74140, '2020-05-21', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74141, '2020-05-22', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74142, '2020-05-23', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74143, '2020-05-24', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74144, '2020-05-25', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74145, '2020-05-26', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74146, '2020-05-27', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74147, '2020-05-28', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74148, '2020-05-29', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74149, '2020-05-30', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74150, '2020-05-31', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74151, '2020-06-01', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74152, '2020-06-02', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74153, '2020-06-03', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74154, '2020-06-04', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74155, '2020-06-05', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74156, '2020-06-06', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74157, '2020-06-07', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74158, '2020-06-08', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74159, '2020-06-09', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74160, '2020-06-10', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74161, '2020-06-11', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74162, '2020-06-12', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74163, '2020-06-13', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74164, '2020-06-14', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74165, '2020-06-15', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74166, '2020-06-16', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74167, '2020-06-17', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74168, '2020-06-18', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74169, '2020-06-19', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74170, '2020-06-20', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74171, '2020-06-21', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74172, '2020-06-22', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74173, '2020-06-23', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74174, '2020-06-24', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74175, '2020-06-25', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74176, '2020-06-26', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74177, '2020-06-27', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74178, '2020-06-28', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74179, '2020-06-29', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74180, '2020-06-30', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74181, '2020-07-01', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74182, '2020-07-02', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74183, '2020-07-03', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74184, '2020-07-04', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74185, '2020-07-05', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74186, '2020-07-06', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74187, '2020-07-07', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74188, '2020-07-08', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74189, '2020-07-09', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74190, '2020-07-10', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74191, '2020-07-11', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74192, '2020-07-12', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74193, '2020-07-13', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74194, '2020-07-14', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74195, '2020-07-15', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74196, '2020-07-16', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74197, '2020-07-17', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74198, '2020-07-18', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74199, '2020-07-19', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74200, '2020-07-20', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74201, '2020-07-21', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74202, '2020-07-22', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74203, '2020-07-23', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74204, '2020-07-24', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74205, '2020-07-25', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74206, '2020-07-26', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74207, '2020-07-27', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74208, '2020-07-28', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74209, '2020-07-29', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74210, '2020-07-30', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74211, '2020-07-31', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74212, '2020-08-01', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74213, '2020-08-02', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74214, '2020-08-03', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74215, '2020-08-04', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74216, '2020-08-05', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74217, '2020-08-06', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74218, '2020-08-07', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74219, '2020-08-08', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74220, '2020-08-09', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74221, '2020-08-10', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74222, '2020-08-11', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74223, '2020-08-12', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74224, '2020-08-13', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74225, '2020-08-14', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74226, '2020-08-15', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74227, '2020-08-16', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74228, '2020-08-17', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74229, '2020-08-18', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74230, '2020-08-19', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74231, '2020-08-20', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74232, '2020-08-21', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74233, '2020-08-22', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74234, '2020-08-23', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74235, '2020-08-24', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74236, '2020-08-25', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74237, '2020-08-26', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74238, '2020-08-27', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74239, '2020-08-28', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74240, '2020-08-29', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74241, '2020-08-30', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74242, '2020-08-31', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74243, '2020-09-01', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74244, '2020-09-02', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74245, '2020-09-03', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74246, '2020-09-04', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74247, '2020-09-05', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74248, '2020-09-06', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74249, '2020-09-07', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74250, '2020-09-08', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74251, '2020-09-09', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74252, '2020-09-10', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74253, '2020-09-11', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74254, '2020-09-12', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74255, '2020-09-13', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74256, '2020-09-14', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74257, '2020-09-15', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74258, '2020-09-16', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74259, '2020-09-17', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74260, '2020-09-18', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74261, '2020-09-19', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74262, '2020-09-20', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74263, '2020-09-21', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74264, '2020-09-22', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74265, '2020-09-23', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74266, '2020-09-24', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74267, '2020-09-25', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74268, '2020-09-26', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74269, '2020-09-27', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74270, '2020-09-28', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74271, '2020-09-29', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74272, '2020-09-30', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74273, '2020-10-01', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74274, '2020-10-02', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74275, '2020-10-03', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74276, '2020-10-04', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74277, '2020-10-05', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74278, '2020-10-06', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74279, '2020-10-07', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74280, '2020-10-08', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74281, '2020-10-09', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74282, '2020-10-10', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74283, '2020-10-11', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74284, '2020-10-12', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74285, '2020-10-13', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74286, '2020-10-14', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74287, '2020-10-15', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74288, '2020-10-16', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74289, '2020-10-17', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74290, '2020-10-18', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74291, '2020-10-19', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74292, '2020-10-20', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74293, '2020-10-21', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74294, '2020-10-22', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74295, '2020-10-23', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74296, '2020-10-24', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74297, '2020-10-25', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74298, '2020-10-26', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74299, '2020-10-27', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74300, '2020-10-28', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74301, '2020-10-29', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74302, '2020-10-30', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74303, '2020-10-31', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74304, '2020-11-01', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74305, '2020-11-02', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74306, '2020-11-03', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74307, '2020-11-04', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74308, '2020-11-05', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74309, '2020-11-06', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74310, '2020-11-07', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74311, '2020-11-08', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74312, '2020-11-09', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74313, '2020-11-10', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74314, '2020-11-11', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74315, '2020-11-12', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74316, '2020-11-13', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74317, '2020-11-14', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74318, '2020-11-15', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74319, '2020-11-16', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74320, '2020-11-17', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74321, '2020-11-18', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74322, '2020-11-19', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74323, '2020-11-20', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74324, '2020-11-21', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74325, '2020-11-22', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74326, '2020-11-23', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74327, '2020-11-24', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74328, '2020-11-25', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74329, '2020-11-26', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74330, '2020-11-27', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74331, '2020-11-28', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74332, '2020-11-29', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74333, '2020-11-30', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74334, '2020-12-01', 'WS', 'Samoa', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74335, '2020-12-02', 'WS', 'Samoa', 'WPRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74336, '2020-12-03', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74337, '2020-12-04', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74338, '2020-12-05', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74339, '2020-12-06', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74340, '2020-12-07', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74341, '2020-12-08', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74342, '2020-12-09', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74343, '2020-12-10', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74344, '2020-12-11', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74345, '2020-12-12', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74346, '2020-12-13', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74347, '2020-12-14', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74348, '2020-12-15', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74349, '2020-12-16', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74350, '2020-12-17', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74351, '2020-12-18', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74352, '2020-12-19', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74353, '2020-12-20', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74354, '2020-12-21', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74355, '2020-12-22', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74356, '2020-12-23', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74357, '2020-12-24', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74358, '2020-12-25', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74359, '2020-12-26', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74360, '2020-12-27', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74361, '2020-12-28', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74362, '2020-12-29', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74363, '2020-12-30', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74364, '2020-12-31', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74365, '2021-01-01', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74366, '2021-01-02', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74367, '2021-01-03', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74368, '2021-01-04', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74369, '2021-01-05', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74370, '2021-01-06', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74371, '2021-01-07', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74372, '2021-01-08', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74373, '2021-01-09', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74374, '2021-01-10', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74375, '2021-01-11', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74376, '2021-01-12', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74377, '2021-01-13', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74378, '2021-01-14', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74379, '2021-01-15', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74380, '2021-01-16', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74381, '2021-01-17', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74382, '2021-01-18', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74383, '2021-01-19', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74384, '2021-01-20', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74385, '2021-01-21', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74386, '2021-01-22', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74387, '2021-01-23', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74388, '2021-01-24', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74389, '2021-01-25', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74390, '2021-01-26', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74391, '2021-01-27', 'WS', 'Samoa', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74392, '2021-01-28', 'WS', 'Samoa', 'WPRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74393, '2021-01-29', 'WS', 'Samoa', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74394, '2021-01-30', 'WS', 'Samoa', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74395, '2021-01-31', 'WS', 'Samoa', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74396, '2021-02-01', 'WS', 'Samoa', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74397, '2021-02-02', 'WS', 'Samoa', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74398, '2021-02-03', 'WS', 'Samoa', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74399, '2021-02-04', 'WS', 'Samoa', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74400, '2021-02-05', 'WS', 'Samoa', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74401, '2020-01-03', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74402, '2020-01-04', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74403, '2020-01-05', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74404, '2020-01-06', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74405, '2020-01-07', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74406, '2020-01-08', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74407, '2020-01-09', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74408, '2020-01-10', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74409, '2020-01-11', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74410, '2020-01-12', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74411, '2020-01-13', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74412, '2020-01-14', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74413, '2020-01-15', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74414, '2020-01-16', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74415, '2020-01-17', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74416, '2020-01-18', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74417, '2020-01-19', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74418, '2020-01-20', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74419, '2020-01-21', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74420, '2020-01-22', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74421, '2020-01-23', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74422, '2020-01-24', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74423, '2020-01-25', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74424, '2020-01-26', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74425, '2020-01-27', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74426, '2020-01-28', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74427, '2020-01-29', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74428, '2020-01-30', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74429, '2020-01-31', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74430, '2020-02-01', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74431, '2020-02-02', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74432, '2020-02-03', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74433, '2020-02-04', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74434, '2020-02-05', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74435, '2020-02-06', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74436, '2020-02-07', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74437, '2020-02-08', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74438, '2020-02-09', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74439, '2020-02-10', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74440, '2020-02-11', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74441, '2020-02-12', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74442, '2020-02-13', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74443, '2020-02-14', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74444, '2020-02-15', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74445, '2020-02-16', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74446, '2020-02-17', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74447, '2020-02-18', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74448, '2020-02-19', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74449, '2020-02-20', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74450, '2020-02-21', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74451, '2020-02-22', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74452, '2020-02-23', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74453, '2020-02-24', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74454, '2020-02-25', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74455, '2020-02-26', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74456, '2020-02-27', 'SM', 'San Marino', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74457, '2020-02-28', 'SM', 'San Marino', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74458, '2020-02-29', 'SM', 'San Marino', 'EURO', '0', '1', '1', '1');
INSERT INTO public.who_global_data_import VALUES (74459, '2020-03-01', 'SM', 'San Marino', 'EURO', '0', '1', '0', '1');
INSERT INTO public.who_global_data_import VALUES (74460, '2020-03-02', 'SM', 'San Marino', 'EURO', '0', '1', '0', '1');
INSERT INTO public.who_global_data_import VALUES (74461, '2020-03-03', 'SM', 'San Marino', 'EURO', '8', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (74462, '2020-03-04', 'SM', 'San Marino', 'EURO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (74463, '2020-03-05', 'SM', 'San Marino', 'EURO', '7', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (74464, '2020-03-06', 'SM', 'San Marino', 'EURO', '6', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (74465, '2020-03-07', 'SM', 'San Marino', 'EURO', '2', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (74466, '2020-03-08', 'SM', 'San Marino', 'EURO', '3', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (74467, '2020-03-09', 'SM', 'San Marino', 'EURO', '10', '37', '0', '1');
INSERT INTO public.who_global_data_import VALUES (74468, '2020-03-10', 'SM', 'San Marino', 'EURO', '12', '49', '1', '2');
INSERT INTO public.who_global_data_import VALUES (74469, '2020-03-11', 'SM', 'San Marino', 'EURO', '11', '60', '0', '2');
INSERT INTO public.who_global_data_import VALUES (74470, '2020-03-12', 'SM', 'San Marino', 'EURO', '0', '60', '0', '2');
INSERT INTO public.who_global_data_import VALUES (74471, '2020-03-13', 'SM', 'San Marino', 'EURO', '4', '64', '3', '5');
INSERT INTO public.who_global_data_import VALUES (74472, '2020-03-14', 'SM', 'San Marino', 'EURO', '13', '77', '0', '5');
INSERT INTO public.who_global_data_import VALUES (74473, '2020-03-15', 'SM', 'San Marino', 'EURO', '0', '77', '0', '5');
INSERT INTO public.who_global_data_import VALUES (74474, '2020-03-16', 'SM', 'San Marino', 'EURO', '0', '77', '0', '5');
INSERT INTO public.who_global_data_import VALUES (74475, '2020-03-17', 'SM', 'San Marino', 'EURO', '25', '102', '4', '9');
INSERT INTO public.who_global_data_import VALUES (74476, '2020-03-18', 'SM', 'San Marino', 'EURO', '2', '104', '2', '11');
INSERT INTO public.who_global_data_import VALUES (74477, '2020-03-19', 'SM', 'San Marino', 'EURO', '5', '109', '3', '14');
INSERT INTO public.who_global_data_import VALUES (74478, '2020-03-20', 'SM', 'San Marino', 'EURO', '17', '126', '0', '14');
INSERT INTO public.who_global_data_import VALUES (74479, '2020-03-21', 'SM', 'San Marino', 'EURO', '25', '151', '6', '20');
INSERT INTO public.who_global_data_import VALUES (74480, '2020-03-22', 'SM', 'San Marino', 'EURO', '24', '175', '0', '20');
INSERT INTO public.who_global_data_import VALUES (74481, '2020-03-23', 'SM', 'San Marino', 'EURO', '12', '187', '0', '20');
INSERT INTO public.who_global_data_import VALUES (74482, '2020-03-24', 'SM', 'San Marino', 'EURO', '0', '187', '1', '21');
INSERT INTO public.who_global_data_import VALUES (74483, '2020-03-25', 'SM', 'San Marino', 'EURO', '21', '208', '0', '21');
INSERT INTO public.who_global_data_import VALUES (74484, '2020-03-26', 'SM', 'San Marino', 'EURO', '10', '218', '0', '21');
INSERT INTO public.who_global_data_import VALUES (74485, '2020-03-27', 'SM', 'San Marino', 'EURO', '5', '223', '0', '21');
INSERT INTO public.who_global_data_import VALUES (74486, '2020-03-28', 'SM', 'San Marino', 'EURO', '5', '228', '1', '22');
INSERT INTO public.who_global_data_import VALUES (74487, '2020-03-29', 'SM', 'San Marino', 'EURO', '0', '228', '0', '22');
INSERT INTO public.who_global_data_import VALUES (74488, '2020-03-30', 'SM', 'San Marino', 'EURO', '2', '230', '3', '25');
INSERT INTO public.who_global_data_import VALUES (74489, '2020-03-31', 'SM', 'San Marino', 'EURO', '6', '236', '1', '26');
INSERT INTO public.who_global_data_import VALUES (74490, '2020-04-01', 'SM', 'San Marino', 'EURO', '0', '236', '2', '28');
INSERT INTO public.who_global_data_import VALUES (74491, '2020-04-02', 'SM', 'San Marino', 'EURO', '0', '236', '0', '28');
INSERT INTO public.who_global_data_import VALUES (74492, '2020-04-03', 'SM', 'San Marino', 'EURO', '9', '245', '2', '30');
INSERT INTO public.who_global_data_import VALUES (74493, '2020-04-04', 'SM', 'San Marino', 'EURO', '7', '252', '2', '32');
INSERT INTO public.who_global_data_import VALUES (74494, '2020-04-05', 'SM', 'San Marino', 'EURO', '7', '259', '0', '32');
INSERT INTO public.who_global_data_import VALUES (74495, '2020-04-06', 'SM', 'San Marino', 'EURO', '7', '266', '0', '32');
INSERT INTO public.who_global_data_import VALUES (74496, '2020-04-07', 'SM', 'San Marino', 'EURO', '11', '277', '0', '32');
INSERT INTO public.who_global_data_import VALUES (74497, '2020-04-08', 'SM', 'San Marino', 'EURO', '2', '279', '2', '34');
INSERT INTO public.who_global_data_import VALUES (74498, '2020-04-09', 'SM', 'San Marino', 'EURO', '29', '308', '0', '34');
INSERT INTO public.who_global_data_import VALUES (74499, '2020-04-10', 'SM', 'San Marino', 'EURO', '36', '344', '0', '34');
INSERT INTO public.who_global_data_import VALUES (74500, '2020-04-11', 'SM', 'San Marino', 'EURO', '0', '344', '0', '34');
INSERT INTO public.who_global_data_import VALUES (74501, '2020-04-12', 'SM', 'San Marino', 'EURO', '12', '356', '1', '35');
INSERT INTO public.who_global_data_import VALUES (74502, '2020-04-13', 'SM', 'San Marino', 'EURO', '0', '356', '0', '35');
INSERT INTO public.who_global_data_import VALUES (74503, '2020-04-14', 'SM', 'San Marino', 'EURO', '15', '371', '1', '36');
INSERT INTO public.who_global_data_import VALUES (74504, '2020-04-15', 'SM', 'San Marino', 'EURO', '1', '372', '0', '36');
INSERT INTO public.who_global_data_import VALUES (74505, '2020-04-16', 'SM', 'San Marino', 'EURO', '21', '393', '0', '36');
INSERT INTO public.who_global_data_import VALUES (74506, '2020-04-17', 'SM', 'San Marino', 'EURO', '33', '426', '2', '38');
INSERT INTO public.who_global_data_import VALUES (74507, '2020-04-18', 'SM', 'San Marino', 'EURO', '0', '426', '0', '38');
INSERT INTO public.who_global_data_import VALUES (74508, '2020-04-19', 'SM', 'San Marino', 'EURO', '29', '455', '1', '39');
INSERT INTO public.who_global_data_import VALUES (74509, '2020-04-20', 'SM', 'San Marino', 'EURO', '6', '461', '0', '39');
INSERT INTO public.who_global_data_import VALUES (74510, '2020-04-21', 'SM', 'San Marino', 'EURO', '1', '462', '0', '39');
INSERT INTO public.who_global_data_import VALUES (74511, '2020-04-22', 'SM', 'San Marino', 'EURO', '14', '476', '1', '40');
INSERT INTO public.who_global_data_import VALUES (74512, '2020-04-23', 'SM', 'San Marino', 'EURO', '12', '488', '0', '40');
INSERT INTO public.who_global_data_import VALUES (74513, '2020-04-24', 'SM', 'San Marino', 'EURO', '13', '501', '0', '40');
INSERT INTO public.who_global_data_import VALUES (74514, '2020-04-25', 'SM', 'San Marino', 'EURO', '12', '513', '0', '40');
INSERT INTO public.who_global_data_import VALUES (74515, '2020-04-26', 'SM', 'San Marino', 'EURO', '0', '513', '0', '40');
INSERT INTO public.who_global_data_import VALUES (74516, '2020-04-27', 'SM', 'San Marino', 'EURO', '25', '538', '1', '41');
INSERT INTO public.who_global_data_import VALUES (74517, '2020-04-28', 'SM', 'San Marino', 'EURO', '0', '538', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74518, '2020-04-29', 'SM', 'San Marino', 'EURO', '15', '553', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74519, '2020-04-30', 'SM', 'San Marino', 'EURO', '10', '563', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74520, '2020-05-01', 'SM', 'San Marino', 'EURO', '6', '569', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74521, '2020-05-02', 'SM', 'San Marino', 'EURO', '11', '580', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74522, '2020-05-03', 'SM', 'San Marino', 'EURO', '0', '580', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74523, '2020-05-04', 'SM', 'San Marino', 'EURO', '2', '582', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74524, '2020-05-05', 'SM', 'San Marino', 'EURO', '0', '582', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74525, '2020-05-06', 'SM', 'San Marino', 'EURO', '7', '589', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74526, '2020-05-07', 'SM', 'San Marino', 'EURO', '19', '608', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74527, '2020-05-08', 'SM', 'San Marino', 'EURO', '24', '632', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74528, '2020-05-09', 'SM', 'San Marino', 'EURO', '0', '632', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74529, '2020-05-10', 'SM', 'San Marino', 'EURO', '0', '632', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74530, '2020-05-11', 'SM', 'San Marino', 'EURO', '5', '637', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74531, '2020-05-12', 'SM', 'San Marino', 'EURO', '10', '647', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74532, '2020-05-13', 'SM', 'San Marino', 'EURO', '0', '647', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74533, '2020-05-14', 'SM', 'San Marino', 'EURO', '0', '647', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74534, '2020-05-15', 'SM', 'San Marino', 'EURO', '0', '647', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74535, '2020-05-16', 'SM', 'San Marino', 'EURO', '5', '652', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74536, '2020-05-17', 'SM', 'San Marino', 'EURO', '0', '652', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74537, '2020-05-18', 'SM', 'San Marino', 'EURO', '16', '668', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74538, '2020-05-19', 'SM', 'San Marino', 'EURO', '0', '668', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74539, '2020-05-20', 'SM', 'San Marino', 'EURO', '0', '668', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74540, '2020-05-21', 'SM', 'San Marino', 'EURO', '2', '670', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74541, '2020-05-22', 'SM', 'San Marino', 'EURO', '2', '672', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74542, '2020-05-23', 'SM', 'San Marino', 'EURO', '0', '672', '0', '41');
INSERT INTO public.who_global_data_import VALUES (74543, '2020-05-24', 'SM', 'San Marino', 'EURO', '0', '672', '1', '42');
INSERT INTO public.who_global_data_import VALUES (74544, '2020-05-25', 'SM', 'San Marino', 'EURO', '0', '672', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74545, '2020-05-26', 'SM', 'San Marino', 'EURO', '0', '672', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74546, '2020-05-27', 'SM', 'San Marino', 'EURO', '0', '672', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74547, '2020-05-28', 'SM', 'San Marino', 'EURO', '0', '672', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74548, '2020-05-29', 'SM', 'San Marino', 'EURO', '15', '687', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74549, '2020-05-30', 'SM', 'San Marino', 'EURO', '0', '687', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74550, '2020-05-31', 'SM', 'San Marino', 'EURO', '0', '687', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74551, '2020-06-01', 'SM', 'San Marino', 'EURO', '0', '687', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74552, '2020-06-02', 'SM', 'San Marino', 'EURO', '0', '687', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74553, '2020-06-03', 'SM', 'San Marino', 'EURO', '0', '687', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74554, '2020-06-04', 'SM', 'San Marino', 'EURO', '0', '687', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74555, '2020-06-05', 'SM', 'San Marino', 'EURO', '8', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74556, '2020-06-06', 'SM', 'San Marino', 'EURO', '0', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74557, '2020-06-07', 'SM', 'San Marino', 'EURO', '0', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74558, '2020-06-08', 'SM', 'San Marino', 'EURO', '0', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74559, '2020-06-09', 'SM', 'San Marino', 'EURO', '0', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74560, '2020-06-10', 'SM', 'San Marino', 'EURO', '0', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74561, '2020-06-11', 'SM', 'San Marino', 'EURO', '0', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74562, '2020-06-12', 'SM', 'San Marino', 'EURO', '0', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74563, '2020-06-13', 'SM', 'San Marino', 'EURO', '0', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74564, '2020-06-14', 'SM', 'San Marino', 'EURO', '0', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74565, '2020-06-15', 'SM', 'San Marino', 'EURO', '0', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74566, '2020-06-16', 'SM', 'San Marino', 'EURO', '0', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74567, '2020-06-17', 'SM', 'San Marino', 'EURO', '0', '695', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74568, '2020-06-18', 'SM', 'San Marino', 'EURO', '14', '709', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74569, '2020-06-19', 'SM', 'San Marino', 'EURO', '0', '709', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74570, '2020-06-20', 'SM', 'San Marino', 'EURO', '4', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74571, '2020-06-21', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74572, '2020-06-22', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74573, '2020-06-23', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74574, '2020-06-24', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74575, '2020-06-25', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74576, '2020-06-26', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74577, '2020-06-27', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74578, '2020-06-28', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74579, '2020-06-29', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74580, '2020-06-30', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74581, '2020-07-01', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74582, '2020-07-02', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74583, '2020-07-03', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74584, '2020-07-04', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74585, '2020-07-05', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74586, '2020-07-06', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74587, '2020-07-07', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74588, '2020-07-08', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74589, '2020-07-09', 'SM', 'San Marino', 'EURO', '0', '713', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74590, '2020-07-10', 'SM', 'San Marino', 'EURO', '3', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74591, '2020-07-11', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74592, '2020-07-12', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74593, '2020-07-13', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74594, '2020-07-14', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74595, '2020-07-15', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74596, '2020-07-16', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74597, '2020-07-17', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74598, '2020-07-18', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74599, '2020-07-19', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74600, '2020-07-20', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74601, '2020-07-21', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74602, '2020-07-22', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74603, '2020-07-23', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74604, '2020-07-24', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74605, '2020-07-25', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74606, '2020-07-26', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74607, '2020-07-27', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74608, '2020-07-28', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74609, '2020-07-29', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74610, '2020-07-30', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74611, '2020-07-31', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74612, '2020-08-01', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74613, '2020-08-02', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74614, '2020-08-03', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74615, '2020-08-04', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74616, '2020-08-05', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74617, '2020-08-06', 'SM', 'San Marino', 'EURO', '0', '716', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74618, '2020-08-07', 'SM', 'San Marino', 'EURO', '1', '717', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74619, '2020-08-08', 'SM', 'San Marino', 'EURO', '0', '717', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74620, '2020-08-09', 'SM', 'San Marino', 'EURO', '0', '717', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74621, '2020-08-10', 'SM', 'San Marino', 'EURO', '0', '717', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74622, '2020-08-11', 'SM', 'San Marino', 'EURO', '0', '717', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74623, '2020-08-12', 'SM', 'San Marino', 'EURO', '2', '719', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74624, '2020-08-13', 'SM', 'San Marino', 'EURO', '0', '719', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74625, '2020-08-14', 'SM', 'San Marino', 'EURO', '0', '719', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74626, '2020-08-15', 'SM', 'San Marino', 'EURO', '0', '719', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74627, '2020-08-16', 'SM', 'San Marino', 'EURO', '0', '719', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74628, '2020-08-17', 'SM', 'San Marino', 'EURO', '0', '719', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74629, '2020-08-18', 'SM', 'San Marino', 'EURO', '0', '719', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74630, '2020-08-19', 'SM', 'San Marino', 'EURO', '0', '719', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74631, '2020-08-20', 'SM', 'San Marino', 'EURO', '0', '719', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74632, '2020-08-21', 'SM', 'San Marino', 'EURO', '7', '726', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74633, '2020-08-22', 'SM', 'San Marino', 'EURO', '0', '726', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74634, '2020-08-23', 'SM', 'San Marino', 'EURO', '0', '726', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74635, '2020-08-24', 'SM', 'San Marino', 'EURO', '0', '726', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74636, '2020-08-25', 'SM', 'San Marino', 'EURO', '0', '726', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74637, '2020-08-26', 'SM', 'San Marino', 'EURO', '4', '730', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74638, '2020-08-27', 'SM', 'San Marino', 'EURO', '0', '730', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74639, '2020-08-28', 'SM', 'San Marino', 'EURO', '2', '732', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74640, '2020-08-29', 'SM', 'San Marino', 'EURO', '1', '733', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74641, '2020-08-30', 'SM', 'San Marino', 'EURO', '0', '733', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74642, '2020-08-31', 'SM', 'San Marino', 'EURO', '2', '735', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74643, '2020-09-01', 'SM', 'San Marino', 'EURO', '0', '735', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74644, '2020-09-02', 'SM', 'San Marino', 'EURO', '0', '735', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74645, '2020-09-03', 'SM', 'San Marino', 'EURO', '0', '735', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74646, '2020-09-04', 'SM', 'San Marino', 'EURO', '0', '735', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74647, '2020-09-05', 'SM', 'San Marino', 'EURO', '0', '735', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74648, '2020-09-06', 'SM', 'San Marino', 'EURO', '0', '735', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74649, '2020-09-07', 'SM', 'San Marino', 'EURO', '0', '735', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74650, '2020-09-08', 'SM', 'San Marino', 'EURO', '0', '735', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74651, '2020-09-09', 'SM', 'San Marino', 'EURO', '0', '735', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74652, '2020-09-10', 'SM', 'San Marino', 'EURO', '0', '735', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74653, '2020-09-11', 'SM', 'San Marino', 'EURO', '6', '741', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74654, '2020-09-12', 'SM', 'San Marino', 'EURO', '0', '741', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74655, '2020-09-13', 'SM', 'San Marino', 'EURO', '0', '741', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74656, '2020-09-14', 'SM', 'San Marino', 'EURO', '0', '741', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74657, '2020-09-15', 'SM', 'San Marino', 'EURO', '0', '741', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74658, '2020-09-16', 'SM', 'San Marino', 'EURO', '0', '741', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74659, '2020-09-17', 'SM', 'San Marino', 'EURO', '1', '742', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74660, '2020-09-18', 'SM', 'San Marino', 'EURO', '0', '742', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74661, '2020-09-19', 'SM', 'San Marino', 'EURO', '0', '742', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74662, '2020-09-20', 'SM', 'San Marino', 'EURO', '0', '742', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74663, '2020-09-21', 'SM', 'San Marino', 'EURO', '0', '742', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74664, '2020-09-22', 'SM', 'San Marino', 'EURO', '0', '742', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74665, '2020-09-23', 'SM', 'San Marino', 'EURO', '0', '742', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74666, '2020-09-24', 'SM', 'San Marino', 'EURO', '4', '746', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74667, '2020-09-25', 'SM', 'San Marino', 'EURO', '0', '746', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74668, '2020-09-26', 'SM', 'San Marino', 'EURO', '0', '746', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74669, '2020-09-27', 'SM', 'San Marino', 'EURO', '0', '746', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74670, '2020-09-28', 'SM', 'San Marino', 'EURO', '0', '746', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74671, '2020-09-29', 'SM', 'San Marino', 'EURO', '3', '749', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74672, '2020-09-30', 'SM', 'San Marino', 'EURO', '0', '749', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74673, '2020-10-01', 'SM', 'San Marino', 'EURO', '1', '750', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74674, '2020-10-02', 'SM', 'San Marino', 'EURO', '0', '750', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74675, '2020-10-03', 'SM', 'San Marino', 'EURO', '0', '750', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74676, '2020-10-04', 'SM', 'San Marino', 'EURO', '0', '750', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74677, '2020-10-05', 'SM', 'San Marino', 'EURO', '0', '750', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74678, '2020-10-06', 'SM', 'San Marino', 'EURO', '1', '751', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74679, '2020-10-07', 'SM', 'San Marino', 'EURO', '0', '751', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74680, '2020-10-08', 'SM', 'San Marino', 'EURO', '1', '752', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74681, '2020-10-09', 'SM', 'San Marino', 'EURO', '0', '752', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74682, '2020-10-10', 'SM', 'San Marino', 'EURO', '14', '766', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74683, '2020-10-11', 'SM', 'San Marino', 'EURO', '0', '766', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74684, '2020-10-12', 'SM', 'San Marino', 'EURO', '0', '766', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74685, '2020-10-13', 'SM', 'San Marino', 'EURO', '0', '766', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74686, '2020-10-14', 'SM', 'San Marino', 'EURO', '6', '772', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74687, '2020-10-15', 'SM', 'San Marino', 'EURO', '0', '772', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74688, '2020-10-16', 'SM', 'San Marino', 'EURO', '9', '781', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74689, '2020-10-17', 'SM', 'San Marino', 'EURO', '3', '784', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74690, '2020-10-18', 'SM', 'San Marino', 'EURO', '0', '784', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74691, '2020-10-19', 'SM', 'San Marino', 'EURO', '0', '784', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74692, '2020-10-20', 'SM', 'San Marino', 'EURO', '5', '789', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74693, '2020-10-21', 'SM', 'San Marino', 'EURO', '5', '794', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74694, '2020-10-22', 'SM', 'San Marino', 'EURO', '2', '796', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74695, '2020-10-23', 'SM', 'San Marino', 'EURO', '6', '802', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74696, '2020-10-24', 'SM', 'San Marino', 'EURO', '17', '819', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74697, '2020-10-25', 'SM', 'San Marino', 'EURO', '25', '844', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74698, '2020-10-26', 'SM', 'San Marino', 'EURO', '0', '844', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74699, '2020-10-27', 'SM', 'San Marino', 'EURO', '8', '852', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74700, '2020-10-28', 'SM', 'San Marino', 'EURO', '31', '883', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74701, '2020-10-29', 'SM', 'San Marino', 'EURO', '20', '903', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74702, '2020-10-30', 'SM', 'San Marino', 'EURO', '26', '929', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74703, '2020-10-31', 'SM', 'San Marino', 'EURO', '29', '958', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74704, '2020-11-01', 'SM', 'San Marino', 'EURO', '0', '958', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74705, '2020-11-02', 'SM', 'San Marino', 'EURO', '0', '958', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74706, '2020-11-03', 'SM', 'San Marino', 'EURO', '0', '958', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74707, '2020-11-04', 'SM', 'San Marino', 'EURO', '36', '994', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74708, '2020-11-05', 'SM', 'San Marino', 'EURO', '8', '1002', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74709, '2020-11-06', 'SM', 'San Marino', 'EURO', '41', '1043', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74710, '2020-11-07', 'SM', 'San Marino', 'EURO', '58', '1101', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74711, '2020-11-08', 'SM', 'San Marino', 'EURO', '0', '1101', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74712, '2020-11-09', 'SM', 'San Marino', 'EURO', '0', '1101', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74713, '2020-11-10', 'SM', 'San Marino', 'EURO', '13', '1114', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74714, '2020-11-11', 'SM', 'San Marino', 'EURO', '41', '1155', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74715, '2020-11-12', 'SM', 'San Marino', 'EURO', '35', '1190', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74716, '2020-11-13', 'SM', 'San Marino', 'EURO', '44', '1234', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74717, '2020-11-14', 'SM', 'San Marino', 'EURO', '19', '1253', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74718, '2020-11-15', 'SM', 'San Marino', 'EURO', '0', '1253', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74719, '2020-11-16', 'SM', 'San Marino', 'EURO', '37', '1290', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74720, '2020-11-17', 'SM', 'San Marino', 'EURO', '0', '1290', '0', '42');
INSERT INTO public.who_global_data_import VALUES (74721, '2020-11-18', 'SM', 'San Marino', 'EURO', '31', '1321', '1', '43');
INSERT INTO public.who_global_data_import VALUES (74722, '2020-11-19', 'SM', 'San Marino', 'EURO', '37', '1358', '0', '43');
INSERT INTO public.who_global_data_import VALUES (74723, '2020-11-20', 'SM', 'San Marino', 'EURO', '15', '1373', '0', '43');
INSERT INTO public.who_global_data_import VALUES (74724, '2020-11-21', 'SM', 'San Marino', 'EURO', '22', '1395', '0', '43');
INSERT INTO public.who_global_data_import VALUES (74725, '2020-11-22', 'SM', 'San Marino', 'EURO', '32', '1427', '0', '43');
INSERT INTO public.who_global_data_import VALUES (74726, '2020-11-23', 'SM', 'San Marino', 'EURO', '1', '1428', '1', '44');
INSERT INTO public.who_global_data_import VALUES (74727, '2020-11-24', 'SM', 'San Marino', 'EURO', '0', '1428', '0', '44');
INSERT INTO public.who_global_data_import VALUES (74728, '2020-11-25', 'SM', 'San Marino', 'EURO', '26', '1454', '0', '44');
INSERT INTO public.who_global_data_import VALUES (74729, '2020-11-26', 'SM', 'San Marino', 'EURO', '38', '1492', '0', '44');
INSERT INTO public.who_global_data_import VALUES (74730, '2020-11-27', 'SM', 'San Marino', 'EURO', '22', '1514', '0', '44');
INSERT INTO public.who_global_data_import VALUES (74731, '2020-11-28', 'SM', 'San Marino', 'EURO', '40', '1554', '0', '44');
INSERT INTO public.who_global_data_import VALUES (74732, '2020-11-29', 'SM', 'San Marino', 'EURO', '32', '1586', '1', '45');
INSERT INTO public.who_global_data_import VALUES (74733, '2020-11-30', 'SM', 'San Marino', 'EURO', '23', '1609', '0', '45');
INSERT INTO public.who_global_data_import VALUES (74734, '2020-12-01', 'SM', 'San Marino', 'EURO', '3', '1612', '1', '46');
INSERT INTO public.who_global_data_import VALUES (74735, '2020-12-02', 'SM', 'San Marino', 'EURO', '38', '1650', '0', '46');
INSERT INTO public.who_global_data_import VALUES (74736, '2020-12-03', 'SM', 'San Marino', 'EURO', '37', '1687', '0', '46');
INSERT INTO public.who_global_data_import VALUES (74737, '2020-12-04', 'SM', 'San Marino', 'EURO', '27', '1714', '0', '46');
INSERT INTO public.who_global_data_import VALUES (74738, '2020-12-05', 'SM', 'San Marino', 'EURO', '42', '1756', '1', '47');
INSERT INTO public.who_global_data_import VALUES (74739, '2020-12-06', 'SM', 'San Marino', 'EURO', '33', '1789', '1', '48');
INSERT INTO public.who_global_data_import VALUES (74740, '2020-12-07', 'SM', 'San Marino', 'EURO', '0', '1789', '0', '48');
INSERT INTO public.who_global_data_import VALUES (74741, '2020-12-08', 'SM', 'San Marino', 'EURO', '11', '1800', '0', '48');
INSERT INTO public.who_global_data_import VALUES (74742, '2020-12-09', 'SM', 'San Marino', 'EURO', '32', '1832', '0', '48');
INSERT INTO public.who_global_data_import VALUES (74743, '2020-12-10', 'SM', 'San Marino', 'EURO', '2', '1834', '1', '49');
INSERT INTO public.who_global_data_import VALUES (74744, '2020-12-11', 'SM', 'San Marino', 'EURO', '34', '1868', '0', '49');
INSERT INTO public.who_global_data_import VALUES (74745, '2020-12-12', 'SM', 'San Marino', 'EURO', '40', '1908', '1', '50');
INSERT INTO public.who_global_data_import VALUES (74746, '2020-12-13', 'SM', 'San Marino', 'EURO', '24', '1932', '1', '51');
INSERT INTO public.who_global_data_import VALUES (74747, '2020-12-14', 'SM', 'San Marino', 'EURO', '15', '1947', '0', '51');
INSERT INTO public.who_global_data_import VALUES (74748, '2020-12-15', 'SM', 'San Marino', 'EURO', '35', '1982', '1', '52');
INSERT INTO public.who_global_data_import VALUES (74749, '2020-12-16', 'SM', 'San Marino', 'EURO', '43', '2025', '2', '54');
INSERT INTO public.who_global_data_import VALUES (74750, '2020-12-17', 'SM', 'San Marino', 'EURO', '0', '2025', '0', '54');
INSERT INTO public.who_global_data_import VALUES (74751, '2020-12-18', 'SM', 'San Marino', 'EURO', '24', '2049', '0', '54');
INSERT INTO public.who_global_data_import VALUES (74752, '2020-12-19', 'SM', 'San Marino', 'EURO', '0', '2049', '1', '55');
INSERT INTO public.who_global_data_import VALUES (74753, '2020-12-20', 'SM', 'San Marino', 'EURO', '58', '2107', '0', '55');
INSERT INTO public.who_global_data_import VALUES (74754, '2020-12-21', 'SM', 'San Marino', 'EURO', '0', '2107', '0', '55');
INSERT INTO public.who_global_data_import VALUES (74755, '2020-12-22', 'SM', 'San Marino', 'EURO', '28', '2135', '0', '55');
INSERT INTO public.who_global_data_import VALUES (74756, '2020-12-23', 'SM', 'San Marino', 'EURO', '0', '2135', '0', '55');
INSERT INTO public.who_global_data_import VALUES (74757, '2020-12-24', 'SM', 'San Marino', 'EURO', '71', '2206', '1', '56');
INSERT INTO public.who_global_data_import VALUES (74758, '2020-12-25', 'SM', 'San Marino', 'EURO', '25', '2231', '0', '56');
INSERT INTO public.who_global_data_import VALUES (74759, '2020-12-26', 'SM', 'San Marino', 'EURO', '33', '2264', '1', '57');
INSERT INTO public.who_global_data_import VALUES (74760, '2020-12-27', 'SM', 'San Marino', 'EURO', '0', '2264', '0', '57');
INSERT INTO public.who_global_data_import VALUES (74761, '2020-12-28', 'SM', 'San Marino', 'EURO', '12', '2276', '0', '57');
INSERT INTO public.who_global_data_import VALUES (74762, '2020-12-29', 'SM', 'San Marino', 'EURO', '0', '2276', '0', '57');
INSERT INTO public.who_global_data_import VALUES (74763, '2020-12-30', 'SM', 'San Marino', 'EURO', '57', '2333', '2', '59');
INSERT INTO public.who_global_data_import VALUES (74764, '2020-12-31', 'SM', 'San Marino', 'EURO', '0', '2333', '0', '59');
INSERT INTO public.who_global_data_import VALUES (74765, '2021-01-01', 'SM', 'San Marino', 'EURO', '51', '2384', '0', '59');
INSERT INTO public.who_global_data_import VALUES (74766, '2021-01-02', 'SM', 'San Marino', 'EURO', '44', '2428', '0', '59');
INSERT INTO public.who_global_data_import VALUES (74767, '2021-01-03', 'SM', 'San Marino', 'EURO', '35', '2463', '2', '61');
INSERT INTO public.who_global_data_import VALUES (74768, '2021-01-04', 'SM', 'San Marino', 'EURO', '0', '2463', '0', '61');
INSERT INTO public.who_global_data_import VALUES (74769, '2021-01-05', 'SM', 'San Marino', 'EURO', '30', '2493', '1', '62');
INSERT INTO public.who_global_data_import VALUES (74770, '2021-01-06', 'SM', 'San Marino', 'EURO', '56', '2549', '0', '62');
INSERT INTO public.who_global_data_import VALUES (74771, '2021-01-07', 'SM', 'San Marino', 'EURO', '0', '2549', '0', '62');
INSERT INTO public.who_global_data_import VALUES (74772, '2021-01-08', 'SM', 'San Marino', 'EURO', '34', '2583', '2', '64');
INSERT INTO public.who_global_data_import VALUES (74773, '2021-01-09', 'SM', 'San Marino', 'EURO', '45', '2628', '0', '64');
INSERT INTO public.who_global_data_import VALUES (74774, '2021-01-10', 'SM', 'San Marino', 'EURO', '22', '2650', '0', '64');
INSERT INTO public.who_global_data_import VALUES (74775, '2021-01-11', 'SM', 'San Marino', 'EURO', '0', '2650', '0', '64');
INSERT INTO public.who_global_data_import VALUES (74776, '2021-01-12', 'SM', 'San Marino', 'EURO', '0', '2650', '0', '64');
INSERT INTO public.who_global_data_import VALUES (74777, '2021-01-13', 'SM', 'San Marino', 'EURO', '56', '2706', '1', '65');
INSERT INTO public.who_global_data_import VALUES (74778, '2021-01-14', 'SM', 'San Marino', 'EURO', '17', '2723', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74779, '2021-01-15', 'SM', 'San Marino', 'EURO', '0', '2723', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74780, '2021-01-16', 'SM', 'San Marino', 'EURO', '44', '2767', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74781, '2021-01-17', 'SM', 'San Marino', 'EURO', '11', '2778', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74782, '2021-01-18', 'SM', 'San Marino', 'EURO', '0', '2778', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74783, '2021-01-19', 'SM', 'San Marino', 'EURO', '9', '2787', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74784, '2021-01-20', 'SM', 'San Marino', 'EURO', '0', '2787', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74785, '2021-01-21', 'SM', 'San Marino', 'EURO', '28', '2815', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74786, '2021-01-22', 'SM', 'San Marino', 'EURO', '18', '2833', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74787, '2021-01-23', 'SM', 'San Marino', 'EURO', '28', '2861', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74788, '2021-01-24', 'SM', 'San Marino', 'EURO', '13', '2874', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74789, '2021-01-25', 'SM', 'San Marino', 'EURO', '0', '2874', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74790, '2021-01-26', 'SM', 'San Marino', 'EURO', '15', '2889', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74791, '2021-01-27', 'SM', 'San Marino', 'EURO', '26', '2915', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74792, '2021-01-28', 'SM', 'San Marino', 'EURO', '26', '2941', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74793, '2021-01-29', 'SM', 'San Marino', 'EURO', '28', '2969', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74794, '2021-01-30', 'SM', 'San Marino', 'EURO', '27', '2996', '0', '65');
INSERT INTO public.who_global_data_import VALUES (74795, '2021-01-31', 'SM', 'San Marino', 'EURO', '29', '3025', '2', '67');
INSERT INTO public.who_global_data_import VALUES (74796, '2021-02-01', 'SM', 'San Marino', 'EURO', '0', '3025', '0', '67');
INSERT INTO public.who_global_data_import VALUES (74797, '2021-02-02', 'SM', 'San Marino', 'EURO', '41', '3066', '0', '67');
INSERT INTO public.who_global_data_import VALUES (74798, '2021-02-03', 'SM', 'San Marino', 'EURO', '28', '3094', '1', '68');
INSERT INTO public.who_global_data_import VALUES (74799, '2021-02-04', 'SM', 'San Marino', 'EURO', '17', '3111', '0', '68');
INSERT INTO public.who_global_data_import VALUES (74800, '2021-02-05', 'SM', 'San Marino', 'EURO', '14', '3125', '0', '68');
INSERT INTO public.who_global_data_import VALUES (74801, '2020-01-03', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74802, '2020-01-04', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74803, '2020-01-05', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74804, '2020-01-06', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74805, '2020-01-07', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74806, '2020-01-08', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74807, '2020-01-09', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74808, '2020-01-10', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74809, '2020-01-11', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74810, '2020-01-12', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74811, '2020-01-13', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74812, '2020-01-14', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74813, '2020-01-15', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74814, '2020-01-16', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74815, '2020-01-17', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74816, '2020-01-18', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74817, '2020-01-19', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74818, '2020-01-20', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74819, '2020-01-21', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74820, '2020-01-22', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74821, '2020-01-23', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74822, '2020-01-24', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74823, '2020-01-25', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74824, '2020-01-26', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74825, '2020-01-27', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74826, '2020-01-28', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74827, '2020-01-29', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74828, '2020-01-30', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74829, '2020-01-31', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74830, '2020-02-01', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74831, '2020-02-02', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74832, '2020-02-03', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74833, '2020-02-04', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74834, '2020-02-05', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74835, '2020-02-06', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74836, '2020-02-07', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74837, '2020-02-08', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74838, '2020-02-09', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74839, '2020-02-10', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74840, '2020-02-11', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74841, '2020-02-12', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74842, '2020-02-13', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74843, '2020-02-14', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74844, '2020-02-15', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74845, '2020-02-16', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74846, '2020-02-17', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74847, '2020-02-18', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74848, '2020-02-19', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74849, '2020-02-20', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74850, '2020-02-21', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74851, '2020-02-22', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74852, '2020-02-23', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74853, '2020-02-24', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74854, '2020-02-25', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74855, '2020-02-26', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74856, '2020-02-27', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74857, '2020-02-28', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74858, '2020-02-29', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74859, '2020-03-01', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74860, '2020-03-02', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74861, '2020-03-03', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74862, '2020-03-04', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74863, '2020-03-05', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74864, '2020-03-06', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74865, '2020-03-07', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74866, '2020-03-08', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74867, '2020-03-09', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74868, '2020-03-10', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74869, '2020-03-11', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74870, '2020-03-12', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74871, '2020-03-13', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74872, '2020-03-14', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74873, '2020-03-15', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74874, '2020-03-16', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74875, '2020-03-17', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74876, '2020-03-18', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74877, '2020-03-19', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74878, '2020-03-20', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74879, '2020-03-21', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74880, '2020-03-22', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74881, '2020-03-23', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74882, '2020-03-24', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74883, '2020-03-25', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74884, '2020-03-26', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74885, '2020-03-27', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74886, '2020-03-28', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74887, '2020-03-29', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74888, '2020-03-30', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74889, '2020-03-31', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74890, '2020-04-01', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74891, '2020-04-02', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74892, '2020-04-03', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74893, '2020-04-04', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74894, '2020-04-05', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74895, '2020-04-06', 'ST', 'Sao Tome and Principe', 'AFRO', '4', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74896, '2020-04-07', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74897, '2020-04-08', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74898, '2020-04-09', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74899, '2020-04-10', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74900, '2020-04-11', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74901, '2020-04-12', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74902, '2020-04-13', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74903, '2020-04-14', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74904, '2020-04-15', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74905, '2020-04-16', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74906, '2020-04-17', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74907, '2020-04-18', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74908, '2020-04-19', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74909, '2020-04-20', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74910, '2020-04-21', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74911, '2020-04-22', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74912, '2020-04-23', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74913, '2020-04-24', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74914, '2020-04-25', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74915, '2020-04-26', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74916, '2020-04-27', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74917, '2020-04-28', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74918, '2020-04-29', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74919, '2020-04-30', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (74920, '2020-05-01', 'ST', 'Sao Tome and Principe', 'AFRO', '5', '16', '1', '1');
INSERT INTO public.who_global_data_import VALUES (74921, '2020-05-02', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (74922, '2020-05-03', 'ST', 'Sao Tome and Principe', 'AFRO', '7', '23', '2', '3');
INSERT INTO public.who_global_data_import VALUES (74923, '2020-05-04', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '23', '0', '3');
INSERT INTO public.who_global_data_import VALUES (74924, '2020-05-05', 'ST', 'Sao Tome and Principe', 'AFRO', '138', '161', '0', '3');
INSERT INTO public.who_global_data_import VALUES (74925, '2020-05-06', 'ST', 'Sao Tome and Principe', 'AFRO', '10', '171', '0', '3');
INSERT INTO public.who_global_data_import VALUES (74926, '2020-05-07', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '174', '0', '3');
INSERT INTO public.who_global_data_import VALUES (74927, '2020-05-08', 'ST', 'Sao Tome and Principe', 'AFRO', '-9', '165', '1', '4');
INSERT INTO public.who_global_data_import VALUES (74928, '2020-05-09', 'ST', 'Sao Tome and Principe', 'AFRO', '43', '208', '1', '5');
INSERT INTO public.who_global_data_import VALUES (74929, '2020-05-10', 'ST', 'Sao Tome and Principe', 'AFRO', '-43', '165', '-1', '4');
INSERT INTO public.who_global_data_import VALUES (74930, '2020-05-11', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '165', '0', '4');
INSERT INTO public.who_global_data_import VALUES (74931, '2020-05-12', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '165', '0', '4');
INSERT INTO public.who_global_data_import VALUES (74932, '2020-05-13', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '165', '0', '4');
INSERT INTO public.who_global_data_import VALUES (74933, '2020-05-14', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '165', '3', '7');
INSERT INTO public.who_global_data_import VALUES (74934, '2020-05-15', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '166', '0', '7');
INSERT INTO public.who_global_data_import VALUES (74935, '2020-05-16', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '166', '0', '7');
INSERT INTO public.who_global_data_import VALUES (74936, '2020-05-17', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '169', '0', '7');
INSERT INTO public.who_global_data_import VALUES (74937, '2020-05-18', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '169', '0', '7');
INSERT INTO public.who_global_data_import VALUES (74938, '2020-05-19', 'ST', 'Sao Tome and Principe', 'AFRO', '-4', '165', '0', '7');
INSERT INTO public.who_global_data_import VALUES (74939, '2020-05-20', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '165', '0', '7');
INSERT INTO public.who_global_data_import VALUES (74940, '2020-05-21', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '165', '1', '8');
INSERT INTO public.who_global_data_import VALUES (74941, '2020-05-22', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '165', '0', '8');
INSERT INTO public.who_global_data_import VALUES (74942, '2020-05-23', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '165', '0', '8');
INSERT INTO public.who_global_data_import VALUES (74943, '2020-05-24', 'ST', 'Sao Tome and Principe', 'AFRO', '9', '174', '0', '8');
INSERT INTO public.who_global_data_import VALUES (74944, '2020-05-25', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '174', '1', '9');
INSERT INTO public.who_global_data_import VALUES (74945, '2020-05-26', 'ST', 'Sao Tome and Principe', 'AFRO', '-9', '165', '1', '10');
INSERT INTO public.who_global_data_import VALUES (74946, '2020-05-27', 'ST', 'Sao Tome and Principe', 'AFRO', '130', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74947, '2020-05-28', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74948, '2020-05-29', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74949, '2020-05-30', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74950, '2020-05-31', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74951, '2020-06-01', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74952, '2020-06-02', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74953, '2020-06-03', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74954, '2020-06-04', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74955, '2020-06-05', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74956, '2020-06-06', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74957, '2020-06-07', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74958, '2020-06-08', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74959, '2020-06-09', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74960, '2020-06-10', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '295', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74961, '2020-06-11', 'ST', 'Sao Tome and Principe', 'AFRO', '93', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74962, '2020-06-12', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74963, '2020-06-13', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74964, '2020-06-14', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74965, '2020-06-15', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74966, '2020-06-16', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74967, '2020-06-17', 'ST', 'Sao Tome and Principe', 'AFRO', '10', '398', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74968, '2020-06-18', 'ST', 'Sao Tome and Principe', 'AFRO', '-10', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74969, '2020-06-19', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74970, '2020-06-20', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74971, '2020-06-21', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74972, '2020-06-22', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74973, '2020-06-23', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74974, '2020-06-24', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74975, '2020-06-25', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (74976, '2020-06-26', 'ST', 'Sao Tome and Principe', 'AFRO', '4', '392', '1', '11');
INSERT INTO public.who_global_data_import VALUES (74977, '2020-06-27', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '392', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74978, '2020-06-28', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '393', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74979, '2020-06-29', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '393', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74980, '2020-06-30', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '393', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74981, '2020-07-01', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '394', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74982, '2020-07-02', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '395', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74983, '2020-07-03', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '397', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74984, '2020-07-04', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '399', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74985, '2020-07-05', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '399', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74986, '2020-07-06', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '400', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74987, '2020-07-07', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '401', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74988, '2020-07-08', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '404', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74989, '2020-07-09', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '404', '0', '11');
INSERT INTO public.who_global_data_import VALUES (74990, '2020-07-10', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '406', '1', '12');
INSERT INTO public.who_global_data_import VALUES (74991, '2020-07-11', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '407', '0', '12');
INSERT INTO public.who_global_data_import VALUES (74992, '2020-07-12', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '407', '0', '12');
INSERT INTO public.who_global_data_import VALUES (74993, '2020-07-13', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '409', '0', '12');
INSERT INTO public.who_global_data_import VALUES (74994, '2020-07-14', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '412', '0', '12');
INSERT INTO public.who_global_data_import VALUES (74995, '2020-07-15', 'ST', 'Sao Tome and Principe', 'AFRO', '4', '416', '0', '12');
INSERT INTO public.who_global_data_import VALUES (74996, '2020-07-16', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '417', '0', '12');
INSERT INTO public.who_global_data_import VALUES (74997, '2020-07-17', 'ST', 'Sao Tome and Principe', 'AFRO', '323', '740', '2', '14');
INSERT INTO public.who_global_data_import VALUES (74998, '2020-07-18', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '741', '0', '14');
INSERT INTO public.who_global_data_import VALUES (74999, '2020-07-19', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '743', '0', '14');
INSERT INTO public.who_global_data_import VALUES (75000, '2020-07-20', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '746', '0', '14');
INSERT INTO public.who_global_data_import VALUES (75001, '2020-07-21', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '746', '0', '14');
INSERT INTO public.who_global_data_import VALUES (75002, '2020-07-22', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '746', '0', '14');
INSERT INTO public.who_global_data_import VALUES (75003, '2020-07-23', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '747', '0', '14');
INSERT INTO public.who_global_data_import VALUES (75004, '2020-07-24', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '749', '0', '14');
INSERT INTO public.who_global_data_import VALUES (75005, '2020-07-25', 'ST', 'Sao Tome and Principe', 'AFRO', '111', '860', '0', '14');
INSERT INTO public.who_global_data_import VALUES (75006, '2020-07-26', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '862', '0', '14');
INSERT INTO public.who_global_data_import VALUES (75007, '2020-07-27', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '863', '0', '14');
INSERT INTO public.who_global_data_import VALUES (75008, '2020-07-28', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '865', '0', '14');
INSERT INTO public.who_global_data_import VALUES (75009, '2020-07-29', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '867', '0', '14');
INSERT INTO public.who_global_data_import VALUES (75010, '2020-07-30', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '868', '1', '15');
INSERT INTO public.who_global_data_import VALUES (75011, '2020-07-31', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '870', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75012, '2020-08-01', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '871', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75013, '2020-08-02', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '874', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75014, '2020-08-03', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '874', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75015, '2020-08-04', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '874', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75016, '2020-08-05', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '875', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75017, '2020-08-06', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '878', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75018, '2020-08-07', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '878', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75019, '2020-08-08', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '878', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75020, '2020-08-09', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '878', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75021, '2020-08-10', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '878', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75022, '2020-08-11', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '878', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75023, '2020-08-12', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '881', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75024, '2020-08-13', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '882', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75025, '2020-08-14', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '883', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75026, '2020-08-15', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '885', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75027, '2020-08-16', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '885', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75028, '2020-08-17', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '885', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75029, '2020-08-18', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '885', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75030, '2020-08-19', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '885', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75031, '2020-08-20', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '885', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75032, '2020-08-21', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '888', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75033, '2020-08-22', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '891', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75034, '2020-08-23', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '892', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75035, '2020-08-24', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '892', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75036, '2020-08-25', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '892', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75037, '2020-08-26', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '892', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75038, '2020-08-27', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '892', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75039, '2020-08-28', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '894', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75040, '2020-08-29', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '895', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75041, '2020-08-30', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '895', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75042, '2020-08-31', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '896', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75043, '2020-09-01', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '896', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75044, '2020-09-02', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '896', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75045, '2020-09-03', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '896', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75046, '2020-09-04', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '897', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75047, '2020-09-05', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '897', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75048, '2020-09-06', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '898', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75049, '2020-09-07', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '898', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75050, '2020-09-08', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '898', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75051, '2020-09-09', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '898', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75052, '2020-09-10', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '898', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75053, '2020-09-11', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '901', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75054, '2020-09-12', 'ST', 'Sao Tome and Principe', 'AFRO', '5', '906', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75055, '2020-09-13', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '906', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75056, '2020-09-14', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '906', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75057, '2020-09-15', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '906', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75058, '2020-09-16', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '907', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75059, '2020-09-17', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '907', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75060, '2020-09-18', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '907', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75061, '2020-09-19', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '908', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75062, '2020-09-20', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '908', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75063, '2020-09-21', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '908', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75064, '2020-09-22', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '908', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75065, '2020-09-23', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '908', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75066, '2020-09-24', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '908', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75067, '2020-09-25', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '910', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75068, '2020-09-26', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '911', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75069, '2020-09-27', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '911', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75070, '2020-09-28', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '911', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75071, '2020-09-29', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '911', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75072, '2020-09-30', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '911', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75073, '2020-10-01', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '911', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75074, '2020-10-02', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '911', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75075, '2020-10-03', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '911', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75076, '2020-10-04', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '913', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75077, '2020-10-05', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '913', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75078, '2020-10-06', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '913', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75079, '2020-10-07', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '914', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75080, '2020-10-08', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '914', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75081, '2020-10-09', 'ST', 'Sao Tome and Principe', 'AFRO', '7', '921', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75082, '2020-10-10', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '922', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75083, '2020-10-11', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '922', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75084, '2020-10-12', 'ST', 'Sao Tome and Principe', 'AFRO', '7', '929', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75085, '2020-10-13', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '929', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75086, '2020-10-14', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '929', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75087, '2020-10-15', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '929', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75088, '2020-10-16', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '929', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75089, '2020-10-17', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '932', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75090, '2020-10-18', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '932', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75091, '2020-10-19', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '933', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75092, '2020-10-20', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '933', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75093, '2020-10-21', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '933', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75094, '2020-10-22', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '935', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75095, '2020-10-23', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '935', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75096, '2020-10-24', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '938', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75097, '2020-10-25', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '940', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75098, '2020-10-26', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '940', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75099, '2020-10-27', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '941', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75100, '2020-10-28', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '941', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75101, '2020-10-29', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '943', '0', '15');
INSERT INTO public.who_global_data_import VALUES (75102, '2020-10-30', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '944', '1', '16');
INSERT INTO public.who_global_data_import VALUES (75103, '2020-10-31', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '945', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75104, '2020-11-01', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '945', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75105, '2020-11-02', 'ST', 'Sao Tome and Principe', 'AFRO', '4', '949', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75106, '2020-11-03', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '949', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75107, '2020-11-04', 'ST', 'Sao Tome and Principe', 'AFRO', '5', '954', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75108, '2020-11-05', 'ST', 'Sao Tome and Principe', 'AFRO', '4', '958', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75109, '2020-11-06', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '958', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75110, '2020-11-07', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '960', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75111, '2020-11-08', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '962', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75112, '2020-11-09', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '962', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75113, '2020-11-10', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '962', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75114, '2020-11-11', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '962', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75115, '2020-11-12', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '962', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75116, '2020-11-13', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '963', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75117, '2020-11-14', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '963', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75118, '2020-11-15', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '964', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75119, '2020-11-16', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '965', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75120, '2020-11-17', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '965', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75121, '2020-11-18', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '967', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75122, '2020-11-19', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '967', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75123, '2020-11-20', 'ST', 'Sao Tome and Principe', 'AFRO', '7', '974', '0', '16');
INSERT INTO public.who_global_data_import VALUES (75124, '2020-11-21', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '974', '1', '17');
INSERT INTO public.who_global_data_import VALUES (75125, '2020-11-22', 'ST', 'Sao Tome and Principe', 'AFRO', '5', '979', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75126, '2020-11-23', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '979', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75127, '2020-11-24', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '981', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75128, '2020-11-25', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '981', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75129, '2020-11-26', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '982', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75130, '2020-11-27', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '985', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75131, '2020-11-28', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '985', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75132, '2020-11-29', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '985', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75133, '2020-11-30', 'ST', 'Sao Tome and Principe', 'AFRO', '4', '989', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75134, '2020-12-01', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '991', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75135, '2020-12-02', 'ST', 'Sao Tome and Principe', 'AFRO', '5', '996', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75136, '2020-12-03', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '997', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75137, '2020-12-04', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '997', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75138, '2020-12-05', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '999', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75139, '2020-12-06', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '999', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75140, '2020-12-07', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '999', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75141, '2020-12-08', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '1002', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75142, '2020-12-09', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '1005', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75143, '2020-12-10', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1005', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75144, '2020-12-11', 'ST', 'Sao Tome and Principe', 'AFRO', '4', '1009', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75145, '2020-12-12', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1009', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75146, '2020-12-13', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1009', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75147, '2020-12-14', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1009', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75148, '2020-12-15', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '1010', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75149, '2020-12-16', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1010', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75150, '2020-12-17', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1010', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75151, '2020-12-18', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '1011', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75152, '2020-12-19', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1011', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75153, '2020-12-20', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '1012', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75154, '2020-12-21', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1012', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75155, '2020-12-22', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1012', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75156, '2020-12-23', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1012', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75157, '2020-12-24', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1012', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75158, '2020-12-25', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1012', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75159, '2020-12-26', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1012', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75160, '2020-12-27', 'ST', 'Sao Tome and Principe', 'AFRO', '2', '1014', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75161, '2020-12-28', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1014', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75162, '2020-12-29', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1014', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75163, '2020-12-30', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1014', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75164, '2020-12-31', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1014', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75165, '2021-01-01', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1014', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75166, '2021-01-02', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1014', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75167, '2021-01-03', 'ST', 'Sao Tome and Principe', 'AFRO', '10', '1024', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75168, '2021-01-04', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1024', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75169, '2021-01-05', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1024', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75170, '2021-01-06', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1024', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75171, '2021-01-07', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1024', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75172, '2021-01-08', 'ST', 'Sao Tome and Principe', 'AFRO', '11', '1035', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75173, '2021-01-09', 'ST', 'Sao Tome and Principe', 'AFRO', '19', '1054', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75174, '2021-01-10', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1054', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75175, '2021-01-11', 'ST', 'Sao Tome and Principe', 'AFRO', '12', '1066', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75176, '2021-01-12', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1066', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75177, '2021-01-13', 'ST', 'Sao Tome and Principe', 'AFRO', '24', '1090', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75178, '2021-01-14', 'ST', 'Sao Tome and Principe', 'AFRO', '15', '1105', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75179, '2021-01-15', 'ST', 'Sao Tome and Principe', 'AFRO', '14', '1119', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75180, '2021-01-16', 'ST', 'Sao Tome and Principe', 'AFRO', '6', '1125', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75181, '2021-01-17', 'ST', 'Sao Tome and Principe', 'AFRO', '5', '1130', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75182, '2021-01-18', 'ST', 'Sao Tome and Principe', 'AFRO', '12', '1142', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75183, '2021-01-19', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1142', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75184, '2021-01-20', 'ST', 'Sao Tome and Principe', 'AFRO', '9', '1151', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75185, '2021-01-21', 'ST', 'Sao Tome and Principe', 'AFRO', '19', '1170', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75186, '2021-01-22', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '1171', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75187, '2021-01-23', 'ST', 'Sao Tome and Principe', 'AFRO', '11', '1182', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75188, '2021-01-24', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1182', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75189, '2021-01-25', 'ST', 'Sao Tome and Principe', 'AFRO', '6', '1188', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75190, '2021-01-26', 'ST', 'Sao Tome and Principe', 'AFRO', '1', '1189', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75191, '2021-01-27', 'ST', 'Sao Tome and Principe', 'AFRO', '21', '1210', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75192, '2021-01-28', 'ST', 'Sao Tome and Principe', 'AFRO', '11', '1221', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75193, '2021-01-29', 'ST', 'Sao Tome and Principe', 'AFRO', '11', '1232', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75194, '2021-01-30', 'ST', 'Sao Tome and Principe', 'AFRO', '13', '1245', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75195, '2021-01-31', 'ST', 'Sao Tome and Principe', 'AFRO', '11', '1256', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75196, '2021-02-01', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1256', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75197, '2021-02-02', 'ST', 'Sao Tome and Principe', 'AFRO', '3', '1259', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75198, '2021-02-03', 'ST', 'Sao Tome and Principe', 'AFRO', '12', '1271', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75199, '2021-02-04', 'ST', 'Sao Tome and Principe', 'AFRO', '4', '1275', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75200, '2021-02-05', 'ST', 'Sao Tome and Principe', 'AFRO', '0', '1275', '0', '17');
INSERT INTO public.who_global_data_import VALUES (75201, '2020-01-03', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75202, '2020-01-04', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75203, '2020-01-05', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75204, '2020-01-06', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75205, '2020-01-07', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75206, '2020-01-08', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75207, '2020-01-09', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75208, '2020-01-10', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75209, '2020-01-11', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75210, '2020-01-12', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75211, '2020-01-13', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75212, '2020-01-14', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75213, '2020-01-15', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75214, '2020-01-16', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75215, '2020-01-17', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75216, '2020-01-18', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75217, '2020-01-19', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75218, '2020-01-20', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75219, '2020-01-21', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75220, '2020-01-22', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75221, '2020-01-23', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75222, '2020-01-24', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75223, '2020-01-25', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75224, '2020-01-26', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75225, '2020-01-27', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75226, '2020-01-28', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75227, '2020-01-29', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75228, '2020-01-30', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75229, '2020-01-31', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75230, '2020-02-01', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75231, '2020-02-02', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75232, '2020-02-03', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75233, '2020-02-04', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75234, '2020-02-05', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75235, '2020-02-06', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75236, '2020-02-07', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75237, '2020-02-08', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75238, '2020-02-09', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75239, '2020-02-10', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75240, '2020-02-11', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75241, '2020-02-12', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75242, '2020-02-13', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75243, '2020-02-14', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75244, '2020-02-15', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75245, '2020-02-16', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75246, '2020-02-17', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75247, '2020-02-18', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75248, '2020-02-19', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75249, '2020-02-20', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75250, '2020-02-21', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75251, '2020-02-22', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75252, '2020-02-23', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75253, '2020-02-24', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75254, '2020-02-25', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75255, '2020-02-26', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75256, '2020-02-27', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75257, '2020-02-28', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75258, '2020-02-29', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75259, '2020-03-01', 'SA', 'Saudi Arabia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75260, '2020-03-02', 'SA', 'Saudi Arabia', 'EMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75261, '2020-03-03', 'SA', 'Saudi Arabia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75262, '2020-03-04', 'SA', 'Saudi Arabia', 'EMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75263, '2020-03-05', 'SA', 'Saudi Arabia', 'EMRO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75264, '2020-03-06', 'SA', 'Saudi Arabia', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75265, '2020-03-07', 'SA', 'Saudi Arabia', 'EMRO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75266, '2020-03-08', 'SA', 'Saudi Arabia', 'EMRO', '4', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75267, '2020-03-09', 'SA', 'Saudi Arabia', 'EMRO', '4', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75268, '2020-03-10', 'SA', 'Saudi Arabia', 'EMRO', '5', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75269, '2020-03-11', 'SA', 'Saudi Arabia', 'EMRO', '1', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75270, '2020-03-12', 'SA', 'Saudi Arabia', 'EMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75271, '2020-03-13', 'SA', 'Saudi Arabia', 'EMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75272, '2020-03-14', 'SA', 'Saudi Arabia', 'EMRO', '82', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75273, '2020-03-15', 'SA', 'Saudi Arabia', 'EMRO', '0', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75274, '2020-03-16', 'SA', 'Saudi Arabia', 'EMRO', '30', '137', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75275, '2020-03-17', 'SA', 'Saudi Arabia', 'EMRO', '38', '175', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75276, '2020-03-18', 'SA', 'Saudi Arabia', 'EMRO', '67', '242', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75277, '2020-03-19', 'SA', 'Saudi Arabia', 'EMRO', '0', '242', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75278, '2020-03-20', 'SA', 'Saudi Arabia', 'EMRO', '32', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75279, '2020-03-21', 'SA', 'Saudi Arabia', 'EMRO', '118', '392', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75280, '2020-03-22', 'SA', 'Saudi Arabia', 'EMRO', '119', '511', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75281, '2020-03-23', 'SA', 'Saudi Arabia', 'EMRO', '51', '562', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75282, '2020-03-24', 'SA', 'Saudi Arabia', 'EMRO', '205', '767', '1', '1');
INSERT INTO public.who_global_data_import VALUES (75283, '2020-03-25', 'SA', 'Saudi Arabia', 'EMRO', '133', '900', '1', '2');
INSERT INTO public.who_global_data_import VALUES (75284, '2020-03-26', 'SA', 'Saudi Arabia', 'EMRO', '112', '1012', '1', '3');
INSERT INTO public.who_global_data_import VALUES (75285, '2020-03-27', 'SA', 'Saudi Arabia', 'EMRO', '92', '1104', '0', '3');
INSERT INTO public.who_global_data_import VALUES (75286, '2020-03-28', 'SA', 'Saudi Arabia', 'EMRO', '99', '1203', '1', '4');
INSERT INTO public.who_global_data_import VALUES (75287, '2020-03-29', 'SA', 'Saudi Arabia', 'EMRO', '96', '1299', '4', '8');
INSERT INTO public.who_global_data_import VALUES (75288, '2020-03-30', 'SA', 'Saudi Arabia', 'EMRO', '154', '1453', '0', '8');
INSERT INTO public.who_global_data_import VALUES (75289, '2020-03-31', 'SA', 'Saudi Arabia', 'EMRO', '110', '1563', '2', '10');
INSERT INTO public.who_global_data_import VALUES (75290, '2020-04-01', 'SA', 'Saudi Arabia', 'EMRO', '157', '1720', '6', '16');
INSERT INTO public.who_global_data_import VALUES (75291, '2020-04-02', 'SA', 'Saudi Arabia', 'EMRO', '165', '1885', '5', '21');
INSERT INTO public.who_global_data_import VALUES (75292, '2020-04-03', 'SA', 'Saudi Arabia', 'EMRO', '154', '2039', '4', '25');
INSERT INTO public.who_global_data_import VALUES (75293, '2020-04-04', 'SA', 'Saudi Arabia', 'EMRO', '140', '2179', '4', '29');
INSERT INTO public.who_global_data_import VALUES (75294, '2020-04-05', 'SA', 'Saudi Arabia', 'EMRO', '206', '2385', '5', '34');
INSERT INTO public.who_global_data_import VALUES (75295, '2020-04-06', 'SA', 'Saudi Arabia', 'EMRO', '138', '2523', '4', '38');
INSERT INTO public.who_global_data_import VALUES (75296, '2020-04-07', 'SA', 'Saudi Arabia', 'EMRO', '272', '2795', '3', '41');
INSERT INTO public.who_global_data_import VALUES (75297, '2020-04-08', 'SA', 'Saudi Arabia', 'EMRO', '137', '2932', '0', '41');
INSERT INTO public.who_global_data_import VALUES (75298, '2020-04-09', 'SA', 'Saudi Arabia', 'EMRO', '355', '3287', '3', '44');
INSERT INTO public.who_global_data_import VALUES (75299, '2020-04-10', 'SA', 'Saudi Arabia', 'EMRO', '364', '3651', '3', '47');
INSERT INTO public.who_global_data_import VALUES (75300, '2020-04-11', 'SA', 'Saudi Arabia', 'EMRO', '382', '4033', '5', '52');
INSERT INTO public.who_global_data_import VALUES (75301, '2020-04-12', 'SA', 'Saudi Arabia', 'EMRO', '429', '4462', '7', '59');
INSERT INTO public.who_global_data_import VALUES (75302, '2020-04-13', 'SA', 'Saudi Arabia', 'EMRO', '472', '4934', '6', '65');
INSERT INTO public.who_global_data_import VALUES (75303, '2020-04-14', 'SA', 'Saudi Arabia', 'EMRO', '435', '5369', '8', '73');
INSERT INTO public.who_global_data_import VALUES (75304, '2020-04-15', 'SA', 'Saudi Arabia', 'EMRO', '493', '5862', '6', '79');
INSERT INTO public.who_global_data_import VALUES (75305, '2020-04-16', 'SA', 'Saudi Arabia', 'EMRO', '518', '6380', '4', '83');
INSERT INTO public.who_global_data_import VALUES (75306, '2020-04-17', 'SA', 'Saudi Arabia', 'EMRO', '762', '7142', '4', '87');
INSERT INTO public.who_global_data_import VALUES (75307, '2020-04-18', 'SA', 'Saudi Arabia', 'EMRO', '1132', '8274', '5', '92');
INSERT INTO public.who_global_data_import VALUES (75308, '2020-04-19', 'SA', 'Saudi Arabia', 'EMRO', '1088', '9362', '5', '97');
INSERT INTO public.who_global_data_import VALUES (75309, '2020-04-20', 'SA', 'Saudi Arabia', 'EMRO', '1122', '10484', '6', '103');
INSERT INTO public.who_global_data_import VALUES (75310, '2020-04-21', 'SA', 'Saudi Arabia', 'EMRO', '1147', '11631', '6', '109');
INSERT INTO public.who_global_data_import VALUES (75311, '2020-04-22', 'SA', 'Saudi Arabia', 'EMRO', '1141', '12772', '5', '114');
INSERT INTO public.who_global_data_import VALUES (75312, '2020-04-23', 'SA', 'Saudi Arabia', 'EMRO', '1158', '13930', '7', '121');
INSERT INTO public.who_global_data_import VALUES (75313, '2020-04-24', 'SA', 'Saudi Arabia', 'EMRO', '1172', '15102', '6', '127');
INSERT INTO public.who_global_data_import VALUES (75314, '2020-04-25', 'SA', 'Saudi Arabia', 'EMRO', '1197', '16299', '9', '136');
INSERT INTO public.who_global_data_import VALUES (75315, '2020-04-26', 'SA', 'Saudi Arabia', 'EMRO', '1223', '17522', '3', '139');
INSERT INTO public.who_global_data_import VALUES (75316, '2020-04-27', 'SA', 'Saudi Arabia', 'EMRO', '1289', '18811', '5', '144');
INSERT INTO public.who_global_data_import VALUES (75317, '2020-04-28', 'SA', 'Saudi Arabia', 'EMRO', '1266', '20077', '8', '152');
INSERT INTO public.who_global_data_import VALUES (75318, '2020-04-29', 'SA', 'Saudi Arabia', 'EMRO', '1325', '21402', '5', '157');
INSERT INTO public.who_global_data_import VALUES (75319, '2020-04-30', 'SA', 'Saudi Arabia', 'EMRO', '1351', '22753', '5', '162');
INSERT INTO public.who_global_data_import VALUES (75320, '2020-05-01', 'SA', 'Saudi Arabia', 'EMRO', '1344', '24097', '7', '169');
INSERT INTO public.who_global_data_import VALUES (75321, '2020-05-02', 'SA', 'Saudi Arabia', 'EMRO', '1362', '25459', '7', '176');
INSERT INTO public.who_global_data_import VALUES (75322, '2020-05-03', 'SA', 'Saudi Arabia', 'EMRO', '1552', '27011', '8', '184');
INSERT INTO public.who_global_data_import VALUES (75323, '2020-05-04', 'SA', 'Saudi Arabia', 'EMRO', '1645', '28656', '7', '191');
INSERT INTO public.who_global_data_import VALUES (75324, '2020-05-05', 'SA', 'Saudi Arabia', 'EMRO', '1595', '30251', '9', '200');
INSERT INTO public.who_global_data_import VALUES (75325, '2020-05-06', 'SA', 'Saudi Arabia', 'EMRO', '1687', '31938', '9', '209');
INSERT INTO public.who_global_data_import VALUES (75326, '2020-05-07', 'SA', 'Saudi Arabia', 'EMRO', '1793', '33731', '10', '219');
INSERT INTO public.who_global_data_import VALUES (75327, '2020-05-08', 'SA', 'Saudi Arabia', 'EMRO', '1701', '35432', '10', '229');
INSERT INTO public.who_global_data_import VALUES (75328, '2020-05-09', 'SA', 'Saudi Arabia', 'EMRO', '1704', '37136', '10', '239');
INSERT INTO public.who_global_data_import VALUES (75329, '2020-05-10', 'SA', 'Saudi Arabia', 'EMRO', '1912', '39048', '7', '246');
INSERT INTO public.who_global_data_import VALUES (75330, '2020-05-11', 'SA', 'Saudi Arabia', 'EMRO', '1966', '41014', '9', '255');
INSERT INTO public.who_global_data_import VALUES (75331, '2020-05-12', 'SA', 'Saudi Arabia', 'EMRO', '1911', '42925', '9', '264');
INSERT INTO public.who_global_data_import VALUES (75332, '2020-05-13', 'SA', 'Saudi Arabia', 'EMRO', '1905', '44830', '9', '273');
INSERT INTO public.who_global_data_import VALUES (75333, '2020-05-14', 'SA', 'Saudi Arabia', 'EMRO', '2039', '46869', '10', '283');
INSERT INTO public.who_global_data_import VALUES (75334, '2020-05-15', 'SA', 'Saudi Arabia', 'EMRO', '2307', '49176', '9', '292');
INSERT INTO public.who_global_data_import VALUES (75335, '2020-05-16', 'SA', 'Saudi Arabia', 'EMRO', '2840', '52016', '10', '302');
INSERT INTO public.who_global_data_import VALUES (75336, '2020-05-17', 'SA', 'Saudi Arabia', 'EMRO', '2736', '54752', '10', '312');
INSERT INTO public.who_global_data_import VALUES (75337, '2020-05-18', 'SA', 'Saudi Arabia', 'EMRO', '2593', '57345', '8', '320');
INSERT INTO public.who_global_data_import VALUES (75338, '2020-05-19', 'SA', 'Saudi Arabia', 'EMRO', '2509', '59854', '9', '329');
INSERT INTO public.who_global_data_import VALUES (75339, '2020-05-20', 'SA', 'Saudi Arabia', 'EMRO', '2691', '62545', '10', '339');
INSERT INTO public.who_global_data_import VALUES (75340, '2020-05-21', 'SA', 'Saudi Arabia', 'EMRO', '2532', '65077', '12', '351');
INSERT INTO public.who_global_data_import VALUES (75341, '2020-05-22', 'SA', 'Saudi Arabia', 'EMRO', '0', '65077', '0', '351');
INSERT INTO public.who_global_data_import VALUES (75342, '2020-05-23', 'SA', 'Saudi Arabia', 'EMRO', '2642', '67719', '13', '364');
INSERT INTO public.who_global_data_import VALUES (75343, '2020-05-24', 'SA', 'Saudi Arabia', 'EMRO', '2442', '70161', '15', '379');
INSERT INTO public.who_global_data_import VALUES (75344, '2020-05-25', 'SA', 'Saudi Arabia', 'EMRO', '2399', '72560', '11', '390');
INSERT INTO public.who_global_data_import VALUES (75345, '2020-05-26', 'SA', 'Saudi Arabia', 'EMRO', '2235', '74795', '9', '399');
INSERT INTO public.who_global_data_import VALUES (75346, '2020-05-27', 'SA', 'Saudi Arabia', 'EMRO', '1931', '76726', '12', '411');
INSERT INTO public.who_global_data_import VALUES (75347, '2020-05-28', 'SA', 'Saudi Arabia', 'EMRO', '1815', '78541', '14', '425');
INSERT INTO public.who_global_data_import VALUES (75348, '2020-05-29', 'SA', 'Saudi Arabia', 'EMRO', '1644', '80185', '16', '441');
INSERT INTO public.who_global_data_import VALUES (75349, '2020-05-30', 'SA', 'Saudi Arabia', 'EMRO', '1581', '81766', '17', '458');
INSERT INTO public.who_global_data_import VALUES (75350, '2020-05-31', 'SA', 'Saudi Arabia', 'EMRO', '1618', '83384', '22', '480');
INSERT INTO public.who_global_data_import VALUES (75351, '2020-06-01', 'SA', 'Saudi Arabia', 'EMRO', '1877', '85261', '23', '503');
INSERT INTO public.who_global_data_import VALUES (75352, '2020-06-02', 'SA', 'Saudi Arabia', 'EMRO', '1881', '87142', '22', '525');
INSERT INTO public.who_global_data_import VALUES (75353, '2020-06-03', 'SA', 'Saudi Arabia', 'EMRO', '1869', '89011', '24', '549');
INSERT INTO public.who_global_data_import VALUES (75354, '2020-06-04', 'SA', 'Saudi Arabia', 'EMRO', '2171', '91182', '30', '579');
INSERT INTO public.who_global_data_import VALUES (75355, '2020-06-05', 'SA', 'Saudi Arabia', 'EMRO', '1975', '93157', '32', '611');
INSERT INTO public.who_global_data_import VALUES (75356, '2020-06-06', 'SA', 'Saudi Arabia', 'EMRO', '2591', '95748', '31', '642');
INSERT INTO public.who_global_data_import VALUES (75357, '2020-06-07', 'SA', 'Saudi Arabia', 'EMRO', '3121', '98869', '34', '676');
INSERT INTO public.who_global_data_import VALUES (75358, '2020-06-08', 'SA', 'Saudi Arabia', 'EMRO', '3045', '101914', '36', '712');
INSERT INTO public.who_global_data_import VALUES (75359, '2020-06-09', 'SA', 'Saudi Arabia', 'EMRO', '3369', '105283', '34', '746');
INSERT INTO public.who_global_data_import VALUES (75360, '2020-06-10', 'SA', 'Saudi Arabia', 'EMRO', '3288', '108571', '37', '783');
INSERT INTO public.who_global_data_import VALUES (75361, '2020-06-11', 'SA', 'Saudi Arabia', 'EMRO', '3717', '112288', '36', '819');
INSERT INTO public.who_global_data_import VALUES (75362, '2020-06-12', 'SA', 'Saudi Arabia', 'EMRO', '3733', '116021', '38', '857');
INSERT INTO public.who_global_data_import VALUES (75363, '2020-06-13', 'SA', 'Saudi Arabia', 'EMRO', '3921', '119942', '36', '893');
INSERT INTO public.who_global_data_import VALUES (75364, '2020-06-14', 'SA', 'Saudi Arabia', 'EMRO', '3366', '123308', '39', '932');
INSERT INTO public.who_global_data_import VALUES (75365, '2020-06-15', 'SA', 'Saudi Arabia', 'EMRO', '4233', '127541', '40', '972');
INSERT INTO public.who_global_data_import VALUES (75366, '2020-06-16', 'SA', 'Saudi Arabia', 'EMRO', '4507', '132048', '39', '1011');
INSERT INTO public.who_global_data_import VALUES (75367, '2020-06-17', 'SA', 'Saudi Arabia', 'EMRO', '4267', '136315', '41', '1052');
INSERT INTO public.who_global_data_import VALUES (75368, '2020-06-18', 'SA', 'Saudi Arabia', 'EMRO', '4919', '141234', '39', '1091');
INSERT INTO public.who_global_data_import VALUES (75369, '2020-06-19', 'SA', 'Saudi Arabia', 'EMRO', '4757', '145991', '48', '1139');
INSERT INTO public.who_global_data_import VALUES (75370, '2020-06-20', 'SA', 'Saudi Arabia', 'EMRO', '4301', '150292', '45', '1184');
INSERT INTO public.who_global_data_import VALUES (75371, '2020-06-21', 'SA', 'Saudi Arabia', 'EMRO', '3941', '154233', '46', '1230');
INSERT INTO public.who_global_data_import VALUES (75372, '2020-06-22', 'SA', 'Saudi Arabia', 'EMRO', '3379', '157612', '37', '1267');
INSERT INTO public.who_global_data_import VALUES (75373, '2020-06-23', 'SA', 'Saudi Arabia', 'EMRO', '3393', '161005', '40', '1307');
INSERT INTO public.who_global_data_import VALUES (75374, '2020-06-24', 'SA', 'Saudi Arabia', 'EMRO', '3139', '164144', '39', '1346');
INSERT INTO public.who_global_data_import VALUES (75375, '2020-06-25', 'SA', 'Saudi Arabia', 'EMRO', '3123', '167267', '41', '1387');
INSERT INTO public.who_global_data_import VALUES (75376, '2020-06-26', 'SA', 'Saudi Arabia', 'EMRO', '3372', '170639', '41', '1428');
INSERT INTO public.who_global_data_import VALUES (75377, '2020-06-27', 'SA', 'Saudi Arabia', 'EMRO', '3938', '174577', '46', '1474');
INSERT INTO public.who_global_data_import VALUES (75378, '2020-06-28', 'SA', 'Saudi Arabia', 'EMRO', '3927', '178504', '37', '1511');
INSERT INTO public.who_global_data_import VALUES (75379, '2020-06-29', 'SA', 'Saudi Arabia', 'EMRO', '3989', '182493', '40', '1551');
INSERT INTO public.who_global_data_import VALUES (75380, '2020-06-30', 'SA', 'Saudi Arabia', 'EMRO', '3943', '186436', '48', '1599');
INSERT INTO public.who_global_data_import VALUES (75381, '2020-07-01', 'SA', 'Saudi Arabia', 'EMRO', '4387', '190823', '50', '1649');
INSERT INTO public.who_global_data_import VALUES (75382, '2020-07-02', 'SA', 'Saudi Arabia', 'EMRO', '3402', '194225', '49', '1698');
INSERT INTO public.who_global_data_import VALUES (75383, '2020-07-03', 'SA', 'Saudi Arabia', 'EMRO', '3383', '197608', '54', '1752');
INSERT INTO public.who_global_data_import VALUES (75384, '2020-07-04', 'SA', 'Saudi Arabia', 'EMRO', '4193', '201801', '50', '1802');
INSERT INTO public.who_global_data_import VALUES (75385, '2020-07-05', 'SA', 'Saudi Arabia', 'EMRO', '4128', '205929', '56', '1858');
INSERT INTO public.who_global_data_import VALUES (75386, '2020-07-06', 'SA', 'Saudi Arabia', 'EMRO', '3580', '209509', '58', '1916');
INSERT INTO public.who_global_data_import VALUES (75387, '2020-07-07', 'SA', 'Saudi Arabia', 'EMRO', '4207', '213716', '52', '1968');
INSERT INTO public.who_global_data_import VALUES (75388, '2020-07-08', 'SA', 'Saudi Arabia', 'EMRO', '3392', '217108', '49', '2017');
INSERT INTO public.who_global_data_import VALUES (75389, '2020-07-09', 'SA', 'Saudi Arabia', 'EMRO', '3036', '220144', '42', '2059');
INSERT INTO public.who_global_data_import VALUES (75390, '2020-07-10', 'SA', 'Saudi Arabia', 'EMRO', '3183', '223327', '41', '2100');
INSERT INTO public.who_global_data_import VALUES (75391, '2020-07-11', 'SA', 'Saudi Arabia', 'EMRO', '3159', '226486', '51', '2151');
INSERT INTO public.who_global_data_import VALUES (75392, '2020-07-12', 'SA', 'Saudi Arabia', 'EMRO', '2994', '229480', '30', '2181');
INSERT INTO public.who_global_data_import VALUES (75393, '2020-07-13', 'SA', 'Saudi Arabia', 'EMRO', '2779', '232259', '42', '2223');
INSERT INTO public.who_global_data_import VALUES (75394, '2020-07-14', 'SA', 'Saudi Arabia', 'EMRO', '2852', '235111', '20', '2243');
INSERT INTO public.who_global_data_import VALUES (75395, '2020-07-15', 'SA', 'Saudi Arabia', 'EMRO', '2692', '237803', '40', '2283');
INSERT INTO public.who_global_data_import VALUES (75396, '2020-07-16', 'SA', 'Saudi Arabia', 'EMRO', '2671', '240474', '42', '2325');
INSERT INTO public.who_global_data_import VALUES (75397, '2020-07-17', 'SA', 'Saudi Arabia', 'EMRO', '2764', '243238', '45', '2370');
INSERT INTO public.who_global_data_import VALUES (75398, '2020-07-18', 'SA', 'Saudi Arabia', 'EMRO', '2613', '245851', '37', '2407');
INSERT INTO public.who_global_data_import VALUES (75399, '2020-07-19', 'SA', 'Saudi Arabia', 'EMRO', '2565', '248416', '40', '2447');
INSERT INTO public.who_global_data_import VALUES (75400, '2020-07-20', 'SA', 'Saudi Arabia', 'EMRO', '2504', '250920', '39', '2486');
INSERT INTO public.who_global_data_import VALUES (75401, '2020-07-21', 'SA', 'Saudi Arabia', 'EMRO', '2429', '253349', '37', '2523');
INSERT INTO public.who_global_data_import VALUES (75402, '2020-07-22', 'SA', 'Saudi Arabia', 'EMRO', '2476', '255825', '34', '2557');
INSERT INTO public.who_global_data_import VALUES (75403, '2020-07-23', 'SA', 'Saudi Arabia', 'EMRO', '2331', '258156', '44', '2601');
INSERT INTO public.who_global_data_import VALUES (75404, '2020-07-24', 'SA', 'Saudi Arabia', 'EMRO', '2238', '260394', '34', '2635');
INSERT INTO public.who_global_data_import VALUES (75405, '2020-07-25', 'SA', 'Saudi Arabia', 'EMRO', '2378', '262772', '37', '2672');
INSERT INTO public.who_global_data_import VALUES (75406, '2020-07-26', 'SA', 'Saudi Arabia', 'EMRO', '2201', '264973', '31', '2703');
INSERT INTO public.who_global_data_import VALUES (75407, '2020-07-27', 'SA', 'Saudi Arabia', 'EMRO', '1968', '266941', '30', '2733');
INSERT INTO public.who_global_data_import VALUES (75408, '2020-07-28', 'SA', 'Saudi Arabia', 'EMRO', '1993', '268934', '27', '2760');
INSERT INTO public.who_global_data_import VALUES (75409, '2020-07-29', 'SA', 'Saudi Arabia', 'EMRO', '1897', '270831', '29', '2789');
INSERT INTO public.who_global_data_import VALUES (75410, '2020-07-30', 'SA', 'Saudi Arabia', 'EMRO', '1759', '272590', '27', '2816');
INSERT INTO public.who_global_data_import VALUES (75411, '2020-07-31', 'SA', 'Saudi Arabia', 'EMRO', '1629', '274219', '26', '2842');
INSERT INTO public.who_global_data_import VALUES (75412, '2020-08-01', 'SA', 'Saudi Arabia', 'EMRO', '1686', '275905', '24', '2866');
INSERT INTO public.who_global_data_import VALUES (75413, '2020-08-02', 'SA', 'Saudi Arabia', 'EMRO', '1573', '277478', '21', '2887');
INSERT INTO public.who_global_data_import VALUES (75414, '2020-08-03', 'SA', 'Saudi Arabia', 'EMRO', '1357', '278835', '30', '2917');
INSERT INTO public.who_global_data_import VALUES (75415, '2020-08-04', 'SA', 'Saudi Arabia', 'EMRO', '1258', '280093', '32', '2949');
INSERT INTO public.who_global_data_import VALUES (75416, '2020-08-05', 'SA', 'Saudi Arabia', 'EMRO', '1342', '281435', '35', '2984');
INSERT INTO public.who_global_data_import VALUES (75417, '2020-08-06', 'SA', 'Saudi Arabia', 'EMRO', '1389', '282824', '36', '3020');
INSERT INTO public.who_global_data_import VALUES (75418, '2020-08-07', 'SA', 'Saudi Arabia', 'EMRO', '1402', '284226', '35', '3055');
INSERT INTO public.who_global_data_import VALUES (75419, '2020-08-08', 'SA', 'Saudi Arabia', 'EMRO', '1567', '285793', '38', '3093');
INSERT INTO public.who_global_data_import VALUES (75420, '2020-08-09', 'SA', 'Saudi Arabia', 'EMRO', '1469', '287262', '37', '3130');
INSERT INTO public.who_global_data_import VALUES (75421, '2020-08-10', 'SA', 'Saudi Arabia', 'EMRO', '1428', '288690', '37', '3167');
INSERT INTO public.who_global_data_import VALUES (75422, '2020-08-11', 'SA', 'Saudi Arabia', 'EMRO', '1257', '289947', '32', '3199');
INSERT INTO public.who_global_data_import VALUES (75423, '2020-08-12', 'SA', 'Saudi Arabia', 'EMRO', '1521', '291468', '34', '3233');
INSERT INTO public.who_global_data_import VALUES (75424, '2020-08-13', 'SA', 'Saudi Arabia', 'EMRO', '1569', '293037', '36', '3269');
INSERT INTO public.who_global_data_import VALUES (75425, '2020-08-14', 'SA', 'Saudi Arabia', 'EMRO', '1482', '294519', '34', '3303');
INSERT INTO public.who_global_data_import VALUES (75426, '2020-08-15', 'SA', 'Saudi Arabia', 'EMRO', '1383', '295902', '35', '3338');
INSERT INTO public.who_global_data_import VALUES (75427, '2020-08-16', 'SA', 'Saudi Arabia', 'EMRO', '1413', '297315', '31', '3369');
INSERT INTO public.who_global_data_import VALUES (75428, '2020-08-17', 'SA', 'Saudi Arabia', 'EMRO', '1227', '298542', '39', '3408');
INSERT INTO public.who_global_data_import VALUES (75429, '2020-08-18', 'SA', 'Saudi Arabia', 'EMRO', '1372', '299914', '28', '3436');
INSERT INTO public.who_global_data_import VALUES (75430, '2020-08-19', 'SA', 'Saudi Arabia', 'EMRO', '1409', '301323', '34', '3470');
INSERT INTO public.who_global_data_import VALUES (75431, '2020-08-20', 'SA', 'Saudi Arabia', 'EMRO', '1363', '302686', '36', '3506');
INSERT INTO public.who_global_data_import VALUES (75432, '2020-08-21', 'SA', 'Saudi Arabia', 'EMRO', '1287', '303973', '42', '3548');
INSERT INTO public.who_global_data_import VALUES (75433, '2020-08-22', 'SA', 'Saudi Arabia', 'EMRO', '1213', '305186', '32', '3580');
INSERT INTO public.who_global_data_import VALUES (75434, '2020-08-23', 'SA', 'Saudi Arabia', 'EMRO', '1184', '306370', '39', '3619');
INSERT INTO public.who_global_data_import VALUES (75435, '2020-08-24', 'SA', 'Saudi Arabia', 'EMRO', '1109', '307479', '30', '3649');
INSERT INTO public.who_global_data_import VALUES (75436, '2020-08-25', 'SA', 'Saudi Arabia', 'EMRO', '1175', '308654', '42', '3691');
INSERT INTO public.who_global_data_import VALUES (75437, '2020-08-26', 'SA', 'Saudi Arabia', 'EMRO', '1114', '309768', '31', '3722');
INSERT INTO public.who_global_data_import VALUES (75438, '2020-08-27', 'SA', 'Saudi Arabia', 'EMRO', '1068', '310836', '33', '3755');
INSERT INTO public.who_global_data_import VALUES (75439, '2020-08-28', 'SA', 'Saudi Arabia', 'EMRO', '1019', '311855', '30', '3785');
INSERT INTO public.who_global_data_import VALUES (75440, '2020-08-29', 'SA', 'Saudi Arabia', 'EMRO', '1069', '312924', '28', '3813');
INSERT INTO public.who_global_data_import VALUES (75441, '2020-08-30', 'SA', 'Saudi Arabia', 'EMRO', '987', '313911', '27', '3840');
INSERT INTO public.who_global_data_import VALUES (75442, '2020-08-31', 'SA', 'Saudi Arabia', 'EMRO', '910', '314821', '30', '3870');
INSERT INTO public.who_global_data_import VALUES (75443, '2020-09-01', 'SA', 'Saudi Arabia', 'EMRO', '951', '315772', '27', '3897');
INSERT INTO public.who_global_data_import VALUES (75444, '2020-09-02', 'SA', 'Saudi Arabia', 'EMRO', '898', '316670', '32', '3929');
INSERT INTO public.who_global_data_import VALUES (75445, '2020-09-03', 'SA', 'Saudi Arabia', 'EMRO', '816', '317486', '27', '3956');
INSERT INTO public.who_global_data_import VALUES (75446, '2020-09-04', 'SA', 'Saudi Arabia', 'EMRO', '833', '318319', '26', '3982');
INSERT INTO public.who_global_data_import VALUES (75447, '2020-09-05', 'SA', 'Saudi Arabia', 'EMRO', '822', '319141', '33', '4015');
INSERT INTO public.who_global_data_import VALUES (75448, '2020-09-06', 'SA', 'Saudi Arabia', 'EMRO', '791', '319932', '34', '4049');
INSERT INTO public.who_global_data_import VALUES (75449, '2020-09-07', 'SA', 'Saudi Arabia', 'EMRO', '895', '320827', '32', '4081');
INSERT INTO public.who_global_data_import VALUES (75450, '2020-09-08', 'SA', 'Saudi Arabia', 'EMRO', '629', '321456', '26', '4107');
INSERT INTO public.who_global_data_import VALUES (75451, '2020-09-09', 'SA', 'Saudi Arabia', 'EMRO', '781', '322237', '30', '4137');
INSERT INTO public.who_global_data_import VALUES (75452, '2020-09-10', 'SA', 'Saudi Arabia', 'EMRO', '775', '323012', '28', '4165');
INSERT INTO public.who_global_data_import VALUES (75453, '2020-09-11', 'SA', 'Saudi Arabia', 'EMRO', '708', '323720', '24', '4189');
INSERT INTO public.who_global_data_import VALUES (75454, '2020-09-12', 'SA', 'Saudi Arabia', 'EMRO', '687', '324407', '24', '4213');
INSERT INTO public.who_global_data_import VALUES (75455, '2020-09-13', 'SA', 'Saudi Arabia', 'EMRO', '643', '325050', '27', '4240');
INSERT INTO public.who_global_data_import VALUES (75456, '2020-09-14', 'SA', 'Saudi Arabia', 'EMRO', '601', '325651', '28', '4268');
INSERT INTO public.who_global_data_import VALUES (75457, '2020-09-15', 'SA', 'Saudi Arabia', 'EMRO', '607', '326258', '37', '4305');
INSERT INTO public.who_global_data_import VALUES (75458, '2020-09-16', 'SA', 'Saudi Arabia', 'EMRO', '672', '326930', '33', '4338');
INSERT INTO public.who_global_data_import VALUES (75459, '2020-09-17', 'SA', 'Saudi Arabia', 'EMRO', '621', '327551', '31', '4369');
INSERT INTO public.who_global_data_import VALUES (75460, '2020-09-18', 'SA', 'Saudi Arabia', 'EMRO', '593', '328144', '30', '4399');
INSERT INTO public.who_global_data_import VALUES (75461, '2020-09-19', 'SA', 'Saudi Arabia', 'EMRO', '576', '328720', '31', '4430');
INSERT INTO public.who_global_data_import VALUES (75462, '2020-09-20', 'SA', 'Saudi Arabia', 'EMRO', '551', '329271', '28', '4458');
INSERT INTO public.who_global_data_import VALUES (75463, '2020-09-21', 'SA', 'Saudi Arabia', 'EMRO', '483', '329754', '27', '4485');
INSERT INTO public.who_global_data_import VALUES (75464, '2020-09-22', 'SA', 'Saudi Arabia', 'EMRO', '492', '330246', '27', '4512');
INSERT INTO public.who_global_data_import VALUES (75465, '2020-09-23', 'SA', 'Saudi Arabia', 'EMRO', '552', '330798', '30', '4542');
INSERT INTO public.who_global_data_import VALUES (75466, '2020-09-24', 'SA', 'Saudi Arabia', 'EMRO', '561', '331359', '27', '4569');
INSERT INTO public.who_global_data_import VALUES (75467, '2020-09-25', 'SA', 'Saudi Arabia', 'EMRO', '498', '331857', '30', '4599');
INSERT INTO public.who_global_data_import VALUES (75468, '2020-09-26', 'SA', 'Saudi Arabia', 'EMRO', '472', '332329', '26', '4625');
INSERT INTO public.who_global_data_import VALUES (75469, '2020-09-27', 'SA', 'Saudi Arabia', 'EMRO', '461', '332790', '30', '4655');
INSERT INTO public.who_global_data_import VALUES (75470, '2020-09-28', 'SA', 'Saudi Arabia', 'EMRO', '403', '333193', '28', '4683');
INSERT INTO public.who_global_data_import VALUES (75471, '2020-09-29', 'SA', 'Saudi Arabia', 'EMRO', '455', '333648', '29', '4712');
INSERT INTO public.who_global_data_import VALUES (75472, '2020-09-30', 'SA', 'Saudi Arabia', 'EMRO', '539', '334187', '27', '4739');
INSERT INTO public.who_global_data_import VALUES (75473, '2020-10-01', 'SA', 'Saudi Arabia', 'EMRO', '418', '334605', '29', '4768');
INSERT INTO public.who_global_data_import VALUES (75474, '2020-10-02', 'SA', 'Saudi Arabia', 'EMRO', '492', '335097', '26', '4794');
INSERT INTO public.who_global_data_import VALUES (75475, '2020-10-03', 'SA', 'Saudi Arabia', 'EMRO', '481', '335578', '29', '4823');
INSERT INTO public.who_global_data_import VALUES (75476, '2020-10-04', 'SA', 'Saudi Arabia', 'EMRO', '419', '335997', '27', '4850');
INSERT INTO public.who_global_data_import VALUES (75477, '2020-10-05', 'SA', 'Saudi Arabia', 'EMRO', '390', '336387', '25', '4875');
INSERT INTO public.who_global_data_import VALUES (75478, '2020-10-06', 'SA', 'Saudi Arabia', 'EMRO', '379', '336766', '23', '4898');
INSERT INTO public.who_global_data_import VALUES (75479, '2020-10-07', 'SA', 'Saudi Arabia', 'EMRO', '477', '337243', '25', '4923');
INSERT INTO public.who_global_data_import VALUES (75480, '2020-10-08', 'SA', 'Saudi Arabia', 'EMRO', '468', '337711', '24', '4947');
INSERT INTO public.who_global_data_import VALUES (75481, '2020-10-09', 'SA', 'Saudi Arabia', 'EMRO', '421', '338132', '25', '4972');
INSERT INTO public.who_global_data_import VALUES (75482, '2020-10-10', 'SA', 'Saudi Arabia', 'EMRO', '407', '338539', '24', '4996');
INSERT INTO public.who_global_data_import VALUES (75483, '2020-10-11', 'SA', 'Saudi Arabia', 'EMRO', '405', '338944', '22', '5018');
INSERT INTO public.who_global_data_import VALUES (75484, '2020-10-12', 'SA', 'Saudi Arabia', 'EMRO', '323', '339267', '25', '5043');
INSERT INTO public.who_global_data_import VALUES (75485, '2020-10-13', 'SA', 'Saudi Arabia', 'EMRO', '348', '339615', '25', '5068');
INSERT INTO public.who_global_data_import VALUES (75486, '2020-10-14', 'SA', 'Saudi Arabia', 'EMRO', '474', '340089', '19', '5087');
INSERT INTO public.who_global_data_import VALUES (75487, '2020-10-15', 'SA', 'Saudi Arabia', 'EMRO', '501', '340590', '21', '5108');
INSERT INTO public.who_global_data_import VALUES (75488, '2020-10-16', 'SA', 'Saudi Arabia', 'EMRO', '472', '341062', '19', '5127');
INSERT INTO public.who_global_data_import VALUES (75489, '2020-10-17', 'SA', 'Saudi Arabia', 'EMRO', '433', '341495', '17', '5144');
INSERT INTO public.who_global_data_import VALUES (75490, '2020-10-18', 'SA', 'Saudi Arabia', 'EMRO', '359', '341854', '21', '5165');
INSERT INTO public.who_global_data_import VALUES (75491, '2020-10-19', 'SA', 'Saudi Arabia', 'EMRO', '348', '342202', '20', '5185');
INSERT INTO public.who_global_data_import VALUES (75492, '2020-10-20', 'SA', 'Saudi Arabia', 'EMRO', '381', '342583', '16', '5201');
INSERT INTO public.who_global_data_import VALUES (75493, '2020-10-21', 'SA', 'Saudi Arabia', 'EMRO', '385', '342968', '16', '5217');
INSERT INTO public.who_global_data_import VALUES (75494, '2020-10-22', 'SA', 'Saudi Arabia', 'EMRO', '405', '343373', '18', '5235');
INSERT INTO public.who_global_data_import VALUES (75495, '2020-10-23', 'SA', 'Saudi Arabia', 'EMRO', '401', '343774', '15', '5250');
INSERT INTO public.who_global_data_import VALUES (75496, '2020-10-24', 'SA', 'Saudi Arabia', 'EMRO', '383', '344157', '14', '5264');
INSERT INTO public.who_global_data_import VALUES (75497, '2020-10-25', 'SA', 'Saudi Arabia', 'EMRO', '395', '344552', '17', '5281');
INSERT INTO public.who_global_data_import VALUES (75498, '2020-10-26', 'SA', 'Saudi Arabia', 'EMRO', '323', '344875', '15', '5296');
INSERT INTO public.who_global_data_import VALUES (75499, '2020-10-27', 'SA', 'Saudi Arabia', 'EMRO', '357', '345232', '17', '5313');
INSERT INTO public.who_global_data_import VALUES (75500, '2020-10-28', 'SA', 'Saudi Arabia', 'EMRO', '399', '345631', '16', '5329');
INSERT INTO public.who_global_data_import VALUES (75501, '2020-10-29', 'SA', 'Saudi Arabia', 'EMRO', '416', '346047', '19', '5348');
INSERT INTO public.who_global_data_import VALUES (75502, '2020-10-30', 'SA', 'Saudi Arabia', 'EMRO', '435', '346482', '15', '5363');
INSERT INTO public.who_global_data_import VALUES (75503, '2020-10-31', 'SA', 'Saudi Arabia', 'EMRO', '398', '346880', '20', '5383');
INSERT INTO public.who_global_data_import VALUES (75504, '2020-11-01', 'SA', 'Saudi Arabia', 'EMRO', '402', '347282', '19', '5402');
INSERT INTO public.who_global_data_import VALUES (75505, '2020-11-02', 'SA', 'Saudi Arabia', 'EMRO', '374', '347656', '18', '5420');
INSERT INTO public.who_global_data_import VALUES (75506, '2020-11-03', 'SA', 'Saudi Arabia', 'EMRO', '381', '348037', '17', '5437');
INSERT INTO public.who_global_data_import VALUES (75507, '2020-11-04', 'SA', 'Saudi Arabia', 'EMRO', '473', '348510', '19', '5456');
INSERT INTO public.who_global_data_import VALUES (75508, '2020-11-05', 'SA', 'Saudi Arabia', 'EMRO', '426', '348936', '15', '5471');
INSERT INTO public.who_global_data_import VALUES (75509, '2020-11-06', 'SA', 'Saudi Arabia', 'EMRO', '450', '349386', '18', '5489');
INSERT INTO public.who_global_data_import VALUES (75510, '2020-11-07', 'SA', 'Saudi Arabia', 'EMRO', '436', '349822', '17', '5506');
INSERT INTO public.who_global_data_import VALUES (75511, '2020-11-08', 'SA', 'Saudi Arabia', 'EMRO', '407', '350229', '19', '5525');
INSERT INTO public.who_global_data_import VALUES (75512, '2020-11-09', 'SA', 'Saudi Arabia', 'EMRO', '363', '350592', '15', '5540');
INSERT INTO public.who_global_data_import VALUES (75513, '2020-11-10', 'SA', 'Saudi Arabia', 'EMRO', '392', '350984', '19', '5559');
INSERT INTO public.who_global_data_import VALUES (75514, '2020-11-11', 'SA', 'Saudi Arabia', 'EMRO', '471', '351455', '17', '5576');
INSERT INTO public.who_global_data_import VALUES (75515, '2020-11-12', 'SA', 'Saudi Arabia', 'EMRO', '394', '351849', '14', '5590');
INSERT INTO public.who_global_data_import VALUES (75516, '2020-11-13', 'SA', 'Saudi Arabia', 'EMRO', '311', '352160', '15', '5605');
INSERT INTO public.who_global_data_import VALUES (75517, '2020-11-14', 'SA', 'Saudi Arabia', 'EMRO', '441', '352601', '20', '5625');
INSERT INTO public.who_global_data_import VALUES (75518, '2020-11-15', 'SA', 'Saudi Arabia', 'EMRO', '349', '352950', '16', '5641');
INSERT INTO public.who_global_data_import VALUES (75519, '2020-11-16', 'SA', 'Saudi Arabia', 'EMRO', '305', '353255', '16', '5657');
INSERT INTO public.who_global_data_import VALUES (75520, '2020-11-17', 'SA', 'Saudi Arabia', 'EMRO', '301', '353556', '19', '5676');
INSERT INTO public.who_global_data_import VALUES (75521, '2020-11-18', 'SA', 'Saudi Arabia', 'EMRO', '362', '353918', '16', '5692');
INSERT INTO public.who_global_data_import VALUES (75522, '2020-11-19', 'SA', 'Saudi Arabia', 'EMRO', '290', '354208', '18', '5710');
INSERT INTO public.who_global_data_import VALUES (75523, '2020-11-20', 'SA', 'Saudi Arabia', 'EMRO', '319', '354527', '19', '5729');
INSERT INTO public.who_global_data_import VALUES (75524, '2020-11-21', 'SA', 'Saudi Arabia', 'EMRO', '286', '354813', '16', '5745');
INSERT INTO public.who_global_data_import VALUES (75525, '2020-11-22', 'SA', 'Saudi Arabia', 'EMRO', '221', '355034', '16', '5761');
INSERT INTO public.who_global_data_import VALUES (75526, '2020-11-23', 'SA', 'Saudi Arabia', 'EMRO', '224', '355258', '19', '5780');
INSERT INTO public.who_global_data_import VALUES (75527, '2020-11-24', 'SA', 'Saudi Arabia', 'EMRO', '231', '355489', '16', '5796');
INSERT INTO public.who_global_data_import VALUES (75528, '2020-11-25', 'SA', 'Saudi Arabia', 'EMRO', '252', '355741', '15', '5811');
INSERT INTO public.who_global_data_import VALUES (75529, '2020-11-26', 'SA', 'Saudi Arabia', 'EMRO', '326', '356067', '14', '5825');
INSERT INTO public.who_global_data_import VALUES (75530, '2020-11-27', 'SA', 'Saudi Arabia', 'EMRO', '322', '356389', '15', '5840');
INSERT INTO public.who_global_data_import VALUES (75531, '2020-11-28', 'SA', 'Saudi Arabia', 'EMRO', '302', '356691', '17', '5857');
INSERT INTO public.who_global_data_import VALUES (75532, '2020-11-29', 'SA', 'Saudi Arabia', 'EMRO', '220', '356911', '13', '5870');
INSERT INTO public.who_global_data_import VALUES (75533, '2020-11-30', 'SA', 'Saudi Arabia', 'EMRO', '217', '357128', '14', '5884');
INSERT INTO public.who_global_data_import VALUES (75534, '2020-12-01', 'SA', 'Saudi Arabia', 'EMRO', '232', '357360', '12', '5896');
INSERT INTO public.who_global_data_import VALUES (75535, '2020-12-02', 'SA', 'Saudi Arabia', 'EMRO', '263', '357623', '11', '5907');
INSERT INTO public.who_global_data_import VALUES (75536, '2020-12-03', 'SA', 'Saudi Arabia', 'EMRO', '249', '357872', '12', '5919');
INSERT INTO public.who_global_data_import VALUES (75537, '2020-12-04', 'SA', 'Saudi Arabia', 'EMRO', '230', '358102', '11', '5930');
INSERT INTO public.who_global_data_import VALUES (75538, '2020-12-05', 'SA', 'Saudi Arabia', 'EMRO', '234', '358336', '10', '5940');
INSERT INTO public.who_global_data_import VALUES (75539, '2020-12-06', 'SA', 'Saudi Arabia', 'EMRO', '190', '358526', '14', '5954');
INSERT INTO public.who_global_data_import VALUES (75540, '2020-12-07', 'SA', 'Saudi Arabia', 'EMRO', '187', '358713', '11', '5965');
INSERT INTO public.who_global_data_import VALUES (75541, '2020-12-08', 'SA', 'Saudi Arabia', 'EMRO', '209', '358922', '12', '5977');
INSERT INTO public.who_global_data_import VALUES (75542, '2020-12-09', 'SA', 'Saudi Arabia', 'EMRO', '193', '359115', '12', '5989');
INSERT INTO public.who_global_data_import VALUES (75543, '2020-12-10', 'SA', 'Saudi Arabia', 'EMRO', '159', '359274', '13', '6002');
INSERT INTO public.who_global_data_import VALUES (75544, '2020-12-11', 'SA', 'Saudi Arabia', 'EMRO', '141', '359415', '10', '6012');
INSERT INTO public.who_global_data_import VALUES (75545, '2020-12-12', 'SA', 'Saudi Arabia', 'EMRO', '168', '359583', '11', '6023');
INSERT INTO public.who_global_data_import VALUES (75546, '2020-12-13', 'SA', 'Saudi Arabia', 'EMRO', '166', '359749', '13', '6036');
INSERT INTO public.who_global_data_import VALUES (75547, '2020-12-14', 'SA', 'Saudi Arabia', 'EMRO', '139', '359888', '12', '6048');
INSERT INTO public.who_global_data_import VALUES (75548, '2020-12-15', 'SA', 'Saudi Arabia', 'EMRO', '125', '360013', '11', '6059');
INSERT INTO public.who_global_data_import VALUES (75549, '2020-12-16', 'SA', 'Saudi Arabia', 'EMRO', '142', '360155', '10', '6069');
INSERT INTO public.who_global_data_import VALUES (75550, '2020-12-17', 'SA', 'Saudi Arabia', 'EMRO', '180', '360335', '11', '6080');
INSERT INTO public.who_global_data_import VALUES (75551, '2020-12-18', 'SA', 'Saudi Arabia', 'EMRO', '181', '360516', '11', '6091');
INSERT INTO public.who_global_data_import VALUES (75552, '2020-12-19', 'SA', 'Saudi Arabia', 'EMRO', '174', '360690', '10', '6101');
INSERT INTO public.who_global_data_import VALUES (75553, '2020-12-20', 'SA', 'Saudi Arabia', 'EMRO', '158', '360848', '11', '6112');
INSERT INTO public.who_global_data_import VALUES (75554, '2020-12-21', 'SA', 'Saudi Arabia', 'EMRO', '162', '361010', '10', '6122');
INSERT INTO public.who_global_data_import VALUES (75555, '2020-12-22', 'SA', 'Saudi Arabia', 'EMRO', '168', '361178', '9', '6131');
INSERT INTO public.who_global_data_import VALUES (75556, '2020-12-23', 'SA', 'Saudi Arabia', 'EMRO', '181', '361359', '8', '6139');
INSERT INTO public.who_global_data_import VALUES (75557, '2020-12-24', 'SA', 'Saudi Arabia', 'EMRO', '177', '361536', '9', '6148');
INSERT INTO public.who_global_data_import VALUES (75558, '2020-12-25', 'SA', 'Saudi Arabia', 'EMRO', '189', '361725', '11', '6159');
INSERT INTO public.who_global_data_import VALUES (75559, '2020-12-26', 'SA', 'Saudi Arabia', 'EMRO', '178', '361903', '9', '6168');
INSERT INTO public.who_global_data_import VALUES (75560, '2020-12-27', 'SA', 'Saudi Arabia', 'EMRO', '163', '362066', '8', '6176');
INSERT INTO public.who_global_data_import VALUES (75561, '2020-12-28', 'SA', 'Saudi Arabia', 'EMRO', '154', '362220', '9', '6185');
INSERT INTO public.who_global_data_import VALUES (75562, '2020-12-29', 'SA', 'Saudi Arabia', 'EMRO', '119', '362339', '11', '6196');
INSERT INTO public.who_global_data_import VALUES (75563, '2020-12-30', 'SA', 'Saudi Arabia', 'EMRO', '149', '362488', '8', '6204');
INSERT INTO public.who_global_data_import VALUES (75564, '2020-12-31', 'SA', 'Saudi Arabia', 'EMRO', '113', '362601', '10', '6214');
INSERT INTO public.who_global_data_import VALUES (75565, '2021-01-01', 'SA', 'Saudi Arabia', 'EMRO', '140', '362741', '9', '6223');
INSERT INTO public.who_global_data_import VALUES (75566, '2021-01-02', 'SA', 'Saudi Arabia', 'EMRO', '137', '362878', '7', '6230');
INSERT INTO public.who_global_data_import VALUES (75567, '2021-01-03', 'SA', 'Saudi Arabia', 'EMRO', '101', '362979', '9', '6239');
INSERT INTO public.who_global_data_import VALUES (75568, '2021-01-04', 'SA', 'Saudi Arabia', 'EMRO', '82', '363061', '7', '6246');
INSERT INTO public.who_global_data_import VALUES (75569, '2021-01-05', 'SA', 'Saudi Arabia', 'EMRO', '94', '363155', '10', '6256');
INSERT INTO public.who_global_data_import VALUES (75570, '2021-01-06', 'SA', 'Saudi Arabia', 'EMRO', '104', '363259', '9', '6265');
INSERT INTO public.who_global_data_import VALUES (75571, '2021-01-07', 'SA', 'Saudi Arabia', 'EMRO', '118', '363377', '7', '6272');
INSERT INTO public.who_global_data_import VALUES (75572, '2021-01-08', 'SA', 'Saudi Arabia', 'EMRO', '108', '363485', '6', '6278');
INSERT INTO public.who_global_data_import VALUES (75573, '2021-01-09', 'SA', 'Saudi Arabia', 'EMRO', '97', '363582', '4', '6282');
INSERT INTO public.who_global_data_import VALUES (75574, '2021-01-10', 'SA', 'Saudi Arabia', 'EMRO', '110', '363692', '4', '6286');
INSERT INTO public.who_global_data_import VALUES (75575, '2021-01-11', 'SA', 'Saudi Arabia', 'EMRO', '117', '363809', '5', '6291');
INSERT INTO public.who_global_data_import VALUES (75576, '2021-01-12', 'SA', 'Saudi Arabia', 'EMRO', '140', '363949', '4', '6295');
INSERT INTO public.who_global_data_import VALUES (75577, '2021-01-13', 'SA', 'Saudi Arabia', 'EMRO', '147', '364096', '5', '6300');
INSERT INTO public.who_global_data_import VALUES (75578, '2021-01-14', 'SA', 'Saudi Arabia', 'EMRO', '175', '364271', '4', '6304');
INSERT INTO public.who_global_data_import VALUES (75579, '2021-01-15', 'SA', 'Saudi Arabia', 'EMRO', '169', '364440', '6', '6310');
INSERT INTO public.who_global_data_import VALUES (75580, '2021-01-16', 'SA', 'Saudi Arabia', 'EMRO', '173', '364613', '3', '6313');
INSERT INTO public.who_global_data_import VALUES (75581, '2021-01-17', 'SA', 'Saudi Arabia', 'EMRO', '140', '364753', '5', '6318');
INSERT INTO public.who_global_data_import VALUES (75582, '2021-01-18', 'SA', 'Saudi Arabia', 'EMRO', '176', '364929', '5', '6323');
INSERT INTO public.who_global_data_import VALUES (75583, '2021-01-19', 'SA', 'Saudi Arabia', 'EMRO', '170', '365099', '6', '6329');
INSERT INTO public.who_global_data_import VALUES (75584, '2021-01-20', 'SA', 'Saudi Arabia', 'EMRO', '226', '365325', '6', '6335');
INSERT INTO public.who_global_data_import VALUES (75585, '2021-01-21', 'SA', 'Saudi Arabia', 'EMRO', '238', '365563', '3', '6338');
INSERT INTO public.who_global_data_import VALUES (75586, '2021-01-22', 'SA', 'Saudi Arabia', 'EMRO', '212', '365775', '4', '6342');
INSERT INTO public.who_global_data_import VALUES (75587, '2021-01-23', 'SA', 'Saudi Arabia', 'EMRO', '213', '365988', '4', '6346');
INSERT INTO public.who_global_data_import VALUES (75588, '2021-01-24', 'SA', 'Saudi Arabia', 'EMRO', '197', '366185', '4', '6350');
INSERT INTO public.who_global_data_import VALUES (75589, '2021-01-25', 'SA', 'Saudi Arabia', 'EMRO', '186', '366371', '2', '6352');
INSERT INTO public.who_global_data_import VALUES (75590, '2021-01-26', 'SA', 'Saudi Arabia', 'EMRO', '213', '366584', '3', '6355');
INSERT INTO public.who_global_data_import VALUES (75591, '2021-01-27', 'SA', 'Saudi Arabia', 'EMRO', '223', '366807', '4', '6359');
INSERT INTO public.who_global_data_import VALUES (75592, '2021-01-28', 'SA', 'Saudi Arabia', 'EMRO', '216', '367023', '4', '6363');
INSERT INTO public.who_global_data_import VALUES (75593, '2021-01-29', 'SA', 'Saudi Arabia', 'EMRO', '253', '367276', '3', '6366');
INSERT INTO public.who_global_data_import VALUES (75594, '2021-01-30', 'SA', 'Saudi Arabia', 'EMRO', '267', '367543', '2', '6368');
INSERT INTO public.who_global_data_import VALUES (75595, '2021-01-31', 'SA', 'Saudi Arabia', 'EMRO', '270', '367813', '4', '6372');
INSERT INTO public.who_global_data_import VALUES (75596, '2021-02-01', 'SA', 'Saudi Arabia', 'EMRO', '261', '368074', '3', '6375');
INSERT INTO public.who_global_data_import VALUES (75597, '2021-02-02', 'SA', 'Saudi Arabia', 'EMRO', '255', '368329', '4', '6379');
INSERT INTO public.who_global_data_import VALUES (75598, '2021-02-03', 'SA', 'Saudi Arabia', 'EMRO', '310', '368639', '4', '6383');
INSERT INTO public.who_global_data_import VALUES (75599, '2021-02-04', 'SA', 'Saudi Arabia', 'EMRO', '306', '368945', '3', '6386');
INSERT INTO public.who_global_data_import VALUES (75600, '2021-02-05', 'SA', 'Saudi Arabia', 'EMRO', '303', '369248', '3', '6389');
INSERT INTO public.who_global_data_import VALUES (75601, '2020-01-03', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75602, '2020-01-04', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75603, '2020-01-05', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75604, '2020-01-06', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75605, '2020-01-07', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75606, '2020-01-08', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75607, '2020-01-09', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75608, '2020-01-10', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75609, '2020-01-11', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75610, '2020-01-12', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75611, '2020-01-13', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75612, '2020-01-14', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75613, '2020-01-15', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75614, '2020-01-16', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75615, '2020-01-17', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75616, '2020-01-18', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75617, '2020-01-19', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75618, '2020-01-20', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75619, '2020-01-21', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75620, '2020-01-22', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75621, '2020-01-23', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75622, '2020-01-24', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75623, '2020-01-25', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75624, '2020-01-26', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75625, '2020-01-27', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75626, '2020-01-28', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75627, '2020-01-29', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75628, '2020-01-30', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75629, '2020-01-31', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75630, '2020-02-01', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75631, '2020-02-02', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75632, '2020-02-03', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75633, '2020-02-04', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75634, '2020-02-05', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75635, '2020-02-06', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75636, '2020-02-07', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75637, '2020-02-08', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75638, '2020-02-09', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75639, '2020-02-10', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75640, '2020-02-11', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75641, '2020-02-12', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75642, '2020-02-13', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75643, '2020-02-14', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75644, '2020-02-15', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75645, '2020-02-16', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75646, '2020-02-17', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75647, '2020-02-18', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75648, '2020-02-19', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75649, '2020-02-20', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75650, '2020-02-21', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75651, '2020-02-22', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75652, '2020-02-23', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75653, '2020-02-24', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75654, '2020-02-25', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75655, '2020-02-26', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75656, '2020-02-27', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75657, '2020-02-28', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75658, '2020-02-29', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75659, '2020-03-01', 'SN', 'Senegal', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75660, '2020-03-02', 'SN', 'Senegal', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75661, '2020-03-03', 'SN', 'Senegal', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75662, '2020-03-04', 'SN', 'Senegal', 'AFRO', '3', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75663, '2020-03-05', 'SN', 'Senegal', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75664, '2020-03-06', 'SN', 'Senegal', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75665, '2020-03-07', 'SN', 'Senegal', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75666, '2020-03-08', 'SN', 'Senegal', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75667, '2020-03-09', 'SN', 'Senegal', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75668, '2020-03-10', 'SN', 'Senegal', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75669, '2020-03-11', 'SN', 'Senegal', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75670, '2020-03-12', 'SN', 'Senegal', 'AFRO', '6', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75671, '2020-03-13', 'SN', 'Senegal', 'AFRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75672, '2020-03-14', 'SN', 'Senegal', 'AFRO', '11', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75673, '2020-03-15', 'SN', 'Senegal', 'AFRO', '5', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75674, '2020-03-16', 'SN', 'Senegal', 'AFRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75675, '2020-03-17', 'SN', 'Senegal', 'AFRO', '1', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75676, '2020-03-18', 'SN', 'Senegal', 'AFRO', '9', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75677, '2020-03-19', 'SN', 'Senegal', 'AFRO', '2', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75678, '2020-03-20', 'SN', 'Senegal', 'AFRO', '0', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75679, '2020-03-21', 'SN', 'Senegal', 'AFRO', '14', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75680, '2020-03-22', 'SN', 'Senegal', 'AFRO', '0', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75681, '2020-03-23', 'SN', 'Senegal', 'AFRO', '11', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75682, '2020-03-24', 'SN', 'Senegal', 'AFRO', '12', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75683, '2020-03-25', 'SN', 'Senegal', 'AFRO', '7', '86', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75684, '2020-03-26', 'SN', 'Senegal', 'AFRO', '13', '99', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75685, '2020-03-27', 'SN', 'Senegal', 'AFRO', '6', '105', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75686, '2020-03-28', 'SN', 'Senegal', 'AFRO', '14', '119', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75687, '2020-03-29', 'SN', 'Senegal', 'AFRO', '11', '130', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75688, '2020-03-30', 'SN', 'Senegal', 'AFRO', '12', '142', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75689, '2020-03-31', 'SN', 'Senegal', 'AFRO', '20', '162', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75690, '2020-04-01', 'SN', 'Senegal', 'AFRO', '13', '175', '0', '0');
INSERT INTO public.who_global_data_import VALUES (75691, '2020-04-02', 'SN', 'Senegal', 'AFRO', '15', '190', '1', '1');
INSERT INTO public.who_global_data_import VALUES (75692, '2020-04-03', 'SN', 'Senegal', 'AFRO', '5', '195', '0', '1');
INSERT INTO public.who_global_data_import VALUES (75693, '2020-04-04', 'SN', 'Senegal', 'AFRO', '24', '219', '1', '2');
INSERT INTO public.who_global_data_import VALUES (75694, '2020-04-05', 'SN', 'Senegal', 'AFRO', '0', '219', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75695, '2020-04-06', 'SN', 'Senegal', 'AFRO', '7', '226', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75696, '2020-04-07', 'SN', 'Senegal', 'AFRO', '0', '226', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75697, '2020-04-08', 'SN', 'Senegal', 'AFRO', '11', '237', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75698, '2020-04-09', 'SN', 'Senegal', 'AFRO', '7', '244', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75699, '2020-04-10', 'SN', 'Senegal', 'AFRO', '6', '250', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75700, '2020-04-11', 'SN', 'Senegal', 'AFRO', '15', '265', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75701, '2020-04-12', 'SN', 'Senegal', 'AFRO', '13', '278', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75702, '2020-04-13', 'SN', 'Senegal', 'AFRO', '2', '280', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75703, '2020-04-14', 'SN', 'Senegal', 'AFRO', '11', '291', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75704, '2020-04-15', 'SN', 'Senegal', 'AFRO', '8', '299', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75705, '2020-04-16', 'SN', 'Senegal', 'AFRO', '15', '314', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75706, '2020-04-17', 'SN', 'Senegal', 'AFRO', '21', '335', '0', '2');
INSERT INTO public.who_global_data_import VALUES (75707, '2020-04-18', 'SN', 'Senegal', 'AFRO', '7', '342', '1', '3');
INSERT INTO public.who_global_data_import VALUES (75708, '2020-04-19', 'SN', 'Senegal', 'AFRO', '8', '350', '0', '3');
INSERT INTO public.who_global_data_import VALUES (75709, '2020-04-20', 'SN', 'Senegal', 'AFRO', '17', '367', '0', '3');
INSERT INTO public.who_global_data_import VALUES (75710, '2020-04-21', 'SN', 'Senegal', 'AFRO', '10', '377', '2', '5');
INSERT INTO public.who_global_data_import VALUES (75711, '2020-04-22', 'SN', 'Senegal', 'AFRO', '35', '412', '0', '5');
INSERT INTO public.who_global_data_import VALUES (75712, '2020-04-23', 'SN', 'Senegal', 'AFRO', '30', '442', '1', '6');
INSERT INTO public.who_global_data_import VALUES (75713, '2020-04-24', 'SN', 'Senegal', 'AFRO', '37', '479', '0', '6');
INSERT INTO public.who_global_data_import VALUES (75714, '2020-04-25', 'SN', 'Senegal', 'AFRO', '66', '545', '1', '7');
INSERT INTO public.who_global_data_import VALUES (75715, '2020-04-26', 'SN', 'Senegal', 'AFRO', '69', '614', '0', '7');
INSERT INTO public.who_global_data_import VALUES (75716, '2020-04-27', 'SN', 'Senegal', 'AFRO', '57', '671', '2', '9');
INSERT INTO public.who_global_data_import VALUES (75717, '2020-04-28', 'SN', 'Senegal', 'AFRO', '64', '735', '0', '9');
INSERT INTO public.who_global_data_import VALUES (75718, '2020-04-29', 'SN', 'Senegal', 'AFRO', '88', '823', '0', '9');
INSERT INTO public.who_global_data_import VALUES (75719, '2020-04-30', 'SN', 'Senegal', 'AFRO', '59', '882', '0', '9');
INSERT INTO public.who_global_data_import VALUES (75720, '2020-05-01', 'SN', 'Senegal', 'AFRO', '51', '933', '0', '9');
INSERT INTO public.who_global_data_import VALUES (75721, '2020-05-02', 'SN', 'Senegal', 'AFRO', '91', '1024', '0', '9');
INSERT INTO public.who_global_data_import VALUES (75722, '2020-05-03', 'SN', 'Senegal', 'AFRO', '89', '1113', '0', '9');
INSERT INTO public.who_global_data_import VALUES (75723, '2020-05-04', 'SN', 'Senegal', 'AFRO', '158', '1271', '0', '9');
INSERT INTO public.who_global_data_import VALUES (75724, '2020-05-05', 'SN', 'Senegal', 'AFRO', '0', '1271', '1', '10');
INSERT INTO public.who_global_data_import VALUES (75725, '2020-05-06', 'SN', 'Senegal', 'AFRO', '58', '1329', '1', '11');
INSERT INTO public.who_global_data_import VALUES (75726, '2020-05-07', 'SN', 'Senegal', 'AFRO', '104', '1433', '1', '12');
INSERT INTO public.who_global_data_import VALUES (75727, '2020-05-08', 'SN', 'Senegal', 'AFRO', '59', '1492', '1', '13');
INSERT INTO public.who_global_data_import VALUES (75728, '2020-05-09', 'SN', 'Senegal', 'AFRO', '59', '1551', '0', '13');
INSERT INTO public.who_global_data_import VALUES (75729, '2020-05-10', 'SN', 'Senegal', 'AFRO', '83', '1634', '4', '17');
INSERT INTO public.who_global_data_import VALUES (75730, '2020-05-11', 'SN', 'Senegal', 'AFRO', '75', '1709', '2', '19');
INSERT INTO public.who_global_data_import VALUES (75731, '2020-05-12', 'SN', 'Senegal', 'AFRO', '177', '1886', '0', '19');
INSERT INTO public.who_global_data_import VALUES (75732, '2020-05-13', 'SN', 'Senegal', 'AFRO', '109', '1995', '0', '19');
INSERT INTO public.who_global_data_import VALUES (75733, '2020-05-14', 'SN', 'Senegal', 'AFRO', '110', '2105', '3', '22');
INSERT INTO public.who_global_data_import VALUES (75734, '2020-05-15', 'SN', 'Senegal', 'AFRO', '84', '2189', '1', '23');
INSERT INTO public.who_global_data_import VALUES (75735, '2020-05-16', 'SN', 'Senegal', 'AFRO', '121', '2310', '0', '23');
INSERT INTO public.who_global_data_import VALUES (75736, '2020-05-17', 'SN', 'Senegal', 'AFRO', '119', '2429', '2', '25');
INSERT INTO public.who_global_data_import VALUES (75737, '2020-05-18', 'SN', 'Senegal', 'AFRO', '51', '2480', '0', '25');
INSERT INTO public.who_global_data_import VALUES (75738, '2020-05-19', 'SN', 'Senegal', 'AFRO', '64', '2544', '1', '26');
INSERT INTO public.who_global_data_import VALUES (75739, '2020-05-20', 'SN', 'Senegal', 'AFRO', '73', '2617', '4', '30');
INSERT INTO public.who_global_data_import VALUES (75740, '2020-05-21', 'SN', 'Senegal', 'AFRO', '97', '2714', '0', '30');
INSERT INTO public.who_global_data_import VALUES (75741, '2020-05-22', 'SN', 'Senegal', 'AFRO', '101', '2815', '3', '33');
INSERT INTO public.who_global_data_import VALUES (75742, '2020-05-23', 'SN', 'Senegal', 'AFRO', '94', '2909', '0', '33');
INSERT INTO public.who_global_data_import VALUES (75743, '2020-05-24', 'SN', 'Senegal', 'AFRO', '67', '2976', '1', '34');
INSERT INTO public.who_global_data_import VALUES (75744, '2020-05-25', 'SN', 'Senegal', 'AFRO', '71', '3047', '1', '35');
INSERT INTO public.who_global_data_import VALUES (75745, '2020-05-26', 'SN', 'Senegal', 'AFRO', '83', '3130', '0', '35');
INSERT INTO public.who_global_data_import VALUES (75746, '2020-05-27', 'SN', 'Senegal', 'AFRO', '31', '3161', '2', '37');
INSERT INTO public.who_global_data_import VALUES (75747, '2020-05-28', 'SN', 'Senegal', 'AFRO', '92', '3253', '2', '39');
INSERT INTO public.who_global_data_import VALUES (75748, '2020-05-29', 'SN', 'Senegal', 'AFRO', '95', '3348', '2', '41');
INSERT INTO public.who_global_data_import VALUES (75749, '2020-05-30', 'SN', 'Senegal', 'AFRO', '81', '3429', '0', '41');
INSERT INTO public.who_global_data_import VALUES (75750, '2020-05-31', 'SN', 'Senegal', 'AFRO', '106', '3535', '1', '42');
INSERT INTO public.who_global_data_import VALUES (75751, '2020-06-01', 'SN', 'Senegal', 'AFRO', '110', '3645', '0', '42');
INSERT INTO public.who_global_data_import VALUES (75752, '2020-06-02', 'SN', 'Senegal', 'AFRO', '94', '3739', '0', '42');
INSERT INTO public.who_global_data_import VALUES (75753, '2020-06-03', 'SN', 'Senegal', 'AFRO', '97', '3836', '1', '43');
INSERT INTO public.who_global_data_import VALUES (75754, '2020-06-04', 'SN', 'Senegal', 'AFRO', '96', '3932', '2', '45');
INSERT INTO public.who_global_data_import VALUES (75755, '2020-06-05', 'SN', 'Senegal', 'AFRO', '89', '4021', '0', '45');
INSERT INTO public.who_global_data_import VALUES (75756, '2020-06-06', 'SN', 'Senegal', 'AFRO', '134', '4155', '0', '45');
INSERT INTO public.who_global_data_import VALUES (75757, '2020-06-07', 'SN', 'Senegal', 'AFRO', '94', '4249', '2', '47');
INSERT INTO public.who_global_data_import VALUES (75758, '2020-06-08', 'SN', 'Senegal', 'AFRO', '79', '4328', '2', '49');
INSERT INTO public.who_global_data_import VALUES (75759, '2020-06-09', 'SN', 'Senegal', 'AFRO', '102', '4430', '0', '49');
INSERT INTO public.who_global_data_import VALUES (75760, '2020-06-10', 'SN', 'Senegal', 'AFRO', '86', '4516', '3', '52');
INSERT INTO public.who_global_data_import VALUES (75761, '2020-06-11', 'SN', 'Senegal', 'AFRO', '124', '4640', '2', '54');
INSERT INTO public.who_global_data_import VALUES (75762, '2020-06-12', 'SN', 'Senegal', 'AFRO', '119', '4759', '1', '55');
INSERT INTO public.who_global_data_import VALUES (75763, '2020-06-13', 'SN', 'Senegal', 'AFRO', '92', '4851', '1', '56');
INSERT INTO public.who_global_data_import VALUES (75764, '2020-06-14', 'SN', 'Senegal', 'AFRO', '145', '4996', '4', '60');
INSERT INTO public.who_global_data_import VALUES (75765, '2020-06-15', 'SN', 'Senegal', 'AFRO', '94', '5090', '0', '60');
INSERT INTO public.who_global_data_import VALUES (75766, '2020-06-16', 'SN', 'Senegal', 'AFRO', '0', '5090', '0', '60');
INSERT INTO public.who_global_data_import VALUES (75767, '2020-06-17', 'SN', 'Senegal', 'AFRO', '157', '5247', '10', '70');
INSERT INTO public.who_global_data_import VALUES (75768, '2020-06-18', 'SN', 'Senegal', 'AFRO', '122', '5369', '3', '73');
INSERT INTO public.who_global_data_import VALUES (75769, '2020-06-19', 'SN', 'Senegal', 'AFRO', '106', '5475', '3', '76');
INSERT INTO public.who_global_data_import VALUES (75770, '2020-06-20', 'SN', 'Senegal', 'AFRO', '164', '5639', '3', '79');
INSERT INTO public.who_global_data_import VALUES (75771, '2020-06-21', 'SN', 'Senegal', 'AFRO', '144', '5783', '3', '82');
INSERT INTO public.who_global_data_import VALUES (75772, '2020-06-22', 'SN', 'Senegal', 'AFRO', '105', '5888', '2', '84');
INSERT INTO public.who_global_data_import VALUES (75773, '2020-06-23', 'SN', 'Senegal', 'AFRO', '82', '5970', '2', '86');
INSERT INTO public.who_global_data_import VALUES (75774, '2020-06-24', 'SN', 'Senegal', 'AFRO', '64', '6034', '3', '89');
INSERT INTO public.who_global_data_import VALUES (75775, '2020-06-25', 'SN', 'Senegal', 'AFRO', '95', '6129', '4', '93');
INSERT INTO public.who_global_data_import VALUES (75776, '2020-06-26', 'SN', 'Senegal', 'AFRO', '104', '6233', '1', '94');
INSERT INTO public.who_global_data_import VALUES (75777, '2020-06-27', 'SN', 'Senegal', 'AFRO', '121', '6354', '4', '98');
INSERT INTO public.who_global_data_import VALUES (75778, '2020-06-28', 'SN', 'Senegal', 'AFRO', '105', '6459', '4', '102');
INSERT INTO public.who_global_data_import VALUES (75779, '2020-06-29', 'SN', 'Senegal', 'AFRO', '127', '6586', '3', '105');
INSERT INTO public.who_global_data_import VALUES (75780, '2020-06-30', 'SN', 'Senegal', 'AFRO', '112', '6698', '3', '108');
INSERT INTO public.who_global_data_import VALUES (75781, '2020-07-01', 'SN', 'Senegal', 'AFRO', '95', '6793', '4', '112');
INSERT INTO public.who_global_data_import VALUES (75782, '2020-07-02', 'SN', 'Senegal', 'AFRO', '132', '6925', '4', '116');
INSERT INTO public.who_global_data_import VALUES (75783, '2020-07-03', 'SN', 'Senegal', 'AFRO', '129', '7054', '5', '121');
INSERT INTO public.who_global_data_import VALUES (75784, '2020-07-04', 'SN', 'Senegal', 'AFRO', '110', '7164', '4', '125');
INSERT INTO public.who_global_data_import VALUES (75785, '2020-07-05', 'SN', 'Senegal', 'AFRO', '108', '7272', '4', '129');
INSERT INTO public.who_global_data_import VALUES (75786, '2020-07-06', 'SN', 'Senegal', 'AFRO', '128', '7400', '4', '133');
INSERT INTO public.who_global_data_import VALUES (75787, '2020-07-07', 'SN', 'Senegal', 'AFRO', '78', '7478', '3', '136');
INSERT INTO public.who_global_data_import VALUES (75788, '2020-07-08', 'SN', 'Senegal', 'AFRO', '69', '7547', '1', '137');
INSERT INTO public.who_global_data_import VALUES (75789, '2020-07-09', 'SN', 'Senegal', 'AFRO', '110', '7657', '4', '141');
INSERT INTO public.who_global_data_import VALUES (75790, '2020-07-10', 'SN', 'Senegal', 'AFRO', '127', '7784', '2', '143');
INSERT INTO public.who_global_data_import VALUES (75791, '2020-07-11', 'SN', 'Senegal', 'AFRO', '98', '7882', '2', '145');
INSERT INTO public.who_global_data_import VALUES (75792, '2020-07-12', 'SN', 'Senegal', 'AFRO', '132', '8014', '0', '145');
INSERT INTO public.who_global_data_import VALUES (75793, '2020-07-13', 'SN', 'Senegal', 'AFRO', '121', '8135', '3', '148');
INSERT INTO public.who_global_data_import VALUES (75794, '2020-07-14', 'SN', 'Senegal', 'AFRO', '63', '8198', '2', '150');
INSERT INTO public.who_global_data_import VALUES (75795, '2020-07-15', 'SN', 'Senegal', 'AFRO', '45', '8243', '0', '150');
INSERT INTO public.who_global_data_import VALUES (75796, '2020-07-16', 'SN', 'Senegal', 'AFRO', '126', '8369', '3', '153');
INSERT INTO public.who_global_data_import VALUES (75797, '2020-07-17', 'SN', 'Senegal', 'AFRO', '112', '8481', '3', '156');
INSERT INTO public.who_global_data_import VALUES (75798, '2020-07-18', 'SN', 'Senegal', 'AFRO', '63', '8544', '4', '160');
INSERT INTO public.who_global_data_import VALUES (75799, '2020-07-19', 'SN', 'Senegal', 'AFRO', '125', '8669', '3', '163');
INSERT INTO public.who_global_data_import VALUES (75800, '2020-07-20', 'SN', 'Senegal', 'AFRO', '141', '8810', '4', '167');
INSERT INTO public.who_global_data_import VALUES (75801, '2020-07-21', 'SN', 'Senegal', 'AFRO', '138', '8948', '3', '170');
INSERT INTO public.who_global_data_import VALUES (75802, '2020-07-22', 'SN', 'Senegal', 'AFRO', '37', '8985', '4', '174');
INSERT INTO public.who_global_data_import VALUES (75803, '2020-07-23', 'SN', 'Senegal', 'AFRO', '136', '9121', '3', '177');
INSERT INTO public.who_global_data_import VALUES (75804, '2020-07-24', 'SN', 'Senegal', 'AFRO', '145', '9266', '1', '178');
INSERT INTO public.who_global_data_import VALUES (75805, '2020-07-25', 'SN', 'Senegal', 'AFRO', '156', '9422', '4', '182');
INSERT INTO public.who_global_data_import VALUES (75806, '2020-07-26', 'SN', 'Senegal', 'AFRO', '130', '9552', '5', '187');
INSERT INTO public.who_global_data_import VALUES (75807, '2020-07-27', 'SN', 'Senegal', 'AFRO', '129', '9681', '4', '191');
INSERT INTO public.who_global_data_import VALUES (75808, '2020-07-28', 'SN', 'Senegal', 'AFRO', '83', '9764', '3', '194');
INSERT INTO public.who_global_data_import VALUES (75809, '2020-07-29', 'SN', 'Senegal', 'AFRO', '41', '9805', '4', '198');
INSERT INTO public.who_global_data_import VALUES (75810, '2020-07-30', 'SN', 'Senegal', 'AFRO', '156', '9961', '2', '200');
INSERT INTO public.who_global_data_import VALUES (75811, '2020-07-31', 'SN', 'Senegal', 'AFRO', '145', '10106', '4', '204');
INSERT INTO public.who_global_data_import VALUES (75812, '2020-08-01', 'SN', 'Senegal', 'AFRO', '126', '10232', '1', '205');
INSERT INTO public.who_global_data_import VALUES (75813, '2020-08-02', 'SN', 'Senegal', 'AFRO', '52', '10284', '4', '209');
INSERT INTO public.who_global_data_import VALUES (75814, '2020-08-03', 'SN', 'Senegal', 'AFRO', '60', '10344', '0', '209');
INSERT INTO public.who_global_data_import VALUES (75815, '2020-08-04', 'SN', 'Senegal', 'AFRO', '42', '10386', '2', '211');
INSERT INTO public.who_global_data_import VALUES (75816, '2020-08-05', 'SN', 'Senegal', 'AFRO', '46', '10432', '3', '214');
INSERT INTO public.who_global_data_import VALUES (75817, '2020-08-06', 'SN', 'Senegal', 'AFRO', '106', '10538', '4', '218');
INSERT INTO public.who_global_data_import VALUES (75818, '2020-08-07', 'SN', 'Senegal', 'AFRO', '177', '10715', '5', '223');
INSERT INTO public.who_global_data_import VALUES (75819, '2020-08-08', 'SN', 'Senegal', 'AFRO', '172', '10887', '2', '225');
INSERT INTO public.who_global_data_import VALUES (75820, '2020-08-09', 'SN', 'Senegal', 'AFRO', '116', '11003', '4', '229');
INSERT INTO public.who_global_data_import VALUES (75821, '2020-08-10', 'SN', 'Senegal', 'AFRO', '172', '11175', '3', '232');
INSERT INTO public.who_global_data_import VALUES (75822, '2020-08-11', 'SN', 'Senegal', 'AFRO', '137', '11312', '4', '236');
INSERT INTO public.who_global_data_import VALUES (75823, '2020-08-12', 'SN', 'Senegal', 'AFRO', '68', '11380', '2', '238');
INSERT INTO public.who_global_data_import VALUES (75824, '2020-08-13', 'SN', 'Senegal', 'AFRO', '207', '11587', '4', '242');
INSERT INTO public.who_global_data_import VALUES (75825, '2020-08-14', 'SN', 'Senegal', 'AFRO', '153', '11740', '2', '244');
INSERT INTO public.who_global_data_import VALUES (75826, '2020-08-15', 'SN', 'Senegal', 'AFRO', '132', '11872', '5', '249');
INSERT INTO public.who_global_data_import VALUES (75827, '2020-08-16', 'SN', 'Senegal', 'AFRO', '160', '12032', '2', '251');
INSERT INTO public.who_global_data_import VALUES (75828, '2020-08-17', 'SN', 'Senegal', 'AFRO', '130', '12162', '2', '253');
INSERT INTO public.who_global_data_import VALUES (75829, '2020-08-18', 'SN', 'Senegal', 'AFRO', '75', '12237', '3', '256');
INSERT INTO public.who_global_data_import VALUES (75830, '2020-08-19', 'SN', 'Senegal', 'AFRO', '68', '12305', '0', '256');
INSERT INTO public.who_global_data_import VALUES (75831, '2020-08-20', 'SN', 'Senegal', 'AFRO', '141', '12446', '2', '258');
INSERT INTO public.who_global_data_import VALUES (75832, '2020-08-21', 'SN', 'Senegal', 'AFRO', '113', '12559', '3', '261');
INSERT INTO public.who_global_data_import VALUES (75833, '2020-08-22', 'SN', 'Senegal', 'AFRO', '130', '12689', '1', '262');
INSERT INTO public.who_global_data_import VALUES (75834, '2020-08-23', 'SN', 'Senegal', 'AFRO', '161', '12850', '4', '266');
INSERT INTO public.who_global_data_import VALUES (75835, '2020-08-24', 'SN', 'Senegal', 'AFRO', '99', '12949', '3', '269');
INSERT INTO public.who_global_data_import VALUES (75836, '2020-08-25', 'SN', 'Senegal', 'AFRO', '64', '13013', '3', '272');
INSERT INTO public.who_global_data_import VALUES (75837, '2020-08-26', 'SN', 'Senegal', 'AFRO', '43', '13056', '2', '274');
INSERT INTO public.who_global_data_import VALUES (75838, '2020-08-27', 'SN', 'Senegal', 'AFRO', '130', '13186', '1', '275');
INSERT INTO public.who_global_data_import VALUES (75839, '2020-08-28', 'SN', 'Senegal', 'AFRO', '108', '13294', '2', '277');
INSERT INTO public.who_global_data_import VALUES (75840, '2020-08-29', 'SN', 'Senegal', 'AFRO', '90', '13384', '2', '279');
INSERT INTO public.who_global_data_import VALUES (75841, '2020-08-30', 'SN', 'Senegal', 'AFRO', '72', '13456', '3', '282');
INSERT INTO public.who_global_data_import VALUES (75842, '2020-08-31', 'SN', 'Senegal', 'AFRO', '100', '13556', '2', '284');
INSERT INTO public.who_global_data_import VALUES (75843, '2020-09-01', 'SN', 'Senegal', 'AFRO', '55', '13611', '0', '284');
INSERT INTO public.who_global_data_import VALUES (75844, '2020-09-02', 'SN', 'Senegal', 'AFRO', '44', '13655', '0', '284');
INSERT INTO public.who_global_data_import VALUES (75845, '2020-09-03', 'SN', 'Senegal', 'AFRO', '88', '13743', '3', '287');
INSERT INTO public.who_global_data_import VALUES (75846, '2020-09-04', 'SN', 'Senegal', 'AFRO', '83', '13826', '0', '287');
INSERT INTO public.who_global_data_import VALUES (75847, '2020-09-05', 'SN', 'Senegal', 'AFRO', '55', '13881', '2', '289');
INSERT INTO public.who_global_data_import VALUES (75848, '2020-09-06', 'SN', 'Senegal', 'AFRO', '0', '13881', '0', '289');
INSERT INTO public.who_global_data_import VALUES (75849, '2020-09-07', 'SN', 'Senegal', 'AFRO', '106', '13987', '1', '290');
INSERT INTO public.who_global_data_import VALUES (75850, '2020-09-08', 'SN', 'Senegal', 'AFRO', '0', '13987', '0', '290');
INSERT INTO public.who_global_data_import VALUES (75851, '2020-09-09', 'SN', 'Senegal', 'AFRO', '27', '14014', '1', '291');
INSERT INTO public.who_global_data_import VALUES (75852, '2020-09-10', 'SN', 'Senegal', 'AFRO', '88', '14102', '2', '293');
INSERT INTO public.who_global_data_import VALUES (75853, '2020-09-11', 'SN', 'Senegal', 'AFRO', '48', '14150', '0', '293');
INSERT INTO public.who_global_data_import VALUES (75854, '2020-09-12', 'SN', 'Senegal', 'AFRO', '43', '14193', '0', '293');
INSERT INTO public.who_global_data_import VALUES (75855, '2020-09-13', 'SN', 'Senegal', 'AFRO', '0', '14193', '0', '293');
INSERT INTO public.who_global_data_import VALUES (75856, '2020-09-14', 'SN', 'Senegal', 'AFRO', '0', '14193', '0', '293');
INSERT INTO public.who_global_data_import VALUES (75857, '2020-09-15', 'SN', 'Senegal', 'AFRO', '113', '14306', '4', '297');
INSERT INTO public.who_global_data_import VALUES (75858, '2020-09-16', 'SN', 'Senegal', 'AFRO', '223', '14529', '1', '298');
INSERT INTO public.who_global_data_import VALUES (75859, '2020-09-17', 'SN', 'Senegal', 'AFRO', '39', '14568', '1', '299');
INSERT INTO public.who_global_data_import VALUES (75860, '2020-09-18', 'SN', 'Senegal', 'AFRO', '50', '14618', '1', '300');
INSERT INTO public.who_global_data_import VALUES (75861, '2020-09-19', 'SN', 'Senegal', 'AFRO', '27', '14645', '1', '301');
INSERT INTO public.who_global_data_import VALUES (75862, '2020-09-20', 'SN', 'Senegal', 'AFRO', '43', '14688', '1', '302');
INSERT INTO public.who_global_data_import VALUES (75863, '2020-09-21', 'SN', 'Senegal', 'AFRO', '26', '14714', '0', '302');
INSERT INTO public.who_global_data_import VALUES (75864, '2020-09-22', 'SN', 'Senegal', 'AFRO', '24', '14738', '0', '302');
INSERT INTO public.who_global_data_import VALUES (75865, '2020-09-23', 'SN', 'Senegal', 'AFRO', '21', '14759', '0', '302');
INSERT INTO public.who_global_data_import VALUES (75866, '2020-09-24', 'SN', 'Senegal', 'AFRO', '36', '14795', '1', '303');
INSERT INTO public.who_global_data_import VALUES (75867, '2020-09-25', 'SN', 'Senegal', 'AFRO', '21', '14816', '1', '304');
INSERT INTO public.who_global_data_import VALUES (75868, '2020-09-26', 'SN', 'Senegal', 'AFRO', '0', '14816', '0', '304');
INSERT INTO public.who_global_data_import VALUES (75869, '2020-09-27', 'SN', 'Senegal', 'AFRO', '53', '14869', '2', '306');
INSERT INTO public.who_global_data_import VALUES (75870, '2020-09-28', 'SN', 'Senegal', 'AFRO', '40', '14909', '2', '308');
INSERT INTO public.who_global_data_import VALUES (75871, '2020-09-29', 'SN', 'Senegal', 'AFRO', '10', '14919', '1', '309');
INSERT INTO public.who_global_data_import VALUES (75872, '2020-09-30', 'SN', 'Senegal', 'AFRO', '0', '14919', '0', '309');
INSERT INTO public.who_global_data_import VALUES (75873, '2020-10-01', 'SN', 'Senegal', 'AFRO', '63', '14982', '2', '311');
INSERT INTO public.who_global_data_import VALUES (75874, '2020-10-02', 'SN', 'Senegal', 'AFRO', '37', '15019', '0', '311');
INSERT INTO public.who_global_data_import VALUES (75875, '2020-10-03', 'SN', 'Senegal', 'AFRO', '0', '15019', '0', '311');
INSERT INTO public.who_global_data_import VALUES (75876, '2020-10-04', 'SN', 'Senegal', 'AFRO', '32', '15051', '1', '312');
INSERT INTO public.who_global_data_import VALUES (75877, '2020-10-05', 'SN', 'Senegal', 'AFRO', '43', '15094', '0', '312');
INSERT INTO public.who_global_data_import VALUES (75878, '2020-10-06', 'SN', 'Senegal', 'AFRO', '28', '15122', '0', '312');
INSERT INTO public.who_global_data_import VALUES (75879, '2020-10-07', 'SN', 'Senegal', 'AFRO', '19', '15141', '0', '312');
INSERT INTO public.who_global_data_import VALUES (75880, '2020-10-08', 'SN', 'Senegal', 'AFRO', '0', '15141', '0', '312');
INSERT INTO public.who_global_data_import VALUES (75881, '2020-10-09', 'SN', 'Senegal', 'AFRO', '49', '15190', '1', '313');
INSERT INTO public.who_global_data_import VALUES (75882, '2020-10-10', 'SN', 'Senegal', 'AFRO', '23', '15213', '0', '313');
INSERT INTO public.who_global_data_import VALUES (75883, '2020-10-11', 'SN', 'Senegal', 'AFRO', '0', '15213', '0', '313');
INSERT INTO public.who_global_data_import VALUES (75884, '2020-10-12', 'SN', 'Senegal', 'AFRO', '0', '15213', '0', '313');
INSERT INTO public.who_global_data_import VALUES (75885, '2020-10-13', 'SN', 'Senegal', 'AFRO', '79', '15292', '2', '315');
INSERT INTO public.who_global_data_import VALUES (75886, '2020-10-14', 'SN', 'Senegal', 'AFRO', '15', '15307', '0', '315');
INSERT INTO public.who_global_data_import VALUES (75887, '2020-10-15', 'SN', 'Senegal', 'AFRO', '24', '15331', '1', '316');
INSERT INTO public.who_global_data_import VALUES (75888, '2020-10-16', 'SN', 'Senegal', 'AFRO', '17', '15348', '0', '316');
INSERT INTO public.who_global_data_import VALUES (75889, '2020-10-17', 'SN', 'Senegal', 'AFRO', '20', '15368', '1', '317');
INSERT INTO public.who_global_data_import VALUES (75890, '2020-10-18', 'SN', 'Senegal', 'AFRO', '0', '15368', '0', '317');
INSERT INTO public.who_global_data_import VALUES (75891, '2020-10-19', 'SN', 'Senegal', 'AFRO', '50', '15418', '0', '317');
INSERT INTO public.who_global_data_import VALUES (75892, '2020-10-20', 'SN', 'Senegal', 'AFRO', '14', '15432', '2', '319');
INSERT INTO public.who_global_data_import VALUES (75893, '2020-10-21', 'SN', 'Senegal', 'AFRO', '27', '15459', '1', '320');
INSERT INTO public.who_global_data_import VALUES (75894, '2020-10-22', 'SN', 'Senegal', 'AFRO', '25', '15484', '1', '321');
INSERT INTO public.who_global_data_import VALUES (75895, '2020-10-23', 'SN', 'Senegal', 'AFRO', '24', '15508', '0', '321');
INSERT INTO public.who_global_data_import VALUES (75896, '2020-10-24', 'SN', 'Senegal', 'AFRO', '17', '15525', '0', '321');
INSERT INTO public.who_global_data_import VALUES (75897, '2020-10-25', 'SN', 'Senegal', 'AFRO', '18', '15543', '0', '321');
INSERT INTO public.who_global_data_import VALUES (75898, '2020-10-26', 'SN', 'Senegal', 'AFRO', '8', '15551', '0', '321');
INSERT INTO public.who_global_data_import VALUES (75899, '2020-10-27', 'SN', 'Senegal', 'AFRO', '14', '15565', '1', '322');
INSERT INTO public.who_global_data_import VALUES (75900, '2020-10-28', 'SN', 'Senegal', 'AFRO', '6', '15571', '0', '322');
INSERT INTO public.who_global_data_import VALUES (75901, '2020-10-29', 'SN', 'Senegal', 'AFRO', '11', '15582', '0', '322');
INSERT INTO public.who_global_data_import VALUES (75902, '2020-10-30', 'SN', 'Senegal', 'AFRO', '11', '15593', '1', '323');
INSERT INTO public.who_global_data_import VALUES (75903, '2020-10-31', 'SN', 'Senegal', 'AFRO', '0', '15593', '0', '323');
INSERT INTO public.who_global_data_import VALUES (75904, '2020-11-01', 'SN', 'Senegal', 'AFRO', '23', '15616', '1', '324');
INSERT INTO public.who_global_data_import VALUES (75905, '2020-11-02', 'SN', 'Senegal', 'AFRO', '0', '15616', '0', '324');
INSERT INTO public.who_global_data_import VALUES (75906, '2020-11-03', 'SN', 'Senegal', 'AFRO', '14', '15630', '1', '325');
INSERT INTO public.who_global_data_import VALUES (75907, '2020-11-04', 'SN', 'Senegal', 'AFRO', '10', '15640', '1', '326');
INSERT INTO public.who_global_data_import VALUES (75908, '2020-11-05', 'SN', 'Senegal', 'AFRO', '10', '15650', '0', '326');
INSERT INTO public.who_global_data_import VALUES (75909, '2020-11-06', 'SN', 'Senegal', 'AFRO', '18', '15668', '0', '326');
INSERT INTO public.who_global_data_import VALUES (75910, '2020-11-07', 'SN', 'Senegal', 'AFRO', '0', '15668', '0', '326');
INSERT INTO public.who_global_data_import VALUES (75911, '2020-11-08', 'SN', 'Senegal', 'AFRO', '0', '15668', '0', '326');
INSERT INTO public.who_global_data_import VALUES (75912, '2020-11-09', 'SN', 'Senegal', 'AFRO', '40', '15708', '0', '326');
INSERT INTO public.who_global_data_import VALUES (75913, '2020-11-10', 'SN', 'Senegal', 'AFRO', '3', '15711', '0', '326');
INSERT INTO public.who_global_data_import VALUES (75914, '2020-11-11', 'SN', 'Senegal', 'AFRO', '9', '15720', '0', '326');
INSERT INTO public.who_global_data_import VALUES (75915, '2020-11-12', 'SN', 'Senegal', 'AFRO', '15', '15735', '0', '326');
INSERT INTO public.who_global_data_import VALUES (75916, '2020-11-13', 'SN', 'Senegal', 'AFRO', '9', '15744', '0', '326');
INSERT INTO public.who_global_data_import VALUES (75917, '2020-11-14', 'SN', 'Senegal', 'AFRO', '11', '15755', '0', '326');
INSERT INTO public.who_global_data_import VALUES (75918, '2020-11-15', 'SN', 'Senegal', 'AFRO', '24', '15779', '1', '327');
INSERT INTO public.who_global_data_import VALUES (75919, '2020-11-16', 'SN', 'Senegal', 'AFRO', '14', '15793', '1', '328');
INSERT INTO public.who_global_data_import VALUES (75920, '2020-11-17', 'SN', 'Senegal', 'AFRO', '0', '15793', '0', '328');
INSERT INTO public.who_global_data_import VALUES (75921, '2020-11-18', 'SN', 'Senegal', 'AFRO', '13', '15806', '1', '329');
INSERT INTO public.who_global_data_import VALUES (75922, '2020-11-19', 'SN', 'Senegal', 'AFRO', '17', '15823', '0', '329');
INSERT INTO public.who_global_data_import VALUES (75923, '2020-11-20', 'SN', 'Senegal', 'AFRO', '12', '15835', '0', '329');
INSERT INTO public.who_global_data_import VALUES (75924, '2020-11-21', 'SN', 'Senegal', 'AFRO', '13', '15848', '1', '330');
INSERT INTO public.who_global_data_import VALUES (75925, '2020-11-22', 'SN', 'Senegal', 'AFRO', '17', '15865', '0', '330');
INSERT INTO public.who_global_data_import VALUES (75926, '2020-11-23', 'SN', 'Senegal', 'AFRO', '17', '15882', '0', '330');
INSERT INTO public.who_global_data_import VALUES (75927, '2020-11-24', 'SN', 'Senegal', 'AFRO', '15', '15897', '0', '330');
INSERT INTO public.who_global_data_import VALUES (75928, '2020-11-25', 'SN', 'Senegal', 'AFRO', '11', '15908', '1', '331');
INSERT INTO public.who_global_data_import VALUES (75929, '2020-11-26', 'SN', 'Senegal', 'AFRO', '19', '15927', '0', '331');
INSERT INTO public.who_global_data_import VALUES (75930, '2020-11-27', 'SN', 'Senegal', 'AFRO', '33', '15960', '0', '331');
INSERT INTO public.who_global_data_import VALUES (75931, '2020-11-28', 'SN', 'Senegal', 'AFRO', '21', '15981', '1', '332');
INSERT INTO public.who_global_data_import VALUES (75932, '2020-11-29', 'SN', 'Senegal', 'AFRO', '46', '16027', '0', '332');
INSERT INTO public.who_global_data_import VALUES (75933, '2020-11-30', 'SN', 'Senegal', 'AFRO', '48', '16075', '1', '333');
INSERT INTO public.who_global_data_import VALUES (75934, '2020-12-01', 'SN', 'Senegal', 'AFRO', '14', '16089', '0', '333');
INSERT INTO public.who_global_data_import VALUES (75935, '2020-12-02', 'SN', 'Senegal', 'AFRO', '18', '16107', '0', '333');
INSERT INTO public.who_global_data_import VALUES (75936, '2020-12-03', 'SN', 'Senegal', 'AFRO', '66', '16173', '1', '334');
INSERT INTO public.who_global_data_import VALUES (75937, '2020-12-04', 'SN', 'Senegal', 'AFRO', '44', '16217', '1', '335');
INSERT INTO public.who_global_data_import VALUES (75938, '2020-12-05', 'SN', 'Senegal', 'AFRO', '80', '16297', '1', '336');
INSERT INTO public.who_global_data_import VALUES (75939, '2020-12-06', 'SN', 'Senegal', 'AFRO', '100', '16397', '1', '337');
INSERT INTO public.who_global_data_import VALUES (75940, '2020-12-07', 'SN', 'Senegal', 'AFRO', '80', '16477', '1', '338');
INSERT INTO public.who_global_data_import VALUES (75941, '2020-12-08', 'SN', 'Senegal', 'AFRO', '76', '16553', '2', '340');
INSERT INTO public.who_global_data_import VALUES (75942, '2020-12-09', 'SN', 'Senegal', 'AFRO', '43', '16596', '0', '340');
INSERT INTO public.who_global_data_import VALUES (75943, '2020-12-10', 'SN', 'Senegal', 'AFRO', '69', '16665', '1', '341');
INSERT INTO public.who_global_data_import VALUES (75944, '2020-12-11', 'SN', 'Senegal', 'AFRO', '101', '16766', '2', '343');
INSERT INTO public.who_global_data_import VALUES (75945, '2020-12-12', 'SN', 'Senegal', 'AFRO', '127', '16893', '2', '345');
INSERT INTO public.who_global_data_import VALUES (75946, '2020-12-13', 'SN', 'Senegal', 'AFRO', '168', '17061', '4', '349');
INSERT INTO public.who_global_data_import VALUES (75947, '2020-12-14', 'SN', 'Senegal', 'AFRO', '14', '17075', '0', '349');
INSERT INTO public.who_global_data_import VALUES (75948, '2020-12-15', 'SN', 'Senegal', 'AFRO', '71', '17146', '1', '350');
INSERT INTO public.who_global_data_import VALUES (75949, '2020-12-16', 'SN', 'Senegal', 'AFRO', '70', '17216', '0', '350');
INSERT INTO public.who_global_data_import VALUES (75950, '2020-12-17', 'SN', 'Senegal', 'AFRO', '120', '17336', '2', '352');
INSERT INTO public.who_global_data_import VALUES (75951, '2020-12-18', 'SN', 'Senegal', 'AFRO', '115', '17451', '3', '355');
INSERT INTO public.who_global_data_import VALUES (75952, '2020-12-19', 'SN', 'Senegal', 'AFRO', '108', '17559', '2', '357');
INSERT INTO public.who_global_data_import VALUES (75953, '2020-12-20', 'SN', 'Senegal', 'AFRO', '111', '17670', '4', '361');
INSERT INTO public.who_global_data_import VALUES (75954, '2020-12-21', 'SN', 'Senegal', 'AFRO', '88', '17758', '4', '365');
INSERT INTO public.who_global_data_import VALUES (75955, '2020-12-22', 'SN', 'Senegal', 'AFRO', '121', '17879', '6', '371');
INSERT INTO public.who_global_data_import VALUES (75956, '2020-12-23', 'SN', 'Senegal', 'AFRO', '66', '17945', '1', '372');
INSERT INTO public.who_global_data_import VALUES (75957, '2020-12-24', 'SN', 'Senegal', 'AFRO', '98', '18043', '6', '378');
INSERT INTO public.who_global_data_import VALUES (75958, '2020-12-25', 'SN', 'Senegal', 'AFRO', '157', '18200', '3', '381');
INSERT INTO public.who_global_data_import VALUES (75959, '2020-12-26', 'SN', 'Senegal', 'AFRO', '169', '18369', '5', '386');
INSERT INTO public.who_global_data_import VALUES (75960, '2020-12-27', 'SN', 'Senegal', 'AFRO', '154', '18523', '1', '387');
INSERT INTO public.who_global_data_import VALUES (75961, '2020-12-28', 'SN', 'Senegal', 'AFRO', '86', '18609', '1', '388');
INSERT INTO public.who_global_data_import VALUES (75962, '2020-12-29', 'SN', 'Senegal', 'AFRO', '119', '18728', '2', '390');
INSERT INTO public.who_global_data_import VALUES (75963, '2020-12-30', 'SN', 'Senegal', 'AFRO', '78', '18806', '5', '395');
INSERT INTO public.who_global_data_import VALUES (75964, '2020-12-31', 'SN', 'Senegal', 'AFRO', '139', '18945', '7', '402');
INSERT INTO public.who_global_data_import VALUES (75965, '2021-01-01', 'SN', 'Senegal', 'AFRO', '195', '19140', '8', '410');
INSERT INTO public.who_global_data_import VALUES (75966, '2021-01-02', 'SN', 'Senegal', 'AFRO', '0', '19140', '0', '410');
INSERT INTO public.who_global_data_import VALUES (75967, '2021-01-03', 'SN', 'Senegal', 'AFRO', '371', '19511', '6', '416');
INSERT INTO public.who_global_data_import VALUES (75968, '2021-01-04', 'SN', 'Senegal', 'AFRO', '186', '19697', '5', '421');
INSERT INTO public.who_global_data_import VALUES (75969, '2021-01-05', 'SN', 'Senegal', 'AFRO', '106', '19803', '3', '424');
INSERT INTO public.who_global_data_import VALUES (75970, '2021-01-06', 'SN', 'Senegal', 'AFRO', '161', '19964', '4', '428');
INSERT INTO public.who_global_data_import VALUES (75971, '2021-01-07', 'SN', 'Senegal', 'AFRO', '192', '20156', '5', '433');
INSERT INTO public.who_global_data_import VALUES (75972, '2021-01-08', 'SN', 'Senegal', 'AFRO', '220', '20376', '5', '438');
INSERT INTO public.who_global_data_import VALUES (75973, '2021-01-09', 'SN', 'Senegal', 'AFRO', '296', '20672', '8', '446');
INSERT INTO public.who_global_data_import VALUES (75974, '2021-01-10', 'SN', 'Senegal', 'AFRO', '328', '21000', '13', '459');
INSERT INTO public.who_global_data_import VALUES (75975, '2021-01-11', 'SN', 'Senegal', 'AFRO', '245', '21245', '6', '465');
INSERT INTO public.who_global_data_import VALUES (75976, '2021-01-12', 'SN', 'Senegal', 'AFRO', '288', '21533', '4', '469');
INSERT INTO public.who_global_data_import VALUES (75977, '2021-01-13', 'SN', 'Senegal', 'AFRO', '152', '21685', '11', '480');
INSERT INTO public.who_global_data_import VALUES (75978, '2021-01-14', 'SN', 'Senegal', 'AFRO', '198', '21883', '9', '489');
INSERT INTO public.who_global_data_import VALUES (75979, '2021-01-15', 'SN', 'Senegal', 'AFRO', '295', '22178', '7', '496');
INSERT INTO public.who_global_data_import VALUES (75980, '2021-01-16', 'SN', 'Senegal', 'AFRO', '218', '22396', '10', '506');
INSERT INTO public.who_global_data_import VALUES (75981, '2021-01-17', 'SN', 'Senegal', 'AFRO', '342', '22738', '3', '509');
INSERT INTO public.who_global_data_import VALUES (75982, '2021-01-18', 'SN', 'Senegal', 'AFRO', '290', '23028', '6', '515');
INSERT INTO public.who_global_data_import VALUES (75983, '2021-01-19', 'SN', 'Senegal', 'AFRO', '196', '23224', '11', '526');
INSERT INTO public.who_global_data_import VALUES (75984, '2021-01-20', 'SN', 'Senegal', 'AFRO', '168', '23392', '10', '536');
INSERT INTO public.who_global_data_import VALUES (75985, '2021-01-21', 'SN', 'Senegal', 'AFRO', '250', '23642', '10', '546');
INSERT INTO public.who_global_data_import VALUES (75986, '2021-01-22', 'SN', 'Senegal', 'AFRO', '268', '23910', '6', '552');
INSERT INTO public.who_global_data_import VALUES (75987, '2021-01-23', 'SN', 'Senegal', 'AFRO', '300', '24210', '9', '561');
INSERT INTO public.who_global_data_import VALUES (75988, '2021-01-24', 'SN', 'Senegal', 'AFRO', '250', '24460', '8', '569');
INSERT INTO public.who_global_data_import VALUES (75989, '2021-01-25', 'SN', 'Senegal', 'AFRO', '268', '24728', '6', '575');
INSERT INTO public.who_global_data_import VALUES (75990, '2021-01-26', 'SN', 'Senegal', 'AFRO', '265', '24993', '7', '582');
INSERT INTO public.who_global_data_import VALUES (75991, '2021-01-27', 'SN', 'Senegal', 'AFRO', '133', '25126', '10', '592');
INSERT INTO public.who_global_data_import VALUES (75992, '2021-01-28', 'SN', 'Senegal', 'AFRO', '281', '25407', '9', '601');
INSERT INTO public.who_global_data_import VALUES (75993, '2021-01-29', 'SN', 'Senegal', 'AFRO', '304', '25711', '13', '614');
INSERT INTO public.who_global_data_import VALUES (75994, '2021-01-30', 'SN', 'Senegal', 'AFRO', '184', '25895', '3', '617');
INSERT INTO public.who_global_data_import VALUES (75995, '2021-01-31', 'SN', 'Senegal', 'AFRO', '318', '26213', '4', '621');
INSERT INTO public.who_global_data_import VALUES (75996, '2021-02-01', 'SN', 'Senegal', 'AFRO', '310', '26523', '7', '628');
INSERT INTO public.who_global_data_import VALUES (75997, '2021-02-02', 'SN', 'Senegal', 'AFRO', '404', '26927', '10', '638');
INSERT INTO public.who_global_data_import VALUES (75998, '2021-02-03', 'SN', 'Senegal', 'AFRO', '153', '27080', '3', '641');
INSERT INTO public.who_global_data_import VALUES (75999, '2021-02-04', 'SN', 'Senegal', 'AFRO', '285', '27365', '7', '648');
INSERT INTO public.who_global_data_import VALUES (76000, '2021-02-05', 'SN', 'Senegal', 'AFRO', '368', '27733', '11', '659');
INSERT INTO public.who_global_data_import VALUES (76001, '2020-01-03', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76002, '2020-01-04', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76003, '2020-01-05', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76004, '2020-01-06', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76005, '2020-01-07', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76006, '2020-01-08', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76007, '2020-01-09', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76008, '2020-01-10', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76009, '2020-01-11', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76010, '2020-01-12', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76011, '2020-01-13', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76012, '2020-01-14', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76013, '2020-01-15', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76014, '2020-01-16', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76015, '2020-01-17', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76016, '2020-01-18', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76017, '2020-01-19', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76018, '2020-01-20', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76019, '2020-01-21', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76020, '2020-01-22', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76021, '2020-01-23', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76022, '2020-01-24', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76023, '2020-01-25', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76024, '2020-01-26', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76025, '2020-01-27', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76026, '2020-01-28', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76027, '2020-01-29', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76028, '2020-01-30', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76029, '2020-01-31', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76030, '2020-02-01', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76031, '2020-02-02', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76032, '2020-02-03', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76033, '2020-02-04', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76034, '2020-02-05', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76035, '2020-02-06', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76036, '2020-02-07', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76037, '2020-02-08', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76038, '2020-02-09', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76039, '2020-02-10', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76040, '2020-02-11', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76041, '2020-02-12', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76042, '2020-02-13', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76043, '2020-02-14', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76044, '2020-02-15', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76045, '2020-02-16', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76046, '2020-02-17', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76047, '2020-02-18', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76048, '2020-02-19', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76049, '2020-02-20', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76050, '2020-02-21', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76051, '2020-02-22', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76052, '2020-02-23', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76053, '2020-02-24', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76054, '2020-02-25', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76055, '2020-02-26', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76056, '2020-02-27', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76057, '2020-02-28', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76058, '2020-02-29', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76059, '2020-03-01', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76060, '2020-03-02', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76061, '2020-03-03', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76062, '2020-03-04', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76063, '2020-03-05', 'RS', 'Serbia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76064, '2020-03-06', 'RS', 'Serbia', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76065, '2020-03-07', 'RS', 'Serbia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76066, '2020-03-08', 'RS', 'Serbia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76067, '2020-03-09', 'RS', 'Serbia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76068, '2020-03-10', 'RS', 'Serbia', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76069, '2020-03-11', 'RS', 'Serbia', 'EURO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76070, '2020-03-12', 'RS', 'Serbia', 'EURO', '8', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76071, '2020-03-13', 'RS', 'Serbia', 'EURO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76072, '2020-03-14', 'RS', 'Serbia', 'EURO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76073, '2020-03-15', 'RS', 'Serbia', 'EURO', '32', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76074, '2020-03-16', 'RS', 'Serbia', 'EURO', '0', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76075, '2020-03-17', 'RS', 'Serbia', 'EURO', '0', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76076, '2020-03-18', 'RS', 'Serbia', 'EURO', '26', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76077, '2020-03-19', 'RS', 'Serbia', 'EURO', '22', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76078, '2020-03-20', 'RS', 'Serbia', 'EURO', '29', '123', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76079, '2020-03-21', 'RS', 'Serbia', 'EURO', '50', '173', '1', '1');
INSERT INTO public.who_global_data_import VALUES (76080, '2020-03-22', 'RS', 'Serbia', 'EURO', '46', '219', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76081, '2020-03-23', 'RS', 'Serbia', 'EURO', '3', '222', '1', '2');
INSERT INTO public.who_global_data_import VALUES (76082, '2020-03-24', 'RS', 'Serbia', 'EURO', '27', '249', '0', '2');
INSERT INTO public.who_global_data_import VALUES (76083, '2020-03-25', 'RS', 'Serbia', 'EURO', '135', '384', '2', '4');
INSERT INTO public.who_global_data_import VALUES (76084, '2020-03-26', 'RS', 'Serbia', 'EURO', '0', '384', '0', '4');
INSERT INTO public.who_global_data_import VALUES (76085, '2020-03-27', 'RS', 'Serbia', 'EURO', '73', '457', '3', '7');
INSERT INTO public.who_global_data_import VALUES (76086, '2020-03-28', 'RS', 'Serbia', 'EURO', '71', '528', '0', '7');
INSERT INTO public.who_global_data_import VALUES (76087, '2020-03-29', 'RS', 'Serbia', 'EURO', '131', '659', '3', '10');
INSERT INTO public.who_global_data_import VALUES (76088, '2020-03-30', 'RS', 'Serbia', 'EURO', '82', '741', '3', '13');
INSERT INTO public.who_global_data_import VALUES (76089, '2020-03-31', 'RS', 'Serbia', 'EURO', '44', '785', '0', '13');
INSERT INTO public.who_global_data_import VALUES (76090, '2020-04-01', 'RS', 'Serbia', 'EURO', '115', '900', '0', '13');
INSERT INTO public.who_global_data_import VALUES (76091, '2020-04-02', 'RS', 'Serbia', 'EURO', '160', '1060', '0', '13');
INSERT INTO public.who_global_data_import VALUES (76092, '2020-04-03', 'RS', 'Serbia', 'EURO', '111', '1171', '0', '13');
INSERT INTO public.who_global_data_import VALUES (76093, '2020-04-04', 'RS', 'Serbia', 'EURO', '305', '1476', '26', '39');
INSERT INTO public.who_global_data_import VALUES (76094, '2020-04-05', 'RS', 'Serbia', 'EURO', '148', '1624', '0', '39');
INSERT INTO public.who_global_data_import VALUES (76095, '2020-04-06', 'RS', 'Serbia', 'EURO', '284', '1908', '12', '51');
INSERT INTO public.who_global_data_import VALUES (76096, '2020-04-07', 'RS', 'Serbia', 'EURO', '292', '2200', '7', '58');
INSERT INTO public.who_global_data_import VALUES (76097, '2020-04-08', 'RS', 'Serbia', 'EURO', '247', '2447', '3', '61');
INSERT INTO public.who_global_data_import VALUES (76098, '2020-04-09', 'RS', 'Serbia', 'EURO', '219', '2666', '4', '65');
INSERT INTO public.who_global_data_import VALUES (76099, '2020-04-10', 'RS', 'Serbia', 'EURO', '201', '2867', '0', '65');
INSERT INTO public.who_global_data_import VALUES (76100, '2020-04-11', 'RS', 'Serbia', 'EURO', '238', '3105', '6', '71');
INSERT INTO public.who_global_data_import VALUES (76101, '2020-04-12', 'RS', 'Serbia', 'EURO', '275', '3380', '3', '74');
INSERT INTO public.who_global_data_import VALUES (76102, '2020-04-13', 'RS', 'Serbia', 'EURO', '250', '3630', '6', '80');
INSERT INTO public.who_global_data_import VALUES (76103, '2020-04-14', 'RS', 'Serbia', 'EURO', '424', '4054', '5', '85');
INSERT INTO public.who_global_data_import VALUES (76104, '2020-04-15', 'RS', 'Serbia', 'EURO', '411', '4465', '9', '94');
INSERT INTO public.who_global_data_import VALUES (76105, '2020-04-16', 'RS', 'Serbia', 'EURO', '408', '4873', '5', '99');
INSERT INTO public.who_global_data_import VALUES (76106, '2020-04-17', 'RS', 'Serbia', 'EURO', '445', '5318', '4', '103');
INSERT INTO public.who_global_data_import VALUES (76107, '2020-04-18', 'RS', 'Serbia', 'EURO', '372', '5690', '7', '110');
INSERT INTO public.who_global_data_import VALUES (76108, '2020-04-19', 'RS', 'Serbia', 'EURO', '304', '5994', '7', '117');
INSERT INTO public.who_global_data_import VALUES (76109, '2020-04-20', 'RS', 'Serbia', 'EURO', '324', '6318', '5', '122');
INSERT INTO public.who_global_data_import VALUES (76110, '2020-04-21', 'RS', 'Serbia', 'EURO', '312', '6630', '3', '125');
INSERT INTO public.who_global_data_import VALUES (76111, '2020-04-22', 'RS', 'Serbia', 'EURO', '260', '6890', '5', '130');
INSERT INTO public.who_global_data_import VALUES (76112, '2020-04-23', 'RS', 'Serbia', 'EURO', '224', '7114', '4', '134');
INSERT INTO public.who_global_data_import VALUES (76113, '2020-04-24', 'RS', 'Serbia', 'EURO', '162', '7276', '5', '139');
INSERT INTO public.who_global_data_import VALUES (76114, '2020-04-25', 'RS', 'Serbia', 'EURO', '207', '7483', '5', '144');
INSERT INTO public.who_global_data_import VALUES (76115, '2020-04-26', 'RS', 'Serbia', 'EURO', '296', '7779', '7', '151');
INSERT INTO public.who_global_data_import VALUES (76116, '2020-04-27', 'RS', 'Serbia', 'EURO', '263', '8042', '5', '156');
INSERT INTO public.who_global_data_import VALUES (76117, '2020-04-28', 'RS', 'Serbia', 'EURO', '233', '8275', '6', '162');
INSERT INTO public.who_global_data_import VALUES (76118, '2020-04-29', 'RS', 'Serbia', 'EURO', '222', '8497', '6', '168');
INSERT INTO public.who_global_data_import VALUES (76119, '2020-04-30', 'RS', 'Serbia', 'EURO', '227', '8724', '5', '173');
INSERT INTO public.who_global_data_import VALUES (76120, '2020-05-01', 'RS', 'Serbia', 'EURO', '285', '9009', '6', '179');
INSERT INTO public.who_global_data_import VALUES (76121, '2020-05-02', 'RS', 'Serbia', 'EURO', '196', '9205', '6', '185');
INSERT INTO public.who_global_data_import VALUES (76122, '2020-05-03', 'RS', 'Serbia', 'EURO', '157', '9362', '4', '189');
INSERT INTO public.who_global_data_import VALUES (76123, '2020-05-04', 'RS', 'Serbia', 'EURO', '102', '9464', '4', '193');
INSERT INTO public.who_global_data_import VALUES (76124, '2020-05-05', 'RS', 'Serbia', 'EURO', '93', '9557', '4', '197');
INSERT INTO public.who_global_data_import VALUES (76125, '2020-05-06', 'RS', 'Serbia', 'EURO', '120', '9677', '3', '200');
INSERT INTO public.who_global_data_import VALUES (76126, '2020-05-07', 'RS', 'Serbia', 'EURO', '114', '9791', '3', '203');
INSERT INTO public.who_global_data_import VALUES (76127, '2020-05-08', 'RS', 'Serbia', 'EURO', '57', '9848', '3', '206');
INSERT INTO public.who_global_data_import VALUES (76128, '2020-05-09', 'RS', 'Serbia', 'EURO', '95', '9943', '3', '209');
INSERT INTO public.who_global_data_import VALUES (76129, '2020-05-10', 'RS', 'Serbia', 'EURO', '89', '10032', '4', '213');
INSERT INTO public.who_global_data_import VALUES (76130, '2020-05-11', 'RS', 'Serbia', 'EURO', '82', '10114', '2', '215');
INSERT INTO public.who_global_data_import VALUES (76131, '2020-05-12', 'RS', 'Serbia', 'EURO', '62', '10176', '3', '218');
INSERT INTO public.who_global_data_import VALUES (76132, '2020-05-13', 'RS', 'Serbia', 'EURO', '67', '10243', '2', '220');
INSERT INTO public.who_global_data_import VALUES (76133, '2020-05-14', 'RS', 'Serbia', 'EURO', '52', '10295', '2', '222');
INSERT INTO public.who_global_data_import VALUES (76134, '2020-05-15', 'RS', 'Serbia', 'EURO', '79', '10374', '2', '224');
INSERT INTO public.who_global_data_import VALUES (76135, '2020-05-16', 'RS', 'Serbia', 'EURO', '64', '10438', '1', '225');
INSERT INTO public.who_global_data_import VALUES (76136, '2020-05-17', 'RS', 'Serbia', 'EURO', '58', '10496', '3', '228');
INSERT INTO public.who_global_data_import VALUES (76137, '2020-05-18', 'RS', 'Serbia', 'EURO', '114', '10610', '2', '230');
INSERT INTO public.who_global_data_import VALUES (76138, '2020-05-19', 'RS', 'Serbia', 'EURO', '89', '10699', '1', '231');
INSERT INTO public.who_global_data_import VALUES (76139, '2020-05-20', 'RS', 'Serbia', 'EURO', '34', '10733', '3', '234');
INSERT INTO public.who_global_data_import VALUES (76140, '2020-05-21', 'RS', 'Serbia', 'EURO', '100', '10833', '1', '235');
INSERT INTO public.who_global_data_import VALUES (76141, '2020-05-22', 'RS', 'Serbia', 'EURO', '86', '10919', '2', '237');
INSERT INTO public.who_global_data_import VALUES (76142, '2020-05-23', 'RS', 'Serbia', 'EURO', '105', '11024', '0', '237');
INSERT INTO public.who_global_data_import VALUES (76143, '2020-05-24', 'RS', 'Serbia', 'EURO', '68', '11092', '1', '238');
INSERT INTO public.who_global_data_import VALUES (76144, '2020-05-25', 'RS', 'Serbia', 'EURO', '67', '11159', '0', '238');
INSERT INTO public.who_global_data_import VALUES (76145, '2020-05-26', 'RS', 'Serbia', 'EURO', '34', '11193', '1', '239');
INSERT INTO public.who_global_data_import VALUES (76146, '2020-05-27', 'RS', 'Serbia', 'EURO', '34', '11227', '0', '239');
INSERT INTO public.who_global_data_import VALUES (76147, '2020-05-28', 'RS', 'Serbia', 'EURO', '48', '11275', '1', '240');
INSERT INTO public.who_global_data_import VALUES (76148, '2020-05-29', 'RS', 'Serbia', 'EURO', '25', '11300', '1', '241');
INSERT INTO public.who_global_data_import VALUES (76149, '2020-05-30', 'RS', 'Serbia', 'EURO', '54', '11354', '1', '242');
INSERT INTO public.who_global_data_import VALUES (76150, '2020-05-31', 'RS', 'Serbia', 'EURO', '27', '11381', '0', '242');
INSERT INTO public.who_global_data_import VALUES (76151, '2020-06-01', 'RS', 'Serbia', 'EURO', '31', '11412', '1', '243');
INSERT INTO public.who_global_data_import VALUES (76152, '2020-06-02', 'RS', 'Serbia', 'EURO', '18', '11430', '1', '244');
INSERT INTO public.who_global_data_import VALUES (76153, '2020-06-03', 'RS', 'Serbia', 'EURO', '24', '11454', '1', '245');
INSERT INTO public.who_global_data_import VALUES (76154, '2020-06-04', 'RS', 'Serbia', 'EURO', '69', '11523', '0', '245');
INSERT INTO public.who_global_data_import VALUES (76155, '2020-06-05', 'RS', 'Serbia', 'EURO', '48', '11571', '1', '246');
INSERT INTO public.who_global_data_import VALUES (76156, '2020-06-06', 'RS', 'Serbia', 'EURO', '96', '11667', '1', '247');
INSERT INTO public.who_global_data_import VALUES (76157, '2020-06-07', 'RS', 'Serbia', 'EURO', '74', '11741', '1', '248');
INSERT INTO public.who_global_data_import VALUES (76158, '2020-06-08', 'RS', 'Serbia', 'EURO', '82', '11823', '1', '249');
INSERT INTO public.who_global_data_import VALUES (76159, '2020-06-09', 'RS', 'Serbia', 'EURO', '73', '11896', '1', '250');
INSERT INTO public.who_global_data_import VALUES (76160, '2020-06-10', 'RS', 'Serbia', 'EURO', '69', '11965', '0', '250');
INSERT INTO public.who_global_data_import VALUES (76161, '2020-06-11', 'RS', 'Serbia', 'EURO', '66', '12031', '1', '251');
INSERT INTO public.who_global_data_import VALUES (76162, '2020-06-12', 'RS', 'Serbia', 'EURO', '71', '12102', '1', '252');
INSERT INTO public.who_global_data_import VALUES (76163, '2020-06-13', 'RS', 'Serbia', 'EURO', '73', '12175', '0', '252');
INSERT INTO public.who_global_data_import VALUES (76164, '2020-06-14', 'RS', 'Serbia', 'EURO', '76', '12251', '1', '253');
INSERT INTO public.who_global_data_import VALUES (76165, '2020-06-15', 'RS', 'Serbia', 'EURO', '59', '12310', '1', '254');
INSERT INTO public.who_global_data_import VALUES (76166, '2020-06-16', 'RS', 'Serbia', 'EURO', '57', '12367', '1', '255');
INSERT INTO public.who_global_data_import VALUES (76167, '2020-06-17', 'RS', 'Serbia', 'EURO', '59', '12426', '1', '256');
INSERT INTO public.who_global_data_import VALUES (76168, '2020-06-18', 'RS', 'Serbia', 'EURO', '96', '12522', '1', '257');
INSERT INTO public.who_global_data_import VALUES (76169, '2020-06-19', 'RS', 'Serbia', 'EURO', '94', '12616', '1', '258');
INSERT INTO public.who_global_data_import VALUES (76170, '2020-06-20', 'RS', 'Serbia', 'EURO', '93', '12709', '1', '259');
INSERT INTO public.who_global_data_import VALUES (76171, '2020-06-21', 'RS', 'Serbia', 'EURO', '94', '12803', '1', '260');
INSERT INTO public.who_global_data_import VALUES (76172, '2020-06-22', 'RS', 'Serbia', 'EURO', '91', '12894', '1', '261');
INSERT INTO public.who_global_data_import VALUES (76173, '2020-06-23', 'RS', 'Serbia', 'EURO', '96', '12990', '1', '262');
INSERT INTO public.who_global_data_import VALUES (76174, '2020-06-24', 'RS', 'Serbia', 'EURO', '102', '13092', '1', '263');
INSERT INTO public.who_global_data_import VALUES (76175, '2020-06-25', 'RS', 'Serbia', 'EURO', '143', '13235', '0', '263');
INSERT INTO public.who_global_data_import VALUES (76176, '2020-06-26', 'RS', 'Serbia', 'EURO', '137', '13372', '1', '264');
INSERT INTO public.who_global_data_import VALUES (76177, '2020-06-27', 'RS', 'Serbia', 'EURO', '193', '13565', '1', '265');
INSERT INTO public.who_global_data_import VALUES (76178, '2020-06-28', 'RS', 'Serbia', 'EURO', '227', '13792', '2', '267');
INSERT INTO public.who_global_data_import VALUES (76179, '2020-06-29', 'RS', 'Serbia', 'EURO', '254', '14046', '3', '270');
INSERT INTO public.who_global_data_import VALUES (76180, '2020-06-30', 'RS', 'Serbia', 'EURO', '242', '14288', '4', '274');
INSERT INTO public.who_global_data_import VALUES (76181, '2020-07-01', 'RS', 'Serbia', 'EURO', '276', '14564', '3', '277');
INSERT INTO public.who_global_data_import VALUES (76182, '2020-07-02', 'RS', 'Serbia', 'EURO', '272', '14836', '4', '281');
INSERT INTO public.who_global_data_import VALUES (76183, '2020-07-03', 'RS', 'Serbia', 'EURO', '359', '15195', '6', '287');
INSERT INTO public.who_global_data_import VALUES (76184, '2020-07-04', 'RS', 'Serbia', 'EURO', '309', '15504', '11', '298');
INSERT INTO public.who_global_data_import VALUES (76185, '2020-07-05', 'RS', 'Serbia', 'EURO', '325', '15829', '8', '306');
INSERT INTO public.who_global_data_import VALUES (76186, '2020-07-06', 'RS', 'Serbia', 'EURO', '302', '16131', '5', '311');
INSERT INTO public.who_global_data_import VALUES (76187, '2020-07-07', 'RS', 'Serbia', 'EURO', '289', '16420', '6', '317');
INSERT INTO public.who_global_data_import VALUES (76188, '2020-07-08', 'RS', 'Serbia', 'EURO', '299', '16719', '13', '330');
INSERT INTO public.who_global_data_import VALUES (76189, '2020-07-09', 'RS', 'Serbia', 'EURO', '357', '17076', '11', '341');
INSERT INTO public.who_global_data_import VALUES (76190, '2020-07-10', 'RS', 'Serbia', 'EURO', '266', '17342', '11', '352');
INSERT INTO public.who_global_data_import VALUES (76191, '2020-07-11', 'RS', 'Serbia', 'EURO', '386', '17728', '18', '370');
INSERT INTO public.who_global_data_import VALUES (76192, '2020-07-12', 'RS', 'Serbia', 'EURO', '345', '18073', '12', '382');
INSERT INTO public.who_global_data_import VALUES (76193, '2020-07-13', 'RS', 'Serbia', 'EURO', '287', '18360', '11', '393');
INSERT INTO public.who_global_data_import VALUES (76194, '2020-07-14', 'RS', 'Serbia', 'EURO', '279', '18639', '12', '405');
INSERT INTO public.who_global_data_import VALUES (76195, '2020-07-15', 'RS', 'Serbia', 'EURO', '344', '18983', '13', '418');
INSERT INTO public.who_global_data_import VALUES (76196, '2020-07-16', 'RS', 'Serbia', 'EURO', '351', '19334', '11', '429');
INSERT INTO public.who_global_data_import VALUES (76197, '2020-07-17', 'RS', 'Serbia', 'EURO', '383', '19717', '13', '442');
INSERT INTO public.who_global_data_import VALUES (76198, '2020-07-18', 'RS', 'Serbia', 'EURO', '392', '20109', '10', '452');
INSERT INTO public.who_global_data_import VALUES (76199, '2020-07-19', 'RS', 'Serbia', 'EURO', '389', '20498', '9', '461');
INSERT INTO public.who_global_data_import VALUES (76200, '2020-07-20', 'RS', 'Serbia', 'EURO', '396', '20894', '11', '472');
INSERT INTO public.who_global_data_import VALUES (76201, '2020-07-21', 'RS', 'Serbia', 'EURO', '359', '21253', '10', '482');
INSERT INTO public.who_global_data_import VALUES (76202, '2020-07-22', 'RS', 'Serbia', 'EURO', '352', '21605', '9', '491');
INSERT INTO public.who_global_data_import VALUES (76203, '2020-07-23', 'RS', 'Serbia', 'EURO', '426', '22031', '8', '499');
INSERT INTO public.who_global_data_import VALUES (76204, '2020-07-24', 'RS', 'Serbia', 'EURO', '412', '22443', '9', '508');
INSERT INTO public.who_global_data_import VALUES (76205, '2020-07-25', 'RS', 'Serbia', 'EURO', '409', '22852', '10', '518');
INSERT INTO public.who_global_data_import VALUES (76206, '2020-07-26', 'RS', 'Serbia', 'EURO', '411', '23263', '8', '526');
INSERT INTO public.who_global_data_import VALUES (76207, '2020-07-27', 'RS', 'Serbia', 'EURO', '467', '23730', '8', '534');
INSERT INTO public.who_global_data_import VALUES (76208, '2020-07-28', 'RS', 'Serbia', 'EURO', '411', '24141', '9', '543');
INSERT INTO public.who_global_data_import VALUES (76209, '2020-07-29', 'RS', 'Serbia', 'EURO', '379', '24520', '8', '551');
INSERT INTO public.who_global_data_import VALUES (76210, '2020-07-30', 'RS', 'Serbia', 'EURO', '372', '24892', '7', '558');
INSERT INTO public.who_global_data_import VALUES (76211, '2020-07-31', 'RS', 'Serbia', 'EURO', '321', '25213', '7', '565');
INSERT INTO public.who_global_data_import VALUES (76212, '2020-08-01', 'RS', 'Serbia', 'EURO', '339', '25552', '8', '573');
INSERT INTO public.who_global_data_import VALUES (76213, '2020-08-02', 'RS', 'Serbia', 'EURO', '330', '25882', '9', '582');
INSERT INTO public.who_global_data_import VALUES (76214, '2020-08-03', 'RS', 'Serbia', 'EURO', '311', '26193', '8', '590');
INSERT INTO public.who_global_data_import VALUES (76215, '2020-08-04', 'RS', 'Serbia', 'EURO', '258', '26451', '8', '598');
INSERT INTO public.who_global_data_import VALUES (76216, '2020-08-05', 'RS', 'Serbia', 'EURO', '287', '26738', '7', '605');
INSERT INTO public.who_global_data_import VALUES (76217, '2020-08-06', 'RS', 'Serbia', 'EURO', '295', '27033', '9', '614');
INSERT INTO public.who_global_data_import VALUES (76218, '2020-08-07', 'RS', 'Serbia', 'EURO', '299', '27332', '7', '621');
INSERT INTO public.who_global_data_import VALUES (76219, '2020-08-08', 'RS', 'Serbia', 'EURO', '276', '27608', '5', '626');
INSERT INTO public.who_global_data_import VALUES (76220, '2020-08-09', 'RS', 'Serbia', 'EURO', '255', '27863', '6', '632');
INSERT INTO public.who_global_data_import VALUES (76221, '2020-08-10', 'RS', 'Serbia', 'EURO', '236', '28099', '9', '641');
INSERT INTO public.who_global_data_import VALUES (76222, '2020-08-11', 'RS', 'Serbia', 'EURO', '163', '28262', '5', '646');
INSERT INTO public.who_global_data_import VALUES (76223, '2020-08-12', 'RS', 'Serbia', 'EURO', '235', '28497', '6', '652');
INSERT INTO public.who_global_data_import VALUES (76224, '2020-08-13', 'RS', 'Serbia', 'EURO', '254', '28751', '6', '658');
INSERT INTO public.who_global_data_import VALUES (76225, '2020-08-14', 'RS', 'Serbia', 'EURO', '247', '28998', '3', '661');
INSERT INTO public.who_global_data_import VALUES (76226, '2020-08-15', 'RS', 'Serbia', 'EURO', '235', '29233', '4', '665');
INSERT INTO public.who_global_data_import VALUES (76227, '2020-08-16', 'RS', 'Serbia', 'EURO', '238', '29471', '5', '670');
INSERT INTO public.who_global_data_import VALUES (76228, '2020-08-17', 'RS', 'Serbia', 'EURO', '211', '29682', '4', '674');
INSERT INTO public.who_global_data_import VALUES (76229, '2020-08-18', 'RS', 'Serbia', 'EURO', '100', '29782', '3', '677');
INSERT INTO public.who_global_data_import VALUES (76230, '2020-08-19', 'RS', 'Serbia', 'EURO', '108', '29890', '4', '681');
INSERT INTO public.who_global_data_import VALUES (76231, '2020-08-20', 'RS', 'Serbia', 'EURO', '158', '30048', '3', '684');
INSERT INTO public.who_global_data_import VALUES (76232, '2020-08-21', 'RS', 'Serbia', 'EURO', '161', '30209', '5', '689');
INSERT INTO public.who_global_data_import VALUES (76233, '2020-08-22', 'RS', 'Serbia', 'EURO', '169', '30378', '3', '692');
INSERT INTO public.who_global_data_import VALUES (76234, '2020-08-23', 'RS', 'Serbia', 'EURO', '170', '30548', '3', '695');
INSERT INTO public.who_global_data_import VALUES (76235, '2020-08-24', 'RS', 'Serbia', 'EURO', '109', '30657', '3', '698');
INSERT INTO public.who_global_data_import VALUES (76236, '2020-08-25', 'RS', 'Serbia', 'EURO', '57', '30714', '3', '701');
INSERT INTO public.who_global_data_import VALUES (76237, '2020-08-26', 'RS', 'Serbia', 'EURO', '106', '30820', '4', '705');
INSERT INTO public.who_global_data_import VALUES (76238, '2020-08-27', 'RS', 'Serbia', 'EURO', '154', '30974', '2', '707');
INSERT INTO public.who_global_data_import VALUES (76239, '2020-08-28', 'RS', 'Serbia', 'EURO', '125', '31099', '0', '707');
INSERT INTO public.who_global_data_import VALUES (76240, '2020-08-29', 'RS', 'Serbia', 'EURO', '108', '31207', '2', '709');
INSERT INTO public.who_global_data_import VALUES (76241, '2020-08-30', 'RS', 'Serbia', 'EURO', '75', '31282', '1', '710');
INSERT INTO public.who_global_data_import VALUES (76242, '2020-08-31', 'RS', 'Serbia', 'EURO', '83', '31365', '1', '711');
INSERT INTO public.who_global_data_import VALUES (76243, '2020-09-01', 'RS', 'Serbia', 'EURO', '41', '31406', '2', '713');
INSERT INTO public.who_global_data_import VALUES (76244, '2020-09-02', 'RS', 'Serbia', 'EURO', '76', '31482', '2', '715');
INSERT INTO public.who_global_data_import VALUES (76245, '2020-09-03', 'RS', 'Serbia', 'EURO', '99', '31581', '1', '716');
INSERT INTO public.who_global_data_import VALUES (76246, '2020-09-04', 'RS', 'Serbia', 'EURO', '95', '31676', '2', '718');
INSERT INTO public.who_global_data_import VALUES (76247, '2020-09-05', 'RS', 'Serbia', 'EURO', '96', '31772', '3', '721');
INSERT INTO public.who_global_data_import VALUES (76248, '2020-09-06', 'RS', 'Serbia', 'EURO', '77', '31849', '2', '723');
INSERT INTO public.who_global_data_import VALUES (76249, '2020-09-07', 'RS', 'Serbia', 'EURO', '56', '31905', '1', '724');
INSERT INTO public.who_global_data_import VALUES (76250, '2020-09-08', 'RS', 'Serbia', 'EURO', '36', '31941', '1', '725');
INSERT INTO public.who_global_data_import VALUES (76251, '2020-09-09', 'RS', 'Serbia', 'EURO', '53', '31994', '2', '727');
INSERT INTO public.who_global_data_import VALUES (76252, '2020-09-10', 'RS', 'Serbia', 'EURO', '84', '32078', '1', '728');
INSERT INTO public.who_global_data_import VALUES (76253, '2020-09-11', 'RS', 'Serbia', 'EURO', '58', '32136', '1', '729');
INSERT INTO public.who_global_data_import VALUES (76254, '2020-09-12', 'RS', 'Serbia', 'EURO', '92', '32228', '1', '730');
INSERT INTO public.who_global_data_import VALUES (76255, '2020-09-13', 'RS', 'Serbia', 'EURO', '72', '32300', '1', '731');
INSERT INTO public.who_global_data_import VALUES (76256, '2020-09-14', 'RS', 'Serbia', 'EURO', '108', '32408', '2', '733');
INSERT INTO public.who_global_data_import VALUES (76257, '2020-09-15', 'RS', 'Serbia', 'EURO', '29', '32437', '0', '733');
INSERT INTO public.who_global_data_import VALUES (76258, '2020-09-16', 'RS', 'Serbia', 'EURO', '74', '32511', '2', '735');
INSERT INTO public.who_global_data_import VALUES (76259, '2020-09-17', 'RS', 'Serbia', 'EURO', '102', '32613', '1', '736');
INSERT INTO public.who_global_data_import VALUES (76260, '2020-09-18', 'RS', 'Serbia', 'EURO', '82', '32695', '2', '738');
INSERT INTO public.who_global_data_import VALUES (76261, '2020-09-19', 'RS', 'Serbia', 'EURO', '62', '32757', '1', '739');
INSERT INTO public.who_global_data_import VALUES (76262, '2020-09-20', 'RS', 'Serbia', 'EURO', '83', '32840', '1', '740');
INSERT INTO public.who_global_data_import VALUES (76263, '2020-09-21', 'RS', 'Serbia', 'EURO', '68', '32908', '1', '741');
INSERT INTO public.who_global_data_import VALUES (76264, '2020-09-22', 'RS', 'Serbia', 'EURO', '30', '32938', '2', '743');
INSERT INTO public.who_global_data_import VALUES (76265, '2020-09-23', 'RS', 'Serbia', 'EURO', '61', '32999', '0', '743');
INSERT INTO public.who_global_data_import VALUES (76266, '2020-09-24', 'RS', 'Serbia', 'EURO', '81', '33080', '1', '744');
INSERT INTO public.who_global_data_import VALUES (76267, '2020-09-25', 'RS', 'Serbia', 'EURO', '83', '33163', '1', '745');
INSERT INTO public.who_global_data_import VALUES (76268, '2020-09-26', 'RS', 'Serbia', 'EURO', '75', '33238', '1', '746');
INSERT INTO public.who_global_data_import VALUES (76269, '2020-09-27', 'RS', 'Serbia', 'EURO', '74', '33312', '0', '746');
INSERT INTO public.who_global_data_import VALUES (76270, '2020-09-28', 'RS', 'Serbia', 'EURO', '72', '33384', '1', '747');
INSERT INTO public.who_global_data_import VALUES (76271, '2020-09-29', 'RS', 'Serbia', 'EURO', '30', '33414', '1', '748');
INSERT INTO public.who_global_data_import VALUES (76272, '2020-09-30', 'RS', 'Serbia', 'EURO', '65', '33479', '1', '749');
INSERT INTO public.who_global_data_import VALUES (76273, '2020-10-01', 'RS', 'Serbia', 'EURO', '72', '33551', '0', '749');
INSERT INTO public.who_global_data_import VALUES (76274, '2020-10-02', 'RS', 'Serbia', 'EURO', '111', '33662', '1', '750');
INSERT INTO public.who_global_data_import VALUES (76275, '2020-10-03', 'RS', 'Serbia', 'EURO', '73', '33735', '1', '751');
INSERT INTO public.who_global_data_import VALUES (76276, '2020-10-04', 'RS', 'Serbia', 'EURO', '107', '33842', '2', '753');
INSERT INTO public.who_global_data_import VALUES (76277, '2020-10-05', 'RS', 'Serbia', 'EURO', '59', '33901', '1', '754');
INSERT INTO public.who_global_data_import VALUES (76278, '2020-10-06', 'RS', 'Serbia', 'EURO', '51', '33952', '2', '756');
INSERT INTO public.who_global_data_import VALUES (76279, '2020-10-07', 'RS', 'Serbia', 'EURO', '120', '34072', '1', '757');
INSERT INTO public.who_global_data_import VALUES (76280, '2020-10-08', 'RS', 'Serbia', 'EURO', '121', '34193', '1', '758');
INSERT INTO public.who_global_data_import VALUES (76281, '2020-10-09', 'RS', 'Serbia', 'EURO', '151', '34344', '2', '760');
INSERT INTO public.who_global_data_import VALUES (76282, '2020-10-10', 'RS', 'Serbia', 'EURO', '173', '34517', '1', '761');
INSERT INTO public.who_global_data_import VALUES (76283, '2020-10-11', 'RS', 'Serbia', 'EURO', '168', '34685', '1', '762');
INSERT INTO public.who_global_data_import VALUES (76284, '2020-10-12', 'RS', 'Serbia', 'EURO', '102', '34787', '1', '763');
INSERT INTO public.who_global_data_import VALUES (76285, '2020-10-13', 'RS', 'Serbia', 'EURO', '67', '34854', '2', '765');
INSERT INTO public.who_global_data_import VALUES (76286, '2020-10-14', 'RS', 'Serbia', 'EURO', '152', '35006', '2', '767');
INSERT INTO public.who_global_data_import VALUES (76287, '2020-10-15', 'RS', 'Serbia', 'EURO', '245', '35251', '1', '768');
INSERT INTO public.who_global_data_import VALUES (76288, '2020-10-16', 'RS', 'Serbia', 'EURO', '203', '35454', '2', '770');
INSERT INTO public.who_global_data_import VALUES (76289, '2020-10-17', 'RS', 'Serbia', 'EURO', '265', '35719', '2', '772');
INSERT INTO public.who_global_data_import VALUES (76290, '2020-10-18', 'RS', 'Serbia', 'EURO', '227', '35946', '2', '774');
INSERT INTO public.who_global_data_import VALUES (76291, '2020-10-19', 'RS', 'Serbia', 'EURO', '214', '36160', '2', '776');
INSERT INTO public.who_global_data_import VALUES (76292, '2020-10-20', 'RS', 'Serbia', 'EURO', '122', '36282', '2', '778');
INSERT INTO public.who_global_data_import VALUES (76293, '2020-10-21', 'RS', 'Serbia', 'EURO', '326', '36608', '2', '780');
INSERT INTO public.who_global_data_import VALUES (76294, '2020-10-22', 'RS', 'Serbia', 'EURO', '512', '37120', '1', '781');
INSERT INTO public.who_global_data_import VALUES (76295, '2020-10-23', 'RS', 'Serbia', 'EURO', '416', '37536', '2', '783');
INSERT INTO public.who_global_data_import VALUES (76296, '2020-10-24', 'RS', 'Serbia', 'EURO', '579', '38115', '3', '786');
INSERT INTO public.who_global_data_import VALUES (76297, '2020-10-25', 'RS', 'Serbia', 'EURO', '757', '38872', '3', '789');
INSERT INTO public.who_global_data_import VALUES (76298, '2020-10-26', 'RS', 'Serbia', 'EURO', '614', '39486', '3', '792');
INSERT INTO public.who_global_data_import VALUES (76299, '2020-10-27', 'RS', 'Serbia', 'EURO', '341', '39827', '1', '793');
INSERT INTO public.who_global_data_import VALUES (76300, '2020-10-28', 'RS', 'Serbia', 'EURO', '1053', '40880', '5', '798');
INSERT INTO public.who_global_data_import VALUES (76301, '2020-10-29', 'RS', 'Serbia', 'EURO', '1328', '42208', '5', '803');
INSERT INTO public.who_global_data_import VALUES (76302, '2020-10-30', 'RS', 'Serbia', 'EURO', '1384', '43592', '6', '809');
INSERT INTO public.who_global_data_import VALUES (76303, '2020-10-31', 'RS', 'Serbia', 'EURO', '1545', '45137', '5', '814');
INSERT INTO public.who_global_data_import VALUES (76304, '2020-11-01', 'RS', 'Serbia', 'EURO', '1817', '46954', '6', '820');
INSERT INTO public.who_global_data_import VALUES (76305, '2020-11-02', 'RS', 'Serbia', 'EURO', '1449', '48403', '6', '826');
INSERT INTO public.who_global_data_import VALUES (76306, '2020-11-03', 'RS', 'Serbia', 'EURO', '802', '49205', '7', '833');
INSERT INTO public.who_global_data_import VALUES (76307, '2020-11-04', 'RS', 'Serbia', 'EURO', '1878', '51083', '11', '844');
INSERT INTO public.who_global_data_import VALUES (76308, '2020-11-05', 'RS', 'Serbia', 'EURO', '2412', '53495', '6', '850');
INSERT INTO public.who_global_data_import VALUES (76309, '2020-11-06', 'RS', 'Serbia', 'EURO', '2181', '55676', '11', '861');
INSERT INTO public.who_global_data_import VALUES (76310, '2020-11-07', 'RS', 'Serbia', 'EURO', '2282', '57958', '10', '871');
INSERT INTO public.who_global_data_import VALUES (76311, '2020-11-08', 'RS', 'Serbia', 'EURO', '2677', '60635', '9', '880');
INSERT INTO public.who_global_data_import VALUES (76312, '2020-11-09', 'RS', 'Serbia', 'EURO', '2112', '62747', '10', '890');
INSERT INTO public.who_global_data_import VALUES (76313, '2020-11-10', 'RS', 'Serbia', 'EURO', '1318', '64065', '11', '901');
INSERT INTO public.who_global_data_import VALUES (76314, '2020-11-11', 'RS', 'Serbia', 'EURO', '2823', '66888', '14', '915');
INSERT INTO public.who_global_data_import VALUES (76315, '2020-11-12', 'RS', 'Serbia', 'EURO', '3536', '70424', '21', '936');
INSERT INTO public.who_global_data_import VALUES (76316, '2020-11-13', 'RS', 'Serbia', 'EURO', '3341', '73765', '19', '955');
INSERT INTO public.who_global_data_import VALUES (76317, '2020-11-14', 'RS', 'Serbia', 'EURO', '3499', '77264', '17', '972');
INSERT INTO public.who_global_data_import VALUES (76318, '2020-11-15', 'RS', 'Serbia', 'EURO', '3822', '81086', '17', '989');
INSERT INTO public.who_global_data_import VALUES (76319, '2020-11-16', 'RS', 'Serbia', 'EURO', '3482', '84568', '20', '1009');
INSERT INTO public.who_global_data_import VALUES (76320, '2020-11-17', 'RS', 'Serbia', 'EURO', '2813', '87381', '21', '1030');
INSERT INTO public.who_global_data_import VALUES (76321, '2020-11-18', 'RS', 'Serbia', 'EURO', '4994', '92375', '24', '1054');
INSERT INTO public.who_global_data_import VALUES (76322, '2020-11-19', 'RS', 'Serbia', 'EURO', '5613', '97988', '27', '1081');
INSERT INTO public.who_global_data_import VALUES (76323, '2020-11-20', 'RS', 'Serbia', 'EURO', '6109', '104097', '29', '1110');
INSERT INTO public.who_global_data_import VALUES (76324, '2020-11-21', 'RS', 'Serbia', 'EURO', '6254', '110351', '30', '1140');
INSERT INTO public.who_global_data_import VALUES (76325, '2020-11-22', 'RS', 'Serbia', 'EURO', '5774', '116125', '28', '1168');
INSERT INTO public.who_global_data_import VALUES (76326, '2020-11-23', 'RS', 'Serbia', 'EURO', '4995', '121120', '31', '1199');
INSERT INTO public.who_global_data_import VALUES (76327, '2020-11-24', 'RS', 'Serbia', 'EURO', '5067', '126187', '38', '1237');
INSERT INTO public.who_global_data_import VALUES (76328, '2020-11-25', 'RS', 'Serbia', 'EURO', '6842', '133029', '37', '1274');
INSERT INTO public.who_global_data_import VALUES (76329, '2020-11-26', 'RS', 'Serbia', 'EURO', '7579', '140608', '41', '1315');
INSERT INTO public.who_global_data_import VALUES (76330, '2020-11-27', 'RS', 'Serbia', 'EURO', '7606', '148214', '51', '1366');
INSERT INTO public.who_global_data_import VALUES (76331, '2020-11-28', 'RS', 'Serbia', 'EURO', '7780', '155994', '57', '1423');
INSERT INTO public.who_global_data_import VALUES (76332, '2020-11-29', 'RS', 'Serbia', 'EURO', '7041', '163035', '61', '1484');
INSERT INTO public.who_global_data_import VALUES (76333, '2020-11-30', 'RS', 'Serbia', 'EURO', '6179', '169214', '65', '1549');
INSERT INTO public.who_global_data_import VALUES (76334, '2020-12-01', 'RS', 'Serbia', 'EURO', '6224', '175438', '55', '1604');
INSERT INTO public.who_global_data_import VALUES (76335, '2020-12-02', 'RS', 'Serbia', 'EURO', '7999', '183437', '48', '1652');
INSERT INTO public.who_global_data_import VALUES (76336, '2020-12-03', 'RS', 'Serbia', 'EURO', '7919', '191356', '52', '1704');
INSERT INTO public.who_global_data_import VALUES (76337, '2020-12-04', 'RS', 'Serbia', 'EURO', '7802', '199158', '61', '1765');
INSERT INTO public.who_global_data_import VALUES (76338, '2020-12-05', 'RS', 'Serbia', 'EURO', '7782', '206940', '69', '1834');
INSERT INTO public.who_global_data_import VALUES (76339, '2020-12-06', 'RS', 'Serbia', 'EURO', '6903', '213843', '57', '1891');
INSERT INTO public.who_global_data_import VALUES (76340, '2020-12-07', 'RS', 'Serbia', 'EURO', '5809', '219652', '58', '1949');
INSERT INTO public.who_global_data_import VALUES (76341, '2020-12-08', 'RS', 'Serbia', 'EURO', '6557', '226209', '56', '2005');
INSERT INTO public.who_global_data_import VALUES (76342, '2020-12-09', 'RS', 'Serbia', 'EURO', '7818', '234027', '57', '2062');
INSERT INTO public.who_global_data_import VALUES (76343, '2020-12-10', 'RS', 'Serbia', 'EURO', '7804', '241831', '54', '2116');
INSERT INTO public.who_global_data_import VALUES (76344, '2020-12-11', 'RS', 'Serbia', 'EURO', '7393', '249224', '56', '2172');
INSERT INTO public.who_global_data_import VALUES (76345, '2020-12-12', 'RS', 'Serbia', 'EURO', '6534', '255758', '55', '2227');
INSERT INTO public.who_global_data_import VALUES (76346, '2020-12-13', 'RS', 'Serbia', 'EURO', '5679', '261437', '48', '2275');
INSERT INTO public.who_global_data_import VALUES (76347, '2020-12-14', 'RS', 'Serbia', 'EURO', '4995', '266432', '56', '2331');
INSERT INTO public.who_global_data_import VALUES (76348, '2020-12-15', 'RS', 'Serbia', 'EURO', '4932', '271364', '49', '2380');
INSERT INTO public.who_global_data_import VALUES (76349, '2020-12-16', 'RS', 'Serbia', 'EURO', '5884', '277248', '53', '2433');
INSERT INTO public.who_global_data_import VALUES (76350, '2020-12-17', 'RS', 'Serbia', 'EURO', '5353', '282601', '49', '2482');
INSERT INTO public.who_global_data_import VALUES (76351, '2020-12-18', 'RS', 'Serbia', 'EURO', '5129', '287730', '47', '2529');
INSERT INTO public.who_global_data_import VALUES (76352, '2020-12-19', 'RS', 'Serbia', 'EURO', '4910', '292640', '51', '2580');
INSERT INTO public.who_global_data_import VALUES (76353, '2020-12-20', 'RS', 'Serbia', 'EURO', '3888', '296528', '52', '2632');
INSERT INTO public.who_global_data_import VALUES (76354, '2020-12-21', 'RS', 'Serbia', 'EURO', '3534', '300062', '54', '2686');
INSERT INTO public.who_global_data_import VALUES (76355, '2020-12-22', 'RS', 'Serbia', 'EURO', '3685', '303747', '47', '2733');
INSERT INTO public.who_global_data_import VALUES (76356, '2020-12-23', 'RS', 'Serbia', 'EURO', '4080', '307827', '49', '2782');
INSERT INTO public.who_global_data_import VALUES (76357, '2020-12-24', 'RS', 'Serbia', 'EURO', '4426', '312253', '51', '2833');
INSERT INTO public.who_global_data_import VALUES (76358, '2020-12-25', 'RS', 'Serbia', 'EURO', '4091', '316344', '49', '2882');
INSERT INTO public.who_global_data_import VALUES (76359, '2020-12-26', 'RS', 'Serbia', 'EURO', '3823', '320167', '49', '2931');
INSERT INTO public.who_global_data_import VALUES (76360, '2020-12-27', 'RS', 'Serbia', 'EURO', '3200', '323367', '52', '2983');
INSERT INTO public.who_global_data_import VALUES (76361, '2020-12-28', 'RS', 'Serbia', 'EURO', '2693', '326060', '47', '3030');
INSERT INTO public.who_global_data_import VALUES (76362, '2020-12-29', 'RS', 'Serbia', 'EURO', '2559', '328619', '43', '3073');
INSERT INTO public.who_global_data_import VALUES (76363, '2020-12-30', 'RS', 'Serbia', 'EURO', '3136', '331755', '46', '3119');
INSERT INTO public.who_global_data_import VALUES (76364, '2020-12-31', 'RS', 'Serbia', 'EURO', '3236', '334991', '44', '3163');
INSERT INTO public.who_global_data_import VALUES (76365, '2021-01-01', 'RS', 'Serbia', 'EURO', '2932', '337923', '48', '3211');
INSERT INTO public.who_global_data_import VALUES (76366, '2021-01-02', 'RS', 'Serbia', 'EURO', '2074', '339997', '39', '3250');
INSERT INTO public.who_global_data_import VALUES (76367, '2021-01-03', 'RS', 'Serbia', 'EURO', '1907', '341904', '38', '3288');
INSERT INTO public.who_global_data_import VALUES (76368, '2021-01-04', 'RS', 'Serbia', 'EURO', '1966', '343870', '37', '3325');
INSERT INTO public.who_global_data_import VALUES (76369, '2021-01-05', 'RS', 'Serbia', 'EURO', '2715', '346585', '39', '3364');
INSERT INTO public.who_global_data_import VALUES (76370, '2021-01-06', 'RS', 'Serbia', 'EURO', '2653', '349238', '41', '3405');
INSERT INTO public.who_global_data_import VALUES (76371, '2021-01-07', 'RS', 'Serbia', 'EURO', '2882', '352120', '39', '3444');
INSERT INTO public.who_global_data_import VALUES (76372, '2021-01-08', 'RS', 'Serbia', 'EURO', '1787', '353907', '35', '3479');
INSERT INTO public.who_global_data_import VALUES (76373, '2021-01-09', 'RS', 'Serbia', 'EURO', '2218', '356125', '34', '3513');
INSERT INTO public.who_global_data_import VALUES (76374, '2021-01-10', 'RS', 'Serbia', 'EURO', '1769', '357894', '35', '3548');
INSERT INTO public.who_global_data_import VALUES (76375, '2021-01-11', 'RS', 'Serbia', 'EURO', '1795', '359689', '34', '3582');
INSERT INTO public.who_global_data_import VALUES (76376, '2021-01-12', 'RS', 'Serbia', 'EURO', '2093', '361782', '28', '3610');
INSERT INTO public.who_global_data_import VALUES (76377, '2021-01-13', 'RS', 'Serbia', 'EURO', '2142', '363924', '29', '3639');
INSERT INTO public.who_global_data_import VALUES (76378, '2021-01-14', 'RS', 'Serbia', 'EURO', '2267', '366191', '25', '3664');
INSERT INTO public.who_global_data_import VALUES (76379, '2021-01-15', 'RS', 'Serbia', 'EURO', '1881', '368072', '23', '3687');
INSERT INTO public.who_global_data_import VALUES (76380, '2021-01-16', 'RS', 'Serbia', 'EURO', '1751', '369823', '21', '3708');
INSERT INTO public.who_global_data_import VALUES (76381, '2021-01-17', 'RS', 'Serbia', 'EURO', '1393', '371216', '22', '3730');
INSERT INTO public.who_global_data_import VALUES (76382, '2021-01-18', 'RS', 'Serbia', 'EURO', '1317', '372533', '20', '3750');
INSERT INTO public.who_global_data_import VALUES (76383, '2021-01-19', 'RS', 'Serbia', 'EURO', '1578', '374111', '21', '3771');
INSERT INTO public.who_global_data_import VALUES (76384, '2021-01-20', 'RS', 'Serbia', 'EURO', '1688', '375799', '20', '3791');
INSERT INTO public.who_global_data_import VALUES (76385, '2021-01-21', 'RS', 'Serbia', 'EURO', '1646', '377445', '19', '3810');
INSERT INTO public.who_global_data_import VALUES (76386, '2021-01-22', 'RS', 'Serbia', 'EURO', '1648', '379093', '20', '3830');
INSERT INTO public.who_global_data_import VALUES (76387, '2021-01-23', 'RS', 'Serbia', 'EURO', '1709', '380802', '19', '3849');
INSERT INTO public.who_global_data_import VALUES (76388, '2021-01-24', 'RS', 'Serbia', 'EURO', '1483', '382285', '19', '3868');
INSERT INTO public.who_global_data_import VALUES (76389, '2021-01-25', 'RS', 'Serbia', 'EURO', '1318', '383603', '18', '3886');
INSERT INTO public.who_global_data_import VALUES (76390, '2021-01-26', 'RS', 'Serbia', 'EURO', '1523', '385126', '19', '3905');
INSERT INTO public.who_global_data_import VALUES (76391, '2021-01-27', 'RS', 'Serbia', 'EURO', '2080', '387206', '19', '3924');
INSERT INTO public.who_global_data_import VALUES (76392, '2021-01-28', 'RS', 'Serbia', 'EURO', '1839', '389045', '20', '3944');
INSERT INTO public.who_global_data_import VALUES (76393, '2021-01-29', 'RS', 'Serbia', 'EURO', '1592', '390637', '21', '3965');
INSERT INTO public.who_global_data_import VALUES (76394, '2021-01-30', 'RS', 'Serbia', 'EURO', '1717', '392354', '18', '3983');
INSERT INTO public.who_global_data_import VALUES (76395, '2021-01-31', 'RS', 'Serbia', 'EURO', '1543', '393897', '17', '4000');
INSERT INTO public.who_global_data_import VALUES (76396, '2021-02-01', 'RS', 'Serbia', 'EURO', '1366', '395263', '20', '4020');
INSERT INTO public.who_global_data_import VALUES (76397, '2021-02-02', 'RS', 'Serbia', 'EURO', '1739', '397002', '18', '4038');
INSERT INTO public.who_global_data_import VALUES (76398, '2021-02-03', 'RS', 'Serbia', 'EURO', '1903', '398905', '18', '4056');
INSERT INTO public.who_global_data_import VALUES (76399, '2021-02-04', 'RS', 'Serbia', 'EURO', '1932', '400837', '15', '4071');
INSERT INTO public.who_global_data_import VALUES (76400, '2021-02-05', 'RS', 'Serbia', 'EURO', '1863', '402700', '14', '4085');
INSERT INTO public.who_global_data_import VALUES (76401, '2020-01-03', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76402, '2020-01-04', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76403, '2020-01-05', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76404, '2020-01-06', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76405, '2020-01-07', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76406, '2020-01-08', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76407, '2020-01-09', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76408, '2020-01-10', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76409, '2020-01-11', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76410, '2020-01-12', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76411, '2020-01-13', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76412, '2020-01-14', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76413, '2020-01-15', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76414, '2020-01-16', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76415, '2020-01-17', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76416, '2020-01-18', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76417, '2020-01-19', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76418, '2020-01-20', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76419, '2020-01-21', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76420, '2020-01-22', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76421, '2020-01-23', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76422, '2020-01-24', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76423, '2020-01-25', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76424, '2020-01-26', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76425, '2020-01-27', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76426, '2020-01-28', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76427, '2020-01-29', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76428, '2020-01-30', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76429, '2020-01-31', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76430, '2020-02-01', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76431, '2020-02-02', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76432, '2020-02-03', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76433, '2020-02-04', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76434, '2020-02-05', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76435, '2020-02-06', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76436, '2020-02-07', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76437, '2020-02-08', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76438, '2020-02-09', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76439, '2020-02-10', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76440, '2020-02-11', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76441, '2020-02-12', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76442, '2020-02-13', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76443, '2020-02-14', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76444, '2020-02-15', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76445, '2020-02-16', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76446, '2020-02-17', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76447, '2020-02-18', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76448, '2020-02-19', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76449, '2020-02-20', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76450, '2020-02-21', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76451, '2020-02-22', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76452, '2020-02-23', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76453, '2020-02-24', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76454, '2020-02-25', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76455, '2020-02-26', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76456, '2020-02-27', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76457, '2020-02-28', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76458, '2020-02-29', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76459, '2020-03-01', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76460, '2020-03-02', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76461, '2020-03-03', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76462, '2020-03-04', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76463, '2020-03-05', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76464, '2020-03-06', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76465, '2020-03-07', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76466, '2020-03-08', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76467, '2020-03-09', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76468, '2020-03-10', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76469, '2020-03-11', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76470, '2020-03-12', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76471, '2020-03-13', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76472, '2020-03-14', 'SC', 'Seychelles', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76473, '2020-03-15', 'SC', 'Seychelles', 'AFRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76474, '2020-03-16', 'SC', 'Seychelles', 'AFRO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76475, '2020-03-17', 'SC', 'Seychelles', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76476, '2020-03-18', 'SC', 'Seychelles', 'AFRO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76477, '2020-03-19', 'SC', 'Seychelles', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76478, '2020-03-20', 'SC', 'Seychelles', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76479, '2020-03-21', 'SC', 'Seychelles', 'AFRO', '-3', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76480, '2020-03-22', 'SC', 'Seychelles', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76481, '2020-03-23', 'SC', 'Seychelles', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76482, '2020-03-24', 'SC', 'Seychelles', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76483, '2020-03-25', 'SC', 'Seychelles', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76484, '2020-03-26', 'SC', 'Seychelles', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76485, '2020-03-27', 'SC', 'Seychelles', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76486, '2020-03-28', 'SC', 'Seychelles', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76487, '2020-03-29', 'SC', 'Seychelles', 'AFRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76488, '2020-03-30', 'SC', 'Seychelles', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76489, '2020-03-31', 'SC', 'Seychelles', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76490, '2020-04-01', 'SC', 'Seychelles', 'AFRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76491, '2020-04-02', 'SC', 'Seychelles', 'AFRO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76492, '2020-04-03', 'SC', 'Seychelles', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76493, '2020-04-04', 'SC', 'Seychelles', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76494, '2020-04-05', 'SC', 'Seychelles', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76495, '2020-04-06', 'SC', 'Seychelles', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76496, '2020-04-07', 'SC', 'Seychelles', 'AFRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76497, '2020-04-08', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76498, '2020-04-09', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76499, '2020-04-10', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76500, '2020-04-11', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76501, '2020-04-12', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76502, '2020-04-13', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76503, '2020-04-14', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76504, '2020-04-15', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76505, '2020-04-16', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76506, '2020-04-17', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76507, '2020-04-18', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76508, '2020-04-19', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76509, '2020-04-20', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76510, '2020-04-21', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76511, '2020-04-22', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76512, '2020-04-23', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76513, '2020-04-24', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76514, '2020-04-25', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76515, '2020-04-26', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76516, '2020-04-27', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76517, '2020-04-28', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76518, '2020-04-29', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76519, '2020-04-30', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76520, '2020-05-01', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76521, '2020-05-02', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76522, '2020-05-03', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76523, '2020-05-04', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76524, '2020-05-05', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76525, '2020-05-06', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76526, '2020-05-07', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76527, '2020-05-08', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76528, '2020-05-09', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76529, '2020-05-10', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76530, '2020-05-11', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76531, '2020-05-12', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76532, '2020-05-13', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76533, '2020-05-14', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76534, '2020-05-15', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76535, '2020-05-16', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76536, '2020-05-17', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76537, '2020-05-18', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76538, '2020-05-19', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76539, '2020-05-20', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76540, '2020-05-21', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76541, '2020-05-22', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76542, '2020-05-23', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76543, '2020-05-24', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76544, '2020-05-25', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76545, '2020-05-26', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76546, '2020-05-27', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76547, '2020-05-28', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76548, '2020-05-29', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76549, '2020-05-30', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76550, '2020-05-31', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76551, '2020-06-01', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76552, '2020-06-02', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76553, '2020-06-03', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76554, '2020-06-04', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76555, '2020-06-05', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76556, '2020-06-06', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76557, '2020-06-07', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76558, '2020-06-08', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76559, '2020-06-09', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76560, '2020-06-10', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76561, '2020-06-11', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76562, '2020-06-12', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76563, '2020-06-13', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76564, '2020-06-14', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76565, '2020-06-15', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76566, '2020-06-16', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76567, '2020-06-17', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76568, '2020-06-18', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76569, '2020-06-19', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76570, '2020-06-20', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76571, '2020-06-21', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76572, '2020-06-22', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76573, '2020-06-23', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76574, '2020-06-24', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76575, '2020-06-25', 'SC', 'Seychelles', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76576, '2020-06-26', 'SC', 'Seychelles', 'AFRO', '5', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76577, '2020-06-27', 'SC', 'Seychelles', 'AFRO', '4', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76578, '2020-06-28', 'SC', 'Seychelles', 'AFRO', '50', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76579, '2020-06-29', 'SC', 'Seychelles', 'AFRO', '7', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76580, '2020-06-30', 'SC', 'Seychelles', 'AFRO', '4', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76581, '2020-07-01', 'SC', 'Seychelles', 'AFRO', '0', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76582, '2020-07-02', 'SC', 'Seychelles', 'AFRO', '0', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76583, '2020-07-03', 'SC', 'Seychelles', 'AFRO', '0', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76584, '2020-07-04', 'SC', 'Seychelles', 'AFRO', '0', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76585, '2020-07-05', 'SC', 'Seychelles', 'AFRO', '0', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76586, '2020-07-06', 'SC', 'Seychelles', 'AFRO', '0', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76587, '2020-07-07', 'SC', 'Seychelles', 'AFRO', '0', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76588, '2020-07-08', 'SC', 'Seychelles', 'AFRO', '10', '91', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76589, '2020-07-09', 'SC', 'Seychelles', 'AFRO', '3', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76590, '2020-07-10', 'SC', 'Seychelles', 'AFRO', '6', '100', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76591, '2020-07-11', 'SC', 'Seychelles', 'AFRO', '0', '100', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76592, '2020-07-12', 'SC', 'Seychelles', 'AFRO', '0', '100', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76593, '2020-07-13', 'SC', 'Seychelles', 'AFRO', '0', '100', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76594, '2020-07-14', 'SC', 'Seychelles', 'AFRO', '0', '100', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76595, '2020-07-15', 'SC', 'Seychelles', 'AFRO', '0', '100', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76596, '2020-07-16', 'SC', 'Seychelles', 'AFRO', '8', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76597, '2020-07-17', 'SC', 'Seychelles', 'AFRO', '0', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76598, '2020-07-18', 'SC', 'Seychelles', 'AFRO', '0', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76599, '2020-07-19', 'SC', 'Seychelles', 'AFRO', '0', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76600, '2020-07-20', 'SC', 'Seychelles', 'AFRO', '0', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76601, '2020-07-21', 'SC', 'Seychelles', 'AFRO', '0', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76602, '2020-07-22', 'SC', 'Seychelles', 'AFRO', '0', '108', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76603, '2020-07-23', 'SC', 'Seychelles', 'AFRO', '-1', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76604, '2020-07-24', 'SC', 'Seychelles', 'AFRO', '0', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76605, '2020-07-25', 'SC', 'Seychelles', 'AFRO', '0', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76606, '2020-07-26', 'SC', 'Seychelles', 'AFRO', '0', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76607, '2020-07-27', 'SC', 'Seychelles', 'AFRO', '0', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76608, '2020-07-28', 'SC', 'Seychelles', 'AFRO', '7', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76609, '2020-07-29', 'SC', 'Seychelles', 'AFRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76610, '2020-07-30', 'SC', 'Seychelles', 'AFRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76611, '2020-07-31', 'SC', 'Seychelles', 'AFRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76612, '2020-08-01', 'SC', 'Seychelles', 'AFRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76613, '2020-08-02', 'SC', 'Seychelles', 'AFRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76614, '2020-08-03', 'SC', 'Seychelles', 'AFRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76615, '2020-08-04', 'SC', 'Seychelles', 'AFRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76616, '2020-08-05', 'SC', 'Seychelles', 'AFRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76617, '2020-08-06', 'SC', 'Seychelles', 'AFRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76618, '2020-08-07', 'SC', 'Seychelles', 'AFRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76619, '2020-08-08', 'SC', 'Seychelles', 'AFRO', '12', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76620, '2020-08-09', 'SC', 'Seychelles', 'AFRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76621, '2020-08-10', 'SC', 'Seychelles', 'AFRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76622, '2020-08-11', 'SC', 'Seychelles', 'AFRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76623, '2020-08-12', 'SC', 'Seychelles', 'AFRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76624, '2020-08-13', 'SC', 'Seychelles', 'AFRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76625, '2020-08-14', 'SC', 'Seychelles', 'AFRO', '0', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76626, '2020-08-15', 'SC', 'Seychelles', 'AFRO', '1', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76627, '2020-08-16', 'SC', 'Seychelles', 'AFRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76628, '2020-08-17', 'SC', 'Seychelles', 'AFRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76629, '2020-08-18', 'SC', 'Seychelles', 'AFRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76630, '2020-08-19', 'SC', 'Seychelles', 'AFRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76631, '2020-08-20', 'SC', 'Seychelles', 'AFRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76632, '2020-08-21', 'SC', 'Seychelles', 'AFRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76633, '2020-08-22', 'SC', 'Seychelles', 'AFRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76634, '2020-08-23', 'SC', 'Seychelles', 'AFRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76635, '2020-08-24', 'SC', 'Seychelles', 'AFRO', '0', '127', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76636, '2020-08-25', 'SC', 'Seychelles', 'AFRO', '4', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76637, '2020-08-26', 'SC', 'Seychelles', 'AFRO', '0', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76638, '2020-08-27', 'SC', 'Seychelles', 'AFRO', '0', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76639, '2020-08-28', 'SC', 'Seychelles', 'AFRO', '0', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76640, '2020-08-29', 'SC', 'Seychelles', 'AFRO', '0', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76641, '2020-08-30', 'SC', 'Seychelles', 'AFRO', '0', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76642, '2020-08-31', 'SC', 'Seychelles', 'AFRO', '0', '131', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76643, '2020-09-01', 'SC', 'Seychelles', 'AFRO', '4', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76644, '2020-09-02', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76645, '2020-09-03', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76646, '2020-09-04', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76647, '2020-09-05', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76648, '2020-09-06', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76649, '2020-09-07', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76650, '2020-09-08', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76651, '2020-09-09', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76652, '2020-09-10', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76653, '2020-09-11', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76654, '2020-09-12', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76655, '2020-09-13', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76656, '2020-09-14', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76657, '2020-09-15', 'SC', 'Seychelles', 'AFRO', '0', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76658, '2020-09-16', 'SC', 'Seychelles', 'AFRO', '3', '138', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76659, '2020-09-17', 'SC', 'Seychelles', 'AFRO', '0', '138', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76660, '2020-09-18', 'SC', 'Seychelles', 'AFRO', '1', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76661, '2020-09-19', 'SC', 'Seychelles', 'AFRO', '0', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76662, '2020-09-20', 'SC', 'Seychelles', 'AFRO', '0', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76663, '2020-09-21', 'SC', 'Seychelles', 'AFRO', '0', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76664, '2020-09-22', 'SC', 'Seychelles', 'AFRO', '0', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76665, '2020-09-23', 'SC', 'Seychelles', 'AFRO', '0', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76666, '2020-09-24', 'SC', 'Seychelles', 'AFRO', '0', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76667, '2020-09-25', 'SC', 'Seychelles', 'AFRO', '0', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76668, '2020-09-26', 'SC', 'Seychelles', 'AFRO', '2', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76669, '2020-09-27', 'SC', 'Seychelles', 'AFRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76670, '2020-09-28', 'SC', 'Seychelles', 'AFRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76671, '2020-09-29', 'SC', 'Seychelles', 'AFRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76672, '2020-09-30', 'SC', 'Seychelles', 'AFRO', '0', '141', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76673, '2020-10-01', 'SC', 'Seychelles', 'AFRO', '1', '142', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76674, '2020-10-02', 'SC', 'Seychelles', 'AFRO', '0', '142', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76675, '2020-10-03', 'SC', 'Seychelles', 'AFRO', '0', '142', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76676, '2020-10-04', 'SC', 'Seychelles', 'AFRO', '0', '142', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76677, '2020-10-05', 'SC', 'Seychelles', 'AFRO', '0', '142', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76678, '2020-10-06', 'SC', 'Seychelles', 'AFRO', '0', '142', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76679, '2020-10-07', 'SC', 'Seychelles', 'AFRO', '4', '146', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76680, '2020-10-08', 'SC', 'Seychelles', 'AFRO', '1', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76681, '2020-10-09', 'SC', 'Seychelles', 'AFRO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76682, '2020-10-10', 'SC', 'Seychelles', 'AFRO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76683, '2020-10-11', 'SC', 'Seychelles', 'AFRO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76684, '2020-10-12', 'SC', 'Seychelles', 'AFRO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76685, '2020-10-13', 'SC', 'Seychelles', 'AFRO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76686, '2020-10-14', 'SC', 'Seychelles', 'AFRO', '0', '147', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76687, '2020-10-15', 'SC', 'Seychelles', 'AFRO', '1', '148', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76688, '2020-10-16', 'SC', 'Seychelles', 'AFRO', '0', '148', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76689, '2020-10-17', 'SC', 'Seychelles', 'AFRO', '0', '148', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76690, '2020-10-18', 'SC', 'Seychelles', 'AFRO', '0', '148', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76691, '2020-10-19', 'SC', 'Seychelles', 'AFRO', '0', '148', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76692, '2020-10-20', 'SC', 'Seychelles', 'AFRO', '0', '148', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76693, '2020-10-21', 'SC', 'Seychelles', 'AFRO', '0', '148', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76694, '2020-10-22', 'SC', 'Seychelles', 'AFRO', '1', '149', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76695, '2020-10-23', 'SC', 'Seychelles', 'AFRO', '3', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76696, '2020-10-24', 'SC', 'Seychelles', 'AFRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76697, '2020-10-25', 'SC', 'Seychelles', 'AFRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76698, '2020-10-26', 'SC', 'Seychelles', 'AFRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76699, '2020-10-27', 'SC', 'Seychelles', 'AFRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76700, '2020-10-28', 'SC', 'Seychelles', 'AFRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76701, '2020-10-29', 'SC', 'Seychelles', 'AFRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76702, '2020-10-30', 'SC', 'Seychelles', 'AFRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76703, '2020-10-31', 'SC', 'Seychelles', 'AFRO', '0', '152', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76704, '2020-11-01', 'SC', 'Seychelles', 'AFRO', '2', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76705, '2020-11-02', 'SC', 'Seychelles', 'AFRO', '0', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76706, '2020-11-03', 'SC', 'Seychelles', 'AFRO', '0', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76707, '2020-11-04', 'SC', 'Seychelles', 'AFRO', '0', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76708, '2020-11-05', 'SC', 'Seychelles', 'AFRO', '0', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76709, '2020-11-06', 'SC', 'Seychelles', 'AFRO', '0', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76710, '2020-11-07', 'SC', 'Seychelles', 'AFRO', '0', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76711, '2020-11-08', 'SC', 'Seychelles', 'AFRO', '0', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76712, '2020-11-09', 'SC', 'Seychelles', 'AFRO', '0', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76713, '2020-11-10', 'SC', 'Seychelles', 'AFRO', '0', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76714, '2020-11-11', 'SC', 'Seychelles', 'AFRO', '4', '158', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76715, '2020-11-12', 'SC', 'Seychelles', 'AFRO', '0', '158', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76716, '2020-11-13', 'SC', 'Seychelles', 'AFRO', '0', '158', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76717, '2020-11-14', 'SC', 'Seychelles', 'AFRO', '0', '158', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76718, '2020-11-15', 'SC', 'Seychelles', 'AFRO', '0', '158', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76719, '2020-11-16', 'SC', 'Seychelles', 'AFRO', '0', '158', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76720, '2020-11-17', 'SC', 'Seychelles', 'AFRO', '0', '158', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76721, '2020-11-18', 'SC', 'Seychelles', 'AFRO', '3', '161', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76722, '2020-11-19', 'SC', 'Seychelles', 'AFRO', '0', '161', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76723, '2020-11-20', 'SC', 'Seychelles', 'AFRO', '0', '161', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76724, '2020-11-21', 'SC', 'Seychelles', 'AFRO', '0', '161', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76725, '2020-11-22', 'SC', 'Seychelles', 'AFRO', '0', '161', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76726, '2020-11-23', 'SC', 'Seychelles', 'AFRO', '0', '161', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76727, '2020-11-24', 'SC', 'Seychelles', 'AFRO', '0', '161', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76728, '2020-11-25', 'SC', 'Seychelles', 'AFRO', '6', '167', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76729, '2020-11-26', 'SC', 'Seychelles', 'AFRO', '0', '167', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76730, '2020-11-27', 'SC', 'Seychelles', 'AFRO', '0', '167', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76731, '2020-11-28', 'SC', 'Seychelles', 'AFRO', '0', '167', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76732, '2020-11-29', 'SC', 'Seychelles', 'AFRO', '5', '172', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76733, '2020-11-30', 'SC', 'Seychelles', 'AFRO', '0', '172', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76734, '2020-12-01', 'SC', 'Seychelles', 'AFRO', '0', '172', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76735, '2020-12-02', 'SC', 'Seychelles', 'AFRO', '0', '172', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76736, '2020-12-03', 'SC', 'Seychelles', 'AFRO', '9', '181', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76737, '2020-12-04', 'SC', 'Seychelles', 'AFRO', '0', '181', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76738, '2020-12-05', 'SC', 'Seychelles', 'AFRO', '1', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76739, '2020-12-06', 'SC', 'Seychelles', 'AFRO', '0', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76740, '2020-12-07', 'SC', 'Seychelles', 'AFRO', '0', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76741, '2020-12-08', 'SC', 'Seychelles', 'AFRO', '0', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76742, '2020-12-09', 'SC', 'Seychelles', 'AFRO', '0', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76743, '2020-12-10', 'SC', 'Seychelles', 'AFRO', '0', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76744, '2020-12-11', 'SC', 'Seychelles', 'AFRO', '0', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76745, '2020-12-12', 'SC', 'Seychelles', 'AFRO', '3', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76746, '2020-12-13', 'SC', 'Seychelles', 'AFRO', '0', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76747, '2020-12-14', 'SC', 'Seychelles', 'AFRO', '0', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76748, '2020-12-15', 'SC', 'Seychelles', 'AFRO', '0', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76749, '2020-12-16', 'SC', 'Seychelles', 'AFRO', '0', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76750, '2020-12-17', 'SC', 'Seychelles', 'AFRO', '17', '202', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76751, '2020-12-18', 'SC', 'Seychelles', 'AFRO', '0', '202', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76752, '2020-12-19', 'SC', 'Seychelles', 'AFRO', '0', '202', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76753, '2020-12-20', 'SC', 'Seychelles', 'AFRO', '0', '202', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76754, '2020-12-21', 'SC', 'Seychelles', 'AFRO', '0', '202', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76755, '2020-12-22', 'SC', 'Seychelles', 'AFRO', '0', '202', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76756, '2020-12-23', 'SC', 'Seychelles', 'AFRO', '9', '211', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76757, '2020-12-24', 'SC', 'Seychelles', 'AFRO', '0', '211', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76758, '2020-12-25', 'SC', 'Seychelles', 'AFRO', '0', '211', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76759, '2020-12-26', 'SC', 'Seychelles', 'AFRO', '0', '211', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76760, '2020-12-27', 'SC', 'Seychelles', 'AFRO', '0', '211', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76761, '2020-12-28', 'SC', 'Seychelles', 'AFRO', '0', '211', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76762, '2020-12-29', 'SC', 'Seychelles', 'AFRO', '0', '211', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76763, '2020-12-30', 'SC', 'Seychelles', 'AFRO', '15', '226', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76764, '2020-12-31', 'SC', 'Seychelles', 'AFRO', '0', '226', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76765, '2021-01-01', 'SC', 'Seychelles', 'AFRO', '41', '267', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76766, '2021-01-02', 'SC', 'Seychelles', 'AFRO', '0', '267', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76767, '2021-01-03', 'SC', 'Seychelles', 'AFRO', '17', '284', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76768, '2021-01-04', 'SC', 'Seychelles', 'AFRO', '12', '296', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76769, '2021-01-05', 'SC', 'Seychelles', 'AFRO', '26', '322', '1', '1');
INSERT INTO public.who_global_data_import VALUES (76770, '2021-01-06', 'SC', 'Seychelles', 'AFRO', '24', '346', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76771, '2021-01-07', 'SC', 'Seychelles', 'AFRO', '27', '373', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76772, '2021-01-08', 'SC', 'Seychelles', 'AFRO', '45', '418', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76773, '2021-01-09', 'SC', 'Seychelles', 'AFRO', '30', '448', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76774, '2021-01-10', 'SC', 'Seychelles', 'AFRO', '54', '502', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76775, '2021-01-11', 'SC', 'Seychelles', 'AFRO', '23', '525', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76776, '2021-01-12', 'SC', 'Seychelles', 'AFRO', '52', '577', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76777, '2021-01-13', 'SC', 'Seychelles', 'AFRO', '0', '577', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76778, '2021-01-14', 'SC', 'Seychelles', 'AFRO', '33', '610', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76779, '2021-01-15', 'SC', 'Seychelles', 'AFRO', '16', '626', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76780, '2021-01-16', 'SC', 'Seychelles', 'AFRO', '0', '626', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76781, '2021-01-17', 'SC', 'Seychelles', 'AFRO', '63', '689', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76782, '2021-01-18', 'SC', 'Seychelles', 'AFRO', '-1', '688', '1', '2');
INSERT INTO public.who_global_data_import VALUES (76783, '2021-01-19', 'SC', 'Seychelles', 'AFRO', '58', '746', '0', '2');
INSERT INTO public.who_global_data_import VALUES (76784, '2021-01-20', 'SC', 'Seychelles', 'AFRO', '16', '762', '0', '2');
INSERT INTO public.who_global_data_import VALUES (76785, '2021-01-21', 'SC', 'Seychelles', 'AFRO', '82', '844', '1', '3');
INSERT INTO public.who_global_data_import VALUES (76786, '2021-01-22', 'SC', 'Seychelles', 'AFRO', '22', '866', '0', '3');
INSERT INTO public.who_global_data_import VALUES (76787, '2021-01-23', 'SC', 'Seychelles', 'AFRO', '106', '972', '0', '3');
INSERT INTO public.who_global_data_import VALUES (76788, '2021-01-24', 'SC', 'Seychelles', 'AFRO', '61', '1033', '0', '3');
INSERT INTO public.who_global_data_import VALUES (76789, '2021-01-25', 'SC', 'Seychelles', 'AFRO', '0', '1033', '0', '3');
INSERT INTO public.who_global_data_import VALUES (76790, '2021-01-26', 'SC', 'Seychelles', 'AFRO', '36', '1069', '0', '3');
INSERT INTO public.who_global_data_import VALUES (76791, '2021-01-27', 'SC', 'Seychelles', 'AFRO', '47', '1116', '0', '3');
INSERT INTO public.who_global_data_import VALUES (76792, '2021-01-28', 'SC', 'Seychelles', 'AFRO', '14', '1130', '0', '3');
INSERT INTO public.who_global_data_import VALUES (76793, '2021-01-29', 'SC', 'Seychelles', 'AFRO', '0', '1130', '0', '3');
INSERT INTO public.who_global_data_import VALUES (76794, '2021-01-30', 'SC', 'Seychelles', 'AFRO', '27', '1157', '0', '3');
INSERT INTO public.who_global_data_import VALUES (76795, '2021-01-31', 'SC', 'Seychelles', 'AFRO', '29', '1186', '0', '3');
INSERT INTO public.who_global_data_import VALUES (76796, '2021-02-01', 'SC', 'Seychelles', 'AFRO', '15', '1201', '1', '4');
INSERT INTO public.who_global_data_import VALUES (76797, '2021-02-02', 'SC', 'Seychelles', 'AFRO', '4', '1205', '0', '4');
INSERT INTO public.who_global_data_import VALUES (76798, '2021-02-03', 'SC', 'Seychelles', 'AFRO', '38', '1243', '1', '5');
INSERT INTO public.who_global_data_import VALUES (76799, '2021-02-04', 'SC', 'Seychelles', 'AFRO', '0', '1243', '0', '5');
INSERT INTO public.who_global_data_import VALUES (76800, '2021-02-05', 'SC', 'Seychelles', 'AFRO', '36', '1279', '0', '5');
INSERT INTO public.who_global_data_import VALUES (76801, '2020-01-03', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76802, '2020-01-04', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76803, '2020-01-05', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76804, '2020-01-06', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76805, '2020-01-07', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76806, '2020-01-08', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76807, '2020-01-09', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76808, '2020-01-10', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76809, '2020-01-11', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76810, '2020-01-12', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76811, '2020-01-13', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76812, '2020-01-14', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76813, '2020-01-15', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76814, '2020-01-16', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76815, '2020-01-17', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76816, '2020-01-18', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76817, '2020-01-19', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76818, '2020-01-20', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76819, '2020-01-21', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76820, '2020-01-22', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76821, '2020-01-23', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76822, '2020-01-24', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76823, '2020-01-25', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76824, '2020-01-26', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76825, '2020-01-27', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76826, '2020-01-28', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76827, '2020-01-29', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76828, '2020-01-30', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76829, '2020-01-31', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76830, '2020-02-01', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76831, '2020-02-02', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76832, '2020-02-03', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76833, '2020-02-04', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76834, '2020-02-05', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76835, '2020-02-06', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76836, '2020-02-07', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76837, '2020-02-08', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76838, '2020-02-09', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76839, '2020-02-10', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76840, '2020-02-11', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76841, '2020-02-12', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76842, '2020-02-13', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76843, '2020-02-14', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76844, '2020-02-15', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76845, '2020-02-16', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76846, '2020-02-17', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76847, '2020-02-18', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76848, '2020-02-19', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76849, '2020-02-20', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76850, '2020-02-21', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76851, '2020-02-22', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76852, '2020-02-23', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76853, '2020-02-24', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76854, '2020-02-25', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76855, '2020-02-26', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76856, '2020-02-27', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76857, '2020-02-28', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76858, '2020-02-29', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76859, '2020-03-01', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76860, '2020-03-02', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76861, '2020-03-03', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76862, '2020-03-04', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76863, '2020-03-05', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76864, '2020-03-06', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76865, '2020-03-07', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76866, '2020-03-08', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76867, '2020-03-09', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76868, '2020-03-10', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76869, '2020-03-11', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76870, '2020-03-12', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76871, '2020-03-13', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76872, '2020-03-14', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76873, '2020-03-15', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76874, '2020-03-16', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76875, '2020-03-17', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76876, '2020-03-18', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76877, '2020-03-19', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76878, '2020-03-20', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76879, '2020-03-21', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76880, '2020-03-22', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76881, '2020-03-23', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76882, '2020-03-24', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76883, '2020-03-25', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76884, '2020-03-26', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76885, '2020-03-27', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76886, '2020-03-28', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76887, '2020-03-29', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76888, '2020-03-30', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76889, '2020-03-31', 'SL', 'Sierra Leone', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76890, '2020-04-01', 'SL', 'Sierra Leone', 'AFRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76891, '2020-04-02', 'SL', 'Sierra Leone', 'AFRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76892, '2020-04-03', 'SL', 'Sierra Leone', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76893, '2020-04-04', 'SL', 'Sierra Leone', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76894, '2020-04-05', 'SL', 'Sierra Leone', 'AFRO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76895, '2020-04-06', 'SL', 'Sierra Leone', 'AFRO', '2', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76896, '2020-04-07', 'SL', 'Sierra Leone', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76897, '2020-04-08', 'SL', 'Sierra Leone', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76898, '2020-04-09', 'SL', 'Sierra Leone', 'AFRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76899, '2020-04-10', 'SL', 'Sierra Leone', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76900, '2020-04-11', 'SL', 'Sierra Leone', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76901, '2020-04-12', 'SL', 'Sierra Leone', 'AFRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76902, '2020-04-13', 'SL', 'Sierra Leone', 'AFRO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76903, '2020-04-14', 'SL', 'Sierra Leone', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76904, '2020-04-15', 'SL', 'Sierra Leone', 'AFRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76905, '2020-04-16', 'SL', 'Sierra Leone', 'AFRO', '2', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76906, '2020-04-17', 'SL', 'Sierra Leone', 'AFRO', '2', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76907, '2020-04-18', 'SL', 'Sierra Leone', 'AFRO', '11', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76908, '2020-04-19', 'SL', 'Sierra Leone', 'AFRO', '4', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76909, '2020-04-20', 'SL', 'Sierra Leone', 'AFRO', '5', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76910, '2020-04-21', 'SL', 'Sierra Leone', 'AFRO', '8', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76911, '2020-04-22', 'SL', 'Sierra Leone', 'AFRO', '7', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (76912, '2020-04-23', 'SL', 'Sierra Leone', 'AFRO', '11', '61', '1', '1');
INSERT INTO public.who_global_data_import VALUES (76913, '2020-04-24', 'SL', 'Sierra Leone', 'AFRO', '3', '64', '0', '1');
INSERT INTO public.who_global_data_import VALUES (76914, '2020-04-25', 'SL', 'Sierra Leone', 'AFRO', '18', '82', '2', '3');
INSERT INTO public.who_global_data_import VALUES (76915, '2020-04-26', 'SL', 'Sierra Leone', 'AFRO', '4', '86', '0', '3');
INSERT INTO public.who_global_data_import VALUES (76916, '2020-04-27', 'SL', 'Sierra Leone', 'AFRO', '7', '93', '1', '4');
INSERT INTO public.who_global_data_import VALUES (76917, '2020-04-28', 'SL', 'Sierra Leone', 'AFRO', '6', '99', '0', '4');
INSERT INTO public.who_global_data_import VALUES (76918, '2020-04-29', 'SL', 'Sierra Leone', 'AFRO', '5', '104', '0', '4');
INSERT INTO public.who_global_data_import VALUES (76919, '2020-04-30', 'SL', 'Sierra Leone', 'AFRO', '12', '116', '1', '5');
INSERT INTO public.who_global_data_import VALUES (76920, '2020-05-01', 'SL', 'Sierra Leone', 'AFRO', '8', '124', '2', '7');
INSERT INTO public.who_global_data_import VALUES (76921, '2020-05-02', 'SL', 'Sierra Leone', 'AFRO', '12', '136', '1', '8');
INSERT INTO public.who_global_data_import VALUES (76922, '2020-05-03', 'SL', 'Sierra Leone', 'AFRO', '19', '155', '0', '8');
INSERT INTO public.who_global_data_import VALUES (76923, '2020-05-04', 'SL', 'Sierra Leone', 'AFRO', '2', '157', '0', '8');
INSERT INTO public.who_global_data_import VALUES (76924, '2020-05-05', 'SL', 'Sierra Leone', 'AFRO', '21', '178', '1', '9');
INSERT INTO public.who_global_data_import VALUES (76925, '2020-05-06', 'SL', 'Sierra Leone', 'AFRO', '21', '199', '2', '11');
INSERT INTO public.who_global_data_import VALUES (76926, '2020-05-07', 'SL', 'Sierra Leone', 'AFRO', '26', '225', '3', '14');
INSERT INTO public.who_global_data_import VALUES (76927, '2020-05-08', 'SL', 'Sierra Leone', 'AFRO', '6', '231', '0', '14');
INSERT INTO public.who_global_data_import VALUES (76928, '2020-05-09', 'SL', 'Sierra Leone', 'AFRO', '26', '257', '3', '17');
INSERT INTO public.who_global_data_import VALUES (76929, '2020-05-10', 'SL', 'Sierra Leone', 'AFRO', '34', '291', '1', '18');
INSERT INTO public.who_global_data_import VALUES (76930, '2020-05-11', 'SL', 'Sierra Leone', 'AFRO', '16', '307', '0', '18');
INSERT INTO public.who_global_data_import VALUES (76931, '2020-05-12', 'SL', 'Sierra Leone', 'AFRO', '31', '338', '1', '19');
INSERT INTO public.who_global_data_import VALUES (76932, '2020-05-13', 'SL', 'Sierra Leone', 'AFRO', '0', '338', '1', '20');
INSERT INTO public.who_global_data_import VALUES (76933, '2020-05-14', 'SL', 'Sierra Leone', 'AFRO', '49', '387', '1', '21');
INSERT INTO public.who_global_data_import VALUES (76934, '2020-05-15', 'SL', 'Sierra Leone', 'AFRO', '21', '408', '5', '26');
INSERT INTO public.who_global_data_import VALUES (76935, '2020-05-16', 'SL', 'Sierra Leone', 'AFRO', '39', '447', '1', '27');
INSERT INTO public.who_global_data_import VALUES (76936, '2020-05-17', 'SL', 'Sierra Leone', 'AFRO', '15', '462', '2', '29');
INSERT INTO public.who_global_data_import VALUES (76937, '2020-05-18', 'SL', 'Sierra Leone', 'AFRO', '43', '505', '3', '32');
INSERT INTO public.who_global_data_import VALUES (76938, '2020-05-19', 'SL', 'Sierra Leone', 'AFRO', '14', '519', '1', '33');
INSERT INTO public.who_global_data_import VALUES (76939, '2020-05-20', 'SL', 'Sierra Leone', 'AFRO', '15', '534', '0', '33');
INSERT INTO public.who_global_data_import VALUES (76940, '2020-05-21', 'SL', 'Sierra Leone', 'AFRO', '36', '570', '1', '34');
INSERT INTO public.who_global_data_import VALUES (76941, '2020-05-22', 'SL', 'Sierra Leone', 'AFRO', '15', '585', '1', '35');
INSERT INTO public.who_global_data_import VALUES (76942, '2020-05-23', 'SL', 'Sierra Leone', 'AFRO', '21', '606', '3', '38');
INSERT INTO public.who_global_data_import VALUES (76943, '2020-05-24', 'SL', 'Sierra Leone', 'AFRO', '15', '621', '1', '39');
INSERT INTO public.who_global_data_import VALUES (76944, '2020-05-25', 'SL', 'Sierra Leone', 'AFRO', '100', '721', '1', '40');
INSERT INTO public.who_global_data_import VALUES (76945, '2020-05-26', 'SL', 'Sierra Leone', 'AFRO', '14', '735', '2', '42');
INSERT INTO public.who_global_data_import VALUES (76946, '2020-05-27', 'SL', 'Sierra Leone', 'AFRO', '19', '754', '2', '44');
INSERT INTO public.who_global_data_import VALUES (76947, '2020-05-28', 'SL', 'Sierra Leone', 'AFRO', '28', '782', '1', '45');
INSERT INTO public.who_global_data_import VALUES (76948, '2020-05-29', 'SL', 'Sierra Leone', 'AFRO', '30', '812', '0', '45');
INSERT INTO public.who_global_data_import VALUES (76949, '2020-05-30', 'SL', 'Sierra Leone', 'AFRO', '17', '829', '0', '45');
INSERT INTO public.who_global_data_import VALUES (76950, '2020-05-31', 'SL', 'Sierra Leone', 'AFRO', '23', '852', '1', '46');
INSERT INTO public.who_global_data_import VALUES (76951, '2020-06-01', 'SL', 'Sierra Leone', 'AFRO', '9', '861', '0', '46');
INSERT INTO public.who_global_data_import VALUES (76952, '2020-06-02', 'SL', 'Sierra Leone', 'AFRO', '4', '865', '0', '46');
INSERT INTO public.who_global_data_import VALUES (76953, '2020-06-03', 'SL', 'Sierra Leone', 'AFRO', '31', '896', '0', '46');
INSERT INTO public.who_global_data_import VALUES (76954, '2020-06-04', 'SL', 'Sierra Leone', 'AFRO', '13', '909', '1', '47');
INSERT INTO public.who_global_data_import VALUES (76955, '2020-06-05', 'SL', 'Sierra Leone', 'AFRO', '5', '914', '0', '47');
INSERT INTO public.who_global_data_import VALUES (76956, '2020-06-06', 'SL', 'Sierra Leone', 'AFRO', '15', '929', '0', '47');
INSERT INTO public.who_global_data_import VALUES (76957, '2020-06-07', 'SL', 'Sierra Leone', 'AFRO', '17', '946', '1', '48');
INSERT INTO public.who_global_data_import VALUES (76958, '2020-06-08', 'SL', 'Sierra Leone', 'AFRO', '23', '969', '0', '48');
INSERT INTO public.who_global_data_import VALUES (76959, '2020-06-09', 'SL', 'Sierra Leone', 'AFRO', '32', '1001', '1', '49');
INSERT INTO public.who_global_data_import VALUES (76960, '2020-06-10', 'SL', 'Sierra Leone', 'AFRO', '24', '1025', '1', '50');
INSERT INTO public.who_global_data_import VALUES (76961, '2020-06-11', 'SL', 'Sierra Leone', 'AFRO', '37', '1062', '0', '50');
INSERT INTO public.who_global_data_import VALUES (76962, '2020-06-12', 'SL', 'Sierra Leone', 'AFRO', '23', '1085', '0', '50');
INSERT INTO public.who_global_data_import VALUES (76963, '2020-06-13', 'SL', 'Sierra Leone', 'AFRO', '18', '1103', '1', '51');
INSERT INTO public.who_global_data_import VALUES (76964, '2020-06-14', 'SL', 'Sierra Leone', 'AFRO', '29', '1132', '0', '51');
INSERT INTO public.who_global_data_import VALUES (76965, '2020-06-15', 'SL', 'Sierra Leone', 'AFRO', '37', '1169', '0', '51');
INSERT INTO public.who_global_data_import VALUES (76966, '2020-06-16', 'SL', 'Sierra Leone', 'AFRO', '7', '1176', '0', '51');
INSERT INTO public.who_global_data_import VALUES (76967, '2020-06-17', 'SL', 'Sierra Leone', 'AFRO', '49', '1225', '0', '51');
INSERT INTO public.who_global_data_import VALUES (76968, '2020-06-18', 'SL', 'Sierra Leone', 'AFRO', '24', '1249', '0', '51');
INSERT INTO public.who_global_data_import VALUES (76969, '2020-06-19', 'SL', 'Sierra Leone', 'AFRO', '23', '1272', '0', '51');
INSERT INTO public.who_global_data_import VALUES (76970, '2020-06-20', 'SL', 'Sierra Leone', 'AFRO', '26', '1298', '2', '53');
INSERT INTO public.who_global_data_import VALUES (76971, '2020-06-21', 'SL', 'Sierra Leone', 'AFRO', '11', '1309', '0', '53');
INSERT INTO public.who_global_data_import VALUES (76972, '2020-06-22', 'SL', 'Sierra Leone', 'AFRO', '18', '1327', '2', '55');
INSERT INTO public.who_global_data_import VALUES (76973, '2020-06-23', 'SL', 'Sierra Leone', 'AFRO', '13', '1340', '0', '55');
INSERT INTO public.who_global_data_import VALUES (76974, '2020-06-24', 'SL', 'Sierra Leone', 'AFRO', '7', '1347', '0', '55');
INSERT INTO public.who_global_data_import VALUES (76975, '2020-06-25', 'SL', 'Sierra Leone', 'AFRO', '7', '1354', '1', '56');
INSERT INTO public.who_global_data_import VALUES (76976, '2020-06-26', 'SL', 'Sierra Leone', 'AFRO', '27', '1381', '0', '56');
INSERT INTO public.who_global_data_import VALUES (76977, '2020-06-27', 'SL', 'Sierra Leone', 'AFRO', '13', '1394', '3', '59');
INSERT INTO public.who_global_data_import VALUES (76978, '2020-06-28', 'SL', 'Sierra Leone', 'AFRO', '16', '1410', '0', '59');
INSERT INTO public.who_global_data_import VALUES (76979, '2020-06-29', 'SL', 'Sierra Leone', 'AFRO', '17', '1427', '1', '60');
INSERT INTO public.who_global_data_import VALUES (76980, '2020-06-30', 'SL', 'Sierra Leone', 'AFRO', '23', '1450', '0', '60');
INSERT INTO public.who_global_data_import VALUES (76981, '2020-07-01', 'SL', 'Sierra Leone', 'AFRO', '12', '1462', '0', '60');
INSERT INTO public.who_global_data_import VALUES (76982, '2020-07-02', 'SL', 'Sierra Leone', 'AFRO', '36', '1498', '0', '60');
INSERT INTO public.who_global_data_import VALUES (76983, '2020-07-03', 'SL', 'Sierra Leone', 'AFRO', '20', '1518', '0', '60');
INSERT INTO public.who_global_data_import VALUES (76984, '2020-07-04', 'SL', 'Sierra Leone', 'AFRO', '6', '1524', '2', '62');
INSERT INTO public.who_global_data_import VALUES (76985, '2020-07-05', 'SL', 'Sierra Leone', 'AFRO', '9', '1533', '0', '62');
INSERT INTO public.who_global_data_import VALUES (76986, '2020-07-06', 'SL', 'Sierra Leone', 'AFRO', '9', '1542', '0', '62');
INSERT INTO public.who_global_data_import VALUES (76987, '2020-07-07', 'SL', 'Sierra Leone', 'AFRO', '5', '1547', '0', '62');
INSERT INTO public.who_global_data_import VALUES (76988, '2020-07-08', 'SL', 'Sierra Leone', 'AFRO', '25', '1572', '1', '63');
INSERT INTO public.who_global_data_import VALUES (76989, '2020-07-09', 'SL', 'Sierra Leone', 'AFRO', '12', '1584', '0', '63');
INSERT INTO public.who_global_data_import VALUES (76990, '2020-07-10', 'SL', 'Sierra Leone', 'AFRO', '14', '1598', '0', '63');
INSERT INTO public.who_global_data_import VALUES (76991, '2020-07-11', 'SL', 'Sierra Leone', 'AFRO', '15', '1613', '0', '63');
INSERT INTO public.who_global_data_import VALUES (76992, '2020-07-12', 'SL', 'Sierra Leone', 'AFRO', '5', '1618', '0', '63');
INSERT INTO public.who_global_data_import VALUES (76993, '2020-07-13', 'SL', 'Sierra Leone', 'AFRO', '17', '1635', '0', '63');
INSERT INTO public.who_global_data_import VALUES (76994, '2020-07-14', 'SL', 'Sierra Leone', 'AFRO', '7', '1642', '0', '63');
INSERT INTO public.who_global_data_import VALUES (76995, '2020-07-15', 'SL', 'Sierra Leone', 'AFRO', '9', '1651', '1', '64');
INSERT INTO public.who_global_data_import VALUES (76996, '2020-07-16', 'SL', 'Sierra Leone', 'AFRO', '17', '1668', '0', '64');
INSERT INTO public.who_global_data_import VALUES (76997, '2020-07-17', 'SL', 'Sierra Leone', 'AFRO', '10', '1678', '0', '64');
INSERT INTO public.who_global_data_import VALUES (76998, '2020-07-18', 'SL', 'Sierra Leone', 'AFRO', '10', '1688', '1', '65');
INSERT INTO public.who_global_data_import VALUES (76999, '2020-07-19', 'SL', 'Sierra Leone', 'AFRO', '13', '1701', '0', '65');
INSERT INTO public.who_global_data_import VALUES (77000, '2020-07-20', 'SL', 'Sierra Leone', 'AFRO', '10', '1711', '0', '65');
INSERT INTO public.who_global_data_import VALUES (77001, '2020-07-21', 'SL', 'Sierra Leone', 'AFRO', '0', '1711', '1', '66');
INSERT INTO public.who_global_data_import VALUES (77002, '2020-07-22', 'SL', 'Sierra Leone', 'AFRO', '16', '1727', '0', '66');
INSERT INTO public.who_global_data_import VALUES (77003, '2020-07-23', 'SL', 'Sierra Leone', 'AFRO', '4', '1731', '0', '66');
INSERT INTO public.who_global_data_import VALUES (77004, '2020-07-24', 'SL', 'Sierra Leone', 'AFRO', '21', '1752', '0', '66');
INSERT INTO public.who_global_data_import VALUES (77005, '2020-07-25', 'SL', 'Sierra Leone', 'AFRO', '13', '1765', '0', '66');
INSERT INTO public.who_global_data_import VALUES (77006, '2020-07-26', 'SL', 'Sierra Leone', 'AFRO', '3', '1768', '0', '66');
INSERT INTO public.who_global_data_import VALUES (77007, '2020-07-27', 'SL', 'Sierra Leone', 'AFRO', '15', '1783', '0', '66');
INSERT INTO public.who_global_data_import VALUES (77008, '2020-07-28', 'SL', 'Sierra Leone', 'AFRO', '0', '1783', '0', '66');
INSERT INTO public.who_global_data_import VALUES (77009, '2020-07-29', 'SL', 'Sierra Leone', 'AFRO', '3', '1786', '0', '66');
INSERT INTO public.who_global_data_import VALUES (77010, '2020-07-30', 'SL', 'Sierra Leone', 'AFRO', '17', '1803', '1', '67');
INSERT INTO public.who_global_data_import VALUES (77011, '2020-07-31', 'SL', 'Sierra Leone', 'AFRO', '15', '1818', '0', '67');
INSERT INTO public.who_global_data_import VALUES (77012, '2020-08-01', 'SL', 'Sierra Leone', 'AFRO', '5', '1823', '0', '67');
INSERT INTO public.who_global_data_import VALUES (77013, '2020-08-02', 'SL', 'Sierra Leone', 'AFRO', '12', '1835', '0', '67');
INSERT INTO public.who_global_data_import VALUES (77014, '2020-08-03', 'SL', 'Sierra Leone', 'AFRO', '8', '1843', '0', '67');
INSERT INTO public.who_global_data_import VALUES (77015, '2020-08-04', 'SL', 'Sierra Leone', 'AFRO', '5', '1848', '0', '67');
INSERT INTO public.who_global_data_import VALUES (77016, '2020-08-05', 'SL', 'Sierra Leone', 'AFRO', '7', '1855', '0', '67');
INSERT INTO public.who_global_data_import VALUES (77017, '2020-08-06', 'SL', 'Sierra Leone', 'AFRO', '5', '1860', '0', '67');
INSERT INTO public.who_global_data_import VALUES (77018, '2020-08-07', 'SL', 'Sierra Leone', 'AFRO', '17', '1877', '1', '68');
INSERT INTO public.who_global_data_import VALUES (77019, '2020-08-08', 'SL', 'Sierra Leone', 'AFRO', '10', '1887', '0', '68');
INSERT INTO public.who_global_data_import VALUES (77020, '2020-08-09', 'SL', 'Sierra Leone', 'AFRO', '8', '1895', '0', '68');
INSERT INTO public.who_global_data_import VALUES (77021, '2020-08-10', 'SL', 'Sierra Leone', 'AFRO', '21', '1916', '0', '68');
INSERT INTO public.who_global_data_import VALUES (77022, '2020-08-11', 'SL', 'Sierra Leone', 'AFRO', '1', '1917', '1', '69');
INSERT INTO public.who_global_data_import VALUES (77023, '2020-08-12', 'SL', 'Sierra Leone', 'AFRO', '15', '1932', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77024, '2020-08-13', 'SL', 'Sierra Leone', 'AFRO', '5', '1937', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77025, '2020-08-14', 'SL', 'Sierra Leone', 'AFRO', '3', '1940', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77026, '2020-08-15', 'SL', 'Sierra Leone', 'AFRO', '7', '1947', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77027, '2020-08-16', 'SL', 'Sierra Leone', 'AFRO', '7', '1954', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77028, '2020-08-17', 'SL', 'Sierra Leone', 'AFRO', '2', '1956', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77029, '2020-08-18', 'SL', 'Sierra Leone', 'AFRO', '0', '1956', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77030, '2020-08-19', 'SL', 'Sierra Leone', 'AFRO', '3', '1959', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77031, '2020-08-20', 'SL', 'Sierra Leone', 'AFRO', '2', '1961', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77032, '2020-08-21', 'SL', 'Sierra Leone', 'AFRO', '8', '1969', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77033, '2020-08-22', 'SL', 'Sierra Leone', 'AFRO', '3', '1972', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77034, '2020-08-23', 'SL', 'Sierra Leone', 'AFRO', '8', '1980', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77035, '2020-08-24', 'SL', 'Sierra Leone', 'AFRO', '12', '1992', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77036, '2020-08-25', 'SL', 'Sierra Leone', 'AFRO', '5', '1997', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77037, '2020-08-26', 'SL', 'Sierra Leone', 'AFRO', '4', '2001', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77038, '2020-08-27', 'SL', 'Sierra Leone', 'AFRO', '2', '2003', '0', '69');
INSERT INTO public.who_global_data_import VALUES (77039, '2020-08-28', 'SL', 'Sierra Leone', 'AFRO', '10', '2013', '1', '70');
INSERT INTO public.who_global_data_import VALUES (77040, '2020-08-29', 'SL', 'Sierra Leone', 'AFRO', '2', '2015', '0', '70');
INSERT INTO public.who_global_data_import VALUES (77041, '2020-08-30', 'SL', 'Sierra Leone', 'AFRO', '4', '2019', '0', '70');
INSERT INTO public.who_global_data_import VALUES (77042, '2020-08-31', 'SL', 'Sierra Leone', 'AFRO', '3', '2022', '0', '70');
INSERT INTO public.who_global_data_import VALUES (77043, '2020-09-01', 'SL', 'Sierra Leone', 'AFRO', '4', '2026', '0', '70');
INSERT INTO public.who_global_data_import VALUES (77044, '2020-09-02', 'SL', 'Sierra Leone', 'AFRO', '2', '2028', '1', '71');
INSERT INTO public.who_global_data_import VALUES (77045, '2020-09-03', 'SL', 'Sierra Leone', 'AFRO', '1', '2029', '0', '71');
INSERT INTO public.who_global_data_import VALUES (77046, '2020-09-04', 'SL', 'Sierra Leone', 'AFRO', '6', '2035', '0', '71');
INSERT INTO public.who_global_data_import VALUES (77047, '2020-09-05', 'SL', 'Sierra Leone', 'AFRO', '6', '2041', '0', '71');
INSERT INTO public.who_global_data_import VALUES (77048, '2020-09-06', 'SL', 'Sierra Leone', 'AFRO', '2', '2043', '0', '71');
INSERT INTO public.who_global_data_import VALUES (77049, '2020-09-07', 'SL', 'Sierra Leone', 'AFRO', '11', '2054', '0', '71');
INSERT INTO public.who_global_data_import VALUES (77050, '2020-09-08', 'SL', 'Sierra Leone', 'AFRO', '1', '2055', '0', '71');
INSERT INTO public.who_global_data_import VALUES (77051, '2020-09-09', 'SL', 'Sierra Leone', 'AFRO', '9', '2064', '1', '72');
INSERT INTO public.who_global_data_import VALUES (77052, '2020-09-10', 'SL', 'Sierra Leone', 'AFRO', '3', '2067', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77053, '2020-09-11', 'SL', 'Sierra Leone', 'AFRO', '2', '2069', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77054, '2020-09-12', 'SL', 'Sierra Leone', 'AFRO', '18', '2087', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77055, '2020-09-13', 'SL', 'Sierra Leone', 'AFRO', '9', '2096', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77056, '2020-09-14', 'SL', 'Sierra Leone', 'AFRO', '13', '2109', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77057, '2020-09-15', 'SL', 'Sierra Leone', 'AFRO', '2', '2111', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77058, '2020-09-16', 'SL', 'Sierra Leone', 'AFRO', '15', '2126', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77059, '2020-09-17', 'SL', 'Sierra Leone', 'AFRO', '7', '2133', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77060, '2020-09-18', 'SL', 'Sierra Leone', 'AFRO', '4', '2137', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77061, '2020-09-19', 'SL', 'Sierra Leone', 'AFRO', '16', '2153', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77062, '2020-09-20', 'SL', 'Sierra Leone', 'AFRO', '6', '2159', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77063, '2020-09-21', 'SL', 'Sierra Leone', 'AFRO', '9', '2168', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77064, '2020-09-22', 'SL', 'Sierra Leone', 'AFRO', '0', '2168', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77065, '2020-09-23', 'SL', 'Sierra Leone', 'AFRO', '6', '2174', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77066, '2020-09-24', 'SL', 'Sierra Leone', 'AFRO', '9', '2183', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77067, '2020-09-25', 'SL', 'Sierra Leone', 'AFRO', '5', '2188', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77068, '2020-09-26', 'SL', 'Sierra Leone', 'AFRO', '11', '2199', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77069, '2020-09-27', 'SL', 'Sierra Leone', 'AFRO', '9', '2208', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77070, '2020-09-28', 'SL', 'Sierra Leone', 'AFRO', '7', '2215', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77071, '2020-09-29', 'SL', 'Sierra Leone', 'AFRO', '0', '2215', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77072, '2020-09-30', 'SL', 'Sierra Leone', 'AFRO', '7', '2222', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77073, '2020-10-01', 'SL', 'Sierra Leone', 'AFRO', '9', '2231', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77074, '2020-10-02', 'SL', 'Sierra Leone', 'AFRO', '7', '2238', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77075, '2020-10-03', 'SL', 'Sierra Leone', 'AFRO', '14', '2252', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77076, '2020-10-04', 'SL', 'Sierra Leone', 'AFRO', '7', '2259', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77077, '2020-10-05', 'SL', 'Sierra Leone', 'AFRO', '10', '2269', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77078, '2020-10-06', 'SL', 'Sierra Leone', 'AFRO', '0', '2269', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77079, '2020-10-07', 'SL', 'Sierra Leone', 'AFRO', '8', '2277', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77080, '2020-10-08', 'SL', 'Sierra Leone', 'AFRO', '10', '2287', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77081, '2020-10-09', 'SL', 'Sierra Leone', 'AFRO', '6', '2293', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77082, '2020-10-10', 'SL', 'Sierra Leone', 'AFRO', '2', '2295', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77083, '2020-10-11', 'SL', 'Sierra Leone', 'AFRO', '5', '2300', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77084, '2020-10-12', 'SL', 'Sierra Leone', 'AFRO', '0', '2300', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77085, '2020-10-13', 'SL', 'Sierra Leone', 'AFRO', '6', '2306', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77086, '2020-10-14', 'SL', 'Sierra Leone', 'AFRO', '3', '2309', '0', '72');
INSERT INTO public.who_global_data_import VALUES (77087, '2020-10-15', 'SL', 'Sierra Leone', 'AFRO', '6', '2315', '1', '73');
INSERT INTO public.who_global_data_import VALUES (77088, '2020-10-16', 'SL', 'Sierra Leone', 'AFRO', '8', '2323', '0', '73');
INSERT INTO public.who_global_data_import VALUES (77089, '2020-10-17', 'SL', 'Sierra Leone', 'AFRO', '2', '2325', '0', '73');
INSERT INTO public.who_global_data_import VALUES (77090, '2020-10-18', 'SL', 'Sierra Leone', 'AFRO', '2', '2327', '0', '73');
INSERT INTO public.who_global_data_import VALUES (77091, '2020-10-19', 'SL', 'Sierra Leone', 'AFRO', '3', '2330', '0', '73');
INSERT INTO public.who_global_data_import VALUES (77092, '2020-10-20', 'SL', 'Sierra Leone', 'AFRO', '1', '2331', '0', '73');
INSERT INTO public.who_global_data_import VALUES (77093, '2020-10-21', 'SL', 'Sierra Leone', 'AFRO', '5', '2336', '0', '73');
INSERT INTO public.who_global_data_import VALUES (77094, '2020-10-22', 'SL', 'Sierra Leone', 'AFRO', '1', '2337', '0', '73');
INSERT INTO public.who_global_data_import VALUES (77095, '2020-10-23', 'SL', 'Sierra Leone', 'AFRO', '3', '2340', '0', '73');
INSERT INTO public.who_global_data_import VALUES (77096, '2020-10-24', 'SL', 'Sierra Leone', 'AFRO', '3', '2343', '1', '74');
INSERT INTO public.who_global_data_import VALUES (77097, '2020-10-25', 'SL', 'Sierra Leone', 'AFRO', '2', '2345', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77098, '2020-10-26', 'SL', 'Sierra Leone', 'AFRO', '1', '2346', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77099, '2020-10-27', 'SL', 'Sierra Leone', 'AFRO', '0', '2346', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77100, '2020-10-28', 'SL', 'Sierra Leone', 'AFRO', '4', '2350', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77101, '2020-10-29', 'SL', 'Sierra Leone', 'AFRO', '4', '2354', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77102, '2020-10-30', 'SL', 'Sierra Leone', 'AFRO', '8', '2362', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77103, '2020-10-31', 'SL', 'Sierra Leone', 'AFRO', '3', '2365', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77104, '2020-11-01', 'SL', 'Sierra Leone', 'AFRO', '1', '2366', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77105, '2020-11-02', 'SL', 'Sierra Leone', 'AFRO', '0', '2366', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77106, '2020-11-03', 'SL', 'Sierra Leone', 'AFRO', '0', '2366', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77107, '2020-11-04', 'SL', 'Sierra Leone', 'AFRO', '2', '2368', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77108, '2020-11-05', 'SL', 'Sierra Leone', 'AFRO', '1', '2369', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77109, '2020-11-06', 'SL', 'Sierra Leone', 'AFRO', '4', '2373', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77110, '2020-11-07', 'SL', 'Sierra Leone', 'AFRO', '0', '2373', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77111, '2020-11-08', 'SL', 'Sierra Leone', 'AFRO', '0', '2373', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77112, '2020-11-09', 'SL', 'Sierra Leone', 'AFRO', '10', '2383', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77113, '2020-11-10', 'SL', 'Sierra Leone', 'AFRO', '0', '2383', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77114, '2020-11-11', 'SL', 'Sierra Leone', 'AFRO', '0', '2383', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77115, '2020-11-12', 'SL', 'Sierra Leone', 'AFRO', '3', '2386', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77116, '2020-11-13', 'SL', 'Sierra Leone', 'AFRO', '0', '2386', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77117, '2020-11-14', 'SL', 'Sierra Leone', 'AFRO', '3', '2389', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77118, '2020-11-15', 'SL', 'Sierra Leone', 'AFRO', '0', '2389', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77119, '2020-11-16', 'SL', 'Sierra Leone', 'AFRO', '2', '2391', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77120, '2020-11-17', 'SL', 'Sierra Leone', 'AFRO', '0', '2391', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77121, '2020-11-18', 'SL', 'Sierra Leone', 'AFRO', '0', '2391', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77122, '2020-11-19', 'SL', 'Sierra Leone', 'AFRO', '6', '2397', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77123, '2020-11-20', 'SL', 'Sierra Leone', 'AFRO', '0', '2397', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77124, '2020-11-21', 'SL', 'Sierra Leone', 'AFRO', '2', '2399', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77125, '2020-11-22', 'SL', 'Sierra Leone', 'AFRO', '6', '2405', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77126, '2020-11-23', 'SL', 'Sierra Leone', 'AFRO', '0', '2405', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77127, '2020-11-24', 'SL', 'Sierra Leone', 'AFRO', '1', '2406', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77128, '2020-11-25', 'SL', 'Sierra Leone', 'AFRO', '0', '2406', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77129, '2020-11-26', 'SL', 'Sierra Leone', 'AFRO', '2', '2408', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77130, '2020-11-27', 'SL', 'Sierra Leone', 'AFRO', '1', '2409', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77131, '2020-11-28', 'SL', 'Sierra Leone', 'AFRO', '1', '2410', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77132, '2020-11-29', 'SL', 'Sierra Leone', 'AFRO', '0', '2410', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77133, '2020-11-30', 'SL', 'Sierra Leone', 'AFRO', '1', '2411', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77134, '2020-12-01', 'SL', 'Sierra Leone', 'AFRO', '1', '2412', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77135, '2020-12-02', 'SL', 'Sierra Leone', 'AFRO', '1', '2413', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77136, '2020-12-03', 'SL', 'Sierra Leone', 'AFRO', '3', '2416', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77137, '2020-12-04', 'SL', 'Sierra Leone', 'AFRO', '0', '2416', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77138, '2020-12-05', 'SL', 'Sierra Leone', 'AFRO', '4', '2420', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77139, '2020-12-06', 'SL', 'Sierra Leone', 'AFRO', '0', '2420', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77140, '2020-12-07', 'SL', 'Sierra Leone', 'AFRO', '6', '2426', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77141, '2020-12-08', 'SL', 'Sierra Leone', 'AFRO', '2', '2428', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77142, '2020-12-09', 'SL', 'Sierra Leone', 'AFRO', '0', '2428', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77143, '2020-12-10', 'SL', 'Sierra Leone', 'AFRO', '6', '2434', '0', '74');
INSERT INTO public.who_global_data_import VALUES (77144, '2020-12-11', 'SL', 'Sierra Leone', 'AFRO', '1', '2435', '1', '75');
INSERT INTO public.who_global_data_import VALUES (77145, '2020-12-12', 'SL', 'Sierra Leone', 'AFRO', '0', '2435', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77146, '2020-12-13', 'SL', 'Sierra Leone', 'AFRO', '0', '2435', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77147, '2020-12-14', 'SL', 'Sierra Leone', 'AFRO', '7', '2442', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77148, '2020-12-15', 'SL', 'Sierra Leone', 'AFRO', '3', '2445', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77149, '2020-12-16', 'SL', 'Sierra Leone', 'AFRO', '6', '2451', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77150, '2020-12-17', 'SL', 'Sierra Leone', 'AFRO', '0', '2451', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77151, '2020-12-18', 'SL', 'Sierra Leone', 'AFRO', '13', '2464', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77152, '2020-12-19', 'SL', 'Sierra Leone', 'AFRO', '22', '2486', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77153, '2020-12-20', 'SL', 'Sierra Leone', 'AFRO', '0', '2486', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77154, '2020-12-21', 'SL', 'Sierra Leone', 'AFRO', '11', '2497', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77155, '2020-12-22', 'SL', 'Sierra Leone', 'AFRO', '0', '2497', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77156, '2020-12-23', 'SL', 'Sierra Leone', 'AFRO', '0', '2497', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77157, '2020-12-24', 'SL', 'Sierra Leone', 'AFRO', '0', '2497', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77158, '2020-12-25', 'SL', 'Sierra Leone', 'AFRO', '0', '2497', '0', '75');
INSERT INTO public.who_global_data_import VALUES (77159, '2020-12-26', 'SL', 'Sierra Leone', 'AFRO', '52', '2549', '1', '76');
INSERT INTO public.who_global_data_import VALUES (77160, '2020-12-27', 'SL', 'Sierra Leone', 'AFRO', '0', '2549', '0', '76');
INSERT INTO public.who_global_data_import VALUES (77161, '2020-12-28', 'SL', 'Sierra Leone', 'AFRO', '0', '2549', '0', '76');
INSERT INTO public.who_global_data_import VALUES (77162, '2020-12-29', 'SL', 'Sierra Leone', 'AFRO', '11', '2560', '0', '76');
INSERT INTO public.who_global_data_import VALUES (77163, '2020-12-30', 'SL', 'Sierra Leone', 'AFRO', '0', '2560', '0', '76');
INSERT INTO public.who_global_data_import VALUES (77164, '2020-12-31', 'SL', 'Sierra Leone', 'AFRO', '0', '2560', '0', '76');
INSERT INTO public.who_global_data_import VALUES (77165, '2021-01-01', 'SL', 'Sierra Leone', 'AFRO', '0', '2560', '0', '76');
INSERT INTO public.who_global_data_import VALUES (77166, '2021-01-02', 'SL', 'Sierra Leone', 'AFRO', '0', '2560', '0', '76');
INSERT INTO public.who_global_data_import VALUES (77167, '2021-01-03', 'SL', 'Sierra Leone', 'AFRO', '0', '2560', '0', '76');
INSERT INTO public.who_global_data_import VALUES (77168, '2021-01-04', 'SL', 'Sierra Leone', 'AFRO', '113', '2673', '0', '76');
INSERT INTO public.who_global_data_import VALUES (77169, '2021-01-05', 'SL', 'Sierra Leone', 'AFRO', '0', '2673', '0', '76');
INSERT INTO public.who_global_data_import VALUES (77170, '2021-01-06', 'SL', 'Sierra Leone', 'AFRO', '51', '2724', '0', '76');
INSERT INTO public.who_global_data_import VALUES (77171, '2021-01-07', 'SL', 'Sierra Leone', 'AFRO', '15', '2739', '0', '76');
INSERT INTO public.who_global_data_import VALUES (77172, '2021-01-08', 'SL', 'Sierra Leone', 'AFRO', '18', '2757', '1', '77');
INSERT INTO public.who_global_data_import VALUES (77173, '2021-01-09', 'SL', 'Sierra Leone', 'AFRO', '25', '2782', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77174, '2021-01-10', 'SL', 'Sierra Leone', 'AFRO', '21', '2803', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77175, '2021-01-11', 'SL', 'Sierra Leone', 'AFRO', '31', '2834', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77176, '2021-01-12', 'SL', 'Sierra Leone', 'AFRO', '12', '2846', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77177, '2021-01-13', 'SL', 'Sierra Leone', 'AFRO', '18', '2864', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77178, '2021-01-14', 'SL', 'Sierra Leone', 'AFRO', '23', '2887', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77179, '2021-01-15', 'SL', 'Sierra Leone', 'AFRO', '46', '2933', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77180, '2021-01-16', 'SL', 'Sierra Leone', 'AFRO', '26', '2959', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77181, '2021-01-17', 'SL', 'Sierra Leone', 'AFRO', '11', '2970', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77182, '2021-01-18', 'SL', 'Sierra Leone', 'AFRO', '36', '3006', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77183, '2021-01-19', 'SL', 'Sierra Leone', 'AFRO', '8', '3014', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77184, '2021-01-20', 'SL', 'Sierra Leone', 'AFRO', '16', '3030', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77185, '2021-01-21', 'SL', 'Sierra Leone', 'AFRO', '21', '3051', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77186, '2021-01-22', 'SL', 'Sierra Leone', 'AFRO', '30', '3081', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77187, '2021-01-23', 'SL', 'Sierra Leone', 'AFRO', '12', '3093', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77188, '2021-01-24', 'SL', 'Sierra Leone', 'AFRO', '27', '3120', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77189, '2021-01-25', 'SL', 'Sierra Leone', 'AFRO', '19', '3139', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77190, '2021-01-26', 'SL', 'Sierra Leone', 'AFRO', '34', '3173', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77191, '2021-01-27', 'SL', 'Sierra Leone', 'AFRO', '21', '3194', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77192, '2021-01-28', 'SL', 'Sierra Leone', 'AFRO', '42', '3236', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77193, '2021-01-29', 'SL', 'Sierra Leone', 'AFRO', '46', '3282', '0', '77');
INSERT INTO public.who_global_data_import VALUES (77194, '2021-01-30', 'SL', 'Sierra Leone', 'AFRO', '100', '3382', '2', '79');
INSERT INTO public.who_global_data_import VALUES (77195, '2021-01-31', 'SL', 'Sierra Leone', 'AFRO', '146', '3528', '0', '79');
INSERT INTO public.who_global_data_import VALUES (77196, '2021-02-01', 'SL', 'Sierra Leone', 'AFRO', '65', '3593', '0', '79');
INSERT INTO public.who_global_data_import VALUES (77197, '2021-02-02', 'SL', 'Sierra Leone', 'AFRO', '41', '3634', '0', '79');
INSERT INTO public.who_global_data_import VALUES (77198, '2021-02-03', 'SL', 'Sierra Leone', 'AFRO', '26', '3660', '0', '79');
INSERT INTO public.who_global_data_import VALUES (77199, '2021-02-04', 'SL', 'Sierra Leone', 'AFRO', '39', '3699', '0', '79');
INSERT INTO public.who_global_data_import VALUES (77200, '2021-02-05', 'SL', 'Sierra Leone', 'AFRO', '29', '3728', '0', '79');
INSERT INTO public.who_global_data_import VALUES (77201, '2020-01-03', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77202, '2020-01-04', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77203, '2020-01-05', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77204, '2020-01-06', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77205, '2020-01-07', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77206, '2020-01-08', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77207, '2020-01-09', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77208, '2020-01-10', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77209, '2020-01-11', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77210, '2020-01-12', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77211, '2020-01-13', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77212, '2020-01-14', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77213, '2020-01-15', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77214, '2020-01-16', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77215, '2020-01-17', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77216, '2020-01-18', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77217, '2020-01-19', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77218, '2020-01-20', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77219, '2020-01-21', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77220, '2020-01-22', 'SG', 'Singapore', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77221, '2020-01-23', 'SG', 'Singapore', 'WPRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77222, '2020-01-24', 'SG', 'Singapore', 'WPRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77223, '2020-01-25', 'SG', 'Singapore', 'WPRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77224, '2020-01-26', 'SG', 'Singapore', 'WPRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77225, '2020-01-27', 'SG', 'Singapore', 'WPRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77226, '2020-01-28', 'SG', 'Singapore', 'WPRO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77227, '2020-01-29', 'SG', 'Singapore', 'WPRO', '3', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77228, '2020-01-30', 'SG', 'Singapore', 'WPRO', '3', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77229, '2020-01-31', 'SG', 'Singapore', 'WPRO', '3', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77230, '2020-02-01', 'SG', 'Singapore', 'WPRO', '2', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77231, '2020-02-02', 'SG', 'Singapore', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77232, '2020-02-03', 'SG', 'Singapore', 'WPRO', '0', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77233, '2020-02-04', 'SG', 'Singapore', 'WPRO', '6', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77234, '2020-02-05', 'SG', 'Singapore', 'WPRO', '4', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77235, '2020-02-06', 'SG', 'Singapore', 'WPRO', '2', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77236, '2020-02-07', 'SG', 'Singapore', 'WPRO', '3', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77237, '2020-02-08', 'SG', 'Singapore', 'WPRO', '7', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77238, '2020-02-09', 'SG', 'Singapore', 'WPRO', '3', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77239, '2020-02-10', 'SG', 'Singapore', 'WPRO', '2', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77240, '2020-02-11', 'SG', 'Singapore', 'WPRO', '2', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77241, '2020-02-12', 'SG', 'Singapore', 'WPRO', '3', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77242, '2020-02-13', 'SG', 'Singapore', 'WPRO', '8', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77243, '2020-02-14', 'SG', 'Singapore', 'WPRO', '9', '71', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77244, '2020-02-15', 'SG', 'Singapore', 'WPRO', '5', '76', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77245, '2020-02-16', 'SG', 'Singapore', 'WPRO', '3', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77246, '2020-02-17', 'SG', 'Singapore', 'WPRO', '2', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77247, '2020-02-18', 'SG', 'Singapore', 'WPRO', '4', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77248, '2020-02-19', 'SG', 'Singapore', 'WPRO', '3', '88', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77249, '2020-02-20', 'SG', 'Singapore', 'WPRO', '1', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77250, '2020-02-21', 'SG', 'Singapore', 'WPRO', '1', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77251, '2020-02-22', 'SG', 'Singapore', 'WPRO', '3', '93', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77252, '2020-02-23', 'SG', 'Singapore', 'WPRO', '0', '93', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77253, '2020-02-24', 'SG', 'Singapore', 'WPRO', '1', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77254, '2020-02-25', 'SG', 'Singapore', 'WPRO', '1', '95', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77255, '2020-02-26', 'SG', 'Singapore', 'WPRO', '2', '97', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77256, '2020-02-27', 'SG', 'Singapore', 'WPRO', '3', '100', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77257, '2020-02-28', 'SG', 'Singapore', 'WPRO', '2', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77258, '2020-02-29', 'SG', 'Singapore', 'WPRO', '4', '106', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77259, '2020-03-01', 'SG', 'Singapore', 'WPRO', '4', '110', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77260, '2020-03-02', 'SG', 'Singapore', 'WPRO', '2', '112', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77261, '2020-03-03', 'SG', 'Singapore', 'WPRO', '2', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77262, '2020-03-04', 'SG', 'Singapore', 'WPRO', '0', '114', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77263, '2020-03-05', 'SG', 'Singapore', 'WPRO', '7', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77264, '2020-03-06', 'SG', 'Singapore', 'WPRO', '13', '134', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77265, '2020-03-07', 'SG', 'Singapore', 'WPRO', '8', '142', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77266, '2020-03-08', 'SG', 'Singapore', 'WPRO', '12', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77267, '2020-03-09', 'SG', 'Singapore', 'WPRO', '10', '164', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77268, '2020-03-10', 'SG', 'Singapore', 'WPRO', '6', '170', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77269, '2020-03-11', 'SG', 'Singapore', 'WPRO', '12', '182', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77270, '2020-03-12', 'SG', 'Singapore', 'WPRO', '9', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77271, '2020-03-13', 'SG', 'Singapore', 'WPRO', '13', '204', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77272, '2020-03-14', 'SG', 'Singapore', 'WPRO', '12', '216', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77273, '2020-03-15', 'SG', 'Singapore', 'WPRO', '14', '230', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77274, '2020-03-16', 'SG', 'Singapore', 'WPRO', '17', '247', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77275, '2020-03-17', 'SG', 'Singapore', 'WPRO', '23', '270', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77276, '2020-03-18', 'SG', 'Singapore', 'WPRO', '47', '317', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77277, '2020-03-19', 'SG', 'Singapore', 'WPRO', '28', '345', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77278, '2020-03-20', 'SG', 'Singapore', 'WPRO', '40', '385', '2', '2');
INSERT INTO public.who_global_data_import VALUES (77279, '2020-03-21', 'SG', 'Singapore', 'WPRO', '47', '432', '0', '2');
INSERT INTO public.who_global_data_import VALUES (77280, '2020-03-22', 'SG', 'Singapore', 'WPRO', '0', '432', '0', '2');
INSERT INTO public.who_global_data_import VALUES (77281, '2020-03-23', 'SG', 'Singapore', 'WPRO', '23', '455', '0', '2');
INSERT INTO public.who_global_data_import VALUES (77282, '2020-03-24', 'SG', 'Singapore', 'WPRO', '52', '507', '0', '2');
INSERT INTO public.who_global_data_import VALUES (77283, '2020-03-25', 'SG', 'Singapore', 'WPRO', '51', '558', '0', '2');
INSERT INTO public.who_global_data_import VALUES (77284, '2020-03-26', 'SG', 'Singapore', 'WPRO', '73', '631', '0', '2');
INSERT INTO public.who_global_data_import VALUES (77285, '2020-03-27', 'SG', 'Singapore', 'WPRO', '52', '683', '0', '2');
INSERT INTO public.who_global_data_import VALUES (77286, '2020-03-28', 'SG', 'Singapore', 'WPRO', '49', '732', '0', '2');
INSERT INTO public.who_global_data_import VALUES (77287, '2020-03-29', 'SG', 'Singapore', 'WPRO', '70', '802', '0', '2');
INSERT INTO public.who_global_data_import VALUES (77288, '2020-03-30', 'SG', 'Singapore', 'WPRO', '42', '844', '1', '3');
INSERT INTO public.who_global_data_import VALUES (77289, '2020-03-31', 'SG', 'Singapore', 'WPRO', '35', '879', '0', '3');
INSERT INTO public.who_global_data_import VALUES (77290, '2020-04-01', 'SG', 'Singapore', 'WPRO', '47', '926', '0', '3');
INSERT INTO public.who_global_data_import VALUES (77291, '2020-04-02', 'SG', 'Singapore', 'WPRO', '74', '1000', '0', '3');
INSERT INTO public.who_global_data_import VALUES (77292, '2020-04-03', 'SG', 'Singapore', 'WPRO', '49', '1049', '1', '4');
INSERT INTO public.who_global_data_import VALUES (77293, '2020-04-04', 'SG', 'Singapore', 'WPRO', '65', '1114', '1', '5');
INSERT INTO public.who_global_data_import VALUES (77294, '2020-04-05', 'SG', 'Singapore', 'WPRO', '75', '1189', '0', '5');
INSERT INTO public.who_global_data_import VALUES (77295, '2020-04-06', 'SG', 'Singapore', 'WPRO', '120', '1309', '1', '6');
INSERT INTO public.who_global_data_import VALUES (77296, '2020-04-07', 'SG', 'Singapore', 'WPRO', '66', '1375', '0', '6');
INSERT INTO public.who_global_data_import VALUES (77297, '2020-04-08', 'SG', 'Singapore', 'WPRO', '106', '1481', '0', '6');
INSERT INTO public.who_global_data_import VALUES (77298, '2020-04-09', 'SG', 'Singapore', 'WPRO', '142', '1623', '0', '6');
INSERT INTO public.who_global_data_import VALUES (77299, '2020-04-10', 'SG', 'Singapore', 'WPRO', '287', '1910', '1', '7');
INSERT INTO public.who_global_data_import VALUES (77300, '2020-04-11', 'SG', 'Singapore', 'WPRO', '198', '2108', '0', '7');
INSERT INTO public.who_global_data_import VALUES (77301, '2020-04-12', 'SG', 'Singapore', 'WPRO', '191', '2299', '1', '8');
INSERT INTO public.who_global_data_import VALUES (77302, '2020-04-13', 'SG', 'Singapore', 'WPRO', '233', '2532', '0', '8');
INSERT INTO public.who_global_data_import VALUES (77303, '2020-04-14', 'SG', 'Singapore', 'WPRO', '386', '2918', '1', '9');
INSERT INTO public.who_global_data_import VALUES (77304, '2020-04-15', 'SG', 'Singapore', 'WPRO', '334', '3252', '1', '10');
INSERT INTO public.who_global_data_import VALUES (77305, '2020-04-16', 'SG', 'Singapore', 'WPRO', '447', '3699', '0', '10');
INSERT INTO public.who_global_data_import VALUES (77306, '2020-04-17', 'SG', 'Singapore', 'WPRO', '728', '4427', '0', '10');
INSERT INTO public.who_global_data_import VALUES (77307, '2020-04-18', 'SG', 'Singapore', 'WPRO', '623', '5050', '1', '11');
INSERT INTO public.who_global_data_import VALUES (77308, '2020-04-19', 'SG', 'Singapore', 'WPRO', '942', '5992', '0', '11');
INSERT INTO public.who_global_data_import VALUES (77309, '2020-04-20', 'SG', 'Singapore', 'WPRO', '596', '6588', '0', '11');
INSERT INTO public.who_global_data_import VALUES (77310, '2020-04-21', 'SG', 'Singapore', 'WPRO', '1426', '8014', '0', '11');
INSERT INTO public.who_global_data_import VALUES (77311, '2020-04-22', 'SG', 'Singapore', 'WPRO', '1111', '9125', '0', '11');
INSERT INTO public.who_global_data_import VALUES (77312, '2020-04-23', 'SG', 'Singapore', 'WPRO', '1016', '10141', '1', '12');
INSERT INTO public.who_global_data_import VALUES (77313, '2020-04-24', 'SG', 'Singapore', 'WPRO', '1037', '11178', '0', '12');
INSERT INTO public.who_global_data_import VALUES (77314, '2020-04-25', 'SG', 'Singapore', 'WPRO', '897', '12075', '0', '12');
INSERT INTO public.who_global_data_import VALUES (77315, '2020-04-26', 'SG', 'Singapore', 'WPRO', '618', '12693', '0', '12');
INSERT INTO public.who_global_data_import VALUES (77316, '2020-04-27', 'SG', 'Singapore', 'WPRO', '931', '13624', '0', '12');
INSERT INTO public.who_global_data_import VALUES (77317, '2020-04-28', 'SG', 'Singapore', 'WPRO', '799', '14423', '2', '14');
INSERT INTO public.who_global_data_import VALUES (77318, '2020-04-29', 'SG', 'Singapore', 'WPRO', '528', '14951', '0', '14');
INSERT INTO public.who_global_data_import VALUES (77319, '2020-04-30', 'SG', 'Singapore', 'WPRO', '690', '15641', '0', '14');
INSERT INTO public.who_global_data_import VALUES (77320, '2020-05-01', 'SG', 'Singapore', 'WPRO', '528', '16169', '1', '15');
INSERT INTO public.who_global_data_import VALUES (77321, '2020-05-02', 'SG', 'Singapore', 'WPRO', '932', '17101', '1', '16');
INSERT INTO public.who_global_data_import VALUES (77322, '2020-05-03', 'SG', 'Singapore', 'WPRO', '447', '17548', '1', '17');
INSERT INTO public.who_global_data_import VALUES (77323, '2020-05-04', 'SG', 'Singapore', 'WPRO', '657', '18205', '1', '18');
INSERT INTO public.who_global_data_import VALUES (77324, '2020-05-05', 'SG', 'Singapore', 'WPRO', '573', '18778', '0', '18');
INSERT INTO public.who_global_data_import VALUES (77325, '2020-05-06', 'SG', 'Singapore', 'WPRO', '632', '19410', '0', '18');
INSERT INTO public.who_global_data_import VALUES (77326, '2020-05-07', 'SG', 'Singapore', 'WPRO', '788', '20198', '2', '20');
INSERT INTO public.who_global_data_import VALUES (77327, '2020-05-08', 'SG', 'Singapore', 'WPRO', '741', '20939', '0', '20');
INSERT INTO public.who_global_data_import VALUES (77328, '2020-05-09', 'SG', 'Singapore', 'WPRO', '768', '21707', '0', '20');
INSERT INTO public.who_global_data_import VALUES (77329, '2020-05-10', 'SG', 'Singapore', 'WPRO', '753', '22460', '0', '20');
INSERT INTO public.who_global_data_import VALUES (77330, '2020-05-11', 'SG', 'Singapore', 'WPRO', '876', '23336', '0', '20');
INSERT INTO public.who_global_data_import VALUES (77331, '2020-05-12', 'SG', 'Singapore', 'WPRO', '486', '23822', '1', '21');
INSERT INTO public.who_global_data_import VALUES (77332, '2020-05-13', 'SG', 'Singapore', 'WPRO', '849', '24671', '0', '21');
INSERT INTO public.who_global_data_import VALUES (77333, '2020-05-14', 'SG', 'Singapore', 'WPRO', '675', '25346', '0', '21');
INSERT INTO public.who_global_data_import VALUES (77334, '2020-05-15', 'SG', 'Singapore', 'WPRO', '752', '26098', '0', '21');
INSERT INTO public.who_global_data_import VALUES (77335, '2020-05-16', 'SG', 'Singapore', 'WPRO', '793', '26891', '0', '21');
INSERT INTO public.who_global_data_import VALUES (77336, '2020-05-17', 'SG', 'Singapore', 'WPRO', '465', '27356', '1', '22');
INSERT INTO public.who_global_data_import VALUES (77337, '2020-05-18', 'SG', 'Singapore', 'WPRO', '682', '28038', '0', '22');
INSERT INTO public.who_global_data_import VALUES (77338, '2020-05-19', 'SG', 'Singapore', 'WPRO', '305', '28343', '0', '22');
INSERT INTO public.who_global_data_import VALUES (77339, '2020-05-20', 'SG', 'Singapore', 'WPRO', '451', '28794', '0', '22');
INSERT INTO public.who_global_data_import VALUES (77340, '2020-05-21', 'SG', 'Singapore', 'WPRO', '570', '29364', '0', '22');
INSERT INTO public.who_global_data_import VALUES (77341, '2020-05-22', 'SG', 'Singapore', 'WPRO', '448', '29812', '1', '23');
INSERT INTO public.who_global_data_import VALUES (77342, '2020-05-23', 'SG', 'Singapore', 'WPRO', '614', '30426', '0', '23');
INSERT INTO public.who_global_data_import VALUES (77343, '2020-05-24', 'SG', 'Singapore', 'WPRO', '642', '31068', '0', '23');
INSERT INTO public.who_global_data_import VALUES (77344, '2020-05-25', 'SG', 'Singapore', 'WPRO', '548', '31616', '0', '23');
INSERT INTO public.who_global_data_import VALUES (77345, '2020-05-26', 'SG', 'Singapore', 'WPRO', '344', '31960', '0', '23');
INSERT INTO public.who_global_data_import VALUES (77346, '2020-05-27', 'SG', 'Singapore', 'WPRO', '383', '32343', '0', '23');
INSERT INTO public.who_global_data_import VALUES (77347, '2020-05-28', 'SG', 'Singapore', 'WPRO', '533', '32876', '0', '23');
INSERT INTO public.who_global_data_import VALUES (77348, '2020-05-29', 'SG', 'Singapore', 'WPRO', '373', '33249', '0', '23');
INSERT INTO public.who_global_data_import VALUES (77349, '2020-05-30', 'SG', 'Singapore', 'WPRO', '611', '33860', '0', '23');
INSERT INTO public.who_global_data_import VALUES (77350, '2020-05-31', 'SG', 'Singapore', 'WPRO', '506', '34366', '0', '23');
INSERT INTO public.who_global_data_import VALUES (77351, '2020-06-01', 'SG', 'Singapore', 'WPRO', '518', '34884', '0', '23');
INSERT INTO public.who_global_data_import VALUES (77352, '2020-06-02', 'SG', 'Singapore', 'WPRO', '408', '35292', '1', '24');
INSERT INTO public.who_global_data_import VALUES (77353, '2020-06-03', 'SG', 'Singapore', 'WPRO', '544', '35836', '0', '24');
INSERT INTO public.who_global_data_import VALUES (77354, '2020-06-04', 'SG', 'Singapore', 'WPRO', '569', '36405', '0', '24');
INSERT INTO public.who_global_data_import VALUES (77355, '2020-06-05', 'SG', 'Singapore', 'WPRO', '517', '36922', '0', '24');
INSERT INTO public.who_global_data_import VALUES (77356, '2020-06-06', 'SG', 'Singapore', 'WPRO', '261', '37183', '0', '24');
INSERT INTO public.who_global_data_import VALUES (77357, '2020-06-07', 'SG', 'Singapore', 'WPRO', '344', '37527', '1', '25');
INSERT INTO public.who_global_data_import VALUES (77358, '2020-06-08', 'SG', 'Singapore', 'WPRO', '383', '37910', '0', '25');
INSERT INTO public.who_global_data_import VALUES (77359, '2020-06-09', 'SG', 'Singapore', 'WPRO', '386', '38296', '0', '25');
INSERT INTO public.who_global_data_import VALUES (77360, '2020-06-10', 'SG', 'Singapore', 'WPRO', '218', '38514', '0', '25');
INSERT INTO public.who_global_data_import VALUES (77361, '2020-06-11', 'SG', 'Singapore', 'WPRO', '451', '38965', '0', '25');
INSERT INTO public.who_global_data_import VALUES (77362, '2020-06-12', 'SG', 'Singapore', 'WPRO', '422', '39387', '0', '25');
INSERT INTO public.who_global_data_import VALUES (77363, '2020-06-13', 'SG', 'Singapore', 'WPRO', '463', '39850', '0', '25');
INSERT INTO public.who_global_data_import VALUES (77364, '2020-06-14', 'SG', 'Singapore', 'WPRO', '347', '40197', '1', '26');
INSERT INTO public.who_global_data_import VALUES (77365, '2020-06-15', 'SG', 'Singapore', 'WPRO', '407', '40604', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77366, '2020-06-16', 'SG', 'Singapore', 'WPRO', '214', '40818', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77367, '2020-06-17', 'SG', 'Singapore', 'WPRO', '151', '40969', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77368, '2020-06-18', 'SG', 'Singapore', 'WPRO', '247', '41216', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77369, '2020-06-19', 'SG', 'Singapore', 'WPRO', '257', '41473', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77370, '2020-06-20', 'SG', 'Singapore', 'WPRO', '142', '41615', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77371, '2020-06-21', 'SG', 'Singapore', 'WPRO', '218', '41833', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77372, '2020-06-22', 'SG', 'Singapore', 'WPRO', '262', '42095', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77373, '2020-06-23', 'SG', 'Singapore', 'WPRO', '218', '42313', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77374, '2020-06-24', 'SG', 'Singapore', 'WPRO', '119', '42432', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77375, '2020-06-25', 'SG', 'Singapore', 'WPRO', '191', '42623', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77376, '2020-06-26', 'SG', 'Singapore', 'WPRO', '113', '42736', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77377, '2020-06-27', 'SG', 'Singapore', 'WPRO', '219', '42955', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77378, '2020-06-28', 'SG', 'Singapore', 'WPRO', '291', '43246', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77379, '2020-06-29', 'SG', 'Singapore', 'WPRO', '213', '43459', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77380, '2020-06-30', 'SG', 'Singapore', 'WPRO', '202', '43661', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77381, '2020-07-01', 'SG', 'Singapore', 'WPRO', '246', '43907', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77382, '2020-07-02', 'SG', 'Singapore', 'WPRO', '215', '44122', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77383, '2020-07-03', 'SG', 'Singapore', 'WPRO', '188', '44310', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77384, '2020-07-04', 'SG', 'Singapore', 'WPRO', '169', '44479', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77385, '2020-07-05', 'SG', 'Singapore', 'WPRO', '185', '44664', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77386, '2020-07-06', 'SG', 'Singapore', 'WPRO', '136', '44800', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77387, '2020-07-07', 'SG', 'Singapore', 'WPRO', '183', '44983', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77388, '2020-07-08', 'SG', 'Singapore', 'WPRO', '157', '45140', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77389, '2020-07-09', 'SG', 'Singapore', 'WPRO', '158', '45298', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77390, '2020-07-10', 'SG', 'Singapore', 'WPRO', '125', '45423', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77391, '2020-07-11', 'SG', 'Singapore', 'WPRO', '191', '45614', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77392, '2020-07-12', 'SG', 'Singapore', 'WPRO', '169', '45783', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77393, '2020-07-13', 'SG', 'Singapore', 'WPRO', '178', '45961', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77394, '2020-07-14', 'SG', 'Singapore', 'WPRO', '322', '46283', '0', '26');
INSERT INTO public.who_global_data_import VALUES (77395, '2020-07-15', 'SG', 'Singapore', 'WPRO', '347', '46630', '1', '27');
INSERT INTO public.who_global_data_import VALUES (77396, '2020-07-16', 'SG', 'Singapore', 'WPRO', '249', '46879', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77397, '2020-07-17', 'SG', 'Singapore', 'WPRO', '248', '47127', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77398, '2020-07-18', 'SG', 'Singapore', 'WPRO', '327', '47454', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77399, '2020-07-19', 'SG', 'Singapore', 'WPRO', '202', '47656', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77400, '2020-07-20', 'SG', 'Singapore', 'WPRO', '257', '47913', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77401, '2020-07-21', 'SG', 'Singapore', 'WPRO', '123', '48036', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77402, '2020-07-22', 'SG', 'Singapore', 'WPRO', '398', '48434', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77403, '2020-07-23', 'SG', 'Singapore', 'WPRO', '310', '48744', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77404, '2020-07-24', 'SG', 'Singapore', 'WPRO', '354', '49098', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77405, '2020-07-25', 'SG', 'Singapore', 'WPRO', '277', '49375', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77406, '2020-07-26', 'SG', 'Singapore', 'WPRO', '513', '49888', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77407, '2020-07-27', 'SG', 'Singapore', 'WPRO', '481', '50369', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77408, '2020-07-28', 'SG', 'Singapore', 'WPRO', '469', '50838', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77409, '2020-07-29', 'SG', 'Singapore', 'WPRO', '359', '51197', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77410, '2020-07-30', 'SG', 'Singapore', 'WPRO', '334', '51531', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77411, '2020-07-31', 'SG', 'Singapore', 'WPRO', '278', '51809', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77412, '2020-08-01', 'SG', 'Singapore', 'WPRO', '396', '52205', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77413, '2020-08-02', 'SG', 'Singapore', 'WPRO', '307', '52512', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77414, '2020-08-03', 'SG', 'Singapore', 'WPRO', '313', '52825', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77415, '2020-08-04', 'SG', 'Singapore', 'WPRO', '226', '53051', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77416, '2020-08-05', 'SG', 'Singapore', 'WPRO', '295', '53346', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77417, '2020-08-06', 'SG', 'Singapore', 'WPRO', '908', '54254', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77418, '2020-08-07', 'SG', 'Singapore', 'WPRO', '301', '54555', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77419, '2020-08-08', 'SG', 'Singapore', 'WPRO', '242', '54797', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77420, '2020-08-09', 'SG', 'Singapore', 'WPRO', '132', '54929', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77421, '2020-08-10', 'SG', 'Singapore', 'WPRO', '175', '55104', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77422, '2020-08-11', 'SG', 'Singapore', 'WPRO', '188', '55292', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77423, '2020-08-12', 'SG', 'Singapore', 'WPRO', '61', '55353', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77424, '2020-08-13', 'SG', 'Singapore', 'WPRO', '42', '55395', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77425, '2020-08-14', 'SG', 'Singapore', 'WPRO', '102', '55497', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77426, '2020-08-15', 'SG', 'Singapore', 'WPRO', '83', '55580', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77427, '2020-08-16', 'SG', 'Singapore', 'WPRO', '81', '55661', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77428, '2020-08-17', 'SG', 'Singapore', 'WPRO', '86', '55747', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77429, '2020-08-18', 'SG', 'Singapore', 'WPRO', '91', '55838', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77430, '2020-08-19', 'SG', 'Singapore', 'WPRO', '100', '55938', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77431, '2020-08-20', 'SG', 'Singapore', 'WPRO', '93', '56031', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77432, '2020-08-21', 'SG', 'Singapore', 'WPRO', '68', '56099', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77433, '2020-08-22', 'SG', 'Singapore', 'WPRO', '117', '56216', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77434, '2020-08-23', 'SG', 'Singapore', 'WPRO', '50', '56266', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77435, '2020-08-24', 'SG', 'Singapore', 'WPRO', '87', '56353', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77436, '2020-08-25', 'SG', 'Singapore', 'WPRO', '51', '56404', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77437, '2020-08-26', 'SG', 'Singapore', 'WPRO', '31', '56435', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77438, '2020-08-27', 'SG', 'Singapore', 'WPRO', '60', '56495', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77439, '2020-08-28', 'SG', 'Singapore', 'WPRO', '77', '56572', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77440, '2020-08-29', 'SG', 'Singapore', 'WPRO', '94', '56666', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77441, '2020-08-30', 'SG', 'Singapore', 'WPRO', '51', '56717', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77442, '2020-08-31', 'SG', 'Singapore', 'WPRO', '54', '56771', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77443, '2020-09-01', 'SG', 'Singapore', 'WPRO', '41', '56812', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77444, '2020-09-02', 'SG', 'Singapore', 'WPRO', '40', '56852', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77445, '2020-09-03', 'SG', 'Singapore', 'WPRO', '8', '56860', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77446, '2020-09-04', 'SG', 'Singapore', 'WPRO', '48', '56908', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77447, '2020-09-05', 'SG', 'Singapore', 'WPRO', '40', '56948', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77448, '2020-09-06', 'SG', 'Singapore', 'WPRO', '34', '56982', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77449, '2020-09-07', 'SG', 'Singapore', 'WPRO', '40', '57022', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77450, '2020-09-08', 'SG', 'Singapore', 'WPRO', '22', '57044', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77451, '2020-09-09', 'SG', 'Singapore', 'WPRO', '47', '57091', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77452, '2020-09-10', 'SG', 'Singapore', 'WPRO', '75', '57166', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77453, '2020-09-11', 'SG', 'Singapore', 'WPRO', '63', '57229', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77454, '2020-09-12', 'SG', 'Singapore', 'WPRO', '86', '57315', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77455, '2020-09-13', 'SG', 'Singapore', 'WPRO', '42', '57357', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77456, '2020-09-14', 'SG', 'Singapore', 'WPRO', '49', '57406', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77457, '2020-09-15', 'SG', 'Singapore', 'WPRO', '48', '57454', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77458, '2020-09-16', 'SG', 'Singapore', 'WPRO', '34', '57488', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77459, '2020-09-17', 'SG', 'Singapore', 'WPRO', '26', '57514', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77460, '2020-09-18', 'SG', 'Singapore', 'WPRO', '18', '57532', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77461, '2020-09-19', 'SG', 'Singapore', 'WPRO', '11', '57543', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77462, '2020-09-20', 'SG', 'Singapore', 'WPRO', '15', '57558', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77463, '2020-09-21', 'SG', 'Singapore', 'WPRO', '18', '57576', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77464, '2020-09-22', 'SG', 'Singapore', 'WPRO', '30', '57606', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77465, '2020-09-23', 'SG', 'Singapore', 'WPRO', '21', '57627', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77466, '2020-09-24', 'SG', 'Singapore', 'WPRO', '12', '57639', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77467, '2020-09-25', 'SG', 'Singapore', 'WPRO', '15', '57654', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77468, '2020-09-26', 'SG', 'Singapore', 'WPRO', '11', '57665', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77469, '2020-09-27', 'SG', 'Singapore', 'WPRO', '20', '57685', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77470, '2020-09-28', 'SG', 'Singapore', 'WPRO', '15', '57700', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77471, '2020-09-29', 'SG', 'Singapore', 'WPRO', '15', '57715', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77472, '2020-09-30', 'SG', 'Singapore', 'WPRO', '27', '57742', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77473, '2020-10-01', 'SG', 'Singapore', 'WPRO', '23', '57765', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77474, '2020-10-02', 'SG', 'Singapore', 'WPRO', '19', '57784', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77475, '2020-10-03', 'SG', 'Singapore', 'WPRO', '10', '57794', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77476, '2020-10-04', 'SG', 'Singapore', 'WPRO', '6', '57800', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77477, '2020-10-05', 'SG', 'Singapore', 'WPRO', '12', '57812', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77478, '2020-10-06', 'SG', 'Singapore', 'WPRO', '7', '57819', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77479, '2020-10-07', 'SG', 'Singapore', 'WPRO', '11', '57830', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77480, '2020-10-08', 'SG', 'Singapore', 'WPRO', '10', '57840', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77481, '2020-10-09', 'SG', 'Singapore', 'WPRO', '9', '57849', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77482, '2020-10-10', 'SG', 'Singapore', 'WPRO', '10', '57859', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77483, '2020-10-11', 'SG', 'Singapore', 'WPRO', '7', '57866', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77484, '2020-10-12', 'SG', 'Singapore', 'WPRO', '10', '57876', '0', '27');
INSERT INTO public.who_global_data_import VALUES (77485, '2020-10-13', 'SG', 'Singapore', 'WPRO', '4', '57880', '1', '28');
INSERT INTO public.who_global_data_import VALUES (77486, '2020-10-14', 'SG', 'Singapore', 'WPRO', '4', '57884', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77487, '2020-10-15', 'SG', 'Singapore', 'WPRO', '5', '57889', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77488, '2020-10-16', 'SG', 'Singapore', 'WPRO', '3', '57892', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77489, '2020-10-17', 'SG', 'Singapore', 'WPRO', '9', '57901', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77490, '2020-10-18', 'SG', 'Singapore', 'WPRO', '3', '57904', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77491, '2020-10-19', 'SG', 'Singapore', 'WPRO', '7', '57911', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77492, '2020-10-20', 'SG', 'Singapore', 'WPRO', '4', '57915', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77493, '2020-10-21', 'SG', 'Singapore', 'WPRO', '6', '57921', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77494, '2020-10-22', 'SG', 'Singapore', 'WPRO', '12', '57933', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77495, '2020-10-23', 'SG', 'Singapore', 'WPRO', '8', '57941', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77496, '2020-10-24', 'SG', 'Singapore', 'WPRO', '10', '57951', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77497, '2020-10-25', 'SG', 'Singapore', 'WPRO', '14', '57965', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77498, '2020-10-26', 'SG', 'Singapore', 'WPRO', '5', '57970', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77499, '2020-10-27', 'SG', 'Singapore', 'WPRO', '3', '57973', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77500, '2020-10-28', 'SG', 'Singapore', 'WPRO', '7', '57980', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77501, '2020-10-29', 'SG', 'Singapore', 'WPRO', '7', '57987', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77502, '2020-10-30', 'SG', 'Singapore', 'WPRO', '7', '57994', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77503, '2020-10-31', 'SG', 'Singapore', 'WPRO', '9', '58003', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77504, '2020-11-01', 'SG', 'Singapore', 'WPRO', '12', '58015', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77505, '2020-11-02', 'SG', 'Singapore', 'WPRO', '4', '58019', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77506, '2020-11-03', 'SG', 'Singapore', 'WPRO', '1', '58020', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77507, '2020-11-04', 'SG', 'Singapore', 'WPRO', '9', '58029', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77508, '2020-11-05', 'SG', 'Singapore', 'WPRO', '7', '58036', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77509, '2020-11-06', 'SG', 'Singapore', 'WPRO', '7', '58043', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77510, '2020-11-07', 'SG', 'Singapore', 'WPRO', '4', '58047', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77511, '2020-11-08', 'SG', 'Singapore', 'WPRO', '7', '58054', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77512, '2020-11-09', 'SG', 'Singapore', 'WPRO', '2', '58056', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77513, '2020-11-10', 'SG', 'Singapore', 'WPRO', '8', '58064', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77514, '2020-11-11', 'SG', 'Singapore', 'WPRO', '9', '58073', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77515, '2020-11-12', 'SG', 'Singapore', 'WPRO', '18', '58091', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77516, '2020-11-13', 'SG', 'Singapore', 'WPRO', '11', '58102', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77517, '2020-11-14', 'SG', 'Singapore', 'WPRO', '12', '58114', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77518, '2020-11-15', 'SG', 'Singapore', 'WPRO', '2', '58116', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77519, '2020-11-16', 'SG', 'Singapore', 'WPRO', '3', '58119', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77520, '2020-11-17', 'SG', 'Singapore', 'WPRO', '5', '58124', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77521, '2020-11-18', 'SG', 'Singapore', 'WPRO', '6', '58130', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77522, '2020-11-19', 'SG', 'Singapore', 'WPRO', '5', '58135', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77523, '2020-11-20', 'SG', 'Singapore', 'WPRO', '4', '58139', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77524, '2020-11-21', 'SG', 'Singapore', 'WPRO', '4', '58143', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77525, '2020-11-22', 'SG', 'Singapore', 'WPRO', '5', '58148', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77526, '2020-11-23', 'SG', 'Singapore', 'WPRO', '12', '58160', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77527, '2020-11-24', 'SG', 'Singapore', 'WPRO', '5', '58165', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77528, '2020-11-25', 'SG', 'Singapore', 'WPRO', '18', '58183', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77529, '2020-11-26', 'SG', 'Singapore', 'WPRO', '7', '58190', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77530, '2020-11-27', 'SG', 'Singapore', 'WPRO', '5', '58195', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77531, '2020-11-28', 'SG', 'Singapore', 'WPRO', '4', '58199', '0', '28');
INSERT INTO public.who_global_data_import VALUES (77532, '2020-11-29', 'SG', 'Singapore', 'WPRO', '6', '58205', '1', '29');
INSERT INTO public.who_global_data_import VALUES (77533, '2020-11-30', 'SG', 'Singapore', 'WPRO', '8', '58213', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77534, '2020-12-01', 'SG', 'Singapore', 'WPRO', '5', '58218', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77535, '2020-12-02', 'SG', 'Singapore', 'WPRO', '10', '58228', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77536, '2020-12-03', 'SG', 'Singapore', 'WPRO', '2', '58230', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77537, '2020-12-04', 'SG', 'Singapore', 'WPRO', '9', '58239', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77538, '2020-12-05', 'SG', 'Singapore', 'WPRO', '3', '58242', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77539, '2020-12-06', 'SG', 'Singapore', 'WPRO', '13', '58255', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77540, '2020-12-07', 'SG', 'Singapore', 'WPRO', '5', '58260', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77541, '2020-12-08', 'SG', 'Singapore', 'WPRO', '13', '58273', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77542, '2020-12-09', 'SG', 'Singapore', 'WPRO', '12', '58285', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77543, '2020-12-10', 'SG', 'Singapore', 'WPRO', '6', '58291', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77544, '2020-12-11', 'SG', 'Singapore', 'WPRO', '6', '58297', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77545, '2020-12-12', 'SG', 'Singapore', 'WPRO', '8', '58305', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77546, '2020-12-13', 'SG', 'Singapore', 'WPRO', '8', '58313', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77547, '2020-12-14', 'SG', 'Singapore', 'WPRO', '7', '58320', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77548, '2020-12-15', 'SG', 'Singapore', 'WPRO', '5', '58325', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77549, '2020-12-16', 'SG', 'Singapore', 'WPRO', '16', '58341', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77550, '2020-12-17', 'SG', 'Singapore', 'WPRO', '12', '58353', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77551, '2020-12-18', 'SG', 'Singapore', 'WPRO', '24', '58377', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77552, '2020-12-19', 'SG', 'Singapore', 'WPRO', '9', '58386', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77553, '2020-12-20', 'SG', 'Singapore', 'WPRO', '17', '58403', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77554, '2020-12-21', 'SG', 'Singapore', 'WPRO', '19', '58422', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77555, '2020-12-22', 'SG', 'Singapore', 'WPRO', '10', '58432', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77556, '2020-12-23', 'SG', 'Singapore', 'WPRO', '29', '58461', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77557, '2020-12-24', 'SG', 'Singapore', 'WPRO', '21', '58482', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77558, '2020-12-25', 'SG', 'Singapore', 'WPRO', '13', '58495', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77559, '2020-12-26', 'SG', 'Singapore', 'WPRO', '14', '58509', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77560, '2020-12-27', 'SG', 'Singapore', 'WPRO', '10', '58519', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77561, '2020-12-28', 'SG', 'Singapore', 'WPRO', '5', '58524', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77562, '2020-12-29', 'SG', 'Singapore', 'WPRO', '5', '58529', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77563, '2020-12-30', 'SG', 'Singapore', 'WPRO', '13', '58542', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77564, '2020-12-31', 'SG', 'Singapore', 'WPRO', '27', '58569', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77565, '2021-01-01', 'SG', 'Singapore', 'WPRO', '30', '58599', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77566, '2021-01-02', 'SG', 'Singapore', 'WPRO', '30', '58629', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77567, '2021-01-03', 'SG', 'Singapore', 'WPRO', '33', '58662', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77568, '2021-01-04', 'SG', 'Singapore', 'WPRO', '35', '58697', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77569, '2021-01-05', 'SG', 'Singapore', 'WPRO', '24', '58721', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77570, '2021-01-06', 'SG', 'Singapore', 'WPRO', '28', '58749', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77571, '2021-01-07', 'SG', 'Singapore', 'WPRO', '31', '58780', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77572, '2021-01-08', 'SG', 'Singapore', 'WPRO', '33', '58813', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77573, '2021-01-09', 'SG', 'Singapore', 'WPRO', '23', '58836', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77574, '2021-01-10', 'SG', 'Singapore', 'WPRO', '29', '58865', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77575, '2021-01-11', 'SG', 'Singapore', 'WPRO', '42', '58907', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77576, '2021-01-12', 'SG', 'Singapore', 'WPRO', '22', '58929', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77577, '2021-01-13', 'SG', 'Singapore', 'WPRO', '17', '58946', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77578, '2021-01-14', 'SG', 'Singapore', 'WPRO', '38', '58984', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77579, '2021-01-15', 'SG', 'Singapore', 'WPRO', '45', '59029', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77580, '2021-01-16', 'SG', 'Singapore', 'WPRO', '30', '59059', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77581, '2021-01-17', 'SG', 'Singapore', 'WPRO', '24', '59083', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77582, '2021-01-18', 'SG', 'Singapore', 'WPRO', '30', '59113', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77583, '2021-01-19', 'SG', 'Singapore', 'WPRO', '14', '59127', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77584, '2021-01-20', 'SG', 'Singapore', 'WPRO', '30', '59157', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77585, '2021-01-21', 'SG', 'Singapore', 'WPRO', '40', '59197', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77586, '2021-01-22', 'SG', 'Singapore', 'WPRO', '38', '59235', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77587, '2021-01-23', 'SG', 'Singapore', 'WPRO', '15', '59250', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77588, '2021-01-24', 'SG', 'Singapore', 'WPRO', '10', '59260', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77589, '2021-01-25', 'SG', 'Singapore', 'WPRO', '48', '59308', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77590, '2021-01-26', 'SG', 'Singapore', 'WPRO', '44', '59352', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77591, '2021-01-27', 'SG', 'Singapore', 'WPRO', '14', '59366', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77592, '2021-01-28', 'SG', 'Singapore', 'WPRO', '25', '59391', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77593, '2021-01-29', 'SG', 'Singapore', 'WPRO', '34', '59425', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77594, '2021-01-30', 'SG', 'Singapore', 'WPRO', '24', '59449', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77595, '2021-01-31', 'SG', 'Singapore', 'WPRO', '58', '59507', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77596, '2021-02-01', 'SG', 'Singapore', 'WPRO', '29', '59536', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77597, '2021-02-02', 'SG', 'Singapore', 'WPRO', '29', '59565', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77598, '2021-02-03', 'SG', 'Singapore', 'WPRO', '19', '59584', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77599, '2021-02-04', 'SG', 'Singapore', 'WPRO', '18', '59602', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77600, '2021-02-05', 'SG', 'Singapore', 'WPRO', '22', '59624', '0', '29');
INSERT INTO public.who_global_data_import VALUES (77601, '2020-01-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77602, '2020-01-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77603, '2020-01-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77604, '2020-01-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77605, '2020-01-07', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77606, '2020-01-08', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77607, '2020-01-09', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77608, '2020-01-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77609, '2020-01-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77610, '2020-01-12', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77611, '2020-01-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77612, '2020-01-14', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77613, '2020-01-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77614, '2020-01-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77615, '2020-01-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77616, '2020-01-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77617, '2020-01-19', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77618, '2020-01-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77619, '2020-01-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77620, '2020-01-22', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77621, '2020-01-23', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77622, '2020-01-24', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77623, '2020-01-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77624, '2020-01-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77625, '2020-01-27', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77626, '2020-01-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77627, '2020-01-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77628, '2020-01-30', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77629, '2020-01-31', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77630, '2020-02-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77631, '2020-02-02', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77632, '2020-02-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77633, '2020-02-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77634, '2020-02-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77635, '2020-02-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77636, '2020-02-07', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77637, '2020-02-08', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77638, '2020-02-09', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77639, '2020-02-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77640, '2020-02-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77641, '2020-02-12', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77642, '2020-02-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77643, '2020-02-14', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77644, '2020-02-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77645, '2020-02-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77646, '2020-02-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77647, '2020-02-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77648, '2020-02-19', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77649, '2020-02-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77650, '2020-02-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77651, '2020-02-22', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77652, '2020-02-23', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77653, '2020-02-24', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77654, '2020-02-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77655, '2020-02-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77656, '2020-02-27', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77657, '2020-02-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77658, '2020-02-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77659, '2020-03-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77660, '2020-03-02', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77661, '2020-03-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77662, '2020-03-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77663, '2020-03-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77664, '2020-03-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77665, '2020-03-07', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77666, '2020-03-08', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77667, '2020-03-09', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77668, '2020-03-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77669, '2020-03-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77670, '2020-03-12', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77671, '2020-03-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77672, '2020-03-14', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77673, '2020-03-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77674, '2020-03-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77675, '2020-03-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77676, '2020-03-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77677, '2020-03-19', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77678, '2020-03-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77679, '2020-03-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77680, '2020-03-22', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77681, '2020-03-23', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77682, '2020-03-24', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77683, '2020-03-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77684, '2020-03-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77685, '2020-03-27', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77686, '2020-03-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77687, '2020-03-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77688, '2020-03-30', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77689, '2020-03-31', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77690, '2020-04-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77691, '2020-04-02', 'XB', 'Sint Eustatius', 'AMRO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77692, '2020-04-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77693, '2020-04-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77694, '2020-04-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77695, '2020-04-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77696, '2020-04-07', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77697, '2020-04-08', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77698, '2020-04-09', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77699, '2020-04-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77700, '2020-04-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77701, '2020-04-12', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77702, '2020-04-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77703, '2020-04-14', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77704, '2020-04-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77705, '2020-04-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77706, '2020-04-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77707, '2020-04-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77708, '2020-04-19', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77709, '2020-04-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77710, '2020-04-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77711, '2020-04-22', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77712, '2020-04-23', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77713, '2020-04-24', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77714, '2020-04-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77715, '2020-04-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77716, '2020-04-27', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77717, '2020-04-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77718, '2020-04-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77719, '2020-04-30', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77720, '2020-05-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77721, '2020-05-02', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77722, '2020-05-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77723, '2020-05-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77724, '2020-05-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77725, '2020-05-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77726, '2020-05-07', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77727, '2020-05-08', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77728, '2020-05-09', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77729, '2020-05-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77730, '2020-05-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77731, '2020-05-12', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77732, '2020-05-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77733, '2020-05-14', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77734, '2020-05-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77735, '2020-05-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77736, '2020-05-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77737, '2020-05-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77738, '2020-05-19', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77739, '2020-05-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77740, '2020-05-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77741, '2020-05-22', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77742, '2020-05-23', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77743, '2020-05-24', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77744, '2020-05-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77745, '2020-05-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77746, '2020-05-27', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77747, '2020-05-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77748, '2020-05-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77749, '2020-05-30', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77750, '2020-05-31', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77751, '2020-06-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77752, '2020-06-02', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77753, '2020-06-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77754, '2020-06-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77755, '2020-06-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77756, '2020-06-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77757, '2020-06-07', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77758, '2020-06-08', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77759, '2020-06-09', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77760, '2020-06-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77761, '2020-06-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77762, '2020-06-12', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77763, '2020-06-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77764, '2020-06-14', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77765, '2020-06-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77766, '2020-06-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77767, '2020-06-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77768, '2020-06-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77769, '2020-06-19', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77770, '2020-06-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77771, '2020-06-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77772, '2020-06-22', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77773, '2020-06-23', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77774, '2020-06-24', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77775, '2020-06-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77776, '2020-06-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77777, '2020-06-27', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77778, '2020-06-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77779, '2020-06-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77780, '2020-06-30', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77781, '2020-07-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77782, '2020-07-02', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77783, '2020-07-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77784, '2020-07-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77785, '2020-07-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77786, '2020-07-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77787, '2020-07-07', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77788, '2020-07-08', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77789, '2020-07-09', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77790, '2020-07-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77791, '2020-07-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77792, '2020-07-12', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77793, '2020-07-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77794, '2020-07-14', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77795, '2020-07-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77796, '2020-07-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77797, '2020-07-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77798, '2020-07-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77799, '2020-07-19', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77800, '2020-07-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77801, '2020-07-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77802, '2020-07-22', 'XB', 'Sint Eustatius', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77803, '2020-07-23', 'XB', 'Sint Eustatius', 'AMRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77804, '2020-07-24', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77805, '2020-07-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77806, '2020-07-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77807, '2020-07-27', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77808, '2020-07-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77809, '2020-07-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77810, '2020-07-30', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77811, '2020-07-31', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77812, '2020-08-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77813, '2020-08-02', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77814, '2020-08-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77815, '2020-08-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77816, '2020-08-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77817, '2020-08-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77818, '2020-08-07', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77819, '2020-08-08', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77820, '2020-08-09', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77821, '2020-08-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77822, '2020-08-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77823, '2020-08-12', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77824, '2020-08-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77825, '2020-08-14', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77826, '2020-08-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77827, '2020-08-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77828, '2020-08-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77829, '2020-08-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77830, '2020-08-19', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77831, '2020-08-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77832, '2020-08-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77833, '2020-08-22', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77834, '2020-08-23', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77835, '2020-08-24', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77836, '2020-08-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77837, '2020-08-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77838, '2020-08-27', 'XB', 'Sint Eustatius', 'AMRO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77839, '2020-08-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77840, '2020-08-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77841, '2020-08-30', 'XB', 'Sint Eustatius', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77842, '2020-08-31', 'XB', 'Sint Eustatius', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77843, '2020-09-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77844, '2020-09-02', 'XB', 'Sint Eustatius', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77845, '2020-09-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77846, '2020-09-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77847, '2020-09-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77848, '2020-09-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77849, '2020-09-07', 'XB', 'Sint Eustatius', 'AMRO', '2', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77850, '2020-09-08', 'XB', 'Sint Eustatius', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77851, '2020-09-09', 'XB', 'Sint Eustatius', 'AMRO', '4', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77852, '2020-09-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77853, '2020-09-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77854, '2020-09-12', 'XB', 'Sint Eustatius', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77855, '2020-09-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77856, '2020-09-14', 'XB', 'Sint Eustatius', 'AMRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77857, '2020-09-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77858, '2020-09-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77859, '2020-09-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77860, '2020-09-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77861, '2020-09-19', 'XB', 'Sint Eustatius', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77862, '2020-09-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77863, '2020-09-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77864, '2020-09-22', 'XB', 'Sint Eustatius', 'AMRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77865, '2020-09-23', 'XB', 'Sint Eustatius', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77866, '2020-09-24', 'XB', 'Sint Eustatius', 'AMRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77867, '2020-09-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77868, '2020-09-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77869, '2020-09-27', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77870, '2020-09-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77871, '2020-09-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77872, '2020-09-30', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77873, '2020-10-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77874, '2020-10-02', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77875, '2020-10-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77876, '2020-10-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77877, '2020-10-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77878, '2020-10-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77879, '2020-10-07', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77880, '2020-10-08', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77881, '2020-10-09', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77882, '2020-10-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77883, '2020-10-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77884, '2020-10-12', 'XB', 'Sint Eustatius', 'AMRO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77885, '2020-10-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77886, '2020-10-14', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77887, '2020-10-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77888, '2020-10-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77889, '2020-10-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77890, '2020-10-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77891, '2020-10-19', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77892, '2020-10-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77893, '2020-10-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77894, '2020-10-22', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77895, '2020-10-23', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77896, '2020-10-24', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77897, '2020-10-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77898, '2020-10-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77899, '2020-10-27', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77900, '2020-10-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77901, '2020-10-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77902, '2020-10-30', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77903, '2020-10-31', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77904, '2020-11-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77905, '2020-11-02', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77906, '2020-11-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77907, '2020-11-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77908, '2020-11-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77909, '2020-11-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77910, '2020-11-07', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77911, '2020-11-08', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77912, '2020-11-09', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77913, '2020-11-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77914, '2020-11-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77915, '2020-11-12', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77916, '2020-11-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77917, '2020-11-14', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77918, '2020-11-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77919, '2020-11-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77920, '2020-11-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77921, '2020-11-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77922, '2020-11-19', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77923, '2020-11-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77924, '2020-11-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77925, '2020-11-22', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77926, '2020-11-23', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77927, '2020-11-24', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77928, '2020-11-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77929, '2020-11-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77930, '2020-11-27', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77931, '2020-11-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77932, '2020-11-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77933, '2020-11-30', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77934, '2020-12-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77935, '2020-12-02', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77936, '2020-12-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77937, '2020-12-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77938, '2020-12-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77939, '2020-12-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77940, '2020-12-07', 'XB', 'Sint Eustatius', 'AMRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77941, '2020-12-08', 'XB', 'Sint Eustatius', 'AMRO', '2', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77942, '2020-12-09', 'XB', 'Sint Eustatius', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77943, '2020-12-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77944, '2020-12-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77945, '2020-12-12', 'XB', 'Sint Eustatius', 'AMRO', '2', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77946, '2020-12-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77947, '2020-12-14', 'XB', 'Sint Eustatius', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77948, '2020-12-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77949, '2020-12-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77950, '2020-12-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77951, '2020-12-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77952, '2020-12-19', 'XB', 'Sint Eustatius', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77953, '2020-12-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77954, '2020-12-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77955, '2020-12-22', 'XB', 'Sint Eustatius', 'AMRO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77956, '2020-12-23', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77957, '2020-12-24', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77958, '2020-12-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77959, '2020-12-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77960, '2020-12-27', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77961, '2020-12-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77962, '2020-12-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77963, '2020-12-30', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77964, '2020-12-31', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77965, '2021-01-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77966, '2021-01-02', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77967, '2021-01-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77968, '2021-01-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77969, '2021-01-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77970, '2021-01-06', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77971, '2021-01-07', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77972, '2021-01-08', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77973, '2021-01-09', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77974, '2021-01-10', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77975, '2021-01-11', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77976, '2021-01-12', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77977, '2021-01-13', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77978, '2021-01-14', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77979, '2021-01-15', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77980, '2021-01-16', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77981, '2021-01-17', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77982, '2021-01-18', 'XB', 'Sint Eustatius', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77983, '2021-01-19', 'XB', 'Sint Eustatius', 'AMRO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77984, '2021-01-20', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77985, '2021-01-21', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77986, '2021-01-22', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77987, '2021-01-23', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77988, '2021-01-24', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77989, '2021-01-25', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77990, '2021-01-26', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77991, '2021-01-27', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77992, '2021-01-28', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77993, '2021-01-29', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77994, '2021-01-30', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77995, '2021-01-31', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77996, '2021-02-01', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77997, '2021-02-02', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77998, '2021-02-03', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (77999, '2021-02-04', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78000, '2021-02-05', 'XB', 'Sint Eustatius', 'AMRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78001, '2020-01-03', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78002, '2020-01-04', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78003, '2020-01-05', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78004, '2020-01-06', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78005, '2020-01-07', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78006, '2020-01-08', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78007, '2020-01-09', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78008, '2020-01-10', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78009, '2020-01-11', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78010, '2020-01-12', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78011, '2020-01-13', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78012, '2020-01-14', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78013, '2020-01-15', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78014, '2020-01-16', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78015, '2020-01-17', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78016, '2020-01-18', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78017, '2020-01-19', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78018, '2020-01-20', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78019, '2020-01-21', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78020, '2020-01-22', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78021, '2020-01-23', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78022, '2020-01-24', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78023, '2020-01-25', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78024, '2020-01-26', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78025, '2020-01-27', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78026, '2020-01-28', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78027, '2020-01-29', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78028, '2020-01-30', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78029, '2020-01-31', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78030, '2020-02-01', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78031, '2020-02-02', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78032, '2020-02-03', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78033, '2020-02-04', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78034, '2020-02-05', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78035, '2020-02-06', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78036, '2020-02-07', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78037, '2020-02-08', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78038, '2020-02-09', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78039, '2020-02-10', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78040, '2020-02-11', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78041, '2020-02-12', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78042, '2020-02-13', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78043, '2020-02-14', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78044, '2020-02-15', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78045, '2020-02-16', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78046, '2020-02-17', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78047, '2020-02-18', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78048, '2020-02-19', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78049, '2020-02-20', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78050, '2020-02-21', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78051, '2020-02-22', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78052, '2020-02-23', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78053, '2020-02-24', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78054, '2020-02-25', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78055, '2020-02-26', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78056, '2020-02-27', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78057, '2020-02-28', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78058, '2020-02-29', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78059, '2020-03-01', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78060, '2020-03-02', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78061, '2020-03-03', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78062, '2020-03-04', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78063, '2020-03-05', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78064, '2020-03-06', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78065, '2020-03-07', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78066, '2020-03-08', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78067, '2020-03-09', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78068, '2020-03-10', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78069, '2020-03-11', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78070, '2020-03-12', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78071, '2020-03-13', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78072, '2020-03-14', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78073, '2020-03-15', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78074, '2020-03-16', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78075, '2020-03-17', 'SX', 'Sint Maarten', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78076, '2020-03-18', 'SX', 'Sint Maarten', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78077, '2020-03-19', 'SX', 'Sint Maarten', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78078, '2020-03-20', 'SX', 'Sint Maarten', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78079, '2020-03-21', 'SX', 'Sint Maarten', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78080, '2020-03-22', 'SX', 'Sint Maarten', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78081, '2020-03-23', 'SX', 'Sint Maarten', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78082, '2020-03-24', 'SX', 'Sint Maarten', 'AMRO', '-3', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78083, '2020-03-25', 'SX', 'Sint Maarten', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78084, '2020-03-26', 'SX', 'Sint Maarten', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78085, '2020-03-27', 'SX', 'Sint Maarten', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78086, '2020-03-28', 'SX', 'Sint Maarten', 'AMRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78087, '2020-03-29', 'SX', 'Sint Maarten', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78088, '2020-03-30', 'SX', 'Sint Maarten', 'AMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78089, '2020-03-31', 'SX', 'Sint Maarten', 'AMRO', '3', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78090, '2020-04-01', 'SX', 'Sint Maarten', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78091, '2020-04-02', 'SX', 'Sint Maarten', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78092, '2020-04-03', 'SX', 'Sint Maarten', 'AMRO', '12', '18', '1', '1');
INSERT INTO public.who_global_data_import VALUES (78093, '2020-04-04', 'SX', 'Sint Maarten', 'AMRO', '5', '23', '1', '2');
INSERT INTO public.who_global_data_import VALUES (78094, '2020-04-05', 'SX', 'Sint Maarten', 'AMRO', '0', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (78095, '2020-04-06', 'SX', 'Sint Maarten', 'AMRO', '0', '23', '0', '2');
INSERT INTO public.who_global_data_import VALUES (78096, '2020-04-07', 'SX', 'Sint Maarten', 'AMRO', '14', '37', '4', '6');
INSERT INTO public.who_global_data_import VALUES (78097, '2020-04-08', 'SX', 'Sint Maarten', 'AMRO', '3', '40', '2', '8');
INSERT INTO public.who_global_data_import VALUES (78098, '2020-04-09', 'SX', 'Sint Maarten', 'AMRO', '0', '40', '0', '8');
INSERT INTO public.who_global_data_import VALUES (78099, '2020-04-10', 'SX', 'Sint Maarten', 'AMRO', '3', '43', '0', '8');
INSERT INTO public.who_global_data_import VALUES (78100, '2020-04-11', 'SX', 'Sint Maarten', 'AMRO', '7', '50', '1', '9');
INSERT INTO public.who_global_data_import VALUES (78101, '2020-04-12', 'SX', 'Sint Maarten', 'AMRO', '0', '50', '0', '9');
INSERT INTO public.who_global_data_import VALUES (78102, '2020-04-13', 'SX', 'Sint Maarten', 'AMRO', '0', '50', '0', '9');
INSERT INTO public.who_global_data_import VALUES (78103, '2020-04-14', 'SX', 'Sint Maarten', 'AMRO', '2', '52', '0', '9');
INSERT INTO public.who_global_data_import VALUES (78104, '2020-04-15', 'SX', 'Sint Maarten', 'AMRO', '0', '52', '0', '9');
INSERT INTO public.who_global_data_import VALUES (78105, '2020-04-16', 'SX', 'Sint Maarten', 'AMRO', '1', '53', '0', '9');
INSERT INTO public.who_global_data_import VALUES (78106, '2020-04-17', 'SX', 'Sint Maarten', 'AMRO', '4', '57', '0', '9');
INSERT INTO public.who_global_data_import VALUES (78107, '2020-04-18', 'SX', 'Sint Maarten', 'AMRO', '0', '57', '0', '9');
INSERT INTO public.who_global_data_import VALUES (78108, '2020-04-19', 'SX', 'Sint Maarten', 'AMRO', '0', '57', '0', '9');
INSERT INTO public.who_global_data_import VALUES (78109, '2020-04-20', 'SX', 'Sint Maarten', 'AMRO', '7', '64', '0', '9');
INSERT INTO public.who_global_data_import VALUES (78110, '2020-04-21', 'SX', 'Sint Maarten', 'AMRO', '3', '67', '1', '10');
INSERT INTO public.who_global_data_import VALUES (78111, '2020-04-22', 'SX', 'Sint Maarten', 'AMRO', '1', '68', '0', '10');
INSERT INTO public.who_global_data_import VALUES (78112, '2020-04-23', 'SX', 'Sint Maarten', 'AMRO', '3', '71', '1', '11');
INSERT INTO public.who_global_data_import VALUES (78113, '2020-04-24', 'SX', 'Sint Maarten', 'AMRO', '2', '73', '1', '12');
INSERT INTO public.who_global_data_import VALUES (78114, '2020-04-25', 'SX', 'Sint Maarten', 'AMRO', '0', '73', '0', '12');
INSERT INTO public.who_global_data_import VALUES (78115, '2020-04-26', 'SX', 'Sint Maarten', 'AMRO', '0', '73', '0', '12');
INSERT INTO public.who_global_data_import VALUES (78116, '2020-04-27', 'SX', 'Sint Maarten', 'AMRO', '1', '74', '1', '13');
INSERT INTO public.who_global_data_import VALUES (78117, '2020-04-28', 'SX', 'Sint Maarten', 'AMRO', '0', '74', '0', '13');
INSERT INTO public.who_global_data_import VALUES (78118, '2020-04-29', 'SX', 'Sint Maarten', 'AMRO', '1', '75', '0', '13');
INSERT INTO public.who_global_data_import VALUES (78119, '2020-04-30', 'SX', 'Sint Maarten', 'AMRO', '0', '75', '0', '13');
INSERT INTO public.who_global_data_import VALUES (78120, '2020-05-01', 'SX', 'Sint Maarten', 'AMRO', '1', '76', '0', '13');
INSERT INTO public.who_global_data_import VALUES (78121, '2020-05-02', 'SX', 'Sint Maarten', 'AMRO', '0', '76', '0', '13');
INSERT INTO public.who_global_data_import VALUES (78122, '2020-05-03', 'SX', 'Sint Maarten', 'AMRO', '0', '76', '0', '13');
INSERT INTO public.who_global_data_import VALUES (78123, '2020-05-04', 'SX', 'Sint Maarten', 'AMRO', '0', '76', '0', '13');
INSERT INTO public.who_global_data_import VALUES (78124, '2020-05-05', 'SX', 'Sint Maarten', 'AMRO', '0', '76', '0', '13');
INSERT INTO public.who_global_data_import VALUES (78125, '2020-05-06', 'SX', 'Sint Maarten', 'AMRO', '0', '76', '1', '14');
INSERT INTO public.who_global_data_import VALUES (78126, '2020-05-07', 'SX', 'Sint Maarten', 'AMRO', '0', '76', '0', '14');
INSERT INTO public.who_global_data_import VALUES (78127, '2020-05-08', 'SX', 'Sint Maarten', 'AMRO', '0', '76', '0', '14');
INSERT INTO public.who_global_data_import VALUES (78128, '2020-05-09', 'SX', 'Sint Maarten', 'AMRO', '0', '76', '0', '14');
INSERT INTO public.who_global_data_import VALUES (78129, '2020-05-10', 'SX', 'Sint Maarten', 'AMRO', '1', '77', '1', '15');
INSERT INTO public.who_global_data_import VALUES (78130, '2020-05-11', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78131, '2020-05-12', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78132, '2020-05-13', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78133, '2020-05-14', 'SX', 'Sint Maarten', 'AMRO', '1', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78134, '2020-05-15', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78135, '2020-05-16', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78136, '2020-05-17', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78137, '2020-05-18', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78138, '2020-05-19', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78139, '2020-05-20', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78140, '2020-05-21', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78141, '2020-05-22', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78142, '2020-05-23', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78143, '2020-05-24', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78144, '2020-05-25', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78145, '2020-05-26', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78146, '2020-05-27', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78147, '2020-05-28', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78148, '2020-05-29', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78149, '2020-05-30', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78150, '2020-05-31', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78151, '2020-06-01', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78152, '2020-06-02', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78153, '2020-06-03', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78154, '2020-06-04', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78155, '2020-06-05', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78156, '2020-06-06', 'SX', 'Sint Maarten', 'AMRO', '-1', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78157, '2020-06-07', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78158, '2020-06-08', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78159, '2020-06-09', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78160, '2020-06-10', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78161, '2020-06-11', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78162, '2020-06-12', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78163, '2020-06-13', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78164, '2020-06-14', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78165, '2020-06-15', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78166, '2020-06-16', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78167, '2020-06-17', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78168, '2020-06-18', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78169, '2020-06-19', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78170, '2020-06-20', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78171, '2020-06-21', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78172, '2020-06-22', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78173, '2020-06-23', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78174, '2020-06-24', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78175, '2020-06-25', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78176, '2020-06-26', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78177, '2020-06-27', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78178, '2020-06-28', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78179, '2020-06-29', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78180, '2020-06-30', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78181, '2020-07-01', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78182, '2020-07-02', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78183, '2020-07-03', 'SX', 'Sint Maarten', 'AMRO', '0', '77', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78184, '2020-07-04', 'SX', 'Sint Maarten', 'AMRO', '1', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78185, '2020-07-05', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78186, '2020-07-06', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78187, '2020-07-07', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78188, '2020-07-08', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78189, '2020-07-09', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78190, '2020-07-10', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78191, '2020-07-11', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78192, '2020-07-12', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78193, '2020-07-13', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78194, '2020-07-14', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78195, '2020-07-15', 'SX', 'Sint Maarten', 'AMRO', '0', '78', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78196, '2020-07-16', 'SX', 'Sint Maarten', 'AMRO', '1', '79', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78197, '2020-07-17', 'SX', 'Sint Maarten', 'AMRO', '0', '79', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78198, '2020-07-18', 'SX', 'Sint Maarten', 'AMRO', '0', '79', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78199, '2020-07-19', 'SX', 'Sint Maarten', 'AMRO', '0', '79', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78200, '2020-07-20', 'SX', 'Sint Maarten', 'AMRO', '0', '79', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78201, '2020-07-21', 'SX', 'Sint Maarten', 'AMRO', '0', '79', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78202, '2020-07-22', 'SX', 'Sint Maarten', 'AMRO', '0', '79', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78203, '2020-07-23', 'SX', 'Sint Maarten', 'AMRO', '2', '81', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78204, '2020-07-24', 'SX', 'Sint Maarten', 'AMRO', '3', '84', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78205, '2020-07-25', 'SX', 'Sint Maarten', 'AMRO', '10', '94', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78206, '2020-07-26', 'SX', 'Sint Maarten', 'AMRO', '0', '94', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78207, '2020-07-27', 'SX', 'Sint Maarten', 'AMRO', '0', '94', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78208, '2020-07-28', 'SX', 'Sint Maarten', 'AMRO', '20', '114', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78209, '2020-07-29', 'SX', 'Sint Maarten', 'AMRO', '1', '115', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78210, '2020-07-30', 'SX', 'Sint Maarten', 'AMRO', '6', '121', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78211, '2020-07-31', 'SX', 'Sint Maarten', 'AMRO', '5', '126', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78212, '2020-08-01', 'SX', 'Sint Maarten', 'AMRO', '2', '128', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78213, '2020-08-02', 'SX', 'Sint Maarten', 'AMRO', '0', '128', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78214, '2020-08-03', 'SX', 'Sint Maarten', 'AMRO', '0', '128', '0', '15');
INSERT INTO public.who_global_data_import VALUES (78215, '2020-08-04', 'SX', 'Sint Maarten', 'AMRO', '18', '146', '1', '16');
INSERT INTO public.who_global_data_import VALUES (78216, '2020-08-05', 'SX', 'Sint Maarten', 'AMRO', '4', '150', '0', '16');
INSERT INTO public.who_global_data_import VALUES (78217, '2020-08-06', 'SX', 'Sint Maarten', 'AMRO', '6', '156', '0', '16');
INSERT INTO public.who_global_data_import VALUES (78218, '2020-08-07', 'SX', 'Sint Maarten', 'AMRO', '4', '160', '0', '16');
INSERT INTO public.who_global_data_import VALUES (78219, '2020-08-08', 'SX', 'Sint Maarten', 'AMRO', '16', '176', '0', '16');
INSERT INTO public.who_global_data_import VALUES (78220, '2020-08-09', 'SX', 'Sint Maarten', 'AMRO', '0', '176', '0', '16');
INSERT INTO public.who_global_data_import VALUES (78221, '2020-08-10', 'SX', 'Sint Maarten', 'AMRO', '0', '176', '0', '16');
INSERT INTO public.who_global_data_import VALUES (78222, '2020-08-11', 'SX', 'Sint Maarten', 'AMRO', '16', '192', '1', '17');
INSERT INTO public.who_global_data_import VALUES (78223, '2020-08-12', 'SX', 'Sint Maarten', 'AMRO', '0', '192', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78224, '2020-08-13', 'SX', 'Sint Maarten', 'AMRO', '27', '219', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78225, '2020-08-14', 'SX', 'Sint Maarten', 'AMRO', '29', '248', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78226, '2020-08-15', 'SX', 'Sint Maarten', 'AMRO', '15', '263', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78227, '2020-08-16', 'SX', 'Sint Maarten', 'AMRO', '0', '263', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78228, '2020-08-17', 'SX', 'Sint Maarten', 'AMRO', '0', '263', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78229, '2020-08-18', 'SX', 'Sint Maarten', 'AMRO', '54', '317', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78230, '2020-08-19', 'SX', 'Sint Maarten', 'AMRO', '9', '326', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78231, '2020-08-20', 'SX', 'Sint Maarten', 'AMRO', '7', '333', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78232, '2020-08-21', 'SX', 'Sint Maarten', 'AMRO', '15', '348', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78233, '2020-08-22', 'SX', 'Sint Maarten', 'AMRO', '5', '353', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78234, '2020-08-23', 'SX', 'Sint Maarten', 'AMRO', '0', '353', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78235, '2020-08-24', 'SX', 'Sint Maarten', 'AMRO', '0', '353', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78236, '2020-08-25', 'SX', 'Sint Maarten', 'AMRO', '43', '396', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78237, '2020-08-26', 'SX', 'Sint Maarten', 'AMRO', '12', '408', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78238, '2020-08-27', 'SX', 'Sint Maarten', 'AMRO', '10', '418', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78239, '2020-08-28', 'SX', 'Sint Maarten', 'AMRO', '24', '442', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78240, '2020-08-29', 'SX', 'Sint Maarten', 'AMRO', '2', '444', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78241, '2020-08-30', 'SX', 'Sint Maarten', 'AMRO', '0', '444', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78242, '2020-08-31', 'SX', 'Sint Maarten', 'AMRO', '0', '444', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78243, '2020-09-01', 'SX', 'Sint Maarten', 'AMRO', '19', '463', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78244, '2020-09-02', 'SX', 'Sint Maarten', 'AMRO', '13', '476', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78245, '2020-09-03', 'SX', 'Sint Maarten', 'AMRO', '6', '482', '2', '19');
INSERT INTO public.who_global_data_import VALUES (78246, '2020-09-04', 'SX', 'Sint Maarten', 'AMRO', '13', '495', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78247, '2020-09-05', 'SX', 'Sint Maarten', 'AMRO', '9', '504', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78248, '2020-09-06', 'SX', 'Sint Maarten', 'AMRO', '0', '504', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78249, '2020-09-07', 'SX', 'Sint Maarten', 'AMRO', '0', '504', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78250, '2020-09-08', 'SX', 'Sint Maarten', 'AMRO', '7', '511', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78251, '2020-09-09', 'SX', 'Sint Maarten', 'AMRO', '5', '516', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78252, '2020-09-10', 'SX', 'Sint Maarten', 'AMRO', '11', '527', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78253, '2020-09-11', 'SX', 'Sint Maarten', 'AMRO', '3', '530', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78254, '2020-09-12', 'SX', 'Sint Maarten', 'AMRO', '0', '530', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78255, '2020-09-13', 'SX', 'Sint Maarten', 'AMRO', '0', '530', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78256, '2020-09-14', 'SX', 'Sint Maarten', 'AMRO', '0', '530', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78257, '2020-09-15', 'SX', 'Sint Maarten', 'AMRO', '19', '549', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78258, '2020-09-16', 'SX', 'Sint Maarten', 'AMRO', '0', '549', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78259, '2020-09-17', 'SX', 'Sint Maarten', 'AMRO', '0', '549', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78260, '2020-09-18', 'SX', 'Sint Maarten', 'AMRO', '8', '557', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78261, '2020-09-19', 'SX', 'Sint Maarten', 'AMRO', '8', '565', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78262, '2020-09-20', 'SX', 'Sint Maarten', 'AMRO', '0', '565', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78263, '2020-09-21', 'SX', 'Sint Maarten', 'AMRO', '0', '565', '0', '19');
INSERT INTO public.who_global_data_import VALUES (78264, '2020-09-22', 'SX', 'Sint Maarten', 'AMRO', '19', '584', '1', '20');
INSERT INTO public.who_global_data_import VALUES (78265, '2020-09-23', 'SX', 'Sint Maarten', 'AMRO', '7', '591', '0', '20');
INSERT INTO public.who_global_data_import VALUES (78266, '2020-09-24', 'SX', 'Sint Maarten', 'AMRO', '3', '594', '0', '20');
INSERT INTO public.who_global_data_import VALUES (78267, '2020-09-25', 'SX', 'Sint Maarten', 'AMRO', '22', '616', '1', '21');
INSERT INTO public.who_global_data_import VALUES (78268, '2020-09-26', 'SX', 'Sint Maarten', 'AMRO', '2', '618', '1', '22');
INSERT INTO public.who_global_data_import VALUES (78269, '2020-09-27', 'SX', 'Sint Maarten', 'AMRO', '0', '618', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78270, '2020-09-28', 'SX', 'Sint Maarten', 'AMRO', '0', '618', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78271, '2020-09-29', 'SX', 'Sint Maarten', 'AMRO', '26', '644', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78272, '2020-09-30', 'SX', 'Sint Maarten', 'AMRO', '1', '645', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78273, '2020-10-01', 'SX', 'Sint Maarten', 'AMRO', '0', '645', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78274, '2020-10-02', 'SX', 'Sint Maarten', 'AMRO', '14', '659', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78275, '2020-10-03', 'SX', 'Sint Maarten', 'AMRO', '9', '668', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78276, '2020-10-04', 'SX', 'Sint Maarten', 'AMRO', '0', '668', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78277, '2020-10-05', 'SX', 'Sint Maarten', 'AMRO', '0', '668', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78278, '2020-10-06', 'SX', 'Sint Maarten', 'AMRO', '11', '679', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78279, '2020-10-07', 'SX', 'Sint Maarten', 'AMRO', '7', '686', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78280, '2020-10-08', 'SX', 'Sint Maarten', 'AMRO', '3', '689', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78281, '2020-10-09', 'SX', 'Sint Maarten', 'AMRO', '9', '698', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78282, '2020-10-10', 'SX', 'Sint Maarten', 'AMRO', '1', '699', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78283, '2020-10-11', 'SX', 'Sint Maarten', 'AMRO', '0', '699', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78284, '2020-10-12', 'SX', 'Sint Maarten', 'AMRO', '0', '699', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78285, '2020-10-13', 'SX', 'Sint Maarten', 'AMRO', '11', '710', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78286, '2020-10-14', 'SX', 'Sint Maarten', 'AMRO', '0', '710', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78287, '2020-10-15', 'SX', 'Sint Maarten', 'AMRO', '9', '719', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78288, '2020-10-16', 'SX', 'Sint Maarten', 'AMRO', '10', '729', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78289, '2020-10-17', 'SX', 'Sint Maarten', 'AMRO', '8', '737', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78290, '2020-10-18', 'SX', 'Sint Maarten', 'AMRO', '0', '737', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78291, '2020-10-19', 'SX', 'Sint Maarten', 'AMRO', '0', '737', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78292, '2020-10-20', 'SX', 'Sint Maarten', 'AMRO', '16', '753', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78293, '2020-10-21', 'SX', 'Sint Maarten', 'AMRO', '3', '756', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78294, '2020-10-22', 'SX', 'Sint Maarten', 'AMRO', '6', '762', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78295, '2020-10-23', 'SX', 'Sint Maarten', 'AMRO', '7', '769', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78296, '2020-10-24', 'SX', 'Sint Maarten', 'AMRO', '7', '776', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78297, '2020-10-25', 'SX', 'Sint Maarten', 'AMRO', '0', '776', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78298, '2020-10-26', 'SX', 'Sint Maarten', 'AMRO', '0', '776', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78299, '2020-10-27', 'SX', 'Sint Maarten', 'AMRO', '8', '784', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78300, '2020-10-28', 'SX', 'Sint Maarten', 'AMRO', '5', '789', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78301, '2020-10-29', 'SX', 'Sint Maarten', 'AMRO', '3', '792', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78302, '2020-10-30', 'SX', 'Sint Maarten', 'AMRO', '13', '805', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78303, '2020-10-31', 'SX', 'Sint Maarten', 'AMRO', '0', '805', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78304, '2020-11-01', 'SX', 'Sint Maarten', 'AMRO', '0', '805', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78305, '2020-11-02', 'SX', 'Sint Maarten', 'AMRO', '0', '805', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78306, '2020-11-03', 'SX', 'Sint Maarten', 'AMRO', '26', '831', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78307, '2020-11-04', 'SX', 'Sint Maarten', 'AMRO', '13', '844', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78308, '2020-11-05', 'SX', 'Sint Maarten', 'AMRO', '15', '859', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78309, '2020-11-06', 'SX', 'Sint Maarten', 'AMRO', '11', '870', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78310, '2020-11-07', 'SX', 'Sint Maarten', 'AMRO', '0', '870', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78311, '2020-11-08', 'SX', 'Sint Maarten', 'AMRO', '0', '870', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78312, '2020-11-09', 'SX', 'Sint Maarten', 'AMRO', '0', '870', '0', '22');
INSERT INTO public.who_global_data_import VALUES (78313, '2020-11-10', 'SX', 'Sint Maarten', 'AMRO', '26', '896', '1', '23');
INSERT INTO public.who_global_data_import VALUES (78314, '2020-11-11', 'SX', 'Sint Maarten', 'AMRO', '0', '896', '0', '23');
INSERT INTO public.who_global_data_import VALUES (78315, '2020-11-12', 'SX', 'Sint Maarten', 'AMRO', '12', '908', '0', '23');
INSERT INTO public.who_global_data_import VALUES (78316, '2020-11-13', 'SX', 'Sint Maarten', 'AMRO', '0', '908', '0', '23');
INSERT INTO public.who_global_data_import VALUES (78317, '2020-11-14', 'SX', 'Sint Maarten', 'AMRO', '6', '914', '0', '23');
INSERT INTO public.who_global_data_import VALUES (78318, '2020-11-15', 'SX', 'Sint Maarten', 'AMRO', '0', '914', '0', '23');
INSERT INTO public.who_global_data_import VALUES (78319, '2020-11-16', 'SX', 'Sint Maarten', 'AMRO', '0', '914', '0', '23');
INSERT INTO public.who_global_data_import VALUES (78320, '2020-11-17', 'SX', 'Sint Maarten', 'AMRO', '19', '933', '1', '24');
INSERT INTO public.who_global_data_import VALUES (78321, '2020-11-18', 'SX', 'Sint Maarten', 'AMRO', '6', '939', '0', '24');
INSERT INTO public.who_global_data_import VALUES (78322, '2020-11-19', 'SX', 'Sint Maarten', 'AMRO', '15', '954', '0', '24');
INSERT INTO public.who_global_data_import VALUES (78323, '2020-11-20', 'SX', 'Sint Maarten', 'AMRO', '10', '964', '0', '24');
INSERT INTO public.who_global_data_import VALUES (78324, '2020-11-21', 'SX', 'Sint Maarten', 'AMRO', '9', '973', '0', '24');
INSERT INTO public.who_global_data_import VALUES (78325, '2020-11-22', 'SX', 'Sint Maarten', 'AMRO', '0', '973', '0', '24');
INSERT INTO public.who_global_data_import VALUES (78326, '2020-11-23', 'SX', 'Sint Maarten', 'AMRO', '0', '973', '0', '24');
INSERT INTO public.who_global_data_import VALUES (78327, '2020-11-24', 'SX', 'Sint Maarten', 'AMRO', '34', '1007', '1', '25');
INSERT INTO public.who_global_data_import VALUES (78328, '2020-11-25', 'SX', 'Sint Maarten', 'AMRO', '10', '1017', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78329, '2020-11-26', 'SX', 'Sint Maarten', 'AMRO', '3', '1020', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78330, '2020-11-27', 'SX', 'Sint Maarten', 'AMRO', '16', '1036', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78331, '2020-11-28', 'SX', 'Sint Maarten', 'AMRO', '5', '1041', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78332, '2020-11-29', 'SX', 'Sint Maarten', 'AMRO', '0', '1041', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78333, '2020-11-30', 'SX', 'Sint Maarten', 'AMRO', '0', '1041', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78334, '2020-12-01', 'SX', 'Sint Maarten', 'AMRO', '25', '1066', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78335, '2020-12-02', 'SX', 'Sint Maarten', 'AMRO', '3', '1069', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78336, '2020-12-03', 'SX', 'Sint Maarten', 'AMRO', '3', '1072', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78337, '2020-12-04', 'SX', 'Sint Maarten', 'AMRO', '20', '1092', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78338, '2020-12-05', 'SX', 'Sint Maarten', 'AMRO', '13', '1105', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78339, '2020-12-06', 'SX', 'Sint Maarten', 'AMRO', '0', '1105', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78340, '2020-12-07', 'SX', 'Sint Maarten', 'AMRO', '0', '1105', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78341, '2020-12-08', 'SX', 'Sint Maarten', 'AMRO', '36', '1141', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78342, '2020-12-09', 'SX', 'Sint Maarten', 'AMRO', '14', '1155', '1', '26');
INSERT INTO public.who_global_data_import VALUES (78343, '2020-12-10', 'SX', 'Sint Maarten', 'AMRO', '0', '1155', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78344, '2020-12-11', 'SX', 'Sint Maarten', 'AMRO', '30', '1185', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78345, '2020-12-12', 'SX', 'Sint Maarten', 'AMRO', '16', '1201', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78346, '2020-12-13', 'SX', 'Sint Maarten', 'AMRO', '0', '1201', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78347, '2020-12-14', 'SX', 'Sint Maarten', 'AMRO', '0', '1201', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78348, '2020-12-15', 'SX', 'Sint Maarten', 'AMRO', '31', '1232', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78349, '2020-12-16', 'SX', 'Sint Maarten', 'AMRO', '17', '1249', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78350, '2020-12-17', 'SX', 'Sint Maarten', 'AMRO', '20', '1269', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78351, '2020-12-18', 'SX', 'Sint Maarten', 'AMRO', '7', '1276', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78352, '2020-12-19', 'SX', 'Sint Maarten', 'AMRO', '18', '1294', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78353, '2020-12-20', 'SX', 'Sint Maarten', 'AMRO', '0', '1294', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78354, '2020-12-21', 'SX', 'Sint Maarten', 'AMRO', '0', '1294', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78355, '2020-12-22', 'SX', 'Sint Maarten', 'AMRO', '34', '1328', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78356, '2020-12-23', 'SX', 'Sint Maarten', 'AMRO', '10', '1338', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78357, '2020-12-24', 'SX', 'Sint Maarten', 'AMRO', '24', '1362', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78358, '2020-12-25', 'SX', 'Sint Maarten', 'AMRO', '8', '1370', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78359, '2020-12-26', 'SX', 'Sint Maarten', 'AMRO', '0', '1370', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78360, '2020-12-27', 'SX', 'Sint Maarten', 'AMRO', '0', '1370', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78361, '2020-12-28', 'SX', 'Sint Maarten', 'AMRO', '0', '1370', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78362, '2020-12-29', 'SX', 'Sint Maarten', 'AMRO', '41', '1411', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78363, '2020-12-30', 'SX', 'Sint Maarten', 'AMRO', '0', '1411', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78364, '2020-12-31', 'SX', 'Sint Maarten', 'AMRO', '12', '1423', '1', '27');
INSERT INTO public.who_global_data_import VALUES (78365, '2021-01-01', 'SX', 'Sint Maarten', 'AMRO', '11', '1434', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78366, '2021-01-02', 'SX', 'Sint Maarten', 'AMRO', '0', '1434', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78367, '2021-01-03', 'SX', 'Sint Maarten', 'AMRO', '0', '1434', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78368, '2021-01-04', 'SX', 'Sint Maarten', 'AMRO', '0', '1434', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78369, '2021-01-05', 'SX', 'Sint Maarten', 'AMRO', '28', '1462', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78370, '2021-01-06', 'SX', 'Sint Maarten', 'AMRO', '3', '1465', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78371, '2021-01-07', 'SX', 'Sint Maarten', 'AMRO', '39', '1504', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78372, '2021-01-08', 'SX', 'Sint Maarten', 'AMRO', '8', '1512', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78373, '2021-01-09', 'SX', 'Sint Maarten', 'AMRO', '19', '1531', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78374, '2021-01-10', 'SX', 'Sint Maarten', 'AMRO', '0', '1531', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78375, '2021-01-11', 'SX', 'Sint Maarten', 'AMRO', '0', '1531', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78376, '2021-01-12', 'SX', 'Sint Maarten', 'AMRO', '24', '1555', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78377, '2021-01-13', 'SX', 'Sint Maarten', 'AMRO', '20', '1575', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78378, '2021-01-14', 'SX', 'Sint Maarten', 'AMRO', '14', '1589', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78379, '2021-01-15', 'SX', 'Sint Maarten', 'AMRO', '18', '1607', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78380, '2021-01-16', 'SX', 'Sint Maarten', 'AMRO', '22', '1629', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78381, '2021-01-17', 'SX', 'Sint Maarten', 'AMRO', '0', '1629', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78382, '2021-01-18', 'SX', 'Sint Maarten', 'AMRO', '0', '1629', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78383, '2021-01-19', 'SX', 'Sint Maarten', 'AMRO', '27', '1656', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78384, '2021-01-20', 'SX', 'Sint Maarten', 'AMRO', '13', '1669', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78385, '2021-01-21', 'SX', 'Sint Maarten', 'AMRO', '8', '1677', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78386, '2021-01-22', 'SX', 'Sint Maarten', 'AMRO', '26', '1703', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78387, '2021-01-23', 'SX', 'Sint Maarten', 'AMRO', '5', '1708', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78388, '2021-01-24', 'SX', 'Sint Maarten', 'AMRO', '0', '1708', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78389, '2021-01-25', 'SX', 'Sint Maarten', 'AMRO', '0', '1708', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78390, '2021-01-26', 'SX', 'Sint Maarten', 'AMRO', '41', '1749', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78391, '2021-01-27', 'SX', 'Sint Maarten', 'AMRO', '9', '1758', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78392, '2021-01-28', 'SX', 'Sint Maarten', 'AMRO', '9', '1767', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78393, '2021-01-29', 'SX', 'Sint Maarten', 'AMRO', '40', '1807', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78394, '2021-01-30', 'SX', 'Sint Maarten', 'AMRO', '15', '1822', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78395, '2021-01-31', 'SX', 'Sint Maarten', 'AMRO', '0', '1822', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78396, '2021-02-01', 'SX', 'Sint Maarten', 'AMRO', '0', '1822', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78397, '2021-02-02', 'SX', 'Sint Maarten', 'AMRO', '40', '1862', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78398, '2021-02-03', 'SX', 'Sint Maarten', 'AMRO', '8', '1870', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78399, '2021-02-04', 'SX', 'Sint Maarten', 'AMRO', '15', '1885', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78400, '2021-02-05', 'SX', 'Sint Maarten', 'AMRO', '14', '1899', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78401, '2020-01-03', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78402, '2020-01-04', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78403, '2020-01-05', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78404, '2020-01-06', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78405, '2020-01-07', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78406, '2020-01-08', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78407, '2020-01-09', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78408, '2020-01-10', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78409, '2020-01-11', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78410, '2020-01-12', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78411, '2020-01-13', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78412, '2020-01-14', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78413, '2020-01-15', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78414, '2020-01-16', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78415, '2020-01-17', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78416, '2020-01-18', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78417, '2020-01-19', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78418, '2020-01-20', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78419, '2020-01-21', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78420, '2020-01-22', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78421, '2020-01-23', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78422, '2020-01-24', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78423, '2020-01-25', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78424, '2020-01-26', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78425, '2020-01-27', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78426, '2020-01-28', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78427, '2020-01-29', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78428, '2020-01-30', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78429, '2020-01-31', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78430, '2020-02-01', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78431, '2020-02-02', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78432, '2020-02-03', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78433, '2020-02-04', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78434, '2020-02-05', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78435, '2020-02-06', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78436, '2020-02-07', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78437, '2020-02-08', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78438, '2020-02-09', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78439, '2020-02-10', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78440, '2020-02-11', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78441, '2020-02-12', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78442, '2020-02-13', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78443, '2020-02-14', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78444, '2020-02-15', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78445, '2020-02-16', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78446, '2020-02-17', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78447, '2020-02-18', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78448, '2020-02-19', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78449, '2020-02-20', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78450, '2020-02-21', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78451, '2020-02-22', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78452, '2020-02-23', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78453, '2020-02-24', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78454, '2020-02-25', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78455, '2020-02-26', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78456, '2020-02-27', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78457, '2020-02-28', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78458, '2020-02-29', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78459, '2020-03-01', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78460, '2020-03-02', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78461, '2020-03-03', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78462, '2020-03-04', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78463, '2020-03-05', 'SK', 'Slovakia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78464, '2020-03-06', 'SK', 'Slovakia', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78465, '2020-03-07', 'SK', 'Slovakia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78466, '2020-03-08', 'SK', 'Slovakia', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78467, '2020-03-09', 'SK', 'Slovakia', 'EURO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78468, '2020-03-10', 'SK', 'Slovakia', 'EURO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78469, '2020-03-11', 'SK', 'Slovakia', 'EURO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78470, '2020-03-12', 'SK', 'Slovakia', 'EURO', '3', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78471, '2020-03-13', 'SK', 'Slovakia', 'EURO', '11', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78472, '2020-03-14', 'SK', 'Slovakia', 'EURO', '9', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78473, '2020-03-15', 'SK', 'Slovakia', 'EURO', '14', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78474, '2020-03-16', 'SK', 'Slovakia', 'EURO', '17', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78475, '2020-03-17', 'SK', 'Slovakia', 'EURO', '23', '84', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78476, '2020-03-18', 'SK', 'Slovakia', 'EURO', '13', '97', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78477, '2020-03-19', 'SK', 'Slovakia', 'EURO', '10', '107', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78478, '2020-03-20', 'SK', 'Slovakia', 'EURO', '16', '123', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78479, '2020-03-21', 'SK', 'Slovakia', 'EURO', '14', '137', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78480, '2020-03-22', 'SK', 'Slovakia', 'EURO', '41', '178', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78481, '2020-03-23', 'SK', 'Slovakia', 'EURO', '7', '185', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78482, '2020-03-24', 'SK', 'Slovakia', 'EURO', '6', '191', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78483, '2020-03-25', 'SK', 'Slovakia', 'EURO', '13', '204', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78484, '2020-03-26', 'SK', 'Slovakia', 'EURO', '12', '216', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78485, '2020-03-27', 'SK', 'Slovakia', 'EURO', '10', '226', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78486, '2020-03-28', 'SK', 'Slovakia', 'EURO', '69', '295', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78487, '2020-03-29', 'SK', 'Slovakia', 'EURO', '0', '295', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78488, '2020-03-30', 'SK', 'Slovakia', 'EURO', '41', '336', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78489, '2020-03-31', 'SK', 'Slovakia', 'EURO', '0', '336', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78490, '2020-04-01', 'SK', 'Slovakia', 'EURO', '27', '363', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78491, '2020-04-02', 'SK', 'Slovakia', 'EURO', '37', '400', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78492, '2020-04-03', 'SK', 'Slovakia', 'EURO', '26', '426', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78493, '2020-04-04', 'SK', 'Slovakia', 'EURO', '24', '450', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78494, '2020-04-05', 'SK', 'Slovakia', 'EURO', '21', '471', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78495, '2020-04-06', 'SK', 'Slovakia', 'EURO', '14', '485', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78496, '2020-04-07', 'SK', 'Slovakia', 'EURO', '49', '534', '2', '2');
INSERT INTO public.who_global_data_import VALUES (78497, '2020-04-08', 'SK', 'Slovakia', 'EURO', '47', '581', '0', '2');
INSERT INTO public.who_global_data_import VALUES (78498, '2020-04-09', 'SK', 'Slovakia', 'EURO', '101', '682', '0', '2');
INSERT INTO public.who_global_data_import VALUES (78499, '2020-04-10', 'SK', 'Slovakia', 'EURO', '19', '701', '0', '2');
INSERT INTO public.who_global_data_import VALUES (78500, '2020-04-11', 'SK', 'Slovakia', 'EURO', '14', '715', '0', '2');
INSERT INTO public.who_global_data_import VALUES (78501, '2020-04-12', 'SK', 'Slovakia', 'EURO', '13', '728', '0', '2');
INSERT INTO public.who_global_data_import VALUES (78502, '2020-04-13', 'SK', 'Slovakia', 'EURO', '14', '742', '0', '2');
INSERT INTO public.who_global_data_import VALUES (78503, '2020-04-14', 'SK', 'Slovakia', 'EURO', '27', '769', '0', '2');
INSERT INTO public.who_global_data_import VALUES (78504, '2020-04-15', 'SK', 'Slovakia', 'EURO', '66', '835', '0', '2');
INSERT INTO public.who_global_data_import VALUES (78505, '2020-04-16', 'SK', 'Slovakia', 'EURO', '28', '863', '4', '6');
INSERT INTO public.who_global_data_import VALUES (78506, '2020-04-17', 'SK', 'Slovakia', 'EURO', '114', '977', '2', '8');
INSERT INTO public.who_global_data_import VALUES (78507, '2020-04-18', 'SK', 'Slovakia', 'EURO', '72', '1049', '1', '9');
INSERT INTO public.who_global_data_import VALUES (78508, '2020-04-19', 'SK', 'Slovakia', 'EURO', '40', '1089', '2', '11');
INSERT INTO public.who_global_data_import VALUES (78509, '2020-04-20', 'SK', 'Slovakia', 'EURO', '72', '1161', '1', '12');
INSERT INTO public.who_global_data_import VALUES (78510, '2020-04-21', 'SK', 'Slovakia', 'EURO', '12', '1173', '1', '13');
INSERT INTO public.who_global_data_import VALUES (78511, '2020-04-22', 'SK', 'Slovakia', 'EURO', '26', '1199', '1', '14');
INSERT INTO public.who_global_data_import VALUES (78512, '2020-04-23', 'SK', 'Slovakia', 'EURO', '45', '1244', '0', '14');
INSERT INTO public.who_global_data_import VALUES (78513, '2020-04-24', 'SK', 'Slovakia', 'EURO', '81', '1325', '1', '15');
INSERT INTO public.who_global_data_import VALUES (78514, '2020-04-25', 'SK', 'Slovakia', 'EURO', '35', '1360', '2', '17');
INSERT INTO public.who_global_data_import VALUES (78515, '2020-04-26', 'SK', 'Slovakia', 'EURO', '13', '1373', '0', '17');
INSERT INTO public.who_global_data_import VALUES (78516, '2020-04-27', 'SK', 'Slovakia', 'EURO', '6', '1379', '1', '18');
INSERT INTO public.who_global_data_import VALUES (78517, '2020-04-28', 'SK', 'Slovakia', 'EURO', '2', '1381', '0', '18');
INSERT INTO public.who_global_data_import VALUES (78518, '2020-04-29', 'SK', 'Slovakia', 'EURO', '3', '1384', '2', '20');
INSERT INTO public.who_global_data_import VALUES (78519, '2020-04-30', 'SK', 'Slovakia', 'EURO', '7', '1391', '2', '22');
INSERT INTO public.who_global_data_import VALUES (78520, '2020-05-01', 'SK', 'Slovakia', 'EURO', '5', '1396', '1', '23');
INSERT INTO public.who_global_data_import VALUES (78521, '2020-05-02', 'SK', 'Slovakia', 'EURO', '7', '1403', '0', '23');
INSERT INTO public.who_global_data_import VALUES (78522, '2020-05-03', 'SK', 'Slovakia', 'EURO', '4', '1407', '1', '24');
INSERT INTO public.who_global_data_import VALUES (78523, '2020-05-04', 'SK', 'Slovakia', 'EURO', '1', '1408', '0', '24');
INSERT INTO public.who_global_data_import VALUES (78524, '2020-05-05', 'SK', 'Slovakia', 'EURO', '5', '1413', '1', '25');
INSERT INTO public.who_global_data_import VALUES (78525, '2020-05-06', 'SK', 'Slovakia', 'EURO', '8', '1421', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78526, '2020-05-07', 'SK', 'Slovakia', 'EURO', '8', '1429', '0', '25');
INSERT INTO public.who_global_data_import VALUES (78527, '2020-05-08', 'SK', 'Slovakia', 'EURO', '16', '1445', '1', '26');
INSERT INTO public.who_global_data_import VALUES (78528, '2020-05-09', 'SK', 'Slovakia', 'EURO', '10', '1455', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78529, '2020-05-10', 'SK', 'Slovakia', 'EURO', '0', '1455', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78530, '2020-05-11', 'SK', 'Slovakia', 'EURO', '2', '1457', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78531, '2020-05-12', 'SK', 'Slovakia', 'EURO', '0', '1457', '0', '26');
INSERT INTO public.who_global_data_import VALUES (78532, '2020-05-13', 'SK', 'Slovakia', 'EURO', '8', '1465', '1', '27');
INSERT INTO public.who_global_data_import VALUES (78533, '2020-05-14', 'SK', 'Slovakia', 'EURO', '4', '1469', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78534, '2020-05-15', 'SK', 'Slovakia', 'EURO', '8', '1477', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78535, '2020-05-16', 'SK', 'Slovakia', 'EURO', '3', '1480', '0', '27');
INSERT INTO public.who_global_data_import VALUES (78536, '2020-05-17', 'SK', 'Slovakia', 'EURO', '13', '1493', '1', '28');
INSERT INTO public.who_global_data_import VALUES (78537, '2020-05-18', 'SK', 'Slovakia', 'EURO', '1', '1494', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78538, '2020-05-19', 'SK', 'Slovakia', 'EURO', '1', '1495', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78539, '2020-05-20', 'SK', 'Slovakia', 'EURO', '0', '1495', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78540, '2020-05-21', 'SK', 'Slovakia', 'EURO', '1', '1496', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78541, '2020-05-22', 'SK', 'Slovakia', 'EURO', '6', '1502', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78542, '2020-05-23', 'SK', 'Slovakia', 'EURO', '1', '1503', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78543, '2020-05-24', 'SK', 'Slovakia', 'EURO', '1', '1504', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78544, '2020-05-25', 'SK', 'Slovakia', 'EURO', '5', '1509', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78545, '2020-05-26', 'SK', 'Slovakia', 'EURO', '2', '1511', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78546, '2020-05-27', 'SK', 'Slovakia', 'EURO', '2', '1513', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78547, '2020-05-28', 'SK', 'Slovakia', 'EURO', '2', '1515', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78548, '2020-05-29', 'SK', 'Slovakia', 'EURO', '5', '1520', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78549, '2020-05-30', 'SK', 'Slovakia', 'EURO', '0', '1520', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78550, '2020-05-31', 'SK', 'Slovakia', 'EURO', '1', '1521', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78551, '2020-06-01', 'SK', 'Slovakia', 'EURO', '1', '1522', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78552, '2020-06-02', 'SK', 'Slovakia', 'EURO', '0', '1522', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78553, '2020-06-03', 'SK', 'Slovakia', 'EURO', '0', '1522', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78554, '2020-06-04', 'SK', 'Slovakia', 'EURO', '3', '1525', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78555, '2020-06-05', 'SK', 'Slovakia', 'EURO', '1', '1526', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78556, '2020-06-06', 'SK', 'Slovakia', 'EURO', '0', '1526', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78557, '2020-06-07', 'SK', 'Slovakia', 'EURO', '2', '1528', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78558, '2020-06-08', 'SK', 'Slovakia', 'EURO', '0', '1528', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78559, '2020-06-09', 'SK', 'Slovakia', 'EURO', '2', '1530', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78560, '2020-06-10', 'SK', 'Slovakia', 'EURO', '1', '1531', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78561, '2020-06-11', 'SK', 'Slovakia', 'EURO', '2', '1533', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78562, '2020-06-12', 'SK', 'Slovakia', 'EURO', '8', '1541', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78563, '2020-06-13', 'SK', 'Slovakia', 'EURO', '1', '1542', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78564, '2020-06-14', 'SK', 'Slovakia', 'EURO', '3', '1545', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78565, '2020-06-15', 'SK', 'Slovakia', 'EURO', '3', '1548', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78566, '2020-06-16', 'SK', 'Slovakia', 'EURO', '4', '1552', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78567, '2020-06-17', 'SK', 'Slovakia', 'EURO', '0', '1552', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78568, '2020-06-18', 'SK', 'Slovakia', 'EURO', '9', '1561', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78569, '2020-06-19', 'SK', 'Slovakia', 'EURO', '1', '1562', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78570, '2020-06-20', 'SK', 'Slovakia', 'EURO', '14', '1576', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78571, '2020-06-21', 'SK', 'Slovakia', 'EURO', '10', '1586', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78572, '2020-06-22', 'SK', 'Slovakia', 'EURO', '1', '1587', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78573, '2020-06-23', 'SK', 'Slovakia', 'EURO', '1', '1588', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78574, '2020-06-24', 'SK', 'Slovakia', 'EURO', '1', '1589', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78575, '2020-06-25', 'SK', 'Slovakia', 'EURO', '18', '1607', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78576, '2020-06-26', 'SK', 'Slovakia', 'EURO', '23', '1630', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78577, '2020-06-27', 'SK', 'Slovakia', 'EURO', '13', '1643', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78578, '2020-06-28', 'SK', 'Slovakia', 'EURO', '14', '1657', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78579, '2020-06-29', 'SK', 'Slovakia', 'EURO', '7', '1664', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78580, '2020-06-30', 'SK', 'Slovakia', 'EURO', '1', '1665', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78581, '2020-07-01', 'SK', 'Slovakia', 'EURO', '2', '1667', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78582, '2020-07-02', 'SK', 'Slovakia', 'EURO', '20', '1687', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78583, '2020-07-03', 'SK', 'Slovakia', 'EURO', '13', '1700', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78584, '2020-07-04', 'SK', 'Slovakia', 'EURO', '20', '1720', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78585, '2020-07-05', 'SK', 'Slovakia', 'EURO', '29', '1749', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78586, '2020-07-06', 'SK', 'Slovakia', 'EURO', '15', '1764', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78587, '2020-07-07', 'SK', 'Slovakia', 'EURO', '1', '1765', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78588, '2020-07-08', 'SK', 'Slovakia', 'EURO', '2', '1767', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78589, '2020-07-09', 'SK', 'Slovakia', 'EURO', '31', '1798', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78590, '2020-07-10', 'SK', 'Slovakia', 'EURO', '53', '1851', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78591, '2020-07-11', 'SK', 'Slovakia', 'EURO', '19', '1870', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78592, '2020-07-12', 'SK', 'Slovakia', 'EURO', '23', '1893', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78593, '2020-07-13', 'SK', 'Slovakia', 'EURO', '8', '1901', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78594, '2020-07-14', 'SK', 'Slovakia', 'EURO', '1', '1902', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78595, '2020-07-15', 'SK', 'Slovakia', 'EURO', '6', '1908', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78596, '2020-07-16', 'SK', 'Slovakia', 'EURO', '19', '1927', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78597, '2020-07-17', 'SK', 'Slovakia', 'EURO', '24', '1951', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78598, '2020-07-18', 'SK', 'Slovakia', 'EURO', '14', '1965', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78599, '2020-07-19', 'SK', 'Slovakia', 'EURO', '11', '1976', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78600, '2020-07-20', 'SK', 'Slovakia', 'EURO', '3', '1979', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78601, '2020-07-21', 'SK', 'Slovakia', 'EURO', '1', '1980', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78602, '2020-07-22', 'SK', 'Slovakia', 'EURO', '41', '2021', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78603, '2020-07-23', 'SK', 'Slovakia', 'EURO', '37', '2058', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78604, '2020-07-24', 'SK', 'Slovakia', 'EURO', '31', '2089', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78605, '2020-07-25', 'SK', 'Slovakia', 'EURO', '29', '2118', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78606, '2020-07-26', 'SK', 'Slovakia', 'EURO', '23', '2141', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78607, '2020-07-27', 'SK', 'Slovakia', 'EURO', '38', '2179', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78608, '2020-07-28', 'SK', 'Slovakia', 'EURO', '2', '2181', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78609, '2020-07-29', 'SK', 'Slovakia', 'EURO', '23', '2204', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78610, '2020-07-30', 'SK', 'Slovakia', 'EURO', '41', '2245', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78611, '2020-07-31', 'SK', 'Slovakia', 'EURO', '20', '2265', '0', '28');
INSERT INTO public.who_global_data_import VALUES (78612, '2020-08-01', 'SK', 'Slovakia', 'EURO', '27', '2292', '1', '29');
INSERT INTO public.who_global_data_import VALUES (78613, '2020-08-02', 'SK', 'Slovakia', 'EURO', '45', '2337', '0', '29');
INSERT INTO public.who_global_data_import VALUES (78614, '2020-08-03', 'SK', 'Slovakia', 'EURO', '7', '2344', '0', '29');
INSERT INTO public.who_global_data_import VALUES (78615, '2020-08-04', 'SK', 'Slovakia', 'EURO', '10', '2354', '0', '29');
INSERT INTO public.who_global_data_import VALUES (78616, '2020-08-05', 'SK', 'Slovakia', 'EURO', '14', '2368', '0', '29');
INSERT INTO public.who_global_data_import VALUES (78617, '2020-08-06', 'SK', 'Slovakia', 'EURO', '49', '2417', '0', '29');
INSERT INTO public.who_global_data_import VALUES (78618, '2020-08-07', 'SK', 'Slovakia', 'EURO', '63', '2480', '0', '29');
INSERT INTO public.who_global_data_import VALUES (78619, '2020-08-08', 'SK', 'Slovakia', 'EURO', '43', '2523', '2', '31');
INSERT INTO public.who_global_data_import VALUES (78620, '2020-08-09', 'SK', 'Slovakia', 'EURO', '43', '2566', '0', '31');
INSERT INTO public.who_global_data_import VALUES (78621, '2020-08-10', 'SK', 'Slovakia', 'EURO', '30', '2596', '0', '31');
INSERT INTO public.who_global_data_import VALUES (78622, '2020-08-11', 'SK', 'Slovakia', 'EURO', '3', '2599', '0', '31');
INSERT INTO public.who_global_data_import VALUES (78623, '2020-08-12', 'SK', 'Slovakia', 'EURO', '16', '2615', '0', '31');
INSERT INTO public.who_global_data_import VALUES (78624, '2020-08-13', 'SK', 'Slovakia', 'EURO', '75', '2690', '0', '31');
INSERT INTO public.who_global_data_import VALUES (78625, '2020-08-14', 'SK', 'Slovakia', 'EURO', '49', '2739', '0', '31');
INSERT INTO public.who_global_data_import VALUES (78626, '2020-08-15', 'SK', 'Slovakia', 'EURO', '62', '2801', '0', '31');
INSERT INTO public.who_global_data_import VALUES (78627, '2020-08-16', 'SK', 'Slovakia', 'EURO', '54', '2855', '0', '31');
INSERT INTO public.who_global_data_import VALUES (78628, '2020-08-17', 'SK', 'Slovakia', 'EURO', '47', '2902', '0', '31');
INSERT INTO public.who_global_data_import VALUES (78629, '2020-08-18', 'SK', 'Slovakia', 'EURO', '5', '2907', '0', '31');
INSERT INTO public.who_global_data_import VALUES (78630, '2020-08-19', 'SK', 'Slovakia', 'EURO', '15', '2922', '0', '31');
INSERT INTO public.who_global_data_import VALUES (78631, '2020-08-20', 'SK', 'Slovakia', 'EURO', '100', '3022', '2', '33');
INSERT INTO public.who_global_data_import VALUES (78632, '2020-08-21', 'SK', 'Slovakia', 'EURO', '80', '3102', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78633, '2020-08-22', 'SK', 'Slovakia', 'EURO', '123', '3225', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78634, '2020-08-23', 'SK', 'Slovakia', 'EURO', '91', '3316', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78635, '2020-08-24', 'SK', 'Slovakia', 'EURO', '40', '3356', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78636, '2020-08-25', 'SK', 'Slovakia', 'EURO', '68', '3424', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78637, '2020-08-26', 'SK', 'Slovakia', 'EURO', '28', '3452', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78638, '2020-08-27', 'SK', 'Slovakia', 'EURO', '84', '3536', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78639, '2020-08-28', 'SK', 'Slovakia', 'EURO', '90', '3626', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78640, '2020-08-29', 'SK', 'Slovakia', 'EURO', '102', '3728', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78641, '2020-08-30', 'SK', 'Slovakia', 'EURO', '114', '3842', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78642, '2020-08-31', 'SK', 'Slovakia', 'EURO', '34', '3876', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78643, '2020-09-01', 'SK', 'Slovakia', 'EURO', '41', '3917', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78644, '2020-09-02', 'SK', 'Slovakia', 'EURO', '72', '3989', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78645, '2020-09-03', 'SK', 'Slovakia', 'EURO', '53', '4042', '0', '33');
INSERT INTO public.who_global_data_import VALUES (78646, '2020-09-04', 'SK', 'Slovakia', 'EURO', '121', '4163', '4', '37');
INSERT INTO public.who_global_data_import VALUES (78647, '2020-09-05', 'SK', 'Slovakia', 'EURO', '137', '4300', '0', '37');
INSERT INTO public.who_global_data_import VALUES (78648, '2020-09-06', 'SK', 'Slovakia', 'EURO', '226', '4526', '0', '37');
INSERT INTO public.who_global_data_import VALUES (78649, '2020-09-07', 'SK', 'Slovakia', 'EURO', '88', '4614', '0', '37');
INSERT INTO public.who_global_data_import VALUES (78650, '2020-09-08', 'SK', 'Slovakia', 'EURO', '22', '4636', '0', '37');
INSERT INTO public.who_global_data_import VALUES (78651, '2020-09-09', 'SK', 'Slovakia', 'EURO', '91', '4727', '0', '37');
INSERT INTO public.who_global_data_import VALUES (78652, '2020-09-10', 'SK', 'Slovakia', 'EURO', '161', '4888', '0', '37');
INSERT INTO public.who_global_data_import VALUES (78653, '2020-09-11', 'SK', 'Slovakia', 'EURO', '133', '5021', '0', '37');
INSERT INTO public.who_global_data_import VALUES (78654, '2020-09-12', 'SK', 'Slovakia', 'EURO', '231', '5252', '0', '37');
INSERT INTO public.who_global_data_import VALUES (78655, '2020-09-13', 'SK', 'Slovakia', 'EURO', '201', '5453', '1', '38');
INSERT INTO public.who_global_data_import VALUES (78656, '2020-09-14', 'SK', 'Slovakia', 'EURO', '79', '5532', '0', '38');
INSERT INTO public.who_global_data_import VALUES (78657, '2020-09-15', 'SK', 'Slovakia', 'EURO', '48', '5580', '0', '38');
INSERT INTO public.who_global_data_import VALUES (78658, '2020-09-16', 'SK', 'Slovakia', 'EURO', '188', '5768', '0', '38');
INSERT INTO public.who_global_data_import VALUES (78659, '2020-09-17', 'SK', 'Slovakia', 'EURO', '92', '5860', '0', '38');
INSERT INTO public.who_global_data_import VALUES (78660, '2020-09-18', 'SK', 'Slovakia', 'EURO', '161', '6021', '1', '39');
INSERT INTO public.who_global_data_import VALUES (78661, '2020-09-19', 'SK', 'Slovakia', 'EURO', '235', '6256', '0', '39');
INSERT INTO public.who_global_data_import VALUES (78662, '2020-09-20', 'SK', 'Slovakia', 'EURO', '290', '6546', '0', '39');
INSERT INTO public.who_global_data_import VALUES (78663, '2020-09-21', 'SK', 'Slovakia', 'EURO', '131', '6677', '0', '39');
INSERT INTO public.who_global_data_import VALUES (78664, '2020-09-22', 'SK', 'Slovakia', 'EURO', '79', '6756', '0', '39');
INSERT INTO public.who_global_data_import VALUES (78665, '2020-09-23', 'SK', 'Slovakia', 'EURO', '175', '6931', '1', '40');
INSERT INTO public.who_global_data_import VALUES (78666, '2020-09-24', 'SK', 'Slovakia', 'EURO', '338', '7269', '1', '41');
INSERT INTO public.who_global_data_import VALUES (78667, '2020-09-25', 'SK', 'Slovakia', 'EURO', '360', '7629', '0', '41');
INSERT INTO public.who_global_data_import VALUES (78668, '2020-09-26', 'SK', 'Slovakia', 'EURO', '419', '8048', '0', '41');
INSERT INTO public.who_global_data_import VALUES (78669, '2020-09-27', 'SK', 'Slovakia', 'EURO', '552', '8600', '3', '44');
INSERT INTO public.who_global_data_import VALUES (78670, '2020-09-28', 'SK', 'Slovakia', 'EURO', '478', '9078', '0', '44');
INSERT INTO public.who_global_data_import VALUES (78671, '2020-09-29', 'SK', 'Slovakia', 'EURO', '265', '9343', '0', '44');
INSERT INTO public.who_global_data_import VALUES (78672, '2020-09-30', 'SK', 'Slovakia', 'EURO', '231', '9574', '1', '45');
INSERT INTO public.who_global_data_import VALUES (78673, '2020-10-01', 'SK', 'Slovakia', 'EURO', '567', '10141', '3', '48');
INSERT INTO public.who_global_data_import VALUES (78674, '2020-10-02', 'SK', 'Slovakia', 'EURO', '797', '10938', '0', '48');
INSERT INTO public.who_global_data_import VALUES (78675, '2020-10-03', 'SK', 'Slovakia', 'EURO', '679', '11617', '6', '54');
INSERT INTO public.who_global_data_import VALUES (78676, '2020-10-04', 'SK', 'Slovakia', 'EURO', '704', '12321', '0', '54');
INSERT INTO public.who_global_data_import VALUES (78677, '2020-10-05', 'SK', 'Slovakia', 'EURO', '818', '13139', '1', '55');
INSERT INTO public.who_global_data_import VALUES (78678, '2020-10-06', 'SK', 'Slovakia', 'EURO', '353', '13492', '0', '55');
INSERT INTO public.who_global_data_import VALUES (78679, '2020-10-07', 'SK', 'Slovakia', 'EURO', '320', '13812', '0', '55');
INSERT INTO public.who_global_data_import VALUES (78680, '2020-10-08', 'SK', 'Slovakia', 'EURO', '877', '14689', '0', '55');
INSERT INTO public.who_global_data_import VALUES (78681, '2020-10-09', 'SK', 'Slovakia', 'EURO', '1037', '15726', '2', '57');
INSERT INTO public.who_global_data_import VALUES (78682, '2020-10-10', 'SK', 'Slovakia', 'EURO', '1184', '16910', '0', '57');
INSERT INTO public.who_global_data_import VALUES (78683, '2020-10-11', 'SK', 'Slovakia', 'EURO', '1887', '18797', '4', '61');
INSERT INTO public.who_global_data_import VALUES (78684, '2020-10-12', 'SK', 'Slovakia', 'EURO', '1054', '19851', '0', '61');
INSERT INTO public.who_global_data_import VALUES (78685, '2020-10-13', 'SK', 'Slovakia', 'EURO', '504', '20355', '0', '61');
INSERT INTO public.who_global_data_import VALUES (78686, '2020-10-14', 'SK', 'Slovakia', 'EURO', '531', '20886', '0', '61');
INSERT INTO public.who_global_data_import VALUES (78687, '2020-10-15', 'SK', 'Slovakia', 'EURO', '1410', '22296', '5', '66');
INSERT INTO public.who_global_data_import VALUES (78688, '2020-10-16', 'SK', 'Slovakia', 'EURO', '1929', '24225', '5', '71');
INSERT INTO public.who_global_data_import VALUES (78689, '2020-10-17', 'SK', 'Slovakia', 'EURO', '2075', '26300', '0', '71');
INSERT INTO public.who_global_data_import VALUES (78690, '2020-10-18', 'SK', 'Slovakia', 'EURO', '1968', '28268', '11', '82');
INSERT INTO public.who_global_data_import VALUES (78691, '2020-10-19', 'SK', 'Slovakia', 'EURO', '1567', '29835', '6', '88');
INSERT INTO public.who_global_data_import VALUES (78692, '2020-10-20', 'SK', 'Slovakia', 'EURO', '860', '30695', '4', '92');
INSERT INTO public.who_global_data_import VALUES (78693, '2020-10-21', 'SK', 'Slovakia', 'EURO', '705', '31400', '6', '98');
INSERT INTO public.who_global_data_import VALUES (78694, '2020-10-22', 'SK', 'Slovakia', 'EURO', '2202', '33602', '0', '98');
INSERT INTO public.who_global_data_import VALUES (78695, '2020-10-23', 'SK', 'Slovakia', 'EURO', '1728', '35330', '17', '115');
INSERT INTO public.who_global_data_import VALUES (78696, '2020-10-24', 'SK', 'Slovakia', 'EURO', '2581', '37911', '19', '134');
INSERT INTO public.who_global_data_import VALUES (78697, '2020-10-25', 'SK', 'Slovakia', 'EURO', '2890', '40801', '25', '159');
INSERT INTO public.who_global_data_import VALUES (78698, '2020-10-26', 'SK', 'Slovakia', 'EURO', '3042', '43843', '0', '159');
INSERT INTO public.who_global_data_import VALUES (78699, '2020-10-27', 'SK', 'Slovakia', 'EURO', '1312', '45155', '6', '165');
INSERT INTO public.who_global_data_import VALUES (78700, '2020-10-28', 'SK', 'Slovakia', 'EURO', '901', '46056', '11', '176');
INSERT INTO public.who_global_data_import VALUES (78701, '2020-10-29', 'SK', 'Slovakia', 'EURO', '2887', '48943', '8', '184');
INSERT INTO public.who_global_data_import VALUES (78702, '2020-10-30', 'SK', 'Slovakia', 'EURO', '2785', '51728', '16', '200');
INSERT INTO public.who_global_data_import VALUES (78703, '2020-10-31', 'SK', 'Slovakia', 'EURO', '3363', '55091', '12', '212');
INSERT INTO public.who_global_data_import VALUES (78704, '2020-11-01', 'SK', 'Slovakia', 'EURO', '2573', '57664', '7', '219');
INSERT INTO public.who_global_data_import VALUES (78705, '2020-11-02', 'SK', 'Slovakia', 'EURO', '2282', '59946', '0', '219');
INSERT INTO public.who_global_data_import VALUES (78706, '2020-11-03', 'SK', 'Slovakia', 'EURO', '1883', '61829', '0', '219');
INSERT INTO public.who_global_data_import VALUES (78707, '2020-11-04', 'SK', 'Slovakia', 'EURO', '1727', '63556', '16', '235');
INSERT INTO public.who_global_data_import VALUES (78708, '2020-11-05', 'SK', 'Slovakia', 'EURO', '3216', '66772', '26', '261');
INSERT INTO public.who_global_data_import VALUES (78709, '2020-11-06', 'SK', 'Slovakia', 'EURO', '1962', '68734', '25', '286');
INSERT INTO public.who_global_data_import VALUES (78710, '2020-11-07', 'SK', 'Slovakia', 'EURO', '2354', '71088', '31', '317');
INSERT INTO public.who_global_data_import VALUES (78711, '2020-11-08', 'SK', 'Slovakia', 'EURO', '2579', '73667', '34', '351');
INSERT INTO public.who_global_data_import VALUES (78712, '2020-11-09', 'SK', 'Slovakia', 'EURO', '1828', '75495', '0', '351');
INSERT INTO public.who_global_data_import VALUES (78713, '2020-11-10', 'SK', 'Slovakia', 'EURO', '577', '76072', '15', '366');
INSERT INTO public.who_global_data_import VALUES (78714, '2020-11-11', 'SK', 'Slovakia', 'EURO', '1051', '77123', '24', '390');
INSERT INTO public.who_global_data_import VALUES (78715, '2020-11-12', 'SK', 'Slovakia', 'EURO', '2058', '79181', '24', '414');
INSERT INTO public.who_global_data_import VALUES (78716, '2020-11-13', 'SK', 'Slovakia', 'EURO', '2591', '81772', '50', '464');
INSERT INTO public.who_global_data_import VALUES (78717, '2020-11-14', 'SK', 'Slovakia', 'EURO', '2024', '83796', '27', '491');
INSERT INTO public.who_global_data_import VALUES (78718, '2020-11-15', 'SK', 'Slovakia', 'EURO', '1771', '85567', '19', '510');
INSERT INTO public.who_global_data_import VALUES (78719, '2020-11-16', 'SK', 'Slovakia', 'EURO', '1200', '86767', '0', '510');
INSERT INTO public.who_global_data_import VALUES (78720, '2020-11-17', 'SK', 'Slovakia', 'EURO', '509', '87276', '16', '526');
INSERT INTO public.who_global_data_import VALUES (78721, '2020-11-18', 'SK', 'Slovakia', 'EURO', '1326', '88602', '31', '557');
INSERT INTO public.who_global_data_import VALUES (78722, '2020-11-19', 'SK', 'Slovakia', 'EURO', '1311', '89913', '22', '579');
INSERT INTO public.who_global_data_import VALUES (78723, '2020-11-20', 'SK', 'Slovakia', 'EURO', '1665', '91578', '0', '579');
INSERT INTO public.who_global_data_import VALUES (78724, '2020-11-21', 'SK', 'Slovakia', 'EURO', '1818', '93396', '35', '614');
INSERT INTO public.who_global_data_import VALUES (78725, '2020-11-22', 'SK', 'Slovakia', 'EURO', '1861', '95257', '30', '644');
INSERT INTO public.who_global_data_import VALUES (78726, '2020-11-23', 'SK', 'Slovakia', 'EURO', '984', '96241', '27', '671');
INSERT INTO public.who_global_data_import VALUES (78727, '2020-11-24', 'SK', 'Slovakia', 'EURO', '231', '96472', '22', '693');
INSERT INTO public.who_global_data_import VALUES (78728, '2020-11-25', 'SK', 'Slovakia', 'EURO', '1021', '97493', '16', '709');
INSERT INTO public.who_global_data_import VALUES (78729, '2020-11-26', 'SK', 'Slovakia', 'EURO', '1811', '99304', '23', '732');
INSERT INTO public.who_global_data_import VALUES (78730, '2020-11-27', 'SK', 'Slovakia', 'EURO', '1953', '101257', '17', '749');
INSERT INTO public.who_global_data_import VALUES (78731, '2020-11-28', 'SK', 'Slovakia', 'EURO', '1849', '103106', '22', '771');
INSERT INTO public.who_global_data_import VALUES (78732, '2020-11-29', 'SK', 'Slovakia', 'EURO', '1526', '104632', '27', '798');
INSERT INTO public.who_global_data_import VALUES (78733, '2020-11-30', 'SK', 'Slovakia', 'EURO', '1101', '105733', '18', '816');
INSERT INTO public.who_global_data_import VALUES (78734, '2020-12-01', 'SK', 'Slovakia', 'EURO', '2760', '108493', '43', '859');
INSERT INTO public.who_global_data_import VALUES (78735, '2020-12-02', 'SK', 'Slovakia', 'EURO', '1254', '109747', '29', '888');
INSERT INTO public.who_global_data_import VALUES (78736, '2020-12-03', 'SK', 'Slovakia', 'EURO', '2043', '111790', '30', '918');
INSERT INTO public.who_global_data_import VALUES (78737, '2020-12-04', 'SK', 'Slovakia', 'EURO', '1982', '113772', '32', '950');
INSERT INTO public.who_global_data_import VALUES (78738, '2020-12-05', 'SK', 'Slovakia', 'EURO', '2184', '115956', '27', '977');
INSERT INTO public.who_global_data_import VALUES (78739, '2020-12-06', 'SK', 'Slovakia', 'EURO', '2070', '118026', '24', '1001');
INSERT INTO public.who_global_data_import VALUES (78740, '2020-12-07', 'SK', 'Slovakia', 'EURO', '1269', '119295', '15', '1016');
INSERT INTO public.who_global_data_import VALUES (78741, '2020-12-08', 'SK', 'Slovakia', 'EURO', '552', '119847', '22', '1038');
INSERT INTO public.who_global_data_import VALUES (78742, '2020-12-09', 'SK', 'Slovakia', 'EURO', '1949', '121796', '28', '1066');
INSERT INTO public.who_global_data_import VALUES (78743, '2020-12-10', 'SK', 'Slovakia', 'EURO', '3125', '124921', '38', '1104');
INSERT INTO public.who_global_data_import VALUES (78744, '2020-12-11', 'SK', 'Slovakia', 'EURO', '2166', '127087', '18', '1122');
INSERT INTO public.who_global_data_import VALUES (78745, '2020-12-12', 'SK', 'Slovakia', 'EURO', '3707', '130794', '26', '1148');
INSERT INTO public.who_global_data_import VALUES (78746, '2020-12-13', 'SK', 'Slovakia', 'EURO', '2190', '132984', '27', '1175');
INSERT INTO public.who_global_data_import VALUES (78747, '2020-12-14', 'SK', 'Slovakia', 'EURO', '505', '133489', '30', '1205');
INSERT INTO public.who_global_data_import VALUES (78748, '2020-12-15', 'SK', 'Slovakia', 'EURO', '2034', '135523', '46', '1251');
INSERT INTO public.who_global_data_import VALUES (78749, '2020-12-16', 'SK', 'Slovakia', 'EURO', '3565', '139088', '58', '1309');
INSERT INTO public.who_global_data_import VALUES (78750, '2020-12-17', 'SK', 'Slovakia', 'EURO', '3045', '142133', '69', '1378');
INSERT INTO public.who_global_data_import VALUES (78751, '2020-12-18', 'SK', 'Slovakia', 'EURO', '3991', '146124', '62', '1440');
INSERT INTO public.who_global_data_import VALUES (78752, '2020-12-19', 'SK', 'Slovakia', 'EURO', '3151', '149275', '70', '1510');
INSERT INTO public.who_global_data_import VALUES (78753, '2020-12-20', 'SK', 'Slovakia', 'EURO', '2061', '151336', '45', '1555');
INSERT INTO public.who_global_data_import VALUES (78754, '2020-12-21', 'SK', 'Slovakia', 'EURO', '1219', '152555', '63', '1618');
INSERT INTO public.who_global_data_import VALUES (78755, '2020-12-22', 'SK', 'Slovakia', 'EURO', '2663', '155218', '0', '1618');
INSERT INTO public.who_global_data_import VALUES (78756, '2020-12-23', 'SK', 'Slovakia', 'EURO', '3687', '158905', '68', '1686');
INSERT INTO public.who_global_data_import VALUES (78757, '2020-12-24', 'SK', 'Slovakia', 'EURO', '2657', '161562', '46', '1732');
INSERT INTO public.who_global_data_import VALUES (78758, '2020-12-25', 'SK', 'Slovakia', 'EURO', '4046', '165608', '0', '1732');
INSERT INTO public.who_global_data_import VALUES (78759, '2020-12-26', 'SK', 'Slovakia', 'EURO', '1041', '166649', '0', '1732');
INSERT INTO public.who_global_data_import VALUES (78760, '2020-12-27', 'SK', 'Slovakia', 'EURO', '874', '167523', '41', '1773');
INSERT INTO public.who_global_data_import VALUES (78761, '2020-12-28', 'SK', 'Slovakia', 'EURO', '569', '168092', '106', '1879');
INSERT INTO public.who_global_data_import VALUES (78762, '2020-12-29', 'SK', 'Slovakia', 'EURO', '2095', '170187', '104', '1983');
INSERT INTO public.who_global_data_import VALUES (78763, '2020-12-30', 'SK', 'Slovakia', 'EURO', '3041', '173228', '82', '2065');
INSERT INTO public.who_global_data_import VALUES (78764, '2020-12-31', 'SK', 'Slovakia', 'EURO', '6315', '179543', '73', '2138');
INSERT INTO public.who_global_data_import VALUES (78765, '2021-01-01', 'SK', 'Slovakia', 'EURO', '4965', '184508', '112', '2250');
INSERT INTO public.who_global_data_import VALUES (78766, '2021-01-02', 'SK', 'Slovakia', 'EURO', '1736', '186244', '0', '2250');
INSERT INTO public.who_global_data_import VALUES (78767, '2021-01-03', 'SK', 'Slovakia', 'EURO', '1219', '187463', '67', '2317');
INSERT INTO public.who_global_data_import VALUES (78768, '2021-01-04', 'SK', 'Slovakia', 'EURO', '636', '188099', '204', '2521');
INSERT INTO public.who_global_data_import VALUES (78769, '2021-01-05', 'SK', 'Slovakia', 'EURO', '2989', '191088', '82', '2603');
INSERT INTO public.who_global_data_import VALUES (78770, '2021-01-06', 'SK', 'Slovakia', 'EURO', '4959', '196047', '54', '2657');
INSERT INTO public.who_global_data_import VALUES (78771, '2021-01-07', 'SK', 'Slovakia', 'EURO', '2137', '198184', '60', '2717');
INSERT INTO public.who_global_data_import VALUES (78772, '2021-01-08', 'SK', 'Slovakia', 'EURO', '2980', '201164', '71', '2788');
INSERT INTO public.who_global_data_import VALUES (78773, '2021-01-09', 'SK', 'Slovakia', 'EURO', '4072', '205236', '48', '2836');
INSERT INTO public.who_global_data_import VALUES (78774, '2021-01-10', 'SK', 'Slovakia', 'EURO', '2973', '208209', '82', '2918');
INSERT INTO public.who_global_data_import VALUES (78775, '2021-01-11', 'SK', 'Slovakia', 'EURO', '860', '209069', '89', '3007');
INSERT INTO public.who_global_data_import VALUES (78776, '2021-01-12', 'SK', 'Slovakia', 'EURO', '2410', '211479', '95', '3102');
INSERT INTO public.who_global_data_import VALUES (78777, '2021-01-13', 'SK', 'Slovakia', 'EURO', '3576', '215055', '61', '3163');
INSERT INTO public.who_global_data_import VALUES (78778, '2021-01-14', 'SK', 'Slovakia', 'EURO', '2923', '217978', '97', '3260');
INSERT INTO public.who_global_data_import VALUES (78779, '2021-01-15', 'SK', 'Slovakia', 'EURO', '2729', '220707', '102', '3362');
INSERT INTO public.who_global_data_import VALUES (78780, '2021-01-16', 'SK', 'Slovakia', 'EURO', '2045', '222752', '55', '3417');
INSERT INTO public.who_global_data_import VALUES (78781, '2021-01-17', 'SK', 'Slovakia', 'EURO', '573', '223325', '57', '3474');
INSERT INTO public.who_global_data_import VALUES (78782, '2021-01-18', 'SK', 'Slovakia', 'EURO', '1060', '224385', '52', '3526');
INSERT INTO public.who_global_data_import VALUES (78783, '2021-01-19', 'SK', 'Slovakia', 'EURO', '1909', '226294', '111', '3637');
INSERT INTO public.who_global_data_import VALUES (78784, '2021-01-20', 'SK', 'Slovakia', 'EURO', '2484', '228778', '100', '3737');
INSERT INTO public.who_global_data_import VALUES (78785, '2021-01-21', 'SK', 'Slovakia', 'EURO', '2464', '231242', '64', '3801');
INSERT INTO public.who_global_data_import VALUES (78786, '2021-01-22', 'SK', 'Slovakia', 'EURO', '1785', '233027', '93', '3894');
INSERT INTO public.who_global_data_import VALUES (78787, '2021-01-23', 'SK', 'Slovakia', 'EURO', '1544', '234571', '71', '3965');
INSERT INTO public.who_global_data_import VALUES (78788, '2021-01-24', 'SK', 'Slovakia', 'EURO', '1905', '236476', '103', '4068');
INSERT INTO public.who_global_data_import VALUES (78789, '2021-01-25', 'SK', 'Slovakia', 'EURO', '551', '237027', '0', '4068');
INSERT INTO public.who_global_data_import VALUES (78790, '2021-01-26', 'SK', 'Slovakia', 'EURO', '1590', '238617', '192', '4260');
INSERT INTO public.who_global_data_import VALUES (78791, '2021-01-27', 'SK', 'Slovakia', 'EURO', '2775', '241392', '101', '4361');
INSERT INTO public.who_global_data_import VALUES (78792, '2021-01-28', 'SK', 'Slovakia', 'EURO', '2035', '243427', '50', '4411');
INSERT INTO public.who_global_data_import VALUES (78793, '2021-01-29', 'SK', 'Slovakia', 'EURO', '2581', '246008', '84', '4495');
INSERT INTO public.who_global_data_import VALUES (78794, '2021-01-30', 'SK', 'Slovakia', 'EURO', '991', '246999', '70', '4565');
INSERT INTO public.who_global_data_import VALUES (78795, '2021-01-31', 'SK', 'Slovakia', 'EURO', '2914', '249913', '77', '4642');
INSERT INTO public.who_global_data_import VALUES (78796, '2021-02-01', 'SK', 'Slovakia', 'EURO', '444', '250357', '69', '4711');
INSERT INTO public.who_global_data_import VALUES (78797, '2021-02-02', 'SK', 'Slovakia', 'EURO', '1737', '252094', '73', '4784');
INSERT INTO public.who_global_data_import VALUES (78798, '2021-02-03', 'SK', 'Slovakia', 'EURO', '2732', '254826', '105', '4889');
INSERT INTO public.who_global_data_import VALUES (78799, '2021-02-04', 'SK', 'Slovakia', 'EURO', '2077', '256903', '87', '4976');
INSERT INTO public.who_global_data_import VALUES (78800, '2021-02-05', 'SK', 'Slovakia', 'EURO', '2630', '259533', '74', '5050');
INSERT INTO public.who_global_data_import VALUES (78801, '2020-01-03', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78802, '2020-01-04', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78803, '2020-01-05', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78804, '2020-01-06', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78805, '2020-01-07', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78806, '2020-01-08', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78807, '2020-01-09', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78808, '2020-01-10', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78809, '2020-01-11', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78810, '2020-01-12', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78811, '2020-01-13', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78812, '2020-01-14', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78813, '2020-01-15', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78814, '2020-01-16', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78815, '2020-01-17', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78816, '2020-01-18', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78817, '2020-01-19', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78818, '2020-01-20', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78819, '2020-01-21', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78820, '2020-01-22', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78821, '2020-01-23', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78822, '2020-01-24', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78823, '2020-01-25', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78824, '2020-01-26', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78825, '2020-01-27', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78826, '2020-01-28', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78827, '2020-01-29', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78828, '2020-01-30', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78829, '2020-01-31', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78830, '2020-02-01', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78831, '2020-02-02', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78832, '2020-02-03', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78833, '2020-02-04', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78834, '2020-02-05', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78835, '2020-02-06', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78836, '2020-02-07', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78837, '2020-02-08', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78838, '2020-02-09', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78839, '2020-02-10', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78840, '2020-02-11', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78841, '2020-02-12', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78842, '2020-02-13', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78843, '2020-02-14', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78844, '2020-02-15', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78845, '2020-02-16', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78846, '2020-02-17', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78847, '2020-02-18', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78848, '2020-02-19', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78849, '2020-02-20', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78850, '2020-02-21', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78851, '2020-02-22', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78852, '2020-02-23', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78853, '2020-02-24', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78854, '2020-02-25', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78855, '2020-02-26', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78856, '2020-02-27', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78857, '2020-02-28', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78858, '2020-02-29', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78859, '2020-03-01', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78860, '2020-03-02', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78861, '2020-03-03', 'SI', 'Slovenia', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78862, '2020-03-04', 'SI', 'Slovenia', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78863, '2020-03-05', 'SI', 'Slovenia', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78864, '2020-03-06', 'SI', 'Slovenia', 'EURO', '5', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78865, '2020-03-07', 'SI', 'Slovenia', 'EURO', '4', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78866, '2020-03-08', 'SI', 'Slovenia', 'EURO', '5', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78867, '2020-03-09', 'SI', 'Slovenia', 'EURO', '5', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78868, '2020-03-10', 'SI', 'Slovenia', 'EURO', '11', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78869, '2020-03-11', 'SI', 'Slovenia', 'EURO', '17', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78870, '2020-03-12', 'SI', 'Slovenia', 'EURO', '35', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78871, '2020-03-13', 'SI', 'Slovenia', 'EURO', '50', '133', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78872, '2020-03-14', 'SI', 'Slovenia', 'EURO', '46', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78873, '2020-03-15', 'SI', 'Slovenia', 'EURO', '36', '215', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78874, '2020-03-16', 'SI', 'Slovenia', 'EURO', '35', '250', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78875, '2020-03-17', 'SI', 'Slovenia', 'EURO', '26', '276', '0', '0');
INSERT INTO public.who_global_data_import VALUES (78876, '2020-03-18', 'SI', 'Slovenia', 'EURO', '10', '286', '1', '1');
INSERT INTO public.who_global_data_import VALUES (78877, '2020-03-19', 'SI', 'Slovenia', 'EURO', '32', '318', '0', '1');
INSERT INTO public.who_global_data_import VALUES (78878, '2020-03-20', 'SI', 'Slovenia', 'EURO', '23', '341', '0', '1');
INSERT INTO public.who_global_data_import VALUES (78879, '2020-03-21', 'SI', 'Slovenia', 'EURO', '28', '369', '0', '1');
INSERT INTO public.who_global_data_import VALUES (78880, '2020-03-22', 'SI', 'Slovenia', 'EURO', '37', '406', '0', '1');
INSERT INTO public.who_global_data_import VALUES (78881, '2020-03-23', 'SI', 'Slovenia', 'EURO', '36', '442', '1', '2');
INSERT INTO public.who_global_data_import VALUES (78882, '2020-03-24', 'SI', 'Slovenia', 'EURO', '36', '478', '1', '3');
INSERT INTO public.who_global_data_import VALUES (78883, '2020-03-25', 'SI', 'Slovenia', 'EURO', '48', '526', '3', '6');
INSERT INTO public.who_global_data_import VALUES (78884, '2020-03-26', 'SI', 'Slovenia', 'EURO', '47', '573', '0', '6');
INSERT INTO public.who_global_data_import VALUES (78885, '2020-03-27', 'SI', 'Slovenia', 'EURO', '61', '634', '2', '8');
INSERT INTO public.who_global_data_import VALUES (78886, '2020-03-28', 'SI', 'Slovenia', 'EURO', '52', '686', '2', '10');
INSERT INTO public.who_global_data_import VALUES (78887, '2020-03-29', 'SI', 'Slovenia', 'EURO', '47', '733', '2', '12');
INSERT INTO public.who_global_data_import VALUES (78888, '2020-03-30', 'SI', 'Slovenia', 'EURO', '24', '757', '1', '13');
INSERT INTO public.who_global_data_import VALUES (78889, '2020-03-31', 'SI', 'Slovenia', 'EURO', '48', '805', '5', '18');
INSERT INTO public.who_global_data_import VALUES (78890, '2020-04-01', 'SI', 'Slovenia', 'EURO', '37', '842', '1', '19');
INSERT INTO public.who_global_data_import VALUES (78891, '2020-04-02', 'SI', 'Slovenia', 'EURO', '55', '897', '1', '20');
INSERT INTO public.who_global_data_import VALUES (78892, '2020-04-03', 'SI', 'Slovenia', 'EURO', '40', '937', '3', '23');
INSERT INTO public.who_global_data_import VALUES (78893, '2020-04-04', 'SI', 'Slovenia', 'EURO', '41', '978', '3', '26');
INSERT INTO public.who_global_data_import VALUES (78894, '2020-04-05', 'SI', 'Slovenia', 'EURO', '20', '998', '4', '30');
INSERT INTO public.who_global_data_import VALUES (78895, '2020-04-06', 'SI', 'Slovenia', 'EURO', '23', '1021', '3', '33');
INSERT INTO public.who_global_data_import VALUES (78896, '2020-04-07', 'SI', 'Slovenia', 'EURO', '35', '1056', '7', '40');
INSERT INTO public.who_global_data_import VALUES (78897, '2020-04-08', 'SI', 'Slovenia', 'EURO', '36', '1092', '2', '42');
INSERT INTO public.who_global_data_import VALUES (78898, '2020-04-09', 'SI', 'Slovenia', 'EURO', '33', '1125', '4', '46');
INSERT INTO public.who_global_data_import VALUES (78899, '2020-04-10', 'SI', 'Slovenia', 'EURO', '35', '1160', '2', '48');
INSERT INTO public.who_global_data_import VALUES (78900, '2020-04-11', 'SI', 'Slovenia', 'EURO', '29', '1189', '6', '54');
INSERT INTO public.who_global_data_import VALUES (78901, '2020-04-12', 'SI', 'Slovenia', 'EURO', '17', '1206', '3', '57');
INSERT INTO public.who_global_data_import VALUES (78902, '2020-04-13', 'SI', 'Slovenia', 'EURO', '7', '1213', '4', '61');
INSERT INTO public.who_global_data_import VALUES (78903, '2020-04-14', 'SI', 'Slovenia', 'EURO', '8', '1221', '3', '64');
INSERT INTO public.who_global_data_import VALUES (78904, '2020-04-15', 'SI', 'Slovenia', 'EURO', '27', '1248', '1', '65');
INSERT INTO public.who_global_data_import VALUES (78905, '2020-04-16', 'SI', 'Slovenia', 'EURO', '21', '1269', '0', '65');
INSERT INTO public.who_global_data_import VALUES (78906, '2020-04-17', 'SI', 'Slovenia', 'EURO', '36', '1305', '6', '71');
INSERT INTO public.who_global_data_import VALUES (78907, '2020-04-18', 'SI', 'Slovenia', 'EURO', '13', '1318', '4', '75');
INSERT INTO public.who_global_data_import VALUES (78908, '2020-04-19', 'SI', 'Slovenia', 'EURO', '13', '1331', '3', '78');
INSERT INTO public.who_global_data_import VALUES (78909, '2020-04-20', 'SI', 'Slovenia', 'EURO', '5', '1336', '5', '83');
INSERT INTO public.who_global_data_import VALUES (78910, '2020-04-21', 'SI', 'Slovenia', 'EURO', '9', '1345', '1', '84');
INSERT INTO public.who_global_data_import VALUES (78911, '2020-04-22', 'SI', 'Slovenia', 'EURO', '9', '1354', '3', '87');
INSERT INTO public.who_global_data_import VALUES (78912, '2020-04-23', 'SI', 'Slovenia', 'EURO', '13', '1367', '0', '87');
INSERT INTO public.who_global_data_import VALUES (78913, '2020-04-24', 'SI', 'Slovenia', 'EURO', '7', '1374', '1', '88');
INSERT INTO public.who_global_data_import VALUES (78914, '2020-04-25', 'SI', 'Slovenia', 'EURO', '15', '1389', '1', '89');
INSERT INTO public.who_global_data_import VALUES (78915, '2020-04-26', 'SI', 'Slovenia', 'EURO', '8', '1397', '1', '90');
INSERT INTO public.who_global_data_import VALUES (78916, '2020-04-27', 'SI', 'Slovenia', 'EURO', '6', '1403', '0', '90');
INSERT INTO public.who_global_data_import VALUES (78917, '2020-04-28', 'SI', 'Slovenia', 'EURO', '6', '1409', '3', '93');
INSERT INTO public.who_global_data_import VALUES (78918, '2020-04-29', 'SI', 'Slovenia', 'EURO', '9', '1418', '3', '96');
INSERT INTO public.who_global_data_import VALUES (78919, '2020-04-30', 'SI', 'Slovenia', 'EURO', '11', '1429', '1', '97');
INSERT INTO public.who_global_data_import VALUES (78920, '2020-05-01', 'SI', 'Slovenia', 'EURO', '5', '1434', '3', '100');
INSERT INTO public.who_global_data_import VALUES (78921, '2020-05-02', 'SI', 'Slovenia', 'EURO', '5', '1439', '2', '102');
INSERT INTO public.who_global_data_import VALUES (78922, '2020-05-03', 'SI', 'Slovenia', 'EURO', '0', '1439', '2', '104');
INSERT INTO public.who_global_data_import VALUES (78923, '2020-05-04', 'SI', 'Slovenia', 'EURO', '0', '1439', '1', '105');
INSERT INTO public.who_global_data_import VALUES (78924, '2020-05-05', 'SI', 'Slovenia', 'EURO', '6', '1445', '0', '105');
INSERT INTO public.who_global_data_import VALUES (78925, '2020-05-06', 'SI', 'Slovenia', 'EURO', '3', '1448', '2', '107');
INSERT INTO public.who_global_data_import VALUES (78926, '2020-05-07', 'SI', 'Slovenia', 'EURO', '1', '1449', '0', '107');
INSERT INTO public.who_global_data_import VALUES (78927, '2020-05-08', 'SI', 'Slovenia', 'EURO', '1', '1450', '1', '108');
INSERT INTO public.who_global_data_import VALUES (78928, '2020-05-09', 'SI', 'Slovenia', 'EURO', '4', '1454', '1', '109');
INSERT INTO public.who_global_data_import VALUES (78929, '2020-05-10', 'SI', 'Slovenia', 'EURO', '3', '1457', '1', '110');
INSERT INTO public.who_global_data_import VALUES (78930, '2020-05-11', 'SI', 'Slovenia', 'EURO', '3', '1460', '0', '110');
INSERT INTO public.who_global_data_import VALUES (78931, '2020-05-12', 'SI', 'Slovenia', 'EURO', '1', '1461', '0', '110');
INSERT INTO public.who_global_data_import VALUES (78932, '2020-05-13', 'SI', 'Slovenia', 'EURO', '2', '1463', '1', '111');
INSERT INTO public.who_global_data_import VALUES (78933, '2020-05-14', 'SI', 'Slovenia', 'EURO', '1', '1464', '0', '111');
INSERT INTO public.who_global_data_import VALUES (78934, '2020-05-15', 'SI', 'Slovenia', 'EURO', '1', '1465', '0', '111');
INSERT INTO public.who_global_data_import VALUES (78935, '2020-05-16', 'SI', 'Slovenia', 'EURO', '0', '1465', '0', '111');
INSERT INTO public.who_global_data_import VALUES (78936, '2020-05-17', 'SI', 'Slovenia', 'EURO', '1', '1466', '0', '111');
INSERT INTO public.who_global_data_import VALUES (78937, '2020-05-18', 'SI', 'Slovenia', 'EURO', '0', '1466', '0', '111');
INSERT INTO public.who_global_data_import VALUES (78938, '2020-05-19', 'SI', 'Slovenia', 'EURO', '1', '1467', '0', '111');
INSERT INTO public.who_global_data_import VALUES (78939, '2020-05-20', 'SI', 'Slovenia', 'EURO', '1', '1468', '1', '112');
INSERT INTO public.who_global_data_import VALUES (78940, '2020-05-21', 'SI', 'Slovenia', 'EURO', '0', '1468', '1', '113');
INSERT INTO public.who_global_data_import VALUES (78941, '2020-05-22', 'SI', 'Slovenia', 'EURO', '0', '1468', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78942, '2020-05-23', 'SI', 'Slovenia', 'EURO', '0', '1468', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78943, '2020-05-24', 'SI', 'Slovenia', 'EURO', '0', '1468', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78944, '2020-05-25', 'SI', 'Slovenia', 'EURO', '1', '1469', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78945, '2020-05-26', 'SI', 'Slovenia', 'EURO', '0', '1469', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78946, '2020-05-27', 'SI', 'Slovenia', 'EURO', '2', '1471', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78947, '2020-05-28', 'SI', 'Slovenia', 'EURO', '2', '1473', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78948, '2020-05-29', 'SI', 'Slovenia', 'EURO', '0', '1473', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78949, '2020-05-30', 'SI', 'Slovenia', 'EURO', '0', '1473', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78950, '2020-05-31', 'SI', 'Slovenia', 'EURO', '0', '1473', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78951, '2020-06-01', 'SI', 'Slovenia', 'EURO', '0', '1473', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78952, '2020-06-02', 'SI', 'Slovenia', 'EURO', '2', '1475', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78953, '2020-06-03', 'SI', 'Slovenia', 'EURO', '2', '1477', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78954, '2020-06-04', 'SI', 'Slovenia', 'EURO', '0', '1477', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78955, '2020-06-05', 'SI', 'Slovenia', 'EURO', '2', '1479', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78956, '2020-06-06', 'SI', 'Slovenia', 'EURO', '5', '1484', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78957, '2020-06-07', 'SI', 'Slovenia', 'EURO', '1', '1485', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78958, '2020-06-08', 'SI', 'Slovenia', 'EURO', '0', '1485', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78959, '2020-06-09', 'SI', 'Slovenia', 'EURO', '1', '1486', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78960, '2020-06-10', 'SI', 'Slovenia', 'EURO', '2', '1488', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78961, '2020-06-11', 'SI', 'Slovenia', 'EURO', '0', '1488', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78962, '2020-06-12', 'SI', 'Slovenia', 'EURO', '2', '1490', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78963, '2020-06-13', 'SI', 'Slovenia', 'EURO', '2', '1492', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78964, '2020-06-14', 'SI', 'Slovenia', 'EURO', '3', '1495', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78965, '2020-06-15', 'SI', 'Slovenia', 'EURO', '1', '1496', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78966, '2020-06-16', 'SI', 'Slovenia', 'EURO', '3', '1499', '0', '113');
INSERT INTO public.who_global_data_import VALUES (78967, '2020-06-17', 'SI', 'Slovenia', 'EURO', '4', '1503', '1', '114');
INSERT INTO public.who_global_data_import VALUES (78968, '2020-06-18', 'SI', 'Slovenia', 'EURO', '8', '1511', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78969, '2020-06-19', 'SI', 'Slovenia', 'EURO', '2', '1513', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78970, '2020-06-20', 'SI', 'Slovenia', 'EURO', '6', '1519', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78971, '2020-06-21', 'SI', 'Slovenia', 'EURO', '1', '1520', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78972, '2020-06-22', 'SI', 'Slovenia', 'EURO', '1', '1521', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78973, '2020-06-23', 'SI', 'Slovenia', 'EURO', '13', '1534', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78974, '2020-06-24', 'SI', 'Slovenia', 'EURO', '6', '1540', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78975, '2020-06-25', 'SI', 'Slovenia', 'EURO', '6', '1546', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78976, '2020-06-26', 'SI', 'Slovenia', 'EURO', '11', '1557', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78977, '2020-06-27', 'SI', 'Slovenia', 'EURO', '14', '1571', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78978, '2020-06-28', 'SI', 'Slovenia', 'EURO', '9', '1580', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78979, '2020-06-29', 'SI', 'Slovenia', 'EURO', '4', '1584', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78980, '2020-06-30', 'SI', 'Slovenia', 'EURO', '15', '1599', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78981, '2020-07-01', 'SI', 'Slovenia', 'EURO', '13', '1612', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78982, '2020-07-02', 'SI', 'Slovenia', 'EURO', '21', '1633', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78983, '2020-07-03', 'SI', 'Slovenia', 'EURO', '16', '1649', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78984, '2020-07-04', 'SI', 'Slovenia', 'EURO', '30', '1679', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78985, '2020-07-05', 'SI', 'Slovenia', 'EURO', '21', '1700', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78986, '2020-07-06', 'SI', 'Slovenia', 'EURO', '16', '1716', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78987, '2020-07-07', 'SI', 'Slovenia', 'EURO', '23', '1739', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78988, '2020-07-08', 'SI', 'Slovenia', 'EURO', '24', '1763', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78989, '2020-07-09', 'SI', 'Slovenia', 'EURO', '13', '1776', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78990, '2020-07-10', 'SI', 'Slovenia', 'EURO', '17', '1793', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78991, '2020-07-11', 'SI', 'Slovenia', 'EURO', '34', '1827', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78992, '2020-07-12', 'SI', 'Slovenia', 'EURO', '15', '1842', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78993, '2020-07-13', 'SI', 'Slovenia', 'EURO', '8', '1850', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78994, '2020-07-14', 'SI', 'Slovenia', 'EURO', '10', '1860', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78995, '2020-07-15', 'SI', 'Slovenia', 'EURO', '19', '1879', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78996, '2020-07-16', 'SI', 'Slovenia', 'EURO', '19', '1898', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78997, '2020-07-17', 'SI', 'Slovenia', 'EURO', '19', '1917', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78998, '2020-07-18', 'SI', 'Slovenia', 'EURO', '24', '1941', '0', '114');
INSERT INTO public.who_global_data_import VALUES (78999, '2020-07-19', 'SI', 'Slovenia', 'EURO', '6', '1947', '0', '114');
INSERT INTO public.who_global_data_import VALUES (79000, '2020-07-20', 'SI', 'Slovenia', 'EURO', '7', '1954', '1', '115');
INSERT INTO public.who_global_data_import VALUES (79001, '2020-07-21', 'SI', 'Slovenia', 'EURO', '24', '1978', '1', '116');
INSERT INTO public.who_global_data_import VALUES (79002, '2020-07-22', 'SI', 'Slovenia', 'EURO', '29', '2007', '1', '117');
INSERT INTO public.who_global_data_import VALUES (79003, '2020-07-23', 'SI', 'Slovenia', 'EURO', '27', '2034', '0', '117');
INSERT INTO public.who_global_data_import VALUES (79004, '2020-07-24', 'SI', 'Slovenia', 'EURO', '19', '2053', '0', '117');
INSERT INTO public.who_global_data_import VALUES (79005, '2020-07-25', 'SI', 'Slovenia', 'EURO', '14', '2067', '1', '118');
INSERT INTO public.who_global_data_import VALUES (79006, '2020-07-26', 'SI', 'Slovenia', 'EURO', '16', '2083', '0', '118');
INSERT INTO public.who_global_data_import VALUES (79007, '2020-07-27', 'SI', 'Slovenia', 'EURO', '5', '2088', '1', '119');
INSERT INTO public.who_global_data_import VALUES (79008, '2020-07-28', 'SI', 'Slovenia', 'EURO', '14', '2102', '0', '119');
INSERT INTO public.who_global_data_import VALUES (79009, '2020-07-29', 'SI', 'Slovenia', 'EURO', '14', '2116', '1', '120');
INSERT INTO public.who_global_data_import VALUES (79010, '2020-07-30', 'SI', 'Slovenia', 'EURO', '24', '2140', '0', '120');
INSERT INTO public.who_global_data_import VALUES (79011, '2020-07-31', 'SI', 'Slovenia', 'EURO', '17', '2157', '1', '121');
INSERT INTO public.who_global_data_import VALUES (79012, '2020-08-01', 'SI', 'Slovenia', 'EURO', '15', '2172', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79013, '2020-08-02', 'SI', 'Slovenia', 'EURO', '9', '2181', '1', '122');
INSERT INTO public.who_global_data_import VALUES (79014, '2020-08-03', 'SI', 'Slovenia', 'EURO', '1', '2182', '2', '124');
INSERT INTO public.who_global_data_import VALUES (79015, '2020-08-04', 'SI', 'Slovenia', 'EURO', '9', '2191', '1', '125');
INSERT INTO public.who_global_data_import VALUES (79016, '2020-08-05', 'SI', 'Slovenia', 'EURO', '18', '2209', '1', '126');
INSERT INTO public.who_global_data_import VALUES (79017, '2020-08-06', 'SI', 'Slovenia', 'EURO', '15', '2224', '0', '126');
INSERT INTO public.who_global_data_import VALUES (79018, '2020-08-07', 'SI', 'Slovenia', 'EURO', '10', '2234', '0', '126');
INSERT INTO public.who_global_data_import VALUES (79019, '2020-08-08', 'SI', 'Slovenia', 'EURO', '14', '2248', '1', '127');
INSERT INTO public.who_global_data_import VALUES (79020, '2020-08-09', 'SI', 'Slovenia', 'EURO', '2', '2250', '2', '129');
INSERT INTO public.who_global_data_import VALUES (79021, '2020-08-10', 'SI', 'Slovenia', 'EURO', '6', '2256', '1', '130');
INSERT INTO public.who_global_data_import VALUES (79022, '2020-08-11', 'SI', 'Slovenia', 'EURO', '17', '2273', '1', '131');
INSERT INTO public.who_global_data_import VALUES (79023, '2020-08-12', 'SI', 'Slovenia', 'EURO', '31', '2304', '0', '131');
INSERT INTO public.who_global_data_import VALUES (79024, '2020-08-13', 'SI', 'Slovenia', 'EURO', '29', '2333', '0', '131');
INSERT INTO public.who_global_data_import VALUES (79025, '2020-08-14', 'SI', 'Slovenia', 'EURO', '37', '2370', '0', '131');
INSERT INTO public.who_global_data_import VALUES (79026, '2020-08-15', 'SI', 'Slovenia', 'EURO', '32', '2402', '0', '131');
INSERT INTO public.who_global_data_import VALUES (79027, '2020-08-16', 'SI', 'Slovenia', 'EURO', '15', '2417', '0', '131');
INSERT INTO public.who_global_data_import VALUES (79028, '2020-08-17', 'SI', 'Slovenia', 'EURO', '13', '2430', '0', '131');
INSERT INTO public.who_global_data_import VALUES (79029, '2020-08-18', 'SI', 'Slovenia', 'EURO', '27', '2457', '0', '131');
INSERT INTO public.who_global_data_import VALUES (79030, '2020-08-19', 'SI', 'Slovenia', 'EURO', '37', '2494', '0', '131');
INSERT INTO public.who_global_data_import VALUES (79031, '2020-08-20', 'SI', 'Slovenia', 'EURO', '43', '2537', '0', '131');
INSERT INTO public.who_global_data_import VALUES (79032, '2020-08-21', 'SI', 'Slovenia', 'EURO', '38', '2575', '1', '132');
INSERT INTO public.who_global_data_import VALUES (79033, '2020-08-22', 'SI', 'Slovenia', 'EURO', '43', '2618', '0', '132');
INSERT INTO public.who_global_data_import VALUES (79034, '2020-08-23', 'SI', 'Slovenia', 'EURO', '34', '2652', '0', '132');
INSERT INTO public.who_global_data_import VALUES (79035, '2020-08-24', 'SI', 'Slovenia', 'EURO', '14', '2666', '1', '133');
INSERT INTO public.who_global_data_import VALUES (79036, '2020-08-25', 'SI', 'Slovenia', 'EURO', '21', '2687', '0', '133');
INSERT INTO public.who_global_data_import VALUES (79037, '2020-08-26', 'SI', 'Slovenia', 'EURO', '36', '2723', '0', '133');
INSERT INTO public.who_global_data_import VALUES (79038, '2020-08-27', 'SI', 'Slovenia', 'EURO', '33', '2756', '0', '133');
INSERT INTO public.who_global_data_import VALUES (79039, '2020-08-28', 'SI', 'Slovenia', 'EURO', '42', '2798', '0', '133');
INSERT INTO public.who_global_data_import VALUES (79040, '2020-08-29', 'SI', 'Slovenia', 'EURO', '37', '2835', '0', '133');
INSERT INTO public.who_global_data_import VALUES (79041, '2020-08-30', 'SI', 'Slovenia', 'EURO', '31', '2866', '0', '133');
INSERT INTO public.who_global_data_import VALUES (79042, '2020-08-31', 'SI', 'Slovenia', 'EURO', '18', '2884', '0', '133');
INSERT INTO public.who_global_data_import VALUES (79043, '2020-09-01', 'SI', 'Slovenia', 'EURO', '41', '2925', '0', '133');
INSERT INTO public.who_global_data_import VALUES (79044, '2020-09-02', 'SI', 'Slovenia', 'EURO', '55', '2980', '0', '133');
INSERT INTO public.who_global_data_import VALUES (79045, '2020-09-03', 'SI', 'Slovenia', 'EURO', '53', '3033', '0', '133');
INSERT INTO public.who_global_data_import VALUES (79046, '2020-09-04', 'SI', 'Slovenia', 'EURO', '47', '3080', '0', '133');
INSERT INTO public.who_global_data_import VALUES (79047, '2020-09-05', 'SI', 'Slovenia', 'EURO', '43', '3123', '1', '134');
INSERT INTO public.who_global_data_import VALUES (79048, '2020-09-06', 'SI', 'Slovenia', 'EURO', '43', '3166', '0', '134');
INSERT INTO public.who_global_data_import VALUES (79049, '2020-09-07', 'SI', 'Slovenia', 'EURO', '25', '3191', '0', '134');
INSERT INTO public.who_global_data_import VALUES (79050, '2020-09-08', 'SI', 'Slovenia', 'EURO', '43', '3234', '0', '134');
INSERT INTO public.who_global_data_import VALUES (79051, '2020-09-09', 'SI', 'Slovenia', 'EURO', '79', '3313', '1', '135');
INSERT INTO public.who_global_data_import VALUES (79052, '2020-09-10', 'SI', 'Slovenia', 'EURO', '78', '3391', '0', '135');
INSERT INTO public.who_global_data_import VALUES (79053, '2020-09-11', 'SI', 'Slovenia', 'EURO', '108', '3499', '0', '135');
INSERT INTO public.who_global_data_import VALUES (79054, '2020-09-12', 'SI', 'Slovenia', 'EURO', '105', '3604', '1', '136');
INSERT INTO public.who_global_data_import VALUES (79055, '2020-09-13', 'SI', 'Slovenia', 'EURO', '99', '3703', '1', '137');
INSERT INTO public.who_global_data_import VALUES (79056, '2020-09-14', 'SI', 'Slovenia', 'EURO', '47', '3750', '0', '137');
INSERT INTO public.who_global_data_import VALUES (79057, '2020-09-15', 'SI', 'Slovenia', 'EURO', '83', '3833', '0', '137');
INSERT INTO public.who_global_data_import VALUES (79058, '2020-09-16', 'SI', 'Slovenia', 'EURO', '123', '3956', '0', '137');
INSERT INTO public.who_global_data_import VALUES (79059, '2020-09-17', 'SI', 'Slovenia', 'EURO', '104', '4060', '1', '138');
INSERT INTO public.who_global_data_import VALUES (79060, '2020-09-18', 'SI', 'Slovenia', 'EURO', '137', '4197', '4', '142');
INSERT INTO public.who_global_data_import VALUES (79061, '2020-09-19', 'SI', 'Slovenia', 'EURO', '113', '4310', '2', '144');
INSERT INTO public.who_global_data_import VALUES (79062, '2020-09-20', 'SI', 'Slovenia', 'EURO', '111', '4421', '1', '145');
INSERT INTO public.who_global_data_import VALUES (79063, '2020-09-21', 'SI', 'Slovenia', 'EURO', '50', '4471', '0', '145');
INSERT INTO public.who_global_data_import VALUES (79064, '2020-09-22', 'SI', 'Slovenia', 'EURO', '88', '4559', '1', '146');
INSERT INTO public.who_global_data_import VALUES (79065, '2020-09-23', 'SI', 'Slovenia', 'EURO', '136', '4695', '1', '147');
INSERT INTO public.who_global_data_import VALUES (79066, '2020-09-24', 'SI', 'Slovenia', 'EURO', '121', '4816', '2', '149');
INSERT INTO public.who_global_data_import VALUES (79067, '2020-09-25', 'SI', 'Slovenia', 'EURO', '193', '5009', '1', '150');
INSERT INTO public.who_global_data_import VALUES (79068, '2020-09-26', 'SI', 'Slovenia', 'EURO', '184', '5193', '1', '151');
INSERT INTO public.who_global_data_import VALUES (79069, '2020-09-27', 'SI', 'Slovenia', 'EURO', '158', '5351', '1', '152');
INSERT INTO public.who_global_data_import VALUES (79070, '2020-09-28', 'SI', 'Slovenia', 'EURO', '39', '5390', '2', '154');
INSERT INTO public.who_global_data_import VALUES (79071, '2020-09-29', 'SI', 'Slovenia', 'EURO', '99', '5489', '0', '154');
INSERT INTO public.who_global_data_import VALUES (79072, '2020-09-30', 'SI', 'Slovenia', 'EURO', '202', '5691', '1', '155');
INSERT INTO public.who_global_data_import VALUES (79073, '2020-10-01', 'SI', 'Slovenia', 'EURO', '175', '5866', '2', '157');
INSERT INTO public.who_global_data_import VALUES (79074, '2020-10-02', 'SI', 'Slovenia', 'EURO', '239', '6105', '2', '159');
INSERT INTO public.who_global_data_import VALUES (79075, '2020-10-03', 'SI', 'Slovenia', 'EURO', '228', '6333', '0', '159');
INSERT INTO public.who_global_data_import VALUES (79076, '2020-10-04', 'SI', 'Slovenia', 'EURO', '168', '6501', '0', '159');
INSERT INTO public.who_global_data_import VALUES (79077, '2020-10-05', 'SI', 'Slovenia', 'EURO', '75', '6576', '2', '161');
INSERT INTO public.who_global_data_import VALUES (79078, '2020-10-06', 'SI', 'Slovenia', 'EURO', '190', '6766', '5', '166');
INSERT INTO public.who_global_data_import VALUES (79079, '2020-10-07', 'SI', 'Slovenia', 'EURO', '357', '7123', '0', '166');
INSERT INTO public.who_global_data_import VALUES (79080, '2020-10-08', 'SI', 'Slovenia', 'EURO', '388', '7511', '1', '167');
INSERT INTO public.who_global_data_import VALUES (79081, '2020-10-09', 'SI', 'Slovenia', 'EURO', '363', '7874', '2', '169');
INSERT INTO public.who_global_data_import VALUES (79082, '2020-10-10', 'SI', 'Slovenia', 'EURO', '380', '8254', '7', '176');
INSERT INTO public.who_global_data_import VALUES (79083, '2020-10-11', 'SI', 'Slovenia', 'EURO', '411', '8665', '0', '176');
INSERT INTO public.who_global_data_import VALUES (79084, '2020-10-12', 'SI', 'Slovenia', 'EURO', '169', '8834', '2', '178');
INSERT INTO public.who_global_data_import VALUES (79085, '2020-10-13', 'SI', 'Slovenia', 'EURO', '399', '9233', '3', '181');
INSERT INTO public.who_global_data_import VALUES (79086, '2020-10-14', 'SI', 'Slovenia', 'EURO', '707', '9940', '5', '186');
INSERT INTO public.who_global_data_import VALUES (79087, '2020-10-15', 'SI', 'Slovenia', 'EURO', '748', '10688', '3', '189');
INSERT INTO public.who_global_data_import VALUES (79088, '2020-10-16', 'SI', 'Slovenia', 'EURO', '836', '11524', '8', '197');
INSERT INTO public.who_global_data_import VALUES (79089, '2020-10-17', 'SI', 'Slovenia', 'EURO', '898', '12422', '5', '202');
INSERT INTO public.who_global_data_import VALUES (79090, '2020-10-18', 'SI', 'Slovenia', 'EURO', '727', '13149', '6', '208');
INSERT INTO public.who_global_data_import VALUES (79091, '2020-10-19', 'SI', 'Slovenia', 'EURO', '537', '13686', '4', '212');
INSERT INTO public.who_global_data_import VALUES (79092, '2020-10-20', 'SI', 'Slovenia', 'EURO', '802', '14488', '6', '218');
INSERT INTO public.who_global_data_import VALUES (79093, '2020-10-21', 'SI', 'Slovenia', 'EURO', '1505', '15993', '11', '229');
INSERT INTO public.who_global_data_import VALUES (79094, '2020-10-22', 'SI', 'Slovenia', 'EURO', '1670', '17663', '8', '237');
INSERT INTO public.who_global_data_import VALUES (79095, '2020-10-23', 'SI', 'Slovenia', 'EURO', '1661', '19324', '9', '246');
INSERT INTO public.who_global_data_import VALUES (79096, '2020-10-24', 'SI', 'Slovenia', 'EURO', '1969', '21293', '20', '266');
INSERT INTO public.who_global_data_import VALUES (79097, '2020-10-25', 'SI', 'Slovenia', 'EURO', '1702', '22995', '5', '271');
INSERT INTO public.who_global_data_import VALUES (79098, '2020-10-26', 'SI', 'Slovenia', 'EURO', '1118', '24113', '17', '288');
INSERT INTO public.who_global_data_import VALUES (79099, '2020-10-27', 'SI', 'Slovenia', 'EURO', '1502', '25615', '15', '303');
INSERT INTO public.who_global_data_import VALUES (79100, '2020-10-28', 'SI', 'Slovenia', 'EURO', '2611', '28226', '16', '319');
INSERT INTO public.who_global_data_import VALUES (79101, '2020-10-29', 'SI', 'Slovenia', 'EURO', '2492', '30718', '20', '339');
INSERT INTO public.who_global_data_import VALUES (79102, '2020-10-30', 'SI', 'Slovenia', 'EURO', '1800', '32518', '25', '364');
INSERT INTO public.who_global_data_import VALUES (79103, '2020-10-31', 'SI', 'Slovenia', 'EURO', '1797', '34315', '27', '391');
INSERT INTO public.who_global_data_import VALUES (79104, '2020-11-01', 'SI', 'Slovenia', 'EURO', '1347', '35662', '27', '418');
INSERT INTO public.who_global_data_import VALUES (79105, '2020-11-02', 'SI', 'Slovenia', 'EURO', '557', '36219', '23', '441');
INSERT INTO public.who_global_data_import VALUES (79106, '2020-11-03', 'SI', 'Slovenia', 'EURO', '1177', '37396', '31', '472');
INSERT INTO public.who_global_data_import VALUES (79107, '2020-11-04', 'SI', 'Slovenia', 'EURO', '2032', '39428', '31', '503');
INSERT INTO public.who_global_data_import VALUES (79108, '2020-11-05', 'SI', 'Slovenia', 'EURO', '1691', '41119', '31', '534');
INSERT INTO public.who_global_data_import VALUES (79109, '2020-11-06', 'SI', 'Slovenia', 'EURO', '1567', '42686', '28', '562');
INSERT INTO public.who_global_data_import VALUES (79110, '2020-11-07', 'SI', 'Slovenia', 'EURO', '1613', '44299', '35', '597');
INSERT INTO public.who_global_data_import VALUES (79111, '2020-11-08', 'SI', 'Slovenia', 'EURO', '891', '45190', '21', '618');
INSERT INTO public.who_global_data_import VALUES (79112, '2020-11-09', 'SI', 'Slovenia', 'EURO', '466', '45656', '25', '643');
INSERT INTO public.who_global_data_import VALUES (79113, '2020-11-10', 'SI', 'Slovenia', 'EURO', '1089', '46745', '28', '671');
INSERT INTO public.who_global_data_import VALUES (79114, '2020-11-11', 'SI', 'Slovenia', 'EURO', '2228', '48973', '43', '714');
INSERT INTO public.who_global_data_import VALUES (79115, '2020-11-12', 'SI', 'Slovenia', 'EURO', '1932', '50905', '49', '763');
INSERT INTO public.who_global_data_import VALUES (79116, '2020-11-13', 'SI', 'Slovenia', 'EURO', '1516', '52421', '43', '806');
INSERT INTO public.who_global_data_import VALUES (79117, '2020-11-14', 'SI', 'Slovenia', 'EURO', '1740', '54161', '41', '847');
INSERT INTO public.who_global_data_import VALUES (79118, '2020-11-15', 'SI', 'Slovenia', 'EURO', '922', '55083', '31', '878');
INSERT INTO public.who_global_data_import VALUES (79119, '2020-11-16', 'SI', 'Slovenia', 'EURO', '500', '55583', '34', '912');
INSERT INTO public.who_global_data_import VALUES (79120, '2020-11-17', 'SI', 'Slovenia', 'EURO', '1393', '56976', '44', '956');
INSERT INTO public.who_global_data_import VALUES (79121, '2020-11-18', 'SI', 'Slovenia', 'EURO', '2018', '58994', '45', '1001');
INSERT INTO public.who_global_data_import VALUES (79122, '2020-11-19', 'SI', 'Slovenia', 'EURO', '2068', '61062', '43', '1044');
INSERT INTO public.who_global_data_import VALUES (79123, '2020-11-20', 'SI', 'Slovenia', 'EURO', '1549', '62611', '37', '1081');
INSERT INTO public.who_global_data_import VALUES (79124, '2020-11-21', 'SI', 'Slovenia', 'EURO', '1691', '64302', '43', '1124');
INSERT INTO public.who_global_data_import VALUES (79125, '2020-11-22', 'SI', 'Slovenia', 'EURO', '1025', '65327', '26', '1150');
INSERT INTO public.who_global_data_import VALUES (79126, '2020-11-23', 'SI', 'Slovenia', 'EURO', '471', '65798', '53', '1203');
INSERT INTO public.who_global_data_import VALUES (79127, '2020-11-24', 'SI', 'Slovenia', 'EURO', '1308', '67106', '56', '1259');
INSERT INTO public.who_global_data_import VALUES (79128, '2020-11-25', 'SI', 'Slovenia', 'EURO', '2235', '69341', '44', '1303');
INSERT INTO public.who_global_data_import VALUES (79129, '2020-11-26', 'SI', 'Slovenia', 'EURO', '1782', '71123', '54', '1357');
INSERT INTO public.who_global_data_import VALUES (79130, '2020-11-27', 'SI', 'Slovenia', 'EURO', '1612', '72735', '47', '1404');
INSERT INTO public.who_global_data_import VALUES (79131, '2020-11-28', 'SI', 'Slovenia', 'EURO', '1601', '74336', '63', '1467');
INSERT INTO public.who_global_data_import VALUES (79132, '2020-11-29', 'SI', 'Slovenia', 'EURO', '1109', '75445', '46', '1513');
INSERT INTO public.who_global_data_import VALUES (79133, '2020-11-30', 'SI', 'Slovenia', 'EURO', '427', '75872', '51', '1564');
INSERT INTO public.who_global_data_import VALUES (79134, '2020-12-01', 'SI', 'Slovenia', 'EURO', '1299', '77171', '58', '1622');
INSERT INTO public.who_global_data_import VALUES (79135, '2020-12-02', 'SI', 'Slovenia', 'EURO', '2438', '79609', '64', '1686');
INSERT INTO public.who_global_data_import VALUES (79136, '2020-12-03', 'SI', 'Slovenia', 'EURO', '1776', '81385', '49', '1735');
INSERT INTO public.who_global_data_import VALUES (79137, '2020-12-04', 'SI', 'Slovenia', 'EURO', '1786', '83171', '74', '1809');
INSERT INTO public.who_global_data_import VALUES (79138, '2020-12-05', 'SI', 'Slovenia', 'EURO', '1647', '84818', '51', '1860');
INSERT INTO public.who_global_data_import VALUES (79139, '2020-12-06', 'SI', 'Slovenia', 'EURO', '1033', '85851', '49', '1909');
INSERT INTO public.who_global_data_import VALUES (79140, '2020-12-07', 'SI', 'Slovenia', 'EURO', '480', '86331', '59', '1968');
INSERT INTO public.who_global_data_import VALUES (79141, '2020-12-08', 'SI', 'Slovenia', 'EURO', '1630', '87961', '60', '2028');
INSERT INTO public.who_global_data_import VALUES (79142, '2020-12-09', 'SI', 'Slovenia', 'EURO', '2140', '90101', '43', '2071');
INSERT INTO public.who_global_data_import VALUES (79143, '2020-12-10', 'SI', 'Slovenia', 'EURO', '1852', '91953', '55', '2126');
INSERT INTO public.who_global_data_import VALUES (79144, '2020-12-11', 'SI', 'Slovenia', 'EURO', '1816', '93769', '57', '2183');
INSERT INTO public.who_global_data_import VALUES (79145, '2020-12-12', 'SI', 'Slovenia', 'EURO', '1750', '95519', '53', '2236');
INSERT INTO public.who_global_data_import VALUES (79146, '2020-12-13', 'SI', 'Slovenia', 'EURO', '834', '96353', '39', '2275');
INSERT INTO public.who_global_data_import VALUES (79147, '2020-12-14', 'SI', 'Slovenia', 'EURO', '434', '96787', '46', '2321');
INSERT INTO public.who_global_data_import VALUES (79148, '2020-12-15', 'SI', 'Slovenia', 'EURO', '1532', '98319', '55', '2376');
INSERT INTO public.who_global_data_import VALUES (79149, '2020-12-16', 'SI', 'Slovenia', 'EURO', '2112', '100431', '52', '2428');
INSERT INTO public.who_global_data_import VALUES (79150, '2020-12-17', 'SI', 'Slovenia', 'EURO', '1648', '102079', '42', '2470');
INSERT INTO public.who_global_data_import VALUES (79151, '2020-12-18', 'SI', 'Slovenia', 'EURO', '1517', '103596', '39', '2509');
INSERT INTO public.who_global_data_import VALUES (79152, '2020-12-19', 'SI', 'Slovenia', 'EURO', '1430', '105026', '42', '2551');
INSERT INTO public.who_global_data_import VALUES (79153, '2020-12-20', 'SI', 'Slovenia', 'EURO', '884', '105910', '40', '2591');
INSERT INTO public.who_global_data_import VALUES (79154, '2020-12-21', 'SI', 'Slovenia', 'EURO', '396', '106306', '27', '2618');
INSERT INTO public.who_global_data_import VALUES (79155, '2020-12-22', 'SI', 'Slovenia', 'EURO', '1550', '107856', '45', '2663');
INSERT INTO public.who_global_data_import VALUES (79156, '2020-12-23', 'SI', 'Slovenia', 'EURO', '2157', '110013', '37', '2700');
INSERT INTO public.who_global_data_import VALUES (79157, '2020-12-24', 'SI', 'Slovenia', 'EURO', '2064', '112077', '32', '2732');
INSERT INTO public.who_global_data_import VALUES (79158, '2020-12-25', 'SI', 'Slovenia', 'EURO', '1809', '113886', '35', '2767');
INSERT INTO public.who_global_data_import VALUES (79159, '2020-12-26', 'SI', 'Slovenia', 'EURO', '369', '114255', '33', '2800');
INSERT INTO public.who_global_data_import VALUES (79160, '2020-12-27', 'SI', 'Slovenia', 'EURO', '622', '114877', '27', '2827');
INSERT INTO public.who_global_data_import VALUES (79161, '2020-12-28', 'SI', 'Slovenia', 'EURO', '533', '115410', '48', '2875');
INSERT INTO public.who_global_data_import VALUES (79162, '2020-12-29', 'SI', 'Slovenia', 'EURO', '1990', '117400', '44', '2919');
INSERT INTO public.who_global_data_import VALUES (79163, '2020-12-30', 'SI', 'Slovenia', 'EURO', '2429', '119829', '31', '2950');
INSERT INTO public.who_global_data_import VALUES (79164, '2020-12-31', 'SI', 'Slovenia', 'EURO', '2428', '122257', '28', '2978');
INSERT INTO public.who_global_data_import VALUES (79165, '2021-01-01', 'SI', 'Slovenia', 'EURO', '1773', '124030', '42', '3020');
INSERT INTO public.who_global_data_import VALUES (79166, '2021-01-02', 'SI', 'Slovenia', 'EURO', '398', '124428', '35', '3055');
INSERT INTO public.who_global_data_import VALUES (79167, '2021-01-03', 'SI', 'Slovenia', 'EURO', '760', '125188', '35', '3090');
INSERT INTO public.who_global_data_import VALUES (79168, '2021-01-04', 'SI', 'Slovenia', 'EURO', '764', '125952', '31', '3121');
INSERT INTO public.who_global_data_import VALUES (79169, '2021-01-05', 'SI', 'Slovenia', 'EURO', '2600', '128552', '30', '3151');
INSERT INTO public.who_global_data_import VALUES (79170, '2021-01-06', 'SI', 'Slovenia', 'EURO', '3421', '131973', '36', '3187');
INSERT INTO public.who_global_data_import VALUES (79171, '2021-01-07', 'SI', 'Slovenia', 'EURO', '2690', '134663', '25', '3212');
INSERT INTO public.who_global_data_import VALUES (79172, '2021-01-08', 'SI', 'Slovenia', 'EURO', '2077', '136740', '28', '3240');
INSERT INTO public.who_global_data_import VALUES (79173, '2021-01-09', 'SI', 'Slovenia', 'EURO', '1854', '138594', '27', '3267');
INSERT INTO public.who_global_data_import VALUES (79174, '2021-01-10', 'SI', 'Slovenia', 'EURO', '762', '139356', '33', '3300');
INSERT INTO public.who_global_data_import VALUES (79175, '2021-01-11', 'SI', 'Slovenia', 'EURO', '428', '139784', '19', '3319');
INSERT INTO public.who_global_data_import VALUES (79176, '2021-01-12', 'SI', 'Slovenia', 'EURO', '1897', '141681', '29', '3348');
INSERT INTO public.who_global_data_import VALUES (79177, '2021-01-13', 'SI', 'Slovenia', 'EURO', '2100', '143781', '23', '3371');
INSERT INTO public.who_global_data_import VALUES (79178, '2021-01-14', 'SI', 'Slovenia', 'EURO', '1804', '145585', '18', '3389');
INSERT INTO public.who_global_data_import VALUES (79179, '2021-01-15', 'SI', 'Slovenia', 'EURO', '1493', '147078', '24', '3413');
INSERT INTO public.who_global_data_import VALUES (79180, '2021-01-16', 'SI', 'Slovenia', 'EURO', '1543', '148621', '28', '3441');
INSERT INTO public.who_global_data_import VALUES (79181, '2021-01-17', 'SI', 'Slovenia', 'EURO', '573', '149194', '31', '3472');
INSERT INTO public.who_global_data_import VALUES (79182, '2021-01-18', 'SI', 'Slovenia', 'EURO', '300', '149494', '27', '3499');
INSERT INTO public.who_global_data_import VALUES (79183, '2021-01-19', 'SI', 'Slovenia', 'EURO', '1702', '151196', '27', '3526');
INSERT INTO public.who_global_data_import VALUES (79184, '2021-01-20', 'SI', 'Slovenia', 'EURO', '1713', '152909', '23', '3549');
INSERT INTO public.who_global_data_import VALUES (79185, '2021-01-21', 'SI', 'Slovenia', 'EURO', '1455', '154364', '26', '3575');
INSERT INTO public.who_global_data_import VALUES (79186, '2021-01-22', 'SI', 'Slovenia', 'EURO', '1458', '155822', '19', '3594');
INSERT INTO public.who_global_data_import VALUES (79187, '2021-01-23', 'SI', 'Slovenia', 'EURO', '1518', '157340', '20', '3614');
INSERT INTO public.who_global_data_import VALUES (79188, '2021-01-24', 'SI', 'Slovenia', 'EURO', '540', '157880', '14', '3628');
INSERT INTO public.who_global_data_import VALUES (79189, '2021-01-25', 'SI', 'Slovenia', 'EURO', '295', '158175', '9', '3637');
INSERT INTO public.who_global_data_import VALUES (79190, '2021-01-26', 'SI', 'Slovenia', 'EURO', '1680', '159855', '10', '3647');
INSERT INTO public.who_global_data_import VALUES (79191, '2021-01-27', 'SI', 'Slovenia', 'EURO', '1864', '161719', '11', '3658');
INSERT INTO public.who_global_data_import VALUES (79192, '2021-01-28', 'SI', 'Slovenia', 'EURO', '1516', '163235', '7', '3665');
INSERT INTO public.who_global_data_import VALUES (79193, '2021-01-29', 'SI', 'Slovenia', 'EURO', '1348', '164583', '44', '3709');
INSERT INTO public.who_global_data_import VALUES (79194, '2021-01-30', 'SI', 'Slovenia', 'EURO', '1304', '165887', '23', '3732');
INSERT INTO public.who_global_data_import VALUES (79195, '2021-01-31', 'SI', 'Slovenia', 'EURO', '586', '166473', '20', '3752');
INSERT INTO public.who_global_data_import VALUES (79196, '2021-02-01', 'SI', 'Slovenia', 'EURO', '363', '166836', '7', '3759');
INSERT INTO public.who_global_data_import VALUES (79197, '2021-02-02', 'SI', 'Slovenia', 'EURO', '1650', '168486', '20', '3779');
INSERT INTO public.who_global_data_import VALUES (79198, '2021-02-03', 'SI', 'Slovenia', 'EURO', '1615', '170101', '32', '3811');
INSERT INTO public.who_global_data_import VALUES (79199, '2021-02-04', 'SI', 'Slovenia', 'EURO', '1239', '171340', '22', '3833');
INSERT INTO public.who_global_data_import VALUES (79200, '2021-02-05', 'SI', 'Slovenia', 'EURO', '869', '172209', '24', '3857');
INSERT INTO public.who_global_data_import VALUES (79201, '2020-01-03', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79202, '2020-01-04', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79203, '2020-01-05', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79204, '2020-01-06', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79205, '2020-01-07', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79206, '2020-01-08', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79207, '2020-01-09', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79208, '2020-01-10', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79209, '2020-01-11', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79210, '2020-01-12', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79211, '2020-01-13', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79212, '2020-01-14', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79213, '2020-01-15', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79214, '2020-01-16', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79215, '2020-01-17', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79216, '2020-01-18', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79217, '2020-01-19', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79218, '2020-01-20', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79219, '2020-01-21', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79220, '2020-01-22', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79221, '2020-01-23', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79222, '2020-01-24', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79223, '2020-01-25', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79224, '2020-01-26', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79225, '2020-01-27', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79226, '2020-01-28', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79227, '2020-01-29', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79228, '2020-01-30', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79229, '2020-01-31', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79230, '2020-02-01', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79231, '2020-02-02', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79232, '2020-02-03', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79233, '2020-02-04', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79234, '2020-02-05', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79235, '2020-02-06', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79236, '2020-02-07', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79237, '2020-02-08', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79238, '2020-02-09', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79239, '2020-02-10', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79240, '2020-02-11', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79241, '2020-02-12', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79242, '2020-02-13', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79243, '2020-02-14', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79244, '2020-02-15', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79245, '2020-02-16', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79246, '2020-02-17', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79247, '2020-02-18', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79248, '2020-02-19', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79249, '2020-02-20', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79250, '2020-02-21', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79251, '2020-02-22', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79252, '2020-02-23', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79253, '2020-02-24', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79254, '2020-02-25', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79255, '2020-02-26', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79256, '2020-02-27', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79257, '2020-02-28', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79258, '2020-02-29', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79259, '2020-03-01', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79260, '2020-03-02', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79261, '2020-03-03', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79262, '2020-03-04', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79263, '2020-03-05', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79264, '2020-03-06', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79265, '2020-03-07', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79266, '2020-03-08', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79267, '2020-03-09', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79268, '2020-03-10', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79269, '2020-03-11', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79270, '2020-03-12', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79271, '2020-03-13', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79272, '2020-03-14', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79273, '2020-03-15', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79274, '2020-03-16', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79275, '2020-03-17', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79276, '2020-03-18', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79277, '2020-03-19', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79278, '2020-03-20', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79279, '2020-03-21', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79280, '2020-03-22', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79281, '2020-03-23', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79282, '2020-03-24', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79283, '2020-03-25', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79284, '2020-03-26', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79285, '2020-03-27', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79286, '2020-03-28', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79287, '2020-03-29', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79288, '2020-03-30', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79289, '2020-03-31', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79290, '2020-04-01', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79613, '2020-01-15', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79291, '2020-04-02', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79292, '2020-04-03', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79293, '2020-04-04', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79294, '2020-04-05', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79295, '2020-04-06', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79296, '2020-04-07', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79297, '2020-04-08', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79298, '2020-04-09', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79299, '2020-04-10', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79300, '2020-04-11', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79301, '2020-04-12', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79302, '2020-04-13', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79303, '2020-04-14', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79304, '2020-04-15', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79305, '2020-04-16', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79306, '2020-04-17', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79307, '2020-04-18', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79308, '2020-04-19', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79309, '2020-04-20', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79310, '2020-04-21', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79311, '2020-04-22', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79312, '2020-04-23', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79313, '2020-04-24', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79314, '2020-04-25', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79315, '2020-04-26', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79316, '2020-04-27', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79317, '2020-04-28', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79318, '2020-04-29', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79319, '2020-04-30', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79320, '2020-05-01', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79321, '2020-05-02', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79322, '2020-05-03', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79323, '2020-05-04', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79324, '2020-05-05', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79325, '2020-05-06', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79326, '2020-05-07', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79327, '2020-05-08', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79328, '2020-05-09', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79329, '2020-05-10', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79330, '2020-05-11', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79331, '2020-05-12', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79332, '2020-05-13', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79333, '2020-05-14', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79334, '2020-05-15', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79335, '2020-05-16', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79336, '2020-05-17', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79337, '2020-05-18', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79338, '2020-05-19', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79339, '2020-05-20', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79340, '2020-05-21', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79341, '2020-05-22', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79342, '2020-05-23', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79343, '2020-05-24', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79344, '2020-05-25', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79345, '2020-05-26', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79346, '2020-05-27', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79347, '2020-05-28', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79348, '2020-05-29', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79349, '2020-05-30', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79350, '2020-05-31', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79351, '2020-06-01', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79352, '2020-06-02', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79353, '2020-06-03', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79354, '2020-06-04', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79355, '2020-06-05', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79356, '2020-06-06', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79357, '2020-06-07', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79358, '2020-06-08', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79359, '2020-06-09', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79360, '2020-06-10', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79361, '2020-06-11', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79362, '2020-06-12', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79363, '2020-06-13', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79364, '2020-06-14', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79365, '2020-06-15', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79366, '2020-06-16', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79367, '2020-06-17', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79368, '2020-06-18', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79369, '2020-06-19', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79370, '2020-06-20', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79371, '2020-06-21', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79372, '2020-06-22', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79373, '2020-06-23', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79374, '2020-06-24', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79375, '2020-06-25', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79376, '2020-06-26', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79377, '2020-06-27', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79378, '2020-06-28', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79379, '2020-06-29', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79380, '2020-06-30', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79381, '2020-07-01', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79382, '2020-07-02', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79383, '2020-07-03', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79384, '2020-07-04', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79385, '2020-07-05', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79386, '2020-07-06', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79387, '2020-07-07', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79388, '2020-07-08', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79389, '2020-07-09', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79390, '2020-07-10', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79391, '2020-07-11', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79392, '2020-07-12', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79393, '2020-07-13', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79394, '2020-07-14', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79395, '2020-07-15', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79396, '2020-07-16', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79397, '2020-07-17', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79398, '2020-07-18', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79399, '2020-07-19', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79400, '2020-07-20', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79401, '2020-07-21', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79402, '2020-07-22', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79403, '2020-07-23', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79404, '2020-07-24', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79405, '2020-07-25', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79406, '2020-07-26', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79407, '2020-07-27', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79408, '2020-07-28', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79409, '2020-07-29', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79410, '2020-07-30', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79411, '2020-07-31', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79412, '2020-08-01', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79413, '2020-08-02', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79414, '2020-08-03', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79415, '2020-08-04', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79416, '2020-08-05', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79417, '2020-08-06', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79418, '2020-08-07', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79419, '2020-08-08', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79420, '2020-08-09', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79421, '2020-08-10', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79422, '2020-08-11', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79423, '2020-08-12', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79424, '2020-08-13', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79425, '2020-08-14', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79426, '2020-08-15', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79427, '2020-08-16', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79428, '2020-08-17', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79429, '2020-08-18', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79430, '2020-08-19', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79431, '2020-08-20', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79432, '2020-08-21', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79433, '2020-08-22', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79434, '2020-08-23', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79435, '2020-08-24', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79436, '2020-08-25', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79437, '2020-08-26', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79438, '2020-08-27', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79439, '2020-08-28', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79440, '2020-08-29', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79441, '2020-08-30', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79442, '2020-08-31', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79443, '2020-09-01', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79444, '2020-09-02', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79445, '2020-09-03', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79446, '2020-09-04', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79447, '2020-09-05', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79448, '2020-09-06', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79449, '2020-09-07', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79450, '2020-09-08', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79451, '2020-09-09', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79452, '2020-09-10', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79453, '2020-09-11', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79454, '2020-09-12', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79455, '2020-09-13', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79456, '2020-09-14', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79457, '2020-09-15', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79458, '2020-09-16', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79459, '2020-09-17', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79460, '2020-09-18', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79461, '2020-09-19', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79462, '2020-09-20', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79463, '2020-09-21', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79464, '2020-09-22', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79465, '2020-09-23', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79466, '2020-09-24', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79467, '2020-09-25', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79468, '2020-09-26', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79469, '2020-09-27', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79470, '2020-09-28', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79471, '2020-09-29', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79472, '2020-09-30', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79473, '2020-10-01', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79474, '2020-10-02', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79475, '2020-10-03', 'SB', 'Solomon Islands', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79476, '2020-10-04', 'SB', 'Solomon Islands', 'WPRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79477, '2020-10-05', 'SB', 'Solomon Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79478, '2020-10-06', 'SB', 'Solomon Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79479, '2020-10-07', 'SB', 'Solomon Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79480, '2020-10-08', 'SB', 'Solomon Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79481, '2020-10-09', 'SB', 'Solomon Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79482, '2020-10-10', 'SB', 'Solomon Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79483, '2020-10-11', 'SB', 'Solomon Islands', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79484, '2020-10-12', 'SB', 'Solomon Islands', 'WPRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79485, '2020-10-13', 'SB', 'Solomon Islands', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79486, '2020-10-14', 'SB', 'Solomon Islands', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79487, '2020-10-15', 'SB', 'Solomon Islands', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79488, '2020-10-16', 'SB', 'Solomon Islands', 'WPRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79489, '2020-10-17', 'SB', 'Solomon Islands', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79490, '2020-10-18', 'SB', 'Solomon Islands', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79491, '2020-10-19', 'SB', 'Solomon Islands', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79492, '2020-10-20', 'SB', 'Solomon Islands', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79493, '2020-10-21', 'SB', 'Solomon Islands', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79494, '2020-10-22', 'SB', 'Solomon Islands', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79495, '2020-10-23', 'SB', 'Solomon Islands', 'WPRO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79496, '2020-10-24', 'SB', 'Solomon Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79497, '2020-10-25', 'SB', 'Solomon Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79498, '2020-10-26', 'SB', 'Solomon Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79499, '2020-10-27', 'SB', 'Solomon Islands', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79500, '2020-10-28', 'SB', 'Solomon Islands', 'WPRO', '4', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79501, '2020-10-29', 'SB', 'Solomon Islands', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79502, '2020-10-30', 'SB', 'Solomon Islands', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79503, '2020-10-31', 'SB', 'Solomon Islands', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79504, '2020-11-01', 'SB', 'Solomon Islands', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79505, '2020-11-02', 'SB', 'Solomon Islands', 'WPRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79506, '2020-11-03', 'SB', 'Solomon Islands', 'WPRO', '5', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79507, '2020-11-04', 'SB', 'Solomon Islands', 'WPRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79508, '2020-11-05', 'SB', 'Solomon Islands', 'WPRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79509, '2020-11-06', 'SB', 'Solomon Islands', 'WPRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79510, '2020-11-07', 'SB', 'Solomon Islands', 'WPRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79511, '2020-11-08', 'SB', 'Solomon Islands', 'WPRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79512, '2020-11-09', 'SB', 'Solomon Islands', 'WPRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79513, '2020-11-10', 'SB', 'Solomon Islands', 'WPRO', '3', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79514, '2020-11-11', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79515, '2020-11-12', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79516, '2020-11-13', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79517, '2020-11-14', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79518, '2020-11-15', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79519, '2020-11-16', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79520, '2020-11-17', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79521, '2020-11-18', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79522, '2020-11-19', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79523, '2020-11-20', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79524, '2020-11-21', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79525, '2020-11-22', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79526, '2020-11-23', 'SB', 'Solomon Islands', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79527, '2020-11-24', 'SB', 'Solomon Islands', 'WPRO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79528, '2020-11-25', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79529, '2020-11-26', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79530, '2020-11-27', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79531, '2020-11-28', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79532, '2020-11-29', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79533, '2020-11-30', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79534, '2020-12-01', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79535, '2020-12-02', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79536, '2020-12-03', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79537, '2020-12-04', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79538, '2020-12-05', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79539, '2020-12-06', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79540, '2020-12-07', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79541, '2020-12-08', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79542, '2020-12-09', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79543, '2020-12-10', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79544, '2020-12-11', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79545, '2020-12-12', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79546, '2020-12-13', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79547, '2020-12-14', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79548, '2020-12-15', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79549, '2020-12-16', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79550, '2020-12-17', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79551, '2020-12-18', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79552, '2020-12-19', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79553, '2020-12-20', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79554, '2020-12-21', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79555, '2020-12-22', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79556, '2020-12-23', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79557, '2020-12-24', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79558, '2020-12-25', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79559, '2020-12-26', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79560, '2020-12-27', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79561, '2020-12-28', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79562, '2020-12-29', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79563, '2020-12-30', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79564, '2020-12-31', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79565, '2021-01-01', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79566, '2021-01-02', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79567, '2021-01-03', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79568, '2021-01-04', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79569, '2021-01-05', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79570, '2021-01-06', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79571, '2021-01-07', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79572, '2021-01-08', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79573, '2021-01-09', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79574, '2021-01-10', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79575, '2021-01-11', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79576, '2021-01-12', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79577, '2021-01-13', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79578, '2021-01-14', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79579, '2021-01-15', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79580, '2021-01-16', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79581, '2021-01-17', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79582, '2021-01-18', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79583, '2021-01-19', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79584, '2021-01-20', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79585, '2021-01-21', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79586, '2021-01-22', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79587, '2021-01-23', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79588, '2021-01-24', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79589, '2021-01-25', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79590, '2021-01-26', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79591, '2021-01-27', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79592, '2021-01-28', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79593, '2021-01-29', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79594, '2021-01-30', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79595, '2021-01-31', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79596, '2021-02-01', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79597, '2021-02-02', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79598, '2021-02-03', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79599, '2021-02-04', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79600, '2021-02-05', 'SB', 'Solomon Islands', 'WPRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79601, '2020-01-03', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79602, '2020-01-04', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79603, '2020-01-05', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79604, '2020-01-06', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79605, '2020-01-07', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79606, '2020-01-08', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79607, '2020-01-09', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79608, '2020-01-10', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79609, '2020-01-11', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79610, '2020-01-12', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79611, '2020-01-13', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79612, '2020-01-14', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79614, '2020-01-16', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79615, '2020-01-17', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79616, '2020-01-18', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79617, '2020-01-19', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79618, '2020-01-20', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79619, '2020-01-21', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79620, '2020-01-22', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79621, '2020-01-23', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79622, '2020-01-24', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79623, '2020-01-25', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79624, '2020-01-26', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79625, '2020-01-27', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79626, '2020-01-28', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79627, '2020-01-29', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79628, '2020-01-30', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79629, '2020-01-31', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79630, '2020-02-01', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79631, '2020-02-02', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79632, '2020-02-03', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79633, '2020-02-04', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79634, '2020-02-05', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79635, '2020-02-06', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79636, '2020-02-07', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79637, '2020-02-08', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79638, '2020-02-09', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79639, '2020-02-10', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79640, '2020-02-11', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79641, '2020-02-12', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79642, '2020-02-13', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79643, '2020-02-14', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79644, '2020-02-15', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79645, '2020-02-16', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79646, '2020-02-17', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79647, '2020-02-18', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79648, '2020-02-19', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79649, '2020-02-20', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79650, '2020-02-21', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79651, '2020-02-22', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79652, '2020-02-23', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79653, '2020-02-24', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79654, '2020-02-25', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79655, '2020-02-26', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79656, '2020-02-27', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79657, '2020-02-28', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79658, '2020-02-29', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79659, '2020-03-01', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79660, '2020-03-02', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79661, '2020-03-03', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79662, '2020-03-04', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79663, '2020-03-05', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79664, '2020-03-06', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79665, '2020-03-07', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79666, '2020-03-08', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79667, '2020-03-09', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79668, '2020-03-10', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79669, '2020-03-11', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79670, '2020-03-12', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79671, '2020-03-13', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79672, '2020-03-14', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79673, '2020-03-15', 'SO', 'Somalia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79674, '2020-03-16', 'SO', 'Somalia', 'EMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79675, '2020-03-17', 'SO', 'Somalia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79676, '2020-03-18', 'SO', 'Somalia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79677, '2020-03-19', 'SO', 'Somalia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79678, '2020-03-20', 'SO', 'Somalia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79679, '2020-03-21', 'SO', 'Somalia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79680, '2020-03-22', 'SO', 'Somalia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79681, '2020-03-23', 'SO', 'Somalia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79682, '2020-03-24', 'SO', 'Somalia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79683, '2020-03-25', 'SO', 'Somalia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79684, '2020-03-26', 'SO', 'Somalia', 'EMRO', '-3', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79685, '2020-03-27', 'SO', 'Somalia', 'EMRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79686, '2020-03-28', 'SO', 'Somalia', 'EMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79687, '2020-03-29', 'SO', 'Somalia', 'EMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79688, '2020-03-30', 'SO', 'Somalia', 'EMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79689, '2020-03-31', 'SO', 'Somalia', 'EMRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79690, '2020-04-01', 'SO', 'Somalia', 'EMRO', '2', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79691, '2020-04-02', 'SO', 'Somalia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79692, '2020-04-03', 'SO', 'Somalia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79693, '2020-04-04', 'SO', 'Somalia', 'EMRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79694, '2020-04-05', 'SO', 'Somalia', 'EMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79695, '2020-04-06', 'SO', 'Somalia', 'EMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79696, '2020-04-07', 'SO', 'Somalia', 'EMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79697, '2020-04-08', 'SO', 'Somalia', 'EMRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (79698, '2020-04-09', 'SO', 'Somalia', 'EMRO', '4', '12', '1', '1');
INSERT INTO public.who_global_data_import VALUES (79699, '2020-04-10', 'SO', 'Somalia', 'EMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (79700, '2020-04-11', 'SO', 'Somalia', 'EMRO', '9', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (79701, '2020-04-12', 'SO', 'Somalia', 'EMRO', '0', '21', '0', '1');
INSERT INTO public.who_global_data_import VALUES (79702, '2020-04-13', 'SO', 'Somalia', 'EMRO', '4', '25', '1', '2');
INSERT INTO public.who_global_data_import VALUES (79703, '2020-04-14', 'SO', 'Somalia', 'EMRO', '35', '60', '0', '2');
INSERT INTO public.who_global_data_import VALUES (79704, '2020-04-15', 'SO', 'Somalia', 'EMRO', '0', '60', '0', '2');
INSERT INTO public.who_global_data_import VALUES (79705, '2020-04-16', 'SO', 'Somalia', 'EMRO', '20', '80', '3', '5');
INSERT INTO public.who_global_data_import VALUES (79706, '2020-04-17', 'SO', 'Somalia', 'EMRO', '0', '80', '0', '5');
INSERT INTO public.who_global_data_import VALUES (79707, '2020-04-18', 'SO', 'Somalia', 'EMRO', '36', '116', '0', '5');
INSERT INTO public.who_global_data_import VALUES (79708, '2020-04-19', 'SO', 'Somalia', 'EMRO', '19', '135', '2', '7');
INSERT INTO public.who_global_data_import VALUES (79709, '2020-04-20', 'SO', 'Somalia', 'EMRO', '29', '164', '0', '7');
INSERT INTO public.who_global_data_import VALUES (79710, '2020-04-21', 'SO', 'Somalia', 'EMRO', '73', '237', '1', '8');
INSERT INTO public.who_global_data_import VALUES (79711, '2020-04-22', 'SO', 'Somalia', 'EMRO', '49', '286', '6', '14');
INSERT INTO public.who_global_data_import VALUES (79712, '2020-04-23', 'SO', 'Somalia', 'EMRO', '42', '328', '2', '16');
INSERT INTO public.who_global_data_import VALUES (79713, '2020-04-24', 'SO', 'Somalia', 'EMRO', '0', '328', '0', '16');
INSERT INTO public.who_global_data_import VALUES (79714, '2020-04-25', 'SO', 'Somalia', 'EMRO', '62', '390', '2', '18');
INSERT INTO public.who_global_data_import VALUES (79715, '2020-04-26', 'SO', 'Somalia', 'EMRO', '46', '436', '5', '23');
INSERT INTO public.who_global_data_import VALUES (79716, '2020-04-27', 'SO', 'Somalia', 'EMRO', '44', '480', '3', '26');
INSERT INTO public.who_global_data_import VALUES (79717, '2020-04-28', 'SO', 'Somalia', 'EMRO', '48', '528', '2', '28');
INSERT INTO public.who_global_data_import VALUES (79718, '2020-04-29', 'SO', 'Somalia', 'EMRO', '54', '582', '0', '28');
INSERT INTO public.who_global_data_import VALUES (79719, '2020-04-30', 'SO', 'Somalia', 'EMRO', '19', '601', '0', '28');
INSERT INTO public.who_global_data_import VALUES (79720, '2020-05-01', 'SO', 'Somalia', 'EMRO', '0', '601', '0', '28');
INSERT INTO public.who_global_data_import VALUES (79721, '2020-05-02', 'SO', 'Somalia', 'EMRO', '70', '671', '3', '31');
INSERT INTO public.who_global_data_import VALUES (79722, '2020-05-03', 'SO', 'Somalia', 'EMRO', '51', '722', '1', '32');
INSERT INTO public.who_global_data_import VALUES (79723, '2020-05-04', 'SO', 'Somalia', 'EMRO', '34', '756', '3', '35');
INSERT INTO public.who_global_data_import VALUES (79724, '2020-05-05', 'SO', 'Somalia', 'EMRO', '79', '835', '3', '38');
INSERT INTO public.who_global_data_import VALUES (79725, '2020-05-06', 'SO', 'Somalia', 'EMRO', '38', '873', '1', '39');
INSERT INTO public.who_global_data_import VALUES (79726, '2020-05-07', 'SO', 'Somalia', 'EMRO', '55', '928', '5', '44');
INSERT INTO public.who_global_data_import VALUES (79727, '2020-05-08', 'SO', 'Somalia', 'EMRO', '0', '928', '0', '44');
INSERT INTO public.who_global_data_import VALUES (79728, '2020-05-09', 'SO', 'Somalia', 'EMRO', '69', '997', '4', '48');
INSERT INTO public.who_global_data_import VALUES (79729, '2020-05-10', 'SO', 'Somalia', 'EMRO', '57', '1054', '3', '51');
INSERT INTO public.who_global_data_import VALUES (79730, '2020-05-11', 'SO', 'Somalia', 'EMRO', '35', '1089', '1', '52');
INSERT INTO public.who_global_data_import VALUES (79731, '2020-05-12', 'SO', 'Somalia', 'EMRO', '81', '1170', '0', '52');
INSERT INTO public.who_global_data_import VALUES (79732, '2020-05-13', 'SO', 'Somalia', 'EMRO', '49', '1219', '0', '52');
INSERT INTO public.who_global_data_import VALUES (79733, '2020-05-14', 'SO', 'Somalia', 'EMRO', '65', '1284', '1', '53');
INSERT INTO public.who_global_data_import VALUES (79734, '2020-05-15', 'SO', 'Somalia', 'EMRO', '0', '1284', '0', '53');
INSERT INTO public.who_global_data_import VALUES (79735, '2020-05-16', 'SO', 'Somalia', 'EMRO', '73', '1357', '2', '55');
INSERT INTO public.who_global_data_import VALUES (79736, '2020-05-17', 'SO', 'Somalia', 'EMRO', '64', '1421', '1', '56');
INSERT INTO public.who_global_data_import VALUES (79737, '2020-05-18', 'SO', 'Somalia', 'EMRO', '34', '1455', '1', '57');
INSERT INTO public.who_global_data_import VALUES (79738, '2020-05-19', 'SO', 'Somalia', 'EMRO', '47', '1502', '2', '59');
INSERT INTO public.who_global_data_import VALUES (79739, '2020-05-20', 'SO', 'Somalia', 'EMRO', '71', '1573', '2', '61');
INSERT INTO public.who_global_data_import VALUES (79740, '2020-05-21', 'SO', 'Somalia', 'EMRO', '21', '1594', '0', '61');
INSERT INTO public.who_global_data_import VALUES (79741, '2020-05-22', 'SO', 'Somalia', 'EMRO', '0', '1594', '0', '61');
INSERT INTO public.who_global_data_import VALUES (79742, '2020-05-23', 'SO', 'Somalia', 'EMRO', '0', '1594', '0', '61');
INSERT INTO public.who_global_data_import VALUES (79743, '2020-05-24', 'SO', 'Somalia', 'EMRO', '0', '1594', '0', '61');
INSERT INTO public.who_global_data_import VALUES (79744, '2020-05-25', 'SO', 'Somalia', 'EMRO', '0', '1594', '0', '61');
INSERT INTO public.who_global_data_import VALUES (79745, '2020-05-26', 'SO', 'Somalia', 'EMRO', '95', '1689', '5', '66');
INSERT INTO public.who_global_data_import VALUES (79746, '2020-05-27', 'SO', 'Somalia', 'EMRO', '22', '1711', '1', '67');
INSERT INTO public.who_global_data_import VALUES (79747, '2020-05-28', 'SO', 'Somalia', 'EMRO', '20', '1731', '0', '67');
INSERT INTO public.who_global_data_import VALUES (79748, '2020-05-29', 'SO', 'Somalia', 'EMRO', '97', '1828', '5', '72');
INSERT INTO public.who_global_data_import VALUES (79749, '2020-05-30', 'SO', 'Somalia', 'EMRO', '0', '1828', '0', '72');
INSERT INTO public.who_global_data_import VALUES (79750, '2020-05-31', 'SO', 'Somalia', 'EMRO', '88', '1916', '1', '73');
INSERT INTO public.who_global_data_import VALUES (79751, '2020-06-01', 'SO', 'Somalia', 'EMRO', '60', '1976', '5', '78');
INSERT INTO public.who_global_data_import VALUES (79752, '2020-06-02', 'SO', 'Somalia', 'EMRO', '47', '2023', '1', '79');
INSERT INTO public.who_global_data_import VALUES (79753, '2020-06-03', 'SO', 'Somalia', 'EMRO', '66', '2089', '0', '79');
INSERT INTO public.who_global_data_import VALUES (79754, '2020-06-04', 'SO', 'Somalia', 'EMRO', '57', '2146', '0', '79');
INSERT INTO public.who_global_data_import VALUES (79755, '2020-06-05', 'SO', 'Somalia', 'EMRO', '58', '2204', '0', '79');
INSERT INTO public.who_global_data_import VALUES (79756, '2020-06-06', 'SO', 'Somalia', 'EMRO', '0', '2204', '0', '79');
INSERT INTO public.who_global_data_import VALUES (79757, '2020-06-07', 'SO', 'Somalia', 'EMRO', '85', '2289', '3', '82');
INSERT INTO public.who_global_data_import VALUES (79758, '2020-06-08', 'SO', 'Somalia', 'EMRO', '45', '2334', '1', '83');
INSERT INTO public.who_global_data_import VALUES (79759, '2020-06-09', 'SO', 'Somalia', 'EMRO', '34', '2368', '1', '84');
INSERT INTO public.who_global_data_import VALUES (79760, '2020-06-10', 'SO', 'Somalia', 'EMRO', '48', '2416', '1', '85');
INSERT INTO public.who_global_data_import VALUES (79761, '2020-06-11', 'SO', 'Somalia', 'EMRO', '36', '2452', '0', '85');
INSERT INTO public.who_global_data_import VALUES (79762, '2020-06-12', 'SO', 'Somalia', 'EMRO', '61', '2513', '0', '85');
INSERT INTO public.who_global_data_import VALUES (79763, '2020-06-13', 'SO', 'Somalia', 'EMRO', '0', '2513', '0', '85');
INSERT INTO public.who_global_data_import VALUES (79764, '2020-06-14', 'SO', 'Somalia', 'EMRO', '66', '2579', '2', '87');
INSERT INTO public.who_global_data_import VALUES (79765, '2020-06-15', 'SO', 'Somalia', 'EMRO', '24', '2603', '1', '88');
INSERT INTO public.who_global_data_import VALUES (79766, '2020-06-16', 'SO', 'Somalia', 'EMRO', '39', '2642', '0', '88');
INSERT INTO public.who_global_data_import VALUES (79767, '2020-06-17', 'SO', 'Somalia', 'EMRO', '16', '2658', '0', '88');
INSERT INTO public.who_global_data_import VALUES (79768, '2020-06-18', 'SO', 'Somalia', 'EMRO', '38', '2696', '0', '88');
INSERT INTO public.who_global_data_import VALUES (79769, '2020-06-19', 'SO', 'Somalia', 'EMRO', '23', '2719', '0', '88');
INSERT INTO public.who_global_data_import VALUES (79770, '2020-06-20', 'SO', 'Somalia', 'EMRO', '0', '2719', '0', '88');
INSERT INTO public.who_global_data_import VALUES (79771, '2020-06-21', 'SO', 'Somalia', 'EMRO', '36', '2755', '0', '88');
INSERT INTO public.who_global_data_import VALUES (79772, '2020-06-22', 'SO', 'Somalia', 'EMRO', '24', '2779', '2', '90');
INSERT INTO public.who_global_data_import VALUES (79773, '2020-06-23', 'SO', 'Somalia', 'EMRO', '33', '2812', '0', '90');
INSERT INTO public.who_global_data_import VALUES (79774, '2020-06-24', 'SO', 'Somalia', 'EMRO', '23', '2835', '0', '90');
INSERT INTO public.who_global_data_import VALUES (79775, '2020-06-25', 'SO', 'Somalia', 'EMRO', '25', '2860', '0', '90');
INSERT INTO public.who_global_data_import VALUES (79776, '2020-06-26', 'SO', 'Somalia', 'EMRO', '18', '2878', '0', '90');
INSERT INTO public.who_global_data_import VALUES (79777, '2020-06-27', 'SO', 'Somalia', 'EMRO', '0', '2878', '0', '90');
INSERT INTO public.who_global_data_import VALUES (79778, '2020-06-28', 'SO', 'Somalia', 'EMRO', '0', '2878', '0', '90');
INSERT INTO public.who_global_data_import VALUES (79779, '2020-06-29', 'SO', 'Somalia', 'EMRO', '16', '2894', '0', '90');
INSERT INTO public.who_global_data_import VALUES (79780, '2020-06-30', 'SO', 'Somalia', 'EMRO', '10', '2904', '0', '90');
INSERT INTO public.who_global_data_import VALUES (79781, '2020-07-01', 'SO', 'Somalia', 'EMRO', '20', '2924', '0', '90');
INSERT INTO public.who_global_data_import VALUES (79782, '2020-07-02', 'SO', 'Somalia', 'EMRO', '0', '2924', '0', '90');
INSERT INTO public.who_global_data_import VALUES (79783, '2020-07-03', 'SO', 'Somalia', 'EMRO', '20', '2944', '0', '90');
INSERT INTO public.who_global_data_import VALUES (79784, '2020-07-04', 'SO', 'Somalia', 'EMRO', '0', '2944', '0', '90');
INSERT INTO public.who_global_data_import VALUES (79785, '2020-07-05', 'SO', 'Somalia', 'EMRO', '17', '2961', '2', '92');
INSERT INTO public.who_global_data_import VALUES (79786, '2020-07-06', 'SO', 'Somalia', 'EMRO', '36', '2997', '0', '92');
INSERT INTO public.who_global_data_import VALUES (79787, '2020-07-07', 'SO', 'Somalia', 'EMRO', '9', '3006', '0', '92');
INSERT INTO public.who_global_data_import VALUES (79788, '2020-07-08', 'SO', 'Somalia', 'EMRO', '9', '3015', '0', '92');
INSERT INTO public.who_global_data_import VALUES (79789, '2020-07-09', 'SO', 'Somalia', 'EMRO', '13', '3028', '0', '92');
INSERT INTO public.who_global_data_import VALUES (79790, '2020-07-10', 'SO', 'Somalia', 'EMRO', '10', '3038', '0', '92');
INSERT INTO public.who_global_data_import VALUES (79791, '2020-07-11', 'SO', 'Somalia', 'EMRO', '0', '3038', '0', '92');
INSERT INTO public.who_global_data_import VALUES (79792, '2020-07-12', 'SO', 'Somalia', 'EMRO', '13', '3051', '0', '92');
INSERT INTO public.who_global_data_import VALUES (79793, '2020-07-13', 'SO', 'Somalia', 'EMRO', '8', '3059', '1', '93');
INSERT INTO public.who_global_data_import VALUES (79794, '2020-07-14', 'SO', 'Somalia', 'EMRO', '13', '3072', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79795, '2020-07-15', 'SO', 'Somalia', 'EMRO', '4', '3076', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79796, '2020-07-16', 'SO', 'Somalia', 'EMRO', '7', '3083', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79797, '2020-07-17', 'SO', 'Somalia', 'EMRO', '23', '3106', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79798, '2020-07-18', 'SO', 'Somalia', 'EMRO', '0', '3106', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79799, '2020-07-19', 'SO', 'Somalia', 'EMRO', '5', '3111', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79800, '2020-07-20', 'SO', 'Somalia', 'EMRO', '8', '3119', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79801, '2020-07-21', 'SO', 'Somalia', 'EMRO', '11', '3130', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79802, '2020-07-22', 'SO', 'Somalia', 'EMRO', '5', '3135', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79803, '2020-07-23', 'SO', 'Somalia', 'EMRO', '26', '3161', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79804, '2020-07-24', 'SO', 'Somalia', 'EMRO', '10', '3171', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79805, '2020-07-25', 'SO', 'Somalia', 'EMRO', '0', '3171', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79806, '2020-07-26', 'SO', 'Somalia', 'EMRO', '7', '3178', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79807, '2020-07-27', 'SO', 'Somalia', 'EMRO', '0', '3178', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79808, '2020-07-28', 'SO', 'Somalia', 'EMRO', '18', '3196', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79809, '2020-07-29', 'SO', 'Somalia', 'EMRO', '16', '3212', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79810, '2020-07-30', 'SO', 'Somalia', 'EMRO', '0', '3212', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79811, '2020-07-31', 'SO', 'Somalia', 'EMRO', '0', '3212', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79812, '2020-08-01', 'SO', 'Somalia', 'EMRO', '0', '3212', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79813, '2020-08-02', 'SO', 'Somalia', 'EMRO', '0', '3212', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79814, '2020-08-03', 'SO', 'Somalia', 'EMRO', '8', '3220', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79815, '2020-08-04', 'SO', 'Somalia', 'EMRO', '0', '3220', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79816, '2020-08-05', 'SO', 'Somalia', 'EMRO', '0', '3220', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79817, '2020-08-06', 'SO', 'Somalia', 'EMRO', '7', '3227', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79818, '2020-08-07', 'SO', 'Somalia', 'EMRO', '0', '3227', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79819, '2020-08-08', 'SO', 'Somalia', 'EMRO', '0', '3227', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79820, '2020-08-09', 'SO', 'Somalia', 'EMRO', '0', '3227', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79821, '2020-08-10', 'SO', 'Somalia', 'EMRO', '0', '3227', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79822, '2020-08-11', 'SO', 'Somalia', 'EMRO', '0', '3227', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79823, '2020-08-12', 'SO', 'Somalia', 'EMRO', '0', '3227', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79824, '2020-08-13', 'SO', 'Somalia', 'EMRO', '0', '3227', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79825, '2020-08-14', 'SO', 'Somalia', 'EMRO', '0', '3227', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79826, '2020-08-15', 'SO', 'Somalia', 'EMRO', '23', '3250', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79827, '2020-08-16', 'SO', 'Somalia', 'EMRO', '6', '3256', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79828, '2020-08-17', 'SO', 'Somalia', 'EMRO', '0', '3256', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79829, '2020-08-18', 'SO', 'Somalia', 'EMRO', '1', '3257', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79830, '2020-08-19', 'SO', 'Somalia', 'EMRO', '0', '3257', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79831, '2020-08-20', 'SO', 'Somalia', 'EMRO', '8', '3265', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79832, '2020-08-21', 'SO', 'Somalia', 'EMRO', '0', '3265', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79833, '2020-08-22', 'SO', 'Somalia', 'EMRO', '0', '3265', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79834, '2020-08-23', 'SO', 'Somalia', 'EMRO', '4', '3269', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79835, '2020-08-24', 'SO', 'Somalia', 'EMRO', '0', '3269', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79836, '2020-08-25', 'SO', 'Somalia', 'EMRO', '0', '3269', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79837, '2020-08-26', 'SO', 'Somalia', 'EMRO', '0', '3269', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79838, '2020-08-27', 'SO', 'Somalia', 'EMRO', '0', '3269', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79839, '2020-08-28', 'SO', 'Somalia', 'EMRO', '0', '3269', '0', '93');
INSERT INTO public.who_global_data_import VALUES (79840, '2020-08-29', 'SO', 'Somalia', 'EMRO', '6', '3275', '2', '95');
INSERT INTO public.who_global_data_import VALUES (79841, '2020-08-30', 'SO', 'Somalia', 'EMRO', '35', '3310', '2', '97');
INSERT INTO public.who_global_data_import VALUES (79842, '2020-08-31', 'SO', 'Somalia', 'EMRO', '0', '3310', '0', '97');
INSERT INTO public.who_global_data_import VALUES (79843, '2020-09-01', 'SO', 'Somalia', 'EMRO', '0', '3310', '0', '97');
INSERT INTO public.who_global_data_import VALUES (79844, '2020-09-02', 'SO', 'Somalia', 'EMRO', '0', '3310', '0', '97');
INSERT INTO public.who_global_data_import VALUES (79845, '2020-09-03', 'SO', 'Somalia', 'EMRO', '0', '3310', '0', '97');
INSERT INTO public.who_global_data_import VALUES (79846, '2020-09-04', 'SO', 'Somalia', 'EMRO', '0', '3310', '0', '97');
INSERT INTO public.who_global_data_import VALUES (79847, '2020-09-05', 'SO', 'Somalia', 'EMRO', '22', '3332', '0', '97');
INSERT INTO public.who_global_data_import VALUES (79848, '2020-09-06', 'SO', 'Somalia', 'EMRO', '30', '3362', '0', '97');
INSERT INTO public.who_global_data_import VALUES (79849, '2020-09-07', 'SO', 'Somalia', 'EMRO', '0', '3362', '0', '97');
INSERT INTO public.who_global_data_import VALUES (79850, '2020-09-08', 'SO', 'Somalia', 'EMRO', '0', '3362', '0', '97');
INSERT INTO public.who_global_data_import VALUES (79851, '2020-09-09', 'SO', 'Somalia', 'EMRO', '0', '3362', '0', '97');
INSERT INTO public.who_global_data_import VALUES (79852, '2020-09-10', 'SO', 'Somalia', 'EMRO', '9', '3371', '0', '97');
INSERT INTO public.who_global_data_import VALUES (79853, '2020-09-11', 'SO', 'Somalia', 'EMRO', '5', '3376', '1', '98');
INSERT INTO public.who_global_data_import VALUES (79854, '2020-09-12', 'SO', 'Somalia', 'EMRO', '0', '3376', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79855, '2020-09-13', 'SO', 'Somalia', 'EMRO', '0', '3376', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79856, '2020-09-14', 'SO', 'Somalia', 'EMRO', '13', '3389', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79857, '2020-09-15', 'SO', 'Somalia', 'EMRO', '0', '3389', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79858, '2020-09-16', 'SO', 'Somalia', 'EMRO', '1', '3390', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79859, '2020-09-17', 'SO', 'Somalia', 'EMRO', '0', '3390', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79860, '2020-09-18', 'SO', 'Somalia', 'EMRO', '0', '3390', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79861, '2020-09-19', 'SO', 'Somalia', 'EMRO', '0', '3390', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79862, '2020-09-20', 'SO', 'Somalia', 'EMRO', '11', '3401', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79863, '2020-09-21', 'SO', 'Somalia', 'EMRO', '41', '3442', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79864, '2020-09-22', 'SO', 'Somalia', 'EMRO', '23', '3465', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79865, '2020-09-23', 'SO', 'Somalia', 'EMRO', '0', '3465', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79866, '2020-09-24', 'SO', 'Somalia', 'EMRO', '0', '3465', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79867, '2020-09-25', 'SO', 'Somalia', 'EMRO', '0', '3465', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79868, '2020-09-26', 'SO', 'Somalia', 'EMRO', '0', '3465', '0', '98');
INSERT INTO public.who_global_data_import VALUES (79869, '2020-09-27', 'SO', 'Somalia', 'EMRO', '123', '3588', '1', '99');
INSERT INTO public.who_global_data_import VALUES (79870, '2020-09-28', 'SO', 'Somalia', 'EMRO', '0', '3588', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79871, '2020-09-29', 'SO', 'Somalia', 'EMRO', '0', '3588', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79872, '2020-09-30', 'SO', 'Somalia', 'EMRO', '0', '3588', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79873, '2020-10-01', 'SO', 'Somalia', 'EMRO', '0', '3588', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79874, '2020-10-02', 'SO', 'Somalia', 'EMRO', '5', '3593', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79875, '2020-10-03', 'SO', 'Somalia', 'EMRO', '0', '3593', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79876, '2020-10-04', 'SO', 'Somalia', 'EMRO', '0', '3593', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79877, '2020-10-05', 'SO', 'Somalia', 'EMRO', '152', '3745', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79878, '2020-10-06', 'SO', 'Somalia', 'EMRO', '0', '3745', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79879, '2020-10-07', 'SO', 'Somalia', 'EMRO', '0', '3745', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79880, '2020-10-08', 'SO', 'Somalia', 'EMRO', '0', '3745', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79881, '2020-10-09', 'SO', 'Somalia', 'EMRO', '0', '3745', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79882, '2020-10-10', 'SO', 'Somalia', 'EMRO', '0', '3745', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79883, '2020-10-11', 'SO', 'Somalia', 'EMRO', '102', '3847', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79884, '2020-10-12', 'SO', 'Somalia', 'EMRO', '17', '3864', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79885, '2020-10-13', 'SO', 'Somalia', 'EMRO', '0', '3864', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79886, '2020-10-14', 'SO', 'Somalia', 'EMRO', '0', '3864', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79887, '2020-10-15', 'SO', 'Somalia', 'EMRO', '0', '3864', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79888, '2020-10-16', 'SO', 'Somalia', 'EMRO', '0', '3864', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79889, '2020-10-17', 'SO', 'Somalia', 'EMRO', '0', '3864', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79890, '2020-10-18', 'SO', 'Somalia', 'EMRO', '0', '3864', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79891, '2020-10-19', 'SO', 'Somalia', 'EMRO', '0', '3864', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79892, '2020-10-20', 'SO', 'Somalia', 'EMRO', '0', '3864', '0', '99');
INSERT INTO public.who_global_data_import VALUES (79893, '2020-10-21', 'SO', 'Somalia', 'EMRO', '26', '3890', '2', '101');
INSERT INTO public.who_global_data_import VALUES (79894, '2020-10-22', 'SO', 'Somalia', 'EMRO', '0', '3890', '0', '101');
INSERT INTO public.who_global_data_import VALUES (79895, '2020-10-23', 'SO', 'Somalia', 'EMRO', '7', '3897', '1', '102');
INSERT INTO public.who_global_data_import VALUES (79896, '2020-10-24', 'SO', 'Somalia', 'EMRO', '0', '3897', '0', '102');
INSERT INTO public.who_global_data_import VALUES (79897, '2020-10-25', 'SO', 'Somalia', 'EMRO', '0', '3897', '0', '102');
INSERT INTO public.who_global_data_import VALUES (79898, '2020-10-26', 'SO', 'Somalia', 'EMRO', '44', '3941', '2', '104');
INSERT INTO public.who_global_data_import VALUES (79899, '2020-10-27', 'SO', 'Somalia', 'EMRO', '0', '3941', '0', '104');
INSERT INTO public.who_global_data_import VALUES (79900, '2020-10-28', 'SO', 'Somalia', 'EMRO', '0', '3941', '0', '104');
INSERT INTO public.who_global_data_import VALUES (79901, '2020-10-29', 'SO', 'Somalia', 'EMRO', '0', '3941', '0', '104');
INSERT INTO public.who_global_data_import VALUES (79902, '2020-10-30', 'SO', 'Somalia', 'EMRO', '0', '3941', '0', '104');
INSERT INTO public.who_global_data_import VALUES (79903, '2020-10-31', 'SO', 'Somalia', 'EMRO', '0', '3941', '0', '104');
INSERT INTO public.who_global_data_import VALUES (79904, '2020-11-01', 'SO', 'Somalia', 'EMRO', '0', '3941', '0', '104');
INSERT INTO public.who_global_data_import VALUES (79905, '2020-11-02', 'SO', 'Somalia', 'EMRO', '0', '3941', '0', '104');
INSERT INTO public.who_global_data_import VALUES (79906, '2020-11-03', 'SO', 'Somalia', 'EMRO', '0', '3941', '0', '104');
INSERT INTO public.who_global_data_import VALUES (79907, '2020-11-04', 'SO', 'Somalia', 'EMRO', '288', '4229', '3', '107');
INSERT INTO public.who_global_data_import VALUES (79908, '2020-11-05', 'SO', 'Somalia', 'EMRO', '0', '4229', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79909, '2020-11-06', 'SO', 'Somalia', 'EMRO', '0', '4229', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79910, '2020-11-07', 'SO', 'Somalia', 'EMRO', '0', '4229', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79911, '2020-11-08', 'SO', 'Somalia', 'EMRO', '0', '4229', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79912, '2020-11-09', 'SO', 'Somalia', 'EMRO', '0', '4229', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79913, '2020-11-10', 'SO', 'Somalia', 'EMRO', '72', '4301', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79914, '2020-11-11', 'SO', 'Somalia', 'EMRO', '0', '4301', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79915, '2020-11-12', 'SO', 'Somalia', 'EMRO', '0', '4301', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79916, '2020-11-13', 'SO', 'Somalia', 'EMRO', '0', '4301', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79917, '2020-11-14', 'SO', 'Somalia', 'EMRO', '0', '4301', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79918, '2020-11-15', 'SO', 'Somalia', 'EMRO', '0', '4301', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79919, '2020-11-16', 'SO', 'Somalia', 'EMRO', '0', '4301', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79920, '2020-11-17', 'SO', 'Somalia', 'EMRO', '0', '4301', '0', '107');
INSERT INTO public.who_global_data_import VALUES (79921, '2020-11-18', 'SO', 'Somalia', 'EMRO', '81', '4382', '1', '108');
INSERT INTO public.who_global_data_import VALUES (79922, '2020-11-19', 'SO', 'Somalia', 'EMRO', '0', '4382', '0', '108');
INSERT INTO public.who_global_data_import VALUES (79923, '2020-11-20', 'SO', 'Somalia', 'EMRO', '0', '4382', '0', '108');
INSERT INTO public.who_global_data_import VALUES (79924, '2020-11-21', 'SO', 'Somalia', 'EMRO', '0', '4382', '0', '108');
INSERT INTO public.who_global_data_import VALUES (79925, '2020-11-22', 'SO', 'Somalia', 'EMRO', '0', '4382', '0', '108');
INSERT INTO public.who_global_data_import VALUES (79926, '2020-11-23', 'SO', 'Somalia', 'EMRO', '63', '4445', '5', '113');
INSERT INTO public.who_global_data_import VALUES (79927, '2020-11-24', 'SO', 'Somalia', 'EMRO', '0', '4445', '0', '113');
INSERT INTO public.who_global_data_import VALUES (79928, '2020-11-25', 'SO', 'Somalia', 'EMRO', '0', '4445', '0', '113');
INSERT INTO public.who_global_data_import VALUES (79929, '2020-11-26', 'SO', 'Somalia', 'EMRO', '0', '4445', '0', '113');
INSERT INTO public.who_global_data_import VALUES (79930, '2020-11-27', 'SO', 'Somalia', 'EMRO', '6', '4451', '0', '113');
INSERT INTO public.who_global_data_import VALUES (79931, '2020-11-28', 'SO', 'Somalia', 'EMRO', '0', '4451', '0', '113');
INSERT INTO public.who_global_data_import VALUES (79932, '2020-11-29', 'SO', 'Somalia', 'EMRO', '0', '4451', '0', '113');
INSERT INTO public.who_global_data_import VALUES (79933, '2020-11-30', 'SO', 'Somalia', 'EMRO', '0', '4451', '0', '113');
INSERT INTO public.who_global_data_import VALUES (79934, '2020-12-01', 'SO', 'Somalia', 'EMRO', '0', '4451', '0', '113');
INSERT INTO public.who_global_data_import VALUES (79935, '2020-12-02', 'SO', 'Somalia', 'EMRO', '0', '4451', '0', '113');
INSERT INTO public.who_global_data_import VALUES (79936, '2020-12-03', 'SO', 'Somalia', 'EMRO', '74', '4525', '8', '121');
INSERT INTO public.who_global_data_import VALUES (79937, '2020-12-04', 'SO', 'Somalia', 'EMRO', '0', '4525', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79938, '2020-12-05', 'SO', 'Somalia', 'EMRO', '0', '4525', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79939, '2020-12-06', 'SO', 'Somalia', 'EMRO', '0', '4525', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79940, '2020-12-07', 'SO', 'Somalia', 'EMRO', '0', '4525', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79941, '2020-12-08', 'SO', 'Somalia', 'EMRO', '54', '4579', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79942, '2020-12-09', 'SO', 'Somalia', 'EMRO', '0', '4579', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79943, '2020-12-10', 'SO', 'Somalia', 'EMRO', '0', '4579', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79944, '2020-12-11', 'SO', 'Somalia', 'EMRO', '0', '4579', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79945, '2020-12-12', 'SO', 'Somalia', 'EMRO', '0', '4579', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79946, '2020-12-13', 'SO', 'Somalia', 'EMRO', '0', '4579', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79947, '2020-12-14', 'SO', 'Somalia', 'EMRO', '0', '4579', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79948, '2020-12-15', 'SO', 'Somalia', 'EMRO', '0', '4579', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79949, '2020-12-16', 'SO', 'Somalia', 'EMRO', '0', '4579', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79950, '2020-12-17', 'SO', 'Somalia', 'EMRO', '0', '4579', '0', '121');
INSERT INTO public.who_global_data_import VALUES (79951, '2020-12-18', 'SO', 'Somalia', 'EMRO', '83', '4662', '3', '124');
INSERT INTO public.who_global_data_import VALUES (79952, '2020-12-19', 'SO', 'Somalia', 'EMRO', '0', '4662', '0', '124');
INSERT INTO public.who_global_data_import VALUES (79953, '2020-12-20', 'SO', 'Somalia', 'EMRO', '0', '4662', '0', '124');
INSERT INTO public.who_global_data_import VALUES (79954, '2020-12-21', 'SO', 'Somalia', 'EMRO', '0', '4662', '0', '124');
INSERT INTO public.who_global_data_import VALUES (79955, '2020-12-22', 'SO', 'Somalia', 'EMRO', '0', '4662', '0', '124');
INSERT INTO public.who_global_data_import VALUES (79956, '2020-12-23', 'SO', 'Somalia', 'EMRO', '28', '4690', '3', '127');
INSERT INTO public.who_global_data_import VALUES (79957, '2020-12-24', 'SO', 'Somalia', 'EMRO', '0', '4690', '0', '127');
INSERT INTO public.who_global_data_import VALUES (79958, '2020-12-25', 'SO', 'Somalia', 'EMRO', '0', '4690', '0', '127');
INSERT INTO public.who_global_data_import VALUES (79959, '2020-12-26', 'SO', 'Somalia', 'EMRO', '0', '4690', '0', '127');
INSERT INTO public.who_global_data_import VALUES (79960, '2020-12-27', 'SO', 'Somalia', 'EMRO', '0', '4690', '0', '127');
INSERT INTO public.who_global_data_import VALUES (79961, '2020-12-28', 'SO', 'Somalia', 'EMRO', '0', '4690', '0', '127');
INSERT INTO public.who_global_data_import VALUES (79962, '2020-12-29', 'SO', 'Somalia', 'EMRO', '0', '4690', '0', '127');
INSERT INTO public.who_global_data_import VALUES (79963, '2020-12-30', 'SO', 'Somalia', 'EMRO', '0', '4690', '0', '127');
INSERT INTO public.who_global_data_import VALUES (79964, '2020-12-31', 'SO', 'Somalia', 'EMRO', '24', '4714', '3', '130');
INSERT INTO public.who_global_data_import VALUES (79965, '2021-01-01', 'SO', 'Somalia', 'EMRO', '0', '4714', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79966, '2021-01-02', 'SO', 'Somalia', 'EMRO', '0', '4714', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79967, '2021-01-03', 'SO', 'Somalia', 'EMRO', '0', '4714', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79968, '2021-01-04', 'SO', 'Somalia', 'EMRO', '0', '4714', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79969, '2021-01-05', 'SO', 'Somalia', 'EMRO', '0', '4714', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79970, '2021-01-06', 'SO', 'Somalia', 'EMRO', '0', '4714', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79971, '2021-01-07', 'SO', 'Somalia', 'EMRO', '12', '4726', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79972, '2021-01-08', 'SO', 'Somalia', 'EMRO', '0', '4726', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79973, '2021-01-09', 'SO', 'Somalia', 'EMRO', '0', '4726', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79974, '2021-01-10', 'SO', 'Somalia', 'EMRO', '0', '4726', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79975, '2021-01-11', 'SO', 'Somalia', 'EMRO', '0', '4726', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79976, '2021-01-12', 'SO', 'Somalia', 'EMRO', '0', '4726', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79977, '2021-01-13', 'SO', 'Somalia', 'EMRO', '0', '4726', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79978, '2021-01-14', 'SO', 'Somalia', 'EMRO', '0', '4726', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79979, '2021-01-15', 'SO', 'Somalia', 'EMRO', '18', '4744', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79980, '2021-01-16', 'SO', 'Somalia', 'EMRO', '0', '4744', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79981, '2021-01-17', 'SO', 'Somalia', 'EMRO', '0', '4744', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79982, '2021-01-18', 'SO', 'Somalia', 'EMRO', '0', '4744', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79983, '2021-01-19', 'SO', 'Somalia', 'EMRO', '0', '4744', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79984, '2021-01-20', 'SO', 'Somalia', 'EMRO', '0', '4744', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79985, '2021-01-21', 'SO', 'Somalia', 'EMRO', '0', '4744', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79986, '2021-01-22', 'SO', 'Somalia', 'EMRO', '0', '4744', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79987, '2021-01-23', 'SO', 'Somalia', 'EMRO', '0', '4744', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79988, '2021-01-24', 'SO', 'Somalia', 'EMRO', '10', '4754', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79989, '2021-01-25', 'SO', 'Somalia', 'EMRO', '0', '4754', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79990, '2021-01-26', 'SO', 'Somalia', 'EMRO', '0', '4754', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79991, '2021-01-27', 'SO', 'Somalia', 'EMRO', '30', '4784', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79992, '2021-01-28', 'SO', 'Somalia', 'EMRO', '0', '4784', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79993, '2021-01-29', 'SO', 'Somalia', 'EMRO', '0', '4784', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79994, '2021-01-30', 'SO', 'Somalia', 'EMRO', '0', '4784', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79995, '2021-01-31', 'SO', 'Somalia', 'EMRO', '0', '4784', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79996, '2021-02-01', 'SO', 'Somalia', 'EMRO', '0', '4784', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79997, '2021-02-02', 'SO', 'Somalia', 'EMRO', '0', '4784', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79998, '2021-02-03', 'SO', 'Somalia', 'EMRO', '0', '4784', '0', '130');
INSERT INTO public.who_global_data_import VALUES (79999, '2021-02-04', 'SO', 'Somalia', 'EMRO', '30', '4814', '2', '132');
INSERT INTO public.who_global_data_import VALUES (80000, '2021-02-05', 'SO', 'Somalia', 'EMRO', '0', '4814', '0', '132');
INSERT INTO public.who_global_data_import VALUES (80001, '2020-01-03', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80002, '2020-01-04', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80003, '2020-01-05', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80004, '2020-01-06', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80005, '2020-01-07', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80006, '2020-01-08', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80007, '2020-01-09', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80008, '2020-01-10', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80009, '2020-01-11', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80010, '2020-01-12', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80011, '2020-01-13', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80012, '2020-01-14', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80013, '2020-01-15', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80014, '2020-01-16', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80015, '2020-01-17', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80016, '2020-01-18', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80017, '2020-01-19', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80018, '2020-01-20', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80019, '2020-01-21', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80020, '2020-01-22', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80021, '2020-01-23', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80022, '2020-01-24', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80023, '2020-01-25', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80024, '2020-01-26', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80025, '2020-01-27', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80026, '2020-01-28', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80027, '2020-01-29', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80028, '2020-01-30', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80029, '2020-01-31', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80030, '2020-02-01', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80031, '2020-02-02', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80032, '2020-02-03', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80033, '2020-02-04', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80034, '2020-02-05', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80035, '2020-02-06', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80036, '2020-02-07', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80037, '2020-02-08', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80038, '2020-02-09', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80039, '2020-02-10', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80040, '2020-02-11', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80041, '2020-02-12', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80042, '2020-02-13', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80043, '2020-02-14', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80044, '2020-02-15', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80045, '2020-02-16', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80046, '2020-02-17', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80047, '2020-02-18', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80048, '2020-02-19', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80049, '2020-02-20', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80050, '2020-02-21', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80051, '2020-02-22', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80052, '2020-02-23', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80053, '2020-02-24', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80054, '2020-02-25', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80055, '2020-02-26', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80056, '2020-02-27', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80057, '2020-02-28', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80058, '2020-02-29', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80059, '2020-03-01', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80060, '2020-03-02', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80061, '2020-03-03', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80062, '2020-03-04', 'ZA', 'South Africa', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80063, '2020-03-05', 'ZA', 'South Africa', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80064, '2020-03-06', 'ZA', 'South Africa', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80065, '2020-03-07', 'ZA', 'South Africa', 'AFRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80066, '2020-03-08', 'ZA', 'South Africa', 'AFRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80067, '2020-03-09', 'ZA', 'South Africa', 'AFRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80068, '2020-03-10', 'ZA', 'South Africa', 'AFRO', '4', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80069, '2020-03-11', 'ZA', 'South Africa', 'AFRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80070, '2020-03-12', 'ZA', 'South Africa', 'AFRO', '10', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80071, '2020-03-13', 'ZA', 'South Africa', 'AFRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80072, '2020-03-14', 'ZA', 'South Africa', 'AFRO', '21', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80073, '2020-03-15', 'ZA', 'South Africa', 'AFRO', '0', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80074, '2020-03-16', 'ZA', 'South Africa', 'AFRO', '13', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80075, '2020-03-17', 'ZA', 'South Africa', 'AFRO', '11', '66', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80076, '2020-03-18', 'ZA', 'South Africa', 'AFRO', '54', '120', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80077, '2020-03-19', 'ZA', 'South Africa', 'AFRO', '34', '154', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80078, '2020-03-20', 'ZA', 'South Africa', 'AFRO', '51', '205', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80079, '2020-03-21', 'ZA', 'South Africa', 'AFRO', '35', '240', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80080, '2020-03-22', 'ZA', 'South Africa', 'AFRO', '0', '240', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80081, '2020-03-23', 'ZA', 'South Africa', 'AFRO', '34', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80082, '2020-03-24', 'ZA', 'South Africa', 'AFRO', '128', '402', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80083, '2020-03-25', 'ZA', 'South Africa', 'AFRO', '152', '554', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80084, '2020-03-26', 'ZA', 'South Africa', 'AFRO', '373', '927', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80085, '2020-03-27', 'ZA', 'South Africa', 'AFRO', '0', '927', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80086, '2020-03-28', 'ZA', 'South Africa', 'AFRO', '243', '1170', '1', '1');
INSERT INTO public.who_global_data_import VALUES (80087, '2020-03-29', 'ZA', 'South Africa', 'AFRO', '17', '1187', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80088, '2020-03-30', 'ZA', 'South Africa', 'AFRO', '93', '1280', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80089, '2020-03-31', 'ZA', 'South Africa', 'AFRO', '46', '1326', '2', '3');
INSERT INTO public.who_global_data_import VALUES (80090, '2020-04-01', 'ZA', 'South Africa', 'AFRO', '27', '1353', '2', '5');
INSERT INTO public.who_global_data_import VALUES (80091, '2020-04-02', 'ZA', 'South Africa', 'AFRO', '27', '1380', '0', '5');
INSERT INTO public.who_global_data_import VALUES (80092, '2020-04-03', 'ZA', 'South Africa', 'AFRO', '82', '1462', '0', '5');
INSERT INTO public.who_global_data_import VALUES (80093, '2020-04-04', 'ZA', 'South Africa', 'AFRO', '43', '1505', '2', '7');
INSERT INTO public.who_global_data_import VALUES (80094, '2020-04-05', 'ZA', 'South Africa', 'AFRO', '80', '1585', '2', '9');
INSERT INTO public.who_global_data_import VALUES (80095, '2020-04-06', 'ZA', 'South Africa', 'AFRO', '70', '1655', '2', '11');
INSERT INTO public.who_global_data_import VALUES (80096, '2020-04-07', 'ZA', 'South Africa', 'AFRO', '31', '1686', '1', '12');
INSERT INTO public.who_global_data_import VALUES (80097, '2020-04-08', 'ZA', 'South Africa', 'AFRO', '63', '1749', '1', '13');
INSERT INTO public.who_global_data_import VALUES (80098, '2020-04-09', 'ZA', 'South Africa', 'AFRO', '96', '1845', '5', '18');
INSERT INTO public.who_global_data_import VALUES (80099, '2020-04-10', 'ZA', 'South Africa', 'AFRO', '89', '1934', '0', '18');
INSERT INTO public.who_global_data_import VALUES (80100, '2020-04-11', 'ZA', 'South Africa', 'AFRO', '69', '2003', '6', '24');
INSERT INTO public.who_global_data_import VALUES (80101, '2020-04-12', 'ZA', 'South Africa', 'AFRO', '25', '2028', '1', '25');
INSERT INTO public.who_global_data_import VALUES (80102, '2020-04-13', 'ZA', 'South Africa', 'AFRO', '145', '2173', '0', '25');
INSERT INTO public.who_global_data_import VALUES (80103, '2020-04-14', 'ZA', 'South Africa', 'AFRO', '99', '2272', '2', '27');
INSERT INTO public.who_global_data_import VALUES (80104, '2020-04-15', 'ZA', 'South Africa', 'AFRO', '143', '2415', '0', '27');
INSERT INTO public.who_global_data_import VALUES (80105, '2020-04-16', 'ZA', 'South Africa', 'AFRO', '91', '2506', '7', '34');
INSERT INTO public.who_global_data_import VALUES (80106, '2020-04-17', 'ZA', 'South Africa', 'AFRO', '99', '2605', '14', '48');
INSERT INTO public.who_global_data_import VALUES (80107, '2020-04-18', 'ZA', 'South Africa', 'AFRO', '178', '2783', '2', '50');
INSERT INTO public.who_global_data_import VALUES (80108, '2020-04-19', 'ZA', 'South Africa', 'AFRO', '251', '3034', '2', '52');
INSERT INTO public.who_global_data_import VALUES (80109, '2020-04-20', 'ZA', 'South Africa', 'AFRO', '124', '3158', '2', '54');
INSERT INTO public.who_global_data_import VALUES (80110, '2020-04-21', 'ZA', 'South Africa', 'AFRO', '142', '3300', '4', '58');
INSERT INTO public.who_global_data_import VALUES (80111, '2020-04-22', 'ZA', 'South Africa', 'AFRO', '165', '3465', '0', '58');
INSERT INTO public.who_global_data_import VALUES (80112, '2020-04-23', 'ZA', 'South Africa', 'AFRO', '170', '3635', '7', '65');
INSERT INTO public.who_global_data_import VALUES (80113, '2020-04-24', 'ZA', 'South Africa', 'AFRO', '318', '3953', '10', '75');
INSERT INTO public.who_global_data_import VALUES (80114, '2020-04-25', 'ZA', 'South Africa', 'AFRO', '267', '4220', '4', '79');
INSERT INTO public.who_global_data_import VALUES (80115, '2020-04-26', 'ZA', 'South Africa', 'AFRO', '141', '4361', '7', '86');
INSERT INTO public.who_global_data_import VALUES (80116, '2020-04-27', 'ZA', 'South Africa', 'AFRO', '185', '4546', '1', '87');
INSERT INTO public.who_global_data_import VALUES (80117, '2020-04-28', 'ZA', 'South Africa', 'AFRO', '247', '4793', '3', '90');
INSERT INTO public.who_global_data_import VALUES (80118, '2020-04-29', 'ZA', 'South Africa', 'AFRO', '203', '4996', '3', '93');
INSERT INTO public.who_global_data_import VALUES (80119, '2020-04-30', 'ZA', 'South Africa', 'AFRO', '354', '5350', '10', '103');
INSERT INTO public.who_global_data_import VALUES (80120, '2020-05-01', 'ZA', 'South Africa', 'AFRO', '297', '5647', '0', '103');
INSERT INTO public.who_global_data_import VALUES (80121, '2020-05-02', 'ZA', 'South Africa', 'AFRO', '304', '5951', '13', '116');
INSERT INTO public.who_global_data_import VALUES (80122, '2020-05-03', 'ZA', 'South Africa', 'AFRO', '385', '6336', '7', '123');
INSERT INTO public.who_global_data_import VALUES (80123, '2020-05-04', 'ZA', 'South Africa', 'AFRO', '447', '6783', '8', '131');
INSERT INTO public.who_global_data_import VALUES (80124, '2020-05-05', 'ZA', 'South Africa', 'AFRO', '437', '7220', '7', '138');
INSERT INTO public.who_global_data_import VALUES (80125, '2020-05-06', 'ZA', 'South Africa', 'AFRO', '219', '7439', '10', '148');
INSERT INTO public.who_global_data_import VALUES (80126, '2020-05-07', 'ZA', 'South Africa', 'AFRO', '369', '7808', '5', '153');
INSERT INTO public.who_global_data_import VALUES (80127, '2020-05-08', 'ZA', 'South Africa', 'AFRO', '424', '8232', '8', '161');
INSERT INTO public.who_global_data_import VALUES (80128, '2020-05-09', 'ZA', 'South Africa', 'AFRO', '663', '8895', '17', '178');
INSERT INTO public.who_global_data_import VALUES (80129, '2020-05-10', 'ZA', 'South Africa', 'AFRO', '525', '9420', '8', '186');
INSERT INTO public.who_global_data_import VALUES (80130, '2020-05-11', 'ZA', 'South Africa', 'AFRO', '595', '10015', '8', '194');
INSERT INTO public.who_global_data_import VALUES (80131, '2020-05-12', 'ZA', 'South Africa', 'AFRO', '637', '10652', '12', '206');
INSERT INTO public.who_global_data_import VALUES (80132, '2020-05-13', 'ZA', 'South Africa', 'AFRO', '698', '11350', '0', '206');
INSERT INTO public.who_global_data_import VALUES (80133, '2020-05-14', 'ZA', 'South Africa', 'AFRO', '724', '12074', '13', '219');
INSERT INTO public.who_global_data_import VALUES (80134, '2020-05-15', 'ZA', 'South Africa', 'AFRO', '665', '12739', '19', '238');
INSERT INTO public.who_global_data_import VALUES (80135, '2020-05-16', 'ZA', 'South Africa', 'AFRO', '785', '13524', '9', '247');
INSERT INTO public.who_global_data_import VALUES (80136, '2020-05-17', 'ZA', 'South Africa', 'AFRO', '831', '14355', '14', '261');
INSERT INTO public.who_global_data_import VALUES (80137, '2020-05-18', 'ZA', 'South Africa', 'AFRO', '1160', '15515', '3', '264');
INSERT INTO public.who_global_data_import VALUES (80138, '2020-05-19', 'ZA', 'South Africa', 'AFRO', '918', '16433', '22', '286');
INSERT INTO public.who_global_data_import VALUES (80139, '2020-05-20', 'ZA', 'South Africa', 'AFRO', '767', '17200', '26', '312');
INSERT INTO public.who_global_data_import VALUES (80140, '2020-05-21', 'ZA', 'South Africa', 'AFRO', '803', '18003', '27', '339');
INSERT INTO public.who_global_data_import VALUES (80141, '2020-05-22', 'ZA', 'South Africa', 'AFRO', '1134', '19137', '30', '369');
INSERT INTO public.who_global_data_import VALUES (80142, '2020-05-23', 'ZA', 'South Africa', 'AFRO', '988', '20125', '28', '397');
INSERT INTO public.who_global_data_import VALUES (80143, '2020-05-24', 'ZA', 'South Africa', 'AFRO', '1218', '21343', '10', '407');
INSERT INTO public.who_global_data_import VALUES (80144, '2020-05-25', 'ZA', 'South Africa', 'AFRO', '1240', '22583', '22', '429');
INSERT INTO public.who_global_data_import VALUES (80145, '2020-05-26', 'ZA', 'South Africa', 'AFRO', '1032', '23615', '52', '481');
INSERT INTO public.who_global_data_import VALUES (80146, '2020-05-27', 'ZA', 'South Africa', 'AFRO', '649', '24264', '43', '524');
INSERT INTO public.who_global_data_import VALUES (80147, '2020-05-28', 'ZA', 'South Africa', 'AFRO', '1673', '25937', '28', '552');
INSERT INTO public.who_global_data_import VALUES (80148, '2020-05-29', 'ZA', 'South Africa', 'AFRO', '1466', '27403', '25', '577');
INSERT INTO public.who_global_data_import VALUES (80149, '2020-05-30', 'ZA', 'South Africa', 'AFRO', '1837', '29240', '34', '611');
INSERT INTO public.who_global_data_import VALUES (80150, '2020-05-31', 'ZA', 'South Africa', 'AFRO', '1727', '30967', '32', '643');
INSERT INTO public.who_global_data_import VALUES (80151, '2020-06-01', 'ZA', 'South Africa', 'AFRO', '1716', '32683', '40', '683');
INSERT INTO public.who_global_data_import VALUES (80152, '2020-06-02', 'ZA', 'South Africa', 'AFRO', '1674', '34357', '22', '705');
INSERT INTO public.who_global_data_import VALUES (80153, '2020-06-03', 'ZA', 'South Africa', 'AFRO', '1455', '35812', '50', '755');
INSERT INTO public.who_global_data_import VALUES (80154, '2020-06-04', 'ZA', 'South Africa', 'AFRO', '1713', '37525', '37', '792');
INSERT INTO public.who_global_data_import VALUES (80155, '2020-06-05', 'ZA', 'South Africa', 'AFRO', '3267', '40792', '56', '848');
INSERT INTO public.who_global_data_import VALUES (80156, '2020-06-06', 'ZA', 'South Africa', 'AFRO', '2642', '43434', '60', '908');
INSERT INTO public.who_global_data_import VALUES (80157, '2020-06-07', 'ZA', 'South Africa', 'AFRO', '2539', '45973', '44', '952');
INSERT INTO public.who_global_data_import VALUES (80158, '2020-06-08', 'ZA', 'South Africa', 'AFRO', '2312', '48285', '46', '998');
INSERT INTO public.who_global_data_import VALUES (80159, '2020-06-09', 'ZA', 'South Africa', 'AFRO', '2594', '50879', '82', '1080');
INSERT INTO public.who_global_data_import VALUES (80160, '2020-06-10', 'ZA', 'South Africa', 'AFRO', '2112', '52991', '82', '1162');
INSERT INTO public.who_global_data_import VALUES (80161, '2020-06-11', 'ZA', 'South Africa', 'AFRO', '2430', '55421', '48', '1210');
INSERT INTO public.who_global_data_import VALUES (80162, '2020-06-12', 'ZA', 'South Africa', 'AFRO', '3147', '58568', '74', '1284');
INSERT INTO public.who_global_data_import VALUES (80163, '2020-06-13', 'ZA', 'South Africa', 'AFRO', '3359', '61927', '70', '1354');
INSERT INTO public.who_global_data_import VALUES (80164, '2020-06-14', 'ZA', 'South Africa', 'AFRO', '3809', '65736', '69', '1423');
INSERT INTO public.who_global_data_import VALUES (80165, '2020-06-15', 'ZA', 'South Africa', 'AFRO', '4302', '70038', '57', '1480');
INSERT INTO public.who_global_data_import VALUES (80166, '2020-06-16', 'ZA', 'South Africa', 'AFRO', '3495', '73533', '88', '1568');
INSERT INTO public.who_global_data_import VALUES (80167, '2020-06-17', 'ZA', 'South Africa', 'AFRO', '2801', '76334', '57', '1625');
INSERT INTO public.who_global_data_import VALUES (80168, '2020-06-18', 'ZA', 'South Africa', 'AFRO', '4078', '80412', '49', '1674');
INSERT INTO public.who_global_data_import VALUES (80169, '2020-06-19', 'ZA', 'South Africa', 'AFRO', '3478', '83890', '63', '1737');
INSERT INTO public.who_global_data_import VALUES (80170, '2020-06-20', 'ZA', 'South Africa', 'AFRO', '3825', '87715', '94', '1831');
INSERT INTO public.who_global_data_import VALUES (80171, '2020-06-21', 'ZA', 'South Africa', 'AFRO', '4966', '92681', '46', '1877');
INSERT INTO public.who_global_data_import VALUES (80172, '2020-06-22', 'ZA', 'South Africa', 'AFRO', '4621', '97302', '53', '1930');
INSERT INTO public.who_global_data_import VALUES (80173, '2020-06-23', 'ZA', 'South Africa', 'AFRO', '4288', '101590', '61', '1991');
INSERT INTO public.who_global_data_import VALUES (80174, '2020-06-24', 'ZA', 'South Africa', 'AFRO', '4518', '106108', '111', '2102');
INSERT INTO public.who_global_data_import VALUES (80175, '2020-06-25', 'ZA', 'South Africa', 'AFRO', '5688', '111796', '103', '2205');
INSERT INTO public.who_global_data_import VALUES (80176, '2020-06-26', 'ZA', 'South Africa', 'AFRO', '6579', '118375', '87', '2292');
INSERT INTO public.who_global_data_import VALUES (80177, '2020-06-27', 'ZA', 'South Africa', 'AFRO', '6215', '124590', '48', '2340');
INSERT INTO public.who_global_data_import VALUES (80178, '2020-06-28', 'ZA', 'South Africa', 'AFRO', '7210', '131800', '73', '2413');
INSERT INTO public.who_global_data_import VALUES (80179, '2020-06-29', 'ZA', 'South Africa', 'AFRO', '6334', '138134', '43', '2456');
INSERT INTO public.who_global_data_import VALUES (80180, '2020-06-30', 'ZA', 'South Africa', 'AFRO', '6130', '144264', '73', '2529');
INSERT INTO public.who_global_data_import VALUES (80181, '2020-07-01', 'ZA', 'South Africa', 'AFRO', '6945', '151209', '128', '2657');
INSERT INTO public.who_global_data_import VALUES (80182, '2020-07-02', 'ZA', 'South Africa', 'AFRO', '8124', '159333', '92', '2749');
INSERT INTO public.who_global_data_import VALUES (80183, '2020-07-03', 'ZA', 'South Africa', 'AFRO', '8728', '168061', '95', '2844');
INSERT INTO public.who_global_data_import VALUES (80184, '2020-07-04', 'ZA', 'South Africa', 'AFRO', '9063', '177124', '108', '2952');
INSERT INTO public.who_global_data_import VALUES (80185, '2020-07-05', 'ZA', 'South Africa', 'AFRO', '10853', '187977', '74', '3026');
INSERT INTO public.who_global_data_import VALUES (80186, '2020-07-06', 'ZA', 'South Africa', 'AFRO', '8773', '196750', '173', '3199');
INSERT INTO public.who_global_data_import VALUES (80187, '2020-07-07', 'ZA', 'South Africa', 'AFRO', '8971', '205721', '111', '3310');
INSERT INTO public.who_global_data_import VALUES (80188, '2020-07-08', 'ZA', 'South Africa', 'AFRO', '10134', '215855', '192', '3502');
INSERT INTO public.who_global_data_import VALUES (80189, '2020-07-09', 'ZA', 'South Africa', 'AFRO', '8810', '224665', '100', '3602');
INSERT INTO public.who_global_data_import VALUES (80190, '2020-07-10', 'ZA', 'South Africa', 'AFRO', '13674', '238339', '118', '3720');
INSERT INTO public.who_global_data_import VALUES (80191, '2020-07-11', 'ZA', 'South Africa', 'AFRO', '12348', '250687', '140', '3860');
INSERT INTO public.who_global_data_import VALUES (80192, '2020-07-12', 'ZA', 'South Africa', 'AFRO', '13497', '264184', '111', '3971');
INSERT INTO public.who_global_data_import VALUES (80193, '2020-07-13', 'ZA', 'South Africa', 'AFRO', '12058', '276242', '108', '4079');
INSERT INTO public.who_global_data_import VALUES (80194, '2020-07-14', 'ZA', 'South Africa', 'AFRO', '11554', '287796', '93', '4172');
INSERT INTO public.who_global_data_import VALUES (80195, '2020-07-15', 'ZA', 'South Africa', 'AFRO', '10496', '298292', '174', '4346');
INSERT INTO public.who_global_data_import VALUES (80196, '2020-07-16', 'ZA', 'South Africa', 'AFRO', '12757', '311049', '107', '4453');
INSERT INTO public.who_global_data_import VALUES (80197, '2020-07-17', 'ZA', 'South Africa', 'AFRO', '13172', '324221', '216', '4669');
INSERT INTO public.who_global_data_import VALUES (80198, '2020-07-18', 'ZA', 'South Africa', 'AFRO', '13373', '337594', '135', '4804');
INSERT INTO public.who_global_data_import VALUES (80199, '2020-07-19', 'ZA', 'South Africa', 'AFRO', '13285', '350879', '144', '4948');
INSERT INTO public.who_global_data_import VALUES (80200, '2020-07-20', 'ZA', 'South Africa', 'AFRO', '13449', '364328', '85', '5033');
INSERT INTO public.who_global_data_import VALUES (80201, '2020-07-21', 'ZA', 'South Africa', 'AFRO', '9300', '373628', '140', '5173');
INSERT INTO public.who_global_data_import VALUES (80202, '2020-07-22', 'ZA', 'South Africa', 'AFRO', '8170', '381798', '195', '5368');
INSERT INTO public.who_global_data_import VALUES (80203, '2020-07-23', 'ZA', 'South Africa', 'AFRO', '13150', '394948', '572', '5940');
INSERT INTO public.who_global_data_import VALUES (80204, '2020-07-24', 'ZA', 'South Africa', 'AFRO', '13104', '408052', '153', '6093');
INSERT INTO public.who_global_data_import VALUES (80205, '2020-07-25', 'ZA', 'South Africa', 'AFRO', '13944', '421996', '250', '6343');
INSERT INTO public.who_global_data_import VALUES (80206, '2020-07-26', 'ZA', 'South Africa', 'AFRO', '12204', '434200', '312', '6655');
INSERT INTO public.who_global_data_import VALUES (80207, '2020-07-27', 'ZA', 'South Africa', 'AFRO', '11233', '445433', '114', '6769');
INSERT INTO public.who_global_data_import VALUES (80208, '2020-07-28', 'ZA', 'South Africa', 'AFRO', '7097', '452530', '298', '7067');
INSERT INTO public.who_global_data_import VALUES (80209, '2020-07-29', 'ZA', 'South Africa', 'AFRO', '7231', '459761', '190', '7257');
INSERT INTO public.who_global_data_import VALUES (80210, '2020-07-30', 'ZA', 'South Africa', 'AFRO', '11362', '471123', '240', '7497');
INSERT INTO public.who_global_data_import VALUES (80211, '2020-07-31', 'ZA', 'South Africa', 'AFRO', '11046', '482169', '315', '7812');
INSERT INTO public.who_global_data_import VALUES (80212, '2020-08-01', 'ZA', 'South Africa', 'AFRO', '11014', '493183', '193', '8005');
INSERT INTO public.who_global_data_import VALUES (80213, '2020-08-02', 'ZA', 'South Africa', 'AFRO', '10107', '503290', '148', '8153');
INSERT INTO public.who_global_data_import VALUES (80214, '2020-08-03', 'ZA', 'South Africa', 'AFRO', '8195', '511485', '213', '8366');
INSERT INTO public.who_global_data_import VALUES (80215, '2020-08-04', 'ZA', 'South Africa', 'AFRO', '5377', '516862', '0', '8366');
INSERT INTO public.who_global_data_import VALUES (80216, '2020-08-05', 'ZA', 'South Africa', 'AFRO', '4456', '521318', '518', '8884');
INSERT INTO public.who_global_data_import VALUES (80217, '2020-08-06', 'ZA', 'South Africa', 'AFRO', '8559', '529877', '414', '9298');
INSERT INTO public.who_global_data_import VALUES (80218, '2020-08-07', 'ZA', 'South Africa', 'AFRO', '8307', '538184', '306', '9604');
INSERT INTO public.who_global_data_import VALUES (80219, '2020-08-08', 'ZA', 'South Africa', 'AFRO', '7292', '545476', '305', '9909');
INSERT INTO public.who_global_data_import VALUES (80220, '2020-08-09', 'ZA', 'South Africa', 'AFRO', '7712', '553188', '301', '10210');
INSERT INTO public.who_global_data_import VALUES (80221, '2020-08-10', 'ZA', 'South Africa', 'AFRO', '6671', '559859', '198', '10408');
INSERT INTO public.who_global_data_import VALUES (80222, '2020-08-11', 'ZA', 'South Africa', 'AFRO', '3739', '563598', '213', '10621');
INSERT INTO public.who_global_data_import VALUES (80223, '2020-08-12', 'ZA', 'South Africa', 'AFRO', '2511', '566109', '130', '10751');
INSERT INTO public.who_global_data_import VALUES (80224, '2020-08-13', 'ZA', 'South Africa', 'AFRO', '2810', '568919', '259', '11010');
INSERT INTO public.who_global_data_import VALUES (80225, '2020-08-14', 'ZA', 'South Africa', 'AFRO', '3946', '572865', '260', '11270');
INSERT INTO public.who_global_data_import VALUES (80226, '2020-08-15', 'ZA', 'South Africa', 'AFRO', '6275', '579140', '286', '11556');
INSERT INTO public.who_global_data_import VALUES (80227, '2020-08-16', 'ZA', 'South Africa', 'AFRO', '4513', '583653', '121', '11677');
INSERT INTO public.who_global_data_import VALUES (80228, '2020-08-17', 'ZA', 'South Africa', 'AFRO', '3692', '587345', '162', '11839');
INSERT INTO public.who_global_data_import VALUES (80229, '2020-08-18', 'ZA', 'South Africa', 'AFRO', '2541', '589886', '143', '11982');
INSERT INTO public.who_global_data_import VALUES (80230, '2020-08-19', 'ZA', 'South Africa', 'AFRO', '2258', '592144', '282', '12264');
INSERT INTO public.who_global_data_import VALUES (80231, '2020-08-20', 'ZA', 'South Africa', 'AFRO', '3916', '596060', '159', '12423');
INSERT INTO public.who_global_data_import VALUES (80232, '2020-08-21', 'ZA', 'South Africa', 'AFRO', '3880', '599940', '195', '12618');
INSERT INTO public.who_global_data_import VALUES (80233, '2020-08-22', 'ZA', 'South Africa', 'AFRO', '3398', '603338', '225', '12843');
INSERT INTO public.who_global_data_import VALUES (80234, '2020-08-23', 'ZA', 'South Africa', 'AFRO', '3707', '607045', '144', '12987');
INSERT INTO public.who_global_data_import VALUES (80235, '2020-08-24', 'ZA', 'South Africa', 'AFRO', '2728', '609773', '72', '13059');
INSERT INTO public.who_global_data_import VALUES (80236, '2020-08-25', 'ZA', 'South Africa', 'AFRO', '1677', '611450', '100', '13159');
INSERT INTO public.who_global_data_import VALUES (80237, '2020-08-26', 'ZA', 'South Africa', 'AFRO', '1567', '613017', '149', '13308');
INSERT INTO public.who_global_data_import VALUES (80238, '2020-08-27', 'ZA', 'South Africa', 'AFRO', '2684', '615701', '194', '13502');
INSERT INTO public.who_global_data_import VALUES (80239, '2020-08-28', 'ZA', 'South Africa', 'AFRO', '0', '615701', '0', '13502');
INSERT INTO public.who_global_data_import VALUES (80240, '2020-08-29', 'ZA', 'South Africa', 'AFRO', '4431', '620132', '241', '13743');
INSERT INTO public.who_global_data_import VALUES (80241, '2020-08-30', 'ZA', 'South Africa', 'AFRO', '2419', '622551', '238', '13981');
INSERT INTO public.who_global_data_import VALUES (80242, '2020-08-31', 'ZA', 'South Africa', 'AFRO', '2505', '625056', '47', '14028');
INSERT INTO public.who_global_data_import VALUES (80243, '2020-09-01', 'ZA', 'South Africa', 'AFRO', '1985', '627041', '121', '14149');
INSERT INTO public.who_global_data_import VALUES (80244, '2020-09-02', 'ZA', 'South Africa', 'AFRO', '1218', '628259', '114', '14263');
INSERT INTO public.who_global_data_import VALUES (80245, '2020-09-03', 'ZA', 'South Africa', 'AFRO', '2336', '630595', '126', '14389');
INSERT INTO public.who_global_data_import VALUES (80246, '2020-09-04', 'ZA', 'South Africa', 'AFRO', '2420', '633015', '0', '14389');
INSERT INTO public.who_global_data_import VALUES (80247, '2020-09-05', 'ZA', 'South Africa', 'AFRO', '2063', '635078', '289', '14678');
INSERT INTO public.who_global_data_import VALUES (80248, '2020-09-06', 'ZA', 'South Africa', 'AFRO', '1806', '636884', '101', '14779');
INSERT INTO public.who_global_data_import VALUES (80249, '2020-09-07', 'ZA', 'South Africa', 'AFRO', '1633', '638517', '110', '14889');
INSERT INTO public.who_global_data_import VALUES (80250, '2020-09-08', 'ZA', 'South Africa', 'AFRO', '845', '639362', '115', '15004');
INSERT INTO public.who_global_data_import VALUES (80251, '2020-09-09', 'ZA', 'South Africa', 'AFRO', '1079', '640441', '82', '15086');
INSERT INTO public.who_global_data_import VALUES (80252, '2020-09-10', 'ZA', 'South Africa', 'AFRO', '1990', '642431', '82', '15168');
INSERT INTO public.who_global_data_import VALUES (80253, '2020-09-11', 'ZA', 'South Africa', 'AFRO', '2007', '644438', '97', '15265');
INSERT INTO public.who_global_data_import VALUES (80254, '2020-09-12', 'ZA', 'South Africa', 'AFRO', '1960', '646398', '113', '15378');
INSERT INTO public.who_global_data_import VALUES (80255, '2020-09-13', 'ZA', 'South Africa', 'AFRO', '1816', '648214', '49', '15427');
INSERT INTO public.who_global_data_import VALUES (80256, '2020-09-14', 'ZA', 'South Africa', 'AFRO', '1579', '649793', '20', '15447');
INSERT INTO public.who_global_data_import VALUES (80257, '2020-09-15', 'ZA', 'South Africa', 'AFRO', '956', '650749', '52', '15499');
INSERT INTO public.who_global_data_import VALUES (80258, '2020-09-16', 'ZA', 'South Africa', 'AFRO', '772', '651521', '142', '15641');
INSERT INTO public.who_global_data_import VALUES (80259, '2020-09-17', 'ZA', 'South Africa', 'AFRO', '1923', '653444', '64', '15705');
INSERT INTO public.who_global_data_import VALUES (80260, '2020-09-18', 'ZA', 'South Africa', 'AFRO', '2128', '655572', '67', '15772');
INSERT INTO public.who_global_data_import VALUES (80261, '2020-09-19', 'ZA', 'South Africa', 'AFRO', '2055', '657627', '85', '15857');
INSERT INTO public.who_global_data_import VALUES (80262, '2020-09-20', 'ZA', 'South Africa', 'AFRO', '2029', '659656', '83', '15940');
INSERT INTO public.who_global_data_import VALUES (80263, '2020-09-21', 'ZA', 'South Africa', 'AFRO', '1555', '661211', '13', '15953');
INSERT INTO public.who_global_data_import VALUES (80264, '2020-09-22', 'ZA', 'South Africa', 'AFRO', '725', '661936', '39', '15992');
INSERT INTO public.who_global_data_import VALUES (80265, '2020-09-23', 'ZA', 'South Africa', 'AFRO', '1346', '663282', '126', '16118');
INSERT INTO public.who_global_data_import VALUES (80266, '2020-09-24', 'ZA', 'South Africa', 'AFRO', '1906', '665188', '88', '16206');
INSERT INTO public.who_global_data_import VALUES (80267, '2020-09-25', 'ZA', 'South Africa', 'AFRO', '1861', '667049', '77', '16283');
INSERT INTO public.who_global_data_import VALUES (80268, '2020-09-26', 'ZA', 'South Africa', 'AFRO', '1480', '668529', '29', '16312');
INSERT INTO public.who_global_data_import VALUES (80269, '2020-09-27', 'ZA', 'South Africa', 'AFRO', '969', '669498', '64', '16376');
INSERT INTO public.who_global_data_import VALUES (80270, '2020-09-28', 'ZA', 'South Africa', 'AFRO', '1268', '670766', '22', '16398');
INSERT INTO public.who_global_data_import VALUES (80271, '2020-09-29', 'ZA', 'South Africa', 'AFRO', '903', '671669', '188', '16586');
INSERT INTO public.who_global_data_import VALUES (80272, '2020-09-30', 'ZA', 'South Africa', 'AFRO', '903', '672572', '81', '16667');
INSERT INTO public.who_global_data_import VALUES (80273, '2020-10-01', 'ZA', 'South Africa', 'AFRO', '1767', '674339', '67', '16734');
INSERT INTO public.who_global_data_import VALUES (80274, '2020-10-02', 'ZA', 'South Africa', 'AFRO', '1745', '676084', '132', '16866');
INSERT INTO public.who_global_data_import VALUES (80275, '2020-10-03', 'ZA', 'South Africa', 'AFRO', '1749', '677833', '43', '16909');
INSERT INTO public.who_global_data_import VALUES (80276, '2020-10-04', 'ZA', 'South Africa', 'AFRO', '1883', '679716', '29', '16938');
INSERT INTO public.who_global_data_import VALUES (80277, '2020-10-05', 'ZA', 'South Africa', 'AFRO', '1573', '681289', '38', '16976');
INSERT INTO public.who_global_data_import VALUES (80278, '2020-10-06', 'ZA', 'South Africa', 'AFRO', '926', '682215', '40', '17016');
INSERT INTO public.who_global_data_import VALUES (80279, '2020-10-07', 'ZA', 'South Africa', 'AFRO', '1027', '683242', '87', '17103');
INSERT INTO public.who_global_data_import VALUES (80280, '2020-10-08', 'ZA', 'South Africa', 'AFRO', '0', '683242', '0', '17103');
INSERT INTO public.who_global_data_import VALUES (80281, '2020-10-09', 'ZA', 'South Africa', 'AFRO', '3649', '686891', '305', '17408');
INSERT INTO public.who_global_data_import VALUES (80282, '2020-10-10', 'ZA', 'South Africa', 'AFRO', '1641', '688532', '139', '17547');
INSERT INTO public.who_global_data_import VALUES (80283, '2020-10-11', 'ZA', 'South Africa', 'AFRO', '2364', '690896', '126', '17673');
INSERT INTO public.who_global_data_import VALUES (80284, '2020-10-12', 'ZA', 'South Africa', 'AFRO', '1575', '692471', '107', '17780');
INSERT INTO public.who_global_data_import VALUES (80285, '2020-10-13', 'ZA', 'South Africa', 'AFRO', '888', '693359', '83', '17863');
INSERT INTO public.who_global_data_import VALUES (80286, '2020-10-14', 'ZA', 'South Africa', 'AFRO', '1178', '694537', '165', '18028');
INSERT INTO public.who_global_data_import VALUES (80287, '2020-10-15', 'ZA', 'South Africa', 'AFRO', '1877', '696414', '123', '18151');
INSERT INTO public.who_global_data_import VALUES (80288, '2020-10-16', 'ZA', 'South Africa', 'AFRO', '1770', '698184', '158', '18309');
INSERT INTO public.who_global_data_import VALUES (80289, '2020-10-17', 'ZA', 'South Africa', 'AFRO', '2019', '700203', '61', '18370');
INSERT INTO public.who_global_data_import VALUES (80290, '2020-10-18', 'ZA', 'South Africa', 'AFRO', '1928', '702131', '38', '18408');
INSERT INTO public.who_global_data_import VALUES (80291, '2020-10-19', 'ZA', 'South Africa', 'AFRO', '1662', '703793', '63', '18471');
INSERT INTO public.who_global_data_import VALUES (80292, '2020-10-20', 'ZA', 'South Africa', 'AFRO', '1461', '705254', '21', '18492');
INSERT INTO public.who_global_data_import VALUES (80293, '2020-10-21', 'ZA', 'South Africa', 'AFRO', '1050', '706304', '164', '18656');
INSERT INTO public.who_global_data_import VALUES (80294, '2020-10-22', 'ZA', 'South Africa', 'AFRO', '2055', '708359', '85', '18741');
INSERT INTO public.who_global_data_import VALUES (80295, '2020-10-23', 'ZA', 'South Africa', 'AFRO', '2156', '710515', '102', '18843');
INSERT INTO public.who_global_data_import VALUES (80296, '2020-10-24', 'ZA', 'South Africa', 'AFRO', '1897', '712412', '48', '18891');
INSERT INTO public.who_global_data_import VALUES (80297, '2020-10-25', 'ZA', 'South Africa', 'AFRO', '1834', '714246', '53', '18944');
INSERT INTO public.who_global_data_import VALUES (80298, '2020-10-26', 'ZA', 'South Africa', 'AFRO', '1622', '715868', '24', '18968');
INSERT INTO public.who_global_data_import VALUES (80299, '2020-10-27', 'ZA', 'South Africa', 'AFRO', '891', '716759', '40', '19008');
INSERT INTO public.who_global_data_import VALUES (80300, '2020-10-28', 'ZA', 'South Africa', 'AFRO', '1092', '717851', '45', '19053');
INSERT INTO public.who_global_data_import VALUES (80301, '2020-10-29', 'ZA', 'South Africa', 'AFRO', '1863', '719714', '58', '19111');
INSERT INTO public.who_global_data_import VALUES (80302, '2020-10-30', 'ZA', 'South Africa', 'AFRO', '2056', '721770', '53', '19164');
INSERT INTO public.who_global_data_import VALUES (80303, '2020-10-31', 'ZA', 'South Africa', 'AFRO', '1912', '723682', '66', '19230');
INSERT INTO public.who_global_data_import VALUES (80304, '2020-11-01', 'ZA', 'South Africa', 'AFRO', '1770', '725452', '46', '19276');
INSERT INTO public.who_global_data_import VALUES (80305, '2020-11-02', 'ZA', 'South Africa', 'AFRO', '1371', '726823', '135', '19411');
INSERT INTO public.who_global_data_import VALUES (80306, '2020-11-03', 'ZA', 'South Africa', 'AFRO', '772', '727595', '54', '19465');
INSERT INTO public.who_global_data_import VALUES (80307, '2020-11-04', 'ZA', 'South Africa', 'AFRO', '1241', '728836', '74', '19539');
INSERT INTO public.who_global_data_import VALUES (80308, '2020-11-05', 'ZA', 'South Africa', 'AFRO', '1712', '730548', '46', '19585');
INSERT INTO public.who_global_data_import VALUES (80309, '2020-11-06', 'ZA', 'South Africa', 'AFRO', '1866', '732414', '92', '19677');
INSERT INTO public.who_global_data_import VALUES (80310, '2020-11-07', 'ZA', 'South Africa', 'AFRO', '1761', '734175', '72', '19749');
INSERT INTO public.who_global_data_import VALUES (80311, '2020-11-08', 'ZA', 'South Africa', 'AFRO', '1731', '735906', '40', '19789');
INSERT INTO public.who_global_data_import VALUES (80312, '2020-11-09', 'ZA', 'South Africa', 'AFRO', '1372', '737278', '20', '19809');
INSERT INTO public.who_global_data_import VALUES (80313, '2020-11-10', 'ZA', 'South Africa', 'AFRO', '1247', '738525', '36', '19845');
INSERT INTO public.who_global_data_import VALUES (80314, '2020-11-11', 'ZA', 'South Africa', 'AFRO', '1729', '740254', '106', '19951');
INSERT INTO public.who_global_data_import VALUES (80315, '2020-11-12', 'ZA', 'South Africa', 'AFRO', '2140', '742394', '60', '20011');
INSERT INTO public.who_global_data_import VALUES (80316, '2020-11-13', 'ZA', 'South Africa', 'AFRO', '2338', '744732', '65', '20076');
INSERT INTO public.who_global_data_import VALUES (80317, '2020-11-14', 'ZA', 'South Africa', 'AFRO', '2213', '746945', '77', '20153');
INSERT INTO public.who_global_data_import VALUES (80318, '2020-11-15', 'ZA', 'South Africa', 'AFRO', '2237', '749182', '53', '20206');
INSERT INTO public.who_global_data_import VALUES (80319, '2020-11-16', 'ZA', 'South Africa', 'AFRO', '1842', '751024', '35', '20241');
INSERT INTO public.who_global_data_import VALUES (80320, '2020-11-17', 'ZA', 'South Africa', 'AFRO', '1245', '752269', '73', '20314');
INSERT INTO public.who_global_data_import VALUES (80321, '2020-11-18', 'ZA', 'South Africa', 'AFRO', '1987', '754256', '119', '20433');
INSERT INTO public.who_global_data_import VALUES (80322, '2020-11-19', 'ZA', 'South Africa', 'AFRO', '2888', '757144', '123', '20556');
INSERT INTO public.who_global_data_import VALUES (80323, '2020-11-20', 'ZA', 'South Africa', 'AFRO', '2514', '759658', '115', '20671');
INSERT INTO public.who_global_data_import VALUES (80324, '2020-11-21', 'ZA', 'South Africa', 'AFRO', '3105', '762763', '88', '20759');
INSERT INTO public.who_global_data_import VALUES (80325, '2020-11-22', 'ZA', 'South Africa', 'AFRO', '2646', '765409', '86', '20845');
INSERT INTO public.who_global_data_import VALUES (80326, '2020-11-23', 'ZA', 'South Africa', 'AFRO', '2270', '767679', '58', '20903');
INSERT INTO public.who_global_data_import VALUES (80327, '2020-11-24', 'ZA', 'South Africa', 'AFRO', '2080', '769759', '65', '20968');
INSERT INTO public.who_global_data_import VALUES (80328, '2020-11-25', 'ZA', 'South Africa', 'AFRO', '2493', '772252', '115', '21083');
INSERT INTO public.who_global_data_import VALUES (80329, '2020-11-26', 'ZA', 'South Africa', 'AFRO', '3250', '775502', '118', '21201');
INSERT INTO public.who_global_data_import VALUES (80330, '2020-11-27', 'ZA', 'South Africa', 'AFRO', '3069', '778571', '88', '21289');
INSERT INTO public.who_global_data_import VALUES (80331, '2020-11-28', 'ZA', 'South Africa', 'AFRO', '3370', '781941', '89', '21378');
INSERT INTO public.who_global_data_import VALUES (80332, '2020-11-29', 'ZA', 'South Africa', 'AFRO', '3198', '785139', '61', '21439');
INSERT INTO public.who_global_data_import VALUES (80333, '2020-11-30', 'ZA', 'South Africa', 'AFRO', '2563', '787702', '38', '21477');
INSERT INTO public.who_global_data_import VALUES (80334, '2020-12-01', 'ZA', 'South Africa', 'AFRO', '2302', '790004', '58', '21535');
INSERT INTO public.who_global_data_import VALUES (80335, '2020-12-02', 'ZA', 'South Africa', 'AFRO', '2295', '792299', '109', '21644');
INSERT INTO public.who_global_data_import VALUES (80336, '2020-12-03', 'ZA', 'South Africa', 'AFRO', '4173', '796472', '65', '21709');
INSERT INTO public.who_global_data_import VALUES (80337, '2020-12-04', 'ZA', 'South Africa', 'AFRO', '4400', '800872', '94', '21803');
INSERT INTO public.who_global_data_import VALUES (80338, '2020-12-05', 'ZA', 'South Africa', 'AFRO', '4932', '805804', '160', '21963');
INSERT INTO public.who_global_data_import VALUES (80339, '2020-12-06', 'ZA', 'South Africa', 'AFRO', '4645', '810449', '104', '22067');
INSERT INTO public.who_global_data_import VALUES (80340, '2020-12-07', 'ZA', 'South Africa', 'AFRO', '4116', '814565', '139', '22206');
INSERT INTO public.who_global_data_import VALUES (80341, '2020-12-08', 'ZA', 'South Africa', 'AFRO', '3313', '817878', '43', '22249');
INSERT INTO public.who_global_data_import VALUES (80342, '2020-12-09', 'ZA', 'South Africa', 'AFRO', '4011', '821889', '183', '22432');
INSERT INTO public.who_global_data_import VALUES (80343, '2020-12-10', 'ZA', 'South Africa', 'AFRO', '6709', '828598', '142', '22574');
INSERT INTO public.who_global_data_import VALUES (80344, '2020-12-11', 'ZA', 'South Africa', 'AFRO', '8166', '836764', '173', '22747');
INSERT INTO public.who_global_data_import VALUES (80345, '2020-12-12', 'ZA', 'South Africa', 'AFRO', '8319', '845083', '205', '22952');
INSERT INTO public.who_global_data_import VALUES (80346, '2020-12-13', 'ZA', 'South Africa', 'AFRO', '7882', '852965', '154', '23106');
INSERT INTO public.who_global_data_import VALUES (80347, '2020-12-14', 'ZA', 'South Africa', 'AFRO', '7999', '860964', '170', '23276');
INSERT INTO public.who_global_data_import VALUES (80348, '2020-12-15', 'ZA', 'South Africa', 'AFRO', '5163', '866127', '175', '23451');
INSERT INTO public.who_global_data_import VALUES (80349, '2020-12-16', 'ZA', 'South Africa', 'AFRO', '7552', '873679', '210', '23661');
INSERT INTO public.who_global_data_import VALUES (80350, '2020-12-17', 'ZA', 'South Africa', 'AFRO', '10008', '883687', '166', '23827');
INSERT INTO public.who_global_data_import VALUES (80351, '2020-12-18', 'ZA', 'South Africa', 'AFRO', '9126', '892813', '184', '24011');
INSERT INTO public.who_global_data_import VALUES (80352, '2020-12-19', 'ZA', 'South Africa', 'AFRO', '8725', '901538', '274', '24285');
INSERT INTO public.who_global_data_import VALUES (80353, '2020-12-20', 'ZA', 'South Africa', 'AFRO', '10939', '912477', '254', '24539');
INSERT INTO public.who_global_data_import VALUES (80354, '2020-12-21', 'ZA', 'South Africa', 'AFRO', '9445', '921922', '152', '24691');
INSERT INTO public.who_global_data_import VALUES (80355, '2020-12-22', 'ZA', 'South Africa', 'AFRO', '8789', '930711', '216', '24907');
INSERT INTO public.who_global_data_import VALUES (80356, '2020-12-23', 'ZA', 'South Africa', 'AFRO', '9501', '940212', '339', '25246');
INSERT INTO public.who_global_data_import VALUES (80357, '2020-12-24', 'ZA', 'South Africa', 'AFRO', '14046', '954258', '411', '25657');
INSERT INTO public.who_global_data_import VALUES (80358, '2020-12-25', 'ZA', 'South Africa', 'AFRO', '14305', '968563', '326', '25983');
INSERT INTO public.who_global_data_import VALUES (80359, '2020-12-26', 'ZA', 'South Africa', 'AFRO', '14796', '983359', '293', '26276');
INSERT INTO public.who_global_data_import VALUES (80360, '2020-12-27', 'ZA', 'South Africa', 'AFRO', '11552', '994911', '245', '26521');
INSERT INTO public.who_global_data_import VALUES (80361, '2020-12-28', 'ZA', 'South Africa', 'AFRO', '9502', '1004413', '214', '26735');
INSERT INTO public.who_global_data_import VALUES (80362, '2020-12-29', 'ZA', 'South Africa', 'AFRO', '7458', '1011871', '336', '27071');
INSERT INTO public.who_global_data_import VALUES (80363, '2020-12-30', 'ZA', 'South Africa', 'AFRO', '9580', '1021451', '497', '27568');
INSERT INTO public.who_global_data_import VALUES (80364, '2020-12-31', 'ZA', 'South Africa', 'AFRO', '17710', '1039161', '465', '28033');
INSERT INTO public.who_global_data_import VALUES (80365, '2021-01-01', 'ZA', 'South Africa', 'AFRO', '18400', '1057561', '436', '28469');
INSERT INTO public.who_global_data_import VALUES (80366, '2021-01-02', 'ZA', 'South Africa', 'AFRO', '0', '1057561', '0', '28469');
INSERT INTO public.who_global_data_import VALUES (80367, '2021-01-03', 'ZA', 'South Africa', 'AFRO', '31328', '1088889', '706', '29175');
INSERT INTO public.who_global_data_import VALUES (80368, '2021-01-04', 'ZA', 'South Africa', 'AFRO', '11859', '1100748', '402', '29577');
INSERT INTO public.who_global_data_import VALUES (80369, '2021-01-05', 'ZA', 'South Africa', 'AFRO', '12601', '1113349', '434', '30011');
INSERT INTO public.who_global_data_import VALUES (80370, '2021-01-06', 'ZA', 'South Africa', 'AFRO', '14410', '1127759', '513', '30524');
INSERT INTO public.who_global_data_import VALUES (80371, '2021-01-07', 'ZA', 'South Africa', 'AFRO', '21832', '1149591', '844', '31368');
INSERT INTO public.who_global_data_import VALUES (80372, '2021-01-08', 'ZA', 'South Africa', 'AFRO', '20999', '1170590', '441', '31809');
INSERT INTO public.who_global_data_import VALUES (80373, '2021-01-09', 'ZA', 'South Africa', 'AFRO', '21980', '1192570', '616', '32425');
INSERT INTO public.who_global_data_import VALUES (80374, '2021-01-10', 'ZA', 'South Africa', 'AFRO', '21606', '1214176', '399', '32824');
INSERT INTO public.who_global_data_import VALUES (80375, '2021-01-11', 'ZA', 'South Africa', 'AFRO', '17421', '1231597', '339', '33163');
INSERT INTO public.who_global_data_import VALUES (80376, '2021-01-12', 'ZA', 'South Africa', 'AFRO', '15046', '1246643', '416', '33579');
INSERT INTO public.who_global_data_import VALUES (80377, '2021-01-13', 'ZA', 'South Africa', 'AFRO', '13105', '1259748', '755', '34334');
INSERT INTO public.who_global_data_import VALUES (80378, '2021-01-14', 'ZA', 'South Africa', 'AFRO', '18555', '1278303', '806', '35140');
INSERT INTO public.who_global_data_import VALUES (80379, '2021-01-15', 'ZA', 'South Africa', 'AFRO', '18503', '1296806', '712', '35852');
INSERT INTO public.who_global_data_import VALUES (80380, '2021-01-16', 'ZA', 'South Africa', 'AFRO', '14880', '1311686', '615', '36467');
INSERT INTO public.who_global_data_import VALUES (80381, '2021-01-17', 'ZA', 'South Africa', 'AFRO', '13973', '1325659', '384', '36851');
INSERT INTO public.who_global_data_import VALUES (80382, '2021-01-18', 'ZA', 'South Africa', 'AFRO', '12267', '1337926', '254', '37105');
INSERT INTO public.who_global_data_import VALUES (80383, '2021-01-19', 'ZA', 'South Africa', 'AFRO', '9010', '1346936', '344', '37449');
INSERT INTO public.who_global_data_import VALUES (80384, '2021-01-20', 'ZA', 'South Africa', 'AFRO', '9780', '1356716', '839', '38288');
INSERT INTO public.who_global_data_import VALUES (80385, '2021-01-21', 'ZA', 'South Africa', 'AFRO', '12710', '1369426', '566', '38854');
INSERT INTO public.who_global_data_import VALUES (80386, '2021-01-22', 'ZA', 'South Africa', 'AFRO', '11381', '1380807', '647', '39501');
INSERT INTO public.who_global_data_import VALUES (80387, '2021-01-23', 'ZA', 'South Africa', 'AFRO', '11761', '1392568', '575', '40076');
INSERT INTO public.who_global_data_import VALUES (80388, '2021-01-24', 'ZA', 'South Africa', 'AFRO', '12271', '1404839', '498', '40574');
INSERT INTO public.who_global_data_import VALUES (80389, '2021-01-25', 'ZA', 'South Africa', 'AFRO', '8147', '1412986', '300', '40874');
INSERT INTO public.who_global_data_import VALUES (80390, '2021-01-26', 'ZA', 'South Africa', 'AFRO', '4551', '1417537', '243', '41117');
INSERT INTO public.who_global_data_import VALUES (80391, '2021-01-27', 'ZA', 'South Africa', 'AFRO', '6041', '1423578', '680', '41797');
INSERT INTO public.who_global_data_import VALUES (80392, '2021-01-28', 'ZA', 'South Africa', 'AFRO', '7070', '1430648', '753', '42550');
INSERT INTO public.who_global_data_import VALUES (80393, '2021-01-29', 'ZA', 'South Africa', 'AFRO', '7150', '1437798', '555', '43105');
INSERT INTO public.who_global_data_import VALUES (80394, '2021-01-30', 'ZA', 'South Africa', 'AFRO', '6141', '1443939', '528', '43633');
INSERT INTO public.who_global_data_import VALUES (80395, '2021-01-31', 'ZA', 'South Africa', 'AFRO', '5297', '1449236', '318', '43951');
INSERT INTO public.who_global_data_import VALUES (80396, '2021-02-01', 'ZA', 'South Africa', 'AFRO', '4525', '1453761', '213', '44164');
INSERT INTO public.who_global_data_import VALUES (80397, '2021-02-02', 'ZA', 'South Africa', 'AFRO', '2548', '1456309', '235', '44399');
INSERT INTO public.who_global_data_import VALUES (80398, '2021-02-03', 'ZA', 'South Africa', 'AFRO', '2649', '1458958', '547', '44946');
INSERT INTO public.who_global_data_import VALUES (80399, '2021-02-04', 'ZA', 'South Africa', 'AFRO', '4058', '1463016', '398', '45344');
INSERT INTO public.who_global_data_import VALUES (80400, '2021-02-05', 'ZA', 'South Africa', 'AFRO', '3751', '1466767', '261', '45605');
INSERT INTO public.who_global_data_import VALUES (80401, '2020-01-03', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80402, '2020-01-04', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80403, '2020-01-05', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80404, '2020-01-06', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80405, '2020-01-07', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80406, '2020-01-08', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80407, '2020-01-09', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80408, '2020-01-10', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80409, '2020-01-11', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80410, '2020-01-12', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80411, '2020-01-13', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80412, '2020-01-14', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80413, '2020-01-15', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80414, '2020-01-16', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80415, '2020-01-17', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80416, '2020-01-18', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80417, '2020-01-19', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80418, '2020-01-20', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80419, '2020-01-21', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80420, '2020-01-22', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80421, '2020-01-23', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80422, '2020-01-24', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80423, '2020-01-25', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80424, '2020-01-26', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80425, '2020-01-27', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80426, '2020-01-28', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80427, '2020-01-29', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80428, '2020-01-30', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80429, '2020-01-31', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80430, '2020-02-01', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80431, '2020-02-02', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80432, '2020-02-03', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80433, '2020-02-04', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80434, '2020-02-05', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80435, '2020-02-06', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80436, '2020-02-07', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80437, '2020-02-08', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80438, '2020-02-09', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80439, '2020-02-10', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80440, '2020-02-11', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80441, '2020-02-12', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80442, '2020-02-13', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80443, '2020-02-14', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80444, '2020-02-15', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80445, '2020-02-16', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80446, '2020-02-17', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80447, '2020-02-18', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80448, '2020-02-19', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80449, '2020-02-20', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80450, '2020-02-21', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80451, '2020-02-22', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80452, '2020-02-23', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80453, '2020-02-24', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80454, '2020-02-25', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80455, '2020-02-26', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80456, '2020-02-27', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80457, '2020-02-28', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80458, '2020-02-29', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80459, '2020-03-01', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80460, '2020-03-02', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80461, '2020-03-03', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80462, '2020-03-04', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80463, '2020-03-05', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80464, '2020-03-06', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80465, '2020-03-07', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80466, '2020-03-08', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80467, '2020-03-09', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80468, '2020-03-10', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80469, '2020-03-11', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80470, '2020-03-12', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80471, '2020-03-13', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80472, '2020-03-14', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80473, '2020-03-15', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80474, '2020-03-16', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80475, '2020-03-17', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80476, '2020-03-18', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80477, '2020-03-19', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80478, '2020-03-20', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80479, '2020-03-21', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80480, '2020-03-22', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80481, '2020-03-23', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80482, '2020-03-24', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80483, '2020-03-25', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80484, '2020-03-26', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80485, '2020-03-27', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80486, '2020-03-28', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80487, '2020-03-29', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80488, '2020-03-30', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80489, '2020-03-31', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80490, '2020-04-01', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80491, '2020-04-02', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80492, '2020-04-03', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80493, '2020-04-04', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80494, '2020-04-05', 'SS', 'South Sudan', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80495, '2020-04-06', 'SS', 'South Sudan', 'AFRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80496, '2020-04-07', 'SS', 'South Sudan', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80497, '2020-04-08', 'SS', 'South Sudan', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80498, '2020-04-09', 'SS', 'South Sudan', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80499, '2020-04-10', 'SS', 'South Sudan', 'AFRO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80500, '2020-04-11', 'SS', 'South Sudan', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80501, '2020-04-12', 'SS', 'South Sudan', 'AFRO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80502, '2020-04-13', 'SS', 'South Sudan', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80503, '2020-04-14', 'SS', 'South Sudan', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80504, '2020-04-15', 'SS', 'South Sudan', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80505, '2020-04-16', 'SS', 'South Sudan', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80506, '2020-04-17', 'SS', 'South Sudan', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80507, '2020-04-18', 'SS', 'South Sudan', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80508, '2020-04-19', 'SS', 'South Sudan', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80509, '2020-04-20', 'SS', 'South Sudan', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80510, '2020-04-21', 'SS', 'South Sudan', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80511, '2020-04-22', 'SS', 'South Sudan', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80512, '2020-04-23', 'SS', 'South Sudan', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80513, '2020-04-24', 'SS', 'South Sudan', 'AFRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80514, '2020-04-25', 'SS', 'South Sudan', 'AFRO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80515, '2020-04-26', 'SS', 'South Sudan', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80516, '2020-04-27', 'SS', 'South Sudan', 'AFRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80517, '2020-04-28', 'SS', 'South Sudan', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80518, '2020-04-29', 'SS', 'South Sudan', 'AFRO', '28', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80519, '2020-04-30', 'SS', 'South Sudan', 'AFRO', '0', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80520, '2020-05-01', 'SS', 'South Sudan', 'AFRO', '1', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80521, '2020-05-02', 'SS', 'South Sudan', 'AFRO', '10', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80522, '2020-05-03', 'SS', 'South Sudan', 'AFRO', '0', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80523, '2020-05-04', 'SS', 'South Sudan', 'AFRO', '1', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80524, '2020-05-05', 'SS', 'South Sudan', 'AFRO', '3', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80525, '2020-05-06', 'SS', 'South Sudan', 'AFRO', '0', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80526, '2020-05-07', 'SS', 'South Sudan', 'AFRO', '9', '58', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80527, '2020-05-08', 'SS', 'South Sudan', 'AFRO', '32', '90', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80528, '2020-05-09', 'SS', 'South Sudan', 'AFRO', '30', '120', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80529, '2020-05-10', 'SS', 'South Sudan', 'AFRO', '0', '120', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80530, '2020-05-11', 'SS', 'South Sudan', 'AFRO', '36', '156', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80531, '2020-05-12', 'SS', 'South Sudan', 'AFRO', '18', '174', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80532, '2020-05-13', 'SS', 'South Sudan', 'AFRO', '0', '174', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80533, '2020-05-14', 'SS', 'South Sudan', 'AFRO', '20', '194', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80534, '2020-05-15', 'SS', 'South Sudan', 'AFRO', '37', '231', '1', '1');
INSERT INTO public.who_global_data_import VALUES (80535, '2020-05-16', 'SS', 'South Sudan', 'AFRO', '0', '231', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80536, '2020-05-17', 'SS', 'South Sudan', 'AFRO', '0', '231', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80537, '2020-05-18', 'SS', 'South Sudan', 'AFRO', '51', '282', '3', '4');
INSERT INTO public.who_global_data_import VALUES (80538, '2020-05-19', 'SS', 'South Sudan', 'AFRO', '0', '282', '0', '4');
INSERT INTO public.who_global_data_import VALUES (80539, '2020-05-20', 'SS', 'South Sudan', 'AFRO', '0', '282', '0', '4');
INSERT INTO public.who_global_data_import VALUES (80540, '2020-05-21', 'SS', 'South Sudan', 'AFRO', '57', '339', '2', '6');
INSERT INTO public.who_global_data_import VALUES (80541, '2020-05-22', 'SS', 'South Sudan', 'AFRO', '134', '473', '0', '6');
INSERT INTO public.who_global_data_import VALUES (80542, '2020-05-23', 'SS', 'South Sudan', 'AFRO', '0', '473', '-1', '5');
INSERT INTO public.who_global_data_import VALUES (80543, '2020-05-24', 'SS', 'South Sudan', 'AFRO', '90', '563', '1', '6');
INSERT INTO public.who_global_data_import VALUES (80544, '2020-05-25', 'SS', 'South Sudan', 'AFRO', '92', '655', '2', '8');
INSERT INTO public.who_global_data_import VALUES (80545, '2020-05-26', 'SS', 'South Sudan', 'AFRO', '0', '655', '0', '8');
INSERT INTO public.who_global_data_import VALUES (80546, '2020-05-27', 'SS', 'South Sudan', 'AFRO', '151', '806', '0', '8');
INSERT INTO public.who_global_data_import VALUES (80547, '2020-05-28', 'SS', 'South Sudan', 'AFRO', '0', '806', '0', '8');
INSERT INTO public.who_global_data_import VALUES (80548, '2020-05-29', 'SS', 'South Sudan', 'AFRO', '188', '994', '2', '10');
INSERT INTO public.who_global_data_import VALUES (80549, '2020-05-30', 'SS', 'South Sudan', 'AFRO', '0', '994', '0', '10');
INSERT INTO public.who_global_data_import VALUES (80550, '2020-05-31', 'SS', 'South Sudan', 'AFRO', '0', '994', '0', '10');
INSERT INTO public.who_global_data_import VALUES (80551, '2020-06-01', 'SS', 'South Sudan', 'AFRO', '0', '994', '0', '10');
INSERT INTO public.who_global_data_import VALUES (80552, '2020-06-02', 'SS', 'South Sudan', 'AFRO', '0', '994', '0', '10');
INSERT INTO public.who_global_data_import VALUES (80553, '2020-06-03', 'SS', 'South Sudan', 'AFRO', '0', '994', '0', '10');
INSERT INTO public.who_global_data_import VALUES (80554, '2020-06-04', 'SS', 'South Sudan', 'AFRO', '323', '1317', '4', '14');
INSERT INTO public.who_global_data_import VALUES (80555, '2020-06-05', 'SS', 'South Sudan', 'AFRO', '0', '1317', '0', '14');
INSERT INTO public.who_global_data_import VALUES (80556, '2020-06-06', 'SS', 'South Sudan', 'AFRO', '0', '1317', '0', '14');
INSERT INTO public.who_global_data_import VALUES (80557, '2020-06-07', 'SS', 'South Sudan', 'AFRO', '0', '1317', '0', '14');
INSERT INTO public.who_global_data_import VALUES (80558, '2020-06-08', 'SS', 'South Sudan', 'AFRO', '0', '1317', '0', '14');
INSERT INTO public.who_global_data_import VALUES (80559, '2020-06-09', 'SS', 'South Sudan', 'AFRO', '287', '1604', '5', '19');
INSERT INTO public.who_global_data_import VALUES (80560, '2020-06-10', 'SS', 'South Sudan', 'AFRO', '2', '1606', '1', '20');
INSERT INTO public.who_global_data_import VALUES (80561, '2020-06-11', 'SS', 'South Sudan', 'AFRO', '0', '1606', '0', '20');
INSERT INTO public.who_global_data_import VALUES (80562, '2020-06-12', 'SS', 'South Sudan', 'AFRO', '0', '1606', '2', '22');
INSERT INTO public.who_global_data_import VALUES (80563, '2020-06-13', 'SS', 'South Sudan', 'AFRO', '64', '1670', '0', '22');
INSERT INTO public.who_global_data_import VALUES (80564, '2020-06-14', 'SS', 'South Sudan', 'AFRO', '14', '1684', '3', '25');
INSERT INTO public.who_global_data_import VALUES (80565, '2020-06-15', 'SS', 'South Sudan', 'AFRO', '9', '1693', '2', '27');
INSERT INTO public.who_global_data_import VALUES (80566, '2020-06-16', 'SS', 'South Sudan', 'AFRO', '62', '1755', '3', '30');
INSERT INTO public.who_global_data_import VALUES (80567, '2020-06-17', 'SS', 'South Sudan', 'AFRO', '21', '1776', '0', '30');
INSERT INTO public.who_global_data_import VALUES (80568, '2020-06-18', 'SS', 'South Sudan', 'AFRO', '31', '1807', '1', '31');
INSERT INTO public.who_global_data_import VALUES (80569, '2020-06-19', 'SS', 'South Sudan', 'AFRO', '6', '1813', '0', '31');
INSERT INTO public.who_global_data_import VALUES (80570, '2020-06-20', 'SS', 'South Sudan', 'AFRO', '17', '1830', '1', '32');
INSERT INTO public.who_global_data_import VALUES (80571, '2020-06-21', 'SS', 'South Sudan', 'AFRO', '34', '1864', '2', '34');
INSERT INTO public.who_global_data_import VALUES (80572, '2020-06-22', 'SS', 'South Sudan', 'AFRO', '18', '1882', '0', '34');
INSERT INTO public.who_global_data_import VALUES (80573, '2020-06-23', 'SS', 'South Sudan', 'AFRO', '10', '1892', '0', '34');
INSERT INTO public.who_global_data_import VALUES (80574, '2020-06-24', 'SS', 'South Sudan', 'AFRO', '24', '1916', '1', '35');
INSERT INTO public.who_global_data_import VALUES (80575, '2020-06-25', 'SS', 'South Sudan', 'AFRO', '14', '1930', '1', '36');
INSERT INTO public.who_global_data_import VALUES (80576, '2020-06-26', 'SS', 'South Sudan', 'AFRO', '12', '1942', '0', '36');
INSERT INTO public.who_global_data_import VALUES (80577, '2020-06-27', 'SS', 'South Sudan', 'AFRO', '10', '1952', '0', '36');
INSERT INTO public.who_global_data_import VALUES (80578, '2020-06-28', 'SS', 'South Sudan', 'AFRO', '6', '1958', '0', '36');
INSERT INTO public.who_global_data_import VALUES (80579, '2020-06-29', 'SS', 'South Sudan', 'AFRO', '8', '1966', '0', '36');
INSERT INTO public.who_global_data_import VALUES (80580, '2020-06-30', 'SS', 'South Sudan', 'AFRO', '40', '2006', '1', '37');
INSERT INTO public.who_global_data_import VALUES (80581, '2020-07-01', 'SS', 'South Sudan', 'AFRO', '1', '2007', '1', '38');
INSERT INTO public.who_global_data_import VALUES (80582, '2020-07-02', 'SS', 'South Sudan', 'AFRO', '0', '2007', '0', '38');
INSERT INTO public.who_global_data_import VALUES (80583, '2020-07-03', 'SS', 'South Sudan', 'AFRO', '29', '2036', '0', '38');
INSERT INTO public.who_global_data_import VALUES (80584, '2020-07-04', 'SS', 'South Sudan', 'AFRO', '0', '2036', '0', '38');
INSERT INTO public.who_global_data_import VALUES (80585, '2020-07-05', 'SS', 'South Sudan', 'AFRO', '22', '2058', '0', '38');
INSERT INTO public.who_global_data_import VALUES (80586, '2020-07-06', 'SS', 'South Sudan', 'AFRO', '35', '2093', '2', '40');
INSERT INTO public.who_global_data_import VALUES (80587, '2020-07-07', 'SS', 'South Sudan', 'AFRO', '5', '2098', '0', '40');
INSERT INTO public.who_global_data_import VALUES (80588, '2020-07-08', 'SS', 'South Sudan', 'AFRO', '8', '2106', '0', '40');
INSERT INTO public.who_global_data_import VALUES (80589, '2020-07-09', 'SS', 'South Sudan', 'AFRO', '0', '2106', '0', '40');
INSERT INTO public.who_global_data_import VALUES (80590, '2020-07-10', 'SS', 'South Sudan', 'AFRO', '23', '2129', '1', '41');
INSERT INTO public.who_global_data_import VALUES (80591, '2020-07-11', 'SS', 'South Sudan', 'AFRO', '0', '2129', '0', '41');
INSERT INTO public.who_global_data_import VALUES (80592, '2020-07-12', 'SS', 'South Sudan', 'AFRO', '10', '2139', '0', '41');
INSERT INTO public.who_global_data_import VALUES (80593, '2020-07-13', 'SS', 'South Sudan', 'AFRO', '9', '2148', '0', '41');
INSERT INTO public.who_global_data_import VALUES (80594, '2020-07-14', 'SS', 'South Sudan', 'AFRO', '0', '2148', '0', '41');
INSERT INTO public.who_global_data_import VALUES (80595, '2020-07-15', 'SS', 'South Sudan', 'AFRO', '5', '2153', '0', '41');
INSERT INTO public.who_global_data_import VALUES (80596, '2020-07-16', 'SS', 'South Sudan', 'AFRO', '18', '2171', '0', '41');
INSERT INTO public.who_global_data_import VALUES (80597, '2020-07-17', 'SS', 'South Sudan', 'AFRO', '20', '2191', '2', '43');
INSERT INTO public.who_global_data_import VALUES (80598, '2020-07-18', 'SS', 'South Sudan', 'AFRO', '0', '2191', '0', '43');
INSERT INTO public.who_global_data_import VALUES (80599, '2020-07-19', 'SS', 'South Sudan', 'AFRO', '9', '2200', '0', '43');
INSERT INTO public.who_global_data_import VALUES (80600, '2020-07-20', 'SS', 'South Sudan', 'AFRO', '11', '2211', '2', '45');
INSERT INTO public.who_global_data_import VALUES (80601, '2020-07-21', 'SS', 'South Sudan', 'AFRO', '0', '2211', '0', '45');
INSERT INTO public.who_global_data_import VALUES (80602, '2020-07-22', 'SS', 'South Sudan', 'AFRO', '0', '2211', '0', '45');
INSERT INTO public.who_global_data_import VALUES (80603, '2020-07-23', 'SS', 'South Sudan', 'AFRO', '28', '2239', '0', '45');
INSERT INTO public.who_global_data_import VALUES (80604, '2020-07-24', 'SS', 'South Sudan', 'AFRO', '19', '2258', '0', '45');
INSERT INTO public.who_global_data_import VALUES (80605, '2020-07-25', 'SS', 'South Sudan', 'AFRO', '0', '2258', '0', '45');
INSERT INTO public.who_global_data_import VALUES (80606, '2020-07-26', 'SS', 'South Sudan', 'AFRO', '4', '2262', '0', '45');
INSERT INTO public.who_global_data_import VALUES (80607, '2020-07-27', 'SS', 'South Sudan', 'AFRO', '43', '2305', '1', '46');
INSERT INTO public.who_global_data_import VALUES (80608, '2020-07-28', 'SS', 'South Sudan', 'AFRO', '0', '2305', '0', '46');
INSERT INTO public.who_global_data_import VALUES (80609, '2020-07-29', 'SS', 'South Sudan', 'AFRO', '17', '2322', '0', '46');
INSERT INTO public.who_global_data_import VALUES (80610, '2020-07-30', 'SS', 'South Sudan', 'AFRO', '0', '2322', '0', '46');
INSERT INTO public.who_global_data_import VALUES (80611, '2020-07-31', 'SS', 'South Sudan', 'AFRO', '0', '2322', '0', '46');
INSERT INTO public.who_global_data_import VALUES (80612, '2020-08-01', 'SS', 'South Sudan', 'AFRO', '30', '2352', '0', '46');
INSERT INTO public.who_global_data_import VALUES (80613, '2020-08-02', 'SS', 'South Sudan', 'AFRO', '77', '2429', '0', '46');
INSERT INTO public.who_global_data_import VALUES (80614, '2020-08-03', 'SS', 'South Sudan', 'AFRO', '0', '2429', '0', '46');
INSERT INTO public.who_global_data_import VALUES (80615, '2020-08-04', 'SS', 'South Sudan', 'AFRO', '8', '2437', '1', '47');
INSERT INTO public.who_global_data_import VALUES (80616, '2020-08-05', 'SS', 'South Sudan', 'AFRO', '0', '2437', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80617, '2020-08-06', 'SS', 'South Sudan', 'AFRO', '13', '2450', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80618, '2020-08-07', 'SS', 'South Sudan', 'AFRO', '0', '2450', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80619, '2020-08-08', 'SS', 'South Sudan', 'AFRO', '13', '2463', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80620, '2020-08-09', 'SS', 'South Sudan', 'AFRO', '7', '2470', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80621, '2020-08-10', 'SS', 'South Sudan', 'AFRO', '0', '2470', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80622, '2020-08-11', 'SS', 'South Sudan', 'AFRO', '2', '2472', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80623, '2020-08-12', 'SS', 'South Sudan', 'AFRO', '5', '2477', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80624, '2020-08-13', 'SS', 'South Sudan', 'AFRO', '1', '2478', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80625, '2020-08-14', 'SS', 'South Sudan', 'AFRO', '4', '2482', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80626, '2020-08-15', 'SS', 'South Sudan', 'AFRO', '6', '2488', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80627, '2020-08-16', 'SS', 'South Sudan', 'AFRO', '1', '2489', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80628, '2020-08-17', 'SS', 'South Sudan', 'AFRO', '1', '2490', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80629, '2020-08-18', 'SS', 'South Sudan', 'AFRO', '0', '2490', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80630, '2020-08-19', 'SS', 'South Sudan', 'AFRO', '4', '2494', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80631, '2020-08-20', 'SS', 'South Sudan', 'AFRO', '0', '2494', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80632, '2020-08-21', 'SS', 'South Sudan', 'AFRO', '3', '2497', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80633, '2020-08-22', 'SS', 'South Sudan', 'AFRO', '0', '2497', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80634, '2020-08-23', 'SS', 'South Sudan', 'AFRO', '2', '2499', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80635, '2020-08-24', 'SS', 'South Sudan', 'AFRO', '5', '2504', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80636, '2020-08-25', 'SS', 'South Sudan', 'AFRO', '3', '2507', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80637, '2020-08-26', 'SS', 'South Sudan', 'AFRO', '3', '2510', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80638, '2020-08-27', 'SS', 'South Sudan', 'AFRO', '4', '2514', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80639, '2020-08-28', 'SS', 'South Sudan', 'AFRO', '4', '2518', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80640, '2020-08-29', 'SS', 'South Sudan', 'AFRO', '1', '2519', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80641, '2020-08-30', 'SS', 'South Sudan', 'AFRO', '0', '2519', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80642, '2020-08-31', 'SS', 'South Sudan', 'AFRO', '8', '2527', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80643, '2020-09-01', 'SS', 'South Sudan', 'AFRO', '0', '2527', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80644, '2020-09-02', 'SS', 'South Sudan', 'AFRO', '5', '2532', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80645, '2020-09-03', 'SS', 'South Sudan', 'AFRO', '1', '2533', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80646, '2020-09-04', 'SS', 'South Sudan', 'AFRO', '3', '2536', '0', '47');
INSERT INTO public.who_global_data_import VALUES (80647, '2020-09-05', 'SS', 'South Sudan', 'AFRO', '8', '2544', '1', '48');
INSERT INTO public.who_global_data_import VALUES (80648, '2020-09-06', 'SS', 'South Sudan', 'AFRO', '0', '2544', '0', '48');
INSERT INTO public.who_global_data_import VALUES (80649, '2020-09-07', 'SS', 'South Sudan', 'AFRO', '1', '2545', '0', '48');
INSERT INTO public.who_global_data_import VALUES (80650, '2020-09-08', 'SS', 'South Sudan', 'AFRO', '7', '2552', '1', '49');
INSERT INTO public.who_global_data_import VALUES (80651, '2020-09-09', 'SS', 'South Sudan', 'AFRO', '3', '2555', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80652, '2020-09-10', 'SS', 'South Sudan', 'AFRO', '0', '2555', '-1', '48');
INSERT INTO public.who_global_data_import VALUES (80653, '2020-09-11', 'SS', 'South Sudan', 'AFRO', '13', '2568', '0', '48');
INSERT INTO public.who_global_data_import VALUES (80654, '2020-09-12', 'SS', 'South Sudan', 'AFRO', '10', '2578', '1', '49');
INSERT INTO public.who_global_data_import VALUES (80655, '2020-09-13', 'SS', 'South Sudan', 'AFRO', '0', '2578', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80656, '2020-09-14', 'SS', 'South Sudan', 'AFRO', '9', '2587', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80657, '2020-09-15', 'SS', 'South Sudan', 'AFRO', '5', '2592', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80658, '2020-09-16', 'SS', 'South Sudan', 'AFRO', '2', '2594', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80659, '2020-09-17', 'SS', 'South Sudan', 'AFRO', '5', '2599', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80660, '2020-09-18', 'SS', 'South Sudan', 'AFRO', '10', '2609', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80661, '2020-09-19', 'SS', 'South Sudan', 'AFRO', '33', '2642', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80662, '2020-09-20', 'SS', 'South Sudan', 'AFRO', '0', '2642', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80663, '2020-09-21', 'SS', 'South Sudan', 'AFRO', '7', '2649', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80664, '2020-09-22', 'SS', 'South Sudan', 'AFRO', '11', '2660', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80665, '2020-09-23', 'SS', 'South Sudan', 'AFRO', '4', '2664', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80666, '2020-09-24', 'SS', 'South Sudan', 'AFRO', '5', '2669', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80667, '2020-09-25', 'SS', 'South Sudan', 'AFRO', '7', '2676', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80668, '2020-09-26', 'SS', 'South Sudan', 'AFRO', '0', '2676', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80669, '2020-09-27', 'SS', 'South Sudan', 'AFRO', '10', '2686', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80670, '2020-09-28', 'SS', 'South Sudan', 'AFRO', '6', '2692', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80671, '2020-09-29', 'SS', 'South Sudan', 'AFRO', '8', '2700', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80672, '2020-09-30', 'SS', 'South Sudan', 'AFRO', '4', '2704', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80673, '2020-10-01', 'SS', 'South Sudan', 'AFRO', '0', '2704', '0', '49');
INSERT INTO public.who_global_data_import VALUES (80674, '2020-10-02', 'SS', 'South Sudan', 'AFRO', '11', '2715', '1', '50');
INSERT INTO public.who_global_data_import VALUES (80675, '2020-10-03', 'SS', 'South Sudan', 'AFRO', '0', '2715', '0', '50');
INSERT INTO public.who_global_data_import VALUES (80676, '2020-10-04', 'SS', 'South Sudan', 'AFRO', '11', '2726', '0', '50');
INSERT INTO public.who_global_data_import VALUES (80677, '2020-10-05', 'SS', 'South Sudan', 'AFRO', '0', '2726', '0', '50');
INSERT INTO public.who_global_data_import VALUES (80678, '2020-10-06', 'SS', 'South Sudan', 'AFRO', '8', '2734', '0', '50');
INSERT INTO public.who_global_data_import VALUES (80679, '2020-10-07', 'SS', 'South Sudan', 'AFRO', '14', '2748', '0', '50');
INSERT INTO public.who_global_data_import VALUES (80680, '2020-10-08', 'SS', 'South Sudan', 'AFRO', '1', '2749', '3', '53');
INSERT INTO public.who_global_data_import VALUES (80681, '2020-10-09', 'SS', 'South Sudan', 'AFRO', '12', '2761', '1', '54');
INSERT INTO public.who_global_data_import VALUES (80682, '2020-10-10', 'SS', 'South Sudan', 'AFRO', '0', '2761', '0', '54');
INSERT INTO public.who_global_data_import VALUES (80683, '2020-10-11', 'SS', 'South Sudan', 'AFRO', '16', '2777', '1', '55');
INSERT INTO public.who_global_data_import VALUES (80684, '2020-10-12', 'SS', 'South Sudan', 'AFRO', '10', '2787', '0', '55');
INSERT INTO public.who_global_data_import VALUES (80685, '2020-10-13', 'SS', 'South Sudan', 'AFRO', '11', '2798', '0', '55');
INSERT INTO public.who_global_data_import VALUES (80686, '2020-10-14', 'SS', 'South Sudan', 'AFRO', '0', '2798', '0', '55');
INSERT INTO public.who_global_data_import VALUES (80687, '2020-10-15', 'SS', 'South Sudan', 'AFRO', '9', '2807', '0', '55');
INSERT INTO public.who_global_data_import VALUES (80688, '2020-10-16', 'SS', 'South Sudan', 'AFRO', '10', '2817', '0', '55');
INSERT INTO public.who_global_data_import VALUES (80689, '2020-10-17', 'SS', 'South Sudan', 'AFRO', '0', '2817', '0', '55');
INSERT INTO public.who_global_data_import VALUES (80690, '2020-10-18', 'SS', 'South Sudan', 'AFRO', '25', '2842', '0', '55');
INSERT INTO public.who_global_data_import VALUES (80691, '2020-10-19', 'SS', 'South Sudan', 'AFRO', '5', '2847', '0', '55');
INSERT INTO public.who_global_data_import VALUES (80692, '2020-10-20', 'SS', 'South Sudan', 'AFRO', '0', '2847', '0', '55');
INSERT INTO public.who_global_data_import VALUES (80693, '2020-10-21', 'SS', 'South Sudan', 'AFRO', '23', '2870', '0', '55');
INSERT INTO public.who_global_data_import VALUES (80694, '2020-10-22', 'SS', 'South Sudan', 'AFRO', '2', '2872', '0', '55');
INSERT INTO public.who_global_data_import VALUES (80695, '2020-10-23', 'SS', 'South Sudan', 'AFRO', '4', '2876', '1', '56');
INSERT INTO public.who_global_data_import VALUES (80696, '2020-10-24', 'SS', 'South Sudan', 'AFRO', '2', '2878', '0', '56');
INSERT INTO public.who_global_data_import VALUES (80697, '2020-10-25', 'SS', 'South Sudan', 'AFRO', '5', '2883', '0', '56');
INSERT INTO public.who_global_data_import VALUES (80698, '2020-10-26', 'SS', 'South Sudan', 'AFRO', '0', '2883', '0', '56');
INSERT INTO public.who_global_data_import VALUES (80699, '2020-10-27', 'SS', 'South Sudan', 'AFRO', '7', '2890', '0', '56');
INSERT INTO public.who_global_data_import VALUES (80700, '2020-10-28', 'SS', 'South Sudan', 'AFRO', '0', '2890', '0', '56');
INSERT INTO public.who_global_data_import VALUES (80701, '2020-10-29', 'SS', 'South Sudan', 'AFRO', '13', '2903', '2', '58');
INSERT INTO public.who_global_data_import VALUES (80702, '2020-10-30', 'SS', 'South Sudan', 'AFRO', '0', '2903', '0', '58');
INSERT INTO public.who_global_data_import VALUES (80703, '2020-10-31', 'SS', 'South Sudan', 'AFRO', '2', '2905', '0', '58');
INSERT INTO public.who_global_data_import VALUES (80704, '2020-11-01', 'SS', 'South Sudan', 'AFRO', '21', '2926', '1', '59');
INSERT INTO public.who_global_data_import VALUES (80705, '2020-11-02', 'SS', 'South Sudan', 'AFRO', '0', '2926', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80706, '2020-11-03', 'SS', 'South Sudan', 'AFRO', '14', '2940', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80707, '2020-11-04', 'SS', 'South Sudan', 'AFRO', '3', '2943', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80708, '2020-11-05', 'SS', 'South Sudan', 'AFRO', '0', '2943', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80709, '2020-11-06', 'SS', 'South Sudan', 'AFRO', '0', '2943', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80710, '2020-11-07', 'SS', 'South Sudan', 'AFRO', '0', '2943', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80711, '2020-11-08', 'SS', 'South Sudan', 'AFRO', '0', '2943', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80712, '2020-11-09', 'SS', 'South Sudan', 'AFRO', '17', '2960', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80713, '2020-11-10', 'SS', 'South Sudan', 'AFRO', '0', '2960', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80714, '2020-11-11', 'SS', 'South Sudan', 'AFRO', '0', '2960', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80715, '2020-11-12', 'SS', 'South Sudan', 'AFRO', '0', '2960', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80716, '2020-11-13', 'SS', 'South Sudan', 'AFRO', '20', '2980', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80717, '2020-11-14', 'SS', 'South Sudan', 'AFRO', '23', '3003', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80718, '2020-11-15', 'SS', 'South Sudan', 'AFRO', '0', '3003', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80719, '2020-11-16', 'SS', 'South Sudan', 'AFRO', '9', '3012', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80720, '2020-11-17', 'SS', 'South Sudan', 'AFRO', '4', '3016', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80721, '2020-11-18', 'SS', 'South Sudan', 'AFRO', '0', '3016', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80722, '2020-11-19', 'SS', 'South Sudan', 'AFRO', '0', '3016', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80723, '2020-11-20', 'SS', 'South Sudan', 'AFRO', '0', '3016', '0', '59');
INSERT INTO public.who_global_data_import VALUES (80724, '2020-11-21', 'SS', 'South Sudan', 'AFRO', '31', '3047', '1', '60');
INSERT INTO public.who_global_data_import VALUES (80725, '2020-11-22', 'SS', 'South Sudan', 'AFRO', '0', '3047', '0', '60');
INSERT INTO public.who_global_data_import VALUES (80726, '2020-11-23', 'SS', 'South Sudan', 'AFRO', '0', '3047', '0', '60');
INSERT INTO public.who_global_data_import VALUES (80727, '2020-11-24', 'SS', 'South Sudan', 'AFRO', '0', '3047', '0', '60');
INSERT INTO public.who_global_data_import VALUES (80728, '2020-11-25', 'SS', 'South Sudan', 'AFRO', '0', '3047', '0', '60');
INSERT INTO public.who_global_data_import VALUES (80729, '2020-11-26', 'SS', 'South Sudan', 'AFRO', '0', '3047', '0', '60');
INSERT INTO public.who_global_data_import VALUES (80730, '2020-11-27', 'SS', 'South Sudan', 'AFRO', '0', '3047', '0', '60');
INSERT INTO public.who_global_data_import VALUES (80731, '2020-11-28', 'SS', 'South Sudan', 'AFRO', '57', '3104', '1', '61');
INSERT INTO public.who_global_data_import VALUES (80732, '2020-11-29', 'SS', 'South Sudan', 'AFRO', '0', '3104', '0', '61');
INSERT INTO public.who_global_data_import VALUES (80733, '2020-11-30', 'SS', 'South Sudan', 'AFRO', '0', '3104', '0', '61');
INSERT INTO public.who_global_data_import VALUES (80734, '2020-12-01', 'SS', 'South Sudan', 'AFRO', '5', '3109', '0', '61');
INSERT INTO public.who_global_data_import VALUES (80735, '2020-12-02', 'SS', 'South Sudan', 'AFRO', '0', '3109', '0', '61');
INSERT INTO public.who_global_data_import VALUES (80736, '2020-12-03', 'SS', 'South Sudan', 'AFRO', '0', '3109', '0', '61');
INSERT INTO public.who_global_data_import VALUES (80737, '2020-12-04', 'SS', 'South Sudan', 'AFRO', '45', '3154', '1', '62');
INSERT INTO public.who_global_data_import VALUES (80738, '2020-12-05', 'SS', 'South Sudan', 'AFRO', '0', '3154', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80739, '2020-12-06', 'SS', 'South Sudan', 'AFRO', '12', '3166', '-1', '61');
INSERT INTO public.who_global_data_import VALUES (80740, '2020-12-07', 'SS', 'South Sudan', 'AFRO', '15', '3181', '1', '62');
INSERT INTO public.who_global_data_import VALUES (80741, '2020-12-08', 'SS', 'South Sudan', 'AFRO', '0', '3181', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80742, '2020-12-09', 'SS', 'South Sudan', 'AFRO', '0', '3181', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80743, '2020-12-10', 'SS', 'South Sudan', 'AFRO', '0', '3181', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80744, '2020-12-11', 'SS', 'South Sudan', 'AFRO', '0', '3181', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80745, '2020-12-12', 'SS', 'South Sudan', 'AFRO', '0', '3181', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80746, '2020-12-13', 'SS', 'South Sudan', 'AFRO', '0', '3181', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80747, '2020-12-14', 'SS', 'South Sudan', 'AFRO', '25', '3206', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80748, '2020-12-15', 'SS', 'South Sudan', 'AFRO', '0', '3206', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80749, '2020-12-16', 'SS', 'South Sudan', 'AFRO', '0', '3206', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80750, '2020-12-17', 'SS', 'South Sudan', 'AFRO', '0', '3206', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80751, '2020-12-18', 'SS', 'South Sudan', 'AFRO', '17', '3223', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80752, '2020-12-19', 'SS', 'South Sudan', 'AFRO', '5', '3228', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80753, '2020-12-20', 'SS', 'South Sudan', 'AFRO', '0', '3228', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80754, '2020-12-21', 'SS', 'South Sudan', 'AFRO', '0', '3228', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80755, '2020-12-22', 'SS', 'South Sudan', 'AFRO', '6', '3234', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80756, '2020-12-23', 'SS', 'South Sudan', 'AFRO', '42', '3276', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80757, '2020-12-24', 'SS', 'South Sudan', 'AFRO', '0', '3276', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80758, '2020-12-25', 'SS', 'South Sudan', 'AFRO', '32', '3308', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80759, '2020-12-26', 'SS', 'South Sudan', 'AFRO', '0', '3308', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80760, '2020-12-27', 'SS', 'South Sudan', 'AFRO', '0', '3308', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80761, '2020-12-28', 'SS', 'South Sudan', 'AFRO', '0', '3308', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80762, '2020-12-29', 'SS', 'South Sudan', 'AFRO', '183', '3491', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80763, '2020-12-30', 'SS', 'South Sudan', 'AFRO', '0', '3491', '0', '62');
INSERT INTO public.who_global_data_import VALUES (80764, '2020-12-31', 'SS', 'South Sudan', 'AFRO', '49', '3540', '1', '63');
INSERT INTO public.who_global_data_import VALUES (80765, '2021-01-01', 'SS', 'South Sudan', 'AFRO', '18', '3558', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80766, '2021-01-02', 'SS', 'South Sudan', 'AFRO', '0', '3558', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80767, '2021-01-03', 'SS', 'South Sudan', 'AFRO', '0', '3558', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80768, '2021-01-04', 'SS', 'South Sudan', 'AFRO', '0', '3558', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80769, '2021-01-05', 'SS', 'South Sudan', 'AFRO', '31', '3589', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80770, '2021-01-06', 'SS', 'South Sudan', 'AFRO', '0', '3589', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80771, '2021-01-07', 'SS', 'South Sudan', 'AFRO', '15', '3604', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80772, '2021-01-08', 'SS', 'South Sudan', 'AFRO', '0', '3604', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80773, '2021-01-09', 'SS', 'South Sudan', 'AFRO', '0', '3604', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80774, '2021-01-10', 'SS', 'South Sudan', 'AFRO', '36', '3640', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80775, '2021-01-11', 'SS', 'South Sudan', 'AFRO', '9', '3649', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80776, '2021-01-12', 'SS', 'South Sudan', 'AFRO', '13', '3662', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80777, '2021-01-13', 'SS', 'South Sudan', 'AFRO', '8', '3670', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80778, '2021-01-14', 'SS', 'South Sudan', 'AFRO', '0', '3670', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80779, '2021-01-15', 'SS', 'South Sudan', 'AFRO', '0', '3670', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80780, '2021-01-16', 'SS', 'South Sudan', 'AFRO', '23', '3693', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80781, '2021-01-17', 'SS', 'South Sudan', 'AFRO', '0', '3693', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80782, '2021-01-18', 'SS', 'South Sudan', 'AFRO', '10', '3703', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80783, '2021-01-19', 'SS', 'South Sudan', 'AFRO', '0', '3703', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80784, '2021-01-20', 'SS', 'South Sudan', 'AFRO', '59', '3762', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80785, '2021-01-21', 'SS', 'South Sudan', 'AFRO', '0', '3762', '0', '63');
INSERT INTO public.who_global_data_import VALUES (80786, '2021-01-22', 'SS', 'South Sudan', 'AFRO', '0', '3762', '1', '64');
INSERT INTO public.who_global_data_import VALUES (80787, '2021-01-23', 'SS', 'South Sudan', 'AFRO', '11', '3773', '0', '64');
INSERT INTO public.who_global_data_import VALUES (80788, '2021-01-24', 'SS', 'South Sudan', 'AFRO', '0', '3773', '0', '64');
INSERT INTO public.who_global_data_import VALUES (80789, '2021-01-25', 'SS', 'South Sudan', 'AFRO', '92', '3865', '0', '64');
INSERT INTO public.who_global_data_import VALUES (80790, '2021-01-26', 'SS', 'South Sudan', 'AFRO', '0', '3865', '0', '64');
INSERT INTO public.who_global_data_import VALUES (80791, '2021-01-27', 'SS', 'South Sudan', 'AFRO', '17', '3882', '0', '64');
INSERT INTO public.who_global_data_import VALUES (80792, '2021-01-28', 'SS', 'South Sudan', 'AFRO', '0', '3882', '0', '64');
INSERT INTO public.who_global_data_import VALUES (80793, '2021-01-29', 'SS', 'South Sudan', 'AFRO', '47', '3929', '0', '64');
INSERT INTO public.who_global_data_import VALUES (80794, '2021-01-30', 'SS', 'South Sudan', 'AFRO', '32', '3961', '0', '64');
INSERT INTO public.who_global_data_import VALUES (80795, '2021-01-31', 'SS', 'South Sudan', 'AFRO', '0', '3961', '0', '64');
INSERT INTO public.who_global_data_import VALUES (80796, '2021-02-01', 'SS', 'South Sudan', 'AFRO', '0', '3961', '0', '64');
INSERT INTO public.who_global_data_import VALUES (80797, '2021-02-02', 'SS', 'South Sudan', 'AFRO', '76', '4037', '0', '64');
INSERT INTO public.who_global_data_import VALUES (80798, '2021-02-03', 'SS', 'South Sudan', 'AFRO', '0', '4037', '0', '64');
INSERT INTO public.who_global_data_import VALUES (80799, '2021-02-04', 'SS', 'South Sudan', 'AFRO', '69', '4106', '1', '65');
INSERT INTO public.who_global_data_import VALUES (80800, '2021-02-05', 'SS', 'South Sudan', 'AFRO', '0', '4106', '0', '65');
INSERT INTO public.who_global_data_import VALUES (80801, '2020-01-03', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80802, '2020-01-04', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80803, '2020-01-05', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80804, '2020-01-06', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80805, '2020-01-07', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80806, '2020-01-08', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80807, '2020-01-09', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80808, '2020-01-10', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80809, '2020-01-11', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80810, '2020-01-12', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80811, '2020-01-13', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80812, '2020-01-14', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80813, '2020-01-15', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80814, '2020-01-16', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80815, '2020-01-17', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80816, '2020-01-18', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80817, '2020-01-19', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80818, '2020-01-20', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80819, '2020-01-21', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80820, '2020-01-22', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80821, '2020-01-23', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80822, '2020-01-24', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80823, '2020-01-25', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80824, '2020-01-26', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80825, '2020-01-27', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80826, '2020-01-28', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80827, '2020-01-29', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80828, '2020-01-30', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80829, '2020-01-31', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80830, '2020-02-01', 'ES', 'Spain', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80831, '2020-02-02', 'ES', 'Spain', 'EURO', '23', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80832, '2020-02-03', 'ES', 'Spain', 'EURO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80833, '2020-02-04', 'ES', 'Spain', 'EURO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80834, '2020-02-05', 'ES', 'Spain', 'EURO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80835, '2020-02-06', 'ES', 'Spain', 'EURO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80836, '2020-02-07', 'ES', 'Spain', 'EURO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80837, '2020-02-08', 'ES', 'Spain', 'EURO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80838, '2020-02-09', 'ES', 'Spain', 'EURO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80839, '2020-02-10', 'ES', 'Spain', 'EURO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80840, '2020-02-11', 'ES', 'Spain', 'EURO', '1', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80841, '2020-02-12', 'ES', 'Spain', 'EURO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (80842, '2020-02-13', 'ES', 'Spain', 'EURO', '0', '24', '1', '1');
INSERT INTO public.who_global_data_import VALUES (80843, '2020-02-14', 'ES', 'Spain', 'EURO', '5', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80844, '2020-02-15', 'ES', 'Spain', 'EURO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80845, '2020-02-16', 'ES', 'Spain', 'EURO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80846, '2020-02-17', 'ES', 'Spain', 'EURO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80847, '2020-02-18', 'ES', 'Spain', 'EURO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80848, '2020-02-19', 'ES', 'Spain', 'EURO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80849, '2020-02-20', 'ES', 'Spain', 'EURO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80850, '2020-02-21', 'ES', 'Spain', 'EURO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80851, '2020-02-22', 'ES', 'Spain', 'EURO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80852, '2020-02-23', 'ES', 'Spain', 'EURO', '0', '29', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80853, '2020-02-24', 'ES', 'Spain', 'EURO', '1', '30', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80854, '2020-02-25', 'ES', 'Spain', 'EURO', '2', '32', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80855, '2020-02-26', 'ES', 'Spain', 'EURO', '2', '34', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80856, '2020-02-27', 'ES', 'Spain', 'EURO', '1', '35', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80857, '2020-02-28', 'ES', 'Spain', 'EURO', '7', '42', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80858, '2020-02-29', 'ES', 'Spain', 'EURO', '23', '65', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80859, '2020-03-01', 'ES', 'Spain', 'EURO', '24', '89', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80860, '2020-03-02', 'ES', 'Spain', 'EURO', '19', '108', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80861, '2020-03-03', 'ES', 'Spain', 'EURO', '38', '146', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80862, '2020-03-04', 'ES', 'Spain', 'EURO', '72', '218', '0', '1');
INSERT INTO public.who_global_data_import VALUES (80863, '2020-03-05', 'ES', 'Spain', 'EURO', '85', '303', '1', '2');
INSERT INTO public.who_global_data_import VALUES (80864, '2020-03-06', 'ES', 'Spain', 'EURO', '100', '403', '2', '4');
INSERT INTO public.who_global_data_import VALUES (80865, '2020-03-07', 'ES', 'Spain', 'EURO', '190', '593', '1', '5');
INSERT INTO public.who_global_data_import VALUES (80866, '2020-03-08', 'ES', 'Spain', 'EURO', '274', '867', '3', '8');
INSERT INTO public.who_global_data_import VALUES (80867, '2020-03-09', 'ES', 'Spain', 'EURO', '290', '1157', '3', '11');
INSERT INTO public.who_global_data_import VALUES (80868, '2020-03-10', 'ES', 'Spain', 'EURO', '369', '1526', '14', '25');
INSERT INTO public.who_global_data_import VALUES (80869, '2020-03-11', 'ES', 'Spain', 'EURO', '650', '2176', '17', '42');
INSERT INTO public.who_global_data_import VALUES (80870, '2020-03-12', 'ES', 'Spain', 'EURO', '1036', '3212', '28', '70');
INSERT INTO public.who_global_data_import VALUES (80871, '2020-03-13', 'ES', 'Spain', 'EURO', '1346', '4558', '35', '105');
INSERT INTO public.who_global_data_import VALUES (80872, '2020-03-14', 'ES', 'Spain', 'EURO', '1810', '6368', '59', '164');
INSERT INTO public.who_global_data_import VALUES (80873, '2020-03-15', 'ES', 'Spain', 'EURO', '2178', '8546', '79', '243');
INSERT INTO public.who_global_data_import VALUES (80874, '2020-03-16', 'ES', 'Spain', 'EURO', '2032', '10578', '108', '351');
INSERT INTO public.who_global_data_import VALUES (80875, '2020-03-17', 'ES', 'Spain', 'EURO', '2311', '12889', '131', '482');
INSERT INTO public.who_global_data_import VALUES (80876, '2020-03-18', 'ES', 'Spain', 'EURO', '3262', '16151', '183', '665');
INSERT INTO public.who_global_data_import VALUES (80877, '2020-03-19', 'ES', 'Spain', 'EURO', '4482', '20633', '191', '856');
INSERT INTO public.who_global_data_import VALUES (80878, '2020-03-20', 'ES', 'Spain', 'EURO', '4785', '25418', '246', '1102');
INSERT INTO public.who_global_data_import VALUES (80879, '2020-03-21', 'ES', 'Spain', 'EURO', '5880', '31298', '322', '1424');
INSERT INTO public.who_global_data_import VALUES (80880, '2020-03-22', 'ES', 'Spain', 'EURO', '6529', '37827', '433', '1857');
INSERT INTO public.who_global_data_import VALUES (80881, '2020-03-23', 'ES', 'Spain', 'EURO', '5793', '43620', '506', '2363');
INSERT INTO public.who_global_data_import VALUES (80882, '2020-03-24', 'ES', 'Spain', 'EURO', '5322', '48942', '551', '2914');
INSERT INTO public.who_global_data_import VALUES (80883, '2020-03-25', 'ES', 'Spain', 'EURO', '8206', '57148', '686', '3600');
INSERT INTO public.who_global_data_import VALUES (80884, '2020-03-26', 'ES', 'Spain', 'EURO', '9725', '66873', '723', '4323');
INSERT INTO public.who_global_data_import VALUES (80885, '2020-03-27', 'ES', 'Spain', 'EURO', '10141', '77014', '824', '5147');
INSERT INTO public.who_global_data_import VALUES (80886, '2020-03-28', 'ES', 'Spain', 'EURO', '10115', '87129', '871', '6018');
INSERT INTO public.who_global_data_import VALUES (80887, '2020-03-29', 'ES', 'Spain', 'EURO', '9107', '96236', '909', '6927');
INSERT INTO public.who_global_data_import VALUES (80888, '2020-03-30', 'ES', 'Spain', 'EURO', '7095', '103331', '840', '7767');
INSERT INTO public.who_global_data_import VALUES (80889, '2020-03-31', 'ES', 'Spain', 'EURO', '5090', '108421', '811', '8578');
INSERT INTO public.who_global_data_import VALUES (80890, '2020-04-01', 'ES', 'Spain', 'EURO', '8008', '116429', '913', '9491');
INSERT INTO public.who_global_data_import VALUES (80891, '2020-04-02', 'ES', 'Spain', 'EURO', '7926', '124355', '899', '10390');
INSERT INTO public.who_global_data_import VALUES (80892, '2020-04-03', 'ES', 'Spain', 'EURO', '7057', '131412', '895', '11285');
INSERT INTO public.who_global_data_import VALUES (80893, '2020-04-04', 'ES', 'Spain', 'EURO', '6908', '138320', '858', '12143');
INSERT INTO public.who_global_data_import VALUES (80894, '2020-04-05', 'ES', 'Spain', 'EURO', '6821', '145141', '786', '12929');
INSERT INTO public.who_global_data_import VALUES (80895, '2020-04-06', 'ES', 'Spain', 'EURO', '4670', '149811', '740', '13669');
INSERT INTO public.who_global_data_import VALUES (80896, '2020-04-07', 'ES', 'Spain', 'EURO', '3146', '152957', '750', '14419');
INSERT INTO public.who_global_data_import VALUES (80897, '2020-04-08', 'ES', 'Spain', 'EURO', '5395', '158352', '766', '15185');
INSERT INTO public.who_global_data_import VALUES (80898, '2020-04-09', 'ES', 'Spain', 'EURO', '5322', '163674', '736', '15921');
INSERT INTO public.who_global_data_import VALUES (80899, '2020-04-10', 'ES', 'Spain', 'EURO', '5489', '169163', '749', '16670');
INSERT INTO public.who_global_data_import VALUES (80900, '2020-04-11', 'ES', 'Spain', 'EURO', '4610', '173773', '667', '17337');
INSERT INTO public.who_global_data_import VALUES (80901, '2020-04-12', 'ES', 'Spain', 'EURO', '4437', '178210', '676', '18013');
INSERT INTO public.who_global_data_import VALUES (80902, '2020-04-13', 'ES', 'Spain', 'EURO', '3077', '181287', '628', '18641');
INSERT INTO public.who_global_data_import VALUES (80903, '2020-04-14', 'ES', 'Spain', 'EURO', '2379', '183666', '544', '19185');
INSERT INTO public.who_global_data_import VALUES (80904, '2020-04-15', 'ES', 'Spain', 'EURO', '3126', '186792', '587', '19772');
INSERT INTO public.who_global_data_import VALUES (80905, '2020-04-16', 'ES', 'Spain', 'EURO', '3994', '190786', '607', '20379');
INSERT INTO public.who_global_data_import VALUES (80906, '2020-04-17', 'ES', 'Spain', 'EURO', '3703', '194489', '552', '20931');
INSERT INTO public.who_global_data_import VALUES (80907, '2020-04-18', 'ES', 'Spain', 'EURO', '3418', '197907', '487', '21418');
INSERT INTO public.who_global_data_import VALUES (80908, '2020-04-19', 'ES', 'Spain', 'EURO', '3464', '201371', '507', '21925');
INSERT INTO public.who_global_data_import VALUES (80909, '2020-04-20', 'ES', 'Spain', 'EURO', '2182', '203553', '435', '22360');
INSERT INTO public.who_global_data_import VALUES (80910, '2020-04-21', 'ES', 'Spain', 'EURO', '1446', '204999', '401', '22761');
INSERT INTO public.who_global_data_import VALUES (80911, '2020-04-22', 'ES', 'Spain', 'EURO', '2519', '207518', '387', '23148');
INSERT INTO public.who_global_data_import VALUES (80912, '2020-04-23', 'ES', 'Spain', 'EURO', '2732', '210250', '427', '23575');
INSERT INTO public.who_global_data_import VALUES (80913, '2020-04-24', 'ES', 'Spain', 'EURO', '2774', '213024', '344', '23919');
INSERT INTO public.who_global_data_import VALUES (80914, '2020-04-25', 'ES', 'Spain', 'EURO', '2222', '215246', '331', '24250');
INSERT INTO public.who_global_data_import VALUES (80915, '2020-04-26', 'ES', 'Spain', 'EURO', '2292', '217538', '330', '24580');
INSERT INTO public.who_global_data_import VALUES (80916, '2020-04-27', 'ES', 'Spain', 'EURO', '1296', '218834', '295', '24875');
INSERT INTO public.who_global_data_import VALUES (80917, '2020-04-28', 'ES', 'Spain', 'EURO', '818', '219652', '272', '25147');
INSERT INTO public.who_global_data_import VALUES (80918, '2020-04-29', 'ES', 'Spain', 'EURO', '1655', '221307', '258', '25405');
INSERT INTO public.who_global_data_import VALUES (80919, '2020-04-30', 'ES', 'Spain', 'EURO', '1742', '223049', '259', '25664');
INSERT INTO public.who_global_data_import VALUES (80920, '2020-05-01', 'ES', 'Spain', 'EURO', '1485', '224534', '236', '25900');
INSERT INTO public.who_global_data_import VALUES (80921, '2020-05-02', 'ES', 'Spain', 'EURO', '1441', '225975', '223', '26123');
INSERT INTO public.who_global_data_import VALUES (80922, '2020-05-03', 'ES', 'Spain', 'EURO', '796', '226771', '176', '26299');
INSERT INTO public.who_global_data_import VALUES (80923, '2020-05-04', 'ES', 'Spain', 'EURO', '567', '227338', '202', '26501');
INSERT INTO public.who_global_data_import VALUES (80924, '2020-05-05', 'ES', 'Spain', 'EURO', '451', '227789', '197', '26698');
INSERT INTO public.who_global_data_import VALUES (80925, '2020-05-06', 'ES', 'Spain', 'EURO', '1015', '228804', '186', '26884');
INSERT INTO public.who_global_data_import VALUES (80926, '2020-05-07', 'ES', 'Spain', 'EURO', '983', '229787', '183', '27067');
INSERT INTO public.who_global_data_import VALUES (80927, '2020-05-08', 'ES', 'Spain', 'EURO', '981', '230768', '153', '27220');
INSERT INTO public.who_global_data_import VALUES (80928, '2020-05-09', 'ES', 'Spain', 'EURO', '961', '231729', '166', '27386');
INSERT INTO public.who_global_data_import VALUES (80929, '2020-05-10', 'ES', 'Spain', 'EURO', '923', '232652', '146', '27532');
INSERT INTO public.who_global_data_import VALUES (80930, '2020-05-11', 'ES', 'Spain', 'EURO', '494', '233146', '125', '27657');
INSERT INTO public.who_global_data_import VALUES (80931, '2020-05-12', 'ES', 'Spain', 'EURO', '318', '233464', '110', '27767');
INSERT INTO public.who_global_data_import VALUES (80932, '2020-05-13', 'ES', 'Spain', 'EURO', '592', '234056', '122', '27889');
INSERT INTO public.who_global_data_import VALUES (80933, '2020-05-14', 'ES', 'Spain', 'EURO', '712', '234768', '113', '28002');
INSERT INTO public.who_global_data_import VALUES (80934, '2020-05-15', 'ES', 'Spain', 'EURO', '876', '235644', '87', '28089');
INSERT INTO public.who_global_data_import VALUES (80935, '2020-05-16', 'ES', 'Spain', 'EURO', '880', '236524', '86', '28175');
INSERT INTO public.who_global_data_import VALUES (80936, '2020-05-17', 'ES', 'Spain', 'EURO', '893', '237417', '78', '28253');
INSERT INTO public.who_global_data_import VALUES (80937, '2020-05-18', 'ES', 'Spain', 'EURO', '390', '237807', '64', '28317');
INSERT INTO public.who_global_data_import VALUES (80938, '2020-05-19', 'ES', 'Spain', 'EURO', '256', '238063', '61', '28378');
INSERT INTO public.who_global_data_import VALUES (80939, '2020-05-20', 'ES', 'Spain', 'EURO', '682', '238745', '72', '28450');
INSERT INTO public.who_global_data_import VALUES (80940, '2020-05-21', 'ES', 'Spain', 'EURO', '948', '239693', '67', '28517');
INSERT INTO public.who_global_data_import VALUES (80941, '2020-05-22', 'ES', 'Spain', 'EURO', '820', '240513', '56', '28573');
INSERT INTO public.who_global_data_import VALUES (80942, '2020-05-23', 'ES', 'Spain', 'EURO', '922', '241435', '70', '28643');
INSERT INTO public.who_global_data_import VALUES (80943, '2020-05-24', 'ES', 'Spain', 'EURO', '969', '242404', '72', '28715');
INSERT INTO public.who_global_data_import VALUES (80944, '2020-05-25', 'ES', 'Spain', 'EURO', '363', '242767', '59', '28774');
INSERT INTO public.who_global_data_import VALUES (80945, '2020-05-26', 'ES', 'Spain', 'EURO', '306', '243073', '55', '28829');
INSERT INTO public.who_global_data_import VALUES (80946, '2020-05-27', 'ES', 'Spain', 'EURO', '645', '243718', '66', '28895');
INSERT INTO public.who_global_data_import VALUES (80947, '2020-05-28', 'ES', 'Spain', 'EURO', '812', '244530', '56', '28951');
INSERT INTO public.who_global_data_import VALUES (80948, '2020-05-29', 'ES', 'Spain', 'EURO', '662', '245192', '45', '28996');
INSERT INTO public.who_global_data_import VALUES (80949, '2020-05-30', 'ES', 'Spain', 'EURO', '746', '245938', '40', '29036');
INSERT INTO public.who_global_data_import VALUES (80950, '2020-05-31', 'ES', 'Spain', 'EURO', '801', '246739', '43', '29079');
INSERT INTO public.who_global_data_import VALUES (80951, '2020-06-01', 'ES', 'Spain', 'EURO', '367', '247106', '43', '29122');
INSERT INTO public.who_global_data_import VALUES (80952, '2020-06-02', 'ES', 'Spain', 'EURO', '191', '247297', '39', '29161');
INSERT INTO public.who_global_data_import VALUES (80953, '2020-06-03', 'ES', 'Spain', 'EURO', '359', '247656', '34', '29195');
INSERT INTO public.who_global_data_import VALUES (80954, '2020-06-04', 'ES', 'Spain', 'EURO', '493', '248149', '47', '29242');
INSERT INTO public.who_global_data_import VALUES (80955, '2020-06-05', 'ES', 'Spain', 'EURO', '631', '248780', '38', '29280');
INSERT INTO public.who_global_data_import VALUES (80956, '2020-06-06', 'ES', 'Spain', 'EURO', '532', '249312', '45', '29325');
INSERT INTO public.who_global_data_import VALUES (80957, '2020-06-07', 'ES', 'Spain', 'EURO', '709', '250021', '23', '29348');
INSERT INTO public.who_global_data_import VALUES (80958, '2020-06-08', 'ES', 'Spain', 'EURO', '278', '250299', '30', '29378');
INSERT INTO public.who_global_data_import VALUES (80959, '2020-06-09', 'ES', 'Spain', 'EURO', '153', '250452', '20', '29398');
INSERT INTO public.who_global_data_import VALUES (80960, '2020-06-10', 'ES', 'Spain', 'EURO', '379', '250831', '29', '29427');
INSERT INTO public.who_global_data_import VALUES (80961, '2020-06-11', 'ES', 'Spain', 'EURO', '485', '251316', '13', '29440');
INSERT INTO public.who_global_data_import VALUES (80962, '2020-06-12', 'ES', 'Spain', 'EURO', '508', '251824', '29', '29469');
INSERT INTO public.who_global_data_import VALUES (80963, '2020-06-13', 'ES', 'Spain', 'EURO', '411', '252235', '24', '29493');
INSERT INTO public.who_global_data_import VALUES (80964, '2020-06-14', 'ES', 'Spain', 'EURO', '531', '252766', '19', '29512');
INSERT INTO public.who_global_data_import VALUES (80965, '2020-06-15', 'ES', 'Spain', 'EURO', '132', '252898', '22', '29534');
INSERT INTO public.who_global_data_import VALUES (80966, '2020-06-16', 'ES', 'Spain', 'EURO', '96', '252994', '18', '29552');
INSERT INTO public.who_global_data_import VALUES (80967, '2020-06-17', 'ES', 'Spain', 'EURO', '301', '253295', '20', '29572');
INSERT INTO public.who_global_data_import VALUES (80968, '2020-06-18', 'ES', 'Spain', 'EURO', '387', '253682', '12', '29584');
INSERT INTO public.who_global_data_import VALUES (80969, '2020-06-19', 'ES', 'Spain', 'EURO', '357', '254039', '23', '29607');
INSERT INTO public.who_global_data_import VALUES (80970, '2020-06-20', 'ES', 'Spain', 'EURO', '391', '254430', '11', '29618');
INSERT INTO public.who_global_data_import VALUES (80971, '2020-06-21', 'ES', 'Spain', 'EURO', '360', '254790', '18', '29636');
INSERT INTO public.who_global_data_import VALUES (80972, '2020-06-22', 'ES', 'Spain', 'EURO', '232', '255022', '13', '29649');
INSERT INTO public.who_global_data_import VALUES (80973, '2020-06-23', 'ES', 'Spain', 'EURO', '172', '255194', '15', '29664');
INSERT INTO public.who_global_data_import VALUES (80974, '2020-06-24', 'ES', 'Spain', 'EURO', '260', '255454', '7', '29671');
INSERT INTO public.who_global_data_import VALUES (80975, '2020-06-25', 'ES', 'Spain', 'EURO', '464', '255918', '9', '29680');
INSERT INTO public.who_global_data_import VALUES (80976, '2020-06-26', 'ES', 'Spain', 'EURO', '329', '256247', '12', '29692');
INSERT INTO public.who_global_data_import VALUES (80977, '2020-06-27', 'ES', 'Spain', 'EURO', '385', '256632', '11', '29703');
INSERT INTO public.who_global_data_import VALUES (80978, '2020-06-28', 'ES', 'Spain', 'EURO', '525', '257157', '8', '29711');
INSERT INTO public.who_global_data_import VALUES (80979, '2020-06-29', 'ES', 'Spain', 'EURO', '252', '257409', '3', '29714');
INSERT INTO public.who_global_data_import VALUES (80980, '2020-06-30', 'ES', 'Spain', 'EURO', '191', '257600', '11', '29725');
INSERT INTO public.who_global_data_import VALUES (80981, '2020-07-01', 'ES', 'Spain', 'EURO', '288', '257888', '10', '29735');
INSERT INTO public.who_global_data_import VALUES (80982, '2020-07-02', 'ES', 'Spain', 'EURO', '474', '258362', '10', '29745');
INSERT INTO public.who_global_data_import VALUES (80983, '2020-07-03', 'ES', 'Spain', 'EURO', '497', '258859', '10', '29755');
INSERT INTO public.who_global_data_import VALUES (80984, '2020-07-04', 'ES', 'Spain', 'EURO', '520', '259379', '1', '29756');
INSERT INTO public.who_global_data_import VALUES (80985, '2020-07-05', 'ES', 'Spain', 'EURO', '615', '259994', '5', '29761');
INSERT INTO public.who_global_data_import VALUES (80986, '2020-07-06', 'ES', 'Spain', 'EURO', '302', '260296', '6', '29767');
INSERT INTO public.who_global_data_import VALUES (80987, '2020-07-07', 'ES', 'Spain', 'EURO', '215', '260511', '0', '29767');
INSERT INTO public.who_global_data_import VALUES (80988, '2020-07-08', 'ES', 'Spain', 'EURO', '367', '260878', '5', '29772');
INSERT INTO public.who_global_data_import VALUES (80989, '2020-07-09', 'ES', 'Spain', 'EURO', '752', '261630', '4', '29776');
INSERT INTO public.who_global_data_import VALUES (80990, '2020-07-10', 'ES', 'Spain', 'EURO', '804', '262434', '4', '29780');
INSERT INTO public.who_global_data_import VALUES (80991, '2020-07-11', 'ES', 'Spain', 'EURO', '925', '263359', '2', '29782');
INSERT INTO public.who_global_data_import VALUES (80992, '2020-07-12', 'ES', 'Spain', 'EURO', '1255', '264614', '4', '29786');
INSERT INTO public.who_global_data_import VALUES (80993, '2020-07-13', 'ES', 'Spain', 'EURO', '653', '265267', '4', '29790');
INSERT INTO public.who_global_data_import VALUES (80994, '2020-07-14', 'ES', 'Spain', 'EURO', '414', '265681', '3', '29793');
INSERT INTO public.who_global_data_import VALUES (80995, '2020-07-15', 'ES', 'Spain', 'EURO', '931', '266612', '1', '29794');
INSERT INTO public.who_global_data_import VALUES (80996, '2020-07-16', 'ES', 'Spain', 'EURO', '1346', '267958', '2', '29796');
INSERT INTO public.who_global_data_import VALUES (80997, '2020-07-17', 'ES', 'Spain', 'EURO', '1670', '269628', '5', '29801');
INSERT INTO public.who_global_data_import VALUES (80998, '2020-07-18', 'ES', 'Spain', 'EURO', '1729', '271357', '2', '29803');
INSERT INTO public.who_global_data_import VALUES (80999, '2020-07-19', 'ES', 'Spain', 'EURO', '2233', '273590', '2', '29805');
INSERT INTO public.who_global_data_import VALUES (81000, '2020-07-20', 'ES', 'Spain', 'EURO', '1609', '275199', '3', '29808');
INSERT INTO public.who_global_data_import VALUES (81001, '2020-07-21', 'ES', 'Spain', 'EURO', '1235', '276434', '5', '29813');
INSERT INTO public.who_global_data_import VALUES (81002, '2020-07-22', 'ES', 'Spain', 'EURO', '1726', '278160', '7', '29820');
INSERT INTO public.who_global_data_import VALUES (81003, '2020-07-23', 'ES', 'Spain', 'EURO', '2484', '280644', '7', '29827');
INSERT INTO public.who_global_data_import VALUES (81004, '2020-07-24', 'ES', 'Spain', 'EURO', '2505', '283149', '3', '29830');
INSERT INTO public.who_global_data_import VALUES (81005, '2020-07-25', 'ES', 'Spain', 'EURO', '2525', '285674', '3', '29833');
INSERT INTO public.who_global_data_import VALUES (81006, '2020-07-26', 'ES', 'Spain', 'EURO', '3013', '288687', '7', '29840');
INSERT INTO public.who_global_data_import VALUES (81007, '2020-07-27', 'ES', 'Spain', 'EURO', '1808', '290495', '9', '29849');
INSERT INTO public.who_global_data_import VALUES (81008, '2020-07-28', 'ES', 'Spain', 'EURO', '1462', '291957', '7', '29856');
INSERT INTO public.who_global_data_import VALUES (81009, '2020-07-29', 'ES', 'Spain', 'EURO', '2158', '294115', '8', '29864');
INSERT INTO public.who_global_data_import VALUES (81010, '2020-07-30', 'ES', 'Spain', 'EURO', '3091', '297206', '12', '29876');
INSERT INTO public.who_global_data_import VALUES (81011, '2020-07-31', 'ES', 'Spain', 'EURO', '3352', '300558', '8', '29884');
INSERT INTO public.who_global_data_import VALUES (81012, '2020-08-01', 'ES', 'Spain', 'EURO', '3562', '304120', '11', '29895');
INSERT INTO public.who_global_data_import VALUES (81013, '2020-08-02', 'ES', 'Spain', 'EURO', '4017', '308137', '15', '29910');
INSERT INTO public.who_global_data_import VALUES (81014, '2020-08-03', 'ES', 'Spain', 'EURO', '3108', '311245', '9', '29919');
INSERT INTO public.who_global_data_import VALUES (81015, '2020-08-04', 'ES', 'Spain', 'EURO', '1888', '313133', '14', '29933');
INSERT INTO public.who_global_data_import VALUES (81016, '2020-08-05', 'ES', 'Spain', 'EURO', '2793', '315926', '12', '29945');
INSERT INTO public.who_global_data_import VALUES (81017, '2020-08-06', 'ES', 'Spain', 'EURO', '4557', '320483', '15', '29960');
INSERT INTO public.who_global_data_import VALUES (81018, '2020-08-07', 'ES', 'Spain', 'EURO', '4418', '324901', '11', '29971');
INSERT INTO public.who_global_data_import VALUES (81019, '2020-08-08', 'ES', 'Spain', 'EURO', '4957', '329858', '27', '29998');
INSERT INTO public.who_global_data_import VALUES (81020, '2020-08-09', 'ES', 'Spain', 'EURO', '5803', '335661', '19', '30017');
INSERT INTO public.who_global_data_import VALUES (81021, '2020-08-10', 'ES', 'Spain', 'EURO', '3599', '339260', '30', '30047');
INSERT INTO public.who_global_data_import VALUES (81022, '2020-08-11', 'ES', 'Spain', 'EURO', '2660', '341920', '16', '30063');
INSERT INTO public.who_global_data_import VALUES (81023, '2020-08-12', 'ES', 'Spain', 'EURO', '3969', '345889', '27', '30090');
INSERT INTO public.who_global_data_import VALUES (81024, '2020-08-13', 'ES', 'Spain', 'EURO', '6154', '352043', '27', '30117');
INSERT INTO public.who_global_data_import VALUES (81025, '2020-08-14', 'ES', 'Spain', 'EURO', '6549', '358592', '25', '30142');
INSERT INTO public.who_global_data_import VALUES (81026, '2020-08-15', 'ES', 'Spain', 'EURO', '7171', '365763', '23', '30165');
INSERT INTO public.who_global_data_import VALUES (81027, '2020-08-16', 'ES', 'Spain', 'EURO', '8475', '374238', '34', '30199');
INSERT INTO public.who_global_data_import VALUES (81028, '2020-08-17', 'ES', 'Spain', 'EURO', '4882', '379120', '29', '30228');
INSERT INTO public.who_global_data_import VALUES (81029, '2020-08-18', 'ES', 'Spain', 'EURO', '3341', '382461', '22', '30250');
INSERT INTO public.who_global_data_import VALUES (81030, '2020-08-19', 'ES', 'Spain', 'EURO', '5095', '387556', '30', '30280');
INSERT INTO public.who_global_data_import VALUES (81031, '2020-08-20', 'ES', 'Spain', 'EURO', '8620', '396176', '40', '30320');
INSERT INTO public.who_global_data_import VALUES (81032, '2020-08-21', 'ES', 'Spain', 'EURO', '8780', '404956', '45', '30365');
INSERT INTO public.who_global_data_import VALUES (81033, '2020-08-22', 'ES', 'Spain', 'EURO', '9205', '414161', '37', '30402');
INSERT INTO public.who_global_data_import VALUES (81034, '2020-08-23', 'ES', 'Spain', 'EURO', '10663', '424824', '42', '30444');
INSERT INTO public.who_global_data_import VALUES (81035, '2020-08-24', 'ES', 'Spain', 'EURO', '6099', '430923', '42', '30486');
INSERT INTO public.who_global_data_import VALUES (81036, '2020-08-25', 'ES', 'Spain', 'EURO', '4347', '435270', '52', '30538');
INSERT INTO public.who_global_data_import VALUES (81037, '2020-08-26', 'ES', 'Spain', 'EURO', '6160', '441430', '53', '30591');
INSERT INTO public.who_global_data_import VALUES (81038, '2020-08-27', 'ES', 'Spain', 'EURO', '10518', '451948', '40', '30631');
INSERT INTO public.who_global_data_import VALUES (81039, '2020-08-28', 'ES', 'Spain', 'EURO', '10560', '462508', '48', '30679');
INSERT INTO public.who_global_data_import VALUES (81040, '2020-08-29', 'ES', 'Spain', 'EURO', '10522', '473030', '45', '30724');
INSERT INTO public.who_global_data_import VALUES (81041, '2020-08-30', 'ES', 'Spain', 'EURO', '12140', '485170', '67', '30791');
INSERT INTO public.who_global_data_import VALUES (81042, '2020-08-31', 'ES', 'Spain', 'EURO', '6911', '492081', '49', '30840');
INSERT INTO public.who_global_data_import VALUES (81043, '2020-09-01', 'ES', 'Spain', 'EURO', '5232', '497313', '54', '30894');
INSERT INTO public.who_global_data_import VALUES (81044, '2020-09-02', 'ES', 'Spain', 'EURO', '6796', '504109', '62', '30956');
INSERT INTO public.who_global_data_import VALUES (81045, '2020-09-03', 'ES', 'Spain', 'EURO', '10628', '514737', '68', '31024');
INSERT INTO public.who_global_data_import VALUES (81046, '2020-09-04', 'ES', 'Spain', 'EURO', '10876', '525613', '80', '31104');
INSERT INTO public.who_global_data_import VALUES (81047, '2020-09-05', 'ES', 'Spain', 'EURO', '11118', '536731', '74', '31178');
INSERT INTO public.who_global_data_import VALUES (81048, '2020-09-06', 'ES', 'Spain', 'EURO', '13380', '550111', '72', '31250');
INSERT INTO public.who_global_data_import VALUES (81049, '2020-09-07', 'ES', 'Spain', 'EURO', '7978', '558089', '64', '31314');
INSERT INTO public.who_global_data_import VALUES (81050, '2020-09-08', 'ES', 'Spain', 'EURO', '5540', '563629', '62', '31376');
INSERT INTO public.who_global_data_import VALUES (81051, '2020-09-09', 'ES', 'Spain', 'EURO', '7176', '570805', '80', '31456');
INSERT INTO public.who_global_data_import VALUES (81052, '2020-09-10', 'ES', 'Spain', 'EURO', '12097', '582902', '83', '31539');
INSERT INTO public.who_global_data_import VALUES (81053, '2020-09-11', 'ES', 'Spain', 'EURO', '12947', '595849', '89', '31628');
INSERT INTO public.who_global_data_import VALUES (81054, '2020-09-12', 'ES', 'Spain', 'EURO', '13160', '609009', '90', '31718');
INSERT INTO public.who_global_data_import VALUES (81055, '2020-09-13', 'ES', 'Spain', 'EURO', '14468', '623477', '97', '31815');
INSERT INTO public.who_global_data_import VALUES (81056, '2020-09-14', 'ES', 'Spain', 'EURO', '8401', '631878', '98', '31913');
INSERT INTO public.who_global_data_import VALUES (81057, '2020-09-15', 'ES', 'Spain', 'EURO', '6524', '638402', '101', '32014');
INSERT INTO public.who_global_data_import VALUES (81058, '2020-09-16', 'ES', 'Spain', 'EURO', '8384', '646786', '97', '32111');
INSERT INTO public.who_global_data_import VALUES (81059, '2020-09-17', 'ES', 'Spain', 'EURO', '14040', '660826', '126', '32237');
INSERT INTO public.who_global_data_import VALUES (81060, '2020-09-18', 'ES', 'Spain', 'EURO', '14279', '675105', '109', '32346');
INSERT INTO public.who_global_data_import VALUES (81061, '2020-09-19', 'ES', 'Spain', 'EURO', '13953', '689058', '120', '32466');
INSERT INTO public.who_global_data_import VALUES (81062, '2020-09-20', 'ES', 'Spain', 'EURO', '16960', '706018', '115', '32581');
INSERT INTO public.who_global_data_import VALUES (81063, '2020-09-21', 'ES', 'Spain', 'EURO', '8428', '714446', '117', '32698');
INSERT INTO public.who_global_data_import VALUES (81064, '2020-09-22', 'ES', 'Spain', 'EURO', '5905', '720351', '99', '32797');
INSERT INTO public.who_global_data_import VALUES (81065, '2020-09-23', 'ES', 'Spain', 'EURO', '8254', '728605', '129', '32926');
INSERT INTO public.who_global_data_import VALUES (81066, '2020-09-24', 'ES', 'Spain', 'EURO', '12947', '741552', '122', '33048');
INSERT INTO public.who_global_data_import VALUES (81067, '2020-09-25', 'ES', 'Spain', 'EURO', '12911', '754463', '111', '33159');
INSERT INTO public.who_global_data_import VALUES (81068, '2020-09-26', 'ES', 'Spain', 'EURO', '12789', '767252', '131', '33290');
INSERT INTO public.who_global_data_import VALUES (81069, '2020-09-27', 'ES', 'Spain', 'EURO', '13723', '780975', '127', '33417');
INSERT INTO public.who_global_data_import VALUES (81070, '2020-09-28', 'ES', 'Spain', 'EURO', '7786', '788761', '115', '33532');
INSERT INTO public.who_global_data_import VALUES (81071, '2020-09-29', 'ES', 'Spain', 'EURO', '5099', '793860', '120', '33652');
INSERT INTO public.who_global_data_import VALUES (81072, '2020-09-30', 'ES', 'Spain', 'EURO', '7243', '801103', '143', '33795');
INSERT INTO public.who_global_data_import VALUES (81073, '2020-10-01', 'ES', 'Spain', 'EURO', '11568', '812671', '146', '33941');
INSERT INTO public.who_global_data_import VALUES (81074, '2020-10-02', 'ES', 'Spain', 'EURO', '11500', '824171', '154', '34095');
INSERT INTO public.who_global_data_import VALUES (81075, '2020-10-03', 'ES', 'Spain', 'EURO', '11199', '835370', '130', '34225');
INSERT INTO public.who_global_data_import VALUES (81076, '2020-10-04', 'ES', 'Spain', 'EURO', '12614', '847984', '141', '34366');
INSERT INTO public.who_global_data_import VALUES (81077, '2020-10-05', 'ES', 'Spain', 'EURO', '7039', '855023', '103', '34469');
INSERT INTO public.who_global_data_import VALUES (81078, '2020-10-06', 'ES', 'Spain', 'EURO', '5187', '860210', '89', '34558');
INSERT INTO public.who_global_data_import VALUES (81079, '2020-10-07', 'ES', 'Spain', 'EURO', '9038', '869248', '132', '34690');
INSERT INTO public.who_global_data_import VALUES (81080, '2020-10-08', 'ES', 'Spain', 'EURO', '12473', '881721', '130', '34820');
INSERT INTO public.who_global_data_import VALUES (81081, '2020-10-09', 'ES', 'Spain', 'EURO', '12666', '894387', '134', '34954');
INSERT INTO public.who_global_data_import VALUES (81082, '2020-10-10', 'ES', 'Spain', 'EURO', '14216', '908603', '129', '35083');
INSERT INTO public.who_global_data_import VALUES (81083, '2020-10-11', 'ES', 'Spain', 'EURO', '15097', '923700', '153', '35236');
INSERT INTO public.who_global_data_import VALUES (81084, '2020-10-12', 'ES', 'Spain', 'EURO', '8876', '932576', '133', '35369');
INSERT INTO public.who_global_data_import VALUES (81085, '2020-10-13', 'ES', 'Spain', 'EURO', '6925', '939501', '114', '35483');
INSERT INTO public.who_global_data_import VALUES (81086, '2020-10-14', 'ES', 'Spain', 'EURO', '6401', '945902', '125', '35608');
INSERT INTO public.who_global_data_import VALUES (81087, '2020-10-15', 'ES', 'Spain', 'EURO', '12699', '958601', '144', '35752');
INSERT INTO public.who_global_data_import VALUES (81088, '2020-10-16', 'ES', 'Spain', 'EURO', '16821', '975422', '135', '35887');
INSERT INTO public.who_global_data_import VALUES (81089, '2020-10-17', 'ES', 'Spain', 'EURO', '17979', '993401', '144', '36031');
INSERT INTO public.who_global_data_import VALUES (81090, '2020-10-18', 'ES', 'Spain', 'EURO', '18774', '1012175', '146', '36177');
INSERT INTO public.who_global_data_import VALUES (81091, '2020-10-19', 'ES', 'Spain', 'EURO', '12219', '1024394', '124', '36301');
INSERT INTO public.who_global_data_import VALUES (81092, '2020-10-20', 'ES', 'Spain', 'EURO', '8458', '1032852', '143', '36444');
INSERT INTO public.who_global_data_import VALUES (81093, '2020-10-21', 'ES', 'Spain', 'EURO', '16143', '1048995', '164', '36608');
INSERT INTO public.who_global_data_import VALUES (81094, '2020-10-22', 'ES', 'Spain', 'EURO', '21778', '1070773', '184', '36792');
INSERT INTO public.who_global_data_import VALUES (81095, '2020-10-23', 'ES', 'Spain', 'EURO', '24044', '1094817', '166', '36958');
INSERT INTO public.who_global_data_import VALUES (81096, '2020-10-24', 'ES', 'Spain', 'EURO', '24851', '1119668', '201', '37159');
INSERT INTO public.who_global_data_import VALUES (81097, '2020-10-25', 'ES', 'Spain', 'EURO', '25808', '1145476', '216', '37375');
INSERT INTO public.who_global_data_import VALUES (81098, '2020-10-26', 'ES', 'Spain', 'EURO', '15857', '1161333', '186', '37561');
INSERT INTO public.who_global_data_import VALUES (81099, '2020-10-27', 'ES', 'Spain', 'EURO', '11531', '1172864', '182', '37743');
INSERT INTO public.who_global_data_import VALUES (81100, '2020-10-28', 'ES', 'Spain', 'EURO', '20610', '1193474', '203', '37946');
INSERT INTO public.who_global_data_import VALUES (81101, '2020-10-29', 'ES', 'Spain', 'EURO', '25091', '1218565', '235', '38181');
INSERT INTO public.who_global_data_import VALUES (81102, '2020-10-30', 'ES', 'Spain', 'EURO', '25192', '1243757', '227', '38408');
INSERT INTO public.who_global_data_import VALUES (81103, '2020-10-31', 'ES', 'Spain', 'EURO', '24728', '1268485', '226', '38634');
INSERT INTO public.who_global_data_import VALUES (81104, '2020-11-01', 'ES', 'Spain', 'EURO', '25591', '1294076', '232', '38866');
INSERT INTO public.who_global_data_import VALUES (81105, '2020-11-02', 'ES', 'Spain', 'EURO', '16480', '1310556', '234', '39100');
INSERT INTO public.who_global_data_import VALUES (81106, '2020-11-03', 'ES', 'Spain', 'EURO', '11149', '1321705', '240', '39340');
INSERT INTO public.who_global_data_import VALUES (81107, '2020-11-04', 'ES', 'Spain', 'EURO', '16117', '1337822', '266', '39606');
INSERT INTO public.who_global_data_import VALUES (81108, '2020-11-05', 'ES', 'Spain', 'EURO', '22487', '1360309', '297', '39903');
INSERT INTO public.who_global_data_import VALUES (81109, '2020-11-06', 'ES', 'Spain', 'EURO', '24680', '1384989', '318', '40221');
INSERT INTO public.who_global_data_import VALUES (81110, '2020-11-07', 'ES', 'Spain', 'EURO', '24028', '1409017', '296', '40517');
INSERT INTO public.who_global_data_import VALUES (81111, '2020-11-08', 'ES', 'Spain', 'EURO', '23785', '1432802', '334', '40851');
INSERT INTO public.who_global_data_import VALUES (81112, '2020-11-09', 'ES', 'Spain', 'EURO', '14826', '1447628', '244', '41095');
INSERT INTO public.who_global_data_import VALUES (81113, '2020-11-10', 'ES', 'Spain', 'EURO', '9879', '1457507', '280', '41375');
INSERT INTO public.who_global_data_import VALUES (81114, '2020-11-11', 'ES', 'Spain', 'EURO', '16650', '1474157', '280', '41655');
INSERT INTO public.who_global_data_import VALUES (81115, '2020-11-12', 'ES', 'Spain', 'EURO', '20694', '1494851', '306', '41961');
INSERT INTO public.who_global_data_import VALUES (81116, '2020-11-13', 'ES', 'Spain', 'EURO', '19775', '1514626', '324', '42285');
INSERT INTO public.who_global_data_import VALUES (81117, '2020-11-14', 'ES', 'Spain', 'EURO', '19098', '1533724', '316', '42601');
INSERT INTO public.who_global_data_import VALUES (81118, '2020-11-15', 'ES', 'Spain', 'EURO', '18318', '1552042', '302', '42903');
INSERT INTO public.who_global_data_import VALUES (81119, '2020-11-16', 'ES', 'Spain', 'EURO', '10591', '1562633', '267', '43170');
INSERT INTO public.who_global_data_import VALUES (81120, '2020-11-17', 'ES', 'Spain', 'EURO', '6682', '1569315', '248', '43418');
INSERT INTO public.who_global_data_import VALUES (81121, '2020-11-18', 'ES', 'Spain', 'EURO', '12933', '1582248', '265', '43683');
INSERT INTO public.who_global_data_import VALUES (81122, '2020-11-19', 'ES', 'Spain', 'EURO', '16015', '1598263', '343', '44026');
INSERT INTO public.who_global_data_import VALUES (81123, '2020-11-20', 'ES', 'Spain', 'EURO', '14862', '1613125', '265', '44291');
INSERT INTO public.who_global_data_import VALUES (81124, '2020-11-21', 'ES', 'Spain', 'EURO', '13318', '1626443', '288', '44579');
INSERT INTO public.who_global_data_import VALUES (81125, '2020-11-22', 'ES', 'Spain', 'EURO', '12693', '1639136', '286', '44865');
INSERT INTO public.who_global_data_import VALUES (81126, '2020-11-23', 'ES', 'Spain', 'EURO', '7270', '1646406', '253', '45118');
INSERT INTO public.who_global_data_import VALUES (81127, '2020-11-24', 'ES', 'Spain', 'EURO', '4658', '1651064', '234', '45352');
INSERT INTO public.who_global_data_import VALUES (81128, '2020-11-25', 'ES', 'Spain', 'EURO', '9268', '1660332', '257', '45609');
INSERT INTO public.who_global_data_import VALUES (81129, '2020-11-26', 'ES', 'Spain', 'EURO', '11058', '1671390', '228', '45837');
INSERT INTO public.who_global_data_import VALUES (81130, '2020-11-27', 'ES', 'Spain', 'EURO', '10118', '1681508', '255', '46092');
INSERT INTO public.who_global_data_import VALUES (81131, '2020-11-28', 'ES', 'Spain', 'EURO', '9779', '1691287', '258', '46350');
INSERT INTO public.who_global_data_import VALUES (81132, '2020-11-29', 'ES', 'Spain', 'EURO', '10145', '1701432', '240', '46590');
INSERT INTO public.who_global_data_import VALUES (81133, '2020-11-30', 'ES', 'Spain', 'EURO', '5612', '1707044', '192', '46782');
INSERT INTO public.who_global_data_import VALUES (81134, '2020-12-01', 'ES', 'Spain', 'EURO', '3453', '1710497', '181', '46963');
INSERT INTO public.who_global_data_import VALUES (81135, '2020-12-02', 'ES', 'Spain', 'EURO', '7576', '1718073', '199', '47162');
INSERT INTO public.who_global_data_import VALUES (81136, '2020-12-03', 'ES', 'Spain', 'EURO', '9739', '1727812', '204', '47366');
INSERT INTO public.who_global_data_import VALUES (81137, '2020-12-04', 'ES', 'Spain', 'EURO', '9015', '1736827', '199', '47565');
INSERT INTO public.who_global_data_import VALUES (81138, '2020-12-05', 'ES', 'Spain', 'EURO', '8249', '1745076', '186', '47751');
INSERT INTO public.who_global_data_import VALUES (81139, '2020-12-06', 'ES', 'Spain', 'EURO', '8557', '1753633', '197', '47948');
INSERT INTO public.who_global_data_import VALUES (81140, '2020-12-07', 'ES', 'Spain', 'EURO', '4987', '1758620', '156', '48104');
INSERT INTO public.who_global_data_import VALUES (81141, '2020-12-08', 'ES', 'Spain', 'EURO', '3297', '1761917', '161', '48265');
INSERT INTO public.who_global_data_import VALUES (81142, '2020-12-09', 'ES', 'Spain', 'EURO', '5472', '1767389', '164', '48429');
INSERT INTO public.who_global_data_import VALUES (81143, '2020-12-10', 'ES', 'Spain', 'EURO', '4102', '1771491', '141', '48570');
INSERT INTO public.who_global_data_import VALUES (81144, '2020-12-11', 'ES', 'Spain', 'EURO', '8642', '1780133', '189', '48759');
INSERT INTO public.who_global_data_import VALUES (81145, '2020-12-12', 'ES', 'Spain', 'EURO', '10968', '1791101', '158', '48917');
INSERT INTO public.who_global_data_import VALUES (81146, '2020-12-13', 'ES', 'Spain', 'EURO', '11536', '1802637', '176', '49093');
INSERT INTO public.who_global_data_import VALUES (81147, '2020-12-14', 'ES', 'Spain', 'EURO', '6653', '1809290', '149', '49242');
INSERT INTO public.who_global_data_import VALUES (81148, '2020-12-15', 'ES', 'Spain', 'EURO', '4340', '1813630', '139', '49381');
INSERT INTO public.who_global_data_import VALUES (81149, '2020-12-16', 'ES', 'Spain', 'EURO', '10142', '1823772', '146', '49527');
INSERT INTO public.who_global_data_import VALUES (81150, '2020-12-17', 'ES', 'Spain', 'EURO', '12412', '1836184', '155', '49682');
INSERT INTO public.who_global_data_import VALUES (81151, '2020-12-18', 'ES', 'Spain', 'EURO', '11975', '1848159', '124', '49806');
INSERT INTO public.who_global_data_import VALUES (81152, '2020-12-19', 'ES', 'Spain', 'EURO', '11124', '1859283', '156', '49962');
INSERT INTO public.who_global_data_import VALUES (81153, '2020-12-20', 'ES', 'Spain', 'EURO', '12478', '1871761', '158', '50120');
INSERT INTO public.who_global_data_import VALUES (81154, '2020-12-21', 'ES', 'Spain', 'EURO', '6968', '1878729', '121', '50241');
INSERT INTO public.who_global_data_import VALUES (81155, '2020-12-22', 'ES', 'Spain', 'EURO', '4457', '1883186', '135', '50376');
INSERT INTO public.who_global_data_import VALUES (81156, '2020-12-23', 'ES', 'Spain', 'EURO', '11394', '1894580', '132', '50508');
INSERT INTO public.who_global_data_import VALUES (81157, '2020-12-24', 'ES', 'Spain', 'EURO', '13833', '1908413', '147', '50655');
INSERT INTO public.who_global_data_import VALUES (81158, '2020-12-25', 'ES', 'Spain', 'EURO', '14734', '1923147', '149', '50804');
INSERT INTO public.who_global_data_import VALUES (81159, '2020-12-26', 'ES', 'Spain', 'EURO', '10250', '1933397', '134', '50938');
INSERT INTO public.who_global_data_import VALUES (81160, '2020-12-27', 'ES', 'Spain', 'EURO', '5027', '1938424', '116', '51054');
INSERT INTO public.who_global_data_import VALUES (81161, '2020-12-28', 'ES', 'Spain', 'EURO', '6467', '1944891', '145', '51199');
INSERT INTO public.who_global_data_import VALUES (81162, '2020-12-29', 'ES', 'Spain', 'EURO', '6135', '1951026', '148', '51347');
INSERT INTO public.who_global_data_import VALUES (81163, '2020-12-30', 'ES', 'Spain', 'EURO', '15990', '1967016', '161', '51508');
INSERT INTO public.who_global_data_import VALUES (81164, '2020-12-31', 'ES', 'Spain', 'EURO', '19415', '1986431', '124', '51632');
INSERT INTO public.who_global_data_import VALUES (81165, '2021-01-01', 'ES', 'Spain', 'EURO', '20617', '2007048', '161', '51793');
INSERT INTO public.who_global_data_import VALUES (81166, '2021-01-02', 'ES', 'Spain', 'EURO', '13891', '2020939', '142', '51935');
INSERT INTO public.who_global_data_import VALUES (81167, '2021-01-03', 'ES', 'Spain', 'EURO', '7145', '2028084', '124', '52059');
INSERT INTO public.who_global_data_import VALUES (81168, '2021-01-04', 'ES', 'Spain', 'EURO', '9900', '2037984', '153', '52212');
INSERT INTO public.who_global_data_import VALUES (81169, '2021-01-05', 'ES', 'Spain', 'EURO', '9414', '2047398', '137', '52349');
INSERT INTO public.who_global_data_import VALUES (81170, '2021-01-06', 'ES', 'Spain', 'EURO', '21018', '2068416', '150', '52499');
INSERT INTO public.who_global_data_import VALUES (81171, '2021-01-07', 'ES', 'Spain', 'EURO', '29434', '2097850', '193', '52692');
INSERT INTO public.who_global_data_import VALUES (81172, '2021-01-08', 'ES', 'Spain', 'EURO', '13986', '2111836', '147', '52839');
INSERT INTO public.who_global_data_import VALUES (81173, '2021-01-09', 'ES', 'Spain', 'EURO', '25618', '2137454', '179', '53018');
INSERT INTO public.who_global_data_import VALUES (81174, '2021-01-10', 'ES', 'Spain', 'EURO', '31500', '2168954', '187', '53205');
INSERT INTO public.who_global_data_import VALUES (81175, '2021-01-11', 'ES', 'Spain', 'EURO', '18564', '2187518', '169', '53374');
INSERT INTO public.who_global_data_import VALUES (81176, '2021-01-12', 'ES', 'Spain', 'EURO', '13443', '2200961', '166', '53540');
INSERT INTO public.who_global_data_import VALUES (81177, '2021-01-13', 'ES', 'Spain', 'EURO', '31235', '2232196', '235', '53775');
INSERT INTO public.who_global_data_import VALUES (81178, '2021-01-14', 'ES', 'Spain', 'EURO', '36154', '2268350', '228', '54003');
INSERT INTO public.who_global_data_import VALUES (81179, '2021-01-15', 'ES', 'Spain', 'EURO', '37995', '2306345', '231', '54234');
INSERT INTO public.who_global_data_import VALUES (81180, '2021-01-16', 'ES', 'Spain', 'EURO', '37301', '2343646', '238', '54472');
INSERT INTO public.who_global_data_import VALUES (81181, '2021-01-17', 'ES', 'Spain', 'EURO', '42029', '2385675', '306', '54778');
INSERT INTO public.who_global_data_import VALUES (81182, '2021-01-18', 'ES', 'Spain', 'EURO', '24336', '2410011', '281', '55059');
INSERT INTO public.who_global_data_import VALUES (81183, '2021-01-19', 'ES', 'Spain', 'EURO', '18249', '2428260', '274', '55333');
INSERT INTO public.who_global_data_import VALUES (81184, '2021-01-20', 'ES', 'Spain', 'EURO', '34619', '2462879', '324', '55657');
INSERT INTO public.who_global_data_import VALUES (81185, '2021-01-21', 'ES', 'Spain', 'EURO', '41232', '2504111', '378', '56035');
INSERT INTO public.who_global_data_import VALUES (81186, '2021-01-22', 'ES', 'Spain', 'EURO', '40980', '2545091', '346', '56381');
INSERT INTO public.who_global_data_import VALUES (81187, '2021-01-23', 'ES', 'Spain', 'EURO', '39629', '2584720', '380', '56761');
INSERT INTO public.who_global_data_import VALUES (81188, '2021-01-24', 'ES', 'Spain', 'EURO', '41230', '2625950', '415', '57176');
INSERT INTO public.who_global_data_import VALUES (81189, '2021-01-25', 'ES', 'Spain', 'EURO', '23318', '2649268', '343', '57519');
INSERT INTO public.who_global_data_import VALUES (81190, '2021-01-26', 'ES', 'Spain', 'EURO', '16838', '2666106', '358', '57877');
INSERT INTO public.who_global_data_import VALUES (81191, '2021-01-27', 'ES', 'Spain', 'EURO', '31515', '2697621', '319', '58196');
INSERT INTO public.who_global_data_import VALUES (81192, '2021-01-28', 'ES', 'Spain', 'EURO', '36370', '2733991', '339', '58535');
INSERT INTO public.who_global_data_import VALUES (81193, '2021-01-29', 'ES', 'Spain', 'EURO', '34570', '2768561', '384', '58919');
INSERT INTO public.who_global_data_import VALUES (81194, '2021-01-30', 'ES', 'Spain', 'EURO', '32003', '2800564', '344', '59263');
INSERT INTO public.who_global_data_import VALUES (81195, '2021-01-31', 'ES', 'Spain', 'EURO', '30669', '2831233', '337', '59600');
INSERT INTO public.who_global_data_import VALUES (81196, '2021-02-01', 'ES', 'Spain', 'EURO', '17399', '2848632', '318', '59918');
INSERT INTO public.who_global_data_import VALUES (81197, '2021-02-02', 'ES', 'Spain', 'EURO', '11024', '2859656', '273', '60191');
INSERT INTO public.who_global_data_import VALUES (81198, '2021-02-03', 'ES', 'Spain', 'EURO', '20626', '2880282', '330', '60521');
INSERT INTO public.who_global_data_import VALUES (81199, '2021-02-04', 'ES', 'Spain', 'EURO', '21755', '2902037', '196', '60717');
INSERT INTO public.who_global_data_import VALUES (81200, '2021-02-05', 'ES', 'Spain', 'EURO', '11388', '2913425', '85', '60802');
INSERT INTO public.who_global_data_import VALUES (81201, '2020-01-03', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81202, '2020-01-04', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81203, '2020-01-05', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81204, '2020-01-06', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81205, '2020-01-07', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81206, '2020-01-08', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81207, '2020-01-09', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81208, '2020-01-10', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81209, '2020-01-11', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81210, '2020-01-12', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81211, '2020-01-13', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81212, '2020-01-14', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81213, '2020-01-15', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81214, '2020-01-16', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81215, '2020-01-17', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81216, '2020-01-18', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81217, '2020-01-19', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81218, '2020-01-20', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81219, '2020-01-21', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81220, '2020-01-22', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81221, '2020-01-23', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81222, '2020-01-24', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81223, '2020-01-25', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81224, '2020-01-26', 'LK', 'Sri Lanka', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81225, '2020-01-27', 'LK', 'Sri Lanka', 'SEARO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81226, '2020-01-28', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81227, '2020-01-29', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81228, '2020-01-30', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81229, '2020-01-31', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81230, '2020-02-01', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81231, '2020-02-02', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81232, '2020-02-03', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81233, '2020-02-04', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81234, '2020-02-05', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81235, '2020-02-06', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81236, '2020-02-07', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81237, '2020-02-08', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81238, '2020-02-09', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81239, '2020-02-10', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81240, '2020-02-11', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81241, '2020-02-12', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81242, '2020-02-13', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81243, '2020-02-14', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81244, '2020-02-15', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81245, '2020-02-16', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81246, '2020-02-17', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81247, '2020-02-18', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81248, '2020-02-19', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81249, '2020-02-20', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81250, '2020-02-21', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81251, '2020-02-22', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81252, '2020-02-23', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81253, '2020-02-24', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81254, '2020-02-25', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81255, '2020-02-26', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81256, '2020-02-27', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81257, '2020-02-28', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81258, '2020-02-29', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81259, '2020-03-01', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81260, '2020-03-02', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81261, '2020-03-03', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81262, '2020-03-04', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81263, '2020-03-05', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81264, '2020-03-06', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81265, '2020-03-07', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81266, '2020-03-08', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81267, '2020-03-09', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81268, '2020-03-10', 'LK', 'Sri Lanka', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81269, '2020-03-11', 'LK', 'Sri Lanka', 'SEARO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81270, '2020-03-12', 'LK', 'Sri Lanka', 'SEARO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81271, '2020-03-13', 'LK', 'Sri Lanka', 'SEARO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81272, '2020-03-14', 'LK', 'Sri Lanka', 'SEARO', '3', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81273, '2020-03-15', 'LK', 'Sri Lanka', 'SEARO', '5', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81274, '2020-03-16', 'LK', 'Sri Lanka', 'SEARO', '8', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81275, '2020-03-17', 'LK', 'Sri Lanka', 'SEARO', '10', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81276, '2020-03-18', 'LK', 'Sri Lanka', 'SEARO', '13', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81277, '2020-03-19', 'LK', 'Sri Lanka', 'SEARO', '13', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81278, '2020-03-20', 'LK', 'Sri Lanka', 'SEARO', '0', '59', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81279, '2020-03-21', 'LK', 'Sri Lanka', 'SEARO', '13', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81280, '2020-03-22', 'LK', 'Sri Lanka', 'SEARO', '0', '72', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81281, '2020-03-23', 'LK', 'Sri Lanka', 'SEARO', '22', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81282, '2020-03-24', 'LK', 'Sri Lanka', 'SEARO', '3', '97', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81283, '2020-03-25', 'LK', 'Sri Lanka', 'SEARO', '5', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81284, '2020-03-26', 'LK', 'Sri Lanka', 'SEARO', '0', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81285, '2020-03-27', 'LK', 'Sri Lanka', 'SEARO', '4', '106', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81286, '2020-03-28', 'LK', 'Sri Lanka', 'SEARO', '0', '106', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81287, '2020-03-29', 'LK', 'Sri Lanka', 'SEARO', '9', '115', '1', '1');
INSERT INTO public.who_global_data_import VALUES (81288, '2020-03-30', 'LK', 'Sri Lanka', 'SEARO', '5', '120', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81289, '2020-03-31', 'LK', 'Sri Lanka', 'SEARO', '2', '122', '1', '2');
INSERT INTO public.who_global_data_import VALUES (81290, '2020-04-01', 'LK', 'Sri Lanka', 'SEARO', '21', '143', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81291, '2020-04-02', 'LK', 'Sri Lanka', 'SEARO', '5', '148', '1', '3');
INSERT INTO public.who_global_data_import VALUES (81292, '2020-04-03', 'LK', 'Sri Lanka', 'SEARO', '3', '151', '1', '4');
INSERT INTO public.who_global_data_import VALUES (81293, '2020-04-04', 'LK', 'Sri Lanka', 'SEARO', '8', '159', '1', '5');
INSERT INTO public.who_global_data_import VALUES (81294, '2020-04-05', 'LK', 'Sri Lanka', 'SEARO', '7', '166', '0', '5');
INSERT INTO public.who_global_data_import VALUES (81295, '2020-04-06', 'LK', 'Sri Lanka', 'SEARO', '10', '176', '0', '5');
INSERT INTO public.who_global_data_import VALUES (81296, '2020-04-07', 'LK', 'Sri Lanka', 'SEARO', '4', '180', '1', '6');
INSERT INTO public.who_global_data_import VALUES (81297, '2020-04-08', 'LK', 'Sri Lanka', 'SEARO', '6', '186', '0', '6');
INSERT INTO public.who_global_data_import VALUES (81298, '2020-04-09', 'LK', 'Sri Lanka', 'SEARO', '3', '189', '1', '7');
INSERT INTO public.who_global_data_import VALUES (81299, '2020-04-10', 'LK', 'Sri Lanka', 'SEARO', '1', '190', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81300, '2020-04-11', 'LK', 'Sri Lanka', 'SEARO', '7', '197', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81301, '2020-04-12', 'LK', 'Sri Lanka', 'SEARO', '2', '199', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81302, '2020-04-13', 'LK', 'Sri Lanka', 'SEARO', '11', '210', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81303, '2020-04-14', 'LK', 'Sri Lanka', 'SEARO', '8', '218', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81304, '2020-04-15', 'LK', 'Sri Lanka', 'SEARO', '15', '233', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81305, '2020-04-16', 'LK', 'Sri Lanka', 'SEARO', '5', '238', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81306, '2020-04-17', 'LK', 'Sri Lanka', 'SEARO', '0', '238', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81307, '2020-04-18', 'LK', 'Sri Lanka', 'SEARO', '6', '244', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81308, '2020-04-19', 'LK', 'Sri Lanka', 'SEARO', '10', '254', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81309, '2020-04-20', 'LK', 'Sri Lanka', 'SEARO', '17', '271', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81310, '2020-04-21', 'LK', 'Sri Lanka', 'SEARO', '33', '304', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81311, '2020-04-22', 'LK', 'Sri Lanka', 'SEARO', '6', '310', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81312, '2020-04-23', 'LK', 'Sri Lanka', 'SEARO', '20', '330', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81313, '2020-04-24', 'LK', 'Sri Lanka', 'SEARO', '38', '368', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81314, '2020-04-25', 'LK', 'Sri Lanka', 'SEARO', '52', '420', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81315, '2020-04-26', 'LK', 'Sri Lanka', 'SEARO', '40', '460', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81316, '2020-04-27', 'LK', 'Sri Lanka', 'SEARO', '63', '523', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81317, '2020-04-28', 'LK', 'Sri Lanka', 'SEARO', '65', '588', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81318, '2020-04-29', 'LK', 'Sri Lanka', 'SEARO', '31', '619', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81319, '2020-04-30', 'LK', 'Sri Lanka', 'SEARO', '30', '649', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81320, '2020-05-01', 'LK', 'Sri Lanka', 'SEARO', '16', '665', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81321, '2020-05-02', 'LK', 'Sri Lanka', 'SEARO', '25', '690', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81322, '2020-05-03', 'LK', 'Sri Lanka', 'SEARO', '15', '705', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81323, '2020-05-04', 'LK', 'Sri Lanka', 'SEARO', '13', '718', '0', '7');
INSERT INTO public.who_global_data_import VALUES (81324, '2020-05-05', 'LK', 'Sri Lanka', 'SEARO', '37', '755', '1', '8');
INSERT INTO public.who_global_data_import VALUES (81325, '2020-05-06', 'LK', 'Sri Lanka', 'SEARO', '16', '771', '1', '9');
INSERT INTO public.who_global_data_import VALUES (81326, '2020-05-07', 'LK', 'Sri Lanka', 'SEARO', '26', '797', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81327, '2020-05-08', 'LK', 'Sri Lanka', 'SEARO', '27', '824', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81328, '2020-05-09', 'LK', 'Sri Lanka', 'SEARO', '11', '835', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81329, '2020-05-10', 'LK', 'Sri Lanka', 'SEARO', '12', '847', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81330, '2020-05-11', 'LK', 'Sri Lanka', 'SEARO', '16', '863', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81331, '2020-05-12', 'LK', 'Sri Lanka', 'SEARO', '6', '869', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81332, '2020-05-13', 'LK', 'Sri Lanka', 'SEARO', '24', '893', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81333, '2020-05-14', 'LK', 'Sri Lanka', 'SEARO', '23', '916', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81334, '2020-05-15', 'LK', 'Sri Lanka', 'SEARO', '9', '925', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81335, '2020-05-16', 'LK', 'Sri Lanka', 'SEARO', '24', '949', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81336, '2020-05-17', 'LK', 'Sri Lanka', 'SEARO', '21', '970', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81337, '2020-05-18', 'LK', 'Sri Lanka', 'SEARO', '16', '986', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81338, '2020-05-19', 'LK', 'Sri Lanka', 'SEARO', '34', '1020', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81339, '2020-05-20', 'LK', 'Sri Lanka', 'SEARO', '7', '1027', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81340, '2020-05-21', 'LK', 'Sri Lanka', 'SEARO', '18', '1045', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81341, '2020-05-22', 'LK', 'Sri Lanka', 'SEARO', '15', '1060', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81342, '2020-05-23', 'LK', 'Sri Lanka', 'SEARO', '25', '1085', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81343, '2020-05-24', 'LK', 'Sri Lanka', 'SEARO', '33', '1118', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81344, '2020-05-25', 'LK', 'Sri Lanka', 'SEARO', '64', '1182', '0', '9');
INSERT INTO public.who_global_data_import VALUES (81345, '2020-05-26', 'LK', 'Sri Lanka', 'SEARO', '96', '1278', '1', '10');
INSERT INTO public.who_global_data_import VALUES (81346, '2020-05-27', 'LK', 'Sri Lanka', 'SEARO', '147', '1425', '0', '10');
INSERT INTO public.who_global_data_import VALUES (81347, '2020-05-28', 'LK', 'Sri Lanka', 'SEARO', '78', '1503', '0', '10');
INSERT INTO public.who_global_data_import VALUES (81348, '2020-05-29', 'LK', 'Sri Lanka', 'SEARO', '37', '1540', '0', '10');
INSERT INTO public.who_global_data_import VALUES (81349, '2020-05-30', 'LK', 'Sri Lanka', 'SEARO', '26', '1566', '0', '10');
INSERT INTO public.who_global_data_import VALUES (81350, '2020-05-31', 'LK', 'Sri Lanka', 'SEARO', '64', '1630', '0', '10');
INSERT INTO public.who_global_data_import VALUES (81351, '2020-06-01', 'LK', 'Sri Lanka', 'SEARO', '3', '1633', '0', '10');
INSERT INTO public.who_global_data_import VALUES (81352, '2020-06-02', 'LK', 'Sri Lanka', 'SEARO', '10', '1643', '1', '11');
INSERT INTO public.who_global_data_import VALUES (81353, '2020-06-03', 'LK', 'Sri Lanka', 'SEARO', '40', '1683', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81354, '2020-06-04', 'LK', 'Sri Lanka', 'SEARO', '66', '1749', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81355, '2020-06-05', 'LK', 'Sri Lanka', 'SEARO', '48', '1797', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81356, '2020-06-06', 'LK', 'Sri Lanka', 'SEARO', '4', '1801', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81357, '2020-06-07', 'LK', 'Sri Lanka', 'SEARO', '13', '1814', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81358, '2020-06-08', 'LK', 'Sri Lanka', 'SEARO', '21', '1835', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81359, '2020-06-09', 'LK', 'Sri Lanka', 'SEARO', '22', '1857', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81360, '2020-06-10', 'LK', 'Sri Lanka', 'SEARO', '2', '1859', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81361, '2020-06-11', 'LK', 'Sri Lanka', 'SEARO', '10', '1869', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81362, '2020-06-12', 'LK', 'Sri Lanka', 'SEARO', '8', '1877', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81363, '2020-06-13', 'LK', 'Sri Lanka', 'SEARO', '3', '1880', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81364, '2020-06-14', 'LK', 'Sri Lanka', 'SEARO', '4', '1884', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81365, '2020-06-15', 'LK', 'Sri Lanka', 'SEARO', '5', '1889', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81366, '2020-06-16', 'LK', 'Sri Lanka', 'SEARO', '16', '1905', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81367, '2020-06-17', 'LK', 'Sri Lanka', 'SEARO', '10', '1915', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81368, '2020-06-18', 'LK', 'Sri Lanka', 'SEARO', '9', '1924', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81369, '2020-06-19', 'LK', 'Sri Lanka', 'SEARO', '23', '1947', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81370, '2020-06-20', 'LK', 'Sri Lanka', 'SEARO', '3', '1950', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81371, '2020-06-21', 'LK', 'Sri Lanka', 'SEARO', '0', '1950', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81372, '2020-06-22', 'LK', 'Sri Lanka', 'SEARO', '0', '1950', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81373, '2020-06-23', 'LK', 'Sri Lanka', 'SEARO', '1', '1951', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81374, '2020-06-24', 'LK', 'Sri Lanka', 'SEARO', '40', '1991', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81375, '2020-06-25', 'LK', 'Sri Lanka', 'SEARO', '10', '2001', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81376, '2020-06-26', 'LK', 'Sri Lanka', 'SEARO', '9', '2010', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81377, '2020-06-27', 'LK', 'Sri Lanka', 'SEARO', '4', '2014', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81378, '2020-06-28', 'LK', 'Sri Lanka', 'SEARO', '19', '2033', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81379, '2020-06-29', 'LK', 'Sri Lanka', 'SEARO', '4', '2037', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81380, '2020-06-30', 'LK', 'Sri Lanka', 'SEARO', '5', '2042', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81381, '2020-07-01', 'LK', 'Sri Lanka', 'SEARO', '5', '2047', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81382, '2020-07-02', 'LK', 'Sri Lanka', 'SEARO', '7', '2054', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81383, '2020-07-03', 'LK', 'Sri Lanka', 'SEARO', '12', '2066', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81384, '2020-07-04', 'LK', 'Sri Lanka', 'SEARO', '3', '2069', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81385, '2020-07-05', 'LK', 'Sri Lanka', 'SEARO', '5', '2074', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81386, '2020-07-06', 'LK', 'Sri Lanka', 'SEARO', '2', '2076', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81387, '2020-07-07', 'LK', 'Sri Lanka', 'SEARO', '2', '2078', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81388, '2020-07-08', 'LK', 'Sri Lanka', 'SEARO', '3', '2081', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81389, '2020-07-09', 'LK', 'Sri Lanka', 'SEARO', '13', '2094', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81390, '2020-07-10', 'LK', 'Sri Lanka', 'SEARO', '256', '2350', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81391, '2020-07-11', 'LK', 'Sri Lanka', 'SEARO', '104', '2454', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81392, '2020-07-12', 'LK', 'Sri Lanka', 'SEARO', '57', '2511', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81393, '2020-07-13', 'LK', 'Sri Lanka', 'SEARO', '106', '2617', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81394, '2020-07-14', 'LK', 'Sri Lanka', 'SEARO', '29', '2646', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81395, '2020-07-15', 'LK', 'Sri Lanka', 'SEARO', '19', '2665', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81396, '2020-07-16', 'LK', 'Sri Lanka', 'SEARO', '9', '2674', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81397, '2020-07-17', 'LK', 'Sri Lanka', 'SEARO', '13', '2687', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81398, '2020-07-18', 'LK', 'Sri Lanka', 'SEARO', '10', '2697', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81399, '2020-07-19', 'LK', 'Sri Lanka', 'SEARO', '11', '2708', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81400, '2020-07-20', 'LK', 'Sri Lanka', 'SEARO', '16', '2724', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81401, '2020-07-21', 'LK', 'Sri Lanka', 'SEARO', '6', '2730', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81402, '2020-07-22', 'LK', 'Sri Lanka', 'SEARO', '0', '2730', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81403, '2020-07-23', 'LK', 'Sri Lanka', 'SEARO', '22', '2752', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81404, '2020-07-24', 'LK', 'Sri Lanka', 'SEARO', '1', '2753', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81405, '2020-07-25', 'LK', 'Sri Lanka', 'SEARO', '11', '2764', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81406, '2020-07-26', 'LK', 'Sri Lanka', 'SEARO', '6', '2770', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81407, '2020-07-27', 'LK', 'Sri Lanka', 'SEARO', '12', '2782', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81408, '2020-07-28', 'LK', 'Sri Lanka', 'SEARO', '23', '2805', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81409, '2020-07-29', 'LK', 'Sri Lanka', 'SEARO', '5', '2810', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81410, '2020-07-30', 'LK', 'Sri Lanka', 'SEARO', '0', '2810', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81411, '2020-07-31', 'LK', 'Sri Lanka', 'SEARO', '4', '2814', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81412, '2020-08-01', 'LK', 'Sri Lanka', 'SEARO', '1', '2815', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81413, '2020-08-02', 'LK', 'Sri Lanka', 'SEARO', '0', '2815', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81414, '2020-08-03', 'LK', 'Sri Lanka', 'SEARO', '8', '2823', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81415, '2020-08-04', 'LK', 'Sri Lanka', 'SEARO', '5', '2828', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81416, '2020-08-05', 'LK', 'Sri Lanka', 'SEARO', '6', '2834', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81417, '2020-08-06', 'LK', 'Sri Lanka', 'SEARO', '5', '2839', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81418, '2020-08-07', 'LK', 'Sri Lanka', 'SEARO', '0', '2839', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81419, '2020-08-08', 'LK', 'Sri Lanka', 'SEARO', '0', '2839', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81420, '2020-08-09', 'LK', 'Sri Lanka', 'SEARO', '2', '2841', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81421, '2020-08-10', 'LK', 'Sri Lanka', 'SEARO', '3', '2844', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81422, '2020-08-11', 'LK', 'Sri Lanka', 'SEARO', '27', '2871', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81423, '2020-08-12', 'LK', 'Sri Lanka', 'SEARO', '9', '2880', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81424, '2020-08-13', 'LK', 'Sri Lanka', 'SEARO', '0', '2880', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81425, '2020-08-14', 'LK', 'Sri Lanka', 'SEARO', '2', '2882', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81426, '2020-08-15', 'LK', 'Sri Lanka', 'SEARO', '0', '2882', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81427, '2020-08-16', 'LK', 'Sri Lanka', 'SEARO', '4', '2886', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81428, '2020-08-17', 'LK', 'Sri Lanka', 'SEARO', '7', '2893', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81429, '2020-08-18', 'LK', 'Sri Lanka', 'SEARO', '7', '2900', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81430, '2020-08-19', 'LK', 'Sri Lanka', 'SEARO', '2', '2902', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81431, '2020-08-20', 'LK', 'Sri Lanka', 'SEARO', '0', '2902', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81432, '2020-08-21', 'LK', 'Sri Lanka', 'SEARO', '16', '2918', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81433, '2020-08-22', 'LK', 'Sri Lanka', 'SEARO', '0', '2918', '0', '11');
INSERT INTO public.who_global_data_import VALUES (81434, '2020-08-23', 'LK', 'Sri Lanka', 'SEARO', '29', '2947', '1', '12');
INSERT INTO public.who_global_data_import VALUES (81435, '2020-08-24', 'LK', 'Sri Lanka', 'SEARO', '6', '2953', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81436, '2020-08-25', 'LK', 'Sri Lanka', 'SEARO', '6', '2959', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81437, '2020-08-26', 'LK', 'Sri Lanka', 'SEARO', '0', '2959', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81438, '2020-08-27', 'LK', 'Sri Lanka', 'SEARO', '25', '2984', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81439, '2020-08-28', 'LK', 'Sri Lanka', 'SEARO', '2', '2986', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81440, '2020-08-29', 'LK', 'Sri Lanka', 'SEARO', '2', '2988', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81441, '2020-08-30', 'LK', 'Sri Lanka', 'SEARO', '7', '2995', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81442, '2020-08-31', 'LK', 'Sri Lanka', 'SEARO', '17', '3012', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81443, '2020-09-01', 'LK', 'Sri Lanka', 'SEARO', '37', '3049', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81444, '2020-09-02', 'LK', 'Sri Lanka', 'SEARO', '43', '3092', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81445, '2020-09-03', 'LK', 'Sri Lanka', 'SEARO', '10', '3102', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81446, '2020-09-04', 'LK', 'Sri Lanka', 'SEARO', '9', '3111', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81447, '2020-09-05', 'LK', 'Sri Lanka', 'SEARO', '4', '3115', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81448, '2020-09-06', 'LK', 'Sri Lanka', 'SEARO', '6', '3121', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81449, '2020-09-07', 'LK', 'Sri Lanka', 'SEARO', '2', '3123', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81450, '2020-09-08', 'LK', 'Sri Lanka', 'SEARO', '0', '3123', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81451, '2020-09-09', 'LK', 'Sri Lanka', 'SEARO', '17', '3140', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81452, '2020-09-10', 'LK', 'Sri Lanka', 'SEARO', '7', '3147', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81453, '2020-09-11', 'LK', 'Sri Lanka', 'SEARO', '8', '3155', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81454, '2020-09-12', 'LK', 'Sri Lanka', 'SEARO', '14', '3169', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81455, '2020-09-13', 'LK', 'Sri Lanka', 'SEARO', '35', '3204', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81456, '2020-09-14', 'LK', 'Sri Lanka', 'SEARO', '30', '3234', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81457, '2020-09-15', 'LK', 'Sri Lanka', 'SEARO', '28', '3262', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81458, '2020-09-16', 'LK', 'Sri Lanka', 'SEARO', '9', '3271', '1', '13');
INSERT INTO public.who_global_data_import VALUES (81459, '2020-09-17', 'LK', 'Sri Lanka', 'SEARO', '0', '3271', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81460, '2020-09-18', 'LK', 'Sri Lanka', 'SEARO', '5', '3276', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81461, '2020-09-19', 'LK', 'Sri Lanka', 'SEARO', '5', '3281', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81462, '2020-09-20', 'LK', 'Sri Lanka', 'SEARO', '2', '3283', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81463, '2020-09-21', 'LK', 'Sri Lanka', 'SEARO', '4', '3287', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81464, '2020-09-22', 'LK', 'Sri Lanka', 'SEARO', '12', '3299', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81465, '2020-09-23', 'LK', 'Sri Lanka', 'SEARO', '14', '3313', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81466, '2020-09-24', 'LK', 'Sri Lanka', 'SEARO', '11', '3324', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81467, '2020-09-25', 'LK', 'Sri Lanka', 'SEARO', '9', '3333', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81468, '2020-09-26', 'LK', 'Sri Lanka', 'SEARO', '12', '3345', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81469, '2020-09-27', 'LK', 'Sri Lanka', 'SEARO', '4', '3349', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81470, '2020-09-28', 'LK', 'Sri Lanka', 'SEARO', '11', '3360', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81471, '2020-09-29', 'LK', 'Sri Lanka', 'SEARO', '3', '3363', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81472, '2020-09-30', 'LK', 'Sri Lanka', 'SEARO', '11', '3374', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81473, '2020-10-01', 'LK', 'Sri Lanka', 'SEARO', '6', '3380', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81474, '2020-10-02', 'LK', 'Sri Lanka', 'SEARO', '2', '3382', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81475, '2020-10-03', 'LK', 'Sri Lanka', 'SEARO', '6', '3388', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81476, '2020-10-04', 'LK', 'Sri Lanka', 'SEARO', '7', '3395', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81477, '2020-10-05', 'LK', 'Sri Lanka', 'SEARO', '76', '3471', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81478, '2020-10-06', 'LK', 'Sri Lanka', 'SEARO', '262', '3733', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81479, '2020-10-07', 'LK', 'Sri Lanka', 'SEARO', '519', '4252', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81480, '2020-10-08', 'LK', 'Sri Lanka', 'SEARO', '207', '4459', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81481, '2020-10-09', 'LK', 'Sri Lanka', 'SEARO', '29', '4488', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81482, '2020-10-10', 'LK', 'Sri Lanka', 'SEARO', '35', '4523', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81483, '2020-10-11', 'LK', 'Sri Lanka', 'SEARO', '105', '4628', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81484, '2020-10-12', 'LK', 'Sri Lanka', 'SEARO', '124', '4752', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81485, '2020-10-13', 'LK', 'Sri Lanka', 'SEARO', '92', '4844', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81486, '2020-10-14', 'LK', 'Sri Lanka', 'SEARO', '194', '5038', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81487, '2020-10-15', 'LK', 'Sri Lanka', 'SEARO', '130', '5168', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81488, '2020-10-16', 'LK', 'Sri Lanka', 'SEARO', '76', '5244', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81489, '2020-10-17', 'LK', 'Sri Lanka', 'SEARO', '110', '5354', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81490, '2020-10-18', 'LK', 'Sri Lanka', 'SEARO', '121', '5475', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81491, '2020-10-19', 'LK', 'Sri Lanka', 'SEARO', '63', '5538', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81492, '2020-10-20', 'LK', 'Sri Lanka', 'SEARO', '87', '5625', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81493, '2020-10-21', 'LK', 'Sri Lanka', 'SEARO', '186', '5811', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81494, '2020-10-22', 'LK', 'Sri Lanka', 'SEARO', '167', '5978', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81495, '2020-10-23', 'LK', 'Sri Lanka', 'SEARO', '309', '6287', '1', '14');
INSERT INTO public.who_global_data_import VALUES (81496, '2020-10-24', 'LK', 'Sri Lanka', 'SEARO', '866', '7153', '0', '14');
INSERT INTO public.who_global_data_import VALUES (81497, '2020-10-25', 'LK', 'Sri Lanka', 'SEARO', '368', '7521', '0', '14');
INSERT INTO public.who_global_data_import VALUES (81498, '2020-10-26', 'LK', 'Sri Lanka', 'SEARO', '351', '7872', '1', '15');
INSERT INTO public.who_global_data_import VALUES (81499, '2020-10-27', 'LK', 'Sri Lanka', 'SEARO', '541', '8413', '1', '16');
INSERT INTO public.who_global_data_import VALUES (81500, '2020-10-28', 'LK', 'Sri Lanka', 'SEARO', '457', '8870', '3', '19');
INSERT INTO public.who_global_data_import VALUES (81501, '2020-10-29', 'LK', 'Sri Lanka', 'SEARO', '335', '9205', '0', '19');
INSERT INTO public.who_global_data_import VALUES (81502, '2020-10-30', 'LK', 'Sri Lanka', 'SEARO', '586', '9791', '0', '19');
INSERT INTO public.who_global_data_import VALUES (81503, '2020-10-31', 'LK', 'Sri Lanka', 'SEARO', '633', '10424', '0', '19');
INSERT INTO public.who_global_data_import VALUES (81504, '2020-11-01', 'LK', 'Sri Lanka', 'SEARO', '239', '10663', '1', '20');
INSERT INTO public.who_global_data_import VALUES (81505, '2020-11-02', 'LK', 'Sri Lanka', 'SEARO', '397', '11060', '1', '21');
INSERT INTO public.who_global_data_import VALUES (81506, '2020-11-03', 'LK', 'Sri Lanka', 'SEARO', '275', '11335', '0', '21');
INSERT INTO public.who_global_data_import VALUES (81507, '2020-11-04', 'LK', 'Sri Lanka', 'SEARO', '409', '11744', '2', '23');
INSERT INTO public.who_global_data_import VALUES (81508, '2020-11-05', 'LK', 'Sri Lanka', 'SEARO', '443', '12187', '1', '24');
INSERT INTO public.who_global_data_import VALUES (81509, '2020-11-06', 'LK', 'Sri Lanka', 'SEARO', '383', '12570', '5', '29');
INSERT INTO public.who_global_data_import VALUES (81510, '2020-11-07', 'LK', 'Sri Lanka', 'SEARO', '400', '12970', '1', '30');
INSERT INTO public.who_global_data_import VALUES (81511, '2020-11-08', 'LK', 'Sri Lanka', 'SEARO', '449', '13419', '4', '34');
INSERT INTO public.who_global_data_import VALUES (81512, '2020-11-09', 'LK', 'Sri Lanka', 'SEARO', '510', '13929', '1', '35');
INSERT INTO public.who_global_data_import VALUES (81513, '2020-11-10', 'LK', 'Sri Lanka', 'SEARO', '356', '14285', '0', '35');
INSERT INTO public.who_global_data_import VALUES (81514, '2020-11-11', 'LK', 'Sri Lanka', 'SEARO', '430', '14715', '6', '41');
INSERT INTO public.who_global_data_import VALUES (81515, '2020-11-12', 'LK', 'Sri Lanka', 'SEARO', '0', '14715', '0', '41');
INSERT INTO public.who_global_data_import VALUES (81516, '2020-11-13', 'LK', 'Sri Lanka', 'SEARO', '635', '15350', '5', '46');
INSERT INTO public.who_global_data_import VALUES (81517, '2020-11-14', 'LK', 'Sri Lanka', 'SEARO', '373', '15723', '2', '48');
INSERT INTO public.who_global_data_import VALUES (81518, '2020-11-15', 'LK', 'Sri Lanka', 'SEARO', '468', '16191', '5', '53');
INSERT INTO public.who_global_data_import VALUES (81519, '2020-11-16', 'LK', 'Sri Lanka', 'SEARO', '1096', '17287', '5', '58');
INSERT INTO public.who_global_data_import VALUES (81520, '2020-11-17', 'LK', 'Sri Lanka', 'SEARO', '387', '17674', '3', '61');
INSERT INTO public.who_global_data_import VALUES (81521, '2020-11-18', 'LK', 'Sri Lanka', 'SEARO', '401', '18075', '5', '66');
INSERT INTO public.who_global_data_import VALUES (81522, '2020-11-19', 'LK', 'Sri Lanka', 'SEARO', '327', '18402', '3', '69');
INSERT INTO public.who_global_data_import VALUES (81523, '2020-11-20', 'LK', 'Sri Lanka', 'SEARO', '439', '18841', '4', '73');
INSERT INTO public.who_global_data_import VALUES (81524, '2020-11-21', 'LK', 'Sri Lanka', 'SEARO', '439', '19280', '1', '74');
INSERT INTO public.who_global_data_import VALUES (81525, '2020-11-22', 'LK', 'Sri Lanka', 'SEARO', '491', '19771', '9', '83');
INSERT INTO public.who_global_data_import VALUES (81526, '2020-11-23', 'LK', 'Sri Lanka', 'SEARO', '400', '20171', '4', '87');
INSERT INTO public.who_global_data_import VALUES (81527, '2020-11-24', 'LK', 'Sri Lanka', 'SEARO', '337', '20508', '3', '90');
INSERT INTO public.who_global_data_import VALUES (81528, '2020-11-25', 'LK', 'Sri Lanka', 'SEARO', '459', '20967', '4', '94');
INSERT INTO public.who_global_data_import VALUES (81529, '2020-11-26', 'LK', 'Sri Lanka', 'SEARO', '502', '21469', '2', '96');
INSERT INTO public.who_global_data_import VALUES (81530, '2020-11-27', 'LK', 'Sri Lanka', 'SEARO', '559', '22028', '3', '99');
INSERT INTO public.who_global_data_import VALUES (81531, '2020-11-28', 'LK', 'Sri Lanka', 'SEARO', '473', '22501', '8', '107');
INSERT INTO public.who_global_data_import VALUES (81532, '2020-11-29', 'LK', 'Sri Lanka', 'SEARO', '0', '22501', '0', '107');
INSERT INTO public.who_global_data_import VALUES (81533, '2020-11-30', 'LK', 'Sri Lanka', 'SEARO', '487', '22988', '2', '109');
INSERT INTO public.who_global_data_import VALUES (81534, '2020-12-01', 'LK', 'Sri Lanka', 'SEARO', '496', '23484', '7', '116');
INSERT INTO public.who_global_data_import VALUES (81535, '2020-12-02', 'LK', 'Sri Lanka', 'SEARO', '1048', '24532', '6', '122');
INSERT INTO public.who_global_data_import VALUES (81536, '2020-12-03', 'LK', 'Sri Lanka', 'SEARO', '878', '25410', '2', '124');
INSERT INTO public.who_global_data_import VALUES (81537, '2020-12-04', 'LK', 'Sri Lanka', 'SEARO', '0', '25410', '0', '124');
INSERT INTO public.who_global_data_import VALUES (81538, '2020-12-05', 'LK', 'Sri Lanka', 'SEARO', '628', '26038', '5', '129');
INSERT INTO public.who_global_data_import VALUES (81539, '2020-12-06', 'LK', 'Sri Lanka', 'SEARO', '1190', '27228', '8', '137');
INSERT INTO public.who_global_data_import VALUES (81540, '2020-12-07', 'LK', 'Sri Lanka', 'SEARO', '0', '27228', '0', '137');
INSERT INTO public.who_global_data_import VALUES (81541, '2020-12-08', 'LK', 'Sri Lanka', 'SEARO', '649', '27877', '3', '140');
INSERT INTO public.who_global_data_import VALUES (81542, '2020-12-09', 'LK', 'Sri Lanka', 'SEARO', '1501', '29378', '2', '142');
INSERT INTO public.who_global_data_import VALUES (81543, '2020-12-10', 'LK', 'Sri Lanka', 'SEARO', '0', '29378', '0', '142');
INSERT INTO public.who_global_data_import VALUES (81544, '2020-12-11', 'LK', 'Sri Lanka', 'SEARO', '1235', '30613', '4', '146');
INSERT INTO public.who_global_data_import VALUES (81545, '2020-12-12', 'LK', 'Sri Lanka', 'SEARO', '0', '30613', '0', '146');
INSERT INTO public.who_global_data_import VALUES (81546, '2020-12-13', 'LK', 'Sri Lanka', 'SEARO', '1522', '32135', '3', '149');
INSERT INTO public.who_global_data_import VALUES (81547, '2020-12-14', 'LK', 'Sri Lanka', 'SEARO', '655', '32790', '3', '152');
INSERT INTO public.who_global_data_import VALUES (81548, '2020-12-15', 'LK', 'Sri Lanka', 'SEARO', '688', '33478', '2', '154');
INSERT INTO public.who_global_data_import VALUES (81549, '2020-12-16', 'LK', 'Sri Lanka', 'SEARO', '643', '34121', '0', '154');
INSERT INTO public.who_global_data_import VALUES (81550, '2020-12-17', 'LK', 'Sri Lanka', 'SEARO', '0', '34121', '0', '154');
INSERT INTO public.who_global_data_import VALUES (81551, '2020-12-18', 'LK', 'Sri Lanka', 'SEARO', '1266', '35387', '6', '160');
INSERT INTO public.who_global_data_import VALUES (81552, '2020-12-19', 'LK', 'Sri Lanka', 'SEARO', '0', '35387', '0', '160');
INSERT INTO public.who_global_data_import VALUES (81553, '2020-12-20', 'LK', 'Sri Lanka', 'SEARO', '662', '36049', '5', '165');
INSERT INTO public.who_global_data_import VALUES (81554, '2020-12-21', 'LK', 'Sri Lanka', 'SEARO', '1212', '37261', '11', '176');
INSERT INTO public.who_global_data_import VALUES (81555, '2020-12-22', 'LK', 'Sri Lanka', 'SEARO', '0', '37261', '0', '176');
INSERT INTO public.who_global_data_import VALUES (81556, '2020-12-23', 'LK', 'Sri Lanka', 'SEARO', '798', '38059', '7', '183');
INSERT INTO public.who_global_data_import VALUES (81557, '2020-12-24', 'LK', 'Sri Lanka', 'SEARO', '580', '38639', '1', '184');
INSERT INTO public.who_global_data_import VALUES (81558, '2020-12-25', 'LK', 'Sri Lanka', 'SEARO', '0', '38639', '0', '184');
INSERT INTO public.who_global_data_import VALUES (81559, '2020-12-26', 'LK', 'Sri Lanka', 'SEARO', '1143', '39782', '2', '186');
INSERT INTO public.who_global_data_import VALUES (81560, '2020-12-27', 'LK', 'Sri Lanka', 'SEARO', '598', '40380', '1', '187');
INSERT INTO public.who_global_data_import VALUES (81561, '2020-12-28', 'LK', 'Sri Lanka', 'SEARO', '674', '41054', '4', '191');
INSERT INTO public.who_global_data_import VALUES (81562, '2020-12-29', 'LK', 'Sri Lanka', 'SEARO', '549', '41603', '3', '194');
INSERT INTO public.who_global_data_import VALUES (81563, '2020-12-30', 'LK', 'Sri Lanka', 'SEARO', '460', '42063', '0', '194');
INSERT INTO public.who_global_data_import VALUES (81564, '2020-12-31', 'LK', 'Sri Lanka', 'SEARO', '639', '42702', '5', '199');
INSERT INTO public.who_global_data_import VALUES (81565, '2021-01-01', 'LK', 'Sri Lanka', 'SEARO', '597', '43299', '5', '204');
INSERT INTO public.who_global_data_import VALUES (81566, '2021-01-02', 'LK', 'Sri Lanka', 'SEARO', '557', '43856', '0', '204');
INSERT INTO public.who_global_data_import VALUES (81567, '2021-01-03', 'LK', 'Sri Lanka', 'SEARO', '515', '44371', '7', '211');
INSERT INTO public.who_global_data_import VALUES (81568, '2021-01-04', 'LK', 'Sri Lanka', 'SEARO', '403', '44774', '2', '213');
INSERT INTO public.who_global_data_import VALUES (81569, '2021-01-05', 'LK', 'Sri Lanka', 'SEARO', '468', '45242', '2', '215');
INSERT INTO public.who_global_data_import VALUES (81570, '2021-01-06', 'LK', 'Sri Lanka', 'SEARO', '484', '45726', '2', '217');
INSERT INTO public.who_global_data_import VALUES (81571, '2021-01-07', 'LK', 'Sri Lanka', 'SEARO', '522', '46248', '2', '219');
INSERT INTO public.who_global_data_import VALUES (81572, '2021-01-08', 'LK', 'Sri Lanka', 'SEARO', '532', '46780', '0', '219');
INSERT INTO public.who_global_data_import VALUES (81573, '2021-01-09', 'LK', 'Sri Lanka', 'SEARO', '525', '47305', '3', '222');
INSERT INTO public.who_global_data_import VALUES (81574, '2021-01-10', 'LK', 'Sri Lanka', 'SEARO', '535', '47840', '7', '229');
INSERT INTO public.who_global_data_import VALUES (81575, '2021-01-11', 'LK', 'Sri Lanka', 'SEARO', '540', '48380', '3', '232');
INSERT INTO public.who_global_data_import VALUES (81576, '2021-01-12', 'LK', 'Sri Lanka', 'SEARO', '569', '48949', '0', '232');
INSERT INTO public.who_global_data_import VALUES (81577, '2021-01-13', 'LK', 'Sri Lanka', 'SEARO', '588', '49537', '12', '244');
INSERT INTO public.who_global_data_import VALUES (81578, '2021-01-14', 'LK', 'Sri Lanka', 'SEARO', '692', '50229', '3', '247');
INSERT INTO public.who_global_data_import VALUES (81579, '2021-01-15', 'LK', 'Sri Lanka', 'SEARO', '670', '50899', '4', '251');
INSERT INTO public.who_global_data_import VALUES (81580, '2021-01-16', 'LK', 'Sri Lanka', 'SEARO', '695', '51594', '4', '255');
INSERT INTO public.who_global_data_import VALUES (81581, '2021-01-17', 'LK', 'Sri Lanka', 'SEARO', '719', '52313', '1', '256');
INSERT INTO public.who_global_data_import VALUES (81582, '2021-01-18', 'LK', 'Sri Lanka', 'SEARO', '749', '53062', '8', '264');
INSERT INTO public.who_global_data_import VALUES (81583, '2021-01-19', 'LK', 'Sri Lanka', 'SEARO', '688', '53750', '6', '270');
INSERT INTO public.who_global_data_import VALUES (81584, '2021-01-20', 'LK', 'Sri Lanka', 'SEARO', '669', '54419', '3', '273');
INSERT INTO public.who_global_data_import VALUES (81585, '2021-01-21', 'LK', 'Sri Lanka', 'SEARO', '770', '55189', '1', '274');
INSERT INTO public.who_global_data_import VALUES (81586, '2021-01-22', 'LK', 'Sri Lanka', 'SEARO', '887', '56076', '2', '276');
INSERT INTO public.who_global_data_import VALUES (81587, '2021-01-23', 'LK', 'Sri Lanka', 'SEARO', '787', '56863', '2', '278');
INSERT INTO public.who_global_data_import VALUES (81588, '2021-01-24', 'LK', 'Sri Lanka', 'SEARO', '724', '57587', '2', '280');
INSERT INTO public.who_global_data_import VALUES (81589, '2021-01-25', 'LK', 'Sri Lanka', 'SEARO', '843', '58430', '3', '283');
INSERT INTO public.who_global_data_import VALUES (81590, '2021-01-26', 'LK', 'Sri Lanka', 'SEARO', '737', '59167', '0', '283');
INSERT INTO public.who_global_data_import VALUES (81591, '2021-01-27', 'LK', 'Sri Lanka', 'SEARO', '755', '59922', '5', '288');
INSERT INTO public.who_global_data_import VALUES (81592, '2021-01-28', 'LK', 'Sri Lanka', 'SEARO', '772', '60694', '2', '290');
INSERT INTO public.who_global_data_import VALUES (81593, '2021-01-29', 'LK', 'Sri Lanka', 'SEARO', '892', '61586', '7', '297');
INSERT INTO public.who_global_data_import VALUES (81594, '2021-01-30', 'LK', 'Sri Lanka', 'SEARO', '859', '62445', '8', '305');
INSERT INTO public.who_global_data_import VALUES (81595, '2021-01-31', 'LK', 'Sri Lanka', 'SEARO', '848', '63293', '8', '313');
INSERT INTO public.who_global_data_import VALUES (81596, '2021-02-01', 'LK', 'Sri Lanka', 'SEARO', '864', '64157', '3', '316');
INSERT INTO public.who_global_data_import VALUES (81597, '2021-02-02', 'LK', 'Sri Lanka', 'SEARO', '826', '64983', '7', '323');
INSERT INTO public.who_global_data_import VALUES (81598, '2021-02-03', 'LK', 'Sri Lanka', 'SEARO', '715', '65698', '7', '330');
INSERT INTO public.who_global_data_import VALUES (81599, '2021-02-04', 'LK', 'Sri Lanka', 'SEARO', '711', '66409', '2', '332');
INSERT INTO public.who_global_data_import VALUES (81600, '2021-02-05', 'LK', 'Sri Lanka', 'SEARO', '706', '67115', '7', '339');
INSERT INTO public.who_global_data_import VALUES (81601, '2020-01-03', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81602, '2020-01-04', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81603, '2020-01-05', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81604, '2020-01-06', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81605, '2020-01-07', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81606, '2020-01-08', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81607, '2020-01-09', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81608, '2020-01-10', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81609, '2020-01-11', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81610, '2020-01-12', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81611, '2020-01-13', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81612, '2020-01-14', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81613, '2020-01-15', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81614, '2020-01-16', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81615, '2020-01-17', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81616, '2020-01-18', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81617, '2020-01-19', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81618, '2020-01-20', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81619, '2020-01-21', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81620, '2020-01-22', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81621, '2020-01-23', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81622, '2020-01-24', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81623, '2020-01-25', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81624, '2020-01-26', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81625, '2020-01-27', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81626, '2020-01-28', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81627, '2020-01-29', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81628, '2020-01-30', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81629, '2020-01-31', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81630, '2020-02-01', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81631, '2020-02-02', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81632, '2020-02-03', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81633, '2020-02-04', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81634, '2020-02-05', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81635, '2020-02-06', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81636, '2020-02-07', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81637, '2020-02-08', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81638, '2020-02-09', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81639, '2020-02-10', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81640, '2020-02-11', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81641, '2020-02-12', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81642, '2020-02-13', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81643, '2020-02-14', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81644, '2020-02-15', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81645, '2020-02-16', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81646, '2020-02-17', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81647, '2020-02-18', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81648, '2020-02-19', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81649, '2020-02-20', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81650, '2020-02-21', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81651, '2020-02-22', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81652, '2020-02-23', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81653, '2020-02-24', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81654, '2020-02-25', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81655, '2020-02-26', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81656, '2020-02-27', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81657, '2020-02-28', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81658, '2020-02-29', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81659, '2020-03-01', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81660, '2020-03-02', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81661, '2020-03-03', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81662, '2020-03-04', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81663, '2020-03-05', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81664, '2020-03-06', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81665, '2020-03-07', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81666, '2020-03-08', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81667, '2020-03-09', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81668, '2020-03-10', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81669, '2020-03-11', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81670, '2020-03-12', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81671, '2020-03-13', 'SD', 'Sudan', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81672, '2020-03-14', 'SD', 'Sudan', 'EMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (81673, '2020-03-15', 'SD', 'Sudan', 'EMRO', '0', '1', '1', '1');
INSERT INTO public.who_global_data_import VALUES (81674, '2020-03-16', 'SD', 'Sudan', 'EMRO', '0', '1', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81675, '2020-03-17', 'SD', 'Sudan', 'EMRO', '0', '1', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81676, '2020-03-18', 'SD', 'Sudan', 'EMRO', '0', '1', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81677, '2020-03-19', 'SD', 'Sudan', 'EMRO', '0', '1', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81678, '2020-03-20', 'SD', 'Sudan', 'EMRO', '0', '1', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81679, '2020-03-21', 'SD', 'Sudan', 'EMRO', '1', '2', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81680, '2020-03-22', 'SD', 'Sudan', 'EMRO', '0', '2', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81681, '2020-03-23', 'SD', 'Sudan', 'EMRO', '0', '2', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81682, '2020-03-24', 'SD', 'Sudan', 'EMRO', '1', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81683, '2020-03-25', 'SD', 'Sudan', 'EMRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81684, '2020-03-26', 'SD', 'Sudan', 'EMRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81685, '2020-03-27', 'SD', 'Sudan', 'EMRO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81686, '2020-03-28', 'SD', 'Sudan', 'EMRO', '2', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81687, '2020-03-29', 'SD', 'Sudan', 'EMRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (81688, '2020-03-30', 'SD', 'Sudan', 'EMRO', '1', '6', '1', '2');
INSERT INTO public.who_global_data_import VALUES (81689, '2020-03-31', 'SD', 'Sudan', 'EMRO', '1', '7', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81690, '2020-04-01', 'SD', 'Sudan', 'EMRO', '0', '7', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81691, '2020-04-02', 'SD', 'Sudan', 'EMRO', '0', '7', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81692, '2020-04-03', 'SD', 'Sudan', 'EMRO', '3', '10', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81693, '2020-04-04', 'SD', 'Sudan', 'EMRO', '0', '10', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81694, '2020-04-05', 'SD', 'Sudan', 'EMRO', '2', '12', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81695, '2020-04-06', 'SD', 'Sudan', 'EMRO', '0', '12', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81696, '2020-04-07', 'SD', 'Sudan', 'EMRO', '2', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81697, '2020-04-08', 'SD', 'Sudan', 'EMRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81698, '2020-04-09', 'SD', 'Sudan', 'EMRO', '0', '14', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81699, '2020-04-10', 'SD', 'Sudan', 'EMRO', '1', '15', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81700, '2020-04-11', 'SD', 'Sudan', 'EMRO', '4', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81701, '2020-04-12', 'SD', 'Sudan', 'EMRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81702, '2020-04-13', 'SD', 'Sudan', 'EMRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (81703, '2020-04-14', 'SD', 'Sudan', 'EMRO', '10', '29', '2', '4');
INSERT INTO public.who_global_data_import VALUES (81704, '2020-04-15', 'SD', 'Sudan', 'EMRO', '3', '32', '1', '5');
INSERT INTO public.who_global_data_import VALUES (81705, '2020-04-16', 'SD', 'Sudan', 'EMRO', '0', '32', '0', '5');
INSERT INTO public.who_global_data_import VALUES (81706, '2020-04-17', 'SD', 'Sudan', 'EMRO', '0', '32', '0', '5');
INSERT INTO public.who_global_data_import VALUES (81707, '2020-04-18', 'SD', 'Sudan', 'EMRO', '34', '66', '5', '10');
INSERT INTO public.who_global_data_import VALUES (81708, '2020-04-19', 'SD', 'Sudan', 'EMRO', '0', '66', '0', '10');
INSERT INTO public.who_global_data_import VALUES (81709, '2020-04-20', 'SD', 'Sudan', 'EMRO', '26', '92', '2', '12');
INSERT INTO public.who_global_data_import VALUES (81710, '2020-04-21', 'SD', 'Sudan', 'EMRO', '15', '107', '0', '12');
INSERT INTO public.who_global_data_import VALUES (81711, '2020-04-22', 'SD', 'Sudan', 'EMRO', '33', '140', '1', '13');
INSERT INTO public.who_global_data_import VALUES (81712, '2020-04-23', 'SD', 'Sudan', 'EMRO', '22', '162', '0', '13');
INSERT INTO public.who_global_data_import VALUES (81713, '2020-04-24', 'SD', 'Sudan', 'EMRO', '12', '174', '3', '16');
INSERT INTO public.who_global_data_import VALUES (81714, '2020-04-25', 'SD', 'Sudan', 'EMRO', '39', '213', '1', '17');
INSERT INTO public.who_global_data_import VALUES (81715, '2020-04-26', 'SD', 'Sudan', 'EMRO', '24', '237', '4', '21');
INSERT INTO public.who_global_data_import VALUES (81716, '2020-04-27', 'SD', 'Sudan', 'EMRO', '38', '275', '1', '22');
INSERT INTO public.who_global_data_import VALUES (81717, '2020-04-28', 'SD', 'Sudan', 'EMRO', '43', '318', '3', '25');
INSERT INTO public.who_global_data_import VALUES (81718, '2020-04-29', 'SD', 'Sudan', 'EMRO', '57', '375', '3', '28');
INSERT INTO public.who_global_data_import VALUES (81719, '2020-04-30', 'SD', 'Sudan', 'EMRO', '0', '375', '0', '28');
INSERT INTO public.who_global_data_import VALUES (81720, '2020-05-01', 'SD', 'Sudan', 'EMRO', '67', '442', '3', '31');
INSERT INTO public.who_global_data_import VALUES (81721, '2020-05-02', 'SD', 'Sudan', 'EMRO', '91', '533', '5', '36');
INSERT INTO public.who_global_data_import VALUES (81722, '2020-05-03', 'SD', 'Sudan', 'EMRO', '59', '592', '5', '41');
INSERT INTO public.who_global_data_import VALUES (81723, '2020-05-04', 'SD', 'Sudan', 'EMRO', '86', '678', '0', '41');
INSERT INTO public.who_global_data_import VALUES (81724, '2020-05-05', 'SD', 'Sudan', 'EMRO', '100', '778', '4', '45');
INSERT INTO public.who_global_data_import VALUES (81725, '2020-05-06', 'SD', 'Sudan', 'EMRO', '74', '852', '4', '49');
INSERT INTO public.who_global_data_import VALUES (81726, '2020-05-07', 'SD', 'Sudan', 'EMRO', '78', '930', '3', '52');
INSERT INTO public.who_global_data_import VALUES (81727, '2020-05-08', 'SD', 'Sudan', 'EMRO', '0', '930', '0', '52');
INSERT INTO public.who_global_data_import VALUES (81728, '2020-05-09', 'SD', 'Sudan', 'EMRO', '181', '1111', '7', '59');
INSERT INTO public.who_global_data_import VALUES (81729, '2020-05-10', 'SD', 'Sudan', 'EMRO', '53', '1164', '5', '64');
INSERT INTO public.who_global_data_import VALUES (81730, '2020-05-11', 'SD', 'Sudan', 'EMRO', '201', '1365', '6', '70');
INSERT INTO public.who_global_data_import VALUES (81731, '2020-05-12', 'SD', 'Sudan', 'EMRO', '161', '1526', '4', '74');
INSERT INTO public.who_global_data_import VALUES (81732, '2020-05-13', 'SD', 'Sudan', 'EMRO', '134', '1660', '6', '80');
INSERT INTO public.who_global_data_import VALUES (81733, '2020-05-14', 'SD', 'Sudan', 'EMRO', '158', '1818', '10', '90');
INSERT INTO public.who_global_data_import VALUES (81734, '2020-05-15', 'SD', 'Sudan', 'EMRO', '146', '1964', '1', '91');
INSERT INTO public.who_global_data_import VALUES (81735, '2020-05-16', 'SD', 'Sudan', 'EMRO', '0', '1964', '0', '91');
INSERT INTO public.who_global_data_import VALUES (81736, '2020-05-17', 'SD', 'Sudan', 'EMRO', '325', '2289', '6', '97');
INSERT INTO public.who_global_data_import VALUES (81737, '2020-05-18', 'SD', 'Sudan', 'EMRO', '302', '2591', '8', '105');
INSERT INTO public.who_global_data_import VALUES (81738, '2020-05-19', 'SD', 'Sudan', 'EMRO', '0', '2591', '0', '105');
INSERT INTO public.who_global_data_import VALUES (81739, '2020-05-20', 'SD', 'Sudan', 'EMRO', '137', '2728', '6', '111');
INSERT INTO public.who_global_data_import VALUES (81740, '2020-05-21', 'SD', 'Sudan', 'EMRO', '410', '3138', '10', '121');
INSERT INTO public.who_global_data_import VALUES (81741, '2020-05-22', 'SD', 'Sudan', 'EMRO', '0', '3138', '0', '121');
INSERT INTO public.who_global_data_import VALUES (81742, '2020-05-23', 'SD', 'Sudan', 'EMRO', '240', '3378', '16', '137');
INSERT INTO public.who_global_data_import VALUES (81743, '2020-05-24', 'SD', 'Sudan', 'EMRO', '256', '3634', '9', '146');
INSERT INTO public.who_global_data_import VALUES (81744, '2020-05-25', 'SD', 'Sudan', 'EMRO', '192', '3826', '19', '165');
INSERT INTO public.who_global_data_import VALUES (81745, '2020-05-26', 'SD', 'Sudan', 'EMRO', '150', '3976', '5', '170');
INSERT INTO public.who_global_data_import VALUES (81746, '2020-05-27', 'SD', 'Sudan', 'EMRO', '170', '4146', '14', '184');
INSERT INTO public.who_global_data_import VALUES (81747, '2020-05-28', 'SD', 'Sudan', 'EMRO', '200', '4346', '11', '195');
INSERT INTO public.who_global_data_import VALUES (81748, '2020-05-29', 'SD', 'Sudan', 'EMRO', '0', '4346', '0', '195');
INSERT INTO public.who_global_data_import VALUES (81749, '2020-05-30', 'SD', 'Sudan', 'EMRO', '175', '4521', '38', '233');
INSERT INTO public.who_global_data_import VALUES (81750, '2020-05-31', 'SD', 'Sudan', 'EMRO', '279', '4800', '29', '262');
INSERT INTO public.who_global_data_import VALUES (81751, '2020-06-01', 'SD', 'Sudan', 'EMRO', '226', '5026', '24', '286');
INSERT INTO public.who_global_data_import VALUES (81752, '2020-06-02', 'SD', 'Sudan', 'EMRO', '147', '5173', '12', '298');
INSERT INTO public.who_global_data_import VALUES (81753, '2020-06-03', 'SD', 'Sudan', 'EMRO', '137', '5310', '9', '307');
INSERT INTO public.who_global_data_import VALUES (81754, '2020-06-04', 'SD', 'Sudan', 'EMRO', '189', '5499', '7', '314');
INSERT INTO public.who_global_data_import VALUES (81755, '2020-06-05', 'SD', 'Sudan', 'EMRO', '215', '5714', '19', '333');
INSERT INTO public.who_global_data_import VALUES (81756, '2020-06-06', 'SD', 'Sudan', 'EMRO', '152', '5866', '14', '347');
INSERT INTO public.who_global_data_import VALUES (81757, '2020-06-07', 'SD', 'Sudan', 'EMRO', '215', '6081', '12', '359');
INSERT INTO public.who_global_data_import VALUES (81758, '2020-06-08', 'SD', 'Sudan', 'EMRO', '0', '6081', '0', '359');
INSERT INTO public.who_global_data_import VALUES (81759, '2020-06-09', 'SD', 'Sudan', 'EMRO', '161', '6242', '13', '372');
INSERT INTO public.who_global_data_import VALUES (81760, '2020-06-10', 'SD', 'Sudan', 'EMRO', '185', '6427', '17', '389');
INSERT INTO public.who_global_data_import VALUES (81761, '2020-06-11', 'SD', 'Sudan', 'EMRO', '155', '6582', '12', '401');
INSERT INTO public.who_global_data_import VALUES (81762, '2020-06-12', 'SD', 'Sudan', 'EMRO', '148', '6730', '12', '413');
INSERT INTO public.who_global_data_import VALUES (81763, '2020-06-13', 'SD', 'Sudan', 'EMRO', '149', '6879', '20', '433');
INSERT INTO public.who_global_data_import VALUES (81764, '2020-06-14', 'SD', 'Sudan', 'EMRO', '128', '7007', '14', '447');
INSERT INTO public.who_global_data_import VALUES (81765, '2020-06-15', 'SD', 'Sudan', 'EMRO', '213', '7220', '12', '459');
INSERT INTO public.who_global_data_import VALUES (81766, '2020-06-16', 'SD', 'Sudan', 'EMRO', '215', '7435', '9', '468');
INSERT INTO public.who_global_data_import VALUES (81767, '2020-06-17', 'SD', 'Sudan', 'EMRO', '305', '7740', '9', '477');
INSERT INTO public.who_global_data_import VALUES (81768, '2020-06-18', 'SD', 'Sudan', 'EMRO', '280', '8020', '10', '487');
INSERT INTO public.who_global_data_import VALUES (81769, '2020-06-19', 'SD', 'Sudan', 'EMRO', '0', '8020', '0', '487');
INSERT INTO public.who_global_data_import VALUES (81770, '2020-06-20', 'SD', 'Sudan', 'EMRO', '396', '8416', '26', '513');
INSERT INTO public.who_global_data_import VALUES (81771, '2020-06-21', 'SD', 'Sudan', 'EMRO', '164', '8580', '8', '521');
INSERT INTO public.who_global_data_import VALUES (81772, '2020-06-22', 'SD', 'Sudan', 'EMRO', '118', '8698', '12', '533');
INSERT INTO public.who_global_data_import VALUES (81773, '2020-06-23', 'SD', 'Sudan', 'EMRO', '98', '8796', '8', '541');
INSERT INTO public.who_global_data_import VALUES (81774, '2020-06-24', 'SD', 'Sudan', 'EMRO', '91', '8887', '7', '548');
INSERT INTO public.who_global_data_import VALUES (81775, '2020-06-25', 'SD', 'Sudan', 'EMRO', '0', '8887', '0', '548');
INSERT INTO public.who_global_data_import VALUES (81776, '2020-06-26', 'SD', 'Sudan', 'EMRO', '95', '8982', '8', '556');
INSERT INTO public.who_global_data_import VALUES (81777, '2020-06-27', 'SD', 'Sudan', 'EMRO', '275', '9257', '16', '572');
INSERT INTO public.who_global_data_import VALUES (81778, '2020-06-28', 'SD', 'Sudan', 'EMRO', '57', '9314', '4', '576');
INSERT INTO public.who_global_data_import VALUES (81779, '2020-06-29', 'SD', 'Sudan', 'EMRO', '6', '9320', '8', '584');
INSERT INTO public.who_global_data_import VALUES (81780, '2020-06-30', 'SD', 'Sudan', 'EMRO', '52', '9372', '3', '587');
INSERT INTO public.who_global_data_import VALUES (81781, '2020-07-01', 'SD', 'Sudan', 'EMRO', '128', '9500', '5', '592');
INSERT INTO public.who_global_data_import VALUES (81782, '2020-07-02', 'SD', 'Sudan', 'EMRO', '73', '9573', '10', '602');
INSERT INTO public.who_global_data_import VALUES (81783, '2020-07-03', 'SD', 'Sudan', 'EMRO', '116', '9689', '5', '607');
INSERT INTO public.who_global_data_import VALUES (81784, '2020-07-04', 'SD', 'Sudan', 'EMRO', '0', '9689', '0', '607');
INSERT INTO public.who_global_data_import VALUES (81785, '2020-07-05', 'SD', 'Sudan', 'EMRO', '78', '9767', '1', '608');
INSERT INTO public.who_global_data_import VALUES (81786, '2020-07-06', 'SD', 'Sudan', 'EMRO', '0', '9767', '0', '608');
INSERT INTO public.who_global_data_import VALUES (81787, '2020-07-07', 'SD', 'Sudan', 'EMRO', '127', '9894', '8', '616');
INSERT INTO public.who_global_data_import VALUES (81788, '2020-07-08', 'SD', 'Sudan', 'EMRO', '103', '9997', '6', '622');
INSERT INTO public.who_global_data_import VALUES (81789, '2020-07-09', 'SD', 'Sudan', 'EMRO', '87', '10084', '14', '636');
INSERT INTO public.who_global_data_import VALUES (81790, '2020-07-10', 'SD', 'Sudan', 'EMRO', '120', '10204', '13', '649');
INSERT INTO public.who_global_data_import VALUES (81791, '2020-07-11', 'SD', 'Sudan', 'EMRO', '0', '10204', '0', '649');
INSERT INTO public.who_global_data_import VALUES (81792, '2020-07-12', 'SD', 'Sudan', 'EMRO', '46', '10250', '1', '650');
INSERT INTO public.who_global_data_import VALUES (81793, '2020-07-13', 'SD', 'Sudan', 'EMRO', '0', '10250', '0', '650');
INSERT INTO public.who_global_data_import VALUES (81794, '2020-07-14', 'SD', 'Sudan', 'EMRO', '66', '10316', '7', '657');
INSERT INTO public.who_global_data_import VALUES (81795, '2020-07-15', 'SD', 'Sudan', 'EMRO', '101', '10417', '2', '659');
INSERT INTO public.who_global_data_import VALUES (81796, '2020-07-16', 'SD', 'Sudan', 'EMRO', '110', '10527', '9', '668');
INSERT INTO public.who_global_data_import VALUES (81797, '2020-07-17', 'SD', 'Sudan', 'EMRO', '0', '10527', '0', '668');
INSERT INTO public.who_global_data_import VALUES (81798, '2020-07-18', 'SD', 'Sudan', 'EMRO', '0', '10527', '0', '668');
INSERT INTO public.who_global_data_import VALUES (81799, '2020-07-19', 'SD', 'Sudan', 'EMRO', '235', '10762', '12', '680');
INSERT INTO public.who_global_data_import VALUES (81800, '2020-07-20', 'SD', 'Sudan', 'EMRO', '230', '10992', '13', '693');
INSERT INTO public.who_global_data_import VALUES (81801, '2020-07-21', 'SD', 'Sudan', 'EMRO', '0', '10992', '0', '693');
INSERT INTO public.who_global_data_import VALUES (81802, '2020-07-22', 'SD', 'Sudan', 'EMRO', '135', '11127', '13', '706');
INSERT INTO public.who_global_data_import VALUES (81803, '2020-07-23', 'SD', 'Sudan', 'EMRO', '110', '11237', '2', '708');
INSERT INTO public.who_global_data_import VALUES (81804, '2020-07-24', 'SD', 'Sudan', 'EMRO', '65', '11302', '7', '715');
INSERT INTO public.who_global_data_import VALUES (81805, '2020-07-25', 'SD', 'Sudan', 'EMRO', '0', '11302', '0', '715');
INSERT INTO public.who_global_data_import VALUES (81806, '2020-07-26', 'SD', 'Sudan', 'EMRO', '83', '11385', '2', '717');
INSERT INTO public.who_global_data_import VALUES (81807, '2020-07-27', 'SD', 'Sudan', 'EMRO', '39', '11424', '3', '720');
INSERT INTO public.who_global_data_import VALUES (81808, '2020-07-28', 'SD', 'Sudan', 'EMRO', '72', '11496', '5', '725');
INSERT INTO public.who_global_data_import VALUES (81809, '2020-07-29', 'SD', 'Sudan', 'EMRO', '83', '11579', '6', '731');
INSERT INTO public.who_global_data_import VALUES (81810, '2020-07-30', 'SD', 'Sudan', 'EMRO', '0', '11579', '0', '731');
INSERT INTO public.who_global_data_import VALUES (81811, '2020-07-31', 'SD', 'Sudan', 'EMRO', '0', '11579', '0', '731');
INSERT INTO public.who_global_data_import VALUES (81812, '2020-08-01', 'SD', 'Sudan', 'EMRO', '65', '11644', '15', '746');
INSERT INTO public.who_global_data_import VALUES (81813, '2020-08-02', 'SD', 'Sudan', 'EMRO', '94', '11738', '6', '752');
INSERT INTO public.who_global_data_import VALUES (81814, '2020-08-03', 'SD', 'Sudan', 'EMRO', '0', '11738', '0', '752');
INSERT INTO public.who_global_data_import VALUES (81815, '2020-08-04', 'SD', 'Sudan', 'EMRO', '42', '11780', '11', '763');
INSERT INTO public.who_global_data_import VALUES (81816, '2020-08-05', 'SD', 'Sudan', 'EMRO', '0', '11780', '0', '763');
INSERT INTO public.who_global_data_import VALUES (81817, '2020-08-06', 'SD', 'Sudan', 'EMRO', '70', '11850', '6', '769');
INSERT INTO public.who_global_data_import VALUES (81818, '2020-08-07', 'SD', 'Sudan', 'EMRO', '44', '11894', '4', '773');
INSERT INTO public.who_global_data_import VALUES (81819, '2020-08-08', 'SD', 'Sudan', 'EMRO', '0', '11894', '0', '773');
INSERT INTO public.who_global_data_import VALUES (81820, '2020-08-09', 'SD', 'Sudan', 'EMRO', '62', '11956', '8', '781');
INSERT INTO public.who_global_data_import VALUES (81821, '2020-08-10', 'SD', 'Sudan', 'EMRO', '77', '12033', '5', '786');
INSERT INTO public.who_global_data_import VALUES (81822, '2020-08-11', 'SD', 'Sudan', 'EMRO', '0', '12033', '0', '786');
INSERT INTO public.who_global_data_import VALUES (81823, '2020-08-12', 'SD', 'Sudan', 'EMRO', '82', '12115', '6', '792');
INSERT INTO public.who_global_data_import VALUES (81824, '2020-08-13', 'SD', 'Sudan', 'EMRO', '47', '12162', '1', '793');
INSERT INTO public.who_global_data_import VALUES (81825, '2020-08-14', 'SD', 'Sudan', 'EMRO', '49', '12211', '3', '796');
INSERT INTO public.who_global_data_import VALUES (81826, '2020-08-15', 'SD', 'Sudan', 'EMRO', '103', '12314', '2', '798');
INSERT INTO public.who_global_data_import VALUES (81827, '2020-08-16', 'SD', 'Sudan', 'EMRO', '96', '12410', '5', '803');
INSERT INTO public.who_global_data_import VALUES (81828, '2020-08-17', 'SD', 'Sudan', 'EMRO', '75', '12485', '2', '805');
INSERT INTO public.who_global_data_import VALUES (81829, '2020-08-18', 'SD', 'Sudan', 'EMRO', '61', '12546', '3', '808');
INSERT INTO public.who_global_data_import VALUES (81830, '2020-08-19', 'SD', 'Sudan', 'EMRO', '36', '12582', '4', '812');
INSERT INTO public.who_global_data_import VALUES (81831, '2020-08-20', 'SD', 'Sudan', 'EMRO', '41', '12623', '0', '812');
INSERT INTO public.who_global_data_import VALUES (81832, '2020-08-21', 'SD', 'Sudan', 'EMRO', '59', '12682', '3', '815');
INSERT INTO public.who_global_data_import VALUES (81833, '2020-08-22', 'SD', 'Sudan', 'EMRO', '154', '12836', '0', '815');
INSERT INTO public.who_global_data_import VALUES (81834, '2020-08-23', 'SD', 'Sudan', 'EMRO', '67', '12903', '3', '818');
INSERT INTO public.who_global_data_import VALUES (81835, '2020-08-24', 'SD', 'Sudan', 'EMRO', '71', '12974', '1', '819');
INSERT INTO public.who_global_data_import VALUES (81836, '2020-08-25', 'SD', 'Sudan', 'EMRO', '0', '12974', '0', '819');
INSERT INTO public.who_global_data_import VALUES (81837, '2020-08-26', 'SD', 'Sudan', 'EMRO', '71', '13045', '4', '823');
INSERT INTO public.who_global_data_import VALUES (81838, '2020-08-27', 'SD', 'Sudan', 'EMRO', '37', '13082', '0', '823');
INSERT INTO public.who_global_data_import VALUES (81839, '2020-08-28', 'SD', 'Sudan', 'EMRO', '107', '13189', '0', '823');
INSERT INTO public.who_global_data_import VALUES (81840, '2020-08-29', 'SD', 'Sudan', 'EMRO', '0', '13189', '0', '823');
INSERT INTO public.who_global_data_import VALUES (81841, '2020-08-30', 'SD', 'Sudan', 'EMRO', '0', '13189', '0', '823');
INSERT INTO public.who_global_data_import VALUES (81842, '2020-08-31', 'SD', 'Sudan', 'EMRO', '0', '13189', '0', '823');
INSERT INTO public.who_global_data_import VALUES (81843, '2020-09-01', 'SD', 'Sudan', 'EMRO', '0', '13189', '0', '823');
INSERT INTO public.who_global_data_import VALUES (81844, '2020-09-02', 'SD', 'Sudan', 'EMRO', '0', '13189', '0', '823');
INSERT INTO public.who_global_data_import VALUES (81845, '2020-09-03', 'SD', 'Sudan', 'EMRO', '0', '13189', '0', '823');
INSERT INTO public.who_global_data_import VALUES (81846, '2020-09-04', 'SD', 'Sudan', 'EMRO', '0', '13189', '0', '823');
INSERT INTO public.who_global_data_import VALUES (81847, '2020-09-05', 'SD', 'Sudan', 'EMRO', '218', '13407', '9', '832');
INSERT INTO public.who_global_data_import VALUES (81848, '2020-09-06', 'SD', 'Sudan', 'EMRO', '30', '13437', '1', '833');
INSERT INTO public.who_global_data_import VALUES (81849, '2020-09-07', 'SD', 'Sudan', 'EMRO', '0', '13437', '0', '833');
INSERT INTO public.who_global_data_import VALUES (81850, '2020-09-08', 'SD', 'Sudan', 'EMRO', '33', '13470', '1', '834');
INSERT INTO public.who_global_data_import VALUES (81851, '2020-09-09', 'SD', 'Sudan', 'EMRO', '0', '13470', '0', '834');
INSERT INTO public.who_global_data_import VALUES (81852, '2020-09-10', 'SD', 'Sudan', 'EMRO', '0', '13470', '0', '834');
INSERT INTO public.who_global_data_import VALUES (81853, '2020-09-11', 'SD', 'Sudan', 'EMRO', '46', '13516', '1', '835');
INSERT INTO public.who_global_data_import VALUES (81854, '2020-09-12', 'SD', 'Sudan', 'EMRO', '16', '13532', '1', '836');
INSERT INTO public.who_global_data_import VALUES (81855, '2020-09-13', 'SD', 'Sudan', 'EMRO', '0', '13532', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81856, '2020-09-14', 'SD', 'Sudan', 'EMRO', '0', '13532', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81857, '2020-09-15', 'SD', 'Sudan', 'EMRO', '3', '13535', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81858, '2020-09-16', 'SD', 'Sudan', 'EMRO', '0', '13535', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81859, '2020-09-17', 'SD', 'Sudan', 'EMRO', '0', '13535', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81860, '2020-09-18', 'SD', 'Sudan', 'EMRO', '20', '13555', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81861, '2020-09-19', 'SD', 'Sudan', 'EMRO', '0', '13555', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81862, '2020-09-20', 'SD', 'Sudan', 'EMRO', '0', '13555', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81863, '2020-09-21', 'SD', 'Sudan', 'EMRO', '21', '13576', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81864, '2020-09-22', 'SD', 'Sudan', 'EMRO', '2', '13578', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81865, '2020-09-23', 'SD', 'Sudan', 'EMRO', '0', '13578', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81866, '2020-09-24', 'SD', 'Sudan', 'EMRO', '14', '13592', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81867, '2020-09-25', 'SD', 'Sudan', 'EMRO', '12', '13604', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81868, '2020-09-26', 'SD', 'Sudan', 'EMRO', '2', '13606', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81869, '2020-09-27', 'SD', 'Sudan', 'EMRO', '4', '13610', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81870, '2020-09-28', 'SD', 'Sudan', 'EMRO', '3', '13613', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81871, '2020-09-29', 'SD', 'Sudan', 'EMRO', '27', '13640', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81872, '2020-09-30', 'SD', 'Sudan', 'EMRO', '6', '13646', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81873, '2020-10-01', 'SD', 'Sudan', 'EMRO', '7', '13653', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81874, '2020-10-02', 'SD', 'Sudan', 'EMRO', '4', '13657', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81875, '2020-10-03', 'SD', 'Sudan', 'EMRO', '1', '13658', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81876, '2020-10-04', 'SD', 'Sudan', 'EMRO', '2', '13660', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81877, '2020-10-05', 'SD', 'Sudan', 'EMRO', '0', '13660', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81878, '2020-10-06', 'SD', 'Sudan', 'EMRO', '8', '13668', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81879, '2020-10-07', 'SD', 'Sudan', 'EMRO', '0', '13668', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81880, '2020-10-08', 'SD', 'Sudan', 'EMRO', '2', '13670', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81881, '2020-10-09', 'SD', 'Sudan', 'EMRO', '3', '13673', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81882, '2020-10-10', 'SD', 'Sudan', 'EMRO', '9', '13682', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81883, '2020-10-11', 'SD', 'Sudan', 'EMRO', '3', '13685', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81884, '2020-10-12', 'SD', 'Sudan', 'EMRO', '6', '13691', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81885, '2020-10-13', 'SD', 'Sudan', 'EMRO', '0', '13691', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81886, '2020-10-14', 'SD', 'Sudan', 'EMRO', '6', '13697', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81887, '2020-10-15', 'SD', 'Sudan', 'EMRO', '0', '13697', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81888, '2020-10-16', 'SD', 'Sudan', 'EMRO', '3', '13700', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81889, '2020-10-17', 'SD', 'Sudan', 'EMRO', '0', '13700', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81890, '2020-10-18', 'SD', 'Sudan', 'EMRO', '11', '13711', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81891, '2020-10-19', 'SD', 'Sudan', 'EMRO', '13', '13724', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81892, '2020-10-20', 'SD', 'Sudan', 'EMRO', '0', '13724', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81893, '2020-10-21', 'SD', 'Sudan', 'EMRO', '4', '13728', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81894, '2020-10-22', 'SD', 'Sudan', 'EMRO', '0', '13728', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81895, '2020-10-23', 'SD', 'Sudan', 'EMRO', '5', '13733', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81896, '2020-10-24', 'SD', 'Sudan', 'EMRO', '0', '13733', '0', '836');
INSERT INTO public.who_global_data_import VALUES (81897, '2020-10-25', 'SD', 'Sudan', 'EMRO', '9', '13742', '1', '837');
INSERT INTO public.who_global_data_import VALUES (81898, '2020-10-26', 'SD', 'Sudan', 'EMRO', '0', '13742', '0', '837');
INSERT INTO public.who_global_data_import VALUES (81899, '2020-10-27', 'SD', 'Sudan', 'EMRO', '5', '13747', '0', '837');
INSERT INTO public.who_global_data_import VALUES (81900, '2020-10-28', 'SD', 'Sudan', 'EMRO', '18', '13765', '0', '837');
INSERT INTO public.who_global_data_import VALUES (81901, '2020-10-29', 'SD', 'Sudan', 'EMRO', '12', '13777', '0', '837');
INSERT INTO public.who_global_data_import VALUES (81902, '2020-10-30', 'SD', 'Sudan', 'EMRO', '27', '13804', '0', '837');
INSERT INTO public.who_global_data_import VALUES (81903, '2020-10-31', 'SD', 'Sudan', 'EMRO', '0', '13804', '0', '837');
INSERT INTO public.who_global_data_import VALUES (81904, '2020-11-01', 'SD', 'Sudan', 'EMRO', '0', '13804', '0', '837');
INSERT INTO public.who_global_data_import VALUES (81905, '2020-11-02', 'SD', 'Sudan', 'EMRO', '15', '13819', '0', '837');
INSERT INTO public.who_global_data_import VALUES (81906, '2020-11-03', 'SD', 'Sudan', 'EMRO', '47', '13866', '0', '837');
INSERT INTO public.who_global_data_import VALUES (81907, '2020-11-04', 'SD', 'Sudan', 'EMRO', '39', '13905', '0', '837');
INSERT INTO public.who_global_data_import VALUES (81908, '2020-11-05', 'SD', 'Sudan', 'EMRO', '91', '13996', '278', '1115');
INSERT INTO public.who_global_data_import VALUES (81909, '2020-11-06', 'SD', 'Sudan', 'EMRO', '37', '14033', '0', '1115');
INSERT INTO public.who_global_data_import VALUES (81910, '2020-11-07', 'SD', 'Sudan', 'EMRO', '57', '14090', '0', '1115');
INSERT INTO public.who_global_data_import VALUES (81911, '2020-11-08', 'SD', 'Sudan', 'EMRO', '65', '14155', '1', '1116');
INSERT INTO public.who_global_data_import VALUES (81912, '2020-11-09', 'SD', 'Sudan', 'EMRO', '50', '14205', '0', '1116');
INSERT INTO public.who_global_data_import VALUES (81913, '2020-11-10', 'SD', 'Sudan', 'EMRO', '96', '14301', '0', '1116');
INSERT INTO public.who_global_data_import VALUES (81914, '2020-11-11', 'SD', 'Sudan', 'EMRO', '45', '14346', '0', '1116');
INSERT INTO public.who_global_data_import VALUES (81915, '2020-11-12', 'SD', 'Sudan', 'EMRO', '55', '14401', '0', '1116');
INSERT INTO public.who_global_data_import VALUES (81916, '2020-11-13', 'SD', 'Sudan', 'EMRO', '97', '14498', '0', '1116');
INSERT INTO public.who_global_data_import VALUES (81917, '2020-11-14', 'SD', 'Sudan', 'EMRO', '128', '14626', '0', '1116');
INSERT INTO public.who_global_data_import VALUES (81918, '2020-11-15', 'SD', 'Sudan', 'EMRO', '102', '14728', '3', '1119');
INSERT INTO public.who_global_data_import VALUES (81919, '2020-11-16', 'SD', 'Sudan', 'EMRO', '319', '15047', '56', '1175');
INSERT INTO public.who_global_data_import VALUES (81920, '2020-11-17', 'SD', 'Sudan', 'EMRO', '106', '15153', '3', '1178');
INSERT INTO public.who_global_data_import VALUES (81921, '2020-11-18', 'SD', 'Sudan', 'EMRO', '146', '15299', '1', '1179');
INSERT INTO public.who_global_data_import VALUES (81922, '2020-11-19', 'SD', 'Sudan', 'EMRO', '231', '15530', '6', '1185');
INSERT INTO public.who_global_data_import VALUES (81923, '2020-11-20', 'SD', 'Sudan', 'EMRO', '309', '15839', '8', '1193');
INSERT INTO public.who_global_data_import VALUES (81924, '2020-11-21', 'SD', 'Sudan', 'EMRO', '213', '16052', '4', '1197');
INSERT INTO public.who_global_data_import VALUES (81925, '2020-11-22', 'SD', 'Sudan', 'EMRO', '135', '16187', '2', '1199');
INSERT INTO public.who_global_data_import VALUES (81926, '2020-11-23', 'SD', 'Sudan', 'EMRO', '244', '16431', '3', '1202');
INSERT INTO public.who_global_data_import VALUES (81927, '2020-11-24', 'SD', 'Sudan', 'EMRO', '218', '16649', '8', '1210');
INSERT INTO public.who_global_data_import VALUES (81928, '2020-11-25', 'SD', 'Sudan', 'EMRO', '215', '16864', '5', '1215');
INSERT INTO public.who_global_data_import VALUES (81929, '2020-11-26', 'SD', 'Sudan', 'EMRO', '204', '17068', '5', '1220');
INSERT INTO public.who_global_data_import VALUES (81930, '2020-11-27', 'SD', 'Sudan', 'EMRO', '336', '17404', '15', '1235');
INSERT INTO public.who_global_data_import VALUES (81931, '2020-11-28', 'SD', 'Sudan', 'EMRO', '223', '17627', '6', '1241');
INSERT INTO public.who_global_data_import VALUES (81932, '2020-11-29', 'SD', 'Sudan', 'EMRO', '183', '17810', '8', '1249');
INSERT INTO public.who_global_data_import VALUES (81933, '2020-11-30', 'SD', 'Sudan', 'EMRO', '235', '18045', '6', '1255');
INSERT INTO public.who_global_data_import VALUES (81934, '2020-12-01', 'SD', 'Sudan', 'EMRO', '209', '18254', '10', '1265');
INSERT INTO public.who_global_data_import VALUES (81935, '2020-12-02', 'SD', 'Sudan', 'EMRO', '281', '18535', '6', '1271');
INSERT INTO public.who_global_data_import VALUES (81936, '2020-12-03', 'SD', 'Sudan', 'EMRO', '349', '18884', '9', '1280');
INSERT INTO public.who_global_data_import VALUES (81937, '2020-12-04', 'SD', 'Sudan', 'EMRO', '312', '19196', '10', '1290');
INSERT INTO public.who_global_data_import VALUES (81938, '2020-12-05', 'SD', 'Sudan', 'EMRO', '272', '19468', '5', '1295');
INSERT INTO public.who_global_data_import VALUES (81939, '2020-12-06', 'SD', 'Sudan', 'EMRO', '279', '19747', '6', '1301');
INSERT INTO public.who_global_data_import VALUES (81940, '2020-12-07', 'SD', 'Sudan', 'EMRO', '337', '20084', '6', '1307');
INSERT INTO public.who_global_data_import VALUES (81941, '2020-12-08', 'SD', 'Sudan', 'EMRO', '212', '20296', '2', '1309');
INSERT INTO public.who_global_data_import VALUES (81942, '2020-12-09', 'SD', 'Sudan', 'EMRO', '172', '20468', '10', '1319');
INSERT INTO public.who_global_data_import VALUES (81943, '2020-12-10', 'SD', 'Sudan', 'EMRO', '376', '20844', '21', '1340');
INSERT INTO public.who_global_data_import VALUES (81944, '2020-12-11', 'SD', 'Sudan', 'EMRO', '303', '21147', '4', '1344');
INSERT INTO public.who_global_data_import VALUES (81945, '2020-12-12', 'SD', 'Sudan', 'EMRO', '239', '21386', '3', '1347');
INSERT INTO public.who_global_data_import VALUES (81946, '2020-12-13', 'SD', 'Sudan', 'EMRO', '205', '21591', '8', '1355');
INSERT INTO public.who_global_data_import VALUES (81947, '2020-12-14', 'SD', 'Sudan', 'EMRO', '273', '21864', '17', '1372');
INSERT INTO public.who_global_data_import VALUES (81948, '2020-12-15', 'SD', 'Sudan', 'EMRO', '218', '22082', '12', '1384');
INSERT INTO public.who_global_data_import VALUES (81949, '2020-12-16', 'SD', 'Sudan', 'EMRO', '183', '22265', '24', '1408');
INSERT INTO public.who_global_data_import VALUES (81950, '2020-12-17', 'SD', 'Sudan', 'EMRO', '356', '22621', '17', '1425');
INSERT INTO public.who_global_data_import VALUES (81951, '2020-12-18', 'SD', 'Sudan', 'EMRO', '202', '22823', '9', '1434');
INSERT INTO public.who_global_data_import VALUES (81952, '2020-12-19', 'SD', 'Sudan', 'EMRO', '167', '22990', '16', '1450');
INSERT INTO public.who_global_data_import VALUES (81953, '2020-12-20', 'SD', 'Sudan', 'EMRO', '110', '23100', '11', '1461');
INSERT INTO public.who_global_data_import VALUES (81954, '2020-12-21', 'SD', 'Sudan', 'EMRO', '216', '23316', '7', '1468');
INSERT INTO public.who_global_data_import VALUES (81955, '2020-12-22', 'SD', 'Sudan', 'EMRO', '256', '23572', '14', '1482');
INSERT INTO public.who_global_data_import VALUES (81956, '2020-12-23', 'SD', 'Sudan', 'EMRO', '274', '23846', '10', '1492');
INSERT INTO public.who_global_data_import VALUES (81957, '2020-12-24', 'SD', 'Sudan', 'EMRO', '212', '24058', '5', '1497');
INSERT INTO public.who_global_data_import VALUES (81958, '2020-12-25', 'SD', 'Sudan', 'EMRO', '283', '24341', '10', '1507');
INSERT INTO public.who_global_data_import VALUES (81959, '2020-12-26', 'SD', 'Sudan', 'EMRO', '247', '24588', '8', '1515');
INSERT INTO public.who_global_data_import VALUES (81960, '2020-12-27', 'SD', 'Sudan', 'EMRO', '106', '24694', '5', '1520');
INSERT INTO public.who_global_data_import VALUES (81961, '2020-12-28', 'SD', 'Sudan', 'EMRO', '194', '24888', '16', '1536');
INSERT INTO public.who_global_data_import VALUES (81962, '2020-12-29', 'SD', 'Sudan', 'EMRO', '172', '25060', '4', '1540');
INSERT INTO public.who_global_data_import VALUES (81963, '2020-12-30', 'SD', 'Sudan', 'EMRO', '178', '25238', '9', '1549');
INSERT INTO public.who_global_data_import VALUES (81964, '2020-12-31', 'SD', 'Sudan', 'EMRO', '262', '25500', '12', '1561');
INSERT INTO public.who_global_data_import VALUES (81965, '2021-01-01', 'SD', 'Sudan', 'EMRO', '230', '25730', '15', '1576');
INSERT INTO public.who_global_data_import VALUES (81966, '2021-01-02', 'SD', 'Sudan', 'EMRO', '152', '25882', '12', '1588');
INSERT INTO public.who_global_data_import VALUES (81967, '2021-01-03', 'SD', 'Sudan', 'EMRO', '157', '26039', '9', '1597');
INSERT INTO public.who_global_data_import VALUES (81968, '2021-01-04', 'SD', 'Sudan', 'EMRO', '240', '26279', '6', '1603');
INSERT INTO public.who_global_data_import VALUES (81969, '2021-01-05', 'SD', 'Sudan', 'EMRO', '0', '26279', '0', '1603');
INSERT INTO public.who_global_data_import VALUES (81970, '2021-01-06', 'SD', 'Sudan', 'EMRO', '0', '26279', '0', '1603');
INSERT INTO public.who_global_data_import VALUES (81971, '2021-01-07', 'SD', 'Sudan', 'EMRO', '0', '26279', '0', '1603');
INSERT INTO public.who_global_data_import VALUES (81972, '2021-01-08', 'SD', 'Sudan', 'EMRO', '0', '26279', '0', '1603');
INSERT INTO public.who_global_data_import VALUES (81973, '2021-01-09', 'SD', 'Sudan', 'EMRO', '0', '26279', '0', '1603');
INSERT INTO public.who_global_data_import VALUES (81974, '2021-01-10', 'SD', 'Sudan', 'EMRO', '1215', '27494', '54', '1657');
INSERT INTO public.who_global_data_import VALUES (81975, '2021-01-11', 'SD', 'Sudan', 'EMRO', '125', '27619', '9', '1666');
INSERT INTO public.who_global_data_import VALUES (81976, '2021-01-12', 'SD', 'Sudan', 'EMRO', '149', '27768', '6', '1672');
INSERT INTO public.who_global_data_import VALUES (81977, '2021-01-13', 'SD', 'Sudan', 'EMRO', '59', '27827', '5', '1677');
INSERT INTO public.who_global_data_import VALUES (81978, '2021-01-14', 'SD', 'Sudan', 'EMRO', '142', '27969', '6', '1683');
INSERT INTO public.who_global_data_import VALUES (81979, '2021-01-15', 'SD', 'Sudan', 'EMRO', '128', '28097', '12', '1695');
INSERT INTO public.who_global_data_import VALUES (81980, '2021-01-16', 'SD', 'Sudan', 'EMRO', '82', '28179', '4', '1699');
INSERT INTO public.who_global_data_import VALUES (81981, '2021-01-17', 'SD', 'Sudan', 'EMRO', '54', '28233', '8', '1707');
INSERT INTO public.who_global_data_import VALUES (81982, '2021-01-18', 'SD', 'Sudan', 'EMRO', '84', '28317', '10', '1717');
INSERT INTO public.who_global_data_import VALUES (81983, '2021-01-19', 'SD', 'Sudan', 'EMRO', '133', '28450', '4', '1721');
INSERT INTO public.who_global_data_import VALUES (81984, '2021-01-20', 'SD', 'Sudan', 'EMRO', '72', '28522', '1', '1722');
INSERT INTO public.who_global_data_import VALUES (81985, '2021-01-21', 'SD', 'Sudan', 'EMRO', '67', '28589', '10', '1732');
INSERT INTO public.who_global_data_import VALUES (81986, '2021-01-22', 'SD', 'Sudan', 'EMRO', '65', '28654', '1', '1733');
INSERT INTO public.who_global_data_import VALUES (81987, '2021-01-23', 'SD', 'Sudan', 'EMRO', '134', '28788', '5', '1738');
INSERT INTO public.who_global_data_import VALUES (81988, '2021-01-24', 'SD', 'Sudan', 'EMRO', '82', '28870', '0', '1738');
INSERT INTO public.who_global_data_import VALUES (81989, '2021-01-25', 'SD', 'Sudan', 'EMRO', '54', '28924', '0', '1738');
INSERT INTO public.who_global_data_import VALUES (81990, '2021-01-26', 'SD', 'Sudan', 'EMRO', '70', '28994', '12', '1750');
INSERT INTO public.who_global_data_import VALUES (81991, '2021-01-27', 'SD', 'Sudan', 'EMRO', '72', '29066', '10', '1760');
INSERT INTO public.who_global_data_import VALUES (81992, '2021-01-28', 'SD', 'Sudan', 'EMRO', '225', '29291', '38', '1798');
INSERT INTO public.who_global_data_import VALUES (81993, '2021-01-29', 'SD', 'Sudan', 'EMRO', '49', '29340', '3', '1801');
INSERT INTO public.who_global_data_import VALUES (81994, '2021-01-30', 'SD', 'Sudan', 'EMRO', '40', '29380', '3', '1804');
INSERT INTO public.who_global_data_import VALUES (81995, '2021-01-31', 'SD', 'Sudan', 'EMRO', '69', '29449', '3', '1807');
INSERT INTO public.who_global_data_import VALUES (81996, '2021-02-01', 'SD', 'Sudan', 'EMRO', '39', '29488', '5', '1812');
INSERT INTO public.who_global_data_import VALUES (81997, '2021-02-02', 'SD', 'Sudan', 'EMRO', '48', '29536', '17', '1829');
INSERT INTO public.who_global_data_import VALUES (81998, '2021-02-03', 'SD', 'Sudan', 'EMRO', '0', '29536', '0', '1829');
INSERT INTO public.who_global_data_import VALUES (81999, '2021-02-04', 'SD', 'Sudan', 'EMRO', '41', '29577', '1', '1830');
INSERT INTO public.who_global_data_import VALUES (82000, '2021-02-05', 'SD', 'Sudan', 'EMRO', '57', '29634', '1', '1831');
INSERT INTO public.who_global_data_import VALUES (82001, '2020-01-03', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82002, '2020-01-04', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82003, '2020-01-05', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82004, '2020-01-06', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82005, '2020-01-07', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82006, '2020-01-08', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82007, '2020-01-09', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82008, '2020-01-10', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82009, '2020-01-11', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82010, '2020-01-12', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82011, '2020-01-13', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82012, '2020-01-14', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82013, '2020-01-15', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82014, '2020-01-16', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82015, '2020-01-17', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82016, '2020-01-18', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82017, '2020-01-19', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82018, '2020-01-20', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82019, '2020-01-21', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82020, '2020-01-22', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82021, '2020-01-23', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82022, '2020-01-24', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82023, '2020-01-25', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82024, '2020-01-26', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82025, '2020-01-27', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82026, '2020-01-28', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82027, '2020-01-29', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82028, '2020-01-30', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82029, '2020-01-31', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82030, '2020-02-01', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82031, '2020-02-02', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82032, '2020-02-03', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82033, '2020-02-04', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82034, '2020-02-05', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82035, '2020-02-06', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82036, '2020-02-07', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82037, '2020-02-08', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82038, '2020-02-09', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82039, '2020-02-10', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82040, '2020-02-11', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82041, '2020-02-12', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82042, '2020-02-13', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82043, '2020-02-14', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82044, '2020-02-15', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82045, '2020-02-16', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82046, '2020-02-17', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82047, '2020-02-18', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82048, '2020-02-19', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82049, '2020-02-20', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82050, '2020-02-21', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82051, '2020-02-22', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82052, '2020-02-23', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82053, '2020-02-24', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82054, '2020-02-25', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82055, '2020-02-26', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82056, '2020-02-27', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82057, '2020-02-28', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82058, '2020-02-29', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82059, '2020-03-01', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82060, '2020-03-02', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82061, '2020-03-03', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82062, '2020-03-04', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82063, '2020-03-05', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82064, '2020-03-06', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82065, '2020-03-07', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82066, '2020-03-08', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82067, '2020-03-09', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82068, '2020-03-10', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82069, '2020-03-11', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82070, '2020-03-12', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82071, '2020-03-13', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82072, '2020-03-14', 'SR', 'Suriname', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82073, '2020-03-15', 'SR', 'Suriname', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82074, '2020-03-16', 'SR', 'Suriname', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82075, '2020-03-17', 'SR', 'Suriname', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82076, '2020-03-18', 'SR', 'Suriname', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82077, '2020-03-19', 'SR', 'Suriname', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82078, '2020-03-20', 'SR', 'Suriname', 'AMRO', '-3', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82079, '2020-03-21', 'SR', 'Suriname', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82080, '2020-03-22', 'SR', 'Suriname', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82081, '2020-03-23', 'SR', 'Suriname', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82082, '2020-03-24', 'SR', 'Suriname', 'AMRO', '4', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82083, '2020-03-25', 'SR', 'Suriname', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82084, '2020-03-26', 'SR', 'Suriname', 'AMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82085, '2020-03-27', 'SR', 'Suriname', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82086, '2020-03-28', 'SR', 'Suriname', 'AMRO', '1', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82087, '2020-03-29', 'SR', 'Suriname', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82088, '2020-03-30', 'SR', 'Suriname', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82089, '2020-03-31', 'SR', 'Suriname', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82090, '2020-04-01', 'SR', 'Suriname', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82091, '2020-04-02', 'SR', 'Suriname', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82092, '2020-04-03', 'SR', 'Suriname', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82093, '2020-04-04', 'SR', 'Suriname', 'AMRO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82094, '2020-04-05', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82095, '2020-04-06', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82096, '2020-04-07', 'SR', 'Suriname', 'AMRO', '0', '10', '1', '1');
INSERT INTO public.who_global_data_import VALUES (82097, '2020-04-08', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82098, '2020-04-09', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82099, '2020-04-10', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82100, '2020-04-11', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82101, '2020-04-12', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82102, '2020-04-13', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82103, '2020-04-14', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82104, '2020-04-15', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82105, '2020-04-16', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82106, '2020-04-17', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82107, '2020-04-18', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82108, '2020-04-19', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82109, '2020-04-20', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82110, '2020-04-21', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82111, '2020-04-22', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82112, '2020-04-23', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82113, '2020-04-24', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82114, '2020-04-25', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82115, '2020-04-26', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82116, '2020-04-27', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82117, '2020-04-28', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82118, '2020-04-29', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82119, '2020-04-30', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82120, '2020-05-01', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82121, '2020-05-02', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82122, '2020-05-03', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82123, '2020-05-04', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82124, '2020-05-05', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82125, '2020-05-06', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82126, '2020-05-07', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82127, '2020-05-08', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82128, '2020-05-09', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82129, '2020-05-10', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82130, '2020-05-11', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82131, '2020-05-12', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82132, '2020-05-13', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82133, '2020-05-14', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82134, '2020-05-15', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82135, '2020-05-16', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82136, '2020-05-17', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82137, '2020-05-18', 'SR', 'Suriname', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82138, '2020-05-19', 'SR', 'Suriname', 'AMRO', '1', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82139, '2020-05-20', 'SR', 'Suriname', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82140, '2020-05-21', 'SR', 'Suriname', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82141, '2020-05-22', 'SR', 'Suriname', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82142, '2020-05-23', 'SR', 'Suriname', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82143, '2020-05-24', 'SR', 'Suriname', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82144, '2020-05-25', 'SR', 'Suriname', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82145, '2020-05-26', 'SR', 'Suriname', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82146, '2020-05-27', 'SR', 'Suriname', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82147, '2020-05-28', 'SR', 'Suriname', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82148, '2020-05-29', 'SR', 'Suriname', 'AMRO', '1', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82149, '2020-05-30', 'SR', 'Suriname', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82150, '2020-05-31', 'SR', 'Suriname', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82151, '2020-06-01', 'SR', 'Suriname', 'AMRO', '2', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82152, '2020-06-02', 'SR', 'Suriname', 'AMRO', '13', '27', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82153, '2020-06-03', 'SR', 'Suriname', 'AMRO', '26', '53', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82154, '2020-06-04', 'SR', 'Suriname', 'AMRO', '1', '54', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82155, '2020-06-05', 'SR', 'Suriname', 'AMRO', '28', '82', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82156, '2020-06-06', 'SR', 'Suriname', 'AMRO', '0', '82', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82157, '2020-06-07', 'SR', 'Suriname', 'AMRO', '8', '90', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82158, '2020-06-08', 'SR', 'Suriname', 'AMRO', '11', '101', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82159, '2020-06-09', 'SR', 'Suriname', 'AMRO', '27', '128', '1', '2');
INSERT INTO public.who_global_data_import VALUES (82160, '2020-06-10', 'SR', 'Suriname', 'AMRO', '5', '133', '0', '2');
INSERT INTO public.who_global_data_import VALUES (82161, '2020-06-11', 'SR', 'Suriname', 'AMRO', '4', '137', '0', '2');
INSERT INTO public.who_global_data_import VALUES (82162, '2020-06-12', 'SR', 'Suriname', 'AMRO', '7', '144', '0', '2');
INSERT INTO public.who_global_data_import VALUES (82163, '2020-06-13', 'SR', 'Suriname', 'AMRO', '24', '168', '0', '2');
INSERT INTO public.who_global_data_import VALUES (82164, '2020-06-14', 'SR', 'Suriname', 'AMRO', '19', '187', '1', '3');
INSERT INTO public.who_global_data_import VALUES (82165, '2020-06-15', 'SR', 'Suriname', 'AMRO', '0', '187', '0', '3');
INSERT INTO public.who_global_data_import VALUES (82166, '2020-06-16', 'SR', 'Suriname', 'AMRO', '21', '208', '1', '4');
INSERT INTO public.who_global_data_import VALUES (82167, '2020-06-17', 'SR', 'Suriname', 'AMRO', '28', '236', '2', '6');
INSERT INTO public.who_global_data_import VALUES (82168, '2020-06-18', 'SR', 'Suriname', 'AMRO', '6', '242', '0', '6');
INSERT INTO public.who_global_data_import VALUES (82169, '2020-06-19', 'SR', 'Suriname', 'AMRO', '19', '261', '1', '7');
INSERT INTO public.who_global_data_import VALUES (82170, '2020-06-20', 'SR', 'Suriname', 'AMRO', '16', '277', '1', '8');
INSERT INTO public.who_global_data_import VALUES (82171, '2020-06-21', 'SR', 'Suriname', 'AMRO', '16', '293', '0', '8');
INSERT INTO public.who_global_data_import VALUES (82172, '2020-06-22', 'SR', 'Suriname', 'AMRO', '9', '302', '0', '8');
INSERT INTO public.who_global_data_import VALUES (82173, '2020-06-23', 'SR', 'Suriname', 'AMRO', '16', '318', '0', '8');
INSERT INTO public.who_global_data_import VALUES (82174, '2020-06-24', 'SR', 'Suriname', 'AMRO', '1', '319', '1', '9');
INSERT INTO public.who_global_data_import VALUES (82175, '2020-06-25', 'SR', 'Suriname', 'AMRO', '0', '319', '0', '9');
INSERT INTO public.who_global_data_import VALUES (82176, '2020-06-26', 'SR', 'Suriname', 'AMRO', '38', '357', '1', '10');
INSERT INTO public.who_global_data_import VALUES (82177, '2020-06-27', 'SR', 'Suriname', 'AMRO', '16', '373', '0', '10');
INSERT INTO public.who_global_data_import VALUES (82178, '2020-06-28', 'SR', 'Suriname', 'AMRO', '18', '391', '0', '10');
INSERT INTO public.who_global_data_import VALUES (82179, '2020-06-29', 'SR', 'Suriname', 'AMRO', '76', '467', '1', '11');
INSERT INTO public.who_global_data_import VALUES (82180, '2020-06-30', 'SR', 'Suriname', 'AMRO', '25', '492', '2', '13');
INSERT INTO public.who_global_data_import VALUES (82181, '2020-07-01', 'SR', 'Suriname', 'AMRO', '23', '515', '0', '13');
INSERT INTO public.who_global_data_import VALUES (82182, '2020-07-02', 'SR', 'Suriname', 'AMRO', '2', '517', '0', '13');
INSERT INTO public.who_global_data_import VALUES (82183, '2020-07-03', 'SR', 'Suriname', 'AMRO', '18', '535', '0', '13');
INSERT INTO public.who_global_data_import VALUES (82184, '2020-07-04', 'SR', 'Suriname', 'AMRO', '12', '547', '0', '13');
INSERT INTO public.who_global_data_import VALUES (82185, '2020-07-05', 'SR', 'Suriname', 'AMRO', '18', '565', '1', '14');
INSERT INTO public.who_global_data_import VALUES (82186, '2020-07-06', 'SR', 'Suriname', 'AMRO', '18', '583', '0', '14');
INSERT INTO public.who_global_data_import VALUES (82187, '2020-07-07', 'SR', 'Suriname', 'AMRO', '21', '604', '0', '14');
INSERT INTO public.who_global_data_import VALUES (82188, '2020-07-08', 'SR', 'Suriname', 'AMRO', '10', '614', '1', '15');
INSERT INTO public.who_global_data_import VALUES (82189, '2020-07-09', 'SR', 'Suriname', 'AMRO', '21', '635', '2', '17');
INSERT INTO public.who_global_data_import VALUES (82190, '2020-07-10', 'SR', 'Suriname', 'AMRO', '36', '671', '0', '17');
INSERT INTO public.who_global_data_import VALUES (82191, '2020-07-11', 'SR', 'Suriname', 'AMRO', '55', '726', '0', '17');
INSERT INTO public.who_global_data_import VALUES (82192, '2020-07-12', 'SR', 'Suriname', 'AMRO', '3', '729', '1', '18');
INSERT INTO public.who_global_data_import VALUES (82193, '2020-07-13', 'SR', 'Suriname', 'AMRO', '12', '741', '0', '18');
INSERT INTO public.who_global_data_import VALUES (82194, '2020-07-14', 'SR', 'Suriname', 'AMRO', '21', '762', '0', '18');
INSERT INTO public.who_global_data_import VALUES (82195, '2020-07-15', 'SR', 'Suriname', 'AMRO', '18', '780', '0', '18');
INSERT INTO public.who_global_data_import VALUES (82196, '2020-07-16', 'SR', 'Suriname', 'AMRO', '21', '801', '0', '18');
INSERT INTO public.who_global_data_import VALUES (82197, '2020-07-17', 'SR', 'Suriname', 'AMRO', '48', '849', '0', '18');
INSERT INTO public.who_global_data_import VALUES (82198, '2020-07-18', 'SR', 'Suriname', 'AMRO', '70', '919', '1', '19');
INSERT INTO public.who_global_data_import VALUES (82199, '2020-07-19', 'SR', 'Suriname', 'AMRO', '24', '943', '0', '19');
INSERT INTO public.who_global_data_import VALUES (82200, '2020-07-20', 'SR', 'Suriname', 'AMRO', '58', '1001', '1', '20');
INSERT INTO public.who_global_data_import VALUES (82201, '2020-07-21', 'SR', 'Suriname', 'AMRO', '28', '1029', '1', '21');
INSERT INTO public.who_global_data_import VALUES (82202, '2020-07-22', 'SR', 'Suriname', 'AMRO', '50', '1079', '0', '21');
INSERT INTO public.who_global_data_import VALUES (82203, '2020-07-23', 'SR', 'Suriname', 'AMRO', '52', '1131', '0', '21');
INSERT INTO public.who_global_data_import VALUES (82204, '2020-07-24', 'SR', 'Suriname', 'AMRO', '45', '1176', '0', '21');
INSERT INTO public.who_global_data_import VALUES (82205, '2020-07-25', 'SR', 'Suriname', 'AMRO', '58', '1234', '2', '23');
INSERT INTO public.who_global_data_import VALUES (82206, '2020-07-26', 'SR', 'Suriname', 'AMRO', '71', '1305', '0', '23');
INSERT INTO public.who_global_data_import VALUES (82207, '2020-07-27', 'SR', 'Suriname', 'AMRO', '76', '1381', '0', '23');
INSERT INTO public.who_global_data_import VALUES (82208, '2020-07-28', 'SR', 'Suriname', 'AMRO', '58', '1439', '0', '23');
INSERT INTO public.who_global_data_import VALUES (82209, '2020-07-29', 'SR', 'Suriname', 'AMRO', '44', '1483', '1', '24');
INSERT INTO public.who_global_data_import VALUES (82210, '2020-07-30', 'SR', 'Suriname', 'AMRO', '27', '1510', '0', '24');
INSERT INTO public.who_global_data_import VALUES (82211, '2020-07-31', 'SR', 'Suriname', 'AMRO', '97', '1607', '2', '26');
INSERT INTO public.who_global_data_import VALUES (82212, '2020-08-01', 'SR', 'Suriname', 'AMRO', '43', '1650', '0', '26');
INSERT INTO public.who_global_data_import VALUES (82213, '2020-08-02', 'SR', 'Suriname', 'AMRO', '56', '1706', '0', '26');
INSERT INTO public.who_global_data_import VALUES (82214, '2020-08-03', 'SR', 'Suriname', 'AMRO', '54', '1760', '0', '26');
INSERT INTO public.who_global_data_import VALUES (82215, '2020-08-04', 'SR', 'Suriname', 'AMRO', '89', '1849', '1', '27');
INSERT INTO public.who_global_data_import VALUES (82216, '2020-08-05', 'SR', 'Suriname', 'AMRO', '44', '1893', '0', '27');
INSERT INTO public.who_global_data_import VALUES (82217, '2020-08-06', 'SR', 'Suriname', 'AMRO', '88', '1981', '0', '27');
INSERT INTO public.who_global_data_import VALUES (82218, '2020-08-07', 'SR', 'Suriname', 'AMRO', '69', '2050', '0', '27');
INSERT INTO public.who_global_data_import VALUES (82219, '2020-08-08', 'SR', 'Suriname', 'AMRO', '46', '2096', '2', '29');
INSERT INTO public.who_global_data_import VALUES (82220, '2020-08-09', 'SR', 'Suriname', 'AMRO', '107', '2203', '0', '29');
INSERT INTO public.who_global_data_import VALUES (82221, '2020-08-10', 'SR', 'Suriname', 'AMRO', '103', '2306', '0', '29');
INSERT INTO public.who_global_data_import VALUES (82222, '2020-08-11', 'SR', 'Suriname', 'AMRO', '85', '2391', '0', '29');
INSERT INTO public.who_global_data_import VALUES (82223, '2020-08-12', 'SR', 'Suriname', 'AMRO', '98', '2489', '1', '30');
INSERT INTO public.who_global_data_import VALUES (82224, '2020-08-13', 'SR', 'Suriname', 'AMRO', '70', '2559', '9', '39');
INSERT INTO public.who_global_data_import VALUES (82225, '2020-08-14', 'SR', 'Suriname', 'AMRO', '94', '2653', '0', '39');
INSERT INTO public.who_global_data_import VALUES (82226, '2020-08-15', 'SR', 'Suriname', 'AMRO', '108', '2761', '1', '40');
INSERT INTO public.who_global_data_import VALUES (82227, '2020-08-16', 'SR', 'Suriname', 'AMRO', '77', '2838', '1', '41');
INSERT INTO public.who_global_data_import VALUES (82228, '2020-08-17', 'SR', 'Suriname', 'AMRO', '123', '2961', '1', '42');
INSERT INTO public.who_global_data_import VALUES (82229, '2020-08-18', 'SR', 'Suriname', 'AMRO', '55', '3016', '5', '47');
INSERT INTO public.who_global_data_import VALUES (82230, '2020-08-19', 'SR', 'Suriname', 'AMRO', '61', '3077', '1', '48');
INSERT INTO public.who_global_data_import VALUES (82231, '2020-08-20', 'SR', 'Suriname', 'AMRO', '139', '3216', '6', '54');
INSERT INTO public.who_global_data_import VALUES (82232, '2020-08-21', 'SR', 'Suriname', 'AMRO', '79', '3295', '0', '54');
INSERT INTO public.who_global_data_import VALUES (82233, '2020-08-22', 'SR', 'Suriname', 'AMRO', '71', '3366', '1', '55');
INSERT INTO public.who_global_data_import VALUES (82234, '2020-08-23', 'SR', 'Suriname', 'AMRO', '94', '3460', '1', '56');
INSERT INTO public.who_global_data_import VALUES (82235, '2020-08-24', 'SR', 'Suriname', 'AMRO', '109', '3569', '1', '57');
INSERT INTO public.who_global_data_import VALUES (82236, '2020-08-25', 'SR', 'Suriname', 'AMRO', '38', '3607', '1', '58');
INSERT INTO public.who_global_data_import VALUES (82237, '2020-08-26', 'SR', 'Suriname', 'AMRO', '25', '3632', '2', '60');
INSERT INTO public.who_global_data_import VALUES (82238, '2020-08-27', 'SR', 'Suriname', 'AMRO', '66', '3698', '1', '61');
INSERT INTO public.who_global_data_import VALUES (82239, '2020-08-28', 'SR', 'Suriname', 'AMRO', '26', '3724', '1', '62');
INSERT INTO public.who_global_data_import VALUES (82240, '2020-08-29', 'SR', 'Suriname', 'AMRO', '69', '3793', '4', '66');
INSERT INTO public.who_global_data_import VALUES (82241, '2020-08-30', 'SR', 'Suriname', 'AMRO', '55', '3848', '0', '66');
INSERT INTO public.who_global_data_import VALUES (82242, '2020-08-31', 'SR', 'Suriname', 'AMRO', '106', '3954', '1', '67');
INSERT INTO public.who_global_data_import VALUES (82243, '2020-09-01', 'SR', 'Suriname', 'AMRO', '55', '4009', '0', '67');
INSERT INTO public.who_global_data_import VALUES (82244, '2020-09-02', 'SR', 'Suriname', 'AMRO', '25', '4034', '4', '71');
INSERT INTO public.who_global_data_import VALUES (82245, '2020-09-03', 'SR', 'Suriname', 'AMRO', '55', '4089', '1', '72');
INSERT INTO public.who_global_data_import VALUES (82246, '2020-09-04', 'SR', 'Suriname', 'AMRO', '60', '4149', '0', '72');
INSERT INTO public.who_global_data_import VALUES (82247, '2020-09-05', 'SR', 'Suriname', 'AMRO', '66', '4215', '1', '73');
INSERT INTO public.who_global_data_import VALUES (82248, '2020-09-06', 'SR', 'Suriname', 'AMRO', '37', '4252', '2', '75');
INSERT INTO public.who_global_data_import VALUES (82249, '2020-09-07', 'SR', 'Suriname', 'AMRO', '68', '4320', '2', '77');
INSERT INTO public.who_global_data_import VALUES (82250, '2020-09-08', 'SR', 'Suriname', 'AMRO', '26', '4346', '8', '85');
INSERT INTO public.who_global_data_import VALUES (82251, '2020-09-09', 'SR', 'Suriname', 'AMRO', '14', '4360', '6', '91');
INSERT INTO public.who_global_data_import VALUES (82252, '2020-09-10', 'SR', 'Suriname', 'AMRO', '59', '4419', '0', '91');
INSERT INTO public.who_global_data_import VALUES (82253, '2020-09-11', 'SR', 'Suriname', 'AMRO', '28', '4447', '1', '92');
INSERT INTO public.who_global_data_import VALUES (82254, '2020-09-12', 'SR', 'Suriname', 'AMRO', '30', '4477', '1', '93');
INSERT INTO public.who_global_data_import VALUES (82255, '2020-09-13', 'SR', 'Suriname', 'AMRO', '52', '4529', '0', '93');
INSERT INTO public.who_global_data_import VALUES (82256, '2020-09-14', 'SR', 'Suriname', 'AMRO', '50', '4579', '0', '93');
INSERT INTO public.who_global_data_import VALUES (82257, '2020-09-15', 'SR', 'Suriname', 'AMRO', '3', '4582', '0', '93');
INSERT INTO public.who_global_data_import VALUES (82258, '2020-09-16', 'SR', 'Suriname', 'AMRO', '29', '4611', '2', '95');
INSERT INTO public.who_global_data_import VALUES (82259, '2020-09-17', 'SR', 'Suriname', 'AMRO', '14', '4625', '0', '95');
INSERT INTO public.who_global_data_import VALUES (82260, '2020-09-18', 'SR', 'Suriname', 'AMRO', '20', '4645', '0', '95');
INSERT INTO public.who_global_data_import VALUES (82261, '2020-09-19', 'SR', 'Suriname', 'AMRO', '26', '4671', '0', '95');
INSERT INTO public.who_global_data_import VALUES (82262, '2020-09-20', 'SR', 'Suriname', 'AMRO', '20', '4691', '1', '96');
INSERT INTO public.who_global_data_import VALUES (82263, '2020-09-21', 'SR', 'Suriname', 'AMRO', '18', '4709', '1', '97');
INSERT INTO public.who_global_data_import VALUES (82264, '2020-09-22', 'SR', 'Suriname', 'AMRO', '14', '4723', '0', '97');
INSERT INTO public.who_global_data_import VALUES (82265, '2020-09-23', 'SR', 'Suriname', 'AMRO', '17', '4740', '0', '97');
INSERT INTO public.who_global_data_import VALUES (82266, '2020-09-24', 'SR', 'Suriname', 'AMRO', '19', '4759', '3', '100');
INSERT INTO public.who_global_data_import VALUES (82267, '2020-09-25', 'SR', 'Suriname', 'AMRO', '20', '4779', '1', '101');
INSERT INTO public.who_global_data_import VALUES (82268, '2020-09-26', 'SR', 'Suriname', 'AMRO', '10', '4789', '1', '102');
INSERT INTO public.who_global_data_import VALUES (82269, '2020-09-27', 'SR', 'Suriname', 'AMRO', '28', '4817', '0', '102');
INSERT INTO public.who_global_data_import VALUES (82270, '2020-09-28', 'SR', 'Suriname', 'AMRO', '14', '4831', '0', '102');
INSERT INTO public.who_global_data_import VALUES (82271, '2020-09-29', 'SR', 'Suriname', 'AMRO', '4', '4835', '0', '102');
INSERT INTO public.who_global_data_import VALUES (82272, '2020-09-30', 'SR', 'Suriname', 'AMRO', '1', '4836', '0', '102');
INSERT INTO public.who_global_data_import VALUES (82273, '2020-10-01', 'SR', 'Suriname', 'AMRO', '27', '4863', '2', '104');
INSERT INTO public.who_global_data_import VALUES (82274, '2020-10-02', 'SR', 'Suriname', 'AMRO', '14', '4877', '0', '104');
INSERT INTO public.who_global_data_import VALUES (82275, '2020-10-03', 'SR', 'Suriname', 'AMRO', '14', '4891', '1', '105');
INSERT INTO public.who_global_data_import VALUES (82276, '2020-10-04', 'SR', 'Suriname', 'AMRO', '8', '4899', '0', '105');
INSERT INTO public.who_global_data_import VALUES (82277, '2020-10-05', 'SR', 'Suriname', 'AMRO', '25', '4924', '1', '106');
INSERT INTO public.who_global_data_import VALUES (82278, '2020-10-06', 'SR', 'Suriname', 'AMRO', '17', '4941', '0', '106');
INSERT INTO public.who_global_data_import VALUES (82279, '2020-10-07', 'SR', 'Suriname', 'AMRO', '13', '4954', '0', '106');
INSERT INTO public.who_global_data_import VALUES (82280, '2020-10-08', 'SR', 'Suriname', 'AMRO', '11', '4965', '0', '106');
INSERT INTO public.who_global_data_import VALUES (82281, '2020-10-09', 'SR', 'Suriname', 'AMRO', '14', '4979', '0', '106');
INSERT INTO public.who_global_data_import VALUES (82282, '2020-10-10', 'SR', 'Suriname', 'AMRO', '25', '5004', '0', '106');
INSERT INTO public.who_global_data_import VALUES (82283, '2020-10-11', 'SR', 'Suriname', 'AMRO', '14', '5018', '0', '106');
INSERT INTO public.who_global_data_import VALUES (82284, '2020-10-12', 'SR', 'Suriname', 'AMRO', '17', '5035', '1', '107');
INSERT INTO public.who_global_data_import VALUES (82285, '2020-10-13', 'SR', 'Suriname', 'AMRO', '16', '5051', '0', '107');
INSERT INTO public.who_global_data_import VALUES (82286, '2020-10-14', 'SR', 'Suriname', 'AMRO', '7', '5058', '0', '107');
INSERT INTO public.who_global_data_import VALUES (82287, '2020-10-15', 'SR', 'Suriname', 'AMRO', '14', '5072', '0', '107');
INSERT INTO public.who_global_data_import VALUES (82288, '2020-10-16', 'SR', 'Suriname', 'AMRO', '11', '5083', '1', '108');
INSERT INTO public.who_global_data_import VALUES (82289, '2020-10-17', 'SR', 'Suriname', 'AMRO', '11', '5094', '1', '109');
INSERT INTO public.who_global_data_import VALUES (82290, '2020-10-18', 'SR', 'Suriname', 'AMRO', '19', '5113', '0', '109');
INSERT INTO public.who_global_data_import VALUES (82291, '2020-10-19', 'SR', 'Suriname', 'AMRO', '10', '5123', '0', '109');
INSERT INTO public.who_global_data_import VALUES (82292, '2020-10-20', 'SR', 'Suriname', 'AMRO', '7', '5130', '0', '109');
INSERT INTO public.who_global_data_import VALUES (82293, '2020-10-21', 'SR', 'Suriname', 'AMRO', '3', '5133', '0', '109');
INSERT INTO public.who_global_data_import VALUES (82294, '2020-10-22', 'SR', 'Suriname', 'AMRO', '11', '5144', '0', '109');
INSERT INTO public.who_global_data_import VALUES (82295, '2020-10-23', 'SR', 'Suriname', 'AMRO', '6', '5150', '0', '109');
INSERT INTO public.who_global_data_import VALUES (82296, '2020-10-24', 'SR', 'Suriname', 'AMRO', '4', '5154', '0', '109');
INSERT INTO public.who_global_data_import VALUES (82297, '2020-10-25', 'SR', 'Suriname', 'AMRO', '1', '5155', '0', '109');
INSERT INTO public.who_global_data_import VALUES (82298, '2020-10-26', 'SR', 'Suriname', 'AMRO', '11', '5166', '0', '109');
INSERT INTO public.who_global_data_import VALUES (82299, '2020-10-27', 'SR', 'Suriname', 'AMRO', '4', '5170', '0', '109');
INSERT INTO public.who_global_data_import VALUES (82300, '2020-10-28', 'SR', 'Suriname', 'AMRO', '10', '5180', '1', '110');
INSERT INTO public.who_global_data_import VALUES (82301, '2020-10-29', 'SR', 'Suriname', 'AMRO', '7', '5187', '1', '111');
INSERT INTO public.who_global_data_import VALUES (82302, '2020-10-30', 'SR', 'Suriname', 'AMRO', '5', '5192', '0', '111');
INSERT INTO public.who_global_data_import VALUES (82303, '2020-10-31', 'SR', 'Suriname', 'AMRO', '5', '5197', '0', '111');
INSERT INTO public.who_global_data_import VALUES (82304, '2020-11-01', 'SR', 'Suriname', 'AMRO', '4', '5201', '0', '111');
INSERT INTO public.who_global_data_import VALUES (82305, '2020-11-02', 'SR', 'Suriname', 'AMRO', '2', '5203', '0', '111');
INSERT INTO public.who_global_data_import VALUES (82306, '2020-11-03', 'SR', 'Suriname', 'AMRO', '7', '5210', '0', '111');
INSERT INTO public.who_global_data_import VALUES (82307, '2020-11-04', 'SR', 'Suriname', 'AMRO', '2', '5212', '0', '111');
INSERT INTO public.who_global_data_import VALUES (82308, '2020-11-05', 'SR', 'Suriname', 'AMRO', '6', '5218', '0', '111');
INSERT INTO public.who_global_data_import VALUES (82309, '2020-11-06', 'SR', 'Suriname', 'AMRO', '2', '5220', '1', '112');
INSERT INTO public.who_global_data_import VALUES (82310, '2020-11-07', 'SR', 'Suriname', 'AMRO', '5', '5225', '0', '112');
INSERT INTO public.who_global_data_import VALUES (82311, '2020-11-08', 'SR', 'Suriname', 'AMRO', '2', '5227', '0', '112');
INSERT INTO public.who_global_data_import VALUES (82312, '2020-11-09', 'SR', 'Suriname', 'AMRO', '7', '5234', '1', '113');
INSERT INTO public.who_global_data_import VALUES (82313, '2020-11-10', 'SR', 'Suriname', 'AMRO', '5', '5239', '0', '113');
INSERT INTO public.who_global_data_import VALUES (82314, '2020-11-11', 'SR', 'Suriname', 'AMRO', '2', '5241', '0', '113');
INSERT INTO public.who_global_data_import VALUES (82315, '2020-11-12', 'SR', 'Suriname', 'AMRO', '4', '5245', '0', '113');
INSERT INTO public.who_global_data_import VALUES (82316, '2020-11-13', 'SR', 'Suriname', 'AMRO', '9', '5254', '0', '113');
INSERT INTO public.who_global_data_import VALUES (82317, '2020-11-14', 'SR', 'Suriname', 'AMRO', '7', '5261', '1', '114');
INSERT INTO public.who_global_data_import VALUES (82318, '2020-11-15', 'SR', 'Suriname', 'AMRO', '7', '5268', '0', '114');
INSERT INTO public.who_global_data_import VALUES (82319, '2020-11-16', 'SR', 'Suriname', 'AMRO', '6', '5274', '0', '114');
INSERT INTO public.who_global_data_import VALUES (82320, '2020-11-17', 'SR', 'Suriname', 'AMRO', '0', '5274', '0', '114');
INSERT INTO public.who_global_data_import VALUES (82321, '2020-11-18', 'SR', 'Suriname', 'AMRO', '1', '5275', '1', '115');
INSERT INTO public.who_global_data_import VALUES (82322, '2020-11-19', 'SR', 'Suriname', 'AMRO', '3', '5278', '1', '116');
INSERT INTO public.who_global_data_import VALUES (82323, '2020-11-20', 'SR', 'Suriname', 'AMRO', '4', '5282', '0', '116');
INSERT INTO public.who_global_data_import VALUES (82324, '2020-11-21', 'SR', 'Suriname', 'AMRO', '2', '5284', '0', '116');
INSERT INTO public.who_global_data_import VALUES (82325, '2020-11-22', 'SR', 'Suriname', 'AMRO', '5', '5289', '0', '116');
INSERT INTO public.who_global_data_import VALUES (82326, '2020-11-23', 'SR', 'Suriname', 'AMRO', '6', '5295', '0', '116');
INSERT INTO public.who_global_data_import VALUES (82327, '2020-11-24', 'SR', 'Suriname', 'AMRO', '1', '5296', '0', '116');
INSERT INTO public.who_global_data_import VALUES (82328, '2020-11-25', 'SR', 'Suriname', 'AMRO', '1', '5297', '0', '116');
INSERT INTO public.who_global_data_import VALUES (82329, '2020-11-26', 'SR', 'Suriname', 'AMRO', '3', '5300', '1', '117');
INSERT INTO public.who_global_data_import VALUES (82330, '2020-11-27', 'SR', 'Suriname', 'AMRO', '5', '5305', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82331, '2020-11-28', 'SR', 'Suriname', 'AMRO', '2', '5307', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82332, '2020-11-29', 'SR', 'Suriname', 'AMRO', '4', '5311', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82333, '2020-11-30', 'SR', 'Suriname', 'AMRO', '1', '5312', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82334, '2020-12-01', 'SR', 'Suriname', 'AMRO', '0', '5312', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82335, '2020-12-02', 'SR', 'Suriname', 'AMRO', '0', '5312', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82336, '2020-12-03', 'SR', 'Suriname', 'AMRO', '7', '5319', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82337, '2020-12-04', 'SR', 'Suriname', 'AMRO', '1', '5320', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82338, '2020-12-05', 'SR', 'Suriname', 'AMRO', '2', '5322', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82339, '2020-12-06', 'SR', 'Suriname', 'AMRO', '0', '5322', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82340, '2020-12-07', 'SR', 'Suriname', 'AMRO', '2', '5324', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82341, '2020-12-08', 'SR', 'Suriname', 'AMRO', '0', '5324', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82342, '2020-12-09', 'SR', 'Suriname', 'AMRO', '1', '5325', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82343, '2020-12-10', 'SR', 'Suriname', 'AMRO', '1', '5326', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82344, '2020-12-11', 'SR', 'Suriname', 'AMRO', '7', '5333', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82345, '2020-12-12', 'SR', 'Suriname', 'AMRO', '4', '5337', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82346, '2020-12-13', 'SR', 'Suriname', 'AMRO', '2', '5339', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82347, '2020-12-14', 'SR', 'Suriname', 'AMRO', '10', '5349', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82348, '2020-12-15', 'SR', 'Suriname', 'AMRO', '4', '5353', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82349, '2020-12-16', 'SR', 'Suriname', 'AMRO', '6', '5359', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82350, '2020-12-17', 'SR', 'Suriname', 'AMRO', '22', '5381', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82351, '2020-12-18', 'SR', 'Suriname', 'AMRO', '20', '5401', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82352, '2020-12-19', 'SR', 'Suriname', 'AMRO', '27', '5428', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82353, '2020-12-20', 'SR', 'Suriname', 'AMRO', '31', '5459', '0', '117');
INSERT INTO public.who_global_data_import VALUES (82354, '2020-12-21', 'SR', 'Suriname', 'AMRO', '52', '5511', '1', '118');
INSERT INTO public.who_global_data_import VALUES (82355, '2020-12-22', 'SR', 'Suriname', 'AMRO', '41', '5552', '0', '118');
INSERT INTO public.who_global_data_import VALUES (82356, '2020-12-23', 'SR', 'Suriname', 'AMRO', '31', '5583', '0', '118');
INSERT INTO public.who_global_data_import VALUES (82357, '2020-12-24', 'SR', 'Suriname', 'AMRO', '86', '5669', '0', '118');
INSERT INTO public.who_global_data_import VALUES (82358, '2020-12-25', 'SR', 'Suriname', 'AMRO', '65', '5734', '0', '118');
INSERT INTO public.who_global_data_import VALUES (82359, '2020-12-26', 'SR', 'Suriname', 'AMRO', '76', '5810', '0', '118');
INSERT INTO public.who_global_data_import VALUES (82360, '2020-12-27', 'SR', 'Suriname', 'AMRO', '70', '5880', '1', '119');
INSERT INTO public.who_global_data_import VALUES (82361, '2020-12-28', 'SR', 'Suriname', 'AMRO', '58', '5938', '0', '119');
INSERT INTO public.who_global_data_import VALUES (82362, '2020-12-29', 'SR', 'Suriname', 'AMRO', '40', '5978', '0', '119');
INSERT INTO public.who_global_data_import VALUES (82363, '2020-12-30', 'SR', 'Suriname', 'AMRO', '35', '6013', '1', '120');
INSERT INTO public.who_global_data_import VALUES (82364, '2020-12-31', 'SR', 'Suriname', 'AMRO', '85', '6098', '0', '120');
INSERT INTO public.who_global_data_import VALUES (82365, '2021-01-01', 'SR', 'Suriname', 'AMRO', '83', '6181', '1', '121');
INSERT INTO public.who_global_data_import VALUES (82366, '2021-01-02', 'SR', 'Suriname', 'AMRO', '29', '6210', '1', '122');
INSERT INTO public.who_global_data_import VALUES (82367, '2021-01-03', 'SR', 'Suriname', 'AMRO', '67', '6277', '1', '123');
INSERT INTO public.who_global_data_import VALUES (82368, '2021-01-04', 'SR', 'Suriname', 'AMRO', '66', '6343', '0', '123');
INSERT INTO public.who_global_data_import VALUES (82369, '2021-01-05', 'SR', 'Suriname', 'AMRO', '50', '6393', '0', '123');
INSERT INTO public.who_global_data_import VALUES (82370, '2021-01-06', 'SR', 'Suriname', 'AMRO', '100', '6493', '1', '124');
INSERT INTO public.who_global_data_import VALUES (82371, '2021-01-07', 'SR', 'Suriname', 'AMRO', '93', '6586', '1', '125');
INSERT INTO public.who_global_data_import VALUES (82372, '2021-01-08', 'SR', 'Suriname', 'AMRO', '80', '6666', '1', '126');
INSERT INTO public.who_global_data_import VALUES (82373, '2021-01-09', 'SR', 'Suriname', 'AMRO', '84', '6750', '4', '130');
INSERT INTO public.who_global_data_import VALUES (82374, '2021-01-10', 'SR', 'Suriname', 'AMRO', '104', '6854', '1', '131');
INSERT INTO public.who_global_data_import VALUES (82375, '2021-01-11', 'SR', 'Suriname', 'AMRO', '94', '6948', '1', '132');
INSERT INTO public.who_global_data_import VALUES (82376, '2021-01-12', 'SR', 'Suriname', 'AMRO', '60', '7008', '1', '133');
INSERT INTO public.who_global_data_import VALUES (82377, '2021-01-13', 'SR', 'Suriname', 'AMRO', '56', '7064', '5', '138');
INSERT INTO public.who_global_data_import VALUES (82378, '2021-01-14', 'SR', 'Suriname', 'AMRO', '114', '7178', '0', '138');
INSERT INTO public.who_global_data_import VALUES (82379, '2021-01-15', 'SR', 'Suriname', 'AMRO', '69', '7247', '1', '139');
INSERT INTO public.who_global_data_import VALUES (82380, '2021-01-16', 'SR', 'Suriname', 'AMRO', '53', '7300', '0', '139');
INSERT INTO public.who_global_data_import VALUES (82381, '2021-01-17', 'SR', 'Suriname', 'AMRO', '109', '7409', '0', '139');
INSERT INTO public.who_global_data_import VALUES (82382, '2021-01-18', 'SR', 'Suriname', 'AMRO', '60', '7469', '2', '141');
INSERT INTO public.who_global_data_import VALUES (82383, '2021-01-19', 'SR', 'Suriname', 'AMRO', '58', '7527', '0', '141');
INSERT INTO public.who_global_data_import VALUES (82384, '2021-01-20', 'SR', 'Suriname', 'AMRO', '97', '7624', '4', '145');
INSERT INTO public.who_global_data_import VALUES (82385, '2021-01-21', 'SR', 'Suriname', 'AMRO', '85', '7709', '1', '146');
INSERT INTO public.who_global_data_import VALUES (82386, '2021-01-22', 'SR', 'Suriname', 'AMRO', '74', '7783', '0', '146');
INSERT INTO public.who_global_data_import VALUES (82387, '2021-01-23', 'SR', 'Suriname', 'AMRO', '97', '7880', '0', '146');
INSERT INTO public.who_global_data_import VALUES (82388, '2021-01-24', 'SR', 'Suriname', 'AMRO', '65', '7945', '2', '148');
INSERT INTO public.who_global_data_import VALUES (82389, '2021-01-25', 'SR', 'Suriname', 'AMRO', '55', '8000', '0', '148');
INSERT INTO public.who_global_data_import VALUES (82390, '2021-01-26', 'SR', 'Suriname', 'AMRO', '57', '8057', '1', '149');
INSERT INTO public.who_global_data_import VALUES (82391, '2021-01-27', 'SR', 'Suriname', 'AMRO', '55', '8112', '0', '149');
INSERT INTO public.who_global_data_import VALUES (82392, '2021-01-28', 'SR', 'Suriname', 'AMRO', '62', '8174', '1', '150');
INSERT INTO public.who_global_data_import VALUES (82393, '2021-01-29', 'SR', 'Suriname', 'AMRO', '69', '8243', '2', '152');
INSERT INTO public.who_global_data_import VALUES (82394, '2021-01-30', 'SR', 'Suriname', 'AMRO', '50', '8293', '2', '154');
INSERT INTO public.who_global_data_import VALUES (82395, '2021-01-31', 'SR', 'Suriname', 'AMRO', '71', '8364', '0', '154');
INSERT INTO public.who_global_data_import VALUES (82396, '2021-02-01', 'SR', 'Suriname', 'AMRO', '39', '8403', '0', '154');
INSERT INTO public.who_global_data_import VALUES (82397, '2021-02-02', 'SR', 'Suriname', 'AMRO', '35', '8438', '0', '154');
INSERT INTO public.who_global_data_import VALUES (82398, '2021-02-03', 'SR', 'Suriname', 'AMRO', '11', '8449', '2', '156');
INSERT INTO public.who_global_data_import VALUES (82399, '2021-02-04', 'SR', 'Suriname', 'AMRO', '48', '8497', '0', '156');
INSERT INTO public.who_global_data_import VALUES (82400, '2021-02-05', 'SR', 'Suriname', 'AMRO', '59', '8556', '0', '156');
INSERT INTO public.who_global_data_import VALUES (82401, '2020-01-03', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82402, '2020-01-04', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82403, '2020-01-05', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82404, '2020-01-06', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82405, '2020-01-07', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82406, '2020-01-08', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82407, '2020-01-09', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82408, '2020-01-10', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82409, '2020-01-11', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82410, '2020-01-12', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82411, '2020-01-13', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82412, '2020-01-14', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82413, '2020-01-15', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82414, '2020-01-16', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82415, '2020-01-17', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82416, '2020-01-18', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82417, '2020-01-19', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82418, '2020-01-20', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82419, '2020-01-21', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82420, '2020-01-22', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82421, '2020-01-23', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82422, '2020-01-24', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82423, '2020-01-25', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82424, '2020-01-26', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82425, '2020-01-27', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82426, '2020-01-28', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82427, '2020-01-29', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82428, '2020-01-30', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82429, '2020-01-31', 'SE', 'Sweden', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82430, '2020-02-01', 'SE', 'Sweden', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82431, '2020-02-02', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82432, '2020-02-03', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82433, '2020-02-04', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82434, '2020-02-05', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82435, '2020-02-06', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82436, '2020-02-07', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82437, '2020-02-08', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82438, '2020-02-09', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82439, '2020-02-10', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82440, '2020-02-11', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82441, '2020-02-12', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82442, '2020-02-13', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82443, '2020-02-14', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82444, '2020-02-15', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82445, '2020-02-16', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82446, '2020-02-17', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82447, '2020-02-18', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82448, '2020-02-19', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82449, '2020-02-20', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82450, '2020-02-21', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82451, '2020-02-22', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82452, '2020-02-23', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82453, '2020-02-24', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82454, '2020-02-25', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82455, '2020-02-26', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82456, '2020-02-27', 'SE', 'Sweden', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82457, '2020-02-28', 'SE', 'Sweden', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82458, '2020-02-29', 'SE', 'Sweden', 'EURO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82459, '2020-03-01', 'SE', 'Sweden', 'EURO', '8', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82460, '2020-03-02', 'SE', 'Sweden', 'EURO', '3', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82461, '2020-03-03', 'SE', 'Sweden', 'EURO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82462, '2020-03-04', 'SE', 'Sweden', 'EURO', '5', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82463, '2020-03-05', 'SE', 'Sweden', 'EURO', '13', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82464, '2020-03-06', 'SE', 'Sweden', 'EURO', '30', '62', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82465, '2020-03-07', 'SE', 'Sweden', 'EURO', '25', '87', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82466, '2020-03-08', 'SE', 'Sweden', 'EURO', '59', '146', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82467, '2020-03-09', 'SE', 'Sweden', 'EURO', '33', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82468, '2020-03-10', 'SE', 'Sweden', 'EURO', '46', '225', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82469, '2020-03-11', 'SE', 'Sweden', 'EURO', '101', '326', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82470, '2020-03-12', 'SE', 'Sweden', 'EURO', '98', '424', '1', '1');
INSERT INTO public.who_global_data_import VALUES (82471, '2020-03-13', 'SE', 'Sweden', 'EURO', '196', '620', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82472, '2020-03-14', 'SE', 'Sweden', 'EURO', '151', '771', '0', '1');
INSERT INTO public.who_global_data_import VALUES (82473, '2020-03-15', 'SE', 'Sweden', 'EURO', '152', '923', '1', '2');
INSERT INTO public.who_global_data_import VALUES (82474, '2020-03-16', 'SE', 'Sweden', 'EURO', '71', '994', '1', '3');
INSERT INTO public.who_global_data_import VALUES (82475, '2020-03-17', 'SE', 'Sweden', 'EURO', '69', '1063', '2', '5');
INSERT INTO public.who_global_data_import VALUES (82476, '2020-03-18', 'SE', 'Sweden', 'EURO', '83', '1146', '2', '7');
INSERT INTO public.who_global_data_import VALUES (82477, '2020-03-19', 'SE', 'Sweden', 'EURO', '119', '1265', '1', '8');
INSERT INTO public.who_global_data_import VALUES (82478, '2020-03-20', 'SE', 'Sweden', 'EURO', '145', '1410', '6', '14');
INSERT INTO public.who_global_data_import VALUES (82479, '2020-03-21', 'SE', 'Sweden', 'EURO', '143', '1553', '7', '21');
INSERT INTO public.who_global_data_import VALUES (82480, '2020-03-22', 'SE', 'Sweden', 'EURO', '180', '1733', '9', '30');
INSERT INTO public.who_global_data_import VALUES (82481, '2020-03-23', 'SE', 'Sweden', 'EURO', '136', '1869', '8', '38');
INSERT INTO public.who_global_data_import VALUES (82482, '2020-03-24', 'SE', 'Sweden', 'EURO', '118', '1987', '11', '49');
INSERT INTO public.who_global_data_import VALUES (82483, '2020-03-25', 'SE', 'Sweden', 'EURO', '182', '2169', '11', '60');
INSERT INTO public.who_global_data_import VALUES (82484, '2020-03-26', 'SE', 'Sweden', 'EURO', '230', '2399', '21', '81');
INSERT INTO public.who_global_data_import VALUES (82485, '2020-03-27', 'SE', 'Sweden', 'EURO', '314', '2713', '22', '103');
INSERT INTO public.who_global_data_import VALUES (82486, '2020-03-28', 'SE', 'Sweden', 'EURO', '286', '2999', '31', '134');
INSERT INTO public.who_global_data_import VALUES (82487, '2020-03-29', 'SE', 'Sweden', 'EURO', '365', '3364', '32', '166');
INSERT INTO public.who_global_data_import VALUES (82488, '2020-03-30', 'SE', 'Sweden', 'EURO', '300', '3664', '35', '201');
INSERT INTO public.who_global_data_import VALUES (82489, '2020-03-31', 'SE', 'Sweden', 'EURO', '280', '3944', '38', '239');
INSERT INTO public.who_global_data_import VALUES (82490, '2020-04-01', 'SE', 'Sweden', 'EURO', '416', '4360', '45', '284');
INSERT INTO public.who_global_data_import VALUES (82491, '2020-04-02', 'SE', 'Sweden', 'EURO', '474', '4834', '48', '332');
INSERT INTO public.who_global_data_import VALUES (82492, '2020-04-03', 'SE', 'Sweden', 'EURO', '486', '5320', '53', '385');
INSERT INTO public.who_global_data_import VALUES (82493, '2020-04-04', 'SE', 'Sweden', 'EURO', '554', '5874', '70', '455');
INSERT INTO public.who_global_data_import VALUES (82494, '2020-04-05', 'SE', 'Sweden', 'EURO', '601', '6475', '80', '535');
INSERT INTO public.who_global_data_import VALUES (82495, '2020-04-06', 'SE', 'Sweden', 'EURO', '357', '6832', '70', '605');
INSERT INTO public.who_global_data_import VALUES (82496, '2020-04-07', 'SE', 'Sweden', 'EURO', '340', '7172', '85', '690');
INSERT INTO public.who_global_data_import VALUES (82497, '2020-04-08', 'SE', 'Sweden', 'EURO', '389', '7561', '90', '780');
INSERT INTO public.who_global_data_import VALUES (82498, '2020-04-09', 'SE', 'Sweden', 'EURO', '739', '8300', '84', '864');
INSERT INTO public.who_global_data_import VALUES (82499, '2020-04-10', 'SE', 'Sweden', 'EURO', '654', '8954', '154', '1018');
INSERT INTO public.who_global_data_import VALUES (82500, '2020-04-11', 'SE', 'Sweden', 'EURO', '645', '9599', '86', '1104');
INSERT INTO public.who_global_data_import VALUES (82501, '2020-04-12', 'SE', 'Sweden', 'EURO', '454', '10053', '90', '1194');
INSERT INTO public.who_global_data_import VALUES (82502, '2020-04-13', 'SE', 'Sweden', 'EURO', '395', '10448', '102', '1296');
INSERT INTO public.who_global_data_import VALUES (82503, '2020-04-14', 'SE', 'Sweden', 'EURO', '464', '10912', '97', '1393');
INSERT INTO public.who_global_data_import VALUES (82504, '2020-04-15', 'SE', 'Sweden', 'EURO', '437', '11349', '84', '1477');
INSERT INTO public.who_global_data_import VALUES (82505, '2020-04-16', 'SE', 'Sweden', 'EURO', '479', '11828', '91', '1568');
INSERT INTO public.who_global_data_import VALUES (82506, '2020-04-17', 'SE', 'Sweden', 'EURO', '604', '12432', '115', '1683');
INSERT INTO public.who_global_data_import VALUES (82507, '2020-04-18', 'SE', 'Sweden', 'EURO', '623', '13055', '111', '1794');
INSERT INTO public.who_global_data_import VALUES (82508, '2020-04-19', 'SE', 'Sweden', 'EURO', '688', '13743', '83', '1877');
INSERT INTO public.who_global_data_import VALUES (82509, '2020-04-20', 'SE', 'Sweden', 'EURO', '532', '14275', '86', '1963');
INSERT INTO public.who_global_data_import VALUES (82510, '2020-04-21', 'SE', 'Sweden', 'EURO', '388', '14663', '87', '2050');
INSERT INTO public.who_global_data_import VALUES (82511, '2020-04-22', 'SE', 'Sweden', 'EURO', '461', '15124', '85', '2135');
INSERT INTO public.who_global_data_import VALUES (82512, '2020-04-23', 'SE', 'Sweden', 'EURO', '707', '15831', '62', '2197');
INSERT INTO public.who_global_data_import VALUES (82513, '2020-04-24', 'SE', 'Sweden', 'EURO', '722', '16553', '77', '2274');
INSERT INTO public.who_global_data_import VALUES (82514, '2020-04-25', 'SE', 'Sweden', 'EURO', '758', '17311', '86', '2360');
INSERT INTO public.who_global_data_import VALUES (82515, '2020-04-26', 'SE', 'Sweden', 'EURO', '780', '18091', '89', '2449');
INSERT INTO public.who_global_data_import VALUES (82516, '2020-04-27', 'SE', 'Sweden', 'EURO', '473', '18564', '73', '2522');
INSERT INTO public.who_global_data_import VALUES (82517, '2020-04-28', 'SE', 'Sweden', 'EURO', '300', '18864', '74', '2596');
INSERT INTO public.who_global_data_import VALUES (82518, '2020-04-29', 'SE', 'Sweden', 'EURO', '563', '19427', '74', '2670');
INSERT INTO public.who_global_data_import VALUES (82519, '2020-04-30', 'SE', 'Sweden', 'EURO', '742', '20169', '83', '2753');
INSERT INTO public.who_global_data_import VALUES (82520, '2020-05-01', 'SE', 'Sweden', 'EURO', '799', '20968', '83', '2836');
INSERT INTO public.who_global_data_import VALUES (82521, '2020-05-02', 'SE', 'Sweden', 'EURO', '636', '21604', '78', '2914');
INSERT INTO public.who_global_data_import VALUES (82522, '2020-05-03', 'SE', 'Sweden', 'EURO', '532', '22136', '78', '2992');
INSERT INTO public.who_global_data_import VALUES (82523, '2020-05-04', 'SE', 'Sweden', 'EURO', '299', '22435', '72', '3064');
INSERT INTO public.who_global_data_import VALUES (82524, '2020-05-05', 'SE', 'Sweden', 'EURO', '261', '22696', '75', '3139');
INSERT INTO public.who_global_data_import VALUES (82525, '2020-05-06', 'SE', 'Sweden', 'EURO', '477', '23173', '84', '3223');
INSERT INTO public.who_global_data_import VALUES (82526, '2020-05-07', 'SE', 'Sweden', 'EURO', '657', '23830', '72', '3295');
INSERT INTO public.who_global_data_import VALUES (82527, '2020-05-08', 'SE', 'Sweden', 'EURO', '745', '24575', '73', '3368');
INSERT INTO public.who_global_data_import VALUES (82528, '2020-05-09', 'SE', 'Sweden', 'EURO', '785', '25360', '80', '3448');
INSERT INTO public.who_global_data_import VALUES (82529, '2020-05-10', 'SE', 'Sweden', 'EURO', '701', '26061', '60', '3508');
INSERT INTO public.who_global_data_import VALUES (82530, '2020-05-11', 'SE', 'Sweden', 'EURO', '509', '26570', '68', '3576');
INSERT INTO public.who_global_data_import VALUES (82531, '2020-05-12', 'SE', 'Sweden', 'EURO', '279', '26849', '73', '3649');
INSERT INTO public.who_global_data_import VALUES (82532, '2020-05-13', 'SE', 'Sweden', 'EURO', '455', '27304', '65', '3714');
INSERT INTO public.who_global_data_import VALUES (82533, '2020-05-14', 'SE', 'Sweden', 'EURO', '754', '28058', '61', '3775');
INSERT INTO public.who_global_data_import VALUES (82534, '2020-05-15', 'SE', 'Sweden', 'EURO', '698', '28756', '50', '3825');
INSERT INTO public.who_global_data_import VALUES (82535, '2020-05-16', 'SE', 'Sweden', 'EURO', '657', '29413', '46', '3871');
INSERT INTO public.who_global_data_import VALUES (82536, '2020-05-17', 'SE', 'Sweden', 'EURO', '688', '30101', '58', '3929');
INSERT INTO public.who_global_data_import VALUES (82537, '2020-05-18', 'SE', 'Sweden', 'EURO', '358', '30459', '48', '3977');
INSERT INTO public.who_global_data_import VALUES (82538, '2020-05-19', 'SE', 'Sweden', 'EURO', '259', '30718', '52', '4029');
INSERT INTO public.who_global_data_import VALUES (82539, '2020-05-20', 'SE', 'Sweden', 'EURO', '430', '31148', '59', '4088');
INSERT INTO public.who_global_data_import VALUES (82540, '2020-05-21', 'SE', 'Sweden', 'EURO', '666', '31814', '41', '4129');
INSERT INTO public.who_global_data_import VALUES (82541, '2020-05-22', 'SE', 'Sweden', 'EURO', '808', '32622', '52', '4181');
INSERT INTO public.who_global_data_import VALUES (82542, '2020-05-23', 'SE', 'Sweden', 'EURO', '610', '33232', '53', '4234');
INSERT INTO public.who_global_data_import VALUES (82543, '2020-05-24', 'SE', 'Sweden', 'EURO', '532', '33764', '56', '4290');
INSERT INTO public.who_global_data_import VALUES (82544, '2020-05-25', 'SE', 'Sweden', 'EURO', '403', '34167', '55', '4345');
INSERT INTO public.who_global_data_import VALUES (82545, '2020-05-26', 'SE', 'Sweden', 'EURO', '210', '34377', '44', '4389');
INSERT INTO public.who_global_data_import VALUES (82546, '2020-05-27', 'SE', 'Sweden', 'EURO', '491', '34868', '42', '4431');
INSERT INTO public.who_global_data_import VALUES (82547, '2020-05-28', 'SE', 'Sweden', 'EURO', '746', '35614', '28', '4459');
INSERT INTO public.who_global_data_import VALUES (82548, '2020-05-29', 'SE', 'Sweden', 'EURO', '800', '36414', '38', '4497');
INSERT INTO public.who_global_data_import VALUES (82549, '2020-05-30', 'SE', 'Sweden', 'EURO', '774', '37188', '40', '4537');
INSERT INTO public.who_global_data_import VALUES (82550, '2020-05-31', 'SE', 'Sweden', 'EURO', '773', '37961', '40', '4577');
INSERT INTO public.who_global_data_import VALUES (82551, '2020-06-01', 'SE', 'Sweden', 'EURO', '432', '38393', '38', '4615');
INSERT INTO public.who_global_data_import VALUES (82552, '2020-06-02', 'SE', 'Sweden', 'EURO', '265', '38658', '46', '4661');
INSERT INTO public.who_global_data_import VALUES (82553, '2020-06-03', 'SE', 'Sweden', 'EURO', '648', '39306', '39', '4700');
INSERT INTO public.who_global_data_import VALUES (82554, '2020-06-04', 'SE', 'Sweden', 'EURO', '900', '40206', '36', '4736');
INSERT INTO public.who_global_data_import VALUES (82555, '2020-06-05', 'SE', 'Sweden', 'EURO', '1046', '41252', '28', '4764');
INSERT INTO public.who_global_data_import VALUES (82556, '2020-06-06', 'SE', 'Sweden', 'EURO', '1039', '42291', '43', '4807');
INSERT INTO public.who_global_data_import VALUES (82557, '2020-06-07', 'SE', 'Sweden', 'EURO', '1146', '43437', '37', '4844');
INSERT INTO public.who_global_data_import VALUES (82558, '2020-06-08', 'SE', 'Sweden', 'EURO', '780', '44217', '29', '4873');
INSERT INTO public.who_global_data_import VALUES (82559, '2020-06-09', 'SE', 'Sweden', 'EURO', '462', '44679', '33', '4906');
INSERT INTO public.who_global_data_import VALUES (82560, '2020-06-10', 'SE', 'Sweden', 'EURO', '677', '45356', '38', '4944');
INSERT INTO public.who_global_data_import VALUES (82561, '2020-06-11', 'SE', 'Sweden', 'EURO', '937', '46293', '33', '4977');
INSERT INTO public.who_global_data_import VALUES (82562, '2020-06-12', 'SE', 'Sweden', 'EURO', '1437', '47730', '39', '5016');
INSERT INTO public.who_global_data_import VALUES (82563, '2020-06-13', 'SE', 'Sweden', 'EURO', '1293', '49023', '35', '5051');
INSERT INTO public.who_global_data_import VALUES (82564, '2020-06-14', 'SE', 'Sweden', 'EURO', '1329', '50352', '29', '5080');
INSERT INTO public.who_global_data_import VALUES (82565, '2020-06-15', 'SE', 'Sweden', 'EURO', '1032', '51384', '33', '5113');
INSERT INTO public.who_global_data_import VALUES (82566, '2020-06-16', 'SE', 'Sweden', 'EURO', '418', '51802', '27', '5140');
INSERT INTO public.who_global_data_import VALUES (82567, '2020-06-17', 'SE', 'Sweden', 'EURO', '685', '52487', '30', '5170');
INSERT INTO public.who_global_data_import VALUES (82568, '2020-06-18', 'SE', 'Sweden', 'EURO', '1209', '53696', '28', '5198');
INSERT INTO public.who_global_data_import VALUES (82569, '2020-06-19', 'SE', 'Sweden', 'EURO', '1457', '55153', '32', '5230');
INSERT INTO public.who_global_data_import VALUES (82570, '2020-06-20', 'SE', 'Sweden', 'EURO', '1494', '56647', '29', '5259');
INSERT INTO public.who_global_data_import VALUES (82571, '2020-06-21', 'SE', 'Sweden', 'EURO', '1209', '57856', '30', '5289');
INSERT INTO public.who_global_data_import VALUES (82572, '2020-06-22', 'SE', 'Sweden', 'EURO', '698', '58554', '29', '5318');
INSERT INTO public.who_global_data_import VALUES (82573, '2020-06-23', 'SE', 'Sweden', 'EURO', '321', '58875', '22', '5340');
INSERT INTO public.who_global_data_import VALUES (82574, '2020-06-24', 'SE', 'Sweden', 'EURO', '800', '59675', '20', '5360');
INSERT INTO public.who_global_data_import VALUES (82575, '2020-06-25', 'SE', 'Sweden', 'EURO', '1309', '60984', '25', '5385');
INSERT INTO public.who_global_data_import VALUES (82576, '2020-06-26', 'SE', 'Sweden', 'EURO', '1698', '62682', '22', '5407');
INSERT INTO public.who_global_data_import VALUES (82577, '2020-06-27', 'SE', 'Sweden', 'EURO', '1278', '63960', '23', '5430');
INSERT INTO public.who_global_data_import VALUES (82578, '2020-06-28', 'SE', 'Sweden', 'EURO', '1204', '65164', '11', '5441');
INSERT INTO public.who_global_data_import VALUES (82579, '2020-06-29', 'SE', 'Sweden', 'EURO', '755', '65919', '14', '5455');
INSERT INTO public.who_global_data_import VALUES (82580, '2020-06-30', 'SE', 'Sweden', 'EURO', '415', '66334', '23', '5478');
INSERT INTO public.who_global_data_import VALUES (82581, '2020-07-01', 'SE', 'Sweden', 'EURO', '726', '67060', '16', '5494');
INSERT INTO public.who_global_data_import VALUES (82582, '2020-07-02', 'SE', 'Sweden', 'EURO', '804', '67864', '20', '5514');
INSERT INTO public.who_global_data_import VALUES (82583, '2020-07-03', 'SE', 'Sweden', 'EURO', '685', '68549', '15', '5529');
INSERT INTO public.who_global_data_import VALUES (82584, '2020-07-04', 'SE', 'Sweden', 'EURO', '687', '69236', '15', '5544');
INSERT INTO public.who_global_data_import VALUES (82585, '2020-07-05', 'SE', 'Sweden', 'EURO', '694', '69930', '8', '5552');
INSERT INTO public.who_global_data_import VALUES (82586, '2020-07-06', 'SE', 'Sweden', 'EURO', '364', '70294', '15', '5567');
INSERT INTO public.who_global_data_import VALUES (82587, '2020-07-07', 'SE', 'Sweden', 'EURO', '315', '70609', '9', '5576');
INSERT INTO public.who_global_data_import VALUES (82588, '2020-07-08', 'SE', 'Sweden', 'EURO', '251', '70860', '15', '5591');
INSERT INTO public.who_global_data_import VALUES (82589, '2020-07-09', 'SE', 'Sweden', 'EURO', '278', '71138', '12', '5603');
INSERT INTO public.who_global_data_import VALUES (82590, '2020-07-10', 'SE', 'Sweden', 'EURO', '533', '71671', '10', '5613');
INSERT INTO public.who_global_data_import VALUES (82591, '2020-07-11', 'SE', 'Sweden', 'EURO', '334', '72005', '15', '5628');
INSERT INTO public.who_global_data_import VALUES (82592, '2020-07-12', 'SE', 'Sweden', 'EURO', '369', '72374', '14', '5642');
INSERT INTO public.who_global_data_import VALUES (82593, '2020-07-13', 'SE', 'Sweden', 'EURO', '308', '72682', '10', '5652');
INSERT INTO public.who_global_data_import VALUES (82594, '2020-07-14', 'SE', 'Sweden', 'EURO', '106', '72788', '8', '5660');
INSERT INTO public.who_global_data_import VALUES (82595, '2020-07-15', 'SE', 'Sweden', 'EURO', '170', '72958', '12', '5672');
INSERT INTO public.who_global_data_import VALUES (82596, '2020-07-16', 'SE', 'Sweden', 'EURO', '312', '73270', '8', '5680');
INSERT INTO public.who_global_data_import VALUES (82597, '2020-07-17', 'SE', 'Sweden', 'EURO', '287', '73557', '6', '5686');
INSERT INTO public.who_global_data_import VALUES (82598, '2020-07-18', 'SE', 'Sweden', 'EURO', '268', '73825', '6', '5692');
INSERT INTO public.who_global_data_import VALUES (82599, '2020-07-19', 'SE', 'Sweden', 'EURO', '284', '74109', '7', '5699');
INSERT INTO public.who_global_data_import VALUES (82600, '2020-07-20', 'SE', 'Sweden', 'EURO', '191', '74300', '11', '5710');
INSERT INTO public.who_global_data_import VALUES (82601, '2020-07-21', 'SE', 'Sweden', 'EURO', '110', '74410', '7', '5717');
INSERT INTO public.who_global_data_import VALUES (82602, '2020-07-22', 'SE', 'Sweden', 'EURO', '131', '74541', '6', '5723');
INSERT INTO public.who_global_data_import VALUES (82603, '2020-07-23', 'SE', 'Sweden', 'EURO', '226', '74767', '7', '5730');
INSERT INTO public.who_global_data_import VALUES (82604, '2020-07-24', 'SE', 'Sweden', 'EURO', '297', '75064', '6', '5736');
INSERT INTO public.who_global_data_import VALUES (82605, '2020-07-25', 'SE', 'Sweden', 'EURO', '220', '75284', '5', '5741');
INSERT INTO public.who_global_data_import VALUES (82606, '2020-07-26', 'SE', 'Sweden', 'EURO', '262', '75546', '3', '5744');
INSERT INTO public.who_global_data_import VALUES (82607, '2020-07-27', 'SE', 'Sweden', 'EURO', '138', '75684', '1', '5745');
INSERT INTO public.who_global_data_import VALUES (82608, '2020-07-28', 'SE', 'Sweden', 'EURO', '42', '75726', '2', '5747');
INSERT INTO public.who_global_data_import VALUES (82609, '2020-07-29', 'SE', 'Sweden', 'EURO', '71', '75797', '6', '5753');
INSERT INTO public.who_global_data_import VALUES (82610, '2020-07-30', 'SE', 'Sweden', 'EURO', '283', '76080', '4', '5757');
INSERT INTO public.who_global_data_import VALUES (82611, '2020-07-31', 'SE', 'Sweden', 'EURO', '301', '76381', '1', '5758');
INSERT INTO public.who_global_data_import VALUES (82612, '2020-08-01', 'SE', 'Sweden', 'EURO', '302', '76683', '0', '5758');
INSERT INTO public.who_global_data_import VALUES (82613, '2020-08-02', 'SE', 'Sweden', 'EURO', '258', '76941', '2', '5760');
INSERT INTO public.who_global_data_import VALUES (82614, '2020-08-03', 'SE', 'Sweden', 'EURO', '303', '77244', '2', '5762');
INSERT INTO public.who_global_data_import VALUES (82615, '2020-08-04', 'SE', 'Sweden', 'EURO', '38', '77282', '3', '5765');
INSERT INTO public.who_global_data_import VALUES (82616, '2020-08-05', 'SE', 'Sweden', 'EURO', '165', '77447', '4', '5769');
INSERT INTO public.who_global_data_import VALUES (82617, '2020-08-06', 'SE', 'Sweden', 'EURO', '333', '77780', '2', '5771');
INSERT INTO public.who_global_data_import VALUES (82618, '2020-08-07', 'SE', 'Sweden', 'EURO', '425', '78205', '1', '5772');
INSERT INTO public.who_global_data_import VALUES (82619, '2020-08-08', 'SE', 'Sweden', 'EURO', '378', '78583', '4', '5776');
INSERT INTO public.who_global_data_import VALUES (82620, '2020-08-09', 'SE', 'Sweden', 'EURO', '380', '78963', '2', '5778');
INSERT INTO public.who_global_data_import VALUES (82621, '2020-08-10', 'SE', 'Sweden', 'EURO', '260', '79223', '1', '5779');
INSERT INTO public.who_global_data_import VALUES (82622, '2020-08-11', 'SE', 'Sweden', 'EURO', '73', '79296', '4', '5783');
INSERT INTO public.who_global_data_import VALUES (82623, '2020-08-12', 'SE', 'Sweden', 'EURO', '196', '79492', '2', '5785');
INSERT INTO public.who_global_data_import VALUES (82624, '2020-08-13', 'SE', 'Sweden', 'EURO', '417', '79909', '4', '5789');
INSERT INTO public.who_global_data_import VALUES (82625, '2020-08-14', 'SE', 'Sweden', 'EURO', '443', '80352', '3', '5792');
INSERT INTO public.who_global_data_import VALUES (82626, '2020-08-15', 'SE', 'Sweden', 'EURO', '363', '80715', '5', '5797');
INSERT INTO public.who_global_data_import VALUES (82627, '2020-08-16', 'SE', 'Sweden', 'EURO', '344', '81059', '1', '5798');
INSERT INTO public.who_global_data_import VALUES (82628, '2020-08-17', 'SE', 'Sweden', 'EURO', '226', '81285', '1', '5799');
INSERT INTO public.who_global_data_import VALUES (82629, '2020-08-18', 'SE', 'Sweden', 'EURO', '63', '81348', '0', '5799');
INSERT INTO public.who_global_data_import VALUES (82630, '2020-08-19', 'SE', 'Sweden', 'EURO', '174', '81522', '3', '5802');
INSERT INTO public.who_global_data_import VALUES (82631, '2020-08-20', 'SE', 'Sweden', 'EURO', '314', '81836', '4', '5806');
INSERT INTO public.who_global_data_import VALUES (82632, '2020-08-21', 'SE', 'Sweden', 'EURO', '351', '82187', '1', '5807');
INSERT INTO public.who_global_data_import VALUES (82633, '2020-08-22', 'SE', 'Sweden', 'EURO', '333', '82520', '2', '5809');
INSERT INTO public.who_global_data_import VALUES (82634, '2020-08-23', 'SE', 'Sweden', 'EURO', '298', '82818', '5', '5814');
INSERT INTO public.who_global_data_import VALUES (82635, '2020-08-24', 'SE', 'Sweden', 'EURO', '160', '82978', '1', '5815');
INSERT INTO public.who_global_data_import VALUES (82636, '2020-08-25', 'SE', 'Sweden', 'EURO', '57', '83035', '3', '5818');
INSERT INTO public.who_global_data_import VALUES (82637, '2020-08-26', 'SE', 'Sweden', 'EURO', '174', '83209', '1', '5819');
INSERT INTO public.who_global_data_import VALUES (82638, '2020-08-27', 'SE', 'Sweden', 'EURO', '222', '83431', '1', '5820');
INSERT INTO public.who_global_data_import VALUES (82639, '2020-08-28', 'SE', 'Sweden', 'EURO', '244', '83675', '2', '5822');
INSERT INTO public.who_global_data_import VALUES (82640, '2020-08-29', 'SE', 'Sweden', 'EURO', '202', '83877', '1', '5823');
INSERT INTO public.who_global_data_import VALUES (82641, '2020-08-30', 'SE', 'Sweden', 'EURO', '179', '84056', '1', '5824');
INSERT INTO public.who_global_data_import VALUES (82642, '2020-08-31', 'SE', 'Sweden', 'EURO', '131', '84187', '1', '5825');
INSERT INTO public.who_global_data_import VALUES (82643, '2020-09-01', 'SE', 'Sweden', 'EURO', '48', '84235', '3', '5828');
INSERT INTO public.who_global_data_import VALUES (82644, '2020-09-02', 'SE', 'Sweden', 'EURO', '162', '84397', '2', '5830');
INSERT INTO public.who_global_data_import VALUES (82645, '2020-09-03', 'SE', 'Sweden', 'EURO', '171', '84568', '3', '5833');
INSERT INTO public.who_global_data_import VALUES (82646, '2020-09-04', 'SE', 'Sweden', 'EURO', '213', '84781', '2', '5835');
INSERT INTO public.who_global_data_import VALUES (82647, '2020-09-05', 'SE', 'Sweden', 'EURO', '286', '85067', '2', '5837');
INSERT INTO public.who_global_data_import VALUES (82648, '2020-09-06', 'SE', 'Sweden', 'EURO', '262', '85329', '0', '5837');
INSERT INTO public.who_global_data_import VALUES (82649, '2020-09-07', 'SE', 'Sweden', 'EURO', '171', '85500', '0', '5837');
INSERT INTO public.who_global_data_import VALUES (82650, '2020-09-08', 'SE', 'Sweden', 'EURO', '67', '85567', '3', '5840');
INSERT INTO public.who_global_data_import VALUES (82651, '2020-09-09', 'SE', 'Sweden', 'EURO', '185', '85752', '1', '5841');
INSERT INTO public.who_global_data_import VALUES (82652, '2020-09-10', 'SE', 'Sweden', 'EURO', '236', '85988', '1', '5842');
INSERT INTO public.who_global_data_import VALUES (82653, '2020-09-11', 'SE', 'Sweden', 'EURO', '314', '86302', '2', '5844');
INSERT INTO public.who_global_data_import VALUES (82654, '2020-09-12', 'SE', 'Sweden', 'EURO', '254', '86556', '2', '5846');
INSERT INTO public.who_global_data_import VALUES (82655, '2020-09-13', 'SE', 'Sweden', 'EURO', '291', '86847', '4', '5850');
INSERT INTO public.who_global_data_import VALUES (82656, '2020-09-14', 'SE', 'Sweden', 'EURO', '206', '87053', '1', '5851');
INSERT INTO public.who_global_data_import VALUES (82657, '2020-09-15', 'SE', 'Sweden', 'EURO', '106', '87159', '2', '5853');
INSERT INTO public.who_global_data_import VALUES (82658, '2020-09-16', 'SE', 'Sweden', 'EURO', '220', '87379', '2', '5855');
INSERT INTO public.who_global_data_import VALUES (82659, '2020-09-17', 'SE', 'Sweden', 'EURO', '292', '87671', '1', '5856');
INSERT INTO public.who_global_data_import VALUES (82660, '2020-09-18', 'SE', 'Sweden', 'EURO', '330', '88001', '2', '5858');
INSERT INTO public.who_global_data_import VALUES (82661, '2020-09-19', 'SE', 'Sweden', 'EURO', '389', '88390', '1', '5859');
INSERT INTO public.who_global_data_import VALUES (82662, '2020-09-20', 'SE', 'Sweden', 'EURO', '437', '88827', '1', '5860');
INSERT INTO public.who_global_data_import VALUES (82663, '2020-09-21', 'SE', 'Sweden', 'EURO', '279', '89106', '1', '5861');
INSERT INTO public.who_global_data_import VALUES (82664, '2020-09-22', 'SE', 'Sweden', 'EURO', '133', '89239', '4', '5865');
INSERT INTO public.who_global_data_import VALUES (82665, '2020-09-23', 'SE', 'Sweden', 'EURO', '266', '89505', '2', '5867');
INSERT INTO public.who_global_data_import VALUES (82666, '2020-09-24', 'SE', 'Sweden', 'EURO', '438', '89943', '1', '5868');
INSERT INTO public.who_global_data_import VALUES (82667, '2020-09-25', 'SE', 'Sweden', 'EURO', '553', '90496', '0', '5868');
INSERT INTO public.who_global_data_import VALUES (82668, '2020-09-26', 'SE', 'Sweden', 'EURO', '540', '91036', '1', '5869');
INSERT INTO public.who_global_data_import VALUES (82669, '2020-09-27', 'SE', 'Sweden', 'EURO', '630', '91666', '4', '5873');
INSERT INTO public.who_global_data_import VALUES (82670, '2020-09-28', 'SE', 'Sweden', 'EURO', '325', '91991', '2', '5875');
INSERT INTO public.who_global_data_import VALUES (82671, '2020-09-29', 'SE', 'Sweden', 'EURO', '167', '92158', '1', '5876');
INSERT INTO public.who_global_data_import VALUES (82672, '2020-09-30', 'SE', 'Sweden', 'EURO', '378', '92536', '1', '5877');
INSERT INTO public.who_global_data_import VALUES (82673, '2020-10-01', 'SE', 'Sweden', 'EURO', '613', '93149', '2', '5879');
INSERT INTO public.who_global_data_import VALUES (82674, '2020-10-02', 'SE', 'Sweden', 'EURO', '689', '93838', '4', '5883');
INSERT INTO public.who_global_data_import VALUES (82675, '2020-10-03', 'SE', 'Sweden', 'EURO', '633', '94471', '1', '5884');
INSERT INTO public.who_global_data_import VALUES (82676, '2020-10-04', 'SE', 'Sweden', 'EURO', '712', '95183', '3', '5887');
INSERT INTO public.who_global_data_import VALUES (82677, '2020-10-05', 'SE', 'Sweden', 'EURO', '461', '95644', '3', '5890');
INSERT INTO public.who_global_data_import VALUES (82678, '2020-10-06', 'SE', 'Sweden', 'EURO', '156', '95800', '3', '5893');
INSERT INTO public.who_global_data_import VALUES (82679, '2020-10-07', 'SE', 'Sweden', 'EURO', '374', '96174', '2', '5895');
INSERT INTO public.who_global_data_import VALUES (82680, '2020-10-08', 'SE', 'Sweden', 'EURO', '786', '96960', '4', '5899');
INSERT INTO public.who_global_data_import VALUES (82681, '2020-10-09', 'SE', 'Sweden', 'EURO', '831', '97791', '3', '5902');
INSERT INTO public.who_global_data_import VALUES (82682, '2020-10-10', 'SE', 'Sweden', 'EURO', '834', '98625', '1', '5903');
INSERT INTO public.who_global_data_import VALUES (82683, '2020-10-11', 'SE', 'Sweden', 'EURO', '783', '99408', '5', '5908');
INSERT INTO public.who_global_data_import VALUES (82684, '2020-10-12', 'SE', 'Sweden', 'EURO', '509', '99917', '5', '5913');
INSERT INTO public.who_global_data_import VALUES (82685, '2020-10-13', 'SE', 'Sweden', 'EURO', '161', '100078', '2', '5915');
INSERT INTO public.who_global_data_import VALUES (82686, '2020-10-14', 'SE', 'Sweden', 'EURO', '637', '100715', '3', '5918');
INSERT INTO public.who_global_data_import VALUES (82687, '2020-10-15', 'SE', 'Sweden', 'EURO', '916', '101631', '1', '5919');
INSERT INTO public.who_global_data_import VALUES (82688, '2020-10-16', 'SE', 'Sweden', 'EURO', '968', '102599', '2', '5921');
INSERT INTO public.who_global_data_import VALUES (82689, '2020-10-17', 'SE', 'Sweden', 'EURO', '902', '103501', '3', '5924');
INSERT INTO public.who_global_data_import VALUES (82690, '2020-10-18', 'SE', 'Sweden', 'EURO', '1179', '104680', '2', '5926');
INSERT INTO public.who_global_data_import VALUES (82691, '2020-10-19', 'SE', 'Sweden', 'EURO', '697', '105377', '4', '5930');
INSERT INTO public.who_global_data_import VALUES (82692, '2020-10-20', 'SE', 'Sweden', 'EURO', '321', '105698', '1', '5931');
INSERT INTO public.who_global_data_import VALUES (82693, '2020-10-21', 'SE', 'Sweden', 'EURO', '771', '106469', '4', '5935');
INSERT INTO public.who_global_data_import VALUES (82694, '2020-10-22', 'SE', 'Sweden', 'EURO', '1289', '107758', '4', '5939');
INSERT INTO public.who_global_data_import VALUES (82695, '2020-10-23', 'SE', 'Sweden', 'EURO', '1571', '109329', '3', '5942');
INSERT INTO public.who_global_data_import VALUES (82696, '2020-10-24', 'SE', 'Sweden', 'EURO', '1666', '110995', '9', '5951');
INSERT INTO public.who_global_data_import VALUES (82697, '2020-10-25', 'SE', 'Sweden', 'EURO', '1868', '112863', '7', '5958');
INSERT INTO public.who_global_data_import VALUES (82698, '2020-10-26', 'SE', 'Sweden', 'EURO', '1477', '114340', '8', '5966');
INSERT INTO public.who_global_data_import VALUES (82699, '2020-10-27', 'SE', 'Sweden', 'EURO', '514', '114854', '8', '5974');
INSERT INTO public.who_global_data_import VALUES (82700, '2020-10-28', 'SE', 'Sweden', 'EURO', '1069', '115923', '11', '5985');
INSERT INTO public.who_global_data_import VALUES (82701, '2020-10-29', 'SE', 'Sweden', 'EURO', '2414', '118337', '9', '5994');
INSERT INTO public.who_global_data_import VALUES (82702, '2020-10-30', 'SE', 'Sweden', 'EURO', '3390', '121727', '9', '6003');
INSERT INTO public.who_global_data_import VALUES (82703, '2020-10-31', 'SE', 'Sweden', 'EURO', '3262', '124989', '9', '6012');
INSERT INTO public.who_global_data_import VALUES (82704, '2020-11-01', 'SE', 'Sweden', 'EURO', '4056', '129045', '9', '6021');
INSERT INTO public.who_global_data_import VALUES (82705, '2020-11-02', 'SE', 'Sweden', 'EURO', '2987', '132032', '13', '6034');
INSERT INTO public.who_global_data_import VALUES (82706, '2020-11-03', 'SE', 'Sweden', 'EURO', '1297', '133329', '22', '6056');
INSERT INTO public.who_global_data_import VALUES (82707, '2020-11-04', 'SE', 'Sweden', 'EURO', '1569', '134898', '20', '6076');
INSERT INTO public.who_global_data_import VALUES (82708, '2020-11-05', 'SE', 'Sweden', 'EURO', '3608', '138506', '20', '6096');
INSERT INTO public.who_global_data_import VALUES (82709, '2020-11-06', 'SE', 'Sweden', 'EURO', '4482', '142988', '21', '6117');
INSERT INTO public.who_global_data_import VALUES (82710, '2020-11-07', 'SE', 'Sweden', 'EURO', '4744', '147732', '22', '6139');
INSERT INTO public.who_global_data_import VALUES (82711, '2020-11-08', 'SE', 'Sweden', 'EURO', '4454', '152186', '25', '6164');
INSERT INTO public.who_global_data_import VALUES (82712, '2020-11-09', 'SE', 'Sweden', 'EURO', '4451', '156637', '27', '6191');
INSERT INTO public.who_global_data_import VALUES (82713, '2020-11-10', 'SE', 'Sweden', 'EURO', '2097', '158734', '22', '6213');
INSERT INTO public.who_global_data_import VALUES (82714, '2020-11-11', 'SE', 'Sweden', 'EURO', '3725', '162459', '35', '6248');
INSERT INTO public.who_global_data_import VALUES (82715, '2020-11-12', 'SE', 'Sweden', 'EURO', '4497', '166956', '35', '6283');
INSERT INTO public.who_global_data_import VALUES (82716, '2020-11-13', 'SE', 'Sweden', 'EURO', '5709', '172665', '27', '6310');
INSERT INTO public.who_global_data_import VALUES (82717, '2020-11-14', 'SE', 'Sweden', 'EURO', '5564', '178229', '28', '6338');
INSERT INTO public.who_global_data_import VALUES (82718, '2020-11-15', 'SE', 'Sweden', 'EURO', '6730', '184959', '33', '6371');
INSERT INTO public.who_global_data_import VALUES (82719, '2020-11-16', 'SE', 'Sweden', 'EURO', '3513', '188472', '38', '6409');
INSERT INTO public.who_global_data_import VALUES (82720, '2020-11-17', 'SE', 'Sweden', 'EURO', '1581', '190053', '39', '6448');
INSERT INTO public.who_global_data_import VALUES (82721, '2020-11-18', 'SE', 'Sweden', 'EURO', '2544', '192597', '37', '6485');
INSERT INTO public.who_global_data_import VALUES (82722, '2020-11-19', 'SE', 'Sweden', 'EURO', '4458', '197055', '44', '6529');
INSERT INTO public.who_global_data_import VALUES (82723, '2020-11-20', 'SE', 'Sweden', 'EURO', '4961', '202016', '50', '6579');
INSERT INTO public.who_global_data_import VALUES (82724, '2020-11-21', 'SE', 'Sweden', 'EURO', '7609', '209625', '46', '6625');
INSERT INTO public.who_global_data_import VALUES (82725, '2020-11-22', 'SE', 'Sweden', 'EURO', '5459', '215084', '45', '6670');
INSERT INTO public.who_global_data_import VALUES (82726, '2020-11-23', 'SE', 'Sweden', 'EURO', '4492', '219576', '51', '6721');
INSERT INTO public.who_global_data_import VALUES (82727, '2020-11-24', 'SE', 'Sweden', 'EURO', '2422', '221998', '59', '6780');
INSERT INTO public.who_global_data_import VALUES (82728, '2020-11-25', 'SE', 'Sweden', 'EURO', '3876', '225874', '55', '6835');
INSERT INTO public.who_global_data_import VALUES (82729, '2020-11-26', 'SE', 'Sweden', 'EURO', '5674', '231548', '68', '6903');
INSERT INTO public.who_global_data_import VALUES (82730, '2020-11-27', 'SE', 'Sweden', 'EURO', '6066', '237614', '69', '6972');
INSERT INTO public.who_global_data_import VALUES (82731, '2020-11-28', 'SE', 'Sweden', 'EURO', '6903', '244517', '60', '7032');
INSERT INTO public.who_global_data_import VALUES (82732, '2020-11-29', 'SE', 'Sweden', 'EURO', '6462', '250979', '65', '7097');
INSERT INTO public.who_global_data_import VALUES (82733, '2020-11-30', 'SE', 'Sweden', 'EURO', '3825', '254804', '50', '7147');
INSERT INTO public.who_global_data_import VALUES (82734, '2020-12-01', 'SE', 'Sweden', 'EURO', '2753', '257557', '50', '7197');
INSERT INTO public.who_global_data_import VALUES (82735, '2020-12-02', 'SE', 'Sweden', 'EURO', '3482', '261039', '66', '7263');
INSERT INTO public.who_global_data_import VALUES (82736, '2020-12-03', 'SE', 'Sweden', 'EURO', '5820', '266859', '68', '7331');
INSERT INTO public.who_global_data_import VALUES (82737, '2020-12-04', 'SE', 'Sweden', 'EURO', '6547', '273406', '71', '7402');
INSERT INTO public.who_global_data_import VALUES (82738, '2020-12-05', 'SE', 'Sweden', 'EURO', '6986', '280392', '77', '7479');
INSERT INTO public.who_global_data_import VALUES (82739, '2020-12-06', 'SE', 'Sweden', 'EURO', '7338', '287730', '70', '7549');
INSERT INTO public.who_global_data_import VALUES (82740, '2020-12-07', 'SE', 'Sweden', 'EURO', '4864', '292594', '43', '7592');
INSERT INTO public.who_global_data_import VALUES (82741, '2020-12-08', 'SE', 'Sweden', 'EURO', '1803', '294397', '81', '7673');
INSERT INTO public.who_global_data_import VALUES (82742, '2020-12-09', 'SE', 'Sweden', 'EURO', '3782', '298179', '58', '7731');
INSERT INTO public.who_global_data_import VALUES (82743, '2020-12-10', 'SE', 'Sweden', 'EURO', '7446', '305625', '54', '7785');
INSERT INTO public.who_global_data_import VALUES (82744, '2020-12-11', 'SE', 'Sweden', 'EURO', '8398', '314023', '75', '7860');
INSERT INTO public.who_global_data_import VALUES (82745, '2020-12-12', 'SE', 'Sweden', 'EURO', '6693', '320716', '86', '7946');
INSERT INTO public.who_global_data_import VALUES (82746, '2020-12-13', 'SE', 'Sweden', 'EURO', '7718', '328434', '88', '8034');
INSERT INTO public.who_global_data_import VALUES (82747, '2020-12-14', 'SE', 'Sweden', 'EURO', '6538', '334972', '67', '8101');
INSERT INTO public.who_global_data_import VALUES (82748, '2020-12-15', 'SE', 'Sweden', 'EURO', '3057', '338029', '71', '8172');
INSERT INTO public.who_global_data_import VALUES (82749, '2020-12-16', 'SE', 'Sweden', 'EURO', '3534', '341563', '94', '8266');
INSERT INTO public.who_global_data_import VALUES (82750, '2020-12-17', 'SE', 'Sweden', 'EURO', '7001', '348564', '88', '8354');
INSERT INTO public.who_global_data_import VALUES (82751, '2020-12-18', 'SE', 'Sweden', 'EURO', '8825', '357389', '102', '8456');
INSERT INTO public.who_global_data_import VALUES (82752, '2020-12-19', 'SE', 'Sweden', 'EURO', '9640', '367029', '117', '8573');
INSERT INTO public.who_global_data_import VALUES (82753, '2020-12-20', 'SE', 'Sweden', 'EURO', '7918', '374947', '71', '8644');
INSERT INTO public.who_global_data_import VALUES (82754, '2020-12-21', 'SE', 'Sweden', 'EURO', '5510', '380457', '80', '8724');
INSERT INTO public.who_global_data_import VALUES (82755, '2020-12-22', 'SE', 'Sweden', 'EURO', '3752', '384209', '92', '8816');
INSERT INTO public.who_global_data_import VALUES (82756, '2020-12-23', 'SE', 'Sweden', 'EURO', '5160', '389369', '77', '8893');
INSERT INTO public.who_global_data_import VALUES (82757, '2020-12-24', 'SE', 'Sweden', 'EURO', '6597', '395966', '92', '8985');
INSERT INTO public.who_global_data_import VALUES (82758, '2020-12-25', 'SE', 'Sweden', 'EURO', '11376', '407342', '87', '9072');
INSERT INTO public.who_global_data_import VALUES (82759, '2020-12-26', 'SE', 'Sweden', 'EURO', '5036', '412378', '87', '9159');
INSERT INTO public.who_global_data_import VALUES (82760, '2020-12-27', 'SE', 'Sweden', 'EURO', '2793', '415171', '106', '9265');
INSERT INTO public.who_global_data_import VALUES (82761, '2020-12-28', 'SE', 'Sweden', 'EURO', '2966', '418137', '94', '9359');
INSERT INTO public.who_global_data_import VALUES (82762, '2020-12-29', 'SE', 'Sweden', 'EURO', '3209', '421346', '98', '9457');
INSERT INTO public.who_global_data_import VALUES (82763, '2020-12-30', 'SE', 'Sweden', 'EURO', '7095', '428441', '121', '9578');
INSERT INTO public.who_global_data_import VALUES (82764, '2020-12-31', 'SE', 'Sweden', 'EURO', '8874', '437315', '72', '9650');
INSERT INTO public.who_global_data_import VALUES (82765, '2021-01-01', 'SE', 'Sweden', 'EURO', '10459', '447774', '90', '9740');
INSERT INTO public.who_global_data_import VALUES (82766, '2021-01-02', 'SE', 'Sweden', 'EURO', '7002', '454776', '110', '9850');
INSERT INTO public.who_global_data_import VALUES (82767, '2021-01-03', 'SE', 'Sweden', 'EURO', '2618', '457394', '86', '9936');
INSERT INTO public.who_global_data_import VALUES (82768, '2021-01-04', 'SE', 'Sweden', 'EURO', '2532', '459926', '98', '10034');
INSERT INTO public.who_global_data_import VALUES (82769, '2021-01-05', 'SE', 'Sweden', 'EURO', '2756', '462682', '83', '10117');
INSERT INTO public.who_global_data_import VALUES (82770, '2021-01-06', 'SE', 'Sweden', 'EURO', '6984', '469666', '86', '10203');
INSERT INTO public.who_global_data_import VALUES (82771, '2021-01-07', 'SE', 'Sweden', 'EURO', '7546', '477212', '93', '10296');
INSERT INTO public.who_global_data_import VALUES (82772, '2021-01-08', 'SE', 'Sweden', 'EURO', '5031', '482243', '82', '10378');
INSERT INTO public.who_global_data_import VALUES (82773, '2021-01-09', 'SE', 'Sweden', 'EURO', '7152', '489395', '102', '10480');
INSERT INTO public.who_global_data_import VALUES (82774, '2021-01-10', 'SE', 'Sweden', 'EURO', '5699', '495094', '99', '10579');
INSERT INTO public.who_global_data_import VALUES (82775, '2021-01-11', 'SE', 'Sweden', 'EURO', '4737', '499831', '87', '10666');
INSERT INTO public.who_global_data_import VALUES (82776, '2021-01-12', 'SE', 'Sweden', 'EURO', '2318', '502149', '90', '10756');
INSERT INTO public.who_global_data_import VALUES (82777, '2021-01-13', 'SE', 'Sweden', 'EURO', '4648', '506797', '88', '10844');
INSERT INTO public.who_global_data_import VALUES (82778, '2021-01-14', 'SE', 'Sweden', 'EURO', '5342', '512139', '88', '10932');
INSERT INTO public.who_global_data_import VALUES (82779, '2021-01-15', 'SE', 'Sweden', 'EURO', '6597', '518736', '89', '11021');
INSERT INTO public.who_global_data_import VALUES (82780, '2021-01-16', 'SE', 'Sweden', 'EURO', '4749', '523485', '95', '11116');
INSERT INTO public.who_global_data_import VALUES (82781, '2021-01-17', 'SE', 'Sweden', 'EURO', '4209', '527694', '85', '11201');
INSERT INTO public.who_global_data_import VALUES (82782, '2021-01-18', 'SE', 'Sweden', 'EURO', '2162', '529856', '81', '11282');
INSERT INTO public.who_global_data_import VALUES (82783, '2021-01-19', 'SE', 'Sweden', 'EURO', '1250', '531106', '58', '11340');
INSERT INTO public.who_global_data_import VALUES (82784, '2021-01-20', 'SE', 'Sweden', 'EURO', '2118', '533224', '72', '11412');
INSERT INTO public.who_global_data_import VALUES (82785, '2021-01-21', 'SE', 'Sweden', 'EURO', '4739', '537963', '86', '11498');
INSERT INTO public.who_global_data_import VALUES (82786, '2021-01-22', 'SE', 'Sweden', 'EURO', '4950', '542913', '85', '11583');
INSERT INTO public.who_global_data_import VALUES (82787, '2021-01-23', 'SE', 'Sweden', 'EURO', '4204', '547117', '86', '11669');
INSERT INTO public.who_global_data_import VALUES (82788, '2021-01-24', 'SE', 'Sweden', 'EURO', '3724', '550841', '57', '11726');
INSERT INTO public.who_global_data_import VALUES (82789, '2021-01-25', 'SE', 'Sweden', 'EURO', '2369', '553210', '57', '11783');
INSERT INTO public.who_global_data_import VALUES (82790, '2021-01-26', 'SE', 'Sweden', 'EURO', '1148', '554358', '49', '11832');
INSERT INTO public.who_global_data_import VALUES (82791, '2021-01-27', 'SE', 'Sweden', 'EURO', '1889', '556247', '42', '11874');
INSERT INTO public.who_global_data_import VALUES (82792, '2021-01-28', 'SE', 'Sweden', 'EURO', '4190', '560437', '37', '11911');
INSERT INTO public.who_global_data_import VALUES (82793, '2021-01-29', 'SE', 'Sweden', 'EURO', '4109', '564546', '22', '11933');
INSERT INTO public.who_global_data_import VALUES (82794, '2021-01-30', 'SE', 'Sweden', 'EURO', '2376', '566922', '22', '11955');
INSERT INTO public.who_global_data_import VALUES (82795, '2021-01-31', 'SE', 'Sweden', 'EURO', '4262', '571184', '28', '11983');
INSERT INTO public.who_global_data_import VALUES (82796, '2021-02-01', 'SE', 'Sweden', 'EURO', '2695', '573879', '15', '11998');
INSERT INTO public.who_global_data_import VALUES (82797, '2021-02-02', 'SE', 'Sweden', 'EURO', '1165', '575044', '11', '12009');
INSERT INTO public.who_global_data_import VALUES (82798, '2021-02-03', 'SE', 'Sweden', 'EURO', '1560', '576604', '14', '12023');
INSERT INTO public.who_global_data_import VALUES (82799, '2021-02-04', 'SE', 'Sweden', 'EURO', '4325', '580929', '3', '12026');
INSERT INTO public.who_global_data_import VALUES (82800, '2021-02-05', 'SE', 'Sweden', 'EURO', '3745', '584674', '2', '12028');
INSERT INTO public.who_global_data_import VALUES (82801, '2020-01-03', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82802, '2020-01-04', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82803, '2020-01-05', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82804, '2020-01-06', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82805, '2020-01-07', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82806, '2020-01-08', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82807, '2020-01-09', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82808, '2020-01-10', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82809, '2020-01-11', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82810, '2020-01-12', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82811, '2020-01-13', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82812, '2020-01-14', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82813, '2020-01-15', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82814, '2020-01-16', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82815, '2020-01-17', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82816, '2020-01-18', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82817, '2020-01-19', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82818, '2020-01-20', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82819, '2020-01-21', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82820, '2020-01-22', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82821, '2020-01-23', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82822, '2020-01-24', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82823, '2020-01-25', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82824, '2020-01-26', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82825, '2020-01-27', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82826, '2020-01-28', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82827, '2020-01-29', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82828, '2020-01-30', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82829, '2020-01-31', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82830, '2020-02-01', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82831, '2020-02-02', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82832, '2020-02-03', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82833, '2020-02-04', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82834, '2020-02-05', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82835, '2020-02-06', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82836, '2020-02-07', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82837, '2020-02-08', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82838, '2020-02-09', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82839, '2020-02-10', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82840, '2020-02-11', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82841, '2020-02-12', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82842, '2020-02-13', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82843, '2020-02-14', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82844, '2020-02-15', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82845, '2020-02-16', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82846, '2020-02-17', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82847, '2020-02-18', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82848, '2020-02-19', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82849, '2020-02-20', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82850, '2020-02-21', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82851, '2020-02-22', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82852, '2020-02-23', 'CH', 'Switzerland', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82853, '2020-02-24', 'CH', 'Switzerland', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82854, '2020-02-25', 'CH', 'Switzerland', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82855, '2020-02-26', 'CH', 'Switzerland', 'EURO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82856, '2020-02-27', 'CH', 'Switzerland', 'EURO', '10', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82857, '2020-02-28', 'CH', 'Switzerland', 'EURO', '10', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82858, '2020-02-29', 'CH', 'Switzerland', 'EURO', '10', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82859, '2020-03-01', 'CH', 'Switzerland', 'EURO', '13', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82860, '2020-03-02', 'CH', 'Switzerland', 'EURO', '11', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82861, '2020-03-03', 'CH', 'Switzerland', 'EURO', '30', '86', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82862, '2020-03-04', 'CH', 'Switzerland', 'EURO', '33', '119', '0', '0');
INSERT INTO public.who_global_data_import VALUES (82863, '2020-03-05', 'CH', 'Switzerland', 'EURO', '61', '180', '2', '2');
INSERT INTO public.who_global_data_import VALUES (82864, '2020-03-06', 'CH', 'Switzerland', 'EURO', '62', '242', '0', '2');
INSERT INTO public.who_global_data_import VALUES (82865, '2020-03-07', 'CH', 'Switzerland', 'EURO', '73', '315', '0', '2');
INSERT INTO public.who_global_data_import VALUES (82866, '2020-03-08', 'CH', 'Switzerland', 'EURO', '49', '364', '0', '2');
INSERT INTO public.who_global_data_import VALUES (82867, '2020-03-09', 'CH', 'Switzerland', 'EURO', '68', '432', '1', '3');
INSERT INTO public.who_global_data_import VALUES (82868, '2020-03-10', 'CH', 'Switzerland', 'EURO', '192', '624', '0', '3');
INSERT INTO public.who_global_data_import VALUES (82869, '2020-03-11', 'CH', 'Switzerland', 'EURO', '210', '834', '2', '5');
INSERT INTO public.who_global_data_import VALUES (82870, '2020-03-12', 'CH', 'Switzerland', 'EURO', '333', '1167', '3', '8');
INSERT INTO public.who_global_data_import VALUES (82871, '2020-03-13', 'CH', 'Switzerland', 'EURO', '356', '1523', '4', '12');
INSERT INTO public.who_global_data_import VALUES (82872, '2020-03-14', 'CH', 'Switzerland', 'EURO', '431', '1954', '3', '15');
INSERT INTO public.who_global_data_import VALUES (82873, '2020-03-15', 'CH', 'Switzerland', 'EURO', '416', '2370', '5', '20');
INSERT INTO public.who_global_data_import VALUES (82874, '2020-03-16', 'CH', 'Switzerland', 'EURO', '325', '2695', '8', '28');
INSERT INTO public.who_global_data_import VALUES (82875, '2020-03-17', 'CH', 'Switzerland', 'EURO', '1060', '3755', '7', '35');
INSERT INTO public.who_global_data_import VALUES (82876, '2020-03-18', 'CH', 'Switzerland', 'EURO', '1082', '4837', '12', '47');
INSERT INTO public.who_global_data_import VALUES (82877, '2020-03-19', 'CH', 'Switzerland', 'EURO', '1205', '6042', '8', '55');
INSERT INTO public.who_global_data_import VALUES (82878, '2020-03-20', 'CH', 'Switzerland', 'EURO', '835', '6877', '14', '69');
INSERT INTO public.who_global_data_import VALUES (82879, '2020-03-21', 'CH', 'Switzerland', 'EURO', '1139', '8016', '21', '90');
INSERT INTO public.who_global_data_import VALUES (82880, '2020-03-22', 'CH', 'Switzerland', 'EURO', '691', '8707', '19', '109');
INSERT INTO public.who_global_data_import VALUES (82881, '2020-03-23', 'CH', 'Switzerland', 'EURO', '546', '9253', '18', '127');
INSERT INTO public.who_global_data_import VALUES (82882, '2020-03-24', 'CH', 'Switzerland', 'EURO', '1461', '10714', '23', '150');
INSERT INTO public.who_global_data_import VALUES (82883, '2020-03-25', 'CH', 'Switzerland', 'EURO', '1241', '11955', '19', '169');
INSERT INTO public.who_global_data_import VALUES (82884, '2020-03-26', 'CH', 'Switzerland', 'EURO', '1069', '13024', '39', '208');
INSERT INTO public.who_global_data_import VALUES (82885, '2020-03-27', 'CH', 'Switzerland', 'EURO', '1114', '14138', '38', '246');
INSERT INTO public.who_global_data_import VALUES (82886, '2020-03-28', 'CH', 'Switzerland', 'EURO', '1307', '15445', '32', '278');
INSERT INTO public.who_global_data_import VALUES (82887, '2020-03-29', 'CH', 'Switzerland', 'EURO', '722', '16167', '57', '335');
INSERT INTO public.who_global_data_import VALUES (82888, '2020-03-30', 'CH', 'Switzerland', 'EURO', '432', '16599', '46', '381');
INSERT INTO public.who_global_data_import VALUES (82889, '2020-03-31', 'CH', 'Switzerland', 'EURO', '1307', '17906', '58', '439');
INSERT INTO public.who_global_data_import VALUES (82890, '2020-04-01', 'CH', 'Switzerland', 'EURO', '1134', '19040', '44', '483');
INSERT INTO public.who_global_data_import VALUES (82891, '2020-04-02', 'CH', 'Switzerland', 'EURO', '1013', '20053', '57', '540');
INSERT INTO public.who_global_data_import VALUES (82892, '2020-04-03', 'CH', 'Switzerland', 'EURO', '877', '20930', '60', '600');
INSERT INTO public.who_global_data_import VALUES (82893, '2020-04-04', 'CH', 'Switzerland', 'EURO', '927', '21857', '57', '657');
INSERT INTO public.who_global_data_import VALUES (82894, '2020-04-05', 'CH', 'Switzerland', 'EURO', '486', '22343', '55', '712');
INSERT INTO public.who_global_data_import VALUES (82895, '2020-04-06', 'CH', 'Switzerland', 'EURO', '281', '22624', '50', '762');
INSERT INTO public.who_global_data_import VALUES (82896, '2020-04-07', 'CH', 'Switzerland', 'EURO', '924', '23548', '50', '812');
INSERT INTO public.who_global_data_import VALUES (82897, '2020-04-08', 'CH', 'Switzerland', 'EURO', '715', '24263', '56', '868');
INSERT INTO public.who_global_data_import VALUES (82898, '2020-04-09', 'CH', 'Switzerland', 'EURO', '612', '24875', '58', '926');
INSERT INTO public.who_global_data_import VALUES (82899, '2020-04-10', 'CH', 'Switzerland', 'EURO', '559', '25434', '44', '970');
INSERT INTO public.who_global_data_import VALUES (82900, '2020-04-11', 'CH', 'Switzerland', 'EURO', '309', '25743', '52', '1022');
INSERT INTO public.who_global_data_import VALUES (82901, '2020-04-12', 'CH', 'Switzerland', 'EURO', '261', '26004', '45', '1067');
INSERT INTO public.who_global_data_import VALUES (82902, '2020-04-13', 'CH', 'Switzerland', 'EURO', '219', '26223', '36', '1103');
INSERT INTO public.who_global_data_import VALUES (82903, '2020-04-14', 'CH', 'Switzerland', 'EURO', '245', '26468', '36', '1139');
INSERT INTO public.who_global_data_import VALUES (82904, '2020-04-15', 'CH', 'Switzerland', 'EURO', '424', '26892', '37', '1176');
INSERT INTO public.who_global_data_import VALUES (82905, '2020-04-16', 'CH', 'Switzerland', 'EURO', '328', '27220', '38', '1214');
INSERT INTO public.who_global_data_import VALUES (82906, '2020-04-17', 'CH', 'Switzerland', 'EURO', '320', '27540', '38', '1252');
INSERT INTO public.who_global_data_import VALUES (82907, '2020-04-18', 'CH', 'Switzerland', 'EURO', '291', '27831', '36', '1288');
INSERT INTO public.who_global_data_import VALUES (82908, '2020-04-19', 'CH', 'Switzerland', 'EURO', '145', '27976', '34', '1322');
INSERT INTO public.who_global_data_import VALUES (82909, '2020-04-20', 'CH', 'Switzerland', 'EURO', '87', '28063', '21', '1343');
INSERT INTO public.who_global_data_import VALUES (82910, '2020-04-21', 'CH', 'Switzerland', 'EURO', '277', '28340', '38', '1381');
INSERT INTO public.who_global_data_import VALUES (82911, '2020-04-22', 'CH', 'Switzerland', 'EURO', '213', '28553', '33', '1414');
INSERT INTO public.who_global_data_import VALUES (82912, '2020-04-23', 'CH', 'Switzerland', 'EURO', '155', '28708', '27', '1441');
INSERT INTO public.who_global_data_import VALUES (82913, '2020-04-24', 'CH', 'Switzerland', 'EURO', '207', '28915', '31', '1472');
INSERT INTO public.who_global_data_import VALUES (82914, '2020-04-25', 'CH', 'Switzerland', 'EURO', '167', '29082', '27', '1499');
INSERT INTO public.who_global_data_import VALUES (82915, '2020-04-26', 'CH', 'Switzerland', 'EURO', '87', '29169', '25', '1524');
INSERT INTO public.who_global_data_import VALUES (82916, '2020-04-27', 'CH', 'Switzerland', 'EURO', '61', '29230', '13', '1537');
INSERT INTO public.who_global_data_import VALUES (82917, '2020-04-28', 'CH', 'Switzerland', 'EURO', '173', '29403', '23', '1560');
INSERT INTO public.who_global_data_import VALUES (82918, '2020-04-29', 'CH', 'Switzerland', 'EURO', '153', '29556', '12', '1572');
INSERT INTO public.who_global_data_import VALUES (82919, '2020-04-30', 'CH', 'Switzerland', 'EURO', '120', '29676', '11', '1583');
INSERT INTO public.who_global_data_import VALUES (82920, '2020-05-01', 'CH', 'Switzerland', 'EURO', '101', '29777', '13', '1596');
INSERT INTO public.who_global_data_import VALUES (82921, '2020-05-02', 'CH', 'Switzerland', 'EURO', '83', '29860', '12', '1608');
INSERT INTO public.who_global_data_import VALUES (82922, '2020-05-03', 'CH', 'Switzerland', 'EURO', '47', '29907', '9', '1617');
INSERT INTO public.who_global_data_import VALUES (82923, '2020-05-04', 'CH', 'Switzerland', 'EURO', '22', '29929', '8', '1625');
INSERT INTO public.who_global_data_import VALUES (82924, '2020-05-05', 'CH', 'Switzerland', 'EURO', '90', '30019', '9', '1634');
INSERT INTO public.who_global_data_import VALUES (82925, '2020-05-06', 'CH', 'Switzerland', 'EURO', '73', '30092', '10', '1644');
INSERT INTO public.who_global_data_import VALUES (82926, '2020-05-07', 'CH', 'Switzerland', 'EURO', '79', '30171', '4', '1648');
INSERT INTO public.who_global_data_import VALUES (82927, '2020-05-08', 'CH', 'Switzerland', 'EURO', '46', '30217', '12', '1660');
INSERT INTO public.who_global_data_import VALUES (82928, '2020-05-09', 'CH', 'Switzerland', 'EURO', '59', '30276', '7', '1667');
INSERT INTO public.who_global_data_import VALUES (82929, '2020-05-10', 'CH', 'Switzerland', 'EURO', '39', '30315', '5', '1672');
INSERT INTO public.who_global_data_import VALUES (82930, '2020-05-11', 'CH', 'Switzerland', 'EURO', '16', '30331', '7', '1679');
INSERT INTO public.who_global_data_import VALUES (82931, '2020-05-12', 'CH', 'Switzerland', 'EURO', '47', '30378', '3', '1682');
INSERT INTO public.who_global_data_import VALUES (82932, '2020-05-13', 'CH', 'Switzerland', 'EURO', '42', '30420', '1', '1683');
INSERT INTO public.who_global_data_import VALUES (82933, '2020-05-14', 'CH', 'Switzerland', 'EURO', '37', '30457', '1', '1684');
INSERT INTO public.who_global_data_import VALUES (82934, '2020-05-15', 'CH', 'Switzerland', 'EURO', '37', '30494', '2', '1686');
INSERT INTO public.who_global_data_import VALUES (82935, '2020-05-16', 'CH', 'Switzerland', 'EURO', '41', '30535', '5', '1691');
INSERT INTO public.who_global_data_import VALUES (82936, '2020-05-17', 'CH', 'Switzerland', 'EURO', '15', '30550', '1', '1692');
INSERT INTO public.who_global_data_import VALUES (82937, '2020-05-18', 'CH', 'Switzerland', 'EURO', '12', '30562', '4', '1696');
INSERT INTO public.who_global_data_import VALUES (82938, '2020-05-19', 'CH', 'Switzerland', 'EURO', '34', '30596', '3', '1699');
INSERT INTO public.who_global_data_import VALUES (82939, '2020-05-20', 'CH', 'Switzerland', 'EURO', '36', '30632', '4', '1703');
INSERT INTO public.who_global_data_import VALUES (82940, '2020-05-21', 'CH', 'Switzerland', 'EURO', '29', '30661', '0', '1703');
INSERT INTO public.who_global_data_import VALUES (82941, '2020-05-22', 'CH', 'Switzerland', 'EURO', '11', '30672', '5', '1708');
INSERT INTO public.who_global_data_import VALUES (82942, '2020-05-23', 'CH', 'Switzerland', 'EURO', '20', '30692', '1', '1709');
INSERT INTO public.who_global_data_import VALUES (82943, '2020-05-24', 'CH', 'Switzerland', 'EURO', '14', '30706', '1', '1710');
INSERT INTO public.who_global_data_import VALUES (82944, '2020-05-25', 'CH', 'Switzerland', 'EURO', '10', '30716', '0', '1710');
INSERT INTO public.who_global_data_import VALUES (82945, '2020-05-26', 'CH', 'Switzerland', 'EURO', '15', '30731', '2', '1712');
INSERT INTO public.who_global_data_import VALUES (82946, '2020-05-27', 'CH', 'Switzerland', 'EURO', '18', '30749', '2', '1714');
INSERT INTO public.who_global_data_import VALUES (82947, '2020-05-28', 'CH', 'Switzerland', 'EURO', '25', '30774', '0', '1714');
INSERT INTO public.who_global_data_import VALUES (82948, '2020-05-29', 'CH', 'Switzerland', 'EURO', '30', '30804', '0', '1714');
INSERT INTO public.who_global_data_import VALUES (82949, '2020-05-30', 'CH', 'Switzerland', 'EURO', '21', '30825', '0', '1714');
INSERT INTO public.who_global_data_import VALUES (82950, '2020-05-31', 'CH', 'Switzerland', 'EURO', '10', '30835', '0', '1714');
INSERT INTO public.who_global_data_import VALUES (82951, '2020-06-01', 'CH', 'Switzerland', 'EURO', '7', '30842', '0', '1714');
INSERT INTO public.who_global_data_import VALUES (82952, '2020-06-02', 'CH', 'Switzerland', 'EURO', '3', '30845', '0', '1714');
INSERT INTO public.who_global_data_import VALUES (82953, '2020-06-03', 'CH', 'Switzerland', 'EURO', '23', '30868', '0', '1714');
INSERT INTO public.who_global_data_import VALUES (82954, '2020-06-04', 'CH', 'Switzerland', 'EURO', '23', '30891', '0', '1714');
INSERT INTO public.who_global_data_import VALUES (82955, '2020-06-05', 'CH', 'Switzerland', 'EURO', '17', '30908', '0', '1714');
INSERT INTO public.who_global_data_import VALUES (82956, '2020-06-06', 'CH', 'Switzerland', 'EURO', '15', '30923', '0', '1714');
INSERT INTO public.who_global_data_import VALUES (82957, '2020-06-07', 'CH', 'Switzerland', 'EURO', '10', '30933', '1', '1715');
INSERT INTO public.who_global_data_import VALUES (82958, '2020-06-08', 'CH', 'Switzerland', 'EURO', '8', '30941', '0', '1715');
INSERT INTO public.who_global_data_import VALUES (82959, '2020-06-09', 'CH', 'Switzerland', 'EURO', '25', '30966', '1', '1716');
INSERT INTO public.who_global_data_import VALUES (82960, '2020-06-10', 'CH', 'Switzerland', 'EURO', '11', '30977', '0', '1716');
INSERT INTO public.who_global_data_import VALUES (82961, '2020-06-11', 'CH', 'Switzerland', 'EURO', '24', '31001', '1', '1717');
INSERT INTO public.who_global_data_import VALUES (82962, '2020-06-12', 'CH', 'Switzerland', 'EURO', '25', '31026', '0', '1717');
INSERT INTO public.who_global_data_import VALUES (82963, '2020-06-13', 'CH', 'Switzerland', 'EURO', '34', '31060', '1', '1718');
INSERT INTO public.who_global_data_import VALUES (82964, '2020-06-14', 'CH', 'Switzerland', 'EURO', '9', '31069', '1', '1719');
INSERT INTO public.who_global_data_import VALUES (82965, '2020-06-15', 'CH', 'Switzerland', 'EURO', '12', '31081', '0', '1719');
INSERT INTO public.who_global_data_import VALUES (82966, '2020-06-16', 'CH', 'Switzerland', 'EURO', '32', '31113', '0', '1719');
INSERT INTO public.who_global_data_import VALUES (82967, '2020-06-17', 'CH', 'Switzerland', 'EURO', '21', '31134', '1', '1720');
INSERT INTO public.who_global_data_import VALUES (82968, '2020-06-18', 'CH', 'Switzerland', 'EURO', '18', '31152', '0', '1720');
INSERT INTO public.who_global_data_import VALUES (82969, '2020-06-19', 'CH', 'Switzerland', 'EURO', '18', '31170', '0', '1720');
INSERT INTO public.who_global_data_import VALUES (82970, '2020-06-20', 'CH', 'Switzerland', 'EURO', '37', '31207', '0', '1720');
INSERT INTO public.who_global_data_import VALUES (82971, '2020-06-21', 'CH', 'Switzerland', 'EURO', '32', '31239', '0', '1720');
INSERT INTO public.who_global_data_import VALUES (82972, '2020-06-22', 'CH', 'Switzerland', 'EURO', '13', '31252', '1', '1721');
INSERT INTO public.who_global_data_import VALUES (82973, '2020-06-23', 'CH', 'Switzerland', 'EURO', '56', '31308', '1', '1722');
INSERT INTO public.who_global_data_import VALUES (82974, '2020-06-24', 'CH', 'Switzerland', 'EURO', '37', '31345', '0', '1722');
INSERT INTO public.who_global_data_import VALUES (82975, '2020-06-25', 'CH', 'Switzerland', 'EURO', '64', '31409', '0', '1722');
INSERT INTO public.who_global_data_import VALUES (82976, '2020-06-26', 'CH', 'Switzerland', 'EURO', '48', '31457', '0', '1722');
INSERT INTO public.who_global_data_import VALUES (82977, '2020-06-27', 'CH', 'Switzerland', 'EURO', '92', '31549', '0', '1722');
INSERT INTO public.who_global_data_import VALUES (82978, '2020-06-28', 'CH', 'Switzerland', 'EURO', '36', '31585', '0', '1722');
INSERT INTO public.who_global_data_import VALUES (82979, '2020-06-29', 'CH', 'Switzerland', 'EURO', '24', '31609', '0', '1722');
INSERT INTO public.who_global_data_import VALUES (82980, '2020-06-30', 'CH', 'Switzerland', 'EURO', '160', '31769', '1', '1723');
INSERT INTO public.who_global_data_import VALUES (82981, '2020-07-01', 'CH', 'Switzerland', 'EURO', '138', '31907', '0', '1723');
INSERT INTO public.who_global_data_import VALUES (82982, '2020-07-02', 'CH', 'Switzerland', 'EURO', '101', '32008', '1', '1724');
INSERT INTO public.who_global_data_import VALUES (82983, '2020-07-03', 'CH', 'Switzerland', 'EURO', '127', '32135', '0', '1724');
INSERT INTO public.who_global_data_import VALUES (82984, '2020-07-04', 'CH', 'Switzerland', 'EURO', '96', '32231', '0', '1724');
INSERT INTO public.who_global_data_import VALUES (82985, '2020-07-05', 'CH', 'Switzerland', 'EURO', '26', '32257', '0', '1724');
INSERT INTO public.who_global_data_import VALUES (82986, '2020-07-06', 'CH', 'Switzerland', 'EURO', '36', '32293', '0', '1724');
INSERT INTO public.who_global_data_import VALUES (82987, '2020-07-07', 'CH', 'Switzerland', 'EURO', '106', '32399', '0', '1724');
INSERT INTO public.who_global_data_import VALUES (82988, '2020-07-08', 'CH', 'Switzerland', 'EURO', '107', '32506', '0', '1724');
INSERT INTO public.who_global_data_import VALUES (82989, '2020-07-09', 'CH', 'Switzerland', 'EURO', '97', '32603', '2', '1726');
INSERT INTO public.who_global_data_import VALUES (82990, '2020-07-10', 'CH', 'Switzerland', 'EURO', '97', '32700', '0', '1726');
INSERT INTO public.who_global_data_import VALUES (82991, '2020-07-11', 'CH', 'Switzerland', 'EURO', '111', '32811', '0', '1726');
INSERT INTO public.who_global_data_import VALUES (82992, '2020-07-12', 'CH', 'Switzerland', 'EURO', '71', '32882', '0', '1726');
INSERT INTO public.who_global_data_import VALUES (82993, '2020-07-13', 'CH', 'Switzerland', 'EURO', '46', '32928', '0', '1726');
INSERT INTO public.who_global_data_import VALUES (82994, '2020-07-14', 'CH', 'Switzerland', 'EURO', '120', '33048', '1', '1727');
INSERT INTO public.who_global_data_import VALUES (82995, '2020-07-15', 'CH', 'Switzerland', 'EURO', '129', '33177', '0', '1727');
INSERT INTO public.who_global_data_import VALUES (82996, '2020-07-16', 'CH', 'Switzerland', 'EURO', '123', '33300', '1', '1728');
INSERT INTO public.who_global_data_import VALUES (82997, '2020-07-17', 'CH', 'Switzerland', 'EURO', '106', '33406', '1', '1729');
INSERT INTO public.who_global_data_import VALUES (82998, '2020-07-18', 'CH', 'Switzerland', 'EURO', '115', '33521', '1', '1730');
INSERT INTO public.who_global_data_import VALUES (82999, '2020-07-19', 'CH', 'Switzerland', 'EURO', '80', '33601', '0', '1730');
INSERT INTO public.who_global_data_import VALUES (83000, '2020-07-20', 'CH', 'Switzerland', 'EURO', '42', '33643', '0', '1730');
INSERT INTO public.who_global_data_import VALUES (83001, '2020-07-21', 'CH', 'Switzerland', 'EURO', '127', '33770', '2', '1732');
INSERT INTO public.who_global_data_import VALUES (83002, '2020-07-22', 'CH', 'Switzerland', 'EURO', '138', '33908', '1', '1733');
INSERT INTO public.who_global_data_import VALUES (83003, '2020-07-23', 'CH', 'Switzerland', 'EURO', '118', '34026', '0', '1733');
INSERT INTO public.who_global_data_import VALUES (83004, '2020-07-24', 'CH', 'Switzerland', 'EURO', '143', '34169', '0', '1733');
INSERT INTO public.who_global_data_import VALUES (83005, '2020-07-25', 'CH', 'Switzerland', 'EURO', '148', '34317', '1', '1734');
INSERT INTO public.who_global_data_import VALUES (83006, '2020-07-26', 'CH', 'Switzerland', 'EURO', '95', '34412', '1', '1735');
INSERT INTO public.who_global_data_import VALUES (83007, '2020-07-27', 'CH', 'Switzerland', 'EURO', '57', '34469', '0', '1735');
INSERT INTO public.who_global_data_import VALUES (83008, '2020-07-28', 'CH', 'Switzerland', 'EURO', '193', '34662', '1', '1736');
INSERT INTO public.who_global_data_import VALUES (83009, '2020-07-29', 'CH', 'Switzerland', 'EURO', '189', '34851', '1', '1737');
INSERT INTO public.who_global_data_import VALUES (83010, '2020-07-30', 'CH', 'Switzerland', 'EURO', '220', '35071', '0', '1737');
INSERT INTO public.who_global_data_import VALUES (83011, '2020-07-31', 'CH', 'Switzerland', 'EURO', '212', '35283', '0', '1737');
INSERT INTO public.who_global_data_import VALUES (83012, '2020-08-01', 'CH', 'Switzerland', 'EURO', '164', '35447', '2', '1739');
INSERT INTO public.who_global_data_import VALUES (83013, '2020-08-02', 'CH', 'Switzerland', 'EURO', '97', '35544', '1', '1740');
INSERT INTO public.who_global_data_import VALUES (83014, '2020-08-03', 'CH', 'Switzerland', 'EURO', '80', '35624', '0', '1740');
INSERT INTO public.who_global_data_import VALUES (83015, '2020-08-04', 'CH', 'Switzerland', 'EURO', '196', '35820', '0', '1740');
INSERT INTO public.who_global_data_import VALUES (83016, '2020-08-05', 'CH', 'Switzerland', 'EURO', '181', '36001', '1', '1741');
INSERT INTO public.who_global_data_import VALUES (83017, '2020-08-06', 'CH', 'Switzerland', 'EURO', '152', '36153', '1', '1742');
INSERT INTO public.who_global_data_import VALUES (83018, '2020-08-07', 'CH', 'Switzerland', 'EURO', '156', '36309', '1', '1743');
INSERT INTO public.who_global_data_import VALUES (83019, '2020-08-08', 'CH', 'Switzerland', 'EURO', '185', '36494', '1', '1744');
INSERT INTO public.who_global_data_import VALUES (83020, '2020-08-09', 'CH', 'Switzerland', 'EURO', '130', '36624', '1', '1745');
INSERT INTO public.who_global_data_import VALUES (83021, '2020-08-10', 'CH', 'Switzerland', 'EURO', '100', '36724', '0', '1745');
INSERT INTO public.who_global_data_import VALUES (83022, '2020-08-11', 'CH', 'Switzerland', 'EURO', '281', '37005', '1', '1746');
INSERT INTO public.who_global_data_import VALUES (83023, '2020-08-12', 'CH', 'Switzerland', 'EURO', '255', '37260', '0', '1746');
INSERT INTO public.who_global_data_import VALUES (83024, '2020-08-13', 'CH', 'Switzerland', 'EURO', '246', '37506', '0', '1746');
INSERT INTO public.who_global_data_import VALUES (83025, '2020-08-14', 'CH', 'Switzerland', 'EURO', '273', '37779', '1', '1747');
INSERT INTO public.who_global_data_import VALUES (83026, '2020-08-15', 'CH', 'Switzerland', 'EURO', '233', '38012', '0', '1747');
INSERT INTO public.who_global_data_import VALUES (83027, '2020-08-16', 'CH', 'Switzerland', 'EURO', '149', '38161', '3', '1750');
INSERT INTO public.who_global_data_import VALUES (83028, '2020-08-17', 'CH', 'Switzerland', 'EURO', '137', '38298', '0', '1750');
INSERT INTO public.who_global_data_import VALUES (83029, '2020-08-18', 'CH', 'Switzerland', 'EURO', '285', '38583', '1', '1751');
INSERT INTO public.who_global_data_import VALUES (83030, '2020-08-19', 'CH', 'Switzerland', 'EURO', '294', '38877', '0', '1751');
INSERT INTO public.who_global_data_import VALUES (83031, '2020-08-20', 'CH', 'Switzerland', 'EURO', '285', '39162', '0', '1751');
INSERT INTO public.who_global_data_import VALUES (83032, '2020-08-21', 'CH', 'Switzerland', 'EURO', '349', '39511', '0', '1751');
INSERT INTO public.who_global_data_import VALUES (83033, '2020-08-22', 'CH', 'Switzerland', 'EURO', '314', '39825', '1', '1752');
INSERT INTO public.who_global_data_import VALUES (83034, '2020-08-23', 'CH', 'Switzerland', 'EURO', '192', '40017', '1', '1753');
INSERT INTO public.who_global_data_import VALUES (83035, '2020-08-24', 'CH', 'Switzerland', 'EURO', '136', '40153', '2', '1755');
INSERT INTO public.who_global_data_import VALUES (83036, '2020-08-25', 'CH', 'Switzerland', 'EURO', '304', '40457', '1', '1756');
INSERT INTO public.who_global_data_import VALUES (83037, '2020-08-26', 'CH', 'Switzerland', 'EURO', '338', '40795', '0', '1756');
INSERT INTO public.who_global_data_import VALUES (83038, '2020-08-27', 'CH', 'Switzerland', 'EURO', '362', '41157', '0', '1756');
INSERT INTO public.who_global_data_import VALUES (83039, '2020-08-28', 'CH', 'Switzerland', 'EURO', '352', '41509', '2', '1758');
INSERT INTO public.who_global_data_import VALUES (83040, '2020-08-29', 'CH', 'Switzerland', 'EURO', '377', '41886', '0', '1758');
INSERT INTO public.who_global_data_import VALUES (83041, '2020-08-30', 'CH', 'Switzerland', 'EURO', '215', '42101', '0', '1758');
INSERT INTO public.who_global_data_import VALUES (83042, '2020-08-31', 'CH', 'Switzerland', 'EURO', '144', '42245', '1', '1759');
INSERT INTO public.who_global_data_import VALUES (83043, '2020-09-01', 'CH', 'Switzerland', 'EURO', '347', '42592', '1', '1760');
INSERT INTO public.who_global_data_import VALUES (83044, '2020-09-02', 'CH', 'Switzerland', 'EURO', '364', '42956', '1', '1761');
INSERT INTO public.who_global_data_import VALUES (83045, '2020-09-03', 'CH', 'Switzerland', 'EURO', '417', '43373', '3', '1764');
INSERT INTO public.who_global_data_import VALUES (83046, '2020-09-04', 'CH', 'Switzerland', 'EURO', '438', '43811', '1', '1765');
INSERT INTO public.who_global_data_import VALUES (83047, '2020-09-05', 'CH', 'Switzerland', 'EURO', '426', '44237', '2', '1767');
INSERT INTO public.who_global_data_import VALUES (83048, '2020-09-06', 'CH', 'Switzerland', 'EURO', '294', '44531', '2', '1769');
INSERT INTO public.who_global_data_import VALUES (83049, '2020-09-07', 'CH', 'Switzerland', 'EURO', '170', '44701', '3', '1772');
INSERT INTO public.who_global_data_import VALUES (83050, '2020-09-08', 'CH', 'Switzerland', 'EURO', '468', '45169', '1', '1773');
INSERT INTO public.who_global_data_import VALUES (83051, '2020-09-09', 'CH', 'Switzerland', 'EURO', '387', '45556', '1', '1774');
INSERT INTO public.who_global_data_import VALUES (83052, '2020-09-10', 'CH', 'Switzerland', 'EURO', '462', '46018', '7', '1781');
INSERT INTO public.who_global_data_import VALUES (83053, '2020-09-11', 'CH', 'Switzerland', 'EURO', '507', '46525', '0', '1781');
INSERT INTO public.who_global_data_import VALUES (83054, '2020-09-12', 'CH', 'Switzerland', 'EURO', '533', '47058', '4', '1785');
INSERT INTO public.who_global_data_import VALUES (83055, '2020-09-13', 'CH', 'Switzerland', 'EURO', '266', '47324', '3', '1788');
INSERT INTO public.who_global_data_import VALUES (83056, '2020-09-14', 'CH', 'Switzerland', 'EURO', '238', '47562', '1', '1789');
INSERT INTO public.who_global_data_import VALUES (83057, '2020-09-15', 'CH', 'Switzerland', 'EURO', '504', '48066', '0', '1789');
INSERT INTO public.who_global_data_import VALUES (83058, '2020-09-16', 'CH', 'Switzerland', 'EURO', '458', '48524', '3', '1792');
INSERT INTO public.who_global_data_import VALUES (83059, '2020-09-17', 'CH', 'Switzerland', 'EURO', '516', '49040', '5', '1797');
INSERT INTO public.who_global_data_import VALUES (83060, '2020-09-18', 'CH', 'Switzerland', 'EURO', '499', '49539', '4', '1801');
INSERT INTO public.who_global_data_import VALUES (83061, '2020-09-19', 'CH', 'Switzerland', 'EURO', '444', '49983', '2', '1803');
INSERT INTO public.who_global_data_import VALUES (83062, '2020-09-20', 'CH', 'Switzerland', 'EURO', '284', '50267', '1', '1804');
INSERT INTO public.who_global_data_import VALUES (83063, '2020-09-21', 'CH', 'Switzerland', 'EURO', '200', '50467', '0', '1804');
INSERT INTO public.who_global_data_import VALUES (83064, '2020-09-22', 'CH', 'Switzerland', 'EURO', '395', '50862', '3', '1807');
INSERT INTO public.who_global_data_import VALUES (83065, '2020-09-23', 'CH', 'Switzerland', 'EURO', '425', '51287', '1', '1808');
INSERT INTO public.who_global_data_import VALUES (83066, '2020-09-24', 'CH', 'Switzerland', 'EURO', '389', '51676', '1', '1809');
INSERT INTO public.who_global_data_import VALUES (83067, '2020-09-25', 'CH', 'Switzerland', 'EURO', '308', '51984', '3', '1812');
INSERT INTO public.who_global_data_import VALUES (83068, '2020-09-26', 'CH', 'Switzerland', 'EURO', '359', '52343', '1', '1813');
INSERT INTO public.who_global_data_import VALUES (83069, '2020-09-27', 'CH', 'Switzerland', 'EURO', '222', '52565', '2', '1815');
INSERT INTO public.who_global_data_import VALUES (83070, '2020-09-28', 'CH', 'Switzerland', 'EURO', '120', '52685', '1', '1816');
INSERT INTO public.who_global_data_import VALUES (83071, '2020-09-29', 'CH', 'Switzerland', 'EURO', '368', '53053', '3', '1819');
INSERT INTO public.who_global_data_import VALUES (83072, '2020-09-30', 'CH', 'Switzerland', 'EURO', '449', '53502', '1', '1820');
INSERT INTO public.who_global_data_import VALUES (83073, '2020-10-01', 'CH', 'Switzerland', 'EURO', '540', '54042', '0', '1820');
INSERT INTO public.who_global_data_import VALUES (83074, '2020-10-02', 'CH', 'Switzerland', 'EURO', '601', '54643', '5', '1825');
INSERT INTO public.who_global_data_import VALUES (83075, '2020-10-03', 'CH', 'Switzerland', 'EURO', '677', '55320', '1', '1826');
INSERT INTO public.who_global_data_import VALUES (83076, '2020-10-04', 'CH', 'Switzerland', 'EURO', '512', '55832', '0', '1826');
INSERT INTO public.who_global_data_import VALUES (83077, '2020-10-05', 'CH', 'Switzerland', 'EURO', '316', '56148', '1', '1827');
INSERT INTO public.who_global_data_import VALUES (83078, '2020-10-06', 'CH', 'Switzerland', 'EURO', '1018', '57166', '2', '1829');
INSERT INTO public.who_global_data_import VALUES (83079, '2020-10-07', 'CH', 'Switzerland', 'EURO', '1097', '58263', '1', '1830');
INSERT INTO public.who_global_data_import VALUES (83080, '2020-10-08', 'CH', 'Switzerland', 'EURO', '1377', '59640', '2', '1832');
INSERT INTO public.who_global_data_import VALUES (83081, '2020-10-09', 'CH', 'Switzerland', 'EURO', '1471', '61111', '3', '1835');
INSERT INTO public.who_global_data_import VALUES (83082, '2020-10-10', 'CH', 'Switzerland', 'EURO', '1722', '62833', '3', '1838');
INSERT INTO public.who_global_data_import VALUES (83083, '2020-10-11', 'CH', 'Switzerland', 'EURO', '1251', '64084', '3', '1841');
INSERT INTO public.who_global_data_import VALUES (83084, '2020-10-12', 'CH', 'Switzerland', 'EURO', '812', '64896', '3', '1844');
INSERT INTO public.who_global_data_import VALUES (83085, '2020-10-13', 'CH', 'Switzerland', 'EURO', '2557', '67453', '5', '1849');
INSERT INTO public.who_global_data_import VALUES (83086, '2020-10-14', 'CH', 'Switzerland', 'EURO', '2687', '70140', '6', '1855');
INSERT INTO public.who_global_data_import VALUES (83087, '2020-10-15', 'CH', 'Switzerland', 'EURO', '2997', '73137', '5', '1860');
INSERT INTO public.who_global_data_import VALUES (83088, '2020-10-16', 'CH', 'Switzerland', 'EURO', '3393', '76530', '5', '1865');
INSERT INTO public.who_global_data_import VALUES (83089, '2020-10-17', 'CH', 'Switzerland', 'EURO', '3680', '80210', '9', '1874');
INSERT INTO public.who_global_data_import VALUES (83090, '2020-10-18', 'CH', 'Switzerland', 'EURO', '2377', '82587', '7', '1881');
INSERT INTO public.who_global_data_import VALUES (83091, '2020-10-19', 'CH', 'Switzerland', 'EURO', '1788', '84375', '7', '1888');
INSERT INTO public.who_global_data_import VALUES (83092, '2020-10-20', 'CH', 'Switzerland', 'EURO', '5397', '89772', '16', '1904');
INSERT INTO public.who_global_data_import VALUES (83093, '2020-10-21', 'CH', 'Switzerland', 'EURO', '5669', '95441', '13', '1917');
INSERT INTO public.who_global_data_import VALUES (83094, '2020-10-22', 'CH', 'Switzerland', 'EURO', '6450', '101891', '18', '1935');
INSERT INTO public.who_global_data_import VALUES (83095, '2020-10-23', 'CH', 'Switzerland', 'EURO', '6766', '108657', '24', '1959');
INSERT INTO public.who_global_data_import VALUES (83096, '2020-10-24', 'CH', 'Switzerland', 'EURO', '7506', '116163', '25', '1984');
INSERT INTO public.who_global_data_import VALUES (83097, '2020-10-25', 'CH', 'Switzerland', 'EURO', '4655', '120818', '25', '2009');
INSERT INTO public.who_global_data_import VALUES (83098, '2020-10-26', 'CH', 'Switzerland', 'EURO', '3204', '124022', '21', '2030');
INSERT INTO public.who_global_data_import VALUES (83099, '2020-10-27', 'CH', 'Switzerland', 'EURO', '10111', '134133', '20', '2050');
INSERT INTO public.who_global_data_import VALUES (83100, '2020-10-28', 'CH', 'Switzerland', 'EURO', '9753', '143886', '39', '2089');
INSERT INTO public.who_global_data_import VALUES (83101, '2020-10-29', 'CH', 'Switzerland', 'EURO', '9302', '153188', '42', '2131');
INSERT INTO public.who_global_data_import VALUES (83102, '2020-10-30', 'CH', 'Switzerland', 'EURO', '8984', '162172', '57', '2188');
INSERT INTO public.who_global_data_import VALUES (83103, '2020-10-31', 'CH', 'Switzerland', 'EURO', '8943', '171115', '40', '2228');
INSERT INTO public.who_global_data_import VALUES (83104, '2020-11-01', 'CH', 'Switzerland', 'EURO', '5128', '176243', '58', '2286');
INSERT INTO public.who_global_data_import VALUES (83105, '2020-11-02', 'CH', 'Switzerland', 'EURO', '3626', '179869', '59', '2345');
INSERT INTO public.who_global_data_import VALUES (83106, '2020-11-03', 'CH', 'Switzerland', 'EURO', '10514', '190383', '58', '2403');
INSERT INTO public.who_global_data_import VALUES (83107, '2020-11-04', 'CH', 'Switzerland', 'EURO', '9595', '199978', '78', '2481');
INSERT INTO public.who_global_data_import VALUES (83108, '2020-11-05', 'CH', 'Switzerland', 'EURO', '8708', '208686', '81', '2562');
INSERT INTO public.who_global_data_import VALUES (83109, '2020-11-06', 'CH', 'Switzerland', 'EURO', '7828', '216514', '77', '2639');
INSERT INTO public.who_global_data_import VALUES (83110, '2020-11-07', 'CH', 'Switzerland', 'EURO', '7377', '223891', '91', '2730');
INSERT INTO public.who_global_data_import VALUES (83111, '2020-11-08', 'CH', 'Switzerland', 'EURO', '4189', '228080', '69', '2799');
INSERT INTO public.who_global_data_import VALUES (83112, '2020-11-09', 'CH', 'Switzerland', 'EURO', '2979', '231059', '88', '2887');
INSERT INTO public.who_global_data_import VALUES (83113, '2020-11-10', 'CH', 'Switzerland', 'EURO', '8683', '239742', '85', '2972');
INSERT INTO public.who_global_data_import VALUES (83114, '2020-11-11', 'CH', 'Switzerland', 'EURO', '7387', '247129', '83', '3055');
INSERT INTO public.who_global_data_import VALUES (83115, '2020-11-12', 'CH', 'Switzerland', 'EURO', '6354', '253483', '89', '3144');
INSERT INTO public.who_global_data_import VALUES (83116, '2020-11-13', 'CH', 'Switzerland', 'EURO', '5962', '259445', '102', '3246');
INSERT INTO public.who_global_data_import VALUES (83117, '2020-11-14', 'CH', 'Switzerland', 'EURO', '5679', '265124', '85', '3331');
INSERT INTO public.who_global_data_import VALUES (83118, '2020-11-15', 'CH', 'Switzerland', 'EURO', '3203', '268327', '77', '3408');
INSERT INTO public.who_global_data_import VALUES (83119, '2020-11-16', 'CH', 'Switzerland', 'EURO', '2314', '270641', '83', '3491');
INSERT INTO public.who_global_data_import VALUES (83120, '2020-11-17', 'CH', 'Switzerland', 'EURO', '6584', '277225', '88', '3579');
INSERT INTO public.who_global_data_import VALUES (83121, '2020-11-18', 'CH', 'Switzerland', 'EURO', '5417', '282642', '85', '3664');
INSERT INTO public.who_global_data_import VALUES (83122, '2020-11-19', 'CH', 'Switzerland', 'EURO', '4858', '287500', '103', '3767');
INSERT INTO public.who_global_data_import VALUES (83123, '2020-11-20', 'CH', 'Switzerland', 'EURO', '4493', '291993', '79', '3846');
INSERT INTO public.who_global_data_import VALUES (83124, '2020-11-21', 'CH', 'Switzerland', 'EURO', '4323', '296316', '80', '3926');
INSERT INTO public.who_global_data_import VALUES (83125, '2020-11-22', 'CH', 'Switzerland', 'EURO', '2571', '298887', '76', '4002');
INSERT INTO public.who_global_data_import VALUES (83126, '2020-11-23', 'CH', 'Switzerland', 'EURO', '1871', '300758', '76', '4078');
INSERT INTO public.who_global_data_import VALUES (83127, '2020-11-24', 'CH', 'Switzerland', 'EURO', '5434', '306192', '95', '4173');
INSERT INTO public.who_global_data_import VALUES (83128, '2020-11-25', 'CH', 'Switzerland', 'EURO', '4432', '310624', '89', '4262');
INSERT INTO public.who_global_data_import VALUES (83129, '2020-11-26', 'CH', 'Switzerland', 'EURO', '4302', '314926', '84', '4346');
INSERT INTO public.who_global_data_import VALUES (83130, '2020-11-27', 'CH', 'Switzerland', 'EURO', '3955', '318881', '72', '4418');
INSERT INTO public.who_global_data_import VALUES (83131, '2020-11-28', 'CH', 'Switzerland', 'EURO', '4071', '322952', '87', '4505');
INSERT INTO public.who_global_data_import VALUES (83132, '2020-11-29', 'CH', 'Switzerland', 'EURO', '2311', '325263', '86', '4591');
INSERT INTO public.who_global_data_import VALUES (83133, '2020-11-30', 'CH', 'Switzerland', 'EURO', '1692', '326955', '81', '4672');
INSERT INTO public.who_global_data_import VALUES (83134, '2020-12-01', 'CH', 'Switzerland', 'EURO', '5270', '332225', '91', '4763');
INSERT INTO public.who_global_data_import VALUES (83135, '2020-12-02', 'CH', 'Switzerland', 'EURO', '4252', '336477', '88', '4851');
INSERT INTO public.who_global_data_import VALUES (83136, '2020-12-03', 'CH', 'Switzerland', 'EURO', '4421', '340898', '87', '4938');
INSERT INTO public.who_global_data_import VALUES (83137, '2020-12-04', 'CH', 'Switzerland', 'EURO', '4318', '345216', '78', '5016');
INSERT INTO public.who_global_data_import VALUES (83138, '2020-12-05', 'CH', 'Switzerland', 'EURO', '4554', '349770', '75', '5091');
INSERT INTO public.who_global_data_import VALUES (83139, '2020-12-06', 'CH', 'Switzerland', 'EURO', '2518', '352288', '94', '5185');
INSERT INTO public.who_global_data_import VALUES (83140, '2020-12-07', 'CH', 'Switzerland', 'EURO', '1939', '354227', '62', '5247');
INSERT INTO public.who_global_data_import VALUES (83141, '2020-12-08', 'CH', 'Switzerland', 'EURO', '5829', '360056', '73', '5320');
INSERT INTO public.who_global_data_import VALUES (83142, '2020-12-09', 'CH', 'Switzerland', 'EURO', '4670', '364726', '94', '5414');
INSERT INTO public.who_global_data_import VALUES (83143, '2020-12-10', 'CH', 'Switzerland', 'EURO', '5241', '369967', '81', '5495');
INSERT INTO public.who_global_data_import VALUES (83144, '2020-12-11', 'CH', 'Switzerland', 'EURO', '4638', '374605', '83', '5578');
INSERT INTO public.who_global_data_import VALUES (83145, '2020-12-12', 'CH', 'Switzerland', 'EURO', '4679', '379284', '87', '5665');
INSERT INTO public.who_global_data_import VALUES (83146, '2020-12-13', 'CH', 'Switzerland', 'EURO', '2864', '382148', '84', '5749');
INSERT INTO public.who_global_data_import VALUES (83147, '2020-12-14', 'CH', 'Switzerland', 'EURO', '2086', '384234', '83', '5832');
INSERT INTO public.who_global_data_import VALUES (83148, '2020-12-15', 'CH', 'Switzerland', 'EURO', '5915', '390149', '97', '5929');
INSERT INTO public.who_global_data_import VALUES (83149, '2020-12-16', 'CH', 'Switzerland', 'EURO', '5166', '395315', '87', '6016');
INSERT INTO public.who_global_data_import VALUES (83150, '2020-12-17', 'CH', 'Switzerland', 'EURO', '4815', '400130', '88', '6104');
INSERT INTO public.who_global_data_import VALUES (83151, '2020-12-18', 'CH', 'Switzerland', 'EURO', '4385', '404515', '82', '6186');
INSERT INTO public.who_global_data_import VALUES (83152, '2020-12-19', 'CH', 'Switzerland', 'EURO', '4340', '408855', '88', '6274');
INSERT INTO public.who_global_data_import VALUES (83153, '2020-12-20', 'CH', 'Switzerland', 'EURO', '2675', '411530', '79', '6353');
INSERT INTO public.who_global_data_import VALUES (83154, '2020-12-21', 'CH', 'Switzerland', 'EURO', '1947', '413477', '94', '6447');
INSERT INTO public.who_global_data_import VALUES (83155, '2020-12-22', 'CH', 'Switzerland', 'EURO', '5627', '419104', '85', '6532');
INSERT INTO public.who_global_data_import VALUES (83156, '2020-12-23', 'CH', 'Switzerland', 'EURO', '4602', '423706', '82', '6614');
INSERT INTO public.who_global_data_import VALUES (83157, '2020-12-24', 'CH', 'Switzerland', 'EURO', '4474', '428180', '79', '6693');
INSERT INTO public.who_global_data_import VALUES (83158, '2020-12-25', 'CH', 'Switzerland', 'EURO', '3048', '431228', '88', '6781');
INSERT INTO public.who_global_data_import VALUES (83159, '2020-12-26', 'CH', 'Switzerland', 'EURO', '1721', '432949', '59', '6840');
INSERT INTO public.who_global_data_import VALUES (83160, '2020-12-27', 'CH', 'Switzerland', 'EURO', '2355', '435304', '89', '6929');
INSERT INTO public.who_global_data_import VALUES (83161, '2020-12-28', 'CH', 'Switzerland', 'EURO', '2115', '437419', '88', '7017');
INSERT INTO public.who_global_data_import VALUES (83162, '2020-12-29', 'CH', 'Switzerland', 'EURO', '5032', '442451', '70', '7087');
INSERT INTO public.who_global_data_import VALUES (83163, '2020-12-30', 'CH', 'Switzerland', 'EURO', '4463', '446914', '68', '7155');
INSERT INTO public.who_global_data_import VALUES (83164, '2020-12-31', 'CH', 'Switzerland', 'EURO', '4206', '451120', '85', '7240');
INSERT INTO public.who_global_data_import VALUES (83165, '2021-01-01', 'CH', 'Switzerland', 'EURO', '3054', '454174', '75', '7315');
INSERT INTO public.who_global_data_import VALUES (83166, '2021-01-02', 'CH', 'Switzerland', 'EURO', '1679', '455853', '72', '7387');
INSERT INTO public.who_global_data_import VALUES (83167, '2021-01-03', 'CH', 'Switzerland', 'EURO', '2718', '458571', '62', '7449');
INSERT INTO public.who_global_data_import VALUES (83168, '2021-01-04', 'CH', 'Switzerland', 'EURO', '2219', '460790', '57', '7506');
INSERT INTO public.who_global_data_import VALUES (83169, '2021-01-05', 'CH', 'Switzerland', 'EURO', '5277', '466067', '46', '7552');
INSERT INTO public.who_global_data_import VALUES (83170, '2021-01-06', 'CH', 'Switzerland', 'EURO', '4161', '470228', '61', '7613');
INSERT INTO public.who_global_data_import VALUES (83171, '2021-01-07', 'CH', 'Switzerland', 'EURO', '3346', '473574', '58', '7671');
INSERT INTO public.who_global_data_import VALUES (83172, '2021-01-08', 'CH', 'Switzerland', 'EURO', '3177', '476751', '57', '7728');
INSERT INTO public.who_global_data_import VALUES (83173, '2021-01-09', 'CH', 'Switzerland', 'EURO', '3049', '479800', '42', '7770');
INSERT INTO public.who_global_data_import VALUES (83174, '2021-01-10', 'CH', 'Switzerland', 'EURO', '1681', '481481', '61', '7831');
INSERT INTO public.who_global_data_import VALUES (83175, '2021-01-11', 'CH', 'Switzerland', 'EURO', '1293', '482774', '54', '7885');
INSERT INTO public.who_global_data_import VALUES (83176, '2021-01-12', 'CH', 'Switzerland', 'EURO', '3458', '486232', '54', '7939');
INSERT INTO public.who_global_data_import VALUES (83177, '2021-01-13', 'CH', 'Switzerland', 'EURO', '2606', '488838', '51', '7990');
INSERT INTO public.who_global_data_import VALUES (83178, '2021-01-14', 'CH', 'Switzerland', 'EURO', '2458', '491296', '56', '8046');
INSERT INTO public.who_global_data_import VALUES (83179, '2021-01-15', 'CH', 'Switzerland', 'EURO', '2241', '493537', '44', '8090');
INSERT INTO public.who_global_data_import VALUES (83180, '2021-01-16', 'CH', 'Switzerland', 'EURO', '2158', '495695', '59', '8149');
INSERT INTO public.who_global_data_import VALUES (83181, '2021-01-17', 'CH', 'Switzerland', 'EURO', '1334', '497029', '46', '8195');
INSERT INTO public.who_global_data_import VALUES (83182, '2021-01-18', 'CH', 'Switzerland', 'EURO', '892', '497921', '31', '8226');
INSERT INTO public.who_global_data_import VALUES (83183, '2021-01-19', 'CH', 'Switzerland', 'EURO', '2945', '500866', '36', '8262');
INSERT INTO public.who_global_data_import VALUES (83184, '2021-01-20', 'CH', 'Switzerland', 'EURO', '2330', '503196', '60', '8322');
INSERT INTO public.who_global_data_import VALUES (83185, '2021-01-21', 'CH', 'Switzerland', 'EURO', '2277', '505473', '41', '8363');
INSERT INTO public.who_global_data_import VALUES (83186, '2021-01-22', 'CH', 'Switzerland', 'EURO', '2051', '507524', '41', '8404');
INSERT INTO public.who_global_data_import VALUES (83187, '2021-01-23', 'CH', 'Switzerland', 'EURO', '2035', '509559', '42', '8446');
INSERT INTO public.who_global_data_import VALUES (83188, '2021-01-24', 'CH', 'Switzerland', 'EURO', '1097', '510656', '44', '8490');
INSERT INTO public.who_global_data_import VALUES (83189, '2021-01-25', 'CH', 'Switzerland', 'EURO', '732', '511388', '45', '8535');
INSERT INTO public.who_global_data_import VALUES (83190, '2021-01-26', 'CH', 'Switzerland', 'EURO', '2491', '513879', '30', '8565');
INSERT INTO public.who_global_data_import VALUES (83191, '2021-01-27', 'CH', 'Switzerland', 'EURO', '1835', '515714', '33', '8598');
INSERT INTO public.who_global_data_import VALUES (83192, '2021-01-28', 'CH', 'Switzerland', 'EURO', '1870', '517584', '30', '8628');
INSERT INTO public.who_global_data_import VALUES (83193, '2021-01-29', 'CH', 'Switzerland', 'EURO', '1767', '519351', '32', '8660');
INSERT INTO public.who_global_data_import VALUES (83194, '2021-01-30', 'CH', 'Switzerland', 'EURO', '1766', '521117', '27', '8687');
INSERT INTO public.who_global_data_import VALUES (83195, '2021-01-31', 'CH', 'Switzerland', 'EURO', '1017', '522134', '25', '8712');
INSERT INTO public.who_global_data_import VALUES (83196, '2021-02-01', 'CH', 'Switzerland', 'EURO', '721', '522855', '24', '8736');
INSERT INTO public.who_global_data_import VALUES (83197, '2021-02-02', 'CH', 'Switzerland', 'EURO', '2046', '524901', '26', '8762');
INSERT INTO public.who_global_data_import VALUES (83198, '2021-02-03', 'CH', 'Switzerland', 'EURO', '1036', '525937', '5', '8767');
INSERT INTO public.who_global_data_import VALUES (83199, '2021-02-04', 'CH', 'Switzerland', 'EURO', '7', '525944', '0', '8767');
INSERT INTO public.who_global_data_import VALUES (83200, '2021-02-05', 'CH', 'Switzerland', 'EURO', '1759', '527703', '23', '8790');
INSERT INTO public.who_global_data_import VALUES (83201, '2020-01-03', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83202, '2020-01-04', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83203, '2020-01-05', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83204, '2020-01-06', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83205, '2020-01-07', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83206, '2020-01-08', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83207, '2020-01-09', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83208, '2020-01-10', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83209, '2020-01-11', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83210, '2020-01-12', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83211, '2020-01-13', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83212, '2020-01-14', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83213, '2020-01-15', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83214, '2020-01-16', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83215, '2020-01-17', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83216, '2020-01-18', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83217, '2020-01-19', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83218, '2020-01-20', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83219, '2020-01-21', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83220, '2020-01-22', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83221, '2020-01-23', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83222, '2020-01-24', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83223, '2020-01-25', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83224, '2020-01-26', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83225, '2020-01-27', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83226, '2020-01-28', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83227, '2020-01-29', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83228, '2020-01-30', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83229, '2020-01-31', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83230, '2020-02-01', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83231, '2020-02-02', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83232, '2020-02-03', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83233, '2020-02-04', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83234, '2020-02-05', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83235, '2020-02-06', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83236, '2020-02-07', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83237, '2020-02-08', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83238, '2020-02-09', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83239, '2020-02-10', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83240, '2020-02-11', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83241, '2020-02-12', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83242, '2020-02-13', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83243, '2020-02-14', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83244, '2020-02-15', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83245, '2020-02-16', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83246, '2020-02-17', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83247, '2020-02-18', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83248, '2020-02-19', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83249, '2020-02-20', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83250, '2020-02-21', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83251, '2020-02-22', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83252, '2020-02-23', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83253, '2020-02-24', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83254, '2020-02-25', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83255, '2020-02-26', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83256, '2020-02-27', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83257, '2020-02-28', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83258, '2020-02-29', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83259, '2020-03-01', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83260, '2020-03-02', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83261, '2020-03-03', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83262, '2020-03-04', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83263, '2020-03-05', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83264, '2020-03-06', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83265, '2020-03-07', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83266, '2020-03-08', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83267, '2020-03-09', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83268, '2020-03-10', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83269, '2020-03-11', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83270, '2020-03-12', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83271, '2020-03-13', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83272, '2020-03-14', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83273, '2020-03-15', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83274, '2020-03-16', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83275, '2020-03-17', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83276, '2020-03-18', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83277, '2020-03-19', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83278, '2020-03-20', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83279, '2020-03-21', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83280, '2020-03-22', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83281, '2020-03-23', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83282, '2020-03-24', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83283, '2020-03-25', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83284, '2020-03-26', 'SY', 'Syrian Arab Republic', 'EMRO', '4', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83285, '2020-03-27', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83286, '2020-03-28', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83287, '2020-03-29', 'SY', 'Syrian Arab Republic', 'EMRO', '4', '9', '1', '1');
INSERT INTO public.who_global_data_import VALUES (83288, '2020-03-30', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (83289, '2020-03-31', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '10', '1', '2');
INSERT INTO public.who_global_data_import VALUES (83290, '2020-04-01', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '10', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83291, '2020-04-02', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '10', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83292, '2020-04-03', 'SY', 'Syrian Arab Republic', 'EMRO', '6', '16', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83293, '2020-04-04', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '16', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83294, '2020-04-05', 'SY', 'Syrian Arab Republic', 'EMRO', '3', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83295, '2020-04-06', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83296, '2020-04-07', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83297, '2020-04-08', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83298, '2020-04-09', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83299, '2020-04-10', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '19', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83300, '2020-04-11', 'SY', 'Syrian Arab Republic', 'EMRO', '6', '25', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83301, '2020-04-12', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '25', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83302, '2020-04-13', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '25', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83303, '2020-04-14', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '25', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83304, '2020-04-15', 'SY', 'Syrian Arab Republic', 'EMRO', '4', '29', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83305, '2020-04-16', 'SY', 'Syrian Arab Republic', 'EMRO', '4', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83306, '2020-04-17', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '33', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83307, '2020-04-18', 'SY', 'Syrian Arab Republic', 'EMRO', '5', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83308, '2020-04-19', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '38', '0', '2');
INSERT INTO public.who_global_data_import VALUES (83309, '2020-04-20', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '39', '1', '3');
INSERT INTO public.who_global_data_import VALUES (83310, '2020-04-21', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '39', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83311, '2020-04-22', 'SY', 'Syrian Arab Republic', 'EMRO', '3', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83312, '2020-04-23', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83313, '2020-04-24', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83314, '2020-04-25', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83315, '2020-04-26', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '42', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83316, '2020-04-27', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83317, '2020-04-28', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83318, '2020-04-29', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83319, '2020-04-30', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83320, '2020-05-01', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '43', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83321, '2020-05-02', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83322, '2020-05-03', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83323, '2020-05-04', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83324, '2020-05-05', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83325, '2020-05-06', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '45', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83326, '2020-05-07', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '45', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83327, '2020-05-08', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '45', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83328, '2020-05-09', 'SY', 'Syrian Arab Republic', 'EMRO', '2', '47', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83329, '2020-05-10', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '47', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83330, '2020-05-11', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '47', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83331, '2020-05-12', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '47', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83332, '2020-05-13', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '48', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83333, '2020-05-14', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '48', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83334, '2020-05-15', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '48', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83335, '2020-05-16', 'SY', 'Syrian Arab Republic', 'EMRO', '2', '50', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83336, '2020-05-17', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '51', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83337, '2020-05-18', 'SY', 'Syrian Arab Republic', 'EMRO', '7', '58', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83338, '2020-05-19', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '58', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83339, '2020-05-20', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '58', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83340, '2020-05-21', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '58', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83341, '2020-05-22', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '58', '0', '3');
INSERT INTO public.who_global_data_import VALUES (83342, '2020-05-23', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '59', '1', '4');
INSERT INTO public.who_global_data_import VALUES (83343, '2020-05-24', 'SY', 'Syrian Arab Republic', 'EMRO', '11', '70', '0', '4');
INSERT INTO public.who_global_data_import VALUES (83344, '2020-05-25', 'SY', 'Syrian Arab Republic', 'EMRO', '16', '86', '0', '4');
INSERT INTO public.who_global_data_import VALUES (83345, '2020-05-26', 'SY', 'Syrian Arab Republic', 'EMRO', '20', '106', '0', '4');
INSERT INTO public.who_global_data_import VALUES (83346, '2020-05-27', 'SY', 'Syrian Arab Republic', 'EMRO', '15', '121', '0', '4');
INSERT INTO public.who_global_data_import VALUES (83347, '2020-05-28', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '121', '0', '4');
INSERT INTO public.who_global_data_import VALUES (83348, '2020-05-29', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '122', '0', '4');
INSERT INTO public.who_global_data_import VALUES (83349, '2020-05-30', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '122', '0', '4');
INSERT INTO public.who_global_data_import VALUES (83350, '2020-05-31', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '122', '0', '4');
INSERT INTO public.who_global_data_import VALUES (83351, '2020-06-01', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '122', '1', '5');
INSERT INTO public.who_global_data_import VALUES (83352, '2020-06-02', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '123', '0', '5');
INSERT INTO public.who_global_data_import VALUES (83353, '2020-06-03', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '123', '1', '6');
INSERT INTO public.who_global_data_import VALUES (83354, '2020-06-04', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '123', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83355, '2020-06-05', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '124', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83356, '2020-06-06', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '124', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83357, '2020-06-07', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '125', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83358, '2020-06-08', 'SY', 'Syrian Arab Republic', 'EMRO', '16', '141', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83359, '2020-06-09', 'SY', 'Syrian Arab Republic', 'EMRO', '3', '144', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83360, '2020-06-10', 'SY', 'Syrian Arab Republic', 'EMRO', '2', '146', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83361, '2020-06-11', 'SY', 'Syrian Arab Republic', 'EMRO', '6', '152', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83362, '2020-06-12', 'SY', 'Syrian Arab Republic', 'EMRO', '12', '164', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83363, '2020-06-13', 'SY', 'Syrian Arab Republic', 'EMRO', '6', '170', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83364, '2020-06-14', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '170', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83365, '2020-06-15', 'SY', 'Syrian Arab Republic', 'EMRO', '7', '177', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83366, '2020-06-16', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '177', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83367, '2020-06-17', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '177', '0', '6');
INSERT INTO public.who_global_data_import VALUES (83368, '2020-06-18', 'SY', 'Syrian Arab Republic', 'EMRO', '1', '178', '1', '7');
INSERT INTO public.who_global_data_import VALUES (83369, '2020-06-19', 'SY', 'Syrian Arab Republic', 'EMRO', '9', '187', '0', '7');
INSERT INTO public.who_global_data_import VALUES (83370, '2020-06-20', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '187', '0', '7');
INSERT INTO public.who_global_data_import VALUES (83371, '2020-06-21', 'SY', 'Syrian Arab Republic', 'EMRO', '11', '198', '0', '7');
INSERT INTO public.who_global_data_import VALUES (83372, '2020-06-22', 'SY', 'Syrian Arab Republic', 'EMRO', '6', '204', '0', '7');
INSERT INTO public.who_global_data_import VALUES (83373, '2020-06-23', 'SY', 'Syrian Arab Republic', 'EMRO', '15', '219', '0', '7');
INSERT INTO public.who_global_data_import VALUES (83374, '2020-06-24', 'SY', 'Syrian Arab Republic', 'EMRO', '12', '231', '0', '7');
INSERT INTO public.who_global_data_import VALUES (83375, '2020-06-25', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '231', '0', '7');
INSERT INTO public.who_global_data_import VALUES (83376, '2020-06-26', 'SY', 'Syrian Arab Republic', 'EMRO', '11', '242', '0', '7');
INSERT INTO public.who_global_data_import VALUES (83377, '2020-06-27', 'SY', 'Syrian Arab Republic', 'EMRO', '12', '254', '0', '7');
INSERT INTO public.who_global_data_import VALUES (83378, '2020-06-28', 'SY', 'Syrian Arab Republic', 'EMRO', '2', '256', '2', '9');
INSERT INTO public.who_global_data_import VALUES (83379, '2020-06-29', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '256', '0', '9');
INSERT INTO public.who_global_data_import VALUES (83380, '2020-06-30', 'SY', 'Syrian Arab Republic', 'EMRO', '13', '269', '0', '9');
INSERT INTO public.who_global_data_import VALUES (83381, '2020-07-01', 'SY', 'Syrian Arab Republic', 'EMRO', '10', '279', '0', '9');
INSERT INTO public.who_global_data_import VALUES (83382, '2020-07-02', 'SY', 'Syrian Arab Republic', 'EMRO', '14', '293', '0', '9');
INSERT INTO public.who_global_data_import VALUES (83383, '2020-07-03', 'SY', 'Syrian Arab Republic', 'EMRO', '19', '312', '0', '9');
INSERT INTO public.who_global_data_import VALUES (83384, '2020-07-04', 'SY', 'Syrian Arab Republic', 'EMRO', '16', '328', '1', '10');
INSERT INTO public.who_global_data_import VALUES (83385, '2020-07-05', 'SY', 'Syrian Arab Republic', 'EMRO', '10', '338', '0', '10');
INSERT INTO public.who_global_data_import VALUES (83386, '2020-07-06', 'SY', 'Syrian Arab Republic', 'EMRO', '20', '358', '3', '13');
INSERT INTO public.who_global_data_import VALUES (83387, '2020-07-07', 'SY', 'Syrian Arab Republic', 'EMRO', '14', '372', '1', '14');
INSERT INTO public.who_global_data_import VALUES (83388, '2020-07-08', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '372', '0', '14');
INSERT INTO public.who_global_data_import VALUES (83389, '2020-07-09', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '372', '0', '14');
INSERT INTO public.who_global_data_import VALUES (83390, '2020-07-10', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '372', '0', '14');
INSERT INTO public.who_global_data_import VALUES (83391, '2020-07-11', 'SY', 'Syrian Arab Republic', 'EMRO', '22', '394', '2', '16');
INSERT INTO public.who_global_data_import VALUES (83392, '2020-07-12', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '394', '0', '16');
INSERT INTO public.who_global_data_import VALUES (83393, '2020-07-13', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '394', '0', '16');
INSERT INTO public.who_global_data_import VALUES (83394, '2020-07-14', 'SY', 'Syrian Arab Republic', 'EMRO', '23', '417', '3', '19');
INSERT INTO public.who_global_data_import VALUES (83395, '2020-07-15', 'SY', 'Syrian Arab Republic', 'EMRO', '22', '439', '2', '21');
INSERT INTO public.who_global_data_import VALUES (83396, '2020-07-16', 'SY', 'Syrian Arab Republic', 'EMRO', '19', '458', '1', '22');
INSERT INTO public.who_global_data_import VALUES (83397, '2020-07-17', 'SY', 'Syrian Arab Republic', 'EMRO', '19', '477', '0', '22');
INSERT INTO public.who_global_data_import VALUES (83398, '2020-07-18', 'SY', 'Syrian Arab Republic', 'EMRO', '19', '496', '3', '25');
INSERT INTO public.who_global_data_import VALUES (83399, '2020-07-19', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '496', '0', '25');
INSERT INTO public.who_global_data_import VALUES (83400, '2020-07-20', 'SY', 'Syrian Arab Republic', 'EMRO', '0', '496', '0', '25');
INSERT INTO public.who_global_data_import VALUES (83401, '2020-07-21', 'SY', 'Syrian Arab Republic', 'EMRO', '26', '522', '4', '29');
INSERT INTO public.who_global_data_import VALUES (83402, '2020-07-22', 'SY', 'Syrian Arab Republic', 'EMRO', '18', '540', '2', '31');
INSERT INTO public.who_global_data_import VALUES (83403, '2020-07-23', 'SY', 'Syrian Arab Republic', 'EMRO', '21', '561', '1', '32');
INSERT INTO public.who_global_data_import VALUES (83404, '2020-07-24', 'SY', 'Syrian Arab Republic', 'EMRO', '23', '584', '3', '35');
INSERT INTO public.who_global_data_import VALUES (83405, '2020-07-25', 'SY', 'Syrian Arab Republic', 'EMRO', '24', '608', '0', '35');
INSERT INTO public.who_global_data_import VALUES (83406, '2020-07-26', 'SY', 'Syrian Arab Republic', 'EMRO', '19', '627', '1', '36');
INSERT INTO public.who_global_data_import VALUES (83407, '2020-07-27', 'SY', 'Syrian Arab Republic', 'EMRO', '23', '650', '2', '38');
INSERT INTO public.who_global_data_import VALUES (83408, '2020-07-28', 'SY', 'Syrian Arab Republic', 'EMRO', '24', '674', '2', '40');
INSERT INTO public.who_global_data_import VALUES (83409, '2020-07-29', 'SY', 'Syrian Arab Republic', 'EMRO', '20', '694', '0', '40');
INSERT INTO public.who_global_data_import VALUES (83410, '2020-07-30', 'SY', 'Syrian Arab Republic', 'EMRO', '23', '717', '0', '40');
INSERT INTO public.who_global_data_import VALUES (83411, '2020-07-31', 'SY', 'Syrian Arab Republic', 'EMRO', '21', '738', '1', '41');
INSERT INTO public.who_global_data_import VALUES (83412, '2020-08-01', 'SY', 'Syrian Arab Republic', 'EMRO', '19', '757', '2', '43');
INSERT INTO public.who_global_data_import VALUES (83413, '2020-08-02', 'SY', 'Syrian Arab Republic', 'EMRO', '23', '780', '0', '43');
INSERT INTO public.who_global_data_import VALUES (83414, '2020-08-03', 'SY', 'Syrian Arab Republic', 'EMRO', '29', '809', '1', '44');
INSERT INTO public.who_global_data_import VALUES (83415, '2020-08-04', 'SY', 'Syrian Arab Republic', 'EMRO', '38', '847', '2', '46');
INSERT INTO public.who_global_data_import VALUES (83416, '2020-08-05', 'SY', 'Syrian Arab Republic', 'EMRO', '45', '892', '0', '46');
INSERT INTO public.who_global_data_import VALUES (83417, '2020-08-06', 'SY', 'Syrian Arab Republic', 'EMRO', '52', '944', '2', '48');
INSERT INTO public.who_global_data_import VALUES (83418, '2020-08-07', 'SY', 'Syrian Arab Republic', 'EMRO', '55', '999', '0', '48');
INSERT INTO public.who_global_data_import VALUES (83419, '2020-08-08', 'SY', 'Syrian Arab Republic', 'EMRO', '61', '1060', '0', '48');
INSERT INTO public.who_global_data_import VALUES (83420, '2020-08-09', 'SY', 'Syrian Arab Republic', 'EMRO', '65', '1125', '2', '50');
INSERT INTO public.who_global_data_import VALUES (83421, '2020-08-10', 'SY', 'Syrian Arab Republic', 'EMRO', '63', '1188', '2', '52');
INSERT INTO public.who_global_data_import VALUES (83422, '2020-08-11', 'SY', 'Syrian Arab Republic', 'EMRO', '67', '1255', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83423, '2020-08-12', 'SY', 'Syrian Arab Republic', 'EMRO', '72', '1327', '1', '53');
INSERT INTO public.who_global_data_import VALUES (83424, '2020-08-13', 'SY', 'Syrian Arab Republic', 'EMRO', '75', '1402', '0', '53');
INSERT INTO public.who_global_data_import VALUES (83425, '2020-08-14', 'SY', 'Syrian Arab Republic', 'EMRO', '30', '1432', '2', '55');
INSERT INTO public.who_global_data_import VALUES (83426, '2020-08-15', 'SY', 'Syrian Arab Republic', 'EMRO', '83', '1515', '3', '58');
INSERT INTO public.who_global_data_import VALUES (83427, '2020-08-16', 'SY', 'Syrian Arab Republic', 'EMRO', '78', '1593', '2', '60');
INSERT INTO public.who_global_data_import VALUES (83428, '2020-08-17', 'SY', 'Syrian Arab Republic', 'EMRO', '84', '1677', '4', '64');
INSERT INTO public.who_global_data_import VALUES (83429, '2020-08-18', 'SY', 'Syrian Arab Republic', 'EMRO', '87', '1764', '4', '68');
INSERT INTO public.who_global_data_import VALUES (83430, '2020-08-19', 'SY', 'Syrian Arab Republic', 'EMRO', '80', '1844', '5', '73');
INSERT INTO public.who_global_data_import VALUES (83431, '2020-08-20', 'SY', 'Syrian Arab Republic', 'EMRO', '83', '1927', '5', '78');
INSERT INTO public.who_global_data_import VALUES (83432, '2020-08-21', 'SY', 'Syrian Arab Republic', 'EMRO', '81', '2008', '4', '82');
INSERT INTO public.who_global_data_import VALUES (83433, '2020-08-22', 'SY', 'Syrian Arab Republic', 'EMRO', '65', '2073', '1', '83');
INSERT INTO public.who_global_data_import VALUES (83434, '2020-08-23', 'SY', 'Syrian Arab Republic', 'EMRO', '70', '2143', '2', '85');
INSERT INTO public.who_global_data_import VALUES (83435, '2020-08-24', 'SY', 'Syrian Arab Republic', 'EMRO', '74', '2217', '4', '89');
INSERT INTO public.who_global_data_import VALUES (83436, '2020-08-25', 'SY', 'Syrian Arab Republic', 'EMRO', '76', '2293', '3', '92');
INSERT INTO public.who_global_data_import VALUES (83437, '2020-08-26', 'SY', 'Syrian Arab Republic', 'EMRO', '72', '2365', '3', '95');
INSERT INTO public.who_global_data_import VALUES (83438, '2020-08-27', 'SY', 'Syrian Arab Republic', 'EMRO', '75', '2440', '3', '98');
INSERT INTO public.who_global_data_import VALUES (83439, '2020-08-28', 'SY', 'Syrian Arab Republic', 'EMRO', '64', '2504', '2', '100');
INSERT INTO public.who_global_data_import VALUES (83440, '2020-08-29', 'SY', 'Syrian Arab Republic', 'EMRO', '59', '2563', '3', '103');
INSERT INTO public.who_global_data_import VALUES (83441, '2020-08-30', 'SY', 'Syrian Arab Republic', 'EMRO', '65', '2628', '3', '106');
INSERT INTO public.who_global_data_import VALUES (83442, '2020-08-31', 'SY', 'Syrian Arab Republic', 'EMRO', '75', '2703', '3', '109');
INSERT INTO public.who_global_data_import VALUES (83443, '2020-09-01', 'SY', 'Syrian Arab Republic', 'EMRO', '62', '2765', '3', '112');
INSERT INTO public.who_global_data_import VALUES (83444, '2020-09-02', 'SY', 'Syrian Arab Republic', 'EMRO', '65', '2830', '4', '116');
INSERT INTO public.who_global_data_import VALUES (83445, '2020-09-03', 'SY', 'Syrian Arab Republic', 'EMRO', '68', '2898', '4', '120');
INSERT INTO public.who_global_data_import VALUES (83446, '2020-09-04', 'SY', 'Syrian Arab Republic', 'EMRO', '75', '2973', '4', '124');
INSERT INTO public.who_global_data_import VALUES (83447, '2020-09-05', 'SY', 'Syrian Arab Republic', 'EMRO', '68', '3041', '3', '127');
INSERT INTO public.who_global_data_import VALUES (83448, '2020-09-06', 'SY', 'Syrian Arab Republic', 'EMRO', '63', '3104', '3', '130');
INSERT INTO public.who_global_data_import VALUES (83449, '2020-09-07', 'SY', 'Syrian Arab Republic', 'EMRO', '67', '3171', '4', '134');
INSERT INTO public.who_global_data_import VALUES (83450, '2020-09-08', 'SY', 'Syrian Arab Republic', 'EMRO', '58', '3229', '3', '137');
INSERT INTO public.who_global_data_import VALUES (83451, '2020-09-09', 'SY', 'Syrian Arab Republic', 'EMRO', '60', '3289', '3', '140');
INSERT INTO public.who_global_data_import VALUES (83452, '2020-09-10', 'SY', 'Syrian Arab Republic', 'EMRO', '62', '3351', '3', '143');
INSERT INTO public.who_global_data_import VALUES (83453, '2020-09-11', 'SY', 'Syrian Arab Republic', 'EMRO', '65', '3416', '4', '147');
INSERT INTO public.who_global_data_import VALUES (83454, '2020-09-12', 'SY', 'Syrian Arab Republic', 'EMRO', '60', '3476', '3', '150');
INSERT INTO public.who_global_data_import VALUES (83455, '2020-09-13', 'SY', 'Syrian Arab Republic', 'EMRO', '30', '3506', '2', '152');
INSERT INTO public.who_global_data_import VALUES (83456, '2020-09-14', 'SY', 'Syrian Arab Republic', 'EMRO', '34', '3540', '3', '155');
INSERT INTO public.who_global_data_import VALUES (83457, '2020-09-15', 'SY', 'Syrian Arab Republic', 'EMRO', '36', '3576', '2', '157');
INSERT INTO public.who_global_data_import VALUES (83458, '2020-09-16', 'SY', 'Syrian Arab Republic', 'EMRO', '38', '3614', '3', '160');
INSERT INTO public.who_global_data_import VALUES (83459, '2020-09-17', 'SY', 'Syrian Arab Republic', 'EMRO', '40', '3654', '3', '163');
INSERT INTO public.who_global_data_import VALUES (83460, '2020-09-18', 'SY', 'Syrian Arab Republic', 'EMRO', '37', '3691', '2', '165');
INSERT INTO public.who_global_data_import VALUES (83461, '2020-09-19', 'SY', 'Syrian Arab Republic', 'EMRO', '40', '3731', '3', '168');
INSERT INTO public.who_global_data_import VALUES (83462, '2020-09-20', 'SY', 'Syrian Arab Republic', 'EMRO', '34', '3765', '2', '170');
INSERT INTO public.who_global_data_import VALUES (83463, '2020-09-21', 'SY', 'Syrian Arab Republic', 'EMRO', '35', '3800', '2', '172');
INSERT INTO public.who_global_data_import VALUES (83464, '2020-09-22', 'SY', 'Syrian Arab Republic', 'EMRO', '33', '3833', '3', '175');
INSERT INTO public.who_global_data_import VALUES (83465, '2020-09-23', 'SY', 'Syrian Arab Republic', 'EMRO', '44', '3877', '3', '178');
INSERT INTO public.who_global_data_import VALUES (83466, '2020-09-24', 'SY', 'Syrian Arab Republic', 'EMRO', '47', '3924', '3', '181');
INSERT INTO public.who_global_data_import VALUES (83467, '2020-09-25', 'SY', 'Syrian Arab Republic', 'EMRO', '42', '3966', '2', '183');
INSERT INTO public.who_global_data_import VALUES (83468, '2020-09-26', 'SY', 'Syrian Arab Republic', 'EMRO', '35', '4001', '2', '185');
INSERT INTO public.who_global_data_import VALUES (83469, '2020-09-27', 'SY', 'Syrian Arab Republic', 'EMRO', '37', '4038', '3', '188');
INSERT INTO public.who_global_data_import VALUES (83470, '2020-09-28', 'SY', 'Syrian Arab Republic', 'EMRO', '34', '4072', '4', '192');
INSERT INTO public.who_global_data_import VALUES (83471, '2020-09-29', 'SY', 'Syrian Arab Republic', 'EMRO', '30', '4102', '2', '194');
INSERT INTO public.who_global_data_import VALUES (83472, '2020-09-30', 'SY', 'Syrian Arab Republic', 'EMRO', '46', '4148', '3', '197');
INSERT INTO public.who_global_data_import VALUES (83473, '2020-10-01', 'SY', 'Syrian Arab Republic', 'EMRO', '52', '4200', '3', '200');
INSERT INTO public.who_global_data_import VALUES (83474, '2020-10-02', 'SY', 'Syrian Arab Republic', 'EMRO', '47', '4247', '2', '202');
INSERT INTO public.who_global_data_import VALUES (83475, '2020-10-03', 'SY', 'Syrian Arab Republic', 'EMRO', '42', '4289', '1', '203');
INSERT INTO public.who_global_data_import VALUES (83476, '2020-10-04', 'SY', 'Syrian Arab Republic', 'EMRO', '40', '4329', '1', '204');
INSERT INTO public.who_global_data_import VALUES (83477, '2020-10-05', 'SY', 'Syrian Arab Republic', 'EMRO', '37', '4366', '1', '205');
INSERT INTO public.who_global_data_import VALUES (83478, '2020-10-06', 'SY', 'Syrian Arab Republic', 'EMRO', '45', '4411', '2', '207');
INSERT INTO public.who_global_data_import VALUES (83479, '2020-10-07', 'SY', 'Syrian Arab Republic', 'EMRO', '46', '4457', '2', '209');
INSERT INTO public.who_global_data_import VALUES (83480, '2020-10-08', 'SY', 'Syrian Arab Republic', 'EMRO', '47', '4504', '3', '212');
INSERT INTO public.who_global_data_import VALUES (83481, '2020-10-09', 'SY', 'Syrian Arab Republic', 'EMRO', '62', '4566', '3', '215');
INSERT INTO public.who_global_data_import VALUES (83482, '2020-10-10', 'SY', 'Syrian Arab Republic', 'EMRO', '50', '4616', '3', '218');
INSERT INTO public.who_global_data_import VALUES (83483, '2020-10-11', 'SY', 'Syrian Arab Republic', 'EMRO', '57', '4673', '3', '221');
INSERT INTO public.who_global_data_import VALUES (83484, '2020-10-12', 'SY', 'Syrian Arab Republic', 'EMRO', '45', '4718', '3', '224');
INSERT INTO public.who_global_data_import VALUES (83485, '2020-10-13', 'SY', 'Syrian Arab Republic', 'EMRO', '56', '4774', '4', '228');
INSERT INTO public.who_global_data_import VALUES (83486, '2020-10-14', 'SY', 'Syrian Arab Republic', 'EMRO', '52', '4826', '3', '231');
INSERT INTO public.who_global_data_import VALUES (83487, '2020-10-15', 'SY', 'Syrian Arab Republic', 'EMRO', '57', '4883', '3', '234');
INSERT INTO public.who_global_data_import VALUES (83488, '2020-10-16', 'SY', 'Syrian Arab Republic', 'EMRO', '48', '4931', '4', '238');
INSERT INTO public.who_global_data_import VALUES (83489, '2020-10-17', 'SY', 'Syrian Arab Republic', 'EMRO', '56', '4987', '3', '241');
INSERT INTO public.who_global_data_import VALUES (83490, '2020-10-18', 'SY', 'Syrian Arab Republic', 'EMRO', '46', '5033', '4', '245');
INSERT INTO public.who_global_data_import VALUES (83491, '2020-10-19', 'SY', 'Syrian Arab Republic', 'EMRO', '44', '5077', '3', '248');
INSERT INTO public.who_global_data_import VALUES (83492, '2020-10-20', 'SY', 'Syrian Arab Republic', 'EMRO', '57', '5134', '3', '251');
INSERT INTO public.who_global_data_import VALUES (83493, '2020-10-21', 'SY', 'Syrian Arab Republic', 'EMRO', '46', '5180', '3', '254');
INSERT INTO public.who_global_data_import VALUES (83494, '2020-10-22', 'SY', 'Syrian Arab Republic', 'EMRO', '44', '5224', '3', '257');
INSERT INTO public.who_global_data_import VALUES (83495, '2020-10-23', 'SY', 'Syrian Arab Republic', 'EMRO', '43', '5267', '3', '260');
INSERT INTO public.who_global_data_import VALUES (83496, '2020-10-24', 'SY', 'Syrian Arab Republic', 'EMRO', '52', '5319', '4', '264');
INSERT INTO public.who_global_data_import VALUES (83497, '2020-10-25', 'SY', 'Syrian Arab Republic', 'EMRO', '40', '5359', '3', '267');
INSERT INTO public.who_global_data_import VALUES (83498, '2020-10-26', 'SY', 'Syrian Arab Republic', 'EMRO', '49', '5408', '2', '269');
INSERT INTO public.who_global_data_import VALUES (83499, '2020-10-27', 'SY', 'Syrian Arab Republic', 'EMRO', '53', '5461', '3', '272');
INSERT INTO public.who_global_data_import VALUES (83500, '2020-10-28', 'SY', 'Syrian Arab Republic', 'EMRO', '67', '5528', '3', '275');
INSERT INTO public.who_global_data_import VALUES (83501, '2020-10-29', 'SY', 'Syrian Arab Republic', 'EMRO', '52', '5580', '3', '278');
INSERT INTO public.who_global_data_import VALUES (83502, '2020-10-30', 'SY', 'Syrian Arab Republic', 'EMRO', '53', '5633', '3', '281');
INSERT INTO public.who_global_data_import VALUES (83503, '2020-10-31', 'SY', 'Syrian Arab Republic', 'EMRO', '50', '5683', '4', '285');
INSERT INTO public.who_global_data_import VALUES (83504, '2020-11-01', 'SY', 'Syrian Arab Republic', 'EMRO', '45', '5728', '3', '288');
INSERT INTO public.who_global_data_import VALUES (83505, '2020-11-02', 'SY', 'Syrian Arab Republic', 'EMRO', '61', '5789', '4', '292');
INSERT INTO public.who_global_data_import VALUES (83506, '2020-11-03', 'SY', 'Syrian Arab Republic', 'EMRO', '54', '5843', '3', '295');
INSERT INTO public.who_global_data_import VALUES (83507, '2020-11-04', 'SY', 'Syrian Arab Republic', 'EMRO', '45', '5888', '3', '298');
INSERT INTO public.who_global_data_import VALUES (83508, '2020-11-05', 'SY', 'Syrian Arab Republic', 'EMRO', '76', '5964', '3', '301');
INSERT INTO public.who_global_data_import VALUES (83509, '2020-11-06', 'SY', 'Syrian Arab Republic', 'EMRO', '76', '6040', '4', '305');
INSERT INTO public.who_global_data_import VALUES (83510, '2020-11-07', 'SY', 'Syrian Arab Republic', 'EMRO', '62', '6102', '4', '309');
INSERT INTO public.who_global_data_import VALUES (83511, '2020-11-08', 'SY', 'Syrian Arab Republic', 'EMRO', '45', '6147', '4', '313');
INSERT INTO public.who_global_data_import VALUES (83512, '2020-11-09', 'SY', 'Syrian Arab Republic', 'EMRO', '68', '6215', '4', '317');
INSERT INTO public.who_global_data_import VALUES (83513, '2020-11-10', 'SY', 'Syrian Arab Republic', 'EMRO', '69', '6284', '4', '321');
INSERT INTO public.who_global_data_import VALUES (83514, '2020-11-11', 'SY', 'Syrian Arab Republic', 'EMRO', '68', '6352', '4', '325');
INSERT INTO public.who_global_data_import VALUES (83515, '2020-11-12', 'SY', 'Syrian Arab Republic', 'EMRO', '69', '6421', '4', '329');
INSERT INTO public.who_global_data_import VALUES (83516, '2020-11-13', 'SY', 'Syrian Arab Republic', 'EMRO', '65', '6486', '4', '333');
INSERT INTO public.who_global_data_import VALUES (83517, '2020-11-14', 'SY', 'Syrian Arab Republic', 'EMRO', '66', '6552', '4', '337');
INSERT INTO public.who_global_data_import VALUES (83518, '2020-11-15', 'SY', 'Syrian Arab Republic', 'EMRO', '61', '6613', '4', '341');
INSERT INTO public.who_global_data_import VALUES (83519, '2020-11-16', 'SY', 'Syrian Arab Republic', 'EMRO', '71', '6684', '4', '345');
INSERT INTO public.who_global_data_import VALUES (83520, '2020-11-17', 'SY', 'Syrian Arab Republic', 'EMRO', '75', '6759', '5', '350');
INSERT INTO public.who_global_data_import VALUES (83521, '2020-11-18', 'SY', 'Syrian Arab Republic', 'EMRO', '77', '6836', '4', '354');
INSERT INTO public.who_global_data_import VALUES (83522, '2020-11-19', 'SY', 'Syrian Arab Republic', 'EMRO', '83', '6919', '4', '358');
INSERT INTO public.who_global_data_import VALUES (83523, '2020-11-20', 'SY', 'Syrian Arab Republic', 'EMRO', '72', '6991', '5', '363');
INSERT INTO public.who_global_data_import VALUES (83524, '2020-11-21', 'SY', 'Syrian Arab Republic', 'EMRO', '88', '7079', '5', '368');
INSERT INTO public.who_global_data_import VALUES (83525, '2020-11-22', 'SY', 'Syrian Arab Republic', 'EMRO', '75', '7154', '4', '372');
INSERT INTO public.who_global_data_import VALUES (83526, '2020-11-23', 'SY', 'Syrian Arab Republic', 'EMRO', '71', '7225', '4', '376');
INSERT INTO public.who_global_data_import VALUES (83527, '2020-11-24', 'SY', 'Syrian Arab Republic', 'EMRO', '70', '7295', '4', '380');
INSERT INTO public.who_global_data_import VALUES (83528, '2020-11-25', 'SY', 'Syrian Arab Republic', 'EMRO', '74', '7369', '5', '385');
INSERT INTO public.who_global_data_import VALUES (83529, '2020-11-26', 'SY', 'Syrian Arab Republic', 'EMRO', '90', '7459', '6', '391');
INSERT INTO public.who_global_data_import VALUES (83530, '2020-11-27', 'SY', 'Syrian Arab Republic', 'EMRO', '83', '7542', '8', '399');
INSERT INTO public.who_global_data_import VALUES (83531, '2020-11-28', 'SY', 'Syrian Arab Republic', 'EMRO', '93', '7635', '5', '404');
INSERT INTO public.who_global_data_import VALUES (83532, '2020-11-29', 'SY', 'Syrian Arab Republic', 'EMRO', '80', '7715', '5', '409');
INSERT INTO public.who_global_data_import VALUES (83533, '2020-11-30', 'SY', 'Syrian Arab Republic', 'EMRO', '82', '7797', '4', '413');
INSERT INTO public.who_global_data_import VALUES (83534, '2020-12-01', 'SY', 'Syrian Arab Republic', 'EMRO', '90', '7887', '4', '417');
INSERT INTO public.who_global_data_import VALUES (85256, '2020-02-27', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83535, '2020-12-02', 'SY', 'Syrian Arab Republic', 'EMRO', '86', '7973', '5', '422');
INSERT INTO public.who_global_data_import VALUES (83536, '2020-12-03', 'SY', 'Syrian Arab Republic', 'EMRO', '86', '8059', '4', '426');
INSERT INTO public.who_global_data_import VALUES (83537, '2020-12-04', 'SY', 'Syrian Arab Republic', 'EMRO', '88', '8147', '6', '432');
INSERT INTO public.who_global_data_import VALUES (83538, '2020-12-05', 'SY', 'Syrian Arab Republic', 'EMRO', '86', '8233', '5', '437');
INSERT INTO public.who_global_data_import VALUES (83539, '2020-12-06', 'SY', 'Syrian Arab Republic', 'EMRO', '87', '8320', '5', '442');
INSERT INTO public.who_global_data_import VALUES (83540, '2020-12-07', 'SY', 'Syrian Arab Republic', 'EMRO', '83', '8403', '5', '447');
INSERT INTO public.who_global_data_import VALUES (83541, '2020-12-08', 'SY', 'Syrian Arab Republic', 'EMRO', '87', '8490', '5', '452');
INSERT INTO public.who_global_data_import VALUES (83542, '2020-12-09', 'SY', 'Syrian Arab Republic', 'EMRO', '90', '8580', '6', '458');
INSERT INTO public.who_global_data_import VALUES (83543, '2020-12-10', 'SY', 'Syrian Arab Republic', 'EMRO', '95', '8675', '7', '465');
INSERT INTO public.who_global_data_import VALUES (83544, '2020-12-11', 'SY', 'Syrian Arab Republic', 'EMRO', '112', '8787', '11', '476');
INSERT INTO public.who_global_data_import VALUES (83545, '2020-12-12', 'SY', 'Syrian Arab Republic', 'EMRO', '124', '8911', '15', '491');
INSERT INTO public.who_global_data_import VALUES (83546, '2020-12-13', 'SY', 'Syrian Arab Republic', 'EMRO', '130', '9041', '15', '506');
INSERT INTO public.who_global_data_import VALUES (83547, '2020-12-14', 'SY', 'Syrian Arab Republic', 'EMRO', '125', '9166', '12', '518');
INSERT INTO public.who_global_data_import VALUES (83548, '2020-12-15', 'SY', 'Syrian Arab Republic', 'EMRO', '136', '9302', '12', '530');
INSERT INTO public.who_global_data_import VALUES (83549, '2020-12-16', 'SY', 'Syrian Arab Republic', 'EMRO', '150', '9452', '13', '543');
INSERT INTO public.who_global_data_import VALUES (83550, '2020-12-17', 'SY', 'Syrian Arab Republic', 'EMRO', '151', '9603', '11', '554');
INSERT INTO public.who_global_data_import VALUES (83551, '2020-12-18', 'SY', 'Syrian Arab Republic', 'EMRO', '156', '9759', '17', '571');
INSERT INTO public.who_global_data_import VALUES (83552, '2020-12-19', 'SY', 'Syrian Arab Republic', 'EMRO', '169', '9928', '20', '591');
INSERT INTO public.who_global_data_import VALUES (83553, '2020-12-20', 'SY', 'Syrian Arab Republic', 'EMRO', '122', '10050', '10', '601');
INSERT INTO public.who_global_data_import VALUES (83554, '2020-12-21', 'SY', 'Syrian Arab Republic', 'EMRO', '145', '10195', '9', '610');
INSERT INTO public.who_global_data_import VALUES (83555, '2020-12-22', 'SY', 'Syrian Arab Republic', 'EMRO', '123', '10318', '11', '621');
INSERT INTO public.who_global_data_import VALUES (83556, '2020-12-23', 'SY', 'Syrian Arab Republic', 'EMRO', '124', '10442', '9', '630');
INSERT INTO public.who_global_data_import VALUES (83557, '2020-12-24', 'SY', 'Syrian Arab Republic', 'EMRO', '129', '10571', '11', '641');
INSERT INTO public.who_global_data_import VALUES (83558, '2020-12-25', 'SY', 'Syrian Arab Republic', 'EMRO', '130', '10701', '11', '652');
INSERT INTO public.who_global_data_import VALUES (83559, '2020-12-26', 'SY', 'Syrian Arab Republic', 'EMRO', '120', '10821', '8', '660');
INSERT INTO public.who_global_data_import VALUES (83560, '2020-12-27', 'SY', 'Syrian Arab Republic', 'EMRO', '111', '10932', '9', '669');
INSERT INTO public.who_global_data_import VALUES (83561, '2020-12-28', 'SY', 'Syrian Arab Republic', 'EMRO', '101', '11033', '9', '678');
INSERT INTO public.who_global_data_import VALUES (83562, '2020-12-29', 'SY', 'Syrian Arab Republic', 'EMRO', '105', '11138', '8', '686');
INSERT INTO public.who_global_data_import VALUES (83563, '2020-12-30', 'SY', 'Syrian Arab Republic', 'EMRO', '105', '11243', '10', '696');
INSERT INTO public.who_global_data_import VALUES (83564, '2020-12-31', 'SY', 'Syrian Arab Republic', 'EMRO', '101', '11344', '8', '704');
INSERT INTO public.who_global_data_import VALUES (83565, '2021-01-01', 'SY', 'Syrian Arab Republic', 'EMRO', '90', '11434', '7', '711');
INSERT INTO public.who_global_data_import VALUES (83566, '2021-01-02', 'SY', 'Syrian Arab Republic', 'EMRO', '92', '11526', '6', '717');
INSERT INTO public.who_global_data_import VALUES (83567, '2021-01-03', 'SY', 'Syrian Arab Republic', 'EMRO', '90', '11616', '6', '723');
INSERT INTO public.who_global_data_import VALUES (83568, '2021-01-04', 'SY', 'Syrian Arab Republic', 'EMRO', '94', '11710', '6', '729');
INSERT INTO public.who_global_data_import VALUES (83569, '2021-01-05', 'SY', 'Syrian Arab Republic', 'EMRO', '89', '11799', '5', '734');
INSERT INTO public.who_global_data_import VALUES (83570, '2021-01-06', 'SY', 'Syrian Arab Republic', 'EMRO', '91', '11890', '7', '741');
INSERT INTO public.who_global_data_import VALUES (83571, '2021-01-07', 'SY', 'Syrian Arab Republic', 'EMRO', '98', '11988', '6', '747');
INSERT INTO public.who_global_data_import VALUES (83572, '2021-01-08', 'SY', 'Syrian Arab Republic', 'EMRO', '96', '12084', '8', '755');
INSERT INTO public.who_global_data_import VALUES (83573, '2021-01-09', 'SY', 'Syrian Arab Republic', 'EMRO', '95', '12179', '8', '763');
INSERT INTO public.who_global_data_import VALUES (83574, '2021-01-10', 'SY', 'Syrian Arab Republic', 'EMRO', '95', '12274', '5', '768');
INSERT INTO public.who_global_data_import VALUES (83575, '2021-01-11', 'SY', 'Syrian Arab Republic', 'EMRO', '90', '12364', '6', '774');
INSERT INTO public.who_global_data_import VALUES (83576, '2021-01-12', 'SY', 'Syrian Arab Republic', 'EMRO', '98', '12462', '7', '781');
INSERT INTO public.who_global_data_import VALUES (83577, '2021-01-13', 'SY', 'Syrian Arab Republic', 'EMRO', '96', '12558', '9', '790');
INSERT INTO public.who_global_data_import VALUES (83578, '2021-01-14', 'SY', 'Syrian Arab Republic', 'EMRO', '102', '12660', '9', '799');
INSERT INTO public.who_global_data_import VALUES (83579, '2021-01-15', 'SY', 'Syrian Arab Republic', 'EMRO', '100', '12760', '10', '809');
INSERT INTO public.who_global_data_import VALUES (83580, '2021-01-16', 'SY', 'Syrian Arab Republic', 'EMRO', '90', '12850', '8', '817');
INSERT INTO public.who_global_data_import VALUES (83581, '2021-01-17', 'SY', 'Syrian Arab Republic', 'EMRO', '92', '12942', '7', '824');
INSERT INTO public.who_global_data_import VALUES (83582, '2021-01-18', 'SY', 'Syrian Arab Republic', 'EMRO', '94', '13036', '8', '832');
INSERT INTO public.who_global_data_import VALUES (83583, '2021-01-19', 'SY', 'Syrian Arab Republic', 'EMRO', '96', '13132', '9', '841');
INSERT INTO public.who_global_data_import VALUES (83584, '2021-01-20', 'SY', 'Syrian Arab Republic', 'EMRO', '92', '13224', '9', '850');
INSERT INTO public.who_global_data_import VALUES (83585, '2021-01-21', 'SY', 'Syrian Arab Republic', 'EMRO', '89', '13313', '8', '858');
INSERT INTO public.who_global_data_import VALUES (83586, '2021-01-22', 'SY', 'Syrian Arab Republic', 'EMRO', '85', '13398', '8', '866');
INSERT INTO public.who_global_data_import VALUES (83587, '2021-01-23', 'SY', 'Syrian Arab Republic', 'EMRO', '81', '13479', '7', '873');
INSERT INTO public.who_global_data_import VALUES (83588, '2021-01-24', 'SY', 'Syrian Arab Republic', 'EMRO', '78', '13557', '6', '879');
INSERT INTO public.who_global_data_import VALUES (83589, '2021-01-25', 'SY', 'Syrian Arab Republic', 'EMRO', '71', '13628', '6', '885');
INSERT INTO public.who_global_data_import VALUES (83590, '2021-01-26', 'SY', 'Syrian Arab Republic', 'EMRO', '69', '13697', '5', '890');
INSERT INTO public.who_global_data_import VALUES (83591, '2021-01-27', 'SY', 'Syrian Arab Republic', 'EMRO', '65', '13762', '5', '895');
INSERT INTO public.who_global_data_import VALUES (83592, '2021-01-28', 'SY', 'Syrian Arab Republic', 'EMRO', '61', '13823', '5', '900');
INSERT INTO public.who_global_data_import VALUES (83593, '2021-01-29', 'SY', 'Syrian Arab Republic', 'EMRO', '62', '13885', '6', '906');
INSERT INTO public.who_global_data_import VALUES (83594, '2021-01-30', 'SY', 'Syrian Arab Republic', 'EMRO', '59', '13944', '5', '911');
INSERT INTO public.who_global_data_import VALUES (83595, '2021-01-31', 'SY', 'Syrian Arab Republic', 'EMRO', '54', '13998', '5', '916');
INSERT INTO public.who_global_data_import VALUES (83596, '2021-02-01', 'SY', 'Syrian Arab Republic', 'EMRO', '50', '14048', '5', '921');
INSERT INTO public.who_global_data_import VALUES (83597, '2021-02-02', 'SY', 'Syrian Arab Republic', 'EMRO', '48', '14096', '5', '926');
INSERT INTO public.who_global_data_import VALUES (83598, '2021-02-03', 'SY', 'Syrian Arab Republic', 'EMRO', '46', '14142', '3', '929');
INSERT INTO public.who_global_data_import VALUES (83599, '2021-02-04', 'SY', 'Syrian Arab Republic', 'EMRO', '60', '14202', '4', '933');
INSERT INTO public.who_global_data_import VALUES (83600, '2021-02-05', 'SY', 'Syrian Arab Republic', 'EMRO', '65', '14267', '5', '938');
INSERT INTO public.who_global_data_import VALUES (83601, '2020-01-03', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83602, '2020-01-04', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83603, '2020-01-05', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83604, '2020-01-06', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83605, '2020-01-07', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83606, '2020-01-08', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83607, '2020-01-09', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83608, '2020-01-10', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83609, '2020-01-11', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83610, '2020-01-12', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83611, '2020-01-13', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83612, '2020-01-14', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83613, '2020-01-15', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83614, '2020-01-16', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83615, '2020-01-17', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83616, '2020-01-18', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83617, '2020-01-19', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83618, '2020-01-20', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83619, '2020-01-21', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83620, '2020-01-22', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83621, '2020-01-23', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83622, '2020-01-24', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83623, '2020-01-25', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83624, '2020-01-26', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83625, '2020-01-27', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83626, '2020-01-28', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83627, '2020-01-29', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83628, '2020-01-30', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83629, '2020-01-31', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83630, '2020-02-01', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83631, '2020-02-02', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83632, '2020-02-03', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83633, '2020-02-04', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83634, '2020-02-05', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83635, '2020-02-06', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83636, '2020-02-07', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83637, '2020-02-08', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83638, '2020-02-09', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83639, '2020-02-10', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83640, '2020-02-11', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83641, '2020-02-12', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83642, '2020-02-13', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83643, '2020-02-14', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83644, '2020-02-15', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83645, '2020-02-16', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83646, '2020-02-17', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83647, '2020-02-18', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83648, '2020-02-19', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83649, '2020-02-20', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83650, '2020-02-21', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83651, '2020-02-22', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83652, '2020-02-23', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83653, '2020-02-24', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83654, '2020-02-25', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83655, '2020-02-26', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83656, '2020-02-27', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83657, '2020-02-28', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83658, '2020-02-29', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83659, '2020-03-01', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83660, '2020-03-02', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83661, '2020-03-03', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83662, '2020-03-04', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83663, '2020-03-05', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83664, '2020-03-06', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83665, '2020-03-07', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83666, '2020-03-08', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83667, '2020-03-09', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83668, '2020-03-10', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83669, '2020-03-11', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83670, '2020-03-12', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83671, '2020-03-13', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83672, '2020-03-14', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83673, '2020-03-15', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83674, '2020-03-16', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83675, '2020-03-17', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83676, '2020-03-18', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83677, '2020-03-19', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83678, '2020-03-20', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83679, '2020-03-21', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83680, '2020-03-22', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83681, '2020-03-23', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83682, '2020-03-24', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83683, '2020-03-25', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83684, '2020-03-26', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83685, '2020-03-27', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83686, '2020-03-28', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83687, '2020-03-29', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83688, '2020-03-30', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83689, '2020-03-31', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83690, '2020-04-01', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83691, '2020-04-02', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83692, '2020-04-03', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83693, '2020-04-04', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83694, '2020-04-05', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83695, '2020-04-06', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83696, '2020-04-07', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83697, '2020-04-08', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83698, '2020-04-09', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83699, '2020-04-10', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83700, '2020-04-11', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83701, '2020-04-12', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83702, '2020-04-13', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83703, '2020-04-14', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83704, '2020-04-15', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83705, '2020-04-16', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83706, '2020-04-17', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83707, '2020-04-18', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83708, '2020-04-19', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83709, '2020-04-20', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83710, '2020-04-21', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83711, '2020-04-22', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83712, '2020-04-23', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83713, '2020-04-24', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83714, '2020-04-25', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83715, '2020-04-26', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83716, '2020-04-27', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83717, '2020-04-28', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83718, '2020-04-29', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83719, '2020-04-30', 'TJ', 'Tajikistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83720, '2020-05-01', 'TJ', 'Tajikistan', 'EURO', '15', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83721, '2020-05-02', 'TJ', 'Tajikistan', 'EURO', '17', '32', '0', '0');
INSERT INTO public.who_global_data_import VALUES (83722, '2020-05-03', 'TJ', 'Tajikistan', 'EURO', '44', '76', '2', '2');
INSERT INTO public.who_global_data_import VALUES (83723, '2020-05-04', 'TJ', 'Tajikistan', 'EURO', '52', '128', '2', '4');
INSERT INTO public.who_global_data_import VALUES (83724, '2020-05-05', 'TJ', 'Tajikistan', 'EURO', '102', '230', '3', '7');
INSERT INTO public.who_global_data_import VALUES (83725, '2020-05-06', 'TJ', 'Tajikistan', 'EURO', '63', '293', '0', '7');
INSERT INTO public.who_global_data_import VALUES (83726, '2020-05-07', 'TJ', 'Tajikistan', 'EURO', '86', '379', '2', '9');
INSERT INTO public.who_global_data_import VALUES (83727, '2020-05-08', 'TJ', 'Tajikistan', 'EURO', '82', '461', '7', '16');
INSERT INTO public.who_global_data_import VALUES (83728, '2020-05-09', 'TJ', 'Tajikistan', 'EURO', '61', '522', '2', '18');
INSERT INTO public.who_global_data_import VALUES (83729, '2020-05-10', 'TJ', 'Tajikistan', 'EURO', '39', '561', '1', '19');
INSERT INTO public.who_global_data_import VALUES (83730, '2020-05-11', 'TJ', 'Tajikistan', 'EURO', '51', '612', '1', '20');
INSERT INTO public.who_global_data_import VALUES (83731, '2020-05-12', 'TJ', 'Tajikistan', 'EURO', '49', '661', '1', '21');
INSERT INTO public.who_global_data_import VALUES (83732, '2020-05-13', 'TJ', 'Tajikistan', 'EURO', '68', '729', '2', '23');
INSERT INTO public.who_global_data_import VALUES (83733, '2020-05-14', 'TJ', 'Tajikistan', 'EURO', '178', '907', '9', '32');
INSERT INTO public.who_global_data_import VALUES (83734, '2020-05-15', 'TJ', 'Tajikistan', 'EURO', '178', '1085', '4', '36');
INSERT INTO public.who_global_data_import VALUES (83735, '2020-05-16', 'TJ', 'Tajikistan', 'EURO', '33', '1118', '0', '36');
INSERT INTO public.who_global_data_import VALUES (83736, '2020-05-17', 'TJ', 'Tajikistan', 'EURO', '204', '1322', '3', '39');
INSERT INTO public.who_global_data_import VALUES (83737, '2020-05-18', 'TJ', 'Tajikistan', 'EURO', '0', '1322', '0', '39');
INSERT INTO public.who_global_data_import VALUES (83738, '2020-05-19', 'TJ', 'Tajikistan', 'EURO', '407', '1729', '5', '44');
INSERT INTO public.who_global_data_import VALUES (83739, '2020-05-20', 'TJ', 'Tajikistan', 'EURO', '207', '1936', '0', '44');
INSERT INTO public.who_global_data_import VALUES (83740, '2020-05-21', 'TJ', 'Tajikistan', 'EURO', '204', '2140', '0', '44');
INSERT INTO public.who_global_data_import VALUES (83741, '2020-05-22', 'TJ', 'Tajikistan', 'EURO', '210', '2350', '0', '44');
INSERT INTO public.who_global_data_import VALUES (83742, '2020-05-23', 'TJ', 'Tajikistan', 'EURO', '201', '2551', '0', '44');
INSERT INTO public.who_global_data_import VALUES (83743, '2020-05-24', 'TJ', 'Tajikistan', 'EURO', '187', '2738', '0', '44');
INSERT INTO public.who_global_data_import VALUES (83744, '2020-05-25', 'TJ', 'Tajikistan', 'EURO', '191', '2929', '2', '46');
INSERT INTO public.who_global_data_import VALUES (83745, '2020-05-26', 'TJ', 'Tajikistan', 'EURO', '171', '3100', '0', '46');
INSERT INTO public.who_global_data_import VALUES (83746, '2020-05-27', 'TJ', 'Tajikistan', 'EURO', '166', '3266', '1', '47');
INSERT INTO public.who_global_data_import VALUES (83747, '2020-05-28', 'TJ', 'Tajikistan', 'EURO', '158', '3424', '0', '47');
INSERT INTO public.who_global_data_import VALUES (83748, '2020-05-29', 'TJ', 'Tajikistan', 'EURO', '139', '3563', '0', '47');
INSERT INTO public.who_global_data_import VALUES (83749, '2020-05-30', 'TJ', 'Tajikistan', 'EURO', '123', '3686', '0', '47');
INSERT INTO public.who_global_data_import VALUES (83750, '2020-05-31', 'TJ', 'Tajikistan', 'EURO', '121', '3807', '0', '47');
INSERT INTO public.who_global_data_import VALUES (83751, '2020-06-01', 'TJ', 'Tajikistan', 'EURO', '123', '3930', '0', '47');
INSERT INTO public.who_global_data_import VALUES (83752, '2020-06-02', 'TJ', 'Tajikistan', 'EURO', '83', '4013', '0', '47');
INSERT INTO public.who_global_data_import VALUES (83753, '2020-06-03', 'TJ', 'Tajikistan', 'EURO', '87', '4100', '0', '47');
INSERT INTO public.who_global_data_import VALUES (83754, '2020-06-04', 'TJ', 'Tajikistan', 'EURO', '91', '4191', '1', '48');
INSERT INTO public.who_global_data_import VALUES (83755, '2020-06-05', 'TJ', 'Tajikistan', 'EURO', '98', '4289', '0', '48');
INSERT INTO public.who_global_data_import VALUES (83756, '2020-06-06', 'TJ', 'Tajikistan', 'EURO', '81', '4370', '0', '48');
INSERT INTO public.who_global_data_import VALUES (83757, '2020-06-07', 'TJ', 'Tajikistan', 'EURO', '83', '4453', '0', '48');
INSERT INTO public.who_global_data_import VALUES (83758, '2020-06-08', 'TJ', 'Tajikistan', 'EURO', '76', '4529', '0', '48');
INSERT INTO public.who_global_data_import VALUES (83759, '2020-06-09', 'TJ', 'Tajikistan', 'EURO', '80', '4609', '0', '48');
INSERT INTO public.who_global_data_import VALUES (83760, '2020-06-10', 'TJ', 'Tajikistan', 'EURO', '81', '4690', '0', '48');
INSERT INTO public.who_global_data_import VALUES (83761, '2020-06-11', 'TJ', 'Tajikistan', 'EURO', '73', '4763', '0', '48');
INSERT INTO public.who_global_data_import VALUES (83762, '2020-06-12', 'TJ', 'Tajikistan', 'EURO', '71', '4834', '1', '49');
INSERT INTO public.who_global_data_import VALUES (83763, '2020-06-13', 'TJ', 'Tajikistan', 'EURO', '68', '4902', '0', '49');
INSERT INTO public.who_global_data_import VALUES (83764, '2020-06-14', 'TJ', 'Tajikistan', 'EURO', '69', '4971', '1', '50');
INSERT INTO public.who_global_data_import VALUES (83765, '2020-06-15', 'TJ', 'Tajikistan', 'EURO', '64', '5035', '0', '50');
INSERT INTO public.who_global_data_import VALUES (83766, '2020-06-16', 'TJ', 'Tajikistan', 'EURO', '62', '5097', '0', '50');
INSERT INTO public.who_global_data_import VALUES (83767, '2020-06-17', 'TJ', 'Tajikistan', 'EURO', '63', '5160', '0', '50');
INSERT INTO public.who_global_data_import VALUES (83768, '2020-06-18', 'TJ', 'Tajikistan', 'EURO', '61', '5221', '1', '51');
INSERT INTO public.who_global_data_import VALUES (83769, '2020-06-19', 'TJ', 'Tajikistan', 'EURO', '58', '5279', '0', '51');
INSERT INTO public.who_global_data_import VALUES (83770, '2020-06-20', 'TJ', 'Tajikistan', 'EURO', '59', '5338', '0', '51');
INSERT INTO public.who_global_data_import VALUES (83771, '2020-06-21', 'TJ', 'Tajikistan', 'EURO', '61', '5399', '1', '52');
INSERT INTO public.who_global_data_import VALUES (83772, '2020-06-22', 'TJ', 'Tajikistan', 'EURO', '58', '5457', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83773, '2020-06-23', 'TJ', 'Tajikistan', 'EURO', '56', '5513', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83774, '2020-06-24', 'TJ', 'Tajikistan', 'EURO', '54', '5567', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83775, '2020-06-25', 'TJ', 'Tajikistan', 'EURO', '63', '5630', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83776, '2020-06-26', 'TJ', 'Tajikistan', 'EURO', '61', '5691', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83777, '2020-06-27', 'TJ', 'Tajikistan', 'EURO', '56', '5747', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83778, '2020-06-28', 'TJ', 'Tajikistan', 'EURO', '52', '5799', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83779, '2020-06-29', 'TJ', 'Tajikistan', 'EURO', '50', '5849', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83780, '2020-06-30', 'TJ', 'Tajikistan', 'EURO', '51', '5900', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83781, '2020-07-01', 'TJ', 'Tajikistan', 'EURO', '54', '5954', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83782, '2020-07-02', 'TJ', 'Tajikistan', 'EURO', '51', '6005', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83783, '2020-07-03', 'TJ', 'Tajikistan', 'EURO', '0', '6005', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83784, '2020-07-04', 'TJ', 'Tajikistan', 'EURO', '53', '6058', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83785, '2020-07-05', 'TJ', 'Tajikistan', 'EURO', '101', '6159', '0', '52');
INSERT INTO public.who_global_data_import VALUES (83786, '2020-07-06', 'TJ', 'Tajikistan', 'EURO', '54', '6213', '1', '53');
INSERT INTO public.who_global_data_import VALUES (83787, '2020-07-07', 'TJ', 'Tajikistan', 'EURO', '49', '6262', '0', '53');
INSERT INTO public.who_global_data_import VALUES (83788, '2020-07-08', 'TJ', 'Tajikistan', 'EURO', '53', '6315', '0', '53');
INSERT INTO public.who_global_data_import VALUES (83789, '2020-07-09', 'TJ', 'Tajikistan', 'EURO', '48', '6363', '1', '54');
INSERT INTO public.who_global_data_import VALUES (83790, '2020-07-10', 'TJ', 'Tajikistan', 'EURO', '46', '6409', '0', '54');
INSERT INTO public.who_global_data_import VALUES (83791, '2020-07-11', 'TJ', 'Tajikistan', 'EURO', '47', '6456', '1', '55');
INSERT INTO public.who_global_data_import VALUES (83792, '2020-07-12', 'TJ', 'Tajikistan', 'EURO', '49', '6505', '0', '55');
INSERT INTO public.who_global_data_import VALUES (83793, '2020-07-13', 'TJ', 'Tajikistan', 'EURO', '46', '6551', '0', '55');
INSERT INTO public.who_global_data_import VALUES (83794, '2020-07-14', 'TJ', 'Tajikistan', 'EURO', '44', '6595', '0', '55');
INSERT INTO public.who_global_data_import VALUES (83795, '2020-07-15', 'TJ', 'Tajikistan', 'EURO', '48', '6643', '1', '56');
INSERT INTO public.who_global_data_import VALUES (83796, '2020-07-16', 'TJ', 'Tajikistan', 'EURO', '52', '6695', '0', '56');
INSERT INTO public.who_global_data_import VALUES (83797, '2020-07-17', 'TJ', 'Tajikistan', 'EURO', '46', '6741', '0', '56');
INSERT INTO public.who_global_data_import VALUES (83798, '2020-07-18', 'TJ', 'Tajikistan', 'EURO', '45', '6786', '0', '56');
INSERT INTO public.who_global_data_import VALUES (83799, '2020-07-19', 'TJ', 'Tajikistan', 'EURO', '48', '6834', '1', '57');
INSERT INTO public.who_global_data_import VALUES (83800, '2020-07-20', 'TJ', 'Tajikistan', 'EURO', '44', '6878', '0', '57');
INSERT INTO public.who_global_data_import VALUES (83801, '2020-07-21', 'TJ', 'Tajikistan', 'EURO', '43', '6921', '0', '57');
INSERT INTO public.who_global_data_import VALUES (83802, '2020-07-22', 'TJ', 'Tajikistan', 'EURO', '46', '6967', '0', '57');
INSERT INTO public.who_global_data_import VALUES (83803, '2020-07-23', 'TJ', 'Tajikistan', 'EURO', '48', '7015', '1', '58');
INSERT INTO public.who_global_data_import VALUES (83804, '2020-07-24', 'TJ', 'Tajikistan', 'EURO', '45', '7060', '0', '58');
INSERT INTO public.who_global_data_import VALUES (83805, '2020-07-25', 'TJ', 'Tajikistan', 'EURO', '44', '7104', '0', '58');
INSERT INTO public.who_global_data_import VALUES (83806, '2020-07-26', 'TJ', 'Tajikistan', 'EURO', '46', '7150', '1', '59');
INSERT INTO public.who_global_data_import VALUES (83807, '2020-07-27', 'TJ', 'Tajikistan', 'EURO', '42', '7192', '0', '59');
INSERT INTO public.who_global_data_import VALUES (83808, '2020-07-28', 'TJ', 'Tajikistan', 'EURO', '43', '7235', '1', '60');
INSERT INTO public.who_global_data_import VALUES (83809, '2020-07-29', 'TJ', 'Tajikistan', 'EURO', '41', '7276', '0', '60');
INSERT INTO public.who_global_data_import VALUES (83810, '2020-07-30', 'TJ', 'Tajikistan', 'EURO', '44', '7320', '0', '60');
INSERT INTO public.who_global_data_import VALUES (83811, '2020-07-31', 'TJ', 'Tajikistan', 'EURO', '46', '7366', '0', '60');
INSERT INTO public.who_global_data_import VALUES (83812, '2020-08-01', 'TJ', 'Tajikistan', 'EURO', '43', '7409', '0', '60');
INSERT INTO public.who_global_data_import VALUES (83813, '2020-08-02', 'TJ', 'Tajikistan', 'EURO', '42', '7451', '0', '60');
INSERT INTO public.who_global_data_import VALUES (83814, '2020-08-03', 'TJ', 'Tajikistan', 'EURO', '44', '7495', '1', '61');
INSERT INTO public.who_global_data_import VALUES (83815, '2020-08-04', 'TJ', 'Tajikistan', 'EURO', '43', '7538', '0', '61');
INSERT INTO public.who_global_data_import VALUES (83816, '2020-08-05', 'TJ', 'Tajikistan', 'EURO', '45', '7583', '0', '61');
INSERT INTO public.who_global_data_import VALUES (83817, '2020-08-06', 'TJ', 'Tajikistan', 'EURO', '42', '7625', '0', '61');
INSERT INTO public.who_global_data_import VALUES (83818, '2020-08-07', 'TJ', 'Tajikistan', 'EURO', '40', '7665', '1', '62');
INSERT INTO public.who_global_data_import VALUES (83819, '2020-08-08', 'TJ', 'Tajikistan', 'EURO', '41', '7706', '0', '62');
INSERT INTO public.who_global_data_import VALUES (83820, '2020-08-09', 'TJ', 'Tajikistan', 'EURO', '39', '7745', '0', '62');
INSERT INTO public.who_global_data_import VALUES (83821, '2020-08-10', 'TJ', 'Tajikistan', 'EURO', '40', '7785', '0', '62');
INSERT INTO public.who_global_data_import VALUES (83822, '2020-08-11', 'TJ', 'Tajikistan', 'EURO', '42', '7827', '0', '62');
INSERT INTO public.who_global_data_import VALUES (83823, '2020-08-12', 'TJ', 'Tajikistan', 'EURO', '44', '7871', '1', '63');
INSERT INTO public.who_global_data_import VALUES (83824, '2020-08-13', 'TJ', 'Tajikistan', 'EURO', '41', '7912', '0', '63');
INSERT INTO public.who_global_data_import VALUES (83825, '2020-08-14', 'TJ', 'Tajikistan', 'EURO', '38', '7950', '0', '63');
INSERT INTO public.who_global_data_import VALUES (83826, '2020-08-15', 'TJ', 'Tajikistan', 'EURO', '39', '7989', '0', '63');
INSERT INTO public.who_global_data_import VALUES (83827, '2020-08-16', 'TJ', 'Tajikistan', 'EURO', '40', '8029', '1', '64');
INSERT INTO public.who_global_data_import VALUES (83828, '2020-08-17', 'TJ', 'Tajikistan', 'EURO', '36', '8065', '0', '64');
INSERT INTO public.who_global_data_import VALUES (83829, '2020-08-18', 'TJ', 'Tajikistan', 'EURO', '34', '8099', '0', '64');
INSERT INTO public.who_global_data_import VALUES (83830, '2020-08-19', 'TJ', 'Tajikistan', 'EURO', '32', '8131', '1', '65');
INSERT INTO public.who_global_data_import VALUES (83831, '2020-08-20', 'TJ', 'Tajikistan', 'EURO', '35', '8166', '0', '65');
INSERT INTO public.who_global_data_import VALUES (83832, '2020-08-21', 'TJ', 'Tajikistan', 'EURO', '37', '8203', '1', '66');
INSERT INTO public.who_global_data_import VALUES (83833, '2020-08-22', 'TJ', 'Tajikistan', 'EURO', '38', '8241', '0', '66');
INSERT INTO public.who_global_data_import VALUES (83834, '2020-08-23', 'TJ', 'Tajikistan', 'EURO', '36', '8277', '0', '66');
INSERT INTO public.who_global_data_import VALUES (83835, '2020-08-24', 'TJ', 'Tajikistan', 'EURO', '34', '8311', '0', '66');
INSERT INTO public.who_global_data_import VALUES (83836, '2020-08-25', 'TJ', 'Tajikistan', 'EURO', '35', '8346', '1', '67');
INSERT INTO public.who_global_data_import VALUES (83837, '2020-08-26', 'TJ', 'Tajikistan', 'EURO', '33', '8379', '0', '67');
INSERT INTO public.who_global_data_import VALUES (83838, '2020-08-27', 'TJ', 'Tajikistan', 'EURO', '34', '8413', '0', '67');
INSERT INTO public.who_global_data_import VALUES (83839, '2020-08-28', 'TJ', 'Tajikistan', 'EURO', '36', '8449', '1', '68');
INSERT INTO public.who_global_data_import VALUES (83840, '2020-08-29', 'TJ', 'Tajikistan', 'EURO', '32', '8481', '0', '68');
INSERT INTO public.who_global_data_import VALUES (83841, '2020-08-30', 'TJ', 'Tajikistan', 'EURO', '35', '8516', '0', '68');
INSERT INTO public.who_global_data_import VALUES (83842, '2020-08-31', 'TJ', 'Tajikistan', 'EURO', '34', '8550', '0', '68');
INSERT INTO public.who_global_data_import VALUES (83843, '2020-09-01', 'TJ', 'Tajikistan', 'EURO', '33', '8583', '0', '68');
INSERT INTO public.who_global_data_import VALUES (83844, '2020-09-02', 'TJ', 'Tajikistan', 'EURO', '36', '8619', '1', '69');
INSERT INTO public.who_global_data_import VALUES (83845, '2020-09-03', 'TJ', 'Tajikistan', 'EURO', '35', '8654', '0', '69');
INSERT INTO public.who_global_data_import VALUES (83846, '2020-09-04', 'TJ', 'Tajikistan', 'EURO', '36', '8690', '0', '69');
INSERT INTO public.who_global_data_import VALUES (83847, '2020-09-05', 'TJ', 'Tajikistan', 'EURO', '34', '8724', '0', '69');
INSERT INTO public.who_global_data_import VALUES (83848, '2020-09-06', 'TJ', 'Tajikistan', 'EURO', '33', '8757', '1', '70');
INSERT INTO public.who_global_data_import VALUES (83849, '2020-09-07', 'TJ', 'Tajikistan', 'EURO', '35', '8792', '0', '70');
INSERT INTO public.who_global_data_import VALUES (83850, '2020-09-08', 'TJ', 'Tajikistan', 'EURO', '32', '8824', '0', '70');
INSERT INTO public.who_global_data_import VALUES (83851, '2020-09-09', 'TJ', 'Tajikistan', 'EURO', '36', '8860', '0', '70');
INSERT INTO public.who_global_data_import VALUES (83852, '2020-09-10', 'TJ', 'Tajikistan', 'EURO', '39', '8899', '1', '71');
INSERT INTO public.who_global_data_import VALUES (83853, '2020-09-11', 'TJ', 'Tajikistan', 'EURO', '40', '8939', '1', '72');
INSERT INTO public.who_global_data_import VALUES (83854, '2020-09-12', 'TJ', 'Tajikistan', 'EURO', '38', '8977', '0', '72');
INSERT INTO public.who_global_data_import VALUES (83855, '2020-09-13', 'TJ', 'Tajikistan', 'EURO', '37', '9014', '0', '72');
INSERT INTO public.who_global_data_import VALUES (83856, '2020-09-14', 'TJ', 'Tajikistan', 'EURO', '35', '9049', '0', '72');
INSERT INTO public.who_global_data_import VALUES (83857, '2020-09-15', 'TJ', 'Tajikistan', 'EURO', '39', '9088', '0', '72');
INSERT INTO public.who_global_data_import VALUES (83858, '2020-09-16', 'TJ', 'Tajikistan', 'EURO', '41', '9129', '1', '73');
INSERT INTO public.who_global_data_import VALUES (83859, '2020-09-17', 'TJ', 'Tajikistan', 'EURO', '42', '9171', '0', '73');
INSERT INTO public.who_global_data_import VALUES (83860, '2020-09-18', 'TJ', 'Tajikistan', 'EURO', '43', '9214', '0', '73');
INSERT INTO public.who_global_data_import VALUES (83861, '2020-09-19', 'TJ', 'Tajikistan', 'EURO', '45', '9259', '0', '73');
INSERT INTO public.who_global_data_import VALUES (83862, '2020-09-20', 'TJ', 'Tajikistan', 'EURO', '44', '9303', '0', '73');
INSERT INTO public.who_global_data_import VALUES (83863, '2020-09-21', 'TJ', 'Tajikistan', 'EURO', '43', '9346', '0', '73');
INSERT INTO public.who_global_data_import VALUES (83864, '2020-09-22', 'TJ', 'Tajikistan', 'EURO', '42', '9388', '0', '73');
INSERT INTO public.who_global_data_import VALUES (83865, '2020-09-23', 'TJ', 'Tajikistan', 'EURO', '44', '9432', '0', '73');
INSERT INTO public.who_global_data_import VALUES (83866, '2020-09-24', 'TJ', 'Tajikistan', 'EURO', '43', '9475', '1', '74');
INSERT INTO public.who_global_data_import VALUES (83867, '2020-09-25', 'TJ', 'Tajikistan', 'EURO', '45', '9520', '0', '74');
INSERT INTO public.who_global_data_import VALUES (83868, '2020-09-26', 'TJ', 'Tajikistan', 'EURO', '42', '9562', '0', '74');
INSERT INTO public.who_global_data_import VALUES (83869, '2020-09-27', 'TJ', 'Tajikistan', 'EURO', '43', '9605', '1', '75');
INSERT INTO public.who_global_data_import VALUES (83870, '2020-09-28', 'TJ', 'Tajikistan', 'EURO', '41', '9646', '0', '75');
INSERT INTO public.who_global_data_import VALUES (83871, '2020-09-29', 'TJ', 'Tajikistan', 'EURO', '39', '9685', '0', '75');
INSERT INTO public.who_global_data_import VALUES (83872, '2020-09-30', 'TJ', 'Tajikistan', 'EURO', '41', '9726', '0', '75');
INSERT INTO public.who_global_data_import VALUES (83873, '2020-10-01', 'TJ', 'Tajikistan', 'EURO', '43', '9769', '1', '76');
INSERT INTO public.who_global_data_import VALUES (83874, '2020-10-02', 'TJ', 'Tajikistan', 'EURO', '42', '9811', '1', '77');
INSERT INTO public.who_global_data_import VALUES (83875, '2020-10-03', 'TJ', 'Tajikistan', 'EURO', '41', '9852', '0', '77');
INSERT INTO public.who_global_data_import VALUES (83876, '2020-10-04', 'TJ', 'Tajikistan', 'EURO', '43', '9895', '0', '77');
INSERT INTO public.who_global_data_import VALUES (83877, '2020-10-05', 'TJ', 'Tajikistan', 'EURO', '40', '9935', '1', '78');
INSERT INTO public.who_global_data_import VALUES (83878, '2020-10-06', 'TJ', 'Tajikistan', 'EURO', '39', '9974', '0', '78');
INSERT INTO public.who_global_data_import VALUES (83879, '2020-10-07', 'TJ', 'Tajikistan', 'EURO', '40', '10014', '0', '78');
INSERT INTO public.who_global_data_import VALUES (83880, '2020-10-08', 'TJ', 'Tajikistan', 'EURO', '41', '10055', '0', '78');
INSERT INTO public.who_global_data_import VALUES (83881, '2020-10-09', 'TJ', 'Tajikistan', 'EURO', '42', '10097', '0', '78');
INSERT INTO public.who_global_data_import VALUES (83882, '2020-10-10', 'TJ', 'Tajikistan', 'EURO', '40', '10137', '1', '79');
INSERT INTO public.who_global_data_import VALUES (83883, '2020-10-11', 'TJ', 'Tajikistan', 'EURO', '43', '10180', '0', '79');
INSERT INTO public.who_global_data_import VALUES (83884, '2020-10-12', 'TJ', 'Tajikistan', 'EURO', '42', '10222', '0', '79');
INSERT INTO public.who_global_data_import VALUES (83885, '2020-10-13', 'TJ', 'Tajikistan', 'EURO', '38', '10260', '0', '79');
INSERT INTO public.who_global_data_import VALUES (83886, '2020-10-14', 'TJ', 'Tajikistan', 'EURO', '37', '10297', '0', '79');
INSERT INTO public.who_global_data_import VALUES (83887, '2020-10-15', 'TJ', 'Tajikistan', 'EURO', '39', '10336', '0', '79');
INSERT INTO public.who_global_data_import VALUES (83888, '2020-10-16', 'TJ', 'Tajikistan', 'EURO', '38', '10374', '1', '80');
INSERT INTO public.who_global_data_import VALUES (83889, '2020-10-17', 'TJ', 'Tajikistan', 'EURO', '40', '10414', '0', '80');
INSERT INTO public.who_global_data_import VALUES (83890, '2020-10-18', 'TJ', 'Tajikistan', 'EURO', '41', '10455', '0', '80');
INSERT INTO public.who_global_data_import VALUES (83891, '2020-10-19', 'TJ', 'Tajikistan', 'EURO', '38', '10493', '0', '80');
INSERT INTO public.who_global_data_import VALUES (83892, '2020-10-20', 'TJ', 'Tajikistan', 'EURO', '40', '10533', '0', '80');
INSERT INTO public.who_global_data_import VALUES (83893, '2020-10-21', 'TJ', 'Tajikistan', 'EURO', '41', '10574', '0', '80');
INSERT INTO public.who_global_data_import VALUES (83894, '2020-10-22', 'TJ', 'Tajikistan', 'EURO', '39', '10613', '0', '80');
INSERT INTO public.who_global_data_import VALUES (83895, '2020-10-23', 'TJ', 'Tajikistan', 'EURO', '40', '10653', '1', '81');
INSERT INTO public.who_global_data_import VALUES (83896, '2020-10-24', 'TJ', 'Tajikistan', 'EURO', '42', '10695', '0', '81');
INSERT INTO public.who_global_data_import VALUES (83897, '2020-10-25', 'TJ', 'Tajikistan', 'EURO', '41', '10736', '0', '81');
INSERT INTO public.who_global_data_import VALUES (83898, '2020-10-26', 'TJ', 'Tajikistan', 'EURO', '40', '10776', '0', '81');
INSERT INTO public.who_global_data_import VALUES (83899, '2020-10-27', 'TJ', 'Tajikistan', 'EURO', '43', '10819', '0', '81');
INSERT INTO public.who_global_data_import VALUES (83900, '2020-10-28', 'TJ', 'Tajikistan', 'EURO', '41', '10860', '0', '81');
INSERT INTO public.who_global_data_import VALUES (83901, '2020-10-29', 'TJ', 'Tajikistan', 'EURO', '40', '10900', '1', '82');
INSERT INTO public.who_global_data_import VALUES (83902, '2020-10-30', 'TJ', 'Tajikistan', 'EURO', '39', '10939', '0', '82');
INSERT INTO public.who_global_data_import VALUES (83903, '2020-10-31', 'TJ', 'Tajikistan', 'EURO', '38', '10977', '0', '82');
INSERT INTO public.who_global_data_import VALUES (83904, '2020-11-01', 'TJ', 'Tajikistan', 'EURO', '40', '11017', '0', '82');
INSERT INTO public.who_global_data_import VALUES (83905, '2020-11-02', 'TJ', 'Tajikistan', 'EURO', '37', '11054', '0', '82');
INSERT INTO public.who_global_data_import VALUES (83906, '2020-11-03', 'TJ', 'Tajikistan', 'EURO', '42', '11096', '0', '82');
INSERT INTO public.who_global_data_import VALUES (83907, '2020-11-04', 'TJ', 'Tajikistan', 'EURO', '43', '11139', '1', '83');
INSERT INTO public.who_global_data_import VALUES (83908, '2020-11-05', 'TJ', 'Tajikistan', 'EURO', '41', '11180', '0', '83');
INSERT INTO public.who_global_data_import VALUES (83909, '2020-11-06', 'TJ', 'Tajikistan', 'EURO', '39', '11219', '0', '83');
INSERT INTO public.who_global_data_import VALUES (83910, '2020-11-07', 'TJ', 'Tajikistan', 'EURO', '37', '11256', '0', '83');
INSERT INTO public.who_global_data_import VALUES (83911, '2020-11-08', 'TJ', 'Tajikistan', 'EURO', '38', '11294', '0', '83');
INSERT INTO public.who_global_data_import VALUES (83912, '2020-11-09', 'TJ', 'Tajikistan', 'EURO', '42', '11336', '0', '83');
INSERT INTO public.who_global_data_import VALUES (83913, '2020-11-10', 'TJ', 'Tajikistan', 'EURO', '40', '11376', '0', '83');
INSERT INTO public.who_global_data_import VALUES (83914, '2020-11-11', 'TJ', 'Tajikistan', 'EURO', '41', '11417', '1', '84');
INSERT INTO public.who_global_data_import VALUES (83915, '2020-11-12', 'TJ', 'Tajikistan', 'EURO', '39', '11456', '0', '84');
INSERT INTO public.who_global_data_import VALUES (83916, '2020-11-13', 'TJ', 'Tajikistan', 'EURO', '40', '11496', '0', '84');
INSERT INTO public.who_global_data_import VALUES (83917, '2020-11-14', 'TJ', 'Tajikistan', 'EURO', '38', '11534', '1', '85');
INSERT INTO public.who_global_data_import VALUES (83918, '2020-11-15', 'TJ', 'Tajikistan', 'EURO', '39', '11573', '0', '85');
INSERT INTO public.who_global_data_import VALUES (83919, '2020-11-16', 'TJ', 'Tajikistan', 'EURO', '37', '11610', '0', '85');
INSERT INTO public.who_global_data_import VALUES (83920, '2020-11-17', 'TJ', 'Tajikistan', 'EURO', '39', '11649', '0', '85');
INSERT INTO public.who_global_data_import VALUES (83921, '2020-11-18', 'TJ', 'Tajikistan', 'EURO', '40', '11689', '0', '85');
INSERT INTO public.who_global_data_import VALUES (83922, '2020-11-19', 'TJ', 'Tajikistan', 'EURO', '42', '11731', '1', '86');
INSERT INTO public.who_global_data_import VALUES (83923, '2020-11-20', 'TJ', 'Tajikistan', 'EURO', '41', '11772', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83924, '2020-11-21', 'TJ', 'Tajikistan', 'EURO', '43', '11815', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83925, '2020-11-22', 'TJ', 'Tajikistan', 'EURO', '39', '11854', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83926, '2020-11-23', 'TJ', 'Tajikistan', 'EURO', '40', '11894', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83927, '2020-11-24', 'TJ', 'Tajikistan', 'EURO', '38', '11932', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83928, '2020-11-25', 'TJ', 'Tajikistan', 'EURO', '39', '11971', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83929, '2020-11-26', 'TJ', 'Tajikistan', 'EURO', '37', '12008', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83930, '2020-11-27', 'TJ', 'Tajikistan', 'EURO', '36', '12044', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83931, '2020-11-28', 'TJ', 'Tajikistan', 'EURO', '38', '12082', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83932, '2020-11-29', 'TJ', 'Tajikistan', 'EURO', '36', '12118', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83933, '2020-11-30', 'TJ', 'Tajikistan', 'EURO', '37', '12155', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83934, '2020-12-01', 'TJ', 'Tajikistan', 'EURO', '39', '12194', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83935, '2020-12-02', 'TJ', 'Tajikistan', 'EURO', '37', '12231', '0', '86');
INSERT INTO public.who_global_data_import VALUES (83936, '2020-12-03', 'TJ', 'Tajikistan', 'EURO', '38', '12269', '1', '87');
INSERT INTO public.who_global_data_import VALUES (83937, '2020-12-04', 'TJ', 'Tajikistan', 'EURO', '39', '12308', '0', '87');
INSERT INTO public.who_global_data_import VALUES (83938, '2020-12-05', 'TJ', 'Tajikistan', 'EURO', '41', '12349', '0', '87');
INSERT INTO public.who_global_data_import VALUES (83939, '2020-12-06', 'TJ', 'Tajikistan', 'EURO', '40', '12389', '0', '87');
INSERT INTO public.who_global_data_import VALUES (83940, '2020-12-07', 'TJ', 'Tajikistan', 'EURO', '67', '12456', '0', '87');
INSERT INTO public.who_global_data_import VALUES (83941, '2020-12-08', 'TJ', 'Tajikistan', 'EURO', '58', '12514', '0', '87');
INSERT INTO public.who_global_data_import VALUES (83942, '2020-12-09', 'TJ', 'Tajikistan', 'EURO', '78', '12592', '0', '87');
INSERT INTO public.who_global_data_import VALUES (83943, '2020-12-10', 'TJ', 'Tajikistan', 'EURO', '66', '12658', '0', '87');
INSERT INTO public.who_global_data_import VALUES (83944, '2020-12-11', 'TJ', 'Tajikistan', 'EURO', '64', '12722', '0', '87');
INSERT INTO public.who_global_data_import VALUES (83945, '2020-12-12', 'TJ', 'Tajikistan', 'EURO', '76', '12798', '0', '87');
INSERT INTO public.who_global_data_import VALUES (83946, '2020-12-13', 'TJ', 'Tajikistan', 'EURO', '59', '12857', '0', '87');
INSERT INTO public.who_global_data_import VALUES (83947, '2020-12-14', 'TJ', 'Tajikistan', 'EURO', '56', '12913', '0', '87');
INSERT INTO public.who_global_data_import VALUES (83948, '2020-12-15', 'TJ', 'Tajikistan', 'EURO', '47', '12960', '0', '87');
INSERT INTO public.who_global_data_import VALUES (83949, '2020-12-16', 'TJ', 'Tajikistan', 'EURO', '57', '13017', '2', '89');
INSERT INTO public.who_global_data_import VALUES (83950, '2020-12-17', 'TJ', 'Tajikistan', 'EURO', '55', '13072', '0', '89');
INSERT INTO public.who_global_data_import VALUES (83951, '2020-12-18', 'TJ', 'Tajikistan', 'EURO', '64', '13136', '0', '89');
INSERT INTO public.who_global_data_import VALUES (83952, '2020-12-19', 'TJ', 'Tajikistan', 'EURO', '46', '13182', '0', '89');
INSERT INTO public.who_global_data_import VALUES (83953, '2020-12-20', 'TJ', 'Tajikistan', 'EURO', '57', '13239', '0', '89');
INSERT INTO public.who_global_data_import VALUES (83954, '2020-12-21', 'TJ', 'Tajikistan', 'EURO', '41', '13280', '0', '89');
INSERT INTO public.who_global_data_import VALUES (83955, '2020-12-22', 'TJ', 'Tajikistan', 'EURO', '56', '13336', '0', '89');
INSERT INTO public.who_global_data_import VALUES (83956, '2020-12-23', 'TJ', 'Tajikistan', 'EURO', '52', '13388', '0', '89');
INSERT INTO public.who_global_data_import VALUES (83957, '2020-12-24', 'TJ', 'Tajikistan', 'EURO', '51', '13439', '0', '89');
INSERT INTO public.who_global_data_import VALUES (83958, '2020-12-25', 'TJ', 'Tajikistan', 'EURO', '36', '13475', '0', '89');
INSERT INTO public.who_global_data_import VALUES (83959, '2020-12-26', 'TJ', 'Tajikistan', 'EURO', '43', '13518', '1', '90');
INSERT INTO public.who_global_data_import VALUES (83960, '2020-12-27', 'TJ', 'Tajikistan', 'EURO', '37', '13555', '0', '90');
INSERT INTO public.who_global_data_import VALUES (83961, '2020-12-28', 'TJ', 'Tajikistan', 'EURO', '36', '13591', '0', '90');
INSERT INTO public.who_global_data_import VALUES (83962, '2020-12-29', 'TJ', 'Tajikistan', 'EURO', '34', '13625', '0', '90');
INSERT INTO public.who_global_data_import VALUES (83963, '2020-12-30', 'TJ', 'Tajikistan', 'EURO', '37', '13662', '0', '90');
INSERT INTO public.who_global_data_import VALUES (83964, '2020-12-31', 'TJ', 'Tajikistan', 'EURO', '3', '13665', '0', '90');
INSERT INTO public.who_global_data_import VALUES (83965, '2021-01-01', 'TJ', 'Tajikistan', 'EURO', '0', '13665', '0', '90');
INSERT INTO public.who_global_data_import VALUES (83966, '2021-01-02', 'TJ', 'Tajikistan', 'EURO', '6', '13671', '1', '91');
INSERT INTO public.who_global_data_import VALUES (83967, '2021-01-03', 'TJ', 'Tajikistan', 'EURO', '3', '13674', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83968, '2021-01-04', 'TJ', 'Tajikistan', 'EURO', '2', '13676', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83969, '2021-01-05', 'TJ', 'Tajikistan', 'EURO', '10', '13686', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83970, '2021-01-06', 'TJ', 'Tajikistan', 'EURO', '9', '13695', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83971, '2021-01-07', 'TJ', 'Tajikistan', 'EURO', '6', '13701', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83972, '2021-01-08', 'TJ', 'Tajikistan', 'EURO', '4', '13705', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83973, '2021-01-09', 'TJ', 'Tajikistan', 'EURO', '1', '13706', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83974, '2021-01-10', 'TJ', 'Tajikistan', 'EURO', '1', '13707', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83975, '2021-01-11', 'TJ', 'Tajikistan', 'EURO', '1', '13708', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83976, '2021-01-12', 'TJ', 'Tajikistan', 'EURO', '1', '13709', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83977, '2021-01-13', 'TJ', 'Tajikistan', 'EURO', '1', '13710', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83978, '2021-01-14', 'TJ', 'Tajikistan', 'EURO', '1', '13711', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83979, '2021-01-15', 'TJ', 'Tajikistan', 'EURO', '0', '13711', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83980, '2021-01-16', 'TJ', 'Tajikistan', 'EURO', '0', '13711', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83981, '2021-01-17', 'TJ', 'Tajikistan', 'EURO', '3', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83982, '2021-01-18', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83983, '2021-01-19', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83984, '2021-01-20', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83985, '2021-01-21', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83986, '2021-01-22', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83987, '2021-01-23', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83988, '2021-01-24', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83989, '2021-01-25', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83990, '2021-01-26', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83991, '2021-01-27', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83992, '2021-01-28', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83993, '2021-01-29', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83994, '2021-01-30', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83995, '2021-01-31', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83996, '2021-02-01', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83997, '2021-02-02', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83998, '2021-02-03', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (83999, '2021-02-04', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (84000, '2021-02-05', 'TJ', 'Tajikistan', 'EURO', '0', '13714', '0', '91');
INSERT INTO public.who_global_data_import VALUES (84001, '2020-01-03', 'TH', 'Thailand', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84002, '2020-01-04', 'TH', 'Thailand', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84003, '2020-01-05', 'TH', 'Thailand', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84004, '2020-01-06', 'TH', 'Thailand', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84005, '2020-01-07', 'TH', 'Thailand', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84006, '2020-01-08', 'TH', 'Thailand', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84007, '2020-01-09', 'TH', 'Thailand', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84008, '2020-01-10', 'TH', 'Thailand', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84009, '2020-01-11', 'TH', 'Thailand', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84010, '2020-01-12', 'TH', 'Thailand', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84011, '2020-01-13', 'TH', 'Thailand', 'SEARO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84012, '2020-01-14', 'TH', 'Thailand', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84013, '2020-01-15', 'TH', 'Thailand', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84014, '2020-01-16', 'TH', 'Thailand', 'SEARO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84015, '2020-01-17', 'TH', 'Thailand', 'SEARO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84016, '2020-01-18', 'TH', 'Thailand', 'SEARO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84017, '2020-01-19', 'TH', 'Thailand', 'SEARO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84018, '2020-01-20', 'TH', 'Thailand', 'SEARO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84019, '2020-01-21', 'TH', 'Thailand', 'SEARO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84020, '2020-01-22', 'TH', 'Thailand', 'SEARO', '2', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84021, '2020-01-23', 'TH', 'Thailand', 'SEARO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84022, '2020-01-24', 'TH', 'Thailand', 'SEARO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84023, '2020-01-25', 'TH', 'Thailand', 'SEARO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84024, '2020-01-26', 'TH', 'Thailand', 'SEARO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84025, '2020-01-27', 'TH', 'Thailand', 'SEARO', '3', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84026, '2020-01-28', 'TH', 'Thailand', 'SEARO', '6', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84027, '2020-01-29', 'TH', 'Thailand', 'SEARO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84028, '2020-01-30', 'TH', 'Thailand', 'SEARO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84029, '2020-01-31', 'TH', 'Thailand', 'SEARO', '5', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84030, '2020-02-01', 'TH', 'Thailand', 'SEARO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84031, '2020-02-02', 'TH', 'Thailand', 'SEARO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84032, '2020-02-03', 'TH', 'Thailand', 'SEARO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84033, '2020-02-04', 'TH', 'Thailand', 'SEARO', '6', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84034, '2020-02-05', 'TH', 'Thailand', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84035, '2020-02-06', 'TH', 'Thailand', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84036, '2020-02-07', 'TH', 'Thailand', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84037, '2020-02-08', 'TH', 'Thailand', 'SEARO', '7', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84038, '2020-02-09', 'TH', 'Thailand', 'SEARO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84039, '2020-02-10', 'TH', 'Thailand', 'SEARO', '0', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84040, '2020-02-11', 'TH', 'Thailand', 'SEARO', '1', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84041, '2020-02-12', 'TH', 'Thailand', 'SEARO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84042, '2020-02-13', 'TH', 'Thailand', 'SEARO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84043, '2020-02-14', 'TH', 'Thailand', 'SEARO', '0', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84044, '2020-02-15', 'TH', 'Thailand', 'SEARO', '1', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84045, '2020-02-16', 'TH', 'Thailand', 'SEARO', '0', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84046, '2020-02-17', 'TH', 'Thailand', 'SEARO', '1', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84047, '2020-02-18', 'TH', 'Thailand', 'SEARO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84048, '2020-02-19', 'TH', 'Thailand', 'SEARO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84049, '2020-02-20', 'TH', 'Thailand', 'SEARO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84050, '2020-02-21', 'TH', 'Thailand', 'SEARO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84051, '2020-02-22', 'TH', 'Thailand', 'SEARO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84052, '2020-02-23', 'TH', 'Thailand', 'SEARO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84053, '2020-02-24', 'TH', 'Thailand', 'SEARO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84054, '2020-02-25', 'TH', 'Thailand', 'SEARO', '2', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84055, '2020-02-26', 'TH', 'Thailand', 'SEARO', '3', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84056, '2020-02-27', 'TH', 'Thailand', 'SEARO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84057, '2020-02-28', 'TH', 'Thailand', 'SEARO', '1', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84058, '2020-02-29', 'TH', 'Thailand', 'SEARO', '1', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84059, '2020-03-01', 'TH', 'Thailand', 'SEARO', '0', '46', '1', '1');
INSERT INTO public.who_global_data_import VALUES (84060, '2020-03-02', 'TH', 'Thailand', 'SEARO', '1', '47', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84061, '2020-03-03', 'TH', 'Thailand', 'SEARO', '0', '47', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84062, '2020-03-04', 'TH', 'Thailand', 'SEARO', '0', '47', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84063, '2020-03-05', 'TH', 'Thailand', 'SEARO', '4', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84064, '2020-03-06', 'TH', 'Thailand', 'SEARO', '1', '52', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84065, '2020-03-07', 'TH', 'Thailand', 'SEARO', '2', '54', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84066, '2020-03-08', 'TH', 'Thailand', 'SEARO', '0', '54', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84067, '2020-03-09', 'TH', 'Thailand', 'SEARO', '0', '54', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84068, '2020-03-10', 'TH', 'Thailand', 'SEARO', '3', '57', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84069, '2020-03-11', 'TH', 'Thailand', 'SEARO', '6', '63', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84070, '2020-03-12', 'TH', 'Thailand', 'SEARO', '11', '74', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84071, '2020-03-13', 'TH', 'Thailand', 'SEARO', '5', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84072, '2020-03-14', 'TH', 'Thailand', 'SEARO', '0', '79', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84073, '2020-03-15', 'TH', 'Thailand', 'SEARO', '39', '118', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84074, '2020-03-16', 'TH', 'Thailand', 'SEARO', '33', '151', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84075, '2020-03-17', 'TH', 'Thailand', 'SEARO', '30', '181', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84076, '2020-03-18', 'TH', 'Thailand', 'SEARO', '35', '216', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84077, '2020-03-19', 'TH', 'Thailand', 'SEARO', '106', '322', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84078, '2020-03-20', 'TH', 'Thailand', 'SEARO', '0', '322', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84079, '2020-03-21', 'TH', 'Thailand', 'SEARO', '89', '411', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84080, '2020-03-22', 'TH', 'Thailand', 'SEARO', '188', '599', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84081, '2020-03-23', 'TH', 'Thailand', 'SEARO', '122', '721', '0', '1');
INSERT INTO public.who_global_data_import VALUES (84082, '2020-03-24', 'TH', 'Thailand', 'SEARO', '106', '827', '3', '4');
INSERT INTO public.who_global_data_import VALUES (84083, '2020-03-25', 'TH', 'Thailand', 'SEARO', '107', '934', '0', '4');
INSERT INTO public.who_global_data_import VALUES (84084, '2020-03-26', 'TH', 'Thailand', 'SEARO', '111', '1045', '0', '4');
INSERT INTO public.who_global_data_import VALUES (84085, '2020-03-27', 'TH', 'Thailand', 'SEARO', '91', '1136', '1', '5');
INSERT INTO public.who_global_data_import VALUES (84086, '2020-03-28', 'TH', 'Thailand', 'SEARO', '0', '1136', '0', '5');
INSERT INTO public.who_global_data_import VALUES (84087, '2020-03-29', 'TH', 'Thailand', 'SEARO', '252', '1388', '2', '7');
INSERT INTO public.who_global_data_import VALUES (84088, '2020-03-30', 'TH', 'Thailand', 'SEARO', '136', '1524', '2', '9');
INSERT INTO public.who_global_data_import VALUES (84089, '2020-03-31', 'TH', 'Thailand', 'SEARO', '127', '1651', '1', '10');
INSERT INTO public.who_global_data_import VALUES (84090, '2020-04-01', 'TH', 'Thailand', 'SEARO', '120', '1771', '2', '12');
INSERT INTO public.who_global_data_import VALUES (84091, '2020-04-02', 'TH', 'Thailand', 'SEARO', '104', '1875', '3', '15');
INSERT INTO public.who_global_data_import VALUES (84092, '2020-04-03', 'TH', 'Thailand', 'SEARO', '103', '1978', '4', '19');
INSERT INTO public.who_global_data_import VALUES (84093, '2020-04-04', 'TH', 'Thailand', 'SEARO', '89', '2067', '1', '20');
INSERT INTO public.who_global_data_import VALUES (84094, '2020-04-05', 'TH', 'Thailand', 'SEARO', '102', '2169', '3', '23');
INSERT INTO public.who_global_data_import VALUES (84095, '2020-04-06', 'TH', 'Thailand', 'SEARO', '51', '2220', '3', '26');
INSERT INTO public.who_global_data_import VALUES (84096, '2020-04-07', 'TH', 'Thailand', 'SEARO', '38', '2258', '1', '27');
INSERT INTO public.who_global_data_import VALUES (84097, '2020-04-08', 'TH', 'Thailand', 'SEARO', '111', '2369', '3', '30');
INSERT INTO public.who_global_data_import VALUES (84098, '2020-04-09', 'TH', 'Thailand', 'SEARO', '54', '2423', '2', '32');
INSERT INTO public.who_global_data_import VALUES (84099, '2020-04-10', 'TH', 'Thailand', 'SEARO', '50', '2473', '1', '33');
INSERT INTO public.who_global_data_import VALUES (84100, '2020-04-11', 'TH', 'Thailand', 'SEARO', '45', '2518', '2', '35');
INSERT INTO public.who_global_data_import VALUES (84101, '2020-04-12', 'TH', 'Thailand', 'SEARO', '33', '2551', '3', '38');
INSERT INTO public.who_global_data_import VALUES (84102, '2020-04-13', 'TH', 'Thailand', 'SEARO', '28', '2579', '2', '40');
INSERT INTO public.who_global_data_import VALUES (84103, '2020-04-14', 'TH', 'Thailand', 'SEARO', '34', '2613', '1', '41');
INSERT INTO public.who_global_data_import VALUES (84104, '2020-04-15', 'TH', 'Thailand', 'SEARO', '30', '2643', '2', '43');
INSERT INTO public.who_global_data_import VALUES (84105, '2020-04-16', 'TH', 'Thailand', 'SEARO', '29', '2672', '3', '46');
INSERT INTO public.who_global_data_import VALUES (84106, '2020-04-17', 'TH', 'Thailand', 'SEARO', '28', '2700', '1', '47');
INSERT INTO public.who_global_data_import VALUES (84107, '2020-04-18', 'TH', 'Thailand', 'SEARO', '33', '2733', '0', '47');
INSERT INTO public.who_global_data_import VALUES (84108, '2020-04-19', 'TH', 'Thailand', 'SEARO', '32', '2765', '0', '47');
INSERT INTO public.who_global_data_import VALUES (84109, '2020-04-20', 'TH', 'Thailand', 'SEARO', '27', '2792', '0', '47');
INSERT INTO public.who_global_data_import VALUES (84110, '2020-04-21', 'TH', 'Thailand', 'SEARO', '19', '2811', '1', '48');
INSERT INTO public.who_global_data_import VALUES (84111, '2020-04-22', 'TH', 'Thailand', 'SEARO', '15', '2826', '1', '49');
INSERT INTO public.who_global_data_import VALUES (84112, '2020-04-23', 'TH', 'Thailand', 'SEARO', '13', '2839', '1', '50');
INSERT INTO public.who_global_data_import VALUES (84113, '2020-04-24', 'TH', 'Thailand', 'SEARO', '15', '2854', '0', '50');
INSERT INTO public.who_global_data_import VALUES (84114, '2020-04-25', 'TH', 'Thailand', 'SEARO', '53', '2907', '1', '51');
INSERT INTO public.who_global_data_import VALUES (84115, '2020-04-26', 'TH', 'Thailand', 'SEARO', '15', '2922', '0', '51');
INSERT INTO public.who_global_data_import VALUES (84116, '2020-04-27', 'TH', 'Thailand', 'SEARO', '9', '2931', '1', '52');
INSERT INTO public.who_global_data_import VALUES (84117, '2020-04-28', 'TH', 'Thailand', 'SEARO', '7', '2938', '2', '54');
INSERT INTO public.who_global_data_import VALUES (84118, '2020-04-29', 'TH', 'Thailand', 'SEARO', '9', '2947', '0', '54');
INSERT INTO public.who_global_data_import VALUES (84119, '2020-04-30', 'TH', 'Thailand', 'SEARO', '7', '2954', '0', '54');
INSERT INTO public.who_global_data_import VALUES (84120, '2020-05-01', 'TH', 'Thailand', 'SEARO', '6', '2960', '0', '54');
INSERT INTO public.who_global_data_import VALUES (84121, '2020-05-02', 'TH', 'Thailand', 'SEARO', '6', '2966', '0', '54');
INSERT INTO public.who_global_data_import VALUES (84122, '2020-05-03', 'TH', 'Thailand', 'SEARO', '3', '2969', '0', '54');
INSERT INTO public.who_global_data_import VALUES (84123, '2020-05-04', 'TH', 'Thailand', 'SEARO', '18', '2987', '0', '54');
INSERT INTO public.who_global_data_import VALUES (84124, '2020-05-05', 'TH', 'Thailand', 'SEARO', '1', '2988', '0', '54');
INSERT INTO public.who_global_data_import VALUES (84125, '2020-05-06', 'TH', 'Thailand', 'SEARO', '1', '2989', '1', '55');
INSERT INTO public.who_global_data_import VALUES (84126, '2020-05-07', 'TH', 'Thailand', 'SEARO', '3', '2992', '0', '55');
INSERT INTO public.who_global_data_import VALUES (84127, '2020-05-08', 'TH', 'Thailand', 'SEARO', '8', '3000', '0', '55');
INSERT INTO public.who_global_data_import VALUES (84128, '2020-05-09', 'TH', 'Thailand', 'SEARO', '4', '3004', '1', '56');
INSERT INTO public.who_global_data_import VALUES (84129, '2020-05-10', 'TH', 'Thailand', 'SEARO', '5', '3009', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84130, '2020-05-11', 'TH', 'Thailand', 'SEARO', '6', '3015', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84131, '2020-05-12', 'TH', 'Thailand', 'SEARO', '2', '3017', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84132, '2020-05-13', 'TH', 'Thailand', 'SEARO', '0', '3017', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84133, '2020-05-14', 'TH', 'Thailand', 'SEARO', '1', '3018', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84134, '2020-05-15', 'TH', 'Thailand', 'SEARO', '7', '3025', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84135, '2020-05-16', 'TH', 'Thailand', 'SEARO', '0', '3025', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84136, '2020-05-17', 'TH', 'Thailand', 'SEARO', '3', '3028', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84137, '2020-05-18', 'TH', 'Thailand', 'SEARO', '3', '3031', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84138, '2020-05-19', 'TH', 'Thailand', 'SEARO', '2', '3033', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84139, '2020-05-20', 'TH', 'Thailand', 'SEARO', '1', '3034', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84140, '2020-05-21', 'TH', 'Thailand', 'SEARO', '3', '3037', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84141, '2020-05-22', 'TH', 'Thailand', 'SEARO', '0', '3037', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84142, '2020-05-23', 'TH', 'Thailand', 'SEARO', '3', '3040', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84143, '2020-05-24', 'TH', 'Thailand', 'SEARO', '0', '3040', '0', '56');
INSERT INTO public.who_global_data_import VALUES (84144, '2020-05-25', 'TH', 'Thailand', 'SEARO', '2', '3042', '1', '57');
INSERT INTO public.who_global_data_import VALUES (84145, '2020-05-26', 'TH', 'Thailand', 'SEARO', '3', '3045', '0', '57');
INSERT INTO public.who_global_data_import VALUES (84146, '2020-05-27', 'TH', 'Thailand', 'SEARO', '9', '3054', '0', '57');
INSERT INTO public.who_global_data_import VALUES (84147, '2020-05-28', 'TH', 'Thailand', 'SEARO', '11', '3065', '0', '57');
INSERT INTO public.who_global_data_import VALUES (84148, '2020-05-29', 'TH', 'Thailand', 'SEARO', '11', '3076', '0', '57');
INSERT INTO public.who_global_data_import VALUES (84149, '2020-05-30', 'TH', 'Thailand', 'SEARO', '1', '3077', '0', '57');
INSERT INTO public.who_global_data_import VALUES (84150, '2020-05-31', 'TH', 'Thailand', 'SEARO', '4', '3081', '0', '57');
INSERT INTO public.who_global_data_import VALUES (84151, '2020-06-01', 'TH', 'Thailand', 'SEARO', '1', '3082', '0', '57');
INSERT INTO public.who_global_data_import VALUES (84152, '2020-06-02', 'TH', 'Thailand', 'SEARO', '1', '3083', '1', '58');
INSERT INTO public.who_global_data_import VALUES (84153, '2020-06-03', 'TH', 'Thailand', 'SEARO', '1', '3084', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84154, '2020-06-04', 'TH', 'Thailand', 'SEARO', '17', '3101', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84155, '2020-06-05', 'TH', 'Thailand', 'SEARO', '1', '3102', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84156, '2020-06-06', 'TH', 'Thailand', 'SEARO', '2', '3104', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84157, '2020-06-07', 'TH', 'Thailand', 'SEARO', '8', '3112', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84158, '2020-06-08', 'TH', 'Thailand', 'SEARO', '7', '3119', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84159, '2020-06-09', 'TH', 'Thailand', 'SEARO', '2', '3121', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84160, '2020-06-10', 'TH', 'Thailand', 'SEARO', '4', '3125', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84161, '2020-06-11', 'TH', 'Thailand', 'SEARO', '0', '3125', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84162, '2020-06-12', 'TH', 'Thailand', 'SEARO', '4', '3129', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84163, '2020-06-13', 'TH', 'Thailand', 'SEARO', '5', '3134', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84164, '2020-06-14', 'TH', 'Thailand', 'SEARO', '1', '3135', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84165, '2020-06-15', 'TH', 'Thailand', 'SEARO', '0', '3135', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84166, '2020-06-16', 'TH', 'Thailand', 'SEARO', '0', '3135', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84167, '2020-06-17', 'TH', 'Thailand', 'SEARO', '0', '3135', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84168, '2020-06-18', 'TH', 'Thailand', 'SEARO', '6', '3141', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84169, '2020-06-19', 'TH', 'Thailand', 'SEARO', '5', '3146', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84170, '2020-06-20', 'TH', 'Thailand', 'SEARO', '1', '3147', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84171, '2020-06-21', 'TH', 'Thailand', 'SEARO', '1', '3148', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84172, '2020-06-22', 'TH', 'Thailand', 'SEARO', '3', '3151', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84173, '2020-06-23', 'TH', 'Thailand', 'SEARO', '5', '3156', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84174, '2020-06-24', 'TH', 'Thailand', 'SEARO', '1', '3157', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84175, '2020-06-25', 'TH', 'Thailand', 'SEARO', '1', '3158', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84176, '2020-06-26', 'TH', 'Thailand', 'SEARO', '4', '3162', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84177, '2020-06-27', 'TH', 'Thailand', 'SEARO', '0', '3162', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84178, '2020-06-28', 'TH', 'Thailand', 'SEARO', '0', '3162', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84179, '2020-06-29', 'TH', 'Thailand', 'SEARO', '7', '3169', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84180, '2020-06-30', 'TH', 'Thailand', 'SEARO', '2', '3171', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84181, '2020-07-01', 'TH', 'Thailand', 'SEARO', '2', '3173', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84182, '2020-07-02', 'TH', 'Thailand', 'SEARO', '6', '3179', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84183, '2020-07-03', 'TH', 'Thailand', 'SEARO', '1', '3180', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84184, '2020-07-04', 'TH', 'Thailand', 'SEARO', '5', '3185', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84185, '2020-07-05', 'TH', 'Thailand', 'SEARO', '5', '3190', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84186, '2020-07-06', 'TH', 'Thailand', 'SEARO', '5', '3195', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84187, '2020-07-07', 'TH', 'Thailand', 'SEARO', '0', '3195', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84188, '2020-07-08', 'TH', 'Thailand', 'SEARO', '2', '3197', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84189, '2020-07-09', 'TH', 'Thailand', 'SEARO', '5', '3202', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84190, '2020-07-10', 'TH', 'Thailand', 'SEARO', '0', '3202', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84191, '2020-07-11', 'TH', 'Thailand', 'SEARO', '14', '3216', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84192, '2020-07-12', 'TH', 'Thailand', 'SEARO', '1', '3217', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84193, '2020-07-13', 'TH', 'Thailand', 'SEARO', '3', '3220', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84194, '2020-07-14', 'TH', 'Thailand', 'SEARO', '7', '3227', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84195, '2020-07-15', 'TH', 'Thailand', 'SEARO', '5', '3232', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84196, '2020-07-16', 'TH', 'Thailand', 'SEARO', '4', '3236', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84197, '2020-07-17', 'TH', 'Thailand', 'SEARO', '3', '3239', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84198, '2020-07-18', 'TH', 'Thailand', 'SEARO', '7', '3246', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84199, '2020-07-19', 'TH', 'Thailand', 'SEARO', '3', '3249', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84200, '2020-07-20', 'TH', 'Thailand', 'SEARO', '1', '3250', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84201, '2020-07-21', 'TH', 'Thailand', 'SEARO', '5', '3255', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84202, '2020-07-22', 'TH', 'Thailand', 'SEARO', '6', '3261', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84203, '2020-07-23', 'TH', 'Thailand', 'SEARO', '8', '3269', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84204, '2020-07-24', 'TH', 'Thailand', 'SEARO', '10', '3279', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84205, '2020-07-25', 'TH', 'Thailand', 'SEARO', '3', '3282', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84206, '2020-07-26', 'TH', 'Thailand', 'SEARO', '9', '3291', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84207, '2020-07-27', 'TH', 'Thailand', 'SEARO', '4', '3295', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84208, '2020-07-28', 'TH', 'Thailand', 'SEARO', '2', '3297', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84209, '2020-07-29', 'TH', 'Thailand', 'SEARO', '1', '3298', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84210, '2020-07-30', 'TH', 'Thailand', 'SEARO', '6', '3304', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84211, '2020-07-31', 'TH', 'Thailand', 'SEARO', '6', '3310', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84212, '2020-08-01', 'TH', 'Thailand', 'SEARO', '2', '3312', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84213, '2020-08-02', 'TH', 'Thailand', 'SEARO', '5', '3317', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84214, '2020-08-03', 'TH', 'Thailand', 'SEARO', '3', '3320', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84215, '2020-08-04', 'TH', 'Thailand', 'SEARO', '1', '3321', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84216, '2020-08-05', 'TH', 'Thailand', 'SEARO', '7', '3328', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84217, '2020-08-06', 'TH', 'Thailand', 'SEARO', '2', '3330', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84218, '2020-08-07', 'TH', 'Thailand', 'SEARO', '15', '3345', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84219, '2020-08-08', 'TH', 'Thailand', 'SEARO', '3', '3348', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84220, '2020-08-09', 'TH', 'Thailand', 'SEARO', '3', '3351', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84221, '2020-08-10', 'TH', 'Thailand', 'SEARO', '0', '3351', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84222, '2020-08-11', 'TH', 'Thailand', 'SEARO', '0', '3351', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84223, '2020-08-12', 'TH', 'Thailand', 'SEARO', '5', '3356', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84224, '2020-08-13', 'TH', 'Thailand', 'SEARO', '3', '3359', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84225, '2020-08-14', 'TH', 'Thailand', 'SEARO', '17', '3376', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84226, '2020-08-15', 'TH', 'Thailand', 'SEARO', '0', '3376', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84227, '2020-08-16', 'TH', 'Thailand', 'SEARO', '1', '3377', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84228, '2020-08-17', 'TH', 'Thailand', 'SEARO', '1', '3378', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84229, '2020-08-18', 'TH', 'Thailand', 'SEARO', '3', '3381', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84230, '2020-08-19', 'TH', 'Thailand', 'SEARO', '1', '3382', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84231, '2020-08-20', 'TH', 'Thailand', 'SEARO', '7', '3389', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84232, '2020-08-21', 'TH', 'Thailand', 'SEARO', '1', '3390', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84233, '2020-08-22', 'TH', 'Thailand', 'SEARO', '0', '3390', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84234, '2020-08-23', 'TH', 'Thailand', 'SEARO', '5', '3395', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84235, '2020-08-24', 'TH', 'Thailand', 'SEARO', '2', '3397', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84236, '2020-08-25', 'TH', 'Thailand', 'SEARO', '5', '3402', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84237, '2020-08-26', 'TH', 'Thailand', 'SEARO', '0', '3402', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84238, '2020-08-27', 'TH', 'Thailand', 'SEARO', '2', '3404', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84239, '2020-08-28', 'TH', 'Thailand', 'SEARO', '6', '3410', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84240, '2020-08-29', 'TH', 'Thailand', 'SEARO', '1', '3411', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84241, '2020-08-30', 'TH', 'Thailand', 'SEARO', '0', '3411', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84242, '2020-08-31', 'TH', 'Thailand', 'SEARO', '1', '3412', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84243, '2020-09-01', 'TH', 'Thailand', 'SEARO', '5', '3417', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84244, '2020-09-02', 'TH', 'Thailand', 'SEARO', '8', '3425', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84245, '2020-09-03', 'TH', 'Thailand', 'SEARO', '2', '3427', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84246, '2020-09-04', 'TH', 'Thailand', 'SEARO', '4', '3431', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84247, '2020-09-05', 'TH', 'Thailand', 'SEARO', '7', '3438', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84248, '2020-09-06', 'TH', 'Thailand', 'SEARO', '6', '3444', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84249, '2020-09-07', 'TH', 'Thailand', 'SEARO', '1', '3445', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84250, '2020-09-08', 'TH', 'Thailand', 'SEARO', '1', '3446', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84251, '2020-09-09', 'TH', 'Thailand', 'SEARO', '1', '3447', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84252, '2020-09-10', 'TH', 'Thailand', 'SEARO', '7', '3454', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84253, '2020-09-11', 'TH', 'Thailand', 'SEARO', '7', '3461', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84254, '2020-09-12', 'TH', 'Thailand', 'SEARO', '5', '3466', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84255, '2020-09-13', 'TH', 'Thailand', 'SEARO', '7', '3473', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84256, '2020-09-14', 'TH', 'Thailand', 'SEARO', '2', '3475', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84257, '2020-09-15', 'TH', 'Thailand', 'SEARO', '5', '3480', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84258, '2020-09-16', 'TH', 'Thailand', 'SEARO', '10', '3490', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84259, '2020-09-17', 'TH', 'Thailand', 'SEARO', '0', '3490', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84260, '2020-09-18', 'TH', 'Thailand', 'SEARO', '7', '3497', '0', '58');
INSERT INTO public.who_global_data_import VALUES (84261, '2020-09-19', 'TH', 'Thailand', 'SEARO', '3', '3500', '1', '59');
INSERT INTO public.who_global_data_import VALUES (84262, '2020-09-20', 'TH', 'Thailand', 'SEARO', '6', '3506', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84263, '2020-09-21', 'TH', 'Thailand', 'SEARO', '0', '3506', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84264, '2020-09-22', 'TH', 'Thailand', 'SEARO', '5', '3511', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84265, '2020-09-23', 'TH', 'Thailand', 'SEARO', '3', '3514', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84266, '2020-09-24', 'TH', 'Thailand', 'SEARO', '2', '3516', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84267, '2020-09-25', 'TH', 'Thailand', 'SEARO', '3', '3519', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84268, '2020-09-26', 'TH', 'Thailand', 'SEARO', '3', '3522', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84269, '2020-09-27', 'TH', 'Thailand', 'SEARO', '1', '3523', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84270, '2020-09-28', 'TH', 'Thailand', 'SEARO', '22', '3545', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84271, '2020-09-29', 'TH', 'Thailand', 'SEARO', '14', '3559', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84272, '2020-09-30', 'TH', 'Thailand', 'SEARO', '5', '3564', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84273, '2020-10-01', 'TH', 'Thailand', 'SEARO', '5', '3569', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84274, '2020-10-02', 'TH', 'Thailand', 'SEARO', '6', '3575', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84275, '2020-10-03', 'TH', 'Thailand', 'SEARO', '8', '3583', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84276, '2020-10-04', 'TH', 'Thailand', 'SEARO', '2', '3585', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84277, '2020-10-05', 'TH', 'Thailand', 'SEARO', '5', '3590', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84278, '2020-10-06', 'TH', 'Thailand', 'SEARO', '10', '3600', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84279, '2020-10-07', 'TH', 'Thailand', 'SEARO', '15', '3615', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84280, '2020-10-08', 'TH', 'Thailand', 'SEARO', '7', '3622', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84281, '2020-10-09', 'TH', 'Thailand', 'SEARO', '6', '3628', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84282, '2020-10-10', 'TH', 'Thailand', 'SEARO', '6', '3634', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84283, '2020-10-11', 'TH', 'Thailand', 'SEARO', '2', '3636', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84284, '2020-10-12', 'TH', 'Thailand', 'SEARO', '5', '3641', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84285, '2020-10-13', 'TH', 'Thailand', 'SEARO', '2', '3643', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84286, '2020-10-14', 'TH', 'Thailand', 'SEARO', '9', '3652', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84287, '2020-10-15', 'TH', 'Thailand', 'SEARO', '13', '3665', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84288, '2020-10-16', 'TH', 'Thailand', 'SEARO', '4', '3669', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84289, '2020-10-17', 'TH', 'Thailand', 'SEARO', '10', '3679', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84290, '2020-10-18', 'TH', 'Thailand', 'SEARO', '7', '3686', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84291, '2020-10-19', 'TH', 'Thailand', 'SEARO', '5', '3691', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84292, '2020-10-20', 'TH', 'Thailand', 'SEARO', '9', '3700', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84293, '2020-10-21', 'TH', 'Thailand', 'SEARO', '9', '3709', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84294, '2020-10-22', 'TH', 'Thailand', 'SEARO', '10', '3719', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84295, '2020-10-23', 'TH', 'Thailand', 'SEARO', '8', '3727', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84296, '2020-10-24', 'TH', 'Thailand', 'SEARO', '4', '3731', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84297, '2020-10-25', 'TH', 'Thailand', 'SEARO', '5', '3736', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84298, '2020-10-26', 'TH', 'Thailand', 'SEARO', '7', '3743', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84299, '2020-10-27', 'TH', 'Thailand', 'SEARO', '3', '3746', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84300, '2020-10-28', 'TH', 'Thailand', 'SEARO', '13', '3759', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84301, '2020-10-29', 'TH', 'Thailand', 'SEARO', '4', '3763', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84302, '2020-10-30', 'TH', 'Thailand', 'SEARO', '12', '3775', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84303, '2020-10-31', 'TH', 'Thailand', 'SEARO', '5', '3780', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84304, '2020-11-01', 'TH', 'Thailand', 'SEARO', '4', '3784', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84305, '2020-11-02', 'TH', 'Thailand', 'SEARO', '3', '3787', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84306, '2020-11-03', 'TH', 'Thailand', 'SEARO', '10', '3797', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84307, '2020-11-04', 'TH', 'Thailand', 'SEARO', '7', '3804', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84308, '2020-11-05', 'TH', 'Thailand', 'SEARO', '6', '3810', '0', '59');
INSERT INTO public.who_global_data_import VALUES (84309, '2020-11-06', 'TH', 'Thailand', 'SEARO', '8', '3818', '1', '60');
INSERT INTO public.who_global_data_import VALUES (84310, '2020-11-07', 'TH', 'Thailand', 'SEARO', '12', '3830', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84311, '2020-11-08', 'TH', 'Thailand', 'SEARO', '7', '3837', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84312, '2020-11-09', 'TH', 'Thailand', 'SEARO', '3', '3840', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84313, '2020-11-10', 'TH', 'Thailand', 'SEARO', '4', '3844', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84314, '2020-11-11', 'TH', 'Thailand', 'SEARO', '3', '3847', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84315, '2020-11-12', 'TH', 'Thailand', 'SEARO', '5', '3852', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84316, '2020-11-13', 'TH', 'Thailand', 'SEARO', '9', '3861', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84317, '2020-11-14', 'TH', 'Thailand', 'SEARO', '0', '3861', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84318, '2020-11-15', 'TH', 'Thailand', 'SEARO', '5', '3866', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84319, '2020-11-16', 'TH', 'Thailand', 'SEARO', '9', '3875', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84320, '2020-11-17', 'TH', 'Thailand', 'SEARO', '3', '3878', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84321, '2020-11-18', 'TH', 'Thailand', 'SEARO', '2', '3880', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84322, '2020-11-19', 'TH', 'Thailand', 'SEARO', '8', '3888', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84323, '2020-11-20', 'TH', 'Thailand', 'SEARO', '4', '3892', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84324, '2020-11-21', 'TH', 'Thailand', 'SEARO', '10', '3902', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84325, '2020-11-22', 'TH', 'Thailand', 'SEARO', '11', '3913', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84326, '2020-11-23', 'TH', 'Thailand', 'SEARO', '7', '3920', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84327, '2020-11-24', 'TH', 'Thailand', 'SEARO', '2', '3922', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84328, '2020-11-25', 'TH', 'Thailand', 'SEARO', '4', '3926', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84329, '2020-11-26', 'TH', 'Thailand', 'SEARO', '16', '3942', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84330, '2020-11-27', 'TH', 'Thailand', 'SEARO', '19', '3961', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84331, '2020-11-28', 'TH', 'Thailand', 'SEARO', '5', '3966', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84332, '2020-11-29', 'TH', 'Thailand', 'SEARO', '0', '3966', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84333, '2020-11-30', 'TH', 'Thailand', 'SEARO', '11', '3977', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84334, '2020-12-01', 'TH', 'Thailand', 'SEARO', '21', '3998', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84335, '2020-12-02', 'TH', 'Thailand', 'SEARO', '10', '4008', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84336, '2020-12-03', 'TH', 'Thailand', 'SEARO', '18', '4026', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84337, '2020-12-04', 'TH', 'Thailand', 'SEARO', '13', '4039', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84338, '2020-12-05', 'TH', 'Thailand', 'SEARO', '14', '4053', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84339, '2020-12-06', 'TH', 'Thailand', 'SEARO', '19', '4072', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84340, '2020-12-07', 'TH', 'Thailand', 'SEARO', '14', '4086', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84341, '2020-12-08', 'TH', 'Thailand', 'SEARO', '21', '4107', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84342, '2020-12-09', 'TH', 'Thailand', 'SEARO', '19', '4126', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84343, '2020-12-10', 'TH', 'Thailand', 'SEARO', '25', '4151', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84344, '2020-12-11', 'TH', 'Thailand', 'SEARO', '18', '4169', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84345, '2020-12-12', 'TH', 'Thailand', 'SEARO', '11', '4180', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84346, '2020-12-13', 'TH', 'Thailand', 'SEARO', '12', '4192', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84347, '2020-12-14', 'TH', 'Thailand', 'SEARO', '17', '4209', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84348, '2020-12-15', 'TH', 'Thailand', 'SEARO', '28', '4237', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84349, '2020-12-16', 'TH', 'Thailand', 'SEARO', '9', '4246', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84350, '2020-12-17', 'TH', 'Thailand', 'SEARO', '15', '4261', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84351, '2020-12-18', 'TH', 'Thailand', 'SEARO', '20', '4281', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84352, '2020-12-19', 'TH', 'Thailand', 'SEARO', '16', '4297', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84353, '2020-12-20', 'TH', 'Thailand', 'SEARO', '34', '4331', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84354, '2020-12-21', 'TH', 'Thailand', 'SEARO', '576', '4907', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84355, '2020-12-22', 'TH', 'Thailand', 'SEARO', '382', '5289', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84356, '2020-12-23', 'TH', 'Thailand', 'SEARO', '473', '5762', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84357, '2020-12-24', 'TH', 'Thailand', 'SEARO', '67', '5829', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84358, '2020-12-25', 'TH', 'Thailand', 'SEARO', '0', '5829', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84359, '2020-12-26', 'TH', 'Thailand', 'SEARO', '81', '5910', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84360, '2020-12-27', 'TH', 'Thailand', 'SEARO', '110', '6020', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84361, '2020-12-28', 'TH', 'Thailand', 'SEARO', '121', '6141', '0', '60');
INSERT INTO public.who_global_data_import VALUES (84362, '2020-12-29', 'TH', 'Thailand', 'SEARO', '299', '6440', '1', '61');
INSERT INTO public.who_global_data_import VALUES (84363, '2020-12-30', 'TH', 'Thailand', 'SEARO', '0', '6440', '0', '61');
INSERT INTO public.who_global_data_import VALUES (84364, '2020-12-31', 'TH', 'Thailand', 'SEARO', '250', '6690', '0', '61');
INSERT INTO public.who_global_data_import VALUES (84365, '2021-01-01', 'TH', 'Thailand', 'SEARO', '194', '6884', '0', '61');
INSERT INTO public.who_global_data_import VALUES (84366, '2021-01-02', 'TH', 'Thailand', 'SEARO', '279', '7163', '2', '63');
INSERT INTO public.who_global_data_import VALUES (84367, '2021-01-03', 'TH', 'Thailand', 'SEARO', '216', '7379', '1', '64');
INSERT INTO public.who_global_data_import VALUES (84368, '2021-01-04', 'TH', 'Thailand', 'SEARO', '1060', '8439', '1', '65');
INSERT INTO public.who_global_data_import VALUES (84369, '2021-01-05', 'TH', 'Thailand', 'SEARO', '527', '8966', '0', '65');
INSERT INTO public.who_global_data_import VALUES (84370, '2021-01-06', 'TH', 'Thailand', 'SEARO', '365', '9331', '1', '66');
INSERT INTO public.who_global_data_import VALUES (84371, '2021-01-07', 'TH', 'Thailand', 'SEARO', '305', '9636', '1', '67');
INSERT INTO public.who_global_data_import VALUES (84372, '2021-01-08', 'TH', 'Thailand', 'SEARO', '205', '9841', '0', '67');
INSERT INTO public.who_global_data_import VALUES (84373, '2021-01-09', 'TH', 'Thailand', 'SEARO', '0', '9841', '0', '67');
INSERT INTO public.who_global_data_import VALUES (84374, '2021-01-10', 'TH', 'Thailand', 'SEARO', '457', '10298', '0', '67');
INSERT INTO public.who_global_data_import VALUES (84375, '2021-01-11', 'TH', 'Thailand', 'SEARO', '249', '10547', '0', '67');
INSERT INTO public.who_global_data_import VALUES (84376, '2021-01-12', 'TH', 'Thailand', 'SEARO', '287', '10834', '0', '67');
INSERT INTO public.who_global_data_import VALUES (84377, '2021-01-13', 'TH', 'Thailand', 'SEARO', '157', '10991', '0', '67');
INSERT INTO public.who_global_data_import VALUES (84378, '2021-01-14', 'TH', 'Thailand', 'SEARO', '271', '11262', '2', '69');
INSERT INTO public.who_global_data_import VALUES (84379, '2021-01-15', 'TH', 'Thailand', 'SEARO', '188', '11450', '0', '69');
INSERT INTO public.who_global_data_import VALUES (84380, '2021-01-16', 'TH', 'Thailand', 'SEARO', '230', '11680', '1', '70');
INSERT INTO public.who_global_data_import VALUES (84381, '2021-01-17', 'TH', 'Thailand', 'SEARO', '374', '12054', '0', '70');
INSERT INTO public.who_global_data_import VALUES (84382, '2021-01-18', 'TH', 'Thailand', 'SEARO', '369', '12423', '0', '70');
INSERT INTO public.who_global_data_import VALUES (84383, '2021-01-19', 'TH', 'Thailand', 'SEARO', '171', '12594', '0', '70');
INSERT INTO public.who_global_data_import VALUES (84384, '2021-01-20', 'TH', 'Thailand', 'SEARO', '59', '12653', '1', '71');
INSERT INTO public.who_global_data_import VALUES (84385, '2021-01-21', 'TH', 'Thailand', 'SEARO', '142', '12795', '0', '71');
INSERT INTO public.who_global_data_import VALUES (84386, '2021-01-22', 'TH', 'Thailand', 'SEARO', '309', '13104', '0', '71');
INSERT INTO public.who_global_data_import VALUES (84387, '2021-01-23', 'TH', 'Thailand', 'SEARO', '198', '13302', '1', '72');
INSERT INTO public.who_global_data_import VALUES (84388, '2021-01-24', 'TH', 'Thailand', 'SEARO', '198', '13500', '1', '73');
INSERT INTO public.who_global_data_import VALUES (84389, '2021-01-25', 'TH', 'Thailand', 'SEARO', '187', '13687', '2', '75');
INSERT INTO public.who_global_data_import VALUES (84390, '2021-01-26', 'TH', 'Thailand', 'SEARO', '959', '14646', '0', '75');
INSERT INTO public.who_global_data_import VALUES (84391, '2021-01-27', 'TH', 'Thailand', 'SEARO', '819', '15465', '1', '76');
INSERT INTO public.who_global_data_import VALUES (84392, '2021-01-28', 'TH', 'Thailand', 'SEARO', '756', '16221', '0', '76');
INSERT INTO public.who_global_data_import VALUES (84393, '2021-01-29', 'TH', 'Thailand', 'SEARO', '802', '17023', '0', '76');
INSERT INTO public.who_global_data_import VALUES (84394, '2021-01-30', 'TH', 'Thailand', 'SEARO', '930', '17953', '1', '77');
INSERT INTO public.who_global_data_import VALUES (84395, '2021-01-31', 'TH', 'Thailand', 'SEARO', '829', '18782', '0', '77');
INSERT INTO public.who_global_data_import VALUES (84396, '2021-02-01', 'TH', 'Thailand', 'SEARO', '836', '19618', '0', '77');
INSERT INTO public.who_global_data_import VALUES (84397, '2021-02-02', 'TH', 'Thailand', 'SEARO', '836', '20454', '2', '79');
INSERT INTO public.who_global_data_import VALUES (84398, '2021-02-03', 'TH', 'Thailand', 'SEARO', '795', '21249', '0', '79');
INSERT INTO public.who_global_data_import VALUES (84399, '2021-02-04', 'TH', 'Thailand', 'SEARO', '809', '22058', '0', '79');
INSERT INTO public.who_global_data_import VALUES (84400, '2021-02-05', 'TH', 'Thailand', 'SEARO', '586', '22644', '0', '79');
INSERT INTO public.who_global_data_import VALUES (84401, '2020-01-03', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84402, '2020-01-04', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84403, '2020-01-05', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84404, '2020-01-06', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84405, '2020-01-07', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84406, '2020-01-08', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84407, '2020-01-09', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84408, '2020-01-10', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84409, '2020-01-11', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84410, '2020-01-12', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84411, '2020-01-13', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84412, '2020-01-14', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84413, '2020-01-15', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84414, '2020-01-16', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84415, '2020-01-17', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84416, '2020-01-18', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84417, '2020-01-19', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84418, '2020-01-20', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84419, '2020-01-21', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84420, '2020-01-22', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84421, '2020-01-23', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84422, '2020-01-24', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84423, '2020-01-25', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84424, '2020-01-26', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84425, '2020-01-27', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84426, '2020-01-28', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84427, '2020-01-29', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84428, '2020-01-30', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84429, '2020-01-31', 'GB', 'The United Kingdom', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84430, '2020-02-01', 'GB', 'The United Kingdom', 'EURO', '2', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84431, '2020-02-02', 'GB', 'The United Kingdom', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84432, '2020-02-03', 'GB', 'The United Kingdom', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84433, '2020-02-04', 'GB', 'The United Kingdom', 'EURO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84434, '2020-02-05', 'GB', 'The United Kingdom', 'EURO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84435, '2020-02-06', 'GB', 'The United Kingdom', 'EURO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84436, '2020-02-07', 'GB', 'The United Kingdom', 'EURO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84437, '2020-02-08', 'GB', 'The United Kingdom', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84438, '2020-02-09', 'GB', 'The United Kingdom', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84439, '2020-02-10', 'GB', 'The United Kingdom', 'EURO', '4', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84440, '2020-02-11', 'GB', 'The United Kingdom', 'EURO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84441, '2020-02-12', 'GB', 'The United Kingdom', 'EURO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84442, '2020-02-13', 'GB', 'The United Kingdom', 'EURO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84443, '2020-02-14', 'GB', 'The United Kingdom', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84444, '2020-02-15', 'GB', 'The United Kingdom', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84445, '2020-02-16', 'GB', 'The United Kingdom', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84446, '2020-02-17', 'GB', 'The United Kingdom', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84447, '2020-02-18', 'GB', 'The United Kingdom', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84448, '2020-02-19', 'GB', 'The United Kingdom', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84449, '2020-02-20', 'GB', 'The United Kingdom', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84450, '2020-02-21', 'GB', 'The United Kingdom', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84451, '2020-02-22', 'GB', 'The United Kingdom', 'EURO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84452, '2020-02-23', 'GB', 'The United Kingdom', 'EURO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84453, '2020-02-24', 'GB', 'The United Kingdom', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84454, '2020-02-25', 'GB', 'The United Kingdom', 'EURO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84455, '2020-02-26', 'GB', 'The United Kingdom', 'EURO', '2', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84456, '2020-02-27', 'GB', 'The United Kingdom', 'EURO', '5', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84457, '2020-02-28', 'GB', 'The United Kingdom', 'EURO', '4', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84458, '2020-02-29', 'GB', 'The United Kingdom', 'EURO', '8', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84459, '2020-03-01', 'GB', 'The United Kingdom', 'EURO', '12', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84460, '2020-03-02', 'GB', 'The United Kingdom', 'EURO', '5', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84461, '2020-03-03', 'GB', 'The United Kingdom', 'EURO', '22', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84462, '2020-03-04', 'GB', 'The United Kingdom', 'EURO', '40', '109', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84463, '2020-03-05', 'GB', 'The United Kingdom', 'EURO', '55', '164', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84464, '2020-03-06', 'GB', 'The United Kingdom', 'EURO', '56', '220', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84465, '2020-03-07', 'GB', 'The United Kingdom', 'EURO', '51', '271', '1', '1');
INSERT INTO public.who_global_data_import VALUES (84466, '2020-03-08', 'GB', 'The United Kingdom', 'EURO', '81', '352', '1', '2');
INSERT INTO public.who_global_data_import VALUES (84467, '2020-03-09', 'GB', 'The United Kingdom', 'EURO', '60', '412', '0', '2');
INSERT INTO public.who_global_data_import VALUES (84468, '2020-03-10', 'GB', 'The United Kingdom', 'EURO', '57', '469', '1', '3');
INSERT INTO public.who_global_data_import VALUES (84469, '2020-03-11', 'GB', 'The United Kingdom', 'EURO', '148', '617', '4', '7');
INSERT INTO public.who_global_data_import VALUES (84470, '2020-03-12', 'GB', 'The United Kingdom', 'EURO', '259', '876', '0', '7');
INSERT INTO public.who_global_data_import VALUES (84471, '2020-03-13', 'GB', 'The United Kingdom', 'EURO', '406', '1282', '2', '9');
INSERT INTO public.who_global_data_import VALUES (84472, '2020-03-14', 'GB', 'The United Kingdom', 'EURO', '484', '1766', '1', '10');
INSERT INTO public.who_global_data_import VALUES (84473, '2020-03-15', 'GB', 'The United Kingdom', 'EURO', '478', '2244', '19', '29');
INSERT INTO public.who_global_data_import VALUES (84474, '2020-03-16', 'GB', 'The United Kingdom', 'EURO', '361', '2605', '14', '43');
INSERT INTO public.who_global_data_import VALUES (84475, '2020-03-17', 'GB', 'The United Kingdom', 'EURO', '442', '3047', '22', '65');
INSERT INTO public.who_global_data_import VALUES (84476, '2020-03-18', 'GB', 'The United Kingdom', 'EURO', '611', '3658', '17', '82');
INSERT INTO public.who_global_data_import VALUES (84477, '2020-03-19', 'GB', 'The United Kingdom', 'EURO', '769', '4427', '34', '116');
INSERT INTO public.who_global_data_import VALUES (84478, '2020-03-20', 'GB', 'The United Kingdom', 'EURO', '999', '5426', '46', '162');
INSERT INTO public.who_global_data_import VALUES (84479, '2020-03-21', 'GB', 'The United Kingdom', 'EURO', '1055', '6481', '32', '194');
INSERT INTO public.who_global_data_import VALUES (84480, '2020-03-22', 'GB', 'The United Kingdom', 'EURO', '1255', '7736', '58', '252');
INSERT INTO public.who_global_data_import VALUES (84481, '2020-03-23', 'GB', 'The United Kingdom', 'EURO', '1198', '8934', '36', '288');
INSERT INTO public.who_global_data_import VALUES (84482, '2020-03-24', 'GB', 'The United Kingdom', 'EURO', '1378', '10312', '76', '364');
INSERT INTO public.who_global_data_import VALUES (84483, '2020-03-25', 'GB', 'The United Kingdom', 'EURO', '2338', '12650', '148', '512');
INSERT INTO public.who_global_data_import VALUES (84484, '2020-03-26', 'GB', 'The United Kingdom', 'EURO', '2375', '15025', '191', '703');
INSERT INTO public.who_global_data_import VALUES (84485, '2020-03-27', 'GB', 'The United Kingdom', 'EURO', '2692', '17717', '181', '884');
INSERT INTO public.who_global_data_import VALUES (84486, '2020-03-28', 'GB', 'The United Kingdom', 'EURO', '3087', '20804', '288', '1172');
INSERT INTO public.who_global_data_import VALUES (84487, '2020-03-29', 'GB', 'The United Kingdom', 'EURO', '3197', '24001', '292', '1464');
INSERT INTO public.who_global_data_import VALUES (84488, '2020-03-30', 'GB', 'The United Kingdom', 'EURO', '2822', '26823', '212', '1676');
INSERT INTO public.who_global_data_import VALUES (84489, '2020-03-31', 'GB', 'The United Kingdom', 'EURO', '2858', '29681', '374', '2050');
INSERT INTO public.who_global_data_import VALUES (84490, '2020-04-01', 'GB', 'The United Kingdom', 'EURO', '4273', '33954', '403', '2453');
INSERT INTO public.who_global_data_import VALUES (84491, '2020-04-02', 'GB', 'The United Kingdom', 'EURO', '4514', '38468', '672', '3125');
INSERT INTO public.who_global_data_import VALUES (84492, '2020-04-03', 'GB', 'The United Kingdom', 'EURO', '4913', '43381', '657', '3782');
INSERT INTO public.who_global_data_import VALUES (84493, '2020-04-04', 'GB', 'The United Kingdom', 'EURO', '4868', '48249', '736', '4518');
INSERT INTO public.who_global_data_import VALUES (84494, '2020-04-05', 'GB', 'The United Kingdom', 'EURO', '4911', '53160', '756', '5274');
INSERT INTO public.who_global_data_import VALUES (84495, '2020-04-06', 'GB', 'The United Kingdom', 'EURO', '4020', '57180', '599', '5873');
INSERT INTO public.who_global_data_import VALUES (84496, '2020-04-07', 'GB', 'The United Kingdom', 'EURO', '3592', '60772', '567', '6440');
INSERT INTO public.who_global_data_import VALUES (84497, '2020-04-08', 'GB', 'The United Kingdom', 'EURO', '5282', '66054', '1105', '7545');
INSERT INTO public.who_global_data_import VALUES (84498, '2020-04-09', 'GB', 'The United Kingdom', 'EURO', '5450', '71504', '1030', '8575');
INSERT INTO public.who_global_data_import VALUES (84499, '2020-04-10', 'GB', 'The United Kingdom', 'EURO', '5131', '76635', '1116', '9691');
INSERT INTO public.who_global_data_import VALUES (84500, '2020-04-11', 'GB', 'The United Kingdom', 'EURO', '4858', '81493', '1122', '10813');
INSERT INTO public.who_global_data_import VALUES (84501, '2020-04-12', 'GB', 'The United Kingdom', 'EURO', '4313', '85806', '843', '11656');
INSERT INTO public.who_global_data_import VALUES (84502, '2020-04-13', 'GB', 'The United Kingdom', 'EURO', '3579', '89385', '657', '12313');
INSERT INTO public.who_global_data_import VALUES (84503, '2020-04-14', 'GB', 'The United Kingdom', 'EURO', '3489', '92874', '724', '13037');
INSERT INTO public.who_global_data_import VALUES (84504, '2020-04-15', 'GB', 'The United Kingdom', 'EURO', '4178', '97052', '1076', '14113');
INSERT INTO public.who_global_data_import VALUES (84505, '2020-04-16', 'GB', 'The United Kingdom', 'EURO', '4326', '101378', '880', '14993');
INSERT INTO public.who_global_data_import VALUES (84506, '2020-04-17', 'GB', 'The United Kingdom', 'EURO', '5065', '106443', '1036', '16029');
INSERT INTO public.who_global_data_import VALUES (84507, '2020-04-18', 'GB', 'The United Kingdom', 'EURO', '5292', '111735', '913', '16942');
INSERT INTO public.who_global_data_import VALUES (84508, '2020-04-19', 'GB', 'The United Kingdom', 'EURO', '4956', '116691', '1105', '18047');
INSERT INTO public.who_global_data_import VALUES (84509, '2020-04-20', 'GB', 'The United Kingdom', 'EURO', '4721', '121412', '432', '18479');
INSERT INTO public.who_global_data_import VALUES (84510, '2020-04-21', 'GB', 'The United Kingdom', 'EURO', '3853', '125265', '570', '19049');
INSERT INTO public.who_global_data_import VALUES (84511, '2020-04-22', 'GB', 'The United Kingdom', 'EURO', '4854', '130119', '1224', '20273');
INSERT INTO public.who_global_data_import VALUES (84512, '2020-04-23', 'GB', 'The United Kingdom', 'EURO', '4760', '134879', '847', '21120');
INSERT INTO public.who_global_data_import VALUES (84513, '2020-04-24', 'GB', 'The United Kingdom', 'EURO', '5487', '140366', '682', '21802');
INSERT INTO public.who_global_data_import VALUES (84514, '2020-04-25', 'GB', 'The United Kingdom', 'EURO', '5158', '145524', '1010', '22812');
INSERT INTO public.who_global_data_import VALUES (84515, '2020-04-26', 'GB', 'The United Kingdom', 'EURO', '4970', '150494', '815', '23627');
INSERT INTO public.who_global_data_import VALUES (84516, '2020-04-27', 'GB', 'The United Kingdom', 'EURO', '3748', '154242', '364', '23991');
INSERT INTO public.who_global_data_import VALUES (84517, '2020-04-28', 'GB', 'The United Kingdom', 'EURO', '3473', '157715', '320', '24311');
INSERT INTO public.who_global_data_import VALUES (84518, '2020-04-29', 'GB', 'The United Kingdom', 'EURO', '4706', '162421', '969', '25280');
INSERT INTO public.who_global_data_import VALUES (84519, '2020-04-30', 'GB', 'The United Kingdom', 'EURO', '4729', '167150', '769', '26049');
INSERT INTO public.who_global_data_import VALUES (84520, '2020-05-01', 'GB', 'The United Kingdom', 'EURO', '5446', '172596', '634', '26683');
INSERT INTO public.who_global_data_import VALUES (84521, '2020-05-02', 'GB', 'The United Kingdom', 'EURO', '4966', '177562', '698', '27381');
INSERT INTO public.who_global_data_import VALUES (84522, '2020-05-03', 'GB', 'The United Kingdom', 'EURO', '4737', '182299', '584', '27965');
INSERT INTO public.who_global_data_import VALUES (84523, '2020-05-04', 'GB', 'The United Kingdom', 'EURO', '3229', '185528', '253', '28218');
INSERT INTO public.who_global_data_import VALUES (84524, '2020-05-05', 'GB', 'The United Kingdom', 'EURO', '2982', '188510', '272', '28490');
INSERT INTO public.who_global_data_import VALUES (84525, '2020-05-06', 'GB', 'The United Kingdom', 'EURO', '3389', '191899', '726', '29216');
INSERT INTO public.who_global_data_import VALUES (84526, '2020-05-07', 'GB', 'The United Kingdom', 'EURO', '3682', '195581', '647', '29863');
INSERT INTO public.who_global_data_import VALUES (84527, '2020-05-08', 'GB', 'The United Kingdom', 'EURO', '3827', '199408', '458', '30321');
INSERT INTO public.who_global_data_import VALUES (84528, '2020-05-09', 'GB', 'The United Kingdom', 'EURO', '3767', '203175', '579', '30900');
INSERT INTO public.who_global_data_import VALUES (84529, '2020-05-10', 'GB', 'The United Kingdom', 'EURO', '3063', '206238', '275', '31175');
INSERT INTO public.who_global_data_import VALUES (84530, '2020-05-11', 'GB', 'The United Kingdom', 'EURO', '2157', '208395', '217', '31392');
INSERT INTO public.who_global_data_import VALUES (84531, '2020-05-12', 'GB', 'The United Kingdom', 'EURO', '2329', '210724', '187', '31579');
INSERT INTO public.who_global_data_import VALUES (84532, '2020-05-13', 'GB', 'The United Kingdom', 'EURO', '3586', '214310', '614', '32193');
INSERT INTO public.who_global_data_import VALUES (84533, '2020-05-14', 'GB', 'The United Kingdom', 'EURO', '3402', '217712', '447', '32640');
INSERT INTO public.who_global_data_import VALUES (84534, '2020-05-15', 'GB', 'The United Kingdom', 'EURO', '3307', '221019', '352', '32992');
INSERT INTO public.who_global_data_import VALUES (84535, '2020-05-16', 'GB', 'The United Kingdom', 'EURO', '2628', '223647', '350', '33342');
INSERT INTO public.who_global_data_import VALUES (84536, '2020-05-17', 'GB', 'The United Kingdom', 'EURO', '2526', '226173', '411', '33753');
INSERT INTO public.who_global_data_import VALUES (84537, '2020-05-18', 'GB', 'The United Kingdom', 'EURO', '2079', '228252', '67', '33820');
INSERT INTO public.who_global_data_import VALUES (84538, '2020-05-19', 'GB', 'The United Kingdom', 'EURO', '1838', '230090', '146', '33966');
INSERT INTO public.who_global_data_import VALUES (84539, '2020-05-20', 'GB', 'The United Kingdom', 'EURO', '2589', '232679', '500', '34466');
INSERT INTO public.who_global_data_import VALUES (84540, '2020-05-21', 'GB', 'The United Kingdom', 'EURO', '3052', '235731', '328', '34794');
INSERT INTO public.who_global_data_import VALUES (84541, '2020-05-22', 'GB', 'The United Kingdom', 'EURO', '2718', '238449', '273', '35067');
INSERT INTO public.who_global_data_import VALUES (84542, '2020-05-23', 'GB', 'The United Kingdom', 'EURO', '2574', '241023', '291', '35358');
INSERT INTO public.who_global_data_import VALUES (84543, '2020-05-24', 'GB', 'The United Kingdom', 'EURO', '2062', '243085', '220', '35578');
INSERT INTO public.who_global_data_import VALUES (84544, '2020-05-25', 'GB', 'The United Kingdom', 'EURO', '1527', '244612', '379', '35957');
INSERT INTO public.who_global_data_import VALUES (84545, '2020-05-26', 'GB', 'The United Kingdom', 'EURO', '1364', '245976', '104', '36061');
INSERT INTO public.who_global_data_import VALUES (84546, '2020-05-27', 'GB', 'The United Kingdom', 'EURO', '1624', '247600', '131', '36192');
INSERT INTO public.who_global_data_import VALUES (84547, '2020-05-28', 'GB', 'The United Kingdom', 'EURO', '1672', '249272', '422', '36614');
INSERT INTO public.who_global_data_import VALUES (84548, '2020-05-29', 'GB', 'The United Kingdom', 'EURO', '1835', '251107', '343', '36957');
INSERT INTO public.who_global_data_import VALUES (84549, '2020-05-30', 'GB', 'The United Kingdom', 'EURO', '1760', '252867', '274', '37231');
INSERT INTO public.who_global_data_import VALUES (84550, '2020-05-31', 'GB', 'The United Kingdom', 'EURO', '1527', '254394', '154', '37385');
INSERT INTO public.who_global_data_import VALUES (84551, '2020-06-01', 'GB', 'The United Kingdom', 'EURO', '1125', '255519', '60', '37445');
INSERT INTO public.who_global_data_import VALUES (84552, '2020-06-02', 'GB', 'The United Kingdom', 'EURO', '1079', '256598', '86', '37531');
INSERT INTO public.who_global_data_import VALUES (84553, '2020-06-03', 'GB', 'The United Kingdom', 'EURO', '1441', '258039', '249', '37780');
INSERT INTO public.who_global_data_import VALUES (84554, '2020-06-04', 'GB', 'The United Kingdom', 'EURO', '1484', '259523', '254', '38034');
INSERT INTO public.who_global_data_import VALUES (84555, '2020-06-05', 'GB', 'The United Kingdom', 'EURO', '1356', '260879', '130', '38164');
INSERT INTO public.who_global_data_import VALUES (84556, '2020-06-06', 'GB', 'The United Kingdom', 'EURO', '1243', '262122', '258', '38422');
INSERT INTO public.who_global_data_import VALUES (84557, '2020-06-07', 'GB', 'The United Kingdom', 'EURO', '1120', '263242', '143', '38565');
INSERT INTO public.who_global_data_import VALUES (84558, '2020-06-08', 'GB', 'The United Kingdom', 'EURO', '801', '264043', '54', '38619');
INSERT INTO public.who_global_data_import VALUES (84559, '2020-06-09', 'GB', 'The United Kingdom', 'EURO', '721', '264764', '47', '38666');
INSERT INTO public.who_global_data_import VALUES (84560, '2020-06-10', 'GB', 'The United Kingdom', 'EURO', '1099', '265863', '195', '38861');
INSERT INTO public.who_global_data_import VALUES (84561, '2020-06-11', 'GB', 'The United Kingdom', 'EURO', '1158', '267021', '164', '39025');
INSERT INTO public.who_global_data_import VALUES (84562, '2020-06-12', 'GB', 'The United Kingdom', 'EURO', '1199', '268220', '76', '39101');
INSERT INTO public.who_global_data_import VALUES (84563, '2020-06-13', 'GB', 'The United Kingdom', 'EURO', '1017', '269237', '131', '39232');
INSERT INTO public.who_global_data_import VALUES (84564, '2020-06-14', 'GB', 'The United Kingdom', 'EURO', '1052', '270289', '107', '39339');
INSERT INTO public.who_global_data_import VALUES (84565, '2020-06-15', 'GB', 'The United Kingdom', 'EURO', '890', '271179', '27', '39366');
INSERT INTO public.who_global_data_import VALUES (84566, '2020-06-16', 'GB', 'The United Kingdom', 'EURO', '822', '272001', '29', '39395');
INSERT INTO public.who_global_data_import VALUES (84567, '2020-06-17', 'GB', 'The United Kingdom', 'EURO', '1043', '273044', '120', '39515');
INSERT INTO public.who_global_data_import VALUES (84568, '2020-06-18', 'GB', 'The United Kingdom', 'EURO', '1102', '274146', '110', '39625');
INSERT INTO public.who_global_data_import VALUES (84569, '2020-06-19', 'GB', 'The United Kingdom', 'EURO', '1013', '275159', '67', '39692');
INSERT INTO public.who_global_data_import VALUES (84570, '2020-06-20', 'GB', 'The United Kingdom', 'EURO', '1027', '276186', '84', '39776');
INSERT INTO public.who_global_data_import VALUES (84571, '2020-06-21', 'GB', 'The United Kingdom', 'EURO', '986', '277172', '71', '39847');
INSERT INTO public.who_global_data_import VALUES (84572, '2020-06-22', 'GB', 'The United Kingdom', 'EURO', '687', '277859', '31', '39878');
INSERT INTO public.who_global_data_import VALUES (84573, '2020-06-23', 'GB', 'The United Kingdom', 'EURO', '639', '278498', '14', '39892');
INSERT INTO public.who_global_data_import VALUES (84574, '2020-06-24', 'GB', 'The United Kingdom', 'EURO', '896', '279394', '94', '39986');
INSERT INTO public.who_global_data_import VALUES (84575, '2020-06-25', 'GB', 'The United Kingdom', 'EURO', '886', '280280', '87', '40073');
INSERT INTO public.who_global_data_import VALUES (84576, '2020-06-26', 'GB', 'The United Kingdom', 'EURO', '778', '281058', '99', '40172');
INSERT INTO public.who_global_data_import VALUES (84577, '2020-06-27', 'GB', 'The United Kingdom', 'EURO', '721', '281779', '77', '40249');
INSERT INTO public.who_global_data_import VALUES (84578, '2020-06-28', 'GB', 'The United Kingdom', 'EURO', '671', '282450', '40', '40289');
INSERT INTO public.who_global_data_import VALUES (84579, '2020-06-29', 'GB', 'The United Kingdom', 'EURO', '649', '283099', '31', '40320');
INSERT INTO public.who_global_data_import VALUES (84580, '2020-06-30', 'GB', 'The United Kingdom', 'EURO', '446', '283545', '21', '40341');
INSERT INTO public.who_global_data_import VALUES (84581, '2020-07-01', 'GB', 'The United Kingdom', 'EURO', '730', '284275', '53', '40394');
INSERT INTO public.who_global_data_import VALUES (84582, '2020-07-02', 'GB', 'The United Kingdom', 'EURO', '617', '284892', '97', '40491');
INSERT INTO public.who_global_data_import VALUES (84583, '2020-07-03', 'GB', 'The United Kingdom', 'EURO', '651', '285543', '41', '40532');
INSERT INTO public.who_global_data_import VALUES (84584, '2020-07-04', 'GB', 'The United Kingdom', 'EURO', '602', '286145', '49', '40581');
INSERT INTO public.who_global_data_import VALUES (84585, '2020-07-05', 'GB', 'The United Kingdom', 'EURO', '579', '286724', '32', '40613');
INSERT INTO public.who_global_data_import VALUES (84586, '2020-07-06', 'GB', 'The United Kingdom', 'EURO', '401', '287125', '19', '40632');
INSERT INTO public.who_global_data_import VALUES (84587, '2020-07-07', 'GB', 'The United Kingdom', 'EURO', '555', '287680', '11', '40643');
INSERT INTO public.who_global_data_import VALUES (84588, '2020-07-08', 'GB', 'The United Kingdom', 'EURO', '704', '288384', '54', '40697');
INSERT INTO public.who_global_data_import VALUES (84589, '2020-07-09', 'GB', 'The United Kingdom', 'EURO', '597', '288981', '57', '40754');
INSERT INTO public.who_global_data_import VALUES (84590, '2020-07-10', 'GB', 'The United Kingdom', 'EURO', '693', '289674', '31', '40785');
INSERT INTO public.who_global_data_import VALUES (84591, '2020-07-11', 'GB', 'The United Kingdom', 'EURO', '715', '290389', '34', '40819');
INSERT INTO public.who_global_data_import VALUES (84592, '2020-07-12', 'GB', 'The United Kingdom', 'EURO', '565', '290954', '17', '40836');
INSERT INTO public.who_global_data_import VALUES (84593, '2020-07-13', 'GB', 'The United Kingdom', 'EURO', '442', '291396', '9', '40845');
INSERT INTO public.who_global_data_import VALUES (84594, '2020-07-14', 'GB', 'The United Kingdom', 'EURO', '361', '291757', '10', '40855');
INSERT INTO public.who_global_data_import VALUES (84595, '2020-07-15', 'GB', 'The United Kingdom', 'EURO', '726', '292483', '44', '40899');
INSERT INTO public.who_global_data_import VALUES (84596, '2020-07-16', 'GB', 'The United Kingdom', 'EURO', '685', '293168', '26', '40925');
INSERT INTO public.who_global_data_import VALUES (84597, '2020-07-17', 'GB', 'The United Kingdom', 'EURO', '772', '293940', '24', '40949');
INSERT INTO public.who_global_data_import VALUES (84598, '2020-07-18', 'GB', 'The United Kingdom', 'EURO', '704', '294644', '26', '40975');
INSERT INTO public.who_global_data_import VALUES (84599, '2020-07-19', 'GB', 'The United Kingdom', 'EURO', '569', '295213', '9', '40984');
INSERT INTO public.who_global_data_import VALUES (84600, '2020-07-20', 'GB', 'The United Kingdom', 'EURO', '493', '295706', '11', '40995');
INSERT INTO public.who_global_data_import VALUES (84601, '2020-07-21', 'GB', 'The United Kingdom', 'EURO', '413', '296119', '10', '41005');
INSERT INTO public.who_global_data_import VALUES (84602, '2020-07-22', 'GB', 'The United Kingdom', 'EURO', '793', '296912', '25', '41030');
INSERT INTO public.who_global_data_import VALUES (84603, '2020-07-23', 'GB', 'The United Kingdom', 'EURO', '751', '297663', '17', '41047');
INSERT INTO public.who_global_data_import VALUES (84604, '2020-07-24', 'GB', 'The United Kingdom', 'EURO', '773', '298436', '9', '41056');
INSERT INTO public.who_global_data_import VALUES (84605, '2020-07-25', 'GB', 'The United Kingdom', 'EURO', '731', '299167', '32', '41088');
INSERT INTO public.who_global_data_import VALUES (84606, '2020-07-26', 'GB', 'The United Kingdom', 'EURO', '667', '299834', '15', '41103');
INSERT INTO public.who_global_data_import VALUES (84607, '2020-07-27', 'GB', 'The United Kingdom', 'EURO', '421', '300255', '8', '41111');
INSERT INTO public.who_global_data_import VALUES (84608, '2020-07-28', 'GB', 'The United Kingdom', 'EURO', '371', '300626', '3', '41114');
INSERT INTO public.who_global_data_import VALUES (84609, '2020-07-29', 'GB', 'The United Kingdom', 'EURO', '70', '300696', '21', '41135');
INSERT INTO public.who_global_data_import VALUES (84610, '2020-07-30', 'GB', 'The United Kingdom', 'EURO', '763', '301459', '34', '41169');
INSERT INTO public.who_global_data_import VALUES (84611, '2020-07-31', 'GB', 'The United Kingdom', 'EURO', '846', '302305', '0', '41169');
INSERT INTO public.who_global_data_import VALUES (84612, '2020-08-01', 'GB', 'The United Kingdom', 'EURO', '880', '303185', '20', '41189');
INSERT INTO public.who_global_data_import VALUES (84613, '2020-08-02', 'GB', 'The United Kingdom', 'EURO', '771', '303956', '13', '41202');
INSERT INTO public.who_global_data_import VALUES (84614, '2020-08-03', 'GB', 'The United Kingdom', 'EURO', '743', '304699', '5', '41207');
INSERT INTO public.who_global_data_import VALUES (84615, '2020-08-04', 'GB', 'The United Kingdom', 'EURO', '928', '305627', '1', '41208');
INSERT INTO public.who_global_data_import VALUES (84616, '2020-08-05', 'GB', 'The United Kingdom', 'EURO', '670', '306297', '18', '41226');
INSERT INTO public.who_global_data_import VALUES (84617, '2020-08-06', 'GB', 'The United Kingdom', 'EURO', '891', '307188', '14', '41240');
INSERT INTO public.who_global_data_import VALUES (84618, '2020-08-07', 'GB', 'The United Kingdom', 'EURO', '950', '308138', '18', '41258');
INSERT INTO public.who_global_data_import VALUES (84619, '2020-08-08', 'GB', 'The United Kingdom', 'EURO', '871', '309009', '12', '41270');
INSERT INTO public.who_global_data_import VALUES (84620, '2020-08-09', 'GB', 'The United Kingdom', 'EURO', '758', '309767', '3', '41273');
INSERT INTO public.who_global_data_import VALUES (84621, '2020-08-10', 'GB', 'The United Kingdom', 'EURO', '1062', '310829', '5', '41278');
INSERT INTO public.who_global_data_import VALUES (84622, '2020-08-11', 'GB', 'The United Kingdom', 'EURO', '816', '311645', '18', '41296');
INSERT INTO public.who_global_data_import VALUES (84623, '2020-08-12', 'GB', 'The United Kingdom', 'EURO', '1148', '312793', '13', '41309');
INSERT INTO public.who_global_data_import VALUES (84624, '2020-08-13', 'GB', 'The United Kingdom', 'EURO', '1009', '313802', '20', '41329');
INSERT INTO public.who_global_data_import VALUES (84625, '2020-08-14', 'GB', 'The United Kingdom', 'EURO', '1129', '314931', '18', '41347');
INSERT INTO public.who_global_data_import VALUES (84626, '2020-08-15', 'GB', 'The United Kingdom', 'EURO', '1440', '316371', '11', '41358');
INSERT INTO public.who_global_data_import VALUES (84627, '2020-08-16', 'GB', 'The United Kingdom', 'EURO', '1077', '317448', '3', '41361');
INSERT INTO public.who_global_data_import VALUES (84628, '2020-08-17', 'GB', 'The United Kingdom', 'EURO', '1040', '318488', '5', '41366');
INSERT INTO public.who_global_data_import VALUES (84629, '2020-08-18', 'GB', 'The United Kingdom', 'EURO', '713', '319201', '3', '41369');
INSERT INTO public.who_global_data_import VALUES (84630, '2020-08-19', 'GB', 'The United Kingdom', 'EURO', '1089', '320290', '12', '41381');
INSERT INTO public.who_global_data_import VALUES (84631, '2020-08-20', 'GB', 'The United Kingdom', 'EURO', '812', '321102', '16', '41397');
INSERT INTO public.who_global_data_import VALUES (84632, '2020-08-21', 'GB', 'The United Kingdom', 'EURO', '1182', '322284', '6', '41403');
INSERT INTO public.who_global_data_import VALUES (84633, '2020-08-22', 'GB', 'The United Kingdom', 'EURO', '1033', '323317', '2', '41405');
INSERT INTO public.who_global_data_import VALUES (84634, '2020-08-23', 'GB', 'The United Kingdom', 'EURO', '1288', '324605', '18', '41423');
INSERT INTO public.who_global_data_import VALUES (84635, '2020-08-24', 'GB', 'The United Kingdom', 'EURO', '1041', '325646', '6', '41429');
INSERT INTO public.who_global_data_import VALUES (84636, '2020-08-25', 'GB', 'The United Kingdom', 'EURO', '972', '326618', '4', '41433');
INSERT INTO public.who_global_data_import VALUES (84637, '2020-08-26', 'GB', 'The United Kingdom', 'EURO', '1184', '327802', '16', '41449');
INSERT INTO public.who_global_data_import VALUES (84638, '2020-08-27', 'GB', 'The United Kingdom', 'EURO', '1048', '328850', '16', '41465');
INSERT INTO public.who_global_data_import VALUES (84639, '2020-08-28', 'GB', 'The United Kingdom', 'EURO', '1522', '330372', '12', '41477');
INSERT INTO public.who_global_data_import VALUES (84640, '2020-08-29', 'GB', 'The United Kingdom', 'EURO', '1276', '331648', '9', '41486');
INSERT INTO public.who_global_data_import VALUES (84641, '2020-08-30', 'GB', 'The United Kingdom', 'EURO', '1108', '332756', '12', '41498');
INSERT INTO public.who_global_data_import VALUES (84642, '2020-08-31', 'GB', 'The United Kingdom', 'EURO', '1715', '334471', '1', '41499');
INSERT INTO public.who_global_data_import VALUES (84643, '2020-09-01', 'GB', 'The United Kingdom', 'EURO', '1406', '335877', '2', '41501');
INSERT INTO public.who_global_data_import VALUES (84644, '2020-09-02', 'GB', 'The United Kingdom', 'EURO', '1295', '337172', '3', '41504');
INSERT INTO public.who_global_data_import VALUES (84645, '2020-09-03', 'GB', 'The United Kingdom', 'EURO', '1508', '338680', '10', '41514');
INSERT INTO public.who_global_data_import VALUES (84646, '2020-09-04', 'GB', 'The United Kingdom', 'EURO', '1735', '340415', '13', '41527');
INSERT INTO public.who_global_data_import VALUES (84647, '2020-09-05', 'GB', 'The United Kingdom', 'EURO', '1940', '342355', '10', '41537');
INSERT INTO public.who_global_data_import VALUES (84648, '2020-09-06', 'GB', 'The United Kingdom', 'EURO', '1813', '344168', '12', '41549');
INSERT INTO public.who_global_data_import VALUES (84649, '2020-09-07', 'GB', 'The United Kingdom', 'EURO', '2988', '347156', '2', '41551');
INSERT INTO public.who_global_data_import VALUES (84650, '2020-09-08', 'GB', 'The United Kingdom', 'EURO', '2948', '350104', '3', '41554');
INSERT INTO public.who_global_data_import VALUES (84651, '2020-09-09', 'GB', 'The United Kingdom', 'EURO', '2460', '352564', '32', '41586');
INSERT INTO public.who_global_data_import VALUES (85257, '2020-02-28', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84652, '2020-09-10', 'GB', 'The United Kingdom', 'EURO', '2659', '355223', '8', '41594');
INSERT INTO public.who_global_data_import VALUES (84653, '2020-09-11', 'GB', 'The United Kingdom', 'EURO', '2919', '358142', '14', '41608');
INSERT INTO public.who_global_data_import VALUES (84654, '2020-09-12', 'GB', 'The United Kingdom', 'EURO', '3539', '361681', '6', '41614');
INSERT INTO public.who_global_data_import VALUES (84655, '2020-09-13', 'GB', 'The United Kingdom', 'EURO', '3497', '365178', '9', '41623');
INSERT INTO public.who_global_data_import VALUES (84656, '2020-09-14', 'GB', 'The United Kingdom', 'EURO', '3330', '368508', '5', '41628');
INSERT INTO public.who_global_data_import VALUES (84657, '2020-09-15', 'GB', 'The United Kingdom', 'EURO', '2621', '371129', '9', '41637');
INSERT INTO public.who_global_data_import VALUES (84658, '2020-09-16', 'GB', 'The United Kingdom', 'EURO', '3103', '374232', '27', '41664');
INSERT INTO public.who_global_data_import VALUES (84659, '2020-09-17', 'GB', 'The United Kingdom', 'EURO', '3991', '378223', '20', '41684');
INSERT INTO public.who_global_data_import VALUES (84660, '2020-09-18', 'GB', 'The United Kingdom', 'EURO', '3395', '381618', '21', '41705');
INSERT INTO public.who_global_data_import VALUES (84661, '2020-09-19', 'GB', 'The United Kingdom', 'EURO', '4322', '385940', '27', '41732');
INSERT INTO public.who_global_data_import VALUES (84662, '2020-09-20', 'GB', 'The United Kingdom', 'EURO', '4422', '390362', '27', '41759');
INSERT INTO public.who_global_data_import VALUES (84663, '2020-09-21', 'GB', 'The United Kingdom', 'EURO', '3899', '394261', '18', '41777');
INSERT INTO public.who_global_data_import VALUES (84664, '2020-09-22', 'GB', 'The United Kingdom', 'EURO', '4368', '398629', '11', '41788');
INSERT INTO public.who_global_data_import VALUES (84665, '2020-09-23', 'GB', 'The United Kingdom', 'EURO', '4926', '403555', '37', '41825');
INSERT INTO public.who_global_data_import VALUES (84666, '2020-09-24', 'GB', 'The United Kingdom', 'EURO', '6178', '409733', '37', '41862');
INSERT INTO public.who_global_data_import VALUES (84667, '2020-09-25', 'GB', 'The United Kingdom', 'EURO', '6634', '416367', '40', '41902');
INSERT INTO public.who_global_data_import VALUES (84668, '2020-09-26', 'GB', 'The United Kingdom', 'EURO', '6873', '423240', '34', '41936');
INSERT INTO public.who_global_data_import VALUES (84669, '2020-09-27', 'GB', 'The United Kingdom', 'EURO', '6041', '429281', '35', '41971');
INSERT INTO public.who_global_data_import VALUES (84670, '2020-09-28', 'GB', 'The United Kingdom', 'EURO', '5692', '434973', '17', '41988');
INSERT INTO public.who_global_data_import VALUES (84671, '2020-09-29', 'GB', 'The United Kingdom', 'EURO', '4044', '439017', '13', '42001');
INSERT INTO public.who_global_data_import VALUES (84672, '2020-09-30', 'GB', 'The United Kingdom', 'EURO', '7143', '446160', '71', '42072');
INSERT INTO public.who_global_data_import VALUES (84673, '2020-10-01', 'GB', 'The United Kingdom', 'EURO', '7108', '453268', '71', '42143');
INSERT INTO public.who_global_data_import VALUES (84674, '2020-10-02', 'GB', 'The United Kingdom', 'EURO', '6914', '460182', '59', '42202');
INSERT INTO public.who_global_data_import VALUES (84675, '2020-10-03', 'GB', 'The United Kingdom', 'EURO', '6968', '467150', '66', '42268');
INSERT INTO public.who_global_data_import VALUES (84676, '2020-10-04', 'GB', 'The United Kingdom', 'EURO', '12871', '480021', '49', '42317');
INSERT INTO public.who_global_data_import VALUES (84677, '2020-10-05', 'GB', 'The United Kingdom', 'EURO', '22961', '502982', '33', '42350');
INSERT INTO public.who_global_data_import VALUES (84678, '2020-10-06', 'GB', 'The United Kingdom', 'EURO', '12593', '515575', '19', '42369');
INSERT INTO public.who_global_data_import VALUES (84679, '2020-10-07', 'GB', 'The United Kingdom', 'EURO', '14542', '530117', '76', '42445');
INSERT INTO public.who_global_data_import VALUES (84680, '2020-10-08', 'GB', 'The United Kingdom', 'EURO', '14162', '544279', '70', '42515');
INSERT INTO public.who_global_data_import VALUES (84681, '2020-10-09', 'GB', 'The United Kingdom', 'EURO', '17540', '561819', '77', '42592');
INSERT INTO public.who_global_data_import VALUES (84682, '2020-10-10', 'GB', 'The United Kingdom', 'EURO', '13864', '575683', '87', '42679');
INSERT INTO public.who_global_data_import VALUES (84683, '2020-10-11', 'GB', 'The United Kingdom', 'EURO', '15165', '590848', '81', '42760');
INSERT INTO public.who_global_data_import VALUES (84684, '2020-10-12', 'GB', 'The United Kingdom', 'EURO', '12872', '603720', '65', '42825');
INSERT INTO public.who_global_data_import VALUES (84685, '2020-10-13', 'GB', 'The United Kingdom', 'EURO', '13972', '617692', '50', '42875');
INSERT INTO public.who_global_data_import VALUES (84686, '2020-10-14', 'GB', 'The United Kingdom', 'EURO', '17232', '634924', '143', '43018');
INSERT INTO public.who_global_data_import VALUES (84687, '2020-10-15', 'GB', 'The United Kingdom', 'EURO', '19724', '654648', '137', '43155');
INSERT INTO public.who_global_data_import VALUES (84688, '2020-10-16', 'GB', 'The United Kingdom', 'EURO', '18978', '673626', '138', '43293');
INSERT INTO public.who_global_data_import VALUES (84689, '2020-10-17', 'GB', 'The United Kingdom', 'EURO', '15635', '689261', '136', '43429');
INSERT INTO public.who_global_data_import VALUES (84690, '2020-10-18', 'GB', 'The United Kingdom', 'EURO', '16171', '705432', '150', '43579');
INSERT INTO public.who_global_data_import VALUES (84691, '2020-10-19', 'GB', 'The United Kingdom', 'EURO', '16981', '722413', '67', '43646');
INSERT INTO public.who_global_data_import VALUES (84692, '2020-10-20', 'GB', 'The United Kingdom', 'EURO', '18803', '741216', '80', '43726');
INSERT INTO public.who_global_data_import VALUES (84693, '2020-10-21', 'GB', 'The United Kingdom', 'EURO', '21330', '762546', '241', '43967');
INSERT INTO public.who_global_data_import VALUES (84694, '2020-10-22', 'GB', 'The United Kingdom', 'EURO', '26687', '789233', '191', '44158');
INSERT INTO public.who_global_data_import VALUES (84695, '2020-10-23', 'GB', 'The United Kingdom', 'EURO', '21238', '810471', '189', '44347');
INSERT INTO public.who_global_data_import VALUES (84696, '2020-10-24', 'GB', 'The United Kingdom', 'EURO', '20531', '831002', '224', '44571');
INSERT INTO public.who_global_data_import VALUES (84697, '2020-10-25', 'GB', 'The United Kingdom', 'EURO', '23012', '854014', '174', '44745');
INSERT INTO public.who_global_data_import VALUES (84698, '2020-10-26', 'GB', 'The United Kingdom', 'EURO', '19790', '873804', '151', '44896');
INSERT INTO public.who_global_data_import VALUES (84699, '2020-10-27', 'GB', 'The United Kingdom', 'EURO', '20890', '894694', '102', '44998');
INSERT INTO public.who_global_data_import VALUES (84700, '2020-10-28', 'GB', 'The United Kingdom', 'EURO', '22885', '917579', '367', '45365');
INSERT INTO public.who_global_data_import VALUES (84701, '2020-10-29', 'GB', 'The United Kingdom', 'EURO', '24700', '942279', '310', '45675');
INSERT INTO public.who_global_data_import VALUES (84702, '2020-10-30', 'GB', 'The United Kingdom', 'EURO', '23065', '965344', '280', '45955');
INSERT INTO public.who_global_data_import VALUES (84703, '2020-10-31', 'GB', 'The United Kingdom', 'EURO', '24405', '989749', '274', '46229');
INSERT INTO public.who_global_data_import VALUES (84704, '2020-11-01', 'GB', 'The United Kingdom', 'EURO', '21915', '1011664', '326', '46555');
INSERT INTO public.who_global_data_import VALUES (84705, '2020-11-02', 'GB', 'The United Kingdom', 'EURO', '23254', '1034918', '162', '46717');
INSERT INTO public.who_global_data_import VALUES (84706, '2020-11-03', 'GB', 'The United Kingdom', 'EURO', '18950', '1053868', '136', '46853');
INSERT INTO public.who_global_data_import VALUES (84707, '2020-11-04', 'GB', 'The United Kingdom', 'EURO', '20018', '1073886', '397', '47250');
INSERT INTO public.who_global_data_import VALUES (84708, '2020-11-05', 'GB', 'The United Kingdom', 'EURO', '25177', '1099063', '492', '47742');
INSERT INTO public.who_global_data_import VALUES (84709, '2020-11-06', 'GB', 'The United Kingdom', 'EURO', '24138', '1123201', '378', '48120');
INSERT INTO public.who_global_data_import VALUES (84710, '2020-11-07', 'GB', 'The United Kingdom', 'EURO', '23287', '1146488', '355', '48475');
INSERT INTO public.who_global_data_import VALUES (84711, '2020-11-08', 'GB', 'The United Kingdom', 'EURO', '24957', '1171445', '413', '48888');
INSERT INTO public.who_global_data_import VALUES (84712, '2020-11-09', 'GB', 'The United Kingdom', 'EURO', '20572', '1192017', '156', '49044');
INSERT INTO public.who_global_data_import VALUES (84713, '2020-11-10', 'GB', 'The United Kingdom', 'EURO', '21350', '1213367', '194', '49238');
INSERT INTO public.who_global_data_import VALUES (84714, '2020-11-11', 'GB', 'The United Kingdom', 'EURO', '20412', '1233779', '532', '49770');
INSERT INTO public.who_global_data_import VALUES (84715, '2020-11-12', 'GB', 'The United Kingdom', 'EURO', '22950', '1256729', '595', '50365');
INSERT INTO public.who_global_data_import VALUES (84716, '2020-11-13', 'GB', 'The United Kingdom', 'EURO', '33470', '1290199', '563', '50928');
INSERT INTO public.who_global_data_import VALUES (84717, '2020-11-14', 'GB', 'The United Kingdom', 'EURO', '27301', '1317500', '376', '51304');
INSERT INTO public.who_global_data_import VALUES (84718, '2020-11-15', 'GB', 'The United Kingdom', 'EURO', '26860', '1344360', '462', '51766');
INSERT INTO public.who_global_data_import VALUES (84719, '2020-11-16', 'GB', 'The United Kingdom', 'EURO', '24962', '1369322', '168', '51934');
INSERT INTO public.who_global_data_import VALUES (84720, '2020-11-17', 'GB', 'The United Kingdom', 'EURO', '21363', '1390685', '213', '52147');
INSERT INTO public.who_global_data_import VALUES (84721, '2020-11-18', 'GB', 'The United Kingdom', 'EURO', '20051', '1410736', '598', '52745');
INSERT INTO public.who_global_data_import VALUES (84722, '2020-11-19', 'GB', 'The United Kingdom', 'EURO', '19609', '1430345', '529', '53274');
INSERT INTO public.who_global_data_import VALUES (84723, '2020-11-20', 'GB', 'The United Kingdom', 'EURO', '22915', '1453260', '501', '53775');
INSERT INTO public.who_global_data_import VALUES (84724, '2020-11-21', 'GB', 'The United Kingdom', 'EURO', '20252', '1473512', '511', '54286');
INSERT INTO public.who_global_data_import VALUES (84725, '2020-11-22', 'GB', 'The United Kingdom', 'EURO', '19875', '1493387', '340', '54626');
INSERT INTO public.who_global_data_import VALUES (84726, '2020-11-23', 'GB', 'The United Kingdom', 'EURO', '18662', '1512049', '125', '54751');
INSERT INTO public.who_global_data_import VALUES (84727, '2020-11-24', 'GB', 'The United Kingdom', 'EURO', '15450', '1527499', '479', '55230');
INSERT INTO public.who_global_data_import VALUES (84728, '2020-11-25', 'GB', 'The United Kingdom', 'EURO', '11299', '1538798', '608', '55838');
INSERT INTO public.who_global_data_import VALUES (84729, '2020-11-26', 'GB', 'The United Kingdom', 'EURO', '18213', '1557011', '695', '56533');
INSERT INTO public.who_global_data_import VALUES (84730, '2020-11-27', 'GB', 'The United Kingdom', 'EURO', '17555', '1574566', '498', '57031');
INSERT INTO public.who_global_data_import VALUES (84731, '2020-11-28', 'GB', 'The United Kingdom', 'EURO', '14739', '1589305', '520', '57551');
INSERT INTO public.who_global_data_import VALUES (84732, '2020-11-29', 'GB', 'The United Kingdom', 'EURO', '15871', '1605176', '479', '58030');
INSERT INTO public.who_global_data_import VALUES (84733, '2020-11-30', 'GB', 'The United Kingdom', 'EURO', '12155', '1617331', '215', '58245');
INSERT INTO public.who_global_data_import VALUES (84734, '2020-12-01', 'GB', 'The United Kingdom', 'EURO', '12330', '1629661', '203', '58448');
INSERT INTO public.who_global_data_import VALUES (84735, '2020-12-02', 'GB', 'The United Kingdom', 'EURO', '13429', '1643090', '603', '59051');
INSERT INTO public.who_global_data_import VALUES (84736, '2020-12-03', 'GB', 'The United Kingdom', 'EURO', '16170', '1659260', '648', '59699');
INSERT INTO public.who_global_data_import VALUES (84737, '2020-12-04', 'GB', 'The United Kingdom', 'EURO', '14878', '1674138', '414', '60113');
INSERT INTO public.who_global_data_import VALUES (84738, '2020-12-05', 'GB', 'The United Kingdom', 'EURO', '16298', '1690436', '504', '60617');
INSERT INTO public.who_global_data_import VALUES (84739, '2020-12-06', 'GB', 'The United Kingdom', 'EURO', '15539', '1705975', '397', '61014');
INSERT INTO public.who_global_data_import VALUES (84740, '2020-12-07', 'GB', 'The United Kingdom', 'EURO', '17271', '1723246', '231', '61245');
INSERT INTO public.who_global_data_import VALUES (84741, '2020-12-08', 'GB', 'The United Kingdom', 'EURO', '14718', '1737964', '189', '61434');
INSERT INTO public.who_global_data_import VALUES (84742, '2020-12-09', 'GB', 'The United Kingdom', 'EURO', '12281', '1750245', '599', '62033');
INSERT INTO public.who_global_data_import VALUES (84743, '2020-12-10', 'GB', 'The United Kingdom', 'EURO', '16578', '1766823', '533', '62566');
INSERT INTO public.who_global_data_import VALUES (84744, '2020-12-11', 'GB', 'The United Kingdom', 'EURO', '20964', '1787787', '516', '63082');
INSERT INTO public.who_global_data_import VALUES (84745, '2020-12-12', 'GB', 'The United Kingdom', 'EURO', '21672', '1809459', '424', '63506');
INSERT INTO public.who_global_data_import VALUES (84746, '2020-12-13', 'GB', 'The United Kingdom', 'EURO', '21501', '1830960', '520', '64026');
INSERT INTO public.who_global_data_import VALUES (84747, '2020-12-14', 'GB', 'The United Kingdom', 'EURO', '18447', '1849407', '144', '64170');
INSERT INTO public.who_global_data_import VALUES (84748, '2020-12-15', 'GB', 'The United Kingdom', 'EURO', '20263', '1869670', '232', '64402');
INSERT INTO public.who_global_data_import VALUES (84749, '2020-12-16', 'GB', 'The United Kingdom', 'EURO', '18450', '1888120', '506', '64908');
INSERT INTO public.who_global_data_import VALUES (84750, '2020-12-17', 'GB', 'The United Kingdom', 'EURO', '25161', '1913281', '612', '65520');
INSERT INTO public.who_global_data_import VALUES (84751, '2020-12-18', 'GB', 'The United Kingdom', 'EURO', '35383', '1948664', '532', '66052');
INSERT INTO public.who_global_data_import VALUES (84752, '2020-12-19', 'GB', 'The United Kingdom', 'EURO', '28507', '1977171', '489', '66541');
INSERT INTO public.who_global_data_import VALUES (84753, '2020-12-20', 'GB', 'The United Kingdom', 'EURO', '27052', '2004223', '534', '67075');
INSERT INTO public.who_global_data_import VALUES (84754, '2020-12-21', 'GB', 'The United Kingdom', 'EURO', '35928', '2040151', '326', '67401');
INSERT INTO public.who_global_data_import VALUES (84755, '2020-12-22', 'GB', 'The United Kingdom', 'EURO', '33364', '2073515', '215', '67616');
INSERT INTO public.who_global_data_import VALUES (84756, '2020-12-23', 'GB', 'The United Kingdom', 'EURO', '36803', '2110318', '691', '68307');
INSERT INTO public.who_global_data_import VALUES (84757, '2020-12-24', 'GB', 'The United Kingdom', 'EURO', '39237', '2149555', '744', '69051');
INSERT INTO public.who_global_data_import VALUES (84758, '2020-12-25', 'GB', 'The United Kingdom', 'EURO', '39036', '2188591', '574', '69625');
INSERT INTO public.who_global_data_import VALUES (84759, '2020-12-26', 'GB', 'The United Kingdom', 'EURO', '32725', '2221316', '570', '70195');
INSERT INTO public.who_global_data_import VALUES (84760, '2020-12-27', 'GB', 'The United Kingdom', 'EURO', '34693', '2256009', '210', '70405');
INSERT INTO public.who_global_data_import VALUES (84761, '2020-12-28', 'GB', 'The United Kingdom', 'EURO', '32340', '2288349', '347', '70752');
INSERT INTO public.who_global_data_import VALUES (84762, '2020-12-29', 'GB', 'The United Kingdom', 'EURO', '41385', '2329734', '357', '71109');
INSERT INTO public.who_global_data_import VALUES (84763, '2020-12-30', 'GB', 'The United Kingdom', 'EURO', '53135', '2382869', '458', '71567');
INSERT INTO public.who_global_data_import VALUES (84764, '2020-12-31', 'GB', 'The United Kingdom', 'EURO', '50023', '2432892', '981', '72548');
INSERT INTO public.who_global_data_import VALUES (84765, '2021-01-01', 'GB', 'The United Kingdom', 'EURO', '55892', '2488784', '964', '73512');
INSERT INTO public.who_global_data_import VALUES (84766, '2021-01-02', 'GB', 'The United Kingdom', 'EURO', '53285', '2542069', '613', '74125');
INSERT INTO public.who_global_data_import VALUES (84767, '2021-01-03', 'GB', 'The United Kingdom', 'EURO', '57724', '2599793', '445', '74570');
INSERT INTO public.who_global_data_import VALUES (84768, '2021-01-04', 'GB', 'The United Kingdom', 'EURO', '54990', '2654783', '454', '75024');
INSERT INTO public.who_global_data_import VALUES (84769, '2021-01-05', 'GB', 'The United Kingdom', 'EURO', '58784', '2713567', '407', '75431');
INSERT INTO public.who_global_data_import VALUES (84770, '2021-01-06', 'GB', 'The United Kingdom', 'EURO', '60916', '2774483', '874', '76305');
INSERT INTO public.who_global_data_import VALUES (84771, '2021-01-07', 'GB', 'The United Kingdom', 'EURO', '62322', '2836805', '1041', '77346');
INSERT INTO public.who_global_data_import VALUES (84772, '2021-01-08', 'GB', 'The United Kingdom', 'EURO', '52618', '2889423', '1162', '78508');
INSERT INTO public.who_global_data_import VALUES (84773, '2021-01-09', 'GB', 'The United Kingdom', 'EURO', '68053', '2957476', '1325', '79833');
INSERT INTO public.who_global_data_import VALUES (84774, '2021-01-10', 'GB', 'The United Kingdom', 'EURO', '59937', '3017413', '1035', '80868');
INSERT INTO public.who_global_data_import VALUES (84775, '2021-01-11', 'GB', 'The United Kingdom', 'EURO', '54940', '3072353', '563', '81431');
INSERT INTO public.who_global_data_import VALUES (84776, '2021-01-12', 'GB', 'The United Kingdom', 'EURO', '46169', '3118522', '529', '81960');
INSERT INTO public.who_global_data_import VALUES (84777, '2021-01-13', 'GB', 'The United Kingdom', 'EURO', '45533', '3164055', '1243', '83203');
INSERT INTO public.who_global_data_import VALUES (84778, '2021-01-14', 'GB', 'The United Kingdom', 'EURO', '47525', '3211580', '1564', '84767');
INSERT INTO public.who_global_data_import VALUES (84779, '2021-01-15', 'GB', 'The United Kingdom', 'EURO', '48682', '3260262', '1248', '86015');
INSERT INTO public.who_global_data_import VALUES (84780, '2021-01-16', 'GB', 'The United Kingdom', 'EURO', '55761', '3316023', '1280', '87295');
INSERT INTO public.who_global_data_import VALUES (84781, '2021-01-17', 'GB', 'The United Kingdom', 'EURO', '41342', '3357365', '1295', '88590');
INSERT INTO public.who_global_data_import VALUES (84782, '2021-01-18', 'GB', 'The United Kingdom', 'EURO', '38598', '3395963', '671', '89261');
INSERT INTO public.who_global_data_import VALUES (84783, '2021-01-19', 'GB', 'The United Kingdom', 'EURO', '37535', '3433498', '599', '89860');
INSERT INTO public.who_global_data_import VALUES (84784, '2021-01-20', 'GB', 'The United Kingdom', 'EURO', '33355', '3466853', '1610', '91470');
INSERT INTO public.who_global_data_import VALUES (84785, '2021-01-21', 'GB', 'The United Kingdom', 'EURO', '38905', '3505758', '1820', '93290');
INSERT INTO public.who_global_data_import VALUES (84786, '2021-01-22', 'GB', 'The United Kingdom', 'EURO', '37892', '3543650', '1290', '94580');
INSERT INTO public.who_global_data_import VALUES (84787, '2021-01-23', 'GB', 'The United Kingdom', 'EURO', '40261', '3583911', '1401', '95981');
INSERT INTO public.who_global_data_import VALUES (84788, '2021-01-24', 'GB', 'The United Kingdom', 'EURO', '33552', '3617463', '1348', '97329');
INSERT INTO public.who_global_data_import VALUES (84789, '2021-01-25', 'GB', 'The United Kingdom', 'EURO', '30004', '3647467', '610', '97939');
INSERT INTO public.who_global_data_import VALUES (84790, '2021-01-26', 'GB', 'The United Kingdom', 'EURO', '22195', '3669662', '592', '98531');
INSERT INTO public.who_global_data_import VALUES (84791, '2021-01-27', 'GB', 'The United Kingdom', 'EURO', '20088', '3689750', '1631', '100162');
INSERT INTO public.who_global_data_import VALUES (84792, '2021-01-28', 'GB', 'The United Kingdom', 'EURO', '25308', '3715058', '1725', '101887');
INSERT INTO public.who_global_data_import VALUES (84793, '2021-01-29', 'GB', 'The United Kingdom', 'EURO', '28680', '3743738', '1239', '103126');
INSERT INTO public.who_global_data_import VALUES (84794, '2021-01-30', 'GB', 'The United Kingdom', 'EURO', '29079', '3772817', '1223', '104349');
INSERT INTO public.who_global_data_import VALUES (84795, '2021-01-31', 'GB', 'The United Kingdom', 'EURO', '23275', '3796092', '1222', '105571');
INSERT INTO public.who_global_data_import VALUES (84796, '2021-02-01', 'GB', 'The United Kingdom', 'EURO', '21088', '3817180', '587', '106158');
INSERT INTO public.who_global_data_import VALUES (84797, '2021-02-02', 'GB', 'The United Kingdom', 'EURO', '18607', '3835787', '406', '106564');
INSERT INTO public.who_global_data_import VALUES (84798, '2021-02-03', 'GB', 'The United Kingdom', 'EURO', '16840', '3852627', '1449', '108013');
INSERT INTO public.who_global_data_import VALUES (84799, '2021-02-04', 'GB', 'The United Kingdom', 'EURO', '19202', '3871829', '1322', '109335');
INSERT INTO public.who_global_data_import VALUES (84800, '2021-02-05', 'GB', 'The United Kingdom', 'EURO', '20634', '3892463', '915', '110250');
INSERT INTO public.who_global_data_import VALUES (84801, '2020-01-03', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84802, '2020-01-04', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84803, '2020-01-05', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84804, '2020-01-06', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84805, '2020-01-07', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84806, '2020-01-08', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84807, '2020-01-09', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84808, '2020-01-10', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84809, '2020-01-11', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84810, '2020-01-12', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84811, '2020-01-13', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84812, '2020-01-14', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84813, '2020-01-15', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84814, '2020-01-16', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84815, '2020-01-17', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84816, '2020-01-18', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84817, '2020-01-19', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84818, '2020-01-20', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84819, '2020-01-21', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84820, '2020-01-22', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84821, '2020-01-23', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85258, '2020-02-29', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84822, '2020-01-24', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84823, '2020-01-25', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84824, '2020-01-26', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84825, '2020-01-27', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84826, '2020-01-28', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84827, '2020-01-29', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84828, '2020-01-30', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84829, '2020-01-31', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84830, '2020-02-01', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84831, '2020-02-02', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84832, '2020-02-03', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84833, '2020-02-04', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84834, '2020-02-05', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84835, '2020-02-06', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84836, '2020-02-07', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84837, '2020-02-08', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84838, '2020-02-09', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84839, '2020-02-10', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84840, '2020-02-11', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84841, '2020-02-12', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84842, '2020-02-13', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84843, '2020-02-14', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84844, '2020-02-15', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84845, '2020-02-16', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84846, '2020-02-17', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84847, '2020-02-18', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84848, '2020-02-19', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84849, '2020-02-20', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84850, '2020-02-21', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84851, '2020-02-22', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84852, '2020-02-23', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84853, '2020-02-24', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84854, '2020-02-25', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84855, '2020-02-26', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84856, '2020-02-27', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84857, '2020-02-28', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84858, '2020-02-29', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84859, '2020-03-01', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84860, '2020-03-02', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84861, '2020-03-03', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84862, '2020-03-04', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84863, '2020-03-05', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84864, '2020-03-06', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84865, '2020-03-07', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84866, '2020-03-08', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84867, '2020-03-09', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84868, '2020-03-10', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84869, '2020-03-11', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84870, '2020-03-12', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84871, '2020-03-13', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84872, '2020-03-14', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84873, '2020-03-15', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84874, '2020-03-16', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84875, '2020-03-17', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84876, '2020-03-18', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84877, '2020-03-19', 'TL', 'Timor-Leste', 'SEARO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84878, '2020-03-20', 'TL', 'Timor-Leste', 'SEARO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84879, '2020-03-21', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84880, '2020-03-22', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84881, '2020-03-23', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84882, '2020-03-24', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84883, '2020-03-25', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84884, '2020-03-26', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84885, '2020-03-27', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84886, '2020-03-28', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84887, '2020-03-29', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84888, '2020-03-30', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84889, '2020-03-31', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84890, '2020-04-01', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84891, '2020-04-02', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84892, '2020-04-03', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84893, '2020-04-04', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84894, '2020-04-05', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84895, '2020-04-06', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84896, '2020-04-07', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84897, '2020-04-08', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84898, '2020-04-09', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84899, '2020-04-10', 'TL', 'Timor-Leste', 'SEARO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84900, '2020-04-11', 'TL', 'Timor-Leste', 'SEARO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84901, '2020-04-12', 'TL', 'Timor-Leste', 'SEARO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84902, '2020-04-13', 'TL', 'Timor-Leste', 'SEARO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84903, '2020-04-14', 'TL', 'Timor-Leste', 'SEARO', '2', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84904, '2020-04-15', 'TL', 'Timor-Leste', 'SEARO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84905, '2020-04-16', 'TL', 'Timor-Leste', 'SEARO', '12', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84906, '2020-04-17', 'TL', 'Timor-Leste', 'SEARO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84907, '2020-04-18', 'TL', 'Timor-Leste', 'SEARO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84908, '2020-04-19', 'TL', 'Timor-Leste', 'SEARO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84909, '2020-04-20', 'TL', 'Timor-Leste', 'SEARO', '3', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84910, '2020-04-21', 'TL', 'Timor-Leste', 'SEARO', '1', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84911, '2020-04-22', 'TL', 'Timor-Leste', 'SEARO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84912, '2020-04-23', 'TL', 'Timor-Leste', 'SEARO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84913, '2020-04-24', 'TL', 'Timor-Leste', 'SEARO', '1', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84914, '2020-04-25', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84915, '2020-04-26', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84916, '2020-04-27', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84917, '2020-04-28', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84918, '2020-04-29', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84919, '2020-04-30', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84920, '2020-05-01', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84921, '2020-05-02', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84922, '2020-05-03', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84923, '2020-05-04', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84924, '2020-05-05', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84925, '2020-05-06', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84926, '2020-05-07', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84927, '2020-05-08', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84928, '2020-05-09', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84929, '2020-05-10', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84930, '2020-05-11', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84931, '2020-05-12', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84932, '2020-05-13', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84933, '2020-05-14', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84934, '2020-05-15', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84935, '2020-05-16', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84936, '2020-05-17', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84937, '2020-05-18', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84938, '2020-05-19', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84939, '2020-05-20', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84940, '2020-05-21', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84941, '2020-05-22', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84942, '2020-05-23', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84943, '2020-05-24', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84944, '2020-05-25', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84945, '2020-05-26', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84946, '2020-05-27', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84947, '2020-05-28', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84948, '2020-05-29', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84949, '2020-05-30', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84950, '2020-05-31', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84951, '2020-06-01', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84952, '2020-06-02', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84953, '2020-06-03', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84954, '2020-06-04', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84955, '2020-06-05', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84956, '2020-06-06', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84957, '2020-06-07', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84958, '2020-06-08', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84959, '2020-06-09', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84960, '2020-06-10', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84961, '2020-06-11', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84962, '2020-06-12', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84963, '2020-06-13', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84964, '2020-06-14', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84965, '2020-06-15', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84966, '2020-06-16', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84967, '2020-06-17', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84968, '2020-06-18', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84969, '2020-06-19', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84970, '2020-06-20', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84971, '2020-06-21', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84972, '2020-06-22', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84973, '2020-06-23', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84974, '2020-06-24', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84975, '2020-06-25', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84976, '2020-06-26', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84977, '2020-06-27', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84978, '2020-06-28', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84979, '2020-06-29', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84980, '2020-06-30', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84981, '2020-07-01', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84982, '2020-07-02', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84983, '2020-07-03', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84984, '2020-07-04', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84985, '2020-07-05', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84986, '2020-07-06', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84987, '2020-07-07', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84988, '2020-07-08', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84989, '2020-07-09', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84990, '2020-07-10', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84991, '2020-07-11', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84992, '2020-07-12', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84993, '2020-07-13', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84994, '2020-07-14', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84995, '2020-07-15', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84996, '2020-07-16', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84997, '2020-07-17', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84998, '2020-07-18', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (84999, '2020-07-19', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85000, '2020-07-20', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85001, '2020-07-21', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85002, '2020-07-22', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85003, '2020-07-23', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85004, '2020-07-24', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85005, '2020-07-25', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85006, '2020-07-26', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85007, '2020-07-27', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85008, '2020-07-28', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85009, '2020-07-29', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85010, '2020-07-30', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85011, '2020-07-31', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85012, '2020-08-01', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85013, '2020-08-02', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85014, '2020-08-03', 'TL', 'Timor-Leste', 'SEARO', '0', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85015, '2020-08-04', 'TL', 'Timor-Leste', 'SEARO', '1', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85016, '2020-08-05', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85017, '2020-08-06', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85018, '2020-08-07', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85019, '2020-08-08', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85020, '2020-08-09', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85021, '2020-08-10', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85022, '2020-08-11', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85023, '2020-08-12', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85024, '2020-08-13', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85025, '2020-08-14', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85026, '2020-08-15', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85027, '2020-08-16', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85028, '2020-08-17', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85029, '2020-08-18', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85030, '2020-08-19', 'TL', 'Timor-Leste', 'SEARO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85031, '2020-08-20', 'TL', 'Timor-Leste', 'SEARO', '1', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85032, '2020-08-21', 'TL', 'Timor-Leste', 'SEARO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85033, '2020-08-22', 'TL', 'Timor-Leste', 'SEARO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85034, '2020-08-23', 'TL', 'Timor-Leste', 'SEARO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85035, '2020-08-24', 'TL', 'Timor-Leste', 'SEARO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85036, '2020-08-25', 'TL', 'Timor-Leste', 'SEARO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85037, '2020-08-26', 'TL', 'Timor-Leste', 'SEARO', '0', '26', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85038, '2020-08-27', 'TL', 'Timor-Leste', 'SEARO', '1', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85039, '2020-08-28', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85040, '2020-08-29', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85041, '2020-08-30', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85042, '2020-08-31', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85043, '2020-09-01', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85044, '2020-09-02', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85045, '2020-09-03', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85046, '2020-09-04', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85047, '2020-09-05', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85048, '2020-09-06', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85049, '2020-09-07', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85050, '2020-09-08', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85051, '2020-09-09', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85052, '2020-09-10', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85053, '2020-09-11', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85054, '2020-09-12', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85055, '2020-09-13', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85056, '2020-09-14', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85057, '2020-09-15', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85058, '2020-09-16', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85059, '2020-09-17', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85060, '2020-09-18', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85061, '2020-09-19', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85062, '2020-09-20', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85063, '2020-09-21', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85064, '2020-09-22', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85065, '2020-09-23', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85066, '2020-09-24', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85067, '2020-09-25', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85068, '2020-09-26', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85069, '2020-09-27', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85070, '2020-09-28', 'TL', 'Timor-Leste', 'SEARO', '0', '27', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85071, '2020-09-29', 'TL', 'Timor-Leste', 'SEARO', '1', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85072, '2020-09-30', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85073, '2020-10-01', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85074, '2020-10-02', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85075, '2020-10-03', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85076, '2020-10-04', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85077, '2020-10-05', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85078, '2020-10-06', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85079, '2020-10-07', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85080, '2020-10-08', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85081, '2020-10-09', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85082, '2020-10-10', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85083, '2020-10-11', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85084, '2020-10-12', 'TL', 'Timor-Leste', 'SEARO', '0', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85085, '2020-10-13', 'TL', 'Timor-Leste', 'SEARO', '1', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85086, '2020-10-14', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85087, '2020-10-15', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85088, '2020-10-16', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85089, '2020-10-17', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85090, '2020-10-18', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85091, '2020-10-19', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85092, '2020-10-20', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85093, '2020-10-21', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85094, '2020-10-22', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85095, '2020-10-23', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85096, '2020-10-24', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85097, '2020-10-25', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85098, '2020-10-26', 'TL', 'Timor-Leste', 'SEARO', '0', '29', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85099, '2020-10-27', 'TL', 'Timor-Leste', 'SEARO', '1', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85100, '2020-10-28', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85101, '2020-10-29', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85102, '2020-10-30', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85103, '2020-10-31', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85104, '2020-11-01', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85105, '2020-11-02', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85106, '2020-11-03', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85107, '2020-11-04', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85108, '2020-11-05', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85109, '2020-11-06', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85110, '2020-11-07', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85111, '2020-11-08', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85112, '2020-11-09', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85113, '2020-11-10', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85114, '2020-11-11', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85115, '2020-11-12', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85116, '2020-11-13', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85117, '2020-11-14', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85118, '2020-11-15', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85119, '2020-11-16', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85120, '2020-11-17', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85121, '2020-11-18', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85122, '2020-11-19', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85123, '2020-11-20', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85124, '2020-11-21', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85125, '2020-11-22', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85126, '2020-11-23', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85127, '2020-11-24', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85128, '2020-11-25', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85129, '2020-11-26', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85130, '2020-11-27', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85131, '2020-11-28', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85132, '2020-11-29', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85133, '2020-11-30', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85134, '2020-12-01', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85135, '2020-12-02', 'TL', 'Timor-Leste', 'SEARO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85136, '2020-12-03', 'TL', 'Timor-Leste', 'SEARO', '1', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85137, '2020-12-04', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85138, '2020-12-05', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85139, '2020-12-06', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85140, '2020-12-07', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85141, '2020-12-08', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85142, '2020-12-09', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85143, '2020-12-10', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85144, '2020-12-11', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85145, '2020-12-12', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85146, '2020-12-13', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85147, '2020-12-14', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85148, '2020-12-15', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85149, '2020-12-16', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85150, '2020-12-17', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85151, '2020-12-18', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85152, '2020-12-19', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85153, '2020-12-20', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85154, '2020-12-21', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85155, '2020-12-22', 'TL', 'Timor-Leste', 'SEARO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85156, '2020-12-23', 'TL', 'Timor-Leste', 'SEARO', '2', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85157, '2020-12-24', 'TL', 'Timor-Leste', 'SEARO', '3', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85158, '2020-12-25', 'TL', 'Timor-Leste', 'SEARO', '5', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85159, '2020-12-26', 'TL', 'Timor-Leste', 'SEARO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85160, '2020-12-27', 'TL', 'Timor-Leste', 'SEARO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85161, '2020-12-28', 'TL', 'Timor-Leste', 'SEARO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85162, '2020-12-29', 'TL', 'Timor-Leste', 'SEARO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85163, '2020-12-30', 'TL', 'Timor-Leste', 'SEARO', '3', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85164, '2020-12-31', 'TL', 'Timor-Leste', 'SEARO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85165, '2021-01-01', 'TL', 'Timor-Leste', 'SEARO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85166, '2021-01-02', 'TL', 'Timor-Leste', 'SEARO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85167, '2021-01-03', 'TL', 'Timor-Leste', 'SEARO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85168, '2021-01-04', 'TL', 'Timor-Leste', 'SEARO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85169, '2021-01-05', 'TL', 'Timor-Leste', 'SEARO', '0', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85170, '2021-01-06', 'TL', 'Timor-Leste', 'SEARO', '5', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85171, '2021-01-07', 'TL', 'Timor-Leste', 'SEARO', '0', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85172, '2021-01-08', 'TL', 'Timor-Leste', 'SEARO', '0', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85173, '2021-01-09', 'TL', 'Timor-Leste', 'SEARO', '0', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85174, '2021-01-10', 'TL', 'Timor-Leste', 'SEARO', '0', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85175, '2021-01-11', 'TL', 'Timor-Leste', 'SEARO', '0', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85176, '2021-01-12', 'TL', 'Timor-Leste', 'SEARO', '0', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85177, '2021-01-13', 'TL', 'Timor-Leste', 'SEARO', '2', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85178, '2021-01-14', 'TL', 'Timor-Leste', 'SEARO', '0', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85179, '2021-01-15', 'TL', 'Timor-Leste', 'SEARO', '0', '51', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85180, '2021-01-16', 'TL', 'Timor-Leste', 'SEARO', '1', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85181, '2021-01-17', 'TL', 'Timor-Leste', 'SEARO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85182, '2021-01-18', 'TL', 'Timor-Leste', 'SEARO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85183, '2021-01-19', 'TL', 'Timor-Leste', 'SEARO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85184, '2021-01-20', 'TL', 'Timor-Leste', 'SEARO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85185, '2021-01-21', 'TL', 'Timor-Leste', 'SEARO', '1', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85186, '2021-01-22', 'TL', 'Timor-Leste', 'SEARO', '0', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85187, '2021-01-23', 'TL', 'Timor-Leste', 'SEARO', '11', '64', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85188, '2021-01-24', 'TL', 'Timor-Leste', 'SEARO', '3', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85189, '2021-01-25', 'TL', 'Timor-Leste', 'SEARO', '0', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85190, '2021-01-26', 'TL', 'Timor-Leste', 'SEARO', '0', '67', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85191, '2021-01-27', 'TL', 'Timor-Leste', 'SEARO', '1', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85192, '2021-01-28', 'TL', 'Timor-Leste', 'SEARO', '0', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85193, '2021-01-29', 'TL', 'Timor-Leste', 'SEARO', '1', '69', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85194, '2021-01-30', 'TL', 'Timor-Leste', 'SEARO', '1', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85195, '2021-01-31', 'TL', 'Timor-Leste', 'SEARO', '0', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85196, '2021-02-01', 'TL', 'Timor-Leste', 'SEARO', '0', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85197, '2021-02-02', 'TL', 'Timor-Leste', 'SEARO', '5', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85198, '2021-02-03', 'TL', 'Timor-Leste', 'SEARO', '2', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85199, '2021-02-04', 'TL', 'Timor-Leste', 'SEARO', '3', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85200, '2021-02-05', 'TL', 'Timor-Leste', 'SEARO', '0', '80', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85201, '2020-01-03', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85202, '2020-01-04', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85203, '2020-01-05', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85204, '2020-01-06', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85205, '2020-01-07', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85206, '2020-01-08', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85207, '2020-01-09', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85208, '2020-01-10', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85209, '2020-01-11', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85210, '2020-01-12', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85211, '2020-01-13', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85212, '2020-01-14', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85213, '2020-01-15', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85214, '2020-01-16', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85215, '2020-01-17', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85216, '2020-01-18', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85217, '2020-01-19', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85218, '2020-01-20', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85219, '2020-01-21', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85220, '2020-01-22', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85221, '2020-01-23', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85222, '2020-01-24', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85223, '2020-01-25', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85224, '2020-01-26', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85225, '2020-01-27', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85226, '2020-01-28', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85227, '2020-01-29', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85228, '2020-01-30', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85229, '2020-01-31', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85230, '2020-02-01', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85231, '2020-02-02', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85232, '2020-02-03', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85233, '2020-02-04', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85234, '2020-02-05', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85235, '2020-02-06', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85236, '2020-02-07', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85237, '2020-02-08', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85238, '2020-02-09', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85239, '2020-02-10', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85240, '2020-02-11', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85241, '2020-02-12', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85242, '2020-02-13', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85243, '2020-02-14', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85244, '2020-02-15', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85245, '2020-02-16', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85246, '2020-02-17', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85247, '2020-02-18', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85248, '2020-02-19', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85249, '2020-02-20', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85250, '2020-02-21', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85251, '2020-02-22', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85252, '2020-02-23', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85253, '2020-02-24', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85254, '2020-02-25', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85255, '2020-02-26', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85259, '2020-03-01', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85260, '2020-03-02', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85261, '2020-03-03', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85262, '2020-03-04', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85263, '2020-03-05', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85264, '2020-03-06', 'TG', 'Togo', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85265, '2020-03-07', 'TG', 'Togo', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85266, '2020-03-08', 'TG', 'Togo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85267, '2020-03-09', 'TG', 'Togo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85268, '2020-03-10', 'TG', 'Togo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85269, '2020-03-11', 'TG', 'Togo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85270, '2020-03-12', 'TG', 'Togo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85271, '2020-03-13', 'TG', 'Togo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85272, '2020-03-14', 'TG', 'Togo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85273, '2020-03-15', 'TG', 'Togo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85274, '2020-03-16', 'TG', 'Togo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85275, '2020-03-17', 'TG', 'Togo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85276, '2020-03-18', 'TG', 'Togo', 'AFRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85277, '2020-03-19', 'TG', 'Togo', 'AFRO', '8', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85278, '2020-03-20', 'TG', 'Togo', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85279, '2020-03-21', 'TG', 'Togo', 'AFRO', '2', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85280, '2020-03-22', 'TG', 'Togo', 'AFRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85281, '2020-03-23', 'TG', 'Togo', 'AFRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85282, '2020-03-24', 'TG', 'Togo', 'AFRO', '2', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85283, '2020-03-25', 'TG', 'Togo', 'AFRO', '2', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85284, '2020-03-26', 'TG', 'Togo', 'AFRO', '3', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85285, '2020-03-27', 'TG', 'Togo', 'AFRO', '1', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85286, '2020-03-28', 'TG', 'Togo', 'AFRO', '1', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85287, '2020-03-29', 'TG', 'Togo', 'AFRO', '3', '28', '1', '1');
INSERT INTO public.who_global_data_import VALUES (85288, '2020-03-30', 'TG', 'Togo', 'AFRO', '0', '28', '0', '1');
INSERT INTO public.who_global_data_import VALUES (85289, '2020-03-31', 'TG', 'Togo', 'AFRO', '6', '34', '0', '1');
INSERT INTO public.who_global_data_import VALUES (85290, '2020-04-01', 'TG', 'Togo', 'AFRO', '0', '34', '0', '1');
INSERT INTO public.who_global_data_import VALUES (85291, '2020-04-02', 'TG', 'Togo', 'AFRO', '2', '36', '1', '2');
INSERT INTO public.who_global_data_import VALUES (85292, '2020-04-03', 'TG', 'Togo', 'AFRO', '3', '39', '0', '2');
INSERT INTO public.who_global_data_import VALUES (85293, '2020-04-04', 'TG', 'Togo', 'AFRO', '0', '39', '0', '2');
INSERT INTO public.who_global_data_import VALUES (85294, '2020-04-05', 'TG', 'Togo', 'AFRO', '1', '40', '1', '3');
INSERT INTO public.who_global_data_import VALUES (85295, '2020-04-06', 'TG', 'Togo', 'AFRO', '4', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (85296, '2020-04-07', 'TG', 'Togo', 'AFRO', '0', '44', '0', '3');
INSERT INTO public.who_global_data_import VALUES (85297, '2020-04-08', 'TG', 'Togo', 'AFRO', '14', '58', '0', '3');
INSERT INTO public.who_global_data_import VALUES (85298, '2020-04-09', 'TG', 'Togo', 'AFRO', '12', '70', '0', '3');
INSERT INTO public.who_global_data_import VALUES (85299, '2020-04-10', 'TG', 'Togo', 'AFRO', '3', '73', '0', '3');
INSERT INTO public.who_global_data_import VALUES (85300, '2020-04-11', 'TG', 'Togo', 'AFRO', '0', '73', '0', '3');
INSERT INTO public.who_global_data_import VALUES (85301, '2020-04-12', 'TG', 'Togo', 'AFRO', '0', '73', '0', '3');
INSERT INTO public.who_global_data_import VALUES (85302, '2020-04-13', 'TG', 'Togo', 'AFRO', '3', '76', '0', '3');
INSERT INTO public.who_global_data_import VALUES (85303, '2020-04-14', 'TG', 'Togo', 'AFRO', '0', '76', '0', '3');
INSERT INTO public.who_global_data_import VALUES (85304, '2020-04-15', 'TG', 'Togo', 'AFRO', '1', '77', '0', '3');
INSERT INTO public.who_global_data_import VALUES (85305, '2020-04-16', 'TG', 'Togo', 'AFRO', '0', '77', '0', '3');
INSERT INTO public.who_global_data_import VALUES (85306, '2020-04-17', 'TG', 'Togo', 'AFRO', '4', '81', '2', '5');
INSERT INTO public.who_global_data_import VALUES (85307, '2020-04-18', 'TG', 'Togo', 'AFRO', '2', '83', '0', '5');
INSERT INTO public.who_global_data_import VALUES (85308, '2020-04-19', 'TG', 'Togo', 'AFRO', '0', '83', '0', '5');
INSERT INTO public.who_global_data_import VALUES (85309, '2020-04-20', 'TG', 'Togo', 'AFRO', '0', '83', '0', '5');
INSERT INTO public.who_global_data_import VALUES (85310, '2020-04-21', 'TG', 'Togo', 'AFRO', '1', '84', '0', '5');
INSERT INTO public.who_global_data_import VALUES (85311, '2020-04-22', 'TG', 'Togo', 'AFRO', '2', '86', '1', '6');
INSERT INTO public.who_global_data_import VALUES (85312, '2020-04-23', 'TG', 'Togo', 'AFRO', '2', '88', '0', '6');
INSERT INTO public.who_global_data_import VALUES (85313, '2020-04-24', 'TG', 'Togo', 'AFRO', '0', '88', '0', '6');
INSERT INTO public.who_global_data_import VALUES (85314, '2020-04-25', 'TG', 'Togo', 'AFRO', '2', '90', '0', '6');
INSERT INTO public.who_global_data_import VALUES (85315, '2020-04-26', 'TG', 'Togo', 'AFRO', '6', '96', '0', '6');
INSERT INTO public.who_global_data_import VALUES (85316, '2020-04-27', 'TG', 'Togo', 'AFRO', '2', '98', '0', '6');
INSERT INTO public.who_global_data_import VALUES (85317, '2020-04-28', 'TG', 'Togo', 'AFRO', '1', '99', '0', '6');
INSERT INTO public.who_global_data_import VALUES (85318, '2020-04-29', 'TG', 'Togo', 'AFRO', '0', '99', '0', '6');
INSERT INTO public.who_global_data_import VALUES (85319, '2020-04-30', 'TG', 'Togo', 'AFRO', '10', '109', '1', '7');
INSERT INTO public.who_global_data_import VALUES (85320, '2020-05-01', 'TG', 'Togo', 'AFRO', '7', '116', '2', '9');
INSERT INTO public.who_global_data_import VALUES (85321, '2020-05-02', 'TG', 'Togo', 'AFRO', '7', '123', '0', '9');
INSERT INTO public.who_global_data_import VALUES (85322, '2020-05-03', 'TG', 'Togo', 'AFRO', '0', '123', '0', '9');
INSERT INTO public.who_global_data_import VALUES (85323, '2020-05-04', 'TG', 'Togo', 'AFRO', '1', '124', '0', '9');
INSERT INTO public.who_global_data_import VALUES (85324, '2020-05-05', 'TG', 'Togo', 'AFRO', '2', '126', '0', '9');
INSERT INTO public.who_global_data_import VALUES (85325, '2020-05-06', 'TG', 'Togo', 'AFRO', '2', '128', '0', '9');
INSERT INTO public.who_global_data_import VALUES (85326, '2020-05-07', 'TG', 'Togo', 'AFRO', '0', '128', '0', '9');
INSERT INTO public.who_global_data_import VALUES (85327, '2020-05-08', 'TG', 'Togo', 'AFRO', '7', '135', '0', '9');
INSERT INTO public.who_global_data_import VALUES (85328, '2020-05-09', 'TG', 'Togo', 'AFRO', '10', '145', '1', '10');
INSERT INTO public.who_global_data_import VALUES (85329, '2020-05-10', 'TG', 'Togo', 'AFRO', '8', '153', '0', '10');
INSERT INTO public.who_global_data_import VALUES (85330, '2020-05-11', 'TG', 'Togo', 'AFRO', '20', '173', '1', '11');
INSERT INTO public.who_global_data_import VALUES (85331, '2020-05-12', 'TG', 'Togo', 'AFRO', '8', '181', '0', '11');
INSERT INTO public.who_global_data_import VALUES (85332, '2020-05-13', 'TG', 'Togo', 'AFRO', '18', '199', '0', '11');
INSERT INTO public.who_global_data_import VALUES (85333, '2020-05-14', 'TG', 'Togo', 'AFRO', '20', '219', '0', '11');
INSERT INTO public.who_global_data_import VALUES (85334, '2020-05-15', 'TG', 'Togo', 'AFRO', '19', '238', '0', '11');
INSERT INTO public.who_global_data_import VALUES (85335, '2020-05-16', 'TG', 'Togo', 'AFRO', '25', '263', '0', '11');
INSERT INTO public.who_global_data_import VALUES (85336, '2020-05-17', 'TG', 'Togo', 'AFRO', '35', '298', '0', '11');
INSERT INTO public.who_global_data_import VALUES (85337, '2020-05-18', 'TG', 'Togo', 'AFRO', '3', '301', '0', '11');
INSERT INTO public.who_global_data_import VALUES (85338, '2020-05-19', 'TG', 'Togo', 'AFRO', '29', '330', '1', '12');
INSERT INTO public.who_global_data_import VALUES (85339, '2020-05-20', 'TG', 'Togo', 'AFRO', '8', '338', '0', '12');
INSERT INTO public.who_global_data_import VALUES (85340, '2020-05-21', 'TG', 'Togo', 'AFRO', '0', '338', '0', '12');
INSERT INTO public.who_global_data_import VALUES (85341, '2020-05-22', 'TG', 'Togo', 'AFRO', '16', '354', '0', '12');
INSERT INTO public.who_global_data_import VALUES (85342, '2020-05-23', 'TG', 'Togo', 'AFRO', '9', '363', '0', '12');
INSERT INTO public.who_global_data_import VALUES (85343, '2020-05-24', 'TG', 'Togo', 'AFRO', '10', '373', '0', '12');
INSERT INTO public.who_global_data_import VALUES (85344, '2020-05-25', 'TG', 'Togo', 'AFRO', '8', '381', '0', '12');
INSERT INTO public.who_global_data_import VALUES (85345, '2020-05-26', 'TG', 'Togo', 'AFRO', '5', '386', '1', '13');
INSERT INTO public.who_global_data_import VALUES (85346, '2020-05-27', 'TG', 'Togo', 'AFRO', '5', '391', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85347, '2020-05-28', 'TG', 'Togo', 'AFRO', '4', '395', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85348, '2020-05-29', 'TG', 'Togo', 'AFRO', '27', '422', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85349, '2020-05-30', 'TG', 'Togo', 'AFRO', '6', '428', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85350, '2020-05-31', 'TG', 'Togo', 'AFRO', '0', '428', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85351, '2020-06-01', 'TG', 'Togo', 'AFRO', '14', '442', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85352, '2020-06-02', 'TG', 'Togo', 'AFRO', '1', '443', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85353, '2020-06-03', 'TG', 'Togo', 'AFRO', '2', '445', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85354, '2020-06-04', 'TG', 'Togo', 'AFRO', '7', '452', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85355, '2020-06-05', 'TG', 'Togo', 'AFRO', '13', '465', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85356, '2020-06-06', 'TG', 'Togo', 'AFRO', '20', '485', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85357, '2020-06-07', 'TG', 'Togo', 'AFRO', '2', '487', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85358, '2020-06-08', 'TG', 'Togo', 'AFRO', '8', '495', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85359, '2020-06-09', 'TG', 'Togo', 'AFRO', '2', '497', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85360, '2020-06-10', 'TG', 'Togo', 'AFRO', '0', '497', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85361, '2020-06-11', 'TG', 'Togo', 'AFRO', '25', '522', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85362, '2020-06-12', 'TG', 'Togo', 'AFRO', '0', '522', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85363, '2020-06-13', 'TG', 'Togo', 'AFRO', '2', '524', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85364, '2020-06-14', 'TG', 'Togo', 'AFRO', '1', '525', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85365, '2020-06-15', 'TG', 'Togo', 'AFRO', '5', '530', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85366, '2020-06-16', 'TG', 'Togo', 'AFRO', '1', '531', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85367, '2020-06-17', 'TG', 'Togo', 'AFRO', '6', '537', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85368, '2020-06-18', 'TG', 'Togo', 'AFRO', '0', '537', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85369, '2020-06-19', 'TG', 'Togo', 'AFRO', '7', '544', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85370, '2020-06-20', 'TG', 'Togo', 'AFRO', '11', '555', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85371, '2020-06-21', 'TG', 'Togo', 'AFRO', '6', '561', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85372, '2020-06-22', 'TG', 'Togo', 'AFRO', '8', '569', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85373, '2020-06-23', 'TG', 'Togo', 'AFRO', '0', '569', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85374, '2020-06-24', 'TG', 'Togo', 'AFRO', '7', '576', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85375, '2020-06-25', 'TG', 'Togo', 'AFRO', '0', '576', '0', '13');
INSERT INTO public.who_global_data_import VALUES (85376, '2020-06-26', 'TG', 'Togo', 'AFRO', '12', '588', '1', '14');
INSERT INTO public.who_global_data_import VALUES (85377, '2020-06-27', 'TG', 'Togo', 'AFRO', '3', '591', '0', '14');
INSERT INTO public.who_global_data_import VALUES (85378, '2020-06-28', 'TG', 'Togo', 'AFRO', '24', '615', '0', '14');
INSERT INTO public.who_global_data_import VALUES (85379, '2020-06-29', 'TG', 'Togo', 'AFRO', '0', '615', '0', '14');
INSERT INTO public.who_global_data_import VALUES (85380, '2020-06-30', 'TG', 'Togo', 'AFRO', '27', '642', '0', '14');
INSERT INTO public.who_global_data_import VALUES (85381, '2020-07-01', 'TG', 'Togo', 'AFRO', '1', '643', '0', '14');
INSERT INTO public.who_global_data_import VALUES (85382, '2020-07-02', 'TG', 'Togo', 'AFRO', '18', '661', '0', '14');
INSERT INTO public.who_global_data_import VALUES (85383, '2020-07-03', 'TG', 'Togo', 'AFRO', '6', '667', '0', '14');
INSERT INTO public.who_global_data_import VALUES (85384, '2020-07-04', 'TG', 'Togo', 'AFRO', '4', '671', '0', '14');
INSERT INTO public.who_global_data_import VALUES (85385, '2020-07-05', 'TG', 'Togo', 'AFRO', '5', '676', '1', '15');
INSERT INTO public.who_global_data_import VALUES (85386, '2020-07-06', 'TG', 'Togo', 'AFRO', '4', '680', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85387, '2020-07-07', 'TG', 'Togo', 'AFRO', '0', '680', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85388, '2020-07-08', 'TG', 'Togo', 'AFRO', '9', '689', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85389, '2020-07-09', 'TG', 'Togo', 'AFRO', '6', '695', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85390, '2020-07-10', 'TG', 'Togo', 'AFRO', '9', '704', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85391, '2020-07-11', 'TG', 'Togo', 'AFRO', '6', '710', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85392, '2020-07-12', 'TG', 'Togo', 'AFRO', '0', '710', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85393, '2020-07-13', 'TG', 'Togo', 'AFRO', '10', '720', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85394, '2020-07-14', 'TG', 'Togo', 'AFRO', '0', '720', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85395, '2020-07-15', 'TG', 'Togo', 'AFRO', '11', '731', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85396, '2020-07-16', 'TG', 'Togo', 'AFRO', '9', '740', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85397, '2020-07-17', 'TG', 'Togo', 'AFRO', '9', '749', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85398, '2020-07-18', 'TG', 'Togo', 'AFRO', '17', '766', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85399, '2020-07-19', 'TG', 'Togo', 'AFRO', '8', '774', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85400, '2020-07-20', 'TG', 'Togo', 'AFRO', '0', '774', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85401, '2020-07-21', 'TG', 'Togo', 'AFRO', '9', '783', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85402, '2020-07-22', 'TG', 'Togo', 'AFRO', '7', '790', '0', '15');
INSERT INTO public.who_global_data_import VALUES (85403, '2020-07-23', 'TG', 'Togo', 'AFRO', '16', '806', '1', '16');
INSERT INTO public.who_global_data_import VALUES (85404, '2020-07-24', 'TG', 'Togo', 'AFRO', '22', '828', '0', '16');
INSERT INTO public.who_global_data_import VALUES (85405, '2020-07-25', 'TG', 'Togo', 'AFRO', '11', '839', '1', '17');
INSERT INTO public.who_global_data_import VALUES (85406, '2020-07-26', 'TG', 'Togo', 'AFRO', '14', '853', '0', '17');
INSERT INTO public.who_global_data_import VALUES (85407, '2020-07-27', 'TG', 'Togo', 'AFRO', '15', '868', '1', '18');
INSERT INTO public.who_global_data_import VALUES (85408, '2020-07-28', 'TG', 'Togo', 'AFRO', '6', '874', '0', '18');
INSERT INTO public.who_global_data_import VALUES (85409, '2020-07-29', 'TG', 'Togo', 'AFRO', '0', '874', '0', '18');
INSERT INTO public.who_global_data_import VALUES (85410, '2020-07-30', 'TG', 'Togo', 'AFRO', '22', '896', '0', '18');
INSERT INTO public.who_global_data_import VALUES (85411, '2020-07-31', 'TG', 'Togo', 'AFRO', '12', '908', '0', '18');
INSERT INTO public.who_global_data_import VALUES (85412, '2020-08-01', 'TG', 'Togo', 'AFRO', '19', '927', '0', '18');
INSERT INTO public.who_global_data_import VALUES (85413, '2020-08-02', 'TG', 'Togo', 'AFRO', '0', '927', '0', '18');
INSERT INTO public.who_global_data_import VALUES (85414, '2020-08-03', 'TG', 'Togo', 'AFRO', '0', '927', '0', '18');
INSERT INTO public.who_global_data_import VALUES (85415, '2020-08-04', 'TG', 'Togo', 'AFRO', '34', '961', '1', '19');
INSERT INTO public.who_global_data_import VALUES (85416, '2020-08-05', 'TG', 'Togo', 'AFRO', '15', '976', '0', '19');
INSERT INTO public.who_global_data_import VALUES (85417, '2020-08-06', 'TG', 'Togo', 'AFRO', '12', '988', '0', '19');
INSERT INTO public.who_global_data_import VALUES (85418, '2020-08-07', 'TG', 'Togo', 'AFRO', '13', '1001', '2', '21');
INSERT INTO public.who_global_data_import VALUES (85419, '2020-08-08', 'TG', 'Togo', 'AFRO', '11', '1012', '1', '22');
INSERT INTO public.who_global_data_import VALUES (85420, '2020-08-09', 'TG', 'Togo', 'AFRO', '0', '1012', '0', '22');
INSERT INTO public.who_global_data_import VALUES (85421, '2020-08-10', 'TG', 'Togo', 'AFRO', '34', '1046', '0', '22');
INSERT INTO public.who_global_data_import VALUES (85422, '2020-08-11', 'TG', 'Togo', 'AFRO', '14', '1060', '1', '23');
INSERT INTO public.who_global_data_import VALUES (85423, '2020-08-12', 'TG', 'Togo', 'AFRO', '7', '1067', '2', '25');
INSERT INTO public.who_global_data_import VALUES (85424, '2020-08-13', 'TG', 'Togo', 'AFRO', '0', '1067', '0', '25');
INSERT INTO public.who_global_data_import VALUES (85425, '2020-08-14', 'TG', 'Togo', 'AFRO', '25', '1092', '1', '26');
INSERT INTO public.who_global_data_import VALUES (85426, '2020-08-15', 'TG', 'Togo', 'AFRO', '0', '1092', '0', '26');
INSERT INTO public.who_global_data_import VALUES (85427, '2020-08-16', 'TG', 'Togo', 'AFRO', '0', '1092', '0', '26');
INSERT INTO public.who_global_data_import VALUES (85428, '2020-08-17', 'TG', 'Togo', 'AFRO', '55', '1147', '1', '27');
INSERT INTO public.who_global_data_import VALUES (85429, '2020-08-18', 'TG', 'Togo', 'AFRO', '0', '1147', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85430, '2020-08-19', 'TG', 'Togo', 'AFRO', '7', '1154', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85431, '2020-08-20', 'TG', 'Togo', 'AFRO', '19', '1173', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85432, '2020-08-21', 'TG', 'Togo', 'AFRO', '17', '1190', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85433, '2020-08-22', 'TG', 'Togo', 'AFRO', '22', '1212', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85434, '2020-08-23', 'TG', 'Togo', 'AFRO', '0', '1212', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85435, '2020-08-24', 'TG', 'Togo', 'AFRO', '65', '1277', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85436, '2020-08-25', 'TG', 'Togo', 'AFRO', '18', '1295', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85437, '2020-08-26', 'TG', 'Togo', 'AFRO', '14', '1309', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85438, '2020-08-27', 'TG', 'Togo', 'AFRO', '0', '1309', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85439, '2020-08-28', 'TG', 'Togo', 'AFRO', '17', '1326', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85440, '2020-08-29', 'TG', 'Togo', 'AFRO', '15', '1341', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85441, '2020-08-30', 'TG', 'Togo', 'AFRO', '49', '1390', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85442, '2020-08-31', 'TG', 'Togo', 'AFRO', '6', '1396', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85443, '2020-09-01', 'TG', 'Togo', 'AFRO', '0', '1396', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85444, '2020-09-02', 'TG', 'Togo', 'AFRO', '4', '1400', '0', '27');
INSERT INTO public.who_global_data_import VALUES (85445, '2020-09-03', 'TG', 'Togo', 'AFRO', '16', '1416', '1', '28');
INSERT INTO public.who_global_data_import VALUES (85446, '2020-09-04', 'TG', 'Togo', 'AFRO', '27', '1443', '3', '31');
INSERT INTO public.who_global_data_import VALUES (85447, '2020-09-05', 'TG', 'Togo', 'AFRO', '0', '1443', '0', '31');
INSERT INTO public.who_global_data_import VALUES (85448, '2020-09-06', 'TG', 'Togo', 'AFRO', '0', '1443', '0', '31');
INSERT INTO public.who_global_data_import VALUES (85449, '2020-09-07', 'TG', 'Togo', 'AFRO', '14', '1457', '0', '31');
INSERT INTO public.who_global_data_import VALUES (85450, '2020-09-08', 'TG', 'Togo', 'AFRO', '31', '1488', '1', '32');
INSERT INTO public.who_global_data_import VALUES (85451, '2020-09-09', 'TG', 'Togo', 'AFRO', '5', '1493', '1', '33');
INSERT INTO public.who_global_data_import VALUES (85452, '2020-09-10', 'TG', 'Togo', 'AFRO', '35', '1528', '3', '36');
INSERT INTO public.who_global_data_import VALUES (85453, '2020-09-11', 'TG', 'Togo', 'AFRO', '9', '1537', '1', '37');
INSERT INTO public.who_global_data_import VALUES (85454, '2020-09-12', 'TG', 'Togo', 'AFRO', '11', '1548', '0', '37');
INSERT INTO public.who_global_data_import VALUES (85455, '2020-09-13', 'TG', 'Togo', 'AFRO', '7', '1555', '0', '37');
INSERT INTO public.who_global_data_import VALUES (85456, '2020-09-14', 'TG', 'Togo', 'AFRO', '17', '1572', '0', '37');
INSERT INTO public.who_global_data_import VALUES (85457, '2020-09-15', 'TG', 'Togo', 'AFRO', '6', '1578', '3', '40');
INSERT INTO public.who_global_data_import VALUES (85458, '2020-09-16', 'TG', 'Togo', 'AFRO', '17', '1595', '0', '40');
INSERT INTO public.who_global_data_import VALUES (85459, '2020-09-17', 'TG', 'Togo', 'AFRO', '13', '1608', '0', '40');
INSERT INTO public.who_global_data_import VALUES (85460, '2020-09-18', 'TG', 'Togo', 'AFRO', '10', '1618', '1', '41');
INSERT INTO public.who_global_data_import VALUES (85461, '2020-09-19', 'TG', 'Togo', 'AFRO', '22', '1640', '0', '41');
INSERT INTO public.who_global_data_import VALUES (85462, '2020-09-20', 'TG', 'Togo', 'AFRO', '0', '1640', '0', '41');
INSERT INTO public.who_global_data_import VALUES (85463, '2020-09-21', 'TG', 'Togo', 'AFRO', '26', '1666', '0', '41');
INSERT INTO public.who_global_data_import VALUES (85464, '2020-09-22', 'TG', 'Togo', 'AFRO', '3', '1669', '0', '41');
INSERT INTO public.who_global_data_import VALUES (85465, '2020-09-23', 'TG', 'Togo', 'AFRO', '14', '1683', '0', '41');
INSERT INTO public.who_global_data_import VALUES (85466, '2020-09-24', 'TG', 'Togo', 'AFRO', '18', '1701', '0', '41');
INSERT INTO public.who_global_data_import VALUES (85467, '2020-09-25', 'TG', 'Togo', 'AFRO', '6', '1707', '3', '44');
INSERT INTO public.who_global_data_import VALUES (85468, '2020-09-26', 'TG', 'Togo', 'AFRO', '15', '1722', '0', '44');
INSERT INTO public.who_global_data_import VALUES (85469, '2020-09-27', 'TG', 'Togo', 'AFRO', '14', '1736', '2', '46');
INSERT INTO public.who_global_data_import VALUES (85470, '2020-09-28', 'TG', 'Togo', 'AFRO', '7', '1743', '0', '46');
INSERT INTO public.who_global_data_import VALUES (85471, '2020-09-29', 'TG', 'Togo', 'AFRO', '6', '1749', '1', '47');
INSERT INTO public.who_global_data_import VALUES (85472, '2020-09-30', 'TG', 'Togo', 'AFRO', '10', '1759', '1', '48');
INSERT INTO public.who_global_data_import VALUES (85473, '2020-10-01', 'TG', 'Togo', 'AFRO', '25', '1784', '0', '48');
INSERT INTO public.who_global_data_import VALUES (85474, '2020-10-02', 'TG', 'Togo', 'AFRO', '25', '1809', '0', '48');
INSERT INTO public.who_global_data_import VALUES (85475, '2020-10-03', 'TG', 'Togo', 'AFRO', '9', '1818', '0', '48');
INSERT INTO public.who_global_data_import VALUES (85476, '2020-10-04', 'TG', 'Togo', 'AFRO', '22', '1840', '0', '48');
INSERT INTO public.who_global_data_import VALUES (85477, '2020-10-05', 'TG', 'Togo', 'AFRO', '14', '1854', '0', '48');
INSERT INTO public.who_global_data_import VALUES (85478, '2020-10-06', 'TG', 'Togo', 'AFRO', '10', '1864', '0', '48');
INSERT INTO public.who_global_data_import VALUES (85479, '2020-10-07', 'TG', 'Togo', 'AFRO', '17', '1881', '1', '49');
INSERT INTO public.who_global_data_import VALUES (85480, '2020-10-08', 'TG', 'Togo', 'AFRO', '17', '1898', '0', '49');
INSERT INTO public.who_global_data_import VALUES (85481, '2020-10-09', 'TG', 'Togo', 'AFRO', '9', '1907', '0', '49');
INSERT INTO public.who_global_data_import VALUES (85482, '2020-10-10', 'TG', 'Togo', 'AFRO', '0', '1907', '0', '49');
INSERT INTO public.who_global_data_import VALUES (85483, '2020-10-11', 'TG', 'Togo', 'AFRO', '28', '1935', '0', '49');
INSERT INTO public.who_global_data_import VALUES (85484, '2020-10-12', 'TG', 'Togo', 'AFRO', '5', '1940', '0', '49');
INSERT INTO public.who_global_data_import VALUES (85485, '2020-10-13', 'TG', 'Togo', 'AFRO', '9', '1949', '0', '49');
INSERT INTO public.who_global_data_import VALUES (85486, '2020-10-14', 'TG', 'Togo', 'AFRO', '23', '1972', '1', '50');
INSERT INTO public.who_global_data_import VALUES (85487, '2020-10-15', 'TG', 'Togo', 'AFRO', '0', '1972', '0', '50');
INSERT INTO public.who_global_data_import VALUES (85488, '2020-10-16', 'TG', 'Togo', 'AFRO', '24', '1996', '1', '51');
INSERT INTO public.who_global_data_import VALUES (85489, '2020-10-17', 'TG', 'Togo', 'AFRO', '31', '2027', '0', '51');
INSERT INTO public.who_global_data_import VALUES (85490, '2020-10-18', 'TG', 'Togo', 'AFRO', '22', '2049', '0', '51');
INSERT INTO public.who_global_data_import VALUES (85491, '2020-10-19', 'TG', 'Togo', 'AFRO', '8', '2057', '0', '51');
INSERT INTO public.who_global_data_import VALUES (85492, '2020-10-20', 'TG', 'Togo', 'AFRO', '14', '2071', '0', '51');
INSERT INTO public.who_global_data_import VALUES (85493, '2020-10-21', 'TG', 'Togo', 'AFRO', '33', '2104', '0', '51');
INSERT INTO public.who_global_data_import VALUES (85494, '2020-10-22', 'TG', 'Togo', 'AFRO', '16', '2120', '0', '51');
INSERT INTO public.who_global_data_import VALUES (85495, '2020-10-23', 'TG', 'Togo', 'AFRO', '19', '2139', '1', '52');
INSERT INTO public.who_global_data_import VALUES (85496, '2020-10-24', 'TG', 'Togo', 'AFRO', '23', '2162', '0', '52');
INSERT INTO public.who_global_data_import VALUES (85497, '2020-10-25', 'TG', 'Togo', 'AFRO', '0', '2162', '0', '52');
INSERT INTO public.who_global_data_import VALUES (85498, '2020-10-26', 'TG', 'Togo', 'AFRO', '0', '2162', '0', '52');
INSERT INTO public.who_global_data_import VALUES (85499, '2020-10-27', 'TG', 'Togo', 'AFRO', '25', '2187', '0', '52');
INSERT INTO public.who_global_data_import VALUES (85500, '2020-10-28', 'TG', 'Togo', 'AFRO', '0', '2187', '0', '52');
INSERT INTO public.who_global_data_import VALUES (85501, '2020-10-29', 'TG', 'Togo', 'AFRO', '51', '2238', '2', '54');
INSERT INTO public.who_global_data_import VALUES (85502, '2020-10-30', 'TG', 'Togo', 'AFRO', '58', '2296', '1', '55');
INSERT INTO public.who_global_data_import VALUES (85503, '2020-10-31', 'TG', 'Togo', 'AFRO', '0', '2296', '0', '55');
INSERT INTO public.who_global_data_import VALUES (85504, '2020-11-01', 'TG', 'Togo', 'AFRO', '0', '2296', '0', '55');
INSERT INTO public.who_global_data_import VALUES (85505, '2020-11-02', 'TG', 'Togo', 'AFRO', '61', '2357', '2', '57');
INSERT INTO public.who_global_data_import VALUES (85506, '2020-11-03', 'TG', 'Togo', 'AFRO', '0', '2357', '0', '57');
INSERT INTO public.who_global_data_import VALUES (85507, '2020-11-04', 'TG', 'Togo', 'AFRO', '24', '2381', '0', '57');
INSERT INTO public.who_global_data_import VALUES (85508, '2020-11-05', 'TG', 'Togo', 'AFRO', '0', '2381', '0', '57');
INSERT INTO public.who_global_data_import VALUES (85509, '2020-11-06', 'TG', 'Togo', 'AFRO', '61', '2442', '0', '57');
INSERT INTO public.who_global_data_import VALUES (85510, '2020-11-07', 'TG', 'Togo', 'AFRO', '0', '2442', '0', '57');
INSERT INTO public.who_global_data_import VALUES (85511, '2020-11-08', 'TG', 'Togo', 'AFRO', '0', '2442', '0', '57');
INSERT INTO public.who_global_data_import VALUES (85512, '2020-11-09', 'TG', 'Togo', 'AFRO', '41', '2483', '0', '57');
INSERT INTO public.who_global_data_import VALUES (85513, '2020-11-10', 'TG', 'Togo', 'AFRO', '33', '2516', '0', '57');
INSERT INTO public.who_global_data_import VALUES (85514, '2020-11-11', 'TG', 'Togo', 'AFRO', '42', '2558', '0', '57');
INSERT INTO public.who_global_data_import VALUES (85515, '2020-11-12', 'TG', 'Togo', 'AFRO', '0', '2558', '0', '57');
INSERT INTO public.who_global_data_import VALUES (85516, '2020-11-13', 'TG', 'Togo', 'AFRO', '47', '2605', '3', '60');
INSERT INTO public.who_global_data_import VALUES (85517, '2020-11-14', 'TG', 'Togo', 'AFRO', '0', '2605', '0', '60');
INSERT INTO public.who_global_data_import VALUES (85518, '2020-11-15', 'TG', 'Togo', 'AFRO', '0', '2605', '0', '60');
INSERT INTO public.who_global_data_import VALUES (85519, '2020-11-16', 'TG', 'Togo', 'AFRO', '0', '2605', '0', '60');
INSERT INTO public.who_global_data_import VALUES (85520, '2020-11-17', 'TG', 'Togo', 'AFRO', '0', '2605', '0', '60');
INSERT INTO public.who_global_data_import VALUES (85521, '2020-11-18', 'TG', 'Togo', 'AFRO', '117', '2722', '2', '62');
INSERT INTO public.who_global_data_import VALUES (85522, '2020-11-19', 'TG', 'Togo', 'AFRO', '30', '2752', '1', '63');
INSERT INTO public.who_global_data_import VALUES (85523, '2020-11-20', 'TG', 'Togo', 'AFRO', '19', '2771', '0', '63');
INSERT INTO public.who_global_data_import VALUES (85524, '2020-11-21', 'TG', 'Togo', 'AFRO', '0', '2771', '0', '63');
INSERT INTO public.who_global_data_import VALUES (85525, '2020-11-22', 'TG', 'Togo', 'AFRO', '0', '2771', '0', '63');
INSERT INTO public.who_global_data_import VALUES (85526, '2020-11-23', 'TG', 'Togo', 'AFRO', '58', '2829', '1', '64');
INSERT INTO public.who_global_data_import VALUES (85527, '2020-11-24', 'TG', 'Togo', 'AFRO', '0', '2829', '0', '64');
INSERT INTO public.who_global_data_import VALUES (85528, '2020-11-25', 'TG', 'Togo', 'AFRO', '28', '2857', '0', '64');
INSERT INTO public.who_global_data_import VALUES (85529, '2020-11-26', 'TG', 'Togo', 'AFRO', '15', '2872', '0', '64');
INSERT INTO public.who_global_data_import VALUES (85530, '2020-11-27', 'TG', 'Togo', 'AFRO', '0', '2872', '0', '64');
INSERT INTO public.who_global_data_import VALUES (85531, '2020-11-28', 'TG', 'Togo', 'AFRO', '54', '2926', '0', '64');
INSERT INTO public.who_global_data_import VALUES (85532, '2020-11-29', 'TG', 'Togo', 'AFRO', '0', '2926', '0', '64');
INSERT INTO public.who_global_data_import VALUES (85533, '2020-11-30', 'TG', 'Togo', 'AFRO', '20', '2946', '0', '64');
INSERT INTO public.who_global_data_import VALUES (85534, '2020-12-01', 'TG', 'Togo', 'AFRO', '0', '2946', '0', '64');
INSERT INTO public.who_global_data_import VALUES (85535, '2020-12-02', 'TG', 'Togo', 'AFRO', '0', '2946', '0', '64');
INSERT INTO public.who_global_data_import VALUES (85536, '2020-12-03', 'TG', 'Togo', 'AFRO', '68', '3014', '1', '65');
INSERT INTO public.who_global_data_import VALUES (85537, '2020-12-04', 'TG', 'Togo', 'AFRO', '0', '3014', '0', '65');
INSERT INTO public.who_global_data_import VALUES (85538, '2020-12-05', 'TG', 'Togo', 'AFRO', '37', '3051', '0', '65');
INSERT INTO public.who_global_data_import VALUES (85539, '2020-12-06', 'TG', 'Togo', 'AFRO', '0', '3051', '0', '65');
INSERT INTO public.who_global_data_import VALUES (85540, '2020-12-07', 'TG', 'Togo', 'AFRO', '34', '3085', '0', '65');
INSERT INTO public.who_global_data_import VALUES (85541, '2020-12-08', 'TG', 'Togo', 'AFRO', '10', '3095', '0', '65');
INSERT INTO public.who_global_data_import VALUES (85542, '2020-12-09', 'TG', 'Togo', 'AFRO', '37', '3132', '0', '65');
INSERT INTO public.who_global_data_import VALUES (85543, '2020-12-10', 'TG', 'Togo', 'AFRO', '0', '3132', '0', '65');
INSERT INTO public.who_global_data_import VALUES (85544, '2020-12-11', 'TG', 'Togo', 'AFRO', '0', '3132', '0', '65');
INSERT INTO public.who_global_data_import VALUES (85545, '2020-12-12', 'TG', 'Togo', 'AFRO', '0', '3132', '0', '65');
INSERT INTO public.who_global_data_import VALUES (85546, '2020-12-13', 'TG', 'Togo', 'AFRO', '70', '3202', '1', '66');
INSERT INTO public.who_global_data_import VALUES (85547, '2020-12-14', 'TG', 'Togo', 'AFRO', '0', '3202', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85548, '2020-12-15', 'TG', 'Togo', 'AFRO', '64', '3266', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85549, '2020-12-16', 'TG', 'Togo', 'AFRO', '29', '3295', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85550, '2020-12-17', 'TG', 'Togo', 'AFRO', '20', '3315', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85551, '2020-12-18', 'TG', 'Togo', 'AFRO', '0', '3315', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85552, '2020-12-19', 'TG', 'Togo', 'AFRO', '0', '3315', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85553, '2020-12-20', 'TG', 'Togo', 'AFRO', '81', '3396', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85554, '2020-12-21', 'TG', 'Togo', 'AFRO', '0', '3396', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85555, '2020-12-22', 'TG', 'Togo', 'AFRO', '40', '3436', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85556, '2020-12-23', 'TG', 'Togo', 'AFRO', '31', '3467', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85557, '2020-12-24', 'TG', 'Togo', 'AFRO', '0', '3467', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85558, '2020-12-25', 'TG', 'Togo', 'AFRO', '0', '3467', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85559, '2020-12-26', 'TG', 'Togo', 'AFRO', '0', '3467', '0', '66');
INSERT INTO public.who_global_data_import VALUES (85560, '2020-12-27', 'TG', 'Togo', 'AFRO', '88', '3555', '2', '68');
INSERT INTO public.who_global_data_import VALUES (85561, '2020-12-28', 'TG', 'Togo', 'AFRO', '0', '3555', '0', '68');
INSERT INTO public.who_global_data_import VALUES (85562, '2020-12-29', 'TG', 'Togo', 'AFRO', '21', '3576', '0', '68');
INSERT INTO public.who_global_data_import VALUES (85563, '2020-12-30', 'TG', 'Togo', 'AFRO', '0', '3576', '0', '68');
INSERT INTO public.who_global_data_import VALUES (85564, '2020-12-31', 'TG', 'Togo', 'AFRO', '28', '3604', '0', '68');
INSERT INTO public.who_global_data_import VALUES (85565, '2021-01-01', 'TG', 'Togo', 'AFRO', '29', '3633', '0', '68');
INSERT INTO public.who_global_data_import VALUES (85566, '2021-01-02', 'TG', 'Togo', 'AFRO', '0', '3633', '0', '68');
INSERT INTO public.who_global_data_import VALUES (85567, '2021-01-03', 'TG', 'Togo', 'AFRO', '50', '3683', '0', '68');
INSERT INTO public.who_global_data_import VALUES (85568, '2021-01-04', 'TG', 'Togo', 'AFRO', '19', '3702', '0', '68');
INSERT INTO public.who_global_data_import VALUES (85569, '2021-01-05', 'TG', 'Togo', 'AFRO', '20', '3722', '1', '69');
INSERT INTO public.who_global_data_import VALUES (85570, '2021-01-06', 'TG', 'Togo', 'AFRO', '0', '3722', '0', '69');
INSERT INTO public.who_global_data_import VALUES (85571, '2021-01-07', 'TG', 'Togo', 'AFRO', '85', '3807', '1', '70');
INSERT INTO public.who_global_data_import VALUES (85572, '2021-01-08', 'TG', 'Togo', 'AFRO', '0', '3807', '0', '70');
INSERT INTO public.who_global_data_import VALUES (85573, '2021-01-09', 'TG', 'Togo', 'AFRO', '38', '3845', '2', '72');
INSERT INTO public.who_global_data_import VALUES (85574, '2021-01-10', 'TG', 'Togo', 'AFRO', '87', '3932', '0', '72');
INSERT INTO public.who_global_data_import VALUES (85575, '2021-01-11', 'TG', 'Togo', 'AFRO', '25', '3957', '0', '72');
INSERT INTO public.who_global_data_import VALUES (85576, '2021-01-12', 'TG', 'Togo', 'AFRO', '21', '3978', '1', '73');
INSERT INTO public.who_global_data_import VALUES (85577, '2021-01-13', 'TG', 'Togo', 'AFRO', '67', '4045', '0', '73');
INSERT INTO public.who_global_data_import VALUES (85578, '2021-01-14', 'TG', 'Togo', 'AFRO', '64', '4109', '0', '73');
INSERT INTO public.who_global_data_import VALUES (85579, '2021-01-15', 'TG', 'Togo', 'AFRO', '0', '4109', '0', '73');
INSERT INTO public.who_global_data_import VALUES (85580, '2021-01-16', 'TG', 'Togo', 'AFRO', '111', '4220', '0', '73');
INSERT INTO public.who_global_data_import VALUES (85581, '2021-01-17', 'TG', 'Togo', 'AFRO', '52', '4272', '0', '73');
INSERT INTO public.who_global_data_import VALUES (85582, '2021-01-18', 'TG', 'Togo', 'AFRO', '30', '4302', '0', '73');
INSERT INTO public.who_global_data_import VALUES (85583, '2021-01-19', 'TG', 'Togo', 'AFRO', '22', '4324', '1', '74');
INSERT INTO public.who_global_data_import VALUES (85584, '2021-01-20', 'TG', 'Togo', 'AFRO', '59', '4383', '0', '74');
INSERT INTO public.who_global_data_import VALUES (85585, '2021-01-21', 'TG', 'Togo', 'AFRO', '76', '4459', '0', '74');
INSERT INTO public.who_global_data_import VALUES (85586, '2021-01-22', 'TG', 'Togo', 'AFRO', '46', '4505', '0', '74');
INSERT INTO public.who_global_data_import VALUES (85587, '2021-01-23', 'TG', 'Togo', 'AFRO', '0', '4505', '0', '74');
INSERT INTO public.who_global_data_import VALUES (85588, '2021-01-24', 'TG', 'Togo', 'AFRO', '131', '4636', '0', '74');
INSERT INTO public.who_global_data_import VALUES (85589, '2021-01-25', 'TG', 'Togo', 'AFRO', '26', '4662', '1', '75');
INSERT INTO public.who_global_data_import VALUES (85590, '2021-01-26', 'TG', 'Togo', 'AFRO', '0', '4662', '0', '75');
INSERT INTO public.who_global_data_import VALUES (85591, '2021-01-27', 'TG', 'Togo', 'AFRO', '20', '4682', '1', '76');
INSERT INTO public.who_global_data_import VALUES (85592, '2021-01-28', 'TG', 'Togo', 'AFRO', '188', '4870', '0', '76');
INSERT INTO public.who_global_data_import VALUES (85593, '2021-01-29', 'TG', 'Togo', 'AFRO', '52', '4922', '0', '76');
INSERT INTO public.who_global_data_import VALUES (85594, '2021-01-30', 'TG', 'Togo', 'AFRO', '0', '4922', '0', '76');
INSERT INTO public.who_global_data_import VALUES (85595, '2021-01-31', 'TG', 'Togo', 'AFRO', '119', '5041', '1', '77');
INSERT INTO public.who_global_data_import VALUES (85596, '2021-02-01', 'TG', 'Togo', 'AFRO', '33', '5074', '0', '77');
INSERT INTO public.who_global_data_import VALUES (85597, '2021-02-02', 'TG', 'Togo', 'AFRO', '18', '5092', '2', '79');
INSERT INTO public.who_global_data_import VALUES (85598, '2021-02-03', 'TG', 'Togo', 'AFRO', '74', '5166', '0', '79');
INSERT INTO public.who_global_data_import VALUES (85599, '2021-02-04', 'TG', 'Togo', 'AFRO', '58', '5224', '0', '79');
INSERT INTO public.who_global_data_import VALUES (85600, '2021-02-05', 'TG', 'Togo', 'AFRO', '66', '5290', '0', '79');
INSERT INTO public.who_global_data_import VALUES (85601, '2020-01-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85602, '2020-01-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85603, '2020-01-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85604, '2020-01-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85605, '2020-01-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85606, '2020-01-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85607, '2020-01-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85608, '2020-01-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85609, '2020-01-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85610, '2020-01-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85611, '2020-01-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85612, '2020-01-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85613, '2020-01-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85614, '2020-01-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85615, '2020-01-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85616, '2020-01-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85617, '2020-01-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85618, '2020-01-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85619, '2020-01-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85620, '2020-01-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85621, '2020-01-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85622, '2020-01-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85623, '2020-01-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85624, '2020-01-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85625, '2020-01-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85626, '2020-01-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85627, '2020-01-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85628, '2020-01-30', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85629, '2020-01-31', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85630, '2020-02-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85631, '2020-02-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85632, '2020-02-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85633, '2020-02-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85634, '2020-02-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85635, '2020-02-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85636, '2020-02-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85637, '2020-02-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85638, '2020-02-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85639, '2020-02-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85640, '2020-02-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85641, '2020-02-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85642, '2020-02-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85643, '2020-02-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85644, '2020-02-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85645, '2020-02-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85646, '2020-02-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85647, '2020-02-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85648, '2020-02-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85649, '2020-02-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85650, '2020-02-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85651, '2020-02-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85652, '2020-02-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85653, '2020-02-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85654, '2020-02-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85655, '2020-02-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85656, '2020-02-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85657, '2020-02-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85658, '2020-02-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85659, '2020-03-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85660, '2020-03-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85661, '2020-03-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85662, '2020-03-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85663, '2020-03-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85664, '2020-03-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85665, '2020-03-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85666, '2020-03-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85667, '2020-03-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85668, '2020-03-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85669, '2020-03-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85670, '2020-03-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85671, '2020-03-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85672, '2020-03-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85673, '2020-03-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85674, '2020-03-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85675, '2020-03-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85676, '2020-03-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85677, '2020-03-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85678, '2020-03-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85679, '2020-03-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85680, '2020-03-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85681, '2020-03-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85682, '2020-03-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85683, '2020-03-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85684, '2020-03-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85685, '2020-03-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85686, '2020-03-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85687, '2020-03-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85688, '2020-03-30', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85689, '2020-03-31', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85690, '2020-04-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85691, '2020-04-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85692, '2020-04-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85693, '2020-04-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85694, '2020-04-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85695, '2020-04-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85696, '2020-04-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85697, '2020-04-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85698, '2020-04-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85699, '2020-04-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85700, '2020-04-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85701, '2020-04-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85702, '2020-04-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85703, '2020-04-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85704, '2020-04-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85705, '2020-04-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85706, '2020-04-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85707, '2020-04-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85708, '2020-04-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85709, '2020-04-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85710, '2020-04-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85711, '2020-04-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85712, '2020-04-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85713, '2020-04-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85714, '2020-04-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85715, '2020-04-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85716, '2020-04-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85717, '2020-04-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85718, '2020-04-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85719, '2020-04-30', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85720, '2020-05-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85721, '2020-05-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85722, '2020-05-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85723, '2020-05-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85724, '2020-05-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85725, '2020-05-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85726, '2020-05-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85727, '2020-05-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85728, '2020-05-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85729, '2020-05-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85730, '2020-05-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85731, '2020-05-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85732, '2020-05-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85733, '2020-05-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85734, '2020-05-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85735, '2020-05-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85736, '2020-05-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85737, '2020-05-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85738, '2020-05-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85739, '2020-05-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85740, '2020-05-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85741, '2020-05-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85742, '2020-05-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85743, '2020-05-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85744, '2020-05-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85745, '2020-05-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85746, '2020-05-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85747, '2020-05-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85748, '2020-05-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85749, '2020-05-30', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85750, '2020-05-31', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85751, '2020-06-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85752, '2020-06-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85753, '2020-06-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85754, '2020-06-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85755, '2020-06-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85756, '2020-06-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85757, '2020-06-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85758, '2020-06-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85759, '2020-06-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85760, '2020-06-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85761, '2020-06-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85762, '2020-06-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85763, '2020-06-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85764, '2020-06-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85765, '2020-06-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85766, '2020-06-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85767, '2020-06-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85768, '2020-06-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85769, '2020-06-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85770, '2020-06-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85771, '2020-06-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85772, '2020-06-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85773, '2020-06-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85774, '2020-06-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85775, '2020-06-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85776, '2020-06-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85777, '2020-06-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85778, '2020-06-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85779, '2020-06-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85780, '2020-06-30', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85781, '2020-07-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85782, '2020-07-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85783, '2020-07-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85784, '2020-07-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85785, '2020-07-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85786, '2020-07-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85787, '2020-07-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85788, '2020-07-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85789, '2020-07-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85790, '2020-07-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85791, '2020-07-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85792, '2020-07-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85793, '2020-07-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85794, '2020-07-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85795, '2020-07-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85796, '2020-07-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85797, '2020-07-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85798, '2020-07-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85799, '2020-07-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85800, '2020-07-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85801, '2020-07-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85802, '2020-07-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85803, '2020-07-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85804, '2020-07-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85805, '2020-07-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85806, '2020-07-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85807, '2020-07-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85808, '2020-07-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85809, '2020-07-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85810, '2020-07-30', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85811, '2020-07-31', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85812, '2020-08-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85813, '2020-08-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85814, '2020-08-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85815, '2020-08-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85816, '2020-08-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85817, '2020-08-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85818, '2020-08-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85819, '2020-08-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85820, '2020-08-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85821, '2020-08-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85822, '2020-08-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85823, '2020-08-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85824, '2020-08-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85825, '2020-08-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85826, '2020-08-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85827, '2020-08-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85828, '2020-08-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85829, '2020-08-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85830, '2020-08-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85831, '2020-08-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85832, '2020-08-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85833, '2020-08-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85834, '2020-08-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85835, '2020-08-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85836, '2020-08-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85837, '2020-08-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85838, '2020-08-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85839, '2020-08-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85840, '2020-08-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85841, '2020-08-30', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85842, '2020-08-31', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85843, '2020-09-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85844, '2020-09-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85845, '2020-09-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85846, '2020-09-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85847, '2020-09-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85848, '2020-09-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85849, '2020-09-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85850, '2020-09-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85851, '2020-09-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85852, '2020-09-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85853, '2020-09-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85854, '2020-09-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85855, '2020-09-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85856, '2020-09-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85857, '2020-09-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85858, '2020-09-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85859, '2020-09-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85860, '2020-09-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85861, '2020-09-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85862, '2020-09-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85863, '2020-09-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85864, '2020-09-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85865, '2020-09-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85866, '2020-09-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85867, '2020-09-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85868, '2020-09-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85869, '2020-09-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85870, '2020-09-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85871, '2020-09-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85872, '2020-09-30', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85873, '2020-10-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85874, '2020-10-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85875, '2020-10-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85876, '2020-10-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85877, '2020-10-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85878, '2020-10-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85879, '2020-10-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85880, '2020-10-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85881, '2020-10-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85882, '2020-10-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85883, '2020-10-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85884, '2020-10-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85885, '2020-10-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85886, '2020-10-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85887, '2020-10-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85888, '2020-10-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85889, '2020-10-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85890, '2020-10-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85891, '2020-10-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85892, '2020-10-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85893, '2020-10-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85894, '2020-10-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85895, '2020-10-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85896, '2020-10-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85897, '2020-10-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85898, '2020-10-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85899, '2020-10-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85900, '2020-10-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85901, '2020-10-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85902, '2020-10-30', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85903, '2020-10-31', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85904, '2020-11-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85905, '2020-11-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85906, '2020-11-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85907, '2020-11-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85908, '2020-11-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85909, '2020-11-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85910, '2020-11-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85911, '2020-11-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85912, '2020-11-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85913, '2020-11-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85914, '2020-11-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85915, '2020-11-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85916, '2020-11-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85917, '2020-11-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85918, '2020-11-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85919, '2020-11-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85920, '2020-11-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85921, '2020-11-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85922, '2020-11-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85923, '2020-11-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85924, '2020-11-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85925, '2020-11-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85926, '2020-11-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85927, '2020-11-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85928, '2020-11-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85929, '2020-11-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85930, '2020-11-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85931, '2020-11-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85932, '2020-11-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85933, '2020-11-30', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85934, '2020-12-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85935, '2020-12-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85936, '2020-12-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85937, '2020-12-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85938, '2020-12-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85939, '2020-12-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85940, '2020-12-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85941, '2020-12-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85942, '2020-12-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85943, '2020-12-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85944, '2020-12-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85945, '2020-12-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85946, '2020-12-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85947, '2020-12-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85948, '2020-12-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85949, '2020-12-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85950, '2020-12-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85951, '2020-12-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85952, '2020-12-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85953, '2020-12-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85954, '2020-12-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85955, '2020-12-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85956, '2020-12-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85957, '2020-12-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85958, '2020-12-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85959, '2020-12-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85960, '2020-12-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85961, '2020-12-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85962, '2020-12-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85963, '2020-12-30', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85964, '2020-12-31', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85965, '2021-01-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85966, '2021-01-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85967, '2021-01-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85968, '2021-01-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85969, '2021-01-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85970, '2021-01-06', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85971, '2021-01-07', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85972, '2021-01-08', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85973, '2021-01-09', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85974, '2021-01-10', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85975, '2021-01-11', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85976, '2021-01-12', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85977, '2021-01-13', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85978, '2021-01-14', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85979, '2021-01-15', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85980, '2021-01-16', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85981, '2021-01-17', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85982, '2021-01-18', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85983, '2021-01-19', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85984, '2021-01-20', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85985, '2021-01-21', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85986, '2021-01-22', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85987, '2021-01-23', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85988, '2021-01-24', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85989, '2021-01-25', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85990, '2021-01-26', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85991, '2021-01-27', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85992, '2021-01-28', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85993, '2021-01-29', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85994, '2021-01-30', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85995, '2021-01-31', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85996, '2021-02-01', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85997, '2021-02-02', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85998, '2021-02-03', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (85999, '2021-02-04', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86000, '2021-02-05', 'TK', 'Tokelau', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86001, '2020-01-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86002, '2020-01-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86003, '2020-01-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86004, '2020-01-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86005, '2020-01-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86006, '2020-01-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86007, '2020-01-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86008, '2020-01-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86009, '2020-01-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86010, '2020-01-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86011, '2020-01-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86012, '2020-01-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86013, '2020-01-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86014, '2020-01-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86015, '2020-01-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86016, '2020-01-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86017, '2020-01-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86018, '2020-01-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86019, '2020-01-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86020, '2020-01-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86021, '2020-01-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86022, '2020-01-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86023, '2020-01-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86024, '2020-01-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86025, '2020-01-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86026, '2020-01-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86027, '2020-01-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86028, '2020-01-30', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86029, '2020-01-31', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86030, '2020-02-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86031, '2020-02-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86032, '2020-02-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86033, '2020-02-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86034, '2020-02-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86035, '2020-02-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86036, '2020-02-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86037, '2020-02-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86038, '2020-02-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86039, '2020-02-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86040, '2020-02-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86041, '2020-02-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86042, '2020-02-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86043, '2020-02-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86044, '2020-02-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86045, '2020-02-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86046, '2020-02-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86047, '2020-02-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86048, '2020-02-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86049, '2020-02-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86050, '2020-02-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86051, '2020-02-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86052, '2020-02-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86053, '2020-02-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86054, '2020-02-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86055, '2020-02-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86056, '2020-02-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86057, '2020-02-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86058, '2020-02-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86059, '2020-03-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86060, '2020-03-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86061, '2020-03-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86062, '2020-03-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86063, '2020-03-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86064, '2020-03-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86065, '2020-03-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86066, '2020-03-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86067, '2020-03-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86068, '2020-03-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86069, '2020-03-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86070, '2020-03-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86071, '2020-03-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86072, '2020-03-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86073, '2020-03-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86074, '2020-03-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86075, '2020-03-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86076, '2020-03-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86077, '2020-03-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86078, '2020-03-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86079, '2020-03-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86080, '2020-03-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86081, '2020-03-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86082, '2020-03-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86083, '2020-03-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86084, '2020-03-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86085, '2020-03-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86086, '2020-03-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86087, '2020-03-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86088, '2020-03-30', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86089, '2020-03-31', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86090, '2020-04-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86091, '2020-04-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86092, '2020-04-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86093, '2020-04-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86094, '2020-04-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86095, '2020-04-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86096, '2020-04-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86097, '2020-04-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86098, '2020-04-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86099, '2020-04-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86100, '2020-04-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86101, '2020-04-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86102, '2020-04-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86103, '2020-04-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86104, '2020-04-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86105, '2020-04-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86106, '2020-04-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86107, '2020-04-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86108, '2020-04-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86109, '2020-04-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86110, '2020-04-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86111, '2020-04-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86112, '2020-04-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86113, '2020-04-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86114, '2020-04-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86115, '2020-04-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86116, '2020-04-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86117, '2020-04-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86118, '2020-04-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86119, '2020-04-30', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86120, '2020-05-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86121, '2020-05-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86122, '2020-05-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86123, '2020-05-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86124, '2020-05-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86125, '2020-05-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86126, '2020-05-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86127, '2020-05-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86128, '2020-05-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86129, '2020-05-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86130, '2020-05-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86131, '2020-05-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86132, '2020-05-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86133, '2020-05-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86134, '2020-05-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86135, '2020-05-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86136, '2020-05-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86137, '2020-05-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86138, '2020-05-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86139, '2020-05-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86140, '2020-05-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86141, '2020-05-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86142, '2020-05-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86143, '2020-05-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86144, '2020-05-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86145, '2020-05-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86146, '2020-05-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86147, '2020-05-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86148, '2020-05-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86149, '2020-05-30', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86150, '2020-05-31', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86151, '2020-06-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86152, '2020-06-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86153, '2020-06-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86154, '2020-06-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86155, '2020-06-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86156, '2020-06-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86157, '2020-06-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86158, '2020-06-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86159, '2020-06-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86160, '2020-06-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86161, '2020-06-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86162, '2020-06-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86163, '2020-06-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86164, '2020-06-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86165, '2020-06-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86166, '2020-06-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86167, '2020-06-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86168, '2020-06-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86169, '2020-06-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86170, '2020-06-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86171, '2020-06-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86172, '2020-06-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86173, '2020-06-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86174, '2020-06-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86175, '2020-06-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86176, '2020-06-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86177, '2020-06-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86178, '2020-06-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86179, '2020-06-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86180, '2020-06-30', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86181, '2020-07-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86182, '2020-07-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86183, '2020-07-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86184, '2020-07-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86185, '2020-07-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86186, '2020-07-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86187, '2020-07-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86188, '2020-07-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86189, '2020-07-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86190, '2020-07-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86191, '2020-07-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86192, '2020-07-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86193, '2020-07-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86194, '2020-07-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86195, '2020-07-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86196, '2020-07-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86197, '2020-07-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86198, '2020-07-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86199, '2020-07-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86200, '2020-07-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86201, '2020-07-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86202, '2020-07-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86203, '2020-07-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86204, '2020-07-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86205, '2020-07-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86206, '2020-07-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86207, '2020-07-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86208, '2020-07-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86209, '2020-07-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86210, '2020-07-30', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86211, '2020-07-31', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86212, '2020-08-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86213, '2020-08-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86214, '2020-08-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86215, '2020-08-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86216, '2020-08-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86217, '2020-08-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86218, '2020-08-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86219, '2020-08-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86220, '2020-08-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86221, '2020-08-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86222, '2020-08-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86223, '2020-08-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86224, '2020-08-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86225, '2020-08-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86226, '2020-08-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86227, '2020-08-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86228, '2020-08-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86229, '2020-08-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86230, '2020-08-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86231, '2020-08-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86232, '2020-08-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86233, '2020-08-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86234, '2020-08-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86235, '2020-08-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86236, '2020-08-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86237, '2020-08-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86238, '2020-08-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86239, '2020-08-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86240, '2020-08-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86241, '2020-08-30', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86242, '2020-08-31', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86243, '2020-09-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86244, '2020-09-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86245, '2020-09-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86246, '2020-09-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86247, '2020-09-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86248, '2020-09-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86249, '2020-09-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86250, '2020-09-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86251, '2020-09-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86252, '2020-09-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86253, '2020-09-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86254, '2020-09-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86255, '2020-09-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86256, '2020-09-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86257, '2020-09-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86258, '2020-09-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86259, '2020-09-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86260, '2020-09-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86261, '2020-09-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86262, '2020-09-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86263, '2020-09-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86264, '2020-09-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86265, '2020-09-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86266, '2020-09-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86267, '2020-09-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86268, '2020-09-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86269, '2020-09-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86270, '2020-09-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86271, '2020-09-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86272, '2020-09-30', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86273, '2020-10-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86274, '2020-10-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86275, '2020-10-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86276, '2020-10-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86277, '2020-10-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86278, '2020-10-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86279, '2020-10-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86280, '2020-10-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86281, '2020-10-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86282, '2020-10-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86283, '2020-10-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86284, '2020-10-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86285, '2020-10-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86286, '2020-10-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86287, '2020-10-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86288, '2020-10-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86289, '2020-10-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86290, '2020-10-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86291, '2020-10-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86292, '2020-10-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86293, '2020-10-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86294, '2020-10-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86295, '2020-10-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86296, '2020-10-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86297, '2020-10-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86298, '2020-10-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86299, '2020-10-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86300, '2020-10-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86301, '2020-10-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86302, '2020-10-30', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86303, '2020-10-31', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86304, '2020-11-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86305, '2020-11-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86306, '2020-11-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86307, '2020-11-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86308, '2020-11-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86309, '2020-11-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86310, '2020-11-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86311, '2020-11-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86312, '2020-11-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86313, '2020-11-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86314, '2020-11-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86315, '2020-11-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86316, '2020-11-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86317, '2020-11-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86318, '2020-11-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86319, '2020-11-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86320, '2020-11-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86321, '2020-11-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86322, '2020-11-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86323, '2020-11-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86324, '2020-11-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86325, '2020-11-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86326, '2020-11-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86327, '2020-11-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86328, '2020-11-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86329, '2020-11-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86330, '2020-11-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86331, '2020-11-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86332, '2020-11-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86333, '2020-11-30', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86334, '2020-12-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86335, '2020-12-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86336, '2020-12-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86337, '2020-12-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86338, '2020-12-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86339, '2020-12-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86340, '2020-12-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86341, '2020-12-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86342, '2020-12-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86343, '2020-12-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86344, '2020-12-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86345, '2020-12-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86346, '2020-12-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86347, '2020-12-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86348, '2020-12-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86349, '2020-12-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86350, '2020-12-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86351, '2020-12-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86352, '2020-12-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86353, '2020-12-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86354, '2020-12-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86355, '2020-12-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86356, '2020-12-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86357, '2020-12-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86358, '2020-12-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86359, '2020-12-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86360, '2020-12-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86361, '2020-12-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86362, '2020-12-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86363, '2020-12-30', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86364, '2020-12-31', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86365, '2021-01-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86366, '2021-01-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86367, '2021-01-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86368, '2021-01-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86369, '2021-01-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86370, '2021-01-06', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86371, '2021-01-07', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86372, '2021-01-08', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86373, '2021-01-09', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86374, '2021-01-10', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86375, '2021-01-11', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86376, '2021-01-12', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86377, '2021-01-13', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86378, '2021-01-14', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86379, '2021-01-15', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86380, '2021-01-16', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86381, '2021-01-17', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86382, '2021-01-18', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86383, '2021-01-19', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86384, '2021-01-20', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86385, '2021-01-21', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86386, '2021-01-22', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86387, '2021-01-23', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86388, '2021-01-24', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86389, '2021-01-25', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86390, '2021-01-26', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86391, '2021-01-27', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86392, '2021-01-28', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86393, '2021-01-29', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86394, '2021-01-30', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86395, '2021-01-31', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86396, '2021-02-01', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86397, '2021-02-02', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86398, '2021-02-03', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86399, '2021-02-04', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86400, '2021-02-05', 'TO', 'Tonga', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86401, '2020-01-03', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86402, '2020-01-04', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86403, '2020-01-05', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86404, '2020-01-06', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86405, '2020-01-07', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86406, '2020-01-08', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86407, '2020-01-09', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86408, '2020-01-10', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86409, '2020-01-11', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86410, '2020-01-12', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86411, '2020-01-13', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86412, '2020-01-14', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86413, '2020-01-15', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86414, '2020-01-16', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86415, '2020-01-17', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86416, '2020-01-18', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86417, '2020-01-19', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86418, '2020-01-20', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86419, '2020-01-21', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86420, '2020-01-22', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86421, '2020-01-23', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86422, '2020-01-24', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86423, '2020-01-25', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86424, '2020-01-26', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86425, '2020-01-27', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86426, '2020-01-28', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86427, '2020-01-29', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86428, '2020-01-30', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86429, '2020-01-31', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86430, '2020-02-01', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86431, '2020-02-02', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86432, '2020-02-03', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86433, '2020-02-04', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86434, '2020-02-05', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86435, '2020-02-06', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86436, '2020-02-07', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86437, '2020-02-08', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86438, '2020-02-09', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86439, '2020-02-10', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86440, '2020-02-11', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86441, '2020-02-12', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86442, '2020-02-13', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86443, '2020-02-14', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86444, '2020-02-15', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86445, '2020-02-16', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86446, '2020-02-17', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86447, '2020-02-18', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86448, '2020-02-19', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86449, '2020-02-20', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86450, '2020-02-21', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86451, '2020-02-22', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86452, '2020-02-23', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86453, '2020-02-24', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86454, '2020-02-25', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86455, '2020-02-26', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86456, '2020-02-27', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86457, '2020-02-28', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86458, '2020-02-29', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86459, '2020-03-01', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86460, '2020-03-02', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86461, '2020-03-03', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86462, '2020-03-04', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86463, '2020-03-05', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86464, '2020-03-06', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86465, '2020-03-07', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86466, '2020-03-08', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86467, '2020-03-09', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86468, '2020-03-10', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86469, '2020-03-11', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86470, '2020-03-12', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86471, '2020-03-13', 'TT', 'Trinidad and Tobago', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86472, '2020-03-14', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86473, '2020-03-15', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86474, '2020-03-16', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86475, '2020-03-17', 'TT', 'Trinidad and Tobago', 'AMRO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86476, '2020-03-18', 'TT', 'Trinidad and Tobago', 'AMRO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86477, '2020-03-19', 'TT', 'Trinidad and Tobago', 'AMRO', '-2', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86478, '2020-03-20', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86479, '2020-03-21', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86480, '2020-03-22', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86481, '2020-03-23', 'TT', 'Trinidad and Tobago', 'AMRO', '41', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86482, '2020-03-24', 'TT', 'Trinidad and Tobago', 'AMRO', '7', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86483, '2020-03-25', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86484, '2020-03-26', 'TT', 'Trinidad and Tobago', 'AMRO', '4', '61', '1', '1');
INSERT INTO public.who_global_data_import VALUES (86485, '2020-03-27', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '61', '0', '1');
INSERT INTO public.who_global_data_import VALUES (86486, '2020-03-28', 'TT', 'Trinidad and Tobago', 'AMRO', '5', '66', '1', '2');
INSERT INTO public.who_global_data_import VALUES (86487, '2020-03-29', 'TT', 'Trinidad and Tobago', 'AMRO', '8', '74', '0', '2');
INSERT INTO public.who_global_data_import VALUES (86488, '2020-03-30', 'TT', 'Trinidad and Tobago', 'AMRO', '2', '76', '1', '3');
INSERT INTO public.who_global_data_import VALUES (86489, '2020-03-31', 'TT', 'Trinidad and Tobago', 'AMRO', '6', '82', '0', '3');
INSERT INTO public.who_global_data_import VALUES (86490, '2020-04-01', 'TT', 'Trinidad and Tobago', 'AMRO', '3', '85', '0', '3');
INSERT INTO public.who_global_data_import VALUES (86491, '2020-04-02', 'TT', 'Trinidad and Tobago', 'AMRO', '4', '89', '2', '5');
INSERT INTO public.who_global_data_import VALUES (86492, '2020-04-03', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '90', '0', '5');
INSERT INTO public.who_global_data_import VALUES (86493, '2020-04-04', 'TT', 'Trinidad and Tobago', 'AMRO', '7', '97', '1', '6');
INSERT INTO public.who_global_data_import VALUES (86494, '2020-04-05', 'TT', 'Trinidad and Tobago', 'AMRO', '3', '100', '0', '6');
INSERT INTO public.who_global_data_import VALUES (86495, '2020-04-06', 'TT', 'Trinidad and Tobago', 'AMRO', '3', '103', '0', '6');
INSERT INTO public.who_global_data_import VALUES (86496, '2020-04-07', 'TT', 'Trinidad and Tobago', 'AMRO', '2', '105', '2', '8');
INSERT INTO public.who_global_data_import VALUES (86497, '2020-04-08', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '106', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86498, '2020-04-09', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '107', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86499, '2020-04-10', 'TT', 'Trinidad and Tobago', 'AMRO', '2', '109', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86500, '2020-04-11', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '109', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86501, '2020-04-12', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '109', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86502, '2020-04-13', 'TT', 'Trinidad and Tobago', 'AMRO', '3', '112', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86503, '2020-04-14', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '113', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86504, '2020-04-15', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '113', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86505, '2020-04-16', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '114', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86506, '2020-04-17', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '114', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86507, '2020-04-18', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '114', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86508, '2020-04-19', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '114', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86509, '2020-04-20', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '114', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86510, '2020-04-21', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '114', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86511, '2020-04-22', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '114', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86512, '2020-04-23', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '115', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86513, '2020-04-24', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '115', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86514, '2020-04-25', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '115', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86515, '2020-04-26', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '115', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86516, '2020-04-27', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '115', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86517, '2020-04-28', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86518, '2020-04-29', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86519, '2020-04-30', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86520, '2020-05-01', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86521, '2020-05-02', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86522, '2020-05-03', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86523, '2020-05-04', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86524, '2020-05-05', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86525, '2020-05-06', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86526, '2020-05-07', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86527, '2020-05-08', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86528, '2020-05-09', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86529, '2020-05-10', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86530, '2020-05-11', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86531, '2020-05-12', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86532, '2020-05-13', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86533, '2020-05-14', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86534, '2020-05-15', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86535, '2020-05-16', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86536, '2020-05-17', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86537, '2020-05-18', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86538, '2020-05-19', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86539, '2020-05-20', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86540, '2020-05-21', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86541, '2020-05-22', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86542, '2020-05-23', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86543, '2020-05-24', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86544, '2020-05-25', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86545, '2020-05-26', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86546, '2020-05-27', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86547, '2020-05-28', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86548, '2020-05-29', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86549, '2020-05-30', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86550, '2020-05-31', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '116', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86551, '2020-06-01', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86552, '2020-06-02', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86553, '2020-06-03', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86554, '2020-06-04', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86555, '2020-06-05', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86556, '2020-06-06', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86557, '2020-06-07', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86558, '2020-06-08', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86559, '2020-06-09', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86560, '2020-06-10', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86561, '2020-06-11', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86562, '2020-06-12', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86563, '2020-06-13', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86564, '2020-06-14', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86565, '2020-06-15', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '117', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86566, '2020-06-16', 'TT', 'Trinidad and Tobago', 'AMRO', '6', '123', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86567, '2020-06-17', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '123', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86568, '2020-06-18', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '123', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86569, '2020-06-19', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '123', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86570, '2020-06-20', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '123', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86571, '2020-06-21', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '123', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86572, '2020-06-22', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '123', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86573, '2020-06-23', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '123', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86574, '2020-06-24', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '123', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86575, '2020-06-25', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '123', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86576, '2020-06-26', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '123', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86577, '2020-06-27', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '123', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86578, '2020-06-28', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '124', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86579, '2020-06-29', 'TT', 'Trinidad and Tobago', 'AMRO', '2', '126', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86580, '2020-06-30', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '126', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86581, '2020-07-01', 'TT', 'Trinidad and Tobago', 'AMRO', '4', '130', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86582, '2020-07-02', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '130', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86583, '2020-07-03', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '130', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86584, '2020-07-04', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '130', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86585, '2020-07-05', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '130', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86586, '2020-07-06', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '131', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86587, '2020-07-07', 'TT', 'Trinidad and Tobago', 'AMRO', '2', '133', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86588, '2020-07-08', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '133', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86589, '2020-07-09', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '133', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86590, '2020-07-10', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '133', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86591, '2020-07-11', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '133', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86592, '2020-07-12', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '133', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86593, '2020-07-13', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '133', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86594, '2020-07-14', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '133', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86595, '2020-07-15', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '133', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86596, '2020-07-16', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '133', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86597, '2020-07-17', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '133', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86598, '2020-07-18', 'TT', 'Trinidad and Tobago', 'AMRO', '3', '136', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86599, '2020-07-19', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '136', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86600, '2020-07-20', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '137', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86601, '2020-07-21', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '137', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86602, '2020-07-22', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '137', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86603, '2020-07-23', 'TT', 'Trinidad and Tobago', 'AMRO', '3', '140', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86604, '2020-07-24', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '141', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86605, '2020-07-25', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '142', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86606, '2020-07-26', 'TT', 'Trinidad and Tobago', 'AMRO', '5', '147', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86607, '2020-07-27', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '147', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86608, '2020-07-28', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '148', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86609, '2020-07-29', 'TT', 'Trinidad and Tobago', 'AMRO', '5', '153', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86610, '2020-07-30', 'TT', 'Trinidad and Tobago', 'AMRO', '3', '156', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86611, '2020-07-31', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '157', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86612, '2020-08-01', 'TT', 'Trinidad and Tobago', 'AMRO', '12', '169', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86613, '2020-08-02', 'TT', 'Trinidad and Tobago', 'AMRO', '4', '173', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86614, '2020-08-03', 'TT', 'Trinidad and Tobago', 'AMRO', '7', '180', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86615, '2020-08-04', 'TT', 'Trinidad and Tobago', 'AMRO', '2', '182', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86616, '2020-08-05', 'TT', 'Trinidad and Tobago', 'AMRO', '10', '192', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86617, '2020-08-06', 'TT', 'Trinidad and Tobago', 'AMRO', '5', '197', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86618, '2020-08-07', 'TT', 'Trinidad and Tobago', 'AMRO', '10', '207', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86619, '2020-08-08', 'TT', 'Trinidad and Tobago', 'AMRO', '10', '217', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86620, '2020-08-09', 'TT', 'Trinidad and Tobago', 'AMRO', '8', '225', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86621, '2020-08-10', 'TT', 'Trinidad and Tobago', 'AMRO', '54', '279', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86622, '2020-08-11', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '280', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86623, '2020-08-12', 'TT', 'Trinidad and Tobago', 'AMRO', '15', '295', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86624, '2020-08-13', 'TT', 'Trinidad and Tobago', 'AMRO', '13', '308', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86625, '2020-08-14', 'TT', 'Trinidad and Tobago', 'AMRO', '61', '369', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86626, '2020-08-15', 'TT', 'Trinidad and Tobago', 'AMRO', '43', '412', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86627, '2020-08-16', 'TT', 'Trinidad and Tobago', 'AMRO', '62', '474', '2', '10');
INSERT INTO public.who_global_data_import VALUES (86628, '2020-08-17', 'TT', 'Trinidad and Tobago', 'AMRO', '45', '519', '1', '11');
INSERT INTO public.who_global_data_import VALUES (86629, '2020-08-18', 'TT', 'Trinidad and Tobago', 'AMRO', '46', '565', '1', '12');
INSERT INTO public.who_global_data_import VALUES (86630, '2020-08-19', 'TT', 'Trinidad and Tobago', 'AMRO', '35', '600', '0', '12');
INSERT INTO public.who_global_data_import VALUES (86631, '2020-08-20', 'TT', 'Trinidad and Tobago', 'AMRO', '50', '650', '0', '12');
INSERT INTO public.who_global_data_import VALUES (86632, '2020-08-21', 'TT', 'Trinidad and Tobago', 'AMRO', '80', '730', '0', '12');
INSERT INTO public.who_global_data_import VALUES (86633, '2020-08-22', 'TT', 'Trinidad and Tobago', 'AMRO', '76', '806', '0', '12');
INSERT INTO public.who_global_data_import VALUES (86634, '2020-08-23', 'TT', 'Trinidad and Tobago', 'AMRO', '93', '899', '1', '13');
INSERT INTO public.who_global_data_import VALUES (86635, '2020-08-24', 'TT', 'Trinidad and Tobago', 'AMRO', '64', '963', '1', '14');
INSERT INTO public.who_global_data_import VALUES (86636, '2020-08-25', 'TT', 'Trinidad and Tobago', 'AMRO', '68', '1031', '1', '15');
INSERT INTO public.who_global_data_import VALUES (86637, '2020-08-26', 'TT', 'Trinidad and Tobago', 'AMRO', '153', '1184', '0', '15');
INSERT INTO public.who_global_data_import VALUES (86638, '2020-08-27', 'TT', 'Trinidad and Tobago', 'AMRO', '200', '1384', '0', '15');
INSERT INTO public.who_global_data_import VALUES (86639, '2020-08-28', 'TT', 'Trinidad and Tobago', 'AMRO', '45', '1429', '0', '15');
INSERT INTO public.who_global_data_import VALUES (86640, '2020-08-29', 'TT', 'Trinidad and Tobago', 'AMRO', '83', '1512', '2', '17');
INSERT INTO public.who_global_data_import VALUES (86641, '2020-08-30', 'TT', 'Trinidad and Tobago', 'AMRO', '65', '1577', '2', '19');
INSERT INTO public.who_global_data_import VALUES (86642, '2020-08-31', 'TT', 'Trinidad and Tobago', 'AMRO', '106', '1683', '2', '21');
INSERT INTO public.who_global_data_import VALUES (86643, '2020-09-01', 'TT', 'Trinidad and Tobago', 'AMRO', '44', '1727', '1', '22');
INSERT INTO public.who_global_data_import VALUES (86644, '2020-09-02', 'TT', 'Trinidad and Tobago', 'AMRO', '46', '1773', '3', '25');
INSERT INTO public.who_global_data_import VALUES (86645, '2020-09-03', 'TT', 'Trinidad and Tobago', 'AMRO', '66', '1839', '3', '28');
INSERT INTO public.who_global_data_import VALUES (86646, '2020-09-04', 'TT', 'Trinidad and Tobago', 'AMRO', '102', '1941', '0', '28');
INSERT INTO public.who_global_data_import VALUES (86647, '2020-09-05', 'TT', 'Trinidad and Tobago', 'AMRO', '89', '2030', '2', '30');
INSERT INTO public.who_global_data_import VALUES (86648, '2020-09-06', 'TT', 'Trinidad and Tobago', 'AMRO', '112', '2142', '2', '32');
INSERT INTO public.who_global_data_import VALUES (86649, '2020-09-07', 'TT', 'Trinidad and Tobago', 'AMRO', '92', '2234', '1', '33');
INSERT INTO public.who_global_data_import VALUES (86650, '2020-09-08', 'TT', 'Trinidad and Tobago', 'AMRO', '20', '2254', '2', '35');
INSERT INTO public.who_global_data_import VALUES (86651, '2020-09-09', 'TT', 'Trinidad and Tobago', 'AMRO', '93', '2347', '3', '38');
INSERT INTO public.who_global_data_import VALUES (86652, '2020-09-10', 'TT', 'Trinidad and Tobago', 'AMRO', '146', '2493', '1', '39');
INSERT INTO public.who_global_data_import VALUES (86653, '2020-09-11', 'TT', 'Trinidad and Tobago', 'AMRO', '170', '2663', '1', '40');
INSERT INTO public.who_global_data_import VALUES (86654, '2020-09-12', 'TT', 'Trinidad and Tobago', 'AMRO', '114', '2777', '5', '45');
INSERT INTO public.who_global_data_import VALUES (86655, '2020-09-13', 'TT', 'Trinidad and Tobago', 'AMRO', '115', '2892', '5', '50');
INSERT INTO public.who_global_data_import VALUES (86656, '2020-09-14', 'TT', 'Trinidad and Tobago', 'AMRO', '127', '3019', '3', '53');
INSERT INTO public.who_global_data_import VALUES (86657, '2020-09-15', 'TT', 'Trinidad and Tobago', 'AMRO', '72', '3091', '1', '54');
INSERT INTO public.who_global_data_import VALUES (86658, '2020-09-16', 'TT', 'Trinidad and Tobago', 'AMRO', '92', '3183', '2', '56');
INSERT INTO public.who_global_data_import VALUES (86659, '2020-09-17', 'TT', 'Trinidad and Tobago', 'AMRO', '110', '3293', '1', '57');
INSERT INTO public.who_global_data_import VALUES (86660, '2020-09-18', 'TT', 'Trinidad and Tobago', 'AMRO', '43', '3336', '1', '58');
INSERT INTO public.who_global_data_import VALUES (86661, '2020-09-19', 'TT', 'Trinidad and Tobago', 'AMRO', '176', '3512', '2', '60');
INSERT INTO public.who_global_data_import VALUES (86662, '2020-09-20', 'TT', 'Trinidad and Tobago', 'AMRO', '227', '3739', '0', '60');
INSERT INTO public.who_global_data_import VALUES (86663, '2020-09-21', 'TT', 'Trinidad and Tobago', 'AMRO', '127', '3866', '4', '64');
INSERT INTO public.who_global_data_import VALUES (86664, '2020-09-22', 'TT', 'Trinidad and Tobago', 'AMRO', '64', '3930', '1', '65');
INSERT INTO public.who_global_data_import VALUES (86665, '2020-09-23', 'TT', 'Trinidad and Tobago', 'AMRO', '44', '3974', '0', '65');
INSERT INTO public.who_global_data_import VALUES (86666, '2020-09-24', 'TT', 'Trinidad and Tobago', 'AMRO', '72', '4046', '2', '67');
INSERT INTO public.who_global_data_import VALUES (86667, '2020-09-25', 'TT', 'Trinidad and Tobago', 'AMRO', '176', '4222', '0', '67');
INSERT INTO public.who_global_data_import VALUES (86668, '2020-09-26', 'TT', 'Trinidad and Tobago', 'AMRO', '38', '4260', '2', '69');
INSERT INTO public.who_global_data_import VALUES (86669, '2020-09-27', 'TT', 'Trinidad and Tobago', 'AMRO', '25', '4285', '1', '70');
INSERT INTO public.who_global_data_import VALUES (86670, '2020-09-28', 'TT', 'Trinidad and Tobago', 'AMRO', '36', '4321', '0', '70');
INSERT INTO public.who_global_data_import VALUES (86671, '2020-09-29', 'TT', 'Trinidad and Tobago', 'AMRO', '61', '4382', '2', '72');
INSERT INTO public.who_global_data_import VALUES (86672, '2020-09-30', 'TT', 'Trinidad and Tobago', 'AMRO', '59', '4441', '2', '74');
INSERT INTO public.who_global_data_import VALUES (86673, '2020-10-01', 'TT', 'Trinidad and Tobago', 'AMRO', '76', '4517', '1', '75');
INSERT INTO public.who_global_data_import VALUES (86674, '2020-10-02', 'TT', 'Trinidad and Tobago', 'AMRO', '25', '4542', '1', '76');
INSERT INTO public.who_global_data_import VALUES (86675, '2020-10-03', 'TT', 'Trinidad and Tobago', 'AMRO', '71', '4613', '0', '76');
INSERT INTO public.who_global_data_import VALUES (86676, '2020-10-04', 'TT', 'Trinidad and Tobago', 'AMRO', '96', '4709', '2', '78');
INSERT INTO public.who_global_data_import VALUES (86677, '2020-10-05', 'TT', 'Trinidad and Tobago', 'AMRO', '32', '4741', '3', '81');
INSERT INTO public.who_global_data_import VALUES (86678, '2020-10-06', 'TT', 'Trinidad and Tobago', 'AMRO', '25', '4766', '0', '81');
INSERT INTO public.who_global_data_import VALUES (86679, '2020-10-07', 'TT', 'Trinidad and Tobago', 'AMRO', '52', '4818', '2', '83');
INSERT INTO public.who_global_data_import VALUES (86680, '2020-10-08', 'TT', 'Trinidad and Tobago', 'AMRO', '58', '4876', '1', '84');
INSERT INTO public.who_global_data_import VALUES (86681, '2020-10-09', 'TT', 'Trinidad and Tobago', 'AMRO', '11', '4887', '0', '84');
INSERT INTO public.who_global_data_import VALUES (86682, '2020-10-10', 'TT', 'Trinidad and Tobago', 'AMRO', '76', '4963', '2', '86');
INSERT INTO public.who_global_data_import VALUES (86683, '2020-10-11', 'TT', 'Trinidad and Tobago', 'AMRO', '80', '5043', '4', '90');
INSERT INTO public.who_global_data_import VALUES (86684, '2020-10-12', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '5043', '0', '90');
INSERT INTO public.who_global_data_import VALUES (86685, '2020-10-13', 'TT', 'Trinidad and Tobago', 'AMRO', '58', '5101', '0', '90');
INSERT INTO public.who_global_data_import VALUES (86686, '2020-10-14', 'TT', 'Trinidad and Tobago', 'AMRO', '15', '5116', '2', '92');
INSERT INTO public.who_global_data_import VALUES (86687, '2020-10-15', 'TT', 'Trinidad and Tobago', 'AMRO', '11', '5127', '1', '93');
INSERT INTO public.who_global_data_import VALUES (86688, '2020-10-16', 'TT', 'Trinidad and Tobago', 'AMRO', '27', '5154', '0', '93');
INSERT INTO public.who_global_data_import VALUES (86689, '2020-10-17', 'TT', 'Trinidad and Tobago', 'AMRO', '40', '5194', '0', '93');
INSERT INTO public.who_global_data_import VALUES (86690, '2020-10-18', 'TT', 'Trinidad and Tobago', 'AMRO', '47', '5241', '2', '95');
INSERT INTO public.who_global_data_import VALUES (86691, '2020-10-19', 'TT', 'Trinidad and Tobago', 'AMRO', '40', '5281', '0', '95');
INSERT INTO public.who_global_data_import VALUES (86692, '2020-10-20', 'TT', 'Trinidad and Tobago', 'AMRO', '16', '5297', '1', '96');
INSERT INTO public.who_global_data_import VALUES (86693, '2020-10-21', 'TT', 'Trinidad and Tobago', 'AMRO', '1', '5298', '1', '97');
INSERT INTO public.who_global_data_import VALUES (86694, '2020-10-22', 'TT', 'Trinidad and Tobago', 'AMRO', '35', '5333', '1', '98');
INSERT INTO public.who_global_data_import VALUES (86695, '2020-10-23', 'TT', 'Trinidad and Tobago', 'AMRO', '59', '5392', '3', '101');
INSERT INTO public.who_global_data_import VALUES (86696, '2020-10-24', 'TT', 'Trinidad and Tobago', 'AMRO', '54', '5446', '2', '103');
INSERT INTO public.who_global_data_import VALUES (86697, '2020-10-25', 'TT', 'Trinidad and Tobago', 'AMRO', '41', '5487', '1', '104');
INSERT INTO public.who_global_data_import VALUES (86698, '2020-10-26', 'TT', 'Trinidad and Tobago', 'AMRO', '16', '5503', '1', '105');
INSERT INTO public.who_global_data_import VALUES (86699, '2020-10-27', 'TT', 'Trinidad and Tobago', 'AMRO', '8', '5511', '0', '105');
INSERT INTO public.who_global_data_import VALUES (86700, '2020-10-28', 'TT', 'Trinidad and Tobago', 'AMRO', '24', '5535', '1', '106');
INSERT INTO public.who_global_data_import VALUES (86701, '2020-10-29', 'TT', 'Trinidad and Tobago', 'AMRO', '33', '5568', '0', '106');
INSERT INTO public.who_global_data_import VALUES (86702, '2020-10-30', 'TT', 'Trinidad and Tobago', 'AMRO', '26', '5594', '1', '107');
INSERT INTO public.who_global_data_import VALUES (86703, '2020-10-31', 'TT', 'Trinidad and Tobago', 'AMRO', '42', '5636', '0', '107');
INSERT INTO public.who_global_data_import VALUES (86704, '2020-11-01', 'TT', 'Trinidad and Tobago', 'AMRO', '32', '5668', '0', '107');
INSERT INTO public.who_global_data_import VALUES (86705, '2020-11-02', 'TT', 'Trinidad and Tobago', 'AMRO', '36', '5704', '1', '108');
INSERT INTO public.who_global_data_import VALUES (86706, '2020-11-03', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '5704', '1', '109');
INSERT INTO public.who_global_data_import VALUES (86707, '2020-11-04', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '5704', '0', '109');
INSERT INTO public.who_global_data_import VALUES (86708, '2020-11-05', 'TT', 'Trinidad and Tobago', 'AMRO', '50', '5754', '1', '110');
INSERT INTO public.who_global_data_import VALUES (86709, '2020-11-06', 'TT', 'Trinidad and Tobago', 'AMRO', '10', '5764', '0', '110');
INSERT INTO public.who_global_data_import VALUES (86710, '2020-11-07', 'TT', 'Trinidad and Tobago', 'AMRO', '10', '5774', '1', '111');
INSERT INTO public.who_global_data_import VALUES (86711, '2020-11-08', 'TT', 'Trinidad and Tobago', 'AMRO', '24', '5798', '0', '111');
INSERT INTO public.who_global_data_import VALUES (86712, '2020-11-09', 'TT', 'Trinidad and Tobago', 'AMRO', '40', '5838', '0', '111');
INSERT INTO public.who_global_data_import VALUES (86713, '2020-11-10', 'TT', 'Trinidad and Tobago', 'AMRO', '11', '5849', '0', '111');
INSERT INTO public.who_global_data_import VALUES (86714, '2020-11-11', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '5849', '0', '111');
INSERT INTO public.who_global_data_import VALUES (86715, '2020-11-12', 'TT', 'Trinidad and Tobago', 'AMRO', '31', '5880', '0', '111');
INSERT INTO public.who_global_data_import VALUES (86716, '2020-11-13', 'TT', 'Trinidad and Tobago', 'AMRO', '24', '5904', '0', '111');
INSERT INTO public.who_global_data_import VALUES (86717, '2020-11-14', 'TT', 'Trinidad and Tobago', 'AMRO', '26', '5930', '0', '111');
INSERT INTO public.who_global_data_import VALUES (86718, '2020-11-15', 'TT', 'Trinidad and Tobago', 'AMRO', '50', '5980', '0', '111');
INSERT INTO public.who_global_data_import VALUES (86719, '2020-11-16', 'TT', 'Trinidad and Tobago', 'AMRO', '97', '6077', '1', '112');
INSERT INTO public.who_global_data_import VALUES (86720, '2020-11-17', 'TT', 'Trinidad and Tobago', 'AMRO', '3', '6080', '0', '112');
INSERT INTO public.who_global_data_import VALUES (86721, '2020-11-18', 'TT', 'Trinidad and Tobago', 'AMRO', '16', '6096', '0', '112');
INSERT INTO public.who_global_data_import VALUES (86722, '2020-11-19', 'TT', 'Trinidad and Tobago', 'AMRO', '39', '6135', '1', '113');
INSERT INTO public.who_global_data_import VALUES (86723, '2020-11-20', 'TT', 'Trinidad and Tobago', 'AMRO', '45', '6180', '0', '113');
INSERT INTO public.who_global_data_import VALUES (86724, '2020-11-21', 'TT', 'Trinidad and Tobago', 'AMRO', '53', '6233', '0', '113');
INSERT INTO public.who_global_data_import VALUES (86725, '2020-11-22', 'TT', 'Trinidad and Tobago', 'AMRO', '28', '6261', '0', '113');
INSERT INTO public.who_global_data_import VALUES (86726, '2020-11-23', 'TT', 'Trinidad and Tobago', 'AMRO', '63', '6324', '2', '115');
INSERT INTO public.who_global_data_import VALUES (86727, '2020-11-24', 'TT', 'Trinidad and Tobago', 'AMRO', '126', '6450', '0', '115');
INSERT INTO public.who_global_data_import VALUES (86728, '2020-11-25', 'TT', 'Trinidad and Tobago', 'AMRO', '25', '6475', '0', '115');
INSERT INTO public.who_global_data_import VALUES (86729, '2020-11-26', 'TT', 'Trinidad and Tobago', 'AMRO', '13', '6488', '0', '115');
INSERT INTO public.who_global_data_import VALUES (86730, '2020-11-27', 'TT', 'Trinidad and Tobago', 'AMRO', '15', '6503', '1', '116');
INSERT INTO public.who_global_data_import VALUES (86731, '2020-11-28', 'TT', 'Trinidad and Tobago', 'AMRO', '67', '6570', '0', '116');
INSERT INTO public.who_global_data_import VALUES (86732, '2020-11-29', 'TT', 'Trinidad and Tobago', 'AMRO', '16', '6586', '2', '118');
INSERT INTO public.who_global_data_import VALUES (86733, '2020-11-30', 'TT', 'Trinidad and Tobago', 'AMRO', '44', '6630', '0', '118');
INSERT INTO public.who_global_data_import VALUES (86734, '2020-12-01', 'TT', 'Trinidad and Tobago', 'AMRO', '30', '6660', '2', '120');
INSERT INTO public.who_global_data_import VALUES (86735, '2020-12-02', 'TT', 'Trinidad and Tobago', 'AMRO', '9', '6669', '0', '120');
INSERT INTO public.who_global_data_import VALUES (86736, '2020-12-03', 'TT', 'Trinidad and Tobago', 'AMRO', '16', '6685', '0', '120');
INSERT INTO public.who_global_data_import VALUES (86737, '2020-12-04', 'TT', 'Trinidad and Tobago', 'AMRO', '19', '6704', '1', '121');
INSERT INTO public.who_global_data_import VALUES (86738, '2020-12-05', 'TT', 'Trinidad and Tobago', 'AMRO', '21', '6725', '0', '121');
INSERT INTO public.who_global_data_import VALUES (86739, '2020-12-06', 'TT', 'Trinidad and Tobago', 'AMRO', '10', '6735', '0', '121');
INSERT INTO public.who_global_data_import VALUES (86740, '2020-12-07', 'TT', 'Trinidad and Tobago', 'AMRO', '16', '6751', '1', '122');
INSERT INTO public.who_global_data_import VALUES (86741, '2020-12-08', 'TT', 'Trinidad and Tobago', 'AMRO', '16', '6767', '0', '122');
INSERT INTO public.who_global_data_import VALUES (86742, '2020-12-09', 'TT', 'Trinidad and Tobago', 'AMRO', '8', '6775', '0', '122');
INSERT INTO public.who_global_data_import VALUES (86743, '2020-12-10', 'TT', 'Trinidad and Tobago', 'AMRO', '33', '6808', '0', '122');
INSERT INTO public.who_global_data_import VALUES (86744, '2020-12-11', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '6808', '0', '122');
INSERT INTO public.who_global_data_import VALUES (86745, '2020-12-12', 'TT', 'Trinidad and Tobago', 'AMRO', '25', '6833', '0', '122');
INSERT INTO public.who_global_data_import VALUES (86746, '2020-12-13', 'TT', 'Trinidad and Tobago', 'AMRO', '19', '6852', '0', '122');
INSERT INTO public.who_global_data_import VALUES (86747, '2020-12-14', 'TT', 'Trinidad and Tobago', 'AMRO', '12', '6864', '0', '122');
INSERT INTO public.who_global_data_import VALUES (86748, '2020-12-15', 'TT', 'Trinidad and Tobago', 'AMRO', '15', '6879', '0', '122');
INSERT INTO public.who_global_data_import VALUES (86749, '2020-12-16', 'TT', 'Trinidad and Tobago', 'AMRO', '6', '6885', '1', '123');
INSERT INTO public.who_global_data_import VALUES (86750, '2020-12-17', 'TT', 'Trinidad and Tobago', 'AMRO', '15', '6900', '0', '123');
INSERT INTO public.who_global_data_import VALUES (86751, '2020-12-18', 'TT', 'Trinidad and Tobago', 'AMRO', '17', '6917', '0', '123');
INSERT INTO public.who_global_data_import VALUES (86752, '2020-12-19', 'TT', 'Trinidad and Tobago', 'AMRO', '23', '6940', '0', '123');
INSERT INTO public.who_global_data_import VALUES (86753, '2020-12-20', 'TT', 'Trinidad and Tobago', 'AMRO', '15', '6955', '0', '123');
INSERT INTO public.who_global_data_import VALUES (86754, '2020-12-21', 'TT', 'Trinidad and Tobago', 'AMRO', '19', '6974', '0', '123');
INSERT INTO public.who_global_data_import VALUES (86755, '2020-12-22', 'TT', 'Trinidad and Tobago', 'AMRO', '26', '7000', '0', '123');
INSERT INTO public.who_global_data_import VALUES (86756, '2020-12-23', 'TT', 'Trinidad and Tobago', 'AMRO', '12', '7012', '2', '125');
INSERT INTO public.who_global_data_import VALUES (86757, '2020-12-24', 'TT', 'Trinidad and Tobago', 'AMRO', '12', '7024', '0', '125');
INSERT INTO public.who_global_data_import VALUES (86758, '2020-12-25', 'TT', 'Trinidad and Tobago', 'AMRO', '47', '7071', '0', '125');
INSERT INTO public.who_global_data_import VALUES (86759, '2020-12-26', 'TT', 'Trinidad and Tobago', 'AMRO', '18', '7089', '0', '125');
INSERT INTO public.who_global_data_import VALUES (86760, '2020-12-27', 'TT', 'Trinidad and Tobago', 'AMRO', '8', '7097', '0', '125');
INSERT INTO public.who_global_data_import VALUES (86761, '2020-12-28', 'TT', 'Trinidad and Tobago', 'AMRO', '7', '7104', '0', '125');
INSERT INTO public.who_global_data_import VALUES (86762, '2020-12-29', 'TT', 'Trinidad and Tobago', 'AMRO', '11', '7115', '0', '125');
INSERT INTO public.who_global_data_import VALUES (86763, '2020-12-30', 'TT', 'Trinidad and Tobago', 'AMRO', '12', '7127', '0', '125');
INSERT INTO public.who_global_data_import VALUES (86764, '2020-12-31', 'TT', 'Trinidad and Tobago', 'AMRO', '5', '7132', '1', '126');
INSERT INTO public.who_global_data_import VALUES (86765, '2021-01-01', 'TT', 'Trinidad and Tobago', 'AMRO', '0', '7132', '0', '126');
INSERT INTO public.who_global_data_import VALUES (86766, '2021-01-02', 'TT', 'Trinidad and Tobago', 'AMRO', '18', '7150', '1', '127');
INSERT INTO public.who_global_data_import VALUES (86767, '2021-01-03', 'TT', 'Trinidad and Tobago', 'AMRO', '8', '7158', '0', '127');
INSERT INTO public.who_global_data_import VALUES (86768, '2021-01-04', 'TT', 'Trinidad and Tobago', 'AMRO', '4', '7162', '0', '127');
INSERT INTO public.who_global_data_import VALUES (86769, '2021-01-05', 'TT', 'Trinidad and Tobago', 'AMRO', '6', '7168', '0', '127');
INSERT INTO public.who_global_data_import VALUES (86770, '2021-01-06', 'TT', 'Trinidad and Tobago', 'AMRO', '10', '7178', '0', '127');
INSERT INTO public.who_global_data_import VALUES (86771, '2021-01-07', 'TT', 'Trinidad and Tobago', 'AMRO', '8', '7186', '0', '127');
INSERT INTO public.who_global_data_import VALUES (86772, '2021-01-08', 'TT', 'Trinidad and Tobago', 'AMRO', '10', '7196', '0', '127');
INSERT INTO public.who_global_data_import VALUES (86773, '2021-01-09', 'TT', 'Trinidad and Tobago', 'AMRO', '14', '7210', '0', '127');
INSERT INTO public.who_global_data_import VALUES (86774, '2021-01-10', 'TT', 'Trinidad and Tobago', 'AMRO', '9', '7219', '0', '127');
INSERT INTO public.who_global_data_import VALUES (86775, '2021-01-11', 'TT', 'Trinidad and Tobago', 'AMRO', '25', '7244', '1', '128');
INSERT INTO public.who_global_data_import VALUES (86776, '2021-01-12', 'TT', 'Trinidad and Tobago', 'AMRO', '21', '7265', '0', '128');
INSERT INTO public.who_global_data_import VALUES (86777, '2021-01-13', 'TT', 'Trinidad and Tobago', 'AMRO', '8', '7273', '0', '128');
INSERT INTO public.who_global_data_import VALUES (86778, '2021-01-14', 'TT', 'Trinidad and Tobago', 'AMRO', '13', '7286', '0', '128');
INSERT INTO public.who_global_data_import VALUES (86779, '2021-01-15', 'TT', 'Trinidad and Tobago', 'AMRO', '19', '7305', '1', '129');
INSERT INTO public.who_global_data_import VALUES (86780, '2021-01-16', 'TT', 'Trinidad and Tobago', 'AMRO', '15', '7320', '1', '130');
INSERT INTO public.who_global_data_import VALUES (86781, '2021-01-17', 'TT', 'Trinidad and Tobago', 'AMRO', '23', '7343', '0', '130');
INSERT INTO public.who_global_data_import VALUES (86782, '2021-01-18', 'TT', 'Trinidad and Tobago', 'AMRO', '27', '7370', '1', '131');
INSERT INTO public.who_global_data_import VALUES (86783, '2021-01-19', 'TT', 'Trinidad and Tobago', 'AMRO', '23', '7393', '1', '132');
INSERT INTO public.who_global_data_import VALUES (86784, '2021-01-20', 'TT', 'Trinidad and Tobago', 'AMRO', '6', '7399', '0', '132');
INSERT INTO public.who_global_data_import VALUES (86785, '2021-01-21', 'TT', 'Trinidad and Tobago', 'AMRO', '16', '7415', '0', '132');
INSERT INTO public.who_global_data_import VALUES (86786, '2021-01-22', 'TT', 'Trinidad and Tobago', 'AMRO', '15', '7430', '1', '133');
INSERT INTO public.who_global_data_import VALUES (86787, '2021-01-23', 'TT', 'Trinidad and Tobago', 'AMRO', '20', '7450', '0', '133');
INSERT INTO public.who_global_data_import VALUES (86788, '2021-01-24', 'TT', 'Trinidad and Tobago', 'AMRO', '6', '7456', '0', '133');
INSERT INTO public.who_global_data_import VALUES (86789, '2021-01-25', 'TT', 'Trinidad and Tobago', 'AMRO', '6', '7462', '1', '134');
INSERT INTO public.who_global_data_import VALUES (86790, '2021-01-26', 'TT', 'Trinidad and Tobago', 'AMRO', '11', '7473', '0', '134');
INSERT INTO public.who_global_data_import VALUES (86791, '2021-01-27', 'TT', 'Trinidad and Tobago', 'AMRO', '17', '7490', '0', '134');
INSERT INTO public.who_global_data_import VALUES (86792, '2021-01-28', 'TT', 'Trinidad and Tobago', 'AMRO', '6', '7496', '0', '134');
INSERT INTO public.who_global_data_import VALUES (86793, '2021-01-29', 'TT', 'Trinidad and Tobago', 'AMRO', '13', '7509', '0', '134');
INSERT INTO public.who_global_data_import VALUES (86794, '2021-01-30', 'TT', 'Trinidad and Tobago', 'AMRO', '11', '7520', '0', '134');
INSERT INTO public.who_global_data_import VALUES (86795, '2021-01-31', 'TT', 'Trinidad and Tobago', 'AMRO', '13', '7533', '0', '134');
INSERT INTO public.who_global_data_import VALUES (86796, '2021-02-01', 'TT', 'Trinidad and Tobago', 'AMRO', '9', '7542', '0', '134');
INSERT INTO public.who_global_data_import VALUES (86797, '2021-02-02', 'TT', 'Trinidad and Tobago', 'AMRO', '22', '7564', '0', '134');
INSERT INTO public.who_global_data_import VALUES (86798, '2021-02-03', 'TT', 'Trinidad and Tobago', 'AMRO', '2', '7566', '0', '134');
INSERT INTO public.who_global_data_import VALUES (86799, '2021-02-04', 'TT', 'Trinidad and Tobago', 'AMRO', '12', '7578', '0', '134');
INSERT INTO public.who_global_data_import VALUES (86800, '2021-02-05', 'TT', 'Trinidad and Tobago', 'AMRO', '8', '7586', '1', '135');
INSERT INTO public.who_global_data_import VALUES (86801, '2020-01-03', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86802, '2020-01-04', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86803, '2020-01-05', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86804, '2020-01-06', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86805, '2020-01-07', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86806, '2020-01-08', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86807, '2020-01-09', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86808, '2020-01-10', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86809, '2020-01-11', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86810, '2020-01-12', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86811, '2020-01-13', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86812, '2020-01-14', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86813, '2020-01-15', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86814, '2020-01-16', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86815, '2020-01-17', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86816, '2020-01-18', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86817, '2020-01-19', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86818, '2020-01-20', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86819, '2020-01-21', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86820, '2020-01-22', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86821, '2020-01-23', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86822, '2020-01-24', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86823, '2020-01-25', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86824, '2020-01-26', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86825, '2020-01-27', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86826, '2020-01-28', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86827, '2020-01-29', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86828, '2020-01-30', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86829, '2020-01-31', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86830, '2020-02-01', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86831, '2020-02-02', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86832, '2020-02-03', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86833, '2020-02-04', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86834, '2020-02-05', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86835, '2020-02-06', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86836, '2020-02-07', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86837, '2020-02-08', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86838, '2020-02-09', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86839, '2020-02-10', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86840, '2020-02-11', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86841, '2020-02-12', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86842, '2020-02-13', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86843, '2020-02-14', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86844, '2020-02-15', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86845, '2020-02-16', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86846, '2020-02-17', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86847, '2020-02-18', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86848, '2020-02-19', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86849, '2020-02-20', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86850, '2020-02-21', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86851, '2020-02-22', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86852, '2020-02-23', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86853, '2020-02-24', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86854, '2020-02-25', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86855, '2020-02-26', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86856, '2020-02-27', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86857, '2020-02-28', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86858, '2020-02-29', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86859, '2020-03-01', 'TN', 'Tunisia', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86860, '2020-03-02', 'TN', 'Tunisia', 'EMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86861, '2020-03-03', 'TN', 'Tunisia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86862, '2020-03-04', 'TN', 'Tunisia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86863, '2020-03-05', 'TN', 'Tunisia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86864, '2020-03-06', 'TN', 'Tunisia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86865, '2020-03-07', 'TN', 'Tunisia', 'EMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86866, '2020-03-08', 'TN', 'Tunisia', 'EMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86867, '2020-03-09', 'TN', 'Tunisia', 'EMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86868, '2020-03-10', 'TN', 'Tunisia', 'EMRO', '4', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86869, '2020-03-11', 'TN', 'Tunisia', 'EMRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86870, '2020-03-12', 'TN', 'Tunisia', 'EMRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86871, '2020-03-13', 'TN', 'Tunisia', 'EMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86872, '2020-03-14', 'TN', 'Tunisia', 'EMRO', '9', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86873, '2020-03-15', 'TN', 'Tunisia', 'EMRO', '2', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86874, '2020-03-16', 'TN', 'Tunisia', 'EMRO', '2', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86875, '2020-03-17', 'TN', 'Tunisia', 'EMRO', '4', '28', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86876, '2020-03-18', 'TN', 'Tunisia', 'EMRO', '5', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86877, '2020-03-19', 'TN', 'Tunisia', 'EMRO', '6', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86878, '2020-03-20', 'TN', 'Tunisia', 'EMRO', '15', '54', '1', '1');
INSERT INTO public.who_global_data_import VALUES (86879, '2020-03-21', 'TN', 'Tunisia', 'EMRO', '6', '60', '0', '1');
INSERT INTO public.who_global_data_import VALUES (86880, '2020-03-22', 'TN', 'Tunisia', 'EMRO', '15', '75', '2', '3');
INSERT INTO public.who_global_data_import VALUES (86881, '2020-03-23', 'TN', 'Tunisia', 'EMRO', '14', '89', '0', '3');
INSERT INTO public.who_global_data_import VALUES (86882, '2020-03-24', 'TN', 'Tunisia', 'EMRO', '25', '114', '0', '3');
INSERT INTO public.who_global_data_import VALUES (86883, '2020-03-25', 'TN', 'Tunisia', 'EMRO', '59', '173', '2', '5');
INSERT INTO public.who_global_data_import VALUES (86884, '2020-03-26', 'TN', 'Tunisia', 'EMRO', '0', '173', '0', '5');
INSERT INTO public.who_global_data_import VALUES (86885, '2020-03-27', 'TN', 'Tunisia', 'EMRO', '54', '227', '1', '6');
INSERT INTO public.who_global_data_import VALUES (86886, '2020-03-28', 'TN', 'Tunisia', 'EMRO', '0', '227', '0', '6');
INSERT INTO public.who_global_data_import VALUES (86887, '2020-03-29', 'TN', 'Tunisia', 'EMRO', '51', '278', '2', '8');
INSERT INTO public.who_global_data_import VALUES (86888, '2020-03-30', 'TN', 'Tunisia', 'EMRO', '34', '312', '0', '8');
INSERT INTO public.who_global_data_import VALUES (86889, '2020-03-31', 'TN', 'Tunisia', 'EMRO', '50', '362', '1', '9');
INSERT INTO public.who_global_data_import VALUES (86890, '2020-04-01', 'TN', 'Tunisia', 'EMRO', '32', '394', '1', '10');
INSERT INTO public.who_global_data_import VALUES (86891, '2020-04-02', 'TN', 'Tunisia', 'EMRO', '61', '455', '3', '13');
INSERT INTO public.who_global_data_import VALUES (86892, '2020-04-03', 'TN', 'Tunisia', 'EMRO', '40', '495', '5', '18');
INSERT INTO public.who_global_data_import VALUES (86893, '2020-04-04', 'TN', 'Tunisia', 'EMRO', '0', '495', '0', '18');
INSERT INTO public.who_global_data_import VALUES (86894, '2020-04-05', 'TN', 'Tunisia', 'EMRO', '58', '553', '1', '19');
INSERT INTO public.who_global_data_import VALUES (86895, '2020-04-06', 'TN', 'Tunisia', 'EMRO', '21', '574', '3', '22');
INSERT INTO public.who_global_data_import VALUES (86896, '2020-04-07', 'TN', 'Tunisia', 'EMRO', '22', '596', '0', '22');
INSERT INTO public.who_global_data_import VALUES (86897, '2020-04-08', 'TN', 'Tunisia', 'EMRO', '27', '623', '1', '23');
INSERT INTO public.who_global_data_import VALUES (86898, '2020-04-09', 'TN', 'Tunisia', 'EMRO', '5', '628', '1', '24');
INSERT INTO public.who_global_data_import VALUES (86899, '2020-04-10', 'TN', 'Tunisia', 'EMRO', '15', '643', '1', '25');
INSERT INTO public.who_global_data_import VALUES (86900, '2020-04-11', 'TN', 'Tunisia', 'EMRO', '28', '671', '0', '25');
INSERT INTO public.who_global_data_import VALUES (86901, '2020-04-12', 'TN', 'Tunisia', 'EMRO', '14', '685', '3', '28');
INSERT INTO public.who_global_data_import VALUES (86902, '2020-04-13', 'TN', 'Tunisia', 'EMRO', '22', '707', '3', '31');
INSERT INTO public.who_global_data_import VALUES (86903, '2020-04-14', 'TN', 'Tunisia', 'EMRO', '19', '726', '3', '34');
INSERT INTO public.who_global_data_import VALUES (86904, '2020-04-15', 'TN', 'Tunisia', 'EMRO', '21', '747', '0', '34');
INSERT INTO public.who_global_data_import VALUES (86905, '2020-04-16', 'TN', 'Tunisia', 'EMRO', '33', '780', '1', '35');
INSERT INTO public.who_global_data_import VALUES (86906, '2020-04-17', 'TN', 'Tunisia', 'EMRO', '42', '822', '2', '37');
INSERT INTO public.who_global_data_import VALUES (86907, '2020-04-18', 'TN', 'Tunisia', 'EMRO', '42', '864', '0', '37');
INSERT INTO public.who_global_data_import VALUES (86908, '2020-04-19', 'TN', 'Tunisia', 'EMRO', '2', '866', '0', '37');
INSERT INTO public.who_global_data_import VALUES (86909, '2020-04-20', 'TN', 'Tunisia', 'EMRO', '13', '879', '1', '38');
INSERT INTO public.who_global_data_import VALUES (86910, '2020-04-21', 'TN', 'Tunisia', 'EMRO', '5', '884', '0', '38');
INSERT INTO public.who_global_data_import VALUES (86911, '2020-04-22', 'TN', 'Tunisia', 'EMRO', '17', '901', '0', '38');
INSERT INTO public.who_global_data_import VALUES (86912, '2020-04-23', 'TN', 'Tunisia', 'EMRO', '8', '909', '0', '38');
INSERT INTO public.who_global_data_import VALUES (86913, '2020-04-24', 'TN', 'Tunisia', 'EMRO', '9', '918', '0', '38');
INSERT INTO public.who_global_data_import VALUES (86914, '2020-04-25', 'TN', 'Tunisia', 'EMRO', '4', '922', '0', '38');
INSERT INTO public.who_global_data_import VALUES (86915, '2020-04-26', 'TN', 'Tunisia', 'EMRO', '17', '939', '0', '38');
INSERT INTO public.who_global_data_import VALUES (86916, '2020-04-27', 'TN', 'Tunisia', 'EMRO', '10', '949', '0', '38');
INSERT INTO public.who_global_data_import VALUES (86917, '2020-04-28', 'TN', 'Tunisia', 'EMRO', '18', '967', '1', '39');
INSERT INTO public.who_global_data_import VALUES (86918, '2020-04-29', 'TN', 'Tunisia', 'EMRO', '8', '975', '1', '40');
INSERT INTO public.who_global_data_import VALUES (86919, '2020-04-30', 'TN', 'Tunisia', 'EMRO', '5', '980', '0', '40');
INSERT INTO public.who_global_data_import VALUES (86920, '2020-05-01', 'TN', 'Tunisia', 'EMRO', '14', '994', '1', '41');
INSERT INTO public.who_global_data_import VALUES (86921, '2020-05-02', 'TN', 'Tunisia', 'EMRO', '4', '998', '0', '41');
INSERT INTO public.who_global_data_import VALUES (86922, '2020-05-03', 'TN', 'Tunisia', 'EMRO', '11', '1009', '1', '42');
INSERT INTO public.who_global_data_import VALUES (86923, '2020-05-04', 'TN', 'Tunisia', 'EMRO', '4', '1013', '0', '42');
INSERT INTO public.who_global_data_import VALUES (86924, '2020-05-05', 'TN', 'Tunisia', 'EMRO', '5', '1018', '1', '43');
INSERT INTO public.who_global_data_import VALUES (86925, '2020-05-06', 'TN', 'Tunisia', 'EMRO', '4', '1022', '0', '43');
INSERT INTO public.who_global_data_import VALUES (86926, '2020-05-07', 'TN', 'Tunisia', 'EMRO', '3', '1025', '0', '43');
INSERT INTO public.who_global_data_import VALUES (86927, '2020-05-08', 'TN', 'Tunisia', 'EMRO', '1', '1026', '1', '44');
INSERT INTO public.who_global_data_import VALUES (86928, '2020-05-09', 'TN', 'Tunisia', 'EMRO', '4', '1030', '1', '45');
INSERT INTO public.who_global_data_import VALUES (86929, '2020-05-10', 'TN', 'Tunisia', 'EMRO', '2', '1032', '0', '45');
INSERT INTO public.who_global_data_import VALUES (86930, '2020-05-11', 'TN', 'Tunisia', 'EMRO', '0', '1032', '0', '45');
INSERT INTO public.who_global_data_import VALUES (87244, '2020-02-15', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (86931, '2020-05-12', 'TN', 'Tunisia', 'EMRO', '0', '1032', '0', '45');
INSERT INTO public.who_global_data_import VALUES (86932, '2020-05-13', 'TN', 'Tunisia', 'EMRO', '0', '1032', '0', '45');
INSERT INTO public.who_global_data_import VALUES (86933, '2020-05-14', 'TN', 'Tunisia', 'EMRO', '0', '1032', '0', '45');
INSERT INTO public.who_global_data_import VALUES (86934, '2020-05-15', 'TN', 'Tunisia', 'EMRO', '0', '1032', '0', '45');
INSERT INTO public.who_global_data_import VALUES (86935, '2020-05-16', 'TN', 'Tunisia', 'EMRO', '3', '1035', '0', '45');
INSERT INTO public.who_global_data_import VALUES (86936, '2020-05-17', 'TN', 'Tunisia', 'EMRO', '2', '1037', '0', '45');
INSERT INTO public.who_global_data_import VALUES (86937, '2020-05-18', 'TN', 'Tunisia', 'EMRO', '0', '1037', '0', '45');
INSERT INTO public.who_global_data_import VALUES (86938, '2020-05-19', 'TN', 'Tunisia', 'EMRO', '6', '1043', '1', '46');
INSERT INTO public.who_global_data_import VALUES (86939, '2020-05-20', 'TN', 'Tunisia', 'EMRO', '1', '1044', '1', '47');
INSERT INTO public.who_global_data_import VALUES (86940, '2020-05-21', 'TN', 'Tunisia', 'EMRO', '1', '1045', '0', '47');
INSERT INTO public.who_global_data_import VALUES (86941, '2020-05-22', 'TN', 'Tunisia', 'EMRO', '1', '1046', '0', '47');
INSERT INTO public.who_global_data_import VALUES (86942, '2020-05-23', 'TN', 'Tunisia', 'EMRO', '2', '1048', '0', '47');
INSERT INTO public.who_global_data_import VALUES (86943, '2020-05-24', 'TN', 'Tunisia', 'EMRO', '0', '1048', '1', '48');
INSERT INTO public.who_global_data_import VALUES (86944, '2020-05-25', 'TN', 'Tunisia', 'EMRO', '3', '1051', '0', '48');
INSERT INTO public.who_global_data_import VALUES (86945, '2020-05-26', 'TN', 'Tunisia', 'EMRO', '0', '1051', '0', '48');
INSERT INTO public.who_global_data_import VALUES (86946, '2020-05-27', 'TN', 'Tunisia', 'EMRO', '0', '1051', '0', '48');
INSERT INTO public.who_global_data_import VALUES (86947, '2020-05-28', 'TN', 'Tunisia', 'EMRO', '17', '1068', '0', '48');
INSERT INTO public.who_global_data_import VALUES (86948, '2020-05-29', 'TN', 'Tunisia', 'EMRO', '3', '1071', '0', '48');
INSERT INTO public.who_global_data_import VALUES (86949, '2020-05-30', 'TN', 'Tunisia', 'EMRO', '5', '1076', '0', '48');
INSERT INTO public.who_global_data_import VALUES (86950, '2020-05-31', 'TN', 'Tunisia', 'EMRO', '1', '1077', '0', '48');
INSERT INTO public.who_global_data_import VALUES (86951, '2020-06-01', 'TN', 'Tunisia', 'EMRO', '7', '1084', '0', '48');
INSERT INTO public.who_global_data_import VALUES (86952, '2020-06-02', 'TN', 'Tunisia', 'EMRO', '2', '1086', '0', '48');
INSERT INTO public.who_global_data_import VALUES (86953, '2020-06-03', 'TN', 'Tunisia', 'EMRO', '1', '1087', '1', '49');
INSERT INTO public.who_global_data_import VALUES (86954, '2020-06-04', 'TN', 'Tunisia', 'EMRO', '0', '1087', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86955, '2020-06-05', 'TN', 'Tunisia', 'EMRO', '0', '1087', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86956, '2020-06-06', 'TN', 'Tunisia', 'EMRO', '0', '1087', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86957, '2020-06-07', 'TN', 'Tunisia', 'EMRO', '0', '1087', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86958, '2020-06-08', 'TN', 'Tunisia', 'EMRO', '0', '1087', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86959, '2020-06-09', 'TN', 'Tunisia', 'EMRO', '0', '1087', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86960, '2020-06-10', 'TN', 'Tunisia', 'EMRO', '0', '1087', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86961, '2020-06-11', 'TN', 'Tunisia', 'EMRO', '0', '1087', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86962, '2020-06-12', 'TN', 'Tunisia', 'EMRO', '6', '1093', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86963, '2020-06-13', 'TN', 'Tunisia', 'EMRO', '1', '1094', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86964, '2020-06-14', 'TN', 'Tunisia', 'EMRO', '2', '1096', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86965, '2020-06-15', 'TN', 'Tunisia', 'EMRO', '14', '1110', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86966, '2020-06-16', 'TN', 'Tunisia', 'EMRO', '15', '1125', '0', '49');
INSERT INTO public.who_global_data_import VALUES (86967, '2020-06-17', 'TN', 'Tunisia', 'EMRO', '3', '1128', '1', '50');
INSERT INTO public.who_global_data_import VALUES (86968, '2020-06-18', 'TN', 'Tunisia', 'EMRO', '4', '1132', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86969, '2020-06-19', 'TN', 'Tunisia', 'EMRO', '14', '1146', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86970, '2020-06-20', 'TN', 'Tunisia', 'EMRO', '10', '1156', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86971, '2020-06-21', 'TN', 'Tunisia', 'EMRO', '1', '1157', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86972, '2020-06-22', 'TN', 'Tunisia', 'EMRO', '2', '1159', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86973, '2020-06-23', 'TN', 'Tunisia', 'EMRO', '0', '1159', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86974, '2020-06-24', 'TN', 'Tunisia', 'EMRO', '1', '1160', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86975, '2020-06-25', 'TN', 'Tunisia', 'EMRO', '2', '1162', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86976, '2020-06-26', 'TN', 'Tunisia', 'EMRO', '2', '1164', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86977, '2020-06-27', 'TN', 'Tunisia', 'EMRO', '4', '1168', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86978, '2020-06-28', 'TN', 'Tunisia', 'EMRO', '1', '1169', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86979, '2020-06-29', 'TN', 'Tunisia', 'EMRO', '3', '1172', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86980, '2020-06-30', 'TN', 'Tunisia', 'EMRO', '2', '1174', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86981, '2020-07-01', 'TN', 'Tunisia', 'EMRO', '1', '1175', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86982, '2020-07-02', 'TN', 'Tunisia', 'EMRO', '3', '1178', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86983, '2020-07-03', 'TN', 'Tunisia', 'EMRO', '3', '1181', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86984, '2020-07-04', 'TN', 'Tunisia', 'EMRO', '5', '1186', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86985, '2020-07-05', 'TN', 'Tunisia', 'EMRO', '2', '1188', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86986, '2020-07-06', 'TN', 'Tunisia', 'EMRO', '11', '1199', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86987, '2020-07-07', 'TN', 'Tunisia', 'EMRO', '6', '1205', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86988, '2020-07-08', 'TN', 'Tunisia', 'EMRO', '16', '1221', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86989, '2020-07-09', 'TN', 'Tunisia', 'EMRO', '10', '1231', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86990, '2020-07-10', 'TN', 'Tunisia', 'EMRO', '9', '1240', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86991, '2020-07-11', 'TN', 'Tunisia', 'EMRO', '5', '1245', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86992, '2020-07-12', 'TN', 'Tunisia', 'EMRO', '18', '1263', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86993, '2020-07-13', 'TN', 'Tunisia', 'EMRO', '39', '1302', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86994, '2020-07-14', 'TN', 'Tunisia', 'EMRO', '4', '1306', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86995, '2020-07-15', 'TN', 'Tunisia', 'EMRO', '13', '1319', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86996, '2020-07-16', 'TN', 'Tunisia', 'EMRO', '8', '1327', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86997, '2020-07-17', 'TN', 'Tunisia', 'EMRO', '9', '1336', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86998, '2020-07-18', 'TN', 'Tunisia', 'EMRO', '12', '1348', '0', '50');
INSERT INTO public.who_global_data_import VALUES (86999, '2020-07-19', 'TN', 'Tunisia', 'EMRO', '26', '1374', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87000, '2020-07-20', 'TN', 'Tunisia', 'EMRO', '7', '1381', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87001, '2020-07-21', 'TN', 'Tunisia', 'EMRO', '8', '1389', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87002, '2020-07-22', 'TN', 'Tunisia', 'EMRO', '5', '1394', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87003, '2020-07-23', 'TN', 'Tunisia', 'EMRO', '12', '1406', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87004, '2020-07-24', 'TN', 'Tunisia', 'EMRO', '19', '1425', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87005, '2020-07-25', 'TN', 'Tunisia', 'EMRO', '18', '1443', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87006, '2020-07-26', 'TN', 'Tunisia', 'EMRO', '9', '1452', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87007, '2020-07-27', 'TN', 'Tunisia', 'EMRO', '3', '1455', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87008, '2020-07-28', 'TN', 'Tunisia', 'EMRO', '13', '1468', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87009, '2020-07-29', 'TN', 'Tunisia', 'EMRO', '20', '1488', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87010, '2020-07-30', 'TN', 'Tunisia', 'EMRO', '26', '1514', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87011, '2020-07-31', 'TN', 'Tunisia', 'EMRO', '21', '1535', '0', '50');
INSERT INTO public.who_global_data_import VALUES (87012, '2020-08-01', 'TN', 'Tunisia', 'EMRO', '17', '1552', '1', '51');
INSERT INTO public.who_global_data_import VALUES (87013, '2020-08-02', 'TN', 'Tunisia', 'EMRO', '9', '1561', '0', '51');
INSERT INTO public.who_global_data_import VALUES (87014, '2020-08-03', 'TN', 'Tunisia', 'EMRO', '4', '1565', '0', '51');
INSERT INTO public.who_global_data_import VALUES (87015, '2020-08-04', 'TN', 'Tunisia', 'EMRO', '19', '1584', '0', '51');
INSERT INTO public.who_global_data_import VALUES (87016, '2020-08-05', 'TN', 'Tunisia', 'EMRO', '17', '1601', '0', '51');
INSERT INTO public.who_global_data_import VALUES (87017, '2020-08-06', 'TN', 'Tunisia', 'EMRO', '41', '1642', '0', '51');
INSERT INTO public.who_global_data_import VALUES (87018, '2020-08-07', 'TN', 'Tunisia', 'EMRO', '14', '1656', '0', '51');
INSERT INTO public.who_global_data_import VALUES (87019, '2020-08-08', 'TN', 'Tunisia', 'EMRO', '22', '1678', '0', '51');
INSERT INTO public.who_global_data_import VALUES (87020, '2020-08-09', 'TN', 'Tunisia', 'EMRO', '19', '1697', '0', '51');
INSERT INTO public.who_global_data_import VALUES (87021, '2020-08-10', 'TN', 'Tunisia', 'EMRO', '20', '1717', '0', '51');
INSERT INTO public.who_global_data_import VALUES (87022, '2020-08-11', 'TN', 'Tunisia', 'EMRO', '21', '1738', '1', '52');
INSERT INTO public.who_global_data_import VALUES (87023, '2020-08-12', 'TN', 'Tunisia', 'EMRO', '42', '1780', '0', '52');
INSERT INTO public.who_global_data_import VALUES (87024, '2020-08-13', 'TN', 'Tunisia', 'EMRO', '67', '1847', '1', '53');
INSERT INTO public.who_global_data_import VALUES (87025, '2020-08-14', 'TN', 'Tunisia', 'EMRO', '56', '1903', '0', '53');
INSERT INTO public.who_global_data_import VALUES (87026, '2020-08-15', 'TN', 'Tunisia', 'EMRO', '120', '2023', '1', '54');
INSERT INTO public.who_global_data_import VALUES (87027, '2020-08-16', 'TN', 'Tunisia', 'EMRO', '84', '2107', '0', '54');
INSERT INTO public.who_global_data_import VALUES (87028, '2020-08-17', 'TN', 'Tunisia', 'EMRO', '78', '2185', '2', '56');
INSERT INTO public.who_global_data_import VALUES (87029, '2020-08-18', 'TN', 'Tunisia', 'EMRO', '129', '2314', '1', '57');
INSERT INTO public.who_global_data_import VALUES (87030, '2020-08-19', 'TN', 'Tunisia', 'EMRO', '113', '2427', '3', '60');
INSERT INTO public.who_global_data_import VALUES (87031, '2020-08-20', 'TN', 'Tunisia', 'EMRO', '116', '2543', '3', '63');
INSERT INTO public.who_global_data_import VALUES (87032, '2020-08-21', 'TN', 'Tunisia', 'EMRO', '64', '2607', '0', '63');
INSERT INTO public.who_global_data_import VALUES (87033, '2020-08-22', 'TN', 'Tunisia', 'EMRO', '131', '2738', '5', '68');
INSERT INTO public.who_global_data_import VALUES (87034, '2020-08-23', 'TN', 'Tunisia', 'EMRO', '80', '2818', '3', '71');
INSERT INTO public.who_global_data_import VALUES (87035, '2020-08-24', 'TN', 'Tunisia', 'EMRO', '75', '2893', '0', '71');
INSERT INTO public.who_global_data_import VALUES (87036, '2020-08-25', 'TN', 'Tunisia', 'EMRO', '176', '3069', '0', '71');
INSERT INTO public.who_global_data_import VALUES (87037, '2020-08-26', 'TN', 'Tunisia', 'EMRO', '137', '3206', '0', '71');
INSERT INTO public.who_global_data_import VALUES (87038, '2020-08-27', 'TN', 'Tunisia', 'EMRO', '117', '3323', '2', '73');
INSERT INTO public.who_global_data_import VALUES (87039, '2020-08-28', 'TN', 'Tunisia', 'EMRO', '138', '3461', '1', '74');
INSERT INTO public.who_global_data_import VALUES (87040, '2020-08-29', 'TN', 'Tunisia', 'EMRO', '111', '3572', '2', '76');
INSERT INTO public.who_global_data_import VALUES (87041, '2020-08-30', 'TN', 'Tunisia', 'EMRO', '113', '3685', '0', '76');
INSERT INTO public.who_global_data_import VALUES (87042, '2020-08-31', 'TN', 'Tunisia', 'EMRO', '118', '3803', '1', '77');
INSERT INTO public.who_global_data_import VALUES (87043, '2020-09-01', 'TN', 'Tunisia', 'EMRO', '160', '3963', '3', '80');
INSERT INTO public.who_global_data_import VALUES (87044, '2020-09-02', 'TN', 'Tunisia', 'EMRO', '233', '4196', '1', '81');
INSERT INTO public.who_global_data_import VALUES (87045, '2020-09-03', 'TN', 'Tunisia', 'EMRO', '198', '4394', '3', '84');
INSERT INTO public.who_global_data_import VALUES (87046, '2020-09-04', 'TN', 'Tunisia', 'EMRO', '148', '4542', '3', '87');
INSERT INTO public.who_global_data_import VALUES (87047, '2020-09-05', 'TN', 'Tunisia', 'EMRO', '234', '4776', '6', '93');
INSERT INTO public.who_global_data_import VALUES (87048, '2020-09-06', 'TN', 'Tunisia', 'EMRO', '265', '5041', '0', '93');
INSERT INTO public.who_global_data_import VALUES (87049, '2020-09-07', 'TN', 'Tunisia', 'EMRO', '83', '5124', '1', '94');
INSERT INTO public.who_global_data_import VALUES (87050, '2020-09-08', 'TN', 'Tunisia', 'EMRO', '293', '5417', '2', '96');
INSERT INTO public.who_global_data_import VALUES (87051, '2020-09-09', 'TN', 'Tunisia', 'EMRO', '465', '5882', '3', '99');
INSERT INTO public.who_global_data_import VALUES (87052, '2020-09-10', 'TN', 'Tunisia', 'EMRO', '377', '6259', '4', '103');
INSERT INTO public.who_global_data_import VALUES (87053, '2020-09-11', 'TN', 'Tunisia', 'EMRO', '376', '6635', '4', '107');
INSERT INTO public.who_global_data_import VALUES (87054, '2020-09-12', 'TN', 'Tunisia', 'EMRO', '0', '6635', '0', '107');
INSERT INTO public.who_global_data_import VALUES (87055, '2020-09-13', 'TN', 'Tunisia', 'EMRO', '747', '7382', '10', '117');
INSERT INTO public.who_global_data_import VALUES (87056, '2020-09-14', 'TN', 'Tunisia', 'EMRO', '241', '7623', '6', '123');
INSERT INTO public.who_global_data_import VALUES (87057, '2020-09-15', 'TN', 'Tunisia', 'EMRO', '477', '8100', '6', '129');
INSERT INTO public.who_global_data_import VALUES (87058, '2020-09-16', 'TN', 'Tunisia', 'EMRO', '470', '8570', '4', '133');
INSERT INTO public.who_global_data_import VALUES (87059, '2020-09-17', 'TN', 'Tunisia', 'EMRO', '540', '9110', '5', '138');
INSERT INTO public.who_global_data_import VALUES (87060, '2020-09-18', 'TN', 'Tunisia', 'EMRO', '626', '9736', '17', '155');
INSERT INTO public.who_global_data_import VALUES (87061, '2020-09-19', 'TN', 'Tunisia', 'EMRO', '0', '9736', '0', '155');
INSERT INTO public.who_global_data_import VALUES (87062, '2020-09-20', 'TN', 'Tunisia', 'EMRO', '996', '10732', '4', '159');
INSERT INTO public.who_global_data_import VALUES (87063, '2020-09-21', 'TN', 'Tunisia', 'EMRO', '528', '11260', '5', '164');
INSERT INTO public.who_global_data_import VALUES (87064, '2020-09-22', 'TN', 'Tunisia', 'EMRO', '0', '11260', '0', '164');
INSERT INTO public.who_global_data_import VALUES (87065, '2020-09-23', 'TN', 'Tunisia', 'EMRO', '1219', '12479', '10', '174');
INSERT INTO public.who_global_data_import VALUES (87066, '2020-09-24', 'TN', 'Tunisia', 'EMRO', '826', '13305', '6', '180');
INSERT INTO public.who_global_data_import VALUES (87067, '2020-09-25', 'TN', 'Tunisia', 'EMRO', '1087', '14392', '11', '191');
INSERT INTO public.who_global_data_import VALUES (87068, '2020-09-26', 'TN', 'Tunisia', 'EMRO', '786', '15178', '16', '207');
INSERT INTO public.who_global_data_import VALUES (87069, '2020-09-27', 'TN', 'Tunisia', 'EMRO', '936', '16114', '7', '214');
INSERT INTO public.who_global_data_import VALUES (87070, '2020-09-28', 'TN', 'Tunisia', 'EMRO', '0', '16114', '0', '214');
INSERT INTO public.who_global_data_import VALUES (87071, '2020-09-29', 'TN', 'Tunisia', 'EMRO', '1291', '17405', '32', '246');
INSERT INTO public.who_global_data_import VALUES (87072, '2020-09-30', 'TN', 'Tunisia', 'EMRO', '1008', '18413', '19', '265');
INSERT INTO public.who_global_data_import VALUES (87073, '2020-10-01', 'TN', 'Tunisia', 'EMRO', '1308', '19721', '6', '271');
INSERT INTO public.who_global_data_import VALUES (87074, '2020-10-02', 'TN', 'Tunisia', 'EMRO', '1223', '20944', '5', '276');
INSERT INTO public.who_global_data_import VALUES (87075, '2020-10-03', 'TN', 'Tunisia', 'EMRO', '0', '20944', '0', '276');
INSERT INTO public.who_global_data_import VALUES (87076, '2020-10-04', 'TN', 'Tunisia', 'EMRO', '2509', '23453', '45', '321');
INSERT INTO public.who_global_data_import VALUES (87077, '2020-10-05', 'TN', 'Tunisia', 'EMRO', '0', '23453', '0', '321');
INSERT INTO public.who_global_data_import VALUES (87078, '2020-10-06', 'TN', 'Tunisia', 'EMRO', '2312', '25765', '43', '364');
INSERT INTO public.who_global_data_import VALUES (87079, '2020-10-07', 'TN', 'Tunisia', 'EMRO', '0', '25765', '0', '364');
INSERT INTO public.who_global_data_import VALUES (87080, '2020-10-08', 'TN', 'Tunisia', 'EMRO', '2357', '28122', '45', '409');
INSERT INTO public.who_global_data_import VALUES (87081, '2020-10-09', 'TN', 'Tunisia', 'EMRO', '0', '28122', '0', '409');
INSERT INTO public.who_global_data_import VALUES (87082, '2020-10-10', 'TN', 'Tunisia', 'EMRO', '3137', '31259', '47', '456');
INSERT INTO public.who_global_data_import VALUES (87083, '2020-10-11', 'TN', 'Tunisia', 'EMRO', '1297', '32556', '22', '478');
INSERT INTO public.who_global_data_import VALUES (87084, '2020-10-12', 'TN', 'Tunisia', 'EMRO', '0', '32556', '0', '478');
INSERT INTO public.who_global_data_import VALUES (87085, '2020-10-13', 'TN', 'Tunisia', 'EMRO', '2234', '34790', '34', '512');
INSERT INTO public.who_global_data_import VALUES (87086, '2020-10-14', 'TN', 'Tunisia', 'EMRO', '0', '34790', '0', '512');
INSERT INTO public.who_global_data_import VALUES (87087, '2020-10-15', 'TN', 'Tunisia', 'EMRO', '0', '34790', '0', '512');
INSERT INTO public.who_global_data_import VALUES (87088, '2020-10-16', 'TN', 'Tunisia', 'EMRO', '0', '34790', '0', '512');
INSERT INTO public.who_global_data_import VALUES (87089, '2020-10-17', 'TN', 'Tunisia', 'EMRO', '5752', '40542', '114', '626');
INSERT INTO public.who_global_data_import VALUES (87090, '2020-10-18', 'TN', 'Tunisia', 'EMRO', '0', '40542', '0', '626');
INSERT INTO public.who_global_data_import VALUES (87091, '2020-10-19', 'TN', 'Tunisia', 'EMRO', '2185', '42727', '61', '687');
INSERT INTO public.who_global_data_import VALUES (87092, '2020-10-20', 'TN', 'Tunisia', 'EMRO', '1723', '44450', '24', '711');
INSERT INTO public.who_global_data_import VALUES (87093, '2020-10-21', 'TN', 'Tunisia', 'EMRO', '1442', '45892', '29', '740');
INSERT INTO public.who_global_data_import VALUES (87094, '2020-10-22', 'TN', 'Tunisia', 'EMRO', '1322', '47214', '44', '784');
INSERT INTO public.who_global_data_import VALUES (87095, '2020-10-23', 'TN', 'Tunisia', 'EMRO', '1585', '48799', '35', '819');
INSERT INTO public.who_global_data_import VALUES (87096, '2020-10-24', 'TN', 'Tunisia', 'EMRO', '1606', '50405', '58', '877');
INSERT INTO public.who_global_data_import VALUES (87097, '2020-10-25', 'TN', 'Tunisia', 'EMRO', '1994', '52399', '106', '983');
INSERT INTO public.who_global_data_import VALUES (87098, '2020-10-26', 'TN', 'Tunisia', 'EMRO', '0', '52399', '0', '983');
INSERT INTO public.who_global_data_import VALUES (87099, '2020-10-27', 'TN', 'Tunisia', 'EMRO', '1879', '54278', '170', '1153');
INSERT INTO public.who_global_data_import VALUES (87100, '2020-10-28', 'TN', 'Tunisia', 'EMRO', '0', '54278', '0', '1153');
INSERT INTO public.who_global_data_import VALUES (87101, '2020-10-29', 'TN', 'Tunisia', 'EMRO', '0', '54278', '0', '1153');
INSERT INTO public.who_global_data_import VALUES (87102, '2020-10-30', 'TN', 'Tunisia', 'EMRO', '3751', '58029', '100', '1253');
INSERT INTO public.who_global_data_import VALUES (87103, '2020-10-31', 'TN', 'Tunisia', 'EMRO', '1784', '59813', '64', '1317');
INSERT INTO public.who_global_data_import VALUES (87104, '2020-11-01', 'TN', 'Tunisia', 'EMRO', '1302', '61115', '31', '1348');
INSERT INTO public.who_global_data_import VALUES (87105, '2020-11-02', 'TN', 'Tunisia', 'EMRO', '791', '61906', '33', '1381');
INSERT INTO public.who_global_data_import VALUES (87106, '2020-11-03', 'TN', 'Tunisia', 'EMRO', '1220', '63126', '102', '1483');
INSERT INTO public.who_global_data_import VALUES (87107, '2020-11-04', 'TN', 'Tunisia', 'EMRO', '1237', '64363', '29', '1512');
INSERT INTO public.who_global_data_import VALUES (87108, '2020-11-05', 'TN', 'Tunisia', 'EMRO', '1971', '66334', '65', '1577');
INSERT INTO public.who_global_data_import VALUES (87109, '2020-11-06', 'TN', 'Tunisia', 'EMRO', '0', '66334', '144', '1721');
INSERT INTO public.who_global_data_import VALUES (87110, '2020-11-07', 'TN', 'Tunisia', 'EMRO', '1625', '67959', '66', '1787');
INSERT INTO public.who_global_data_import VALUES (87111, '2020-11-08', 'TN', 'Tunisia', 'EMRO', '1584', '69543', '61', '1848');
INSERT INTO public.who_global_data_import VALUES (87112, '2020-11-09', 'TN', 'Tunisia', 'EMRO', '1588', '71131', '25', '1873');
INSERT INTO public.who_global_data_import VALUES (87113, '2020-11-10', 'TN', 'Tunisia', 'EMRO', '438', '71569', '47', '1920');
INSERT INTO public.who_global_data_import VALUES (87114, '2020-11-11', 'TN', 'Tunisia', 'EMRO', '1424', '72993', '86', '2006');
INSERT INTO public.who_global_data_import VALUES (87115, '2020-11-12', 'TN', 'Tunisia', 'EMRO', '1529', '74522', '94', '2100');
INSERT INTO public.who_global_data_import VALUES (87116, '2020-11-13', 'TN', 'Tunisia', 'EMRO', '1584', '76106', '51', '2151');
INSERT INTO public.who_global_data_import VALUES (87117, '2020-11-14', 'TN', 'Tunisia', 'EMRO', '1562', '77668', '58', '2209');
INSERT INTO public.who_global_data_import VALUES (87118, '2020-11-15', 'TN', 'Tunisia', 'EMRO', '1671', '79339', '70', '2279');
INSERT INTO public.who_global_data_import VALUES (87119, '2020-11-16', 'TN', 'Tunisia', 'EMRO', '1065', '80404', '66', '2345');
INSERT INTO public.who_global_data_import VALUES (87120, '2020-11-17', 'TN', 'Tunisia', 'EMRO', '599', '81003', '44', '2389');
INSERT INTO public.who_global_data_import VALUES (87121, '2020-11-18', 'TN', 'Tunisia', 'EMRO', '720', '81723', '56', '2445');
INSERT INTO public.who_global_data_import VALUES (87122, '2020-11-19', 'TN', 'Tunisia', 'EMRO', '2049', '83772', '96', '2541');
INSERT INTO public.who_global_data_import VALUES (87123, '2020-11-20', 'TN', 'Tunisia', 'EMRO', '1270', '85042', '73', '2614');
INSERT INTO public.who_global_data_import VALUES (87124, '2020-11-21', 'TN', 'Tunisia', 'EMRO', '1223', '86265', '70', '2684');
INSERT INTO public.who_global_data_import VALUES (87125, '2020-11-22', 'TN', 'Tunisia', 'EMRO', '1206', '87471', '68', '2752');
INSERT INTO public.who_global_data_import VALUES (87126, '2020-11-23', 'TN', 'Tunisia', 'EMRO', '1240', '88711', '69', '2821');
INSERT INTO public.who_global_data_import VALUES (87127, '2020-11-24', 'TN', 'Tunisia', 'EMRO', '485', '89196', '41', '2862');
INSERT INTO public.who_global_data_import VALUES (87128, '2020-11-25', 'TN', 'Tunisia', 'EMRO', '1017', '90213', '73', '2935');
INSERT INTO public.who_global_data_import VALUES (87129, '2020-11-26', 'TN', 'Tunisia', 'EMRO', '1094', '91307', '48', '2983');
INSERT INTO public.who_global_data_import VALUES (87130, '2020-11-27', 'TN', 'Tunisia', 'EMRO', '1168', '92475', '51', '3034');
INSERT INTO public.who_global_data_import VALUES (87131, '2020-11-28', 'TN', 'Tunisia', 'EMRO', '1295', '93770', '72', '3106');
INSERT INTO public.who_global_data_import VALUES (87132, '2020-11-29', 'TN', 'Tunisia', 'EMRO', '1210', '94980', '47', '3153');
INSERT INTO public.who_global_data_import VALUES (87133, '2020-11-30', 'TN', 'Tunisia', 'EMRO', '1271', '96251', '66', '3219');
INSERT INTO public.who_global_data_import VALUES (87134, '2020-12-01', 'TN', 'Tunisia', 'EMRO', '518', '96769', '41', '3260');
INSERT INTO public.who_global_data_import VALUES (87135, '2020-12-02', 'TN', 'Tunisia', 'EMRO', '1303', '98072', '51', '3311');
INSERT INTO public.who_global_data_import VALUES (87136, '2020-12-03', 'TN', 'Tunisia', 'EMRO', '1208', '99280', '48', '3359');
INSERT INTO public.who_global_data_import VALUES (87137, '2020-12-04', 'TN', 'Tunisia', 'EMRO', '1403', '100683', '56', '3415');
INSERT INTO public.who_global_data_import VALUES (87138, '2020-12-05', 'TN', 'Tunisia', 'EMRO', '1217', '101900', '66', '3481');
INSERT INTO public.who_global_data_import VALUES (87139, '2020-12-06', 'TN', 'Tunisia', 'EMRO', '1091', '102991', '45', '3526');
INSERT INTO public.who_global_data_import VALUES (87140, '2020-12-07', 'TN', 'Tunisia', 'EMRO', '1011', '104002', '35', '3561');
INSERT INTO public.who_global_data_import VALUES (87141, '2020-12-08', 'TN', 'Tunisia', 'EMRO', '327', '104329', '35', '3596');
INSERT INTO public.who_global_data_import VALUES (87142, '2020-12-09', 'TN', 'Tunisia', 'EMRO', '1116', '105445', '72', '3668');
INSERT INTO public.who_global_data_import VALUES (87143, '2020-12-10', 'TN', 'Tunisia', 'EMRO', '1411', '106856', '49', '3717');
INSERT INTO public.who_global_data_import VALUES (87144, '2020-12-11', 'TN', 'Tunisia', 'EMRO', '958', '107814', '41', '3758');
INSERT INTO public.who_global_data_import VALUES (87145, '2020-12-12', 'TN', 'Tunisia', 'EMRO', '1290', '109104', '43', '3801');
INSERT INTO public.who_global_data_import VALUES (87146, '2020-12-13', 'TN', 'Tunisia', 'EMRO', '1289', '110393', '35', '3836');
INSERT INTO public.who_global_data_import VALUES (87147, '2020-12-14', 'TN', 'Tunisia', 'EMRO', '968', '111361', '58', '3894');
INSERT INTO public.who_global_data_import VALUES (87148, '2020-12-15', 'TN', 'Tunisia', 'EMRO', '397', '111758', '21', '3915');
INSERT INTO public.who_global_data_import VALUES (87149, '2020-12-16', 'TN', 'Tunisia', 'EMRO', '1483', '113241', '41', '3956');
INSERT INTO public.who_global_data_import VALUES (87150, '2020-12-17', 'TN', 'Tunisia', 'EMRO', '1306', '114547', '41', '3997');
INSERT INTO public.who_global_data_import VALUES (87151, '2020-12-18', 'TN', 'Tunisia', 'EMRO', '1419', '115966', '35', '4032');
INSERT INTO public.who_global_data_import VALUES (87152, '2020-12-19', 'TN', 'Tunisia', 'EMRO', '1616', '117582', '58', '4090');
INSERT INTO public.who_global_data_import VALUES (87153, '2020-12-20', 'TN', 'Tunisia', 'EMRO', '1569', '119151', '36', '4126');
INSERT INTO public.who_global_data_import VALUES (87154, '2020-12-21', 'TN', 'Tunisia', 'EMRO', '1536', '120687', '32', '4158');
INSERT INTO public.who_global_data_import VALUES (87155, '2020-12-22', 'TN', 'Tunisia', 'EMRO', '1031', '121718', '41', '4199');
INSERT INTO public.who_global_data_import VALUES (87156, '2020-12-23', 'TN', 'Tunisia', 'EMRO', '1605', '123323', '38', '4237');
INSERT INTO public.who_global_data_import VALUES (87157, '2020-12-24', 'TN', 'Tunisia', 'EMRO', '1677', '125000', '38', '4275');
INSERT INTO public.who_global_data_import VALUES (87158, '2020-12-25', 'TN', 'Tunisia', 'EMRO', '1752', '126752', '49', '4324');
INSERT INTO public.who_global_data_import VALUES (87159, '2020-12-26', 'TN', 'Tunisia', 'EMRO', '1826', '128578', '61', '4385');
INSERT INTO public.who_global_data_import VALUES (87160, '2020-12-27', 'TN', 'Tunisia', 'EMRO', '1652', '130230', '41', '4426');
INSERT INTO public.who_global_data_import VALUES (87161, '2020-12-28', 'TN', 'Tunisia', 'EMRO', '1362', '131592', '40', '4466');
INSERT INTO public.who_global_data_import VALUES (87162, '2020-12-29', 'TN', 'Tunisia', 'EMRO', '1612', '133204', '52', '4518');
INSERT INTO public.who_global_data_import VALUES (87163, '2020-12-30', 'TN', 'Tunisia', 'EMRO', '1598', '134802', '52', '4570');
INSERT INTO public.who_global_data_import VALUES (87164, '2020-12-31', 'TN', 'Tunisia', 'EMRO', '2414', '137216', '50', '4620');
INSERT INTO public.who_global_data_import VALUES (87165, '2021-01-01', 'TN', 'Tunisia', 'EMRO', '1924', '139140', '56', '4676');
INSERT INTO public.who_global_data_import VALUES (87166, '2021-01-02', 'TN', 'Tunisia', 'EMRO', '1417', '140557', '54', '4730');
INSERT INTO public.who_global_data_import VALUES (87167, '2021-01-03', 'TN', 'Tunisia', 'EMRO', '1422', '141979', '35', '4765');
INSERT INTO public.who_global_data_import VALUES (87168, '2021-01-04', 'TN', 'Tunisia', 'EMRO', '1565', '143544', '35', '4800');
INSERT INTO public.who_global_data_import VALUES (87169, '2021-01-05', 'TN', 'Tunisia', 'EMRO', '1252', '144796', '62', '4862');
INSERT INTO public.who_global_data_import VALUES (87170, '2021-01-06', 'TN', 'Tunisia', 'EMRO', '2265', '147061', '72', '4934');
INSERT INTO public.who_global_data_import VALUES (87171, '2021-01-07', 'TN', 'Tunisia', 'EMRO', '2820', '149881', '70', '5004');
INSERT INTO public.who_global_data_import VALUES (87172, '2021-01-08', 'TN', 'Tunisia', 'EMRO', '2373', '152254', '48', '5052');
INSERT INTO public.who_global_data_import VALUES (87173, '2021-01-09', 'TN', 'Tunisia', 'EMRO', '2649', '154903', '56', '5108');
INSERT INTO public.who_global_data_import VALUES (87174, '2021-01-10', 'TN', 'Tunisia', 'EMRO', '2611', '157514', '45', '5153');
INSERT INTO public.who_global_data_import VALUES (87175, '2021-01-11', 'TN', 'Tunisia', 'EMRO', '1762', '159276', '62', '5215');
INSERT INTO public.who_global_data_import VALUES (87176, '2021-01-12', 'TN', 'Tunisia', 'EMRO', '3074', '162350', '69', '5284');
INSERT INTO public.who_global_data_import VALUES (87177, '2021-01-13', 'TN', 'Tunisia', 'EMRO', '2586', '164936', '59', '5343');
INSERT INTO public.who_global_data_import VALUES (87178, '2021-01-14', 'TN', 'Tunisia', 'EMRO', '3632', '168568', '72', '5415');
INSERT INTO public.who_global_data_import VALUES (87179, '2021-01-15', 'TN', 'Tunisia', 'EMRO', '2327', '170895', '63', '5478');
INSERT INTO public.who_global_data_import VALUES (87180, '2021-01-16', 'TN', 'Tunisia', 'EMRO', '4170', '175065', '50', '5528');
INSERT INTO public.who_global_data_import VALUES (87181, '2021-01-17', 'TN', 'Tunisia', 'EMRO', '2166', '177231', '88', '5616');
INSERT INTO public.who_global_data_import VALUES (87182, '2021-01-18', 'TN', 'Tunisia', 'EMRO', '2859', '180090', '76', '5692');
INSERT INTO public.who_global_data_import VALUES (87183, '2021-01-19', 'TN', 'Tunisia', 'EMRO', '1795', '181885', '58', '5750');
INSERT INTO public.who_global_data_import VALUES (87184, '2021-01-20', 'TN', 'Tunisia', 'EMRO', '2598', '184483', '94', '5844');
INSERT INTO public.who_global_data_import VALUES (87185, '2021-01-21', 'TN', 'Tunisia', 'EMRO', '3890', '188373', '77', '5921');
INSERT INTO public.who_global_data_import VALUES (87186, '2021-01-22', 'TN', 'Tunisia', 'EMRO', '2511', '190884', '68', '5989');
INSERT INTO public.who_global_data_import VALUES (87187, '2021-01-23', 'TN', 'Tunisia', 'EMRO', '2389', '193273', '103', '6092');
INSERT INTO public.who_global_data_import VALUES (87188, '2021-01-24', 'TN', 'Tunisia', 'EMRO', '2041', '195314', '62', '6154');
INSERT INTO public.who_global_data_import VALUES (87189, '2021-01-25', 'TN', 'Tunisia', 'EMRO', '2059', '197373', '80', '6234');
INSERT INTO public.who_global_data_import VALUES (87190, '2021-01-26', 'TN', 'Tunisia', 'EMRO', '1263', '198636', '53', '6287');
INSERT INTO public.who_global_data_import VALUES (87191, '2021-01-27', 'TN', 'Tunisia', 'EMRO', '2026', '200662', '83', '6370');
INSERT INTO public.who_global_data_import VALUES (87192, '2021-01-28', 'TN', 'Tunisia', 'EMRO', '1661', '202323', '76', '6446');
INSERT INTO public.who_global_data_import VALUES (87193, '2021-01-29', 'TN', 'Tunisia', 'EMRO', '2028', '204351', '62', '6508');
INSERT INTO public.who_global_data_import VALUES (87194, '2021-01-30', 'TN', 'Tunisia', 'EMRO', '1679', '206030', '91', '6599');
INSERT INTO public.who_global_data_import VALUES (87195, '2021-01-31', 'TN', 'Tunisia', 'EMRO', '1438', '207468', '81', '6680');
INSERT INTO public.who_global_data_import VALUES (87196, '2021-02-01', 'TN', 'Tunisia', 'EMRO', '1417', '208885', '74', '6754');
INSERT INTO public.who_global_data_import VALUES (87197, '2021-02-02', 'TN', 'Tunisia', 'EMRO', '1160', '210045', '48', '6802');
INSERT INTO public.who_global_data_import VALUES (87198, '2021-02-03', 'TN', 'Tunisia', 'EMRO', '1367', '211412', '91', '6893');
INSERT INTO public.who_global_data_import VALUES (87199, '2021-02-04', 'TN', 'Tunisia', 'EMRO', '1267', '212679', '87', '6980');
INSERT INTO public.who_global_data_import VALUES (87200, '2021-02-05', 'TN', 'Tunisia', 'EMRO', '1270', '213949', '68', '7048');
INSERT INTO public.who_global_data_import VALUES (87201, '2020-01-03', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87202, '2020-01-04', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87203, '2020-01-05', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87204, '2020-01-06', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87205, '2020-01-07', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87206, '2020-01-08', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87207, '2020-01-09', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87208, '2020-01-10', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87209, '2020-01-11', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87210, '2020-01-12', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87211, '2020-01-13', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87212, '2020-01-14', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87213, '2020-01-15', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87214, '2020-01-16', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87215, '2020-01-17', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87216, '2020-01-18', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87217, '2020-01-19', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87218, '2020-01-20', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87219, '2020-01-21', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87220, '2020-01-22', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87221, '2020-01-23', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87222, '2020-01-24', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87223, '2020-01-25', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87224, '2020-01-26', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87225, '2020-01-27', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87226, '2020-01-28', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87227, '2020-01-29', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87228, '2020-01-30', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87229, '2020-01-31', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87230, '2020-02-01', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87231, '2020-02-02', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87232, '2020-02-03', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87233, '2020-02-04', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87234, '2020-02-05', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87235, '2020-02-06', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87236, '2020-02-07', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87237, '2020-02-08', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87238, '2020-02-09', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87239, '2020-02-10', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87240, '2020-02-11', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87241, '2020-02-12', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87242, '2020-02-13', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87243, '2020-02-14', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87245, '2020-02-16', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87246, '2020-02-17', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87247, '2020-02-18', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87248, '2020-02-19', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87249, '2020-02-20', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87250, '2020-02-21', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87251, '2020-02-22', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87252, '2020-02-23', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87253, '2020-02-24', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87254, '2020-02-25', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87255, '2020-02-26', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87256, '2020-02-27', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87257, '2020-02-28', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87258, '2020-02-29', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87259, '2020-03-01', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87260, '2020-03-02', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87261, '2020-03-03', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87262, '2020-03-04', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87263, '2020-03-05', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87264, '2020-03-06', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87265, '2020-03-07', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87266, '2020-03-08', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87267, '2020-03-09', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87268, '2020-03-10', 'TR', 'Turkey', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87269, '2020-03-11', 'TR', 'Turkey', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87270, '2020-03-12', 'TR', 'Turkey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87271, '2020-03-13', 'TR', 'Turkey', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87272, '2020-03-14', 'TR', 'Turkey', 'EURO', '4', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87273, '2020-03-15', 'TR', 'Turkey', 'EURO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87274, '2020-03-16', 'TR', 'Turkey', 'EURO', '12', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87275, '2020-03-17', 'TR', 'Turkey', 'EURO', '29', '47', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87276, '2020-03-18', 'TR', 'Turkey', 'EURO', '51', '98', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87277, '2020-03-19', 'TR', 'Turkey', 'EURO', '93', '191', '2', '2');
INSERT INTO public.who_global_data_import VALUES (87278, '2020-03-20', 'TR', 'Turkey', 'EURO', '0', '191', '0', '2');
INSERT INTO public.who_global_data_import VALUES (87279, '2020-03-21', 'TR', 'Turkey', 'EURO', '479', '670', '7', '9');
INSERT INTO public.who_global_data_import VALUES (87280, '2020-03-22', 'TR', 'Turkey', 'EURO', '277', '947', '12', '21');
INSERT INTO public.who_global_data_import VALUES (87281, '2020-03-23', 'TR', 'Turkey', 'EURO', '289', '1236', '9', '30');
INSERT INTO public.who_global_data_import VALUES (87282, '2020-03-24', 'TR', 'Turkey', 'EURO', '293', '1529', '7', '37');
INSERT INTO public.who_global_data_import VALUES (87283, '2020-03-25', 'TR', 'Turkey', 'EURO', '343', '1872', '7', '44');
INSERT INTO public.who_global_data_import VALUES (87284, '2020-03-26', 'TR', 'Turkey', 'EURO', '561', '2433', '15', '59');
INSERT INTO public.who_global_data_import VALUES (87285, '2020-03-27', 'TR', 'Turkey', 'EURO', '1196', '3629', '16', '75');
INSERT INTO public.who_global_data_import VALUES (87286, '2020-03-28', 'TR', 'Turkey', 'EURO', '2069', '5698', '17', '92');
INSERT INTO public.who_global_data_import VALUES (87287, '2020-03-29', 'TR', 'Turkey', 'EURO', '1704', '7402', '16', '108');
INSERT INTO public.who_global_data_import VALUES (87288, '2020-03-30', 'TR', 'Turkey', 'EURO', '1869', '9271', '23', '131');
INSERT INTO public.who_global_data_import VALUES (87289, '2020-03-31', 'TR', 'Turkey', 'EURO', '1556', '10827', '37', '168');
INSERT INTO public.who_global_data_import VALUES (87290, '2020-04-01', 'TR', 'Turkey', 'EURO', '2704', '13531', '46', '214');
INSERT INTO public.who_global_data_import VALUES (87291, '2020-04-02', 'TR', 'Turkey', 'EURO', '2148', '15679', '63', '277');
INSERT INTO public.who_global_data_import VALUES (87292, '2020-04-03', 'TR', 'Turkey', 'EURO', '2456', '18135', '79', '356');
INSERT INTO public.who_global_data_import VALUES (87293, '2020-04-04', 'TR', 'Turkey', 'EURO', '2786', '20921', '69', '425');
INSERT INTO public.who_global_data_import VALUES (87294, '2020-04-05', 'TR', 'Turkey', 'EURO', '3013', '23934', '76', '501');
INSERT INTO public.who_global_data_import VALUES (87295, '2020-04-06', 'TR', 'Turkey', 'EURO', '3135', '27069', '73', '574');
INSERT INTO public.who_global_data_import VALUES (87296, '2020-04-07', 'TR', 'Turkey', 'EURO', '3148', '30217', '75', '649');
INSERT INTO public.who_global_data_import VALUES (87297, '2020-04-08', 'TR', 'Turkey', 'EURO', '3892', '34109', '76', '725');
INSERT INTO public.who_global_data_import VALUES (87298, '2020-04-09', 'TR', 'Turkey', 'EURO', '4117', '38226', '87', '812');
INSERT INTO public.who_global_data_import VALUES (87299, '2020-04-10', 'TR', 'Turkey', 'EURO', '4056', '42282', '96', '908');
INSERT INTO public.who_global_data_import VALUES (87300, '2020-04-11', 'TR', 'Turkey', 'EURO', '4747', '47029', '98', '1006');
INSERT INTO public.who_global_data_import VALUES (87301, '2020-04-12', 'TR', 'Turkey', 'EURO', '5138', '52167', '95', '1101');
INSERT INTO public.who_global_data_import VALUES (87302, '2020-04-13', 'TR', 'Turkey', 'EURO', '4789', '56956', '97', '1198');
INSERT INTO public.who_global_data_import VALUES (87303, '2020-04-14', 'TR', 'Turkey', 'EURO', '4093', '61049', '98', '1296');
INSERT INTO public.who_global_data_import VALUES (87304, '2020-04-15', 'TR', 'Turkey', 'EURO', '4062', '65111', '107', '1403');
INSERT INTO public.who_global_data_import VALUES (87305, '2020-04-16', 'TR', 'Turkey', 'EURO', '4281', '69392', '115', '1518');
INSERT INTO public.who_global_data_import VALUES (87306, '2020-04-17', 'TR', 'Turkey', 'EURO', '4801', '74193', '125', '1643');
INSERT INTO public.who_global_data_import VALUES (87307, '2020-04-18', 'TR', 'Turkey', 'EURO', '4353', '78546', '126', '1769');
INSERT INTO public.who_global_data_import VALUES (87308, '2020-04-19', 'TR', 'Turkey', 'EURO', '3783', '82329', '121', '1890');
INSERT INTO public.who_global_data_import VALUES (87309, '2020-04-20', 'TR', 'Turkey', 'EURO', '3977', '86306', '127', '2017');
INSERT INTO public.who_global_data_import VALUES (87310, '2020-04-21', 'TR', 'Turkey', 'EURO', '4674', '90980', '123', '2140');
INSERT INTO public.who_global_data_import VALUES (87311, '2020-04-22', 'TR', 'Turkey', 'EURO', '4611', '95591', '119', '2259');
INSERT INTO public.who_global_data_import VALUES (87312, '2020-04-23', 'TR', 'Turkey', 'EURO', '3083', '98674', '117', '2376');
INSERT INTO public.who_global_data_import VALUES (87313, '2020-04-24', 'TR', 'Turkey', 'EURO', '3116', '101790', '115', '2491');
INSERT INTO public.who_global_data_import VALUES (87314, '2020-04-25', 'TR', 'Turkey', 'EURO', '3122', '104912', '109', '2600');
INSERT INTO public.who_global_data_import VALUES (87315, '2020-04-26', 'TR', 'Turkey', 'EURO', '2861', '107773', '106', '2706');
INSERT INTO public.who_global_data_import VALUES (87316, '2020-04-27', 'TR', 'Turkey', 'EURO', '2357', '110130', '99', '2805');
INSERT INTO public.who_global_data_import VALUES (87317, '2020-04-28', 'TR', 'Turkey', 'EURO', '2131', '112261', '95', '2900');
INSERT INTO public.who_global_data_import VALUES (87318, '2020-04-29', 'TR', 'Turkey', 'EURO', '2392', '114653', '92', '2992');
INSERT INTO public.who_global_data_import VALUES (87319, '2020-04-30', 'TR', 'Turkey', 'EURO', '2936', '117589', '89', '3081');
INSERT INTO public.who_global_data_import VALUES (87320, '2020-05-01', 'TR', 'Turkey', 'EURO', '2615', '120204', '93', '3174');
INSERT INTO public.who_global_data_import VALUES (87321, '2020-05-02', 'TR', 'Turkey', 'EURO', '2188', '122392', '84', '3258');
INSERT INTO public.who_global_data_import VALUES (87322, '2020-05-03', 'TR', 'Turkey', 'EURO', '1983', '124375', '78', '3336');
INSERT INTO public.who_global_data_import VALUES (87323, '2020-05-04', 'TR', 'Turkey', 'EURO', '1670', '126045', '61', '3397');
INSERT INTO public.who_global_data_import VALUES (87324, '2020-05-05', 'TR', 'Turkey', 'EURO', '1614', '127659', '64', '3461');
INSERT INTO public.who_global_data_import VALUES (87325, '2020-05-06', 'TR', 'Turkey', 'EURO', '1832', '129491', '59', '3520');
INSERT INTO public.who_global_data_import VALUES (87326, '2020-05-07', 'TR', 'Turkey', 'EURO', '2253', '131744', '64', '3584');
INSERT INTO public.who_global_data_import VALUES (87327, '2020-05-08', 'TR', 'Turkey', 'EURO', '1977', '133721', '57', '3641');
INSERT INTO public.who_global_data_import VALUES (87328, '2020-05-09', 'TR', 'Turkey', 'EURO', '1848', '135569', '48', '3689');
INSERT INTO public.who_global_data_import VALUES (87329, '2020-05-10', 'TR', 'Turkey', 'EURO', '1546', '137115', '50', '3739');
INSERT INTO public.who_global_data_import VALUES (87330, '2020-05-11', 'TR', 'Turkey', 'EURO', '1542', '138657', '47', '3786');
INSERT INTO public.who_global_data_import VALUES (87331, '2020-05-12', 'TR', 'Turkey', 'EURO', '1114', '139771', '55', '3841');
INSERT INTO public.who_global_data_import VALUES (87332, '2020-05-13', 'TR', 'Turkey', 'EURO', '1704', '141475', '53', '3894');
INSERT INTO public.who_global_data_import VALUES (87333, '2020-05-14', 'TR', 'Turkey', 'EURO', '1639', '143114', '58', '3952');
INSERT INTO public.who_global_data_import VALUES (87334, '2020-05-15', 'TR', 'Turkey', 'EURO', '1635', '144749', '55', '4007');
INSERT INTO public.who_global_data_import VALUES (87335, '2020-05-16', 'TR', 'Turkey', 'EURO', '1708', '146457', '48', '4055');
INSERT INTO public.who_global_data_import VALUES (87336, '2020-05-17', 'TR', 'Turkey', 'EURO', '1610', '148067', '41', '4096');
INSERT INTO public.who_global_data_import VALUES (87337, '2020-05-18', 'TR', 'Turkey', 'EURO', '1368', '149435', '44', '4140');
INSERT INTO public.who_global_data_import VALUES (87338, '2020-05-19', 'TR', 'Turkey', 'EURO', '1158', '150593', '31', '4171');
INSERT INTO public.who_global_data_import VALUES (87339, '2020-05-20', 'TR', 'Turkey', 'EURO', '1022', '151615', '28', '4199');
INSERT INTO public.who_global_data_import VALUES (87340, '2020-05-21', 'TR', 'Turkey', 'EURO', '972', '152587', '23', '4222');
INSERT INTO public.who_global_data_import VALUES (87341, '2020-05-22', 'TR', 'Turkey', 'EURO', '961', '153548', '27', '4249');
INSERT INTO public.who_global_data_import VALUES (87342, '2020-05-23', 'TR', 'Turkey', 'EURO', '952', '154500', '27', '4276');
INSERT INTO public.who_global_data_import VALUES (87343, '2020-05-24', 'TR', 'Turkey', 'EURO', '1186', '155686', '32', '4308');
INSERT INTO public.who_global_data_import VALUES (87344, '2020-05-25', 'TR', 'Turkey', 'EURO', '1141', '156827', '32', '4340');
INSERT INTO public.who_global_data_import VALUES (87345, '2020-05-26', 'TR', 'Turkey', 'EURO', '987', '157814', '29', '4369');
INSERT INTO public.who_global_data_import VALUES (87346, '2020-05-27', 'TR', 'Turkey', 'EURO', '948', '158762', '28', '4397');
INSERT INTO public.who_global_data_import VALUES (87347, '2020-05-28', 'TR', 'Turkey', 'EURO', '1035', '159797', '34', '4431');
INSERT INTO public.who_global_data_import VALUES (87348, '2020-05-29', 'TR', 'Turkey', 'EURO', '1182', '160979', '30', '4461');
INSERT INTO public.who_global_data_import VALUES (87349, '2020-05-30', 'TR', 'Turkey', 'EURO', '1141', '162120', '28', '4489');
INSERT INTO public.who_global_data_import VALUES (87350, '2020-05-31', 'TR', 'Turkey', 'EURO', '983', '163103', '26', '4515');
INSERT INTO public.who_global_data_import VALUES (87351, '2020-06-01', 'TR', 'Turkey', 'EURO', '839', '163942', '25', '4540');
INSERT INTO public.who_global_data_import VALUES (87352, '2020-06-02', 'TR', 'Turkey', 'EURO', '827', '164769', '23', '4563');
INSERT INTO public.who_global_data_import VALUES (87353, '2020-06-03', 'TR', 'Turkey', 'EURO', '786', '165555', '22', '4585');
INSERT INTO public.who_global_data_import VALUES (87354, '2020-06-04', 'TR', 'Turkey', 'EURO', '867', '166422', '24', '4609');
INSERT INTO public.who_global_data_import VALUES (87355, '2020-06-05', 'TR', 'Turkey', 'EURO', '988', '167410', '21', '4630');
INSERT INTO public.who_global_data_import VALUES (87356, '2020-06-06', 'TR', 'Turkey', 'EURO', '930', '168340', '18', '4648');
INSERT INTO public.who_global_data_import VALUES (87357, '2020-06-07', 'TR', 'Turkey', 'EURO', '878', '169218', '21', '4669');
INSERT INTO public.who_global_data_import VALUES (87358, '2020-06-08', 'TR', 'Turkey', 'EURO', '914', '170132', '23', '4692');
INSERT INTO public.who_global_data_import VALUES (87359, '2020-06-09', 'TR', 'Turkey', 'EURO', '989', '171121', '19', '4711');
INSERT INTO public.who_global_data_import VALUES (87360, '2020-06-10', 'TR', 'Turkey', 'EURO', '993', '172114', '18', '4729');
INSERT INTO public.who_global_data_import VALUES (87361, '2020-06-11', 'TR', 'Turkey', 'EURO', '922', '173036', '17', '4746');
INSERT INTO public.who_global_data_import VALUES (87362, '2020-06-12', 'TR', 'Turkey', 'EURO', '987', '174023', '17', '4763');
INSERT INTO public.who_global_data_import VALUES (87363, '2020-06-13', 'TR', 'Turkey', 'EURO', '1195', '175218', '15', '4778');
INSERT INTO public.who_global_data_import VALUES (87364, '2020-06-14', 'TR', 'Turkey', 'EURO', '1459', '176677', '14', '4792');
INSERT INTO public.who_global_data_import VALUES (87365, '2020-06-15', 'TR', 'Turkey', 'EURO', '1562', '178239', '15', '4807');
INSERT INTO public.who_global_data_import VALUES (87366, '2020-06-16', 'TR', 'Turkey', 'EURO', '1592', '179831', '18', '4825');
INSERT INTO public.who_global_data_import VALUES (87367, '2020-06-17', 'TR', 'Turkey', 'EURO', '1467', '181298', '17', '4842');
INSERT INTO public.who_global_data_import VALUES (87368, '2020-06-18', 'TR', 'Turkey', 'EURO', '1429', '182727', '19', '4861');
INSERT INTO public.who_global_data_import VALUES (87369, '2020-06-19', 'TR', 'Turkey', 'EURO', '1304', '184031', '21', '4882');
INSERT INTO public.who_global_data_import VALUES (87370, '2020-06-20', 'TR', 'Turkey', 'EURO', '1214', '185245', '23', '4905');
INSERT INTO public.who_global_data_import VALUES (87371, '2020-06-21', 'TR', 'Turkey', 'EURO', '1248', '186493', '22', '4927');
INSERT INTO public.who_global_data_import VALUES (87372, '2020-06-22', 'TR', 'Turkey', 'EURO', '1192', '187685', '23', '4950');
INSERT INTO public.who_global_data_import VALUES (87373, '2020-06-23', 'TR', 'Turkey', 'EURO', '1212', '188897', '24', '4974');
INSERT INTO public.who_global_data_import VALUES (87374, '2020-06-24', 'TR', 'Turkey', 'EURO', '1268', '190165', '27', '5001');
INSERT INTO public.who_global_data_import VALUES (87375, '2020-06-25', 'TR', 'Turkey', 'EURO', '1492', '191657', '24', '5025');
INSERT INTO public.who_global_data_import VALUES (87376, '2020-06-26', 'TR', 'Turkey', 'EURO', '1458', '193115', '21', '5046');
INSERT INTO public.who_global_data_import VALUES (87377, '2020-06-27', 'TR', 'Turkey', 'EURO', '1396', '194511', '19', '5065');
INSERT INTO public.who_global_data_import VALUES (87378, '2020-06-28', 'TR', 'Turkey', 'EURO', '1372', '195883', '17', '5082');
INSERT INTO public.who_global_data_import VALUES (87379, '2020-06-29', 'TR', 'Turkey', 'EURO', '1356', '197239', '15', '5097');
INSERT INTO public.who_global_data_import VALUES (87380, '2020-06-30', 'TR', 'Turkey', 'EURO', '1374', '198613', '18', '5115');
INSERT INTO public.who_global_data_import VALUES (87381, '2020-07-01', 'TR', 'Turkey', 'EURO', '1293', '199906', '16', '5131');
INSERT INTO public.who_global_data_import VALUES (87382, '2020-07-02', 'TR', 'Turkey', 'EURO', '1192', '201098', '19', '5150');
INSERT INTO public.who_global_data_import VALUES (87383, '2020-07-03', 'TR', 'Turkey', 'EURO', '1186', '202284', '17', '5167');
INSERT INTO public.who_global_data_import VALUES (87384, '2020-07-04', 'TR', 'Turkey', 'EURO', '1172', '203456', '19', '5186');
INSERT INTO public.who_global_data_import VALUES (87385, '2020-07-05', 'TR', 'Turkey', 'EURO', '1154', '204610', '20', '5206');
INSERT INTO public.who_global_data_import VALUES (87386, '2020-07-06', 'TR', 'Turkey', 'EURO', '1148', '205758', '19', '5225');
INSERT INTO public.who_global_data_import VALUES (87387, '2020-07-07', 'TR', 'Turkey', 'EURO', '1086', '206844', '16', '5241');
INSERT INTO public.who_global_data_import VALUES (87388, '2020-07-08', 'TR', 'Turkey', 'EURO', '1053', '207897', '19', '5260');
INSERT INTO public.who_global_data_import VALUES (87389, '2020-07-09', 'TR', 'Turkey', 'EURO', '1041', '208938', '22', '5282');
INSERT INTO public.who_global_data_import VALUES (87390, '2020-07-10', 'TR', 'Turkey', 'EURO', '1024', '209962', '18', '5300');
INSERT INTO public.who_global_data_import VALUES (87391, '2020-07-11', 'TR', 'Turkey', 'EURO', '1003', '210965', '23', '5323');
INSERT INTO public.who_global_data_import VALUES (87392, '2020-07-12', 'TR', 'Turkey', 'EURO', '1016', '211981', '21', '5344');
INSERT INTO public.who_global_data_import VALUES (87393, '2020-07-13', 'TR', 'Turkey', 'EURO', '1012', '212993', '19', '5363');
INSERT INTO public.who_global_data_import VALUES (87394, '2020-07-14', 'TR', 'Turkey', 'EURO', '1008', '214001', '19', '5382');
INSERT INTO public.who_global_data_import VALUES (87395, '2020-07-15', 'TR', 'Turkey', 'EURO', '992', '214993', '20', '5402');
INSERT INTO public.who_global_data_import VALUES (87396, '2020-07-16', 'TR', 'Turkey', 'EURO', '947', '215940', '17', '5419');
INSERT INTO public.who_global_data_import VALUES (87397, '2020-07-17', 'TR', 'Turkey', 'EURO', '933', '216873', '21', '5440');
INSERT INTO public.who_global_data_import VALUES (87398, '2020-07-18', 'TR', 'Turkey', 'EURO', '926', '217799', '18', '5458');
INSERT INTO public.who_global_data_import VALUES (87399, '2020-07-19', 'TR', 'Turkey', 'EURO', '918', '218717', '17', '5475');
INSERT INTO public.who_global_data_import VALUES (87400, '2020-07-20', 'TR', 'Turkey', 'EURO', '924', '219641', '16', '5491');
INSERT INTO public.who_global_data_import VALUES (87401, '2020-07-21', 'TR', 'Turkey', 'EURO', '931', '220572', '17', '5508');
INSERT INTO public.who_global_data_import VALUES (87402, '2020-07-22', 'TR', 'Turkey', 'EURO', '928', '221500', '18', '5526');
INSERT INTO public.who_global_data_import VALUES (87403, '2020-07-23', 'TR', 'Turkey', 'EURO', '902', '222402', '19', '5545');
INSERT INTO public.who_global_data_import VALUES (87404, '2020-07-24', 'TR', 'Turkey', 'EURO', '913', '223315', '18', '5563');
INSERT INTO public.who_global_data_import VALUES (87405, '2020-07-25', 'TR', 'Turkey', 'EURO', '937', '224252', '17', '5580');
INSERT INTO public.who_global_data_import VALUES (87406, '2020-07-26', 'TR', 'Turkey', 'EURO', '921', '225173', '16', '5596');
INSERT INTO public.who_global_data_import VALUES (87407, '2020-07-27', 'TR', 'Turkey', 'EURO', '927', '226100', '17', '5613');
INSERT INTO public.who_global_data_import VALUES (87408, '2020-07-28', 'TR', 'Turkey', 'EURO', '919', '227019', '17', '5630');
INSERT INTO public.who_global_data_import VALUES (87409, '2020-07-29', 'TR', 'Turkey', 'EURO', '7693', '234712', '15', '5645');
INSERT INTO public.who_global_data_import VALUES (87410, '2020-07-30', 'TR', 'Turkey', 'EURO', '7672', '242384', '14', '5659');
INSERT INTO public.who_global_data_import VALUES (87411, '2020-07-31', 'TR', 'Turkey', 'EURO', '7697', '250081', '15', '5674');
INSERT INTO public.who_global_data_import VALUES (87412, '2020-08-01', 'TR', 'Turkey', 'EURO', '7712', '257793', '17', '5691');
INSERT INTO public.who_global_data_import VALUES (87413, '2020-08-02', 'TR', 'Turkey', 'EURO', '7726', '265519', '19', '5710');
INSERT INTO public.who_global_data_import VALUES (87414, '2020-08-03', 'TR', 'Turkey', 'EURO', '7717', '273236', '18', '5728');
INSERT INTO public.who_global_data_import VALUES (87415, '2020-08-04', 'TR', 'Turkey', 'EURO', '7725', '280961', '19', '5747');
INSERT INTO public.who_global_data_import VALUES (87416, '2020-08-05', 'TR', 'Turkey', 'EURO', '7813', '288774', '18', '5765');
INSERT INTO public.who_global_data_import VALUES (87417, '2020-08-06', 'TR', 'Turkey', 'EURO', '7908', '296682', '19', '5784');
INSERT INTO public.who_global_data_import VALUES (87418, '2020-08-07', 'TR', 'Turkey', 'EURO', '7883', '304565', '14', '5798');
INSERT INTO public.who_global_data_import VALUES (87419, '2020-08-08', 'TR', 'Turkey', 'EURO', '7915', '312480', '15', '5813');
INSERT INTO public.who_global_data_import VALUES (87420, '2020-08-09', 'TR', 'Turkey', 'EURO', '7902', '320382', '16', '5829');
INSERT INTO public.who_global_data_import VALUES (87421, '2020-08-10', 'TR', 'Turkey', 'EURO', '7912', '328294', '15', '5844');
INSERT INTO public.who_global_data_import VALUES (87422, '2020-08-11', 'TR', 'Turkey', 'EURO', '7923', '336217', '14', '5858');
INSERT INTO public.who_global_data_import VALUES (87423, '2020-08-12', 'TR', 'Turkey', 'EURO', '7913', '344130', '15', '5873');
INSERT INTO public.who_global_data_import VALUES (87424, '2020-08-13', 'TR', 'Turkey', 'EURO', '7942', '352072', '18', '5891');
INSERT INTO public.who_global_data_import VALUES (87425, '2020-08-14', 'TR', 'Turkey', 'EURO', '7973', '360045', '21', '5912');
INSERT INTO public.who_global_data_import VALUES (87426, '2020-08-15', 'TR', 'Turkey', 'EURO', '7956', '368001', '22', '5934');
INSERT INTO public.who_global_data_import VALUES (87427, '2020-08-16', 'TR', 'Turkey', 'EURO', '7986', '375987', '21', '5955');
INSERT INTO public.who_global_data_import VALUES (87428, '2020-08-17', 'TR', 'Turkey', 'EURO', '7922', '383909', '19', '5974');
INSERT INTO public.who_global_data_import VALUES (87429, '2020-08-18', 'TR', 'Turkey', 'EURO', '7963', '391872', '22', '5996');
INSERT INTO public.who_global_data_import VALUES (87430, '2020-08-19', 'TR', 'Turkey', 'EURO', '7993', '399865', '20', '6016');
INSERT INTO public.who_global_data_import VALUES (87431, '2020-08-20', 'TR', 'Turkey', 'EURO', '8033', '407898', '23', '6039');
INSERT INTO public.who_global_data_import VALUES (87432, '2020-08-21', 'TR', 'Turkey', 'EURO', '8142', '416040', '19', '6058');
INSERT INTO public.who_global_data_import VALUES (87433, '2020-08-22', 'TR', 'Turkey', 'EURO', '7933', '423973', '22', '6080');
INSERT INTO public.who_global_data_import VALUES (87434, '2020-08-23', 'TR', 'Turkey', 'EURO', '8039', '432012', '22', '6102');
INSERT INTO public.who_global_data_import VALUES (87435, '2020-08-24', 'TR', 'Turkey', 'EURO', '7947', '439959', '19', '6121');
INSERT INTO public.who_global_data_import VALUES (87436, '2020-08-25', 'TR', 'Turkey', 'EURO', '8173', '448132', '18', '6139');
INSERT INTO public.who_global_data_import VALUES (87437, '2020-08-26', 'TR', 'Turkey', 'EURO', '8232', '456364', '24', '6163');
INSERT INTO public.who_global_data_import VALUES (87438, '2020-08-27', 'TR', 'Turkey', 'EURO', '8043', '464407', '20', '6183');
INSERT INTO public.who_global_data_import VALUES (87439, '2020-08-28', 'TR', 'Turkey', 'EURO', '8221', '472628', '26', '6209');
INSERT INTO public.who_global_data_import VALUES (87440, '2020-08-29', 'TR', 'Turkey', 'EURO', '8247', '480875', '36', '6245');
INSERT INTO public.who_global_data_import VALUES (87441, '2020-08-30', 'TR', 'Turkey', 'EURO', '8279', '489154', '39', '6284');
INSERT INTO public.who_global_data_import VALUES (87442, '2020-08-31', 'TR', 'Turkey', 'EURO', '8212', '497366', '42', '6326');
INSERT INTO public.who_global_data_import VALUES (87443, '2020-09-01', 'TR', 'Turkey', 'EURO', '8317', '505683', '44', '6370');
INSERT INTO public.who_global_data_import VALUES (87444, '2020-09-02', 'TR', 'Turkey', 'EURO', '8302', '513985', '47', '6417');
INSERT INTO public.who_global_data_import VALUES (87445, '2020-09-03', 'TR', 'Turkey', 'EURO', '8326', '522311', '45', '6462');
INSERT INTO public.who_global_data_import VALUES (87446, '2020-09-04', 'TR', 'Turkey', 'EURO', '8372', '530683', '49', '6511');
INSERT INTO public.who_global_data_import VALUES (87447, '2020-09-05', 'TR', 'Turkey', 'EURO', '8342', '539025', '53', '6564');
INSERT INTO public.who_global_data_import VALUES (87448, '2020-09-06', 'TR', 'Turkey', 'EURO', '8403', '547428', '56', '6620');
INSERT INTO public.who_global_data_import VALUES (87449, '2020-09-07', 'TR', 'Turkey', 'EURO', '8308', '555736', '53', '6673');
INSERT INTO public.who_global_data_import VALUES (87450, '2020-09-08', 'TR', 'Turkey', 'EURO', '8433', '564169', '57', '6730');
INSERT INTO public.who_global_data_import VALUES (87451, '2020-09-09', 'TR', 'Turkey', 'EURO', '8491', '572660', '52', '6782');
INSERT INTO public.who_global_data_import VALUES (87452, '2020-09-10', 'TR', 'Turkey', 'EURO', '8403', '581063', '55', '6837');
INSERT INTO public.who_global_data_import VALUES (87453, '2020-09-11', 'TR', 'Turkey', 'EURO', '8242', '589305', '58', '6895');
INSERT INTO public.who_global_data_import VALUES (87454, '2020-09-12', 'TR', 'Turkey', 'EURO', '8401', '597706', '56', '6951');
INSERT INTO public.who_global_data_import VALUES (87455, '2020-09-13', 'TR', 'Turkey', 'EURO', '8239', '605945', '48', '6999');
INSERT INTO public.who_global_data_import VALUES (87456, '2020-09-14', 'TR', 'Turkey', 'EURO', '8257', '614202', '57', '7056');
INSERT INTO public.who_global_data_import VALUES (87457, '2020-09-15', 'TR', 'Turkey', 'EURO', '8446', '622648', '63', '7119');
INSERT INTO public.who_global_data_import VALUES (87458, '2020-09-16', 'TR', 'Turkey', 'EURO', '8472', '631120', '67', '7186');
INSERT INTO public.who_global_data_import VALUES (87459, '2020-09-17', 'TR', 'Turkey', 'EURO', '8501', '639621', '63', '7249');
INSERT INTO public.who_global_data_import VALUES (87460, '2020-09-18', 'TR', 'Turkey', 'EURO', '8378', '647999', '66', '7315');
INSERT INTO public.who_global_data_import VALUES (87461, '2020-09-19', 'TR', 'Turkey', 'EURO', '8501', '656500', '62', '7377');
INSERT INTO public.who_global_data_import VALUES (87462, '2020-09-20', 'TR', 'Turkey', 'EURO', '8268', '664768', '68', '7445');
INSERT INTO public.who_global_data_import VALUES (87463, '2020-09-21', 'TR', 'Turkey', 'EURO', '8249', '673017', '61', '7506');
INSERT INTO public.who_global_data_import VALUES (87464, '2020-09-22', 'TR', 'Turkey', 'EURO', '8473', '681490', '68', '7574');
INSERT INTO public.who_global_data_import VALUES (87465, '2020-09-23', 'TR', 'Turkey', 'EURO', '8422', '689912', '65', '7639');
INSERT INTO public.who_global_data_import VALUES (87466, '2020-09-24', 'TR', 'Turkey', 'EURO', '8497', '698409', '72', '7711');
INSERT INTO public.who_global_data_import VALUES (87467, '2020-09-25', 'TR', 'Turkey', 'EURO', '8451', '706860', '74', '7785');
INSERT INTO public.who_global_data_import VALUES (87468, '2020-09-26', 'TR', 'Turkey', 'EURO', '8395', '715255', '73', '7858');
INSERT INTO public.who_global_data_import VALUES (87469, '2020-09-27', 'TR', 'Turkey', 'EURO', '8241', '723496', '71', '7929');
INSERT INTO public.who_global_data_import VALUES (87470, '2020-09-28', 'TR', 'Turkey', 'EURO', '8197', '731693', '68', '7997');
INSERT INTO public.who_global_data_import VALUES (87471, '2020-09-29', 'TR', 'Turkey', 'EURO', '8142', '739835', '65', '8062');
INSERT INTO public.who_global_data_import VALUES (87472, '2020-09-30', 'TR', 'Turkey', 'EURO', '8157', '747992', '68', '8130');
INSERT INTO public.who_global_data_import VALUES (87473, '2020-10-01', 'TR', 'Turkey', 'EURO', '8121', '756113', '65', '8195');
INSERT INTO public.who_global_data_import VALUES (87474, '2020-10-02', 'TR', 'Turkey', 'EURO', '8137', '764250', '67', '8262');
INSERT INTO public.who_global_data_import VALUES (87475, '2020-10-03', 'TR', 'Turkey', 'EURO', '8172', '772422', '63', '8325');
INSERT INTO public.who_global_data_import VALUES (87476, '2020-10-04', 'TR', 'Turkey', 'EURO', '8232', '780654', '59', '8384');
INSERT INTO public.who_global_data_import VALUES (87477, '2020-10-05', 'TR', 'Turkey', 'EURO', '8159', '788813', '57', '8441');
INSERT INTO public.who_global_data_import VALUES (87478, '2020-10-06', 'TR', 'Turkey', 'EURO', '8333', '797146', '57', '8498');
INSERT INTO public.who_global_data_import VALUES (87479, '2020-10-07', 'TR', 'Turkey', 'EURO', '8241', '805387', '55', '8553');
INSERT INTO public.who_global_data_import VALUES (87480, '2020-10-08', 'TR', 'Turkey', 'EURO', '8311', '813698', '56', '8609');
INSERT INTO public.who_global_data_import VALUES (87481, '2020-10-09', 'TR', 'Turkey', 'EURO', '8345', '822043', '58', '8667');
INSERT INTO public.who_global_data_import VALUES (87482, '2020-10-10', 'TR', 'Turkey', 'EURO', '8359', '830402', '55', '8722');
INSERT INTO public.who_global_data_import VALUES (87483, '2020-10-11', 'TR', 'Turkey', 'EURO', '8379', '838781', '56', '8778');
INSERT INTO public.who_global_data_import VALUES (87484, '2020-10-12', 'TR', 'Turkey', 'EURO', '8232', '847013', '59', '8837');
INSERT INTO public.who_global_data_import VALUES (87485, '2020-10-13', 'TR', 'Turkey', 'EURO', '8344', '855357', '58', '8895');
INSERT INTO public.who_global_data_import VALUES (87486, '2020-10-14', 'TR', 'Turkey', 'EURO', '8362', '863719', '62', '8957');
INSERT INTO public.who_global_data_import VALUES (87487, '2020-10-15', 'TR', 'Turkey', 'EURO', '8401', '872120', '57', '9014');
INSERT INTO public.who_global_data_import VALUES (87488, '2020-10-16', 'TR', 'Turkey', 'EURO', '8423', '880543', '66', '9080');
INSERT INTO public.who_global_data_import VALUES (87489, '2020-10-17', 'TR', 'Turkey', 'EURO', '8542', '889085', '73', '9153');
INSERT INTO public.who_global_data_import VALUES (87490, '2020-10-18', 'TR', 'Turkey', 'EURO', '8453', '897538', '71', '9224');
INSERT INTO public.who_global_data_import VALUES (87491, '2020-10-19', 'TR', 'Turkey', 'EURO', '8545', '906083', '72', '9296');
INSERT INTO public.who_global_data_import VALUES (87492, '2020-10-20', 'TR', 'Turkey', 'EURO', '8756', '914839', '75', '9371');
INSERT INTO public.who_global_data_import VALUES (87493, '2020-10-21', 'TR', 'Turkey', 'EURO', '8624', '923463', '74', '9445');
INSERT INTO public.who_global_data_import VALUES (87494, '2020-10-22', 'TR', 'Turkey', 'EURO', '8743', '932206', '68', '9513');
INSERT INTO public.who_global_data_import VALUES (87495, '2020-10-23', 'TR', 'Turkey', 'EURO', '8832', '941038', '71', '9584');
INSERT INTO public.who_global_data_import VALUES (87496, '2020-10-24', 'TR', 'Turkey', 'EURO', '8895', '949933', '74', '9658');
INSERT INTO public.who_global_data_import VALUES (87497, '2020-10-25', 'TR', 'Turkey', 'EURO', '8821', '958754', '69', '9727');
INSERT INTO public.who_global_data_import VALUES (87498, '2020-10-26', 'TR', 'Turkey', 'EURO', '8747', '967501', '72', '9799');
INSERT INTO public.who_global_data_import VALUES (87499, '2020-10-27', 'TR', 'Turkey', 'EURO', '8928', '976429', '75', '9874');
INSERT INTO public.who_global_data_import VALUES (87500, '2020-10-28', 'TR', 'Turkey', 'EURO', '8939', '985368', '76', '9950');
INSERT INTO public.who_global_data_import VALUES (87501, '2020-10-29', 'TR', 'Turkey', 'EURO', '9035', '994403', '77', '10027');
INSERT INTO public.who_global_data_import VALUES (87502, '2020-10-30', 'TR', 'Turkey', 'EURO', '9049', '1003452', '72', '10099');
INSERT INTO public.who_global_data_import VALUES (87503, '2020-10-31', 'TR', 'Turkey', 'EURO', '9052', '1012504', '78', '10177');
INSERT INTO public.who_global_data_import VALUES (87504, '2020-11-01', 'TR', 'Turkey', 'EURO', '8943', '1021447', '75', '10252');
INSERT INTO public.who_global_data_import VALUES (87505, '2020-11-02', 'TR', 'Turkey', 'EURO', '8836', '1030283', '74', '10326');
INSERT INTO public.who_global_data_import VALUES (87506, '2020-11-03', 'TR', 'Turkey', 'EURO', '9032', '1039315', '76', '10402');
INSERT INTO public.who_global_data_import VALUES (87507, '2020-11-04', 'TR', 'Turkey', 'EURO', '9073', '1048388', '79', '10481');
INSERT INTO public.who_global_data_import VALUES (87508, '2020-11-05', 'TR', 'Turkey', 'EURO', '9121', '1057509', '77', '10558');
INSERT INTO public.who_global_data_import VALUES (87509, '2020-11-06', 'TR', 'Turkey', 'EURO', '9041', '1066550', '81', '10639');
INSERT INTO public.who_global_data_import VALUES (87510, '2020-11-07', 'TR', 'Turkey', 'EURO', '9166', '1075716', '83', '10722');
INSERT INTO public.who_global_data_import VALUES (87511, '2020-11-08', 'TR', 'Turkey', 'EURO', '9213', '1084929', '81', '10803');
INSERT INTO public.who_global_data_import VALUES (87512, '2020-11-09', 'TR', 'Turkey', 'EURO', '9246', '1094175', '84', '10887');
INSERT INTO public.who_global_data_import VALUES (87513, '2020-11-10', 'TR', 'Turkey', 'EURO', '9306', '1103481', '85', '10972');
INSERT INTO public.who_global_data_import VALUES (87514, '2020-11-11', 'TR', 'Turkey', 'EURO', '9259', '1112740', '87', '11059');
INSERT INTO public.who_global_data_import VALUES (87515, '2020-11-12', 'TR', 'Turkey', 'EURO', '9423', '1122163', '86', '11145');
INSERT INTO public.who_global_data_import VALUES (87516, '2020-11-13', 'TR', 'Turkey', 'EURO', '9571', '1131734', '88', '11233');
INSERT INTO public.who_global_data_import VALUES (87517, '2020-11-14', 'TR', 'Turkey', 'EURO', '9775', '1141509', '93', '11326');
INSERT INTO public.who_global_data_import VALUES (87518, '2020-11-15', 'TR', 'Turkey', 'EURO', '9846', '1151355', '92', '11418');
INSERT INTO public.who_global_data_import VALUES (87519, '2020-11-16', 'TR', 'Turkey', 'EURO', '9953', '1161308', '89', '11507');
INSERT INTO public.who_global_data_import VALUES (87520, '2020-11-17', 'TR', 'Turkey', 'EURO', '10046', '1171354', '94', '11601');
INSERT INTO public.who_global_data_import VALUES (87521, '2020-11-18', 'TR', 'Turkey', 'EURO', '10549', '1181903', '103', '11704');
INSERT INTO public.who_global_data_import VALUES (87522, '2020-11-19', 'TR', 'Turkey', 'EURO', '10946', '1192849', '116', '11820');
INSERT INTO public.who_global_data_import VALUES (87523, '2020-11-20', 'TR', 'Turkey', 'EURO', '11273', '1204122', '123', '11943');
INSERT INTO public.who_global_data_import VALUES (87524, '2020-11-21', 'TR', 'Turkey', 'EURO', '11834', '1215956', '141', '12084');
INSERT INTO public.who_global_data_import VALUES (87525, '2020-11-22', 'TR', 'Turkey', 'EURO', '12263', '1228219', '135', '12219');
INSERT INTO public.who_global_data_import VALUES (87526, '2020-11-23', 'TR', 'Turkey', 'EURO', '12748', '1240967', '139', '12358');
INSERT INTO public.who_global_data_import VALUES (87527, '2020-11-24', 'TR', 'Turkey', 'EURO', '13444', '1254411', '153', '12511');
INSERT INTO public.who_global_data_import VALUES (87528, '2020-11-25', 'TR', 'Turkey', 'EURO', '14112', '1268523', '161', '12672');
INSERT INTO public.who_global_data_import VALUES (87529, '2020-11-26', 'TR', 'Turkey', 'EURO', '13545', '1282068', '168', '12840');
INSERT INTO public.who_global_data_import VALUES (87530, '2020-11-27', 'TR', 'Turkey', 'EURO', '29132', '1311200', '174', '13014');
INSERT INTO public.who_global_data_import VALUES (87531, '2020-11-28', 'TR', 'Turkey', 'EURO', '29845', '1341045', '177', '13191');
INSERT INTO public.who_global_data_import VALUES (87532, '2020-11-29', 'TR', 'Turkey', 'EURO', '30103', '1371148', '182', '13373');
INSERT INTO public.who_global_data_import VALUES (87533, '2020-11-30', 'TR', 'Turkey', 'EURO', '29281', '1400429', '185', '13558');
INSERT INTO public.who_global_data_import VALUES (87534, '2020-12-01', 'TR', 'Turkey', 'EURO', '31219', '1431648', '188', '13746');
INSERT INTO public.who_global_data_import VALUES (87535, '2020-12-02', 'TR', 'Turkey', 'EURO', '30110', '1461758', '190', '13936');
INSERT INTO public.who_global_data_import VALUES (87536, '2020-12-03', 'TR', 'Turkey', 'EURO', '31923', '1493681', '193', '14129');
INSERT INTO public.who_global_data_import VALUES (87537, '2020-12-04', 'TR', 'Turkey', 'EURO', '32381', '1526062', '187', '14316');
INSERT INTO public.who_global_data_import VALUES (87538, '2020-12-05', 'TR', 'Turkey', 'EURO', '32736', '1558798', '193', '14509');
INSERT INTO public.who_global_data_import VALUES (87539, '2020-12-06', 'TR', 'Turkey', 'EURO', '31896', '1590694', '196', '14705');
INSERT INTO public.who_global_data_import VALUES (87540, '2020-12-07', 'TR', 'Turkey', 'EURO', '30402', '1621096', '195', '14900');
INSERT INTO public.who_global_data_import VALUES (87541, '2020-12-08', 'TR', 'Turkey', 'EURO', '32137', '1653233', '203', '15103');
INSERT INTO public.who_global_data_import VALUES (87542, '2020-12-09', 'TR', 'Turkey', 'EURO', '33198', '1686431', '211', '15314');
INSERT INTO public.who_global_data_import VALUES (87543, '2020-12-10', 'TR', 'Turkey', 'EURO', '31712', '1718143', '217', '15531');
INSERT INTO public.who_global_data_import VALUES (87544, '2020-12-11', 'TR', 'Turkey', 'EURO', '30424', '1748567', '220', '15751');
INSERT INTO public.who_global_data_import VALUES (87545, '2020-12-12', 'TR', 'Turkey', 'EURO', '32106', '1780673', '226', '15977');
INSERT INTO public.who_global_data_import VALUES (87546, '2020-12-13', 'TR', 'Turkey', 'EURO', '29136', '1809809', '222', '16199');
INSERT INTO public.who_global_data_import VALUES (87547, '2020-12-14', 'TR', 'Turkey', 'EURO', '26919', '1836728', '218', '16417');
INSERT INTO public.who_global_data_import VALUES (87548, '2020-12-15', 'TR', 'Turkey', 'EURO', '29617', '1866345', '229', '16646');
INSERT INTO public.who_global_data_import VALUES (87549, '2020-12-16', 'TR', 'Turkey', 'EURO', '32102', '1898447', '235', '16881');
INSERT INTO public.who_global_data_import VALUES (87550, '2020-12-17', 'TR', 'Turkey', 'EURO', '29718', '1928165', '240', '17121');
INSERT INTO public.who_global_data_import VALUES (87551, '2020-12-18', 'TR', 'Turkey', 'EURO', '27515', '1955680', '243', '17364');
INSERT INTO public.who_global_data_import VALUES (87552, '2020-12-19', 'TR', 'Turkey', 'EURO', '26410', '1982090', '246', '17610');
INSERT INTO public.who_global_data_import VALUES (87553, '2020-12-20', 'TR', 'Turkey', 'EURO', '22195', '2004285', '241', '17851');
INSERT INTO public.who_global_data_import VALUES (87554, '2020-12-21', 'TR', 'Turkey', 'EURO', '20316', '2024601', '246', '18097');
INSERT INTO public.who_global_data_import VALUES (87555, '2020-12-22', 'TR', 'Turkey', 'EURO', '19103', '2043704', '254', '18351');
INSERT INTO public.who_global_data_import VALUES (87556, '2020-12-23', 'TR', 'Turkey', 'EURO', '19256', '2062960', '251', '18602');
INSERT INTO public.who_global_data_import VALUES (87557, '2020-12-24', 'TR', 'Turkey', 'EURO', '19650', '2082610', '259', '18861');
INSERT INTO public.who_global_data_import VALUES (87558, '2020-12-25', 'TR', 'Turkey', 'EURO', '18102', '2100712', '254', '19115');
INSERT INTO public.who_global_data_import VALUES (87559, '2020-12-26', 'TR', 'Turkey', 'EURO', '17543', '2118255', '256', '19371');
INSERT INTO public.who_global_data_import VALUES (87560, '2020-12-27', 'TR', 'Turkey', 'EURO', '15118', '2133373', '253', '19624');
INSERT INTO public.who_global_data_import VALUES (87561, '2020-12-28', 'TR', 'Turkey', 'EURO', '14205', '2147578', '254', '19878');
INSERT INTO public.who_global_data_import VALUES (87562, '2020-12-29', 'TR', 'Turkey', 'EURO', '15197', '2162775', '257', '20135');
INSERT INTO public.who_global_data_import VALUES (87563, '2020-12-30', 'TR', 'Turkey', 'EURO', '15805', '2178580', '253', '20388');
INSERT INTO public.who_global_data_import VALUES (87564, '2020-12-31', 'TR', 'Turkey', 'EURO', '15692', '2194272', '254', '20642');
INSERT INTO public.who_global_data_import VALUES (87565, '2021-01-01', 'TR', 'Turkey', 'EURO', '14380', '2208652', '239', '20881');
INSERT INTO public.who_global_data_import VALUES (87566, '2021-01-02', 'TR', 'Turkey', 'EURO', '12203', '2220855', '212', '21093');
INSERT INTO public.who_global_data_import VALUES (87567, '2021-01-03', 'TR', 'Turkey', 'EURO', '11180', '2232035', '202', '21295');
INSERT INTO public.who_global_data_import VALUES (87568, '2021-01-04', 'TR', 'Turkey', 'EURO', '9877', '2241912', '193', '21488');
INSERT INTO public.who_global_data_import VALUES (87569, '2021-01-05', 'TR', 'Turkey', 'EURO', '13695', '2255607', '197', '21685');
INSERT INTO public.who_global_data_import VALUES (87570, '2021-01-06', 'TR', 'Turkey', 'EURO', '14494', '2270101', '194', '21879');
INSERT INTO public.who_global_data_import VALUES (87571, '2021-01-07', 'TR', 'Turkey', 'EURO', '13830', '2283931', '191', '22070');
INSERT INTO public.who_global_data_import VALUES (87572, '2021-01-08', 'TR', 'Turkey', 'EURO', '12171', '2296102', '194', '22264');
INSERT INTO public.who_global_data_import VALUES (87573, '2021-01-09', 'TR', 'Turkey', 'EURO', '11479', '2307581', '186', '22450');
INSERT INTO public.who_global_data_import VALUES (87574, '2021-01-10', 'TR', 'Turkey', 'EURO', '9537', '2317118', '181', '22631');
INSERT INTO public.who_global_data_import VALUES (87575, '2021-01-11', 'TR', 'Turkey', 'EURO', '9138', '2326256', '176', '22807');
INSERT INTO public.who_global_data_import VALUES (87576, '2021-01-12', 'TR', 'Turkey', 'EURO', '10220', '2336476', '174', '22981');
INSERT INTO public.who_global_data_import VALUES (87577, '2021-01-13', 'TR', 'Turkey', 'EURO', '9809', '2346285', '171', '23152');
INSERT INTO public.who_global_data_import VALUES (87578, '2021-01-14', 'TR', 'Turkey', 'EURO', '9554', '2355839', '173', '23325');
INSERT INTO public.who_global_data_import VALUES (87579, '2021-01-15', 'TR', 'Turkey', 'EURO', '8962', '2364801', '170', '23495');
INSERT INTO public.who_global_data_import VALUES (87580, '2021-01-16', 'TR', 'Turkey', 'EURO', '8314', '2373115', '169', '23664');
INSERT INTO public.who_global_data_import VALUES (87581, '2021-01-17', 'TR', 'Turkey', 'EURO', '7550', '2380665', '168', '23832');
INSERT INTO public.who_global_data_import VALUES (87582, '2021-01-18', 'TR', 'Turkey', 'EURO', '6436', '2387101', '165', '23997');
INSERT INTO public.who_global_data_import VALUES (87583, '2021-01-19', 'TR', 'Turkey', 'EURO', '5862', '2392963', '164', '24161');
INSERT INTO public.who_global_data_import VALUES (87584, '2021-01-20', 'TR', 'Turkey', 'EURO', '6818', '2399781', '167', '24328');
INSERT INTO public.who_global_data_import VALUES (87585, '2021-01-21', 'TR', 'Turkey', 'EURO', '6435', '2406216', '159', '24487');
INSERT INTO public.who_global_data_import VALUES (87586, '2021-01-22', 'TR', 'Turkey', 'EURO', '6289', '2412505', '153', '24640');
INSERT INTO public.who_global_data_import VALUES (87587, '2021-01-23', 'TR', 'Turkey', 'EURO', '5967', '2418472', '149', '24789');
INSERT INTO public.who_global_data_import VALUES (87588, '2021-01-24', 'TR', 'Turkey', 'EURO', '5856', '2424328', '144', '24933');
INSERT INTO public.who_global_data_import VALUES (87589, '2021-01-25', 'TR', 'Turkey', 'EURO', '5277', '2429605', '140', '25073');
INSERT INTO public.who_global_data_import VALUES (87590, '2021-01-26', 'TR', 'Turkey', 'EURO', '5642', '2435247', '137', '25210');
INSERT INTO public.who_global_data_import VALUES (87591, '2021-01-27', 'TR', 'Turkey', 'EURO', '7103', '2442350', '134', '25344');
INSERT INTO public.who_global_data_import VALUES (87592, '2021-01-28', 'TR', 'Turkey', 'EURO', '7489', '2449839', '132', '25476');
INSERT INTO public.who_global_data_import VALUES (87593, '2021-01-29', 'TR', 'Turkey', 'EURO', '7279', '2457118', '129', '25605');
INSERT INTO public.who_global_data_import VALUES (87594, '2021-01-30', 'TR', 'Turkey', 'EURO', '6912', '2464030', '131', '25736');
INSERT INTO public.who_global_data_import VALUES (87595, '2021-01-31', 'TR', 'Turkey', 'EURO', '6871', '2470901', '129', '25865');
INSERT INTO public.who_global_data_import VALUES (87596, '2021-02-01', 'TR', 'Turkey', 'EURO', '6562', '2477463', '128', '25993');
INSERT INTO public.who_global_data_import VALUES (87597, '2021-02-02', 'TR', 'Turkey', 'EURO', '7719', '2485182', '124', '26117');
INSERT INTO public.who_global_data_import VALUES (87598, '2021-02-03', 'TR', 'Turkey', 'EURO', '7795', '2492977', '120', '26237');
INSERT INTO public.who_global_data_import VALUES (87599, '2021-02-04', 'TR', 'Turkey', 'EURO', '8102', '2501079', '117', '26354');
INSERT INTO public.who_global_data_import VALUES (87600, '2021-02-05', 'TR', 'Turkey', 'EURO', '7909', '2508988', '113', '26467');
INSERT INTO public.who_global_data_import VALUES (87601, '2020-01-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87602, '2020-01-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87603, '2020-01-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87604, '2020-01-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87605, '2020-01-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87606, '2020-01-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87607, '2020-01-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87608, '2020-01-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87609, '2020-01-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87610, '2020-01-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87611, '2020-01-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87612, '2020-01-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87613, '2020-01-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87614, '2020-01-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87615, '2020-01-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87616, '2020-01-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87617, '2020-01-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87618, '2020-01-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87619, '2020-01-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87620, '2020-01-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87621, '2020-01-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87622, '2020-01-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87623, '2020-01-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87624, '2020-01-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87625, '2020-01-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87626, '2020-01-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87627, '2020-01-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87628, '2020-01-30', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87629, '2020-01-31', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87630, '2020-02-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87631, '2020-02-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87632, '2020-02-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87633, '2020-02-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87634, '2020-02-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87635, '2020-02-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87636, '2020-02-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87637, '2020-02-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87638, '2020-02-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87639, '2020-02-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87640, '2020-02-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87641, '2020-02-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87642, '2020-02-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87643, '2020-02-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87644, '2020-02-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87645, '2020-02-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87646, '2020-02-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87647, '2020-02-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87648, '2020-02-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87649, '2020-02-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87650, '2020-02-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87651, '2020-02-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87652, '2020-02-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87653, '2020-02-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87654, '2020-02-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87655, '2020-02-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87656, '2020-02-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87657, '2020-02-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87658, '2020-02-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87659, '2020-03-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87660, '2020-03-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87661, '2020-03-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87662, '2020-03-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87663, '2020-03-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87664, '2020-03-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87665, '2020-03-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87666, '2020-03-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87667, '2020-03-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87668, '2020-03-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87669, '2020-03-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87670, '2020-03-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87671, '2020-03-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87672, '2020-03-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87673, '2020-03-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87674, '2020-03-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87675, '2020-03-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87676, '2020-03-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87677, '2020-03-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87678, '2020-03-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87679, '2020-03-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87680, '2020-03-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87681, '2020-03-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87682, '2020-03-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87683, '2020-03-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87684, '2020-03-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87685, '2020-03-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87686, '2020-03-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87687, '2020-03-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87688, '2020-03-30', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87689, '2020-03-31', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87690, '2020-04-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87691, '2020-04-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87692, '2020-04-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87693, '2020-04-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87694, '2020-04-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87695, '2020-04-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87696, '2020-04-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87697, '2020-04-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87698, '2020-04-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87699, '2020-04-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87700, '2020-04-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87701, '2020-04-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87702, '2020-04-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87703, '2020-04-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87704, '2020-04-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87705, '2020-04-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87706, '2020-04-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87707, '2020-04-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87708, '2020-04-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87709, '2020-04-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87710, '2020-04-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87711, '2020-04-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87712, '2020-04-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87713, '2020-04-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87714, '2020-04-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87715, '2020-04-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87716, '2020-04-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87717, '2020-04-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87718, '2020-04-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87719, '2020-04-30', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87720, '2020-05-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87721, '2020-05-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87722, '2020-05-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87723, '2020-05-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87724, '2020-05-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87725, '2020-05-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87726, '2020-05-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87727, '2020-05-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87728, '2020-05-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87729, '2020-05-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87730, '2020-05-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87731, '2020-05-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87732, '2020-05-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87733, '2020-05-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87734, '2020-05-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87735, '2020-05-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87736, '2020-05-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87737, '2020-05-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87738, '2020-05-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87739, '2020-05-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87740, '2020-05-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87741, '2020-05-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87742, '2020-05-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87743, '2020-05-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87744, '2020-05-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87745, '2020-05-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87746, '2020-05-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87747, '2020-05-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87748, '2020-05-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87749, '2020-05-30', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87750, '2020-05-31', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87751, '2020-06-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87752, '2020-06-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87753, '2020-06-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87754, '2020-06-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87755, '2020-06-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87756, '2020-06-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87757, '2020-06-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87758, '2020-06-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87759, '2020-06-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87760, '2020-06-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87761, '2020-06-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87762, '2020-06-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87763, '2020-06-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87764, '2020-06-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87765, '2020-06-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87766, '2020-06-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87767, '2020-06-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87768, '2020-06-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87769, '2020-06-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87770, '2020-06-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87771, '2020-06-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87772, '2020-06-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87773, '2020-06-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87774, '2020-06-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87775, '2020-06-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87776, '2020-06-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87777, '2020-06-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87778, '2020-06-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87779, '2020-06-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87780, '2020-06-30', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87781, '2020-07-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87782, '2020-07-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87783, '2020-07-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87784, '2020-07-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87785, '2020-07-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87786, '2020-07-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87787, '2020-07-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87788, '2020-07-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87789, '2020-07-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87790, '2020-07-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87791, '2020-07-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87792, '2020-07-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87793, '2020-07-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87794, '2020-07-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87795, '2020-07-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87796, '2020-07-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87797, '2020-07-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87798, '2020-07-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87799, '2020-07-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87800, '2020-07-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87801, '2020-07-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87802, '2020-07-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87803, '2020-07-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87804, '2020-07-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87805, '2020-07-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87806, '2020-07-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87807, '2020-07-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87808, '2020-07-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87809, '2020-07-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87810, '2020-07-30', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87811, '2020-07-31', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87812, '2020-08-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87813, '2020-08-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87814, '2020-08-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87815, '2020-08-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87816, '2020-08-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87817, '2020-08-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87818, '2020-08-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87819, '2020-08-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87820, '2020-08-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87821, '2020-08-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87822, '2020-08-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87823, '2020-08-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87824, '2020-08-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87825, '2020-08-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87826, '2020-08-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87827, '2020-08-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87828, '2020-08-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87829, '2020-08-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87830, '2020-08-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87831, '2020-08-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87832, '2020-08-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87833, '2020-08-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87834, '2020-08-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87835, '2020-08-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87836, '2020-08-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87837, '2020-08-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87838, '2020-08-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87839, '2020-08-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87840, '2020-08-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87841, '2020-08-30', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87842, '2020-08-31', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87843, '2020-09-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87844, '2020-09-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87845, '2020-09-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87846, '2020-09-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87847, '2020-09-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87848, '2020-09-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87849, '2020-09-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87850, '2020-09-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87851, '2020-09-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87852, '2020-09-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87853, '2020-09-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87854, '2020-09-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87855, '2020-09-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87856, '2020-09-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87857, '2020-09-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87858, '2020-09-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87859, '2020-09-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87860, '2020-09-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87861, '2020-09-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87862, '2020-09-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87863, '2020-09-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87864, '2020-09-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87865, '2020-09-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87866, '2020-09-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87867, '2020-09-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87868, '2020-09-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87869, '2020-09-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87870, '2020-09-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87871, '2020-09-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87872, '2020-09-30', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87873, '2020-10-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87874, '2020-10-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87875, '2020-10-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87876, '2020-10-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87877, '2020-10-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87878, '2020-10-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87879, '2020-10-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87880, '2020-10-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87881, '2020-10-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87882, '2020-10-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87883, '2020-10-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87884, '2020-10-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87885, '2020-10-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87886, '2020-10-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87887, '2020-10-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87888, '2020-10-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87889, '2020-10-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87890, '2020-10-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87891, '2020-10-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87892, '2020-10-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87893, '2020-10-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87894, '2020-10-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87895, '2020-10-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87896, '2020-10-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87897, '2020-10-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87898, '2020-10-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87899, '2020-10-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87900, '2020-10-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87901, '2020-10-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87902, '2020-10-30', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87903, '2020-10-31', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87904, '2020-11-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87905, '2020-11-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87906, '2020-11-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87907, '2020-11-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87908, '2020-11-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87909, '2020-11-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87910, '2020-11-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87911, '2020-11-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87912, '2020-11-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87913, '2020-11-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87914, '2020-11-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87915, '2020-11-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87916, '2020-11-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87917, '2020-11-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87918, '2020-11-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87919, '2020-11-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87920, '2020-11-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87921, '2020-11-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87922, '2020-11-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87923, '2020-11-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87924, '2020-11-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87925, '2020-11-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87926, '2020-11-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87927, '2020-11-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87928, '2020-11-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87929, '2020-11-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87930, '2020-11-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87931, '2020-11-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87932, '2020-11-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87933, '2020-11-30', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87934, '2020-12-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87935, '2020-12-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87936, '2020-12-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87937, '2020-12-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87938, '2020-12-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87939, '2020-12-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87940, '2020-12-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87941, '2020-12-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87942, '2020-12-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87943, '2020-12-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87944, '2020-12-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87945, '2020-12-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87946, '2020-12-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87947, '2020-12-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87948, '2020-12-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87949, '2020-12-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87950, '2020-12-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87951, '2020-12-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87952, '2020-12-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87953, '2020-12-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87954, '2020-12-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87955, '2020-12-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87956, '2020-12-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87957, '2020-12-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87958, '2020-12-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87959, '2020-12-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87960, '2020-12-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87961, '2020-12-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87962, '2020-12-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87963, '2020-12-30', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87964, '2020-12-31', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87965, '2021-01-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87966, '2021-01-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87967, '2021-01-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87968, '2021-01-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87969, '2021-01-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87970, '2021-01-06', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87971, '2021-01-07', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87972, '2021-01-08', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87973, '2021-01-09', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87974, '2021-01-10', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87975, '2021-01-11', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87976, '2021-01-12', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87977, '2021-01-13', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87978, '2021-01-14', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87979, '2021-01-15', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87980, '2021-01-16', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87981, '2021-01-17', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87982, '2021-01-18', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87983, '2021-01-19', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87984, '2021-01-20', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87985, '2021-01-21', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87986, '2021-01-22', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87987, '2021-01-23', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87988, '2021-01-24', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87989, '2021-01-25', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87990, '2021-01-26', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87991, '2021-01-27', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87992, '2021-01-28', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87993, '2021-01-29', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87994, '2021-01-30', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87995, '2021-01-31', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87996, '2021-02-01', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87997, '2021-02-02', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87998, '2021-02-03', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (87999, '2021-02-04', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88000, '2021-02-05', 'TM', 'Turkmenistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88001, '2020-01-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88002, '2020-01-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88003, '2020-01-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88004, '2020-01-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88005, '2020-01-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88006, '2020-01-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88007, '2020-01-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88008, '2020-01-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88009, '2020-01-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88010, '2020-01-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88011, '2020-01-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88012, '2020-01-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88013, '2020-01-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88014, '2020-01-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88015, '2020-01-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88016, '2020-01-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88017, '2020-01-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88018, '2020-01-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88019, '2020-01-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88020, '2020-01-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88021, '2020-01-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88022, '2020-01-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88023, '2020-01-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88024, '2020-01-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88025, '2020-01-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88026, '2020-01-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88027, '2020-01-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88028, '2020-01-30', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88029, '2020-01-31', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88030, '2020-02-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88031, '2020-02-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88032, '2020-02-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88033, '2020-02-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88034, '2020-02-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88035, '2020-02-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88036, '2020-02-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88037, '2020-02-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88038, '2020-02-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88039, '2020-02-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88040, '2020-02-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88041, '2020-02-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88042, '2020-02-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88043, '2020-02-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88044, '2020-02-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88045, '2020-02-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88046, '2020-02-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88047, '2020-02-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88048, '2020-02-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88049, '2020-02-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88050, '2020-02-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88051, '2020-02-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88052, '2020-02-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88053, '2020-02-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88054, '2020-02-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88055, '2020-02-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88056, '2020-02-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88057, '2020-02-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88058, '2020-02-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88059, '2020-03-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88060, '2020-03-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88061, '2020-03-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88062, '2020-03-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88063, '2020-03-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88064, '2020-03-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88065, '2020-03-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88066, '2020-03-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88067, '2020-03-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88068, '2020-03-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88069, '2020-03-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88070, '2020-03-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88071, '2020-03-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88072, '2020-03-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88073, '2020-03-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88074, '2020-03-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88075, '2020-03-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88076, '2020-03-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88077, '2020-03-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88078, '2020-03-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88079, '2020-03-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88080, '2020-03-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88081, '2020-03-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88082, '2020-03-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88083, '2020-03-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88084, '2020-03-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88085, '2020-03-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88086, '2020-03-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88087, '2020-03-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88088, '2020-03-30', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88089, '2020-03-31', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88090, '2020-04-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88091, '2020-04-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88092, '2020-04-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88093, '2020-04-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88094, '2020-04-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88095, '2020-04-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '5', '1', '1');
INSERT INTO public.who_global_data_import VALUES (88096, '2020-04-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88097, '2020-04-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '3', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88098, '2020-04-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88099, '2020-04-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88100, '2020-04-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88101, '2020-04-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88102, '2020-04-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88103, '2020-04-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88104, '2020-04-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88105, '2020-04-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '10', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88106, '2020-04-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88107, '2020-04-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88108, '2020-04-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88109, '2020-04-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88110, '2020-04-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88111, '2020-04-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88112, '2020-04-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88113, '2020-04-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88114, '2020-04-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88115, '2020-04-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88116, '2020-04-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '11', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88117, '2020-04-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88118, '2020-04-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88119, '2020-04-30', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88120, '2020-05-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88121, '2020-05-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88122, '2020-05-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88123, '2020-05-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88124, '2020-05-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88125, '2020-05-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88126, '2020-05-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88127, '2020-05-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88128, '2020-05-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88129, '2020-05-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88130, '2020-05-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88131, '2020-05-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88132, '2020-05-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88133, '2020-05-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88134, '2020-05-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88135, '2020-05-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88136, '2020-05-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88137, '2020-05-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88138, '2020-05-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88139, '2020-05-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88140, '2020-05-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88141, '2020-05-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88142, '2020-05-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88143, '2020-05-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88144, '2020-05-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88145, '2020-05-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88146, '2020-05-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88147, '2020-05-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88148, '2020-05-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88149, '2020-05-30', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88150, '2020-05-31', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88151, '2020-06-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88152, '2020-06-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88153, '2020-06-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88154, '2020-06-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88155, '2020-06-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88156, '2020-06-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88157, '2020-06-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88158, '2020-06-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88159, '2020-06-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88160, '2020-06-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88161, '2020-06-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88162, '2020-06-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88163, '2020-06-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88164, '2020-06-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88165, '2020-06-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88166, '2020-06-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88167, '2020-06-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88168, '2020-06-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88169, '2020-06-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88170, '2020-06-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88171, '2020-06-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '12', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88172, '2020-06-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88173, '2020-06-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88174, '2020-06-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88175, '2020-06-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '14', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88176, '2020-06-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '15', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88177, '2020-06-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88178, '2020-06-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88179, '2020-06-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '16', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88180, '2020-06-30', 'TC', 'Turks and Caicos Islands', 'AMRO', '25', '41', '0', '1');
INSERT INTO public.who_global_data_import VALUES (88181, '2020-07-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '41', '1', '2');
INSERT INTO public.who_global_data_import VALUES (88182, '2020-07-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '42', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88183, '2020-07-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '42', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88184, '2020-07-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '44', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88185, '2020-07-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '45', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88186, '2020-07-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '47', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88187, '2020-07-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88188, '2020-07-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '49', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88189, '2020-07-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '6', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88190, '2020-07-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '55', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88191, '2020-07-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '11', '66', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88192, '2020-07-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '66', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88193, '2020-07-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '5', '71', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88194, '2020-07-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '72', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88195, '2020-07-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '72', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88196, '2020-07-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '72', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88197, '2020-07-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '72', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88198, '2020-07-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '74', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88199, '2020-07-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '75', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88200, '2020-07-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '75', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88201, '2020-07-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '6', '81', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88202, '2020-07-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '81', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88203, '2020-07-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '82', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88204, '2020-07-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '4', '86', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88205, '2020-07-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '4', '90', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88206, '2020-07-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '92', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88207, '2020-07-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '5', '97', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88208, '2020-07-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '99', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88209, '2020-07-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '99', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88210, '2020-07-30', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '99', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88211, '2020-07-31', 'TC', 'Turks and Caicos Islands', 'AMRO', '5', '104', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88212, '2020-08-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '3', '107', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88213, '2020-08-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '7', '114', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88214, '2020-08-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '114', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88215, '2020-08-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '114', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88216, '2020-08-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '116', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88217, '2020-08-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '116', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88218, '2020-08-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '13', '129', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88219, '2020-08-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '12', '141', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88220, '2020-08-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '29', '170', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88221, '2020-08-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '27', '197', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88222, '2020-08-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '19', '216', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88223, '2020-08-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '216', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88224, '2020-08-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '8', '224', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88225, '2020-08-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '17', '241', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88226, '2020-08-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '17', '258', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88227, '2020-08-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '16', '274', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88228, '2020-08-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '24', '298', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88229, '2020-08-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '298', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88230, '2020-08-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '298', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88231, '2020-08-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '17', '315', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88232, '2020-08-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '12', '327', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88233, '2020-08-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '7', '334', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88234, '2020-08-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '13', '347', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88235, '2020-08-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '36', '383', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88236, '2020-08-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '383', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88237, '2020-08-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '383', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88238, '2020-08-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '48', '431', '0', '2');
INSERT INTO public.who_global_data_import VALUES (88239, '2020-08-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '33', '464', '1', '3');
INSERT INTO public.who_global_data_import VALUES (88240, '2020-08-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '18', '482', '0', '3');
INSERT INTO public.who_global_data_import VALUES (88241, '2020-08-30', 'TC', 'Turks and Caicos Islands', 'AMRO', '8', '490', '0', '3');
INSERT INTO public.who_global_data_import VALUES (88242, '2020-08-31', 'TC', 'Turks and Caicos Islands', 'AMRO', '15', '505', '0', '3');
INSERT INTO public.who_global_data_import VALUES (88243, '2020-09-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '507', '0', '3');
INSERT INTO public.who_global_data_import VALUES (88244, '2020-09-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '508', '1', '4');
INSERT INTO public.who_global_data_import VALUES (88245, '2020-09-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '30', '538', '0', '4');
INSERT INTO public.who_global_data_import VALUES (88430, '2020-02-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88246, '2020-09-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '17', '555', '0', '4');
INSERT INTO public.who_global_data_import VALUES (88247, '2020-09-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '22', '577', '1', '5');
INSERT INTO public.who_global_data_import VALUES (88248, '2020-09-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '14', '591', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88249, '2020-09-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '7', '598', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88250, '2020-09-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '599', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88251, '2020-09-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '599', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88252, '2020-09-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '15', '614', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88253, '2020-09-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '14', '628', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88254, '2020-09-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '10', '638', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88255, '2020-09-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '3', '641', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88256, '2020-09-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '3', '644', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88257, '2020-09-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '646', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88258, '2020-09-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '648', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88259, '2020-09-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '650', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88260, '2020-09-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '9', '659', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88261, '2020-09-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '4', '663', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88262, '2020-09-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '4', '667', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88263, '2020-09-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '668', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88264, '2020-09-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '668', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88265, '2020-09-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '668', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88266, '2020-09-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '4', '672', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88267, '2020-09-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '4', '676', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88268, '2020-09-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '3', '679', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88269, '2020-09-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '680', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88270, '2020-09-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '681', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88271, '2020-09-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '682', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88272, '2020-09-30', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '682', '0', '5');
INSERT INTO public.who_global_data_import VALUES (88273, '2020-10-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '4', '686', '1', '6');
INSERT INTO public.who_global_data_import VALUES (88274, '2020-10-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '3', '689', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88275, '2020-10-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '690', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88276, '2020-10-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '5', '695', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88277, '2020-10-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '695', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88278, '2020-10-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '695', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88279, '2020-10-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '695', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88280, '2020-10-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '695', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88281, '2020-10-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '695', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88282, '2020-10-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '695', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88283, '2020-10-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '695', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88284, '2020-10-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '696', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88285, '2020-10-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '696', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88286, '2020-10-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '696', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88287, '2020-10-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '696', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88288, '2020-10-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '696', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88289, '2020-10-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '696', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88290, '2020-10-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '697', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88291, '2020-10-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '698', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88292, '2020-10-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '698', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88293, '2020-10-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '698', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88294, '2020-10-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '698', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88295, '2020-10-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '698', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88296, '2020-10-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '699', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88297, '2020-10-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '699', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88298, '2020-10-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '701', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88299, '2020-10-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '701', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88300, '2020-10-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '701', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88301, '2020-10-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '703', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88302, '2020-10-30', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '703', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88303, '2020-10-31', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '703', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88304, '2020-11-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '703', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88305, '2020-11-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '703', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88306, '2020-11-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '704', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88307, '2020-11-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '704', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88308, '2020-11-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '704', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88309, '2020-11-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '705', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88310, '2020-11-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '705', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88311, '2020-11-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '707', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88312, '2020-11-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '707', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88313, '2020-11-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '707', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88314, '2020-11-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '707', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88315, '2020-11-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '4', '711', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88316, '2020-11-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '5', '716', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88317, '2020-11-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '716', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88318, '2020-11-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '716', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88319, '2020-11-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '4', '720', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88320, '2020-11-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '720', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88321, '2020-11-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '720', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88322, '2020-11-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '721', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88323, '2020-11-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '721', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88324, '2020-11-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '5', '726', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88325, '2020-11-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '726', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88326, '2020-11-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '20', '746', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88327, '2020-11-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '746', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88328, '2020-11-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '746', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88329, '2020-11-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '746', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88330, '2020-11-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '746', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88331, '2020-11-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '746', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88332, '2020-11-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '748', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88333, '2020-11-30', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '748', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88431, '2020-02-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88334, '2020-12-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '748', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88335, '2020-12-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '748', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88336, '2020-12-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '750', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88337, '2020-12-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '751', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88338, '2020-12-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '751', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88339, '2020-12-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '4', '755', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88340, '2020-12-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '756', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88341, '2020-12-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '756', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88342, '2020-12-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '756', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88343, '2020-12-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '5', '761', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88344, '2020-12-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '7', '768', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88345, '2020-12-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '768', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88346, '2020-12-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '769', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88347, '2020-12-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '769', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88348, '2020-12-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '769', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88349, '2020-12-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '769', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88350, '2020-12-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '2', '771', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88351, '2020-12-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '772', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88352, '2020-12-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '9', '781', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88353, '2020-12-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '8', '789', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88354, '2020-12-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '9', '798', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88355, '2020-12-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '798', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88356, '2020-12-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '798', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88357, '2020-12-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '9', '807', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88358, '2020-12-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '3', '810', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88359, '2020-12-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '19', '829', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88360, '2020-12-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '15', '844', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88361, '2020-12-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '844', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88362, '2020-12-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '5', '849', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88363, '2020-12-30', 'TC', 'Turks and Caicos Islands', 'AMRO', '16', '865', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88364, '2020-12-31', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '865', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88365, '2021-01-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '9', '874', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88366, '2021-01-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '19', '893', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88367, '2021-01-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '15', '908', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88368, '2021-01-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '909', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88369, '2021-01-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '910', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88370, '2021-01-06', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '910', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88371, '2021-01-07', 'TC', 'Turks and Caicos Islands', 'AMRO', '8', '918', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88372, '2021-01-08', 'TC', 'Turks and Caicos Islands', 'AMRO', '23', '941', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88373, '2021-01-09', 'TC', 'Turks and Caicos Islands', 'AMRO', '15', '956', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88374, '2021-01-10', 'TC', 'Turks and Caicos Islands', 'AMRO', '9', '965', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88375, '2021-01-11', 'TC', 'Turks and Caicos Islands', 'AMRO', '29', '994', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88376, '2021-01-12', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '994', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88377, '2021-01-13', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '994', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88378, '2021-01-14', 'TC', 'Turks and Caicos Islands', 'AMRO', '17', '1011', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88379, '2021-01-15', 'TC', 'Turks and Caicos Islands', 'AMRO', '19', '1030', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88380, '2021-01-16', 'TC', 'Turks and Caicos Islands', 'AMRO', '32', '1062', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88381, '2021-01-17', 'TC', 'Turks and Caicos Islands', 'AMRO', '17', '1079', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88382, '2021-01-18', 'TC', 'Turks and Caicos Islands', 'AMRO', '23', '1102', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88383, '2021-01-19', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '1102', '0', '6');
INSERT INTO public.who_global_data_import VALUES (88384, '2021-01-20', 'TC', 'Turks and Caicos Islands', 'AMRO', '3', '1105', '1', '7');
INSERT INTO public.who_global_data_import VALUES (88385, '2021-01-21', 'TC', 'Turks and Caicos Islands', 'AMRO', '20', '1125', '0', '7');
INSERT INTO public.who_global_data_import VALUES (88386, '2021-01-22', 'TC', 'Turks and Caicos Islands', 'AMRO', '39', '1164', '0', '7');
INSERT INTO public.who_global_data_import VALUES (88387, '2021-01-23', 'TC', 'Turks and Caicos Islands', 'AMRO', '29', '1193', '0', '7');
INSERT INTO public.who_global_data_import VALUES (88388, '2021-01-24', 'TC', 'Turks and Caicos Islands', 'AMRO', '51', '1244', '0', '7');
INSERT INTO public.who_global_data_import VALUES (88389, '2021-01-25', 'TC', 'Turks and Caicos Islands', 'AMRO', '43', '1287', '0', '7');
INSERT INTO public.who_global_data_import VALUES (88390, '2021-01-26', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '1287', '0', '7');
INSERT INTO public.who_global_data_import VALUES (88391, '2021-01-27', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '1287', '1', '8');
INSERT INTO public.who_global_data_import VALUES (88392, '2021-01-28', 'TC', 'Turks and Caicos Islands', 'AMRO', '25', '1312', '0', '8');
INSERT INTO public.who_global_data_import VALUES (88393, '2021-01-29', 'TC', 'Turks and Caicos Islands', 'AMRO', '75', '1387', '0', '8');
INSERT INTO public.who_global_data_import VALUES (88394, '2021-01-30', 'TC', 'Turks and Caicos Islands', 'AMRO', '48', '1435', '0', '8');
INSERT INTO public.who_global_data_import VALUES (88395, '2021-01-31', 'TC', 'Turks and Caicos Islands', 'AMRO', '24', '1459', '0', '8');
INSERT INTO public.who_global_data_import VALUES (88396, '2021-02-01', 'TC', 'Turks and Caicos Islands', 'AMRO', '44', '1503', '1', '9');
INSERT INTO public.who_global_data_import VALUES (88397, '2021-02-02', 'TC', 'Turks and Caicos Islands', 'AMRO', '1', '1504', '0', '9');
INSERT INTO public.who_global_data_import VALUES (88398, '2021-02-03', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '1504', '0', '9');
INSERT INTO public.who_global_data_import VALUES (88399, '2021-02-04', 'TC', 'Turks and Caicos Islands', 'AMRO', '0', '1504', '0', '9');
INSERT INTO public.who_global_data_import VALUES (88400, '2021-02-05', 'TC', 'Turks and Caicos Islands', 'AMRO', '49', '1553', '0', '9');
INSERT INTO public.who_global_data_import VALUES (88401, '2020-01-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88402, '2020-01-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88403, '2020-01-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88404, '2020-01-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88405, '2020-01-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88406, '2020-01-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88407, '2020-01-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88408, '2020-01-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88409, '2020-01-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88410, '2020-01-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88411, '2020-01-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88412, '2020-01-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88413, '2020-01-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88414, '2020-01-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88415, '2020-01-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88416, '2020-01-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88417, '2020-01-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88418, '2020-01-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88419, '2020-01-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88420, '2020-01-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88421, '2020-01-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88422, '2020-01-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88423, '2020-01-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88424, '2020-01-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88425, '2020-01-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88426, '2020-01-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88427, '2020-01-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88428, '2020-01-30', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88429, '2020-01-31', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88432, '2020-02-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88433, '2020-02-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88434, '2020-02-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88435, '2020-02-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88436, '2020-02-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88437, '2020-02-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88438, '2020-02-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88439, '2020-02-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88440, '2020-02-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88441, '2020-02-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88442, '2020-02-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88443, '2020-02-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88444, '2020-02-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88445, '2020-02-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88446, '2020-02-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88447, '2020-02-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88448, '2020-02-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88449, '2020-02-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88450, '2020-02-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88451, '2020-02-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88452, '2020-02-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88453, '2020-02-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88454, '2020-02-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88455, '2020-02-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88456, '2020-02-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88457, '2020-02-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88458, '2020-02-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88459, '2020-03-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88460, '2020-03-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88461, '2020-03-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88462, '2020-03-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88463, '2020-03-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88464, '2020-03-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88465, '2020-03-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88466, '2020-03-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88467, '2020-03-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88468, '2020-03-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88469, '2020-03-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88470, '2020-03-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88471, '2020-03-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88472, '2020-03-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88473, '2020-03-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88474, '2020-03-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88475, '2020-03-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88476, '2020-03-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88477, '2020-03-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88478, '2020-03-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88479, '2020-03-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88480, '2020-03-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88481, '2020-03-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88482, '2020-03-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88483, '2020-03-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88484, '2020-03-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88485, '2020-03-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88486, '2020-03-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88487, '2020-03-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88488, '2020-03-30', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88489, '2020-03-31', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88490, '2020-04-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88491, '2020-04-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88492, '2020-04-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88493, '2020-04-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88494, '2020-04-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88495, '2020-04-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88496, '2020-04-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88497, '2020-04-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88498, '2020-04-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88499, '2020-04-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88500, '2020-04-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88501, '2020-04-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88502, '2020-04-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88503, '2020-04-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88504, '2020-04-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88505, '2020-04-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88506, '2020-04-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88507, '2020-04-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88508, '2020-04-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88509, '2020-04-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88510, '2020-04-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88511, '2020-04-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88512, '2020-04-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88513, '2020-04-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88514, '2020-04-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88515, '2020-04-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88516, '2020-04-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88517, '2020-04-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88518, '2020-04-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88519, '2020-04-30', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88520, '2020-05-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88521, '2020-05-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88522, '2020-05-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88523, '2020-05-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88524, '2020-05-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88525, '2020-05-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88526, '2020-05-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88527, '2020-05-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88528, '2020-05-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88529, '2020-05-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88530, '2020-05-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88531, '2020-05-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88532, '2020-05-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88533, '2020-05-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88534, '2020-05-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88535, '2020-05-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88536, '2020-05-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88537, '2020-05-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88538, '2020-05-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88539, '2020-05-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88540, '2020-05-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88541, '2020-05-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88542, '2020-05-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88543, '2020-05-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88544, '2020-05-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88545, '2020-05-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88546, '2020-05-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88547, '2020-05-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88548, '2020-05-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88549, '2020-05-30', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88550, '2020-05-31', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88551, '2020-06-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88552, '2020-06-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88553, '2020-06-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88554, '2020-06-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88555, '2020-06-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88556, '2020-06-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88557, '2020-06-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88558, '2020-06-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88559, '2020-06-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88560, '2020-06-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88561, '2020-06-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88562, '2020-06-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88563, '2020-06-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88564, '2020-06-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88565, '2020-06-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88566, '2020-06-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88567, '2020-06-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88568, '2020-06-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88569, '2020-06-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88570, '2020-06-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88571, '2020-06-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88572, '2020-06-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88573, '2020-06-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88574, '2020-06-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88575, '2020-06-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88576, '2020-06-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88577, '2020-06-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88578, '2020-06-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88579, '2020-06-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88580, '2020-06-30', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88581, '2020-07-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88582, '2020-07-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88583, '2020-07-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88584, '2020-07-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88585, '2020-07-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88586, '2020-07-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88587, '2020-07-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88588, '2020-07-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88589, '2020-07-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88590, '2020-07-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88591, '2020-07-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88592, '2020-07-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88593, '2020-07-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88594, '2020-07-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88595, '2020-07-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88596, '2020-07-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88597, '2020-07-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88598, '2020-07-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88599, '2020-07-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88600, '2020-07-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88601, '2020-07-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88602, '2020-07-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88603, '2020-07-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88604, '2020-07-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88605, '2020-07-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88606, '2020-07-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88607, '2020-07-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88608, '2020-07-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88609, '2020-07-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88610, '2020-07-30', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88611, '2020-07-31', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88612, '2020-08-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88613, '2020-08-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88614, '2020-08-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88615, '2020-08-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88616, '2020-08-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88617, '2020-08-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88618, '2020-08-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88619, '2020-08-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88620, '2020-08-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88621, '2020-08-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88622, '2020-08-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88623, '2020-08-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88624, '2020-08-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88625, '2020-08-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88626, '2020-08-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88627, '2020-08-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88628, '2020-08-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88629, '2020-08-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88630, '2020-08-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88631, '2020-08-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88632, '2020-08-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88633, '2020-08-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88634, '2020-08-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88635, '2020-08-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88636, '2020-08-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88637, '2020-08-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88638, '2020-08-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88639, '2020-08-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88640, '2020-08-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88641, '2020-08-30', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88642, '2020-08-31', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88643, '2020-09-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88644, '2020-09-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88645, '2020-09-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88646, '2020-09-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88647, '2020-09-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88648, '2020-09-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88649, '2020-09-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88650, '2020-09-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88651, '2020-09-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88652, '2020-09-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88653, '2020-09-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88654, '2020-09-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88655, '2020-09-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88656, '2020-09-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88657, '2020-09-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88658, '2020-09-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88659, '2020-09-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88660, '2020-09-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88661, '2020-09-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88662, '2020-09-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88663, '2020-09-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88664, '2020-09-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88665, '2020-09-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88666, '2020-09-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88667, '2020-09-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88668, '2020-09-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88669, '2020-09-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88670, '2020-09-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88671, '2020-09-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88672, '2020-09-30', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88673, '2020-10-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88674, '2020-10-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88675, '2020-10-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88676, '2020-10-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88677, '2020-10-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88678, '2020-10-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88679, '2020-10-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88680, '2020-10-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88681, '2020-10-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88682, '2020-10-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88683, '2020-10-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88684, '2020-10-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88685, '2020-10-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88686, '2020-10-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88687, '2020-10-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88688, '2020-10-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88689, '2020-10-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88690, '2020-10-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88691, '2020-10-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88692, '2020-10-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88693, '2020-10-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88694, '2020-10-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88695, '2020-10-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88696, '2020-10-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88697, '2020-10-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88698, '2020-10-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88699, '2020-10-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88700, '2020-10-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88701, '2020-10-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88702, '2020-10-30', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88703, '2020-10-31', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88704, '2020-11-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88705, '2020-11-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88706, '2020-11-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88707, '2020-11-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88708, '2020-11-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88709, '2020-11-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88710, '2020-11-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88711, '2020-11-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88712, '2020-11-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88713, '2020-11-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88714, '2020-11-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88715, '2020-11-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88716, '2020-11-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88717, '2020-11-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88718, '2020-11-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88719, '2020-11-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88720, '2020-11-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88721, '2020-11-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88722, '2020-11-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88723, '2020-11-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88724, '2020-11-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88725, '2020-11-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88726, '2020-11-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88727, '2020-11-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88728, '2020-11-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88729, '2020-11-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88730, '2020-11-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88731, '2020-11-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88732, '2020-11-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88733, '2020-11-30', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88734, '2020-12-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88735, '2020-12-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88736, '2020-12-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88737, '2020-12-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88738, '2020-12-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88739, '2020-12-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88740, '2020-12-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88741, '2020-12-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88742, '2020-12-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88743, '2020-12-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88744, '2020-12-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88745, '2020-12-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88746, '2020-12-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88747, '2020-12-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88748, '2020-12-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88749, '2020-12-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88750, '2020-12-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88751, '2020-12-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88752, '2020-12-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88753, '2020-12-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88754, '2020-12-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88755, '2020-12-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88756, '2020-12-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88757, '2020-12-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88758, '2020-12-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88759, '2020-12-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88760, '2020-12-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88761, '2020-12-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88762, '2020-12-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88763, '2020-12-30', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88764, '2020-12-31', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88765, '2021-01-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88766, '2021-01-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88767, '2021-01-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88768, '2021-01-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88769, '2021-01-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88770, '2021-01-06', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88771, '2021-01-07', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88772, '2021-01-08', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88773, '2021-01-09', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88774, '2021-01-10', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88775, '2021-01-11', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88776, '2021-01-12', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88777, '2021-01-13', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88778, '2021-01-14', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88779, '2021-01-15', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88780, '2021-01-16', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88781, '2021-01-17', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88782, '2021-01-18', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88783, '2021-01-19', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88784, '2021-01-20', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88785, '2021-01-21', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88786, '2021-01-22', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88787, '2021-01-23', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88788, '2021-01-24', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88789, '2021-01-25', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88790, '2021-01-26', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88791, '2021-01-27', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88792, '2021-01-28', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88793, '2021-01-29', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88794, '2021-01-30', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88795, '2021-01-31', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88796, '2021-02-01', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88797, '2021-02-02', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88798, '2021-02-03', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88799, '2021-02-04', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88800, '2021-02-05', 'TV', 'Tuvalu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88801, '2020-01-03', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88802, '2020-01-04', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88803, '2020-01-05', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88804, '2020-01-06', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88805, '2020-01-07', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88806, '2020-01-08', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88807, '2020-01-09', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88808, '2020-01-10', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88809, '2020-01-11', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88810, '2020-01-12', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88811, '2020-01-13', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88812, '2020-01-14', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88813, '2020-01-15', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88814, '2020-01-16', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88815, '2020-01-17', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88816, '2020-01-18', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88817, '2020-01-19', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88818, '2020-01-20', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88819, '2020-01-21', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88820, '2020-01-22', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88821, '2020-01-23', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88822, '2020-01-24', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88823, '2020-01-25', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88824, '2020-01-26', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88825, '2020-01-27', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88826, '2020-01-28', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88827, '2020-01-29', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88828, '2020-01-30', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88829, '2020-01-31', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88830, '2020-02-01', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88831, '2020-02-02', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88832, '2020-02-03', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88833, '2020-02-04', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88834, '2020-02-05', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88835, '2020-02-06', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88836, '2020-02-07', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88837, '2020-02-08', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88838, '2020-02-09', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88839, '2020-02-10', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88840, '2020-02-11', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88841, '2020-02-12', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88842, '2020-02-13', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88843, '2020-02-14', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88844, '2020-02-15', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88845, '2020-02-16', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88846, '2020-02-17', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88847, '2020-02-18', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88848, '2020-02-19', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88849, '2020-02-20', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88850, '2020-02-21', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88851, '2020-02-22', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88852, '2020-02-23', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88853, '2020-02-24', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88854, '2020-02-25', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88855, '2020-02-26', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88856, '2020-02-27', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88857, '2020-02-28', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88858, '2020-02-29', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88859, '2020-03-01', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88860, '2020-03-02', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88861, '2020-03-03', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88862, '2020-03-04', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88863, '2020-03-05', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88864, '2020-03-06', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88865, '2020-03-07', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88866, '2020-03-08', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88867, '2020-03-09', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88868, '2020-03-10', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88869, '2020-03-11', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88870, '2020-03-12', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88871, '2020-03-13', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88872, '2020-03-14', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88873, '2020-03-15', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88874, '2020-03-16', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88875, '2020-03-17', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88876, '2020-03-18', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88877, '2020-03-19', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88878, '2020-03-20', 'UG', 'Uganda', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88879, '2020-03-21', 'UG', 'Uganda', 'AFRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88880, '2020-03-22', 'UG', 'Uganda', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88881, '2020-03-23', 'UG', 'Uganda', 'AFRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88882, '2020-03-24', 'UG', 'Uganda', 'AFRO', '8', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88883, '2020-03-25', 'UG', 'Uganda', 'AFRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88884, '2020-03-26', 'UG', 'Uganda', 'AFRO', '5', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88885, '2020-03-27', 'UG', 'Uganda', 'AFRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88886, '2020-03-28', 'UG', 'Uganda', 'AFRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88887, '2020-03-29', 'UG', 'Uganda', 'AFRO', '16', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88888, '2020-03-30', 'UG', 'Uganda', 'AFRO', '3', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88889, '2020-03-31', 'UG', 'Uganda', 'AFRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88890, '2020-04-01', 'UG', 'Uganda', 'AFRO', '0', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88891, '2020-04-02', 'UG', 'Uganda', 'AFRO', '11', '44', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88892, '2020-04-03', 'UG', 'Uganda', 'AFRO', '1', '45', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88893, '2020-04-04', 'UG', 'Uganda', 'AFRO', '3', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88894, '2020-04-05', 'UG', 'Uganda', 'AFRO', '0', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88895, '2020-04-06', 'UG', 'Uganda', 'AFRO', '0', '48', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88896, '2020-04-07', 'UG', 'Uganda', 'AFRO', '4', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88897, '2020-04-08', 'UG', 'Uganda', 'AFRO', '0', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88898, '2020-04-09', 'UG', 'Uganda', 'AFRO', '1', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88899, '2020-04-10', 'UG', 'Uganda', 'AFRO', '0', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88900, '2020-04-11', 'UG', 'Uganda', 'AFRO', '0', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88901, '2020-04-12', 'UG', 'Uganda', 'AFRO', '0', '53', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88902, '2020-04-13', 'UG', 'Uganda', 'AFRO', '1', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88903, '2020-04-14', 'UG', 'Uganda', 'AFRO', '0', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88904, '2020-04-15', 'UG', 'Uganda', 'AFRO', '0', '54', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88905, '2020-04-16', 'UG', 'Uganda', 'AFRO', '1', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88906, '2020-04-17', 'UG', 'Uganda', 'AFRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88907, '2020-04-18', 'UG', 'Uganda', 'AFRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88908, '2020-04-19', 'UG', 'Uganda', 'AFRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88909, '2020-04-20', 'UG', 'Uganda', 'AFRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88910, '2020-04-21', 'UG', 'Uganda', 'AFRO', '0', '55', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88911, '2020-04-22', 'UG', 'Uganda', 'AFRO', '1', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88912, '2020-04-23', 'UG', 'Uganda', 'AFRO', '5', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88913, '2020-04-24', 'UG', 'Uganda', 'AFRO', '2', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88914, '2020-04-25', 'UG', 'Uganda', 'AFRO', '12', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88915, '2020-04-26', 'UG', 'Uganda', 'AFRO', '0', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88916, '2020-04-27', 'UG', 'Uganda', 'AFRO', '0', '75', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88917, '2020-04-28', 'UG', 'Uganda', 'AFRO', '4', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88918, '2020-04-29', 'UG', 'Uganda', 'AFRO', '0', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88919, '2020-04-30', 'UG', 'Uganda', 'AFRO', '0', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88920, '2020-05-01', 'UG', 'Uganda', 'AFRO', '2', '81', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88921, '2020-05-02', 'UG', 'Uganda', 'AFRO', '2', '83', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88922, '2020-05-03', 'UG', 'Uganda', 'AFRO', '2', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88923, '2020-05-04', 'UG', 'Uganda', 'AFRO', '3', '88', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88924, '2020-05-05', 'UG', 'Uganda', 'AFRO', '1', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88925, '2020-05-06', 'UG', 'Uganda', 'AFRO', '8', '97', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88926, '2020-05-07', 'UG', 'Uganda', 'AFRO', '1', '98', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88927, '2020-05-08', 'UG', 'Uganda', 'AFRO', '3', '101', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88928, '2020-05-09', 'UG', 'Uganda', 'AFRO', '0', '101', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88929, '2020-05-10', 'UG', 'Uganda', 'AFRO', '15', '116', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88930, '2020-05-11', 'UG', 'Uganda', 'AFRO', '5', '121', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88931, '2020-05-12', 'UG', 'Uganda', 'AFRO', '1', '122', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88932, '2020-05-13', 'UG', 'Uganda', 'AFRO', '4', '126', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88933, '2020-05-14', 'UG', 'Uganda', 'AFRO', '13', '139', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88934, '2020-05-15', 'UG', 'Uganda', 'AFRO', '21', '160', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88935, '2020-05-16', 'UG', 'Uganda', 'AFRO', '43', '203', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88936, '2020-05-17', 'UG', 'Uganda', 'AFRO', '24', '227', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88937, '2020-05-18', 'UG', 'Uganda', 'AFRO', '0', '227', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88938, '2020-05-19', 'UG', 'Uganda', 'AFRO', '33', '260', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88939, '2020-05-20', 'UG', 'Uganda', 'AFRO', '0', '260', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88940, '2020-05-21', 'UG', 'Uganda', 'AFRO', '4', '264', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88941, '2020-05-22', 'UG', 'Uganda', 'AFRO', '0', '264', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88942, '2020-05-23', 'UG', 'Uganda', 'AFRO', '10', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88943, '2020-05-24', 'UG', 'Uganda', 'AFRO', '38', '312', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88944, '2020-05-25', 'UG', 'Uganda', 'AFRO', '-8', '304', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88945, '2020-05-26', 'UG', 'Uganda', 'AFRO', '0', '304', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88946, '2020-05-27', 'UG', 'Uganda', 'AFRO', '37', '341', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88947, '2020-05-28', 'UG', 'Uganda', 'AFRO', '10', '351', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88948, '2020-05-29', 'UG', 'Uganda', 'AFRO', '59', '410', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88949, '2020-05-30', 'UG', 'Uganda', 'AFRO', '0', '410', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88950, '2020-05-31', 'UG', 'Uganda', 'AFRO', '36', '446', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88951, '2020-06-01', 'UG', 'Uganda', 'AFRO', '12', '458', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88952, '2020-06-02', 'UG', 'Uganda', 'AFRO', '0', '458', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88953, '2020-06-03', 'UG', 'Uganda', 'AFRO', '128', '586', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88954, '2020-06-04', 'UG', 'Uganda', 'AFRO', '50', '636', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88955, '2020-06-05', 'UG', 'Uganda', 'AFRO', '15', '651', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88956, '2020-06-06', 'UG', 'Uganda', 'AFRO', '35', '686', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88957, '2020-06-07', 'UG', 'Uganda', 'AFRO', '36', '722', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88958, '2020-06-08', 'UG', 'Uganda', 'AFRO', '23', '745', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88959, '2020-06-09', 'UG', 'Uganda', 'AFRO', '30', '775', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88960, '2020-06-10', 'UG', 'Uganda', 'AFRO', '0', '775', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88961, '2020-06-11', 'UG', 'Uganda', 'AFRO', '19', '794', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88962, '2020-06-12', 'UG', 'Uganda', 'AFRO', '14', '808', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88963, '2020-06-13', 'UG', 'Uganda', 'AFRO', '0', '808', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88964, '2020-06-14', 'UG', 'Uganda', 'AFRO', '15', '823', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88965, '2020-06-15', 'UG', 'Uganda', 'AFRO', '0', '823', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88966, '2020-06-16', 'UG', 'Uganda', 'AFRO', '0', '823', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88967, '2020-06-17', 'UG', 'Uganda', 'AFRO', '0', '823', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88968, '2020-06-18', 'UG', 'Uganda', 'AFRO', '0', '823', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88969, '2020-06-19', 'UG', 'Uganda', 'AFRO', '0', '823', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88970, '2020-06-20', 'UG', 'Uganda', 'AFRO', '0', '823', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88971, '2020-06-21', 'UG', 'Uganda', 'AFRO', '0', '823', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88972, '2020-06-22', 'UG', 'Uganda', 'AFRO', '-68', '755', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88973, '2020-06-23', 'UG', 'Uganda', 'AFRO', '19', '774', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88974, '2020-06-24', 'UG', 'Uganda', 'AFRO', '23', '797', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88975, '2020-06-25', 'UG', 'Uganda', 'AFRO', '8', '805', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88976, '2020-06-26', 'UG', 'Uganda', 'AFRO', '16', '821', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88977, '2020-06-27', 'UG', 'Uganda', 'AFRO', '12', '833', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88978, '2020-06-28', 'UG', 'Uganda', 'AFRO', '0', '833', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88979, '2020-06-29', 'UG', 'Uganda', 'AFRO', '0', '833', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88980, '2020-06-30', 'UG', 'Uganda', 'AFRO', '37', '870', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88981, '2020-07-01', 'UG', 'Uganda', 'AFRO', '19', '889', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88982, '2020-07-02', 'UG', 'Uganda', 'AFRO', '4', '893', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88983, '2020-07-03', 'UG', 'Uganda', 'AFRO', '9', '902', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88984, '2020-07-04', 'UG', 'Uganda', 'AFRO', '9', '911', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88985, '2020-07-05', 'UG', 'Uganda', 'AFRO', '16', '927', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88986, '2020-07-06', 'UG', 'Uganda', 'AFRO', '12', '939', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88987, '2020-07-07', 'UG', 'Uganda', 'AFRO', '14', '953', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88988, '2020-07-08', 'UG', 'Uganda', 'AFRO', '18', '971', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88989, '2020-07-09', 'UG', 'Uganda', 'AFRO', '6', '977', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88990, '2020-07-10', 'UG', 'Uganda', 'AFRO', '23', '1000', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88991, '2020-07-11', 'UG', 'Uganda', 'AFRO', '6', '1006', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88992, '2020-07-12', 'UG', 'Uganda', 'AFRO', '7', '1013', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88993, '2020-07-13', 'UG', 'Uganda', 'AFRO', '12', '1025', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88994, '2020-07-14', 'UG', 'Uganda', 'AFRO', '4', '1029', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88995, '2020-07-15', 'UG', 'Uganda', 'AFRO', '11', '1040', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88996, '2020-07-16', 'UG', 'Uganda', 'AFRO', '3', '1043', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88997, '2020-07-17', 'UG', 'Uganda', 'AFRO', '8', '1051', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88998, '2020-07-18', 'UG', 'Uganda', 'AFRO', '5', '1056', '0', '0');
INSERT INTO public.who_global_data_import VALUES (88999, '2020-07-19', 'UG', 'Uganda', 'AFRO', '6', '1062', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89000, '2020-07-20', 'UG', 'Uganda', 'AFRO', '3', '1065', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89001, '2020-07-21', 'UG', 'Uganda', 'AFRO', '4', '1069', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89002, '2020-07-22', 'UG', 'Uganda', 'AFRO', '3', '1072', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89003, '2020-07-23', 'UG', 'Uganda', 'AFRO', '3', '1075', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89004, '2020-07-24', 'UG', 'Uganda', 'AFRO', '5', '1080', '1', '1');
INSERT INTO public.who_global_data_import VALUES (89005, '2020-07-25', 'UG', 'Uganda', 'AFRO', '9', '1089', '0', '1');
INSERT INTO public.who_global_data_import VALUES (89006, '2020-07-26', 'UG', 'Uganda', 'AFRO', '14', '1103', '0', '1');
INSERT INTO public.who_global_data_import VALUES (89007, '2020-07-27', 'UG', 'Uganda', 'AFRO', '12', '1115', '1', '2');
INSERT INTO public.who_global_data_import VALUES (89008, '2020-07-28', 'UG', 'Uganda', 'AFRO', '13', '1128', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89009, '2020-07-29', 'UG', 'Uganda', 'AFRO', '7', '1135', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89010, '2020-07-30', 'UG', 'Uganda', 'AFRO', '0', '1135', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89011, '2020-07-31', 'UG', 'Uganda', 'AFRO', '12', '1147', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89012, '2020-08-01', 'UG', 'Uganda', 'AFRO', '7', '1154', '1', '3');
INSERT INTO public.who_global_data_import VALUES (89013, '2020-08-02', 'UG', 'Uganda', 'AFRO', '22', '1176', '1', '4');
INSERT INTO public.who_global_data_import VALUES (89014, '2020-08-03', 'UG', 'Uganda', 'AFRO', '6', '1182', '0', '4');
INSERT INTO public.who_global_data_import VALUES (89015, '2020-08-04', 'UG', 'Uganda', 'AFRO', '13', '1195', '1', '5');
INSERT INTO public.who_global_data_import VALUES (89016, '2020-08-05', 'UG', 'Uganda', 'AFRO', '8', '1203', '0', '5');
INSERT INTO public.who_global_data_import VALUES (89017, '2020-08-06', 'UG', 'Uganda', 'AFRO', '10', '1213', '0', '5');
INSERT INTO public.who_global_data_import VALUES (89018, '2020-08-07', 'UG', 'Uganda', 'AFRO', '10', '1223', '0', '5');
INSERT INTO public.who_global_data_import VALUES (89019, '2020-08-08', 'UG', 'Uganda', 'AFRO', '31', '1254', '1', '6');
INSERT INTO public.who_global_data_import VALUES (89020, '2020-08-09', 'UG', 'Uganda', 'AFRO', '15', '1269', '0', '6');
INSERT INTO public.who_global_data_import VALUES (89021, '2020-08-10', 'UG', 'Uganda', 'AFRO', '14', '1283', '1', '7');
INSERT INTO public.who_global_data_import VALUES (89022, '2020-08-11', 'UG', 'Uganda', 'AFRO', '14', '1297', '2', '9');
INSERT INTO public.who_global_data_import VALUES (89023, '2020-08-12', 'UG', 'Uganda', 'AFRO', '16', '1313', '0', '9');
INSERT INTO public.who_global_data_import VALUES (89024, '2020-08-13', 'UG', 'Uganda', 'AFRO', '19', '1332', '0', '9');
INSERT INTO public.who_global_data_import VALUES (89025, '2020-08-14', 'UG', 'Uganda', 'AFRO', '21', '1353', '2', '11');
INSERT INTO public.who_global_data_import VALUES (89026, '2020-08-15', 'UG', 'Uganda', 'AFRO', '32', '1385', '1', '12');
INSERT INTO public.who_global_data_import VALUES (89027, '2020-08-16', 'UG', 'Uganda', 'AFRO', '49', '1434', '0', '12');
INSERT INTO public.who_global_data_import VALUES (89028, '2020-08-17', 'UG', 'Uganda', 'AFRO', '66', '1500', '1', '13');
INSERT INTO public.who_global_data_import VALUES (89029, '2020-08-18', 'UG', 'Uganda', 'AFRO', '60', '1560', '2', '15');
INSERT INTO public.who_global_data_import VALUES (89030, '2020-08-19', 'UG', 'Uganda', 'AFRO', '43', '1603', '0', '15');
INSERT INTO public.who_global_data_import VALUES (89031, '2020-08-20', 'UG', 'Uganda', 'AFRO', '53', '1656', '1', '16');
INSERT INTO public.who_global_data_import VALUES (89032, '2020-08-21', 'UG', 'Uganda', 'AFRO', '94', '1750', '3', '19');
INSERT INTO public.who_global_data_import VALUES (89033, '2020-08-22', 'UG', 'Uganda', 'AFRO', '0', '1750', '0', '19');
INSERT INTO public.who_global_data_import VALUES (89034, '2020-08-23', 'UG', 'Uganda', 'AFRO', '416', '2166', '1', '20');
INSERT INTO public.who_global_data_import VALUES (89035, '2020-08-24', 'UG', 'Uganda', 'AFRO', '97', '2263', '0', '20');
INSERT INTO public.who_global_data_import VALUES (89036, '2020-08-25', 'UG', 'Uganda', 'AFRO', '99', '2362', '2', '22');
INSERT INTO public.who_global_data_import VALUES (89037, '2020-08-26', 'UG', 'Uganda', 'AFRO', '64', '2426', '3', '25');
INSERT INTO public.who_global_data_import VALUES (89038, '2020-08-27', 'UG', 'Uganda', 'AFRO', '98', '2524', '1', '26');
INSERT INTO public.who_global_data_import VALUES (89039, '2020-08-28', 'UG', 'Uganda', 'AFRO', '0', '2524', '0', '26');
INSERT INTO public.who_global_data_import VALUES (89040, '2020-08-29', 'UG', 'Uganda', 'AFRO', '232', '2756', '2', '28');
INSERT INTO public.who_global_data_import VALUES (89041, '2020-08-30', 'UG', 'Uganda', 'AFRO', '0', '2756', '0', '28');
INSERT INTO public.who_global_data_import VALUES (89042, '2020-08-31', 'UG', 'Uganda', 'AFRO', '132', '2888', '2', '30');
INSERT INTO public.who_global_data_import VALUES (89043, '2020-09-01', 'UG', 'Uganda', 'AFRO', '84', '2972', '2', '32');
INSERT INTO public.who_global_data_import VALUES (89044, '2020-09-02', 'UG', 'Uganda', 'AFRO', '65', '3037', '0', '32');
INSERT INTO public.who_global_data_import VALUES (89045, '2020-09-03', 'UG', 'Uganda', 'AFRO', '75', '3112', '0', '32');
INSERT INTO public.who_global_data_import VALUES (89046, '2020-09-04', 'UG', 'Uganda', 'AFRO', '176', '3288', '1', '33');
INSERT INTO public.who_global_data_import VALUES (89047, '2020-09-05', 'UG', 'Uganda', 'AFRO', '65', '3353', '2', '35');
INSERT INTO public.who_global_data_import VALUES (89048, '2020-09-06', 'UG', 'Uganda', 'AFRO', '186', '3539', '4', '39');
INSERT INTO public.who_global_data_import VALUES (89049, '2020-09-07', 'UG', 'Uganda', 'AFRO', '128', '3667', '2', '41');
INSERT INTO public.who_global_data_import VALUES (89050, '2020-09-08', 'UG', 'Uganda', 'AFRO', '109', '3776', '3', '44');
INSERT INTO public.who_global_data_import VALUES (89051, '2020-09-09', 'UG', 'Uganda', 'AFRO', '124', '3900', '2', '46');
INSERT INTO public.who_global_data_import VALUES (89052, '2020-09-10', 'UG', 'Uganda', 'AFRO', '201', '4101', '0', '46');
INSERT INTO public.who_global_data_import VALUES (89053, '2020-09-11', 'UG', 'Uganda', 'AFRO', '190', '4291', '2', '48');
INSERT INTO public.who_global_data_import VALUES (89054, '2020-09-12', 'UG', 'Uganda', 'AFRO', '86', '4377', '1', '49');
INSERT INTO public.who_global_data_import VALUES (89055, '2020-09-13', 'UG', 'Uganda', 'AFRO', '326', '4703', '3', '52');
INSERT INTO public.who_global_data_import VALUES (89056, '2020-09-14', 'UG', 'Uganda', 'AFRO', '96', '4799', '3', '55');
INSERT INTO public.who_global_data_import VALUES (89057, '2020-09-15', 'UG', 'Uganda', 'AFRO', '179', '4978', '1', '56');
INSERT INTO public.who_global_data_import VALUES (89058, '2020-09-16', 'UG', 'Uganda', 'AFRO', '145', '5123', '2', '58');
INSERT INTO public.who_global_data_import VALUES (89059, '2020-09-17', 'UG', 'Uganda', 'AFRO', '143', '5266', '2', '60');
INSERT INTO public.who_global_data_import VALUES (89060, '2020-09-18', 'UG', 'Uganda', 'AFRO', '114', '5380', '0', '60');
INSERT INTO public.who_global_data_import VALUES (89061, '2020-09-19', 'UG', 'Uganda', 'AFRO', '210', '5590', '1', '61');
INSERT INTO public.who_global_data_import VALUES (89062, '2020-09-20', 'UG', 'Uganda', 'AFRO', '427', '6017', '2', '63');
INSERT INTO public.who_global_data_import VALUES (89063, '2020-09-21', 'UG', 'Uganda', 'AFRO', '270', '6287', '0', '63');
INSERT INTO public.who_global_data_import VALUES (89064, '2020-09-22', 'UG', 'Uganda', 'AFRO', '181', '6468', '0', '63');
INSERT INTO public.who_global_data_import VALUES (89065, '2020-09-23', 'UG', 'Uganda', 'AFRO', '244', '6712', '1', '64');
INSERT INTO public.who_global_data_import VALUES (89066, '2020-09-24', 'UG', 'Uganda', 'AFRO', '167', '6879', '5', '69');
INSERT INTO public.who_global_data_import VALUES (89067, '2020-09-25', 'UG', 'Uganda', 'AFRO', '185', '7064', '1', '70');
INSERT INTO public.who_global_data_import VALUES (89068, '2020-09-26', 'UG', 'Uganda', 'AFRO', '154', '7218', '1', '71');
INSERT INTO public.who_global_data_import VALUES (89069, '2020-09-27', 'UG', 'Uganda', 'AFRO', '146', '7364', '0', '71');
INSERT INTO public.who_global_data_import VALUES (89070, '2020-09-28', 'UG', 'Uganda', 'AFRO', '166', '7530', '2', '73');
INSERT INTO public.who_global_data_import VALUES (89071, '2020-09-29', 'UG', 'Uganda', 'AFRO', '247', '7777', '2', '75');
INSERT INTO public.who_global_data_import VALUES (89072, '2020-09-30', 'UG', 'Uganda', 'AFRO', '240', '8017', '0', '75');
INSERT INTO public.who_global_data_import VALUES (89073, '2020-10-01', 'UG', 'Uganda', 'AFRO', '112', '8129', '0', '75');
INSERT INTO public.who_global_data_import VALUES (89074, '2020-10-02', 'UG', 'Uganda', 'AFRO', '158', '8287', '0', '75');
INSERT INTO public.who_global_data_import VALUES (89075, '2020-10-03', 'UG', 'Uganda', 'AFRO', '204', '8491', '4', '79');
INSERT INTO public.who_global_data_import VALUES (89076, '2020-10-04', 'UG', 'Uganda', 'AFRO', '0', '8491', '0', '79');
INSERT INTO public.who_global_data_import VALUES (89077, '2020-10-05', 'UG', 'Uganda', 'AFRO', '317', '8808', '2', '81');
INSERT INTO public.who_global_data_import VALUES (89078, '2020-10-06', 'UG', 'Uganda', 'AFRO', '157', '8965', '1', '82');
INSERT INTO public.who_global_data_import VALUES (89079, '2020-10-07', 'UG', 'Uganda', 'AFRO', '117', '9082', '2', '84');
INSERT INTO public.who_global_data_import VALUES (89080, '2020-10-08', 'UG', 'Uganda', 'AFRO', '178', '9260', '1', '85');
INSERT INTO public.who_global_data_import VALUES (89081, '2020-10-09', 'UG', 'Uganda', 'AFRO', '182', '9442', '0', '85');
INSERT INTO public.who_global_data_import VALUES (89082, '2020-10-10', 'UG', 'Uganda', 'AFRO', '96', '9538', '1', '86');
INSERT INTO public.who_global_data_import VALUES (89083, '2020-10-11', 'UG', 'Uganda', 'AFRO', '0', '9538', '0', '86');
INSERT INTO public.who_global_data_import VALUES (89084, '2020-10-12', 'UG', 'Uganda', 'AFRO', '263', '9801', '7', '93');
INSERT INTO public.who_global_data_import VALUES (89085, '2020-10-13', 'UG', 'Uganda', 'AFRO', '63', '9864', '1', '94');
INSERT INTO public.who_global_data_import VALUES (89086, '2020-10-14', 'UG', 'Uganda', 'AFRO', '81', '9945', '1', '95');
INSERT INTO public.who_global_data_import VALUES (89087, '2020-10-15', 'UG', 'Uganda', 'AFRO', '124', '10069', '0', '95');
INSERT INTO public.who_global_data_import VALUES (89088, '2020-10-16', 'UG', 'Uganda', 'AFRO', '48', '10117', '1', '96');
INSERT INTO public.who_global_data_import VALUES (89089, '2020-10-17', 'UG', 'Uganda', 'AFRO', '217', '10334', '0', '96');
INSERT INTO public.who_global_data_import VALUES (89090, '2020-10-18', 'UG', 'Uganda', 'AFRO', '121', '10455', '0', '96');
INSERT INTO public.who_global_data_import VALUES (89091, '2020-10-19', 'UG', 'Uganda', 'AFRO', '135', '10590', '1', '97');
INSERT INTO public.who_global_data_import VALUES (89092, '2020-10-20', 'UG', 'Uganda', 'AFRO', '101', '10691', '0', '97');
INSERT INTO public.who_global_data_import VALUES (89093, '2020-10-21', 'UG', 'Uganda', 'AFRO', '97', '10788', '0', '97');
INSERT INTO public.who_global_data_import VALUES (89094, '2020-10-22', 'UG', 'Uganda', 'AFRO', '145', '10933', '1', '98');
INSERT INTO public.who_global_data_import VALUES (89095, '2020-10-23', 'UG', 'Uganda', 'AFRO', '108', '11041', '0', '98');
INSERT INTO public.who_global_data_import VALUES (89096, '2020-10-24', 'UG', 'Uganda', 'AFRO', '122', '11163', '1', '99');
INSERT INTO public.who_global_data_import VALUES (89097, '2020-10-25', 'UG', 'Uganda', 'AFRO', '134', '11297', '0', '99');
INSERT INTO public.who_global_data_import VALUES (89098, '2020-10-26', 'UG', 'Uganda', 'AFRO', '146', '11443', '2', '101');
INSERT INTO public.who_global_data_import VALUES (89099, '2020-10-27', 'UG', 'Uganda', 'AFRO', '114', '11557', '0', '101');
INSERT INTO public.who_global_data_import VALUES (89100, '2020-10-28', 'UG', 'Uganda', 'AFRO', '64', '11621', '2', '103');
INSERT INTO public.who_global_data_import VALUES (89101, '2020-10-29', 'UG', 'Uganda', 'AFRO', '146', '11767', '3', '106');
INSERT INTO public.who_global_data_import VALUES (89102, '2020-10-30', 'UG', 'Uganda', 'AFRO', '434', '12201', '2', '108');
INSERT INTO public.who_global_data_import VALUES (89103, '2020-10-31', 'UG', 'Uganda', 'AFRO', '209', '12410', '2', '110');
INSERT INTO public.who_global_data_import VALUES (89104, '2020-11-01', 'UG', 'Uganda', 'AFRO', '85', '12495', '1', '111');
INSERT INTO public.who_global_data_import VALUES (89105, '2020-11-02', 'UG', 'Uganda', 'AFRO', '248', '12743', '1', '112');
INSERT INTO public.who_global_data_import VALUES (89106, '2020-11-03', 'UG', 'Uganda', 'AFRO', '228', '12971', '2', '114');
INSERT INTO public.who_global_data_import VALUES (89107, '2020-11-04', 'UG', 'Uganda', 'AFRO', '128', '13099', '1', '115');
INSERT INTO public.who_global_data_import VALUES (89108, '2020-11-05', 'UG', 'Uganda', 'AFRO', '252', '13351', '2', '117');
INSERT INTO public.who_global_data_import VALUES (89109, '2020-11-06', 'UG', 'Uganda', 'AFRO', '217', '13568', '0', '117');
INSERT INTO public.who_global_data_import VALUES (89110, '2020-11-07', 'UG', 'Uganda', 'AFRO', '284', '13852', '14', '131');
INSERT INTO public.who_global_data_import VALUES (89111, '2020-11-08', 'UG', 'Uganda', 'AFRO', '214', '14066', '0', '131');
INSERT INTO public.who_global_data_import VALUES (89112, '2020-11-09', 'UG', 'Uganda', 'AFRO', '337', '14403', '1', '132');
INSERT INTO public.who_global_data_import VALUES (89113, '2020-11-10', 'UG', 'Uganda', 'AFRO', '171', '14574', '1', '133');
INSERT INTO public.who_global_data_import VALUES (89114, '2020-11-11', 'UG', 'Uganda', 'AFRO', '130', '14704', '0', '133');
INSERT INTO public.who_global_data_import VALUES (89115, '2020-11-12', 'UG', 'Uganda', 'AFRO', '289', '14993', '6', '139');
INSERT INTO public.who_global_data_import VALUES (89116, '2020-11-13', 'UG', 'Uganda', 'AFRO', '224', '15217', '4', '143');
INSERT INTO public.who_global_data_import VALUES (89117, '2020-11-14', 'UG', 'Uganda', 'AFRO', '185', '15402', '1', '144');
INSERT INTO public.who_global_data_import VALUES (89118, '2020-11-15', 'UG', 'Uganda', 'AFRO', '387', '15789', '0', '144');
INSERT INTO public.who_global_data_import VALUES (89119, '2020-11-16', 'UG', 'Uganda', 'AFRO', '231', '16020', '1', '145');
INSERT INTO public.who_global_data_import VALUES (89120, '2020-11-17', 'UG', 'Uganda', 'AFRO', '237', '16257', '5', '150');
INSERT INTO public.who_global_data_import VALUES (89121, '2020-11-18', 'UG', 'Uganda', 'AFRO', '306', '16563', '0', '150');
INSERT INTO public.who_global_data_import VALUES (89122, '2020-11-19', 'UG', 'Uganda', 'AFRO', '342', '16905', '7', '157');
INSERT INTO public.who_global_data_import VALUES (89123, '2020-11-20', 'UG', 'Uganda', 'AFRO', '243', '17148', '1', '158');
INSERT INTO public.who_global_data_import VALUES (89124, '2020-11-21', 'UG', 'Uganda', 'AFRO', '283', '17431', '10', '168');
INSERT INTO public.who_global_data_import VALUES (89125, '2020-11-22', 'UG', 'Uganda', 'AFRO', '236', '17667', '0', '168');
INSERT INTO public.who_global_data_import VALUES (89126, '2020-11-23', 'UG', 'Uganda', 'AFRO', '301', '17968', '4', '172');
INSERT INTO public.who_global_data_import VALUES (89127, '2020-11-24', 'UG', 'Uganda', 'AFRO', '197', '18165', '9', '181');
INSERT INTO public.who_global_data_import VALUES (89128, '2020-11-25', 'UG', 'Uganda', 'AFRO', '241', '18406', '5', '186');
INSERT INTO public.who_global_data_import VALUES (89129, '2020-11-26', 'UG', 'Uganda', 'AFRO', '484', '18890', '5', '191');
INSERT INTO public.who_global_data_import VALUES (89130, '2020-11-27', 'UG', 'Uganda', 'AFRO', '225', '19115', '0', '191');
INSERT INTO public.who_global_data_import VALUES (89131, '2020-11-28', 'UG', 'Uganda', 'AFRO', '473', '19588', '6', '197');
INSERT INTO public.who_global_data_import VALUES (89132, '2020-11-29', 'UG', 'Uganda', 'AFRO', '356', '19944', '4', '201');
INSERT INTO public.who_global_data_import VALUES (89133, '2020-11-30', 'UG', 'Uganda', 'AFRO', '201', '20145', '0', '201');
INSERT INTO public.who_global_data_import VALUES (89134, '2020-12-01', 'UG', 'Uganda', 'AFRO', '314', '20459', '4', '205');
INSERT INTO public.who_global_data_import VALUES (89135, '2020-12-02', 'UG', 'Uganda', 'AFRO', '576', '21035', '0', '205');
INSERT INTO public.who_global_data_import VALUES (89136, '2020-12-03', 'UG', 'Uganda', 'AFRO', '374', '21409', '1', '206');
INSERT INTO public.who_global_data_import VALUES (89137, '2020-12-04', 'UG', 'Uganda', 'AFRO', '203', '21612', '0', '206');
INSERT INTO public.who_global_data_import VALUES (89138, '2020-12-05', 'UG', 'Uganda', 'AFRO', '286', '21898', '0', '206');
INSERT INTO public.who_global_data_import VALUES (89139, '2020-12-06', 'UG', 'Uganda', 'AFRO', '290', '22188', '0', '206');
INSERT INTO public.who_global_data_import VALUES (89140, '2020-12-07', 'UG', 'Uganda', 'AFRO', '311', '22499', '0', '206');
INSERT INTO public.who_global_data_import VALUES (89141, '2020-12-08', 'UG', 'Uganda', 'AFRO', '701', '23200', '1', '207');
INSERT INTO public.who_global_data_import VALUES (89142, '2020-12-09', 'UG', 'Uganda', 'AFRO', '0', '23200', '0', '207');
INSERT INTO public.who_global_data_import VALUES (89143, '2020-12-10', 'UG', 'Uganda', 'AFRO', '1859', '25059', '0', '207');
INSERT INTO public.who_global_data_import VALUES (89144, '2020-12-11', 'UG', 'Uganda', 'AFRO', '671', '25730', '13', '220');
INSERT INTO public.who_global_data_import VALUES (89145, '2020-12-12', 'UG', 'Uganda', 'AFRO', '639', '26369', '0', '220');
INSERT INTO public.who_global_data_import VALUES (89146, '2020-12-13', 'UG', 'Uganda', 'AFRO', '702', '27071', '0', '220');
INSERT INTO public.who_global_data_import VALUES (89147, '2020-12-14', 'UG', 'Uganda', 'AFRO', '461', '27532', '1', '221');
INSERT INTO public.who_global_data_import VALUES (89148, '2020-12-15', 'UG', 'Uganda', 'AFRO', '234', '27766', '3', '224');
INSERT INTO public.who_global_data_import VALUES (89149, '2020-12-16', 'UG', 'Uganda', 'AFRO', '402', '28168', '1', '225');
INSERT INTO public.who_global_data_import VALUES (89150, '2020-12-17', 'UG', 'Uganda', 'AFRO', '565', '28733', '0', '225');
INSERT INTO public.who_global_data_import VALUES (89151, '2020-12-18', 'UG', 'Uganda', 'AFRO', '628', '29361', '3', '228');
INSERT INTO public.who_global_data_import VALUES (89152, '2020-12-19', 'UG', 'Uganda', 'AFRO', '710', '30071', '2', '230');
INSERT INTO public.who_global_data_import VALUES (89153, '2020-12-20', 'UG', 'Uganda', 'AFRO', '631', '30702', '0', '230');
INSERT INTO public.who_global_data_import VALUES (89154, '2020-12-21', 'UG', 'Uganda', 'AFRO', '485', '31187', '1', '231');
INSERT INTO public.who_global_data_import VALUES (89155, '2020-12-22', 'UG', 'Uganda', 'AFRO', '197', '31384', '7', '238');
INSERT INTO public.who_global_data_import VALUES (89156, '2020-12-23', 'UG', 'Uganda', 'AFRO', '526', '31910', '0', '238');
INSERT INTO public.who_global_data_import VALUES (89157, '2020-12-24', 'UG', 'Uganda', 'AFRO', '489', '32399', '7', '245');
INSERT INTO public.who_global_data_import VALUES (89158, '2020-12-25', 'UG', 'Uganda', 'AFRO', '515', '32914', '0', '245');
INSERT INTO public.who_global_data_import VALUES (89159, '2020-12-26', 'UG', 'Uganda', 'AFRO', '446', '33360', '0', '245');
INSERT INTO public.who_global_data_import VALUES (89160, '2020-12-27', 'UG', 'Uganda', 'AFRO', '203', '33563', '0', '245');
INSERT INTO public.who_global_data_import VALUES (89161, '2020-12-28', 'UG', 'Uganda', 'AFRO', '248', '33811', '3', '248');
INSERT INTO public.who_global_data_import VALUES (89162, '2020-12-29', 'UG', 'Uganda', 'AFRO', '0', '33811', '0', '248');
INSERT INTO public.who_global_data_import VALUES (89163, '2020-12-30', 'UG', 'Uganda', 'AFRO', '470', '34281', '0', '248');
INSERT INTO public.who_global_data_import VALUES (89164, '2020-12-31', 'UG', 'Uganda', 'AFRO', '396', '34677', '1', '249');
INSERT INTO public.who_global_data_import VALUES (89165, '2021-01-01', 'UG', 'Uganda', 'AFRO', '539', '35216', '2', '251');
INSERT INTO public.who_global_data_import VALUES (89166, '2021-01-02', 'UG', 'Uganda', 'AFRO', '0', '35216', '0', '251');
INSERT INTO public.who_global_data_import VALUES (89167, '2021-01-03', 'UG', 'Uganda', 'AFRO', '496', '35712', '23', '274');
INSERT INTO public.who_global_data_import VALUES (89168, '2021-01-04', 'UG', 'Uganda', 'AFRO', '210', '35922', '0', '274');
INSERT INTO public.who_global_data_import VALUES (89169, '2021-01-05', 'UG', 'Uganda', 'AFRO', '128', '36050', '0', '274');
INSERT INTO public.who_global_data_import VALUES (89170, '2021-01-06', 'UG', 'Uganda', 'AFRO', '0', '36050', '0', '274');
INSERT INTO public.who_global_data_import VALUES (89171, '2021-01-07', 'UG', 'Uganda', 'AFRO', '652', '36702', '20', '294');
INSERT INTO public.who_global_data_import VALUES (89172, '2021-01-08', 'UG', 'Uganda', 'AFRO', '372', '37074', '3', '297');
INSERT INTO public.who_global_data_import VALUES (89173, '2021-01-09', 'UG', 'Uganda', 'AFRO', '222', '37296', '3', '300');
INSERT INTO public.who_global_data_import VALUES (89174, '2021-01-10', 'UG', 'Uganda', 'AFRO', '258', '37554', '1', '301');
INSERT INTO public.who_global_data_import VALUES (89175, '2021-01-11', 'UG', 'Uganda', 'AFRO', '188', '37742', '0', '301');
INSERT INTO public.who_global_data_import VALUES (89176, '2021-01-12', 'UG', 'Uganda', 'AFRO', '66', '37808', '1', '302');
INSERT INTO public.who_global_data_import VALUES (89177, '2021-01-13', 'UG', 'Uganda', 'AFRO', '140', '37948', '1', '303');
INSERT INTO public.who_global_data_import VALUES (89178, '2021-01-14', 'UG', 'Uganda', 'AFRO', '137', '38085', '1', '304');
INSERT INTO public.who_global_data_import VALUES (89179, '2021-01-15', 'UG', 'Uganda', 'AFRO', '0', '38085', '0', '304');
INSERT INTO public.who_global_data_import VALUES (89180, '2021-01-16', 'UG', 'Uganda', 'AFRO', '0', '38085', '0', '304');
INSERT INTO public.who_global_data_import VALUES (89181, '2021-01-17', 'UG', 'Uganda', 'AFRO', '0', '38085', '0', '304');
INSERT INTO public.who_global_data_import VALUES (89182, '2021-01-18', 'UG', 'Uganda', 'AFRO', '0', '38085', '0', '304');
INSERT INTO public.who_global_data_import VALUES (89183, '2021-01-19', 'UG', 'Uganda', 'AFRO', '0', '38085', '0', '304');
INSERT INTO public.who_global_data_import VALUES (89184, '2021-01-20', 'UG', 'Uganda', 'AFRO', '449', '38534', '1', '305');
INSERT INTO public.who_global_data_import VALUES (89185, '2021-01-21', 'UG', 'Uganda', 'AFRO', '94', '38628', '0', '305');
INSERT INTO public.who_global_data_import VALUES (89186, '2021-01-22', 'UG', 'Uganda', 'AFRO', '178', '38806', '11', '316');
INSERT INTO public.who_global_data_import VALUES (89187, '2021-01-23', 'UG', 'Uganda', 'AFRO', '129', '38935', '1', '317');
INSERT INTO public.who_global_data_import VALUES (89188, '2021-01-24', 'UG', 'Uganda', 'AFRO', '109', '39044', '0', '317');
INSERT INTO public.who_global_data_import VALUES (89189, '2021-01-25', 'UG', 'Uganda', 'AFRO', '105', '39149', '0', '317');
INSERT INTO public.who_global_data_import VALUES (89190, '2021-01-26', 'UG', 'Uganda', 'AFRO', '39', '39188', '1', '318');
INSERT INTO public.who_global_data_import VALUES (89191, '2021-01-27', 'UG', 'Uganda', 'AFRO', '73', '39261', '0', '318');
INSERT INTO public.who_global_data_import VALUES (89192, '2021-01-28', 'UG', 'Uganda', 'AFRO', '53', '39314', '0', '318');
INSERT INTO public.who_global_data_import VALUES (89193, '2021-01-29', 'UG', 'Uganda', 'AFRO', '110', '39424', '0', '318');
INSERT INTO public.who_global_data_import VALUES (89194, '2021-01-30', 'UG', 'Uganda', 'AFRO', '66', '39490', '6', '324');
INSERT INTO public.who_global_data_import VALUES (89195, '2021-01-31', 'UG', 'Uganda', 'AFRO', '43', '39533', '0', '324');
INSERT INTO public.who_global_data_import VALUES (89196, '2021-02-01', 'UG', 'Uganda', 'AFRO', '46', '39579', '0', '324');
INSERT INTO public.who_global_data_import VALUES (89197, '2021-02-02', 'UG', 'Uganda', 'AFRO', '27', '39606', '1', '325');
INSERT INTO public.who_global_data_import VALUES (89198, '2021-02-03', 'UG', 'Uganda', 'AFRO', '45', '39651', '0', '325');
INSERT INTO public.who_global_data_import VALUES (89199, '2021-02-04', 'UG', 'Uganda', 'AFRO', '34', '39685', '2', '327');
INSERT INTO public.who_global_data_import VALUES (89200, '2021-02-05', 'UG', 'Uganda', 'AFRO', '50', '39735', '0', '327');
INSERT INTO public.who_global_data_import VALUES (89201, '2020-01-03', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89202, '2020-01-04', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89203, '2020-01-05', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89204, '2020-01-06', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89205, '2020-01-07', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89206, '2020-01-08', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89207, '2020-01-09', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89208, '2020-01-10', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89209, '2020-01-11', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89210, '2020-01-12', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89211, '2020-01-13', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89212, '2020-01-14', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89213, '2020-01-15', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89214, '2020-01-16', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89215, '2020-01-17', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89216, '2020-01-18', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89217, '2020-01-19', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89218, '2020-01-20', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89219, '2020-01-21', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89220, '2020-01-22', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89221, '2020-01-23', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89222, '2020-01-24', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89223, '2020-01-25', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89224, '2020-01-26', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89225, '2020-01-27', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89226, '2020-01-28', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89227, '2020-01-29', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89228, '2020-01-30', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89229, '2020-01-31', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89230, '2020-02-01', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89231, '2020-02-02', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89232, '2020-02-03', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89233, '2020-02-04', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89234, '2020-02-05', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89235, '2020-02-06', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89236, '2020-02-07', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89237, '2020-02-08', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89238, '2020-02-09', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89239, '2020-02-10', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89240, '2020-02-11', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89241, '2020-02-12', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89242, '2020-02-13', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89243, '2020-02-14', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89244, '2020-02-15', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89245, '2020-02-16', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89246, '2020-02-17', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89247, '2020-02-18', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89248, '2020-02-19', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89249, '2020-02-20', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89250, '2020-02-21', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89251, '2020-02-22', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89252, '2020-02-23', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89253, '2020-02-24', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89254, '2020-02-25', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89255, '2020-02-26', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89256, '2020-02-27', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89257, '2020-02-28', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89258, '2020-02-29', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89259, '2020-03-01', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89260, '2020-03-02', 'UA', 'Ukraine', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89261, '2020-03-03', 'UA', 'Ukraine', 'EURO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89262, '2020-03-04', 'UA', 'Ukraine', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89263, '2020-03-05', 'UA', 'Ukraine', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89264, '2020-03-06', 'UA', 'Ukraine', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89265, '2020-03-07', 'UA', 'Ukraine', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89266, '2020-03-08', 'UA', 'Ukraine', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89267, '2020-03-09', 'UA', 'Ukraine', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89268, '2020-03-10', 'UA', 'Ukraine', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89269, '2020-03-11', 'UA', 'Ukraine', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89270, '2020-03-12', 'UA', 'Ukraine', 'EURO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89271, '2020-03-13', 'UA', 'Ukraine', 'EURO', '2', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89272, '2020-03-14', 'UA', 'Ukraine', 'EURO', '0', '3', '1', '1');
INSERT INTO public.who_global_data_import VALUES (89273, '2020-03-15', 'UA', 'Ukraine', 'EURO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (89274, '2020-03-16', 'UA', 'Ukraine', 'EURO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (89275, '2020-03-17', 'UA', 'Ukraine', 'EURO', '0', '3', '0', '1');
INSERT INTO public.who_global_data_import VALUES (89276, '2020-03-18', 'UA', 'Ukraine', 'EURO', '11', '14', '1', '2');
INSERT INTO public.who_global_data_import VALUES (89277, '2020-03-19', 'UA', 'Ukraine', 'EURO', '2', '16', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89278, '2020-03-20', 'UA', 'Ukraine', 'EURO', '0', '16', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89279, '2020-03-21', 'UA', 'Ukraine', 'EURO', '31', '47', '1', '3');
INSERT INTO public.who_global_data_import VALUES (89280, '2020-03-22', 'UA', 'Ukraine', 'EURO', '0', '47', '0', '3');
INSERT INTO public.who_global_data_import VALUES (89281, '2020-03-23', 'UA', 'Ukraine', 'EURO', '26', '73', '0', '3');
INSERT INTO public.who_global_data_import VALUES (89282, '2020-03-24', 'UA', 'Ukraine', 'EURO', '11', '84', '0', '3');
INSERT INTO public.who_global_data_import VALUES (89283, '2020-03-25', 'UA', 'Ukraine', 'EURO', '29', '113', '1', '4');
INSERT INTO public.who_global_data_import VALUES (89284, '2020-03-26', 'UA', 'Ukraine', 'EURO', '43', '156', '1', '5');
INSERT INTO public.who_global_data_import VALUES (89285, '2020-03-27', 'UA', 'Ukraine', 'EURO', '62', '218', '0', '5');
INSERT INTO public.who_global_data_import VALUES (89286, '2020-03-28', 'UA', 'Ukraine', 'EURO', '93', '311', '3', '8');
INSERT INTO public.who_global_data_import VALUES (89287, '2020-03-29', 'UA', 'Ukraine', 'EURO', '107', '418', '1', '9');
INSERT INTO public.who_global_data_import VALUES (89288, '2020-03-30', 'UA', 'Ukraine', 'EURO', '62', '480', '2', '11');
INSERT INTO public.who_global_data_import VALUES (89289, '2020-03-31', 'UA', 'Ukraine', 'EURO', '69', '549', '2', '13');
INSERT INTO public.who_global_data_import VALUES (89290, '2020-04-01', 'UA', 'Ukraine', 'EURO', '120', '669', '4', '17');
INSERT INTO public.who_global_data_import VALUES (89291, '2020-04-02', 'UA', 'Ukraine', 'EURO', '135', '804', '3', '20');
INSERT INTO public.who_global_data_import VALUES (89292, '2020-04-03', 'UA', 'Ukraine', 'EURO', '183', '987', '3', '23');
INSERT INTO public.who_global_data_import VALUES (89293, '2020-04-04', 'UA', 'Ukraine', 'EURO', '109', '1096', '5', '28');
INSERT INTO public.who_global_data_import VALUES (89294, '2020-04-05', 'UA', 'Ukraine', 'EURO', '155', '1251', '4', '32');
INSERT INTO public.who_global_data_import VALUES (89295, '2020-04-06', 'UA', 'Ukraine', 'EURO', '68', '1319', '6', '38');
INSERT INTO public.who_global_data_import VALUES (89296, '2020-04-07', 'UA', 'Ukraine', 'EURO', '143', '1462', '7', '45');
INSERT INTO public.who_global_data_import VALUES (89297, '2020-04-08', 'UA', 'Ukraine', 'EURO', '206', '1668', '7', '52');
INSERT INTO public.who_global_data_import VALUES (89298, '2020-04-09', 'UA', 'Ukraine', 'EURO', '224', '1892', '5', '57');
INSERT INTO public.who_global_data_import VALUES (89299, '2020-04-10', 'UA', 'Ukraine', 'EURO', '311', '2203', '12', '69');
INSERT INTO public.who_global_data_import VALUES (89300, '2020-04-11', 'UA', 'Ukraine', 'EURO', '308', '2511', '4', '73');
INSERT INTO public.who_global_data_import VALUES (89301, '2020-04-12', 'UA', 'Ukraine', 'EURO', '266', '2777', '10', '83');
INSERT INTO public.who_global_data_import VALUES (89302, '2020-04-13', 'UA', 'Ukraine', 'EURO', '325', '3102', '10', '93');
INSERT INTO public.who_global_data_import VALUES (89303, '2020-04-14', 'UA', 'Ukraine', 'EURO', '270', '3372', '5', '98');
INSERT INTO public.who_global_data_import VALUES (89304, '2020-04-15', 'UA', 'Ukraine', 'EURO', '392', '3764', '10', '108');
INSERT INTO public.who_global_data_import VALUES (89305, '2020-04-16', 'UA', 'Ukraine', 'EURO', '398', '4162', '7', '115');
INSERT INTO public.who_global_data_import VALUES (89306, '2020-04-17', 'UA', 'Ukraine', 'EURO', '500', '4662', '10', '125');
INSERT INTO public.who_global_data_import VALUES (89307, '2020-04-18', 'UA', 'Ukraine', 'EURO', '444', '5106', '8', '133');
INSERT INTO public.who_global_data_import VALUES (89308, '2020-04-19', 'UA', 'Ukraine', 'EURO', '343', '5449', '8', '141');
INSERT INTO public.who_global_data_import VALUES (89309, '2020-04-20', 'UA', 'Ukraine', 'EURO', '261', '5710', '10', '151');
INSERT INTO public.who_global_data_import VALUES (89310, '2020-04-21', 'UA', 'Ukraine', 'EURO', '415', '6125', '10', '161');
INSERT INTO public.who_global_data_import VALUES (89311, '2020-04-22', 'UA', 'Ukraine', 'EURO', '467', '6592', '13', '174');
INSERT INTO public.who_global_data_import VALUES (89312, '2020-04-23', 'UA', 'Ukraine', 'EURO', '578', '7170', '13', '187');
INSERT INTO public.who_global_data_import VALUES (89313, '2020-04-24', 'UA', 'Ukraine', 'EURO', '477', '7647', '6', '193');
INSERT INTO public.who_global_data_import VALUES (89314, '2020-04-25', 'UA', 'Ukraine', 'EURO', '478', '8125', '8', '201');
INSERT INTO public.who_global_data_import VALUES (89315, '2020-04-26', 'UA', 'Ukraine', 'EURO', '492', '8617', '8', '209');
INSERT INTO public.who_global_data_import VALUES (89316, '2020-04-27', 'UA', 'Ukraine', 'EURO', '392', '9009', '11', '220');
INSERT INTO public.who_global_data_import VALUES (89317, '2020-04-28', 'UA', 'Ukraine', 'EURO', '401', '9410', '19', '239');
INSERT INTO public.who_global_data_import VALUES (89318, '2020-04-29', 'UA', 'Ukraine', 'EURO', '456', '9866', '11', '250');
INSERT INTO public.who_global_data_import VALUES (89319, '2020-04-30', 'UA', 'Ukraine', 'EURO', '540', '10406', '11', '261');
INSERT INTO public.who_global_data_import VALUES (89320, '2020-05-01', 'UA', 'Ukraine', 'EURO', '455', '10861', '11', '272');
INSERT INTO public.who_global_data_import VALUES (89321, '2020-05-02', 'UA', 'Ukraine', 'EURO', '550', '11411', '7', '279');
INSERT INTO public.who_global_data_import VALUES (89322, '2020-05-03', 'UA', 'Ukraine', 'EURO', '502', '11913', '9', '288');
INSERT INTO public.who_global_data_import VALUES (89323, '2020-05-04', 'UA', 'Ukraine', 'EURO', '418', '12331', '15', '303');
INSERT INTO public.who_global_data_import VALUES (89324, '2020-05-05', 'UA', 'Ukraine', 'EURO', '366', '12697', '13', '316');
INSERT INTO public.who_global_data_import VALUES (89325, '2020-05-06', 'UA', 'Ukraine', 'EURO', '487', '13184', '11', '327');
INSERT INTO public.who_global_data_import VALUES (89326, '2020-05-07', 'UA', 'Ukraine', 'EURO', '507', '13691', '13', '340');
INSERT INTO public.who_global_data_import VALUES (89327, '2020-05-08', 'UA', 'Ukraine', 'EURO', '504', '14195', '21', '361');
INSERT INTO public.who_global_data_import VALUES (89328, '2020-05-09', 'UA', 'Ukraine', 'EURO', '515', '14710', '15', '376');
INSERT INTO public.who_global_data_import VALUES (89329, '2020-05-10', 'UA', 'Ukraine', 'EURO', '522', '15232', '15', '391');
INSERT INTO public.who_global_data_import VALUES (89330, '2020-05-11', 'UA', 'Ukraine', 'EURO', '416', '15648', '17', '408');
INSERT INTO public.who_global_data_import VALUES (89331, '2020-05-12', 'UA', 'Ukraine', 'EURO', '375', '16023', '17', '425');
INSERT INTO public.who_global_data_import VALUES (89332, '2020-05-13', 'UA', 'Ukraine', 'EURO', '402', '16425', '14', '439');
INSERT INTO public.who_global_data_import VALUES (89333, '2020-05-14', 'UA', 'Ukraine', 'EURO', '422', '16847', '17', '456');
INSERT INTO public.who_global_data_import VALUES (89334, '2020-05-15', 'UA', 'Ukraine', 'EURO', '483', '17330', '20', '476');
INSERT INTO public.who_global_data_import VALUES (89335, '2020-05-16', 'UA', 'Ukraine', 'EURO', '528', '17858', '21', '497');
INSERT INTO public.who_global_data_import VALUES (89336, '2020-05-17', 'UA', 'Ukraine', 'EURO', '433', '18291', '17', '514');
INSERT INTO public.who_global_data_import VALUES (89337, '2020-05-18', 'UA', 'Ukraine', 'EURO', '325', '18616', '21', '535');
INSERT INTO public.who_global_data_import VALUES (89338, '2020-05-19', 'UA', 'Ukraine', 'EURO', '260', '18876', '13', '548');
INSERT INTO public.who_global_data_import VALUES (89339, '2020-05-20', 'UA', 'Ukraine', 'EURO', '354', '19230', '16', '564');
INSERT INTO public.who_global_data_import VALUES (89340, '2020-05-21', 'UA', 'Ukraine', 'EURO', '476', '19706', '15', '579');
INSERT INTO public.who_global_data_import VALUES (89341, '2020-05-22', 'UA', 'Ukraine', 'EURO', '442', '20148', '9', '588');
INSERT INTO public.who_global_data_import VALUES (89342, '2020-05-23', 'UA', 'Ukraine', 'EURO', '432', '20580', '17', '605');
INSERT INTO public.who_global_data_import VALUES (89343, '2020-05-24', 'UA', 'Ukraine', 'EURO', '406', '20986', '12', '617');
INSERT INTO public.who_global_data_import VALUES (89344, '2020-05-25', 'UA', 'Ukraine', 'EURO', '259', '21245', '6', '623');
INSERT INTO public.who_global_data_import VALUES (89345, '2020-05-26', 'UA', 'Ukraine', 'EURO', '339', '21584', '21', '644');
INSERT INTO public.who_global_data_import VALUES (89346, '2020-05-27', 'UA', 'Ukraine', 'EURO', '321', '21905', '14', '658');
INSERT INTO public.who_global_data_import VALUES (89347, '2020-05-28', 'UA', 'Ukraine', 'EURO', '477', '22382', '11', '669');
INSERT INTO public.who_global_data_import VALUES (89348, '2020-05-29', 'UA', 'Ukraine', 'EURO', '429', '22811', '10', '679');
INSERT INTO public.who_global_data_import VALUES (89349, '2020-05-30', 'UA', 'Ukraine', 'EURO', '393', '23204', '17', '696');
INSERT INTO public.who_global_data_import VALUES (89350, '2020-05-31', 'UA', 'Ukraine', 'EURO', '468', '23672', '12', '708');
INSERT INTO public.who_global_data_import VALUES (89351, '2020-06-01', 'UA', 'Ukraine', 'EURO', '340', '24012', '10', '718');
INSERT INTO public.who_global_data_import VALUES (89352, '2020-06-02', 'UA', 'Ukraine', 'EURO', '328', '24340', '9', '727');
INSERT INTO public.who_global_data_import VALUES (89353, '2020-06-03', 'UA', 'Ukraine', 'EURO', '483', '24823', '8', '735');
INSERT INTO public.who_global_data_import VALUES (89354, '2020-06-04', 'UA', 'Ukraine', 'EURO', '588', '25411', '13', '748');
INSERT INTO public.who_global_data_import VALUES (89355, '2020-06-05', 'UA', 'Ukraine', 'EURO', '553', '25964', '14', '762');
INSERT INTO public.who_global_data_import VALUES (89356, '2020-06-06', 'UA', 'Ukraine', 'EURO', '550', '26514', '15', '777');
INSERT INTO public.who_global_data_import VALUES (89357, '2020-06-07', 'UA', 'Ukraine', 'EURO', '485', '26999', '11', '788');
INSERT INTO public.who_global_data_import VALUES (89358, '2020-06-08', 'UA', 'Ukraine', 'EURO', '463', '27462', '9', '797');
INSERT INTO public.who_global_data_import VALUES (89359, '2020-06-09', 'UA', 'Ukraine', 'EURO', '394', '27856', '13', '810');
INSERT INTO public.who_global_data_import VALUES (89360, '2020-06-10', 'UA', 'Ukraine', 'EURO', '525', '28381', '23', '833');
INSERT INTO public.who_global_data_import VALUES (89361, '2020-06-11', 'UA', 'Ukraine', 'EURO', '689', '29070', '21', '854');
INSERT INTO public.who_global_data_import VALUES (89362, '2020-06-12', 'UA', 'Ukraine', 'EURO', '683', '29753', '16', '870');
INSERT INTO public.who_global_data_import VALUES (89363, '2020-06-13', 'UA', 'Ukraine', 'EURO', '753', '30506', '10', '880');
INSERT INTO public.who_global_data_import VALUES (89364, '2020-06-14', 'UA', 'Ukraine', 'EURO', '648', '31154', '9', '889');
INSERT INTO public.who_global_data_import VALUES (89365, '2020-06-15', 'UA', 'Ukraine', 'EURO', '656', '31810', '12', '901');
INSERT INTO public.who_global_data_import VALUES (89366, '2020-06-16', 'UA', 'Ukraine', 'EURO', '666', '32476', '12', '913');
INSERT INTO public.who_global_data_import VALUES (89367, '2020-06-17', 'UA', 'Ukraine', 'EURO', '758', '33234', '30', '943');
INSERT INTO public.who_global_data_import VALUES (89368, '2020-06-18', 'UA', 'Ukraine', 'EURO', '829', '34063', '23', '966');
INSERT INTO public.who_global_data_import VALUES (89369, '2020-06-19', 'UA', 'Ukraine', 'EURO', '921', '34984', '19', '985');
INSERT INTO public.who_global_data_import VALUES (89370, '2020-06-20', 'UA', 'Ukraine', 'EURO', '841', '35825', '9', '994');
INSERT INTO public.who_global_data_import VALUES (89371, '2020-06-21', 'UA', 'Ukraine', 'EURO', '735', '36560', '8', '1002');
INSERT INTO public.who_global_data_import VALUES (89372, '2020-06-22', 'UA', 'Ukraine', 'EURO', '681', '37241', '10', '1012');
INSERT INTO public.who_global_data_import VALUES (89373, '2020-06-23', 'UA', 'Ukraine', 'EURO', '833', '38074', '23', '1035');
INSERT INTO public.who_global_data_import VALUES (89374, '2020-06-24', 'UA', 'Ukraine', 'EURO', '940', '39014', '16', '1051');
INSERT INTO public.who_global_data_import VALUES (89375, '2020-06-25', 'UA', 'Ukraine', 'EURO', '994', '40008', '16', '1067');
INSERT INTO public.who_global_data_import VALUES (89376, '2020-06-26', 'UA', 'Ukraine', 'EURO', '1109', '41117', '19', '1086');
INSERT INTO public.who_global_data_import VALUES (89377, '2020-06-27', 'UA', 'Ukraine', 'EURO', '948', '42065', '24', '1110');
INSERT INTO public.who_global_data_import VALUES (89378, '2020-06-28', 'UA', 'Ukraine', 'EURO', '917', '42982', '19', '1129');
INSERT INTO public.who_global_data_import VALUES (89379, '2020-06-29', 'UA', 'Ukraine', 'EURO', '646', '43628', '18', '1147');
INSERT INTO public.who_global_data_import VALUES (89380, '2020-06-30', 'UA', 'Ukraine', 'EURO', '706', '44334', '12', '1159');
INSERT INTO public.who_global_data_import VALUES (89381, '2020-07-01', 'UA', 'Ukraine', 'EURO', '664', '44998', '14', '1173');
INSERT INTO public.who_global_data_import VALUES (89382, '2020-07-02', 'UA', 'Ukraine', 'EURO', '890', '45888', '12', '1185');
INSERT INTO public.who_global_data_import VALUES (89383, '2020-07-03', 'UA', 'Ukraine', 'EURO', '875', '46763', '27', '1212');
INSERT INTO public.who_global_data_import VALUES (89384, '2020-07-04', 'UA', 'Ukraine', 'EURO', '914', '47677', '15', '1227');
INSERT INTO public.who_global_data_import VALUES (89385, '2020-07-05', 'UA', 'Ukraine', 'EURO', '823', '48500', '22', '1249');
INSERT INTO public.who_global_data_import VALUES (89386, '2020-07-06', 'UA', 'Ukraine', 'EURO', '543', '49043', '13', '1262');
INSERT INTO public.who_global_data_import VALUES (89387, '2020-07-07', 'UA', 'Ukraine', 'EURO', '564', '49607', '21', '1283');
INSERT INTO public.who_global_data_import VALUES (89388, '2020-07-08', 'UA', 'Ukraine', 'EURO', '807', '50414', '24', '1307');
INSERT INTO public.who_global_data_import VALUES (89389, '2020-07-09', 'UA', 'Ukraine', 'EURO', '810', '51224', '20', '1327');
INSERT INTO public.who_global_data_import VALUES (89390, '2020-07-10', 'UA', 'Ukraine', 'EURO', '819', '52043', '18', '1345');
INSERT INTO public.who_global_data_import VALUES (89391, '2020-07-11', 'UA', 'Ukraine', 'EURO', '800', '52843', '27', '1372');
INSERT INTO public.who_global_data_import VALUES (89392, '2020-07-12', 'UA', 'Ukraine', 'EURO', '678', '53521', '11', '1383');
INSERT INTO public.who_global_data_import VALUES (89393, '2020-07-13', 'UA', 'Ukraine', 'EURO', '612', '54133', '15', '1398');
INSERT INTO public.who_global_data_import VALUES (89394, '2020-07-14', 'UA', 'Ukraine', 'EURO', '638', '54771', '14', '1412');
INSERT INTO public.who_global_data_import VALUES (89395, '2020-07-15', 'UA', 'Ukraine', 'EURO', '836', '55607', '15', '1427');
INSERT INTO public.who_global_data_import VALUES (89396, '2020-07-16', 'UA', 'Ukraine', 'EURO', '848', '56455', '18', '1445');
INSERT INTO public.who_global_data_import VALUES (89397, '2020-07-17', 'UA', 'Ukraine', 'EURO', '809', '57264', '11', '1456');
INSERT INTO public.who_global_data_import VALUES (89398, '2020-07-18', 'UA', 'Ukraine', 'EURO', '847', '58111', '21', '1477');
INSERT INTO public.who_global_data_import VALUES (89399, '2020-07-19', 'UA', 'Ukraine', 'EURO', '731', '58842', '8', '1485');
INSERT INTO public.who_global_data_import VALUES (89400, '2020-07-20', 'UA', 'Ukraine', 'EURO', '651', '59493', '13', '1498');
INSERT INTO public.who_global_data_import VALUES (89401, '2020-07-21', 'UA', 'Ukraine', 'EURO', '673', '60166', '20', '1518');
INSERT INTO public.who_global_data_import VALUES (89402, '2020-07-22', 'UA', 'Ukraine', 'EURO', '829', '60995', '16', '1534');
INSERT INTO public.who_global_data_import VALUES (89403, '2020-07-23', 'UA', 'Ukraine', 'EURO', '856', '61851', '17', '1551');
INSERT INTO public.who_global_data_import VALUES (89404, '2020-07-24', 'UA', 'Ukraine', 'EURO', '972', '62823', '20', '1571');
INSERT INTO public.who_global_data_import VALUES (89405, '2020-07-25', 'UA', 'Ukraine', 'EURO', '1106', '63929', '19', '1590');
INSERT INTO public.who_global_data_import VALUES (89406, '2020-07-26', 'UA', 'Ukraine', 'EURO', '920', '64849', '15', '1605');
INSERT INTO public.who_global_data_import VALUES (89407, '2020-07-27', 'UA', 'Ukraine', 'EURO', '807', '65656', '11', '1616');
INSERT INTO public.who_global_data_import VALUES (89408, '2020-07-28', 'UA', 'Ukraine', 'EURO', '919', '66575', '13', '1629');
INSERT INTO public.who_global_data_import VALUES (89409, '2020-07-29', 'UA', 'Ukraine', 'EURO', '1022', '67597', '21', '1650');
INSERT INTO public.who_global_data_import VALUES (89410, '2020-07-30', 'UA', 'Ukraine', 'EURO', '1197', '68794', '23', '1673');
INSERT INTO public.who_global_data_import VALUES (89411, '2020-07-31', 'UA', 'Ukraine', 'EURO', '1090', '69884', '20', '1693');
INSERT INTO public.who_global_data_import VALUES (89412, '2020-08-01', 'UA', 'Ukraine', 'EURO', '1172', '71056', '16', '1709');
INSERT INTO public.who_global_data_import VALUES (89413, '2020-08-02', 'UA', 'Ukraine', 'EURO', '1112', '72168', '16', '1725');
INSERT INTO public.who_global_data_import VALUES (89414, '2020-08-03', 'UA', 'Ukraine', 'EURO', '990', '73158', '13', '1738');
INSERT INTO public.who_global_data_import VALUES (89415, '2020-08-04', 'UA', 'Ukraine', 'EURO', '1061', '74219', '26', '1764');
INSERT INTO public.who_global_data_import VALUES (89416, '2020-08-05', 'UA', 'Ukraine', 'EURO', '1271', '75490', '24', '1788');
INSERT INTO public.who_global_data_import VALUES (89417, '2020-08-06', 'UA', 'Ukraine', 'EURO', '1318', '76808', '31', '1819');
INSERT INTO public.who_global_data_import VALUES (89418, '2020-08-07', 'UA', 'Ukraine', 'EURO', '1453', '78261', '33', '1852');
INSERT INTO public.who_global_data_import VALUES (89419, '2020-08-08', 'UA', 'Ukraine', 'EURO', '1489', '79750', '27', '1879');
INSERT INTO public.who_global_data_import VALUES (89420, '2020-08-09', 'UA', 'Ukraine', 'EURO', '1199', '80949', '18', '1897');
INSERT INTO public.who_global_data_import VALUES (89421, '2020-08-10', 'UA', 'Ukraine', 'EURO', '1008', '81957', '25', '1922');
INSERT INTO public.who_global_data_import VALUES (89422, '2020-08-11', 'UA', 'Ukraine', 'EURO', '1158', '83115', '29', '1951');
INSERT INTO public.who_global_data_import VALUES (89423, '2020-08-12', 'UA', 'Ukraine', 'EURO', '1433', '84548', '19', '1970');
INSERT INTO public.who_global_data_import VALUES (89424, '2020-08-13', 'UA', 'Ukraine', 'EURO', '1592', '86140', '22', '1992');
INSERT INTO public.who_global_data_import VALUES (89425, '2020-08-14', 'UA', 'Ukraine', 'EURO', '1732', '87872', '19', '2011');
INSERT INTO public.who_global_data_import VALUES (89426, '2020-08-15', 'UA', 'Ukraine', 'EURO', '1847', '89719', '33', '2044');
INSERT INTO public.who_global_data_import VALUES (89427, '2020-08-16', 'UA', 'Ukraine', 'EURO', '1637', '91356', '26', '2070');
INSERT INTO public.who_global_data_import VALUES (89428, '2020-08-17', 'UA', 'Ukraine', 'EURO', '1464', '92820', '19', '2089');
INSERT INTO public.who_global_data_import VALUES (89429, '2020-08-18', 'UA', 'Ukraine', 'EURO', '1616', '94436', '27', '2116');
INSERT INTO public.who_global_data_import VALUES (89430, '2020-08-19', 'UA', 'Ukraine', 'EURO', '1967', '96403', '28', '2144');
INSERT INTO public.who_global_data_import VALUES (89431, '2020-08-20', 'UA', 'Ukraine', 'EURO', '2134', '98537', '40', '2184');
INSERT INTO public.who_global_data_import VALUES (89432, '2020-08-21', 'UA', 'Ukraine', 'EURO', '2106', '100643', '23', '2207');
INSERT INTO public.who_global_data_import VALUES (89433, '2020-08-22', 'UA', 'Ukraine', 'EURO', '2328', '102971', '37', '2244');
INSERT INTO public.who_global_data_import VALUES (89434, '2020-08-23', 'UA', 'Ukraine', 'EURO', '1987', '104958', '27', '2271');
INSERT INTO public.who_global_data_import VALUES (89435, '2020-08-24', 'UA', 'Ukraine', 'EURO', '1799', '106757', '22', '2293');
INSERT INTO public.who_global_data_import VALUES (89436, '2020-08-25', 'UA', 'Ukraine', 'EURO', '1658', '108415', '25', '2318');
INSERT INTO public.who_global_data_import VALUES (89437, '2020-08-26', 'UA', 'Ukraine', 'EURO', '1670', '110085', '36', '2354');
INSERT INTO public.who_global_data_import VALUES (89438, '2020-08-27', 'UA', 'Ukraine', 'EURO', '1974', '112059', '49', '2403');
INSERT INTO public.who_global_data_import VALUES (89439, '2020-08-28', 'UA', 'Ukraine', 'EURO', '2438', '114497', '48', '2451');
INSERT INTO public.who_global_data_import VALUES (89440, '2020-08-29', 'UA', 'Ukraine', 'EURO', '2481', '116978', '41', '2492');
INSERT INTO public.who_global_data_import VALUES (89441, '2020-08-30', 'UA', 'Ukraine', 'EURO', '2096', '119074', '35', '2527');
INSERT INTO public.who_global_data_import VALUES (89442, '2020-08-31', 'UA', 'Ukraine', 'EURO', '2141', '121215', '30', '2557');
INSERT INTO public.who_global_data_import VALUES (89443, '2020-09-01', 'UA', 'Ukraine', 'EURO', '2088', '123303', '48', '2605');
INSERT INTO public.who_global_data_import VALUES (89444, '2020-09-02', 'UA', 'Ukraine', 'EURO', '2495', '125798', '51', '2656');
INSERT INTO public.who_global_data_import VALUES (89445, '2020-09-03', 'UA', 'Ukraine', 'EURO', '2430', '128228', '54', '2710');
INSERT INTO public.who_global_data_import VALUES (89446, '2020-09-04', 'UA', 'Ukraine', 'EURO', '2723', '130951', '51', '2761');
INSERT INTO public.who_global_data_import VALUES (89447, '2020-09-05', 'UA', 'Ukraine', 'EURO', '2836', '133787', '50', '2811');
INSERT INTO public.who_global_data_import VALUES (89448, '2020-09-06', 'UA', 'Ukraine', 'EURO', '2107', '135894', '35', '2846');
INSERT INTO public.who_global_data_import VALUES (89449, '2020-09-07', 'UA', 'Ukraine', 'EURO', '2174', '138068', '31', '2877');
INSERT INTO public.who_global_data_import VALUES (89450, '2020-09-08', 'UA', 'Ukraine', 'EURO', '2411', '140479', '57', '2934');
INSERT INTO public.who_global_data_import VALUES (89451, '2020-09-09', 'UA', 'Ukraine', 'EURO', '2551', '143030', '45', '2979');
INSERT INTO public.who_global_data_import VALUES (89452, '2020-09-10', 'UA', 'Ukraine', 'EURO', '2582', '145612', '44', '3023');
INSERT INTO public.who_global_data_import VALUES (89453, '2020-09-11', 'UA', 'Ukraine', 'EURO', '3144', '148756', '53', '3076');
INSERT INTO public.who_global_data_import VALUES (89454, '2020-09-12', 'UA', 'Ukraine', 'EURO', '3103', '151859', '72', '3148');
INSERT INTO public.who_global_data_import VALUES (89455, '2020-09-13', 'UA', 'Ukraine', 'EURO', '2476', '154335', '30', '3178');
INSERT INTO public.who_global_data_import VALUES (89456, '2020-09-14', 'UA', 'Ukraine', 'EURO', '2462', '156797', '33', '3211');
INSERT INTO public.who_global_data_import VALUES (89457, '2020-09-15', 'UA', 'Ukraine', 'EURO', '2905', '159702', '53', '3264');
INSERT INTO public.who_global_data_import VALUES (89458, '2020-09-16', 'UA', 'Ukraine', 'EURO', '2958', '162660', '76', '3340');
INSERT INTO public.who_global_data_import VALUES (89459, '2020-09-17', 'UA', 'Ukraine', 'EURO', '3584', '166244', '60', '3400');
INSERT INTO public.who_global_data_import VALUES (89460, '2020-09-18', 'UA', 'Ukraine', 'EURO', '3228', '169472', '68', '3468');
INSERT INTO public.who_global_data_import VALUES (89461, '2020-09-19', 'UA', 'Ukraine', 'EURO', '3240', '172712', '48', '3516');
INSERT INTO public.who_global_data_import VALUES (89462, '2020-09-20', 'UA', 'Ukraine', 'EURO', '2966', '175678', '41', '3557');
INSERT INTO public.who_global_data_import VALUES (89463, '2020-09-21', 'UA', 'Ukraine', 'EURO', '2675', '178353', '26', '3583');
INSERT INTO public.who_global_data_import VALUES (89464, '2020-09-22', 'UA', 'Ukraine', 'EURO', '2884', '181237', '59', '3642');
INSERT INTO public.who_global_data_import VALUES (89465, '2020-09-23', 'UA', 'Ukraine', 'EURO', '3497', '184734', '63', '3705');
INSERT INTO public.who_global_data_import VALUES (89466, '2020-09-24', 'UA', 'Ukraine', 'EURO', '3372', '188106', '52', '3757');
INSERT INTO public.who_global_data_import VALUES (89467, '2020-09-25', 'UA', 'Ukraine', 'EURO', '3565', '191671', '70', '3827');
INSERT INTO public.who_global_data_import VALUES (89468, '2020-09-26', 'UA', 'Ukraine', 'EURO', '3833', '195504', '76', '3903');
INSERT INTO public.who_global_data_import VALUES (89469, '2020-09-27', 'UA', 'Ukraine', 'EURO', '3130', '198634', '56', '3959');
INSERT INTO public.who_global_data_import VALUES (89470, '2020-09-28', 'UA', 'Ukraine', 'EURO', '2671', '201305', '37', '3996');
INSERT INTO public.who_global_data_import VALUES (89471, '2020-09-29', 'UA', 'Ukraine', 'EURO', '3627', '204932', '69', '4065');
INSERT INTO public.who_global_data_import VALUES (89472, '2020-09-30', 'UA', 'Ukraine', 'EURO', '4027', '208959', '64', '4129');
INSERT INTO public.who_global_data_import VALUES (89473, '2020-10-01', 'UA', 'Ukraine', 'EURO', '4069', '213028', '64', '4193');
INSERT INTO public.who_global_data_import VALUES (89474, '2020-10-02', 'UA', 'Ukraine', 'EURO', '4633', '217661', '68', '4261');
INSERT INTO public.who_global_data_import VALUES (89475, '2020-10-03', 'UA', 'Ukraine', 'EURO', '4661', '222322', '92', '4353');
INSERT INTO public.who_global_data_import VALUES (89476, '2020-10-04', 'UA', 'Ukraine', 'EURO', '4140', '226462', '44', '4397');
INSERT INTO public.who_global_data_import VALUES (89477, '2020-10-05', 'UA', 'Ukraine', 'EURO', '3774', '230236', '33', '4430');
INSERT INTO public.who_global_data_import VALUES (89478, '2020-10-06', 'UA', 'Ukraine', 'EURO', '4348', '234584', '90', '4520');
INSERT INTO public.who_global_data_import VALUES (89479, '2020-10-07', 'UA', 'Ukraine', 'EURO', '4753', '239337', '77', '4597');
INSERT INTO public.who_global_data_import VALUES (89480, '2020-10-08', 'UA', 'Ukraine', 'EURO', '5397', '244734', '93', '4690');
INSERT INTO public.who_global_data_import VALUES (89481, '2020-10-09', 'UA', 'Ukraine', 'EURO', '5804', '250538', '89', '4779');
INSERT INTO public.who_global_data_import VALUES (89482, '2020-10-10', 'UA', 'Ukraine', 'EURO', '5728', '256266', '108', '4887');
INSERT INTO public.who_global_data_import VALUES (89483, '2020-10-11', 'UA', 'Ukraine', 'EURO', '4768', '261034', '85', '4972');
INSERT INTO public.who_global_data_import VALUES (89484, '2020-10-12', 'UA', 'Ukraine', 'EURO', '4420', '265454', '43', '5015');
INSERT INTO public.who_global_data_import VALUES (89485, '2020-10-13', 'UA', 'Ukraine', 'EURO', '5133', '270587', '107', '5122');
INSERT INTO public.who_global_data_import VALUES (89486, '2020-10-14', 'UA', 'Ukraine', 'EURO', '5590', '276177', '107', '5229');
INSERT INTO public.who_global_data_import VALUES (89487, '2020-10-15', 'UA', 'Ukraine', 'EURO', '5062', '281239', '73', '5302');
INSERT INTO public.who_global_data_import VALUES (89488, '2020-10-16', 'UA', 'Ukraine', 'EURO', '5992', '287231', '106', '5408');
INSERT INTO public.who_global_data_import VALUES (89489, '2020-10-17', 'UA', 'Ukraine', 'EURO', '6410', '293641', '109', '5517');
INSERT INTO public.who_global_data_import VALUES (89490, '2020-10-18', 'UA', 'Ukraine', 'EURO', '5231', '298872', '90', '5607');
INSERT INTO public.who_global_data_import VALUES (89491, '2020-10-19', 'UA', 'Ukraine', 'EURO', '4766', '303638', '66', '5673');
INSERT INTO public.who_global_data_import VALUES (89492, '2020-10-20', 'UA', 'Ukraine', 'EURO', '5469', '309107', '113', '5786');
INSERT INTO public.who_global_data_import VALUES (89493, '2020-10-21', 'UA', 'Ukraine', 'EURO', '6719', '315826', '141', '5927');
INSERT INTO public.who_global_data_import VALUES (89494, '2020-10-22', 'UA', 'Ukraine', 'EURO', '7053', '322879', '116', '6043');
INSERT INTO public.who_global_data_import VALUES (89495, '2020-10-23', 'UA', 'Ukraine', 'EURO', '7517', '330396', '121', '6164');
INSERT INTO public.who_global_data_import VALUES (89496, '2020-10-24', 'UA', 'Ukraine', 'EURO', '7014', '337410', '125', '6289');
INSERT INTO public.who_global_data_import VALUES (89497, '2020-10-25', 'UA', 'Ukraine', 'EURO', '6088', '343498', '102', '6391');
INSERT INTO public.who_global_data_import VALUES (89498, '2020-10-26', 'UA', 'Ukraine', 'EURO', '5426', '348924', '73', '6464');
INSERT INTO public.who_global_data_import VALUES (89499, '2020-10-27', 'UA', 'Ukraine', 'EURO', '6677', '355601', '126', '6590');
INSERT INTO public.who_global_data_import VALUES (89500, '2020-10-28', 'UA', 'Ukraine', 'EURO', '7474', '363075', '165', '6755');
INSERT INTO public.who_global_data_import VALUES (89501, '2020-10-29', 'UA', 'Ukraine', 'EURO', '7342', '370417', '113', '6868');
INSERT INTO public.who_global_data_import VALUES (89502, '2020-10-30', 'UA', 'Ukraine', 'EURO', '8312', '378729', '173', '7041');
INSERT INTO public.who_global_data_import VALUES (89503, '2020-10-31', 'UA', 'Ukraine', 'EURO', '8752', '387481', '155', '7196');
INSERT INTO public.who_global_data_import VALUES (89504, '2020-11-01', 'UA', 'Ukraine', 'EURO', '7959', '395440', '110', '7306');
INSERT INTO public.who_global_data_import VALUES (89505, '2020-11-02', 'UA', 'Ukraine', 'EURO', '6754', '402194', '69', '7375');
INSERT INTO public.who_global_data_import VALUES (89506, '2020-11-03', 'UA', 'Ukraine', 'EURO', '8899', '411093', '157', '7532');
INSERT INTO public.who_global_data_import VALUES (89507, '2020-11-04', 'UA', 'Ukraine', 'EURO', '9524', '420617', '199', '7731');
INSERT INTO public.who_global_data_import VALUES (89508, '2020-11-05', 'UA', 'Ukraine', 'EURO', '9850', '430467', '193', '7924');
INSERT INTO public.who_global_data_import VALUES (89509, '2020-11-06', 'UA', 'Ukraine', 'EURO', '9721', '440188', '202', '8126');
INSERT INTO public.who_global_data_import VALUES (89510, '2020-11-07', 'UA', 'Ukraine', 'EURO', '10746', '450934', '186', '8312');
INSERT INTO public.who_global_data_import VALUES (89511, '2020-11-08', 'UA', 'Ukraine', 'EURO', '9397', '460331', '138', '8450');
INSERT INTO public.who_global_data_import VALUES (89512, '2020-11-09', 'UA', 'Ukraine', 'EURO', '8687', '469018', '115', '8565');
INSERT INTO public.who_global_data_import VALUES (89513, '2020-11-10', 'UA', 'Ukraine', 'EURO', '10179', '479197', '191', '8756');
INSERT INTO public.who_global_data_import VALUES (89514, '2020-11-11', 'UA', 'Ukraine', 'EURO', '10611', '489808', '191', '8947');
INSERT INTO public.who_global_data_import VALUES (89515, '2020-11-12', 'UA', 'Ukraine', 'EURO', '11057', '500865', '198', '9145');
INSERT INTO public.who_global_data_import VALUES (89516, '2020-11-13', 'UA', 'Ukraine', 'EURO', '11787', '512652', '172', '9317');
INSERT INTO public.who_global_data_import VALUES (89517, '2020-11-14', 'UA', 'Ukraine', 'EURO', '12524', '525176', '191', '9508');
INSERT INTO public.who_global_data_import VALUES (89518, '2020-11-15', 'UA', 'Ukraine', 'EURO', '10681', '535857', '95', '9603');
INSERT INTO public.who_global_data_import VALUES (89519, '2020-11-16', 'UA', 'Ukraine', 'EURO', '9832', '545689', '94', '9697');
INSERT INTO public.who_global_data_import VALUES (89520, '2020-11-17', 'UA', 'Ukraine', 'EURO', '11968', '557657', '159', '9856');
INSERT INTO public.who_global_data_import VALUES (89521, '2020-11-18', 'UA', 'Ukraine', 'EURO', '12496', '570153', '256', '10112');
INSERT INTO public.who_global_data_import VALUES (89522, '2020-11-19', 'UA', 'Ukraine', 'EURO', '13357', '583510', '257', '10369');
INSERT INTO public.who_global_data_import VALUES (89523, '2020-11-20', 'UA', 'Ukraine', 'EURO', '14575', '598085', '229', '10598');
INSERT INTO public.who_global_data_import VALUES (89524, '2020-11-21', 'UA', 'Ukraine', 'EURO', '14580', '612665', '215', '10813');
INSERT INTO public.who_global_data_import VALUES (89525, '2020-11-22', 'UA', 'Ukraine', 'EURO', '12079', '624744', '138', '10951');
INSERT INTO public.who_global_data_import VALUES (89526, '2020-11-23', 'UA', 'Ukraine', 'EURO', '10945', '635689', '124', '11075');
INSERT INTO public.who_global_data_import VALUES (89527, '2020-11-24', 'UA', 'Ukraine', 'EURO', '12287', '647976', '188', '11263');
INSERT INTO public.who_global_data_import VALUES (89528, '2020-11-25', 'UA', 'Ukraine', 'EURO', '13882', '661858', '229', '11492');
INSERT INTO public.who_global_data_import VALUES (89529, '2020-11-26', 'UA', 'Ukraine', 'EURO', '15331', '677189', '225', '11717');
INSERT INTO public.who_global_data_import VALUES (89530, '2020-11-27', 'UA', 'Ukraine', 'EURO', '16218', '693407', '192', '11909');
INSERT INTO public.who_global_data_import VALUES (89531, '2020-11-28', 'UA', 'Ukraine', 'EURO', '16294', '709701', '184', '12093');
INSERT INTO public.who_global_data_import VALUES (89532, '2020-11-29', 'UA', 'Ukraine', 'EURO', '12978', '722679', '120', '12213');
INSERT INTO public.who_global_data_import VALUES (89533, '2020-11-30', 'UA', 'Ukraine', 'EURO', '9946', '732625', '114', '12327');
INSERT INTO public.who_global_data_import VALUES (89534, '2020-12-01', 'UA', 'Ukraine', 'EURO', '12498', '745123', '221', '12548');
INSERT INTO public.who_global_data_import VALUES (89535, '2020-12-02', 'UA', 'Ukraine', 'EURO', '13141', '758264', '169', '12717');
INSERT INTO public.who_global_data_import VALUES (89536, '2020-12-03', 'UA', 'Ukraine', 'EURO', '14496', '772760', '243', '12960');
INSERT INTO public.who_global_data_import VALUES (89537, '2020-12-04', 'UA', 'Ukraine', 'EURO', '15131', '787891', '235', '13195');
INSERT INTO public.who_global_data_import VALUES (89538, '2020-12-05', 'UA', 'Ukraine', 'EURO', '13825', '801716', '226', '13421');
INSERT INTO public.who_global_data_import VALUES (89539, '2020-12-06', 'UA', 'Ukraine', 'EURO', '11590', '813306', '167', '13588');
INSERT INTO public.who_global_data_import VALUES (89540, '2020-12-07', 'UA', 'Ukraine', 'EURO', '8641', '821947', '145', '13733');
INSERT INTO public.who_global_data_import VALUES (89541, '2020-12-08', 'UA', 'Ukraine', 'EURO', '10811', '832758', '195', '13928');
INSERT INTO public.who_global_data_import VALUES (89542, '2020-12-09', 'UA', 'Ukraine', 'EURO', '12585', '845343', '276', '14204');
INSERT INTO public.who_global_data_import VALUES (89543, '2020-12-10', 'UA', 'Ukraine', 'EURO', '13371', '858714', '266', '14470');
INSERT INTO public.who_global_data_import VALUES (89544, '2020-12-11', 'UA', 'Ukraine', 'EURO', '13514', '872228', '285', '14755');
INSERT INTO public.who_global_data_import VALUES (89545, '2020-12-12', 'UA', 'Ukraine', 'EURO', '12811', '885039', '243', '14998');
INSERT INTO public.who_global_data_import VALUES (89546, '2020-12-13', 'UA', 'Ukraine', 'EURO', '9176', '894215', '156', '15154');
INSERT INTO public.who_global_data_import VALUES (89547, '2020-12-14', 'UA', 'Ukraine', 'EURO', '6451', '900666', '93', '15247');
INSERT INTO public.who_global_data_import VALUES (89548, '2020-12-15', 'UA', 'Ukraine', 'EURO', '8416', '909082', '233', '15480');
INSERT INTO public.who_global_data_import VALUES (89549, '2020-12-16', 'UA', 'Ukraine', 'EURO', '10622', '919704', '264', '15744');
INSERT INTO public.who_global_data_import VALUES (89550, '2020-12-17', 'UA', 'Ukraine', 'EURO', '12047', '931751', '252', '15996');
INSERT INTO public.who_global_data_import VALUES (89551, '2020-12-18', 'UA', 'Ukraine', 'EURO', '12630', '944381', '260', '16256');
INSERT INTO public.who_global_data_import VALUES (89552, '2020-12-19', 'UA', 'Ukraine', 'EURO', '11742', '956123', '213', '16469');
INSERT INTO public.who_global_data_import VALUES (89553, '2020-12-20', 'UA', 'Ukraine', 'EURO', '8325', '964448', '116', '16585');
INSERT INTO public.who_global_data_import VALUES (89554, '2020-12-21', 'UA', 'Ukraine', 'EURO', '6545', '970993', '80', '16665');
INSERT INTO public.who_global_data_import VALUES (89555, '2020-12-22', 'UA', 'Ukraine', 'EURO', '8513', '979506', '232', '16897');
INSERT INTO public.who_global_data_import VALUES (89556, '2020-12-23', 'UA', 'Ukraine', 'EURO', '10136', '989642', '275', '17172');
INSERT INTO public.who_global_data_import VALUES (89557, '2020-12-24', 'UA', 'Ukraine', 'EURO', '11490', '1001132', '223', '17395');
INSERT INTO public.who_global_data_import VALUES (89558, '2020-12-25', 'UA', 'Ukraine', 'EURO', '11035', '1012167', '186', '17581');
INSERT INTO public.who_global_data_import VALUES (89559, '2020-12-26', 'UA', 'Ukraine', 'EURO', '7709', '1019876', '121', '17702');
INSERT INTO public.who_global_data_import VALUES (89560, '2020-12-27', 'UA', 'Ukraine', 'EURO', '6113', '1025989', '72', '17774');
INSERT INTO public.who_global_data_import VALUES (89561, '2020-12-28', 'UA', 'Ukraine', 'EURO', '4385', '1030374', '75', '17849');
INSERT INTO public.who_global_data_import VALUES (89562, '2020-12-29', 'UA', 'Ukraine', 'EURO', '6988', '1037362', '232', '18081');
INSERT INTO public.who_global_data_import VALUES (89563, '2020-12-30', 'UA', 'Ukraine', 'EURO', '7986', '1045348', '243', '18324');
INSERT INTO public.who_global_data_import VALUES (89564, '2020-12-31', 'UA', 'Ukraine', 'EURO', '9699', '1055047', '209', '18533');
INSERT INTO public.who_global_data_import VALUES (89565, '2021-01-01', 'UA', 'Ukraine', 'EURO', '9432', '1064479', '147', '18680');
INSERT INTO public.who_global_data_import VALUES (89566, '2021-01-02', 'UA', 'Ukraine', 'EURO', '5038', '1069517', '51', '18731');
INSERT INTO public.who_global_data_import VALUES (89567, '2021-01-03', 'UA', 'Ukraine', 'EURO', '4576', '1074093', '123', '18854');
INSERT INTO public.who_global_data_import VALUES (89568, '2021-01-04', 'UA', 'Ukraine', 'EURO', '4158', '1078251', '73', '18927');
INSERT INTO public.who_global_data_import VALUES (89569, '2021-01-05', 'UA', 'Ukraine', 'EURO', '5334', '1083585', '202', '19129');
INSERT INTO public.who_global_data_import VALUES (89570, '2021-01-06', 'UA', 'Ukraine', 'EURO', '6911', '1090496', '228', '19357');
INSERT INTO public.who_global_data_import VALUES (89571, '2021-01-07', 'UA', 'Ukraine', 'EURO', '8997', '1099493', '148', '19505');
INSERT INTO public.who_global_data_import VALUES (89572, '2021-01-08', 'UA', 'Ukraine', 'EURO', '5676', '1105169', '83', '19588');
INSERT INTO public.who_global_data_import VALUES (89573, '2021-01-09', 'UA', 'Ukraine', 'EURO', '4846', '1110015', '80', '19668');
INSERT INTO public.who_global_data_import VALUES (89574, '2021-01-10', 'UA', 'Ukraine', 'EURO', '5011', '1115026', '99', '19767');
INSERT INTO public.who_global_data_import VALUES (89575, '2021-01-11', 'UA', 'Ukraine', 'EURO', '4288', '1119314', '68', '19835');
INSERT INTO public.who_global_data_import VALUES (89576, '2021-01-12', 'UA', 'Ukraine', 'EURO', '5116', '1124430', '184', '20019');
INSERT INTO public.who_global_data_import VALUES (89577, '2021-01-13', 'UA', 'Ukraine', 'EURO', '6409', '1130839', '195', '20214');
INSERT INTO public.who_global_data_import VALUES (89578, '2021-01-14', 'UA', 'Ukraine', 'EURO', '7925', '1138764', '162', '20376');
INSERT INTO public.who_global_data_import VALUES (89579, '2021-01-15', 'UA', 'Ukraine', 'EURO', '8199', '1146963', '166', '20542');
INSERT INTO public.who_global_data_import VALUES (89580, '2021-01-16', 'UA', 'Ukraine', 'EURO', '7729', '1154692', '144', '20686');
INSERT INTO public.who_global_data_import VALUES (89581, '2021-01-17', 'UA', 'Ukraine', 'EURO', '5990', '1160682', '116', '20802');
INSERT INTO public.who_global_data_import VALUES (89582, '2021-01-18', 'UA', 'Ukraine', 'EURO', '3034', '1163716', '67', '20869');
INSERT INTO public.who_global_data_import VALUES (89583, '2021-01-19', 'UA', 'Ukraine', 'EURO', '3939', '1167655', '177', '21046');
INSERT INTO public.who_global_data_import VALUES (89584, '2021-01-20', 'UA', 'Ukraine', 'EURO', '4383', '1172038', '212', '21258');
INSERT INTO public.who_global_data_import VALUES (89585, '2021-01-21', 'UA', 'Ukraine', 'EURO', '5583', '1177621', '241', '21499');
INSERT INTO public.who_global_data_import VALUES (89586, '2021-01-22', 'UA', 'Ukraine', 'EURO', '5348', '1182969', '163', '21662');
INSERT INTO public.who_global_data_import VALUES (89587, '2021-01-23', 'UA', 'Ukraine', 'EURO', '4928', '1187897', '116', '21778');
INSERT INTO public.who_global_data_import VALUES (89588, '2021-01-24', 'UA', 'Ukraine', 'EURO', '3915', '1191812', '83', '21861');
INSERT INTO public.who_global_data_import VALUES (89589, '2021-01-25', 'UA', 'Ukraine', 'EURO', '2516', '1194328', '63', '21924');
INSERT INTO public.who_global_data_import VALUES (89590, '2021-01-26', 'UA', 'Ukraine', 'EURO', '2779', '1197107', '133', '22057');
INSERT INTO public.who_global_data_import VALUES (89591, '2021-01-27', 'UA', 'Ukraine', 'EURO', '3776', '1200883', '145', '22202');
INSERT INTO public.who_global_data_import VALUES (89592, '2021-01-28', 'UA', 'Ukraine', 'EURO', '5529', '1206412', '149', '22351');
INSERT INTO public.who_global_data_import VALUES (89593, '2021-01-29', 'UA', 'Ukraine', 'EURO', '5181', '1211593', '128', '22479');
INSERT INTO public.who_global_data_import VALUES (89594, '2021-01-30', 'UA', 'Ukraine', 'EURO', '4685', '1216278', '149', '22628');
INSERT INTO public.who_global_data_import VALUES (89595, '2021-01-31', 'UA', 'Ukraine', 'EURO', '3177', '1219455', '79', '22707');
INSERT INTO public.who_global_data_import VALUES (89596, '2021-02-01', 'UA', 'Ukraine', 'EURO', '2030', '1221485', '61', '22768');
INSERT INTO public.who_global_data_import VALUES (89597, '2021-02-02', 'UA', 'Ukraine', 'EURO', '2394', '1223879', '156', '22924');
INSERT INTO public.who_global_data_import VALUES (89598, '2021-02-03', 'UA', 'Ukraine', 'EURO', '3285', '1227164', '165', '23089');
INSERT INTO public.who_global_data_import VALUES (89599, '2021-02-04', 'UA', 'Ukraine', 'EURO', '5082', '1232246', '140', '23229');
INSERT INTO public.who_global_data_import VALUES (89600, '2021-02-05', 'UA', 'Ukraine', 'EURO', '4923', '1237169', '158', '23387');
INSERT INTO public.who_global_data_import VALUES (89601, '2020-01-03', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89602, '2020-01-04', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89603, '2020-01-05', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89604, '2020-01-06', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89605, '2020-01-07', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89606, '2020-01-08', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89607, '2020-01-09', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89608, '2020-01-10', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89609, '2020-01-11', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89610, '2020-01-12', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89611, '2020-01-13', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89612, '2020-01-14', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89613, '2020-01-15', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89614, '2020-01-16', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89615, '2020-01-17', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89616, '2020-01-18', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89617, '2020-01-19', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89618, '2020-01-20', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89619, '2020-01-21', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89620, '2020-01-22', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89621, '2020-01-23', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89622, '2020-01-24', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89623, '2020-01-25', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89624, '2020-01-26', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89625, '2020-01-27', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89626, '2020-01-28', 'AE', 'United Arab Emirates', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89627, '2020-01-29', 'AE', 'United Arab Emirates', 'EMRO', '8', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89628, '2020-01-30', 'AE', 'United Arab Emirates', 'EMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89629, '2020-01-31', 'AE', 'United Arab Emirates', 'EMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89630, '2020-02-01', 'AE', 'United Arab Emirates', 'EMRO', '1', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89631, '2020-02-02', 'AE', 'United Arab Emirates', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89632, '2020-02-03', 'AE', 'United Arab Emirates', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89633, '2020-02-04', 'AE', 'United Arab Emirates', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89634, '2020-02-05', 'AE', 'United Arab Emirates', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89635, '2020-02-06', 'AE', 'United Arab Emirates', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89636, '2020-02-07', 'AE', 'United Arab Emirates', 'EMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89637, '2020-02-08', 'AE', 'United Arab Emirates', 'EMRO', '2', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89638, '2020-02-09', 'AE', 'United Arab Emirates', 'EMRO', '0', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89639, '2020-02-10', 'AE', 'United Arab Emirates', 'EMRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89640, '2020-02-11', 'AE', 'United Arab Emirates', 'EMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89641, '2020-02-12', 'AE', 'United Arab Emirates', 'EMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89642, '2020-02-13', 'AE', 'United Arab Emirates', 'EMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89643, '2020-02-14', 'AE', 'United Arab Emirates', 'EMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89644, '2020-02-15', 'AE', 'United Arab Emirates', 'EMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89645, '2020-02-16', 'AE', 'United Arab Emirates', 'EMRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89646, '2020-02-17', 'AE', 'United Arab Emirates', 'EMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89647, '2020-02-18', 'AE', 'United Arab Emirates', 'EMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89648, '2020-02-19', 'AE', 'United Arab Emirates', 'EMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89649, '2020-02-20', 'AE', 'United Arab Emirates', 'EMRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89650, '2020-02-21', 'AE', 'United Arab Emirates', 'EMRO', '2', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89651, '2020-02-22', 'AE', 'United Arab Emirates', 'EMRO', '2', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89652, '2020-02-23', 'AE', 'United Arab Emirates', 'EMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89653, '2020-02-24', 'AE', 'United Arab Emirates', 'EMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89654, '2020-02-25', 'AE', 'United Arab Emirates', 'EMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89655, '2020-02-26', 'AE', 'United Arab Emirates', 'EMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89656, '2020-02-27', 'AE', 'United Arab Emirates', 'EMRO', '6', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89657, '2020-02-28', 'AE', 'United Arab Emirates', 'EMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89658, '2020-02-29', 'AE', 'United Arab Emirates', 'EMRO', '0', '23', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89659, '2020-03-01', 'AE', 'United Arab Emirates', 'EMRO', '2', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89660, '2020-03-02', 'AE', 'United Arab Emirates', 'EMRO', '0', '25', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89661, '2020-03-03', 'AE', 'United Arab Emirates', 'EMRO', '6', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89662, '2020-03-04', 'AE', 'United Arab Emirates', 'EMRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89663, '2020-03-05', 'AE', 'United Arab Emirates', 'EMRO', '0', '31', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89664, '2020-03-06', 'AE', 'United Arab Emirates', 'EMRO', '18', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89665, '2020-03-07', 'AE', 'United Arab Emirates', 'EMRO', '0', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89666, '2020-03-08', 'AE', 'United Arab Emirates', 'EMRO', '0', '49', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89667, '2020-03-09', 'AE', 'United Arab Emirates', 'EMRO', '14', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89668, '2020-03-10', 'AE', 'United Arab Emirates', 'EMRO', '15', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89669, '2020-03-11', 'AE', 'United Arab Emirates', 'EMRO', '0', '78', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89670, '2020-03-12', 'AE', 'United Arab Emirates', 'EMRO', '11', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89671, '2020-03-13', 'AE', 'United Arab Emirates', 'EMRO', '0', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89672, '2020-03-14', 'AE', 'United Arab Emirates', 'EMRO', '0', '89', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89673, '2020-03-15', 'AE', 'United Arab Emirates', 'EMRO', '13', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89674, '2020-03-16', 'AE', 'United Arab Emirates', 'EMRO', '0', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89675, '2020-03-17', 'AE', 'United Arab Emirates', 'EMRO', '0', '102', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89676, '2020-03-18', 'AE', 'United Arab Emirates', 'EMRO', '15', '117', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89677, '2020-03-19', 'AE', 'United Arab Emirates', 'EMRO', '23', '140', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89678, '2020-03-20', 'AE', 'United Arab Emirates', 'EMRO', '0', '140', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89679, '2020-03-21', 'AE', 'United Arab Emirates', 'EMRO', '13', '153', '2', '2');
INSERT INTO public.who_global_data_import VALUES (89680, '2020-03-22', 'AE', 'United Arab Emirates', 'EMRO', '0', '153', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89681, '2020-03-23', 'AE', 'United Arab Emirates', 'EMRO', '45', '198', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89682, '2020-03-24', 'AE', 'United Arab Emirates', 'EMRO', '50', '248', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89683, '2020-03-25', 'AE', 'United Arab Emirates', 'EMRO', '85', '333', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89684, '2020-03-26', 'AE', 'United Arab Emirates', 'EMRO', '0', '333', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89685, '2020-03-27', 'AE', 'United Arab Emirates', 'EMRO', '0', '333', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89686, '2020-03-28', 'AE', 'United Arab Emirates', 'EMRO', '135', '468', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89687, '2020-03-29', 'AE', 'United Arab Emirates', 'EMRO', '0', '468', '0', '2');
INSERT INTO public.who_global_data_import VALUES (89688, '2020-03-30', 'AE', 'United Arab Emirates', 'EMRO', '143', '611', '3', '5');
INSERT INTO public.who_global_data_import VALUES (89689, '2020-03-31', 'AE', 'United Arab Emirates', 'EMRO', '53', '664', '1', '6');
INSERT INTO public.who_global_data_import VALUES (89690, '2020-04-01', 'AE', 'United Arab Emirates', 'EMRO', '0', '664', '0', '6');
INSERT INTO public.who_global_data_import VALUES (89691, '2020-04-02', 'AE', 'United Arab Emirates', 'EMRO', '150', '814', '2', '8');
INSERT INTO public.who_global_data_import VALUES (89692, '2020-04-03', 'AE', 'United Arab Emirates', 'EMRO', '210', '1024', '0', '8');
INSERT INTO public.who_global_data_import VALUES (89693, '2020-04-04', 'AE', 'United Arab Emirates', 'EMRO', '481', '1505', '2', '10');
INSERT INTO public.who_global_data_import VALUES (89694, '2020-04-05', 'AE', 'United Arab Emirates', 'EMRO', '0', '1505', '0', '10');
INSERT INTO public.who_global_data_import VALUES (89695, '2020-04-06', 'AE', 'United Arab Emirates', 'EMRO', '571', '2076', '1', '11');
INSERT INTO public.who_global_data_import VALUES (89696, '2020-04-07', 'AE', 'United Arab Emirates', 'EMRO', '0', '2076', '0', '11');
INSERT INTO public.who_global_data_import VALUES (89697, '2020-04-08', 'AE', 'United Arab Emirates', 'EMRO', '583', '2659', '1', '12');
INSERT INTO public.who_global_data_import VALUES (89698, '2020-04-09', 'AE', 'United Arab Emirates', 'EMRO', '0', '2659', '0', '12');
INSERT INTO public.who_global_data_import VALUES (89699, '2020-04-10', 'AE', 'United Arab Emirates', 'EMRO', '331', '2990', '2', '14');
INSERT INTO public.who_global_data_import VALUES (89700, '2020-04-11', 'AE', 'United Arab Emirates', 'EMRO', '746', '3736', '6', '20');
INSERT INTO public.who_global_data_import VALUES (89701, '2020-04-12', 'AE', 'United Arab Emirates', 'EMRO', '0', '3736', '0', '20');
INSERT INTO public.who_global_data_import VALUES (89702, '2020-04-13', 'AE', 'United Arab Emirates', 'EMRO', '387', '4123', '5', '25');
INSERT INTO public.who_global_data_import VALUES (89703, '2020-04-14', 'AE', 'United Arab Emirates', 'EMRO', '398', '4521', '0', '25');
INSERT INTO public.who_global_data_import VALUES (89704, '2020-04-15', 'AE', 'United Arab Emirates', 'EMRO', '412', '4933', '3', '28');
INSERT INTO public.who_global_data_import VALUES (89705, '2020-04-16', 'AE', 'United Arab Emirates', 'EMRO', '432', '5365', '5', '33');
INSERT INTO public.who_global_data_import VALUES (89706, '2020-04-17', 'AE', 'United Arab Emirates', 'EMRO', '460', '5825', '2', '35');
INSERT INTO public.who_global_data_import VALUES (89707, '2020-04-18', 'AE', 'United Arab Emirates', 'EMRO', '477', '6302', '2', '37');
INSERT INTO public.who_global_data_import VALUES (89708, '2020-04-19', 'AE', 'United Arab Emirates', 'EMRO', '479', '6781', '4', '41');
INSERT INTO public.who_global_data_import VALUES (89709, '2020-04-20', 'AE', 'United Arab Emirates', 'EMRO', '484', '7265', '2', '43');
INSERT INTO public.who_global_data_import VALUES (89710, '2020-04-21', 'AE', 'United Arab Emirates', 'EMRO', '490', '7755', '3', '46');
INSERT INTO public.who_global_data_import VALUES (89711, '2020-04-22', 'AE', 'United Arab Emirates', 'EMRO', '483', '8238', '6', '52');
INSERT INTO public.who_global_data_import VALUES (89712, '2020-04-23', 'AE', 'United Arab Emirates', 'EMRO', '518', '8756', '4', '56');
INSERT INTO public.who_global_data_import VALUES (89713, '2020-04-24', 'AE', 'United Arab Emirates', 'EMRO', '525', '9281', '8', '64');
INSERT INTO public.who_global_data_import VALUES (89714, '2020-04-25', 'AE', 'United Arab Emirates', 'EMRO', '0', '9281', '0', '64');
INSERT INTO public.who_global_data_import VALUES (89715, '2020-04-26', 'AE', 'United Arab Emirates', 'EMRO', '1068', '10349', '12', '76');
INSERT INTO public.who_global_data_import VALUES (89716, '2020-04-27', 'AE', 'United Arab Emirates', 'EMRO', '0', '10349', '0', '76');
INSERT INTO public.who_global_data_import VALUES (89717, '2020-04-28', 'AE', 'United Arab Emirates', 'EMRO', '1031', '11380', '13', '89');
INSERT INTO public.who_global_data_import VALUES (89718, '2020-04-29', 'AE', 'United Arab Emirates', 'EMRO', '0', '11380', '0', '89');
INSERT INTO public.who_global_data_import VALUES (89719, '2020-04-30', 'AE', 'United Arab Emirates', 'EMRO', '1101', '12481', '16', '105');
INSERT INTO public.who_global_data_import VALUES (89720, '2020-05-01', 'AE', 'United Arab Emirates', 'EMRO', '557', '13038', '6', '111');
INSERT INTO public.who_global_data_import VALUES (89721, '2020-05-02', 'AE', 'United Arab Emirates', 'EMRO', '0', '13038', '0', '111');
INSERT INTO public.who_global_data_import VALUES (89722, '2020-05-03', 'AE', 'United Arab Emirates', 'EMRO', '1125', '14163', '15', '126');
INSERT INTO public.who_global_data_import VALUES (89723, '2020-05-04', 'AE', 'United Arab Emirates', 'EMRO', '0', '14163', '0', '126');
INSERT INTO public.who_global_data_import VALUES (89724, '2020-05-05', 'AE', 'United Arab Emirates', 'EMRO', '1029', '15192', '20', '146');
INSERT INTO public.who_global_data_import VALUES (89725, '2020-05-06', 'AE', 'United Arab Emirates', 'EMRO', '0', '15192', '0', '146');
INSERT INTO public.who_global_data_import VALUES (89726, '2020-05-07', 'AE', 'United Arab Emirates', 'EMRO', '1048', '16240', '19', '165');
INSERT INTO public.who_global_data_import VALUES (89727, '2020-05-08', 'AE', 'United Arab Emirates', 'EMRO', '553', '16793', '9', '174');
INSERT INTO public.who_global_data_import VALUES (89728, '2020-05-09', 'AE', 'United Arab Emirates', 'EMRO', '0', '16793', '0', '174');
INSERT INTO public.who_global_data_import VALUES (89729, '2020-05-10', 'AE', 'United Arab Emirates', 'EMRO', '1405', '18198', '24', '198');
INSERT INTO public.who_global_data_import VALUES (89730, '2020-05-11', 'AE', 'United Arab Emirates', 'EMRO', '0', '18198', '0', '198');
INSERT INTO public.who_global_data_import VALUES (89731, '2020-05-12', 'AE', 'United Arab Emirates', 'EMRO', '1463', '19661', '5', '203');
INSERT INTO public.who_global_data_import VALUES (89732, '2020-05-13', 'AE', 'United Arab Emirates', 'EMRO', '0', '19661', '0', '203');
INSERT INTO public.who_global_data_import VALUES (89733, '2020-05-14', 'AE', 'United Arab Emirates', 'EMRO', '1423', '21084', '5', '208');
INSERT INTO public.who_global_data_import VALUES (89734, '2020-05-15', 'AE', 'United Arab Emirates', 'EMRO', '747', '21831', '2', '210');
INSERT INTO public.who_global_data_import VALUES (89735, '2020-05-16', 'AE', 'United Arab Emirates', 'EMRO', '0', '21831', '0', '210');
INSERT INTO public.who_global_data_import VALUES (89736, '2020-05-17', 'AE', 'United Arab Emirates', 'EMRO', '1527', '23358', '10', '220');
INSERT INTO public.who_global_data_import VALUES (89737, '2020-05-18', 'AE', 'United Arab Emirates', 'EMRO', '0', '23358', '0', '220');
INSERT INTO public.who_global_data_import VALUES (89738, '2020-05-19', 'AE', 'United Arab Emirates', 'EMRO', '1705', '25063', '7', '227');
INSERT INTO public.who_global_data_import VALUES (89739, '2020-05-20', 'AE', 'United Arab Emirates', 'EMRO', '0', '25063', '0', '227');
INSERT INTO public.who_global_data_import VALUES (89740, '2020-05-21', 'AE', 'United Arab Emirates', 'EMRO', '941', '26004', '6', '233');
INSERT INTO public.who_global_data_import VALUES (89741, '2020-05-22', 'AE', 'United Arab Emirates', 'EMRO', '894', '26898', '4', '237');
INSERT INTO public.who_global_data_import VALUES (89742, '2020-05-23', 'AE', 'United Arab Emirates', 'EMRO', '994', '27892', '4', '241');
INSERT INTO public.who_global_data_import VALUES (89743, '2020-05-24', 'AE', 'United Arab Emirates', 'EMRO', '812', '28704', '3', '244');
INSERT INTO public.who_global_data_import VALUES (89744, '2020-05-25', 'AE', 'United Arab Emirates', 'EMRO', '781', '29485', '1', '245');
INSERT INTO public.who_global_data_import VALUES (89745, '2020-05-26', 'AE', 'United Arab Emirates', 'EMRO', '822', '30307', '3', '248');
INSERT INTO public.who_global_data_import VALUES (89746, '2020-05-27', 'AE', 'United Arab Emirates', 'EMRO', '779', '31086', '5', '253');
INSERT INTO public.who_global_data_import VALUES (89747, '2020-05-28', 'AE', 'United Arab Emirates', 'EMRO', '883', '31969', '2', '255');
INSERT INTO public.who_global_data_import VALUES (89748, '2020-05-29', 'AE', 'United Arab Emirates', 'EMRO', '563', '32532', '3', '258');
INSERT INTO public.who_global_data_import VALUES (89749, '2020-05-30', 'AE', 'United Arab Emirates', 'EMRO', '638', '33170', '2', '260');
INSERT INTO public.who_global_data_import VALUES (89750, '2020-05-31', 'AE', 'United Arab Emirates', 'EMRO', '726', '33896', '2', '262');
INSERT INTO public.who_global_data_import VALUES (89751, '2020-06-01', 'AE', 'United Arab Emirates', 'EMRO', '661', '34557', '2', '264');
INSERT INTO public.who_global_data_import VALUES (89752, '2020-06-02', 'AE', 'United Arab Emirates', 'EMRO', '635', '35192', '2', '266');
INSERT INTO public.who_global_data_import VALUES (89753, '2020-06-03', 'AE', 'United Arab Emirates', 'EMRO', '596', '35788', '3', '269');
INSERT INTO public.who_global_data_import VALUES (89754, '2020-06-04', 'AE', 'United Arab Emirates', 'EMRO', '571', '36359', '1', '270');
INSERT INTO public.who_global_data_import VALUES (89755, '2020-06-05', 'AE', 'United Arab Emirates', 'EMRO', '659', '37018', '3', '273');
INSERT INTO public.who_global_data_import VALUES (89756, '2020-06-06', 'AE', 'United Arab Emirates', 'EMRO', '624', '37642', '1', '274');
INSERT INTO public.who_global_data_import VALUES (89757, '2020-06-07', 'AE', 'United Arab Emirates', 'EMRO', '626', '38268', '1', '275');
INSERT INTO public.who_global_data_import VALUES (89758, '2020-06-08', 'AE', 'United Arab Emirates', 'EMRO', '540', '38808', '1', '276');
INSERT INTO public.who_global_data_import VALUES (89759, '2020-06-09', 'AE', 'United Arab Emirates', 'EMRO', '568', '39376', '5', '281');
INSERT INTO public.who_global_data_import VALUES (89760, '2020-06-10', 'AE', 'United Arab Emirates', 'EMRO', '528', '39904', '2', '283');
INSERT INTO public.who_global_data_import VALUES (89761, '2020-06-11', 'AE', 'United Arab Emirates', 'EMRO', '603', '40507', '1', '284');
INSERT INTO public.who_global_data_import VALUES (89762, '2020-06-12', 'AE', 'United Arab Emirates', 'EMRO', '479', '40986', '2', '286');
INSERT INTO public.who_global_data_import VALUES (89763, '2020-06-13', 'AE', 'United Arab Emirates', 'EMRO', '513', '41499', '1', '287');
INSERT INTO public.who_global_data_import VALUES (89764, '2020-06-14', 'AE', 'United Arab Emirates', 'EMRO', '491', '41990', '1', '288');
INSERT INTO public.who_global_data_import VALUES (89765, '2020-06-15', 'AE', 'United Arab Emirates', 'EMRO', '304', '42294', '1', '289');
INSERT INTO public.who_global_data_import VALUES (89766, '2020-06-16', 'AE', 'United Arab Emirates', 'EMRO', '342', '42636', '2', '291');
INSERT INTO public.who_global_data_import VALUES (89767, '2020-06-17', 'AE', 'United Arab Emirates', 'EMRO', '346', '42982', '2', '293');
INSERT INTO public.who_global_data_import VALUES (89768, '2020-06-18', 'AE', 'United Arab Emirates', 'EMRO', '382', '43364', '2', '295');
INSERT INTO public.who_global_data_import VALUES (89769, '2020-06-19', 'AE', 'United Arab Emirates', 'EMRO', '388', '43752', '3', '298');
INSERT INTO public.who_global_data_import VALUES (89770, '2020-06-20', 'AE', 'United Arab Emirates', 'EMRO', '393', '44145', '2', '300');
INSERT INTO public.who_global_data_import VALUES (89771, '2020-06-21', 'AE', 'United Arab Emirates', 'EMRO', '388', '44533', '1', '301');
INSERT INTO public.who_global_data_import VALUES (89772, '2020-06-22', 'AE', 'United Arab Emirates', 'EMRO', '392', '44925', '1', '302');
INSERT INTO public.who_global_data_import VALUES (89773, '2020-06-23', 'AE', 'United Arab Emirates', 'EMRO', '378', '45303', '1', '303');
INSERT INTO public.who_global_data_import VALUES (89774, '2020-06-24', 'AE', 'United Arab Emirates', 'EMRO', '380', '45683', '2', '305');
INSERT INTO public.who_global_data_import VALUES (89775, '2020-06-25', 'AE', 'United Arab Emirates', 'EMRO', '450', '46133', '2', '307');
INSERT INTO public.who_global_data_import VALUES (89776, '2020-06-26', 'AE', 'United Arab Emirates', 'EMRO', '430', '46563', '1', '308');
INSERT INTO public.who_global_data_import VALUES (89777, '2020-06-27', 'AE', 'United Arab Emirates', 'EMRO', '410', '46973', '2', '310');
INSERT INTO public.who_global_data_import VALUES (89778, '2020-06-28', 'AE', 'United Arab Emirates', 'EMRO', '387', '47360', '1', '311');
INSERT INTO public.who_global_data_import VALUES (89779, '2020-06-29', 'AE', 'United Arab Emirates', 'EMRO', '437', '47797', '2', '313');
INSERT INTO public.who_global_data_import VALUES (89780, '2020-06-30', 'AE', 'United Arab Emirates', 'EMRO', '449', '48246', '1', '314');
INSERT INTO public.who_global_data_import VALUES (89781, '2020-07-01', 'AE', 'United Arab Emirates', 'EMRO', '421', '48667', '1', '315');
INSERT INTO public.who_global_data_import VALUES (89782, '2020-07-02', 'AE', 'United Arab Emirates', 'EMRO', '402', '49069', '1', '316');
INSERT INTO public.who_global_data_import VALUES (89783, '2020-07-03', 'AE', 'United Arab Emirates', 'EMRO', '400', '49469', '1', '317');
INSERT INTO public.who_global_data_import VALUES (89784, '2020-07-04', 'AE', 'United Arab Emirates', 'EMRO', '672', '50141', '1', '318');
INSERT INTO public.who_global_data_import VALUES (89785, '2020-07-05', 'AE', 'United Arab Emirates', 'EMRO', '716', '50857', '3', '321');
INSERT INTO public.who_global_data_import VALUES (89786, '2020-07-06', 'AE', 'United Arab Emirates', 'EMRO', '683', '51540', '2', '323');
INSERT INTO public.who_global_data_import VALUES (89787, '2020-07-07', 'AE', 'United Arab Emirates', 'EMRO', '528', '52068', '1', '324');
INSERT INTO public.who_global_data_import VALUES (89788, '2020-07-08', 'AE', 'United Arab Emirates', 'EMRO', '532', '52600', '2', '326');
INSERT INTO public.who_global_data_import VALUES (89789, '2020-07-09', 'AE', 'United Arab Emirates', 'EMRO', '445', '53045', '1', '327');
INSERT INTO public.who_global_data_import VALUES (89790, '2020-07-10', 'AE', 'United Arab Emirates', 'EMRO', '532', '53577', '1', '328');
INSERT INTO public.who_global_data_import VALUES (89791, '2020-07-11', 'AE', 'United Arab Emirates', 'EMRO', '473', '54050', '2', '330');
INSERT INTO public.who_global_data_import VALUES (89792, '2020-07-12', 'AE', 'United Arab Emirates', 'EMRO', '403', '54453', '1', '331');
INSERT INTO public.who_global_data_import VALUES (89793, '2020-07-13', 'AE', 'United Arab Emirates', 'EMRO', '401', '54854', '2', '333');
INSERT INTO public.who_global_data_import VALUES (89794, '2020-07-14', 'AE', 'United Arab Emirates', 'EMRO', '344', '55198', '1', '334');
INSERT INTO public.who_global_data_import VALUES (89795, '2020-07-15', 'AE', 'United Arab Emirates', 'EMRO', '375', '55573', '1', '335');
INSERT INTO public.who_global_data_import VALUES (89796, '2020-07-16', 'AE', 'United Arab Emirates', 'EMRO', '275', '55848', '0', '335');
INSERT INTO public.who_global_data_import VALUES (89797, '2020-07-17', 'AE', 'United Arab Emirates', 'EMRO', '281', '56129', '0', '335');
INSERT INTO public.who_global_data_import VALUES (89798, '2020-07-18', 'AE', 'United Arab Emirates', 'EMRO', '293', '56422', '2', '337');
INSERT INTO public.who_global_data_import VALUES (89799, '2020-07-19', 'AE', 'United Arab Emirates', 'EMRO', '289', '56711', '1', '338');
INSERT INTO public.who_global_data_import VALUES (89800, '2020-07-20', 'AE', 'United Arab Emirates', 'EMRO', '211', '56922', '1', '339');
INSERT INTO public.who_global_data_import VALUES (89801, '2020-07-21', 'AE', 'United Arab Emirates', 'EMRO', '271', '57193', '1', '340');
INSERT INTO public.who_global_data_import VALUES (89802, '2020-07-22', 'AE', 'United Arab Emirates', 'EMRO', '305', '57498', '1', '341');
INSERT INTO public.who_global_data_import VALUES (89803, '2020-07-23', 'AE', 'United Arab Emirates', 'EMRO', '236', '57734', '1', '342');
INSERT INTO public.who_global_data_import VALUES (89804, '2020-07-24', 'AE', 'United Arab Emirates', 'EMRO', '254', '57988', '0', '342');
INSERT INTO public.who_global_data_import VALUES (89805, '2020-07-25', 'AE', 'United Arab Emirates', 'EMRO', '261', '58249', '1', '343');
INSERT INTO public.who_global_data_import VALUES (89806, '2020-07-26', 'AE', 'United Arab Emirates', 'EMRO', '313', '58562', '0', '343');
INSERT INTO public.who_global_data_import VALUES (89807, '2020-07-27', 'AE', 'United Arab Emirates', 'EMRO', '351', '58913', '1', '344');
INSERT INTO public.who_global_data_import VALUES (89808, '2020-07-28', 'AE', 'United Arab Emirates', 'EMRO', '264', '59177', '1', '345');
INSERT INTO public.who_global_data_import VALUES (89809, '2020-07-29', 'AE', 'United Arab Emirates', 'EMRO', '369', '59546', '2', '347');
INSERT INTO public.who_global_data_import VALUES (89810, '2020-07-30', 'AE', 'United Arab Emirates', 'EMRO', '375', '59921', '0', '347');
INSERT INTO public.who_global_data_import VALUES (89811, '2020-07-31', 'AE', 'United Arab Emirates', 'EMRO', '302', '60223', '2', '349');
INSERT INTO public.who_global_data_import VALUES (89812, '2020-08-01', 'AE', 'United Arab Emirates', 'EMRO', '283', '60506', '2', '351');
INSERT INTO public.who_global_data_import VALUES (89813, '2020-08-02', 'AE', 'United Arab Emirates', 'EMRO', '254', '60760', '0', '351');
INSERT INTO public.who_global_data_import VALUES (89814, '2020-08-03', 'AE', 'United Arab Emirates', 'EMRO', '239', '60999', '0', '351');
INSERT INTO public.who_global_data_import VALUES (89815, '2020-08-04', 'AE', 'United Arab Emirates', 'EMRO', '164', '61163', '0', '351');
INSERT INTO public.who_global_data_import VALUES (89816, '2020-08-05', 'AE', 'United Arab Emirates', 'EMRO', '189', '61352', '0', '351');
INSERT INTO public.who_global_data_import VALUES (89817, '2020-08-06', 'AE', 'United Arab Emirates', 'EMRO', '254', '61606', '2', '353');
INSERT INTO public.who_global_data_import VALUES (89818, '2020-08-07', 'AE', 'United Arab Emirates', 'EMRO', '239', '61845', '1', '354');
INSERT INTO public.who_global_data_import VALUES (89819, '2020-08-08', 'AE', 'United Arab Emirates', 'EMRO', '216', '62061', '2', '356');
INSERT INTO public.who_global_data_import VALUES (89820, '2020-08-09', 'AE', 'United Arab Emirates', 'EMRO', '239', '62300', '0', '356');
INSERT INTO public.who_global_data_import VALUES (89821, '2020-08-10', 'AE', 'United Arab Emirates', 'EMRO', '225', '62525', '1', '357');
INSERT INTO public.who_global_data_import VALUES (89822, '2020-08-11', 'AE', 'United Arab Emirates', 'EMRO', '179', '62704', '0', '357');
INSERT INTO public.who_global_data_import VALUES (89823, '2020-08-12', 'AE', 'United Arab Emirates', 'EMRO', '262', '62966', '1', '358');
INSERT INTO public.who_global_data_import VALUES (89824, '2020-08-13', 'AE', 'United Arab Emirates', 'EMRO', '246', '63212', '0', '358');
INSERT INTO public.who_global_data_import VALUES (89825, '2020-08-14', 'AE', 'United Arab Emirates', 'EMRO', '277', '63489', '0', '358');
INSERT INTO public.who_global_data_import VALUES (89826, '2020-08-15', 'AE', 'United Arab Emirates', 'EMRO', '330', '63819', '1', '359');
INSERT INTO public.who_global_data_import VALUES (92022, '2020-01-24', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89827, '2020-08-16', 'AE', 'United Arab Emirates', 'EMRO', '283', '64102', '2', '361');
INSERT INTO public.who_global_data_import VALUES (89828, '2020-08-17', 'AE', 'United Arab Emirates', 'EMRO', '210', '64312', '3', '364');
INSERT INTO public.who_global_data_import VALUES (89829, '2020-08-18', 'AE', 'United Arab Emirates', 'EMRO', '229', '64541', '0', '364');
INSERT INTO public.who_global_data_import VALUES (89830, '2020-08-19', 'AE', 'United Arab Emirates', 'EMRO', '365', '64906', '2', '366');
INSERT INTO public.who_global_data_import VALUES (89831, '2020-08-20', 'AE', 'United Arab Emirates', 'EMRO', '435', '65341', '1', '367');
INSERT INTO public.who_global_data_import VALUES (89832, '2020-08-21', 'AE', 'United Arab Emirates', 'EMRO', '461', '65802', '2', '369');
INSERT INTO public.who_global_data_import VALUES (89833, '2020-08-22', 'AE', 'United Arab Emirates', 'EMRO', '391', '66193', '1', '370');
INSERT INTO public.who_global_data_import VALUES (89834, '2020-08-23', 'AE', 'United Arab Emirates', 'EMRO', '424', '66617', '2', '372');
INSERT INTO public.who_global_data_import VALUES (89835, '2020-08-24', 'AE', 'United Arab Emirates', 'EMRO', '390', '67007', '3', '375');
INSERT INTO public.who_global_data_import VALUES (89836, '2020-08-25', 'AE', 'United Arab Emirates', 'EMRO', '275', '67282', '1', '376');
INSERT INTO public.who_global_data_import VALUES (89837, '2020-08-26', 'AE', 'United Arab Emirates', 'EMRO', '339', '67621', '1', '377');
INSERT INTO public.who_global_data_import VALUES (89838, '2020-08-27', 'AE', 'United Arab Emirates', 'EMRO', '399', '68020', '1', '378');
INSERT INTO public.who_global_data_import VALUES (89839, '2020-08-28', 'AE', 'United Arab Emirates', 'EMRO', '491', '68511', '0', '378');
INSERT INTO public.who_global_data_import VALUES (89840, '2020-08-29', 'AE', 'United Arab Emirates', 'EMRO', '390', '68901', '1', '379');
INSERT INTO public.who_global_data_import VALUES (89841, '2020-08-30', 'AE', 'United Arab Emirates', 'EMRO', '427', '69328', '0', '379');
INSERT INTO public.who_global_data_import VALUES (89842, '2020-08-31', 'AE', 'United Arab Emirates', 'EMRO', '362', '69690', '3', '382');
INSERT INTO public.who_global_data_import VALUES (89843, '2020-09-01', 'AE', 'United Arab Emirates', 'EMRO', '541', '70231', '2', '384');
INSERT INTO public.who_global_data_import VALUES (89844, '2020-09-02', 'AE', 'United Arab Emirates', 'EMRO', '574', '70805', '0', '384');
INSERT INTO public.who_global_data_import VALUES (89845, '2020-09-03', 'AE', 'United Arab Emirates', 'EMRO', '735', '71540', '3', '387');
INSERT INTO public.who_global_data_import VALUES (89846, '2020-09-04', 'AE', 'United Arab Emirates', 'EMRO', '614', '72154', '0', '387');
INSERT INTO public.who_global_data_import VALUES (89847, '2020-09-05', 'AE', 'United Arab Emirates', 'EMRO', '612', '72766', '0', '387');
INSERT INTO public.who_global_data_import VALUES (89848, '2020-09-06', 'AE', 'United Arab Emirates', 'EMRO', '705', '73471', '1', '388');
INSERT INTO public.who_global_data_import VALUES (89849, '2020-09-07', 'AE', 'United Arab Emirates', 'EMRO', '513', '73984', '0', '388');
INSERT INTO public.who_global_data_import VALUES (89850, '2020-09-08', 'AE', 'United Arab Emirates', 'EMRO', '470', '74454', '2', '390');
INSERT INTO public.who_global_data_import VALUES (89851, '2020-09-09', 'AE', 'United Arab Emirates', 'EMRO', '644', '75098', '1', '391');
INSERT INTO public.who_global_data_import VALUES (89852, '2020-09-10', 'AE', 'United Arab Emirates', 'EMRO', '883', '75981', '2', '393');
INSERT INTO public.who_global_data_import VALUES (89853, '2020-09-11', 'AE', 'United Arab Emirates', 'EMRO', '930', '76911', '5', '398');
INSERT INTO public.who_global_data_import VALUES (89854, '2020-09-12', 'AE', 'United Arab Emirates', 'EMRO', '931', '77842', '0', '398');
INSERT INTO public.who_global_data_import VALUES (89855, '2020-09-13', 'AE', 'United Arab Emirates', 'EMRO', '1007', '78849', '1', '399');
INSERT INTO public.who_global_data_import VALUES (89856, '2020-09-14', 'AE', 'United Arab Emirates', 'EMRO', '640', '79489', '0', '399');
INSERT INTO public.who_global_data_import VALUES (89857, '2020-09-15', 'AE', 'United Arab Emirates', 'EMRO', '777', '80266', '0', '399');
INSERT INTO public.who_global_data_import VALUES (89858, '2020-09-16', 'AE', 'United Arab Emirates', 'EMRO', '674', '80940', '2', '401');
INSERT INTO public.who_global_data_import VALUES (89859, '2020-09-17', 'AE', 'United Arab Emirates', 'EMRO', '842', '81782', '1', '402');
INSERT INTO public.who_global_data_import VALUES (89860, '2020-09-18', 'AE', 'United Arab Emirates', 'EMRO', '786', '82568', '0', '402');
INSERT INTO public.who_global_data_import VALUES (89861, '2020-09-19', 'AE', 'United Arab Emirates', 'EMRO', '865', '83433', '1', '403');
INSERT INTO public.who_global_data_import VALUES (89862, '2020-09-20', 'AE', 'United Arab Emirates', 'EMRO', '809', '84242', '1', '404');
INSERT INTO public.who_global_data_import VALUES (89863, '2020-09-21', 'AE', 'United Arab Emirates', 'EMRO', '674', '84916', '0', '404');
INSERT INTO public.who_global_data_import VALUES (89864, '2020-09-22', 'AE', 'United Arab Emirates', 'EMRO', '679', '85595', '1', '405');
INSERT INTO public.who_global_data_import VALUES (89865, '2020-09-23', 'AE', 'United Arab Emirates', 'EMRO', '852', '86447', '0', '405');
INSERT INTO public.who_global_data_import VALUES (89866, '2020-09-24', 'AE', 'United Arab Emirates', 'EMRO', '1083', '87530', '1', '406');
INSERT INTO public.who_global_data_import VALUES (89867, '2020-09-25', 'AE', 'United Arab Emirates', 'EMRO', '1002', '88532', '1', '407');
INSERT INTO public.who_global_data_import VALUES (89868, '2020-09-26', 'AE', 'United Arab Emirates', 'EMRO', '1008', '89540', '2', '409');
INSERT INTO public.who_global_data_import VALUES (89869, '2020-09-27', 'AE', 'United Arab Emirates', 'EMRO', '1078', '90618', '2', '411');
INSERT INTO public.who_global_data_import VALUES (89870, '2020-09-28', 'AE', 'United Arab Emirates', 'EMRO', '851', '91469', '1', '412');
INSERT INTO public.who_global_data_import VALUES (89871, '2020-09-29', 'AE', 'United Arab Emirates', 'EMRO', '626', '92095', '1', '413');
INSERT INTO public.who_global_data_import VALUES (89872, '2020-09-30', 'AE', 'United Arab Emirates', 'EMRO', '995', '93090', '3', '416');
INSERT INTO public.who_global_data_import VALUES (89873, '2020-10-01', 'AE', 'United Arab Emirates', 'EMRO', '1100', '94190', '3', '419');
INSERT INTO public.who_global_data_import VALUES (89874, '2020-10-02', 'AE', 'United Arab Emirates', 'EMRO', '1158', '95348', '2', '421');
INSERT INTO public.who_global_data_import VALUES (89875, '2020-10-03', 'AE', 'United Arab Emirates', 'EMRO', '1181', '96529', '3', '424');
INSERT INTO public.who_global_data_import VALUES (89876, '2020-10-04', 'AE', 'United Arab Emirates', 'EMRO', '1231', '97760', '2', '426');
INSERT INTO public.who_global_data_import VALUES (89877, '2020-10-05', 'AE', 'United Arab Emirates', 'EMRO', '1041', '98801', '0', '426');
INSERT INTO public.who_global_data_import VALUES (89878, '2020-10-06', 'AE', 'United Arab Emirates', 'EMRO', '932', '99733', '3', '429');
INSERT INTO public.who_global_data_import VALUES (89879, '2020-10-07', 'AE', 'United Arab Emirates', 'EMRO', '1061', '100794', '6', '435');
INSERT INTO public.who_global_data_import VALUES (89880, '2020-10-08', 'AE', 'United Arab Emirates', 'EMRO', '1046', '101840', '1', '436');
INSERT INTO public.who_global_data_import VALUES (89881, '2020-10-09', 'AE', 'United Arab Emirates', 'EMRO', '1089', '102929', '2', '438');
INSERT INTO public.who_global_data_import VALUES (89882, '2020-10-10', 'AE', 'United Arab Emirates', 'EMRO', '1075', '104004', '4', '442');
INSERT INTO public.who_global_data_import VALUES (89883, '2020-10-11', 'AE', 'United Arab Emirates', 'EMRO', '1129', '105133', '1', '443');
INSERT INTO public.who_global_data_import VALUES (89884, '2020-10-12', 'AE', 'United Arab Emirates', 'EMRO', '1096', '106229', '2', '445');
INSERT INTO public.who_global_data_import VALUES (89885, '2020-10-13', 'AE', 'United Arab Emirates', 'EMRO', '1064', '107293', '1', '446');
INSERT INTO public.who_global_data_import VALUES (89886, '2020-10-14', 'AE', 'United Arab Emirates', 'EMRO', '1315', '108608', '2', '448');
INSERT INTO public.who_global_data_import VALUES (89887, '2020-10-15', 'AE', 'United Arab Emirates', 'EMRO', '1431', '110039', '2', '450');
INSERT INTO public.who_global_data_import VALUES (89888, '2020-10-16', 'AE', 'United Arab Emirates', 'EMRO', '1398', '111437', '2', '452');
INSERT INTO public.who_global_data_import VALUES (89889, '2020-10-17', 'AE', 'United Arab Emirates', 'EMRO', '1412', '112849', '3', '455');
INSERT INTO public.who_global_data_import VALUES (89890, '2020-10-18', 'AE', 'United Arab Emirates', 'EMRO', '1538', '114387', '4', '459');
INSERT INTO public.who_global_data_import VALUES (89891, '2020-10-19', 'AE', 'United Arab Emirates', 'EMRO', '1215', '115602', '4', '463');
INSERT INTO public.who_global_data_import VALUES (89892, '2020-10-20', 'AE', 'United Arab Emirates', 'EMRO', '915', '116517', '3', '466');
INSERT INTO public.who_global_data_import VALUES (89893, '2020-10-21', 'AE', 'United Arab Emirates', 'EMRO', '1077', '117594', '4', '470');
INSERT INTO public.who_global_data_import VALUES (89894, '2020-10-22', 'AE', 'United Arab Emirates', 'EMRO', '1538', '119132', '2', '472');
INSERT INTO public.who_global_data_import VALUES (89895, '2020-10-23', 'AE', 'United Arab Emirates', 'EMRO', '1578', '120710', '2', '474');
INSERT INTO public.who_global_data_import VALUES (89896, '2020-10-24', 'AE', 'United Arab Emirates', 'EMRO', '1563', '122273', '1', '475');
INSERT INTO public.who_global_data_import VALUES (89897, '2020-10-25', 'AE', 'United Arab Emirates', 'EMRO', '1491', '123764', '0', '475');
INSERT INTO public.who_global_data_import VALUES (89898, '2020-10-26', 'AE', 'United Arab Emirates', 'EMRO', '1359', '125123', '2', '477');
INSERT INTO public.who_global_data_import VALUES (89899, '2020-10-27', 'AE', 'United Arab Emirates', 'EMRO', '1111', '126234', '3', '480');
INSERT INTO public.who_global_data_import VALUES (89900, '2020-10-28', 'AE', 'United Arab Emirates', 'EMRO', '1390', '127624', '2', '482');
INSERT INTO public.who_global_data_import VALUES (89901, '2020-10-29', 'AE', 'United Arab Emirates', 'EMRO', '1400', '129024', '3', '485');
INSERT INTO public.who_global_data_import VALUES (89902, '2020-10-30', 'AE', 'United Arab Emirates', 'EMRO', '1312', '130336', '3', '488');
INSERT INTO public.who_global_data_import VALUES (89903, '2020-10-31', 'AE', 'United Arab Emirates', 'EMRO', '1172', '131508', '2', '490');
INSERT INTO public.who_global_data_import VALUES (89904, '2020-11-01', 'AE', 'United Arab Emirates', 'EMRO', '1121', '132629', '5', '495');
INSERT INTO public.who_global_data_import VALUES (89905, '2020-11-02', 'AE', 'United Arab Emirates', 'EMRO', '1278', '133907', '1', '496');
INSERT INTO public.who_global_data_import VALUES (89906, '2020-11-03', 'AE', 'United Arab Emirates', 'EMRO', '1234', '135141', '1', '497');
INSERT INTO public.who_global_data_import VALUES (89907, '2020-11-04', 'AE', 'United Arab Emirates', 'EMRO', '1008', '136149', '6', '503');
INSERT INTO public.who_global_data_import VALUES (89908, '2020-11-05', 'AE', 'United Arab Emirates', 'EMRO', '1161', '137310', '2', '505');
INSERT INTO public.who_global_data_import VALUES (89909, '2020-11-06', 'AE', 'United Arab Emirates', 'EMRO', '1289', '138599', '3', '508');
INSERT INTO public.who_global_data_import VALUES (89910, '2020-11-07', 'AE', 'United Arab Emirates', 'EMRO', '1292', '139891', '2', '510');
INSERT INTO public.who_global_data_import VALUES (89911, '2020-11-08', 'AE', 'United Arab Emirates', 'EMRO', '1141', '141032', '4', '514');
INSERT INTO public.who_global_data_import VALUES (89912, '2020-11-09', 'AE', 'United Arab Emirates', 'EMRO', '1111', '142143', '0', '514');
INSERT INTO public.who_global_data_import VALUES (89913, '2020-11-10', 'AE', 'United Arab Emirates', 'EMRO', '1146', '143289', '1', '515');
INSERT INTO public.who_global_data_import VALUES (89914, '2020-11-11', 'AE', 'United Arab Emirates', 'EMRO', '1096', '144385', '3', '518');
INSERT INTO public.who_global_data_import VALUES (92023, '2020-01-25', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (89915, '2020-11-12', 'AE', 'United Arab Emirates', 'EMRO', '1214', '145599', '2', '520');
INSERT INTO public.who_global_data_import VALUES (89916, '2020-11-13', 'AE', 'United Arab Emirates', 'EMRO', '1136', '146735', '3', '523');
INSERT INTO public.who_global_data_import VALUES (89917, '2020-11-14', 'AE', 'United Arab Emirates', 'EMRO', '1226', '147961', '5', '528');
INSERT INTO public.who_global_data_import VALUES (89918, '2020-11-15', 'AE', 'United Arab Emirates', 'EMRO', '1174', '149135', '0', '528');
INSERT INTO public.who_global_data_import VALUES (89919, '2020-11-16', 'AE', 'United Arab Emirates', 'EMRO', '1210', '150345', '2', '530');
INSERT INTO public.who_global_data_import VALUES (89920, '2020-11-17', 'AE', 'United Arab Emirates', 'EMRO', '1209', '151554', '4', '534');
INSERT INTO public.who_global_data_import VALUES (89921, '2020-11-18', 'AE', 'United Arab Emirates', 'EMRO', '1255', '152809', '4', '538');
INSERT INTO public.who_global_data_import VALUES (89922, '2020-11-19', 'AE', 'United Arab Emirates', 'EMRO', '1292', '154101', '4', '542');
INSERT INTO public.who_global_data_import VALUES (89923, '2020-11-20', 'AE', 'United Arab Emirates', 'EMRO', '1153', '155254', '2', '544');
INSERT INTO public.who_global_data_import VALUES (89924, '2020-11-21', 'AE', 'United Arab Emirates', 'EMRO', '1269', '156523', '3', '547');
INSERT INTO public.who_global_data_import VALUES (89925, '2020-11-22', 'AE', 'United Arab Emirates', 'EMRO', '1262', '157785', '1', '548');
INSERT INTO public.who_global_data_import VALUES (89926, '2020-11-23', 'AE', 'United Arab Emirates', 'EMRO', '1205', '158990', '4', '552');
INSERT INTO public.who_global_data_import VALUES (89927, '2020-11-24', 'AE', 'United Arab Emirates', 'EMRO', '1065', '160055', '2', '554');
INSERT INTO public.who_global_data_import VALUES (89928, '2020-11-25', 'AE', 'United Arab Emirates', 'EMRO', '1310', '161365', '5', '559');
INSERT INTO public.who_global_data_import VALUES (89929, '2020-11-26', 'AE', 'United Arab Emirates', 'EMRO', '1297', '162662', '4', '563');
INSERT INTO public.who_global_data_import VALUES (89930, '2020-11-27', 'AE', 'United Arab Emirates', 'EMRO', '1305', '163967', '1', '564');
INSERT INTO public.who_global_data_import VALUES (89931, '2020-11-28', 'AE', 'United Arab Emirates', 'EMRO', '1283', '165250', '3', '567');
INSERT INTO public.who_global_data_import VALUES (89932, '2020-11-29', 'AE', 'United Arab Emirates', 'EMRO', '1252', '166502', '2', '569');
INSERT INTO public.who_global_data_import VALUES (89933, '2020-11-30', 'AE', 'United Arab Emirates', 'EMRO', '1251', '167753', '1', '570');
INSERT INTO public.who_global_data_import VALUES (89934, '2020-12-01', 'AE', 'United Arab Emirates', 'EMRO', '1107', '168860', '2', '572');
INSERT INTO public.who_global_data_import VALUES (89935, '2020-12-02', 'AE', 'United Arab Emirates', 'EMRO', '1289', '170149', '4', '576');
INSERT INTO public.who_global_data_import VALUES (89936, '2020-12-03', 'AE', 'United Arab Emirates', 'EMRO', '1285', '171434', '4', '580');
INSERT INTO public.who_global_data_import VALUES (89937, '2020-12-04', 'AE', 'United Arab Emirates', 'EMRO', '1317', '172751', '5', '585');
INSERT INTO public.who_global_data_import VALUES (89938, '2020-12-05', 'AE', 'United Arab Emirates', 'EMRO', '1311', '174062', '1', '586');
INSERT INTO public.who_global_data_import VALUES (89939, '2020-12-06', 'AE', 'United Arab Emirates', 'EMRO', '1214', '175276', '3', '589');
INSERT INTO public.who_global_data_import VALUES (89940, '2020-12-07', 'AE', 'United Arab Emirates', 'EMRO', '1153', '176429', '3', '592');
INSERT INTO public.who_global_data_import VALUES (89941, '2020-12-08', 'AE', 'United Arab Emirates', 'EMRO', '1148', '177577', '2', '594');
INSERT INTO public.who_global_data_import VALUES (89942, '2020-12-09', 'AE', 'United Arab Emirates', 'EMRO', '1260', '178837', '2', '596');
INSERT INTO public.who_global_data_import VALUES (89943, '2020-12-10', 'AE', 'United Arab Emirates', 'EMRO', '1313', '180150', '2', '598');
INSERT INTO public.who_global_data_import VALUES (89944, '2020-12-11', 'AE', 'United Arab Emirates', 'EMRO', '1255', '181405', '4', '602');
INSERT INTO public.who_global_data_import VALUES (89945, '2020-12-12', 'AE', 'United Arab Emirates', 'EMRO', '1196', '182601', '5', '607');
INSERT INTO public.who_global_data_import VALUES (89946, '2020-12-13', 'AE', 'United Arab Emirates', 'EMRO', '1154', '183755', '2', '609');
INSERT INTO public.who_global_data_import VALUES (89947, '2020-12-14', 'AE', 'United Arab Emirates', 'EMRO', '1194', '184949', '8', '617');
INSERT INTO public.who_global_data_import VALUES (89948, '2020-12-15', 'AE', 'United Arab Emirates', 'EMRO', '1092', '186041', '1', '618');
INSERT INTO public.who_global_data_import VALUES (89949, '2020-12-16', 'AE', 'United Arab Emirates', 'EMRO', '1226', '187267', '4', '622');
INSERT INTO public.who_global_data_import VALUES (89950, '2020-12-17', 'AE', 'United Arab Emirates', 'EMRO', '1278', '188545', '4', '626');
INSERT INTO public.who_global_data_import VALUES (89951, '2020-12-18', 'AE', 'United Arab Emirates', 'EMRO', '1321', '189866', '3', '629');
INSERT INTO public.who_global_data_import VALUES (89952, '2020-12-19', 'AE', 'United Arab Emirates', 'EMRO', '1284', '191150', '1', '630');
INSERT INTO public.who_global_data_import VALUES (89953, '2020-12-20', 'AE', 'United Arab Emirates', 'EMRO', '1254', '192404', '4', '634');
INSERT INTO public.who_global_data_import VALUES (89954, '2020-12-21', 'AE', 'United Arab Emirates', 'EMRO', '1171', '193575', '3', '637');
INSERT INTO public.who_global_data_import VALUES (89955, '2020-12-22', 'AE', 'United Arab Emirates', 'EMRO', '1077', '194652', '2', '639');
INSERT INTO public.who_global_data_import VALUES (89956, '2020-12-23', 'AE', 'United Arab Emirates', 'EMRO', '1226', '195878', '3', '642');
INSERT INTO public.who_global_data_import VALUES (89957, '2020-12-24', 'AE', 'United Arab Emirates', 'EMRO', '1246', '197124', '3', '645');
INSERT INTO public.who_global_data_import VALUES (89958, '2020-12-25', 'AE', 'United Arab Emirates', 'EMRO', '1311', '198435', '2', '647');
INSERT INTO public.who_global_data_import VALUES (89959, '2020-12-26', 'AE', 'United Arab Emirates', 'EMRO', '1230', '199665', '6', '653');
INSERT INTO public.who_global_data_import VALUES (89960, '2020-12-27', 'AE', 'United Arab Emirates', 'EMRO', '1227', '200892', '2', '655');
INSERT INTO public.who_global_data_import VALUES (89961, '2020-12-28', 'AE', 'United Arab Emirates', 'EMRO', '944', '201836', '2', '657');
INSERT INTO public.who_global_data_import VALUES (89962, '2020-12-29', 'AE', 'United Arab Emirates', 'EMRO', '1027', '202863', '3', '660');
INSERT INTO public.who_global_data_import VALUES (89963, '2020-12-30', 'AE', 'United Arab Emirates', 'EMRO', '1506', '204369', '2', '662');
INSERT INTO public.who_global_data_import VALUES (89964, '2020-12-31', 'AE', 'United Arab Emirates', 'EMRO', '1723', '206092', '3', '665');
INSERT INTO public.who_global_data_import VALUES (89965, '2021-01-01', 'AE', 'United Arab Emirates', 'EMRO', '1730', '207822', '4', '669');
INSERT INTO public.who_global_data_import VALUES (89966, '2021-01-02', 'AE', 'United Arab Emirates', 'EMRO', '1856', '209678', '2', '671');
INSERT INTO public.who_global_data_import VALUES (89967, '2021-01-03', 'AE', 'United Arab Emirates', 'EMRO', '1963', '211641', '3', '674');
INSERT INTO public.who_global_data_import VALUES (89968, '2021-01-04', 'AE', 'United Arab Emirates', 'EMRO', '1590', '213231', '5', '679');
INSERT INTO public.who_global_data_import VALUES (89969, '2021-01-05', 'AE', 'United Arab Emirates', 'EMRO', '1501', '214732', '3', '682');
INSERT INTO public.who_global_data_import VALUES (89970, '2021-01-06', 'AE', 'United Arab Emirates', 'EMRO', '1967', '216699', '3', '685');
INSERT INTO public.who_global_data_import VALUES (89971, '2021-01-07', 'AE', 'United Arab Emirates', 'EMRO', '2067', '218766', '4', '689');
INSERT INTO public.who_global_data_import VALUES (89972, '2021-01-08', 'AE', 'United Arab Emirates', 'EMRO', '2988', '221754', '5', '694');
INSERT INTO public.who_global_data_import VALUES (89973, '2021-01-09', 'AE', 'United Arab Emirates', 'EMRO', '2950', '224704', '3', '697');
INSERT INTO public.who_global_data_import VALUES (89974, '2021-01-10', 'AE', 'United Arab Emirates', 'EMRO', '2998', '227702', '5', '702');
INSERT INTO public.who_global_data_import VALUES (89975, '2021-01-11', 'AE', 'United Arab Emirates', 'EMRO', '2876', '230578', '6', '708');
INSERT INTO public.who_global_data_import VALUES (89976, '2021-01-12', 'AE', 'United Arab Emirates', 'EMRO', '2404', '232982', '3', '711');
INSERT INTO public.who_global_data_import VALUES (89977, '2021-01-13', 'AE', 'United Arab Emirates', 'EMRO', '3243', '236225', '6', '717');
INSERT INTO public.who_global_data_import VALUES (89978, '2021-01-14', 'AE', 'United Arab Emirates', 'EMRO', '3362', '239587', '6', '723');
INSERT INTO public.who_global_data_import VALUES (89979, '2021-01-15', 'AE', 'United Arab Emirates', 'EMRO', '3382', '242969', '3', '726');
INSERT INTO public.who_global_data_import VALUES (89980, '2021-01-16', 'AE', 'United Arab Emirates', 'EMRO', '3407', '246376', '7', '733');
INSERT INTO public.who_global_data_import VALUES (89981, '2021-01-17', 'AE', 'United Arab Emirates', 'EMRO', '3432', '249808', '7', '740');
INSERT INTO public.who_global_data_import VALUES (89982, '2021-01-18', 'AE', 'United Arab Emirates', 'EMRO', '3453', '253261', '5', '745');
INSERT INTO public.who_global_data_import VALUES (89983, '2021-01-19', 'AE', 'United Arab Emirates', 'EMRO', '3471', '256732', '6', '751');
INSERT INTO public.who_global_data_import VALUES (89984, '2021-01-20', 'AE', 'United Arab Emirates', 'EMRO', '3491', '260223', '5', '756');
INSERT INTO public.who_global_data_import VALUES (89985, '2021-01-21', 'AE', 'United Arab Emirates', 'EMRO', '3506', '263729', '6', '762');
INSERT INTO public.who_global_data_import VALUES (89986, '2021-01-22', 'AE', 'United Arab Emirates', 'EMRO', '3529', '267258', '4', '766');
INSERT INTO public.who_global_data_import VALUES (89987, '2021-01-23', 'AE', 'United Arab Emirates', 'EMRO', '3552', '270810', '10', '776');
INSERT INTO public.who_global_data_import VALUES (89988, '2021-01-24', 'AE', 'United Arab Emirates', 'EMRO', '3566', '274376', '7', '783');
INSERT INTO public.who_global_data_import VALUES (89989, '2021-01-25', 'AE', 'United Arab Emirates', 'EMRO', '3579', '277955', '9', '792');
INSERT INTO public.who_global_data_import VALUES (89990, '2021-01-26', 'AE', 'United Arab Emirates', 'EMRO', '3591', '281546', '6', '798');
INSERT INTO public.who_global_data_import VALUES (89991, '2021-01-27', 'AE', 'United Arab Emirates', 'EMRO', '3601', '285147', '7', '805');
INSERT INTO public.who_global_data_import VALUES (89992, '2021-01-28', 'AE', 'United Arab Emirates', 'EMRO', '3939', '289086', '6', '811');
INSERT INTO public.who_global_data_import VALUES (89993, '2021-01-29', 'AE', 'United Arab Emirates', 'EMRO', '3966', '293052', '8', '819');
INSERT INTO public.who_global_data_import VALUES (89994, '2021-01-30', 'AE', 'United Arab Emirates', 'EMRO', '3962', '297014', '7', '826');
INSERT INTO public.who_global_data_import VALUES (89995, '2021-01-31', 'AE', 'United Arab Emirates', 'EMRO', '3647', '300661', '12', '838');
INSERT INTO public.who_global_data_import VALUES (89996, '2021-02-01', 'AE', 'United Arab Emirates', 'EMRO', '2948', '303609', '12', '850');
INSERT INTO public.who_global_data_import VALUES (89997, '2021-02-02', 'AE', 'United Arab Emirates', 'EMRO', '2730', '306339', '9', '859');
INSERT INTO public.who_global_data_import VALUES (89998, '2021-02-03', 'AE', 'United Arab Emirates', 'EMRO', '3310', '309649', '7', '866');
INSERT INTO public.who_global_data_import VALUES (89999, '2021-02-04', 'AE', 'United Arab Emirates', 'EMRO', '3977', '313626', '12', '878');
INSERT INTO public.who_global_data_import VALUES (90000, '2021-02-05', 'AE', 'United Arab Emirates', 'EMRO', '3249', '316875', '10', '888');
INSERT INTO public.who_global_data_import VALUES (90001, '2020-01-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90002, '2020-01-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92024, '2020-01-26', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90003, '2020-01-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90004, '2020-01-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90005, '2020-01-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90006, '2020-01-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90007, '2020-01-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90008, '2020-01-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90009, '2020-01-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90010, '2020-01-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90011, '2020-01-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90012, '2020-01-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90013, '2020-01-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90014, '2020-01-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90015, '2020-01-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90016, '2020-01-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90017, '2020-01-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90018, '2020-01-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90019, '2020-01-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90020, '2020-01-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90021, '2020-01-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90022, '2020-01-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90023, '2020-01-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90024, '2020-01-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90025, '2020-01-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90026, '2020-01-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90027, '2020-01-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90028, '2020-01-30', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90029, '2020-01-31', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90030, '2020-02-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90031, '2020-02-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90032, '2020-02-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90033, '2020-02-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90034, '2020-02-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90035, '2020-02-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90036, '2020-02-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90037, '2020-02-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90038, '2020-02-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90039, '2020-02-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90040, '2020-02-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90041, '2020-02-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90042, '2020-02-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90043, '2020-02-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90044, '2020-02-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90045, '2020-02-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90046, '2020-02-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90047, '2020-02-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90048, '2020-02-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90049, '2020-02-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90050, '2020-02-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90051, '2020-02-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90052, '2020-02-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90053, '2020-02-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90054, '2020-02-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90055, '2020-02-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90056, '2020-02-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90057, '2020-02-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90058, '2020-02-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90059, '2020-03-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90060, '2020-03-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90061, '2020-03-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90062, '2020-03-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90063, '2020-03-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90064, '2020-03-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90065, '2020-03-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90066, '2020-03-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90067, '2020-03-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90068, '2020-03-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90069, '2020-03-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90070, '2020-03-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90071, '2020-03-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90072, '2020-03-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90073, '2020-03-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90074, '2020-03-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90075, '2020-03-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90076, '2020-03-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '2', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90077, '2020-03-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '3', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90078, '2020-03-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90079, '2020-03-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90080, '2020-03-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90081, '2020-03-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '2', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90082, '2020-03-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90083, '2020-03-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90084, '2020-03-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '1', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90085, '2020-03-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90086, '2020-03-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90087, '2020-03-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '1', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90088, '2020-03-30', 'TZ', 'United Republic of Tanzania', 'AFRO', '5', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90089, '2020-03-31', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90090, '2020-04-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '1', '20', '1', '1');
INSERT INTO public.who_global_data_import VALUES (92025, '2020-01-27', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90091, '2020-04-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90092, '2020-04-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90093, '2020-04-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90094, '2020-04-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '20', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90095, '2020-04-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '2', '22', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90096, '2020-04-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '2', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90097, '2020-04-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '24', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90098, '2020-04-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '1', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90099, '2020-04-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '25', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90100, '2020-04-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '7', '32', '2', '3');
INSERT INTO public.who_global_data_import VALUES (90101, '2020-04-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '32', '0', '3');
INSERT INTO public.who_global_data_import VALUES (90102, '2020-04-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '32', '0', '3');
INSERT INTO public.who_global_data_import VALUES (90103, '2020-04-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '17', '49', '0', '3');
INSERT INTO public.who_global_data_import VALUES (90104, '2020-04-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '4', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (90105, '2020-04-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '35', '88', '1', '4');
INSERT INTO public.who_global_data_import VALUES (90106, '2020-04-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '6', '94', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90107, '2020-04-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '54', '148', '1', '5');
INSERT INTO public.who_global_data_import VALUES (90108, '2020-04-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '148', '0', '5');
INSERT INTO public.who_global_data_import VALUES (90109, '2020-04-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '23', '171', '2', '7');
INSERT INTO public.who_global_data_import VALUES (90110, '2020-04-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '84', '255', '3', '10');
INSERT INTO public.who_global_data_import VALUES (90111, '2020-04-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '255', '0', '10');
INSERT INTO public.who_global_data_import VALUES (90112, '2020-04-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '30', '285', '0', '10');
INSERT INTO public.who_global_data_import VALUES (90113, '2020-04-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '285', '0', '10');
INSERT INTO public.who_global_data_import VALUES (90114, '2020-04-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '15', '300', '0', '10');
INSERT INTO public.who_global_data_import VALUES (90115, '2020-04-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '300', '0', '10');
INSERT INTO public.who_global_data_import VALUES (90116, '2020-04-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '300', '0', '10');
INSERT INTO public.who_global_data_import VALUES (90117, '2020-04-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '300', '0', '10');
INSERT INTO public.who_global_data_import VALUES (90118, '2020-04-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '300', '0', '10');
INSERT INTO public.who_global_data_import VALUES (90119, '2020-04-30', 'TZ', 'United Republic of Tanzania', 'AFRO', '180', '480', '6', '16');
INSERT INTO public.who_global_data_import VALUES (90120, '2020-05-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '480', '1', '17');
INSERT INTO public.who_global_data_import VALUES (90121, '2020-05-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '480', '0', '17');
INSERT INTO public.who_global_data_import VALUES (90122, '2020-05-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '480', '1', '18');
INSERT INTO public.who_global_data_import VALUES (90123, '2020-05-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '480', '0', '18');
INSERT INTO public.who_global_data_import VALUES (90124, '2020-05-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '480', '0', '18');
INSERT INTO public.who_global_data_import VALUES (90125, '2020-05-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '480', '0', '18');
INSERT INTO public.who_global_data_import VALUES (90126, '2020-05-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '480', '0', '18');
INSERT INTO public.who_global_data_import VALUES (90127, '2020-05-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '29', '509', '3', '21');
INSERT INTO public.who_global_data_import VALUES (90128, '2020-05-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90129, '2020-05-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90130, '2020-05-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90131, '2020-05-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90132, '2020-05-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90133, '2020-05-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90134, '2020-05-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90135, '2020-05-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90136, '2020-05-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90137, '2020-05-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90138, '2020-05-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90139, '2020-05-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90140, '2020-05-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90141, '2020-05-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90142, '2020-05-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90143, '2020-05-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90144, '2020-05-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90145, '2020-05-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90146, '2020-05-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90147, '2020-05-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90148, '2020-05-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90149, '2020-05-30', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90150, '2020-05-31', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90151, '2020-06-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90152, '2020-06-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90153, '2020-06-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90154, '2020-06-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90155, '2020-06-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90156, '2020-06-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90157, '2020-06-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90158, '2020-06-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90159, '2020-06-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90160, '2020-06-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90161, '2020-06-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90162, '2020-06-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90163, '2020-06-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90164, '2020-06-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90165, '2020-06-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90166, '2020-06-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90167, '2020-06-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90168, '2020-06-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90169, '2020-06-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90170, '2020-06-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90171, '2020-06-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90172, '2020-06-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90173, '2020-06-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90174, '2020-06-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90175, '2020-06-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90176, '2020-06-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90177, '2020-06-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90178, '2020-06-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (92026, '2020-01-28', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90179, '2020-06-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90180, '2020-06-30', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90181, '2020-07-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90182, '2020-07-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90183, '2020-07-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90184, '2020-07-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90185, '2020-07-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90186, '2020-07-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90187, '2020-07-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90188, '2020-07-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90189, '2020-07-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90190, '2020-07-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90191, '2020-07-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90192, '2020-07-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90193, '2020-07-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90194, '2020-07-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90195, '2020-07-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90196, '2020-07-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90197, '2020-07-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90198, '2020-07-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90199, '2020-07-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90200, '2020-07-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90201, '2020-07-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90202, '2020-07-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90203, '2020-07-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90204, '2020-07-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90205, '2020-07-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90206, '2020-07-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90207, '2020-07-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90208, '2020-07-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90209, '2020-07-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90210, '2020-07-30', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90211, '2020-07-31', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90212, '2020-08-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90213, '2020-08-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90214, '2020-08-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90215, '2020-08-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90216, '2020-08-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90217, '2020-08-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90218, '2020-08-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90219, '2020-08-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90220, '2020-08-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90221, '2020-08-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90222, '2020-08-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90223, '2020-08-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90224, '2020-08-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90225, '2020-08-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90226, '2020-08-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90227, '2020-08-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90228, '2020-08-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90229, '2020-08-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90230, '2020-08-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90231, '2020-08-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90232, '2020-08-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90233, '2020-08-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90234, '2020-08-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90235, '2020-08-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90236, '2020-08-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90237, '2020-08-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90238, '2020-08-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90239, '2020-08-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90240, '2020-08-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90241, '2020-08-30', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90242, '2020-08-31', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90243, '2020-09-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90244, '2020-09-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90245, '2020-09-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90246, '2020-09-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90247, '2020-09-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90248, '2020-09-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90249, '2020-09-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90250, '2020-09-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90251, '2020-09-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90252, '2020-09-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90253, '2020-09-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90254, '2020-09-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90255, '2020-09-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90256, '2020-09-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90257, '2020-09-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90258, '2020-09-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90259, '2020-09-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90260, '2020-09-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90261, '2020-09-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90262, '2020-09-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90263, '2020-09-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90264, '2020-09-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90265, '2020-09-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90266, '2020-09-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (92027, '2020-01-29', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90267, '2020-09-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90268, '2020-09-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90269, '2020-09-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90270, '2020-09-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90271, '2020-09-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90272, '2020-09-30', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90273, '2020-10-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90274, '2020-10-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90275, '2020-10-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90276, '2020-10-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90277, '2020-10-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90278, '2020-10-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90279, '2020-10-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90280, '2020-10-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90281, '2020-10-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90282, '2020-10-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90283, '2020-10-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90284, '2020-10-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90285, '2020-10-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90286, '2020-10-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90287, '2020-10-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90288, '2020-10-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90289, '2020-10-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90290, '2020-10-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90291, '2020-10-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90292, '2020-10-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90293, '2020-10-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90294, '2020-10-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90295, '2020-10-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90296, '2020-10-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90297, '2020-10-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90298, '2020-10-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90299, '2020-10-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90300, '2020-10-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90301, '2020-10-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90302, '2020-10-30', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90303, '2020-10-31', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90304, '2020-11-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90305, '2020-11-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90306, '2020-11-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90307, '2020-11-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90308, '2020-11-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90309, '2020-11-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90310, '2020-11-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90311, '2020-11-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90312, '2020-11-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90313, '2020-11-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90314, '2020-11-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90315, '2020-11-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90316, '2020-11-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90317, '2020-11-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90318, '2020-11-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90319, '2020-11-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90320, '2020-11-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90321, '2020-11-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90322, '2020-11-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90323, '2020-11-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90324, '2020-11-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90325, '2020-11-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90326, '2020-11-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90327, '2020-11-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90328, '2020-11-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90329, '2020-11-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90330, '2020-11-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90331, '2020-11-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90332, '2020-11-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90333, '2020-11-30', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90334, '2020-12-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90335, '2020-12-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90336, '2020-12-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90337, '2020-12-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90338, '2020-12-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90339, '2020-12-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90340, '2020-12-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90341, '2020-12-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90342, '2020-12-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90343, '2020-12-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90344, '2020-12-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90345, '2020-12-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90346, '2020-12-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90347, '2020-12-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90348, '2020-12-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90349, '2020-12-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90350, '2020-12-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90351, '2020-12-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90352, '2020-12-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90353, '2020-12-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90354, '2020-12-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (92028, '2020-01-30', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90355, '2020-12-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90356, '2020-12-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90357, '2020-12-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90358, '2020-12-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90359, '2020-12-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90360, '2020-12-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90361, '2020-12-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90362, '2020-12-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90363, '2020-12-30', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90364, '2020-12-31', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90365, '2021-01-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90366, '2021-01-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90367, '2021-01-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90368, '2021-01-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90369, '2021-01-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90370, '2021-01-06', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90371, '2021-01-07', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90372, '2021-01-08', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90373, '2021-01-09', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90374, '2021-01-10', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90375, '2021-01-11', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90376, '2021-01-12', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90377, '2021-01-13', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90378, '2021-01-14', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90379, '2021-01-15', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90380, '2021-01-16', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90381, '2021-01-17', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90382, '2021-01-18', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90383, '2021-01-19', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90384, '2021-01-20', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90385, '2021-01-21', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90386, '2021-01-22', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90387, '2021-01-23', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90388, '2021-01-24', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90389, '2021-01-25', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90390, '2021-01-26', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90391, '2021-01-27', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90392, '2021-01-28', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90393, '2021-01-29', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90394, '2021-01-30', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90395, '2021-01-31', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90396, '2021-02-01', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90397, '2021-02-02', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90398, '2021-02-03', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90399, '2021-02-04', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90400, '2021-02-05', 'TZ', 'United Republic of Tanzania', 'AFRO', '0', '509', '0', '21');
INSERT INTO public.who_global_data_import VALUES (90401, '2020-01-03', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90402, '2020-01-04', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90403, '2020-01-05', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90404, '2020-01-06', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90405, '2020-01-07', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90406, '2020-01-08', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90407, '2020-01-09', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90408, '2020-01-10', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90409, '2020-01-11', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90410, '2020-01-12', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90411, '2020-01-13', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90412, '2020-01-14', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90413, '2020-01-15', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90414, '2020-01-16', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90415, '2020-01-17', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90416, '2020-01-18', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90417, '2020-01-19', 'US', 'United States of America', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90418, '2020-01-20', 'US', 'United States of America', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90419, '2020-01-21', 'US', 'United States of America', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90420, '2020-01-22', 'US', 'United States of America', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90421, '2020-01-23', 'US', 'United States of America', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90422, '2020-01-24', 'US', 'United States of America', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90423, '2020-01-25', 'US', 'United States of America', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90424, '2020-01-26', 'US', 'United States of America', 'AMRO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90425, '2020-01-27', 'US', 'United States of America', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90426, '2020-01-28', 'US', 'United States of America', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90427, '2020-01-29', 'US', 'United States of America', 'AMRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90428, '2020-01-30', 'US', 'United States of America', 'AMRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90429, '2020-01-31', 'US', 'United States of America', 'AMRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90430, '2020-02-01', 'US', 'United States of America', 'AMRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90431, '2020-02-02', 'US', 'United States of America', 'AMRO', '0', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90432, '2020-02-03', 'US', 'United States of America', 'AMRO', '3', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90433, '2020-02-04', 'US', 'United States of America', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90434, '2020-02-05', 'US', 'United States of America', 'AMRO', '0', '15', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90435, '2020-02-06', 'US', 'United States of America', 'AMRO', '1', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90436, '2020-02-07', 'US', 'United States of America', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90437, '2020-02-08', 'US', 'United States of America', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90438, '2020-02-09', 'US', 'United States of America', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90439, '2020-02-10', 'US', 'United States of America', 'AMRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90440, '2020-02-11', 'US', 'United States of America', 'AMRO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90441, '2020-02-12', 'US', 'United States of America', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90442, '2020-02-13', 'US', 'United States of America', 'AMRO', '2', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90443, '2020-02-14', 'US', 'United States of America', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90444, '2020-02-15', 'US', 'United States of America', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90445, '2020-02-16', 'US', 'United States of America', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90446, '2020-02-17', 'US', 'United States of America', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90447, '2020-02-18', 'US', 'United States of America', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90448, '2020-02-19', 'US', 'United States of America', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90449, '2020-02-20', 'US', 'United States of America', 'AMRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90450, '2020-02-21', 'US', 'United States of America', 'AMRO', '19', '38', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90451, '2020-02-22', 'US', 'United States of America', 'AMRO', '1', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90452, '2020-02-23', 'US', 'United States of America', 'AMRO', '0', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90453, '2020-02-24', 'US', 'United States of America', 'AMRO', '18', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90454, '2020-02-25', 'US', 'United States of America', 'AMRO', '0', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90455, '2020-02-26', 'US', 'United States of America', 'AMRO', '6', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90456, '2020-02-27', 'US', 'United States of America', 'AMRO', '0', '63', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90457, '2020-02-28', 'US', 'United States of America', 'AMRO', '3', '66', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90458, '2020-02-29', 'US', 'United States of America', 'AMRO', '0', '66', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90459, '2020-03-01', 'US', 'United States of America', 'AMRO', '0', '66', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90460, '2020-03-02', 'US', 'United States of America', 'AMRO', '2', '68', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90461, '2020-03-03', 'US', 'United States of America', 'AMRO', '44', '112', '2', '2');
INSERT INTO public.who_global_data_import VALUES (90462, '2020-03-04', 'US', 'United States of America', 'AMRO', '21', '133', '3', '5');
INSERT INTO public.who_global_data_import VALUES (90463, '2020-03-05', 'US', 'United States of America', 'AMRO', '0', '133', '4', '9');
INSERT INTO public.who_global_data_import VALUES (90464, '2020-03-06', 'US', 'United States of America', 'AMRO', '84', '217', '2', '11');
INSERT INTO public.who_global_data_import VALUES (90465, '2020-03-07', 'US', 'United States of America', 'AMRO', '0', '217', '0', '11');
INSERT INTO public.who_global_data_import VALUES (90466, '2020-03-08', 'US', 'United States of America', 'AMRO', '0', '217', '0', '11');
INSERT INTO public.who_global_data_import VALUES (90467, '2020-03-09', 'US', 'United States of America', 'AMRO', '259', '476', '8', '19');
INSERT INTO public.who_global_data_import VALUES (90468, '2020-03-10', 'US', 'United States of America', 'AMRO', '224', '700', '6', '25');
INSERT INTO public.who_global_data_import VALUES (90469, '2020-03-11', 'US', 'United States of America', 'AMRO', '0', '700', '0', '25');
INSERT INTO public.who_global_data_import VALUES (90470, '2020-03-12', 'US', 'United States of America', 'AMRO', '291', '991', '4', '29');
INSERT INTO public.who_global_data_import VALUES (90471, '2020-03-13', 'US', 'United States of America', 'AMRO', '277', '1268', '7', '36');
INSERT INTO public.who_global_data_import VALUES (90472, '2020-03-14', 'US', 'United States of America', 'AMRO', '414', '1682', '5', '41');
INSERT INTO public.who_global_data_import VALUES (90473, '2020-03-15', 'US', 'United States of America', 'AMRO', '36', '1718', '0', '41');
INSERT INTO public.who_global_data_import VALUES (90474, '2020-03-16', 'US', 'United States of America', 'AMRO', '0', '1718', '0', '41');
INSERT INTO public.who_global_data_import VALUES (90475, '2020-03-17', 'US', 'United States of America', 'AMRO', '1822', '3540', '17', '58');
INSERT INTO public.who_global_data_import VALUES (90476, '2020-03-18', 'US', 'United States of America', 'AMRO', '3551', '7091', '42', '100');
INSERT INTO public.who_global_data_import VALUES (90477, '2020-03-19', 'US', 'United States of America', 'AMRO', '3351', '10442', '50', '150');
INSERT INTO public.who_global_data_import VALUES (90478, '2020-03-20', 'US', 'United States of America', 'AMRO', '4777', '15219', '51', '201');
INSERT INTO public.who_global_data_import VALUES (90479, '2020-03-21', 'US', 'United States of America', 'AMRO', '0', '15219', '0', '201');
INSERT INTO public.who_global_data_import VALUES (90480, '2020-03-22', 'US', 'United States of America', 'AMRO', '0', '15219', '0', '201');
INSERT INTO public.who_global_data_import VALUES (90481, '2020-03-23', 'US', 'United States of America', 'AMRO', '16354', '31573', '201', '402');
INSERT INTO public.who_global_data_import VALUES (90482, '2020-03-24', 'US', 'United States of America', 'AMRO', '20341', '51914', '271', '673');
INSERT INTO public.who_global_data_import VALUES (90483, '2020-03-25', 'US', 'United States of America', 'AMRO', '0', '51914', '0', '673');
INSERT INTO public.who_global_data_import VALUES (90484, '2020-03-26', 'US', 'United States of America', 'AMRO', '16420', '68334', '318', '991');
INSERT INTO public.who_global_data_import VALUES (90485, '2020-03-27', 'US', 'United States of America', 'AMRO', '0', '68334', '0', '991');
INSERT INTO public.who_global_data_import VALUES (90486, '2020-03-28', 'US', 'United States of America', 'AMRO', '16894', '85228', '252', '1243');
INSERT INTO public.who_global_data_import VALUES (90487, '2020-03-29', 'US', 'United States of America', 'AMRO', '18093', '103321', '425', '1668');
INSERT INTO public.who_global_data_import VALUES (90488, '2020-03-30', 'US', 'United States of America', 'AMRO', '19332', '122653', '444', '2112');
INSERT INTO public.who_global_data_import VALUES (90489, '2020-03-31', 'US', 'United States of America', 'AMRO', '17987', '140640', '286', '2398');
INSERT INTO public.who_global_data_import VALUES (90490, '2020-04-01', 'US', 'United States of America', 'AMRO', '22559', '163199', '452', '2850');
INSERT INTO public.who_global_data_import VALUES (90491, '2020-04-02', 'US', 'United States of America', 'AMRO', '24103', '187302', '996', '3846');
INSERT INTO public.who_global_data_import VALUES (90492, '2020-04-03', 'US', 'United States of America', 'AMRO', '26298', '213600', '947', '4793');
INSERT INTO public.who_global_data_import VALUES (90493, '2020-04-04', 'US', 'United States of America', 'AMRO', '28103', '241703', '1061', '5854');
INSERT INTO public.who_global_data_import VALUES (90494, '2020-04-05', 'US', 'United States of America', 'AMRO', '32105', '273808', '1166', '7020');
INSERT INTO public.who_global_data_import VALUES (90495, '2020-04-06', 'US', 'United States of America', 'AMRO', '33510', '307318', '1338', '8358');
INSERT INTO public.who_global_data_import VALUES (90496, '2020-04-07', 'US', 'United States of America', 'AMRO', '26493', '333811', '1201', '9559');
INSERT INTO public.who_global_data_import VALUES (90497, '2020-04-08', 'US', 'United States of America', 'AMRO', '29510', '363321', '1286', '10845');
INSERT INTO public.who_global_data_import VALUES (90498, '2020-04-09', 'US', 'United States of America', 'AMRO', '31709', '395030', '1895', '12740');
INSERT INTO public.who_global_data_import VALUES (90499, '2020-04-10', 'US', 'United States of America', 'AMRO', '30859', '425889', '1925', '14665');
INSERT INTO public.who_global_data_import VALUES (90500, '2020-04-11', 'US', 'United States of America', 'AMRO', '35386', '461275', '1931', '16596');
INSERT INTO public.who_global_data_import VALUES (90501, '2020-04-12', 'US', 'United States of America', 'AMRO', '31606', '492881', '1920', '18516');
INSERT INTO public.who_global_data_import VALUES (90502, '2020-04-13', 'US', 'United States of America', 'AMRO', '31633', '524514', '1928', '20444');
INSERT INTO public.who_global_data_import VALUES (90503, '2020-04-14', 'US', 'United States of America', 'AMRO', '29308', '553822', '1528', '21972');
INSERT INTO public.who_global_data_import VALUES (90504, '2020-04-15', 'US', 'United States of America', 'AMRO', '24446', '578268', '1504', '23476');
INSERT INTO public.who_global_data_import VALUES (90505, '2020-04-16', 'US', 'United States of America', 'AMRO', '25802', '604070', '2395', '25871');
INSERT INTO public.who_global_data_import VALUES (90506, '2020-04-17', 'US', 'United States of America', 'AMRO', '28711', '632781', '6409', '32280');
INSERT INTO public.who_global_data_import VALUES (90507, '2020-04-18', 'US', 'United States of America', 'AMRO', '32549', '665330', '2018', '34298');
INSERT INTO public.who_global_data_import VALUES (90508, '2020-04-19', 'US', 'United States of America', 'AMRO', '30023', '695353', '2438', '36736');
INSERT INTO public.who_global_data_import VALUES (90509, '2020-04-20', 'US', 'United States of America', 'AMRO', '28252', '723605', '1776', '38512');
INSERT INTO public.who_global_data_import VALUES (90510, '2020-04-21', 'US', 'United States of America', 'AMRO', '27668', '751273', '1801', '40313');
INSERT INTO public.who_global_data_import VALUES (90511, '2020-04-22', 'US', 'United States of America', 'AMRO', '25634', '776907', '2154', '42467');
INSERT INTO public.who_global_data_import VALUES (90512, '2020-04-23', 'US', 'United States of America', 'AMRO', '24019', '800926', '2575', '45042');
INSERT INTO public.who_global_data_import VALUES (90513, '2020-04-24', 'US', 'United States of America', 'AMRO', '29127', '830053', '2390', '47432');
INSERT INTO public.who_global_data_import VALUES (90514, '2020-04-25', 'US', 'United States of America', 'AMRO', '30719', '860772', '1742', '49174');
INSERT INTO public.who_global_data_import VALUES (90515, '2020-04-26', 'US', 'United States of America', 'AMRO', '38509', '899281', '2151', '51325');
INSERT INTO public.who_global_data_import VALUES (90516, '2020-04-27', 'US', 'United States of America', 'AMRO', '32417', '931698', '1964', '53289');
INSERT INTO public.who_global_data_import VALUES (90517, '2020-04-28', 'US', 'United States of America', 'AMRO', '29218', '960916', '1109', '54398');
INSERT INTO public.who_global_data_import VALUES (90518, '2020-04-29', 'US', 'United States of America', 'AMRO', '22541', '983457', '1322', '55720');
INSERT INTO public.who_global_data_import VALUES (90519, '2020-04-30', 'US', 'United States of America', 'AMRO', '20517', '1003974', '2010', '57730');
INSERT INTO public.who_global_data_import VALUES (90520, '2020-05-01', 'US', 'United States of America', 'AMRO', '31379', '1035353', '2902', '60632');
INSERT INTO public.who_global_data_import VALUES (90521, '2020-05-02', 'US', 'United States of America', 'AMRO', '31774', '1067127', '2005', '62637');
INSERT INTO public.who_global_data_import VALUES (90522, '2020-05-03', 'US', 'United States of America', 'AMRO', '26753', '1093880', '5000', '67637');
INSERT INTO public.who_global_data_import VALUES (90523, '2020-05-04', 'US', 'United States of America', 'AMRO', '31839', '1125719', '156', '67793');
INSERT INTO public.who_global_data_import VALUES (90524, '2020-05-05', 'US', 'United States of America', 'AMRO', '29266', '1154985', '-514', '67279');
INSERT INTO public.who_global_data_import VALUES (90525, '2020-05-06', 'US', 'United States of America', 'AMRO', '16200', '1171185', '802', '68081');
INSERT INTO public.who_global_data_import VALUES (90526, '2020-05-07', 'US', 'United States of America', 'AMRO', '22267', '1193452', '2475', '70556');
INSERT INTO public.who_global_data_import VALUES (90527, '2020-05-08', 'US', 'United States of America', 'AMRO', '22119', '1215571', '1968', '72524');
INSERT INTO public.who_global_data_import VALUES (90528, '2020-05-09', 'US', 'United States of America', 'AMRO', '30204', '1245775', '2840', '75364');
INSERT INTO public.who_global_data_import VALUES (92029, '2020-01-31', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90529, '2020-05-10', 'US', 'United States of America', 'AMRO', '25870', '1271645', '1552', '76916');
INSERT INTO public.who_global_data_import VALUES (90530, '2020-05-11', 'US', 'United States of America', 'AMRO', '26642', '1298287', '1736', '78652');
INSERT INTO public.who_global_data_import VALUES (90531, '2020-05-12', 'US', 'United States of America', 'AMRO', '23767', '1322054', '982', '79634');
INSERT INTO public.who_global_data_import VALUES (90532, '2020-05-13', 'US', 'United States of America', 'AMRO', '18044', '1340098', '1061', '80695');
INSERT INTO public.who_global_data_import VALUES (90533, '2020-05-14', 'US', 'United States of America', 'AMRO', '21424', '1361522', '1424', '82119');
INSERT INTO public.who_global_data_import VALUES (90534, '2020-05-15', 'US', 'United States of America', 'AMRO', '20840', '1382362', '1700', '83819');
INSERT INTO public.who_global_data_import VALUES (90535, '2020-05-16', 'US', 'United States of America', 'AMRO', '27090', '1409452', '2041', '85860');
INSERT INTO public.who_global_data_import VALUES (90536, '2020-05-17', 'US', 'United States of America', 'AMRO', '22813', '1432265', '1320', '87180');
INSERT INTO public.who_global_data_import VALUES (90537, '2020-05-18', 'US', 'United States of America', 'AMRO', '31967', '1464232', '1394', '88574');
INSERT INTO public.who_global_data_import VALUES (90538, '2020-05-19', 'US', 'United States of America', 'AMRO', '13227', '1477459', '697', '89271');
INSERT INTO public.who_global_data_import VALUES (90539, '2020-05-20', 'US', 'United States of America', 'AMRO', '24417', '1501876', '932', '90203');
INSERT INTO public.who_global_data_import VALUES (90540, '2020-05-21', 'US', 'United States of America', 'AMRO', '23310', '1525186', '1324', '91527');
INSERT INTO public.who_global_data_import VALUES (90541, '2020-05-22', 'US', 'United States of America', 'AMRO', '22787', '1547973', '1396', '92923');
INSERT INTO public.who_global_data_import VALUES (90542, '2020-05-23', 'US', 'United States of America', 'AMRO', '20475', '1568448', '1088', '94011');
INSERT INTO public.who_global_data_import VALUES (90543, '2020-05-24', 'US', 'United States of America', 'AMRO', '24151', '1592599', '1852', '95863');
INSERT INTO public.who_global_data_import VALUES (90544, '2020-05-25', 'US', 'United States of America', 'AMRO', '26158', '1618757', '1046', '96909');
INSERT INTO public.who_global_data_import VALUES (90545, '2020-05-26', 'US', 'United States of America', 'AMRO', '15253', '1634010', '620', '97529');
INSERT INTO public.who_global_data_import VALUES (90546, '2020-05-27', 'US', 'United States of America', 'AMRO', '24886', '1658896', '590', '98119');
INSERT INTO public.who_global_data_import VALUES (90547, '2020-05-28', 'US', 'United States of America', 'AMRO', '16362', '1675258', '770', '98889');
INSERT INTO public.who_global_data_import VALUES (90548, '2020-05-29', 'US', 'United States of America', 'AMRO', '19606', '1694864', '1415', '100304');
INSERT INTO public.who_global_data_import VALUES (90549, '2020-05-30', 'US', 'United States of America', 'AMRO', '21214', '1716078', '1263', '101567');
INSERT INTO public.who_global_data_import VALUES (90550, '2020-05-31', 'US', 'United States of America', 'AMRO', '17962', '1734040', '1073', '102640');
INSERT INTO public.who_global_data_import VALUES (90551, '2020-06-01', 'US', 'United States of America', 'AMRO', '23482', '1757522', '914', '103554');
INSERT INTO public.who_global_data_import VALUES (90552, '2020-06-02', 'US', 'United States of America', 'AMRO', '26116', '1783638', '693', '104247');
INSERT INTO public.who_global_data_import VALUES (90553, '2020-06-03', 'US', 'United States of America', 'AMRO', '14692', '1798330', '761', '105008');
INSERT INTO public.who_global_data_import VALUES (90554, '2020-06-04', 'US', 'United States of America', 'AMRO', '24890', '1823220', '1043', '106051');
INSERT INTO public.who_global_data_import VALUES (90555, '2020-06-05', 'US', 'United States of America', 'AMRO', '14583', '1837803', '825', '106876');
INSERT INTO public.who_global_data_import VALUES (90556, '2020-06-06', 'US', 'United States of America', 'AMRO', '20069', '1857872', '1035', '107911');
INSERT INTO public.who_global_data_import VALUES (90557, '2020-06-07', 'US', 'United States of America', 'AMRO', '28922', '1886794', '1127', '109038');
INSERT INTO public.who_global_data_import VALUES (90558, '2020-06-08', 'US', 'United States of America', 'AMRO', '28918', '1915712', '708', '109746');
INSERT INTO public.who_global_data_import VALUES (90559, '2020-06-09', 'US', 'United States of America', 'AMRO', '17848', '1933560', '474', '110220');
INSERT INTO public.who_global_data_import VALUES (90560, '2020-06-10', 'US', 'United States of America', 'AMRO', '17536', '1951096', '550', '110770');
INSERT INTO public.who_global_data_import VALUES (90561, '2020-06-11', 'US', 'United States of America', 'AMRO', '17235', '1968331', '1208', '111978');
INSERT INTO public.who_global_data_import VALUES (90562, '2020-06-12', 'US', 'United States of America', 'AMRO', '20315', '1988646', '832', '112810');
INSERT INTO public.who_global_data_import VALUES (90563, '2020-06-13', 'US', 'United States of America', 'AMRO', '21745', '2010391', '947', '113757');
INSERT INTO public.who_global_data_import VALUES (90564, '2020-06-14', 'US', 'United States of America', 'AMRO', '22133', '2032524', '709', '114466');
INSERT INTO public.who_global_data_import VALUES (90565, '2020-06-15', 'US', 'United States of America', 'AMRO', '25314', '2057838', '646', '115112');
INSERT INTO public.who_global_data_import VALUES (90566, '2020-06-16', 'US', 'United States of America', 'AMRO', '21754', '2079592', '372', '115484');
INSERT INTO public.who_global_data_import VALUES (90567, '2020-06-17', 'US', 'United States of America', 'AMRO', '18514', '2098106', '496', '115980');
INSERT INTO public.who_global_data_import VALUES (90568, '2020-06-18', 'US', 'United States of America', 'AMRO', '27921', '2126027', '722', '116702');
INSERT INTO public.who_global_data_import VALUES (90569, '2020-06-19', 'US', 'United States of America', 'AMRO', '23139', '2149166', '770', '117472');
INSERT INTO public.who_global_data_import VALUES (90570, '2020-06-20', 'US', 'United States of America', 'AMRO', '23046', '2172212', '733', '118205');
INSERT INTO public.who_global_data_import VALUES (90571, '2020-06-21', 'US', 'United States of America', 'AMRO', '36617', '2208829', '690', '118895');
INSERT INTO public.who_global_data_import VALUES (90572, '2020-06-22', 'US', 'United States of America', 'AMRO', '32349', '2241178', '558', '119453');
INSERT INTO public.who_global_data_import VALUES (90573, '2020-06-23', 'US', 'United States of America', 'AMRO', '27575', '2268753', '308', '119761');
INSERT INTO public.who_global_data_import VALUES (90574, '2020-06-24', 'US', 'United States of America', 'AMRO', '26519', '2295272', '410', '120171');
INSERT INTO public.who_global_data_import VALUES (90575, '2020-06-25', 'US', 'United States of America', 'AMRO', '34191', '2329463', '784', '120955');
INSERT INTO public.who_global_data_import VALUES (90576, '2020-06-26', 'US', 'United States of America', 'AMRO', '37601', '2367064', '690', '121645');
INSERT INTO public.who_global_data_import VALUES (90577, '2020-06-27', 'US', 'United States of America', 'AMRO', '40526', '2407590', '2516', '124161');
INSERT INTO public.who_global_data_import VALUES (90578, '2020-06-28', 'US', 'United States of America', 'AMRO', '44458', '2452048', '650', '124811');
INSERT INTO public.who_global_data_import VALUES (90579, '2020-06-29', 'US', 'United States of America', 'AMRO', '44580', '2496628', '507', '125318');
INSERT INTO public.who_global_data_import VALUES (90580, '2020-06-30', 'US', 'United States of America', 'AMRO', '41008', '2537636', '885', '126203');
INSERT INTO public.who_global_data_import VALUES (90581, '2020-07-01', 'US', 'United States of America', 'AMRO', '35757', '2573393', '370', '126573');
INSERT INTO public.who_global_data_import VALUES (90582, '2020-07-02', 'US', 'United States of America', 'AMRO', '43556', '2616949', '560', '127133');
INSERT INTO public.who_global_data_import VALUES (90583, '2020-07-03', 'US', 'United States of America', 'AMRO', '54271', '2671220', '725', '127858');
INSERT INTO public.who_global_data_import VALUES (90584, '2020-07-04', 'US', 'United States of America', 'AMRO', '53213', '2724433', '623', '128481');
INSERT INTO public.who_global_data_import VALUES (90585, '2020-07-05', 'US', 'United States of America', 'AMRO', '51933', '2776366', '745', '129226');
INSERT INTO public.who_global_data_import VALUES (90586, '2020-07-06', 'US', 'United States of America', 'AMRO', '57186', '2833552', '182', '129408');
INSERT INTO public.who_global_data_import VALUES (90587, '2020-07-07', 'US', 'United States of America', 'AMRO', '43686', '2877238', '235', '129643');
INSERT INTO public.who_global_data_import VALUES (90588, '2020-07-08', 'US', 'United States of America', 'AMRO', '46194', '2923432', '320', '129963');
INSERT INTO public.who_global_data_import VALUES (90589, '2020-07-09', 'US', 'United States of America', 'AMRO', '50263', '2973695', '930', '130893');
INSERT INTO public.who_global_data_import VALUES (90590, '2020-07-10', 'US', 'United States of America', 'AMRO', '64630', '3038325', '991', '131884');
INSERT INTO public.who_global_data_import VALUES (90591, '2020-07-11', 'US', 'United States of America', 'AMRO', '58975', '3097300', '799', '132683');
INSERT INTO public.who_global_data_import VALUES (90592, '2020-07-12', 'US', 'United States of America', 'AMRO', '66281', '3163581', '803', '133486');
INSERT INTO public.who_global_data_import VALUES (90593, '2020-07-13', 'US', 'United States of America', 'AMRO', '62369', '3225950', '906', '134392');
INSERT INTO public.who_global_data_import VALUES (90594, '2020-07-14', 'US', 'United States of America', 'AMRO', '60113', '3286063', '312', '134704');
INSERT INTO public.who_global_data_import VALUES (90595, '2020-07-15', 'US', 'United States of America', 'AMRO', '58720', '3344783', '349', '135053');
INSERT INTO public.who_global_data_import VALUES (90596, '2020-07-16', 'US', 'United States of America', 'AMRO', '60711', '3405494', '754', '135807');
INSERT INTO public.who_global_data_import VALUES (90597, '2020-07-17', 'US', 'United States of America', 'AMRO', '67165', '3472659', '946', '136753');
INSERT INTO public.who_global_data_import VALUES (90598, '2020-07-18', 'US', 'United States of America', 'AMRO', '71484', '3544143', '921', '137674');
INSERT INTO public.who_global_data_import VALUES (90599, '2020-07-19', 'US', 'United States of America', 'AMRO', '74354', '3618497', '917', '138591');
INSERT INTO public.who_global_data_import VALUES (90600, '2020-07-20', 'US', 'United States of America', 'AMRO', '66963', '3685460', '877', '139468');
INSERT INTO public.who_global_data_import VALUES (90601, '2020-07-21', 'US', 'United States of America', 'AMRO', '62788', '3748248', '496', '139964');
INSERT INTO public.who_global_data_import VALUES (90602, '2020-07-22', 'US', 'United States of America', 'AMRO', '57276', '3805524', '473', '140437');
INSERT INTO public.who_global_data_import VALUES (90603, '2020-07-23', 'US', 'United States of America', 'AMRO', '62929', '3868453', '1042', '141479');
INSERT INTO public.who_global_data_import VALUES (90604, '2020-07-24', 'US', 'United States of America', 'AMRO', '69641', '3938094', '1074', '142553');
INSERT INTO public.who_global_data_import VALUES (90605, '2020-07-25', 'US', 'United States of America', 'AMRO', '71714', '4009808', '1110', '143663');
INSERT INTO public.who_global_data_import VALUES (90606, '2020-07-26', 'US', 'United States of America', 'AMRO', '74235', '4084043', '1135', '144798');
INSERT INTO public.who_global_data_import VALUES (90607, '2020-07-27', 'US', 'United States of America', 'AMRO', '63968', '4148011', '929', '145727');
INSERT INTO public.who_global_data_import VALUES (90608, '2020-07-28', 'US', 'United States of America', 'AMRO', '61498', '4209509', '604', '146331');
INSERT INTO public.who_global_data_import VALUES (90609, '2020-07-29', 'US', 'United States of America', 'AMRO', '54022', '4263531', '1118', '147449');
INSERT INTO public.who_global_data_import VALUES (90610, '2020-07-30', 'US', 'United States of America', 'AMRO', '59629', '4323160', '1191', '148640');
INSERT INTO public.who_global_data_import VALUES (90611, '2020-07-31', 'US', 'United States of America', 'AMRO', '65406', '4388566', '1414', '150054');
INSERT INTO public.who_global_data_import VALUES (90612, '2020-08-01', 'US', 'United States of America', 'AMRO', '67823', '4456389', '1211', '151265');
INSERT INTO public.who_global_data_import VALUES (90613, '2020-08-02', 'US', 'United States of America', 'AMRO', '67499', '4523888', '1365', '152630');
INSERT INTO public.who_global_data_import VALUES (90614, '2020-08-03', 'US', 'United States of America', 'AMRO', '58388', '4582276', '1127', '153757');
INSERT INTO public.who_global_data_import VALUES (90615, '2020-08-04', 'US', 'United States of America', 'AMRO', '47183', '4629459', '469', '154226');
INSERT INTO public.who_global_data_import VALUES (90616, '2020-08-05', 'US', 'United States of America', 'AMRO', '49151', '4678610', '726', '154952');
INSERT INTO public.who_global_data_import VALUES (90617, '2020-08-06', 'US', 'United States of America', 'AMRO', '49629', '4728239', '1098', '156050');
INSERT INTO public.who_global_data_import VALUES (90618, '2020-08-07', 'US', 'United States of America', 'AMRO', '53373', '4781612', '1307', '157357');
INSERT INTO public.who_global_data_import VALUES (90619, '2020-08-08', 'US', 'United States of America', 'AMRO', '55318', '4836930', '1249', '158606');
INSERT INTO public.who_global_data_import VALUES (90620, '2020-08-09', 'US', 'United States of America', 'AMRO', '61028', '4897958', '1324', '159930');
INSERT INTO public.who_global_data_import VALUES (90621, '2020-08-10', 'US', 'United States of America', 'AMRO', '53893', '4951851', '1059', '160989');
INSERT INTO public.who_global_data_import VALUES (90622, '2020-08-11', 'US', 'United States of America', 'AMRO', '47964', '4999815', '558', '161547');
INSERT INTO public.who_global_data_import VALUES (90623, '2020-08-12', 'US', 'United States of America', 'AMRO', '39894', '5039709', '557', '162104');
INSERT INTO public.who_global_data_import VALUES (90624, '2020-08-13', 'US', 'United States of America', 'AMRO', '54791', '5094500', '1236', '163340');
INSERT INTO public.who_global_data_import VALUES (90625, '2020-08-14', 'US', 'United States of America', 'AMRO', '55907', '5150407', '1486', '164826');
INSERT INTO public.who_global_data_import VALUES (90626, '2020-08-15', 'US', 'United States of America', 'AMRO', '52799', '5203206', '1169', '165995');
INSERT INTO public.who_global_data_import VALUES (90627, '2020-08-16', 'US', 'United States of America', 'AMRO', '55359', '5258565', '1206', '167201');
INSERT INTO public.who_global_data_import VALUES (90628, '2020-08-17', 'US', 'United States of America', 'AMRO', '54375', '5312940', '1144', '168345');
INSERT INTO public.who_global_data_import VALUES (90629, '2020-08-18', 'US', 'United States of America', 'AMRO', '41073', '5354013', '654', '168999');
INSERT INTO public.who_global_data_import VALUES (90630, '2020-08-19', 'US', 'United States of America', 'AMRO', '39125', '5393138', '509', '169508');
INSERT INTO public.who_global_data_import VALUES (90631, '2020-08-20', 'US', 'United States of America', 'AMRO', '37908', '5431046', '1132', '170640');
INSERT INTO public.who_global_data_import VALUES (90632, '2020-08-21', 'US', 'United States of America', 'AMRO', '46259', '5477305', '1393', '172033');
INSERT INTO public.who_global_data_import VALUES (90633, '2020-08-22', 'US', 'United States of America', 'AMRO', '43952', '5521257', '1065', '173098');
INSERT INTO public.who_global_data_import VALUES (90634, '2020-08-23', 'US', 'United States of America', 'AMRO', '45960', '5567217', '1148', '174246');
INSERT INTO public.who_global_data_import VALUES (90635, '2020-08-24', 'US', 'United States of America', 'AMRO', '44946', '5612163', '997', '175243');
INSERT INTO public.who_global_data_import VALUES (90636, '2020-08-25', 'US', 'United States of America', 'AMRO', '37765', '5649928', '570', '175813');
INSERT INTO public.who_global_data_import VALUES (90637, '2020-08-26', 'US', 'United States of America', 'AMRO', '32883', '5682811', '388', '176201');
INSERT INTO public.who_global_data_import VALUES (90638, '2020-08-27', 'US', 'United States of America', 'AMRO', '37030', '5719841', '1131', '177332');
INSERT INTO public.who_global_data_import VALUES (90639, '2020-08-28', 'US', 'United States of America', 'AMRO', '45484', '5765325', '1229', '178561');
INSERT INTO public.who_global_data_import VALUES (90640, '2020-08-29', 'US', 'United States of America', 'AMRO', '46194', '5811519', '1155', '179716');
INSERT INTO public.who_global_data_import VALUES (90641, '2020-08-30', 'US', 'United States of America', 'AMRO', '44002', '5855521', '973', '180689');
INSERT INTO public.who_global_data_import VALUES (90642, '2020-08-31', 'US', 'United States of America', 'AMRO', '43983', '5899504', '1000', '181689');
INSERT INTO public.who_global_data_import VALUES (90643, '2020-09-01', 'US', 'United States of America', 'AMRO', '37068', '5936572', '473', '182162');
INSERT INTO public.who_global_data_import VALUES (90644, '2020-09-02', 'US', 'United States of America', 'AMRO', '31808', '5968380', '423', '182585');
INSERT INTO public.who_global_data_import VALUES (90645, '2020-09-03', 'US', 'United States of America', 'AMRO', '42662', '6011042', '1025', '183610');
INSERT INTO public.who_global_data_import VALUES (90646, '2020-09-04', 'US', 'United States of America', 'AMRO', '39402', '6050444', '1004', '184614');
INSERT INTO public.who_global_data_import VALUES (90647, '2020-09-05', 'US', 'United States of America', 'AMRO', '44563', '6095007', '1073', '185687');
INSERT INTO public.who_global_data_import VALUES (90648, '2020-09-06', 'US', 'United States of America', 'AMRO', '49131', '6144138', '976', '186663');
INSERT INTO public.who_global_data_import VALUES (90649, '2020-09-07', 'US', 'United States of America', 'AMRO', '45350', '6189488', '878', '187541');
INSERT INTO public.who_global_data_import VALUES (90650, '2020-09-08', 'US', 'United States of America', 'AMRO', '33486', '6222974', '462', '188003');
INSERT INTO public.who_global_data_import VALUES (90651, '2020-09-09', 'US', 'United States of America', 'AMRO', '26015', '6248989', '169', '188172');
INSERT INTO public.who_global_data_import VALUES (90652, '2020-09-10', 'US', 'United States of America', 'AMRO', '23204', '6272193', '436', '188608');
INSERT INTO public.who_global_data_import VALUES (90653, '2020-09-11', 'US', 'United States of America', 'AMRO', '31988', '6304181', '1101', '189709');
INSERT INTO public.who_global_data_import VALUES (90654, '2020-09-12', 'US', 'United States of America', 'AMRO', '37128', '6341309', '1078', '190787');
INSERT INTO public.who_global_data_import VALUES (90655, '2020-09-13', 'US', 'United States of America', 'AMRO', '45523', '6386832', '1022', '191809');
INSERT INTO public.who_global_data_import VALUES (90656, '2020-09-14', 'US', 'United States of America', 'AMRO', '40126', '6426958', '803', '192612');
INSERT INTO public.who_global_data_import VALUES (90657, '2020-09-15', 'US', 'United States of America', 'AMRO', '35177', '6462135', '507', '193119');
INSERT INTO public.who_global_data_import VALUES (90658, '2020-09-16', 'US', 'United States of America', 'AMRO', '34111', '6496246', '375', '193494');
INSERT INTO public.who_global_data_import VALUES (90659, '2020-09-17', 'US', 'United States of America', 'AMRO', '34078', '6530324', '940', '194434');
INSERT INTO public.who_global_data_import VALUES (90660, '2020-09-18', 'US', 'United States of America', 'AMRO', '40795', '6571119', '1204', '195638');
INSERT INTO public.who_global_data_import VALUES (90661, '2020-09-19', 'US', 'United States of America', 'AMRO', '42618', '6613737', '827', '196465');
INSERT INTO public.who_global_data_import VALUES (90662, '2020-09-20', 'US', 'United States of America', 'AMRO', '48266', '6662003', '977', '197442');
INSERT INTO public.who_global_data_import VALUES (90663, '2020-09-21', 'US', 'United States of America', 'AMRO', '41695', '6703698', '652', '198094');
INSERT INTO public.who_global_data_import VALUES (90664, '2020-09-22', 'US', 'United States of America', 'AMRO', '36766', '6740464', '269', '198363');
INSERT INTO public.who_global_data_import VALUES (90665, '2020-09-23', 'US', 'United States of America', 'AMRO', '39145', '6779609', '430', '198793');
INSERT INTO public.who_global_data_import VALUES (90666, '2020-09-24', 'US', 'United States of America', 'AMRO', '49176', '6828785', '807', '199600');
INSERT INTO public.who_global_data_import VALUES (90667, '2020-09-25', 'US', 'United States of America', 'AMRO', '40043', '6868828', '1125', '200725');
INSERT INTO public.who_global_data_import VALUES (90668, '2020-09-26', 'US', 'United States of America', 'AMRO', '41254', '6910082', '909', '201634');
INSERT INTO public.who_global_data_import VALUES (90669, '2020-09-27', 'US', 'United States of America', 'AMRO', '50070', '6960152', '844', '202478');
INSERT INTO public.who_global_data_import VALUES (90670, '2020-09-28', 'US', 'United States of America', 'AMRO', '48958', '7009110', '851', '203329');
INSERT INTO public.who_global_data_import VALUES (90671, '2020-09-29', 'US', 'United States of America', 'AMRO', '35217', '7044327', '291', '203620');
INSERT INTO public.who_global_data_import VALUES (90672, '2020-09-30', 'US', 'United States of America', 'AMRO', '32688', '7077015', '255', '203875');
INSERT INTO public.who_global_data_import VALUES (90673, '2020-10-01', 'US', 'United States of America', 'AMRO', '38476', '7115491', '767', '204642');
INSERT INTO public.who_global_data_import VALUES (90674, '2020-10-02', 'US', 'United States of America', 'AMRO', '44985', '7160476', '1024', '205666');
INSERT INTO public.who_global_data_import VALUES (90675, '2020-10-03', 'US', 'United States of America', 'AMRO', '46293', '7206769', '892', '206558');
INSERT INTO public.who_global_data_import VALUES (90676, '2020-10-04', 'US', 'United States of America', 'AMRO', '49465', '7256234', '808', '207366');
INSERT INTO public.who_global_data_import VALUES (90677, '2020-10-05', 'US', 'United States of America', 'AMRO', '49036', '7305270', '698', '208064');
INSERT INTO public.who_global_data_import VALUES (90678, '2020-10-06', 'US', 'United States of America', 'AMRO', '36136', '7341406', '369', '208433');
INSERT INTO public.who_global_data_import VALUES (90679, '2020-10-07', 'US', 'United States of America', 'AMRO', '38920', '7380326', '354', '208787');
INSERT INTO public.who_global_data_import VALUES (92030, '2020-02-01', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90680, '2020-10-08', 'US', 'United States of America', 'AMRO', '38904', '7419230', '663', '209450');
INSERT INTO public.who_global_data_import VALUES (90681, '2020-10-09', 'US', 'United States of America', 'AMRO', '52458', '7471688', '888', '210338');
INSERT INTO public.who_global_data_import VALUES (90682, '2020-10-10', 'US', 'United States of America', 'AMRO', '54232', '7525920', '973', '211311');
INSERT INTO public.who_global_data_import VALUES (90683, '2020-10-11', 'US', 'United States of America', 'AMRO', '57828', '7583748', '918', '212229');
INSERT INTO public.who_global_data_import VALUES (90684, '2020-10-12', 'US', 'United States of America', 'AMRO', '53055', '7636803', '575', '212804');
INSERT INTO public.who_global_data_import VALUES (90685, '2020-10-13', 'US', 'United States of America', 'AMRO', '45325', '7682128', '487', '213291');
INSERT INTO public.who_global_data_import VALUES (90686, '2020-10-14', 'US', 'United States of America', 'AMRO', '46308', '7728436', '335', '213626');
INSERT INTO public.who_global_data_import VALUES (90687, '2020-10-15', 'US', 'United States of America', 'AMRO', '46309', '7774745', '743', '214369');
INSERT INTO public.who_global_data_import VALUES (90688, '2020-10-16', 'US', 'United States of America', 'AMRO', '59106', '7833851', '830', '215199');
INSERT INTO public.who_global_data_import VALUES (90689, '2020-10-17', 'US', 'United States of America', 'AMRO', '63044', '7896895', '874', '216073');
INSERT INTO public.who_global_data_import VALUES (90690, '2020-10-18', 'US', 'United States of America', 'AMRO', '69834', '7966729', '998', '217071');
INSERT INTO public.who_global_data_import VALUES (90691, '2020-10-19', 'US', 'United States of America', 'AMRO', '52508', '8019237', '588', '217659');
INSERT INTO public.who_global_data_import VALUES (90692, '2020-10-20', 'US', 'United States of America', 'AMRO', '46378', '8065615', '472', '218131');
INSERT INTO public.who_global_data_import VALUES (90693, '2020-10-21', 'US', 'United States of America', 'AMRO', '59018', '8124633', '510', '218641');
INSERT INTO public.who_global_data_import VALUES (90694, '2020-10-22', 'US', 'United States of America', 'AMRO', '60155', '8184788', '856', '219497');
INSERT INTO public.who_global_data_import VALUES (90695, '2020-10-23', 'US', 'United States of America', 'AMRO', '63361', '8248149', '1066', '220563');
INSERT INTO public.who_global_data_import VALUES (90696, '2020-10-24', 'US', 'United States of America', 'AMRO', '72342', '8320491', '1001', '221564');
INSERT INTO public.who_global_data_import VALUES (90697, '2020-10-25', 'US', 'United States of America', 'AMRO', '82630', '8403121', '943', '222507');
INSERT INTO public.who_global_data_import VALUES (90698, '2020-10-26', 'US', 'United States of America', 'AMRO', '82626', '8485747', '821', '223328');
INSERT INTO public.who_global_data_import VALUES (90699, '2020-10-27', 'US', 'United States of America', 'AMRO', '62364', '8548111', '371', '223699');
INSERT INTO public.who_global_data_import VALUES (90700, '2020-10-28', 'US', 'United States of America', 'AMRO', '63145', '8611256', '479', '224178');
INSERT INTO public.who_global_data_import VALUES (90701, '2020-10-29', 'US', 'United States of America', 'AMRO', '72042', '8683298', '895', '225073');
INSERT INTO public.who_global_data_import VALUES (90702, '2020-10-30', 'US', 'United States of America', 'AMRO', '80384', '8763682', '1059', '226132');
INSERT INTO public.who_global_data_import VALUES (90703, '2020-10-31', 'US', 'United States of America', 'AMRO', '89048', '8852730', '1046', '227178');
INSERT INTO public.who_global_data_import VALUES (90704, '2020-11-01', 'US', 'United States of America', 'AMRO', '99356', '8952086', '1007', '228185');
INSERT INTO public.who_global_data_import VALUES (90705, '2020-11-02', 'US', 'United States of America', 'AMRO', '80379', '9032465', '813', '228998');
INSERT INTO public.who_global_data_import VALUES (90706, '2020-11-03', 'US', 'United States of America', 'AMRO', '75888', '9108353', '444', '229442');
INSERT INTO public.who_global_data_import VALUES (90707, '2020-11-04', 'US', 'United States of America', 'AMRO', '85412', '9193765', '506', '229948');
INSERT INTO public.who_global_data_import VALUES (90708, '2020-11-05', 'US', 'United States of America', 'AMRO', '88163', '9281928', '1086', '231034');
INSERT INTO public.who_global_data_import VALUES (90709, '2020-11-06', 'US', 'United States of America', 'AMRO', '106050', '9387978', '1132', '232166');
INSERT INTO public.who_global_data_import VALUES (90710, '2020-11-07', 'US', 'United States of America', 'AMRO', '116780', '9504758', '1126', '233292');
INSERT INTO public.who_global_data_import VALUES (90711, '2020-11-08', 'US', 'United States of America', 'AMRO', '131821', '9636579', '1208', '234500');
INSERT INTO public.who_global_data_import VALUES (90712, '2020-11-09', 'US', 'United States of America', 'AMRO', '127151', '9763730', '1062', '235562');
INSERT INTO public.who_global_data_import VALUES (90713, '2020-11-10', 'US', 'United States of America', 'AMRO', '104659', '9868389', '480', '236042');
INSERT INTO public.who_global_data_import VALUES (90714, '2020-11-11', 'US', 'United States of America', 'AMRO', '122231', '9990620', '685', '236727');
INSERT INTO public.who_global_data_import VALUES (90715, '2020-11-12', 'US', 'United States of America', 'AMRO', '133935', '10124555', '1846', '238573');
INSERT INTO public.who_global_data_import VALUES (90716, '2020-11-13', 'US', 'United States of America', 'AMRO', '142076', '10266631', '1471', '240044');
INSERT INTO public.who_global_data_import VALUES (90717, '2020-11-14', 'US', 'United States of America', 'AMRO', '193734', '10460365', '1142', '241186');
INSERT INTO public.who_global_data_import VALUES (90718, '2020-11-15', 'US', 'United States of America', 'AMRO', '181066', '10641431', '1356', '242542');
INSERT INTO public.who_global_data_import VALUES (90719, '2020-11-16', 'US', 'United States of America', 'AMRO', '155001', '10796432', '1216', '243758');
INSERT INTO public.who_global_data_import VALUES (90720, '2020-11-17', 'US', 'United States of America', 'AMRO', '137486', '10933918', '653', '244411');
INSERT INTO public.who_global_data_import VALUES (90721, '2020-11-18', 'US', 'United States of America', 'AMRO', '151266', '11085184', '753', '245164');
INSERT INTO public.who_global_data_import VALUES (90722, '2020-11-19', 'US', 'United States of America', 'AMRO', '164044', '11249228', '1582', '246746');
INSERT INTO public.who_global_data_import VALUES (90723, '2020-11-20', 'US', 'United States of America', 'AMRO', '164560', '11413788', '1825', '248571');
INSERT INTO public.who_global_data_import VALUES (90724, '2020-11-21', 'US', 'United States of America', 'AMRO', '184191', '11597979', '2036', '250607');
INSERT INTO public.who_global_data_import VALUES (90725, '2020-11-22', 'US', 'United States of America', 'AMRO', '191033', '11789012', '1853', '252460');
INSERT INTO public.who_global_data_import VALUES (90726, '2020-11-23', 'US', 'United States of America', 'AMRO', '183544', '11972556', '1471', '253931');
INSERT INTO public.who_global_data_import VALUES (90727, '2020-11-24', 'US', 'United States of America', 'AMRO', '147098', '12119654', '867', '254798');
INSERT INTO public.who_global_data_import VALUES (90728, '2020-11-25', 'US', 'United States of America', 'AMRO', '157180', '12276834', '1052', '255850');
INSERT INTO public.who_global_data_import VALUES (90729, '2020-11-26', 'US', 'United States of America', 'AMRO', '165091', '12441925', '1975', '257825');
INSERT INTO public.who_global_data_import VALUES (90730, '2020-11-27', 'US', 'United States of America', 'AMRO', '180850', '12622775', '2248', '260073');
INSERT INTO public.who_global_data_import VALUES (90731, '2020-11-28', 'US', 'United States of America', 'AMRO', '141222', '12763997', '1387', '261460');
INSERT INTO public.who_global_data_import VALUES (90732, '2020-11-29', 'US', 'United States of America', 'AMRO', '175669', '12939666', '1276', '262736');
INSERT INTO public.who_global_data_import VALUES (90733, '2020-11-30', 'US', 'United States of America', 'AMRO', '143211', '13082877', '1210', '263946');
INSERT INTO public.who_global_data_import VALUES (90734, '2020-12-01', 'US', 'United States of America', 'AMRO', '151674', '13234551', '862', '264808');
INSERT INTO public.who_global_data_import VALUES (90735, '2020-12-02', 'US', 'United States of America', 'AMRO', '151204', '13385755', '1235', '266043');
INSERT INTO public.who_global_data_import VALUES (90736, '2020-12-03', 'US', 'United States of America', 'AMRO', '177976', '13563731', '2439', '268482');
INSERT INTO public.who_global_data_import VALUES (90737, '2020-12-04', 'US', 'United States of America', 'AMRO', '195769', '13759500', '2751', '271233');
INSERT INTO public.who_global_data_import VALUES (90738, '2020-12-05', 'US', 'United States of America', 'AMRO', '218671', '13978171', '2844', '274077');
INSERT INTO public.who_global_data_import VALUES (90739, '2020-12-06', 'US', 'United States of America', 'AMRO', '213127', '14191298', '2426', '276503');
INSERT INTO public.who_global_data_import VALUES (90740, '2020-12-07', 'US', 'United States of America', 'AMRO', '205837', '14397135', '2303', '278806');
INSERT INTO public.who_global_data_import VALUES (90741, '2020-12-08', 'US', 'United States of America', 'AMRO', '173388', '14570523', '1107', '279913');
INSERT INTO public.who_global_data_import VALUES (90742, '2020-12-09', 'US', 'United States of America', 'AMRO', '185473', '14755996', '1529', '281442');
INSERT INTO public.who_global_data_import VALUES (90743, '2020-12-10', 'US', 'United States of America', 'AMRO', '216360', '14972356', '2552', '283994');
INSERT INTO public.who_global_data_import VALUES (90744, '2020-12-11', 'US', 'United States of America', 'AMRO', '230852', '15203208', '3390', '287384');
INSERT INTO public.who_global_data_import VALUES (90745, '2020-12-12', 'US', 'United States of America', 'AMRO', '201681', '15404889', '2749', '290133');
INSERT INTO public.who_global_data_import VALUES (90746, '2020-12-13', 'US', 'United States of America', 'AMRO', '243209', '15648098', '2996', '293129');
INSERT INTO public.who_global_data_import VALUES (90747, '2020-12-14', 'US', 'United States of America', 'AMRO', '212577', '15860675', '2277', '295406');
INSERT INTO public.who_global_data_import VALUES (90748, '2020-12-15', 'US', 'United States of America', 'AMRO', '180420', '16041095', '1434', '296840');
INSERT INTO public.who_global_data_import VALUES (90749, '2020-12-16', 'US', 'United States of America', 'AMRO', '204281', '16245376', '1754', '298594');
INSERT INTO public.who_global_data_import VALUES (90750, '2020-12-17', 'US', 'United States of America', 'AMRO', '201468', '16446844', '2942', '301536');
INSERT INTO public.who_global_data_import VALUES (90751, '2020-12-18', 'US', 'United States of America', 'AMRO', '235805', '16682649', '3424', '304960');
INSERT INTO public.who_global_data_import VALUES (90752, '2020-12-19', 'US', 'United States of America', 'AMRO', '229915', '16912564', '3443', '308403');
INSERT INTO public.who_global_data_import VALUES (90753, '2020-12-20', 'US', 'United States of America', 'AMRO', '402270', '17314834', '2747', '311150');
INSERT INTO public.who_global_data_import VALUES (90754, '2020-12-21', 'US', 'United States of America', 'AMRO', '200257', '17515091', '2598', '313748');
INSERT INTO public.who_global_data_import VALUES (92031, '2020-02-02', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90755, '2020-12-22', 'US', 'United States of America', 'AMRO', '197199', '17712290', '1570', '315318');
INSERT INTO public.who_global_data_import VALUES (90756, '2020-12-23', 'US', 'United States of America', 'AMRO', '182819', '17895109', '1714', '317032');
INSERT INTO public.who_global_data_import VALUES (90757, '2020-12-24', 'US', 'United States of America', 'AMRO', '195151', '18090260', '3148', '320180');
INSERT INTO public.who_global_data_import VALUES (90758, '2020-12-25', 'US', 'United States of America', 'AMRO', '221145', '18311405', '3347', '323527');
INSERT INTO public.who_global_data_import VALUES (90759, '2020-12-26', 'US', 'United States of America', 'AMRO', '192095', '18503500', '2795', '326322');
INSERT INTO public.who_global_data_import VALUES (90760, '2020-12-27', 'US', 'United States of America', 'AMRO', '145489', '18648989', '1692', '328014');
INSERT INTO public.who_global_data_import VALUES (90761, '2020-12-28', 'US', 'United States of America', 'AMRO', '178311', '18827300', '1296', '329310');
INSERT INTO public.who_global_data_import VALUES (90762, '2020-12-29', 'US', 'United States of America', 'AMRO', '145513', '18972813', '1334', '330644');
INSERT INTO public.who_global_data_import VALUES (90763, '2020-12-30', 'US', 'United States of America', 'AMRO', '174814', '19147627', '1779', '332423');
INSERT INTO public.who_global_data_import VALUES (90764, '2020-12-31', 'US', 'United States of America', 'AMRO', '199163', '19346790', '3366', '335789');
INSERT INTO public.who_global_data_import VALUES (90765, '2021-01-01', 'US', 'United States of America', 'AMRO', '231427', '19578217', '3761', '339550');
INSERT INTO public.who_global_data_import VALUES (90766, '2021-01-02', 'US', 'United States of America', 'AMRO', '228437', '19806654', '3280', '342830');
INSERT INTO public.who_global_data_import VALUES (90767, '2021-01-03', 'US', 'United States of America', 'AMRO', '167759', '19974413', '2423', '345253');
INSERT INTO public.who_global_data_import VALUES (90768, '2021-01-04', 'US', 'United States of America', 'AMRO', '284312', '20258725', '2302', '347555');
INSERT INTO public.who_global_data_import VALUES (90769, '2021-01-05', 'US', 'United States of America', 'AMRO', '211444', '20470169', '1407', '348962');
INSERT INTO public.who_global_data_import VALUES (90770, '2021-01-06', 'US', 'United States of America', 'AMRO', '173375', '20643544', '1791', '350753');
INSERT INTO public.who_global_data_import VALUES (90771, '2021-01-07', 'US', 'United States of America', 'AMRO', '227369', '20870913', '3533', '354286');
INSERT INTO public.who_global_data_import VALUES (90772, '2021-01-08', 'US', 'United States of America', 'AMRO', '299562', '21170475', '3825', '358111');
INSERT INTO public.who_global_data_import VALUES (90773, '2021-01-09', 'US', 'United States of America', 'AMRO', '277195', '21447670', '4176', '362287');
INSERT INTO public.who_global_data_import VALUES (90774, '2021-01-10', 'US', 'United States of America', 'AMRO', '313516', '21761186', '3599', '365886');
INSERT INTO public.who_global_data_import VALUES (90775, '2021-01-11', 'US', 'United States of America', 'AMRO', '248089', '22009275', '3418', '369304');
INSERT INTO public.who_global_data_import VALUES (90776, '2021-01-12', 'US', 'United States of America', 'AMRO', '220528', '22229803', '2071', '371375');
INSERT INTO public.who_global_data_import VALUES (90777, '2021-01-13', 'US', 'United States of America', 'AMRO', '198788', '22428591', '1954', '373329');
INSERT INTO public.who_global_data_import VALUES (90778, '2021-01-14', 'US', 'United States of America', 'AMRO', '217166', '22645757', '4117', '377446');
INSERT INTO public.who_global_data_import VALUES (90779, '2021-01-15', 'US', 'United States of America', 'AMRO', '225573', '22871330', '4076', '381522');
INSERT INTO public.who_global_data_import VALUES (90780, '2021-01-16', 'US', 'United States of America', 'AMRO', '226608', '23097938', '3891', '385413');
INSERT INTO public.who_global_data_import VALUES (90781, '2021-01-17', 'US', 'United States of America', 'AMRO', '246485', '23344423', '3671', '389084');
INSERT INTO public.who_global_data_import VALUES (90782, '2021-01-18', 'US', 'United States of America', 'AMRO', '212253', '23556676', '3557', '392641');
INSERT INTO public.who_global_data_import VALUES (90783, '2021-01-19', 'US', 'United States of America', 'AMRO', '185383', '23742059', '1947', '394588');
INSERT INTO public.who_global_data_import VALUES (90784, '2021-01-20', 'US', 'United States of America', 'AMRO', '142240', '23884299', '1567', '396155');
INSERT INTO public.who_global_data_import VALUES (90785, '2021-01-21', 'US', 'United States of America', 'AMRO', '152937', '24037236', '2280', '398435');
INSERT INTO public.who_global_data_import VALUES (90786, '2021-01-22', 'US', 'United States of America', 'AMRO', '187919', '24225155', '4368', '402803');
INSERT INTO public.who_global_data_import VALUES (90787, '2021-01-23', 'US', 'United States of America', 'AMRO', '188176', '24413331', '3979', '406782');
INSERT INTO public.who_global_data_import VALUES (90788, '2021-01-24', 'US', 'United States of America', 'AMRO', '190994', '24604325', '3885', '410667');
INSERT INTO public.who_global_data_import VALUES (90789, '2021-01-25', 'US', 'United States of America', 'AMRO', '170883', '24775208', '3416', '414083');
INSERT INTO public.who_global_data_import VALUES (90790, '2021-01-26', 'US', 'United States of America', 'AMRO', '141691', '24916899', '1921', '416004');
INSERT INTO public.who_global_data_import VALUES (90791, '2021-01-27', 'US', 'United States of America', 'AMRO', '133409', '25050308', '1885', '417889');
INSERT INTO public.who_global_data_import VALUES (90792, '2021-01-28', 'US', 'United States of America', 'AMRO', '148533', '25198841', '3681', '421570');
INSERT INTO public.who_global_data_import VALUES (90793, '2021-01-29', 'US', 'United States of America', 'AMRO', '155203', '25354044', '4100', '425670');
INSERT INTO public.who_global_data_import VALUES (90794, '2021-01-30', 'US', 'United States of America', 'AMRO', '158153', '25512197', '3982', '429652');
INSERT INTO public.who_global_data_import VALUES (90795, '2021-01-31', 'US', 'United States of America', 'AMRO', '164415', '25676612', '3521', '433173');
INSERT INTO public.who_global_data_import VALUES (90796, '2021-02-01', 'US', 'United States of America', 'AMRO', '141327', '25817939', '2878', '436051');
INSERT INTO public.who_global_data_import VALUES (90797, '2021-02-02', 'US', 'United States of America', 'AMRO', '112129', '25930068', '1913', '437964');
INSERT INTO public.who_global_data_import VALUES (90798, '2021-02-03', 'US', 'United States of America', 'AMRO', '125444', '26055512', '1866', '439830');
INSERT INTO public.who_global_data_import VALUES (90799, '2021-02-04', 'US', 'United States of America', 'AMRO', '116762', '26172274', '3426', '443256');
INSERT INTO public.who_global_data_import VALUES (90800, '2021-02-05', 'US', 'United States of America', 'AMRO', '0', '26172274', '0', '443256');
INSERT INTO public.who_global_data_import VALUES (90801, '2020-01-03', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90802, '2020-01-04', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90803, '2020-01-05', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90804, '2020-01-06', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90805, '2020-01-07', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90806, '2020-01-08', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90807, '2020-01-09', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90808, '2020-01-10', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90809, '2020-01-11', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90810, '2020-01-12', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90811, '2020-01-13', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90812, '2020-01-14', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90813, '2020-01-15', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90814, '2020-01-16', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90815, '2020-01-17', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90816, '2020-01-18', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90817, '2020-01-19', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90818, '2020-01-20', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90819, '2020-01-21', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90820, '2020-01-22', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90821, '2020-01-23', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90822, '2020-01-24', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90823, '2020-01-25', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90824, '2020-01-26', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90825, '2020-01-27', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90826, '2020-01-28', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90827, '2020-01-29', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90828, '2020-01-30', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90829, '2020-01-31', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90830, '2020-02-01', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90831, '2020-02-02', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90832, '2020-02-03', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90833, '2020-02-04', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90834, '2020-02-05', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92032, '2020-02-03', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90835, '2020-02-06', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90836, '2020-02-07', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90837, '2020-02-08', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90838, '2020-02-09', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90839, '2020-02-10', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90840, '2020-02-11', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90841, '2020-02-12', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90842, '2020-02-13', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90843, '2020-02-14', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90844, '2020-02-15', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90845, '2020-02-16', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90846, '2020-02-17', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90847, '2020-02-18', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90848, '2020-02-19', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90849, '2020-02-20', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90850, '2020-02-21', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90851, '2020-02-22', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90852, '2020-02-23', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90853, '2020-02-24', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90854, '2020-02-25', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90855, '2020-02-26', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90856, '2020-02-27', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90857, '2020-02-28', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90858, '2020-02-29', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90859, '2020-03-01', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90860, '2020-03-02', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90861, '2020-03-03', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90862, '2020-03-04', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90863, '2020-03-05', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90864, '2020-03-06', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90865, '2020-03-07', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90866, '2020-03-08', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90867, '2020-03-09', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90868, '2020-03-10', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90869, '2020-03-11', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90870, '2020-03-12', 'VI', 'United States Virgin Islands', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90871, '2020-03-13', 'VI', 'United States Virgin Islands', 'AMRO', '5', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90872, '2020-03-14', 'VI', 'United States Virgin Islands', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90873, '2020-03-15', 'VI', 'United States Virgin Islands', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90874, '2020-03-16', 'VI', 'United States Virgin Islands', 'AMRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90875, '2020-03-17', 'VI', 'United States Virgin Islands', 'AMRO', '1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90876, '2020-03-18', 'VI', 'United States Virgin Islands', 'AMRO', '1', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90877, '2020-03-19', 'VI', 'United States Virgin Islands', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90878, '2020-03-20', 'VI', 'United States Virgin Islands', 'AMRO', '0', '7', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90879, '2020-03-21', 'VI', 'United States Virgin Islands', 'AMRO', '-1', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90880, '2020-03-22', 'VI', 'United States Virgin Islands', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90881, '2020-03-23', 'VI', 'United States Virgin Islands', 'AMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90882, '2020-03-24', 'VI', 'United States Virgin Islands', 'AMRO', '11', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90883, '2020-03-25', 'VI', 'United States Virgin Islands', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90884, '2020-03-26', 'VI', 'United States Virgin Islands', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90885, '2020-03-27', 'VI', 'United States Virgin Islands', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90886, '2020-03-28', 'VI', 'United States Virgin Islands', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90887, '2020-03-29', 'VI', 'United States Virgin Islands', 'AMRO', '0', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90888, '2020-03-30', 'VI', 'United States Virgin Islands', 'AMRO', '5', '22', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90889, '2020-03-31', 'VI', 'United States Virgin Islands', 'AMRO', '8', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90890, '2020-04-01', 'VI', 'United States Virgin Islands', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90891, '2020-04-02', 'VI', 'United States Virgin Islands', 'AMRO', '0', '30', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90892, '2020-04-03', 'VI', 'United States Virgin Islands', 'AMRO', '3', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90893, '2020-04-04', 'VI', 'United States Virgin Islands', 'AMRO', '4', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90894, '2020-04-05', 'VI', 'United States Virgin Islands', 'AMRO', '3', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90895, '2020-04-06', 'VI', 'United States Virgin Islands', 'AMRO', '2', '42', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90896, '2020-04-07', 'VI', 'United States Virgin Islands', 'AMRO', '1', '43', '1', '1');
INSERT INTO public.who_global_data_import VALUES (90897, '2020-04-08', 'VI', 'United States Virgin Islands', 'AMRO', '0', '43', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90898, '2020-04-09', 'VI', 'United States Virgin Islands', 'AMRO', '2', '45', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90899, '2020-04-10', 'VI', 'United States Virgin Islands', 'AMRO', '1', '46', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90900, '2020-04-11', 'VI', 'United States Virgin Islands', 'AMRO', '5', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90901, '2020-04-12', 'VI', 'United States Virgin Islands', 'AMRO', '0', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90902, '2020-04-13', 'VI', 'United States Virgin Islands', 'AMRO', '0', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90903, '2020-04-14', 'VI', 'United States Virgin Islands', 'AMRO', '0', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90904, '2020-04-15', 'VI', 'United States Virgin Islands', 'AMRO', '0', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90905, '2020-04-16', 'VI', 'United States Virgin Islands', 'AMRO', '0', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90906, '2020-04-17', 'VI', 'United States Virgin Islands', 'AMRO', '0', '51', '0', '1');
INSERT INTO public.who_global_data_import VALUES (90907, '2020-04-18', 'VI', 'United States Virgin Islands', 'AMRO', '0', '51', '1', '2');
INSERT INTO public.who_global_data_import VALUES (90908, '2020-04-19', 'VI', 'United States Virgin Islands', 'AMRO', '2', '53', '1', '3');
INSERT INTO public.who_global_data_import VALUES (90909, '2020-04-20', 'VI', 'United States Virgin Islands', 'AMRO', '0', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (90910, '2020-04-21', 'VI', 'United States Virgin Islands', 'AMRO', '0', '53', '0', '3');
INSERT INTO public.who_global_data_import VALUES (90911, '2020-04-22', 'VI', 'United States Virgin Islands', 'AMRO', '1', '54', '0', '3');
INSERT INTO public.who_global_data_import VALUES (90912, '2020-04-23', 'VI', 'United States Virgin Islands', 'AMRO', '0', '54', '0', '3');
INSERT INTO public.who_global_data_import VALUES (90913, '2020-04-24', 'VI', 'United States Virgin Islands', 'AMRO', '0', '54', '0', '3');
INSERT INTO public.who_global_data_import VALUES (90914, '2020-04-25', 'VI', 'United States Virgin Islands', 'AMRO', '0', '54', '0', '3');
INSERT INTO public.who_global_data_import VALUES (90915, '2020-04-26', 'VI', 'United States Virgin Islands', 'AMRO', '1', '55', '0', '3');
INSERT INTO public.who_global_data_import VALUES (90916, '2020-04-27', 'VI', 'United States Virgin Islands', 'AMRO', '0', '55', '0', '3');
INSERT INTO public.who_global_data_import VALUES (90917, '2020-04-28', 'VI', 'United States Virgin Islands', 'AMRO', '4', '59', '1', '4');
INSERT INTO public.who_global_data_import VALUES (90918, '2020-04-29', 'VI', 'United States Virgin Islands', 'AMRO', '0', '59', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90919, '2020-04-30', 'VI', 'United States Virgin Islands', 'AMRO', '3', '62', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90920, '2020-05-01', 'VI', 'United States Virgin Islands', 'AMRO', '4', '66', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90921, '2020-05-02', 'VI', 'United States Virgin Islands', 'AMRO', '0', '66', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90922, '2020-05-03', 'VI', 'United States Virgin Islands', 'AMRO', '0', '66', '0', '4');
INSERT INTO public.who_global_data_import VALUES (92033, '2020-02-04', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (90923, '2020-05-04', 'VI', 'United States Virgin Islands', 'AMRO', '0', '66', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90924, '2020-05-05', 'VI', 'United States Virgin Islands', 'AMRO', '0', '66', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90925, '2020-05-06', 'VI', 'United States Virgin Islands', 'AMRO', '0', '66', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90926, '2020-05-07', 'VI', 'United States Virgin Islands', 'AMRO', '0', '66', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90927, '2020-05-08', 'VI', 'United States Virgin Islands', 'AMRO', '0', '66', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90928, '2020-05-09', 'VI', 'United States Virgin Islands', 'AMRO', '2', '68', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90929, '2020-05-10', 'VI', 'United States Virgin Islands', 'AMRO', '0', '68', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90930, '2020-05-11', 'VI', 'United States Virgin Islands', 'AMRO', '1', '69', '0', '4');
INSERT INTO public.who_global_data_import VALUES (90931, '2020-05-12', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '1', '5');
INSERT INTO public.who_global_data_import VALUES (90932, '2020-05-13', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '5');
INSERT INTO public.who_global_data_import VALUES (90933, '2020-05-14', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '1', '6');
INSERT INTO public.who_global_data_import VALUES (90934, '2020-05-15', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90935, '2020-05-16', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90936, '2020-05-17', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90937, '2020-05-18', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90938, '2020-05-19', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90939, '2020-05-20', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90940, '2020-05-21', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90941, '2020-05-22', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90942, '2020-05-23', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90943, '2020-05-24', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90944, '2020-05-25', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90945, '2020-05-26', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90946, '2020-05-27', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90947, '2020-05-28', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90948, '2020-05-29', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90949, '2020-05-30', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90950, '2020-05-31', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90951, '2020-06-01', 'VI', 'United States Virgin Islands', 'AMRO', '0', '69', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90952, '2020-06-02', 'VI', 'United States Virgin Islands', 'AMRO', '1', '70', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90953, '2020-06-03', 'VI', 'United States Virgin Islands', 'AMRO', '0', '70', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90954, '2020-06-04', 'VI', 'United States Virgin Islands', 'AMRO', '0', '70', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90955, '2020-06-05', 'VI', 'United States Virgin Islands', 'AMRO', '1', '71', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90956, '2020-06-06', 'VI', 'United States Virgin Islands', 'AMRO', '0', '71', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90957, '2020-06-07', 'VI', 'United States Virgin Islands', 'AMRO', '0', '71', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90958, '2020-06-08', 'VI', 'United States Virgin Islands', 'AMRO', '0', '71', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90959, '2020-06-09', 'VI', 'United States Virgin Islands', 'AMRO', '0', '71', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90960, '2020-06-10', 'VI', 'United States Virgin Islands', 'AMRO', '0', '71', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90961, '2020-06-11', 'VI', 'United States Virgin Islands', 'AMRO', '1', '72', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90962, '2020-06-12', 'VI', 'United States Virgin Islands', 'AMRO', '0', '72', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90963, '2020-06-13', 'VI', 'United States Virgin Islands', 'AMRO', '0', '72', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90964, '2020-06-14', 'VI', 'United States Virgin Islands', 'AMRO', '0', '72', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90965, '2020-06-15', 'VI', 'United States Virgin Islands', 'AMRO', '0', '72', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90966, '2020-06-16', 'VI', 'United States Virgin Islands', 'AMRO', '0', '72', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90967, '2020-06-17', 'VI', 'United States Virgin Islands', 'AMRO', '1', '73', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90968, '2020-06-18', 'VI', 'United States Virgin Islands', 'AMRO', '0', '73', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90969, '2020-06-19', 'VI', 'United States Virgin Islands', 'AMRO', '0', '73', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90970, '2020-06-20', 'VI', 'United States Virgin Islands', 'AMRO', '0', '73', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90971, '2020-06-21', 'VI', 'United States Virgin Islands', 'AMRO', '1', '74', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90972, '2020-06-22', 'VI', 'United States Virgin Islands', 'AMRO', '2', '76', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90973, '2020-06-23', 'VI', 'United States Virgin Islands', 'AMRO', '0', '76', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90974, '2020-06-24', 'VI', 'United States Virgin Islands', 'AMRO', '0', '76', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90975, '2020-06-25', 'VI', 'United States Virgin Islands', 'AMRO', '0', '76', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90976, '2020-06-26', 'VI', 'United States Virgin Islands', 'AMRO', '4', '80', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90977, '2020-06-27', 'VI', 'United States Virgin Islands', 'AMRO', '1', '81', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90978, '2020-06-28', 'VI', 'United States Virgin Islands', 'AMRO', '0', '81', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90979, '2020-06-29', 'VI', 'United States Virgin Islands', 'AMRO', '0', '81', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90980, '2020-06-30', 'VI', 'United States Virgin Islands', 'AMRO', '0', '81', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90981, '2020-07-01', 'VI', 'United States Virgin Islands', 'AMRO', '3', '84', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90982, '2020-07-02', 'VI', 'United States Virgin Islands', 'AMRO', '6', '90', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90983, '2020-07-03', 'VI', 'United States Virgin Islands', 'AMRO', '2', '92', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90984, '2020-07-04', 'VI', 'United States Virgin Islands', 'AMRO', '6', '98', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90985, '2020-07-05', 'VI', 'United States Virgin Islands', 'AMRO', '13', '111', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90986, '2020-07-06', 'VI', 'United States Virgin Islands', 'AMRO', '0', '111', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90987, '2020-07-07', 'VI', 'United States Virgin Islands', 'AMRO', '1', '112', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90988, '2020-07-08', 'VI', 'United States Virgin Islands', 'AMRO', '4', '116', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90989, '2020-07-09', 'VI', 'United States Virgin Islands', 'AMRO', '6', '122', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90990, '2020-07-10', 'VI', 'United States Virgin Islands', 'AMRO', '22', '144', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90991, '2020-07-11', 'VI', 'United States Virgin Islands', 'AMRO', '9', '153', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90992, '2020-07-12', 'VI', 'United States Virgin Islands', 'AMRO', '14', '167', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90993, '2020-07-13', 'VI', 'United States Virgin Islands', 'AMRO', '14', '181', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90994, '2020-07-14', 'VI', 'United States Virgin Islands', 'AMRO', '25', '206', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90995, '2020-07-15', 'VI', 'United States Virgin Islands', 'AMRO', '0', '206', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90996, '2020-07-16', 'VI', 'United States Virgin Islands', 'AMRO', '37', '243', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90997, '2020-07-17', 'VI', 'United States Virgin Islands', 'AMRO', '6', '249', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90998, '2020-07-18', 'VI', 'United States Virgin Islands', 'AMRO', '14', '263', '0', '6');
INSERT INTO public.who_global_data_import VALUES (90999, '2020-07-19', 'VI', 'United States Virgin Islands', 'AMRO', '20', '283', '0', '6');
INSERT INTO public.who_global_data_import VALUES (91000, '2020-07-20', 'VI', 'United States Virgin Islands', 'AMRO', '0', '283', '0', '6');
INSERT INTO public.who_global_data_import VALUES (91001, '2020-07-21', 'VI', 'United States Virgin Islands', 'AMRO', '14', '297', '0', '6');
INSERT INTO public.who_global_data_import VALUES (91002, '2020-07-22', 'VI', 'United States Virgin Islands', 'AMRO', '11', '308', '0', '6');
INSERT INTO public.who_global_data_import VALUES (91003, '2020-07-23', 'VI', 'United States Virgin Islands', 'AMRO', '12', '320', '1', '7');
INSERT INTO public.who_global_data_import VALUES (91004, '2020-07-24', 'VI', 'United States Virgin Islands', 'AMRO', '16', '336', '0', '7');
INSERT INTO public.who_global_data_import VALUES (91005, '2020-07-25', 'VI', 'United States Virgin Islands', 'AMRO', '6', '342', '0', '7');
INSERT INTO public.who_global_data_import VALUES (91006, '2020-07-26', 'VI', 'United States Virgin Islands', 'AMRO', '10', '352', '0', '7');
INSERT INTO public.who_global_data_import VALUES (91007, '2020-07-27', 'VI', 'United States Virgin Islands', 'AMRO', '9', '361', '0', '7');
INSERT INTO public.who_global_data_import VALUES (91008, '2020-07-28', 'VI', 'United States Virgin Islands', 'AMRO', '3', '364', '0', '7');
INSERT INTO public.who_global_data_import VALUES (91009, '2020-07-29', 'VI', 'United States Virgin Islands', 'AMRO', '11', '375', '0', '7');
INSERT INTO public.who_global_data_import VALUES (91010, '2020-07-30', 'VI', 'United States Virgin Islands', 'AMRO', '10', '385', '1', '8');
INSERT INTO public.who_global_data_import VALUES (92034, '2020-02-05', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91011, '2020-07-31', 'VI', 'United States Virgin Islands', 'AMRO', '13', '398', '0', '8');
INSERT INTO public.who_global_data_import VALUES (91012, '2020-08-01', 'VI', 'United States Virgin Islands', 'AMRO', '8', '406', '0', '8');
INSERT INTO public.who_global_data_import VALUES (91013, '2020-08-02', 'VI', 'United States Virgin Islands', 'AMRO', '15', '421', '0', '8');
INSERT INTO public.who_global_data_import VALUES (91014, '2020-08-03', 'VI', 'United States Virgin Islands', 'AMRO', '17', '438', '0', '8');
INSERT INTO public.who_global_data_import VALUES (91015, '2020-08-04', 'VI', 'United States Virgin Islands', 'AMRO', '1', '439', '0', '8');
INSERT INTO public.who_global_data_import VALUES (91016, '2020-08-05', 'VI', 'United States Virgin Islands', 'AMRO', '24', '463', '0', '8');
INSERT INTO public.who_global_data_import VALUES (91017, '2020-08-06', 'VI', 'United States Virgin Islands', 'AMRO', '18', '481', '0', '8');
INSERT INTO public.who_global_data_import VALUES (91018, '2020-08-07', 'VI', 'United States Virgin Islands', 'AMRO', '20', '501', '1', '9');
INSERT INTO public.who_global_data_import VALUES (91019, '2020-08-08', 'VI', 'United States Virgin Islands', 'AMRO', '21', '522', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91020, '2020-08-09', 'VI', 'United States Virgin Islands', 'AMRO', '6', '528', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91021, '2020-08-10', 'VI', 'United States Virgin Islands', 'AMRO', '0', '528', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91022, '2020-08-11', 'VI', 'United States Virgin Islands', 'AMRO', '19', '547', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91023, '2020-08-12', 'VI', 'United States Virgin Islands', 'AMRO', '29', '576', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91024, '2020-08-13', 'VI', 'United States Virgin Islands', 'AMRO', '63', '639', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91025, '2020-08-14', 'VI', 'United States Virgin Islands', 'AMRO', '43', '682', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91026, '2020-08-15', 'VI', 'United States Virgin Islands', 'AMRO', '22', '704', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91027, '2020-08-16', 'VI', 'United States Virgin Islands', 'AMRO', '30', '734', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91028, '2020-08-17', 'VI', 'United States Virgin Islands', 'AMRO', '7', '741', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91029, '2020-08-18', 'VI', 'United States Virgin Islands', 'AMRO', '19', '760', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91030, '2020-08-19', 'VI', 'United States Virgin Islands', 'AMRO', '36', '796', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91031, '2020-08-20', 'VI', 'United States Virgin Islands', 'AMRO', '32', '828', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91032, '2020-08-21', 'VI', 'United States Virgin Islands', 'AMRO', '41', '869', '1', '10');
INSERT INTO public.who_global_data_import VALUES (91033, '2020-08-22', 'VI', 'United States Virgin Islands', 'AMRO', '63', '932', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91034, '2020-08-23', 'VI', 'United States Virgin Islands', 'AMRO', '0', '932', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91035, '2020-08-24', 'VI', 'United States Virgin Islands', 'AMRO', '28', '960', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91036, '2020-08-25', 'VI', 'United States Virgin Islands', 'AMRO', '24', '984', '1', '11');
INSERT INTO public.who_global_data_import VALUES (91037, '2020-08-26', 'VI', 'United States Virgin Islands', 'AMRO', '14', '998', '1', '12');
INSERT INTO public.who_global_data_import VALUES (91038, '2020-08-27', 'VI', 'United States Virgin Islands', 'AMRO', '32', '1030', '2', '14');
INSERT INTO public.who_global_data_import VALUES (91039, '2020-08-28', 'VI', 'United States Virgin Islands', 'AMRO', '22', '1052', '0', '14');
INSERT INTO public.who_global_data_import VALUES (91040, '2020-08-29', 'VI', 'United States Virgin Islands', 'AMRO', '23', '1075', '0', '14');
INSERT INTO public.who_global_data_import VALUES (91041, '2020-08-30', 'VI', 'United States Virgin Islands', 'AMRO', '43', '1118', '0', '14');
INSERT INTO public.who_global_data_import VALUES (91042, '2020-08-31', 'VI', 'United States Virgin Islands', 'AMRO', '11', '1129', '0', '14');
INSERT INTO public.who_global_data_import VALUES (91043, '2020-09-01', 'VI', 'United States Virgin Islands', 'AMRO', '5', '1134', '0', '14');
INSERT INTO public.who_global_data_import VALUES (91044, '2020-09-02', 'VI', 'United States Virgin Islands', 'AMRO', '5', '1139', '1', '15');
INSERT INTO public.who_global_data_import VALUES (91045, '2020-09-03', 'VI', 'United States Virgin Islands', 'AMRO', '4', '1143', '0', '15');
INSERT INTO public.who_global_data_import VALUES (91046, '2020-09-04', 'VI', 'United States Virgin Islands', 'AMRO', '1', '1144', '0', '15');
INSERT INTO public.who_global_data_import VALUES (91047, '2020-09-05', 'VI', 'United States Virgin Islands', 'AMRO', '6', '1150', '1', '16');
INSERT INTO public.who_global_data_import VALUES (91048, '2020-09-06', 'VI', 'United States Virgin Islands', 'AMRO', '17', '1167', '0', '16');
INSERT INTO public.who_global_data_import VALUES (91049, '2020-09-07', 'VI', 'United States Virgin Islands', 'AMRO', '14', '1181', '1', '17');
INSERT INTO public.who_global_data_import VALUES (91050, '2020-09-08', 'VI', 'United States Virgin Islands', 'AMRO', '9', '1190', '0', '17');
INSERT INTO public.who_global_data_import VALUES (91051, '2020-09-09', 'VI', 'United States Virgin Islands', 'AMRO', '1', '1191', '1', '18');
INSERT INTO public.who_global_data_import VALUES (91052, '2020-09-10', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1191', '0', '18');
INSERT INTO public.who_global_data_import VALUES (91053, '2020-09-11', 'VI', 'United States Virgin Islands', 'AMRO', '6', '1197', '0', '18');
INSERT INTO public.who_global_data_import VALUES (91054, '2020-09-12', 'VI', 'United States Virgin Islands', 'AMRO', '4', '1201', '0', '18');
INSERT INTO public.who_global_data_import VALUES (91055, '2020-09-13', 'VI', 'United States Virgin Islands', 'AMRO', '10', '1211', '1', '19');
INSERT INTO public.who_global_data_import VALUES (91056, '2020-09-14', 'VI', 'United States Virgin Islands', 'AMRO', '9', '1220', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91057, '2020-09-15', 'VI', 'United States Virgin Islands', 'AMRO', '1', '1221', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91058, '2020-09-16', 'VI', 'United States Virgin Islands', 'AMRO', '4', '1225', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91059, '2020-09-17', 'VI', 'United States Virgin Islands', 'AMRO', '7', '1232', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91060, '2020-09-18', 'VI', 'United States Virgin Islands', 'AMRO', '6', '1238', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91061, '2020-09-19', 'VI', 'United States Virgin Islands', 'AMRO', '4', '1242', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91062, '2020-09-20', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1242', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91063, '2020-09-21', 'VI', 'United States Virgin Islands', 'AMRO', '27', '1269', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91064, '2020-09-22', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1269', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91065, '2020-09-23', 'VI', 'United States Virgin Islands', 'AMRO', '7', '1276', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91066, '2020-09-24', 'VI', 'United States Virgin Islands', 'AMRO', '2', '1278', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91067, '2020-09-25', 'VI', 'United States Virgin Islands', 'AMRO', '12', '1290', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91068, '2020-09-26', 'VI', 'United States Virgin Islands', 'AMRO', '6', '1296', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91069, '2020-09-27', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1296', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91070, '2020-09-28', 'VI', 'United States Virgin Islands', 'AMRO', '21', '1317', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91071, '2020-09-29', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1317', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91072, '2020-09-30', 'VI', 'United States Virgin Islands', 'AMRO', '1', '1318', '1', '20');
INSERT INTO public.who_global_data_import VALUES (91073, '2020-10-01', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1318', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91074, '2020-10-02', 'VI', 'United States Virgin Islands', 'AMRO', '5', '1323', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91075, '2020-10-03', 'VI', 'United States Virgin Islands', 'AMRO', '3', '1326', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91076, '2020-10-04', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1326', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91077, '2020-10-05', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1326', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91078, '2020-10-06', 'VI', 'United States Virgin Islands', 'AMRO', '1', '1327', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91079, '2020-10-07', 'VI', 'United States Virgin Islands', 'AMRO', '-5', '1322', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91080, '2020-10-08', 'VI', 'United States Virgin Islands', 'AMRO', '-1', '1321', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91081, '2020-10-09', 'VI', 'United States Virgin Islands', 'AMRO', '1', '1322', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91082, '2020-10-10', 'VI', 'United States Virgin Islands', 'AMRO', '2', '1324', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91083, '2020-10-11', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1324', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91084, '2020-10-12', 'VI', 'United States Virgin Islands', 'AMRO', '1', '1325', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91085, '2020-10-13', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1325', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91086, '2020-10-14', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1325', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91087, '2020-10-15', 'VI', 'United States Virgin Islands', 'AMRO', '3', '1328', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91088, '2020-10-16', 'VI', 'United States Virgin Islands', 'AMRO', '-1', '1327', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91089, '2020-10-17', 'VI', 'United States Virgin Islands', 'AMRO', '2', '1329', '1', '21');
INSERT INTO public.who_global_data_import VALUES (91090, '2020-10-18', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1329', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91091, '2020-10-19', 'VI', 'United States Virgin Islands', 'AMRO', '6', '1335', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91092, '2020-10-20', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1335', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91093, '2020-10-21', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1335', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91094, '2020-10-22', 'VI', 'United States Virgin Islands', 'AMRO', '2', '1337', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91095, '2020-10-23', 'VI', 'United States Virgin Islands', 'AMRO', '6', '1343', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91096, '2020-10-24', 'VI', 'United States Virgin Islands', 'AMRO', '3', '1346', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91097, '2020-10-25', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1346', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91098, '2020-10-26', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1346', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91099, '2020-10-27', 'VI', 'United States Virgin Islands', 'AMRO', '2', '1348', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91100, '2020-10-28', 'VI', 'United States Virgin Islands', 'AMRO', '3', '1351', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91101, '2020-10-29', 'VI', 'United States Virgin Islands', 'AMRO', '2', '1353', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91102, '2020-10-30', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1353', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91103, '2020-10-31', 'VI', 'United States Virgin Islands', 'AMRO', '9', '1362', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91104, '2020-11-01', 'VI', 'United States Virgin Islands', 'AMRO', '14', '1376', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91105, '2020-11-02', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1376', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91106, '2020-11-03', 'VI', 'United States Virgin Islands', 'AMRO', '2', '1378', '0', '21');
INSERT INTO public.who_global_data_import VALUES (91107, '2020-11-04', 'VI', 'United States Virgin Islands', 'AMRO', '7', '1385', '1', '22');
INSERT INTO public.who_global_data_import VALUES (91108, '2020-11-05', 'VI', 'United States Virgin Islands', 'AMRO', '3', '1388', '1', '23');
INSERT INTO public.who_global_data_import VALUES (91109, '2020-11-06', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1388', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91110, '2020-11-07', 'VI', 'United States Virgin Islands', 'AMRO', '2', '1390', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91111, '2020-11-08', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1390', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91112, '2020-11-09', 'VI', 'United States Virgin Islands', 'AMRO', '15', '1405', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91113, '2020-11-10', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1405', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91114, '2020-11-11', 'VI', 'United States Virgin Islands', 'AMRO', '5', '1410', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91115, '2020-11-12', 'VI', 'United States Virgin Islands', 'AMRO', '3', '1413', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91116, '2020-11-13', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1413', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91117, '2020-11-14', 'VI', 'United States Virgin Islands', 'AMRO', '13', '1426', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91118, '2020-11-15', 'VI', 'United States Virgin Islands', 'AMRO', '8', '1434', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91119, '2020-11-16', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1434', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91120, '2020-11-17', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1434', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91121, '2020-11-18', 'VI', 'United States Virgin Islands', 'AMRO', '16', '1450', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91122, '2020-11-19', 'VI', 'United States Virgin Islands', 'AMRO', '13', '1463', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91123, '2020-11-20', 'VI', 'United States Virgin Islands', 'AMRO', '6', '1469', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91124, '2020-11-21', 'VI', 'United States Virgin Islands', 'AMRO', '13', '1482', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91125, '2020-11-22', 'VI', 'United States Virgin Islands', 'AMRO', '9', '1491', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91126, '2020-11-23', 'VI', 'United States Virgin Islands', 'AMRO', '13', '1504', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91127, '2020-11-24', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1504', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91128, '2020-11-25', 'VI', 'United States Virgin Islands', 'AMRO', '3', '1507', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91129, '2020-11-26', 'VI', 'United States Virgin Islands', 'AMRO', '14', '1521', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91130, '2020-11-27', 'VI', 'United States Virgin Islands', 'AMRO', '15', '1536', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91131, '2020-11-28', 'VI', 'United States Virgin Islands', 'AMRO', '2', '1538', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91132, '2020-11-29', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1538', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91133, '2020-11-30', 'VI', 'United States Virgin Islands', 'AMRO', '6', '1544', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91134, '2020-12-01', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1544', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91135, '2020-12-02', 'VI', 'United States Virgin Islands', 'AMRO', '6', '1550', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91136, '2020-12-03', 'VI', 'United States Virgin Islands', 'AMRO', '13', '1563', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91137, '2020-12-04', 'VI', 'United States Virgin Islands', 'AMRO', '26', '1589', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91138, '2020-12-05', 'VI', 'United States Virgin Islands', 'AMRO', '24', '1613', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91139, '2020-12-06', 'VI', 'United States Virgin Islands', 'AMRO', '20', '1633', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91140, '2020-12-07', 'VI', 'United States Virgin Islands', 'AMRO', '16', '1649', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91141, '2020-12-08', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1649', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91142, '2020-12-09', 'VI', 'United States Virgin Islands', 'AMRO', '31', '1680', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91143, '2020-12-10', 'VI', 'United States Virgin Islands', 'AMRO', '18', '1698', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91144, '2020-12-11', 'VI', 'United States Virgin Islands', 'AMRO', '35', '1733', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91145, '2020-12-12', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1733', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91146, '2020-12-13', 'VI', 'United States Virgin Islands', 'AMRO', '58', '1791', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91147, '2020-12-14', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1791', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91148, '2020-12-15', 'VI', 'United States Virgin Islands', 'AMRO', '16', '1807', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91149, '2020-12-16', 'VI', 'United States Virgin Islands', 'AMRO', '21', '1828', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91150, '2020-12-17', 'VI', 'United States Virgin Islands', 'AMRO', '22', '1850', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91151, '2020-12-18', 'VI', 'United States Virgin Islands', 'AMRO', '28', '1878', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91152, '2020-12-19', 'VI', 'United States Virgin Islands', 'AMRO', '22', '1900', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91153, '2020-12-20', 'VI', 'United States Virgin Islands', 'AMRO', '10', '1910', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91154, '2020-12-21', 'VI', 'United States Virgin Islands', 'AMRO', '11', '1921', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91155, '2020-12-22', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1921', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91156, '2020-12-23', 'VI', 'United States Virgin Islands', 'AMRO', '13', '1934', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91157, '2020-12-24', 'VI', 'United States Virgin Islands', 'AMRO', '16', '1950', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91158, '2020-12-25', 'VI', 'United States Virgin Islands', 'AMRO', '17', '1967', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91159, '2020-12-26', 'VI', 'United States Virgin Islands', 'AMRO', '12', '1979', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91160, '2020-12-27', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1979', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91161, '2020-12-28', 'VI', 'United States Virgin Islands', 'AMRO', '9', '1988', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91162, '2020-12-29', 'VI', 'United States Virgin Islands', 'AMRO', '0', '1988', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91163, '2020-12-30', 'VI', 'United States Virgin Islands', 'AMRO', '16', '2004', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91164, '2020-12-31', 'VI', 'United States Virgin Islands', 'AMRO', '6', '2010', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91165, '2021-01-01', 'VI', 'United States Virgin Islands', 'AMRO', '21', '2031', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91166, '2021-01-02', 'VI', 'United States Virgin Islands', 'AMRO', '5', '2036', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91167, '2021-01-03', 'VI', 'United States Virgin Islands', 'AMRO', '0', '2036', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91168, '2021-01-04', 'VI', 'United States Virgin Islands', 'AMRO', '5', '2041', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91169, '2021-01-05', 'VI', 'United States Virgin Islands', 'AMRO', '1', '2042', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91170, '2021-01-06', 'VI', 'United States Virgin Islands', 'AMRO', '13', '2055', '1', '24');
INSERT INTO public.who_global_data_import VALUES (91171, '2021-01-07', 'VI', 'United States Virgin Islands', 'AMRO', '28', '2083', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91172, '2021-01-08', 'VI', 'United States Virgin Islands', 'AMRO', '23', '2106', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91173, '2021-01-09', 'VI', 'United States Virgin Islands', 'AMRO', '24', '2130', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91174, '2021-01-10', 'VI', 'United States Virgin Islands', 'AMRO', '13', '2143', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91175, '2021-01-11', 'VI', 'United States Virgin Islands', 'AMRO', '0', '2143', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91176, '2021-01-12', 'VI', 'United States Virgin Islands', 'AMRO', '0', '2143', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91177, '2021-01-13', 'VI', 'United States Virgin Islands', 'AMRO', '23', '2166', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91178, '2021-01-14', 'VI', 'United States Virgin Islands', 'AMRO', '14', '2180', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91179, '2021-01-15', 'VI', 'United States Virgin Islands', 'AMRO', '38', '2218', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91180, '2021-01-16', 'VI', 'United States Virgin Islands', 'AMRO', '0', '2218', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91181, '2021-01-17', 'VI', 'United States Virgin Islands', 'AMRO', '34', '2252', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91182, '2021-01-18', 'VI', 'United States Virgin Islands', 'AMRO', '8', '2260', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91183, '2021-01-19', 'VI', 'United States Virgin Islands', 'AMRO', '0', '2260', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91184, '2021-01-20', 'VI', 'United States Virgin Islands', 'AMRO', '0', '2260', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91185, '2021-01-21', 'VI', 'United States Virgin Islands', 'AMRO', '23', '2283', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91186, '2021-01-22', 'VI', 'United States Virgin Islands', 'AMRO', '22', '2305', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91187, '2021-01-23', 'VI', 'United States Virgin Islands', 'AMRO', '16', '2321', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91188, '2021-01-24', 'VI', 'United States Virgin Islands', 'AMRO', '14', '2335', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91189, '2021-01-25', 'VI', 'United States Virgin Islands', 'AMRO', '6', '2341', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91190, '2021-01-26', 'VI', 'United States Virgin Islands', 'AMRO', '0', '2341', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91191, '2021-01-27', 'VI', 'United States Virgin Islands', 'AMRO', '9', '2350', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91192, '2021-01-28', 'VI', 'United States Virgin Islands', 'AMRO', '23', '2373', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91193, '2021-01-29', 'VI', 'United States Virgin Islands', 'AMRO', '11', '2384', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91194, '2021-01-30', 'VI', 'United States Virgin Islands', 'AMRO', '14', '2398', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91195, '2021-01-31', 'VI', 'United States Virgin Islands', 'AMRO', '0', '2398', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91196, '2021-02-01', 'VI', 'United States Virgin Islands', 'AMRO', '23', '2421', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91197, '2021-02-02', 'VI', 'United States Virgin Islands', 'AMRO', '0', '2421', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91198, '2021-02-03', 'VI', 'United States Virgin Islands', 'AMRO', '5', '2426', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91199, '2021-02-04', 'VI', 'United States Virgin Islands', 'AMRO', '4', '2430', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91200, '2021-02-05', 'VI', 'United States Virgin Islands', 'AMRO', '10', '2440', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91201, '2020-01-03', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91202, '2020-01-04', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91203, '2020-01-05', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91204, '2020-01-06', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91205, '2020-01-07', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91206, '2020-01-08', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91207, '2020-01-09', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91208, '2020-01-10', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91209, '2020-01-11', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91210, '2020-01-12', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91211, '2020-01-13', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91212, '2020-01-14', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91213, '2020-01-15', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91214, '2020-01-16', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91215, '2020-01-17', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91216, '2020-01-18', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91217, '2020-01-19', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91218, '2020-01-20', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91219, '2020-01-21', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91220, '2020-01-22', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91221, '2020-01-23', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91222, '2020-01-24', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91223, '2020-01-25', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91224, '2020-01-26', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91225, '2020-01-27', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91226, '2020-01-28', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91227, '2020-01-29', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91228, '2020-01-30', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91229, '2020-01-31', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91230, '2020-02-01', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91231, '2020-02-02', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91232, '2020-02-03', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91233, '2020-02-04', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91234, '2020-02-05', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91235, '2020-02-06', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91236, '2020-02-07', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91237, '2020-02-08', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91238, '2020-02-09', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91239, '2020-02-10', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91240, '2020-02-11', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91241, '2020-02-12', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91242, '2020-02-13', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91243, '2020-02-14', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91244, '2020-02-15', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91245, '2020-02-16', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91246, '2020-02-17', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91247, '2020-02-18', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91248, '2020-02-19', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91249, '2020-02-20', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91250, '2020-02-21', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91251, '2020-02-22', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91252, '2020-02-23', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91253, '2020-02-24', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91254, '2020-02-25', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91255, '2020-02-26', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91256, '2020-02-27', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91257, '2020-02-28', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91258, '2020-02-29', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91259, '2020-03-01', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91260, '2020-03-02', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91261, '2020-03-03', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91262, '2020-03-04', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91263, '2020-03-05', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91264, '2020-03-06', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91265, '2020-03-07', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91266, '2020-03-08', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91267, '2020-03-09', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91268, '2020-03-10', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91269, '2020-03-11', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91270, '2020-03-12', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91271, '2020-03-13', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91272, '2020-03-14', 'UY', 'Uruguay', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91273, '2020-03-15', 'UY', 'Uruguay', 'AMRO', '8', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91274, '2020-03-16', 'UY', 'Uruguay', 'AMRO', '0', '8', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91275, '2020-03-17', 'UY', 'Uruguay', 'AMRO', '2', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91276, '2020-03-18', 'UY', 'Uruguay', 'AMRO', '23', '33', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91277, '2020-03-19', 'UY', 'Uruguay', 'AMRO', '46', '79', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91278, '2020-03-20', 'UY', 'Uruguay', 'AMRO', '15', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91279, '2020-03-21', 'UY', 'Uruguay', 'AMRO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91280, '2020-03-22', 'UY', 'Uruguay', 'AMRO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91281, '2020-03-23', 'UY', 'Uruguay', 'AMRO', '41', '135', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91282, '2020-03-24', 'UY', 'Uruguay', 'AMRO', '27', '162', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91283, '2020-03-25', 'UY', 'Uruguay', 'AMRO', '0', '162', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91284, '2020-03-26', 'UY', 'Uruguay', 'AMRO', '55', '217', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91285, '2020-03-27', 'UY', 'Uruguay', 'AMRO', '0', '217', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91286, '2020-03-28', 'UY', 'Uruguay', 'AMRO', '21', '238', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91287, '2020-03-29', 'UY', 'Uruguay', 'AMRO', '36', '274', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91288, '2020-03-30', 'UY', 'Uruguay', 'AMRO', '29', '303', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91289, '2020-03-31', 'UY', 'Uruguay', 'AMRO', '6', '309', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91290, '2020-04-01', 'UY', 'Uruguay', 'AMRO', '11', '320', '1', '1');
INSERT INTO public.who_global_data_import VALUES (91291, '2020-04-02', 'UY', 'Uruguay', 'AMRO', '18', '338', '1', '2');
INSERT INTO public.who_global_data_import VALUES (91292, '2020-04-03', 'UY', 'Uruguay', 'AMRO', '12', '350', '2', '4');
INSERT INTO public.who_global_data_import VALUES (91293, '2020-04-04', 'UY', 'Uruguay', 'AMRO', '19', '369', '0', '4');
INSERT INTO public.who_global_data_import VALUES (91294, '2020-04-05', 'UY', 'Uruguay', 'AMRO', '17', '386', '0', '4');
INSERT INTO public.who_global_data_import VALUES (91295, '2020-04-06', 'UY', 'Uruguay', 'AMRO', '14', '400', '1', '5');
INSERT INTO public.who_global_data_import VALUES (91296, '2020-04-07', 'UY', 'Uruguay', 'AMRO', '6', '406', '1', '6');
INSERT INTO public.who_global_data_import VALUES (91297, '2020-04-08', 'UY', 'Uruguay', 'AMRO', '9', '415', '0', '6');
INSERT INTO public.who_global_data_import VALUES (91298, '2020-04-09', 'UY', 'Uruguay', 'AMRO', '9', '424', '1', '7');
INSERT INTO public.who_global_data_import VALUES (91299, '2020-04-10', 'UY', 'Uruguay', 'AMRO', '22', '446', '0', '7');
INSERT INTO public.who_global_data_import VALUES (91300, '2020-04-11', 'UY', 'Uruguay', 'AMRO', '7', '453', '0', '7');
INSERT INTO public.who_global_data_import VALUES (91301, '2020-04-12', 'UY', 'Uruguay', 'AMRO', '12', '465', '0', '7');
INSERT INTO public.who_global_data_import VALUES (91302, '2020-04-13', 'UY', 'Uruguay', 'AMRO', '7', '472', '0', '7');
INSERT INTO public.who_global_data_import VALUES (91303, '2020-04-14', 'UY', 'Uruguay', 'AMRO', '11', '483', '0', '7');
INSERT INTO public.who_global_data_import VALUES (91304, '2020-04-15', 'UY', 'Uruguay', 'AMRO', '0', '483', '1', '8');
INSERT INTO public.who_global_data_import VALUES (91305, '2020-04-16', 'UY', 'Uruguay', 'AMRO', '9', '492', '0', '8');
INSERT INTO public.who_global_data_import VALUES (91306, '2020-04-17', 'UY', 'Uruguay', 'AMRO', '1', '493', '1', '9');
INSERT INTO public.who_global_data_import VALUES (91307, '2020-04-18', 'UY', 'Uruguay', 'AMRO', '9', '502', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91308, '2020-04-19', 'UY', 'Uruguay', 'AMRO', '6', '508', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91309, '2020-04-20', 'UY', 'Uruguay', 'AMRO', '9', '517', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91310, '2020-04-21', 'UY', 'Uruguay', 'AMRO', '11', '528', '1', '10');
INSERT INTO public.who_global_data_import VALUES (91311, '2020-04-22', 'UY', 'Uruguay', 'AMRO', '7', '535', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91312, '2020-04-23', 'UY', 'Uruguay', 'AMRO', '8', '543', '2', '12');
INSERT INTO public.who_global_data_import VALUES (91313, '2020-04-24', 'UY', 'Uruguay', 'AMRO', '6', '549', '0', '12');
INSERT INTO public.who_global_data_import VALUES (91314, '2020-04-25', 'UY', 'Uruguay', 'AMRO', '8', '557', '0', '12');
INSERT INTO public.who_global_data_import VALUES (91315, '2020-04-26', 'UY', 'Uruguay', 'AMRO', '6', '563', '0', '12');
INSERT INTO public.who_global_data_import VALUES (91316, '2020-04-27', 'UY', 'Uruguay', 'AMRO', '33', '596', '2', '14');
INSERT INTO public.who_global_data_import VALUES (91317, '2020-04-28', 'UY', 'Uruguay', 'AMRO', '10', '606', '1', '15');
INSERT INTO public.who_global_data_import VALUES (91318, '2020-04-29', 'UY', 'Uruguay', 'AMRO', '14', '620', '0', '15');
INSERT INTO public.who_global_data_import VALUES (91319, '2020-04-30', 'UY', 'Uruguay', 'AMRO', '5', '625', '0', '15');
INSERT INTO public.who_global_data_import VALUES (91320, '2020-05-01', 'UY', 'Uruguay', 'AMRO', '5', '630', '0', '15');
INSERT INTO public.who_global_data_import VALUES (91321, '2020-05-02', 'UY', 'Uruguay', 'AMRO', '13', '643', '2', '17');
INSERT INTO public.who_global_data_import VALUES (91322, '2020-05-03', 'UY', 'Uruguay', 'AMRO', '5', '648', '0', '17');
INSERT INTO public.who_global_data_import VALUES (91323, '2020-05-04', 'UY', 'Uruguay', 'AMRO', '4', '652', '0', '17');
INSERT INTO public.who_global_data_import VALUES (91324, '2020-05-05', 'UY', 'Uruguay', 'AMRO', '3', '655', '0', '17');
INSERT INTO public.who_global_data_import VALUES (91325, '2020-05-06', 'UY', 'Uruguay', 'AMRO', '2', '657', '0', '17');
INSERT INTO public.who_global_data_import VALUES (91326, '2020-05-07', 'UY', 'Uruguay', 'AMRO', '13', '670', '0', '17');
INSERT INTO public.who_global_data_import VALUES (91327, '2020-05-08', 'UY', 'Uruguay', 'AMRO', '3', '673', '0', '17');
INSERT INTO public.who_global_data_import VALUES (91328, '2020-05-09', 'UY', 'Uruguay', 'AMRO', '11', '684', '0', '17');
INSERT INTO public.who_global_data_import VALUES (91329, '2020-05-10', 'UY', 'Uruguay', 'AMRO', '10', '694', '0', '17');
INSERT INTO public.who_global_data_import VALUES (91330, '2020-05-11', 'UY', 'Uruguay', 'AMRO', '8', '702', '0', '17');
INSERT INTO public.who_global_data_import VALUES (91331, '2020-05-12', 'UY', 'Uruguay', 'AMRO', '5', '707', '2', '19');
INSERT INTO public.who_global_data_import VALUES (91332, '2020-05-13', 'UY', 'Uruguay', 'AMRO', '4', '711', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91333, '2020-05-14', 'UY', 'Uruguay', 'AMRO', '6', '717', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91334, '2020-05-15', 'UY', 'Uruguay', 'AMRO', '2', '719', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91335, '2020-05-16', 'UY', 'Uruguay', 'AMRO', '5', '724', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91336, '2020-05-17', 'UY', 'Uruguay', 'AMRO', '8', '732', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91337, '2020-05-18', 'UY', 'Uruguay', 'AMRO', '2', '734', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91338, '2020-05-19', 'UY', 'Uruguay', 'AMRO', '0', '734', '1', '20');
INSERT INTO public.who_global_data_import VALUES (91339, '2020-05-20', 'UY', 'Uruguay', 'AMRO', '3', '737', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91340, '2020-05-21', 'UY', 'Uruguay', 'AMRO', '1', '738', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91341, '2020-05-22', 'UY', 'Uruguay', 'AMRO', '8', '746', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91342, '2020-05-23', 'UY', 'Uruguay', 'AMRO', '3', '749', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91343, '2020-05-24', 'UY', 'Uruguay', 'AMRO', '4', '753', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91344, '2020-05-25', 'UY', 'Uruguay', 'AMRO', '11', '764', '2', '22');
INSERT INTO public.who_global_data_import VALUES (91345, '2020-05-26', 'UY', 'Uruguay', 'AMRO', '5', '769', '0', '22');
INSERT INTO public.who_global_data_import VALUES (91346, '2020-05-27', 'UY', 'Uruguay', 'AMRO', '18', '787', '0', '22');
INSERT INTO public.who_global_data_import VALUES (91347, '2020-05-28', 'UY', 'Uruguay', 'AMRO', '2', '789', '0', '22');
INSERT INTO public.who_global_data_import VALUES (91348, '2020-05-29', 'UY', 'Uruguay', 'AMRO', '14', '803', '0', '22');
INSERT INTO public.who_global_data_import VALUES (91349, '2020-05-30', 'UY', 'Uruguay', 'AMRO', '8', '811', '0', '22');
INSERT INTO public.who_global_data_import VALUES (91350, '2020-05-31', 'UY', 'Uruguay', 'AMRO', '5', '816', '0', '22');
INSERT INTO public.who_global_data_import VALUES (91351, '2020-06-01', 'UY', 'Uruguay', 'AMRO', '5', '821', '0', '22');
INSERT INTO public.who_global_data_import VALUES (91352, '2020-06-02', 'UY', 'Uruguay', 'AMRO', '2', '823', '0', '22');
INSERT INTO public.who_global_data_import VALUES (91353, '2020-06-03', 'UY', 'Uruguay', 'AMRO', '2', '825', '1', '23');
INSERT INTO public.who_global_data_import VALUES (91354, '2020-06-04', 'UY', 'Uruguay', 'AMRO', '1', '826', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91355, '2020-06-05', 'UY', 'Uruguay', 'AMRO', '2', '828', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91356, '2020-06-06', 'UY', 'Uruguay', 'AMRO', '4', '832', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91357, '2020-06-07', 'UY', 'Uruguay', 'AMRO', '2', '834', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91358, '2020-06-08', 'UY', 'Uruguay', 'AMRO', '11', '845', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91359, '2020-06-09', 'UY', 'Uruguay', 'AMRO', '0', '845', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91360, '2020-06-10', 'UY', 'Uruguay', 'AMRO', '0', '845', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91361, '2020-06-11', 'UY', 'Uruguay', 'AMRO', '1', '846', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91362, '2020-06-12', 'UY', 'Uruguay', 'AMRO', '1', '847', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91363, '2020-06-13', 'UY', 'Uruguay', 'AMRO', '0', '847', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91364, '2020-06-14', 'UY', 'Uruguay', 'AMRO', '0', '847', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91365, '2020-06-15', 'UY', 'Uruguay', 'AMRO', '0', '847', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91366, '2020-06-16', 'UY', 'Uruguay', 'AMRO', '1', '848', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91367, '2020-06-17', 'UY', 'Uruguay', 'AMRO', '0', '848', '0', '23');
INSERT INTO public.who_global_data_import VALUES (91368, '2020-06-18', 'UY', 'Uruguay', 'AMRO', '1', '849', '1', '24');
INSERT INTO public.who_global_data_import VALUES (91369, '2020-06-19', 'UY', 'Uruguay', 'AMRO', '0', '849', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91370, '2020-06-20', 'UY', 'Uruguay', 'AMRO', '1', '850', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91371, '2020-06-21', 'UY', 'Uruguay', 'AMRO', '3', '853', '0', '24');
INSERT INTO public.who_global_data_import VALUES (91372, '2020-06-22', 'UY', 'Uruguay', 'AMRO', '6', '859', '1', '25');
INSERT INTO public.who_global_data_import VALUES (91373, '2020-06-23', 'UY', 'Uruguay', 'AMRO', '17', '876', '0', '25');
INSERT INTO public.who_global_data_import VALUES (91374, '2020-06-24', 'UY', 'Uruguay', 'AMRO', '6', '882', '0', '25');
INSERT INTO public.who_global_data_import VALUES (91375, '2020-06-25', 'UY', 'Uruguay', 'AMRO', '3', '885', '0', '25');
INSERT INTO public.who_global_data_import VALUES (91376, '2020-06-26', 'UY', 'Uruguay', 'AMRO', '17', '902', '1', '26');
INSERT INTO public.who_global_data_import VALUES (91377, '2020-06-27', 'UY', 'Uruguay', 'AMRO', '5', '907', '0', '26');
INSERT INTO public.who_global_data_import VALUES (91378, '2020-06-28', 'UY', 'Uruguay', 'AMRO', '12', '919', '0', '26');
INSERT INTO public.who_global_data_import VALUES (91379, '2020-06-29', 'UY', 'Uruguay', 'AMRO', '5', '924', '0', '26');
INSERT INTO public.who_global_data_import VALUES (91380, '2020-06-30', 'UY', 'Uruguay', 'AMRO', '5', '929', '1', '27');
INSERT INTO public.who_global_data_import VALUES (91381, '2020-07-01', 'UY', 'Uruguay', 'AMRO', '3', '932', '0', '27');
INSERT INTO public.who_global_data_import VALUES (91382, '2020-07-02', 'UY', 'Uruguay', 'AMRO', '4', '936', '0', '27');
INSERT INTO public.who_global_data_import VALUES (91383, '2020-07-03', 'UY', 'Uruguay', 'AMRO', '7', '943', '1', '28');
INSERT INTO public.who_global_data_import VALUES (91384, '2020-07-04', 'UY', 'Uruguay', 'AMRO', '4', '947', '0', '28');
INSERT INTO public.who_global_data_import VALUES (91385, '2020-07-05', 'UY', 'Uruguay', 'AMRO', '5', '952', '0', '28');
INSERT INTO public.who_global_data_import VALUES (91386, '2020-07-06', 'UY', 'Uruguay', 'AMRO', '3', '955', '0', '28');
INSERT INTO public.who_global_data_import VALUES (91387, '2020-07-07', 'UY', 'Uruguay', 'AMRO', '1', '956', '0', '28');
INSERT INTO public.who_global_data_import VALUES (91388, '2020-07-08', 'UY', 'Uruguay', 'AMRO', '4', '960', '1', '29');
INSERT INTO public.who_global_data_import VALUES (91389, '2020-07-09', 'UY', 'Uruguay', 'AMRO', '5', '965', '0', '29');
INSERT INTO public.who_global_data_import VALUES (91390, '2020-07-10', 'UY', 'Uruguay', 'AMRO', '9', '974', '0', '29');
INSERT INTO public.who_global_data_import VALUES (91391, '2020-07-11', 'UY', 'Uruguay', 'AMRO', '3', '977', '0', '29');
INSERT INTO public.who_global_data_import VALUES (91392, '2020-07-12', 'UY', 'Uruguay', 'AMRO', '8', '985', '0', '29');
INSERT INTO public.who_global_data_import VALUES (91393, '2020-07-13', 'UY', 'Uruguay', 'AMRO', '1', '986', '1', '30');
INSERT INTO public.who_global_data_import VALUES (91394, '2020-07-14', 'UY', 'Uruguay', 'AMRO', '1', '987', '1', '31');
INSERT INTO public.who_global_data_import VALUES (91395, '2020-07-15', 'UY', 'Uruguay', 'AMRO', '2', '989', '0', '31');
INSERT INTO public.who_global_data_import VALUES (91396, '2020-07-16', 'UY', 'Uruguay', 'AMRO', '8', '997', '0', '31');
INSERT INTO public.who_global_data_import VALUES (91397, '2020-07-17', 'UY', 'Uruguay', 'AMRO', '12', '1009', '0', '31');
INSERT INTO public.who_global_data_import VALUES (91398, '2020-07-18', 'UY', 'Uruguay', 'AMRO', '17', '1026', '1', '32');
INSERT INTO public.who_global_data_import VALUES (91399, '2020-07-19', 'UY', 'Uruguay', 'AMRO', '11', '1037', '0', '32');
INSERT INTO public.who_global_data_import VALUES (91400, '2020-07-20', 'UY', 'Uruguay', 'AMRO', '7', '1044', '1', '33');
INSERT INTO public.who_global_data_import VALUES (91401, '2020-07-21', 'UY', 'Uruguay', 'AMRO', '10', '1054', '0', '33');
INSERT INTO public.who_global_data_import VALUES (91402, '2020-07-22', 'UY', 'Uruguay', 'AMRO', '10', '1064', '0', '33');
INSERT INTO public.who_global_data_import VALUES (91403, '2020-07-23', 'UY', 'Uruguay', 'AMRO', '32', '1096', '0', '33');
INSERT INTO public.who_global_data_import VALUES (91404, '2020-07-24', 'UY', 'Uruguay', 'AMRO', '21', '1117', '1', '34');
INSERT INTO public.who_global_data_import VALUES (91405, '2020-07-25', 'UY', 'Uruguay', 'AMRO', '24', '1141', '0', '34');
INSERT INTO public.who_global_data_import VALUES (91406, '2020-07-26', 'UY', 'Uruguay', 'AMRO', '25', '1166', '0', '34');
INSERT INTO public.who_global_data_import VALUES (91407, '2020-07-27', 'UY', 'Uruguay', 'AMRO', '8', '1174', '0', '34');
INSERT INTO public.who_global_data_import VALUES (91408, '2020-07-28', 'UY', 'Uruguay', 'AMRO', '18', '1192', '0', '34');
INSERT INTO public.who_global_data_import VALUES (91409, '2020-07-29', 'UY', 'Uruguay', 'AMRO', '10', '1202', '1', '35');
INSERT INTO public.who_global_data_import VALUES (91410, '2020-07-30', 'UY', 'Uruguay', 'AMRO', '16', '1218', '0', '35');
INSERT INTO public.who_global_data_import VALUES (91411, '2020-07-31', 'UY', 'Uruguay', 'AMRO', '19', '1237', '0', '35');
INSERT INTO public.who_global_data_import VALUES (91412, '2020-08-01', 'UY', 'Uruguay', 'AMRO', '6', '1243', '0', '35');
INSERT INTO public.who_global_data_import VALUES (91413, '2020-08-02', 'UY', 'Uruguay', 'AMRO', '22', '1265', '0', '35');
INSERT INTO public.who_global_data_import VALUES (91414, '2020-08-03', 'UY', 'Uruguay', 'AMRO', '13', '1278', '0', '35');
INSERT INTO public.who_global_data_import VALUES (91415, '2020-08-04', 'UY', 'Uruguay', 'AMRO', '8', '1286', '1', '36');
INSERT INTO public.who_global_data_import VALUES (91416, '2020-08-05', 'UY', 'Uruguay', 'AMRO', '5', '1291', '0', '36');
INSERT INTO public.who_global_data_import VALUES (91417, '2020-08-06', 'UY', 'Uruguay', 'AMRO', '9', '1300', '1', '37');
INSERT INTO public.who_global_data_import VALUES (91418, '2020-08-07', 'UY', 'Uruguay', 'AMRO', '9', '1309', '0', '37');
INSERT INTO public.who_global_data_import VALUES (91419, '2020-08-08', 'UY', 'Uruguay', 'AMRO', '9', '1318', '0', '37');
INSERT INTO public.who_global_data_import VALUES (91420, '2020-08-09', 'UY', 'Uruguay', 'AMRO', '7', '1325', '0', '37');
INSERT INTO public.who_global_data_import VALUES (91421, '2020-08-10', 'UY', 'Uruguay', 'AMRO', '10', '1335', '0', '37');
INSERT INTO public.who_global_data_import VALUES (91422, '2020-08-11', 'UY', 'Uruguay', 'AMRO', '18', '1353', '0', '37');
INSERT INTO public.who_global_data_import VALUES (91423, '2020-08-12', 'UY', 'Uruguay', 'AMRO', '11', '1364', '0', '37');
INSERT INTO public.who_global_data_import VALUES (91424, '2020-08-13', 'UY', 'Uruguay', 'AMRO', '21', '1385', '0', '37');
INSERT INTO public.who_global_data_import VALUES (91425, '2020-08-14', 'UY', 'Uruguay', 'AMRO', '8', '1393', '0', '37');
INSERT INTO public.who_global_data_import VALUES (91426, '2020-08-15', 'UY', 'Uruguay', 'AMRO', '16', '1409', '0', '37');
INSERT INTO public.who_global_data_import VALUES (91427, '2020-08-16', 'UY', 'Uruguay', 'AMRO', '12', '1421', '1', '38');
INSERT INTO public.who_global_data_import VALUES (91428, '2020-08-17', 'UY', 'Uruguay', 'AMRO', '13', '1434', '0', '38');
INSERT INTO public.who_global_data_import VALUES (91429, '2020-08-18', 'UY', 'Uruguay', 'AMRO', '6', '1440', '0', '38');
INSERT INTO public.who_global_data_import VALUES (91430, '2020-08-19', 'UY', 'Uruguay', 'AMRO', '17', '1457', '2', '40');
INSERT INTO public.who_global_data_import VALUES (91431, '2020-08-20', 'UY', 'Uruguay', 'AMRO', '28', '1485', '0', '40');
INSERT INTO public.who_global_data_import VALUES (91432, '2020-08-21', 'UY', 'Uruguay', 'AMRO', '8', '1493', '0', '40');
INSERT INTO public.who_global_data_import VALUES (91433, '2020-08-22', 'UY', 'Uruguay', 'AMRO', '13', '1506', '1', '41');
INSERT INTO public.who_global_data_import VALUES (91434, '2020-08-23', 'UY', 'Uruguay', 'AMRO', '10', '1516', '1', '42');
INSERT INTO public.who_global_data_import VALUES (91435, '2020-08-24', 'UY', 'Uruguay', 'AMRO', '5', '1521', '0', '42');
INSERT INTO public.who_global_data_import VALUES (91436, '2020-08-25', 'UY', 'Uruguay', 'AMRO', '6', '1527', '0', '42');
INSERT INTO public.who_global_data_import VALUES (91437, '2020-08-26', 'UY', 'Uruguay', 'AMRO', '6', '1533', '0', '42');
INSERT INTO public.who_global_data_import VALUES (91438, '2020-08-27', 'UY', 'Uruguay', 'AMRO', '3', '1536', '1', '43');
INSERT INTO public.who_global_data_import VALUES (91439, '2020-08-28', 'UY', 'Uruguay', 'AMRO', '7', '1543', '0', '43');
INSERT INTO public.who_global_data_import VALUES (91440, '2020-08-29', 'UY', 'Uruguay', 'AMRO', '8', '1551', '0', '43');
INSERT INTO public.who_global_data_import VALUES (91441, '2020-08-30', 'UY', 'Uruguay', 'AMRO', '5', '1556', '0', '43');
INSERT INTO public.who_global_data_import VALUES (91442, '2020-08-31', 'UY', 'Uruguay', 'AMRO', '14', '1570', '1', '44');
INSERT INTO public.who_global_data_import VALUES (91443, '2020-09-01', 'UY', 'Uruguay', 'AMRO', '15', '1585', '0', '44');
INSERT INTO public.who_global_data_import VALUES (91444, '2020-09-02', 'UY', 'Uruguay', 'AMRO', '10', '1595', '0', '44');
INSERT INTO public.who_global_data_import VALUES (91445, '2020-09-03', 'UY', 'Uruguay', 'AMRO', '16', '1611', '0', '44');
INSERT INTO public.who_global_data_import VALUES (91446, '2020-09-04', 'UY', 'Uruguay', 'AMRO', '15', '1626', '0', '44');
INSERT INTO public.who_global_data_import VALUES (91447, '2020-09-05', 'UY', 'Uruguay', 'AMRO', '10', '1636', '0', '44');
INSERT INTO public.who_global_data_import VALUES (91448, '2020-09-06', 'UY', 'Uruguay', 'AMRO', '17', '1653', '1', '45');
INSERT INTO public.who_global_data_import VALUES (91449, '2020-09-07', 'UY', 'Uruguay', 'AMRO', '16', '1669', '0', '45');
INSERT INTO public.who_global_data_import VALUES (91450, '2020-09-08', 'UY', 'Uruguay', 'AMRO', '10', '1679', '0', '45');
INSERT INTO public.who_global_data_import VALUES (91451, '2020-09-09', 'UY', 'Uruguay', 'AMRO', '14', '1693', '0', '45');
INSERT INTO public.who_global_data_import VALUES (91452, '2020-09-10', 'UY', 'Uruguay', 'AMRO', '19', '1712', '0', '45');
INSERT INTO public.who_global_data_import VALUES (91453, '2020-09-11', 'UY', 'Uruguay', 'AMRO', '29', '1741', '0', '45');
INSERT INTO public.who_global_data_import VALUES (91454, '2020-09-12', 'UY', 'Uruguay', 'AMRO', '18', '1759', '0', '45');
INSERT INTO public.who_global_data_import VALUES (91455, '2020-09-13', 'UY', 'Uruguay', 'AMRO', '14', '1773', '0', '45');
INSERT INTO public.who_global_data_import VALUES (91456, '2020-09-14', 'UY', 'Uruguay', 'AMRO', '7', '1780', '0', '45');
INSERT INTO public.who_global_data_import VALUES (91457, '2020-09-15', 'UY', 'Uruguay', 'AMRO', '28', '1808', '0', '45');
INSERT INTO public.who_global_data_import VALUES (91458, '2020-09-16', 'UY', 'Uruguay', 'AMRO', '4', '1812', '0', '45');
INSERT INTO public.who_global_data_import VALUES (91459, '2020-09-17', 'UY', 'Uruguay', 'AMRO', '15', '1827', '0', '45');
INSERT INTO public.who_global_data_import VALUES (91460, '2020-09-18', 'UY', 'Uruguay', 'AMRO', '29', '1856', '0', '45');
INSERT INTO public.who_global_data_import VALUES (91461, '2020-09-19', 'UY', 'Uruguay', 'AMRO', '20', '1876', '1', '46');
INSERT INTO public.who_global_data_import VALUES (91462, '2020-09-20', 'UY', 'Uruguay', 'AMRO', '14', '1890', '0', '46');
INSERT INTO public.who_global_data_import VALUES (91463, '2020-09-21', 'UY', 'Uruguay', 'AMRO', '14', '1904', '0', '46');
INSERT INTO public.who_global_data_import VALUES (91464, '2020-09-22', 'UY', 'Uruguay', 'AMRO', '13', '1917', '0', '46');
INSERT INTO public.who_global_data_import VALUES (91465, '2020-09-23', 'UY', 'Uruguay', 'AMRO', '10', '1927', '0', '46');
INSERT INTO public.who_global_data_import VALUES (91466, '2020-09-24', 'UY', 'Uruguay', 'AMRO', '7', '1934', '0', '46');
INSERT INTO public.who_global_data_import VALUES (91467, '2020-09-25', 'UY', 'Uruguay', 'AMRO', '12', '1946', '1', '47');
INSERT INTO public.who_global_data_import VALUES (91468, '2020-09-26', 'UY', 'Uruguay', 'AMRO', '13', '1959', '0', '47');
INSERT INTO public.who_global_data_import VALUES (91469, '2020-09-27', 'UY', 'Uruguay', 'AMRO', '8', '1967', '0', '47');
INSERT INTO public.who_global_data_import VALUES (91470, '2020-09-28', 'UY', 'Uruguay', 'AMRO', '31', '1998', '0', '47');
INSERT INTO public.who_global_data_import VALUES (91471, '2020-09-29', 'UY', 'Uruguay', 'AMRO', '10', '2008', '0', '47');
INSERT INTO public.who_global_data_import VALUES (91472, '2020-09-30', 'UY', 'Uruguay', 'AMRO', '2', '2010', '0', '47');
INSERT INTO public.who_global_data_import VALUES (91473, '2020-10-01', 'UY', 'Uruguay', 'AMRO', '23', '2033', '1', '48');
INSERT INTO public.who_global_data_import VALUES (91474, '2020-10-02', 'UY', 'Uruguay', 'AMRO', '13', '2046', '0', '48');
INSERT INTO public.who_global_data_import VALUES (91475, '2020-10-03', 'UY', 'Uruguay', 'AMRO', '15', '2061', '0', '48');
INSERT INTO public.who_global_data_import VALUES (91476, '2020-10-04', 'UY', 'Uruguay', 'AMRO', '36', '2097', '0', '48');
INSERT INTO public.who_global_data_import VALUES (91477, '2020-10-05', 'UY', 'Uruguay', 'AMRO', '25', '2122', '0', '48');
INSERT INTO public.who_global_data_import VALUES (91478, '2020-10-06', 'UY', 'Uruguay', 'AMRO', '23', '2145', '0', '48');
INSERT INTO public.who_global_data_import VALUES (91479, '2020-10-07', 'UY', 'Uruguay', 'AMRO', '10', '2155', '0', '48');
INSERT INTO public.who_global_data_import VALUES (91480, '2020-10-08', 'UY', 'Uruguay', 'AMRO', '22', '2177', '1', '49');
INSERT INTO public.who_global_data_import VALUES (91481, '2020-10-09', 'UY', 'Uruguay', 'AMRO', '29', '2206', '0', '49');
INSERT INTO public.who_global_data_import VALUES (91482, '2020-10-10', 'UY', 'Uruguay', 'AMRO', '20', '2226', '0', '49');
INSERT INTO public.who_global_data_import VALUES (91483, '2020-10-11', 'UY', 'Uruguay', 'AMRO', '25', '2251', '0', '49');
INSERT INTO public.who_global_data_import VALUES (91484, '2020-10-12', 'UY', 'Uruguay', 'AMRO', '17', '2268', '1', '50');
INSERT INTO public.who_global_data_import VALUES (91485, '2020-10-13', 'UY', 'Uruguay', 'AMRO', '26', '2294', '0', '50');
INSERT INTO public.who_global_data_import VALUES (91486, '2020-10-14', 'UY', 'Uruguay', 'AMRO', '19', '2313', '1', '51');
INSERT INTO public.who_global_data_import VALUES (91487, '2020-10-15', 'UY', 'Uruguay', 'AMRO', '24', '2337', '0', '51');
INSERT INTO public.who_global_data_import VALUES (91488, '2020-10-16', 'UY', 'Uruguay', 'AMRO', '51', '2388', '0', '51');
INSERT INTO public.who_global_data_import VALUES (91489, '2020-10-17', 'UY', 'Uruguay', 'AMRO', '29', '2417', '0', '51');
INSERT INTO public.who_global_data_import VALUES (91490, '2020-10-18', 'UY', 'Uruguay', 'AMRO', '33', '2450', '0', '51');
INSERT INTO public.who_global_data_import VALUES (91491, '2020-10-19', 'UY', 'Uruguay', 'AMRO', '51', '2501', '0', '51');
INSERT INTO public.who_global_data_import VALUES (91492, '2020-10-20', 'UY', 'Uruguay', 'AMRO', '30', '2531', '0', '51');
INSERT INTO public.who_global_data_import VALUES (91493, '2020-10-21', 'UY', 'Uruguay', 'AMRO', '29', '2560', '0', '51');
INSERT INTO public.who_global_data_import VALUES (91494, '2020-10-22', 'UY', 'Uruguay', 'AMRO', '63', '2623', '1', '52');
INSERT INTO public.who_global_data_import VALUES (91495, '2020-10-23', 'UY', 'Uruguay', 'AMRO', '40', '2663', '1', '53');
INSERT INTO public.who_global_data_import VALUES (91496, '2020-10-24', 'UY', 'Uruguay', 'AMRO', '38', '2701', '0', '53');
INSERT INTO public.who_global_data_import VALUES (91497, '2020-10-25', 'UY', 'Uruguay', 'AMRO', '58', '2759', '0', '53');
INSERT INTO public.who_global_data_import VALUES (91498, '2020-10-26', 'UY', 'Uruguay', 'AMRO', '48', '2807', '0', '53');
INSERT INTO public.who_global_data_import VALUES (91499, '2020-10-27', 'UY', 'Uruguay', 'AMRO', '44', '2851', '0', '53');
INSERT INTO public.who_global_data_import VALUES (91500, '2020-10-28', 'UY', 'Uruguay', 'AMRO', '21', '2872', '1', '54');
INSERT INTO public.who_global_data_import VALUES (91501, '2020-10-29', 'UY', 'Uruguay', 'AMRO', '44', '2916', '0', '54');
INSERT INTO public.who_global_data_import VALUES (91502, '2020-10-30', 'UY', 'Uruguay', 'AMRO', '65', '2981', '1', '55');
INSERT INTO public.who_global_data_import VALUES (91503, '2020-10-31', 'UY', 'Uruguay', 'AMRO', '63', '3044', '2', '57');
INSERT INTO public.who_global_data_import VALUES (91504, '2020-11-01', 'UY', 'Uruguay', 'AMRO', '38', '3082', '1', '58');
INSERT INTO public.who_global_data_import VALUES (91505, '2020-11-02', 'UY', 'Uruguay', 'AMRO', '42', '3124', '0', '58');
INSERT INTO public.who_global_data_import VALUES (91506, '2020-11-03', 'UY', 'Uruguay', 'AMRO', '25', '3149', '1', '59');
INSERT INTO public.who_global_data_import VALUES (91507, '2020-11-04', 'UY', 'Uruguay', 'AMRO', '16', '3165', '1', '60');
INSERT INTO public.who_global_data_import VALUES (91508, '2020-11-05', 'UY', 'Uruguay', 'AMRO', '31', '3196', '1', '61');
INSERT INTO public.who_global_data_import VALUES (91509, '2020-11-06', 'UY', 'Uruguay', 'AMRO', '49', '3245', '0', '61');
INSERT INTO public.who_global_data_import VALUES (91510, '2020-11-07', 'UY', 'Uruguay', 'AMRO', '64', '3309', '0', '61');
INSERT INTO public.who_global_data_import VALUES (91511, '2020-11-08', 'UY', 'Uruguay', 'AMRO', '61', '3370', '0', '61');
INSERT INTO public.who_global_data_import VALUES (91512, '2020-11-09', 'UY', 'Uruguay', 'AMRO', '71', '3441', '0', '61');
INSERT INTO public.who_global_data_import VALUES (91513, '2020-11-10', 'UY', 'Uruguay', 'AMRO', '73', '3514', '1', '62');
INSERT INTO public.who_global_data_import VALUES (91514, '2020-11-11', 'UY', 'Uruguay', 'AMRO', '46', '3560', '0', '62');
INSERT INTO public.who_global_data_import VALUES (91515, '2020-11-12', 'UY', 'Uruguay', 'AMRO', '60', '3620', '0', '62');
INSERT INTO public.who_global_data_import VALUES (91516, '2020-11-13', 'UY', 'Uruguay', 'AMRO', '80', '3700', '1', '63');
INSERT INTO public.who_global_data_import VALUES (91517, '2020-11-14', 'UY', 'Uruguay', 'AMRO', '95', '3795', '0', '63');
INSERT INTO public.who_global_data_import VALUES (91518, '2020-11-15', 'UY', 'Uruguay', 'AMRO', '88', '3883', '1', '64');
INSERT INTO public.who_global_data_import VALUES (91519, '2020-11-16', 'UY', 'Uruguay', 'AMRO', '74', '3957', '0', '64');
INSERT INTO public.who_global_data_import VALUES (91520, '2020-11-17', 'UY', 'Uruguay', 'AMRO', '73', '4030', '1', '65');
INSERT INTO public.who_global_data_import VALUES (91521, '2020-11-18', 'UY', 'Uruguay', 'AMRO', '74', '4104', '2', '67');
INSERT INTO public.who_global_data_import VALUES (91522, '2020-11-19', 'UY', 'Uruguay', 'AMRO', '104', '4208', '1', '68');
INSERT INTO public.who_global_data_import VALUES (91523, '2020-11-20', 'UY', 'Uruguay', 'AMRO', '88', '4296', '0', '68');
INSERT INTO public.who_global_data_import VALUES (91524, '2020-11-21', 'UY', 'Uruguay', 'AMRO', '81', '4377', '1', '69');
INSERT INTO public.who_global_data_import VALUES (91525, '2020-11-22', 'UY', 'Uruguay', 'AMRO', '100', '4477', '0', '69');
INSERT INTO public.who_global_data_import VALUES (91526, '2020-11-23', 'UY', 'Uruguay', 'AMRO', '87', '4564', '0', '69');
INSERT INTO public.who_global_data_import VALUES (91527, '2020-11-24', 'UY', 'Uruguay', 'AMRO', '135', '4699', '2', '71');
INSERT INTO public.who_global_data_import VALUES (91528, '2020-11-25', 'UY', 'Uruguay', 'AMRO', '64', '4763', '0', '71');
INSERT INTO public.who_global_data_import VALUES (91529, '2020-11-26', 'UY', 'Uruguay', 'AMRO', '107', '4870', '1', '72');
INSERT INTO public.who_global_data_import VALUES (91530, '2020-11-27', 'UY', 'Uruguay', 'AMRO', '118', '4988', '1', '73');
INSERT INTO public.who_global_data_import VALUES (91531, '2020-11-28', 'UY', 'Uruguay', 'AMRO', '129', '5117', '1', '74');
INSERT INTO public.who_global_data_import VALUES (91532, '2020-11-29', 'UY', 'Uruguay', 'AMRO', '186', '5303', '0', '74');
INSERT INTO public.who_global_data_import VALUES (91533, '2020-11-30', 'UY', 'Uruguay', 'AMRO', '208', '5511', '1', '75');
INSERT INTO public.who_global_data_import VALUES (91534, '2020-12-01', 'UY', 'Uruguay', 'AMRO', '205', '5716', '1', '76');
INSERT INTO public.who_global_data_import VALUES (91535, '2020-12-02', 'UY', 'Uruguay', 'AMRO', '141', '5857', '1', '77');
INSERT INTO public.who_global_data_import VALUES (91536, '2020-12-03', 'UY', 'Uruguay', 'AMRO', '167', '6024', '1', '78');
INSERT INTO public.who_global_data_import VALUES (91537, '2020-12-04', 'UY', 'Uruguay', 'AMRO', '201', '6225', '2', '80');
INSERT INTO public.who_global_data_import VALUES (91538, '2020-12-05', 'UY', 'Uruguay', 'AMRO', '230', '6455', '0', '80');
INSERT INTO public.who_global_data_import VALUES (91539, '2020-12-06', 'UY', 'Uruguay', 'AMRO', '276', '6731', '0', '80');
INSERT INTO public.who_global_data_import VALUES (91540, '2020-12-07', 'UY', 'Uruguay', 'AMRO', '234', '6965', '1', '81');
INSERT INTO public.who_global_data_import VALUES (91541, '2020-12-08', 'UY', 'Uruguay', 'AMRO', '338', '7303', '1', '82');
INSERT INTO public.who_global_data_import VALUES (91542, '2020-12-09', 'UY', 'Uruguay', 'AMRO', '202', '7505', '1', '83');
INSERT INTO public.who_global_data_import VALUES (91543, '2020-12-10', 'UY', 'Uruguay', 'AMRO', '301', '7806', '3', '86');
INSERT INTO public.who_global_data_import VALUES (91544, '2020-12-11', 'UY', 'Uruguay', 'AMRO', '298', '8104', '1', '87');
INSERT INTO public.who_global_data_import VALUES (91545, '2020-12-12', 'UY', 'Uruguay', 'AMRO', '383', '8487', '3', '90');
INSERT INTO public.who_global_data_import VALUES (91546, '2020-12-13', 'UY', 'Uruguay', 'AMRO', '362', '8849', '0', '90');
INSERT INTO public.who_global_data_import VALUES (91547, '2020-12-14', 'UY', 'Uruguay', 'AMRO', '331', '9180', '1', '91');
INSERT INTO public.who_global_data_import VALUES (91548, '2020-12-15', 'UY', 'Uruguay', 'AMRO', '528', '9708', '1', '92');
INSERT INTO public.who_global_data_import VALUES (91549, '2020-12-16', 'UY', 'Uruguay', 'AMRO', '321', '10029', '3', '95');
INSERT INTO public.who_global_data_import VALUES (91550, '2020-12-17', 'UY', 'Uruguay', 'AMRO', '389', '10418', '3', '98');
INSERT INTO public.who_global_data_import VALUES (91551, '2020-12-18', 'UY', 'Uruguay', 'AMRO', '475', '10893', '4', '102');
INSERT INTO public.who_global_data_import VALUES (91552, '2020-12-19', 'UY', 'Uruguay', 'AMRO', '543', '11436', '3', '105');
INSERT INTO public.who_global_data_import VALUES (91553, '2020-12-20', 'UY', 'Uruguay', 'AMRO', '514', '11950', '4', '109');
INSERT INTO public.who_global_data_import VALUES (91554, '2020-12-21', 'UY', 'Uruguay', 'AMRO', '607', '12557', '5', '114');
INSERT INTO public.who_global_data_import VALUES (91555, '2020-12-22', 'UY', 'Uruguay', 'AMRO', '491', '13048', '5', '119');
INSERT INTO public.who_global_data_import VALUES (91556, '2020-12-23', 'UY', 'Uruguay', 'AMRO', '429', '13477', '0', '119');
INSERT INTO public.who_global_data_import VALUES (91557, '2020-12-24', 'UY', 'Uruguay', 'AMRO', '524', '14001', '1', '120');
INSERT INTO public.who_global_data_import VALUES (91558, '2020-12-25', 'UY', 'Uruguay', 'AMRO', '709', '14710', '8', '128');
INSERT INTO public.who_global_data_import VALUES (91559, '2020-12-26', 'UY', 'Uruguay', 'AMRO', '747', '15457', '7', '135');
INSERT INTO public.who_global_data_import VALUES (91560, '2020-12-27', 'UY', 'Uruguay', 'AMRO', '391', '15848', '8', '143');
INSERT INTO public.who_global_data_import VALUES (91561, '2020-12-28', 'UY', 'Uruguay', 'AMRO', '370', '16218', '4', '147');
INSERT INTO public.who_global_data_import VALUES (91562, '2020-12-29', 'UY', 'Uruguay', 'AMRO', '510', '16728', '11', '158');
INSERT INTO public.who_global_data_import VALUES (91563, '2020-12-30', 'UY', 'Uruguay', 'AMRO', '578', '17306', '2', '160');
INSERT INTO public.who_global_data_import VALUES (91564, '2020-12-31', 'UY', 'Uruguay', 'AMRO', '656', '17962', '8', '168');
INSERT INTO public.who_global_data_import VALUES (91565, '2021-01-01', 'UY', 'Uruguay', 'AMRO', '518', '18480', '6', '174');
INSERT INTO public.who_global_data_import VALUES (91566, '2021-01-02', 'UY', 'Uruguay', 'AMRO', '639', '19119', '7', '181');
INSERT INTO public.who_global_data_import VALUES (91567, '2021-01-03', 'UY', 'Uruguay', 'AMRO', '634', '19753', '12', '193');
INSERT INTO public.who_global_data_import VALUES (91568, '2021-01-04', 'UY', 'Uruguay', 'AMRO', '522', '20275', '8', '201');
INSERT INTO public.who_global_data_import VALUES (91569, '2021-01-05', 'UY', 'Uruguay', 'AMRO', '548', '20823', '3', '204');
INSERT INTO public.who_global_data_import VALUES (91570, '2021-01-06', 'UY', 'Uruguay', 'AMRO', '603', '21426', '7', '211');
INSERT INTO public.who_global_data_import VALUES (91571, '2021-01-07', 'UY', 'Uruguay', 'AMRO', '678', '22104', '6', '217');
INSERT INTO public.who_global_data_import VALUES (91572, '2021-01-08', 'UY', 'Uruguay', 'AMRO', '944', '23048', '4', '221');
INSERT INTO public.who_global_data_import VALUES (91573, '2021-01-09', 'UY', 'Uruguay', 'AMRO', '759', '23807', '10', '231');
INSERT INTO public.who_global_data_import VALUES (91574, '2021-01-10', 'UY', 'Uruguay', 'AMRO', '532', '24339', '9', '240');
INSERT INTO public.who_global_data_import VALUES (91575, '2021-01-11', 'UY', 'Uruguay', 'AMRO', '635', '24974', '8', '248');
INSERT INTO public.who_global_data_import VALUES (91576, '2021-01-12', 'UY', 'Uruguay', 'AMRO', '1212', '26186', '8', '256');
INSERT INTO public.who_global_data_import VALUES (91577, '2021-01-13', 'UY', 'Uruguay', 'AMRO', '715', '26901', '6', '262');
INSERT INTO public.who_global_data_import VALUES (91578, '2021-01-14', 'UY', 'Uruguay', 'AMRO', '945', '27846', '7', '269');
INSERT INTO public.who_global_data_import VALUES (91579, '2021-01-15', 'UY', 'Uruguay', 'AMRO', '629', '28475', '6', '275');
INSERT INTO public.who_global_data_import VALUES (91580, '2021-01-16', 'UY', 'Uruguay', 'AMRO', '1514', '29989', '5', '280');
INSERT INTO public.who_global_data_import VALUES (91581, '2021-01-17', 'UY', 'Uruguay', 'AMRO', '957', '30946', '11', '291');
INSERT INTO public.who_global_data_import VALUES (91582, '2021-01-18', 'UY', 'Uruguay', 'AMRO', '723', '31669', '7', '298');
INSERT INTO public.who_global_data_import VALUES (91583, '2021-01-19', 'UY', 'Uruguay', 'AMRO', '709', '32378', '13', '311');
INSERT INTO public.who_global_data_import VALUES (91584, '2021-01-20', 'UY', 'Uruguay', 'AMRO', '485', '32863', '8', '319');
INSERT INTO public.who_global_data_import VALUES (91585, '2021-01-21', 'UY', 'Uruguay', 'AMRO', '583', '33446', '11', '330');
INSERT INTO public.who_global_data_import VALUES (91586, '2021-01-22', 'UY', 'Uruguay', 'AMRO', '848', '34294', '6', '336');
INSERT INTO public.who_global_data_import VALUES (91587, '2021-01-23', 'UY', 'Uruguay', 'AMRO', '698', '34992', '11', '347');
INSERT INTO public.who_global_data_import VALUES (91588, '2021-01-24', 'UY', 'Uruguay', 'AMRO', '1178', '36170', '17', '364');
INSERT INTO public.who_global_data_import VALUES (91589, '2021-01-25', 'UY', 'Uruguay', 'AMRO', '797', '36967', '3', '367');
INSERT INTO public.who_global_data_import VALUES (91590, '2021-01-26', 'UY', 'Uruguay', 'AMRO', '666', '37633', '9', '376');
INSERT INTO public.who_global_data_import VALUES (91591, '2021-01-27', 'UY', 'Uruguay', 'AMRO', '408', '38041', '14', '390');
INSERT INTO public.who_global_data_import VALUES (91592, '2021-01-28', 'UY', 'Uruguay', 'AMRO', '639', '38680', '11', '401');
INSERT INTO public.who_global_data_import VALUES (91593, '2021-01-29', 'UY', 'Uruguay', 'AMRO', '648', '39328', '6', '407');
INSERT INTO public.who_global_data_import VALUES (91594, '2021-01-30', 'UY', 'Uruguay', 'AMRO', '559', '39887', '8', '415');
INSERT INTO public.who_global_data_import VALUES (91595, '2021-01-31', 'UY', 'Uruguay', 'AMRO', '642', '40529', '10', '425');
INSERT INTO public.who_global_data_import VALUES (91596, '2021-02-01', 'UY', 'Uruguay', 'AMRO', '652', '41181', '6', '431');
INSERT INTO public.who_global_data_import VALUES (91597, '2021-02-02', 'UY', 'Uruguay', 'AMRO', '557', '41738', '5', '436');
INSERT INTO public.who_global_data_import VALUES (91598, '2021-02-03', 'UY', 'Uruguay', 'AMRO', '390', '42128', '8', '444');
INSERT INTO public.who_global_data_import VALUES (91599, '2021-02-04', 'UY', 'Uruguay', 'AMRO', '539', '42667', '9', '453');
INSERT INTO public.who_global_data_import VALUES (91600, '2021-02-05', 'UY', 'Uruguay', 'AMRO', '548', '43215', '11', '464');
INSERT INTO public.who_global_data_import VALUES (91601, '2020-01-03', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91602, '2020-01-04', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91603, '2020-01-05', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91604, '2020-01-06', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91605, '2020-01-07', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91606, '2020-01-08', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91607, '2020-01-09', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91608, '2020-01-10', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91609, '2020-01-11', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91610, '2020-01-12', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91611, '2020-01-13', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91612, '2020-01-14', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91613, '2020-01-15', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91614, '2020-01-16', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91615, '2020-01-17', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91616, '2020-01-18', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91617, '2020-01-19', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91618, '2020-01-20', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91619, '2020-01-21', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91620, '2020-01-22', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91621, '2020-01-23', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91622, '2020-01-24', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91623, '2020-01-25', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91624, '2020-01-26', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91625, '2020-01-27', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91626, '2020-01-28', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91627, '2020-01-29', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91628, '2020-01-30', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91629, '2020-01-31', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91630, '2020-02-01', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91631, '2020-02-02', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91632, '2020-02-03', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91633, '2020-02-04', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91634, '2020-02-05', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91635, '2020-02-06', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91636, '2020-02-07', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91637, '2020-02-08', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91638, '2020-02-09', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91639, '2020-02-10', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91640, '2020-02-11', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91641, '2020-02-12', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91642, '2020-02-13', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91643, '2020-02-14', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91644, '2020-02-15', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91645, '2020-02-16', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91646, '2020-02-17', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91647, '2020-02-18', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91648, '2020-02-19', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91649, '2020-02-20', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91650, '2020-02-21', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91651, '2020-02-22', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91652, '2020-02-23', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91653, '2020-02-24', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91654, '2020-02-25', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91655, '2020-02-26', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91656, '2020-02-27', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91657, '2020-02-28', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91658, '2020-02-29', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91659, '2020-03-01', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91660, '2020-03-02', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91661, '2020-03-03', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91662, '2020-03-04', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91663, '2020-03-05', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91664, '2020-03-06', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91665, '2020-03-07', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91666, '2020-03-08', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91667, '2020-03-09', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91668, '2020-03-10', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91669, '2020-03-11', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91670, '2020-03-12', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91671, '2020-03-13', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91672, '2020-03-14', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91673, '2020-03-15', 'UZ', 'Uzbekistan', 'EURO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91674, '2020-03-16', 'UZ', 'Uzbekistan', 'EURO', '4', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91675, '2020-03-17', 'UZ', 'Uzbekistan', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91676, '2020-03-18', 'UZ', 'Uzbekistan', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91677, '2020-03-19', 'UZ', 'Uzbekistan', 'EURO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91678, '2020-03-20', 'UZ', 'Uzbekistan', 'EURO', '17', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91679, '2020-03-21', 'UZ', 'Uzbekistan', 'EURO', '20', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91680, '2020-03-22', 'UZ', 'Uzbekistan', 'EURO', '0', '41', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91681, '2020-03-23', 'UZ', 'Uzbekistan', 'EURO', '5', '46', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91682, '2020-03-24', 'UZ', 'Uzbekistan', 'EURO', '4', '50', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91683, '2020-03-25', 'UZ', 'Uzbekistan', 'EURO', '6', '56', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91684, '2020-03-26', 'UZ', 'Uzbekistan', 'EURO', '9', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91685, '2020-03-27', 'UZ', 'Uzbekistan', 'EURO', '23', '88', '0', '0');
INSERT INTO public.who_global_data_import VALUES (91686, '2020-03-28', 'UZ', 'Uzbekistan', 'EURO', '16', '104', '1', '1');
INSERT INTO public.who_global_data_import VALUES (91687, '2020-03-29', 'UZ', 'Uzbekistan', 'EURO', '40', '144', '1', '2');
INSERT INTO public.who_global_data_import VALUES (91688, '2020-03-30', 'UZ', 'Uzbekistan', 'EURO', '5', '149', '0', '2');
INSERT INTO public.who_global_data_import VALUES (91689, '2020-03-31', 'UZ', 'Uzbekistan', 'EURO', '18', '167', '0', '2');
INSERT INTO public.who_global_data_import VALUES (91690, '2020-04-01', 'UZ', 'Uzbekistan', 'EURO', '6', '173', '0', '2');
INSERT INTO public.who_global_data_import VALUES (91691, '2020-04-02', 'UZ', 'Uzbekistan', 'EURO', '17', '190', '0', '2');
INSERT INTO public.who_global_data_import VALUES (91692, '2020-04-03', 'UZ', 'Uzbekistan', 'EURO', '31', '221', '0', '2');
INSERT INTO public.who_global_data_import VALUES (91693, '2020-04-04', 'UZ', 'Uzbekistan', 'EURO', '20', '241', '0', '2');
INSERT INTO public.who_global_data_import VALUES (91694, '2020-04-05', 'UZ', 'Uzbekistan', 'EURO', '57', '298', '0', '2');
INSERT INTO public.who_global_data_import VALUES (91695, '2020-04-06', 'UZ', 'Uzbekistan', 'EURO', '92', '390', '0', '2');
INSERT INTO public.who_global_data_import VALUES (91696, '2020-04-07', 'UZ', 'Uzbekistan', 'EURO', '82', '472', '0', '2');
INSERT INTO public.who_global_data_import VALUES (91697, '2020-04-08', 'UZ', 'Uzbekistan', 'EURO', '62', '534', '1', '3');
INSERT INTO public.who_global_data_import VALUES (91698, '2020-04-09', 'UZ', 'Uzbekistan', 'EURO', '21', '555', '0', '3');
INSERT INTO public.who_global_data_import VALUES (91699, '2020-04-10', 'UZ', 'Uzbekistan', 'EURO', '69', '624', '0', '3');
INSERT INTO public.who_global_data_import VALUES (91700, '2020-04-11', 'UZ', 'Uzbekistan', 'EURO', '0', '624', '0', '3');
INSERT INTO public.who_global_data_import VALUES (91701, '2020-04-12', 'UZ', 'Uzbekistan', 'EURO', '172', '796', '0', '3');
INSERT INTO public.who_global_data_import VALUES (91702, '2020-04-13', 'UZ', 'Uzbekistan', 'EURO', '100', '896', '1', '4');
INSERT INTO public.who_global_data_import VALUES (91703, '2020-04-14', 'UZ', 'Uzbekistan', 'EURO', '158', '1054', '0', '4');
INSERT INTO public.who_global_data_import VALUES (91704, '2020-04-15', 'UZ', 'Uzbekistan', 'EURO', '160', '1214', '0', '4');
INSERT INTO public.who_global_data_import VALUES (91705, '2020-04-16', 'UZ', 'Uzbekistan', 'EURO', '135', '1349', '0', '4');
INSERT INTO public.who_global_data_import VALUES (91706, '2020-04-17', 'UZ', 'Uzbekistan', 'EURO', '31', '1380', '0', '4');
INSERT INTO public.who_global_data_import VALUES (91707, '2020-04-18', 'UZ', 'Uzbekistan', 'EURO', '70', '1450', '0', '4');
INSERT INTO public.who_global_data_import VALUES (91708, '2020-04-19', 'UZ', 'Uzbekistan', 'EURO', '45', '1495', '1', '5');
INSERT INTO public.who_global_data_import VALUES (91709, '2020-04-20', 'UZ', 'Uzbekistan', 'EURO', '70', '1565', '0', '5');
INSERT INTO public.who_global_data_import VALUES (91710, '2020-04-21', 'UZ', 'Uzbekistan', 'EURO', '92', '1657', '0', '5');
INSERT INTO public.who_global_data_import VALUES (91711, '2020-04-22', 'UZ', 'Uzbekistan', 'EURO', '0', '1657', '1', '6');
INSERT INTO public.who_global_data_import VALUES (91712, '2020-04-23', 'UZ', 'Uzbekistan', 'EURO', '59', '1716', '1', '7');
INSERT INTO public.who_global_data_import VALUES (91713, '2020-04-24', 'UZ', 'Uzbekistan', 'EURO', '62', '1778', '0', '7');
INSERT INTO public.who_global_data_import VALUES (91714, '2020-04-25', 'UZ', 'Uzbekistan', 'EURO', '58', '1836', '1', '8');
INSERT INTO public.who_global_data_import VALUES (91715, '2020-04-26', 'UZ', 'Uzbekistan', 'EURO', '29', '1865', '0', '8');
INSERT INTO public.who_global_data_import VALUES (91716, '2020-04-27', 'UZ', 'Uzbekistan', 'EURO', '22', '1887', '0', '8');
INSERT INTO public.who_global_data_import VALUES (91717, '2020-04-28', 'UZ', 'Uzbekistan', 'EURO', '37', '1924', '0', '8');
INSERT INTO public.who_global_data_import VALUES (91718, '2020-04-29', 'UZ', 'Uzbekistan', 'EURO', '31', '1955', '0', '8');
INSERT INTO public.who_global_data_import VALUES (91719, '2020-04-30', 'UZ', 'Uzbekistan', 'EURO', '76', '2031', '1', '9');
INSERT INTO public.who_global_data_import VALUES (91720, '2020-05-01', 'UZ', 'Uzbekistan', 'EURO', '15', '2046', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91721, '2020-05-02', 'UZ', 'Uzbekistan', 'EURO', '48', '2094', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91722, '2020-05-03', 'UZ', 'Uzbekistan', 'EURO', '33', '2127', '0', '9');
INSERT INTO public.who_global_data_import VALUES (91723, '2020-05-04', 'UZ', 'Uzbekistan', 'EURO', '33', '2160', '1', '10');
INSERT INTO public.who_global_data_import VALUES (91724, '2020-05-05', 'UZ', 'Uzbekistan', 'EURO', '29', '2189', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91725, '2020-05-06', 'UZ', 'Uzbekistan', 'EURO', '28', '2217', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91726, '2020-05-07', 'UZ', 'Uzbekistan', 'EURO', '49', '2266', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91727, '2020-05-08', 'UZ', 'Uzbekistan', 'EURO', '48', '2314', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91728, '2020-05-09', 'UZ', 'Uzbekistan', 'EURO', '22', '2336', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91729, '2020-05-10', 'UZ', 'Uzbekistan', 'EURO', '51', '2387', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91730, '2020-05-11', 'UZ', 'Uzbekistan', 'EURO', '24', '2411', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91731, '2020-05-12', 'UZ', 'Uzbekistan', 'EURO', '98', '2509', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91732, '2020-05-13', 'UZ', 'Uzbekistan', 'EURO', '89', '2598', '0', '10');
INSERT INTO public.who_global_data_import VALUES (91733, '2020-05-14', 'UZ', 'Uzbekistan', 'EURO', '22', '2620', '1', '11');
INSERT INTO public.who_global_data_import VALUES (91734, '2020-05-15', 'UZ', 'Uzbekistan', 'EURO', '32', '2652', '0', '11');
INSERT INTO public.who_global_data_import VALUES (91735, '2020-05-16', 'UZ', 'Uzbekistan', 'EURO', '39', '2691', '0', '11');
INSERT INTO public.who_global_data_import VALUES (91736, '2020-05-17', 'UZ', 'Uzbekistan', 'EURO', '50', '2741', '0', '11');
INSERT INTO public.who_global_data_import VALUES (91737, '2020-05-18', 'UZ', 'Uzbekistan', 'EURO', '21', '2762', '1', '12');
INSERT INTO public.who_global_data_import VALUES (91738, '2020-05-19', 'UZ', 'Uzbekistan', 'EURO', '40', '2802', '1', '13');
INSERT INTO public.who_global_data_import VALUES (91739, '2020-05-20', 'UZ', 'Uzbekistan', 'EURO', '78', '2880', '0', '13');
INSERT INTO public.who_global_data_import VALUES (91740, '2020-05-21', 'UZ', 'Uzbekistan', 'EURO', '70', '2950', '0', '13');
INSERT INTO public.who_global_data_import VALUES (91741, '2020-05-22', 'UZ', 'Uzbekistan', 'EURO', '56', '3006', '0', '13');
INSERT INTO public.who_global_data_import VALUES (91742, '2020-05-23', 'UZ', 'Uzbekistan', 'EURO', '72', '3078', '0', '13');
INSERT INTO public.who_global_data_import VALUES (91743, '2020-05-24', 'UZ', 'Uzbekistan', 'EURO', '54', '3132', '0', '13');
INSERT INTO public.who_global_data_import VALUES (91744, '2020-05-25', 'UZ', 'Uzbekistan', 'EURO', '48', '3180', '0', '13');
INSERT INTO public.who_global_data_import VALUES (91745, '2020-05-26', 'UZ', 'Uzbekistan', 'EURO', '81', '3261', '0', '13');
INSERT INTO public.who_global_data_import VALUES (91746, '2020-05-27', 'UZ', 'Uzbekistan', 'EURO', '72', '3333', '1', '14');
INSERT INTO public.who_global_data_import VALUES (91747, '2020-05-28', 'UZ', 'Uzbekistan', 'EURO', '63', '3396', '0', '14');
INSERT INTO public.who_global_data_import VALUES (91748, '2020-05-29', 'UZ', 'Uzbekistan', 'EURO', '67', '3463', '0', '14');
INSERT INTO public.who_global_data_import VALUES (91749, '2020-05-30', 'UZ', 'Uzbekistan', 'EURO', '50', '3513', '0', '14');
INSERT INTO public.who_global_data_import VALUES (91750, '2020-05-31', 'UZ', 'Uzbekistan', 'EURO', '41', '3554', '0', '14');
INSERT INTO public.who_global_data_import VALUES (91751, '2020-06-01', 'UZ', 'Uzbekistan', 'EURO', '108', '3662', '1', '15');
INSERT INTO public.who_global_data_import VALUES (91752, '2020-06-02', 'UZ', 'Uzbekistan', 'EURO', '56', '3718', '0', '15');
INSERT INTO public.who_global_data_import VALUES (91753, '2020-06-03', 'UZ', 'Uzbekistan', 'EURO', '0', '3718', '0', '15');
INSERT INTO public.who_global_data_import VALUES (91754, '2020-06-04', 'UZ', 'Uzbekistan', 'EURO', '156', '3874', '1', '16');
INSERT INTO public.who_global_data_import VALUES (91755, '2020-06-05', 'UZ', 'Uzbekistan', 'EURO', '91', '3965', '0', '16');
INSERT INTO public.who_global_data_import VALUES (91756, '2020-06-06', 'UZ', 'Uzbekistan', 'EURO', '57', '4022', '0', '16');
INSERT INTO public.who_global_data_import VALUES (91757, '2020-06-07', 'UZ', 'Uzbekistan', 'EURO', '159', '4181', '1', '17');
INSERT INTO public.who_global_data_import VALUES (91758, '2020-06-08', 'UZ', 'Uzbekistan', 'EURO', '171', '4352', '0', '17');
INSERT INTO public.who_global_data_import VALUES (91759, '2020-06-09', 'UZ', 'Uzbekistan', 'EURO', '96', '4448', '1', '18');
INSERT INTO public.who_global_data_import VALUES (91760, '2020-06-10', 'UZ', 'Uzbekistan', 'EURO', '99', '4547', '0', '18');
INSERT INTO public.who_global_data_import VALUES (91761, '2020-06-11', 'UZ', 'Uzbekistan', 'EURO', '148', '4695', '1', '19');
INSERT INTO public.who_global_data_import VALUES (91762, '2020-06-12', 'UZ', 'Uzbekistan', 'EURO', '124', '4819', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91763, '2020-06-13', 'UZ', 'Uzbekistan', 'EURO', '82', '4901', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91764, '2020-06-14', 'UZ', 'Uzbekistan', 'EURO', '93', '4994', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91765, '2020-06-15', 'UZ', 'Uzbekistan', 'EURO', '109', '5103', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91766, '2020-06-16', 'UZ', 'Uzbekistan', 'EURO', '190', '5293', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91767, '2020-06-17', 'UZ', 'Uzbekistan', 'EURO', '268', '5561', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91768, '2020-06-18', 'UZ', 'Uzbekistan', 'EURO', '136', '5697', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91769, '2020-06-19', 'UZ', 'Uzbekistan', 'EURO', '158', '5855', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91770, '2020-06-20', 'UZ', 'Uzbekistan', 'EURO', '170', '6025', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91771, '2020-06-21', 'UZ', 'Uzbekistan', 'EURO', '191', '6216', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91772, '2020-06-22', 'UZ', 'Uzbekistan', 'EURO', '142', '6358', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91773, '2020-06-23', 'UZ', 'Uzbekistan', 'EURO', '142', '6500', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91774, '2020-06-24', 'UZ', 'Uzbekistan', 'EURO', '255', '6755', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91775, '2020-06-25', 'UZ', 'Uzbekistan', 'EURO', '235', '6990', '0', '19');
INSERT INTO public.who_global_data_import VALUES (91776, '2020-06-26', 'UZ', 'Uzbekistan', 'EURO', '238', '7228', '1', '20');
INSERT INTO public.who_global_data_import VALUES (91777, '2020-06-27', 'UZ', 'Uzbekistan', 'EURO', '262', '7490', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91778, '2020-06-28', 'UZ', 'Uzbekistan', 'EURO', '235', '7725', '0', '20');
INSERT INTO public.who_global_data_import VALUES (91779, '2020-06-29', 'UZ', 'Uzbekistan', 'EURO', '306', '8031', '2', '22');
INSERT INTO public.who_global_data_import VALUES (91780, '2020-06-30', 'UZ', 'Uzbekistan', 'EURO', '267', '8298', '2', '24');
INSERT INTO public.who_global_data_import VALUES (91781, '2020-07-01', 'UZ', 'Uzbekistan', 'EURO', '329', '8627', '2', '26');
INSERT INTO public.who_global_data_import VALUES (91782, '2020-07-02', 'UZ', 'Uzbekistan', 'EURO', '277', '8904', '0', '26');
INSERT INTO public.who_global_data_import VALUES (91783, '2020-07-03', 'UZ', 'Uzbekistan', 'EURO', '295', '9199', '1', '27');
INSERT INTO public.who_global_data_import VALUES (91784, '2020-07-04', 'UZ', 'Uzbekistan', 'EURO', '301', '9500', '2', '29');
INSERT INTO public.who_global_data_import VALUES (91785, '2020-07-05', 'UZ', 'Uzbekistan', 'EURO', '329', '9829', '2', '31');
INSERT INTO public.who_global_data_import VALUES (91786, '2020-07-06', 'UZ', 'Uzbekistan', 'EURO', '314', '10143', '4', '35');
INSERT INTO public.who_global_data_import VALUES (91787, '2020-07-07', 'UZ', 'Uzbekistan', 'EURO', '316', '10459', '3', '38');
INSERT INTO public.who_global_data_import VALUES (91788, '2020-07-08', 'UZ', 'Uzbekistan', 'EURO', '379', '10838', '3', '41');
INSERT INTO public.who_global_data_import VALUES (91789, '2020-07-09', 'UZ', 'Uzbekistan', 'EURO', '421', '11259', '6', '47');
INSERT INTO public.who_global_data_import VALUES (91790, '2020-07-10', 'UZ', 'Uzbekistan', 'EURO', '464', '11723', '5', '52');
INSERT INTO public.who_global_data_import VALUES (91791, '2020-07-11', 'UZ', 'Uzbekistan', 'EURO', '483', '12206', '3', '55');
INSERT INTO public.who_global_data_import VALUES (91792, '2020-07-12', 'UZ', 'Uzbekistan', 'EURO', '500', '12706', '3', '58');
INSERT INTO public.who_global_data_import VALUES (91793, '2020-07-13', 'UZ', 'Uzbekistan', 'EURO', '487', '13193', '3', '61');
INSERT INTO public.who_global_data_import VALUES (91794, '2020-07-14', 'UZ', 'Uzbekistan', 'EURO', '679', '13872', '3', '64');
INSERT INTO public.who_global_data_import VALUES (91795, '2020-07-15', 'UZ', 'Uzbekistan', 'EURO', '421', '14293', '4', '68');
INSERT INTO public.who_global_data_import VALUES (91796, '2020-07-16', 'UZ', 'Uzbekistan', 'EURO', '494', '14787', '4', '72');
INSERT INTO public.who_global_data_import VALUES (91797, '2020-07-17', 'UZ', 'Uzbekistan', 'EURO', '562', '15349', '4', '76');
INSERT INTO public.who_global_data_import VALUES (91798, '2020-07-18', 'UZ', 'Uzbekistan', 'EURO', '547', '15896', '4', '80');
INSERT INTO public.who_global_data_import VALUES (91799, '2020-07-19', 'UZ', 'Uzbekistan', 'EURO', '533', '16429', '4', '84');
INSERT INTO public.who_global_data_import VALUES (91800, '2020-07-20', 'UZ', 'Uzbekistan', 'EURO', '537', '16966', '4', '88');
INSERT INTO public.who_global_data_import VALUES (91801, '2020-07-21', 'UZ', 'Uzbekistan', 'EURO', '624', '17590', '4', '92');
INSERT INTO public.who_global_data_import VALUES (91802, '2020-07-22', 'UZ', 'Uzbekistan', 'EURO', '581', '18171', '4', '96');
INSERT INTO public.who_global_data_import VALUES (91803, '2020-07-23', 'UZ', 'Uzbekistan', 'EURO', '360', '18531', '3', '99');
INSERT INTO public.who_global_data_import VALUES (91804, '2020-07-24', 'UZ', 'Uzbekistan', 'EURO', '455', '18986', '4', '103');
INSERT INTO public.who_global_data_import VALUES (91805, '2020-07-25', 'UZ', 'Uzbekistan', 'EURO', '667', '19653', '1', '104');
INSERT INTO public.who_global_data_import VALUES (91806, '2020-07-26', 'UZ', 'Uzbekistan', 'EURO', '573', '20226', '8', '112');
INSERT INTO public.who_global_data_import VALUES (91807, '2020-07-27', 'UZ', 'Uzbekistan', 'EURO', '594', '20820', '5', '117');
INSERT INTO public.who_global_data_import VALUES (91808, '2020-07-28', 'UZ', 'Uzbekistan', 'EURO', '686', '21506', '2', '119');
INSERT INTO public.who_global_data_import VALUES (91809, '2020-07-29', 'UZ', 'Uzbekistan', 'EURO', '663', '22169', '10', '129');
INSERT INTO public.who_global_data_import VALUES (91810, '2020-07-30', 'UZ', 'Uzbekistan', 'EURO', '703', '22872', '3', '132');
INSERT INTO public.who_global_data_import VALUES (91811, '2020-07-31', 'UZ', 'Uzbekistan', 'EURO', '686', '23558', '5', '137');
INSERT INTO public.who_global_data_import VALUES (91812, '2020-08-01', 'UZ', 'Uzbekistan', 'EURO', '746', '24304', '6', '143');
INSERT INTO public.who_global_data_import VALUES (91813, '2020-08-02', 'UZ', 'Uzbekistan', 'EURO', '736', '25040', '6', '149');
INSERT INTO public.who_global_data_import VALUES (91814, '2020-08-03', 'UZ', 'Uzbekistan', 'EURO', '788', '25828', '6', '155');
INSERT INTO public.who_global_data_import VALUES (91815, '2020-08-04', 'UZ', 'Uzbekistan', 'EURO', '722', '26550', '6', '161');
INSERT INTO public.who_global_data_import VALUES (91816, '2020-08-05', 'UZ', 'Uzbekistan', 'EURO', '764', '27314', '6', '167');
INSERT INTO public.who_global_data_import VALUES (91817, '2020-08-06', 'UZ', 'Uzbekistan', 'EURO', '755', '28069', '6', '173');
INSERT INTO public.who_global_data_import VALUES (91818, '2020-08-07', 'UZ', 'Uzbekistan', 'EURO', '740', '28809', '6', '179');
INSERT INTO public.who_global_data_import VALUES (91819, '2020-08-08', 'UZ', 'Uzbekistan', 'EURO', '650', '29459', '6', '185');
INSERT INTO public.who_global_data_import VALUES (91820, '2020-08-09', 'UZ', 'Uzbekistan', 'EURO', '738', '30197', '5', '190');
INSERT INTO public.who_global_data_import VALUES (91821, '2020-08-10', 'UZ', 'Uzbekistan', 'EURO', '623', '30820', '6', '196');
INSERT INTO public.who_global_data_import VALUES (91822, '2020-08-11', 'UZ', 'Uzbekistan', 'EURO', '725', '31545', '6', '202');
INSERT INTO public.who_global_data_import VALUES (91823, '2020-08-12', 'UZ', 'Uzbekistan', 'EURO', '670', '32215', '6', '208');
INSERT INTO public.who_global_data_import VALUES (91824, '2020-08-13', 'UZ', 'Uzbekistan', 'EURO', '622', '32837', '5', '213');
INSERT INTO public.who_global_data_import VALUES (91825, '2020-08-14', 'UZ', 'Uzbekistan', 'EURO', '724', '33561', '5', '218');
INSERT INTO public.who_global_data_import VALUES (91826, '2020-08-15', 'UZ', 'Uzbekistan', 'EURO', '690', '34251', '5', '223');
INSERT INTO public.who_global_data_import VALUES (91827, '2020-08-16', 'UZ', 'Uzbekistan', 'EURO', '693', '34944', '5', '228');
INSERT INTO public.who_global_data_import VALUES (91828, '2020-08-17', 'UZ', 'Uzbekistan', 'EURO', '569', '35513', '6', '234');
INSERT INTO public.who_global_data_import VALUES (91829, '2020-08-18', 'UZ', 'Uzbekistan', 'EURO', '587', '36100', '6', '240');
INSERT INTO public.who_global_data_import VALUES (91830, '2020-08-19', 'UZ', 'Uzbekistan', 'EURO', '660', '36760', '5', '245');
INSERT INTO public.who_global_data_import VALUES (91831, '2020-08-20', 'UZ', 'Uzbekistan', 'EURO', '606', '37366', '5', '250');
INSERT INTO public.who_global_data_import VALUES (91832, '2020-08-21', 'UZ', 'Uzbekistan', 'EURO', '459', '37825', '6', '256');
INSERT INTO public.who_global_data_import VALUES (91833, '2020-08-22', 'UZ', 'Uzbekistan', 'EURO', '406', '38231', '6', '262');
INSERT INTO public.who_global_data_import VALUES (91834, '2020-08-23', 'UZ', 'Uzbekistan', 'EURO', '467', '38698', '7', '269');
INSERT INTO public.who_global_data_import VALUES (91835, '2020-08-24', 'UZ', 'Uzbekistan', 'EURO', '367', '39065', '6', '275');
INSERT INTO public.who_global_data_import VALUES (91836, '2020-08-25', 'UZ', 'Uzbekistan', 'EURO', '441', '39506', '7', '282');
INSERT INTO public.who_global_data_import VALUES (91837, '2020-08-26', 'UZ', 'Uzbekistan', 'EURO', '284', '39790', '7', '289');
INSERT INTO public.who_global_data_import VALUES (91838, '2020-08-27', 'UZ', 'Uzbekistan', 'EURO', '405', '40195', '6', '295');
INSERT INTO public.who_global_data_import VALUES (91839, '2020-08-28', 'UZ', 'Uzbekistan', 'EURO', '418', '40613', '5', '300');
INSERT INTO public.who_global_data_import VALUES (91840, '2020-08-29', 'UZ', 'Uzbekistan', 'EURO', '340', '40953', '5', '305');
INSERT INTO public.who_global_data_import VALUES (91841, '2020-08-30', 'UZ', 'Uzbekistan', 'EURO', '350', '41303', '6', '311');
INSERT INTO public.who_global_data_import VALUES (91842, '2020-08-31', 'UZ', 'Uzbekistan', 'EURO', '348', '41651', '6', '317');
INSERT INTO public.who_global_data_import VALUES (91843, '2020-09-01', 'UZ', 'Uzbekistan', 'EURO', '343', '41994', '5', '322');
INSERT INTO public.who_global_data_import VALUES (91844, '2020-09-02', 'UZ', 'Uzbekistan', 'EURO', '376', '42370', '4', '326');
INSERT INTO public.who_global_data_import VALUES (91845, '2020-09-03', 'UZ', 'Uzbekistan', 'EURO', '170', '42540', '3', '329');
INSERT INTO public.who_global_data_import VALUES (91846, '2020-09-04', 'UZ', 'Uzbekistan', 'EURO', '363', '42903', '7', '336');
INSERT INTO public.who_global_data_import VALUES (91847, '2020-09-05', 'UZ', 'Uzbekistan', 'EURO', '266', '43169', '2', '338');
INSERT INTO public.who_global_data_import VALUES (91848, '2020-09-06', 'UZ', 'Uzbekistan', 'EURO', '307', '43476', '5', '343');
INSERT INTO public.who_global_data_import VALUES (91849, '2020-09-07', 'UZ', 'Uzbekistan', 'EURO', '299', '43775', '7', '350');
INSERT INTO public.who_global_data_import VALUES (91850, '2020-09-08', 'UZ', 'Uzbekistan', 'EURO', '332', '44107', '6', '356');
INSERT INTO public.who_global_data_import VALUES (91851, '2020-09-09', 'UZ', 'Uzbekistan', 'EURO', '450', '44557', '6', '362');
INSERT INTO public.who_global_data_import VALUES (91852, '2020-09-10', 'UZ', 'Uzbekistan', 'EURO', '603', '45160', '6', '368');
INSERT INTO public.who_global_data_import VALUES (91853, '2020-09-11', 'UZ', 'Uzbekistan', 'EURO', '767', '45927', '7', '375');
INSERT INTO public.who_global_data_import VALUES (91854, '2020-09-12', 'UZ', 'Uzbekistan', 'EURO', '571', '46498', '7', '382');
INSERT INTO public.who_global_data_import VALUES (91855, '2020-09-13', 'UZ', 'Uzbekistan', 'EURO', '544', '47042', '6', '388');
INSERT INTO public.who_global_data_import VALUES (91856, '2020-09-14', 'UZ', 'Uzbekistan', 'EURO', '578', '47620', '6', '394');
INSERT INTO public.who_global_data_import VALUES (91857, '2020-09-15', 'UZ', 'Uzbekistan', 'EURO', '572', '48192', '6', '400');
INSERT INTO public.who_global_data_import VALUES (91858, '2020-09-16', 'UZ', 'Uzbekistan', 'EURO', '584', '48776', '5', '405');
INSERT INTO public.who_global_data_import VALUES (91859, '2020-09-17', 'UZ', 'Uzbekistan', 'EURO', '609', '49385', '6', '411');
INSERT INTO public.who_global_data_import VALUES (91860, '2020-09-18', 'UZ', 'Uzbekistan', 'EURO', '609', '49994', '6', '417');
INSERT INTO public.who_global_data_import VALUES (91861, '2020-09-19', 'UZ', 'Uzbekistan', 'EURO', '640', '50634', '6', '423');
INSERT INTO public.who_global_data_import VALUES (91862, '2020-09-20', 'UZ', 'Uzbekistan', 'EURO', '601', '51235', '6', '429');
INSERT INTO public.who_global_data_import VALUES (91863, '2020-09-21', 'UZ', 'Uzbekistan', 'EURO', '554', '51789', '6', '435');
INSERT INTO public.who_global_data_import VALUES (91864, '2020-09-22', 'UZ', 'Uzbekistan', 'EURO', '702', '52491', '5', '440');
INSERT INTO public.who_global_data_import VALUES (91865, '2020-09-23', 'UZ', 'Uzbekistan', 'EURO', '560', '53051', '3', '443');
INSERT INTO public.who_global_data_import VALUES (91866, '2020-09-24', 'UZ', 'Uzbekistan', 'EURO', '616', '53667', '2', '445');
INSERT INTO public.who_global_data_import VALUES (91867, '2020-09-25', 'UZ', 'Uzbekistan', 'EURO', '514', '54181', '3', '448');
INSERT INTO public.who_global_data_import VALUES (91868, '2020-09-26', 'UZ', 'Uzbekistan', 'EURO', '281', '54462', '2', '450');
INSERT INTO public.who_global_data_import VALUES (91869, '2020-09-27', 'UZ', 'Uzbekistan', 'EURO', '491', '54953', '4', '454');
INSERT INTO public.who_global_data_import VALUES (91870, '2020-09-28', 'UZ', 'Uzbekistan', 'EURO', '640', '55593', '6', '460');
INSERT INTO public.who_global_data_import VALUES (91871, '2020-09-29', 'UZ', 'Uzbekistan', 'EURO', '475', '56068', '3', '463');
INSERT INTO public.who_global_data_import VALUES (91872, '2020-09-30', 'UZ', 'Uzbekistan', 'EURO', '451', '56519', '5', '468');
INSERT INTO public.who_global_data_import VALUES (91873, '2020-10-01', 'UZ', 'Uzbekistan', 'EURO', '800', '57319', '6', '474');
INSERT INTO public.who_global_data_import VALUES (91874, '2020-10-02', 'UZ', 'Uzbekistan', 'EURO', '457', '57776', '1', '475');
INSERT INTO public.who_global_data_import VALUES (91875, '2020-10-03', 'UZ', 'Uzbekistan', 'EURO', '0', '57776', '0', '475');
INSERT INTO public.who_global_data_import VALUES (91876, '2020-10-04', 'UZ', 'Uzbekistan', 'EURO', '645', '58421', '4', '479');
INSERT INTO public.who_global_data_import VALUES (91877, '2020-10-05', 'UZ', 'Uzbekistan', 'EURO', '438', '58859', '4', '483');
INSERT INTO public.who_global_data_import VALUES (91878, '2020-10-06', 'UZ', 'Uzbekistan', 'EURO', '338', '59197', '4', '487');
INSERT INTO public.who_global_data_import VALUES (91879, '2020-10-07', 'UZ', 'Uzbekistan', 'EURO', '382', '59579', '4', '491');
INSERT INTO public.who_global_data_import VALUES (91880, '2020-10-08', 'UZ', 'Uzbekistan', 'EURO', '326', '59905', '3', '494');
INSERT INTO public.who_global_data_import VALUES (91881, '2020-10-09', 'UZ', 'Uzbekistan', 'EURO', '328', '60233', '3', '497');
INSERT INTO public.who_global_data_import VALUES (91882, '2020-10-10', 'UZ', 'Uzbekistan', 'EURO', '329', '60562', '3', '500');
INSERT INTO public.who_global_data_import VALUES (91883, '2020-10-11', 'UZ', 'Uzbekistan', 'EURO', '332', '60894', '3', '503');
INSERT INTO public.who_global_data_import VALUES (91884, '2020-10-12', 'UZ', 'Uzbekistan', 'EURO', '311', '61205', '4', '507');
INSERT INTO public.who_global_data_import VALUES (91885, '2020-10-13', 'UZ', 'Uzbekistan', 'EURO', '329', '61534', '3', '510');
INSERT INTO public.who_global_data_import VALUES (91886, '2020-10-14', 'UZ', 'Uzbekistan', 'EURO', '325', '61859', '2', '512');
INSERT INTO public.who_global_data_import VALUES (91887, '2020-10-15', 'UZ', 'Uzbekistan', 'EURO', '316', '62175', '4', '516');
INSERT INTO public.who_global_data_import VALUES (91888, '2020-10-16', 'UZ', 'Uzbekistan', 'EURO', '309', '62484', '3', '519');
INSERT INTO public.who_global_data_import VALUES (91889, '2020-10-17', 'UZ', 'Uzbekistan', 'EURO', '325', '62809', '3', '522');
INSERT INTO public.who_global_data_import VALUES (91890, '2020-10-18', 'UZ', 'Uzbekistan', 'EURO', '315', '63124', '3', '525');
INSERT INTO public.who_global_data_import VALUES (91891, '2020-10-19', 'UZ', 'Uzbekistan', 'EURO', '306', '63430', '4', '529');
INSERT INTO public.who_global_data_import VALUES (91892, '2020-10-20', 'UZ', 'Uzbekistan', 'EURO', '307', '63737', '4', '533');
INSERT INTO public.who_global_data_import VALUES (91893, '2020-10-21', 'UZ', 'Uzbekistan', 'EURO', '273', '64010', '1', '534');
INSERT INTO public.who_global_data_import VALUES (91894, '2020-10-22', 'UZ', 'Uzbekistan', 'EURO', '325', '64335', '4', '538');
INSERT INTO public.who_global_data_import VALUES (91895, '2020-10-23', 'UZ', 'Uzbekistan', 'EURO', '298', '64633', '3', '541');
INSERT INTO public.who_global_data_import VALUES (91896, '2020-10-24', 'UZ', 'Uzbekistan', 'EURO', '290', '64923', '3', '544');
INSERT INTO public.who_global_data_import VALUES (91897, '2020-10-25', 'UZ', 'Uzbekistan', 'EURO', '277', '65200', '3', '547');
INSERT INTO public.who_global_data_import VALUES (91898, '2020-10-26', 'UZ', 'Uzbekistan', 'EURO', '280', '65480', '3', '550');
INSERT INTO public.who_global_data_import VALUES (91899, '2020-10-27', 'UZ', 'Uzbekistan', 'EURO', '285', '65765', '4', '554');
INSERT INTO public.who_global_data_import VALUES (91900, '2020-10-28', 'UZ', 'Uzbekistan', 'EURO', '272', '66037', '3', '557');
INSERT INTO public.who_global_data_import VALUES (91901, '2020-10-29', 'UZ', 'Uzbekistan', 'EURO', '276', '66313', '3', '560');
INSERT INTO public.who_global_data_import VALUES (91902, '2020-10-30', 'UZ', 'Uzbekistan', 'EURO', '229', '66542', '2', '562');
INSERT INTO public.who_global_data_import VALUES (91903, '2020-10-31', 'UZ', 'Uzbekistan', 'EURO', '259', '66801', '2', '564');
INSERT INTO public.who_global_data_import VALUES (91904, '2020-11-01', 'UZ', 'Uzbekistan', 'EURO', '254', '67055', '4', '568');
INSERT INTO public.who_global_data_import VALUES (91905, '2020-11-02', 'UZ', 'Uzbekistan', 'EURO', '199', '67254', '3', '571');
INSERT INTO public.who_global_data_import VALUES (91906, '2020-11-03', 'UZ', 'Uzbekistan', 'EURO', '247', '67501', '2', '573');
INSERT INTO public.who_global_data_import VALUES (91907, '2020-11-04', 'UZ', 'Uzbekistan', 'EURO', '197', '67698', '2', '575');
INSERT INTO public.who_global_data_import VALUES (91908, '2020-11-05', 'UZ', 'Uzbekistan', 'EURO', '234', '67932', '4', '579');
INSERT INTO public.who_global_data_import VALUES (91909, '2020-11-06', 'UZ', 'Uzbekistan', 'EURO', '207', '68139', '0', '579');
INSERT INTO public.who_global_data_import VALUES (91910, '2020-11-07', 'UZ', 'Uzbekistan', 'EURO', '84', '68223', '0', '579');
INSERT INTO public.who_global_data_import VALUES (91911, '2020-11-08', 'UZ', 'Uzbekistan', 'EURO', '370', '68593', '2', '581');
INSERT INTO public.who_global_data_import VALUES (91912, '2020-11-09', 'UZ', 'Uzbekistan', 'EURO', '195', '68788', '4', '585');
INSERT INTO public.who_global_data_import VALUES (91913, '2020-11-10', 'UZ', 'Uzbekistan', 'EURO', '239', '69027', '3', '588');
INSERT INTO public.who_global_data_import VALUES (91914, '2020-11-11', 'UZ', 'Uzbekistan', 'EURO', '146', '69173', '1', '589');
INSERT INTO public.who_global_data_import VALUES (91915, '2020-11-12', 'UZ', 'Uzbekistan', 'EURO', '224', '69397', '2', '591');
INSERT INTO public.who_global_data_import VALUES (91916, '2020-11-13', 'UZ', 'Uzbekistan', 'EURO', '283', '69680', '3', '594');
INSERT INTO public.who_global_data_import VALUES (91917, '2020-11-14', 'UZ', 'Uzbekistan', 'EURO', '234', '69914', '2', '596');
INSERT INTO public.who_global_data_import VALUES (91918, '2020-11-15', 'UZ', 'Uzbekistan', 'EURO', '188', '70102', '2', '598');
INSERT INTO public.who_global_data_import VALUES (91919, '2020-11-16', 'UZ', 'Uzbekistan', 'EURO', '141', '70243', '0', '598');
INSERT INTO public.who_global_data_import VALUES (91920, '2020-11-17', 'UZ', 'Uzbekistan', 'EURO', '201', '70444', '0', '598');
INSERT INTO public.who_global_data_import VALUES (91921, '2020-11-18', 'UZ', 'Uzbekistan', 'EURO', '204', '70648', '1', '599');
INSERT INTO public.who_global_data_import VALUES (91922, '2020-11-19', 'UZ', 'Uzbekistan', 'EURO', '210', '70858', '2', '601');
INSERT INTO public.who_global_data_import VALUES (91923, '2020-11-20', 'UZ', 'Uzbekistan', 'EURO', '213', '71071', '1', '602');
INSERT INTO public.who_global_data_import VALUES (91924, '2020-11-21', 'UZ', 'Uzbekistan', 'EURO', '209', '71280', '1', '603');
INSERT INTO public.who_global_data_import VALUES (91925, '2020-11-22', 'UZ', 'Uzbekistan', 'EURO', '272', '71552', '0', '603');
INSERT INTO public.who_global_data_import VALUES (91926, '2020-11-23', 'UZ', 'Uzbekistan', 'EURO', '161', '71713', '0', '603');
INSERT INTO public.who_global_data_import VALUES (91927, '2020-11-24', 'UZ', 'Uzbekistan', 'EURO', '134', '71847', '1', '604');
INSERT INTO public.who_global_data_import VALUES (91928, '2020-11-25', 'UZ', 'Uzbekistan', 'EURO', '192', '72039', '1', '605');
INSERT INTO public.who_global_data_import VALUES (91929, '2020-11-26', 'UZ', 'Uzbekistan', 'EURO', '188', '72227', '1', '606');
INSERT INTO public.who_global_data_import VALUES (91930, '2020-11-27', 'UZ', 'Uzbekistan', 'EURO', '182', '72409', '1', '607');
INSERT INTO public.who_global_data_import VALUES (91931, '2020-11-28', 'UZ', 'Uzbekistan', 'EURO', '173', '72582', '1', '608');
INSERT INTO public.who_global_data_import VALUES (91932, '2020-11-29', 'UZ', 'Uzbekistan', 'EURO', '227', '72809', '0', '608');
INSERT INTO public.who_global_data_import VALUES (91933, '2020-11-30', 'UZ', 'Uzbekistan', 'EURO', '111', '72920', '0', '608');
INSERT INTO public.who_global_data_import VALUES (91934, '2020-12-01', 'UZ', 'Uzbekistan', 'EURO', '174', '73094', '2', '610');
INSERT INTO public.who_global_data_import VALUES (91935, '2020-12-02', 'UZ', 'Uzbekistan', 'EURO', '182', '73276', '1', '611');
INSERT INTO public.who_global_data_import VALUES (91936, '2020-12-03', 'UZ', 'Uzbekistan', 'EURO', '155', '73431', '0', '611');
INSERT INTO public.who_global_data_import VALUES (91937, '2020-12-04', 'UZ', 'Uzbekistan', 'EURO', '161', '73592', '0', '611');
INSERT INTO public.who_global_data_import VALUES (91938, '2020-12-05', 'UZ', 'Uzbekistan', 'EURO', '159', '73751', '0', '611');
INSERT INTO public.who_global_data_import VALUES (91939, '2020-12-06', 'UZ', 'Uzbekistan', 'EURO', '153', '73904', '0', '611');
INSERT INTO public.who_global_data_import VALUES (91940, '2020-12-07', 'UZ', 'Uzbekistan', 'EURO', '149', '74053', '0', '611');
INSERT INTO public.who_global_data_import VALUES (91941, '2020-12-08', 'UZ', 'Uzbekistan', 'EURO', '153', '74206', '0', '611');
INSERT INTO public.who_global_data_import VALUES (91942, '2020-12-09', 'UZ', 'Uzbekistan', 'EURO', '146', '74352', '0', '611');
INSERT INTO public.who_global_data_import VALUES (91943, '2020-12-10', 'UZ', 'Uzbekistan', 'EURO', '146', '74498', '0', '611');
INSERT INTO public.who_global_data_import VALUES (91944, '2020-12-11', 'UZ', 'Uzbekistan', 'EURO', '166', '74664', '0', '611');
INSERT INTO public.who_global_data_import VALUES (91945, '2020-12-12', 'UZ', 'Uzbekistan', 'EURO', '147', '74811', '1', '612');
INSERT INTO public.who_global_data_import VALUES (91946, '2020-12-13', 'UZ', 'Uzbekistan', 'EURO', '0', '74811', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91947, '2020-12-14', 'UZ', 'Uzbekistan', 'EURO', '283', '75094', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91948, '2020-12-15', 'UZ', 'Uzbekistan', 'EURO', '147', '75241', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91949, '2020-12-16', 'UZ', 'Uzbekistan', 'EURO', '155', '75396', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91950, '2020-12-17', 'UZ', 'Uzbekistan', 'EURO', '142', '75538', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91951, '2020-12-18', 'UZ', 'Uzbekistan', 'EURO', '137', '75675', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91952, '2020-12-19', 'UZ', 'Uzbekistan', 'EURO', '131', '75806', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91953, '2020-12-20', 'UZ', 'Uzbekistan', 'EURO', '0', '75806', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91954, '2020-12-21', 'UZ', 'Uzbekistan', 'EURO', '242', '76048', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91955, '2020-12-22', 'UZ', 'Uzbekistan', 'EURO', '0', '76048', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91956, '2020-12-23', 'UZ', 'Uzbekistan', 'EURO', '267', '76315', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91957, '2020-12-24', 'UZ', 'Uzbekistan', 'EURO', '141', '76456', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91958, '2020-12-25', 'UZ', 'Uzbekistan', 'EURO', '112', '76568', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91959, '2020-12-26', 'UZ', 'Uzbekistan', 'EURO', '98', '76666', '0', '612');
INSERT INTO public.who_global_data_import VALUES (91960, '2020-12-27', 'UZ', 'Uzbekistan', 'EURO', '85', '76751', '1', '613');
INSERT INTO public.who_global_data_import VALUES (91961, '2020-12-28', 'UZ', 'Uzbekistan', 'EURO', '81', '76832', '0', '613');
INSERT INTO public.who_global_data_import VALUES (91962, '2020-12-29', 'UZ', 'Uzbekistan', 'EURO', '75', '76907', '0', '613');
INSERT INTO public.who_global_data_import VALUES (91963, '2020-12-30', 'UZ', 'Uzbekistan', 'EURO', '78', '76985', '1', '614');
INSERT INTO public.who_global_data_import VALUES (91964, '2020-12-31', 'UZ', 'Uzbekistan', 'EURO', '75', '77060', '0', '614');
INSERT INTO public.who_global_data_import VALUES (91965, '2021-01-01', 'UZ', 'Uzbekistan', 'EURO', '66', '77126', '0', '614');
INSERT INTO public.who_global_data_import VALUES (91966, '2021-01-02', 'UZ', 'Uzbekistan', 'EURO', '56', '77182', '0', '614');
INSERT INTO public.who_global_data_import VALUES (91967, '2021-01-03', 'UZ', 'Uzbekistan', 'EURO', '56', '77238', '0', '614');
INSERT INTO public.who_global_data_import VALUES (91968, '2021-01-04', 'UZ', 'Uzbekistan', 'EURO', '20', '77258', '0', '614');
INSERT INTO public.who_global_data_import VALUES (91969, '2021-01-05', 'UZ', 'Uzbekistan', 'EURO', '37', '77295', '0', '614');
INSERT INTO public.who_global_data_import VALUES (91970, '2021-01-06', 'UZ', 'Uzbekistan', 'EURO', '55', '77350', '1', '615');
INSERT INTO public.who_global_data_import VALUES (91971, '2021-01-07', 'UZ', 'Uzbekistan', 'EURO', '62', '77412', '0', '615');
INSERT INTO public.who_global_data_import VALUES (91972, '2021-01-08', 'UZ', 'Uzbekistan', 'EURO', '73', '77485', '1', '616');
INSERT INTO public.who_global_data_import VALUES (91973, '2021-01-09', 'UZ', 'Uzbekistan', 'EURO', '45', '77530', '0', '616');
INSERT INTO public.who_global_data_import VALUES (91974, '2021-01-10', 'UZ', 'Uzbekistan', 'EURO', '42', '77572', '1', '617');
INSERT INTO public.who_global_data_import VALUES (91975, '2021-01-11', 'UZ', 'Uzbekistan', 'EURO', '39', '77611', '0', '617');
INSERT INTO public.who_global_data_import VALUES (91976, '2021-01-12', 'UZ', 'Uzbekistan', 'EURO', '52', '77663', '0', '617');
INSERT INTO public.who_global_data_import VALUES (91977, '2021-01-13', 'UZ', 'Uzbekistan', 'EURO', '53', '77716', '1', '618');
INSERT INTO public.who_global_data_import VALUES (91978, '2021-01-14', 'UZ', 'Uzbekistan', 'EURO', '61', '77777', '0', '618');
INSERT INTO public.who_global_data_import VALUES (91979, '2021-01-15', 'UZ', 'Uzbekistan', 'EURO', '68', '77845', '1', '619');
INSERT INTO public.who_global_data_import VALUES (91980, '2021-01-16', 'UZ', 'Uzbekistan', 'EURO', '59', '77904', '0', '619');
INSERT INTO public.who_global_data_import VALUES (91981, '2021-01-17', 'UZ', 'Uzbekistan', 'EURO', '64', '77968', '0', '619');
INSERT INTO public.who_global_data_import VALUES (91982, '2021-01-18', 'UZ', 'Uzbekistan', 'EURO', '68', '78036', '0', '619');
INSERT INTO public.who_global_data_import VALUES (91983, '2021-01-19', 'UZ', 'Uzbekistan', 'EURO', '55', '78091', '1', '620');
INSERT INTO public.who_global_data_import VALUES (91984, '2021-01-20', 'UZ', 'Uzbekistan', 'EURO', '72', '78163', '0', '620');
INSERT INTO public.who_global_data_import VALUES (91985, '2021-01-21', 'UZ', 'Uzbekistan', 'EURO', '56', '78219', '0', '620');
INSERT INTO public.who_global_data_import VALUES (91986, '2021-01-22', 'UZ', 'Uzbekistan', 'EURO', '53', '78272', '0', '620');
INSERT INTO public.who_global_data_import VALUES (91987, '2021-01-23', 'UZ', 'Uzbekistan', 'EURO', '45', '78317', '1', '621');
INSERT INTO public.who_global_data_import VALUES (91988, '2021-01-24', 'UZ', 'Uzbekistan', 'EURO', '58', '78375', '0', '621');
INSERT INTO public.who_global_data_import VALUES (91989, '2021-01-25', 'UZ', 'Uzbekistan', 'EURO', '54', '78429', '0', '621');
INSERT INTO public.who_global_data_import VALUES (91990, '2021-01-26', 'UZ', 'Uzbekistan', 'EURO', '42', '78471', '0', '621');
INSERT INTO public.who_global_data_import VALUES (91991, '2021-01-27', 'UZ', 'Uzbekistan', 'EURO', '39', '78510', '0', '621');
INSERT INTO public.who_global_data_import VALUES (91992, '2021-01-28', 'UZ', 'Uzbekistan', 'EURO', '46', '78556', '0', '621');
INSERT INTO public.who_global_data_import VALUES (91993, '2021-01-29', 'UZ', 'Uzbekistan', 'EURO', '46', '78602', '0', '621');
INSERT INTO public.who_global_data_import VALUES (91994, '2021-01-30', 'UZ', 'Uzbekistan', 'EURO', '70', '78672', '0', '621');
INSERT INTO public.who_global_data_import VALUES (91995, '2021-01-31', 'UZ', 'Uzbekistan', 'EURO', '39', '78711', '0', '621');
INSERT INTO public.who_global_data_import VALUES (91996, '2021-02-01', 'UZ', 'Uzbekistan', 'EURO', '44', '78755', '0', '621');
INSERT INTO public.who_global_data_import VALUES (91997, '2021-02-02', 'UZ', 'Uzbekistan', 'EURO', '46', '78801', '0', '621');
INSERT INTO public.who_global_data_import VALUES (91998, '2021-02-03', 'UZ', 'Uzbekistan', 'EURO', '58', '78859', '0', '621');
INSERT INTO public.who_global_data_import VALUES (91999, '2021-02-04', 'UZ', 'Uzbekistan', 'EURO', '57', '78916', '0', '621');
INSERT INTO public.who_global_data_import VALUES (92000, '2021-02-05', 'UZ', 'Uzbekistan', 'EURO', '73', '78989', '0', '621');
INSERT INTO public.who_global_data_import VALUES (92001, '2020-01-03', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92002, '2020-01-04', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92003, '2020-01-05', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92004, '2020-01-06', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92005, '2020-01-07', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92006, '2020-01-08', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92007, '2020-01-09', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92008, '2020-01-10', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92009, '2020-01-11', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92010, '2020-01-12', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92011, '2020-01-13', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92012, '2020-01-14', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92013, '2020-01-15', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92014, '2020-01-16', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92015, '2020-01-17', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92016, '2020-01-18', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92017, '2020-01-19', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92018, '2020-01-20', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92019, '2020-01-21', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92020, '2020-01-22', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92021, '2020-01-23', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92035, '2020-02-06', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92036, '2020-02-07', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92037, '2020-02-08', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92038, '2020-02-09', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92039, '2020-02-10', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92040, '2020-02-11', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92041, '2020-02-12', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92042, '2020-02-13', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92043, '2020-02-14', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92044, '2020-02-15', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92045, '2020-02-16', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92046, '2020-02-17', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92047, '2020-02-18', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92048, '2020-02-19', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92049, '2020-02-20', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92050, '2020-02-21', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92051, '2020-02-22', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92052, '2020-02-23', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92053, '2020-02-24', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92054, '2020-02-25', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92055, '2020-02-26', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92056, '2020-02-27', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92057, '2020-02-28', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92058, '2020-02-29', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92059, '2020-03-01', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92060, '2020-03-02', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92061, '2020-03-03', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92062, '2020-03-04', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92063, '2020-03-05', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92064, '2020-03-06', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92065, '2020-03-07', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92066, '2020-03-08', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92067, '2020-03-09', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92068, '2020-03-10', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92069, '2020-03-11', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92070, '2020-03-12', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92071, '2020-03-13', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92072, '2020-03-14', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92073, '2020-03-15', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92074, '2020-03-16', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92075, '2020-03-17', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92076, '2020-03-18', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92077, '2020-03-19', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92078, '2020-03-20', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92079, '2020-03-21', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92080, '2020-03-22', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92081, '2020-03-23', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92082, '2020-03-24', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92083, '2020-03-25', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92084, '2020-03-26', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92085, '2020-03-27', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92086, '2020-03-28', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92087, '2020-03-29', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92088, '2020-03-30', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92089, '2020-03-31', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92090, '2020-04-01', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92091, '2020-04-02', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92092, '2020-04-03', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92093, '2020-04-04', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92094, '2020-04-05', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92095, '2020-04-06', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92096, '2020-04-07', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92097, '2020-04-08', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92098, '2020-04-09', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92099, '2020-04-10', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92100, '2020-04-11', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92101, '2020-04-12', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92102, '2020-04-13', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92103, '2020-04-14', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92104, '2020-04-15', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92105, '2020-04-16', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92106, '2020-04-17', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92107, '2020-04-18', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92108, '2020-04-19', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92109, '2020-04-20', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92110, '2020-04-21', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92111, '2020-04-22', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92112, '2020-04-23', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92113, '2020-04-24', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92114, '2020-04-25', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92115, '2020-04-26', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92116, '2020-04-27', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92117, '2020-04-28', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92118, '2020-04-29', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92119, '2020-04-30', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92120, '2020-05-01', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92121, '2020-05-02', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92122, '2020-05-03', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92123, '2020-05-04', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92124, '2020-05-05', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92125, '2020-05-06', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92126, '2020-05-07', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92127, '2020-05-08', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92128, '2020-05-09', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92129, '2020-05-10', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92130, '2020-05-11', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92131, '2020-05-12', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92132, '2020-05-13', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92133, '2020-05-14', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92134, '2020-05-15', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92135, '2020-05-16', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92136, '2020-05-17', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92137, '2020-05-18', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92138, '2020-05-19', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92139, '2020-05-20', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92140, '2020-05-21', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92141, '2020-05-22', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92142, '2020-05-23', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92143, '2020-05-24', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92144, '2020-05-25', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92145, '2020-05-26', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92146, '2020-05-27', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92147, '2020-05-28', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92148, '2020-05-29', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92149, '2020-05-30', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92150, '2020-05-31', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92151, '2020-06-01', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92152, '2020-06-02', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92153, '2020-06-03', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92154, '2020-06-04', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92155, '2020-06-05', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92156, '2020-06-06', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92157, '2020-06-07', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92158, '2020-06-08', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92159, '2020-06-09', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92160, '2020-06-10', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92161, '2020-06-11', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92162, '2020-06-12', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92163, '2020-06-13', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92164, '2020-06-14', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92165, '2020-06-15', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92166, '2020-06-16', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92167, '2020-06-17', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92168, '2020-06-18', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92169, '2020-06-19', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92170, '2020-06-20', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92171, '2020-06-21', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92172, '2020-06-22', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92173, '2020-06-23', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92174, '2020-06-24', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92175, '2020-06-25', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92176, '2020-06-26', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92177, '2020-06-27', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92178, '2020-06-28', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92179, '2020-06-29', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92180, '2020-06-30', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92181, '2020-07-01', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92182, '2020-07-02', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92183, '2020-07-03', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92184, '2020-07-04', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92185, '2020-07-05', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92186, '2020-07-06', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92187, '2020-07-07', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92188, '2020-07-08', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92189, '2020-07-09', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92190, '2020-07-10', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92191, '2020-07-11', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92192, '2020-07-12', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92193, '2020-07-13', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92194, '2020-07-14', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92195, '2020-07-15', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92196, '2020-07-16', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92197, '2020-07-17', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92198, '2020-07-18', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92199, '2020-07-19', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92200, '2020-07-20', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92201, '2020-07-21', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92202, '2020-07-22', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92203, '2020-07-23', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92204, '2020-07-24', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92205, '2020-07-25', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92206, '2020-07-26', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92207, '2020-07-27', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92208, '2020-07-28', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92209, '2020-07-29', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92210, '2020-07-30', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92211, '2020-07-31', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92212, '2020-08-01', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92213, '2020-08-02', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92214, '2020-08-03', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92215, '2020-08-04', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92216, '2020-08-05', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92217, '2020-08-06', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92218, '2020-08-07', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92219, '2020-08-08', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92220, '2020-08-09', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92221, '2020-08-10', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92222, '2020-08-11', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92223, '2020-08-12', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92224, '2020-08-13', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92225, '2020-08-14', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92226, '2020-08-15', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92227, '2020-08-16', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92228, '2020-08-17', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92229, '2020-08-18', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92230, '2020-08-19', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92231, '2020-08-20', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92232, '2020-08-21', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92233, '2020-08-22', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92234, '2020-08-23', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92235, '2020-08-24', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92236, '2020-08-25', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92237, '2020-08-26', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92238, '2020-08-27', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92239, '2020-08-28', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92240, '2020-08-29', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92241, '2020-08-30', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92242, '2020-08-31', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92243, '2020-09-01', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92244, '2020-09-02', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92245, '2020-09-03', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92246, '2020-09-04', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92247, '2020-09-05', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92248, '2020-09-06', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92249, '2020-09-07', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92250, '2020-09-08', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92251, '2020-09-09', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92252, '2020-09-10', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92253, '2020-09-11', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92254, '2020-09-12', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92255, '2020-09-13', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92256, '2020-09-14', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92257, '2020-09-15', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92258, '2020-09-16', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92259, '2020-09-17', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92260, '2020-09-18', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92261, '2020-09-19', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92262, '2020-09-20', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92263, '2020-09-21', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92264, '2020-09-22', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92265, '2020-09-23', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92266, '2020-09-24', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92267, '2020-09-25', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92268, '2020-09-26', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92269, '2020-09-27', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92270, '2020-09-28', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92271, '2020-09-29', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92272, '2020-09-30', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92273, '2020-10-01', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92274, '2020-10-02', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92275, '2020-10-03', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92276, '2020-10-04', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92277, '2020-10-05', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92278, '2020-10-06', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92279, '2020-10-07', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92280, '2020-10-08', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92281, '2020-10-09', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92282, '2020-10-10', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92283, '2020-10-11', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92284, '2020-10-12', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92285, '2020-10-13', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92286, '2020-10-14', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92287, '2020-10-15', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92288, '2020-10-16', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92289, '2020-10-17', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92290, '2020-10-18', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92291, '2020-10-19', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92292, '2020-10-20', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92293, '2020-10-21', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92294, '2020-10-22', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92295, '2020-10-23', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92296, '2020-10-24', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92297, '2020-10-25', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92298, '2020-10-26', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92299, '2020-10-27', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92300, '2020-10-28', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92301, '2020-10-29', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92302, '2020-10-30', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92303, '2020-10-31', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92304, '2020-11-01', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92305, '2020-11-02', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92306, '2020-11-03', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92307, '2020-11-04', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92308, '2020-11-05', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92309, '2020-11-06', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92310, '2020-11-07', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92311, '2020-11-08', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92312, '2020-11-09', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92313, '2020-11-10', 'VU', 'Vanuatu', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92314, '2020-11-11', 'VU', 'Vanuatu', 'WPRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92315, '2020-11-12', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92316, '2020-11-13', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92317, '2020-11-14', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92318, '2020-11-15', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92319, '2020-11-16', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92320, '2020-11-17', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92321, '2020-11-18', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92322, '2020-11-19', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92323, '2020-11-20', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92324, '2020-11-21', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92325, '2020-11-22', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92326, '2020-11-23', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92327, '2020-11-24', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92328, '2020-11-25', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92329, '2020-11-26', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92330, '2020-11-27', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92331, '2020-11-28', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92332, '2020-11-29', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92333, '2020-11-30', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92334, '2020-12-01', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92335, '2020-12-02', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92336, '2020-12-03', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92337, '2020-12-04', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92338, '2020-12-05', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92339, '2020-12-06', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92340, '2020-12-07', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92341, '2020-12-08', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92342, '2020-12-09', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92343, '2020-12-10', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92344, '2020-12-11', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92345, '2020-12-12', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92346, '2020-12-13', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92347, '2020-12-14', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92348, '2020-12-15', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92349, '2020-12-16', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92350, '2020-12-17', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92351, '2020-12-18', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92352, '2020-12-19', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92353, '2020-12-20', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92354, '2020-12-21', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92355, '2020-12-22', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92356, '2020-12-23', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92357, '2020-12-24', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92358, '2020-12-25', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92359, '2020-12-26', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92360, '2020-12-27', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92361, '2020-12-28', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92362, '2020-12-29', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92363, '2020-12-30', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92364, '2020-12-31', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92365, '2021-01-01', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92366, '2021-01-02', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92367, '2021-01-03', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92368, '2021-01-04', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92369, '2021-01-05', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92370, '2021-01-06', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92371, '2021-01-07', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92372, '2021-01-08', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92373, '2021-01-09', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92374, '2021-01-10', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92375, '2021-01-11', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92376, '2021-01-12', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92377, '2021-01-13', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92378, '2021-01-14', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92379, '2021-01-15', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92380, '2021-01-16', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92381, '2021-01-17', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92382, '2021-01-18', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92383, '2021-01-19', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92384, '2021-01-20', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92385, '2021-01-21', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92386, '2021-01-22', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92387, '2021-01-23', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92388, '2021-01-24', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92389, '2021-01-25', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92390, '2021-01-26', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92391, '2021-01-27', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92392, '2021-01-28', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92393, '2021-01-29', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92394, '2021-01-30', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92395, '2021-01-31', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92396, '2021-02-01', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92397, '2021-02-02', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92398, '2021-02-03', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92399, '2021-02-04', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92400, '2021-02-05', 'VU', 'Vanuatu', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92401, '2020-01-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92402, '2020-01-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92403, '2020-01-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92404, '2020-01-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92405, '2020-01-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92406, '2020-01-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92407, '2020-01-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92408, '2020-01-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92409, '2020-01-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92410, '2020-01-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92411, '2020-01-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92412, '2020-01-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92413, '2020-01-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92414, '2020-01-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92415, '2020-01-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92416, '2020-01-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92417, '2020-01-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92418, '2020-01-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92419, '2020-01-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92420, '2020-01-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92421, '2020-01-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92422, '2020-01-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92423, '2020-01-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92424, '2020-01-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92425, '2020-01-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92426, '2020-01-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92427, '2020-01-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92428, '2020-01-30', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92429, '2020-01-31', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92430, '2020-02-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92431, '2020-02-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92432, '2020-02-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92433, '2020-02-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92434, '2020-02-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92435, '2020-02-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92436, '2020-02-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92437, '2020-02-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92438, '2020-02-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92439, '2020-02-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92440, '2020-02-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92441, '2020-02-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92442, '2020-02-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92443, '2020-02-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92444, '2020-02-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92445, '2020-02-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92446, '2020-02-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92447, '2020-02-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92448, '2020-02-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92449, '2020-02-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92450, '2020-02-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92451, '2020-02-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92452, '2020-02-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92453, '2020-02-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92454, '2020-02-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92455, '2020-02-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92456, '2020-02-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92457, '2020-02-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92458, '2020-02-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92459, '2020-03-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92460, '2020-03-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92461, '2020-03-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92462, '2020-03-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92463, '2020-03-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92464, '2020-03-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92465, '2020-03-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92466, '2020-03-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92467, '2020-03-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92468, '2020-03-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92469, '2020-03-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92470, '2020-03-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92471, '2020-03-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92472, '2020-03-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92473, '2020-03-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '15', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92474, '2020-03-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92475, '2020-03-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '16', '37', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92476, '2020-03-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '3', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92477, '2020-03-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92478, '2020-03-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92479, '2020-03-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92480, '2020-03-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '40', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92481, '2020-03-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '30', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92482, '2020-03-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '7', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92483, '2020-03-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '77', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92484, '2020-03-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '14', '91', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92485, '2020-03-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '91', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92486, '2020-03-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '15', '106', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92487, '2020-03-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '7', '113', '2', '2');
INSERT INTO public.who_global_data_import VALUES (92488, '2020-03-30', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '113', '0', '2');
INSERT INTO public.who_global_data_import VALUES (92489, '2020-03-31', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '16', '129', '1', '3');
INSERT INTO public.who_global_data_import VALUES (92490, '2020-04-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '129', '0', '3');
INSERT INTO public.who_global_data_import VALUES (92491, '2020-04-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '14', '143', '0', '3');
INSERT INTO public.who_global_data_import VALUES (92492, '2020-04-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (92493, '2020-04-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (92494, '2020-04-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (92495, '2020-04-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '144', '0', '3');
INSERT INTO public.who_global_data_import VALUES (92496, '2020-04-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '15', '159', '0', '3');
INSERT INTO public.who_global_data_import VALUES (92497, '2020-04-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '6', '165', '4', '7');
INSERT INTO public.who_global_data_import VALUES (92498, '2020-04-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1', '166', '0', '7');
INSERT INTO public.who_global_data_import VALUES (92499, '2020-04-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '166', '0', '7');
INSERT INTO public.who_global_data_import VALUES (92500, '2020-04-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '5', '171', '2', '9');
INSERT INTO public.who_global_data_import VALUES (92501, '2020-04-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '171', '0', '9');
INSERT INTO public.who_global_data_import VALUES (92502, '2020-04-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '171', '0', '9');
INSERT INTO public.who_global_data_import VALUES (92503, '2020-04-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '10', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (92504, '2020-04-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '181', '0', '9');
INSERT INTO public.who_global_data_import VALUES (92505, '2020-04-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '12', '193', '0', '9');
INSERT INTO public.who_global_data_import VALUES (92506, '2020-04-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '4', '197', '0', '9');
INSERT INTO public.who_global_data_import VALUES (92507, '2020-04-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '7', '204', '0', '9');
INSERT INTO public.who_global_data_import VALUES (92508, '2020-04-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '204', '0', '9');
INSERT INTO public.who_global_data_import VALUES (92509, '2020-04-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '24', '228', '0', '9');
INSERT INTO public.who_global_data_import VALUES (92510, '2020-04-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '28', '256', '0', '9');
INSERT INTO public.who_global_data_import VALUES (92511, '2020-04-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '29', '285', '1', '10');
INSERT INTO public.who_global_data_import VALUES (92512, '2020-04-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '3', '288', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92513, '2020-04-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '10', '298', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92514, '2020-04-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '20', '318', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92515, '2020-04-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '318', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92516, '2020-04-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '5', '323', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92517, '2020-04-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '2', '325', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92518, '2020-04-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '4', '329', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92519, '2020-04-30', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '329', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92520, '2020-05-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '2', '331', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92521, '2020-05-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '2', '333', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92522, '2020-05-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '12', '345', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92523, '2020-05-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '345', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92524, '2020-05-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '12', '357', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92525, '2020-05-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '4', '361', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92526, '2020-05-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '6', '367', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92527, '2020-05-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '12', '379', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92528, '2020-05-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '2', '381', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92529, '2020-05-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '7', '388', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92530, '2020-05-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '14', '402', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92531, '2020-05-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '12', '414', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92532, '2020-05-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '8', '422', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92533, '2020-05-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '18', '440', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92534, '2020-05-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '440', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92535, '2020-05-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '15', '455', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92536, '2020-05-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '49', '504', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92537, '2020-05-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '37', '541', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92538, '2020-05-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '77', '618', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92539, '2020-05-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '618', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92540, '2020-05-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '206', '824', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92541, '2020-05-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '824', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92542, '2020-05-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '58', '882', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92543, '2020-05-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '62', '944', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92544, '2020-05-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '66', '1010', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92545, '2020-05-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '111', '1121', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92546, '2020-05-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '56', '1177', '0', '10');
INSERT INTO public.who_global_data_import VALUES (92547, '2020-05-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '34', '1211', '1', '11');
INSERT INTO public.who_global_data_import VALUES (92548, '2020-05-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '34', '1245', '0', '11');
INSERT INTO public.who_global_data_import VALUES (92549, '2020-05-30', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '82', '1327', '0', '11');
INSERT INTO public.who_global_data_import VALUES (92550, '2020-05-31', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '43', '1370', '3', '14');
INSERT INTO public.who_global_data_import VALUES (92551, '2020-06-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '89', '1459', '0', '14');
INSERT INTO public.who_global_data_import VALUES (92552, '2020-06-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '51', '1510', '0', '14');
INSERT INTO public.who_global_data_import VALUES (92553, '2020-06-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '152', '1662', '3', '17');
INSERT INTO public.who_global_data_import VALUES (92554, '2020-06-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '157', '1819', '1', '18');
INSERT INTO public.who_global_data_import VALUES (92555, '2020-06-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '133', '1952', '2', '20');
INSERT INTO public.who_global_data_import VALUES (92556, '2020-06-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '135', '2087', '0', '20');
INSERT INTO public.who_global_data_import VALUES (92557, '2020-06-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '58', '2145', '0', '20');
INSERT INTO public.who_global_data_import VALUES (92558, '2020-06-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '171', '2316', '2', '22');
INSERT INTO public.who_global_data_import VALUES (93718, '2020-04-29', 'YE', 'Yemen', 'EMRO', '5', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92559, '2020-06-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '61', '2377', '0', '22');
INSERT INTO public.who_global_data_import VALUES (92560, '2020-06-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '96', '2473', '0', '22');
INSERT INTO public.who_global_data_import VALUES (92561, '2020-06-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '159', '2632', '1', '23');
INSERT INTO public.who_global_data_import VALUES (92562, '2020-06-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '106', '2738', '0', '23');
INSERT INTO public.who_global_data_import VALUES (92563, '2020-06-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '76', '2814', '0', '23');
INSERT INTO public.who_global_data_import VALUES (92564, '2020-06-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '65', '2879', '0', '23');
INSERT INTO public.who_global_data_import VALUES (92565, '2020-06-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '25', '2904', '1', '24');
INSERT INTO public.who_global_data_import VALUES (92566, '2020-06-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '74', '2978', '1', '25');
INSERT INTO public.who_global_data_import VALUES (92567, '2020-06-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '84', '3062', '1', '26');
INSERT INTO public.who_global_data_import VALUES (92568, '2020-06-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '88', '3150', '1', '27');
INSERT INTO public.who_global_data_import VALUES (92569, '2020-06-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '236', '3386', '1', '28');
INSERT INTO public.who_global_data_import VALUES (92570, '2020-06-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '98', '3484', '0', '28');
INSERT INTO public.who_global_data_import VALUES (92571, '2020-06-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '107', '3591', '2', '30');
INSERT INTO public.who_global_data_import VALUES (92572, '2020-06-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '199', '3790', '3', '33');
INSERT INTO public.who_global_data_import VALUES (92573, '2020-06-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '128', '3918', '0', '33');
INSERT INTO public.who_global_data_import VALUES (92574, '2020-06-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '130', '4048', '2', '35');
INSERT INTO public.who_global_data_import VALUES (92575, '2020-06-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '138', '4186', '0', '35');
INSERT INTO public.who_global_data_import VALUES (92576, '2020-06-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '179', '4365', '3', '38');
INSERT INTO public.who_global_data_import VALUES (92577, '2020-06-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '198', '4563', '1', '39');
INSERT INTO public.who_global_data_import VALUES (92578, '2020-06-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '216', '4779', '2', '41');
INSERT INTO public.who_global_data_import VALUES (92579, '2020-06-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '351', '5130', '1', '42');
INSERT INTO public.who_global_data_import VALUES (92580, '2020-06-30', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '167', '5297', '2', '44');
INSERT INTO public.who_global_data_import VALUES (92581, '2020-07-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '233', '5530', '4', '48');
INSERT INTO public.who_global_data_import VALUES (92582, '2020-07-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '302', '5832', '3', '51');
INSERT INTO public.who_global_data_import VALUES (92583, '2020-07-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '230', '6062', '3', '54');
INSERT INTO public.who_global_data_import VALUES (92584, '2020-07-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '211', '6273', '3', '57');
INSERT INTO public.who_global_data_import VALUES (92585, '2020-07-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '264', '6537', '2', '59');
INSERT INTO public.who_global_data_import VALUES (92586, '2020-07-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '213', '6750', '3', '62');
INSERT INTO public.who_global_data_import VALUES (92587, '2020-07-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '419', '7169', '2', '64');
INSERT INTO public.who_global_data_import VALUES (92588, '2020-07-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '242', '7411', '4', '68');
INSERT INTO public.who_global_data_import VALUES (92589, '2020-07-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '282', '7693', '3', '71');
INSERT INTO public.who_global_data_import VALUES (92590, '2020-07-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '317', '8010', '4', '75');
INSERT INTO public.who_global_data_import VALUES (92591, '2020-07-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '362', '8372', '5', '80');
INSERT INTO public.who_global_data_import VALUES (92592, '2020-07-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '431', '8803', '3', '83');
INSERT INTO public.who_global_data_import VALUES (92593, '2020-07-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '375', '9178', '2', '85');
INSERT INTO public.who_global_data_import VALUES (92594, '2020-07-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '287', '9465', '4', '89');
INSERT INTO public.who_global_data_import VALUES (92595, '2020-07-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '242', '9707', '4', '93');
INSERT INTO public.who_global_data_import VALUES (92596, '2020-07-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '303', '10010', '3', '96');
INSERT INTO public.who_global_data_import VALUES (92597, '2020-07-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '418', '10428', '4', '100');
INSERT INTO public.who_global_data_import VALUES (92598, '2020-07-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '426', '10854', '4', '104');
INSERT INTO public.who_global_data_import VALUES (92599, '2020-07-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '337', '11191', '3', '107');
INSERT INTO public.who_global_data_import VALUES (92600, '2020-07-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '292', '11483', '3', '110');
INSERT INTO public.who_global_data_import VALUES (92601, '2020-07-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '408', '11891', '2', '112');
INSERT INTO public.who_global_data_import VALUES (92602, '2020-07-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '443', '12334', '4', '116');
INSERT INTO public.who_global_data_import VALUES (92603, '2020-07-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '440', '12774', '4', '120');
INSERT INTO public.who_global_data_import VALUES (92604, '2020-07-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '390', '13164', '4', '124');
INSERT INTO public.who_global_data_import VALUES (92605, '2020-07-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '449', '13613', '5', '129');
INSERT INTO public.who_global_data_import VALUES (92606, '2020-07-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '650', '14263', '5', '134');
INSERT INTO public.who_global_data_import VALUES (92607, '2020-07-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '666', '14929', '4', '138');
INSERT INTO public.who_global_data_import VALUES (92608, '2020-07-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '534', '15463', '4', '142');
INSERT INTO public.who_global_data_import VALUES (92609, '2020-07-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '525', '15988', '4', '146');
INSERT INTO public.who_global_data_import VALUES (92610, '2020-07-30', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '583', '16571', '5', '151');
INSERT INTO public.who_global_data_import VALUES (92611, '2020-07-31', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '588', '17159', '3', '154');
INSERT INTO public.who_global_data_import VALUES (92612, '2020-08-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '700', '17859', '4', '158');
INSERT INTO public.who_global_data_import VALUES (92613, '2020-08-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '715', '18574', '6', '164');
INSERT INTO public.who_global_data_import VALUES (92614, '2020-08-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '869', '19443', '5', '169');
INSERT INTO public.who_global_data_import VALUES (92615, '2020-08-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '763', '20206', '5', '174');
INSERT INTO public.who_global_data_import VALUES (92616, '2020-08-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '548', '20754', '6', '180');
INSERT INTO public.who_global_data_import VALUES (92617, '2020-08-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '684', '21438', '7', '187');
INSERT INTO public.who_global_data_import VALUES (92618, '2020-08-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '861', '22299', '8', '195');
INSERT INTO public.who_global_data_import VALUES (92619, '2020-08-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '981', '23280', '7', '202');
INSERT INTO public.who_global_data_import VALUES (92620, '2020-08-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '886', '24166', '6', '208');
INSERT INTO public.who_global_data_import VALUES (92621, '2020-08-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '795', '24961', '7', '215');
INSERT INTO public.who_global_data_import VALUES (92622, '2020-08-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '844', '25805', '8', '223');
INSERT INTO public.who_global_data_import VALUES (92623, '2020-08-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '995', '26800', '6', '229');
INSERT INTO public.who_global_data_import VALUES (92624, '2020-08-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1138', '27938', '9', '238');
INSERT INTO public.who_global_data_import VALUES (92625, '2020-08-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1150', '29088', '9', '247');
INSERT INTO public.who_global_data_import VALUES (92626, '2020-08-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1281', '30369', '12', '259');
INSERT INTO public.who_global_data_import VALUES (92627, '2020-08-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1012', '31381', '7', '266');
INSERT INTO public.who_global_data_import VALUES (92628, '2020-08-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1226', '32607', '10', '276');
INSERT INTO public.who_global_data_import VALUES (92629, '2020-08-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1148', '33755', '5', '281');
INSERT INTO public.who_global_data_import VALUES (92630, '2020-08-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1047', '34802', '7', '288');
INSERT INTO public.who_global_data_import VALUES (92631, '2020-08-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '895', '35697', '9', '297');
INSERT INTO public.who_global_data_import VALUES (92632, '2020-08-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1171', '36868', '6', '303');
INSERT INTO public.who_global_data_import VALUES (92633, '2020-08-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '699', '37567', '8', '311');
INSERT INTO public.who_global_data_import VALUES (92634, '2020-08-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '621', '38188', '6', '317');
INSERT INTO public.who_global_data_import VALUES (92635, '2020-08-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '769', '38957', '6', '323');
INSERT INTO public.who_global_data_import VALUES (92636, '2020-08-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '607', '39564', '6', '329');
INSERT INTO public.who_global_data_import VALUES (92637, '2020-08-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '774', '40338', '8', '337');
INSERT INTO public.who_global_data_import VALUES (92638, '2020-08-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '820', '41158', '6', '343');
INSERT INTO public.who_global_data_import VALUES (92639, '2020-08-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '807', '41965', '8', '351');
INSERT INTO public.who_global_data_import VALUES (92640, '2020-08-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '933', '42898', '7', '358');
INSERT INTO public.who_global_data_import VALUES (92641, '2020-08-30', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '981', '43879', '0', '358');
INSERT INTO public.who_global_data_import VALUES (92642, '2020-08-31', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1067', '44946', '17', '375');
INSERT INTO public.who_global_data_import VALUES (92643, '2020-09-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '922', '45868', '6', '381');
INSERT INTO public.who_global_data_import VALUES (92644, '2020-09-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '860', '46728', '5', '386');
INSERT INTO public.who_global_data_import VALUES (92645, '2020-09-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1028', '47756', '5', '391');
INSERT INTO public.who_global_data_import VALUES (92646, '2020-09-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1127', '48883', '7', '398');
INSERT INTO public.who_global_data_import VALUES (92647, '2020-09-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '994', '49877', '4', '402');
INSERT INTO public.who_global_data_import VALUES (92648, '2020-09-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1096', '50973', '10', '412');
INSERT INTO public.who_global_data_import VALUES (92649, '2020-09-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1192', '52165', '8', '420');
INSERT INTO public.who_global_data_import VALUES (92650, '2020-09-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1124', '53289', '8', '428');
INSERT INTO public.who_global_data_import VALUES (92651, '2020-09-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1061', '54350', '8', '436');
INSERT INTO public.who_global_data_import VALUES (92652, '2020-09-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1213', '55563', '8', '444');
INSERT INTO public.who_global_data_import VALUES (92653, '2020-09-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1188', '56751', '8', '452');
INSERT INTO public.who_global_data_import VALUES (92654, '2020-09-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1072', '57823', '8', '460');
INSERT INTO public.who_global_data_import VALUES (92655, '2020-09-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '840', '58663', '8', '468');
INSERT INTO public.who_global_data_import VALUES (92656, '2020-09-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '967', '59630', '9', '477');
INSERT INTO public.who_global_data_import VALUES (92657, '2020-09-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1939', '61569', '17', '494');
INSERT INTO public.who_global_data_import VALUES (92658, '2020-09-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '61569', '0', '494');
INSERT INTO public.who_global_data_import VALUES (92659, '2020-09-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1086', '62655', '8', '502');
INSERT INTO public.who_global_data_import VALUES (92660, '2020-09-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '761', '63416', '9', '511');
INSERT INTO public.who_global_data_import VALUES (92661, '2020-09-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '868', '64284', '9', '520');
INSERT INTO public.who_global_data_import VALUES (92662, '2020-09-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '890', '65174', '10', '530');
INSERT INTO public.who_global_data_import VALUES (92663, '2020-09-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '775', '65949', '9', '539');
INSERT INTO public.who_global_data_import VALUES (92664, '2020-09-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '707', '66656', '8', '547');
INSERT INTO public.who_global_data_import VALUES (92665, '2020-09-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '787', '67443', '8', '555');
INSERT INTO public.who_global_data_import VALUES (92666, '2020-09-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '1010', '68453', '9', '564');
INSERT INTO public.who_global_data_import VALUES (92667, '2020-09-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '986', '69439', '10', '574');
INSERT INTO public.who_global_data_import VALUES (92668, '2020-09-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '967', '70406', '7', '581');
INSERT INTO public.who_global_data_import VALUES (92669, '2020-09-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '867', '71273', '10', '591');
INSERT INTO public.who_global_data_import VALUES (92670, '2020-09-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '667', '71940', '9', '600');
INSERT INTO public.who_global_data_import VALUES (92671, '2020-09-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '751', '72691', '6', '606');
INSERT INTO public.who_global_data_import VALUES (92672, '2020-09-30', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '837', '73528', '8', '614');
INSERT INTO public.who_global_data_import VALUES (92673, '2020-10-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '835', '74363', '7', '621');
INSERT INTO public.who_global_data_import VALUES (92674, '2020-10-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '759', '75122', '7', '628');
INSERT INTO public.who_global_data_import VALUES (92675, '2020-10-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '907', '76029', '7', '635');
INSERT INTO public.who_global_data_import VALUES (92676, '2020-10-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '791', '76820', '8', '643');
INSERT INTO public.who_global_data_import VALUES (92677, '2020-10-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '826', '77646', '6', '649');
INSERT INTO public.who_global_data_import VALUES (92678, '2020-10-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '788', '78434', '4', '653');
INSERT INTO public.who_global_data_import VALUES (92679, '2020-10-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '683', '79117', '5', '658');
INSERT INTO public.who_global_data_import VALUES (92680, '2020-10-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '679', '79796', '7', '665');
INSERT INTO public.who_global_data_import VALUES (92681, '2020-10-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '608', '80404', '6', '671');
INSERT INTO public.who_global_data_import VALUES (92682, '2020-10-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '615', '81019', '7', '678');
INSERT INTO public.who_global_data_import VALUES (92683, '2020-10-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '677', '81696', '6', '684');
INSERT INTO public.who_global_data_import VALUES (92684, '2020-10-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '757', '82453', '7', '691');
INSERT INTO public.who_global_data_import VALUES (92685, '2020-10-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '684', '83137', '6', '697');
INSERT INTO public.who_global_data_import VALUES (92686, '2020-10-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '619', '83756', '7', '704');
INSERT INTO public.who_global_data_import VALUES (92687, '2020-10-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '635', '84391', '6', '710');
INSERT INTO public.who_global_data_import VALUES (92688, '2020-10-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '614', '85005', '4', '714');
INSERT INTO public.who_global_data_import VALUES (92689, '2020-10-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '464', '85469', '6', '720');
INSERT INTO public.who_global_data_import VALUES (92690, '2020-10-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '289', '85758', '5', '725');
INSERT INTO public.who_global_data_import VALUES (92691, '2020-10-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '531', '86289', '6', '731');
INSERT INTO public.who_global_data_import VALUES (92692, '2020-10-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '347', '86636', '5', '736');
INSERT INTO public.who_global_data_import VALUES (92693, '2020-10-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '525', '87161', '5', '741');
INSERT INTO public.who_global_data_import VALUES (92694, '2020-10-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '483', '87644', '6', '747');
INSERT INTO public.who_global_data_import VALUES (92695, '2020-10-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '391', '88035', '6', '753');
INSERT INTO public.who_global_data_import VALUES (92696, '2020-10-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '381', '88416', '6', '759');
INSERT INTO public.who_global_data_import VALUES (92697, '2020-10-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '88416', '0', '759');
INSERT INTO public.who_global_data_import VALUES (92698, '2020-10-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '726', '89142', '11', '770');
INSERT INTO public.who_global_data_import VALUES (92699, '2020-10-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '423', '89565', '3', '773');
INSERT INTO public.who_global_data_import VALUES (92700, '2020-10-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '482', '90047', '4', '777');
INSERT INTO public.who_global_data_import VALUES (92701, '2020-10-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '353', '90400', '3', '780');
INSERT INTO public.who_global_data_import VALUES (92702, '2020-10-30', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '476', '90876', '4', '784');
INSERT INTO public.who_global_data_import VALUES (92703, '2020-10-31', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '404', '91280', '5', '789');
INSERT INTO public.who_global_data_import VALUES (92704, '2020-11-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '309', '91589', '4', '793');
INSERT INTO public.who_global_data_import VALUES (92705, '2020-11-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '424', '92013', '5', '798');
INSERT INTO public.who_global_data_import VALUES (92706, '2020-11-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '312', '92325', '3', '801');
INSERT INTO public.who_global_data_import VALUES (92707, '2020-11-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '380', '92705', '4', '805');
INSERT INTO public.who_global_data_import VALUES (92708, '2020-11-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '395', '93100', '5', '810');
INSERT INTO public.who_global_data_import VALUES (92709, '2020-11-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '380', '93480', '4', '814');
INSERT INTO public.who_global_data_import VALUES (92710, '2020-11-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '441', '93921', '5', '819');
INSERT INTO public.who_global_data_import VALUES (92711, '2020-11-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '384', '94305', '2', '821');
INSERT INTO public.who_global_data_import VALUES (93719, '2020-04-30', 'YE', 'Yemen', 'EMRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92712, '2020-11-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '393', '94698', '3', '824');
INSERT INTO public.who_global_data_import VALUES (92713, '2020-11-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '185', '94883', '2', '826');
INSERT INTO public.who_global_data_import VALUES (92714, '2020-11-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '266', '95149', '4', '830');
INSERT INTO public.who_global_data_import VALUES (92715, '2020-11-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '296', '95445', '4', '834');
INSERT INTO public.who_global_data_import VALUES (92716, '2020-11-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '305', '95750', '4', '838');
INSERT INTO public.who_global_data_import VALUES (92717, '2020-11-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '390', '96140', '3', '841');
INSERT INTO public.who_global_data_import VALUES (92718, '2020-11-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '301', '96441', '3', '844');
INSERT INTO public.who_global_data_import VALUES (92719, '2020-11-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '492', '96933', '4', '848');
INSERT INTO public.who_global_data_import VALUES (92720, '2020-11-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '419', '97352', '3', '851');
INSERT INTO public.who_global_data_import VALUES (92721, '2020-11-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '387', '97739', '4', '855');
INSERT INTO public.who_global_data_import VALUES (92722, '2020-11-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '311', '98050', '3', '858');
INSERT INTO public.who_global_data_import VALUES (92723, '2020-11-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '300', '98350', '2', '860');
INSERT INTO public.who_global_data_import VALUES (92724, '2020-11-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '315', '98665', '3', '863');
INSERT INTO public.who_global_data_import VALUES (92725, '2020-11-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '352', '99017', '3', '866');
INSERT INTO public.who_global_data_import VALUES (92726, '2020-11-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '418', '99435', '3', '869');
INSERT INTO public.who_global_data_import VALUES (92727, '2020-11-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '400', '99835', '2', '871');
INSERT INTO public.who_global_data_import VALUES (92728, '2020-11-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '308', '100143', '2', '873');
INSERT INTO public.who_global_data_import VALUES (92729, '2020-11-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '355', '100498', '3', '876');
INSERT INTO public.who_global_data_import VALUES (92730, '2020-11-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '319', '100817', '4', '880');
INSERT INTO public.who_global_data_import VALUES (92731, '2020-11-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '398', '101215', '4', '884');
INSERT INTO public.who_global_data_import VALUES (92732, '2020-11-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '309', '101524', '4', '888');
INSERT INTO public.who_global_data_import VALUES (92733, '2020-11-30', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '236', '101760', '4', '892');
INSERT INTO public.who_global_data_import VALUES (92734, '2020-12-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '280', '102040', '2', '894');
INSERT INTO public.who_global_data_import VALUES (92735, '2020-12-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '354', '102394', '3', '897');
INSERT INTO public.who_global_data_import VALUES (92736, '2020-12-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '227', '102621', '4', '901');
INSERT INTO public.who_global_data_import VALUES (92737, '2020-12-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '446', '103067', '4', '905');
INSERT INTO public.who_global_data_import VALUES (92738, '2020-12-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '481', '103548', '4', '909');
INSERT INTO public.who_global_data_import VALUES (92739, '2020-12-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '329', '103877', '4', '913');
INSERT INTO public.who_global_data_import VALUES (92740, '2020-12-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '300', '104177', '3', '916');
INSERT INTO public.who_global_data_import VALUES (92741, '2020-12-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '265', '104442', '3', '919');
INSERT INTO public.who_global_data_import VALUES (92742, '2020-12-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '104442', '0', '919');
INSERT INTO public.who_global_data_import VALUES (92743, '2020-12-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '942', '105384', '9', '928');
INSERT INTO public.who_global_data_import VALUES (92744, '2020-12-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '468', '105852', '5', '933');
INSERT INTO public.who_global_data_import VALUES (92745, '2020-12-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '428', '106280', '5', '938');
INSERT INTO public.who_global_data_import VALUES (92746, '2020-12-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '435', '106715', '6', '944');
INSERT INTO public.who_global_data_import VALUES (92747, '2020-12-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '462', '107177', '5', '949');
INSERT INTO public.who_global_data_import VALUES (92748, '2020-12-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '609', '107786', '5', '954');
INSERT INTO public.who_global_data_import VALUES (92749, '2020-12-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '339', '108125', '6', '960');
INSERT INTO public.who_global_data_import VALUES (92750, '2020-12-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '355', '108480', '5', '965');
INSERT INTO public.who_global_data_import VALUES (92751, '2020-12-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '237', '108717', '5', '970');
INSERT INTO public.who_global_data_import VALUES (92752, '2020-12-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '364', '109081', '5', '975');
INSERT INTO public.who_global_data_import VALUES (92753, '2020-12-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '314', '109395', '4', '979');
INSERT INTO public.who_global_data_import VALUES (92754, '2020-12-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '386', '109781', '5', '984');
INSERT INTO public.who_global_data_import VALUES (92755, '2020-12-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '294', '110075', '4', '988');
INSERT INTO public.who_global_data_import VALUES (92756, '2020-12-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '438', '110513', '5', '993');
INSERT INTO public.who_global_data_import VALUES (92757, '2020-12-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '315', '110828', '4', '997');
INSERT INTO public.who_global_data_import VALUES (92758, '2020-12-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '196', '111024', '5', '1002');
INSERT INTO public.who_global_data_import VALUES (92759, '2020-12-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '221', '111245', '4', '1006');
INSERT INTO public.who_global_data_import VALUES (92760, '2020-12-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '358', '111603', '4', '1010');
INSERT INTO public.who_global_data_import VALUES (92761, '2020-12-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '348', '111951', '3', '1013');
INSERT INTO public.who_global_data_import VALUES (92762, '2020-12-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '365', '112316', '1', '1014');
INSERT INTO public.who_global_data_import VALUES (92763, '2020-12-30', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '320', '112636', '4', '1018');
INSERT INTO public.who_global_data_import VALUES (92764, '2020-12-31', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '225', '112861', '3', '1021');
INSERT INTO public.who_global_data_import VALUES (92765, '2021-01-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '260', '113121', '4', '1025');
INSERT INTO public.who_global_data_import VALUES (92766, '2021-01-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '441', '113562', '3', '1028');
INSERT INTO public.who_global_data_import VALUES (92767, '2021-01-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '0', '113562', '0', '1028');
INSERT INTO public.who_global_data_import VALUES (92768, '2021-01-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '521', '114083', '4', '1032');
INSERT INTO public.who_global_data_import VALUES (92769, '2021-01-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '147', '114230', '2', '1034');
INSERT INTO public.who_global_data_import VALUES (92770, '2021-01-06', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '177', '114407', '4', '1038');
INSERT INTO public.who_global_data_import VALUES (92771, '2021-01-07', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '255', '114662', '4', '1042');
INSERT INTO public.who_global_data_import VALUES (92772, '2021-01-08', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '246', '114908', '5', '1047');
INSERT INTO public.who_global_data_import VALUES (92773, '2021-01-09', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '414', '115322', '5', '1052');
INSERT INTO public.who_global_data_import VALUES (92774, '2021-01-10', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '345', '115667', '4', '1056');
INSERT INTO public.who_global_data_import VALUES (92775, '2021-01-11', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '505', '116172', '5', '1061');
INSERT INTO public.who_global_data_import VALUES (92776, '2021-01-12', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '438', '116610', '6', '1067');
INSERT INTO public.who_global_data_import VALUES (92777, '2021-01-13', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '373', '116983', '6', '1073');
INSERT INTO public.who_global_data_import VALUES (92778, '2021-01-14', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '316', '117299', '5', '1078');
INSERT INTO public.who_global_data_import VALUES (92779, '2021-01-15', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '512', '117811', '6', '1084');
INSERT INTO public.who_global_data_import VALUES (92780, '2021-01-16', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '604', '118415', '6', '1090');
INSERT INTO public.who_global_data_import VALUES (92781, '2021-01-17', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '441', '118856', '5', '1095');
INSERT INTO public.who_global_data_import VALUES (92782, '2021-01-18', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '450', '119306', '6', '1101');
INSERT INTO public.who_global_data_import VALUES (92783, '2021-01-19', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '497', '119803', '5', '1106');
INSERT INTO public.who_global_data_import VALUES (92784, '2021-01-20', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '641', '120444', '6', '1112');
INSERT INTO public.who_global_data_import VALUES (92785, '2021-01-21', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '673', '121117', '4', '1116');
INSERT INTO public.who_global_data_import VALUES (92786, '2021-01-22', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '574', '121691', '6', '1122');
INSERT INTO public.who_global_data_import VALUES (93720, '2020-05-01', 'YE', 'Yemen', 'EMRO', '0', '6', '2', '2');
INSERT INTO public.who_global_data_import VALUES (92787, '2021-01-23', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '569', '122260', '7', '1129');
INSERT INTO public.who_global_data_import VALUES (92788, '2021-01-24', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '535', '122795', '7', '1136');
INSERT INTO public.who_global_data_import VALUES (92789, '2021-01-25', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '450', '123245', '6', '1142');
INSERT INTO public.who_global_data_import VALUES (92790, '2021-01-26', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '464', '123709', '6', '1148');
INSERT INTO public.who_global_data_import VALUES (92791, '2021-01-27', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '403', '124112', '6', '1154');
INSERT INTO public.who_global_data_import VALUES (92792, '2021-01-28', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '413', '124525', '5', '1159');
INSERT INTO public.who_global_data_import VALUES (92793, '2021-01-29', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '433', '124958', '6', '1165');
INSERT INTO public.who_global_data_import VALUES (92794, '2021-01-30', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '406', '125364', '6', '1171');
INSERT INTO public.who_global_data_import VALUES (92795, '2021-01-31', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '412', '125776', '6', '1177');
INSERT INTO public.who_global_data_import VALUES (92796, '2021-02-01', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '547', '126323', '6', '1183');
INSERT INTO public.who_global_data_import VALUES (92797, '2021-02-02', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '604', '126927', '6', '1189');
INSERT INTO public.who_global_data_import VALUES (92798, '2021-02-03', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '419', '127346', '7', '1196');
INSERT INTO public.who_global_data_import VALUES (92799, '2021-02-04', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '406', '127752', '6', '1202');
INSERT INTO public.who_global_data_import VALUES (92800, '2021-02-05', 'VE', 'Venezuela (Bolivarian Republic of)', 'AMRO', '563', '128315', '7', '1209');
INSERT INTO public.who_global_data_import VALUES (92801, '2020-01-03', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92802, '2020-01-04', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92803, '2020-01-05', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92804, '2020-01-06', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92805, '2020-01-07', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92806, '2020-01-08', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92807, '2020-01-09', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92808, '2020-01-10', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92809, '2020-01-11', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92810, '2020-01-12', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92811, '2020-01-13', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92812, '2020-01-14', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92813, '2020-01-15', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92814, '2020-01-16', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92815, '2020-01-17', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92816, '2020-01-18', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92817, '2020-01-19', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92818, '2020-01-20', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92819, '2020-01-21', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92820, '2020-01-22', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92821, '2020-01-23', 'VN', 'Viet Nam', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92822, '2020-01-24', 'VN', 'Viet Nam', 'WPRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92823, '2020-01-25', 'VN', 'Viet Nam', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92824, '2020-01-26', 'VN', 'Viet Nam', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92825, '2020-01-27', 'VN', 'Viet Nam', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92826, '2020-01-28', 'VN', 'Viet Nam', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92827, '2020-01-29', 'VN', 'Viet Nam', 'WPRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92828, '2020-01-30', 'VN', 'Viet Nam', 'WPRO', '3', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92829, '2020-01-31', 'VN', 'Viet Nam', 'WPRO', '0', '9', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92830, '2020-02-01', 'VN', 'Viet Nam', 'WPRO', '1', '10', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92831, '2020-02-02', 'VN', 'Viet Nam', 'WPRO', '1', '11', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92832, '2020-02-03', 'VN', 'Viet Nam', 'WPRO', '1', '12', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92833, '2020-02-04', 'VN', 'Viet Nam', 'WPRO', '2', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92834, '2020-02-05', 'VN', 'Viet Nam', 'WPRO', '0', '14', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92835, '2020-02-06', 'VN', 'Viet Nam', 'WPRO', '2', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92836, '2020-02-07', 'VN', 'Viet Nam', 'WPRO', '0', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92837, '2020-02-08', 'VN', 'Viet Nam', 'WPRO', '1', '17', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92838, '2020-02-09', 'VN', 'Viet Nam', 'WPRO', '1', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92839, '2020-02-10', 'VN', 'Viet Nam', 'WPRO', '0', '18', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92840, '2020-02-11', 'VN', 'Viet Nam', 'WPRO', '1', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92841, '2020-02-12', 'VN', 'Viet Nam', 'WPRO', '0', '19', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92842, '2020-02-13', 'VN', 'Viet Nam', 'WPRO', '1', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92843, '2020-02-14', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92844, '2020-02-15', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92845, '2020-02-16', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92846, '2020-02-17', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92847, '2020-02-18', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92848, '2020-02-19', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92849, '2020-02-20', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92850, '2020-02-21', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92851, '2020-02-22', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92852, '2020-02-23', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92853, '2020-02-24', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92854, '2020-02-25', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92855, '2020-02-26', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92856, '2020-02-27', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92857, '2020-02-28', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92858, '2020-02-29', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92859, '2020-03-01', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92860, '2020-03-02', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92861, '2020-03-03', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92862, '2020-03-04', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92863, '2020-03-05', 'VN', 'Viet Nam', 'WPRO', '0', '20', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92864, '2020-03-06', 'VN', 'Viet Nam', 'WPRO', '1', '21', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92865, '2020-03-07', 'VN', 'Viet Nam', 'WPRO', '3', '24', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92866, '2020-03-08', 'VN', 'Viet Nam', 'WPRO', '10', '34', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92867, '2020-03-09', 'VN', 'Viet Nam', 'WPRO', '1', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92868, '2020-03-10', 'VN', 'Viet Nam', 'WPRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92869, '2020-03-11', 'VN', 'Viet Nam', 'WPRO', '4', '39', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92870, '2020-03-12', 'VN', 'Viet Nam', 'WPRO', '4', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92871, '2020-03-13', 'VN', 'Viet Nam', 'WPRO', '0', '43', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92872, '2020-03-14', 'VN', 'Viet Nam', 'WPRO', '9', '52', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92873, '2020-03-15', 'VN', 'Viet Nam', 'WPRO', '5', '57', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92874, '2020-03-16', 'VN', 'Viet Nam', 'WPRO', '4', '61', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92875, '2020-03-17', 'VN', 'Viet Nam', 'WPRO', '4', '65', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92876, '2020-03-18', 'VN', 'Viet Nam', 'WPRO', '5', '70', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92877, '2020-03-19', 'VN', 'Viet Nam', 'WPRO', '15', '85', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92878, '2020-03-20', 'VN', 'Viet Nam', 'WPRO', '6', '91', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92879, '2020-03-21', 'VN', 'Viet Nam', 'WPRO', '3', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92880, '2020-03-22', 'VN', 'Viet Nam', 'WPRO', '0', '94', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92881, '2020-03-23', 'VN', 'Viet Nam', 'WPRO', '24', '118', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92882, '2020-03-24', 'VN', 'Viet Nam', 'WPRO', '5', '123', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92883, '2020-03-25', 'VN', 'Viet Nam', 'WPRO', '11', '134', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92884, '2020-03-26', 'VN', 'Viet Nam', 'WPRO', '14', '148', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92885, '2020-03-27', 'VN', 'Viet Nam', 'WPRO', '5', '153', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92886, '2020-03-28', 'VN', 'Viet Nam', 'WPRO', '16', '169', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92887, '2020-03-29', 'VN', 'Viet Nam', 'WPRO', '10', '179', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92888, '2020-03-30', 'VN', 'Viet Nam', 'WPRO', '15', '194', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92889, '2020-03-31', 'VN', 'Viet Nam', 'WPRO', '9', '203', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92890, '2020-04-01', 'VN', 'Viet Nam', 'WPRO', '9', '212', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92891, '2020-04-02', 'VN', 'Viet Nam', 'WPRO', '4', '216', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92892, '2020-04-03', 'VN', 'Viet Nam', 'WPRO', '17', '233', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92893, '2020-04-04', 'VN', 'Viet Nam', 'WPRO', '6', '239', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92894, '2020-04-05', 'VN', 'Viet Nam', 'WPRO', '1', '240', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92895, '2020-04-06', 'VN', 'Viet Nam', 'WPRO', '1', '241', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92896, '2020-04-07', 'VN', 'Viet Nam', 'WPRO', '4', '245', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92897, '2020-04-08', 'VN', 'Viet Nam', 'WPRO', '6', '251', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92898, '2020-04-09', 'VN', 'Viet Nam', 'WPRO', '0', '251', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92899, '2020-04-10', 'VN', 'Viet Nam', 'WPRO', '4', '255', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92900, '2020-04-11', 'VN', 'Viet Nam', 'WPRO', '2', '257', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92901, '2020-04-12', 'VN', 'Viet Nam', 'WPRO', '1', '258', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92902, '2020-04-13', 'VN', 'Viet Nam', 'WPRO', '4', '262', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92903, '2020-04-14', 'VN', 'Viet Nam', 'WPRO', '3', '265', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92904, '2020-04-15', 'VN', 'Viet Nam', 'WPRO', '2', '267', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92905, '2020-04-16', 'VN', 'Viet Nam', 'WPRO', '0', '267', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92906, '2020-04-17', 'VN', 'Viet Nam', 'WPRO', '1', '268', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92907, '2020-04-18', 'VN', 'Viet Nam', 'WPRO', '0', '268', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92908, '2020-04-19', 'VN', 'Viet Nam', 'WPRO', '0', '268', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92909, '2020-04-20', 'VN', 'Viet Nam', 'WPRO', '0', '268', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92910, '2020-04-21', 'VN', 'Viet Nam', 'WPRO', '0', '268', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92911, '2020-04-22', 'VN', 'Viet Nam', 'WPRO', '0', '268', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92912, '2020-04-23', 'VN', 'Viet Nam', 'WPRO', '0', '268', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92913, '2020-04-24', 'VN', 'Viet Nam', 'WPRO', '0', '268', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92914, '2020-04-25', 'VN', 'Viet Nam', 'WPRO', '2', '270', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92915, '2020-04-26', 'VN', 'Viet Nam', 'WPRO', '0', '270', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92916, '2020-04-27', 'VN', 'Viet Nam', 'WPRO', '0', '270', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92917, '2020-04-28', 'VN', 'Viet Nam', 'WPRO', '0', '270', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92918, '2020-04-29', 'VN', 'Viet Nam', 'WPRO', '0', '270', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92919, '2020-04-30', 'VN', 'Viet Nam', 'WPRO', '0', '270', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92920, '2020-05-01', 'VN', 'Viet Nam', 'WPRO', '0', '270', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92921, '2020-05-02', 'VN', 'Viet Nam', 'WPRO', '0', '270', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92922, '2020-05-03', 'VN', 'Viet Nam', 'WPRO', '0', '270', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92923, '2020-05-04', 'VN', 'Viet Nam', 'WPRO', '1', '271', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92924, '2020-05-05', 'VN', 'Viet Nam', 'WPRO', '0', '271', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92925, '2020-05-06', 'VN', 'Viet Nam', 'WPRO', '0', '271', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92926, '2020-05-07', 'VN', 'Viet Nam', 'WPRO', '17', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92927, '2020-05-08', 'VN', 'Viet Nam', 'WPRO', '0', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92928, '2020-05-09', 'VN', 'Viet Nam', 'WPRO', '0', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92929, '2020-05-10', 'VN', 'Viet Nam', 'WPRO', '0', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92930, '2020-05-11', 'VN', 'Viet Nam', 'WPRO', '0', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92931, '2020-05-12', 'VN', 'Viet Nam', 'WPRO', '0', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92932, '2020-05-13', 'VN', 'Viet Nam', 'WPRO', '0', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92933, '2020-05-14', 'VN', 'Viet Nam', 'WPRO', '0', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92934, '2020-05-15', 'VN', 'Viet Nam', 'WPRO', '0', '288', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92935, '2020-05-16', 'VN', 'Viet Nam', 'WPRO', '30', '318', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92936, '2020-05-17', 'VN', 'Viet Nam', 'WPRO', '0', '318', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92937, '2020-05-18', 'VN', 'Viet Nam', 'WPRO', '2', '320', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92938, '2020-05-19', 'VN', 'Viet Nam', 'WPRO', '4', '324', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92939, '2020-05-20', 'VN', 'Viet Nam', 'WPRO', '0', '324', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92940, '2020-05-21', 'VN', 'Viet Nam', 'WPRO', '0', '324', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92941, '2020-05-22', 'VN', 'Viet Nam', 'WPRO', '0', '324', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92942, '2020-05-23', 'VN', 'Viet Nam', 'WPRO', '0', '324', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92943, '2020-05-24', 'VN', 'Viet Nam', 'WPRO', '1', '325', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92944, '2020-05-25', 'VN', 'Viet Nam', 'WPRO', '0', '325', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92945, '2020-05-26', 'VN', 'Viet Nam', 'WPRO', '1', '326', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92946, '2020-05-27', 'VN', 'Viet Nam', 'WPRO', '1', '327', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92947, '2020-05-28', 'VN', 'Viet Nam', 'WPRO', '0', '327', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92948, '2020-05-29', 'VN', 'Viet Nam', 'WPRO', '0', '327', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92949, '2020-05-30', 'VN', 'Viet Nam', 'WPRO', '0', '327', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92950, '2020-05-31', 'VN', 'Viet Nam', 'WPRO', '1', '328', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92951, '2020-06-01', 'VN', 'Viet Nam', 'WPRO', '0', '328', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92952, '2020-06-02', 'VN', 'Viet Nam', 'WPRO', '0', '328', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92953, '2020-06-03', 'VN', 'Viet Nam', 'WPRO', '0', '328', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92954, '2020-06-04', 'VN', 'Viet Nam', 'WPRO', '0', '328', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92955, '2020-06-05', 'VN', 'Viet Nam', 'WPRO', '0', '328', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92956, '2020-06-06', 'VN', 'Viet Nam', 'WPRO', '1', '329', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92957, '2020-06-07', 'VN', 'Viet Nam', 'WPRO', '0', '329', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92958, '2020-06-08', 'VN', 'Viet Nam', 'WPRO', '0', '329', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92959, '2020-06-09', 'VN', 'Viet Nam', 'WPRO', '3', '332', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92960, '2020-06-10', 'VN', 'Viet Nam', 'WPRO', '0', '332', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92961, '2020-06-11', 'VN', 'Viet Nam', 'WPRO', '0', '332', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92962, '2020-06-12', 'VN', 'Viet Nam', 'WPRO', '0', '332', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92963, '2020-06-13', 'VN', 'Viet Nam', 'WPRO', '0', '332', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92964, '2020-06-14', 'VN', 'Viet Nam', 'WPRO', '2', '334', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92965, '2020-06-15', 'VN', 'Viet Nam', 'WPRO', '0', '334', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92966, '2020-06-16', 'VN', 'Viet Nam', 'WPRO', '0', '334', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92967, '2020-06-17', 'VN', 'Viet Nam', 'WPRO', '1', '335', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92968, '2020-06-18', 'VN', 'Viet Nam', 'WPRO', '0', '335', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92969, '2020-06-19', 'VN', 'Viet Nam', 'WPRO', '7', '342', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92970, '2020-06-20', 'VN', 'Viet Nam', 'WPRO', '7', '349', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92971, '2020-06-21', 'VN', 'Viet Nam', 'WPRO', '0', '349', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92972, '2020-06-22', 'VN', 'Viet Nam', 'WPRO', '0', '349', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92973, '2020-06-23', 'VN', 'Viet Nam', 'WPRO', '0', '349', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92974, '2020-06-24', 'VN', 'Viet Nam', 'WPRO', '0', '349', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92975, '2020-06-25', 'VN', 'Viet Nam', 'WPRO', '3', '352', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92976, '2020-06-26', 'VN', 'Viet Nam', 'WPRO', '0', '352', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92977, '2020-06-27', 'VN', 'Viet Nam', 'WPRO', '1', '353', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92978, '2020-06-28', 'VN', 'Viet Nam', 'WPRO', '2', '355', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92979, '2020-06-29', 'VN', 'Viet Nam', 'WPRO', '0', '355', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92980, '2020-06-30', 'VN', 'Viet Nam', 'WPRO', '0', '355', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92981, '2020-07-01', 'VN', 'Viet Nam', 'WPRO', '0', '355', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92982, '2020-07-02', 'VN', 'Viet Nam', 'WPRO', '0', '355', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92983, '2020-07-03', 'VN', 'Viet Nam', 'WPRO', '0', '355', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92984, '2020-07-04', 'VN', 'Viet Nam', 'WPRO', '0', '355', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92985, '2020-07-05', 'VN', 'Viet Nam', 'WPRO', '0', '355', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92986, '2020-07-06', 'VN', 'Viet Nam', 'WPRO', '0', '355', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92987, '2020-07-07', 'VN', 'Viet Nam', 'WPRO', '14', '369', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92988, '2020-07-08', 'VN', 'Viet Nam', 'WPRO', '0', '369', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92989, '2020-07-09', 'VN', 'Viet Nam', 'WPRO', '0', '369', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92990, '2020-07-10', 'VN', 'Viet Nam', 'WPRO', '0', '369', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92991, '2020-07-11', 'VN', 'Viet Nam', 'WPRO', '1', '370', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92992, '2020-07-12', 'VN', 'Viet Nam', 'WPRO', '0', '370', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92993, '2020-07-13', 'VN', 'Viet Nam', 'WPRO', '2', '372', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92994, '2020-07-14', 'VN', 'Viet Nam', 'WPRO', '0', '372', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92995, '2020-07-15', 'VN', 'Viet Nam', 'WPRO', '1', '373', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92996, '2020-07-16', 'VN', 'Viet Nam', 'WPRO', '8', '381', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92997, '2020-07-17', 'VN', 'Viet Nam', 'WPRO', '0', '381', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92998, '2020-07-18', 'VN', 'Viet Nam', 'WPRO', '1', '382', '0', '0');
INSERT INTO public.who_global_data_import VALUES (92999, '2020-07-19', 'VN', 'Viet Nam', 'WPRO', '0', '382', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93000, '2020-07-20', 'VN', 'Viet Nam', 'WPRO', '1', '383', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93001, '2020-07-21', 'VN', 'Viet Nam', 'WPRO', '1', '384', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93002, '2020-07-22', 'VN', 'Viet Nam', 'WPRO', '17', '401', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93003, '2020-07-23', 'VN', 'Viet Nam', 'WPRO', '7', '408', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93004, '2020-07-24', 'VN', 'Viet Nam', 'WPRO', '4', '412', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93005, '2020-07-25', 'VN', 'Viet Nam', 'WPRO', '3', '415', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93006, '2020-07-26', 'VN', 'Viet Nam', 'WPRO', '3', '418', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93007, '2020-07-27', 'VN', 'Viet Nam', 'WPRO', '2', '420', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93008, '2020-07-28', 'VN', 'Viet Nam', 'WPRO', '11', '431', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93009, '2020-07-29', 'VN', 'Viet Nam', 'WPRO', '15', '446', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93010, '2020-07-30', 'VN', 'Viet Nam', 'WPRO', '13', '459', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93011, '2020-07-31', 'VN', 'Viet Nam', 'WPRO', '50', '509', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93012, '2020-08-01', 'VN', 'Viet Nam', 'WPRO', '49', '558', '2', '2');
INSERT INTO public.who_global_data_import VALUES (93013, '2020-08-02', 'VN', 'Viet Nam', 'WPRO', '32', '590', '1', '3');
INSERT INTO public.who_global_data_import VALUES (93014, '2020-08-03', 'VN', 'Viet Nam', 'WPRO', '31', '621', '3', '6');
INSERT INTO public.who_global_data_import VALUES (93015, '2020-08-04', 'VN', 'Viet Nam', 'WPRO', '31', '652', '0', '6');
INSERT INTO public.who_global_data_import VALUES (93016, '2020-08-05', 'VN', 'Viet Nam', 'WPRO', '20', '672', '2', '8');
INSERT INTO public.who_global_data_import VALUES (93017, '2020-08-06', 'VN', 'Viet Nam', 'WPRO', '45', '717', '0', '8');
INSERT INTO public.who_global_data_import VALUES (93018, '2020-08-07', 'VN', 'Viet Nam', 'WPRO', '33', '750', '2', '10');
INSERT INTO public.who_global_data_import VALUES (93019, '2020-08-08', 'VN', 'Viet Nam', 'WPRO', '39', '789', '0', '10');
INSERT INTO public.who_global_data_import VALUES (93020, '2020-08-09', 'VN', 'Viet Nam', 'WPRO', '23', '812', '0', '10');
INSERT INTO public.who_global_data_import VALUES (93021, '2020-08-10', 'VN', 'Viet Nam', 'WPRO', '29', '841', '3', '13');
INSERT INTO public.who_global_data_import VALUES (93022, '2020-08-11', 'VN', 'Viet Nam', 'WPRO', '6', '847', '2', '15');
INSERT INTO public.who_global_data_import VALUES (93023, '2020-08-12', 'VN', 'Viet Nam', 'WPRO', '19', '866', '2', '17');
INSERT INTO public.who_global_data_import VALUES (93024, '2020-08-13', 'VN', 'Viet Nam', 'WPRO', '17', '883', '1', '18');
INSERT INTO public.who_global_data_import VALUES (93025, '2020-08-14', 'VN', 'Viet Nam', 'WPRO', '28', '911', '3', '21');
INSERT INTO public.who_global_data_import VALUES (93026, '2020-08-15', 'VN', 'Viet Nam', 'WPRO', '19', '930', '1', '22');
INSERT INTO public.who_global_data_import VALUES (93027, '2020-08-16', 'VN', 'Viet Nam', 'WPRO', '21', '951', '1', '23');
INSERT INTO public.who_global_data_import VALUES (93028, '2020-08-17', 'VN', 'Viet Nam', 'WPRO', '13', '964', '1', '24');
INSERT INTO public.who_global_data_import VALUES (93029, '2020-08-18', 'VN', 'Viet Nam', 'WPRO', '19', '983', '1', '25');
INSERT INTO public.who_global_data_import VALUES (93030, '2020-08-19', 'VN', 'Viet Nam', 'WPRO', '6', '989', '0', '25');
INSERT INTO public.who_global_data_import VALUES (93031, '2020-08-20', 'VN', 'Viet Nam', 'WPRO', '4', '993', '0', '25');
INSERT INTO public.who_global_data_import VALUES (93032, '2020-08-21', 'VN', 'Viet Nam', 'WPRO', '14', '1007', '0', '25');
INSERT INTO public.who_global_data_import VALUES (93033, '2020-08-22', 'VN', 'Viet Nam', 'WPRO', '2', '1009', '0', '25');
INSERT INTO public.who_global_data_import VALUES (93034, '2020-08-23', 'VN', 'Viet Nam', 'WPRO', '5', '1014', '1', '26');
INSERT INTO public.who_global_data_import VALUES (93035, '2020-08-24', 'VN', 'Viet Nam', 'WPRO', '2', '1016', '1', '27');
INSERT INTO public.who_global_data_import VALUES (93036, '2020-08-25', 'VN', 'Viet Nam', 'WPRO', '6', '1022', '0', '27');
INSERT INTO public.who_global_data_import VALUES (93037, '2020-08-26', 'VN', 'Viet Nam', 'WPRO', '7', '1029', '0', '27');
INSERT INTO public.who_global_data_import VALUES (93038, '2020-08-27', 'VN', 'Viet Nam', 'WPRO', '5', '1034', '2', '29');
INSERT INTO public.who_global_data_import VALUES (93039, '2020-08-28', 'VN', 'Viet Nam', 'WPRO', '2', '1036', '1', '30');
INSERT INTO public.who_global_data_import VALUES (93040, '2020-08-29', 'VN', 'Viet Nam', 'WPRO', '2', '1038', '0', '30');
INSERT INTO public.who_global_data_import VALUES (93041, '2020-08-30', 'VN', 'Viet Nam', 'WPRO', '2', '1040', '2', '32');
INSERT INTO public.who_global_data_import VALUES (93042, '2020-08-31', 'VN', 'Viet Nam', 'WPRO', '0', '1040', '0', '32');
INSERT INTO public.who_global_data_import VALUES (93043, '2020-09-01', 'VN', 'Viet Nam', 'WPRO', '4', '1044', '2', '34');
INSERT INTO public.who_global_data_import VALUES (93044, '2020-09-02', 'VN', 'Viet Nam', 'WPRO', '0', '1044', '0', '34');
INSERT INTO public.who_global_data_import VALUES (93045, '2020-09-03', 'VN', 'Viet Nam', 'WPRO', '2', '1046', '0', '34');
INSERT INTO public.who_global_data_import VALUES (93046, '2020-09-04', 'VN', 'Viet Nam', 'WPRO', '0', '1046', '1', '35');
INSERT INTO public.who_global_data_import VALUES (93047, '2020-09-05', 'VN', 'Viet Nam', 'WPRO', '3', '1049', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93048, '2020-09-06', 'VN', 'Viet Nam', 'WPRO', '0', '1049', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93049, '2020-09-07', 'VN', 'Viet Nam', 'WPRO', '0', '1049', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93050, '2020-09-08', 'VN', 'Viet Nam', 'WPRO', '0', '1049', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93051, '2020-09-09', 'VN', 'Viet Nam', 'WPRO', '5', '1054', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93052, '2020-09-10', 'VN', 'Viet Nam', 'WPRO', '5', '1059', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93053, '2020-09-11', 'VN', 'Viet Nam', 'WPRO', '0', '1059', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93054, '2020-09-12', 'VN', 'Viet Nam', 'WPRO', '1', '1060', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93055, '2020-09-13', 'VN', 'Viet Nam', 'WPRO', '0', '1060', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93056, '2020-09-14', 'VN', 'Viet Nam', 'WPRO', '3', '1063', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93057, '2020-09-15', 'VN', 'Viet Nam', 'WPRO', '0', '1063', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93058, '2020-09-16', 'VN', 'Viet Nam', 'WPRO', '0', '1063', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93059, '2020-09-17', 'VN', 'Viet Nam', 'WPRO', '0', '1063', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93060, '2020-09-18', 'VN', 'Viet Nam', 'WPRO', '3', '1066', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93061, '2020-09-19', 'VN', 'Viet Nam', 'WPRO', '2', '1068', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93062, '2020-09-20', 'VN', 'Viet Nam', 'WPRO', '0', '1068', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93063, '2020-09-21', 'VN', 'Viet Nam', 'WPRO', '0', '1068', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93064, '2020-09-22', 'VN', 'Viet Nam', 'WPRO', '0', '1068', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93065, '2020-09-23', 'VN', 'Viet Nam', 'WPRO', '0', '1068', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93066, '2020-09-24', 'VN', 'Viet Nam', 'WPRO', '1', '1069', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93067, '2020-09-25', 'VN', 'Viet Nam', 'WPRO', '0', '1069', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93068, '2020-09-26', 'VN', 'Viet Nam', 'WPRO', '0', '1069', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93069, '2020-09-27', 'VN', 'Viet Nam', 'WPRO', '0', '1069', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93070, '2020-09-28', 'VN', 'Viet Nam', 'WPRO', '5', '1074', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93071, '2020-09-29', 'VN', 'Viet Nam', 'WPRO', '3', '1077', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93072, '2020-09-30', 'VN', 'Viet Nam', 'WPRO', '17', '1094', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93073, '2020-10-01', 'VN', 'Viet Nam', 'WPRO', '1', '1095', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93074, '2020-10-02', 'VN', 'Viet Nam', 'WPRO', '0', '1095', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93075, '2020-10-03', 'VN', 'Viet Nam', 'WPRO', '1', '1096', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93076, '2020-10-04', 'VN', 'Viet Nam', 'WPRO', '0', '1096', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93077, '2020-10-05', 'VN', 'Viet Nam', 'WPRO', '0', '1096', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93078, '2020-10-06', 'VN', 'Viet Nam', 'WPRO', '1', '1097', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93079, '2020-10-07', 'VN', 'Viet Nam', 'WPRO', '1', '1098', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93080, '2020-10-08', 'VN', 'Viet Nam', 'WPRO', '1', '1099', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93081, '2020-10-09', 'VN', 'Viet Nam', 'WPRO', '1', '1100', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93082, '2020-10-10', 'VN', 'Viet Nam', 'WPRO', '5', '1105', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93083, '2020-10-11', 'VN', 'Viet Nam', 'WPRO', '2', '1107', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93084, '2020-10-12', 'VN', 'Viet Nam', 'WPRO', '2', '1109', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93085, '2020-10-13', 'VN', 'Viet Nam', 'WPRO', '1', '1110', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93086, '2020-10-14', 'VN', 'Viet Nam', 'WPRO', '3', '1113', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93087, '2020-10-15', 'VN', 'Viet Nam', 'WPRO', '9', '1122', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93088, '2020-10-16', 'VN', 'Viet Nam', 'WPRO', '2', '1124', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93089, '2020-10-17', 'VN', 'Viet Nam', 'WPRO', '0', '1124', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93090, '2020-10-18', 'VN', 'Viet Nam', 'WPRO', '2', '1126', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93091, '2020-10-19', 'VN', 'Viet Nam', 'WPRO', '8', '1134', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93092, '2020-10-20', 'VN', 'Viet Nam', 'WPRO', '6', '1140', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93093, '2020-10-21', 'VN', 'Viet Nam', 'WPRO', '1', '1141', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93094, '2020-10-22', 'VN', 'Viet Nam', 'WPRO', '4', '1145', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93095, '2020-10-23', 'VN', 'Viet Nam', 'WPRO', '3', '1148', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93096, '2020-10-24', 'VN', 'Viet Nam', 'WPRO', '0', '1148', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93097, '2020-10-25', 'VN', 'Viet Nam', 'WPRO', '12', '1160', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93098, '2020-10-26', 'VN', 'Viet Nam', 'WPRO', '8', '1168', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93099, '2020-10-27', 'VN', 'Viet Nam', 'WPRO', '1', '1169', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93100, '2020-10-28', 'VN', 'Viet Nam', 'WPRO', '3', '1172', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93101, '2020-10-29', 'VN', 'Viet Nam', 'WPRO', '1', '1173', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93102, '2020-10-30', 'VN', 'Viet Nam', 'WPRO', '4', '1177', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93103, '2020-10-31', 'VN', 'Viet Nam', 'WPRO', '0', '1177', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93104, '2020-11-01', 'VN', 'Viet Nam', 'WPRO', '3', '1180', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93105, '2020-11-02', 'VN', 'Viet Nam', 'WPRO', '0', '1180', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93106, '2020-11-03', 'VN', 'Viet Nam', 'WPRO', '12', '1192', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93107, '2020-11-04', 'VN', 'Viet Nam', 'WPRO', '11', '1203', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93108, '2020-11-05', 'VN', 'Viet Nam', 'WPRO', '4', '1207', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93109, '2020-11-06', 'VN', 'Viet Nam', 'WPRO', '3', '1210', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93110, '2020-11-07', 'VN', 'Viet Nam', 'WPRO', '3', '1213', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93111, '2020-11-08', 'VN', 'Viet Nam', 'WPRO', '0', '1213', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93112, '2020-11-09', 'VN', 'Viet Nam', 'WPRO', '0', '1213', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93113, '2020-11-10', 'VN', 'Viet Nam', 'WPRO', '3', '1216', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93114, '2020-11-11', 'VN', 'Viet Nam', 'WPRO', '10', '1226', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93115, '2020-11-12', 'VN', 'Viet Nam', 'WPRO', '26', '1252', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93116, '2020-11-13', 'VN', 'Viet Nam', 'WPRO', '1', '1253', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93117, '2020-11-14', 'VN', 'Viet Nam', 'WPRO', '3', '1256', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93118, '2020-11-15', 'VN', 'Viet Nam', 'WPRO', '9', '1265', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93119, '2020-11-16', 'VN', 'Viet Nam', 'WPRO', '16', '1281', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93120, '2020-11-17', 'VN', 'Viet Nam', 'WPRO', '2', '1283', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93121, '2020-11-18', 'VN', 'Viet Nam', 'WPRO', '5', '1288', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93122, '2020-11-19', 'VN', 'Viet Nam', 'WPRO', '12', '1300', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93123, '2020-11-20', 'VN', 'Viet Nam', 'WPRO', '4', '1304', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93124, '2020-11-21', 'VN', 'Viet Nam', 'WPRO', '1', '1305', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93125, '2020-11-22', 'VN', 'Viet Nam', 'WPRO', '1', '1306', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93126, '2020-11-23', 'VN', 'Viet Nam', 'WPRO', '1', '1307', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93127, '2020-11-24', 'VN', 'Viet Nam', 'WPRO', '5', '1312', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93128, '2020-11-25', 'VN', 'Viet Nam', 'WPRO', '4', '1316', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93129, '2020-11-26', 'VN', 'Viet Nam', 'WPRO', '5', '1321', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93130, '2020-11-27', 'VN', 'Viet Nam', 'WPRO', '10', '1331', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93131, '2020-11-28', 'VN', 'Viet Nam', 'WPRO', '8', '1339', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93132, '2020-11-29', 'VN', 'Viet Nam', 'WPRO', '2', '1341', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93133, '2020-11-30', 'VN', 'Viet Nam', 'WPRO', '2', '1343', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93134, '2020-12-01', 'VN', 'Viet Nam', 'WPRO', '4', '1347', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93135, '2020-12-02', 'VN', 'Viet Nam', 'WPRO', '4', '1351', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93136, '2020-12-03', 'VN', 'Viet Nam', 'WPRO', '7', '1358', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93137, '2020-12-04', 'VN', 'Viet Nam', 'WPRO', '3', '1361', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93138, '2020-12-05', 'VN', 'Viet Nam', 'WPRO', '0', '1361', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93139, '2020-12-06', 'VN', 'Viet Nam', 'WPRO', '4', '1365', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93140, '2020-12-07', 'VN', 'Viet Nam', 'WPRO', '1', '1366', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93141, '2020-12-08', 'VN', 'Viet Nam', 'WPRO', '1', '1367', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93142, '2020-12-09', 'VN', 'Viet Nam', 'WPRO', '10', '1377', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93143, '2020-12-10', 'VN', 'Viet Nam', 'WPRO', '4', '1381', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93144, '2020-12-11', 'VN', 'Viet Nam', 'WPRO', '4', '1385', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93145, '2020-12-12', 'VN', 'Viet Nam', 'WPRO', '6', '1391', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93146, '2020-12-13', 'VN', 'Viet Nam', 'WPRO', '4', '1395', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93147, '2020-12-14', 'VN', 'Viet Nam', 'WPRO', '2', '1397', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93148, '2020-12-15', 'VN', 'Viet Nam', 'WPRO', '5', '1402', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93149, '2020-12-16', 'VN', 'Viet Nam', 'WPRO', '3', '1405', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93150, '2020-12-17', 'VN', 'Viet Nam', 'WPRO', '0', '1405', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93151, '2020-12-18', 'VN', 'Viet Nam', 'WPRO', '2', '1407', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93152, '2020-12-19', 'VN', 'Viet Nam', 'WPRO', '3', '1410', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93153, '2020-12-20', 'VN', 'Viet Nam', 'WPRO', '1', '1411', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93154, '2020-12-21', 'VN', 'Viet Nam', 'WPRO', '2', '1413', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93155, '2020-12-22', 'VN', 'Viet Nam', 'WPRO', '1', '1414', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93156, '2020-12-23', 'VN', 'Viet Nam', 'WPRO', '6', '1420', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93157, '2020-12-24', 'VN', 'Viet Nam', 'WPRO', '1', '1421', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93158, '2020-12-25', 'VN', 'Viet Nam', 'WPRO', '12', '1433', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93159, '2020-12-26', 'VN', 'Viet Nam', 'WPRO', '6', '1439', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93160, '2020-12-27', 'VN', 'Viet Nam', 'WPRO', '1', '1440', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93161, '2020-12-28', 'VN', 'Viet Nam', 'WPRO', '1', '1441', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93162, '2020-12-29', 'VN', 'Viet Nam', 'WPRO', '10', '1451', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93163, '2020-12-30', 'VN', 'Viet Nam', 'WPRO', '3', '1454', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93164, '2020-12-31', 'VN', 'Viet Nam', 'WPRO', '2', '1456', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93165, '2021-01-01', 'VN', 'Viet Nam', 'WPRO', '9', '1465', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93166, '2021-01-02', 'VN', 'Viet Nam', 'WPRO', '9', '1474', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93167, '2021-01-03', 'VN', 'Viet Nam', 'WPRO', '8', '1482', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93168, '2021-01-04', 'VN', 'Viet Nam', 'WPRO', '12', '1494', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93169, '2021-01-05', 'VN', 'Viet Nam', 'WPRO', '3', '1497', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93170, '2021-01-06', 'VN', 'Viet Nam', 'WPRO', '7', '1504', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93171, '2021-01-07', 'VN', 'Viet Nam', 'WPRO', '1', '1505', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93172, '2021-01-08', 'VN', 'Viet Nam', 'WPRO', '4', '1509', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93173, '2021-01-09', 'VN', 'Viet Nam', 'WPRO', '3', '1512', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93174, '2021-01-10', 'VN', 'Viet Nam', 'WPRO', '1', '1513', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93175, '2021-01-11', 'VN', 'Viet Nam', 'WPRO', '1', '1514', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93176, '2021-01-12', 'VN', 'Viet Nam', 'WPRO', '1', '1515', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93177, '2021-01-13', 'VN', 'Viet Nam', 'WPRO', '5', '1520', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93178, '2021-01-14', 'VN', 'Viet Nam', 'WPRO', '1', '1521', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93179, '2021-01-15', 'VN', 'Viet Nam', 'WPRO', '10', '1531', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93180, '2021-01-16', 'VN', 'Viet Nam', 'WPRO', '5', '1536', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93181, '2021-01-17', 'VN', 'Viet Nam', 'WPRO', '1', '1537', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93182, '2021-01-18', 'VN', 'Viet Nam', 'WPRO', '0', '1537', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93183, '2021-01-19', 'VN', 'Viet Nam', 'WPRO', '2', '1539', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93184, '2021-01-20', 'VN', 'Viet Nam', 'WPRO', '1', '1540', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93185, '2021-01-21', 'VN', 'Viet Nam', 'WPRO', '4', '1544', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93186, '2021-01-22', 'VN', 'Viet Nam', 'WPRO', '2', '1546', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93187, '2021-01-23', 'VN', 'Viet Nam', 'WPRO', '2', '1548', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93188, '2021-01-24', 'VN', 'Viet Nam', 'WPRO', '0', '1548', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93189, '2021-01-25', 'VN', 'Viet Nam', 'WPRO', '0', '1548', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93190, '2021-01-26', 'VN', 'Viet Nam', 'WPRO', '1', '1549', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93191, '2021-01-27', 'VN', 'Viet Nam', 'WPRO', '2', '1551', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93192, '2021-01-28', 'VN', 'Viet Nam', 'WPRO', '2', '1553', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93193, '2021-01-29', 'VN', 'Viet Nam', 'WPRO', '98', '1651', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93194, '2021-01-30', 'VN', 'Viet Nam', 'WPRO', '88', '1739', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93195, '2021-01-31', 'VN', 'Viet Nam', 'WPRO', '42', '1781', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93196, '2021-02-01', 'VN', 'Viet Nam', 'WPRO', '38', '1819', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93197, '2021-02-02', 'VN', 'Viet Nam', 'WPRO', '32', '1851', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93198, '2021-02-03', 'VN', 'Viet Nam', 'WPRO', '40', '1891', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93199, '2021-02-04', 'VN', 'Viet Nam', 'WPRO', '57', '1948', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93200, '2021-02-05', 'VN', 'Viet Nam', 'WPRO', '9', '1957', '0', '35');
INSERT INTO public.who_global_data_import VALUES (93201, '2020-01-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93202, '2020-01-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93203, '2020-01-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93204, '2020-01-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93205, '2020-01-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93206, '2020-01-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93207, '2020-01-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93208, '2020-01-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93209, '2020-01-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93210, '2020-01-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93211, '2020-01-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93212, '2020-01-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93213, '2020-01-15', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93214, '2020-01-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93215, '2020-01-17', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93216, '2020-01-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93217, '2020-01-19', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93218, '2020-01-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93219, '2020-01-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93220, '2020-01-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93221, '2020-01-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93222, '2020-01-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93223, '2020-01-25', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93224, '2020-01-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93225, '2020-01-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93226, '2020-01-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93227, '2020-01-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93228, '2020-01-30', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93229, '2020-01-31', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93230, '2020-02-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93231, '2020-02-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93232, '2020-02-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93233, '2020-02-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93234, '2020-02-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93235, '2020-02-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93236, '2020-02-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93237, '2020-02-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93238, '2020-02-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93239, '2020-02-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93240, '2020-02-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93241, '2020-02-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93242, '2020-02-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93243, '2020-02-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93244, '2020-02-15', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93245, '2020-02-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93246, '2020-02-17', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93247, '2020-02-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93248, '2020-02-19', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93249, '2020-02-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93250, '2020-02-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93251, '2020-02-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93252, '2020-02-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93253, '2020-02-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93254, '2020-02-25', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93255, '2020-02-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93256, '2020-02-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93257, '2020-02-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93258, '2020-02-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93259, '2020-03-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93260, '2020-03-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93261, '2020-03-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93262, '2020-03-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93263, '2020-03-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93264, '2020-03-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93265, '2020-03-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93266, '2020-03-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93267, '2020-03-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93268, '2020-03-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93269, '2020-03-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93270, '2020-03-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93271, '2020-03-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93272, '2020-03-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93273, '2020-03-15', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93274, '2020-03-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93275, '2020-03-17', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93276, '2020-03-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93277, '2020-03-19', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93278, '2020-03-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93279, '2020-03-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93280, '2020-03-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93281, '2020-03-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93282, '2020-03-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93283, '2020-03-25', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93284, '2020-03-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93285, '2020-03-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93286, '2020-03-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93287, '2020-03-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93288, '2020-03-30', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93289, '2020-03-31', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93290, '2020-04-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93291, '2020-04-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93292, '2020-04-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93293, '2020-04-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93294, '2020-04-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93295, '2020-04-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93296, '2020-04-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93297, '2020-04-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93298, '2020-04-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93299, '2020-04-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93300, '2020-04-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93301, '2020-04-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93302, '2020-04-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93303, '2020-04-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93304, '2020-04-15', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93305, '2020-04-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93306, '2020-04-17', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93307, '2020-04-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93308, '2020-04-19', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93309, '2020-04-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93310, '2020-04-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93311, '2020-04-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93312, '2020-04-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93313, '2020-04-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93314, '2020-04-25', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93315, '2020-04-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93316, '2020-04-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93317, '2020-04-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93318, '2020-04-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93319, '2020-04-30', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93320, '2020-05-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93321, '2020-05-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93322, '2020-05-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93323, '2020-05-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93324, '2020-05-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93325, '2020-05-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93326, '2020-05-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93327, '2020-05-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93328, '2020-05-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93329, '2020-05-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93330, '2020-05-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93331, '2020-05-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93332, '2020-05-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93333, '2020-05-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93334, '2020-05-15', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93335, '2020-05-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93336, '2020-05-17', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93337, '2020-05-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93338, '2020-05-19', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93339, '2020-05-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93340, '2020-05-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93341, '2020-05-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93342, '2020-05-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93343, '2020-05-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93344, '2020-05-25', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93345, '2020-05-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93346, '2020-05-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93347, '2020-05-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93348, '2020-05-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93349, '2020-05-30', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93350, '2020-05-31', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93351, '2020-06-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93352, '2020-06-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93353, '2020-06-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93354, '2020-06-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93355, '2020-06-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93356, '2020-06-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93357, '2020-06-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93358, '2020-06-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93359, '2020-06-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93360, '2020-06-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93361, '2020-06-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93362, '2020-06-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93363, '2020-06-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93364, '2020-06-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93365, '2020-06-15', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93366, '2020-06-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93367, '2020-06-17', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93368, '2020-06-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93369, '2020-06-19', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93370, '2020-06-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93371, '2020-06-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93372, '2020-06-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93373, '2020-06-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93374, '2020-06-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93375, '2020-06-25', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93376, '2020-06-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93377, '2020-06-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93378, '2020-06-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93379, '2020-06-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93380, '2020-06-30', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93381, '2020-07-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93382, '2020-07-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93383, '2020-07-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93384, '2020-07-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93385, '2020-07-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93386, '2020-07-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93387, '2020-07-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93388, '2020-07-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93389, '2020-07-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93390, '2020-07-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93391, '2020-07-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93392, '2020-07-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93393, '2020-07-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93394, '2020-07-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93395, '2020-07-15', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93396, '2020-07-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93397, '2020-07-17', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93398, '2020-07-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93399, '2020-07-19', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93400, '2020-07-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93401, '2020-07-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93402, '2020-07-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93403, '2020-07-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93404, '2020-07-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93405, '2020-07-25', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93406, '2020-07-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93407, '2020-07-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93408, '2020-07-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93409, '2020-07-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93410, '2020-07-30', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93411, '2020-07-31', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93412, '2020-08-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93413, '2020-08-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93414, '2020-08-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93415, '2020-08-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93416, '2020-08-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93417, '2020-08-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93418, '2020-08-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93419, '2020-08-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93420, '2020-08-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93421, '2020-08-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93422, '2020-08-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93423, '2020-08-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93424, '2020-08-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93425, '2020-08-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93426, '2020-08-15', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93427, '2020-08-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93428, '2020-08-17', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93429, '2020-08-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93430, '2020-08-19', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93431, '2020-08-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93432, '2020-08-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93433, '2020-08-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93434, '2020-08-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93435, '2020-08-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93436, '2020-08-25', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93437, '2020-08-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93438, '2020-08-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93439, '2020-08-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93440, '2020-08-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93441, '2020-08-30', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93442, '2020-08-31', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93443, '2020-09-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93444, '2020-09-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93445, '2020-09-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93446, '2020-09-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93447, '2020-09-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93448, '2020-09-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93449, '2020-09-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93450, '2020-09-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93451, '2020-09-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93452, '2020-09-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93453, '2020-09-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93454, '2020-09-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93455, '2020-09-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93456, '2020-09-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93457, '2020-09-15', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93458, '2020-09-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93459, '2020-09-17', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93460, '2020-09-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93461, '2020-09-19', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93462, '2020-09-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93463, '2020-09-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93464, '2020-09-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93465, '2020-09-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93466, '2020-09-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93467, '2020-09-25', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93468, '2020-09-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93469, '2020-09-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93470, '2020-09-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93471, '2020-09-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93472, '2020-09-30', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93473, '2020-10-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93474, '2020-10-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93475, '2020-10-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93476, '2020-10-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93477, '2020-10-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93478, '2020-10-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93479, '2020-10-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93480, '2020-10-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93481, '2020-10-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93482, '2020-10-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93483, '2020-10-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93484, '2020-10-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93485, '2020-10-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93486, '2020-10-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93487, '2020-10-15', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93488, '2020-10-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93489, '2020-10-17', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93490, '2020-10-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93491, '2020-10-19', 'WF', 'Wallis and Futuna', 'WPRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93492, '2020-10-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93493, '2020-10-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93494, '2020-10-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93495, '2020-10-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93496, '2020-10-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93497, '2020-10-25', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93498, '2020-10-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93499, '2020-10-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93500, '2020-10-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93501, '2020-10-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93502, '2020-10-30', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93503, '2020-10-31', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93504, '2020-11-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93505, '2020-11-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93506, '2020-11-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93507, '2020-11-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93508, '2020-11-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93509, '2020-11-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93510, '2020-11-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93511, '2020-11-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93512, '2020-11-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93513, '2020-11-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93514, '2020-11-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93515, '2020-11-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93516, '2020-11-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93517, '2020-11-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93518, '2020-11-15', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93519, '2020-11-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93520, '2020-11-17', 'WF', 'Wallis and Futuna', 'WPRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93521, '2020-11-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93522, '2020-11-19', 'WF', 'Wallis and Futuna', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93523, '2020-11-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93524, '2020-11-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93525, '2020-11-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93526, '2020-11-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93527, '2020-11-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93528, '2020-11-25', 'WF', 'Wallis and Futuna', 'WPRO', '1', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93529, '2020-11-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93530, '2020-11-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93531, '2020-11-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93532, '2020-11-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93533, '2020-11-30', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93534, '2020-12-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93535, '2020-12-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93536, '2020-12-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93537, '2020-12-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93538, '2020-12-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93539, '2020-12-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93540, '2020-12-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93541, '2020-12-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93542, '2020-12-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93543, '2020-12-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93544, '2020-12-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93545, '2020-12-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93546, '2020-12-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93547, '2020-12-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93548, '2020-12-15', 'WF', 'Wallis and Futuna', 'WPRO', '1', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93549, '2020-12-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93550, '2020-12-17', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93551, '2020-12-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93552, '2020-12-19', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93553, '2020-12-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93554, '2020-12-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93555, '2020-12-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93556, '2020-12-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93557, '2020-12-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93558, '2020-12-25', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93559, '2020-12-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93560, '2020-12-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93561, '2020-12-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93562, '2020-12-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93563, '2020-12-30', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93564, '2020-12-31', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93565, '2021-01-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93566, '2021-01-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93567, '2021-01-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93568, '2021-01-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93569, '2021-01-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93570, '2021-01-06', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93571, '2021-01-07', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93572, '2021-01-08', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93573, '2021-01-09', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93574, '2021-01-10', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93575, '2021-01-11', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93576, '2021-01-12', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93577, '2021-01-13', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93578, '2021-01-14', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93579, '2021-01-15', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93580, '2021-01-16', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93581, '2021-01-17', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93582, '2021-01-18', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93583, '2021-01-19', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93584, '2021-01-20', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93585, '2021-01-21', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93586, '2021-01-22', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93587, '2021-01-23', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93588, '2021-01-24', 'WF', 'Wallis and Futuna', 'WPRO', '0', '4', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93589, '2021-01-25', 'WF', 'Wallis and Futuna', 'WPRO', '1', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93590, '2021-01-26', 'WF', 'Wallis and Futuna', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93591, '2021-01-27', 'WF', 'Wallis and Futuna', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93592, '2021-01-28', 'WF', 'Wallis and Futuna', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93593, '2021-01-29', 'WF', 'Wallis and Futuna', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93594, '2021-01-30', 'WF', 'Wallis and Futuna', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93595, '2021-01-31', 'WF', 'Wallis and Futuna', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93596, '2021-02-01', 'WF', 'Wallis and Futuna', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93597, '2021-02-02', 'WF', 'Wallis and Futuna', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93598, '2021-02-03', 'WF', 'Wallis and Futuna', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93599, '2021-02-04', 'WF', 'Wallis and Futuna', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93600, '2021-02-05', 'WF', 'Wallis and Futuna', 'WPRO', '0', '5', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93601, '2020-01-03', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93602, '2020-01-04', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93603, '2020-01-05', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93604, '2020-01-06', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93605, '2020-01-07', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93606, '2020-01-08', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93607, '2020-01-09', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93608, '2020-01-10', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93609, '2020-01-11', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93610, '2020-01-12', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93611, '2020-01-13', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93612, '2020-01-14', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93613, '2020-01-15', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93614, '2020-01-16', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93615, '2020-01-17', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93616, '2020-01-18', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93617, '2020-01-19', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93618, '2020-01-20', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93619, '2020-01-21', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93620, '2020-01-22', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93621, '2020-01-23', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93622, '2020-01-24', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93623, '2020-01-25', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93624, '2020-01-26', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93625, '2020-01-27', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93626, '2020-01-28', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93627, '2020-01-29', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93628, '2020-01-30', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93629, '2020-01-31', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93630, '2020-02-01', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93631, '2020-02-02', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93632, '2020-02-03', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93633, '2020-02-04', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93634, '2020-02-05', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93635, '2020-02-06', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93636, '2020-02-07', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93637, '2020-02-08', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93638, '2020-02-09', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93639, '2020-02-10', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93640, '2020-02-11', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93641, '2020-02-12', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93642, '2020-02-13', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93643, '2020-02-14', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93644, '2020-02-15', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93645, '2020-02-16', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93646, '2020-02-17', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93647, '2020-02-18', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93648, '2020-02-19', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93649, '2020-02-20', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93650, '2020-02-21', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93651, '2020-02-22', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93652, '2020-02-23', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93653, '2020-02-24', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93654, '2020-02-25', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93655, '2020-02-26', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93656, '2020-02-27', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93657, '2020-02-28', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93658, '2020-02-29', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93659, '2020-03-01', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93660, '2020-03-02', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93661, '2020-03-03', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93662, '2020-03-04', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93663, '2020-03-05', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93664, '2020-03-06', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93665, '2020-03-07', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93666, '2020-03-08', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93667, '2020-03-09', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93668, '2020-03-10', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93669, '2020-03-11', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93670, '2020-03-12', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93671, '2020-03-13', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93672, '2020-03-14', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93673, '2020-03-15', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93674, '2020-03-16', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93675, '2020-03-17', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93676, '2020-03-18', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93677, '2020-03-19', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93678, '2020-03-20', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93679, '2020-03-21', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93680, '2020-03-22', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93681, '2020-03-23', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93682, '2020-03-24', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93683, '2020-03-25', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93684, '2020-03-26', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93685, '2020-03-27', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93686, '2020-03-28', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93687, '2020-03-29', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93688, '2020-03-30', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93689, '2020-03-31', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93690, '2020-04-01', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93691, '2020-04-02', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93692, '2020-04-03', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93693, '2020-04-04', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93694, '2020-04-05', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93695, '2020-04-06', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93696, '2020-04-07', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93697, '2020-04-08', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93698, '2020-04-09', 'YE', 'Yemen', 'EMRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93699, '2020-04-10', 'YE', 'Yemen', 'EMRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93700, '2020-04-11', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93701, '2020-04-12', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93702, '2020-04-13', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93703, '2020-04-14', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93704, '2020-04-15', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93705, '2020-04-16', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93706, '2020-04-17', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93707, '2020-04-18', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93708, '2020-04-19', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93709, '2020-04-20', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93710, '2020-04-21', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93711, '2020-04-22', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93712, '2020-04-23', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93713, '2020-04-24', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93714, '2020-04-25', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93715, '2020-04-26', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93716, '2020-04-27', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93717, '2020-04-28', 'YE', 'Yemen', 'EMRO', '0', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (93721, '2020-05-02', 'YE', 'Yemen', 'EMRO', '1', '7', '0', '2');
INSERT INTO public.who_global_data_import VALUES (93722, '2020-05-03', 'YE', 'Yemen', 'EMRO', '3', '10', '0', '2');
INSERT INTO public.who_global_data_import VALUES (93723, '2020-05-04', 'YE', 'Yemen', 'EMRO', '0', '10', '0', '2');
INSERT INTO public.who_global_data_import VALUES (93724, '2020-05-05', 'YE', 'Yemen', 'EMRO', '11', '21', '1', '3');
INSERT INTO public.who_global_data_import VALUES (93725, '2020-05-06', 'YE', 'Yemen', 'EMRO', '5', '26', '2', '5');
INSERT INTO public.who_global_data_import VALUES (93726, '2020-05-07', 'YE', 'Yemen', 'EMRO', '0', '26', '1', '6');
INSERT INTO public.who_global_data_import VALUES (93727, '2020-05-08', 'YE', 'Yemen', 'EMRO', '9', '35', '1', '7');
INSERT INTO public.who_global_data_import VALUES (93728, '2020-05-09', 'YE', 'Yemen', 'EMRO', '1', '36', '1', '8');
INSERT INTO public.who_global_data_import VALUES (93729, '2020-05-10', 'YE', 'Yemen', 'EMRO', '0', '36', '0', '8');
INSERT INTO public.who_global_data_import VALUES (93730, '2020-05-11', 'YE', 'Yemen', 'EMRO', '17', '53', '1', '9');
INSERT INTO public.who_global_data_import VALUES (93731, '2020-05-12', 'YE', 'Yemen', 'EMRO', '14', '67', '2', '11');
INSERT INTO public.who_global_data_import VALUES (93732, '2020-05-13', 'YE', 'Yemen', 'EMRO', '5', '72', '2', '13');
INSERT INTO public.who_global_data_import VALUES (93733, '2020-05-14', 'YE', 'Yemen', 'EMRO', '15', '87', '0', '13');
INSERT INTO public.who_global_data_import VALUES (93734, '2020-05-15', 'YE', 'Yemen', 'EMRO', '21', '108', '3', '16');
INSERT INTO public.who_global_data_import VALUES (93735, '2020-05-16', 'YE', 'Yemen', 'EMRO', '16', '124', '3', '19');
INSERT INTO public.who_global_data_import VALUES (93736, '2020-05-17', 'YE', 'Yemen', 'EMRO', '2', '126', '0', '19');
INSERT INTO public.who_global_data_import VALUES (93737, '2020-05-18', 'YE', 'Yemen', 'EMRO', '6', '132', '2', '21');
INSERT INTO public.who_global_data_import VALUES (93738, '2020-05-19', 'YE', 'Yemen', 'EMRO', '2', '134', '0', '21');
INSERT INTO public.who_global_data_import VALUES (93739, '2020-05-20', 'YE', 'Yemen', 'EMRO', '37', '171', '8', '29');
INSERT INTO public.who_global_data_import VALUES (93740, '2020-05-21', 'YE', 'Yemen', 'EMRO', '13', '184', '1', '30');
INSERT INTO public.who_global_data_import VALUES (93741, '2020-05-22', 'YE', 'Yemen', 'EMRO', '9', '193', '3', '33');
INSERT INTO public.who_global_data_import VALUES (93742, '2020-05-23', 'YE', 'Yemen', 'EMRO', '12', '205', '0', '33');
INSERT INTO public.who_global_data_import VALUES (93743, '2020-05-24', 'YE', 'Yemen', 'EMRO', '7', '212', '6', '39');
INSERT INTO public.who_global_data_import VALUES (93744, '2020-05-25', 'YE', 'Yemen', 'EMRO', '10', '222', '3', '42');
INSERT INTO public.who_global_data_import VALUES (93745, '2020-05-26', 'YE', 'Yemen', 'EMRO', '11', '233', '2', '44');
INSERT INTO public.who_global_data_import VALUES (93746, '2020-05-27', 'YE', 'Yemen', 'EMRO', '16', '249', '5', '49');
INSERT INTO public.who_global_data_import VALUES (93747, '2020-05-28', 'YE', 'Yemen', 'EMRO', '7', '256', '4', '53');
INSERT INTO public.who_global_data_import VALUES (93748, '2020-05-29', 'YE', 'Yemen', 'EMRO', '22', '278', '4', '57');
INSERT INTO public.who_global_data_import VALUES (93749, '2020-05-30', 'YE', 'Yemen', 'EMRO', '5', '283', '8', '65');
INSERT INTO public.who_global_data_import VALUES (93750, '2020-05-31', 'YE', 'Yemen', 'EMRO', '27', '310', '12', '77');
INSERT INTO public.who_global_data_import VALUES (93751, '2020-06-01', 'YE', 'Yemen', 'EMRO', '13', '323', '3', '80');
INSERT INTO public.who_global_data_import VALUES (93752, '2020-06-02', 'YE', 'Yemen', 'EMRO', '31', '354', '4', '84');
INSERT INTO public.who_global_data_import VALUES (93753, '2020-06-03', 'YE', 'Yemen', 'EMRO', '45', '399', '3', '87');
INSERT INTO public.who_global_data_import VALUES (93754, '2020-06-04', 'YE', 'Yemen', 'EMRO', '20', '419', '8', '95');
INSERT INTO public.who_global_data_import VALUES (93755, '2020-06-05', 'YE', 'Yemen', 'EMRO', '34', '453', '8', '103');
INSERT INTO public.who_global_data_import VALUES (93756, '2020-06-06', 'YE', 'Yemen', 'EMRO', '16', '469', '8', '111');
INSERT INTO public.who_global_data_import VALUES (93757, '2020-06-07', 'YE', 'Yemen', 'EMRO', '13', '482', '0', '111');
INSERT INTO public.who_global_data_import VALUES (93758, '2020-06-08', 'YE', 'Yemen', 'EMRO', '2', '484', '1', '112');
INSERT INTO public.who_global_data_import VALUES (93759, '2020-06-09', 'YE', 'Yemen', 'EMRO', '12', '496', '0', '112');
INSERT INTO public.who_global_data_import VALUES (93760, '2020-06-10', 'YE', 'Yemen', 'EMRO', '28', '524', '15', '127');
INSERT INTO public.who_global_data_import VALUES (93761, '2020-06-11', 'YE', 'Yemen', 'EMRO', '36', '560', '2', '129');
INSERT INTO public.who_global_data_import VALUES (93762, '2020-06-12', 'YE', 'Yemen', 'EMRO', '31', '591', '7', '136');
INSERT INTO public.who_global_data_import VALUES (93763, '2020-06-13', 'YE', 'Yemen', 'EMRO', '41', '632', '3', '139');
INSERT INTO public.who_global_data_import VALUES (93764, '2020-06-14', 'YE', 'Yemen', 'EMRO', '73', '705', '21', '160');
INSERT INTO public.who_global_data_import VALUES (93765, '2020-06-15', 'YE', 'Yemen', 'EMRO', '23', '728', '4', '164');
INSERT INTO public.who_global_data_import VALUES (93766, '2020-06-16', 'YE', 'Yemen', 'EMRO', '116', '844', '44', '208');
INSERT INTO public.who_global_data_import VALUES (93767, '2020-06-17', 'YE', 'Yemen', 'EMRO', '41', '885', '6', '214');
INSERT INTO public.who_global_data_import VALUES (93768, '2020-06-18', 'YE', 'Yemen', 'EMRO', '17', '902', '30', '244');
INSERT INTO public.who_global_data_import VALUES (93769, '2020-06-19', 'YE', 'Yemen', 'EMRO', '7', '909', '4', '248');
INSERT INTO public.who_global_data_import VALUES (93770, '2020-06-20', 'YE', 'Yemen', 'EMRO', '10', '919', '3', '251');
INSERT INTO public.who_global_data_import VALUES (93771, '2020-06-21', 'YE', 'Yemen', 'EMRO', '3', '922', '3', '254');
INSERT INTO public.who_global_data_import VALUES (93772, '2020-06-22', 'YE', 'Yemen', 'EMRO', '19', '941', '2', '256');
INSERT INTO public.who_global_data_import VALUES (93773, '2020-06-23', 'YE', 'Yemen', 'EMRO', '26', '967', '1', '257');
INSERT INTO public.who_global_data_import VALUES (93774, '2020-06-24', 'YE', 'Yemen', 'EMRO', '25', '992', '4', '261');
INSERT INTO public.who_global_data_import VALUES (93775, '2020-06-25', 'YE', 'Yemen', 'EMRO', '23', '1015', '13', '274');
INSERT INTO public.who_global_data_import VALUES (93776, '2020-06-26', 'YE', 'Yemen', 'EMRO', '61', '1076', '14', '288');
INSERT INTO public.who_global_data_import VALUES (93777, '2020-06-27', 'YE', 'Yemen', 'EMRO', '13', '1089', '5', '293');
INSERT INTO public.who_global_data_import VALUES (93778, '2020-06-28', 'YE', 'Yemen', 'EMRO', '14', '1103', '3', '296');
INSERT INTO public.who_global_data_import VALUES (93779, '2020-06-29', 'YE', 'Yemen', 'EMRO', '15', '1118', '6', '302');
INSERT INTO public.who_global_data_import VALUES (93780, '2020-06-30', 'YE', 'Yemen', 'EMRO', '10', '1128', '2', '304');
INSERT INTO public.who_global_data_import VALUES (93781, '2020-07-01', 'YE', 'Yemen', 'EMRO', '30', '1158', '8', '312');
INSERT INTO public.who_global_data_import VALUES (93782, '2020-07-02', 'YE', 'Yemen', 'EMRO', '32', '1190', '6', '318');
INSERT INTO public.who_global_data_import VALUES (93783, '2020-07-03', 'YE', 'Yemen', 'EMRO', '31', '1221', '7', '325');
INSERT INTO public.who_global_data_import VALUES (93784, '2020-07-04', 'YE', 'Yemen', 'EMRO', '19', '1240', '10', '335');
INSERT INTO public.who_global_data_import VALUES (93785, '2020-07-05', 'YE', 'Yemen', 'EMRO', '8', '1248', '2', '337');
INSERT INTO public.who_global_data_import VALUES (93786, '2020-07-06', 'YE', 'Yemen', 'EMRO', '17', '1265', '1', '338');
INSERT INTO public.who_global_data_import VALUES (93787, '2020-07-07', 'YE', 'Yemen', 'EMRO', '19', '1284', '7', '345');
INSERT INTO public.who_global_data_import VALUES (93788, '2020-07-08', 'YE', 'Yemen', 'EMRO', '13', '1297', '3', '348');
INSERT INTO public.who_global_data_import VALUES (93789, '2020-07-09', 'YE', 'Yemen', 'EMRO', '21', '1318', '3', '351');
INSERT INTO public.who_global_data_import VALUES (93790, '2020-07-10', 'YE', 'Yemen', 'EMRO', '38', '1356', '10', '361');
INSERT INTO public.who_global_data_import VALUES (93791, '2020-07-11', 'YE', 'Yemen', 'EMRO', '24', '1380', '3', '364');
INSERT INTO public.who_global_data_import VALUES (93792, '2020-07-12', 'YE', 'Yemen', 'EMRO', '9', '1389', '1', '365');
INSERT INTO public.who_global_data_import VALUES (93793, '2020-07-13', 'YE', 'Yemen', 'EMRO', '80', '1469', '53', '418');
INSERT INTO public.who_global_data_import VALUES (93794, '2020-07-14', 'YE', 'Yemen', 'EMRO', '33', '1502', '7', '425');
INSERT INTO public.who_global_data_import VALUES (93795, '2020-07-15', 'YE', 'Yemen', 'EMRO', '18', '1520', '5', '430');
INSERT INTO public.who_global_data_import VALUES (93796, '2020-07-16', 'YE', 'Yemen', 'EMRO', '10', '1530', '4', '434');
INSERT INTO public.who_global_data_import VALUES (93797, '2020-07-17', 'YE', 'Yemen', 'EMRO', '26', '1556', '5', '439');
INSERT INTO public.who_global_data_import VALUES (93798, '2020-07-18', 'YE', 'Yemen', 'EMRO', '24', '1580', '2', '441');
INSERT INTO public.who_global_data_import VALUES (93799, '2020-07-19', 'YE', 'Yemen', 'EMRO', '5', '1585', '3', '444');
INSERT INTO public.who_global_data_import VALUES (93800, '2020-07-20', 'YE', 'Yemen', 'EMRO', '25', '1610', '2', '446');
INSERT INTO public.who_global_data_import VALUES (93801, '2020-07-21', 'YE', 'Yemen', 'EMRO', '13', '1623', '2', '448');
INSERT INTO public.who_global_data_import VALUES (93802, '2020-07-22', 'YE', 'Yemen', 'EMRO', '10', '1633', '9', '457');
INSERT INTO public.who_global_data_import VALUES (93803, '2020-07-23', 'YE', 'Yemen', 'EMRO', '11', '1644', '2', '459');
INSERT INTO public.who_global_data_import VALUES (93804, '2020-07-24', 'YE', 'Yemen', 'EMRO', '14', '1658', '3', '462');
INSERT INTO public.who_global_data_import VALUES (93805, '2020-07-25', 'YE', 'Yemen', 'EMRO', '20', '1678', '8', '470');
INSERT INTO public.who_global_data_import VALUES (93806, '2020-07-26', 'YE', 'Yemen', 'EMRO', '0', '1678', '5', '475');
INSERT INTO public.who_global_data_import VALUES (93807, '2020-07-27', 'YE', 'Yemen', 'EMRO', '7', '1685', '5', '480');
INSERT INTO public.who_global_data_import VALUES (93808, '2020-07-28', 'YE', 'Yemen', 'EMRO', '10', '1695', '4', '484');
INSERT INTO public.who_global_data_import VALUES (93809, '2020-07-29', 'YE', 'Yemen', 'EMRO', '12', '1707', '1', '485');
INSERT INTO public.who_global_data_import VALUES (93810, '2020-07-30', 'YE', 'Yemen', 'EMRO', '8', '1715', '1', '486');
INSERT INTO public.who_global_data_import VALUES (93811, '2020-07-31', 'YE', 'Yemen', 'EMRO', '15', '1730', '2', '488');
INSERT INTO public.who_global_data_import VALUES (93812, '2020-08-01', 'YE', 'Yemen', 'EMRO', '2', '1732', '6', '494');
INSERT INTO public.who_global_data_import VALUES (93813, '2020-08-02', 'YE', 'Yemen', 'EMRO', '2', '1734', '1', '495');
INSERT INTO public.who_global_data_import VALUES (93814, '2020-08-03', 'YE', 'Yemen', 'EMRO', '4', '1738', '3', '498');
INSERT INTO public.who_global_data_import VALUES (93815, '2020-08-04', 'YE', 'Yemen', 'EMRO', '0', '1738', '2', '500');
INSERT INTO public.who_global_data_import VALUES (93816, '2020-08-05', 'YE', 'Yemen', 'EMRO', '26', '1764', '7', '507');
INSERT INTO public.who_global_data_import VALUES (93817, '2020-08-06', 'YE', 'Yemen', 'EMRO', '3', '1767', '2', '509');
INSERT INTO public.who_global_data_import VALUES (93818, '2020-08-07', 'YE', 'Yemen', 'EMRO', '5', '1772', '0', '509');
INSERT INTO public.who_global_data_import VALUES (93819, '2020-08-08', 'YE', 'Yemen', 'EMRO', '28', '1800', '4', '513');
INSERT INTO public.who_global_data_import VALUES (93820, '2020-08-09', 'YE', 'Yemen', 'EMRO', '1', '1801', '0', '513');
INSERT INTO public.who_global_data_import VALUES (93821, '2020-08-10', 'YE', 'Yemen', 'EMRO', '7', '1808', '3', '516');
INSERT INTO public.who_global_data_import VALUES (93822, '2020-08-11', 'YE', 'Yemen', 'EMRO', '22', '1830', '3', '519');
INSERT INTO public.who_global_data_import VALUES (93823, '2020-08-12', 'YE', 'Yemen', 'EMRO', '5', '1835', '5', '524');
INSERT INTO public.who_global_data_import VALUES (93824, '2020-08-13', 'YE', 'Yemen', 'EMRO', '10', '1845', '5', '529');
INSERT INTO public.who_global_data_import VALUES (93825, '2020-08-14', 'YE', 'Yemen', 'EMRO', '6', '1851', '0', '529');
INSERT INTO public.who_global_data_import VALUES (93826, '2020-08-15', 'YE', 'Yemen', 'EMRO', '11', '1862', '0', '529');
INSERT INTO public.who_global_data_import VALUES (93827, '2020-08-16', 'YE', 'Yemen', 'EMRO', '0', '1862', '0', '529');
INSERT INTO public.who_global_data_import VALUES (93828, '2020-08-17', 'YE', 'Yemen', 'EMRO', '11', '1873', '2', '531');
INSERT INTO public.who_global_data_import VALUES (93829, '2020-08-18', 'YE', 'Yemen', 'EMRO', '13', '1886', '5', '536');
INSERT INTO public.who_global_data_import VALUES (93830, '2020-08-19', 'YE', 'Yemen', 'EMRO', '7', '1893', '2', '538');
INSERT INTO public.who_global_data_import VALUES (93831, '2020-08-20', 'YE', 'Yemen', 'EMRO', '3', '1896', '2', '540');
INSERT INTO public.who_global_data_import VALUES (93832, '2020-08-21', 'YE', 'Yemen', 'EMRO', '7', '1903', '2', '542');
INSERT INTO public.who_global_data_import VALUES (93833, '2020-08-22', 'YE', 'Yemen', 'EMRO', '7', '1910', '1', '543');
INSERT INTO public.who_global_data_import VALUES (93834, '2020-08-23', 'YE', 'Yemen', 'EMRO', '1', '1911', '4', '547');
INSERT INTO public.who_global_data_import VALUES (93835, '2020-08-24', 'YE', 'Yemen', 'EMRO', '4', '1915', '7', '554');
INSERT INTO public.who_global_data_import VALUES (93836, '2020-08-25', 'YE', 'Yemen', 'EMRO', '5', '1920', '2', '556');
INSERT INTO public.who_global_data_import VALUES (93837, '2020-08-26', 'YE', 'Yemen', 'EMRO', '8', '1928', '2', '558');
INSERT INTO public.who_global_data_import VALUES (93838, '2020-08-27', 'YE', 'Yemen', 'EMRO', '6', '1934', '3', '561');
INSERT INTO public.who_global_data_import VALUES (93839, '2020-08-28', 'YE', 'Yemen', 'EMRO', '3', '1937', '2', '563');
INSERT INTO public.who_global_data_import VALUES (93840, '2020-08-29', 'YE', 'Yemen', 'EMRO', '10', '1947', '1', '564');
INSERT INTO public.who_global_data_import VALUES (93841, '2020-08-30', 'YE', 'Yemen', 'EMRO', '3', '1950', '0', '564');
INSERT INTO public.who_global_data_import VALUES (93842, '2020-08-31', 'YE', 'Yemen', 'EMRO', '7', '1957', '1', '565');
INSERT INTO public.who_global_data_import VALUES (93843, '2020-09-01', 'YE', 'Yemen', 'EMRO', '5', '1962', '2', '567');
INSERT INTO public.who_global_data_import VALUES (93844, '2020-09-02', 'YE', 'Yemen', 'EMRO', '4', '1966', '4', '571');
INSERT INTO public.who_global_data_import VALUES (93845, '2020-09-03', 'YE', 'Yemen', 'EMRO', '14', '1980', '1', '572');
INSERT INTO public.who_global_data_import VALUES (93846, '2020-09-04', 'YE', 'Yemen', 'EMRO', '3', '1983', '0', '572');
INSERT INTO public.who_global_data_import VALUES (93847, '2020-09-05', 'YE', 'Yemen', 'EMRO', '4', '1987', '1', '573');
INSERT INTO public.who_global_data_import VALUES (93848, '2020-09-06', 'YE', 'Yemen', 'EMRO', '0', '1987', '0', '573');
INSERT INTO public.who_global_data_import VALUES (93849, '2020-09-07', 'YE', 'Yemen', 'EMRO', '4', '1991', '0', '573');
INSERT INTO public.who_global_data_import VALUES (93850, '2020-09-08', 'YE', 'Yemen', 'EMRO', '2', '1993', '1', '574');
INSERT INTO public.who_global_data_import VALUES (93851, '2020-09-09', 'YE', 'Yemen', 'EMRO', '5', '1998', '3', '577');
INSERT INTO public.who_global_data_import VALUES (93852, '2020-09-10', 'YE', 'Yemen', 'EMRO', '5', '2003', '0', '577');
INSERT INTO public.who_global_data_import VALUES (93853, '2020-09-11', 'YE', 'Yemen', 'EMRO', '4', '2007', '4', '581');
INSERT INTO public.who_global_data_import VALUES (93854, '2020-09-12', 'YE', 'Yemen', 'EMRO', '4', '2011', '2', '583');
INSERT INTO public.who_global_data_import VALUES (93855, '2020-09-13', 'YE', 'Yemen', 'EMRO', '2', '2013', '0', '583');
INSERT INTO public.who_global_data_import VALUES (93856, '2020-09-14', 'YE', 'Yemen', 'EMRO', '2', '2015', '1', '584');
INSERT INTO public.who_global_data_import VALUES (93857, '2020-09-15', 'YE', 'Yemen', 'EMRO', '2', '2017', '0', '584');
INSERT INTO public.who_global_data_import VALUES (93858, '2020-09-16', 'YE', 'Yemen', 'EMRO', '3', '2020', '0', '584');
INSERT INTO public.who_global_data_import VALUES (93859, '2020-09-17', 'YE', 'Yemen', 'EMRO', '3', '2023', '0', '584');
INSERT INTO public.who_global_data_import VALUES (93860, '2020-09-18', 'YE', 'Yemen', 'EMRO', '3', '2026', '2', '586');
INSERT INTO public.who_global_data_import VALUES (93861, '2020-09-19', 'YE', 'Yemen', 'EMRO', '2', '2028', '0', '586');
INSERT INTO public.who_global_data_import VALUES (93862, '2020-09-20', 'YE', 'Yemen', 'EMRO', '2', '2030', '0', '586');
INSERT INTO public.who_global_data_import VALUES (93863, '2020-09-21', 'YE', 'Yemen', 'EMRO', '0', '2030', '1', '587');
INSERT INTO public.who_global_data_import VALUES (93864, '2020-09-22', 'YE', 'Yemen', 'EMRO', '2', '2032', '0', '587');
INSERT INTO public.who_global_data_import VALUES (93865, '2020-09-23', 'YE', 'Yemen', 'EMRO', '0', '2032', '0', '587');
INSERT INTO public.who_global_data_import VALUES (93866, '2020-09-24', 'YE', 'Yemen', 'EMRO', '1', '2033', '0', '587');
INSERT INTO public.who_global_data_import VALUES (93867, '2020-09-25', 'YE', 'Yemen', 'EMRO', '0', '2033', '0', '587');
INSERT INTO public.who_global_data_import VALUES (93868, '2020-09-26', 'YE', 'Yemen', 'EMRO', '0', '2033', '1', '588');
INSERT INTO public.who_global_data_import VALUES (93869, '2020-09-27', 'YE', 'Yemen', 'EMRO', '1', '2034', '0', '588');
INSERT INTO public.who_global_data_import VALUES (93870, '2020-09-28', 'YE', 'Yemen', 'EMRO', '0', '2034', '0', '588');
INSERT INTO public.who_global_data_import VALUES (93871, '2020-09-29', 'YE', 'Yemen', 'EMRO', '1', '2035', '0', '588');
INSERT INTO public.who_global_data_import VALUES (93872, '2020-09-30', 'YE', 'Yemen', 'EMRO', '0', '2035', '0', '588');
INSERT INTO public.who_global_data_import VALUES (93873, '2020-10-01', 'YE', 'Yemen', 'EMRO', '3', '2038', '0', '588');
INSERT INTO public.who_global_data_import VALUES (93874, '2020-10-02', 'YE', 'Yemen', 'EMRO', '5', '2043', '0', '588');
INSERT INTO public.who_global_data_import VALUES (93875, '2020-10-03', 'YE', 'Yemen', 'EMRO', '1', '2044', '2', '590');
INSERT INTO public.who_global_data_import VALUES (93876, '2020-10-04', 'YE', 'Yemen', 'EMRO', '1', '2045', '0', '590');
INSERT INTO public.who_global_data_import VALUES (93877, '2020-10-05', 'YE', 'Yemen', 'EMRO', '0', '2045', '2', '592');
INSERT INTO public.who_global_data_import VALUES (93878, '2020-10-06', 'YE', 'Yemen', 'EMRO', '0', '2045', '1', '593');
INSERT INTO public.who_global_data_import VALUES (93879, '2020-10-07', 'YE', 'Yemen', 'EMRO', '6', '2051', '1', '594');
INSERT INTO public.who_global_data_import VALUES (93880, '2020-10-08', 'YE', 'Yemen', 'EMRO', '2', '2053', '0', '594');
INSERT INTO public.who_global_data_import VALUES (93881, '2020-10-09', 'YE', 'Yemen', 'EMRO', '1', '2054', '0', '594');
INSERT INTO public.who_global_data_import VALUES (93882, '2020-10-10', 'YE', 'Yemen', 'EMRO', '1', '2055', '0', '594');
INSERT INTO public.who_global_data_import VALUES (93883, '2020-10-11', 'YE', 'Yemen', 'EMRO', '0', '2055', '2', '596');
INSERT INTO public.who_global_data_import VALUES (93884, '2020-10-12', 'YE', 'Yemen', 'EMRO', '1', '2056', '0', '596');
INSERT INTO public.who_global_data_import VALUES (93885, '2020-10-13', 'YE', 'Yemen', 'EMRO', '0', '2056', '1', '597');
INSERT INTO public.who_global_data_import VALUES (93886, '2020-10-14', 'YE', 'Yemen', 'EMRO', '1', '2057', '0', '597');
INSERT INTO public.who_global_data_import VALUES (93887, '2020-10-15', 'YE', 'Yemen', 'EMRO', '0', '2057', '0', '597');
INSERT INTO public.who_global_data_import VALUES (93888, '2020-10-16', 'YE', 'Yemen', 'EMRO', '0', '2057', '0', '597');
INSERT INTO public.who_global_data_import VALUES (93889, '2020-10-17', 'YE', 'Yemen', 'EMRO', '2', '2059', '0', '597');
INSERT INTO public.who_global_data_import VALUES (93890, '2020-10-18', 'YE', 'Yemen', 'EMRO', '0', '2059', '0', '597');
INSERT INTO public.who_global_data_import VALUES (93891, '2020-10-19', 'YE', 'Yemen', 'EMRO', '1', '2060', '1', '598');
INSERT INTO public.who_global_data_import VALUES (93892, '2020-10-20', 'YE', 'Yemen', 'EMRO', '0', '2060', '0', '598');
INSERT INTO public.who_global_data_import VALUES (93893, '2020-10-21', 'YE', 'Yemen', 'EMRO', '1', '2061', '0', '598');
INSERT INTO public.who_global_data_import VALUES (93894, '2020-10-22', 'YE', 'Yemen', 'EMRO', '0', '2061', '0', '598');
INSERT INTO public.who_global_data_import VALUES (93895, '2020-10-23', 'YE', 'Yemen', 'EMRO', '0', '2061', '0', '598');
INSERT INTO public.who_global_data_import VALUES (93896, '2020-10-24', 'YE', 'Yemen', 'EMRO', '3', '2064', '2', '600');
INSERT INTO public.who_global_data_import VALUES (93897, '2020-10-25', 'YE', 'Yemen', 'EMRO', '0', '2064', '0', '600');
INSERT INTO public.who_global_data_import VALUES (93898, '2020-10-26', 'YE', 'Yemen', 'EMRO', '0', '2064', '0', '600');
INSERT INTO public.who_global_data_import VALUES (93899, '2020-10-27', 'YE', 'Yemen', 'EMRO', '0', '2064', '0', '600');
INSERT INTO public.who_global_data_import VALUES (93900, '2020-10-28', 'YE', 'Yemen', 'EMRO', '0', '2064', '0', '600');
INSERT INTO public.who_global_data_import VALUES (93901, '2020-10-29', 'YE', 'Yemen', 'EMRO', '1', '2065', '0', '600');
INSERT INTO public.who_global_data_import VALUES (93902, '2020-10-30', 'YE', 'Yemen', 'EMRO', '1', '2066', '0', '600');
INSERT INTO public.who_global_data_import VALUES (93903, '2020-10-31', 'YE', 'Yemen', 'EMRO', '0', '2066', '0', '600');
INSERT INTO public.who_global_data_import VALUES (93904, '2020-11-01', 'YE', 'Yemen', 'EMRO', '1', '2067', '0', '600');
INSERT INTO public.who_global_data_import VALUES (93905, '2020-11-02', 'YE', 'Yemen', 'EMRO', '0', '2067', '1', '601');
INSERT INTO public.who_global_data_import VALUES (93906, '2020-11-03', 'YE', 'Yemen', 'EMRO', '0', '2067', '1', '602');
INSERT INTO public.who_global_data_import VALUES (93907, '2020-11-04', 'YE', 'Yemen', 'EMRO', '2', '2069', '0', '602');
INSERT INTO public.who_global_data_import VALUES (93908, '2020-11-05', 'YE', 'Yemen', 'EMRO', '0', '2069', '0', '602');
INSERT INTO public.who_global_data_import VALUES (93909, '2020-11-06', 'YE', 'Yemen', 'EMRO', '1', '2070', '0', '602');
INSERT INTO public.who_global_data_import VALUES (93910, '2020-11-07', 'YE', 'Yemen', 'EMRO', '0', '2070', '0', '602');
INSERT INTO public.who_global_data_import VALUES (93911, '2020-11-08', 'YE', 'Yemen', 'EMRO', '0', '2070', '0', '602');
INSERT INTO public.who_global_data_import VALUES (93912, '2020-11-09', 'YE', 'Yemen', 'EMRO', '0', '2070', '0', '602');
INSERT INTO public.who_global_data_import VALUES (93913, '2020-11-10', 'YE', 'Yemen', 'EMRO', '0', '2070', '0', '602');
INSERT INTO public.who_global_data_import VALUES (93914, '2020-11-11', 'YE', 'Yemen', 'EMRO', '0', '2070', '0', '602');
INSERT INTO public.who_global_data_import VALUES (93915, '2020-11-12', 'YE', 'Yemen', 'EMRO', '0', '2070', '0', '602');
INSERT INTO public.who_global_data_import VALUES (93916, '2020-11-13', 'YE', 'Yemen', 'EMRO', '2', '2072', '1', '603');
INSERT INTO public.who_global_data_import VALUES (93917, '2020-11-14', 'YE', 'Yemen', 'EMRO', '0', '2072', '0', '603');
INSERT INTO public.who_global_data_import VALUES (93918, '2020-11-15', 'YE', 'Yemen', 'EMRO', '0', '2072', '0', '603');
INSERT INTO public.who_global_data_import VALUES (93919, '2020-11-16', 'YE', 'Yemen', 'EMRO', '0', '2072', '1', '604');
INSERT INTO public.who_global_data_import VALUES (93920, '2020-11-17', 'YE', 'Yemen', 'EMRO', '0', '2072', '0', '604');
INSERT INTO public.who_global_data_import VALUES (93921, '2020-11-18', 'YE', 'Yemen', 'EMRO', '0', '2072', '0', '604');
INSERT INTO public.who_global_data_import VALUES (93922, '2020-11-19', 'YE', 'Yemen', 'EMRO', '0', '2072', '0', '604');
INSERT INTO public.who_global_data_import VALUES (93923, '2020-11-20', 'YE', 'Yemen', 'EMRO', '0', '2072', '1', '605');
INSERT INTO public.who_global_data_import VALUES (93924, '2020-11-21', 'YE', 'Yemen', 'EMRO', '1', '2073', '0', '605');
INSERT INTO public.who_global_data_import VALUES (93925, '2020-11-22', 'YE', 'Yemen', 'EMRO', '0', '2073', '0', '605');
INSERT INTO public.who_global_data_import VALUES (93926, '2020-11-23', 'YE', 'Yemen', 'EMRO', '0', '2073', '0', '605');
INSERT INTO public.who_global_data_import VALUES (93927, '2020-11-24', 'YE', 'Yemen', 'EMRO', '3', '2076', '0', '605');
INSERT INTO public.who_global_data_import VALUES (93928, '2020-11-25', 'YE', 'Yemen', 'EMRO', '1', '2077', '0', '605');
INSERT INTO public.who_global_data_import VALUES (93929, '2020-11-26', 'YE', 'Yemen', 'EMRO', '0', '2077', '0', '605');
INSERT INTO public.who_global_data_import VALUES (93930, '2020-11-27', 'YE', 'Yemen', 'EMRO', '1', '2078', '0', '605');
INSERT INTO public.who_global_data_import VALUES (93931, '2020-11-28', 'YE', 'Yemen', 'EMRO', '0', '2078', '0', '605');
INSERT INTO public.who_global_data_import VALUES (93932, '2020-11-29', 'YE', 'Yemen', 'EMRO', '0', '2078', '0', '605');
INSERT INTO public.who_global_data_import VALUES (93933, '2020-11-30', 'YE', 'Yemen', 'EMRO', '3', '2081', '1', '606');
INSERT INTO public.who_global_data_import VALUES (93934, '2020-12-01', 'YE', 'Yemen', 'EMRO', '0', '2081', '0', '606');
INSERT INTO public.who_global_data_import VALUES (93935, '2020-12-02', 'YE', 'Yemen', 'EMRO', '0', '2081', '0', '606');
INSERT INTO public.who_global_data_import VALUES (93936, '2020-12-03', 'YE', 'Yemen', 'EMRO', '0', '2081', '0', '606');
INSERT INTO public.who_global_data_import VALUES (93937, '2020-12-04', 'YE', 'Yemen', 'EMRO', '0', '2081', '1', '607');
INSERT INTO public.who_global_data_import VALUES (93938, '2020-12-05', 'YE', 'Yemen', 'EMRO', '0', '2081', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93939, '2020-12-06', 'YE', 'Yemen', 'EMRO', '0', '2081', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93940, '2020-12-07', 'YE', 'Yemen', 'EMRO', '1', '2082', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93941, '2020-12-08', 'YE', 'Yemen', 'EMRO', '0', '2082', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93942, '2020-12-09', 'YE', 'Yemen', 'EMRO', '1', '2083', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93943, '2020-12-10', 'YE', 'Yemen', 'EMRO', '0', '2083', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93944, '2020-12-11', 'YE', 'Yemen', 'EMRO', '2', '2085', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93945, '2020-12-12', 'YE', 'Yemen', 'EMRO', '1', '2086', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93946, '2020-12-13', 'YE', 'Yemen', 'EMRO', '1', '2087', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93947, '2020-12-14', 'YE', 'Yemen', 'EMRO', '0', '2087', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93948, '2020-12-15', 'YE', 'Yemen', 'EMRO', '1', '2088', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93949, '2020-12-16', 'YE', 'Yemen', 'EMRO', '1', '2089', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93950, '2020-12-17', 'YE', 'Yemen', 'EMRO', '0', '2089', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93951, '2020-12-18', 'YE', 'Yemen', 'EMRO', '2', '2091', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93952, '2020-12-19', 'YE', 'Yemen', 'EMRO', '0', '2091', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93953, '2020-12-20', 'YE', 'Yemen', 'EMRO', '0', '2091', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93954, '2020-12-21', 'YE', 'Yemen', 'EMRO', '0', '2091', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93955, '2020-12-22', 'YE', 'Yemen', 'EMRO', '0', '2091', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93956, '2020-12-23', 'YE', 'Yemen', 'EMRO', '3', '2094', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93957, '2020-12-24', 'YE', 'Yemen', 'EMRO', '1', '2095', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93958, '2020-12-25', 'YE', 'Yemen', 'EMRO', '1', '2096', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93959, '2020-12-26', 'YE', 'Yemen', 'EMRO', '0', '2096', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93960, '2020-12-27', 'YE', 'Yemen', 'EMRO', '0', '2096', '0', '607');
INSERT INTO public.who_global_data_import VALUES (93961, '2020-12-28', 'YE', 'Yemen', 'EMRO', '2', '2098', '1', '608');
INSERT INTO public.who_global_data_import VALUES (93962, '2020-12-29', 'YE', 'Yemen', 'EMRO', '2', '2100', '1', '609');
INSERT INTO public.who_global_data_import VALUES (93963, '2020-12-30', 'YE', 'Yemen', 'EMRO', '0', '2100', '2', '611');
INSERT INTO public.who_global_data_import VALUES (93964, '2020-12-31', 'YE', 'Yemen', 'EMRO', '1', '2101', '0', '611');
INSERT INTO public.who_global_data_import VALUES (93965, '2021-01-01', 'YE', 'Yemen', 'EMRO', '2', '2103', '0', '611');
INSERT INTO public.who_global_data_import VALUES (93966, '2021-01-02', 'YE', 'Yemen', 'EMRO', '2', '2105', '0', '611');
INSERT INTO public.who_global_data_import VALUES (93967, '2021-01-03', 'YE', 'Yemen', 'EMRO', '0', '2105', '0', '611');
INSERT INTO public.who_global_data_import VALUES (93968, '2021-01-04', 'YE', 'Yemen', 'EMRO', '0', '2105', '0', '611');
INSERT INTO public.who_global_data_import VALUES (93969, '2021-01-05', 'YE', 'Yemen', 'EMRO', '0', '2105', '0', '611');
INSERT INTO public.who_global_data_import VALUES (93970, '2021-01-06', 'YE', 'Yemen', 'EMRO', '0', '2105', '0', '611');
INSERT INTO public.who_global_data_import VALUES (93971, '2021-01-07', 'YE', 'Yemen', 'EMRO', '1', '2106', '0', '611');
INSERT INTO public.who_global_data_import VALUES (93972, '2021-01-08', 'YE', 'Yemen', 'EMRO', '2', '2108', '0', '611');
INSERT INTO public.who_global_data_import VALUES (93973, '2021-01-09', 'YE', 'Yemen', 'EMRO', '0', '2108', '0', '611');
INSERT INTO public.who_global_data_import VALUES (93974, '2021-01-10', 'YE', 'Yemen', 'EMRO', '0', '2108', '0', '611');
INSERT INTO public.who_global_data_import VALUES (93975, '2021-01-11', 'YE', 'Yemen', 'EMRO', '0', '2108', '1', '612');
INSERT INTO public.who_global_data_import VALUES (93976, '2021-01-12', 'YE', 'Yemen', 'EMRO', '1', '2109', '1', '613');
INSERT INTO public.who_global_data_import VALUES (93977, '2021-01-13', 'YE', 'Yemen', 'EMRO', '2', '2111', '0', '613');
INSERT INTO public.who_global_data_import VALUES (93978, '2021-01-14', 'YE', 'Yemen', 'EMRO', '2', '2113', '0', '613');
INSERT INTO public.who_global_data_import VALUES (93979, '2021-01-15', 'YE', 'Yemen', 'EMRO', '1', '2114', '0', '613');
INSERT INTO public.who_global_data_import VALUES (93980, '2021-01-16', 'YE', 'Yemen', 'EMRO', '1', '2115', '0', '613');
INSERT INTO public.who_global_data_import VALUES (93981, '2021-01-17', 'YE', 'Yemen', 'EMRO', '1', '2116', '0', '613');
INSERT INTO public.who_global_data_import VALUES (93982, '2021-01-18', 'YE', 'Yemen', 'EMRO', '0', '2116', '0', '613');
INSERT INTO public.who_global_data_import VALUES (93983, '2021-01-19', 'YE', 'Yemen', 'EMRO', '1', '2117', '0', '613');
INSERT INTO public.who_global_data_import VALUES (93984, '2021-01-20', 'YE', 'Yemen', 'EMRO', '2', '2119', '0', '613');
INSERT INTO public.who_global_data_import VALUES (93985, '2021-01-21', 'YE', 'Yemen', 'EMRO', '0', '2119', '0', '613');
INSERT INTO public.who_global_data_import VALUES (93986, '2021-01-22', 'YE', 'Yemen', 'EMRO', '0', '2119', '2', '615');
INSERT INTO public.who_global_data_import VALUES (93987, '2021-01-23', 'YE', 'Yemen', 'EMRO', '3', '2122', '0', '615');
INSERT INTO public.who_global_data_import VALUES (93988, '2021-01-24', 'YE', 'Yemen', 'EMRO', '0', '2122', '1', '616');
INSERT INTO public.who_global_data_import VALUES (93989, '2021-01-25', 'YE', 'Yemen', 'EMRO', '0', '2122', '0', '616');
INSERT INTO public.who_global_data_import VALUES (93990, '2021-01-26', 'YE', 'Yemen', 'EMRO', '0', '2122', '0', '616');
INSERT INTO public.who_global_data_import VALUES (93991, '2021-01-27', 'YE', 'Yemen', 'EMRO', '1', '2123', '0', '616');
INSERT INTO public.who_global_data_import VALUES (93992, '2021-01-28', 'YE', 'Yemen', 'EMRO', '1', '2124', '0', '616');
INSERT INTO public.who_global_data_import VALUES (93993, '2021-01-29', 'YE', 'Yemen', 'EMRO', '0', '2124', '0', '616');
INSERT INTO public.who_global_data_import VALUES (93994, '2021-01-30', 'YE', 'Yemen', 'EMRO', '0', '2124', '0', '616');
INSERT INTO public.who_global_data_import VALUES (93995, '2021-01-31', 'YE', 'Yemen', 'EMRO', '0', '2124', '0', '616');
INSERT INTO public.who_global_data_import VALUES (93996, '2021-02-01', 'YE', 'Yemen', 'EMRO', '1', '2125', '0', '616');
INSERT INTO public.who_global_data_import VALUES (93997, '2021-02-02', 'YE', 'Yemen', 'EMRO', '1', '2126', '0', '616');
INSERT INTO public.who_global_data_import VALUES (93998, '2021-02-03', 'YE', 'Yemen', 'EMRO', '0', '2126', '0', '616');
INSERT INTO public.who_global_data_import VALUES (93999, '2021-02-04', 'YE', 'Yemen', 'EMRO', '0', '2126', '0', '616');
INSERT INTO public.who_global_data_import VALUES (94000, '2021-02-05', 'YE', 'Yemen', 'EMRO', '0', '2126', '0', '616');
INSERT INTO public.who_global_data_import VALUES (94001, '2020-01-03', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94002, '2020-01-04', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94003, '2020-01-05', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94004, '2020-01-06', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94005, '2020-01-07', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94006, '2020-01-08', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94007, '2020-01-09', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94008, '2020-01-10', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94009, '2020-01-11', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94010, '2020-01-12', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94011, '2020-01-13', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94012, '2020-01-14', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94013, '2020-01-15', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94014, '2020-01-16', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94015, '2020-01-17', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94016, '2020-01-18', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94017, '2020-01-19', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94018, '2020-01-20', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94019, '2020-01-21', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94020, '2020-01-22', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94021, '2020-01-23', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94022, '2020-01-24', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94023, '2020-01-25', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94024, '2020-01-26', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94025, '2020-01-27', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94026, '2020-01-28', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94027, '2020-01-29', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94028, '2020-01-30', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94029, '2020-01-31', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94030, '2020-02-01', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94031, '2020-02-02', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94032, '2020-02-03', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94033, '2020-02-04', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94034, '2020-02-05', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94035, '2020-02-06', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94036, '2020-02-07', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94037, '2020-02-08', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94038, '2020-02-09', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94039, '2020-02-10', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94040, '2020-02-11', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94041, '2020-02-12', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94042, '2020-02-13', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94043, '2020-02-14', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94044, '2020-02-15', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94045, '2020-02-16', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94046, '2020-02-17', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94047, '2020-02-18', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94048, '2020-02-19', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94049, '2020-02-20', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94050, '2020-02-21', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94051, '2020-02-22', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94052, '2020-02-23', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94053, '2020-02-24', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94054, '2020-02-25', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94055, '2020-02-26', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94056, '2020-02-27', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94057, '2020-02-28', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94058, '2020-02-29', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94059, '2020-03-01', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94060, '2020-03-02', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94061, '2020-03-03', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94062, '2020-03-04', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94063, '2020-03-05', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94064, '2020-03-06', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94065, '2020-03-07', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94066, '2020-03-08', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94067, '2020-03-09', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94068, '2020-03-10', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94069, '2020-03-11', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94070, '2020-03-12', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94071, '2020-03-13', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94072, '2020-03-14', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94073, '2020-03-15', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94074, '2020-03-16', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94075, '2020-03-17', 'ZM', 'Zambia', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94076, '2020-03-18', 'ZM', 'Zambia', 'AFRO', '6', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94077, '2020-03-19', 'ZM', 'Zambia', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94078, '2020-03-20', 'ZM', 'Zambia', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94079, '2020-03-21', 'ZM', 'Zambia', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94080, '2020-03-22', 'ZM', 'Zambia', 'AFRO', '0', '6', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94081, '2020-03-23', 'ZM', 'Zambia', 'AFRO', '-3', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94082, '2020-03-24', 'ZM', 'Zambia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94083, '2020-03-25', 'ZM', 'Zambia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94084, '2020-03-26', 'ZM', 'Zambia', 'AFRO', '0', '3', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94085, '2020-03-27', 'ZM', 'Zambia', 'AFRO', '10', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94086, '2020-03-28', 'ZM', 'Zambia', 'AFRO', '0', '13', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94087, '2020-03-29', 'ZM', 'Zambia', 'AFRO', '3', '16', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94088, '2020-03-30', 'ZM', 'Zambia', 'AFRO', '19', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94089, '2020-03-31', 'ZM', 'Zambia', 'AFRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94090, '2020-04-01', 'ZM', 'Zambia', 'AFRO', '0', '35', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94091, '2020-04-02', 'ZM', 'Zambia', 'AFRO', '1', '36', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94092, '2020-04-03', 'ZM', 'Zambia', 'AFRO', '3', '39', '1', '1');
INSERT INTO public.who_global_data_import VALUES (94093, '2020-04-04', 'ZM', 'Zambia', 'AFRO', '0', '39', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94094, '2020-04-05', 'ZM', 'Zambia', 'AFRO', '0', '39', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94095, '2020-04-06', 'ZM', 'Zambia', 'AFRO', '0', '39', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94096, '2020-04-07', 'ZM', 'Zambia', 'AFRO', '0', '39', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94097, '2020-04-08', 'ZM', 'Zambia', 'AFRO', '0', '39', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94098, '2020-04-09', 'ZM', 'Zambia', 'AFRO', '0', '39', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94099, '2020-04-10', 'ZM', 'Zambia', 'AFRO', '0', '39', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94100, '2020-04-11', 'ZM', 'Zambia', 'AFRO', '1', '40', '1', '2');
INSERT INTO public.who_global_data_import VALUES (94101, '2020-04-12', 'ZM', 'Zambia', 'AFRO', '0', '40', '0', '2');
INSERT INTO public.who_global_data_import VALUES (94102, '2020-04-13', 'ZM', 'Zambia', 'AFRO', '3', '43', '0', '2');
INSERT INTO public.who_global_data_import VALUES (94103, '2020-04-14', 'ZM', 'Zambia', 'AFRO', '2', '45', '0', '2');
INSERT INTO public.who_global_data_import VALUES (94104, '2020-04-15', 'ZM', 'Zambia', 'AFRO', '0', '45', '0', '2');
INSERT INTO public.who_global_data_import VALUES (94105, '2020-04-16', 'ZM', 'Zambia', 'AFRO', '3', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (94106, '2020-04-17', 'ZM', 'Zambia', 'AFRO', '0', '48', '0', '2');
INSERT INTO public.who_global_data_import VALUES (94107, '2020-04-18', 'ZM', 'Zambia', 'AFRO', '4', '52', '0', '2');
INSERT INTO public.who_global_data_import VALUES (94108, '2020-04-19', 'ZM', 'Zambia', 'AFRO', '5', '57', '0', '2');
INSERT INTO public.who_global_data_import VALUES (94109, '2020-04-20', 'ZM', 'Zambia', 'AFRO', '4', '61', '1', '3');
INSERT INTO public.who_global_data_import VALUES (94110, '2020-04-21', 'ZM', 'Zambia', 'AFRO', '4', '65', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94111, '2020-04-22', 'ZM', 'Zambia', 'AFRO', '5', '70', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94112, '2020-04-23', 'ZM', 'Zambia', 'AFRO', '4', '74', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94113, '2020-04-24', 'ZM', 'Zambia', 'AFRO', '2', '76', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94114, '2020-04-25', 'ZM', 'Zambia', 'AFRO', '8', '84', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94115, '2020-04-26', 'ZM', 'Zambia', 'AFRO', '0', '84', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94116, '2020-04-27', 'ZM', 'Zambia', 'AFRO', '4', '88', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94117, '2020-04-28', 'ZM', 'Zambia', 'AFRO', '1', '89', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94118, '2020-04-29', 'ZM', 'Zambia', 'AFRO', '6', '95', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94119, '2020-04-30', 'ZM', 'Zambia', 'AFRO', '2', '97', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94120, '2020-05-01', 'ZM', 'Zambia', 'AFRO', '9', '106', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94121, '2020-05-02', 'ZM', 'Zambia', 'AFRO', '3', '109', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94122, '2020-05-03', 'ZM', 'Zambia', 'AFRO', '10', '119', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94123, '2020-05-04', 'ZM', 'Zambia', 'AFRO', '5', '124', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94124, '2020-05-05', 'ZM', 'Zambia', 'AFRO', '13', '137', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94125, '2020-05-06', 'ZM', 'Zambia', 'AFRO', '0', '137', '1', '4');
INSERT INTO public.who_global_data_import VALUES (94126, '2020-05-07', 'ZM', 'Zambia', 'AFRO', '2', '139', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94127, '2020-05-08', 'ZM', 'Zambia', 'AFRO', '14', '153', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94128, '2020-05-09', 'ZM', 'Zambia', 'AFRO', '14', '167', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94129, '2020-05-10', 'ZM', 'Zambia', 'AFRO', '85', '252', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94130, '2020-05-11', 'ZM', 'Zambia', 'AFRO', '15', '267', '3', '7');
INSERT INTO public.who_global_data_import VALUES (94131, '2020-05-12', 'ZM', 'Zambia', 'AFRO', '0', '267', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94132, '2020-05-13', 'ZM', 'Zambia', 'AFRO', '174', '441', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94133, '2020-05-14', 'ZM', 'Zambia', 'AFRO', '5', '446', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94134, '2020-05-15', 'ZM', 'Zambia', 'AFRO', '208', '654', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94135, '2020-05-16', 'ZM', 'Zambia', 'AFRO', '14', '668', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94136, '2020-05-17', 'ZM', 'Zambia', 'AFRO', '11', '679', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94137, '2020-05-18', 'ZM', 'Zambia', 'AFRO', '74', '753', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94138, '2020-05-19', 'ZM', 'Zambia', 'AFRO', '8', '761', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94139, '2020-05-20', 'ZM', 'Zambia', 'AFRO', '11', '772', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94140, '2020-05-21', 'ZM', 'Zambia', 'AFRO', '60', '832', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94141, '2020-05-22', 'ZM', 'Zambia', 'AFRO', '34', '866', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94142, '2020-05-23', 'ZM', 'Zambia', 'AFRO', '54', '920', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94143, '2020-05-24', 'ZM', 'Zambia', 'AFRO', '0', '920', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94144, '2020-05-25', 'ZM', 'Zambia', 'AFRO', '0', '920', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94145, '2020-05-26', 'ZM', 'Zambia', 'AFRO', '0', '920', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94146, '2020-05-27', 'ZM', 'Zambia', 'AFRO', '0', '920', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94147, '2020-05-28', 'ZM', 'Zambia', 'AFRO', '137', '1057', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94148, '2020-05-29', 'ZM', 'Zambia', 'AFRO', '0', '1057', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94149, '2020-05-30', 'ZM', 'Zambia', 'AFRO', '0', '1057', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94150, '2020-05-31', 'ZM', 'Zambia', 'AFRO', '0', '1057', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94151, '2020-06-01', 'ZM', 'Zambia', 'AFRO', '0', '1057', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94152, '2020-06-02', 'ZM', 'Zambia', 'AFRO', '32', '1089', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94153, '2020-06-03', 'ZM', 'Zambia', 'AFRO', '0', '1089', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94154, '2020-06-04', 'ZM', 'Zambia', 'AFRO', '0', '1089', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94155, '2020-06-05', 'ZM', 'Zambia', 'AFRO', '22', '1111', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94156, '2020-06-06', 'ZM', 'Zambia', 'AFRO', '0', '1111', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94157, '2020-06-07', 'ZM', 'Zambia', 'AFRO', '43', '1154', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94158, '2020-06-08', 'ZM', 'Zambia', 'AFRO', '0', '1154', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94159, '2020-06-09', 'ZM', 'Zambia', 'AFRO', '46', '1200', '3', '10');
INSERT INTO public.who_global_data_import VALUES (94160, '2020-06-10', 'ZM', 'Zambia', 'AFRO', '0', '1200', '0', '10');
INSERT INTO public.who_global_data_import VALUES (94161, '2020-06-11', 'ZM', 'Zambia', 'AFRO', '52', '1252', '0', '10');
INSERT INTO public.who_global_data_import VALUES (94162, '2020-06-12', 'ZM', 'Zambia', 'AFRO', '0', '1252', '0', '10');
INSERT INTO public.who_global_data_import VALUES (94163, '2020-06-13', 'ZM', 'Zambia', 'AFRO', '69', '1321', '0', '10');
INSERT INTO public.who_global_data_import VALUES (94164, '2020-06-14', 'ZM', 'Zambia', 'AFRO', '36', '1357', '0', '10');
INSERT INTO public.who_global_data_import VALUES (94165, '2020-06-15', 'ZM', 'Zambia', 'AFRO', '1', '1358', '1', '11');
INSERT INTO public.who_global_data_import VALUES (94166, '2020-06-16', 'ZM', 'Zambia', 'AFRO', '24', '1382', '0', '11');
INSERT INTO public.who_global_data_import VALUES (94167, '2020-06-17', 'ZM', 'Zambia', 'AFRO', '23', '1405', '0', '11');
INSERT INTO public.who_global_data_import VALUES (94168, '2020-06-18', 'ZM', 'Zambia', 'AFRO', '7', '1412', '0', '11');
INSERT INTO public.who_global_data_import VALUES (94169, '2020-06-19', 'ZM', 'Zambia', 'AFRO', '4', '1416', '0', '11');
INSERT INTO public.who_global_data_import VALUES (94170, '2020-06-20', 'ZM', 'Zambia', 'AFRO', '14', '1430', '0', '11');
INSERT INTO public.who_global_data_import VALUES (94171, '2020-06-21', 'ZM', 'Zambia', 'AFRO', '0', '1430', '0', '11');
INSERT INTO public.who_global_data_import VALUES (94172, '2020-06-22', 'ZM', 'Zambia', 'AFRO', '0', '1430', '0', '11');
INSERT INTO public.who_global_data_import VALUES (94173, '2020-06-23', 'ZM', 'Zambia', 'AFRO', '0', '1430', '0', '11');
INSERT INTO public.who_global_data_import VALUES (94174, '2020-06-24', 'ZM', 'Zambia', 'AFRO', '47', '1477', '7', '18');
INSERT INTO public.who_global_data_import VALUES (94175, '2020-06-25', 'ZM', 'Zambia', 'AFRO', '12', '1489', '0', '18');
INSERT INTO public.who_global_data_import VALUES (94176, '2020-06-26', 'ZM', 'Zambia', 'AFRO', '8', '1497', '0', '18');
INSERT INTO public.who_global_data_import VALUES (94177, '2020-06-27', 'ZM', 'Zambia', 'AFRO', '34', '1531', '3', '21');
INSERT INTO public.who_global_data_import VALUES (94178, '2020-06-28', 'ZM', 'Zambia', 'AFRO', '0', '1531', '0', '21');
INSERT INTO public.who_global_data_import VALUES (94179, '2020-06-29', 'ZM', 'Zambia', 'AFRO', '0', '1531', '0', '21');
INSERT INTO public.who_global_data_import VALUES (94180, '2020-06-30', 'ZM', 'Zambia', 'AFRO', '37', '1568', '1', '22');
INSERT INTO public.who_global_data_import VALUES (94181, '2020-07-01', 'ZM', 'Zambia', 'AFRO', '26', '1594', '2', '24');
INSERT INTO public.who_global_data_import VALUES (94182, '2020-07-02', 'ZM', 'Zambia', 'AFRO', '38', '1632', '6', '30');
INSERT INTO public.who_global_data_import VALUES (94183, '2020-07-03', 'ZM', 'Zambia', 'AFRO', '0', '1632', '0', '30');
INSERT INTO public.who_global_data_import VALUES (94184, '2020-07-04', 'ZM', 'Zambia', 'AFRO', '0', '1632', '0', '30');
INSERT INTO public.who_global_data_import VALUES (94185, '2020-07-05', 'ZM', 'Zambia', 'AFRO', '0', '1632', '0', '30');
INSERT INTO public.who_global_data_import VALUES (94186, '2020-07-06', 'ZM', 'Zambia', 'AFRO', '0', '1632', '0', '30');
INSERT INTO public.who_global_data_import VALUES (94187, '2020-07-07', 'ZM', 'Zambia', 'AFRO', '0', '1632', '0', '30');
INSERT INTO public.who_global_data_import VALUES (94188, '2020-07-08', 'ZM', 'Zambia', 'AFRO', '263', '1895', '12', '42');
INSERT INTO public.who_global_data_import VALUES (94189, '2020-07-09', 'ZM', 'Zambia', 'AFRO', '0', '1895', '0', '42');
INSERT INTO public.who_global_data_import VALUES (94190, '2020-07-10', 'ZM', 'Zambia', 'AFRO', '0', '1895', '0', '42');
INSERT INTO public.who_global_data_import VALUES (94191, '2020-07-11', 'ZM', 'Zambia', 'AFRO', '0', '1895', '0', '42');
INSERT INTO public.who_global_data_import VALUES (94192, '2020-07-12', 'ZM', 'Zambia', 'AFRO', '0', '1895', '0', '42');
INSERT INTO public.who_global_data_import VALUES (94193, '2020-07-13', 'ZM', 'Zambia', 'AFRO', '0', '1895', '0', '42');
INSERT INTO public.who_global_data_import VALUES (94194, '2020-07-14', 'ZM', 'Zambia', 'AFRO', '388', '2283', '40', '82');
INSERT INTO public.who_global_data_import VALUES (94195, '2020-07-15', 'ZM', 'Zambia', 'AFRO', '0', '2283', '0', '82');
INSERT INTO public.who_global_data_import VALUES (94196, '2020-07-16', 'ZM', 'Zambia', 'AFRO', '0', '2283', '0', '82');
INSERT INTO public.who_global_data_import VALUES (94197, '2020-07-17', 'ZM', 'Zambia', 'AFRO', '0', '2283', '0', '82');
INSERT INTO public.who_global_data_import VALUES (94198, '2020-07-18', 'ZM', 'Zambia', 'AFRO', '527', '2810', '27', '109');
INSERT INTO public.who_global_data_import VALUES (94199, '2020-07-19', 'ZM', 'Zambia', 'AFRO', '170', '2980', '11', '120');
INSERT INTO public.who_global_data_import VALUES (94200, '2020-07-20', 'ZM', 'Zambia', 'AFRO', '0', '2980', '0', '120');
INSERT INTO public.who_global_data_import VALUES (94201, '2020-07-21', 'ZM', 'Zambia', 'AFRO', '346', '3326', '8', '128');
INSERT INTO public.who_global_data_import VALUES (94202, '2020-07-22', 'ZM', 'Zambia', 'AFRO', '0', '3326', '0', '128');
INSERT INTO public.who_global_data_import VALUES (94203, '2020-07-23', 'ZM', 'Zambia', 'AFRO', '257', '3583', '0', '128');
INSERT INTO public.who_global_data_import VALUES (94204, '2020-07-24', 'ZM', 'Zambia', 'AFRO', '0', '3583', '0', '128');
INSERT INTO public.who_global_data_import VALUES (94205, '2020-07-25', 'ZM', 'Zambia', 'AFRO', '270', '3853', '6', '134');
INSERT INTO public.who_global_data_import VALUES (94206, '2020-07-26', 'ZM', 'Zambia', 'AFRO', '475', '4328', '5', '139');
INSERT INTO public.who_global_data_import VALUES (94207, '2020-07-27', 'ZM', 'Zambia', 'AFRO', '153', '4481', '0', '139');
INSERT INTO public.who_global_data_import VALUES (94208, '2020-07-28', 'ZM', 'Zambia', 'AFRO', '71', '4552', '1', '140');
INSERT INTO public.who_global_data_import VALUES (94209, '2020-07-29', 'ZM', 'Zambia', 'AFRO', '450', '5002', '2', '142');
INSERT INTO public.who_global_data_import VALUES (94210, '2020-07-30', 'ZM', 'Zambia', 'AFRO', '247', '5249', '4', '146');
INSERT INTO public.who_global_data_import VALUES (94211, '2020-07-31', 'ZM', 'Zambia', 'AFRO', '306', '5555', '3', '149');
INSERT INTO public.who_global_data_import VALUES (94212, '2020-08-01', 'ZM', 'Zambia', 'AFRO', '408', '5963', '2', '151');
INSERT INTO public.who_global_data_import VALUES (94213, '2020-08-02', 'ZM', 'Zambia', 'AFRO', '265', '6228', '14', '165');
INSERT INTO public.who_global_data_import VALUES (94214, '2020-08-03', 'ZM', 'Zambia', 'AFRO', '119', '6347', '5', '170');
INSERT INTO public.who_global_data_import VALUES (94215, '2020-08-04', 'ZM', 'Zambia', 'AFRO', '233', '6580', '1', '171');
INSERT INTO public.who_global_data_import VALUES (94216, '2020-08-05', 'ZM', 'Zambia', 'AFRO', '0', '6580', '0', '171');
INSERT INTO public.who_global_data_import VALUES (94217, '2020-08-06', 'ZM', 'Zambia', 'AFRO', '442', '7022', '5', '176');
INSERT INTO public.who_global_data_import VALUES (94218, '2020-08-07', 'ZM', 'Zambia', 'AFRO', '142', '7164', '23', '199');
INSERT INTO public.who_global_data_import VALUES (94219, '2020-08-08', 'ZM', 'Zambia', 'AFRO', '0', '7164', '0', '199');
INSERT INTO public.who_global_data_import VALUES (94220, '2020-08-09', 'ZM', 'Zambia', 'AFRO', '739', '7903', '4', '203');
INSERT INTO public.who_global_data_import VALUES (94221, '2020-08-10', 'ZM', 'Zambia', 'AFRO', '182', '8085', '32', '235');
INSERT INTO public.who_global_data_import VALUES (94222, '2020-08-11', 'ZM', 'Zambia', 'AFRO', '125', '8210', '6', '241');
INSERT INTO public.who_global_data_import VALUES (94223, '2020-08-12', 'ZM', 'Zambia', 'AFRO', '65', '8275', '0', '241');
INSERT INTO public.who_global_data_import VALUES (94224, '2020-08-13', 'ZM', 'Zambia', 'AFRO', '226', '8501', '5', '246');
INSERT INTO public.who_global_data_import VALUES (94225, '2020-08-14', 'ZM', 'Zambia', 'AFRO', '162', '8663', '0', '246');
INSERT INTO public.who_global_data_import VALUES (94226, '2020-08-15', 'ZM', 'Zambia', 'AFRO', '358', '9021', '10', '256');
INSERT INTO public.who_global_data_import VALUES (94227, '2020-08-16', 'ZM', 'Zambia', 'AFRO', '165', '9186', '4', '260');
INSERT INTO public.who_global_data_import VALUES (94228, '2020-08-17', 'ZM', 'Zambia', 'AFRO', '157', '9343', '0', '260');
INSERT INTO public.who_global_data_import VALUES (94229, '2020-08-18', 'ZM', 'Zambia', 'AFRO', '493', '9836', '4', '264');
INSERT INTO public.who_global_data_import VALUES (94230, '2020-08-19', 'ZM', 'Zambia', 'AFRO', '145', '9981', '0', '264');
INSERT INTO public.who_global_data_import VALUES (94231, '2020-08-20', 'ZM', 'Zambia', 'AFRO', '237', '10218', '5', '269');
INSERT INTO public.who_global_data_import VALUES (94232, '2020-08-21', 'ZM', 'Zambia', 'AFRO', '154', '10372', '5', '274');
INSERT INTO public.who_global_data_import VALUES (94233, '2020-08-22', 'ZM', 'Zambia', 'AFRO', '255', '10627', '3', '277');
INSERT INTO public.who_global_data_import VALUES (94234, '2020-08-23', 'ZM', 'Zambia', 'AFRO', '0', '10627', '0', '277');
INSERT INTO public.who_global_data_import VALUES (94235, '2020-08-24', 'ZM', 'Zambia', 'AFRO', '455', '11082', '3', '280');
INSERT INTO public.who_global_data_import VALUES (94236, '2020-08-25', 'ZM', 'Zambia', 'AFRO', '66', '11148', '0', '280');
INSERT INTO public.who_global_data_import VALUES (94237, '2020-08-26', 'ZM', 'Zambia', 'AFRO', '0', '11148', '0', '280');
INSERT INTO public.who_global_data_import VALUES (94238, '2020-08-27', 'ZM', 'Zambia', 'AFRO', '228', '11376', '2', '282');
INSERT INTO public.who_global_data_import VALUES (94239, '2020-08-28', 'ZM', 'Zambia', 'AFRO', '225', '11601', '0', '282');
INSERT INTO public.who_global_data_import VALUES (94240, '2020-08-29', 'ZM', 'Zambia', 'AFRO', '178', '11779', '1', '283');
INSERT INTO public.who_global_data_import VALUES (94241, '2020-08-30', 'ZM', 'Zambia', 'AFRO', '123', '11902', '1', '284');
INSERT INTO public.who_global_data_import VALUES (94242, '2020-08-31', 'ZM', 'Zambia', 'AFRO', '123', '12025', '3', '287');
INSERT INTO public.who_global_data_import VALUES (94243, '2020-09-01', 'ZM', 'Zambia', 'AFRO', '72', '12097', '1', '288');
INSERT INTO public.who_global_data_import VALUES (94244, '2020-09-02', 'ZM', 'Zambia', 'AFRO', '284', '12381', '2', '290');
INSERT INTO public.who_global_data_import VALUES (94245, '2020-09-03', 'ZM', 'Zambia', 'AFRO', '34', '12415', '2', '292');
INSERT INTO public.who_global_data_import VALUES (94246, '2020-09-04', 'ZM', 'Zambia', 'AFRO', '108', '12523', '0', '292');
INSERT INTO public.who_global_data_import VALUES (94247, '2020-09-05', 'ZM', 'Zambia', 'AFRO', '116', '12639', '0', '292');
INSERT INTO public.who_global_data_import VALUES (94248, '2020-09-06', 'ZM', 'Zambia', 'AFRO', '70', '12709', '0', '292');
INSERT INTO public.who_global_data_import VALUES (94249, '2020-09-07', 'ZM', 'Zambia', 'AFRO', '67', '12776', '3', '295');
INSERT INTO public.who_global_data_import VALUES (94250, '2020-09-08', 'ZM', 'Zambia', 'AFRO', '60', '12836', '0', '295');
INSERT INTO public.who_global_data_import VALUES (94251, '2020-09-09', 'ZM', 'Zambia', 'AFRO', '116', '12952', '2', '297');
INSERT INTO public.who_global_data_import VALUES (94252, '2020-09-10', 'ZM', 'Zambia', 'AFRO', '160', '13112', '3', '300');
INSERT INTO public.who_global_data_import VALUES (94253, '2020-09-11', 'ZM', 'Zambia', 'AFRO', '102', '13214', '0', '300');
INSERT INTO public.who_global_data_import VALUES (94254, '2020-09-12', 'ZM', 'Zambia', 'AFRO', '109', '13323', '6', '306');
INSERT INTO public.who_global_data_import VALUES (94255, '2020-09-13', 'ZM', 'Zambia', 'AFRO', '143', '13466', '6', '312');
INSERT INTO public.who_global_data_import VALUES (94256, '2020-09-14', 'ZM', 'Zambia', 'AFRO', '73', '13539', '0', '312');
INSERT INTO public.who_global_data_import VALUES (94257, '2020-09-15', 'ZM', 'Zambia', 'AFRO', '181', '13720', '8', '320');
INSERT INTO public.who_global_data_import VALUES (94258, '2020-09-16', 'ZM', 'Zambia', 'AFRO', '99', '13819', '4', '324');
INSERT INTO public.who_global_data_import VALUES (94259, '2020-09-17', 'ZM', 'Zambia', 'AFRO', '68', '13887', '2', '326');
INSERT INTO public.who_global_data_import VALUES (94260, '2020-09-18', 'ZM', 'Zambia', 'AFRO', '41', '13928', '0', '326');
INSERT INTO public.who_global_data_import VALUES (94261, '2020-09-19', 'ZM', 'Zambia', 'AFRO', '96', '14024', '3', '329');
INSERT INTO public.who_global_data_import VALUES (94262, '2020-09-20', 'ZM', 'Zambia', 'AFRO', '0', '14024', '0', '329');
INSERT INTO public.who_global_data_import VALUES (94263, '2020-09-21', 'ZM', 'Zambia', 'AFRO', '107', '14131', '1', '330');
INSERT INTO public.who_global_data_import VALUES (94264, '2020-09-22', 'ZM', 'Zambia', 'AFRO', '44', '14175', '1', '331');
INSERT INTO public.who_global_data_import VALUES (94265, '2020-09-23', 'ZM', 'Zambia', 'AFRO', '214', '14389', '0', '331');
INSERT INTO public.who_global_data_import VALUES (94266, '2020-09-24', 'ZM', 'Zambia', 'AFRO', '54', '14443', '1', '332');
INSERT INTO public.who_global_data_import VALUES (94267, '2020-09-25', 'ZM', 'Zambia', 'AFRO', '48', '14491', '0', '332');
INSERT INTO public.who_global_data_import VALUES (94268, '2020-09-26', 'ZM', 'Zambia', 'AFRO', '24', '14515', '0', '332');
INSERT INTO public.who_global_data_import VALUES (94269, '2020-09-27', 'ZM', 'Zambia', 'AFRO', '97', '14612', '0', '332');
INSERT INTO public.who_global_data_import VALUES (94270, '2020-09-28', 'ZM', 'Zambia', 'AFRO', '29', '14641', '0', '332');
INSERT INTO public.who_global_data_import VALUES (94271, '2020-09-29', 'ZM', 'Zambia', 'AFRO', '19', '14660', '0', '332');
INSERT INTO public.who_global_data_import VALUES (94272, '2020-09-30', 'ZM', 'Zambia', 'AFRO', '55', '14715', '0', '332');
INSERT INTO public.who_global_data_import VALUES (94273, '2020-10-01', 'ZM', 'Zambia', 'AFRO', '44', '14759', '0', '332');
INSERT INTO public.who_global_data_import VALUES (94274, '2020-10-02', 'ZM', 'Zambia', 'AFRO', '43', '14802', '1', '333');
INSERT INTO public.who_global_data_import VALUES (94275, '2020-10-03', 'ZM', 'Zambia', 'AFRO', '28', '14830', '0', '333');
INSERT INTO public.who_global_data_import VALUES (94276, '2020-10-04', 'ZM', 'Zambia', 'AFRO', '0', '14830', '0', '333');
INSERT INTO public.who_global_data_import VALUES (94277, '2020-10-05', 'ZM', 'Zambia', 'AFRO', '222', '15052', '0', '333');
INSERT INTO public.who_global_data_import VALUES (94278, '2020-10-06', 'ZM', 'Zambia', 'AFRO', '37', '15089', '1', '334');
INSERT INTO public.who_global_data_import VALUES (94279, '2020-10-07', 'ZM', 'Zambia', 'AFRO', '81', '15170', '1', '335');
INSERT INTO public.who_global_data_import VALUES (94280, '2020-10-08', 'ZM', 'Zambia', 'AFRO', '54', '15224', '0', '335');
INSERT INTO public.who_global_data_import VALUES (94281, '2020-10-09', 'ZM', 'Zambia', 'AFRO', '77', '15301', '0', '335');
INSERT INTO public.who_global_data_import VALUES (94282, '2020-10-10', 'ZM', 'Zambia', 'AFRO', '38', '15339', '1', '336');
INSERT INTO public.who_global_data_import VALUES (94283, '2020-10-11', 'ZM', 'Zambia', 'AFRO', '76', '15415', '0', '336');
INSERT INTO public.who_global_data_import VALUES (94284, '2020-10-12', 'ZM', 'Zambia', 'AFRO', '43', '15458', '0', '336');
INSERT INTO public.who_global_data_import VALUES (94285, '2020-10-13', 'ZM', 'Zambia', 'AFRO', '91', '15549', '8', '344');
INSERT INTO public.who_global_data_import VALUES (94286, '2020-10-14', 'ZM', 'Zambia', 'AFRO', '0', '15549', '0', '344');
INSERT INTO public.who_global_data_import VALUES (94287, '2020-10-15', 'ZM', 'Zambia', 'AFRO', '67', '15616', '0', '344');
INSERT INTO public.who_global_data_import VALUES (94288, '2020-10-16', 'ZM', 'Zambia', 'AFRO', '43', '15659', '2', '346');
INSERT INTO public.who_global_data_import VALUES (94289, '2020-10-17', 'ZM', 'Zambia', 'AFRO', '0', '15659', '0', '346');
INSERT INTO public.who_global_data_import VALUES (94290, '2020-10-18', 'ZM', 'Zambia', 'AFRO', '130', '15789', '0', '346');
INSERT INTO public.who_global_data_import VALUES (94291, '2020-10-19', 'ZM', 'Zambia', 'AFRO', '64', '15853', '0', '346');
INSERT INTO public.who_global_data_import VALUES (94292, '2020-10-20', 'ZM', 'Zambia', 'AFRO', '44', '15897', '0', '346');
INSERT INTO public.who_global_data_import VALUES (94293, '2020-10-21', 'ZM', 'Zambia', 'AFRO', '85', '15982', '0', '346');
INSERT INTO public.who_global_data_import VALUES (94294, '2020-10-22', 'ZM', 'Zambia', 'AFRO', '18', '16000', '0', '346');
INSERT INTO public.who_global_data_import VALUES (94295, '2020-10-23', 'ZM', 'Zambia', 'AFRO', '35', '16035', '0', '346');
INSERT INTO public.who_global_data_import VALUES (94296, '2020-10-24', 'ZM', 'Zambia', 'AFRO', '60', '16095', '0', '346');
INSERT INTO public.who_global_data_import VALUES (94297, '2020-10-25', 'ZM', 'Zambia', 'AFRO', '22', '16117', '2', '348');
INSERT INTO public.who_global_data_import VALUES (94298, '2020-10-26', 'ZM', 'Zambia', 'AFRO', '0', '16117', '0', '348');
INSERT INTO public.who_global_data_import VALUES (94299, '2020-10-27', 'ZM', 'Zambia', 'AFRO', '83', '16200', '0', '348');
INSERT INTO public.who_global_data_import VALUES (94300, '2020-10-28', 'ZM', 'Zambia', 'AFRO', '0', '16200', '0', '348');
INSERT INTO public.who_global_data_import VALUES (94301, '2020-10-29', 'ZM', 'Zambia', 'AFRO', '0', '16200', '0', '348');
INSERT INTO public.who_global_data_import VALUES (94302, '2020-10-30', 'ZM', 'Zambia', 'AFRO', '125', '16325', '0', '348');
INSERT INTO public.who_global_data_import VALUES (94303, '2020-10-31', 'ZM', 'Zambia', 'AFRO', '90', '16415', '1', '349');
INSERT INTO public.who_global_data_import VALUES (94304, '2020-11-01', 'ZM', 'Zambia', 'AFRO', '17', '16432', '0', '349');
INSERT INTO public.who_global_data_import VALUES (94305, '2020-11-02', 'ZM', 'Zambia', 'AFRO', '48', '16480', '0', '349');
INSERT INTO public.who_global_data_import VALUES (94306, '2020-11-03', 'ZM', 'Zambia', 'AFRO', '63', '16543', '0', '349');
INSERT INTO public.who_global_data_import VALUES (94307, '2020-11-04', 'ZM', 'Zambia', 'AFRO', '118', '16661', '0', '349');
INSERT INTO public.who_global_data_import VALUES (94308, '2020-11-05', 'ZM', 'Zambia', 'AFRO', '37', '16698', '0', '349');
INSERT INTO public.who_global_data_import VALUES (94309, '2020-11-06', 'ZM', 'Zambia', 'AFRO', '72', '16770', '0', '349');
INSERT INTO public.who_global_data_import VALUES (94310, '2020-11-07', 'ZM', 'Zambia', 'AFRO', '49', '16819', '0', '349');
INSERT INTO public.who_global_data_import VALUES (94311, '2020-11-08', 'ZM', 'Zambia', 'AFRO', '89', '16908', '0', '349');
INSERT INTO public.who_global_data_import VALUES (94312, '2020-11-09', 'ZM', 'Zambia', 'AFRO', '46', '16954', '0', '349');
INSERT INTO public.who_global_data_import VALUES (94313, '2020-11-10', 'ZM', 'Zambia', 'AFRO', '17', '16971', '0', '349');
INSERT INTO public.who_global_data_import VALUES (94314, '2020-11-11', 'ZM', 'Zambia', 'AFRO', '26', '16997', '1', '350');
INSERT INTO public.who_global_data_import VALUES (94315, '2020-11-12', 'ZM', 'Zambia', 'AFRO', '39', '17036', '0', '350');
INSERT INTO public.who_global_data_import VALUES (94316, '2020-11-13', 'ZM', 'Zambia', 'AFRO', '20', '17056', '0', '350');
INSERT INTO public.who_global_data_import VALUES (94317, '2020-11-14', 'ZM', 'Zambia', 'AFRO', '37', '17093', '0', '350');
INSERT INTO public.who_global_data_import VALUES (94318, '2020-11-15', 'ZM', 'Zambia', 'AFRO', '4', '17097', '0', '350');
INSERT INTO public.who_global_data_import VALUES (94319, '2020-11-16', 'ZM', 'Zambia', 'AFRO', '26', '17123', '3', '353');
INSERT INTO public.who_global_data_import VALUES (94320, '2020-11-17', 'ZM', 'Zambia', 'AFRO', '64', '17187', '0', '353');
INSERT INTO public.who_global_data_import VALUES (94321, '2020-11-18', 'ZM', 'Zambia', 'AFRO', '56', '17243', '0', '353');
INSERT INTO public.who_global_data_import VALUES (94322, '2020-11-19', 'ZM', 'Zambia', 'AFRO', '37', '17280', '3', '356');
INSERT INTO public.who_global_data_import VALUES (94323, '2020-11-20', 'ZM', 'Zambia', 'AFRO', '70', '17350', '0', '356');
INSERT INTO public.who_global_data_import VALUES (94324, '2020-11-21', 'ZM', 'Zambia', 'AFRO', '23', '17373', '0', '356');
INSERT INTO public.who_global_data_import VALUES (94325, '2020-11-22', 'ZM', 'Zambia', 'AFRO', '21', '17394', '0', '356');
INSERT INTO public.who_global_data_import VALUES (94326, '2020-11-23', 'ZM', 'Zambia', 'AFRO', '30', '17424', '1', '357');
INSERT INTO public.who_global_data_import VALUES (94327, '2020-11-24', 'ZM', 'Zambia', 'AFRO', '30', '17454', '0', '357');
INSERT INTO public.who_global_data_import VALUES (94328, '2020-11-25', 'ZM', 'Zambia', 'AFRO', '12', '17466', '0', '357');
INSERT INTO public.who_global_data_import VALUES (94329, '2020-11-26', 'ZM', 'Zambia', 'AFRO', '69', '17535', '0', '357');
INSERT INTO public.who_global_data_import VALUES (94330, '2020-11-27', 'ZM', 'Zambia', 'AFRO', '18', '17553', '0', '357');
INSERT INTO public.who_global_data_import VALUES (94331, '2020-11-28', 'ZM', 'Zambia', 'AFRO', '16', '17569', '0', '357');
INSERT INTO public.who_global_data_import VALUES (94332, '2020-11-29', 'ZM', 'Zambia', 'AFRO', '20', '17589', '0', '357');
INSERT INTO public.who_global_data_import VALUES (94333, '2020-11-30', 'ZM', 'Zambia', 'AFRO', '19', '17608', '0', '357');
INSERT INTO public.who_global_data_import VALUES (94334, '2020-12-01', 'ZM', 'Zambia', 'AFRO', '39', '17647', '0', '357');
INSERT INTO public.who_global_data_import VALUES (94335, '2020-12-02', 'ZM', 'Zambia', 'AFRO', '18', '17665', '0', '357');
INSERT INTO public.who_global_data_import VALUES (94336, '2020-12-03', 'ZM', 'Zambia', 'AFRO', '35', '17700', '0', '357');
INSERT INTO public.who_global_data_import VALUES (94337, '2020-12-04', 'ZM', 'Zambia', 'AFRO', '30', '17730', '0', '357');
INSERT INTO public.who_global_data_import VALUES (94338, '2020-12-05', 'ZM', 'Zambia', 'AFRO', '127', '17857', '7', '364');
INSERT INTO public.who_global_data_import VALUES (94339, '2020-12-06', 'ZM', 'Zambia', 'AFRO', '41', '17898', '0', '364');
INSERT INTO public.who_global_data_import VALUES (94340, '2020-12-07', 'ZM', 'Zambia', 'AFRO', '18', '17916', '0', '364');
INSERT INTO public.who_global_data_import VALUES (94341, '2020-12-08', 'ZM', 'Zambia', 'AFRO', '15', '17931', '0', '364');
INSERT INTO public.who_global_data_import VALUES (94342, '2020-12-09', 'ZM', 'Zambia', 'AFRO', '0', '17931', '0', '364');
INSERT INTO public.who_global_data_import VALUES (94343, '2020-12-10', 'ZM', 'Zambia', 'AFRO', '131', '18062', '0', '364');
INSERT INTO public.who_global_data_import VALUES (94344, '2020-12-11', 'ZM', 'Zambia', 'AFRO', '29', '18091', '0', '364');
INSERT INTO public.who_global_data_import VALUES (94345, '2020-12-12', 'ZM', 'Zambia', 'AFRO', '0', '18091', '0', '364');
INSERT INTO public.who_global_data_import VALUES (94346, '2020-12-13', 'ZM', 'Zambia', 'AFRO', '0', '18091', '0', '364');
INSERT INTO public.who_global_data_import VALUES (94347, '2020-12-14', 'ZM', 'Zambia', 'AFRO', '183', '18274', '3', '367');
INSERT INTO public.who_global_data_import VALUES (94348, '2020-12-15', 'ZM', 'Zambia', 'AFRO', '48', '18322', '0', '367');
INSERT INTO public.who_global_data_import VALUES (94349, '2020-12-16', 'ZM', 'Zambia', 'AFRO', '106', '18428', '1', '368');
INSERT INTO public.who_global_data_import VALUES (94350, '2020-12-17', 'ZM', 'Zambia', 'AFRO', '0', '18428', '0', '368');
INSERT INTO public.who_global_data_import VALUES (94351, '2020-12-18', 'ZM', 'Zambia', 'AFRO', '76', '18504', '1', '369');
INSERT INTO public.who_global_data_import VALUES (94352, '2020-12-19', 'ZM', 'Zambia', 'AFRO', '72', '18576', '4', '373');
INSERT INTO public.who_global_data_import VALUES (94353, '2020-12-20', 'ZM', 'Zambia', 'AFRO', '44', '18620', '0', '373');
INSERT INTO public.who_global_data_import VALUES (94354, '2020-12-21', 'ZM', 'Zambia', 'AFRO', '96', '18716', '0', '373');
INSERT INTO public.who_global_data_import VALUES (94355, '2020-12-22', 'ZM', 'Zambia', 'AFRO', '52', '18768', '2', '375');
INSERT INTO public.who_global_data_import VALUES (94356, '2020-12-23', 'ZM', 'Zambia', 'AFRO', '113', '18881', '4', '379');
INSERT INTO public.who_global_data_import VALUES (94357, '2020-12-24', 'ZM', 'Zambia', 'AFRO', '0', '18881', '0', '379');
INSERT INTO public.who_global_data_import VALUES (94358, '2020-12-25', 'ZM', 'Zambia', 'AFRO', '353', '19234', '2', '381');
INSERT INTO public.who_global_data_import VALUES (94359, '2020-12-26', 'ZM', 'Zambia', 'AFRO', '337', '19571', '0', '381');
INSERT INTO public.who_global_data_import VALUES (94360, '2020-12-27', 'ZM', 'Zambia', 'AFRO', '100', '19671', '1', '382');
INSERT INTO public.who_global_data_import VALUES (94361, '2020-12-28', 'ZM', 'Zambia', 'AFRO', '0', '19671', '0', '382');
INSERT INTO public.who_global_data_import VALUES (94362, '2020-12-29', 'ZM', 'Zambia', 'AFRO', '272', '19943', '2', '384');
INSERT INTO public.who_global_data_import VALUES (94363, '2020-12-30', 'ZM', 'Zambia', 'AFRO', '0', '19943', '0', '384');
INSERT INTO public.who_global_data_import VALUES (94364, '2020-12-31', 'ZM', 'Zambia', 'AFRO', '519', '20462', '2', '386');
INSERT INTO public.who_global_data_import VALUES (94365, '2021-01-01', 'ZM', 'Zambia', 'AFRO', '263', '20725', '2', '388');
INSERT INTO public.who_global_data_import VALUES (94366, '2021-01-02', 'ZM', 'Zambia', 'AFRO', '0', '20725', '0', '388');
INSERT INTO public.who_global_data_import VALUES (94367, '2021-01-03', 'ZM', 'Zambia', 'AFRO', '505', '21230', '4', '392');
INSERT INTO public.who_global_data_import VALUES (94368, '2021-01-04', 'ZM', 'Zambia', 'AFRO', '353', '21583', '2', '394');
INSERT INTO public.who_global_data_import VALUES (94369, '2021-01-05', 'ZM', 'Zambia', 'AFRO', '410', '21993', '4', '398');
INSERT INTO public.who_global_data_import VALUES (94370, '2021-01-06', 'ZM', 'Zambia', 'AFRO', '652', '22645', '14', '412');
INSERT INTO public.who_global_data_import VALUES (94371, '2021-01-07', 'ZM', 'Zambia', 'AFRO', '850', '23495', '5', '417');
INSERT INTO public.who_global_data_import VALUES (94372, '2021-01-08', 'ZM', 'Zambia', 'AFRO', '802', '24297', '6', '423');
INSERT INTO public.who_global_data_import VALUES (94373, '2021-01-09', 'ZM', 'Zambia', 'AFRO', '1029', '25326', '18', '441');
INSERT INTO public.who_global_data_import VALUES (94374, '2021-01-10', 'ZM', 'Zambia', 'AFRO', '1241', '26567', '23', '464');
INSERT INTO public.who_global_data_import VALUES (94375, '2021-01-11', 'ZM', 'Zambia', 'AFRO', '1161', '27728', '5', '469');
INSERT INTO public.who_global_data_import VALUES (94376, '2021-01-12', 'ZM', 'Zambia', 'AFRO', '868', '28596', '2', '471');
INSERT INTO public.who_global_data_import VALUES (94377, '2021-01-13', 'ZM', 'Zambia', 'AFRO', '1161', '29757', '24', '495');
INSERT INTO public.who_global_data_import VALUES (94378, '2021-01-14', 'ZM', 'Zambia', 'AFRO', '1343', '31100', '14', '509');
INSERT INTO public.who_global_data_import VALUES (94379, '2021-01-15', 'ZM', 'Zambia', 'AFRO', '1700', '32800', '5', '514');
INSERT INTO public.who_global_data_import VALUES (94380, '2021-01-16', 'ZM', 'Zambia', 'AFRO', '1478', '34278', '13', '527');
INSERT INTO public.who_global_data_import VALUES (94381, '2021-01-17', 'ZM', 'Zambia', 'AFRO', '1796', '36074', '5', '532');
INSERT INTO public.who_global_data_import VALUES (94382, '2021-01-18', 'ZM', 'Zambia', 'AFRO', '1531', '37605', '14', '546');
INSERT INTO public.who_global_data_import VALUES (94383, '2021-01-19', 'ZM', 'Zambia', 'AFRO', '602', '38207', '13', '559');
INSERT INTO public.who_global_data_import VALUES (94384, '2021-01-20', 'ZM', 'Zambia', 'AFRO', '1308', '39515', '19', '578');
INSERT INTO public.who_global_data_import VALUES (94385, '2021-01-21', 'ZM', 'Zambia', 'AFRO', '1434', '40949', '7', '585');
INSERT INTO public.who_global_data_import VALUES (94386, '2021-01-22', 'ZM', 'Zambia', 'AFRO', '1264', '42213', '12', '597');
INSERT INTO public.who_global_data_import VALUES (94387, '2021-01-23', 'ZM', 'Zambia', 'AFRO', '1120', '43333', '13', '610');
INSERT INTO public.who_global_data_import VALUES (94388, '2021-01-24', 'ZM', 'Zambia', 'AFRO', '1259', '44592', '17', '627');
INSERT INTO public.who_global_data_import VALUES (94389, '2021-01-25', 'ZM', 'Zambia', 'AFRO', '745', '45337', '12', '639');
INSERT INTO public.who_global_data_import VALUES (94390, '2021-01-26', 'ZM', 'Zambia', 'AFRO', '809', '46146', '21', '660');
INSERT INTO public.who_global_data_import VALUES (94391, '2021-01-27', 'ZM', 'Zambia', 'AFRO', '1476', '47622', '12', '672');
INSERT INTO public.who_global_data_import VALUES (94392, '2021-01-28', 'ZM', 'Zambia', 'AFRO', '1289', '48911', '16', '688');
INSERT INTO public.who_global_data_import VALUES (94393, '2021-01-29', 'ZM', 'Zambia', 'AFRO', '1408', '50319', '17', '705');
INSERT INTO public.who_global_data_import VALUES (94394, '2021-01-30', 'ZM', 'Zambia', 'AFRO', '1305', '51624', '23', '728');
INSERT INTO public.who_global_data_import VALUES (94395, '2021-01-31', 'ZM', 'Zambia', 'AFRO', '1728', '53352', '17', '745');
INSERT INTO public.who_global_data_import VALUES (94396, '2021-02-01', 'ZM', 'Zambia', 'AFRO', '865', '54217', '18', '763');
INSERT INTO public.who_global_data_import VALUES (94397, '2021-02-02', 'ZM', 'Zambia', 'AFRO', '825', '55042', '17', '780');
INSERT INTO public.who_global_data_import VALUES (94398, '2021-02-03', 'ZM', 'Zambia', 'AFRO', '1191', '56233', '14', '794');
INSERT INTO public.who_global_data_import VALUES (94399, '2021-02-04', 'ZM', 'Zambia', 'AFRO', '1256', '57489', '10', '804');
INSERT INTO public.who_global_data_import VALUES (94400, '2021-02-05', 'ZM', 'Zambia', 'AFRO', '1514', '59003', '8', '812');
INSERT INTO public.who_global_data_import VALUES (94401, '2020-01-03', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94402, '2020-01-04', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94403, '2020-01-05', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94404, '2020-01-06', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94405, '2020-01-07', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94406, '2020-01-08', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94407, '2020-01-09', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94408, '2020-01-10', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94409, '2020-01-11', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94410, '2020-01-12', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94411, '2020-01-13', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94412, '2020-01-14', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94413, '2020-01-15', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94414, '2020-01-16', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94415, '2020-01-17', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94416, '2020-01-18', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94417, '2020-01-19', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94418, '2020-01-20', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94419, '2020-01-21', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94420, '2020-01-22', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94421, '2020-01-23', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94422, '2020-01-24', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94423, '2020-01-25', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94424, '2020-01-26', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94425, '2020-01-27', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94426, '2020-01-28', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94427, '2020-01-29', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94428, '2020-01-30', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94429, '2020-01-31', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94430, '2020-02-01', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94431, '2020-02-02', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94432, '2020-02-03', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94433, '2020-02-04', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94434, '2020-02-05', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94435, '2020-02-06', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94436, '2020-02-07', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94437, '2020-02-08', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94438, '2020-02-09', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94439, '2020-02-10', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94440, '2020-02-11', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94441, '2020-02-12', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94442, '2020-02-13', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94443, '2020-02-14', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94444, '2020-02-15', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94445, '2020-02-16', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94446, '2020-02-17', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94447, '2020-02-18', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94448, '2020-02-19', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94449, '2020-02-20', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94450, '2020-02-21', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94451, '2020-02-22', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94452, '2020-02-23', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94453, '2020-02-24', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94454, '2020-02-25', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94455, '2020-02-26', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94456, '2020-02-27', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94457, '2020-02-28', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94458, '2020-02-29', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94459, '2020-03-01', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94460, '2020-03-02', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94461, '2020-03-03', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94462, '2020-03-04', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94463, '2020-03-05', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94464, '2020-03-06', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94465, '2020-03-07', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94466, '2020-03-08', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94467, '2020-03-09', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94468, '2020-03-10', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94469, '2020-03-11', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94470, '2020-03-12', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94471, '2020-03-13', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94472, '2020-03-14', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94473, '2020-03-15', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94474, '2020-03-16', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94475, '2020-03-17', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94476, '2020-03-18', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94477, '2020-03-19', 'ZW', 'Zimbabwe', 'AFRO', '0', '0', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94478, '2020-03-20', 'ZW', 'Zimbabwe', 'AFRO', '1', '1', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94479, '2020-03-21', 'ZW', 'Zimbabwe', 'AFRO', '1', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94480, '2020-03-22', 'ZW', 'Zimbabwe', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94481, '2020-03-23', 'ZW', 'Zimbabwe', 'AFRO', '0', '2', '0', '0');
INSERT INTO public.who_global_data_import VALUES (94482, '2020-03-24', 'ZW', 'Zimbabwe', 'AFRO', '0', '2', '1', '1');
INSERT INTO public.who_global_data_import VALUES (94483, '2020-03-25', 'ZW', 'Zimbabwe', 'AFRO', '0', '2', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94484, '2020-03-26', 'ZW', 'Zimbabwe', 'AFRO', '0', '2', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94485, '2020-03-27', 'ZW', 'Zimbabwe', 'AFRO', '3', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94486, '2020-03-28', 'ZW', 'Zimbabwe', 'AFRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94487, '2020-03-29', 'ZW', 'Zimbabwe', 'AFRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94488, '2020-03-30', 'ZW', 'Zimbabwe', 'AFRO', '0', '5', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94489, '2020-03-31', 'ZW', 'Zimbabwe', 'AFRO', '3', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94490, '2020-04-01', 'ZW', 'Zimbabwe', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94491, '2020-04-02', 'ZW', 'Zimbabwe', 'AFRO', '0', '8', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94492, '2020-04-03', 'ZW', 'Zimbabwe', 'AFRO', '1', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94493, '2020-04-04', 'ZW', 'Zimbabwe', 'AFRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94494, '2020-04-05', 'ZW', 'Zimbabwe', 'AFRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94495, '2020-04-06', 'ZW', 'Zimbabwe', 'AFRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94496, '2020-04-07', 'ZW', 'Zimbabwe', 'AFRO', '0', '9', '0', '1');
INSERT INTO public.who_global_data_import VALUES (94497, '2020-04-08', 'ZW', 'Zimbabwe', 'AFRO', '2', '11', '1', '2');
INSERT INTO public.who_global_data_import VALUES (94498, '2020-04-09', 'ZW', 'Zimbabwe', 'AFRO', '0', '11', '1', '3');
INSERT INTO public.who_global_data_import VALUES (94499, '2020-04-10', 'ZW', 'Zimbabwe', 'AFRO', '0', '11', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94500, '2020-04-11', 'ZW', 'Zimbabwe', 'AFRO', '0', '11', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94501, '2020-04-12', 'ZW', 'Zimbabwe', 'AFRO', '2', '13', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94502, '2020-04-13', 'ZW', 'Zimbabwe', 'AFRO', '1', '14', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94503, '2020-04-14', 'ZW', 'Zimbabwe', 'AFRO', '3', '17', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94504, '2020-04-15', 'ZW', 'Zimbabwe', 'AFRO', '1', '18', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94505, '2020-04-16', 'ZW', 'Zimbabwe', 'AFRO', '5', '23', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94506, '2020-04-17', 'ZW', 'Zimbabwe', 'AFRO', '0', '23', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94507, '2020-04-18', 'ZW', 'Zimbabwe', 'AFRO', '1', '24', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94508, '2020-04-19', 'ZW', 'Zimbabwe', 'AFRO', '1', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94509, '2020-04-20', 'ZW', 'Zimbabwe', 'AFRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94510, '2020-04-21', 'ZW', 'Zimbabwe', 'AFRO', '0', '25', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94511, '2020-04-22', 'ZW', 'Zimbabwe', 'AFRO', '3', '28', '0', '3');
INSERT INTO public.who_global_data_import VALUES (94512, '2020-04-23', 'ZW', 'Zimbabwe', 'AFRO', '0', '28', '1', '4');
INSERT INTO public.who_global_data_import VALUES (94513, '2020-04-24', 'ZW', 'Zimbabwe', 'AFRO', '0', '28', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94514, '2020-04-25', 'ZW', 'Zimbabwe', 'AFRO', '1', '29', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94515, '2020-04-26', 'ZW', 'Zimbabwe', 'AFRO', '2', '31', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94516, '2020-04-27', 'ZW', 'Zimbabwe', 'AFRO', '0', '31', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94517, '2020-04-28', 'ZW', 'Zimbabwe', 'AFRO', '0', '31', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94518, '2020-04-29', 'ZW', 'Zimbabwe', 'AFRO', '1', '32', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94519, '2020-04-30', 'ZW', 'Zimbabwe', 'AFRO', '0', '32', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94520, '2020-05-01', 'ZW', 'Zimbabwe', 'AFRO', '0', '32', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94521, '2020-05-02', 'ZW', 'Zimbabwe', 'AFRO', '2', '34', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94522, '2020-05-03', 'ZW', 'Zimbabwe', 'AFRO', '0', '34', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94523, '2020-05-04', 'ZW', 'Zimbabwe', 'AFRO', '0', '34', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94524, '2020-05-05', 'ZW', 'Zimbabwe', 'AFRO', '0', '34', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94525, '2020-05-06', 'ZW', 'Zimbabwe', 'AFRO', '0', '34', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94526, '2020-05-07', 'ZW', 'Zimbabwe', 'AFRO', '0', '34', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94527, '2020-05-08', 'ZW', 'Zimbabwe', 'AFRO', '0', '34', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94528, '2020-05-09', 'ZW', 'Zimbabwe', 'AFRO', '0', '34', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94529, '2020-05-10', 'ZW', 'Zimbabwe', 'AFRO', '1', '35', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94530, '2020-05-11', 'ZW', 'Zimbabwe', 'AFRO', '1', '36', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94531, '2020-05-12', 'ZW', 'Zimbabwe', 'AFRO', '0', '36', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94532, '2020-05-13', 'ZW', 'Zimbabwe', 'AFRO', '1', '37', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94533, '2020-05-14', 'ZW', 'Zimbabwe', 'AFRO', '0', '37', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94534, '2020-05-15', 'ZW', 'Zimbabwe', 'AFRO', '0', '37', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94535, '2020-05-16', 'ZW', 'Zimbabwe', 'AFRO', '5', '42', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94536, '2020-05-17', 'ZW', 'Zimbabwe', 'AFRO', '2', '44', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94537, '2020-05-18', 'ZW', 'Zimbabwe', 'AFRO', '0', '44', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94538, '2020-05-19', 'ZW', 'Zimbabwe', 'AFRO', '2', '46', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94539, '2020-05-20', 'ZW', 'Zimbabwe', 'AFRO', '0', '46', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94540, '2020-05-21', 'ZW', 'Zimbabwe', 'AFRO', '2', '48', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94541, '2020-05-22', 'ZW', 'Zimbabwe', 'AFRO', '3', '51', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94542, '2020-05-23', 'ZW', 'Zimbabwe', 'AFRO', '0', '51', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94543, '2020-05-24', 'ZW', 'Zimbabwe', 'AFRO', '5', '56', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94544, '2020-05-25', 'ZW', 'Zimbabwe', 'AFRO', '0', '56', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94545, '2020-05-26', 'ZW', 'Zimbabwe', 'AFRO', '0', '56', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94546, '2020-05-27', 'ZW', 'Zimbabwe', 'AFRO', '0', '56', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94547, '2020-05-28', 'ZW', 'Zimbabwe', 'AFRO', '76', '132', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94548, '2020-05-29', 'ZW', 'Zimbabwe', 'AFRO', '0', '132', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94549, '2020-05-30', 'ZW', 'Zimbabwe', 'AFRO', '17', '149', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94550, '2020-05-31', 'ZW', 'Zimbabwe', 'AFRO', '25', '174', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94551, '2020-06-01', 'ZW', 'Zimbabwe', 'AFRO', '4', '178', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94552, '2020-06-02', 'ZW', 'Zimbabwe', 'AFRO', '0', '178', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94553, '2020-06-03', 'ZW', 'Zimbabwe', 'AFRO', '28', '206', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94554, '2020-06-04', 'ZW', 'Zimbabwe', 'AFRO', '16', '222', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94555, '2020-06-05', 'ZW', 'Zimbabwe', 'AFRO', '0', '222', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94556, '2020-06-06', 'ZW', 'Zimbabwe', 'AFRO', '43', '265', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94557, '2020-06-07', 'ZW', 'Zimbabwe', 'AFRO', '14', '279', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94558, '2020-06-08', 'ZW', 'Zimbabwe', 'AFRO', '0', '279', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94559, '2020-06-09', 'ZW', 'Zimbabwe', 'AFRO', '8', '287', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94560, '2020-06-10', 'ZW', 'Zimbabwe', 'AFRO', '27', '314', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94561, '2020-06-11', 'ZW', 'Zimbabwe', 'AFRO', '6', '320', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94562, '2020-06-12', 'ZW', 'Zimbabwe', 'AFRO', '12', '332', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94563, '2020-06-13', 'ZW', 'Zimbabwe', 'AFRO', '11', '343', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94564, '2020-06-14', 'ZW', 'Zimbabwe', 'AFRO', '13', '356', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94565, '2020-06-15', 'ZW', 'Zimbabwe', 'AFRO', '27', '383', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94566, '2020-06-16', 'ZW', 'Zimbabwe', 'AFRO', '4', '387', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94567, '2020-06-17', 'ZW', 'Zimbabwe', 'AFRO', '4', '391', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94568, '2020-06-18', 'ZW', 'Zimbabwe', 'AFRO', '10', '401', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94569, '2020-06-19', 'ZW', 'Zimbabwe', 'AFRO', '62', '463', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94570, '2020-06-20', 'ZW', 'Zimbabwe', 'AFRO', '16', '479', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94571, '2020-06-21', 'ZW', 'Zimbabwe', 'AFRO', '0', '479', '0', '4');
INSERT INTO public.who_global_data_import VALUES (94572, '2020-06-22', 'ZW', 'Zimbabwe', 'AFRO', '10', '489', '2', '6');
INSERT INTO public.who_global_data_import VALUES (94573, '2020-06-23', 'ZW', 'Zimbabwe', 'AFRO', '23', '512', '0', '6');
INSERT INTO public.who_global_data_import VALUES (94574, '2020-06-24', 'ZW', 'Zimbabwe', 'AFRO', '13', '525', '0', '6');
INSERT INTO public.who_global_data_import VALUES (94575, '2020-06-25', 'ZW', 'Zimbabwe', 'AFRO', '5', '530', '0', '6');
INSERT INTO public.who_global_data_import VALUES (94576, '2020-06-26', 'ZW', 'Zimbabwe', 'AFRO', '21', '551', '0', '6');
INSERT INTO public.who_global_data_import VALUES (94577, '2020-06-27', 'ZW', 'Zimbabwe', 'AFRO', '10', '561', '1', '7');
INSERT INTO public.who_global_data_import VALUES (94578, '2020-06-28', 'ZW', 'Zimbabwe', 'AFRO', '6', '567', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94579, '2020-06-29', 'ZW', 'Zimbabwe', 'AFRO', '0', '567', '-1', '6');
INSERT INTO public.who_global_data_import VALUES (94580, '2020-06-30', 'ZW', 'Zimbabwe', 'AFRO', '7', '574', '1', '7');
INSERT INTO public.who_global_data_import VALUES (94581, '2020-07-01', 'ZW', 'Zimbabwe', 'AFRO', '17', '591', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94582, '2020-07-02', 'ZW', 'Zimbabwe', 'AFRO', '14', '605', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94583, '2020-07-03', 'ZW', 'Zimbabwe', 'AFRO', '12', '617', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94584, '2020-07-04', 'ZW', 'Zimbabwe', 'AFRO', '8', '625', '0', '7');
INSERT INTO public.who_global_data_import VALUES (94585, '2020-07-05', 'ZW', 'Zimbabwe', 'AFRO', '73', '698', '1', '8');
INSERT INTO public.who_global_data_import VALUES (94586, '2020-07-06', 'ZW', 'Zimbabwe', 'AFRO', '18', '716', '0', '8');
INSERT INTO public.who_global_data_import VALUES (94587, '2020-07-07', 'ZW', 'Zimbabwe', 'AFRO', '18', '734', '1', '9');
INSERT INTO public.who_global_data_import VALUES (94588, '2020-07-08', 'ZW', 'Zimbabwe', 'AFRO', '53', '787', '0', '9');
INSERT INTO public.who_global_data_import VALUES (94589, '2020-07-09', 'ZW', 'Zimbabwe', 'AFRO', '98', '885', '0', '9');
INSERT INTO public.who_global_data_import VALUES (94590, '2020-07-10', 'ZW', 'Zimbabwe', 'AFRO', '41', '926', '3', '12');
INSERT INTO public.who_global_data_import VALUES (94591, '2020-07-11', 'ZW', 'Zimbabwe', 'AFRO', '16', '942', '1', '13');
INSERT INTO public.who_global_data_import VALUES (94592, '2020-07-12', 'ZW', 'Zimbabwe', 'AFRO', '40', '982', '5', '18');
INSERT INTO public.who_global_data_import VALUES (94593, '2020-07-13', 'ZW', 'Zimbabwe', 'AFRO', '3', '985', '0', '18');
INSERT INTO public.who_global_data_import VALUES (94594, '2020-07-14', 'ZW', 'Zimbabwe', 'AFRO', '49', '1034', '1', '19');
INSERT INTO public.who_global_data_import VALUES (94595, '2020-07-15', 'ZW', 'Zimbabwe', 'AFRO', '30', '1064', '1', '20');
INSERT INTO public.who_global_data_import VALUES (94596, '2020-07-16', 'ZW', 'Zimbabwe', 'AFRO', '25', '1089', '0', '20');
INSERT INTO public.who_global_data_import VALUES (94597, '2020-07-17', 'ZW', 'Zimbabwe', 'AFRO', '273', '1362', '3', '23');
INSERT INTO public.who_global_data_import VALUES (94598, '2020-07-18', 'ZW', 'Zimbabwe', 'AFRO', '58', '1420', '1', '24');
INSERT INTO public.who_global_data_import VALUES (94599, '2020-07-19', 'ZW', 'Zimbabwe', 'AFRO', '58', '1478', '1', '25');
INSERT INTO public.who_global_data_import VALUES (94600, '2020-07-20', 'ZW', 'Zimbabwe', 'AFRO', '133', '1611', '0', '25');
INSERT INTO public.who_global_data_import VALUES (94601, '2020-07-21', 'ZW', 'Zimbabwe', 'AFRO', '102', '1713', '1', '26');
INSERT INTO public.who_global_data_import VALUES (94602, '2020-07-22', 'ZW', 'Zimbabwe', 'AFRO', '107', '1820', '0', '26');
INSERT INTO public.who_global_data_import VALUES (94603, '2020-07-23', 'ZW', 'Zimbabwe', 'AFRO', '214', '2034', '0', '26');
INSERT INTO public.who_global_data_import VALUES (94604, '2020-07-24', 'ZW', 'Zimbabwe', 'AFRO', '90', '2124', '2', '28');
INSERT INTO public.who_global_data_import VALUES (94605, '2020-07-25', 'ZW', 'Zimbabwe', 'AFRO', '172', '2296', '4', '32');
INSERT INTO public.who_global_data_import VALUES (94606, '2020-07-26', 'ZW', 'Zimbabwe', 'AFRO', '138', '2434', '2', '34');
INSERT INTO public.who_global_data_import VALUES (94607, '2020-07-27', 'ZW', 'Zimbabwe', 'AFRO', '78', '2512', '0', '34');
INSERT INTO public.who_global_data_import VALUES (94608, '2020-07-28', 'ZW', 'Zimbabwe', 'AFRO', '192', '2704', '2', '36');
INSERT INTO public.who_global_data_import VALUES (94609, '2020-07-29', 'ZW', 'Zimbabwe', 'AFRO', '113', '2817', '4', '40');
INSERT INTO public.who_global_data_import VALUES (94610, '2020-07-30', 'ZW', 'Zimbabwe', 'AFRO', '62', '2879', '1', '41');
INSERT INTO public.who_global_data_import VALUES (94611, '2020-07-31', 'ZW', 'Zimbabwe', 'AFRO', '213', '3092', '12', '53');
INSERT INTO public.who_global_data_import VALUES (94612, '2020-08-01', 'ZW', 'Zimbabwe', 'AFRO', '77', '3169', '14', '67');
INSERT INTO public.who_global_data_import VALUES (94613, '2020-08-02', 'ZW', 'Zimbabwe', 'AFRO', '490', '3659', '2', '69');
INSERT INTO public.who_global_data_import VALUES (94614, '2020-08-03', 'ZW', 'Zimbabwe', 'AFRO', '262', '3921', '1', '70');
INSERT INTO public.who_global_data_import VALUES (94615, '2020-08-04', 'ZW', 'Zimbabwe', 'AFRO', '154', '4075', '10', '80');
INSERT INTO public.who_global_data_import VALUES (94616, '2020-08-05', 'ZW', 'Zimbabwe', 'AFRO', '146', '4221', '1', '81');
INSERT INTO public.who_global_data_import VALUES (94617, '2020-08-06', 'ZW', 'Zimbabwe', 'AFRO', '118', '4339', '3', '84');
INSERT INTO public.who_global_data_import VALUES (94618, '2020-08-07', 'ZW', 'Zimbabwe', 'AFRO', '56', '4395', '13', '97');
INSERT INTO public.who_global_data_import VALUES (94619, '2020-08-08', 'ZW', 'Zimbabwe', 'AFRO', '56', '4451', '5', '102');
INSERT INTO public.who_global_data_import VALUES (94620, '2020-08-09', 'ZW', 'Zimbabwe', 'AFRO', '124', '4575', '0', '102');
INSERT INTO public.who_global_data_import VALUES (94621, '2020-08-10', 'ZW', 'Zimbabwe', 'AFRO', '74', '4649', '2', '104');
INSERT INTO public.who_global_data_import VALUES (94622, '2020-08-11', 'ZW', 'Zimbabwe', 'AFRO', '99', '4748', '0', '104');
INSERT INTO public.who_global_data_import VALUES (94623, '2020-08-12', 'ZW', 'Zimbabwe', 'AFRO', '70', '4818', '0', '104');
INSERT INTO public.who_global_data_import VALUES (94624, '2020-08-13', 'ZW', 'Zimbabwe', 'AFRO', '75', '4893', '18', '122');
INSERT INTO public.who_global_data_import VALUES (94625, '2020-08-14', 'ZW', 'Zimbabwe', 'AFRO', '97', '4990', '6', '128');
INSERT INTO public.who_global_data_import VALUES (94626, '2020-08-15', 'ZW', 'Zimbabwe', 'AFRO', '82', '5072', '0', '128');
INSERT INTO public.who_global_data_import VALUES (94627, '2020-08-16', 'ZW', 'Zimbabwe', 'AFRO', '104', '5176', '2', '130');
INSERT INTO public.who_global_data_import VALUES (94628, '2020-08-17', 'ZW', 'Zimbabwe', 'AFRO', '85', '5261', '2', '132');
INSERT INTO public.who_global_data_import VALUES (94629, '2020-08-18', 'ZW', 'Zimbabwe', 'AFRO', '47', '5308', '3', '135');
INSERT INTO public.who_global_data_import VALUES (94630, '2020-08-19', 'ZW', 'Zimbabwe', 'AFRO', '70', '5378', '6', '141');
INSERT INTO public.who_global_data_import VALUES (94631, '2020-08-20', 'ZW', 'Zimbabwe', 'AFRO', '265', '5643', '9', '150');
INSERT INTO public.who_global_data_import VALUES (94632, '2020-08-21', 'ZW', 'Zimbabwe', 'AFRO', '102', '5745', '1', '151');
INSERT INTO public.who_global_data_import VALUES (94633, '2020-08-22', 'ZW', 'Zimbabwe', 'AFRO', '70', '5815', '1', '152');
INSERT INTO public.who_global_data_import VALUES (94634, '2020-08-23', 'ZW', 'Zimbabwe', 'AFRO', '78', '5893', '1', '153');
INSERT INTO public.who_global_data_import VALUES (94635, '2020-08-24', 'ZW', 'Zimbabwe', 'AFRO', '37', '5930', '2', '155');
INSERT INTO public.who_global_data_import VALUES (94636, '2020-08-25', 'ZW', 'Zimbabwe', 'AFRO', '140', '6070', '0', '155');
INSERT INTO public.who_global_data_import VALUES (94637, '2020-08-26', 'ZW', 'Zimbabwe', 'AFRO', '126', '6196', '11', '166');
INSERT INTO public.who_global_data_import VALUES (94638, '2020-08-27', 'ZW', 'Zimbabwe', 'AFRO', '55', '6251', '13', '179');
INSERT INTO public.who_global_data_import VALUES (94639, '2020-08-28', 'ZW', 'Zimbabwe', 'AFRO', '41', '6292', '10', '189');
INSERT INTO public.who_global_data_import VALUES (94640, '2020-08-29', 'ZW', 'Zimbabwe', 'AFRO', '96', '6388', '6', '195');
INSERT INTO public.who_global_data_import VALUES (94641, '2020-08-30', 'ZW', 'Zimbabwe', 'AFRO', '18', '6406', '1', '196');
INSERT INTO public.who_global_data_import VALUES (94642, '2020-08-31', 'ZW', 'Zimbabwe', 'AFRO', '6', '6412', '0', '196');
INSERT INTO public.who_global_data_import VALUES (94643, '2020-09-01', 'ZW', 'Zimbabwe', 'AFRO', '85', '6497', '6', '202');
INSERT INTO public.who_global_data_import VALUES (94644, '2020-09-02', 'ZW', 'Zimbabwe', 'AFRO', '62', '6559', '1', '203');
INSERT INTO public.who_global_data_import VALUES (94645, '2020-09-03', 'ZW', 'Zimbabwe', 'AFRO', '79', '6638', '3', '206');
INSERT INTO public.who_global_data_import VALUES (94646, '2020-09-04', 'ZW', 'Zimbabwe', 'AFRO', '40', '6678', '0', '206');
INSERT INTO public.who_global_data_import VALUES (94647, '2020-09-05', 'ZW', 'Zimbabwe', 'AFRO', '159', '6837', '0', '206');
INSERT INTO public.who_global_data_import VALUES (94648, '2020-09-06', 'ZW', 'Zimbabwe', 'AFRO', '0', '6837', '0', '206');
INSERT INTO public.who_global_data_import VALUES (94649, '2020-09-07', 'ZW', 'Zimbabwe', 'AFRO', '0', '6837', '0', '206');
INSERT INTO public.who_global_data_import VALUES (94650, '2020-09-08', 'ZW', 'Zimbabwe', 'AFRO', '279', '7116', '2', '208');
INSERT INTO public.who_global_data_import VALUES (94651, '2020-09-09', 'ZW', 'Zimbabwe', 'AFRO', '272', '7388', '10', '218');
INSERT INTO public.who_global_data_import VALUES (94652, '2020-09-10', 'ZW', 'Zimbabwe', 'AFRO', '41', '7429', '4', '222');
INSERT INTO public.who_global_data_import VALUES (94653, '2020-09-11', 'ZW', 'Zimbabwe', 'AFRO', '24', '7453', '0', '222');
INSERT INTO public.who_global_data_import VALUES (94654, '2020-09-12', 'ZW', 'Zimbabwe', 'AFRO', '26', '7479', '2', '224');
INSERT INTO public.who_global_data_import VALUES (94655, '2020-09-13', 'ZW', 'Zimbabwe', 'AFRO', '29', '7508', '0', '224');
INSERT INTO public.who_global_data_import VALUES (94656, '2020-09-14', 'ZW', 'Zimbabwe', 'AFRO', '18', '7526', '0', '224');
INSERT INTO public.who_global_data_import VALUES (94657, '2020-09-15', 'ZW', 'Zimbabwe', 'AFRO', '5', '7531', '0', '224');
INSERT INTO public.who_global_data_import VALUES (94658, '2020-09-16', 'ZW', 'Zimbabwe', 'AFRO', '45', '7576', '0', '224');
INSERT INTO public.who_global_data_import VALUES (94659, '2020-09-17', 'ZW', 'Zimbabwe', 'AFRO', '22', '7598', '0', '224');
INSERT INTO public.who_global_data_import VALUES (94660, '2020-09-18', 'ZW', 'Zimbabwe', 'AFRO', '35', '7633', '0', '224');
INSERT INTO public.who_global_data_import VALUES (94661, '2020-09-19', 'ZW', 'Zimbabwe', 'AFRO', '14', '7647', '0', '224');
INSERT INTO public.who_global_data_import VALUES (94662, '2020-09-20', 'ZW', 'Zimbabwe', 'AFRO', '25', '7672', '1', '225');
INSERT INTO public.who_global_data_import VALUES (94663, '2020-09-21', 'ZW', 'Zimbabwe', 'AFRO', '11', '7683', '0', '225');
INSERT INTO public.who_global_data_import VALUES (94664, '2020-09-22', 'ZW', 'Zimbabwe', 'AFRO', '0', '7683', '0', '225');
INSERT INTO public.who_global_data_import VALUES (94665, '2020-09-23', 'ZW', 'Zimbabwe', 'AFRO', '28', '7711', '1', '226');
INSERT INTO public.who_global_data_import VALUES (94666, '2020-09-24', 'ZW', 'Zimbabwe', 'AFRO', '14', '7725', '1', '227');
INSERT INTO public.who_global_data_import VALUES (94667, '2020-09-25', 'ZW', 'Zimbabwe', 'AFRO', '0', '7725', '0', '227');
INSERT INTO public.who_global_data_import VALUES (94668, '2020-09-26', 'ZW', 'Zimbabwe', 'AFRO', '62', '7787', '0', '227');
INSERT INTO public.who_global_data_import VALUES (94669, '2020-09-27', 'ZW', 'Zimbabwe', 'AFRO', '16', '7803', '0', '227');
INSERT INTO public.who_global_data_import VALUES (94670, '2020-09-28', 'ZW', 'Zimbabwe', 'AFRO', '9', '7812', '0', '227');
INSERT INTO public.who_global_data_import VALUES (94671, '2020-09-29', 'ZW', 'Zimbabwe', 'AFRO', '4', '7816', '1', '228');
INSERT INTO public.who_global_data_import VALUES (94672, '2020-09-30', 'ZW', 'Zimbabwe', 'AFRO', '21', '7837', '0', '228');
INSERT INTO public.who_global_data_import VALUES (94673, '2020-10-01', 'ZW', 'Zimbabwe', 'AFRO', '1', '7838', '0', '228');
INSERT INTO public.who_global_data_import VALUES (94674, '2020-10-02', 'ZW', 'Zimbabwe', 'AFRO', '12', '7850', '0', '228');
INSERT INTO public.who_global_data_import VALUES (94675, '2020-10-03', 'ZW', 'Zimbabwe', 'AFRO', '8', '7858', '0', '228');
INSERT INTO public.who_global_data_import VALUES (94676, '2020-10-04', 'ZW', 'Zimbabwe', 'AFRO', '0', '7858', '0', '228');
INSERT INTO public.who_global_data_import VALUES (94677, '2020-10-05', 'ZW', 'Zimbabwe', 'AFRO', '30', '7888', '0', '228');
INSERT INTO public.who_global_data_import VALUES (94678, '2020-10-06', 'ZW', 'Zimbabwe', 'AFRO', '10', '7898', '0', '228');
INSERT INTO public.who_global_data_import VALUES (94679, '2020-10-07', 'ZW', 'Zimbabwe', 'AFRO', '17', '7915', '1', '229');
INSERT INTO public.who_global_data_import VALUES (94680, '2020-10-08', 'ZW', 'Zimbabwe', 'AFRO', '4', '7919', '0', '229');
INSERT INTO public.who_global_data_import VALUES (94681, '2020-10-09', 'ZW', 'Zimbabwe', 'AFRO', '32', '7951', '0', '229');
INSERT INTO public.who_global_data_import VALUES (94682, '2020-10-10', 'ZW', 'Zimbabwe', 'AFRO', '43', '7994', '0', '229');
INSERT INTO public.who_global_data_import VALUES (94683, '2020-10-11', 'ZW', 'Zimbabwe', 'AFRO', '0', '7994', '0', '229');
INSERT INTO public.who_global_data_import VALUES (94684, '2020-10-12', 'ZW', 'Zimbabwe', 'AFRO', '17', '8011', '1', '230');
INSERT INTO public.who_global_data_import VALUES (94685, '2020-10-13', 'ZW', 'Zimbabwe', 'AFRO', '10', '8021', '0', '230');
INSERT INTO public.who_global_data_import VALUES (94686, '2020-10-14', 'ZW', 'Zimbabwe', 'AFRO', '15', '8036', '0', '230');
INSERT INTO public.who_global_data_import VALUES (94687, '2020-10-15', 'ZW', 'Zimbabwe', 'AFRO', '19', '8055', '1', '231');
INSERT INTO public.who_global_data_import VALUES (94688, '2020-10-16', 'ZW', 'Zimbabwe', 'AFRO', '20', '8075', '0', '231');
INSERT INTO public.who_global_data_import VALUES (94689, '2020-10-17', 'ZW', 'Zimbabwe', 'AFRO', '24', '8099', '0', '231');
INSERT INTO public.who_global_data_import VALUES (94690, '2020-10-18', 'ZW', 'Zimbabwe', 'AFRO', '11', '8110', '0', '231');
INSERT INTO public.who_global_data_import VALUES (94691, '2020-10-19', 'ZW', 'Zimbabwe', 'AFRO', '37', '8147', '0', '231');
INSERT INTO public.who_global_data_import VALUES (94692, '2020-10-20', 'ZW', 'Zimbabwe', 'AFRO', '12', '8159', '1', '232');
INSERT INTO public.who_global_data_import VALUES (94693, '2020-10-21', 'ZW', 'Zimbabwe', 'AFRO', '28', '8187', '1', '233');
INSERT INTO public.who_global_data_import VALUES (94694, '2020-10-22', 'ZW', 'Zimbabwe', 'AFRO', '28', '8215', '3', '236');
INSERT INTO public.who_global_data_import VALUES (94695, '2020-10-23', 'ZW', 'Zimbabwe', 'AFRO', '27', '8242', '0', '236');
INSERT INTO public.who_global_data_import VALUES (94696, '2020-10-24', 'ZW', 'Zimbabwe', 'AFRO', '15', '8257', '0', '236');
INSERT INTO public.who_global_data_import VALUES (94697, '2020-10-25', 'ZW', 'Zimbabwe', 'AFRO', '12', '8269', '0', '236');
INSERT INTO public.who_global_data_import VALUES (94698, '2020-10-26', 'ZW', 'Zimbabwe', 'AFRO', '7', '8276', '1', '237');
INSERT INTO public.who_global_data_import VALUES (94699, '2020-10-27', 'ZW', 'Zimbabwe', 'AFRO', '27', '8303', '5', '242');
INSERT INTO public.who_global_data_import VALUES (94700, '2020-10-28', 'ZW', 'Zimbabwe', 'AFRO', '12', '8315', '0', '242');
INSERT INTO public.who_global_data_import VALUES (94701, '2020-10-29', 'ZW', 'Zimbabwe', 'AFRO', '5', '8320', '0', '242');
INSERT INTO public.who_global_data_import VALUES (94702, '2020-10-30', 'ZW', 'Zimbabwe', 'AFRO', '1', '8321', '0', '242');
INSERT INTO public.who_global_data_import VALUES (94703, '2020-10-31', 'ZW', 'Zimbabwe', 'AFRO', '41', '8362', '0', '242');
INSERT INTO public.who_global_data_import VALUES (94704, '2020-11-01', 'ZW', 'Zimbabwe', 'AFRO', '5', '8367', '1', '243');
INSERT INTO public.who_global_data_import VALUES (94705, '2020-11-02', 'ZW', 'Zimbabwe', 'AFRO', '7', '8374', '0', '243');
INSERT INTO public.who_global_data_import VALUES (94706, '2020-11-03', 'ZW', 'Zimbabwe', 'AFRO', '15', '8389', '2', '245');
INSERT INTO public.who_global_data_import VALUES (94707, '2020-11-04', 'ZW', 'Zimbabwe', 'AFRO', '21', '8410', '1', '246');
INSERT INTO public.who_global_data_import VALUES (94708, '2020-11-05', 'ZW', 'Zimbabwe', 'AFRO', '17', '8427', '2', '248');
INSERT INTO public.who_global_data_import VALUES (94709, '2020-11-06', 'ZW', 'Zimbabwe', 'AFRO', '16', '8443', '0', '248');
INSERT INTO public.who_global_data_import VALUES (94710, '2020-11-07', 'ZW', 'Zimbabwe', 'AFRO', '28', '8471', '2', '250');
INSERT INTO public.who_global_data_import VALUES (94711, '2020-11-08', 'ZW', 'Zimbabwe', 'AFRO', '0', '8471', '0', '250');
INSERT INTO public.who_global_data_import VALUES (94712, '2020-11-09', 'ZW', 'Zimbabwe', 'AFRO', '60', '8531', '3', '253');
INSERT INTO public.who_global_data_import VALUES (94713, '2020-11-10', 'ZW', 'Zimbabwe', 'AFRO', '30', '8561', '1', '254');
INSERT INTO public.who_global_data_import VALUES (94714, '2020-11-11', 'ZW', 'Zimbabwe', 'AFRO', '49', '8610', '1', '255');
INSERT INTO public.who_global_data_import VALUES (94715, '2020-11-12', 'ZW', 'Zimbabwe', 'AFRO', '57', '8667', '0', '255');
INSERT INTO public.who_global_data_import VALUES (94716, '2020-11-13', 'ZW', 'Zimbabwe', 'AFRO', '29', '8696', '0', '255');
INSERT INTO public.who_global_data_import VALUES (94717, '2020-11-14', 'ZW', 'Zimbabwe', 'AFRO', '69', '8765', '2', '257');
INSERT INTO public.who_global_data_import VALUES (94718, '2020-11-15', 'ZW', 'Zimbabwe', 'AFRO', '21', '8786', '0', '257');
INSERT INTO public.who_global_data_import VALUES (94719, '2020-11-16', 'ZW', 'Zimbabwe', 'AFRO', '43', '8829', '0', '257');
INSERT INTO public.who_global_data_import VALUES (94720, '2020-11-17', 'ZW', 'Zimbabwe', 'AFRO', '68', '8897', '0', '257');
INSERT INTO public.who_global_data_import VALUES (94721, '2020-11-18', 'ZW', 'Zimbabwe', 'AFRO', '48', '8945', '2', '259');
INSERT INTO public.who_global_data_import VALUES (94722, '2020-11-19', 'ZW', 'Zimbabwe', 'AFRO', '36', '8981', '2', '261');
INSERT INTO public.who_global_data_import VALUES (94723, '2020-11-20', 'ZW', 'Zimbabwe', 'AFRO', '65', '9046', '4', '265');
INSERT INTO public.who_global_data_import VALUES (94724, '2020-11-21', 'ZW', 'Zimbabwe', 'AFRO', '74', '9120', '0', '265');
INSERT INTO public.who_global_data_import VALUES (94725, '2020-11-22', 'ZW', 'Zimbabwe', 'AFRO', '0', '9120', '0', '265');
INSERT INTO public.who_global_data_import VALUES (94726, '2020-11-23', 'ZW', 'Zimbabwe', 'AFRO', '100', '9220', '3', '268');
INSERT INTO public.who_global_data_import VALUES (94727, '2020-11-24', 'ZW', 'Zimbabwe', 'AFRO', '88', '9308', '5', '273');
INSERT INTO public.who_global_data_import VALUES (94728, '2020-11-25', 'ZW', 'Zimbabwe', 'AFRO', '90', '9398', '1', '274');
INSERT INTO public.who_global_data_import VALUES (94729, '2020-11-26', 'ZW', 'Zimbabwe', 'AFRO', '110', '9508', '0', '274');
INSERT INTO public.who_global_data_import VALUES (94730, '2020-11-27', 'ZW', 'Zimbabwe', 'AFRO', '115', '9623', '0', '274');
INSERT INTO public.who_global_data_import VALUES (94731, '2020-11-28', 'ZW', 'Zimbabwe', 'AFRO', '91', '9714', '1', '275');
INSERT INTO public.who_global_data_import VALUES (94732, '2020-11-29', 'ZW', 'Zimbabwe', 'AFRO', '108', '9822', '0', '275');
INSERT INTO public.who_global_data_import VALUES (94733, '2020-11-30', 'ZW', 'Zimbabwe', 'AFRO', '128', '9950', '1', '276');
INSERT INTO public.who_global_data_import VALUES (94734, '2020-12-01', 'ZW', 'Zimbabwe', 'AFRO', '84', '10034', '1', '277');
INSERT INTO public.who_global_data_import VALUES (94735, '2020-12-02', 'ZW', 'Zimbabwe', 'AFRO', '95', '10129', '0', '277');
INSERT INTO public.who_global_data_import VALUES (94736, '2020-12-03', 'ZW', 'Zimbabwe', 'AFRO', '114', '10243', '0', '277');
INSERT INTO public.who_global_data_import VALUES (94737, '2020-12-04', 'ZW', 'Zimbabwe', 'AFRO', '181', '10424', '3', '280');
INSERT INTO public.who_global_data_import VALUES (94738, '2020-12-05', 'ZW', 'Zimbabwe', 'AFRO', '123', '10547', '1', '281');
INSERT INTO public.who_global_data_import VALUES (94739, '2020-12-06', 'ZW', 'Zimbabwe', 'AFRO', '70', '10617', '10', '291');
INSERT INTO public.who_global_data_import VALUES (94740, '2020-12-07', 'ZW', 'Zimbabwe', 'AFRO', '101', '10718', '0', '291');
INSERT INTO public.who_global_data_import VALUES (94741, '2020-12-08', 'ZW', 'Zimbabwe', 'AFRO', '121', '10839', '3', '294');
INSERT INTO public.who_global_data_import VALUES (94742, '2020-12-09', 'ZW', 'Zimbabwe', 'AFRO', '0', '10839', '0', '294');
INSERT INTO public.who_global_data_import VALUES (94743, '2020-12-10', 'ZW', 'Zimbabwe', 'AFRO', '168', '11007', '10', '304');
INSERT INTO public.who_global_data_import VALUES (94744, '2020-12-11', 'ZW', 'Zimbabwe', 'AFRO', '74', '11081', '1', '305');
INSERT INTO public.who_global_data_import VALUES (94745, '2020-12-12', 'ZW', 'Zimbabwe', 'AFRO', '0', '11081', '0', '305');
INSERT INTO public.who_global_data_import VALUES (94746, '2020-12-13', 'ZW', 'Zimbabwe', 'AFRO', '0', '11081', '0', '305');
INSERT INTO public.who_global_data_import VALUES (94747, '2020-12-14', 'ZW', 'Zimbabwe', 'AFRO', '165', '11246', '2', '307');
INSERT INTO public.who_global_data_import VALUES (94748, '2020-12-15', 'ZW', 'Zimbabwe', 'AFRO', '112', '11358', '2', '309');
INSERT INTO public.who_global_data_import VALUES (94749, '2020-12-16', 'ZW', 'Zimbabwe', 'AFRO', '164', '11522', '1', '310');
INSERT INTO public.who_global_data_import VALUES (94750, '2020-12-17', 'ZW', 'Zimbabwe', 'AFRO', '0', '11522', '0', '310');
INSERT INTO public.who_global_data_import VALUES (94751, '2020-12-18', 'ZW', 'Zimbabwe', 'AFRO', '344', '11866', '4', '314');
INSERT INTO public.who_global_data_import VALUES (94752, '2020-12-19', 'ZW', 'Zimbabwe', 'AFRO', '181', '12047', '2', '316');
INSERT INTO public.who_global_data_import VALUES (94753, '2020-12-20', 'ZW', 'Zimbabwe', 'AFRO', '104', '12151', '2', '318');
INSERT INTO public.who_global_data_import VALUES (94754, '2020-12-21', 'ZW', 'Zimbabwe', 'AFRO', '174', '12325', '2', '320');
INSERT INTO public.who_global_data_import VALUES (94755, '2020-12-22', 'ZW', 'Zimbabwe', 'AFRO', '97', '12422', '2', '322');
INSERT INTO public.who_global_data_import VALUES (94756, '2020-12-23', 'ZW', 'Zimbabwe', 'AFRO', '122', '12544', '4', '326');
INSERT INTO public.who_global_data_import VALUES (94757, '2020-12-24', 'ZW', 'Zimbabwe', 'AFRO', '0', '12544', '0', '326');
INSERT INTO public.who_global_data_import VALUES (94758, '2020-12-25', 'ZW', 'Zimbabwe', 'AFRO', '242', '12786', '13', '339');
INSERT INTO public.who_global_data_import VALUES (94759, '2020-12-26', 'ZW', 'Zimbabwe', 'AFRO', '94', '12880', '2', '341');
INSERT INTO public.who_global_data_import VALUES (94760, '2020-12-27', 'ZW', 'Zimbabwe', 'AFRO', '83', '12963', '0', '341');
INSERT INTO public.who_global_data_import VALUES (94761, '2020-12-28', 'ZW', 'Zimbabwe', 'AFRO', '0', '12963', '0', '341');
INSERT INTO public.who_global_data_import VALUES (94762, '2020-12-29', 'ZW', 'Zimbabwe', 'AFRO', '185', '13148', '13', '354');
INSERT INTO public.who_global_data_import VALUES (94763, '2020-12-30', 'ZW', 'Zimbabwe', 'AFRO', '0', '13148', '0', '354');
INSERT INTO public.who_global_data_import VALUES (94764, '2020-12-31', 'ZW', 'Zimbabwe', 'AFRO', '477', '13625', '6', '360');
INSERT INTO public.who_global_data_import VALUES (94765, '2021-01-01', 'ZW', 'Zimbabwe', 'AFRO', '242', '13867', '3', '363');
INSERT INTO public.who_global_data_import VALUES (94766, '2021-01-02', 'ZW', 'Zimbabwe', 'AFRO', '0', '13867', '0', '363');
INSERT INTO public.who_global_data_import VALUES (94767, '2021-01-03', 'ZW', 'Zimbabwe', 'AFRO', '624', '14491', '14', '377');
INSERT INTO public.who_global_data_import VALUES (94768, '2021-01-04', 'ZW', 'Zimbabwe', 'AFRO', '774', '15265', '3', '380');
INSERT INTO public.who_global_data_import VALUES (94769, '2021-01-05', 'ZW', 'Zimbabwe', 'AFRO', '564', '15829', '4', '384');
INSERT INTO public.who_global_data_import VALUES (94770, '2021-01-06', 'ZW', 'Zimbabwe', 'AFRO', '1365', '17194', '34', '418');
INSERT INTO public.who_global_data_import VALUES (94771, '2021-01-07', 'ZW', 'Zimbabwe', 'AFRO', '610', '17804', '13', '431');
INSERT INTO public.who_global_data_import VALUES (94772, '2021-01-08', 'ZW', 'Zimbabwe', 'AFRO', '871', '18675', '15', '446');
INSERT INTO public.who_global_data_import VALUES (94773, '2021-01-09', 'ZW', 'Zimbabwe', 'AFRO', '985', '19660', '22', '468');
INSERT INTO public.who_global_data_import VALUES (94774, '2021-01-10', 'ZW', 'Zimbabwe', 'AFRO', '839', '20499', '15', '483');
INSERT INTO public.who_global_data_import VALUES (94775, '2021-01-11', 'ZW', 'Zimbabwe', 'AFRO', '978', '21477', '24', '507');
INSERT INTO public.who_global_data_import VALUES (94776, '2021-01-12', 'ZW', 'Zimbabwe', 'AFRO', '820', '22297', '21', '528');
INSERT INTO public.who_global_data_import VALUES (94777, '2021-01-13', 'ZW', 'Zimbabwe', 'AFRO', '942', '23239', '23', '551');
INSERT INTO public.who_global_data_import VALUES (94778, '2021-01-14', 'ZW', 'Zimbabwe', 'AFRO', '1017', '24256', '38', '589');
INSERT INTO public.who_global_data_import VALUES (94779, '2021-01-15', 'ZW', 'Zimbabwe', 'AFRO', '1112', '25368', '47', '636');
INSERT INTO public.who_global_data_import VALUES (94780, '2021-01-16', 'ZW', 'Zimbabwe', 'AFRO', '741', '26109', '30', '666');
INSERT INTO public.who_global_data_import VALUES (94781, '2021-01-17', 'ZW', 'Zimbabwe', 'AFRO', '772', '26881', '17', '683');
INSERT INTO public.who_global_data_import VALUES (94782, '2021-01-18', 'ZW', 'Zimbabwe', 'AFRO', '322', '27203', '30', '713');
INSERT INTO public.who_global_data_import VALUES (94783, '2021-01-19', 'ZW', 'Zimbabwe', 'AFRO', '689', '27892', '60', '773');
INSERT INTO public.who_global_data_import VALUES (94784, '2021-01-20', 'ZW', 'Zimbabwe', 'AFRO', '783', '28675', '52', '825');
INSERT INTO public.who_global_data_import VALUES (94785, '2021-01-21', 'ZW', 'Zimbabwe', 'AFRO', '733', '29408', '54', '879');
INSERT INTO public.who_global_data_import VALUES (94786, '2021-01-22', 'ZW', 'Zimbabwe', 'AFRO', '639', '30047', '38', '917');
INSERT INTO public.who_global_data_import VALUES (94787, '2021-01-23', 'ZW', 'Zimbabwe', 'AFRO', '476', '30523', '45', '962');
INSERT INTO public.who_global_data_import VALUES (94788, '2021-01-24', 'ZW', 'Zimbabwe', 'AFRO', '484', '31007', '12', '974');
INSERT INTO public.who_global_data_import VALUES (94789, '2021-01-25', 'ZW', 'Zimbabwe', 'AFRO', '313', '31320', '31', '1005');
INSERT INTO public.who_global_data_import VALUES (94790, '2021-01-26', 'ZW', 'Zimbabwe', 'AFRO', '326', '31646', '70', '1075');
INSERT INTO public.who_global_data_import VALUES (94791, '2021-01-27', 'ZW', 'Zimbabwe', 'AFRO', '358', '32004', '28', '1103');
INSERT INTO public.who_global_data_import VALUES (94792, '2021-01-28', 'ZW', 'Zimbabwe', 'AFRO', '300', '32304', '19', '1122');
INSERT INTO public.who_global_data_import VALUES (94793, '2021-01-29', 'ZW', 'Zimbabwe', 'AFRO', '342', '32646', '38', '1160');
INSERT INTO public.who_global_data_import VALUES (94794, '2021-01-30', 'ZW', 'Zimbabwe', 'AFRO', '306', '32952', '18', '1178');
INSERT INTO public.who_global_data_import VALUES (94795, '2021-01-31', 'ZW', 'Zimbabwe', 'AFRO', '319', '33271', '15', '1193');
INSERT INTO public.who_global_data_import VALUES (94796, '2021-02-01', 'ZW', 'Zimbabwe', 'AFRO', '117', '33388', '24', '1217');
INSERT INTO public.who_global_data_import VALUES (94797, '2021-02-02', 'ZW', 'Zimbabwe', 'AFRO', '160', '33548', '17', '1234');
INSERT INTO public.who_global_data_import VALUES (94798, '2021-02-03', 'ZW', 'Zimbabwe', 'AFRO', '266', '33814', '20', '1254');
INSERT INTO public.who_global_data_import VALUES (94799, '2021-02-04', 'ZW', 'Zimbabwe', 'AFRO', '150', '33964', '15', '1269');
INSERT INTO public.who_global_data_import VALUES (94800, '2021-02-05', 'ZW', 'Zimbabwe', 'AFRO', '207', '34171', '19', '1288');


--
-- Name: common_date_reported_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.common_date_reported_id_seq', 457, true);


--
-- Name: common_region_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.common_region_id_seq', 13, true);


--
-- Name: europe_country_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.europe_country_id_seq', 215, true);


--
-- Name: europe_data_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.europe_data_id_seq', 10366, true);


--
-- Name: europe_data_import_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.europe_data_import_id_seq', 10433, true);


--
-- Name: rki_country_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.rki_country_id_seq', 1, false);


--
-- Name: rki_global_data_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.rki_global_data_id_seq', 1, false);


--
-- Name: rki_global_data_import_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.rki_global_data_import_id_seq', 1, false);


--
-- Name: vaccination_germany_timeline_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.vaccination_germany_timeline_id_seq', 40, true);


--
-- Name: who_country_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.who_country_id_seq', 237, true);


--
-- Name: who_global_data_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.who_global_data_id_seq', 94800, true);


--
-- Name: who_global_data_import_id_seq; Type: SEQUENCE SET; Schema: public; Owner: covid19data
--

SELECT pg_catalog.setval('public.who_global_data_import_id_seq', 94800, true);


--
-- Name: common_date_reported common_date_reported_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.common_date_reported
    ADD CONSTRAINT common_date_reported_pkey PRIMARY KEY (id);


--
-- Name: common_region common_region_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.common_region
    ADD CONSTRAINT common_region_pkey PRIMARY KEY (id);


--
-- Name: europe_country europe_country_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_country
    ADD CONSTRAINT europe_country_pkey PRIMARY KEY (id);


--
-- Name: europe_data_import europe_data_import_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_data_import
    ADD CONSTRAINT europe_data_import_pkey PRIMARY KEY (id);


--
-- Name: europe_data europe_data_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_data
    ADD CONSTRAINT europe_data_pkey PRIMARY KEY (id);


--
-- Name: rki_country rki_country_country_code_key; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_country
    ADD CONSTRAINT rki_country_country_code_key UNIQUE (country_code);


--
-- Name: rki_country rki_country_country_key; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_country
    ADD CONSTRAINT rki_country_country_key UNIQUE (country);


--
-- Name: rki_country rki_country_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_country
    ADD CONSTRAINT rki_country_pkey PRIMARY KEY (id);


--
-- Name: rki_global_data_import rki_global_data_import_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_global_data_import
    ADD CONSTRAINT rki_global_data_import_pkey PRIMARY KEY (id);


--
-- Name: rki_global_data rki_global_data_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_global_data
    ADD CONSTRAINT rki_global_data_pkey PRIMARY KEY (id);


--
-- Name: common_date_reported unique_common_date_reported; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.common_date_reported
    ADD CONSTRAINT unique_common_date_reported UNIQUE (type, date_reported, datum, year_week);


--
-- Name: common_region unique_common_region_reported; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.common_region
    ADD CONSTRAINT unique_common_region_reported UNIQUE (type, region);


--
-- Name: vaccination_germany_timeline vaccination_germany_timeline_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.vaccination_germany_timeline
    ADD CONSTRAINT vaccination_germany_timeline_pkey PRIMARY KEY (id);


--
-- Name: who_country who_country_country_code_key; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_country
    ADD CONSTRAINT who_country_country_code_key UNIQUE (country_code);


--
-- Name: who_country who_country_country_key; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_country
    ADD CONSTRAINT who_country_country_key UNIQUE (country);


--
-- Name: who_country who_country_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_country
    ADD CONSTRAINT who_country_pkey PRIMARY KEY (id);


--
-- Name: who_global_data_import who_global_data_import_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_global_data_import
    ADD CONSTRAINT who_global_data_import_pkey PRIMARY KEY (id);


--
-- Name: who_global_data who_global_data_pkey; Type: CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_global_data
    ADD CONSTRAINT who_global_data_pkey PRIMARY KEY (id);


--
-- Name: europe_country europe_country_continent_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_country
    ADD CONSTRAINT europe_country_continent_id_fkey FOREIGN KEY (continent_id) REFERENCES public.common_region(id);


--
-- Name: europe_data europe_data_europe_country_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_data
    ADD CONSTRAINT europe_data_europe_country_id_fkey FOREIGN KEY (europe_country_id) REFERENCES public.europe_country(id);


--
-- Name: europe_data europe_data_europe_date_reported_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.europe_data
    ADD CONSTRAINT europe_data_europe_date_reported_id_fkey FOREIGN KEY (europe_date_reported_id) REFERENCES public.common_date_reported(id);


--
-- Name: rki_country rki_country_region_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_country
    ADD CONSTRAINT rki_country_region_id_fkey FOREIGN KEY (region_id) REFERENCES public.common_region(id);


--
-- Name: rki_global_data rki_global_data_country_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_global_data
    ADD CONSTRAINT rki_global_data_country_id_fkey FOREIGN KEY (country_id) REFERENCES public.who_country(id);


--
-- Name: rki_global_data rki_global_data_date_reported_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.rki_global_data
    ADD CONSTRAINT rki_global_data_date_reported_id_fkey FOREIGN KEY (date_reported_id) REFERENCES public.common_date_reported(id);


--
-- Name: who_country who_country_region_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_country
    ADD CONSTRAINT who_country_region_id_fkey FOREIGN KEY (region_id) REFERENCES public.common_region(id);


--
-- Name: who_global_data who_global_data_country_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_global_data
    ADD CONSTRAINT who_global_data_country_id_fkey FOREIGN KEY (country_id) REFERENCES public.who_country(id);


--
-- Name: who_global_data who_global_data_date_reported_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: covid19data
--

ALTER TABLE ONLY public.who_global_data
    ADD CONSTRAINT who_global_data_date_reported_id_fkey FOREIGN KEY (date_reported_id) REFERENCES public.common_date_reported(id);


--
-- PostgreSQL database dump complete
--

